-- --------------------------------------------------------
-- Host:                         127.0.0.1
-- Versión del servidor:         5.6.21 - MySQL Community Server (GPL)
-- SO del servidor:              Win32
-- HeidiSQL Versión:             9.2.0.4947
-- --------------------------------------------------------

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET NAMES utf8mb4 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;

-- Volcando estructura de base de datos para fia
CREATE DATABASE IF NOT EXISTS `fia` /*!40100 DEFAULT CHARACTER SET latin1 */;
USE `fia`;


-- Volcando estructura para tabla fia.circuit
CREATE TABLE IF NOT EXISTS `circuit` (
  `codi_circuit` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `nom` varchar(50) NOT NULL,
  `sobrenom` varchar(50) DEFAULT NULL,
  `longitud` smallint(6) unsigned DEFAULT NULL,
  `pais` char(2) NOT NULL,
  PRIMARY KEY (`codi_circuit`),
  UNIQUE KEY `nom` (`nom`),
  UNIQUE KEY `sobrenom` (`sobrenom`),
  KEY `FK_circuit_pais` (`pais`),
  CONSTRAINT `FK_circuit_pais` FOREIGN KEY (`pais`) REFERENCES `pais` (`codi_pais`)
) ENGINE=InnoDB AUTO_INCREMENT=77 DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.circuit: ~76 rows (aproximadamente)
DELETE FROM `circuit`;
/*!40000 ALTER TABLE `circuit` DISABLE KEYS */;
INSERT INTO `circuit` (`codi_circuit`, `nom`, `sobrenom`, `longitud`, `pais`) VALUES
	(1, 'Autodromo Nazionale di Monza', 'monza', 5793, 'IT'),
	(2, 'Bahrain International Circuit', 'bahrain', 5412, 'BH'),
	(3, 'Circuit de Catalunya', 'catalunya', 4627, 'ES'),
	(4, 'Circuit de Monaco', 'monaco', 4891, 'MC'),
	(5, 'Circuit de Spa-Francorchamps', 'spa', 4915, 'BE'),
	(6, 'Circuit Gilles Villeneuve', 'villeneuve', 4404, 'CA'),
	(7, 'Circuit of the Americas', 'americas', 3777, 'US'),
	(8, 'Hockenheimring', 'hockenheimring', 4170, 'DE'),
	(9, 'Hungaroring', 'hungaroring', 4021, 'HU'),
	(10, 'Marina Bay Street Circuit', 'marina_bay', 4096, 'SG'),
	(11, 'Red Bull Ring', 'red_bull_ring', 4916, 'AT'),
	(12, 'Sepang International Circuit', 'sepang', 4793, 'MY'),
	(13, 'Shanghai International Circuit', 'shanghai', 3717, 'CN'),
	(14, 'Silverstone Circuit', 'silverstone', 4707, 'GB'),
	(15, 'Sochi International Street Circuit', 'sochi', 4883, 'RU'),
	(16, 'Suzuka Circuit', 'suzuka', 4797, 'JP'),
	(17, 'Yas Marina Circuit', 'yas_marina', 3833, 'AE'),
	(18, 'Autódromo Juan y Oscar Gálvez', 'galvez', 4237, 'AR'),
	(19, 'A1-Ring', 'osterreichring', 3732, 'AT'),
	(20, 'Zeltweg', 'zeltweg', 4450, 'AT'),
	(21, 'Adelaide Street Circuit', 'adelaide', 3555, 'AU'),
	(22, 'Zolder', 'zolder', 4925, 'BE'),
	(23, 'Nivelles-Baulers', 'nivelles', 4462, 'BE'),
	(24, 'Autódromo José Carlos Pace', 'interlagos', 4035, 'BR'),
	(25, 'Autódromo Internacional Nelson Piquet', 'jacarepagua', 5291, 'BR'),
	(26, 'Mosport International Raceway', 'mosport', 4849, 'CA'),
	(27, 'Circuit Mont-Tremblant', 'tremblant', 4873, 'CA'),
	(28, 'Circuit Bremgarten', 'bremgarten', 4320, 'CH'),
	(29, 'Nürburgring', 'nurburgring', 5481, 'DE'),
	(30, 'AVUS', 'avus', 4944, 'DE'),
	(31, 'Valencia Street Circuit', 'valencia', 4777, 'ES'),
	(32, 'Circuito de Jerez', 'jerez', 3552, 'ES'),
	(33, 'Jarama', 'jarama', 3933, 'ES'),
	(34, 'Montjuïc', 'montjuic', 3507, 'ES'),
	(35, 'Circuit de Pedralbes', 'pedralbes', 4237, 'ES'),
	(36, 'Circuit de Nevers Magny-Cours', 'magny_cours', 5166, 'FR'),
	(37, 'Circuit Paul Ricard', 'ricard', 3618, 'FR'),
	(38, 'Dijon-Prenois', 'dijon', 5092, 'FR'),
	(39, 'Charade Circuit', 'charade', 5108, 'FR'),
	(40, 'Rouen-Les-Essarts', 'essarts', 4765, 'FR'),
	(41, 'Le Mans', 'lemans', 4999, 'FR'),
	(42, 'Reims-Gueux', 'reims', 5204, 'FR'),
	(43, 'Donington Park', 'donington', 3520, 'GB'),
	(44, 'Brands Hatch', 'brands_hatch', 4491, 'GB'),
	(45, 'Aintree', 'aintree', 4396, 'GB'),
	(46, 'Buddh International Circuit', 'buddh', 5007, 'IN'),
	(47, 'Autodromo Enzo e Dino Ferrari', 'imola', 4348, 'IT'),
	(48, 'Pescara Circuit', 'pescara', 5218, 'IT'),
	(49, 'Fuji Speedway', 'fuji', 3546, 'JP'),
	(50, 'Okayama International Circuit', 'okayama', 4579, 'JP'),
	(51, 'Ain Diab', 'ain-diab', 4755, 'MA'),
	(52, 'Autódromo Hermanos Rodríguez', 'rodriguez', 4541, 'MX'),
	(53, 'Circuit Park Zandvoort', 'zandvoort', 4940, 'NL'),
	(54, 'Autódromo do Estoril', 'estoril', 3578, 'PT'),
	(55, 'Circuito da Boavista', 'boavista', 3571, 'PT'),
	(56, 'Monsanto Park Circuit', 'monsanto', 3622, 'PT'),
	(57, 'Scandinavian Raceway', 'anderstorp', 3897, 'SE'),
	(58, 'Istanbul Park', 'istanbul', 5121, 'TR'),
	(59, 'Indianapolis Motor Speedway', 'indianapolis', 4412, 'US'),
	(60, 'Phoenix street circuit', 'phoenix', 5198, 'US'),
	(61, 'Detroit Street Circuit', 'detroit', 5254, 'US'),
	(62, 'Fair Park', 'dallas', 5178, 'US'),
	(63, 'Long Beach', 'long_beach', 4629, 'US'),
	(64, 'Las Vegas Street Circuit', 'las_vegas', 4109, 'US'),
	(65, 'Watkins Glen', 'watkins_glen', 5158, 'US'),
	(66, 'Riverside International Raceway', 'riverside', 3966, 'US'),
	(67, 'Sebring International Raceway', 'sebring', 4858, 'US'),
	(68, 'Port Imperial Street Circuit', 'port_imperial', 4889, 'US'),
	(69, 'Kyalami', 'kyalami', 4374, 'ZA'),
	(70, 'Prince George Circuit', 'george', 3704, 'ZA'),
	(71, 'Beijing Olympic Green Circuit', 'beijing', 4871, 'CN'),
	(72, 'Berlin Tempelhof Airport', 'tempelhof', 5169, 'DE'),
	(73, 'Battersea Park Circuit', 'battersea', 3729, 'GB'),
	(74, 'Putrajaya Street Circuit', 'putrajaya', 3512, 'MY'),
	(75, 'Punta del Este Street Circuit', 'punta', 5143, 'UY'),
	(76, 'testcircuit_baixa', 'testcircuit_baixa_sobrenom', 6666, 'ES');
/*!40000 ALTER TABLE `circuit` ENABLE KEYS */;


-- Volcando estructura para tabla fia.competicio
CREATE TABLE IF NOT EXISTS `competicio` (
  `codi_competicio` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `nom` varchar(50) NOT NULL,
  `acronim` varchar(10) NOT NULL,
  `descripcio` text NOT NULL,
  PRIMARY KEY (`codi_competicio`),
  UNIQUE KEY `temporada` (`nom`),
  UNIQUE KEY `acronim` (`acronim`)
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.competicio: ~11 rows (aproximadamente)
DELETE FROM `competicio`;
/*!40000 ALTER TABLE `competicio` DISABLE KEYS */;
INSERT INTO `competicio` (`codi_competicio`, `nom`, `acronim`, `descripcio`) VALUES
	(1, 'Fórmula 1', 'F1', 'http://en.wikipedia.org/wiki/2015_Formula_One_season'),
	(2, 'World Rally Championship', 'WRC', 'http://en.wikipedia.org/wiki/2015_World_Rally_Championship_season'),
	(3, 'World Endurance Championship', 'WEC', 'http://en.wikipedia.org/wiki/2015_FIA_World_Endurance_Championship_season'),
	(4, 'World Touring Car Championship', 'WTCC', 'http://en.wikipedia.org/wiki/2015_World_Touring_Car_Championship_season'),
	(5, 'World Rally Cross Championship', 'WRX', 'http://en.wikipedia.org/wiki/2015_FIA_World_Rallycross_Championship_season'),
	(6, 'European Rally Cross Championship', 'ERX', 'http://en.wikipedia.org/wiki/FIA_European_Rallycross_Championship'),
	(7, 'Commission internationale de karting', 'CIK', 'http://en.wikipedia.org/wiki/Commission_Internationale_de_Karting'),
	(8, 'Formula-e Championship', 'FormulaE', 'http://en.wikipedia.org/wiki/2015%E2%80%9316_Formula_E_season'),
	(9, 'Formula 3', 'F3', 'http://en.wikipedia.org/wiki/2015_European_Formula_3_season'),
	(10, 'European Rally Championship', 'ERC', 'http://en.wikipedia.org/wiki/European_Rally_Championship'),
	(11, 'testcomp_baixa', 'TCB', 'Prova descripció'),
	(12, 'testcomp modificacio', 'TCM', 'Prova descripció modificacio');
	
/*!40000 ALTER TABLE `competicio` ENABLE KEYS */;


-- Volcando estructura para tabla fia.competicio_temporada
CREATE TABLE IF NOT EXISTS `competicio_temporada` (
  `competicio` smallint(5) unsigned NOT NULL,
  `temporada` year(4) NOT NULL,
  PRIMARY KEY (`competicio`,`temporada`),
  KEY `FK_competicio_temporada_temporada` (`temporada`),
  CONSTRAINT `FK_competicio_temporada_competicio` FOREIGN KEY (`competicio`) REFERENCES `competicio` (`codi_competicio`),
  CONSTRAINT `FK_competicio_temporada_temporada` FOREIGN KEY (`temporada`) REFERENCES `temporada` (`any`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.competicio_temporada: ~3 rows (aproximadamente)
DELETE FROM `competicio_temporada`;
/*!40000 ALTER TABLE `competicio_temporada` DISABLE KEYS */;
INSERT INTO `competicio_temporada` (`competicio`, `temporada`) VALUES
	(1, '2014'),
	(1, '2015'),
	(2, '2015');
/*!40000 ALTER TABLE `competicio_temporada` ENABLE KEYS */;


-- Volcando estructura para tabla fia.component
CREATE TABLE IF NOT EXISTS `component` (
  `codi_component` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `fabricant` mediumint(8) unsigned NOT NULL,
  `cotxe` mediumint(8) unsigned DEFAULT NULL,
  `descripcio` text NOT NULL,
  `utilitat` text NOT NULL,
  PRIMARY KEY (`codi_component`),
  KEY `FK_component_fabricant` (`fabricant`),
  KEY `FK_component_cotxe` (`cotxe`),
  CONSTRAINT `FK_component_cotxe` FOREIGN KEY (`cotxe`) REFERENCES `cotxe` (`codi_cotxe`),
  CONSTRAINT `FK_component_fabricant` FOREIGN KEY (`fabricant`) REFERENCES `fabricant` (`codi_fabricant`)
) ENGINE=InnoDB AUTO_INCREMENT=148 DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.component: ~147 rows (aproximadamente)
DELETE FROM `component`;
/*!40000 ALTER TABLE `component` DISABLE KEYS */;
INSERT INTO `component` (`codi_component`, `fabricant`, `cotxe`, `descripcio`, `utilitat`) VALUES
	(1, 1, 1, 'Neumàtics', 'Neumàtics per a la F1 intermig'),
	(2, 2, 1, 'Rodes', 'Rodes per a la F1'),
	(3, 3, 2, 'Rodes', 'Rodes per a la F1'),
	(4, 4, 3, 'Rodes', 'Rodes per a la F1'),
	(5, 5, 4, 'Rodes', 'Rodes per a la F1'),
	(6, 6, 5, 'Rodes', 'Rodes per a la F1'),
	(7, 22, 1, 'Embragatges', 'Embragatges per a la F1'),
	(8, 22, 1, 'Amortiguadors', 'Embragatges per a la F1'),
	(9, 23, 2, 'Amortiguadors', 'Amortiguadors per a la F1'),
	(10, 24, 3, 'Amortiguadors', 'Amortiguadors per a la F1'),
	(11, 25, 4, 'Amortiguadors', 'Amortiguadors per a la F1'),
	(12, 26, 5, 'Amortiguadors', 'Amortiguadors per a la F1'),
	(13, 10, 1, 'Frens', 'Frens per a la F1'),
	(14, 11, 2, 'Frens', 'Frens per a la F1'),
	(15, 12, 3, 'Frens', 'Frens per a la F1'),
	(16, 13, 4, 'Frens', 'Frens per a la F1'),
	(17, 14, 5, 'Frens', 'Frens per a la F1'),
	(18, 17, 1, 'Bugies', 'Bugies per a la F1'),
	(19, 18, 2, 'Bugies', 'Bugies per a la F1'),
	(20, 19, 3, 'Bugies', 'Bugies per a la F1'),
	(21, 17, 1, 'Caixa de canvi', 'Caixa de canvi per a la F1'),
	(22, 27, 2, 'Caixa de canvi', 'Caixa de canvi per a la F1'),
	(23, 28, 3, 'Caixa de canvi', 'Caixa de canvi per a la F1'),
	(24, 17, 1, 'Electrònica', 'Electrònica per a la F1'),
	(25, 29, 2, 'Electrònica', 'Electrònica per a la F1'),
	(26, 30, 3, 'Electrònica', 'Electrònica per a la F1'),
	(27, 31, 4, 'Electrònica', 'Electrònica per a la F1'),
	(28, 46, 1, 'Telemetria', 'Telemetria per a la F1'),
	(29, 47, 1, 'Bateries', 'Bateries per a la F1'),
	(30, 1, 2, 'Neumàtics', 'Neumàtics per a la F1 intermig'),
	(31, 1, 3, 'Neumàtics', 'Neumàtics per a la F1 intermig'),
	(32, 1, 4, 'Neumàtics', 'Neumàtics per a la F1 intermig'),
	(33, 1, 5, 'Neumàtics', 'Neumàtics per a la F1 intermig'),
	(34, 1, 6, 'Neumàtics', 'Neumàtics per a la F1 intermig'),
	(35, 1, 7, 'Neumàtics', 'Neumàtics per a la F1 intermig'),
	(36, 1, 8, 'Neumàtics', 'Neumàtics per a la F1 intermig'),
	(37, 1, 9, 'Neumàtics', 'Neumàtics per a la F1 intermig'),
	(38, 1, 10, 'Neumàtics', 'Neumàtics per a la F1 intermig'),
	(39, 22, 2, 'Embragatges', 'Embragatges per a la F1'),
	(40, 22, 3, 'Embragatges', 'Embragatges per a la F1'),
	(41, 22, 4, 'Embragatges', 'Embragatges per a la F1'),
	(42, 22, 5, 'Embragatges', 'Embragatges per a la F1'),
	(43, 22, 6, 'Embragatges', 'Embragatges per a la F1'),
	(44, 22, 7, 'Embragatges', 'Embragatges per a la F1'),
	(45, 22, 8, 'Embragatges', 'Embragatges per a la F1'),
	(46, 22, 9, 'Embragatges', 'Embragatges per a la F1'),
	(47, 22, 10, 'Embragatges', 'Embragatges per a la F1'),
	(48, 22, 6, 'Amortiguadors', 'Embragatges per a la F1'),
	(49, 23, 10, 'Amortiguadors', 'Amortiguadors per a la F1'),
	(50, 24, 7, 'Amortiguadors', 'Amortiguadors per a la F1'),
	(51, 25, 8, 'Amortiguadors', 'Amortiguadors per a la F1'),
	(52, 26, 9, 'Amortiguadors', 'Amortiguadors per a la F1'),
	(53, 10, 6, 'Frens', 'Frens per a la F1'),
	(54, 11, 7, 'Frens', 'Frens per a la F1'),
	(55, 12, 8, 'Frens', 'Frens per a la F1'),
	(56, 13, 9, 'Frens', 'Frens per a la F1'),
	(57, 14, 10, 'Frens', 'Frens per a la F1'),
	(58, 17, 4, 'Bugies', 'Bugies per a la F1'),
	(59, 17, 5, 'Bugies', 'Bugies per a la F1'),
	(60, 18, 6, 'Bugies', 'Bugies per a la F1'),
	(61, 18, 7, 'Bugies', 'Bugies per a la F1'),
	(62, 19, 8, 'Bugies', 'Bugies per a la F1'),
	(63, 19, 9, 'Bugies', 'Bugies per a la F1'),
	(64, 19, 10, 'Bugies', 'Bugies per a la F1'),
	(65, 17, 4, 'Caixa de canvi', 'Caixa de canvi per a la F1'),
	(66, 17, 5, 'Caixa de canvi', 'Caixa de canvi per a la F1'),
	(67, 27, 6, 'Caixa de canvi', 'Caixa de canvi per a la F1'),
	(68, 27, 7, 'Caixa de canvi', 'Caixa de canvi per a la F1'),
	(69, 28, 8, 'Caixa de canvi', 'Caixa de canvi per a la F1'),
	(70, 28, 9, 'Caixa de canvi', 'Caixa de canvi per a la F1'),
	(71, 28, 10, 'Caixa de canvi', 'Caixa de canvi per a la F1'),
	(72, 17, 5, 'Electrònica', 'Electrònica per a la F1'),
	(73, 17, 6, 'Electrònica', 'Electrònica per a la F1'),
	(74, 29, 7, 'Electrònica', 'Electrònica per a la F1'),
	(75, 29, 8, 'Electrònica', 'Electrònica per a la F1'),
	(76, 30, 9, 'Electrònica', 'Electrònica per a la F1'),
	(77, 31, 10, 'Electrònica', 'Electrònica per a la F1'),
	(78, 46, 2, 'Telemetria', 'Telemetria per a la F1'),
	(79, 46, 3, 'Telemetria', 'Telemetria per a la F1'),
	(80, 46, 4, 'Telemetria', 'Telemetria per a la F1'),
	(81, 46, 5, 'Telemetria', 'Telemetria per a la F1'),
	(82, 46, 6, 'Telemetria', 'Telemetria per a la F1'),
	(83, 46, 7, 'Telemetria', 'Telemetria per a la F1'),
	(84, 46, 8, 'Telemetria', 'Telemetria per a la F1'),
	(85, 46, 9, 'Telemetria', 'Telemetria per a la F1'),
	(86, 46, 10, 'Telemetria', 'Telemetria per a la F1'),
	(87, 47, 2, 'Bateries', 'Bateries per a la F1'),
	(88, 47, 3, 'Bateries', 'Bateries per a la F1'),
	(89, 47, 4, 'Bateries', 'Bateries per a la F1'),
	(90, 47, 5, 'Bateries', 'Bateries per a la F1'),
	(91, 47, 6, 'Bateries', 'Bateries per a la F1'),
	(92, 47, 7, 'Bateries', 'Bateries per a la F1'),
	(93, 47, 8, 'Bateries', 'Bateries per a la F1'),
	(94, 47, 9, 'Bateries', 'Bateries per a la F1'),
	(95, 47, 10, 'Bateries', 'Bateries per a la F1'),
	(96, 2, 6, 'Rodes', 'Rodes per a la F1'),
	(97, 2, 7, 'Rodes', 'Rodes per a la F1'),
	(98, 2, 8, 'Rodes', 'Rodes per a la F1'),
	(99, 2, 9, 'Rodes', 'Rodes per a la F1'),
	(100, 2, 10, 'Rodes', 'Rodes per a la F1'),
	(101, 1, 1, 'Neumàtics', 'Neumàtics per a la F1 intermig'),
	(102, 46, 1, 'Consumeter', 'Mesura el consum del cotxe en litres per segon'),
	(103, 3, 1, 'Velocímetre', 'Calcula el temps per volta del cotxe'),
	(104, 3, 2, 'Velocímetre', 'Calcula el temps per volta del cotxe'),
	(105, 3, 3, 'Velocímetre', 'Calcula el temps per volta del cotxe'),
	(106, 3, 4, 'Velocímetre', 'Calcula el temps per volta del cotxe'),
	(107, 3, 5, 'Velocímetre', 'Calcula el temps per volta del cotxe'),
	(108, 41, 1, 'Termòmetre', 'Calcula la temperatura del motor'),
	(109, 41, 2, 'Termòmetre', 'Calcula la temperatura del motor'),
	(110, 41, 3, 'Termòmetre', 'Calcula la temperatura del motor'),
	(111, 41, 4, 'Termòmetre', 'Calcula la temperatura del motor'),
	(112, 41, 5, 'Termòmetre', 'Calcula la temperatura del motor'),
	(113, 3, 14, 'Velocímetre', 'Calcula el temps per volta del cotxe'),
	(114, 3, 15, 'Velocímetre', 'Calcula el temps per volta del cotxe'),
	(115, 3, 16, 'Velocímetre', 'Calcula el temps per volta del cotxe'),
	(116, 3, 17, 'Velocímetre', 'Calcula el temps per volta del cotxe'),
	(117, 3, 18, 'Velocímetre', 'Calcula el temps per volta del cotxe'),
	(118, 41, 14, 'Termòmetre', 'Calcula la temperatura del motor'),
	(119, 41, 15, 'Termòmetre', 'Calcula la temperatura del motor'),
	(120, 41, 16, 'Termòmetre', 'Calcula la temperatura del motor'),
	(121, 41, 17, 'Termòmetre', 'Calcula la temperatura del motor'),
	(122, 41, 18, 'Termòmetre', 'Calcula la temperatura del motor'),
	(123, 46, 2, 'Consumeter', 'Mesura el consum del cotxe en litres per segon'),
	(124, 46, 3, 'Consumeter', 'Mesura el consum del cotxe en litres per segon'),
	(125, 46, 4, 'Consumeter', 'Mesura el consum del cotxe en litres per segon'),
	(126, 46, 5, 'Consumeter', 'Mesura el consum del cotxe en litres per segon'),
	(127, 46, 14, 'Consumeter', 'Mesura el consum del cotxe en litres per segon'),
	(128, 46, 15, 'Consumeter', 'Mesura el consum del cotxe en litres per segon'),
	(129, 46, 16, 'Consumeter', 'Mesura el consum del cotxe en litres per segon'),
	(130, 46, 17, 'Consumeter', 'Mesura el consum del cotxe en litres per segon'),
	(131, 46, 18, 'Consumeter', 'Mesura el consum del cotxe en litres per segon'),
	(132, 46, 9, 'Consumeter', 'Mesura el consum del cotxe en litres per segon'),
	(133, 46, 10, 'Consumeter', 'Mesura el consum del cotxe en litres per segon'),
	(134, 46, 11, 'Consumeter', 'Mesura el consum del cotxe en litres per segon'),
	(135, 46, 12, 'Consumeter', 'Mesura el consum del cotxe en litres per segon'),
	(136, 46, 13, 'Consumeter', 'Mesura el consum del cotxe en litres per segon'),
	(137, 3, 9, 'Velocímetre', 'Calcula el temps per volta del cotxe'),
	(138, 3, 10, 'Velocímetre', 'Calcula el temps per volta del cotxen'),
	(139, 3, 11, 'Velocímetre', 'Calcula el temps per volta del cotxe'),
	(140, 3, 12, 'Velocímetre', 'Calcula el temps per volta del cotxe'),
	(141, 3, 13, 'Velocímetre', 'Calcula el temps per volta del cotxe'),
	(142, 41, 9, 'Termòmetre', 'Calcula la temperatura del motor'),
	(143, 41, 10, 'Termòmetre', 'Calcula la temperatura del motor'),
	(144, 41, 11, 'Termòmetre', 'Calcula la temperatura del motor'),
	(145, 41, 12, 'Termòmetre', 'Calcula la temperatura del motor'),
	(146, 41, 13, 'Termòmetre', 'Calcula la temperatura del motor'),
	(147, 3, 1, 'TestComponent baixa', 'Prova descripció');
/*!40000 ALTER TABLE `component` ENABLE KEYS */;


-- Volcando estructura para tabla fia.cotxe
CREATE TABLE IF NOT EXISTS `cotxe` (
  `codi_cotxe` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `model` varchar(25) NOT NULL,
  `any_debut` year(4) NOT NULL,
  PRIMARY KEY (`codi_cotxe`),
  UNIQUE KEY `model` (`model`)
) ENGINE=InnoDB AUTO_INCREMENT=19 DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.cotxe: ~18 rows (aproximadamente)
DELETE FROM `cotxe`;
/*!40000 ALTER TABLE `cotxe` DISABLE KEYS */;
INSERT INTO `cotxe` (`codi_cotxe`, `model`, `any_debut`) VALUES
	(1, 'SF15-T', '2015'),
	(2, 'F1 W06 Hybrid', '2015'),
	(3, 'RB11', '2015'),
	(4, 'FW37', '2015'),
	(5, 'MP4-30', '2015'),
	(6, 'VJM08', '2015'),
	(7, 'STR10', '2015'),
	(8, 'E23 Hybrid', '2015'),
	(9, 'C34', '2015'),
	(10, 'MR03', '2015'),
	(11, 'Citroën DS3 WRC', '2015'),
	(12, 'Hyundai i20WRC', '2015'),
	(13, 'testmodel_mod', '2015'),
	(14, 'SF14-T', '2014'),
	(15, 'F1 W05 Hybrid', '2014'),
	(16, 'RB10', '2014'),
	(17, 'FW36', '2014'),
	(18, 'MP4-20', '2014');
/*!40000 ALTER TABLE `cotxe` ENABLE KEYS */;


-- Volcando estructura para tabla fia.cotxe_equip
CREATE TABLE IF NOT EXISTS `cotxe_equip` (
  `cotxe` mediumint(8) unsigned NOT NULL,
  `equip` smallint(5) unsigned NOT NULL,
  `temporada` year(4) NOT NULL,
  PRIMARY KEY (`cotxe`,`equip`,`temporada`),
  KEY `FK_cotxe_equip_equip` (`equip`),
  KEY `FK_cotxe_equip_temporada` (`temporada`),
  CONSTRAINT `FK_cotxe_equip_cotxe` FOREIGN KEY (`cotxe`) REFERENCES `cotxe` (`codi_cotxe`),
  CONSTRAINT `FK_cotxe_equip_equip` FOREIGN KEY (`equip`) REFERENCES `equip` (`codi_equip`),
  CONSTRAINT `FK_cotxe_equip_temporada` FOREIGN KEY (`temporada`) REFERENCES `temporada` (`any`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.cotxe_equip: ~18 rows (aproximadamente)
DELETE FROM `cotxe_equip`;
/*!40000 ALTER TABLE `cotxe_equip` DISABLE KEYS */;
INSERT INTO `cotxe_equip` (`cotxe`, `equip`, `temporada`) VALUES
	(14, 1, '2014'),
	(15, 2, '2014'),
	(16, 3, '2014'),
	(17, 4, '2014'),
	(18, 5, '2014'),
	(1, 1, '2015'),
	(2, 2, '2015'),
	(3, 3, '2015'),
	(4, 4, '2015'),
	(5, 5, '2015'),
	(6, 6, '2015'),
	(7, 7, '2015'),
	(8, 8, '2015'),
	(9, 9, '2015'),
	(10, 10, '2015'),
	(11, 11, '2015'),
	(12, 12, '2015'),
	(13, 13, '2015');
/*!40000 ALTER TABLE `cotxe_equip` ENABLE KEYS */;


-- Volcando estructura para tabla fia.cursa
CREATE TABLE IF NOT EXISTS `cursa` (
  `circuit` mediumint(8) unsigned NOT NULL,
  `pilot` mediumint(8) unsigned NOT NULL,
  `competicio` smallint(5) unsigned NOT NULL,
  `posicio` smallint(5) unsigned NOT NULL,
  `data_cursa` date NOT NULL,
  PRIMARY KEY (`circuit`,`pilot`,`competicio`,`data_cursa`),
  KEY `FK_cursa_pilot` (`pilot`),
  KEY `FK_cursa_competicio` (`competicio`),
  CONSTRAINT `FK_cursa_circuit` FOREIGN KEY (`circuit`) REFERENCES `circuit` (`codi_circuit`),
  CONSTRAINT `FK_cursa_competicio` FOREIGN KEY (`competicio`) REFERENCES `competicio` (`codi_competicio`),
  CONSTRAINT `FK_cursa_pilot` FOREIGN KEY (`pilot`) REFERENCES `pilot` (`codi_persona`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.cursa: ~75 rows (aproximadamente)
DELETE FROM `cursa`;
/*!40000 ALTER TABLE `cursa` DISABLE KEYS */;
INSERT INTO `cursa` (`circuit`, `pilot`, `competicio`, `posicio`, `data_cursa`) VALUES
	(3, 6, 1, 4, '2014-01-15'),
	(3, 6, 1, 0, '2015-01-15'),
	(3, 7, 1, 0, '2014-01-15'),
	(3, 7, 1, 0, '2015-01-15'),
	(3, 8, 1, 3, '2014-01-15'),
	(3, 8, 1, 3, '2015-01-15'),
	(3, 9, 1, 2, '2014-01-15'),
	(3, 9, 1, 2, '2015-01-15'),
	(3, 10, 1, 1, '2014-01-15'),
	(3, 10, 1, 1, '2015-01-15'),
	(4, 6, 1, 5, '2014-02-01'),
	(4, 6, 1, 0, '2015-02-01'),
	(4, 7, 1, 3, '2014-02-01'),
	(4, 7, 1, 2, '2015-02-01'),
	(4, 8, 1, 4, '2014-02-01'),
	(4, 8, 1, 3, '2015-02-01'),
	(4, 9, 1, 2, '2014-02-01'),
	(4, 9, 1, 1, '2015-02-01'),
	(4, 10, 1, 1, '2014-02-01'),
	(4, 10, 1, 4, '2015-02-01'),
	(5, 6, 1, 3, '2014-02-15'),
	(5, 6, 1, 0, '2015-02-15'),
	(5, 7, 1, 1, '2014-02-15'),
	(5, 7, 1, 4, '2015-02-15'),
	(5, 8, 1, 0, '2014-02-15'),
	(5, 8, 1, 3, '2015-02-15'),
	(5, 9, 1, 4, '2014-02-15'),
	(5, 9, 1, 1, '2015-02-15'),
	(5, 10, 1, 2, '2014-02-15'),
	(5, 10, 1, 2, '2015-02-15'),
	(6, 6, 1, 5, '2014-03-01'),
	(6, 6, 1, 5, '2015-03-01'),
	(6, 7, 1, 4, '2014-03-01'),
	(6, 7, 1, 4, '2015-03-01'),
	(6, 8, 1, 3, '2014-03-01'),
	(6, 8, 1, 1, '2015-03-01'),
	(6, 9, 1, 2, '2014-03-01'),
	(6, 9, 1, 2, '2015-03-01'),
	(6, 10, 1, 1, '2014-03-01'),
	(6, 10, 1, 3, '2015-03-01'),
	(8, 6, 1, 4, '2014-03-15'),
	(8, 6, 1, 3, '2015-03-15'),
	(8, 7, 1, 5, '2014-03-15'),
	(8, 7, 1, 0, '2015-03-15'),
	(8, 8, 1, 2, '2014-03-15'),
	(8, 8, 1, 2, '2015-03-15'),
	(8, 9, 1, 3, '2014-03-15'),
	(8, 9, 1, 0, '2015-03-15'),
	(8, 10, 1, 1, '2014-03-15'),
	(8, 10, 1, 1, '2015-03-15'),
	(9, 6, 1, 4, '2014-04-01'),
	(9, 6, 1, 0, '2015-04-01'),
	(9, 7, 1, 0, '2014-04-01'),
	(9, 7, 1, 1, '2015-04-01'),
	(9, 8, 1, 2, '2014-04-01'),
	(9, 8, 1, 2, '2015-04-01'),
	(9, 9, 1, 1, '2014-04-01'),
	(9, 9, 1, 4, '2015-04-01'),
	(9, 10, 1, 3, '2014-04-01'),
	(9, 10, 1, 3, '2015-04-01'),
	(15, 11, 2, 1, '2015-01-15'),
	(15, 12, 2, 2, '2015-01-15'),
	(15, 13, 2, 3, '2015-01-15'),
	(15, 14, 2, 0, '2015-01-15'),
	(15, 15, 2, 0, '2015-01-15'),
	(16, 11, 2, 0, '2015-01-01'),
	(16, 12, 2, 2, '2015-01-01'),
	(16, 13, 2, 1, '2015-01-01'),
	(16, 14, 2, 0, '2015-01-01'),
	(16, 15, 2, 3, '2015-01-01'),
	(17, 11, 2, 1, '2015-02-01'),
	(17, 12, 2, 0, '2015-02-01'),
	(17, 13, 2, 2, '2015-02-01'),
	(17, 14, 2, 0, '2015-02-01'),
	(17, 15, 2, 3, '2015-02-01');
/*!40000 ALTER TABLE `cursa` ENABLE KEYS */;


-- Volcando estructura para tabla fia.dim_classificacio
CREATE TABLE IF NOT EXISTS `dim_classificacio` (
  `competicio` smallint(5) unsigned NOT NULL,
  `temporada` year(4) NOT NULL,
  `pilot` mediumint(8) unsigned NOT NULL,
  `punts` smallint(5) unsigned NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.dim_classificacio: ~15 rows (aproximadamente)
DELETE FROM `dim_classificacio`;
/*!40000 ALTER TABLE `dim_classificacio` DISABLE KEYS */;
INSERT INTO `dim_classificacio` (`competicio`, `temporada`, `pilot`, `punts`) VALUES
	(1, '2014', 6, 5),
	(1, '2014', 7, 30),
	(1, '2014', 8, 40),
	(1, '2014', 9, 75),
	(1, '2014', 10, 120),
	(1, '2015', 6, 5),
	(1, '2015', 7, 40),
	(1, '2015', 8, 70),
	(1, '2015', 9, 80),
	(1, '2015', 10, 75),
	(2, '2015', 11, 50),
	(2, '2015', 12, 30),
	(2, '2015', 13, 45),
	(2, '2015', 14, 0),
	(2, '2015', 15, 10);
/*!40000 ALTER TABLE `dim_classificacio` ENABLE KEYS */;


-- Volcando estructura para tabla fia.dim_component
CREATE TABLE IF NOT EXISTS `dim_component` (
  `fabricant` mediumint(8) unsigned NOT NULL,
  `components` mediumint(8) unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.dim_component: ~27 rows (aproximadamente)
DELETE FROM `dim_component`;
/*!40000 ALTER TABLE `dim_component` DISABLE KEYS */;
INSERT INTO `dim_component` (`fabricant`, `components`) VALUES
	(1, 11),
	(2, 6),
	(3, 17),
	(4, 1),
	(5, 1),
	(6, 1),
	(22, 12),
	(23, 2),
	(24, 2),
	(25, 2),
	(26, 2),
	(10, 2),
	(11, 2),
	(12, 2),
	(13, 2),
	(14, 2),
	(17, 9),
	(18, 3),
	(19, 4),
	(27, 3),
	(28, 4),
	(29, 3),
	(30, 2),
	(31, 2),
	(46, 25),
	(47, 10),
	(41, 15);
/*!40000 ALTER TABLE `dim_component` ENABLE KEYS */;


-- Volcando estructura para tabla fia.dim_consum
CREATE TABLE IF NOT EXISTS `dim_consum` (
  `competicio` smallint(5) unsigned NOT NULL,
  `temporada` year(4) NOT NULL,
  `cotxe` mediumint(8) unsigned NOT NULL,
  `consum` float(8,4) unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.dim_consum: ~15 rows (aproximadamente)
DELETE FROM `dim_consum`;
/*!40000 ALTER TABLE `dim_consum` DISABLE KEYS */;
INSERT INTO `dim_consum` (`competicio`, `temporada`, `cotxe`, `consum`) VALUES
	(1, '2015', 1, 524.4401),
	(1, '2015', 2, 527.3482),
	(1, '2015', 3, 635.5076),
	(1, '2015', 4, 666.8037),
	(1, '2015', 5, 569.2689),
	(1, '2014', 14, 574.2866),
	(1, '2014', 15, 609.6933),
	(1, '2014', 16, 556.8136),
	(1, '2014', 17, 641.4167),
	(1, '2014', 18, 637.0983),
	(2, '2015', 9, 341.4133),
	(2, '2015', 10, 301.9355),
	(2, '2015', 11, 359.8874),
	(2, '2015', 12, 338.6833),
	(2, '2015', 13, 353.3720);
/*!40000 ALTER TABLE `dim_consum` ENABLE KEYS */;


-- Volcando estructura para tabla fia.dim_defectuos
CREATE TABLE IF NOT EXISTS `dim_defectuos` (
  `cotxe` mediumint(8) unsigned NOT NULL,
  `component` mediumint(8) unsigned NOT NULL,
  `defectuos` bit(1) NOT NULL DEFAULT b'0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.dim_defectuos: ~147 rows (aproximadamente)
DELETE FROM `dim_defectuos`;
/*!40000 ALTER TABLE `dim_defectuos` DISABLE KEYS */;
INSERT INTO `dim_defectuos` (`cotxe`, `component`, `defectuos`) VALUES
	(1, 1, b'0'),
	(1, 2, b'0'),
	(2, 3, b'0'),
	(3, 4, b'0'),
	(4, 5, b'0'),
	(5, 6, b'0'),
	(1, 7, b'0'),
	(1, 8, b'0'),
	(2, 9, b'0'),
	(3, 10, b'0'),
	(4, 11, b'0'),
	(5, 12, b'0'),
	(1, 13, b'0'),
	(2, 14, b'0'),
	(3, 15, b'0'),
	(4, 16, b'0'),
	(5, 17, b'0'),
	(1, 18, b'0'),
	(2, 19, b'0'),
	(3, 20, b'0'),
	(1, 21, b'0'),
	(2, 22, b'0'),
	(3, 23, b'0'),
	(1, 24, b'0'),
	(2, 25, b'0'),
	(3, 26, b'0'),
	(4, 27, b'0'),
	(1, 28, b'0'),
	(1, 29, b'0'),
	(2, 30, b'0'),
	(3, 31, b'0'),
	(4, 32, b'0'),
	(5, 33, b'0'),
	(6, 34, b'0'),
	(7, 35, b'0'),
	(8, 36, b'0'),
	(9, 37, b'0'),
	(10, 38, b'0'),
	(2, 39, b'0'),
	(3, 40, b'0'),
	(4, 41, b'0'),
	(5, 42, b'0'),
	(6, 43, b'0'),
	(7, 44, b'0'),
	(8, 45, b'0'),
	(9, 46, b'0'),
	(10, 47, b'0'),
	(6, 48, b'0'),
	(10, 49, b'0'),
	(7, 50, b'0'),
	(8, 51, b'0'),
	(9, 52, b'0'),
	(6, 53, b'0'),
	(7, 54, b'0'),
	(8, 55, b'0'),
	(9, 56, b'0'),
	(10, 57, b'0'),
	(4, 58, b'0'),
	(5, 59, b'0'),
	(6, 60, b'0'),
	(7, 61, b'0'),
	(8, 62, b'0'),
	(9, 63, b'0'),
	(10, 64, b'0'),
	(4, 65, b'0'),
	(5, 66, b'0'),
	(6, 67, b'0'),
	(7, 68, b'0'),
	(8, 69, b'0'),
	(9, 70, b'0'),
	(10, 71, b'0'),
	(5, 72, b'0'),
	(6, 73, b'0'),
	(7, 74, b'0'),
	(8, 75, b'0'),
	(9, 76, b'0'),
	(10, 77, b'0'),
	(2, 78, b'0'),
	(3, 79, b'0'),
	(4, 80, b'0'),
	(5, 81, b'0'),
	(6, 82, b'0'),
	(7, 83, b'0'),
	(8, 84, b'0'),
	(9, 85, b'0'),
	(10, 86, b'0'),
	(2, 87, b'0'),
	(3, 88, b'0'),
	(4, 89, b'0'),
	(5, 90, b'0'),
	(6, 91, b'0'),
	(7, 92, b'0'),
	(8, 93, b'0'),
	(9, 94, b'0'),
	(10, 95, b'0'),
	(6, 96, b'0'),
	(7, 97, b'0'),
	(8, 98, b'0'),
	(9, 99, b'0'),
	(10, 100, b'0'),
	(1, 101, b'0'),
	(1, 102, b'0'),
	(1, 103, b'0'),
	(2, 104, b'0'),
	(3, 105, b'0'),
	(4, 106, b'0'),
	(5, 107, b'0'),
	(1, 108, b'0'),
	(2, 109, b'0'),
	(3, 110, b'0'),
	(4, 111, b'0'),
	(5, 112, b'0'),
	(14, 113, b'0'),
	(15, 114, b'0'),
	(16, 115, b'0'),
	(17, 116, b'0'),
	(18, 117, b'0'),
	(14, 118, b'0'),
	(15, 119, b'0'),
	(16, 120, b'0'),
	(17, 121, b'0'),
	(18, 122, b'0'),
	(2, 123, b'0'),
	(3, 124, b'0'),
	(4, 125, b'0'),
	(5, 126, b'0'),
	(14, 127, b'0'),
	(15, 128, b'0'),
	(16, 129, b'0'),
	(17, 130, b'0'),
	(18, 131, b'0'),
	(9, 132, b'0'),
	(10, 133, b'0'),
	(11, 134, b'0'),
	(12, 135, b'0'),
	(13, 136, b'0'),
	(9, 137, b'0'),
	(10, 138, b'0'),
	(11, 139, b'0'),
	(12, 140, b'0'),
	(13, 141, b'0'),
	(9, 142, b'0'),
	(10, 143, b'0'),
	(11, 144, b'0'),
	(12, 145, b'0'),
	(13, 146, b'0'),
	(1, 147, b'0');
/*!40000 ALTER TABLE `dim_defectuos` ENABLE KEYS */;


-- Volcando estructura para tabla fia.dim_patrocini
CREATE TABLE IF NOT EXISTS `dim_patrocini` (
  `patrocinador` mediumint(9) unsigned NOT NULL,
  `cost` int(11) unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.dim_patrocini: ~12 rows (aproximadamente)
DELETE FROM `dim_patrocini`;
/*!40000 ALTER TABLE `dim_patrocini` DISABLE KEYS */;
INSERT INTO `dim_patrocini` (`patrocinador`, `cost`) VALUES
	(1, 1250000),
	(2, 3200000),
	(3, 1805555),
	(4, 700000),
	(5, 1000000),
	(6, 1250000),
	(7, 2500000),
	(8, 2300000),
	(9, 1720000),
	(10, 1150000),
	(11, 2400000),
	(12, 2100000);
/*!40000 ALTER TABLE `dim_patrocini` ENABLE KEYS */;


-- Volcando estructura para tabla fia.dim_resultat
CREATE TABLE IF NOT EXISTS `dim_resultat` (
  `pilot` mediumint(8) unsigned NOT NULL,
  `guanyades` smallint(5) unsigned NOT NULL DEFAULT '0',
  `finalitzades` smallint(5) unsigned NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.dim_resultat: ~9 rows (aproximadamente)
DELETE FROM `dim_resultat`;
/*!40000 ALTER TABLE `dim_resultat` DISABLE KEYS */;
INSERT INTO `dim_resultat` (`pilot`, `guanyades`, `finalitzades`) VALUES
	(6, 0, 8),
	(8, 1, 11),
	(9, 3, 11),
	(10, 6, 12),
	(7, 2, 8),
	(11, 2, 2),
	(12, 0, 2),
	(13, 1, 3),
	(15, 0, 2);
/*!40000 ALTER TABLE `dim_resultat` ENABLE KEYS */;


-- Volcando estructura para tabla fia.dim_telemetria
CREATE TABLE IF NOT EXISTS `dim_telemetria` (
  `temporada` year(4) NOT NULL,
  `equip` smallint(6) unsigned NOT NULL,
  `dades_any` mediumint(8) unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.dim_telemetria: ~15 rows (aproximadamente)
DELETE FROM `dim_telemetria`;
/*!40000 ALTER TABLE `dim_telemetria` DISABLE KEYS */;
INSERT INTO `dim_telemetria` (`temporada`, `equip`, `dades_any`) VALUES
	('2015', 1, 53636),
	('2015', 2, 52879),
	('2015', 3, 56853),
	('2015', 4, 54326),
	('2015', 5, 54477),
	('2014', 1, 55294),
	('2014', 2, 56467),
	('2014', 3, 55680),
	('2014', 4, 58555),
	('2014', 5, 59682),
	('2015', 9, 26411),
	('2015', 10, 26406),
	('2015', 11, 27177),
	('2015', 12, 25989),
	('2015', 13, 25644);
/*!40000 ALTER TABLE `dim_telemetria` ENABLE KEYS */;


-- Volcando estructura para tabla fia.dim_volta_rapida
CREATE TABLE IF NOT EXISTS `dim_volta_rapida` (
  `circuit` mediumint(8) unsigned NOT NULL,
  `pilot` mediumint(8) unsigned NOT NULL,
  `equip` smallint(5) unsigned NOT NULL,
  `data` date NOT NULL,
  `temps` time NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.dim_volta_rapida: ~4.500 rows (aproximadamente)
DELETE FROM `dim_volta_rapida`;
/*!40000 ALTER TABLE `dim_volta_rapida` DISABLE KEYS */;
INSERT INTO `dim_volta_rapida` (`circuit`, `pilot`, `equip`, `data`, `temps`) VALUES
	(3, 6, 1, '2015-01-15', '02:16:00'),
	(3, 6, 1, '2015-01-15', '03:21:00'),
	(3, 6, 1, '2015-01-15', '03:31:00'),
	(3, 6, 1, '2015-01-15', '03:35:00'),
	(3, 6, 1, '2015-01-15', '03:24:00'),
	(3, 6, 1, '2015-01-15', '02:22:00'),
	(3, 6, 1, '2015-01-15', '02:32:00'),
	(3, 6, 1, '2015-01-15', '01:39:00'),
	(3, 6, 1, '2015-01-15', '01:37:00'),
	(3, 6, 1, '2015-01-15', '01:40:00'),
	(3, 6, 1, '2015-01-15', '01:57:00'),
	(3, 6, 1, '2015-01-15', '03:16:00'),
	(3, 6, 1, '2015-01-15', '01:38:00'),
	(3, 6, 1, '2015-01-15', '01:45:00'),
	(3, 6, 1, '2015-01-15', '02:23:00'),
	(3, 6, 1, '2015-01-15', '02:42:00'),
	(3, 6, 1, '2015-01-15', '02:23:00'),
	(3, 6, 1, '2015-01-15', '02:23:00'),
	(3, 6, 1, '2015-01-15', '03:15:00'),
	(3, 6, 1, '2015-01-15', '02:43:00'),
	(3, 6, 1, '2015-01-15', '02:20:00'),
	(3, 6, 1, '2015-01-15', '02:01:00'),
	(3, 6, 1, '2015-01-15', '01:35:00'),
	(3, 6, 1, '2015-01-15', '02:50:00'),
	(3, 6, 1, '2015-01-15', '03:04:00'),
	(3, 6, 1, '2015-01-15', '02:51:00'),
	(3, 6, 1, '2015-01-15', '03:32:00'),
	(3, 6, 1, '2015-01-15', '02:46:00'),
	(3, 6, 1, '2015-01-15', '01:42:00'),
	(3, 6, 1, '2015-01-15', '03:39:00'),
	(3, 6, 1, '2015-01-15', '01:49:00'),
	(3, 6, 1, '2015-01-15', '01:34:00'),
	(3, 6, 1, '2015-01-15', '03:22:00'),
	(3, 6, 1, '2015-01-15', '03:17:00'),
	(3, 6, 1, '2015-01-15', '02:24:00'),
	(3, 6, 1, '2015-01-15', '03:04:00'),
	(3, 6, 1, '2015-01-15', '01:45:00'),
	(3, 6, 1, '2015-01-15', '02:59:00'),
	(3, 6, 1, '2015-01-15', '03:17:00'),
	(3, 6, 1, '2015-01-15', '03:32:00'),
	(3, 6, 1, '2015-01-15', '03:50:00'),
	(3, 6, 1, '2015-01-15', '02:12:00'),
	(3, 6, 1, '2015-01-15', '02:55:00'),
	(3, 6, 1, '2015-01-15', '01:35:00'),
	(3, 6, 1, '2015-01-15', '02:34:00'),
	(3, 6, 1, '2015-01-15', '01:41:00'),
	(3, 6, 1, '2015-01-15', '01:43:00'),
	(3, 6, 1, '2015-01-15', '02:02:00'),
	(3, 6, 1, '2015-01-15', '03:31:00'),
	(3, 6, 1, '2015-01-15', '02:38:00'),
	(3, 6, 1, '2015-01-15', '03:36:00'),
	(3, 6, 1, '2015-01-15', '03:41:00'),
	(3, 6, 1, '2015-01-15', '03:42:00'),
	(3, 6, 1, '2015-01-15', '03:28:00'),
	(3, 6, 1, '2015-01-15', '02:20:00'),
	(3, 6, 1, '2015-01-15', '02:14:00'),
	(3, 6, 1, '2015-01-15', '02:38:00'),
	(3, 6, 1, '2015-01-15', '02:32:00'),
	(3, 6, 1, '2015-01-15', '03:18:00'),
	(3, 6, 1, '2015-01-15', '02:30:00'),
	(3, 7, 2, '2015-01-15', '03:50:00'),
	(3, 7, 2, '2015-01-15', '02:23:00'),
	(3, 7, 2, '2015-01-15', '03:43:00'),
	(3, 7, 2, '2015-01-15', '02:45:00'),
	(3, 7, 2, '2015-01-15', '03:31:00'),
	(3, 7, 2, '2015-01-15', '03:04:00'),
	(3, 7, 2, '2015-01-15', '03:20:00'),
	(3, 7, 2, '2015-01-15', '03:34:00'),
	(3, 7, 2, '2015-01-15', '01:33:00'),
	(3, 7, 2, '2015-01-15', '02:43:00'),
	(3, 7, 2, '2015-01-15', '02:42:00'),
	(3, 7, 2, '2015-01-15', '03:50:00'),
	(3, 7, 2, '2015-01-15', '02:26:00'),
	(3, 7, 2, '2015-01-15', '01:35:00'),
	(3, 7, 2, '2015-01-15', '03:52:00'),
	(3, 7, 2, '2015-01-15', '03:36:00'),
	(3, 7, 2, '2015-01-15', '02:29:00'),
	(3, 7, 2, '2015-01-15', '02:32:00'),
	(3, 7, 2, '2015-01-15', '03:42:00'),
	(3, 7, 2, '2015-01-15', '02:14:00'),
	(3, 7, 2, '2015-01-15', '03:23:00'),
	(3, 7, 2, '2015-01-15', '01:32:00'),
	(3, 7, 2, '2015-01-15', '03:12:00'),
	(3, 7, 2, '2015-01-15', '02:44:00'),
	(3, 7, 2, '2015-01-15', '02:34:00'),
	(3, 7, 2, '2015-01-15', '03:10:00'),
	(3, 7, 2, '2015-01-15', '01:54:00'),
	(3, 7, 2, '2015-01-15', '03:15:00'),
	(3, 7, 2, '2015-01-15', '01:53:00'),
	(3, 7, 2, '2015-01-15', '02:59:00'),
	(3, 7, 2, '2015-01-15', '02:59:00'),
	(3, 7, 2, '2015-01-15', '02:05:00'),
	(3, 7, 2, '2015-01-15', '02:23:00'),
	(3, 7, 2, '2015-01-15', '01:47:00'),
	(3, 7, 2, '2015-01-15', '02:38:00'),
	(3, 7, 2, '2015-01-15', '01:34:00'),
	(3, 7, 2, '2015-01-15', '03:11:00'),
	(3, 7, 2, '2015-01-15', '02:36:00'),
	(3, 7, 2, '2015-01-15', '01:59:00'),
	(3, 7, 2, '2015-01-15', '02:57:00'),
	(3, 7, 2, '2015-01-15', '02:36:00'),
	(3, 7, 2, '2015-01-15', '02:39:00'),
	(3, 7, 2, '2015-01-15', '01:35:00'),
	(3, 7, 2, '2015-01-15', '03:12:00'),
	(3, 7, 2, '2015-01-15', '02:38:00'),
	(3, 7, 2, '2015-01-15', '02:03:00'),
	(3, 7, 2, '2015-01-15', '03:15:00'),
	(3, 7, 2, '2015-01-15', '03:50:00'),
	(3, 7, 2, '2015-01-15', '03:10:00'),
	(3, 7, 2, '2015-01-15', '02:52:00'),
	(3, 7, 2, '2015-01-15', '03:19:00'),
	(3, 7, 2, '2015-01-15', '01:45:00'),
	(3, 7, 2, '2015-01-15', '02:02:00'),
	(3, 7, 2, '2015-01-15', '03:27:00'),
	(3, 7, 2, '2015-01-15', '02:31:00'),
	(3, 7, 2, '2015-01-15', '03:08:00'),
	(3, 7, 2, '2015-01-15', '01:52:00'),
	(3, 7, 2, '2015-01-15', '03:11:00'),
	(3, 7, 2, '2015-01-15', '01:40:00'),
	(3, 7, 2, '2015-01-15', '02:03:00'),
	(3, 8, 3, '2015-01-15', '01:51:00'),
	(3, 8, 3, '2015-01-15', '03:28:00'),
	(3, 8, 3, '2015-01-15', '02:56:00'),
	(3, 8, 3, '2015-01-15', '02:44:00'),
	(3, 8, 3, '2015-01-15', '03:23:00'),
	(3, 8, 3, '2015-01-15', '02:16:00'),
	(3, 8, 3, '2015-01-15', '02:12:00'),
	(3, 8, 3, '2015-01-15', '02:43:00'),
	(3, 8, 3, '2015-01-15', '03:02:00'),
	(3, 8, 3, '2015-01-15', '03:04:00'),
	(3, 8, 3, '2015-01-15', '02:17:00'),
	(3, 8, 3, '2015-01-15', '03:10:00'),
	(3, 8, 3, '2015-01-15', '02:33:00'),
	(3, 8, 3, '2015-01-15', '01:45:00'),
	(3, 8, 3, '2015-01-15', '02:04:00'),
	(3, 8, 3, '2015-01-15', '03:36:00'),
	(3, 8, 3, '2015-01-15', '02:57:00'),
	(3, 8, 3, '2015-01-15', '02:25:00'),
	(3, 8, 3, '2015-01-15', '01:43:00'),
	(3, 8, 3, '2015-01-15', '02:20:00'),
	(3, 8, 3, '2015-01-15', '02:35:00'),
	(3, 8, 3, '2015-01-15', '01:57:00'),
	(3, 8, 3, '2015-01-15', '02:59:00'),
	(3, 8, 3, '2015-01-15', '02:38:00'),
	(3, 8, 3, '2015-01-15', '02:45:00'),
	(3, 8, 3, '2015-01-15', '01:54:00'),
	(3, 8, 3, '2015-01-15', '02:12:00'),
	(3, 8, 3, '2015-01-15', '03:47:00'),
	(3, 8, 3, '2015-01-15', '03:26:00'),
	(3, 8, 3, '2015-01-15', '01:53:00'),
	(3, 8, 3, '2015-01-15', '02:33:00'),
	(3, 8, 3, '2015-01-15', '03:10:00'),
	(3, 8, 3, '2015-01-15', '01:45:00'),
	(3, 8, 3, '2015-01-15', '02:40:00'),
	(3, 8, 3, '2015-01-15', '01:38:00'),
	(3, 8, 3, '2015-01-15', '03:39:00'),
	(3, 8, 3, '2015-01-15', '01:59:00'),
	(3, 8, 3, '2015-01-15', '02:23:00'),
	(3, 8, 3, '2015-01-15', '02:00:00'),
	(3, 8, 3, '2015-01-15', '03:49:00'),
	(3, 8, 3, '2015-01-15', '01:45:00'),
	(3, 8, 3, '2015-01-15', '03:12:00'),
	(3, 8, 3, '2015-01-15', '01:50:00'),
	(3, 8, 3, '2015-01-15', '03:02:00'),
	(3, 8, 3, '2015-01-15', '03:15:00'),
	(3, 8, 3, '2015-01-15', '03:11:00'),
	(3, 8, 3, '2015-01-15', '02:11:00'),
	(3, 8, 3, '2015-01-15', '02:20:00'),
	(3, 8, 3, '2015-01-15', '03:39:00'),
	(3, 8, 3, '2015-01-15', '02:20:00'),
	(3, 8, 3, '2015-01-15', '01:41:00'),
	(3, 8, 3, '2015-01-15', '02:23:00'),
	(3, 8, 3, '2015-01-15', '02:54:00'),
	(3, 8, 3, '2015-01-15', '03:26:00'),
	(3, 8, 3, '2015-01-15', '02:00:00'),
	(3, 8, 3, '2015-01-15', '03:09:00'),
	(3, 8, 3, '2015-01-15', '03:21:00'),
	(3, 8, 3, '2015-01-15', '03:21:00'),
	(3, 8, 3, '2015-01-15', '02:45:00'),
	(3, 8, 3, '2015-01-15', '02:12:00'),
	(3, 9, 4, '2015-01-15', '03:02:00'),
	(3, 9, 4, '2015-01-15', '02:40:00'),
	(3, 9, 4, '2015-01-15', '02:45:00'),
	(3, 9, 4, '2015-01-15', '01:52:00'),
	(3, 9, 4, '2015-01-15', '02:00:00'),
	(3, 9, 4, '2015-01-15', '02:56:00'),
	(3, 9, 4, '2015-01-15', '02:18:00'),
	(3, 9, 4, '2015-01-15', '03:37:00'),
	(3, 9, 4, '2015-01-15', '02:28:00'),
	(3, 9, 4, '2015-01-15', '02:26:00'),
	(3, 9, 4, '2015-01-15', '03:15:00'),
	(3, 9, 4, '2015-01-15', '02:40:00'),
	(3, 9, 4, '2015-01-15', '02:03:00'),
	(3, 9, 4, '2015-01-15', '03:10:00'),
	(3, 9, 4, '2015-01-15', '03:24:00'),
	(3, 9, 4, '2015-01-15', '03:34:00'),
	(3, 9, 4, '2015-01-15', '03:42:00'),
	(3, 9, 4, '2015-01-15', '03:54:00'),
	(3, 9, 4, '2015-01-15', '02:06:00'),
	(3, 9, 4, '2015-01-15', '02:07:00'),
	(3, 9, 4, '2015-01-15', '02:47:00'),
	(3, 9, 4, '2015-01-15', '03:41:00'),
	(3, 9, 4, '2015-01-15', '03:45:00'),
	(3, 9, 4, '2015-01-15', '03:48:00'),
	(3, 9, 4, '2015-01-15', '03:49:00'),
	(3, 9, 4, '2015-01-15', '03:49:00'),
	(3, 9, 4, '2015-01-15', '03:42:00'),
	(3, 9, 4, '2015-01-15', '03:07:00'),
	(3, 9, 4, '2015-01-15', '02:59:00'),
	(3, 9, 4, '2015-01-15', '01:39:00'),
	(3, 9, 4, '2015-01-15', '02:38:00'),
	(3, 9, 4, '2015-01-15', '01:56:00'),
	(3, 9, 4, '2015-01-15', '02:39:00'),
	(3, 9, 4, '2015-01-15', '03:35:00'),
	(3, 9, 4, '2015-01-15', '03:39:00'),
	(3, 9, 4, '2015-01-15', '03:33:00'),
	(3, 9, 4, '2015-01-15', '02:54:00'),
	(3, 9, 4, '2015-01-15', '02:22:00'),
	(3, 9, 4, '2015-01-15', '01:37:00'),
	(3, 9, 4, '2015-01-15', '01:53:00'),
	(3, 9, 4, '2015-01-15', '03:08:00'),
	(3, 9, 4, '2015-01-15', '03:39:00'),
	(3, 9, 4, '2015-01-15', '02:34:00'),
	(3, 9, 4, '2015-01-15', '02:46:00'),
	(3, 9, 4, '2015-01-15', '02:13:00'),
	(3, 9, 4, '2015-01-15', '03:44:00'),
	(3, 9, 4, '2015-01-15', '03:18:00'),
	(3, 9, 4, '2015-01-15', '03:45:00'),
	(3, 9, 4, '2015-01-15', '02:34:00'),
	(3, 9, 4, '2015-01-15', '02:30:00'),
	(3, 9, 4, '2015-01-15', '03:17:00'),
	(3, 9, 4, '2015-01-15', '02:37:00'),
	(3, 9, 4, '2015-01-15', '01:42:00'),
	(3, 9, 4, '2015-01-15', '01:38:00'),
	(3, 9, 4, '2015-01-15', '01:33:00'),
	(3, 9, 4, '2015-01-15', '03:45:00'),
	(3, 9, 4, '2015-01-15', '02:56:00'),
	(3, 9, 4, '2015-01-15', '01:55:00'),
	(3, 9, 4, '2015-01-15', '01:42:00'),
	(3, 9, 4, '2015-01-15', '03:41:00'),
	(3, 10, 5, '2015-01-15', '02:48:00'),
	(3, 10, 5, '2015-01-15', '02:24:00'),
	(3, 10, 5, '2015-01-15', '02:05:00'),
	(3, 10, 5, '2015-01-15', '01:46:00'),
	(3, 10, 5, '2015-01-15', '03:04:00'),
	(3, 10, 5, '2015-01-15', '02:32:00'),
	(3, 10, 5, '2015-01-15', '01:58:00'),
	(3, 10, 5, '2015-01-15', '02:45:00'),
	(3, 10, 5, '2015-01-15', '02:21:00'),
	(3, 10, 5, '2015-01-15', '02:03:00'),
	(3, 10, 5, '2015-01-15', '01:39:00'),
	(3, 10, 5, '2015-01-15', '02:39:00'),
	(3, 10, 5, '2015-01-15', '02:50:00'),
	(3, 10, 5, '2015-01-15', '02:40:00'),
	(3, 10, 5, '2015-01-15', '03:22:00'),
	(3, 10, 5, '2015-01-15', '03:22:00'),
	(3, 10, 5, '2015-01-15', '03:15:00'),
	(3, 10, 5, '2015-01-15', '02:37:00'),
	(3, 10, 5, '2015-01-15', '01:52:00'),
	(3, 10, 5, '2015-01-15', '02:00:00'),
	(3, 10, 5, '2015-01-15', '02:53:00'),
	(3, 10, 5, '2015-01-15', '02:57:00'),
	(3, 10, 5, '2015-01-15', '02:38:00'),
	(3, 10, 5, '2015-01-15', '02:47:00'),
	(3, 10, 5, '2015-01-15', '02:32:00'),
	(3, 10, 5, '2015-01-15', '02:48:00'),
	(3, 10, 5, '2015-01-15', '02:55:00'),
	(3, 10, 5, '2015-01-15', '02:43:00'),
	(3, 10, 5, '2015-01-15', '03:22:00'),
	(3, 10, 5, '2015-01-15', '03:09:00'),
	(3, 10, 5, '2015-01-15', '02:11:00'),
	(3, 10, 5, '2015-01-15', '01:57:00'),
	(3, 10, 5, '2015-01-15', '01:44:00'),
	(3, 10, 5, '2015-01-15', '03:18:00'),
	(3, 10, 5, '2015-01-15', '01:49:00'),
	(3, 10, 5, '2015-01-15', '01:41:00'),
	(3, 10, 5, '2015-01-15', '03:29:00'),
	(3, 10, 5, '2015-01-15', '02:52:00'),
	(3, 10, 5, '2015-01-15', '02:26:00'),
	(3, 10, 5, '2015-01-15', '02:02:00'),
	(3, 10, 5, '2015-01-15', '03:24:00'),
	(3, 10, 5, '2015-01-15', '03:26:00'),
	(3, 10, 5, '2015-01-15', '03:27:00'),
	(3, 10, 5, '2015-01-15', '03:28:00'),
	(3, 10, 5, '2015-01-15', '01:30:00'),
	(3, 10, 5, '2015-01-15', '01:37:00'),
	(3, 10, 5, '2015-01-15', '02:04:00'),
	(3, 10, 5, '2015-01-15', '01:59:00'),
	(3, 10, 5, '2015-01-15', '02:14:00'),
	(3, 10, 5, '2015-01-15', '01:42:00'),
	(3, 10, 5, '2015-01-15', '02:19:00'),
	(3, 10, 5, '2015-01-15', '03:00:00'),
	(3, 10, 5, '2015-01-15', '02:35:00'),
	(3, 10, 5, '2015-01-15', '02:23:00'),
	(3, 10, 5, '2015-01-15', '02:43:00'),
	(3, 10, 5, '2015-01-15', '02:56:00'),
	(3, 10, 5, '2015-01-15', '03:02:00'),
	(3, 10, 5, '2015-01-15', '02:51:00'),
	(3, 10, 5, '2015-01-15', '01:40:00'),
	(3, 10, 5, '2015-01-15', '02:16:00'),
	(4, 6, 1, '2015-02-01', '02:08:00'),
	(4, 6, 1, '2015-02-01', '02:18:00'),
	(4, 6, 1, '2015-02-01', '03:34:00'),
	(4, 6, 1, '2015-02-01', '02:34:00'),
	(4, 6, 1, '2015-02-01', '02:58:00'),
	(4, 6, 1, '2015-02-01', '03:21:00'),
	(4, 6, 1, '2015-02-01', '01:46:00'),
	(4, 6, 1, '2015-02-01', '01:54:00'),
	(4, 6, 1, '2015-02-01', '02:40:00'),
	(4, 6, 1, '2015-02-01', '01:36:00'),
	(4, 6, 1, '2015-02-01', '03:03:00'),
	(4, 6, 1, '2015-02-01', '02:08:00'),
	(4, 6, 1, '2015-02-01', '02:16:00'),
	(4, 6, 1, '2015-02-01', '03:29:00'),
	(4, 6, 1, '2015-02-01', '02:16:00'),
	(4, 6, 1, '2015-02-01', '01:38:00'),
	(4, 6, 1, '2015-02-01', '02:12:00'),
	(4, 6, 1, '2015-02-01', '02:18:00'),
	(4, 6, 1, '2015-02-01', '03:26:00'),
	(4, 6, 1, '2015-02-01', '01:57:00'),
	(4, 6, 1, '2015-02-01', '02:30:00'),
	(4, 6, 1, '2015-02-01', '02:52:00'),
	(4, 6, 1, '2015-02-01', '03:06:00'),
	(4, 6, 1, '2015-02-01', '03:05:00'),
	(4, 6, 1, '2015-02-01', '02:21:00'),
	(4, 6, 1, '2015-02-01', '03:19:00'),
	(4, 6, 1, '2015-02-01', '03:27:00'),
	(4, 6, 1, '2015-02-01', '03:30:00'),
	(4, 6, 1, '2015-02-01', '03:26:00'),
	(4, 6, 1, '2015-02-01', '02:51:00'),
	(4, 6, 1, '2015-02-01', '02:27:00'),
	(4, 6, 1, '2015-02-01', '02:11:00'),
	(4, 6, 1, '2015-02-01', '02:08:00'),
	(4, 6, 1, '2015-02-01', '02:34:00'),
	(4, 6, 1, '2015-02-01', '02:43:00'),
	(4, 6, 1, '2015-02-01', '02:05:00'),
	(4, 6, 1, '2015-02-01', '03:02:00'),
	(4, 6, 1, '2015-02-01', '02:53:00'),
	(4, 6, 1, '2015-02-01', '01:34:00'),
	(4, 6, 1, '2015-02-01', '02:14:00'),
	(4, 6, 1, '2015-02-01', '02:40:00'),
	(4, 6, 1, '2015-02-01', '02:54:00'),
	(4, 6, 1, '2015-02-01', '02:41:00'),
	(4, 6, 1, '2015-02-01', '03:14:00'),
	(4, 6, 1, '2015-02-01', '02:02:00'),
	(4, 6, 1, '2015-02-01', '03:34:00'),
	(4, 6, 1, '2015-02-01', '03:23:00'),
	(4, 6, 1, '2015-02-01', '02:28:00'),
	(4, 6, 1, '2015-02-01', '03:00:00'),
	(4, 6, 1, '2015-02-01', '03:46:00'),
	(4, 6, 1, '2015-02-01', '01:33:00'),
	(4, 6, 1, '2015-02-01', '01:46:00'),
	(4, 6, 1, '2015-02-01', '02:44:00'),
	(4, 6, 1, '2015-02-01', '02:18:00'),
	(4, 6, 1, '2015-02-01', '01:47:00'),
	(4, 6, 1, '2015-02-01', '02:51:00'),
	(4, 6, 1, '2015-02-01', '02:49:00'),
	(4, 6, 1, '2015-02-01', '01:46:00'),
	(4, 6, 1, '2015-02-01', '03:29:00'),
	(4, 6, 1, '2015-02-01', '03:46:00'),
	(4, 7, 2, '2015-02-01', '03:15:00'),
	(4, 7, 2, '2015-02-01', '01:49:00'),
	(4, 7, 2, '2015-02-01', '01:59:00'),
	(4, 7, 2, '2015-02-01', '02:59:00'),
	(4, 7, 2, '2015-02-01', '03:17:00'),
	(4, 7, 2, '2015-02-01', '01:54:00'),
	(4, 7, 2, '2015-02-01', '02:15:00'),
	(4, 7, 2, '2015-02-01', '02:01:00'),
	(4, 7, 2, '2015-02-01', '01:52:00'),
	(4, 7, 2, '2015-02-01', '01:45:00'),
	(4, 7, 2, '2015-02-01', '01:38:00'),
	(4, 7, 2, '2015-02-01', '03:33:00'),
	(4, 7, 2, '2015-02-01', '03:03:00'),
	(4, 7, 2, '2015-02-01', '03:05:00'),
	(4, 7, 2, '2015-02-01', '02:45:00'),
	(4, 7, 2, '2015-02-01', '03:01:00'),
	(4, 7, 2, '2015-02-01', '03:16:00'),
	(4, 7, 2, '2015-02-01', '01:38:00'),
	(4, 7, 2, '2015-02-01', '03:06:00'),
	(4, 7, 2, '2015-02-01', '02:56:00'),
	(4, 7, 2, '2015-02-01', '01:47:00'),
	(4, 7, 2, '2015-02-01', '02:47:00'),
	(4, 7, 2, '2015-02-01', '02:54:00'),
	(4, 7, 2, '2015-02-01', '02:37:00'),
	(4, 7, 2, '2015-02-01', '02:53:00'),
	(4, 7, 2, '2015-02-01', '03:02:00'),
	(4, 7, 2, '2015-02-01', '02:58:00'),
	(4, 7, 2, '2015-02-01', '02:10:00'),
	(4, 7, 2, '2015-02-01', '02:28:00'),
	(4, 7, 2, '2015-02-01', '02:18:00'),
	(4, 7, 2, '2015-02-01', '02:37:00'),
	(4, 7, 2, '2015-02-01', '02:38:00'),
	(4, 7, 2, '2015-02-01', '01:46:00'),
	(4, 7, 2, '2015-02-01', '01:30:00'),
	(4, 7, 2, '2015-02-01', '02:45:00'),
	(4, 7, 2, '2015-02-01', '01:33:00'),
	(4, 7, 2, '2015-02-01', '02:08:00'),
	(4, 7, 2, '2015-02-01', '02:30:00'),
	(4, 7, 2, '2015-02-01', '02:30:00'),
	(4, 7, 2, '2015-02-01', '03:31:00'),
	(4, 7, 2, '2015-02-01', '02:23:00'),
	(4, 7, 2, '2015-02-01', '01:58:00'),
	(4, 7, 2, '2015-02-01', '03:16:00'),
	(4, 7, 2, '2015-02-01', '02:44:00'),
	(4, 7, 2, '2015-02-01', '02:24:00'),
	(4, 7, 2, '2015-02-01', '02:18:00'),
	(4, 7, 2, '2015-02-01', '02:48:00'),
	(4, 7, 2, '2015-02-01', '03:32:00'),
	(4, 7, 2, '2015-02-01', '01:37:00'),
	(4, 7, 2, '2015-02-01', '02:10:00'),
	(4, 7, 2, '2015-02-01', '02:25:00'),
	(4, 7, 2, '2015-02-01', '02:03:00'),
	(4, 7, 2, '2015-02-01', '01:30:00'),
	(4, 7, 2, '2015-02-01', '01:54:00'),
	(4, 7, 2, '2015-02-01', '03:31:00'),
	(4, 7, 2, '2015-02-01', '02:08:00'),
	(4, 7, 2, '2015-02-01', '02:47:00'),
	(4, 7, 2, '2015-02-01', '01:52:00'),
	(4, 7, 2, '2015-02-01', '01:33:00'),
	(4, 7, 2, '2015-02-01', '02:44:00'),
	(4, 8, 3, '2015-02-01', '03:18:00'),
	(4, 8, 3, '2015-02-01', '01:30:00'),
	(4, 8, 3, '2015-02-01', '03:22:00'),
	(4, 8, 3, '2015-02-01', '03:32:00'),
	(4, 8, 3, '2015-02-01', '03:42:00'),
	(4, 8, 3, '2015-02-01', '03:55:00'),
	(4, 8, 3, '2015-02-01', '02:10:00'),
	(4, 8, 3, '2015-02-01', '02:25:00'),
	(4, 8, 3, '2015-02-01', '01:42:00'),
	(4, 8, 3, '2015-02-01', '02:10:00'),
	(4, 8, 3, '2015-02-01', '01:47:00'),
	(4, 8, 3, '2015-02-01', '03:22:00'),
	(4, 8, 3, '2015-02-01', '02:41:00'),
	(4, 8, 3, '2015-02-01', '01:50:00'),
	(4, 8, 3, '2015-02-01', '02:04:00'),
	(4, 8, 3, '2015-02-01', '03:22:00'),
	(4, 8, 3, '2015-02-01', '01:49:00'),
	(4, 8, 3, '2015-02-01', '02:23:00'),
	(4, 8, 3, '2015-02-01', '02:31:00'),
	(4, 8, 3, '2015-02-01', '01:31:00'),
	(4, 8, 3, '2015-02-01', '03:25:00'),
	(4, 8, 3, '2015-02-01', '03:46:00'),
	(4, 8, 3, '2015-02-01', '02:11:00'),
	(4, 8, 3, '2015-02-01', '02:59:00'),
	(4, 8, 3, '2015-02-01', '02:01:00'),
	(4, 8, 3, '2015-02-01', '02:03:00'),
	(4, 8, 3, '2015-02-01', '02:42:00'),
	(4, 8, 3, '2015-02-01', '03:28:00'),
	(4, 8, 3, '2015-02-01', '02:52:00'),
	(4, 8, 3, '2015-02-01', '02:25:00'),
	(4, 8, 3, '2015-02-01', '02:01:00'),
	(4, 8, 3, '2015-02-01', '03:44:00'),
	(4, 8, 3, '2015-02-01', '03:53:00'),
	(4, 8, 3, '2015-02-01', '01:49:00'),
	(4, 8, 3, '2015-02-01', '03:16:00'),
	(4, 8, 3, '2015-02-01', '02:03:00'),
	(4, 8, 3, '2015-02-01', '03:51:00'),
	(4, 8, 3, '2015-02-01', '01:51:00'),
	(4, 8, 3, '2015-02-01', '03:29:00'),
	(4, 8, 3, '2015-02-01', '03:08:00'),
	(4, 8, 3, '2015-02-01', '03:41:00'),
	(4, 8, 3, '2015-02-01', '02:42:00'),
	(4, 8, 3, '2015-02-01', '03:22:00'),
	(4, 8, 3, '2015-02-01', '02:23:00'),
	(4, 8, 3, '2015-02-01', '02:45:00'),
	(4, 8, 3, '2015-02-01', '02:41:00'),
	(4, 8, 3, '2015-02-01', '03:42:00'),
	(4, 8, 3, '2015-02-01', '01:40:00'),
	(4, 8, 3, '2015-02-01', '03:02:00'),
	(4, 8, 3, '2015-02-01', '03:46:00'),
	(4, 8, 3, '2015-02-01', '03:26:00'),
	(4, 8, 3, '2015-02-01', '01:54:00'),
	(4, 8, 3, '2015-02-01', '02:33:00'),
	(4, 8, 3, '2015-02-01', '03:10:00'),
	(4, 8, 3, '2015-02-01', '01:50:00'),
	(4, 8, 3, '2015-02-01', '03:01:00'),
	(4, 8, 3, '2015-02-01', '03:15:00'),
	(4, 8, 3, '2015-02-01', '03:16:00'),
	(4, 8, 3, '2015-02-01', '02:40:00'),
	(4, 8, 3, '2015-02-01', '02:02:00'),
	(4, 9, 4, '2015-02-01', '02:54:00'),
	(4, 9, 4, '2015-02-01', '01:47:00'),
	(4, 9, 4, '2015-02-01', '03:14:00'),
	(4, 9, 4, '2015-02-01', '02:34:00'),
	(4, 9, 4, '2015-02-01', '01:40:00'),
	(4, 9, 4, '2015-02-01', '03:38:00'),
	(4, 9, 4, '2015-02-01', '02:38:00'),
	(4, 9, 4, '2015-02-01', '03:01:00'),
	(4, 9, 4, '2015-02-01', '03:26:00'),
	(4, 9, 4, '2015-02-01', '02:07:00'),
	(4, 9, 4, '2015-02-01', '03:17:00'),
	(4, 9, 4, '2015-02-01', '01:46:00'),
	(4, 9, 4, '2015-02-01', '02:01:00'),
	(4, 9, 4, '2015-02-01', '03:20:00'),
	(4, 9, 4, '2015-02-01', '02:20:00'),
	(4, 9, 4, '2015-02-01', '02:23:00'),
	(4, 9, 4, '2015-02-01', '03:29:00'),
	(4, 9, 4, '2015-02-01', '01:56:00'),
	(4, 9, 4, '2015-02-01', '02:16:00'),
	(4, 9, 4, '2015-02-01', '01:48:00'),
	(4, 9, 4, '2015-02-01', '02:57:00'),
	(4, 9, 4, '2015-02-01', '03:18:00'),
	(4, 9, 4, '2015-02-01', '01:38:00'),
	(4, 9, 4, '2015-02-01', '03:37:00'),
	(4, 9, 4, '2015-02-01', '02:36:00'),
	(4, 9, 4, '2015-02-01', '02:56:00'),
	(4, 9, 4, '2015-02-01', '03:07:00'),
	(4, 9, 4, '2015-02-01', '03:02:00'),
	(4, 9, 4, '2015-02-01', '02:01:00'),
	(4, 9, 4, '2015-02-01', '01:48:00'),
	(4, 9, 4, '2015-02-01', '03:42:00'),
	(4, 9, 4, '2015-02-01', '02:34:00'),
	(4, 9, 4, '2015-02-01', '02:29:00'),
	(4, 9, 4, '2015-02-01', '03:15:00'),
	(4, 9, 4, '2015-02-01', '02:47:00'),
	(4, 9, 4, '2015-02-01', '02:40:00'),
	(4, 9, 4, '2015-02-01', '03:30:00'),
	(4, 9, 4, '2015-02-01', '03:29:00'),
	(4, 9, 4, '2015-02-01', '03:07:00'),
	(4, 9, 4, '2015-02-01', '03:41:00'),
	(4, 9, 4, '2015-02-01', '03:01:00'),
	(4, 9, 4, '2015-02-01', '02:33:00'),
	(4, 9, 4, '2015-02-01', '02:11:00'),
	(4, 9, 4, '2015-02-01', '01:47:00'),
	(4, 9, 4, '2015-02-01', '03:07:00'),
	(4, 9, 4, '2015-02-01', '01:57:00'),
	(4, 9, 4, '2015-02-01', '03:25:00'),
	(4, 9, 4, '2015-02-01', '02:59:00'),
	(4, 9, 4, '2015-02-01', '03:08:00'),
	(4, 9, 4, '2015-02-01', '02:57:00'),
	(4, 9, 4, '2015-02-01', '01:37:00'),
	(4, 9, 4, '2015-02-01', '02:18:00'),
	(4, 9, 4, '2015-02-01', '02:51:00'),
	(4, 9, 4, '2015-02-01', '03:38:00'),
	(4, 9, 4, '2015-02-01', '03:35:00'),
	(4, 9, 4, '2015-02-01', '03:15:00'),
	(4, 9, 4, '2015-02-01', '01:45:00'),
	(4, 9, 4, '2015-02-01', '02:02:00'),
	(4, 9, 4, '2015-02-01', '03:25:00'),
	(4, 9, 4, '2015-02-01', '02:43:00'),
	(4, 10, 5, '2015-02-01', '01:39:00'),
	(4, 10, 5, '2015-02-01', '01:31:00'),
	(4, 10, 5, '2015-02-01', '03:02:00'),
	(4, 10, 5, '2015-02-01', '03:21:00'),
	(4, 10, 5, '2015-02-01', '02:19:00'),
	(4, 10, 5, '2015-02-01', '01:57:00'),
	(4, 10, 5, '2015-02-01', '03:14:00'),
	(4, 10, 5, '2015-02-01', '03:06:00'),
	(4, 10, 5, '2015-02-01', '02:24:00'),
	(4, 10, 5, '2015-02-01', '03:07:00'),
	(4, 10, 5, '2015-02-01', '03:03:00'),
	(4, 10, 5, '2015-02-01', '02:29:00'),
	(4, 10, 5, '2015-02-01', '01:48:00'),
	(4, 10, 5, '2015-02-01', '01:58:00'),
	(4, 10, 5, '2015-02-01', '02:58:00'),
	(4, 10, 5, '2015-02-01', '01:41:00'),
	(4, 10, 5, '2015-02-01', '01:49:00'),
	(4, 10, 5, '2015-02-01', '02:36:00'),
	(4, 10, 5, '2015-02-01', '02:10:00'),
	(4, 10, 5, '2015-02-01', '01:35:00'),
	(4, 10, 5, '2015-02-01', '01:48:00'),
	(4, 10, 5, '2015-02-01', '02:46:00'),
	(4, 10, 5, '2015-02-01', '03:06:00'),
	(4, 10, 5, '2015-02-01', '01:54:00'),
	(4, 10, 5, '2015-02-01', '02:32:00'),
	(4, 10, 5, '2015-02-01', '01:39:00'),
	(4, 10, 5, '2015-02-01', '02:58:00'),
	(4, 10, 5, '2015-02-01', '02:40:00'),
	(4, 10, 5, '2015-02-01', '02:56:00'),
	(4, 10, 5, '2015-02-01', '03:17:00'),
	(4, 10, 5, '2015-02-01', '02:18:00'),
	(4, 10, 5, '2015-02-01', '02:04:00'),
	(4, 10, 5, '2015-02-01', '01:57:00'),
	(4, 10, 5, '2015-02-01', '02:05:00'),
	(4, 10, 5, '2015-02-01', '03:02:00'),
	(4, 10, 5, '2015-02-01', '01:42:00'),
	(4, 10, 5, '2015-02-01', '01:42:00'),
	(4, 10, 5, '2015-02-01', '01:56:00'),
	(4, 10, 5, '2015-02-01', '03:04:00'),
	(4, 10, 5, '2015-02-01', '02:19:00'),
	(4, 10, 5, '2015-02-01', '02:48:00'),
	(4, 10, 5, '2015-02-01', '01:44:00'),
	(4, 10, 5, '2015-02-01', '02:37:00'),
	(4, 10, 5, '2015-02-01', '02:35:00'),
	(4, 10, 5, '2015-02-01', '01:36:00'),
	(4, 10, 5, '2015-02-01', '02:36:00'),
	(4, 10, 5, '2015-02-01', '02:54:00'),
	(4, 10, 5, '2015-02-01', '03:19:00'),
	(4, 10, 5, '2015-02-01', '02:30:00'),
	(4, 10, 5, '2015-02-01', '02:59:00'),
	(4, 10, 5, '2015-02-01', '02:08:00'),
	(4, 10, 5, '2015-02-01', '02:06:00'),
	(4, 10, 5, '2015-02-01', '02:39:00'),
	(4, 10, 5, '2015-02-01', '01:35:00'),
	(4, 10, 5, '2015-02-01', '02:18:00'),
	(4, 10, 5, '2015-02-01', '03:22:00'),
	(4, 10, 5, '2015-02-01', '02:42:00'),
	(4, 10, 5, '2015-02-01', '01:54:00'),
	(4, 10, 5, '2015-02-01', '01:51:00'),
	(4, 10, 5, '2015-02-01', '02:04:00'),
	(5, 6, 1, '2015-02-15', '03:28:00'),
	(5, 6, 1, '2015-02-15', '01:57:00'),
	(5, 6, 1, '2015-02-15', '02:48:00'),
	(5, 6, 1, '2015-02-15', '01:46:00'),
	(5, 6, 1, '2015-02-15', '03:50:00'),
	(5, 6, 1, '2015-02-15', '02:35:00'),
	(5, 6, 1, '2015-02-15', '02:22:00'),
	(5, 6, 1, '2015-02-15', '02:37:00'),
	(5, 6, 1, '2015-02-15', '02:00:00'),
	(5, 6, 1, '2015-02-15', '03:08:00'),
	(5, 6, 1, '2015-02-15', '03:17:00'),
	(5, 6, 1, '2015-02-15', '03:04:00'),
	(5, 6, 1, '2015-02-15', '01:31:00'),
	(5, 6, 1, '2015-02-15', '01:48:00'),
	(5, 6, 1, '2015-02-15', '03:00:00'),
	(5, 6, 1, '2015-02-15', '03:09:00'),
	(5, 6, 1, '2015-02-15', '02:52:00'),
	(5, 6, 1, '2015-02-15', '03:20:00'),
	(5, 6, 1, '2015-02-15', '01:43:00'),
	(5, 6, 1, '2015-02-15', '01:57:00'),
	(5, 6, 1, '2015-02-15', '03:10:00'),
	(5, 6, 1, '2015-02-15', '03:33:00'),
	(5, 6, 1, '2015-02-15', '01:53:00'),
	(5, 6, 1, '2015-02-15', '02:09:00'),
	(5, 6, 1, '2015-02-15', '03:36:00'),
	(5, 6, 1, '2015-02-15', '02:44:00'),
	(5, 6, 1, '2015-02-15', '03:51:00'),
	(5, 6, 1, '2015-02-15', '02:11:00'),
	(5, 6, 1, '2015-02-15', '02:45:00'),
	(5, 6, 1, '2015-02-15', '03:17:00'),
	(5, 6, 1, '2015-02-15', '01:45:00'),
	(5, 6, 1, '2015-02-15', '02:21:00'),
	(5, 6, 1, '2015-02-15', '02:30:00'),
	(5, 6, 1, '2015-02-15', '01:33:00'),
	(5, 6, 1, '2015-02-15', '03:40:00'),
	(5, 6, 1, '2015-02-15', '02:22:00'),
	(5, 6, 1, '2015-02-15', '01:48:00'),
	(5, 6, 1, '2015-02-15', '02:50:00'),
	(5, 6, 1, '2015-02-15', '02:24:00'),
	(5, 6, 1, '2015-02-15', '02:02:00'),
	(5, 6, 1, '2015-02-15', '03:55:00'),
	(5, 6, 1, '2015-02-15', '02:10:00'),
	(5, 6, 1, '2015-02-15', '02:32:00'),
	(5, 6, 1, '2015-02-15', '02:12:00'),
	(5, 6, 1, '2015-02-15', '01:56:00'),
	(5, 6, 1, '2015-02-15', '01:32:00'),
	(5, 6, 1, '2015-02-15', '02:51:00'),
	(5, 6, 1, '2015-02-15', '03:16:00'),
	(5, 6, 1, '2015-02-15', '03:49:00'),
	(5, 6, 1, '2015-02-15', '02:55:00'),
	(5, 6, 1, '2015-02-15', '01:37:00'),
	(5, 6, 1, '2015-02-15', '02:46:00'),
	(5, 6, 1, '2015-02-15', '02:35:00'),
	(5, 6, 1, '2015-02-15', '03:10:00'),
	(5, 6, 1, '2015-02-15', '01:38:00'),
	(5, 6, 1, '2015-02-15', '02:04:00'),
	(5, 6, 1, '2015-02-15', '01:30:00'),
	(5, 6, 1, '2015-02-15', '02:17:00'),
	(5, 6, 1, '2015-02-15', '02:58:00'),
	(5, 6, 1, '2015-02-15', '01:33:00'),
	(5, 7, 2, '2015-02-15', '02:43:00'),
	(5, 7, 2, '2015-02-15', '03:30:00'),
	(5, 7, 2, '2015-02-15', '01:43:00'),
	(5, 7, 2, '2015-02-15', '02:45:00'),
	(5, 7, 2, '2015-02-15', '03:01:00'),
	(5, 7, 2, '2015-02-15', '03:19:00'),
	(5, 7, 2, '2015-02-15', '01:53:00'),
	(5, 7, 2, '2015-02-15', '02:07:00'),
	(5, 7, 2, '2015-02-15', '03:27:00'),
	(5, 7, 2, '2015-02-15', '03:13:00'),
	(5, 7, 2, '2015-02-15', '02:14:00'),
	(5, 7, 2, '2015-02-15', '02:01:00'),
	(5, 7, 2, '2015-02-15', '01:57:00'),
	(5, 7, 2, '2015-02-15', '02:12:00'),
	(5, 7, 2, '2015-02-15', '01:36:00'),
	(5, 7, 2, '2015-02-15', '01:58:00'),
	(5, 7, 2, '2015-02-15', '01:30:00'),
	(5, 7, 2, '2015-02-15', '02:09:00'),
	(5, 7, 2, '2015-02-15', '02:43:00'),
	(5, 7, 2, '2015-02-15', '01:31:00'),
	(5, 7, 2, '2015-02-15', '02:05:00'),
	(5, 7, 2, '2015-02-15', '02:20:00'),
	(5, 7, 2, '2015-02-15', '01:50:00'),
	(5, 7, 2, '2015-02-15', '02:45:00'),
	(5, 7, 2, '2015-02-15', '02:41:00'),
	(5, 7, 2, '2015-02-15', '01:37:00'),
	(5, 7, 2, '2015-02-15', '02:38:00'),
	(5, 7, 2, '2015-02-15', '02:42:00'),
	(5, 7, 2, '2015-02-15', '02:05:00'),
	(5, 7, 2, '2015-02-15', '02:51:00'),
	(5, 7, 2, '2015-02-15', '02:27:00'),
	(5, 7, 2, '2015-02-15', '02:09:00'),
	(5, 7, 2, '2015-02-15', '01:58:00'),
	(5, 7, 2, '2015-02-15', '01:53:00'),
	(5, 7, 2, '2015-02-15', '01:59:00'),
	(5, 7, 2, '2015-02-15', '02:48:00'),
	(5, 7, 2, '2015-02-15', '02:27:00'),
	(5, 7, 2, '2015-02-15', '02:21:00'),
	(5, 7, 2, '2015-02-15', '02:55:00'),
	(5, 7, 2, '2015-02-15', '01:57:00'),
	(5, 7, 2, '2015-02-15', '01:34:00'),
	(5, 7, 2, '2015-02-15', '02:32:00'),
	(5, 7, 2, '2015-02-15', '02:23:00'),
	(5, 7, 2, '2015-02-15', '02:51:00'),
	(5, 7, 2, '2015-02-15', '03:32:00'),
	(5, 7, 2, '2015-02-15', '03:32:00'),
	(5, 7, 2, '2015-02-15', '03:31:00'),
	(5, 7, 2, '2015-02-15', '03:27:00'),
	(5, 7, 2, '2015-02-15', '03:09:00'),
	(5, 7, 2, '2015-02-15', '01:50:00'),
	(5, 7, 2, '2015-02-15', '02:20:00'),
	(5, 7, 2, '2015-02-15', '02:38:00'),
	(5, 7, 2, '2015-02-15', '02:39:00'),
	(5, 7, 2, '2015-02-15', '01:47:00'),
	(5, 7, 2, '2015-02-15', '01:33:00'),
	(5, 7, 2, '2015-02-15', '02:56:00'),
	(5, 7, 2, '2015-02-15', '02:23:00'),
	(5, 7, 2, '2015-02-15', '01:39:00'),
	(5, 7, 2, '2015-02-15', '01:37:00'),
	(5, 7, 2, '2015-02-15', '01:39:00'),
	(5, 8, 3, '2015-02-15', '03:03:00'),
	(5, 8, 3, '2015-02-15', '02:12:00'),
	(5, 8, 3, '2015-02-15', '02:20:00'),
	(5, 8, 3, '2015-02-15', '01:37:00'),
	(5, 8, 3, '2015-02-15', '01:30:00'),
	(5, 8, 3, '2015-02-15', '03:11:00'),
	(5, 8, 3, '2015-02-15', '02:02:00'),
	(5, 8, 3, '2015-02-15', '03:05:00'),
	(5, 8, 3, '2015-02-15', '01:56:00'),
	(5, 8, 3, '2015-02-15', '02:51:00'),
	(5, 8, 3, '2015-02-15', '03:03:00'),
	(5, 8, 3, '2015-02-15', '03:11:00'),
	(5, 8, 3, '2015-02-15', '03:21:00'),
	(5, 8, 3, '2015-02-15', '01:48:00'),
	(5, 8, 3, '2015-02-15', '03:19:00'),
	(5, 8, 3, '2015-02-15', '01:52:00'),
	(5, 8, 3, '2015-02-15', '01:49:00'),
	(5, 8, 3, '2015-02-15', '01:59:00'),
	(5, 8, 3, '2015-02-15', '02:57:00'),
	(5, 8, 3, '2015-02-15', '03:22:00'),
	(5, 8, 3, '2015-02-15', '02:35:00'),
	(5, 8, 3, '2015-02-15', '03:16:00'),
	(5, 8, 3, '2015-02-15', '03:09:00'),
	(5, 8, 3, '2015-02-15', '02:31:00'),
	(5, 8, 3, '2015-02-15', '01:36:00'),
	(5, 8, 3, '2015-02-15', '02:56:00'),
	(5, 8, 3, '2015-02-15', '02:26:00'),
	(5, 8, 3, '2015-02-15', '01:53:00'),
	(5, 8, 3, '2015-02-15', '02:35:00'),
	(5, 8, 3, '2015-02-15', '01:53:00'),
	(5, 8, 3, '2015-02-15', '02:05:00'),
	(5, 8, 3, '2015-02-15', '03:20:00'),
	(5, 8, 3, '2015-02-15', '03:00:00'),
	(5, 8, 3, '2015-02-15', '01:31:00'),
	(5, 8, 3, '2015-02-15', '03:02:00'),
	(5, 8, 3, '2015-02-15', '03:14:00'),
	(5, 8, 3, '2015-02-15', '01:38:00'),
	(5, 8, 3, '2015-02-15', '02:54:00'),
	(5, 8, 3, '2015-02-15', '02:09:00'),
	(5, 8, 3, '2015-02-15', '02:33:00'),
	(5, 8, 3, '2015-02-15', '02:52:00'),
	(5, 8, 3, '2015-02-15', '03:11:00'),
	(5, 8, 3, '2015-02-15', '01:55:00'),
	(5, 8, 3, '2015-02-15', '02:27:00'),
	(5, 8, 3, '2015-02-15', '03:03:00'),
	(5, 8, 3, '2015-02-15', '02:27:00'),
	(5, 8, 3, '2015-02-15', '01:40:00'),
	(5, 8, 3, '2015-02-15', '03:23:00'),
	(5, 8, 3, '2015-02-15', '02:34:00'),
	(5, 8, 3, '2015-02-15', '03:11:00'),
	(5, 8, 3, '2015-02-15', '02:48:00'),
	(5, 8, 3, '2015-02-15', '02:56:00'),
	(5, 8, 3, '2015-02-15', '02:49:00'),
	(5, 8, 3, '2015-02-15', '01:48:00'),
	(5, 8, 3, '2015-02-15', '03:02:00'),
	(5, 8, 3, '2015-02-15', '02:20:00'),
	(5, 8, 3, '2015-02-15', '03:03:00'),
	(5, 8, 3, '2015-02-15', '02:49:00'),
	(5, 8, 3, '2015-02-15', '03:27:00'),
	(5, 8, 3, '2015-02-15', '03:22:00'),
	(5, 9, 4, '2015-02-15', '01:32:00'),
	(5, 9, 4, '2015-02-15', '03:18:00'),
	(5, 9, 4, '2015-02-15', '03:24:00'),
	(5, 9, 4, '2015-02-15', '03:15:00'),
	(5, 9, 4, '2015-02-15', '02:16:00'),
	(5, 9, 4, '2015-02-15', '02:25:00'),
	(5, 9, 4, '2015-02-15', '03:45:00'),
	(5, 9, 4, '2015-02-15', '03:02:00'),
	(5, 9, 4, '2015-02-15', '02:24:00'),
	(5, 9, 4, '2015-02-15', '03:44:00'),
	(5, 9, 4, '2015-02-15', '03:01:00'),
	(5, 9, 4, '2015-02-15', '02:21:00'),
	(5, 9, 4, '2015-02-15', '03:32:00'),
	(5, 9, 4, '2015-02-15', '02:09:00'),
	(5, 9, 4, '2015-02-15', '03:21:00'),
	(5, 9, 4, '2015-02-15', '01:47:00'),
	(5, 9, 4, '2015-02-15', '02:02:00'),
	(5, 9, 4, '2015-02-15', '03:20:00'),
	(5, 9, 4, '2015-02-15', '02:04:00'),
	(5, 9, 4, '2015-02-15', '03:32:00'),
	(5, 9, 4, '2015-02-15', '02:57:00'),
	(5, 9, 4, '2015-02-15', '02:38:00'),
	(5, 9, 4, '2015-02-15', '02:50:00'),
	(5, 9, 4, '2015-02-15', '02:28:00'),
	(5, 9, 4, '2015-02-15', '02:19:00'),
	(5, 9, 4, '2015-02-15', '02:42:00'),
	(5, 9, 4, '2015-02-15', '02:43:00'),
	(5, 9, 4, '2015-02-15', '01:40:00'),
	(5, 9, 4, '2015-02-15', '03:20:00'),
	(5, 9, 4, '2015-02-15', '03:14:00'),
	(5, 9, 4, '2015-02-15', '02:17:00'),
	(5, 9, 4, '2015-02-15', '02:35:00'),
	(5, 9, 4, '2015-02-15', '02:14:00'),
	(5, 9, 4, '2015-02-15', '01:57:00'),
	(5, 9, 4, '2015-02-15', '01:33:00'),
	(5, 9, 4, '2015-02-15', '02:43:00'),
	(5, 9, 4, '2015-02-15', '02:45:00'),
	(5, 9, 4, '2015-02-15', '01:50:00'),
	(5, 9, 4, '2015-02-15', '01:45:00'),
	(5, 9, 4, '2015-02-15', '01:45:00'),
	(5, 9, 4, '2015-02-15', '01:59:00'),
	(5, 9, 4, '2015-02-15', '03:11:00'),
	(5, 9, 4, '2015-02-15', '03:47:00'),
	(5, 9, 4, '2015-02-15', '03:16:00'),
	(5, 9, 4, '2015-02-15', '03:27:00'),
	(5, 9, 4, '2015-02-15', '03:39:00'),
	(5, 9, 4, '2015-02-15', '01:44:00'),
	(5, 9, 4, '2015-02-15', '03:12:00'),
	(5, 9, 4, '2015-02-15', '02:18:00'),
	(5, 9, 4, '2015-02-15', '02:45:00'),
	(5, 9, 4, '2015-02-15', '03:00:00'),
	(5, 9, 4, '2015-02-15', '02:56:00'),
	(5, 9, 4, '2015-02-15', '01:50:00'),
	(5, 9, 4, '2015-02-15', '03:35:00'),
	(5, 9, 4, '2015-02-15', '01:35:00'),
	(5, 9, 4, '2015-02-15', '02:42:00'),
	(5, 9, 4, '2015-02-15', '02:34:00'),
	(5, 9, 4, '2015-02-15', '03:16:00'),
	(5, 9, 4, '2015-02-15', '02:28:00'),
	(5, 9, 4, '2015-02-15', '03:24:00'),
	(5, 10, 5, '2015-02-15', '02:59:00'),
	(5, 10, 5, '2015-02-15', '03:09:00'),
	(5, 10, 5, '2015-02-15', '02:56:00'),
	(5, 10, 5, '2015-02-15', '03:45:00'),
	(5, 10, 5, '2015-02-15', '03:43:00'),
	(5, 10, 5, '2015-02-15', '03:28:00'),
	(5, 10, 5, '2015-02-15', '02:18:00'),
	(5, 10, 5, '2015-02-15', '02:00:00'),
	(5, 10, 5, '2015-02-15', '01:38:00'),
	(5, 10, 5, '2015-02-15', '03:03:00'),
	(5, 10, 5, '2015-02-15', '01:43:00'),
	(5, 10, 5, '2015-02-15', '02:43:00'),
	(5, 10, 5, '2015-02-15', '02:13:00'),
	(5, 10, 5, '2015-02-15', '03:49:00'),
	(5, 10, 5, '2015-02-15', '03:49:00'),
	(5, 10, 5, '2015-02-15', '03:48:00'),
	(5, 10, 5, '2015-02-15', '03:42:00'),
	(5, 10, 5, '2015-02-15', '03:12:00'),
	(5, 10, 5, '2015-02-15', '03:27:00'),
	(5, 10, 5, '2015-02-15', '03:44:00'),
	(5, 10, 5, '2015-02-15', '02:09:00'),
	(5, 10, 5, '2015-02-15', '02:46:00'),
	(5, 10, 5, '2015-02-15', '03:33:00'),
	(5, 10, 5, '2015-02-15', '03:13:00'),
	(5, 10, 5, '2015-02-15', '01:34:00'),
	(5, 10, 5, '2015-02-15', '03:50:00'),
	(5, 10, 5, '2015-02-15', '03:27:00'),
	(5, 10, 5, '2015-02-15', '01:57:00'),
	(5, 10, 5, '2015-02-15', '02:37:00'),
	(5, 10, 5, '2015-02-15', '03:21:00'),
	(5, 10, 5, '2015-02-15', '02:42:00'),
	(5, 10, 5, '2015-02-15', '01:55:00'),
	(5, 10, 5, '2015-02-15', '02:24:00'),
	(5, 10, 5, '2015-02-15', '02:22:00'),
	(5, 10, 5, '2015-02-15', '03:10:00'),
	(5, 10, 5, '2015-02-15', '02:32:00'),
	(5, 10, 5, '2015-02-15', '01:38:00'),
	(5, 10, 5, '2015-02-15', '03:48:00'),
	(5, 10, 5, '2015-02-15', '03:08:00'),
	(5, 10, 5, '2015-02-15', '02:46:00'),
	(5, 10, 5, '2015-02-15', '02:58:00'),
	(5, 10, 5, '2015-02-15', '02:41:00'),
	(5, 10, 5, '2015-02-15', '02:59:00'),
	(5, 10, 5, '2015-02-15', '03:03:00'),
	(5, 10, 5, '2015-02-15', '02:25:00'),
	(5, 10, 5, '2015-02-15', '03:51:00'),
	(5, 10, 5, '2015-02-15', '03:22:00'),
	(5, 10, 5, '2015-02-15', '03:49:00'),
	(5, 10, 5, '2015-02-15', '02:45:00'),
	(5, 10, 5, '2015-02-15', '03:11:00'),
	(5, 10, 5, '2015-02-15', '03:47:00'),
	(5, 10, 5, '2015-02-15', '03:09:00'),
	(5, 10, 5, '2015-02-15', '02:57:00'),
	(5, 10, 5, '2015-02-15', '03:45:00'),
	(5, 10, 5, '2015-02-15', '03:42:00'),
	(5, 10, 5, '2015-02-15', '03:22:00'),
	(5, 10, 5, '2015-02-15', '01:55:00'),
	(5, 10, 5, '2015-02-15', '02:43:00'),
	(5, 10, 5, '2015-02-15', '01:35:00'),
	(5, 10, 5, '2015-02-15', '03:02:00'),
	(6, 6, 1, '2015-03-01', '03:02:00'),
	(6, 6, 1, '2015-03-01', '02:30:00'),
	(6, 6, 1, '2015-03-01', '01:57:00'),
	(6, 6, 1, '2015-03-01', '02:40:00'),
	(6, 6, 1, '2015-03-01', '02:08:00'),
	(6, 6, 1, '2015-03-01', '03:06:00'),
	(6, 6, 1, '2015-03-01', '01:47:00'),
	(6, 6, 1, '2015-03-01', '02:02:00'),
	(6, 6, 1, '2015-03-01', '03:19:00'),
	(6, 6, 1, '2015-03-01', '03:12:00'),
	(6, 6, 1, '2015-03-01', '02:38:00'),
	(6, 6, 1, '2015-03-01', '02:03:00'),
	(6, 6, 1, '2015-03-01', '02:47:00'),
	(6, 6, 1, '2015-03-01', '02:24:00'),
	(6, 6, 1, '2015-03-01', '02:11:00'),
	(6, 6, 1, '2015-03-01', '02:12:00'),
	(6, 6, 1, '2015-03-01', '02:56:00'),
	(6, 6, 1, '2015-03-01', '02:45:00'),
	(6, 6, 1, '2015-03-01', '01:32:00'),
	(6, 6, 1, '2015-03-01', '01:48:00'),
	(6, 6, 1, '2015-03-01', '02:53:00'),
	(6, 6, 1, '2015-03-01', '01:42:00'),
	(6, 6, 1, '2015-03-01', '02:16:00'),
	(6, 6, 1, '2015-03-01', '02:46:00'),
	(6, 6, 1, '2015-03-01', '01:43:00'),
	(6, 6, 1, '2015-03-01', '02:40:00'),
	(6, 6, 1, '2015-03-01', '02:47:00'),
	(6, 6, 1, '2015-03-01', '02:32:00'),
	(6, 6, 1, '2015-03-01', '02:49:00'),
	(6, 6, 1, '2015-03-01', '03:05:00'),
	(6, 6, 1, '2015-03-01', '01:34:00'),
	(6, 6, 1, '2015-03-01', '02:52:00'),
	(6, 6, 1, '2015-03-01', '02:23:00'),
	(6, 6, 1, '2015-03-01', '01:50:00'),
	(6, 6, 1, '2015-03-01', '02:25:00'),
	(6, 6, 1, '2015-03-01', '03:11:00'),
	(6, 6, 1, '2015-03-01', '03:19:00'),
	(6, 6, 1, '2015-03-01', '01:40:00'),
	(6, 6, 1, '2015-03-01', '02:42:00'),
	(6, 6, 1, '2015-03-01', '03:06:00'),
	(6, 6, 1, '2015-03-01', '02:05:00'),
	(6, 6, 1, '2015-03-01', '01:35:00'),
	(6, 6, 1, '2015-03-01', '02:04:00'),
	(6, 6, 1, '2015-03-01', '02:11:00'),
	(6, 6, 1, '2015-03-01', '03:15:00'),
	(6, 6, 1, '2015-03-01', '02:22:00'),
	(6, 6, 1, '2015-03-01', '02:31:00'),
	(6, 6, 1, '2015-03-01', '02:05:00'),
	(6, 6, 1, '2015-03-01', '03:17:00'),
	(6, 6, 1, '2015-03-01', '02:51:00'),
	(6, 6, 1, '2015-03-01', '02:58:00'),
	(6, 6, 1, '2015-03-01', '02:50:00'),
	(6, 6, 1, '2015-03-01', '01:49:00'),
	(6, 6, 1, '2015-03-01', '02:58:00'),
	(6, 6, 1, '2015-03-01', '02:06:00'),
	(6, 6, 1, '2015-03-01', '02:01:00'),
	(6, 6, 1, '2015-03-01', '02:21:00'),
	(6, 6, 1, '2015-03-01', '02:13:00'),
	(6, 6, 1, '2015-03-01', '02:33:00'),
	(6, 6, 1, '2015-03-01', '02:42:00'),
	(6, 7, 2, '2015-03-01', '02:39:00'),
	(6, 7, 2, '2015-03-01', '02:01:00'),
	(6, 7, 2, '2015-03-01', '02:46:00'),
	(6, 7, 2, '2015-03-01', '02:02:00'),
	(6, 7, 2, '2015-03-01', '02:32:00'),
	(6, 7, 2, '2015-03-01', '02:53:00'),
	(6, 7, 2, '2015-03-01', '03:10:00'),
	(6, 7, 2, '2015-03-01', '03:33:00'),
	(6, 7, 2, '2015-03-01', '02:27:00'),
	(6, 7, 2, '2015-03-01', '02:16:00'),
	(6, 7, 2, '2015-03-01', '02:28:00'),
	(6, 7, 2, '2015-03-01', '01:56:00'),
	(6, 7, 2, '2015-03-01', '02:56:00'),
	(6, 7, 2, '2015-03-01', '03:02:00'),
	(6, 7, 2, '2015-03-01', '02:45:00'),
	(6, 7, 2, '2015-03-01', '03:10:00'),
	(6, 7, 2, '2015-03-01', '01:45:00'),
	(6, 7, 2, '2015-03-01', '02:04:00'),
	(6, 7, 2, '2015-03-01', '03:37:00'),
	(6, 7, 2, '2015-03-01', '01:49:00'),
	(6, 7, 2, '2015-03-01', '03:09:00'),
	(6, 7, 2, '2015-03-01', '02:23:00'),
	(6, 7, 2, '2015-03-01', '03:05:00'),
	(6, 7, 2, '2015-03-01', '02:29:00'),
	(6, 7, 2, '2015-03-01', '01:42:00'),
	(6, 7, 2, '2015-03-01', '01:41:00'),
	(6, 7, 2, '2015-03-01', '01:51:00'),
	(6, 7, 2, '2015-03-01', '02:43:00'),
	(6, 7, 2, '2015-03-01', '02:12:00'),
	(6, 7, 2, '2015-03-01', '03:32:00'),
	(6, 7, 2, '2015-03-01', '03:07:00'),
	(6, 7, 2, '2015-03-01', '03:30:00'),
	(6, 7, 2, '2015-03-01', '02:22:00'),
	(6, 7, 2, '2015-03-01', '01:58:00'),
	(6, 7, 2, '2015-03-01', '03:23:00'),
	(6, 7, 2, '2015-03-01', '03:07:00'),
	(6, 7, 2, '2015-03-01', '01:45:00'),
	(6, 7, 2, '2015-03-01', '02:15:00'),
	(6, 7, 2, '2015-03-01', '02:19:00'),
	(6, 7, 2, '2015-03-01', '03:21:00'),
	(6, 7, 2, '2015-03-01', '01:54:00'),
	(6, 7, 2, '2015-03-01', '02:13:00'),
	(6, 7, 2, '2015-03-01', '01:47:00'),
	(6, 7, 2, '2015-03-01', '02:54:00'),
	(6, 7, 2, '2015-03-01', '03:21:00'),
	(6, 7, 2, '2015-03-01', '02:18:00'),
	(6, 7, 2, '2015-03-01', '02:05:00'),
	(6, 7, 2, '2015-03-01', '02:01:00'),
	(6, 7, 2, '2015-03-01', '02:20:00'),
	(6, 7, 2, '2015-03-01', '01:59:00'),
	(6, 7, 2, '2015-03-01', '03:34:00'),
	(6, 7, 2, '2015-03-01', '01:50:00'),
	(6, 7, 2, '2015-03-01', '03:23:00'),
	(6, 7, 2, '2015-03-01', '03:27:00'),
	(6, 7, 2, '2015-03-01', '03:30:00'),
	(6, 7, 2, '2015-03-01', '03:31:00'),
	(6, 7, 2, '2015-03-01', '03:28:00'),
	(6, 7, 2, '2015-03-01', '03:05:00'),
	(6, 7, 2, '2015-03-01', '03:33:00'),
	(6, 7, 2, '2015-03-01', '02:43:00'),
	(6, 8, 3, '2015-03-01', '01:51:00'),
	(6, 8, 3, '2015-03-01', '03:29:00'),
	(6, 8, 3, '2015-03-01', '03:01:00'),
	(6, 8, 3, '2015-03-01', '03:06:00'),
	(6, 8, 3, '2015-03-01', '02:31:00'),
	(6, 8, 3, '2015-03-01', '01:49:00'),
	(6, 8, 3, '2015-03-01', '02:27:00'),
	(6, 8, 3, '2015-03-01', '02:52:00'),
	(6, 8, 3, '2015-03-01', '03:03:00'),
	(6, 8, 3, '2015-03-01', '02:39:00'),
	(6, 8, 3, '2015-03-01', '02:36:00'),
	(6, 8, 3, '2015-03-01', '03:35:00'),
	(6, 8, 3, '2015-03-01', '03:43:00'),
	(6, 8, 3, '2015-03-01', '03:52:00'),
	(6, 8, 3, '2015-03-01', '01:44:00'),
	(6, 8, 3, '2015-03-01', '02:58:00'),
	(6, 8, 3, '2015-03-01', '03:12:00'),
	(6, 8, 3, '2015-03-01', '03:09:00'),
	(6, 8, 3, '2015-03-01', '02:13:00'),
	(6, 8, 3, '2015-03-01', '02:37:00'),
	(6, 8, 3, '2015-03-01', '02:27:00'),
	(6, 8, 3, '2015-03-01', '02:56:00'),
	(6, 8, 3, '2015-03-01', '03:22:00'),
	(6, 8, 3, '2015-03-01', '01:37:00'),
	(6, 8, 3, '2015-03-01', '03:51:00'),
	(6, 8, 3, '2015-03-01', '03:03:00'),
	(6, 8, 3, '2015-03-01', '02:12:00'),
	(6, 8, 3, '2015-03-01', '02:52:00'),
	(6, 8, 3, '2015-03-01', '03:44:00'),
	(6, 8, 3, '2015-03-01', '03:40:00'),
	(6, 8, 3, '2015-03-01', '03:12:00'),
	(6, 8, 3, '2015-03-01', '03:29:00'),
	(6, 8, 3, '2015-03-01', '03:53:00'),
	(6, 8, 3, '2015-03-01', '02:33:00'),
	(6, 8, 3, '2015-03-01', '02:04:00'),
	(6, 8, 3, '2015-03-01', '03:37:00'),
	(6, 8, 3, '2015-03-01', '03:03:00'),
	(6, 8, 3, '2015-03-01', '02:51:00'),
	(6, 8, 3, '2015-03-01', '03:40:00'),
	(6, 8, 3, '2015-03-01', '03:18:00'),
	(6, 8, 3, '2015-03-01', '01:36:00'),
	(6, 8, 3, '2015-03-01', '01:30:00'),
	(6, 8, 3, '2015-03-01', '03:43:00'),
	(6, 8, 3, '2015-03-01', '02:43:00'),
	(6, 8, 3, '2015-03-01', '03:22:00'),
	(6, 8, 3, '2015-03-01', '02:16:00'),
	(6, 8, 3, '2015-03-01', '02:15:00'),
	(6, 8, 3, '2015-03-01', '02:57:00'),
	(6, 8, 3, '2015-03-01', '01:35:00'),
	(6, 8, 3, '2015-03-01', '02:30:00'),
	(6, 8, 3, '2015-03-01', '03:46:00'),
	(6, 8, 3, '2015-03-01', '02:28:00'),
	(6, 8, 3, '2015-03-01', '01:58:00'),
	(6, 8, 3, '2015-03-01', '03:27:00'),
	(6, 8, 3, '2015-03-01', '02:28:00'),
	(6, 8, 3, '2015-03-01', '02:56:00'),
	(6, 8, 3, '2015-03-01', '03:18:00'),
	(6, 8, 3, '2015-03-01', '03:45:00'),
	(6, 8, 3, '2015-03-01', '02:25:00'),
	(6, 8, 3, '2015-03-01', '01:47:00'),
	(6, 9, 4, '2015-03-01', '01:31:00'),
	(6, 9, 4, '2015-03-01', '02:50:00'),
	(6, 9, 4, '2015-03-01', '01:46:00'),
	(6, 9, 4, '2015-03-01', '03:05:00'),
	(6, 9, 4, '2015-03-01', '02:13:00'),
	(6, 9, 4, '2015-03-01', '02:29:00'),
	(6, 9, 4, '2015-03-01', '02:10:00'),
	(6, 9, 4, '2015-03-01', '01:54:00'),
	(6, 9, 4, '2015-03-01', '03:36:00'),
	(6, 9, 4, '2015-03-01', '02:18:00'),
	(6, 9, 4, '2015-03-01', '03:28:00'),
	(6, 9, 4, '2015-03-01', '02:32:00'),
	(6, 9, 4, '2015-03-01', '02:55:00'),
	(6, 9, 4, '2015-03-01', '03:21:00'),
	(6, 9, 4, '2015-03-01', '02:13:00'),
	(6, 9, 4, '2015-03-01', '01:41:00'),
	(6, 9, 4, '2015-03-01', '02:23:00'),
	(6, 9, 4, '2015-03-01', '03:18:00'),
	(6, 9, 4, '2015-03-01', '03:34:00'),
	(6, 9, 4, '2015-03-01', '02:11:00'),
	(6, 9, 4, '2015-03-01', '02:58:00'),
	(6, 9, 4, '2015-03-01', '02:33:00'),
	(6, 9, 4, '2015-03-01', '02:20:00'),
	(6, 9, 4, '2015-03-01', '02:34:00'),
	(6, 9, 4, '2015-03-01', '02:11:00'),
	(6, 9, 4, '2015-03-01', '01:45:00'),
	(6, 9, 4, '2015-03-01', '02:51:00'),
	(6, 9, 4, '2015-03-01', '03:15:00'),
	(6, 9, 4, '2015-03-01', '01:54:00'),
	(6, 9, 4, '2015-03-01', '02:33:00'),
	(6, 9, 4, '2015-03-01', '03:25:00'),
	(6, 9, 4, '2015-03-01', '01:31:00'),
	(6, 9, 4, '2015-03-01', '02:17:00'),
	(6, 9, 4, '2015-03-01', '03:14:00'),
	(6, 9, 4, '2015-03-01', '03:32:00'),
	(6, 9, 4, '2015-03-01', '02:14:00'),
	(6, 9, 4, '2015-03-01', '03:19:00'),
	(6, 9, 4, '2015-03-01', '02:00:00'),
	(6, 9, 4, '2015-03-01', '02:51:00'),
	(6, 9, 4, '2015-03-01', '02:29:00'),
	(6, 9, 4, '2015-03-01', '02:20:00'),
	(6, 9, 4, '2015-03-01', '02:46:00'),
	(6, 9, 4, '2015-03-01', '03:10:00'),
	(6, 9, 4, '2015-03-01', '01:49:00'),
	(6, 9, 4, '2015-03-01', '02:20:00'),
	(6, 9, 4, '2015-03-01', '02:37:00'),
	(6, 9, 4, '2015-03-01', '02:28:00'),
	(6, 9, 4, '2015-03-01', '02:58:00'),
	(6, 9, 4, '2015-03-01', '01:40:00'),
	(6, 9, 4, '2015-03-01', '02:13:00'),
	(6, 9, 4, '2015-03-01', '02:29:00'),
	(6, 9, 4, '2015-03-01', '02:07:00'),
	(6, 9, 4, '2015-03-01', '01:41:00'),
	(6, 9, 4, '2015-03-01', '02:39:00'),
	(6, 9, 4, '2015-03-01', '02:28:00'),
	(6, 9, 4, '2015-03-01', '02:51:00'),
	(6, 9, 4, '2015-03-01', '03:17:00'),
	(6, 9, 4, '2015-03-01', '02:06:00'),
	(6, 9, 4, '2015-03-01', '03:27:00'),
	(6, 9, 4, '2015-03-01', '03:02:00'),
	(6, 10, 5, '2015-03-01', '01:43:00'),
	(6, 10, 5, '2015-03-01', '03:43:00'),
	(6, 10, 5, '2015-03-01', '02:19:00'),
	(6, 10, 5, '2015-03-01', '03:46:00'),
	(6, 10, 5, '2015-03-01', '03:09:00'),
	(6, 10, 5, '2015-03-01', '02:57:00'),
	(6, 10, 5, '2015-03-01', '03:49:00'),
	(6, 10, 5, '2015-03-01', '01:31:00'),
	(6, 10, 5, '2015-03-01', '01:54:00'),
	(6, 10, 5, '2015-03-01', '03:24:00'),
	(6, 10, 5, '2015-03-01', '02:38:00'),
	(6, 10, 5, '2015-03-01', '01:30:00'),
	(6, 10, 5, '2015-03-01', '02:54:00'),
	(6, 10, 5, '2015-03-01', '03:41:00'),
	(6, 10, 5, '2015-03-01', '03:25:00'),
	(6, 10, 5, '2015-03-01', '02:08:00'),
	(6, 10, 5, '2015-03-01', '03:45:00'),
	(6, 10, 5, '2015-03-01', '03:39:00'),
	(6, 10, 5, '2015-03-01', '03:07:00'),
	(6, 10, 5, '2015-03-01', '03:09:00'),
	(6, 10, 5, '2015-03-01', '02:31:00'),
	(6, 10, 5, '2015-03-01', '01:39:00'),
	(6, 10, 5, '2015-03-01', '01:36:00'),
	(6, 10, 5, '2015-03-01', '01:33:00'),
	(6, 10, 5, '2015-03-01', '03:53:00'),
	(6, 10, 5, '2015-03-01', '03:41:00'),
	(6, 10, 5, '2015-03-01', '02:51:00'),
	(6, 10, 5, '2015-03-01', '01:43:00'),
	(6, 10, 5, '2015-03-01', '03:19:00'),
	(6, 10, 5, '2015-03-01', '02:46:00'),
	(6, 10, 5, '2015-03-01', '02:24:00'),
	(6, 10, 5, '2015-03-01', '02:11:00'),
	(6, 10, 5, '2015-03-01', '02:14:00'),
	(6, 10, 5, '2015-03-01', '03:06:00'),
	(6, 10, 5, '2015-03-01', '02:33:00'),
	(6, 10, 5, '2015-03-01', '01:55:00'),
	(6, 10, 5, '2015-03-01', '02:52:00'),
	(6, 10, 5, '2015-03-01', '02:15:00'),
	(6, 10, 5, '2015-03-01', '03:36:00'),
	(6, 10, 5, '2015-03-01', '02:32:00'),
	(6, 10, 5, '2015-03-01', '02:45:00'),
	(6, 10, 5, '2015-03-01', '02:19:00'),
	(6, 10, 5, '2015-03-01', '01:49:00'),
	(6, 10, 5, '2015-03-01', '03:04:00'),
	(6, 10, 5, '2015-03-01', '03:33:00'),
	(6, 10, 5, '2015-03-01', '02:18:00'),
	(6, 10, 5, '2015-03-01', '01:43:00'),
	(6, 10, 5, '2015-03-01', '02:37:00'),
	(6, 10, 5, '2015-03-01', '01:40:00'),
	(6, 10, 5, '2015-03-01', '03:46:00'),
	(6, 10, 5, '2015-03-01', '02:44:00'),
	(6, 10, 5, '2015-03-01', '03:15:00'),
	(6, 10, 5, '2015-03-01', '01:47:00'),
	(6, 10, 5, '2015-03-01', '02:27:00'),
	(6, 10, 5, '2015-03-01', '03:03:00'),
	(6, 10, 5, '2015-03-01', '01:34:00'),
	(6, 10, 5, '2015-03-01', '02:02:00'),
	(6, 10, 5, '2015-03-01', '01:33:00'),
	(6, 10, 5, '2015-03-01', '02:32:00'),
	(6, 10, 5, '2015-03-01', '01:47:00'),
	(8, 6, 1, '2015-03-15', '01:39:00'),
	(8, 6, 1, '2015-03-15', '02:32:00'),
	(8, 6, 1, '2015-03-15', '02:11:00'),
	(8, 6, 1, '2015-03-15', '01:49:00'),
	(8, 6, 1, '2015-03-15', '03:04:00'),
	(8, 6, 1, '2015-03-15', '02:20:00'),
	(8, 6, 1, '2015-03-15', '03:01:00'),
	(8, 6, 1, '2015-03-15', '02:33:00'),
	(8, 6, 1, '2015-03-15', '02:10:00'),
	(8, 6, 1, '2015-03-15', '01:45:00'),
	(8, 6, 1, '2015-03-15', '02:43:00'),
	(8, 6, 1, '2015-03-15', '02:52:00'),
	(8, 6, 1, '2015-03-15', '02:37:00'),
	(8, 6, 1, '2015-03-15', '03:01:00'),
	(8, 6, 1, '2015-03-15', '01:43:00'),
	(8, 6, 1, '2015-03-15', '02:04:00'),
	(8, 6, 1, '2015-03-15', '01:42:00'),
	(8, 6, 1, '2015-03-15', '02:50:00'),
	(8, 6, 1, '2015-03-15', '01:32:00'),
	(8, 6, 1, '2015-03-15', '01:44:00'),
	(8, 6, 1, '2015-03-15', '02:31:00'),
	(8, 6, 1, '2015-03-15', '01:51:00'),
	(8, 6, 1, '2015-03-15', '02:17:00'),
	(8, 6, 1, '2015-03-15', '02:18:00'),
	(8, 6, 1, '2015-03-15', '03:12:00'),
	(8, 6, 1, '2015-03-15', '01:32:00'),
	(8, 6, 1, '2015-03-15', '02:40:00'),
	(8, 6, 1, '2015-03-15', '03:11:00'),
	(8, 6, 1, '2015-03-15', '02:25:00'),
	(8, 6, 1, '2015-03-15', '03:03:00'),
	(8, 6, 1, '2015-03-15', '02:28:00'),
	(8, 6, 1, '2015-03-15', '01:40:00'),
	(8, 6, 1, '2015-03-15', '01:30:00'),
	(8, 6, 1, '2015-03-15', '03:02:00'),
	(8, 6, 1, '2015-03-15', '03:07:00'),
	(8, 6, 1, '2015-03-15', '02:57:00'),
	(8, 6, 1, '2015-03-15', '01:55:00'),
	(8, 6, 1, '2015-03-15', '03:18:00'),
	(8, 6, 1, '2015-03-15', '03:11:00'),
	(8, 6, 1, '2015-03-15', '02:30:00'),
	(8, 6, 1, '2015-03-15', '01:30:00'),
	(8, 6, 1, '2015-03-15', '02:30:00'),
	(8, 6, 1, '2015-03-15', '02:27:00'),
	(8, 6, 1, '2015-03-15', '03:19:00'),
	(8, 6, 1, '2015-03-15', '01:38:00'),
	(8, 6, 1, '2015-03-15', '02:50:00'),
	(8, 6, 1, '2015-03-15', '01:40:00'),
	(8, 6, 1, '2015-03-15', '02:24:00'),
	(8, 6, 1, '2015-03-15', '03:29:00'),
	(8, 6, 1, '2015-03-15', '02:40:00'),
	(8, 6, 1, '2015-03-15', '03:24:00'),
	(8, 6, 1, '2015-03-15', '01:30:00'),
	(8, 6, 1, '2015-03-15', '01:50:00'),
	(8, 6, 1, '2015-03-15', '03:09:00'),
	(8, 6, 1, '2015-03-15', '02:44:00'),
	(8, 6, 1, '2015-03-15', '02:45:00'),
	(8, 6, 1, '2015-03-15', '02:02:00'),
	(8, 6, 1, '2015-03-15', '02:26:00'),
	(8, 6, 1, '2015-03-15', '02:35:00'),
	(8, 6, 1, '2015-03-15', '02:04:00'),
	(8, 7, 2, '2015-03-15', '01:53:00'),
	(8, 7, 2, '2015-03-15', '02:27:00'),
	(8, 7, 2, '2015-03-15', '02:45:00'),
	(8, 7, 2, '2015-03-15', '02:32:00'),
	(8, 7, 2, '2015-03-15', '02:55:00'),
	(8, 7, 2, '2015-03-15', '03:09:00'),
	(8, 7, 2, '2015-03-15', '03:07:00'),
	(8, 7, 2, '2015-03-15', '02:17:00'),
	(8, 7, 2, '2015-03-15', '02:58:00'),
	(8, 7, 2, '2015-03-15', '01:46:00'),
	(8, 7, 2, '2015-03-15', '03:09:00'),
	(8, 7, 2, '2015-03-15', '01:53:00'),
	(8, 7, 2, '2015-03-15', '03:10:00'),
	(8, 7, 2, '2015-03-15', '01:36:00'),
	(8, 7, 2, '2015-03-15', '01:47:00'),
	(8, 7, 2, '2015-03-15', '02:36:00'),
	(8, 7, 2, '2015-03-15', '03:49:00'),
	(8, 7, 2, '2015-03-15', '02:42:00'),
	(8, 7, 2, '2015-03-15', '02:57:00'),
	(8, 7, 2, '2015-03-15', '02:44:00'),
	(8, 7, 2, '2015-03-15', '03:20:00'),
	(8, 7, 2, '2015-03-15', '02:15:00'),
	(8, 7, 2, '2015-03-15', '02:06:00'),
	(8, 7, 2, '2015-03-15', '02:17:00'),
	(8, 7, 2, '2015-03-15', '03:37:00'),
	(8, 7, 2, '2015-03-15', '02:38:00'),
	(8, 7, 2, '2015-03-15', '03:13:00'),
	(8, 7, 2, '2015-03-15', '01:56:00'),
	(8, 7, 2, '2015-03-15', '03:14:00'),
	(8, 7, 2, '2015-03-15', '01:47:00'),
	(8, 7, 2, '2015-03-15', '02:30:00'),
	(8, 7, 2, '2015-03-15', '03:17:00'),
	(8, 7, 2, '2015-03-15', '02:40:00'),
	(8, 7, 2, '2015-03-15', '02:00:00'),
	(8, 7, 2, '2015-03-15', '02:51:00'),
	(8, 7, 2, '2015-03-15', '02:04:00'),
	(8, 7, 2, '2015-03-15', '02:40:00'),
	(8, 7, 2, '2015-03-15', '03:15:00'),
	(8, 7, 2, '2015-03-15', '02:02:00'),
	(8, 7, 2, '2015-03-15', '03:38:00'),
	(8, 7, 2, '2015-03-15', '03:28:00'),
	(8, 7, 2, '2015-03-15', '02:36:00'),
	(8, 7, 2, '2015-03-15', '03:27:00'),
	(8, 7, 2, '2015-03-15', '03:14:00'),
	(8, 7, 2, '2015-03-15', '01:58:00'),
	(8, 7, 2, '2015-03-15', '03:23:00'),
	(8, 7, 2, '2015-03-15', '02:26:00'),
	(8, 7, 2, '2015-03-15', '02:55:00'),
	(8, 7, 2, '2015-03-15', '03:24:00'),
	(8, 7, 2, '2015-03-15', '02:01:00'),
	(8, 7, 2, '2015-03-15', '03:06:00'),
	(8, 7, 2, '2015-03-15', '03:14:00'),
	(8, 7, 2, '2015-03-15', '03:03:00'),
	(8, 7, 2, '2015-03-15', '01:40:00'),
	(8, 7, 2, '2015-03-15', '02:27:00'),
	(8, 7, 2, '2015-03-15', '03:24:00'),
	(8, 7, 2, '2015-03-15', '03:24:00'),
	(8, 7, 2, '2015-03-15', '02:58:00'),
	(8, 7, 2, '2015-03-15', '03:06:00'),
	(8, 7, 2, '2015-03-15', '02:47:00'),
	(8, 8, 3, '2015-03-15', '03:15:00'),
	(8, 8, 3, '2015-03-15', '03:21:00'),
	(8, 8, 3, '2015-03-15', '03:15:00'),
	(8, 8, 3, '2015-03-15', '02:24:00'),
	(8, 8, 3, '2015-03-15', '03:01:00'),
	(8, 8, 3, '2015-03-15', '01:51:00'),
	(8, 8, 3, '2015-03-15', '03:18:00'),
	(8, 8, 3, '2015-03-15', '02:36:00'),
	(8, 8, 3, '2015-03-15', '01:35:00'),
	(8, 8, 3, '2015-03-15', '03:11:00'),
	(8, 8, 3, '2015-03-15', '02:51:00'),
	(8, 8, 3, '2015-03-15', '03:12:00'),
	(8, 8, 3, '2015-03-15', '03:43:00'),
	(8, 8, 3, '2015-03-15', '02:52:00'),
	(8, 8, 3, '2015-03-15', '01:42:00'),
	(8, 8, 3, '2015-03-15', '02:58:00'),
	(8, 8, 3, '2015-03-15', '03:40:00'),
	(8, 8, 3, '2015-03-15', '03:23:00'),
	(8, 8, 3, '2015-03-15', '02:09:00'),
	(8, 8, 3, '2015-03-15', '03:39:00'),
	(8, 8, 3, '2015-03-15', '03:28:00'),
	(8, 8, 3, '2015-03-15', '02:39:00'),
	(8, 8, 3, '2015-03-15', '03:35:00'),
	(8, 8, 3, '2015-03-15', '01:41:00'),
	(8, 8, 3, '2015-03-15', '02:59:00'),
	(8, 8, 3, '2015-03-15', '01:30:00'),
	(8, 8, 3, '2015-03-15', '01:41:00'),
	(8, 8, 3, '2015-03-15', '02:23:00'),
	(8, 8, 3, '2015-03-15', '03:05:00'),
	(8, 8, 3, '2015-03-15', '02:14:00'),
	(8, 8, 3, '2015-03-15', '02:42:00'),
	(8, 8, 3, '2015-03-15', '03:03:00'),
	(8, 8, 3, '2015-03-15', '03:21:00'),
	(8, 8, 3, '2015-03-15', '01:31:00'),
	(8, 8, 3, '2015-03-15', '02:56:00'),
	(8, 8, 3, '2015-03-15', '01:45:00'),
	(8, 8, 3, '2015-03-15', '03:01:00'),
	(8, 8, 3, '2015-03-15', '03:45:00'),
	(8, 8, 3, '2015-03-15', '03:41:00'),
	(8, 8, 3, '2015-03-15', '03:25:00'),
	(8, 8, 3, '2015-03-15', '02:13:00'),
	(8, 8, 3, '2015-03-15', '01:36:00'),
	(8, 8, 3, '2015-03-15', '02:11:00'),
	(8, 8, 3, '2015-03-15', '02:21:00'),
	(8, 8, 3, '2015-03-15', '03:41:00'),
	(8, 8, 3, '2015-03-15', '03:04:00'),
	(8, 8, 3, '2015-03-15', '02:46:00'),
	(8, 8, 3, '2015-03-15', '03:10:00'),
	(8, 8, 3, '2015-03-15', '03:42:00'),
	(8, 8, 3, '2015-03-15', '03:00:00'),
	(8, 8, 3, '2015-03-15', '02:23:00'),
	(8, 8, 3, '2015-03-15', '03:42:00'),
	(8, 8, 3, '2015-03-15', '03:00:00'),
	(8, 8, 3, '2015-03-15', '02:26:00'),
	(8, 8, 3, '2015-03-15', '01:38:00'),
	(8, 8, 3, '2015-03-15', '01:42:00'),
	(8, 8, 3, '2015-03-15', '02:04:00'),
	(8, 8, 3, '2015-03-15', '01:30:00'),
	(8, 8, 3, '2015-03-15', '02:03:00'),
	(8, 8, 3, '2015-03-15', '02:00:00'),
	(8, 9, 4, '2015-03-15', '02:03:00'),
	(8, 9, 4, '2015-03-15', '01:51:00'),
	(8, 9, 4, '2015-03-15', '01:36:00'),
	(8, 9, 4, '2015-03-15', '03:01:00'),
	(8, 9, 4, '2015-03-15', '02:34:00'),
	(8, 9, 4, '2015-03-15', '02:15:00'),
	(8, 9, 4, '2015-03-15', '02:07:00'),
	(8, 9, 4, '2015-03-15', '02:20:00'),
	(8, 9, 4, '2015-03-15', '01:42:00'),
	(8, 9, 4, '2015-03-15', '02:07:00'),
	(8, 9, 4, '2015-03-15', '01:54:00'),
	(8, 9, 4, '2015-03-15', '01:39:00'),
	(8, 9, 4, '2015-03-15', '03:09:00'),
	(8, 9, 4, '2015-03-15', '03:05:00'),
	(8, 9, 4, '2015-03-15', '02:23:00'),
	(8, 9, 4, '2015-03-15', '03:15:00'),
	(8, 9, 4, '2015-03-15', '03:27:00'),
	(8, 9, 4, '2015-03-15', '01:49:00'),
	(8, 9, 4, '2015-03-15', '03:31:00'),
	(8, 9, 4, '2015-03-15', '02:17:00'),
	(8, 9, 4, '2015-03-15', '03:34:00'),
	(8, 9, 4, '2015-03-15', '03:13:00'),
	(8, 9, 4, '2015-03-15', '01:48:00'),
	(8, 9, 4, '2015-03-15', '02:04:00'),
	(8, 9, 4, '2015-03-15', '03:27:00'),
	(8, 9, 4, '2015-03-15', '03:18:00'),
	(8, 9, 4, '2015-03-15', '02:36:00'),
	(8, 9, 4, '2015-03-15', '01:34:00'),
	(8, 9, 4, '2015-03-15', '02:41:00'),
	(8, 9, 4, '2015-03-15', '03:07:00'),
	(8, 9, 4, '2015-03-15', '01:51:00'),
	(8, 9, 4, '2015-03-15', '02:35:00'),
	(8, 9, 4, '2015-03-15', '01:42:00'),
	(8, 9, 4, '2015-03-15', '03:27:00'),
	(8, 9, 4, '2015-03-15', '02:17:00'),
	(8, 9, 4, '2015-03-15', '01:42:00'),
	(8, 9, 4, '2015-03-15', '02:13:00'),
	(8, 9, 4, '2015-03-15', '02:23:00'),
	(8, 9, 4, '2015-03-15', '01:42:00'),
	(8, 9, 4, '2015-03-15', '01:55:00'),
	(8, 9, 4, '2015-03-15', '03:03:00'),
	(8, 9, 4, '2015-03-15', '01:43:00'),
	(8, 9, 4, '2015-03-15', '02:09:00'),
	(8, 9, 4, '2015-03-15', '01:59:00'),
	(8, 9, 4, '2015-03-15', '02:01:00'),
	(8, 9, 4, '2015-03-15', '02:36:00'),
	(8, 9, 4, '2015-03-15', '03:24:00'),
	(8, 9, 4, '2015-03-15', '03:34:00'),
	(8, 9, 4, '2015-03-15', '01:56:00'),
	(8, 9, 4, '2015-03-15', '01:39:00'),
	(8, 9, 4, '2015-03-15', '03:02:00'),
	(8, 9, 4, '2015-03-15', '02:30:00'),
	(8, 9, 4, '2015-03-15', '01:54:00'),
	(8, 9, 4, '2015-03-15', '02:34:00'),
	(8, 9, 4, '2015-03-15', '03:34:00'),
	(8, 9, 4, '2015-03-15', '02:25:00'),
	(8, 9, 4, '2015-03-15', '01:58:00'),
	(8, 9, 4, '2015-03-15', '03:12:00'),
	(8, 9, 4, '2015-03-15', '02:21:00'),
	(8, 9, 4, '2015-03-15', '02:46:00'),
	(8, 10, 5, '2015-03-15', '02:05:00'),
	(8, 10, 5, '2015-03-15', '03:21:00'),
	(8, 10, 5, '2015-03-15', '01:54:00'),
	(8, 10, 5, '2015-03-15', '02:43:00'),
	(8, 10, 5, '2015-03-15', '01:38:00'),
	(8, 10, 5, '2015-03-15', '03:15:00'),
	(8, 10, 5, '2015-03-15', '02:48:00'),
	(8, 10, 5, '2015-03-15', '02:45:00'),
	(8, 10, 5, '2015-03-15', '01:31:00'),
	(8, 10, 5, '2015-03-15', '02:32:00'),
	(8, 10, 5, '2015-03-15', '01:54:00'),
	(8, 10, 5, '2015-03-15', '02:46:00'),
	(8, 10, 5, '2015-03-15', '01:56:00'),
	(8, 10, 5, '2015-03-15', '02:14:00'),
	(8, 10, 5, '2015-03-15', '03:50:00'),
	(8, 10, 5, '2015-03-15', '01:33:00'),
	(8, 10, 5, '2015-03-15', '01:53:00'),
	(8, 10, 5, '2015-03-15', '03:14:00'),
	(8, 10, 5, '2015-03-15', '01:55:00'),
	(8, 10, 5, '2015-03-15', '03:08:00'),
	(8, 10, 5, '2015-03-15', '03:43:00'),
	(8, 10, 5, '2015-03-15', '02:55:00'),
	(8, 10, 5, '2015-03-15', '01:59:00'),
	(8, 10, 5, '2015-03-15', '02:02:00'),
	(8, 10, 5, '2015-03-15', '02:43:00'),
	(8, 10, 5, '2015-03-15', '03:37:00'),
	(8, 10, 5, '2015-03-15', '03:42:00'),
	(8, 10, 5, '2015-03-15', '03:49:00'),
	(8, 10, 5, '2015-03-15', '01:43:00'),
	(8, 10, 5, '2015-03-15', '02:48:00'),
	(8, 10, 5, '2015-03-15', '02:34:00'),
	(8, 10, 5, '2015-03-15', '02:58:00'),
	(8, 10, 5, '2015-03-15', '03:18:00'),
	(8, 10, 5, '2015-03-15', '03:45:00'),
	(8, 10, 5, '2015-03-15', '02:35:00'),
	(8, 10, 5, '2015-03-15', '02:35:00'),
	(8, 10, 5, '2015-03-15', '03:41:00'),
	(8, 10, 5, '2015-03-15', '02:04:00'),
	(8, 10, 5, '2015-03-15', '02:32:00'),
	(8, 10, 5, '2015-03-15', '02:38:00'),
	(8, 10, 5, '2015-03-15', '01:41:00'),
	(8, 10, 5, '2015-03-15', '03:45:00'),
	(8, 10, 5, '2015-03-15', '02:43:00'),
	(8, 10, 5, '2015-03-15', '03:13:00'),
	(8, 10, 5, '2015-03-15', '01:44:00'),
	(8, 10, 5, '2015-03-15', '02:14:00'),
	(8, 10, 5, '2015-03-15', '02:07:00'),
	(8, 10, 5, '2015-03-15', '02:22:00'),
	(8, 10, 5, '2015-03-15', '01:37:00'),
	(8, 10, 5, '2015-03-15', '01:54:00'),
	(8, 10, 5, '2015-03-15', '03:09:00'),
	(8, 10, 5, '2015-03-15', '03:49:00'),
	(8, 10, 5, '2015-03-15', '03:23:00'),
	(8, 10, 5, '2015-03-15', '01:39:00'),
	(8, 10, 5, '2015-03-15', '03:40:00'),
	(8, 10, 5, '2015-03-15', '02:25:00'),
	(8, 10, 5, '2015-03-15', '01:59:00'),
	(8, 10, 5, '2015-03-15', '03:32:00'),
	(8, 10, 5, '2015-03-15', '03:09:00'),
	(8, 10, 5, '2015-03-15', '03:40:00'),
	(9, 6, 1, '2015-04-01', '02:58:00'),
	(9, 6, 1, '2015-04-01', '03:34:00'),
	(9, 6, 1, '2015-04-01', '03:10:00'),
	(9, 6, 1, '2015-04-01', '01:30:00'),
	(9, 6, 1, '2015-04-01', '02:55:00'),
	(9, 6, 1, '2015-04-01', '02:08:00'),
	(9, 6, 1, '2015-04-01', '02:35:00'),
	(9, 6, 1, '2015-04-01', '02:51:00'),
	(9, 6, 1, '2015-04-01', '02:54:00'),
	(9, 6, 1, '2015-04-01', '02:18:00'),
	(9, 6, 1, '2015-04-01', '03:25:00'),
	(9, 6, 1, '2015-04-01', '02:17:00'),
	(9, 6, 1, '2015-04-01', '01:48:00'),
	(9, 6, 1, '2015-04-01', '02:50:00'),
	(9, 6, 1, '2015-04-01', '03:00:00'),
	(9, 6, 1, '2015-04-01', '02:49:00'),
	(9, 6, 1, '2015-04-01', '03:37:00'),
	(9, 6, 1, '2015-04-01', '01:42:00'),
	(9, 6, 1, '2015-04-01', '02:36:00'),
	(9, 6, 1, '2015-04-01', '02:07:00'),
	(9, 6, 1, '2015-04-01', '03:26:00'),
	(9, 6, 1, '2015-04-01', '02:50:00'),
	(9, 6, 1, '2015-04-01', '02:26:00'),
	(9, 6, 1, '2015-04-01', '02:10:00'),
	(9, 6, 1, '2015-04-01', '02:00:00'),
	(9, 6, 1, '2015-04-01', '02:02:00'),
	(9, 6, 1, '2015-04-01', '02:41:00'),
	(9, 6, 1, '2015-04-01', '01:33:00'),
	(9, 6, 1, '2015-04-01', '02:29:00'),
	(9, 6, 1, '2015-04-01', '01:57:00'),
	(9, 6, 1, '2015-04-01', '02:58:00'),
	(9, 6, 1, '2015-04-01', '03:10:00'),
	(9, 6, 1, '2015-04-01', '03:20:00'),
	(9, 6, 1, '2015-04-01', '03:30:00'),
	(9, 6, 1, '2015-04-01', '01:42:00'),
	(9, 6, 1, '2015-04-01', '02:56:00'),
	(9, 6, 1, '2015-04-01', '01:41:00'),
	(9, 6, 1, '2015-04-01', '02:23:00'),
	(9, 6, 1, '2015-04-01', '03:13:00'),
	(9, 6, 1, '2015-04-01', '03:08:00'),
	(9, 6, 1, '2015-04-01', '02:22:00'),
	(9, 6, 1, '2015-04-01', '03:06:00'),
	(9, 6, 1, '2015-04-01', '02:35:00'),
	(9, 6, 1, '2015-04-01', '02:11:00'),
	(9, 6, 1, '2015-04-01', '01:38:00'),
	(9, 6, 1, '2015-04-01', '02:18:00'),
	(9, 6, 1, '2015-04-01', '02:55:00'),
	(9, 6, 1, '2015-04-01', '01:57:00'),
	(9, 6, 1, '2015-04-01', '01:37:00'),
	(9, 6, 1, '2015-04-01', '02:55:00'),
	(9, 6, 1, '2015-04-01', '01:48:00'),
	(9, 6, 1, '2015-04-01', '03:01:00'),
	(9, 6, 1, '2015-04-01', '01:44:00'),
	(9, 6, 1, '2015-04-01', '02:28:00'),
	(9, 6, 1, '2015-04-01', '03:29:00'),
	(9, 6, 1, '2015-04-01', '02:03:00'),
	(9, 6, 1, '2015-04-01', '02:36:00'),
	(9, 6, 1, '2015-04-01', '03:14:00'),
	(9, 6, 1, '2015-04-01', '02:34:00'),
	(9, 6, 1, '2015-04-01', '01:38:00'),
	(9, 7, 2, '2015-04-01', '01:32:00'),
	(9, 7, 2, '2015-04-01', '02:48:00'),
	(9, 7, 2, '2015-04-01', '03:07:00'),
	(9, 7, 2, '2015-04-01', '03:22:00'),
	(9, 7, 2, '2015-04-01', '03:33:00'),
	(9, 7, 2, '2015-04-01', '03:50:00'),
	(9, 7, 2, '2015-04-01', '02:12:00'),
	(9, 7, 2, '2015-04-01', '02:49:00'),
	(9, 7, 2, '2015-04-01', '03:36:00'),
	(9, 7, 2, '2015-04-01', '03:17:00'),
	(9, 7, 2, '2015-04-01', '01:43:00'),
	(9, 7, 2, '2015-04-01', '02:03:00'),
	(9, 7, 2, '2015-04-01', '03:38:00'),
	(9, 7, 2, '2015-04-01', '03:20:00'),
	(9, 7, 2, '2015-04-01', '01:53:00'),
	(9, 7, 2, '2015-04-01', '02:42:00'),
	(9, 7, 2, '2015-04-01', '01:34:00'),
	(9, 7, 2, '2015-04-01', '03:01:00'),
	(9, 7, 2, '2015-04-01', '01:45:00'),
	(9, 7, 2, '2015-04-01', '02:58:00'),
	(9, 7, 2, '2015-04-01', '03:21:00'),
	(9, 7, 2, '2015-04-01', '01:34:00'),
	(9, 7, 2, '2015-04-01', '03:27:00'),
	(9, 7, 2, '2015-04-01', '01:33:00'),
	(9, 7, 2, '2015-04-01', '03:01:00'),
	(9, 7, 2, '2015-04-01', '01:51:00'),
	(9, 7, 2, '2015-04-01', '03:25:00'),
	(9, 7, 2, '2015-04-01', '02:55:00'),
	(9, 7, 2, '2015-04-01', '02:50:00'),
	(9, 7, 2, '2015-04-01', '01:33:00'),
	(9, 7, 2, '2015-04-01', '02:32:00'),
	(9, 7, 2, '2015-04-01', '01:43:00'),
	(9, 7, 2, '2015-04-01', '01:54:00'),
	(9, 7, 2, '2015-04-01', '02:51:00'),
	(9, 7, 2, '2015-04-01', '02:20:00'),
	(9, 7, 2, '2015-04-01', '01:34:00'),
	(9, 7, 2, '2015-04-01', '01:45:00'),
	(9, 7, 2, '2015-04-01', '02:35:00'),
	(9, 7, 2, '2015-04-01', '03:47:00'),
	(9, 7, 2, '2015-04-01', '02:31:00'),
	(9, 7, 2, '2015-04-01', '02:06:00'),
	(9, 7, 2, '2015-04-01', '01:30:00'),
	(9, 7, 2, '2015-04-01', '02:03:00'),
	(9, 7, 2, '2015-04-01', '01:55:00'),
	(9, 7, 2, '2015-04-01', '01:54:00'),
	(9, 7, 2, '2015-04-01', '02:16:00'),
	(9, 7, 2, '2015-04-01', '01:46:00'),
	(9, 7, 2, '2015-04-01', '02:57:00'),
	(9, 7, 2, '2015-04-01', '03:12:00'),
	(9, 7, 2, '2015-04-01', '03:14:00'),
	(9, 7, 2, '2015-04-01', '02:42:00'),
	(9, 7, 2, '2015-04-01', '02:18:00'),
	(9, 7, 2, '2015-04-01', '01:54:00'),
	(9, 7, 2, '2015-04-01', '03:28:00'),
	(9, 7, 2, '2015-04-01', '03:02:00'),
	(9, 7, 2, '2015-04-01', '03:18:00'),
	(9, 7, 2, '2015-04-01', '03:30:00'),
	(9, 7, 2, '2015-04-01', '03:42:00'),
	(9, 7, 2, '2015-04-01', '01:45:00'),
	(9, 7, 2, '2015-04-01', '03:19:00'),
	(9, 8, 3, '2015-04-01', '01:57:00'),
	(9, 8, 3, '2015-04-01', '02:41:00'),
	(9, 8, 3, '2015-04-01', '01:43:00'),
	(9, 8, 3, '2015-04-01', '03:24:00'),
	(9, 8, 3, '2015-04-01', '01:41:00'),
	(9, 8, 3, '2015-04-01', '03:13:00'),
	(9, 8, 3, '2015-04-01', '03:03:00'),
	(9, 8, 3, '2015-04-01', '01:55:00'),
	(9, 8, 3, '2015-04-01', '03:17:00'),
	(9, 8, 3, '2015-04-01', '02:41:00'),
	(9, 8, 3, '2015-04-01', '02:03:00'),
	(9, 8, 3, '2015-04-01', '02:53:00'),
	(9, 8, 3, '2015-04-01', '02:29:00'),
	(9, 8, 3, '2015-04-01', '02:13:00'),
	(9, 8, 3, '2015-04-01', '02:10:00'),
	(9, 8, 3, '2015-04-01', '02:39:00'),
	(9, 8, 3, '2015-04-01', '03:09:00'),
	(9, 8, 3, '2015-04-01', '01:55:00'),
	(9, 8, 3, '2015-04-01', '03:02:00'),
	(9, 8, 3, '2015-04-01', '03:34:00'),
	(9, 8, 3, '2015-04-01', '02:53:00'),
	(9, 8, 3, '2015-04-01', '02:14:00'),
	(9, 8, 3, '2015-04-01', '03:13:00'),
	(9, 8, 3, '2015-04-01', '03:33:00'),
	(9, 8, 3, '2015-04-01', '02:16:00'),
	(9, 8, 3, '2015-04-01', '03:34:00'),
	(9, 8, 3, '2015-04-01', '03:00:00'),
	(9, 8, 3, '2015-04-01', '02:48:00'),
	(9, 8, 3, '2015-04-01', '03:30:00'),
	(9, 8, 3, '2015-04-01', '03:17:00'),
	(9, 8, 3, '2015-04-01', '02:15:00'),
	(9, 8, 3, '2015-04-01', '02:07:00'),
	(9, 8, 3, '2015-04-01', '02:19:00'),
	(9, 8, 3, '2015-04-01', '01:34:00'),
	(9, 8, 3, '2015-04-01', '01:33:00'),
	(9, 8, 3, '2015-04-01', '01:35:00'),
	(9, 8, 3, '2015-04-01', '01:46:00'),
	(9, 8, 3, '2015-04-01', '02:36:00'),
	(9, 8, 3, '2015-04-01', '01:52:00'),
	(9, 8, 3, '2015-04-01', '02:14:00'),
	(9, 8, 3, '2015-04-01', '01:52:00'),
	(9, 8, 3, '2015-04-01', '03:20:00'),
	(9, 8, 3, '2015-04-01', '03:03:00'),
	(9, 8, 3, '2015-04-01', '01:36:00'),
	(9, 8, 3, '2015-04-01', '01:42:00'),
	(9, 8, 3, '2015-04-01', '02:14:00'),
	(9, 8, 3, '2015-04-01', '02:22:00'),
	(9, 8, 3, '2015-04-01', '01:31:00'),
	(9, 8, 3, '2015-04-01', '03:18:00'),
	(9, 8, 3, '2015-04-01', '01:48:00'),
	(9, 8, 3, '2015-04-01', '01:55:00'),
	(9, 8, 3, '2015-04-01', '02:42:00'),
	(9, 8, 3, '2015-04-01', '01:56:00'),
	(9, 8, 3, '2015-04-01', '02:13:00'),
	(9, 8, 3, '2015-04-01', '01:38:00'),
	(9, 8, 3, '2015-04-01', '02:12:00'),
	(9, 8, 3, '2015-04-01', '02:28:00'),
	(9, 8, 3, '2015-04-01', '02:02:00'),
	(9, 8, 3, '2015-04-01', '03:25:00'),
	(9, 8, 3, '2015-04-01', '03:03:00'),
	(9, 9, 4, '2015-04-01', '02:39:00'),
	(9, 9, 4, '2015-04-01', '02:55:00'),
	(9, 9, 4, '2015-04-01', '02:42:00'),
	(9, 9, 4, '2015-04-01', '03:17:00'),
	(9, 9, 4, '2015-04-01', '01:56:00'),
	(9, 9, 4, '2015-04-01', '03:12:00'),
	(9, 9, 4, '2015-04-01', '03:51:00'),
	(9, 9, 4, '2015-04-01', '03:13:00'),
	(9, 9, 4, '2015-04-01', '03:02:00'),
	(9, 9, 4, '2015-04-01', '01:36:00'),
	(9, 9, 4, '2015-04-01', '02:16:00'),
	(9, 9, 4, '2015-04-01', '02:39:00'),
	(9, 9, 4, '2015-04-01', '02:28:00'),
	(9, 9, 4, '2015-04-01', '02:52:00'),
	(9, 9, 4, '2015-04-01', '03:02:00'),
	(9, 9, 4, '2015-04-01', '02:36:00'),
	(9, 9, 4, '2015-04-01', '02:25:00'),
	(9, 9, 4, '2015-04-01', '02:46:00'),
	(9, 9, 4, '2015-04-01', '02:38:00'),
	(9, 9, 4, '2015-04-01', '03:24:00'),
	(9, 9, 4, '2015-04-01', '02:41:00'),
	(9, 9, 4, '2015-04-01', '01:46:00'),
	(9, 9, 4, '2015-04-01', '01:44:00'),
	(9, 9, 4, '2015-04-01', '01:53:00'),
	(9, 9, 4, '2015-04-01', '02:44:00'),
	(9, 9, 4, '2015-04-01', '01:36:00'),
	(9, 9, 4, '2015-04-01', '03:13:00'),
	(9, 9, 4, '2015-04-01', '02:26:00'),
	(9, 9, 4, '2015-04-01', '03:29:00'),
	(9, 9, 4, '2015-04-01', '03:43:00'),
	(9, 9, 4, '2015-04-01', '01:44:00'),
	(9, 9, 4, '2015-04-01', '03:24:00'),
	(9, 9, 4, '2015-04-01', '02:58:00'),
	(9, 9, 4, '2015-04-01', '03:09:00'),
	(9, 9, 4, '2015-04-01', '02:52:00'),
	(9, 9, 4, '2015-04-01', '03:24:00'),
	(9, 9, 4, '2015-04-01', '02:02:00'),
	(9, 9, 4, '2015-04-01', '03:20:00'),
	(9, 9, 4, '2015-04-01', '01:44:00'),
	(9, 9, 4, '2015-04-01', '02:05:00'),
	(9, 9, 4, '2015-04-01', '03:42:00'),
	(9, 9, 4, '2015-04-01', '03:27:00'),
	(9, 9, 4, '2015-04-01', '02:12:00'),
	(9, 9, 4, '2015-04-01', '01:37:00'),
	(9, 9, 4, '2015-04-01', '02:27:00'),
	(9, 9, 4, '2015-04-01', '03:28:00'),
	(9, 9, 4, '2015-04-01', '03:34:00'),
	(9, 9, 4, '2015-04-01', '03:30:00'),
	(9, 9, 4, '2015-04-01', '02:52:00'),
	(9, 9, 4, '2015-04-01', '02:19:00'),
	(9, 9, 4, '2015-04-01', '01:31:00'),
	(9, 9, 4, '2015-04-01', '01:37:00'),
	(9, 9, 4, '2015-04-01', '02:01:00'),
	(9, 9, 4, '2015-04-01', '03:44:00'),
	(9, 9, 4, '2015-04-01', '03:46:00'),
	(9, 9, 4, '2015-04-01', '03:42:00'),
	(9, 9, 4, '2015-04-01', '03:16:00'),
	(9, 9, 4, '2015-04-01', '03:43:00'),
	(9, 9, 4, '2015-04-01', '02:25:00'),
	(9, 9, 4, '2015-04-01', '01:51:00'),
	(9, 10, 5, '2015-04-01', '02:57:00'),
	(9, 10, 5, '2015-04-01', '02:24:00'),
	(9, 10, 5, '2015-04-01', '01:41:00'),
	(9, 10, 5, '2015-04-01', '01:58:00'),
	(9, 10, 5, '2015-04-01', '03:16:00'),
	(9, 10, 5, '2015-04-01', '02:17:00'),
	(9, 10, 5, '2015-04-01', '02:18:00'),
	(9, 10, 5, '2015-04-01', '03:11:00'),
	(9, 10, 5, '2015-04-01', '03:03:00'),
	(9, 10, 5, '2015-04-01', '01:58:00'),
	(9, 10, 5, '2015-04-01', '03:40:00'),
	(9, 10, 5, '2015-04-01', '02:01:00'),
	(9, 10, 5, '2015-04-01', '02:03:00'),
	(9, 10, 5, '2015-04-01', '02:44:00'),
	(9, 10, 5, '2015-04-01', '01:34:00'),
	(9, 10, 5, '2015-04-01', '02:34:00'),
	(9, 10, 5, '2015-04-01', '02:10:00'),
	(9, 10, 5, '2015-04-01', '01:40:00'),
	(9, 10, 5, '2015-04-01', '02:36:00'),
	(9, 10, 5, '2015-04-01', '02:02:00'),
	(9, 10, 5, '2015-04-01', '03:06:00'),
	(9, 10, 5, '2015-04-01', '03:27:00'),
	(9, 10, 5, '2015-04-01', '01:59:00'),
	(9, 10, 5, '2015-04-01', '02:34:00'),
	(9, 10, 5, '2015-04-01', '03:08:00'),
	(9, 10, 5, '2015-04-01', '02:02:00'),
	(9, 10, 5, '2015-04-01', '03:42:00'),
	(9, 10, 5, '2015-04-01', '02:01:00'),
	(9, 10, 5, '2015-04-01', '01:56:00'),
	(9, 10, 5, '2015-04-01', '02:10:00'),
	(9, 10, 5, '2015-04-01', '03:29:00'),
	(9, 10, 5, '2015-04-01', '02:46:00'),
	(9, 10, 5, '2015-04-01', '01:51:00'),
	(9, 10, 5, '2015-04-01', '01:41:00'),
	(9, 10, 5, '2015-04-01', '03:39:00'),
	(9, 10, 5, '2015-04-01', '02:45:00'),
	(9, 10, 5, '2015-04-01', '03:33:00'),
	(9, 10, 5, '2015-04-01', '03:31:00'),
	(9, 10, 5, '2015-04-01', '03:14:00'),
	(9, 10, 5, '2015-04-01', '01:55:00'),
	(9, 10, 5, '2015-04-01', '02:50:00'),
	(9, 10, 5, '2015-04-01', '02:29:00'),
	(9, 10, 5, '2015-04-01', '02:25:00'),
	(9, 10, 5, '2015-04-01', '03:08:00'),
	(9, 10, 5, '2015-04-01', '02:27:00'),
	(9, 10, 5, '2015-04-01', '03:37:00'),
	(9, 10, 5, '2015-04-01', '02:32:00'),
	(9, 10, 5, '2015-04-01', '02:32:00'),
	(9, 10, 5, '2015-04-01', '03:35:00'),
	(9, 10, 5, '2015-04-01', '02:06:00'),
	(9, 10, 5, '2015-04-01', '02:46:00'),
	(9, 10, 5, '2015-04-01', '01:35:00'),
	(9, 10, 5, '2015-04-01', '02:34:00'),
	(9, 10, 5, '2015-04-01', '02:09:00'),
	(9, 10, 5, '2015-04-01', '01:31:00'),
	(9, 10, 5, '2015-04-01', '01:53:00'),
	(9, 10, 5, '2015-04-01', '03:23:00'),
	(9, 10, 5, '2015-04-01', '03:03:00'),
	(9, 10, 5, '2015-04-01', '03:39:00'),
	(9, 10, 5, '2015-04-01', '03:06:00'),
	(3, 6, 1, '2014-01-15', '03:11:00'),
	(3, 6, 1, '2014-01-15', '01:57:00'),
	(3, 6, 1, '2014-01-15', '02:46:00'),
	(3, 6, 1, '2014-01-15', '02:25:00'),
	(3, 6, 1, '2014-01-15', '02:17:00'),
	(3, 6, 1, '2014-01-15', '02:39:00'),
	(3, 6, 1, '2014-01-15', '02:56:00'),
	(3, 6, 1, '2014-01-15', '03:11:00'),
	(3, 6, 1, '2014-01-15', '01:32:00'),
	(3, 6, 1, '2014-01-15', '02:43:00'),
	(3, 6, 1, '2014-01-15', '03:27:00'),
	(3, 6, 1, '2014-01-15', '01:30:00'),
	(3, 6, 1, '2014-01-15', '01:47:00'),
	(3, 6, 1, '2014-01-15', '02:53:00'),
	(3, 6, 1, '2014-01-15', '01:30:00'),
	(3, 6, 1, '2014-01-15', '03:28:00'),
	(3, 6, 1, '2014-01-15', '03:12:00'),
	(3, 6, 1, '2014-01-15', '02:05:00'),
	(3, 6, 1, '2014-01-15', '03:25:00'),
	(3, 6, 1, '2014-01-15', '03:13:00'),
	(3, 6, 1, '2014-01-15', '02:20:00'),
	(3, 6, 1, '2014-01-15', '02:34:00'),
	(3, 6, 1, '2014-01-15', '02:16:00'),
	(3, 6, 1, '2014-01-15', '02:12:00'),
	(3, 6, 1, '2014-01-15', '02:39:00'),
	(3, 6, 1, '2014-01-15', '03:10:00'),
	(3, 6, 1, '2014-01-15', '02:20:00'),
	(3, 6, 1, '2014-01-15', '02:42:00'),
	(3, 6, 1, '2014-01-15', '02:58:00'),
	(3, 6, 1, '2014-01-15', '03:11:00'),
	(3, 6, 1, '2014-01-15', '03:31:00'),
	(3, 6, 1, '2014-01-15', '02:28:00'),
	(3, 6, 1, '2014-01-15', '02:18:00'),
	(3, 6, 1, '2014-01-15', '02:37:00'),
	(3, 6, 1, '2014-01-15', '02:40:00'),
	(3, 6, 1, '2014-01-15', '01:57:00'),
	(3, 6, 1, '2014-01-15', '02:20:00'),
	(3, 6, 1, '2014-01-15', '02:16:00'),
	(3, 6, 1, '2014-01-15', '02:50:00'),
	(3, 6, 1, '2014-01-15', '01:49:00'),
	(3, 6, 1, '2014-01-15', '03:10:00'),
	(3, 6, 1, '2014-01-15', '02:49:00'),
	(3, 6, 1, '2014-01-15', '03:03:00'),
	(3, 6, 1, '2014-01-15', '03:18:00'),
	(3, 6, 1, '2014-01-15', '01:46:00'),
	(3, 6, 1, '2014-01-15', '01:32:00'),
	(3, 6, 1, '2014-01-15', '02:52:00'),
	(3, 6, 1, '2014-01-15', '02:10:00'),
	(3, 6, 1, '2014-01-15', '02:48:00'),
	(3, 6, 1, '2014-01-15', '01:56:00'),
	(3, 6, 1, '2014-01-15', '01:49:00'),
	(3, 6, 1, '2014-01-15', '01:47:00'),
	(3, 6, 1, '2014-01-15', '01:57:00'),
	(3, 6, 1, '2014-01-15', '02:56:00'),
	(3, 6, 1, '2014-01-15', '03:14:00'),
	(3, 6, 1, '2014-01-15', '01:48:00'),
	(3, 6, 1, '2014-01-15', '01:54:00'),
	(3, 6, 1, '2014-01-15', '02:35:00'),
	(3, 6, 1, '2014-01-15', '01:39:00'),
	(3, 6, 1, '2014-01-15', '03:06:00'),
	(3, 7, 2, '2014-01-15', '02:02:00'),
	(3, 7, 2, '2014-01-15', '01:32:00'),
	(3, 7, 2, '2014-01-15', '02:21:00'),
	(3, 7, 2, '2014-01-15', '03:20:00'),
	(3, 7, 2, '2014-01-15', '03:34:00'),
	(3, 7, 2, '2014-01-15', '01:43:00'),
	(3, 7, 2, '2014-01-15', '03:20:00'),
	(3, 7, 2, '2014-01-15', '03:04:00'),
	(3, 7, 2, '2014-01-15', '01:36:00'),
	(3, 7, 2, '2014-01-15', '01:51:00'),
	(3, 7, 2, '2014-01-15', '02:59:00'),
	(3, 7, 2, '2014-01-15', '03:15:00'),
	(3, 7, 2, '2014-01-15', '03:34:00'),
	(3, 7, 2, '2014-01-15', '01:56:00'),
	(3, 7, 2, '2014-01-15', '02:04:00'),
	(3, 7, 2, '2014-01-15', '03:05:00'),
	(3, 7, 2, '2014-01-15', '03:09:00'),
	(3, 7, 2, '2014-01-15', '02:39:00'),
	(3, 7, 2, '2014-01-15', '02:20:00'),
	(3, 7, 2, '2014-01-15', '02:12:00'),
	(3, 7, 2, '2014-01-15', '02:32:00'),
	(3, 7, 2, '2014-01-15', '02:16:00'),
	(3, 7, 2, '2014-01-15', '02:17:00'),
	(3, 7, 2, '2014-01-15', '03:04:00'),
	(3, 7, 2, '2014-01-15', '02:23:00'),
	(3, 7, 2, '2014-01-15', '03:35:00'),
	(3, 7, 2, '2014-01-15', '02:20:00'),
	(3, 7, 2, '2014-01-15', '01:43:00'),
	(3, 7, 2, '2014-01-15', '02:25:00'),
	(3, 7, 2, '2014-01-15', '03:07:00'),
	(3, 7, 2, '2014-01-15', '02:14:00'),
	(3, 7, 2, '2014-01-15', '02:40:00'),
	(3, 7, 2, '2014-01-15', '02:47:00'),
	(3, 7, 2, '2014-01-15', '02:11:00'),
	(3, 7, 2, '2014-01-15', '03:21:00'),
	(3, 7, 2, '2014-01-15', '01:50:00'),
	(3, 7, 2, '2014-01-15', '02:15:00'),
	(3, 7, 2, '2014-01-15', '01:54:00'),
	(3, 7, 2, '2014-01-15', '03:37:00'),
	(3, 7, 2, '2014-01-15', '01:38:00'),
	(3, 7, 2, '2014-01-15', '02:47:00'),
	(3, 7, 2, '2014-01-15', '02:54:00'),
	(3, 7, 2, '2014-01-15', '02:21:00'),
	(3, 7, 2, '2014-01-15', '01:35:00'),
	(3, 7, 2, '2014-01-15', '01:41:00'),
	(3, 7, 2, '2014-01-15', '02:10:00'),
	(3, 7, 2, '2014-01-15', '01:59:00'),
	(3, 7, 2, '2014-01-15', '01:54:00'),
	(3, 7, 2, '2014-01-15', '02:05:00'),
	(3, 7, 2, '2014-01-15', '03:13:00'),
	(3, 7, 2, '2014-01-15', '03:45:00'),
	(3, 7, 2, '2014-01-15', '03:01:00'),
	(3, 7, 2, '2014-01-15', '02:19:00'),
	(3, 7, 2, '2014-01-15', '03:21:00'),
	(3, 7, 2, '2014-01-15', '03:41:00'),
	(3, 7, 2, '2014-01-15', '02:16:00'),
	(3, 7, 2, '2014-01-15', '03:23:00'),
	(3, 7, 2, '2014-01-15', '01:44:00'),
	(3, 7, 2, '2014-01-15', '01:37:00'),
	(3, 7, 2, '2014-01-15', '03:43:00'),
	(3, 8, 3, '2014-01-15', '02:28:00'),
	(3, 8, 3, '2014-01-15', '01:52:00'),
	(3, 8, 3, '2014-01-15', '02:39:00'),
	(3, 8, 3, '2014-01-15', '01:40:00'),
	(3, 8, 3, '2014-01-15', '03:27:00'),
	(3, 8, 3, '2014-01-15', '01:39:00'),
	(3, 8, 3, '2014-01-15', '03:13:00'),
	(3, 8, 3, '2014-01-15', '02:49:00'),
	(3, 8, 3, '2014-01-15', '02:59:00'),
	(3, 8, 3, '2014-01-15', '02:39:00'),
	(3, 8, 3, '2014-01-15', '02:52:00'),
	(3, 8, 3, '2014-01-15', '02:38:00'),
	(3, 8, 3, '2014-01-15', '03:02:00'),
	(3, 8, 3, '2014-01-15', '03:31:00'),
	(3, 8, 3, '2014-01-15', '02:29:00'),
	(3, 8, 3, '2014-01-15', '02:37:00'),
	(3, 8, 3, '2014-01-15', '01:51:00'),
	(3, 8, 3, '2014-01-15', '02:13:00'),
	(3, 8, 3, '2014-01-15', '01:46:00'),
	(3, 8, 3, '2014-01-15', '02:57:00'),
	(3, 8, 3, '2014-01-15', '03:26:00'),
	(3, 8, 3, '2014-01-15', '02:19:00'),
	(3, 8, 3, '2014-01-15', '02:02:00'),
	(3, 8, 3, '2014-01-15', '01:46:00'),
	(3, 8, 3, '2014-01-15', '03:28:00'),
	(3, 8, 3, '2014-01-15', '01:30:00'),
	(3, 8, 3, '2014-01-15', '02:22:00'),
	(3, 8, 3, '2014-01-15', '03:36:00'),
	(3, 8, 3, '2014-01-15', '02:37:00'),
	(3, 8, 3, '2014-01-15', '03:03:00'),
	(3, 8, 3, '2014-01-15', '03:40:00'),
	(3, 8, 3, '2014-01-15', '03:08:00'),
	(3, 8, 3, '2014-01-15', '03:10:00'),
	(3, 8, 3, '2014-01-15', '02:39:00'),
	(3, 8, 3, '2014-01-15', '02:19:00'),
	(3, 8, 3, '2014-01-15', '02:07:00'),
	(3, 8, 3, '2014-01-15', '02:08:00'),
	(3, 8, 3, '2014-01-15', '02:49:00'),
	(3, 8, 3, '2014-01-15', '01:38:00'),
	(3, 8, 3, '2014-01-15', '02:49:00'),
	(3, 8, 3, '2014-01-15', '03:06:00'),
	(3, 8, 3, '2014-01-15', '03:20:00'),
	(3, 8, 3, '2014-01-15', '03:35:00'),
	(3, 8, 3, '2014-01-15', '01:56:00'),
	(3, 8, 3, '2014-01-15', '01:55:00'),
	(3, 8, 3, '2014-01-15', '02:19:00'),
	(3, 8, 3, '2014-01-15', '02:02:00'),
	(3, 8, 3, '2014-01-15', '01:45:00'),
	(3, 8, 3, '2014-01-15', '03:25:00'),
	(3, 8, 3, '2014-01-15', '03:31:00'),
	(3, 8, 3, '2014-01-15', '03:35:00'),
	(3, 8, 3, '2014-01-15', '03:38:00'),
	(3, 8, 3, '2014-01-15', '03:37:00'),
	(3, 8, 3, '2014-01-15', '03:26:00'),
	(3, 8, 3, '2014-01-15', '02:36:00'),
	(3, 8, 3, '2014-01-15', '03:26:00'),
	(3, 8, 3, '2014-01-15', '03:23:00'),
	(3, 8, 3, '2014-01-15', '02:48:00'),
	(3, 8, 3, '2014-01-15', '02:24:00'),
	(3, 8, 3, '2014-01-15', '02:08:00'),
	(3, 9, 4, '2014-01-15', '01:41:00'),
	(3, 9, 4, '2014-01-15', '03:20:00'),
	(3, 9, 4, '2014-01-15', '02:17:00'),
	(3, 9, 4, '2014-01-15', '01:55:00'),
	(3, 9, 4, '2014-01-15', '03:12:00'),
	(3, 9, 4, '2014-01-15', '02:53:00'),
	(3, 9, 4, '2014-01-15', '03:21:00'),
	(3, 9, 4, '2014-01-15', '02:42:00'),
	(3, 9, 4, '2014-01-15', '01:56:00'),
	(3, 9, 4, '2014-01-15', '02:00:00'),
	(3, 9, 4, '2014-01-15', '02:46:00'),
	(3, 9, 4, '2014-01-15', '02:25:00'),
	(3, 9, 4, '2014-01-15', '02:17:00'),
	(3, 9, 4, '2014-01-15', '02:40:00'),
	(3, 9, 4, '2014-01-15', '03:02:00'),
	(3, 9, 4, '2014-01-15', '01:49:00'),
	(3, 9, 4, '2014-01-15', '02:22:00'),
	(3, 9, 4, '2014-01-15', '02:57:00'),
	(3, 9, 4, '2014-01-15', '02:13:00'),
	(3, 9, 4, '2014-01-15', '02:44:00'),
	(3, 9, 4, '2014-01-15', '01:38:00'),
	(3, 9, 4, '2014-01-15', '02:20:00'),
	(3, 9, 4, '2014-01-15', '03:20:00'),
	(3, 9, 4, '2014-01-15', '02:19:00'),
	(3, 9, 4, '2014-01-15', '02:05:00'),
	(3, 9, 4, '2014-01-15', '01:55:00'),
	(3, 9, 4, '2014-01-15', '01:54:00'),
	(3, 9, 4, '2014-01-15', '02:13:00'),
	(3, 9, 4, '2014-01-15', '01:59:00'),
	(3, 9, 4, '2014-01-15', '01:45:00'),
	(3, 9, 4, '2014-01-15', '03:15:00'),
	(3, 9, 4, '2014-01-15', '01:43:00'),
	(3, 9, 4, '2014-01-15', '03:10:00'),
	(3, 9, 4, '2014-01-15', '03:21:00'),
	(3, 9, 4, '2014-01-15', '01:53:00'),
	(3, 9, 4, '2014-01-15', '01:44:00'),
	(3, 9, 4, '2014-01-15', '01:35:00'),
	(3, 9, 4, '2014-01-15', '03:07:00'),
	(3, 9, 4, '2014-01-15', '01:34:00'),
	(3, 9, 4, '2014-01-15', '02:50:00'),
	(3, 9, 4, '2014-01-15', '02:07:00'),
	(3, 9, 4, '2014-01-15', '02:33:00'),
	(3, 9, 4, '2014-01-15', '02:58:00'),
	(3, 9, 4, '2014-01-15', '01:47:00'),
	(3, 9, 4, '2014-01-15', '02:27:00'),
	(3, 9, 4, '2014-01-15', '01:30:00'),
	(3, 9, 4, '2014-01-15', '02:33:00'),
	(3, 9, 4, '2014-01-15', '02:52:00'),
	(3, 9, 4, '2014-01-15', '03:16:00'),
	(3, 9, 4, '2014-01-15', '02:17:00'),
	(3, 9, 4, '2014-01-15', '02:07:00'),
	(3, 9, 4, '2014-01-15', '02:15:00'),
	(3, 9, 4, '2014-01-15', '03:24:00'),
	(3, 9, 4, '2014-01-15', '02:56:00'),
	(3, 9, 4, '2014-01-15', '02:58:00'),
	(3, 9, 4, '2014-01-15', '02:34:00'),
	(3, 9, 4, '2014-01-15', '02:29:00'),
	(3, 9, 4, '2014-01-15', '03:12:00'),
	(3, 9, 4, '2014-01-15', '03:10:00'),
	(3, 9, 4, '2014-01-15', '02:47:00'),
	(3, 10, 5, '2014-01-15', '02:56:00'),
	(3, 10, 5, '2014-01-15', '03:46:00'),
	(3, 10, 5, '2014-01-15', '01:36:00'),
	(3, 10, 5, '2014-01-15', '02:08:00'),
	(3, 10, 5, '2014-01-15', '02:03:00'),
	(3, 10, 5, '2014-01-15', '02:22:00'),
	(3, 10, 5, '2014-01-15', '01:53:00'),
	(3, 10, 5, '2014-01-15', '03:07:00'),
	(3, 10, 5, '2014-01-15', '01:33:00'),
	(3, 10, 5, '2014-01-15', '03:47:00'),
	(3, 10, 5, '2014-01-15', '03:35:00'),
	(3, 10, 5, '2014-01-15', '02:49:00'),
	(3, 10, 5, '2014-01-15', '01:49:00'),
	(3, 10, 5, '2014-01-15', '03:43:00'),
	(3, 10, 5, '2014-01-15', '02:28:00'),
	(3, 10, 5, '2014-01-15', '02:00:00'),
	(3, 10, 5, '2014-01-15', '03:23:00'),
	(3, 10, 5, '2014-01-15', '02:33:00'),
	(3, 10, 5, '2014-01-15', '03:24:00'),
	(3, 10, 5, '2014-01-15', '03:15:00'),
	(3, 10, 5, '2014-01-15', '02:16:00'),
	(3, 10, 5, '2014-01-15', '02:23:00'),
	(3, 10, 5, '2014-01-15', '03:37:00'),
	(3, 10, 5, '2014-01-15', '02:35:00'),
	(3, 10, 5, '2014-01-15', '02:50:00'),
	(3, 10, 5, '2014-01-15', '02:39:00'),
	(3, 10, 5, '2014-01-15', '03:16:00'),
	(3, 10, 5, '2014-01-15', '02:19:00'),
	(3, 10, 5, '2014-01-15', '02:33:00'),
	(3, 10, 5, '2014-01-15', '02:02:00'),
	(3, 10, 5, '2014-01-15', '03:18:00'),
	(3, 10, 5, '2014-01-15', '02:00:00'),
	(3, 10, 5, '2014-01-15', '03:14:00'),
	(3, 10, 5, '2014-01-15', '01:44:00'),
	(3, 10, 5, '2014-01-15', '02:08:00'),
	(3, 10, 5, '2014-01-15', '01:39:00'),
	(3, 10, 5, '2014-01-15', '02:39:00'),
	(3, 10, 5, '2014-01-15', '02:14:00'),
	(3, 10, 5, '2014-01-15', '01:43:00'),
	(3, 10, 5, '2014-01-15', '02:42:00'),
	(3, 10, 5, '2014-01-15', '02:14:00'),
	(3, 10, 5, '2014-01-15', '01:33:00'),
	(3, 10, 5, '2014-01-15', '01:54:00'),
	(3, 10, 5, '2014-01-15', '03:23:00'),
	(3, 10, 5, '2014-01-15', '02:46:00'),
	(3, 10, 5, '2014-01-15', '02:12:00'),
	(3, 10, 5, '2014-01-15', '03:32:00'),
	(3, 10, 5, '2014-01-15', '02:42:00'),
	(3, 10, 5, '2014-01-15', '03:39:00'),
	(3, 10, 5, '2014-01-15', '01:48:00'),
	(3, 10, 5, '2014-01-15', '03:26:00'),
	(3, 10, 5, '2014-01-15', '03:23:00'),
	(3, 10, 5, '2014-01-15', '02:49:00'),
	(3, 10, 5, '2014-01-15', '02:26:00'),
	(3, 10, 5, '2014-01-15', '02:14:00'),
	(3, 10, 5, '2014-01-15', '02:24:00'),
	(3, 10, 5, '2014-01-15', '03:47:00'),
	(3, 10, 5, '2014-01-15', '03:19:00'),
	(3, 10, 5, '2014-01-15', '03:45:00'),
	(3, 10, 5, '2014-01-15', '02:44:00'),
	(4, 6, 1, '2014-02-01', '01:47:00'),
	(4, 6, 1, '2014-02-01', '02:22:00'),
	(4, 6, 1, '2014-02-01', '02:42:00'),
	(4, 6, 1, '2014-02-01', '02:35:00'),
	(4, 6, 1, '2014-02-01', '03:21:00'),
	(4, 6, 1, '2014-02-01', '02:50:00'),
	(4, 6, 1, '2014-02-01', '02:38:00'),
	(4, 6, 1, '2014-02-01', '03:13:00'),
	(4, 6, 1, '2014-02-01', '02:01:00'),
	(4, 6, 1, '2014-02-01', '03:35:00'),
	(4, 6, 1, '2014-02-01', '03:26:00'),
	(4, 6, 1, '2014-02-01', '02:35:00'),
	(4, 6, 1, '2014-02-01', '03:27:00'),
	(4, 6, 1, '2014-02-01', '03:22:00'),
	(4, 6, 1, '2014-02-01', '02:42:00'),
	(4, 6, 1, '2014-02-01', '01:55:00'),
	(4, 6, 1, '2014-02-01', '02:20:00'),
	(4, 6, 1, '2014-02-01', '02:03:00'),
	(4, 6, 1, '2014-02-01', '01:46:00'),
	(4, 6, 1, '2014-02-01', '03:32:00'),
	(4, 6, 1, '2014-02-01', '01:38:00'),
	(4, 6, 1, '2014-02-01', '02:59:00'),
	(4, 6, 1, '2014-02-01', '01:36:00'),
	(4, 6, 1, '2014-02-01', '02:11:00'),
	(4, 6, 1, '2014-02-01', '02:16:00'),
	(4, 6, 1, '2014-02-01', '03:21:00'),
	(4, 6, 1, '2014-02-01', '03:47:00'),
	(4, 6, 1, '2014-02-01', '02:45:00'),
	(4, 6, 1, '2014-02-01', '03:13:00'),
	(4, 6, 1, '2014-02-01', '01:42:00'),
	(4, 6, 1, '2014-02-01', '01:59:00'),
	(4, 6, 1, '2014-02-01', '03:20:00'),
	(4, 6, 1, '2014-02-01', '02:15:00'),
	(4, 6, 1, '2014-02-01', '02:07:00'),
	(4, 6, 1, '2014-02-01', '02:21:00'),
	(4, 6, 1, '2014-02-01', '01:36:00'),
	(4, 6, 1, '2014-02-01', '01:45:00'),
	(4, 6, 1, '2014-02-01', '02:29:00'),
	(4, 6, 1, '2014-02-01', '03:22:00'),
	(4, 6, 1, '2014-02-01', '03:13:00'),
	(4, 6, 1, '2014-02-01', '02:10:00'),
	(4, 6, 1, '2014-02-01', '02:01:00'),
	(4, 6, 1, '2014-02-01', '02:07:00'),
	(4, 6, 1, '2014-02-01', '03:04:00'),
	(4, 6, 1, '2014-02-01', '02:49:00'),
	(4, 6, 1, '2014-02-01', '03:23:00'),
	(4, 6, 1, '2014-02-01', '02:21:00'),
	(4, 6, 1, '2014-02-01', '02:25:00'),
	(4, 6, 1, '2014-02-01', '03:34:00'),
	(4, 6, 1, '2014-02-01', '02:07:00'),
	(4, 6, 1, '2014-02-01', '03:03:00'),
	(4, 6, 1, '2014-02-01', '02:47:00'),
	(4, 6, 1, '2014-02-01', '03:17:00'),
	(4, 6, 1, '2014-02-01', '01:58:00'),
	(4, 6, 1, '2014-02-01', '03:04:00'),
	(4, 6, 1, '2014-02-01', '03:19:00'),
	(4, 6, 1, '2014-02-01', '03:36:00'),
	(4, 6, 1, '2014-02-01', '01:57:00'),
	(4, 6, 1, '2014-02-01', '02:02:00'),
	(4, 6, 1, '2014-02-01', '02:53:00'),
	(4, 7, 2, '2014-02-01', '02:47:00'),
	(4, 7, 2, '2014-02-01', '02:09:00'),
	(4, 7, 2, '2014-02-01', '02:59:00'),
	(4, 7, 2, '2014-02-01', '02:53:00'),
	(4, 7, 2, '2014-02-01', '01:59:00'),
	(4, 7, 2, '2014-02-01', '01:47:00'),
	(4, 7, 2, '2014-02-01', '03:30:00'),
	(4, 7, 2, '2014-02-01', '02:35:00'),
	(4, 7, 2, '2014-02-01', '02:55:00'),
	(4, 7, 2, '2014-02-01', '03:19:00'),
	(4, 7, 2, '2014-02-01', '02:21:00'),
	(4, 7, 2, '2014-02-01', '02:21:00'),
	(4, 7, 2, '2014-02-01', '03:09:00'),
	(4, 7, 2, '2014-02-01', '03:14:00'),
	(4, 7, 2, '2014-02-01', '03:10:00'),
	(4, 7, 2, '2014-02-01', '02:37:00'),
	(4, 7, 2, '2014-02-01', '02:05:00'),
	(4, 7, 2, '2014-02-01', '03:07:00'),
	(4, 7, 2, '2014-02-01', '01:49:00'),
	(4, 7, 2, '2014-02-01', '02:16:00'),
	(4, 7, 2, '2014-02-01', '02:21:00'),
	(4, 7, 2, '2014-02-01', '03:29:00'),
	(4, 7, 2, '2014-02-01', '02:51:00'),
	(4, 7, 2, '2014-02-01', '02:16:00'),
	(4, 7, 2, '2014-02-01', '03:20:00'),
	(4, 7, 2, '2014-02-01', '02:20:00'),
	(4, 7, 2, '2014-02-01', '02:09:00'),
	(4, 7, 2, '2014-02-01', '02:18:00'),
	(4, 7, 2, '2014-02-01', '01:34:00'),
	(4, 7, 2, '2014-02-01', '03:26:00'),
	(4, 7, 2, '2014-02-01', '02:53:00'),
	(4, 7, 2, '2014-02-01', '02:40:00'),
	(4, 7, 2, '2014-02-01', '03:12:00'),
	(4, 7, 2, '2014-02-01', '02:26:00'),
	(4, 7, 2, '2014-02-01', '03:06:00'),
	(4, 7, 2, '2014-02-01', '02:39:00'),
	(4, 7, 2, '2014-02-01', '02:29:00'),
	(4, 7, 2, '2014-02-01', '03:00:00'),
	(4, 7, 2, '2014-02-01', '01:58:00'),
	(4, 7, 2, '2014-02-01', '03:26:00'),
	(4, 7, 2, '2014-02-01', '01:39:00'),
	(4, 7, 2, '2014-02-01', '02:34:00'),
	(4, 7, 2, '2014-02-01', '02:18:00'),
	(4, 7, 2, '2014-02-01', '02:20:00'),
	(4, 7, 2, '2014-02-01', '03:18:00'),
	(4, 7, 2, '2014-02-01', '01:55:00'),
	(4, 7, 2, '2014-02-01', '02:15:00'),
	(4, 7, 2, '2014-02-01', '02:00:00'),
	(4, 7, 2, '2014-02-01', '01:43:00'),
	(4, 7, 2, '2014-02-01', '03:10:00'),
	(4, 7, 2, '2014-02-01', '03:07:00'),
	(4, 7, 2, '2014-02-01', '02:33:00'),
	(4, 7, 2, '2014-02-01', '01:54:00'),
	(4, 7, 2, '2014-02-01', '02:22:00'),
	(4, 7, 2, '2014-02-01', '02:40:00'),
	(4, 7, 2, '2014-02-01', '02:41:00'),
	(4, 7, 2, '2014-02-01', '01:54:00'),
	(4, 7, 2, '2014-02-01', '02:00:00'),
	(4, 7, 2, '2014-02-01', '02:49:00'),
	(4, 7, 2, '2014-02-01', '02:32:00'),
	(4, 8, 3, '2014-02-01', '02:41:00'),
	(4, 8, 3, '2014-02-01', '03:21:00'),
	(4, 8, 3, '2014-02-01', '02:42:00'),
	(4, 8, 3, '2014-02-01', '01:56:00'),
	(4, 8, 3, '2014-02-01', '02:22:00'),
	(4, 8, 3, '2014-02-01', '02:18:00'),
	(4, 8, 3, '2014-02-01', '02:55:00'),
	(4, 8, 3, '2014-02-01', '01:45:00'),
	(4, 8, 3, '2014-02-01', '02:56:00'),
	(4, 8, 3, '2014-02-01', '03:28:00'),
	(4, 8, 3, '2014-02-01', '02:36:00'),
	(4, 8, 3, '2014-02-01', '03:22:00'),
	(4, 8, 3, '2014-02-01', '03:01:00'),
	(4, 8, 3, '2014-02-01', '03:31:00'),
	(4, 8, 3, '2014-02-01', '02:33:00'),
	(4, 8, 3, '2014-02-01', '02:57:00'),
	(4, 8, 3, '2014-02-01', '03:22:00'),
	(4, 8, 3, '2014-02-01', '02:00:00'),
	(4, 8, 3, '2014-02-01', '02:56:00'),
	(4, 8, 3, '2014-02-01', '02:40:00'),
	(4, 8, 3, '2014-02-01', '03:01:00'),
	(4, 8, 3, '2014-02-01', '03:24:00'),
	(4, 8, 3, '2014-02-01', '02:01:00'),
	(4, 8, 3, '2014-02-01', '02:50:00'),
	(4, 8, 3, '2014-02-01', '02:07:00'),
	(4, 8, 3, '2014-02-01', '02:53:00'),
	(4, 8, 3, '2014-02-01', '02:05:00'),
	(4, 8, 3, '2014-02-01', '02:31:00'),
	(4, 8, 3, '2014-02-01', '02:35:00'),
	(4, 8, 3, '2014-02-01', '01:38:00'),
	(4, 8, 3, '2014-02-01', '03:22:00'),
	(4, 8, 3, '2014-02-01', '01:34:00'),
	(4, 8, 3, '2014-02-01', '02:55:00'),
	(4, 8, 3, '2014-02-01', '01:40:00'),
	(4, 8, 3, '2014-02-01', '02:36:00'),
	(4, 8, 3, '2014-02-01', '02:00:00'),
	(4, 8, 3, '2014-02-01', '02:56:00'),
	(4, 8, 3, '2014-02-01', '02:43:00'),
	(4, 8, 3, '2014-02-01', '03:19:00'),
	(4, 8, 3, '2014-02-01', '02:28:00'),
	(4, 8, 3, '2014-02-01', '03:05:00'),
	(4, 8, 3, '2014-02-01', '02:07:00'),
	(4, 8, 3, '2014-02-01', '02:01:00'),
	(4, 8, 3, '2014-02-01', '02:17:00'),
	(4, 8, 3, '2014-02-01', '01:38:00'),
	(4, 8, 3, '2014-02-01', '02:03:00'),
	(4, 8, 3, '2014-02-01', '01:36:00'),
	(4, 8, 3, '2014-02-01', '02:37:00'),
	(4, 8, 3, '2014-02-01', '02:21:00'),
	(4, 8, 3, '2014-02-01', '02:25:00'),
	(4, 8, 3, '2014-02-01', '03:32:00'),
	(4, 8, 3, '2014-02-01', '02:11:00'),
	(4, 8, 3, '2014-02-01', '03:20:00'),
	(4, 8, 3, '2014-02-01', '01:55:00'),
	(4, 8, 3, '2014-02-01', '02:31:00'),
	(4, 8, 3, '2014-02-01', '03:10:00'),
	(4, 8, 3, '2014-02-01', '02:18:00'),
	(4, 8, 3, '2014-02-01', '02:45:00'),
	(4, 8, 3, '2014-02-01', '03:06:00'),
	(4, 8, 3, '2014-02-01', '03:33:00'),
	(4, 9, 4, '2014-02-01', '02:31:00'),
	(4, 9, 4, '2014-02-01', '01:38:00'),
	(4, 9, 4, '2014-02-01', '03:24:00'),
	(4, 9, 4, '2014-02-01', '02:03:00'),
	(4, 9, 4, '2014-02-01', '02:51:00'),
	(4, 9, 4, '2014-02-01', '02:19:00'),
	(4, 9, 4, '2014-02-01', '01:33:00'),
	(4, 9, 4, '2014-02-01', '03:32:00'),
	(4, 9, 4, '2014-02-01', '03:03:00'),
	(4, 9, 4, '2014-02-01', '03:08:00'),
	(4, 9, 4, '2014-02-01', '02:52:00'),
	(4, 9, 4, '2014-02-01', '03:27:00'),
	(4, 9, 4, '2014-02-01', '02:52:00'),
	(4, 9, 4, '2014-02-01', '02:32:00'),
	(4, 9, 4, '2014-02-01', '02:35:00'),
	(4, 9, 4, '2014-02-01', '01:41:00'),
	(4, 9, 4, '2014-02-01', '03:26:00'),
	(4, 9, 4, '2014-02-01', '02:05:00'),
	(4, 9, 4, '2014-02-01', '02:52:00'),
	(4, 9, 4, '2014-02-01', '02:22:00'),
	(4, 9, 4, '2014-02-01', '01:46:00'),
	(4, 9, 4, '2014-02-01', '02:19:00'),
	(4, 9, 4, '2014-02-01', '02:41:00'),
	(4, 9, 4, '2014-02-01', '02:51:00'),
	(4, 9, 4, '2014-02-01', '02:33:00'),
	(4, 9, 4, '2014-02-01', '02:44:00'),
	(4, 9, 4, '2014-02-01', '02:21:00'),
	(4, 9, 4, '2014-02-01', '02:06:00'),
	(4, 9, 4, '2014-02-01', '01:58:00'),
	(4, 9, 4, '2014-02-01', '02:02:00'),
	(4, 9, 4, '2014-02-01', '02:47:00'),
	(4, 9, 4, '2014-02-01', '02:03:00'),
	(4, 9, 4, '2014-02-01', '02:31:00'),
	(4, 9, 4, '2014-02-01', '02:50:00'),
	(4, 9, 4, '2014-02-01', '03:01:00'),
	(4, 9, 4, '2014-02-01', '02:56:00'),
	(4, 9, 4, '2014-02-01', '01:58:00'),
	(4, 9, 4, '2014-02-01', '01:40:00'),
	(4, 9, 4, '2014-02-01', '03:05:00'),
	(4, 9, 4, '2014-02-01', '02:33:00'),
	(4, 9, 4, '2014-02-01', '02:01:00'),
	(4, 9, 4, '2014-02-01', '03:05:00'),
	(4, 9, 4, '2014-02-01', '03:34:00'),
	(4, 9, 4, '2014-02-01', '02:49:00'),
	(4, 9, 4, '2014-02-01', '01:53:00'),
	(4, 9, 4, '2014-02-01', '01:39:00'),
	(4, 9, 4, '2014-02-01', '03:15:00'),
	(4, 9, 4, '2014-02-01', '03:21:00'),
	(4, 9, 4, '2014-02-01', '03:26:00'),
	(4, 9, 4, '2014-02-01', '03:28:00'),
	(4, 9, 4, '2014-02-01', '03:26:00'),
	(4, 9, 4, '2014-02-01', '03:09:00'),
	(4, 9, 4, '2014-02-01', '01:49:00'),
	(4, 9, 4, '2014-02-01', '02:24:00'),
	(4, 9, 4, '2014-02-01', '02:55:00'),
	(4, 9, 4, '2014-02-01', '01:38:00'),
	(4, 9, 4, '2014-02-01', '02:13:00'),
	(4, 9, 4, '2014-02-01', '02:34:00'),
	(4, 9, 4, '2014-02-01', '02:32:00'),
	(4, 9, 4, '2014-02-01', '03:30:00'),
	(4, 10, 5, '2014-02-01', '02:12:00'),
	(4, 10, 5, '2014-02-01', '01:39:00'),
	(4, 10, 5, '2014-02-01', '02:10:00'),
	(4, 10, 5, '2014-02-01', '02:23:00'),
	(4, 10, 5, '2014-02-01', '01:59:00'),
	(4, 10, 5, '2014-02-01', '03:13:00'),
	(4, 10, 5, '2014-02-01', '02:41:00'),
	(4, 10, 5, '2014-02-01', '02:17:00'),
	(4, 10, 5, '2014-02-01', '01:52:00'),
	(4, 10, 5, '2014-02-01', '03:00:00'),
	(4, 10, 5, '2014-02-01', '01:56:00'),
	(4, 10, 5, '2014-02-01', '03:11:00'),
	(4, 10, 5, '2014-02-01', '02:40:00'),
	(4, 10, 5, '2014-02-01', '02:16:00'),
	(4, 10, 5, '2014-02-01', '01:50:00'),
	(4, 10, 5, '2014-02-01', '02:54:00'),
	(4, 10, 5, '2014-02-01', '01:31:00'),
	(4, 10, 5, '2014-02-01', '03:22:00'),
	(4, 10, 5, '2014-02-01', '02:50:00'),
	(4, 10, 5, '2014-02-01', '02:36:00'),
	(4, 10, 5, '2014-02-01', '02:58:00'),
	(4, 10, 5, '2014-02-01', '01:37:00'),
	(4, 10, 5, '2014-02-01', '01:38:00'),
	(4, 10, 5, '2014-02-01', '01:52:00'),
	(4, 10, 5, '2014-02-01', '02:54:00'),
	(4, 10, 5, '2014-02-01', '03:28:00'),
	(4, 10, 5, '2014-02-01', '03:11:00'),
	(4, 10, 5, '2014-02-01', '02:00:00'),
	(4, 10, 5, '2014-02-01', '02:57:00'),
	(4, 10, 5, '2014-02-01', '03:17:00'),
	(4, 10, 5, '2014-02-01', '02:05:00'),
	(4, 10, 5, '2014-02-01', '03:04:00'),
	(4, 10, 5, '2014-02-01', '01:36:00'),
	(4, 10, 5, '2014-02-01', '03:19:00'),
	(4, 10, 5, '2014-02-01', '02:19:00'),
	(4, 10, 5, '2014-02-01', '02:09:00'),
	(4, 10, 5, '2014-02-01', '02:18:00'),
	(4, 10, 5, '2014-02-01', '01:36:00'),
	(4, 10, 5, '2014-02-01', '01:33:00'),
	(4, 10, 5, '2014-02-01', '03:26:00'),
	(4, 10, 5, '2014-02-01', '03:08:00'),
	(4, 10, 5, '2014-02-01', '01:54:00'),
	(4, 10, 5, '2014-02-01', '02:35:00'),
	(4, 10, 5, '2014-02-01', '01:43:00'),
	(4, 10, 5, '2014-02-01', '03:21:00'),
	(4, 10, 5, '2014-02-01', '02:09:00'),
	(4, 10, 5, '2014-02-01', '03:11:00'),
	(4, 10, 5, '2014-02-01', '02:02:00'),
	(4, 10, 5, '2014-02-01', '03:04:00'),
	(4, 10, 5, '2014-02-01', '01:47:00'),
	(4, 10, 5, '2014-02-01', '02:13:00'),
	(4, 10, 5, '2014-02-01', '02:16:00'),
	(4, 10, 5, '2014-02-01', '03:09:00'),
	(4, 10, 5, '2014-02-01', '01:32:00'),
	(4, 10, 5, '2014-02-01', '02:40:00'),
	(4, 10, 5, '2014-02-01', '03:15:00'),
	(4, 10, 5, '2014-02-01', '02:49:00'),
	(4, 10, 5, '2014-02-01', '02:49:00'),
	(4, 10, 5, '2014-02-01', '02:12:00'),
	(4, 10, 5, '2014-02-01', '03:00:00'),
	(5, 6, 1, '2014-02-15', '02:27:00'),
	(5, 6, 1, '2014-02-15', '03:27:00'),
	(5, 6, 1, '2014-02-15', '03:45:00'),
	(5, 6, 1, '2014-02-15', '02:20:00'),
	(5, 6, 1, '2014-02-15', '03:30:00'),
	(5, 6, 1, '2014-02-15', '02:06:00'),
	(5, 6, 1, '2014-02-15', '03:07:00'),
	(5, 6, 1, '2014-02-15', '03:11:00'),
	(5, 6, 1, '2014-02-15', '02:46:00'),
	(5, 6, 1, '2014-02-15', '02:48:00'),
	(5, 6, 1, '2014-02-15', '01:54:00'),
	(5, 6, 1, '2014-02-15', '01:53:00'),
	(5, 6, 1, '2014-02-15', '02:13:00'),
	(5, 6, 1, '2014-02-15', '01:38:00'),
	(5, 6, 1, '2014-02-15', '02:22:00'),
	(5, 6, 1, '2014-02-15', '03:07:00'),
	(5, 6, 1, '2014-02-15', '02:23:00'),
	(5, 6, 1, '2014-02-15', '03:23:00'),
	(5, 6, 1, '2014-02-15', '03:38:00'),
	(5, 6, 1, '2014-02-15', '01:51:00'),
	(5, 6, 1, '2014-02-15', '01:33:00'),
	(5, 6, 1, '2014-02-15', '03:00:00'),
	(5, 6, 1, '2014-02-15', '01:56:00'),
	(5, 6, 1, '2014-02-15', '01:31:00'),
	(5, 6, 1, '2014-02-15', '02:33:00'),
	(5, 6, 1, '2014-02-15', '02:04:00'),
	(5, 6, 1, '2014-02-15', '03:33:00'),
	(5, 6, 1, '2014-02-15', '03:07:00'),
	(5, 6, 1, '2014-02-15', '03:25:00'),
	(5, 6, 1, '2014-02-15', '01:38:00'),
	(5, 6, 1, '2014-02-15', '03:21:00'),
	(5, 6, 1, '2014-02-15', '03:27:00'),
	(5, 6, 1, '2014-02-15', '03:22:00'),
	(5, 6, 1, '2014-02-15', '02:42:00'),
	(5, 6, 1, '2014-02-15', '01:54:00'),
	(5, 6, 1, '2014-02-15', '02:13:00'),
	(5, 6, 1, '2014-02-15', '01:37:00'),
	(5, 6, 1, '2014-02-15', '02:12:00'),
	(5, 6, 1, '2014-02-15', '02:24:00'),
	(5, 6, 1, '2014-02-15', '01:32:00'),
	(5, 6, 1, '2014-02-15', '03:38:00'),
	(5, 6, 1, '2014-02-15', '02:47:00'),
	(5, 6, 1, '2014-02-15', '01:32:00'),
	(5, 6, 1, '2014-02-15', '02:26:00'),
	(5, 6, 1, '2014-02-15', '01:30:00'),
	(5, 6, 1, '2014-02-15', '03:18:00'),
	(5, 6, 1, '2014-02-15', '03:36:00'),
	(5, 6, 1, '2014-02-15', '01:56:00'),
	(5, 6, 1, '2014-02-15', '02:01:00'),
	(5, 6, 1, '2014-02-15', '02:48:00'),
	(5, 6, 1, '2014-02-15', '01:48:00'),
	(5, 6, 1, '2014-02-15', '03:44:00'),
	(5, 6, 1, '2014-02-15', '02:30:00'),
	(5, 6, 1, '2014-02-15', '02:08:00'),
	(5, 6, 1, '2014-02-15', '01:40:00'),
	(5, 6, 1, '2014-02-15', '02:46:00'),
	(5, 6, 1, '2014-02-15', '02:43:00'),
	(5, 6, 1, '2014-02-15', '03:46:00'),
	(5, 6, 1, '2014-02-15', '02:17:00'),
	(5, 6, 1, '2014-02-15', '03:12:00'),
	(5, 7, 2, '2014-02-15', '01:57:00'),
	(5, 7, 2, '2014-02-15', '03:41:00'),
	(5, 7, 2, '2014-02-15', '01:57:00'),
	(5, 7, 2, '2014-02-15', '01:46:00'),
	(5, 7, 2, '2014-02-15', '01:31:00'),
	(5, 7, 2, '2014-02-15', '03:05:00'),
	(5, 7, 2, '2014-02-15', '02:29:00'),
	(5, 7, 2, '2014-02-15', '01:42:00'),
	(5, 7, 2, '2014-02-15', '01:50:00'),
	(5, 7, 2, '2014-02-15', '02:36:00'),
	(5, 7, 2, '2014-02-15', '03:45:00'),
	(5, 7, 2, '2014-02-15', '02:33:00'),
	(5, 7, 2, '2014-02-15', '02:17:00'),
	(5, 7, 2, '2014-02-15', '02:19:00'),
	(5, 7, 2, '2014-02-15', '03:14:00'),
	(5, 7, 2, '2014-02-15', '03:10:00'),
	(5, 7, 2, '2014-02-15', '02:20:00'),
	(5, 7, 2, '2014-02-15', '02:58:00'),
	(5, 7, 2, '2014-02-15', '01:47:00'),
	(5, 7, 2, '2014-02-15', '03:06:00'),
	(5, 7, 2, '2014-02-15', '01:47:00'),
	(5, 7, 2, '2014-02-15', '02:44:00'),
	(5, 7, 2, '2014-02-15', '02:12:00'),
	(5, 7, 2, '2014-02-15', '03:38:00'),
	(5, 7, 2, '2014-02-15', '03:14:00'),
	(5, 7, 2, '2014-02-15', '01:30:00'),
	(5, 7, 2, '2014-02-15', '03:10:00'),
	(5, 7, 2, '2014-02-15', '02:57:00'),
	(5, 7, 2, '2014-02-15', '03:45:00'),
	(5, 7, 2, '2014-02-15', '01:36:00'),
	(5, 7, 2, '2014-02-15', '02:05:00'),
	(5, 7, 2, '2014-02-15', '01:53:00'),
	(5, 7, 2, '2014-02-15', '01:38:00'),
	(5, 7, 2, '2014-02-15', '03:18:00'),
	(5, 7, 2, '2014-02-15', '03:18:00'),
	(5, 7, 2, '2014-02-15', '02:47:00'),
	(5, 7, 2, '2014-02-15', '02:31:00'),
	(5, 7, 2, '2014-02-15', '02:45:00'),
	(5, 7, 2, '2014-02-15', '02:25:00'),
	(5, 7, 2, '2014-02-15', '02:21:00'),
	(5, 7, 2, '2014-02-15', '03:01:00'),
	(5, 7, 2, '2014-02-15', '02:00:00'),
	(5, 7, 2, '2014-02-15', '01:42:00'),
	(5, 7, 2, '2014-02-15', '03:17:00'),
	(5, 7, 2, '2014-02-15', '03:00:00'),
	(5, 7, 2, '2014-02-15', '03:38:00'),
	(5, 7, 2, '2014-02-15', '03:08:00'),
	(5, 7, 2, '2014-02-15', '03:15:00'),
	(5, 7, 2, '2014-02-15', '03:05:00'),
	(5, 7, 2, '2014-02-15', '01:54:00'),
	(5, 7, 2, '2014-02-15', '03:19:00'),
	(5, 7, 2, '2014-02-15', '02:32:00'),
	(5, 7, 2, '2014-02-15', '03:29:00'),
	(5, 7, 2, '2014-02-15', '03:46:00'),
	(5, 7, 2, '2014-02-15', '02:22:00'),
	(5, 7, 2, '2014-02-15', '03:34:00'),
	(5, 7, 2, '2014-02-15', '02:24:00'),
	(5, 7, 2, '2014-02-15', '02:07:00'),
	(5, 7, 2, '2014-02-15', '01:51:00'),
	(5, 7, 2, '2014-02-15', '03:42:00'),
	(5, 8, 3, '2014-02-15', '03:26:00'),
	(5, 8, 3, '2014-02-15', '02:45:00'),
	(5, 8, 3, '2014-02-15', '01:57:00'),
	(5, 8, 3, '2014-02-15', '02:02:00'),
	(5, 8, 3, '2014-02-15', '02:52:00'),
	(5, 8, 3, '2014-02-15', '02:35:00'),
	(5, 8, 3, '2014-02-15', '02:51:00'),
	(5, 8, 3, '2014-02-15', '02:57:00'),
	(5, 8, 3, '2014-02-15', '02:36:00'),
	(5, 8, 3, '2014-02-15', '02:42:00'),
	(5, 8, 3, '2014-02-15', '02:08:00'),
	(5, 8, 3, '2014-02-15', '03:07:00'),
	(5, 8, 3, '2014-02-15', '01:30:00'),
	(5, 8, 3, '2014-02-15', '02:52:00'),
	(5, 8, 3, '2014-02-15', '02:07:00'),
	(5, 8, 3, '2014-02-15', '02:36:00'),
	(5, 8, 3, '2014-02-15', '03:06:00'),
	(5, 8, 3, '2014-02-15', '02:04:00'),
	(5, 8, 3, '2014-02-15', '01:36:00'),
	(5, 8, 3, '2014-02-15', '02:25:00'),
	(5, 8, 3, '2014-02-15', '01:36:00'),
	(5, 8, 3, '2014-02-15', '03:24:00'),
	(5, 8, 3, '2014-02-15', '02:25:00'),
	(5, 8, 3, '2014-02-15', '02:29:00'),
	(5, 8, 3, '2014-02-15', '01:37:00'),
	(5, 8, 3, '2014-02-15', '03:15:00'),
	(5, 8, 3, '2014-02-15', '01:37:00'),
	(5, 8, 3, '2014-02-15', '03:05:00'),
	(5, 8, 3, '2014-02-15', '02:52:00'),
	(5, 8, 3, '2014-02-15', '01:31:00'),
	(5, 8, 3, '2014-02-15', '01:36:00'),
	(5, 8, 3, '2014-02-15', '02:00:00'),
	(5, 8, 3, '2014-02-15', '01:38:00'),
	(5, 8, 3, '2014-02-15', '02:46:00'),
	(5, 8, 3, '2014-02-15', '03:17:00'),
	(5, 8, 3, '2014-02-15', '02:28:00'),
	(5, 8, 3, '2014-02-15', '03:04:00'),
	(5, 8, 3, '2014-02-15', '02:20:00'),
	(5, 8, 3, '2014-02-15', '03:00:00'),
	(5, 8, 3, '2014-02-15', '02:24:00'),
	(5, 8, 3, '2014-02-15', '01:31:00'),
	(5, 8, 3, '2014-02-15', '03:01:00'),
	(5, 8, 3, '2014-02-15', '02:51:00'),
	(5, 8, 3, '2014-02-15', '01:36:00'),
	(5, 8, 3, '2014-02-15', '02:08:00'),
	(5, 8, 3, '2014-02-15', '02:17:00'),
	(5, 8, 3, '2014-02-15', '03:31:00'),
	(5, 8, 3, '2014-02-15', '03:01:00'),
	(5, 8, 3, '2014-02-15', '03:06:00'),
	(5, 8, 3, '2014-02-15', '02:51:00'),
	(5, 8, 3, '2014-02-15', '03:27:00'),
	(5, 8, 3, '2014-02-15', '03:03:00'),
	(5, 8, 3, '2014-02-15', '03:28:00'),
	(5, 8, 3, '2014-02-15', '02:34:00'),
	(5, 8, 3, '2014-02-15', '02:58:00'),
	(5, 8, 3, '2014-02-15', '01:30:00'),
	(5, 8, 3, '2014-02-15', '03:19:00'),
	(5, 8, 3, '2014-02-15', '02:19:00'),
	(5, 8, 3, '2014-02-15', '02:13:00'),
	(5, 8, 3, '2014-02-15', '02:37:00'),
	(5, 9, 4, '2014-02-15', '03:06:00'),
	(5, 9, 4, '2014-02-15', '02:45:00'),
	(5, 9, 4, '2014-02-15', '02:58:00'),
	(5, 9, 4, '2014-02-15', '02:49:00'),
	(5, 9, 4, '2014-02-15', '03:42:00'),
	(5, 9, 4, '2014-02-15', '01:47:00'),
	(5, 9, 4, '2014-02-15', '03:04:00'),
	(5, 9, 4, '2014-02-15', '01:44:00'),
	(5, 9, 4, '2014-02-15', '02:31:00'),
	(5, 9, 4, '2014-02-15', '03:36:00'),
	(5, 9, 4, '2014-02-15', '02:10:00'),
	(5, 9, 4, '2014-02-15', '03:04:00'),
	(5, 9, 4, '2014-02-15', '02:49:00'),
	(5, 9, 4, '2014-02-15', '03:22:00'),
	(5, 9, 4, '2014-02-15', '02:20:00'),
	(5, 9, 4, '2014-02-15', '02:24:00'),
	(5, 9, 4, '2014-02-15', '03:29:00'),
	(5, 9, 4, '2014-02-15', '01:56:00'),
	(5, 9, 4, '2014-02-15', '02:14:00'),
	(5, 9, 4, '2014-02-15', '01:39:00'),
	(5, 9, 4, '2014-02-15', '02:17:00'),
	(5, 9, 4, '2014-02-15', '02:46:00'),
	(5, 9, 4, '2014-02-15', '03:10:00'),
	(5, 9, 4, '2014-02-15', '01:31:00'),
	(5, 9, 4, '2014-02-15', '03:22:00'),
	(5, 9, 4, '2014-02-15', '01:45:00'),
	(5, 9, 4, '2014-02-15', '01:40:00'),
	(5, 9, 4, '2014-02-15', '01:37:00'),
	(5, 9, 4, '2014-02-15', '01:34:00'),
	(5, 9, 4, '2014-02-15', '01:31:00'),
	(5, 9, 4, '2014-02-15', '03:38:00'),
	(5, 9, 4, '2014-02-15', '03:02:00'),
	(5, 9, 4, '2014-02-15', '02:49:00'),
	(5, 9, 4, '2014-02-15', '03:27:00'),
	(5, 9, 4, '2014-02-15', '02:47:00'),
	(5, 9, 4, '2014-02-15', '02:06:00'),
	(5, 9, 4, '2014-02-15', '02:54:00'),
	(5, 9, 4, '2014-02-15', '02:10:00'),
	(5, 9, 4, '2014-02-15', '02:53:00'),
	(5, 9, 4, '2014-02-15', '01:56:00'),
	(5, 9, 4, '2014-02-15', '01:48:00'),
	(5, 9, 4, '2014-02-15', '01:43:00'),
	(5, 9, 4, '2014-02-15', '01:40:00'),
	(5, 9, 4, '2014-02-15', '01:40:00'),
	(5, 9, 4, '2014-02-15', '01:53:00'),
	(5, 9, 4, '2014-02-15', '02:56:00'),
	(5, 9, 4, '2014-02-15', '02:57:00'),
	(5, 9, 4, '2014-02-15', '02:11:00'),
	(5, 9, 4, '2014-02-15', '02:50:00'),
	(5, 9, 4, '2014-02-15', '01:39:00'),
	(5, 9, 4, '2014-02-15', '02:44:00'),
	(5, 9, 4, '2014-02-15', '02:42:00'),
	(5, 9, 4, '2014-02-15', '01:31:00'),
	(5, 9, 4, '2014-02-15', '02:34:00'),
	(5, 9, 4, '2014-02-15', '02:14:00'),
	(5, 9, 4, '2014-02-15', '02:00:00'),
	(5, 9, 4, '2014-02-15', '01:48:00'),
	(5, 9, 4, '2014-02-15', '01:32:00'),
	(5, 9, 4, '2014-02-15', '03:02:00'),
	(5, 9, 4, '2014-02-15', '02:15:00'),
	(5, 10, 5, '2014-02-15', '01:46:00'),
	(5, 10, 5, '2014-02-15', '03:08:00'),
	(5, 10, 5, '2014-02-15', '02:11:00'),
	(5, 10, 5, '2014-02-15', '02:17:00'),
	(5, 10, 5, '2014-02-15', '03:23:00'),
	(5, 10, 5, '2014-02-15', '01:52:00'),
	(5, 10, 5, '2014-02-15', '02:09:00'),
	(5, 10, 5, '2014-02-15', '03:38:00'),
	(5, 10, 5, '2014-02-15', '03:32:00'),
	(5, 10, 5, '2014-02-15', '03:03:00'),
	(5, 10, 5, '2014-02-15', '03:09:00'),
	(5, 10, 5, '2014-02-15', '02:52:00'),
	(5, 10, 5, '2014-02-15', '03:22:00'),
	(5, 10, 5, '2014-02-15', '02:18:00'),
	(5, 10, 5, '2014-02-15', '02:08:00'),
	(5, 10, 5, '2014-02-15', '02:16:00'),
	(5, 10, 5, '2014-02-15', '03:26:00'),
	(5, 10, 5, '2014-02-15', '02:12:00'),
	(5, 10, 5, '2014-02-15', '03:40:00'),
	(5, 10, 5, '2014-02-15', '03:31:00'),
	(5, 10, 5, '2014-02-15', '02:54:00'),
	(5, 10, 5, '2014-02-15', '02:26:00'),
	(5, 10, 5, '2014-02-15', '01:59:00'),
	(5, 10, 5, '2014-02-15', '03:21:00'),
	(5, 10, 5, '2014-02-15', '02:36:00'),
	(5, 10, 5, '2014-02-15', '03:43:00'),
	(5, 10, 5, '2014-02-15', '02:36:00'),
	(5, 10, 5, '2014-02-15', '02:33:00'),
	(5, 10, 5, '2014-02-15', '03:30:00'),
	(5, 10, 5, '2014-02-15', '01:39:00'),
	(5, 10, 5, '2014-02-15', '02:55:00'),
	(5, 10, 5, '2014-02-15', '01:30:00'),
	(5, 10, 5, '2014-02-15', '01:43:00'),
	(5, 10, 5, '2014-02-15', '02:34:00'),
	(5, 10, 5, '2014-02-15', '01:43:00'),
	(5, 10, 5, '2014-02-15', '01:39:00'),
	(5, 10, 5, '2014-02-15', '01:34:00'),
	(5, 10, 5, '2014-02-15', '03:38:00'),
	(5, 10, 5, '2014-02-15', '03:05:00'),
	(5, 10, 5, '2014-02-15', '03:01:00'),
	(5, 10, 5, '2014-02-15', '02:06:00'),
	(5, 10, 5, '2014-02-15', '02:12:00'),
	(5, 10, 5, '2014-02-15', '03:14:00'),
	(5, 10, 5, '2014-02-15', '03:35:00'),
	(5, 10, 5, '2014-02-15', '02:14:00'),
	(5, 10, 5, '2014-02-15', '03:23:00'),
	(5, 10, 5, '2014-02-15', '02:01:00'),
	(5, 10, 5, '2014-02-15', '02:56:00'),
	(5, 10, 5, '2014-02-15', '02:40:00'),
	(5, 10, 5, '2014-02-15', '03:00:00'),
	(5, 10, 5, '2014-02-15', '03:17:00'),
	(5, 10, 5, '2014-02-15', '03:43:00'),
	(5, 10, 5, '2014-02-15', '02:46:00'),
	(5, 10, 5, '2014-02-15', '03:24:00'),
	(5, 10, 5, '2014-02-15', '02:45:00'),
	(5, 10, 5, '2014-02-15', '02:03:00'),
	(5, 10, 5, '2014-02-15', '02:46:00'),
	(5, 10, 5, '2014-02-15', '01:41:00'),
	(5, 10, 5, '2014-02-15', '03:06:00'),
	(5, 10, 5, '2014-02-15', '02:17:00'),
	(6, 6, 1, '2014-03-01', '03:39:00'),
	(6, 6, 1, '2014-03-01', '01:32:00'),
	(6, 6, 1, '2014-03-01', '01:57:00'),
	(6, 6, 1, '2014-03-01', '03:39:00'),
	(6, 6, 1, '2014-03-01', '01:58:00'),
	(6, 6, 1, '2014-03-01', '01:53:00'),
	(6, 6, 1, '2014-03-01', '02:02:00'),
	(6, 6, 1, '2014-03-01', '02:58:00'),
	(6, 6, 1, '2014-03-01', '02:49:00'),
	(6, 6, 1, '2014-03-01', '03:43:00'),
	(6, 6, 1, '2014-03-01', '01:53:00'),
	(6, 6, 1, '2014-03-01', '03:31:00'),
	(6, 6, 1, '2014-03-01', '01:32:00'),
	(6, 6, 1, '2014-03-01', '02:16:00'),
	(6, 6, 1, '2014-03-01', '03:01:00'),
	(6, 6, 1, '2014-03-01', '02:20:00'),
	(6, 6, 1, '2014-03-01', '03:22:00'),
	(6, 6, 1, '2014-03-01', '01:37:00'),
	(6, 6, 1, '2014-03-01', '03:11:00'),
	(6, 6, 1, '2014-03-01', '02:53:00'),
	(6, 6, 1, '2014-03-01', '03:25:00'),
	(6, 6, 1, '2014-03-01', '02:25:00'),
	(6, 6, 1, '2014-03-01', '02:37:00'),
	(6, 6, 1, '2014-03-01', '02:05:00'),
	(6, 6, 1, '2014-03-01', '03:20:00'),
	(6, 6, 1, '2014-03-01', '02:14:00'),
	(6, 6, 1, '2014-03-01', '01:54:00'),
	(6, 6, 1, '2014-03-01', '03:30:00'),
	(6, 6, 1, '2014-03-01', '03:40:00'),
	(6, 6, 1, '2014-03-01', '01:52:00'),
	(6, 6, 1, '2014-03-01', '03:32:00'),
	(6, 6, 1, '2014-03-01', '01:37:00'),
	(6, 6, 1, '2014-03-01', '02:43:00'),
	(6, 6, 1, '2014-03-01', '02:48:00'),
	(6, 6, 1, '2014-03-01', '02:07:00'),
	(6, 6, 1, '2014-03-01', '02:56:00'),
	(6, 6, 1, '2014-03-01', '02:21:00'),
	(6, 6, 1, '2014-03-01', '03:42:00'),
	(6, 6, 1, '2014-03-01', '03:15:00'),
	(6, 6, 1, '2014-03-01', '03:38:00'),
	(6, 6, 1, '2014-03-01', '02:29:00'),
	(6, 6, 1, '2014-03-01', '02:17:00'),
	(6, 6, 1, '2014-03-01', '02:27:00'),
	(6, 6, 1, '2014-03-01', '01:39:00'),
	(6, 6, 1, '2014-03-01', '01:39:00'),
	(6, 6, 1, '2014-03-01', '01:47:00'),
	(6, 6, 1, '2014-03-01', '02:32:00'),
	(6, 6, 1, '2014-03-01', '03:32:00'),
	(6, 6, 1, '2014-03-01', '01:54:00'),
	(6, 6, 1, '2014-03-01', '01:54:00'),
	(6, 6, 1, '2014-03-01', '02:16:00'),
	(6, 6, 1, '2014-03-01', '01:56:00'),
	(6, 6, 1, '2014-03-01', '03:36:00'),
	(6, 6, 1, '2014-03-01', '01:46:00'),
	(6, 6, 1, '2014-03-01', '03:16:00'),
	(6, 6, 1, '2014-03-01', '02:50:00'),
	(6, 6, 1, '2014-03-01', '02:52:00'),
	(6, 6, 1, '2014-03-01', '02:05:00'),
	(6, 6, 1, '2014-03-01', '02:35:00'),
	(6, 6, 1, '2014-03-01', '02:57:00'),
	(6, 7, 2, '2014-03-01', '01:31:00'),
	(6, 7, 2, '2014-03-01', '03:04:00'),
	(6, 7, 2, '2014-03-01', '02:16:00'),
	(6, 7, 2, '2014-03-01', '02:59:00'),
	(6, 7, 2, '2014-03-01', '01:53:00'),
	(6, 7, 2, '2014-03-01', '03:43:00'),
	(6, 7, 2, '2014-03-01', '02:03:00'),
	(6, 7, 2, '2014-03-01', '02:18:00'),
	(6, 7, 2, '2014-03-01', '01:31:00'),
	(6, 7, 2, '2014-03-01', '01:33:00'),
	(6, 7, 2, '2014-03-01', '01:41:00'),
	(6, 7, 2, '2014-03-01', '02:17:00'),
	(6, 7, 2, '2014-03-01', '02:31:00'),
	(6, 7, 2, '2014-03-01', '01:56:00'),
	(6, 7, 2, '2014-03-01', '02:57:00'),
	(6, 7, 2, '2014-03-01', '02:45:00'),
	(6, 7, 2, '2014-03-01', '03:24:00'),
	(6, 7, 2, '2014-03-01', '02:34:00'),
	(6, 7, 2, '2014-03-01', '03:32:00'),
	(6, 7, 2, '2014-03-01', '03:44:00'),
	(6, 7, 2, '2014-03-01', '01:51:00'),
	(6, 7, 2, '2014-03-01', '03:38:00'),
	(6, 7, 2, '2014-03-01', '01:44:00'),
	(6, 7, 2, '2014-03-01', '03:17:00'),
	(6, 7, 2, '2014-03-01', '02:44:00'),
	(6, 7, 2, '2014-03-01', '02:17:00'),
	(6, 7, 2, '2014-03-01', '01:44:00'),
	(6, 7, 2, '2014-03-01', '02:39:00'),
	(6, 7, 2, '2014-03-01', '01:54:00'),
	(6, 7, 2, '2014-03-01', '02:22:00'),
	(6, 7, 2, '2014-03-01', '02:17:00'),
	(6, 7, 2, '2014-03-01', '02:52:00'),
	(6, 7, 2, '2014-03-01', '03:38:00'),
	(6, 7, 2, '2014-03-01', '03:21:00'),
	(6, 7, 2, '2014-03-01', '02:03:00'),
	(6, 7, 2, '2014-03-01', '03:21:00'),
	(6, 7, 2, '2014-03-01', '02:06:00'),
	(6, 7, 2, '2014-03-01', '03:39:00'),
	(6, 7, 2, '2014-03-01', '03:26:00'),
	(6, 7, 2, '2014-03-01', '02:21:00'),
	(6, 7, 2, '2014-03-01', '02:18:00'),
	(6, 7, 2, '2014-03-01', '02:57:00'),
	(6, 7, 2, '2014-03-01', '01:41:00'),
	(6, 7, 2, '2014-03-01', '02:44:00'),
	(6, 7, 2, '2014-03-01', '02:27:00'),
	(6, 7, 2, '2014-03-01', '02:34:00'),
	(6, 7, 2, '2014-03-01', '01:37:00'),
	(6, 7, 2, '2014-03-01', '03:36:00'),
	(6, 7, 2, '2014-03-01', '02:14:00'),
	(6, 7, 2, '2014-03-01', '03:34:00'),
	(6, 7, 2, '2014-03-01', '02:35:00'),
	(6, 7, 2, '2014-03-01', '03:07:00'),
	(6, 7, 2, '2014-03-01', '01:35:00'),
	(6, 7, 2, '2014-03-01', '01:50:00'),
	(6, 7, 2, '2014-03-01', '02:56:00'),
	(6, 7, 2, '2014-03-01', '02:57:00'),
	(6, 7, 2, '2014-03-01', '02:05:00'),
	(6, 7, 2, '2014-03-01', '02:26:00'),
	(6, 7, 2, '2014-03-01', '02:04:00'),
	(6, 7, 2, '2014-03-01', '01:34:00'),
	(6, 8, 3, '2014-03-01', '03:33:00'),
	(6, 8, 3, '2014-03-01', '02:52:00'),
	(6, 8, 3, '2014-03-01', '02:12:00'),
	(6, 8, 3, '2014-03-01', '03:00:00'),
	(6, 8, 3, '2014-03-01', '02:41:00'),
	(6, 8, 3, '2014-03-01', '02:58:00'),
	(6, 8, 3, '2014-03-01', '03:09:00'),
	(6, 8, 3, '2014-03-01', '03:18:00'),
	(6, 8, 3, '2014-03-01', '03:27:00'),
	(6, 8, 3, '2014-03-01', '01:38:00'),
	(6, 8, 3, '2014-03-01', '02:37:00'),
	(6, 8, 3, '2014-03-01', '02:32:00'),
	(6, 8, 3, '2014-03-01', '03:20:00'),
	(6, 8, 3, '2014-03-01', '03:23:00'),
	(6, 8, 3, '2014-03-01', '03:18:00'),
	(6, 8, 3, '2014-03-01', '02:45:00'),
	(6, 8, 3, '2014-03-01', '02:20:00'),
	(6, 8, 3, '2014-03-01', '01:57:00'),
	(6, 8, 3, '2014-03-01', '03:20:00'),
	(6, 8, 3, '2014-03-01', '03:01:00'),
	(6, 8, 3, '2014-03-01', '03:35:00'),
	(6, 8, 3, '2014-03-01', '03:12:00'),
	(6, 8, 3, '2014-03-01', '01:39:00'),
	(6, 8, 3, '2014-03-01', '03:28:00'),
	(6, 8, 3, '2014-03-01', '02:30:00'),
	(6, 8, 3, '2014-03-01', '02:43:00'),
	(6, 8, 3, '2014-03-01', '02:30:00'),
	(6, 8, 3, '2014-03-01', '02:50:00'),
	(6, 8, 3, '2014-03-01', '03:05:00'),
	(6, 8, 3, '2014-03-01', '03:21:00'),
	(6, 8, 3, '2014-03-01', '01:47:00'),
	(6, 8, 3, '2014-03-01', '01:33:00'),
	(6, 8, 3, '2014-03-01', '03:02:00'),
	(6, 8, 3, '2014-03-01', '02:45:00'),
	(6, 8, 3, '2014-03-01', '03:10:00'),
	(6, 8, 3, '2014-03-01', '01:54:00'),
	(6, 8, 3, '2014-03-01', '02:41:00'),
	(6, 8, 3, '2014-03-01', '02:03:00'),
	(6, 8, 3, '2014-03-01', '02:48:00'),
	(6, 8, 3, '2014-03-01', '02:08:00'),
	(6, 8, 3, '2014-03-01', '02:53:00'),
	(6, 8, 3, '2014-03-01', '02:20:00'),
	(6, 8, 3, '2014-03-01', '01:33:00'),
	(6, 8, 3, '2014-03-01', '03:28:00'),
	(6, 8, 3, '2014-03-01', '02:45:00'),
	(6, 8, 3, '2014-03-01', '01:53:00'),
	(6, 8, 3, '2014-03-01', '01:46:00'),
	(6, 8, 3, '2014-03-01', '01:42:00'),
	(6, 8, 3, '2014-03-01', '01:41:00'),
	(6, 8, 3, '2014-03-01', '01:52:00'),
	(6, 8, 3, '2014-03-01', '02:45:00'),
	(6, 8, 3, '2014-03-01', '02:29:00'),
	(6, 8, 3, '2014-03-01', '02:41:00'),
	(6, 8, 3, '2014-03-01', '02:22:00'),
	(6, 8, 3, '2014-03-01', '02:16:00'),
	(6, 8, 3, '2014-03-01', '02:47:00'),
	(6, 8, 3, '2014-03-01', '03:29:00'),
	(6, 8, 3, '2014-03-01', '03:22:00'),
	(6, 8, 3, '2014-03-01', '02:50:00'),
	(6, 8, 3, '2014-03-01', '02:32:00'),
	(6, 9, 4, '2014-03-01', '02:17:00'),
	(6, 9, 4, '2014-03-01', '01:41:00'),
	(6, 9, 4, '2014-03-01', '02:17:00'),
	(6, 9, 4, '2014-03-01', '02:39:00'),
	(6, 9, 4, '2014-03-01', '02:43:00'),
	(6, 9, 4, '2014-03-01', '01:58:00'),
	(6, 9, 4, '2014-03-01', '02:24:00'),
	(6, 9, 4, '2014-03-01', '02:24:00'),
	(6, 9, 4, '2014-03-01', '03:20:00'),
	(6, 9, 4, '2014-03-01', '03:35:00'),
	(6, 9, 4, '2014-03-01', '01:59:00'),
	(6, 9, 4, '2014-03-01', '02:08:00'),
	(6, 9, 4, '2014-03-01', '03:10:00'),
	(6, 9, 4, '2014-03-01', '03:32:00'),
	(6, 9, 4, '2014-03-01', '02:19:00'),
	(6, 9, 4, '2014-03-01', '01:39:00'),
	(6, 9, 4, '2014-03-01', '02:00:00'),
	(6, 9, 4, '2014-03-01', '03:35:00'),
	(6, 9, 4, '2014-03-01', '01:37:00'),
	(6, 9, 4, '2014-03-01', '02:28:00'),
	(6, 9, 4, '2014-03-01', '01:37:00'),
	(6, 9, 4, '2014-03-01', '03:33:00'),
	(6, 9, 4, '2014-03-01', '02:35:00'),
	(6, 9, 4, '2014-03-01', '03:00:00'),
	(6, 9, 4, '2014-03-01', '03:34:00'),
	(6, 9, 4, '2014-03-01', '02:56:00'),
	(6, 9, 4, '2014-03-01', '02:27:00'),
	(6, 9, 4, '2014-03-01', '01:59:00'),
	(6, 9, 4, '2014-03-01', '03:15:00'),
	(6, 9, 4, '2014-03-01', '02:15:00'),
	(6, 9, 4, '2014-03-01', '02:12:00'),
	(6, 9, 4, '2014-03-01', '02:45:00'),
	(6, 9, 4, '2014-03-01', '03:28:00'),
	(6, 9, 4, '2014-03-01', '03:09:00'),
	(6, 9, 4, '2014-03-01', '01:42:00'),
	(6, 9, 4, '2014-03-01', '01:56:00'),
	(6, 9, 4, '2014-03-01', '03:06:00'),
	(6, 9, 4, '2014-03-01', '01:35:00'),
	(6, 9, 4, '2014-03-01', '01:31:00'),
	(6, 9, 4, '2014-03-01', '03:35:00'),
	(6, 9, 4, '2014-03-01', '03:02:00'),
	(6, 9, 4, '2014-03-01', '02:55:00'),
	(6, 9, 4, '2014-03-01', '01:50:00'),
	(6, 9, 4, '2014-03-01', '03:17:00'),
	(6, 9, 4, '2014-03-01', '02:52:00'),
	(6, 9, 4, '2014-03-01', '02:58:00'),
	(6, 9, 4, '2014-03-01', '02:34:00'),
	(6, 9, 4, '2014-03-01', '02:24:00'),
	(6, 9, 4, '2014-03-01', '02:48:00'),
	(6, 9, 4, '2014-03-01', '03:10:00'),
	(6, 9, 4, '2014-03-01', '03:41:00'),
	(6, 9, 4, '2014-03-01', '03:03:00'),
	(6, 9, 4, '2014-03-01', '02:41:00'),
	(6, 9, 4, '2014-03-01', '02:49:00'),
	(6, 9, 4, '2014-03-01', '02:21:00'),
	(6, 9, 4, '2014-03-01', '01:45:00'),
	(6, 9, 4, '2014-03-01', '02:27:00'),
	(6, 9, 4, '2014-03-01', '03:20:00'),
	(6, 9, 4, '2014-03-01', '03:23:00'),
	(6, 9, 4, '2014-03-01', '03:12:00'),
	(6, 10, 5, '2014-03-01', '02:03:00'),
	(6, 10, 5, '2014-03-01', '02:17:00'),
	(6, 10, 5, '2014-03-01', '01:48:00'),
	(6, 10, 5, '2014-03-01', '02:41:00'),
	(6, 10, 5, '2014-03-01', '02:26:00'),
	(6, 10, 5, '2014-03-01', '02:37:00'),
	(6, 10, 5, '2014-03-01', '02:17:00'),
	(6, 10, 5, '2014-03-01', '02:06:00'),
	(6, 10, 5, '2014-03-01', '02:08:00'),
	(6, 10, 5, '2014-03-01', '02:54:00'),
	(6, 10, 5, '2014-03-01', '02:30:00'),
	(6, 10, 5, '2014-03-01', '02:20:00'),
	(6, 10, 5, '2014-03-01', '02:40:00'),
	(6, 10, 5, '2014-03-01', '02:51:00'),
	(6, 10, 5, '2014-03-01', '02:40:00'),
	(6, 10, 5, '2014-03-01', '03:20:00'),
	(6, 10, 5, '2014-03-01', '03:07:00'),
	(6, 10, 5, '2014-03-01', '02:03:00'),
	(6, 10, 5, '2014-03-01', '03:29:00'),
	(6, 10, 5, '2014-03-01', '01:37:00'),
	(6, 10, 5, '2014-03-01', '02:16:00'),
	(6, 10, 5, '2014-03-01', '02:59:00'),
	(6, 10, 5, '2014-03-01', '02:31:00'),
	(6, 10, 5, '2014-03-01', '02:11:00'),
	(6, 10, 5, '2014-03-01', '01:52:00'),
	(6, 10, 5, '2014-03-01', '03:17:00'),
	(6, 10, 5, '2014-03-01', '03:16:00'),
	(6, 10, 5, '2014-03-01', '02:55:00'),
	(6, 10, 5, '2014-03-01', '03:17:00'),
	(6, 10, 5, '2014-03-01', '02:08:00'),
	(6, 10, 5, '2014-03-01', '03:23:00'),
	(6, 10, 5, '2014-03-01', '02:54:00'),
	(6, 10, 5, '2014-03-01', '02:51:00'),
	(6, 10, 5, '2014-03-01', '02:04:00'),
	(6, 10, 5, '2014-03-01', '02:20:00'),
	(6, 10, 5, '2014-03-01', '01:57:00'),
	(6, 10, 5, '2014-03-01', '03:16:00'),
	(6, 10, 5, '2014-03-01', '02:55:00'),
	(6, 10, 5, '2014-03-01', '03:16:00'),
	(6, 10, 5, '2014-03-01', '02:02:00'),
	(6, 10, 5, '2014-03-01', '02:58:00'),
	(6, 10, 5, '2014-03-01', '03:08:00'),
	(6, 10, 5, '2014-03-01', '03:16:00'),
	(6, 10, 5, '2014-03-01', '03:23:00'),
	(6, 10, 5, '2014-03-01', '01:33:00'),
	(6, 10, 5, '2014-03-01', '02:15:00'),
	(6, 10, 5, '2014-03-01', '03:02:00'),
	(6, 10, 5, '2014-03-01', '02:53:00'),
	(6, 10, 5, '2014-03-01', '01:48:00'),
	(6, 10, 5, '2014-03-01', '02:56:00'),
	(6, 10, 5, '2014-03-01', '01:39:00'),
	(6, 10, 5, '2014-03-01', '02:04:00'),
	(6, 10, 5, '2014-03-01', '01:51:00'),
	(6, 10, 5, '2014-03-01', '01:32:00'),
	(6, 10, 5, '2014-03-01', '02:38:00'),
	(6, 10, 5, '2014-03-01', '03:03:00'),
	(6, 10, 5, '2014-03-01', '01:45:00'),
	(6, 10, 5, '2014-03-01', '02:12:00'),
	(6, 10, 5, '2014-03-01', '02:13:00'),
	(6, 10, 5, '2014-03-01', '03:00:00'),
	(8, 6, 1, '2014-03-15', '01:31:00'),
	(8, 6, 1, '2014-03-15', '01:46:00'),
	(8, 6, 1, '2014-03-15', '02:47:00'),
	(8, 6, 1, '2014-03-15', '02:38:00'),
	(8, 6, 1, '2014-03-15', '03:20:00'),
	(8, 6, 1, '2014-03-15', '02:44:00'),
	(8, 6, 1, '2014-03-15', '02:10:00'),
	(8, 6, 1, '2014-03-15', '03:26:00'),
	(8, 6, 1, '2014-03-15', '02:25:00'),
	(8, 6, 1, '2014-03-15', '02:34:00'),
	(8, 6, 1, '2014-03-15', '01:50:00'),
	(8, 6, 1, '2014-03-15', '02:13:00'),
	(8, 6, 1, '2014-03-15', '01:50:00'),
	(8, 6, 1, '2014-03-15', '03:15:00'),
	(8, 6, 1, '2014-03-15', '02:33:00'),
	(8, 6, 1, '2014-03-15', '01:31:00'),
	(8, 6, 1, '2014-03-15', '02:56:00'),
	(8, 6, 1, '2014-03-15', '01:52:00'),
	(8, 6, 1, '2014-03-15', '03:33:00'),
	(8, 6, 1, '2014-03-15', '01:39:00'),
	(8, 6, 1, '2014-03-15', '02:51:00'),
	(8, 6, 1, '2014-03-15', '03:17:00'),
	(8, 6, 1, '2014-03-15', '01:53:00'),
	(8, 6, 1, '2014-03-15', '02:36:00'),
	(8, 6, 1, '2014-03-15', '03:37:00'),
	(8, 6, 1, '2014-03-15', '02:02:00'),
	(8, 6, 1, '2014-03-15', '02:18:00'),
	(8, 6, 1, '2014-03-15', '01:39:00'),
	(8, 6, 1, '2014-03-15', '02:08:00'),
	(8, 6, 1, '2014-03-15', '02:00:00'),
	(8, 6, 1, '2014-03-15', '02:05:00'),
	(8, 6, 1, '2014-03-15', '02:56:00'),
	(8, 6, 1, '2014-03-15', '02:23:00'),
	(8, 6, 1, '2014-03-15', '01:40:00'),
	(8, 6, 1, '2014-03-15', '01:55:00'),
	(8, 6, 1, '2014-03-15', '03:07:00'),
	(8, 6, 1, '2014-03-15', '01:37:00'),
	(8, 6, 1, '2014-03-15', '01:42:00'),
	(8, 6, 1, '2014-03-15', '02:11:00'),
	(8, 6, 1, '2014-03-15', '02:05:00'),
	(8, 6, 1, '2014-03-15', '02:23:00'),
	(8, 6, 1, '2014-03-15', '01:53:00'),
	(8, 6, 1, '2014-03-15', '03:02:00'),
	(8, 6, 1, '2014-03-15', '03:31:00'),
	(8, 6, 1, '2014-03-15', '02:29:00'),
	(8, 6, 1, '2014-03-15', '02:38:00'),
	(8, 6, 1, '2014-03-15', '01:58:00'),
	(8, 6, 1, '2014-03-15', '02:40:00'),
	(8, 6, 1, '2014-03-15', '03:44:00'),
	(8, 6, 1, '2014-03-15', '02:26:00'),
	(8, 6, 1, '2014-03-15', '01:42:00'),
	(8, 6, 1, '2014-03-15', '01:59:00'),
	(8, 6, 1, '2014-03-15', '03:17:00'),
	(8, 6, 1, '2014-03-15', '02:14:00'),
	(8, 6, 1, '2014-03-15', '02:05:00'),
	(8, 6, 1, '2014-03-15', '02:14:00'),
	(8, 6, 1, '2014-03-15', '03:26:00'),
	(8, 6, 1, '2014-03-15', '02:12:00'),
	(8, 6, 1, '2014-03-15', '01:30:00'),
	(8, 6, 1, '2014-03-15', '01:39:00'),
	(8, 7, 2, '2014-03-15', '02:32:00'),
	(8, 7, 2, '2014-03-15', '02:32:00'),
	(8, 7, 2, '2014-03-15', '01:32:00'),
	(8, 7, 2, '2014-03-15', '02:39:00'),
	(8, 7, 2, '2014-03-15', '03:03:00'),
	(8, 7, 2, '2014-03-15', '01:44:00'),
	(8, 7, 2, '2014-03-15', '02:09:00'),
	(8, 7, 2, '2014-03-15', '02:00:00'),
	(8, 7, 2, '2014-03-15', '02:02:00'),
	(8, 7, 2, '2014-03-15', '02:39:00'),
	(8, 7, 2, '2014-03-15', '01:36:00'),
	(8, 7, 2, '2014-03-15', '02:37:00'),
	(8, 7, 2, '2014-03-15', '02:41:00'),
	(8, 7, 2, '2014-03-15', '02:04:00'),
	(8, 7, 2, '2014-03-15', '02:49:00'),
	(8, 7, 2, '2014-03-15', '02:17:00'),
	(8, 7, 2, '2014-03-15', '03:31:00'),
	(8, 7, 2, '2014-03-15', '03:05:00'),
	(8, 7, 2, '2014-03-15', '03:23:00'),
	(8, 7, 2, '2014-03-15', '02:03:00'),
	(8, 7, 2, '2014-03-15', '02:44:00'),
	(8, 7, 2, '2014-03-15', '01:56:00'),
	(8, 7, 2, '2014-03-15', '02:02:00'),
	(8, 7, 2, '2014-03-15', '02:54:00'),
	(8, 7, 2, '2014-03-15', '02:46:00'),
	(8, 7, 2, '2014-03-15', '01:37:00'),
	(8, 7, 2, '2014-03-15', '02:25:00'),
	(8, 7, 2, '2014-03-15', '01:35:00'),
	(8, 7, 2, '2014-03-15', '03:18:00'),
	(8, 7, 2, '2014-03-15', '02:03:00'),
	(8, 7, 2, '2014-03-15', '02:59:00'),
	(8, 7, 2, '2014-03-15', '03:11:00'),
	(8, 7, 2, '2014-03-15', '03:24:00'),
	(8, 7, 2, '2014-03-15', '01:51:00'),
	(8, 7, 2, '2014-03-15', '01:41:00'),
	(8, 7, 2, '2014-03-15', '03:24:00'),
	(8, 7, 2, '2014-03-15', '02:16:00'),
	(8, 7, 2, '2014-03-15', '01:43:00'),
	(8, 7, 2, '2014-03-15', '02:19:00'),
	(8, 7, 2, '2014-03-15', '02:56:00'),
	(8, 7, 2, '2014-03-15', '02:06:00'),
	(8, 7, 2, '2014-03-15', '02:16:00'),
	(8, 7, 2, '2014-03-15', '03:30:00'),
	(8, 7, 2, '2014-03-15', '03:06:00'),
	(8, 7, 2, '2014-03-15', '03:29:00'),
	(8, 7, 2, '2014-03-15', '02:32:00'),
	(8, 7, 2, '2014-03-15', '02:45:00'),
	(8, 7, 2, '2014-03-15', '02:37:00'),
	(8, 7, 2, '2014-03-15', '03:21:00'),
	(8, 7, 2, '2014-03-15', '03:18:00'),
	(8, 7, 2, '2014-03-15', '02:57:00'),
	(8, 7, 2, '2014-03-15', '03:19:00'),
	(8, 7, 2, '2014-03-15', '02:11:00'),
	(8, 7, 2, '2014-03-15', '01:30:00'),
	(8, 7, 2, '2014-03-15', '01:33:00'),
	(8, 7, 2, '2014-03-15', '01:43:00'),
	(8, 7, 2, '2014-03-15', '02:27:00'),
	(8, 7, 2, '2014-03-15', '01:32:00'),
	(8, 7, 2, '2014-03-15', '02:53:00'),
	(8, 7, 2, '2014-03-15', '02:11:00'),
	(8, 8, 3, '2014-03-15', '02:05:00'),
	(8, 8, 3, '2014-03-15', '02:16:00'),
	(8, 8, 3, '2014-03-15', '03:35:00'),
	(8, 8, 3, '2014-03-15', '02:48:00'),
	(8, 8, 3, '2014-03-15', '01:46:00'),
	(8, 8, 3, '2014-03-15', '03:30:00'),
	(8, 8, 3, '2014-03-15', '01:36:00'),
	(8, 8, 3, '2014-03-15', '02:52:00'),
	(8, 8, 3, '2014-03-15', '03:28:00'),
	(8, 8, 3, '2014-03-15', '02:44:00'),
	(8, 8, 3, '2014-03-15', '01:44:00'),
	(8, 8, 3, '2014-03-15', '03:33:00'),
	(8, 8, 3, '2014-03-15', '01:59:00'),
	(8, 8, 3, '2014-03-15', '02:17:00'),
	(8, 8, 3, '2014-03-15', '01:44:00'),
	(8, 8, 3, '2014-03-15', '02:37:00'),
	(8, 8, 3, '2014-03-15', '01:49:00'),
	(8, 8, 3, '2014-03-15', '02:02:00'),
	(8, 8, 3, '2014-03-15', '03:15:00'),
	(8, 8, 3, '2014-03-15', '01:49:00'),
	(8, 8, 3, '2014-03-15', '02:21:00'),
	(8, 8, 3, '2014-03-15', '02:35:00'),
	(8, 8, 3, '2014-03-15', '02:07:00'),
	(8, 8, 3, '2014-03-15', '03:35:00'),
	(8, 8, 3, '2014-03-15', '03:18:00'),
	(8, 8, 3, '2014-03-15', '01:59:00'),
	(8, 8, 3, '2014-03-15', '03:04:00'),
	(8, 8, 3, '2014-03-15', '03:22:00'),
	(8, 8, 3, '2014-03-15', '01:35:00'),
	(8, 8, 3, '2014-03-15', '03:10:00'),
	(8, 8, 3, '2014-03-15', '02:45:00'),
	(8, 8, 3, '2014-03-15', '02:47:00'),
	(8, 8, 3, '2014-03-15', '01:54:00'),
	(8, 8, 3, '2014-03-15', '01:56:00'),
	(8, 8, 3, '2014-03-15', '02:30:00'),
	(8, 8, 3, '2014-03-15', '02:55:00'),
	(8, 8, 3, '2014-03-15', '03:19:00'),
	(8, 8, 3, '2014-03-15', '01:50:00'),
	(8, 8, 3, '2014-03-15', '02:16:00'),
	(8, 8, 3, '2014-03-15', '02:06:00'),
	(8, 8, 3, '2014-03-15', '02:09:00'),
	(8, 8, 3, '2014-03-15', '02:59:00'),
	(8, 8, 3, '2014-03-15', '02:26:00'),
	(8, 8, 3, '2014-03-15', '01:43:00'),
	(8, 8, 3, '2014-03-15', '02:06:00'),
	(8, 8, 3, '2014-03-15', '01:32:00'),
	(8, 8, 3, '2014-03-15', '02:12:00'),
	(8, 8, 3, '2014-03-15', '02:37:00'),
	(8, 8, 3, '2014-03-15', '02:42:00'),
	(8, 8, 3, '2014-03-15', '01:53:00'),
	(8, 8, 3, '2014-03-15', '02:05:00'),
	(8, 8, 3, '2014-03-15', '03:18:00'),
	(8, 8, 3, '2014-03-15', '01:56:00'),
	(8, 8, 3, '2014-03-15', '02:48:00'),
	(8, 8, 3, '2014-03-15', '02:12:00'),
	(8, 8, 3, '2014-03-15', '03:24:00'),
	(8, 8, 3, '2014-03-15', '02:05:00'),
	(8, 8, 3, '2014-03-15', '03:14:00'),
	(8, 8, 3, '2014-03-15', '01:39:00'),
	(8, 8, 3, '2014-03-15', '01:33:00'),
	(8, 9, 4, '2014-03-15', '03:02:00'),
	(8, 9, 4, '2014-03-15', '02:16:00'),
	(8, 9, 4, '2014-03-15', '03:10:00'),
	(8, 9, 4, '2014-03-15', '02:40:00'),
	(8, 9, 4, '2014-03-15', '02:19:00'),
	(8, 9, 4, '2014-03-15', '02:05:00'),
	(8, 9, 4, '2014-03-15', '02:00:00'),
	(8, 9, 4, '2014-03-15', '02:15:00'),
	(8, 9, 4, '2014-03-15', '03:44:00'),
	(8, 9, 4, '2014-03-15', '03:06:00'),
	(8, 9, 4, '2014-03-15', '02:48:00'),
	(8, 9, 4, '2014-03-15', '03:14:00'),
	(8, 9, 4, '2014-03-15', '03:49:00'),
	(8, 9, 4, '2014-03-15', '03:00:00'),
	(8, 9, 4, '2014-03-15', '02:02:00'),
	(8, 9, 4, '2014-03-15', '02:08:00'),
	(8, 9, 4, '2014-03-15', '03:04:00'),
	(8, 9, 4, '2014-03-15', '02:32:00'),
	(8, 9, 4, '2014-03-15', '01:59:00'),
	(8, 9, 4, '2014-03-15', '03:15:00'),
	(8, 9, 4, '2014-03-15', '03:55:00'),
	(8, 9, 4, '2014-03-15', '03:27:00'),
	(8, 9, 4, '2014-03-15', '01:32:00'),
	(8, 9, 4, '2014-03-15', '03:13:00'),
	(8, 9, 4, '2014-03-15', '02:35:00'),
	(8, 9, 4, '2014-03-15', '01:50:00'),
	(8, 9, 4, '2014-03-15', '02:20:00'),
	(8, 9, 4, '2014-03-15', '02:15:00'),
	(8, 9, 4, '2014-03-15', '02:44:00'),
	(8, 9, 4, '2014-03-15', '02:59:00'),
	(8, 9, 4, '2014-03-15', '02:48:00'),
	(8, 9, 4, '2014-03-15', '03:34:00'),
	(8, 9, 4, '2014-03-15', '03:01:00'),
	(8, 9, 4, '2014-03-15', '02:52:00'),
	(8, 9, 4, '2014-03-15', '03:48:00'),
	(8, 9, 4, '2014-03-15', '01:33:00'),
	(8, 9, 4, '2014-03-15', '02:13:00'),
	(8, 9, 4, '2014-03-15', '02:28:00'),
	(8, 9, 4, '2014-03-15', '01:45:00'),
	(8, 9, 4, '2014-03-15', '02:21:00'),
	(8, 9, 4, '2014-03-15', '02:32:00'),
	(8, 9, 4, '2014-03-15', '01:41:00'),
	(8, 9, 4, '2014-03-15', '01:47:00'),
	(8, 9, 4, '2014-03-15', '02:23:00'),
	(8, 9, 4, '2014-03-15', '02:37:00'),
	(8, 9, 4, '2014-03-15', '01:57:00'),
	(8, 9, 4, '2014-03-15', '02:55:00'),
	(8, 9, 4, '2014-03-15', '02:19:00'),
	(8, 9, 4, '2014-03-15', '03:46:00'),
	(8, 9, 4, '2014-03-15', '03:05:00'),
	(8, 9, 4, '2014-03-15', '02:37:00'),
	(8, 9, 4, '2014-03-15', '02:22:00'),
	(8, 9, 4, '2014-03-15', '02:30:00'),
	(8, 9, 4, '2014-03-15', '03:52:00'),
	(8, 9, 4, '2014-03-15', '03:00:00'),
	(8, 9, 4, '2014-03-15', '01:54:00'),
	(8, 9, 4, '2014-03-15', '03:56:00'),
	(8, 9, 4, '2014-03-15', '02:40:00'),
	(8, 9, 4, '2014-03-15', '02:29:00'),
	(8, 9, 4, '2014-03-15', '02:56:00'),
	(8, 10, 5, '2014-03-15', '03:37:00'),
	(8, 10, 5, '2014-03-15', '02:20:00'),
	(8, 10, 5, '2014-03-15', '01:38:00'),
	(8, 10, 5, '2014-03-15', '01:58:00'),
	(8, 10, 5, '2014-03-15', '03:29:00'),
	(8, 10, 5, '2014-03-15', '03:06:00'),
	(8, 10, 5, '2014-03-15', '03:32:00'),
	(8, 10, 5, '2014-03-15', '02:16:00'),
	(8, 10, 5, '2014-03-15', '01:34:00'),
	(8, 10, 5, '2014-03-15', '01:50:00'),
	(8, 10, 5, '2014-03-15', '02:57:00'),
	(8, 10, 5, '2014-03-15', '03:08:00'),
	(8, 10, 5, '2014-03-15', '03:00:00'),
	(8, 10, 5, '2014-03-15', '01:49:00'),
	(8, 10, 5, '2014-03-15', '03:12:00'),
	(8, 10, 5, '2014-03-15', '02:06:00'),
	(8, 10, 5, '2014-03-15', '01:45:00'),
	(8, 10, 5, '2014-03-15', '03:15:00'),
	(8, 10, 5, '2014-03-15', '02:35:00'),
	(8, 10, 5, '2014-03-15', '01:41:00'),
	(8, 10, 5, '2014-03-15', '03:47:00'),
	(8, 10, 5, '2014-03-15', '03:08:00'),
	(8, 10, 5, '2014-03-15', '02:47:00'),
	(8, 10, 5, '2014-03-15', '03:05:00'),
	(8, 10, 5, '2014-03-15', '03:13:00'),
	(8, 10, 5, '2014-03-15', '03:01:00'),
	(8, 10, 5, '2014-03-15', '01:37:00'),
	(8, 10, 5, '2014-03-15', '02:09:00'),
	(8, 10, 5, '2014-03-15', '02:09:00'),
	(8, 10, 5, '2014-03-15', '02:45:00'),
	(8, 10, 5, '2014-03-15', '03:32:00'),
	(8, 10, 5, '2014-03-15', '03:18:00'),
	(8, 10, 5, '2014-03-15', '02:05:00'),
	(8, 10, 5, '2014-03-15', '03:39:00'),
	(8, 10, 5, '2014-03-15', '03:32:00'),
	(8, 10, 5, '2014-03-15', '02:54:00'),
	(8, 10, 5, '2014-03-15', '02:25:00'),
	(8, 10, 5, '2014-03-15', '01:54:00'),
	(8, 10, 5, '2014-03-15', '03:02:00'),
	(8, 10, 5, '2014-03-15', '03:24:00'),
	(8, 10, 5, '2014-03-15', '01:45:00'),
	(8, 10, 5, '2014-03-15', '01:42:00'),
	(8, 10, 5, '2014-03-15', '01:43:00'),
	(8, 10, 5, '2014-03-15', '02:02:00'),
	(8, 10, 5, '2014-03-15', '03:29:00'),
	(8, 10, 5, '2014-03-15', '02:56:00'),
	(8, 10, 5, '2014-03-15', '02:40:00'),
	(8, 10, 5, '2014-03-15', '03:04:00'),
	(8, 10, 5, '2014-03-15', '03:34:00'),
	(8, 10, 5, '2014-03-15', '02:27:00'),
	(8, 10, 5, '2014-03-15', '02:22:00'),
	(8, 10, 5, '2014-03-15', '03:02:00'),
	(8, 10, 5, '2014-03-15', '01:55:00'),
	(8, 10, 5, '2014-03-15', '03:37:00'),
	(8, 10, 5, '2014-03-15', '01:36:00'),
	(8, 10, 5, '2014-03-15', '02:34:00'),
	(8, 10, 5, '2014-03-15', '01:57:00'),
	(8, 10, 5, '2014-03-15', '02:54:00'),
	(8, 10, 5, '2014-03-15', '02:28:00'),
	(8, 10, 5, '2014-03-15', '02:11:00'),
	(9, 6, 1, '2014-04-01', '01:55:00'),
	(9, 6, 1, '2014-04-01', '02:18:00'),
	(9, 6, 1, '2014-04-01', '02:16:00'),
	(9, 6, 1, '2014-04-01', '02:58:00'),
	(9, 6, 1, '2014-04-01', '02:37:00'),
	(9, 6, 1, '2014-04-01', '02:40:00'),
	(9, 6, 1, '2014-04-01', '02:04:00'),
	(9, 6, 1, '2014-04-01', '02:49:00'),
	(9, 6, 1, '2014-04-01', '02:24:00'),
	(9, 6, 1, '2014-04-01', '02:07:00'),
	(9, 6, 1, '2014-04-01', '01:51:00'),
	(9, 6, 1, '2014-04-01', '03:24:00'),
	(9, 6, 1, '2014-04-01', '02:03:00'),
	(9, 6, 1, '2014-04-01', '02:33:00'),
	(9, 6, 1, '2014-04-01', '03:06:00'),
	(9, 6, 1, '2014-04-01', '02:28:00'),
	(9, 6, 1, '2014-04-01', '01:30:00'),
	(9, 6, 1, '2014-04-01', '02:35:00'),
	(9, 6, 1, '2014-04-01', '02:59:00'),
	(9, 6, 1, '2014-04-01', '01:42:00'),
	(9, 6, 1, '2014-04-01', '02:03:00'),
	(9, 6, 1, '2014-04-01', '01:39:00'),
	(9, 6, 1, '2014-04-01', '02:35:00'),
	(9, 6, 1, '2014-04-01', '02:31:00'),
	(9, 6, 1, '2014-04-01', '03:20:00'),
	(9, 6, 1, '2014-04-01', '01:43:00'),
	(9, 6, 1, '2014-04-01', '03:01:00'),
	(9, 6, 1, '2014-04-01', '02:30:00'),
	(9, 6, 1, '2014-04-01', '02:01:00'),
	(9, 6, 1, '2014-04-01', '03:01:00'),
	(9, 6, 1, '2014-04-01', '01:41:00'),
	(9, 6, 1, '2014-04-01', '01:48:00'),
	(9, 6, 1, '2014-04-01', '02:28:00'),
	(9, 6, 1, '2014-04-01', '03:26:00'),
	(9, 6, 1, '2014-04-01', '02:22:00'),
	(9, 6, 1, '2014-04-01', '02:03:00'),
	(9, 6, 1, '2014-04-01', '01:40:00'),
	(9, 6, 1, '2014-04-01', '02:37:00'),
	(9, 6, 1, '2014-04-01', '02:41:00'),
	(9, 6, 1, '2014-04-01', '02:06:00'),
	(9, 6, 1, '2014-04-01', '02:55:00'),
	(9, 6, 1, '2014-04-01', '02:54:00'),
	(9, 6, 1, '2014-04-01', '02:16:00'),
	(9, 6, 1, '2014-04-01', '03:06:00'),
	(9, 6, 1, '2014-04-01', '03:19:00'),
	(9, 6, 1, '2014-04-01', '01:50:00'),
	(9, 6, 1, '2014-04-01', '01:38:00'),
	(9, 6, 1, '2014-04-01', '03:11:00'),
	(9, 6, 1, '2014-04-01', '01:37:00'),
	(9, 6, 1, '2014-04-01', '02:56:00'),
	(9, 6, 1, '2014-04-01', '02:29:00'),
	(9, 6, 1, '2014-04-01', '02:04:00'),
	(9, 6, 1, '2014-04-01', '03:24:00'),
	(9, 6, 1, '2014-04-01', '03:22:00'),
	(9, 6, 1, '2014-04-01', '03:10:00'),
	(9, 6, 1, '2014-04-01', '02:20:00'),
	(9, 6, 1, '2014-04-01', '02:35:00'),
	(9, 6, 1, '2014-04-01', '02:29:00'),
	(9, 6, 1, '2014-04-01', '03:09:00'),
	(9, 6, 1, '2014-04-01', '02:54:00'),
	(9, 7, 2, '2014-04-01', '01:46:00'),
	(9, 7, 2, '2014-04-01', '02:29:00'),
	(9, 7, 2, '2014-04-01', '01:57:00'),
	(9, 7, 2, '2014-04-01', '02:40:00'),
	(9, 7, 2, '2014-04-01', '02:15:00'),
	(9, 7, 2, '2014-04-01', '01:44:00'),
	(9, 7, 2, '2014-04-01', '02:20:00'),
	(9, 7, 2, '2014-04-01', '03:07:00'),
	(9, 7, 2, '2014-04-01', '03:21:00'),
	(9, 7, 2, '2014-04-01', '02:09:00'),
	(9, 7, 2, '2014-04-01', '02:59:00'),
	(9, 7, 2, '2014-04-01', '03:12:00'),
	(9, 7, 2, '2014-04-01', '01:49:00'),
	(9, 7, 2, '2014-04-01', '01:47:00'),
	(9, 7, 2, '2014-04-01', '01:55:00'),
	(9, 7, 2, '2014-04-01', '02:46:00'),
	(9, 7, 2, '2014-04-01', '02:49:00'),
	(9, 7, 2, '2014-04-01', '02:29:00'),
	(9, 7, 2, '2014-04-01', '02:25:00'),
	(9, 7, 2, '2014-04-01', '03:12:00'),
	(9, 7, 2, '2014-04-01', '01:36:00'),
	(9, 7, 2, '2014-04-01', '02:34:00'),
	(9, 7, 2, '2014-04-01', '02:47:00'),
	(9, 7, 2, '2014-04-01', '02:51:00'),
	(9, 7, 2, '2014-04-01', '02:31:00'),
	(9, 7, 2, '2014-04-01', '02:34:00'),
	(9, 7, 2, '2014-04-01', '01:56:00'),
	(9, 7, 2, '2014-04-01', '02:22:00'),
	(9, 7, 2, '2014-04-01', '02:38:00'),
	(9, 7, 2, '2014-04-01', '02:43:00'),
	(9, 7, 2, '2014-04-01', '02:18:00'),
	(9, 7, 2, '2014-04-01', '01:53:00'),
	(9, 7, 2, '2014-04-01', '02:54:00'),
	(9, 7, 2, '2014-04-01', '01:46:00'),
	(9, 7, 2, '2014-04-01', '02:21:00'),
	(9, 7, 2, '2014-04-01', '03:05:00'),
	(9, 7, 2, '2014-04-01', '03:10:00'),
	(9, 7, 2, '2014-04-01', '03:13:00'),
	(9, 7, 2, '2014-04-01', '03:15:00'),
	(9, 7, 2, '2014-04-01', '03:14:00'),
	(9, 7, 2, '2014-04-01', '03:04:00'),
	(9, 7, 2, '2014-04-01', '02:15:00'),
	(9, 7, 2, '2014-04-01', '02:27:00'),
	(9, 7, 2, '2014-04-01', '02:08:00'),
	(9, 7, 2, '2014-04-01', '01:51:00'),
	(9, 7, 2, '2014-04-01', '03:12:00'),
	(9, 7, 2, '2014-04-01', '01:30:00'),
	(9, 7, 2, '2014-04-01', '02:02:00'),
	(9, 7, 2, '2014-04-01', '02:15:00'),
	(9, 7, 2, '2014-04-01', '01:51:00'),
	(9, 7, 2, '2014-04-01', '02:52:00'),
	(9, 7, 2, '2014-04-01', '01:42:00'),
	(9, 7, 2, '2014-04-01', '02:07:00'),
	(9, 7, 2, '2014-04-01', '02:10:00'),
	(9, 7, 2, '2014-04-01', '02:56:00'),
	(9, 7, 2, '2014-04-01', '02:59:00'),
	(9, 7, 2, '2014-04-01', '02:46:00'),
	(9, 7, 2, '2014-04-01', '01:32:00'),
	(9, 7, 2, '2014-04-01', '01:37:00'),
	(9, 7, 2, '2014-04-01', '01:59:00'),
	(9, 8, 3, '2014-04-01', '03:01:00'),
	(9, 8, 3, '2014-04-01', '02:45:00'),
	(9, 8, 3, '2014-04-01', '03:11:00'),
	(9, 8, 3, '2014-04-01', '02:22:00'),
	(9, 8, 3, '2014-04-01', '02:42:00'),
	(9, 8, 3, '2014-04-01', '03:01:00'),
	(9, 8, 3, '2014-04-01', '01:42:00'),
	(9, 8, 3, '2014-04-01', '01:43:00'),
	(9, 8, 3, '2014-04-01', '02:02:00'),
	(9, 8, 3, '2014-04-01', '01:35:00'),
	(9, 8, 3, '2014-04-01', '02:16:00'),
	(9, 8, 3, '2014-04-01', '03:11:00'),
	(9, 8, 3, '2014-04-01', '01:56:00'),
	(9, 8, 3, '2014-04-01', '02:23:00'),
	(9, 8, 3, '2014-04-01', '02:46:00'),
	(9, 8, 3, '2014-04-01', '03:17:00'),
	(9, 8, 3, '2014-04-01', '02:51:00'),
	(9, 8, 3, '2014-04-01', '02:51:00'),
	(9, 8, 3, '2014-04-01', '02:21:00'),
	(9, 8, 3, '2014-04-01', '01:44:00'),
	(9, 8, 3, '2014-04-01', '01:58:00'),
	(9, 8, 3, '2014-04-01', '03:12:00'),
	(9, 8, 3, '2014-04-01', '02:51:00'),
	(9, 8, 3, '2014-04-01', '03:12:00'),
	(9, 8, 3, '2014-04-01', '02:08:00'),
	(9, 8, 3, '2014-04-01', '01:30:00'),
	(9, 8, 3, '2014-04-01', '03:22:00'),
	(9, 8, 3, '2014-04-01', '03:17:00'),
	(9, 8, 3, '2014-04-01', '02:53:00'),
	(9, 8, 3, '2014-04-01', '03:07:00'),
	(9, 8, 3, '2014-04-01', '01:36:00'),
	(9, 8, 3, '2014-04-01', '02:53:00'),
	(9, 8, 3, '2014-04-01', '02:26:00'),
	(9, 8, 3, '2014-04-01', '02:00:00'),
	(9, 8, 3, '2014-04-01', '03:08:00'),
	(9, 8, 3, '2014-04-01', '02:28:00'),
	(9, 8, 3, '2014-04-01', '03:22:00'),
	(9, 8, 3, '2014-04-01', '02:15:00'),
	(9, 8, 3, '2014-04-01', '01:34:00'),
	(9, 8, 3, '2014-04-01', '03:21:00'),
	(9, 8, 3, '2014-04-01', '02:59:00'),
	(9, 8, 3, '2014-04-01', '03:23:00'),
	(9, 8, 3, '2014-04-01', '02:38:00'),
	(9, 8, 3, '2014-04-01', '01:34:00'),
	(9, 8, 3, '2014-04-01', '02:13:00'),
	(9, 8, 3, '2014-04-01', '03:00:00'),
	(9, 8, 3, '2014-04-01', '03:04:00'),
	(9, 8, 3, '2014-04-01', '02:55:00'),
	(9, 8, 3, '2014-04-01', '02:02:00'),
	(9, 8, 3, '2014-04-01', '01:48:00'),
	(9, 8, 3, '2014-04-01', '03:17:00'),
	(9, 8, 3, '2014-04-01', '01:57:00'),
	(9, 8, 3, '2014-04-01', '02:12:00'),
	(9, 8, 3, '2014-04-01', '01:46:00'),
	(9, 8, 3, '2014-04-01', '02:39:00'),
	(9, 8, 3, '2014-04-01', '02:38:00'),
	(9, 8, 3, '2014-04-01', '01:48:00'),
	(9, 8, 3, '2014-04-01', '01:32:00'),
	(9, 8, 3, '2014-04-01', '02:42:00'),
	(9, 8, 3, '2014-04-01', '01:43:00'),
	(9, 9, 4, '2014-04-01', '01:37:00'),
	(9, 9, 4, '2014-04-01', '02:02:00'),
	(9, 9, 4, '2014-04-01', '01:30:00'),
	(9, 9, 4, '2014-04-01', '02:13:00'),
	(9, 9, 4, '2014-04-01', '02:49:00'),
	(9, 9, 4, '2014-04-01', '03:39:00'),
	(9, 9, 4, '2014-04-01', '03:44:00'),
	(9, 9, 4, '2014-04-01', '01:39:00'),
	(9, 9, 4, '2014-04-01', '02:26:00'),
	(9, 9, 4, '2014-04-01', '03:24:00'),
	(9, 9, 4, '2014-04-01', '03:39:00'),
	(9, 9, 4, '2014-04-01', '02:01:00'),
	(9, 9, 4, '2014-04-01', '02:14:00'),
	(9, 9, 4, '2014-04-01', '03:35:00'),
	(9, 9, 4, '2014-04-01', '02:52:00'),
	(9, 9, 4, '2014-04-01', '02:07:00'),
	(9, 9, 4, '2014-04-01', '02:45:00'),
	(9, 9, 4, '2014-04-01', '03:37:00'),
	(9, 9, 4, '2014-04-01', '01:30:00'),
	(9, 9, 4, '2014-04-01', '02:03:00'),
	(9, 9, 4, '2014-04-01', '01:56:00'),
	(9, 9, 4, '2014-04-01', '02:02:00'),
	(9, 9, 4, '2014-04-01', '02:52:00'),
	(9, 9, 4, '2014-04-01', '02:09:00'),
	(9, 9, 4, '2014-04-01', '02:57:00'),
	(9, 9, 4, '2014-04-01', '02:15:00'),
	(9, 9, 4, '2014-04-01', '03:12:00'),
	(9, 9, 4, '2014-04-01', '03:11:00'),
	(9, 9, 4, '2014-04-01', '02:32:00'),
	(9, 9, 4, '2014-04-01', '01:39:00'),
	(9, 9, 4, '2014-04-01', '03:44:00'),
	(9, 9, 4, '2014-04-01', '03:07:00'),
	(9, 9, 4, '2014-04-01', '02:50:00'),
	(9, 9, 4, '2014-04-01', '03:22:00'),
	(9, 9, 4, '2014-04-01', '02:17:00'),
	(9, 9, 4, '2014-04-01', '02:05:00'),
	(9, 9, 4, '2014-04-01', '02:05:00'),
	(9, 9, 4, '2014-04-01', '02:40:00'),
	(9, 9, 4, '2014-04-01', '03:20:00'),
	(9, 9, 4, '2014-04-01', '02:37:00'),
	(9, 9, 4, '2014-04-01', '01:36:00'),
	(9, 9, 4, '2014-04-01', '03:12:00'),
	(9, 9, 4, '2014-04-01', '02:54:00'),
	(9, 9, 4, '2014-04-01', '03:21:00'),
	(9, 9, 4, '2014-04-01', '02:03:00'),
	(9, 9, 4, '2014-04-01', '03:15:00'),
	(9, 9, 4, '2014-04-01', '01:44:00'),
	(9, 9, 4, '2014-04-01', '02:01:00'),
	(9, 9, 4, '2014-04-01', '03:22:00'),
	(9, 9, 4, '2014-04-01', '02:29:00'),
	(9, 9, 4, '2014-04-01', '03:07:00'),
	(9, 9, 4, '2014-04-01', '02:02:00'),
	(9, 9, 4, '2014-04-01', '01:39:00'),
	(9, 9, 4, '2014-04-01', '02:55:00'),
	(9, 9, 4, '2014-04-01', '03:37:00'),
	(9, 9, 4, '2014-04-01', '03:14:00'),
	(9, 9, 4, '2014-04-01', '01:34:00'),
	(9, 9, 4, '2014-04-01', '03:28:00'),
	(9, 9, 4, '2014-04-01', '02:03:00'),
	(9, 9, 4, '2014-04-01', '02:53:00'),
	(9, 10, 5, '2014-04-01', '02:56:00'),
	(9, 10, 5, '2014-04-01', '02:46:00'),
	(9, 10, 5, '2014-04-01', '01:30:00'),
	(9, 10, 5, '2014-04-01', '01:45:00'),
	(9, 10, 5, '2014-04-01', '02:49:00'),
	(9, 10, 5, '2014-04-01', '03:14:00'),
	(9, 10, 5, '2014-04-01', '02:11:00'),
	(9, 10, 5, '2014-04-01', '01:45:00'),
	(9, 10, 5, '2014-04-01', '02:44:00'),
	(9, 10, 5, '2014-04-01', '02:50:00'),
	(9, 10, 5, '2014-04-01', '02:27:00'),
	(9, 10, 5, '2014-04-01', '02:16:00'),
	(9, 10, 5, '2014-04-01', '02:30:00'),
	(9, 10, 5, '2014-04-01', '02:10:00'),
	(9, 10, 5, '2014-04-01', '01:49:00'),
	(9, 10, 5, '2014-04-01', '03:10:00'),
	(9, 10, 5, '2014-04-01', '02:45:00'),
	(9, 10, 5, '2014-04-01', '02:47:00'),
	(9, 10, 5, '2014-04-01', '02:06:00'),
	(9, 10, 5, '2014-04-01', '02:45:00'),
	(9, 10, 5, '2014-04-01', '01:53:00'),
	(9, 10, 5, '2014-04-01', '01:41:00'),
	(9, 10, 5, '2014-04-01', '03:20:00'),
	(9, 10, 5, '2014-04-01', '02:00:00'),
	(9, 10, 5, '2014-04-01', '02:34:00'),
	(9, 10, 5, '2014-04-01', '03:16:00'),
	(9, 10, 5, '2014-04-01', '03:08:00'),
	(9, 10, 5, '2014-04-01', '02:19:00'),
	(9, 10, 5, '2014-04-01', '02:46:00'),
	(9, 10, 5, '2014-04-01', '03:18:00'),
	(9, 10, 5, '2014-04-01', '02:40:00'),
	(9, 10, 5, '2014-04-01', '01:56:00'),
	(9, 10, 5, '2014-04-01', '02:13:00'),
	(9, 10, 5, '2014-04-01', '01:47:00'),
	(9, 10, 5, '2014-04-01', '02:46:00'),
	(9, 10, 5, '2014-04-01', '02:55:00'),
	(9, 10, 5, '2014-04-01', '02:47:00'),
	(9, 10, 5, '2014-04-01', '01:38:00'),
	(9, 10, 5, '2014-04-01', '02:23:00'),
	(9, 10, 5, '2014-04-01', '01:30:00'),
	(9, 10, 5, '2014-04-01', '02:52:00'),
	(9, 10, 5, '2014-04-01', '02:16:00'),
	(9, 10, 5, '2014-04-01', '03:15:00'),
	(9, 10, 5, '2014-04-01', '01:51:00'),
	(9, 10, 5, '2014-04-01', '02:05:00'),
	(9, 10, 5, '2014-04-01', '03:24:00'),
	(9, 10, 5, '2014-04-01', '03:10:00'),
	(9, 10, 5, '2014-04-01', '02:06:00'),
	(9, 10, 5, '2014-04-01', '01:33:00'),
	(9, 10, 5, '2014-04-01', '01:58:00'),
	(9, 10, 5, '2014-04-01', '01:39:00'),
	(9, 10, 5, '2014-04-01', '02:53:00'),
	(9, 10, 5, '2014-04-01', '01:55:00'),
	(9, 10, 5, '2014-04-01', '03:31:00'),
	(9, 10, 5, '2014-04-01', '02:13:00'),
	(9, 10, 5, '2014-04-01', '03:04:00'),
	(9, 10, 5, '2014-04-01', '03:10:00'),
	(9, 10, 5, '2014-04-01', '03:07:00'),
	(9, 10, 5, '2014-04-01', '02:34:00'),
	(9, 10, 5, '2014-04-01', '01:59:00'),
	(16, 11, 9, '2015-01-01', '02:07:00'),
	(16, 11, 9, '2015-01-01', '02:48:00'),
	(16, 11, 9, '2015-01-01', '03:45:00'),
	(16, 11, 9, '2015-01-01', '01:35:00'),
	(16, 11, 9, '2015-01-01', '02:27:00'),
	(16, 11, 9, '2015-01-01', '03:33:00'),
	(16, 11, 9, '2015-01-01', '01:37:00'),
	(16, 11, 9, '2015-01-01', '03:15:00'),
	(16, 11, 9, '2015-01-01', '02:36:00'),
	(16, 11, 9, '2015-01-01', '01:46:00'),
	(16, 11, 9, '2015-01-01', '01:58:00'),
	(16, 11, 9, '2015-01-01', '03:01:00'),
	(16, 11, 9, '2015-01-01', '02:52:00'),
	(16, 11, 9, '2015-01-01', '03:49:00'),
	(16, 11, 9, '2015-01-01', '01:38:00'),
	(16, 11, 9, '2015-01-01', '02:34:00'),
	(16, 11, 9, '2015-01-01', '01:35:00'),
	(16, 11, 9, '2015-01-01', '03:33:00'),
	(16, 11, 9, '2015-01-01', '01:48:00'),
	(16, 11, 9, '2015-01-01', '01:44:00'),
	(16, 11, 9, '2015-01-01', '01:47:00'),
	(16, 11, 9, '2015-01-01', '02:14:00'),
	(16, 11, 9, '2015-01-01', '01:52:00'),
	(16, 11, 9, '2015-01-01', '03:36:00'),
	(16, 11, 9, '2015-01-01', '03:36:00'),
	(16, 11, 9, '2015-01-01', '03:17:00'),
	(16, 11, 9, '2015-01-01', '01:41:00'),
	(16, 11, 9, '2015-01-01', '01:55:00'),
	(16, 11, 9, '2015-01-01', '03:02:00'),
	(16, 11, 9, '2015-01-01', '03:04:00'),
	(16, 11, 9, '2015-01-01', '02:21:00'),
	(16, 11, 9, '2015-01-01', '03:27:00'),
	(16, 11, 9, '2015-01-01', '03:53:00'),
	(16, 11, 9, '2015-01-01', '02:40:00'),
	(16, 11, 9, '2015-01-01', '02:36:00'),
	(16, 11, 9, '2015-01-01', '03:34:00'),
	(16, 11, 9, '2015-01-01', '03:38:00'),
	(16, 11, 9, '2015-01-01', '03:33:00'),
	(16, 11, 9, '2015-01-01', '02:57:00'),
	(16, 11, 9, '2015-01-01', '02:38:00'),
	(16, 11, 9, '2015-01-01', '02:47:00'),
	(16, 11, 9, '2015-01-01', '02:05:00'),
	(16, 11, 9, '2015-01-01', '03:02:00'),
	(16, 11, 9, '2015-01-01', '02:31:00'),
	(16, 11, 9, '2015-01-01', '02:01:00'),
	(16, 11, 9, '2015-01-01', '03:27:00'),
	(16, 11, 9, '2015-01-01', '02:26:00'),
	(16, 11, 9, '2015-01-01', '02:43:00'),
	(16, 11, 9, '2015-01-01', '02:25:00'),
	(16, 11, 9, '2015-01-01', '02:23:00'),
	(16, 11, 9, '2015-01-01', '03:13:00'),
	(16, 11, 9, '2015-01-01', '02:35:00'),
	(16, 11, 9, '2015-01-01', '01:44:00'),
	(16, 11, 9, '2015-01-01', '01:51:00'),
	(16, 11, 9, '2015-01-01', '02:34:00'),
	(16, 11, 9, '2015-01-01', '03:22:00'),
	(16, 11, 9, '2015-01-01', '02:49:00'),
	(16, 11, 9, '2015-01-01', '02:26:00'),
	(16, 11, 9, '2015-01-01', '02:15:00'),
	(16, 11, 9, '2015-01-01', '02:27:00'),
	(16, 12, 10, '2015-01-01', '03:15:00'),
	(16, 12, 10, '2015-01-01', '02:45:00'),
	(16, 12, 10, '2015-01-01', '02:31:00'),
	(16, 12, 10, '2015-01-01', '02:51:00'),
	(16, 12, 10, '2015-01-01', '01:31:00'),
	(16, 12, 10, '2015-01-01', '03:06:00'),
	(16, 12, 10, '2015-01-01', '02:04:00'),
	(16, 12, 10, '2015-01-01', '03:14:00'),
	(16, 12, 10, '2015-01-01', '02:55:00'),
	(16, 12, 10, '2015-01-01', '01:34:00'),
	(16, 12, 10, '2015-01-01', '03:09:00'),
	(16, 12, 10, '2015-01-01', '02:08:00'),
	(16, 12, 10, '2015-01-01', '01:34:00'),
	(16, 12, 10, '2015-01-01', '01:46:00'),
	(16, 12, 10, '2015-01-01', '02:41:00'),
	(16, 12, 10, '2015-01-01', '02:55:00'),
	(16, 12, 10, '2015-01-01', '03:13:00'),
	(16, 12, 10, '2015-01-01', '02:06:00'),
	(16, 12, 10, '2015-01-01', '03:06:00'),
	(16, 12, 10, '2015-01-01', '02:07:00'),
	(16, 12, 10, '2015-01-01', '01:40:00'),
	(16, 12, 10, '2015-01-01', '02:22:00'),
	(16, 12, 10, '2015-01-01', '01:35:00'),
	(16, 12, 10, '2015-01-01', '03:04:00'),
	(16, 12, 10, '2015-01-01', '01:41:00'),
	(16, 12, 10, '2015-01-01', '03:14:00'),
	(16, 12, 10, '2015-01-01', '02:17:00'),
	(16, 12, 10, '2015-01-01', '02:02:00'),
	(16, 12, 10, '2015-01-01', '01:50:00'),
	(16, 12, 10, '2015-01-01', '01:35:00'),
	(16, 12, 10, '2015-01-01', '02:45:00'),
	(16, 12, 10, '2015-01-01', '01:57:00'),
	(16, 12, 10, '2015-01-01', '01:53:00'),
	(16, 12, 10, '2015-01-01', '02:03:00'),
	(16, 12, 10, '2015-01-01', '03:09:00'),
	(16, 12, 10, '2015-01-01', '02:31:00'),
	(16, 12, 10, '2015-01-01', '01:38:00'),
	(16, 12, 10, '2015-01-01', '02:51:00'),
	(16, 12, 10, '2015-01-01', '02:17:00'),
	(16, 12, 10, '2015-01-01', '03:13:00'),
	(16, 12, 10, '2015-01-01', '02:12:00'),
	(16, 12, 10, '2015-01-01', '01:44:00'),
	(16, 12, 10, '2015-01-01', '02:23:00'),
	(16, 12, 10, '2015-01-01', '01:31:00'),
	(16, 12, 10, '2015-01-01', '02:40:00'),
	(16, 12, 10, '2015-01-01', '01:42:00'),
	(16, 12, 10, '2015-01-01', '02:46:00'),
	(16, 12, 10, '2015-01-01', '01:39:00'),
	(16, 12, 10, '2015-01-01', '02:12:00'),
	(16, 12, 10, '2015-01-01', '02:43:00'),
	(16, 12, 10, '2015-01-01', '01:47:00'),
	(16, 12, 10, '2015-01-01', '02:58:00'),
	(16, 12, 10, '2015-01-01', '02:29:00'),
	(16, 12, 10, '2015-01-01', '01:58:00'),
	(16, 12, 10, '2015-01-01', '02:45:00'),
	(16, 12, 10, '2015-01-01', '02:39:00'),
	(16, 12, 10, '2015-01-01', '01:42:00'),
	(16, 12, 10, '2015-01-01', '02:46:00'),
	(16, 12, 10, '2015-01-01', '01:39:00'),
	(16, 12, 10, '2015-01-01', '02:10:00'),
	(16, 13, 11, '2015-01-01', '03:00:00'),
	(16, 13, 11, '2015-01-01', '03:13:00'),
	(16, 13, 11, '2015-01-01', '03:21:00'),
	(16, 13, 11, '2015-01-01', '03:24:00'),
	(16, 13, 11, '2015-01-01', '03:15:00'),
	(16, 13, 11, '2015-01-01', '02:21:00'),
	(16, 13, 11, '2015-01-01', '02:43:00'),
	(16, 13, 11, '2015-01-01', '02:51:00'),
	(16, 13, 11, '2015-01-01', '02:26:00'),
	(16, 13, 11, '2015-01-01', '02:06:00'),
	(16, 13, 11, '2015-01-01', '01:44:00'),
	(16, 13, 11, '2015-01-01', '03:03:00'),
	(16, 13, 11, '2015-01-01', '01:56:00'),
	(16, 13, 11, '2015-01-01', '03:26:00'),
	(16, 13, 11, '2015-01-01', '03:19:00'),
	(16, 13, 11, '2015-01-01', '02:35:00'),
	(16, 13, 11, '2015-01-01', '03:39:00'),
	(16, 13, 11, '2015-01-01', '02:26:00'),
	(16, 13, 11, '2015-01-01', '01:53:00'),
	(16, 13, 11, '2015-01-01', '02:53:00'),
	(16, 13, 11, '2015-01-01', '02:51:00'),
	(16, 13, 11, '2015-01-01', '01:53:00'),
	(16, 13, 11, '2015-01-01', '01:33:00'),
	(16, 13, 11, '2015-01-01', '02:52:00'),
	(16, 13, 11, '2015-01-01', '01:34:00'),
	(16, 13, 11, '2015-01-01', '02:09:00'),
	(16, 13, 11, '2015-01-01', '02:22:00'),
	(16, 13, 11, '2015-01-01', '01:41:00'),
	(16, 13, 11, '2015-01-01', '02:01:00'),
	(16, 13, 11, '2015-01-01', '03:31:00'),
	(16, 13, 11, '2015-01-01', '03:28:00'),
	(16, 13, 11, '2015-01-01', '03:06:00'),
	(16, 13, 11, '2015-01-01', '03:37:00'),
	(16, 13, 11, '2015-01-01', '02:52:00'),
	(16, 13, 11, '2015-01-01', '01:59:00'),
	(16, 13, 11, '2015-01-01', '02:03:00'),
	(16, 13, 11, '2015-01-01', '02:47:00'),
	(16, 13, 11, '2015-01-01', '01:54:00'),
	(16, 13, 11, '2015-01-01', '01:50:00'),
	(16, 13, 11, '2015-01-01', '02:01:00'),
	(16, 13, 11, '2015-01-01', '03:05:00'),
	(16, 13, 11, '2015-01-01', '03:28:00'),
	(16, 13, 11, '2015-01-01', '02:10:00'),
	(16, 13, 11, '2015-01-01', '03:20:00'),
	(16, 13, 11, '2015-01-01', '02:04:00'),
	(16, 13, 11, '2015-01-01', '03:16:00'),
	(16, 13, 11, '2015-01-01', '02:03:00'),
	(16, 13, 11, '2015-01-01', '03:20:00'),
	(16, 13, 11, '2015-01-01', '02:25:00'),
	(16, 13, 11, '2015-01-01', '02:47:00'),
	(16, 13, 11, '2015-01-01', '03:00:00'),
	(16, 13, 11, '2015-01-01', '02:58:00'),
	(16, 13, 11, '2015-01-01', '02:08:00'),
	(16, 13, 11, '2015-01-01', '02:30:00'),
	(16, 13, 11, '2015-01-01', '02:25:00'),
	(16, 13, 11, '2015-01-01', '03:06:00'),
	(16, 13, 11, '2015-01-01', '02:19:00'),
	(16, 13, 11, '2015-01-01', '03:01:00'),
	(16, 13, 11, '2015-01-01', '02:15:00'),
	(16, 13, 11, '2015-01-01', '02:56:00'),
	(16, 15, 12, '2015-01-01', '01:46:00'),
	(16, 15, 12, '2015-01-01', '01:33:00'),
	(16, 15, 12, '2015-01-01', '02:58:00'),
	(16, 15, 12, '2015-01-01', '02:45:00'),
	(16, 15, 12, '2015-01-01', '03:24:00'),
	(16, 15, 12, '2015-01-01', '03:18:00'),
	(16, 15, 12, '2015-01-01', '02:51:00'),
	(16, 15, 12, '2015-01-01', '02:52:00'),
	(16, 15, 12, '2015-01-01', '02:20:00'),
	(16, 15, 12, '2015-01-01', '01:32:00'),
	(16, 15, 12, '2015-01-01', '03:10:00'),
	(16, 15, 12, '2015-01-01', '01:49:00'),
	(16, 15, 12, '2015-01-01', '02:04:00'),
	(16, 15, 12, '2015-01-01', '03:21:00'),
	(16, 15, 12, '2015-01-01', '03:13:00'),
	(16, 15, 12, '2015-01-01', '02:31:00'),
	(16, 15, 12, '2015-01-01', '03:25:00'),
	(16, 15, 12, '2015-01-01', '02:10:00'),
	(16, 15, 12, '2015-01-01', '03:00:00'),
	(16, 15, 12, '2015-01-01', '03:04:00'),
	(16, 15, 12, '2015-01-01', '02:55:00'),
	(16, 15, 12, '2015-01-01', '01:55:00'),
	(16, 15, 12, '2015-01-01', '03:14:00'),
	(16, 15, 12, '2015-01-01', '03:03:00'),
	(16, 15, 12, '2015-01-01', '02:05:00'),
	(16, 15, 12, '2015-01-01', '01:43:00'),
	(16, 15, 12, '2015-01-01', '02:48:00'),
	(16, 15, 12, '2015-01-01', '01:31:00'),
	(16, 15, 12, '2015-01-01', '01:35:00'),
	(16, 15, 12, '2015-01-01', '01:52:00'),
	(16, 15, 12, '2015-01-01', '03:08:00'),
	(16, 15, 12, '2015-01-01', '02:40:00'),
	(16, 15, 12, '2015-01-01', '02:28:00'),
	(16, 15, 12, '2015-01-01', '02:47:00'),
	(16, 15, 12, '2015-01-01', '03:06:00'),
	(16, 15, 12, '2015-01-01', '01:41:00'),
	(16, 15, 12, '2015-01-01', '01:34:00'),
	(16, 15, 12, '2015-01-01', '03:18:00'),
	(16, 15, 12, '2015-01-01', '02:24:00'),
	(16, 15, 12, '2015-01-01', '02:37:00'),
	(16, 15, 12, '2015-01-01', '02:25:00'),
	(16, 15, 12, '2015-01-01', '02:45:00'),
	(16, 15, 12, '2015-01-01', '03:02:00'),
	(16, 15, 12, '2015-01-01', '03:26:00'),
	(16, 15, 12, '2015-01-01', '02:38:00'),
	(16, 15, 12, '2015-01-01', '03:20:00'),
	(16, 15, 12, '2015-01-01', '03:20:00'),
	(16, 15, 12, '2015-01-01', '03:15:00'),
	(16, 15, 12, '2015-01-01', '02:45:00'),
	(16, 15, 12, '2015-01-01', '02:33:00'),
	(16, 15, 12, '2015-01-01', '03:00:00'),
	(16, 15, 12, '2015-01-01', '01:56:00'),
	(16, 15, 12, '2015-01-01', '03:04:00'),
	(16, 15, 12, '2015-01-01', '02:10:00'),
	(16, 15, 12, '2015-01-01', '02:08:00'),
	(16, 15, 12, '2015-01-01', '02:37:00'),
	(16, 15, 12, '2015-01-01', '03:17:00'),
	(16, 15, 12, '2015-01-01', '03:06:00'),
	(16, 15, 12, '2015-01-01', '02:11:00'),
	(16, 15, 12, '2015-01-01', '02:07:00'),
	(16, 14, 13, '2015-01-01', '02:59:00'),
	(16, 14, 13, '2015-01-01', '03:17:00'),
	(16, 14, 13, '2015-01-01', '01:38:00'),
	(16, 14, 13, '2015-01-01', '03:22:00'),
	(16, 14, 13, '2015-01-01', '01:42:00'),
	(16, 14, 13, '2015-01-01', '03:29:00'),
	(16, 14, 13, '2015-01-01', '02:05:00'),
	(16, 14, 13, '2015-01-01', '02:49:00'),
	(16, 14, 13, '2015-01-01', '01:58:00'),
	(16, 14, 13, '2015-01-01', '02:04:00'),
	(16, 14, 13, '2015-01-01', '02:57:00'),
	(16, 14, 13, '2015-01-01', '02:44:00'),
	(16, 14, 13, '2015-01-01', '03:17:00'),
	(16, 14, 13, '2015-01-01', '02:22:00'),
	(16, 14, 13, '2015-01-01', '02:39:00'),
	(16, 14, 13, '2015-01-01', '02:28:00'),
	(16, 14, 13, '2015-01-01', '02:54:00'),
	(16, 14, 13, '2015-01-01', '03:26:00'),
	(16, 14, 13, '2015-01-01', '02:36:00'),
	(16, 14, 13, '2015-01-01', '03:23:00'),
	(16, 14, 13, '2015-01-01', '03:15:00'),
	(16, 14, 13, '2015-01-01', '02:25:00'),
	(16, 14, 13, '2015-01-01', '03:04:00'),
	(16, 14, 13, '2015-01-01', '02:12:00'),
	(16, 14, 13, '2015-01-01', '02:30:00'),
	(16, 14, 13, '2015-01-01', '02:11:00'),
	(16, 14, 13, '2015-01-01', '01:59:00'),
	(16, 14, 13, '2015-01-01', '01:52:00'),
	(16, 14, 13, '2015-01-01', '01:53:00'),
	(16, 14, 13, '2015-01-01', '02:19:00'),
	(16, 14, 13, '2015-01-01', '02:17:00'),
	(16, 14, 13, '2015-01-01', '02:58:00'),
	(16, 14, 13, '2015-01-01', '02:09:00'),
	(16, 14, 13, '2015-01-01', '02:32:00'),
	(16, 14, 13, '2015-01-01', '02:32:00'),
	(16, 14, 13, '2015-01-01', '03:33:00'),
	(16, 14, 13, '2015-01-01', '02:06:00'),
	(16, 14, 13, '2015-01-01', '02:45:00'),
	(16, 14, 13, '2015-01-01', '01:33:00'),
	(16, 14, 13, '2015-01-01', '02:25:00'),
	(16, 14, 13, '2015-01-01', '01:34:00'),
	(16, 14, 13, '2015-01-01', '03:28:00'),
	(16, 14, 13, '2015-01-01', '02:25:00'),
	(16, 14, 13, '2015-01-01', '02:22:00'),
	(16, 14, 13, '2015-01-01', '03:05:00'),
	(16, 14, 13, '2015-01-01', '02:28:00'),
	(16, 14, 13, '2015-01-01', '01:34:00'),
	(16, 14, 13, '2015-01-01', '03:19:00'),
	(16, 14, 13, '2015-01-01', '01:42:00'),
	(16, 14, 13, '2015-01-01', '03:34:00'),
	(16, 14, 13, '2015-01-01', '02:29:00'),
	(16, 14, 13, '2015-01-01', '02:26:00'),
	(16, 14, 13, '2015-01-01', '03:15:00'),
	(16, 14, 13, '2015-01-01', '03:05:00'),
	(16, 14, 13, '2015-01-01', '02:01:00'),
	(16, 14, 13, '2015-01-01', '03:39:00'),
	(16, 14, 13, '2015-01-01', '02:02:00'),
	(16, 14, 13, '2015-01-01', '02:04:00'),
	(16, 14, 13, '2015-01-01', '02:47:00'),
	(16, 14, 13, '2015-01-01', '01:48:00'),
	(15, 11, 9, '2015-01-15', '02:11:00'),
	(15, 11, 9, '2015-01-15', '02:56:00'),
	(15, 11, 9, '2015-01-15', '01:44:00'),
	(15, 11, 9, '2015-01-15', '03:14:00'),
	(15, 11, 9, '2015-01-15', '02:09:00'),
	(15, 11, 9, '2015-01-15', '02:02:00'),
	(15, 11, 9, '2015-01-15', '02:13:00'),
	(15, 11, 9, '2015-01-15', '03:29:00'),
	(15, 11, 9, '2015-01-15', '01:57:00'),
	(15, 11, 9, '2015-01-15', '02:41:00'),
	(15, 11, 9, '2015-01-15', '03:37:00'),
	(15, 11, 9, '2015-01-15', '03:38:00'),
	(15, 11, 9, '2015-01-15', '03:25:00'),
	(15, 11, 9, '2015-01-15', '02:12:00'),
	(15, 11, 9, '2015-01-15', '01:43:00'),
	(15, 11, 9, '2015-01-15', '02:58:00'),
	(15, 11, 9, '2015-01-15', '03:18:00'),
	(15, 11, 9, '2015-01-15', '03:39:00'),
	(15, 11, 9, '2015-01-15', '01:59:00'),
	(15, 11, 9, '2015-01-15', '02:21:00'),
	(15, 11, 9, '2015-01-15', '01:53:00'),
	(15, 11, 9, '2015-01-15', '03:20:00'),
	(15, 11, 9, '2015-01-15', '02:11:00'),
	(15, 11, 9, '2015-01-15', '01:50:00'),
	(15, 11, 9, '2015-01-15', '03:36:00'),
	(15, 11, 9, '2015-01-15', '03:37:00'),
	(15, 11, 9, '2015-01-15', '03:23:00'),
	(15, 11, 9, '2015-01-15', '02:07:00'),
	(15, 11, 9, '2015-01-15', '03:48:00'),
	(15, 11, 9, '2015-01-15', '03:52:00'),
	(15, 11, 9, '2015-01-15', '01:30:00'),
	(15, 11, 9, '2015-01-15', '01:46:00'),
	(15, 11, 9, '2015-01-15', '02:51:00'),
	(15, 11, 9, '2015-01-15', '02:33:00'),
	(15, 11, 9, '2015-01-15', '02:43:00'),
	(15, 11, 9, '2015-01-15', '02:01:00'),
	(15, 11, 9, '2015-01-15', '02:54:00'),
	(15, 11, 9, '2015-01-15', '02:01:00'),
	(15, 11, 9, '2015-01-15', '02:22:00'),
	(15, 11, 9, '2015-01-15', '01:50:00'),
	(15, 11, 9, '2015-01-15', '03:00:00'),
	(15, 11, 9, '2015-01-15', '03:07:00'),
	(15, 11, 9, '2015-01-15', '02:39:00'),
	(15, 11, 9, '2015-01-15', '02:23:00'),
	(15, 11, 9, '2015-01-15', '02:29:00'),
	(15, 11, 9, '2015-01-15', '03:49:00'),
	(15, 11, 9, '2015-01-15', '02:44:00'),
	(15, 11, 9, '2015-01-15', '03:12:00'),
	(15, 11, 9, '2015-01-15', '03:52:00'),
	(15, 11, 9, '2015-01-15', '03:20:00'),
	(15, 11, 9, '2015-01-15', '03:33:00'),
	(15, 11, 9, '2015-01-15', '03:50:00'),
	(15, 11, 9, '2015-01-15', '02:06:00'),
	(15, 11, 9, '2015-01-15', '02:25:00'),
	(15, 11, 9, '2015-01-15', '01:52:00'),
	(15, 11, 9, '2015-01-15', '03:01:00'),
	(15, 11, 9, '2015-01-15', '03:08:00'),
	(15, 11, 9, '2015-01-15', '02:37:00'),
	(15, 11, 9, '2015-01-15', '02:14:00'),
	(15, 11, 9, '2015-01-15', '01:48:00'),
	(15, 12, 10, '2015-01-15', '02:10:00'),
	(15, 12, 10, '2015-01-15', '02:02:00'),
	(15, 12, 10, '2015-01-15', '02:14:00'),
	(15, 12, 10, '2015-01-15', '03:32:00'),
	(15, 12, 10, '2015-01-15', '02:34:00'),
	(15, 12, 10, '2015-01-15', '03:01:00'),
	(15, 12, 10, '2015-01-15', '03:34:00'),
	(15, 12, 10, '2015-01-15', '02:40:00'),
	(15, 12, 10, '2015-01-15', '03:29:00'),
	(15, 12, 10, '2015-01-15', '03:15:00'),
	(15, 12, 10, '2015-01-15', '02:01:00'),
	(15, 12, 10, '2015-01-15', '03:27:00'),
	(15, 12, 10, '2015-01-15', '02:48:00'),
	(15, 12, 10, '2015-01-15', '02:07:00'),
	(15, 12, 10, '2015-01-15', '03:02:00'),
	(15, 12, 10, '2015-01-15', '02:41:00'),
	(15, 12, 10, '2015-01-15', '02:49:00'),
	(15, 12, 10, '2015-01-15', '02:12:00'),
	(15, 12, 10, '2015-01-15', '03:24:00'),
	(15, 12, 10, '2015-01-15', '01:59:00'),
	(15, 12, 10, '2015-01-15', '02:49:00'),
	(15, 12, 10, '2015-01-15', '02:02:00'),
	(15, 12, 10, '2015-01-15', '02:33:00'),
	(15, 12, 10, '2015-01-15', '02:48:00'),
	(15, 12, 10, '2015-01-15', '02:34:00'),
	(15, 12, 10, '2015-01-15', '02:58:00'),
	(15, 12, 10, '2015-01-15', '03:19:00'),
	(15, 12, 10, '2015-01-15', '01:31:00'),
	(15, 12, 10, '2015-01-15', '03:08:00'),
	(15, 12, 10, '2015-01-15', '02:41:00'),
	(15, 12, 10, '2015-01-15', '02:32:00'),
	(15, 12, 10, '2015-01-15', '03:08:00'),
	(15, 12, 10, '2015-01-15', '01:56:00'),
	(15, 12, 10, '2015-01-15', '03:26:00'),
	(15, 12, 10, '2015-01-15', '02:55:00'),
	(15, 12, 10, '2015-01-15', '02:49:00'),
	(15, 12, 10, '2015-01-15', '03:48:00'),
	(15, 12, 10, '2015-01-15', '02:08:00'),
	(15, 12, 10, '2015-01-15', '02:25:00'),
	(15, 12, 10, '2015-01-15', '01:53:00'),
	(15, 12, 10, '2015-01-15', '02:57:00'),
	(15, 12, 10, '2015-01-15', '03:00:00'),
	(15, 12, 10, '2015-01-15', '02:19:00'),
	(15, 12, 10, '2015-01-15', '03:27:00'),
	(15, 12, 10, '2015-01-15', '01:51:00'),
	(15, 12, 10, '2015-01-15', '02:02:00'),
	(15, 12, 10, '2015-01-15', '03:09:00'),
	(15, 12, 10, '2015-01-15', '03:30:00'),
	(15, 12, 10, '2015-01-15', '01:56:00'),
	(15, 12, 10, '2015-01-15', '02:17:00'),
	(15, 12, 10, '2015-01-15', '01:51:00'),
	(15, 12, 10, '2015-01-15', '03:14:00'),
	(15, 12, 10, '2015-01-15', '02:09:00'),
	(15, 12, 10, '2015-01-15', '01:55:00'),
	(15, 12, 10, '2015-01-15', '01:35:00'),
	(15, 12, 10, '2015-01-15', '03:02:00'),
	(15, 12, 10, '2015-01-15', '01:58:00'),
	(15, 12, 10, '2015-01-15', '01:33:00'),
	(15, 12, 10, '2015-01-15', '02:39:00'),
	(15, 12, 10, '2015-01-15', '02:31:00'),
	(15, 13, 11, '2015-01-15', '02:04:00'),
	(15, 13, 11, '2015-01-15', '01:43:00'),
	(15, 13, 11, '2015-01-15', '03:12:00'),
	(15, 13, 11, '2015-01-15', '02:27:00'),
	(15, 13, 11, '2015-01-15', '03:26:00'),
	(15, 13, 11, '2015-01-15', '03:44:00'),
	(15, 13, 11, '2015-01-15', '02:17:00'),
	(15, 13, 11, '2015-01-15', '03:19:00'),
	(15, 13, 11, '2015-01-15', '03:37:00'),
	(15, 13, 11, '2015-01-15', '02:03:00'),
	(15, 13, 11, '2015-01-15', '02:31:00'),
	(15, 13, 11, '2015-01-15', '02:37:00'),
	(15, 13, 11, '2015-01-15', '01:44:00'),
	(15, 13, 11, '2015-01-15', '01:40:00'),
	(15, 13, 11, '2015-01-15', '01:36:00'),
	(15, 13, 11, '2015-01-15', '01:33:00'),
	(15, 13, 11, '2015-01-15', '03:46:00'),
	(15, 13, 11, '2015-01-15', '03:30:00'),
	(15, 13, 11, '2015-01-15', '02:24:00'),
	(15, 13, 11, '2015-01-15', '02:19:00'),
	(15, 13, 11, '2015-01-15', '02:54:00'),
	(15, 13, 11, '2015-01-15', '03:46:00'),
	(15, 13, 11, '2015-01-15', '01:45:00'),
	(15, 13, 11, '2015-01-15', '02:49:00'),
	(15, 13, 11, '2015-01-15', '02:44:00'),
	(15, 13, 11, '2015-01-15', '03:46:00'),
	(15, 13, 11, '2015-01-15', '02:14:00'),
	(15, 13, 11, '2015-01-15', '03:00:00'),
	(15, 13, 11, '2015-01-15', '02:13:00'),
	(15, 13, 11, '2015-01-15', '02:50:00'),
	(15, 13, 11, '2015-01-15', '03:46:00'),
	(15, 13, 11, '2015-01-15', '01:54:00'),
	(15, 13, 11, '2015-01-15', '03:38:00'),
	(15, 13, 11, '2015-01-15', '01:46:00'),
	(15, 13, 11, '2015-01-15', '03:23:00'),
	(15, 13, 11, '2015-01-15', '03:11:00'),
	(15, 13, 11, '2015-01-15', '01:58:00'),
	(15, 13, 11, '2015-01-15', '03:24:00'),
	(15, 13, 11, '2015-01-15', '02:43:00'),
	(15, 13, 11, '2015-01-15', '01:52:00'),
	(15, 13, 11, '2015-01-15', '01:59:00'),
	(15, 13, 11, '2015-01-15', '02:51:00'),
	(15, 13, 11, '2015-01-15', '02:14:00'),
	(15, 13, 11, '2015-01-15', '03:23:00'),
	(15, 13, 11, '2015-01-15', '01:49:00'),
	(15, 13, 11, '2015-01-15', '02:02:00'),
	(15, 13, 11, '2015-01-15', '03:16:00'),
	(15, 13, 11, '2015-01-15', '01:51:00'),
	(15, 13, 11, '2015-01-15', '02:33:00'),
	(15, 13, 11, '2015-01-15', '03:25:00'),
	(15, 13, 11, '2015-01-15', '03:20:00'),
	(15, 13, 11, '2015-01-15', '02:37:00'),
	(15, 13, 11, '2015-01-15', '01:34:00'),
	(15, 13, 11, '2015-01-15', '03:06:00'),
	(15, 13, 11, '2015-01-15', '02:23:00'),
	(15, 13, 11, '2015-01-15', '03:28:00'),
	(15, 13, 11, '2015-01-15', '01:47:00'),
	(15, 13, 11, '2015-01-15', '01:37:00'),
	(15, 13, 11, '2015-01-15', '03:33:00'),
	(15, 13, 11, '2015-01-15', '02:13:00'),
	(15, 15, 12, '2015-01-15', '02:40:00'),
	(15, 15, 12, '2015-01-15', '03:21:00'),
	(15, 15, 12, '2015-01-15', '02:24:00'),
	(15, 15, 12, '2015-01-15', '02:56:00'),
	(15, 15, 12, '2015-01-15', '03:31:00'),
	(15, 15, 12, '2015-01-15', '02:26:00'),
	(15, 15, 12, '2015-01-15', '02:35:00'),
	(15, 15, 12, '2015-01-15', '01:41:00'),
	(15, 15, 12, '2015-01-15', '01:36:00'),
	(15, 15, 12, '2015-01-15', '03:52:00'),
	(15, 15, 12, '2015-01-15', '03:22:00'),
	(15, 15, 12, '2015-01-15', '03:46:00'),
	(15, 15, 12, '2015-01-15', '02:26:00'),
	(15, 15, 12, '2015-01-15', '01:45:00'),
	(15, 15, 12, '2015-01-15', '02:24:00'),
	(15, 15, 12, '2015-01-15', '02:48:00'),
	(15, 15, 12, '2015-01-15', '02:56:00'),
	(15, 15, 12, '2015-01-15', '02:19:00'),
	(15, 15, 12, '2015-01-15', '03:44:00'),
	(15, 15, 12, '2015-01-15', '02:59:00'),
	(15, 15, 12, '2015-01-15', '02:13:00'),
	(15, 15, 12, '2015-01-15', '03:03:00'),
	(15, 15, 12, '2015-01-15', '02:18:00'),
	(15, 15, 12, '2015-01-15', '03:17:00'),
	(15, 15, 12, '2015-01-15', '03:09:00'),
	(15, 15, 12, '2015-01-15', '01:59:00'),
	(15, 15, 12, '2015-01-15', '03:50:00'),
	(15, 15, 12, '2015-01-15', '02:03:00'),
	(15, 15, 12, '2015-01-15', '02:04:00'),
	(15, 15, 12, '2015-01-15', '02:42:00'),
	(15, 15, 12, '2015-01-15', '03:24:00'),
	(15, 15, 12, '2015-01-15', '02:36:00'),
	(15, 15, 12, '2015-01-15', '03:44:00'),
	(15, 15, 12, '2015-01-15', '02:05:00'),
	(15, 15, 12, '2015-01-15', '02:35:00'),
	(15, 15, 12, '2015-01-15', '02:44:00'),
	(15, 15, 12, '2015-01-15', '02:00:00'),
	(15, 15, 12, '2015-01-15', '02:44:00'),
	(15, 15, 12, '2015-01-15', '03:47:00'),
	(15, 15, 12, '2015-01-15', '01:56:00'),
	(15, 15, 12, '2015-01-15', '01:41:00'),
	(15, 15, 12, '2015-01-15', '03:34:00'),
	(15, 15, 12, '2015-01-15', '01:35:00'),
	(15, 15, 12, '2015-01-15', '03:00:00'),
	(15, 15, 12, '2015-01-15', '03:54:00'),
	(15, 15, 12, '2015-01-15', '01:45:00'),
	(15, 15, 12, '2015-01-15', '02:50:00'),
	(15, 15, 12, '2015-01-15', '02:33:00'),
	(15, 15, 12, '2015-01-15', '02:48:00'),
	(15, 15, 12, '2015-01-15', '02:26:00'),
	(15, 15, 12, '2015-01-15', '02:14:00'),
	(15, 15, 12, '2015-01-15', '02:25:00'),
	(15, 15, 12, '2015-01-15', '03:53:00'),
	(15, 15, 12, '2015-01-15', '03:26:00'),
	(15, 15, 12, '2015-01-15', '01:35:00'),
	(15, 15, 12, '2015-01-15', '03:23:00'),
	(15, 15, 12, '2015-01-15', '03:26:00'),
	(15, 15, 12, '2015-01-15', '03:07:00'),
	(15, 15, 12, '2015-01-15', '03:48:00'),
	(15, 15, 12, '2015-01-15', '03:17:00'),
	(15, 14, 13, '2015-01-15', '01:32:00'),
	(15, 14, 13, '2015-01-15', '02:46:00'),
	(15, 14, 13, '2015-01-15', '03:01:00'),
	(15, 14, 13, '2015-01-15', '02:53:00'),
	(15, 14, 13, '2015-01-15', '01:31:00'),
	(15, 14, 13, '2015-01-15', '02:10:00'),
	(15, 14, 13, '2015-01-15', '02:25:00'),
	(15, 14, 13, '2015-01-15', '01:42:00'),
	(15, 14, 13, '2015-01-15', '02:08:00'),
	(15, 14, 13, '2015-01-15', '01:43:00'),
	(15, 14, 13, '2015-01-15', '03:02:00'),
	(15, 14, 13, '2015-01-15', '03:49:00'),
	(15, 14, 13, '2015-01-15', '03:41:00'),
	(15, 14, 13, '2015-01-15', '03:08:00'),
	(15, 14, 13, '2015-01-15', '03:07:00'),
	(15, 14, 13, '2015-01-15', '02:18:00'),
	(15, 14, 13, '2015-01-15', '03:01:00'),
	(15, 14, 13, '2015-01-15', '01:55:00'),
	(15, 14, 13, '2015-01-15', '03:49:00'),
	(15, 14, 13, '2015-01-15', '02:19:00'),
	(15, 14, 13, '2015-01-15', '03:23:00'),
	(15, 14, 13, '2015-01-15', '03:43:00'),
	(15, 14, 13, '2015-01-15', '02:09:00'),
	(15, 14, 13, '2015-01-15', '02:56:00'),
	(15, 14, 13, '2015-01-15', '01:54:00'),
	(15, 14, 13, '2015-01-15', '01:36:00'),
	(15, 14, 13, '2015-01-15', '03:13:00'),
	(15, 14, 13, '2015-01-15', '02:37:00'),
	(15, 14, 13, '2015-01-15', '01:55:00'),
	(15, 14, 13, '2015-01-15', '02:41:00'),
	(15, 14, 13, '2015-01-15', '03:45:00'),
	(15, 14, 13, '2015-01-15', '02:04:00'),
	(15, 14, 13, '2015-01-15', '02:21:00'),
	(15, 14, 13, '2015-01-15', '01:41:00'),
	(15, 14, 13, '2015-01-15', '02:14:00'),
	(15, 14, 13, '2015-01-15', '02:16:00'),
	(15, 14, 13, '2015-01-15', '03:10:00'),
	(15, 14, 13, '2015-01-15', '02:46:00'),
	(15, 14, 13, '2015-01-15', '02:50:00'),
	(15, 14, 13, '2015-01-15', '02:02:00'),
	(15, 14, 13, '2015-01-15', '02:30:00'),
	(15, 14, 13, '2015-01-15', '02:32:00'),
	(15, 14, 13, '2015-01-15', '03:41:00'),
	(15, 14, 13, '2015-01-15', '02:12:00'),
	(15, 14, 13, '2015-01-15', '03:14:00'),
	(15, 14, 13, '2015-01-15', '03:16:00'),
	(15, 14, 13, '2015-01-15', '02:45:00'),
	(15, 14, 13, '2015-01-15', '02:28:00'),
	(15, 14, 13, '2015-01-15', '02:35:00'),
	(15, 14, 13, '2015-01-15', '01:37:00'),
	(15, 14, 13, '2015-01-15', '03:40:00'),
	(15, 14, 13, '2015-01-15', '02:25:00'),
	(15, 14, 13, '2015-01-15', '02:01:00'),
	(15, 14, 13, '2015-01-15', '03:41:00'),
	(15, 14, 13, '2015-01-15', '03:44:00'),
	(15, 14, 13, '2015-01-15', '03:43:00'),
	(15, 14, 13, '2015-01-15', '03:31:00'),
	(15, 14, 13, '2015-01-15', '02:32:00'),
	(15, 14, 13, '2015-01-15', '03:04:00'),
	(15, 14, 13, '2015-01-15', '03:49:00'),
	(17, 11, 9, '2015-02-01', '03:01:00'),
	(17, 11, 9, '2015-02-01', '02:27:00'),
	(17, 11, 9, '2015-02-01', '01:43:00'),
	(17, 11, 9, '2015-02-01', '02:09:00'),
	(17, 11, 9, '2015-02-01', '01:40:00'),
	(17, 11, 9, '2015-02-01', '02:48:00'),
	(17, 11, 9, '2015-02-01', '02:42:00'),
	(17, 11, 9, '2015-02-01', '03:34:00'),
	(17, 11, 9, '2015-02-01', '03:25:00'),
	(17, 11, 9, '2015-02-01', '02:26:00'),
	(17, 11, 9, '2015-02-01', '02:54:00'),
	(17, 11, 9, '2015-02-01', '03:14:00'),
	(17, 11, 9, '2015-02-01', '03:32:00'),
	(17, 11, 9, '2015-02-01', '01:37:00'),
	(17, 11, 9, '2015-02-01', '03:16:00'),
	(17, 11, 9, '2015-02-01', '02:44:00'),
	(17, 11, 9, '2015-02-01', '02:20:00'),
	(17, 11, 9, '2015-02-01', '02:01:00'),
	(17, 11, 9, '2015-02-01', '01:34:00'),
	(17, 11, 9, '2015-02-01', '02:42:00'),
	(17, 11, 9, '2015-02-01', '02:30:00'),
	(17, 11, 9, '2015-02-01', '02:51:00'),
	(17, 11, 9, '2015-02-01', '02:52:00'),
	(17, 11, 9, '2015-02-01', '01:49:00'),
	(17, 11, 9, '2015-02-01', '03:54:00'),
	(17, 11, 9, '2015-02-01', '02:51:00'),
	(17, 11, 9, '2015-02-01', '03:26:00'),
	(17, 11, 9, '2015-02-01', '02:16:00'),
	(17, 11, 9, '2015-02-01', '01:57:00'),
	(17, 11, 9, '2015-02-01', '03:55:00'),
	(17, 11, 9, '2015-02-01', '02:29:00'),
	(17, 11, 9, '2015-02-01', '01:39:00'),
	(17, 11, 9, '2015-02-01', '01:43:00'),
	(17, 11, 9, '2015-02-01', '02:07:00'),
	(17, 11, 9, '2015-02-01', '01:33:00'),
	(17, 11, 9, '2015-02-01', '02:19:00'),
	(17, 11, 9, '2015-02-01', '03:00:00'),
	(17, 11, 9, '2015-02-01', '01:43:00'),
	(17, 11, 9, '2015-02-01', '02:58:00'),
	(17, 11, 9, '2015-02-01', '03:20:00'),
	(17, 11, 9, '2015-02-01', '03:50:00'),
	(17, 11, 9, '2015-02-01', '02:47:00'),
	(17, 11, 9, '2015-02-01', '03:21:00'),
	(17, 11, 9, '2015-02-01', '02:03:00'),
	(17, 11, 9, '2015-02-01', '03:35:00'),
	(17, 11, 9, '2015-02-01', '02:58:00'),
	(17, 11, 9, '2015-02-01', '02:37:00'),
	(17, 11, 9, '2015-02-01', '02:43:00'),
	(17, 11, 9, '2015-02-01', '01:45:00'),
	(17, 11, 9, '2015-02-01', '01:34:00'),
	(17, 11, 9, '2015-02-01', '03:33:00'),
	(17, 11, 9, '2015-02-01', '01:46:00'),
	(17, 11, 9, '2015-02-01', '01:36:00'),
	(17, 11, 9, '2015-02-01', '03:39:00'),
	(17, 11, 9, '2015-02-01', '02:11:00'),
	(17, 11, 9, '2015-02-01', '03:23:00'),
	(17, 11, 9, '2015-02-01', '01:33:00'),
	(17, 11, 9, '2015-02-01', '03:25:00'),
	(17, 11, 9, '2015-02-01', '03:38:00'),
	(17, 11, 9, '2015-02-01', '01:34:00'),
	(17, 12, 10, '2015-02-01', '02:28:00'),
	(17, 12, 10, '2015-02-01', '03:04:00'),
	(17, 12, 10, '2015-02-01', '02:06:00'),
	(17, 12, 10, '2015-02-01', '01:59:00'),
	(17, 12, 10, '2015-02-01', '02:07:00'),
	(17, 12, 10, '2015-02-01', '03:07:00'),
	(17, 12, 10, '2015-02-01', '03:27:00'),
	(17, 12, 10, '2015-02-01', '02:03:00'),
	(17, 12, 10, '2015-02-01', '02:45:00'),
	(17, 12, 10, '2015-02-01', '01:48:00'),
	(17, 12, 10, '2015-02-01', '03:36:00'),
	(17, 12, 10, '2015-02-01', '02:24:00'),
	(17, 12, 10, '2015-02-01', '01:54:00'),
	(17, 12, 10, '2015-02-01', '02:56:00'),
	(17, 12, 10, '2015-02-01', '03:12:00'),
	(17, 12, 10, '2015-02-01', '03:30:00'),
	(17, 12, 10, '2015-02-01', '02:06:00'),
	(17, 12, 10, '2015-02-01', '02:50:00'),
	(17, 12, 10, '2015-02-01', '02:00:00'),
	(17, 12, 10, '2015-02-01', '02:14:00'),
	(17, 12, 10, '2015-02-01', '01:30:00'),
	(17, 12, 10, '2015-02-01', '03:37:00'),
	(17, 12, 10, '2015-02-01', '03:27:00'),
	(17, 12, 10, '2015-02-01', '02:42:00'),
	(17, 12, 10, '2015-02-01', '01:41:00'),
	(17, 12, 10, '2015-02-01', '03:08:00'),
	(17, 12, 10, '2015-02-01', '02:36:00'),
	(17, 12, 10, '2015-02-01', '02:10:00'),
	(17, 12, 10, '2015-02-01', '01:30:00'),
	(17, 12, 10, '2015-02-01', '01:42:00'),
	(17, 12, 10, '2015-02-01', '02:30:00'),
	(17, 12, 10, '2015-02-01', '01:33:00'),
	(17, 12, 10, '2015-02-01', '03:08:00'),
	(17, 12, 10, '2015-02-01', '03:02:00'),
	(17, 12, 10, '2015-02-01', '02:06:00'),
	(17, 12, 10, '2015-02-01', '02:06:00'),
	(17, 12, 10, '2015-02-01', '02:42:00'),
	(17, 12, 10, '2015-02-01', '03:33:00'),
	(17, 12, 10, '2015-02-01', '01:39:00'),
	(17, 12, 10, '2015-02-01', '02:37:00'),
	(17, 12, 10, '2015-02-01', '02:19:00'),
	(17, 12, 10, '2015-02-01', '02:13:00'),
	(17, 12, 10, '2015-02-01', '02:40:00'),
	(17, 12, 10, '2015-02-01', '03:01:00'),
	(17, 12, 10, '2015-02-01', '03:24:00'),
	(17, 12, 10, '2015-02-01', '02:10:00'),
	(17, 12, 10, '2015-02-01', '03:29:00'),
	(17, 12, 10, '2015-02-01', '02:55:00'),
	(17, 12, 10, '2015-02-01', '02:38:00'),
	(17, 12, 10, '2015-02-01', '02:53:00'),
	(17, 12, 10, '2015-02-01', '02:55:00'),
	(17, 12, 10, '2015-02-01', '02:16:00'),
	(17, 12, 10, '2015-02-01', '03:14:00'),
	(17, 12, 10, '2015-02-01', '03:32:00'),
	(17, 12, 10, '2015-02-01', '02:11:00'),
	(17, 12, 10, '2015-02-01', '03:10:00'),
	(17, 12, 10, '2015-02-01', '03:27:00'),
	(17, 12, 10, '2015-02-01', '01:54:00'),
	(17, 12, 10, '2015-02-01', '02:01:00'),
	(17, 12, 10, '2015-02-01', '02:52:00'),
	(17, 13, 11, '2015-02-01', '02:10:00'),
	(17, 13, 11, '2015-02-01', '02:02:00'),
	(17, 13, 11, '2015-02-01', '02:11:00'),
	(17, 13, 11, '2015-02-01', '03:18:00'),
	(17, 13, 11, '2015-02-01', '02:06:00'),
	(17, 13, 11, '2015-02-01', '03:21:00'),
	(17, 13, 11, '2015-02-01', '02:35:00'),
	(17, 13, 11, '2015-02-01', '03:33:00'),
	(17, 13, 11, '2015-02-01', '02:08:00'),
	(17, 13, 11, '2015-02-01', '02:45:00'),
	(17, 13, 11, '2015-02-01', '01:36:00'),
	(17, 13, 11, '2015-02-01', '02:30:00'),
	(17, 13, 11, '2015-02-01', '01:58:00'),
	(17, 13, 11, '2015-02-01', '02:58:00'),
	(17, 13, 11, '2015-02-01', '03:11:00'),
	(17, 13, 11, '2015-02-01', '03:24:00'),
	(17, 13, 11, '2015-02-01', '01:44:00'),
	(17, 13, 11, '2015-02-01', '03:19:00'),
	(17, 13, 11, '2015-02-01', '03:33:00'),
	(17, 13, 11, '2015-02-01', '02:03:00'),
	(17, 13, 11, '2015-02-01', '02:21:00'),
	(17, 13, 11, '2015-02-01', '02:01:00'),
	(17, 13, 11, '2015-02-01', '01:34:00'),
	(17, 13, 11, '2015-02-01', '02:21:00'),
	(17, 13, 11, '2015-02-01', '03:30:00'),
	(17, 13, 11, '2015-02-01', '02:33:00'),
	(17, 13, 11, '2015-02-01', '02:55:00'),
	(17, 13, 11, '2015-02-01', '03:19:00'),
	(17, 13, 11, '2015-02-01', '02:05:00'),
	(17, 13, 11, '2015-02-01', '03:15:00'),
	(17, 13, 11, '2015-02-01', '02:09:00'),
	(17, 13, 11, '2015-02-01', '01:36:00'),
	(17, 13, 11, '2015-02-01', '02:10:00'),
	(17, 13, 11, '2015-02-01', '02:26:00'),
	(17, 13, 11, '2015-02-01', '02:02:00'),
	(17, 13, 11, '2015-02-01', '03:29:00'),
	(17, 13, 11, '2015-02-01', '03:30:00'),
	(17, 13, 11, '2015-02-01', '03:28:00'),
	(17, 13, 11, '2015-02-01', '03:13:00'),
	(17, 13, 11, '2015-02-01', '02:05:00'),
	(17, 13, 11, '2015-02-01', '03:31:00'),
	(17, 13, 11, '2015-02-01', '03:30:00'),
	(17, 13, 11, '2015-02-01', '03:18:00'),
	(17, 13, 11, '2015-02-01', '02:25:00'),
	(17, 13, 11, '2015-02-01', '02:50:00'),
	(17, 13, 11, '2015-02-01', '03:16:00'),
	(17, 13, 11, '2015-02-01', '02:07:00'),
	(17, 13, 11, '2015-02-01', '03:34:00'),
	(17, 13, 11, '2015-02-01', '03:36:00'),
	(17, 13, 11, '2015-02-01', '01:36:00'),
	(17, 13, 11, '2015-02-01', '02:02:00'),
	(17, 13, 11, '2015-02-01', '01:45:00'),
	(17, 13, 11, '2015-02-01', '03:16:00'),
	(17, 13, 11, '2015-02-01', '03:15:00'),
	(17, 13, 11, '2015-02-01', '02:52:00'),
	(17, 13, 11, '2015-02-01', '03:06:00'),
	(17, 13, 11, '2015-02-01', '03:18:00'),
	(17, 13, 11, '2015-02-01', '03:35:00'),
	(17, 13, 11, '2015-02-01', '02:18:00'),
	(17, 13, 11, '2015-02-01', '03:30:00'),
	(17, 15, 12, '2015-02-01', '01:39:00'),
	(17, 15, 12, '2015-02-01', '02:52:00'),
	(17, 15, 12, '2015-02-01', '03:27:00'),
	(17, 15, 12, '2015-02-01', '02:42:00'),
	(17, 15, 12, '2015-02-01', '01:40:00'),
	(17, 15, 12, '2015-02-01', '03:10:00'),
	(17, 15, 12, '2015-02-01', '02:44:00'),
	(17, 15, 12, '2015-02-01', '02:38:00'),
	(17, 15, 12, '2015-02-01', '03:28:00'),
	(17, 15, 12, '2015-02-01', '03:31:00'),
	(17, 15, 12, '2015-02-01', '03:30:00'),
	(17, 15, 12, '2015-02-01', '03:13:00'),
	(17, 15, 12, '2015-02-01', '01:51:00'),
	(17, 15, 12, '2015-02-01', '02:34:00'),
	(17, 15, 12, '2015-02-01', '03:36:00'),
	(17, 15, 12, '2015-02-01', '02:07:00'),
	(17, 15, 12, '2015-02-01', '02:46:00'),
	(17, 15, 12, '2015-02-01', '01:34:00'),
	(17, 15, 12, '2015-02-01', '02:29:00'),
	(17, 15, 12, '2015-02-01', '01:45:00'),
	(17, 15, 12, '2015-02-01', '02:03:00'),
	(17, 15, 12, '2015-02-01', '03:28:00'),
	(17, 15, 12, '2015-02-01', '03:04:00'),
	(17, 15, 12, '2015-02-01', '03:27:00'),
	(17, 15, 12, '2015-02-01', '02:06:00'),
	(17, 15, 12, '2015-02-01', '03:06:00'),
	(17, 15, 12, '2015-02-01', '03:15:00'),
	(17, 15, 12, '2015-02-01', '03:15:00'),
	(17, 15, 12, '2015-02-01', '02:48:00'),
	(17, 15, 12, '2015-02-01', '02:45:00'),
	(17, 15, 12, '2015-02-01', '01:40:00'),
	(17, 15, 12, '2015-02-01', '03:01:00'),
	(17, 15, 12, '2015-02-01', '01:57:00'),
	(17, 15, 12, '2015-02-01', '03:38:00'),
	(17, 15, 12, '2015-02-01', '01:56:00'),
	(17, 15, 12, '2015-02-01', '01:42:00'),
	(17, 15, 12, '2015-02-01', '03:25:00'),
	(17, 15, 12, '2015-02-01', '01:39:00'),
	(17, 15, 12, '2015-02-01', '03:08:00'),
	(17, 15, 12, '2015-02-01', '02:36:00'),
	(17, 15, 12, '2015-02-01', '02:07:00'),
	(17, 15, 12, '2015-02-01', '03:31:00'),
	(17, 15, 12, '2015-02-01', '03:05:00'),
	(17, 15, 12, '2015-02-01', '03:20:00'),
	(17, 15, 12, '2015-02-01', '01:32:00'),
	(17, 15, 12, '2015-02-01', '02:50:00'),
	(17, 15, 12, '2015-02-01', '03:40:00'),
	(17, 15, 12, '2015-02-01', '01:39:00'),
	(17, 15, 12, '2015-02-01', '02:26:00'),
	(17, 15, 12, '2015-02-01', '03:28:00'),
	(17, 15, 12, '2015-02-01', '01:57:00'),
	(17, 15, 12, '2015-02-01', '02:14:00'),
	(17, 15, 12, '2015-02-01', '01:37:00'),
	(17, 15, 12, '2015-02-01', '02:09:00'),
	(17, 15, 12, '2015-02-01', '02:10:00'),
	(17, 15, 12, '2015-02-01', '02:52:00'),
	(17, 15, 12, '2015-02-01', '01:55:00'),
	(17, 15, 12, '2015-02-01', '01:43:00'),
	(17, 15, 12, '2015-02-01', '03:35:00'),
	(17, 15, 12, '2015-02-01', '02:22:00'),
	(17, 14, 13, '2015-02-01', '02:27:00'),
	(17, 14, 13, '2015-02-01', '01:41:00'),
	(17, 14, 13, '2015-02-01', '01:30:00'),
	(17, 14, 13, '2015-02-01', '02:51:00'),
	(17, 14, 13, '2015-02-01', '02:33:00'),
	(17, 14, 13, '2015-02-01', '02:42:00'),
	(17, 14, 13, '2015-02-01', '02:25:00'),
	(17, 14, 13, '2015-02-01', '02:30:00'),
	(17, 14, 13, '2015-02-01', '01:50:00'),
	(17, 14, 13, '2015-02-01', '02:06:00'),
	(17, 14, 13, '2015-02-01', '01:36:00'),
	(17, 14, 13, '2015-02-01', '02:08:00'),
	(17, 14, 13, '2015-02-01', '02:25:00'),
	(17, 14, 13, '2015-02-01', '02:20:00'),
	(17, 14, 13, '2015-02-01', '02:52:00'),
	(17, 14, 13, '2015-02-01', '02:04:00'),
	(17, 14, 13, '2015-02-01', '02:07:00'),
	(17, 14, 13, '2015-02-01', '02:54:00'),
	(17, 14, 13, '2015-02-01', '02:51:00'),
	(17, 14, 13, '2015-02-01', '02:07:00'),
	(17, 14, 13, '2015-02-01', '02:26:00'),
	(17, 14, 13, '2015-02-01', '02:25:00'),
	(17, 14, 13, '2015-02-01', '03:20:00'),
	(17, 14, 13, '2015-02-01', '02:08:00'),
	(17, 14, 13, '2015-02-01', '03:02:00'),
	(17, 14, 13, '2015-02-01', '03:24:00'),
	(17, 14, 13, '2015-02-01', '02:37:00'),
	(17, 14, 13, '2015-02-01', '03:19:00'),
	(17, 14, 13, '2015-02-01', '03:23:00'),
	(17, 14, 13, '2015-02-01', '01:41:00'),
	(17, 14, 13, '2015-02-01', '02:29:00'),
	(17, 14, 13, '2015-02-01', '02:03:00'),
	(17, 14, 13, '2015-02-01', '03:12:00'),
	(17, 14, 13, '2015-02-01', '02:39:00'),
	(17, 14, 13, '2015-02-01', '02:09:00'),
	(17, 14, 13, '2015-02-01', '03:14:00'),
	(17, 14, 13, '2015-02-01', '02:28:00'),
	(17, 14, 13, '2015-02-01', '03:05:00'),
	(17, 14, 13, '2015-02-01', '02:40:00'),
	(17, 14, 13, '2015-02-01', '02:35:00'),
	(17, 14, 13, '2015-02-01', '01:33:00'),
	(17, 14, 13, '2015-02-01', '02:20:00'),
	(17, 14, 13, '2015-02-01', '01:39:00'),
	(17, 14, 13, '2015-02-01', '01:44:00'),
	(17, 14, 13, '2015-02-01', '02:10:00'),
	(17, 14, 13, '2015-02-01', '02:16:00'),
	(17, 14, 13, '2015-02-01', '03:20:00'),
	(17, 14, 13, '2015-02-01', '02:36:00'),
	(17, 14, 13, '2015-02-01', '01:33:00'),
	(17, 14, 13, '2015-02-01', '02:18:00'),
	(17, 14, 13, '2015-02-01', '01:30:00'),
	(17, 14, 13, '2015-02-01', '02:58:00'),
	(17, 14, 13, '2015-02-01', '03:03:00'),
	(17, 14, 13, '2015-02-01', '02:59:00'),
	(17, 14, 13, '2015-02-01', '02:22:00'),
	(17, 14, 13, '2015-02-01', '03:17:00'),
	(17, 14, 13, '2015-02-01', '02:03:00'),
	(17, 14, 13, '2015-02-01', '02:45:00'),
	(17, 14, 13, '2015-02-01', '02:15:00'),
	(17, 14, 13, '2015-02-01', '01:32:00');
/*!40000 ALTER TABLE `dim_volta_rapida` ENABLE KEYS */;


-- Volcando estructura para tabla fia.director
CREATE TABLE IF NOT EXISTS `director` (
  `codi_persona` mediumint(8) unsigned NOT NULL,
  `equip` smallint(5) unsigned NOT NULL,
  `estudis` text NOT NULL,
  `any_inici` year(4) NOT NULL,
  PRIMARY KEY (`codi_persona`),
  UNIQUE KEY `codi_equip` (`equip`),
  CONSTRAINT `FK_director_equip` FOREIGN KEY (`equip`) REFERENCES `equip` (`codi_equip`),
  CONSTRAINT `FK_director_persona` FOREIGN KEY (`codi_persona`) REFERENCES `persona` (`codi_persona`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.director: ~5 rows (aproximadamente)
DELETE FROM `director`;
/*!40000 ALTER TABLE `director` DISABLE KEYS */;
INSERT INTO `director` (`codi_persona`, `equip`, `estudis`, `any_inici`) VALUES
	(1, 1, 'Màrqueting i vendes', '2014'),
	(2, 2, 'Pilot', '2009'),
	(3, 3, 'Pilot', '2005'),
	(4, 4, 'Pilot i mecànic', '1978'),
	(5, 5, 'Enginyeria aeroespacial', '2014');
/*!40000 ALTER TABLE `director` ENABLE KEYS */;


-- Volcando estructura para tabla fia.emissora
CREATE TABLE IF NOT EXISTS `emissora` (
  `codi_emissora` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `nom` varchar(50) NOT NULL,
  `pais` char(2) NOT NULL,
  PRIMARY KEY (`codi_emissora`),
  UNIQUE KEY `nom` (`nom`,`pais`),
  KEY `FK_emisora_pais` (`pais`),
  CONSTRAINT `FK_emisora_pais` FOREIGN KEY (`pais`) REFERENCES `pais` (`codi_pais`)
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.emissora: ~13 rows (aproximadamente)
DELETE FROM `emissora`;
/*!40000 ALTER TABLE `emissora` DISABLE KEYS */;
INSERT INTO `emissora` (`codi_emissora`, `nom`, `pais`) VALUES
	(1, 'ATV', 'HK'),
	(13, 'emissora prova baixa', 'ES'),
	(2, 'NBC Sports', 'US'),
	(3, 'nowTV', 'HK'),
	(4, 'ONE', 'AU'),
	(5, 'ORF', 'AT'),
	(6, 'RTL', 'DE'),
	(7, 'Shant', 'AR'),
	(8, 'SKY Sport', 'DE'),
	(9, 'SportN', 'NO'),
	(10, 'SporTV', 'BR'),
	(11, 'SRF zwei', 'CH'),
	(12, 'TV3', 'ES');
/*!40000 ALTER TABLE `emissora` ENABLE KEYS */;


-- Volcando estructura para tabla fia.equip
CREATE TABLE IF NOT EXISTS `equip` (
  `codi_equip` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `nom` varchar(50) NOT NULL,
  `seu` varchar(100) NOT NULL,
  `data_debut` date NOT NULL,
  PRIMARY KEY (`codi_equip`),
  UNIQUE KEY `nom` (`nom`)
) ENGINE=InnoDB AUTO_INCREMENT=28 DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.equip: ~27 rows (aproximadamente)
DELETE FROM `equip`;
/*!40000 ALTER TABLE `equip` DISABLE KEYS */;
INSERT INTO `equip` (`codi_equip`, `nom`, `seu`, `data_debut`) VALUES
	(1, 'Scuderia Ferrari', 'Maranello', '1948-09-09'),
	(2, 'Mercedes AMG Petronas Formula One Team', 'Brackley', '1954-07-04'),
	(3, 'Infiniti Red Bull Racing', 'Milton Keynes', '2005-09-20'),
	(4, 'Williams Martini Racing', 'Grove', '1975-01-12'),
	(5, 'McLaren Honda', 'Woking', '1966-05-22'),
	(6, 'Sahara Force India F1 Team', 'Silverstone', '2008-03-16'),
	(7, 'Scuderia Toro Rosso', 'Faenza', '2006-03-12'),
	(8, 'Lotus F1 Team', 'Enstone', '2012-03-18'),
	(9, 'Sauber F1 Team', 'Hinwil', '1993-03-13'),
	(10, 'Manor Marussia F1 Team', 'Dinnington', '2012-03-18'),
	(11, 'Volkswagen Motorsport', 'Berlin', '1966-03-15'),
	(12, 'Citroën World Rally Team', 'Paris', '2001-11-16'),
	(13, 'Hyundai World Rally Team', 'Tokio', '1967-03-11'),
	(14, 'M-Sport World Rally Team', 'Abbey', '1988-08-15'),
	(15, 'FWRT S.R.L.', 'Roma', '1999-01-05'),
	(16, 'Jipocar Czech National', 'Praga', '2001-01-01'),
	(17, 'Amlin Aguri', 'Tokyo', '2014-11-01'),
	(18, 'Andretti Autosport', 'USA', '2009-01-01'),
	(19, 'Audi Sport ABT', 'Kempten im Allgäu', '1991-01-01'),
	(20, 'China Racing', 'China', '2004-03-12'),
	(21, 'Dragon Racing', 'USA', '2007-05-27'),
	(22, 'e.dams-Renault', 'Le Mans', '1988-01-15'),
	(23, 'Mahindra Racing', 'Turbenthal ', '2011-03-18'),
	(24, 'Trulli GP', 'Switzerland', '2014-10-01'),
	(25, 'Venturi Grand Prix', 'Monaco', '1992-01-01'),
	(26, 'Virgin Racing', 'UK', '2012-10-01'),
	(27, 'Scuderia de prova baixa', 'Barcelona', '2015-11-13');
/*!40000 ALTER TABLE `equip` ENABLE KEYS */;


-- Volcando estructura para tabla fia.fabricant
CREATE TABLE IF NOT EXISTS `fabricant` (
  `codi_fabricant` mediumint(9) unsigned NOT NULL AUTO_INCREMENT,
  `nom` varchar(50) NOT NULL,
  `any_debut` year(4) NOT NULL,
  PRIMARY KEY (`codi_fabricant`),
  UNIQUE KEY `nom` (`nom`)
) ENGINE=InnoDB AUTO_INCREMENT=48 DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.fabricant: ~47 rows (aproximadamente)
DELETE FROM `fabricant`;
/*!40000 ALTER TABLE `fabricant` DISABLE KEYS */;
INSERT INTO `fabricant` (`codi_fabricant`, `nom`, `any_debut`) VALUES
	(1, 'Pirelli', '2002'),
	(2, 'BBS', '1978'),
	(3, 'OZ Racing', '2004'),
	(4, 'Apptech', '2003'),
	(5, 'Rays', '1989'),
	(6, 'Enkei', '1987'),
	(7, 'Paoli', '1957'),
	(8, 'Mahle', '1950'),
	(9, 'Brembo', '1984'),
	(10, 'AP Racing', '1987'),
	(11, 'Endless', '1970'),
	(12, 'Alcon', '2008'),
	(13, 'Akebono', '1981'),
	(14, 'Carbon Industrie', '2001'),
	(15, 'Hitco', '1981'),
	(16, 'Magneti Marelli', '1953'),
	(17, 'NGK', '2009'),
	(18, 'Champion', '1969'),
	(19, 'OATR', '2006'),
	(20, 'Goetze', '1976'),
	(21, 'Sachs', '1979'),
	(22, 'Penske Racing', '1954'),
	(23, 'Shocks', '1951'),
	(24, 'Bilstein', '2014'),
	(25, 'Koni', '1999'),
	(26, 'Xtract', '2009'),
	(27, 'Hewland', '1963'),
	(28, 'PI Technology', '1976'),
	(29, 'TAG', '1977'),
	(30, 'McLaren-Micorsoft', '2010'),
	(31, 'Lifeline', '1969'),
	(32, 'FEV', '2001'),
	(33, 'TRW', '1951'),
	(34, 'Sabelt', '2006'),
	(35, 'Schroth', '1961'),
	(36, 'OMP Racing', '1974'),
	(37, 'Takata industries', '1970'),
	(38, 'Willans', '1982'),
	(39, 'Catia', '1987'),
	(40, 'Cimatron', '1971'),
	(41, 'BAE', '1950'),
	(42, 'AMI', '1956'),
	(43, 'Flow Science', '1983'),
	(44, 'Alcantara', '1965'),
	(45, 'Plextek', '1988'),
	(46, 'Yuasa Corporation', '1998'),
	(47, 'Fabricant de prova baixa', '1960');
/*!40000 ALTER TABLE `fabricant` ENABLE KEYS */;


-- Volcando estructura para tabla fia.fact_table_1
CREATE TABLE IF NOT EXISTS `fact_table_1` (
  `competicio` smallint(5) unsigned DEFAULT NULL,
  `temporada` year(4) DEFAULT NULL,
  `pilot` mediumint(8) unsigned DEFAULT NULL,
  `equip` smallint(5) unsigned DEFAULT NULL,
  `cotxe` mediumint(8) unsigned DEFAULT NULL,
  `circuit` mediumint(8) unsigned DEFAULT NULL,
  `patrocinador` mediumint(8) unsigned DEFAULT NULL,
  `fabricant` mediumint(8) unsigned DEFAULT NULL,
  `data_cursa` date DEFAULT NULL,
  `data_millora` date DEFAULT NULL,
  `quantitat_components` mediumint(8) unsigned DEFAULT NULL,
  `cost_patrocini` int(10) unsigned DEFAULT NULL,
  `volta_rapida` time DEFAULT NULL,
  `temperatura_maxima` float(8,2) unsigned DEFAULT NULL,
  `dades_telemetriques` mediumint(8) unsigned DEFAULT NULL,
  `dades_telemetriques_equip` mediumint(8) unsigned DEFAULT NULL,
  `consum_cotxe` float(8,2) unsigned DEFAULT NULL,
  `punts_pilot` mediumint(8) unsigned DEFAULT NULL,
  `posicio_pilot` smallint(5) unsigned DEFAULT NULL,
  `curses_finalitzades` smallint(5) unsigned DEFAULT NULL,
  `curses_guanyades` smallint(5) unsigned DEFAULT NULL,
  `components_defectuosos` decimal(4,1) DEFAULT NULL,
  `camp_control` char(4) DEFAULT NULL,
  KEY `FK_fact_table_1_temporada` (`temporada`),
  KEY `FK_fact_table_1_pilot` (`pilot`),
  KEY `FK_fact_table_1_competicio` (`competicio`),
  KEY `FK_fact_table_1_equip` (`equip`),
  KEY `FK_fact_table_1_cotxe` (`cotxe`),
  KEY `FK_fact_table_1_circuit` (`circuit`),
  KEY `FK_fact_table_1_patrocinador` (`patrocinador`),
  KEY `FK_fact_table_1_fabricant` (`fabricant`),
  CONSTRAINT `FK_fact_table_1_circuit` FOREIGN KEY (`circuit`) REFERENCES `circuit` (`codi_circuit`) ON DELETE CASCADE,
  CONSTRAINT `FK_fact_table_1_competicio` FOREIGN KEY (`competicio`) REFERENCES `competicio` (`codi_competicio`) ON DELETE CASCADE,
  CONSTRAINT `FK_fact_table_1_cotxe` FOREIGN KEY (`cotxe`) REFERENCES `cotxe` (`codi_cotxe`) ON DELETE CASCADE,
  CONSTRAINT `FK_fact_table_1_equip` FOREIGN KEY (`equip`) REFERENCES `equip` (`codi_equip`) ON DELETE CASCADE,
  CONSTRAINT `FK_fact_table_1_fabricant` FOREIGN KEY (`fabricant`) REFERENCES `fabricant` (`codi_fabricant`) ON DELETE CASCADE,
  CONSTRAINT `FK_fact_table_1_patrocinador` FOREIGN KEY (`patrocinador`) REFERENCES `patrocinador` (`codi_patrocinador`) ON DELETE CASCADE,
  CONSTRAINT `FK_fact_table_1_pilot` FOREIGN KEY (`pilot`) REFERENCES `pilot` (`codi_persona`) ON DELETE CASCADE,
  CONSTRAINT `FK_fact_table_1_temporada` FOREIGN KEY (`temporada`) REFERENCES `temporada` (`any`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.fact_table_1: ~397 rows (aproximadamente)
DELETE FROM `fact_table_1`;
/*!40000 ALTER TABLE `fact_table_1` DISABLE KEYS */;
INSERT INTO `fact_table_1` (`competicio`, `temporada`, `pilot`, `equip`, `cotxe`, `circuit`, `patrocinador`, `fabricant`, `data_cursa`, `data_millora`, `quantitat_components`, `cost_patrocini`, `volta_rapida`, `temperatura_maxima`, `dades_telemetriques`, `dades_telemetriques_equip`, `consum_cotxe`, `punts_pilot`, `posicio_pilot`, `curses_finalitzades`, `curses_guanyades`, `components_defectuosos`, `camp_control`) VALUES
	(NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.0, '0xCD'),
	(NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.0, '0xCD'),
	(NULL, NULL, NULL, NULL, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.0, '0xCD'),
	(NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.0, '0xCD'),
	(NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.0, '0xCD'),
	(NULL, NULL, NULL, NULL, 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.0, '0xCD'),
	(NULL, NULL, NULL, NULL, 7, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.0, '0xCD'),
	(NULL, NULL, NULL, NULL, 8, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.0, '0xCD'),
	(NULL, NULL, NULL, NULL, 9, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.0, '0xCD'),
	(NULL, NULL, NULL, NULL, 10, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.0, '0xCD'),
	(NULL, NULL, NULL, NULL, 14, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.0, '0xCD'),
	(NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.0, '0xCD'),
	(NULL, NULL, NULL, NULL, 16, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.0, '0xCD'),
	(NULL, NULL, NULL, NULL, 17, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.0, '0xCD'),
	(NULL, NULL, NULL, NULL, 18, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.0, '0xCD'),
	(NULL, NULL, NULL, NULL, 11, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.0, '0xCD'),
	(NULL, NULL, NULL, NULL, 12, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.0, '0xCD'),
	(NULL, NULL, NULL, NULL, 13, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.0, '0xCD'),
	(NULL, NULL, NULL, NULL, NULL, NULL, NULL, 46, NULL, NULL, 25, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xQC'),
	(NULL, NULL, NULL, NULL, NULL, NULL, NULL, 3, NULL, NULL, 17, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xQC'),
	(NULL, NULL, NULL, NULL, NULL, NULL, NULL, 41, NULL, NULL, 15, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xQC'),
	(NULL, NULL, NULL, NULL, NULL, NULL, NULL, 22, NULL, NULL, 12, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xQC'),
	(NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 11, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xQC'),
	(NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, 3200000, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xPA'),
	(NULL, NULL, NULL, NULL, NULL, NULL, 7, NULL, NULL, NULL, NULL, 2500000, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xPA'),
	(NULL, NULL, NULL, NULL, NULL, NULL, 11, NULL, NULL, NULL, NULL, 2400000, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xPA'),
	(NULL, NULL, NULL, NULL, NULL, NULL, 8, NULL, NULL, NULL, NULL, 2300000, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xPA'),
	(NULL, NULL, NULL, NULL, NULL, NULL, 12, NULL, NULL, NULL, NULL, 2100000, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xPA'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-01-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-01-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-01-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-01-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-01-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 50, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 65, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 40, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-02-15', '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-02-15', '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 10, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-02-15', '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 45, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-02-15', '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 90, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 65, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 40, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-02-15', '2014-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-02-15', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-03-01', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-02-15', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-03-01', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 20, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 20, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-02-15', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 20, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-03-01', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 50, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 35, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 20, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-02-15', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 20, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-03-01', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 115, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 90, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 65, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-02-15', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 50, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-03-01', '2014-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-02-15', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-03-01', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, '2014-03-15', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-02-15', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-03-01', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, '2014-03-15', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 40, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 35, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 35, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-02-15', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 35, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-03-01', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, '2014-03-15', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 75, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 60, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 45, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-02-15', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 45, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-03-01', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, '2014-03-15', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 120, 1, NULL, NULL, NULL, '0xCP'),
	(1, '2014', 9, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 75, 2, NULL, NULL, NULL, '0xCP'),
	(1, '2014', 8, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 40, 3, NULL, NULL, NULL, '0xCP'),
	(1, '2014', 7, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, 4, NULL, NULL, NULL, '0xCP'),
	(1, '2014', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, 5, NULL, NULL, NULL, '0xCP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 120, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-01-15', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 95, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-02-01', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 70, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-02-15', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 55, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-03-01', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2014', 10, NULL, NULL, NULL, NULL, NULL, '2014-03-15', '2014-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-01-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-01-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-01-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-01-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-01-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 10, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 40, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 10, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 65, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 50, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 40, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-02-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-02-15', '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-02-15', '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 40, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 35, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-02-15', '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 80, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 65, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 40, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-02-15', '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 45, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 20, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 20, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-02-15', '2015-03-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-02-15', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-03-01', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-02-15', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-03-01', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 55, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 50, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 45, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-02-15', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 40, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-03-01', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 80, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 65, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 40, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-02-15', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-03-01', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 70, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 45, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 45, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-02-15', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-03-01', '2015-03-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-02-15', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-03-01', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, '2015-03-15', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 40, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 40, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-02-15', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-03-01', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, '2015-03-15', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 70, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 65, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 60, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-02-15', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 55, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-03-01', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, '2015-03-15', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 80, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 65, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 40, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-02-15', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-03-01', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, '2015-03-15', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 9, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 80, 1, NULL, NULL, NULL, '0xCP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 75, 2, NULL, NULL, NULL, '0xCP'),
	(1, '2015', 8, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 70, 3, NULL, NULL, NULL, '0xCP'),
	(1, '2015', 7, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 40, 4, NULL, NULL, NULL, '0xCP'),
	(1, '2015', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, 5, NULL, NULL, NULL, '0xCP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 75, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 50, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-02-01', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 50, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-02-15', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 35, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-03-01', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(1, '2015', 10, NULL, NULL, NULL, NULL, NULL, '2015-03-15', '2015-04-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 11, NULL, NULL, NULL, NULL, NULL, '2015-01-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 12, NULL, NULL, NULL, NULL, NULL, '2015-01-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 13, NULL, NULL, NULL, NULL, NULL, '2015-01-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 14, NULL, NULL, NULL, NULL, NULL, '2015-01-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 15, NULL, NULL, NULL, NULL, NULL, '2015-01-15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 11, NULL, NULL, NULL, NULL, NULL, '2015-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 11, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 12, NULL, NULL, NULL, NULL, NULL, '2015-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 12, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 13, NULL, NULL, NULL, NULL, NULL, '2015-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 13, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 14, NULL, NULL, NULL, NULL, NULL, '2015-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 14, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 15, NULL, NULL, NULL, NULL, NULL, '2015-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 15, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(NULL, NULL, 10, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 6, NULL, '0xCG'),
	(NULL, NULL, 9, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 3, NULL, '0xCG'),
	(NULL, NULL, 7, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, '0xCG'),
	(NULL, NULL, 11, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, '0xCG'),
	(NULL, NULL, 8, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, '0xCG'),
	(NULL, NULL, 13, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, '0xCG'),
	(NULL, NULL, 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, '0xCG'),
	(NULL, NULL, 12, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, '0xCG'),
	(NULL, NULL, 15, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, '0xCG'),
	(2, '2015', 11, NULL, NULL, NULL, NULL, NULL, '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 50, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 11, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 11, NULL, NULL, NULL, NULL, NULL, '2015-01-01', '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 25, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 12, NULL, NULL, NULL, NULL, NULL, '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 12, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 12, NULL, NULL, NULL, NULL, NULL, '2015-01-01', '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 13, NULL, NULL, NULL, NULL, NULL, '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 45, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 13, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 40, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 13, NULL, NULL, NULL, NULL, NULL, '2015-01-01', '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 15, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 14, NULL, NULL, NULL, NULL, NULL, '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 14, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 14, NULL, NULL, NULL, NULL, NULL, '2015-01-01', '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, '0xEP'),
	(NULL, NULL, 10, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 12, NULL, NULL, '0xCF'),
	(NULL, NULL, 8, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 11, NULL, NULL, '0xCF'),
	(NULL, NULL, 9, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 11, NULL, NULL, '0xCF'),
	(NULL, NULL, 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 8, NULL, NULL, '0xCF'),
	(NULL, NULL, 7, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 8, NULL, NULL, '0xCF'),
	(NULL, NULL, 13, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 3, NULL, NULL, '0xCF'),
	(NULL, NULL, 11, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, '0xCF'),
	(NULL, NULL, 12, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, '0xCF'),
	(NULL, NULL, 15, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, '0xCF'),
	(2, '2015', 11, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 50, 1, NULL, NULL, NULL, '0xCP'),
	(2, '2015', 13, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 45, 2, NULL, NULL, NULL, '0xCP'),
	(2, '2015', 12, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 30, 3, NULL, NULL, NULL, '0xCP'),
	(2, '2015', 15, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 10, 4, NULL, NULL, NULL, '0xCP'),
	(2, '2015', 14, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 5, NULL, NULL, NULL, '0xCP'),
	(2, '2015', 15, NULL, NULL, NULL, NULL, NULL, '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 10, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 15, NULL, NULL, NULL, NULL, NULL, '2015-01-15', '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 10, NULL, NULL, NULL, NULL, '0xEP'),
	(2, '2015', 15, NULL, NULL, NULL, NULL, NULL, '2015-01-01', '2015-02-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, '0xEP'),
	(NULL, NULL, 9, 4, NULL, 3, NULL, NULL, '2014-01-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 6, 1, NULL, 3, NULL, NULL, '2014-01-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 6, 1, NULL, 3, NULL, NULL, '2014-01-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 10, 5, NULL, 3, NULL, NULL, '2015-01-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 8, 3, NULL, 3, NULL, NULL, '2014-01-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 6, 1, NULL, 3, NULL, NULL, '2014-01-15', NULL, NULL, NULL, '01:32:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 7, 2, NULL, 3, NULL, NULL, '2015-01-15', NULL, NULL, NULL, '01:32:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 7, 2, NULL, 3, NULL, NULL, '2014-01-15', NULL, NULL, NULL, '01:32:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 6, 1, NULL, 3, NULL, NULL, '2014-01-15', NULL, NULL, NULL, '01:32:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 7, 2, NULL, 3, NULL, NULL, '2015-01-15', NULL, NULL, NULL, '01:33:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 8, 3, NULL, 4, NULL, NULL, '2015-02-01', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 7, 2, NULL, 4, NULL, NULL, '2015-02-01', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 7, 2, NULL, 4, NULL, NULL, '2015-02-01', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 10, 5, NULL, 4, NULL, NULL, '2015-02-01', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 8, 3, NULL, 4, NULL, NULL, '2015-02-01', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 10, 5, NULL, 4, NULL, NULL, '2014-02-01', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 10, 5, NULL, 4, NULL, NULL, '2014-02-01', NULL, NULL, NULL, '01:32:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 6, 1, NULL, 4, NULL, NULL, '2015-02-01', NULL, NULL, NULL, '01:33:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 7, 2, NULL, 4, NULL, NULL, '2015-02-01', NULL, NULL, NULL, '01:33:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 7, 2, NULL, 4, NULL, NULL, '2015-02-01', NULL, NULL, NULL, '01:33:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 6, 1, NULL, 5, NULL, NULL, '2014-02-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 8, 3, NULL, 5, NULL, NULL, '2014-02-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 6, 1, NULL, 5, NULL, NULL, '2015-02-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 10, 5, NULL, 5, NULL, NULL, '2014-02-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 8, 3, NULL, 5, NULL, NULL, '2015-02-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 8, 3, NULL, 5, NULL, NULL, '2014-02-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 7, 2, NULL, 5, NULL, NULL, '2015-02-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 7, 2, NULL, 5, NULL, NULL, '2014-02-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 7, 2, NULL, 5, NULL, NULL, '2014-02-15', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 6, 1, NULL, 5, NULL, NULL, '2015-02-15', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 10, 5, NULL, 6, NULL, NULL, '2015-03-01', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 8, 3, NULL, 6, NULL, NULL, '2015-03-01', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 9, 4, NULL, 6, NULL, NULL, '2015-03-01', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 9, 4, NULL, 6, NULL, NULL, '2015-03-01', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 7, 2, NULL, 6, NULL, NULL, '2014-03-01', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 7, 2, NULL, 6, NULL, NULL, '2014-03-01', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 9, 4, NULL, 6, NULL, NULL, '2014-03-01', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 10, 5, NULL, 6, NULL, NULL, '2015-03-01', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 6, 1, NULL, 6, NULL, NULL, '2014-03-01', NULL, NULL, NULL, '01:32:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 6, 1, NULL, 6, NULL, NULL, '2014-03-01', NULL, NULL, NULL, '01:32:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 6, 1, NULL, 8, NULL, NULL, '2015-03-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 8, 3, NULL, 8, NULL, NULL, '2015-03-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 6, 1, NULL, 8, NULL, NULL, '2014-03-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 6, 1, NULL, 8, NULL, NULL, '2015-03-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 8, 3, NULL, 8, NULL, NULL, '2015-03-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 7, 2, NULL, 8, NULL, NULL, '2014-03-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 6, 1, NULL, 8, NULL, NULL, '2015-03-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 10, 5, NULL, 8, NULL, NULL, '2015-03-15', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 6, 1, NULL, 8, NULL, NULL, '2014-03-15', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 8, 3, NULL, 8, NULL, NULL, '2015-03-15', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 6, 1, NULL, 9, NULL, NULL, '2014-04-01', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 8, 3, NULL, 9, NULL, NULL, '2014-04-01', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 9, 4, NULL, 9, NULL, NULL, '2014-04-01', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 6, 1, NULL, 9, NULL, NULL, '2015-04-01', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 9, 4, NULL, 9, NULL, NULL, '2014-04-01', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 7, 2, NULL, 9, NULL, NULL, '2015-04-01', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 7, 2, NULL, 9, NULL, NULL, '2014-04-01', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 10, 5, NULL, 9, NULL, NULL, '2014-04-01', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 10, 5, NULL, 9, NULL, NULL, '2014-04-01', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 10, 5, NULL, 9, NULL, NULL, '2015-04-01', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 12, 10, NULL, 16, NULL, NULL, '2015-01-01', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 15, 12, NULL, 16, NULL, NULL, '2015-01-01', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 12, 10, NULL, 16, NULL, NULL, '2015-01-01', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 15, 12, NULL, 16, NULL, NULL, '2015-01-01', NULL, NULL, NULL, '01:32:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 13, 11, NULL, 16, NULL, NULL, '2015-01-01', NULL, NULL, NULL, '01:33:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 15, 12, NULL, 16, NULL, NULL, '2015-01-01', NULL, NULL, NULL, '01:33:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 14, 13, NULL, 16, NULL, NULL, '2015-01-01', NULL, NULL, NULL, '01:33:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 13, 11, NULL, 16, NULL, NULL, '2015-01-01', NULL, NULL, NULL, '01:34:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 12, 10, NULL, 16, NULL, NULL, '2015-01-01', NULL, NULL, NULL, '01:34:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 15, 12, NULL, 16, NULL, NULL, '2015-01-01', NULL, NULL, NULL, '01:34:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 11, 9, NULL, 15, NULL, NULL, '2015-01-15', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 12, 10, NULL, 15, NULL, NULL, '2015-01-15', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 14, 13, NULL, 15, NULL, NULL, '2015-01-15', NULL, NULL, NULL, '01:31:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 14, 13, NULL, 15, NULL, NULL, '2015-01-15', NULL, NULL, NULL, '01:32:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 13, 11, NULL, 15, NULL, NULL, '2015-01-15', NULL, NULL, NULL, '01:33:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 12, 10, NULL, 15, NULL, NULL, '2015-01-15', NULL, NULL, NULL, '01:33:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 13, 11, NULL, 15, NULL, NULL, '2015-01-15', NULL, NULL, NULL, '01:34:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 15, 12, NULL, 15, NULL, NULL, '2015-01-15', NULL, NULL, NULL, '01:35:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 12, 10, NULL, 15, NULL, NULL, '2015-01-15', NULL, NULL, NULL, '01:35:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 15, 12, NULL, 15, NULL, NULL, '2015-01-15', NULL, NULL, NULL, '01:35:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 14, 13, NULL, 17, NULL, NULL, '2015-02-01', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 12, 10, NULL, 17, NULL, NULL, '2015-02-01', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 14, 13, NULL, 17, NULL, NULL, '2015-02-01', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 12, 10, NULL, 17, NULL, NULL, '2015-02-01', NULL, NULL, NULL, '01:30:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 14, 13, NULL, 17, NULL, NULL, '2015-02-01', NULL, NULL, NULL, '01:32:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 15, 12, NULL, 17, NULL, NULL, '2015-02-01', NULL, NULL, NULL, '01:32:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 14, 13, NULL, 17, NULL, NULL, '2015-02-01', NULL, NULL, NULL, '01:33:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 14, 13, NULL, 17, NULL, NULL, '2015-02-01', NULL, NULL, NULL, '01:33:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 12, 10, NULL, 17, NULL, NULL, '2015-02-01', NULL, NULL, NULL, '01:33:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(NULL, NULL, 11, 9, NULL, 17, NULL, NULL, '2015-02-01', NULL, NULL, NULL, '01:33:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xVR'),
	(1, '2015', 6, NULL, 1, 3, NULL, NULL, '2015-01-15', NULL, NULL, NULL, NULL, 1199.00, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xTM'),
	(1, '2015', NULL, NULL, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 666.80, NULL, NULL, NULL, NULL, NULL, '0xCC'),
	(1, '2014', NULL, NULL, 17, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 641.42, NULL, NULL, NULL, NULL, NULL, '0xCC'),
	(NULL, '2014', NULL, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 285678, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xTE'),
	(2, '2015', NULL, NULL, 11, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 359.89, NULL, NULL, NULL, NULL, NULL, '0xCC'),
	(NULL, '2015', NULL, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 403798, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0xTE');
/*!40000 ALTER TABLE `fact_table_1` ENABLE KEYS */;


-- Volcando estructura para tabla fia.log
CREATE TABLE IF NOT EXISTS `log` (
  `codi_log` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `operacio` enum('ALTA','BAIXA','MODIFICACIÓ') NOT NULL,
  `taula` varchar(100) NOT NULL,
  `antic_valor` varchar(512) DEFAULT NULL,
  `nou_valor` varchar(512) DEFAULT NULL,
  `data` datetime NOT NULL,
  `consulta` varchar(512) DEFAULT NULL,
  PRIMARY KEY (`codi_log`)
) ENGINE=InnoDB AUTO_INCREMENT=690858 DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.log: ~682.322 rows (aproximadamente)
DELETE FROM `log`;
/*!40000 ALTER TABLE `log` DISABLE KEYS */;
INSERT INTO `log` (`codi_log`, `operacio`, `taula`, `antic_valor`, `nou_valor`, `data`, `consulta`) VALUES
	(0, 'ALTA', 'patrocini', ' - ', '1, Aerospacial', '2015-06-13 20:51:27', 'alta_sector (\'Aerospacial\')'),
	(1, 'ALTA', 'pais', ' - ', '692819, AF, Afghanistan', '2015-06-13 20:51:18', 'alta_pais (\'AF\', \'Afghanistan\')'),
	(2, 'ALTA', 'pais', ' - ', '1, AL, Albania', '2015-06-13 20:51:18', 'alta_pais (\'AL\', \'Albania\')'),
	(3, 'ALTA', 'pais', ' - ', '2, DZ, Algeria', '2015-06-13 20:51:18', 'alta_pais (\'DZ\', \'Algeria\')'),
	(4, 'ALTA', 'pais', ' - ', '3, AS, American Samoa', '2015-06-13 20:51:18', 'alta_pais (\'AS\', \'American Samoa\')');
	
	
/*!40000 ALTER TABLE `log` ENABLE KEYS */;


-- Volcando estructura para tabla fia.pais
CREATE TABLE IF NOT EXISTS `pais` (
  `codi_pais` char(2) NOT NULL,
  `nom` varchar(50) NOT NULL,
  PRIMARY KEY (`codi_pais`),
  UNIQUE KEY `nom` (`nom`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.pais: ~233 rows (aproximadamente)
DELETE FROM `pais`;
/*!40000 ALTER TABLE `pais` DISABLE KEYS */;
INSERT INTO `pais` (`codi_pais`, `nom`) VALUES
	('AF', 'Afghanistan'),
	('AX', 'Aland Islands'),
	('AL', 'Albania'),
	('DZ', 'Algeria'),
	('AS', 'American Samoa'),
	('AD', 'Andorra'),
	('AO', 'Angola'),
	('AI', 'Anguilla'),
	('AQ', 'Antarctica'),
	('AG', 'Antigua and Barbuda'),
	('AR', 'Argentina'),
	('AM', 'Armenia'),
	('AW', 'Aruba'),
	('AU', 'Australia'),
	('AT', 'Austria'),
	('AZ', 'Azerbaijan'),
	('BS', 'Bahamas'),
	('BH', 'Bahrain'),
	('BD', 'Bangladesh'),
	('BB', 'Barbados'),
	('BY', 'Belarus'),
	('BE', 'Belgium'),
	('BZ', 'Belize'),
	('BJ', 'Benin'),
	('BM', 'Bermuda'),
	('BT', 'Bhutan'),
	('BA', 'Bosnia and Herzegovina'),
	('BW', 'Botswana'),
	('BV', 'Bouvet Island'),
	('BR', 'Brazil'),
	('IO', 'British Indian Ocean Territory'),
	('BN', 'Brunei Darussalam'),
	('BG', 'Bulgaria'),
	('BF', 'Burkina Faso'),
	('BI', 'Burundi'),
	('KH', 'Cambodia'),
	('CM', 'Cameroon'),
	('CA', 'Canada'),
	('CV', 'Cape Verde'),
	('KY', 'Cayman Islands'),
	('CF', 'Central African Republic'),
	('TD', 'Chad'),
	('CL', 'Chile'),
	('CN', 'China'),
	('CX', 'Christmas Island'),
	('CC', 'Cocos call alta_pais (Keeling) Islands'),
	('CO', 'Colombia'),
	('KM', 'Comoros'),
	('CG', 'Congo'),
	('CK', 'Cook Islands'),
	('CR', 'Costa Rica'),
	('CI', 'Côte d\'Ivoire'),
	('HR', 'Croatia'),
	('CU', 'Cuba'),
	('CW', 'Curaçao'),
	('CY', 'Cyprus'),
	('CZ', 'Czech Republic'),
	('DK', 'Denmark'),
	('DJ', 'Djibouti'),
	('DM', 'Dominica'),
	('DO', 'Dominican Republic'),
	('EC', 'Ecuador'),
	('EG', 'Egypt'),
	('SV', 'El Salvador'),
	('GQ', 'Equatorial Guinea'),
	('ER', 'Eritrea'),
	('EE', 'Estonia'),
	('ET', 'Ethiopia'),
	('FK', 'Falkland Islands call alta_pais (Malvinas)'),
	('FO', 'Faroe Islands'),
	('FJ', 'Fiji'),
	('FI', 'Finland'),
	('FR', 'France'),
	('GF', 'French Guiana'),
	('PF', 'French Polynesia'),
	('TF', 'French Southern Territories'),
	('GA', 'Gabon'),
	('GM', 'Gambia'),
	('GE', 'Georgia'),
	('DE', 'Germany'),
	('GH', 'Ghana'),
	('GI', 'Gibraltar'),
	('GR', 'Greece'),
	('GL', 'Greenland'),
	('GD', 'Grenada'),
	('GP', 'Guadeloupe'),
	('GU', 'Guam'),
	('GT', 'Guatemala'),
	('GG', 'Guernsey'),
	('GN', 'Guinea'),
	('GW', 'Guinea-Bissau'),
	('GY', 'Guyana'),
	('HT', 'Haiti'),
	('HM', 'Heard Island and McDonald Mcdonald Islands'),
	('VA', 'Holy See call alta_pais (Vatican City State)'),
	('HN', 'Honduras'),
	('HK', 'Hong Kong'),
	('HU', 'Hungary'),
	('IS', 'Iceland'),
	('IN', 'India'),
	('ID', 'Indonesia'),
	('IQ', 'Iraq'),
	('IE', 'Ireland'),
	('IM', 'Isle of Man'),
	('IL', 'Israel'),
	('IT', 'Italy'),
	('JM', 'Jamaica'),
	('JP', 'Japan'),
	('JE', 'Jersey'),
	('JO', 'Jordan'),
	('KZ', 'Kazakhstan'),
	('KE', 'Kenya'),
	('KI', 'Kiribati'),
	('KW', 'Kuwait'),
	('KG', 'Kyrgyzstan'),
	('LA', 'Lao People\'s Democratic Republic'),
	('LV', 'Latvia'),
	('LB', 'Lebanon'),
	('LS', 'Lesotho'),
	('LR', 'Liberia'),
	('LY', 'Libya'),
	('LI', 'Liechtenstein'),
	('LT', 'Lithuania'),
	('LU', 'Luxembourg'),
	('MO', 'Macao'),
	('MG', 'Madagascar'),
	('MW', 'Malawi'),
	('MY', 'Malaysia'),
	('MV', 'Maldives'),
	('ML', 'Mali'),
	('MT', 'Malta'),
	('MH', 'Marshall Islands'),
	('MQ', 'Martinique'),
	('MR', 'Mauritania'),
	('MU', 'Mauritius'),
	('YT', 'Mayotte'),
	('MX', 'Mexico'),
	('MC', 'Monaco'),
	('MN', 'Mongolia'),
	('ME', 'Montenegro'),
	('MS', 'Montserrat'),
	('MA', 'Morocco'),
	('MZ', 'Mozambique'),
	('MM', 'Myanmar'),
	('NA', 'Namibia'),
	('NR', 'Nauru'),
	('NP', 'Nepal'),
	('NL', 'Netherlands'),
	('NC', 'New Caledonia'),
	('NZ', 'New Zealand'),
	('NI', 'Nicaragua'),
	('NE', 'Niger'),
	('NG', 'Nigeria'),
	('NU', 'Niue'),
	('NF', 'Norfolk Island'),
	('MP', 'Northern Mariana Islands'),
	('NO', 'Norway'),
	('OM', 'Oman'),
	('PK', 'Pakistan'),
	('PW', 'Palau'),
	('PA', 'Panama'),
	('PG', 'Papua New Guinea'),
	('PY', 'Paraguay'),
	('PE', 'Peru'),
	('PH', 'Philippines'),
	('PN', 'Pitcairn'),
	('PL', 'Poland'),
	('PT', 'Portugal'),
	('PR', 'Puerto Rico'),
	('QA', 'Qatar'),
	('RE', 'Réunion'),
	('RO', 'Romania'),
	('RU', 'Russian Federation'),
	('RW', 'Rwanda'),
	('BL', 'Saint Barthélemy'),
	('KN', 'Saint Kitts and Nevis'),
	('LC', 'Saint Lucia'),
	('MF', 'Saint Martin call alta_pais (French part)'),
	('PM', 'Saint Pierre and Miquelon'),
	('VC', 'Saint Vincent and the Grenadines'),
	('WS', 'Samoa'),
	('SM', 'San Marino'),
	('ST', 'Sao Tome and Principe'),
	('SA', 'Saudi Arabia'),
	('SN', 'Senegal'),
	('RS', 'Serbia'),
	('SC', 'Seychelles'),
	('SL', 'Sierra Leone'),
	('SG', 'Singapore'),
	('SX', 'Sint Maarten call alta_pais (Dutch part)'),
	('SK', 'Slovakia'),
	('SI', 'Slovenia'),
	('SB', 'Solomon Islands'),
	('SO', 'Somalia'),
	('ZA', 'South Africa'),
	('GS', 'South Georgia and the South Sandwich Islands'),
	('SS', 'South Sudan'),
	('ES', 'Spain'),
	('LK', 'Sri Lanka'),
	('SD', 'Sudan'),
	('SR', 'Suriname'),
	('SJ', 'Svalbard and Jan Mayen'),
	('SZ', 'Swaziland'),
	('SE', 'Sweden'),
	('CH', 'Switzerland'),
	('SY', 'Syrian Arab Republic'),
	('TJ', 'Tajikistan'),
	('TH', 'Thailand'),
	('TL', 'Timor-Leste'),
	('TG', 'Togo'),
	('TK', 'Tokelau'),
	('TO', 'Tonga'),
	('TT', 'Trinidad and Tobago'),
	('TN', 'Tunisia'),
	('TR', 'Turkey'),
	('TM', 'Turkmenistan'),
	('TC', 'Turks and Caicos Islands'),
	('TV', 'Tuvalu'),
	('UG', 'Uganda'),
	('GB', 'UK'),
	('UA', 'Ukraine'),
	('AE', 'United Arab Emirates'),
	('UM', 'United States Minor Outlying Islands'),
	('UY', 'Uruguay'),
	('US', 'USA'),
	('UZ', 'Uzbekistan'),
	('VU', 'Vanuatu'),
	('VN', 'Viet Nam'),
	('WF', 'Wallis and Futuna'),
	('EH', 'Western Sahara'),
	('YE', 'Yemen'),
	('ZM', 'Zambia'),
	('ZW', 'Zimbabwe');
/*!40000 ALTER TABLE `pais` ENABLE KEYS */;


-- Volcando estructura para tabla fia.patrocinador
CREATE TABLE IF NOT EXISTS `patrocinador` (
  `codi_patrocinador` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `sector` smallint(5) unsigned DEFAULT '0',
  `nom` varchar(50) NOT NULL DEFAULT '0',
  PRIMARY KEY (`codi_patrocinador`),
  UNIQUE KEY `nom` (`nom`),
  KEY `FK__sector` (`sector`),
  CONSTRAINT `FK__sector` FOREIGN KEY (`sector`) REFERENCES `sector` (`codi_sector`) ON DELETE SET NULL
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.patrocinador: ~13 rows (aproximadamente)
DELETE FROM `patrocinador`;
/*!40000 ALTER TABLE `patrocinador` DISABLE KEYS */;
INSERT INTO `patrocinador` (`codi_patrocinador`, `sector`, `nom`) VALUES
	(1, 5, 'Marlboro'),
	(2, 4, 'Santander'),
	(3, 5, 'Rolex'),
	(4, 2, 'Pirelli'),
	(5, 3, 'UBS'),
	(6, 14, 'DHL'),
	(7, 3, 'Mercedes Benz'),
	(8, 14, 'Fly Emirates'),
	(9, 13, 'Tata Comunications'),
	(10, 5, 'Red Bull'),
	(11, 3, 'Infiniti'),
	(12, 13, 'Vodafone'),
	(13, 1, 'Test patrocinador baixa');
/*!40000 ALTER TABLE `patrocinador` ENABLE KEYS */;


-- Volcando estructura para tabla fia.patrocini
CREATE TABLE IF NOT EXISTS `patrocini` (
  `patrocinador` mediumint(9) unsigned NOT NULL AUTO_INCREMENT,
  `equip` smallint(5) unsigned NOT NULL,
  `temporada` year(4) NOT NULL,
  `cost` int(10) unsigned NOT NULL,
  PRIMARY KEY (`patrocinador`,`equip`,`temporada`),
  KEY `FK_patrocini_equip` (`equip`),
  KEY `FK_patrocini_temporada` (`temporada`),
  CONSTRAINT `FK_patrocini_equip` FOREIGN KEY (`equip`) REFERENCES `equip` (`codi_equip`),
  CONSTRAINT `FK_patrocini_patrocinador` FOREIGN KEY (`patrocinador`) REFERENCES `patrocinador` (`codi_patrocinador`),
  CONSTRAINT `FK_patrocini_temporada` FOREIGN KEY (`temporada`) REFERENCES `temporada` (`any`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.patrocini: ~24 rows (aproximadamente)
DELETE FROM `patrocini`;
/*!40000 ALTER TABLE `patrocini` DISABLE KEYS */;
INSERT INTO `patrocini` (`patrocinador`, `equip`, `temporada`, `cost`) VALUES
	(1, 1, '2014', 1250000),
	(2, 1, '2015', 1200000),
	(2, 24, '2014', 1500000),
	(2, 24, '2015', 500000),
	(3, 2, '2014', 500000),
	(3, 20, '2015', 1150000),
	(3, 24, '2015', 155555),
	(4, 3, '2014', 350000),
	(4, 3, '2015', 350000),
	(5, 4, '2014', 1000000),
	(6, 5, '2014', 1250000),
	(7, 6, '2015', 2500000),
	(8, 6, '2014', 1200000),
	(8, 6, '2015', 1100000),
	(9, 7, '2014', 1350000),
	(9, 16, '2014', 370000),
	(10, 8, '2014', 650000),
	(10, 15, '2014', 500000),
	(11, 9, '2014', 850000),
	(11, 10, '2015', 350000),
	(11, 14, '2014', 1200000),
	(12, 10, '2014', 350000),
	(12, 10, '2015', 350000),
	(12, 13, '2014', 1400000);
/*!40000 ALTER TABLE `patrocini` ENABLE KEYS */;


-- Volcando estructura para tabla fia.persona
CREATE TABLE IF NOT EXISTS `persona` (
  `codi_persona` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `nom` varchar(100) NOT NULL,
  `nacionalitat` char(2) NOT NULL,
  PRIMARY KEY (`codi_persona`),
  UNIQUE KEY `nom` (`nom`),
  KEY `FK_persona_pais` (`nacionalitat`),
  CONSTRAINT `FK_persona_pais` FOREIGN KEY (`nacionalitat`) REFERENCES `pais` (`codi_pais`)
) ENGINE=InnoDB AUTO_INCREMENT=24 DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.persona: ~23 rows (aproximadamente)
DELETE FROM `persona`;
/*!40000 ALTER TABLE `persona` DISABLE KEYS */;
INSERT INTO `persona` (`codi_persona`, `nom`, `nacionalitat`) VALUES
	(1, 'Maurizio Arrivabene', 'IT'),
	(2, 'Toto Wolff', 'AT'),
	(3, 'Christian Horner', 'GB'),
	(4, 'Frank Williams', 'GB'),
	(5, 'Éric Boullier', 'FR'),
	(6, 'Sebastian Vettel', 'DE'),
	(7, 'Lewis Hamilton', 'GB'),
	(8, 'Daniel Ricciardo', 'AU'),
	(9, 'Nico Hulkenberg', 'DE'),
	(10, 'Carlos Sainz', 'ES'),
	(11, 'Marcus Ericsson', 'SE'),
	(12, 'Roberto Merhi', 'ES'),
	(13, 'Romain Grosjean', 'CH'),
	(14, 'Antonio Felix da Costa', 'PT'),
	(15, 'Jean-Eric Vergne Jean-Eric Vergne ', 'FR'),
	(16, 'Lucas di Grassi', 'BR'),
	(17, 'Nelson Piquet', 'BR'),
	(18, 'Jerome D\'Ambrosio', 'DE'),
	(19, 'Nicolas Prost', 'FR'),
	(20, 'Karun Chandhok', 'IN'),
	(21, 'Jarno Trulli', 'IT'),
	(22, 'Nick Heidfeld', 'DE'),
	(23, 'Jaime Alguersuari', 'ES');
/*!40000 ALTER TABLE `persona` ENABLE KEYS */;


-- Volcando estructura para tabla fia.pilot
CREATE TABLE IF NOT EXISTS `pilot` (
  `codi_persona` mediumint(8) unsigned NOT NULL,
  `equip` smallint(6) unsigned NOT NULL,
  `codi_llicencia` varchar(8) NOT NULL,
  `any_inici` year(4) NOT NULL,
  PRIMARY KEY (`codi_persona`),
  UNIQUE KEY `codi_llicencia` (`codi_llicencia`),
  KEY `FK_pilot_equip` (`equip`),
  CONSTRAINT `FK_pilot_equip` FOREIGN KEY (`equip`) REFERENCES `equip` (`codi_equip`),
  CONSTRAINT `pilot_ibfk_1` FOREIGN KEY (`codi_persona`) REFERENCES `persona` (`codi_persona`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 ROW_FORMAT=COMPACT;

-- Volcando datos para la tabla fia.pilot: ~18 rows (aproximadamente)
DELETE FROM `pilot`;
/*!40000 ALTER TABLE `pilot` DISABLE KEYS */;
INSERT INTO `pilot` (`codi_persona`, `equip`, `codi_llicencia`, `any_inici`) VALUES
	(6, 1, 'SB685417', '2015'),
	(7, 2, 'LH884418', '2013'),
	(8, 3, 'DR184313', '2014'),
	(9, 4, 'NH516578', '2014'),
	(10, 5, 'CS649874', '2015'),
	(11, 6, 'ME789985', '2015'),
	(12, 7, 'RM874122', '2015'),
	(13, 8, 'RG874114', '2012'),
	(14, 9, 'AF168487', '2014'),
	(15, 10, 'JV874154', '2014'),
	(16, 11, 'LG744154', '2014'),
	(17, 12, 'NP887414', '2014'),
	(18, 13, 'JD844123', '2014'),
	(19, 14, 'NP344456', '2014'),
	(20, 15, 'KC345543', '2014'),
	(21, 16, 'JT452245', '2014'),
	(22, 17, 'NH646381', '2014'),
	(23, 18, 'JA123765', '2014');
/*!40000 ALTER TABLE `pilot` ENABLE KEYS */;


-- Volcando estructura para tabla fia.pilot_cotxe
CREATE TABLE IF NOT EXISTS `pilot_cotxe` (
  `pilot` mediumint(8) unsigned NOT NULL,
  `cotxe` mediumint(8) unsigned NOT NULL,
  `temporada` year(4) NOT NULL,
  PRIMARY KEY (`pilot`,`cotxe`,`temporada`),
  KEY `FK_pilot_cotxe_cotxe` (`cotxe`),
  KEY `FK_pilot_cotxe_temporada` (`temporada`),
  CONSTRAINT `FK_pilot_cotxe_cotxe` FOREIGN KEY (`cotxe`) REFERENCES `cotxe` (`codi_cotxe`),
  CONSTRAINT `FK_pilot_cotxe_pilot` FOREIGN KEY (`pilot`) REFERENCES `pilot` (`codi_persona`),
  CONSTRAINT `FK_pilot_cotxe_temporada` FOREIGN KEY (`temporada`) REFERENCES `temporada` (`any`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.pilot_cotxe: ~15 rows (aproximadamente)
DELETE FROM `pilot_cotxe`;
/*!40000 ALTER TABLE `pilot_cotxe` DISABLE KEYS */;
INSERT INTO `pilot_cotxe` (`pilot`, `cotxe`, `temporada`) VALUES
	(6, 14, '2014'),
	(7, 15, '2014'),
	(8, 16, '2014'),
	(9, 17, '2014'),
	(10, 18, '2014'),
	(6, 1, '2015'),
	(7, 2, '2015'),
	(8, 3, '2015'),
	(9, 4, '2015'),
	(10, 5, '2015'),
	(11, 9, '2015'),
	(12, 10, '2015'),
	(13, 11, '2015'),
	(14, 13, '2015'),
	(15, 12, '2015');
/*!40000 ALTER TABLE `pilot_cotxe` ENABLE KEYS */;


-- Volcando estructura para tabla fia.retransmissio
CREATE TABLE IF NOT EXISTS `retransmissio` (
  `emissora` smallint(5) unsigned NOT NULL,
  `competicio` smallint(5) unsigned NOT NULL,
  PRIMARY KEY (`emissora`,`competicio`),
  KEY `FK_retransmissio_competicio` (`competicio`),
  CONSTRAINT `FK_retransmissio_competicio` FOREIGN KEY (`competicio`) REFERENCES `competicio` (`codi_competicio`),
  CONSTRAINT `FK_retransmissio_emisora` FOREIGN KEY (`emissora`) REFERENCES `emissora` (`codi_emissora`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.retransmissio: ~13 rows (aproximadamente)
DELETE FROM `retransmissio`;
/*!40000 ALTER TABLE `retransmissio` DISABLE KEYS */;
INSERT INTO `retransmissio` (`emissora`, `competicio`) VALUES
	(1, 1),
	(2, 1),
	(3, 1),
	(4, 1),
	(5, 1),
	(6, 1),
	(7, 1),
	(8, 1),
	(9, 1),
	(10, 1),
	(11, 1),
	(12, 1),
	(12, 2);
/*!40000 ALTER TABLE `retransmissio` ENABLE KEYS */;


-- Volcando estructura para tabla fia.sector
CREATE TABLE IF NOT EXISTS `sector` (
  `codi_sector` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `nom` varchar(50) NOT NULL,
  PRIMARY KEY (`codi_sector`),
  UNIQUE KEY `nom` (`nom`)
) ENGINE=InnoDB AUTO_INCREMENT=16 DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.sector: ~15 rows (aproximadamente)
DELETE FROM `sector`;
/*!40000 ALTER TABLE `sector` DISABLE KEYS */;
INSERT INTO `sector` (`codi_sector`, `nom`) VALUES
	(1, 'Aerospacial'),
	(2, 'Assegurances'),
	(3, 'Automoció'),
	(4, 'Banca'),
	(5, 'Consum'),
	(6, 'Energètic'),
	(7, 'Mineria'),
	(8, 'Públic'),
	(9, 'Quimic'),
	(10, 'Sanitat'),
	(11, 'Seguretat'),
	(12, 'Tela terrestre'),
	(13, 'Telecomunicacions'),
	(14, 'Transport'),
	(15, 'Turisme');
/*!40000 ALTER TABLE `sector` ENABLE KEYS */;


-- Volcando estructura para tabla fia.telemetria
CREATE TABLE IF NOT EXISTS `telemetria` (
  `codi_dada` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `component` mediumint(8) unsigned NOT NULL,
  `moment` datetime(6) NOT NULL,
  `ambit` enum('marxa','velocitat','temperatura','bateria','frenada','consum','temps per volta') NOT NULL,
  `valor` float(8,4) NOT NULL,
  `unitat_de_mesura` enum(' -','kmh','ºC','%','N','lps','ms') NOT NULL,
  PRIMARY KEY (`codi_dada`),
  KEY `FK_telemetria_component` (`component`),
  KEY `Índice 3` (`moment`),
  CONSTRAINT `FK_telemetria_component` FOREIGN KEY (`component`) REFERENCES `component` (`codi_component`)
) ENGINE=InnoDB AUTO_INCREMENT=690077 DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.telemetria: ~688.577 rows (aproximadamente)
DELETE FROM `telemetria`;
/*!40000 ALTER TABLE `telemetria` DISABLE KEYS */;
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(1, 103, '2015-01-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2, 103, '2015-01-15 00:02:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(3, 103, '2015-01-15 00:05:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(4, 103, '2015-01-15 00:09:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(5, 103, '2015-01-15 00:12:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(6, 103, '2015-01-15 00:16:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(7, 103, '2015-01-15 00:18:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(8, 103, '2015-01-15 00:21:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(9, 103, '2015-01-15 00:22:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(10, 103, '2015-01-15 00:24:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(11, 103, '2015-01-15 00:25:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(12, 103, '2015-01-15 00:27:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(13, 103, '2015-01-15 00:31:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(14, 103, '2015-01-15 00:32:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(15, 103, '2015-01-15 00:34:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(16, 103, '2015-01-15 00:36:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(17, 103, '2015-01-15 00:39:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(18, 103, '2015-01-15 00:42:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(19, 103, '2015-01-15 00:44:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(20, 103, '2015-01-15 00:47:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(21, 103, '2015-01-15 00:50:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(22, 103, '2015-01-15 00:52:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(23, 103, '2015-01-15 00:54:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(24, 103, '2015-01-15 00:56:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(25, 103, '2015-01-15 00:59:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(26, 103, '2015-01-15 01:02:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(27, 103, '2015-01-15 01:05:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(28, 103, '2015-01-15 01:08:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(29, 103, '2015-01-15 01:11:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(30, 103, '2015-01-15 01:13:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(31, 103, '2015-01-15 01:16:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(32, 103, '2015-01-15 01:18:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(33, 103, '2015-01-15 01:20:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(34, 103, '2015-01-15 01:23:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(35, 103, '2015-01-15 01:26:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(36, 103, '2015-01-15 01:29:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(37, 103, '2015-01-15 01:32:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(38, 103, '2015-01-15 01:33:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(39, 103, '2015-01-15 01:36:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(40, 103, '2015-01-15 01:40:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(41, 103, '2015-01-15 01:43:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(42, 103, '2015-01-15 01:47:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(43, 103, '2015-01-15 01:49:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(44, 103, '2015-01-15 01:52:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(45, 103, '2015-01-15 01:54:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(46, 103, '2015-01-15 01:56:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(47, 103, '2015-01-15 01:58:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(48, 103, '2015-01-15 02:00:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(49, 103, '2015-01-15 02:02:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(50, 103, '2015-01-15 02:05:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(51, 103, '2015-01-15 02:08:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(52, 103, '2015-01-15 02:12:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(53, 103, '2015-01-15 02:15:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(54, 103, '2015-01-15 02:19:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(55, 103, '2015-01-15 02:22:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(56, 103, '2015-01-15 02:25:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(57, 103, '2015-01-15 02:27:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(58, 103, '2015-01-15 02:30:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(59, 103, '2015-01-15 02:32:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(60, 103, '2015-01-15 02:35:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(61, 104, '2015-01-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(62, 104, '2015-01-15 00:03:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(63, 104, '2015-01-15 00:06:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(64, 104, '2015-01-15 00:09:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(65, 104, '2015-01-15 00:12:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(66, 104, '2015-01-15 00:16:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(67, 104, '2015-01-15 00:19:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(68, 104, '2015-01-15 00:22:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(69, 104, '2015-01-15 00:26:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(70, 104, '2015-01-15 00:27:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(71, 104, '2015-01-15 00:30:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(72, 104, '2015-01-15 00:33:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(73, 104, '2015-01-15 00:36:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(74, 104, '2015-01-15 00:39:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(75, 104, '2015-01-15 00:40:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(76, 104, '2015-01-15 00:44:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(77, 104, '2015-01-15 00:48:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(78, 104, '2015-01-15 00:50:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(79, 104, '2015-01-15 00:53:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(80, 104, '2015-01-15 00:57:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(81, 104, '2015-01-15 00:59:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(82, 104, '2015-01-15 01:02:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(83, 104, '2015-01-15 01:04:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(84, 104, '2015-01-15 01:07:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(85, 104, '2015-01-15 01:10:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(86, 104, '2015-01-15 01:12:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(87, 104, '2015-01-15 01:15:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(88, 104, '2015-01-15 01:17:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(89, 104, '2015-01-15 01:21:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(90, 104, '2015-01-15 01:23:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(91, 104, '2015-01-15 01:26:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(92, 104, '2015-01-15 01:28:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(93, 104, '2015-01-15 01:31:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(94, 104, '2015-01-15 01:33:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(95, 104, '2015-01-15 01:35:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(96, 104, '2015-01-15 01:37:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(97, 104, '2015-01-15 01:39:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(98, 104, '2015-01-15 01:42:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(99, 104, '2015-01-15 01:45:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(100, 104, '2015-01-15 01:47:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(101, 104, '2015-01-15 01:50:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(102, 104, '2015-01-15 01:52:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(103, 104, '2015-01-15 01:55:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(104, 104, '2015-01-15 01:56:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(105, 104, '2015-01-15 02:00:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(106, 104, '2015-01-15 02:02:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(107, 104, '2015-01-15 02:04:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(108, 104, '2015-01-15 02:08:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(109, 104, '2015-01-15 02:11:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(110, 104, '2015-01-15 02:15:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(111, 104, '2015-01-15 02:17:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(112, 104, '2015-01-15 02:21:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(113, 104, '2015-01-15 02:23:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(114, 104, '2015-01-15 02:25:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(115, 104, '2015-01-15 02:28:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(116, 104, '2015-01-15 02:31:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(117, 104, '2015-01-15 02:34:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(118, 104, '2015-01-15 02:36:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(119, 104, '2015-01-15 02:39:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(120, 104, '2015-01-15 02:40:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(121, 105, '2015-01-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(122, 105, '2015-01-15 00:01:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(123, 105, '2015-01-15 00:05:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(124, 105, '2015-01-15 00:08:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(125, 105, '2015-01-15 00:10:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(126, 105, '2015-01-15 00:14:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(127, 105, '2015-01-15 00:16:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(128, 105, '2015-01-15 00:18:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(129, 105, '2015-01-15 00:21:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(130, 105, '2015-01-15 00:24:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(131, 105, '2015-01-15 00:27:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(132, 105, '2015-01-15 00:29:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(133, 105, '2015-01-15 00:33:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(134, 105, '2015-01-15 00:35:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(135, 105, '2015-01-15 00:37:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(136, 105, '2015-01-15 00:39:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(137, 105, '2015-01-15 00:43:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(138, 105, '2015-01-15 00:46:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(139, 105, '2015-01-15 00:48:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(140, 105, '2015-01-15 00:50:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(141, 105, '2015-01-15 00:52:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(142, 105, '2015-01-15 00:55:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(143, 105, '2015-01-15 00:57:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(144, 105, '2015-01-15 01:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(145, 105, '2015-01-15 01:02:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(146, 105, '2015-01-15 01:05:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(147, 105, '2015-01-15 01:07:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(148, 105, '2015-01-15 01:09:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(149, 105, '2015-01-15 01:13:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(150, 105, '2015-01-15 01:16:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(151, 105, '2015-01-15 01:18:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(152, 105, '2015-01-15 01:21:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(153, 105, '2015-01-15 01:24:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(154, 105, '2015-01-15 01:26:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(155, 105, '2015-01-15 01:28:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(156, 105, '2015-01-15 01:30:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(157, 105, '2015-01-15 01:34:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(158, 105, '2015-01-15 01:35:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(159, 105, '2015-01-15 01:38:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(160, 105, '2015-01-15 01:40:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(161, 105, '2015-01-15 01:44:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(162, 105, '2015-01-15 01:45:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(163, 105, '2015-01-15 01:49:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(164, 105, '2015-01-15 01:50:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(165, 105, '2015-01-15 01:54:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(166, 105, '2015-01-15 01:57:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(167, 105, '2015-01-15 02:00:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(168, 105, '2015-01-15 02:02:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(169, 105, '2015-01-15 02:04:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(170, 105, '2015-01-15 02:08:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(171, 105, '2015-01-15 02:10:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(172, 105, '2015-01-15 02:12:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(173, 105, '2015-01-15 02:15:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(174, 105, '2015-01-15 02:17:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(175, 105, '2015-01-15 02:21:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(176, 105, '2015-01-15 02:23:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(177, 105, '2015-01-15 02:26:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(178, 105, '2015-01-15 02:29:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(179, 105, '2015-01-15 02:33:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(180, 105, '2015-01-15 02:35:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(181, 106, '2015-01-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(182, 106, '2015-01-15 00:03:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(183, 106, '2015-01-15 00:05:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(184, 106, '2015-01-15 00:08:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(185, 106, '2015-01-15 00:10:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(186, 106, '2015-01-15 00:12:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(187, 106, '2015-01-15 00:15:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(188, 106, '2015-01-15 00:17:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(189, 106, '2015-01-15 00:21:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(190, 106, '2015-01-15 00:23:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(191, 106, '2015-01-15 00:26:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(192, 106, '2015-01-15 00:29:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(193, 106, '2015-01-15 00:31:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(194, 106, '2015-01-15 00:34:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(195, 106, '2015-01-15 00:37:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(196, 106, '2015-01-15 00:40:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(197, 106, '2015-01-15 00:44:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(198, 106, '2015-01-15 00:47:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(199, 106, '2015-01-15 00:51:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(200, 106, '2015-01-15 00:53:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(201, 106, '2015-01-15 00:55:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(202, 106, '2015-01-15 00:58:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(203, 106, '2015-01-15 01:02:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(204, 106, '2015-01-15 01:06:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(205, 106, '2015-01-15 01:10:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(206, 106, '2015-01-15 01:13:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(207, 106, '2015-01-15 01:17:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(208, 106, '2015-01-15 01:21:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(209, 106, '2015-01-15 01:24:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(210, 106, '2015-01-15 01:27:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(211, 106, '2015-01-15 01:29:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(212, 106, '2015-01-15 01:31:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(213, 106, '2015-01-15 01:33:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(214, 106, '2015-01-15 01:36:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(215, 106, '2015-01-15 01:39:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(216, 106, '2015-01-15 01:43:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(217, 106, '2015-01-15 01:47:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(218, 106, '2015-01-15 01:49:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(219, 106, '2015-01-15 01:52:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(220, 106, '2015-01-15 01:53:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(221, 106, '2015-01-15 01:55:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(222, 106, '2015-01-15 01:58:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(223, 106, '2015-01-15 02:02:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(224, 106, '2015-01-15 02:05:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(225, 106, '2015-01-15 02:07:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(226, 106, '2015-01-15 02:10:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(227, 106, '2015-01-15 02:13:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(228, 106, '2015-01-15 02:17:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(229, 106, '2015-01-15 02:20:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(230, 106, '2015-01-15 02:23:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(231, 106, '2015-01-15 02:26:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(232, 106, '2015-01-15 02:29:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(233, 106, '2015-01-15 02:31:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(234, 106, '2015-01-15 02:33:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(235, 106, '2015-01-15 02:35:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(236, 106, '2015-01-15 02:36:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(237, 106, '2015-01-15 02:40:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(238, 106, '2015-01-15 02:43:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(239, 106, '2015-01-15 02:45:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(240, 106, '2015-01-15 02:47:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(241, 107, '2015-01-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(242, 107, '2015-01-15 00:02:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(243, 107, '2015-01-15 00:05:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(244, 107, '2015-01-15 00:07:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(245, 107, '2015-01-15 00:09:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(246, 107, '2015-01-15 00:12:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(247, 107, '2015-01-15 00:14:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(248, 107, '2015-01-15 00:16:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(249, 107, '2015-01-15 00:19:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(250, 107, '2015-01-15 00:21:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(251, 107, '2015-01-15 00:23:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(252, 107, '2015-01-15 00:25:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(253, 107, '2015-01-15 00:28:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(254, 107, '2015-01-15 00:30:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(255, 107, '2015-01-15 00:33:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(256, 107, '2015-01-15 00:36:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(257, 107, '2015-01-15 00:40:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(258, 107, '2015-01-15 00:43:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(259, 107, '2015-01-15 00:46:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(260, 107, '2015-01-15 00:48:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(261, 107, '2015-01-15 00:50:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(262, 107, '2015-01-15 00:52:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(263, 107, '2015-01-15 00:55:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(264, 107, '2015-01-15 00:58:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(265, 107, '2015-01-15 01:01:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(266, 107, '2015-01-15 01:03:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(267, 107, '2015-01-15 01:06:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(268, 107, '2015-01-15 01:09:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(269, 107, '2015-01-15 01:12:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(270, 107, '2015-01-15 01:15:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(271, 107, '2015-01-15 01:18:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(272, 107, '2015-01-15 01:20:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(273, 107, '2015-01-15 01:22:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(274, 107, '2015-01-15 01:24:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(275, 107, '2015-01-15 01:27:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(276, 107, '2015-01-15 01:29:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(277, 107, '2015-01-15 01:31:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(278, 107, '2015-01-15 01:34:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(279, 107, '2015-01-15 01:37:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(280, 107, '2015-01-15 01:40:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(281, 107, '2015-01-15 01:42:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(282, 107, '2015-01-15 01:45:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(283, 107, '2015-01-15 01:49:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(284, 107, '2015-01-15 01:52:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(285, 107, '2015-01-15 01:56:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(286, 107, '2015-01-15 01:57:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(287, 107, '2015-01-15 01:59:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(288, 107, '2015-01-15 02:01:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(289, 107, '2015-01-15 02:03:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(290, 107, '2015-01-15 02:05:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(291, 107, '2015-01-15 02:07:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(292, 107, '2015-01-15 02:09:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(293, 107, '2015-01-15 02:12:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(294, 107, '2015-01-15 02:15:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(295, 107, '2015-01-15 02:17:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(296, 107, '2015-01-15 02:20:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(297, 107, '2015-01-15 02:23:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(298, 107, '2015-01-15 02:26:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(299, 107, '2015-01-15 02:28:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(300, 107, '2015-01-15 02:30:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(301, 103, '2015-02-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(302, 103, '2015-02-01 00:02:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(303, 103, '2015-02-01 00:04:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(304, 103, '2015-02-01 00:08:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(305, 103, '2015-02-01 00:10:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(306, 103, '2015-02-01 00:13:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(307, 103, '2015-02-01 00:16:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(308, 103, '2015-02-01 00:18:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(309, 103, '2015-02-01 00:20:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(310, 103, '2015-02-01 00:23:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(311, 103, '2015-02-01 00:24:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(312, 103, '2015-02-01 00:27:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(313, 103, '2015-02-01 00:30:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(314, 103, '2015-02-01 00:32:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(315, 103, '2015-02-01 00:35:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(316, 103, '2015-02-01 00:38:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(317, 103, '2015-02-01 00:39:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(318, 103, '2015-02-01 00:41:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(319, 103, '2015-02-01 00:44:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(320, 103, '2015-02-01 00:47:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(321, 103, '2015-02-01 00:49:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(322, 103, '2015-02-01 00:52:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(323, 103, '2015-02-01 00:54:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(324, 103, '2015-02-01 00:58:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(325, 103, '2015-02-01 01:01:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(326, 103, '2015-02-01 01:03:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(327, 103, '2015-02-01 01:06:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(328, 103, '2015-02-01 01:10:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(329, 103, '2015-02-01 01:13:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(330, 103, '2015-02-01 01:17:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(331, 103, '2015-02-01 01:19:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(332, 103, '2015-02-01 01:22:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(333, 103, '2015-02-01 01:24:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(334, 103, '2015-02-01 01:26:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(335, 103, '2015-02-01 01:29:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(336, 103, '2015-02-01 01:32:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(337, 103, '2015-02-01 01:34:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(338, 103, '2015-02-01 01:37:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(339, 103, '2015-02-01 01:40:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(340, 103, '2015-02-01 01:41:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(341, 103, '2015-02-01 01:43:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(342, 103, '2015-02-01 01:46:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(343, 103, '2015-02-01 01:49:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(344, 103, '2015-02-01 01:52:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(345, 103, '2015-02-01 01:55:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(346, 103, '2015-02-01 01:57:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(347, 103, '2015-02-01 02:00:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(348, 103, '2015-02-01 02:04:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(349, 103, '2015-02-01 02:06:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(350, 103, '2015-02-01 02:09:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(351, 103, '2015-02-01 02:13:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(352, 103, '2015-02-01 02:15:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(353, 103, '2015-02-01 02:16:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(354, 103, '2015-02-01 02:19:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(355, 103, '2015-02-01 02:21:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(356, 103, '2015-02-01 02:23:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(357, 103, '2015-02-01 02:26:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(358, 103, '2015-02-01 02:29:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(359, 103, '2015-02-01 02:31:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(360, 103, '2015-02-01 02:34:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(361, 104, '2015-02-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(362, 104, '2015-02-01 00:03:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(363, 104, '2015-02-01 00:05:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(364, 104, '2015-02-01 00:07:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(365, 104, '2015-02-01 00:10:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(366, 104, '2015-02-01 00:13:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(367, 104, '2015-02-01 00:15:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(368, 104, '2015-02-01 00:17:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(369, 104, '2015-02-01 00:19:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(370, 104, '2015-02-01 00:21:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(371, 104, '2015-02-01 00:23:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(372, 104, '2015-02-01 00:24:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(373, 104, '2015-02-01 00:28:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(374, 104, '2015-02-01 00:31:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(375, 104, '2015-02-01 00:34:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(376, 104, '2015-02-01 00:37:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(377, 104, '2015-02-01 00:40:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(378, 104, '2015-02-01 00:43:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(379, 104, '2015-02-01 00:45:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(380, 104, '2015-02-01 00:48:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(381, 104, '2015-02-01 00:51:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(382, 104, '2015-02-01 00:52:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(383, 104, '2015-02-01 00:55:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(384, 104, '2015-02-01 00:58:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(385, 104, '2015-02-01 01:01:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(386, 104, '2015-02-01 01:04:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(387, 104, '2015-02-01 01:07:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(388, 104, '2015-02-01 01:10:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(389, 104, '2015-02-01 01:12:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(390, 104, '2015-02-01 01:14:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(391, 104, '2015-02-01 01:17:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(392, 104, '2015-02-01 01:19:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(393, 104, '2015-02-01 01:22:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(394, 104, '2015-02-01 01:24:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(395, 104, '2015-02-01 01:25:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(396, 104, '2015-02-01 01:28:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(397, 104, '2015-02-01 01:29:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(398, 104, '2015-02-01 01:31:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(399, 104, '2015-02-01 01:34:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(400, 104, '2015-02-01 01:36:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(401, 104, '2015-02-01 01:40:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(402, 104, '2015-02-01 01:42:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(403, 104, '2015-02-01 01:44:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(404, 104, '2015-02-01 01:48:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(405, 104, '2015-02-01 01:50:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(406, 104, '2015-02-01 01:53:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(407, 104, '2015-02-01 01:55:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(408, 104, '2015-02-01 01:58:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(409, 104, '2015-02-01 02:01:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(410, 104, '2015-02-01 02:03:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(411, 104, '2015-02-01 02:05:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(412, 104, '2015-02-01 02:08:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(413, 104, '2015-02-01 02:10:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(414, 104, '2015-02-01 02:11:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(415, 104, '2015-02-01 02:13:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(416, 104, '2015-02-01 02:17:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(417, 104, '2015-02-01 02:19:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(418, 104, '2015-02-01 02:21:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(419, 104, '2015-02-01 02:23:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(420, 104, '2015-02-01 02:25:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(421, 105, '2015-02-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(422, 105, '2015-02-01 00:03:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(423, 105, '2015-02-01 00:04:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(424, 105, '2015-02-01 00:08:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(425, 105, '2015-02-01 00:11:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(426, 105, '2015-02-01 00:15:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(427, 105, '2015-02-01 00:19:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(428, 105, '2015-02-01 00:21:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(429, 105, '2015-02-01 00:23:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(430, 105, '2015-02-01 00:25:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(431, 105, '2015-02-01 00:27:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(432, 105, '2015-02-01 00:29:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(433, 105, '2015-02-01 00:32:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(434, 105, '2015-02-01 00:35:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(435, 105, '2015-02-01 00:37:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(436, 105, '2015-02-01 00:39:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(437, 105, '2015-02-01 00:42:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(438, 105, '2015-02-01 00:44:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(439, 105, '2015-02-01 00:47:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(440, 105, '2015-02-01 00:49:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(441, 105, '2015-02-01 00:51:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(442, 105, '2015-02-01 00:54:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(443, 105, '2015-02-01 00:58:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(444, 105, '2015-02-01 01:00:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(445, 105, '2015-02-01 01:03:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(446, 105, '2015-02-01 01:05:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(447, 105, '2015-02-01 01:07:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(448, 105, '2015-02-01 01:10:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(449, 105, '2015-02-01 01:13:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(450, 105, '2015-02-01 01:16:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(451, 105, '2015-02-01 01:18:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(452, 105, '2015-02-01 01:20:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(453, 105, '2015-02-01 01:24:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(454, 105, '2015-02-01 01:28:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(455, 105, '2015-02-01 01:30:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(456, 105, '2015-02-01 01:33:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(457, 105, '2015-02-01 01:35:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(458, 105, '2015-02-01 01:39:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(459, 105, '2015-02-01 01:41:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(460, 105, '2015-02-01 01:44:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(461, 105, '2015-02-01 01:48:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(462, 105, '2015-02-01 01:51:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(463, 105, '2015-02-01 01:54:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(464, 105, '2015-02-01 01:57:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(465, 105, '2015-02-01 02:00:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(466, 105, '2015-02-01 02:02:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(467, 105, '2015-02-01 02:05:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(468, 105, '2015-02-01 02:09:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(469, 105, '2015-02-01 02:10:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(470, 105, '2015-02-01 02:14:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(471, 105, '2015-02-01 02:17:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(472, 105, '2015-02-01 02:21:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(473, 105, '2015-02-01 02:23:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(474, 105, '2015-02-01 02:25:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(475, 105, '2015-02-01 02:28:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(476, 105, '2015-02-01 02:30:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(477, 105, '2015-02-01 02:33:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(478, 105, '2015-02-01 02:36:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(479, 105, '2015-02-01 02:40:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(480, 105, '2015-02-01 02:42:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(481, 106, '2015-02-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(482, 106, '2015-02-01 00:02:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(483, 106, '2015-02-01 00:04:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(484, 106, '2015-02-01 00:07:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(485, 106, '2015-02-01 00:10:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(486, 106, '2015-02-01 00:12:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(487, 106, '2015-02-01 00:15:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(488, 106, '2015-02-01 00:18:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(489, 106, '2015-02-01 00:21:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(490, 106, '2015-02-01 00:24:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(491, 106, '2015-02-01 00:26:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(492, 106, '2015-02-01 00:30:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(493, 106, '2015-02-01 00:32:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(494, 106, '2015-02-01 00:34:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(495, 106, '2015-02-01 00:37:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(496, 106, '2015-02-01 00:39:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(497, 106, '2015-02-01 00:42:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(498, 106, '2015-02-01 00:45:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(499, 106, '2015-02-01 00:47:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(500, 106, '2015-02-01 00:49:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(501, 106, '2015-02-01 00:51:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(502, 106, '2015-02-01 00:54:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(503, 106, '2015-02-01 00:57:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(504, 106, '2015-02-01 00:59:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(505, 106, '2015-02-01 01:03:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(506, 106, '2015-02-01 01:05:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(507, 106, '2015-02-01 01:08:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(508, 106, '2015-02-01 01:11:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(509, 106, '2015-02-01 01:14:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(510, 106, '2015-02-01 01:16:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(511, 106, '2015-02-01 01:18:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(512, 106, '2015-02-01 01:22:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(513, 106, '2015-02-01 01:24:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(514, 106, '2015-02-01 01:27:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(515, 106, '2015-02-01 01:30:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(516, 106, '2015-02-01 01:33:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(517, 106, '2015-02-01 01:36:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(518, 106, '2015-02-01 01:39:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(519, 106, '2015-02-01 01:43:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(520, 106, '2015-02-01 01:46:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(521, 106, '2015-02-01 01:49:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(522, 106, '2015-02-01 01:52:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(523, 106, '2015-02-01 01:55:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(524, 106, '2015-02-01 01:57:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(525, 106, '2015-02-01 01:59:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(526, 106, '2015-02-01 02:02:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(527, 106, '2015-02-01 02:04:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(528, 106, '2015-02-01 02:07:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(529, 106, '2015-02-01 02:10:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(530, 106, '2015-02-01 02:13:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(531, 106, '2015-02-01 02:16:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(532, 106, '2015-02-01 02:18:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(533, 106, '2015-02-01 02:20:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(534, 106, '2015-02-01 02:23:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(535, 106, '2015-02-01 02:27:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(536, 106, '2015-02-01 02:30:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(537, 106, '2015-02-01 02:34:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(538, 106, '2015-02-01 02:35:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(539, 106, '2015-02-01 02:37:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(540, 106, '2015-02-01 02:41:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(541, 107, '2015-02-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(542, 107, '2015-02-01 00:01:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(543, 107, '2015-02-01 00:03:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(544, 107, '2015-02-01 00:06:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(545, 107, '2015-02-01 00:09:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(546, 107, '2015-02-01 00:11:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(547, 107, '2015-02-01 00:13:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(548, 107, '2015-02-01 00:17:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(549, 107, '2015-02-01 00:20:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(550, 107, '2015-02-01 00:22:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(551, 107, '2015-02-01 00:25:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(552, 107, '2015-02-01 00:28:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(553, 107, '2015-02-01 00:31:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(554, 107, '2015-02-01 00:33:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(555, 107, '2015-02-01 00:34:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(556, 107, '2015-02-01 00:37:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(557, 107, '2015-02-01 00:39:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(558, 107, '2015-02-01 00:41:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(559, 107, '2015-02-01 00:44:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(560, 107, '2015-02-01 00:46:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(561, 107, '2015-02-01 00:47:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(562, 107, '2015-02-01 00:49:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(563, 107, '2015-02-01 00:52:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(564, 107, '2015-02-01 00:55:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(565, 107, '2015-02-01 00:57:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(566, 107, '2015-02-01 00:59:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(567, 107, '2015-02-01 01:01:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(568, 107, '2015-02-01 01:04:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(569, 107, '2015-02-01 01:07:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(570, 107, '2015-02-01 01:10:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(571, 107, '2015-02-01 01:13:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(572, 107, '2015-02-01 01:15:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(573, 107, '2015-02-01 01:17:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(574, 107, '2015-02-01 01:19:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(575, 107, '2015-02-01 01:21:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(576, 107, '2015-02-01 01:24:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(577, 107, '2015-02-01 01:26:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(578, 107, '2015-02-01 01:28:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(579, 107, '2015-02-01 01:30:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(580, 107, '2015-02-01 01:33:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(581, 107, '2015-02-01 01:35:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(582, 107, '2015-02-01 01:38:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(583, 107, '2015-02-01 01:40:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(584, 107, '2015-02-01 01:42:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(585, 107, '2015-02-01 01:45:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(586, 107, '2015-02-01 01:46:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(587, 107, '2015-02-01 01:49:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(588, 107, '2015-02-01 01:52:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(589, 107, '2015-02-01 01:55:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(590, 107, '2015-02-01 01:58:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(591, 107, '2015-02-01 02:01:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(592, 107, '2015-02-01 02:03:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(593, 107, '2015-02-01 02:05:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(594, 107, '2015-02-01 02:08:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(595, 107, '2015-02-01 02:09:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(596, 107, '2015-02-01 02:11:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(597, 107, '2015-02-01 02:15:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(598, 107, '2015-02-01 02:18:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(599, 107, '2015-02-01 02:19:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(600, 107, '2015-02-01 02:21:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(601, 103, '2015-02-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(602, 103, '2015-02-15 00:03:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(603, 103, '2015-02-15 00:05:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(604, 103, '2015-02-15 00:08:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(605, 103, '2015-02-15 00:09:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(606, 103, '2015-02-15 00:13:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(607, 103, '2015-02-15 00:16:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(608, 103, '2015-02-15 00:18:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(609, 103, '2015-02-15 00:21:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(610, 103, '2015-02-15 00:23:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(611, 103, '2015-02-15 00:26:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(612, 103, '2015-02-15 00:29:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(613, 103, '2015-02-15 00:32:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(614, 103, '2015-02-15 00:34:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(615, 103, '2015-02-15 00:36:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(616, 103, '2015-02-15 00:39:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(617, 103, '2015-02-15 00:42:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(618, 103, '2015-02-15 00:45:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(619, 103, '2015-02-15 00:48:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(620, 103, '2015-02-15 00:50:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(621, 103, '2015-02-15 00:52:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(622, 103, '2015-02-15 00:55:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(623, 103, '2015-02-15 00:58:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(624, 103, '2015-02-15 01:00:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(625, 103, '2015-02-15 01:02:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(626, 103, '2015-02-15 01:06:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(627, 103, '2015-02-15 01:09:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(628, 103, '2015-02-15 01:13:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(629, 103, '2015-02-15 01:15:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(630, 103, '2015-02-15 01:18:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(631, 103, '2015-02-15 01:21:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(632, 103, '2015-02-15 01:23:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(633, 103, '2015-02-15 01:25:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(634, 103, '2015-02-15 01:27:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(635, 103, '2015-02-15 01:29:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(636, 103, '2015-02-15 01:33:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(637, 103, '2015-02-15 01:35:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(638, 103, '2015-02-15 01:37:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(639, 103, '2015-02-15 01:40:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(640, 103, '2015-02-15 01:42:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(641, 103, '2015-02-15 01:44:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(642, 103, '2015-02-15 01:48:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(643, 103, '2015-02-15 01:50:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(644, 103, '2015-02-15 01:53:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(645, 103, '2015-02-15 01:55:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(646, 103, '2015-02-15 01:57:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(647, 103, '2015-02-15 01:58:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(648, 103, '2015-02-15 02:01:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(649, 103, '2015-02-15 02:05:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(650, 103, '2015-02-15 02:08:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(651, 103, '2015-02-15 02:11:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(652, 103, '2015-02-15 02:13:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(653, 103, '2015-02-15 02:16:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(654, 103, '2015-02-15 02:18:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(655, 103, '2015-02-15 02:21:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(656, 103, '2015-02-15 02:23:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(657, 103, '2015-02-15 02:25:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(658, 103, '2015-02-15 02:27:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(659, 103, '2015-02-15 02:29:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(660, 103, '2015-02-15 02:32:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(661, 104, '2015-02-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(662, 104, '2015-02-15 00:02:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(663, 104, '2015-02-15 00:06:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(664, 104, '2015-02-15 00:07:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(665, 104, '2015-02-15 00:10:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(666, 104, '2015-02-15 00:13:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(667, 104, '2015-02-15 00:17:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(668, 104, '2015-02-15 00:18:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(669, 104, '2015-02-15 00:21:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(670, 104, '2015-02-15 00:24:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(671, 104, '2015-02-15 00:27:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(672, 104, '2015-02-15 00:29:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(673, 104, '2015-02-15 00:31:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(674, 104, '2015-02-15 00:33:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(675, 104, '2015-02-15 00:36:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(676, 104, '2015-02-15 00:37:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(677, 104, '2015-02-15 00:39:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(678, 104, '2015-02-15 00:41:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(679, 104, '2015-02-15 00:43:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(680, 104, '2015-02-15 00:46:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(681, 104, '2015-02-15 00:47:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(682, 104, '2015-02-15 00:49:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(683, 104, '2015-02-15 00:51:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(684, 104, '2015-02-15 00:53:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(685, 104, '2015-02-15 00:56:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(686, 104, '2015-02-15 00:59:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(687, 104, '2015-02-15 01:00:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(688, 104, '2015-02-15 01:03:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(689, 104, '2015-02-15 01:06:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(690, 104, '2015-02-15 01:08:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(691, 104, '2015-02-15 01:11:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(692, 104, '2015-02-15 01:13:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(693, 104, '2015-02-15 01:15:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(694, 104, '2015-02-15 01:17:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(695, 104, '2015-02-15 01:19:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(696, 104, '2015-02-15 01:21:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(697, 104, '2015-02-15 01:24:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(698, 104, '2015-02-15 01:26:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(699, 104, '2015-02-15 01:29:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(700, 104, '2015-02-15 01:32:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(701, 104, '2015-02-15 01:34:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(702, 104, '2015-02-15 01:35:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(703, 104, '2015-02-15 01:38:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(704, 104, '2015-02-15 01:40:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(705, 104, '2015-02-15 01:43:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(706, 104, '2015-02-15 01:46:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(707, 104, '2015-02-15 01:50:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(708, 104, '2015-02-15 01:53:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(709, 104, '2015-02-15 01:57:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(710, 104, '2015-02-15 02:00:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(711, 104, '2015-02-15 02:02:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(712, 104, '2015-02-15 02:04:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(713, 104, '2015-02-15 02:07:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(714, 104, '2015-02-15 02:09:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(715, 104, '2015-02-15 02:11:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(716, 104, '2015-02-15 02:13:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(717, 104, '2015-02-15 02:16:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(718, 104, '2015-02-15 02:18:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(719, 104, '2015-02-15 02:20:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(720, 104, '2015-02-15 02:21:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(721, 105, '2015-02-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(722, 105, '2015-02-15 00:03:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(723, 105, '2015-02-15 00:05:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(724, 105, '2015-02-15 00:07:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(725, 105, '2015-02-15 00:09:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(726, 105, '2015-02-15 00:10:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(727, 105, '2015-02-15 00:13:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(728, 105, '2015-02-15 00:15:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(729, 105, '2015-02-15 00:19:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(730, 105, '2015-02-15 00:20:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(731, 105, '2015-02-15 00:23:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(732, 105, '2015-02-15 00:26:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(733, 105, '2015-02-15 00:30:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(734, 105, '2015-02-15 00:33:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(735, 105, '2015-02-15 00:35:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(736, 105, '2015-02-15 00:38:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(737, 105, '2015-02-15 00:40:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(738, 105, '2015-02-15 00:42:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(739, 105, '2015-02-15 00:44:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(740, 105, '2015-02-15 00:47:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(741, 105, '2015-02-15 00:50:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(742, 105, '2015-02-15 00:53:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(743, 105, '2015-02-15 00:56:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(744, 105, '2015-02-15 00:59:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(745, 105, '2015-02-15 01:01:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(746, 105, '2015-02-15 01:03:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(747, 105, '2015-02-15 01:06:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(748, 105, '2015-02-15 01:08:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(749, 105, '2015-02-15 01:10:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(750, 105, '2015-02-15 01:13:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(751, 105, '2015-02-15 01:15:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(752, 105, '2015-02-15 01:17:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(753, 105, '2015-02-15 01:20:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(754, 105, '2015-02-15 01:23:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(755, 105, '2015-02-15 01:25:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(756, 105, '2015-02-15 01:28:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(757, 105, '2015-02-15 01:31:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(758, 105, '2015-02-15 01:33:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(759, 105, '2015-02-15 01:36:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(760, 105, '2015-02-15 01:38:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(761, 105, '2015-02-15 01:40:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(762, 105, '2015-02-15 01:43:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(763, 105, '2015-02-15 01:46:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(764, 105, '2015-02-15 01:48:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(765, 105, '2015-02-15 01:51:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(766, 105, '2015-02-15 01:54:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(767, 105, '2015-02-15 01:56:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(768, 105, '2015-02-15 01:58:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(769, 105, '2015-02-15 02:01:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(770, 105, '2015-02-15 02:04:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(771, 105, '2015-02-15 02:07:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(772, 105, '2015-02-15 02:10:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(773, 105, '2015-02-15 02:13:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(774, 105, '2015-02-15 02:16:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(775, 105, '2015-02-15 02:17:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(776, 105, '2015-02-15 02:20:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(777, 105, '2015-02-15 02:23:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(778, 105, '2015-02-15 02:26:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(779, 105, '2015-02-15 02:29:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(780, 105, '2015-02-15 02:32:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(781, 106, '2015-02-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(782, 106, '2015-02-15 00:01:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(783, 106, '2015-02-15 00:04:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(784, 106, '2015-02-15 00:08:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(785, 106, '2015-02-15 00:11:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(786, 106, '2015-02-15 00:13:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(787, 106, '2015-02-15 00:16:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(788, 106, '2015-02-15 00:19:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(789, 106, '2015-02-15 00:22:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(790, 106, '2015-02-15 00:25:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(791, 106, '2015-02-15 00:29:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(792, 106, '2015-02-15 00:32:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(793, 106, '2015-02-15 00:34:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(794, 106, '2015-02-15 00:37:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(795, 106, '2015-02-15 00:40:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(796, 106, '2015-02-15 00:43:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(797, 106, '2015-02-15 00:45:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(798, 106, '2015-02-15 00:47:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(799, 106, '2015-02-15 00:50:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(800, 106, '2015-02-15 00:52:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(801, 106, '2015-02-15 00:56:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(802, 106, '2015-02-15 00:59:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(803, 106, '2015-02-15 01:01:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(804, 106, '2015-02-15 01:04:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(805, 106, '2015-02-15 01:07:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(806, 106, '2015-02-15 01:09:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(807, 106, '2015-02-15 01:12:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(808, 106, '2015-02-15 01:14:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(809, 106, '2015-02-15 01:16:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(810, 106, '2015-02-15 01:19:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(811, 106, '2015-02-15 01:23:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(812, 106, '2015-02-15 01:25:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(813, 106, '2015-02-15 01:27:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(814, 106, '2015-02-15 01:30:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(815, 106, '2015-02-15 01:32:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(816, 106, '2015-02-15 01:33:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(817, 106, '2015-02-15 01:36:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(818, 106, '2015-02-15 01:39:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(819, 106, '2015-02-15 01:40:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(820, 106, '2015-02-15 01:42:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(821, 106, '2015-02-15 01:44:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(822, 106, '2015-02-15 01:46:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(823, 106, '2015-02-15 01:49:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(824, 106, '2015-02-15 01:53:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(825, 106, '2015-02-15 01:56:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(826, 106, '2015-02-15 02:00:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(827, 106, '2015-02-15 02:03:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(828, 106, '2015-02-15 02:05:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(829, 106, '2015-02-15 02:08:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(830, 106, '2015-02-15 02:11:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(831, 106, '2015-02-15 02:13:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(832, 106, '2015-02-15 02:16:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(833, 106, '2015-02-15 02:19:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(834, 106, '2015-02-15 02:21:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(835, 106, '2015-02-15 02:25:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(836, 106, '2015-02-15 02:26:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(837, 106, '2015-02-15 02:29:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(838, 106, '2015-02-15 02:31:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(839, 106, '2015-02-15 02:35:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(840, 106, '2015-02-15 02:37:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(841, 107, '2015-02-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(842, 107, '2015-02-15 00:02:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(843, 107, '2015-02-15 00:06:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(844, 107, '2015-02-15 00:09:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(845, 107, '2015-02-15 00:12:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(846, 107, '2015-02-15 00:16:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(847, 107, '2015-02-15 00:20:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(848, 107, '2015-02-15 00:22:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(849, 107, '2015-02-15 00:24:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(850, 107, '2015-02-15 00:25:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(851, 107, '2015-02-15 00:28:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(852, 107, '2015-02-15 00:30:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(853, 107, '2015-02-15 00:33:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(854, 107, '2015-02-15 00:35:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(855, 107, '2015-02-15 00:39:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(856, 107, '2015-02-15 00:43:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(857, 107, '2015-02-15 00:47:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(858, 107, '2015-02-15 00:50:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(859, 107, '2015-02-15 00:53:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(860, 107, '2015-02-15 00:57:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(861, 107, '2015-02-15 01:01:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(862, 107, '2015-02-15 01:03:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(863, 107, '2015-02-15 01:06:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(864, 107, '2015-02-15 01:09:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(865, 107, '2015-02-15 01:12:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(866, 107, '2015-02-15 01:14:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(867, 107, '2015-02-15 01:18:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(868, 107, '2015-02-15 01:21:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(869, 107, '2015-02-15 01:23:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(870, 107, '2015-02-15 01:26:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(871, 107, '2015-02-15 01:29:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(872, 107, '2015-02-15 01:32:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(873, 107, '2015-02-15 01:34:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(874, 107, '2015-02-15 01:36:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(875, 107, '2015-02-15 01:38:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(876, 107, '2015-02-15 01:42:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(877, 107, '2015-02-15 01:44:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(878, 107, '2015-02-15 01:46:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(879, 107, '2015-02-15 01:50:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(880, 107, '2015-02-15 01:53:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(881, 107, '2015-02-15 01:56:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(882, 107, '2015-02-15 01:58:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(883, 107, '2015-02-15 02:01:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(884, 107, '2015-02-15 02:04:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(885, 107, '2015-02-15 02:07:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(886, 107, '2015-02-15 02:10:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(887, 107, '2015-02-15 02:13:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(888, 107, '2015-02-15 02:17:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(889, 107, '2015-02-15 02:21:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(890, 107, '2015-02-15 02:23:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(891, 107, '2015-02-15 02:27:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(892, 107, '2015-02-15 02:30:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(893, 107, '2015-02-15 02:34:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(894, 107, '2015-02-15 02:36:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(895, 107, '2015-02-15 02:40:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(896, 107, '2015-02-15 02:44:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(897, 107, '2015-02-15 02:47:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(898, 107, '2015-02-15 02:49:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(899, 107, '2015-02-15 02:52:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(900, 107, '2015-02-15 02:54:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(901, 103, '2015-03-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(902, 103, '2015-03-01 00:03:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(903, 103, '2015-03-01 00:05:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(904, 103, '2015-03-01 00:07:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(905, 103, '2015-03-01 00:10:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(906, 103, '2015-03-01 00:12:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(907, 103, '2015-03-01 00:15:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(908, 103, '2015-03-01 00:17:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(909, 103, '2015-03-01 00:19:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(910, 103, '2015-03-01 00:22:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(911, 103, '2015-03-01 00:25:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(912, 103, '2015-03-01 00:28:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(913, 103, '2015-03-01 00:30:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(914, 103, '2015-03-01 00:33:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(915, 103, '2015-03-01 00:35:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(916, 103, '2015-03-01 00:37:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(917, 103, '2015-03-01 00:39:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(918, 103, '2015-03-01 00:42:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(919, 103, '2015-03-01 00:45:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(920, 103, '2015-03-01 00:47:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(921, 103, '2015-03-01 00:48:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(922, 103, '2015-03-01 00:51:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(923, 103, '2015-03-01 00:53:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(924, 103, '2015-03-01 00:55:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(925, 103, '2015-03-01 00:58:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(926, 103, '2015-03-01 01:00:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(927, 103, '2015-03-01 01:02:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(928, 103, '2015-03-01 01:05:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(929, 103, '2015-03-01 01:08:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(930, 103, '2015-03-01 01:11:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(931, 103, '2015-03-01 01:14:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(932, 103, '2015-03-01 01:15:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(933, 103, '2015-03-01 01:18:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(934, 103, '2015-03-01 01:21:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(935, 103, '2015-03-01 01:22:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(936, 103, '2015-03-01 01:25:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(937, 103, '2015-03-01 01:28:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(938, 103, '2015-03-01 01:31:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(939, 103, '2015-03-01 01:33:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(940, 103, '2015-03-01 01:36:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(941, 103, '2015-03-01 01:39:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(942, 103, '2015-03-01 01:41:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(943, 103, '2015-03-01 01:42:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(944, 103, '2015-03-01 01:44:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(945, 103, '2015-03-01 01:47:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(946, 103, '2015-03-01 01:50:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(947, 103, '2015-03-01 01:52:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(948, 103, '2015-03-01 01:55:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(949, 103, '2015-03-01 01:57:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(950, 103, '2015-03-01 02:00:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(951, 103, '2015-03-01 02:03:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(952, 103, '2015-03-01 02:06:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(953, 103, '2015-03-01 02:09:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(954, 103, '2015-03-01 02:11:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(955, 103, '2015-03-01 02:14:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(956, 103, '2015-03-01 02:16:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(957, 103, '2015-03-01 02:18:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(958, 103, '2015-03-01 02:20:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(959, 103, '2015-03-01 02:22:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(960, 103, '2015-03-01 02:25:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(961, 104, '2015-03-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(962, 104, '2015-03-01 00:02:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(963, 104, '2015-03-01 00:04:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(964, 104, '2015-03-01 00:07:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(965, 104, '2015-03-01 00:09:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(966, 104, '2015-03-01 00:12:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(967, 104, '2015-03-01 00:14:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(968, 104, '2015-03-01 00:18:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(969, 104, '2015-03-01 00:21:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(970, 104, '2015-03-01 00:24:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(971, 104, '2015-03-01 00:26:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(972, 104, '2015-03-01 00:28:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(973, 104, '2015-03-01 00:30:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(974, 104, '2015-03-01 00:33:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(975, 104, '2015-03-01 00:36:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(976, 104, '2015-03-01 00:39:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(977, 104, '2015-03-01 00:42:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(978, 104, '2015-03-01 00:44:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(979, 104, '2015-03-01 00:46:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(980, 104, '2015-03-01 00:50:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(981, 104, '2015-03-01 00:51:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(982, 104, '2015-03-01 00:55:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(983, 104, '2015-03-01 00:57:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(984, 104, '2015-03-01 01:00:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(985, 104, '2015-03-01 01:02:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(986, 104, '2015-03-01 01:04:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(987, 104, '2015-03-01 01:06:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(988, 104, '2015-03-01 01:08:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(989, 104, '2015-03-01 01:10:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(990, 104, '2015-03-01 01:13:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(991, 104, '2015-03-01 01:16:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(992, 104, '2015-03-01 01:19:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(993, 104, '2015-03-01 01:23:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(994, 104, '2015-03-01 01:25:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(995, 104, '2015-03-01 01:27:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(996, 104, '2015-03-01 01:30:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(997, 104, '2015-03-01 01:34:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(998, 104, '2015-03-01 01:35:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(999, 104, '2015-03-01 01:38:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1000, 104, '2015-03-01 01:40:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1001, 104, '2015-03-01 01:43:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1002, 104, '2015-03-01 01:45:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1003, 104, '2015-03-01 01:47:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1004, 104, '2015-03-01 01:49:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1005, 104, '2015-03-01 01:52:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(1006, 104, '2015-03-01 01:55:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(1007, 104, '2015-03-01 01:58:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(1008, 104, '2015-03-01 02:00:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1009, 104, '2015-03-01 02:02:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1010, 104, '2015-03-01 02:04:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1011, 104, '2015-03-01 02:06:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(1012, 104, '2015-03-01 02:10:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1013, 104, '2015-03-01 02:12:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(1014, 104, '2015-03-01 02:15:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1015, 104, '2015-03-01 02:18:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(1016, 104, '2015-03-01 02:22:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1017, 104, '2015-03-01 02:25:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1018, 104, '2015-03-01 02:29:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1019, 104, '2015-03-01 02:32:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(1020, 104, '2015-03-01 02:35:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(1021, 105, '2015-03-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1022, 105, '2015-03-01 00:01:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(1023, 105, '2015-03-01 00:05:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1024, 105, '2015-03-01 00:08:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1025, 105, '2015-03-01 00:11:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(1026, 105, '2015-03-01 00:13:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(1027, 105, '2015-03-01 00:15:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1028, 105, '2015-03-01 00:18:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(1029, 105, '2015-03-01 00:21:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(1030, 105, '2015-03-01 00:24:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(1031, 105, '2015-03-01 00:26:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(1032, 105, '2015-03-01 00:29:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1033, 105, '2015-03-01 00:32:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(1034, 105, '2015-03-01 00:36:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(1035, 105, '2015-03-01 00:40:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(1036, 105, '2015-03-01 00:42:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1037, 105, '2015-03-01 00:45:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(1038, 105, '2015-03-01 00:48:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(1039, 105, '2015-03-01 00:51:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(1040, 105, '2015-03-01 00:53:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(1041, 105, '2015-03-01 00:56:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(1042, 105, '2015-03-01 00:58:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(1043, 105, '2015-03-01 01:01:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(1044, 105, '2015-03-01 01:05:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(1045, 105, '2015-03-01 01:06:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1046, 105, '2015-03-01 01:10:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(1047, 105, '2015-03-01 01:13:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(1048, 105, '2015-03-01 01:15:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(1049, 105, '2015-03-01 01:18:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1050, 105, '2015-03-01 01:22:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1051, 105, '2015-03-01 01:26:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1052, 105, '2015-03-01 01:29:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1053, 105, '2015-03-01 01:32:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1054, 105, '2015-03-01 01:36:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1055, 105, '2015-03-01 01:39:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1056, 105, '2015-03-01 01:41:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(1057, 105, '2015-03-01 01:44:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(1058, 105, '2015-03-01 01:48:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1059, 105, '2015-03-01 01:50:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(1060, 105, '2015-03-01 01:54:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(1061, 105, '2015-03-01 01:57:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(1062, 105, '2015-03-01 01:59:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(1063, 105, '2015-03-01 02:00:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(1064, 105, '2015-03-01 02:04:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(1065, 105, '2015-03-01 02:07:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1066, 105, '2015-03-01 02:10:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1067, 105, '2015-03-01 02:13:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(1068, 105, '2015-03-01 02:15:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(1069, 105, '2015-03-01 02:18:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1070, 105, '2015-03-01 02:19:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(1071, 105, '2015-03-01 02:22:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1072, 105, '2015-03-01 02:26:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(1073, 105, '2015-03-01 02:28:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1074, 105, '2015-03-01 02:30:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(1075, 105, '2015-03-01 02:33:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(1076, 105, '2015-03-01 02:36:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(1077, 105, '2015-03-01 02:39:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1078, 105, '2015-03-01 02:42:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1079, 105, '2015-03-01 02:46:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1080, 105, '2015-03-01 02:48:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1081, 106, '2015-03-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1082, 106, '2015-03-01 00:01:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1083, 106, '2015-03-01 00:04:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1084, 106, '2015-03-01 00:06:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(1085, 106, '2015-03-01 00:09:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(1086, 106, '2015-03-01 00:11:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(1087, 106, '2015-03-01 00:13:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(1088, 106, '2015-03-01 00:16:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(1089, 106, '2015-03-01 00:17:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(1090, 106, '2015-03-01 00:21:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(1091, 106, '2015-03-01 00:23:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1092, 106, '2015-03-01 00:27:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1093, 106, '2015-03-01 00:29:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1094, 106, '2015-03-01 00:32:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1095, 106, '2015-03-01 00:36:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(1096, 106, '2015-03-01 00:38:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1097, 106, '2015-03-01 00:40:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1098, 106, '2015-03-01 00:42:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(1099, 106, '2015-03-01 00:45:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(1100, 106, '2015-03-01 00:49:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1101, 106, '2015-03-01 00:51:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(1102, 106, '2015-03-01 00:54:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(1103, 106, '2015-03-01 00:56:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(1104, 106, '2015-03-01 00:59:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(1105, 106, '2015-03-01 01:01:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(1106, 106, '2015-03-01 01:04:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(1107, 106, '2015-03-01 01:05:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1108, 106, '2015-03-01 01:08:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(1109, 106, '2015-03-01 01:11:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(1110, 106, '2015-03-01 01:13:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1111, 106, '2015-03-01 01:16:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(1112, 106, '2015-03-01 01:19:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1113, 106, '2015-03-01 01:21:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1114, 106, '2015-03-01 01:23:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(1115, 106, '2015-03-01 01:26:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1116, 106, '2015-03-01 01:30:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1117, 106, '2015-03-01 01:32:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(1118, 106, '2015-03-01 01:35:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(1119, 106, '2015-03-01 01:37:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(1120, 106, '2015-03-01 01:40:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1121, 106, '2015-03-01 01:43:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(1122, 106, '2015-03-01 01:45:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(1123, 106, '2015-03-01 01:48:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1124, 106, '2015-03-01 01:51:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(1125, 106, '2015-03-01 01:53:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(1126, 106, '2015-03-01 01:55:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1127, 106, '2015-03-01 01:58:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(1128, 106, '2015-03-01 02:00:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(1129, 106, '2015-03-01 02:03:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(1130, 106, '2015-03-01 02:05:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(1131, 106, '2015-03-01 02:07:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(1132, 106, '2015-03-01 02:10:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(1133, 106, '2015-03-01 02:12:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1134, 106, '2015-03-01 02:13:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1135, 106, '2015-03-01 02:16:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1136, 106, '2015-03-01 02:18:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(1137, 106, '2015-03-01 02:21:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(1138, 106, '2015-03-01 02:25:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(1139, 106, '2015-03-01 02:27:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1140, 106, '2015-03-01 02:30:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(1141, 107, '2015-03-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1142, 107, '2015-03-01 00:01:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(1143, 107, '2015-03-01 00:05:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(1144, 107, '2015-03-01 00:07:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1145, 107, '2015-03-01 00:11:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1146, 107, '2015-03-01 00:14:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(1147, 107, '2015-03-01 00:17:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(1148, 107, '2015-03-01 00:21:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(1149, 107, '2015-03-01 00:22:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(1150, 107, '2015-03-01 00:24:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(1151, 107, '2015-03-01 00:28:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(1152, 107, '2015-03-01 00:30:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(1153, 107, '2015-03-01 00:32:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1154, 107, '2015-03-01 00:35:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1155, 107, '2015-03-01 00:38:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(1156, 107, '2015-03-01 00:42:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1157, 107, '2015-03-01 00:44:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1158, 107, '2015-03-01 00:48:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(1159, 107, '2015-03-01 00:51:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(1160, 107, '2015-03-01 00:55:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1161, 107, '2015-03-01 00:58:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1162, 107, '2015-03-01 01:00:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(1163, 107, '2015-03-01 01:02:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1164, 107, '2015-03-01 01:03:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(1165, 107, '2015-03-01 01:05:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(1166, 107, '2015-03-01 01:09:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1167, 107, '2015-03-01 01:13:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(1168, 107, '2015-03-01 01:15:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(1169, 107, '2015-03-01 01:17:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1170, 107, '2015-03-01 01:20:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(1171, 107, '2015-03-01 01:23:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(1172, 107, '2015-03-01 01:26:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(1173, 107, '2015-03-01 01:28:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1174, 107, '2015-03-01 01:30:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1175, 107, '2015-03-01 01:33:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1176, 107, '2015-03-01 01:36:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1177, 107, '2015-03-01 01:38:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(1178, 107, '2015-03-01 01:40:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(1179, 107, '2015-03-01 01:43:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1180, 107, '2015-03-01 01:46:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1181, 107, '2015-03-01 01:49:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1182, 107, '2015-03-01 01:52:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(1183, 107, '2015-03-01 01:54:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(1184, 107, '2015-03-01 01:56:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(1185, 107, '2015-03-01 01:59:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1186, 107, '2015-03-01 02:02:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(1187, 107, '2015-03-01 02:05:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(1188, 107, '2015-03-01 02:06:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1189, 107, '2015-03-01 02:09:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(1190, 107, '2015-03-01 02:11:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(1191, 107, '2015-03-01 02:14:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(1192, 107, '2015-03-01 02:17:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1193, 107, '2015-03-01 02:20:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(1194, 107, '2015-03-01 02:22:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(1195, 107, '2015-03-01 02:25:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(1196, 107, '2015-03-01 02:28:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1197, 107, '2015-03-01 02:29:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1198, 107, '2015-03-01 02:31:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1199, 107, '2015-03-01 02:33:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1200, 107, '2015-03-01 02:35:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1201, 103, '2015-03-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1202, 103, '2015-03-15 00:01:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1203, 103, '2015-03-15 00:04:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1204, 103, '2015-03-15 00:06:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(1205, 103, '2015-03-15 00:08:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1206, 103, '2015-03-15 00:11:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(1207, 103, '2015-03-15 00:13:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(1208, 103, '2015-03-15 00:16:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(1209, 103, '2015-03-15 00:19:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(1210, 103, '2015-03-15 00:21:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(1211, 103, '2015-03-15 00:23:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(1212, 103, '2015-03-15 00:25:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1213, 103, '2015-03-15 00:28:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1214, 103, '2015-03-15 00:31:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(1215, 103, '2015-03-15 00:34:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1216, 103, '2015-03-15 00:36:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1217, 103, '2015-03-15 00:38:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(1218, 103, '2015-03-15 00:39:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(1219, 103, '2015-03-15 00:42:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(1220, 103, '2015-03-15 00:44:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(1221, 103, '2015-03-15 00:45:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1222, 103, '2015-03-15 00:48:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1223, 103, '2015-03-15 00:50:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(1224, 103, '2015-03-15 00:52:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1225, 103, '2015-03-15 00:54:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1226, 103, '2015-03-15 00:58:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(1227, 103, '2015-03-15 00:59:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(1228, 103, '2015-03-15 01:02:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1229, 103, '2015-03-15 01:05:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1230, 103, '2015-03-15 01:07:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1231, 103, '2015-03-15 01:10:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1232, 103, '2015-03-15 01:13:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1233, 103, '2015-03-15 01:15:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1234, 103, '2015-03-15 01:16:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(1235, 103, '2015-03-15 01:19:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1236, 103, '2015-03-15 01:22:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1237, 103, '2015-03-15 01:25:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(1238, 103, '2015-03-15 01:27:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1239, 103, '2015-03-15 01:30:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1240, 103, '2015-03-15 01:34:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1241, 103, '2015-03-15 01:36:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(1242, 103, '2015-03-15 01:38:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1243, 103, '2015-03-15 01:40:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(1244, 103, '2015-03-15 01:42:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(1245, 103, '2015-03-15 01:46:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(1246, 103, '2015-03-15 01:47:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(1247, 103, '2015-03-15 01:50:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(1248, 103, '2015-03-15 01:52:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1249, 103, '2015-03-15 01:54:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(1250, 103, '2015-03-15 01:58:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1251, 103, '2015-03-15 02:00:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(1252, 103, '2015-03-15 02:04:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1253, 103, '2015-03-15 02:05:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(1254, 103, '2015-03-15 02:07:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(1255, 103, '2015-03-15 02:10:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(1256, 103, '2015-03-15 02:13:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(1257, 103, '2015-03-15 02:16:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(1258, 103, '2015-03-15 02:18:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1259, 103, '2015-03-15 02:20:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1260, 103, '2015-03-15 02:23:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(1261, 104, '2015-03-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1262, 104, '2015-03-15 00:01:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(1263, 104, '2015-03-15 00:04:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1264, 104, '2015-03-15 00:07:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1265, 104, '2015-03-15 00:09:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(1266, 104, '2015-03-15 00:12:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1267, 104, '2015-03-15 00:15:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(1268, 104, '2015-03-15 00:18:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(1269, 104, '2015-03-15 00:21:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1270, 104, '2015-03-15 00:24:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(1271, 104, '2015-03-15 00:25:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1272, 104, '2015-03-15 00:28:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(1273, 104, '2015-03-15 00:30:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(1274, 104, '2015-03-15 00:34:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(1275, 104, '2015-03-15 00:35:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(1276, 104, '2015-03-15 00:37:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1277, 104, '2015-03-15 00:40:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1278, 104, '2015-03-15 00:43:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1279, 104, '2015-03-15 00:46:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1280, 104, '2015-03-15 00:49:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(1281, 104, '2015-03-15 00:52:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(1282, 104, '2015-03-15 00:55:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1283, 104, '2015-03-15 00:57:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1284, 104, '2015-03-15 00:59:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(1285, 104, '2015-03-15 01:02:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(1286, 104, '2015-03-15 01:05:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1287, 104, '2015-03-15 01:08:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(1288, 104, '2015-03-15 01:11:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1289, 104, '2015-03-15 01:13:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(1290, 104, '2015-03-15 01:16:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(1291, 104, '2015-03-15 01:18:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(1292, 104, '2015-03-15 01:21:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1293, 104, '2015-03-15 01:24:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(1294, 104, '2015-03-15 01:27:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1295, 104, '2015-03-15 01:29:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1296, 104, '2015-03-15 01:31:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(1297, 104, '2015-03-15 01:33:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(1298, 104, '2015-03-15 01:36:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(1299, 104, '2015-03-15 01:39:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1300, 104, '2015-03-15 01:41:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(1301, 104, '2015-03-15 01:45:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1302, 104, '2015-03-15 01:49:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1303, 104, '2015-03-15 01:51:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(1304, 104, '2015-03-15 01:55:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(1305, 104, '2015-03-15 01:58:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1306, 104, '2015-03-15 02:00:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(1307, 104, '2015-03-15 02:03:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1308, 104, '2015-03-15 02:06:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(1309, 104, '2015-03-15 02:08:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(1310, 104, '2015-03-15 02:12:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1311, 104, '2015-03-15 02:14:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1312, 104, '2015-03-15 02:17:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(1313, 104, '2015-03-15 02:20:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(1314, 104, '2015-03-15 02:23:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1315, 104, '2015-03-15 02:25:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(1316, 104, '2015-03-15 02:27:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(1317, 104, '2015-03-15 02:31:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1318, 104, '2015-03-15 02:34:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(1319, 104, '2015-03-15 02:37:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(1320, 104, '2015-03-15 02:40:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(1321, 105, '2015-03-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1322, 105, '2015-03-15 00:03:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(1323, 105, '2015-03-15 00:06:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(1324, 105, '2015-03-15 00:09:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(1325, 105, '2015-03-15 00:12:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(1326, 105, '2015-03-15 00:15:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(1327, 105, '2015-03-15 00:17:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(1328, 105, '2015-03-15 00:20:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(1329, 105, '2015-03-15 00:23:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(1330, 105, '2015-03-15 00:24:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(1331, 105, '2015-03-15 00:27:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1332, 105, '2015-03-15 00:30:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1333, 105, '2015-03-15 00:33:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(1334, 105, '2015-03-15 00:37:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(1335, 105, '2015-03-15 00:40:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(1336, 105, '2015-03-15 00:42:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(1337, 105, '2015-03-15 00:45:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1338, 105, '2015-03-15 00:48:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1339, 105, '2015-03-15 00:52:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(1340, 105, '2015-03-15 00:54:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1341, 105, '2015-03-15 00:57:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(1342, 105, '2015-03-15 01:01:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1343, 105, '2015-03-15 01:04:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(1344, 105, '2015-03-15 01:07:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1345, 105, '2015-03-15 01:09:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(1346, 105, '2015-03-15 01:12:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1347, 105, '2015-03-15 01:13:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(1348, 105, '2015-03-15 01:15:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(1349, 105, '2015-03-15 01:17:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1350, 105, '2015-03-15 01:20:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(1351, 105, '2015-03-15 01:23:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1352, 105, '2015-03-15 01:25:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(1353, 105, '2015-03-15 01:28:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(1354, 105, '2015-03-15 01:32:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1355, 105, '2015-03-15 01:33:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(1356, 105, '2015-03-15 01:36:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(1357, 105, '2015-03-15 01:38:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(1358, 105, '2015-03-15 01:41:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(1359, 105, '2015-03-15 01:45:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(1360, 105, '2015-03-15 01:48:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(1361, 105, '2015-03-15 01:52:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1362, 105, '2015-03-15 01:54:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(1363, 105, '2015-03-15 01:56:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(1364, 105, '2015-03-15 01:58:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1365, 105, '2015-03-15 02:00:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(1366, 105, '2015-03-15 02:04:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1367, 105, '2015-03-15 02:07:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(1368, 105, '2015-03-15 02:10:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1369, 105, '2015-03-15 02:13:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1370, 105, '2015-03-15 02:17:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1371, 105, '2015-03-15 02:20:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1372, 105, '2015-03-15 02:22:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(1373, 105, '2015-03-15 02:26:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(1374, 105, '2015-03-15 02:29:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(1375, 105, '2015-03-15 02:31:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(1376, 105, '2015-03-15 02:33:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(1377, 105, '2015-03-15 02:34:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(1378, 105, '2015-03-15 02:37:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1379, 105, '2015-03-15 02:38:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(1380, 105, '2015-03-15 02:40:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(1381, 106, '2015-03-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1382, 106, '2015-03-15 00:02:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(1383, 106, '2015-03-15 00:03:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(1384, 106, '2015-03-15 00:05:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(1385, 106, '2015-03-15 00:08:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1386, 106, '2015-03-15 00:11:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1387, 106, '2015-03-15 00:13:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1388, 106, '2015-03-15 00:15:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(1389, 106, '2015-03-15 00:17:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1390, 106, '2015-03-15 00:19:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(1391, 106, '2015-03-15 00:21:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(1392, 106, '2015-03-15 00:23:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(1393, 106, '2015-03-15 00:25:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(1394, 106, '2015-03-15 00:28:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1395, 106, '2015-03-15 00:31:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1396, 106, '2015-03-15 00:33:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(1397, 106, '2015-03-15 00:37:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(1398, 106, '2015-03-15 00:40:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(1399, 106, '2015-03-15 00:42:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1400, 106, '2015-03-15 00:45:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(1401, 106, '2015-03-15 00:48:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1402, 106, '2015-03-15 00:51:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1403, 106, '2015-03-15 00:54:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1404, 106, '2015-03-15 00:56:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(1405, 106, '2015-03-15 00:58:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(1406, 106, '2015-03-15 01:02:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1407, 106, '2015-03-15 01:05:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(1408, 106, '2015-03-15 01:08:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1409, 106, '2015-03-15 01:09:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1410, 106, '2015-03-15 01:12:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1411, 106, '2015-03-15 01:15:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(1412, 106, '2015-03-15 01:17:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1413, 106, '2015-03-15 01:19:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(1414, 106, '2015-03-15 01:21:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(1415, 106, '2015-03-15 01:25:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1416, 106, '2015-03-15 01:27:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(1417, 106, '2015-03-15 01:29:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(1418, 106, '2015-03-15 01:31:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(1419, 106, '2015-03-15 01:33:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(1420, 106, '2015-03-15 01:35:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(1421, 106, '2015-03-15 01:37:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(1422, 106, '2015-03-15 01:40:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1423, 106, '2015-03-15 01:42:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1424, 106, '2015-03-15 01:44:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(1425, 106, '2015-03-15 01:46:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(1426, 106, '2015-03-15 01:48:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(1427, 106, '2015-03-15 01:50:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1428, 106, '2015-03-15 01:54:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(1429, 106, '2015-03-15 01:57:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(1430, 106, '2015-03-15 01:59:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1431, 106, '2015-03-15 02:01:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1432, 106, '2015-03-15 02:04:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1433, 106, '2015-03-15 02:06:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(1434, 106, '2015-03-15 02:08:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(1435, 106, '2015-03-15 02:11:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1436, 106, '2015-03-15 02:14:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1437, 106, '2015-03-15 02:17:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1438, 106, '2015-03-15 02:19:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(1439, 106, '2015-03-15 02:22:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(1440, 106, '2015-03-15 02:24:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(1441, 107, '2015-03-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1442, 107, '2015-03-15 00:02:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1443, 107, '2015-03-15 00:05:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(1444, 107, '2015-03-15 00:07:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1445, 107, '2015-03-15 00:10:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(1446, 107, '2015-03-15 00:11:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(1447, 107, '2015-03-15 00:14:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(1448, 107, '2015-03-15 00:17:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(1449, 107, '2015-03-15 00:20:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(1450, 107, '2015-03-15 00:22:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1451, 107, '2015-03-15 00:24:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1452, 107, '2015-03-15 00:26:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(1453, 107, '2015-03-15 00:29:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(1454, 107, '2015-03-15 00:31:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(1455, 107, '2015-03-15 00:33:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(1456, 107, '2015-03-15 00:37:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(1457, 107, '2015-03-15 00:38:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1458, 107, '2015-03-15 00:40:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1459, 107, '2015-03-15 00:43:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1460, 107, '2015-03-15 00:45:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1461, 107, '2015-03-15 00:48:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(1462, 107, '2015-03-15 00:52:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1463, 107, '2015-03-15 00:55:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(1464, 107, '2015-03-15 00:57:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1465, 107, '2015-03-15 00:59:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(1466, 107, '2015-03-15 01:02:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1467, 107, '2015-03-15 01:05:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(1468, 107, '2015-03-15 01:09:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(1469, 107, '2015-03-15 01:13:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(1470, 107, '2015-03-15 01:15:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(1471, 107, '2015-03-15 01:17:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(1472, 107, '2015-03-15 01:20:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(1473, 107, '2015-03-15 01:23:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(1474, 107, '2015-03-15 01:26:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(1475, 107, '2015-03-15 01:30:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1476, 107, '2015-03-15 01:33:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(1477, 107, '2015-03-15 01:35:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(1478, 107, '2015-03-15 01:39:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(1479, 107, '2015-03-15 01:41:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(1480, 107, '2015-03-15 01:43:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(1481, 107, '2015-03-15 01:46:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(1482, 107, '2015-03-15 01:48:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1483, 107, '2015-03-15 01:52:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1484, 107, '2015-03-15 01:54:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1485, 107, '2015-03-15 01:57:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(1486, 107, '2015-03-15 01:59:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(1487, 107, '2015-03-15 02:01:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(1488, 107, '2015-03-15 02:04:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(1489, 107, '2015-03-15 02:06:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(1490, 107, '2015-03-15 02:08:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1491, 107, '2015-03-15 02:09:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(1492, 107, '2015-03-15 02:13:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1493, 107, '2015-03-15 02:16:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(1494, 107, '2015-03-15 02:20:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1495, 107, '2015-03-15 02:21:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(1496, 107, '2015-03-15 02:25:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(1497, 107, '2015-03-15 02:28:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(1498, 107, '2015-03-15 02:30:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1499, 107, '2015-03-15 02:33:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1500, 107, '2015-03-15 02:36:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(1501, 103, '2015-04-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1502, 103, '2015-04-01 00:02:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(1503, 103, '2015-04-01 00:06:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1504, 103, '2015-04-01 00:09:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(1505, 103, '2015-04-01 00:11:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(1506, 103, '2015-04-01 00:14:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(1507, 103, '2015-04-01 00:16:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(1508, 103, '2015-04-01 00:18:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(1509, 103, '2015-04-01 00:21:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(1510, 103, '2015-04-01 00:24:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(1511, 103, '2015-04-01 00:26:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(1512, 103, '2015-04-01 00:30:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1513, 103, '2015-04-01 00:32:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(1514, 103, '2015-04-01 00:34:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1515, 103, '2015-04-01 00:37:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1516, 103, '2015-04-01 00:40:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1517, 103, '2015-04-01 00:43:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1518, 103, '2015-04-01 00:46:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1519, 103, '2015-04-01 00:48:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1520, 103, '2015-04-01 00:50:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(1521, 103, '2015-04-01 00:53:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(1522, 103, '2015-04-01 00:56:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(1523, 103, '2015-04-01 00:59:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1524, 103, '2015-04-01 01:01:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(1525, 103, '2015-04-01 01:03:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(1526, 103, '2015-04-01 01:05:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(1527, 103, '2015-04-01 01:07:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(1528, 103, '2015-04-01 01:10:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1529, 103, '2015-04-01 01:12:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(1530, 103, '2015-04-01 01:14:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(1531, 103, '2015-04-01 01:16:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1532, 103, '2015-04-01 01:19:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(1533, 103, '2015-04-01 01:22:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(1534, 103, '2015-04-01 01:26:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(1535, 103, '2015-04-01 01:29:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(1536, 103, '2015-04-01 01:31:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1537, 103, '2015-04-01 01:34:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(1538, 103, '2015-04-01 01:35:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(1539, 103, '2015-04-01 01:38:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1540, 103, '2015-04-01 01:41:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1541, 103, '2015-04-01 01:44:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1542, 103, '2015-04-01 01:47:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(1543, 103, '2015-04-01 01:50:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(1544, 103, '2015-04-01 01:52:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(1545, 103, '2015-04-01 01:54:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(1546, 103, '2015-04-01 01:56:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1547, 103, '2015-04-01 01:58:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1548, 103, '2015-04-01 02:01:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(1549, 103, '2015-04-01 02:03:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(1550, 103, '2015-04-01 02:05:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1551, 103, '2015-04-01 02:08:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1552, 103, '2015-04-01 02:10:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(1553, 103, '2015-04-01 02:13:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1554, 103, '2015-04-01 02:14:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(1555, 103, '2015-04-01 02:17:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(1556, 103, '2015-04-01 02:20:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(1557, 103, '2015-04-01 02:22:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(1558, 103, '2015-04-01 02:25:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(1559, 103, '2015-04-01 02:28:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(1560, 103, '2015-04-01 02:31:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(1561, 104, '2015-04-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1562, 104, '2015-04-01 00:01:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1563, 104, '2015-04-01 00:04:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1564, 104, '2015-04-01 00:07:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(1565, 104, '2015-04-01 00:10:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1566, 104, '2015-04-01 00:14:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(1567, 104, '2015-04-01 00:18:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(1568, 104, '2015-04-01 00:20:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1569, 104, '2015-04-01 00:23:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1570, 104, '2015-04-01 00:26:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1571, 104, '2015-04-01 00:30:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(1572, 104, '2015-04-01 00:31:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1573, 104, '2015-04-01 00:33:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1574, 104, '2015-04-01 00:37:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(1575, 104, '2015-04-01 00:40:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(1576, 104, '2015-04-01 00:42:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(1577, 104, '2015-04-01 00:45:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(1578, 104, '2015-04-01 00:46:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(1579, 104, '2015-04-01 00:50:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1580, 104, '2015-04-01 00:51:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1581, 104, '2015-04-01 00:54:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(1582, 104, '2015-04-01 00:58:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(1583, 104, '2015-04-01 00:59:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1584, 104, '2015-04-01 01:03:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1585, 104, '2015-04-01 01:04:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1586, 104, '2015-04-01 01:07:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1587, 104, '2015-04-01 01:09:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(1588, 104, '2015-04-01 01:12:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(1589, 104, '2015-04-01 01:15:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(1590, 104, '2015-04-01 01:18:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(1591, 104, '2015-04-01 01:20:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1592, 104, '2015-04-01 01:22:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1593, 104, '2015-04-01 01:24:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(1594, 104, '2015-04-01 01:26:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(1595, 104, '2015-04-01 01:29:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1596, 104, '2015-04-01 01:31:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(1597, 104, '2015-04-01 01:33:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(1598, 104, '2015-04-01 01:34:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1599, 104, '2015-04-01 01:37:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(1600, 104, '2015-04-01 01:41:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(1601, 104, '2015-04-01 01:43:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1602, 104, '2015-04-01 01:45:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(1603, 104, '2015-04-01 01:47:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1604, 104, '2015-04-01 01:49:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1605, 104, '2015-04-01 01:51:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(1606, 104, '2015-04-01 01:53:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1607, 104, '2015-04-01 01:55:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(1608, 104, '2015-04-01 01:57:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(1609, 104, '2015-04-01 02:00:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(1610, 104, '2015-04-01 02:03:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1611, 104, '2015-04-01 02:06:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1612, 104, '2015-04-01 02:09:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1613, 104, '2015-04-01 02:11:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1614, 104, '2015-04-01 02:13:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1615, 104, '2015-04-01 02:17:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1616, 104, '2015-04-01 02:20:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1617, 104, '2015-04-01 02:23:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1618, 104, '2015-04-01 02:26:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(1619, 104, '2015-04-01 02:30:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1620, 104, '2015-04-01 02:32:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1621, 105, '2015-04-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1622, 105, '2015-04-01 00:01:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(1623, 105, '2015-04-01 00:04:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1624, 105, '2015-04-01 00:06:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1625, 105, '2015-04-01 00:09:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1626, 105, '2015-04-01 00:11:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(1627, 105, '2015-04-01 00:14:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1628, 105, '2015-04-01 00:17:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(1629, 105, '2015-04-01 00:19:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(1630, 105, '2015-04-01 00:22:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(1631, 105, '2015-04-01 00:25:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(1632, 105, '2015-04-01 00:27:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1633, 105, '2015-04-01 00:30:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1634, 105, '2015-04-01 00:33:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1635, 105, '2015-04-01 00:35:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1636, 105, '2015-04-01 00:37:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1637, 105, '2015-04-01 00:40:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1638, 105, '2015-04-01 00:43:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1639, 105, '2015-04-01 00:45:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(1640, 105, '2015-04-01 00:48:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(1641, 105, '2015-04-01 00:51:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(1642, 105, '2015-04-01 00:54:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(1643, 105, '2015-04-01 00:56:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1644, 105, '2015-04-01 01:00:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1645, 105, '2015-04-01 01:03:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(1646, 105, '2015-04-01 01:05:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(1647, 105, '2015-04-01 01:09:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(1648, 105, '2015-04-01 01:12:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(1649, 105, '2015-04-01 01:15:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1650, 105, '2015-04-01 01:18:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(1651, 105, '2015-04-01 01:22:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1652, 105, '2015-04-01 01:24:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(1653, 105, '2015-04-01 01:26:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(1654, 105, '2015-04-01 01:28:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(1655, 105, '2015-04-01 01:30:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(1656, 105, '2015-04-01 01:31:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(1657, 105, '2015-04-01 01:33:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1658, 105, '2015-04-01 01:35:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(1659, 105, '2015-04-01 01:37:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1660, 105, '2015-04-01 01:39:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(1661, 105, '2015-04-01 01:41:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(1662, 105, '2015-04-01 01:43:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(1663, 105, '2015-04-01 01:47:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(1664, 105, '2015-04-01 01:50:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(1665, 105, '2015-04-01 01:51:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(1666, 105, '2015-04-01 01:53:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1667, 105, '2015-04-01 01:55:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1668, 105, '2015-04-01 01:58:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1669, 105, '2015-04-01 01:59:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1670, 105, '2015-04-01 02:02:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1671, 105, '2015-04-01 02:04:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(1672, 105, '2015-04-01 02:06:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1673, 105, '2015-04-01 02:09:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(1674, 105, '2015-04-01 02:11:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(1675, 105, '2015-04-01 02:13:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1676, 105, '2015-04-01 02:15:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(1677, 105, '2015-04-01 02:17:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1678, 105, '2015-04-01 02:19:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(1679, 105, '2015-04-01 02:21:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(1680, 105, '2015-04-01 02:25:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(1681, 106, '2015-04-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1682, 106, '2015-04-01 00:02:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1683, 106, '2015-04-01 00:05:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(1684, 106, '2015-04-01 00:08:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(1685, 106, '2015-04-01 00:11:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(1686, 106, '2015-04-01 00:13:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(1687, 106, '2015-04-01 00:16:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(1688, 106, '2015-04-01 00:20:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1689, 106, '2015-04-01 00:23:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1690, 106, '2015-04-01 00:26:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1691, 106, '2015-04-01 00:28:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1692, 106, '2015-04-01 00:30:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1693, 106, '2015-04-01 00:33:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1694, 106, '2015-04-01 00:35:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(1695, 106, '2015-04-01 00:38:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1696, 106, '2015-04-01 00:41:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(1697, 106, '2015-04-01 00:44:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(1698, 106, '2015-04-01 00:46:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(1699, 106, '2015-04-01 00:49:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(1700, 106, '2015-04-01 00:52:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1701, 106, '2015-04-01 00:55:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(1702, 106, '2015-04-01 00:58:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(1703, 106, '2015-04-01 00:59:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(1704, 106, '2015-04-01 01:01:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(1705, 106, '2015-04-01 01:03:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(1706, 106, '2015-04-01 01:06:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1707, 106, '2015-04-01 01:07:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(1708, 106, '2015-04-01 01:11:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(1709, 106, '2015-04-01 01:13:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1710, 106, '2015-04-01 01:17:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(1711, 106, '2015-04-01 01:20:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(1712, 106, '2015-04-01 01:22:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(1713, 106, '2015-04-01 01:25:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1714, 106, '2015-04-01 01:28:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(1715, 106, '2015-04-01 01:31:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(1716, 106, '2015-04-01 01:34:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(1717, 106, '2015-04-01 01:38:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(1718, 106, '2015-04-01 01:40:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1719, 106, '2015-04-01 01:43:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(1720, 106, '2015-04-01 01:45:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1721, 106, '2015-04-01 01:47:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(1722, 106, '2015-04-01 01:51:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(1723, 106, '2015-04-01 01:54:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(1724, 106, '2015-04-01 01:56:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1725, 106, '2015-04-01 01:58:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1726, 106, '2015-04-01 02:00:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(1727, 106, '2015-04-01 02:04:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(1728, 106, '2015-04-01 02:07:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(1729, 106, '2015-04-01 02:11:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1730, 106, '2015-04-01 02:14:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(1731, 106, '2015-04-01 02:16:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(1732, 106, '2015-04-01 02:18:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1733, 106, '2015-04-01 02:19:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(1734, 106, '2015-04-01 02:21:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(1735, 106, '2015-04-01 02:25:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(1736, 106, '2015-04-01 02:29:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1737, 106, '2015-04-01 02:32:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(1738, 106, '2015-04-01 02:36:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1739, 106, '2015-04-01 02:39:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(1740, 106, '2015-04-01 02:42:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(1741, 107, '2015-04-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1742, 107, '2015-04-01 00:02:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(1743, 107, '2015-04-01 00:05:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1744, 107, '2015-04-01 00:07:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1745, 107, '2015-04-01 00:09:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1746, 107, '2015-04-01 00:12:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(1747, 107, '2015-04-01 00:14:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(1748, 107, '2015-04-01 00:16:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(1749, 107, '2015-04-01 00:20:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1750, 107, '2015-04-01 00:23:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1751, 107, '2015-04-01 00:25:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(1752, 107, '2015-04-01 00:28:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(1753, 107, '2015-04-01 00:30:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(1754, 107, '2015-04-01 00:32:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1755, 107, '2015-04-01 00:35:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1756, 107, '2015-04-01 00:37:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1757, 107, '2015-04-01 00:39:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1758, 107, '2015-04-01 00:41:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1759, 107, '2015-04-01 00:43:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(1760, 107, '2015-04-01 00:46:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1761, 107, '2015-04-01 00:48:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(1762, 107, '2015-04-01 00:51:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1763, 107, '2015-04-01 00:54:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(1764, 107, '2015-04-01 00:56:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(1765, 107, '2015-04-01 00:59:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1766, 107, '2015-04-01 01:02:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1767, 107, '2015-04-01 01:04:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1768, 107, '2015-04-01 01:08:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1769, 107, '2015-04-01 01:10:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(1770, 107, '2015-04-01 01:12:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1771, 107, '2015-04-01 01:14:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(1772, 107, '2015-04-01 01:17:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(1773, 107, '2015-04-01 01:20:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(1774, 107, '2015-04-01 01:22:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1775, 107, '2015-04-01 01:23:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(1776, 107, '2015-04-01 01:27:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1777, 107, '2015-04-01 01:30:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1778, 107, '2015-04-01 01:33:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(1779, 107, '2015-04-01 01:37:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(1780, 107, '2015-04-01 01:40:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(1781, 107, '2015-04-01 01:42:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(1782, 107, '2015-04-01 01:45:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(1783, 107, '2015-04-01 01:47:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(1784, 107, '2015-04-01 01:50:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1785, 107, '2015-04-01 01:53:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(1786, 107, '2015-04-01 01:55:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(1787, 107, '2015-04-01 01:59:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1788, 107, '2015-04-01 02:02:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(1789, 107, '2015-04-01 02:04:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(1790, 107, '2015-04-01 02:08:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1791, 107, '2015-04-01 02:10:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1792, 107, '2015-04-01 02:13:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(1793, 107, '2015-04-01 02:14:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1794, 107, '2015-04-01 02:17:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(1795, 107, '2015-04-01 02:19:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1796, 107, '2015-04-01 02:20:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1797, 107, '2015-04-01 02:22:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1798, 107, '2015-04-01 02:26:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(1799, 107, '2015-04-01 02:29:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1800, 107, '2015-04-01 02:32:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(1801, 103, '2015-04-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1802, 103, '2015-04-15 00:02:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(1803, 103, '2015-04-15 00:06:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1804, 103, '2015-04-15 00:08:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1805, 103, '2015-04-15 00:10:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(1806, 103, '2015-04-15 00:12:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(1807, 103, '2015-04-15 00:14:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(1808, 103, '2015-04-15 00:18:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1809, 103, '2015-04-15 00:20:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1810, 103, '2015-04-15 00:23:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1811, 103, '2015-04-15 00:26:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(1812, 103, '2015-04-15 00:28:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(1813, 103, '2015-04-15 00:30:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(1814, 103, '2015-04-15 00:33:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1815, 103, '2015-04-15 00:36:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(1816, 103, '2015-04-15 00:38:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(1817, 103, '2015-04-15 00:40:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(1818, 103, '2015-04-15 00:43:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(1819, 103, '2015-04-15 00:46:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(1820, 103, '2015-04-15 00:48:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(1821, 103, '2015-04-15 00:50:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(1822, 103, '2015-04-15 00:52:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(1823, 103, '2015-04-15 00:56:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(1824, 103, '2015-04-15 00:57:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1825, 103, '2015-04-15 01:00:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1826, 103, '2015-04-15 01:03:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(1827, 103, '2015-04-15 01:05:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1828, 103, '2015-04-15 01:08:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(1829, 103, '2015-04-15 01:10:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(1830, 103, '2015-04-15 01:11:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(1831, 103, '2015-04-15 01:14:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1832, 103, '2015-04-15 01:17:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(1833, 103, '2015-04-15 01:21:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1834, 103, '2015-04-15 01:24:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(1835, 103, '2015-04-15 01:28:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(1836, 103, '2015-04-15 01:30:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1837, 103, '2015-04-15 01:33:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(1838, 103, '2015-04-15 01:36:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(1839, 103, '2015-04-15 01:38:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(1840, 103, '2015-04-15 01:40:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(1841, 103, '2015-04-15 01:44:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(1842, 103, '2015-04-15 01:46:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1843, 103, '2015-04-15 01:49:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1844, 103, '2015-04-15 01:51:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1845, 103, '2015-04-15 01:54:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1846, 103, '2015-04-15 01:56:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(1847, 103, '2015-04-15 01:59:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1848, 103, '2015-04-15 02:01:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(1849, 103, '2015-04-15 02:05:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1850, 103, '2015-04-15 02:07:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(1851, 103, '2015-04-15 02:11:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(1852, 103, '2015-04-15 02:14:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(1853, 103, '2015-04-15 02:16:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1854, 103, '2015-04-15 02:19:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1855, 103, '2015-04-15 02:20:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(1856, 103, '2015-04-15 02:24:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1857, 103, '2015-04-15 02:26:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(1858, 103, '2015-04-15 02:28:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(1859, 103, '2015-04-15 02:29:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1860, 103, '2015-04-15 02:33:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(1861, 104, '2015-04-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1862, 104, '2015-04-15 00:01:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1863, 104, '2015-04-15 00:05:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(1864, 104, '2015-04-15 00:08:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(1865, 104, '2015-04-15 00:11:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(1866, 104, '2015-04-15 00:14:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(1867, 104, '2015-04-15 00:17:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1868, 104, '2015-04-15 00:19:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(1869, 104, '2015-04-15 00:22:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(1870, 104, '2015-04-15 00:24:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1871, 104, '2015-04-15 00:27:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1872, 104, '2015-04-15 00:29:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(1873, 104, '2015-04-15 00:33:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(1874, 104, '2015-04-15 00:36:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1875, 104, '2015-04-15 00:38:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(1876, 104, '2015-04-15 00:40:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(1877, 104, '2015-04-15 00:43:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1878, 104, '2015-04-15 00:45:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1879, 104, '2015-04-15 00:48:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(1880, 104, '2015-04-15 00:50:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1881, 104, '2015-04-15 00:52:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(1882, 104, '2015-04-15 00:54:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(1883, 104, '2015-04-15 00:58:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1884, 104, '2015-04-15 00:59:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(1885, 104, '2015-04-15 01:01:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(1886, 104, '2015-04-15 01:04:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(1887, 104, '2015-04-15 01:07:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(1888, 104, '2015-04-15 01:10:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1889, 104, '2015-04-15 01:13:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(1890, 104, '2015-04-15 01:15:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(1891, 104, '2015-04-15 01:18:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(1892, 104, '2015-04-15 01:20:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(1893, 104, '2015-04-15 01:22:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(1894, 104, '2015-04-15 01:25:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1895, 104, '2015-04-15 01:28:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(1896, 104, '2015-04-15 01:30:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(1897, 104, '2015-04-15 01:32:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1898, 104, '2015-04-15 01:34:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1899, 104, '2015-04-15 01:37:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1900, 104, '2015-04-15 01:40:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1901, 104, '2015-04-15 01:42:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(1902, 104, '2015-04-15 01:45:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(1903, 104, '2015-04-15 01:48:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(1904, 104, '2015-04-15 01:50:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(1905, 104, '2015-04-15 01:53:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(1906, 104, '2015-04-15 01:57:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1907, 104, '2015-04-15 01:59:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1908, 104, '2015-04-15 02:02:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(1909, 104, '2015-04-15 02:04:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1910, 104, '2015-04-15 02:06:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(1911, 104, '2015-04-15 02:08:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(1912, 104, '2015-04-15 02:10:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(1913, 104, '2015-04-15 02:11:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(1914, 104, '2015-04-15 02:15:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1915, 104, '2015-04-15 02:17:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(1916, 104, '2015-04-15 02:19:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1917, 104, '2015-04-15 02:23:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(1918, 104, '2015-04-15 02:25:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(1919, 104, '2015-04-15 02:28:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(1920, 104, '2015-04-15 02:30:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(1921, 105, '2015-04-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1922, 105, '2015-04-15 00:03:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(1923, 105, '2015-04-15 00:06:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1924, 105, '2015-04-15 00:08:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(1925, 105, '2015-04-15 00:10:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1926, 105, '2015-04-15 00:13:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1927, 105, '2015-04-15 00:14:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(1928, 105, '2015-04-15 00:17:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1929, 105, '2015-04-15 00:20:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(1930, 105, '2015-04-15 00:23:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(1931, 105, '2015-04-15 00:25:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(1932, 105, '2015-04-15 00:28:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(1933, 105, '2015-04-15 00:31:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(1934, 105, '2015-04-15 00:35:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(1935, 105, '2015-04-15 00:38:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(1936, 105, '2015-04-15 00:41:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(1937, 105, '2015-04-15 00:44:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(1938, 105, '2015-04-15 00:46:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1939, 105, '2015-04-15 00:48:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1940, 105, '2015-04-15 00:49:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(1941, 105, '2015-04-15 00:51:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(1942, 105, '2015-04-15 00:53:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1943, 105, '2015-04-15 00:55:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(1944, 105, '2015-04-15 00:57:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(1945, 105, '2015-04-15 00:59:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(1946, 105, '2015-04-15 01:02:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(1947, 105, '2015-04-15 01:04:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1948, 105, '2015-04-15 01:07:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(1949, 105, '2015-04-15 01:09:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(1950, 105, '2015-04-15 01:12:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(1951, 105, '2015-04-15 01:14:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1952, 105, '2015-04-15 01:17:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1953, 105, '2015-04-15 01:19:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(1954, 105, '2015-04-15 01:21:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1955, 105, '2015-04-15 01:23:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(1956, 105, '2015-04-15 01:25:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(1957, 105, '2015-04-15 01:27:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(1958, 105, '2015-04-15 01:30:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(1959, 105, '2015-04-15 01:34:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(1960, 105, '2015-04-15 01:36:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(1961, 105, '2015-04-15 01:38:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(1962, 105, '2015-04-15 01:40:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(1963, 105, '2015-04-15 01:44:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(1964, 105, '2015-04-15 01:46:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(1965, 105, '2015-04-15 01:49:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(1966, 105, '2015-04-15 01:52:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(1967, 105, '2015-04-15 01:54:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1968, 105, '2015-04-15 01:57:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(1969, 105, '2015-04-15 02:00:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(1970, 105, '2015-04-15 02:04:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(1971, 105, '2015-04-15 02:08:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(1972, 105, '2015-04-15 02:11:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(1973, 105, '2015-04-15 02:15:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(1974, 105, '2015-04-15 02:18:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(1975, 105, '2015-04-15 02:21:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(1976, 105, '2015-04-15 02:23:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(1977, 105, '2015-04-15 02:25:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(1978, 105, '2015-04-15 02:29:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1979, 105, '2015-04-15 02:30:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(1980, 105, '2015-04-15 02:33:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(1981, 106, '2015-04-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(1982, 106, '2015-04-15 00:03:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(1983, 106, '2015-04-15 00:04:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(1984, 106, '2015-04-15 00:07:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(1985, 106, '2015-04-15 00:10:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(1986, 106, '2015-04-15 00:13:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(1987, 106, '2015-04-15 00:16:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(1988, 106, '2015-04-15 00:18:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(1989, 106, '2015-04-15 00:19:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(1990, 106, '2015-04-15 00:22:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(1991, 106, '2015-04-15 00:25:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(1992, 106, '2015-04-15 00:28:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(1993, 106, '2015-04-15 00:31:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(1994, 106, '2015-04-15 00:33:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(1995, 106, '2015-04-15 00:35:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(1996, 106, '2015-04-15 00:37:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(1997, 106, '2015-04-15 00:38:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(1998, 106, '2015-04-15 00:41:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(1999, 106, '2015-04-15 00:45:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(2000, 106, '2015-04-15 00:47:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(2001, 106, '2015-04-15 00:50:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(2002, 106, '2015-04-15 00:52:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(2003, 106, '2015-04-15 00:55:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(2004, 106, '2015-04-15 00:57:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2005, 106, '2015-04-15 00:59:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(2006, 106, '2015-04-15 01:01:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(2007, 106, '2015-04-15 01:03:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2008, 106, '2015-04-15 01:05:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(2009, 106, '2015-04-15 01:09:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(2010, 106, '2015-04-15 01:11:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(2011, 106, '2015-04-15 01:13:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(2012, 106, '2015-04-15 01:16:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(2013, 106, '2015-04-15 01:18:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2014, 106, '2015-04-15 01:20:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2015, 106, '2015-04-15 01:22:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(2016, 106, '2015-04-15 01:25:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(2017, 106, '2015-04-15 01:27:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(2018, 106, '2015-04-15 01:30:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(2019, 106, '2015-04-15 01:31:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2020, 106, '2015-04-15 01:33:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(2021, 106, '2015-04-15 01:36:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(2022, 106, '2015-04-15 01:38:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(2023, 106, '2015-04-15 01:41:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(2024, 106, '2015-04-15 01:42:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2025, 106, '2015-04-15 01:45:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(2026, 106, '2015-04-15 01:48:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2027, 106, '2015-04-15 01:50:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(2028, 106, '2015-04-15 01:53:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2029, 106, '2015-04-15 01:55:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(2030, 106, '2015-04-15 01:56:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(2031, 106, '2015-04-15 02:00:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(2032, 106, '2015-04-15 02:01:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(2033, 106, '2015-04-15 02:04:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2034, 106, '2015-04-15 02:05:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2035, 106, '2015-04-15 02:07:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(2036, 106, '2015-04-15 02:10:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2037, 106, '2015-04-15 02:12:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2038, 106, '2015-04-15 02:16:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2039, 106, '2015-04-15 02:18:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(2040, 106, '2015-04-15 02:21:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(2041, 107, '2015-04-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2042, 107, '2015-04-15 00:02:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(2043, 107, '2015-04-15 00:04:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2044, 107, '2015-04-15 00:07:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(2045, 107, '2015-04-15 00:10:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(2046, 107, '2015-04-15 00:13:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(2047, 107, '2015-04-15 00:16:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(2048, 107, '2015-04-15 00:18:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2049, 107, '2015-04-15 00:21:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2050, 107, '2015-04-15 00:25:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2051, 107, '2015-04-15 00:27:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(2052, 107, '2015-04-15 00:29:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(2053, 107, '2015-04-15 00:32:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(2054, 107, '2015-04-15 00:35:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(2055, 107, '2015-04-15 00:39:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(2056, 107, '2015-04-15 00:41:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(2057, 107, '2015-04-15 00:44:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(2058, 107, '2015-04-15 00:47:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2059, 107, '2015-04-15 00:49:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2060, 107, '2015-04-15 00:51:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2061, 107, '2015-04-15 00:55:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2062, 107, '2015-04-15 00:57:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(2063, 107, '2015-04-15 01:01:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2064, 107, '2015-04-15 01:03:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2065, 107, '2015-04-15 01:04:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2066, 107, '2015-04-15 01:07:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2067, 107, '2015-04-15 01:09:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(2068, 107, '2015-04-15 01:12:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(2069, 107, '2015-04-15 01:15:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(2070, 107, '2015-04-15 01:17:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(2071, 107, '2015-04-15 01:21:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2072, 107, '2015-04-15 01:24:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(2073, 107, '2015-04-15 01:27:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(2074, 107, '2015-04-15 01:30:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2075, 107, '2015-04-15 01:32:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(2076, 107, '2015-04-15 01:34:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2077, 107, '2015-04-15 01:36:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(2078, 107, '2015-04-15 01:38:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(2079, 107, '2015-04-15 01:40:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2080, 107, '2015-04-15 01:42:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(2081, 107, '2015-04-15 01:45:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2082, 107, '2015-04-15 01:46:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(2083, 107, '2015-04-15 01:49:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(2084, 107, '2015-04-15 01:51:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(2085, 107, '2015-04-15 01:54:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(2086, 107, '2015-04-15 01:57:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(2087, 107, '2015-04-15 02:00:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(2088, 107, '2015-04-15 02:03:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2089, 107, '2015-04-15 02:04:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(2090, 107, '2015-04-15 02:08:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(2091, 107, '2015-04-15 02:11:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2092, 107, '2015-04-15 02:13:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(2093, 107, '2015-04-15 02:15:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(2094, 107, '2015-04-15 02:17:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(2095, 107, '2015-04-15 02:20:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2096, 107, '2015-04-15 02:22:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(2097, 107, '2015-04-15 02:24:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(2098, 107, '2015-04-15 02:26:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(2099, 107, '2015-04-15 02:29:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(2100, 107, '2015-04-15 02:32:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(2101, 113, '2014-01-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2102, 113, '2014-01-15 00:03:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2103, 113, '2014-01-15 00:05:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2104, 113, '2014-01-15 00:07:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2105, 113, '2014-01-15 00:10:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(2106, 113, '2014-01-15 00:12:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(2107, 113, '2014-01-15 00:15:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2108, 113, '2014-01-15 00:18:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2109, 113, '2014-01-15 00:21:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2110, 113, '2014-01-15 00:22:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2111, 113, '2014-01-15 00:25:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2112, 113, '2014-01-15 00:29:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(2113, 113, '2014-01-15 00:30:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(2114, 113, '2014-01-15 00:32:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(2115, 113, '2014-01-15 00:35:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2116, 113, '2014-01-15 00:36:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(2117, 113, '2014-01-15 00:40:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2118, 113, '2014-01-15 00:43:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(2119, 113, '2014-01-15 00:45:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(2120, 113, '2014-01-15 00:48:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2121, 113, '2014-01-15 00:52:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(2122, 113, '2014-01-15 00:54:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(2123, 113, '2014-01-15 00:57:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(2124, 113, '2014-01-15 00:59:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(2125, 113, '2014-01-15 01:01:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(2126, 113, '2014-01-15 01:04:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2127, 113, '2014-01-15 01:07:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2128, 113, '2014-01-15 01:09:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(2129, 113, '2014-01-15 01:12:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(2130, 113, '2014-01-15 01:15:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2131, 113, '2014-01-15 01:18:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(2132, 113, '2014-01-15 01:22:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2133, 113, '2014-01-15 01:24:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(2134, 113, '2014-01-15 01:26:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2135, 113, '2014-01-15 01:29:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(2136, 113, '2014-01-15 01:32:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(2137, 113, '2014-01-15 01:34:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2138, 113, '2014-01-15 01:36:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(2139, 113, '2014-01-15 01:38:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(2140, 113, '2014-01-15 01:41:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2141, 113, '2014-01-15 01:43:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2142, 113, '2014-01-15 01:46:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(2143, 113, '2014-01-15 01:49:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2144, 113, '2014-01-15 01:52:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(2145, 113, '2014-01-15 01:55:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(2146, 113, '2014-01-15 01:57:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(2147, 113, '2014-01-15 01:58:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(2148, 113, '2014-01-15 02:01:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2149, 113, '2014-01-15 02:03:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(2150, 113, '2014-01-15 02:06:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(2151, 113, '2014-01-15 02:08:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(2152, 113, '2014-01-15 02:10:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(2153, 113, '2014-01-15 02:12:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2154, 113, '2014-01-15 02:14:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2155, 113, '2014-01-15 02:17:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2156, 113, '2014-01-15 02:20:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2157, 113, '2014-01-15 02:22:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2158, 113, '2014-01-15 02:24:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(2159, 113, '2014-01-15 02:26:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(2160, 113, '2014-01-15 02:28:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2161, 114, '2014-01-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2162, 114, '2014-01-15 00:02:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(2163, 114, '2014-01-15 00:03:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(2164, 114, '2014-01-15 00:05:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(2165, 114, '2014-01-15 00:09:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2166, 114, '2014-01-15 00:12:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(2167, 114, '2014-01-15 00:14:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2168, 114, '2014-01-15 00:17:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(2169, 114, '2014-01-15 00:20:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(2170, 114, '2014-01-15 00:22:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2171, 114, '2014-01-15 00:24:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(2172, 114, '2014-01-15 00:27:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2173, 114, '2014-01-15 00:30:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2174, 114, '2014-01-15 00:34:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2175, 114, '2014-01-15 00:36:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(2176, 114, '2014-01-15 00:38:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2177, 114, '2014-01-15 00:41:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(2178, 114, '2014-01-15 00:44:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(2179, 114, '2014-01-15 00:47:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(2180, 114, '2014-01-15 00:49:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(2181, 114, '2014-01-15 00:51:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(2182, 114, '2014-01-15 00:54:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2183, 114, '2014-01-15 00:56:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(2184, 114, '2014-01-15 00:58:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(2185, 114, '2014-01-15 01:01:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2186, 114, '2014-01-15 01:04:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2187, 114, '2014-01-15 01:07:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(2188, 114, '2014-01-15 01:10:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(2189, 114, '2014-01-15 01:11:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2190, 114, '2014-01-15 01:14:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2191, 114, '2014-01-15 01:17:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2192, 114, '2014-01-15 01:19:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2193, 114, '2014-01-15 01:22:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2194, 114, '2014-01-15 01:24:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(2195, 114, '2014-01-15 01:27:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2196, 114, '2014-01-15 01:30:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2197, 114, '2014-01-15 01:32:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(2198, 114, '2014-01-15 01:34:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(2199, 114, '2014-01-15 01:36:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(2200, 114, '2014-01-15 01:40:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(2201, 114, '2014-01-15 01:41:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2202, 114, '2014-01-15 01:44:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2203, 114, '2014-01-15 01:47:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2204, 114, '2014-01-15 01:49:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(2205, 114, '2014-01-15 01:51:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2206, 114, '2014-01-15 01:53:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(2207, 114, '2014-01-15 01:55:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(2208, 114, '2014-01-15 01:57:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2209, 114, '2014-01-15 01:59:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(2210, 114, '2014-01-15 02:01:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2211, 114, '2014-01-15 02:04:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(2212, 114, '2014-01-15 02:08:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(2213, 114, '2014-01-15 02:11:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2214, 114, '2014-01-15 02:13:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(2215, 114, '2014-01-15 02:16:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(2216, 114, '2014-01-15 02:20:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2217, 114, '2014-01-15 02:22:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(2218, 114, '2014-01-15 02:26:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2219, 114, '2014-01-15 02:27:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2220, 114, '2014-01-15 02:29:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2221, 115, '2014-01-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2222, 115, '2014-01-15 00:02:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(2223, 115, '2014-01-15 00:04:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(2224, 115, '2014-01-15 00:06:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(2225, 115, '2014-01-15 00:08:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(2226, 115, '2014-01-15 00:12:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(2227, 115, '2014-01-15 00:13:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2228, 115, '2014-01-15 00:16:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(2229, 115, '2014-01-15 00:19:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(2230, 115, '2014-01-15 00:22:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2231, 115, '2014-01-15 00:25:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(2232, 115, '2014-01-15 00:28:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(2233, 115, '2014-01-15 00:30:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(2234, 115, '2014-01-15 00:33:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(2235, 115, '2014-01-15 00:37:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(2236, 115, '2014-01-15 00:39:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(2237, 115, '2014-01-15 00:42:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(2238, 115, '2014-01-15 00:44:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(2239, 115, '2014-01-15 00:46:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(2240, 115, '2014-01-15 00:48:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(2241, 115, '2014-01-15 00:51:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(2242, 115, '2014-01-15 00:54:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(2243, 115, '2014-01-15 00:57:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(2244, 115, '2014-01-15 00:59:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2245, 115, '2014-01-15 01:00:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2246, 115, '2014-01-15 01:04:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2247, 115, '2014-01-15 01:05:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(2248, 115, '2014-01-15 01:08:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2249, 115, '2014-01-15 01:11:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(2250, 115, '2014-01-15 01:14:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(2251, 115, '2014-01-15 01:17:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(2252, 115, '2014-01-15 01:21:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2253, 115, '2014-01-15 01:24:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2254, 115, '2014-01-15 01:27:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(2255, 115, '2014-01-15 01:30:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(2256, 115, '2014-01-15 01:32:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2257, 115, '2014-01-15 01:34:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(2258, 115, '2014-01-15 01:36:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(2259, 115, '2014-01-15 01:39:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(2260, 115, '2014-01-15 01:41:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2261, 115, '2014-01-15 01:43:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(2262, 115, '2014-01-15 01:47:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(2263, 115, '2014-01-15 01:50:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(2264, 115, '2014-01-15 01:53:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(2265, 115, '2014-01-15 01:55:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2266, 115, '2014-01-15 01:57:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(2267, 115, '2014-01-15 02:00:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2268, 115, '2014-01-15 02:02:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2269, 115, '2014-01-15 02:03:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(2270, 115, '2014-01-15 02:07:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(2271, 115, '2014-01-15 02:10:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(2272, 115, '2014-01-15 02:14:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2273, 115, '2014-01-15 02:18:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(2274, 115, '2014-01-15 02:21:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(2275, 115, '2014-01-15 02:25:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(2276, 115, '2014-01-15 02:27:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(2277, 115, '2014-01-15 02:31:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(2278, 115, '2014-01-15 02:34:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2279, 115, '2014-01-15 02:37:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(2280, 115, '2014-01-15 02:39:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(2281, 116, '2014-01-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2282, 116, '2014-01-15 00:01:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(2283, 116, '2014-01-15 00:05:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(2284, 116, '2014-01-15 00:07:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2285, 116, '2014-01-15 00:09:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(2286, 116, '2014-01-15 00:12:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(2287, 116, '2014-01-15 00:15:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2288, 116, '2014-01-15 00:18:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(2289, 116, '2014-01-15 00:21:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(2290, 116, '2014-01-15 00:23:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(2291, 116, '2014-01-15 00:25:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(2292, 116, '2014-01-15 00:28:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(2293, 116, '2014-01-15 00:30:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(2294, 116, '2014-01-15 00:32:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2295, 116, '2014-01-15 00:35:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(2296, 116, '2014-01-15 00:38:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(2297, 116, '2014-01-15 00:40:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(2298, 116, '2014-01-15 00:42:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(2299, 116, '2014-01-15 00:45:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(2300, 116, '2014-01-15 00:47:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(2301, 116, '2014-01-15 00:50:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2302, 116, '2014-01-15 00:52:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2303, 116, '2014-01-15 00:54:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(2304, 116, '2014-01-15 00:57:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(2305, 116, '2014-01-15 01:00:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(2306, 116, '2014-01-15 01:02:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2307, 116, '2014-01-15 01:04:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(2308, 116, '2014-01-15 01:06:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(2309, 116, '2014-01-15 01:08:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(2310, 116, '2014-01-15 01:10:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2311, 116, '2014-01-15 01:12:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2312, 116, '2014-01-15 01:15:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2313, 116, '2014-01-15 01:16:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(2314, 116, '2014-01-15 01:20:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2315, 116, '2014-01-15 01:23:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(2316, 116, '2014-01-15 01:25:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2317, 116, '2014-01-15 01:27:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(2318, 116, '2014-01-15 01:28:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(2319, 116, '2014-01-15 01:31:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(2320, 116, '2014-01-15 01:33:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2321, 116, '2014-01-15 01:36:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2322, 116, '2014-01-15 01:38:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(2323, 116, '2014-01-15 01:40:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(2324, 116, '2014-01-15 01:43:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(2325, 116, '2014-01-15 01:45:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2326, 116, '2014-01-15 01:48:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(2327, 116, '2014-01-15 01:49:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(2328, 116, '2014-01-15 01:52:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(2329, 116, '2014-01-15 01:54:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(2330, 116, '2014-01-15 01:58:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2331, 116, '2014-01-15 02:00:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2332, 116, '2014-01-15 02:02:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(2333, 116, '2014-01-15 02:04:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2334, 116, '2014-01-15 02:08:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2335, 116, '2014-01-15 02:11:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2336, 116, '2014-01-15 02:14:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2337, 116, '2014-01-15 02:16:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2338, 116, '2014-01-15 02:19:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2339, 116, '2014-01-15 02:22:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(2340, 116, '2014-01-15 02:25:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2341, 117, '2014-01-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2342, 117, '2014-01-15 00:02:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(2343, 117, '2014-01-15 00:06:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(2344, 117, '2014-01-15 00:08:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2345, 117, '2014-01-15 00:10:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2346, 117, '2014-01-15 00:12:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(2347, 117, '2014-01-15 00:14:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(2348, 117, '2014-01-15 00:16:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(2349, 117, '2014-01-15 00:19:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(2350, 117, '2014-01-15 00:21:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(2351, 117, '2014-01-15 00:25:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2352, 117, '2014-01-15 00:28:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2353, 117, '2014-01-15 00:31:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(2354, 117, '2014-01-15 00:33:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(2355, 117, '2014-01-15 00:37:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(2356, 117, '2014-01-15 00:39:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(2357, 117, '2014-01-15 00:41:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(2358, 117, '2014-01-15 00:44:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(2359, 117, '2014-01-15 00:47:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2360, 117, '2014-01-15 00:50:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(2361, 117, '2014-01-15 00:54:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2362, 117, '2014-01-15 00:56:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2363, 117, '2014-01-15 00:58:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(2364, 117, '2014-01-15 01:02:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2365, 117, '2014-01-15 01:05:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(2366, 117, '2014-01-15 01:07:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(2367, 117, '2014-01-15 01:10:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(2368, 117, '2014-01-15 01:13:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2369, 117, '2014-01-15 01:16:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(2370, 117, '2014-01-15 01:18:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(2371, 117, '2014-01-15 01:20:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(2372, 117, '2014-01-15 01:23:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(2373, 117, '2014-01-15 01:25:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(2374, 117, '2014-01-15 01:29:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2375, 117, '2014-01-15 01:30:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(2376, 117, '2014-01-15 01:33:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(2377, 117, '2014-01-15 01:34:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(2378, 117, '2014-01-15 01:37:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2379, 117, '2014-01-15 01:39:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(2380, 117, '2014-01-15 01:41:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(2381, 117, '2014-01-15 01:44:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(2382, 117, '2014-01-15 01:46:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2383, 117, '2014-01-15 01:47:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(2384, 117, '2014-01-15 01:49:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(2385, 117, '2014-01-15 01:53:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(2386, 117, '2014-01-15 01:55:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(2387, 117, '2014-01-15 01:58:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(2388, 117, '2014-01-15 02:01:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(2389, 117, '2014-01-15 02:04:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(2390, 117, '2014-01-15 02:07:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(2391, 117, '2014-01-15 02:09:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(2392, 117, '2014-01-15 02:13:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2393, 117, '2014-01-15 02:16:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(2394, 117, '2014-01-15 02:19:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2395, 117, '2014-01-15 02:21:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(2396, 117, '2014-01-15 02:24:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(2397, 117, '2014-01-15 02:26:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2398, 117, '2014-01-15 02:30:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(2399, 117, '2014-01-15 02:33:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2400, 117, '2014-01-15 02:37:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(2401, 113, '2014-02-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2402, 113, '2014-02-01 00:01:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(2403, 113, '2014-02-01 00:04:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(2404, 113, '2014-02-01 00:06:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(2405, 113, '2014-02-01 00:09:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2406, 113, '2014-02-01 00:12:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(2407, 113, '2014-02-01 00:15:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2408, 113, '2014-02-01 00:18:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2409, 113, '2014-02-01 00:21:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(2410, 113, '2014-02-01 00:23:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(2411, 113, '2014-02-01 00:27:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(2412, 113, '2014-02-01 00:30:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(2413, 113, '2014-02-01 00:33:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(2414, 113, '2014-02-01 00:36:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2415, 113, '2014-02-01 00:39:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2416, 113, '2014-02-01 00:42:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(2417, 113, '2014-02-01 00:44:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2418, 113, '2014-02-01 00:46:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(2419, 113, '2014-02-01 00:48:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2420, 113, '2014-02-01 00:50:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(2421, 113, '2014-02-01 00:54:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2422, 113, '2014-02-01 00:55:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(2423, 113, '2014-02-01 00:58:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(2424, 113, '2014-02-01 01:00:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(2425, 113, '2014-02-01 01:02:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(2426, 113, '2014-02-01 01:04:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(2427, 113, '2014-02-01 01:08:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(2428, 113, '2014-02-01 01:12:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2429, 113, '2014-02-01 01:14:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2430, 113, '2014-02-01 01:17:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(2431, 113, '2014-02-01 01:19:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(2432, 113, '2014-02-01 01:21:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(2433, 113, '2014-02-01 01:24:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(2434, 113, '2014-02-01 01:27:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2435, 113, '2014-02-01 01:29:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(2436, 113, '2014-02-01 01:31:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(2437, 113, '2014-02-01 01:33:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2438, 113, '2014-02-01 01:35:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(2439, 113, '2014-02-01 01:37:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2440, 113, '2014-02-01 01:40:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2441, 113, '2014-02-01 01:44:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(2442, 113, '2014-02-01 01:46:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(2443, 113, '2014-02-01 01:48:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2444, 113, '2014-02-01 01:50:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(2445, 113, '2014-02-01 01:53:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(2446, 113, '2014-02-01 01:56:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2447, 113, '2014-02-01 01:59:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(2448, 113, '2014-02-01 02:02:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(2449, 113, '2014-02-01 02:04:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(2450, 113, '2014-02-01 02:08:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(2451, 113, '2014-02-01 02:10:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2452, 113, '2014-02-01 02:13:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2453, 113, '2014-02-01 02:15:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(2454, 113, '2014-02-01 02:19:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2455, 113, '2014-02-01 02:21:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(2456, 113, '2014-02-01 02:24:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(2457, 113, '2014-02-01 02:27:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(2458, 113, '2014-02-01 02:31:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2459, 113, '2014-02-01 02:33:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(2460, 113, '2014-02-01 02:35:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2461, 114, '2014-02-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2462, 114, '2014-02-01 00:02:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(2463, 114, '2014-02-01 00:04:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(2464, 114, '2014-02-01 00:07:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(2465, 114, '2014-02-01 00:10:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(2466, 114, '2014-02-01 00:12:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(2467, 114, '2014-02-01 00:14:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(2468, 114, '2014-02-01 00:18:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(2469, 114, '2014-02-01 00:20:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(2470, 114, '2014-02-01 00:23:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(2471, 114, '2014-02-01 00:26:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(2472, 114, '2014-02-01 00:29:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2473, 114, '2014-02-01 00:31:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(2474, 114, '2014-02-01 00:34:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(2475, 114, '2014-02-01 00:37:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(2476, 114, '2014-02-01 00:41:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2477, 114, '2014-02-01 00:43:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2478, 114, '2014-02-01 00:45:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(2479, 114, '2014-02-01 00:48:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(2480, 114, '2014-02-01 00:50:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2481, 114, '2014-02-01 00:53:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(2482, 114, '2014-02-01 00:55:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(2483, 114, '2014-02-01 00:58:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(2484, 114, '2014-02-01 01:01:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(2485, 114, '2014-02-01 01:03:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(2486, 114, '2014-02-01 01:07:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(2487, 114, '2014-02-01 01:09:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(2488, 114, '2014-02-01 01:11:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(2489, 114, '2014-02-01 01:14:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(2490, 114, '2014-02-01 01:15:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(2491, 114, '2014-02-01 01:19:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(2492, 114, '2014-02-01 01:21:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(2493, 114, '2014-02-01 01:24:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(2494, 114, '2014-02-01 01:27:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(2495, 114, '2014-02-01 01:30:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(2496, 114, '2014-02-01 01:33:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(2497, 114, '2014-02-01 01:36:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(2498, 114, '2014-02-01 01:38:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2499, 114, '2014-02-01 01:41:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2500, 114, '2014-02-01 01:43:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(2501, 114, '2014-02-01 01:46:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(2502, 114, '2014-02-01 01:48:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(2503, 114, '2014-02-01 01:51:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2504, 114, '2014-02-01 01:53:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2505, 114, '2014-02-01 01:55:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2506, 114, '2014-02-01 01:59:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(2507, 114, '2014-02-01 02:00:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(2508, 114, '2014-02-01 02:03:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2509, 114, '2014-02-01 02:05:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2510, 114, '2014-02-01 02:06:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(2511, 114, '2014-02-01 02:10:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(2512, 114, '2014-02-01 02:13:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2513, 114, '2014-02-01 02:15:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(2514, 114, '2014-02-01 02:17:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(2515, 114, '2014-02-01 02:20:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(2516, 114, '2014-02-01 02:22:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(2517, 114, '2014-02-01 02:25:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(2518, 114, '2014-02-01 02:27:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2519, 114, '2014-02-01 02:29:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2520, 114, '2014-02-01 02:32:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(2521, 115, '2014-02-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2522, 115, '2014-02-01 00:02:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(2523, 115, '2014-02-01 00:06:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(2524, 115, '2014-02-01 00:08:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(2525, 115, '2014-02-01 00:10:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(2526, 115, '2014-02-01 00:13:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(2527, 115, '2014-02-01 00:15:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(2528, 115, '2014-02-01 00:18:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2529, 115, '2014-02-01 00:20:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2530, 115, '2014-02-01 00:22:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(2531, 115, '2014-02-01 00:26:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(2532, 115, '2014-02-01 00:29:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2533, 115, '2014-02-01 00:32:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2534, 115, '2014-02-01 00:35:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(2535, 115, '2014-02-01 00:38:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2536, 115, '2014-02-01 00:41:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(2537, 115, '2014-02-01 00:44:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(2538, 115, '2014-02-01 00:47:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2539, 115, '2014-02-01 00:49:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2540, 115, '2014-02-01 00:52:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(2541, 115, '2014-02-01 00:55:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2542, 115, '2014-02-01 00:58:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(2543, 115, '2014-02-01 01:01:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(2544, 115, '2014-02-01 01:03:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(2545, 115, '2014-02-01 01:06:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(2546, 115, '2014-02-01 01:08:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2547, 115, '2014-02-01 01:11:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(2548, 115, '2014-02-01 01:13:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(2549, 115, '2014-02-01 01:16:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2550, 115, '2014-02-01 01:18:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(2551, 115, '2014-02-01 01:20:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(2552, 115, '2014-02-01 01:23:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(2553, 115, '2014-02-01 01:25:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(2554, 115, '2014-02-01 01:28:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2555, 115, '2014-02-01 01:29:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(2556, 115, '2014-02-01 01:32:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(2557, 115, '2014-02-01 01:34:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(2558, 115, '2014-02-01 01:37:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(2559, 115, '2014-02-01 01:40:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(2560, 115, '2014-02-01 01:43:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2561, 115, '2014-02-01 01:46:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2562, 115, '2014-02-01 01:49:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(2563, 115, '2014-02-01 01:51:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2564, 115, '2014-02-01 01:53:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(2565, 115, '2014-02-01 01:55:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(2566, 115, '2014-02-01 01:57:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2567, 115, '2014-02-01 01:59:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2568, 115, '2014-02-01 02:00:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(2569, 115, '2014-02-01 02:03:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(2570, 115, '2014-02-01 02:05:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2571, 115, '2014-02-01 02:08:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2572, 115, '2014-02-01 02:11:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(2573, 115, '2014-02-01 02:13:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(2574, 115, '2014-02-01 02:17:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(2575, 115, '2014-02-01 02:19:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2576, 115, '2014-02-01 02:21:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(2577, 115, '2014-02-01 02:24:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(2578, 115, '2014-02-01 02:27:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(2579, 115, '2014-02-01 02:29:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(2580, 115, '2014-02-01 02:32:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(2581, 116, '2014-02-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2582, 116, '2014-02-01 00:02:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2583, 116, '2014-02-01 00:04:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(2584, 116, '2014-02-01 00:07:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(2585, 116, '2014-02-01 00:09:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(2586, 116, '2014-02-01 00:12:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(2587, 116, '2014-02-01 00:14:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2588, 116, '2014-02-01 00:16:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(2589, 116, '2014-02-01 00:19:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(2590, 116, '2014-02-01 00:22:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2591, 116, '2014-02-01 00:26:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(2592, 116, '2014-02-01 00:28:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2593, 116, '2014-02-01 00:32:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(2594, 116, '2014-02-01 00:35:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(2595, 116, '2014-02-01 00:37:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2596, 116, '2014-02-01 00:40:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(2597, 116, '2014-02-01 00:42:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(2598, 116, '2014-02-01 00:45:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(2599, 116, '2014-02-01 00:47:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2600, 116, '2014-02-01 00:50:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(2601, 116, '2014-02-01 00:52:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2602, 116, '2014-02-01 00:54:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2603, 116, '2014-02-01 00:56:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(2604, 116, '2014-02-01 00:59:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2605, 116, '2014-02-01 01:02:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(2606, 116, '2014-02-01 01:04:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(2607, 116, '2014-02-01 01:07:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(2608, 116, '2014-02-01 01:10:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(2609, 116, '2014-02-01 01:12:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(2610, 116, '2014-02-01 01:14:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(2611, 116, '2014-02-01 01:16:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(2612, 116, '2014-02-01 01:18:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2613, 116, '2014-02-01 01:20:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(2614, 116, '2014-02-01 01:23:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(2615, 116, '2014-02-01 01:26:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2616, 116, '2014-02-01 01:29:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(2617, 116, '2014-02-01 01:32:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2618, 116, '2014-02-01 01:34:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(2619, 116, '2014-02-01 01:35:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(2620, 116, '2014-02-01 01:38:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(2621, 116, '2014-02-01 01:41:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2622, 116, '2014-02-01 01:43:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2623, 116, '2014-02-01 01:46:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2624, 116, '2014-02-01 01:50:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2625, 116, '2014-02-01 01:53:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2626, 116, '2014-02-01 01:54:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(2627, 116, '2014-02-01 01:56:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2628, 116, '2014-02-01 01:59:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(2629, 116, '2014-02-01 02:03:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2630, 116, '2014-02-01 02:06:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(2631, 116, '2014-02-01 02:10:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(2632, 116, '2014-02-01 02:13:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(2633, 116, '2014-02-01 02:16:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2634, 116, '2014-02-01 02:18:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2635, 116, '2014-02-01 02:20:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(2636, 116, '2014-02-01 02:23:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2637, 116, '2014-02-01 02:25:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(2638, 116, '2014-02-01 02:27:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(2639, 116, '2014-02-01 02:30:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2640, 116, '2014-02-01 02:32:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(2641, 117, '2014-02-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2642, 117, '2014-02-01 00:02:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2643, 117, '2014-02-01 00:03:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(2644, 117, '2014-02-01 00:06:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(2645, 117, '2014-02-01 00:08:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(2646, 117, '2014-02-01 00:10:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(2647, 117, '2014-02-01 00:13:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(2648, 117, '2014-02-01 00:16:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(2649, 117, '2014-02-01 00:18:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(2650, 117, '2014-02-01 00:20:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2651, 117, '2014-02-01 00:23:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2652, 117, '2014-02-01 00:25:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2653, 117, '2014-02-01 00:28:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(2654, 117, '2014-02-01 00:31:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(2655, 117, '2014-02-01 00:33:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(2656, 117, '2014-02-01 00:35:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(2657, 117, '2014-02-01 00:38:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(2658, 117, '2014-02-01 00:39:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(2659, 117, '2014-02-01 00:43:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(2660, 117, '2014-02-01 00:45:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(2661, 117, '2014-02-01 00:48:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2662, 117, '2014-02-01 00:51:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(2663, 117, '2014-02-01 00:53:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(2664, 117, '2014-02-01 00:54:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2665, 117, '2014-02-01 00:56:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2666, 117, '2014-02-01 00:59:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2667, 117, '2014-02-01 01:02:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(2668, 117, '2014-02-01 01:06:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2669, 117, '2014-02-01 01:08:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2670, 117, '2014-02-01 01:11:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(2671, 117, '2014-02-01 01:14:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(2672, 117, '2014-02-01 01:16:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(2673, 117, '2014-02-01 01:19:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(2674, 117, '2014-02-01 01:21:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(2675, 117, '2014-02-01 01:24:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(2676, 117, '2014-02-01 01:26:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(2677, 117, '2014-02-01 01:28:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(2678, 117, '2014-02-01 01:31:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2679, 117, '2014-02-01 01:32:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(2680, 117, '2014-02-01 01:34:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(2681, 117, '2014-02-01 01:37:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(2682, 117, '2014-02-01 01:40:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(2683, 117, '2014-02-01 01:42:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(2684, 117, '2014-02-01 01:45:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2685, 117, '2014-02-01 01:47:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(2686, 117, '2014-02-01 01:50:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(2687, 117, '2014-02-01 01:52:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(2688, 117, '2014-02-01 01:55:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(2689, 117, '2014-02-01 01:57:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(2690, 117, '2014-02-01 02:00:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(2691, 117, '2014-02-01 02:02:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(2692, 117, '2014-02-01 02:04:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(2693, 117, '2014-02-01 02:07:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2694, 117, '2014-02-01 02:10:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(2695, 117, '2014-02-01 02:11:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(2696, 117, '2014-02-01 02:14:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(2697, 117, '2014-02-01 02:17:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(2698, 117, '2014-02-01 02:20:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2699, 117, '2014-02-01 02:23:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2700, 117, '2014-02-01 02:25:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(2701, 113, '2014-02-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2702, 113, '2014-02-15 00:02:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(2703, 113, '2014-02-15 00:05:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2704, 113, '2014-02-15 00:09:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(2705, 113, '2014-02-15 00:11:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(2706, 113, '2014-02-15 00:15:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(2707, 113, '2014-02-15 00:17:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(2708, 113, '2014-02-15 00:20:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(2709, 113, '2014-02-15 00:23:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(2710, 113, '2014-02-15 00:26:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(2711, 113, '2014-02-15 00:29:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(2712, 113, '2014-02-15 00:31:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(2713, 113, '2014-02-15 00:33:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2714, 113, '2014-02-15 00:35:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(2715, 113, '2014-02-15 00:37:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(2716, 113, '2014-02-15 00:39:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(2717, 113, '2014-02-15 00:42:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(2718, 113, '2014-02-15 00:44:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(2719, 113, '2014-02-15 00:48:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(2720, 113, '2014-02-15 00:51:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(2721, 113, '2014-02-15 00:53:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(2722, 113, '2014-02-15 00:55:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2723, 113, '2014-02-15 00:58:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2724, 113, '2014-02-15 01:00:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2725, 113, '2014-02-15 01:01:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(2726, 113, '2014-02-15 01:04:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2727, 113, '2014-02-15 01:06:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2728, 113, '2014-02-15 01:09:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(2729, 113, '2014-02-15 01:13:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(2730, 113, '2014-02-15 01:16:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2731, 113, '2014-02-15 01:18:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(2732, 113, '2014-02-15 01:21:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(2733, 113, '2014-02-15 01:24:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(2734, 113, '2014-02-15 01:28:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(2735, 113, '2014-02-15 01:31:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(2736, 113, '2014-02-15 01:32:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(2737, 113, '2014-02-15 01:35:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2738, 113, '2014-02-15 01:36:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2739, 113, '2014-02-15 01:38:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(2740, 113, '2014-02-15 01:41:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(2741, 113, '2014-02-15 01:42:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(2742, 113, '2014-02-15 01:46:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2743, 113, '2014-02-15 01:49:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2744, 113, '2014-02-15 01:50:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(2745, 113, '2014-02-15 01:53:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(2746, 113, '2014-02-15 01:54:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2747, 113, '2014-02-15 01:58:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(2748, 113, '2014-02-15 02:01:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(2749, 113, '2014-02-15 02:03:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(2750, 113, '2014-02-15 02:05:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2751, 113, '2014-02-15 02:08:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(2752, 113, '2014-02-15 02:10:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(2753, 113, '2014-02-15 02:13:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(2754, 113, '2014-02-15 02:16:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(2755, 113, '2014-02-15 02:18:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(2756, 113, '2014-02-15 02:20:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2757, 113, '2014-02-15 02:23:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(2758, 113, '2014-02-15 02:25:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(2759, 113, '2014-02-15 02:29:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(2760, 113, '2014-02-15 02:31:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(2761, 114, '2014-02-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2762, 114, '2014-02-15 00:01:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(2763, 114, '2014-02-15 00:05:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(2764, 114, '2014-02-15 00:07:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(2765, 114, '2014-02-15 00:09:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(2766, 114, '2014-02-15 00:10:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(2767, 114, '2014-02-15 00:13:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(2768, 114, '2014-02-15 00:16:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2769, 114, '2014-02-15 00:18:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2770, 114, '2014-02-15 00:19:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(2771, 114, '2014-02-15 00:22:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(2772, 114, '2014-02-15 00:26:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(2773, 114, '2014-02-15 00:28:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(2774, 114, '2014-02-15 00:31:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(2775, 114, '2014-02-15 00:33:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(2776, 114, '2014-02-15 00:36:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(2777, 114, '2014-02-15 00:39:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(2778, 114, '2014-02-15 00:42:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2779, 114, '2014-02-15 00:45:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2780, 114, '2014-02-15 00:46:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(2781, 114, '2014-02-15 00:50:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(2782, 114, '2014-02-15 00:51:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(2783, 114, '2014-02-15 00:54:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(2784, 114, '2014-02-15 00:56:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2785, 114, '2014-02-15 01:00:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(2786, 114, '2014-02-15 01:03:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(2787, 114, '2014-02-15 01:05:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2788, 114, '2014-02-15 01:08:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2789, 114, '2014-02-15 01:11:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2790, 114, '2014-02-15 01:15:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2791, 114, '2014-02-15 01:16:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(2792, 114, '2014-02-15 01:18:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(2793, 114, '2014-02-15 01:20:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(2794, 114, '2014-02-15 01:22:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2795, 114, '2014-02-15 01:25:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(2796, 114, '2014-02-15 01:28:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(2797, 114, '2014-02-15 01:31:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(2798, 114, '2014-02-15 01:34:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(2799, 114, '2014-02-15 01:36:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(2800, 114, '2014-02-15 01:39:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(2801, 114, '2014-02-15 01:41:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2802, 114, '2014-02-15 01:44:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(2803, 114, '2014-02-15 01:46:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(2804, 114, '2014-02-15 01:48:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(2805, 114, '2014-02-15 01:51:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2806, 114, '2014-02-15 01:54:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2807, 114, '2014-02-15 01:58:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2808, 114, '2014-02-15 02:01:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(2809, 114, '2014-02-15 02:04:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(2810, 114, '2014-02-15 02:07:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(2811, 114, '2014-02-15 02:09:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2812, 114, '2014-02-15 02:12:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(2813, 114, '2014-02-15 02:15:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(2814, 114, '2014-02-15 02:18:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(2815, 114, '2014-02-15 02:22:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(2816, 114, '2014-02-15 02:25:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(2817, 114, '2014-02-15 02:28:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(2818, 114, '2014-02-15 02:31:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(2819, 114, '2014-02-15 02:33:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2820, 114, '2014-02-15 02:35:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(2821, 115, '2014-02-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2822, 115, '2014-02-15 00:03:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2823, 115, '2014-02-15 00:06:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2824, 115, '2014-02-15 00:08:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2825, 115, '2014-02-15 00:10:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2826, 115, '2014-02-15 00:13:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(2827, 115, '2014-02-15 00:15:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2828, 115, '2014-02-15 00:18:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(2829, 115, '2014-02-15 00:21:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(2830, 115, '2014-02-15 00:24:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(2831, 115, '2014-02-15 00:26:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(2832, 115, '2014-02-15 00:28:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(2833, 115, '2014-02-15 00:31:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(2834, 115, '2014-02-15 00:33:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(2835, 115, '2014-02-15 00:36:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(2836, 115, '2014-02-15 00:38:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(2837, 115, '2014-02-15 00:41:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(2838, 115, '2014-02-15 00:44:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(2839, 115, '2014-02-15 00:46:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(2840, 115, '2014-02-15 00:47:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(2841, 115, '2014-02-15 00:50:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2842, 115, '2014-02-15 00:51:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(2843, 115, '2014-02-15 00:55:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2844, 115, '2014-02-15 00:57:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(2845, 115, '2014-02-15 01:00:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2846, 115, '2014-02-15 01:01:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2847, 115, '2014-02-15 01:05:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2848, 115, '2014-02-15 01:06:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2849, 115, '2014-02-15 01:09:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(2850, 115, '2014-02-15 01:12:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(2851, 115, '2014-02-15 01:14:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(2852, 115, '2014-02-15 01:15:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(2853, 115, '2014-02-15 01:17:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(2854, 115, '2014-02-15 01:19:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(2855, 115, '2014-02-15 01:22:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(2856, 115, '2014-02-15 01:25:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2857, 115, '2014-02-15 01:27:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(2858, 115, '2014-02-15 01:30:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2859, 115, '2014-02-15 01:33:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2860, 115, '2014-02-15 01:36:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2861, 115, '2014-02-15 01:38:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(2862, 115, '2014-02-15 01:40:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(2863, 115, '2014-02-15 01:43:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2864, 115, '2014-02-15 01:46:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(2865, 115, '2014-02-15 01:47:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2866, 115, '2014-02-15 01:49:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2867, 115, '2014-02-15 01:52:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(2868, 115, '2014-02-15 01:55:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(2869, 115, '2014-02-15 01:58:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(2870, 115, '2014-02-15 02:01:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(2871, 115, '2014-02-15 02:04:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2872, 115, '2014-02-15 02:07:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(2873, 115, '2014-02-15 02:11:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(2874, 115, '2014-02-15 02:14:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(2875, 115, '2014-02-15 02:17:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(2876, 115, '2014-02-15 02:20:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(2877, 115, '2014-02-15 02:21:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2878, 115, '2014-02-15 02:24:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(2879, 115, '2014-02-15 02:27:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(2880, 115, '2014-02-15 02:29:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2881, 116, '2014-02-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2882, 116, '2014-02-15 00:03:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(2883, 116, '2014-02-15 00:05:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(2884, 116, '2014-02-15 00:08:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(2885, 116, '2014-02-15 00:11:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(2886, 116, '2014-02-15 00:15:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(2887, 116, '2014-02-15 00:17:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(2888, 116, '2014-02-15 00:20:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2889, 116, '2014-02-15 00:21:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(2890, 116, '2014-02-15 00:24:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2891, 116, '2014-02-15 00:28:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(2892, 116, '2014-02-15 00:30:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2893, 116, '2014-02-15 00:33:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(2894, 116, '2014-02-15 00:36:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(2895, 116, '2014-02-15 00:39:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(2896, 116, '2014-02-15 00:41:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(2897, 116, '2014-02-15 00:44:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2898, 116, '2014-02-15 00:47:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(2899, 116, '2014-02-15 00:49:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(2900, 116, '2014-02-15 00:51:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(2901, 116, '2014-02-15 00:53:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(2902, 116, '2014-02-15 00:55:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2903, 116, '2014-02-15 00:58:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2904, 116, '2014-02-15 01:01:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(2905, 116, '2014-02-15 01:03:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(2906, 116, '2014-02-15 01:06:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(2907, 116, '2014-02-15 01:08:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(2908, 116, '2014-02-15 01:10:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2909, 116, '2014-02-15 01:11:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2910, 116, '2014-02-15 01:13:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2911, 116, '2014-02-15 01:14:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(2912, 116, '2014-02-15 01:18:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(2913, 116, '2014-02-15 01:21:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2914, 116, '2014-02-15 01:24:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(2915, 116, '2014-02-15 01:27:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(2916, 116, '2014-02-15 01:30:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(2917, 116, '2014-02-15 01:32:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2918, 116, '2014-02-15 01:35:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(2919, 116, '2014-02-15 01:37:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(2920, 116, '2014-02-15 01:40:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(2921, 116, '2014-02-15 01:42:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(2922, 116, '2014-02-15 01:44:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2923, 116, '2014-02-15 01:45:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(2924, 116, '2014-02-15 01:47:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(2925, 116, '2014-02-15 01:49:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(2926, 116, '2014-02-15 01:51:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2927, 116, '2014-02-15 01:54:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(2928, 116, '2014-02-15 01:57:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(2929, 116, '2014-02-15 01:59:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2930, 116, '2014-02-15 02:02:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(2931, 116, '2014-02-15 02:03:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(2932, 116, '2014-02-15 02:06:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(2933, 116, '2014-02-15 02:09:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(2934, 116, '2014-02-15 02:10:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(2935, 116, '2014-02-15 02:13:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2936, 116, '2014-02-15 02:15:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2937, 116, '2014-02-15 02:17:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2938, 116, '2014-02-15 02:19:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2939, 116, '2014-02-15 02:20:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2940, 116, '2014-02-15 02:23:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(2941, 117, '2014-02-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2942, 117, '2014-02-15 00:01:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2943, 117, '2014-02-15 00:04:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(2944, 117, '2014-02-15 00:07:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(2945, 117, '2014-02-15 00:09:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2946, 117, '2014-02-15 00:12:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(2947, 117, '2014-02-15 00:14:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2948, 117, '2014-02-15 00:16:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(2949, 117, '2014-02-15 00:20:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(2950, 117, '2014-02-15 00:23:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(2951, 117, '2014-02-15 00:26:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(2952, 117, '2014-02-15 00:30:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(2953, 117, '2014-02-15 00:33:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(2954, 117, '2014-02-15 00:36:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2955, 117, '2014-02-15 00:38:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(2956, 117, '2014-02-15 00:40:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(2957, 117, '2014-02-15 00:43:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(2958, 117, '2014-02-15 00:46:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(2959, 117, '2014-02-15 00:48:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(2960, 117, '2014-02-15 00:52:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(2961, 117, '2014-02-15 00:55:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(2962, 117, '2014-02-15 00:58:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(2963, 117, '2014-02-15 01:01:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(2964, 117, '2014-02-15 01:03:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(2965, 117, '2014-02-15 01:06:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(2966, 117, '2014-02-15 01:09:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(2967, 117, '2014-02-15 01:12:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(2968, 117, '2014-02-15 01:15:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(2969, 117, '2014-02-15 01:18:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(2970, 117, '2014-02-15 01:21:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2971, 117, '2014-02-15 01:23:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2972, 117, '2014-02-15 01:26:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(2973, 117, '2014-02-15 01:27:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(2974, 117, '2014-02-15 01:29:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(2975, 117, '2014-02-15 01:31:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(2976, 117, '2014-02-15 01:33:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(2977, 117, '2014-02-15 01:35:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(2978, 117, '2014-02-15 01:36:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(2979, 117, '2014-02-15 01:40:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(2980, 117, '2014-02-15 01:43:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(2981, 117, '2014-02-15 01:46:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(2982, 117, '2014-02-15 01:48:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(2983, 117, '2014-02-15 01:50:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(2984, 117, '2014-02-15 01:54:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(2985, 117, '2014-02-15 01:57:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(2986, 117, '2014-02-15 01:59:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(2987, 117, '2014-02-15 02:03:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(2988, 117, '2014-02-15 02:05:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(2989, 117, '2014-02-15 02:08:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(2990, 117, '2014-02-15 02:10:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(2991, 117, '2014-02-15 02:13:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(2992, 117, '2014-02-15 02:17:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(2993, 117, '2014-02-15 02:20:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(2994, 117, '2014-02-15 02:23:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(2995, 117, '2014-02-15 02:27:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(2996, 117, '2014-02-15 02:29:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(2997, 117, '2014-02-15 02:31:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(2998, 117, '2014-02-15 02:34:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(2999, 117, '2014-02-15 02:36:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3000, 117, '2014-02-15 02:39:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3001, 113, '2014-03-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3002, 113, '2014-03-01 00:03:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(3003, 113, '2014-03-01 00:05:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(3004, 113, '2014-03-01 00:07:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3005, 113, '2014-03-01 00:10:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3006, 113, '2014-03-01 00:12:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(3007, 113, '2014-03-01 00:14:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(3008, 113, '2014-03-01 00:16:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(3009, 113, '2014-03-01 00:19:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(3010, 113, '2014-03-01 00:22:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3011, 113, '2014-03-01 00:26:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(3012, 113, '2014-03-01 00:28:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(3013, 113, '2014-03-01 00:31:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(3014, 113, '2014-03-01 00:33:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(3015, 113, '2014-03-01 00:35:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(3016, 113, '2014-03-01 00:38:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(3017, 113, '2014-03-01 00:40:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3018, 113, '2014-03-01 00:44:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(3019, 113, '2014-03-01 00:45:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3020, 113, '2014-03-01 00:48:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(3021, 113, '2014-03-01 00:51:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(3022, 113, '2014-03-01 00:55:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(3023, 113, '2014-03-01 00:57:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(3024, 113, '2014-03-01 01:00:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(3025, 113, '2014-03-01 01:02:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3026, 113, '2014-03-01 01:05:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(3027, 113, '2014-03-01 01:07:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(3028, 113, '2014-03-01 01:09:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(3029, 113, '2014-03-01 01:13:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(3030, 113, '2014-03-01 01:16:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(3031, 113, '2014-03-01 01:18:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3032, 113, '2014-03-01 01:22:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(3033, 113, '2014-03-01 01:23:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(3034, 113, '2014-03-01 01:26:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(3035, 113, '2014-03-01 01:29:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(3036, 113, '2014-03-01 01:31:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3037, 113, '2014-03-01 01:34:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3038, 113, '2014-03-01 01:36:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(3039, 113, '2014-03-01 01:40:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(3040, 113, '2014-03-01 01:43:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(3041, 113, '2014-03-01 01:47:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3042, 113, '2014-03-01 01:49:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(3043, 113, '2014-03-01 01:52:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(3044, 113, '2014-03-01 01:54:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(3045, 113, '2014-03-01 01:56:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(3046, 113, '2014-03-01 01:57:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(3047, 113, '2014-03-01 01:59:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(3048, 113, '2014-03-01 02:02:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(3049, 113, '2014-03-01 02:05:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(3050, 113, '2014-03-01 02:07:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3051, 113, '2014-03-01 02:09:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(3052, 113, '2014-03-01 02:11:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(3053, 113, '2014-03-01 02:13:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(3054, 113, '2014-03-01 02:17:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3055, 113, '2014-03-01 02:19:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(3056, 113, '2014-03-01 02:22:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3057, 113, '2014-03-01 02:25:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(3058, 113, '2014-03-01 02:28:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(3059, 113, '2014-03-01 02:30:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(3060, 113, '2014-03-01 02:32:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(3061, 114, '2014-03-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3062, 114, '2014-03-01 00:01:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3063, 114, '2014-03-01 00:04:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3064, 114, '2014-03-01 00:06:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(3065, 114, '2014-03-01 00:09:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(3066, 114, '2014-03-01 00:11:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3067, 114, '2014-03-01 00:15:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(3068, 114, '2014-03-01 00:17:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(3069, 114, '2014-03-01 00:19:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3070, 114, '2014-03-01 00:21:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3071, 114, '2014-03-01 00:22:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(3072, 114, '2014-03-01 00:24:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(3073, 114, '2014-03-01 00:26:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(3074, 114, '2014-03-01 00:29:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(3075, 114, '2014-03-01 00:31:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(3076, 114, '2014-03-01 00:34:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(3077, 114, '2014-03-01 00:36:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(3078, 114, '2014-03-01 00:40:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(3079, 114, '2014-03-01 00:42:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(3080, 114, '2014-03-01 00:46:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(3081, 114, '2014-03-01 00:50:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(3082, 114, '2014-03-01 00:52:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(3083, 114, '2014-03-01 00:55:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(3084, 114, '2014-03-01 00:57:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3085, 114, '2014-03-01 01:00:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3086, 114, '2014-03-01 01:03:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(3087, 114, '2014-03-01 01:05:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3088, 114, '2014-03-01 01:07:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3089, 114, '2014-03-01 01:10:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(3090, 114, '2014-03-01 01:12:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3091, 114, '2014-03-01 01:14:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(3092, 114, '2014-03-01 01:16:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(3093, 114, '2014-03-01 01:19:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3094, 114, '2014-03-01 01:23:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(3095, 114, '2014-03-01 01:26:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3096, 114, '2014-03-01 01:28:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(3097, 114, '2014-03-01 01:31:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(3098, 114, '2014-03-01 01:34:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3099, 114, '2014-03-01 01:37:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(3100, 114, '2014-03-01 01:41:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(3101, 114, '2014-03-01 01:43:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(3102, 114, '2014-03-01 01:45:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(3103, 114, '2014-03-01 01:48:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(3104, 114, '2014-03-01 01:50:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(3105, 114, '2014-03-01 01:53:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(3106, 114, '2014-03-01 01:55:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(3107, 114, '2014-03-01 01:58:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(3108, 114, '2014-03-01 01:59:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(3109, 114, '2014-03-01 02:03:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(3110, 114, '2014-03-01 02:05:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(3111, 114, '2014-03-01 02:09:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3112, 114, '2014-03-01 02:11:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3113, 114, '2014-03-01 02:14:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(3114, 114, '2014-03-01 02:16:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3115, 114, '2014-03-01 02:18:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(3116, 114, '2014-03-01 02:21:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(3117, 114, '2014-03-01 02:24:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3118, 114, '2014-03-01 02:26:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(3119, 114, '2014-03-01 02:28:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(3120, 114, '2014-03-01 02:30:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3121, 115, '2014-03-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3122, 115, '2014-03-01 00:03:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(3123, 115, '2014-03-01 00:06:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3124, 115, '2014-03-01 00:08:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(3125, 115, '2014-03-01 00:11:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(3126, 115, '2014-03-01 00:14:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3127, 115, '2014-03-01 00:17:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(3128, 115, '2014-03-01 00:20:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3129, 115, '2014-03-01 00:23:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3130, 115, '2014-03-01 00:27:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(3131, 115, '2014-03-01 00:28:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3132, 115, '2014-03-01 00:31:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3133, 115, '2014-03-01 00:33:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(3134, 115, '2014-03-01 00:37:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(3135, 115, '2014-03-01 00:40:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(3136, 115, '2014-03-01 00:43:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(3137, 115, '2014-03-01 00:46:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3138, 115, '2014-03-01 00:49:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(3139, 115, '2014-03-01 00:51:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3140, 115, '2014-03-01 00:54:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(3141, 115, '2014-03-01 00:57:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(3142, 115, '2014-03-01 01:00:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(3143, 115, '2014-03-01 01:04:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3144, 115, '2014-03-01 01:05:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3145, 115, '2014-03-01 01:09:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(3146, 115, '2014-03-01 01:11:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(3147, 115, '2014-03-01 01:14:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(3148, 115, '2014-03-01 01:16:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(3149, 115, '2014-03-01 01:19:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3150, 115, '2014-03-01 01:22:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(3151, 115, '2014-03-01 01:26:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(3152, 115, '2014-03-01 01:28:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(3153, 115, '2014-03-01 01:29:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(3154, 115, '2014-03-01 01:32:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(3155, 115, '2014-03-01 01:35:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(3156, 115, '2014-03-01 01:38:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3157, 115, '2014-03-01 01:40:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3158, 115, '2014-03-01 01:43:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(3159, 115, '2014-03-01 01:45:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(3160, 115, '2014-03-01 01:47:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(3161, 115, '2014-03-01 01:50:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(3162, 115, '2014-03-01 01:52:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(3163, 115, '2014-03-01 01:55:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3164, 115, '2014-03-01 01:56:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(3165, 115, '2014-03-01 02:00:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(3166, 115, '2014-03-01 02:03:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(3167, 115, '2014-03-01 02:04:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(3168, 115, '2014-03-01 02:06:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3169, 115, '2014-03-01 02:08:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3170, 115, '2014-03-01 02:10:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(3171, 115, '2014-03-01 02:11:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(3172, 115, '2014-03-01 02:14:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3173, 115, '2014-03-01 02:17:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(3174, 115, '2014-03-01 02:19:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(3175, 115, '2014-03-01 02:22:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(3176, 115, '2014-03-01 02:24:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3177, 115, '2014-03-01 02:27:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3178, 115, '2014-03-01 02:30:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3179, 115, '2014-03-01 02:34:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(3180, 115, '2014-03-01 02:36:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3181, 116, '2014-03-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3182, 116, '2014-03-01 00:02:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(3183, 116, '2014-03-01 00:03:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(3184, 116, '2014-03-01 00:06:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(3185, 116, '2014-03-01 00:08:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(3186, 116, '2014-03-01 00:11:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(3187, 116, '2014-03-01 00:13:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3188, 116, '2014-03-01 00:15:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3189, 116, '2014-03-01 00:18:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(3190, 116, '2014-03-01 00:21:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3191, 116, '2014-03-01 00:25:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3192, 116, '2014-03-01 00:27:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(3193, 116, '2014-03-01 00:29:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3194, 116, '2014-03-01 00:32:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3195, 116, '2014-03-01 00:36:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(3196, 116, '2014-03-01 00:38:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(3197, 116, '2014-03-01 00:40:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(3198, 116, '2014-03-01 00:42:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(3199, 116, '2014-03-01 00:45:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(3200, 116, '2014-03-01 00:47:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(3201, 116, '2014-03-01 00:49:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(3202, 116, '2014-03-01 00:51:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(3203, 116, '2014-03-01 00:54:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(3204, 116, '2014-03-01 00:57:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3205, 116, '2014-03-01 01:00:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3206, 116, '2014-03-01 01:04:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(3207, 116, '2014-03-01 01:07:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3208, 116, '2014-03-01 01:09:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3209, 116, '2014-03-01 01:11:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(3210, 116, '2014-03-01 01:14:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(3211, 116, '2014-03-01 01:16:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(3212, 116, '2014-03-01 01:19:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3213, 116, '2014-03-01 01:21:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(3214, 116, '2014-03-01 01:25:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(3215, 116, '2014-03-01 01:28:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3216, 116, '2014-03-01 01:30:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(3217, 116, '2014-03-01 01:32:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3218, 116, '2014-03-01 01:35:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(3219, 116, '2014-03-01 01:36:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(3220, 116, '2014-03-01 01:38:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(3221, 116, '2014-03-01 01:41:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(3222, 116, '2014-03-01 01:44:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(3223, 116, '2014-03-01 01:47:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(3224, 116, '2014-03-01 01:49:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3225, 116, '2014-03-01 01:52:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3226, 116, '2014-03-01 01:55:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(3227, 116, '2014-03-01 01:58:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(3228, 116, '2014-03-01 02:01:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(3229, 116, '2014-03-01 02:03:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3230, 116, '2014-03-01 02:06:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3231, 116, '2014-03-01 02:09:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(3232, 116, '2014-03-01 02:13:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(3233, 116, '2014-03-01 02:16:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(3234, 116, '2014-03-01 02:19:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(3235, 116, '2014-03-01 02:21:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3236, 116, '2014-03-01 02:24:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(3237, 116, '2014-03-01 02:26:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(3238, 116, '2014-03-01 02:28:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(3239, 116, '2014-03-01 02:31:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(3240, 116, '2014-03-01 02:35:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(3241, 117, '2014-03-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3242, 117, '2014-03-01 00:02:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(3243, 117, '2014-03-01 00:04:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(3244, 117, '2014-03-01 00:06:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3245, 117, '2014-03-01 00:08:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(3246, 117, '2014-03-01 00:11:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(3247, 117, '2014-03-01 00:13:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(3248, 117, '2014-03-01 00:16:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(3249, 117, '2014-03-01 00:18:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(3250, 117, '2014-03-01 00:20:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(3251, 117, '2014-03-01 00:23:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(3252, 117, '2014-03-01 00:25:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3253, 117, '2014-03-01 00:28:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(3254, 117, '2014-03-01 00:30:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3255, 117, '2014-03-01 00:33:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(3256, 117, '2014-03-01 00:36:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3257, 117, '2014-03-01 00:39:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(3258, 117, '2014-03-01 00:42:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(3259, 117, '2014-03-01 00:44:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3260, 117, '2014-03-01 00:48:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(3261, 117, '2014-03-01 00:49:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(3262, 117, '2014-03-01 00:52:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(3263, 117, '2014-03-01 00:55:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(3264, 117, '2014-03-01 00:57:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(3265, 117, '2014-03-01 00:59:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(3266, 117, '2014-03-01 01:01:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3267, 117, '2014-03-01 01:05:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3268, 117, '2014-03-01 01:08:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(3269, 117, '2014-03-01 01:11:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(3270, 117, '2014-03-01 01:14:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(3271, 117, '2014-03-01 01:16:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(3272, 117, '2014-03-01 01:19:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3273, 117, '2014-03-01 01:22:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(3274, 117, '2014-03-01 01:25:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(3275, 117, '2014-03-01 01:27:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3276, 117, '2014-03-01 01:30:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3277, 117, '2014-03-01 01:32:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(3278, 117, '2014-03-01 01:35:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(3279, 117, '2014-03-01 01:38:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(3280, 117, '2014-03-01 01:41:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(3281, 117, '2014-03-01 01:43:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(3282, 117, '2014-03-01 01:46:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(3283, 117, '2014-03-01 01:49:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(3284, 117, '2014-03-01 01:52:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(3285, 117, '2014-03-01 01:56:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(3286, 117, '2014-03-01 01:57:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(3287, 117, '2014-03-01 02:00:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(3288, 117, '2014-03-01 02:03:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(3289, 117, '2014-03-01 02:06:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(3290, 117, '2014-03-01 02:07:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(3291, 117, '2014-03-01 02:10:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(3292, 117, '2014-03-01 02:12:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3293, 117, '2014-03-01 02:14:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(3294, 117, '2014-03-01 02:16:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(3295, 117, '2014-03-01 02:17:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(3296, 117, '2014-03-01 02:20:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3297, 117, '2014-03-01 02:23:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(3298, 117, '2014-03-01 02:25:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3299, 117, '2014-03-01 02:27:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3300, 117, '2014-03-01 02:29:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3301, 113, '2014-03-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3302, 113, '2014-03-15 00:01:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3303, 113, '2014-03-15 00:03:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(3304, 113, '2014-03-15 00:06:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(3305, 113, '2014-03-15 00:08:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3306, 113, '2014-03-15 00:12:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(3307, 113, '2014-03-15 00:14:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(3308, 113, '2014-03-15 00:16:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(3309, 113, '2014-03-15 00:20:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(3310, 113, '2014-03-15 00:22:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3311, 113, '2014-03-15 00:25:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(3312, 113, '2014-03-15 00:27:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(3313, 113, '2014-03-15 00:29:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3314, 113, '2014-03-15 00:31:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(3315, 113, '2014-03-15 00:34:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(3316, 113, '2014-03-15 00:37:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(3317, 113, '2014-03-15 00:38:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(3318, 113, '2014-03-15 00:41:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(3319, 113, '2014-03-15 00:43:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(3320, 113, '2014-03-15 00:46:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(3321, 113, '2014-03-15 00:48:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(3322, 113, '2014-03-15 00:51:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3323, 113, '2014-03-15 00:54:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(3324, 113, '2014-03-15 00:56:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(3325, 113, '2014-03-15 00:59:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(3326, 113, '2014-03-15 01:02:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3327, 113, '2014-03-15 01:04:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(3328, 113, '2014-03-15 01:07:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(3329, 113, '2014-03-15 01:08:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(3330, 113, '2014-03-15 01:10:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(3331, 113, '2014-03-15 01:12:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(3332, 113, '2014-03-15 01:14:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3333, 113, '2014-03-15 01:17:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(3334, 113, '2014-03-15 01:20:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3335, 113, '2014-03-15 01:21:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(3336, 113, '2014-03-15 01:23:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(3337, 113, '2014-03-15 01:27:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3338, 113, '2014-03-15 01:28:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(3339, 113, '2014-03-15 01:30:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(3340, 113, '2014-03-15 01:32:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3341, 113, '2014-03-15 01:34:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3342, 113, '2014-03-15 01:36:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(3343, 113, '2014-03-15 01:38:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(3344, 113, '2014-03-15 01:41:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(3345, 113, '2014-03-15 01:45:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3346, 113, '2014-03-15 01:47:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(3347, 113, '2014-03-15 01:50:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3348, 113, '2014-03-15 01:52:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(3349, 113, '2014-03-15 01:55:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(3350, 113, '2014-03-15 01:58:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(3351, 113, '2014-03-15 02:01:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(3352, 113, '2014-03-15 02:03:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(3353, 113, '2014-03-15 02:05:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3354, 113, '2014-03-15 02:08:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(3355, 113, '2014-03-15 02:10:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3356, 113, '2014-03-15 02:12:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(3357, 113, '2014-03-15 02:14:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(3358, 113, '2014-03-15 02:18:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(3359, 113, '2014-03-15 02:20:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(3360, 113, '2014-03-15 02:21:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(3361, 114, '2014-03-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3362, 114, '2014-03-15 00:02:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(3363, 114, '2014-03-15 00:05:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(3364, 114, '2014-03-15 00:06:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(3365, 114, '2014-03-15 00:09:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(3366, 114, '2014-03-15 00:12:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3367, 114, '2014-03-15 00:14:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(3368, 114, '2014-03-15 00:16:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(3369, 114, '2014-03-15 00:18:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(3370, 114, '2014-03-15 00:20:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(3371, 114, '2014-03-15 00:22:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(3372, 114, '2014-03-15 00:24:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(3373, 114, '2014-03-15 00:27:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(3374, 114, '2014-03-15 00:29:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(3375, 114, '2014-03-15 00:31:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(3376, 114, '2014-03-15 00:34:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(3377, 114, '2014-03-15 00:36:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(3378, 114, '2014-03-15 00:40:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3379, 114, '2014-03-15 00:43:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(3380, 114, '2014-03-15 00:46:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(3381, 114, '2014-03-15 00:48:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(3382, 114, '2014-03-15 00:51:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3383, 114, '2014-03-15 00:53:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(3384, 114, '2014-03-15 00:55:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(3385, 114, '2014-03-15 00:58:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(3386, 114, '2014-03-15 01:01:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(3387, 114, '2014-03-15 01:02:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(3388, 114, '2014-03-15 01:05:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(3389, 114, '2014-03-15 01:06:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(3390, 114, '2014-03-15 01:10:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(3391, 114, '2014-03-15 01:12:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3392, 114, '2014-03-15 01:15:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(3393, 114, '2014-03-15 01:18:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(3394, 114, '2014-03-15 01:21:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(3395, 114, '2014-03-15 01:23:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3396, 114, '2014-03-15 01:25:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3397, 114, '2014-03-15 01:28:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3398, 114, '2014-03-15 01:31:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(3399, 114, '2014-03-15 01:32:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3400, 114, '2014-03-15 01:35:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(3401, 114, '2014-03-15 01:38:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(3402, 114, '2014-03-15 01:40:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3403, 114, '2014-03-15 01:42:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3404, 114, '2014-03-15 01:45:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(3405, 114, '2014-03-15 01:49:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3406, 114, '2014-03-15 01:52:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(3407, 114, '2014-03-15 01:55:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(3408, 114, '2014-03-15 01:57:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(3409, 114, '2014-03-15 02:00:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(3410, 114, '2014-03-15 02:03:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(3411, 114, '2014-03-15 02:07:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(3412, 114, '2014-03-15 02:09:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3413, 114, '2014-03-15 02:13:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3414, 114, '2014-03-15 02:15:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(3415, 114, '2014-03-15 02:16:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3416, 114, '2014-03-15 02:18:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(3417, 114, '2014-03-15 02:20:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(3418, 114, '2014-03-15 02:22:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3419, 114, '2014-03-15 02:24:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(3420, 114, '2014-03-15 02:27:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(3421, 115, '2014-03-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3422, 115, '2014-03-15 00:02:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(3423, 115, '2014-03-15 00:04:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(3424, 115, '2014-03-15 00:07:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(3425, 115, '2014-03-15 00:10:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(3426, 115, '2014-03-15 00:12:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3427, 115, '2014-03-15 00:16:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3428, 115, '2014-03-15 00:17:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(3429, 115, '2014-03-15 00:20:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(3430, 115, '2014-03-15 00:23:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(3431, 115, '2014-03-15 00:26:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(3432, 115, '2014-03-15 00:28:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3433, 115, '2014-03-15 00:31:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(3434, 115, '2014-03-15 00:33:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(3435, 115, '2014-03-15 00:36:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(3436, 115, '2014-03-15 00:37:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(3437, 115, '2014-03-15 00:40:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(3438, 115, '2014-03-15 00:42:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(3439, 115, '2014-03-15 00:44:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3440, 115, '2014-03-15 00:47:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(3441, 115, '2014-03-15 00:49:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(3442, 115, '2014-03-15 00:51:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(3443, 115, '2014-03-15 00:54:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3444, 115, '2014-03-15 00:56:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(3445, 115, '2014-03-15 01:00:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(3446, 115, '2014-03-15 01:03:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3447, 115, '2014-03-15 01:05:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3448, 115, '2014-03-15 01:08:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(3449, 115, '2014-03-15 01:11:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(3450, 115, '2014-03-15 01:13:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3451, 115, '2014-03-15 01:16:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3452, 115, '2014-03-15 01:19:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(3453, 115, '2014-03-15 01:22:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(3454, 115, '2014-03-15 01:24:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(3455, 115, '2014-03-15 01:25:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(3456, 115, '2014-03-15 01:28:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3457, 115, '2014-03-15 01:31:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(3458, 115, '2014-03-15 01:34:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(3459, 115, '2014-03-15 01:36:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3460, 115, '2014-03-15 01:38:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3461, 115, '2014-03-15 01:40:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(3462, 115, '2014-03-15 01:43:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(3463, 115, '2014-03-15 01:46:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(3464, 115, '2014-03-15 01:48:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3465, 115, '2014-03-15 01:50:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(3466, 115, '2014-03-15 01:52:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(3467, 115, '2014-03-15 01:53:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3468, 115, '2014-03-15 01:56:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3469, 115, '2014-03-15 01:58:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(3470, 115, '2014-03-15 02:01:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(3471, 115, '2014-03-15 02:03:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(3472, 115, '2014-03-15 02:05:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(3473, 115, '2014-03-15 02:08:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3474, 115, '2014-03-15 02:10:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3475, 115, '2014-03-15 02:13:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(3476, 115, '2014-03-15 02:15:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3477, 115, '2014-03-15 02:18:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(3478, 115, '2014-03-15 02:21:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3479, 115, '2014-03-15 02:24:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(3480, 115, '2014-03-15 02:25:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(3481, 116, '2014-03-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3482, 116, '2014-03-15 00:03:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(3483, 116, '2014-03-15 00:05:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3484, 116, '2014-03-15 00:08:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(3485, 116, '2014-03-15 00:11:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3486, 116, '2014-03-15 00:13:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3487, 116, '2014-03-15 00:15:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(3488, 116, '2014-03-15 00:17:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(3489, 116, '2014-03-15 00:19:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3490, 116, '2014-03-15 00:23:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3491, 116, '2014-03-15 00:26:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(3492, 116, '2014-03-15 00:29:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3493, 116, '2014-03-15 00:32:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(3494, 116, '2014-03-15 00:36:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(3495, 116, '2014-03-15 00:39:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(3496, 116, '2014-03-15 00:41:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3497, 116, '2014-03-15 00:43:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(3498, 116, '2014-03-15 00:46:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3499, 116, '2014-03-15 00:49:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(3500, 116, '2014-03-15 00:51:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(3501, 116, '2014-03-15 00:54:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(3502, 116, '2014-03-15 00:58:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(3503, 116, '2014-03-15 01:01:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(3504, 116, '2014-03-15 01:03:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(3505, 116, '2014-03-15 01:06:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3506, 116, '2014-03-15 01:09:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(3507, 116, '2014-03-15 01:11:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3508, 116, '2014-03-15 01:13:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(3509, 116, '2014-03-15 01:15:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3510, 116, '2014-03-15 01:18:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(3511, 116, '2014-03-15 01:21:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3512, 116, '2014-03-15 01:24:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(3513, 116, '2014-03-15 01:27:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(3514, 116, '2014-03-15 01:30:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(3515, 116, '2014-03-15 01:33:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(3516, 116, '2014-03-15 01:37:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(3517, 116, '2014-03-15 01:38:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(3518, 116, '2014-03-15 01:41:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(3519, 116, '2014-03-15 01:43:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3520, 116, '2014-03-15 01:45:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(3521, 116, '2014-03-15 01:47:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(3522, 116, '2014-03-15 01:50:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(3523, 116, '2014-03-15 01:51:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(3524, 116, '2014-03-15 01:53:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(3525, 116, '2014-03-15 01:56:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(3526, 116, '2014-03-15 01:58:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(3527, 116, '2014-03-15 02:00:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(3528, 116, '2014-03-15 02:03:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(3529, 116, '2014-03-15 02:05:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(3530, 116, '2014-03-15 02:09:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(3531, 116, '2014-03-15 02:12:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3532, 116, '2014-03-15 02:15:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(3533, 116, '2014-03-15 02:17:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3534, 116, '2014-03-15 02:20:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(3535, 116, '2014-03-15 02:24:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(3536, 116, '2014-03-15 02:27:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(3537, 116, '2014-03-15 02:28:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(3538, 116, '2014-03-15 02:32:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(3539, 116, '2014-03-15 02:35:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(3540, 116, '2014-03-15 02:38:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(3541, 117, '2014-03-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3542, 117, '2014-03-15 00:03:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(3543, 117, '2014-03-15 00:05:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(3544, 117, '2014-03-15 00:07:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3545, 117, '2014-03-15 00:09:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(3546, 117, '2014-03-15 00:13:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(3547, 117, '2014-03-15 00:16:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3548, 117, '2014-03-15 00:19:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(3549, 117, '2014-03-15 00:21:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(3550, 117, '2014-03-15 00:23:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3551, 117, '2014-03-15 00:25:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(3552, 117, '2014-03-15 00:28:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(3553, 117, '2014-03-15 00:31:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3554, 117, '2014-03-15 00:34:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3555, 117, '2014-03-15 00:36:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(3556, 117, '2014-03-15 00:39:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(3557, 117, '2014-03-15 00:41:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(3558, 117, '2014-03-15 00:43:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(3559, 117, '2014-03-15 00:46:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(3560, 117, '2014-03-15 00:49:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(3561, 117, '2014-03-15 00:50:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3562, 117, '2014-03-15 00:54:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3563, 117, '2014-03-15 00:57:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3564, 117, '2014-03-15 01:00:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3565, 117, '2014-03-15 01:03:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3566, 117, '2014-03-15 01:06:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3567, 117, '2014-03-15 01:09:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(3568, 117, '2014-03-15 01:11:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(3569, 117, '2014-03-15 01:13:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3570, 117, '2014-03-15 01:15:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(3571, 117, '2014-03-15 01:18:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(3572, 117, '2014-03-15 01:22:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(3573, 117, '2014-03-15 01:25:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(3574, 117, '2014-03-15 01:27:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3575, 117, '2014-03-15 01:31:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(3576, 117, '2014-03-15 01:34:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3577, 117, '2014-03-15 01:37:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(3578, 117, '2014-03-15 01:39:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(3579, 117, '2014-03-15 01:41:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3580, 117, '2014-03-15 01:44:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(3581, 117, '2014-03-15 01:48:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(3582, 117, '2014-03-15 01:49:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3583, 117, '2014-03-15 01:51:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(3584, 117, '2014-03-15 01:53:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3585, 117, '2014-03-15 01:55:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(3586, 117, '2014-03-15 01:58:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(3587, 117, '2014-03-15 02:01:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(3588, 117, '2014-03-15 02:04:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3589, 117, '2014-03-15 02:07:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3590, 117, '2014-03-15 02:11:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(3591, 117, '2014-03-15 02:13:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(3592, 117, '2014-03-15 02:15:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(3593, 117, '2014-03-15 02:19:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3594, 117, '2014-03-15 02:20:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(3595, 117, '2014-03-15 02:24:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(3596, 117, '2014-03-15 02:26:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3597, 117, '2014-03-15 02:28:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3598, 117, '2014-03-15 02:30:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(3599, 117, '2014-03-15 02:33:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(3600, 117, '2014-03-15 02:36:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(3601, 113, '2014-04-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3602, 113, '2014-04-01 00:01:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(3603, 113, '2014-04-01 00:04:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(3604, 113, '2014-04-01 00:06:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(3605, 113, '2014-04-01 00:09:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3606, 113, '2014-04-01 00:12:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(3607, 113, '2014-04-01 00:14:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(3608, 113, '2014-04-01 00:16:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3609, 113, '2014-04-01 00:19:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(3610, 113, '2014-04-01 00:22:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(3611, 113, '2014-04-01 00:24:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3612, 113, '2014-04-01 00:25:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3613, 113, '2014-04-01 00:29:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(3614, 113, '2014-04-01 00:31:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(3615, 113, '2014-04-01 00:33:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3616, 113, '2014-04-01 00:37:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(3617, 113, '2014-04-01 00:39:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(3618, 113, '2014-04-01 00:41:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(3619, 113, '2014-04-01 00:43:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(3620, 113, '2014-04-01 00:46:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(3621, 113, '2014-04-01 00:48:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(3622, 113, '2014-04-01 00:50:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(3623, 113, '2014-04-01 00:52:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(3624, 113, '2014-04-01 00:54:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(3625, 113, '2014-04-01 00:57:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(3626, 113, '2014-04-01 01:00:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3627, 113, '2014-04-01 01:02:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(3628, 113, '2014-04-01 01:05:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(3629, 113, '2014-04-01 01:07:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(3630, 113, '2014-04-01 01:09:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3631, 113, '2014-04-01 01:12:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3632, 113, '2014-04-01 01:14:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3633, 113, '2014-04-01 01:16:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(3634, 113, '2014-04-01 01:18:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(3635, 113, '2014-04-01 01:22:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(3636, 113, '2014-04-01 01:24:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(3637, 113, '2014-04-01 01:26:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3638, 113, '2014-04-01 01:28:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(3639, 113, '2014-04-01 01:30:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3640, 113, '2014-04-01 01:33:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(3641, 113, '2014-04-01 01:35:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3642, 113, '2014-04-01 01:38:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3643, 113, '2014-04-01 01:41:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3644, 113, '2014-04-01 01:43:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(3645, 113, '2014-04-01 01:46:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(3646, 113, '2014-04-01 01:50:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(3647, 113, '2014-04-01 01:51:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(3648, 113, '2014-04-01 01:53:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(3649, 113, '2014-04-01 01:56:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(3650, 113, '2014-04-01 01:58:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(3651, 113, '2014-04-01 02:01:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(3652, 113, '2014-04-01 02:03:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(3653, 113, '2014-04-01 02:05:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(3654, 113, '2014-04-01 02:09:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(3655, 113, '2014-04-01 02:12:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(3656, 113, '2014-04-01 02:15:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(3657, 113, '2014-04-01 02:18:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(3658, 113, '2014-04-01 02:20:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(3659, 113, '2014-04-01 02:23:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(3660, 113, '2014-04-01 02:26:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(3661, 114, '2014-04-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3662, 114, '2014-04-01 00:01:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(3663, 114, '2014-04-01 00:04:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(3664, 114, '2014-04-01 00:06:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(3665, 114, '2014-04-01 00:08:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(3666, 114, '2014-04-01 00:11:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(3667, 114, '2014-04-01 00:12:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(3668, 114, '2014-04-01 00:15:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(3669, 114, '2014-04-01 00:18:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3670, 114, '2014-04-01 00:21:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(3671, 114, '2014-04-01 00:23:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3672, 114, '2014-04-01 00:26:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3673, 114, '2014-04-01 00:29:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3674, 114, '2014-04-01 00:31:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3675, 114, '2014-04-01 00:33:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3676, 114, '2014-04-01 00:35:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3677, 114, '2014-04-01 00:38:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(3678, 114, '2014-04-01 00:41:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(3679, 114, '2014-04-01 00:43:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(3680, 114, '2014-04-01 00:45:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3681, 114, '2014-04-01 00:49:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(3682, 114, '2014-04-01 00:50:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3683, 114, '2014-04-01 00:53:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(3684, 114, '2014-04-01 00:56:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3685, 114, '2014-04-01 00:58:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3686, 114, '2014-04-01 01:01:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3687, 114, '2014-04-01 01:04:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(3688, 114, '2014-04-01 01:06:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3689, 114, '2014-04-01 01:08:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(3690, 114, '2014-04-01 01:11:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3691, 114, '2014-04-01 01:13:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3692, 114, '2014-04-01 01:16:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(3693, 114, '2014-04-01 01:17:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(3694, 114, '2014-04-01 01:20:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3695, 114, '2014-04-01 01:22:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(3696, 114, '2014-04-01 01:24:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(3697, 114, '2014-04-01 01:28:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3698, 114, '2014-04-01 01:31:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(3699, 114, '2014-04-01 01:34:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(3700, 114, '2014-04-01 01:37:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(3701, 114, '2014-04-01 01:40:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(3702, 114, '2014-04-01 01:43:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(3703, 114, '2014-04-01 01:46:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(3704, 114, '2014-04-01 01:48:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(3705, 114, '2014-04-01 01:50:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(3706, 114, '2014-04-01 01:52:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(3707, 114, '2014-04-01 01:55:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(3708, 114, '2014-04-01 01:57:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(3709, 114, '2014-04-01 01:59:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(3710, 114, '2014-04-01 02:01:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(3711, 114, '2014-04-01 02:03:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3712, 114, '2014-04-01 02:06:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(3713, 114, '2014-04-01 02:08:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(3714, 114, '2014-04-01 02:10:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3715, 114, '2014-04-01 02:12:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3716, 114, '2014-04-01 02:15:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(3717, 114, '2014-04-01 02:18:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(3718, 114, '2014-04-01 02:20:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3719, 114, '2014-04-01 02:22:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3720, 114, '2014-04-01 02:24:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3721, 115, '2014-04-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3722, 115, '2014-04-01 00:03:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(3723, 115, '2014-04-01 00:05:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(3724, 115, '2014-04-01 00:08:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(3725, 115, '2014-04-01 00:11:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(3726, 115, '2014-04-01 00:14:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(3727, 115, '2014-04-01 00:17:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(3728, 115, '2014-04-01 00:18:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(3729, 115, '2014-04-01 00:20:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3730, 115, '2014-04-01 00:22:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(3731, 115, '2014-04-01 00:24:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(3732, 115, '2014-04-01 00:26:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(3733, 115, '2014-04-01 00:29:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3734, 115, '2014-04-01 00:31:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3735, 115, '2014-04-01 00:33:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(3736, 115, '2014-04-01 00:36:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(3737, 115, '2014-04-01 00:39:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(3738, 115, '2014-04-01 00:42:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(3739, 115, '2014-04-01 00:45:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3740, 115, '2014-04-01 00:47:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(3741, 115, '2014-04-01 00:49:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(3742, 115, '2014-04-01 00:51:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(3743, 115, '2014-04-01 00:54:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(3744, 115, '2014-04-01 00:57:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(3745, 115, '2014-04-01 01:00:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(3746, 115, '2014-04-01 01:03:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(3747, 115, '2014-04-01 01:04:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3748, 115, '2014-04-01 01:07:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(3749, 115, '2014-04-01 01:11:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(3750, 115, '2014-04-01 01:14:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(3751, 115, '2014-04-01 01:17:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(3752, 115, '2014-04-01 01:18:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(3753, 115, '2014-04-01 01:21:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(3754, 115, '2014-04-01 01:24:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(3755, 115, '2014-04-01 01:26:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(3756, 115, '2014-04-01 01:29:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(3757, 115, '2014-04-01 01:31:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(3758, 115, '2014-04-01 01:35:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(3759, 115, '2014-04-01 01:37:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3760, 115, '2014-04-01 01:38:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(3761, 115, '2014-04-01 01:42:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(3762, 115, '2014-04-01 01:45:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(3763, 115, '2014-04-01 01:48:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3764, 115, '2014-04-01 01:51:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(3765, 115, '2014-04-01 01:52:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3766, 115, '2014-04-01 01:55:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3767, 115, '2014-04-01 01:58:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3768, 115, '2014-04-01 02:01:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(3769, 115, '2014-04-01 02:03:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3770, 115, '2014-04-01 02:06:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(3771, 115, '2014-04-01 02:07:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(3772, 115, '2014-04-01 02:11:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(3773, 115, '2014-04-01 02:13:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(3774, 115, '2014-04-01 02:15:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(3775, 115, '2014-04-01 02:17:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(3776, 115, '2014-04-01 02:19:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(3777, 115, '2014-04-01 02:22:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3778, 115, '2014-04-01 02:24:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(3779, 115, '2014-04-01 02:25:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(3780, 115, '2014-04-01 02:28:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(3781, 116, '2014-04-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3782, 116, '2014-04-01 00:01:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(3783, 116, '2014-04-01 00:03:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(3784, 116, '2014-04-01 00:05:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(3785, 116, '2014-04-01 00:07:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(3786, 116, '2014-04-01 00:10:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(3787, 116, '2014-04-01 00:13:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(3788, 116, '2014-04-01 00:17:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(3789, 116, '2014-04-01 00:19:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(3790, 116, '2014-04-01 00:21:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(3791, 116, '2014-04-01 00:25:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(3792, 116, '2014-04-01 00:28:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3793, 116, '2014-04-01 00:30:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3794, 116, '2014-04-01 00:32:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(3795, 116, '2014-04-01 00:36:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(3796, 116, '2014-04-01 00:39:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3797, 116, '2014-04-01 00:41:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3798, 116, '2014-04-01 00:44:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(3799, 116, '2014-04-01 00:47:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(3800, 116, '2014-04-01 00:49:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(3801, 116, '2014-04-01 00:51:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(3802, 116, '2014-04-01 00:53:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(3803, 116, '2014-04-01 00:55:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3804, 116, '2014-04-01 00:58:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(3805, 116, '2014-04-01 01:00:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3806, 116, '2014-04-01 01:03:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(3807, 116, '2014-04-01 01:05:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(3808, 116, '2014-04-01 01:08:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(3809, 116, '2014-04-01 01:12:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3810, 116, '2014-04-01 01:14:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(3811, 116, '2014-04-01 01:16:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(3812, 116, '2014-04-01 01:19:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(3813, 116, '2014-04-01 01:23:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(3814, 116, '2014-04-01 01:25:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(3815, 116, '2014-04-01 01:29:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(3816, 116, '2014-04-01 01:31:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3817, 116, '2014-04-01 01:33:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(3818, 116, '2014-04-01 01:35:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(3819, 116, '2014-04-01 01:38:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(3820, 116, '2014-04-01 01:41:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(3821, 116, '2014-04-01 01:44:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(3822, 116, '2014-04-01 01:45:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(3823, 116, '2014-04-01 01:49:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(3824, 116, '2014-04-01 01:52:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3825, 116, '2014-04-01 01:55:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(3826, 116, '2014-04-01 01:57:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3827, 116, '2014-04-01 02:00:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(3828, 116, '2014-04-01 02:02:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(3829, 116, '2014-04-01 02:04:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3830, 116, '2014-04-01 02:07:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(3831, 116, '2014-04-01 02:10:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(3832, 116, '2014-04-01 02:13:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(3833, 116, '2014-04-01 02:15:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3834, 116, '2014-04-01 02:17:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(3835, 116, '2014-04-01 02:19:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(3836, 116, '2014-04-01 02:23:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3837, 116, '2014-04-01 02:26:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(3838, 116, '2014-04-01 02:28:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(3839, 116, '2014-04-01 02:31:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(3840, 116, '2014-04-01 02:33:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(3841, 117, '2014-04-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3842, 117, '2014-04-01 00:02:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(3843, 117, '2014-04-01 00:05:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3844, 117, '2014-04-01 00:07:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(3845, 117, '2014-04-01 00:08:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(3846, 117, '2014-04-01 00:11:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(3847, 117, '2014-04-01 00:15:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3848, 117, '2014-04-01 00:17:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(3849, 117, '2014-04-01 00:18:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(3850, 117, '2014-04-01 00:21:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(3851, 117, '2014-04-01 00:24:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3852, 117, '2014-04-01 00:26:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(3853, 117, '2014-04-01 00:29:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(3854, 117, '2014-04-01 00:31:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3855, 117, '2014-04-01 00:33:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(3856, 117, '2014-04-01 00:35:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3857, 117, '2014-04-01 00:38:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(3858, 117, '2014-04-01 00:41:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(3859, 117, '2014-04-01 00:44:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3860, 117, '2014-04-01 00:46:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3861, 117, '2014-04-01 00:49:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(3862, 117, '2014-04-01 00:51:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3863, 117, '2014-04-01 00:52:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(3864, 117, '2014-04-01 00:56:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(3865, 117, '2014-04-01 00:58:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(3866, 117, '2014-04-01 01:00:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3867, 117, '2014-04-01 01:03:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3868, 117, '2014-04-01 01:07:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(3869, 117, '2014-04-01 01:09:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(3870, 117, '2014-04-01 01:12:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(3871, 117, '2014-04-01 01:15:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3872, 117, '2014-04-01 01:18:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(3873, 117, '2014-04-01 01:20:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(3874, 117, '2014-04-01 01:22:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(3875, 117, '2014-04-01 01:24:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(3876, 117, '2014-04-01 01:26:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(3877, 117, '2014-04-01 01:29:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3878, 117, '2014-04-01 01:32:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(3879, 117, '2014-04-01 01:34:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(3880, 117, '2014-04-01 01:36:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3881, 117, '2014-04-01 01:38:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(3882, 117, '2014-04-01 01:40:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(3883, 117, '2014-04-01 01:43:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(3884, 117, '2014-04-01 01:46:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(3885, 117, '2014-04-01 01:48:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(3886, 117, '2014-04-01 01:50:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3887, 117, '2014-04-01 01:53:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3888, 117, '2014-04-01 01:56:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(3889, 117, '2014-04-01 01:59:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(3890, 117, '2014-04-01 02:00:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(3891, 117, '2014-04-01 02:02:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(3892, 117, '2014-04-01 02:04:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(3893, 117, '2014-04-01 02:07:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(3894, 117, '2014-04-01 02:09:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(3895, 117, '2014-04-01 02:12:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(3896, 117, '2014-04-01 02:14:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(3897, 117, '2014-04-01 02:17:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(3898, 117, '2014-04-01 02:21:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3899, 117, '2014-04-01 02:24:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(3900, 117, '2014-04-01 02:26:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(3901, 113, '2014-04-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3902, 113, '2014-04-15 00:02:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3903, 113, '2014-04-15 00:04:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(3904, 113, '2014-04-15 00:07:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(3905, 113, '2014-04-15 00:09:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3906, 113, '2014-04-15 00:11:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(3907, 113, '2014-04-15 00:14:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3908, 113, '2014-04-15 00:17:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(3909, 113, '2014-04-15 00:19:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3910, 113, '2014-04-15 00:22:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3911, 113, '2014-04-15 00:25:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(3912, 113, '2014-04-15 00:28:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(3913, 113, '2014-04-15 00:31:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(3914, 113, '2014-04-15 00:34:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(3915, 113, '2014-04-15 00:36:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(3916, 113, '2014-04-15 00:39:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3917, 113, '2014-04-15 00:40:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3918, 113, '2014-04-15 00:42:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(3919, 113, '2014-04-15 00:44:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3920, 113, '2014-04-15 00:47:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(3921, 113, '2014-04-15 00:50:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(3922, 113, '2014-04-15 00:52:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(3923, 113, '2014-04-15 00:55:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3924, 113, '2014-04-15 00:58:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3925, 113, '2014-04-15 01:00:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(3926, 113, '2014-04-15 01:04:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3927, 113, '2014-04-15 01:05:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3928, 113, '2014-04-15 01:08:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(3929, 113, '2014-04-15 01:11:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(3930, 113, '2014-04-15 01:14:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(3931, 113, '2014-04-15 01:16:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(3932, 113, '2014-04-15 01:19:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3933, 113, '2014-04-15 01:21:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(3934, 113, '2014-04-15 01:23:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(3935, 113, '2014-04-15 01:26:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3936, 113, '2014-04-15 01:30:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(3937, 113, '2014-04-15 01:32:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(3938, 113, '2014-04-15 01:34:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3939, 113, '2014-04-15 01:38:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(3940, 113, '2014-04-15 01:41:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(3941, 113, '2014-04-15 01:44:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(3942, 113, '2014-04-15 01:46:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3943, 113, '2014-04-15 01:49:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3944, 113, '2014-04-15 01:52:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(3945, 113, '2014-04-15 01:54:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(3946, 113, '2014-04-15 01:56:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3947, 113, '2014-04-15 01:58:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(3948, 113, '2014-04-15 02:01:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(3949, 113, '2014-04-15 02:03:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(3950, 113, '2014-04-15 02:06:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(3951, 113, '2014-04-15 02:09:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(3952, 113, '2014-04-15 02:11:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(3953, 113, '2014-04-15 02:15:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(3954, 113, '2014-04-15 02:17:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(3955, 113, '2014-04-15 02:18:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(3956, 113, '2014-04-15 02:21:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(3957, 113, '2014-04-15 02:25:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3958, 113, '2014-04-15 02:28:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(3959, 113, '2014-04-15 02:32:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(3960, 113, '2014-04-15 02:35:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(3961, 114, '2014-04-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3962, 114, '2014-04-15 00:01:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3963, 114, '2014-04-15 00:04:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(3964, 114, '2014-04-15 00:06:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3965, 114, '2014-04-15 00:08:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(3966, 114, '2014-04-15 00:11:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(3967, 114, '2014-04-15 00:13:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3968, 114, '2014-04-15 00:15:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(3969, 114, '2014-04-15 00:17:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3970, 114, '2014-04-15 00:19:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(3971, 114, '2014-04-15 00:21:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(3972, 114, '2014-04-15 00:23:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(3973, 114, '2014-04-15 00:27:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(3974, 114, '2014-04-15 00:29:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(3975, 114, '2014-04-15 00:31:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(3976, 114, '2014-04-15 00:35:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3977, 114, '2014-04-15 00:38:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(3978, 114, '2014-04-15 00:41:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(3979, 114, '2014-04-15 00:44:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(3980, 114, '2014-04-15 00:47:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(3981, 114, '2014-04-15 00:49:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(3982, 114, '2014-04-15 00:51:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(3983, 114, '2014-04-15 00:54:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(3984, 114, '2014-04-15 00:57:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(3985, 114, '2014-04-15 01:00:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(3986, 114, '2014-04-15 01:02:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3987, 114, '2014-04-15 01:04:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(3988, 114, '2014-04-15 01:07:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(3989, 114, '2014-04-15 01:10:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(3990, 114, '2014-04-15 01:13:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3991, 114, '2014-04-15 01:16:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(3992, 114, '2014-04-15 01:17:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(3993, 114, '2014-04-15 01:21:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(3994, 114, '2014-04-15 01:23:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3995, 114, '2014-04-15 01:25:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(3996, 114, '2014-04-15 01:26:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(3997, 114, '2014-04-15 01:29:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(3998, 114, '2014-04-15 01:31:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(3999, 114, '2014-04-15 01:34:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(4000, 114, '2014-04-15 01:35:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4001, 114, '2014-04-15 01:38:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(4002, 114, '2014-04-15 01:39:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(4003, 114, '2014-04-15 01:41:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(4004, 114, '2014-04-15 01:44:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(4005, 114, '2014-04-15 01:46:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4006, 114, '2014-04-15 01:49:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4007, 114, '2014-04-15 01:51:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(4008, 114, '2014-04-15 01:54:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(4009, 114, '2014-04-15 01:57:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(4010, 114, '2014-04-15 01:59:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4011, 114, '2014-04-15 02:03:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4012, 114, '2014-04-15 02:05:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(4013, 114, '2014-04-15 02:08:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(4014, 114, '2014-04-15 02:10:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4015, 114, '2014-04-15 02:13:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4016, 114, '2014-04-15 02:14:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4017, 114, '2014-04-15 02:17:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(4018, 114, '2014-04-15 02:19:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(4019, 114, '2014-04-15 02:23:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4020, 114, '2014-04-15 02:26:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(4021, 115, '2014-04-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4022, 115, '2014-04-15 00:03:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4023, 115, '2014-04-15 00:06:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(4024, 115, '2014-04-15 00:09:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4025, 115, '2014-04-15 00:13:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(4026, 115, '2014-04-15 00:15:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(4027, 115, '2014-04-15 00:19:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4028, 115, '2014-04-15 00:22:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4029, 115, '2014-04-15 00:25:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4030, 115, '2014-04-15 00:28:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4031, 115, '2014-04-15 00:32:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(4032, 115, '2014-04-15 00:35:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4033, 115, '2014-04-15 00:36:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(4034, 115, '2014-04-15 00:38:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(4035, 115, '2014-04-15 00:41:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(4036, 115, '2014-04-15 00:45:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(4037, 115, '2014-04-15 00:48:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(4038, 115, '2014-04-15 00:49:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4039, 115, '2014-04-15 00:51:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4040, 115, '2014-04-15 00:55:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4041, 115, '2014-04-15 00:58:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4042, 115, '2014-04-15 01:01:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4043, 115, '2014-04-15 01:05:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(4044, 115, '2014-04-15 01:07:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4045, 115, '2014-04-15 01:09:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4046, 115, '2014-04-15 01:12:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(4047, 115, '2014-04-15 01:15:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(4048, 115, '2014-04-15 01:18:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(4049, 115, '2014-04-15 01:20:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(4050, 115, '2014-04-15 01:22:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(4051, 115, '2014-04-15 01:25:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(4052, 115, '2014-04-15 01:27:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4053, 115, '2014-04-15 01:30:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(4054, 115, '2014-04-15 01:33:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(4055, 115, '2014-04-15 01:37:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4056, 115, '2014-04-15 01:40:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(4057, 115, '2014-04-15 01:43:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(4058, 115, '2014-04-15 01:47:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(4059, 115, '2014-04-15 01:50:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4060, 115, '2014-04-15 01:51:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(4061, 115, '2014-04-15 01:53:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(4062, 115, '2014-04-15 01:57:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(4063, 115, '2014-04-15 01:58:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(4064, 115, '2014-04-15 02:00:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(4065, 115, '2014-04-15 02:02:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4066, 115, '2014-04-15 02:04:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(4067, 115, '2014-04-15 02:08:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4068, 115, '2014-04-15 02:10:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4069, 115, '2014-04-15 02:13:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4070, 115, '2014-04-15 02:15:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(4071, 115, '2014-04-15 02:17:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(4072, 115, '2014-04-15 02:19:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(4073, 115, '2014-04-15 02:21:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4074, 115, '2014-04-15 02:24:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(4075, 115, '2014-04-15 02:28:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4076, 115, '2014-04-15 02:30:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4077, 115, '2014-04-15 02:34:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(4078, 115, '2014-04-15 02:37:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(4079, 115, '2014-04-15 02:38:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(4080, 115, '2014-04-15 02:40:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(4081, 116, '2014-04-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4082, 116, '2014-04-15 00:02:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(4083, 116, '2014-04-15 00:04:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(4084, 116, '2014-04-15 00:07:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4085, 116, '2014-04-15 00:08:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(4086, 116, '2014-04-15 00:12:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(4087, 116, '2014-04-15 00:14:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(4088, 116, '2014-04-15 00:17:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4089, 116, '2014-04-15 00:20:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(4090, 116, '2014-04-15 00:23:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(4091, 116, '2014-04-15 00:25:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(4092, 116, '2014-04-15 00:27:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(4093, 116, '2014-04-15 00:29:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4094, 116, '2014-04-15 00:32:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(4095, 116, '2014-04-15 00:34:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(4096, 116, '2014-04-15 00:37:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4097, 116, '2014-04-15 00:39:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(4098, 116, '2014-04-15 00:42:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(4099, 116, '2014-04-15 00:44:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4100, 116, '2014-04-15 00:47:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(4101, 116, '2014-04-15 00:49:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(4102, 116, '2014-04-15 00:52:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(4103, 116, '2014-04-15 00:55:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(4104, 116, '2014-04-15 00:56:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(4105, 116, '2014-04-15 00:59:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(4106, 116, '2014-04-15 01:02:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4107, 116, '2014-04-15 01:05:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4108, 116, '2014-04-15 01:07:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4109, 116, '2014-04-15 01:10:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(4110, 116, '2014-04-15 01:13:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(4111, 116, '2014-04-15 01:15:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(4112, 116, '2014-04-15 01:18:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(4113, 116, '2014-04-15 01:21:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(4114, 116, '2014-04-15 01:23:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(4115, 116, '2014-04-15 01:25:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4116, 116, '2014-04-15 01:28:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4117, 116, '2014-04-15 01:30:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4118, 116, '2014-04-15 01:32:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(4119, 116, '2014-04-15 01:34:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(4120, 116, '2014-04-15 01:36:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(4121, 116, '2014-04-15 01:38:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(4122, 116, '2014-04-15 01:41:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(4123, 116, '2014-04-15 01:44:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(4124, 116, '2014-04-15 01:45:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4125, 116, '2014-04-15 01:48:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4126, 116, '2014-04-15 01:52:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4127, 116, '2014-04-15 01:54:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4128, 116, '2014-04-15 01:56:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(4129, 116, '2014-04-15 01:58:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(4130, 116, '2014-04-15 02:00:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(4131, 116, '2014-04-15 02:02:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4132, 116, '2014-04-15 02:05:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(4133, 116, '2014-04-15 02:08:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(4134, 116, '2014-04-15 02:11:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(4135, 116, '2014-04-15 02:13:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4136, 116, '2014-04-15 02:15:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(4137, 116, '2014-04-15 02:18:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4138, 116, '2014-04-15 02:21:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4139, 116, '2014-04-15 02:24:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4140, 116, '2014-04-15 02:26:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(4141, 117, '2014-04-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4142, 117, '2014-04-15 00:01:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(4143, 117, '2014-04-15 00:04:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(4144, 117, '2014-04-15 00:08:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4145, 117, '2014-04-15 00:10:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(4146, 117, '2014-04-15 00:14:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4147, 117, '2014-04-15 00:15:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4148, 117, '2014-04-15 00:17:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(4149, 117, '2014-04-15 00:20:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(4150, 117, '2014-04-15 00:23:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(4151, 117, '2014-04-15 00:27:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(4152, 117, '2014-04-15 00:28:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4153, 117, '2014-04-15 00:31:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(4154, 117, '2014-04-15 00:34:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(4155, 117, '2014-04-15 00:35:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(4156, 117, '2014-04-15 00:38:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(4157, 117, '2014-04-15 00:40:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(4158, 117, '2014-04-15 00:43:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(4159, 117, '2014-04-15 00:46:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4160, 117, '2014-04-15 00:49:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(4161, 117, '2014-04-15 00:52:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4162, 117, '2014-04-15 00:55:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4163, 117, '2014-04-15 00:59:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4164, 117, '2014-04-15 01:00:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(4165, 117, '2014-04-15 01:03:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(4166, 117, '2014-04-15 01:06:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4167, 117, '2014-04-15 01:08:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(4168, 117, '2014-04-15 01:11:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(4169, 117, '2014-04-15 01:13:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4170, 117, '2014-04-15 01:14:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4171, 117, '2014-04-15 01:17:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(4172, 117, '2014-04-15 01:21:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(4173, 117, '2014-04-15 01:24:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(4174, 117, '2014-04-15 01:26:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(4175, 117, '2014-04-15 01:28:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4176, 117, '2014-04-15 01:31:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(4177, 117, '2014-04-15 01:33:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4178, 117, '2014-04-15 01:36:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(4179, 117, '2014-04-15 01:38:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(4180, 117, '2014-04-15 01:41:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4181, 117, '2014-04-15 01:44:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(4182, 117, '2014-04-15 01:45:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(4183, 117, '2014-04-15 01:47:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4184, 117, '2014-04-15 01:50:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(4185, 117, '2014-04-15 01:53:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4186, 117, '2014-04-15 01:55:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4187, 117, '2014-04-15 01:57:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(4188, 117, '2014-04-15 02:00:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4189, 117, '2014-04-15 02:01:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(4190, 117, '2014-04-15 02:04:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(4191, 117, '2014-04-15 02:06:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(4192, 117, '2014-04-15 02:10:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(4193, 117, '2014-04-15 02:12:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4194, 117, '2014-04-15 02:13:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(4195, 117, '2014-04-15 02:16:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(4196, 117, '2014-04-15 02:18:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(4197, 117, '2014-04-15 02:20:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4198, 117, '2014-04-15 02:22:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4199, 117, '2014-04-15 02:24:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(4200, 117, '2014-04-15 02:27:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(4201, 137, '2015-01-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4202, 137, '2015-01-01 00:02:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(4203, 137, '2015-01-01 00:04:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(4204, 137, '2015-01-01 00:08:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(4205, 137, '2015-01-01 00:10:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(4206, 137, '2015-01-01 00:12:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(4207, 137, '2015-01-01 00:16:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(4208, 137, '2015-01-01 00:17:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(4209, 137, '2015-01-01 00:21:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(4210, 137, '2015-01-01 00:23:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4211, 137, '2015-01-01 00:25:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(4212, 137, '2015-01-01 00:27:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(4213, 137, '2015-01-01 00:30:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4214, 137, '2015-01-01 00:33:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(4215, 137, '2015-01-01 00:37:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4216, 137, '2015-01-01 00:38:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4217, 137, '2015-01-01 00:41:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(4218, 137, '2015-01-01 00:42:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4219, 137, '2015-01-01 00:46:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(4220, 137, '2015-01-01 00:48:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(4221, 137, '2015-01-01 00:50:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4222, 137, '2015-01-01 00:51:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(4223, 137, '2015-01-01 00:54:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(4224, 137, '2015-01-01 00:55:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(4225, 137, '2015-01-01 00:59:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(4226, 137, '2015-01-01 01:03:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(4227, 137, '2015-01-01 01:06:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4228, 137, '2015-01-01 01:08:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4229, 137, '2015-01-01 01:09:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4230, 137, '2015-01-01 01:13:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4231, 137, '2015-01-01 01:16:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(4232, 137, '2015-01-01 01:18:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4233, 137, '2015-01-01 01:21:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(4234, 137, '2015-01-01 01:25:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4235, 137, '2015-01-01 01:28:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4236, 137, '2015-01-01 01:31:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(4237, 137, '2015-01-01 01:34:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(4238, 137, '2015-01-01 01:38:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(4239, 137, '2015-01-01 01:41:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4240, 137, '2015-01-01 01:44:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(4241, 137, '2015-01-01 01:47:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(4242, 137, '2015-01-01 01:50:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4243, 137, '2015-01-01 01:52:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(4244, 137, '2015-01-01 01:55:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(4245, 137, '2015-01-01 01:57:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4246, 137, '2015-01-01 01:59:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(4247, 137, '2015-01-01 02:03:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(4248, 137, '2015-01-01 02:05:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4249, 137, '2015-01-01 02:08:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(4250, 137, '2015-01-01 02:10:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(4251, 137, '2015-01-01 02:13:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4252, 137, '2015-01-01 02:16:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(4253, 137, '2015-01-01 02:19:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4254, 137, '2015-01-01 02:20:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(4255, 137, '2015-01-01 02:22:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(4256, 137, '2015-01-01 02:25:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4257, 137, '2015-01-01 02:28:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(4258, 137, '2015-01-01 02:31:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(4259, 137, '2015-01-01 02:33:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4260, 137, '2015-01-01 02:36:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4261, 138, '2015-01-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4262, 138, '2015-01-01 00:03:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(4263, 138, '2015-01-01 00:06:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4264, 138, '2015-01-01 00:08:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(4265, 138, '2015-01-01 00:11:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(4266, 138, '2015-01-01 00:12:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(4267, 138, '2015-01-01 00:15:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4268, 138, '2015-01-01 00:18:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(4269, 138, '2015-01-01 00:21:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(4270, 138, '2015-01-01 00:24:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4271, 138, '2015-01-01 00:25:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4272, 138, '2015-01-01 00:28:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(4273, 138, '2015-01-01 00:31:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(4274, 138, '2015-01-01 00:32:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(4275, 138, '2015-01-01 00:34:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4276, 138, '2015-01-01 00:37:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4277, 138, '2015-01-01 00:39:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4278, 138, '2015-01-01 00:43:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4279, 138, '2015-01-01 00:45:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(4280, 138, '2015-01-01 00:48:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(4281, 138, '2015-01-01 00:50:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(4282, 138, '2015-01-01 00:52:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(4283, 138, '2015-01-01 00:54:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(4284, 138, '2015-01-01 00:56:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(4285, 138, '2015-01-01 00:59:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4286, 138, '2015-01-01 01:00:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(4287, 138, '2015-01-01 01:04:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(4288, 138, '2015-01-01 01:06:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(4289, 138, '2015-01-01 01:08:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4290, 138, '2015-01-01 01:10:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(4291, 138, '2015-01-01 01:11:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(4292, 138, '2015-01-01 01:14:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(4293, 138, '2015-01-01 01:16:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(4294, 138, '2015-01-01 01:18:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4295, 138, '2015-01-01 01:20:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(4296, 138, '2015-01-01 01:23:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(4297, 138, '2015-01-01 01:26:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4298, 138, '2015-01-01 01:27:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4299, 138, '2015-01-01 01:30:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(4300, 138, '2015-01-01 01:32:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(4301, 138, '2015-01-01 01:36:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(4302, 138, '2015-01-01 01:38:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(4303, 138, '2015-01-01 01:40:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4304, 138, '2015-01-01 01:42:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(4305, 138, '2015-01-01 01:43:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4306, 138, '2015-01-01 01:46:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(4307, 138, '2015-01-01 01:48:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(4308, 138, '2015-01-01 01:51:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(4309, 138, '2015-01-01 01:52:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(4310, 138, '2015-01-01 01:54:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(4311, 138, '2015-01-01 01:57:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(4312, 138, '2015-01-01 01:59:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(4313, 138, '2015-01-01 02:02:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(4314, 138, '2015-01-01 02:04:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(4315, 138, '2015-01-01 02:06:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(4316, 138, '2015-01-01 02:09:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(4317, 138, '2015-01-01 02:12:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(4318, 138, '2015-01-01 02:13:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4319, 138, '2015-01-01 02:16:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(4320, 138, '2015-01-01 02:18:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4321, 139, '2015-01-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4322, 139, '2015-01-01 00:03:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4323, 139, '2015-01-01 00:06:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(4324, 139, '2015-01-01 00:09:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(4325, 139, '2015-01-01 00:12:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4326, 139, '2015-01-01 00:16:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(4327, 139, '2015-01-01 00:18:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(4328, 139, '2015-01-01 00:21:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(4329, 139, '2015-01-01 00:24:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(4330, 139, '2015-01-01 00:26:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(4331, 139, '2015-01-01 00:28:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(4332, 139, '2015-01-01 00:30:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(4333, 139, '2015-01-01 00:33:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(4334, 139, '2015-01-01 00:35:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4335, 139, '2015-01-01 00:38:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(4336, 139, '2015-01-01 00:42:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(4337, 139, '2015-01-01 00:44:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4338, 139, '2015-01-01 00:48:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(4339, 139, '2015-01-01 00:50:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(4340, 139, '2015-01-01 00:52:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4341, 139, '2015-01-01 00:55:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(4342, 139, '2015-01-01 00:58:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(4343, 139, '2015-01-01 01:00:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(4344, 139, '2015-01-01 01:01:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(4345, 139, '2015-01-01 01:04:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4346, 139, '2015-01-01 01:06:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(4347, 139, '2015-01-01 01:08:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4348, 139, '2015-01-01 01:10:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(4349, 139, '2015-01-01 01:12:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(4350, 139, '2015-01-01 01:14:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(4351, 139, '2015-01-01 01:18:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4352, 139, '2015-01-01 01:21:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(4353, 139, '2015-01-01 01:24:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(4354, 139, '2015-01-01 01:28:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4355, 139, '2015-01-01 01:31:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4356, 139, '2015-01-01 01:33:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(4357, 139, '2015-01-01 01:35:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(4358, 139, '2015-01-01 01:37:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(4359, 139, '2015-01-01 01:39:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4360, 139, '2015-01-01 01:41:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(4361, 139, '2015-01-01 01:43:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(4362, 139, '2015-01-01 01:46:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4363, 139, '2015-01-01 01:50:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(4364, 139, '2015-01-01 01:52:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(4365, 139, '2015-01-01 01:55:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4366, 139, '2015-01-01 01:57:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(4367, 139, '2015-01-01 02:01:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4368, 139, '2015-01-01 02:03:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4369, 139, '2015-01-01 02:06:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(4370, 139, '2015-01-01 02:08:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(4371, 139, '2015-01-01 02:11:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(4372, 139, '2015-01-01 02:14:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(4373, 139, '2015-01-01 02:17:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(4374, 139, '2015-01-01 02:19:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(4375, 139, '2015-01-01 02:22:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4376, 139, '2015-01-01 02:24:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(4377, 139, '2015-01-01 02:27:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4378, 139, '2015-01-01 02:30:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(4379, 139, '2015-01-01 02:33:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(4380, 139, '2015-01-01 02:35:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(4381, 140, '2015-01-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4382, 140, '2015-01-01 00:01:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4383, 140, '2015-01-01 00:03:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(4384, 140, '2015-01-01 00:06:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(4385, 140, '2015-01-01 00:09:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(4386, 140, '2015-01-01 00:12:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4387, 140, '2015-01-01 00:15:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(4388, 140, '2015-01-01 00:18:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(4389, 140, '2015-01-01 00:21:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(4390, 140, '2015-01-01 00:23:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4391, 140, '2015-01-01 00:25:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(4392, 140, '2015-01-01 00:28:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(4393, 140, '2015-01-01 00:30:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(4394, 140, '2015-01-01 00:32:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(4395, 140, '2015-01-01 00:35:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4396, 140, '2015-01-01 00:38:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4397, 140, '2015-01-01 00:41:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(4398, 140, '2015-01-01 00:44:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(4399, 140, '2015-01-01 00:47:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(4400, 140, '2015-01-01 00:50:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(4401, 140, '2015-01-01 00:53:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(4402, 140, '2015-01-01 00:56:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4403, 140, '2015-01-01 00:57:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4404, 140, '2015-01-01 01:01:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(4405, 140, '2015-01-01 01:04:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(4406, 140, '2015-01-01 01:06:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(4407, 140, '2015-01-01 01:08:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4408, 140, '2015-01-01 01:10:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(4409, 140, '2015-01-01 01:12:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(4410, 140, '2015-01-01 01:13:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(4411, 140, '2015-01-01 01:15:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4412, 140, '2015-01-01 01:18:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(4413, 140, '2015-01-01 01:21:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(4414, 140, '2015-01-01 01:24:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(4415, 140, '2015-01-01 01:26:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(4416, 140, '2015-01-01 01:29:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4417, 140, '2015-01-01 01:31:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(4418, 140, '2015-01-01 01:33:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(4419, 140, '2015-01-01 01:36:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(4420, 140, '2015-01-01 01:38:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(4421, 140, '2015-01-01 01:41:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(4422, 140, '2015-01-01 01:43:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(4423, 140, '2015-01-01 01:46:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(4424, 140, '2015-01-01 01:49:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(4425, 140, '2015-01-01 01:53:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(4426, 140, '2015-01-01 01:55:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4427, 140, '2015-01-01 01:59:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(4428, 140, '2015-01-01 02:02:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4429, 140, '2015-01-01 02:05:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4430, 140, '2015-01-01 02:08:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4431, 140, '2015-01-01 02:10:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4432, 140, '2015-01-01 02:13:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4433, 140, '2015-01-01 02:15:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(4434, 140, '2015-01-01 02:18:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4435, 140, '2015-01-01 02:21:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4436, 140, '2015-01-01 02:23:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(4437, 140, '2015-01-01 02:25:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(4438, 140, '2015-01-01 02:29:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(4439, 140, '2015-01-01 02:32:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(4440, 140, '2015-01-01 02:34:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4441, 141, '2015-01-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4442, 141, '2015-01-01 00:02:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4443, 141, '2015-01-01 00:06:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(4444, 141, '2015-01-01 00:07:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(4445, 141, '2015-01-01 00:11:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(4446, 141, '2015-01-01 00:12:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4447, 141, '2015-01-01 00:16:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(4448, 141, '2015-01-01 00:18:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(4449, 141, '2015-01-01 00:21:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(4450, 141, '2015-01-01 00:23:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(4451, 141, '2015-01-01 00:25:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4452, 141, '2015-01-01 00:28:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(4453, 141, '2015-01-01 00:31:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4454, 141, '2015-01-01 00:34:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(4455, 141, '2015-01-01 00:36:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4456, 141, '2015-01-01 00:39:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(4457, 141, '2015-01-01 00:41:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(4458, 141, '2015-01-01 00:44:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(4459, 141, '2015-01-01 00:48:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(4460, 141, '2015-01-01 00:50:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4461, 141, '2015-01-01 00:54:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4462, 141, '2015-01-01 00:57:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(4463, 141, '2015-01-01 00:59:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(4464, 141, '2015-01-01 01:02:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(4465, 141, '2015-01-01 01:05:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(4466, 141, '2015-01-01 01:07:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(4467, 141, '2015-01-01 01:09:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4468, 141, '2015-01-01 01:11:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(4469, 141, '2015-01-01 01:13:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(4470, 141, '2015-01-01 01:15:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(4471, 141, '2015-01-01 01:17:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(4472, 141, '2015-01-01 01:20:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(4473, 141, '2015-01-01 01:23:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4474, 141, '2015-01-01 01:25:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(4475, 141, '2015-01-01 01:27:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(4476, 141, '2015-01-01 01:30:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(4477, 141, '2015-01-01 01:33:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(4478, 141, '2015-01-01 01:35:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4479, 141, '2015-01-01 01:38:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4480, 141, '2015-01-01 01:40:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(4481, 141, '2015-01-01 01:42:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(4482, 141, '2015-01-01 01:44:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(4483, 141, '2015-01-01 01:47:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4484, 141, '2015-01-01 01:50:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(4485, 141, '2015-01-01 01:52:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4486, 141, '2015-01-01 01:55:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(4487, 141, '2015-01-01 01:58:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4488, 141, '2015-01-01 01:59:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(4489, 141, '2015-01-01 02:02:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(4490, 141, '2015-01-01 02:04:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(4491, 141, '2015-01-01 02:08:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(4492, 141, '2015-01-01 02:10:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(4493, 141, '2015-01-01 02:13:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(4494, 141, '2015-01-01 02:16:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(4495, 141, '2015-01-01 02:19:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(4496, 141, '2015-01-01 02:21:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4497, 141, '2015-01-01 02:25:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(4498, 141, '2015-01-01 02:27:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(4499, 141, '2015-01-01 02:29:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(4500, 141, '2015-01-01 02:31:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4501, 137, '2015-01-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4502, 137, '2015-01-15 00:02:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(4503, 137, '2015-01-15 00:05:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(4504, 137, '2015-01-15 00:06:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(4505, 137, '2015-01-15 00:10:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(4506, 137, '2015-01-15 00:12:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(4507, 137, '2015-01-15 00:14:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(4508, 137, '2015-01-15 00:16:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(4509, 137, '2015-01-15 00:19:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4510, 137, '2015-01-15 00:21:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(4511, 137, '2015-01-15 00:24:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(4512, 137, '2015-01-15 00:28:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(4513, 137, '2015-01-15 00:31:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(4514, 137, '2015-01-15 00:35:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(4515, 137, '2015-01-15 00:37:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4516, 137, '2015-01-15 00:39:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(4517, 137, '2015-01-15 00:42:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4518, 137, '2015-01-15 00:45:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(4519, 137, '2015-01-15 00:49:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(4520, 137, '2015-01-15 00:51:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(4521, 137, '2015-01-15 00:53:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4522, 137, '2015-01-15 00:55:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(4523, 137, '2015-01-15 00:58:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(4524, 137, '2015-01-15 01:00:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(4525, 137, '2015-01-15 01:02:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(4526, 137, '2015-01-15 01:06:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(4527, 137, '2015-01-15 01:09:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(4528, 137, '2015-01-15 01:13:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(4529, 137, '2015-01-15 01:15:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4530, 137, '2015-01-15 01:19:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(4531, 137, '2015-01-15 01:23:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(4532, 137, '2015-01-15 01:24:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(4533, 137, '2015-01-15 01:26:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(4534, 137, '2015-01-15 01:29:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(4535, 137, '2015-01-15 01:31:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4536, 137, '2015-01-15 01:34:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4537, 137, '2015-01-15 01:36:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(4538, 137, '2015-01-15 01:39:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(4539, 137, '2015-01-15 01:41:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(4540, 137, '2015-01-15 01:43:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(4541, 137, '2015-01-15 01:45:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(4542, 137, '2015-01-15 01:48:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(4543, 137, '2015-01-15 01:51:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4544, 137, '2015-01-15 01:54:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(4545, 137, '2015-01-15 01:56:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4546, 137, '2015-01-15 01:59:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4547, 137, '2015-01-15 02:03:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4548, 137, '2015-01-15 02:05:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(4549, 137, '2015-01-15 02:08:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(4550, 137, '2015-01-15 02:12:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(4551, 137, '2015-01-15 02:16:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4552, 137, '2015-01-15 02:19:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(4553, 137, '2015-01-15 02:23:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(4554, 137, '2015-01-15 02:25:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(4555, 137, '2015-01-15 02:28:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(4556, 137, '2015-01-15 02:29:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(4557, 137, '2015-01-15 02:32:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4558, 137, '2015-01-15 02:36:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4559, 137, '2015-01-15 02:38:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4560, 137, '2015-01-15 02:40:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(4561, 138, '2015-01-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4562, 138, '2015-01-15 00:02:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(4563, 138, '2015-01-15 00:04:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4564, 138, '2015-01-15 00:06:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4565, 138, '2015-01-15 00:09:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4566, 138, '2015-01-15 00:12:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(4567, 138, '2015-01-15 00:15:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(4568, 138, '2015-01-15 00:19:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(4569, 138, '2015-01-15 00:21:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4570, 138, '2015-01-15 00:25:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(4571, 138, '2015-01-15 00:28:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(4572, 138, '2015-01-15 00:30:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(4573, 138, '2015-01-15 00:33:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4574, 138, '2015-01-15 00:36:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4575, 138, '2015-01-15 00:38:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(4576, 138, '2015-01-15 00:41:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4577, 138, '2015-01-15 00:44:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(4578, 138, '2015-01-15 00:47:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4579, 138, '2015-01-15 00:49:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(4580, 138, '2015-01-15 00:53:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(4581, 138, '2015-01-15 00:55:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4582, 138, '2015-01-15 00:57:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(4583, 138, '2015-01-15 00:59:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(4584, 138, '2015-01-15 01:02:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(4585, 138, '2015-01-15 01:05:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(4586, 138, '2015-01-15 01:07:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4587, 138, '2015-01-15 01:10:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(4588, 138, '2015-01-15 01:14:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4589, 138, '2015-01-15 01:15:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(4590, 138, '2015-01-15 01:18:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4591, 138, '2015-01-15 01:21:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(4592, 138, '2015-01-15 01:23:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4593, 138, '2015-01-15 01:27:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4594, 138, '2015-01-15 01:29:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4595, 138, '2015-01-15 01:32:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4596, 138, '2015-01-15 01:35:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(4597, 138, '2015-01-15 01:38:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(4598, 138, '2015-01-15 01:41:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4599, 138, '2015-01-15 01:44:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(4600, 138, '2015-01-15 01:46:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(4601, 138, '2015-01-15 01:48:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(4602, 138, '2015-01-15 01:51:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(4603, 138, '2015-01-15 01:54:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(4604, 138, '2015-01-15 01:56:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(4605, 138, '2015-01-15 02:00:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(4606, 138, '2015-01-15 02:01:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4607, 138, '2015-01-15 02:04:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4608, 138, '2015-01-15 02:07:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4609, 138, '2015-01-15 02:10:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(4610, 138, '2015-01-15 02:12:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(4611, 138, '2015-01-15 02:14:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(4612, 138, '2015-01-15 02:16:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4613, 138, '2015-01-15 02:19:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(4614, 138, '2015-01-15 02:22:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(4615, 138, '2015-01-15 02:24:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4616, 138, '2015-01-15 02:25:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(4617, 138, '2015-01-15 02:28:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(4618, 138, '2015-01-15 02:30:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(4619, 138, '2015-01-15 02:32:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4620, 138, '2015-01-15 02:34:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(4621, 139, '2015-01-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4622, 139, '2015-01-15 00:02:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4623, 139, '2015-01-15 00:03:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4624, 139, '2015-01-15 00:06:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4625, 139, '2015-01-15 00:09:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4626, 139, '2015-01-15 00:12:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(4627, 139, '2015-01-15 00:16:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(4628, 139, '2015-01-15 00:18:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(4629, 139, '2015-01-15 00:22:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4630, 139, '2015-01-15 00:25:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(4631, 139, '2015-01-15 00:27:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(4632, 139, '2015-01-15 00:30:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4633, 139, '2015-01-15 00:33:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4634, 139, '2015-01-15 00:34:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(4635, 139, '2015-01-15 00:36:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(4636, 139, '2015-01-15 00:38:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4637, 139, '2015-01-15 00:39:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(4638, 139, '2015-01-15 00:43:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(4639, 139, '2015-01-15 00:46:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(4640, 139, '2015-01-15 00:49:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(4641, 139, '2015-01-15 00:51:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(4642, 139, '2015-01-15 00:54:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4643, 139, '2015-01-15 00:58:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4644, 139, '2015-01-15 00:59:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(4645, 139, '2015-01-15 01:02:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4646, 139, '2015-01-15 01:05:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(4647, 139, '2015-01-15 01:09:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(4648, 139, '2015-01-15 01:11:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(4649, 139, '2015-01-15 01:14:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(4650, 139, '2015-01-15 01:16:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4651, 139, '2015-01-15 01:19:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(4652, 139, '2015-01-15 01:23:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(4653, 139, '2015-01-15 01:25:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(4654, 139, '2015-01-15 01:28:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(4655, 139, '2015-01-15 01:30:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(4656, 139, '2015-01-15 01:34:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4657, 139, '2015-01-15 01:37:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(4658, 139, '2015-01-15 01:39:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4659, 139, '2015-01-15 01:42:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(4660, 139, '2015-01-15 01:45:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(4661, 139, '2015-01-15 01:47:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(4662, 139, '2015-01-15 01:49:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(4663, 139, '2015-01-15 01:51:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4664, 139, '2015-01-15 01:54:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4665, 139, '2015-01-15 01:57:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(4666, 139, '2015-01-15 01:59:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(4667, 139, '2015-01-15 02:01:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4668, 139, '2015-01-15 02:04:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(4669, 139, '2015-01-15 02:06:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(4670, 139, '2015-01-15 02:09:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(4671, 139, '2015-01-15 02:12:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(4672, 139, '2015-01-15 02:15:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(4673, 139, '2015-01-15 02:18:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4674, 139, '2015-01-15 02:20:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(4675, 139, '2015-01-15 02:23:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(4676, 139, '2015-01-15 02:25:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(4677, 139, '2015-01-15 02:28:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4678, 139, '2015-01-15 02:30:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4679, 139, '2015-01-15 02:32:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4680, 139, '2015-01-15 02:35:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4681, 140, '2015-01-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4682, 140, '2015-01-15 00:02:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(4683, 140, '2015-01-15 00:06:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4684, 140, '2015-01-15 00:08:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(4685, 140, '2015-01-15 00:11:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(4686, 140, '2015-01-15 00:14:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(4687, 140, '2015-01-15 00:17:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(4688, 140, '2015-01-15 00:19:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(4689, 140, '2015-01-15 00:21:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(4690, 140, '2015-01-15 00:23:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(4691, 140, '2015-01-15 00:27:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(4692, 140, '2015-01-15 00:30:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(4693, 140, '2015-01-15 00:34:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(4694, 140, '2015-01-15 00:36:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(4695, 140, '2015-01-15 00:38:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(4696, 140, '2015-01-15 00:40:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(4697, 140, '2015-01-15 00:43:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(4698, 140, '2015-01-15 00:46:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(4699, 140, '2015-01-15 00:48:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(4700, 140, '2015-01-15 00:52:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(4701, 140, '2015-01-15 00:55:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(4702, 140, '2015-01-15 00:57:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(4703, 140, '2015-01-15 01:00:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4704, 140, '2015-01-15 01:03:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(4705, 140, '2015-01-15 01:06:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(4706, 140, '2015-01-15 01:09:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(4707, 140, '2015-01-15 01:11:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(4708, 140, '2015-01-15 01:15:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(4709, 140, '2015-01-15 01:17:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4710, 140, '2015-01-15 01:19:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(4711, 140, '2015-01-15 01:22:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4712, 140, '2015-01-15 01:25:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(4713, 140, '2015-01-15 01:28:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4714, 140, '2015-01-15 01:31:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(4715, 140, '2015-01-15 01:33:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4716, 140, '2015-01-15 01:36:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(4717, 140, '2015-01-15 01:39:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(4718, 140, '2015-01-15 01:41:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(4719, 140, '2015-01-15 01:44:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4720, 140, '2015-01-15 01:47:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(4721, 140, '2015-01-15 01:49:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(4722, 140, '2015-01-15 01:51:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(4723, 140, '2015-01-15 01:54:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4724, 140, '2015-01-15 01:56:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(4725, 140, '2015-01-15 01:59:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(4726, 140, '2015-01-15 02:03:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4727, 140, '2015-01-15 02:05:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(4728, 140, '2015-01-15 02:08:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(4729, 140, '2015-01-15 02:10:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(4730, 140, '2015-01-15 02:13:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(4731, 140, '2015-01-15 02:15:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(4732, 140, '2015-01-15 02:18:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4733, 140, '2015-01-15 02:20:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(4734, 140, '2015-01-15 02:24:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(4735, 140, '2015-01-15 02:27:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(4736, 140, '2015-01-15 02:29:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4737, 140, '2015-01-15 02:32:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4738, 140, '2015-01-15 02:36:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4739, 140, '2015-01-15 02:39:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(4740, 140, '2015-01-15 02:43:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(4741, 141, '2015-01-15 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4742, 141, '2015-01-15 00:01:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(4743, 141, '2015-01-15 00:04:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(4744, 141, '2015-01-15 00:07:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(4745, 141, '2015-01-15 00:10:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4746, 141, '2015-01-15 00:11:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4747, 141, '2015-01-15 00:13:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(4748, 141, '2015-01-15 00:16:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(4749, 141, '2015-01-15 00:18:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4750, 141, '2015-01-15 00:20:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(4751, 141, '2015-01-15 00:21:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(4752, 141, '2015-01-15 00:24:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(4753, 141, '2015-01-15 00:28:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(4754, 141, '2015-01-15 00:32:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4755, 141, '2015-01-15 00:35:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(4756, 141, '2015-01-15 00:38:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(4757, 141, '2015-01-15 00:40:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4758, 141, '2015-01-15 00:43:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(4759, 141, '2015-01-15 00:45:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(4760, 141, '2015-01-15 00:49:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4761, 141, '2015-01-15 00:52:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4762, 141, '2015-01-15 00:55:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4763, 141, '2015-01-15 00:59:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(4764, 141, '2015-01-15 01:01:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(4765, 141, '2015-01-15 01:04:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(4766, 141, '2015-01-15 01:06:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(4767, 141, '2015-01-15 01:07:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4768, 141, '2015-01-15 01:10:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(4769, 141, '2015-01-15 01:13:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(4770, 141, '2015-01-15 01:15:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4771, 141, '2015-01-15 01:18:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(4772, 141, '2015-01-15 01:21:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(4773, 141, '2015-01-15 01:23:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4774, 141, '2015-01-15 01:26:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(4775, 141, '2015-01-15 01:27:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4776, 141, '2015-01-15 01:30:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4777, 141, '2015-01-15 01:32:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4778, 141, '2015-01-15 01:35:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(4779, 141, '2015-01-15 01:38:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(4780, 141, '2015-01-15 01:41:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(4781, 141, '2015-01-15 01:43:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(4782, 141, '2015-01-15 01:45:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4783, 141, '2015-01-15 01:48:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(4784, 141, '2015-01-15 01:51:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4785, 141, '2015-01-15 01:54:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(4786, 141, '2015-01-15 01:57:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(4787, 141, '2015-01-15 02:00:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4788, 141, '2015-01-15 02:03:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4789, 141, '2015-01-15 02:05:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(4790, 141, '2015-01-15 02:08:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(4791, 141, '2015-01-15 02:10:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(4792, 141, '2015-01-15 02:13:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4793, 141, '2015-01-15 02:16:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(4794, 141, '2015-01-15 02:18:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4795, 141, '2015-01-15 02:21:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(4796, 141, '2015-01-15 02:25:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(4797, 141, '2015-01-15 02:29:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(4798, 141, '2015-01-15 02:32:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(4799, 141, '2015-01-15 02:35:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4800, 141, '2015-01-15 02:38:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(4801, 137, '2015-02-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4802, 137, '2015-02-01 00:03:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4803, 137, '2015-02-01 00:05:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4804, 137, '2015-02-01 00:07:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(4805, 137, '2015-02-01 00:09:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(4806, 137, '2015-02-01 00:11:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4807, 137, '2015-02-01 00:13:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(4808, 137, '2015-02-01 00:16:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(4809, 137, '2015-02-01 00:20:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4810, 137, '2015-02-01 00:23:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(4811, 137, '2015-02-01 00:25:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(4812, 137, '2015-02-01 00:28:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(4813, 137, '2015-02-01 00:32:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(4814, 137, '2015-02-01 00:35:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(4815, 137, '2015-02-01 00:37:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4816, 137, '2015-02-01 00:40:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4817, 137, '2015-02-01 00:43:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4818, 137, '2015-02-01 00:45:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(4819, 137, '2015-02-01 00:47:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(4820, 137, '2015-02-01 00:49:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(4821, 137, '2015-02-01 00:51:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(4822, 137, '2015-02-01 00:54:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(4823, 137, '2015-02-01 00:57:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(4824, 137, '2015-02-01 01:00:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(4825, 137, '2015-02-01 01:01:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(4826, 137, '2015-02-01 01:05:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(4827, 137, '2015-02-01 01:08:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(4828, 137, '2015-02-01 01:12:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(4829, 137, '2015-02-01 01:14:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(4830, 137, '2015-02-01 01:16:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(4831, 137, '2015-02-01 01:20:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(4832, 137, '2015-02-01 01:22:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(4833, 137, '2015-02-01 01:24:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(4834, 137, '2015-02-01 01:26:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4835, 137, '2015-02-01 01:28:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(4836, 137, '2015-02-01 01:29:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4837, 137, '2015-02-01 01:32:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4838, 137, '2015-02-01 01:35:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4839, 137, '2015-02-01 01:36:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4840, 137, '2015-02-01 01:39:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4841, 137, '2015-02-01 01:43:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4842, 137, '2015-02-01 01:46:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(4843, 137, '2015-02-01 01:49:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(4844, 137, '2015-02-01 01:52:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4845, 137, '2015-02-01 01:55:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(4846, 137, '2015-02-01 01:58:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(4847, 137, '2015-02-01 02:01:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(4848, 137, '2015-02-01 02:04:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4849, 137, '2015-02-01 02:06:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(4850, 137, '2015-02-01 02:08:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(4851, 137, '2015-02-01 02:10:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(4852, 137, '2015-02-01 02:13:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4853, 137, '2015-02-01 02:15:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(4854, 137, '2015-02-01 02:17:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4855, 137, '2015-02-01 02:20:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(4856, 137, '2015-02-01 02:22:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4857, 137, '2015-02-01 02:26:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(4858, 137, '2015-02-01 02:27:55.000000', 'temps per volta', 10000.0000, 'ms'),
	(4859, 137, '2015-02-01 02:31:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(4860, 137, '2015-02-01 02:34:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4861, 138, '2015-02-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4862, 138, '2015-02-01 00:02:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4863, 138, '2015-02-01 00:05:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(4864, 138, '2015-02-01 00:07:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(4865, 138, '2015-02-01 00:09:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(4866, 138, '2015-02-01 00:11:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(4867, 138, '2015-02-01 00:14:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(4868, 138, '2015-02-01 00:18:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(4869, 138, '2015-02-01 00:20:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(4870, 138, '2015-02-01 00:23:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(4871, 138, '2015-02-01 00:24:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(4872, 138, '2015-02-01 00:28:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(4873, 138, '2015-02-01 00:30:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(4874, 138, '2015-02-01 00:32:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(4875, 138, '2015-02-01 00:35:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(4876, 138, '2015-02-01 00:38:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4877, 138, '2015-02-01 00:42:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4878, 138, '2015-02-01 00:44:32.000000', 'temps per volta', 10000.0000, 'ms'),
	(4879, 138, '2015-02-01 00:47:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(4880, 138, '2015-02-01 00:49:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(4881, 138, '2015-02-01 00:51:36.000000', 'temps per volta', 10000.0000, 'ms'),
	(4882, 138, '2015-02-01 00:53:06.000000', 'temps per volta', 10000.0000, 'ms'),
	(4883, 138, '2015-02-01 00:56:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4884, 138, '2015-02-01 01:00:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(4885, 138, '2015-02-01 01:02:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(4886, 138, '2015-02-01 01:04:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(4887, 138, '2015-02-01 01:07:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4888, 138, '2015-02-01 01:10:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(4889, 138, '2015-02-01 01:12:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(4890, 138, '2015-02-01 01:13:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(4891, 138, '2015-02-01 01:15:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(4892, 138, '2015-02-01 01:18:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4893, 138, '2015-02-01 01:19:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(4894, 138, '2015-02-01 01:22:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(4895, 138, '2015-02-01 01:25:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(4896, 138, '2015-02-01 01:27:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4897, 138, '2015-02-01 01:30:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4898, 138, '2015-02-01 01:32:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4899, 138, '2015-02-01 01:36:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(4900, 138, '2015-02-01 01:37:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4901, 138, '2015-02-01 01:40:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(4902, 138, '2015-02-01 01:42:54.000000', 'temps per volta', 10000.0000, 'ms'),
	(4903, 138, '2015-02-01 01:45:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(4904, 138, '2015-02-01 01:47:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4905, 138, '2015-02-01 01:50:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(4906, 138, '2015-02-01 01:54:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4907, 138, '2015-02-01 01:56:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(4908, 138, '2015-02-01 01:59:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(4909, 138, '2015-02-01 02:02:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4910, 138, '2015-02-01 02:05:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(4911, 138, '2015-02-01 02:08:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(4912, 138, '2015-02-01 02:11:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4913, 138, '2015-02-01 02:13:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4914, 138, '2015-02-01 02:16:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(4915, 138, '2015-02-01 02:20:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(4916, 138, '2015-02-01 02:22:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(4917, 138, '2015-02-01 02:25:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(4918, 138, '2015-02-01 02:29:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(4919, 138, '2015-02-01 02:30:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(4920, 138, '2015-02-01 02:32:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(4921, 139, '2015-02-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4922, 139, '2015-02-01 00:02:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(4923, 139, '2015-02-01 00:04:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4924, 139, '2015-02-01 00:06:23.000000', 'temps per volta', 10000.0000, 'ms'),
	(4925, 139, '2015-02-01 00:09:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4926, 139, '2015-02-01 00:11:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4927, 139, '2015-02-01 00:15:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(4928, 139, '2015-02-01 00:17:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(4929, 139, '2015-02-01 00:21:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(4930, 139, '2015-02-01 00:23:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(4931, 139, '2015-02-01 00:26:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4932, 139, '2015-02-01 00:27:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(4933, 139, '2015-02-01 00:30:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(4934, 139, '2015-02-01 00:32:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(4935, 139, '2015-02-01 00:35:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(4936, 139, '2015-02-01 00:38:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(4937, 139, '2015-02-01 00:41:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4938, 139, '2015-02-01 00:43:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(4939, 139, '2015-02-01 00:46:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(4940, 139, '2015-02-01 00:50:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(4941, 139, '2015-02-01 00:52:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(4942, 139, '2015-02-01 00:54:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4943, 139, '2015-02-01 00:56:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(4944, 139, '2015-02-01 00:58:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(4945, 139, '2015-02-01 01:00:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(4946, 139, '2015-02-01 01:04:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4947, 139, '2015-02-01 01:06:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(4948, 139, '2015-02-01 01:09:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(4949, 139, '2015-02-01 01:12:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4950, 139, '2015-02-01 01:15:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4951, 139, '2015-02-01 01:18:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(4952, 139, '2015-02-01 01:20:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4953, 139, '2015-02-01 01:22:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(4954, 139, '2015-02-01 01:24:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(4955, 139, '2015-02-01 01:26:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(4956, 139, '2015-02-01 01:28:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(4957, 139, '2015-02-01 01:32:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(4958, 139, '2015-02-01 01:35:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(4959, 139, '2015-02-01 01:39:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(4960, 139, '2015-02-01 01:42:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(4961, 139, '2015-02-01 01:44:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(4962, 139, '2015-02-01 01:47:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4963, 139, '2015-02-01 01:51:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4964, 139, '2015-02-01 01:54:46.000000', 'temps per volta', 10000.0000, 'ms'),
	(4965, 139, '2015-02-01 01:57:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(4966, 139, '2015-02-01 02:00:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(4967, 139, '2015-02-01 02:03:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(4968, 139, '2015-02-01 02:05:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(4969, 139, '2015-02-01 02:08:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4970, 139, '2015-02-01 02:12:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(4971, 139, '2015-02-01 02:14:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(4972, 139, '2015-02-01 02:16:12.000000', 'temps per volta', 10000.0000, 'ms'),
	(4973, 139, '2015-02-01 02:17:57.000000', 'temps per volta', 10000.0000, 'ms'),
	(4974, 139, '2015-02-01 02:21:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(4975, 139, '2015-02-01 02:24:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4976, 139, '2015-02-01 02:27:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(4977, 139, '2015-02-01 02:30:26.000000', 'temps per volta', 10000.0000, 'ms'),
	(4978, 139, '2015-02-01 02:33:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(4979, 139, '2015-02-01 02:37:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(4980, 139, '2015-02-01 02:39:37.000000', 'temps per volta', 10000.0000, 'ms'),
	(4981, 140, '2015-02-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(4982, 140, '2015-02-01 00:01:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(4983, 140, '2015-02-01 00:04:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(4984, 140, '2015-02-01 00:07:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(4985, 140, '2015-02-01 00:10:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(4986, 140, '2015-02-01 00:12:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(4987, 140, '2015-02-01 00:15:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(4988, 140, '2015-02-01 00:18:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(4989, 140, '2015-02-01 00:20:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(4990, 140, '2015-02-01 00:24:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(4991, 140, '2015-02-01 00:27:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(4992, 140, '2015-02-01 00:31:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(4993, 140, '2015-02-01 00:34:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(4994, 140, '2015-02-01 00:36:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(4995, 140, '2015-02-01 00:38:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(4996, 140, '2015-02-01 00:42:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(4997, 140, '2015-02-01 00:44:42.000000', 'temps per volta', 10000.0000, 'ms'),
	(4998, 140, '2015-02-01 00:47:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(4999, 140, '2015-02-01 00:49:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(5000, 140, '2015-02-01 00:51:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(5001, 140, '2015-02-01 00:53:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(5002, 140, '2015-02-01 00:55:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(5003, 140, '2015-02-01 00:58:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(5004, 140, '2015-02-01 01:01:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(5005, 140, '2015-02-01 01:05:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(5006, 140, '2015-02-01 01:07:24.000000', 'temps per volta', 10000.0000, 'ms'),
	(5007, 140, '2015-02-01 01:10:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(5008, 140, '2015-02-01 01:13:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(5009, 140, '2015-02-01 01:17:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(5010, 140, '2015-02-01 01:19:48.000000', 'temps per volta', 10000.0000, 'ms'),
	(5011, 140, '2015-02-01 01:22:33.000000', 'temps per volta', 10000.0000, 'ms'),
	(5012, 140, '2015-02-01 01:24:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(5013, 140, '2015-02-01 01:27:14.000000', 'temps per volta', 10000.0000, 'ms'),
	(5014, 140, '2015-02-01 01:29:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(5015, 140, '2015-02-01 01:32:49.000000', 'temps per volta', 10000.0000, 'ms'),
	(5016, 140, '2015-02-01 01:34:45.000000', 'temps per volta', 10000.0000, 'ms'),
	(5017, 140, '2015-02-01 01:36:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(5018, 140, '2015-02-01 01:39:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(5019, 140, '2015-02-01 01:41:31.000000', 'temps per volta', 10000.0000, 'ms'),
	(5020, 140, '2015-02-01 01:44:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(5021, 140, '2015-02-01 01:47:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(5022, 140, '2015-02-01 01:49:22.000000', 'temps per volta', 10000.0000, 'ms'),
	(5023, 140, '2015-02-01 01:52:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(5024, 140, '2015-02-01 01:55:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(5025, 140, '2015-02-01 01:59:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(5026, 140, '2015-02-01 02:00:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(5027, 140, '2015-02-01 02:03:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(5028, 140, '2015-02-01 02:07:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(5029, 140, '2015-02-01 02:08:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(5030, 140, '2015-02-01 02:11:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(5031, 140, '2015-02-01 02:14:53.000000', 'temps per volta', 10000.0000, 'ms'),
	(5032, 140, '2015-02-01 02:16:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(5033, 140, '2015-02-01 02:19:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(5034, 140, '2015-02-01 02:20:41.000000', 'temps per volta', 10000.0000, 'ms'),
	(5035, 140, '2015-02-01 02:22:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(5036, 140, '2015-02-01 02:25:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(5037, 140, '2015-02-01 02:27:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(5038, 140, '2015-02-01 02:29:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(5039, 140, '2015-02-01 02:31:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(5040, 140, '2015-02-01 02:35:05.000000', 'temps per volta', 10000.0000, 'ms'),
	(5041, 141, '2015-02-01 00:00:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(5042, 141, '2015-02-01 00:02:27.000000', 'temps per volta', 10000.0000, 'ms'),
	(5043, 141, '2015-02-01 00:04:08.000000', 'temps per volta', 10000.0000, 'ms'),
	(5044, 141, '2015-02-01 00:05:38.000000', 'temps per volta', 10000.0000, 'ms'),
	(5045, 141, '2015-02-01 00:08:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(5046, 141, '2015-02-01 00:11:02.000000', 'temps per volta', 10000.0000, 'ms'),
	(5047, 141, '2015-02-01 00:13:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(5048, 141, '2015-02-01 00:16:09.000000', 'temps per volta', 10000.0000, 'ms'),
	(5049, 141, '2015-02-01 00:18:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(5050, 141, '2015-02-01 00:20:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(5051, 141, '2015-02-01 00:22:35.000000', 'temps per volta', 10000.0000, 'ms'),
	(5052, 141, '2015-02-01 00:24:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(5053, 141, '2015-02-01 00:26:19.000000', 'temps per volta', 10000.0000, 'ms'),
	(5054, 141, '2015-02-01 00:28:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(5055, 141, '2015-02-01 00:31:04.000000', 'temps per volta', 10000.0000, 'ms'),
	(5056, 141, '2015-02-01 00:33:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(5057, 141, '2015-02-01 00:36:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(5058, 141, '2015-02-01 00:38:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(5059, 141, '2015-02-01 00:41:01.000000', 'temps per volta', 10000.0000, 'ms'),
	(5060, 141, '2015-02-01 00:43:52.000000', 'temps per volta', 10000.0000, 'ms'),
	(5061, 141, '2015-02-01 00:45:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(5062, 141, '2015-02-01 00:48:25.000000', 'temps per volta', 10000.0000, 'ms'),
	(5063, 141, '2015-02-01 00:50:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(5064, 141, '2015-02-01 00:54:10.000000', 'temps per volta', 10000.0000, 'ms'),
	(5065, 141, '2015-02-01 00:56:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(5066, 141, '2015-02-01 00:59:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(5067, 141, '2015-02-01 01:02:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(5068, 141, '2015-02-01 01:05:21.000000', 'temps per volta', 10000.0000, 'ms'),
	(5069, 141, '2015-02-01 01:08:40.000000', 'temps per volta', 10000.0000, 'ms'),
	(5070, 141, '2015-02-01 01:12:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(5071, 141, '2015-02-01 01:13:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(5072, 141, '2015-02-01 01:16:13.000000', 'temps per volta', 10000.0000, 'ms'),
	(5073, 141, '2015-02-01 01:18:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(5074, 141, '2015-02-01 01:21:28.000000', 'temps per volta', 10000.0000, 'ms'),
	(5075, 141, '2015-02-01 01:24:07.000000', 'temps per volta', 10000.0000, 'ms'),
	(5076, 141, '2015-02-01 01:26:16.000000', 'temps per volta', 10000.0000, 'ms'),
	(5077, 141, '2015-02-01 01:29:30.000000', 'temps per volta', 10000.0000, 'ms'),
	(5078, 141, '2015-02-01 01:31:58.000000', 'temps per volta', 10000.0000, 'ms'),
	(5079, 141, '2015-02-01 01:35:03.000000', 'temps per volta', 10000.0000, 'ms'),
	(5080, 141, '2015-02-01 01:37:43.000000', 'temps per volta', 10000.0000, 'ms'),
	(5081, 141, '2015-02-01 01:40:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(5082, 141, '2015-02-01 01:41:51.000000', 'temps per volta', 10000.0000, 'ms'),
	(5083, 141, '2015-02-01 01:44:11.000000', 'temps per volta', 10000.0000, 'ms'),
	(5084, 141, '2015-02-01 01:45:50.000000', 'temps per volta', 10000.0000, 'ms'),
	(5085, 141, '2015-02-01 01:47:34.000000', 'temps per volta', 10000.0000, 'ms'),
	(5086, 141, '2015-02-01 01:49:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(5087, 141, '2015-02-01 01:52:00.000000', 'temps per volta', 10000.0000, 'ms'),
	(5088, 141, '2015-02-01 01:55:20.000000', 'temps per volta', 10000.0000, 'ms'),
	(5089, 141, '2015-02-01 01:57:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(5090, 141, '2015-02-01 01:59:29.000000', 'temps per volta', 10000.0000, 'ms'),
	(5091, 141, '2015-02-01 02:01:47.000000', 'temps per volta', 10000.0000, 'ms'),
	(5092, 141, '2015-02-01 02:03:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(5093, 141, '2015-02-01 02:06:15.000000', 'temps per volta', 10000.0000, 'ms'),
	(5094, 141, '2015-02-01 02:09:18.000000', 'temps per volta', 10000.0000, 'ms'),
	(5095, 141, '2015-02-01 02:12:17.000000', 'temps per volta', 10000.0000, 'ms'),
	(5096, 141, '2015-02-01 02:14:39.000000', 'temps per volta', 10000.0000, 'ms'),
	(5097, 141, '2015-02-01 02:17:56.000000', 'temps per volta', 10000.0000, 'ms'),
	(5098, 141, '2015-02-01 02:19:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(5099, 141, '2015-02-01 02:22:44.000000', 'temps per volta', 10000.0000, 'ms'),
	(5100, 141, '2015-02-01 02:24:59.000000', 'temps per volta', 10000.0000, 'ms'),
	(5101, 108, '2015-01-15 00:00:00.000000', 'temperatura', 586.0000, 'ºC'),
	(5102, 108, '2015-01-15 00:00:01.000000', 'temperatura', 858.0000, 'ºC'),
	(5103, 108, '2015-01-15 00:00:02.000000', 'temperatura', 135.0000, 'ºC'),
	(5104, 108, '2015-01-15 00:00:03.000000', 'temperatura', 499.0000, 'ºC'),
	(5105, 108, '2015-01-15 00:00:04.000000', 'temperatura', 892.0000, 'ºC'),
	(5106, 108, '2015-01-15 00:00:05.000000', 'temperatura', 565.0000, 'ºC'),
	(5107, 108, '2015-01-15 00:00:06.000000', 'temperatura', 148.0000, 'ºC'),
	(5108, 108, '2015-01-15 00:00:07.000000', 'temperatura', 246.0000, 'ºC'),
	(5109, 108, '2015-01-15 00:00:08.000000', 'temperatura', 788.0000, 'ºC'),
	(5110, 108, '2015-01-15 00:00:09.000000', 'temperatura', 803.0000, 'ºC'),
	(5111, 108, '2015-01-15 00:00:10.000000', 'temperatura', 449.0000, 'ºC'),
	(5112, 108, '2015-01-15 00:00:11.000000', 'temperatura', 1036.0000, 'ºC'),
	(5113, 108, '2015-01-15 00:00:12.000000', 'temperatura', 233.0000, 'ºC'),
	(5114, 108, '2015-01-15 00:00:13.000000', 'temperatura', 457.0000, 'ºC'),
	(5115, 108, '2015-01-15 00:00:14.000000', 'temperatura', 385.0000, 'ºC'),
	(5116, 108, '2015-01-15 00:00:15.000000', 'temperatura', 558.0000, 'ºC'),
	(5117, 108, '2015-01-15 00:00:16.000000', 'temperatura', 436.0000, 'ºC'),
	(5118, 108, '2015-01-15 00:00:17.000000', 'temperatura', 504.0000, 'ºC'),
	(5119, 108, '2015-01-15 00:00:18.000000', 'temperatura', 13.0000, 'ºC'),
	(5120, 108, '2015-01-15 00:00:19.000000', 'temperatura', 954.0000, 'ºC'),
	(5121, 108, '2015-01-15 00:00:20.000000', 'temperatura', 1130.0000, 'ºC'),
	(5122, 108, '2015-01-15 00:00:21.000000', 'temperatura', 390.0000, 'ºC'),
	(5123, 108, '2015-01-15 00:00:22.000000', 'temperatura', 961.0000, 'ºC'),
	(5124, 108, '2015-01-15 00:00:23.000000', 'temperatura', 33.0000, 'ºC'),
	(5125, 108, '2015-01-15 00:00:24.000000', 'temperatura', 884.0000, 'ºC'),
	(5126, 108, '2015-01-15 00:00:25.000000', 'temperatura', 721.0000, 'ºC'),
	(5127, 108, '2015-01-15 00:00:26.000000', 'temperatura', 953.0000, 'ºC'),
	(5128, 108, '2015-01-15 00:00:27.000000', 'temperatura', 204.0000, 'ºC'),
	(5129, 108, '2015-01-15 00:00:28.000000', 'temperatura', 563.0000, 'ºC'),
	(5130, 108, '2015-01-15 00:00:29.000000', 'temperatura', 1000.0000, 'ºC'),
	(5131, 108, '2015-01-15 00:00:30.000000', 'temperatura', 913.0000, 'ºC'),
	(5132, 108, '2015-01-15 00:00:31.000000', 'temperatura', 364.0000, 'ºC'),
	(5133, 108, '2015-01-15 00:00:32.000000', 'temperatura', 281.0000, 'ºC'),
	(5134, 108, '2015-01-15 00:00:33.000000', 'temperatura', 316.0000, 'ºC'),
	(5135, 108, '2015-01-15 00:00:34.000000', 'temperatura', 739.0000, 'ºC'),
	(5136, 108, '2015-01-15 00:00:35.000000', 'temperatura', 344.0000, 'ºC'),
	(5137, 108, '2015-01-15 00:00:36.000000', 'temperatura', 704.0000, 'ºC'),
	(5138, 108, '2015-01-15 00:00:37.000000', 'temperatura', 91.0000, 'ºC'),
	(5139, 108, '2015-01-15 00:00:38.000000', 'temperatura', 742.0000, 'ºC'),
	(5140, 108, '2015-01-15 00:00:39.000000', 'temperatura', 1038.0000, 'ºC'),
	(5141, 108, '2015-01-15 00:00:40.000000', 'temperatura', 566.0000, 'ºC'),
	(5142, 108, '2015-01-15 00:00:41.000000', 'temperatura', 913.0000, 'ºC'),
	(5143, 108, '2015-01-15 00:00:42.000000', 'temperatura', 471.0000, 'ºC'),
	(5144, 108, '2015-01-15 00:00:43.000000', 'temperatura', 815.0000, 'ºC'),
	(5145, 108, '2015-01-15 00:00:44.000000', 'temperatura', 264.0000, 'ºC'),
	(5146, 108, '2015-01-15 00:00:45.000000', 'temperatura', 75.0000, 'ºC'),
	(5147, 108, '2015-01-15 00:00:46.000000', 'temperatura', 785.0000, 'ºC'),
	(5148, 108, '2015-01-15 00:00:47.000000', 'temperatura', 98.0000, 'ºC'),
	(5149, 108, '2015-01-15 00:00:48.000000', 'temperatura', 537.0000, 'ºC'),
	(5150, 108, '2015-01-15 00:00:49.000000', 'temperatura', 1192.0000, 'ºC'),
	(5151, 108, '2015-01-15 00:00:50.000000', 'temperatura', 749.0000, 'ºC'),
	(5152, 108, '2015-01-15 00:00:51.000000', 'temperatura', 170.0000, 'ºC'),
	(5153, 108, '2015-01-15 00:00:52.000000', 'temperatura', 1003.0000, 'ºC'),
	(5154, 108, '2015-01-15 00:00:53.000000', 'temperatura', 905.0000, 'ºC'),
	(5155, 108, '2015-01-15 00:00:54.000000', 'temperatura', 318.0000, 'ºC'),
	(5156, 108, '2015-01-15 00:00:55.000000', 'temperatura', 73.0000, 'ºC'),
	(5157, 108, '2015-01-15 00:00:56.000000', 'temperatura', 614.0000, 'ºC'),
	(5158, 108, '2015-01-15 00:00:57.000000', 'temperatura', 451.0000, 'ºC'),
	(5159, 108, '2015-01-15 00:00:58.000000', 'temperatura', 412.0000, 'ºC'),
	(5160, 108, '2015-01-15 00:00:59.000000', 'temperatura', 707.0000, 'ºC'),
	(5161, 108, '2015-01-15 00:01:00.000000', 'temperatura', 1100.0000, 'ºC'),
	(5162, 108, '2015-01-15 00:01:01.000000', 'temperatura', 978.0000, 'ºC'),
	(5163, 108, '2015-01-15 00:01:02.000000', 'temperatura', 390.0000, 'ºC'),
	(5164, 108, '2015-01-15 00:01:03.000000', 'temperatura', 219.0000, 'ºC'),
	(5165, 108, '2015-01-15 00:01:04.000000', 'temperatura', 1127.0000, 'ºC'),
	(5166, 108, '2015-01-15 00:01:05.000000', 'temperatura', 175.0000, 'ºC'),
	(5167, 108, '2015-01-15 00:01:06.000000', 'temperatura', 1098.0000, 'ºC'),
	(5168, 108, '2015-01-15 00:01:07.000000', 'temperatura', 162.0000, 'ºC'),
	(5169, 108, '2015-01-15 00:01:08.000000', 'temperatura', 1118.0000, 'ºC'),
	(5170, 108, '2015-01-15 00:01:09.000000', 'temperatura', 305.0000, 'ºC'),
	(5171, 108, '2015-01-15 00:01:10.000000', 'temperatura', 569.0000, 'ºC'),
	(5172, 108, '2015-01-15 00:01:11.000000', 'temperatura', 733.0000, 'ºC'),
	(5173, 108, '2015-01-15 00:01:12.000000', 'temperatura', 759.0000, 'ºC'),
	(5174, 108, '2015-01-15 00:01:13.000000', 'temperatura', 397.0000, 'ºC'),
	(5175, 108, '2015-01-15 00:01:14.000000', 'temperatura', 910.0000, 'ºC'),
	(5176, 108, '2015-01-15 00:01:15.000000', 'temperatura', 956.0000, 'ºC'),
	(5177, 108, '2015-01-15 00:01:16.000000', 'temperatura', 851.0000, 'ºC'),
	(5178, 108, '2015-01-15 00:01:17.000000', 'temperatura', 189.0000, 'ºC'),
	(5179, 108, '2015-01-15 00:01:18.000000', 'temperatura', 791.0000, 'ºC'),
	(5180, 108, '2015-01-15 00:01:19.000000', 'temperatura', 989.0000, 'ºC'),
	(5181, 108, '2015-01-15 00:01:20.000000', 'temperatura', 173.0000, 'ºC'),
	(5182, 108, '2015-01-15 00:01:21.000000', 'temperatura', 300.0000, 'ºC'),
	(5183, 108, '2015-01-15 00:01:22.000000', 'temperatura', 981.0000, 'ºC'),
	(5184, 108, '2015-01-15 00:01:23.000000', 'temperatura', 406.0000, 'ºC'),
	(5185, 108, '2015-01-15 00:01:24.000000', 'temperatura', 285.0000, 'ºC'),
	(5186, 108, '2015-01-15 00:01:25.000000', 'temperatura', 208.0000, 'ºC'),
	(5187, 108, '2015-01-15 00:01:26.000000', 'temperatura', 185.0000, 'ºC'),
	(5188, 108, '2015-01-15 00:01:27.000000', 'temperatura', 300.0000, 'ºC'),
	(5189, 108, '2015-01-15 00:01:28.000000', 'temperatura', 949.0000, 'ºC'),
	(5190, 108, '2015-01-15 00:01:29.000000', 'temperatura', 244.0000, 'ºC'),
	(5191, 108, '2015-01-15 00:01:30.000000', 'temperatura', 775.0000, 'ºC'),
	(5192, 108, '2015-01-15 00:01:31.000000', 'temperatura', 742.0000, 'ºC'),
	(5193, 108, '2015-01-15 00:01:32.000000', 'temperatura', 187.0000, 'ºC'),
	(5194, 108, '2015-01-15 00:01:33.000000', 'temperatura', 1108.0000, 'ºC'),
	(5195, 108, '2015-01-15 00:01:34.000000', 'temperatura', 179.0000, 'ºC'),
	(5196, 108, '2015-01-15 00:01:35.000000', 'temperatura', 1172.0000, 'ºC'),
	(5197, 108, '2015-01-15 00:01:36.000000', 'temperatura', 525.0000, 'ºC'),
	(5198, 108, '2015-01-15 00:01:37.000000', 'temperatura', 309.0000, 'ºC'),
	(5199, 108, '2015-01-15 00:01:38.000000', 'temperatura', 1172.0000, 'ºC'),
	(5200, 108, '2015-01-15 00:01:39.000000', 'temperatura', 132.0000, 'ºC'),
	(5201, 108, '2015-01-15 00:01:40.000000', 'temperatura', 747.0000, 'ºC'),
	(5202, 108, '2015-01-15 00:01:41.000000', 'temperatura', 936.0000, 'ºC'),
	(5203, 108, '2015-01-15 00:01:42.000000', 'temperatura', 40.0000, 'ºC'),
	(5204, 108, '2015-01-15 00:01:43.000000', 'temperatura', 994.0000, 'ºC'),
	(5205, 108, '2015-01-15 00:01:44.000000', 'temperatura', 52.0000, 'ºC'),
	(5206, 108, '2015-01-15 00:01:45.000000', 'temperatura', 875.0000, 'ºC'),
	(5207, 108, '2015-01-15 00:01:46.000000', 'temperatura', 623.0000, 'ºC'),
	(5208, 108, '2015-01-15 00:01:47.000000', 'temperatura', 489.0000, 'ºC'),
	(5209, 108, '2015-01-15 00:01:48.000000', 'temperatura', 577.0000, 'ºC'),
	(5210, 108, '2015-01-15 00:01:49.000000', 'temperatura', 217.0000, 'ºC'),
	(5211, 108, '2015-01-15 00:01:50.000000', 'temperatura', 554.0000, 'ºC'),
	(5212, 108, '2015-01-15 00:01:51.000000', 'temperatura', 920.0000, 'ºC'),
	(5213, 108, '2015-01-15 00:01:52.000000', 'temperatura', 541.0000, 'ºC'),
	(5214, 108, '2015-01-15 00:01:53.000000', 'temperatura', 1142.0000, 'ºC'),
	(5215, 108, '2015-01-15 00:01:54.000000', 'temperatura', 489.0000, 'ºC'),
	(5216, 108, '2015-01-15 00:01:55.000000', 'temperatura', 219.0000, 'ºC'),
	(5217, 108, '2015-01-15 00:01:56.000000', 'temperatura', 830.0000, 'ºC'),
	(5218, 108, '2015-01-15 00:01:57.000000', 'temperatura', 1093.0000, 'ºC'),
	(5219, 108, '2015-01-15 00:01:58.000000', 'temperatura', 575.0000, 'ºC'),
	(5220, 108, '2015-01-15 00:01:59.000000', 'temperatura', 795.0000, 'ºC'),
	(5221, 108, '2015-01-15 00:02:00.000000', 'temperatura', 1050.0000, 'ºC'),
	(5222, 108, '2015-01-15 00:02:01.000000', 'temperatura', 465.0000, 'ºC'),
	(5223, 108, '2015-01-15 00:02:02.000000', 'temperatura', 378.0000, 'ºC'),
	(5224, 108, '2015-01-15 00:02:03.000000', 'temperatura', 496.0000, 'ºC'),
	(5225, 108, '2015-01-15 00:02:04.000000', 'temperatura', 145.0000, 'ºC'),
	(5226, 108, '2015-01-15 00:02:05.000000', 'temperatura', 438.0000, 'ºC'),
	(5227, 108, '2015-01-15 00:02:06.000000', 'temperatura', 556.0000, 'ºC'),
	(5228, 108, '2015-01-15 00:02:07.000000', 'temperatura', 266.0000, 'ºC'),
	(5229, 108, '2015-01-15 00:02:08.000000', 'temperatura', 863.0000, 'ºC'),
	(5230, 108, '2015-01-15 00:02:09.000000', 'temperatura', 1116.0000, 'ºC'),
	(5231, 108, '2015-01-15 00:02:10.000000', 'temperatura', 591.0000, 'ºC'),
	(5232, 108, '2015-01-15 00:02:11.000000', 'temperatura', 809.0000, 'ºC'),
	(5233, 108, '2015-01-15 00:02:12.000000', 'temperatura', 1071.0000, 'ºC'),
	(5234, 108, '2015-01-15 00:02:13.000000', 'temperatura', 531.0000, 'ºC'),
	(5235, 108, '2015-01-15 00:02:14.000000', 'temperatura', 642.0000, 'ºC'),
	(5236, 108, '2015-01-15 00:02:15.000000', 'temperatura', 418.0000, 'ºC'),
	(5237, 108, '2015-01-15 00:02:16.000000', 'temperatura', 164.0000, 'ºC'),
	(5238, 108, '2015-01-15 00:02:17.000000', 'temperatura', 767.0000, 'ºC'),
	(5239, 108, '2015-01-15 00:02:18.000000', 'temperatura', 942.0000, 'ºC'),
	(5240, 108, '2015-01-15 00:02:19.000000', 'temperatura', 10.0000, 'ºC'),
	(5241, 108, '2015-01-15 00:02:20.000000', 'temperatura', 823.0000, 'ºC'),
	(5242, 108, '2015-01-15 00:02:21.000000', 'temperatura', 489.0000, 'ºC'),
	(5243, 108, '2015-01-15 00:02:22.000000', 'temperatura', 1173.0000, 'ºC'),
	(5244, 108, '2015-01-15 00:02:23.000000', 'temperatura', 802.0000, 'ºC'),
	(5245, 108, '2015-01-15 00:02:24.000000', 'temperatura', 489.0000, 'ºC'),
	(5246, 108, '2015-01-15 00:02:25.000000', 'temperatura', 39.0000, 'ºC'),
	(5247, 108, '2015-01-15 00:02:26.000000', 'temperatura', 1129.0000, 'ºC'),
	(5248, 108, '2015-01-15 00:02:27.000000', 'temperatura', 727.0000, 'ºC'),
	(5249, 108, '2015-01-15 00:02:28.000000', 'temperatura', 249.0000, 'ºC'),
	(5250, 108, '2015-01-15 00:02:29.000000', 'temperatura', 264.0000, 'ºC'),
	(5251, 108, '2015-01-15 00:02:30.000000', 'temperatura', 574.0000, 'ºC'),
	(5252, 108, '2015-01-15 00:02:31.000000', 'temperatura', 877.0000, 'ºC'),
	(5253, 108, '2015-01-15 00:02:32.000000', 'temperatura', 266.0000, 'ºC'),
	(5254, 108, '2015-01-15 00:02:33.000000', 'temperatura', 1100.0000, 'ºC'),
	(5255, 108, '2015-01-15 00:02:34.000000', 'temperatura', 1103.0000, 'ºC'),
	(5256, 108, '2015-01-15 00:02:35.000000', 'temperatura', 1016.0000, 'ºC'),
	(5257, 108, '2015-01-15 00:02:36.000000', 'temperatura', 569.0000, 'ºC'),
	(5258, 108, '2015-01-15 00:02:37.000000', 'temperatura', 999.0000, 'ºC'),
	(5259, 108, '2015-01-15 00:02:38.000000', 'temperatura', 886.0000, 'ºC'),
	(5260, 108, '2015-01-15 00:02:39.000000', 'temperatura', 236.0000, 'ºC'),
	(5261, 108, '2015-01-15 00:02:40.000000', 'temperatura', 921.0000, 'ºC'),
	(5262, 108, '2015-01-15 00:02:41.000000', 'temperatura', 298.0000, 'ºC'),
	(5263, 108, '2015-01-15 00:02:42.000000', 'temperatura', 1127.0000, 'ºC'),
	(5264, 108, '2015-01-15 00:02:43.000000', 'temperatura', 1142.0000, 'ºC'),
	(5265, 108, '2015-01-15 00:02:44.000000', 'temperatura', 1131.0000, 'ºC'),
	(5266, 108, '2015-01-15 00:02:45.000000', 'temperatura', 1027.0000, 'ºC'),
	(5267, 108, '2015-01-15 00:02:46.000000', 'temperatura', 541.0000, 'ºC'),
	(5268, 108, '2015-01-15 00:02:47.000000', 'temperatura', 828.0000, 'ºC'),
	(5269, 108, '2015-01-15 00:02:48.000000', 'temperatura', 118.0000, 'ºC'),
	(5270, 108, '2015-01-15 00:02:49.000000', 'temperatura', 504.0000, 'ºC'),
	(5271, 108, '2015-01-15 00:02:50.000000', 'temperatura', 965.0000, 'ºC'),
	(5272, 108, '2015-01-15 00:02:51.000000', 'temperatura', 917.0000, 'ºC'),
	(5273, 108, '2015-01-15 00:02:52.000000', 'temperatura', 488.0000, 'ºC'),
	(5274, 108, '2015-01-15 00:02:53.000000', 'temperatura', 891.0000, 'ºC'),
	(5275, 108, '2015-01-15 00:02:54.000000', 'temperatura', 592.0000, 'ºC'),
	(5276, 108, '2015-01-15 00:02:55.000000', 'temperatura', 288.0000, 'ºC'),
	(5277, 108, '2015-01-15 00:02:56.000000', 'temperatura', 864.0000, 'ºC'),
	(5278, 108, '2015-01-15 00:02:57.000000', 'temperatura', 1056.0000, 'ºC'),
	(5279, 108, '2015-01-15 00:02:58.000000', 'temperatura', 289.0000, 'ºC'),
	(5280, 108, '2015-01-15 00:02:59.000000', 'temperatura', 677.0000, 'ºC'),
	(5281, 108, '2015-01-15 00:03:00.000000', 'temperatura', 120.0000, 'ºC'),
	(5282, 108, '2015-01-15 00:03:01.000000', 'temperatura', 968.0000, 'ºC'),
	(5283, 108, '2015-01-15 00:03:02.000000', 'temperatura', 879.0000, 'ºC'),
	(5284, 108, '2015-01-15 00:03:03.000000', 'temperatura', 294.0000, 'ºC'),
	(5285, 108, '2015-01-15 00:03:04.000000', 'temperatura', 35.0000, 'ºC'),
	(5286, 108, '2015-01-15 00:03:05.000000', 'temperatura', 491.0000, 'ºC'),
	(5287, 108, '2015-01-15 00:03:06.000000', 'temperatura', 1149.0000, 'ºC'),
	(5288, 108, '2015-01-15 00:03:07.000000', 'temperatura', 676.0000, 'ºC'),
	(5289, 108, '2015-01-15 00:03:08.000000', 'temperatura', 1132.0000, 'ºC'),
	(5290, 108, '2015-01-15 00:03:09.000000', 'temperatura', 31.0000, 'ºC'),
	(5291, 108, '2015-01-15 00:03:10.000000', 'temperatura', 363.0000, 'ºC'),
	(5292, 108, '2015-01-15 00:03:11.000000', 'temperatura', 520.0000, 'ºC'),
	(5293, 108, '2015-01-15 00:03:12.000000', 'temperatura', 310.0000, 'ºC'),
	(5294, 108, '2015-01-15 00:03:13.000000', 'temperatura', 1194.0000, 'ºC'),
	(5295, 108, '2015-01-15 00:03:14.000000', 'temperatura', 238.0000, 'ºC'),
	(5296, 108, '2015-01-15 00:03:15.000000', 'temperatura', 9.0000, 'ºC'),
	(5297, 108, '2015-01-15 00:03:16.000000', 'temperatura', 532.0000, 'ºC'),
	(5298, 108, '2015-01-15 00:03:17.000000', 'temperatura', 235.0000, 'ºC'),
	(5299, 108, '2015-01-15 00:03:18.000000', 'temperatura', 778.0000, 'ºC'),
	(5300, 108, '2015-01-15 00:03:19.000000', 'temperatura', 784.0000, 'ºC'),
	(5301, 108, '2015-01-15 00:03:20.000000', 'temperatura', 387.0000, 'ºC'),
	(5302, 108, '2015-01-15 00:03:21.000000', 'temperatura', 782.0000, 'ºC'),
	(5303, 108, '2015-01-15 00:03:22.000000', 'temperatura', 351.0000, 'ºC'),
	(5304, 108, '2015-01-15 00:03:23.000000', 'temperatura', 608.0000, 'ºC'),
	(5305, 108, '2015-01-15 00:03:24.000000', 'temperatura', 789.0000, 'ºC'),
	(5306, 108, '2015-01-15 00:03:25.000000', 'temperatura', 919.0000, 'ºC'),
	(5307, 108, '2015-01-15 00:03:26.000000', 'temperatura', 1031.0000, 'ºC'),
	(5308, 108, '2015-01-15 00:03:27.000000', 'temperatura', 1198.0000, 'ºC'),
	(5309, 108, '2015-01-15 00:03:28.000000', 'temperatura', 498.0000, 'ºC'),
	(5310, 108, '2015-01-15 00:03:29.000000', 'temperatura', 95.0000, 'ºC'),
	(5311, 108, '2015-01-15 00:03:30.000000', 'temperatura', 184.0000, 'ºC'),
	(5312, 108, '2015-01-15 00:03:31.000000', 'temperatura', 634.0000, 'ºC'),
	(5313, 108, '2015-01-15 00:03:32.000000', 'temperatura', 218.0000, 'ºC'),
	(5314, 108, '2015-01-15 00:03:33.000000', 'temperatura', 389.0000, 'ºC'),
	(5315, 108, '2015-01-15 00:03:34.000000', 'temperatura', 93.0000, 'ºC'),
	(5316, 108, '2015-01-15 00:03:35.000000', 'temperatura', 496.0000, 'ºC'),
	(5317, 108, '2015-01-15 00:03:36.000000', 'temperatura', 1003.0000, 'ºC'),
	(5318, 108, '2015-01-15 00:03:37.000000', 'temperatura', 1128.0000, 'ºC'),
	(5319, 108, '2015-01-15 00:03:38.000000', 'temperatura', 231.0000, 'ºC'),
	(5320, 108, '2015-01-15 00:03:39.000000', 'temperatura', 171.0000, 'ºC'),
	(5321, 108, '2015-01-15 00:03:40.000000', 'temperatura', 164.0000, 'ºC'),
	(5322, 108, '2015-01-15 00:03:41.000000', 'temperatura', 308.0000, 'ºC'),
	(5323, 108, '2015-01-15 00:03:42.000000', 'temperatura', 1049.0000, 'ºC'),
	(5324, 108, '2015-01-15 00:03:43.000000', 'temperatura', 720.0000, 'ºC'),
	(5325, 108, '2015-01-15 00:03:44.000000', 'temperatura', 453.0000, 'ºC'),
	(5326, 108, '2015-01-15 00:03:45.000000', 'temperatura', 107.0000, 'ºC'),
	(5327, 108, '2015-01-15 00:03:46.000000', 'temperatura', 374.0000, 'ºC'),
	(5328, 108, '2015-01-15 00:03:47.000000', 'temperatura', 350.0000, 'ºC'),
	(5329, 108, '2015-01-15 00:03:48.000000', 'temperatura', 631.0000, 'ºC'),
	(5330, 108, '2015-01-15 00:03:49.000000', 'temperatura', 903.0000, 'ºC'),
	(5331, 108, '2015-01-15 00:03:50.000000', 'temperatura', 222.0000, 'ºC'),
	(5332, 108, '2015-01-15 00:03:51.000000', 'temperatura', 801.0000, 'ºC'),
	(5333, 108, '2015-01-15 00:03:52.000000', 'temperatura', 939.0000, 'ºC'),
	(5334, 108, '2015-01-15 00:03:53.000000', 'temperatura', 1092.0000, 'ºC'),
	(5335, 108, '2015-01-15 00:03:54.000000', 'temperatura', 245.0000, 'ºC'),
	(5336, 108, '2015-01-15 00:03:55.000000', 'temperatura', 349.0000, 'ºC'),
	(5337, 108, '2015-01-15 00:03:56.000000', 'temperatura', 1009.0000, 'ºC'),
	(5338, 108, '2015-01-15 00:03:57.000000', 'temperatura', 402.0000, 'ºC'),
	(5339, 108, '2015-01-15 00:03:58.000000', 'temperatura', 181.0000, 'ºC'),
	(5340, 108, '2015-01-15 00:03:59.000000', 'temperatura', 900.0000, 'ºC'),
	(5341, 108, '2015-01-15 00:04:00.000000', 'temperatura', 357.0000, 'ºC'),
	(5342, 108, '2015-01-15 00:04:01.000000', 'temperatura', 288.0000, 'ºC'),
	(5343, 108, '2015-01-15 00:04:02.000000', 'temperatura', 367.0000, 'ºC'),
	(5344, 108, '2015-01-15 00:04:03.000000', 'temperatura', 972.0000, 'ºC'),
	(5345, 108, '2015-01-15 00:04:04.000000', 'temperatura', 159.0000, 'ºC'),
	(5346, 108, '2015-01-15 00:04:05.000000', 'temperatura', 280.0000, 'ºC'),
	(5347, 108, '2015-01-15 00:04:06.000000', 'temperatura', 925.0000, 'ºC'),
	(5348, 108, '2015-01-15 00:04:07.000000', 'temperatura', 183.0000, 'ºC'),
	(5349, 108, '2015-01-15 00:04:08.000000', 'temperatura', 543.0000, 'ºC'),
	(5350, 108, '2015-01-15 00:04:09.000000', 'temperatura', 963.0000, 'ºC'),
	(5351, 108, '2015-01-15 00:04:10.000000', 'temperatura', 790.0000, 'ºC'),
	(5352, 108, '2015-01-15 00:04:11.000000', 'temperatura', 1059.0000, 'ºC'),
	(5353, 108, '2015-01-15 00:04:12.000000', 'temperatura', 525.0000, 'ºC'),
	(5354, 108, '2015-01-15 00:04:13.000000', 'temperatura', 648.0000, 'ºC'),
	(5355, 108, '2015-01-15 00:04:14.000000', 'temperatura', 466.0000, 'ºC'),
	(5356, 108, '2015-01-15 00:04:15.000000', 'temperatura', 389.0000, 'ºC'),
	(5357, 108, '2015-01-15 00:04:16.000000', 'temperatura', 545.0000, 'ºC'),
	(5358, 108, '2015-01-15 00:04:17.000000', 'temperatura', 359.0000, 'ºC'),
	(5359, 108, '2015-01-15 00:04:18.000000', 'temperatura', 163.0000, 'ºC'),
	(5360, 108, '2015-01-15 00:04:19.000000', 'temperatura', 936.0000, 'ºC'),
	(5361, 108, '2015-01-15 00:04:20.000000', 'temperatura', 592.0000, 'ºC'),
	(5362, 108, '2015-01-15 00:04:21.000000', 'temperatura', 152.0000, 'ºC'),
	(5363, 108, '2015-01-15 00:04:22.000000', 'temperatura', 186.0000, 'ºC'),
	(5364, 108, '2015-01-15 00:04:23.000000', 'temperatura', 473.0000, 'ºC'),
	(5365, 108, '2015-01-15 00:04:24.000000', 'temperatura', 608.0000, 'ºC'),
	(5366, 108, '2015-01-15 00:04:25.000000', 'temperatura', 420.0000, 'ºC'),
	(5367, 108, '2015-01-15 00:04:26.000000', 'temperatura', 278.0000, 'ºC'),
	(5368, 108, '2015-01-15 00:04:27.000000', 'temperatura', 130.0000, 'ºC'),
	(5369, 108, '2015-01-15 00:04:28.000000', 'temperatura', 1015.0000, 'ºC'),
	(5370, 108, '2015-01-15 00:04:29.000000', 'temperatura', 1085.0000, 'ºC'),
	(5371, 108, '2015-01-15 00:04:30.000000', 'temperatura', 1184.0000, 'ºC'),
	(5372, 108, '2015-01-15 00:04:31.000000', 'temperatura', 262.0000, 'ºC'),
	(5373, 108, '2015-01-15 00:04:32.000000', 'temperatura', 160.0000, 'ºC'),
	(5374, 108, '2015-01-15 00:04:33.000000', 'temperatura', 13.0000, 'ºC'),
	(5375, 108, '2015-01-15 00:04:34.000000', 'temperatura', 788.0000, 'ºC'),
	(5376, 108, '2015-01-15 00:04:35.000000', 'temperatura', 300.0000, 'ºC'),
	(5377, 108, '2015-01-15 00:04:36.000000', 'temperatura', 335.0000, 'ºC'),
	(5378, 108, '2015-01-15 00:04:37.000000', 'temperatura', 776.0000, 'ºC'),
	(5379, 108, '2015-01-15 00:04:38.000000', 'temperatura', 477.0000, 'ºC'),
	(5380, 108, '2015-01-15 00:04:39.000000', 'temperatura', 58.0000, 'ºC'),
	(5381, 108, '2015-01-15 00:04:40.000000', 'temperatura', 60.0000, 'ºC'),
	(5382, 108, '2015-01-15 00:04:41.000000', 'temperatura', 124.0000, 'ºC'),
	(5383, 108, '2015-01-15 00:04:42.000000', 'temperatura', 440.0000, 'ºC'),
	(5384, 108, '2015-01-15 00:04:43.000000', 'temperatura', 630.0000, 'ºC'),
	(5385, 108, '2015-01-15 00:04:44.000000', 'temperatura', 632.0000, 'ºC'),
	(5386, 108, '2015-01-15 00:04:45.000000', 'temperatura', 68.0000, 'ºC'),
	(5387, 108, '2015-01-15 00:04:46.000000', 'temperatura', 846.0000, 'ºC'),
	(5388, 108, '2015-01-15 00:04:47.000000', 'temperatura', 425.0000, 'ºC'),
	(5389, 108, '2015-01-15 00:04:48.000000', 'temperatura', 789.0000, 'ºC'),
	(5390, 108, '2015-01-15 00:04:49.000000', 'temperatura', 268.0000, 'ºC'),
	(5391, 108, '2015-01-15 00:04:50.000000', 'temperatura', 177.0000, 'ºC'),
	(5392, 108, '2015-01-15 00:04:51.000000', 'temperatura', 80.0000, 'ºC'),
	(5393, 108, '2015-01-15 00:04:52.000000', 'temperatura', 1069.0000, 'ºC'),
	(5394, 108, '2015-01-15 00:04:53.000000', 'temperatura', 306.0000, 'ºC'),
	(5395, 108, '2015-01-15 00:04:54.000000', 'temperatura', 724.0000, 'ºC'),
	(5396, 108, '2015-01-15 00:04:55.000000', 'temperatura', 302.0000, 'ºC'),
	(5397, 108, '2015-01-15 00:04:56.000000', 'temperatura', 538.0000, 'ºC'),
	(5398, 108, '2015-01-15 00:04:57.000000', 'temperatura', 584.0000, 'ºC'),
	(5399, 108, '2015-01-15 00:04:58.000000', 'temperatura', 107.0000, 'ºC'),
	(5400, 108, '2015-01-15 00:04:59.000000', 'temperatura', 1183.0000, 'ºC'),
	(5401, 108, '2015-01-15 00:05:00.000000', 'temperatura', 796.0000, 'ºC'),
	(5402, 108, '2015-01-15 00:05:01.000000', 'temperatura', 430.0000, 'ºC'),
	(5403, 108, '2015-01-15 00:05:02.000000', 'temperatura', 963.0000, 'ºC'),
	(5404, 108, '2015-01-15 00:05:03.000000', 'temperatura', 1125.0000, 'ºC'),
	(5405, 108, '2015-01-15 00:05:04.000000', 'temperatura', 338.0000, 'ºC'),
	(5406, 108, '2015-01-15 00:05:05.000000', 'temperatura', 714.0000, 'ºC'),
	(5407, 108, '2015-01-15 00:05:06.000000', 'temperatura', 156.0000, 'ºC'),
	(5408, 108, '2015-01-15 00:05:07.000000', 'temperatura', 1040.0000, 'ºC'),
	(5409, 108, '2015-01-15 00:05:08.000000', 'temperatura', 1134.0000, 'ºC'),
	(5410, 108, '2015-01-15 00:05:09.000000', 'temperatura', 148.0000, 'ºC'),
	(5411, 108, '2015-01-15 00:05:10.000000', 'temperatura', 937.0000, 'ºC'),
	(5412, 108, '2015-01-15 00:05:11.000000', 'temperatura', 644.0000, 'ºC'),
	(5413, 108, '2015-01-15 00:05:12.000000', 'temperatura', 411.0000, 'ºC'),
	(5414, 108, '2015-01-15 00:05:13.000000', 'temperatura', 121.0000, 'ºC'),
	(5415, 108, '2015-01-15 00:05:14.000000', 'temperatura', 574.0000, 'ºC'),
	(5416, 108, '2015-01-15 00:05:15.000000', 'temperatura', 106.0000, 'ºC'),
	(5417, 108, '2015-01-15 00:05:16.000000', 'temperatura', 9.0000, 'ºC'),
	(5418, 108, '2015-01-15 00:05:17.000000', 'temperatura', 925.0000, 'ºC'),
	(5419, 108, '2015-01-15 00:05:18.000000', 'temperatura', 1002.0000, 'ºC'),
	(5420, 108, '2015-01-15 00:05:19.000000', 'temperatura', 1036.0000, 'ºC'),
	(5421, 108, '2015-01-15 00:05:20.000000', 'temperatura', 975.0000, 'ºC'),
	(5422, 108, '2015-01-15 00:05:21.000000', 'temperatura', 565.0000, 'ºC'),
	(5423, 108, '2015-01-15 00:05:22.000000', 'temperatura', 1103.0000, 'ºC'),
	(5424, 108, '2015-01-15 00:05:23.000000', 'temperatura', 220.0000, 'ºC'),
	(5425, 108, '2015-01-15 00:05:24.000000', 'temperatura', 191.0000, 'ºC'),
	(5426, 108, '2015-01-15 00:05:25.000000', 'temperatura', 294.0000, 'ºC'),
	(5427, 108, '2015-01-15 00:05:26.000000', 'temperatura', 900.0000, 'ºC'),
	(5428, 108, '2015-01-15 00:05:27.000000', 'temperatura', 16.0000, 'ºC'),
	(5429, 108, '2015-01-15 00:05:28.000000', 'temperatura', 980.0000, 'ºC'),
	(5430, 108, '2015-01-15 00:05:29.000000', 'temperatura', 54.0000, 'ºC'),
	(5431, 108, '2015-01-15 00:05:30.000000', 'temperatura', 930.0000, 'ºC'),
	(5432, 108, '2015-01-15 00:05:31.000000', 'temperatura', 889.0000, 'ºC'),
	(5433, 108, '2015-01-15 00:05:32.000000', 'temperatura', 456.0000, 'ºC'),
	(5434, 108, '2015-01-15 00:05:33.000000', 'temperatura', 813.0000, 'ºC'),
	(5435, 108, '2015-01-15 00:05:34.000000', 'temperatura', 300.0000, 'ºC'),
	(5436, 108, '2015-01-15 00:05:35.000000', 'temperatura', 258.0000, 'ºC'),
	(5437, 108, '2015-01-15 00:05:36.000000', 'temperatura', 392.0000, 'ºC'),
	(5438, 108, '2015-01-15 00:05:37.000000', 'temperatura', 1188.0000, 'ºC'),
	(5439, 108, '2015-01-15 00:05:38.000000', 'temperatura', 1162.0000, 'ºC'),
	(5440, 108, '2015-01-15 00:05:39.000000', 'temperatura', 1046.0000, 'ºC'),
	(5441, 108, '2015-01-15 00:05:40.000000', 'temperatura', 546.0000, 'ºC'),
	(5442, 108, '2015-01-15 00:05:41.000000', 'temperatura', 791.0000, 'ºC'),
	(5443, 108, '2015-01-15 00:05:42.000000', 'temperatura', 1118.0000, 'ºC'),
	(5444, 108, '2015-01-15 00:05:43.000000', 'temperatura', 816.0000, 'ºC'),
	(5445, 108, '2015-01-15 00:05:44.000000', 'temperatura', 730.0000, 'ºC'),
	(5446, 108, '2015-01-15 00:05:45.000000', 'temperatura', 1199.0000, 'ºC'),
	(5447, 108, '2015-01-15 00:05:46.000000', 'temperatura', 209.0000, 'ºC'),
	(5448, 108, '2015-01-15 00:05:47.000000', 'temperatura', 1047.0000, 'ºC'),
	(5449, 108, '2015-01-15 00:05:48.000000', 'temperatura', 1007.0000, 'ºC'),
	(5450, 108, '2015-01-15 00:05:49.000000', 'temperatura', 697.0000, 'ºC'),
	(5451, 108, '2015-01-15 00:05:50.000000', 'temperatura', 464.0000, 'ºC'),
	(5452, 108, '2015-01-15 00:05:51.000000', 'temperatura', 230.0000, 'ºC'),
	(5453, 108, '2015-01-15 00:05:52.000000', 'temperatura', 956.0000, 'ºC'),
	(5454, 108, '2015-01-15 00:05:53.000000', 'temperatura', 493.0000, 'ºC'),
	(5455, 108, '2015-01-15 00:05:54.000000', 'temperatura', 796.0000, 'ºC'),
	(5456, 108, '2015-01-15 00:05:55.000000', 'temperatura', 104.0000, 'ºC'),
	(5457, 108, '2015-01-15 00:05:56.000000', 'temperatura', 531.0000, 'ºC'),
	(5458, 108, '2015-01-15 00:05:57.000000', 'temperatura', 1142.0000, 'ºC'),
	(5459, 108, '2015-01-15 00:05:58.000000', 'temperatura', 518.0000, 'ºC'),
	(5460, 108, '2015-01-15 00:05:59.000000', 'temperatura', 364.0000, 'ºC'),
	(5461, 108, '2015-01-15 00:06:00.000000', 'temperatura', 268.0000, 'ºC'),
	(5462, 108, '2015-01-15 00:06:01.000000', 'temperatura', 246.0000, 'ºC'),
	(5463, 108, '2015-01-15 00:06:02.000000', 'temperatura', 428.0000, 'ºC'),
	(5464, 108, '2015-01-15 00:06:03.000000', 'temperatura', 203.0000, 'ºC'),
	(5465, 108, '2015-01-15 00:06:04.000000', 'temperatura', 931.0000, 'ºC'),
	(5466, 108, '2015-01-15 00:06:05.000000', 'temperatura', 449.0000, 'ºC'),
	(5467, 108, '2015-01-15 00:06:06.000000', 'temperatura', 649.0000, 'ºC'),
	(5468, 108, '2015-01-15 00:06:07.000000', 'temperatura', 699.0000, 'ºC'),
	(5469, 108, '2015-01-15 00:06:08.000000', 'temperatura', 350.0000, 'ºC'),
	(5470, 108, '2015-01-15 00:06:09.000000', 'temperatura', 852.0000, 'ºC'),
	(5471, 108, '2015-01-15 00:06:10.000000', 'temperatura', 810.0000, 'ºC'),
	(5472, 108, '2015-01-15 00:06:11.000000', 'temperatura', 295.0000, 'ºC'),
	(5473, 108, '2015-01-15 00:06:12.000000', 'temperatura', 245.0000, 'ºC'),
	(5474, 108, '2015-01-15 00:06:13.000000', 'temperatura', 340.0000, 'ºC'),
	(5475, 108, '2015-01-15 00:06:14.000000', 'temperatura', 965.0000, 'ºC'),
	(5476, 108, '2015-01-15 00:06:15.000000', 'temperatura', 205.0000, 'ºC'),
	(5477, 108, '2015-01-15 00:06:16.000000', 'temperatura', 533.0000, 'ºC'),
	(5478, 108, '2015-01-15 00:06:17.000000', 'temperatura', 850.0000, 'ºC'),
	(5479, 108, '2015-01-15 00:06:18.000000', 'temperatura', 252.0000, 'ºC'),
	(5480, 108, '2015-01-15 00:06:19.000000', 'temperatura', 1109.0000, 'ºC'),
	(5481, 108, '2015-01-15 00:06:20.000000', 'temperatura', 1190.0000, 'ºC'),
	(5482, 108, '2015-01-15 00:06:21.000000', 'temperatura', 222.0000, 'ºC'),
	(5483, 108, '2015-01-15 00:06:22.000000', 'temperatura', 1143.0000, 'ºC'),
	(5484, 108, '2015-01-15 00:06:23.000000', 'temperatura', 250.0000, 'ºC'),
	(5485, 108, '2015-01-15 00:06:24.000000', 'temperatura', 220.0000, 'ºC'),
	(5486, 108, '2015-01-15 00:06:25.000000', 'temperatura', 351.0000, 'ºC'),
	(5487, 108, '2015-01-15 00:06:26.000000', 'temperatura', 1096.0000, 'ºC'),
	(5488, 108, '2015-01-15 00:06:27.000000', 'temperatura', 825.0000, 'ºC'),
	(5489, 108, '2015-01-15 00:06:28.000000', 'temperatura', 839.0000, 'ºC'),
	(5490, 108, '2015-01-15 00:06:29.000000', 'temperatura', 520.0000, 'ºC'),
	(5491, 108, '2015-01-15 00:06:30.000000', 'temperatura', 84.0000, 'ºC'),
	(5492, 108, '2015-01-15 00:06:31.000000', 'temperatura', 60.0000, 'ºC'),
	(5493, 108, '2015-01-15 00:06:32.000000', 'temperatura', 51.0000, 'ºC'),
	(5494, 108, '2015-01-15 00:06:33.000000', 'temperatura', 72.0000, 'ºC'),
	(5495, 108, '2015-01-15 00:06:34.000000', 'temperatura', 209.0000, 'ºC'),
	(5496, 108, '2015-01-15 00:06:35.000000', 'temperatura', 831.0000, 'ºC'),
	(5497, 108, '2015-01-15 00:06:36.000000', 'temperatura', 1129.0000, 'ºC'),
	(5498, 108, '2015-01-15 00:06:37.000000', 'temperatura', 752.0000, 'ºC'),
	(5499, 108, '2015-01-15 00:06:38.000000', 'temperatura', 373.0000, 'ºC'),
	(5500, 108, '2015-01-15 00:06:39.000000', 'temperatura', 809.0000, 'ºC'),
	(5501, 108, '2015-01-15 00:06:40.000000', 'temperatura', 527.0000, 'ºC'),
	(5502, 108, '2015-01-15 00:06:41.000000', 'temperatura', 209.0000, 'ºC'),
	(5503, 108, '2015-01-15 00:06:42.000000', 'temperatura', 662.0000, 'ºC'),
	(5504, 108, '2015-01-15 00:06:43.000000', 'temperatura', 286.0000, 'ºC'),
	(5505, 108, '2015-01-15 00:06:44.000000', 'temperatura', 643.0000, 'ºC'),
	(5506, 108, '2015-01-15 00:06:45.000000', 'temperatura', 1157.0000, 'ºC'),
	(5507, 108, '2015-01-15 00:06:46.000000', 'temperatura', 259.0000, 'ºC'),
	(5508, 108, '2015-01-15 00:06:47.000000', 'temperatura', 225.0000, 'ºC'),
	(5509, 108, '2015-01-15 00:06:48.000000', 'temperatura', 346.0000, 'ºC'),
	(5510, 108, '2015-01-15 00:06:49.000000', 'temperatura', 1055.0000, 'ºC'),
	(5511, 108, '2015-01-15 00:06:50.000000', 'temperatura', 639.0000, 'ºC'),
	(5512, 108, '2015-01-15 00:06:51.000000', 'temperatura', 28.0000, 'ºC'),
	(5513, 108, '2015-01-15 00:06:52.000000', 'temperatura', 627.0000, 'ºC'),
	(5514, 108, '2015-01-15 00:06:53.000000', 'temperatura', 650.0000, 'ºC'),
	(5515, 108, '2015-01-15 00:06:54.000000', 'temperatura', 170.0000, 'ºC'),
	(5516, 108, '2015-01-15 00:06:55.000000', 'temperatura', 102.0000, 'ºC'),
	(5517, 108, '2015-01-15 00:06:56.000000', 'temperatura', 1199.0000, 'ºC'),
	(5518, 108, '2015-01-15 00:06:57.000000', 'temperatura', 890.0000, 'ºC'),
	(5519, 108, '2015-01-15 00:06:58.000000', 'temperatura', 852.0000, 'ºC'),
	(5520, 108, '2015-01-15 00:06:59.000000', 'temperatura', 393.0000, 'ºC'),
	(5521, 108, '2015-01-15 00:07:00.000000', 'temperatura', 607.0000, 'ºC'),
	(5522, 108, '2015-01-15 00:07:01.000000', 'temperatura', 656.0000, 'ºC'),
	(5523, 108, '2015-01-15 00:07:02.000000', 'temperatura', 262.0000, 'ºC'),
	(5524, 108, '2015-01-15 00:07:03.000000', 'temperatura', 542.0000, 'ºC'),
	(5525, 108, '2015-01-15 00:07:04.000000', 'temperatura', 726.0000, 'ºC'),
	(5526, 108, '2015-01-15 00:07:05.000000', 'temperatura', 801.0000, 'ºC'),
	(5527, 108, '2015-01-15 00:07:06.000000', 'temperatura', 630.0000, 'ºC'),
	(5528, 108, '2015-01-15 00:07:07.000000', 'temperatura', 746.0000, 'ºC'),
	(5529, 108, '2015-01-15 00:07:08.000000', 'temperatura', 643.0000, 'ºC'),
	(5530, 108, '2015-01-15 00:07:09.000000', 'temperatura', 977.0000, 'ºC'),
	(5531, 108, '2015-01-15 00:07:10.000000', 'temperatura', 556.0000, 'ºC'),
	(5532, 108, '2015-01-15 00:07:11.000000', 'temperatura', 1050.0000, 'ºC'),
	(5533, 108, '2015-01-15 00:07:12.000000', 'temperatura', 1182.0000, 'ºC'),
	(5534, 108, '2015-01-15 00:07:13.000000', 'temperatura', 362.0000, 'ºC'),
	(5535, 108, '2015-01-15 00:07:14.000000', 'temperatura', 662.0000, 'ºC'),
	(5536, 108, '2015-01-15 00:07:15.000000', 'temperatura', 1028.0000, 'ºC'),
	(5537, 108, '2015-01-15 00:07:16.000000', 'temperatura', 751.0000, 'ºC'),
	(5538, 108, '2015-01-15 00:07:17.000000', 'temperatura', 674.0000, 'ºC'),
	(5539, 108, '2015-01-15 00:07:18.000000', 'temperatura', 1115.0000, 'ºC'),
	(5540, 108, '2015-01-15 00:07:19.000000', 'temperatura', 1153.0000, 'ºC'),
	(5541, 108, '2015-01-15 00:07:20.000000', 'temperatura', 21.0000, 'ºC'),
	(5542, 108, '2015-01-15 00:07:21.000000', 'temperatura', 247.0000, 'ºC'),
	(5543, 108, '2015-01-15 00:07:22.000000', 'temperatura', 1175.0000, 'ºC'),
	(5544, 108, '2015-01-15 00:07:23.000000', 'temperatura', 331.0000, 'ºC'),
	(5545, 108, '2015-01-15 00:07:24.000000', 'temperatura', 530.0000, 'ºC'),
	(5546, 108, '2015-01-15 00:07:25.000000', 'temperatura', 460.0000, 'ºC'),
	(5547, 108, '2015-01-15 00:07:26.000000', 'temperatura', 710.0000, 'ºC'),
	(5548, 108, '2015-01-15 00:07:27.000000', 'temperatura', 970.0000, 'ºC'),
	(5549, 108, '2015-01-15 00:07:28.000000', 'temperatura', 320.0000, 'ºC'),
	(5550, 108, '2015-01-15 00:07:29.000000', 'temperatura', 1091.0000, 'ºC'),
	(5551, 108, '2015-01-15 00:07:30.000000', 'temperatura', 894.0000, 'ºC'),
	(5552, 108, '2015-01-15 00:07:31.000000', 'temperatura', 1198.0000, 'ºC'),
	(5553, 108, '2015-01-15 00:07:32.000000', 'temperatura', 907.0000, 'ºC'),
	(5554, 108, '2015-01-15 00:07:33.000000', 'temperatura', 944.0000, 'ºC'),
	(5555, 108, '2015-01-15 00:07:34.000000', 'temperatura', 798.0000, 'ºC'),
	(5556, 108, '2015-01-15 00:07:35.000000', 'temperatura', 1157.0000, 'ºC'),
	(5557, 108, '2015-01-15 00:07:36.000000', 'temperatura', 992.0000, 'ºC'),
	(5558, 108, '2015-01-15 00:07:37.000000', 'temperatura', 291.0000, 'ºC'),
	(5559, 108, '2015-01-15 00:07:38.000000', 'temperatura', 880.0000, 'ºC'),
	(5560, 108, '2015-01-15 00:07:39.000000', 'temperatura', 1126.0000, 'ºC'),
	(5561, 108, '2015-01-15 00:07:40.000000', 'temperatura', 593.0000, 'ºC'),
	(5562, 108, '2015-01-15 00:07:41.000000', 'temperatura', 784.0000, 'ºC'),
	(5563, 108, '2015-01-15 00:07:42.000000', 'temperatura', 944.0000, 'ºC'),
	(5564, 108, '2015-01-15 00:07:43.000000', 'temperatura', 1167.0000, 'ºC'),
	(5565, 108, '2015-01-15 00:07:44.000000', 'temperatura', 606.0000, 'ºC'),
	(5566, 108, '2015-01-15 00:07:45.000000', 'temperatura', 728.0000, 'ºC'),
	(5567, 108, '2015-01-15 00:07:46.000000', 'temperatura', 624.0000, 'ºC'),
	(5568, 108, '2015-01-15 00:07:47.000000', 'temperatura', 937.0000, 'ºC'),
	(5569, 108, '2015-01-15 00:07:48.000000', 'temperatura', 411.0000, 'ºC'),
	(5570, 108, '2015-01-15 00:07:49.000000', 'temperatura', 445.0000, 'ºC'),
	(5571, 108, '2015-01-15 00:07:50.000000', 'temperatura', 992.0000, 'ºC'),
	(5572, 108, '2015-01-15 00:07:51.000000', 'temperatura', 25.0000, 'ºC'),
	(5573, 108, '2015-01-15 00:07:52.000000', 'temperatura', 749.0000, 'ºC'),
	(5574, 108, '2015-01-15 00:07:53.000000', 'temperatura', 70.0000, 'ºC'),
	(5575, 108, '2015-01-15 00:07:54.000000', 'temperatura', 503.0000, 'ºC'),
	(5576, 108, '2015-01-15 00:07:55.000000', 'temperatura', 1105.0000, 'ºC'),
	(5577, 108, '2015-01-15 00:07:56.000000', 'temperatura', 416.0000, 'ºC'),
	(5578, 108, '2015-01-15 00:07:57.000000', 'temperatura', 1166.0000, 'ºC'),
	(5579, 108, '2015-01-15 00:07:58.000000', 'temperatura', 983.0000, 'ºC'),
	(5580, 108, '2015-01-15 00:07:59.000000', 'temperatura', 219.0000, 'ºC'),
	(5581, 108, '2015-01-15 00:08:00.000000', 'temperatura', 545.0000, 'ºC'),
	(5582, 108, '2015-01-15 00:08:01.000000', 'temperatura', 868.0000, 'ºC'),
	(5583, 108, '2015-01-15 00:08:02.000000', 'temperatura', 306.0000, 'ºC'),
	(5584, 108, '2015-01-15 00:08:03.000000', 'temperatura', 129.0000, 'ºC'),
	(5585, 108, '2015-01-15 00:08:04.000000', 'temperatura', 924.0000, 'ºC'),
	(5586, 108, '2015-01-15 00:08:05.000000', 'temperatura', 635.0000, 'ºC'),
	(5587, 108, '2015-01-15 00:08:06.000000', 'temperatura', 405.0000, 'ºC'),
	(5588, 108, '2015-01-15 00:08:07.000000', 'temperatura', 121.0000, 'ºC'),
	(5589, 108, '2015-01-15 00:08:08.000000', 'temperatura', 587.0000, 'ºC'),
	(5590, 108, '2015-01-15 00:08:09.000000', 'temperatura', 175.0000, 'ºC'),
	(5591, 108, '2015-01-15 00:08:10.000000', 'temperatura', 315.0000, 'ºC'),
	(5592, 108, '2015-01-15 00:08:11.000000', 'temperatura', 1050.0000, 'ºC'),
	(5593, 108, '2015-01-15 00:08:12.000000', 'temperatura', 707.0000, 'ºC'),
	(5594, 108, '2015-01-15 00:08:13.000000', 'temperatura', 386.0000, 'ºC'),
	(5595, 108, '2015-01-15 00:08:14.000000', 'temperatura', 1007.0000, 'ºC'),
	(5596, 108, '2015-01-15 00:08:15.000000', 'temperatura', 280.0000, 'ºC'),
	(5597, 108, '2015-01-15 00:08:16.000000', 'temperatura', 777.0000, 'ºC'),
	(5598, 108, '2015-01-15 00:08:17.000000', 'temperatura', 648.0000, 'ºC'),
	(5599, 108, '2015-01-15 00:08:18.000000', 'temperatura', 910.0000, 'ºC'),
	(5600, 108, '2015-01-15 00:08:19.000000', 'temperatura', 207.0000, 'ºC'),
	(5601, 108, '2015-01-15 00:08:20.000000', 'temperatura', 702.0000, 'ºC'),
	(5602, 108, '2015-01-15 00:08:21.000000', 'temperatura', 493.0000, 'ºC'),
	(5603, 108, '2015-01-15 00:08:22.000000', 'temperatura', 356.0000, 'ºC'),
	(5604, 108, '2015-01-15 00:08:23.000000', 'temperatura', 304.0000, 'ºC'),
	(5605, 108, '2015-01-15 00:08:24.000000', 'temperatura', 450.0000, 'ºC'),
	(5606, 108, '2015-01-15 00:08:25.000000', 'temperatura', 139.0000, 'ºC'),
	(5607, 108, '2015-01-15 00:08:26.000000', 'temperatura', 545.0000, 'ºC'),
	(5608, 108, '2015-01-15 00:08:27.000000', 'temperatura', 1111.0000, 'ºC'),
	(5609, 108, '2015-01-15 00:08:28.000000', 'temperatura', 320.0000, 'ºC'),
	(5610, 108, '2015-01-15 00:08:29.000000', 'temperatura', 669.0000, 'ºC'),
	(5611, 108, '2015-01-15 00:08:30.000000', 'temperatura', 1184.0000, 'ºC'),
	(5612, 108, '2015-01-15 00:08:31.000000', 'temperatura', 314.0000, 'ºC'),
	(5613, 108, '2015-01-15 00:08:32.000000', 'temperatura', 416.0000, 'ºC'),
	(5614, 108, '2015-01-15 00:08:33.000000', 'temperatura', 1142.0000, 'ºC'),
	(5615, 108, '2015-01-15 00:08:34.000000', 'temperatura', 860.0000, 'ºC'),
	(5616, 108, '2015-01-15 00:08:35.000000', 'temperatura', 876.0000, 'ºC'),
	(5617, 108, '2015-01-15 00:08:36.000000', 'temperatura', 600.0000, 'ºC'),
	(5618, 108, '2015-01-15 00:08:37.000000', 'temperatura', 374.0000, 'ºC'),
	(5619, 108, '2015-01-15 00:08:38.000000', 'temperatura', 70.0000, 'ºC'),
	(5620, 108, '2015-01-15 00:08:39.000000', 'temperatura', 428.0000, 'ºC'),
	(5621, 108, '2015-01-15 00:08:40.000000', 'temperatura', 732.0000, 'ºC'),
	(5622, 108, '2015-01-15 00:08:41.000000', 'temperatura', 1176.0000, 'ºC'),
	(5623, 108, '2015-01-15 00:08:42.000000', 'temperatura', 86.0000, 'ºC'),
	(5624, 108, '2015-01-15 00:08:43.000000', 'temperatura', 499.0000, 'ºC'),
	(5625, 108, '2015-01-15 00:08:44.000000', 'temperatura', 1040.0000, 'ºC'),
	(5626, 108, '2015-01-15 00:08:45.000000', 'temperatura', 103.0000, 'ºC'),
	(5627, 108, '2015-01-15 00:08:46.000000', 'temperatura', 994.0000, 'ºC'),
	(5628, 108, '2015-01-15 00:08:47.000000', 'temperatura', 1062.0000, 'ºC'),
	(5629, 108, '2015-01-15 00:08:48.000000', 'temperatura', 1128.0000, 'ºC'),
	(5630, 108, '2015-01-15 00:08:49.000000', 'temperatura', 54.0000, 'ºC'),
	(5631, 108, '2015-01-15 00:08:50.000000', 'temperatura', 486.0000, 'ºC'),
	(5632, 108, '2015-01-15 00:08:51.000000', 'temperatura', 1071.0000, 'ºC'),
	(5633, 108, '2015-01-15 00:08:52.000000', 'temperatura', 298.0000, 'ºC'),
	(5634, 108, '2015-01-15 00:08:53.000000', 'temperatura', 674.0000, 'ºC'),
	(5635, 108, '2015-01-15 00:08:54.000000', 'temperatura', 79.0000, 'ºC'),
	(5636, 108, '2015-01-15 00:08:55.000000', 'temperatura', 773.0000, 'ºC'),
	(5637, 108, '2015-01-15 00:08:56.000000', 'temperatura', 30.0000, 'ºC'),
	(5638, 108, '2015-01-15 00:08:57.000000', 'temperatura', 232.0000, 'ºC'),
	(5639, 108, '2015-01-15 00:08:58.000000', 'temperatura', 1071.0000, 'ºC'),
	(5640, 108, '2015-01-15 00:08:59.000000', 'temperatura', 1057.0000, 'ºC'),
	(5641, 108, '2015-01-15 00:09:00.000000', 'temperatura', 873.0000, 'ºC'),
	(5642, 108, '2015-01-15 00:09:01.000000', 'temperatura', 1194.0000, 'ºC'),
	(5643, 108, '2015-01-15 00:09:02.000000', 'temperatura', 952.0000, 'ºC'),
	(5644, 108, '2015-01-15 00:09:03.000000', 'temperatura', 1177.0000, 'ºC'),
	(5645, 108, '2015-01-15 00:09:04.000000', 'temperatura', 629.0000, 'ºC'),
	(5646, 108, '2015-01-15 00:09:05.000000', 'temperatura', 817.0000, 'ºC'),
	(5647, 108, '2015-01-15 00:09:06.000000', 'temperatura', 996.0000, 'ºC'),
	(5648, 108, '2015-01-15 00:09:07.000000', 'temperatura', 129.0000, 'ºC'),
	(5649, 108, '2015-01-15 00:09:08.000000', 'temperatura', 57.0000, 'ºC'),
	(5650, 108, '2015-01-15 00:09:09.000000', 'temperatura', 1099.0000, 'ºC'),
	(5651, 108, '2015-01-15 00:09:10.000000', 'temperatura', 523.0000, 'ºC'),
	(5652, 108, '2015-01-15 00:09:11.000000', 'temperatura', 519.0000, 'ºC'),
	(5653, 108, '2015-01-15 00:09:12.000000', 'temperatura', 1027.0000, 'ºC'),
	(5654, 108, '2015-01-15 00:09:13.000000', 'temperatura', 1178.0000, 'ºC'),
	(5655, 108, '2015-01-15 00:09:14.000000', 'temperatura', 409.0000, 'ºC'),
	(5656, 108, '2015-01-15 00:09:15.000000', 'temperatura', 914.0000, 'ºC'),
	(5657, 108, '2015-01-15 00:09:16.000000', 'temperatura', 943.0000, 'ºC'),
	(5658, 108, '2015-01-15 00:09:17.000000', 'temperatura', 771.0000, 'ºC'),
	(5659, 108, '2015-01-15 00:09:18.000000', 'temperatura', 1029.0000, 'ºC'),
	(5660, 108, '2015-01-15 00:09:19.000000', 'temperatura', 432.0000, 'ºC'),
	(5661, 108, '2015-01-15 00:09:20.000000', 'temperatura', 272.0000, 'ºC'),
	(5662, 108, '2015-01-15 00:09:21.000000', 'temperatura', 64.0000, 'ºC'),
	(5663, 108, '2015-01-15 00:09:22.000000', 'temperatura', 704.0000, 'ºC'),
	(5664, 108, '2015-01-15 00:09:23.000000', 'temperatura', 929.0000, 'ºC'),
	(5665, 108, '2015-01-15 00:09:24.000000', 'temperatura', 133.0000, 'ºC'),
	(5666, 108, '2015-01-15 00:09:25.000000', 'temperatura', 280.0000, 'ºC'),
	(5667, 108, '2015-01-15 00:09:26.000000', 'temperatura', 1001.0000, 'ºC'),
	(5668, 108, '2015-01-15 00:09:27.000000', 'temperatura', 567.0000, 'ºC'),
	(5669, 108, '2015-01-15 00:09:28.000000', 'temperatura', 1032.0000, 'ºC'),
	(5670, 108, '2015-01-15 00:09:29.000000', 'temperatura', 1059.0000, 'ºC'),
	(5671, 108, '2015-01-15 00:09:30.000000', 'temperatura', 1001.0000, 'ºC'),
	(5672, 108, '2015-01-15 00:09:31.000000', 'temperatura', 628.0000, 'ºC'),
	(5673, 108, '2015-01-15 00:09:32.000000', 'temperatura', 139.0000, 'ºC'),
	(5674, 108, '2015-01-15 00:09:33.000000', 'temperatura', 11.0000, 'ºC'),
	(5675, 108, '2015-01-15 00:09:34.000000', 'temperatura', 838.0000, 'ºC'),
	(5676, 108, '2015-01-15 00:09:35.000000', 'temperatura', 559.0000, 'ºC'),
	(5677, 108, '2015-01-15 00:09:36.000000', 'temperatura', 279.0000, 'ºC'),
	(5678, 108, '2015-01-15 00:09:37.000000', 'temperatura', 918.0000, 'ºC'),
	(5679, 108, '2015-01-15 00:09:38.000000', 'temperatura', 156.0000, 'ºC'),
	(5680, 108, '2015-01-15 00:09:39.000000', 'temperatura', 424.0000, 'ºC'),
	(5681, 108, '2015-01-15 00:09:40.000000', 'temperatura', 452.0000, 'ºC'),
	(5682, 108, '2015-01-15 00:09:41.000000', 'temperatura', 988.0000, 'ºC'),
	(5683, 108, '2015-01-15 00:09:42.000000', 'temperatura', 1188.0000, 'ºC'),
	(5684, 108, '2015-01-15 00:09:43.000000', 'temperatura', 574.0000, 'ºC'),
	(5685, 108, '2015-01-15 00:09:44.000000', 'temperatura', 506.0000, 'ºC'),
	(5686, 108, '2015-01-15 00:09:45.000000', 'temperatura', 807.0000, 'ºC'),
	(5687, 108, '2015-01-15 00:09:46.000000', 'temperatura', 120.0000, 'ºC'),
	(5688, 108, '2015-01-15 00:09:47.000000', 'temperatura', 578.0000, 'ºC'),
	(5689, 108, '2015-01-15 00:09:48.000000', 'temperatura', 133.0000, 'ºC'),
	(5690, 108, '2015-01-15 00:09:49.000000', 'temperatura', 129.0000, 'ºC'),
	(5691, 108, '2015-01-15 00:09:50.000000', 'temperatura', 248.0000, 'ºC'),
	(5692, 108, '2015-01-15 00:09:51.000000', 'temperatura', 852.0000, 'ºC'),
	(5693, 108, '2015-01-15 00:09:52.000000', 'temperatura', 1118.0000, 'ºC'),
	(5694, 108, '2015-01-15 00:09:53.000000', 'temperatura', 632.0000, 'ºC'),
	(5695, 108, '2015-01-15 00:09:54.000000', 'temperatura', 1009.0000, 'ºC'),
	(5696, 108, '2015-01-15 00:09:55.000000', 'temperatura', 747.0000, 'ºC'),
	(5697, 108, '2015-01-15 00:09:56.000000', 'temperatura', 709.0000, 'ºC'),
	(5698, 108, '2015-01-15 00:09:57.000000', 'temperatura', 104.0000, 'ºC'),
	(5699, 108, '2015-01-15 00:09:58.000000', 'temperatura', 796.0000, 'ºC'),
	(5700, 108, '2015-01-15 00:09:59.000000', 'temperatura', 69.0000, 'ºC'),
	(5701, 108, '2015-01-15 00:10:00.000000', 'temperatura', 354.0000, 'ºC'),
	(5702, 108, '2015-01-15 00:10:01.000000', 'temperatura', 367.0000, 'ºC'),
	(5703, 108, '2015-01-15 00:10:02.000000', 'temperatura', 772.0000, 'ºC'),
	(5704, 108, '2015-01-15 00:10:03.000000', 'temperatura', 360.0000, 'ºC'),
	(5705, 108, '2015-01-15 00:10:04.000000', 'temperatura', 685.0000, 'ºC'),
	(5706, 108, '2015-01-15 00:10:05.000000', 'temperatura', 1146.0000, 'ºC'),
	(5707, 108, '2015-01-15 00:10:06.000000', 'temperatura', 76.0000, 'ºC'),
	(5708, 108, '2015-01-15 00:10:07.000000', 'temperatura', 543.0000, 'ºC'),
	(5709, 108, '2015-01-15 00:10:08.000000', 'temperatura', 89.0000, 'ºC'),
	(5710, 108, '2015-01-15 00:10:09.000000', 'temperatura', 13.0000, 'ºC'),
	(5711, 108, '2015-01-15 00:10:10.000000', 'temperatura', 999.0000, 'ºC'),
	(5712, 108, '2015-01-15 00:10:11.000000', 'temperatura', 157.0000, 'ºC'),
	(5713, 108, '2015-01-15 00:10:12.000000', 'temperatura', 188.0000, 'ºC'),
	(5714, 108, '2015-01-15 00:10:13.000000', 'temperatura', 470.0000, 'ºC'),
	(5715, 108, '2015-01-15 00:10:14.000000', 'temperatura', 588.0000, 'ºC'),
	(5716, 108, '2015-01-15 00:10:15.000000', 'temperatura', 328.0000, 'ºC'),
	(5717, 108, '2015-01-15 00:10:16.000000', 'temperatura', 1076.0000, 'ºC'),
	(5718, 108, '2015-01-15 00:10:17.000000', 'temperatura', 797.0000, 'ºC'),
	(5719, 108, '2015-01-15 00:10:18.000000', 'temperatura', 758.0000, 'ºC'),
	(5720, 108, '2015-01-15 00:10:19.000000', 'temperatura', 200.0000, 'ºC'),
	(5721, 108, '2015-01-15 00:10:20.000000', 'temperatura', 1125.0000, 'ºC'),
	(5722, 108, '2015-01-15 00:10:21.000000', 'temperatura', 226.0000, 'ºC'),
	(5723, 108, '2015-01-15 00:10:22.000000', 'temperatura', 155.0000, 'ºC'),
	(5724, 108, '2015-01-15 00:10:23.000000', 'temperatura', 100.0000, 'ºC'),
	(5725, 108, '2015-01-15 00:10:24.000000', 'temperatura', 33.0000, 'ºC'),
	(5726, 108, '2015-01-15 00:10:25.000000', 'temperatura', 1065.0000, 'ºC'),
	(5727, 108, '2015-01-15 00:10:26.000000', 'temperatura', 427.0000, 'ºC'),
	(5728, 108, '2015-01-15 00:10:27.000000', 'temperatura', 140.0000, 'ºC'),
	(5729, 108, '2015-01-15 00:10:28.000000', 'temperatura', 619.0000, 'ºC'),
	(5730, 108, '2015-01-15 00:10:29.000000', 'temperatura', 277.0000, 'ºC'),
	(5731, 108, '2015-01-15 00:10:30.000000', 'temperatura', 728.0000, 'ºC'),
	(5732, 108, '2015-01-15 00:10:31.000000', 'temperatura', 410.0000, 'ºC'),
	(5733, 108, '2015-01-15 00:10:32.000000', 'temperatura', 1068.0000, 'ºC'),
	(5734, 108, '2015-01-15 00:10:33.000000', 'temperatura', 510.0000, 'ºC'),
	(5735, 108, '2015-01-15 00:10:34.000000', 'temperatura', 544.0000, 'ºC'),
	(5736, 108, '2015-01-15 00:10:35.000000', 'temperatura', 1193.0000, 'ºC'),
	(5737, 108, '2015-01-15 00:10:36.000000', 'temperatura', 733.0000, 'ºC'),
	(5738, 108, '2015-01-15 00:10:37.000000', 'temperatura', 85.0000, 'ºC'),
	(5739, 108, '2015-01-15 00:10:38.000000', 'temperatura', 626.0000, 'ºC'),
	(5740, 108, '2015-01-15 00:10:39.000000', 'temperatura', 476.0000, 'ºC'),
	(5741, 108, '2015-01-15 00:10:40.000000', 'temperatura', 502.0000, 'ºC'),
	(5742, 108, '2015-01-15 00:10:41.000000', 'temperatura', 1082.0000, 'ºC'),
	(5743, 108, '2015-01-15 00:10:42.000000', 'temperatura', 306.0000, 'ºC'),
	(5744, 108, '2015-01-15 00:10:43.000000', 'temperatura', 686.0000, 'ºC'),
	(5745, 108, '2015-01-15 00:10:44.000000', 'temperatura', 111.0000, 'ºC'),
	(5746, 108, '2015-01-15 00:10:45.000000', 'temperatura', 899.0000, 'ºC'),
	(5747, 108, '2015-01-15 00:10:46.000000', 'temperatura', 560.0000, 'ºC'),
	(5748, 108, '2015-01-15 00:10:47.000000', 'temperatura', 104.0000, 'ºC'),
	(5749, 108, '2015-01-15 00:10:48.000000', 'temperatura', 40.0000, 'ºC'),
	(5750, 108, '2015-01-15 00:10:49.000000', 'temperatura', 1089.0000, 'ºC'),
	(5751, 108, '2015-01-15 00:10:50.000000', 'temperatura', 526.0000, 'ºC'),
	(5752, 108, '2015-01-15 00:10:51.000000', 'temperatura', 564.0000, 'ºC'),
	(5753, 108, '2015-01-15 00:10:52.000000', 'temperatura', 41.0000, 'ºC'),
	(5754, 108, '2015-01-15 00:10:53.000000', 'temperatura', 916.0000, 'ºC'),
	(5755, 108, '2015-01-15 00:10:54.000000', 'temperatura', 855.0000, 'ºC'),
	(5756, 108, '2015-01-15 00:10:55.000000', 'temperatura', 326.0000, 'ºC'),
	(5757, 108, '2015-01-15 00:10:56.000000', 'temperatura', 268.0000, 'ºC'),
	(5758, 108, '2015-01-15 00:10:57.000000', 'temperatura', 362.0000, 'ºC'),
	(5759, 108, '2015-01-15 00:10:58.000000', 'temperatura', 1006.0000, 'ºC'),
	(5760, 108, '2015-01-15 00:10:59.000000', 'temperatura', 345.0000, 'ºC'),
	(5761, 108, '2015-01-15 00:11:00.000000', 'temperatura', 1108.0000, 'ºC'),
	(5762, 108, '2015-01-15 00:11:01.000000', 'temperatura', 906.0000, 'ºC'),
	(5763, 108, '2015-01-15 00:11:02.000000', 'temperatura', 7.0000, 'ºC'),
	(5764, 108, '2015-01-15 00:11:03.000000', 'temperatura', 916.0000, 'ºC'),
	(5765, 108, '2015-01-15 00:11:04.000000', 'temperatura', 962.0000, 'ºC'),
	(5766, 108, '2015-01-15 00:11:05.000000', 'temperatura', 859.0000, 'ºC'),
	(5767, 108, '2015-01-15 00:11:06.000000', 'temperatura', 213.0000, 'ºC'),
	(5768, 108, '2015-01-15 00:11:07.000000', 'temperatura', 887.0000, 'ºC'),
	(5769, 108, '2015-01-15 00:11:08.000000', 'temperatura', 195.0000, 'ºC'),
	(5770, 108, '2015-01-15 00:11:09.000000', 'temperatura', 714.0000, 'ºC'),
	(5771, 108, '2015-01-15 00:11:10.000000', 'temperatura', 585.0000, 'ºC'),
	(5772, 108, '2015-01-15 00:11:11.000000', 'temperatura', 783.0000, 'ºC'),
	(5773, 108, '2015-01-15 00:11:12.000000', 'temperatura', 960.0000, 'ºC'),
	(5774, 108, '2015-01-15 00:11:13.000000', 'temperatura', 51.0000, 'ºC'),
	(5775, 108, '2015-01-15 00:11:14.000000', 'temperatura', 978.0000, 'ºC'),
	(5776, 108, '2015-01-15 00:11:15.000000', 'temperatura', 1136.0000, 'ºC'),
	(5777, 108, '2015-01-15 00:11:16.000000', 'temperatura', 347.0000, 'ºC'),
	(5778, 108, '2015-01-15 00:11:17.000000', 'temperatura', 725.0000, 'ºC'),
	(5779, 108, '2015-01-15 00:11:18.000000', 'temperatura', 188.0000, 'ºC'),
	(5780, 108, '2015-01-15 00:11:19.000000', 'temperatura', 1165.0000, 'ºC'),
	(5781, 108, '2015-01-15 00:11:20.000000', 'temperatura', 462.0000, 'ºC'),
	(5782, 108, '2015-01-15 00:11:21.000000', 'temperatura', 17.0000, 'ºC'),
	(5783, 108, '2015-01-15 00:11:22.000000', 'temperatura', 1096.0000, 'ºC'),
	(5784, 108, '2015-01-15 00:11:23.000000', 'temperatura', 632.0000, 'ºC'),
	(5785, 108, '2015-01-15 00:11:24.000000', 'temperatura', 1074.0000, 'ºC'),
	(5786, 108, '2015-01-15 00:11:25.000000', 'temperatura', 1071.0000, 'ºC'),
	(5787, 108, '2015-01-15 00:11:26.000000', 'temperatura', 934.0000, 'ºC'),
	(5788, 108, '2015-01-15 00:11:27.000000', 'temperatura', 257.0000, 'ºC'),
	(5789, 108, '2015-01-15 00:11:28.000000', 'temperatura', 884.0000, 'ºC'),
	(5790, 108, '2015-01-15 00:11:29.000000', 'temperatura', 51.0000, 'ºC'),
	(5791, 108, '2015-01-15 00:11:30.000000', 'temperatura', 3.0000, 'ºC'),
	(5792, 108, '2015-01-15 00:11:31.000000', 'temperatura', 1064.0000, 'ºC'),
	(5793, 108, '2015-01-15 00:11:32.000000', 'temperatura', 509.0000, 'ºC'),
	(5794, 108, '2015-01-15 00:11:33.000000', 'temperatura', 555.0000, 'ºC'),
	(5795, 108, '2015-01-15 00:11:34.000000', 'temperatura', 48.0000, 'ºC'),
	(5796, 108, '2015-01-15 00:11:35.000000', 'temperatura', 976.0000, 'ºC'),
	(5797, 108, '2015-01-15 00:11:36.000000', 'temperatura', 1135.0000, 'ºC'),
	(5798, 108, '2015-01-15 00:11:37.000000', 'temperatura', 348.0000, 'ºC'),
	(5799, 108, '2015-01-15 00:11:38.000000', 'temperatura', 737.0000, 'ºC'),
	(5800, 108, '2015-01-15 00:11:39.000000', 'temperatura', 242.0000, 'ºC'),
	(5801, 108, '2015-01-15 00:11:40.000000', 'temperatura', 199.0000, 'ºC'),
	(5802, 108, '2015-01-15 00:11:41.000000', 'temperatura', 270.0000, 'ºC'),
	(5803, 108, '2015-01-15 00:11:42.000000', 'temperatura', 754.0000, 'ºC'),
	(5804, 108, '2015-01-15 00:11:43.000000', 'temperatura', 558.0000, 'ºC'),
	(5805, 108, '2015-01-15 00:11:44.000000', 'temperatura', 529.0000, 'ºC'),
	(5806, 108, '2015-01-15 00:11:45.000000', 'temperatura', 973.0000, 'ºC'),
	(5807, 108, '2015-01-15 00:11:46.000000', 'temperatura', 876.0000, 'ºC'),
	(5808, 108, '2015-01-15 00:11:47.000000', 'temperatura', 262.0000, 'ºC'),
	(5809, 108, '2015-01-15 00:11:48.000000', 'temperatura', 1084.0000, 'ºC'),
	(5810, 108, '2015-01-15 00:11:49.000000', 'temperatura', 1034.0000, 'ºC'),
	(5811, 108, '2015-01-15 00:11:50.000000', 'temperatura', 719.0000, 'ºC'),
	(5812, 108, '2015-01-15 00:11:51.000000', 'temperatura', 494.0000, 'ºC'),
	(5813, 108, '2015-01-15 00:11:52.000000', 'temperatura', 312.0000, 'ºC'),
	(5814, 108, '2015-01-15 00:11:53.000000', 'temperatura', 79.0000, 'ºC'),
	(5815, 108, '2015-01-15 00:11:54.000000', 'temperatura', 661.0000, 'ºC'),
	(5816, 108, '2015-01-15 00:11:55.000000', 'temperatura', 667.0000, 'ºC'),
	(5817, 108, '2015-01-15 00:11:56.000000', 'temperatura', 152.0000, 'ºC'),
	(5818, 108, '2015-01-15 00:11:57.000000', 'temperatura', 1162.0000, 'ºC'),
	(5819, 108, '2015-01-15 00:11:58.000000', 'temperatura', 553.0000, 'ºC'),
	(5820, 108, '2015-01-15 00:11:59.000000', 'temperatura', 479.0000, 'ºC'),
	(5821, 108, '2015-01-15 00:12:00.000000', 'temperatura', 735.0000, 'ºC'),
	(5822, 108, '2015-01-15 00:12:01.000000', 'temperatura', 1042.0000, 'ºC'),
	(5823, 108, '2015-01-15 00:12:02.000000', 'temperatura', 602.0000, 'ºC'),
	(5824, 108, '2015-01-15 00:12:03.000000', 'temperatura', 1086.0000, 'ºC'),
	(5825, 108, '2015-01-15 00:12:04.000000', 'temperatura', 26.0000, 'ºC'),
	(5826, 108, '2015-01-15 00:12:05.000000', 'temperatura', 472.0000, 'ºC'),
	(5827, 108, '2015-01-15 00:12:06.000000', 'temperatura', 1082.0000, 'ºC'),
	(5828, 108, '2015-01-15 00:12:07.000000', 'temperatura', 396.0000, 'ºC'),
	(5829, 108, '2015-01-15 00:12:08.000000', 'temperatura', 1134.0000, 'ºC'),
	(5830, 108, '2015-01-15 00:12:09.000000', 'temperatura', 880.0000, 'ºC'),
	(5831, 108, '2015-01-15 00:12:10.000000', 'temperatura', 1000.0000, 'ºC'),
	(5832, 108, '2015-01-15 00:12:11.000000', 'temperatura', 1162.0000, 'ºC'),
	(5833, 108, '2015-01-15 00:12:12.000000', 'temperatura', 411.0000, 'ºC'),
	(5834, 108, '2015-01-15 00:12:13.000000', 'temperatura', 967.0000, 'ºC'),
	(5835, 108, '2015-01-15 00:12:14.000000', 'temperatura', 5.0000, 'ºC'),
	(5836, 108, '2015-01-15 00:12:15.000000', 'temperatura', 723.0000, 'ºC'),
	(5837, 108, '2015-01-15 00:12:16.000000', 'temperatura', 0.0000, 'ºC'),
	(5838, 108, '2015-01-15 00:12:17.000000', 'temperatura', 231.0000, 'ºC'),
	(5839, 108, '2015-01-15 00:12:18.000000', 'temperatura', 1158.0000, 'ºC'),
	(5840, 108, '2015-01-15 00:12:19.000000', 'temperatura', 297.0000, 'ºC'),
	(5841, 108, '2015-01-15 00:12:20.000000', 'temperatura', 410.0000, 'ºC'),
	(5842, 108, '2015-01-15 00:12:21.000000', 'temperatura', 1162.0000, 'ºC'),
	(5843, 108, '2015-01-15 00:12:22.000000', 'temperatura', 979.0000, 'ºC'),
	(5844, 108, '2015-01-15 00:12:23.000000', 'temperatura', 208.0000, 'ºC'),
	(5845, 108, '2015-01-15 00:12:24.000000', 'temperatura', 504.0000, 'ºC'),
	(5846, 108, '2015-01-15 00:12:25.000000', 'temperatura', 697.0000, 'ºC'),
	(5847, 108, '2015-01-15 00:12:26.000000', 'temperatura', 773.0000, 'ºC'),
	(5848, 108, '2015-01-15 00:12:27.000000', 'temperatura', 574.0000, 'ºC'),
	(5849, 108, '2015-01-15 00:12:28.000000', 'temperatura', 553.0000, 'ºC'),
	(5850, 108, '2015-01-15 00:12:29.000000', 'temperatura', 1043.0000, 'ºC'),
	(5851, 108, '2015-01-15 00:12:30.000000', 'temperatura', 1156.0000, 'ºC'),
	(5852, 108, '2015-01-15 00:12:31.000000', 'temperatura', 253.0000, 'ºC'),
	(5853, 108, '2015-01-15 00:12:32.000000', 'temperatura', 197.0000, 'ºC'),
	(5854, 108, '2015-01-15 00:12:33.000000', 'temperatura', 227.0000, 'ºC'),
	(5855, 108, '2015-01-15 00:12:34.000000', 'temperatura', 544.0000, 'ºC'),
	(5856, 108, '2015-01-15 00:12:35.000000', 'temperatura', 839.0000, 'ºC'),
	(5857, 108, '2015-01-15 00:12:36.000000', 'temperatura', 165.0000, 'ºC'),
	(5858, 108, '2015-01-15 00:12:37.000000', 'temperatura', 709.0000, 'ºC'),
	(5859, 108, '2015-01-15 00:12:38.000000', 'temperatura', 648.0000, 'ºC'),
	(5860, 108, '2015-01-15 00:12:39.000000', 'temperatura', 1114.0000, 'ºC'),
	(5861, 108, '2015-01-15 00:12:40.000000', 'temperatura', 28.0000, 'ºC'),
	(5862, 108, '2015-01-15 00:12:41.000000', 'temperatura', 400.0000, 'ºC'),
	(5863, 108, '2015-01-15 00:12:42.000000', 'temperatura', 713.0000, 'ºC'),
	(5864, 108, '2015-01-15 00:12:43.000000', 'temperatura', 1169.0000, 'ºC'),
	(5865, 108, '2015-01-15 00:12:44.000000', 'temperatura', 104.0000, 'ºC'),
	(5866, 108, '2015-01-15 00:12:45.000000', 'temperatura', 616.0000, 'ºC'),
	(5867, 108, '2015-01-15 00:12:46.000000', 'temperatura', 369.0000, 'ºC'),
	(5868, 108, '2015-01-15 00:12:47.000000', 'temperatura', 1194.0000, 'ºC'),
	(5869, 108, '2015-01-15 00:12:48.000000', 'temperatura', 66.0000, 'ºC'),
	(5870, 108, '2015-01-15 00:12:49.000000', 'temperatura', 347.0000, 'ºC'),
	(5871, 108, '2015-01-15 00:12:50.000000', 'temperatura', 338.0000, 'ºC'),
	(5872, 108, '2015-01-15 00:12:51.000000', 'temperatura', 651.0000, 'ºC'),
	(5873, 108, '2015-01-15 00:12:52.000000', 'temperatura', 1041.0000, 'ºC'),
	(5874, 108, '2015-01-15 00:12:53.000000', 'temperatura', 852.0000, 'ºC'),
	(5875, 108, '2015-01-15 00:12:54.000000', 'temperatura', 1136.0000, 'ºC'),
	(5876, 108, '2015-01-15 00:12:55.000000', 'temperatura', 727.0000, 'ºC'),
	(5877, 108, '2015-01-15 00:12:56.000000', 'temperatura', 227.0000, 'ºC'),
	(5878, 108, '2015-01-15 00:12:57.000000', 'temperatura', 156.0000, 'ºC'),
	(5879, 108, '2015-01-15 00:12:58.000000', 'temperatura', 96.0000, 'ºC'),
	(5880, 108, '2015-01-15 00:12:59.000000', 'temperatura', 15.0000, 'ºC'),
	(5881, 108, '2015-01-15 00:13:00.000000', 'temperatura', 985.0000, 'ºC'),
	(5882, 108, '2015-01-15 00:13:01.000000', 'temperatura', 83.0000, 'ºC'),
	(5883, 108, '2015-01-15 00:13:02.000000', 'temperatura', 1060.0000, 'ºC'),
	(5884, 108, '2015-01-15 00:13:03.000000', 'temperatura', 250.0000, 'ºC'),
	(5885, 108, '2015-01-15 00:13:04.000000', 'temperatura', 469.0000, 'ºC'),
	(5886, 108, '2015-01-15 00:13:05.000000', 'temperatura', 399.0000, 'ºC'),
	(5887, 108, '2015-01-15 00:13:06.000000', 'temperatura', 587.0000, 'ºC'),
	(5888, 108, '2015-01-15 00:13:07.000000', 'temperatura', 540.0000, 'ºC'),
	(5889, 108, '2015-01-15 00:13:08.000000', 'temperatura', 941.0000, 'ºC'),
	(5890, 108, '2015-01-15 00:13:09.000000', 'temperatura', 682.0000, 'ºC'),
	(5891, 108, '2015-01-15 00:13:10.000000', 'temperatura', 590.0000, 'ºC'),
	(5892, 108, '2015-01-15 00:13:11.000000', 'temperatura', 905.0000, 'ºC'),
	(5893, 108, '2015-01-15 00:13:12.000000', 'temperatura', 353.0000, 'ºC'),
	(5894, 108, '2015-01-15 00:13:13.000000', 'temperatura', 253.0000, 'ºC'),
	(5895, 108, '2015-01-15 00:13:14.000000', 'temperatura', 206.0000, 'ºC'),
	(5896, 108, '2015-01-15 00:13:15.000000', 'temperatura', 271.0000, 'ºC'),
	(5897, 108, '2015-01-15 00:13:16.000000', 'temperatura', 738.0000, 'ºC'),
	(5898, 108, '2015-01-15 00:13:17.000000', 'temperatura', 476.0000, 'ºC'),
	(5899, 108, '2015-01-15 00:13:18.000000', 'temperatura', 168.0000, 'ºC'),
	(5900, 108, '2015-01-15 00:13:19.000000', 'temperatura', 614.0000, 'ºC'),
	(5901, 108, '2015-01-15 00:13:20.000000', 'temperatura', 163.0000, 'ºC'),
	(5902, 108, '2015-01-15 00:13:21.000000', 'temperatura', 175.0000, 'ºC'),
	(5903, 108, '2015-01-15 00:13:22.000000', 'temperatura', 387.0000, 'ºC'),
	(5904, 108, '2015-01-15 00:13:23.000000', 'temperatura', 209.0000, 'ºC'),
	(5905, 108, '2015-01-15 00:13:24.000000', 'temperatura', 1084.0000, 'ºC'),
	(5906, 108, '2015-01-15 00:13:25.000000', 'temperatura', 1196.0000, 'ºC'),
	(5907, 108, '2015-01-15 00:13:26.000000', 'temperatura', 329.0000, 'ºC'),
	(5908, 108, '2015-01-15 00:13:27.000000', 'temperatura', 456.0000, 'ºC'),
	(5909, 108, '2015-01-15 00:13:28.000000', 'temperatura', 92.0000, 'ºC'),
	(5910, 108, '2015-01-15 00:13:29.000000', 'temperatura', 293.0000, 'ºC'),
	(5911, 108, '2015-01-15 00:13:30.000000', 'temperatura', 1190.0000, 'ºC'),
	(5912, 108, '2015-01-15 00:13:31.000000', 'temperatura', 271.0000, 'ºC'),
	(5913, 108, '2015-01-15 00:13:32.000000', 'temperatura', 185.0000, 'ºC'),
	(5914, 108, '2015-01-15 00:13:33.000000', 'temperatura', 111.0000, 'ºC'),
	(5915, 108, '2015-01-15 00:13:34.000000', 'temperatura', 4.0000, 'ºC'),
	(5916, 108, '2015-01-15 00:13:35.000000', 'temperatura', 886.0000, 'ºC'),
	(5917, 108, '2015-01-15 00:13:36.000000', 'temperatura', 819.0000, 'ºC'),
	(5918, 108, '2015-01-15 00:13:37.000000', 'temperatura', 239.0000, 'ºC'),
	(5919, 108, '2015-01-15 00:13:38.000000', 'temperatura', 1138.0000, 'ºC'),
	(5920, 108, '2015-01-15 00:13:39.000000', 'temperatura', 174.0000, 'ºC'),
	(5921, 108, '2015-01-15 00:13:40.000000', 'temperatura', 1055.0000, 'ºC'),
	(5922, 108, '2015-01-15 00:13:41.000000', 'temperatura', 1156.0000, 'ºC'),
	(5923, 108, '2015-01-15 00:13:42.000000', 'temperatura', 214.0000, 'ºC'),
	(5924, 108, '2015-01-15 00:13:43.000000', 'temperatura', 2.0000, 'ºC'),
	(5925, 108, '2015-01-15 00:13:44.000000', 'temperatura', 568.0000, 'ºC'),
	(5926, 108, '2015-01-15 00:13:45.000000', 'temperatura', 433.0000, 'ºC'),
	(5927, 108, '2015-01-15 00:13:46.000000', 'temperatura', 463.0000, 'ºC'),
	(5928, 108, '2015-01-15 00:13:47.000000', 'temperatura', 1017.0000, 'ºC'),
	(5929, 108, '2015-01-15 00:13:48.000000', 'temperatura', 94.0000, 'ºC'),
	(5930, 108, '2015-01-15 00:13:49.000000', 'temperatura', 1023.0000, 'ºC'),
	(5931, 108, '2015-01-15 00:13:50.000000', 'temperatura', 31.0000, 'ºC'),
	(5932, 108, '2015-01-15 00:13:51.000000', 'temperatura', 688.0000, 'ºC'),
	(5933, 108, '2015-01-15 00:13:52.000000', 'temperatura', 948.0000, 'ºC'),
	(5934, 108, '2015-01-15 00:13:53.000000', 'temperatura', 275.0000, 'ºC'),
	(5935, 108, '2015-01-15 00:13:54.000000', 'temperatura', 933.0000, 'ºC'),
	(5936, 108, '2015-01-15 00:13:55.000000', 'temperatura', 238.0000, 'ºC'),
	(5937, 108, '2015-01-15 00:13:56.000000', 'temperatura', 794.0000, 'ºC'),
	(5938, 108, '2015-01-15 00:13:57.000000', 'temperatura', 857.0000, 'ºC'),
	(5939, 108, '2015-01-15 00:13:58.000000', 'temperatura', 703.0000, 'ºC'),
	(5940, 108, '2015-01-15 00:13:59.000000', 'temperatura', 946.0000, 'ºC'),
	(5941, 108, '2015-01-15 00:14:00.000000', 'temperatura', 221.0000, 'ºC'),
	(5942, 108, '2015-01-15 00:14:01.000000', 'temperatura', 668.0000, 'ºC'),
	(5943, 108, '2015-01-15 00:14:02.000000', 'temperatura', 277.0000, 'ºC'),
	(5944, 108, '2015-01-15 00:14:03.000000', 'temperatura', 581.0000, 'ºC'),
	(5945, 108, '2015-01-15 00:14:04.000000', 'temperatura', 874.0000, 'ºC'),
	(5946, 108, '2015-01-15 00:14:05.000000', 'temperatura', 230.0000, 'ºC'),
	(5947, 108, '2015-01-15 00:14:06.000000', 'temperatura', 925.0000, 'ºC'),
	(5948, 108, '2015-01-15 00:14:07.000000', 'temperatura', 339.0000, 'ºC'),
	(5949, 108, '2015-01-15 00:14:08.000000', 'temperatura', 120.0000, 'ºC'),
	(5950, 108, '2015-01-15 00:14:09.000000', 'temperatura', 781.0000, 'ºC'),
	(5951, 108, '2015-01-15 00:14:10.000000', 'temperatura', 1146.0000, 'ºC'),
	(5952, 108, '2015-01-15 00:14:11.000000', 'temperatura', 987.0000, 'ºC'),
	(5953, 108, '2015-01-15 00:14:12.000000', 'temperatura', 300.0000, 'ºC'),
	(5954, 108, '2015-01-15 00:14:13.000000', 'temperatura', 939.0000, 'ºC'),
	(5955, 108, '2015-01-15 00:14:14.000000', 'temperatura', 196.0000, 'ºC'),
	(5956, 108, '2015-01-15 00:14:15.000000', 'temperatura', 564.0000, 'ºC'),
	(5957, 108, '2015-01-15 00:14:16.000000', 'temperatura', 1033.0000, 'ºC'),
	(5958, 108, '2015-01-15 00:14:17.000000', 'temperatura', 1073.0000, 'ºC'),
	(5959, 108, '2015-01-15 00:14:18.000000', 'temperatura', 1067.0000, 'ºC'),
	(5960, 108, '2015-01-15 00:14:19.000000', 'temperatura', 917.0000, 'ºC'),
	(5961, 108, '2015-01-15 00:14:20.000000', 'temperatura', 182.0000, 'ºC'),
	(5962, 108, '2015-01-15 00:14:21.000000', 'temperatura', 561.0000, 'ºC'),
	(5963, 108, '2015-01-15 00:14:22.000000', 'temperatura', 1058.0000, 'ºC'),
	(5964, 108, '2015-01-15 00:14:23.000000', 'temperatura', 8.0000, 'ºC'),
	(5965, 108, '2015-01-15 00:14:24.000000', 'temperatura', 467.0000, 'ºC'),
	(5966, 108, '2015-01-15 00:14:25.000000', 'temperatura', 1111.0000, 'ºC'),
	(5967, 108, '2015-01-15 00:14:26.000000', 'temperatura', 554.0000, 'ºC'),
	(5968, 108, '2015-01-15 00:14:27.000000', 'temperatura', 640.0000, 'ºC'),
	(5969, 108, '2015-01-15 00:14:28.000000', 'temperatura', 337.0000, 'ºC'),
	(5970, 108, '2015-01-15 00:14:29.000000', 'temperatura', 967.0000, 'ºC'),
	(5971, 108, '2015-01-15 00:14:30.000000', 'temperatura', 225.0000, 'ºC'),
	(5972, 108, '2015-01-15 00:14:31.000000', 'temperatura', 624.0000, 'ºC'),
	(5973, 108, '2015-01-15 00:14:32.000000', 'temperatura', 43.0000, 'ºC'),
	(5974, 108, '2015-01-15 00:14:33.000000', 'temperatura', 745.0000, 'ºC'),
	(5975, 108, '2015-01-15 00:14:34.000000', 'temperatura', 1198.0000, 'ºC'),
	(5976, 108, '2015-01-15 00:14:35.000000', 'temperatura', 154.0000, 'ºC'),
	(5977, 108, '2015-01-15 00:14:36.000000', 'temperatura', 778.0000, 'ºC'),
	(5978, 108, '2015-01-15 00:14:37.000000', 'temperatura', 1028.0000, 'ºC'),
	(5979, 108, '2015-01-15 00:14:38.000000', 'temperatura', 406.0000, 'ºC'),
	(5980, 108, '2015-01-15 00:14:39.000000', 'temperatura', 148.0000, 'ºC'),
	(5981, 108, '2015-01-15 00:14:40.000000', 'temperatura', 720.0000, 'ºC'),
	(5982, 108, '2015-01-15 00:14:41.000000', 'temperatura', 759.0000, 'ºC'),
	(5983, 108, '2015-01-15 00:14:42.000000', 'temperatura', 435.0000, 'ºC'),
	(5984, 108, '2015-01-15 00:14:43.000000', 'temperatura', 1099.0000, 'ºC'),
	(5985, 108, '2015-01-15 00:14:44.000000', 'temperatura', 589.0000, 'ºC'),
	(5986, 108, '2015-01-15 00:14:45.000000', 'temperatura', 850.0000, 'ºC'),
	(5987, 108, '2015-01-15 00:14:46.000000', 'temperatura', 82.0000, 'ºC'),
	(5988, 108, '2015-01-15 00:14:47.000000', 'temperatura', 263.0000, 'ºC'),
	(5989, 108, '2015-01-15 00:14:48.000000', 'temperatura', 1067.0000, 'ºC'),
	(5990, 108, '2015-01-15 00:14:49.000000', 'temperatura', 945.0000, 'ºC'),
	(5991, 108, '2015-01-15 00:14:50.000000', 'temperatura', 328.0000, 'ºC'),
	(5992, 108, '2015-01-15 00:14:51.000000', 'temperatura', 2.0000, 'ºC'),
	(5993, 108, '2015-01-15 00:14:52.000000', 'temperatura', 229.0000, 'ºC'),
	(5994, 108, '2015-01-15 00:14:53.000000', 'temperatura', 1139.0000, 'ºC'),
	(5995, 108, '2015-01-15 00:14:54.000000', 'temperatura', 207.0000, 'ºC'),
	(5996, 108, '2015-01-15 00:14:55.000000', 'temperatura', 19.0000, 'ºC'),
	(5997, 108, '2015-01-15 00:14:56.000000', 'temperatura', 673.0000, 'ºC'),
	(5998, 108, '2015-01-15 00:14:57.000000', 'temperatura', 912.0000, 'ºC'),
	(5999, 108, '2015-01-15 00:14:58.000000', 'temperatura', 139.0000, 'ºC'),
	(6000, 108, '2015-01-15 00:14:59.000000', 'temperatura', 360.0000, 'ºC'),
	(6001, 108, '2015-01-15 00:15:00.000000', 'temperatura', 185.0000, 'ºC'),
	(6002, 108, '2015-01-15 00:15:01.000000', 'temperatura', 1044.0000, 'ºC'),
	(6003, 108, '2015-01-15 00:15:02.000000', 'temperatura', 1067.0000, 'ºC'),
	(6004, 108, '2015-01-15 00:15:03.000000', 'temperatura', 1005.0000, 'ºC'),
	(6005, 108, '2015-01-15 00:15:04.000000', 'temperatura', 622.0000, 'ºC'),
	(6006, 108, '2015-01-15 00:15:05.000000', 'temperatura', 96.0000, 'ºC'),
	(6007, 108, '2015-01-15 00:15:06.000000', 'temperatura', 1015.0000, 'ºC'),
	(6008, 108, '2015-01-15 00:15:07.000000', 'temperatura', 1189.0000, 'ºC'),
	(6009, 108, '2015-01-15 00:15:08.000000', 'temperatura', 498.0000, 'ºC'),
	(6010, 108, '2015-01-15 00:15:09.000000', 'temperatura', 126.0000, 'ºC'),
	(6011, 108, '2015-01-15 00:15:10.000000', 'temperatura', 337.0000, 'ºC'),
	(6012, 108, '2015-01-15 00:15:11.000000', 'temperatura', 106.0000, 'ºC'),
	(6013, 108, '2015-01-15 00:15:12.000000', 'temperatura', 718.0000, 'ºC'),
	(6014, 108, '2015-01-15 00:15:13.000000', 'temperatura', 875.0000, 'ºC'),
	(6015, 108, '2015-01-15 00:15:14.000000', 'temperatura', 1021.0000, 'ºC'),
	(6016, 108, '2015-01-15 00:15:15.000000', 'temperatura', 81.0000, 'ºC'),
	(6017, 108, '2015-01-15 00:15:16.000000', 'temperatura', 944.0000, 'ºC'),
	(6018, 108, '2015-01-15 00:15:17.000000', 'temperatura', 874.0000, 'ºC'),
	(6019, 108, '2015-01-15 00:15:18.000000', 'temperatura', 341.0000, 'ºC'),
	(6020, 108, '2015-01-15 00:15:19.000000', 'temperatura', 282.0000, 'ºC'),
	(6021, 108, '2015-01-15 00:15:20.000000', 'temperatura', 387.0000, 'ºC'),
	(6022, 108, '2015-01-15 00:15:21.000000', 'temperatura', 1089.0000, 'ºC'),
	(6023, 108, '2015-01-15 00:15:22.000000', 'temperatura', 686.0000, 'ºC'),
	(6024, 108, '2015-01-15 00:15:23.000000', 'temperatura', 162.0000, 'ºC'),
	(6025, 108, '2015-01-15 00:15:24.000000', 'temperatura', 1154.0000, 'ºC'),
	(6026, 108, '2015-01-15 00:15:25.000000', 'temperatura', 483.0000, 'ºC'),
	(6027, 108, '2015-01-15 00:15:26.000000', 'temperatura', 153.0000, 'ºC'),
	(6028, 108, '2015-01-15 00:15:27.000000', 'temperatura', 517.0000, 'ºC'),
	(6029, 108, '2015-01-15 00:15:28.000000', 'temperatura', 928.0000, 'ºC'),
	(6030, 108, '2015-01-15 00:15:29.000000', 'temperatura', 687.0000, 'ºC'),
	(6031, 108, '2015-01-15 00:15:30.000000', 'temperatura', 651.0000, 'ºC'),
	(6032, 108, '2015-01-15 00:15:31.000000', 'temperatura', 1195.0000, 'ºC'),
	(6033, 108, '2015-01-15 00:15:32.000000', 'temperatura', 425.0000, 'ºC'),
	(6034, 108, '2015-01-15 00:15:33.000000', 'temperatura', 938.0000, 'ºC'),
	(6035, 108, '2015-01-15 00:15:34.000000', 'temperatura', 1015.0000, 'ºC'),
	(6036, 108, '2015-01-15 00:15:35.000000', 'temperatura', 1063.0000, 'ºC'),
	(6037, 108, '2015-01-15 00:15:36.000000', 'temperatura', 1070.0000, 'ºC'),
	(6038, 108, '2015-01-15 00:15:37.000000', 'temperatura', 961.0000, 'ºC'),
	(6039, 108, '2015-01-15 00:15:38.000000', 'temperatura', 394.0000, 'ºC'),
	(6040, 108, '2015-01-15 00:15:39.000000', 'temperatura', 290.0000, 'ºC'),
	(6041, 108, '2015-01-15 00:15:40.000000', 'temperatura', 269.0000, 'ºC'),
	(6042, 108, '2015-01-15 00:15:41.000000', 'temperatura', 475.0000, 'ºC'),
	(6043, 108, '2015-01-15 00:15:42.000000', 'temperatura', 367.0000, 'ºC'),
	(6044, 108, '2015-01-15 00:15:43.000000', 'temperatura', 410.0000, 'ºC'),
	(6045, 108, '2015-01-15 00:15:44.000000', 'temperatura', 950.0000, 'ºC'),
	(6046, 108, '2015-01-15 00:15:45.000000', 'temperatura', 1120.0000, 'ºC'),
	(6047, 108, '2015-01-15 00:15:46.000000', 'temperatura', 349.0000, 'ºC'),
	(6048, 108, '2015-01-15 00:15:47.000000', 'temperatura', 787.0000, 'ºC'),
	(6049, 108, '2015-01-15 00:15:48.000000', 'temperatura', 489.0000, 'ºC'),
	(6050, 108, '2015-01-15 00:15:49.000000', 'temperatura', 83.0000, 'ºC'),
	(6051, 108, '2015-01-15 00:15:50.000000', 'temperatura', 151.0000, 'ºC'),
	(6052, 108, '2015-01-15 00:15:51.000000', 'temperatura', 507.0000, 'ºC'),
	(6053, 108, '2015-01-15 00:15:52.000000', 'temperatura', 880.0000, 'ºC'),
	(6054, 108, '2015-01-15 00:15:53.000000', 'temperatura', 481.0000, 'ºC'),
	(6055, 108, '2015-01-15 00:15:54.000000', 'temperatura', 963.0000, 'ºC'),
	(6056, 108, '2015-01-15 00:15:55.000000', 'temperatura', 975.0000, 'ºC'),
	(6057, 108, '2015-01-15 00:15:56.000000', 'temperatura', 787.0000, 'ºC'),
	(6058, 108, '2015-01-15 00:15:57.000000', 'temperatura', 1010.0000, 'ºC'),
	(6059, 108, '2015-01-15 00:15:58.000000', 'temperatura', 287.0000, 'ºC'),
	(6060, 108, '2015-01-15 00:15:59.000000', 'temperatura', 808.0000, 'ºC'),
	(6061, 108, '2015-01-15 00:16:00.000000', 'temperatura', 779.0000, 'ºC'),
	(6062, 108, '2015-01-15 00:16:01.000000', 'temperatura', 270.0000, 'ºC'),
	(6063, 108, '2015-01-15 00:16:02.000000', 'temperatura', 215.0000, 'ºC'),
	(6064, 108, '2015-01-15 00:16:03.000000', 'temperatura', 264.0000, 'ºC'),
	(6065, 108, '2015-01-15 00:16:04.000000', 'temperatura', 677.0000, 'ºC'),
	(6066, 108, '2015-01-15 00:16:05.000000', 'temperatura', 191.0000, 'ºC'),
	(6067, 108, '2015-01-15 00:16:06.000000', 'temperatura', 128.0000, 'ºC'),
	(6068, 108, '2015-01-15 00:16:07.000000', 'temperatura', 66.0000, 'ºC'),
	(6069, 108, '2015-01-15 00:16:08.000000', 'temperatura', 1145.0000, 'ºC'),
	(6070, 108, '2015-01-15 00:16:09.000000', 'temperatura', 729.0000, 'ºC'),
	(6071, 108, '2015-01-15 00:16:10.000000', 'temperatura', 208.0000, 'ºC'),
	(6072, 108, '2015-01-15 00:16:11.000000', 'temperatura', 55.0000, 'ºC'),
	(6073, 108, '2015-01-15 00:16:12.000000', 'temperatura', 853.0000, 'ºC'),
	(6074, 108, '2015-01-15 00:16:13.000000', 'temperatura', 499.0000, 'ºC'),
	(6075, 108, '2015-01-15 00:16:14.000000', 'temperatura', 1137.0000, 'ºC'),
	(6076, 108, '2015-01-15 00:16:15.000000', 'temperatura', 590.0000, 'ºC'),
	(6077, 108, '2015-01-15 00:16:16.000000', 'temperatura', 740.0000, 'ºC'),
	(6078, 108, '2015-01-15 00:16:17.000000', 'temperatura', 731.0000, 'ºC'),
	(6079, 108, '2015-01-15 00:16:18.000000', 'temperatura', 234.0000, 'ºC'),
	(6080, 108, '2015-01-15 00:16:19.000000', 'temperatura', 178.0000, 'ºC'),
	(6081, 108, '2015-01-15 00:16:20.000000', 'temperatura', 190.0000, 'ºC'),
	(6082, 108, '2015-01-15 00:16:21.000000', 'temperatura', 416.0000, 'ºC'),
	(6083, 108, '2015-01-15 00:16:22.000000', 'temperatura', 309.0000, 'ºC'),
	(6084, 108, '2015-01-15 00:16:23.000000', 'temperatura', 300.0000, 'ºC'),
	(6085, 108, '2015-01-15 00:16:24.000000', 'temperatura', 573.0000, 'ºC'),
	(6086, 108, '2015-01-15 00:16:25.000000', 'temperatura', 766.0000, 'ºC'),
	(6087, 108, '2015-01-15 00:16:26.000000', 'temperatura', 910.0000, 'ºC'),
	(6088, 108, '2015-01-15 00:16:27.000000', 'temperatura', 1053.0000, 'ºC'),
	(6089, 108, '2015-01-15 00:16:28.000000', 'temperatura', 134.0000, 'ºC'),
	(6090, 108, '2015-01-15 00:16:29.000000', 'temperatura', 1113.0000, 'ºC'),
	(6091, 108, '2015-01-15 00:16:30.000000', 'temperatura', 363.0000, 'ºC'),
	(6092, 108, '2015-01-15 00:16:31.000000', 'temperatura', 876.0000, 'ºC'),
	(6093, 108, '2015-01-15 00:16:32.000000', 'temperatura', 892.0000, 'ºC'),
	(6094, 108, '2015-01-15 00:16:33.000000', 'temperatura', 634.0000, 'ºC'),
	(6095, 108, '2015-01-15 00:16:34.000000', 'temperatura', 495.0000, 'ºC'),
	(6096, 108, '2015-01-15 00:16:35.000000', 'temperatura', 572.0000, 'ºC'),
	(6097, 108, '2015-01-15 00:16:36.000000', 'temperatura', 176.0000, 'ºC'),
	(6098, 108, '2015-01-15 00:16:37.000000', 'temperatura', 364.0000, 'ºC'),
	(6099, 108, '2015-01-15 00:16:38.000000', 'temperatura', 93.0000, 'ºC'),
	(6100, 108, '2015-01-15 00:16:39.000000', 'temperatura', 571.0000, 'ºC'),
	(6101, 108, '2015-01-15 00:16:40.000000', 'temperatura', 179.0000, 'ºC'),
	(6102, 108, '2015-01-15 00:16:41.000000', 'temperatura', 384.0000, 'ºC'),
	(6103, 108, '2015-01-15 00:16:42.000000', 'temperatura', 182.0000, 'ºC'),
	(6104, 108, '2015-01-15 00:16:43.000000', 'temperatura', 959.0000, 'ºC'),
	(6105, 108, '2015-01-15 00:16:44.000000', 'temperatura', 649.0000, 'ºC'),
	(6106, 108, '2015-01-15 00:16:45.000000', 'temperatura', 367.0000, 'ºC'),
	(6107, 108, '2015-01-15 00:16:46.000000', 'temperatura', 1087.0000, 'ºC'),
	(6108, 108, '2015-01-15 00:16:47.000000', 'temperatura', 738.0000, 'ºC'),
	(6109, 108, '2015-01-15 00:16:48.000000', 'temperatura', 430.0000, 'ºC'),
	(6110, 108, '2015-01-15 00:16:49.000000', 'temperatura', 1137.0000, 'ºC'),
	(6111, 108, '2015-01-15 00:16:50.000000', 'temperatura', 793.0000, 'ºC'),
	(6112, 108, '2015-01-15 00:16:51.000000', 'temperatura', 554.0000, 'ºC'),
	(6113, 108, '2015-01-15 00:16:52.000000', 'temperatura', 394.0000, 'ºC'),
	(6114, 108, '2015-01-15 00:16:53.000000', 'temperatura', 308.0000, 'ºC'),
	(6115, 108, '2015-01-15 00:16:54.000000', 'temperatura', 360.0000, 'ºC'),
	(6116, 108, '2015-01-15 00:16:55.000000', 'temperatura', 874.0000, 'ºC'),
	(6117, 108, '2015-01-15 00:16:56.000000', 'temperatura', 891.0000, 'ºC'),
	(6118, 108, '2015-01-15 00:16:57.000000', 'temperatura', 632.0000, 'ºC'),
	(6119, 108, '2015-01-15 00:16:58.000000', 'temperatura', 490.0000, 'ºC'),
	(6120, 108, '2015-01-15 00:16:59.000000', 'temperatura', 552.0000, 'ºC'),
	(6121, 108, '2015-01-15 00:17:00.000000', 'temperatura', 90.0000, 'ºC'),
	(6122, 108, '2015-01-15 00:17:01.000000', 'temperatura', 1194.0000, 'ºC'),
	(6123, 108, '2015-01-15 00:17:02.000000', 'temperatura', 902.0000, 'ºC'),
	(6124, 108, '2015-01-15 00:17:03.000000', 'temperatura', 928.0000, 'ºC'),
	(6125, 108, '2015-01-15 00:17:04.000000', 'temperatura', 733.0000, 'ºC'),
	(6126, 108, '2015-01-15 00:17:05.000000', 'temperatura', 884.0000, 'ºC'),
	(6127, 108, '2015-01-15 00:17:06.000000', 'temperatura', 1022.0000, 'ºC'),
	(6128, 108, '2015-01-15 00:17:07.000000', 'temperatura', 57.0000, 'ºC'),
	(6129, 108, '2015-01-15 00:17:08.000000', 'temperatura', 818.0000, 'ºC'),
	(6130, 108, '2015-01-15 00:17:09.000000', 'temperatura', 321.0000, 'ºC'),
	(6131, 108, '2015-01-15 00:17:10.000000', 'temperatura', 350.0000, 'ºC'),
	(6132, 108, '2015-01-15 00:17:11.000000', 'temperatura', 791.0000, 'ºC'),
	(6133, 108, '2015-01-15 00:17:12.000000', 'temperatura', 502.0000, 'ºC'),
	(6134, 108, '2015-01-15 00:17:13.000000', 'temperatura', 138.0000, 'ºC'),
	(6135, 108, '2015-01-15 00:17:14.000000', 'temperatura', 384.0000, 'ºC'),
	(6136, 108, '2015-01-15 00:17:15.000000', 'temperatura', 307.0000, 'ºC'),
	(6137, 108, '2015-01-15 00:17:16.000000', 'temperatura', 383.0000, 'ºC'),
	(6138, 108, '2015-01-15 00:17:17.000000', 'temperatura', 997.0000, 'ºC'),
	(6139, 108, '2015-01-15 00:17:18.000000', 'temperatura', 234.0000, 'ºC'),
	(6140, 108, '2015-01-15 00:17:19.000000', 'temperatura', 580.0000, 'ºC'),
	(6141, 108, '2015-01-15 00:17:20.000000', 'temperatura', 997.0000, 'ºC'),
	(6142, 108, '2015-01-15 00:17:21.000000', 'temperatura', 849.0000, 'ºC'),
	(6143, 108, '2015-01-15 00:17:22.000000', 'temperatura', 51.0000, 'ºC'),
	(6144, 108, '2015-01-15 00:17:23.000000', 'temperatura', 110.0000, 'ºC'),
	(6145, 108, '2015-01-15 00:17:24.000000', 'temperatura', 396.0000, 'ºC'),
	(6146, 108, '2015-01-15 00:17:25.000000', 'temperatura', 449.0000, 'ºC'),
	(6147, 108, '2015-01-15 00:17:26.000000', 'temperatura', 1061.0000, 'ºC'),
	(6148, 108, '2015-01-15 00:17:27.000000', 'temperatura', 355.0000, 'ºC'),
	(6149, 108, '2015-01-15 00:17:28.000000', 'temperatura', 996.0000, 'ºC'),
	(6150, 108, '2015-01-15 00:17:29.000000', 'temperatura', 315.0000, 'ºC'),
	(6151, 108, '2015-01-15 00:17:30.000000', 'temperatura', 987.0000, 'ºC'),
	(6152, 108, '2015-01-15 00:17:31.000000', 'temperatura', 390.0000, 'ºC'),
	(6153, 108, '2015-01-15 00:17:32.000000', 'temperatura', 189.0000, 'ºC'),
	(6154, 108, '2015-01-15 00:17:33.000000', 'temperatura', 978.0000, 'ºC'),
	(6155, 108, '2015-01-15 00:17:34.000000', 'temperatura', 723.0000, 'ºC'),
	(6156, 108, '2015-01-15 00:17:35.000000', 'temperatura', 681.0000, 'ºC'),
	(6157, 108, '2015-01-15 00:17:36.000000', 'temperatura', 36.0000, 'ºC'),
	(6158, 108, '2015-01-15 00:17:37.000000', 'temperatura', 539.0000, 'ºC'),
	(6159, 108, '2015-01-15 00:17:38.000000', 'temperatura', 187.0000, 'ºC'),
	(6160, 108, '2015-01-15 00:17:39.000000', 'temperatura', 519.0000, 'ºC'),
	(6161, 108, '2015-01-15 00:17:40.000000', 'temperatura', 835.0000, 'ºC'),
	(6162, 108, '2015-01-15 00:17:41.000000', 'temperatura', 217.0000, 'ºC'),
	(6163, 108, '2015-01-15 00:17:42.000000', 'temperatura', 982.0000, 'ºC'),
	(6164, 108, '2015-01-15 00:17:43.000000', 'temperatura', 657.0000, 'ºC'),
	(6165, 108, '2015-01-15 00:17:44.000000', 'temperatura', 341.0000, 'ºC'),
	(6166, 108, '2015-01-15 00:17:45.000000', 'temperatura', 935.0000, 'ºC'),
	(6167, 108, '2015-01-15 00:17:46.000000', 'temperatura', 52.0000, 'ºC'),
	(6168, 108, '2015-01-15 00:17:47.000000', 'temperatura', 1058.0000, 'ºC'),
	(6169, 108, '2015-01-15 00:17:48.000000', 'temperatura', 331.0000, 'ºC'),
	(6170, 108, '2015-01-15 00:17:49.000000', 'temperatura', 884.0000, 'ºC'),
	(6171, 108, '2015-01-15 00:17:50.000000', 'temperatura', 1027.0000, 'ºC'),
	(6172, 108, '2015-01-15 00:17:51.000000', 'temperatura', 85.0000, 'ºC'),
	(6173, 108, '2015-01-15 00:17:52.000000', 'temperatura', 942.0000, 'ºC'),
	(6174, 108, '2015-01-15 00:17:53.000000', 'temperatura', 858.0000, 'ºC'),
	(6175, 108, '2015-01-15 00:17:54.000000', 'temperatura', 264.0000, 'ºC'),
	(6176, 108, '2015-01-15 00:17:55.000000', 'temperatura', 1145.0000, 'ºC'),
	(6177, 108, '2015-01-15 00:17:56.000000', 'temperatura', 133.0000, 'ºC'),
	(6178, 108, '2015-01-15 00:17:57.000000', 'temperatura', 830.0000, 'ºC'),
	(6179, 108, '2015-01-15 00:17:58.000000', 'temperatura', 154.0000, 'ºC'),
	(6180, 108, '2015-01-15 00:17:59.000000', 'temperatura', 678.0000, 'ºC'),
	(6181, 108, '2015-01-15 00:18:00.000000', 'temperatura', 528.0000, 'ºC'),
	(6182, 108, '2015-01-15 00:18:01.000000', 'temperatura', 606.0000, 'ºC'),
	(6183, 108, '2015-01-15 00:18:02.000000', 'temperatura', 249.0000, 'ºC'),
	(6184, 108, '2015-01-15 00:18:03.000000', 'temperatura', 628.0000, 'ºC'),
	(6185, 108, '2015-01-15 00:18:04.000000', 'temperatura', 1194.0000, 'ºC'),
	(6186, 108, '2015-01-15 00:18:05.000000', 'temperatura', 487.0000, 'ºC'),
	(6187, 108, '2015-01-15 00:18:06.000000', 'temperatura', 53.0000, 'ºC'),
	(6188, 108, '2015-01-15 00:18:07.000000', 'temperatura', 5.0000, 'ºC'),
	(6189, 108, '2015-01-15 00:18:08.000000', 'temperatura', 1066.0000, 'ºC'),
	(6190, 108, '2015-01-15 00:18:09.000000', 'temperatura', 515.0000, 'ºC'),
	(6191, 108, '2015-01-15 00:18:10.000000', 'temperatura', 577.0000, 'ºC'),
	(6192, 108, '2015-01-15 00:18:11.000000', 'temperatura', 140.0000, 'ºC'),
	(6193, 108, '2015-01-15 00:18:12.000000', 'temperatura', 169.0000, 'ºC'),
	(6194, 108, '2015-01-15 00:18:13.000000', 'temperatura', 425.0000, 'ºC'),
	(6195, 108, '2015-01-15 00:18:14.000000', 'temperatura', 418.0000, 'ºC'),
	(6196, 108, '2015-01-15 00:18:15.000000', 'temperatura', 815.0000, 'ºC'),
	(6197, 108, '2015-01-15 00:18:16.000000', 'temperatura', 424.0000, 'ºC'),
	(6198, 108, '2015-01-15 00:18:17.000000', 'temperatura', 873.0000, 'ºC'),
	(6199, 108, '2015-01-15 00:18:18.000000', 'temperatura', 696.0000, 'ºC'),
	(6200, 108, '2015-01-15 00:18:19.000000', 'temperatura', 859.0000, 'ºC'),
	(6201, 108, '2015-01-15 00:18:20.000000', 'temperatura', 1010.0000, 'ºC'),
	(6202, 108, '2015-01-15 00:18:21.000000', 'temperatura', 73.0000, 'ºC'),
	(6203, 108, '2015-01-15 00:18:22.000000', 'temperatura', 934.0000, 'ºC'),
	(6204, 108, '2015-01-15 00:18:23.000000', 'temperatura', 853.0000, 'ºC'),
	(6205, 108, '2015-01-15 00:18:24.000000', 'temperatura', 262.0000, 'ºC'),
	(6206, 108, '2015-01-15 00:18:25.000000', 'temperatura', 1151.0000, 'ºC'),
	(6207, 108, '2015-01-15 00:18:26.000000', 'temperatura', 170.0000, 'ºC'),
	(6208, 108, '2015-01-15 00:18:27.000000', 'temperatura', 998.0000, 'ºC'),
	(6209, 108, '2015-01-15 00:18:28.000000', 'temperatura', 879.0000, 'ºC'),
	(6210, 108, '2015-01-15 00:18:29.000000', 'temperatura', 204.0000, 'ºC'),
	(6211, 108, '2015-01-15 00:18:30.000000', 'temperatura', 782.0000, 'ºC'),
	(6212, 108, '2015-01-15 00:18:31.000000', 'temperatura', 897.0000, 'ºC'),
	(6213, 108, '2015-01-15 00:18:32.000000', 'temperatura', 939.0000, 'ºC'),
	(6214, 108, '2015-01-15 00:18:33.000000', 'temperatura', 808.0000, 'ºC'),
	(6215, 108, '2015-01-15 00:18:34.000000', 'temperatura', 20.0000, 'ºC'),
	(6216, 108, '2015-01-15 00:18:35.000000', 'temperatura', 78.0000, 'ºC'),
	(6217, 108, '2015-01-15 00:18:36.000000', 'temperatura', 331.0000, 'ºC'),
	(6218, 108, '2015-01-15 00:18:37.000000', 'temperatura', 222.0000, 'ºC'),
	(6219, 108, '2015-01-15 00:18:38.000000', 'temperatura', 118.0000, 'ºC'),
	(6220, 108, '2015-01-15 00:18:39.000000', 'temperatura', 1125.0000, 'ºC'),
	(6221, 108, '2015-01-15 00:18:40.000000', 'temperatura', 472.0000, 'ºC'),
	(6222, 108, '2015-01-15 00:18:41.000000', 'temperatura', 184.0000, 'ºC'),
	(6223, 108, '2015-01-15 00:18:42.000000', 'temperatura', 706.0000, 'ºC'),
	(6224, 108, '2015-01-15 00:18:43.000000', 'temperatura', 580.0000, 'ºC'),
	(6225, 108, '2015-01-15 00:18:44.000000', 'temperatura', 780.0000, 'ºC'),
	(6226, 108, '2015-01-15 00:18:45.000000', 'temperatura', 962.0000, 'ºC'),
	(6227, 108, '2015-01-15 00:18:46.000000', 'temperatura', 71.0000, 'ºC'),
	(6228, 108, '2015-01-15 00:18:47.000000', 'temperatura', 1070.0000, 'ºC'),
	(6229, 108, '2015-01-15 00:18:48.000000', 'temperatura', 336.0000, 'ºC'),
	(6230, 108, '2015-01-15 00:18:49.000000', 'temperatura', 869.0000, 'ºC'),
	(6231, 108, '2015-01-15 00:18:50.000000', 'temperatura', 940.0000, 'ºC'),
	(6232, 108, '2015-01-15 00:18:51.000000', 'temperatura', 893.0000, 'ºC'),
	(6233, 108, '2015-01-15 00:18:52.000000', 'temperatura', 445.0000, 'ºC'),
	(6234, 108, '2015-01-15 00:18:53.000000', 'temperatura', 747.0000, 'ºC'),
	(6235, 108, '2015-01-15 00:18:54.000000', 'temperatura', 2.0000, 'ºC'),
	(6236, 108, '2015-01-15 00:18:55.000000', 'temperatura', 169.0000, 'ºC'),
	(6237, 108, '2015-01-15 00:18:56.000000', 'temperatura', 838.0000, 'ºC'),
	(6238, 108, '2015-01-15 00:18:57.000000', 'temperatura', 85.0000, 'ºC'),
	(6239, 108, '2015-01-15 00:18:58.000000', 'temperatura', 311.0000, 'ºC'),
	(6240, 108, '2015-01-15 00:18:59.000000', 'temperatura', 101.0000, 'ºC'),
	(6241, 108, '2015-01-15 00:19:00.000000', 'temperatura', 770.0000, 'ºC'),
	(6242, 108, '2015-01-15 00:19:01.000000', 'temperatura', 1151.0000, 'ºC'),
	(6243, 108, '2015-01-15 00:19:02.000000', 'temperatura', 1043.0000, 'ºC'),
	(6244, 108, '2015-01-15 00:19:03.000000', 'temperatura', 563.0000, 'ºC'),
	(6245, 108, '2015-01-15 00:19:04.000000', 'temperatura', 885.0000, 'ºC'),
	(6246, 108, '2015-01-15 00:19:05.000000', 'temperatura', 338.0000, 'ºC'),
	(6247, 108, '2015-01-15 00:19:06.000000', 'temperatura', 237.0000, 'ºC'),
	(6248, 108, '2015-01-15 00:19:07.000000', 'temperatura', 171.0000, 'ºC'),
	(6249, 108, '2015-01-15 00:19:08.000000', 'temperatura', 144.0000, 'ºC'),
	(6250, 108, '2015-01-15 00:19:09.000000', 'temperatura', 209.0000, 'ºC'),
	(6251, 108, '2015-01-15 00:19:10.000000', 'temperatura', 611.0000, 'ºC'),
	(6252, 108, '2015-01-15 00:19:11.000000', 'temperatura', 29.0000, 'ºC'),
	(6253, 108, '2015-01-15 00:19:12.000000', 'temperatura', 711.0000, 'ºC'),
	(6254, 108, '2015-01-15 00:19:13.000000', 'temperatura', 1070.0000, 'ºC'),
	(6255, 108, '2015-01-15 00:19:14.000000', 'temperatura', 818.0000, 'ºC'),
	(6256, 108, '2015-01-15 00:19:15.000000', 'temperatura', 878.0000, 'ºC'),
	(6257, 108, '2015-01-15 00:19:16.000000', 'temperatura', 739.0000, 'ºC'),
	(6258, 108, '2015-01-15 00:19:17.000000', 'temperatura', 1061.0000, 'ºC'),
	(6259, 108, '2015-01-15 00:19:18.000000', 'temperatura', 689.0000, 'ºC'),
	(6260, 108, '2015-01-15 00:19:19.000000', 'temperatura', 261.0000, 'ºC'),
	(6261, 108, '2015-01-15 00:19:20.000000', 'temperatura', 439.0000, 'ºC'),
	(6262, 108, '2015-01-15 00:19:21.000000', 'temperatura', 213.0000, 'ºC'),
	(6263, 108, '2015-01-15 00:19:22.000000', 'temperatura', 949.0000, 'ºC'),
	(6264, 108, '2015-01-15 00:19:23.000000', 'temperatura', 507.0000, 'ºC'),
	(6265, 108, '2015-01-15 00:19:24.000000', 'temperatura', 888.0000, 'ºC'),
	(6266, 108, '2015-01-15 00:19:25.000000', 'temperatura', 517.0000, 'ºC'),
	(6267, 108, '2015-01-15 00:19:26.000000', 'temperatura', 1124.0000, 'ºC'),
	(6268, 108, '2015-01-15 00:19:27.000000', 'temperatura', 471.0000, 'ºC'),
	(6269, 108, '2015-01-15 00:19:28.000000', 'temperatura', 182.0000, 'ºC'),
	(6270, 108, '2015-01-15 00:19:29.000000', 'temperatura', 698.0000, 'ºC'),
	(6271, 108, '2015-01-15 00:19:30.000000', 'temperatura', 544.0000, 'ºC'),
	(6272, 108, '2015-01-15 00:19:31.000000', 'temperatura', 629.0000, 'ºC'),
	(6273, 108, '2015-01-15 00:19:32.000000', 'temperatura', 310.0000, 'ºC'),
	(6274, 108, '2015-01-15 00:19:33.000000', 'temperatura', 864.0000, 'ºC'),
	(6275, 108, '2015-01-15 00:19:34.000000', 'temperatura', 993.0000, 'ºC'),
	(6276, 108, '2015-01-15 00:19:35.000000', 'temperatura', 1171.0000, 'ºC'),
	(6277, 108, '2015-01-15 00:19:36.000000', 'temperatura', 476.0000, 'ºC'),
	(6278, 108, '2015-01-15 00:19:37.000000', 'temperatura', 68.0000, 'ºC'),
	(6279, 108, '2015-01-15 00:19:38.000000', 'temperatura', 112.0000, 'ºC'),
	(6280, 108, '2015-01-15 00:19:39.000000', 'temperatura', 359.0000, 'ºC'),
	(6281, 108, '2015-01-15 00:19:40.000000', 'temperatura', 258.0000, 'ºC'),
	(6282, 108, '2015-01-15 00:19:41.000000', 'temperatura', 212.0000, 'ºC'),
	(6283, 108, '2015-01-15 00:19:42.000000', 'temperatura', 287.0000, 'ºC'),
	(6284, 108, '2015-01-15 00:19:43.000000', 'temperatura', 801.0000, 'ºC'),
	(6285, 108, '2015-01-15 00:19:44.000000', 'temperatura', 742.0000, 'ºC'),
	(6286, 108, '2015-01-15 00:19:45.000000', 'temperatura', 111.0000, 'ºC'),
	(6287, 108, '2015-01-15 00:19:46.000000', 'temperatura', 726.0000, 'ºC'),
	(6288, 108, '2015-01-15 00:19:47.000000', 'temperatura', 898.0000, 'ºC'),
	(6289, 108, '2015-01-15 00:19:48.000000', 'temperatura', 1113.0000, 'ºC'),
	(6290, 108, '2015-01-15 00:19:49.000000', 'temperatura', 470.0000, 'ºC'),
	(6291, 108, '2015-01-15 00:19:50.000000', 'temperatura', 211.0000, 'ºC'),
	(6292, 108, '2015-01-15 00:19:51.000000', 'temperatura', 845.0000, 'ºC'),
	(6293, 108, '2015-01-15 00:19:52.000000', 'temperatura', 1192.0000, 'ºC'),
	(6294, 108, '2015-01-15 00:19:53.000000', 'temperatura', 1026.0000, 'ºC'),
	(6295, 108, '2015-01-15 00:19:54.000000', 'temperatura', 355.0000, 'ºC'),
	(6296, 108, '2015-01-15 00:19:55.000000', 'temperatura', 1096.0000, 'ºC'),
	(6297, 108, '2015-01-15 00:19:56.000000', 'temperatura', 816.0000, 'ºC'),
	(6298, 108, '2015-01-15 00:19:57.000000', 'temperatura', 793.0000, 'ºC'),
	(6299, 108, '2015-01-15 00:19:58.000000', 'temperatura', 318.0000, 'ºC'),
	(6300, 108, '2015-01-15 00:19:59.000000', 'temperatura', 412.0000, 'ºC'),
	(6301, 108, '2015-01-15 00:20:00.000000', 'temperatura', 1108.0000, 'ºC'),
	(6302, 108, '2015-01-15 00:20:01.000000', 'temperatura', 703.0000, 'ºC'),
	(6303, 108, '2015-01-15 00:20:02.000000', 'temperatura', 191.0000, 'ºC'),
	(6304, 108, '2015-01-15 00:20:03.000000', 'temperatura', 46.0000, 'ºC'),
	(6305, 108, '2015-01-15 00:20:04.000000', 'temperatura', 856.0000, 'ºC'),
	(6306, 108, '2015-01-15 00:20:05.000000', 'temperatura', 544.0000, 'ºC'),
	(6307, 108, '2015-01-15 00:20:06.000000', 'temperatura', 153.0000, 'ºC'),
	(6308, 108, '2015-01-15 00:20:07.000000', 'temperatura', 333.0000, 'ºC'),
	(6309, 108, '2015-01-15 00:20:08.000000', 'temperatura', 8.0000, 'ºC'),
	(6310, 108, '2015-01-15 00:20:09.000000', 'temperatura', 239.0000, 'ºC'),
	(6311, 108, '2015-01-15 00:20:10.000000', 'temperatura', 1170.0000, 'ºC'),
	(6312, 108, '2015-01-15 00:20:11.000000', 'temperatura', 337.0000, 'ºC'),
	(6313, 108, '2015-01-15 00:20:12.000000', 'temperatura', 576.0000, 'ºC'),
	(6314, 108, '2015-01-15 00:20:13.000000', 'temperatura', 667.0000, 'ºC'),
	(6315, 108, '2015-01-15 00:20:14.000000', 'temperatura', 408.0000, 'ºC'),
	(6316, 108, '2015-01-15 00:20:15.000000', 'temperatura', 40.0000, 'ºC'),
	(6317, 108, '2015-01-15 00:20:16.000000', 'temperatura', 177.0000, 'ºC'),
	(6318, 108, '2015-01-15 00:20:17.000000', 'temperatura', 767.0000, 'ºC'),
	(6319, 108, '2015-01-15 00:20:18.000000', 'temperatura', 902.0000, 'ºC'),
	(6320, 108, '2015-01-15 00:20:19.000000', 'temperatura', 1010.0000, 'ºC'),
	(6321, 108, '2015-01-15 00:20:20.000000', 'temperatura', 1147.0000, 'ºC'),
	(6322, 108, '2015-01-15 00:20:21.000000', 'temperatura', 302.0000, 'ºC'),
	(6323, 108, '2015-01-15 00:20:22.000000', 'temperatura', 471.0000, 'ºC'),
	(6324, 108, '2015-01-15 00:20:23.000000', 'temperatura', 250.0000, 'ºC'),
	(6325, 108, '2015-01-15 00:20:24.000000', 'temperatura', 1037.0000, 'ºC'),
	(6326, 108, '2015-01-15 00:20:25.000000', 'temperatura', 837.0000, 'ºC'),
	(6327, 108, '2015-01-15 00:20:26.000000', 'temperatura', 1074.0000, 'ºC'),
	(6328, 108, '2015-01-15 00:20:27.000000', 'temperatura', 459.0000, 'ºC'),
	(6329, 108, '2015-01-15 00:20:28.000000', 'temperatura', 271.0000, 'ºC'),
	(6330, 108, '2015-01-15 00:20:29.000000', 'temperatura', 1182.0000, 'ºC'),
	(6331, 108, '2015-01-15 00:20:30.000000', 'temperatura', 298.0000, 'ºC'),
	(6332, 108, '2015-01-15 00:20:31.000000', 'temperatura', 343.0000, 'ºC'),
	(6333, 108, '2015-01-15 00:20:32.000000', 'temperatura', 820.0000, 'ºC'),
	(6334, 108, '2015-01-15 00:20:33.000000', 'temperatura', 672.0000, 'ºC'),
	(6335, 108, '2015-01-15 00:20:34.000000', 'temperatura', 902.0000, 'ºC'),
	(6336, 108, '2015-01-15 00:20:35.000000', 'temperatura', 92.0000, 'ºC'),
	(6337, 108, '2015-01-15 00:20:36.000000', 'temperatura', 155.0000, 'ºC'),
	(6338, 108, '2015-01-15 00:20:37.000000', 'temperatura', 499.0000, 'ºC'),
	(6339, 108, '2015-01-15 00:20:38.000000', 'temperatura', 832.0000, 'ºC'),
	(6340, 108, '2015-01-15 00:20:39.000000', 'temperatura', 265.0000, 'ºC'),
	(6341, 108, '2015-01-15 00:20:40.000000', 'temperatura', 27.0000, 'ºC'),
	(6342, 108, '2015-01-15 00:20:41.000000', 'temperatura', 543.0000, 'ºC'),
	(6343, 108, '2015-01-15 00:20:42.000000', 'temperatura', 234.0000, 'ºC'),
	(6344, 108, '2015-01-15 00:20:43.000000', 'temperatura', 740.0000, 'ºC'),
	(6345, 108, '2015-01-15 00:20:44.000000', 'temperatura', 599.0000, 'ºC'),
	(6346, 108, '2015-01-15 00:20:45.000000', 'temperatura', 774.0000, 'ºC'),
	(6347, 108, '2015-01-15 00:20:46.000000', 'temperatura', 875.0000, 'ºC'),
	(6348, 108, '2015-01-15 00:20:47.000000', 'temperatura', 855.0000, 'ºC'),
	(6349, 108, '2015-01-15 00:20:48.000000', 'temperatura', 451.0000, 'ºC'),
	(6350, 108, '2015-01-15 00:20:49.000000', 'temperatura', 889.0000, 'ºC'),
	(6351, 108, '2015-01-15 00:20:50.000000', 'temperatura', 693.0000, 'ºC'),
	(6352, 108, '2015-01-15 00:20:51.000000', 'temperatura', 798.0000, 'ºC'),
	(6353, 108, '2015-01-15 00:20:52.000000', 'temperatura', 712.0000, 'ºC'),
	(6354, 108, '2015-01-15 00:20:53.000000', 'temperatura', 1165.0000, 'ºC'),
	(6355, 108, '2015-01-15 00:20:54.000000', 'temperatura', 89.0000, 'ºC'),
	(6356, 108, '2015-01-15 00:20:55.000000', 'temperatura', 553.0000, 'ºC'),
	(6357, 108, '2015-01-15 00:20:56.000000', 'temperatura', 96.0000, 'ºC'),
	(6358, 108, '2015-01-15 00:20:57.000000', 'temperatura', 23.0000, 'ºC'),
	(6359, 108, '2015-01-15 00:20:58.000000', 'temperatura', 1027.0000, 'ºC'),
	(6360, 108, '2015-01-15 00:20:59.000000', 'temperatura', 267.0000, 'ºC'),
	(6361, 108, '2015-01-15 00:21:00.000000', 'temperatura', 654.0000, 'ºC'),
	(6362, 108, '2015-01-15 00:21:01.000000', 'temperatura', 68.0000, 'ºC'),
	(6363, 108, '2015-01-15 00:21:02.000000', 'temperatura', 781.0000, 'ºC'),
	(6364, 108, '2015-01-15 00:21:03.000000', 'temperatura', 103.0000, 'ºC'),
	(6365, 108, '2015-01-15 00:21:04.000000', 'temperatura', 569.0000, 'ºC'),
	(6366, 108, '2015-01-15 00:21:05.000000', 'temperatura', 140.0000, 'ºC'),
	(6367, 108, '2015-01-15 00:21:06.000000', 'temperatura', 191.0000, 'ºC'),
	(6368, 108, '2015-01-15 00:21:07.000000', 'temperatura', 537.0000, 'ºC'),
	(6369, 108, '2015-01-15 00:21:08.000000', 'temperatura', 914.0000, 'ºC'),
	(6370, 108, '2015-01-15 00:21:09.000000', 'temperatura', 556.0000, 'ºC'),
	(6371, 108, '2015-01-15 00:21:10.000000', 'temperatura', 41.0000, 'ºC'),
	(6372, 108, '2015-01-15 00:21:11.000000', 'temperatura', 935.0000, 'ºC'),
	(6373, 108, '2015-01-15 00:21:12.000000', 'temperatura', 953.0000, 'ºC'),
	(6374, 108, '2015-01-15 00:21:13.000000', 'temperatura', 759.0000, 'ºC'),
	(6375, 108, '2015-01-15 00:21:14.000000', 'temperatura', 940.0000, 'ºC'),
	(6376, 108, '2015-01-15 00:21:15.000000', 'temperatura', 21.0000, 'ºC'),
	(6377, 108, '2015-01-15 00:21:16.000000', 'temperatura', 886.0000, 'ºC'),
	(6378, 108, '2015-01-15 00:21:17.000000', 'temperatura', 769.0000, 'ºC'),
	(6379, 108, '2015-01-15 00:21:18.000000', 'temperatura', 1187.0000, 'ºC'),
	(6380, 108, '2015-01-15 00:21:19.000000', 'temperatura', 28.0000, 'ºC'),
	(6381, 108, '2015-01-15 00:21:20.000000', 'temperatura', 179.0000, 'ºC'),
	(6382, 108, '2015-01-15 00:21:21.000000', 'temperatura', 811.0000, 'ºC'),
	(6383, 108, '2015-01-15 00:21:22.000000', 'temperatura', 1118.0000, 'ºC'),
	(6384, 108, '2015-01-15 00:21:23.000000', 'temperatura', 758.0000, 'ºC'),
	(6385, 108, '2015-01-15 00:21:24.000000', 'temperatura', 435.0000, 'ºC'),
	(6386, 108, '2015-01-15 00:21:25.000000', 'temperatura', 1103.0000, 'ºC'),
	(6387, 108, '2015-01-15 00:21:26.000000', 'temperatura', 608.0000, 'ºC'),
	(6388, 108, '2015-01-15 00:21:27.000000', 'temperatura', 934.0000, 'ºC'),
	(6389, 108, '2015-01-15 00:21:28.000000', 'temperatura', 446.0000, 'ºC'),
	(6390, 108, '2015-01-15 00:21:29.000000', 'temperatura', 628.0000, 'ºC'),
	(6391, 108, '2015-01-15 00:21:30.000000', 'temperatura', 605.0000, 'ºC'),
	(6392, 108, '2015-01-15 00:21:31.000000', 'temperatura', 1139.0000, 'ºC'),
	(6393, 108, '2015-01-15 00:21:32.000000', 'temperatura', 280.0000, 'ºC'),
	(6394, 108, '2015-01-15 00:21:33.000000', 'temperatura', 384.0000, 'ºC'),
	(6395, 108, '2015-01-15 00:21:34.000000', 'temperatura', 1080.0000, 'ºC'),
	(6396, 108, '2015-01-15 00:21:35.000000', 'temperatura', 649.0000, 'ºC'),
	(6397, 108, '2015-01-15 00:21:36.000000', 'temperatura', 7.0000, 'ºC'),
	(6398, 108, '2015-01-15 00:21:37.000000', 'temperatura', 488.0000, 'ºC'),
	(6399, 108, '2015-01-15 00:21:38.000000', 'temperatura', 20.0000, 'ºC'),
	(6400, 108, '2015-01-15 00:21:39.000000', 'temperatura', 1036.0000, 'ºC'),
	(6401, 108, '2015-01-15 00:21:40.000000', 'temperatura', 320.0000, 'ºC'),
	(6402, 108, '2015-01-15 00:21:41.000000', 'temperatura', 894.0000, 'ºC'),
	(6403, 108, '2015-01-15 00:21:42.000000', 'temperatura', 1111.0000, 'ºC'),
	(6404, 108, '2015-01-15 00:21:43.000000', 'temperatura', 474.0000, 'ºC'),
	(6405, 108, '2015-01-15 00:21:44.000000', 'temperatura', 239.0000, 'ºC'),
	(6406, 108, '2015-01-15 00:21:45.000000', 'temperatura', 970.0000, 'ºC'),
	(6407, 108, '2015-01-15 00:21:46.000000', 'temperatura', 534.0000, 'ºC'),
	(6408, 108, '2015-01-15 00:21:47.000000', 'temperatura', 960.0000, 'ºC'),
	(6409, 108, '2015-01-15 00:21:48.000000', 'temperatura', 801.0000, 'ºC'),
	(6410, 108, '2015-01-15 00:21:49.000000', 'temperatura', 1124.0000, 'ºC'),
	(6411, 108, '2015-01-15 00:21:50.000000', 'temperatura', 818.0000, 'ºC'),
	(6412, 108, '2015-01-15 00:21:51.000000', 'temperatura', 717.0000, 'ºC'),
	(6413, 108, '2015-01-15 00:21:52.000000', 'temperatura', 1132.0000, 'ºC'),
	(6414, 108, '2015-01-15 00:21:53.000000', 'temperatura', 1111.0000, 'ºC'),
	(6415, 108, '2015-01-15 00:21:54.000000', 'temperatura', 957.0000, 'ºC'),
	(6416, 108, '2015-01-15 00:21:55.000000', 'temperatura', 254.0000, 'ºC'),
	(6417, 108, '2015-01-15 00:21:56.000000', 'temperatura', 798.0000, 'ºC'),
	(6418, 108, '2015-01-15 00:21:57.000000', 'temperatura', 831.0000, 'ºC'),
	(6419, 108, '2015-01-15 00:21:58.000000', 'temperatura', 562.0000, 'ºC'),
	(6420, 108, '2015-01-15 00:21:59.000000', 'temperatura', 318.0000, 'ºC'),
	(6421, 108, '2015-01-15 00:22:00.000000', 'temperatura', 1104.0000, 'ºC'),
	(6422, 108, '2015-01-15 00:22:01.000000', 'temperatura', 966.0000, 'ºC'),
	(6423, 108, '2015-01-15 00:22:02.000000', 'temperatura', 321.0000, 'ºC'),
	(6424, 108, '2015-01-15 00:22:03.000000', 'temperatura', 1104.0000, 'ºC'),
	(6425, 108, '2015-01-15 00:22:04.000000', 'temperatura', 960.0000, 'ºC'),
	(6426, 108, '2015-01-15 00:22:05.000000', 'temperatura', 290.0000, 'ºC'),
	(6427, 108, '2015-01-15 00:22:06.000000', 'temperatura', 967.0000, 'ºC'),
	(6428, 108, '2015-01-15 00:22:07.000000', 'temperatura', 366.0000, 'ºC'),
	(6429, 108, '2015-01-15 00:22:08.000000', 'temperatura', 131.0000, 'ºC'),
	(6430, 108, '2015-01-15 00:22:09.000000', 'temperatura', 757.0000, 'ºC'),
	(6431, 108, '2015-01-15 00:22:10.000000', 'temperatura', 991.0000, 'ºC'),
	(6432, 108, '2015-01-15 00:22:11.000000', 'temperatura', 284.0000, 'ºC'),
	(6433, 108, '2015-01-15 00:22:12.000000', 'temperatura', 851.0000, 'ºC'),
	(6434, 108, '2015-01-15 00:22:13.000000', 'temperatura', 1000.0000, 'ºC'),
	(6435, 108, '2015-01-15 00:22:14.000000', 'temperatura', 50.0000, 'ºC'),
	(6436, 108, '2015-01-15 00:22:15.000000', 'temperatura', 850.0000, 'ºC'),
	(6437, 108, '2015-01-15 00:22:16.000000', 'temperatura', 502.0000, 'ºC'),
	(6438, 108, '2015-01-15 00:22:17.000000', 'temperatura', 1159.0000, 'ºC'),
	(6439, 108, '2015-01-15 00:22:18.000000', 'temperatura', 691.0000, 'ºC'),
	(6440, 108, '2015-01-15 00:22:19.000000', 'temperatura', 1178.0000, 'ºC'),
	(6441, 108, '2015-01-15 00:22:20.000000', 'temperatura', 217.0000, 'ºC'),
	(6442, 108, '2015-01-15 00:22:21.000000', 'temperatura', 1153.0000, 'ºC'),
	(6443, 108, '2015-01-15 00:22:22.000000', 'temperatura', 313.0000, 'ºC'),
	(6444, 108, '2015-01-15 00:22:23.000000', 'temperatura', 505.0000, 'ºC'),
	(6445, 108, '2015-01-15 00:22:24.000000', 'temperatura', 389.0000, 'ºC'),
	(6446, 108, '2015-01-15 00:22:25.000000', 'temperatura', 428.0000, 'ºC'),
	(6447, 108, '2015-01-15 00:22:26.000000', 'temperatura', 975.0000, 'ºC'),
	(6448, 108, '2015-01-15 00:22:27.000000', 'temperatura', 1192.0000, 'ºC'),
	(6449, 108, '2015-01-15 00:22:28.000000', 'temperatura', 636.0000, 'ºC'),
	(6450, 108, '2015-01-15 00:22:29.000000', 'temperatura', 802.0000, 'ºC'),
	(6451, 108, '2015-01-15 00:22:30.000000', 'temperatura', 906.0000, 'ºC'),
	(6452, 108, '2015-01-15 00:22:31.000000', 'temperatura', 922.0000, 'ºC'),
	(6453, 108, '2015-01-15 00:22:32.000000', 'temperatura', 692.0000, 'ºC'),
	(6454, 108, '2015-01-15 00:22:33.000000', 'temperatura', 697.0000, 'ºC'),
	(6455, 108, '2015-01-15 00:22:34.000000', 'temperatura', 210.0000, 'ºC'),
	(6456, 108, '2015-01-15 00:22:35.000000', 'temperatura', 159.0000, 'ºC'),
	(6457, 108, '2015-01-15 00:22:36.000000', 'temperatura', 164.0000, 'ºC'),
	(6458, 108, '2015-01-15 00:22:37.000000', 'temperatura', 343.0000, 'ºC'),
	(6459, 108, '2015-01-15 00:22:38.000000', 'temperatura', 26.0000, 'ºC'),
	(6460, 108, '2015-01-15 00:22:39.000000', 'temperatura', 302.0000, 'ºC'),
	(6461, 108, '2015-01-15 00:22:40.000000', 'temperatura', 231.0000, 'ºC'),
	(6462, 108, '2015-01-15 00:22:41.000000', 'temperatura', 249.0000, 'ºC'),
	(6463, 108, '2015-01-15 00:22:42.000000', 'temperatura', 554.0000, 'ºC'),
	(6464, 108, '2015-01-15 00:22:43.000000', 'temperatura', 823.0000, 'ºC'),
	(6465, 108, '2015-01-15 00:22:44.000000', 'temperatura', 53.0000, 'ºC'),
	(6466, 108, '2015-01-15 00:22:45.000000', 'temperatura', 196.0000, 'ºC'),
	(6467, 108, '2015-01-15 00:22:46.000000', 'temperatura', 820.0000, 'ºC'),
	(6468, 108, '2015-01-15 00:22:47.000000', 'temperatura', 1115.0000, 'ºC'),
	(6469, 108, '2015-01-15 00:22:48.000000', 'temperatura', 715.0000, 'ºC'),
	(6470, 108, '2015-01-15 00:22:49.000000', 'temperatura', 228.0000, 'ºC'),
	(6471, 108, '2015-01-15 00:22:50.000000', 'temperatura', 199.0000, 'ºC'),
	(6472, 108, '2015-01-15 00:22:51.000000', 'temperatura', 310.0000, 'ºC'),
	(6473, 108, '2015-01-15 00:22:52.000000', 'temperatura', 953.0000, 'ºC'),
	(6474, 108, '2015-01-15 00:22:53.000000', 'temperatura', 237.0000, 'ºC'),
	(6475, 108, '2015-01-15 00:22:54.000000', 'temperatura', 726.0000, 'ºC'),
	(6476, 108, '2015-01-15 00:22:55.000000', 'temperatura', 517.0000, 'ºC'),
	(6477, 108, '2015-01-15 00:22:56.000000', 'temperatura', 411.0000, 'ºC'),
	(6478, 108, '2015-01-15 00:22:57.000000', 'temperatura', 502.0000, 'ºC'),
	(6479, 108, '2015-01-15 00:22:58.000000', 'temperatura', 79.0000, 'ºC'),
	(6480, 108, '2015-01-15 00:22:59.000000', 'temperatura', 89.0000, 'ºC'),
	(6481, 108, '2015-01-15 00:23:00.000000', 'temperatura', 208.0000, 'ºC'),
	(6482, 108, '2015-01-15 00:23:01.000000', 'temperatura', 773.0000, 'ºC'),
	(6483, 108, '2015-01-15 00:23:02.000000', 'temperatura', 842.0000, 'ºC'),
	(6484, 108, '2015-01-15 00:23:03.000000', 'temperatura', 693.0000, 'ºC'),
	(6485, 108, '2015-01-15 00:23:04.000000', 'temperatura', 940.0000, 'ºC'),
	(6486, 108, '2015-01-15 00:23:05.000000', 'temperatura', 222.0000, 'ºC'),
	(6487, 108, '2015-01-15 00:23:06.000000', 'temperatura', 688.0000, 'ºC'),
	(6488, 108, '2015-01-15 00:23:07.000000', 'temperatura', 377.0000, 'ºC'),
	(6489, 108, '2015-01-15 00:23:08.000000', 'temperatura', 1020.0000, 'ºC'),
	(6490, 108, '2015-01-15 00:23:09.000000', 'temperatura', 371.0000, 'ºC'),
	(6491, 108, '2015-01-15 00:23:10.000000', 'temperatura', 1194.0000, 'ºC'),
	(6492, 108, '2015-01-15 00:23:11.000000', 'temperatura', 57.0000, 'ºC'),
	(6493, 108, '2015-01-15 00:23:12.000000', 'temperatura', 303.0000, 'ºC'),
	(6494, 108, '2015-01-15 00:23:13.000000', 'temperatura', 145.0000, 'ºC'),
	(6495, 108, '2015-01-15 00:23:14.000000', 'temperatura', 1015.0000, 'ºC'),
	(6496, 108, '2015-01-15 00:23:15.000000', 'temperatura', 1041.0000, 'ºC'),
	(6497, 108, '2015-01-15 00:23:16.000000', 'temperatura', 960.0000, 'ºC'),
	(6498, 108, '2015-01-15 00:23:17.000000', 'temperatura', 479.0000, 'ºC'),
	(6499, 108, '2015-01-15 00:23:18.000000', 'temperatura', 714.0000, 'ºC'),
	(6500, 108, '2015-01-15 00:23:19.000000', 'temperatura', 936.0000, 'ºC'),
	(6501, 108, '2015-01-15 00:23:20.000000', 'temperatura', 135.0000, 'ºC'),
	(6502, 108, '2015-01-15 00:23:21.000000', 'temperatura', 271.0000, 'ºC'),
	(6503, 108, '2015-01-15 00:23:22.000000', 'temperatura', 950.0000, 'ºC'),
	(6504, 108, '2015-01-15 00:23:23.000000', 'temperatura', 335.0000, 'ºC'),
	(6505, 108, '2015-01-15 00:23:24.000000', 'temperatura', 27.0000, 'ºC'),
	(6506, 108, '2015-01-15 00:23:25.000000', 'temperatura', 331.0000, 'ºC'),
	(6507, 108, '2015-01-15 00:23:26.000000', 'temperatura', 376.0000, 'ºC'),
	(6508, 108, '2015-01-15 00:23:27.000000', 'temperatura', 885.0000, 'ºC'),
	(6509, 108, '2015-01-15 00:23:28.000000', 'temperatura', 898.0000, 'ºC'),
	(6510, 108, '2015-01-15 00:23:29.000000', 'temperatura', 637.0000, 'ºC'),
	(6511, 108, '2015-01-15 00:23:30.000000', 'temperatura', 489.0000, 'ºC'),
	(6512, 108, '2015-01-15 00:23:31.000000', 'temperatura', 537.0000, 'ºC'),
	(6513, 108, '2015-01-15 00:23:32.000000', 'temperatura', 17.0000, 'ºC'),
	(6514, 108, '2015-01-15 00:23:33.000000', 'temperatura', 874.0000, 'ºC'),
	(6515, 108, '2015-01-15 00:23:34.000000', 'temperatura', 721.0000, 'ºC'),
	(6516, 108, '2015-01-15 00:23:35.000000', 'temperatura', 982.0000, 'ºC'),
	(6517, 108, '2015-01-15 00:23:36.000000', 'temperatura', 350.0000, 'ºC'),
	(6518, 108, '2015-01-15 00:23:37.000000', 'temperatura', 1.0000, 'ºC'),
	(6519, 108, '2015-01-15 00:23:38.000000', 'temperatura', 158.0000, 'ºC'),
	(6520, 108, '2015-01-15 00:23:39.000000', 'temperatura', 788.0000, 'ºC'),
	(6521, 108, '2015-01-15 00:23:40.000000', 'temperatura', 1067.0000, 'ºC'),
	(6522, 108, '2015-01-15 00:23:41.000000', 'temperatura', 571.0000, 'ºC'),
	(6523, 108, '2015-01-15 00:23:42.000000', 'temperatura', 853.0000, 'ºC'),
	(6524, 108, '2015-01-15 00:23:43.000000', 'temperatura', 153.0000, 'ºC'),
	(6525, 108, '2015-01-15 00:23:44.000000', 'temperatura', 607.0000, 'ºC'),
	(6526, 108, '2015-01-15 00:23:45.000000', 'temperatura', 178.0000, 'ºC'),
	(6527, 108, '2015-01-15 00:23:46.000000', 'temperatura', 269.0000, 'ºC'),
	(6528, 108, '2015-01-15 00:23:47.000000', 'temperatura', 809.0000, 'ºC'),
	(6529, 108, '2015-01-15 00:23:48.000000', 'temperatura', 840.0000, 'ºC'),
	(6530, 108, '2015-01-15 00:23:49.000000', 'temperatura', 574.0000, 'ºC'),
	(6531, 108, '2015-01-15 00:23:50.000000', 'temperatura', 349.0000, 'ºC'),
	(6532, 108, '2015-01-15 00:23:51.000000', 'temperatura', 23.0000, 'ºC'),
	(6533, 108, '2015-01-15 00:23:52.000000', 'temperatura', 267.0000, 'ºC'),
	(6534, 108, '2015-01-15 00:23:53.000000', 'temperatura', 70.0000, 'ºC'),
	(6535, 108, '2015-01-15 00:23:54.000000', 'temperatura', 746.0000, 'ºC'),
	(6536, 108, '2015-01-15 00:23:55.000000', 'temperatura', 1122.0000, 'ºC'),
	(6537, 108, '2015-01-15 00:23:56.000000', 'temperatura', 975.0000, 'ºC'),
	(6538, 108, '2015-01-15 00:23:57.000000', 'temperatura', 306.0000, 'ºC'),
	(6539, 108, '2015-01-15 00:23:58.000000', 'temperatura', 1008.0000, 'ºC'),
	(6540, 108, '2015-01-15 00:23:59.000000', 'temperatura', 523.0000, 'ºC'),
	(6541, 108, '2015-01-15 00:24:00.000000', 'temperatura', 792.0000, 'ºC'),
	(6542, 108, '2015-01-15 00:24:01.000000', 'temperatura', 1188.0000, 'ºC'),
	(6543, 108, '2015-01-15 00:24:02.000000', 'temperatura', 1168.0000, 'ºC'),
	(6544, 108, '2015-01-15 00:24:03.000000', 'temperatura', 1077.0000, 'ºC'),
	(6545, 108, '2015-01-15 00:24:04.000000', 'temperatura', 678.0000, 'ºC'),
	(6546, 108, '2015-01-15 00:24:05.000000', 'temperatura', 162.0000, 'ºC'),
	(6547, 108, '2015-01-15 00:24:06.000000', 'temperatura', 1177.0000, 'ºC'),
	(6548, 108, '2015-01-15 00:24:07.000000', 'temperatura', 598.0000, 'ºC'),
	(6549, 108, '2015-01-15 00:24:08.000000', 'temperatura', 661.0000, 'ºC'),
	(6550, 108, '2015-01-15 00:24:09.000000', 'temperatura', 310.0000, 'ºC'),
	(6551, 108, '2015-01-15 00:24:10.000000', 'temperatura', 769.0000, 'ºC'),
	(6552, 108, '2015-01-15 00:24:11.000000', 'temperatura', 516.0000, 'ºC'),
	(6553, 108, '2015-01-15 00:24:12.000000', 'temperatura', 274.0000, 'ºC'),
	(6554, 108, '2015-01-15 00:24:13.000000', 'temperatura', 1023.0000, 'ºC'),
	(6555, 108, '2015-01-15 00:24:14.000000', 'temperatura', 691.0000, 'ºC'),
	(6556, 108, '2015-01-15 00:24:15.000000', 'temperatura', 389.0000, 'ºC'),
	(6557, 108, '2015-01-15 00:24:16.000000', 'temperatura', 1070.0000, 'ºC'),
	(6558, 108, '2015-01-15 00:24:17.000000', 'temperatura', 583.0000, 'ºC'),
	(6559, 108, '2015-01-15 00:24:18.000000', 'temperatura', 906.0000, 'ºC'),
	(6560, 108, '2015-01-15 00:24:19.000000', 'temperatura', 383.0000, 'ºC'),
	(6561, 108, '2015-01-15 00:24:20.000000', 'temperatura', 395.0000, 'ºC'),
	(6562, 108, '2015-01-15 00:24:21.000000', 'temperatura', 827.0000, 'ºC'),
	(6563, 108, '2015-01-15 00:24:22.000000', 'temperatura', 550.0000, 'ºC'),
	(6564, 108, '2015-01-15 00:24:23.000000', 'temperatura', 272.0000, 'ºC'),
	(6565, 108, '2015-01-15 00:24:24.000000', 'temperatura', 909.0000, 'ºC'),
	(6566, 108, '2015-01-15 00:24:25.000000', 'temperatura', 128.0000, 'ºC'),
	(6567, 108, '2015-01-15 00:24:26.000000', 'temperatura', 317.0000, 'ºC'),
	(6568, 108, '2015-01-15 00:24:27.000000', 'temperatura', 1199.0000, 'ºC'),
	(6569, 108, '2015-01-15 00:24:28.000000', 'temperatura', 243.0000, 'ºC'),
	(6570, 108, '2015-01-15 00:24:29.000000', 'temperatura', 21.0000, 'ºC'),
	(6571, 108, '2015-01-15 00:24:30.000000', 'temperatura', 575.0000, 'ºC'),
	(6572, 108, '2015-01-15 00:24:31.000000', 'temperatura', 411.0000, 'ºC'),
	(6573, 108, '2015-01-15 00:24:32.000000', 'temperatura', 334.0000, 'ºC'),
	(6574, 108, '2015-01-15 00:24:33.000000', 'temperatura', 435.0000, 'ºC'),
	(6575, 108, '2015-01-15 00:24:34.000000', 'temperatura', 1176.0000, 'ºC'),
	(6576, 108, '2015-01-15 00:24:35.000000', 'temperatura', 973.0000, 'ºC'),
	(6577, 108, '2015-01-15 00:24:36.000000', 'temperatura', 140.0000, 'ºC'),
	(6578, 108, '2015-01-15 00:24:37.000000', 'temperatura', 180.0000, 'ºC'),
	(6579, 108, '2015-01-15 00:24:38.000000', 'temperatura', 480.0000, 'ºC'),
	(6580, 108, '2015-01-15 00:24:39.000000', 'temperatura', 662.0000, 'ºC'),
	(6581, 108, '2015-01-15 00:24:40.000000', 'temperatura', 670.0000, 'ºC'),
	(6582, 108, '2015-01-15 00:24:41.000000', 'temperatura', 166.0000, 'ºC'),
	(6583, 108, '2015-01-15 00:24:42.000000', 'temperatura', 19.0000, 'ºC'),
	(6584, 108, '2015-01-15 00:24:43.000000', 'temperatura', 798.0000, 'ºC'),
	(6585, 108, '2015-01-15 00:24:44.000000', 'temperatura', 335.0000, 'ºC'),
	(6586, 108, '2015-01-15 00:24:45.000000', 'temperatura', 479.0000, 'ºC'),
	(6587, 108, '2015-01-15 00:24:46.000000', 'temperatura', 190.0000, 'ºC'),
	(6588, 108, '2015-01-15 00:24:47.000000', 'temperatura', 713.0000, 'ºC'),
	(6589, 108, '2015-01-15 00:24:48.000000', 'temperatura', 596.0000, 'ºC'),
	(6590, 108, '2015-01-15 00:24:49.000000', 'temperatura', 840.0000, 'ºC'),
	(6591, 108, '2015-01-15 00:24:50.000000', 'temperatura', 13.0000, 'ºC'),
	(6592, 108, '2015-01-15 00:24:51.000000', 'temperatura', 1148.0000, 'ºC'),
	(6593, 108, '2015-01-15 00:24:52.000000', 'temperatura', 900.0000, 'ºC'),
	(6594, 108, '2015-01-15 00:24:53.000000', 'temperatura', 1058.0000, 'ºC'),
	(6595, 108, '2015-01-15 00:24:54.000000', 'temperatura', 190.0000, 'ºC'),
	(6596, 108, '2015-01-15 00:24:55.000000', 'temperatura', 176.0000, 'ºC'),
	(6597, 108, '2015-01-15 00:24:56.000000', 'temperatura', 311.0000, 'ºC'),
	(6598, 108, '2015-01-15 00:24:57.000000', 'temperatura', 1029.0000, 'ºC'),
	(6599, 108, '2015-01-15 00:24:58.000000', 'temperatura', 612.0000, 'ºC'),
	(6600, 108, '2015-01-15 00:24:59.000000', 'temperatura', 1172.0000, 'ºC'),
	(6601, 108, '2015-01-15 00:25:00.000000', 'temperatura', 426.0000, 'ºC'),
	(6602, 108, '2015-01-15 00:25:01.000000', 'temperatura', 1015.0000, 'ºC'),
	(6603, 108, '2015-01-15 00:25:02.000000', 'temperatura', 197.0000, 'ºC'),
	(6604, 108, '2015-01-15 00:25:03.000000', 'temperatura', 342.0000, 'ºC'),
	(6605, 108, '2015-01-15 00:25:04.000000', 'temperatura', 1119.0000, 'ºC'),
	(6606, 108, '2015-01-15 00:25:05.000000', 'temperatura', 970.0000, 'ºC'),
	(6607, 108, '2015-01-15 00:25:06.000000', 'temperatura', 294.0000, 'ºC'),
	(6608, 108, '2015-01-15 00:25:07.000000', 'temperatura', 960.0000, 'ºC'),
	(6609, 108, '2015-01-15 00:25:08.000000', 'temperatura', 319.0000, 'ºC'),
	(6610, 108, '2015-01-15 00:25:09.000000', 'temperatura', 1113.0000, 'ºC'),
	(6611, 108, '2015-01-15 00:25:10.000000', 'temperatura', 1010.0000, 'ºC'),
	(6612, 108, '2015-01-15 00:25:11.000000', 'temperatura', 509.0000, 'ºC'),
	(6613, 108, '2015-01-15 00:25:12.000000', 'temperatura', 718.0000, 'ºC'),
	(6614, 108, '2015-01-15 00:25:13.000000', 'temperatura', 865.0000, 'ºC'),
	(6615, 108, '2015-01-15 00:25:14.000000', 'temperatura', 969.0000, 'ºC'),
	(6616, 108, '2015-01-15 00:25:15.000000', 'temperatura', 1053.0000, 'ºC'),
	(6617, 108, '2015-01-15 00:25:16.000000', 'temperatura', 1159.0000, 'ºC'),
	(6618, 108, '2015-01-15 00:25:17.000000', 'temperatura', 235.0000, 'ºC'),
	(6619, 108, '2015-01-15 00:25:18.000000', 'temperatura', 98.0000, 'ºC'),
	(6620, 108, '2015-01-15 00:25:19.000000', 'temperatura', 985.0000, 'ºC'),
	(6621, 108, '2015-01-15 00:25:20.000000', 'temperatura', 1034.0000, 'ºC'),
	(6622, 108, '2015-01-15 00:25:21.000000', 'temperatura', 1013.0000, 'ºC'),
	(6623, 108, '2015-01-15 00:25:22.000000', 'temperatura', 766.0000, 'ºC'),
	(6624, 108, '2015-01-15 00:25:23.000000', 'temperatura', 791.0000, 'ºC'),
	(6625, 108, '2015-01-15 00:25:24.000000', 'temperatura', 456.0000, 'ºC'),
	(6626, 108, '2015-01-15 00:25:25.000000', 'temperatura', 1107.0000, 'ºC'),
	(6627, 108, '2015-01-15 00:25:26.000000', 'temperatura', 568.0000, 'ºC'),
	(6628, 108, '2015-01-15 00:25:27.000000', 'temperatura', 719.0000, 'ºC'),
	(6629, 108, '2015-01-15 00:25:28.000000', 'temperatura', 690.0000, 'ºC'),
	(6630, 108, '2015-01-15 00:25:29.000000', 'temperatura', 96.0000, 'ºC'),
	(6631, 108, '2015-01-15 00:25:30.000000', 'temperatura', 809.0000, 'ºC'),
	(6632, 108, '2015-01-15 00:25:31.000000', 'temperatura', 159.0000, 'ºC'),
	(6633, 108, '2015-01-15 00:25:32.000000', 'temperatura', 770.0000, 'ºC'),
	(6634, 108, '2015-01-15 00:25:33.000000', 'temperatura', 970.0000, 'ºC'),
	(6635, 108, '2015-01-15 00:25:34.000000', 'temperatura', 143.0000, 'ºC'),
	(6636, 108, '2015-01-15 00:25:35.000000', 'temperatura', 203.0000, 'ºC'),
	(6637, 108, '2015-01-15 00:25:36.000000', 'temperatura', 589.0000, 'ºC'),
	(6638, 108, '2015-01-15 00:25:37.000000', 'temperatura', 1138.0000, 'ºC'),
	(6639, 108, '2015-01-15 00:25:38.000000', 'temperatura', 320.0000, 'ºC'),
	(6640, 108, '2015-01-15 00:25:39.000000', 'temperatura', 587.0000, 'ºC'),
	(6641, 108, '2015-01-15 00:25:40.000000', 'temperatura', 778.0000, 'ºC'),
	(6642, 108, '2015-01-15 00:25:41.000000', 'temperatura', 928.0000, 'ºC'),
	(6643, 108, '2015-01-15 00:25:42.000000', 'temperatura', 1106.0000, 'ºC'),
	(6644, 108, '2015-01-15 00:25:43.000000', 'temperatura', 349.0000, 'ºC'),
	(6645, 108, '2015-01-15 00:25:44.000000', 'temperatura', 825.0000, 'ºC'),
	(6646, 108, '2015-01-15 00:25:45.000000', 'temperatura', 681.0000, 'ºC'),
	(6647, 108, '2015-01-15 00:25:46.000000', 'temperatura', 930.0000, 'ºC'),
	(6648, 108, '2015-01-15 00:25:47.000000', 'temperatura', 208.0000, 'ºC'),
	(6649, 108, '2015-01-15 00:25:48.000000', 'temperatura', 651.0000, 'ºC'),
	(6650, 108, '2015-01-15 00:25:49.000000', 'temperatura', 230.0000, 'ºC'),
	(6651, 108, '2015-01-15 00:25:50.000000', 'temperatura', 399.0000, 'ºC'),
	(6652, 108, '2015-01-15 00:25:51.000000', 'temperatura', 106.0000, 'ºC'),
	(6653, 108, '2015-01-15 00:25:52.000000', 'temperatura', 533.0000, 'ºC'),
	(6654, 108, '2015-01-15 00:25:53.000000', 'temperatura', 1145.0000, 'ºC'),
	(6655, 108, '2015-01-15 00:25:54.000000', 'temperatura', 530.0000, 'ºC'),
	(6656, 108, '2015-01-15 00:25:55.000000', 'temperatura', 412.0000, 'ºC'),
	(6657, 108, '2015-01-15 00:25:56.000000', 'temperatura', 472.0000, 'ºC'),
	(6658, 108, '2015-01-15 00:25:57.000000', 'temperatura', 1125.0000, 'ºC'),
	(6659, 108, '2015-01-15 00:25:58.000000', 'temperatura', 609.0000, 'ºC'),
	(6660, 108, '2015-01-15 00:25:59.000000', 'temperatura', 873.0000, 'ºC'),
	(6661, 108, '2015-01-15 00:26:00.000000', 'temperatura', 135.0000, 'ºC'),
	(6662, 108, '2015-01-15 00:26:01.000000', 'temperatura', 459.0000, 'ºC'),
	(6663, 108, '2015-01-15 00:26:02.000000', 'temperatura', 690.0000, 'ºC'),
	(6664, 108, '2015-01-15 00:26:03.000000', 'temperatura', 872.0000, 'ºC'),
	(6665, 108, '2015-01-15 00:26:04.000000', 'temperatura', 1092.0000, 'ºC'),
	(6666, 108, '2015-01-15 00:26:05.000000', 'temperatura', 445.0000, 'ºC'),
	(6667, 108, '2015-01-15 00:26:06.000000', 'temperatura', 147.0000, 'ºC'),
	(6668, 108, '2015-01-15 00:26:07.000000', 'temperatura', 604.0000, 'ºC'),
	(6669, 108, '2015-01-15 00:26:08.000000', 'temperatura', 176.0000, 'ºC'),
	(6670, 108, '2015-01-15 00:26:09.000000', 'temperatura', 271.0000, 'ºC'),
	(6671, 108, '2015-01-15 00:26:10.000000', 'temperatura', 825.0000, 'ºC'),
	(6672, 108, '2015-01-15 00:26:11.000000', 'temperatura', 912.0000, 'ºC'),
	(6673, 108, '2015-01-15 00:26:12.000000', 'temperatura', 886.0000, 'ºC'),
	(6674, 108, '2015-01-15 00:26:13.000000', 'temperatura', 497.0000, 'ºC'),
	(6675, 108, '2015-01-15 00:26:14.000000', 'temperatura', 1025.0000, 'ºC'),
	(6676, 108, '2015-01-15 00:26:15.000000', 'temperatura', 36.0000, 'ºC'),
	(6677, 108, '2015-01-15 00:26:16.000000', 'temperatura', 707.0000, 'ºC'),
	(6678, 108, '2015-01-15 00:26:17.000000', 'temperatura', 1024.0000, 'ºC'),
	(6679, 108, '2015-01-15 00:26:18.000000', 'temperatura', 601.0000, 'ºC'),
	(6680, 108, '2015-01-15 00:26:19.000000', 'temperatura', 1133.0000, 'ºC'),
	(6681, 108, '2015-01-15 00:26:20.000000', 'temperatura', 263.0000, 'ºC'),
	(6682, 108, '2015-01-15 00:26:21.000000', 'temperatura', 315.0000, 'ºC'),
	(6683, 108, '2015-01-15 00:26:22.000000', 'temperatura', 789.0000, 'ºC'),
	(6684, 108, '2015-01-15 00:26:23.000000', 'temperatura', 601.0000, 'ºC'),
	(6685, 108, '2015-01-15 00:26:24.000000', 'temperatura', 637.0000, 'ºC'),
	(6686, 108, '2015-01-15 00:26:25.000000', 'temperatura', 184.0000, 'ºC'),
	(6687, 108, '2015-01-15 00:26:26.000000', 'temperatura', 208.0000, 'ºC'),
	(6688, 108, '2015-01-15 00:26:27.000000', 'temperatura', 487.0000, 'ºC'),
	(6689, 108, '2015-01-15 00:26:28.000000', 'temperatura', 613.0000, 'ºC'),
	(6690, 108, '2015-01-15 00:26:29.000000', 'temperatura', 406.0000, 'ºC'),
	(6691, 108, '2015-01-15 00:26:30.000000', 'temperatura', 191.0000, 'ºC'),
	(6692, 108, '2015-01-15 00:26:31.000000', 'temperatura', 936.0000, 'ºC'),
	(6693, 108, '2015-01-15 00:26:32.000000', 'temperatura', 507.0000, 'ºC'),
	(6694, 108, '2015-01-15 00:26:33.000000', 'temperatura', 927.0000, 'ºC'),
	(6695, 108, '2015-01-15 00:26:34.000000', 'temperatura', 715.0000, 'ºC'),
	(6696, 108, '2015-01-15 00:26:35.000000', 'temperatura', 796.0000, 'ºC'),
	(6697, 108, '2015-01-15 00:26:36.000000', 'temperatura', 633.0000, 'ºC'),
	(6698, 108, '2015-01-15 00:26:37.000000', 'temperatura', 779.0000, 'ºC'),
	(6699, 108, '2015-01-15 00:26:38.000000', 'temperatura', 794.0000, 'ºC'),
	(6700, 108, '2015-01-15 00:26:39.000000', 'temperatura', 437.0000, 'ºC'),
	(6701, 108, '2015-01-15 00:26:40.000000', 'temperatura', 1002.0000, 'ºC'),
	(6702, 108, '2015-01-15 00:26:41.000000', 'temperatura', 99.0000, 'ºC'),
	(6703, 108, '2015-01-15 00:26:42.000000', 'temperatura', 1089.0000, 'ºC'),
	(6704, 108, '2015-01-15 00:26:43.000000', 'temperatura', 349.0000, 'ºC'),
	(6705, 108, '2015-01-15 00:26:44.000000', 'temperatura', 878.0000, 'ºC'),
	(6706, 108, '2015-01-15 00:26:45.000000', 'temperatura', 946.0000, 'ºC'),
	(6707, 108, '2015-01-15 00:26:46.000000', 'temperatura', 895.0000, 'ºC'),
	(6708, 108, '2015-01-15 00:26:47.000000', 'temperatura', 437.0000, 'ºC'),
	(6709, 108, '2015-01-15 00:26:48.000000', 'temperatura', 703.0000, 'ºC'),
	(6710, 108, '2015-01-15 00:26:49.000000', 'temperatura', 1001.0000, 'ºC'),
	(6711, 108, '2015-01-15 00:26:50.000000', 'temperatura', 499.0000, 'ºC'),
	(6712, 108, '2015-01-15 00:26:51.000000', 'temperatura', 693.0000, 'ºC'),
	(6713, 108, '2015-01-15 00:26:52.000000', 'temperatura', 768.0000, 'ºC'),
	(6714, 108, '2015-01-15 00:26:53.000000', 'temperatura', 563.0000, 'ºC'),
	(6715, 108, '2015-01-15 00:26:54.000000', 'temperatura', 509.0000, 'ºC'),
	(6716, 108, '2015-01-15 00:26:55.000000', 'temperatura', 858.0000, 'ºC'),
	(6717, 108, '2015-01-15 00:26:56.000000', 'temperatura', 365.0000, 'ºC'),
	(6718, 108, '2015-01-15 00:26:57.000000', 'temperatura', 450.0000, 'ºC'),
	(6719, 108, '2015-01-15 00:26:58.000000', 'temperatura', 1157.0000, 'ºC'),
	(6720, 108, '2015-01-15 00:26:59.000000', 'temperatura', 835.0000, 'ºC'),
	(6721, 108, '2015-01-15 00:27:00.000000', 'temperatura', 706.0000, 'ºC'),
	(6722, 108, '2015-01-15 00:27:01.000000', 'temperatura', 1024.0000, 'ºC'),
	(6723, 108, '2015-01-15 00:27:02.000000', 'temperatura', 604.0000, 'ºC'),
	(6724, 108, '2015-01-15 00:27:03.000000', 'temperatura', 1148.0000, 'ºC'),
	(6725, 108, '2015-01-15 00:27:04.000000', 'temperatura', 330.0000, 'ºC'),
	(6726, 108, '2015-01-15 00:27:05.000000', 'temperatura', 604.0000, 'ºC'),
	(6727, 108, '2015-01-15 00:27:06.000000', 'temperatura', 830.0000, 'ºC'),
	(6728, 108, '2015-01-15 00:27:07.000000', 'temperatura', 1138.0000, 'ºC'),
	(6729, 108, '2015-01-15 00:27:08.000000', 'temperatura', 803.0000, 'ºC'),
	(6730, 108, '2015-01-15 00:27:09.000000', 'temperatura', 602.0000, 'ºC'),
	(6731, 108, '2015-01-15 00:27:10.000000', 'temperatura', 601.0000, 'ºC'),
	(6732, 108, '2015-01-15 00:27:11.000000', 'temperatura', 1197.0000, 'ºC'),
	(6733, 108, '2015-01-15 00:27:12.000000', 'temperatura', 586.0000, 'ºC'),
	(6734, 108, '2015-01-15 00:27:13.000000', 'temperatura', 537.0000, 'ºC'),
	(6735, 108, '2015-01-15 00:27:14.000000', 'temperatura', 927.0000, 'ºC'),
	(6736, 108, '2015-01-15 00:27:15.000000', 'temperatura', 627.0000, 'ºC'),
	(6737, 108, '2015-01-15 00:27:16.000000', 'temperatura', 351.0000, 'ºC'),
	(6738, 108, '2015-01-15 00:27:17.000000', 'temperatura', 1077.0000, 'ºC'),
	(6739, 108, '2015-01-15 00:27:18.000000', 'temperatura', 734.0000, 'ºC'),
	(6740, 108, '2015-01-15 00:27:19.000000', 'temperatura', 437.0000, 'ºC'),
	(6741, 108, '2015-01-15 00:27:20.000000', 'temperatura', 1186.0000, 'ºC'),
	(6742, 108, '2015-01-15 00:27:21.000000', 'temperatura', 1019.0000, 'ºC'),
	(6743, 108, '2015-01-15 00:27:22.000000', 'temperatura', 337.0000, 'ºC'),
	(6744, 108, '2015-01-15 00:27:23.000000', 'temperatura', 1030.0000, 'ºC'),
	(6745, 108, '2015-01-15 00:27:24.000000', 'temperatura', 536.0000, 'ºC'),
	(6746, 108, '2015-01-15 00:27:25.000000', 'temperatura', 794.0000, 'ºC'),
	(6747, 108, '2015-01-15 00:27:26.000000', 'temperatura', 1161.0000, 'ºC'),
	(6748, 108, '2015-01-15 00:27:27.000000', 'temperatura', 1025.0000, 'ºC'),
	(6749, 108, '2015-01-15 00:27:28.000000', 'temperatura', 440.0000, 'ºC'),
	(6750, 108, '2015-01-15 00:27:29.000000', 'temperatura', 328.0000, 'ºC'),
	(6751, 108, '2015-01-15 00:27:30.000000', 'temperatura', 320.0000, 'ºC'),
	(6752, 108, '2015-01-15 00:27:31.000000', 'temperatura', 616.0000, 'ºC'),
	(6753, 108, '2015-01-15 00:27:32.000000', 'temperatura', 921.0000, 'ºC'),
	(6754, 108, '2015-01-15 00:27:33.000000', 'temperatura', 356.0000, 'ºC'),
	(6755, 108, '2015-01-15 00:27:34.000000', 'temperatura', 218.0000, 'ºC'),
	(6756, 108, '2015-01-15 00:27:35.000000', 'temperatura', 24.0000, 'ºC'),
	(6757, 108, '2015-01-15 00:27:36.000000', 'temperatura', 666.0000, 'ºC'),
	(6758, 108, '2015-01-15 00:27:37.000000', 'temperatura', 857.0000, 'ºC'),
	(6759, 108, '2015-01-15 00:27:38.000000', 'temperatura', 1087.0000, 'ºC'),
	(6760, 108, '2015-01-15 00:27:39.000000', 'temperatura', 467.0000, 'ºC'),
	(6761, 108, '2015-01-15 00:27:40.000000', 'temperatura', 274.0000, 'ºC'),
	(6762, 108, '2015-01-15 00:27:41.000000', 'temperatura', 1169.0000, 'ºC'),
	(6763, 108, '2015-01-15 00:27:42.000000', 'temperatura', 223.0000, 'ºC'),
	(6764, 108, '2015-01-15 00:27:43.000000', 'temperatura', 10.0000, 'ºC'),
	(6765, 108, '2015-01-15 00:27:44.000000', 'temperatura', 583.0000, 'ºC'),
	(6766, 108, '2015-01-15 00:27:45.000000', 'temperatura', 483.0000, 'ºC'),
	(6767, 108, '2015-01-15 00:27:46.000000', 'temperatura', 667.0000, 'ºC'),
	(6768, 108, '2015-01-15 00:27:47.000000', 'temperatura', 687.0000, 'ºC'),
	(6769, 108, '2015-01-15 00:27:48.000000', 'temperatura', 236.0000, 'ºC'),
	(6770, 108, '2015-01-15 00:27:49.000000', 'temperatura', 317.0000, 'ºC'),
	(6771, 108, '2015-01-15 00:27:50.000000', 'temperatura', 877.0000, 'ºC'),
	(6772, 108, '2015-01-15 00:27:51.000000', 'temperatura', 1035.0000, 'ºC'),
	(6773, 108, '2015-01-15 00:27:52.000000', 'temperatura', 144.0000, 'ºC'),
	(6774, 108, '2015-01-15 00:27:53.000000', 'temperatura', 17.0000, 'ºC'),
	(6775, 108, '2015-01-15 00:27:54.000000', 'temperatura', 855.0000, 'ºC'),
	(6776, 108, '2015-01-15 00:27:55.000000', 'temperatura', 622.0000, 'ºC'),
	(6777, 108, '2015-01-15 00:27:56.000000', 'temperatura', 547.0000, 'ºC'),
	(6778, 108, '2015-01-15 00:27:57.000000', 'temperatura', 869.0000, 'ºC'),
	(6779, 108, '2015-01-15 00:27:58.000000', 'temperatura', 303.0000, 'ºC'),
	(6780, 108, '2015-01-15 00:27:59.000000', 'temperatura', 110.0000, 'ºC'),
	(6781, 108, '2015-01-15 00:28:00.000000', 'temperatura', 841.0000, 'ºC'),
	(6782, 108, '2015-01-15 00:28:01.000000', 'temperatura', 276.0000, 'ºC'),
	(6783, 108, '2015-01-15 00:28:02.000000', 'temperatura', 55.0000, 'ºC'),
	(6784, 108, '2015-01-15 00:28:03.000000', 'temperatura', 651.0000, 'ºC'),
	(6785, 108, '2015-01-15 00:28:04.000000', 'temperatura', 688.0000, 'ºC'),
	(6786, 108, '2015-01-15 00:28:05.000000', 'temperatura', 290.0000, 'ºC'),
	(6787, 108, '2015-01-15 00:28:06.000000', 'temperatura', 584.0000, 'ºC'),
	(6788, 108, '2015-01-15 00:28:07.000000', 'temperatura', 849.0000, 'ºC'),
	(6789, 108, '2015-01-15 00:28:08.000000', 'temperatura', 97.0000, 'ºC'),
	(6790, 108, '2015-01-15 00:28:09.000000', 'temperatura', 338.0000, 'ºC'),
	(6791, 108, '2015-01-15 00:28:10.000000', 'temperatura', 199.0000, 'ºC'),
	(6792, 108, '2015-01-15 00:28:11.000000', 'temperatura', 1183.0000, 'ºC'),
	(6793, 108, '2015-01-15 00:28:12.000000', 'temperatura', 516.0000, 'ºC'),
	(6794, 108, '2015-01-15 00:28:13.000000', 'temperatura', 231.0000, 'ºC'),
	(6795, 108, '2015-01-15 00:28:14.000000', 'temperatura', 809.0000, 'ºC'),
	(6796, 108, '2015-01-15 00:28:15.000000', 'temperatura', 951.0000, 'ºC'),
	(6797, 108, '2015-01-15 00:28:16.000000', 'temperatura', 1130.0000, 'ºC'),
	(6798, 108, '2015-01-15 00:28:17.000000', 'temperatura', 397.0000, 'ºC'),
	(6799, 108, '2015-01-15 00:28:18.000000', 'temperatura', 997.0000, 'ºC'),
	(6800, 108, '2015-01-15 00:28:19.000000', 'temperatura', 194.0000, 'ºC'),
	(6801, 108, '2015-01-15 00:28:20.000000', 'temperatura', 381.0000, 'ºC'),
	(6802, 108, '2015-01-15 00:28:21.000000', 'temperatura', 120.0000, 'ºC'),
	(6803, 108, '2015-01-15 00:28:22.000000', 'temperatura', 661.0000, 'ºC'),
	(6804, 108, '2015-01-15 00:28:23.000000', 'temperatura', 544.0000, 'ºC'),
	(6805, 108, '2015-01-15 00:28:24.000000', 'temperatura', 736.0000, 'ºC'),
	(6806, 108, '2015-01-15 00:28:25.000000', 'temperatura', 848.0000, 'ºC'),
	(6807, 108, '2015-01-15 00:28:26.000000', 'temperatura', 833.0000, 'ºC'),
	(6808, 108, '2015-01-15 00:28:27.000000', 'temperatura', 422.0000, 'ºC'),
	(6809, 108, '2015-01-15 00:28:28.000000', 'temperatura', 811.0000, 'ºC'),
	(6810, 108, '2015-01-15 00:28:29.000000', 'temperatura', 389.0000, 'ºC'),
	(6811, 108, '2015-01-15 00:28:30.000000', 'temperatura', 712.0000, 'ºC'),
	(6812, 108, '2015-01-15 00:28:31.000000', 'temperatura', 1193.0000, 'ºC'),
	(6813, 108, '2015-01-15 00:28:32.000000', 'temperatura', 232.0000, 'ºC'),
	(6814, 108, '2015-01-15 00:28:33.000000', 'temperatura', 1181.0000, 'ºC'),
	(6815, 108, '2015-01-15 00:28:34.000000', 'temperatura', 409.0000, 'ºC'),
	(6816, 108, '2015-01-15 00:28:35.000000', 'temperatura', 903.0000, 'ºC'),
	(6817, 108, '2015-01-15 00:28:36.000000', 'temperatura', 889.0000, 'ºC'),
	(6818, 108, '2015-01-15 00:28:37.000000', 'temperatura', 536.0000, 'ºC'),
	(6819, 108, '2015-01-15 00:28:38.000000', 'temperatura', 13.0000, 'ºC'),
	(6820, 108, '2015-01-15 00:28:39.000000', 'temperatura', 856.0000, 'ºC'),
	(6821, 108, '2015-01-15 00:28:40.000000', 'temperatura', 643.0000, 'ºC'),
	(6822, 108, '2015-01-15 00:28:41.000000', 'temperatura', 647.0000, 'ºC'),
	(6823, 108, '2015-01-15 00:28:42.000000', 'temperatura', 107.0000, 'ºC'),
	(6824, 108, '2015-01-15 00:28:43.000000', 'temperatura', 994.0000, 'ºC'),
	(6825, 108, '2015-01-15 00:28:44.000000', 'temperatura', 1050.0000, 'ºC'),
	(6826, 108, '2015-01-15 00:28:45.000000', 'temperatura', 1069.0000, 'ºC'),
	(6827, 108, '2015-01-15 00:28:46.000000', 'temperatura', 996.0000, 'ºC'),
	(6828, 108, '2015-01-15 00:28:47.000000', 'temperatura', 574.0000, 'ºC'),
	(6829, 108, '2015-01-15 00:28:48.000000', 'temperatura', 1082.0000, 'ºC'),
	(6830, 108, '2015-01-15 00:28:49.000000', 'temperatura', 89.0000, 'ºC'),
	(6831, 108, '2015-01-15 00:28:50.000000', 'temperatura', 799.0000, 'ºC'),
	(6832, 108, '2015-01-15 00:28:51.000000', 'temperatura', 126.0000, 'ºC'),
	(6833, 108, '2015-01-15 00:28:52.000000', 'temperatura', 637.0000, 'ºC'),
	(6834, 108, '2015-01-15 00:28:53.000000', 'temperatura', 406.0000, 'ºC'),
	(6835, 108, '2015-01-15 00:28:54.000000', 'temperatura', 120.0000, 'ºC'),
	(6836, 108, '2015-01-15 00:28:55.000000', 'temperatura', 581.0000, 'ºC'),
	(6837, 108, '2015-01-15 00:28:56.000000', 'temperatura', 149.0000, 'ºC'),
	(6838, 108, '2015-01-15 00:28:57.000000', 'temperatura', 199.0000, 'ºC'),
	(6839, 108, '2015-01-15 00:28:58.000000', 'temperatura', 548.0000, 'ºC'),
	(6840, 108, '2015-01-15 00:28:59.000000', 'temperatura', 944.0000, 'ºC'),
	(6841, 108, '2015-01-15 00:29:00.000000', 'temperatura', 678.0000, 'ºC'),
	(6842, 108, '2015-01-15 00:29:01.000000', 'temperatura', 557.0000, 'ºC'),
	(6843, 108, '2015-01-15 00:29:02.000000', 'temperatura', 752.0000, 'ºC'),
	(6844, 108, '2015-01-15 00:29:03.000000', 'temperatura', 890.0000, 'ºC'),
	(6845, 108, '2015-01-15 00:29:04.000000', 'temperatura', 993.0000, 'ºC'),
	(6846, 108, '2015-01-15 00:29:05.000000', 'temperatura', 1096.0000, 'ºC'),
	(6847, 108, '2015-01-15 00:29:06.000000', 'temperatura', 103.0000, 'ºC'),
	(6848, 108, '2015-01-15 00:29:07.000000', 'temperatura', 828.0000, 'ºC'),
	(6849, 108, '2015-01-15 00:29:08.000000', 'temperatura', 228.0000, 'ºC'),
	(6850, 108, '2015-01-15 00:29:09.000000', 'temperatura', 1060.0000, 'ºC'),
	(6851, 108, '2015-01-15 00:29:10.000000', 'temperatura', 1016.0000, 'ºC'),
	(6852, 108, '2015-01-15 00:29:11.000000', 'temperatura', 701.0000, 'ºC'),
	(6853, 108, '2015-01-15 00:29:12.000000', 'temperatura', 458.0000, 'ºC'),
	(6854, 108, '2015-01-15 00:29:13.000000', 'temperatura', 185.0000, 'ºC'),
	(6855, 108, '2015-01-15 00:29:14.000000', 'temperatura', 752.0000, 'ºC'),
	(6856, 108, '2015-01-15 00:29:15.000000', 'temperatura', 804.0000, 'ºC'),
	(6857, 108, '2015-01-15 00:29:16.000000', 'temperatura', 567.0000, 'ºC'),
	(6858, 108, '2015-01-15 00:29:17.000000', 'temperatura', 423.0000, 'ºC'),
	(6859, 108, '2015-01-15 00:29:18.000000', 'temperatura', 412.0000, 'ºC'),
	(6860, 108, '2015-01-15 00:29:19.000000', 'temperatura', 795.0000, 'ºC'),
	(6861, 108, '2015-01-15 00:29:20.000000', 'temperatura', 338.0000, 'ºC'),
	(6862, 108, '2015-01-15 00:29:21.000000', 'temperatura', 506.0000, 'ºC'),
	(6863, 108, '2015-01-15 00:29:22.000000', 'temperatura', 317.0000, 'ºC'),
	(6864, 108, '2015-01-15 00:29:23.000000', 'temperatura', 67.0000, 'ºC'),
	(6865, 108, '2015-01-15 00:29:24.000000', 'temperatura', 586.0000, 'ºC'),
	(6866, 108, '2015-01-15 00:29:25.000000', 'temperatura', 330.0000, 'ºC'),
	(6867, 108, '2015-01-15 00:29:26.000000', 'temperatura', 1091.0000, 'ºC'),
	(6868, 108, '2015-01-15 00:29:27.000000', 'temperatura', 867.0000, 'ºC'),
	(6869, 108, '2015-01-15 00:29:28.000000', 'temperatura', 1061.0000, 'ºC'),
	(6870, 108, '2015-01-15 00:29:29.000000', 'temperatura', 305.0000, 'ºC'),
	(6871, 108, '2015-01-15 00:29:30.000000', 'temperatura', 740.0000, 'ºC'),
	(6872, 108, '2015-01-15 00:29:31.000000', 'temperatura', 389.0000, 'ºC'),
	(6873, 108, '2015-01-15 00:29:32.000000', 'temperatura', 925.0000, 'ºC'),
	(6874, 108, '2015-01-15 00:29:33.000000', 'temperatura', 1057.0000, 'ºC'),
	(6875, 108, '2015-01-15 00:29:34.000000', 'temperatura', 110.0000, 'ºC'),
	(6876, 108, '2015-01-15 00:29:35.000000', 'temperatura', 980.0000, 'ºC'),
	(6877, 108, '2015-01-15 00:29:36.000000', 'temperatura', 972.0000, 'ºC'),
	(6878, 108, '2015-01-15 00:29:37.000000', 'temperatura', 719.0000, 'ºC'),
	(6879, 108, '2015-01-15 00:29:38.000000', 'temperatura', 680.0000, 'ºC'),
	(6880, 108, '2015-01-15 00:29:39.000000', 'temperatura', 41.0000, 'ºC'),
	(6881, 108, '2015-01-15 00:29:40.000000', 'temperatura', 569.0000, 'ºC'),
	(6882, 108, '2015-01-15 00:29:41.000000', 'temperatura', 321.0000, 'ºC'),
	(6883, 108, '2015-01-15 00:29:42.000000', 'temperatura', 1100.0000, 'ºC'),
	(6884, 108, '2015-01-15 00:29:43.000000', 'temperatura', 934.0000, 'ºC'),
	(6885, 108, '2015-01-15 00:29:44.000000', 'temperatura', 174.0000, 'ºC'),
	(6886, 108, '2015-01-15 00:29:45.000000', 'temperatura', 468.0000, 'ºC'),
	(6887, 108, '2015-01-15 00:29:46.000000', 'temperatura', 619.0000, 'ºC'),
	(6888, 108, '2015-01-15 00:29:47.000000', 'temperatura', 493.0000, 'ºC'),
	(6889, 108, '2015-01-15 00:29:48.000000', 'temperatura', 605.0000, 'ºC'),
	(6890, 108, '2015-01-15 00:29:49.000000', 'temperatura', 349.0000, 'ºC'),
	(6891, 108, '2015-01-15 00:29:50.000000', 'temperatura', 1131.0000, 'ºC'),
	(6892, 108, '2015-01-15 00:29:51.000000', 'temperatura', 1010.0000, 'ºC'),
	(6893, 108, '2015-01-15 00:29:52.000000', 'temperatura', 454.0000, 'ºC'),
	(6894, 108, '2015-01-15 00:29:53.000000', 'temperatura', 444.0000, 'ºC'),
	(6895, 108, '2015-01-15 00:29:54.000000', 'temperatura', 856.0000, 'ºC'),
	(6896, 108, '2015-01-15 00:29:55.000000', 'temperatura', 549.0000, 'ºC'),
	(6897, 108, '2015-01-15 00:29:56.000000', 'temperatura', 176.0000, 'ºC'),
	(6898, 108, '2015-01-15 00:29:57.000000', 'temperatura', 437.0000, 'ºC'),
	(6899, 108, '2015-01-15 00:29:58.000000', 'temperatura', 454.0000, 'ºC'),
	(6900, 108, '2015-01-15 00:29:59.000000', 'temperatura', 962.0000, 'ºC'),
	(6901, 108, '2015-01-15 00:30:00.000000', 'temperatura', 1046.0000, 'ºC'),
	(6902, 108, '2015-01-15 00:30:01.000000', 'temperatura', 1147.0000, 'ºC'),
	(6903, 108, '2015-01-15 00:30:02.000000', 'temperatura', 197.0000, 'ºC'),
	(6904, 108, '2015-01-15 00:30:03.000000', 'temperatura', 1145.0000, 'ºC'),
	(6905, 108, '2015-01-15 00:30:04.000000', 'temperatura', 333.0000, 'ºC'),
	(6906, 108, '2015-01-15 00:30:05.000000', 'temperatura', 630.0000, 'ºC'),
	(6907, 108, '2015-01-15 00:30:06.000000', 'temperatura', 950.0000, 'ºC'),
	(6908, 108, '2015-01-15 00:30:07.000000', 'temperatura', 464.0000, 'ºC'),
	(6909, 108, '2015-01-15 00:30:08.000000', 'temperatura', 669.0000, 'ºC'),
	(6910, 108, '2015-01-15 00:30:09.000000', 'temperatura', 754.0000, 'ºC'),
	(6911, 108, '2015-01-15 00:30:10.000000', 'temperatura', 565.0000, 'ºC'),
	(6912, 108, '2015-01-15 00:30:11.000000', 'temperatura', 560.0000, 'ºC'),
	(6913, 108, '2015-01-15 00:30:12.000000', 'temperatura', 1108.0000, 'ºC'),
	(6914, 108, '2015-01-15 00:30:13.000000', 'temperatura', 261.0000, 'ºC'),
	(6915, 108, '2015-01-15 00:30:14.000000', 'temperatura', 379.0000, 'ºC'),
	(6916, 108, '2015-01-15 00:30:15.000000', 'temperatura', 1112.0000, 'ºC'),
	(6917, 108, '2015-01-15 00:30:16.000000', 'temperatura', 824.0000, 'ºC'),
	(6918, 108, '2015-01-15 00:30:17.000000', 'temperatura', 786.0000, 'ºC'),
	(6919, 108, '2015-01-15 00:30:18.000000', 'temperatura', 260.0000, 'ºC'),
	(6920, 108, '2015-01-15 00:30:19.000000', 'temperatura', 140.0000, 'ºC'),
	(6921, 108, '2015-01-15 00:30:20.000000', 'temperatura', 1121.0000, 'ºC'),
	(6922, 108, '2015-01-15 00:30:21.000000', 'temperatura', 384.0000, 'ºC'),
	(6923, 108, '2015-01-15 00:30:22.000000', 'temperatura', 958.0000, 'ºC'),
	(6924, 108, '2015-01-15 00:30:23.000000', 'temperatura', 40.0000, 'ºC'),
	(6925, 108, '2015-01-15 00:30:24.000000', 'temperatura', 924.0000, 'ºC'),
	(6926, 108, '2015-01-15 00:30:25.000000', 'temperatura', 904.0000, 'ºC'),
	(6927, 108, '2015-01-15 00:30:26.000000', 'temperatura', 545.0000, 'ºC'),
	(6928, 108, '2015-01-15 00:30:27.000000', 'temperatura', 16.0000, 'ºC'),
	(6929, 108, '2015-01-15 00:30:28.000000', 'temperatura', 847.0000, 'ºC'),
	(6930, 108, '2015-01-15 00:30:29.000000', 'temperatura', 584.0000, 'ºC'),
	(6931, 108, '2015-01-15 00:30:30.000000', 'temperatura', 382.0000, 'ºC'),
	(6932, 108, '2015-01-15 00:30:31.000000', 'temperatura', 159.0000, 'ºC'),
	(6933, 108, '2015-01-15 00:30:32.000000', 'temperatura', 849.0000, 'ºC'),
	(6934, 108, '2015-01-15 00:30:33.000000', 'temperatura', 169.0000, 'ºC'),
	(6935, 108, '2015-01-15 00:30:34.000000', 'temperatura', 700.0000, 'ºC'),
	(6936, 108, '2015-01-15 00:30:35.000000', 'temperatura', 591.0000, 'ºC'),
	(6937, 108, '2015-01-15 00:30:36.000000', 'temperatura', 858.0000, 'ºC'),
	(6938, 108, '2015-01-15 00:30:37.000000', 'temperatura', 114.0000, 'ºC'),
	(6939, 108, '2015-01-15 00:30:38.000000', 'temperatura', 400.0000, 'ºC'),
	(6940, 108, '2015-01-15 00:30:39.000000', 'temperatura', 457.0000, 'ºC'),
	(6941, 108, '2015-01-15 00:30:40.000000', 'temperatura', 1084.0000, 'ºC'),
	(6942, 108, '2015-01-15 00:30:41.000000', 'temperatura', 453.0000, 'ºC'),
	(6943, 108, '2015-01-15 00:30:42.000000', 'temperatura', 211.0000, 'ºC'),
	(6944, 108, '2015-01-15 00:30:43.000000', 'temperatura', 895.0000, 'ºC'),
	(6945, 108, '2015-01-15 00:30:44.000000', 'temperatura', 244.0000, 'ºC'),
	(6946, 108, '2015-01-15 00:30:45.000000', 'temperatura', 936.0000, 'ºC'),
	(6947, 108, '2015-01-15 00:30:46.000000', 'temperatura', 348.0000, 'ºC'),
	(6948, 108, '2015-01-15 00:30:47.000000', 'temperatura', 132.0000, 'ºC'),
	(6949, 108, '2015-01-15 00:30:48.000000', 'temperatura', 817.0000, 'ºC'),
	(6950, 108, '2015-01-15 00:30:49.000000', 'temperatura', 91.0000, 'ºC'),
	(6951, 108, '2015-01-15 00:30:50.000000', 'temperatura', 403.0000, 'ºC'),
	(6952, 108, '2015-01-15 00:30:51.000000', 'temperatura', 543.0000, 'ºC'),
	(6953, 108, '2015-01-15 00:30:52.000000', 'temperatura', 306.0000, 'ºC'),
	(6954, 108, '2015-01-15 00:30:53.000000', 'temperatura', 1103.0000, 'ºC'),
	(6955, 108, '2015-01-15 00:30:54.000000', 'temperatura', 997.0000, 'ºC'),
	(6956, 108, '2015-01-15 00:30:55.000000', 'temperatura', 478.0000, 'ºC'),
	(6957, 108, '2015-01-15 00:30:56.000000', 'temperatura', 600.0000, 'ºC'),
	(6958, 108, '2015-01-15 00:30:57.000000', 'temperatura', 364.0000, 'ºC'),
	(6959, 108, '2015-01-15 00:30:58.000000', 'temperatura', 22.0000, 'ºC'),
	(6960, 108, '2015-01-15 00:30:59.000000', 'temperatura', 219.0000, 'ºC'),
	(6961, 108, '2015-01-15 00:31:00.000000', 'temperatura', 1027.0000, 'ºC'),
	(6962, 108, '2015-01-15 00:31:01.000000', 'temperatura', 880.0000, 'ºC'),
	(6963, 108, '2015-01-15 00:31:02.000000', 'temperatura', 118.0000, 'ºC'),
	(6964, 108, '2015-01-15 00:31:03.000000', 'temperatura', 353.0000, 'ºC'),
	(6965, 108, '2015-01-15 00:31:04.000000', 'temperatura', 209.0000, 'ºC'),
	(6966, 108, '2015-01-15 00:31:05.000000', 'temperatura', 1185.0000, 'ºC'),
	(6967, 108, '2015-01-15 00:31:06.000000', 'temperatura', 502.0000, 'ºC'),
	(6968, 108, '2015-01-15 00:31:07.000000', 'temperatura', 155.0000, 'ºC'),
	(6969, 108, '2015-01-15 00:31:08.000000', 'temperatura', 469.0000, 'ºC'),
	(6970, 108, '2015-01-15 00:31:09.000000', 'temperatura', 681.0000, 'ºC'),
	(6971, 108, '2015-01-15 00:31:10.000000', 'temperatura', 798.0000, 'ºC'),
	(6972, 108, '2015-01-15 00:31:11.000000', 'temperatura', 748.0000, 'ºC'),
	(6973, 108, '2015-01-15 00:31:12.000000', 'temperatura', 147.0000, 'ºC'),
	(6974, 108, '2015-01-15 00:31:13.000000', 'temperatura', 892.0000, 'ºC'),
	(6975, 108, '2015-01-15 00:31:14.000000', 'temperatura', 420.0000, 'ºC'),
	(6976, 108, '2015-01-15 00:31:15.000000', 'temperatura', 623.0000, 'ºC'),
	(6977, 108, '2015-01-15 00:31:16.000000', 'temperatura', 656.0000, 'ºC'),
	(6978, 108, '2015-01-15 00:31:17.000000', 'temperatura', 210.0000, 'ºC'),
	(6979, 108, '2015-01-15 00:31:18.000000', 'temperatura', 285.0000, 'ºC'),
	(6980, 108, '2015-01-15 00:31:19.000000', 'temperatura', 793.0000, 'ºC'),
	(6981, 108, '2015-01-15 00:31:20.000000', 'temperatura', 709.0000, 'ºC'),
	(6982, 108, '2015-01-15 00:31:21.000000', 'temperatura', 1170.0000, 'ºC'),
	(6983, 108, '2015-01-15 00:31:22.000000', 'temperatura', 123.0000, 'ºC'),
	(6984, 108, '2015-01-15 00:31:23.000000', 'temperatura', 705.0000, 'ºC'),
	(6985, 108, '2015-01-15 00:31:24.000000', 'temperatura', 758.0000, 'ºC'),
	(6986, 108, '2015-01-15 00:31:25.000000', 'temperatura', 473.0000, 'ºC'),
	(6987, 108, '2015-01-15 00:31:26.000000', 'temperatura', 91.0000, 'ºC'),
	(6988, 108, '2015-01-15 00:31:27.000000', 'temperatura', 236.0000, 'ºC'),
	(6989, 108, '2015-01-15 00:31:28.000000', 'temperatura', 909.0000, 'ºC'),
	(6990, 108, '2015-01-15 00:31:29.000000', 'temperatura', 236.0000, 'ºC'),
	(6991, 108, '2015-01-15 00:31:30.000000', 'temperatura', 853.0000, 'ºC'),
	(6992, 108, '2015-01-15 00:31:31.000000', 'temperatura', 1160.0000, 'ºC'),
	(6993, 108, '2015-01-15 00:31:32.000000', 'temperatura', 840.0000, 'ºC'),
	(6994, 108, '2015-01-15 00:31:33.000000', 'temperatura', 721.0000, 'ºC'),
	(6995, 108, '2015-01-15 00:31:34.000000', 'temperatura', 1086.0000, 'ºC'),
	(6996, 108, '2015-01-15 00:31:35.000000', 'temperatura', 866.0000, 'ºC'),
	(6997, 108, '2015-01-15 00:31:36.000000', 'temperatura', 1074.0000, 'ºC'),
	(6998, 108, '2015-01-15 00:31:37.000000', 'temperatura', 373.0000, 'ºC'),
	(6999, 108, '2015-01-15 00:31:38.000000', 'temperatura', 1044.0000, 'ºC'),
	(7000, 108, '2015-01-15 00:31:39.000000', 'temperatura', 502.0000, 'ºC'),
	(7001, 108, '2015-01-15 00:31:40.000000', 'temperatura', 580.0000, 'ºC'),
	(7002, 108, '2015-01-15 00:31:41.000000', 'temperatura', 191.0000, 'ºC'),
	(7003, 108, '2015-01-15 00:31:42.000000', 'temperatura', 416.0000, 'ºC'),
	(7004, 108, '2015-01-15 00:31:43.000000', 'temperatura', 307.0000, 'ºC'),
	(7005, 108, '2015-01-15 00:31:44.000000', 'temperatura', 287.0000, 'ºC'),
	(7006, 108, '2015-01-15 00:31:45.000000', 'temperatura', 516.0000, 'ºC'),
	(7007, 108, '2015-01-15 00:31:46.000000', 'temperatura', 518.0000, 'ºC'),
	(7008, 108, '2015-01-15 00:31:47.000000', 'temperatura', 1042.0000, 'ºC'),
	(7009, 108, '2015-01-15 00:31:48.000000', 'temperatura', 56.0000, 'ºC'),
	(7010, 108, '2015-01-15 00:31:49.000000', 'temperatura', 756.0000, 'ºC'),
	(7011, 108, '2015-01-15 00:31:50.000000', 'temperatura', 14.0000, 'ºC'),
	(7012, 108, '2015-01-15 00:31:51.000000', 'temperatura', 199.0000, 'ºC'),
	(7013, 108, '2015-01-15 00:31:52.000000', 'temperatura', 956.0000, 'ºC'),
	(7014, 108, '2015-01-15 00:31:53.000000', 'temperatura', 582.0000, 'ºC'),
	(7015, 108, '2015-01-15 00:31:54.000000', 'temperatura', 44.0000, 'ºC'),
	(7016, 108, '2015-01-15 00:31:55.000000', 'temperatura', 874.0000, 'ºC'),
	(7017, 108, '2015-01-15 00:31:56.000000', 'temperatura', 638.0000, 'ºC'),
	(7018, 108, '2015-01-15 00:31:57.000000', 'temperatura', 568.0000, 'ºC'),
	(7019, 108, '2015-01-15 00:31:58.000000', 'temperatura', 925.0000, 'ºC'),
	(7020, 108, '2015-01-15 00:31:59.000000', 'temperatura', 523.0000, 'ºC'),
	(7021, 108, '2015-01-15 00:32:00.000000', 'temperatura', 1039.0000, 'ºC'),
	(7022, 108, '2015-01-15 00:32:01.000000', 'temperatura', 29.0000, 'ºC'),
	(7023, 108, '2015-01-15 00:32:02.000000', 'temperatura', 629.0000, 'ºC'),
	(7024, 108, '2015-01-15 00:32:03.000000', 'temperatura', 656.0000, 'ºC'),
	(7025, 108, '2015-01-15 00:32:04.000000', 'temperatura', 192.0000, 'ºC'),
	(7026, 108, '2015-01-15 00:32:05.000000', 'temperatura', 196.0000, 'ºC'),
	(7027, 108, '2015-01-15 00:32:06.000000', 'temperatura', 402.0000, 'ºC'),
	(7028, 108, '2015-01-15 00:32:07.000000', 'temperatura', 225.0000, 'ºC'),
	(7029, 108, '2015-01-15 00:32:08.000000', 'temperatura', 1116.0000, 'ºC'),
	(7030, 108, '2015-01-15 00:32:09.000000', 'temperatura', 108.0000, 'ºC'),
	(7031, 108, '2015-01-15 00:32:10.000000', 'temperatura', 793.0000, 'ºC'),
	(7032, 108, '2015-01-15 00:32:11.000000', 'temperatura', 42.0000, 'ºC'),
	(7033, 108, '2015-01-15 00:32:12.000000', 'temperatura', 231.0000, 'ºC'),
	(7034, 108, '2015-01-15 00:32:13.000000', 'temperatura', 1029.0000, 'ºC'),
	(7035, 108, '2015-01-15 00:32:14.000000', 'temperatura', 854.0000, 'ºC'),
	(7036, 108, '2015-01-15 00:32:15.000000', 'temperatura', 1185.0000, 'ºC'),
	(7037, 108, '2015-01-15 00:32:16.000000', 'temperatura', 960.0000, 'ºC'),
	(7038, 108, '2015-01-15 00:32:17.000000', 'temperatura', 47.0000, 'ºC'),
	(7039, 108, '2015-01-15 00:32:18.000000', 'temperatura', 953.0000, 'ºC'),
	(7040, 108, '2015-01-15 00:32:19.000000', 'temperatura', 1028.0000, 'ºC'),
	(7041, 108, '2015-01-15 00:32:20.000000', 'temperatura', 1081.0000, 'ºC'),
	(7042, 108, '2015-01-15 00:32:21.000000', 'temperatura', 1122.0000, 'ºC'),
	(7043, 108, '2015-01-15 00:32:22.000000', 'temperatura', 1167.0000, 'ºC'),
	(7044, 108, '2015-01-15 00:32:23.000000', 'temperatura', 68.0000, 'ºC'),
	(7045, 108, '2015-01-15 00:32:24.000000', 'temperatura', 442.0000, 'ºC'),
	(7046, 108, '2015-01-15 00:32:25.000000', 'temperatura', 804.0000, 'ºC'),
	(7047, 108, '2015-01-15 00:32:26.000000', 'temperatura', 295.0000, 'ºC'),
	(7048, 108, '2015-01-15 00:32:27.000000', 'temperatura', 265.0000, 'ºC'),
	(7049, 108, '2015-01-15 00:32:28.000000', 'temperatura', 441.0000, 'ºC'),
	(7050, 108, '2015-01-15 00:32:29.000000', 'temperatura', 210.0000, 'ºC'),
	(7051, 108, '2015-01-15 00:32:30.000000', 'temperatura', 927.0000, 'ºC'),
	(7052, 108, '2015-01-15 00:32:31.000000', 'temperatura', 408.0000, 'ºC'),
	(7053, 108, '2015-01-15 00:32:32.000000', 'temperatura', 457.0000, 'ºC'),
	(7054, 108, '2015-01-15 00:32:33.000000', 'temperatura', 1060.0000, 'ºC'),
	(7055, 108, '2015-01-15 00:32:34.000000', 'temperatura', 332.0000, 'ºC'),
	(7056, 108, '2015-01-15 00:32:35.000000', 'temperatura', 878.0000, 'ºC'),
	(7057, 108, '2015-01-15 00:32:36.000000', 'temperatura', 998.0000, 'ºC'),
	(7058, 108, '2015-01-15 00:32:37.000000', 'temperatura', 1154.0000, 'ºC'),
	(7059, 108, '2015-01-15 00:32:38.000000', 'temperatura', 378.0000, 'ºC'),
	(7060, 108, '2015-01-15 00:32:39.000000', 'temperatura', 826.0000, 'ºC'),
	(7061, 108, '2015-01-15 00:32:40.000000', 'temperatura', 599.0000, 'ºC'),
	(7062, 108, '2015-01-15 00:32:41.000000', 'temperatura', 518.0000, 'ºC'),
	(7063, 108, '2015-01-15 00:32:42.000000', 'temperatura', 795.0000, 'ºC'),
	(7064, 108, '2015-01-15 00:32:43.000000', 'temperatura', 18.0000, 'ºC'),
	(7065, 108, '2015-01-15 00:32:44.000000', 'temperatura', 107.0000, 'ºC'),
	(7066, 108, '2015-01-15 00:32:45.000000', 'temperatura', 480.0000, 'ºC'),
	(7067, 108, '2015-01-15 00:32:46.000000', 'temperatura', 880.0000, 'ºC'),
	(7068, 108, '2015-01-15 00:32:47.000000', 'temperatura', 561.0000, 'ºC'),
	(7069, 108, '2015-01-15 00:32:48.000000', 'temperatura', 166.0000, 'ºC'),
	(7070, 108, '2015-01-15 00:32:49.000000', 'temperatura', 349.0000, 'ºC'),
	(7071, 108, '2015-01-15 00:32:50.000000', 'temperatura', 45.0000, 'ºC'),
	(7072, 108, '2015-01-15 00:32:51.000000', 'temperatura', 381.0000, 'ºC'),
	(7073, 108, '2015-01-15 00:32:52.000000', 'temperatura', 571.0000, 'ºC'),
	(7074, 108, '2015-01-15 00:32:53.000000', 'temperatura', 510.0000, 'ºC'),
	(7075, 108, '2015-01-15 00:32:54.000000', 'temperatura', 840.0000, 'ºC'),
	(7076, 108, '2015-01-15 00:32:55.000000', 'temperatura', 269.0000, 'ºC'),
	(7077, 108, '2015-01-15 00:32:56.000000', 'temperatura', 26.0000, 'ºC'),
	(7078, 108, '2015-01-15 00:32:57.000000', 'temperatura', 525.0000, 'ºC'),
	(7079, 108, '2015-01-15 00:32:58.000000', 'temperatura', 147.0000, 'ºC'),
	(7080, 108, '2015-01-15 00:32:59.000000', 'temperatura', 359.0000, 'ºC'),
	(7081, 108, '2015-01-15 00:33:00.000000', 'temperatura', 156.0000, 'ºC'),
	(7082, 108, '2015-01-15 00:33:01.000000', 'temperatura', 904.0000, 'ºC'),
	(7083, 108, '2015-01-15 00:33:02.000000', 'temperatura', 453.0000, 'ºC'),
	(7084, 108, '2015-01-15 00:33:03.000000', 'temperatura', 753.0000, 'ºC'),
	(7085, 108, '2015-01-15 00:33:04.000000', 'temperatura', 5.0000, 'ºC'),
	(7086, 108, '2015-01-15 00:33:05.000000', 'temperatura', 168.0000, 'ºC'),
	(7087, 108, '2015-01-15 00:33:06.000000', 'temperatura', 825.0000, 'ºC'),
	(7088, 108, '2015-01-15 00:33:07.000000', 'temperatura', 23.0000, 'ºC'),
	(7089, 108, '2015-01-15 00:33:08.000000', 'temperatura', 38.0000, 'ºC'),
	(7090, 108, '2015-01-15 00:33:09.000000', 'temperatura', 121.0000, 'ºC'),
	(7091, 108, '2015-01-15 00:33:10.000000', 'temperatura', 495.0000, 'ºC'),
	(7092, 108, '2015-01-15 00:33:11.000000', 'temperatura', 909.0000, 'ºC'),
	(7093, 108, '2015-01-15 00:33:12.000000', 'temperatura', 662.0000, 'ºC'),
	(7094, 108, '2015-01-15 00:33:13.000000', 'temperatura', 585.0000, 'ºC'),
	(7095, 108, '2015-01-15 00:33:14.000000', 'temperatura', 939.0000, 'ºC'),
	(7096, 108, '2015-01-15 00:33:15.000000', 'temperatura', 540.0000, 'ºC'),
	(7097, 108, '2015-01-15 00:33:16.000000', 'temperatura', 1085.0000, 'ºC'),
	(7098, 108, '2015-01-15 00:33:17.000000', 'temperatura', 204.0000, 'ºC'),
	(7099, 108, '2015-01-15 00:33:18.000000', 'temperatura', 164.0000, 'ºC'),
	(7100, 108, '2015-01-15 00:33:19.000000', 'temperatura', 210.0000, 'ºC'),
	(7101, 108, '2015-01-15 00:33:20.000000', 'temperatura', 558.0000, 'ºC'),
	(7102, 108, '2015-01-15 00:33:21.000000', 'temperatura', 961.0000, 'ºC'),
	(7103, 108, '2015-01-15 00:33:22.000000', 'temperatura', 731.0000, 'ºC'),
	(7104, 108, '2015-01-15 00:33:23.000000', 'temperatura', 771.0000, 'ºC'),
	(7105, 108, '2015-01-15 00:33:24.000000', 'temperatura', 465.0000, 'ºC'),
	(7106, 108, '2015-01-15 00:33:25.000000', 'temperatura', 9.0000, 'ºC'),
	(7107, 108, '2015-01-15 00:33:26.000000', 'temperatura', 1054.0000, 'ºC'),
	(7108, 108, '2015-01-15 00:33:27.000000', 'temperatura', 444.0000, 'ºC'),
	(7109, 108, '2015-01-15 00:33:28.000000', 'temperatura', 257.0000, 'ºC'),
	(7110, 108, '2015-01-15 00:33:29.000000', 'temperatura', 1152.0000, 'ºC'),
	(7111, 108, '2015-01-15 00:33:30.000000', 'temperatura', 190.0000, 'ºC'),
	(7112, 108, '2015-01-15 00:33:31.000000', 'temperatura', 1096.0000, 'ºC'),
	(7113, 108, '2015-01-15 00:33:32.000000', 'temperatura', 109.0000, 'ºC'),
	(7114, 108, '2015-01-15 00:33:33.000000', 'temperatura', 858.0000, 'ºC'),
	(7115, 108, '2015-01-15 00:33:34.000000', 'temperatura', 362.0000, 'ºC'),
	(7116, 108, '2015-01-15 00:33:35.000000', 'temperatura', 439.0000, 'ºC'),
	(7117, 108, '2015-01-15 00:33:36.000000', 'temperatura', 1109.0000, 'ºC'),
	(7118, 108, '2015-01-15 00:33:37.000000', 'temperatura', 627.0000, 'ºC'),
	(7119, 108, '2015-01-15 00:33:38.000000', 'temperatura', 1011.0000, 'ºC'),
	(7120, 108, '2015-01-15 00:33:39.000000', 'temperatura', 775.0000, 'ºC'),
	(7121, 108, '2015-01-15 00:33:40.000000', 'temperatura', 841.0000, 'ºC'),
	(7122, 108, '2015-01-15 00:33:41.000000', 'temperatura', 681.0000, 'ºC'),
	(7123, 108, '2015-01-15 00:33:42.000000', 'temperatura', 883.0000, 'ºC'),
	(7124, 108, '2015-01-15 00:33:43.000000', 'temperatura', 1171.0000, 'ºC'),
	(7125, 108, '2015-01-15 00:33:44.000000', 'temperatura', 807.0000, 'ºC'),
	(7126, 108, '2015-01-15 00:33:45.000000', 'temperatura', 522.0000, 'ºC'),
	(7127, 108, '2015-01-15 00:33:46.000000', 'temperatura', 191.0000, 'ºC'),
	(7128, 108, '2015-01-15 00:33:47.000000', 'temperatura', 591.0000, 'ºC'),
	(7129, 108, '2015-01-15 00:33:48.000000', 'temperatura', 1179.0000, 'ºC'),
	(7130, 108, '2015-01-15 00:33:49.000000', 'temperatura', 524.0000, 'ºC'),
	(7131, 108, '2015-01-15 00:33:50.000000', 'temperatura', 282.0000, 'ºC'),
	(7132, 108, '2015-01-15 00:33:51.000000', 'temperatura', 1041.0000, 'ºC'),
	(7133, 108, '2015-01-15 00:33:52.000000', 'temperatura', 758.0000, 'ºC'),
	(7134, 108, '2015-01-15 00:33:53.000000', 'temperatura', 666.0000, 'ºC'),
	(7135, 108, '2015-01-15 00:33:54.000000', 'temperatura', 1059.0000, 'ºC'),
	(7136, 108, '2015-01-15 00:33:55.000000', 'temperatura', 896.0000, 'ºC'),
	(7137, 108, '2015-01-15 00:33:56.000000', 'temperatura', 104.0000, 'ºC'),
	(7138, 108, '2015-01-15 00:33:57.000000', 'temperatura', 234.0000, 'ºC'),
	(7139, 108, '2015-01-15 00:33:58.000000', 'temperatura', 858.0000, 'ºC'),
	(7140, 108, '2015-01-15 00:33:59.000000', 'temperatura', 1190.0000, 'ºC'),
	(7141, 108, '2015-01-15 00:34:00.000000', 'temperatura', 975.0000, 'ºC'),
	(7142, 108, '2015-01-15 00:34:01.000000', 'temperatura', 106.0000, 'ºC'),
	(7143, 108, '2015-01-15 00:34:02.000000', 'temperatura', 5.0000, 'ºC'),
	(7144, 108, '2015-01-15 00:34:03.000000', 'temperatura', 906.0000, 'ºC'),
	(7145, 108, '2015-01-15 00:34:04.000000', 'temperatura', 918.0000, 'ºC'),
	(7146, 108, '2015-01-15 00:34:05.000000', 'temperatura', 671.0000, 'ºC'),
	(7147, 108, '2015-01-15 00:34:06.000000', 'temperatura', 602.0000, 'ºC'),
	(7148, 108, '2015-01-15 00:34:07.000000', 'temperatura', 999.0000, 'ºC'),
	(7149, 108, '2015-01-15 00:34:08.000000', 'temperatura', 789.0000, 'ºC'),
	(7150, 108, '2015-01-15 00:34:09.000000', 'temperatura', 950.0000, 'ºC'),
	(7151, 108, '2015-01-15 00:34:10.000000', 'temperatura', 1182.0000, 'ºC'),
	(7152, 108, '2015-01-15 00:34:11.000000', 'temperatura', 660.0000, 'ºC'),
	(7153, 108, '2015-01-15 00:34:12.000000', 'temperatura', 955.0000, 'ºC'),
	(7154, 108, '2015-01-15 00:34:13.000000', 'temperatura', 396.0000, 'ºC'),
	(7155, 108, '2015-01-15 00:34:14.000000', 'temperatura', 315.0000, 'ºC'),
	(7156, 108, '2015-01-15 00:34:15.000000', 'temperatura', 386.0000, 'ºC'),
	(7157, 108, '2015-01-15 00:34:16.000000', 'temperatura', 988.0000, 'ºC'),
	(7158, 108, '2015-01-15 00:34:17.000000', 'temperatura', 182.0000, 'ºC'),
	(7159, 108, '2015-01-15 00:34:18.000000', 'temperatura', 346.0000, 'ºC'),
	(7160, 108, '2015-01-15 00:34:19.000000', 'temperatura', 1185.0000, 'ºC'),
	(7161, 108, '2015-01-15 00:34:20.000000', 'temperatura', 86.0000, 'ºC'),
	(7162, 108, '2015-01-15 00:34:21.000000', 'temperatura', 474.0000, 'ºC'),
	(7163, 108, '2015-01-15 00:34:22.000000', 'temperatura', 916.0000, 'ºC'),
	(7164, 108, '2015-01-15 00:34:23.000000', 'temperatura', 757.0000, 'ºC'),
	(7165, 108, '2015-01-15 00:34:24.000000', 'temperatura', 1037.0000, 'ºC'),
	(7166, 108, '2015-01-15 00:34:25.000000', 'temperatura', 513.0000, 'ºC'),
	(7167, 108, '2015-01-15 00:34:26.000000', 'temperatura', 657.0000, 'ºC'),
	(7168, 108, '2015-01-15 00:34:27.000000', 'temperatura', 545.0000, 'ºC'),
	(7169, 108, '2015-01-15 00:34:28.000000', 'temperatura', 754.0000, 'ºC'),
	(7170, 108, '2015-01-15 00:34:29.000000', 'temperatura', 937.0000, 'ºC'),
	(7171, 108, '2015-01-15 00:34:30.000000', 'temperatura', 23.0000, 'ºC'),
	(7172, 108, '2015-01-15 00:34:31.000000', 'temperatura', 904.0000, 'ºC'),
	(7173, 108, '2015-01-15 00:34:32.000000', 'temperatura', 851.0000, 'ºC'),
	(7174, 108, '2015-01-15 00:34:33.000000', 'temperatura', 346.0000, 'ºC'),
	(7175, 108, '2015-01-15 00:34:34.000000', 'temperatura', 377.0000, 'ºC'),
	(7176, 108, '2015-01-15 00:34:35.000000', 'temperatura', 846.0000, 'ºC'),
	(7177, 108, '2015-01-15 00:34:36.000000', 'temperatura', 702.0000, 'ºC'),
	(7178, 108, '2015-01-15 00:34:37.000000', 'temperatura', 971.0000, 'ºC'),
	(7179, 108, '2015-01-15 00:34:38.000000', 'temperatura', 350.0000, 'ºC'),
	(7180, 108, '2015-01-15 00:34:39.000000', 'temperatura', 39.0000, 'ºC'),
	(7181, 108, '2015-01-15 00:34:40.000000', 'temperatura', 346.0000, 'ºC'),
	(7182, 108, '2015-01-15 00:34:41.000000', 'temperatura', 412.0000, 'ºC'),
	(7183, 108, '2015-01-15 00:34:42.000000', 'temperatura', 1023.0000, 'ºC'),
	(7184, 108, '2015-01-15 00:34:43.000000', 'temperatura', 279.0000, 'ºC'),
	(7185, 108, '2015-01-15 00:34:44.000000', 'temperatura', 727.0000, 'ºC'),
	(7186, 108, '2015-01-15 00:34:45.000000', 'temperatura', 400.0000, 'ºC'),
	(7187, 108, '2015-01-15 00:34:46.000000', 'temperatura', 1017.0000, 'ºC'),
	(7188, 108, '2015-01-15 00:34:47.000000', 'temperatura', 285.0000, 'ºC'),
	(7189, 108, '2015-01-15 00:34:48.000000', 'temperatura', 777.0000, 'ºC'),
	(7190, 108, '2015-01-15 00:34:49.000000', 'temperatura', 629.0000, 'ºC'),
	(7191, 108, '2015-01-15 00:34:50.000000', 'temperatura', 814.0000, 'ºC'),
	(7192, 108, '2015-01-15 00:34:51.000000', 'temperatura', 984.0000, 'ºC'),
	(7193, 108, '2015-01-15 00:34:52.000000', 'temperatura', 80.0000, 'ºC'),
	(7194, 108, '2015-01-15 00:34:53.000000', 'temperatura', 1050.0000, 'ºC'),
	(7195, 108, '2015-01-15 00:34:54.000000', 'temperatura', 207.0000, 'ºC'),
	(7196, 108, '2015-01-15 00:34:55.000000', 'temperatura', 285.0000, 'ºC'),
	(7197, 108, '2015-01-15 00:34:56.000000', 'temperatura', 806.0000, 'ºC'),
	(7198, 108, '2015-01-15 00:34:57.000000', 'temperatura', 776.0000, 'ºC'),
	(7199, 108, '2015-01-15 00:34:58.000000', 'temperatura', 262.0000, 'ºC'),
	(7200, 108, '2015-01-15 00:34:59.000000', 'temperatura', 182.0000, 'ºC'),
	(7201, 108, '2015-01-15 00:35:00.000000', 'temperatura', 125.0000, 'ºC'),
	(7202, 108, '2015-01-15 00:35:01.000000', 'temperatura', 81.0000, 'ºC'),
	(7203, 108, '2015-01-15 00:35:02.000000', 'temperatura', 28.0000, 'ºC'),
	(7204, 108, '2015-01-15 00:35:03.000000', 'temperatura', 1101.0000, 'ºC'),
	(7205, 108, '2015-01-15 00:35:04.000000', 'temperatura', 618.0000, 'ºC'),
	(7206, 108, '2015-01-15 00:35:05.000000', 'temperatura', 989.0000, 'ºC'),
	(7207, 108, '2015-01-15 00:35:06.000000', 'temperatura', 690.0000, 'ºC'),
	(7208, 108, '2015-01-15 00:35:07.000000', 'temperatura', 485.0000, 'ºC'),
	(7209, 108, '2015-01-15 00:35:08.000000', 'temperatura', 355.0000, 'ºC'),
	(7210, 108, '2015-01-15 00:35:09.000000', 'temperatura', 320.0000, 'ºC'),
	(7211, 108, '2015-01-15 00:35:10.000000', 'temperatura', 538.0000, 'ºC'),
	(7212, 108, '2015-01-15 00:35:11.000000', 'temperatura', 529.0000, 'ºC'),
	(7213, 108, '2015-01-15 00:35:12.000000', 'temperatura', 1032.0000, 'ºC'),
	(7214, 108, '2015-01-15 00:35:13.000000', 'temperatura', 1172.0000, 'ºC'),
	(7215, 108, '2015-01-15 00:35:14.000000', 'temperatura', 367.0000, 'ºC'),
	(7216, 108, '2015-01-15 00:35:15.000000', 'temperatura', 720.0000, 'ºC'),
	(7217, 108, '2015-01-15 00:35:16.000000', 'temperatura', 100.0000, 'ºC'),
	(7218, 108, '2015-01-15 00:35:17.000000', 'temperatura', 738.0000, 'ºC'),
	(7219, 108, '2015-01-15 00:35:18.000000', 'temperatura', 991.0000, 'ºC'),
	(7220, 108, '2015-01-15 00:35:19.000000', 'temperatura', 342.0000, 'ºC'),
	(7221, 108, '2015-01-15 00:35:20.000000', 'temperatura', 1138.0000, 'ºC'),
	(7222, 108, '2015-01-15 00:35:21.000000', 'temperatura', 1062.0000, 'ºC'),
	(7223, 108, '2015-01-15 00:35:22.000000', 'temperatura', 698.0000, 'ºC'),
	(7224, 108, '2015-01-15 00:35:23.000000', 'temperatura', 303.0000, 'ºC'),
	(7225, 108, '2015-01-15 00:35:24.000000', 'temperatura', 623.0000, 'ºC'),
	(7226, 108, '2015-01-15 00:35:25.000000', 'temperatura', 1007.0000, 'ºC'),
	(7227, 108, '2015-01-15 00:35:26.000000', 'temperatura', 767.0000, 'ºC'),
	(7228, 108, '2015-01-15 00:35:27.000000', 'temperatura', 814.0000, 'ºC'),
	(7229, 108, '2015-01-15 00:35:28.000000', 'temperatura', 569.0000, 'ºC'),
	(7230, 108, '2015-01-15 00:35:29.000000', 'temperatura', 406.0000, 'ºC'),
	(7231, 108, '2015-01-15 00:35:30.000000', 'temperatura', 321.0000, 'ºC'),
	(7232, 108, '2015-01-15 00:35:31.000000', 'temperatura', 389.0000, 'ºC'),
	(7233, 108, '2015-01-15 00:35:32.000000', 'temperatura', 981.0000, 'ºC'),
	(7234, 108, '2015-01-15 00:35:33.000000', 'temperatura', 140.0000, 'ºC'),
	(7235, 108, '2015-01-15 00:35:34.000000', 'temperatura', 157.0000, 'ºC'),
	(7236, 108, '2015-01-15 00:35:35.000000', 'temperatura', 367.0000, 'ºC'),
	(7237, 108, '2015-01-15 00:35:36.000000', 'temperatura', 162.0000, 'ºC'),
	(7238, 108, '2015-01-15 00:35:37.000000', 'temperatura', 910.0000, 'ºC'),
	(7239, 108, '2015-01-15 00:35:38.000000', 'temperatura', 465.0000, 'ºC'),
	(7240, 108, '2015-01-15 00:35:39.000000', 'temperatura', 797.0000, 'ºC'),
	(7241, 108, '2015-01-15 00:35:40.000000', 'temperatura', 190.0000, 'ºC'),
	(7242, 108, '2015-01-15 00:35:41.000000', 'temperatura', 959.0000, 'ºC'),
	(7243, 108, '2015-01-15 00:35:42.000000', 'temperatura', 625.0000, 'ºC'),
	(7244, 108, '2015-01-15 00:35:43.000000', 'temperatura', 250.0000, 'ºC'),
	(7245, 108, '2015-01-15 00:35:44.000000', 'temperatura', 575.0000, 'ºC'),
	(7246, 108, '2015-01-15 00:35:45.000000', 'temperatura', 927.0000, 'ºC'),
	(7247, 108, '2015-01-15 00:35:46.000000', 'temperatura', 510.0000, 'ºC'),
	(7248, 108, '2015-01-15 00:35:47.000000', 'temperatura', 967.0000, 'ºC'),
	(7249, 108, '2015-01-15 00:35:48.000000', 'temperatura', 907.0000, 'ºC'),
	(7250, 108, '2015-01-15 00:35:49.000000', 'temperatura', 436.0000, 'ºC'),
	(7251, 108, '2015-01-15 00:35:50.000000', 'temperatura', 657.0000, 'ºC'),
	(7252, 108, '2015-01-15 00:35:51.000000', 'temperatura', 779.0000, 'ºC'),
	(7253, 108, '2015-01-15 00:35:52.000000', 'temperatura', 726.0000, 'ºC'),
	(7254, 108, '2015-01-15 00:35:53.000000', 'temperatura', 90.0000, 'ºC'),
	(7255, 108, '2015-01-15 00:35:54.000000', 'temperatura', 675.0000, 'ºC'),
	(7256, 108, '2015-01-15 00:35:55.000000', 'temperatura', 706.0000, 'ºC'),
	(7257, 108, '2015-01-15 00:35:56.000000', 'temperatura', 305.0000, 'ºC'),
	(7258, 108, '2015-01-15 00:35:57.000000', 'temperatura', 608.0000, 'ºC'),
	(7259, 108, '2015-01-15 00:35:58.000000', 'temperatura', 927.0000, 'ºC'),
	(7260, 108, '2015-01-15 00:35:59.000000', 'temperatura', 409.0000, 'ºC'),
	(7261, 108, '2015-01-15 00:36:00.000000', 'temperatura', 466.0000, 'ºC'),
	(7262, 108, '2015-01-15 00:36:01.000000', 'temperatura', 1103.0000, 'ºC'),
	(7263, 108, '2015-01-15 00:36:02.000000', 'temperatura', 520.0000, 'ºC'),
	(7264, 108, '2015-01-15 00:36:03.000000', 'temperatura', 488.0000, 'ºC'),
	(7265, 108, '2015-01-15 00:36:04.000000', 'temperatura', 883.0000, 'ºC'),
	(7266, 108, '2015-01-15 00:36:05.000000', 'temperatura', 549.0000, 'ºC'),
	(7267, 108, '2015-01-15 00:36:06.000000', 'temperatura', 97.0000, 'ºC'),
	(7268, 108, '2015-01-15 00:36:07.000000', 'temperatura', 39.0000, 'ºC'),
	(7269, 108, '2015-01-15 00:36:08.000000', 'temperatura', 1104.0000, 'ºC'),
	(7270, 108, '2015-01-15 00:36:09.000000', 'temperatura', 605.0000, 'ºC'),
	(7271, 108, '2015-01-15 00:36:10.000000', 'temperatura', 913.0000, 'ºC'),
	(7272, 108, '2015-01-15 00:36:11.000000', 'temperatura', 350.0000, 'ºC'),
	(7273, 108, '2015-01-15 00:36:12.000000', 'temperatura', 214.0000, 'ºC'),
	(7274, 108, '2015-01-15 00:36:13.000000', 'temperatura', 18.0000, 'ºC'),
	(7275, 108, '2015-01-15 00:36:14.000000', 'temperatura', 648.0000, 'ºC'),
	(7276, 108, '2015-01-15 00:36:15.000000', 'temperatura', 788.0000, 'ºC'),
	(7277, 108, '2015-01-15 00:36:16.000000', 'temperatura', 795.0000, 'ºC'),
	(7278, 108, '2015-01-15 00:36:17.000000', 'temperatura', 413.0000, 'ºC'),
	(7279, 108, '2015-01-15 00:36:18.000000', 'temperatura', 880.0000, 'ºC'),
	(7280, 108, '2015-01-15 00:36:19.000000', 'temperatura', 762.0000, 'ºC'),
	(7281, 108, '2015-01-15 00:36:20.000000', 'temperatura', 1170.0000, 'ºC'),
	(7282, 108, '2015-01-15 00:36:21.000000', 'temperatura', 1164.0000, 'ºC'),
	(7283, 108, '2015-01-15 00:36:22.000000', 'temperatura', 1111.0000, 'ºC'),
	(7284, 108, '2015-01-15 00:36:23.000000', 'temperatura', 863.0000, 'ºC'),
	(7285, 108, '2015-01-15 00:36:24.000000', 'temperatura', 983.0000, 'ºC'),
	(7286, 108, '2015-01-15 00:36:25.000000', 'temperatura', 1128.0000, 'ºC'),
	(7287, 108, '2015-01-15 00:36:26.000000', 'temperatura', 291.0000, 'ºC'),
	(7288, 108, '2015-01-15 00:36:27.000000', 'temperatura', 471.0000, 'ºC'),
	(7289, 108, '2015-01-15 00:36:28.000000', 'temperatura', 281.0000, 'ºC'),
	(7290, 108, '2015-01-15 00:36:29.000000', 'temperatura', 1192.0000, 'ºC'),
	(7291, 108, '2015-01-15 00:36:30.000000', 'temperatura', 321.0000, 'ºC'),
	(7292, 108, '2015-01-15 00:36:31.000000', 'temperatura', 426.0000, 'ºC'),
	(7293, 108, '2015-01-15 00:36:32.000000', 'temperatura', 1168.0000, 'ºC'),
	(7294, 108, '2015-01-15 00:36:33.000000', 'temperatura', 965.0000, 'ºC'),
	(7295, 108, '2015-01-15 00:36:34.000000', 'temperatura', 120.0000, 'ºC'),
	(7296, 108, '2015-01-15 00:36:35.000000', 'temperatura', 106.0000, 'ºC'),
	(7297, 108, '2015-01-15 00:36:36.000000', 'temperatura', 170.0000, 'ºC'),
	(7298, 108, '2015-01-15 00:36:37.000000', 'temperatura', 533.0000, 'ºC'),
	(7299, 108, '2015-01-15 00:36:38.000000', 'temperatura', 954.0000, 'ºC'),
	(7300, 108, '2015-01-15 00:36:39.000000', 'temperatura', 771.0000, 'ºC'),
	(7301, 108, '2015-01-15 00:36:40.000000', 'temperatura', 996.0000, 'ºC'),
	(7302, 108, '2015-01-15 00:36:41.000000', 'temperatura', 268.0000, 'ºC'),
	(7303, 108, '2015-01-15 00:36:42.000000', 'temperatura', 751.0000, 'ºC'),
	(7304, 108, '2015-01-15 00:36:43.000000', 'temperatura', 554.0000, 'ºC'),
	(7305, 108, '2015-01-15 00:36:44.000000', 'temperatura', 515.0000, 'ºC'),
	(7306, 108, '2015-01-15 00:36:45.000000', 'temperatura', 913.0000, 'ºC'),
	(7307, 108, '2015-01-15 00:36:46.000000', 'temperatura', 621.0000, 'ºC'),
	(7308, 108, '2015-01-15 00:36:47.000000', 'temperatura', 366.0000, 'ºC'),
	(7309, 108, '2015-01-15 00:36:48.000000', 'temperatura', 1169.0000, 'ºC'),
	(7310, 108, '2015-01-15 00:36:49.000000', 'temperatura', 1146.0000, 'ºC'),
	(7311, 108, '2015-01-15 00:36:50.000000', 'temperatura', 1025.0000, 'ºC'),
	(7312, 108, '2015-01-15 00:36:51.000000', 'temperatura', 487.0000, 'ºC'),
	(7313, 108, '2015-01-15 00:36:52.000000', 'temperatura', 559.0000, 'ºC'),
	(7314, 108, '2015-01-15 00:36:53.000000', 'temperatura', 136.0000, 'ºC'),
	(7315, 108, '2015-01-15 00:36:54.000000', 'temperatura', 205.0000, 'ºC'),
	(7316, 108, '2015-01-15 00:36:55.000000', 'temperatura', 617.0000, 'ºC'),
	(7317, 108, '2015-01-15 00:36:56.000000', 'temperatura', 68.0000, 'ºC'),
	(7318, 108, '2015-01-15 00:36:57.000000', 'temperatura', 891.0000, 'ºC'),
	(7319, 108, '2015-01-15 00:36:58.000000', 'temperatura', 649.0000, 'ºC'),
	(7320, 108, '2015-01-15 00:36:59.000000', 'temperatura', 576.0000, 'ºC'),
	(7321, 108, '2015-01-15 00:37:00.000000', 'temperatura', 931.0000, 'ºC'),
	(7322, 108, '2015-01-15 00:37:01.000000', 'temperatura', 528.0000, 'ºC'),
	(7323, 108, '2015-01-15 00:37:02.000000', 'temperatura', 1047.0000, 'ºC'),
	(7324, 108, '2015-01-15 00:37:03.000000', 'temperatura', 52.0000, 'ºC'),
	(7325, 108, '2015-01-15 00:37:04.000000', 'temperatura', 719.0000, 'ºC'),
	(7326, 108, '2015-01-15 00:37:05.000000', 'temperatura', 1040.0000, 'ºC'),
	(7327, 108, '2015-01-15 00:37:06.000000', 'temperatura', 642.0000, 'ºC'),
	(7328, 108, '2015-01-15 00:37:07.000000', 'temperatura', 90.0000, 'ºC'),
	(7329, 108, '2015-01-15 00:37:08.000000', 'temperatura', 927.0000, 'ºC'),
	(7330, 108, '2015-01-15 00:37:09.000000', 'temperatura', 765.0000, 'ºC'),
	(7331, 108, '2015-01-15 00:37:10.000000', 'temperatura', 1045.0000, 'ºC'),
	(7332, 108, '2015-01-15 00:37:11.000000', 'temperatura', 530.0000, 'ºC'),
	(7333, 108, '2015-01-15 00:37:12.000000', 'temperatura', 716.0000, 'ºC'),
	(7334, 108, '2015-01-15 00:37:13.000000', 'temperatura', 790.0000, 'ºC'),
	(7335, 108, '2015-01-15 00:37:14.000000', 'temperatura', 602.0000, 'ºC'),
	(7336, 108, '2015-01-15 00:37:15.000000', 'temperatura', 642.0000, 'ºC'),
	(7337, 108, '2015-01-15 00:37:16.000000', 'temperatura', 202.0000, 'ºC'),
	(7338, 108, '2015-01-15 00:37:17.000000', 'temperatura', 285.0000, 'ºC'),
	(7339, 108, '2015-01-15 00:37:18.000000', 'temperatura', 819.0000, 'ºC'),
	(7340, 108, '2015-01-15 00:37:19.000000', 'temperatura', 839.0000, 'ºC'),
	(7341, 108, '2015-01-15 00:37:20.000000', 'temperatura', 542.0000, 'ºC'),
	(7342, 108, '2015-01-15 00:37:21.000000', 'temperatura', 191.0000, 'ºC'),
	(7343, 108, '2015-01-15 00:37:22.000000', 'temperatura', 530.0000, 'ºC'),
	(7344, 108, '2015-01-15 00:37:23.000000', 'temperatura', 876.0000, 'ºC'),
	(7345, 108, '2015-01-15 00:37:24.000000', 'temperatura', 392.0000, 'ºC'),
	(7346, 108, '2015-01-15 00:37:25.000000', 'temperatura', 533.0000, 'ºC'),
	(7347, 108, '2015-01-15 00:37:26.000000', 'temperatura', 290.0000, 'ºC'),
	(7348, 108, '2015-01-15 00:37:27.000000', 'temperatura', 1051.0000, 'ºC'),
	(7349, 108, '2015-01-15 00:37:28.000000', 'temperatura', 785.0000, 'ºC'),
	(7350, 108, '2015-01-15 00:37:29.000000', 'temperatura', 773.0000, 'ºC'),
	(7351, 108, '2015-01-15 00:37:30.000000', 'temperatura', 309.0000, 'ºC'),
	(7352, 108, '2015-01-15 00:37:31.000000', 'temperatura', 426.0000, 'ºC'),
	(7353, 108, '2015-01-15 00:37:32.000000', 'temperatura', 5.0000, 'ºC'),
	(7354, 108, '2015-01-15 00:37:33.000000', 'temperatura', 1148.0000, 'ºC'),
	(7355, 108, '2015-01-15 00:37:34.000000', 'temperatura', 923.0000, 'ºC'),
	(7356, 108, '2015-01-15 00:37:35.000000', 'temperatura', 1172.0000, 'ºC'),
	(7357, 108, '2015-01-15 00:37:36.000000', 'temperatura', 692.0000, 'ºC'),
	(7358, 108, '2015-01-15 00:37:37.000000', 'temperatura', 1145.0000, 'ºC'),
	(7359, 108, '2015-01-15 00:37:38.000000', 'temperatura', 48.0000, 'ºC'),
	(7360, 108, '2015-01-15 00:37:39.000000', 'temperatura', 408.0000, 'ºC'),
	(7361, 108, '2015-01-15 00:37:40.000000', 'temperatura', 695.0000, 'ºC'),
	(7362, 108, '2015-01-15 00:37:41.000000', 'temperatura', 1052.0000, 'ºC'),
	(7363, 108, '2015-01-15 00:37:42.000000', 'temperatura', 777.0000, 'ºC'),
	(7364, 108, '2015-01-15 00:37:43.000000', 'temperatura', 729.0000, 'ºC'),
	(7365, 108, '2015-01-15 00:37:44.000000', 'temperatura', 113.0000, 'ºC'),
	(7366, 108, '2015-01-15 00:37:45.000000', 'temperatura', 780.0000, 'ºC'),
	(7367, 108, '2015-01-15 00:37:46.000000', 'temperatura', 1163.0000, 'ºC'),
	(7368, 108, '2015-01-15 00:37:47.000000', 'temperatura', 1074.0000, 'ºC'),
	(7369, 108, '2015-01-15 00:37:48.000000', 'temperatura', 681.0000, 'ºC'),
	(7370, 108, '2015-01-15 00:37:49.000000', 'temperatura', 183.0000, 'ºC'),
	(7371, 108, '2015-01-15 00:37:50.000000', 'temperatura', 75.0000, 'ºC'),
	(7372, 108, '2015-01-15 00:37:51.000000', 'temperatura', 1025.0000, 'ºC'),
	(7373, 108, '2015-01-15 00:37:52.000000', 'temperatura', 102.0000, 'ºC'),
	(7374, 108, '2015-01-15 00:37:53.000000', 'temperatura', 1036.0000, 'ºC'),
	(7375, 108, '2015-01-15 00:37:54.000000', 'temperatura', 72.0000, 'ºC'),
	(7376, 108, '2015-01-15 00:37:55.000000', 'temperatura', 853.0000, 'ºC'),
	(7377, 108, '2015-01-15 00:37:56.000000', 'temperatura', 452.0000, 'ºC'),
	(7378, 108, '2015-01-15 00:37:57.000000', 'temperatura', 898.0000, 'ºC'),
	(7379, 108, '2015-01-15 00:37:58.000000', 'temperatura', 737.0000, 'ºC'),
	(7380, 108, '2015-01-15 00:37:59.000000', 'temperatura', 992.0000, 'ºC'),
	(7381, 108, '2015-01-15 00:38:00.000000', 'temperatura', 348.0000, 'ºC'),
	(7382, 108, '2015-01-15 00:38:01.000000', 'temperatura', 1167.0000, 'ºC'),
	(7383, 108, '2015-01-15 00:38:02.000000', 'temperatura', 1188.0000, 'ºC'),
	(7384, 108, '2015-01-15 00:38:03.000000', 'temperatura', 41.0000, 'ºC'),
	(7385, 108, '2015-01-15 00:38:04.000000', 'temperatura', 241.0000, 'ºC'),
	(7386, 108, '2015-01-15 00:38:05.000000', 'temperatura', 1082.0000, 'ºC'),
	(7387, 108, '2015-01-15 00:38:06.000000', 'temperatura', 1089.0000, 'ºC'),
	(7388, 108, '2015-01-15 00:38:07.000000', 'temperatura', 999.0000, 'ºC'),
	(7389, 108, '2015-01-15 00:38:08.000000', 'temperatura', 530.0000, 'ºC'),
	(7390, 108, '2015-01-15 00:38:09.000000', 'temperatura', 854.0000, 'ºC'),
	(7391, 108, '2015-01-15 00:38:10.000000', 'temperatura', 281.0000, 'ºC'),
	(7392, 108, '2015-01-15 00:38:11.000000', 'temperatura', 40.0000, 'ºC'),
	(7393, 108, '2015-01-15 00:38:12.000000', 'temperatura', 561.0000, 'ºC'),
	(7394, 108, '2015-01-15 00:38:13.000000', 'temperatura', 283.0000, 'ºC'),
	(7395, 108, '2015-01-15 00:38:14.000000', 'temperatura', 934.0000, 'ºC'),
	(7396, 108, '2015-01-15 00:38:15.000000', 'temperatura', 221.0000, 'ºC'),
	(7397, 108, '2015-01-15 00:38:16.000000', 'temperatura', 704.0000, 'ºC'),
	(7398, 108, '2015-01-15 00:38:17.000000', 'temperatura', 459.0000, 'ºC'),
	(7399, 108, '2015-01-15 00:38:18.000000', 'temperatura', 180.0000, 'ºC'),
	(7400, 108, '2015-01-15 00:38:19.000000', 'temperatura', 726.0000, 'ºC'),
	(7401, 108, '2015-01-15 00:38:20.000000', 'temperatura', 689.0000, 'ºC'),
	(7402, 108, '2015-01-15 00:38:21.000000', 'temperatura', 69.0000, 'ºC'),
	(7403, 108, '2015-01-15 00:38:22.000000', 'temperatura', 677.0000, 'ºC'),
	(7404, 108, '2015-01-15 00:38:23.000000', 'temperatura', 781.0000, 'ºC'),
	(7405, 108, '2015-01-15 00:38:24.000000', 'temperatura', 672.0000, 'ºC'),
	(7406, 108, '2015-01-15 00:38:25.000000', 'temperatura', 1018.0000, 'ºC'),
	(7407, 108, '2015-01-15 00:38:26.000000', 'temperatura', 676.0000, 'ºC'),
	(7408, 108, '2015-01-15 00:38:27.000000', 'temperatura', 324.0000, 'ºC'),
	(7409, 108, '2015-01-15 00:38:28.000000', 'temperatura', 793.0000, 'ºC'),
	(7410, 108, '2015-01-15 00:38:29.000000', 'temperatura', 592.0000, 'ºC'),
	(7411, 108, '2015-01-15 00:38:30.000000', 'temperatura', 585.0000, 'ºC'),
	(7412, 108, '2015-01-15 00:38:31.000000', 'temperatura', 1148.0000, 'ºC'),
	(7413, 108, '2015-01-15 00:38:32.000000', 'temperatura', 384.0000, 'ºC'),
	(7414, 108, '2015-01-15 00:38:33.000000', 'temperatura', 877.0000, 'ºC'),
	(7415, 108, '2015-01-15 00:38:34.000000', 'temperatura', 834.0000, 'ºC'),
	(7416, 108, '2015-01-15 00:38:35.000000', 'temperatura', 341.0000, 'ºC'),
	(7417, 108, '2015-01-15 00:38:36.000000', 'temperatura', 403.0000, 'ºC'),
	(7418, 108, '2015-01-15 00:38:37.000000', 'temperatura', 992.0000, 'ºC'),
	(7419, 108, '2015-01-15 00:38:38.000000', 'temperatura', 152.0000, 'ºC'),
	(7420, 108, '2015-01-15 00:38:39.000000', 'temperatura', 184.0000, 'ºC'),
	(7421, 108, '2015-01-15 00:38:40.000000', 'temperatura', 465.0000, 'ºC'),
	(7422, 108, '2015-01-15 00:38:41.000000', 'temperatura', 573.0000, 'ºC'),
	(7423, 108, '2015-01-15 00:38:42.000000', 'temperatura', 271.0000, 'ºC'),
	(7424, 108, '2015-01-15 00:38:43.000000', 'temperatura', 837.0000, 'ºC'),
	(7425, 108, '2015-01-15 00:38:44.000000', 'temperatura', 972.0000, 'ºC'),
	(7426, 108, '2015-01-15 00:38:45.000000', 'temperatura', 1148.0000, 'ºC'),
	(7427, 108, '2015-01-15 00:38:46.000000', 'temperatura', 427.0000, 'ºC'),
	(7428, 108, '2015-01-15 00:38:47.000000', 'temperatura', 1092.0000, 'ºC'),
	(7429, 108, '2015-01-15 00:38:48.000000', 'temperatura', 578.0000, 'ºC'),
	(7430, 108, '2015-01-15 00:38:49.000000', 'temperatura', 813.0000, 'ºC'),
	(7431, 108, '2015-01-15 00:38:50.000000', 'temperatura', 1134.0000, 'ºC'),
	(7432, 108, '2015-01-15 00:38:51.000000', 'temperatura', 830.0000, 'ºC'),
	(7433, 108, '2015-01-15 00:38:52.000000', 'temperatura', 748.0000, 'ºC'),
	(7434, 108, '2015-01-15 00:38:53.000000', 'temperatura', 49.0000, 'ºC'),
	(7435, 108, '2015-01-15 00:38:54.000000', 'temperatura', 404.0000, 'ºC'),
	(7436, 108, '2015-01-15 00:38:55.000000', 'temperatura', 674.0000, 'ºC'),
	(7437, 108, '2015-01-15 00:38:56.000000', 'temperatura', 959.0000, 'ºC'),
	(7438, 108, '2015-01-15 00:38:57.000000', 'temperatura', 375.0000, 'ºC'),
	(7439, 108, '2015-01-15 00:38:58.000000', 'temperatura', 195.0000, 'ºC'),
	(7440, 108, '2015-01-15 00:38:59.000000', 'temperatura', 1053.0000, 'ºC'),
	(7441, 108, '2015-01-15 00:39:00.000000', 'temperatura', 1080.0000, 'ºC'),
	(7442, 108, '2015-01-15 00:39:01.000000', 'temperatura', 1043.0000, 'ºC'),
	(7443, 108, '2015-01-15 00:39:02.000000', 'temperatura', 773.0000, 'ºC'),
	(7444, 108, '2015-01-15 00:39:03.000000', 'temperatura', 737.0000, 'ºC'),
	(7445, 108, '2015-01-15 00:39:04.000000', 'temperatura', 166.0000, 'ºC'),
	(7446, 108, '2015-01-15 00:39:05.000000', 'temperatura', 1021.0000, 'ºC'),
	(7447, 108, '2015-01-15 00:39:06.000000', 'temperatura', 1005.0000, 'ºC'),
	(7448, 108, '2015-01-15 00:39:07.000000', 'temperatura', 764.0000, 'ºC'),
	(7449, 108, '2015-01-15 00:39:08.000000', 'temperatura', 805.0000, 'ºC'),
	(7450, 108, '2015-01-15 00:39:09.000000', 'temperatura', 533.0000, 'ºC'),
	(7451, 108, '2015-01-15 00:39:10.000000', 'temperatura', 249.0000, 'ºC'),
	(7452, 108, '2015-01-15 00:39:11.000000', 'temperatura', 848.0000, 'ºC'),
	(7453, 108, '2015-01-15 00:39:12.000000', 'temperatura', 1092.0000, 'ºC'),
	(7454, 108, '2015-01-15 00:39:13.000000', 'temperatura', 519.0000, 'ºC'),
	(7455, 108, '2015-01-15 00:39:14.000000', 'temperatura', 520.0000, 'ºC'),
	(7456, 108, '2015-01-15 00:39:15.000000', 'temperatura', 1041.0000, 'ºC'),
	(7457, 108, '2015-01-15 00:39:16.000000', 'temperatura', 45.0000, 'ºC'),
	(7458, 108, '2015-01-15 00:39:17.000000', 'temperatura', 703.0000, 'ºC'),
	(7459, 108, '2015-01-15 00:39:18.000000', 'temperatura', 980.0000, 'ºC'),
	(7460, 108, '2015-01-15 00:39:19.000000', 'temperatura', 393.0000, 'ºC'),
	(7461, 108, '2015-01-15 00:39:20.000000', 'temperatura', 223.0000, 'ºC'),
	(7462, 108, '2015-01-15 00:39:21.000000', 'temperatura', 1137.0000, 'ºC'),
	(7463, 108, '2015-01-15 00:39:22.000000', 'temperatura', 216.0000, 'ºC'),
	(7464, 108, '2015-01-15 00:39:23.000000', 'temperatura', 72.0000, 'ºC'),
	(7465, 108, '2015-01-15 00:39:24.000000', 'temperatura', 911.0000, 'ºC'),
	(7466, 108, '2015-01-15 00:39:25.000000', 'temperatura', 741.0000, 'ºC'),
	(7467, 108, '2015-01-15 00:39:26.000000', 'temperatura', 973.0000, 'ºC'),
	(7468, 108, '2015-01-15 00:39:27.000000', 'temperatura', 243.0000, 'ºC'),
	(7469, 108, '2015-01-15 00:39:28.000000', 'temperatura', 694.0000, 'ºC'),
	(7470, 108, '2015-01-15 00:39:29.000000', 'temperatura', 343.0000, 'ºC'),
	(7471, 108, '2015-01-15 00:39:30.000000', 'temperatura', 832.0000, 'ºC'),
	(7472, 108, '2015-01-15 00:39:31.000000', 'temperatura', 731.0000, 'ºC'),
	(7473, 108, '2015-01-15 00:39:32.000000', 'temperatura', 1160.0000, 'ºC'),
	(7474, 108, '2015-01-15 00:39:33.000000', 'temperatura', 8.0000, 'ºC'),
	(7475, 108, '2015-01-15 00:39:34.000000', 'temperatura', 161.0000, 'ºC'),
	(7476, 108, '2015-01-15 00:39:35.000000', 'temperatura', 783.0000, 'ºC'),
	(7477, 108, '2015-01-15 00:39:36.000000', 'temperatura', 1030.0000, 'ºC'),
	(7478, 108, '2015-01-15 00:39:37.000000', 'temperatura', 402.0000, 'ºC'),
	(7479, 108, '2015-01-15 00:39:38.000000', 'temperatura', 121.0000, 'ºC'),
	(7480, 108, '2015-01-15 00:39:39.000000', 'temperatura', 600.0000, 'ºC'),
	(7481, 108, '2015-01-15 00:39:40.000000', 'temperatura', 238.0000, 'ºC'),
	(7482, 108, '2015-01-15 00:39:41.000000', 'temperatura', 589.0000, 'ºC'),
	(7483, 108, '2015-01-15 00:39:42.000000', 'temperatura', 1031.0000, 'ºC'),
	(7484, 108, '2015-01-15 00:39:43.000000', 'temperatura', 991.0000, 'ºC'),
	(7485, 108, '2015-01-15 00:39:44.000000', 'temperatura', 662.0000, 'ºC'),
	(7486, 108, '2015-01-15 00:39:45.000000', 'temperatura', 338.0000, 'ºC'),
	(7487, 108, '2015-01-15 00:39:46.000000', 'temperatura', 905.0000, 'ºC'),
	(7488, 108, '2015-01-15 00:39:47.000000', 'temperatura', 1112.0000, 'ºC'),
	(7489, 108, '2015-01-15 00:39:48.000000', 'temperatura', 443.0000, 'ºC'),
	(7490, 108, '2015-01-15 00:39:49.000000', 'temperatura', 81.0000, 'ºC'),
	(7491, 108, '2015-01-15 00:39:50.000000', 'temperatura', 277.0000, 'ºC'),
	(7492, 108, '2015-01-15 00:39:51.000000', 'temperatura', 1141.0000, 'ºC'),
	(7493, 108, '2015-01-15 00:39:52.000000', 'temperatura', 77.0000, 'ºC'),
	(7494, 108, '2015-01-15 00:39:53.000000', 'temperatura', 559.0000, 'ºC'),
	(7495, 108, '2015-01-15 00:39:54.000000', 'temperatura', 167.0000, 'ºC'),
	(7496, 108, '2015-01-15 00:39:55.000000', 'temperatura', 358.0000, 'ºC'),
	(7497, 108, '2015-01-15 00:39:56.000000', 'temperatura', 89.0000, 'ºC'),
	(7498, 108, '2015-01-15 00:39:57.000000', 'temperatura', 571.0000, 'ºC'),
	(7499, 108, '2015-01-15 00:39:58.000000', 'temperatura', 188.0000, 'ºC'),
	(7500, 108, '2015-01-15 00:39:59.000000', 'temperatura', 428.0000, 'ºC'),
	(7501, 108, '2015-01-15 00:40:00.000000', 'temperatura', 376.0000, 'ºC'),
	(7502, 108, '2015-01-15 00:40:01.000000', 'temperatura', 599.0000, 'ºC'),
	(7503, 108, '2015-01-15 00:40:02.000000', 'temperatura', 665.0000, 'ºC'),
	(7504, 108, '2015-01-15 00:40:03.000000', 'temperatura', 327.0000, 'ºC'),
	(7505, 108, '2015-01-15 00:40:04.000000', 'temperatura', 844.0000, 'ºC'),
	(7506, 108, '2015-01-15 00:40:05.000000', 'temperatura', 836.0000, 'ºC'),
	(7507, 108, '2015-01-15 00:40:06.000000', 'temperatura', 451.0000, 'ºC'),
	(7508, 108, '2015-01-15 00:40:07.000000', 'temperatura', 948.0000, 'ºC'),
	(7509, 108, '2015-01-15 00:40:08.000000', 'temperatura', 986.0000, 'ºC'),
	(7510, 108, '2015-01-15 00:40:09.000000', 'temperatura', 888.0000, 'ºC'),
	(7511, 108, '2015-01-15 00:40:10.000000', 'temperatura', 282.0000, 'ºC'),
	(7512, 108, '2015-01-15 00:40:11.000000', 'temperatura', 1145.0000, 'ºC'),
	(7513, 108, '2015-01-15 00:40:12.000000', 'temperatura', 79.0000, 'ºC'),
	(7514, 108, '2015-01-15 00:40:13.000000', 'temperatura', 561.0000, 'ºC'),
	(7515, 108, '2015-01-15 00:40:14.000000', 'temperatura', 170.0000, 'ºC'),
	(7516, 108, '2015-01-15 00:40:15.000000', 'temperatura', 369.0000, 'ºC'),
	(7517, 108, '2015-01-15 00:40:16.000000', 'temperatura', 132.0000, 'ºC'),
	(7518, 108, '2015-01-15 00:40:17.000000', 'temperatura', 754.0000, 'ºC'),
	(7519, 108, '2015-01-15 00:40:18.000000', 'temperatura', 977.0000, 'ºC'),
	(7520, 108, '2015-01-15 00:40:19.000000', 'temperatura', 223.0000, 'ºC'),
	(7521, 108, '2015-01-15 00:40:20.000000', 'temperatura', 582.0000, 'ºC'),
	(7522, 108, '2015-01-15 00:40:21.000000', 'temperatura', 1043.0000, 'ºC'),
	(7523, 108, '2015-01-15 00:40:22.000000', 'temperatura', 1070.0000, 'ºC'),
	(7524, 108, '2015-01-15 00:40:23.000000', 'temperatura', 1023.0000, 'ºC'),
	(7525, 108, '2015-01-15 00:40:24.000000', 'temperatura', 705.0000, 'ºC'),
	(7526, 108, '2015-01-15 00:40:25.000000', 'temperatura', 455.0000, 'ºC'),
	(7527, 108, '2015-01-15 00:40:26.000000', 'temperatura', 159.0000, 'ºC'),
	(7528, 108, '2015-01-15 00:40:27.000000', 'temperatura', 634.0000, 'ºC'),
	(7529, 108, '2015-01-15 00:40:28.000000', 'temperatura', 290.0000, 'ºC'),
	(7530, 108, '2015-01-15 00:40:29.000000', 'temperatura', 751.0000, 'ºC'),
	(7531, 108, '2015-01-15 00:40:30.000000', 'temperatura', 483.0000, 'ºC'),
	(7532, 108, '2015-01-15 00:40:31.000000', 'temperatura', 163.0000, 'ºC'),
	(7533, 108, '2015-01-15 00:40:32.000000', 'temperatura', 568.0000, 'ºC'),
	(7534, 108, '2015-01-15 00:40:33.000000', 'temperatura', 1151.0000, 'ºC'),
	(7535, 108, '2015-01-15 00:40:34.000000', 'temperatura', 453.0000, 'ºC'),
	(7536, 108, '2015-01-15 00:40:35.000000', 'temperatura', 12.0000, 'ºC'),
	(7537, 108, '2015-01-15 00:40:36.000000', 'temperatura', 1103.0000, 'ºC'),
	(7538, 108, '2015-01-15 00:40:37.000000', 'temperatura', 676.0000, 'ºC'),
	(7539, 108, '2015-01-15 00:40:38.000000', 'temperatura', 75.0000, 'ºC'),
	(7540, 108, '2015-01-15 00:40:39.000000', 'temperatura', 746.0000, 'ºC'),
	(7541, 108, '2015-01-15 00:40:40.000000', 'temperatura', 1104.0000, 'ºC'),
	(7542, 108, '2015-01-15 00:40:41.000000', 'temperatura', 883.0000, 'ºC'),
	(7543, 108, '2015-01-15 00:40:42.000000', 'temperatura', 1104.0000, 'ºC'),
	(7544, 108, '2015-01-15 00:40:43.000000', 'temperatura', 472.0000, 'ºC'),
	(7545, 108, '2015-01-15 00:40:44.000000', 'temperatura', 248.0000, 'ºC'),
	(7546, 108, '2015-01-15 00:40:45.000000', 'temperatura', 1024.0000, 'ºC'),
	(7547, 108, '2015-01-15 00:40:46.000000', 'temperatura', 778.0000, 'ºC'),
	(7548, 108, '2015-01-15 00:40:47.000000', 'temperatura', 819.0000, 'ºC'),
	(7549, 108, '2015-01-15 00:40:48.000000', 'temperatura', 561.0000, 'ºC'),
	(7550, 108, '2015-01-15 00:40:49.000000', 'temperatura', 347.0000, 'ºC'),
	(7551, 108, '2015-01-15 00:40:50.000000', 'temperatura', 54.0000, 'ºC'),
	(7552, 108, '2015-01-15 00:40:51.000000', 'temperatura', 430.0000, 'ºC'),
	(7553, 108, '2015-01-15 00:40:52.000000', 'temperatura', 786.0000, 'ºC'),
	(7554, 108, '2015-01-15 00:40:53.000000', 'temperatura', 243.0000, 'ºC'),
	(7555, 108, '2015-01-15 00:40:54.000000', 'temperatura', 55.0000, 'ºC'),
	(7556, 108, '2015-01-15 00:40:55.000000', 'temperatura', 749.0000, 'ºC'),
	(7557, 108, '2015-01-15 00:40:56.000000', 'temperatura', 1180.0000, 'ºC'),
	(7558, 108, '2015-01-15 00:40:57.000000', 'temperatura', 51.0000, 'ºC'),
	(7559, 108, '2015-01-15 00:40:58.000000', 'temperatura', 318.0000, 'ºC'),
	(7560, 108, '2015-01-15 00:40:59.000000', 'temperatura', 238.0000, 'ºC'),
	(7561, 108, '2015-01-15 00:41:00.000000', 'temperatura', 237.0000, 'ºC'),
	(7562, 108, '2015-01-15 00:41:01.000000', 'temperatura', 472.0000, 'ºC'),
	(7563, 108, '2015-01-15 00:41:02.000000', 'temperatura', 449.0000, 'ºC'),
	(7564, 108, '2015-01-15 00:41:03.000000', 'temperatura', 831.0000, 'ºC'),
	(7565, 108, '2015-01-15 00:41:04.000000', 'temperatura', 407.0000, 'ºC'),
	(7566, 108, '2015-01-15 00:41:05.000000', 'temperatura', 744.0000, 'ºC'),
	(7567, 108, '2015-01-15 00:41:06.000000', 'temperatura', 101.0000, 'ºC'),
	(7568, 108, '2015-01-15 00:41:07.000000', 'temperatura', 670.0000, 'ºC'),
	(7569, 108, '2015-01-15 00:41:08.000000', 'temperatura', 648.0000, 'ºC'),
	(7570, 108, '2015-01-15 00:41:09.000000', 'temperatura', 32.0000, 'ºC'),
	(7571, 108, '2015-01-15 00:41:10.000000', 'temperatura', 614.0000, 'ºC'),
	(7572, 108, '2015-01-15 00:41:11.000000', 'temperatura', 576.0000, 'ºC'),
	(7573, 108, '2015-01-15 00:41:12.000000', 'temperatura', 1040.0000, 'ºC'),
	(7574, 108, '2015-01-15 00:41:13.000000', 'temperatura', 1072.0000, 'ºC'),
	(7575, 108, '2015-01-15 00:41:14.000000', 'temperatura', 1038.0000, 'ºC'),
	(7576, 108, '2015-01-15 00:41:15.000000', 'temperatura', 777.0000, 'ºC'),
	(7577, 108, '2015-01-15 00:41:16.000000', 'temperatura', 769.0000, 'ºC'),
	(7578, 108, '2015-01-15 00:41:17.000000', 'temperatura', 316.0000, 'ºC'),
	(7579, 108, '2015-01-15 00:41:18.000000', 'temperatura', 474.0000, 'ºC'),
	(7580, 108, '2015-01-15 00:41:19.000000', 'temperatura', 223.0000, 'ºC'),
	(7581, 108, '2015-01-15 00:41:20.000000', 'temperatura', 895.0000, 'ºC'),
	(7582, 108, '2015-01-15 00:41:21.000000', 'temperatura', 205.0000, 'ºC'),
	(7583, 108, '2015-01-15 00:41:22.000000', 'temperatura', 739.0000, 'ºC'),
	(7584, 108, '2015-01-15 00:41:23.000000', 'temperatura', 682.0000, 'ºC'),
	(7585, 108, '2015-01-15 00:41:24.000000', 'temperatura', 1195.0000, 'ºC'),
	(7586, 108, '2015-01-15 00:41:25.000000', 'temperatura', 326.0000, 'ºC'),
	(7587, 108, '2015-01-15 00:41:26.000000', 'temperatura', 449.0000, 'ºC'),
	(7588, 108, '2015-01-15 00:41:27.000000', 'temperatura', 66.0000, 'ºC'),
	(7589, 108, '2015-01-15 00:41:28.000000', 'temperatura', 183.0000, 'ºC'),
	(7590, 108, '2015-01-15 00:41:29.000000', 'temperatura', 718.0000, 'ºC'),
	(7591, 108, '2015-01-15 00:41:30.000000', 'temperatura', 640.0000, 'ºC'),
	(7592, 108, '2015-01-15 00:41:31.000000', 'temperatura', 1048.0000, 'ºC'),
	(7593, 108, '2015-01-15 00:41:32.000000', 'temperatura', 918.0000, 'ºC'),
	(7594, 108, '2015-01-15 00:41:33.000000', 'temperatura', 249.0000, 'ºC'),
	(7595, 108, '2015-01-15 00:41:34.000000', 'temperatura', 891.0000, 'ºC'),
	(7596, 108, '2015-01-15 00:41:35.000000', 'temperatura', 109.0000, 'ºC'),
	(7597, 108, '2015-01-15 00:41:36.000000', 'temperatura', 272.0000, 'ºC'),
	(7598, 108, '2015-01-15 00:41:37.000000', 'temperatura', 1033.0000, 'ºC'),
	(7599, 108, '2015-01-15 00:41:38.000000', 'temperatura', 748.0000, 'ºC'),
	(7600, 108, '2015-01-15 00:41:39.000000', 'temperatura', 642.0000, 'ºC'),
	(7601, 108, '2015-01-15 00:41:40.000000', 'temperatura', 969.0000, 'ºC'),
	(7602, 108, '2015-01-15 00:41:41.000000', 'temperatura', 518.0000, 'ºC'),
	(7603, 108, '2015-01-15 00:41:42.000000', 'temperatura', 883.0000, 'ºC'),
	(7604, 108, '2015-01-15 00:41:43.000000', 'temperatura', 460.0000, 'ºC'),
	(7605, 108, '2015-01-15 00:41:44.000000', 'temperatura', 852.0000, 'ºC'),
	(7606, 108, '2015-01-15 00:41:45.000000', 'temperatura', 482.0000, 'ºC'),
	(7607, 108, '2015-01-15 00:41:46.000000', 'temperatura', 1054.0000, 'ºC'),
	(7608, 108, '2015-01-15 00:41:47.000000', 'temperatura', 226.0000, 'ºC'),
	(7609, 108, '2015-01-15 00:41:48.000000', 'temperatura', 367.0000, 'ºC'),
	(7610, 108, '2015-01-15 00:41:49.000000', 'temperatura', 1156.0000, 'ºC'),
	(7611, 108, '2015-01-15 00:41:50.000000', 'temperatura', 1081.0000, 'ºC'),
	(7612, 108, '2015-01-15 00:41:51.000000', 'temperatura', 735.0000, 'ºC'),
	(7613, 108, '2015-01-15 00:41:52.000000', 'temperatura', 436.0000, 'ºC'),
	(7614, 108, '2015-01-15 00:41:53.000000', 'temperatura', 1172.0000, 'ºC'),
	(7615, 108, '2015-01-15 00:41:54.000000', 'temperatura', 955.0000, 'ºC'),
	(7616, 108, '2015-01-15 00:41:55.000000', 'temperatura', 58.0000, 'ºC'),
	(7617, 108, '2015-01-15 00:41:56.000000', 'temperatura', 1026.0000, 'ºC'),
	(7618, 108, '2015-01-15 00:41:57.000000', 'temperatura', 154.0000, 'ºC'),
	(7619, 108, '2015-01-15 00:41:58.000000', 'temperatura', 96.0000, 'ºC'),
	(7620, 108, '2015-01-15 00:41:59.000000', 'temperatura', 19.0000, 'ºC'),
	(7621, 108, '2015-01-15 00:42:00.000000', 'temperatura', 1005.0000, 'ºC'),
	(7622, 108, '2015-01-15 00:42:01.000000', 'temperatura', 171.0000, 'ºC'),
	(7623, 108, '2015-01-15 00:42:02.000000', 'temperatura', 241.0000, 'ºC'),
	(7624, 108, '2015-01-15 00:42:03.000000', 'temperatura', 693.0000, 'ºC'),
	(7625, 108, '2015-01-15 00:42:04.000000', 'temperatura', 342.0000, 'ºC'),
	(7626, 108, '2015-01-15 00:42:05.000000', 'temperatura', 831.0000, 'ºC'),
	(7627, 108, '2015-01-15 00:42:06.000000', 'temperatura', 728.0000, 'ºC'),
	(7628, 108, '2015-01-15 00:42:07.000000', 'temperatura', 1147.0000, 'ºC'),
	(7629, 108, '2015-01-15 00:42:08.000000', 'temperatura', 1151.0000, 'ºC'),
	(7630, 108, '2015-01-15 00:42:09.000000', 'temperatura', 1118.0000, 'ºC'),
	(7631, 108, '2015-01-15 00:42:10.000000', 'temperatura', 934.0000, 'ºC'),
	(7632, 108, '2015-01-15 00:42:11.000000', 'temperatura', 119.0000, 'ºC'),
	(7633, 108, '2015-01-15 00:42:12.000000', 'temperatura', 193.0000, 'ºC'),
	(7634, 108, '2015-01-15 00:42:13.000000', 'temperatura', 609.0000, 'ºC'),
	(7635, 108, '2015-01-15 00:42:14.000000', 'temperatura', 67.0000, 'ºC'),
	(7636, 108, '2015-01-15 00:42:15.000000', 'temperatura', 908.0000, 'ºC'),
	(7637, 108, '2015-01-15 00:42:16.000000', 'temperatura', 741.0000, 'ºC'),
	(7638, 108, '2015-01-15 00:42:17.000000', 'temperatura', 979.0000, 'ºC'),
	(7639, 108, '2015-01-15 00:42:18.000000', 'temperatura', 274.0000, 'ºC'),
	(7640, 108, '2015-01-15 00:42:19.000000', 'temperatura', 834.0000, 'ºC'),
	(7641, 108, '2015-01-15 00:42:20.000000', 'temperatura', 946.0000, 'ºC'),
	(7642, 108, '2015-01-15 00:42:21.000000', 'temperatura', 1031.0000, 'ºC'),
	(7643, 108, '2015-01-15 00:42:22.000000', 'temperatura', 1118.0000, 'ºC'),
	(7644, 108, '2015-01-15 00:42:23.000000', 'temperatura', 96.0000, 'ºC'),
	(7645, 108, '2015-01-15 00:42:24.000000', 'temperatura', 728.0000, 'ºC'),
	(7646, 108, '2015-01-15 00:42:25.000000', 'temperatura', 953.0000, 'ºC'),
	(7647, 108, '2015-01-15 00:42:26.000000', 'temperatura', 181.0000, 'ºC'),
	(7648, 108, '2015-01-15 00:42:27.000000', 'temperatura', 448.0000, 'ºC'),
	(7649, 108, '2015-01-15 00:42:28.000000', 'temperatura', 497.0000, 'ºC'),
	(7650, 108, '2015-01-15 00:42:29.000000', 'temperatura', 1141.0000, 'ºC'),
	(7651, 108, '2015-01-15 00:42:30.000000', 'temperatura', 615.0000, 'ºC'),
	(7652, 108, '2015-01-15 00:42:31.000000', 'temperatura', 853.0000, 'ºC'),
	(7653, 108, '2015-01-15 00:42:32.000000', 'temperatura', 19.0000, 'ºC'),
	(7654, 108, '2015-01-15 00:42:33.000000', 'temperatura', 1137.0000, 'ºC'),
	(7655, 108, '2015-01-15 00:42:34.000000', 'temperatura', 828.0000, 'ºC'),
	(7656, 108, '2015-01-15 00:42:35.000000', 'temperatura', 731.0000, 'ºC'),
	(7657, 108, '2015-01-15 00:42:36.000000', 'temperatura', 1169.0000, 'ºC'),
	(7658, 108, '2015-01-15 00:42:37.000000', 'temperatura', 53.0000, 'ºC'),
	(7659, 108, '2015-01-15 00:42:38.000000', 'temperatura', 358.0000, 'ºC'),
	(7660, 108, '2015-01-15 00:42:39.000000', 'temperatura', 431.0000, 'ºC'),
	(7661, 108, '2015-01-15 00:42:40.000000', 'temperatura', 1082.0000, 'ºC'),
	(7662, 108, '2015-01-15 00:42:41.000000', 'temperatura', 519.0000, 'ºC'),
	(7663, 108, '2015-01-15 00:42:42.000000', 'temperatura', 550.0000, 'ºC'),
	(7664, 108, '2015-01-15 00:42:43.000000', 'temperatura', 1193.0000, 'ºC'),
	(7665, 108, '2015-01-15 00:42:44.000000', 'temperatura', 717.0000, 'ºC'),
	(7666, 108, '2015-01-15 00:42:45.000000', 'temperatura', 4.0000, 'ºC'),
	(7667, 108, '2015-01-15 00:42:46.000000', 'temperatura', 272.0000, 'ºC'),
	(7668, 108, '2015-01-15 00:42:47.000000', 'temperatura', 145.0000, 'ºC'),
	(7669, 108, '2015-01-15 00:42:48.000000', 'temperatura', 1112.0000, 'ºC'),
	(7670, 108, '2015-01-15 00:42:49.000000', 'temperatura', 327.0000, 'ºC'),
	(7671, 108, '2015-01-15 00:42:50.000000', 'temperatura', 698.0000, 'ºC'),
	(7672, 108, '2015-01-15 00:42:51.000000', 'temperatura', 108.0000, 'ºC'),
	(7673, 108, '2015-01-15 00:42:52.000000', 'temperatura', 848.0000, 'ºC'),
	(7674, 108, '2015-01-15 00:42:53.000000', 'temperatura', 316.0000, 'ºC'),
	(7675, 108, '2015-01-15 00:42:54.000000', 'temperatura', 239.0000, 'ºC'),
	(7676, 108, '2015-01-15 00:42:55.000000', 'temperatura', 245.0000, 'ºC'),
	(7677, 108, '2015-01-15 00:42:56.000000', 'temperatura', 507.0000, 'ºC'),
	(7678, 108, '2015-01-15 00:42:57.000000', 'temperatura', 602.0000, 'ºC'),
	(7679, 108, '2015-01-15 00:42:58.000000', 'temperatura', 290.0000, 'ºC'),
	(7680, 108, '2015-01-15 00:42:59.000000', 'temperatura', 844.0000, 'ºC'),
	(7681, 108, '2015-01-15 00:43:00.000000', 'temperatura', 952.0000, 'ºC'),
	(7682, 108, '2015-01-15 00:43:01.000000', 'temperatura', 1028.0000, 'ºC'),
	(7683, 108, '2015-01-15 00:43:02.000000', 'temperatura', 1083.0000, 'ºC'),
	(7684, 108, '2015-01-15 00:43:03.000000', 'temperatura', 1132.0000, 'ºC'),
	(7685, 108, '2015-01-15 00:43:04.000000', 'temperatura', 14.0000, 'ºC'),
	(7686, 108, '2015-01-15 00:43:05.000000', 'temperatura', 272.0000, 'ºC'),
	(7687, 108, '2015-01-15 00:43:06.000000', 'temperatura', 120.0000, 'ºC'),
	(7688, 108, '2015-01-15 00:43:07.000000', 'temperatura', 982.0000, 'ºC'),
	(7689, 108, '2015-01-15 00:43:08.000000', 'temperatura', 951.0000, 'ºC'),
	(7690, 108, '2015-01-15 00:43:09.000000', 'temperatura', 609.0000, 'ºC'),
	(7691, 108, '2015-01-15 00:43:10.000000', 'temperatura', 193.0000, 'ºC'),
	(7692, 108, '2015-01-15 00:43:11.000000', 'temperatura', 338.0000, 'ºC'),
	(7693, 108, '2015-01-15 00:43:12.000000', 'temperatura', 1114.0000, 'ºC'),
	(7694, 108, '2015-01-15 00:43:13.000000', 'temperatura', 955.0000, 'ºC'),
	(7695, 108, '2015-01-15 00:43:14.000000', 'temperatura', 234.0000, 'ºC'),
	(7696, 108, '2015-01-15 00:43:15.000000', 'temperatura', 706.0000, 'ºC'),
	(7697, 108, '2015-01-15 00:43:16.000000', 'temperatura', 429.0000, 'ºC'),
	(7698, 108, '2015-01-15 00:43:17.000000', 'temperatura', 25.0000, 'ºC'),
	(7699, 108, '2015-01-15 00:43:18.000000', 'temperatura', 38.0000, 'ºC'),
	(7700, 108, '2015-01-15 00:43:19.000000', 'temperatura', 118.0000, 'ºC'),
	(7701, 108, '2015-01-15 00:43:20.000000', 'temperatura', 476.0000, 'ºC'),
	(7702, 108, '2015-01-15 00:43:21.000000', 'temperatura', 828.0000, 'ºC'),
	(7703, 108, '2015-01-15 00:43:22.000000', 'temperatura', 311.0000, 'ºC'),
	(7704, 108, '2015-01-15 00:43:23.000000', 'temperatura', 270.0000, 'ºC'),
	(7705, 108, '2015-01-15 00:43:24.000000', 'temperatura', 419.0000, 'ºC'),
	(7706, 108, '2015-01-15 00:43:25.000000', 'temperatura', 84.0000, 'ºC'),
	(7707, 108, '2015-01-15 00:43:26.000000', 'temperatura', 366.0000, 'ºC'),
	(7708, 108, '2015-01-15 00:43:27.000000', 'temperatura', 376.0000, 'ºC'),
	(7709, 108, '2015-01-15 00:43:28.000000', 'temperatura', 782.0000, 'ºC'),
	(7710, 108, '2015-01-15 00:43:29.000000', 'temperatura', 386.0000, 'ºC'),
	(7711, 108, '2015-01-15 00:43:30.000000', 'temperatura', 781.0000, 'ºC'),
	(7712, 108, '2015-01-15 00:43:31.000000', 'temperatura', 349.0000, 'ºC'),
	(7713, 108, '2015-01-15 00:43:32.000000', 'temperatura', 601.0000, 'ºC'),
	(7714, 108, '2015-01-15 00:43:33.000000', 'temperatura', 757.0000, 'ºC'),
	(7715, 108, '2015-01-15 00:43:34.000000', 'temperatura', 786.0000, 'ºC'),
	(7716, 108, '2015-01-15 00:43:35.000000', 'temperatura', 457.0000, 'ºC'),
	(7717, 108, '2015-01-15 00:43:36.000000', 'temperatura', 1129.0000, 'ºC'),
	(7718, 108, '2015-01-15 00:43:37.000000', 'temperatura', 676.0000, 'ºC'),
	(7719, 108, '2015-01-15 00:43:38.000000', 'temperatura', 1192.0000, 'ºC'),
	(7720, 108, '2015-01-15 00:43:39.000000', 'temperatura', 332.0000, 'ºC'),
	(7721, 108, '2015-01-15 00:43:40.000000', 'temperatura', 487.0000, 'ºC'),
	(7722, 108, '2015-01-15 00:43:41.000000', 'temperatura', 238.0000, 'ºC'),
	(7723, 108, '2015-01-15 00:43:42.000000', 'temperatura', 930.0000, 'ºC'),
	(7724, 108, '2015-01-15 00:43:43.000000', 'temperatura', 335.0000, 'ºC'),
	(7725, 108, '2015-01-15 00:43:44.000000', 'temperatura', 87.0000, 'ºC'),
	(7726, 108, '2015-01-15 00:43:45.000000', 'temperatura', 628.0000, 'ºC'),
	(7727, 108, '2015-01-15 00:43:46.000000', 'temperatura', 482.0000, 'ºC'),
	(7728, 108, '2015-01-15 00:43:47.000000', 'temperatura', 524.0000, 'ºC'),
	(7729, 108, '2015-01-15 00:43:48.000000', 'temperatura', 1176.0000, 'ºC'),
	(7730, 108, '2015-01-15 00:43:49.000000', 'temperatura', 710.0000, 'ºC'),
	(7731, 108, '2015-01-15 00:43:50.000000', 'temperatura', 20.0000, 'ºC'),
	(7732, 108, '2015-01-15 00:43:51.000000', 'temperatura', 370.0000, 'ºC'),
	(7733, 108, '2015-01-15 00:43:52.000000', 'temperatura', 591.0000, 'ºC'),
	(7734, 108, '2015-01-15 00:43:53.000000', 'temperatura', 644.0000, 'ºC'),
	(7735, 108, '2015-01-15 00:43:54.000000', 'temperatura', 248.0000, 'ºC'),
	(7736, 108, '2015-01-15 00:43:55.000000', 'temperatura', 511.0000, 'ºC'),
	(7737, 108, '2015-01-15 00:43:56.000000', 'temperatura', 610.0000, 'ºC'),
	(7738, 108, '2015-01-15 00:43:57.000000', 'temperatura', 318.0000, 'ºC'),
	(7739, 108, '2015-01-15 00:43:58.000000', 'temperatura', 962.0000, 'ºC'),
	(7740, 108, '2015-01-15 00:43:59.000000', 'temperatura', 254.0000, 'ºC'),
	(7741, 108, '2015-01-15 00:44:00.000000', 'temperatura', 787.0000, 'ºC'),
	(7742, 108, '2015-01-15 00:44:01.000000', 'temperatura', 774.0000, 'ºC'),
	(7743, 108, '2015-01-15 00:44:02.000000', 'temperatura', 309.0000, 'ºC'),
	(7744, 108, '2015-01-15 00:44:03.000000', 'temperatura', 422.0000, 'ºC'),
	(7745, 108, '2015-01-15 00:44:04.000000', 'temperatura', 1185.0000, 'ºC'),
	(7746, 108, '2015-01-15 00:44:05.000000', 'temperatura', 1059.0000, 'ºC'),
	(7747, 108, '2015-01-15 00:44:06.000000', 'temperatura', 541.0000, 'ºC'),
	(7748, 108, '2015-01-15 00:44:07.000000', 'temperatura', 729.0000, 'ºC'),
	(7749, 108, '2015-01-15 00:44:08.000000', 'temperatura', 823.0000, 'ºC'),
	(7750, 108, '2015-01-15 00:44:09.000000', 'temperatura', 726.0000, 'ºC'),
	(7751, 108, '2015-01-15 00:44:10.000000', 'temperatura', 1164.0000, 'ºC'),
	(7752, 108, '2015-01-15 00:44:11.000000', 'temperatura', 42.0000, 'ºC'),
	(7753, 108, '2015-01-15 00:44:12.000000', 'temperatura', 320.0000, 'ºC'),
	(7754, 108, '2015-01-15 00:44:13.000000', 'temperatura', 273.0000, 'ºC'),
	(7755, 108, '2015-01-15 00:44:14.000000', 'temperatura', 405.0000, 'ºC'),
	(7756, 108, '2015-01-15 00:44:15.000000', 'temperatura', 8.0000, 'ºC'),
	(7757, 108, '2015-01-15 00:44:16.000000', 'temperatura', 25.0000, 'ºC'),
	(7758, 108, '2015-01-15 00:44:17.000000', 'temperatura', 101.0000, 'ºC'),
	(7759, 108, '2015-01-15 00:44:18.000000', 'temperatura', 430.0000, 'ºC'),
	(7760, 108, '2015-01-15 00:44:19.000000', 'temperatura', 649.0000, 'ºC'),
	(7761, 108, '2015-01-15 00:44:20.000000', 'temperatura', 757.0000, 'ºC'),
	(7762, 108, '2015-01-15 00:44:21.000000', 'temperatura', 635.0000, 'ºC'),
	(7763, 108, '2015-01-15 00:44:22.000000', 'temperatura', 906.0000, 'ºC'),
	(7764, 108, '2015-01-15 00:44:23.000000', 'temperatura', 227.0000, 'ºC'),
	(7765, 108, '2015-01-15 00:44:24.000000', 'temperatura', 818.0000, 'ºC'),
	(7766, 108, '2015-01-15 00:44:25.000000', 'temperatura', 1008.0000, 'ºC'),
	(7767, 108, '2015-01-15 00:44:26.000000', 'temperatura', 187.0000, 'ºC'),
	(7768, 108, '2015-01-15 00:44:27.000000', 'temperatura', 313.0000, 'ºC'),
	(7769, 108, '2015-01-15 00:44:28.000000', 'temperatura', 1003.0000, 'ºC'),
	(7770, 108, '2015-01-15 00:44:29.000000', 'temperatura', 475.0000, 'ºC'),
	(7771, 108, '2015-01-15 00:44:30.000000', 'temperatura', 568.0000, 'ºC'),
	(7772, 108, '2015-01-15 00:44:31.000000', 'temperatura', 216.0000, 'ºC'),
	(7773, 108, '2015-01-15 00:44:32.000000', 'temperatura', 577.0000, 'ºC'),
	(7774, 108, '2015-01-15 00:44:33.000000', 'temperatura', 1036.0000, 'ºC'),
	(7775, 108, '2015-01-15 00:44:34.000000', 'temperatura', 1051.0000, 'ºC'),
	(7776, 108, '2015-01-15 00:44:35.000000', 'temperatura', 946.0000, 'ºC'),
	(7777, 108, '2015-01-15 00:44:36.000000', 'temperatura', 378.0000, 'ºC'),
	(7778, 108, '2015-01-15 00:44:37.000000', 'temperatura', 254.0000, 'ºC'),
	(7779, 108, '2015-01-15 00:44:38.000000', 'temperatura', 136.0000, 'ºC'),
	(7780, 108, '2015-01-15 00:44:39.000000', 'temperatura', 1119.0000, 'ºC'),
	(7781, 108, '2015-01-15 00:44:40.000000', 'temperatura', 386.0000, 'ºC'),
	(7782, 108, '2015-01-15 00:44:41.000000', 'temperatura', 973.0000, 'ºC'),
	(7783, 108, '2015-01-15 00:44:42.000000', 'temperatura', 110.0000, 'ºC'),
	(7784, 108, '2015-01-15 00:44:43.000000', 'temperatura', 30.0000, 'ºC'),
	(7785, 108, '2015-01-15 00:44:44.000000', 'temperatura', 1019.0000, 'ºC'),
	(7786, 108, '2015-01-15 00:44:45.000000', 'temperatura', 207.0000, 'ºC'),
	(7787, 108, '2015-01-15 00:44:46.000000', 'temperatura', 377.0000, 'ºC'),
	(7788, 108, '2015-01-15 00:44:47.000000', 'temperatura', 65.0000, 'ºC'),
	(7789, 108, '2015-01-15 00:44:48.000000', 'temperatura', 394.0000, 'ºC'),
	(7790, 108, '2015-01-15 00:44:49.000000', 'temperatura', 578.0000, 'ºC'),
	(7791, 108, '2015-01-15 00:44:50.000000', 'temperatura', 507.0000, 'ºC'),
	(7792, 108, '2015-01-15 00:44:51.000000', 'temperatura', 802.0000, 'ºC'),
	(7793, 108, '2015-01-15 00:44:52.000000', 'temperatura', 88.0000, 'ºC'),
	(7794, 108, '2015-01-15 00:44:53.000000', 'temperatura', 436.0000, 'ºC'),
	(7795, 108, '2015-01-15 00:44:54.000000', 'temperatura', 718.0000, 'ºC'),
	(7796, 108, '2015-01-15 00:44:55.000000', 'temperatura', 1080.0000, 'ºC'),
	(7797, 108, '2015-01-15 00:44:56.000000', 'temperatura', 846.0000, 'ºC'),
	(7798, 108, '2015-01-15 00:44:57.000000', 'temperatura', 992.0000, 'ºC'),
	(7799, 108, '2015-01-15 00:44:58.000000', 'temperatura', 20.0000, 'ºC'),
	(7800, 108, '2015-01-15 00:44:59.000000', 'temperatura', 726.0000, 'ºC'),
	(7801, 108, '2015-01-15 00:45:00.000000', 'temperatura', 1170.0000, 'ºC'),
	(7802, 108, '2015-01-15 00:45:01.000000', 'temperatura', 72.0000, 'ºC'),
	(7803, 108, '2015-01-15 00:45:02.000000', 'temperatura', 452.0000, 'ºC'),
	(7804, 108, '2015-01-15 00:45:03.000000', 'temperatura', 844.0000, 'ºC'),
	(7805, 108, '2015-01-15 00:45:04.000000', 'temperatura', 465.0000, 'ºC'),
	(7806, 108, '2015-01-15 00:45:05.000000', 'temperatura', 994.0000, 'ºC'),
	(7807, 108, '2015-01-15 00:45:06.000000', 'temperatura', 1174.0000, 'ºC'),
	(7808, 108, '2015-01-15 00:45:07.000000', 'temperatura', 491.0000, 'ºC'),
	(7809, 108, '2015-01-15 00:45:08.000000', 'temperatura', 132.0000, 'ºC'),
	(7810, 108, '2015-01-15 00:45:09.000000', 'temperatura', 387.0000, 'ºC'),
	(7811, 108, '2015-01-15 00:45:10.000000', 'temperatura', 341.0000, 'ºC'),
	(7812, 108, '2015-01-15 00:45:11.000000', 'temperatura', 542.0000, 'ºC'),
	(7813, 108, '2015-01-15 00:45:12.000000', 'temperatura', 489.0000, 'ºC'),
	(7814, 108, '2015-01-15 00:45:13.000000', 'temperatura', 819.0000, 'ºC'),
	(7815, 108, '2015-01-15 00:45:14.000000', 'temperatura', 230.0000, 'ºC'),
	(7816, 108, '2015-01-15 00:45:15.000000', 'temperatura', 1093.0000, 'ºC'),
	(7817, 108, '2015-01-15 00:45:16.000000', 'temperatura', 1177.0000, 'ºC'),
	(7818, 108, '2015-01-15 00:45:17.000000', 'temperatura', 204.0000, 'ºC'),
	(7819, 108, '2015-01-15 00:45:18.000000', 'temperatura', 1091.0000, 'ºC'),
	(7820, 108, '2015-01-15 00:45:19.000000', 'temperatura', 42.0000, 'ºC'),
	(7821, 108, '2015-01-15 00:45:20.000000', 'temperatura', 538.0000, 'ºC'),
	(7822, 108, '2015-01-15 00:45:21.000000', 'temperatura', 165.0000, 'ºC'),
	(7823, 108, '2015-01-15 00:45:22.000000', 'temperatura', 412.0000, 'ºC'),
	(7824, 108, '2015-01-15 00:45:23.000000', 'temperatura', 364.0000, 'ºC'),
	(7825, 108, '2015-01-15 00:45:24.000000', 'temperatura', 586.0000, 'ºC'),
	(7826, 108, '2015-01-15 00:45:25.000000', 'temperatura', 639.0000, 'ºC'),
	(7827, 108, '2015-01-15 00:45:26.000000', 'temperatura', 236.0000, 'ºC'),
	(7828, 108, '2015-01-15 00:45:27.000000', 'temperatura', 464.0000, 'ºC'),
	(7829, 108, '2015-01-15 00:45:28.000000', 'temperatura', 414.0000, 'ºC'),
	(7830, 108, '2015-01-15 00:45:29.000000', 'temperatura', 676.0000, 'ºC'),
	(7831, 108, '2015-01-15 00:45:30.000000', 'temperatura', 941.0000, 'ºC'),
	(7832, 108, '2015-01-15 00:45:31.000000', 'temperatura', 278.0000, 'ºC'),
	(7833, 108, '2015-01-15 00:45:32.000000', 'temperatura', 967.0000, 'ºC'),
	(7834, 108, '2015-01-15 00:45:33.000000', 'temperatura', 400.0000, 'ºC'),
	(7835, 108, '2015-01-15 00:45:34.000000', 'temperatura', 299.0000, 'ºC'),
	(7836, 108, '2015-01-15 00:45:35.000000', 'temperatura', 298.0000, 'ºC'),
	(7837, 108, '2015-01-15 00:45:36.000000', 'temperatura', 594.0000, 'ºC'),
	(7838, 108, '2015-01-15 00:45:37.000000', 'temperatura', 874.0000, 'ºC'),
	(7839, 108, '2015-01-15 00:45:38.000000', 'temperatura', 187.0000, 'ºC'),
	(7840, 108, '2015-01-15 00:45:39.000000', 'temperatura', 717.0000, 'ºC'),
	(7841, 108, '2015-01-15 00:45:40.000000', 'temperatura', 623.0000, 'ºC'),
	(7842, 108, '2015-01-15 00:45:41.000000', 'temperatura', 965.0000, 'ºC'),
	(7843, 108, '2015-01-15 00:45:42.000000', 'temperatura', 558.0000, 'ºC'),
	(7844, 108, '2015-01-15 00:45:43.000000', 'temperatura', 1095.0000, 'ºC'),
	(7845, 108, '2015-01-15 00:45:44.000000', 'temperatura', 200.0000, 'ºC'),
	(7846, 108, '2015-01-15 00:45:45.000000', 'temperatura', 117.0000, 'ºC'),
	(7847, 108, '2015-01-15 00:45:46.000000', 'temperatura', 1187.0000, 'ºC'),
	(7848, 108, '2015-01-15 00:45:47.000000', 'temperatura', 782.0000, 'ºC'),
	(7849, 108, '2015-01-15 00:45:48.000000', 'temperatura', 351.0000, 'ºC'),
	(7850, 108, '2015-01-15 00:45:49.000000', 'temperatura', 610.0000, 'ºC'),
	(7851, 108, '2015-01-15 00:45:50.000000', 'temperatura', 796.0000, 'ºC'),
	(7852, 108, '2015-01-15 00:45:51.000000', 'temperatura', 951.0000, 'ºC'),
	(7853, 108, '2015-01-15 00:45:52.000000', 'temperatura', 1167.0000, 'ºC'),
	(7854, 108, '2015-01-15 00:45:53.000000', 'temperatura', 584.0000, 'ºC'),
	(7855, 108, '2015-01-15 00:45:54.000000', 'temperatura', 620.0000, 'ºC'),
	(7856, 108, '2015-01-15 00:45:55.000000', 'temperatura', 148.0000, 'ºC'),
	(7857, 108, '2015-01-15 00:45:56.000000', 'temperatura', 81.0000, 'ºC'),
	(7858, 108, '2015-01-15 00:45:57.000000', 'temperatura', 1161.0000, 'ºC'),
	(7859, 108, '2015-01-15 00:45:58.000000', 'temperatura', 761.0000, 'ºC'),
	(7860, 108, '2015-01-15 00:45:59.000000', 'temperatura', 324.0000, 'ºC'),
	(7861, 108, '2015-01-15 00:46:00.000000', 'temperatura', 536.0000, 'ºC'),
	(7862, 108, '2015-01-15 00:46:01.000000', 'temperatura', 507.0000, 'ºC'),
	(7863, 108, '2015-01-15 00:46:02.000000', 'temperatura', 931.0000, 'ºC'),
	(7864, 108, '2015-01-15 00:46:03.000000', 'temperatura', 734.0000, 'ºC'),
	(7865, 108, '2015-01-15 00:46:04.000000', 'temperatura', 877.0000, 'ºC'),
	(7866, 108, '2015-01-15 00:46:05.000000', 'temperatura', 982.0000, 'ºC'),
	(7867, 108, '2015-01-15 00:46:06.000000', 'temperatura', 1079.0000, 'ºC'),
	(7868, 108, '2015-01-15 00:46:07.000000', 'temperatura', 53.0000, 'ºC'),
	(7869, 108, '2015-01-15 00:46:08.000000', 'temperatura', 625.0000, 'ºC'),
	(7870, 108, '2015-01-15 00:46:09.000000', 'temperatura', 567.0000, 'ºC'),
	(7871, 108, '2015-01-15 00:46:10.000000', 'temperatura', 962.0000, 'ºC'),
	(7872, 108, '2015-01-15 00:46:11.000000', 'temperatura', 707.0000, 'ºC'),
	(7873, 108, '2015-01-15 00:46:12.000000', 'temperatura', 652.0000, 'ºC'),
	(7874, 108, '2015-01-15 00:46:13.000000', 'temperatura', 1140.0000, 'ºC'),
	(7875, 108, '2015-01-15 00:46:14.000000', 'temperatura', 145.0000, 'ºC'),
	(7876, 108, '2015-01-15 00:46:15.000000', 'temperatura', 904.0000, 'ºC'),
	(7877, 108, '2015-01-15 00:46:16.000000', 'temperatura', 485.0000, 'ºC'),
	(7878, 108, '2015-01-15 00:46:17.000000', 'temperatura', 914.0000, 'ºC'),
	(7879, 108, '2015-01-15 00:46:18.000000', 'temperatura', 715.0000, 'ºC'),
	(7880, 108, '2015-01-15 00:46:19.000000', 'temperatura', 832.0000, 'ºC'),
	(7881, 108, '2015-01-15 00:46:20.000000', 'temperatura', 818.0000, 'ºC'),
	(7882, 108, '2015-01-15 00:46:21.000000', 'temperatura', 392.0000, 'ºC'),
	(7883, 108, '2015-01-15 00:46:22.000000', 'temperatura', 707.0000, 'ºC'),
	(7884, 108, '2015-01-15 00:46:23.000000', 'temperatura', 1159.0000, 'ºC'),
	(7885, 108, '2015-01-15 00:46:24.000000', 'temperatura', 73.0000, 'ºC'),
	(7886, 108, '2015-01-15 00:46:25.000000', 'temperatura', 492.0000, 'ºC'),
	(7887, 108, '2015-01-15 00:46:26.000000', 'temperatura', 1039.0000, 'ºC'),
	(7888, 108, '2015-01-15 00:46:27.000000', 'temperatura', 122.0000, 'ºC'),
	(7889, 108, '2015-01-15 00:46:28.000000', 'temperatura', 1091.0000, 'ºC'),
	(7890, 108, '2015-01-15 00:46:29.000000', 'temperatura', 289.0000, 'ºC'),
	(7891, 108, '2015-01-15 00:46:30.000000', 'temperatura', 575.0000, 'ºC'),
	(7892, 108, '2015-01-15 00:46:31.000000', 'temperatura', 807.0000, 'ºC'),
	(7893, 108, '2015-01-15 00:46:32.000000', 'temperatura', 1109.0000, 'ºC'),
	(7894, 108, '2015-01-15 00:46:33.000000', 'temperatura', 726.0000, 'ºC'),
	(7895, 108, '2015-01-15 00:46:34.000000', 'temperatura', 304.0000, 'ºC'),
	(7896, 108, '2015-01-15 00:46:35.000000', 'temperatura', 540.0000, 'ºC'),
	(7897, 108, '2015-01-15 00:46:36.000000', 'temperatura', 590.0000, 'ºC'),
	(7898, 108, '2015-01-15 00:46:37.000000', 'temperatura', 128.0000, 'ºC'),
	(7899, 108, '2015-01-15 00:46:38.000000', 'temperatura', 74.0000, 'ºC'),
	(7900, 108, '2015-01-15 00:46:39.000000', 'temperatura', 1183.0000, 'ºC'),
	(7901, 108, '2015-01-15 00:46:40.000000', 'temperatura', 897.0000, 'ºC'),
	(7902, 108, '2015-01-15 00:46:41.000000', 'temperatura', 936.0000, 'ºC'),
	(7903, 108, '2015-01-15 00:46:42.000000', 'temperatura', 789.0000, 'ºC'),
	(7904, 108, '2015-01-15 00:46:43.000000', 'temperatura', 1136.0000, 'ºC'),
	(7905, 108, '2015-01-15 00:46:44.000000', 'temperatura', 915.0000, 'ºC'),
	(7906, 108, '2015-01-15 00:46:45.000000', 'temperatura', 1167.0000, 'ºC'),
	(7907, 108, '2015-01-15 00:46:46.000000', 'temperatura', 689.0000, 'ºC'),
	(7908, 108, '2015-01-15 00:46:47.000000', 'temperatura', 1146.0000, 'ºC'),
	(7909, 108, '2015-01-15 00:46:48.000000', 'temperatura', 61.0000, 'ºC'),
	(7910, 108, '2015-01-15 00:46:49.000000', 'temperatura', 470.0000, 'ºC'),
	(7911, 108, '2015-01-15 00:46:50.000000', 'temperatura', 968.0000, 'ºC'),
	(7912, 108, '2015-01-15 00:46:51.000000', 'temperatura', 1031.0000, 'ºC'),
	(7913, 108, '2015-01-15 00:46:52.000000', 'temperatura', 1050.0000, 'ºC'),
	(7914, 108, '2015-01-15 00:46:53.000000', 'temperatura', 958.0000, 'ºC'),
	(7915, 108, '2015-01-15 00:46:54.000000', 'temperatura', 440.0000, 'ºC'),
	(7916, 108, '2015-01-15 00:46:55.000000', 'temperatura', 527.0000, 'ºC'),
	(7917, 108, '2015-01-15 00:46:56.000000', 'temperatura', 114.0000, 'ºC'),
	(7918, 108, '2015-01-15 00:46:57.000000', 'temperatura', 192.0000, 'ºC'),
	(7919, 108, '2015-01-15 00:46:58.000000', 'temperatura', 619.0000, 'ºC'),
	(7920, 108, '2015-01-15 00:46:59.000000', 'temperatura', 120.0000, 'ºC'),
	(7921, 108, '2015-01-15 00:47:00.000000', 'temperatura', 1142.0000, 'ºC'),
	(7922, 108, '2015-01-15 00:47:01.000000', 'temperatura', 552.0000, 'ºC'),
	(7923, 108, '2015-01-15 00:47:02.000000', 'temperatura', 532.0000, 'ºC'),
	(7924, 108, '2015-01-15 00:47:03.000000', 'temperatura', 1006.0000, 'ºC'),
	(7925, 108, '2015-01-15 00:47:04.000000', 'temperatura', 1036.0000, 'ºC'),
	(7926, 108, '2015-01-15 00:47:05.000000', 'temperatura', 961.0000, 'ºC'),
	(7927, 108, '2015-01-15 00:47:06.000000', 'temperatura', 498.0000, 'ºC'),
	(7928, 108, '2015-01-15 00:47:07.000000', 'temperatura', 809.0000, 'ºC'),
	(7929, 108, '2015-01-15 00:47:08.000000', 'temperatura', 152.0000, 'ºC'),
	(7930, 108, '2015-01-15 00:47:09.000000', 'temperatura', 732.0000, 'ºC'),
	(7931, 108, '2015-01-15 00:47:10.000000', 'temperatura', 803.0000, 'ºC'),
	(7932, 108, '2015-01-15 00:47:11.000000', 'temperatura', 619.0000, 'ºC'),
	(7933, 108, '2015-01-15 00:47:12.000000', 'temperatura', 688.0000, 'ºC'),
	(7934, 108, '2015-01-15 00:47:13.000000', 'temperatura', 385.0000, 'ºC'),
	(7935, 108, '2015-01-15 00:47:14.000000', 'temperatura', 1059.0000, 'ºC'),
	(7936, 108, '2015-01-15 00:47:15.000000', 'temperatura', 543.0000, 'ºC'),
	(7937, 108, '2015-01-15 00:47:16.000000', 'temperatura', 736.0000, 'ºC'),
	(7938, 108, '2015-01-15 00:47:17.000000', 'temperatura', 853.0000, 'ºC'),
	(7939, 108, '2015-01-15 00:47:18.000000', 'temperatura', 855.0000, 'ºC'),
	(7940, 108, '2015-01-15 00:47:19.000000', 'temperatura', 519.0000, 'ºC'),
	(7941, 108, '2015-01-15 00:47:20.000000', 'temperatura', 31.0000, 'ºC'),
	(7942, 108, '2015-01-15 00:47:21.000000', 'temperatura', 999.0000, 'ºC'),
	(7943, 108, '2015-01-15 00:47:22.000000', 'temperatura', 101.0000, 'ºC'),
	(7944, 108, '2015-01-15 00:47:23.000000', 'temperatura', 1107.0000, 'ºC'),
	(7945, 108, '2015-01-15 00:47:24.000000', 'temperatura', 435.0000, 'ºC'),
	(7946, 108, '2015-01-15 00:47:25.000000', 'temperatura', 52.0000, 'ºC'),
	(7947, 108, '2015-01-15 00:47:26.000000', 'temperatura', 159.0000, 'ºC'),
	(7948, 108, '2015-01-15 00:47:27.000000', 'temperatura', 636.0000, 'ºC'),
	(7949, 108, '2015-01-15 00:47:28.000000', 'temperatura', 304.0000, 'ºC'),
	(7950, 108, '2015-01-15 00:47:29.000000', 'temperatura', 813.0000, 'ºC'),
	(7951, 108, '2015-01-15 00:47:30.000000', 'temperatura', 752.0000, 'ºC'),
	(7952, 108, '2015-01-15 00:47:31.000000', 'temperatura', 124.0000, 'ºC'),
	(7953, 108, '2015-01-15 00:47:32.000000', 'temperatura', 765.0000, 'ºC'),
	(7954, 108, '2015-01-15 00:47:33.000000', 'temperatura', 1050.0000, 'ºC'),
	(7955, 108, '2015-01-15 00:47:34.000000', 'temperatura', 559.0000, 'ºC'),
	(7956, 108, '2015-01-15 00:47:35.000000', 'temperatura', 846.0000, 'ºC'),
	(7957, 108, '2015-01-15 00:47:36.000000', 'temperatura', 151.0000, 'ºC'),
	(7958, 108, '2015-01-15 00:47:37.000000', 'temperatura', 617.0000, 'ºC'),
	(7959, 108, '2015-01-15 00:47:38.000000', 'temperatura', 234.0000, 'ºC'),
	(7960, 108, '2015-01-15 00:47:39.000000', 'temperatura', 519.0000, 'ºC'),
	(7961, 108, '2015-01-15 00:47:40.000000', 'temperatura', 692.0000, 'ºC'),
	(7962, 108, '2015-01-15 00:47:41.000000', 'temperatura', 706.0000, 'ºC'),
	(7963, 108, '2015-01-15 00:47:42.000000', 'temperatura', 252.0000, 'ºC'),
	(7964, 108, '2015-01-15 00:47:43.000000', 'temperatura', 344.0000, 'ºC'),
	(7965, 108, '2015-01-15 00:47:44.000000', 'temperatura', 965.0000, 'ºC'),
	(7966, 108, '2015-01-15 00:47:45.000000', 'temperatura', 193.0000, 'ºC'),
	(7967, 108, '2015-01-15 00:47:46.000000', 'temperatura', 472.0000, 'ºC'),
	(7968, 108, '2015-01-15 00:47:47.000000', 'temperatura', 582.0000, 'ºC'),
	(7969, 108, '2015-01-15 00:47:48.000000', 'temperatura', 294.0000, 'ºC'),
	(7970, 108, '2015-01-15 00:47:49.000000', 'temperatura', 924.0000, 'ºC'),
	(7971, 108, '2015-01-15 00:47:50.000000', 'temperatura', 138.0000, 'ºC'),
	(7972, 108, '2015-01-15 00:47:51.000000', 'temperatura', 318.0000, 'ºC'),
	(7973, 108, '2015-01-15 00:47:52.000000', 'temperatura', 1179.0000, 'ºC'),
	(7974, 108, '2015-01-15 00:47:53.000000', 'temperatura', 139.0000, 'ºC'),
	(7975, 108, '2015-01-15 00:47:54.000000', 'temperatura', 760.0000, 'ºC'),
	(7976, 108, '2015-01-15 00:47:55.000000', 'temperatura', 981.0000, 'ºC'),
	(7977, 108, '2015-01-15 00:47:56.000000', 'temperatura', 228.0000, 'ºC'),
	(7978, 108, '2015-01-15 00:47:57.000000', 'temperatura', 595.0000, 'ºC'),
	(7979, 108, '2015-01-15 00:47:58.000000', 'temperatura', 1093.0000, 'ºC'),
	(7980, 108, '2015-01-15 00:47:59.000000', 'temperatura', 80.0000, 'ºC'),
	(7981, 108, '2015-01-15 00:48:00.000000', 'temperatura', 722.0000, 'ºC'),
	(7982, 108, '2015-01-15 00:48:01.000000', 'temperatura', 971.0000, 'ºC'),
	(7983, 108, '2015-01-15 00:48:02.000000', 'temperatura', 289.0000, 'ºC'),
	(7984, 108, '2015-01-15 00:48:03.000000', 'temperatura', 931.0000, 'ºC'),
	(7985, 108, '2015-01-15 00:48:04.000000', 'temperatura', 191.0000, 'ºC'),
	(7986, 108, '2015-01-15 00:48:05.000000', 'temperatura', 563.0000, 'ºC'),
	(7987, 108, '2015-01-15 00:48:06.000000', 'temperatura', 1043.0000, 'ºC'),
	(7988, 108, '2015-01-15 00:48:07.000000', 'temperatura', 1126.0000, 'ºC'),
	(7989, 108, '2015-01-15 00:48:08.000000', 'temperatura', 101.0000, 'ºC'),
	(7990, 108, '2015-01-15 00:48:09.000000', 'temperatura', 728.0000, 'ºC'),
	(7991, 108, '2015-01-15 00:48:10.000000', 'temperatura', 938.0000, 'ºC'),
	(7992, 108, '2015-01-15 00:48:11.000000', 'temperatura', 104.0000, 'ºC'),
	(7993, 108, '2015-01-15 00:48:12.000000', 'temperatura', 107.0000, 'ºC'),
	(7994, 108, '2015-01-15 00:48:13.000000', 'temperatura', 225.0000, 'ºC'),
	(7995, 108, '2015-01-15 00:48:14.000000', 'temperatura', 804.0000, 'ºC'),
	(7996, 108, '2015-01-15 00:48:15.000000', 'temperatura', 944.0000, 'ºC'),
	(7997, 108, '2015-01-15 00:48:16.000000', 'temperatura', 1111.0000, 'ºC'),
	(7998, 108, '2015-01-15 00:48:17.000000', 'temperatura', 321.0000, 'ºC'),
	(7999, 108, '2015-01-15 00:48:18.000000', 'temperatura', 673.0000, 'ºC'),
	(8000, 108, '2015-01-15 00:48:19.000000', 'temperatura', 1.0000, 'ºC'),
	(8001, 108, '2015-01-15 00:48:20.000000', 'temperatura', 388.0000, 'ºC'),
	(8002, 108, '2015-01-15 00:48:21.000000', 'temperatura', 736.0000, 'ºC'),
	(8003, 108, '2015-01-15 00:48:22.000000', 'temperatura', 117.0000, 'ºC'),
	(8004, 108, '2015-01-15 00:48:23.000000', 'temperatura', 777.0000, 'ºC'),
	(8005, 108, '2015-01-15 00:48:24.000000', 'temperatura', 1134.0000, 'ºC'),
	(8006, 108, '2015-01-15 00:48:25.000000', 'temperatura', 939.0000, 'ºC'),
	(8007, 108, '2015-01-15 00:48:26.000000', 'temperatura', 96.0000, 'ºC'),
	(8008, 108, '2015-01-15 00:48:27.000000', 'temperatura', 61.0000, 'ºC'),
	(8009, 108, '2015-01-15 00:48:28.000000', 'temperatura', 17.0000, 'ºC'),
	(8010, 108, '2015-01-15 00:48:29.000000', 'temperatura', 1102.0000, 'ºC'),
	(8011, 108, '2015-01-15 00:48:30.000000', 'temperatura', 662.0000, 'ºC'),
	(8012, 108, '2015-01-15 00:48:31.000000', 'temperatura', 5.0000, 'ºC'),
	(8013, 108, '2015-01-15 00:48:32.000000', 'temperatura', 440.0000, 'ºC'),
	(8014, 108, '2015-01-15 00:48:33.000000', 'temperatura', 983.0000, 'ºC'),
	(8015, 108, '2015-01-15 00:48:34.000000', 'temperatura', 1196.0000, 'ºC'),
	(8016, 108, '2015-01-15 00:48:35.000000', 'temperatura', 632.0000, 'ºC'),
	(8017, 108, '2015-01-15 00:48:36.000000', 'temperatura', 774.0000, 'ºC'),
	(8018, 108, '2015-01-15 00:48:37.000000', 'temperatura', 771.0000, 'ºC'),
	(8019, 108, '2015-01-15 00:48:38.000000', 'temperatura', 337.0000, 'ºC'),
	(8020, 108, '2015-01-15 00:48:39.000000', 'temperatura', 571.0000, 'ºC'),
	(8021, 108, '2015-01-15 00:48:40.000000', 'temperatura', 644.0000, 'ºC'),
	(8022, 108, '2015-01-15 00:48:41.000000', 'temperatura', 309.0000, 'ºC'),
	(8023, 108, '2015-01-15 00:48:42.000000', 'temperatura', 811.0000, 'ºC'),
	(8024, 108, '2015-01-15 00:48:43.000000', 'temperatura', 731.0000, 'ºC'),
	(8025, 108, '2015-01-15 00:48:44.000000', 'temperatura', 23.0000, 'ºC'),
	(8026, 108, '2015-01-15 00:48:45.000000', 'temperatura', 321.0000, 'ºC'),
	(8027, 108, '2015-01-15 00:48:46.000000', 'temperatura', 335.0000, 'ºC'),
	(8028, 108, '2015-01-15 00:48:47.000000', 'temperatura', 713.0000, 'ºC'),
	(8029, 108, '2015-01-15 00:48:48.000000', 'temperatura', 160.0000, 'ºC'),
	(8030, 108, '2015-01-15 00:48:49.000000', 'temperatura', 1061.0000, 'ºC'),
	(8031, 108, '2015-01-15 00:48:50.000000', 'temperatura', 25.0000, 'ºC'),
	(8032, 108, '2015-01-15 00:48:51.000000', 'temperatura', 544.0000, 'ºC'),
	(8033, 108, '2015-01-15 00:48:52.000000', 'temperatura', 245.0000, 'ºC'),
	(8034, 108, '2015-01-15 00:48:53.000000', 'temperatura', 795.0000, 'ºC'),
	(8035, 108, '2015-01-15 00:48:54.000000', 'temperatura', 840.0000, 'ºC'),
	(8036, 108, '2015-01-15 00:48:55.000000', 'temperatura', 613.0000, 'ºC'),
	(8037, 108, '2015-01-15 00:48:56.000000', 'temperatura', 548.0000, 'ºC'),
	(8038, 108, '2015-01-15 00:48:57.000000', 'temperatura', 899.0000, 'ºC'),
	(8039, 108, '2015-01-15 00:48:58.000000', 'temperatura', 454.0000, 'ºC'),
	(8040, 108, '2015-01-15 00:48:59.000000', 'temperatura', 773.0000, 'ºC'),
	(8041, 108, '2015-01-15 00:49:00.000000', 'temperatura', 102.0000, 'ºC'),
	(8042, 108, '2015-01-15 00:49:01.000000', 'temperatura', 592.0000, 'ºC'),
	(8043, 108, '2015-01-15 00:49:02.000000', 'temperatura', 255.0000, 'ºC'),
	(8044, 108, '2015-01-15 00:49:03.000000', 'temperatura', 697.0000, 'ºC'),
	(8045, 108, '2015-01-15 00:49:04.000000', 'temperatura', 324.0000, 'ºC'),
	(8046, 108, '2015-01-15 00:49:05.000000', 'temperatura', 728.0000, 'ºC'),
	(8047, 108, '2015-01-15 00:49:06.000000', 'temperatura', 271.0000, 'ºC'),
	(8048, 108, '2015-01-15 00:49:07.000000', 'temperatura', 369.0000, 'ºC'),
	(8049, 108, '2015-01-15 00:49:08.000000', 'temperatura', 1032.0000, 'ºC'),
	(8050, 108, '2015-01-15 00:49:09.000000', 'temperatura', 453.0000, 'ºC'),
	(8051, 108, '2015-01-15 00:49:10.000000', 'temperatura', 371.0000, 'ºC'),
	(8052, 108, '2015-01-15 00:49:11.000000', 'temperatura', 497.0000, 'ºC'),
	(8053, 108, '2015-01-15 00:49:12.000000', 'temperatura', 173.0000, 'ºC'),
	(8054, 108, '2015-01-15 00:49:13.000000', 'temperatura', 574.0000, 'ºC'),
	(8055, 108, '2015-01-15 00:49:14.000000', 'temperatura', 1151.0000, 'ºC'),
	(8056, 108, '2015-01-15 00:49:15.000000', 'temperatura', 433.0000, 'ºC'),
	(8057, 108, '2015-01-15 00:49:16.000000', 'temperatura', 1114.0000, 'ºC'),
	(8058, 108, '2015-01-15 00:49:17.000000', 'temperatura', 671.0000, 'ºC'),
	(8059, 108, '2015-01-15 00:49:18.000000', 'temperatura', 13.0000, 'ºC'),
	(8060, 108, '2015-01-15 00:49:19.000000', 'temperatura', 451.0000, 'ºC'),
	(8061, 108, '2015-01-15 00:49:20.000000', 'temperatura', 1020.0000, 'ºC'),
	(8062, 108, '2015-01-15 00:49:21.000000', 'temperatura', 145.0000, 'ºC'),
	(8063, 108, '2015-01-15 00:49:22.000000', 'temperatura', 66.0000, 'ºC'),
	(8064, 108, '2015-01-15 00:49:23.000000', 'temperatura', 1096.0000, 'ºC'),
	(8065, 108, '2015-01-15 00:49:24.000000', 'temperatura', 484.0000, 'ºC'),
	(8066, 108, '2015-01-15 00:49:25.000000', 'temperatura', 331.0000, 'ºC'),
	(8067, 108, '2015-01-15 00:49:26.000000', 'temperatura', 205.0000, 'ºC'),
	(8068, 108, '2015-01-15 00:49:27.000000', 'temperatura', 31.0000, 'ºC'),
	(8069, 108, '2015-01-15 00:49:28.000000', 'temperatura', 740.0000, 'ºC'),
	(8070, 108, '2015-01-15 00:49:29.000000', 'temperatura', 10.0000, 'ºC'),
	(8071, 108, '2015-01-15 00:49:30.000000', 'temperatura', 227.0000, 'ºC'),
	(8072, 108, '2015-01-15 00:49:31.000000', 'temperatura', 1108.0000, 'ºC'),
	(8073, 108, '2015-01-15 00:49:32.000000', 'temperatura', 59.0000, 'ºC'),
	(8074, 108, '2015-01-15 00:49:33.000000', 'temperatura', 573.0000, 'ºC'),
	(8075, 108, '2015-01-15 00:49:34.000000', 'temperatura', 288.0000, 'ºC'),
	(8076, 108, '2015-01-15 00:49:35.000000', 'temperatura', 921.0000, 'ºC'),
	(8077, 108, '2015-01-15 00:49:36.000000', 'temperatura', 143.0000, 'ºC'),
	(8078, 108, '2015-01-15 00:49:37.000000', 'temperatura', 353.0000, 'ºC'),
	(8079, 108, '2015-01-15 00:49:38.000000', 'temperatura', 137.0000, 'ºC'),
	(8080, 108, '2015-01-15 00:49:39.000000', 'temperatura', 827.0000, 'ºC'),
	(8081, 108, '2015-01-15 00:49:40.000000', 'temperatura', 125.0000, 'ºC'),
	(8082, 108, '2015-01-15 00:49:41.000000', 'temperatura', 543.0000, 'ºC'),
	(8083, 108, '2015-01-15 00:49:42.000000', 'temperatura', 1139.0000, 'ºC'),
	(8084, 108, '2015-01-15 00:49:43.000000', 'temperatura', 468.0000, 'ºC'),
	(8085, 108, '2015-01-15 00:49:44.000000', 'temperatura', 124.0000, 'ºC'),
	(8086, 108, '2015-01-15 00:49:45.000000', 'temperatura', 417.0000, 'ºC'),
	(8087, 108, '2015-01-15 00:49:46.000000', 'temperatura', 515.0000, 'ºC'),
	(8088, 108, '2015-01-15 00:49:47.000000', 'temperatura', 121.0000, 'ºC'),
	(8089, 108, '2015-01-15 00:49:48.000000', 'temperatura', 263.0000, 'ºC'),
	(8090, 108, '2015-01-15 00:49:49.000000', 'temperatura', 953.0000, 'ºC'),
	(8091, 108, '2015-01-15 00:49:50.000000', 'temperatura', 378.0000, 'ºC'),
	(8092, 108, '2015-01-15 00:49:51.000000', 'temperatura', 229.0000, 'ºC'),
	(8093, 108, '2015-01-15 00:49:52.000000', 'temperatura', 10.0000, 'ºC'),
	(8094, 108, '2015-01-15 00:49:53.000000', 'temperatura', 565.0000, 'ºC'),
	(8095, 108, '2015-01-15 00:49:54.000000', 'temperatura', 397.0000, 'ºC'),
	(8096, 108, '2015-01-15 00:49:55.000000', 'temperatura', 289.0000, 'ºC'),
	(8097, 108, '2015-01-15 00:49:56.000000', 'temperatura', 256.0000, 'ºC'),
	(8098, 108, '2015-01-15 00:49:57.000000', 'temperatura', 413.0000, 'ºC'),
	(8099, 108, '2015-01-15 00:49:58.000000', 'temperatura', 98.0000, 'ºC'),
	(8100, 108, '2015-01-15 00:49:59.000000', 'temperatura', 450.0000, 'ºC'),
	(8101, 108, '2015-01-15 00:50:00.000000', 'temperatura', 756.0000, 'ºC'),
	(8102, 108, '2015-01-15 00:50:01.000000', 'temperatura', 31.0000, 'ºC'),
	(8103, 108, '2015-01-15 00:50:02.000000', 'temperatura', 289.0000, 'ºC'),
	(8104, 108, '2015-01-15 00:50:03.000000', 'temperatura', 152.0000, 'ºC'),
	(8105, 108, '2015-01-15 00:50:04.000000', 'temperatura', 1094.0000, 'ºC'),
	(8106, 108, '2015-01-15 00:50:05.000000', 'temperatura', 213.0000, 'ºC'),
	(8107, 108, '2015-01-15 00:50:06.000000', 'temperatura', 183.0000, 'ºC'),
	(8108, 108, '2015-01-15 00:50:07.000000', 'temperatura', 278.0000, 'ºC'),
	(8109, 108, '2015-01-15 00:50:08.000000', 'temperatura', 839.0000, 'ºC'),
	(8110, 108, '2015-01-15 00:50:09.000000', 'temperatura', 963.0000, 'ºC'),
	(8111, 108, '2015-01-15 00:50:10.000000', 'temperatura', 1100.0000, 'ºC'),
	(8112, 108, '2015-01-15 00:50:11.000000', 'temperatura', 208.0000, 'ºC'),
	(8113, 108, '2015-01-15 00:50:12.000000', 'temperatura', 144.0000, 'ºC'),
	(8114, 108, '2015-01-15 00:50:13.000000', 'temperatura', 95.0000, 'ºC'),
	(8115, 108, '2015-01-15 00:50:14.000000', 'temperatura', 45.0000, 'ºC'),
	(8116, 108, '2015-01-15 00:50:15.000000', 'temperatura', 1140.0000, 'ºC'),
	(8117, 108, '2015-01-15 00:50:16.000000', 'temperatura', 767.0000, 'ºC'),
	(8118, 108, '2015-01-15 00:50:17.000000', 'temperatura', 415.0000, 'ºC'),
	(8119, 108, '2015-01-15 00:50:18.000000', 'temperatura', 975.0000, 'ºC'),
	(8120, 108, '2015-01-15 00:50:19.000000', 'temperatura', 31.0000, 'ºC'),
	(8121, 108, '2015-01-15 00:50:20.000000', 'temperatura', 828.0000, 'ºC'),
	(8122, 108, '2015-01-15 00:50:21.000000', 'temperatura', 448.0000, 'ºC'),
	(8123, 108, '2015-01-15 00:50:22.000000', 'temperatura', 955.0000, 'ºC'),
	(8124, 108, '2015-01-15 00:50:23.000000', 'temperatura', 1035.0000, 'ºC'),
	(8125, 108, '2015-01-15 00:50:24.000000', 'temperatura', 1107.0000, 'ºC'),
	(8126, 108, '2015-01-15 00:50:25.000000', 'temperatura', 32.0000, 'ºC'),
	(8127, 108, '2015-01-15 00:50:26.000000', 'temperatura', 440.0000, 'ºC'),
	(8128, 108, '2015-01-15 00:50:27.000000', 'temperatura', 903.0000, 'ºC'),
	(8129, 108, '2015-01-15 00:50:28.000000', 'temperatura', 796.0000, 'ºC'),
	(8130, 108, '2015-01-15 00:50:29.000000', 'temperatura', 73.0000, 'ºC'),
	(8131, 108, '2015-01-15 00:50:30.000000', 'temperatura', 378.0000, 'ºC'),
	(8132, 108, '2015-01-15 00:50:31.000000', 'temperatura', 471.0000, 'ºC'),
	(8133, 108, '2015-01-15 00:50:32.000000', 'temperatura', 23.0000, 'ºC'),
	(8134, 108, '2015-01-15 00:50:33.000000', 'temperatura', 1101.0000, 'ºC'),
	(8135, 108, '2015-01-15 00:50:34.000000', 'temperatura', 637.0000, 'ºC'),
	(8136, 108, '2015-01-15 00:50:35.000000', 'temperatura', 1083.0000, 'ºC'),
	(8137, 108, '2015-01-15 00:50:36.000000', 'temperatura', 1105.0000, 'ºC'),
	(8138, 108, '2015-01-15 00:50:37.000000', 'temperatura', 1077.0000, 'ºC'),
	(8139, 108, '2015-01-15 00:50:38.000000', 'temperatura', 870.0000, 'ºC'),
	(8140, 108, '2015-01-15 00:50:39.000000', 'temperatura', 1120.0000, 'ºC'),
	(8141, 108, '2015-01-15 00:50:40.000000', 'temperatura', 589.0000, 'ºC'),
	(8142, 108, '2015-01-15 00:50:41.000000', 'temperatura', 785.0000, 'ºC'),
	(8143, 108, '2015-01-15 00:50:42.000000', 'temperatura', 959.0000, 'ºC'),
	(8144, 108, '2015-01-15 00:50:43.000000', 'temperatura', 40.0000, 'ºC'),
	(8145, 108, '2015-01-15 00:50:44.000000', 'temperatura', 925.0000, 'ºC'),
	(8146, 108, '2015-01-15 00:50:45.000000', 'temperatura', 905.0000, 'ºC'),
	(8147, 108, '2015-01-15 00:50:46.000000', 'temperatura', 549.0000, 'ºC'),
	(8148, 108, '2015-01-15 00:50:47.000000', 'temperatura', 32.0000, 'ºC'),
	(8149, 108, '2015-01-15 00:50:48.000000', 'temperatura', 913.0000, 'ºC'),
	(8150, 108, '2015-01-15 00:50:49.000000', 'temperatura', 871.0000, 'ºC'),
	(8151, 108, '2015-01-15 00:50:50.000000', 'temperatura', 417.0000, 'ºC'),
	(8152, 108, '2015-01-15 00:50:51.000000', 'temperatura', 672.0000, 'ºC'),
	(8153, 108, '2015-01-15 00:50:52.000000', 'temperatura', 911.0000, 'ºC'),
	(8154, 108, '2015-01-15 00:50:53.000000', 'temperatura', 138.0000, 'ºC'),
	(8155, 108, '2015-01-15 00:50:54.000000', 'temperatura', 356.0000, 'ºC'),
	(8156, 108, '2015-01-15 00:50:55.000000', 'temperatura', 166.0000, 'ºC'),
	(8157, 108, '2015-01-15 00:50:56.000000', 'temperatura', 965.0000, 'ºC'),
	(8158, 108, '2015-01-15 00:50:57.000000', 'temperatura', 725.0000, 'ºC'),
	(8159, 108, '2015-01-15 00:50:58.000000', 'temperatura', 732.0000, 'ºC'),
	(8160, 108, '2015-01-15 00:50:59.000000', 'temperatura', 286.0000, 'ºC'),
	(8161, 108, '2015-01-15 00:51:00.000000', 'temperatura', 433.0000, 'ºC'),
	(8162, 108, '2015-01-15 00:51:01.000000', 'temperatura', 108.0000, 'ºC'),
	(8163, 108, '2015-01-15 00:51:02.000000', 'temperatura', 441.0000, 'ºC'),
	(8164, 108, '2015-01-15 00:51:03.000000', 'temperatura', 680.0000, 'ºC'),
	(8165, 108, '2015-01-15 00:51:04.000000', 'temperatura', 879.0000, 'ºC'),
	(8166, 108, '2015-01-15 00:51:05.000000', 'temperatura', 1156.0000, 'ºC'),
	(8167, 108, '2015-01-15 00:51:06.000000', 'temperatura', 742.0000, 'ºC'),
	(8168, 108, '2015-01-15 00:51:07.000000', 'temperatura', 243.0000, 'ºC'),
	(8169, 108, '2015-01-15 00:51:08.000000', 'temperatura', 190.0000, 'ºC'),
	(8170, 108, '2015-01-15 00:51:09.000000', 'temperatura', 220.0000, 'ºC'),
	(8171, 108, '2015-01-15 00:51:10.000000', 'temperatura', 532.0000, 'ºC'),
	(8172, 108, '2015-01-15 00:51:11.000000', 'temperatura', 799.0000, 'ºC'),
	(8173, 108, '2015-01-15 00:51:12.000000', 'temperatura', 2.0000, 'ºC'),
	(8174, 108, '2015-01-15 00:51:13.000000', 'temperatura', 14.0000, 'ºC'),
	(8175, 108, '2015-01-15 00:51:14.000000', 'temperatura', 63.0000, 'ºC'),
	(8176, 108, '2015-01-15 00:51:15.000000', 'temperatura', 272.0000, 'ºC'),
	(8177, 108, '2015-01-15 00:51:16.000000', 'temperatura', 1171.0000, 'ºC'),
	(8178, 108, '2015-01-15 00:51:17.000000', 'temperatura', 242.0000, 'ºC'),
	(8179, 108, '2015-01-15 00:51:18.000000', 'temperatura', 95.0000, 'ºC'),
	(8180, 108, '2015-01-15 00:51:19.000000', 'temperatura', 949.0000, 'ºC'),
	(8181, 108, '2015-01-15 00:51:20.000000', 'temperatura', 860.0000, 'ºC'),
	(8182, 108, '2015-01-15 00:51:21.000000', 'temperatura', 254.0000, 'ºC'),
	(8183, 108, '2015-01-15 00:51:22.000000', 'temperatura', 1090.0000, 'ºC'),
	(8184, 108, '2015-01-15 00:51:23.000000', 'temperatura', 1089.0000, 'ºC'),
	(8185, 108, '2015-01-15 00:51:24.000000', 'temperatura', 974.0000, 'ºC'),
	(8186, 108, '2015-01-15 00:51:25.000000', 'temperatura', 404.0000, 'ºC'),
	(8187, 108, '2015-01-15 00:51:26.000000', 'temperatura', 298.0000, 'ºC'),
	(8188, 108, '2015-01-15 00:51:27.000000', 'temperatura', 280.0000, 'ºC'),
	(8189, 108, '2015-01-15 00:51:28.000000', 'temperatura', 505.0000, 'ºC'),
	(8190, 108, '2015-01-15 00:51:29.000000', 'temperatura', 488.0000, 'ºC'),
	(8191, 108, '2015-01-15 00:51:30.000000', 'temperatura', 924.0000, 'ºC'),
	(8192, 108, '2015-01-15 00:51:31.000000', 'temperatura', 755.0000, 'ºC'),
	(8193, 108, '2015-01-15 00:51:32.000000', 'temperatura', 1007.0000, 'ºC'),
	(8194, 108, '2015-01-15 00:51:33.000000', 'temperatura', 367.0000, 'ºC'),
	(8195, 108, '2015-01-15 00:51:34.000000', 'temperatura', 15.0000, 'ºC'),
	(8196, 108, '2015-01-15 00:51:35.000000', 'temperatura', 175.0000, 'ºC'),
	(8197, 108, '2015-01-15 00:51:36.000000', 'temperatura', 832.0000, 'ºC'),
	(8198, 108, '2015-01-15 00:51:37.000000', 'temperatura', 36.0000, 'ºC'),
	(8199, 108, '2015-01-15 00:51:38.000000', 'temperatura', 82.0000, 'ºC'),
	(8200, 108, '2015-01-15 00:51:39.000000', 'temperatura', 302.0000, 'ºC'),
	(8201, 108, '2015-01-15 00:51:40.000000', 'temperatura', 65.0000, 'ºC'),
	(8202, 108, '2015-01-15 00:51:41.000000', 'temperatura', 620.0000, 'ºC'),
	(8203, 108, '2015-01-15 00:51:42.000000', 'temperatura', 505.0000, 'ºC'),
	(8204, 108, '2015-01-15 00:51:43.000000', 'temperatura', 668.0000, 'ºC'),
	(8205, 108, '2015-01-15 00:51:44.000000', 'temperatura', 623.0000, 'ºC'),
	(8206, 108, '2015-01-15 00:51:45.000000', 'temperatura', 1111.0000, 'ºC'),
	(8207, 108, '2015-01-15 00:51:46.000000', 'temperatura', 86.0000, 'ºC'),
	(8208, 108, '2015-01-15 00:51:47.000000', 'temperatura', 700.0000, 'ºC'),
	(8209, 108, '2015-01-15 00:51:48.000000', 'temperatura', 843.0000, 'ºC'),
	(8210, 108, '2015-01-15 00:51:49.000000', 'temperatura', 913.0000, 'ºC'),
	(8211, 108, '2015-01-15 00:51:50.000000', 'temperatura', 838.0000, 'ºC'),
	(8212, 108, '2015-01-15 00:51:51.000000', 'temperatura', 250.0000, 'ºC'),
	(8213, 108, '2015-01-15 00:51:52.000000', 'temperatura', 1136.0000, 'ºC'),
	(8214, 108, '2015-01-15 00:51:53.000000', 'temperatura', 130.0000, 'ºC'),
	(8215, 108, '2015-01-15 00:51:54.000000', 'temperatura', 843.0000, 'ºC'),
	(8216, 108, '2015-01-15 00:51:55.000000', 'temperatura', 224.0000, 'ºC'),
	(8217, 108, '2015-01-15 00:51:56.000000', 'temperatura', 995.0000, 'ºC'),
	(8218, 108, '2015-01-15 00:51:57.000000', 'temperatura', 700.0000, 'ºC'),
	(8219, 108, '2015-01-15 00:51:58.000000', 'temperatura', 517.0000, 'ºC'),
	(8220, 108, '2015-01-15 00:51:59.000000', 'temperatura', 486.0000, 'ºC'),
	(8221, 108, '2015-01-15 00:52:00.000000', 'temperatura', 881.0000, 'ºC'),
	(8222, 108, '2015-01-15 00:52:01.000000', 'temperatura', 544.0000, 'ºC'),
	(8223, 108, '2015-01-15 00:52:02.000000', 'temperatura', 80.0000, 'ºC'),
	(8224, 108, '2015-01-15 00:52:03.000000', 'temperatura', 1167.0000, 'ºC'),
	(8225, 108, '2015-01-15 00:52:04.000000', 'temperatura', 796.0000, 'ºC'),
	(8226, 108, '2015-01-15 00:52:05.000000', 'temperatura', 478.0000, 'ºC'),
	(8227, 108, '2015-01-15 00:52:06.000000', 'temperatura', 5.0000, 'ºC'),
	(8228, 108, '2015-01-15 00:52:07.000000', 'temperatura', 989.0000, 'ºC'),
	(8229, 108, '2015-01-15 00:52:08.000000', 'temperatura', 133.0000, 'ºC'),
	(8230, 108, '2015-01-15 00:52:09.000000', 'temperatura', 98.0000, 'ºC'),
	(8231, 108, '2015-01-15 00:52:10.000000', 'temperatura', 93.0000, 'ºC'),
	(8232, 108, '2015-01-15 00:52:11.000000', 'temperatura', 170.0000, 'ºC'),
	(8233, 108, '2015-01-15 00:52:12.000000', 'temperatura', 574.0000, 'ºC'),
	(8234, 108, '2015-01-15 00:52:13.000000', 'temperatura', 1158.0000, 'ºC'),
	(8235, 108, '2015-01-15 00:52:14.000000', 'temperatura', 467.0000, 'ºC'),
	(8236, 108, '2015-01-15 00:52:15.000000', 'temperatura', 65.0000, 'ºC'),
	(8237, 108, '2015-01-15 00:52:16.000000', 'temperatura', 121.0000, 'ºC'),
	(8238, 108, '2015-01-15 00:52:17.000000', 'temperatura', 414.0000, 'ºC'),
	(8239, 108, '2015-01-15 00:52:18.000000', 'temperatura', 505.0000, 'ºC'),
	(8240, 108, '2015-01-15 00:52:19.000000', 'temperatura', 83.0000, 'ºC'),
	(8241, 108, '2015-01-15 00:52:20.000000', 'temperatura', 102.0000, 'ºC'),
	(8242, 108, '2015-01-15 00:52:21.000000', 'temperatura', 260.0000, 'ºC'),
	(8243, 108, '2015-01-15 00:52:22.000000', 'temperatura', 995.0000, 'ºC'),
	(8244, 108, '2015-01-15 00:52:23.000000', 'temperatura', 594.0000, 'ºC'),
	(8245, 108, '2015-01-15 00:52:24.000000', 'temperatura', 1188.0000, 'ºC'),
	(8246, 108, '2015-01-15 00:52:25.000000', 'temperatura', 557.0000, 'ºC'),
	(8247, 108, '2015-01-15 00:52:26.000000', 'temperatura', 422.0000, 'ºC'),
	(8248, 108, '2015-01-15 00:52:27.000000', 'temperatura', 441.0000, 'ºC'),
	(8249, 108, '2015-01-15 00:52:28.000000', 'temperatura', 939.0000, 'ºC'),
	(8250, 108, '2015-01-15 00:52:29.000000', 'temperatura', 971.0000, 'ºC'),
	(8251, 108, '2015-01-15 00:52:30.000000', 'temperatura', 841.0000, 'ºC'),
	(8252, 108, '2015-01-15 00:52:31.000000', 'temperatura', 90.0000, 'ºC'),
	(8253, 108, '2015-01-15 00:52:32.000000', 'temperatura', 330.0000, 'ºC'),
	(8254, 108, '2015-01-15 00:52:33.000000', 'temperatura', 179.0000, 'ºC'),
	(8255, 108, '2015-01-15 00:52:34.000000', 'temperatura', 1108.0000, 'ºC'),
	(8256, 108, '2015-01-15 00:52:35.000000', 'temperatura', 200.0000, 'ºC'),
	(8257, 108, '2015-01-15 00:52:36.000000', 'temperatura', 78.0000, 'ºC'),
	(8258, 108, '2015-01-15 00:52:37.000000', 'temperatura', 988.0000, 'ºC'),
	(8259, 108, '2015-01-15 00:52:38.000000', 'temperatura', 1110.0000, 'ºC'),
	(8260, 108, '2015-01-15 00:52:39.000000', 'temperatura', 183.0000, 'ºC'),
	(8261, 108, '2015-01-15 00:52:40.000000', 'temperatura', 1189.0000, 'ºC'),
	(8262, 108, '2015-01-15 00:52:41.000000', 'temperatura', 594.0000, 'ºC'),
	(8263, 108, '2015-01-15 00:52:42.000000', 'temperatura', 606.0000, 'ºC'),
	(8264, 108, '2015-01-15 00:52:43.000000', 'temperatura', 47.0000, 'ºC'),
	(8265, 108, '2015-01-15 00:52:44.000000', 'temperatura', 819.0000, 'ºC'),
	(8266, 108, '2015-01-15 00:52:45.000000', 'temperatura', 352.0000, 'ºC'),
	(8267, 108, '2015-01-15 00:52:46.000000', 'temperatura', 505.0000, 'ºC'),
	(8268, 108, '2015-01-15 00:52:47.000000', 'temperatura', 268.0000, 'ºC'),
	(8269, 108, '2015-01-15 00:52:48.000000', 'temperatura', 1028.0000, 'ºC'),
	(8270, 108, '2015-01-15 00:52:49.000000', 'temperatura', 737.0000, 'ºC'),
	(8271, 108, '2015-01-15 00:52:50.000000', 'temperatura', 600.0000, 'ºC'),
	(8272, 108, '2015-01-15 00:52:51.000000', 'temperatura', 788.0000, 'ºC'),
	(8273, 108, '2015-01-15 00:52:52.000000', 'temperatura', 941.0000, 'ºC'),
	(8274, 108, '2015-01-15 00:52:53.000000', 'temperatura', 1140.0000, 'ºC'),
	(8275, 108, '2015-01-15 00:52:54.000000', 'temperatura', 479.0000, 'ºC'),
	(8276, 108, '2015-01-15 00:52:55.000000', 'temperatura', 177.0000, 'ºC'),
	(8277, 108, '2015-01-15 00:52:56.000000', 'temperatura', 649.0000, 'ºC'),
	(8278, 108, '2015-01-15 00:52:57.000000', 'temperatura', 314.0000, 'ºC'),
	(8279, 108, '2015-01-15 00:52:58.000000', 'temperatura', 821.0000, 'ºC'),
	(8280, 108, '2015-01-15 00:52:59.000000', 'temperatura', 766.0000, 'ºC'),
	(8281, 108, '2015-01-15 00:53:00.000000', 'temperatura', 166.0000, 'ºC'),
	(8282, 108, '2015-01-15 00:53:01.000000', 'temperatura', 932.0000, 'ºC'),
	(8283, 108, '2015-01-15 00:53:02.000000', 'temperatura', 561.0000, 'ºC'),
	(8284, 108, '2015-01-15 00:53:03.000000', 'temperatura', 12.0000, 'ºC'),
	(8285, 108, '2015-01-15 00:53:04.000000', 'temperatura', 778.0000, 'ºC'),
	(8286, 108, '2015-01-15 00:53:05.000000', 'temperatura', 256.0000, 'ºC'),
	(8287, 108, '2015-01-15 00:53:06.000000', 'temperatura', 143.0000, 'ºC'),
	(8288, 108, '2015-01-15 00:53:07.000000', 'temperatura', 1149.0000, 'ºC'),
	(8289, 108, '2015-01-15 00:53:08.000000', 'temperatura', 517.0000, 'ºC'),
	(8290, 108, '2015-01-15 00:53:09.000000', 'temperatura', 336.0000, 'ºC'),
	(8291, 108, '2015-01-15 00:53:10.000000', 'temperatura', 131.0000, 'ºC'),
	(8292, 108, '2015-01-15 00:53:11.000000', 'temperatura', 849.0000, 'ºC'),
	(8293, 108, '2015-01-15 00:53:12.000000', 'temperatura', 251.0000, 'ºC'),
	(8294, 108, '2015-01-15 00:53:13.000000', 'temperatura', 1111.0000, 'ºC'),
	(8295, 108, '2015-01-15 00:53:14.000000', 'temperatura', 0.0000, 'ºC'),
	(8296, 108, '2015-01-15 00:53:15.000000', 'temperatura', 269.0000, 'ºC'),
	(8297, 108, '2015-01-15 00:53:16.000000', 'temperatura', 146.0000, 'ºC'),
	(8298, 108, '2015-01-15 00:53:17.000000', 'temperatura', 1122.0000, 'ºC'),
	(8299, 108, '2015-01-15 00:53:18.000000', 'temperatura', 373.0000, 'ºC'),
	(8300, 108, '2015-01-15 00:53:19.000000', 'temperatura', 899.0000, 'ºC'),
	(8301, 108, '2015-01-15 00:53:20.000000', 'temperatura', 977.0000, 'ºC'),
	(8302, 108, '2015-01-15 00:53:21.000000', 'temperatura', 987.0000, 'ºC'),
	(8303, 108, '2015-01-15 00:53:22.000000', 'temperatura', 807.0000, 'ºC'),
	(8304, 108, '2015-01-15 00:53:23.000000', 'temperatura', 1075.0000, 'ºC'),
	(8305, 108, '2015-01-15 00:53:24.000000', 'temperatura', 552.0000, 'ºC'),
	(8306, 108, '2015-01-15 00:53:25.000000', 'temperatura', 738.0000, 'ºC'),
	(8307, 108, '2015-01-15 00:53:26.000000', 'temperatura', 831.0000, 'ºC'),
	(8308, 108, '2015-01-15 00:53:27.000000', 'temperatura', 745.0000, 'ºC'),
	(8309, 108, '2015-01-15 00:53:28.000000', 'temperatura', 31.0000, 'ºC'),
	(8310, 108, '2015-01-15 00:53:29.000000', 'temperatura', 323.0000, 'ºC'),
	(8311, 108, '2015-01-15 00:53:30.000000', 'temperatura', 320.0000, 'ºC'),
	(8312, 108, '2015-01-15 00:53:31.000000', 'temperatura', 632.0000, 'ºC'),
	(8313, 108, '2015-01-15 00:53:32.000000', 'temperatura', 1000.0000, 'ºC'),
	(8314, 108, '2015-01-15 00:53:33.000000', 'temperatura', 706.0000, 'ºC'),
	(8315, 108, '2015-01-15 00:53:34.000000', 'temperatura', 531.0000, 'ºC'),
	(8316, 108, '2015-01-15 00:53:35.000000', 'temperatura', 538.0000, 'ºC'),
	(8317, 108, '2015-01-15 00:53:36.000000', 'temperatura', 1095.0000, 'ºC'),
	(8318, 108, '2015-01-15 00:53:37.000000', 'temperatura', 261.0000, 'ºC'),
	(8319, 108, '2015-01-15 00:53:38.000000', 'temperatura', 421.0000, 'ºC'),
	(8320, 108, '2015-01-15 00:53:39.000000', 'temperatura', 124.0000, 'ºC'),
	(8321, 108, '2015-01-15 00:53:40.000000', 'temperatura', 558.0000, 'ºC'),
	(8322, 108, '2015-01-15 00:53:41.000000', 'temperatura', 19.0000, 'ºC'),
	(8323, 108, '2015-01-15 00:53:42.000000', 'temperatura', 820.0000, 'ºC'),
	(8324, 108, '2015-01-15 00:53:43.000000', 'temperatura', 445.0000, 'ºC'),
	(8325, 108, '2015-01-15 00:53:44.000000', 'temperatura', 966.0000, 'ºC'),
	(8326, 108, '2015-01-15 00:53:45.000000', 'temperatura', 1093.0000, 'ºC'),
	(8327, 108, '2015-01-15 00:53:46.000000', 'temperatura', 168.0000, 'ºC'),
	(8328, 108, '2015-01-15 00:53:47.000000', 'temperatura', 1164.0000, 'ºC'),
	(8329, 108, '2015-01-15 00:53:48.000000', 'temperatura', 513.0000, 'ºC'),
	(8330, 108, '2015-01-15 00:53:49.000000', 'temperatura', 275.0000, 'ºC'),
	(8331, 108, '2015-01-15 00:53:50.000000', 'temperatura', 1036.0000, 'ºC'),
	(8332, 108, '2015-01-15 00:53:51.000000', 'temperatura', 757.0000, 'ºC'),
	(8333, 108, '2015-01-15 00:53:52.000000', 'temperatura', 676.0000, 'ºC'),
	(8334, 108, '2015-01-15 00:53:53.000000', 'temperatura', 1109.0000, 'ºC'),
	(8335, 108, '2015-01-15 00:53:54.000000', 'temperatura', 1118.0000, 'ºC'),
	(8336, 108, '2015-01-15 00:53:55.000000', 'temperatura', 1063.0000, 'ºC'),
	(8337, 108, '2015-01-15 00:53:56.000000', 'temperatura', 764.0000, 'ºC'),
	(8338, 108, '2015-01-15 00:53:57.000000', 'temperatura', 629.0000, 'ºC'),
	(8339, 108, '2015-01-15 00:53:58.000000', 'temperatura', 853.0000, 'ºC'),
	(8340, 108, '2015-01-15 00:53:59.000000', 'temperatura', 1180.0000, 'ºC'),
	(8341, 108, '2015-01-15 00:54:00.000000', 'temperatura', 943.0000, 'ºC'),
	(8342, 108, '2015-01-15 00:54:01.000000', 'temperatura', 1173.0000, 'ºC'),
	(8343, 108, '2015-01-15 00:54:02.000000', 'temperatura', 639.0000, 'ºC'),
	(8344, 108, '2015-01-15 00:54:03.000000', 'temperatura', 876.0000, 'ºC'),
	(8345, 108, '2015-01-15 00:54:04.000000', 'temperatura', 63.0000, 'ºC'),
	(8346, 108, '2015-01-15 00:54:05.000000', 'temperatura', 88.0000, 'ºC'),
	(8347, 108, '2015-01-15 00:54:06.000000', 'temperatura', 249.0000, 'ºC'),
	(8348, 108, '2015-01-15 00:54:07.000000', 'temperatura', 984.0000, 'ºC'),
	(8349, 108, '2015-01-15 00:54:08.000000', 'temperatura', 573.0000, 'ºC'),
	(8350, 108, '2015-01-15 00:54:09.000000', 'temperatura', 1113.0000, 'ºC'),
	(8351, 108, '2015-01-15 00:54:10.000000', 'temperatura', 246.0000, 'ºC'),
	(8352, 108, '2015-01-15 00:54:11.000000', 'temperatura', 291.0000, 'ºC'),
	(8353, 108, '2015-01-15 00:54:12.000000', 'temperatura', 719.0000, 'ºC'),
	(8354, 108, '2015-01-15 00:54:13.000000', 'temperatura', 321.0000, 'ºC'),
	(8355, 108, '2015-01-15 00:54:14.000000', 'temperatura', 651.0000, 'ºC'),
	(8356, 108, '2015-01-15 00:54:15.000000', 'temperatura', 1090.0000, 'ºC'),
	(8357, 108, '2015-01-15 00:54:16.000000', 'temperatura', 1096.0000, 'ºC'),
	(8358, 108, '2015-01-15 00:54:17.000000', 'temperatura', 1013.0000, 'ºC'),
	(8359, 108, '2015-01-15 00:54:18.000000', 'temperatura', 579.0000, 'ºC'),
	(8360, 108, '2015-01-15 00:54:19.000000', 'temperatura', 1053.0000, 'ºC'),
	(8361, 108, '2015-01-15 00:54:20.000000', 'temperatura', 1130.0000, 'ºC'),
	(8362, 108, '2015-01-15 00:54:21.000000', 'temperatura', 91.0000, 'ºC'),
	(8363, 108, '2015-01-15 00:54:22.000000', 'temperatura', 664.0000, 'ºC'),
	(8364, 108, '2015-01-15 00:54:23.000000', 'temperatura', 649.0000, 'ºC'),
	(8365, 108, '2015-01-15 00:54:24.000000', 'temperatura', 53.0000, 'ºC'),
	(8366, 108, '2015-01-15 00:54:25.000000', 'temperatura', 720.0000, 'ºC'),
	(8367, 108, '2015-01-15 00:54:26.000000', 'temperatura', 1040.0000, 'ºC'),
	(8368, 108, '2015-01-15 00:54:27.000000', 'temperatura', 641.0000, 'ºC'),
	(8369, 108, '2015-01-15 00:54:28.000000', 'temperatura', 84.0000, 'ºC'),
	(8370, 108, '2015-01-15 00:54:29.000000', 'temperatura', 896.0000, 'ºC'),
	(8371, 108, '2015-01-15 00:54:30.000000', 'temperatura', 632.0000, 'ºC'),
	(8372, 108, '2015-01-15 00:54:31.000000', 'temperatura', 473.0000, 'ºC'),
	(8373, 108, '2015-01-15 00:54:32.000000', 'temperatura', 467.0000, 'ºC'),
	(8374, 108, '2015-01-15 00:54:33.000000', 'temperatura', 918.0000, 'ºC'),
	(8375, 108, '2015-01-15 00:54:34.000000', 'temperatura', 787.0000, 'ºC'),
	(8376, 108, '2015-01-15 00:54:35.000000', 'temperatura', 1185.0000, 'ºC'),
	(8377, 108, '2015-01-15 00:54:36.000000', 'temperatura', 1161.0000, 'ºC'),
	(8378, 108, '2015-01-15 00:54:37.000000', 'temperatura', 1052.0000, 'ºC'),
	(8379, 108, '2015-01-15 00:54:38.000000', 'temperatura', 578.0000, 'ºC'),
	(8380, 108, '2015-01-15 00:54:39.000000', 'temperatura', 936.0000, 'ºC'),
	(8381, 108, '2015-01-15 00:54:40.000000', 'temperatura', 546.0000, 'ºC'),
	(8382, 108, '2015-01-15 00:54:41.000000', 'temperatura', 1123.0000, 'ºC'),
	(8383, 108, '2015-01-15 00:54:42.000000', 'temperatura', 378.0000, 'ºC'),
	(8384, 108, '2015-01-15 00:54:43.000000', 'temperatura', 921.0000, 'ºC'),
	(8385, 108, '2015-01-15 00:54:44.000000', 'temperatura', 1069.0000, 'ºC'),
	(8386, 108, '2015-01-15 00:54:45.000000', 'temperatura', 185.0000, 'ºC'),
	(8387, 108, '2015-01-15 00:54:46.000000', 'temperatura', 117.0000, 'ºC'),
	(8388, 108, '2015-01-15 00:54:47.000000', 'temperatura', 32.0000, 'ºC'),
	(8389, 108, '2015-01-15 00:54:48.000000', 'temperatura', 1007.0000, 'ºC'),
	(8390, 108, '2015-01-15 00:54:49.000000', 'temperatura', 141.0000, 'ºC'),
	(8391, 108, '2015-01-15 00:54:50.000000', 'temperatura', 84.0000, 'ºC'),
	(8392, 108, '2015-01-15 00:54:51.000000', 'temperatura', 1197.0000, 'ºC'),
	(8393, 108, '2015-01-15 00:54:52.000000', 'temperatura', 933.0000, 'ºC'),
	(8394, 108, '2015-01-15 00:54:53.000000', 'temperatura', 1075.0000, 'ºC'),
	(8395, 108, '2015-01-15 00:54:54.000000', 'temperatura', 175.0000, 'ºC'),
	(8396, 108, '2015-01-15 00:54:55.000000', 'temperatura', 53.0000, 'ºC'),
	(8397, 108, '2015-01-15 00:54:56.000000', 'temperatura', 939.0000, 'ºC'),
	(8398, 108, '2015-01-15 00:54:57.000000', 'temperatura', 935.0000, 'ºC'),
	(8399, 108, '2015-01-15 00:54:58.000000', 'temperatura', 659.0000, 'ºC'),
	(8400, 108, '2015-01-15 00:54:59.000000', 'temperatura', 490.0000, 'ºC'),
	(8401, 108, '2015-01-15 00:55:00.000000', 'temperatura', 473.0000, 'ºC'),
	(8402, 108, '2015-01-15 00:55:01.000000', 'temperatura', 898.0000, 'ºC'),
	(8403, 108, '2015-01-15 00:55:02.000000', 'temperatura', 670.0000, 'ºC'),
	(8404, 108, '2015-01-15 00:55:03.000000', 'temperatura', 655.0000, 'ºC'),
	(8405, 108, '2015-01-15 00:55:04.000000', 'temperatura', 65.0000, 'ºC'),
	(8406, 108, '2015-01-15 00:55:05.000000', 'temperatura', 763.0000, 'ºC'),
	(8407, 108, '2015-01-15 00:55:06.000000', 'temperatura', 19.0000, 'ºC'),
	(8408, 108, '2015-01-15 00:55:07.000000', 'temperatura', 208.0000, 'ºC'),
	(8409, 108, '2015-01-15 00:55:08.000000', 'temperatura', 984.0000, 'ºC'),
	(8410, 108, '2015-01-15 00:55:09.000000', 'temperatura', 696.0000, 'ºC'),
	(8411, 108, '2015-01-15 00:55:10.000000', 'temperatura', 528.0000, 'ºC'),
	(8412, 108, '2015-01-15 00:55:11.000000', 'temperatura', 552.0000, 'ºC'),
	(8413, 108, '2015-01-15 00:55:12.000000', 'temperatura', 1177.0000, 'ºC'),
	(8414, 108, '2015-01-15 00:55:13.000000', 'temperatura', 628.0000, 'ºC'),
	(8415, 108, '2015-01-15 00:55:14.000000', 'temperatura', 812.0000, 'ºC'),
	(8416, 108, '2015-01-15 00:55:15.000000', 'temperatura', 975.0000, 'ºC'),
	(8417, 108, '2015-01-15 00:55:16.000000', 'temperatura', 39.0000, 'ºC'),
	(8418, 108, '2015-01-15 00:55:17.000000', 'temperatura', 873.0000, 'ºC'),
	(8419, 108, '2015-01-15 00:55:18.000000', 'temperatura', 646.0000, 'ºC'),
	(8420, 108, '2015-01-15 00:55:19.000000', 'temperatura', 614.0000, 'ºC'),
	(8421, 108, '2015-01-15 00:55:20.000000', 'temperatura', 1132.0000, 'ºC'),
	(8422, 108, '2015-01-15 00:55:21.000000', 'temperatura', 217.0000, 'ºC'),
	(8423, 108, '2015-01-15 00:55:22.000000', 'temperatura', 89.0000, 'ºC'),
	(8424, 108, '2015-01-15 00:55:23.000000', 'temperatura', 997.0000, 'ºC'),
	(8425, 108, '2015-01-15 00:55:24.000000', 'temperatura', 1116.0000, 'ºC'),
	(8426, 108, '2015-01-15 00:55:25.000000', 'temperatura', 192.0000, 'ºC'),
	(8427, 108, '2015-01-15 00:55:26.000000', 'temperatura', 13.0000, 'ºC'),
	(8428, 108, '2015-01-15 00:55:27.000000', 'temperatura', 687.0000, 'ºC'),
	(8429, 108, '2015-01-15 00:55:28.000000', 'temperatura', 998.0000, 'ºC'),
	(8430, 108, '2015-01-15 00:55:29.000000', 'temperatura', 530.0000, 'ºC'),
	(8431, 108, '2015-01-15 00:55:30.000000', 'temperatura', 854.0000, 'ºC'),
	(8432, 108, '2015-01-15 00:55:31.000000', 'temperatura', 282.0000, 'ºC'),
	(8433, 108, '2015-01-15 00:55:32.000000', 'temperatura', 50.0000, 'ºC'),
	(8434, 108, '2015-01-15 00:55:33.000000', 'temperatura', 603.0000, 'ºC'),
	(8435, 108, '2015-01-15 00:55:34.000000', 'temperatura', 466.0000, 'ºC'),
	(8436, 108, '2015-01-15 00:55:35.000000', 'temperatura', 523.0000, 'ºC'),
	(8437, 108, '2015-01-15 00:55:36.000000', 'temperatura', 16.0000, 'ºC'),
	(8438, 108, '2015-01-15 00:55:37.000000', 'temperatura', 910.0000, 'ºC'),
	(8439, 108, '2015-01-15 00:55:38.000000', 'temperatura', 905.0000, 'ºC'),
	(8440, 108, '2015-01-15 00:55:39.000000', 'temperatura', 597.0000, 'ºC'),
	(8441, 108, '2015-01-15 00:55:40.000000', 'temperatura', 268.0000, 'ºC'),
	(8442, 108, '2015-01-15 00:55:41.000000', 'temperatura', 748.0000, 'ºC'),
	(8443, 108, '2015-01-15 00:55:42.000000', 'temperatura', 538.0000, 'ºC'),
	(8444, 108, '2015-01-15 00:55:43.000000', 'temperatura', 447.0000, 'ºC'),
	(8445, 108, '2015-01-15 00:55:44.000000', 'temperatura', 621.0000, 'ºC'),
	(8446, 108, '2015-01-15 00:55:45.000000', 'temperatura', 565.0000, 'ºC'),
	(8447, 108, '2015-01-15 00:55:46.000000', 'temperatura', 963.0000, 'ºC'),
	(8448, 108, '2015-01-15 00:55:47.000000', 'temperatura', 720.0000, 'ºC'),
	(8449, 108, '2015-01-15 00:55:48.000000', 'temperatura', 710.0000, 'ºC'),
	(8450, 108, '2015-01-15 00:55:49.000000', 'temperatura', 193.0000, 'ºC'),
	(8451, 108, '2015-01-15 00:55:50.000000', 'temperatura', 35.0000, 'ºC'),
	(8452, 108, '2015-01-15 00:55:51.000000', 'temperatura', 794.0000, 'ºC'),
	(8453, 108, '2015-01-15 00:55:52.000000', 'temperatura', 269.0000, 'ºC'),
	(8454, 108, '2015-01-15 00:55:53.000000', 'temperatura', 161.0000, 'ºC'),
	(8455, 108, '2015-01-15 00:55:54.000000', 'temperatura', 1199.0000, 'ºC'),
	(8456, 108, '2015-01-15 00:55:55.000000', 'temperatura', 714.0000, 'ºC'),
	(8457, 108, '2015-01-15 00:55:56.000000', 'temperatura', 1174.0000, 'ºC'),
	(8458, 108, '2015-01-15 00:55:57.000000', 'temperatura', 129.0000, 'ºC'),
	(8459, 108, '2015-01-15 00:55:58.000000', 'temperatura', 721.0000, 'ºC'),
	(8460, 108, '2015-01-15 00:55:59.000000', 'temperatura', 819.0000, 'ºC'),
	(8461, 108, '2015-01-15 00:56:00.000000', 'temperatura', 733.0000, 'ºC'),
	(8462, 108, '2015-01-15 00:56:01.000000', 'temperatura', 10.0000, 'ºC'),
	(8463, 108, '2015-01-15 00:56:02.000000', 'temperatura', 252.0000, 'ºC'),
	(8464, 108, '2015-01-15 00:56:03.000000', 'temperatura', 31.0000, 'ºC'),
	(8465, 108, '2015-01-15 00:56:04.000000', 'temperatura', 599.0000, 'ºC'),
	(8466, 108, '2015-01-15 00:56:05.000000', 'temperatura', 503.0000, 'ºC'),
	(8467, 108, '2015-01-15 00:56:06.000000', 'temperatura', 716.0000, 'ºC'),
	(8468, 108, '2015-01-15 00:56:07.000000', 'temperatura', 872.0000, 'ºC'),
	(8469, 108, '2015-01-15 00:56:08.000000', 'temperatura', 1012.0000, 'ºC'),
	(8470, 108, '2015-01-15 00:56:09.000000', 'temperatura', 45.0000, 'ºC'),
	(8471, 108, '2015-01-15 00:56:10.000000', 'temperatura', 791.0000, 'ºC'),
	(8472, 108, '2015-01-15 00:56:11.000000', 'temperatura', 221.0000, 'ºC'),
	(8473, 108, '2015-01-15 00:56:12.000000', 'temperatura', 1133.0000, 'ºC'),
	(8474, 108, '2015-01-15 00:56:13.000000', 'temperatura', 202.0000, 'ºC'),
	(8475, 108, '2015-01-15 00:56:14.000000', 'temperatura', 10.0000, 'ºC'),
	(8476, 108, '2015-01-15 00:56:15.000000', 'temperatura', 645.0000, 'ºC'),
	(8477, 108, '2015-01-15 00:56:16.000000', 'temperatura', 796.0000, 'ºC'),
	(8478, 108, '2015-01-15 00:56:17.000000', 'temperatura', 847.0000, 'ºC'),
	(8479, 108, '2015-01-15 00:56:18.000000', 'temperatura', 647.0000, 'ºC'),
	(8480, 108, '2015-01-15 00:56:19.000000', 'temperatura', 695.0000, 'ºC'),
	(8481, 108, '2015-01-15 00:56:20.000000', 'temperatura', 332.0000, 'ºC'),
	(8482, 108, '2015-01-15 00:56:21.000000', 'temperatura', 778.0000, 'ºC'),
	(8483, 108, '2015-01-15 00:56:22.000000', 'temperatura', 492.0000, 'ºC'),
	(8484, 108, '2015-01-15 00:56:23.000000', 'temperatura', 127.0000, 'ºC'),
	(8485, 108, '2015-01-15 00:56:24.000000', 'temperatura', 359.0000, 'ºC'),
	(8486, 108, '2015-01-15 00:56:25.000000', 'temperatura', 214.0000, 'ºC'),
	(8487, 108, '2015-01-15 00:56:26.000000', 'temperatura', 1195.0000, 'ºC'),
	(8488, 108, '2015-01-15 00:56:27.000000', 'temperatura', 531.0000, 'ºC'),
	(8489, 108, '2015-01-15 00:56:28.000000', 'temperatura', 273.0000, 'ºC'),
	(8490, 108, '2015-01-15 00:56:29.000000', 'temperatura', 972.0000, 'ºC'),
	(8491, 108, '2015-01-15 00:56:30.000000', 'temperatura', 439.0000, 'ºC'),
	(8492, 108, '2015-01-15 00:56:31.000000', 'temperatura', 482.0000, 'ºC'),
	(8493, 108, '2015-01-15 00:56:32.000000', 'temperatura', 1094.0000, 'ºC'),
	(8494, 108, '2015-01-15 00:56:33.000000', 'temperatura', 422.0000, 'ºC'),
	(8495, 108, '2015-01-15 00:56:34.000000', 'temperatura', 29.0000, 'ºC'),
	(8496, 108, '2015-01-15 00:56:35.000000', 'temperatura', 78.0000, 'ºC'),
	(8497, 108, '2015-01-15 00:56:36.000000', 'temperatura', 304.0000, 'ºC'),
	(8498, 108, '2015-01-15 00:56:37.000000', 'temperatura', 89.0000, 'ºC'),
	(8499, 108, '2015-01-15 00:56:38.000000', 'temperatura', 731.0000, 'ºC'),
	(8500, 108, '2015-01-15 00:56:39.000000', 'temperatura', 989.0000, 'ºC'),
	(8501, 108, '2015-01-15 00:56:40.000000', 'temperatura', 354.0000, 'ºC'),
	(8502, 108, '2015-01-15 00:56:41.000000', 'temperatura', 2.0000, 'ºC'),
	(8503, 108, '2015-01-15 00:56:42.000000', 'temperatura', 148.0000, 'ºC'),
	(8504, 108, '2015-01-15 00:56:43.000000', 'temperatura', 735.0000, 'ºC'),
	(8505, 108, '2015-01-15 00:56:44.000000', 'temperatura', 831.0000, 'ºC'),
	(8506, 108, '2015-01-15 00:56:45.000000', 'temperatura', 751.0000, 'ºC'),
	(8507, 108, '2015-01-15 00:56:46.000000', 'temperatura', 62.0000, 'ºC'),
	(8508, 108, '2015-01-15 00:56:47.000000', 'temperatura', 458.0000, 'ºC'),
	(8509, 108, '2015-01-15 00:56:48.000000', 'temperatura', 906.0000, 'ºC'),
	(8510, 108, '2015-01-15 00:56:49.000000', 'temperatura', 757.0000, 'ºC'),
	(8511, 108, '2015-01-15 00:56:50.000000', 'temperatura', 1068.0000, 'ºC'),
	(8512, 108, '2015-01-15 00:56:51.000000', 'temperatura', 668.0000, 'ºC'),
	(8513, 108, '2015-01-15 00:56:52.000000', 'temperatura', 136.0000, 'ºC'),
	(8514, 108, '2015-01-15 00:56:53.000000', 'temperatura', 1076.0000, 'ºC'),
	(8515, 108, '2015-01-15 00:56:54.000000', 'temperatura', 175.0000, 'ºC'),
	(8516, 108, '2015-01-15 00:56:55.000000', 'temperatura', 46.0000, 'ºC'),
	(8517, 108, '2015-01-15 00:56:56.000000', 'temperatura', 904.0000, 'ºC'),
	(8518, 108, '2015-01-15 00:56:57.000000', 'temperatura', 784.0000, 'ºC'),
	(8519, 108, '2015-01-15 00:56:58.000000', 'temperatura', 8.0000, 'ºC'),
	(8520, 108, '2015-01-15 00:56:59.000000', 'temperatura', 90.0000, 'ºC'),
	(8521, 108, '2015-01-15 00:57:00.000000', 'temperatura', 427.0000, 'ºC'),
	(8522, 108, '2015-01-15 00:57:01.000000', 'temperatura', 663.0000, 'ºC'),
	(8523, 108, '2015-01-15 00:57:02.000000', 'temperatura', 835.0000, 'ºC'),
	(8524, 108, '2015-01-15 00:57:03.000000', 'temperatura', 985.0000, 'ºC'),
	(8525, 108, '2015-01-15 00:57:04.000000', 'temperatura', 22.0000, 'ºC'),
	(8526, 108, '2015-01-15 00:57:05.000000', 'temperatura', 757.0000, 'ºC'),
	(8527, 108, '2015-01-15 00:57:06.000000', 'temperatura', 119.0000, 'ºC'),
	(8528, 108, '2015-01-15 00:57:07.000000', 'temperatura', 724.0000, 'ºC'),
	(8529, 108, '2015-01-15 00:57:08.000000', 'temperatura', 863.0000, 'ºC'),
	(8530, 108, '2015-01-15 00:57:09.000000', 'temperatura', 944.0000, 'ºC'),
	(8531, 108, '2015-01-15 00:57:10.000000', 'temperatura', 933.0000, 'ºC'),
	(8532, 108, '2015-01-15 00:57:11.000000', 'temperatura', 632.0000, 'ºC'),
	(8533, 108, '2015-01-15 00:57:12.000000', 'temperatura', 363.0000, 'ºC'),
	(8534, 108, '2015-01-15 00:57:13.000000', 'temperatura', 1120.0000, 'ºC'),
	(8535, 108, '2015-01-15 00:57:14.000000', 'temperatura', 909.0000, 'ºC'),
	(8536, 108, '2015-01-15 00:57:15.000000', 'temperatura', 1187.0000, 'ºC'),
	(8537, 108, '2015-01-15 00:57:16.000000', 'temperatura', 808.0000, 'ºC'),
	(8538, 108, '2015-01-15 00:57:17.000000', 'temperatura', 478.0000, 'ºC'),
	(8539, 108, '2015-01-15 00:57:18.000000', 'temperatura', 1168.0000, 'ºC'),
	(8540, 108, '2015-01-15 00:57:19.000000', 'temperatura', 806.0000, 'ºC'),
	(8541, 108, '2015-01-15 00:57:20.000000', 'temperatura', 526.0000, 'ºC'),
	(8542, 108, '2015-01-15 00:57:21.000000', 'temperatura', 214.0000, 'ºC'),
	(8543, 108, '2015-01-15 00:57:22.000000', 'temperatura', 692.0000, 'ºC'),
	(8544, 108, '2015-01-15 00:57:23.000000', 'temperatura', 420.0000, 'ºC'),
	(8545, 108, '2015-01-15 00:57:24.000000', 'temperatura', 25.0000, 'ºC'),
	(8546, 108, '2015-01-15 00:57:25.000000', 'temperatura', 64.0000, 'ºC'),
	(8547, 108, '2015-01-15 00:57:26.000000', 'temperatura', 244.0000, 'ºC'),
	(8548, 108, '2015-01-15 00:57:27.000000', 'temperatura', 1029.0000, 'ºC'),
	(8549, 108, '2015-01-15 00:57:28.000000', 'temperatura', 812.0000, 'ºC'),
	(8550, 108, '2015-01-15 00:57:29.000000', 'temperatura', 977.0000, 'ºC'),
	(8551, 108, '2015-01-15 00:57:30.000000', 'temperatura', 47.0000, 'ºC'),
	(8552, 108, '2015-01-15 00:57:31.000000', 'temperatura', 905.0000, 'ºC'),
	(8553, 108, '2015-01-15 00:57:32.000000', 'temperatura', 787.0000, 'ºC'),
	(8554, 108, '2015-01-15 00:57:33.000000', 'temperatura', 17.0000, 'ºC'),
	(8555, 108, '2015-01-15 00:57:34.000000', 'temperatura', 128.0000, 'ºC'),
	(8556, 108, '2015-01-15 00:57:35.000000', 'temperatura', 587.0000, 'ºC'),
	(8557, 108, '2015-01-15 00:57:36.000000', 'temperatura', 154.0000, 'ºC'),
	(8558, 108, '2015-01-15 00:57:37.000000', 'temperatura', 209.0000, 'ºC'),
	(8559, 108, '2015-01-15 00:57:38.000000', 'temperatura', 582.0000, 'ºC'),
	(8560, 108, '2015-01-15 00:57:39.000000', 'temperatura', 1086.0000, 'ºC'),
	(8561, 108, '2015-01-15 00:57:40.000000', 'temperatura', 82.0000, 'ºC'),
	(8562, 108, '2015-01-15 00:57:41.000000', 'temperatura', 754.0000, 'ºC'),
	(8563, 108, '2015-01-15 00:57:42.000000', 'temperatura', 1125.0000, 'ºC'),
	(8564, 108, '2015-01-15 00:57:43.000000', 'temperatura', 961.0000, 'ºC'),
	(8565, 108, '2015-01-15 00:57:44.000000', 'temperatura', 231.0000, 'ºC'),
	(8566, 108, '2015-01-15 00:57:45.000000', 'temperatura', 675.0000, 'ºC'),
	(8567, 108, '2015-01-15 00:57:46.000000', 'temperatura', 282.0000, 'ºC'),
	(8568, 108, '2015-01-15 00:57:47.000000', 'temperatura', 583.0000, 'ºC'),
	(8569, 108, '2015-01-15 00:57:48.000000', 'temperatura', 872.0000, 'ºC'),
	(8570, 108, '2015-01-15 00:57:49.000000', 'temperatura', 212.0000, 'ºC'),
	(8571, 108, '2015-01-15 00:57:50.000000', 'temperatura', 844.0000, 'ºC'),
	(8572, 108, '2015-01-15 00:57:51.000000', 'temperatura', 1186.0000, 'ºC'),
	(8573, 108, '2015-01-15 00:57:52.000000', 'temperatura', 998.0000, 'ºC'),
	(8574, 108, '2015-01-15 00:57:53.000000', 'temperatura', 232.0000, 'ºC'),
	(8575, 108, '2015-01-15 00:57:54.000000', 'temperatura', 566.0000, 'ºC'),
	(8576, 108, '2015-01-15 00:57:55.000000', 'temperatura', 936.0000, 'ºC'),
	(8577, 108, '2015-01-15 00:57:56.000000', 'temperatura', 582.0000, 'ºC'),
	(8578, 108, '2015-01-15 00:57:57.000000', 'temperatura', 102.0000, 'ºC'),
	(8579, 108, '2015-01-15 00:57:58.000000', 'temperatura', 1166.0000, 'ºC'),
	(8580, 108, '2015-01-15 00:57:59.000000', 'temperatura', 725.0000, 'ºC'),
	(8581, 108, '2015-01-15 00:58:00.000000', 'temperatura', 127.0000, 'ºC'),
	(8582, 108, '2015-01-15 00:58:01.000000', 'temperatura', 859.0000, 'ºC'),
	(8583, 108, '2015-01-15 00:58:02.000000', 'temperatura', 316.0000, 'ºC'),
	(8584, 108, '2015-01-15 00:58:03.000000', 'temperatura', 203.0000, 'ºC'),
	(8585, 108, '2015-01-15 00:58:04.000000', 'temperatura', 68.0000, 'ºC'),
	(8586, 108, '2015-01-15 00:58:05.000000', 'temperatura', 929.0000, 'ºC'),
	(8587, 108, '2015-01-15 00:58:06.000000', 'temperatura', 845.0000, 'ºC'),
	(8588, 108, '2015-01-15 00:58:07.000000', 'temperatura', 237.0000, 'ºC'),
	(8589, 108, '2015-01-15 00:58:08.000000', 'temperatura', 1049.0000, 'ºC'),
	(8590, 108, '2015-01-15 00:58:09.000000', 'temperatura', 935.0000, 'ºC'),
	(8591, 108, '2015-01-15 00:58:10.000000', 'temperatura', 329.0000, 'ºC'),
	(8592, 108, '2015-01-15 00:58:11.000000', 'temperatura', 40.0000, 'ºC'),
	(8593, 108, '2015-01-15 00:58:12.000000', 'temperatura', 413.0000, 'ºC'),
	(8594, 108, '2015-01-15 00:58:13.000000', 'temperatura', 746.0000, 'ºC'),
	(8595, 108, '2015-01-15 00:58:14.000000', 'temperatura', 92.0000, 'ºC'),
	(8596, 108, '2015-01-15 00:58:15.000000', 'temperatura', 621.0000, 'ºC'),
	(8597, 108, '2015-01-15 00:58:16.000000', 'temperatura', 429.0000, 'ºC'),
	(8598, 108, '2015-01-15 00:58:17.000000', 'temperatura', 282.0000, 'ºC'),
	(8599, 108, '2015-01-15 00:58:18.000000', 'temperatura', 125.0000, 'ºC'),
	(8600, 108, '2015-01-15 00:58:19.000000', 'temperatura', 978.0000, 'ºC'),
	(8601, 108, '2015-01-15 00:58:20.000000', 'temperatura', 914.0000, 'ºC'),
	(8602, 108, '2015-01-15 00:58:21.000000', 'temperatura', 439.0000, 'ºC'),
	(8603, 108, '2015-01-15 00:58:22.000000', 'temperatura', 652.0000, 'ºC'),
	(8604, 108, '2015-01-15 00:58:23.000000', 'temperatura', 745.0000, 'ºC'),
	(8605, 108, '2015-01-15 00:58:24.000000', 'temperatura', 569.0000, 'ºC'),
	(8606, 108, '2015-01-15 00:58:25.000000', 'temperatura', 611.0000, 'ºC'),
	(8607, 108, '2015-01-15 00:58:26.000000', 'temperatura', 146.0000, 'ºC'),
	(8608, 108, '2015-01-15 00:58:27.000000', 'temperatura', 100.0000, 'ºC'),
	(8609, 108, '2015-01-15 00:58:28.000000', 'temperatura', 63.0000, 'ºC'),
	(8610, 108, '2015-01-15 00:58:29.000000', 'temperatura', 14.0000, 'ºC'),
	(8611, 108, '2015-01-15 00:58:30.000000', 'temperatura', 1083.0000, 'ºC'),
	(8612, 108, '2015-01-15 00:58:31.000000', 'temperatura', 573.0000, 'ºC'),
	(8613, 108, '2015-01-15 00:58:32.000000', 'temperatura', 815.0000, 'ºC'),
	(8614, 108, '2015-01-15 00:58:33.000000', 'temperatura', 1156.0000, 'ºC'),
	(8615, 108, '2015-01-15 00:58:34.000000', 'temperatura', 937.0000, 'ºC'),
	(8616, 108, '2015-01-15 00:58:35.000000', 'temperatura', 16.0000, 'ºC'),
	(8617, 108, '2015-01-15 00:58:36.000000', 'temperatura', 870.0000, 'ºC'),
	(8618, 108, '2015-01-15 00:58:37.000000', 'temperatura', 705.0000, 'ºC'),
	(8619, 108, '2015-01-15 00:58:38.000000', 'temperatura', 912.0000, 'ºC'),
	(8620, 108, '2015-01-15 00:58:39.000000', 'temperatura', 47.0000, 'ºC'),
	(8621, 108, '2015-01-15 00:58:40.000000', 'temperatura', 1098.0000, 'ºC'),
	(8622, 108, '2015-01-15 00:58:41.000000', 'temperatura', 551.0000, 'ºC'),
	(8623, 108, '2015-01-15 00:58:42.000000', 'temperatura', 662.0000, 'ºC'),
	(8624, 108, '2015-01-15 00:58:43.000000', 'temperatura', 457.0000, 'ºC'),
	(8625, 108, '2015-01-15 00:58:44.000000', 'temperatura', 301.0000, 'ºC'),
	(8626, 108, '2015-01-15 00:58:45.000000', 'temperatura', 133.0000, 'ºC'),
	(8627, 108, '2015-01-15 00:58:46.000000', 'temperatura', 961.0000, 'ºC'),
	(8628, 108, '2015-01-15 00:58:47.000000', 'temperatura', 808.0000, 'ºC'),
	(8629, 108, '2015-01-15 00:58:48.000000', 'temperatura', 1159.0000, 'ºC'),
	(8630, 108, '2015-01-15 00:58:49.000000', 'temperatura', 971.0000, 'ºC'),
	(8631, 108, '2015-01-15 00:58:50.000000', 'temperatura', 179.0000, 'ºC'),
	(8632, 108, '2015-01-15 00:58:51.000000', 'temperatura', 382.0000, 'ºC'),
	(8633, 108, '2015-01-15 00:58:52.000000', 'temperatura', 174.0000, 'ºC'),
	(8634, 108, '2015-01-15 00:58:53.000000', 'temperatura', 926.0000, 'ºC'),
	(8635, 108, '2015-01-15 00:58:54.000000', 'temperatura', 507.0000, 'ºC'),
	(8636, 108, '2015-01-15 00:58:55.000000', 'temperatura', 960.0000, 'ºC'),
	(8637, 108, '2015-01-15 00:58:56.000000', 'temperatura', 876.0000, 'ºC'),
	(8638, 108, '2015-01-15 00:58:57.000000', 'temperatura', 301.0000, 'ºC'),
	(8639, 108, '2015-01-15 00:58:58.000000', 'temperatura', 79.0000, 'ºC'),
	(8640, 108, '2015-01-15 00:58:59.000000', 'temperatura', 690.0000, 'ºC'),
	(8641, 108, '2015-01-15 00:59:00.000000', 'temperatura', 813.0000, 'ºC'),
	(8642, 108, '2015-01-15 00:59:01.000000', 'temperatura', 799.0000, 'ºC'),
	(8643, 108, '2015-01-15 00:59:02.000000', 'temperatura', 354.0000, 'ºC'),
	(8644, 108, '2015-01-15 00:59:03.000000', 'temperatura', 574.0000, 'ºC'),
	(8645, 108, '2015-01-15 00:59:04.000000', 'temperatura', 608.0000, 'ºC'),
	(8646, 108, '2015-01-15 00:59:05.000000', 'temperatura', 117.0000, 'ºC'),
	(8647, 108, '2015-01-15 00:59:06.000000', 'temperatura', 1162.0000, 'ºC'),
	(8648, 108, '2015-01-15 00:59:07.000000', 'temperatura', 660.0000, 'ºC'),
	(8649, 108, '2015-01-15 00:59:08.000000', 'temperatura', 1014.0000, 'ºC'),
	(8650, 108, '2015-01-15 00:59:09.000000', 'temperatura', 691.0000, 'ºC'),
	(8651, 108, '2015-01-15 00:59:10.000000', 'temperatura', 414.0000, 'ºC'),
	(8652, 108, '2015-01-15 00:59:11.000000', 'temperatura', 1196.0000, 'ºC'),
	(8653, 108, '2015-01-15 00:59:12.000000', 'temperatura', 1141.0000, 'ºC'),
	(8654, 108, '2015-01-15 00:59:13.000000', 'temperatura', 914.0000, 'ºC'),
	(8655, 108, '2015-01-15 00:59:14.000000', 'temperatura', 1151.0000, 'ºC'),
	(8656, 108, '2015-01-15 00:59:15.000000', 'temperatura', 610.0000, 'ºC'),
	(8657, 108, '2015-01-15 00:59:16.000000', 'temperatura', 800.0000, 'ºC'),
	(8658, 108, '2015-01-15 00:59:17.000000', 'temperatura', 970.0000, 'ºC'),
	(8659, 108, '2015-01-15 00:59:18.000000', 'temperatura', 51.0000, 'ºC'),
	(8660, 108, '2015-01-15 00:59:19.000000', 'temperatura', 943.0000, 'ºC'),
	(8661, 108, '2015-01-15 00:59:20.000000', 'temperatura', 966.0000, 'ºC'),
	(8662, 108, '2015-01-15 00:59:21.000000', 'temperatura', 800.0000, 'ºC'),
	(8663, 108, '2015-01-15 00:59:22.000000', 'temperatura', 1104.0000, 'ºC'),
	(8664, 108, '2015-01-15 00:59:23.000000', 'temperatura', 720.0000, 'ºC'),
	(8665, 108, '2015-01-15 00:59:24.000000', 'temperatura', 288.0000, 'ºC'),
	(8666, 108, '2015-01-15 00:59:25.000000', 'temperatura', 479.0000, 'ºC'),
	(8667, 108, '2015-01-15 00:59:26.000000', 'temperatura', 333.0000, 'ºC'),
	(8668, 108, '2015-01-15 00:59:27.000000', 'temperatura', 227.0000, 'ºC'),
	(8669, 108, '2015-01-15 00:59:28.000000', 'temperatura', 137.0000, 'ºC'),
	(8670, 108, '2015-01-15 00:59:29.000000', 'temperatura', 6.0000, 'ºC'),
	(8671, 108, '2015-01-15 00:59:30.000000', 'temperatura', 819.0000, 'ºC'),
	(8672, 108, '2015-01-15 00:59:31.000000', 'temperatura', 477.0000, 'ºC'),
	(8673, 108, '2015-01-15 00:59:32.000000', 'temperatura', 1128.0000, 'ºC'),
	(8674, 108, '2015-01-15 00:59:33.000000', 'temperatura', 611.0000, 'ºC'),
	(8675, 108, '2015-01-15 00:59:34.000000', 'temperatura', 872.0000, 'ºC'),
	(8676, 108, '2015-01-15 00:59:35.000000', 'temperatura', 126.0000, 'ºC'),
	(8677, 108, '2015-01-15 00:59:36.000000', 'temperatura', 413.0000, 'ºC'),
	(8678, 108, '2015-01-15 00:59:37.000000', 'temperatura', 489.0000, 'ºC'),
	(8679, 108, '2015-01-15 00:59:38.000000', 'temperatura', 7.0000, 'ºC'),
	(8680, 108, '2015-01-15 00:59:39.000000', 'temperatura', 970.0000, 'ºC'),
	(8681, 108, '2015-01-15 00:59:40.000000', 'temperatura', 26.0000, 'ºC'),
	(8682, 108, '2015-01-15 00:59:41.000000', 'temperatura', 823.0000, 'ºC'),
	(8683, 108, '2015-01-15 00:59:42.000000', 'temperatura', 436.0000, 'ºC'),
	(8684, 108, '2015-01-15 00:59:43.000000', 'temperatura', 913.0000, 'ºC'),
	(8685, 108, '2015-01-15 00:59:44.000000', 'temperatura', 855.0000, 'ºC'),
	(8686, 108, '2015-01-15 00:59:45.000000', 'temperatura', 337.0000, 'ºC'),
	(8687, 108, '2015-01-15 00:59:46.000000', 'temperatura', 323.0000, 'ºC'),
	(8688, 108, '2015-01-15 00:59:47.000000', 'temperatura', 602.0000, 'ºC'),
	(8689, 108, '2015-01-15 00:59:48.000000', 'temperatura', 842.0000, 'ºC'),
	(8690, 108, '2015-01-15 00:59:49.000000', 'temperatura', 6.0000, 'ºC'),
	(8691, 108, '2015-01-15 00:59:50.000000', 'temperatura', 1103.0000, 'ºC'),
	(8692, 108, '2015-01-15 00:59:51.000000', 'temperatura', 700.0000, 'ºC'),
	(8693, 108, '2015-01-15 00:59:52.000000', 'temperatura', 188.0000, 'ºC'),
	(8694, 108, '2015-01-15 00:59:53.000000', 'temperatura', 41.0000, 'ºC'),
	(8695, 108, '2015-01-15 00:59:54.000000', 'temperatura', 844.0000, 'ºC'),
	(8696, 108, '2015-01-15 00:59:55.000000', 'temperatura', 497.0000, 'ºC'),
	(8697, 108, '2015-01-15 00:59:56.000000', 'temperatura', 1154.0000, 'ºC'),
	(8698, 108, '2015-01-15 00:59:57.000000', 'temperatura', 679.0000, 'ºC'),
	(8699, 108, '2015-01-15 00:59:58.000000', 'temperatura', 1133.0000, 'ºC'),
	(8700, 108, '2015-01-15 00:59:59.000000', 'temperatura', 29.0000, 'ºC'),
	(8701, 108, '2015-01-15 01:00:00.000000', 'temperatura', 345.0000, 'ºC'),
	(8702, 108, '2015-01-15 01:00:01.000000', 'temperatura', 438.0000, 'ºC'),
	(8703, 108, '2015-01-15 01:00:02.000000', 'temperatura', 1158.0000, 'ºC'),
	(8704, 108, '2015-01-15 01:00:03.000000', 'temperatura', 877.0000, 'ºC'),
	(8705, 108, '2015-01-15 01:00:04.000000', 'temperatura', 910.0000, 'ºC'),
	(8706, 108, '2015-01-15 01:00:05.000000', 'temperatura', 720.0000, 'ºC'),
	(8707, 108, '2015-01-15 01:00:06.000000', 'temperatura', 869.0000, 'ºC'),
	(8708, 108, '2015-01-15 01:00:07.000000', 'temperatura', 987.0000, 'ºC'),
	(8709, 108, '2015-01-15 01:00:08.000000', 'temperatura', 1126.0000, 'ºC'),
	(8710, 108, '2015-01-15 01:00:09.000000', 'temperatura', 271.0000, 'ºC'),
	(8711, 108, '2015-01-15 01:00:10.000000', 'temperatura', 378.0000, 'ºC'),
	(8712, 108, '2015-01-15 01:00:11.000000', 'temperatura', 1075.0000, 'ºC'),
	(8713, 108, '2015-01-15 01:00:12.000000', 'temperatura', 643.0000, 'ºC'),
	(8714, 108, '2015-01-15 01:00:13.000000', 'temperatura', 1192.0000, 'ºC'),
	(8715, 108, '2015-01-15 01:00:14.000000', 'temperatura', 432.0000, 'ºC'),
	(8716, 108, '2015-01-15 01:00:15.000000', 'temperatura', 982.0000, 'ºC'),
	(8717, 108, '2015-01-15 01:00:16.000000', 'temperatura', 15.0000, 'ºC'),
	(8718, 108, '2015-01-15 01:00:17.000000', 'temperatura', 731.0000, 'ºC'),
	(8719, 108, '2015-01-15 01:00:18.000000', 'temperatura', 8.0000, 'ºC'),
	(8720, 108, '2015-01-15 01:00:19.000000', 'temperatura', 250.0000, 'ºC'),
	(8721, 108, '2015-01-15 01:00:20.000000', 'temperatura', 26.0000, 'ºC'),
	(8722, 108, '2015-01-15 01:00:21.000000', 'temperatura', 581.0000, 'ºC'),
	(8723, 108, '2015-01-15 01:00:22.000000', 'temperatura', 427.0000, 'ºC'),
	(8724, 108, '2015-01-15 01:00:23.000000', 'temperatura', 391.0000, 'ºC'),
	(8725, 108, '2015-01-15 01:00:24.000000', 'temperatura', 675.0000, 'ºC'),
	(8726, 108, '2015-01-15 01:00:25.000000', 'temperatura', 1001.0000, 'ºC'),
	(8727, 108, '2015-01-15 01:00:26.000000', 'temperatura', 581.0000, 'ºC'),
	(8728, 108, '2015-01-15 01:00:27.000000', 'temperatura', 1102.0000, 'ºC'),
	(8729, 108, '2015-01-15 01:00:28.000000', 'temperatura', 169.0000, 'ºC'),
	(8730, 108, '2015-01-15 01:00:29.000000', 'temperatura', 1138.0000, 'ºC'),
	(8731, 108, '2015-01-15 01:00:30.000000', 'temperatura', 385.0000, 'ºC'),
	(8732, 108, '2015-01-15 01:00:31.000000', 'temperatura', 910.0000, 'ºC'),
	(8733, 108, '2015-01-15 01:00:32.000000', 'temperatura', 997.0000, 'ºC'),
	(8734, 108, '2015-01-15 01:00:33.000000', 'temperatura', 1055.0000, 'ºC'),
	(8735, 108, '2015-01-15 01:00:34.000000', 'temperatura', 1082.0000, 'ºC'),
	(8736, 108, '2015-01-15 01:00:35.000000', 'temperatura', 1049.0000, 'ºC'),
	(8737, 108, '2015-01-15 01:00:36.000000', 'temperatura', 799.0000, 'ºC'),
	(8738, 108, '2015-01-15 01:00:37.000000', 'temperatura', 848.0000, 'ºC'),
	(8739, 108, '2015-01-15 01:00:38.000000', 'temperatura', 644.0000, 'ºC'),
	(8740, 108, '2015-01-15 01:00:39.000000', 'temperatura', 676.0000, 'ºC'),
	(8741, 108, '2015-01-15 01:00:40.000000', 'temperatura', 248.0000, 'ºC'),
	(8742, 108, '2015-01-15 01:00:41.000000', 'temperatura', 414.0000, 'ºC'),
	(8743, 108, '2015-01-15 01:00:42.000000', 'temperatura', 128.0000, 'ºC'),
	(8744, 108, '2015-01-15 01:00:43.000000', 'temperatura', 596.0000, 'ºC'),
	(8745, 108, '2015-01-15 01:00:44.000000', 'temperatura', 199.0000, 'ºC'),
	(8746, 108, '2015-01-15 01:00:45.000000', 'temperatura', 407.0000, 'ºC'),
	(8747, 108, '2015-01-15 01:00:46.000000', 'temperatura', 237.0000, 'ºC'),
	(8748, 108, '2015-01-15 01:00:47.000000', 'temperatura', 1163.0000, 'ºC'),
	(8749, 108, '2015-01-15 01:00:48.000000', 'temperatura', 307.0000, 'ºC'),
	(8750, 108, '2015-01-15 01:00:49.000000', 'temperatura', 444.0000, 'ºC'),
	(8751, 108, '2015-01-15 01:00:50.000000', 'temperatura', 102.0000, 'ºC'),
	(8752, 108, '2015-01-15 01:00:51.000000', 'temperatura', 378.0000, 'ºC'),
	(8753, 108, '2015-01-15 01:00:52.000000', 'temperatura', 383.0000, 'ºC'),
	(8754, 108, '2015-01-15 01:00:53.000000', 'temperatura', 784.0000, 'ºC'),
	(8755, 108, '2015-01-15 01:00:54.000000', 'temperatura', 368.0000, 'ºC'),
	(8756, 108, '2015-01-15 01:00:55.000000', 'temperatura', 691.0000, 'ºC'),
	(8757, 108, '2015-01-15 01:00:56.000000', 'temperatura', 1151.0000, 'ºC'),
	(8758, 108, '2015-01-15 01:00:57.000000', 'temperatura', 83.0000, 'ºC'),
	(8759, 108, '2015-01-15 01:00:58.000000', 'temperatura', 563.0000, 'ºC'),
	(8760, 108, '2015-01-15 01:00:59.000000', 'temperatura', 168.0000, 'ºC'),
	(8761, 108, '2015-01-15 01:01:00.000000', 'temperatura', 350.0000, 'ºC'),
	(8762, 108, '2015-01-15 01:01:01.000000', 'temperatura', 45.0000, 'ºC'),
	(8763, 108, '2015-01-15 01:01:02.000000', 'temperatura', 376.0000, 'ºC'),
	(8764, 108, '2015-01-15 01:01:03.000000', 'temperatura', 548.0000, 'ºC'),
	(8765, 108, '2015-01-15 01:01:04.000000', 'temperatura', 409.0000, 'ºC'),
	(8766, 108, '2015-01-15 01:01:05.000000', 'temperatura', 402.0000, 'ºC'),
	(8767, 108, '2015-01-15 01:01:06.000000', 'temperatura', 786.0000, 'ºC'),
	(8768, 108, '2015-01-15 01:01:07.000000', 'temperatura', 323.0000, 'ºC'),
	(8769, 108, '2015-01-15 01:01:08.000000', 'temperatura', 459.0000, 'ºC'),
	(8770, 108, '2015-01-15 01:01:09.000000', 'temperatura', 124.0000, 'ºC'),
	(8771, 108, '2015-01-15 01:01:10.000000', 'temperatura', 444.0000, 'ºC'),
	(8772, 108, '2015-01-15 01:01:11.000000', 'temperatura', 651.0000, 'ºC'),
	(8773, 108, '2015-01-15 01:01:12.000000', 'temperatura', 721.0000, 'ºC'),
	(8774, 108, '2015-01-15 01:01:13.000000', 'temperatura', 454.0000, 'ºC'),
	(8775, 108, '2015-01-15 01:01:14.000000', 'temperatura', 109.0000, 'ºC'),
	(8776, 108, '2015-01-15 01:01:15.000000', 'temperatura', 382.0000, 'ºC'),
	(8777, 108, '2015-01-15 01:01:16.000000', 'temperatura', 386.0000, 'ºC'),
	(8778, 108, '2015-01-15 01:01:17.000000', 'temperatura', 781.0000, 'ºC'),
	(8779, 108, '2015-01-15 01:01:18.000000', 'temperatura', 350.0000, 'ºC'),
	(8780, 108, '2015-01-15 01:01:19.000000', 'temperatura', 607.0000, 'ºC'),
	(8781, 108, '2015-01-15 01:01:20.000000', 'temperatura', 783.0000, 'ºC'),
	(8782, 108, '2015-01-15 01:01:21.000000', 'temperatura', 898.0000, 'ºC'),
	(8783, 108, '2015-01-15 01:01:22.000000', 'temperatura', 941.0000, 'ºC'),
	(8784, 108, '2015-01-15 01:01:23.000000', 'temperatura', 810.0000, 'ºC'),
	(8785, 108, '2015-01-15 01:01:24.000000', 'temperatura', 26.0000, 'ºC'),
	(8786, 108, '2015-01-15 01:01:25.000000', 'temperatura', 104.0000, 'ºC'),
	(8787, 108, '2015-01-15 01:01:26.000000', 'temperatura', 441.0000, 'ºC'),
	(8788, 108, '2015-01-15 01:01:27.000000', 'temperatura', 692.0000, 'ºC'),
	(8789, 108, '2015-01-15 01:01:28.000000', 'temperatura', 936.0000, 'ºC'),
	(8790, 108, '2015-01-15 01:01:29.000000', 'temperatura', 208.0000, 'ºC'),
	(8791, 108, '2015-01-15 01:01:30.000000', 'temperatura', 633.0000, 'ºC'),
	(8792, 108, '2015-01-15 01:01:31.000000', 'temperatura', 140.0000, 'ºC'),
	(8793, 108, '2015-01-15 01:01:32.000000', 'temperatura', 4.0000, 'ºC'),
	(8794, 108, '2015-01-15 01:01:33.000000', 'temperatura', 797.0000, 'ºC'),
	(8795, 108, '2015-01-15 01:01:34.000000', 'temperatura', 374.0000, 'ºC'),
	(8796, 108, '2015-01-15 01:01:35.000000', 'temperatura', 681.0000, 'ºC'),
	(8797, 108, '2015-01-15 01:01:36.000000', 'temperatura', 1084.0000, 'ºC'),
	(8798, 108, '2015-01-15 01:01:37.000000', 'temperatura', 977.0000, 'ºC'),
	(8799, 108, '2015-01-15 01:01:38.000000', 'temperatura', 433.0000, 'ºC'),
	(8800, 108, '2015-01-15 01:01:39.000000', 'temperatura', 433.0000, 'ºC'),
	(8801, 108, '2015-01-15 01:01:40.000000', 'temperatura', 867.0000, 'ºC'),
	(8802, 108, '2015-01-15 01:01:41.000000', 'temperatura', 639.0000, 'ºC'),
	(8803, 108, '2015-01-15 01:01:42.000000', 'temperatura', 594.0000, 'ºC'),
	(8804, 108, '2015-01-15 01:01:43.000000', 'temperatura', 1051.0000, 'ºC'),
	(8805, 108, '2015-01-15 01:01:44.000000', 'temperatura', 1074.0000, 'ºC'),
	(8806, 108, '2015-01-15 01:01:45.000000', 'temperatura', 1017.0000, 'ºC'),
	(8807, 108, '2015-01-15 01:01:46.000000', 'temperatura', 666.0000, 'ºC'),
	(8808, 108, '2015-01-15 01:01:47.000000', 'temperatura', 277.0000, 'ºC'),
	(8809, 108, '2015-01-15 01:01:48.000000', 'temperatura', 588.0000, 'ºC'),
	(8810, 108, '2015-01-15 01:01:49.000000', 'temperatura', 912.0000, 'ºC'),
	(8811, 108, '2015-01-15 01:01:50.000000', 'temperatura', 394.0000, 'ºC'),
	(8812, 108, '2015-01-15 01:01:51.000000', 'temperatura', 436.0000, 'ºC'),
	(8813, 108, '2015-01-15 01:01:52.000000', 'temperatura', 998.0000, 'ºC'),
	(8814, 108, '2015-01-15 01:01:53.000000', 'temperatura', 81.0000, 'ºC'),
	(8815, 108, '2015-01-15 01:01:54.000000', 'temperatura', 1014.0000, 'ºC'),
	(8816, 108, '2015-01-15 01:01:55.000000', 'temperatura', 26.0000, 'ºC'),
	(8817, 108, '2015-01-15 01:01:56.000000', 'temperatura', 688.0000, 'ºC'),
	(8818, 108, '2015-01-15 01:01:57.000000', 'temperatura', 964.0000, 'ºC'),
	(8819, 108, '2015-01-15 01:01:58.000000', 'temperatura', 354.0000, 'ºC'),
	(8820, 108, '2015-01-15 01:01:59.000000', 'temperatura', 80.0000, 'ºC'),
	(8821, 108, '2015-01-15 01:02:00.000000', 'temperatura', 540.0000, 'ºC'),
	(8822, 108, '2015-01-15 01:02:01.000000', 'temperatura', 58.0000, 'ºC'),
	(8823, 108, '2015-01-15 01:02:02.000000', 'temperatura', 1070.0000, 'ºC'),
	(8824, 108, '2015-01-15 01:02:03.000000', 'temperatura', 379.0000, 'ºC'),
	(8825, 108, '2015-01-15 01:02:04.000000', 'temperatura', 1086.0000, 'ºC'),
	(8826, 108, '2015-01-15 01:02:05.000000', 'temperatura', 692.0000, 'ºC'),
	(8827, 108, '2015-01-15 01:02:06.000000', 'temperatura', 203.0000, 'ºC'),
	(8828, 108, '2015-01-15 01:02:07.000000', 'temperatura', 138.0000, 'ºC'),
	(8829, 108, '2015-01-15 01:02:08.000000', 'temperatura', 82.0000, 'ºC'),
	(8830, 108, '2015-01-15 01:02:09.000000', 'temperatura', 1196.0000, 'ºC'),
	(8831, 108, '2015-01-15 01:02:10.000000', 'temperatura', 935.0000, 'ºC'),
	(8832, 108, '2015-01-15 01:02:11.000000', 'temperatura', 1089.0000, 'ºC'),
	(8833, 108, '2015-01-15 01:02:12.000000', 'temperatura', 238.0000, 'ºC'),
	(8834, 108, '2015-01-15 01:02:13.000000', 'temperatura', 324.0000, 'ºC'),
	(8835, 108, '2015-01-15 01:02:14.000000', 'temperatura', 908.0000, 'ºC'),
	(8836, 108, '2015-01-15 01:02:15.000000', 'temperatura', 1168.0000, 'ºC'),
	(8837, 108, '2015-01-15 01:02:16.000000', 'temperatura', 716.0000, 'ºC'),
	(8838, 108, '2015-01-15 01:02:17.000000', 'temperatura', 78.0000, 'ºC'),
	(8839, 108, '2015-01-15 01:02:18.000000', 'temperatura', 640.0000, 'ºC'),
	(8840, 108, '2015-01-15 01:02:19.000000', 'temperatura', 569.0000, 'ºC'),
	(8841, 108, '2015-01-15 01:02:20.000000', 'temperatura', 925.0000, 'ºC'),
	(8842, 108, '2015-01-15 01:02:21.000000', 'temperatura', 518.0000, 'ºC'),
	(8843, 108, '2015-01-15 01:02:22.000000', 'temperatura', 1014.0000, 'ºC'),
	(8844, 108, '2015-01-15 01:02:23.000000', 'temperatura', 1118.0000, 'ºC'),
	(8845, 108, '2015-01-15 01:02:24.000000', 'temperatura', 149.0000, 'ºC'),
	(8846, 108, '2015-01-15 01:02:25.000000', 'temperatura', 990.0000, 'ºC'),
	(8847, 108, '2015-01-15 01:02:26.000000', 'temperatura', 905.0000, 'ºC'),
	(8848, 108, '2015-01-15 01:02:27.000000', 'temperatura', 356.0000, 'ºC'),
	(8849, 108, '2015-01-15 01:02:28.000000', 'temperatura', 264.0000, 'ºC'),
	(8850, 108, '2015-01-15 01:02:29.000000', 'temperatura', 254.0000, 'ºC'),
	(8851, 108, '2015-01-15 01:02:30.000000', 'temperatura', 479.0000, 'ºC'),
	(8852, 108, '2015-01-15 01:02:31.000000', 'temperatura', 434.0000, 'ºC'),
	(8853, 108, '2015-01-15 01:02:32.000000', 'temperatura', 731.0000, 'ºC'),
	(8854, 108, '2015-01-15 01:02:33.000000', 'temperatura', 1155.0000, 'ºC'),
	(8855, 108, '2015-01-15 01:02:34.000000', 'temperatura', 1181.0000, 'ºC'),
	(8856, 108, '2015-01-15 01:02:35.000000', 'temperatura', 41.0000, 'ºC'),
	(8857, 108, '2015-01-15 01:02:36.000000', 'temperatura', 261.0000, 'ºC'),
	(8858, 108, '2015-01-15 01:02:37.000000', 'temperatura', 1184.0000, 'ºC'),
	(8859, 108, '2015-01-15 01:02:38.000000', 'temperatura', 335.0000, 'ºC'),
	(8860, 108, '2015-01-15 01:02:39.000000', 'temperatura', 527.0000, 'ºC'),
	(8861, 108, '2015-01-15 01:02:40.000000', 'temperatura', 430.0000, 'ºC'),
	(8862, 108, '2015-01-15 01:02:41.000000', 'temperatura', 567.0000, 'ºC'),
	(8863, 108, '2015-01-15 01:02:42.000000', 'temperatura', 347.0000, 'ºC'),
	(8864, 108, '2015-01-15 01:02:43.000000', 'temperatura', 32.0000, 'ºC'),
	(8865, 108, '2015-01-15 01:02:44.000000', 'temperatura', 323.0000, 'ºC'),
	(8866, 108, '2015-01-15 01:02:45.000000', 'temperatura', 318.0000, 'ºC'),
	(8867, 108, '2015-01-15 01:02:46.000000', 'temperatura', 620.0000, 'ºC'),
	(8868, 108, '2015-01-15 01:02:47.000000', 'temperatura', 946.0000, 'ºC'),
	(8869, 108, '2015-01-15 01:02:48.000000', 'temperatura', 471.0000, 'ºC'),
	(8870, 108, '2015-01-15 01:02:49.000000', 'temperatura', 717.0000, 'ºC'),
	(8871, 108, '2015-01-15 01:02:50.000000', 'temperatura', 975.0000, 'ºC'),
	(8872, 108, '2015-01-15 01:02:51.000000', 'temperatura', 322.0000, 'ºC'),
	(8873, 108, '2015-01-15 01:02:52.000000', 'temperatura', 1088.0000, 'ºC'),
	(8874, 108, '2015-01-15 01:02:53.000000', 'temperatura', 875.0000, 'ºC'),
	(8875, 108, '2015-01-15 01:02:54.000000', 'temperatura', 1110.0000, 'ºC'),
	(8876, 108, '2015-01-15 01:02:55.000000', 'temperatura', 528.0000, 'ºC'),
	(8877, 108, '2015-01-15 01:02:56.000000', 'temperatura', 507.0000, 'ºC'),
	(8878, 108, '2015-01-15 01:02:57.000000', 'temperatura', 953.0000, 'ºC'),
	(8879, 108, '2015-01-15 01:02:58.000000', 'temperatura', 846.0000, 'ºC'),
	(8880, 108, '2015-01-15 01:02:59.000000', 'temperatura', 171.0000, 'ºC'),
	(8881, 108, '2015-01-15 01:03:00.000000', 'temperatura', 718.0000, 'ºC'),
	(8882, 108, '2015-01-15 01:03:01.000000', 'temperatura', 677.0000, 'ºC'),
	(8883, 108, '2015-01-15 01:03:02.000000', 'temperatura', 33.0000, 'ºC'),
	(8884, 108, '2015-01-15 01:03:03.000000', 'temperatura', 532.0000, 'ºC'),
	(8885, 108, '2015-01-15 01:03:04.000000', 'temperatura', 164.0000, 'ºC'),
	(8886, 108, '2015-01-15 01:03:05.000000', 'temperatura', 425.0000, 'ºC'),
	(8887, 108, '2015-01-15 01:03:06.000000', 'temperatura', 434.0000, 'ºC'),
	(8888, 108, '2015-01-15 01:03:07.000000', 'temperatura', 894.0000, 'ºC'),
	(8889, 108, '2015-01-15 01:03:08.000000', 'temperatura', 768.0000, 'ºC'),
	(8890, 108, '2015-01-15 01:03:09.000000', 'temperatura', 1161.0000, 'ºC'),
	(8891, 108, '2015-01-15 01:03:10.000000', 'temperatura', 1101.0000, 'ºC'),
	(8892, 108, '2015-01-15 01:03:11.000000', 'temperatura', 821.0000, 'ºC'),
	(8893, 108, '2015-01-15 01:03:12.000000', 'temperatura', 802.0000, 'ºC'),
	(8894, 108, '2015-01-15 01:03:13.000000', 'temperatura', 347.0000, 'ºC'),
	(8895, 108, '2015-01-15 01:03:14.000000', 'temperatura', 530.0000, 'ºC'),
	(8896, 108, '2015-01-15 01:03:15.000000', 'temperatura', 409.0000, 'ºC'),
	(8897, 108, '2015-01-15 01:03:16.000000', 'temperatura', 455.0000, 'ºC'),
	(8898, 108, '2015-01-15 01:03:17.000000', 'temperatura', 1050.0000, 'ºC'),
	(8899, 108, '2015-01-15 01:03:18.000000', 'temperatura', 286.0000, 'ºC'),
	(8900, 108, '2015-01-15 01:03:19.000000', 'temperatura', 678.0000, 'ºC'),
	(8901, 108, '2015-01-15 01:03:20.000000', 'temperatura', 134.0000, 'ºC'),
	(8902, 108, '2015-01-15 01:03:21.000000', 'temperatura', 1036.0000, 'ºC'),
	(8903, 108, '2015-01-15 01:03:22.000000', 'temperatura', 1180.0000, 'ºC'),
	(8904, 108, '2015-01-15 01:03:23.000000', 'temperatura', 394.0000, 'ºC'),
	(8905, 108, '2015-01-15 01:03:24.000000', 'temperatura', 827.0000, 'ºC'),
	(8906, 108, '2015-01-15 01:03:25.000000', 'temperatura', 554.0000, 'ºC'),
	(8907, 108, '2015-01-15 01:03:26.000000', 'temperatura', 288.0000, 'ºC'),
	(8908, 108, '2015-01-15 01:03:27.000000', 'temperatura', 982.0000, 'ºC'),
	(8909, 108, '2015-01-15 01:03:28.000000', 'temperatura', 444.0000, 'ºC'),
	(8910, 108, '2015-01-15 01:03:29.000000', 'temperatura', 474.0000, 'ºC'),
	(8911, 108, '2015-01-15 01:03:30.000000', 'temperatura', 1038.0000, 'ºC'),
	(8912, 108, '2015-01-15 01:03:31.000000', 'temperatura', 169.0000, 'ºC'),
	(8913, 108, '2015-01-15 01:03:32.000000', 'temperatura', 131.0000, 'ºC'),
	(8914, 108, '2015-01-15 01:03:33.000000', 'temperatura', 149.0000, 'ºC'),
	(8915, 108, '2015-01-15 01:03:34.000000', 'temperatura', 354.0000, 'ºC'),
	(8916, 108, '2015-01-15 01:03:35.000000', 'temperatura', 122.0000, 'ºC'),
	(8917, 108, '2015-01-15 01:03:36.000000', 'temperatura', 750.0000, 'ºC'),
	(8918, 108, '2015-01-15 01:03:37.000000', 'temperatura', 985.0000, 'ºC'),
	(8919, 108, '2015-01-15 01:03:38.000000', 'temperatura', 276.0000, 'ºC'),
	(8920, 108, '2015-01-15 01:03:39.000000', 'temperatura', 824.0000, 'ºC'),
	(8921, 108, '2015-01-15 01:03:40.000000', 'temperatura', 893.0000, 'ºC'),
	(8922, 108, '2015-01-15 01:03:41.000000', 'temperatura', 793.0000, 'ºC'),
	(8923, 108, '2015-01-15 01:03:42.000000', 'temperatura', 89.0000, 'ºC'),
	(8924, 108, '2015-01-15 01:03:43.000000', 'temperatura', 464.0000, 'ºC'),
	(8925, 108, '2015-01-15 01:03:44.000000', 'temperatura', 854.0000, 'ºC'),
	(8926, 108, '2015-01-15 01:03:45.000000', 'temperatura', 477.0000, 'ºC'),
	(8927, 108, '2015-01-15 01:03:46.000000', 'temperatura', 1023.0000, 'ºC'),
	(8928, 108, '2015-01-15 01:03:47.000000', 'temperatura', 85.0000, 'ºC'),
	(8929, 108, '2015-01-15 01:03:48.000000', 'temperatura', 955.0000, 'ºC'),
	(8930, 108, '2015-01-15 01:03:49.000000', 'temperatura', 923.0000, 'ºC'),
	(8931, 108, '2015-01-15 01:03:50.000000', 'temperatura', 548.0000, 'ºC'),
	(8932, 108, '2015-01-15 01:03:51.000000', 'temperatura', 1171.0000, 'ºC'),
	(8933, 108, '2015-01-15 01:03:52.000000', 'temperatura', 613.0000, 'ºC'),
	(8934, 108, '2015-01-15 01:03:53.000000', 'temperatura', 754.0000, 'ºC'),
	(8935, 108, '2015-01-15 01:03:54.000000', 'temperatura', 729.0000, 'ºC'),
	(8936, 108, '2015-01-15 01:03:55.000000', 'temperatura', 186.0000, 'ºC'),
	(8937, 108, '2015-01-15 01:03:56.000000', 'temperatura', 1140.0000, 'ºC'),
	(8938, 108, '2015-01-15 01:03:57.000000', 'temperatura', 346.0000, 'ºC'),
	(8939, 108, '2015-01-15 01:03:58.000000', 'temperatura', 709.0000, 'ºC'),
	(8940, 108, '2015-01-15 01:03:59.000000', 'temperatura', 109.0000, 'ºC'),
	(8941, 108, '2015-01-15 01:04:00.000000', 'temperatura', 818.0000, 'ºC'),
	(8942, 108, '2015-01-15 01:04:01.000000', 'temperatura', 165.0000, 'ºC'),
	(8943, 108, '2015-01-15 01:04:02.000000', 'temperatura', 770.0000, 'ºC'),
	(8944, 108, '2015-01-15 01:04:03.000000', 'temperatura', 957.0000, 'ºC'),
	(8945, 108, '2015-01-15 01:04:04.000000', 'temperatura', 75.0000, 'ºC'),
	(8946, 108, '2015-01-15 01:04:05.000000', 'temperatura', 1106.0000, 'ºC'),
	(8947, 108, '2015-01-15 01:04:06.000000', 'temperatura', 503.0000, 'ºC'),
	(8948, 108, '2015-01-15 01:04:07.000000', 'temperatura', 397.0000, 'ºC'),
	(8949, 108, '2015-01-15 01:04:08.000000', 'temperatura', 478.0000, 'ºC'),
	(8950, 108, '2015-01-15 01:04:09.000000', 'temperatura', 1198.0000, 'ºC'),
	(8951, 108, '2015-01-15 01:04:10.000000', 'temperatura', 955.0000, 'ºC'),
	(8952, 108, '2015-01-15 01:04:11.000000', 'temperatura', 1184.0000, 'ºC'),
	(8953, 108, '2015-01-15 01:04:12.000000', 'temperatura', 655.0000, 'ºC'),
	(8954, 108, '2015-01-15 01:04:13.000000', 'temperatura', 925.0000, 'ºC'),
	(8955, 108, '2015-01-15 01:04:14.000000', 'temperatura', 257.0000, 'ºC'),
	(8956, 108, '2015-01-15 01:04:15.000000', 'temperatura', 914.0000, 'ºC'),
	(8957, 108, '2015-01-15 01:04:16.000000', 'temperatura', 197.0000, 'ºC'),
	(8958, 108, '2015-01-15 01:04:17.000000', 'temperatura', 642.0000, 'ºC'),
	(8959, 108, '2015-01-15 01:04:18.000000', 'temperatura', 222.0000, 'ºC'),
	(8960, 108, '2015-01-15 01:04:19.000000', 'temperatura', 385.0000, 'ºC'),
	(8961, 108, '2015-01-15 01:04:20.000000', 'temperatura', 59.0000, 'ºC'),
	(8962, 108, '2015-01-15 01:04:21.000000', 'temperatura', 340.0000, 'ºC'),
	(8963, 108, '2015-01-15 01:04:22.000000', 'temperatura', 325.0000, 'ºC'),
	(8964, 108, '2015-01-15 01:04:23.000000', 'temperatura', 606.0000, 'ºC'),
	(8965, 108, '2015-01-15 01:04:24.000000', 'temperatura', 853.0000, 'ºC'),
	(8966, 108, '2015-01-15 01:04:25.000000', 'temperatura', 50.0000, 'ºC'),
	(8967, 108, '2015-01-15 01:04:26.000000', 'temperatura', 91.0000, 'ºC'),
	(8968, 108, '2015-01-15 01:04:27.000000', 'temperatura', 306.0000, 'ºC'),
	(8969, 108, '2015-01-15 01:04:28.000000', 'temperatura', 58.0000, 'ºC'),
	(8970, 108, '2015-01-15 01:04:29.000000', 'temperatura', 573.0000, 'ºC'),
	(8971, 108, '2015-01-15 01:04:30.000000', 'temperatura', 290.0000, 'ºC'),
	(8972, 108, '2015-01-15 01:04:31.000000', 'temperatura', 932.0000, 'ºC'),
	(8973, 108, '2015-01-15 01:04:32.000000', 'temperatura', 191.0000, 'ºC'),
	(8974, 108, '2015-01-15 01:04:33.000000', 'temperatura', 558.0000, 'ºC'),
	(8975, 108, '2015-01-15 01:04:34.000000', 'temperatura', 1019.0000, 'ºC'),
	(8976, 108, '2015-01-15 01:04:35.000000', 'temperatura', 1022.0000, 'ºC'),
	(8977, 108, '2015-01-15 01:04:36.000000', 'temperatura', 854.0000, 'ºC'),
	(8978, 108, '2015-01-15 01:04:37.000000', 'temperatura', 4.0000, 'ºC'),
	(8979, 108, '2015-01-15 01:04:38.000000', 'temperatura', 1056.0000, 'ºC'),
	(8980, 108, '2015-01-15 01:04:39.000000', 'temperatura', 472.0000, 'ºC'),
	(8981, 108, '2015-01-15 01:04:40.000000', 'temperatura', 389.0000, 'ºC'),
	(8982, 108, '2015-01-15 01:04:41.000000', 'temperatura', 531.0000, 'ºC'),
	(8983, 108, '2015-01-15 01:04:42.000000', 'temperatura', 290.0000, 'ºC'),
	(8984, 108, '2015-01-15 01:04:43.000000', 'temperatura', 1056.0000, 'ºC'),
	(8985, 108, '2015-01-15 01:04:44.000000', 'temperatura', 810.0000, 'ºC'),
	(8986, 108, '2015-01-15 01:04:45.000000', 'temperatura', 882.0000, 'ºC'),
	(8987, 108, '2015-01-15 01:04:46.000000', 'temperatura', 779.0000, 'ºC'),
	(8988, 108, '2015-01-15 01:04:47.000000', 'temperatura', 51.0000, 'ºC'),
	(8989, 108, '2015-01-15 01:04:48.000000', 'temperatura', 321.0000, 'ºC'),
	(8990, 108, '2015-01-15 01:04:49.000000', 'temperatura', 249.0000, 'ºC'),
	(8991, 108, '2015-01-15 01:04:50.000000', 'temperatura', 285.0000, 'ºC'),
	(8992, 108, '2015-01-15 01:04:51.000000', 'temperatura', 676.0000, 'ºC'),
	(8993, 108, '2015-01-15 01:04:52.000000', 'temperatura', 125.0000, 'ºC'),
	(8994, 108, '2015-01-15 01:04:53.000000', 'temperatura', 999.0000, 'ºC'),
	(8995, 108, '2015-01-15 01:04:54.000000', 'temperatura', 1019.0000, 'ºC'),
	(8996, 108, '2015-01-15 01:04:55.000000', 'temperatura', 898.0000, 'ºC'),
	(8997, 108, '2015-01-15 01:04:56.000000', 'temperatura', 234.0000, 'ºC'),
	(8998, 108, '2015-01-15 01:04:57.000000', 'temperatura', 876.0000, 'ºC'),
	(8999, 108, '2015-01-15 01:04:58.000000', 'temperatura', 77.0000, 'ºC'),
	(9000, 108, '2015-01-15 01:04:59.000000', 'temperatura', 159.0000, 'ºC'),
	(9001, 108, '2015-01-15 01:05:00.000000', 'temperatura', 566.0000, 'ºC'),
	(9002, 108, '2015-01-15 01:05:01.000000', 'temperatura', 1154.0000, 'ºC'),
	(9003, 108, '2015-01-15 01:05:02.000000', 'temperatura', 472.0000, 'ºC'),
	(9004, 108, '2015-01-15 01:05:03.000000', 'temperatura', 97.0000, 'ºC'),
	(9005, 108, '2015-01-15 01:05:04.000000', 'temperatura', 270.0000, 'ºC'),
	(9006, 108, '2015-01-15 01:05:05.000000', 'temperatura', 1061.0000, 'ºC'),
	(9007, 108, '2015-01-15 01:05:06.000000', 'temperatura', 894.0000, 'ºC'),
	(9008, 108, '2015-01-15 01:05:07.000000', 'temperatura', 89.0000, 'ºC'),
	(9009, 108, '2015-01-15 01:05:08.000000', 'temperatura', 162.0000, 'ºC'),
	(9010, 108, '2015-01-15 01:05:09.000000', 'temperatura', 545.0000, 'ºC'),
	(9011, 108, '2015-01-15 01:05:10.000000', 'temperatura', 1037.0000, 'ºC'),
	(9012, 108, '2015-01-15 01:05:11.000000', 'temperatura', 1153.0000, 'ºC'),
	(9013, 108, '2015-01-15 01:05:12.000000', 'temperatura', 253.0000, 'ºC'),
	(9014, 108, '2015-01-15 01:05:13.000000', 'temperatura', 206.0000, 'ºC'),
	(9015, 108, '2015-01-15 01:05:14.000000', 'temperatura', 274.0000, 'ºC'),
	(9016, 108, '2015-01-15 01:05:15.000000', 'temperatura', 751.0000, 'ºC'),
	(9017, 108, '2015-01-15 01:05:16.000000', 'temperatura', 534.0000, 'ºC'),
	(9018, 108, '2015-01-15 01:05:17.000000', 'temperatura', 418.0000, 'ºC'),
	(9019, 108, '2015-01-15 01:05:18.000000', 'temperatura', 490.0000, 'ºC'),
	(9020, 108, '2015-01-15 01:05:19.000000', 'temperatura', 1194.0000, 'ºC'),
	(9021, 108, '2015-01-15 01:05:20.000000', 'temperatura', 900.0000, 'ºC'),
	(9022, 108, '2015-01-15 01:05:21.000000', 'temperatura', 919.0000, 'ºC'),
	(9023, 108, '2015-01-15 01:05:22.000000', 'temperatura', 695.0000, 'ºC'),
	(9024, 108, '2015-01-15 01:05:23.000000', 'temperatura', 719.0000, 'ºC'),
	(9025, 108, '2015-01-15 01:05:24.000000', 'temperatura', 309.0000, 'ºC'),
	(9026, 108, '2015-01-15 01:05:25.000000', 'temperatura', 590.0000, 'ºC'),
	(9027, 108, '2015-01-15 01:05:26.000000', 'temperatura', 824.0000, 'ºC'),
	(9028, 108, '2015-01-15 01:05:27.000000', 'temperatura', 1150.0000, 'ºC'),
	(9029, 108, '2015-01-15 01:05:28.000000', 'temperatura', 878.0000, 'ºC'),
	(9030, 108, '2015-01-15 01:05:29.000000', 'temperatura', 940.0000, 'ºC'),
	(9031, 108, '2015-01-15 01:05:30.000000', 'temperatura', 868.0000, 'ºC'),
	(9032, 108, '2015-01-15 01:05:31.000000', 'temperatura', 319.0000, 'ºC'),
	(9033, 108, '2015-01-15 01:05:32.000000', 'temperatura', 194.0000, 'ºC'),
	(9034, 108, '2015-01-15 01:05:33.000000', 'temperatura', 11.0000, 'ºC'),
	(9035, 108, '2015-01-15 01:05:34.000000', 'temperatura', 675.0000, 'ºC'),
	(9036, 108, '2015-01-15 01:05:35.000000', 'temperatura', 943.0000, 'ºC'),
	(9037, 108, '2015-01-15 01:05:36.000000', 'temperatura', 288.0000, 'ºC'),
	(9038, 108, '2015-01-15 01:05:37.000000', 'temperatura', 1012.0000, 'ºC'),
	(9039, 108, '2015-01-15 01:05:38.000000', 'temperatura', 596.0000, 'ºC'),
	(9040, 108, '2015-01-15 01:05:39.000000', 'temperatura', 1146.0000, 'ºC'),
	(9041, 108, '2015-01-15 01:05:40.000000', 'temperatura', 343.0000, 'ºC'),
	(9042, 108, '2015-01-15 01:05:41.000000', 'temperatura', 679.0000, 'ºC'),
	(9043, 108, '2015-01-15 01:05:42.000000', 'temperatura', 1163.0000, 'ºC'),
	(9044, 108, '2015-01-15 01:05:43.000000', 'temperatura', 181.0000, 'ºC'),
	(9045, 108, '2015-01-15 01:05:44.000000', 'temperatura', 1015.0000, 'ºC'),
	(9046, 108, '2015-01-15 01:05:45.000000', 'temperatura', 935.0000, 'ºC'),
	(9047, 108, '2015-01-15 01:05:46.000000', 'temperatura', 427.0000, 'ºC'),
	(9048, 108, '2015-01-15 01:05:47.000000', 'temperatura', 532.0000, 'ºC'),
	(9049, 108, '2015-01-15 01:05:48.000000', 'temperatura', 179.0000, 'ºC'),
	(9050, 108, '2015-01-15 01:05:49.000000', 'temperatura', 498.0000, 'ºC'),
	(9051, 108, '2015-01-15 01:05:50.000000', 'temperatura', 757.0000, 'ºC'),
	(9052, 108, '2015-01-15 01:05:51.000000', 'temperatura', 1089.0000, 'ºC'),
	(9053, 108, '2015-01-15 01:05:52.000000', 'temperatura', 775.0000, 'ºC'),
	(9054, 108, '2015-01-15 01:05:53.000000', 'temperatura', 609.0000, 'ºC'),
	(9055, 108, '2015-01-15 01:05:54.000000', 'temperatura', 722.0000, 'ºC'),
	(9056, 108, '2015-01-15 01:05:55.000000', 'temperatura', 581.0000, 'ºC'),
	(9057, 108, '2015-01-15 01:05:56.000000', 'temperatura', 740.0000, 'ºC'),
	(9058, 108, '2015-01-15 01:05:57.000000', 'temperatura', 757.0000, 'ºC'),
	(9059, 108, '2015-01-15 01:05:58.000000', 'temperatura', 364.0000, 'ºC'),
	(9060, 108, '2015-01-15 01:05:59.000000', 'temperatura', 751.0000, 'ºC'),
	(9061, 108, '2015-01-15 01:06:00.000000', 'temperatura', 265.0000, 'ºC'),
	(9062, 108, '2015-01-15 01:06:01.000000', 'temperatura', 272.0000, 'ºC'),
	(9063, 108, '2015-01-15 01:06:02.000000', 'temperatura', 565.0000, 'ºC'),
	(9064, 108, '2015-01-15 01:06:03.000000', 'temperatura', 812.0000, 'ºC'),
	(9065, 108, '2015-01-15 01:06:04.000000', 'temperatura', 1162.0000, 'ºC'),
	(9066, 108, '2015-01-15 01:06:05.000000', 'temperatura', 975.0000, 'ºC'),
	(9067, 108, '2015-01-15 01:06:06.000000', 'temperatura', 191.0000, 'ºC'),
	(9068, 108, '2015-01-15 01:06:07.000000', 'temperatura', 428.0000, 'ºC'),
	(9069, 108, '2015-01-15 01:06:08.000000', 'temperatura', 369.0000, 'ºC'),
	(9070, 108, '2015-01-15 01:06:09.000000', 'temperatura', 560.0000, 'ºC'),
	(9071, 108, '2015-01-15 01:06:10.000000', 'temperatura', 493.0000, 'ºC'),
	(9072, 108, '2015-01-15 01:06:11.000000', 'temperatura', 787.0000, 'ºC'),
	(9073, 108, '2015-01-15 01:06:12.000000', 'temperatura', 58.0000, 'ºC'),
	(9074, 108, '2015-01-15 01:06:13.000000', 'temperatura', 326.0000, 'ºC'),
	(9075, 108, '2015-01-15 01:06:14.000000', 'temperatura', 258.0000, 'ºC'),
	(9076, 108, '2015-01-15 01:06:15.000000', 'temperatura', 314.0000, 'ºC'),
	(9077, 108, '2015-01-15 01:06:16.000000', 'temperatura', 795.0000, 'ºC'),
	(9078, 108, '2015-01-15 01:06:17.000000', 'temperatura', 634.0000, 'ºC'),
	(9079, 108, '2015-01-15 01:06:18.000000', 'temperatura', 785.0000, 'ºC'),
	(9080, 108, '2015-01-15 01:06:19.000000', 'temperatura', 822.0000, 'ºC'),
	(9081, 108, '2015-01-15 01:06:20.000000', 'temperatura', 556.0000, 'ºC'),
	(9082, 108, '2015-01-15 01:06:21.000000', 'temperatura', 317.0000, 'ºC'),
	(9083, 108, '2015-01-15 01:06:22.000000', 'temperatura', 1115.0000, 'ºC'),
	(9084, 108, '2015-01-15 01:06:23.000000', 'temperatura', 1026.0000, 'ºC'),
	(9085, 108, '2015-01-15 01:06:24.000000', 'temperatura', 585.0000, 'ºC'),
	(9086, 108, '2015-01-15 01:06:25.000000', 'temperatura', 1050.0000, 'ºC'),
	(9087, 108, '2015-01-15 01:06:26.000000', 'temperatura', 1092.0000, 'ºC'),
	(9088, 108, '2015-01-15 01:06:27.000000', 'temperatura', 1112.0000, 'ºC'),
	(9089, 108, '2015-01-15 01:06:28.000000', 'temperatura', 1084.0000, 'ºC'),
	(9090, 108, '2015-01-15 01:06:29.000000', 'temperatura', 885.0000, 'ºC'),
	(9091, 108, '2015-01-15 01:06:30.000000', 'temperatura', 1174.0000, 'ºC'),
	(9092, 108, '2015-01-15 01:06:31.000000', 'temperatura', 816.0000, 'ºC'),
	(9093, 108, '2015-01-15 01:06:32.000000', 'temperatura', 558.0000, 'ºC'),
	(9094, 108, '2015-01-15 01:06:33.000000', 'temperatura', 344.0000, 'ºC'),
	(9095, 108, '2015-01-15 01:06:34.000000', 'temperatura', 45.0000, 'ºC'),
	(9096, 108, '2015-01-15 01:06:35.000000', 'temperatura', 392.0000, 'ºC'),
	(9097, 108, '2015-01-15 01:06:36.000000', 'temperatura', 626.0000, 'ºC'),
	(9098, 108, '2015-01-15 01:06:37.000000', 'temperatura', 757.0000, 'ºC'),
	(9099, 108, '2015-01-15 01:06:38.000000', 'temperatura', 706.0000, 'ºC'),
	(9100, 108, '2015-01-15 01:06:39.000000', 'temperatura', 60.0000, 'ºC'),
	(9101, 108, '2015-01-15 01:06:40.000000', 'temperatura', 583.0000, 'ºC'),
	(9102, 108, '2015-01-15 01:06:41.000000', 'temperatura', 337.0000, 'ºC'),
	(9103, 108, '2015-01-15 01:06:42.000000', 'temperatura', 1135.0000, 'ºC'),
	(9104, 108, '2015-01-15 01:06:43.000000', 'temperatura', 1066.0000, 'ºC'),
	(9105, 108, '2015-01-15 01:06:44.000000', 'temperatura', 724.0000, 'ºC'),
	(9106, 108, '2015-01-15 01:06:45.000000', 'temperatura', 422.0000, 'ºC'),
	(9107, 108, '2015-01-15 01:06:46.000000', 'temperatura', 1140.0000, 'ºC'),
	(9108, 108, '2015-01-15 01:06:47.000000', 'temperatura', 832.0000, 'ºC'),
	(9109, 108, '2015-01-15 01:06:48.000000', 'temperatura', 742.0000, 'ºC'),
	(9110, 108, '2015-01-15 01:06:49.000000', 'temperatura', 12.0000, 'ºC'),
	(9111, 108, '2015-01-15 01:06:50.000000', 'temperatura', 237.0000, 'ºC'),
	(9112, 108, '2015-01-15 01:06:51.000000', 'temperatura', 1150.0000, 'ºC'),
	(9113, 108, '2015-01-15 01:06:52.000000', 'temperatura', 240.0000, 'ºC'),
	(9114, 108, '2015-01-15 01:06:53.000000', 'temperatura', 151.0000, 'ºC'),
	(9115, 108, '2015-01-15 01:06:54.000000', 'temperatura', 35.0000, 'ºC'),
	(9116, 108, '2015-01-15 01:06:55.000000', 'temperatura', 922.0000, 'ºC'),
	(9117, 108, '2015-01-15 01:06:56.000000', 'temperatura', 907.0000, 'ºC'),
	(9118, 108, '2015-01-15 01:06:57.000000', 'temperatura', 567.0000, 'ºC'),
	(9119, 108, '2015-01-15 01:06:58.000000', 'temperatura', 114.0000, 'ºC'),
	(9120, 108, '2015-01-15 01:06:59.000000', 'temperatura', 69.0000, 'ºC'),
	(9121, 108, '2015-01-15 01:07:00.000000', 'temperatura', 6.0000, 'ºC'),
	(9122, 108, '2015-01-15 01:07:01.000000', 'temperatura', 1024.0000, 'ºC'),
	(9123, 108, '2015-01-15 01:07:02.000000', 'temperatura', 302.0000, 'ºC'),
	(9124, 108, '2015-01-15 01:07:03.000000', 'temperatura', 839.0000, 'ºC'),
	(9125, 108, '2015-01-15 01:07:04.000000', 'temperatura', 890.0000, 'ºC'),
	(9126, 108, '2015-01-15 01:07:05.000000', 'temperatura', 734.0000, 'ºC'),
	(9127, 108, '2015-01-15 01:07:06.000000', 'temperatura', 998.0000, 'ºC'),
	(9128, 108, '2015-01-15 01:07:07.000000', 'temperatura', 391.0000, 'ºC'),
	(9129, 108, '2015-01-15 01:07:08.000000', 'temperatura', 159.0000, 'ºC'),
	(9130, 108, '2015-01-15 01:07:09.000000', 'temperatura', 824.0000, 'ºC'),
	(9131, 108, '2015-01-15 01:07:10.000000', 'temperatura', 44.0000, 'ºC'),
	(9132, 108, '2015-01-15 01:07:11.000000', 'temperatura', 146.0000, 'ºC'),
	(9133, 108, '2015-01-15 01:07:12.000000', 'temperatura', 600.0000, 'ºC'),
	(9134, 108, '2015-01-15 01:07:13.000000', 'temperatura', 163.0000, 'ºC'),
	(9135, 108, '2015-01-15 01:07:14.000000', 'temperatura', 216.0000, 'ºC'),
	(9136, 108, '2015-01-15 01:07:15.000000', 'temperatura', 592.0000, 'ºC'),
	(9137, 108, '2015-01-15 01:07:16.000000', 'temperatura', 1114.0000, 'ºC'),
	(9138, 108, '2015-01-15 01:07:17.000000', 'temperatura', 192.0000, 'ºC'),
	(9139, 108, '2015-01-15 01:07:18.000000', 'temperatura', 17.0000, 'ºC'),
	(9140, 108, '2015-01-15 01:07:19.000000', 'temperatura', 712.0000, 'ºC'),
	(9141, 108, '2015-01-15 01:07:20.000000', 'temperatura', 1111.0000, 'ºC'),
	(9142, 108, '2015-01-15 01:07:21.000000', 'temperatura', 1017.0000, 'ºC'),
	(9143, 108, '2015-01-15 01:07:22.000000', 'temperatura', 552.0000, 'ºC'),
	(9144, 108, '2015-01-15 01:07:23.000000', 'temperatura', 910.0000, 'ºC'),
	(9145, 108, '2015-01-15 01:07:24.000000', 'temperatura', 497.0000, 'ºC'),
	(9146, 108, '2015-01-15 01:07:25.000000', 'temperatura', 953.0000, 'ºC'),
	(9147, 108, '2015-01-15 01:07:26.000000', 'temperatura', 875.0000, 'ºC'),
	(9148, 108, '2015-01-15 01:07:27.000000', 'temperatura', 318.0000, 'ºC'),
	(9149, 108, '2015-01-15 01:07:28.000000', 'temperatura', 165.0000, 'ºC'),
	(9150, 108, '2015-01-15 01:07:29.000000', 'temperatura', 1073.0000, 'ºC'),
	(9151, 108, '2015-01-15 01:07:30.000000', 'temperatura', 69.0000, 'ºC'),
	(9152, 108, '2015-01-15 01:07:31.000000', 'temperatura', 725.0000, 'ºC'),
	(9153, 108, '2015-01-15 01:07:32.000000', 'temperatura', 1019.0000, 'ºC'),
	(9154, 108, '2015-01-15 01:07:33.000000', 'temperatura', 520.0000, 'ºC'),
	(9155, 108, '2015-01-15 01:07:34.000000', 'temperatura', 743.0000, 'ºC'),
	(9156, 108, '2015-01-15 01:07:35.000000', 'temperatura', 955.0000, 'ºC'),
	(9157, 108, '2015-01-15 01:07:36.000000', 'temperatura', 149.0000, 'ºC'),
	(9158, 108, '2015-01-15 01:07:37.000000', 'temperatura', 279.0000, 'ºC'),
	(9159, 108, '2015-01-15 01:07:38.000000', 'temperatura', 948.0000, 'ºC'),
	(9160, 108, '2015-01-15 01:07:39.000000', 'temperatura', 303.0000, 'ºC'),
	(9161, 108, '2015-01-15 01:07:40.000000', 'temperatura', 1074.0000, 'ºC'),
	(9162, 108, '2015-01-15 01:07:41.000000', 'temperatura', 862.0000, 'ºC'),
	(9163, 108, '2015-01-15 01:07:42.000000', 'temperatura', 1086.0000, 'ºC'),
	(9164, 108, '2015-01-15 01:07:43.000000', 'temperatura', 445.0000, 'ºC'),
	(9165, 108, '2015-01-15 01:07:44.000000', 'temperatura', 166.0000, 'ºC'),
	(9166, 108, '2015-01-15 01:07:45.000000', 'temperatura', 697.0000, 'ºC'),
	(9167, 108, '2015-01-15 01:07:46.000000', 'temperatura', 588.0000, 'ºC'),
	(9168, 108, '2015-01-15 01:07:47.000000', 'temperatura', 849.0000, 'ºC'),
	(9169, 108, '2015-01-15 01:07:48.000000', 'temperatura', 82.0000, 'ºC'),
	(9170, 108, '2015-01-15 01:07:49.000000', 'temperatura', 264.0000, 'ºC'),
	(9171, 108, '2015-01-15 01:07:50.000000', 'temperatura', 1076.0000, 'ºC'),
	(9172, 108, '2015-01-15 01:07:51.000000', 'temperatura', 986.0000, 'ºC'),
	(9173, 108, '2015-01-15 01:07:52.000000', 'temperatura', 504.0000, 'ºC'),
	(9174, 108, '2015-01-15 01:07:53.000000', 'temperatura', 762.0000, 'ºC'),
	(9175, 108, '2015-01-15 01:07:54.000000', 'temperatura', 1097.0000, 'ºC'),
	(9176, 108, '2015-01-15 01:07:55.000000', 'temperatura', 802.0000, 'ºC'),
	(9177, 108, '2015-01-15 01:07:56.000000', 'temperatura', 720.0000, 'ºC'),
	(9178, 108, '2015-01-15 01:07:57.000000', 'temperatura', 1194.0000, 'ºC'),
	(9179, 108, '2015-01-15 01:07:58.000000', 'temperatura', 210.0000, 'ºC'),
	(9180, 108, '2015-01-15 01:07:59.000000', 'temperatura', 1070.0000, 'ºC'),
	(9181, 108, '2015-01-15 01:08:00.000000', 'temperatura', 1119.0000, 'ºC'),
	(9182, 108, '2015-01-15 01:08:01.000000', 'temperatura', 1186.0000, 'ºC'),
	(9183, 108, '2015-01-15 01:08:02.000000', 'temperatura', 175.0000, 'ºC'),
	(9184, 108, '2015-01-15 01:08:03.000000', 'temperatura', 914.0000, 'ºC'),
	(9185, 108, '2015-01-15 01:08:04.000000', 'temperatura', 448.0000, 'ºC'),
	(9186, 108, '2015-01-15 01:08:05.000000', 'temperatura', 699.0000, 'ºC'),
	(9187, 108, '2015-01-15 01:08:06.000000', 'temperatura', 952.0000, 'ºC'),
	(9188, 108, '2015-01-15 01:08:07.000000', 'temperatura', 262.0000, 'ºC'),
	(9189, 108, '2015-01-15 01:08:08.000000', 'temperatura', 856.0000, 'ºC'),
	(9190, 108, '2015-01-15 01:08:09.000000', 'temperatura', 1095.0000, 'ºC'),
	(9191, 108, '2015-01-15 01:08:10.000000', 'temperatura', 505.0000, 'ºC'),
	(9192, 108, '2015-01-15 01:08:11.000000', 'temperatura', 442.0000, 'ºC'),
	(9193, 108, '2015-01-15 01:08:12.000000', 'temperatura', 697.0000, 'ºC'),
	(9194, 108, '2015-01-15 01:08:13.000000', 'temperatura', 957.0000, 'ºC'),
	(9195, 108, '2015-01-15 01:08:14.000000', 'temperatura', 293.0000, 'ºC'),
	(9196, 108, '2015-01-15 01:08:15.000000', 'temperatura', 997.0000, 'ºC'),
	(9197, 108, '2015-01-15 01:08:16.000000', 'temperatura', 507.0000, 'ºC'),
	(9198, 108, '2015-01-15 01:08:17.000000', 'temperatura', 743.0000, 'ºC'),
	(9199, 108, '2015-01-15 01:08:18.000000', 'temperatura', 996.0000, 'ºC'),
	(9200, 108, '2015-01-15 01:08:19.000000', 'temperatura', 350.0000, 'ºC'),
	(9201, 108, '2015-01-15 01:08:20.000000', 'temperatura', 1164.0000, 'ºC'),
	(9202, 108, '2015-01-15 01:08:21.000000', 'temperatura', 1168.0000, 'ºC'),
	(9203, 108, '2015-01-15 01:08:22.000000', 'temperatura', 1149.0000, 'ºC'),
	(9204, 108, '2015-01-15 01:08:23.000000', 'temperatura', 1044.0000, 'ºC'),
	(9205, 108, '2015-01-15 01:08:24.000000', 'temperatura', 572.0000, 'ºC'),
	(9206, 108, '2015-01-15 01:08:25.000000', 'temperatura', 928.0000, 'ºC'),
	(9207, 108, '2015-01-15 01:08:26.000000', 'temperatura', 526.0000, 'ºC'),
	(9208, 108, '2015-01-15 01:08:27.000000', 'temperatura', 1047.0000, 'ºC'),
	(9209, 108, '2015-01-15 01:08:28.000000', 'temperatura', 59.0000, 'ºC'),
	(9210, 108, '2015-01-15 01:08:29.000000', 'temperatura', 751.0000, 'ºC'),
	(9211, 108, '2015-01-15 01:08:30.000000', 'temperatura', 1180.0000, 'ºC'),
	(9212, 108, '2015-01-15 01:08:31.000000', 'temperatura', 46.0000, 'ºC'),
	(9213, 108, '2015-01-15 01:08:32.000000', 'temperatura', 290.0000, 'ºC'),
	(9214, 108, '2015-01-15 01:08:33.000000', 'temperatura', 111.0000, 'ºC'),
	(9215, 108, '2015-01-15 01:08:34.000000', 'temperatura', 889.0000, 'ºC'),
	(9216, 108, '2015-01-15 01:08:35.000000', 'temperatura', 511.0000, 'ºC'),
	(9217, 108, '2015-01-15 01:08:36.000000', 'temperatura', 1087.0000, 'ºC'),
	(9218, 108, '2015-01-15 01:08:37.000000', 'temperatura', 303.0000, 'ºC'),
	(9219, 108, '2015-01-15 01:08:38.000000', 'temperatura', 654.0000, 'ºC'),
	(9220, 108, '2015-01-15 01:08:39.000000', 'temperatura', 1160.0000, 'ºC'),
	(9221, 108, '2015-01-15 01:08:40.000000', 'temperatura', 241.0000, 'ºC'),
	(9222, 108, '2015-01-15 01:08:41.000000', 'temperatura', 127.0000, 'ºC'),
	(9223, 108, '2015-01-15 01:08:42.000000', 'temperatura', 1111.0000, 'ºC'),
	(9224, 108, '2015-01-15 01:08:43.000000', 'temperatura', 374.0000, 'ºC'),
	(9225, 108, '2015-01-15 01:08:44.000000', 'temperatura', 936.0000, 'ºC'),
	(9226, 108, '2015-01-15 01:08:45.000000', 'temperatura', 1160.0000, 'ºC'),
	(9227, 108, '2015-01-15 01:08:46.000000', 'temperatura', 593.0000, 'ºC'),
	(9228, 108, '2015-01-15 01:08:47.000000', 'temperatura', 685.0000, 'ºC'),
	(9229, 108, '2015-01-15 01:08:48.000000', 'temperatura', 448.0000, 'ºC'),
	(9230, 108, '2015-01-15 01:08:49.000000', 'temperatura', 185.0000, 'ºC'),
	(9231, 108, '2015-01-15 01:08:50.000000', 'temperatura', 782.0000, 'ºC'),
	(9232, 108, '2015-01-15 01:08:51.000000', 'temperatura', 954.0000, 'ºC'),
	(9233, 108, '2015-01-15 01:08:52.000000', 'temperatura', 25.0000, 'ºC'),
	(9234, 108, '2015-01-15 01:08:53.000000', 'temperatura', 864.0000, 'ºC'),
	(9235, 108, '2015-01-15 01:08:54.000000', 'temperatura', 643.0000, 'ºC'),
	(9236, 108, '2015-01-15 01:08:55.000000', 'temperatura', 627.0000, 'ºC'),
	(9237, 108, '2015-01-15 01:08:56.000000', 'temperatura', 5.0000, 'ºC'),
	(9238, 108, '2015-01-15 01:08:57.000000', 'temperatura', 546.0000, 'ºC'),
	(9239, 108, '2015-01-15 01:08:58.000000', 'temperatura', 313.0000, 'ºC'),
	(9240, 108, '2015-01-15 01:08:59.000000', 'temperatura', 1128.0000, 'ºC'),
	(9241, 108, '2015-01-15 01:09:00.000000', 'temperatura', 1101.0000, 'ºC'),
	(9242, 108, '2015-01-15 01:09:01.000000', 'temperatura', 924.0000, 'ºC'),
	(9243, 108, '2015-01-15 01:09:02.000000', 'temperatura', 114.0000, 'ºC'),
	(9244, 108, '2015-01-15 01:09:03.000000', 'temperatura', 202.0000, 'ºC'),
	(9245, 108, '2015-01-15 01:09:04.000000', 'temperatura', 666.0000, 'ºC'),
	(9246, 108, '2015-01-15 01:09:05.000000', 'temperatura', 326.0000, 'ºC'),
	(9247, 108, '2015-01-15 01:09:06.000000', 'temperatura', 830.0000, 'ºC'),
	(9248, 108, '2015-01-15 01:09:07.000000', 'temperatura', 775.0000, 'ºC'),
	(9249, 108, '2015-01-15 01:09:08.000000', 'temperatura', 186.0000, 'ºC'),
	(9250, 108, '2015-01-15 01:09:09.000000', 'temperatura', 1004.0000, 'ºC'),
	(9251, 108, '2015-01-15 01:09:10.000000', 'temperatura', 861.0000, 'ºC'),
	(9252, 108, '2015-01-15 01:09:11.000000', 'temperatura', 96.0000, 'ºC'),
	(9253, 108, '2015-01-15 01:09:12.000000', 'temperatura', 297.0000, 'ºC'),
	(9254, 108, '2015-01-15 01:09:13.000000', 'temperatura', 1199.0000, 'ºC'),
	(9255, 108, '2015-01-15 01:09:14.000000', 'temperatura', 305.0000, 'ºC'),
	(9256, 108, '2015-01-15 01:09:15.000000', 'temperatura', 326.0000, 'ºC'),
	(9257, 108, '2015-01-15 01:09:16.000000', 'temperatura', 717.0000, 'ºC'),
	(9258, 108, '2015-01-15 01:09:17.000000', 'temperatura', 207.0000, 'ºC'),
	(9259, 108, '2015-01-15 01:09:18.000000', 'temperatura', 85.0000, 'ºC'),
	(9260, 108, '2015-01-15 01:09:19.000000', 'temperatura', 1004.0000, 'ºC'),
	(9261, 108, '2015-01-15 01:09:20.000000', 'temperatura', 1164.0000, 'ºC'),
	(9262, 108, '2015-01-15 01:09:21.000000', 'temperatura', 411.0000, 'ºC'),
	(9263, 108, '2015-01-15 01:09:22.000000', 'temperatura', 964.0000, 'ºC'),
	(9264, 108, '2015-01-15 01:09:23.000000', 'temperatura', 1185.0000, 'ºC'),
	(9265, 108, '2015-01-15 01:09:24.000000', 'temperatura', 636.0000, 'ºC'),
	(9266, 108, '2015-01-15 01:09:25.000000', 'temperatura', 825.0000, 'ºC'),
	(9267, 108, '2015-01-15 01:09:26.000000', 'temperatura', 1019.0000, 'ºC'),
	(9268, 108, '2015-01-15 01:09:27.000000', 'temperatura', 218.0000, 'ºC'),
	(9269, 108, '2015-01-15 01:09:28.000000', 'temperatura', 434.0000, 'ºC'),
	(9270, 108, '2015-01-15 01:09:29.000000', 'temperatura', 315.0000, 'ºC'),
	(9271, 108, '2015-01-15 01:09:30.000000', 'temperatura', 274.0000, 'ºC'),
	(9272, 108, '2015-01-15 01:09:31.000000', 'temperatura', 425.0000, 'ºC'),
	(9273, 108, '2015-01-15 01:09:32.000000', 'temperatura', 105.0000, 'ºC'),
	(9274, 108, '2015-01-15 01:09:33.000000', 'temperatura', 450.0000, 'ºC'),
	(9275, 108, '2015-01-15 01:09:34.000000', 'temperatura', 736.0000, 'ºC'),
	(9276, 108, '2015-01-15 01:09:35.000000', 'temperatura', 1131.0000, 'ºC'),
	(9277, 108, '2015-01-15 01:09:36.000000', 'temperatura', 1048.0000, 'ºC'),
	(9278, 108, '2015-01-15 01:09:37.000000', 'temperatura', 648.0000, 'ºC'),
	(9279, 108, '2015-01-15 01:09:38.000000', 'temperatura', 95.0000, 'ºC'),
	(9280, 108, '2015-01-15 01:09:39.000000', 'temperatura', 933.0000, 'ºC'),
	(9281, 108, '2015-01-15 01:09:40.000000', 'temperatura', 782.0000, 'ºC'),
	(9282, 108, '2015-01-15 01:09:41.000000', 'temperatura', 1109.0000, 'ºC'),
	(9283, 108, '2015-01-15 01:09:42.000000', 'temperatura', 802.0000, 'ºC'),
	(9284, 108, '2015-01-15 01:09:43.000000', 'temperatura', 682.0000, 'ºC'),
	(9285, 108, '2015-01-15 01:09:44.000000', 'temperatura', 1004.0000, 'ºC'),
	(9286, 108, '2015-01-15 01:09:45.000000', 'temperatura', 577.0000, 'ºC'),
	(9287, 108, '2015-01-15 01:09:46.000000', 'temperatura', 1072.0000, 'ºC'),
	(9288, 108, '2015-01-15 01:09:47.000000', 'temperatura', 30.0000, 'ºC'),
	(9289, 108, '2015-01-15 01:09:48.000000', 'temperatura', 536.0000, 'ºC'),
	(9290, 108, '2015-01-15 01:09:49.000000', 'temperatura', 190.0000, 'ºC'),
	(9291, 108, '2015-01-15 01:09:50.000000', 'temperatura', 544.0000, 'ºC'),
	(9292, 108, '2015-01-15 01:09:51.000000', 'temperatura', 947.0000, 'ºC'),
	(9293, 108, '2015-01-15 01:09:52.000000', 'temperatura', 707.0000, 'ºC'),
	(9294, 108, '2015-01-15 01:09:53.000000', 'temperatura', 693.0000, 'ºC'),
	(9295, 108, '2015-01-15 01:09:54.000000', 'temperatura', 146.0000, 'ºC'),
	(9296, 108, '2015-01-15 01:09:55.000000', 'temperatura', 1051.0000, 'ºC'),
	(9297, 108, '2015-01-15 01:09:56.000000', 'temperatura', 18.0000, 'ºC'),
	(9298, 108, '2015-01-15 01:09:57.000000', 'temperatura', 536.0000, 'ºC'),
	(9299, 108, '2015-01-15 01:09:58.000000', 'temperatura', 228.0000, 'ºC'),
	(9300, 108, '2015-01-15 01:09:59.000000', 'temperatura', 733.0000, 'ºC'),
	(9301, 108, '2015-01-15 01:10:00.000000', 'temperatura', 583.0000, 'ºC'),
	(9302, 108, '2015-01-15 01:10:01.000000', 'temperatura', 713.0000, 'ºC'),
	(9303, 108, '2015-01-15 01:10:02.000000', 'temperatura', 619.0000, 'ºC'),
	(9304, 108, '2015-01-15 01:10:03.000000', 'temperatura', 954.0000, 'ºC'),
	(9305, 108, '2015-01-15 01:10:04.000000', 'temperatura', 516.0000, 'ºC'),
	(9306, 108, '2015-01-15 01:10:05.000000', 'temperatura', 919.0000, 'ºC'),
	(9307, 108, '2015-01-15 01:10:06.000000', 'temperatura', 649.0000, 'ºC'),
	(9308, 108, '2015-01-15 01:10:07.000000', 'temperatura', 485.0000, 'ºC'),
	(9309, 108, '2015-01-15 01:10:08.000000', 'temperatura', 480.0000, 'ºC'),
	(9310, 108, '2015-01-15 01:10:09.000000', 'temperatura', 947.0000, 'ºC'),
	(9311, 108, '2015-01-15 01:10:10.000000', 'temperatura', 894.0000, 'ºC'),
	(9312, 108, '2015-01-15 01:10:11.000000', 'temperatura', 430.0000, 'ºC'),
	(9313, 108, '2015-01-15 01:10:12.000000', 'temperatura', 669.0000, 'ºC'),
	(9314, 108, '2015-01-15 01:10:13.000000', 'temperatura', 854.0000, 'ºC'),
	(9315, 108, '2015-01-15 01:10:14.000000', 'temperatura', 1065.0000, 'ºC'),
	(9316, 108, '2015-01-15 01:10:15.000000', 'temperatura', 362.0000, 'ºC'),
	(9317, 108, '2015-01-15 01:10:16.000000', 'temperatura', 1017.0000, 'ºC'),
	(9318, 108, '2015-01-15 01:10:17.000000', 'temperatura', 400.0000, 'ºC'),
	(9319, 108, '2015-01-15 01:10:18.000000', 'temperatura', 147.0000, 'ºC'),
	(9320, 108, '2015-01-15 01:10:19.000000', 'temperatura', 738.0000, 'ºC'),
	(9321, 108, '2015-01-15 01:10:20.000000', 'temperatura', 850.0000, 'ºC'),
	(9322, 108, '2015-01-15 01:10:21.000000', 'temperatura', 835.0000, 'ºC'),
	(9323, 108, '2015-01-15 01:10:22.000000', 'temperatura', 425.0000, 'ºC'),
	(9324, 108, '2015-01-15 01:10:23.000000', 'temperatura', 821.0000, 'ºC'),
	(9325, 108, '2015-01-15 01:10:24.000000', 'temperatura', 431.0000, 'ºC'),
	(9326, 108, '2015-01-15 01:10:25.000000', 'temperatura', 894.0000, 'ºC'),
	(9327, 108, '2015-01-15 01:10:26.000000', 'temperatura', 775.0000, 'ºC'),
	(9328, 108, '2015-01-15 01:10:27.000000', 'temperatura', 1193.0000, 'ºC'),
	(9329, 108, '2015-01-15 01:10:28.000000', 'temperatura', 40.0000, 'ºC'),
	(9330, 108, '2015-01-15 01:10:29.000000', 'temperatura', 221.0000, 'ºC'),
	(9331, 108, '2015-01-15 01:10:30.000000', 'temperatura', 988.0000, 'ºC'),
	(9332, 108, '2015-01-15 01:10:31.000000', 'temperatura', 675.0000, 'ºC'),
	(9333, 108, '2015-01-15 01:10:32.000000', 'temperatura', 414.0000, 'ºC'),
	(9334, 108, '2015-01-15 01:10:33.000000', 'temperatura', 45.0000, 'ºC'),
	(9335, 108, '2015-01-15 01:10:34.000000', 'temperatura', 183.0000, 'ºC'),
	(9336, 108, '2015-01-15 01:10:35.000000', 'temperatura', 782.0000, 'ºC'),
	(9337, 108, '2015-01-15 01:10:36.000000', 'temperatura', 960.0000, 'ºC'),
	(9338, 108, '2015-01-15 01:10:37.000000', 'temperatura', 55.0000, 'ºC'),
	(9339, 108, '2015-01-15 01:10:38.000000', 'temperatura', 995.0000, 'ºC'),
	(9340, 108, '2015-01-15 01:10:39.000000', 'temperatura', 9.0000, 'ºC'),
	(9341, 108, '2015-01-15 01:10:40.000000', 'temperatura', 663.0000, 'ºC'),
	(9342, 108, '2015-01-15 01:10:41.000000', 'temperatura', 889.0000, 'ºC'),
	(9343, 108, '2015-01-15 01:10:42.000000', 'temperatura', 55.0000, 'ºC'),
	(9344, 108, '2015-01-15 01:10:43.000000', 'temperatura', 10.0000, 'ºC'),
	(9345, 108, '2015-01-15 01:10:44.000000', 'temperatura', 1086.0000, 'ºC'),
	(9346, 108, '2015-01-15 01:10:45.000000', 'temperatura', 600.0000, 'ºC'),
	(9347, 108, '2015-01-15 01:10:46.000000', 'temperatura', 943.0000, 'ºC'),
	(9348, 108, '2015-01-15 01:10:47.000000', 'temperatura', 516.0000, 'ºC'),
	(9349, 108, '2015-01-15 01:10:48.000000', 'temperatura', 953.0000, 'ºC'),
	(9350, 108, '2015-01-15 01:10:49.000000', 'temperatura', 814.0000, 'ºC'),
	(9351, 108, '2015-01-15 01:10:50.000000', 'temperatura', 13.0000, 'ºC'),
	(9352, 108, '2015-01-15 01:10:51.000000', 'temperatura', 22.0000, 'ºC'),
	(9353, 108, '2015-01-15 01:10:52.000000', 'temperatura', 72.0000, 'ºC'),
	(9354, 108, '2015-01-15 01:10:53.000000', 'temperatura', 297.0000, 'ºC'),
	(9355, 108, '2015-01-15 01:10:54.000000', 'temperatura', 67.0000, 'ºC'),
	(9356, 108, '2015-01-15 01:10:55.000000', 'temperatura', 644.0000, 'ºC'),
	(9357, 108, '2015-01-15 01:10:56.000000', 'temperatura', 621.0000, 'ºC'),
	(9358, 108, '2015-01-15 01:10:57.000000', 'temperatura', 1171.0000, 'ºC'),
	(9359, 108, '2015-01-15 01:10:58.000000', 'temperatura', 394.0000, 'ºC'),
	(9360, 108, '2015-01-15 01:10:59.000000', 'temperatura', 859.0000, 'ºC'),
	(9361, 108, '2015-01-15 01:11:00.000000', 'temperatura', 711.0000, 'ºC'),
	(9362, 108, '2015-01-15 01:11:01.000000', 'temperatura', 980.0000, 'ºC'),
	(9363, 108, '2015-01-15 01:11:02.000000', 'temperatura', 366.0000, 'ºC'),
	(9364, 108, '2015-01-15 01:11:03.000000', 'temperatura', 92.0000, 'ºC'),
	(9365, 108, '2015-01-15 01:11:04.000000', 'temperatura', 564.0000, 'ºC'),
	(9366, 108, '2015-01-15 01:11:05.000000', 'temperatura', 142.0000, 'ºC'),
	(9367, 108, '2015-01-15 01:11:06.000000', 'temperatura', 219.0000, 'ºC'),
	(9368, 108, '2015-01-15 01:11:07.000000', 'temperatura', 669.0000, 'ºC'),
	(9369, 108, '2015-01-15 01:11:08.000000', 'temperatura', 289.0000, 'ºC'),
	(9370, 108, '2015-01-15 01:11:09.000000', 'temperatura', 637.0000, 'ºC'),
	(9371, 108, '2015-01-15 01:11:10.000000', 'temperatura', 1118.0000, 'ºC'),
	(9372, 108, '2015-01-15 01:11:11.000000', 'temperatura', 79.0000, 'ºC'),
	(9373, 108, '2015-01-15 01:11:12.000000', 'temperatura', 640.0000, 'ºC'),
	(9374, 108, '2015-01-15 01:11:13.000000', 'temperatura', 567.0000, 'ºC'),
	(9375, 108, '2015-01-15 01:11:14.000000', 'temperatura', 916.0000, 'ºC'),
	(9376, 108, '2015-01-15 01:11:15.000000', 'temperatura', 479.0000, 'ºC'),
	(9377, 108, '2015-01-15 01:11:16.000000', 'temperatura', 845.0000, 'ºC'),
	(9378, 108, '2015-01-15 01:11:17.000000', 'temperatura', 390.0000, 'ºC'),
	(9379, 108, '2015-01-15 01:11:18.000000', 'temperatura', 614.0000, 'ºC'),
	(9380, 108, '2015-01-15 01:11:19.000000', 'temperatura', 701.0000, 'ºC'),
	(9381, 108, '2015-01-15 01:11:20.000000', 'temperatura', 464.0000, 'ºC'),
	(9382, 108, '2015-01-15 01:11:21.000000', 'temperatura', 219.0000, 'ºC'),
	(9383, 108, '2015-01-15 01:11:22.000000', 'temperatura', 901.0000, 'ºC'),
	(9384, 108, '2015-01-15 01:11:23.000000', 'temperatura', 248.0000, 'ºC'),
	(9385, 108, '2015-01-15 01:11:24.000000', 'temperatura', 940.0000, 'ºC'),
	(9386, 108, '2015-01-15 01:11:25.000000', 'temperatura', 356.0000, 'ºC'),
	(9387, 108, '2015-01-15 01:11:26.000000', 'temperatura', 160.0000, 'ºC'),
	(9388, 108, '2015-01-15 01:11:27.000000', 'temperatura', 934.0000, 'ºC'),
	(9389, 108, '2015-01-15 01:11:28.000000', 'temperatura', 589.0000, 'ºC'),
	(9390, 108, '2015-01-15 01:11:29.000000', 'temperatura', 145.0000, 'ºC'),
	(9391, 108, '2015-01-15 01:11:30.000000', 'temperatura', 159.0000, 'ºC'),
	(9392, 108, '2015-01-15 01:11:31.000000', 'temperatura', 361.0000, 'ºC'),
	(9393, 108, '2015-01-15 01:11:32.000000', 'temperatura', 127.0000, 'ºC'),
	(9394, 108, '2015-01-15 01:11:33.000000', 'temperatura', 753.0000, 'ºC'),
	(9395, 108, '2015-01-15 01:11:34.000000', 'temperatura', 985.0000, 'ºC'),
	(9396, 108, '2015-01-15 01:11:35.000000', 'temperatura', 268.0000, 'ºC'),
	(9397, 108, '2015-01-15 01:11:36.000000', 'temperatura', 784.0000, 'ºC'),
	(9398, 108, '2015-01-15 01:11:37.000000', 'temperatura', 718.0000, 'ºC'),
	(9399, 108, '2015-01-15 01:11:38.000000', 'temperatura', 38.0000, 'ºC'),
	(9400, 108, '2015-01-15 01:11:39.000000', 'temperatura', 436.0000, 'ºC'),
	(9401, 108, '2015-01-15 01:11:40.000000', 'temperatura', 867.0000, 'ºC'),
	(9402, 108, '2015-01-15 01:11:41.000000', 'temperatura', 626.0000, 'ºC'),
	(9403, 108, '2015-01-15 01:11:42.000000', 'temperatura', 531.0000, 'ºC'),
	(9404, 108, '2015-01-15 01:11:43.000000', 'temperatura', 777.0000, 'ºC'),
	(9405, 108, '2015-01-15 01:11:44.000000', 'temperatura', 1093.0000, 'ºC'),
	(9406, 108, '2015-01-15 01:11:45.000000', 'temperatura', 733.0000, 'ºC'),
	(9407, 108, '2015-01-15 01:11:46.000000', 'temperatura', 386.0000, 'ºC'),
	(9408, 108, '2015-01-15 01:11:47.000000', 'temperatura', 934.0000, 'ºC'),
	(9409, 108, '2015-01-15 01:11:48.000000', 'temperatura', 1111.0000, 'ºC'),
	(9410, 108, '2015-01-15 01:11:49.000000', 'temperatura', 356.0000, 'ºC'),
	(9411, 108, '2015-01-15 01:11:50.000000', 'temperatura', 846.0000, 'ºC'),
	(9412, 108, '2015-01-15 01:11:51.000000', 'temperatura', 761.0000, 'ºC'),
	(9413, 108, '2015-01-15 01:11:52.000000', 'temperatura', 67.0000, 'ºC'),
	(9414, 108, '2015-01-15 01:11:53.000000', 'temperatura', 452.0000, 'ºC'),
	(9415, 108, '2015-01-15 01:11:54.000000', 'temperatura', 860.0000, 'ºC'),
	(9416, 108, '2015-01-15 01:11:55.000000', 'temperatura', 546.0000, 'ºC'),
	(9417, 108, '2015-01-15 01:11:56.000000', 'temperatura', 150.0000, 'ºC'),
	(9418, 108, '2015-01-15 01:11:57.000000', 'temperatura', 312.0000, 'ºC'),
	(9419, 108, '2015-01-15 01:11:58.000000', 'temperatura', 1112.0000, 'ºC'),
	(9420, 108, '2015-01-15 01:11:59.000000', 'temperatura', 1025.0000, 'ºC'),
	(9421, 108, '2015-01-15 01:12:00.000000', 'temperatura', 587.0000, 'ºC'),
	(9422, 108, '2015-01-15 01:12:01.000000', 'temperatura', 1063.0000, 'ºC'),
	(9423, 108, '2015-01-15 01:12:02.000000', 'temperatura', 1154.0000, 'ºC'),
	(9424, 108, '2015-01-15 01:12:03.000000', 'temperatura', 183.0000, 'ºC'),
	(9425, 108, '2015-01-15 01:12:04.000000', 'temperatura', 1053.0000, 'ºC'),
	(9426, 108, '2015-01-15 01:12:05.000000', 'temperatura', 1115.0000, 'ºC'),
	(9427, 108, '2015-01-15 01:12:06.000000', 'temperatura', 19.0000, 'ºC'),
	(9428, 108, '2015-01-15 01:12:07.000000', 'temperatura', 347.0000, 'ºC'),
	(9429, 108, '2015-01-15 01:12:08.000000', 'temperatura', 481.0000, 'ºC'),
	(9430, 108, '2015-01-15 01:12:09.000000', 'temperatura', 166.0000, 'ºC'),
	(9431, 108, '2015-01-15 01:12:10.000000', 'temperatura', 586.0000, 'ºC'),
	(9432, 108, '2015-01-15 01:12:11.000000', 'temperatura', 31.0000, 'ºC'),
	(9433, 108, '2015-01-15 01:12:12.000000', 'temperatura', 800.0000, 'ºC'),
	(9434, 108, '2015-01-15 01:12:13.000000', 'temperatura', 305.0000, 'ºC'),
	(9435, 108, '2015-01-15 01:12:14.000000', 'temperatura', 325.0000, 'ºC'),
	(9436, 108, '2015-01-15 01:12:15.000000', 'temperatura', 710.0000, 'ºC'),
	(9437, 108, '2015-01-15 01:12:16.000000', 'temperatura', 177.0000, 'ºC'),
	(9438, 108, '2015-01-15 01:12:17.000000', 'temperatura', 1156.0000, 'ºC'),
	(9439, 108, '2015-01-15 01:12:18.000000', 'temperatura', 448.0000, 'ºC'),
	(9440, 108, '2015-01-15 01:12:19.000000', 'temperatura', 1171.0000, 'ºC'),
	(9441, 108, '2015-01-15 01:12:20.000000', 'temperatura', 913.0000, 'ºC'),
	(9442, 108, '2015-01-15 01:12:21.000000', 'temperatura', 1053.0000, 'ºC'),
	(9443, 108, '2015-01-15 01:12:22.000000', 'temperatura', 127.0000, 'ºC'),
	(9444, 108, '2015-01-15 01:12:23.000000', 'temperatura', 1076.0000, 'ºC'),
	(9445, 108, '2015-01-15 01:12:24.000000', 'temperatura', 199.0000, 'ºC'),
	(9446, 108, '2015-01-15 01:12:25.000000', 'temperatura', 167.0000, 'ºC'),
	(9447, 108, '2015-01-15 01:12:26.000000', 'temperatura', 241.0000, 'ºC'),
	(9448, 108, '2015-01-15 01:12:27.000000', 'temperatura', 701.0000, 'ºC'),
	(9449, 108, '2015-01-15 01:12:28.000000', 'temperatura', 385.0000, 'ºC'),
	(9450, 108, '2015-01-15 01:12:29.000000', 'temperatura', 1020.0000, 'ºC'),
	(9451, 108, '2015-01-15 01:12:30.000000', 'temperatura', 348.0000, 'ºC'),
	(9452, 108, '2015-01-15 01:12:31.000000', 'temperatura', 1081.0000, 'ºC'),
	(9453, 108, '2015-01-15 01:12:32.000000', 'temperatura', 760.0000, 'ºC'),
	(9454, 108, '2015-01-15 01:12:33.000000', 'temperatura', 556.0000, 'ºC'),
	(9455, 108, '2015-01-15 01:12:34.000000', 'temperatura', 504.0000, 'ºC'),
	(9456, 108, '2015-01-15 01:12:35.000000', 'temperatura', 850.0000, 'ºC'),
	(9457, 108, '2015-01-15 01:12:36.000000', 'temperatura', 338.0000, 'ºC'),
	(9458, 108, '2015-01-15 01:12:37.000000', 'temperatura', 340.0000, 'ºC'),
	(9459, 108, '2015-01-15 01:12:38.000000', 'temperatura', 689.0000, 'ºC'),
	(9460, 108, '2015-01-15 01:12:39.000000', 'temperatura', 26.0000, 'ºC'),
	(9461, 108, '2015-01-15 01:12:40.000000', 'temperatura', 461.0000, 'ºC'),
	(9462, 108, '2015-01-15 01:12:41.000000', 'temperatura', 1027.0000, 'ºC'),
	(9463, 108, '2015-01-15 01:12:42.000000', 'temperatura', 153.0000, 'ºC'),
	(9464, 108, '2015-01-15 01:12:43.000000', 'temperatura', 86.0000, 'ºC'),
	(9465, 108, '2015-01-15 01:12:44.000000', 'temperatura', 1170.0000, 'ºC'),
	(9466, 108, '2015-01-15 01:12:45.000000', 'temperatura', 794.0000, 'ºC'),
	(9467, 108, '2015-01-15 01:12:46.000000', 'temperatura', 460.0000, 'ºC'),
	(9468, 108, '2015-01-15 01:12:47.000000', 'temperatura', 1119.0000, 'ºC'),
	(9469, 108, '2015-01-15 01:12:48.000000', 'temperatura', 615.0000, 'ºC'),
	(9470, 108, '2015-01-15 01:12:49.000000', 'temperatura', 917.0000, 'ºC'),
	(9471, 108, '2015-01-15 01:12:50.000000', 'temperatura', 344.0000, 'ºC'),
	(9472, 108, '2015-01-15 01:12:51.000000', 'temperatura', 166.0000, 'ºC'),
	(9473, 108, '2015-01-15 01:12:52.000000', 'temperatura', 1000.0000, 'ºC'),
	(9474, 108, '2015-01-15 01:12:53.000000', 'temperatura', 902.0000, 'ºC'),
	(9475, 108, '2015-01-15 01:12:54.000000', 'temperatura', 310.0000, 'ºC'),
	(9476, 108, '2015-01-15 01:12:55.000000', 'temperatura', 44.0000, 'ºC'),
	(9477, 108, '2015-01-15 01:12:56.000000', 'temperatura', 490.0000, 'ºC'),
	(9478, 108, '2015-01-15 01:12:57.000000', 'temperatura', 1120.0000, 'ºC'),
	(9479, 108, '2015-01-15 01:12:58.000000', 'temperatura', 532.0000, 'ºC'),
	(9480, 108, '2015-01-15 01:12:59.000000', 'temperatura', 499.0000, 'ºC'),
	(9481, 108, '2015-01-15 01:13:00.000000', 'temperatura', 901.0000, 'ºC'),
	(9482, 108, '2015-01-15 01:13:01.000000', 'temperatura', 606.0000, 'ºC'),
	(9483, 108, '2015-01-15 01:13:02.000000', 'temperatura', 327.0000, 'ºC'),
	(9484, 108, '2015-01-15 01:13:03.000000', 'temperatura', 1020.0000, 'ºC'),
	(9485, 108, '2015-01-15 01:13:04.000000', 'temperatura', 520.0000, 'ºC'),
	(9486, 108, '2015-01-15 01:13:05.000000', 'temperatura', 739.0000, 'ºC'),
	(9487, 108, '2015-01-15 01:13:06.000000', 'temperatura', 935.0000, 'ºC'),
	(9488, 108, '2015-01-15 01:13:07.000000', 'temperatura', 60.0000, 'ºC'),
	(9489, 108, '2015-01-15 01:13:08.000000', 'temperatura', 1094.0000, 'ºC'),
	(9490, 108, '2015-01-15 01:13:09.000000', 'temperatura', 490.0000, 'ºC'),
	(9491, 108, '2015-01-15 01:13:10.000000', 'temperatura', 369.0000, 'ºC'),
	(9492, 108, '2015-01-15 01:13:11.000000', 'temperatura', 375.0000, 'ºC'),
	(9493, 108, '2015-01-15 01:13:12.000000', 'temperatura', 769.0000, 'ºC'),
	(9494, 108, '2015-01-15 01:13:13.000000', 'temperatura', 319.0000, 'ºC'),
	(9495, 108, '2015-01-15 01:13:14.000000', 'temperatura', 489.0000, 'ºC'),
	(9496, 108, '2015-01-15 01:13:15.000000', 'temperatura', 287.0000, 'ºC'),
	(9497, 108, '2015-01-15 01:13:16.000000', 'temperatura', 1170.0000, 'ºC'),
	(9498, 108, '2015-01-15 01:13:17.000000', 'temperatura', 191.0000, 'ºC'),
	(9499, 108, '2015-01-15 01:13:18.000000', 'temperatura', 1044.0000, 'ºC'),
	(9500, 108, '2015-01-15 01:13:19.000000', 'temperatura', 1046.0000, 'ºC'),
	(9501, 108, '2015-01-15 01:13:20.000000', 'temperatura', 899.0000, 'ºC'),
	(9502, 108, '2015-01-15 01:13:21.000000', 'temperatura', 160.0000, 'ºC'),
	(9503, 108, '2015-01-15 01:13:22.000000', 'temperatura', 501.0000, 'ºC'),
	(9504, 108, '2015-01-15 01:13:23.000000', 'temperatura', 826.0000, 'ºC'),
	(9505, 108, '2015-01-15 01:13:24.000000', 'temperatura', 228.0000, 'ºC'),
	(9506, 108, '2015-01-15 01:13:25.000000', 'temperatura', 1061.0000, 'ºC'),
	(9507, 108, '2015-01-15 01:13:26.000000', 'temperatura', 1024.0000, 'ºC'),
	(9508, 108, '2015-01-15 01:13:27.000000', 'temperatura', 736.0000, 'ºC'),
	(9509, 108, '2015-01-15 01:13:28.000000', 'temperatura', 609.0000, 'ºC'),
	(9510, 108, '2015-01-15 01:13:29.000000', 'temperatura', 837.0000, 'ºC'),
	(9511, 108, '2015-01-15 01:13:30.000000', 'temperatura', 1161.0000, 'ºC'),
	(9512, 108, '2015-01-15 01:13:31.000000', 'temperatura', 892.0000, 'ºC'),
	(9513, 108, '2015-01-15 01:13:32.000000', 'temperatura', 978.0000, 'ºC'),
	(9514, 108, '2015-01-15 01:13:33.000000', 'temperatura', 1014.0000, 'ºC'),
	(9515, 108, '2015-01-15 01:13:34.000000', 'temperatura', 937.0000, 'ºC'),
	(9516, 108, '2015-01-15 01:13:35.000000', 'temperatura', 441.0000, 'ºC'),
	(9517, 108, '2015-01-15 01:13:36.000000', 'temperatura', 598.0000, 'ºC'),
	(9518, 108, '2015-01-15 01:13:37.000000', 'temperatura', 467.0000, 'ºC'),
	(9519, 108, '2015-01-15 01:13:38.000000', 'temperatura', 539.0000, 'ºC'),
	(9520, 108, '2015-01-15 01:13:39.000000', 'temperatura', 97.0000, 'ºC'),
	(9521, 108, '2015-01-15 01:13:40.000000', 'temperatura', 66.0000, 'ºC'),
	(9522, 108, '2015-01-15 01:13:41.000000', 'temperatura', 39.0000, 'ºC'),
	(9523, 108, '2015-01-15 01:13:42.000000', 'temperatura', 1.0000, 'ºC'),
	(9524, 108, '2015-01-15 01:13:43.000000', 'temperatura', 1085.0000, 'ºC'),
	(9525, 108, '2015-01-15 01:13:44.000000', 'temperatura', 624.0000, 'ºC'),
	(9526, 108, '2015-01-15 01:13:45.000000', 'temperatura', 1065.0000, 'ºC'),
	(9527, 108, '2015-01-15 01:13:46.000000', 'temperatura', 1055.0000, 'ºC'),
	(9528, 108, '2015-01-15 01:13:47.000000', 'temperatura', 878.0000, 'ºC'),
	(9529, 108, '2015-01-15 01:13:48.000000', 'temperatura', 26.0000, 'ºC'),
	(9530, 108, '2015-01-15 01:13:49.000000', 'temperatura', 1097.0000, 'ºC'),
	(9531, 108, '2015-01-15 01:13:50.000000', 'temperatura', 609.0000, 'ºC'),
	(9532, 108, '2015-01-15 01:13:51.000000', 'temperatura', 954.0000, 'ºC'),
	(9533, 108, '2015-01-15 01:13:52.000000', 'temperatura', 544.0000, 'ºC'),
	(9534, 108, '2015-01-15 01:13:53.000000', 'temperatura', 1057.0000, 'ºC'),
	(9535, 108, '2015-01-15 01:13:54.000000', 'temperatura', 53.0000, 'ºC'),
	(9536, 108, '2015-01-15 01:13:55.000000', 'temperatura', 696.0000, 'ºC'),
	(9537, 108, '2015-01-15 01:13:56.000000', 'temperatura', 920.0000, 'ºC'),
	(9538, 108, '2015-01-15 01:13:57.000000', 'temperatura', 111.0000, 'ºC'),
	(9539, 108, '2015-01-15 01:13:58.000000', 'temperatura', 199.0000, 'ºC'),
	(9540, 108, '2015-01-15 01:13:59.000000', 'temperatura', 661.0000, 'ºC'),
	(9541, 108, '2015-01-15 01:14:00.000000', 'temperatura', 307.0000, 'ºC'),
	(9542, 108, '2015-01-15 01:14:01.000000', 'temperatura', 754.0000, 'ºC'),
	(9543, 108, '2015-01-15 01:14:02.000000', 'temperatura', 450.0000, 'ºC'),
	(9544, 108, '2015-01-15 01:14:03.000000', 'temperatura', 1189.0000, 'ºC'),
	(9545, 108, '2015-01-15 01:14:04.000000', 'temperatura', 995.0000, 'ºC'),
	(9546, 108, '2015-01-15 01:14:05.000000', 'temperatura', 209.0000, 'ºC'),
	(9547, 108, '2015-01-15 01:14:06.000000', 'temperatura', 459.0000, 'ºC'),
	(9548, 108, '2015-01-15 01:14:07.000000', 'temperatura', 469.0000, 'ºC'),
	(9549, 108, '2015-01-15 01:14:08.000000', 'temperatura', 969.0000, 'ºC'),
	(9550, 108, '2015-01-15 01:14:09.000000', 'temperatura', 1040.0000, 'ºC'),
	(9551, 108, '2015-01-15 01:14:10.000000', 'temperatura', 1091.0000, 'ºC'),
	(9552, 108, '2015-01-15 01:14:11.000000', 'temperatura', 1135.0000, 'ºC'),
	(9553, 108, '2015-01-15 01:14:12.000000', 'temperatura', 3.0000, 'ºC'),
	(9554, 108, '2015-01-15 01:14:13.000000', 'temperatura', 210.0000, 'ºC'),
	(9555, 108, '2015-01-15 01:14:14.000000', 'temperatura', 1042.0000, 'ºC'),
	(9556, 108, '2015-01-15 01:14:15.000000', 'temperatura', 980.0000, 'ºC'),
	(9557, 108, '2015-01-15 01:14:16.000000', 'temperatura', 574.0000, 'ºC'),
	(9558, 108, '2015-01-15 01:14:17.000000', 'temperatura', 1133.0000, 'ºC'),
	(9559, 108, '2015-01-15 01:14:18.000000', 'temperatura', 342.0000, 'ºC'),
	(9560, 108, '2015-01-15 01:14:19.000000', 'temperatura', 710.0000, 'ºC'),
	(9561, 108, '2015-01-15 01:14:20.000000', 'temperatura', 127.0000, 'ºC'),
	(9562, 108, '2015-01-15 01:14:21.000000', 'temperatura', 906.0000, 'ºC'),
	(9563, 108, '2015-01-15 01:14:22.000000', 'temperatura', 547.0000, 'ºC'),
	(9564, 108, '2015-01-15 01:14:23.000000', 'temperatura', 20.0000, 'ºC'),
	(9565, 108, '2015-01-15 01:14:24.000000', 'temperatura', 858.0000, 'ºC'),
	(9566, 108, '2015-01-15 01:14:25.000000', 'temperatura', 631.0000, 'ºC'),
	(9567, 108, '2015-01-15 01:14:26.000000', 'temperatura', 583.0000, 'ºC'),
	(9568, 108, '2015-01-15 01:14:27.000000', 'temperatura', 1020.0000, 'ºC'),
	(9569, 108, '2015-01-15 01:14:28.000000', 'temperatura', 953.0000, 'ºC'),
	(9570, 108, '2015-01-15 01:14:29.000000', 'temperatura', 504.0000, 'ºC'),
	(9571, 108, '2015-01-15 01:14:30.000000', 'temperatura', 861.0000, 'ºC'),
	(9572, 108, '2015-01-15 01:14:31.000000', 'temperatura', 395.0000, 'ºC'),
	(9573, 108, '2015-01-15 01:14:32.000000', 'temperatura', 594.0000, 'ºC'),
	(9574, 108, '2015-01-15 01:14:33.000000', 'temperatura', 584.0000, 'ºC'),
	(9575, 108, '2015-01-15 01:14:34.000000', 'temperatura', 1138.0000, 'ºC'),
	(9576, 108, '2015-01-15 01:14:35.000000', 'temperatura', 338.0000, 'ºC'),
	(9577, 108, '2015-01-15 01:14:36.000000', 'temperatura', 676.0000, 'ºC'),
	(9578, 108, '2015-01-15 01:14:37.000000', 'temperatura', 1169.0000, 'ºC'),
	(9579, 108, '2015-01-15 01:14:38.000000', 'temperatura', 216.0000, 'ºC'),
	(9580, 108, '2015-01-15 01:14:39.000000', 'temperatura', 1174.0000, 'ºC'),
	(9581, 108, '2015-01-15 01:14:40.000000', 'temperatura', 424.0000, 'ºC'),
	(9582, 108, '2015-01-15 01:14:41.000000', 'temperatura', 996.0000, 'ºC'),
	(9583, 108, '2015-01-15 01:14:42.000000', 'temperatura', 110.0000, 'ºC'),
	(9584, 108, '2015-01-15 01:14:43.000000', 'temperatura', 1163.0000, 'ºC'),
	(9585, 108, '2015-01-15 01:14:44.000000', 'temperatura', 685.0000, 'ºC'),
	(9586, 108, '2015-01-15 01:14:45.000000', 'temperatura', 1137.0000, 'ºC'),
	(9587, 108, '2015-01-15 01:14:46.000000', 'temperatura', 31.0000, 'ºC'),
	(9588, 108, '2015-01-15 01:14:47.000000', 'temperatura', 343.0000, 'ºC'),
	(9589, 108, '2015-01-15 01:14:48.000000', 'temperatura', 425.0000, 'ºC'),
	(9590, 108, '2015-01-15 01:14:49.000000', 'temperatura', 1095.0000, 'ºC'),
	(9591, 108, '2015-01-15 01:14:50.000000', 'temperatura', 603.0000, 'ºC'),
	(9592, 108, '2015-01-15 01:14:51.000000', 'temperatura', 927.0000, 'ºC'),
	(9593, 108, '2015-01-15 01:14:52.000000', 'temperatura', 427.0000, 'ºC'),
	(9594, 108, '2015-01-15 01:14:53.000000', 'temperatura', 557.0000, 'ºC'),
	(9595, 108, '2015-01-15 01:14:54.000000', 'temperatura', 301.0000, 'ºC'),
	(9596, 108, '2015-01-15 01:14:55.000000', 'temperatura', 1037.0000, 'ºC'),
	(9597, 108, '2015-01-15 01:14:56.000000', 'temperatura', 683.0000, 'ºC'),
	(9598, 108, '2015-01-15 01:14:57.000000', 'temperatura', 302.0000, 'ºC'),
	(9599, 108, '2015-01-15 01:14:58.000000', 'temperatura', 664.0000, 'ºC'),
	(9600, 108, '2015-01-15 01:14:59.000000', 'temperatura', 14.0000, 'ºC'),
	(9601, 108, '2015-01-15 01:15:00.000000', 'temperatura', 478.0000, 'ºC'),
	(9602, 108, '2015-01-15 01:15:01.000000', 'temperatura', 1148.0000, 'ºC'),
	(9603, 108, '2015-01-15 01:15:02.000000', 'temperatura', 708.0000, 'ºC'),
	(9604, 108, '2015-01-15 01:15:03.000000', 'temperatura', 97.0000, 'ºC'),
	(9605, 108, '2015-01-15 01:15:04.000000', 'temperatura', 759.0000, 'ºC'),
	(9606, 108, '2015-01-15 01:15:05.000000', 'temperatura', 1105.0000, 'ºC'),
	(9607, 108, '2015-01-15 01:15:06.000000', 'temperatura', 847.0000, 'ºC'),
	(9608, 108, '2015-01-15 01:15:07.000000', 'temperatura', 923.0000, 'ºC'),
	(9609, 108, '2015-01-15 01:15:08.000000', 'temperatura', 875.0000, 'ºC'),
	(9610, 108, '2015-01-15 01:15:09.000000', 'temperatura', 406.0000, 'ºC'),
	(9611, 108, '2015-01-15 01:15:10.000000', 'temperatura', 604.0000, 'ºC'),
	(9612, 108, '2015-01-15 01:15:11.000000', 'temperatura', 604.0000, 'ºC'),
	(9613, 108, '2015-01-15 01:15:12.000000', 'temperatura', 7.0000, 'ºC'),
	(9614, 108, '2015-01-15 01:15:13.000000', 'temperatura', 625.0000, 'ºC'),
	(9615, 108, '2015-01-15 01:15:14.000000', 'temperatura', 706.0000, 'ºC'),
	(9616, 108, '2015-01-15 01:15:15.000000', 'temperatura', 454.0000, 'ºC'),
	(9617, 108, '2015-01-15 01:15:16.000000', 'temperatura', 154.0000, 'ºC'),
	(9618, 108, '2015-01-15 01:15:17.000000', 'temperatura', 606.0000, 'ºC'),
	(9619, 108, '2015-01-15 01:15:18.000000', 'temperatura', 171.0000, 'ºC'),
	(9620, 108, '2015-01-15 01:15:19.000000', 'temperatura', 238.0000, 'ºC'),
	(9621, 108, '2015-01-15 01:15:20.000000', 'temperatura', 678.0000, 'ºC'),
	(9622, 108, '2015-01-15 01:15:21.000000', 'temperatura', 276.0000, 'ºC'),
	(9623, 108, '2015-01-15 01:15:22.000000', 'temperatura', 548.0000, 'ºC'),
	(9624, 108, '2015-01-15 01:15:23.000000', 'temperatura', 712.0000, 'ºC'),
	(9625, 108, '2015-01-15 01:15:24.000000', 'temperatura', 715.0000, 'ºC'),
	(9626, 108, '2015-01-15 01:15:25.000000', 'temperatura', 242.0000, 'ºC'),
	(9627, 108, '2015-01-15 01:15:26.000000', 'temperatura', 262.0000, 'ºC'),
	(9628, 108, '2015-01-15 01:15:27.000000', 'temperatura', 588.0000, 'ºC'),
	(9629, 108, '2015-01-15 01:15:28.000000', 'temperatura', 951.0000, 'ºC'),
	(9630, 108, '2015-01-15 01:15:29.000000', 'temperatura', 595.0000, 'ºC'),
	(9631, 108, '2015-01-15 01:15:30.000000', 'temperatura', 120.0000, 'ºC'),
	(9632, 108, '2015-01-15 01:15:31.000000', 'temperatura', 18.0000, 'ºC'),
	(9633, 108, '2015-01-15 01:15:32.000000', 'temperatura', 930.0000, 'ºC'),
	(9634, 108, '2015-01-15 01:15:33.000000', 'temperatura', 995.0000, 'ºC'),
	(9635, 108, '2015-01-15 01:15:34.000000', 'temperatura', 985.0000, 'ºC'),
	(9636, 108, '2015-01-15 01:15:35.000000', 'temperatura', 742.0000, 'ºC'),
	(9637, 108, '2015-01-15 01:15:36.000000', 'temperatura', 756.0000, 'ºC'),
	(9638, 108, '2015-01-15 01:15:37.000000', 'temperatura', 355.0000, 'ºC'),
	(9639, 108, '2015-01-15 01:15:38.000000', 'temperatura', 705.0000, 'ºC'),
	(9640, 108, '2015-01-15 01:15:39.000000', 'temperatura', 61.0000, 'ºC'),
	(9641, 108, '2015-01-15 01:15:40.000000', 'temperatura', 591.0000, 'ºC'),
	(9642, 108, '2015-01-15 01:15:41.000000', 'temperatura', 373.0000, 'ºC'),
	(9643, 108, '2015-01-15 01:15:42.000000', 'temperatura', 92.0000, 'ºC'),
	(9644, 108, '2015-01-15 01:15:43.000000', 'temperatura', 543.0000, 'ºC'),
	(9645, 108, '2015-01-15 01:15:44.000000', 'temperatura', 37.0000, 'ºC'),
	(9646, 108, '2015-01-15 01:15:45.000000', 'temperatura', 958.0000, 'ºC'),
	(9647, 108, '2015-01-15 01:15:46.000000', 'temperatura', 1081.0000, 'ºC'),
	(9648, 108, '2015-01-15 01:15:47.000000', 'temperatura', 129.0000, 'ºC'),
	(9649, 108, '2015-01-15 01:15:48.000000', 'temperatura', 1002.0000, 'ºC'),
	(9650, 108, '2015-01-15 01:15:49.000000', 'temperatura', 1026.0000, 'ºC'),
	(9651, 108, '2015-01-15 01:15:50.000000', 'temperatura', 922.0000, 'ºC'),
	(9652, 108, '2015-01-15 01:15:51.000000', 'temperatura', 336.0000, 'ºC'),
	(9653, 108, '2015-01-15 01:15:52.000000', 'temperatura', 111.0000, 'ºC'),
	(9654, 108, '2015-01-15 01:15:53.000000', 'temperatura', 748.0000, 'ºC'),
	(9655, 108, '2015-01-15 01:15:54.000000', 'temperatura', 1009.0000, 'ºC'),
	(9656, 108, '2015-01-15 01:15:55.000000', 'temperatura', 402.0000, 'ºC'),
	(9657, 108, '2015-01-15 01:15:56.000000', 'temperatura', 182.0000, 'ºC'),
	(9658, 108, '2015-01-15 01:15:57.000000', 'temperatura', 906.0000, 'ºC'),
	(9659, 108, '2015-01-15 01:15:58.000000', 'temperatura', 385.0000, 'ºC'),
	(9660, 108, '2015-01-15 01:15:59.000000', 'temperatura', 405.0000, 'ºC'),
	(9661, 108, '2015-01-15 01:16:00.000000', 'temperatura', 873.0000, 'ºC'),
	(9662, 108, '2015-01-15 01:16:01.000000', 'temperatura', 749.0000, 'ºC'),
	(9663, 108, '2015-01-15 01:16:02.000000', 'temperatura', 1128.0000, 'ºC'),
	(9664, 108, '2015-01-15 01:16:03.000000', 'temperatura', 992.0000, 'ºC'),
	(9665, 108, '2015-01-15 01:16:04.000000', 'temperatura', 378.0000, 'ºC'),
	(9666, 108, '2015-01-15 01:16:05.000000', 'temperatura', 113.0000, 'ºC'),
	(9667, 108, '2015-01-15 01:16:06.000000', 'temperatura', 630.0000, 'ºC'),
	(9668, 108, '2015-01-15 01:16:07.000000', 'temperatura', 414.0000, 'ºC'),
	(9669, 108, '2015-01-15 01:16:08.000000', 'temperatura', 181.0000, 'ºC'),
	(9670, 108, '2015-01-15 01:16:09.000000', 'temperatura', 863.0000, 'ºC'),
	(9671, 108, '2015-01-15 01:16:10.000000', 'temperatura', 172.0000, 'ºC'),
	(9672, 108, '2015-01-15 01:16:11.000000', 'temperatura', 671.0000, 'ºC'),
	(9673, 108, '2015-01-15 01:16:12.000000', 'temperatura', 438.0000, 'ºC'),
	(9674, 108, '2015-01-15 01:16:13.000000', 'temperatura', 179.0000, 'ºC'),
	(9675, 108, '2015-01-15 01:16:14.000000', 'temperatura', 783.0000, 'ºC'),
	(9676, 108, '2015-01-15 01:16:15.000000', 'temperatura', 977.0000, 'ºC'),
	(9677, 108, '2015-01-15 01:16:16.000000', 'temperatura', 138.0000, 'ºC'),
	(9678, 108, '2015-01-15 01:16:17.000000', 'temperatura', 157.0000, 'ºC'),
	(9679, 108, '2015-01-15 01:16:18.000000', 'temperatura', 373.0000, 'ºC'),
	(9680, 108, '2015-01-15 01:16:19.000000', 'temperatura', 195.0000, 'ºC'),
	(9681, 108, '2015-01-15 01:16:20.000000', 'temperatura', 1055.0000, 'ºC'),
	(9682, 108, '2015-01-15 01:16:21.000000', 'temperatura', 1090.0000, 'ºC'),
	(9683, 108, '2015-01-15 01:16:22.000000', 'temperatura', 1088.0000, 'ºC'),
	(9684, 108, '2015-01-15 01:16:23.000000', 'temperatura', 967.0000, 'ºC'),
	(9685, 108, '2015-01-15 01:16:24.000000', 'temperatura', 374.0000, 'ºC'),
	(9686, 108, '2015-01-15 01:16:25.000000', 'temperatura', 169.0000, 'ºC'),
	(9687, 108, '2015-01-15 01:16:26.000000', 'temperatura', 923.0000, 'ºC'),
	(9688, 108, '2015-01-15 01:16:27.000000', 'temperatura', 508.0000, 'ºC'),
	(9689, 108, '2015-01-15 01:16:28.000000', 'temperatura', 971.0000, 'ºC'),
	(9690, 108, '2015-01-15 01:16:29.000000', 'temperatura', 933.0000, 'ºC'),
	(9691, 108, '2015-01-15 01:16:30.000000', 'temperatura', 553.0000, 'ºC'),
	(9692, 108, '2015-01-15 01:16:31.000000', 'temperatura', 1167.0000, 'ºC'),
	(9693, 108, '2015-01-15 01:16:32.000000', 'temperatura', 574.0000, 'ºC'),
	(9694, 108, '2015-01-15 01:16:33.000000', 'temperatura', 569.0000, 'ºC'),
	(9695, 108, '2015-01-15 01:16:34.000000', 'temperatura', 1126.0000, 'ºC'),
	(9696, 108, '2015-01-15 01:16:35.000000', 'temperatura', 324.0000, 'ºC'),
	(9697, 108, '2015-01-15 01:16:36.000000', 'temperatura', 641.0000, 'ºC'),
	(9698, 108, '2015-01-15 01:16:37.000000', 'temperatura', 1035.0000, 'ºC'),
	(9699, 108, '2015-01-15 01:16:38.000000', 'temperatura', 853.0000, 'ºC'),
	(9700, 108, '2015-01-15 01:16:39.000000', 'temperatura', 1160.0000, 'ºC'),
	(9701, 108, '2015-01-15 01:16:40.000000', 'temperatura', 840.0000, 'ºC'),
	(9702, 108, '2015-01-15 01:16:41.000000', 'temperatura', 721.0000, 'ºC'),
	(9703, 108, '2015-01-15 01:16:42.000000', 'temperatura', 1086.0000, 'ºC'),
	(9704, 108, '2015-01-15 01:16:43.000000', 'temperatura', 869.0000, 'ºC'),
	(9705, 108, '2015-01-15 01:16:44.000000', 'temperatura', 1086.0000, 'ºC'),
	(9706, 108, '2015-01-15 01:16:45.000000', 'temperatura', 423.0000, 'ºC'),
	(9707, 108, '2015-01-15 01:16:46.000000', 'temperatura', 56.0000, 'ºC'),
	(9708, 108, '2015-01-15 01:16:47.000000', 'temperatura', 214.0000, 'ºC'),
	(9709, 108, '2015-01-15 01:16:48.000000', 'temperatura', 903.0000, 'ºC'),
	(9710, 108, '2015-01-15 01:16:49.000000', 'temperatura', 274.0000, 'ºC'),
	(9711, 108, '2015-01-15 01:16:50.000000', 'temperatura', 1061.0000, 'ºC'),
	(9712, 108, '2015-01-15 01:16:51.000000', 'temperatura', 885.0000, 'ºC'),
	(9713, 108, '2015-01-15 01:16:52.000000', 'temperatura', 42.0000, 'ºC'),
	(9714, 108, '2015-01-15 01:16:53.000000', 'temperatura', 1155.0000, 'ºC'),
	(9715, 108, '2015-01-15 01:16:54.000000', 'temperatura', 847.0000, 'ºC'),
	(9716, 108, '2015-01-15 01:16:55.000000', 'temperatura', 774.0000, 'ºC'),
	(9717, 108, '2015-01-15 01:16:56.000000', 'temperatura', 130.0000, 'ºC'),
	(9718, 108, '2015-01-15 01:16:57.000000', 'temperatura', 726.0000, 'ºC'),
	(9719, 108, '2015-01-15 01:16:58.000000', 'temperatura', 839.0000, 'ºC'),
	(9720, 108, '2015-01-15 01:16:59.000000', 'temperatura', 821.0000, 'ºC'),
	(9721, 108, '2015-01-15 01:17:00.000000', 'temperatura', 387.0000, 'ºC'),
	(9722, 108, '2015-01-15 01:17:01.000000', 'temperatura', 672.0000, 'ºC'),
	(9723, 108, '2015-01-15 01:17:02.000000', 'temperatura', 1002.0000, 'ºC'),
	(9724, 108, '2015-01-15 01:17:03.000000', 'temperatura', 592.0000, 'ºC'),
	(9725, 108, '2015-01-15 01:17:04.000000', 'temperatura', 1157.0000, 'ºC'),
	(9726, 108, '2015-01-15 01:17:05.000000', 'temperatura', 408.0000, 'ºC'),
	(9727, 108, '2015-01-15 01:17:06.000000', 'temperatura', 968.0000, 'ºC'),
	(9728, 108, '2015-01-15 01:17:07.000000', 'temperatura', 20.0000, 'ºC'),
	(9729, 108, '2015-01-15 01:17:08.000000', 'temperatura', 794.0000, 'ºC'),
	(9730, 108, '2015-01-15 01:17:09.000000', 'temperatura', 310.0000, 'ºC'),
	(9731, 108, '2015-01-15 01:17:10.000000', 'temperatura', 369.0000, 'ºC'),
	(9732, 108, '2015-01-15 01:17:11.000000', 'temperatura', 916.0000, 'ºC'),
	(9733, 108, '2015-01-15 01:17:12.000000', 'temperatura', 1073.0000, 'ºC'),
	(9734, 108, '2015-01-15 01:17:13.000000', 'temperatura', 216.0000, 'ºC'),
	(9735, 108, '2015-01-15 01:17:14.000000', 'temperatura', 263.0000, 'ºC'),
	(9736, 108, '2015-01-15 01:17:15.000000', 'temperatura', 665.0000, 'ºC'),
	(9737, 108, '2015-01-15 01:17:16.000000', 'temperatura', 139.0000, 'ºC'),
	(9738, 108, '2015-01-15 01:17:17.000000', 'temperatura', 1101.0000, 'ºC'),
	(9739, 108, '2015-01-15 01:17:18.000000', 'temperatura', 289.0000, 'ºC'),
	(9740, 108, '2015-01-15 01:17:19.000000', 'temperatura', 542.0000, 'ºC'),
	(9741, 108, '2015-01-15 01:17:20.000000', 'temperatura', 644.0000, 'ºC'),
	(9742, 108, '2015-01-15 01:17:21.000000', 'temperatura', 393.0000, 'ºC'),
	(9743, 108, '2015-01-15 01:17:22.000000', 'temperatura', 36.0000, 'ºC'),
	(9744, 108, '2015-01-15 01:17:23.000000', 'temperatura', 199.0000, 'ºC'),
	(9745, 108, '2015-01-15 01:17:24.000000', 'temperatura', 890.0000, 'ºC'),
	(9746, 108, '2015-01-15 01:17:25.000000', 'temperatura', 253.0000, 'ºC'),
	(9747, 108, '2015-01-15 01:17:26.000000', 'temperatura', 997.0000, 'ºC'),
	(9748, 108, '2015-01-15 01:17:27.000000', 'temperatura', 624.0000, 'ºC'),
	(9749, 108, '2015-01-15 01:17:28.000000', 'temperatura', 129.0000, 'ºC'),
	(9750, 108, '2015-01-15 01:17:29.000000', 'temperatura', 1173.0000, 'ºC'),
	(9751, 108, '2015-01-15 01:17:30.000000', 'temperatura', 679.0000, 'ºC'),
	(9752, 108, '2015-01-15 01:17:31.000000', 'temperatura', 1075.0000, 'ºC'),
	(9753, 108, '2015-01-15 01:17:32.000000', 'temperatura', 940.0000, 'ºC'),
	(9754, 108, '2015-01-15 01:17:33.000000', 'temperatura', 276.0000, 'ºC'),
	(9755, 108, '2015-01-15 01:17:34.000000', 'temperatura', 959.0000, 'ºC'),
	(9756, 108, '2015-01-15 01:17:35.000000', 'temperatura', 366.0000, 'ºC'),
	(9757, 108, '2015-01-15 01:17:36.000000', 'temperatura', 157.0000, 'ºC'),
	(9758, 108, '2015-01-15 01:17:37.000000', 'temperatura', 884.0000, 'ºC'),
	(9759, 108, '2015-01-15 01:17:38.000000', 'temperatura', 352.0000, 'ºC'),
	(9760, 108, '2015-01-15 01:17:39.000000', 'temperatura', 306.0000, 'ºC'),
	(9761, 108, '2015-01-15 01:17:40.000000', 'temperatura', 476.0000, 'ºC'),
	(9762, 108, '2015-01-15 01:17:41.000000', 'temperatura', 262.0000, 'ºC'),
	(9763, 108, '2015-01-15 01:17:42.000000', 'temperatura', 1081.0000, 'ºC'),
	(9764, 108, '2015-01-15 01:17:43.000000', 'temperatura', 1021.0000, 'ºC'),
	(9765, 108, '2015-01-15 01:17:44.000000', 'temperatura', 661.0000, 'ºC'),
	(9766, 108, '2015-01-15 01:17:45.000000', 'temperatura', 245.0000, 'ºC'),
	(9767, 108, '2015-01-15 01:17:46.000000', 'temperatura', 442.0000, 'ºC'),
	(9768, 108, '2015-01-15 01:17:47.000000', 'temperatura', 273.0000, 'ºC'),
	(9769, 108, '2015-01-15 01:17:48.000000', 'temperatura', 42.0000, 'ºC'),
	(9770, 108, '2015-01-15 01:17:49.000000', 'temperatura', 590.0000, 'ºC'),
	(9771, 108, '2015-01-15 01:17:50.000000', 'temperatura', 423.0000, 'ºC'),
	(9772, 108, '2015-01-15 01:17:51.000000', 'temperatura', 347.0000, 'ºC'),
	(9773, 108, '2015-01-15 01:17:52.000000', 'temperatura', 468.0000, 'ºC'),
	(9774, 108, '2015-01-15 01:17:53.000000', 'temperatura', 98.0000, 'ºC'),
	(9775, 108, '2015-01-15 01:17:54.000000', 'temperatura', 285.0000, 'ºC'),
	(9776, 108, '2015-01-15 01:17:55.000000', 'temperatura', 1133.0000, 'ºC'),
	(9777, 108, '2015-01-15 01:17:56.000000', 'temperatura', 10.0000, 'ºC'),
	(9778, 108, '2015-01-15 01:17:57.000000', 'temperatura', 251.0000, 'ºC'),
	(9779, 108, '2015-01-15 01:17:58.000000', 'temperatura', 27.0000, 'ºC'),
	(9780, 108, '2015-01-15 01:17:59.000000', 'temperatura', 582.0000, 'ºC'),
	(9781, 108, '2015-01-15 01:18:00.000000', 'temperatura', 430.0000, 'ºC'),
	(9782, 108, '2015-01-15 01:18:01.000000', 'temperatura', 403.0000, 'ºC'),
	(9783, 108, '2015-01-15 01:18:02.000000', 'temperatura', 726.0000, 'ºC'),
	(9784, 108, '2015-01-15 01:18:03.000000', 'temperatura', 22.0000, 'ºC'),
	(9785, 108, '2015-01-15 01:18:04.000000', 'temperatura', 331.0000, 'ºC'),
	(9786, 108, '2015-01-15 01:18:05.000000', 'temperatura', 389.0000, 'ºC'),
	(9787, 108, '2015-01-15 01:18:06.000000', 'temperatura', 953.0000, 'ºC'),
	(9788, 108, '2015-01-15 01:18:07.000000', 'temperatura', 1198.0000, 'ºC'),
	(9789, 108, '2015-01-15 01:18:08.000000', 'temperatura', 730.0000, 'ºC'),
	(9790, 108, '2015-01-15 01:18:09.000000', 'temperatura', 60.0000, 'ºC'),
	(9791, 108, '2015-01-15 01:18:10.000000', 'temperatura', 508.0000, 'ºC'),
	(9792, 108, '2015-01-15 01:18:11.000000', 'temperatura', 1162.0000, 'ºC'),
	(9793, 108, '2015-01-15 01:18:12.000000', 'temperatura', 686.0000, 'ºC'),
	(9794, 108, '2015-01-15 01:18:13.000000', 'temperatura', 1143.0000, 'ºC'),
	(9795, 108, '2015-01-15 01:18:14.000000', 'temperatura', 58.0000, 'ºC'),
	(9796, 108, '2015-01-15 01:18:15.000000', 'temperatura', 461.0000, 'ºC'),
	(9797, 108, '2015-01-15 01:18:16.000000', 'temperatura', 931.0000, 'ºC'),
	(9798, 108, '2015-01-15 01:18:17.000000', 'temperatura', 875.0000, 'ºC'),
	(9799, 108, '2015-01-15 01:18:18.000000', 'temperatura', 380.0000, 'ºC'),
	(9800, 108, '2015-01-15 01:18:19.000000', 'temperatura', 476.0000, 'ºC'),
	(9801, 108, '2015-01-15 01:18:20.000000', 'temperatura', 42.0000, 'ºC'),
	(9802, 108, '2015-01-15 01:18:21.000000', 'temperatura', 1181.0000, 'ºC'),
	(9803, 108, '2015-01-15 01:18:22.000000', 'temperatura', 979.0000, 'ºC'),
	(9804, 108, '2015-01-15 01:18:23.000000', 'temperatura', 153.0000, 'ºC'),
	(9805, 108, '2015-01-15 01:18:24.000000', 'temperatura', 230.0000, 'ºC'),
	(9806, 108, '2015-01-15 01:18:25.000000', 'temperatura', 689.0000, 'ºC'),
	(9807, 108, '2015-01-15 01:18:26.000000', 'temperatura', 356.0000, 'ºC'),
	(9808, 108, '2015-01-15 01:18:27.000000', 'temperatura', 915.0000, 'ºC'),
	(9809, 108, '2015-01-15 01:18:28.000000', 'temperatura', 1105.0000, 'ºC'),
	(9810, 108, '2015-01-15 01:18:29.000000', 'temperatura', 382.0000, 'ºC'),
	(9811, 108, '2015-01-15 01:18:30.000000', 'temperatura', 993.0000, 'ºC'),
	(9812, 108, '2015-01-15 01:18:31.000000', 'temperatura', 222.0000, 'ºC'),
	(9813, 108, '2015-01-15 01:18:32.000000', 'temperatura', 532.0000, 'ºC'),
	(9814, 108, '2015-01-15 01:18:33.000000', 'temperatura', 793.0000, 'ºC'),
	(9815, 108, '2015-01-15 01:18:34.000000', 'temperatura', 1169.0000, 'ºC'),
	(9816, 108, '2015-01-15 01:18:35.000000', 'temperatura', 1068.0000, 'ºC'),
	(9817, 108, '2015-01-15 01:18:36.000000', 'temperatura', 633.0000, 'ºC'),
	(9818, 108, '2015-01-15 01:18:37.000000', 'temperatura', 1160.0000, 'ºC'),
	(9819, 108, '2015-01-15 01:18:38.000000', 'temperatura', 305.0000, 'ºC'),
	(9820, 108, '2015-01-15 01:18:39.000000', 'temperatura', 442.0000, 'ºC'),
	(9821, 108, '2015-01-15 01:18:40.000000', 'temperatura', 96.0000, 'ºC'),
	(9822, 108, '2015-01-15 01:18:41.000000', 'temperatura', 356.0000, 'ºC'),
	(9823, 108, '2015-01-15 01:18:42.000000', 'temperatura', 291.0000, 'ºC'),
	(9824, 108, '2015-01-15 01:18:43.000000', 'temperatura', 389.0000, 'ºC'),
	(9825, 108, '2015-01-15 01:18:44.000000', 'temperatura', 1070.0000, 'ºC'),
	(9826, 108, '2015-01-15 01:18:45.000000', 'temperatura', 585.0000, 'ºC'),
	(9827, 108, '2015-01-15 01:18:46.000000', 'temperatura', 916.0000, 'ºC'),
	(9828, 108, '2015-01-15 01:18:47.000000', 'temperatura', 424.0000, 'ºC'),
	(9829, 108, '2015-01-15 01:18:48.000000', 'temperatura', 574.0000, 'ºC'),
	(9830, 108, '2015-01-15 01:18:49.000000', 'temperatura', 396.0000, 'ºC'),
	(9831, 108, '2015-01-15 01:18:50.000000', 'temperatura', 260.0000, 'ºC'),
	(9832, 108, '2015-01-15 01:18:51.000000', 'temperatura', 113.0000, 'ºC'),
	(9833, 108, '2015-01-15 01:18:52.000000', 'temperatura', 984.0000, 'ºC'),
	(9834, 108, '2015-01-15 01:18:53.000000', 'temperatura', 982.0000, 'ºC'),
	(9835, 108, '2015-01-15 01:18:54.000000', 'temperatura', 758.0000, 'ºC'),
	(9836, 108, '2015-01-15 01:18:55.000000', 'temperatura', 847.0000, 'ºC'),
	(9837, 108, '2015-01-15 01:18:56.000000', 'temperatura', 758.0000, 'ºC'),
	(9838, 108, '2015-01-15 01:18:57.000000', 'temperatura', 53.0000, 'ºC'),
	(9839, 108, '2015-01-15 01:18:58.000000', 'temperatura', 389.0000, 'ºC'),
	(9840, 108, '2015-01-15 01:18:59.000000', 'temperatura', 589.0000, 'ºC'),
	(9841, 108, '2015-01-15 01:19:00.000000', 'temperatura', 577.0000, 'ºC'),
	(9842, 108, '2015-01-15 01:19:01.000000', 'temperatura', 1118.0000, 'ºC'),
	(9843, 108, '2015-01-15 01:19:02.000000', 'temperatura', 259.0000, 'ºC'),
	(9844, 108, '2015-01-15 01:19:03.000000', 'temperatura', 341.0000, 'ºC'),
	(9845, 108, '2015-01-15 01:19:04.000000', 'temperatura', 929.0000, 'ºC'),
	(9846, 108, '2015-01-15 01:19:05.000000', 'temperatura', 21.0000, 'ºC'),
	(9847, 108, '2015-01-15 01:19:06.000000', 'temperatura', 921.0000, 'ºC'),
	(9848, 108, '2015-01-15 01:19:07.000000', 'temperatura', 941.0000, 'ºC'),
	(9849, 108, '2015-01-15 01:19:08.000000', 'temperatura', 741.0000, 'ºC'),
	(9850, 108, '2015-01-15 01:19:09.000000', 'temperatura', 885.0000, 'ºC'),
	(9851, 108, '2015-01-15 01:19:10.000000', 'temperatura', 1003.0000, 'ºC'),
	(9852, 108, '2015-01-15 01:19:11.000000', 'temperatura', 1159.0000, 'ºC'),
	(9853, 108, '2015-01-15 01:19:12.000000', 'temperatura', 387.0000, 'ºC'),
	(9854, 108, '2015-01-15 01:19:13.000000', 'temperatura', 857.0000, 'ºC'),
	(9855, 108, '2015-01-15 01:19:14.000000', 'temperatura', 726.0000, 'ºC'),
	(9856, 108, '2015-01-15 01:19:15.000000', 'temperatura', 1059.0000, 'ºC'),
	(9857, 108, '2015-01-15 01:19:16.000000', 'temperatura', 719.0000, 'ºC'),
	(9858, 108, '2015-01-15 01:19:17.000000', 'temperatura', 416.0000, 'ºC'),
	(9859, 108, '2015-01-15 01:19:18.000000', 'temperatura', 1126.0000, 'ºC'),
	(9860, 108, '2015-01-15 01:19:19.000000', 'temperatura', 783.0000, 'ºC'),
	(9861, 108, '2015-01-15 01:19:20.000000', 'temperatura', 536.0000, 'ºC'),
	(9862, 108, '2015-01-15 01:19:21.000000', 'temperatura', 330.0000, 'ºC'),
	(9863, 108, '2015-01-15 01:19:22.000000', 'temperatura', 45.0000, 'ºC'),
	(9864, 108, '2015-01-15 01:19:23.000000', 'temperatura', 437.0000, 'ºC'),
	(9865, 108, '2015-01-15 01:19:24.000000', 'temperatura', 847.0000, 'ºC'),
	(9866, 108, '2015-01-15 01:19:25.000000', 'temperatura', 525.0000, 'ºC'),
	(9867, 108, '2015-01-15 01:19:26.000000', 'temperatura', 84.0000, 'ºC'),
	(9868, 108, '2015-01-15 01:19:27.000000', 'temperatura', 46.0000, 'ºC'),
	(9869, 108, '2015-01-15 01:19:28.000000', 'temperatura', 1178.0000, 'ºC'),
	(9870, 108, '2015-01-15 01:19:29.000000', 'temperatura', 954.0000, 'ºC'),
	(9871, 108, '2015-01-15 01:19:30.000000', 'temperatura', 35.0000, 'ºC'),
	(9872, 108, '2015-01-15 01:19:31.000000', 'temperatura', 913.0000, 'ºC'),
	(9873, 108, '2015-01-15 01:19:32.000000', 'temperatura', 863.0000, 'ºC'),
	(9874, 108, '2015-01-15 01:19:33.000000', 'temperatura', 375.0000, 'ºC'),
	(9875, 108, '2015-01-15 01:19:34.000000', 'temperatura', 487.0000, 'ºC'),
	(9876, 108, '2015-01-15 01:19:35.000000', 'temperatura', 108.0000, 'ºC'),
	(9877, 108, '2015-01-15 01:19:36.000000', 'temperatura', 283.0000, 'ºC'),
	(9878, 108, '2015-01-15 01:19:37.000000', 'temperatura', 1088.0000, 'ºC'),
	(9879, 108, '2015-01-15 01:19:38.000000', 'temperatura', 994.0000, 'ºC'),
	(9880, 108, '2015-01-15 01:19:39.000000', 'temperatura', 504.0000, 'ºC'),
	(9881, 108, '2015-01-15 01:19:40.000000', 'temperatura', 742.0000, 'ºC'),
	(9882, 108, '2015-01-15 01:19:41.000000', 'temperatura', 996.0000, 'ºC'),
	(9883, 108, '2015-01-15 01:19:42.000000', 'temperatura', 356.0000, 'ºC'),
	(9884, 108, '2015-01-15 01:19:43.000000', 'temperatura', 1190.0000, 'ºC'),
	(9885, 108, '2015-01-15 01:19:44.000000', 'temperatura', 84.0000, 'ºC'),
	(9886, 108, '2015-01-15 01:19:45.000000', 'temperatura', 450.0000, 'ºC'),
	(9887, 108, '2015-01-15 01:19:46.000000', 'temperatura', 798.0000, 'ºC'),
	(9888, 108, '2015-01-15 01:19:47.000000', 'temperatura', 241.0000, 'ºC'),
	(9889, 108, '2015-01-15 01:19:48.000000', 'temperatura', 10.0000, 'ºC'),
	(9890, 108, '2015-01-15 01:19:49.000000', 'temperatura', 527.0000, 'ºC'),
	(9891, 108, '2015-01-15 01:19:50.000000', 'temperatura', 206.0000, 'ºC'),
	(9892, 108, '2015-01-15 01:19:51.000000', 'temperatura', 648.0000, 'ºC'),
	(9893, 108, '2015-01-15 01:19:52.000000', 'temperatura', 224.0000, 'ºC'),
	(9894, 108, '2015-01-15 01:19:53.000000', 'temperatura', 374.0000, 'ºC'),
	(9895, 108, '2015-01-15 01:19:54.000000', 'temperatura', 1.0000, 'ºC'),
	(9896, 108, '2015-01-15 01:19:55.000000', 'temperatura', 84.0000, 'ºC'),
	(9897, 108, '2015-01-15 01:19:56.000000', 'temperatura', 418.0000, 'ºC'),
	(9898, 108, '2015-01-15 01:19:57.000000', 'temperatura', 639.0000, 'ºC'),
	(9899, 108, '2015-01-15 01:19:58.000000', 'temperatura', 739.0000, 'ºC'),
	(9900, 108, '2015-01-15 01:19:59.000000', 'temperatura', 580.0000, 'ºC'),
	(9901, 108, '2015-01-15 01:20:00.000000', 'temperatura', 682.0000, 'ºC'),
	(9902, 108, '2015-01-15 01:20:01.000000', 'temperatura', 473.0000, 'ºC'),
	(9903, 108, '2015-01-15 01:20:02.000000', 'temperatura', 320.0000, 'ºC'),
	(9904, 108, '2015-01-15 01:20:03.000000', 'temperatura', 179.0000, 'ºC'),
	(9905, 108, '2015-01-15 01:20:04.000000', 'temperatura', 1138.0000, 'ºC'),
	(9906, 108, '2015-01-15 01:20:05.000000', 'temperatura', 350.0000, 'ºC'),
	(9907, 108, '2015-01-15 01:20:06.000000', 'temperatura', 740.0000, 'ºC'),
	(9908, 108, '2015-01-15 01:20:07.000000', 'temperatura', 250.0000, 'ºC'),
	(9909, 108, '2015-01-15 01:20:08.000000', 'temperatura', 229.0000, 'ºC'),
	(9910, 108, '2015-01-15 01:20:09.000000', 'temperatura', 397.0000, 'ºC'),
	(9911, 108, '2015-01-15 01:20:10.000000', 'temperatura', 100.0000, 'ºC'),
	(9912, 108, '2015-01-15 01:20:11.000000', 'temperatura', 506.0000, 'ºC'),
	(9913, 108, '2015-01-15 01:20:12.000000', 'temperatura', 1032.0000, 'ºC'),
	(9914, 108, '2015-01-15 01:20:13.000000', 'temperatura', 42.0000, 'ºC'),
	(9915, 108, '2015-01-15 01:20:14.000000', 'temperatura', 716.0000, 'ºC'),
	(9916, 108, '2015-01-15 01:20:15.000000', 'temperatura', 1052.0000, 'ºC'),
	(9917, 108, '2015-01-15 01:20:16.000000', 'temperatura', 714.0000, 'ºC'),
	(9918, 108, '2015-01-15 01:20:17.000000', 'temperatura', 414.0000, 'ºC'),
	(9919, 108, '2015-01-15 01:20:18.000000', 'temperatura', 1127.0000, 'ºC'),
	(9920, 108, '2015-01-15 01:20:19.000000', 'temperatura', 794.0000, 'ºC'),
	(9921, 108, '2015-01-15 01:20:20.000000', 'temperatura', 590.0000, 'ºC'),
	(9922, 108, '2015-01-15 01:20:21.000000', 'temperatura', 570.0000, 'ºC'),
	(9923, 108, '2015-01-15 01:20:22.000000', 'temperatura', 1079.0000, 'ºC'),
	(9924, 108, '2015-01-15 01:20:23.000000', 'temperatura', 86.0000, 'ºC'),
	(9925, 108, '2015-01-15 01:20:24.000000', 'temperatura', 793.0000, 'ºC'),
	(9926, 108, '2015-01-15 01:20:25.000000', 'temperatura', 110.0000, 'ºC'),
	(9927, 108, '2015-01-15 01:20:26.000000', 'temperatura', 569.0000, 'ºC'),
	(9928, 108, '2015-01-15 01:20:27.000000', 'temperatura', 118.0000, 'ºC'),
	(9929, 108, '2015-01-15 01:20:28.000000', 'temperatura', 83.0000, 'ºC'),
	(9930, 108, '2015-01-15 01:20:29.000000', 'temperatura', 60.0000, 'ºC'),
	(9931, 108, '2015-01-15 01:20:30.000000', 'temperatura', 52.0000, 'ºC'),
	(9932, 108, '2015-01-15 01:20:31.000000', 'temperatura', 81.0000, 'ºC'),
	(9933, 108, '2015-01-15 01:20:32.000000', 'temperatura', 249.0000, 'ºC'),
	(9934, 108, '2015-01-15 01:20:33.000000', 'temperatura', 1003.0000, 'ºC'),
	(9935, 108, '2015-01-15 01:20:34.000000', 'temperatura', 668.0000, 'ºC'),
	(9936, 108, '2015-01-15 01:20:35.000000', 'temperatura', 330.0000, 'ºC'),
	(9937, 108, '2015-01-15 01:20:36.000000', 'temperatura', 847.0000, 'ºC'),
	(9938, 108, '2015-01-15 01:20:37.000000', 'temperatura', 845.0000, 'ºC'),
	(9939, 108, '2015-01-15 01:20:38.000000', 'temperatura', 486.0000, 'ºC'),
	(9940, 108, '2015-01-15 01:20:39.000000', 'temperatura', 1095.0000, 'ºC'),
	(9941, 108, '2015-01-15 01:20:40.000000', 'temperatura', 417.0000, 'ºC'),
	(9942, 108, '2015-01-15 01:20:41.000000', 'temperatura', 1.0000, 'ºC'),
	(9943, 108, '2015-01-15 01:20:42.000000', 'temperatura', 1155.0000, 'ºC'),
	(9944, 108, '2015-01-15 01:20:43.000000', 'temperatura', 971.0000, 'ºC'),
	(9945, 108, '2015-01-15 01:20:44.000000', 'temperatura', 191.0000, 'ºC'),
	(9946, 108, '2015-01-15 01:20:45.000000', 'temperatura', 444.0000, 'ºC'),
	(9947, 108, '2015-01-15 01:20:46.000000', 'temperatura', 447.0000, 'ºC'),
	(9948, 108, '2015-01-15 01:20:47.000000', 'temperatura', 903.0000, 'ºC'),
	(9949, 108, '2015-01-15 01:20:48.000000', 'temperatura', 774.0000, 'ºC'),
	(9950, 108, '2015-01-15 01:20:49.000000', 'temperatura', 1161.0000, 'ºC'),
	(9951, 108, '2015-01-15 01:20:50.000000', 'temperatura', 1084.0000, 'ºC'),
	(9952, 108, '2015-01-15 01:20:51.000000', 'temperatura', 738.0000, 'ºC'),
	(9953, 108, '2015-01-15 01:20:52.000000', 'temperatura', 438.0000, 'ºC'),
	(9954, 108, '2015-01-15 01:20:53.000000', 'temperatura', 1175.0000, 'ºC'),
	(9955, 108, '2015-01-15 01:20:54.000000', 'temperatura', 964.0000, 'ºC'),
	(9956, 108, '2015-01-15 01:20:55.000000', 'temperatura', 95.0000, 'ºC'),
	(9957, 108, '2015-01-15 01:20:56.000000', 'temperatura', 1183.0000, 'ºC'),
	(9958, 108, '2015-01-15 01:20:57.000000', 'temperatura', 831.0000, 'ºC'),
	(9959, 108, '2015-01-15 01:20:58.000000', 'temperatura', 605.0000, 'ºC'),
	(9960, 108, '2015-01-15 01:20:59.000000', 'temperatura', 534.0000, 'ºC'),
	(9961, 108, '2015-01-15 01:21:00.000000', 'temperatura', 855.0000, 'ºC'),
	(9962, 108, '2015-01-15 01:21:01.000000', 'temperatura', 274.0000, 'ºC'),
	(9963, 108, '2015-01-15 01:21:02.000000', 'temperatura', 5.0000, 'ºC'),
	(9964, 108, '2015-01-15 01:21:03.000000', 'temperatura', 405.0000, 'ºC'),
	(9965, 108, '2015-01-15 01:21:04.000000', 'temperatura', 811.0000, 'ºC'),
	(9966, 108, '2015-01-15 01:21:05.000000', 'temperatura', 439.0000, 'ºC'),
	(9967, 108, '2015-01-15 01:21:06.000000', 'temperatura', 964.0000, 'ºC'),
	(9968, 108, '2015-01-15 01:21:07.000000', 'temperatura', 1105.0000, 'ºC'),
	(9969, 108, '2015-01-15 01:21:08.000000', 'temperatura', 230.0000, 'ºC'),
	(9970, 108, '2015-01-15 01:21:09.000000', 'temperatura', 236.0000, 'ºC'),
	(9971, 108, '2015-01-15 01:21:10.000000', 'temperatura', 491.0000, 'ºC'),
	(9972, 108, '2015-01-15 01:21:11.000000', 'temperatura', 549.0000, 'ºC'),
	(9973, 108, '2015-01-15 01:21:12.000000', 'temperatura', 72.0000, 'ºC'),
	(9974, 108, '2015-01-15 01:21:13.000000', 'temperatura', 1114.0000, 'ºC'),
	(9975, 108, '2015-01-15 01:21:14.000000', 'temperatura', 554.0000, 'ºC'),
	(9976, 108, '2015-01-15 01:21:15.000000', 'temperatura', 627.0000, 'ºC'),
	(9977, 108, '2015-01-15 01:21:16.000000', 'temperatura', 274.0000, 'ºC'),
	(9978, 108, '2015-01-15 01:21:17.000000', 'temperatura', 692.0000, 'ºC'),
	(9979, 108, '2015-01-15 01:21:18.000000', 'temperatura', 236.0000, 'ºC'),
	(9980, 108, '2015-01-15 01:21:19.000000', 'temperatura', 306.0000, 'ºC'),
	(9981, 108, '2015-01-15 01:21:20.000000', 'temperatura', 824.0000, 'ºC'),
	(9982, 108, '2015-01-15 01:21:21.000000', 'temperatura', 800.0000, 'ºC'),
	(9983, 108, '2015-01-15 01:21:22.000000', 'temperatura', 327.0000, 'ºC'),
	(9984, 108, '2015-01-15 01:21:23.000000', 'temperatura', 437.0000, 'ºC'),
	(9985, 108, '2015-01-15 01:21:24.000000', 'temperatura', 7.0000, 'ºC'),
	(9986, 108, '2015-01-15 01:21:25.000000', 'temperatura', 1121.0000, 'ºC'),
	(9987, 108, '2015-01-15 01:21:26.000000', 'temperatura', 787.0000, 'ºC'),
	(9988, 108, '2015-01-15 01:21:27.000000', 'temperatura', 570.0000, 'ºC'),
	(9989, 108, '2015-01-15 01:21:28.000000', 'temperatura', 490.0000, 'ºC'),
	(9990, 108, '2015-01-15 01:21:29.000000', 'temperatura', 740.0000, 'ºC'),
	(9991, 108, '2015-01-15 01:21:30.000000', 'temperatura', 1031.0000, 'ºC'),
	(9992, 108, '2015-01-15 01:21:31.000000', 'temperatura', 535.0000, 'ºC'),
	(9993, 108, '2015-01-15 01:21:32.000000', 'temperatura', 785.0000, 'ºC'),
	(9994, 108, '2015-01-15 01:21:33.000000', 'temperatura', 1118.0000, 'ºC'),
	(9995, 108, '2015-01-15 01:21:34.000000', 'temperatura', 838.0000, 'ºC'),
	(9996, 108, '2015-01-15 01:21:35.000000', 'temperatura', 835.0000, 'ºC'),
	(9997, 108, '2015-01-15 01:21:36.000000', 'temperatura', 463.0000, 'ºC'),
	(9998, 108, '2015-01-15 01:21:37.000000', 'temperatura', 1010.0000, 'ºC'),
	(9999, 108, '2015-01-15 01:21:38.000000', 'temperatura', 63.0000, 'ºC'),
	(10000, 108, '2015-01-15 01:21:39.000000', 'temperatura', 884.0000, 'ºC'),
	(10001, 108, '2015-01-15 01:21:40.000000', 'temperatura', 632.0000, 'ºC'),
	(10002, 108, '2015-01-15 01:21:41.000000', 'temperatura', 507.0000, 'ºC'),
	(10003, 108, '2015-01-15 01:21:42.000000', 'temperatura', 641.0000, 'ºC'),
	(10004, 108, '2015-01-15 01:21:43.000000', 'temperatura', 485.0000, 'ºC'),
	(10005, 108, '2015-01-15 01:21:44.000000', 'temperatura', 503.0000, 'ºC'),
	(10006, 108, '2015-01-15 01:21:45.000000', 'temperatura', 1059.0000, 'ºC'),
	(10007, 108, '2015-01-15 01:21:46.000000', 'temperatura', 186.0000, 'ºC'),
	(10008, 108, '2015-01-15 01:21:47.000000', 'temperatura', 152.0000, 'ºC'),
	(10009, 108, '2015-01-15 01:21:48.000000', 'temperatura', 204.0000, 'ºC'),
	(10010, 108, '2015-01-15 01:21:49.000000', 'temperatura', 566.0000, 'ºC'),
	(10011, 108, '2015-01-15 01:21:50.000000', 'temperatura', 1017.0000, 'ºC'),
	(10012, 108, '2015-01-15 01:21:51.000000', 'temperatura', 986.0000, 'ºC'),
	(10013, 108, '2015-01-15 01:21:52.000000', 'temperatura', 682.0000, 'ºC'),
	(10014, 108, '2015-01-15 01:21:53.000000', 'temperatura', 453.0000, 'ºC'),
	(10015, 108, '2015-01-15 01:21:54.000000', 'temperatura', 217.0000, 'ºC'),
	(10016, 108, '2015-01-15 01:21:55.000000', 'temperatura', 927.0000, 'ºC'),
	(10017, 108, '2015-01-15 01:21:56.000000', 'temperatura', 386.0000, 'ºC'),
	(10018, 108, '2015-01-15 01:21:57.000000', 'temperatura', 351.0000, 'ºC'),
	(10019, 108, '2015-01-15 01:21:58.000000', 'temperatura', 595.0000, 'ºC'),
	(10020, 108, '2015-01-15 01:21:59.000000', 'temperatura', 725.0000, 'ºC'),
	(10021, 108, '2015-01-15 01:22:00.000000', 'temperatura', 638.0000, 'ºC'),
	(10022, 108, '2015-01-15 01:22:01.000000', 'temperatura', 1016.0000, 'ºC'),
	(10023, 108, '2015-01-15 01:22:02.000000', 'temperatura', 769.0000, 'ºC'),
	(10024, 108, '2015-01-15 01:22:03.000000', 'temperatura', 794.0000, 'ºC'),
	(10025, 108, '2015-01-15 01:22:04.000000', 'temperatura', 464.0000, 'ºC'),
	(10026, 108, '2015-01-15 01:22:05.000000', 'temperatura', 1141.0000, 'ºC'),
	(10027, 108, '2015-01-15 01:22:06.000000', 'temperatura', 712.0000, 'ºC'),
	(10028, 108, '2015-01-15 01:22:07.000000', 'temperatura', 136.0000, 'ºC'),
	(10029, 108, '2015-01-15 01:22:08.000000', 'temperatura', 945.0000, 'ºC'),
	(10030, 108, '2015-01-15 01:22:09.000000', 'temperatura', 716.0000, 'ºC'),
	(10031, 108, '2015-01-15 01:22:10.000000', 'temperatura', 747.0000, 'ºC'),
	(10032, 108, '2015-01-15 01:22:11.000000', 'temperatura', 387.0000, 'ºC'),
	(10033, 108, '2015-01-15 01:22:12.000000', 'temperatura', 895.0000, 'ºC'),
	(10034, 108, '2015-01-15 01:22:13.000000', 'temperatura', 912.0000, 'ºC'),
	(10035, 108, '2015-01-15 01:22:14.000000', 'temperatura', 678.0000, 'ºC'),
	(10036, 108, '2015-01-15 01:22:15.000000', 'temperatura', 654.0000, 'ºC'),
	(10037, 108, '2015-01-15 01:22:16.000000', 'temperatura', 38.0000, 'ºC'),
	(10038, 108, '2015-01-15 01:22:17.000000', 'temperatura', 626.0000, 'ºC'),
	(10039, 108, '2015-01-15 01:22:18.000000', 'temperatura', 618.0000, 'ºC'),
	(10040, 108, '2015-01-15 01:22:19.000000', 'temperatura', 10.0000, 'ºC'),
	(10041, 108, '2015-01-15 01:22:20.000000', 'temperatura', 598.0000, 'ºC'),
	(10042, 108, '2015-01-15 01:22:21.000000', 'temperatura', 562.0000, 'ºC'),
	(10043, 108, '2015-01-15 01:22:22.000000', 'temperatura', 1013.0000, 'ºC'),
	(10044, 108, '2015-01-15 01:22:23.000000', 'temperatura', 983.0000, 'ºC'),
	(10045, 108, '2015-01-15 01:22:24.000000', 'temperatura', 674.0000, 'ºC'),
	(10046, 108, '2015-01-15 01:22:25.000000', 'temperatura', 422.0000, 'ºC'),
	(10047, 108, '2015-01-15 01:22:26.000000', 'temperatura', 90.0000, 'ºC'),
	(10048, 108, '2015-01-15 01:22:27.000000', 'temperatura', 384.0000, 'ºC'),
	(10049, 108, '2015-01-15 01:22:28.000000', 'temperatura', 451.0000, 'ºC'),
	(10050, 108, '2015-01-15 01:22:29.000000', 'temperatura', 1103.0000, 'ºC'),
	(10051, 108, '2015-01-15 01:22:30.000000', 'temperatura', 564.0000, 'ºC'),
	(10052, 108, '2015-01-15 01:22:31.000000', 'temperatura', 709.0000, 'ºC'),
	(10053, 108, '2015-01-15 01:22:32.000000', 'temperatura', 654.0000, 'ºC'),
	(10054, 108, '2015-01-15 01:22:33.000000', 'temperatura', 1145.0000, 'ºC'),
	(10055, 108, '2015-01-15 01:22:34.000000', 'temperatura', 165.0000, 'ºC'),
	(10056, 108, '2015-01-15 01:22:35.000000', 'temperatura', 987.0000, 'ºC'),
	(10057, 108, '2015-01-15 01:22:36.000000', 'temperatura', 844.0000, 'ºC'),
	(10058, 108, '2015-01-15 01:22:37.000000', 'temperatura', 58.0000, 'ºC'),
	(10059, 108, '2015-01-15 01:22:38.000000', 'temperatura', 157.0000, 'ºC'),
	(10060, 108, '2015-01-15 01:22:39.000000', 'temperatura', 612.0000, 'ºC'),
	(10061, 108, '2015-01-15 01:22:40.000000', 'temperatura', 190.0000, 'ºC'),
	(10062, 108, '2015-01-15 01:22:41.000000', 'temperatura', 315.0000, 'ºC'),
	(10063, 108, '2015-01-15 01:22:42.000000', 'temperatura', 1004.0000, 'ºC'),
	(10064, 108, '2015-01-15 01:22:43.000000', 'temperatura', 478.0000, 'ºC'),
	(10065, 108, '2015-01-15 01:22:44.000000', 'temperatura', 578.0000, 'ºC'),
	(10066, 108, '2015-01-15 01:22:45.000000', 'temperatura', 255.0000, 'ºC'),
	(10067, 108, '2015-01-15 01:22:46.000000', 'temperatura', 742.0000, 'ºC'),
	(10068, 108, '2015-01-15 01:22:47.000000', 'temperatura', 544.0000, 'ºC'),
	(10069, 108, '2015-01-15 01:22:48.000000', 'temperatura', 495.0000, 'ºC'),
	(10070, 108, '2015-01-15 01:22:49.000000', 'temperatura', 845.0000, 'ºC'),
	(10071, 108, '2015-01-15 01:22:50.000000', 'temperatura', 341.0000, 'ºC'),
	(10072, 108, '2015-01-15 01:22:51.000000', 'temperatura', 369.0000, 'ºC'),
	(10073, 108, '2015-01-15 01:22:52.000000', 'temperatura', 823.0000, 'ºC'),
	(10074, 108, '2015-01-15 01:22:53.000000', 'temperatura', 608.0000, 'ºC'),
	(10075, 108, '2015-01-15 01:22:54.000000', 'temperatura', 571.0000, 'ºC'),
	(10076, 108, '2015-01-15 01:22:55.000000', 'temperatura', 1031.0000, 'ºC'),
	(10077, 108, '2015-01-15 01:22:56.000000', 'temperatura', 1042.0000, 'ºC'),
	(10078, 108, '2015-01-15 01:22:57.000000', 'temperatura', 920.0000, 'ºC'),
	(10079, 108, '2015-01-15 01:22:58.000000', 'temperatura', 272.0000, 'ºC'),
	(10080, 108, '2015-01-15 01:22:59.000000', 'temperatura', 1002.0000, 'ºC'),
	(10081, 108, '2015-01-15 01:23:00.000000', 'temperatura', 595.0000, 'ºC'),
	(10082, 108, '2015-01-15 01:23:01.000000', 'temperatura', 1168.0000, 'ºC'),
	(10083, 108, '2015-01-15 01:23:02.000000', 'temperatura', 455.0000, 'ºC'),
	(10084, 108, '2015-01-15 01:23:03.000000', 'temperatura', 1172.0000, 'ºC'),
	(10085, 108, '2015-01-15 01:23:04.000000', 'temperatura', 895.0000, 'ºC'),
	(10086, 108, '2015-01-15 01:23:05.000000', 'temperatura', 958.0000, 'ºC'),
	(10087, 108, '2015-01-15 01:23:06.000000', 'temperatura', 907.0000, 'ºC'),
	(10088, 108, '2015-01-15 01:23:07.000000', 'temperatura', 463.0000, 'ºC'),
	(10089, 108, '2015-01-15 01:23:08.000000', 'temperatura', 794.0000, 'ºC'),
	(10090, 108, '2015-01-15 01:23:09.000000', 'temperatura', 180.0000, 'ºC'),
	(10091, 108, '2015-01-15 01:23:10.000000', 'temperatura', 921.0000, 'ºC'),
	(10092, 108, '2015-01-15 01:23:11.000000', 'temperatura', 465.0000, 'ºC'),
	(10093, 108, '2015-01-15 01:23:12.000000', 'temperatura', 760.0000, 'ºC'),
	(10094, 108, '2015-01-15 01:23:13.000000', 'temperatura', 8.0000, 'ºC'),
	(10095, 108, '2015-01-15 01:23:14.000000', 'temperatura', 161.0000, 'ºC'),
	(10096, 108, '2015-01-15 01:23:15.000000', 'temperatura', 781.0000, 'ºC'),
	(10097, 108, '2015-01-15 01:23:16.000000', 'temperatura', 1021.0000, 'ºC'),
	(10098, 108, '2015-01-15 01:23:17.000000', 'temperatura', 362.0000, 'ºC'),
	(10099, 108, '2015-01-15 01:23:18.000000', 'temperatura', 1149.0000, 'ºC'),
	(10100, 108, '2015-01-15 01:23:19.000000', 'temperatura', 1059.0000, 'ºC'),
	(10101, 108, '2015-01-15 01:23:20.000000', 'temperatura', 647.0000, 'ºC'),
	(10102, 108, '2015-01-15 01:23:21.000000', 'temperatura', 58.0000, 'ºC'),
	(10103, 108, '2015-01-15 01:23:22.000000', 'temperatura', 750.0000, 'ºC'),
	(10104, 108, '2015-01-15 01:23:23.000000', 'temperatura', 1177.0000, 'ºC'),
	(10105, 108, '2015-01-15 01:23:24.000000', 'temperatura', 35.0000, 'ºC'),
	(10106, 108, '2015-01-15 01:23:25.000000', 'temperatura', 247.0000, 'ºC'),
	(10107, 108, '2015-01-15 01:23:26.000000', 'temperatura', 1129.0000, 'ºC'),
	(10108, 108, '2015-01-15 01:23:27.000000', 'temperatura', 103.0000, 'ºC'),
	(10109, 108, '2015-01-15 01:23:28.000000', 'temperatura', 729.0000, 'ºC'),
	(10110, 108, '2015-01-15 01:23:29.000000', 'temperatura', 938.0000, 'ºC'),
	(10111, 108, '2015-01-15 01:23:30.000000', 'temperatura', 105.0000, 'ºC'),
	(10112, 108, '2015-01-15 01:23:31.000000', 'temperatura', 108.0000, 'ºC'),
	(10113, 108, '2015-01-15 01:23:32.000000', 'temperatura', 228.0000, 'ºC'),
	(10114, 108, '2015-01-15 01:23:33.000000', 'temperatura', 816.0000, 'ºC'),
	(10115, 108, '2015-01-15 01:23:34.000000', 'temperatura', 997.0000, 'ºC'),
	(10116, 108, '2015-01-15 01:23:35.000000', 'temperatura', 137.0000, 'ºC'),
	(10117, 108, '2015-01-15 01:23:36.000000', 'temperatura', 92.0000, 'ºC'),
	(10118, 108, '2015-01-15 01:23:37.000000', 'temperatura', 53.0000, 'ºC'),
	(10119, 108, '2015-01-15 01:23:38.000000', 'temperatura', 1187.0000, 'ºC'),
	(10120, 108, '2015-01-15 01:23:39.000000', 'temperatura', 979.0000, 'ºC'),
	(10121, 108, '2015-01-15 01:23:40.000000', 'temperatura', 135.0000, 'ºC'),
	(10122, 108, '2015-01-15 01:23:41.000000', 'temperatura', 139.0000, 'ºC'),
	(10123, 108, '2015-01-15 01:23:42.000000', 'temperatura', 289.0000, 'ºC'),
	(10124, 108, '2015-01-15 01:23:43.000000', 'temperatura', 1030.0000, 'ºC'),
	(10125, 108, '2015-01-15 01:23:44.000000', 'temperatura', 683.0000, 'ºC'),
	(10126, 108, '2015-01-15 01:23:45.000000', 'temperatura', 324.0000, 'ºC'),
	(10127, 108, '2015-01-15 01:23:46.000000', 'temperatura', 771.0000, 'ºC'),
	(10128, 108, '2015-01-15 01:23:47.000000', 'temperatura', 484.0000, 'ºC'),
	(10129, 108, '2015-01-15 01:23:48.000000', 'temperatura', 108.0000, 'ºC'),
	(10130, 108, '2015-01-15 01:23:49.000000', 'temperatura', 287.0000, 'ºC'),
	(10131, 108, '2015-01-15 01:23:50.000000', 'temperatura', 1113.0000, 'ºC'),
	(10132, 108, '2015-01-15 01:23:51.000000', 'temperatura', 1105.0000, 'ºC'),
	(10133, 108, '2015-01-15 01:23:52.000000', 'temperatura', 986.0000, 'ºC'),
	(10134, 108, '2015-01-15 01:23:53.000000', 'temperatura', 415.0000, 'ºC'),
	(10135, 108, '2015-01-15 01:23:54.000000', 'temperatura', 317.0000, 'ºC'),
	(10136, 108, '2015-01-15 01:23:55.000000', 'temperatura', 339.0000, 'ºC'),
	(10137, 108, '2015-01-15 01:23:56.000000', 'temperatura', 748.0000, 'ºC'),
	(10138, 108, '2015-01-15 01:23:57.000000', 'temperatura', 322.0000, 'ºC'),
	(10139, 108, '2015-01-15 01:23:58.000000', 'temperatura', 566.0000, 'ºC'),
	(10140, 108, '2015-01-15 01:23:59.000000', 'temperatura', 664.0000, 'ºC'),
	(10141, 108, '2015-01-15 01:24:00.000000', 'temperatura', 423.0000, 'ºC'),
	(10142, 108, '2015-01-15 01:24:01.000000', 'temperatura', 122.0000, 'ºC'),
	(10143, 108, '2015-01-15 01:24:02.000000', 'temperatura', 540.0000, 'ºC'),
	(10144, 108, '2015-01-15 01:24:03.000000', 'temperatura', 1138.0000, 'ºC'),
	(10145, 108, '2015-01-15 01:24:04.000000', 'temperatura', 471.0000, 'ºC'),
	(10146, 108, '2015-01-15 01:24:05.000000', 'temperatura', 138.0000, 'ºC'),
	(10147, 108, '2015-01-15 01:24:06.000000', 'temperatura', 480.0000, 'ºC'),
	(10148, 108, '2015-01-15 01:24:07.000000', 'temperatura', 785.0000, 'ºC'),
	(10149, 108, '2015-01-15 01:24:08.000000', 'temperatura', 88.0000, 'ºC'),
	(10150, 108, '2015-01-15 01:24:09.000000', 'temperatura', 485.0000, 'ºC'),
	(10151, 108, '2015-01-15 01:24:10.000000', 'temperatura', 961.0000, 'ºC'),
	(10152, 108, '2015-01-15 01:24:11.000000', 'temperatura', 950.0000, 'ºC'),
	(10153, 108, '2015-01-15 01:24:12.000000', 'temperatura', 666.0000, 'ºC'),
	(10154, 108, '2015-01-15 01:24:13.000000', 'temperatura', 482.0000, 'ºC'),
	(10155, 108, '2015-01-15 01:24:14.000000', 'temperatura', 413.0000, 'ºC'),
	(10156, 108, '2015-01-15 01:24:15.000000', 'temperatura', 619.0000, 'ºC'),
	(10157, 108, '2015-01-15 01:24:16.000000', 'temperatura', 659.0000, 'ºC'),
	(10158, 108, '2015-01-15 01:24:17.000000', 'temperatura', 235.0000, 'ºC'),
	(10159, 108, '2015-01-15 01:24:18.000000', 'temperatura', 398.0000, 'ºC'),
	(10160, 108, '2015-01-15 01:24:19.000000', 'temperatura', 88.0000, 'ºC'),
	(10161, 108, '2015-01-15 01:24:20.000000', 'temperatura', 446.0000, 'ºC'),
	(10162, 108, '2015-01-15 01:24:21.000000', 'temperatura', 768.0000, 'ºC'),
	(10163, 108, '2015-01-15 01:24:22.000000', 'temperatura', 102.0000, 'ºC'),
	(10164, 108, '2015-01-15 01:24:23.000000', 'temperatura', 605.0000, 'ºC'),
	(10165, 108, '2015-01-15 01:24:24.000000', 'temperatura', 322.0000, 'ºC'),
	(10166, 108, '2015-01-15 01:24:25.000000', 'temperatura', 995.0000, 'ºC'),
	(10167, 108, '2015-01-15 01:24:26.000000', 'temperatura', 408.0000, 'ºC'),
	(10168, 108, '2015-01-15 01:24:27.000000', 'temperatura', 256.0000, 'ºC'),
	(10169, 108, '2015-01-15 01:24:28.000000', 'temperatura', 58.0000, 'ºC'),
	(10170, 108, '2015-01-15 01:24:29.000000', 'temperatura', 719.0000, 'ºC'),
	(10171, 108, '2015-01-15 01:24:30.000000', 'temperatura', 1025.0000, 'ºC'),
	(10172, 108, '2015-01-15 01:24:31.000000', 'temperatura', 567.0000, 'ºC'),
	(10173, 108, '2015-01-15 01:24:32.000000', 'temperatura', 962.0000, 'ºC'),
	(10174, 108, '2015-01-15 01:24:33.000000', 'temperatura', 709.0000, 'ºC'),
	(10175, 108, '2015-01-15 01:24:34.000000', 'temperatura', 661.0000, 'ºC'),
	(10176, 108, '2015-01-15 01:24:35.000000', 'temperatura', 1175.0000, 'ºC'),
	(10177, 108, '2015-01-15 01:24:36.000000', 'temperatura', 296.0000, 'ºC'),
	(10178, 108, '2015-01-15 01:24:37.000000', 'temperatura', 354.0000, 'ºC'),
	(10179, 108, '2015-01-15 01:24:38.000000', 'temperatura', 882.0000, 'ºC'),
	(10180, 108, '2015-01-15 01:24:39.000000', 'temperatura', 951.0000, 'ºC'),
	(10181, 108, '2015-01-15 01:24:40.000000', 'temperatura', 907.0000, 'ºC'),
	(10182, 108, '2015-01-15 01:24:41.000000', 'temperatura', 483.0000, 'ºC'),
	(10183, 108, '2015-01-15 01:24:42.000000', 'temperatura', 897.0000, 'ºC'),
	(10184, 108, '2015-01-15 01:24:43.000000', 'temperatura', 633.0000, 'ºC'),
	(10185, 108, '2015-01-15 01:24:44.000000', 'temperatura', 478.0000, 'ºC'),
	(10186, 108, '2015-01-15 01:24:45.000000', 'temperatura', 490.0000, 'ºC'),
	(10187, 108, '2015-01-15 01:24:46.000000', 'temperatura', 1015.0000, 'ºC'),
	(10188, 108, '2015-01-15 01:24:47.000000', 'temperatura', 6.0000, 'ºC'),
	(10189, 108, '2015-01-15 01:24:48.000000', 'temperatura', 587.0000, 'ºC'),
	(10190, 108, '2015-01-15 01:24:49.000000', 'temperatura', 517.0000, 'ºC'),
	(10191, 108, '2015-01-15 01:24:50.000000', 'temperatura', 824.0000, 'ºC'),
	(10192, 108, '2015-01-15 01:24:51.000000', 'temperatura', 172.0000, 'ºC'),
	(10193, 108, '2015-01-15 01:24:52.000000', 'temperatura', 785.0000, 'ºC'),
	(10194, 108, '2015-01-15 01:24:53.000000', 'temperatura', 1010.0000, 'ºC'),
	(10195, 108, '2015-01-15 01:24:54.000000', 'temperatura', 298.0000, 'ºC'),
	(10196, 108, '2015-01-15 01:24:55.000000', 'temperatura', 859.0000, 'ºC'),
	(10197, 108, '2015-01-15 01:24:56.000000', 'temperatura', 1003.0000, 'ºC'),
	(10198, 108, '2015-01-15 01:24:57.000000', 'temperatura', 38.0000, 'ºC'),
	(10199, 108, '2015-01-15 01:24:58.000000', 'temperatura', 780.0000, 'ºC'),
	(10200, 108, '2015-01-15 01:24:59.000000', 'temperatura', 188.0000, 'ºC'),
	(10201, 108, '2015-01-15 01:25:00.000000', 'temperatura', 1000.0000, 'ºC'),
	(10202, 108, '2015-01-15 01:25:01.000000', 'temperatura', 838.0000, 'ºC'),
	(10203, 108, '2015-01-15 01:25:02.000000', 'temperatura', 1190.0000, 'ºC'),
	(10204, 108, '2015-01-15 01:25:03.000000', 'temperatura', 1037.0000, 'ºC'),
	(10205, 108, '2015-01-15 01:25:04.000000', 'temperatura', 414.0000, 'ºC'),
	(10206, 108, '2015-01-15 01:25:05.000000', 'temperatura', 160.0000, 'ºC'),
	(10207, 108, '2015-01-15 01:25:06.000000', 'temperatura', 759.0000, 'ºC'),
	(10208, 108, '2015-01-15 01:25:07.000000', 'temperatura', 916.0000, 'ºC'),
	(10209, 108, '2015-01-15 01:25:08.000000', 'temperatura', 1103.0000, 'ºC'),
	(10210, 108, '2015-01-15 01:25:09.000000', 'temperatura', 366.0000, 'ºC'),
	(10211, 108, '2015-01-15 01:25:10.000000', 'temperatura', 925.0000, 'ºC'),
	(10212, 108, '2015-01-15 01:25:11.000000', 'temperatura', 1124.0000, 'ºC'),
	(10213, 108, '2015-01-15 01:25:12.000000', 'temperatura', 448.0000, 'ºC'),
	(10214, 108, '2015-01-15 01:25:13.000000', 'temperatura', 67.0000, 'ºC'),
	(10215, 108, '2015-01-15 01:25:14.000000', 'temperatura', 191.0000, 'ºC'),
	(10216, 108, '2015-01-15 01:25:15.000000', 'temperatura', 756.0000, 'ºC'),
	(10217, 108, '2015-01-15 01:25:16.000000', 'temperatura', 808.0000, 'ºC'),
	(10218, 108, '2015-01-15 01:25:17.000000', 'temperatura', 572.0000, 'ºC'),
	(10219, 108, '2015-01-15 01:25:18.000000', 'temperatura', 435.0000, 'ºC'),
	(10220, 108, '2015-01-15 01:25:19.000000', 'temperatura', 462.0000, 'ºC'),
	(10221, 108, '2015-01-15 01:25:20.000000', 'temperatura', 1006.0000, 'ºC'),
	(10222, 108, '2015-01-15 01:25:21.000000', 'temperatura', 43.0000, 'ºC'),
	(10223, 108, '2015-01-15 01:25:22.000000', 'temperatura', 796.0000, 'ºC'),
	(10224, 108, '2015-01-15 01:25:23.000000', 'temperatura', 251.0000, 'ºC'),
	(10225, 108, '2015-01-15 01:25:24.000000', 'temperatura', 71.0000, 'ºC'),
	(10226, 108, '2015-01-15 01:25:25.000000', 'temperatura', 799.0000, 'ºC'),
	(10227, 108, '2015-01-15 01:25:26.000000', 'temperatura', 186.0000, 'ºC'),
	(10228, 108, '2015-01-15 01:25:27.000000', 'temperatura', 931.0000, 'ºC'),
	(10229, 108, '2015-01-15 01:25:28.000000', 'temperatura', 500.0000, 'ºC'),
	(10230, 108, '2015-01-15 01:25:29.000000', 'temperatura', 907.0000, 'ºC'),
	(10231, 108, '2015-01-15 01:25:30.000000', 'temperatura', 633.0000, 'ºC'),
	(10232, 108, '2015-01-15 01:25:31.000000', 'temperatura', 446.0000, 'ºC'),
	(10233, 108, '2015-01-15 01:25:32.000000', 'temperatura', 333.0000, 'ºC'),
	(10234, 108, '2015-01-15 01:25:33.000000', 'temperatura', 326.0000, 'ºC'),
	(10235, 108, '2015-01-15 01:25:34.000000', 'temperatura', 632.0000, 'ºC'),
	(10236, 108, '2015-01-15 01:25:35.000000', 'temperatura', 983.0000, 'ºC'),
	(10237, 108, '2015-01-15 01:25:36.000000', 'temperatura', 619.0000, 'ºC'),
	(10238, 108, '2015-01-15 01:25:37.000000', 'temperatura', 147.0000, 'ºC'),
	(10239, 108, '2015-01-15 01:25:38.000000', 'temperatura', 77.0000, 'ºC'),
	(10240, 108, '2015-01-15 01:25:39.000000', 'temperatura', 1144.0000, 'ºC'),
	(10241, 108, '2015-01-15 01:25:40.000000', 'temperatura', 688.0000, 'ºC'),
	(10242, 108, '2015-01-15 01:25:41.000000', 'temperatura', 12.0000, 'ºC'),
	(10243, 108, '2015-01-15 01:25:42.000000', 'temperatura', 396.0000, 'ºC'),
	(10244, 108, '2015-01-15 01:25:43.000000', 'temperatura', 746.0000, 'ºC'),
	(10245, 108, '2015-01-15 01:25:44.000000', 'temperatura', 140.0000, 'ºC'),
	(10246, 108, '2015-01-15 01:25:45.000000', 'temperatura', 862.0000, 'ºC'),
	(10247, 108, '2015-01-15 01:25:46.000000', 'temperatura', 293.0000, 'ºC'),
	(10248, 108, '2015-01-15 01:25:47.000000', 'temperatura', 80.0000, 'ºC'),
	(10249, 108, '2015-01-15 01:25:48.000000', 'temperatura', 721.0000, 'ºC'),
	(10250, 108, '2015-01-15 01:25:49.000000', 'temperatura', 967.0000, 'ºC'),
	(10251, 108, '2015-01-15 01:25:50.000000', 'temperatura', 269.0000, 'ºC'),
	(10252, 108, '2015-01-15 01:25:51.000000', 'temperatura', 847.0000, 'ºC'),
	(10253, 108, '2015-01-15 01:25:52.000000', 'temperatura', 1030.0000, 'ºC'),
	(10254, 108, '2015-01-15 01:25:53.000000', 'temperatura', 206.0000, 'ºC'),
	(10255, 108, '2015-01-15 01:25:54.000000', 'temperatura', 341.0000, 'ºC'),
	(10256, 108, '2015-01-15 01:25:55.000000', 'temperatura', 1089.0000, 'ºC'),
	(10257, 108, '2015-01-15 01:25:56.000000', 'temperatura', 824.0000, 'ºC'),
	(10258, 108, '2015-01-15 01:25:57.000000', 'temperatura', 851.0000, 'ºC'),
	(10259, 108, '2015-01-15 01:25:58.000000', 'temperatura', 582.0000, 'ºC'),
	(10260, 108, '2015-01-15 01:25:59.000000', 'temperatura', 360.0000, 'ºC'),
	(10261, 108, '2015-01-15 01:26:00.000000', 'temperatura', 52.0000, 'ºC'),
	(10262, 108, '2015-01-15 01:26:01.000000', 'temperatura', 382.0000, 'ºC'),
	(10263, 108, '2015-01-15 01:26:02.000000', 'temperatura', 556.0000, 'ºC'),
	(10264, 108, '2015-01-15 01:26:03.000000', 'temperatura', 435.0000, 'ºC'),
	(10265, 108, '2015-01-15 01:26:04.000000', 'temperatura', 508.0000, 'ºC'),
	(10266, 108, '2015-01-15 01:26:05.000000', 'temperatura', 36.0000, 'ºC'),
	(10267, 108, '2015-01-15 01:26:06.000000', 'temperatura', 1056.0000, 'ºC'),
	(10268, 108, '2015-01-15 01:26:07.000000', 'temperatura', 371.0000, 'ºC'),
	(10269, 108, '2015-01-15 01:26:08.000000', 'temperatura', 1087.0000, 'ºC'),
	(10270, 108, '2015-01-15 01:26:09.000000', 'temperatura', 722.0000, 'ºC'),
	(10271, 108, '2015-01-15 01:26:10.000000', 'temperatura', 351.0000, 'ºC'),
	(10272, 108, '2015-01-15 01:26:11.000000', 'temperatura', 790.0000, 'ºC'),
	(10273, 108, '2015-01-15 01:26:12.000000', 'temperatura', 498.0000, 'ºC'),
	(10274, 108, '2015-01-15 01:26:13.000000', 'temperatura', 122.0000, 'ºC'),
	(10275, 108, '2015-01-15 01:26:14.000000', 'temperatura', 314.0000, 'ºC'),
	(10276, 108, '2015-01-15 01:26:15.000000', 'temperatura', 5.0000, 'ºC'),
	(10277, 108, '2015-01-15 01:26:16.000000', 'temperatura', 283.0000, 'ºC'),
	(10278, 108, '2015-01-15 01:26:17.000000', 'temperatura', 200.0000, 'ºC'),
	(10279, 108, '2015-01-15 01:26:18.000000', 'temperatura', 152.0000, 'ºC'),
	(10280, 108, '2015-01-15 01:26:19.000000', 'temperatura', 161.0000, 'ºC'),
	(10281, 108, '2015-01-15 01:26:20.000000', 'temperatura', 350.0000, 'ºC'),
	(10282, 108, '2015-01-15 01:26:21.000000', 'temperatura', 66.0000, 'ºC'),
	(10283, 108, '2015-01-15 01:26:22.000000', 'temperatura', 479.0000, 'ºC'),
	(10284, 108, '2015-01-15 01:26:23.000000', 'temperatura', 1000.0000, 'ºC'),
	(10285, 108, '2015-01-15 01:26:24.000000', 'temperatura', 1163.0000, 'ºC'),
	(10286, 108, '2015-01-15 01:26:25.000000', 'temperatura', 414.0000, 'ºC'),
	(10287, 108, '2015-01-15 01:26:26.000000', 'temperatura', 984.0000, 'ºC'),
	(10288, 108, '2015-01-15 01:26:27.000000', 'temperatura', 79.0000, 'ºC'),
	(10289, 108, '2015-01-15 01:26:28.000000', 'temperatura', 1044.0000, 'ºC'),
	(10290, 108, '2015-01-15 01:26:29.000000', 'temperatura', 182.0000, 'ºC'),
	(10291, 108, '2015-01-15 01:26:30.000000', 'temperatura', 180.0000, 'ºC'),
	(10292, 108, '2015-01-15 01:26:31.000000', 'temperatura', 353.0000, 'ºC'),
	(10293, 108, '2015-01-15 01:26:32.000000', 'temperatura', 25.0000, 'ºC'),
	(10294, 108, '2015-01-15 01:26:33.000000', 'temperatura', 266.0000, 'ºC'),
	(10295, 108, '2015-01-15 01:26:34.000000', 'temperatura', 56.0000, 'ºC'),
	(10296, 108, '2015-01-15 01:26:35.000000', 'temperatura', 682.0000, 'ºC'),
	(10297, 108, '2015-01-15 01:26:36.000000', 'temperatura', 842.0000, 'ºC'),
	(10298, 108, '2015-01-15 01:26:37.000000', 'temperatura', 964.0000, 'ºC'),
	(10299, 108, '2015-01-15 01:26:38.000000', 'temperatura', 1094.0000, 'ºC'),
	(10300, 108, '2015-01-15 01:26:39.000000', 'temperatura', 180.0000, 'ºC'),
	(10301, 108, '2015-01-15 01:26:40.000000', 'temperatura', 16.0000, 'ºC'),
	(10302, 108, '2015-01-15 01:26:41.000000', 'temperatura', 742.0000, 'ºC'),
	(10303, 108, '2015-01-15 01:26:42.000000', 'temperatura', 63.0000, 'ºC'),
	(10304, 108, '2015-01-15 01:26:43.000000', 'temperatura', 488.0000, 'ºC'),
	(10305, 108, '2015-01-15 01:26:44.000000', 'temperatura', 1053.0000, 'ºC'),
	(10306, 108, '2015-01-15 01:26:45.000000', 'temperatura', 200.0000, 'ºC'),
	(10307, 108, '2015-01-15 01:26:46.000000', 'temperatura', 241.0000, 'ºC'),
	(10308, 108, '2015-01-15 01:26:47.000000', 'temperatura', 605.0000, 'ºC'),
	(10309, 108, '2015-01-15 01:26:48.000000', 'temperatura', 1103.0000, 'ºC'),
	(10310, 108, '2015-01-15 01:26:49.000000', 'temperatura', 101.0000, 'ºC'),
	(10311, 108, '2015-01-15 01:26:50.000000', 'temperatura', 794.0000, 'ºC'),
	(10312, 108, '2015-01-15 01:26:51.000000', 'temperatura', 70.0000, 'ºC'),
	(10313, 108, '2015-01-15 01:26:52.000000', 'temperatura', 368.0000, 'ºC'),
	(10314, 108, '2015-01-15 01:26:53.000000', 'temperatura', 432.0000, 'ºC'),
	(10315, 108, '2015-01-15 01:26:54.000000', 'temperatura', 1053.0000, 'ºC'),
	(10316, 108, '2015-01-15 01:26:55.000000', 'temperatura', 373.0000, 'ºC'),
	(10317, 108, '2015-01-15 01:26:56.000000', 'temperatura', 1104.0000, 'ºC'),
	(10318, 108, '2015-01-15 01:26:57.000000', 'temperatura', 801.0000, 'ºC'),
	(10319, 108, '2015-01-15 01:26:58.000000', 'temperatura', 695.0000, 'ºC'),
	(10320, 108, '2015-01-15 01:26:59.000000', 'temperatura', 1073.0000, 'ºC'),
	(10321, 108, '2015-01-15 01:27:00.000000', 'temperatura', 882.0000, 'ºC'),
	(10322, 108, '2015-01-15 01:27:01.000000', 'temperatura', 1190.0000, 'ºC'),
	(10323, 108, '2015-01-15 01:27:02.000000', 'temperatura', 903.0000, 'ºC'),
	(10324, 108, '2015-01-15 01:27:03.000000', 'temperatura', 947.0000, 'ºC'),
	(10325, 108, '2015-01-15 01:27:04.000000', 'temperatura', 827.0000, 'ºC'),
	(10326, 108, '2015-01-15 01:27:05.000000', 'temperatura', 94.0000, 'ºC'),
	(10327, 108, '2015-01-15 01:27:06.000000', 'temperatura', 390.0000, 'ºC'),
	(10328, 108, '2015-01-15 01:27:07.000000', 'temperatura', 467.0000, 'ºC'),
	(10329, 108, '2015-01-15 01:27:08.000000', 'temperatura', 1164.0000, 'ºC'),
	(10330, 108, '2015-01-15 01:27:09.000000', 'temperatura', 823.0000, 'ºC'),
	(10331, 108, '2015-01-15 01:27:10.000000', 'temperatura', 622.0000, 'ºC'),
	(10332, 108, '2015-01-15 01:27:11.000000', 'temperatura', 643.0000, 'ºC'),
	(10333, 108, '2015-01-15 01:27:12.000000', 'temperatura', 147.0000, 'ºC'),
	(10334, 108, '2015-01-15 01:27:13.000000', 'temperatura', 6.0000, 'ºC'),
	(10335, 108, '2015-01-15 01:27:14.000000', 'temperatura', 789.0000, 'ºC'),
	(10336, 108, '2015-01-15 01:27:15.000000', 'temperatura', 326.0000, 'ºC'),
	(10337, 108, '2015-01-15 01:27:16.000000', 'temperatura', 467.0000, 'ºC'),
	(10338, 108, '2015-01-15 01:27:17.000000', 'temperatura', 158.0000, 'ºC'),
	(10339, 108, '2015-01-15 01:27:18.000000', 'temperatura', 589.0000, 'ºC'),
	(10340, 108, '2015-01-15 01:27:19.000000', 'temperatura', 70.0000, 'ºC'),
	(10341, 108, '2015-01-15 01:27:20.000000', 'temperatura', 986.0000, 'ºC'),
	(10342, 108, '2015-01-15 01:27:21.000000', 'temperatura', 1120.0000, 'ºC'),
	(10343, 108, '2015-01-15 01:27:22.000000', 'temperatura', 242.0000, 'ºC'),
	(10344, 108, '2015-01-15 01:27:23.000000', 'temperatura', 250.0000, 'ºC'),
	(10345, 108, '2015-01-15 01:27:24.000000', 'temperatura', 526.0000, 'ºC'),
	(10346, 108, '2015-01-15 01:27:25.000000', 'temperatura', 681.0000, 'ºC'),
	(10347, 108, '2015-01-15 01:27:26.000000', 'temperatura', 625.0000, 'ºC'),
	(10348, 108, '2015-01-15 01:27:27.000000', 'temperatura', 1083.0000, 'ºC'),
	(10349, 108, '2015-01-15 01:27:28.000000', 'temperatura', 1143.0000, 'ºC'),
	(10350, 108, '2015-01-15 01:27:29.000000', 'temperatura', 65.0000, 'ºC'),
	(10351, 108, '2015-01-15 01:27:30.000000', 'temperatura', 495.0000, 'ºC'),
	(10352, 108, '2015-01-15 01:27:31.000000', 'temperatura', 1084.0000, 'ºC'),
	(10353, 108, '2015-01-15 01:27:32.000000', 'temperatura', 332.0000, 'ºC'),
	(10354, 108, '2015-01-15 01:27:33.000000', 'temperatura', 809.0000, 'ºC'),
	(10355, 108, '2015-01-15 01:27:34.000000', 'temperatura', 649.0000, 'ºC'),
	(10356, 108, '2015-01-15 01:27:35.000000', 'temperatura', 819.0000, 'ºC'),
	(10357, 108, '2015-01-15 01:27:36.000000', 'temperatura', 949.0000, 'ºC'),
	(10358, 108, '2015-01-15 01:27:37.000000', 'temperatura', 1088.0000, 'ºC'),
	(10359, 108, '2015-01-15 01:27:38.000000', 'temperatura', 194.0000, 'ºC'),
	(10360, 108, '2015-01-15 01:27:39.000000', 'temperatura', 108.0000, 'ºC'),
	(10361, 108, '2015-01-15 01:27:40.000000', 'temperatura', 1156.0000, 'ºC'),
	(10362, 108, '2015-01-15 01:27:41.000000', 'temperatura', 658.0000, 'ºC'),
	(10363, 108, '2015-01-15 01:27:42.000000', 'temperatura', 1022.0000, 'ºC'),
	(10364, 108, '2015-01-15 01:27:43.000000', 'temperatura', 736.0000, 'ºC'),
	(10365, 108, '2015-01-15 01:27:44.000000', 'temperatura', 616.0000, 'ºC'),
	(10366, 108, '2015-01-15 01:27:45.000000', 'temperatura', 870.0000, 'ºC'),
	(10367, 108, '2015-01-15 01:27:46.000000', 'temperatura', 104.0000, 'ºC'),
	(10368, 108, '2015-01-15 01:27:47.000000', 'temperatura', 310.0000, 'ºC'),
	(10369, 108, '2015-01-15 01:27:48.000000', 'temperatura', 40.0000, 'ºC'),
	(10370, 108, '2015-01-15 01:27:49.000000', 'temperatura', 468.0000, 'ºC'),
	(10371, 108, '2015-01-15 01:27:50.000000', 'temperatura', 1020.0000, 'ºC'),
	(10372, 108, '2015-01-15 01:27:51.000000', 'temperatura', 97.0000, 'ºC'),
	(10373, 108, '2015-01-15 01:27:52.000000', 'temperatura', 1027.0000, 'ºC'),
	(10374, 108, '2015-01-15 01:27:53.000000', 'temperatura', 42.0000, 'ºC'),
	(10375, 108, '2015-01-15 01:27:54.000000', 'temperatura', 730.0000, 'ºC'),
	(10376, 108, '2015-01-15 01:27:55.000000', 'temperatura', 1123.0000, 'ºC'),
	(10377, 108, '2015-01-15 01:27:56.000000', 'temperatura', 1027.0000, 'ºC'),
	(10378, 108, '2015-01-15 01:27:57.000000', 'temperatura', 568.0000, 'ºC'),
	(10379, 108, '2015-01-15 01:27:58.000000', 'temperatura', 959.0000, 'ºC'),
	(10380, 108, '2015-01-15 01:27:59.000000', 'temperatura', 693.0000, 'ºC'),
	(10381, 108, '2015-01-15 01:28:00.000000', 'temperatura', 588.0000, 'ºC'),
	(10382, 108, '2015-01-15 01:28:01.000000', 'temperatura', 859.0000, 'ºC'),
	(10383, 108, '2015-01-15 01:28:02.000000', 'temperatura', 133.0000, 'ºC'),
	(10384, 108, '2015-01-15 01:28:03.000000', 'temperatura', 490.0000, 'ºC'),
	(10385, 108, '2015-01-15 01:28:04.000000', 'temperatura', 848.0000, 'ºC'),
	(10386, 108, '2015-01-15 01:28:05.000000', 'temperatura', 373.0000, 'ºC'),
	(10387, 108, '2015-01-15 01:28:06.000000', 'temperatura', 522.0000, 'ºC'),
	(10388, 108, '2015-01-15 01:28:07.000000', 'temperatura', 290.0000, 'ºC'),
	(10389, 108, '2015-01-15 01:28:08.000000', 'temperatura', 1086.0000, 'ºC'),
	(10390, 108, '2015-01-15 01:28:09.000000', 'temperatura', 960.0000, 'ºC'),
	(10391, 108, '2015-01-15 01:28:10.000000', 'temperatura', 344.0000, 'ºC'),
	(10392, 108, '2015-01-15 01:28:11.000000', 'temperatura', 41.0000, 'ºC'),
	(10393, 108, '2015-01-15 01:28:12.000000', 'temperatura', 374.0000, 'ºC'),
	(10394, 108, '2015-01-15 01:28:13.000000', 'temperatura', 548.0000, 'ºC'),
	(10395, 108, '2015-01-15 01:28:14.000000', 'temperatura', 417.0000, 'ºC'),
	(10396, 108, '2015-01-15 01:28:15.000000', 'temperatura', 441.0000, 'ºC'),
	(10397, 108, '2015-01-15 01:28:16.000000', 'temperatura', 955.0000, 'ºC'),
	(10398, 108, '2015-01-15 01:28:17.000000', 'temperatura', 1051.0000, 'ºC'),
	(10399, 108, '2015-01-15 01:28:18.000000', 'temperatura', 1193.0000, 'ºC'),
	(10400, 108, '2015-01-15 01:28:19.000000', 'temperatura', 410.0000, 'ºC'),
	(10401, 108, '2015-01-15 01:28:20.000000', 'temperatura', 874.0000, 'ºC'),
	(10402, 108, '2015-01-15 01:28:21.000000', 'temperatura', 739.0000, 'ºC'),
	(10403, 108, '2015-01-15 01:28:22.000000', 'temperatura', 1073.0000, 'ºC'),
	(10404, 108, '2015-01-15 01:28:23.000000', 'temperatura', 750.0000, 'ºC'),
	(10405, 108, '2015-01-15 01:28:24.000000', 'temperatura', 532.0000, 'ºC'),
	(10406, 108, '2015-01-15 01:28:25.000000', 'temperatura', 409.0000, 'ºC'),
	(10407, 108, '2015-01-15 01:28:26.000000', 'temperatura', 449.0000, 'ºC'),
	(10408, 108, '2015-01-15 01:28:27.000000', 'temperatura', 1019.0000, 'ºC'),
	(10409, 108, '2015-01-15 01:28:28.000000', 'temperatura', 148.0000, 'ºC'),
	(10410, 108, '2015-01-15 01:28:29.000000', 'temperatura', 85.0000, 'ºC'),
	(10411, 108, '2015-01-15 01:28:30.000000', 'temperatura', 1181.0000, 'ºC'),
	(10412, 108, '2015-01-15 01:28:31.000000', 'temperatura', 851.0000, 'ºC'),
	(10413, 108, '2015-01-15 01:28:32.000000', 'temperatura', 713.0000, 'ºC'),
	(10414, 108, '2015-01-15 01:28:33.000000', 'temperatura', 1011.0000, 'ºC'),
	(10415, 108, '2015-01-15 01:28:34.000000', 'temperatura', 516.0000, 'ºC'),
	(10416, 108, '2015-01-15 01:28:35.000000', 'temperatura', 750.0000, 'ºC'),
	(10417, 108, '2015-01-15 01:28:36.000000', 'temperatura', 1002.0000, 'ºC'),
	(10418, 108, '2015-01-15 01:28:37.000000', 'temperatura', 362.0000, 'ºC'),
	(10419, 108, '2015-01-15 01:28:38.000000', 'temperatura', 3.0000, 'ºC'),
	(10420, 108, '2015-01-15 01:28:39.000000', 'temperatura', 132.0000, 'ºC'),
	(10421, 108, '2015-01-15 01:28:40.000000', 'temperatura', 648.0000, 'ºC'),
	(10422, 108, '2015-01-15 01:28:41.000000', 'temperatura', 447.0000, 'ºC'),
	(10423, 108, '2015-01-15 01:28:42.000000', 'temperatura', 290.0000, 'ºC'),
	(10424, 108, '2015-01-15 01:28:43.000000', 'temperatura', 112.0000, 'ºC'),
	(10425, 108, '2015-01-15 01:28:44.000000', 'temperatura', 888.0000, 'ºC'),
	(10426, 108, '2015-01-15 01:28:45.000000', 'temperatura', 504.0000, 'ºC'),
	(10427, 108, '2015-01-15 01:28:46.000000', 'temperatura', 1057.0000, 'ºC'),
	(10428, 108, '2015-01-15 01:28:47.000000', 'temperatura', 174.0000, 'ºC'),
	(10429, 108, '2015-01-15 01:28:48.000000', 'temperatura', 97.0000, 'ºC'),
	(10430, 108, '2015-01-15 01:28:49.000000', 'temperatura', 1167.0000, 'ºC'),
	(10431, 108, '2015-01-15 01:28:50.000000', 'temperatura', 742.0000, 'ºC'),
	(10432, 108, '2015-01-15 01:28:51.000000', 'temperatura', 211.0000, 'ºC'),
	(10433, 108, '2015-01-15 01:28:52.000000', 'temperatura', 29.0000, 'ºC'),
	(10434, 108, '2015-01-15 01:28:53.000000', 'temperatura', 711.0000, 'ºC'),
	(10435, 108, '2015-01-15 01:28:54.000000', 'temperatura', 1071.0000, 'ºC'),
	(10436, 108, '2015-01-15 01:28:55.000000', 'temperatura', 820.0000, 'ºC'),
	(10437, 108, '2015-01-15 01:28:56.000000', 'temperatura', 886.0000, 'ºC'),
	(10438, 108, '2015-01-15 01:28:57.000000', 'temperatura', 774.0000, 'ºC'),
	(10439, 108, '2015-01-15 01:28:58.000000', 'temperatura', 12.0000, 'ºC'),
	(10440, 108, '2015-01-15 01:28:59.000000', 'temperatura', 140.0000, 'ºC'),
	(10441, 108, '2015-01-15 01:29:00.000000', 'temperatura', 661.0000, 'ºC'),
	(10442, 108, '2015-01-15 01:29:01.000000', 'temperatura', 489.0000, 'ºC'),
	(10443, 108, '2015-01-15 01:29:02.000000', 'temperatura', 459.0000, 'ºC'),
	(10444, 108, '2015-01-15 01:29:03.000000', 'temperatura', 832.0000, 'ºC'),
	(10445, 108, '2015-01-15 01:29:04.000000', 'temperatura', 381.0000, 'ºC'),
	(10446, 108, '2015-01-15 01:29:05.000000', 'temperatura', 611.0000, 'ºC'),
	(10447, 108, '2015-01-15 01:29:06.000000', 'temperatura', 712.0000, 'ºC'),
	(10448, 108, '2015-01-15 01:29:07.000000', 'temperatura', 528.0000, 'ºC'),
	(10449, 108, '2015-01-15 01:29:08.000000', 'temperatura', 503.0000, 'ºC'),
	(10450, 108, '2015-01-15 01:29:09.000000', 'temperatura', 933.0000, 'ºC'),
	(10451, 108, '2015-01-15 01:29:10.000000', 'temperatura', 754.0000, 'ºC'),
	(10452, 108, '2015-01-15 01:29:11.000000', 'temperatura', 972.0000, 'ºC'),
	(10453, 108, '2015-01-15 01:29:12.000000', 'temperatura', 201.0000, 'ºC'),
	(10454, 108, '2015-01-15 01:29:13.000000', 'temperatura', 487.0000, 'ºC'),
	(10455, 108, '2015-01-15 01:29:14.000000', 'temperatura', 634.0000, 'ºC'),
	(10456, 108, '2015-01-15 01:29:15.000000', 'temperatura', 510.0000, 'ºC'),
	(10457, 108, '2015-01-15 01:29:16.000000', 'temperatura', 646.0000, 'ºC'),
	(10458, 108, '2015-01-15 01:29:17.000000', 'temperatura', 501.0000, 'ºC'),
	(10459, 108, '2015-01-15 01:29:18.000000', 'temperatura', 567.0000, 'ºC'),
	(10460, 108, '2015-01-15 01:29:19.000000', 'temperatura', 133.0000, 'ºC'),
	(10461, 108, '2015-01-15 01:29:20.000000', 'temperatura', 165.0000, 'ºC'),
	(10462, 108, '2015-01-15 01:29:21.000000', 'temperatura', 427.0000, 'ºC'),
	(10463, 108, '2015-01-15 01:29:22.000000', 'temperatura', 438.0000, 'ºC'),
	(10464, 108, '2015-01-15 01:29:23.000000', 'temperatura', 912.0000, 'ºC'),
	(10465, 108, '2015-01-15 01:29:24.000000', 'temperatura', 847.0000, 'ºC'),
	(10466, 108, '2015-01-15 01:29:25.000000', 'temperatura', 298.0000, 'ºC'),
	(10467, 108, '2015-01-15 01:29:26.000000', 'temperatura', 152.0000, 'ºC'),
	(10468, 108, '2015-01-15 01:29:27.000000', 'temperatura', 1064.0000, 'ºC'),
	(10469, 108, '2015-01-15 01:29:28.000000', 'temperatura', 65.0000, 'ºC'),
	(10470, 108, '2015-01-15 01:29:29.000000', 'temperatura', 732.0000, 'ºC'),
	(10471, 108, '2015-01-15 01:29:30.000000', 'temperatura', 1067.0000, 'ºC'),
	(10472, 108, '2015-01-15 01:29:31.000000', 'temperatura', 739.0000, 'ºC'),
	(10473, 108, '2015-01-15 01:29:32.000000', 'temperatura', 493.0000, 'ºC'),
	(10474, 108, '2015-01-15 01:29:33.000000', 'temperatura', 251.0000, 'ºC'),
	(10475, 108, '2015-01-15 01:29:34.000000', 'temperatura', 977.0000, 'ºC'),
	(10476, 108, '2015-01-15 01:29:35.000000', 'temperatura', 533.0000, 'ºC'),
	(10477, 108, '2015-01-15 01:29:36.000000', 'temperatura', 935.0000, 'ºC'),
	(10478, 108, '2015-01-15 01:29:37.000000', 'temperatura', 675.0000, 'ºC'),
	(10479, 108, '2015-01-15 01:29:38.000000', 'temperatura', 569.0000, 'ºC'),
	(10480, 108, '2015-01-15 01:29:39.000000', 'temperatura', 824.0000, 'ºC'),
	(10481, 108, '2015-01-15 01:29:40.000000', 'temperatura', 11.0000, 'ºC'),
	(10482, 108, '2015-01-15 01:29:41.000000', 'temperatura', 1183.0000, 'ºC'),
	(10483, 108, '2015-01-15 01:29:42.000000', 'temperatura', 1081.0000, 'ºC'),
	(10484, 108, '2015-01-15 01:29:43.000000', 'temperatura', 660.0000, 'ºC'),
	(10485, 108, '2015-01-15 01:29:44.000000', 'temperatura', 56.0000, 'ºC'),
	(10486, 108, '2015-01-15 01:29:45.000000', 'temperatura', 699.0000, 'ºC'),
	(10487, 108, '2015-01-15 01:29:46.000000', 'temperatura', 929.0000, 'ºC'),
	(10488, 108, '2015-01-15 01:29:47.000000', 'temperatura', 150.0000, 'ºC'),
	(10489, 108, '2015-01-15 01:29:48.000000', 'temperatura', 362.0000, 'ºC'),
	(10490, 108, '2015-01-15 01:29:49.000000', 'temperatura', 160.0000, 'ºC'),
	(10491, 108, '2015-01-15 01:29:50.000000', 'temperatura', 915.0000, 'ºC'),
	(10492, 108, '2015-01-15 01:29:51.000000', 'temperatura', 494.0000, 'ºC'),
	(10493, 108, '2015-01-15 01:29:52.000000', 'temperatura', 928.0000, 'ºC'),
	(10494, 108, '2015-01-15 01:29:53.000000', 'temperatura', 755.0000, 'ºC'),
	(10495, 108, '2015-01-15 01:29:54.000000', 'temperatura', 995.0000, 'ºC'),
	(10496, 108, '2015-01-15 01:29:55.000000', 'temperatura', 310.0000, 'ºC'),
	(10497, 108, '2015-01-15 01:29:56.000000', 'temperatura', 965.0000, 'ºC'),
	(10498, 108, '2015-01-15 01:29:57.000000', 'temperatura', 295.0000, 'ºC'),
	(10499, 108, '2015-01-15 01:29:58.000000', 'temperatura', 980.0000, 'ºC'),
	(10500, 108, '2015-01-15 01:29:59.000000', 'temperatura', 417.0000, 'ºC'),
	(10501, 108, '2015-01-15 01:30:00.000000', 'temperatura', 344.0000, 'ºC'),
	(10502, 108, '2015-01-15 01:30:01.000000', 'temperatura', 469.0000, 'ºC'),
	(10503, 108, '2015-01-15 01:30:02.000000', 'temperatura', 114.0000, 'ºC'),
	(10504, 108, '2015-01-15 01:30:03.000000', 'temperatura', 362.0000, 'ºC'),
	(10505, 108, '2015-01-15 01:30:04.000000', 'temperatura', 271.0000, 'ºC'),
	(10506, 108, '2015-01-15 01:30:05.000000', 'temperatura', 270.0000, 'ºC'),
	(10507, 108, '2015-01-15 01:30:06.000000', 'temperatura', 537.0000, 'ºC'),
	(10508, 108, '2015-01-15 01:30:07.000000', 'temperatura', 676.0000, 'ºC'),
	(10509, 108, '2015-01-15 01:30:08.000000', 'temperatura', 568.0000, 'ºC'),
	(10510, 108, '2015-01-15 01:30:09.000000', 'temperatura', 812.0000, 'ºC'),
	(10511, 108, '2015-01-15 01:30:10.000000', 'temperatura', 1157.0000, 'ºC'),
	(10512, 108, '2015-01-15 01:30:11.000000', 'temperatura', 951.0000, 'ºC'),
	(10513, 108, '2015-01-15 01:30:12.000000', 'temperatura', 84.0000, 'ºC'),
	(10514, 108, '2015-01-15 01:30:13.000000', 'temperatura', 1168.0000, 'ºC'),
	(10515, 108, '2015-01-15 01:30:14.000000', 'temperatura', 789.0000, 'ºC'),
	(10516, 108, '2015-01-15 01:30:15.000000', 'temperatura', 440.0000, 'ºC'),
	(10517, 108, '2015-01-15 01:30:16.000000', 'temperatura', 1036.0000, 'ºC'),
	(10518, 108, '2015-01-15 01:30:17.000000', 'temperatura', 258.0000, 'ºC'),
	(10519, 108, '2015-01-15 01:30:18.000000', 'temperatura', 582.0000, 'ºC'),
	(10520, 108, '2015-01-15 01:30:19.000000', 'temperatura', 938.0000, 'ºC'),
	(10521, 108, '2015-01-15 01:30:20.000000', 'temperatura', 544.0000, 'ºC'),
	(10522, 108, '2015-01-15 01:30:21.000000', 'temperatura', 1107.0000, 'ºC'),
	(10523, 108, '2015-01-15 01:30:22.000000', 'temperatura', 302.0000, 'ºC'),
	(10524, 108, '2015-01-15 01:30:23.000000', 'temperatura', 589.0000, 'ºC'),
	(10525, 108, '2015-01-15 01:30:24.000000', 'temperatura', 841.0000, 'ºC'),
	(10526, 108, '2015-01-15 01:30:25.000000', 'temperatura', 39.0000, 'ºC'),
	(10527, 108, '2015-01-15 01:30:26.000000', 'temperatura', 71.0000, 'ºC'),
	(10528, 108, '2015-01-15 01:30:27.000000', 'temperatura', 239.0000, 'ºC'),
	(10529, 108, '2015-01-15 01:30:28.000000', 'temperatura', 982.0000, 'ºC'),
	(10530, 108, '2015-01-15 01:30:29.000000', 'temperatura', 593.0000, 'ºC'),
	(10531, 108, '2015-01-15 01:30:30.000000', 'temperatura', 22.0000, 'ºC'),
	(10532, 108, '2015-01-15 01:30:31.000000', 'temperatura', 731.0000, 'ºC'),
	(10533, 108, '2015-01-15 01:30:32.000000', 'temperatura', 1189.0000, 'ºC'),
	(10534, 108, '2015-01-15 01:30:33.000000', 'temperatura', 153.0000, 'ºC'),
	(10535, 108, '2015-01-15 01:30:34.000000', 'temperatura', 797.0000, 'ºC'),
	(10536, 108, '2015-01-15 01:30:35.000000', 'temperatura', 1126.0000, 'ºC'),
	(10537, 108, '2015-01-15 01:30:36.000000', 'temperatura', 842.0000, 'ºC'),
	(10538, 108, '2015-01-15 01:30:37.000000', 'temperatura', 831.0000, 'ºC'),
	(10539, 108, '2015-01-15 01:30:38.000000', 'temperatura', 432.0000, 'ºC'),
	(10540, 108, '2015-01-15 01:30:39.000000', 'temperatura', 865.0000, 'ºC'),
	(10541, 108, '2015-01-15 01:30:40.000000', 'temperatura', 632.0000, 'ºC'),
	(10542, 108, '2015-01-15 01:30:41.000000', 'temperatura', 563.0000, 'ºC'),
	(10543, 108, '2015-01-15 01:30:42.000000', 'temperatura', 920.0000, 'ºC'),
	(10544, 108, '2015-01-15 01:30:43.000000', 'temperatura', 512.0000, 'ºC'),
	(10545, 108, '2015-01-15 01:30:44.000000', 'temperatura', 1001.0000, 'ºC'),
	(10546, 108, '2015-01-15 01:30:45.000000', 'temperatura', 1070.0000, 'ºC'),
	(10547, 108, '2015-01-15 01:30:46.000000', 'temperatura', 1145.0000, 'ºC'),
	(10548, 108, '2015-01-15 01:30:47.000000', 'temperatura', 116.0000, 'ºC'),
	(10549, 108, '2015-01-15 01:30:48.000000', 'temperatura', 746.0000, 'ºC'),
	(10550, 108, '2015-01-15 01:30:49.000000', 'temperatura', 982.0000, 'ºC'),
	(10551, 108, '2015-01-15 01:30:50.000000', 'temperatura', 271.0000, 'ºC'),
	(10552, 108, '2015-01-15 01:30:51.000000', 'temperatura', 813.0000, 'ºC'),
	(10553, 108, '2015-01-15 01:30:52.000000', 'temperatura', 850.0000, 'ºC'),
	(10554, 108, '2015-01-15 01:30:53.000000', 'temperatura', 611.0000, 'ºC'),
	(10555, 108, '2015-01-15 01:30:54.000000', 'temperatura', 504.0000, 'ºC'),
	(10556, 108, '2015-01-15 01:30:55.000000', 'temperatura', 691.0000, 'ºC'),
	(10557, 108, '2015-01-15 01:30:56.000000', 'temperatura', 742.0000, 'ºC'),
	(10558, 108, '2015-01-15 01:30:57.000000', 'temperatura', 439.0000, 'ºC'),
	(10559, 108, '2015-01-15 01:30:58.000000', 'temperatura', 1170.0000, 'ºC'),
	(10560, 108, '2015-01-15 01:30:59.000000', 'temperatura', 931.0000, 'ºC'),
	(10561, 108, '2015-01-15 01:31:00.000000', 'temperatura', 1146.0000, 'ºC'),
	(10562, 108, '2015-01-15 01:31:01.000000', 'temperatura', 540.0000, 'ºC'),
	(10563, 108, '2015-01-15 01:31:02.000000', 'temperatura', 459.0000, 'ºC'),
	(10564, 108, '2015-01-15 01:31:03.000000', 'temperatura', 677.0000, 'ºC'),
	(10565, 108, '2015-01-15 01:31:04.000000', 'temperatura', 807.0000, 'ºC'),
	(10566, 108, '2015-01-15 01:31:05.000000', 'temperatura', 804.0000, 'ºC'),
	(10567, 108, '2015-01-15 01:31:06.000000', 'temperatura', 400.0000, 'ºC'),
	(10568, 108, '2015-01-15 01:31:07.000000', 'temperatura', 788.0000, 'ºC'),
	(10569, 108, '2015-01-15 01:31:08.000000', 'temperatura', 342.0000, 'ºC'),
	(10570, 108, '2015-01-15 01:31:09.000000', 'temperatura', 547.0000, 'ºC'),
	(10571, 108, '2015-01-15 01:31:10.000000', 'temperatura', 508.0000, 'ºC'),
	(10572, 108, '2015-01-15 01:31:11.000000', 'temperatura', 900.0000, 'ºC'),
	(10573, 108, '2015-01-15 01:31:12.000000', 'temperatura', 577.0000, 'ºC'),
	(10574, 108, '2015-01-15 01:31:13.000000', 'temperatura', 187.0000, 'ºC'),
	(10575, 108, '2015-01-15 01:31:14.000000', 'temperatura', 403.0000, 'ºC'),
	(10576, 108, '2015-01-15 01:31:15.000000', 'temperatura', 256.0000, 'ºC'),
	(10577, 108, '2015-01-15 01:31:16.000000', 'temperatura', 71.0000, 'ºC'),
	(10578, 108, '2015-01-15 01:31:17.000000', 'temperatura', 787.0000, 'ºC'),
	(10579, 108, '2015-01-15 01:31:18.000000', 'temperatura', 124.0000, 'ºC'),
	(10580, 108, '2015-01-15 01:31:19.000000', 'temperatura', 658.0000, 'ºC'),
	(10581, 108, '2015-01-15 01:31:20.000000', 'temperatura', 518.0000, 'ºC'),
	(10582, 108, '2015-01-15 01:31:21.000000', 'temperatura', 618.0000, 'ºC'),
	(10583, 108, '2015-01-15 01:31:22.000000', 'temperatura', 337.0000, 'ºC'),
	(10584, 108, '2015-01-15 01:31:23.000000', 'temperatura', 1031.0000, 'ºC'),
	(10585, 108, '2015-01-15 01:31:24.000000', 'temperatura', 546.0000, 'ºC'),
	(10586, 108, '2015-01-15 01:31:25.000000', 'temperatura', 837.0000, 'ºC'),
	(10587, 108, '2015-01-15 01:31:26.000000', 'temperatura', 148.0000, 'ºC'),
	(10588, 108, '2015-01-15 01:31:27.000000', 'temperatura', 631.0000, 'ºC'),
	(10589, 108, '2015-01-15 01:31:28.000000', 'temperatura', 309.0000, 'ºC'),
	(10590, 108, '2015-01-15 01:31:29.000000', 'temperatura', 854.0000, 'ºC'),
	(10591, 108, '2015-01-15 01:31:30.000000', 'temperatura', 943.0000, 'ºC'),
	(10592, 108, '2015-01-15 01:31:31.000000', 'temperatura', 955.0000, 'ºC'),
	(10593, 108, '2015-01-15 01:31:32.000000', 'temperatura', 745.0000, 'ºC'),
	(10594, 108, '2015-01-15 01:31:33.000000', 'temperatura', 861.0000, 'ºC'),
	(10595, 108, '2015-01-15 01:31:34.000000', 'temperatura', 870.0000, 'ºC'),
	(10596, 108, '2015-01-15 01:31:35.000000', 'temperatura', 568.0000, 'ºC'),
	(10597, 108, '2015-01-15 01:31:36.000000', 'temperatura', 231.0000, 'ºC'),
	(10598, 108, '2015-01-15 01:31:37.000000', 'temperatura', 653.0000, 'ºC'),
	(10599, 108, '2015-01-15 01:31:38.000000', 'temperatura', 170.0000, 'ºC'),
	(10600, 108, '2015-01-15 01:31:39.000000', 'temperatura', 91.0000, 'ºC'),
	(10601, 108, '2015-01-15 01:31:40.000000', 'temperatura', 1147.0000, 'ºC'),
	(10602, 108, '2015-01-15 01:31:41.000000', 'temperatura', 660.0000, 'ºC'),
	(10603, 108, '2015-01-15 01:31:42.000000', 'temperatura', 1063.0000, 'ºC'),
	(10604, 108, '2015-01-15 01:31:43.000000', 'temperatura', 932.0000, 'ºC'),
	(10605, 108, '2015-01-15 01:31:44.000000', 'temperatura', 273.0000, 'ºC'),
	(10606, 108, '2015-01-15 01:31:45.000000', 'temperatura', 970.0000, 'ºC'),
	(10607, 108, '2015-01-15 01:31:46.000000', 'temperatura', 433.0000, 'ºC'),
	(10608, 108, '2015-01-15 01:31:47.000000', 'temperatura', 455.0000, 'ºC'),
	(10609, 108, '2015-01-15 01:31:48.000000', 'temperatura', 977.0000, 'ºC'),
	(10610, 108, '2015-01-15 01:31:49.000000', 'temperatura', 1118.0000, 'ºC'),
	(10611, 108, '2015-01-15 01:31:50.000000', 'temperatura', 261.0000, 'ºC'),
	(10612, 108, '2015-01-15 01:31:51.000000', 'temperatura', 352.0000, 'ºC'),
	(10613, 108, '2015-01-15 01:31:52.000000', 'temperatura', 979.0000, 'ºC'),
	(10614, 108, '2015-01-15 01:31:53.000000', 'temperatura', 237.0000, 'ºC'),
	(10615, 108, '2015-01-15 01:31:54.000000', 'temperatura', 647.0000, 'ºC'),
	(10616, 108, '2015-01-15 01:31:55.000000', 'temperatura', 128.0000, 'ºC'),
	(10617, 108, '2015-01-15 01:31:56.000000', 'temperatura', 1097.0000, 'ºC'),
	(10618, 108, '2015-01-15 01:31:57.000000', 'temperatura', 303.0000, 'ºC'),
	(10619, 108, '2015-01-15 01:31:58.000000', 'temperatura', 625.0000, 'ºC'),
	(10620, 108, '2015-01-15 01:31:59.000000', 'temperatura', 1015.0000, 'ºC'),
	(10621, 108, '2015-01-15 01:32:00.000000', 'temperatura', 802.0000, 'ºC'),
	(10622, 108, '2015-01-15 01:32:01.000000', 'temperatura', 966.0000, 'ºC'),
	(10623, 108, '2015-01-15 01:32:02.000000', 'temperatura', 23.0000, 'ºC'),
	(10624, 108, '2015-01-15 01:32:03.000000', 'temperatura', 819.0000, 'ºC'),
	(10625, 108, '2015-01-15 01:32:04.000000', 'temperatura', 425.0000, 'ºC'),
	(10626, 108, '2015-01-15 01:32:05.000000', 'temperatura', 870.0000, 'ºC'),
	(10627, 108, '2015-01-15 01:32:06.000000', 'temperatura', 677.0000, 'ºC'),
	(10628, 108, '2015-01-15 01:32:07.000000', 'temperatura', 773.0000, 'ºC'),
	(10629, 108, '2015-01-15 01:32:08.000000', 'temperatura', 637.0000, 'ºC'),
	(10630, 108, '2015-01-15 01:32:09.000000', 'temperatura', 864.0000, 'ºC'),
	(10631, 108, '2015-01-15 01:32:10.000000', 'temperatura', 9.0000, 'ºC'),
	(10632, 108, '2015-01-15 01:32:11.000000', 'temperatura', 1054.0000, 'ºC'),
	(10633, 108, '2015-01-15 01:32:12.000000', 'temperatura', 443.0000, 'ºC'),
	(10634, 108, '2015-01-15 01:32:13.000000', 'temperatura', 255.0000, 'ºC'),
	(10635, 108, '2015-01-15 01:32:14.000000', 'temperatura', 1147.0000, 'ºC'),
	(10636, 108, '2015-01-15 01:32:15.000000', 'temperatura', 169.0000, 'ºC'),
	(10637, 108, '2015-01-15 01:32:16.000000', 'temperatura', 1007.0000, 'ºC'),
	(10638, 108, '2015-01-15 01:32:17.000000', 'temperatura', 926.0000, 'ºC'),
	(10639, 108, '2015-01-15 01:32:18.000000', 'temperatura', 411.0000, 'ºC'),
	(10640, 108, '2015-01-15 01:32:19.000000', 'temperatura', 476.0000, 'ºC'),
	(10641, 108, '2015-01-15 01:32:20.000000', 'temperatura', 1148.0000, 'ºC'),
	(10642, 108, '2015-01-15 01:32:21.000000', 'temperatura', 714.0000, 'ºC'),
	(10643, 108, '2015-01-15 01:32:22.000000', 'temperatura', 126.0000, 'ºC'),
	(10644, 108, '2015-01-15 01:32:23.000000', 'temperatura', 889.0000, 'ºC'),
	(10645, 108, '2015-01-15 01:32:24.000000', 'temperatura', 467.0000, 'ºC'),
	(10646, 108, '2015-01-15 01:32:25.000000', 'temperatura', 867.0000, 'ºC'),
	(10647, 108, '2015-01-15 01:32:26.000000', 'temperatura', 537.0000, 'ºC'),
	(10648, 108, '2015-01-15 01:32:27.000000', 'temperatura', 83.0000, 'ºC'),
	(10649, 108, '2015-01-15 01:32:28.000000', 'temperatura', 5.0000, 'ºC'),
	(10650, 108, '2015-01-15 01:32:29.000000', 'temperatura', 976.0000, 'ºC'),
	(10651, 108, '2015-01-15 01:32:30.000000', 'temperatura', 66.0000, 'ºC'),
	(10652, 108, '2015-01-15 01:32:31.000000', 'temperatura', 1000.0000, 'ºC'),
	(10653, 108, '2015-01-15 01:32:32.000000', 'temperatura', 5.0000, 'ºC'),
	(10654, 108, '2015-01-15 01:32:33.000000', 'temperatura', 627.0000, 'ºC'),
	(10655, 108, '2015-01-15 01:32:34.000000', 'temperatura', 718.0000, 'ºC'),
	(10656, 108, '2015-01-15 01:32:35.000000', 'temperatura', 512.0000, 'ºC'),
	(10657, 108, '2015-01-15 01:32:36.000000', 'temperatura', 406.0000, 'ºC'),
	(10658, 108, '2015-01-15 01:32:37.000000', 'temperatura', 494.0000, 'ºC'),
	(10659, 108, '2015-01-15 01:32:38.000000', 'temperatura', 54.0000, 'ºC'),
	(10660, 108, '2015-01-15 01:32:39.000000', 'temperatura', 1188.0000, 'ºC'),
	(10661, 108, '2015-01-15 01:32:40.000000', 'temperatura', 980.0000, 'ºC'),
	(10662, 108, '2015-01-15 01:32:41.000000', 'temperatura', 136.0000, 'ºC'),
	(10663, 108, '2015-01-15 01:32:42.000000', 'temperatura', 141.0000, 'ºC'),
	(10664, 108, '2015-01-15 01:32:43.000000', 'temperatura', 296.0000, 'ºC'),
	(10665, 108, '2015-01-15 01:32:44.000000', 'temperatura', 1058.0000, 'ºC'),
	(10666, 108, '2015-01-15 01:32:45.000000', 'temperatura', 803.0000, 'ºC'),
	(10667, 108, '2015-01-15 01:32:46.000000', 'temperatura', 842.0000, 'ºC'),
	(10668, 108, '2015-01-15 01:32:47.000000', 'temperatura', 601.0000, 'ºC'),
	(10669, 108, '2015-01-15 01:32:48.000000', 'temperatura', 478.0000, 'ºC'),
	(10670, 108, '2015-01-15 01:32:49.000000', 'temperatura', 589.0000, 'ºC'),
	(10671, 108, '2015-01-15 01:32:50.000000', 'temperatura', 311.0000, 'ºC'),
	(10672, 108, '2015-01-15 01:32:51.000000', 'temperatura', 988.0000, 'ºC'),
	(10673, 108, '2015-01-15 01:32:52.000000', 'temperatura', 408.0000, 'ºC'),
	(10674, 108, '2015-01-15 01:32:53.000000', 'temperatura', 275.0000, 'ºC'),
	(10675, 108, '2015-01-15 01:32:54.000000', 'temperatura', 151.0000, 'ºC'),
	(10676, 108, '2015-01-15 01:32:55.000000', 'temperatura', 1130.0000, 'ºC'),
	(10677, 108, '2015-01-15 01:32:56.000000', 'temperatura', 398.0000, 'ºC'),
	(10678, 108, '2015-01-15 01:32:57.000000', 'temperatura', 1000.0000, 'ºC'),
	(10679, 108, '2015-01-15 01:32:58.000000', 'temperatura', 207.0000, 'ºC'),
	(10680, 108, '2015-01-15 01:32:59.000000', 'temperatura', 435.0000, 'ºC'),
	(10681, 108, '2015-01-15 01:33:00.000000', 'temperatura', 355.0000, 'ºC'),
	(10682, 108, '2015-01-15 01:33:01.000000', 'temperatura', 470.0000, 'ºC'),
	(10683, 108, '2015-01-15 01:33:02.000000', 'temperatura', 87.0000, 'ºC'),
	(10684, 108, '2015-01-15 01:33:03.000000', 'temperatura', 225.0000, 'ºC'),
	(10685, 108, '2015-01-15 01:33:04.000000', 'temperatura', 865.0000, 'ºC'),
	(10686, 108, '2015-01-15 01:33:05.000000', 'temperatura', 50.0000, 'ºC'),
	(10687, 108, '2015-01-15 01:33:06.000000', 'temperatura', 54.0000, 'ºC'),
	(10688, 108, '2015-01-15 01:33:07.000000', 'temperatura', 123.0000, 'ºC'),
	(10689, 108, '2015-01-15 01:33:08.000000', 'temperatura', 453.0000, 'ºC'),
	(10690, 108, '2015-01-15 01:33:09.000000', 'temperatura', 697.0000, 'ºC'),
	(10691, 108, '2015-01-15 01:33:10.000000', 'temperatura', 926.0000, 'ºC'),
	(10692, 108, '2015-01-15 01:33:11.000000', 'temperatura', 138.0000, 'ºC'),
	(10693, 108, '2015-01-15 01:33:12.000000', 'temperatura', 312.0000, 'ºC'),
	(10694, 108, '2015-01-15 01:33:13.000000', 'temperatura', 1146.0000, 'ºC'),
	(10695, 108, '2015-01-15 01:33:14.000000', 'temperatura', 1195.0000, 'ºC'),
	(10696, 108, '2015-01-15 01:33:15.000000', 'temperatura', 137.0000, 'ºC'),
	(10697, 108, '2015-01-15 01:33:16.000000', 'temperatura', 703.0000, 'ºC'),
	(10698, 108, '2015-01-15 01:33:17.000000', 'temperatura', 703.0000, 'ºC'),
	(10699, 108, '2015-01-15 01:33:18.000000', 'temperatura', 205.0000, 'ºC'),
	(10700, 108, '2015-01-15 01:33:19.000000', 'temperatura', 117.0000, 'ºC'),
	(10701, 108, '2015-01-15 01:33:20.000000', 'temperatura', 1171.0000, 'ºC'),
	(10702, 108, '2015-01-15 01:33:21.000000', 'temperatura', 705.0000, 'ºC'),
	(10703, 108, '2015-01-15 01:33:22.000000', 'temperatura', 10.0000, 'ºC'),
	(10704, 108, '2015-01-15 01:33:23.000000', 'temperatura', 339.0000, 'ºC'),
	(10705, 108, '2015-01-15 01:33:24.000000', 'temperatura', 464.0000, 'ºC'),
	(10706, 108, '2015-01-15 01:33:25.000000', 'temperatura', 104.0000, 'ºC'),
	(10707, 108, '2015-01-15 01:33:26.000000', 'temperatura', 326.0000, 'ºC'),
	(10708, 108, '2015-01-15 01:33:27.000000', 'temperatura', 122.0000, 'ºC'),
	(10709, 108, '2015-01-15 01:33:28.000000', 'temperatura', 830.0000, 'ºC'),
	(10710, 108, '2015-01-15 01:33:29.000000', 'temperatura', 184.0000, 'ºC'),
	(10711, 108, '2015-01-15 01:33:30.000000', 'temperatura', 832.0000, 'ºC'),
	(10712, 108, '2015-01-15 01:33:31.000000', 'temperatura', 9.0000, 'ºC'),
	(10713, 108, '2015-01-15 01:33:32.000000', 'temperatura', 1147.0000, 'ºC'),
	(10714, 108, '2015-01-15 01:33:33.000000', 'temperatura', 911.0000, 'ºC'),
	(10715, 108, '2015-01-15 01:33:34.000000', 'temperatura', 1113.0000, 'ºC'),
	(10716, 108, '2015-01-15 01:33:35.000000', 'temperatura', 435.0000, 'ºC'),
	(10717, 108, '2015-01-15 01:33:36.000000', 'temperatura', 35.0000, 'ºC'),
	(10718, 108, '2015-01-15 01:33:37.000000', 'temperatura', 72.0000, 'ºC'),
	(10719, 108, '2015-01-15 01:33:38.000000', 'temperatura', 256.0000, 'ºC'),
	(10720, 108, '2015-01-15 01:33:39.000000', 'temperatura', 1065.0000, 'ºC'),
	(10721, 108, '2015-01-15 01:33:40.000000', 'temperatura', 955.0000, 'ºC'),
	(10722, 108, '2015-01-15 01:33:41.000000', 'temperatura', 380.0000, 'ºC'),
	(10723, 108, '2015-01-15 01:33:42.000000', 'temperatura', 238.0000, 'ºC'),
	(10724, 108, '2015-01-15 01:33:43.000000', 'temperatura', 50.0000, 'ºC'),
	(10725, 108, '2015-01-15 01:33:44.000000', 'temperatura', 737.0000, 'ºC'),
	(10726, 108, '2015-01-15 01:33:45.000000', 'temperatura', 1134.0000, 'ºC'),
	(10727, 108, '2015-01-15 01:33:46.000000', 'temperatura', 1060.0000, 'ºC'),
	(10728, 108, '2015-01-15 01:33:47.000000', 'temperatura', 697.0000, 'ºC'),
	(10729, 108, '2015-01-15 01:33:48.000000', 'temperatura', 308.0000, 'ºC'),
	(10730, 108, '2015-01-15 01:33:49.000000', 'temperatura', 650.0000, 'ºC'),
	(10731, 108, '2015-01-15 01:33:50.000000', 'temperatura', 1125.0000, 'ºC'),
	(10732, 108, '2015-01-15 01:33:51.000000', 'temperatura', 76.0000, 'ºC'),
	(10733, 108, '2015-01-15 01:33:52.000000', 'temperatura', 604.0000, 'ºC'),
	(10734, 108, '2015-01-15 01:33:53.000000', 'temperatura', 394.0000, 'ºC'),
	(10735, 108, '2015-01-15 01:33:54.000000', 'temperatura', 160.0000, 'ºC'),
	(10736, 108, '2015-01-15 01:33:55.000000', 'temperatura', 816.0000, 'ºC'),
	(10737, 108, '2015-01-15 01:33:56.000000', 'temperatura', 1199.0000, 'ºC'),
	(10738, 108, '2015-01-15 01:33:57.000000', 'temperatura', 1150.0000, 'ºC'),
	(10739, 108, '2015-01-15 01:33:58.000000', 'temperatura', 954.0000, 'ºC'),
	(10740, 108, '2015-01-15 01:33:59.000000', 'temperatura', 121.0000, 'ºC'),
	(10741, 108, '2015-01-15 01:34:00.000000', 'temperatura', 142.0000, 'ºC'),
	(10742, 108, '2015-01-15 01:34:01.000000', 'temperatura', 347.0000, 'ºC'),
	(10743, 108, '2015-01-15 01:34:02.000000', 'temperatura', 110.0000, 'ºC'),
	(10744, 108, '2015-01-15 01:34:03.000000', 'temperatura', 708.0000, 'ºC'),
	(10745, 108, '2015-01-15 01:34:04.000000', 'temperatura', 810.0000, 'ºC'),
	(10746, 108, '2015-01-15 01:34:05.000000', 'temperatura', 727.0000, 'ºC'),
	(10747, 108, '2015-01-15 01:34:06.000000', 'temperatura', 6.0000, 'ºC'),
	(10748, 108, '2015-01-15 01:34:07.000000', 'temperatura', 248.0000, 'ºC'),
	(10749, 108, '2015-01-15 01:34:08.000000', 'temperatura', 23.0000, 'ºC'),
	(10750, 108, '2015-01-15 01:34:09.000000', 'temperatura', 570.0000, 'ºC'),
	(10751, 108, '2015-01-15 01:34:10.000000', 'temperatura', 382.0000, 'ºC'),
	(10752, 108, '2015-01-15 01:34:11.000000', 'temperatura', 201.0000, 'ºC'),
	(10753, 108, '2015-01-15 01:34:12.000000', 'temperatura', 1058.0000, 'ºC'),
	(10754, 108, '2015-01-15 01:34:13.000000', 'temperatura', 1088.0000, 'ºC'),
	(10755, 108, '2015-01-15 01:34:14.000000', 'temperatura', 1065.0000, 'ºC'),
	(10756, 108, '2015-01-15 01:34:15.000000', 'temperatura', 864.0000, 'ºC'),
	(10757, 108, '2015-01-15 01:34:16.000000', 'temperatura', 1125.0000, 'ºC'),
	(10758, 108, '2015-01-15 01:34:17.000000', 'temperatura', 632.0000, 'ºC'),
	(10759, 108, '2015-01-15 01:34:18.000000', 'temperatura', 986.0000, 'ºC'),
	(10760, 108, '2015-01-15 01:34:19.000000', 'temperatura', 636.0000, 'ºC'),
	(10761, 108, '2015-01-15 01:34:20.000000', 'temperatura', 222.0000, 'ºC'),
	(10762, 108, '2015-01-15 01:34:21.000000', 'temperatura', 403.0000, 'ºC'),
	(10763, 108, '2015-01-15 01:34:22.000000', 'temperatura', 148.0000, 'ºC'),
	(10764, 108, '2015-01-15 01:34:23.000000', 'temperatura', 733.0000, 'ºC'),
	(10765, 108, '2015-01-15 01:34:24.000000', 'temperatura', 821.0000, 'ºC'),
	(10766, 108, '2015-01-15 01:34:25.000000', 'temperatura', 705.0000, 'ºC'),
	(10767, 108, '2015-01-15 01:34:26.000000', 'temperatura', 1065.0000, 'ºC'),
	(10768, 108, '2015-01-15 01:34:27.000000', 'temperatura', 810.0000, 'ºC'),
	(10769, 108, '2015-01-15 01:34:28.000000', 'temperatura', 855.0000, 'ºC'),
	(10770, 108, '2015-01-15 01:34:29.000000', 'temperatura', 646.0000, 'ºC'),
	(10771, 108, '2015-01-15 01:34:30.000000', 'temperatura', 666.0000, 'ºC'),
	(10772, 108, '2015-01-15 01:34:31.000000', 'temperatura', 192.0000, 'ºC'),
	(10773, 108, '2015-01-15 01:34:32.000000', 'temperatura', 164.0000, 'ºC'),
	(10774, 108, '2015-01-15 01:34:33.000000', 'temperatura', 243.0000, 'ºC'),
	(10775, 108, '2015-01-15 01:34:34.000000', 'temperatura', 723.0000, 'ºC'),
	(10776, 108, '2015-01-15 01:34:35.000000', 'temperatura', 487.0000, 'ºC'),
	(10777, 108, '2015-01-15 01:34:36.000000', 'temperatura', 264.0000, 'ºC'),
	(10778, 108, '2015-01-15 01:34:37.000000', 'temperatura', 1063.0000, 'ºC'),
	(10779, 108, '2015-01-15 01:34:38.000000', 'temperatura', 923.0000, 'ºC'),
	(10780, 108, '2015-01-15 01:34:39.000000', 'temperatura', 225.0000, 'ºC'),
	(10781, 108, '2015-01-15 01:34:40.000000', 'temperatura', 756.0000, 'ºC'),
	(10782, 108, '2015-01-15 01:34:41.000000', 'temperatura', 706.0000, 'ºC'),
	(10783, 108, '2015-01-15 01:34:42.000000', 'temperatura', 64.0000, 'ºC'),
	(10784, 108, '2015-01-15 01:34:43.000000', 'temperatura', 600.0000, 'ºC'),
	(10785, 108, '2015-01-15 01:34:44.000000', 'temperatura', 408.0000, 'ºC'),
	(10786, 108, '2015-01-15 01:34:45.000000', 'temperatura', 240.0000, 'ºC'),
	(10787, 108, '2015-01-15 01:34:46.000000', 'temperatura', 1177.0000, 'ºC'),
	(10788, 108, '2015-01-15 01:34:47.000000', 'temperatura', 368.0000, 'ºC'),
	(10789, 108, '2015-01-15 01:34:48.000000', 'temperatura', 708.0000, 'ºC'),
	(10790, 108, '2015-01-15 01:34:49.000000', 'temperatura', 38.0000, 'ºC'),
	(10791, 108, '2015-01-15 01:34:50.000000', 'temperatura', 467.0000, 'ºC'),
	(10792, 108, '2015-01-15 01:34:51.000000', 'temperatura', 1022.0000, 'ºC'),
	(10793, 108, '2015-01-15 01:34:52.000000', 'temperatura', 108.0000, 'ºC'),
	(10794, 108, '2015-01-15 01:34:53.000000', 'temperatura', 1075.0000, 'ºC'),
	(10795, 108, '2015-01-15 01:34:54.000000', 'temperatura', 253.0000, 'ºC'),
	(10796, 108, '2015-01-15 01:34:55.000000', 'temperatura', 438.0000, 'ºC'),
	(10797, 108, '2015-01-15 01:34:56.000000', 'temperatura', 232.0000, 'ºC'),
	(10798, 108, '2015-01-15 01:34:57.000000', 'temperatura', 1046.0000, 'ºC'),
	(10799, 108, '2015-01-15 01:34:58.000000', 'temperatura', 936.0000, 'ºC'),
	(10800, 108, '2015-01-15 01:34:59.000000', 'temperatura', 340.0000, 'ºC'),
	(10801, 108, '2015-01-15 01:35:00.000000', 'temperatura', 96.0000, 'ºC'),
	(10802, 108, '2015-01-15 01:35:01.000000', 'temperatura', 658.0000, 'ºC'),
	(10803, 108, '2015-01-15 01:35:02.000000', 'temperatura', 605.0000, 'ºC'),
	(10804, 108, '2015-01-15 01:35:03.000000', 'temperatura', 1049.0000, 'ºC'),
	(10805, 108, '2015-01-15 01:35:04.000000', 'temperatura', 1033.0000, 'ºC'),
	(10806, 108, '2015-01-15 01:35:05.000000', 'temperatura', 817.0000, 'ºC'),
	(10807, 108, '2015-01-15 01:35:06.000000', 'temperatura', 988.0000, 'ºC'),
	(10808, 108, '2015-01-15 01:35:07.000000', 'temperatura', 88.0000, 'ºC'),
	(10809, 108, '2015-01-15 01:35:08.000000', 'temperatura', 1076.0000, 'ºC'),
	(10810, 108, '2015-01-15 01:35:09.000000', 'temperatura', 318.0000, 'ºC'),
	(10811, 108, '2015-01-15 01:35:10.000000', 'temperatura', 760.0000, 'ºC'),
	(10812, 108, '2015-01-15 01:35:11.000000', 'temperatura', 448.0000, 'ºC'),
	(10813, 108, '2015-01-15 01:35:12.000000', 'temperatura', 1159.0000, 'ºC'),
	(10814, 108, '2015-01-15 01:35:13.000000', 'temperatura', 853.0000, 'ºC'),
	(10815, 108, '2015-01-15 01:35:14.000000', 'temperatura', 790.0000, 'ºC'),
	(10816, 108, '2015-01-15 01:35:15.000000', 'temperatura', 189.0000, 'ºC'),
	(10817, 108, '2015-01-15 01:35:16.000000', 'temperatura', 977.0000, 'ºC'),
	(10818, 108, '2015-01-15 01:35:17.000000', 'temperatura', 717.0000, 'ºC'),
	(10819, 108, '2015-01-15 01:35:18.000000', 'temperatura', 655.0000, 'ºC'),
	(10820, 108, '2015-01-15 01:35:19.000000', 'temperatura', 1126.0000, 'ºC'),
	(10821, 108, '2015-01-15 01:35:20.000000', 'temperatura', 65.0000, 'ºC'),
	(10822, 108, '2015-01-15 01:35:21.000000', 'temperatura', 546.0000, 'ºC'),
	(10823, 108, '2015-01-15 01:35:22.000000', 'temperatura', 136.0000, 'ºC'),
	(10824, 108, '2015-01-15 01:35:23.000000', 'temperatura', 241.0000, 'ºC'),
	(10825, 108, '2015-01-15 01:35:24.000000', 'temperatura', 798.0000, 'ºC'),
	(10826, 108, '2015-01-15 01:35:25.000000', 'temperatura', 868.0000, 'ºC'),
	(10827, 108, '2015-01-15 01:35:26.000000', 'temperatura', 749.0000, 'ºC'),
	(10828, 109, '2015-01-15 00:00:00.000000', 'temperatura', 1044.0000, 'ºC'),
	(10829, 109, '2015-01-15 00:00:01.000000', 'temperatura', 606.0000, 'ºC'),
	(10830, 109, '2015-01-15 00:00:02.000000', 'temperatura', 1099.0000, 'ºC'),
	(10831, 109, '2015-01-15 00:00:03.000000', 'temperatura', 78.0000, 'ºC'),
	(10832, 109, '2015-01-15 00:00:04.000000', 'temperatura', 694.0000, 'ºC'),
	(10833, 109, '2015-01-15 00:00:05.000000', 'temperatura', 838.0000, 'ºC'),
	(10834, 109, '2015-01-15 00:00:06.000000', 'temperatura', 907.0000, 'ºC'),
	(10835, 109, '2015-01-15 00:00:07.000000', 'temperatura', 823.0000, 'ºC'),
	(10836, 109, '2015-01-15 00:00:08.000000', 'temperatura', 193.0000, 'ºC'),
	(10837, 109, '2015-01-15 00:00:09.000000', 'temperatura', 899.0000, 'ºC'),
	(10838, 109, '2015-01-15 00:00:10.000000', 'temperatura', 314.0000, 'ºC'),
	(10839, 109, '2015-01-15 00:00:11.000000', 'temperatura', 75.0000, 'ºC'),
	(10840, 109, '2015-01-15 00:00:12.000000', 'temperatura', 634.0000, 'ºC'),
	(10841, 109, '2015-01-15 00:00:13.000000', 'temperatura', 544.0000, 'ºC'),
	(10842, 109, '2015-01-15 00:00:14.000000', 'temperatura', 818.0000, 'ºC'),
	(10843, 109, '2015-01-15 00:00:15.000000', 'temperatura', 59.0000, 'ºC'),
	(10844, 109, '2015-01-15 00:00:16.000000', 'temperatura', 241.0000, 'ºC'),
	(10845, 109, '2015-01-15 00:00:17.000000', 'temperatura', 1028.0000, 'ºC'),
	(10846, 109, '2015-01-15 00:00:18.000000', 'temperatura', 818.0000, 'ºC'),
	(10847, 109, '2015-01-15 00:00:19.000000', 'temperatura', 1006.0000, 'ºC'),
	(10848, 109, '2015-01-15 00:00:20.000000', 'temperatura', 177.0000, 'ºC'),
	(10849, 109, '2015-01-15 00:00:21.000000', 'temperatura', 269.0000, 'ºC'),
	(10850, 109, '2015-01-15 00:00:22.000000', 'temperatura', 816.0000, 'ºC'),
	(10851, 109, '2015-01-15 00:00:23.000000', 'temperatura', 870.0000, 'ºC'),
	(10852, 109, '2015-01-15 00:00:24.000000', 'temperatura', 703.0000, 'ºC'),
	(10853, 109, '2015-01-15 00:00:25.000000', 'temperatura', 906.0000, 'ºC'),
	(10854, 109, '2015-01-15 00:00:26.000000', 'temperatura', 20.0000, 'ºC'),
	(10855, 109, '2015-01-15 00:00:27.000000', 'temperatura', 982.0000, 'ºC'),
	(10856, 109, '2015-01-15 00:00:28.000000', 'temperatura', 50.0000, 'ºC'),
	(10857, 109, '2015-01-15 00:00:29.000000', 'temperatura', 903.0000, 'ºC'),
	(10858, 109, '2015-01-15 00:00:30.000000', 'temperatura', 769.0000, 'ºC'),
	(10859, 109, '2015-01-15 00:00:31.000000', 'temperatura', 1137.0000, 'ºC'),
	(10860, 109, '2015-01-15 00:00:32.000000', 'temperatura', 977.0000, 'ºC'),
	(10861, 109, '2015-01-15 00:00:33.000000', 'temperatura', 274.0000, 'ºC'),
	(10862, 109, '2015-01-15 00:00:34.000000', 'temperatura', 838.0000, 'ºC'),
	(10863, 109, '2015-01-15 00:00:35.000000', 'temperatura', 971.0000, 'ºC'),
	(10864, 109, '2015-01-15 00:00:36.000000', 'temperatura', 1143.0000, 'ºC'),
	(10865, 109, '2015-01-15 00:00:37.000000', 'temperatura', 400.0000, 'ºC'),
	(10866, 109, '2015-01-15 00:00:38.000000', 'temperatura', 973.0000, 'ºC'),
	(10867, 109, '2015-01-15 00:00:39.000000', 'temperatura', 65.0000, 'ºC'),
	(10868, 109, '2015-01-15 00:00:40.000000', 'temperatura', 1004.0000, 'ºC'),
	(10869, 109, '2015-01-15 00:00:41.000000', 'temperatura', 29.0000, 'ºC'),
	(10870, 109, '2015-01-15 00:00:42.000000', 'temperatura', 731.0000, 'ºC'),
	(10871, 109, '2015-01-15 00:00:43.000000', 'temperatura', 1168.0000, 'ºC'),
	(10872, 109, '2015-01-15 00:00:44.000000', 'temperatura', 51.0000, 'ºC'),
	(10873, 109, '2015-01-15 00:00:45.000000', 'temperatura', 348.0000, 'ºC'),
	(10874, 109, '2015-01-15 00:00:46.000000', 'temperatura', 388.0000, 'ºC'),
	(10875, 109, '2015-01-15 00:00:47.000000', 'temperatura', 895.0000, 'ºC'),
	(10876, 109, '2015-01-15 00:00:48.000000', 'temperatura', 915.0000, 'ºC'),
	(10877, 109, '2015-01-15 00:00:49.000000', 'temperatura', 687.0000, 'ºC'),
	(10878, 109, '2015-01-15 00:00:50.000000', 'temperatura', 694.0000, 'ºC'),
	(10879, 109, '2015-01-15 00:00:51.000000', 'temperatura', 207.0000, 'ºC'),
	(10880, 109, '2015-01-15 00:00:52.000000', 'temperatura', 154.0000, 'ºC'),
	(10881, 109, '2015-01-15 00:00:53.000000', 'temperatura', 149.0000, 'ºC'),
	(10882, 109, '2015-01-15 00:00:54.000000', 'temperatura', 284.0000, 'ºC'),
	(10883, 109, '2015-01-15 00:00:55.000000', 'temperatura', 975.0000, 'ºC'),
	(10884, 109, '2015-01-15 00:00:56.000000', 'temperatura', 423.0000, 'ºC'),
	(10885, 109, '2015-01-15 00:00:57.000000', 'temperatura', 391.0000, 'ºC'),
	(10886, 109, '2015-01-15 00:00:58.000000', 'temperatura', 686.0000, 'ºC'),
	(10887, 109, '2015-01-15 00:00:59.000000', 'temperatura', 1058.0000, 'ºC'),
	(10888, 109, '2015-01-15 00:01:00.000000', 'temperatura', 834.0000, 'ºC'),
	(10889, 109, '2015-01-15 00:01:01.000000', 'temperatura', 995.0000, 'ºC'),
	(10890, 109, '2015-01-15 00:01:02.000000', 'temperatura', 75.0000, 'ºC'),
	(10891, 109, '2015-01-15 00:01:03.000000', 'temperatura', 988.0000, 'ºC'),
	(10892, 109, '2015-01-15 00:01:04.000000', 'temperatura', 1118.0000, 'ºC'),
	(10893, 109, '2015-01-15 00:01:05.000000', 'temperatura', 226.0000, 'ºC'),
	(10894, 109, '2015-01-15 00:01:06.000000', 'temperatura', 174.0000, 'ºC'),
	(10895, 109, '2015-01-15 00:01:07.000000', 'temperatura', 194.0000, 'ºC'),
	(10896, 109, '2015-01-15 00:01:08.000000', 'temperatura', 450.0000, 'ºC'),
	(10897, 109, '2015-01-15 00:01:09.000000', 'temperatura', 467.0000, 'ºC'),
	(10898, 109, '2015-01-15 00:01:10.000000', 'temperatura', 987.0000, 'ºC'),
	(10899, 109, '2015-01-15 00:01:11.000000', 'temperatura', 1135.0000, 'ºC'),
	(10900, 109, '2015-01-15 00:01:12.000000', 'temperatura', 313.0000, 'ºC'),
	(10901, 109, '2015-01-15 00:01:13.000000', 'temperatura', 559.0000, 'ºC'),
	(10902, 109, '2015-01-15 00:01:14.000000', 'temperatura', 660.0000, 'ºC'),
	(10903, 109, '2015-01-15 00:01:15.000000', 'temperatura', 422.0000, 'ºC'),
	(10904, 109, '2015-01-15 00:01:16.000000', 'temperatura', 130.0000, 'ºC'),
	(10905, 109, '2015-01-15 00:01:17.000000', 'temperatura', 583.0000, 'ºC'),
	(10906, 109, '2015-01-15 00:01:18.000000', 'temperatura', 127.0000, 'ºC'),
	(10907, 109, '2015-01-15 00:01:19.000000', 'temperatura', 86.0000, 'ºC'),
	(10908, 109, '2015-01-15 00:01:20.000000', 'temperatura', 49.0000, 'ºC'),
	(10909, 109, '2015-01-15 00:01:21.000000', 'temperatura', 1187.0000, 'ºC'),
	(10910, 109, '2015-01-15 00:01:22.000000', 'temperatura', 989.0000, 'ºC'),
	(10911, 109, '2015-01-15 00:01:23.000000', 'temperatura', 184.0000, 'ºC'),
	(10912, 109, '2015-01-15 00:01:24.000000', 'temperatura', 355.0000, 'ºC'),
	(10913, 109, '2015-01-15 00:01:25.000000', 'temperatura', 23.0000, 'ºC'),
	(10914, 109, '2015-01-15 00:01:26.000000', 'temperatura', 252.0000, 'ºC'),
	(10915, 109, '2015-01-15 00:01:27.000000', 'temperatura', 1189.0000, 'ºC'),
	(10916, 109, '2015-01-15 00:01:28.000000', 'temperatura', 390.0000, 'ºC'),
	(10917, 109, '2015-01-15 00:01:29.000000', 'temperatura', 782.0000, 'ºC'),
	(10918, 109, '2015-01-15 00:01:30.000000', 'temperatura', 343.0000, 'ºC'),
	(10919, 109, '2015-01-15 00:01:31.000000', 'temperatura', 568.0000, 'ºC'),
	(10920, 109, '2015-01-15 00:01:32.000000', 'temperatura', 613.0000, 'ºC'),
	(10921, 109, '2015-01-15 00:01:33.000000', 'temperatura', 162.0000, 'ºC'),
	(10922, 109, '2015-01-15 00:01:34.000000', 'temperatura', 169.0000, 'ºC'),
	(10923, 109, '2015-01-15 00:01:35.000000', 'temperatura', 363.0000, 'ºC'),
	(10924, 109, '2015-01-15 00:01:36.000000', 'temperatura', 106.0000, 'ºC'),
	(10925, 109, '2015-01-15 00:01:37.000000', 'temperatura', 642.0000, 'ºC'),
	(10926, 109, '2015-01-15 00:01:38.000000', 'temperatura', 492.0000, 'ºC'),
	(10927, 109, '2015-01-15 00:01:39.000000', 'temperatura', 535.0000, 'ºC'),
	(10928, 109, '2015-01-15 00:01:40.000000', 'temperatura', 1198.0000, 'ºC'),
	(10929, 109, '2015-01-15 00:01:41.000000', 'temperatura', 789.0000, 'ºC'),
	(10930, 109, '2015-01-15 00:01:42.000000', 'temperatura', 348.0000, 'ºC'),
	(10931, 109, '2015-01-15 00:01:43.000000', 'temperatura', 576.0000, 'ºC'),
	(10932, 109, '2015-01-15 00:01:44.000000', 'temperatura', 634.0000, 'ºC'),
	(10933, 109, '2015-01-15 00:01:45.000000', 'temperatura', 244.0000, 'ºC'),
	(10934, 109, '2015-01-15 00:01:46.000000', 'temperatura', 516.0000, 'ºC'),
	(10935, 109, '2015-01-15 00:01:47.000000', 'temperatura', 651.0000, 'ºC'),
	(10936, 109, '2015-01-15 00:01:48.000000', 'temperatura', 506.0000, 'ºC'),
	(10937, 109, '2015-01-15 00:01:49.000000', 'temperatura', 577.0000, 'ºC'),
	(10938, 109, '2015-01-15 00:01:50.000000', 'temperatura', 169.0000, 'ºC'),
	(10939, 109, '2015-01-15 00:01:51.000000', 'temperatura', 316.0000, 'ºC'),
	(10940, 109, '2015-01-15 00:01:52.000000', 'temperatura', 1072.0000, 'ºC'),
	(10941, 109, '2015-01-15 00:01:53.000000', 'temperatura', 814.0000, 'ºC'),
	(10942, 109, '2015-01-15 00:01:54.000000', 'temperatura', 855.0000, 'ºC'),
	(10943, 109, '2015-01-15 00:01:55.000000', 'temperatura', 631.0000, 'ºC'),
	(10944, 109, '2015-01-15 00:01:56.000000', 'temperatura', 591.0000, 'ºC'),
	(10945, 109, '2015-01-15 00:01:57.000000', 'temperatura', 1064.0000, 'ºC'),
	(10946, 109, '2015-01-15 00:01:58.000000', 'temperatura', 1147.0000, 'ºC'),
	(10947, 109, '2015-01-15 00:01:59.000000', 'temperatura', 145.0000, 'ºC'),
	(10948, 109, '2015-01-15 00:02:00.000000', 'temperatura', 882.0000, 'ºC'),
	(10949, 109, '2015-01-15 00:02:01.000000', 'temperatura', 377.0000, 'ºC'),
	(10950, 109, '2015-01-15 00:02:02.000000', 'temperatura', 440.0000, 'ºC'),
	(10951, 109, '2015-01-15 00:02:03.000000', 'temperatura', 1070.0000, 'ºC'),
	(10952, 109, '2015-01-15 00:02:04.000000', 'temperatura', 430.0000, 'ºC'),
	(10953, 109, '2015-01-15 00:02:05.000000', 'temperatura', 139.0000, 'ºC'),
	(10954, 109, '2015-01-15 00:02:06.000000', 'temperatura', 607.0000, 'ºC'),
	(10955, 109, '2015-01-15 00:02:07.000000', 'temperatura', 220.0000, 'ºC'),
	(10956, 109, '2015-01-15 00:02:08.000000', 'temperatura', 479.0000, 'ºC'),
	(10957, 109, '2015-01-15 00:02:09.000000', 'temperatura', 534.0000, 'ºC'),
	(10958, 109, '2015-01-15 00:02:10.000000', 'temperatura', 36.0000, 'ºC'),
	(10959, 109, '2015-01-15 00:02:11.000000', 'temperatura', 976.0000, 'ºC'),
	(10960, 109, '2015-01-15 00:02:12.000000', 'temperatura', 1172.0000, 'ºC'),
	(10961, 109, '2015-01-15 00:02:13.000000', 'temperatura', 533.0000, 'ºC'),
	(10962, 109, '2015-01-15 00:02:14.000000', 'temperatura', 351.0000, 'ºC'),
	(10963, 109, '2015-01-15 00:02:15.000000', 'temperatura', 157.0000, 'ºC'),
	(10964, 109, '2015-01-15 00:02:16.000000', 'temperatura', 931.0000, 'ºC'),
	(10965, 109, '2015-01-15 00:02:17.000000', 'temperatura', 587.0000, 'ºC'),
	(10966, 109, '2015-01-15 00:02:18.000000', 'temperatura', 141.0000, 'ºC'),
	(10967, 109, '2015-01-15 00:02:19.000000', 'temperatura', 145.0000, 'ºC'),
	(10968, 109, '2015-01-15 00:02:20.000000', 'temperatura', 300.0000, 'ºC'),
	(10969, 109, '2015-01-15 00:02:21.000000', 'temperatura', 1069.0000, 'ºC'),
	(10970, 109, '2015-01-15 00:02:22.000000', 'temperatura', 844.0000, 'ºC'),
	(10971, 109, '2015-01-15 00:02:23.000000', 'temperatura', 1012.0000, 'ºC'),
	(10972, 109, '2015-01-15 00:02:24.000000', 'temperatura', 128.0000, 'ºC'),
	(10973, 109, '2015-01-15 00:02:25.000000', 'temperatura', 8.0000, 'ºC'),
	(10974, 109, '2015-01-15 00:02:26.000000', 'temperatura', 854.0000, 'ºC'),
	(10975, 109, '2015-01-15 00:02:27.000000', 'temperatura', 645.0000, 'ºC'),
	(10976, 109, '2015-01-15 00:02:28.000000', 'temperatura', 665.0000, 'ºC'),
	(10977, 109, '2015-01-15 00:02:29.000000', 'temperatura', 189.0000, 'ºC'),
	(10978, 109, '2015-01-15 00:02:30.000000', 'temperatura', 153.0000, 'ºC'),
	(10979, 109, '2015-01-15 00:02:31.000000', 'temperatura', 197.0000, 'ºC'),
	(10980, 109, '2015-01-15 00:02:32.000000', 'temperatura', 528.0000, 'ºC'),
	(10981, 109, '2015-01-15 00:02:33.000000', 'temperatura', 850.0000, 'ºC'),
	(10982, 109, '2015-01-15 00:02:34.000000', 'temperatura', 267.0000, 'ºC'),
	(10983, 109, '2015-01-15 00:02:35.000000', 'temperatura', 1185.0000, 'ºC'),
	(10984, 109, '2015-01-15 00:02:36.000000', 'temperatura', 325.0000, 'ºC'),
	(10985, 109, '2015-01-15 00:02:37.000000', 'temperatura', 471.0000, 'ºC'),
	(10986, 109, '2015-01-15 00:02:38.000000', 'temperatura', 179.0000, 'ºC'),
	(10987, 109, '2015-01-15 00:02:39.000000', 'temperatura', 685.0000, 'ºC'),
	(10988, 109, '2015-01-15 00:02:40.000000', 'temperatura', 485.0000, 'ºC'),
	(10989, 109, '2015-01-15 00:02:41.000000', 'temperatura', 373.0000, 'ºC'),
	(10990, 109, '2015-01-15 00:02:42.000000', 'temperatura', 409.0000, 'ºC'),
	(10991, 109, '2015-01-15 00:02:43.000000', 'temperatura', 926.0000, 'ºC'),
	(10992, 109, '2015-01-15 00:02:44.000000', 'temperatura', 1005.0000, 'ºC'),
	(10993, 109, '2015-01-15 00:02:45.000000', 'temperatura', 1049.0000, 'ºC'),
	(10994, 109, '2015-01-15 00:02:46.000000', 'temperatura', 1028.0000, 'ºC'),
	(10995, 109, '2015-01-15 00:02:47.000000', 'temperatura', 795.0000, 'ºC'),
	(10996, 109, '2015-01-15 00:02:48.000000', 'temperatura', 893.0000, 'ºC'),
	(10997, 109, '2015-01-15 00:02:49.000000', 'temperatura', 878.0000, 'ºC'),
	(10998, 109, '2015-01-15 00:02:50.000000', 'temperatura', 511.0000, 'ºC'),
	(10999, 109, '2015-01-15 00:02:51.000000', 'temperatura', 1121.0000, 'ºC'),
	(11000, 109, '2015-01-15 00:02:52.000000', 'temperatura', 475.0000, 'ºC'),
	(11001, 109, '2015-01-15 00:02:53.000000', 'temperatura', 210.0000, 'ºC'),
	(11002, 109, '2015-01-15 00:02:54.000000', 'temperatura', 828.0000, 'ºC'),
	(11003, 109, '2015-01-15 00:02:55.000000', 'temperatura', 1108.0000, 'ºC'),
	(11004, 109, '2015-01-15 00:02:56.000000', 'temperatura', 658.0000, 'ºC'),
	(11005, 109, '2015-01-15 00:02:57.000000', 'temperatura', 1168.0000, 'ºC'),
	(11006, 109, '2015-01-15 00:02:58.000000', 'temperatura', 264.0000, 'ºC'),
	(11007, 109, '2015-01-15 00:02:59.000000', 'temperatura', 219.0000, 'ºC'),
	(11008, 109, '2015-01-15 00:03:00.000000', 'temperatura', 302.0000, 'ºC'),
	(11009, 109, '2015-01-15 00:03:01.000000', 'temperatura', 854.0000, 'ºC'),
	(11010, 109, '2015-01-15 00:03:02.000000', 'temperatura', 963.0000, 'ºC'),
	(11011, 109, '2015-01-15 00:03:03.000000', 'temperatura', 1053.0000, 'ºC'),
	(11012, 109, '2015-01-15 00:03:04.000000', 'temperatura', 1178.0000, 'ºC'),
	(11013, 109, '2015-01-15 00:03:05.000000', 'temperatura', 332.0000, 'ºC'),
	(11014, 109, '2015-01-15 00:03:06.000000', 'temperatura', 528.0000, 'ºC'),
	(11015, 109, '2015-01-15 00:03:07.000000', 'temperatura', 442.0000, 'ºC'),
	(11016, 109, '2015-01-15 00:03:08.000000', 'temperatura', 628.0000, 'ºC'),
	(11017, 109, '2015-01-15 00:03:09.000000', 'temperatura', 613.0000, 'ºC'),
	(11018, 109, '2015-01-15 00:03:10.000000', 'temperatura', 1181.0000, 'ºC'),
	(11019, 109, '2015-01-15 00:03:11.000000', 'temperatura', 469.0000, 'ºC'),
	(11020, 109, '2015-01-15 00:03:12.000000', 'temperatura', 3.0000, 'ºC'),
	(11021, 109, '2015-01-15 00:03:13.000000', 'temperatura', 1007.0000, 'ºC'),
	(11022, 109, '2015-01-15 00:03:14.000000', 'temperatura', 226.0000, 'ºC'),
	(11023, 109, '2015-01-15 00:03:15.000000', 'temperatura', 511.0000, 'ºC'),
	(11024, 109, '2015-01-15 00:03:16.000000', 'temperatura', 679.0000, 'ºC'),
	(11025, 109, '2015-01-15 00:03:17.000000', 'temperatura', 660.0000, 'ºC'),
	(11026, 109, '2015-01-15 00:03:18.000000', 'temperatura', 66.0000, 'ºC'),
	(11027, 109, '2015-01-15 00:03:19.000000', 'temperatura', 748.0000, 'ºC'),
	(11028, 109, '2015-01-15 00:03:20.000000', 'temperatura', 1145.0000, 'ºC'),
	(11029, 109, '2015-01-15 00:03:21.000000', 'temperatura', 1079.0000, 'ºC'),
	(11030, 109, '2015-01-15 00:03:22.000000', 'temperatura', 764.0000, 'ºC'),
	(11031, 109, '2015-01-15 00:03:23.000000', 'temperatura', 580.0000, 'ºC'),
	(11032, 109, '2015-01-15 00:03:24.000000', 'temperatura', 608.0000, 'ºC'),
	(11033, 109, '2015-01-15 00:03:25.000000', 'temperatura', 103.0000, 'ºC'),
	(11034, 109, '2015-01-15 00:03:26.000000', 'temperatura', 1091.0000, 'ºC'),
	(11035, 109, '2015-01-15 00:03:27.000000', 'temperatura', 345.0000, 'ºC'),
	(11036, 109, '2015-01-15 00:03:28.000000', 'temperatura', 852.0000, 'ºC'),
	(11037, 109, '2015-01-15 00:03:29.000000', 'temperatura', 828.0000, 'ºC'),
	(11038, 109, '2015-01-15 00:03:30.000000', 'temperatura', 383.0000, 'ºC'),
	(11039, 109, '2015-01-15 00:03:31.000000', 'temperatura', 633.0000, 'ºC'),
	(11040, 109, '2015-01-15 00:03:32.000000', 'temperatura', 815.0000, 'ºC'),
	(11041, 109, '2015-01-15 00:03:33.000000', 'temperatura', 975.0000, 'ºC'),
	(11042, 109, '2015-01-15 00:03:34.000000', 'temperatura', 33.0000, 'ºC'),
	(11043, 109, '2015-01-15 00:03:35.000000', 'temperatura', 841.0000, 'ºC'),
	(11044, 109, '2015-01-15 00:03:36.000000', 'temperatura', 507.0000, 'ºC'),
	(11045, 109, '2015-01-15 00:03:37.000000', 'temperatura', 11.0000, 'ºC'),
	(11046, 109, '2015-01-15 00:03:38.000000', 'temperatura', 935.0000, 'ºC'),
	(11047, 109, '2015-01-15 00:03:39.000000', 'temperatura', 1043.0000, 'ºC'),
	(11048, 109, '2015-01-15 00:03:40.000000', 'temperatura', 9.0000, 'ºC'),
	(11049, 109, '2015-01-15 00:03:41.000000', 'temperatura', 519.0000, 'ºC'),
	(11050, 109, '2015-01-15 00:03:42.000000', 'temperatura', 166.0000, 'ºC'),
	(11051, 109, '2015-01-15 00:03:43.000000', 'temperatura', 475.0000, 'ºC'),
	(11052, 109, '2015-01-15 00:03:44.000000', 'temperatura', 679.0000, 'ºC'),
	(11053, 109, '2015-01-15 00:03:45.000000', 'temperatura', 770.0000, 'ºC'),
	(11054, 109, '2015-01-15 00:03:46.000000', 'temperatura', 613.0000, 'ºC'),
	(11055, 109, '2015-01-15 00:03:47.000000', 'temperatura', 753.0000, 'ºC'),
	(11056, 109, '2015-01-15 00:03:48.000000', 'temperatura', 730.0000, 'ºC'),
	(11057, 109, '2015-01-15 00:03:49.000000', 'temperatura', 192.0000, 'ºC'),
	(11058, 109, '2015-01-15 00:03:50.000000', 'temperatura', 1168.0000, 'ºC'),
	(11059, 109, '2015-01-15 00:03:51.000000', 'temperatura', 464.0000, 'ºC'),
	(11060, 109, '2015-01-15 00:03:52.000000', 'temperatura', 16.0000, 'ºC'),
	(11061, 109, '2015-01-15 00:03:53.000000', 'temperatura', 1089.0000, 'ºC'),
	(11062, 109, '2015-01-15 00:03:54.000000', 'temperatura', 599.0000, 'ºC'),
	(11063, 109, '2015-01-15 00:03:55.000000', 'temperatura', 926.0000, 'ºC'),
	(11064, 109, '2015-01-15 00:03:56.000000', 'temperatura', 437.0000, 'ºC'),
	(11065, 109, '2015-01-15 00:03:57.000000', 'temperatura', 605.0000, 'ºC'),
	(11066, 109, '2015-01-15 00:03:58.000000', 'temperatura', 514.0000, 'ºC'),
	(11067, 109, '2015-01-15 00:03:59.000000', 'temperatura', 756.0000, 'ºC'),
	(11068, 109, '2015-01-15 00:04:00.000000', 'temperatura', 1039.0000, 'ºC'),
	(11069, 109, '2015-01-15 00:04:01.000000', 'temperatura', 528.0000, 'ºC'),
	(11070, 109, '2015-01-15 00:04:02.000000', 'temperatura', 725.0000, 'ºC'),
	(11071, 109, '2015-01-15 00:04:03.000000', 'temperatura', 838.0000, 'ºC'),
	(11072, 109, '2015-01-15 00:04:04.000000', 'temperatura', 818.0000, 'ºC'),
	(11073, 109, '2015-01-15 00:04:05.000000', 'temperatura', 378.0000, 'ºC'),
	(11074, 109, '2015-01-15 00:04:06.000000', 'temperatura', 634.0000, 'ºC'),
	(11075, 109, '2015-01-15 00:04:07.000000', 'temperatura', 835.0000, 'ºC'),
	(11076, 109, '2015-01-15 00:04:08.000000', 'temperatura', 1077.0000, 'ºC'),
	(11077, 109, '2015-01-15 00:04:09.000000', 'temperatura', 479.0000, 'ºC'),
	(11078, 109, '2015-01-15 00:04:10.000000', 'temperatura', 365.0000, 'ºC'),
	(11079, 109, '2015-01-15 00:04:11.000000', 'temperatura', 387.0000, 'ºC'),
	(11080, 109, '2015-01-15 00:04:12.000000', 'temperatura', 841.0000, 'ºC'),
	(11081, 109, '2015-01-15 00:04:13.000000', 'temperatura', 644.0000, 'ºC'),
	(11082, 109, '2015-01-15 00:04:14.000000', 'temperatura', 697.0000, 'ºC'),
	(11083, 109, '2015-01-15 00:04:15.000000', 'temperatura', 355.0000, 'ºC'),
	(11084, 109, '2015-01-15 00:04:16.000000', 'temperatura', 885.0000, 'ºC'),
	(11085, 109, '2015-01-15 00:04:17.000000', 'temperatura', 961.0000, 'ºC'),
	(11086, 109, '2015-01-15 00:04:18.000000', 'temperatura', 948.0000, 'ºC'),
	(11087, 109, '2015-01-15 00:04:19.000000', 'temperatura', 660.0000, 'ºC'),
	(11088, 109, '2015-01-15 00:04:20.000000', 'temperatura', 457.0000, 'ºC'),
	(11089, 109, '2015-01-15 00:04:21.000000', 'temperatura', 306.0000, 'ºC'),
	(11090, 109, '2015-01-15 00:04:22.000000', 'temperatura', 159.0000, 'ºC'),
	(11091, 109, '2015-01-15 00:04:23.000000', 'temperatura', 1076.0000, 'ºC'),
	(11092, 109, '2015-01-15 00:04:24.000000', 'temperatura', 104.0000, 'ºC'),
	(11093, 109, '2015-01-15 00:04:25.000000', 'temperatura', 894.0000, 'ºC'),
	(11094, 109, '2015-01-15 00:04:26.000000', 'temperatura', 558.0000, 'ºC'),
	(11095, 109, '2015-01-15 00:04:27.000000', 'temperatura', 108.0000, 'ºC'),
	(11096, 109, '2015-01-15 00:04:28.000000', 'temperatura', 66.0000, 'ºC'),
	(11097, 109, '2015-01-15 00:04:29.000000', 'temperatura', 6.0000, 'ºC'),
	(11098, 109, '2015-01-15 00:04:30.000000', 'temperatura', 1032.0000, 'ºC'),
	(11099, 109, '2015-01-15 00:04:31.000000', 'temperatura', 342.0000, 'ºC'),
	(11100, 109, '2015-01-15 00:04:32.000000', 'temperatura', 1016.0000, 'ºC'),
	(11101, 109, '2015-01-15 00:04:33.000000', 'temperatura', 455.0000, 'ºC'),
	(11102, 109, '2015-01-15 00:04:34.000000', 'temperatura', 425.0000, 'ºC'),
	(11103, 109, '2015-01-15 00:04:35.000000', 'temperatura', 763.0000, 'ºC'),
	(11104, 109, '2015-01-15 00:04:36.000000', 'temperatura', 138.0000, 'ºC'),
	(11105, 109, '2015-01-15 00:04:37.000000', 'temperatura', 801.0000, 'ºC'),
	(11106, 109, '2015-01-15 00:04:38.000000', 'temperatura', 1191.0000, 'ºC'),
	(11107, 109, '2015-01-15 00:04:39.000000', 'temperatura', 1155.0000, 'ºC'),
	(11108, 109, '2015-01-15 00:04:40.000000', 'temperatura', 1002.0000, 'ºC'),
	(11109, 109, '2015-01-15 00:04:41.000000', 'temperatura', 344.0000, 'ºC'),
	(11110, 109, '2015-01-15 00:04:42.000000', 'temperatura', 1115.0000, 'ºC'),
	(11111, 109, '2015-01-15 00:04:43.000000', 'temperatura', 942.0000, 'ºC'),
	(11112, 109, '2015-01-15 00:04:44.000000', 'temperatura', 166.0000, 'ºC'),
	(11113, 109, '2015-01-15 00:04:45.000000', 'temperatura', 405.0000, 'ºC'),
	(11114, 109, '2015-01-15 00:04:46.000000', 'temperatura', 326.0000, 'ºC'),
	(11115, 109, '2015-01-15 00:04:47.000000', 'temperatura', 418.0000, 'ºC'),
	(11116, 109, '2015-01-15 00:04:48.000000', 'temperatura', 1111.0000, 'ºC'),
	(11117, 109, '2015-01-15 00:04:49.000000', 'temperatura', 701.0000, 'ºC'),
	(11118, 109, '2015-01-15 00:04:50.000000', 'temperatura', 174.0000, 'ºC'),
	(11119, 109, '2015-01-15 00:04:51.000000', 'temperatura', 1168.0000, 'ºC'),
	(11120, 109, '2015-01-15 00:04:52.000000', 'temperatura', 517.0000, 'ºC'),
	(11121, 109, '2015-01-15 00:04:53.000000', 'temperatura', 283.0000, 'ºC'),
	(11122, 109, '2015-01-15 00:04:54.000000', 'temperatura', 1065.0000, 'ºC'),
	(11123, 109, '2015-01-15 00:04:55.000000', 'temperatura', 877.0000, 'ºC'),
	(11124, 109, '2015-01-15 00:04:56.000000', 'temperatura', 1191.0000, 'ºC'),
	(11125, 109, '2015-01-15 00:04:57.000000', 'temperatura', 925.0000, 'ºC'),
	(11126, 109, '2015-01-15 00:04:58.000000', 'temperatura', 1052.0000, 'ºC'),
	(11127, 109, '2015-01-15 00:04:59.000000', 'temperatura', 87.0000, 'ºC'),
	(11128, 109, '2015-01-15 00:05:00.000000', 'temperatura', 878.0000, 'ºC'),
	(11129, 109, '2015-01-15 00:05:01.000000', 'temperatura', 528.0000, 'ºC'),
	(11130, 109, '2015-01-15 00:05:02.000000', 'temperatura', 10.0000, 'ºC'),
	(11131, 109, '2015-01-15 00:05:03.000000', 'temperatura', 863.0000, 'ºC'),
	(11132, 109, '2015-01-15 00:05:04.000000', 'temperatura', 688.0000, 'ºC'),
	(11133, 109, '2015-01-15 00:05:05.000000', 'temperatura', 849.0000, 'ºC'),
	(11134, 109, '2015-01-15 00:05:06.000000', 'temperatura', 984.0000, 'ºC'),
	(11135, 109, '2015-01-15 00:05:07.000000', 'temperatura', 1171.0000, 'ºC'),
	(11136, 109, '2015-01-15 00:05:08.000000', 'temperatura', 506.0000, 'ºC'),
	(11137, 109, '2015-01-15 00:05:09.000000', 'temperatura', 215.0000, 'ºC'),
	(11138, 109, '2015-01-15 00:05:10.000000', 'temperatura', 758.0000, 'ºC'),
	(11139, 109, '2015-01-15 00:05:11.000000', 'temperatura', 745.0000, 'ºC'),
	(11140, 109, '2015-01-15 00:05:12.000000', 'temperatura', 250.0000, 'ºC'),
	(11141, 109, '2015-01-15 00:05:13.000000', 'temperatura', 219.0000, 'ºC'),
	(11142, 109, '2015-01-15 00:05:14.000000', 'temperatura', 343.0000, 'ºC'),
	(11143, 109, '2015-01-15 00:05:15.000000', 'temperatura', 1059.0000, 'ºC'),
	(11144, 109, '2015-01-15 00:05:16.000000', 'temperatura', 666.0000, 'ºC'),
	(11145, 109, '2015-01-15 00:05:17.000000', 'temperatura', 153.0000, 'ºC'),
	(11146, 109, '2015-01-15 00:05:18.000000', 'temperatura', 1166.0000, 'ºC'),
	(11147, 109, '2015-01-15 00:05:19.000000', 'temperatura', 575.0000, 'ºC'),
	(11148, 109, '2015-01-15 00:05:20.000000', 'temperatura', 574.0000, 'ºC'),
	(11149, 109, '2015-01-15 00:05:21.000000', 'temperatura', 1149.0000, 'ºC'),
	(11150, 109, '2015-01-15 00:05:22.000000', 'temperatura', 421.0000, 'ºC'),
	(11151, 109, '2015-01-15 00:05:23.000000', 'temperatura', 1058.0000, 'ºC'),
	(11152, 109, '2015-01-15 00:05:24.000000', 'temperatura', 429.0000, 'ºC'),
	(11153, 109, '2015-01-15 00:05:25.000000', 'temperatura', 171.0000, 'ºC'),
	(11154, 109, '2015-01-15 00:05:26.000000', 'temperatura', 767.0000, 'ºC'),
	(11155, 109, '2015-01-15 00:05:27.000000', 'temperatura', 924.0000, 'ºC'),
	(11156, 109, '2015-01-15 00:05:28.000000', 'temperatura', 1119.0000, 'ºC'),
	(11157, 109, '2015-01-15 00:05:29.000000', 'temperatura', 425.0000, 'ºC'),
	(11158, 109, '2015-01-15 00:05:30.000000', 'temperatura', 1169.0000, 'ºC'),
	(11159, 109, '2015-01-15 00:05:31.000000', 'temperatura', 968.0000, 'ºC'),
	(11160, 109, '2015-01-15 00:05:32.000000', 'temperatura', 136.0000, 'ºC'),
	(11161, 109, '2015-01-15 00:05:33.000000', 'temperatura', 176.0000, 'ºC'),
	(11162, 109, '2015-01-15 00:05:34.000000', 'temperatura', 473.0000, 'ºC'),
	(11163, 109, '2015-01-15 00:05:35.000000', 'temperatura', 637.0000, 'ºC'),
	(11164, 109, '2015-01-15 00:05:36.000000', 'temperatura', 568.0000, 'ºC'),
	(11165, 109, '2015-01-15 00:05:37.000000', 'temperatura', 930.0000, 'ºC'),
	(11166, 109, '2015-01-15 00:05:38.000000', 'temperatura', 543.0000, 'ºC'),
	(11167, 109, '2015-01-15 00:05:39.000000', 'temperatura', 1129.0000, 'ºC'),
	(11168, 109, '2015-01-15 00:05:40.000000', 'temperatura', 414.0000, 'ºC'),
	(11169, 109, '2015-01-15 00:05:41.000000', 'temperatura', 1086.0000, 'ºC'),
	(11170, 109, '2015-01-15 00:05:42.000000', 'temperatura', 587.0000, 'ºC'),
	(11171, 109, '2015-01-15 00:05:43.000000', 'temperatura', 877.0000, 'ºC'),
	(11172, 109, '2015-01-15 00:05:44.000000', 'temperatura', 227.0000, 'ºC'),
	(11173, 109, '2015-01-15 00:05:45.000000', 'temperatura', 903.0000, 'ºC'),
	(11174, 109, '2015-01-15 00:05:46.000000', 'temperatura', 235.0000, 'ºC'),
	(11175, 109, '2015-01-15 00:05:47.000000', 'temperatura', 867.0000, 'ºC'),
	(11176, 109, '2015-01-15 00:05:48.000000', 'temperatura', 31.0000, 'ºC'),
	(11177, 109, '2015-01-15 00:05:49.000000', 'temperatura', 1154.0000, 'ºC'),
	(11178, 109, '2015-01-15 00:05:50.000000', 'temperatura', 877.0000, 'ºC'),
	(11179, 109, '2015-01-15 00:05:51.000000', 'temperatura', 923.0000, 'ºC'),
	(11180, 109, '2015-01-15 00:05:52.000000', 'temperatura', 786.0000, 'ºC'),
	(11181, 109, '2015-01-15 00:05:53.000000', 'temperatura', 1162.0000, 'ºC'),
	(11182, 109, '2015-01-15 00:05:54.000000', 'temperatura', 1052.0000, 'ºC'),
	(11183, 109, '2015-01-15 00:05:55.000000', 'temperatura', 575.0000, 'ºC'),
	(11184, 109, '2015-01-15 00:05:56.000000', 'temperatura', 921.0000, 'ºC'),
	(11185, 109, '2015-01-15 00:05:57.000000', 'temperatura', 478.0000, 'ºC'),
	(11186, 109, '2015-01-15 00:05:58.000000', 'temperatura', 829.0000, 'ºC'),
	(11187, 109, '2015-01-15 00:05:59.000000', 'temperatura', 309.0000, 'ºC'),
	(11188, 109, '2015-01-15 00:06:00.000000', 'temperatura', 260.0000, 'ºC'),
	(11189, 109, '2015-01-15 00:06:01.000000', 'temperatura', 374.0000, 'ºC'),
	(11190, 109, '2015-01-15 00:06:02.000000', 'temperatura', 1090.0000, 'ºC'),
	(11191, 109, '2015-01-15 00:06:03.000000', 'temperatura', 727.0000, 'ºC'),
	(11192, 109, '2015-01-15 00:06:04.000000', 'temperatura', 365.0000, 'ºC'),
	(11193, 109, '2015-01-15 00:06:05.000000', 'temperatura', 847.0000, 'ºC'),
	(11194, 109, '2015-01-15 00:06:06.000000', 'temperatura', 742.0000, 'ºC'),
	(11195, 109, '2015-01-15 00:06:07.000000', 'temperatura', 1166.0000, 'ºC'),
	(11196, 109, '2015-01-15 00:06:08.000000', 'temperatura', 7.0000, 'ºC'),
	(11197, 109, '2015-01-15 00:06:09.000000', 'temperatura', 137.0000, 'ºC'),
	(11198, 109, '2015-01-15 00:06:10.000000', 'temperatura', 664.0000, 'ºC'),
	(11199, 109, '2015-01-15 00:06:11.000000', 'temperatura', 508.0000, 'ºC'),
	(11200, 109, '2015-01-15 00:06:12.000000', 'temperatura', 550.0000, 'ºC'),
	(11201, 109, '2015-01-15 00:06:13.000000', 'temperatura', 27.0000, 'ºC'),
	(11202, 109, '2015-01-15 00:06:14.000000', 'temperatura', 884.0000, 'ºC'),
	(11203, 109, '2015-01-15 00:06:15.000000', 'temperatura', 738.0000, 'ºC'),
	(11204, 109, '2015-01-15 00:06:16.000000', 'temperatura', 1042.0000, 'ºC'),
	(11205, 109, '2015-01-15 00:06:17.000000', 'temperatura', 595.0000, 'ºC'),
	(11206, 109, '2015-01-15 00:06:18.000000', 'temperatura', 1050.0000, 'ºC'),
	(11207, 109, '2015-01-15 00:06:19.000000', 'temperatura', 1065.0000, 'ºC'),
	(11208, 109, '2015-01-15 00:06:20.000000', 'temperatura', 974.0000, 'ºC'),
	(11209, 109, '2015-01-15 00:06:21.000000', 'temperatura', 477.0000, 'ºC'),
	(11210, 109, '2015-01-15 00:06:22.000000', 'temperatura', 663.0000, 'ºC'),
	(11211, 109, '2015-01-15 00:06:23.000000', 'temperatura', 683.0000, 'ºC'),
	(11212, 109, '2015-01-15 00:06:24.000000', 'temperatura', 229.0000, 'ºC'),
	(11213, 109, '2015-01-15 00:06:25.000000', 'temperatura', 294.0000, 'ºC'),
	(11214, 109, '2015-01-15 00:06:26.000000', 'temperatura', 786.0000, 'ºC'),
	(11215, 109, '2015-01-15 00:06:27.000000', 'temperatura', 650.0000, 'ºC'),
	(11216, 109, '2015-01-15 00:06:28.000000', 'temperatura', 889.0000, 'ºC'),
	(11217, 109, '2015-01-15 00:06:29.000000', 'temperatura', 97.0000, 'ºC'),
	(11218, 109, '2015-01-15 00:06:30.000000', 'temperatura', 217.0000, 'ºC'),
	(11219, 109, '2015-01-15 00:06:31.000000', 'temperatura', 796.0000, 'ºC'),
	(11220, 109, '2015-01-15 00:06:32.000000', 'temperatura', 931.0000, 'ºC'),
	(11221, 109, '2015-01-15 00:06:33.000000', 'temperatura', 1066.0000, 'ºC'),
	(11222, 109, '2015-01-15 00:06:34.000000', 'temperatura', 140.0000, 'ºC'),
	(11223, 109, '2015-01-15 00:06:35.000000', 'temperatura', 1099.0000, 'ºC'),
	(11224, 109, '2015-01-15 00:06:36.000000', 'temperatura', 278.0000, 'ºC'),
	(11225, 109, '2015-01-15 00:06:37.000000', 'temperatura', 494.0000, 'ºC'),
	(11226, 109, '2015-01-15 00:06:38.000000', 'temperatura', 434.0000, 'ºC'),
	(11227, 109, '2015-01-15 00:06:39.000000', 'temperatura', 687.0000, 'ºC'),
	(11228, 109, '2015-01-15 00:06:40.000000', 'temperatura', 937.0000, 'ºC'),
	(11229, 109, '2015-01-15 00:06:41.000000', 'temperatura', 224.0000, 'ºC'),
	(11230, 109, '2015-01-15 00:06:42.000000', 'temperatura', 711.0000, 'ºC'),
	(11231, 109, '2015-01-15 00:06:43.000000', 'temperatura', 481.0000, 'ºC'),
	(11232, 109, '2015-01-15 00:06:44.000000', 'temperatura', 273.0000, 'ºC'),
	(11233, 109, '2015-01-15 00:06:45.000000', 'temperatura', 1121.0000, 'ºC'),
	(11234, 109, '2015-01-15 00:06:46.000000', 'temperatura', 1190.0000, 'ºC'),
	(11235, 109, '2015-01-15 00:06:47.000000', 'temperatura', 185.0000, 'ºC'),
	(11236, 109, '2015-01-15 00:06:48.000000', 'temperatura', 956.0000, 'ºC'),
	(11237, 109, '2015-01-15 00:06:49.000000', 'temperatura', 625.0000, 'ºC'),
	(11238, 109, '2015-01-15 00:06:50.000000', 'temperatura', 257.0000, 'ºC'),
	(11239, 109, '2015-01-15 00:06:51.000000', 'temperatura', 611.0000, 'ºC'),
	(11240, 109, '2015-01-15 00:06:52.000000', 'temperatura', 1083.0000, 'ºC'),
	(11241, 109, '2015-01-15 00:06:53.000000', 'temperatura', 1184.0000, 'ºC'),
	(11242, 109, '2015-01-15 00:06:54.000000', 'temperatura', 273.0000, 'ºC'),
	(11243, 109, '2015-01-15 00:06:55.000000', 'temperatura', 213.0000, 'ºC'),
	(11244, 109, '2015-01-15 00:06:56.000000', 'temperatura', 248.0000, 'ºC'),
	(11245, 109, '2015-01-15 00:06:57.000000', 'temperatura', 598.0000, 'ºC'),
	(11246, 109, '2015-01-15 00:06:58.000000', 'temperatura', 1048.0000, 'ºC'),
	(11247, 109, '2015-01-15 00:06:59.000000', 'temperatura', 1048.0000, 'ºC'),
	(11248, 109, '2015-01-15 00:07:00.000000', 'temperatura', 897.0000, 'ºC'),
	(11249, 109, '2015-01-15 00:07:01.000000', 'temperatura', 140.0000, 'ºC'),
	(11250, 109, '2015-01-15 00:07:02.000000', 'temperatura', 410.0000, 'ºC'),
	(11251, 109, '2015-01-15 00:07:03.000000', 'temperatura', 432.0000, 'ºC'),
	(11252, 109, '2015-01-15 00:07:04.000000', 'temperatura', 928.0000, 'ºC'),
	(11253, 109, '2015-01-15 00:07:05.000000', 'temperatura', 946.0000, 'ºC'),
	(11254, 109, '2015-01-15 00:07:06.000000', 'temperatura', 747.0000, 'ºC'),
	(11255, 109, '2015-01-15 00:07:07.000000', 'temperatura', 896.0000, 'ºC'),
	(11256, 109, '2015-01-15 00:07:08.000000', 'temperatura', 1039.0000, 'ºC'),
	(11257, 109, '2015-01-15 00:07:09.000000', 'temperatura', 109.0000, 'ºC'),
	(11258, 109, '2015-01-15 00:07:10.000000', 'temperatura', 1028.0000, 'ºC'),
	(11259, 109, '2015-01-15 00:07:11.000000', 'temperatura', 12.0000, 'ºC'),
	(11260, 109, '2015-01-15 00:07:12.000000', 'temperatura', 578.0000, 'ºC'),
	(11261, 109, '2015-01-15 00:07:13.000000', 'temperatura', 453.0000, 'ºC'),
	(11262, 109, '2015-01-15 00:07:14.000000', 'temperatura', 531.0000, 'ºC'),
	(11263, 109, '2015-01-15 00:07:15.000000', 'temperatura', 99.0000, 'ºC'),
	(11264, 109, '2015-01-15 00:07:16.000000', 'temperatura', 100.0000, 'ºC'),
	(11265, 109, '2015-01-15 00:07:17.000000', 'temperatura', 203.0000, 'ºC'),
	(11266, 109, '2015-01-15 00:07:18.000000', 'temperatura', 716.0000, 'ºC'),
	(11267, 109, '2015-01-15 00:07:19.000000', 'temperatura', 573.0000, 'ºC'),
	(11268, 109, '2015-01-15 00:07:20.000000', 'temperatura', 716.0000, 'ºC'),
	(11269, 109, '2015-01-15 00:07:21.000000', 'temperatura', 663.0000, 'ºC'),
	(11270, 109, '2015-01-15 00:07:22.000000', 'temperatura', 1166.0000, 'ºC'),
	(11271, 109, '2015-01-15 00:07:23.000000', 'temperatura', 242.0000, 'ºC'),
	(11272, 109, '2015-01-15 00:07:24.000000', 'temperatura', 113.0000, 'ºC'),
	(11273, 109, '2015-01-15 00:07:25.000000', 'temperatura', 1040.0000, 'ºC'),
	(11274, 109, '2015-01-15 00:07:26.000000', 'temperatura', 61.0000, 'ºC'),
	(11275, 109, '2015-01-15 00:07:27.000000', 'temperatura', 786.0000, 'ºC'),
	(11276, 109, '2015-01-15 00:07:28.000000', 'temperatura', 148.0000, 'ºC'),
	(11277, 109, '2015-01-15 00:07:29.000000', 'temperatura', 781.0000, 'ºC'),
	(11278, 109, '2015-01-15 00:07:30.000000', 'temperatura', 1062.0000, 'ºC'),
	(11279, 109, '2015-01-15 00:07:31.000000', 'temperatura', 569.0000, 'ºC'),
	(11280, 109, '2015-01-15 00:07:32.000000', 'temperatura', 859.0000, 'ºC'),
	(11281, 109, '2015-01-15 00:07:33.000000', 'temperatura', 189.0000, 'ºC'),
	(11282, 109, '2015-01-15 00:07:34.000000', 'temperatura', 768.0000, 'ºC'),
	(11283, 109, '2015-01-15 00:07:35.000000', 'temperatura', 874.0000, 'ºC'),
	(11284, 109, '2015-01-15 00:07:36.000000', 'temperatura', 866.0000, 'ºC'),
	(11285, 109, '2015-01-15 00:07:37.000000', 'temperatura', 510.0000, 'ºC'),
	(11286, 109, '2015-01-15 00:07:38.000000', 'temperatura', 1152.0000, 'ºC'),
	(11287, 109, '2015-01-15 00:07:39.000000', 'temperatura', 632.0000, 'ºC'),
	(11288, 109, '2015-01-15 00:07:40.000000', 'temperatura', 902.0000, 'ºC'),
	(11289, 109, '2015-01-15 00:07:41.000000', 'temperatura', 213.0000, 'ºC'),
	(11290, 109, '2015-01-15 00:07:42.000000', 'temperatura', 763.0000, 'ºC'),
	(11291, 109, '2015-01-15 00:07:43.000000', 'temperatura', 774.0000, 'ºC'),
	(11292, 109, '2015-01-15 00:07:44.000000', 'temperatura', 384.0000, 'ºC'),
	(11293, 109, '2015-01-15 00:07:45.000000', 'temperatura', 799.0000, 'ºC'),
	(11294, 109, '2015-01-15 00:07:46.000000', 'temperatura', 443.0000, 'ºC'),
	(11295, 109, '2015-01-15 00:07:47.000000', 'temperatura', 1019.0000, 'ºC'),
	(11296, 109, '2015-01-15 00:07:48.000000', 'temperatura', 164.0000, 'ºC'),
	(11297, 109, '2015-01-15 00:07:49.000000', 'temperatura', 166.0000, 'ºC'),
	(11298, 109, '2015-01-15 00:07:50.000000', 'temperatura', 336.0000, 'ºC'),
	(11299, 109, '2015-01-15 00:07:51.000000', 'temperatura', 1184.0000, 'ºC'),
	(11300, 109, '2015-01-15 00:07:52.000000', 'temperatura', 114.0000, 'ºC'),
	(11301, 109, '2015-01-15 00:07:53.000000', 'temperatura', 619.0000, 'ºC'),
	(11302, 109, '2015-01-15 00:07:54.000000', 'temperatura', 351.0000, 'ºC'),
	(11303, 109, '2015-01-15 00:07:55.000000', 'temperatura', 1097.0000, 'ºC'),
	(11304, 109, '2015-01-15 00:07:56.000000', 'temperatura', 836.0000, 'ºC'),
	(11305, 109, '2015-01-15 00:07:57.000000', 'temperatura', 888.0000, 'ºC'),
	(11306, 109, '2015-01-15 00:07:58.000000', 'temperatura', 731.0000, 'ºC'),
	(11307, 109, '2015-01-15 00:07:59.000000', 'temperatura', 991.0000, 'ºC'),
	(11308, 109, '2015-01-15 00:08:00.000000', 'temperatura', 364.0000, 'ºC'),
	(11309, 109, '2015-01-15 00:08:01.000000', 'temperatura', 49.0000, 'ºC'),
	(11310, 109, '2015-01-15 00:08:02.000000', 'temperatura', 352.0000, 'ºC'),
	(11311, 109, '2015-01-15 00:08:03.000000', 'temperatura', 415.0000, 'ºC'),
	(11312, 109, '2015-01-15 00:08:04.000000', 'temperatura', 1020.0000, 'ºC'),
	(11313, 109, '2015-01-15 00:08:05.000000', 'temperatura', 255.0000, 'ºC'),
	(11314, 109, '2015-01-15 00:08:06.000000', 'temperatura', 615.0000, 'ºC'),
	(11315, 109, '2015-01-15 00:08:07.000000', 'temperatura', 1111.0000, 'ºC'),
	(11316, 109, '2015-01-15 00:08:08.000000', 'temperatura', 110.0000, 'ºC'),
	(11317, 109, '2015-01-15 00:08:09.000000', 'temperatura', 819.0000, 'ºC'),
	(11318, 109, '2015-01-15 00:08:10.000000', 'temperatura', 163.0000, 'ºC'),
	(11319, 109, '2015-01-15 00:08:11.000000', 'temperatura', 761.0000, 'ºC'),
	(11320, 109, '2015-01-15 00:08:12.000000', 'temperatura', 914.0000, 'ºC'),
	(11321, 109, '2015-01-15 00:08:13.000000', 'temperatura', 1091.0000, 'ºC'),
	(11322, 109, '2015-01-15 00:08:14.000000', 'temperatura', 310.0000, 'ºC'),
	(11323, 109, '2015-01-15 00:08:15.000000', 'temperatura', 677.0000, 'ºC'),
	(11324, 109, '2015-01-15 00:08:16.000000', 'temperatura', 58.0000, 'ºC'),
	(11325, 109, '2015-01-15 00:08:17.000000', 'temperatura', 660.0000, 'ºC'),
	(11326, 109, '2015-01-15 00:08:18.000000', 'temperatura', 725.0000, 'ºC'),
	(11327, 109, '2015-01-15 00:08:19.000000', 'temperatura', 447.0000, 'ºC'),
	(11328, 109, '2015-01-15 00:08:20.000000', 'temperatura', 61.0000, 'ºC'),
	(11329, 109, '2015-01-15 00:08:21.000000', 'temperatura', 166.0000, 'ºC'),
	(11330, 109, '2015-01-15 00:08:22.000000', 'temperatura', 644.0000, 'ºC'),
	(11331, 109, '2015-01-15 00:08:23.000000', 'temperatura', 324.0000, 'ºC'),
	(11332, 109, '2015-01-15 00:08:24.000000', 'temperatura', 886.0000, 'ºC'),
	(11333, 109, '2015-01-15 00:08:25.000000', 'temperatura', 1062.0000, 'ºC'),
	(11334, 109, '2015-01-15 00:08:26.000000', 'temperatura', 252.0000, 'ºC'),
	(11335, 109, '2015-01-15 00:08:27.000000', 'temperatura', 474.0000, 'ºC'),
	(11336, 109, '2015-01-15 00:08:28.000000', 'temperatura', 416.0000, 'ºC'),
	(11337, 109, '2015-01-15 00:08:29.000000', 'temperatura', 659.0000, 'ºC'),
	(11338, 109, '2015-01-15 00:08:30.000000', 'temperatura', 846.0000, 'ºC'),
	(11339, 109, '2015-01-15 00:08:31.000000', 'temperatura', 1056.0000, 'ºC'),
	(11340, 109, '2015-01-15 00:08:32.000000', 'temperatura', 339.0000, 'ºC'),
	(11341, 109, '2015-01-15 00:08:33.000000', 'temperatura', 929.0000, 'ºC'),
	(11342, 109, '2015-01-15 00:08:34.000000', 'temperatura', 27.0000, 'ºC'),
	(11343, 109, '2015-01-15 00:08:35.000000', 'temperatura', 950.0000, 'ºC'),
	(11344, 109, '2015-01-15 00:08:36.000000', 'temperatura', 1069.0000, 'ºC'),
	(11345, 109, '2015-01-15 00:08:37.000000', 'temperatura', 96.0000, 'ºC'),
	(11346, 109, '2015-01-15 00:08:38.000000', 'temperatura', 872.0000, 'ºC'),
	(11347, 109, '2015-01-15 00:08:39.000000', 'temperatura', 474.0000, 'ºC'),
	(11348, 109, '2015-01-15 00:08:40.000000', 'temperatura', 954.0000, 'ºC'),
	(11349, 109, '2015-01-15 00:08:41.000000', 'temperatura', 949.0000, 'ºC'),
	(11350, 109, '2015-01-15 00:08:42.000000', 'temperatura', 684.0000, 'ºC'),
	(11351, 109, '2015-01-15 00:08:43.000000', 'temperatura', 575.0000, 'ºC'),
	(11352, 109, '2015-01-15 00:08:44.000000', 'temperatura', 822.0000, 'ºC'),
	(11353, 109, '2015-01-15 00:08:45.000000', 'temperatura', 1186.0000, 'ºC'),
	(11354, 109, '2015-01-15 00:08:46.000000', 'temperatura', 1063.0000, 'ºC'),
	(11355, 109, '2015-01-15 00:08:47.000000', 'temperatura', 557.0000, 'ºC'),
	(11356, 109, '2015-01-15 00:08:48.000000', 'temperatura', 797.0000, 'ºC'),
	(11357, 109, '2015-01-15 00:08:49.000000', 'temperatura', 1115.0000, 'ºC'),
	(11358, 109, '2015-01-15 00:08:50.000000', 'temperatura', 786.0000, 'ºC'),
	(11359, 109, '2015-01-15 00:08:51.000000', 'temperatura', 586.0000, 'ºC'),
	(11360, 109, '2015-01-15 00:08:52.000000', 'temperatura', 573.0000, 'ºC'),
	(11361, 109, '2015-01-15 00:08:53.000000', 'temperatura', 1108.0000, 'ºC'),
	(11362, 109, '2015-01-15 00:08:54.000000', 'temperatura', 219.0000, 'ºC'),
	(11363, 109, '2015-01-15 00:08:55.000000', 'temperatura', 174.0000, 'ºC'),
	(11364, 109, '2015-01-15 00:08:56.000000', 'temperatura', 214.0000, 'ºC'),
	(11365, 109, '2015-01-15 00:08:57.000000', 'temperatura', 548.0000, 'ºC'),
	(11366, 109, '2015-01-15 00:08:58.000000', 'temperatura', 896.0000, 'ºC'),
	(11367, 109, '2015-01-15 00:08:59.000000', 'temperatura', 439.0000, 'ºC'),
	(11368, 109, '2015-01-15 00:09:00.000000', 'temperatura', 707.0000, 'ºC'),
	(11369, 109, '2015-01-15 00:09:01.000000', 'temperatura', 1018.0000, 'ºC'),
	(11370, 109, '2015-01-15 00:09:02.000000', 'temperatura', 569.0000, 'ºC'),
	(11371, 109, '2015-01-15 00:09:03.000000', 'temperatura', 991.0000, 'ºC'),
	(11372, 109, '2015-01-15 00:09:04.000000', 'temperatura', 848.0000, 'ºC'),
	(11373, 109, '2015-01-15 00:09:05.000000', 'temperatura', 68.0000, 'ºC'),
	(11374, 109, '2015-01-15 00:09:06.000000', 'temperatura', 198.0000, 'ºC'),
	(11375, 109, '2015-01-15 00:09:07.000000', 'temperatura', 784.0000, 'ºC'),
	(11376, 109, '2015-01-15 00:09:08.000000', 'temperatura', 928.0000, 'ºC'),
	(11377, 109, '2015-01-15 00:09:09.000000', 'temperatura', 1089.0000, 'ºC'),
	(11378, 109, '2015-01-15 00:09:10.000000', 'temperatura', 261.0000, 'ºC'),
	(11379, 109, '2015-01-15 00:09:11.000000', 'temperatura', 440.0000, 'ºC'),
	(11380, 109, '2015-01-15 00:09:12.000000', 'temperatura', 218.0000, 'ºC'),
	(11381, 109, '2015-01-15 00:09:13.000000', 'temperatura', 969.0000, 'ºC'),
	(11382, 109, '2015-01-15 00:09:14.000000', 'temperatura', 593.0000, 'ºC'),
	(11383, 109, '2015-01-15 00:09:15.000000', 'temperatura', 57.0000, 'ºC'),
	(11384, 109, '2015-01-15 00:09:16.000000', 'temperatura', 906.0000, 'ºC'),
	(11385, 109, '2015-01-15 00:09:17.000000', 'temperatura', 762.0000, 'ºC'),
	(11386, 109, '2015-01-15 00:09:18.000000', 'temperatura', 1092.0000, 'ºC'),
	(11387, 109, '2015-01-15 00:09:19.000000', 'temperatura', 776.0000, 'ºC'),
	(11388, 109, '2015-01-15 00:09:20.000000', 'temperatura', 601.0000, 'ºC'),
	(11389, 109, '2015-01-15 00:09:21.000000', 'temperatura', 679.0000, 'ºC'),
	(11390, 109, '2015-01-15 00:09:22.000000', 'temperatura', 393.0000, 'ºC'),
	(11391, 109, '2015-01-15 00:09:23.000000', 'temperatura', 1128.0000, 'ºC'),
	(11392, 109, '2015-01-15 00:09:24.000000', 'temperatura', 863.0000, 'ºC'),
	(11393, 109, '2015-01-15 00:09:25.000000', 'temperatura', 928.0000, 'ºC'),
	(11394, 109, '2015-01-15 00:09:26.000000', 'temperatura', 855.0000, 'ºC'),
	(11395, 109, '2015-01-15 00:09:27.000000', 'temperatura', 290.0000, 'ºC'),
	(11396, 109, '2015-01-15 00:09:28.000000', 'temperatura', 88.0000, 'ºC'),
	(11397, 109, '2015-01-15 00:09:29.000000', 'temperatura', 767.0000, 'ºC'),
	(11398, 109, '2015-01-15 00:09:30.000000', 'temperatura', 1172.0000, 'ºC'),
	(11399, 109, '2015-01-15 00:09:31.000000', 'temperatura', 1161.0000, 'ºC'),
	(11400, 109, '2015-01-15 00:09:32.000000', 'temperatura', 1090.0000, 'ºC'),
	(11401, 109, '2015-01-15 00:09:33.000000', 'temperatura', 768.0000, 'ºC'),
	(11402, 109, '2015-01-15 00:09:34.000000', 'temperatura', 571.0000, 'ºC'),
	(11403, 109, '2015-01-15 00:09:35.000000', 'temperatura', 550.0000, 'ºC'),
	(11404, 109, '2015-01-15 00:09:36.000000', 'temperatura', 1040.0000, 'ºC'),
	(11405, 109, '2015-01-15 00:09:37.000000', 'temperatura', 1147.0000, 'ºC'),
	(11406, 109, '2015-01-15 00:09:38.000000', 'temperatura', 218.0000, 'ºC'),
	(11407, 109, '2015-01-15 00:09:39.000000', 'temperatura', 50.0000, 'ºC'),
	(11408, 109, '2015-01-15 00:09:40.000000', 'temperatura', 795.0000, 'ºC'),
	(11409, 109, '2015-01-15 00:09:41.000000', 'temperatura', 224.0000, 'ºC'),
	(11410, 109, '2015-01-15 00:09:42.000000', 'temperatura', 1138.0000, 'ºC'),
	(11411, 109, '2015-01-15 00:09:43.000000', 'temperatura', 220.0000, 'ºC'),
	(11412, 109, '2015-01-15 00:09:44.000000', 'temperatura', 84.0000, 'ºC'),
	(11413, 109, '2015-01-15 00:09:45.000000', 'temperatura', 961.0000, 'ºC'),
	(11414, 109, '2015-01-15 00:09:46.000000', 'temperatura', 952.0000, 'ºC'),
	(11415, 109, '2015-01-15 00:09:47.000000', 'temperatura', 679.0000, 'ºC'),
	(11416, 109, '2015-01-15 00:09:48.000000', 'temperatura', 538.0000, 'ºC'),
	(11417, 109, '2015-01-15 00:09:49.000000', 'temperatura', 656.0000, 'ºC'),
	(11418, 109, '2015-01-15 00:09:50.000000', 'temperatura', 464.0000, 'ºC'),
	(11419, 109, '2015-01-15 00:09:51.000000', 'temperatura', 352.0000, 'ºC'),
	(11420, 109, '2015-01-15 00:09:52.000000', 'temperatura', 372.0000, 'ºC'),
	(11421, 109, '2015-01-15 00:09:53.000000', 'temperatura', 801.0000, 'ºC'),
	(11422, 109, '2015-01-15 00:09:54.000000', 'temperatura', 492.0000, 'ºC'),
	(11423, 109, '2015-01-15 00:09:55.000000', 'temperatura', 54.0000, 'ºC'),
	(11424, 109, '2015-01-15 00:09:56.000000', 'temperatura', 1198.0000, 'ºC'),
	(11425, 109, '2015-01-15 00:09:57.000000', 'temperatura', 1029.0000, 'ºC'),
	(11426, 109, '2015-01-15 00:09:58.000000', 'temperatura', 351.0000, 'ºC'),
	(11427, 109, '2015-01-15 00:09:59.000000', 'temperatura', 1068.0000, 'ºC'),
	(11428, 109, '2015-01-15 00:10:00.000000', 'temperatura', 688.0000, 'ºC'),
	(11429, 109, '2015-01-15 00:10:01.000000', 'temperatura', 237.0000, 'ºC'),
	(11430, 109, '2015-01-15 00:10:02.000000', 'temperatura', 319.0000, 'ºC'),
	(11431, 109, '2015-01-15 00:10:03.000000', 'temperatura', 886.0000, 'ºC'),
	(11432, 109, '2015-01-15 00:10:04.000000', 'temperatura', 1074.0000, 'ºC'),
	(11433, 109, '2015-01-15 00:10:05.000000', 'temperatura', 313.0000, 'ºC'),
	(11434, 109, '2015-01-15 00:10:06.000000', 'temperatura', 743.0000, 'ºC'),
	(11435, 109, '2015-01-15 00:10:07.000000', 'temperatura', 376.0000, 'ºC'),
	(11436, 109, '2015-01-15 00:10:08.000000', 'temperatura', 850.0000, 'ºC'),
	(11437, 109, '2015-01-15 00:10:09.000000', 'temperatura', 723.0000, 'ºC'),
	(11438, 109, '2015-01-15 00:10:10.000000', 'temperatura', 1067.0000, 'ºC'),
	(11439, 109, '2015-01-15 00:10:11.000000', 'temperatura', 764.0000, 'ºC'),
	(11440, 109, '2015-01-15 00:10:12.000000', 'temperatura', 621.0000, 'ºC'),
	(11441, 109, '2015-01-15 00:10:13.000000', 'temperatura', 815.0000, 'ºC'),
	(11442, 109, '2015-01-15 00:10:14.000000', 'temperatura', 1010.0000, 'ºC'),
	(11443, 109, '2015-01-15 00:10:15.000000', 'temperatura', 207.0000, 'ºC'),
	(11444, 109, '2015-01-15 00:10:16.000000', 'temperatura', 407.0000, 'ºC'),
	(11445, 109, '2015-01-15 00:10:17.000000', 'temperatura', 213.0000, 'ºC'),
	(11446, 109, '2015-01-15 00:10:18.000000', 'temperatura', 1043.0000, 'ºC'),
	(11447, 109, '2015-01-15 00:10:19.000000', 'temperatura', 976.0000, 'ºC'),
	(11448, 109, '2015-01-15 00:10:20.000000', 'temperatura', 551.0000, 'ºC'),
	(11449, 109, '2015-01-15 00:10:21.000000', 'temperatura', 1027.0000, 'ºC'),
	(11450, 109, '2015-01-15 00:10:22.000000', 'temperatura', 1085.0000, 'ºC'),
	(11451, 109, '2015-01-15 00:10:23.000000', 'temperatura', 1143.0000, 'ºC'),
	(11452, 109, '2015-01-15 00:10:24.000000', 'temperatura', 59.0000, 'ºC'),
	(11453, 109, '2015-01-15 00:10:25.000000', 'temperatura', 469.0000, 'ºC'),
	(11454, 109, '2015-01-15 00:10:26.000000', 'temperatura', 969.0000, 'ºC'),
	(11455, 109, '2015-01-15 00:10:27.000000', 'temperatura', 1038.0000, 'ºC'),
	(11456, 109, '2015-01-15 00:10:28.000000', 'temperatura', 1085.0000, 'ºC'),
	(11457, 109, '2015-01-15 00:10:29.000000', 'temperatura', 1111.0000, 'ºC'),
	(11458, 109, '2015-01-15 00:10:30.000000', 'temperatura', 1101.0000, 'ºC'),
	(11459, 109, '2015-01-15 00:10:31.000000', 'temperatura', 974.0000, 'ºC'),
	(11460, 109, '2015-01-15 00:10:32.000000', 'temperatura', 365.0000, 'ºC'),
	(11461, 109, '2015-01-15 00:10:33.000000', 'temperatura', 103.0000, 'ºC'),
	(11462, 109, '2015-01-15 00:10:34.000000', 'temperatura', 620.0000, 'ºC'),
	(11463, 109, '2015-01-15 00:10:35.000000', 'temperatura', 392.0000, 'ºC'),
	(11464, 109, '2015-01-15 00:10:36.000000', 'temperatura', 100.0000, 'ºC'),
	(11465, 109, '2015-01-15 00:10:37.000000', 'temperatura', 523.0000, 'ºC'),
	(11466, 109, '2015-01-15 00:10:38.000000', 'temperatura', 1117.0000, 'ºC'),
	(11467, 109, '2015-01-15 00:10:39.000000', 'temperatura', 417.0000, 'ºC'),
	(11468, 109, '2015-01-15 00:10:40.000000', 'temperatura', 1133.0000, 'ºC'),
	(11469, 109, '2015-01-15 00:10:41.000000', 'temperatura', 816.0000, 'ºC'),
	(11470, 109, '2015-01-15 00:10:42.000000', 'temperatura', 680.0000, 'ºC'),
	(11471, 109, '2015-01-15 00:10:43.000000', 'temperatura', 953.0000, 'ºC'),
	(11472, 109, '2015-01-15 00:10:44.000000', 'temperatura', 324.0000, 'ºC'),
	(11473, 109, '2015-01-15 00:10:45.000000', 'temperatura', 1161.0000, 'ºC'),
	(11474, 109, '2015-01-15 00:10:46.000000', 'temperatura', 33.0000, 'ºC'),
	(11475, 109, '2015-01-15 00:10:47.000000', 'temperatura', 286.0000, 'ºC'),
	(11476, 109, '2015-01-15 00:10:48.000000', 'temperatura', 129.0000, 'ºC'),
	(11477, 109, '2015-01-15 00:10:49.000000', 'temperatura', 987.0000, 'ºC'),
	(11478, 109, '2015-01-15 00:10:50.000000', 'temperatura', 949.0000, 'ºC'),
	(11479, 109, '2015-01-15 00:10:51.000000', 'temperatura', 585.0000, 'ºC'),
	(11480, 109, '2015-01-15 00:10:52.000000', 'temperatura', 77.0000, 'ºC'),
	(11481, 109, '2015-01-15 00:10:53.000000', 'temperatura', 1031.0000, 'ºC'),
	(11482, 109, '2015-01-15 00:10:54.000000', 'temperatura', 124.0000, 'ºC'),
	(11483, 109, '2015-01-15 00:10:55.000000', 'temperatura', 1127.0000, 'ºC'),
	(11484, 109, '2015-01-15 00:10:56.000000', 'temperatura', 465.0000, 'ºC'),
	(11485, 109, '2015-01-15 00:10:57.000000', 'temperatura', 142.0000, 'ºC'),
	(11486, 109, '2015-01-15 00:10:58.000000', 'temperatura', 517.0000, 'ºC'),
	(11487, 109, '2015-01-15 00:10:59.000000', 'temperatura', 957.0000, 'ºC'),
	(11488, 109, '2015-01-15 00:11:00.000000', 'temperatura', 838.0000, 'ºC'),
	(11489, 109, '2015-01-15 00:11:01.000000', 'temperatura', 119.0000, 'ºC'),
	(11490, 109, '2015-01-15 00:11:02.000000', 'temperatura', 481.0000, 'ºC'),
	(11491, 109, '2015-01-15 00:11:03.000000', 'temperatura', 847.0000, 'ºC'),
	(11492, 109, '2015-01-15 00:11:04.000000', 'temperatura', 392.0000, 'ºC'),
	(11493, 109, '2015-01-15 00:11:05.000000', 'temperatura', 623.0000, 'ºC'),
	(11494, 109, '2015-01-15 00:11:06.000000', 'temperatura', 736.0000, 'ºC'),
	(11495, 109, '2015-01-15 00:11:07.000000', 'temperatura', 612.0000, 'ºC'),
	(11496, 109, '2015-01-15 00:11:08.000000', 'temperatura', 852.0000, 'ºC'),
	(11497, 109, '2015-01-15 00:11:09.000000', 'temperatura', 24.0000, 'ºC'),
	(11498, 109, '2015-01-15 00:11:10.000000', 'temperatura', 1167.0000, 'ºC'),
	(11499, 109, '2015-01-15 00:11:11.000000', 'temperatura', 963.0000, 'ºC'),
	(11500, 109, '2015-01-15 00:11:12.000000', 'temperatura', 116.0000, 'ºC'),
	(11501, 109, '2015-01-15 00:11:13.000000', 'temperatura', 91.0000, 'ºC'),
	(11502, 109, '2015-01-15 00:11:14.000000', 'temperatura', 106.0000, 'ºC'),
	(11503, 109, '2015-01-15 00:11:15.000000', 'temperatura', 257.0000, 'ºC'),
	(11504, 109, '2015-01-15 00:11:16.000000', 'temperatura', 966.0000, 'ºC'),
	(11505, 109, '2015-01-15 00:11:17.000000', 'temperatura', 463.0000, 'ºC'),
	(11506, 109, '2015-01-15 00:11:18.000000', 'temperatura', 617.0000, 'ºC'),
	(11507, 109, '2015-01-15 00:11:19.000000', 'temperatura', 497.0000, 'ºC'),
	(11508, 109, '2015-01-15 00:11:20.000000', 'temperatura', 632.0000, 'ºC'),
	(11509, 109, '2015-01-15 00:11:21.000000', 'temperatura', 471.0000, 'ºC'),
	(11510, 109, '2015-01-15 00:11:22.000000', 'temperatura', 459.0000, 'ºC'),
	(11511, 109, '2015-01-15 00:11:23.000000', 'temperatura', 884.0000, 'ºC'),
	(11512, 109, '2015-01-15 00:11:24.000000', 'temperatura', 644.0000, 'ºC'),
	(11513, 109, '2015-01-15 00:11:25.000000', 'temperatura', 568.0000, 'ºC'),
	(11514, 109, '2015-01-15 00:11:26.000000', 'temperatura', 909.0000, 'ºC'),
	(11515, 109, '2015-01-15 00:11:27.000000', 'temperatura', 439.0000, 'ºC'),
	(11516, 109, '2015-01-15 00:11:28.000000', 'temperatura', 670.0000, 'ºC'),
	(11517, 109, '2015-01-15 00:11:29.000000', 'temperatura', 834.0000, 'ºC'),
	(11518, 109, '2015-01-15 00:11:30.000000', 'temperatura', 960.0000, 'ºC'),
	(11519, 109, '2015-01-15 00:11:31.000000', 'temperatura', 1098.0000, 'ºC'),
	(11520, 109, '2015-01-15 00:11:32.000000', 'temperatura', 212.0000, 'ºC'),
	(11521, 109, '2015-01-15 00:11:33.000000', 'temperatura', 165.0000, 'ºC'),
	(11522, 109, '2015-01-15 00:11:34.000000', 'temperatura', 191.0000, 'ºC'),
	(11523, 109, '2015-01-15 00:11:35.000000', 'temperatura', 461.0000, 'ºC'),
	(11524, 109, '2015-01-15 00:11:36.000000', 'temperatura', 531.0000, 'ºC'),
	(11525, 109, '2015-01-15 00:11:37.000000', 'temperatura', 71.0000, 'ºC'),
	(11526, 109, '2015-01-15 00:11:38.000000', 'temperatura', 1165.0000, 'ºC'),
	(11527, 109, '2015-01-15 00:11:39.000000', 'temperatura', 814.0000, 'ºC'),
	(11528, 109, '2015-01-15 00:11:40.000000', 'temperatura', 573.0000, 'ºC'),
	(11529, 109, '2015-01-15 00:11:41.000000', 'temperatura', 422.0000, 'ºC'),
	(11530, 109, '2015-01-15 00:11:42.000000', 'temperatura', 394.0000, 'ºC'),
	(11531, 109, '2015-01-15 00:11:43.000000', 'temperatura', 702.0000, 'ºC'),
	(11532, 109, '2015-01-15 00:11:44.000000', 'temperatura', 1132.0000, 'ºC'),
	(11533, 109, '2015-01-15 00:11:45.000000', 'temperatura', 1152.0000, 'ºC'),
	(11534, 109, '2015-01-15 00:11:46.000000', 'temperatura', 1166.0000, 'ºC'),
	(11535, 109, '2015-01-15 00:11:47.000000', 'temperatura', 1172.0000, 'ºC'),
	(11536, 109, '2015-01-15 00:11:48.000000', 'temperatura', 1164.0000, 'ºC'),
	(11537, 109, '2015-01-15 00:11:49.000000', 'temperatura', 1106.0000, 'ºC'),
	(11538, 109, '2015-01-15 00:11:50.000000', 'temperatura', 836.0000, 'ºC'),
	(11539, 109, '2015-01-15 00:11:51.000000', 'temperatura', 861.0000, 'ºC'),
	(11540, 109, '2015-01-15 00:11:52.000000', 'temperatura', 601.0000, 'ºC'),
	(11541, 109, '2015-01-15 00:11:53.000000', 'temperatura', 421.0000, 'ºC'),
	(11542, 109, '2015-01-15 00:11:54.000000', 'temperatura', 301.0000, 'ºC'),
	(11543, 109, '2015-01-15 00:11:55.000000', 'temperatura', 245.0000, 'ºC'),
	(11544, 109, '2015-01-15 00:11:56.000000', 'temperatura', 321.0000, 'ºC'),
	(11545, 109, '2015-01-15 00:11:57.000000', 'temperatura', 873.0000, 'ºC'),
	(11546, 109, '2015-01-15 00:11:58.000000', 'temperatura', 999.0000, 'ºC'),
	(11547, 109, '2015-01-15 00:11:59.000000', 'temperatura', 1179.0000, 'ºC'),
	(11548, 109, '2015-01-15 00:12:00.000000', 'temperatura', 497.0000, 'ºC'),
	(11549, 109, '2015-01-15 00:12:01.000000', 'temperatura', 150.0000, 'ºC'),
	(11550, 109, '2015-01-15 00:12:02.000000', 'temperatura', 461.0000, 'ºC'),
	(11551, 109, '2015-01-15 00:12:03.000000', 'temperatura', 652.0000, 'ºC'),
	(11552, 109, '2015-01-15 00:12:04.000000', 'temperatura', 680.0000, 'ºC'),
	(11553, 109, '2015-01-15 00:12:05.000000', 'temperatura', 243.0000, 'ºC'),
	(11554, 109, '2015-01-15 00:12:06.000000', 'temperatura', 375.0000, 'ºC'),
	(11555, 109, '2015-01-15 00:12:07.000000', 'temperatura', 1145.0000, 'ºC'),
	(11556, 109, '2015-01-15 00:12:08.000000', 'temperatura', 1003.0000, 'ºC'),
	(11557, 109, '2015-01-15 00:12:09.000000', 'temperatura', 380.0000, 'ºC'),
	(11558, 109, '2015-01-15 00:12:10.000000', 'temperatura', 91.0000, 'ºC'),
	(11559, 109, '2015-01-15 00:12:11.000000', 'temperatura', 517.0000, 'ºC'),
	(11560, 109, '2015-01-15 00:12:12.000000', 'temperatura', 1111.0000, 'ºC'),
	(11561, 109, '2015-01-15 00:12:13.000000', 'temperatura', 407.0000, 'ºC'),
	(11562, 109, '2015-01-15 00:12:14.000000', 'temperatura', 1100.0000, 'ºC'),
	(11563, 109, '2015-01-15 00:12:15.000000', 'temperatura', 679.0000, 'ºC'),
	(11564, 109, '2015-01-15 00:12:16.000000', 'temperatura', 97.0000, 'ºC'),
	(11565, 109, '2015-01-15 00:12:17.000000', 'temperatura', 846.0000, 'ºC'),
	(11566, 109, '2015-01-15 00:12:18.000000', 'temperatura', 343.0000, 'ºC'),
	(11567, 109, '2015-01-15 00:12:19.000000', 'temperatura', 376.0000, 'ºC'),
	(11568, 109, '2015-01-15 00:12:20.000000', 'temperatura', 850.0000, 'ºC'),
	(11569, 109, '2015-01-15 00:12:21.000000', 'temperatura', 724.0000, 'ºC'),
	(11570, 109, '2015-01-15 00:12:22.000000', 'temperatura', 1068.0000, 'ºC'),
	(11571, 109, '2015-01-15 00:12:23.000000', 'temperatura', 771.0000, 'ºC'),
	(11572, 109, '2015-01-15 00:12:24.000000', 'temperatura', 652.0000, 'ºC'),
	(11573, 109, '2015-01-15 00:12:25.000000', 'temperatura', 947.0000, 'ºC'),
	(11574, 109, '2015-01-15 00:12:26.000000', 'temperatura', 379.0000, 'ºC'),
	(11575, 109, '2015-01-15 00:12:27.000000', 'temperatura', 255.0000, 'ºC'),
	(11576, 109, '2015-01-15 00:12:28.000000', 'temperatura', 140.0000, 'ºC'),
	(11577, 109, '2015-01-15 00:12:29.000000', 'temperatura', 1132.0000, 'ºC'),
	(11578, 109, '2015-01-15 00:12:30.000000', 'temperatura', 443.0000, 'ºC'),
	(11579, 109, '2015-01-15 00:12:31.000000', 'temperatura', 20.0000, 'ºC'),
	(11580, 109, '2015-01-15 00:12:32.000000', 'temperatura', 1172.0000, 'ºC'),
	(11581, 109, '2015-01-15 00:12:33.000000', 'temperatura', 998.0000, 'ºC'),
	(11582, 109, '2015-01-15 00:12:34.000000', 'temperatura', 278.0000, 'ºC'),
	(11583, 109, '2015-01-15 00:12:35.000000', 'temperatura', 794.0000, 'ºC'),
	(11584, 109, '2015-01-15 00:12:36.000000', 'temperatura', 736.0000, 'ºC'),
	(11585, 109, '2015-01-15 00:12:37.000000', 'temperatura', 98.0000, 'ºC'),
	(11586, 109, '2015-01-15 00:12:38.000000', 'temperatura', 684.0000, 'ºC'),
	(11587, 109, '2015-01-15 00:12:39.000000', 'temperatura', 724.0000, 'ºC'),
	(11588, 109, '2015-01-15 00:12:40.000000', 'temperatura', 371.0000, 'ºC'),
	(11589, 109, '2015-01-15 00:12:41.000000', 'temperatura', 882.0000, 'ºC'),
	(11590, 109, '2015-01-15 00:12:42.000000', 'temperatura', 899.0000, 'ºC'),
	(11591, 109, '2015-01-15 00:12:43.000000', 'temperatura', 647.0000, 'ºC'),
	(11592, 109, '2015-01-15 00:12:44.000000', 'temperatura', 539.0000, 'ºC'),
	(11593, 109, '2015-01-15 00:12:45.000000', 'temperatura', 754.0000, 'ºC'),
	(11594, 109, '2015-01-15 00:12:46.000000', 'temperatura', 955.0000, 'ºC'),
	(11595, 109, '2015-01-15 00:12:47.000000', 'temperatura', 113.0000, 'ºC'),
	(11596, 109, '2015-01-15 00:12:48.000000', 'temperatura', 103.0000, 'ºC'),
	(11597, 109, '2015-01-15 00:12:49.000000', 'temperatura', 173.0000, 'ºC'),
	(11598, 109, '2015-01-15 00:12:50.000000', 'temperatura', 558.0000, 'ºC'),
	(11599, 109, '2015-01-15 00:12:51.000000', 'temperatura', 1071.0000, 'ºC'),
	(11600, 109, '2015-01-15 00:12:52.000000', 'temperatura', 83.0000, 'ºC'),
	(11601, 109, '2015-01-15 00:12:53.000000', 'temperatura', 804.0000, 'ºC'),
	(11602, 109, '2015-01-15 00:12:54.000000', 'temperatura', 169.0000, 'ºC'),
	(11603, 109, '2015-01-15 00:12:55.000000', 'temperatura', 833.0000, 'ºC'),
	(11604, 109, '2015-01-15 00:12:56.000000', 'temperatura', 59.0000, 'ºC'),
	(11605, 109, '2015-01-15 00:12:57.000000', 'temperatura', 198.0000, 'ºC'),
	(11606, 109, '2015-01-15 00:12:58.000000', 'temperatura', 811.0000, 'ºC'),
	(11607, 109, '2015-01-15 00:12:59.000000', 'temperatura', 1061.0000, 'ºC'),
	(11608, 109, '2015-01-15 00:13:00.000000', 'temperatura', 475.0000, 'ºC'),
	(11609, 109, '2015-01-15 00:13:01.000000', 'temperatura', 391.0000, 'ºC'),
	(11610, 109, '2015-01-15 00:13:02.000000', 'temperatura', 531.0000, 'ºC'),
	(11611, 109, '2015-01-15 00:13:03.000000', 'temperatura', 282.0000, 'ºC'),
	(11612, 109, '2015-01-15 00:13:04.000000', 'temperatura', 1018.0000, 'ºC'),
	(11613, 109, '2015-01-15 00:13:05.000000', 'temperatura', 645.0000, 'ºC'),
	(11614, 109, '2015-01-15 00:13:06.000000', 'temperatura', 170.0000, 'ºC'),
	(11615, 109, '2015-01-15 00:13:07.000000', 'temperatura', 118.0000, 'ºC'),
	(11616, 109, '2015-01-15 00:13:08.000000', 'temperatura', 79.0000, 'ºC'),
	(11617, 109, '2015-01-15 00:13:09.000000', 'temperatura', 42.0000, 'ºC'),
	(11618, 109, '2015-01-15 00:13:10.000000', 'temperatura', 1174.0000, 'ºC'),
	(11619, 109, '2015-01-15 00:13:11.000000', 'temperatura', 945.0000, 'ºC'),
	(11620, 109, '2015-01-15 00:13:12.000000', 'temperatura', 1.0000, 'ºC'),
	(11621, 109, '2015-01-15 00:13:13.000000', 'temperatura', 771.0000, 'ºC'),
	(11622, 109, '2015-01-15 00:13:14.000000', 'temperatura', 253.0000, 'ºC'),
	(11623, 109, '2015-01-15 00:13:15.000000', 'temperatura', 151.0000, 'ºC'),
	(11624, 109, '2015-01-15 00:13:16.000000', 'temperatura', 0.0000, 'ºC'),
	(11625, 109, '2015-01-15 00:13:17.000000', 'temperatura', 744.0000, 'ºC'),
	(11626, 109, '2015-01-15 00:13:18.000000', 'temperatura', 124.0000, 'ºC'),
	(11627, 109, '2015-01-15 00:13:19.000000', 'temperatura', 786.0000, 'ºC'),
	(11628, 109, '2015-01-15 00:13:20.000000', 'temperatura', 1158.0000, 'ºC'),
	(11629, 109, '2015-01-15 00:13:21.000000', 'temperatura', 1033.0000, 'ºC'),
	(11630, 109, '2015-01-15 00:13:22.000000', 'temperatura', 491.0000, 'ºC'),
	(11631, 109, '2015-01-15 00:13:23.000000', 'temperatura', 555.0000, 'ºC'),
	(11632, 109, '2015-01-15 00:13:24.000000', 'temperatura', 105.0000, 'ºC'),
	(11633, 109, '2015-01-15 00:13:25.000000', 'temperatura', 58.0000, 'ºC'),
	(11634, 109, '2015-01-15 00:13:26.000000', 'temperatura', 1176.0000, 'ºC'),
	(11635, 109, '2015-01-15 00:13:27.000000', 'temperatura', 905.0000, 'ºC'),
	(11636, 109, '2015-01-15 00:13:28.000000', 'temperatura', 1001.0000, 'ºC'),
	(11637, 109, '2015-01-15 00:13:29.000000', 'temperatura', 1088.0000, 'ºC'),
	(11638, 109, '2015-01-15 00:13:30.000000', 'temperatura', 39.0000, 'ºC'),
	(11639, 109, '2015-01-15 00:13:31.000000', 'temperatura', 532.0000, 'ºC'),
	(11640, 109, '2015-01-15 00:13:32.000000', 'temperatura', 141.0000, 'ºC'),
	(11641, 109, '2015-01-15 00:13:33.000000', 'temperatura', 312.0000, 'ºC'),
	(11642, 109, '2015-01-15 00:13:34.000000', 'temperatura', 1136.0000, 'ºC'),
	(11643, 109, '2015-01-15 00:13:35.000000', 'temperatura', 1145.0000, 'ºC'),
	(11644, 109, '2015-01-15 00:13:36.000000', 'temperatura', 1118.0000, 'ºC'),
	(11645, 109, '2015-01-15 00:13:37.000000', 'temperatura', 955.0000, 'ºC'),
	(11646, 109, '2015-01-15 00:13:38.000000', 'temperatura', 223.0000, 'ºC'),
	(11647, 109, '2015-01-15 00:13:39.000000', 'temperatura', 649.0000, 'ºC'),
	(11648, 109, '2015-01-15 00:13:40.000000', 'temperatura', 178.0000, 'ºC'),
	(11649, 109, '2015-01-15 00:13:41.000000', 'temperatura', 143.0000, 'ºC'),
	(11650, 109, '2015-01-15 00:13:42.000000', 'temperatura', 181.0000, 'ºC'),
	(11651, 109, '2015-01-15 00:13:43.000000', 'temperatura', 475.0000, 'ºC'),
	(11652, 109, '2015-01-15 00:13:44.000000', 'temperatura', 636.0000, 'ºC'),
	(11653, 109, '2015-01-15 00:13:45.000000', 'temperatura', 552.0000, 'ºC'),
	(11654, 109, '2015-01-15 00:13:46.000000', 'temperatura', 854.0000, 'ºC'),
	(11655, 109, '2015-01-15 00:13:47.000000', 'temperatura', 215.0000, 'ºC'),
	(11656, 109, '2015-01-15 00:13:48.000000', 'temperatura', 914.0000, 'ºC'),
	(11657, 109, '2015-01-15 00:13:49.000000', 'temperatura', 327.0000, 'ºC'),
	(11658, 109, '2015-01-15 00:13:50.000000', 'temperatura', 90.0000, 'ºC'),
	(11659, 109, '2015-01-15 00:13:51.000000', 'temperatura', 672.0000, 'ºC'),
	(11660, 109, '2015-01-15 00:13:52.000000', 'temperatura', 688.0000, 'ºC'),
	(11661, 109, '2015-01-15 00:13:53.000000', 'temperatura', 228.0000, 'ºC'),
	(11662, 109, '2015-01-15 00:13:54.000000', 'temperatura', 273.0000, 'ºC'),
	(11663, 109, '2015-01-15 00:13:55.000000', 'temperatura', 684.0000, 'ºC'),
	(11664, 109, '2015-01-15 00:13:56.000000', 'temperatura', 203.0000, 'ºC'),
	(11665, 109, '2015-01-15 00:13:57.000000', 'temperatura', 161.0000, 'ºC'),
	(11666, 109, '2015-01-15 00:13:58.000000', 'temperatura', 197.0000, 'ºC'),
	(11667, 109, '2015-01-15 00:13:59.000000', 'temperatura', 504.0000, 'ºC'),
	(11668, 109, '2015-01-15 00:14:00.000000', 'temperatura', 729.0000, 'ºC'),
	(11669, 109, '2015-01-15 00:14:01.000000', 'temperatura', 933.0000, 'ºC'),
	(11670, 109, '2015-01-15 00:14:02.000000', 'temperatura', 80.0000, 'ºC'),
	(11671, 109, '2015-01-15 00:14:03.000000', 'temperatura', 1199.0000, 'ºC'),
	(11672, 109, '2015-01-15 00:14:04.000000', 'temperatura', 958.0000, 'ºC'),
	(11673, 109, '2015-01-15 00:14:05.000000', 'temperatura', 1191.0000, 'ºC'),
	(11674, 109, '2015-01-15 00:14:06.000000', 'temperatura', 684.0000, 'ºC'),
	(11675, 109, '2015-01-15 00:14:07.000000', 'temperatura', 1046.0000, 'ºC'),
	(11676, 109, '2015-01-15 00:14:08.000000', 'temperatura', 777.0000, 'ºC'),
	(11677, 109, '2015-01-15 00:14:09.000000', 'temperatura', 750.0000, 'ºC'),
	(11678, 109, '2015-01-15 00:14:10.000000', 'temperatura', 218.0000, 'ºC'),
	(11679, 109, '2015-01-15 00:14:11.000000', 'temperatura', 42.0000, 'ºC'),
	(11680, 109, '2015-01-15 00:14:12.000000', 'temperatura', 757.0000, 'ºC'),
	(11681, 109, '2015-01-15 00:14:13.000000', 'temperatura', 61.0000, 'ºC'),
	(11682, 109, '2015-01-15 00:14:14.000000', 'temperatura', 432.0000, 'ºC'),
	(11683, 109, '2015-01-15 00:14:15.000000', 'temperatura', 777.0000, 'ºC'),
	(11684, 109, '2015-01-15 00:14:16.000000', 'temperatura', 188.0000, 'ºC'),
	(11685, 109, '2015-01-15 00:14:17.000000', 'temperatura', 1013.0000, 'ºC'),
	(11686, 109, '2015-01-15 00:14:18.000000', 'temperatura', 899.0000, 'ºC'),
	(11687, 109, '2015-01-15 00:14:19.000000', 'temperatura', 259.0000, 'ºC'),
	(11688, 109, '2015-01-15 00:14:20.000000', 'temperatura', 996.0000, 'ºC'),
	(11689, 109, '2015-01-15 00:14:21.000000', 'temperatura', 604.0000, 'ºC'),
	(11690, 109, '2015-01-15 00:14:22.000000', 'temperatura', 33.0000, 'ºC'),
	(11691, 109, '2015-01-15 00:14:23.000000', 'temperatura', 755.0000, 'ºC'),
	(11692, 109, '2015-01-15 00:14:24.000000', 'temperatura', 76.0000, 'ºC'),
	(11693, 109, '2015-01-15 00:14:25.000000', 'temperatura', 516.0000, 'ºC'),
	(11694, 109, '2015-01-15 00:14:26.000000', 'temperatura', 1150.0000, 'ºC'),
	(11695, 109, '2015-01-15 00:14:27.000000', 'temperatura', 606.0000, 'ºC'),
	(11696, 109, '2015-01-15 00:14:28.000000', 'temperatura', 779.0000, 'ºC'),
	(11697, 109, '2015-01-15 00:14:29.000000', 'temperatura', 875.0000, 'ºC'),
	(11698, 109, '2015-01-15 00:14:30.000000', 'temperatura', 842.0000, 'ºC'),
	(11699, 109, '2015-01-15 00:14:31.000000', 'temperatura', 384.0000, 'ºC'),
	(11700, 109, '2015-01-15 00:14:32.000000', 'temperatura', 594.0000, 'ºC'),
	(11701, 109, '2015-01-15 00:14:33.000000', 'temperatura', 618.0000, 'ºC'),
	(11702, 109, '2015-01-15 00:14:34.000000', 'temperatura', 108.0000, 'ºC'),
	(11703, 109, '2015-01-15 00:14:35.000000', 'temperatura', 1086.0000, 'ºC'),
	(11704, 109, '2015-01-15 00:14:36.000000', 'temperatura', 309.0000, 'ºC'),
	(11705, 109, '2015-01-15 00:14:37.000000', 'temperatura', 688.0000, 'ºC'),
	(11706, 109, '2015-01-15 00:14:38.000000', 'temperatura', 114.0000, 'ºC'),
	(11707, 109, '2015-01-15 00:14:39.000000', 'temperatura', 906.0000, 'ºC'),
	(11708, 109, '2015-01-15 00:14:40.000000', 'temperatura', 586.0000, 'ºC'),
	(11709, 109, '2015-01-15 00:14:41.000000', 'temperatura', 216.0000, 'ºC'),
	(11710, 109, '2015-01-15 00:14:42.000000', 'temperatura', 520.0000, 'ºC'),
	(11711, 109, '2015-01-15 00:14:43.000000', 'temperatura', 753.0000, 'ºC'),
	(11712, 109, '2015-01-15 00:14:44.000000', 'temperatura', 1007.0000, 'ºC'),
	(11713, 109, '2015-01-15 00:14:45.000000', 'temperatura', 374.0000, 'ºC'),
	(11714, 109, '2015-01-15 00:14:46.000000', 'temperatura', 49.0000, 'ºC'),
	(11715, 109, '2015-01-15 00:14:47.000000', 'temperatura', 326.0000, 'ºC'),
	(11716, 109, '2015-01-15 00:14:48.000000', 'temperatura', 283.0000, 'ºC'),
	(11717, 109, '2015-01-15 00:14:49.000000', 'temperatura', 438.0000, 'ºC'),
	(11718, 109, '2015-01-15 00:14:50.000000', 'temperatura', 139.0000, 'ºC'),
	(11719, 109, '2015-01-15 00:14:51.000000', 'temperatura', 582.0000, 'ºC'),
	(11720, 109, '2015-01-15 00:14:52.000000', 'temperatura', 96.0000, 'ºC'),
	(11721, 109, '2015-01-15 00:14:53.000000', 'temperatura', 1133.0000, 'ºC'),
	(11722, 109, '2015-01-15 00:14:54.000000', 'temperatura', 579.0000, 'ºC'),
	(11723, 109, '2015-01-15 00:14:55.000000', 'temperatura', 695.0000, 'ºC'),
	(11724, 109, '2015-01-15 00:14:56.000000', 'temperatura', 541.0000, 'ºC'),
	(11725, 109, '2015-01-15 00:14:57.000000', 'temperatura', 618.0000, 'ºC'),
	(11726, 109, '2015-01-15 00:14:58.000000', 'temperatura', 268.0000, 'ºC'),
	(11727, 109, '2015-01-15 00:14:59.000000', 'temperatura', 685.0000, 'ºC'),
	(11728, 109, '2015-01-15 00:15:00.000000', 'temperatura', 223.0000, 'ºC'),
	(11729, 109, '2015-01-15 00:15:01.000000', 'temperatura', 259.0000, 'ºC'),
	(11730, 109, '2015-01-15 00:15:02.000000', 'temperatura', 625.0000, 'ºC'),
	(11731, 109, '2015-01-15 00:15:03.000000', 'temperatura', 1152.0000, 'ºC'),
	(11732, 109, '2015-01-15 00:15:04.000000', 'temperatura', 283.0000, 'ºC'),
	(11733, 109, '2015-01-15 00:15:05.000000', 'temperatura', 359.0000, 'ºC'),
	(11734, 109, '2015-01-15 00:15:06.000000', 'temperatura', 946.0000, 'ºC'),
	(11735, 109, '2015-01-15 00:15:07.000000', 'temperatura', 56.0000, 'ºC'),
	(11736, 109, '2015-01-15 00:15:08.000000', 'temperatura', 1040.0000, 'ºC'),
	(11737, 109, '2015-01-15 00:15:09.000000', 'temperatura', 232.0000, 'ºC'),
	(11738, 109, '2015-01-15 00:15:10.000000', 'temperatura', 443.0000, 'ºC'),
	(11739, 109, '2015-01-15 00:15:11.000000', 'temperatura', 317.0000, 'ºC'),
	(11740, 109, '2015-01-15 00:15:12.000000', 'temperatura', 256.0000, 'ºC'),
	(11741, 109, '2015-01-15 00:15:13.000000', 'temperatura', 330.0000, 'ºC'),
	(11742, 109, '2015-01-15 00:15:14.000000', 'temperatura', 884.0000, 'ºC'),
	(11743, 109, '2015-01-15 00:15:15.000000', 'temperatura', 1028.0000, 'ºC'),
	(11744, 109, '2015-01-15 00:15:16.000000', 'temperatura', 89.0000, 'ºC'),
	(11745, 109, '2015-01-15 00:15:17.000000', 'temperatura', 961.0000, 'ºC'),
	(11746, 109, '2015-01-15 00:15:18.000000', 'temperatura', 939.0000, 'ºC'),
	(11747, 109, '2015-01-15 00:15:19.000000', 'temperatura', 614.0000, 'ºC'),
	(11748, 109, '2015-01-15 00:15:20.000000', 'temperatura', 251.0000, 'ºC'),
	(11749, 109, '2015-01-15 00:15:21.000000', 'temperatura', 614.0000, 'ºC'),
	(11750, 109, '2015-01-15 00:15:22.000000', 'temperatura', 1119.0000, 'ºC'),
	(11751, 109, '2015-01-15 00:15:23.000000', 'temperatura', 154.0000, 'ºC'),
	(11752, 109, '2015-01-15 00:15:24.000000', 'temperatura', 1014.0000, 'ºC'),
	(11753, 109, '2015-01-15 00:15:25.000000', 'temperatura', 1007.0000, 'ºC'),
	(11754, 109, '2015-01-15 00:15:26.000000', 'temperatura', 794.0000, 'ºC'),
	(11755, 109, '2015-01-15 00:15:27.000000', 'temperatura', 948.0000, 'ºC'),
	(11756, 109, '2015-01-15 00:15:28.000000', 'temperatura', 1159.0000, 'ºC'),
	(11757, 109, '2015-01-15 00:15:29.000000', 'temperatura', 552.0000, 'ºC'),
	(11758, 109, '2015-01-15 00:15:30.000000', 'temperatura', 485.0000, 'ºC'),
	(11759, 109, '2015-01-15 00:15:31.000000', 'temperatura', 767.0000, 'ºC'),
	(11760, 109, '2015-01-15 00:15:32.000000', 'temperatura', 1180.0000, 'ºC'),
	(11761, 109, '2015-01-15 00:15:33.000000', 'temperatura', 1198.0000, 'ºC'),
	(11762, 109, '2015-01-15 00:15:34.000000', 'temperatura', 54.0000, 'ºC'),
	(11763, 109, '2015-01-15 00:15:35.000000', 'temperatura', 276.0000, 'ºC'),
	(11764, 109, '2015-01-15 00:15:36.000000', 'temperatura', 18.0000, 'ºC'),
	(11765, 109, '2015-01-15 00:15:37.000000', 'temperatura', 462.0000, 'ºC'),
	(11766, 109, '2015-01-15 00:15:38.000000', 'temperatura', 1055.0000, 'ºC'),
	(11767, 109, '2015-01-15 00:15:39.000000', 'temperatura', 290.0000, 'ºC'),
	(11768, 109, '2015-01-15 00:15:40.000000', 'temperatura', 686.0000, 'ºC'),
	(11769, 109, '2015-01-15 00:15:41.000000', 'temperatura', 161.0000, 'ºC'),
	(11770, 109, '2015-01-15 00:15:42.000000', 'temperatura', 1147.0000, 'ºC'),
	(11771, 109, '2015-01-15 00:15:43.000000', 'temperatura', 452.0000, 'ºC'),
	(11772, 109, '2015-01-15 00:15:44.000000', 'temperatura', 19.0000, 'ºC'),
	(11773, 109, '2015-01-15 00:15:45.000000', 'temperatura', 1141.0000, 'ºC'),
	(11774, 109, '2015-01-15 00:15:46.000000', 'temperatura', 846.0000, 'ºC'),
	(11775, 109, '2015-01-15 00:15:47.000000', 'temperatura', 810.0000, 'ºC'),
	(11776, 109, '2015-01-15 00:15:48.000000', 'temperatura', 314.0000, 'ºC'),
	(11777, 109, '2015-01-15 00:15:49.000000', 'temperatura', 338.0000, 'ºC'),
	(11778, 109, '2015-01-15 00:15:50.000000', 'temperatura', 748.0000, 'ºC'),
	(11779, 109, '2015-01-15 00:15:51.000000', 'temperatura', 329.0000, 'ºC'),
	(11780, 109, '2015-01-15 00:15:52.000000', 'temperatura', 599.0000, 'ºC'),
	(11781, 109, '2015-01-15 00:15:53.000000', 'temperatura', 811.0000, 'ºC'),
	(11782, 109, '2015-01-15 00:15:54.000000', 'temperatura', 1059.0000, 'ºC'),
	(11783, 109, '2015-01-15 00:15:55.000000', 'temperatura', 462.0000, 'ºC'),
	(11784, 109, '2015-01-15 00:15:56.000000', 'temperatura', 331.0000, 'ºC'),
	(11785, 109, '2015-01-15 00:15:57.000000', 'temperatura', 272.0000, 'ºC'),
	(11786, 109, '2015-01-15 00:15:58.000000', 'temperatura', 369.0000, 'ºC'),
	(11787, 109, '2015-01-15 00:15:59.000000', 'temperatura', 1027.0000, 'ºC'),
	(11788, 109, '2015-01-15 00:16:00.000000', 'temperatura', 427.0000, 'ºC'),
	(11789, 109, '2015-01-15 00:16:01.000000', 'temperatura', 258.0000, 'ºC'),
	(11790, 109, '2015-01-15 00:16:02.000000', 'temperatura', 9.0000, 'ºC'),
	(11791, 109, '2015-01-15 00:16:03.000000', 'temperatura', 470.0000, 'ºC'),
	(11792, 109, '2015-01-15 00:16:04.000000', 'temperatura', 1123.0000, 'ºC'),
	(11793, 109, '2015-01-15 00:16:05.000000', 'temperatura', 606.0000, 'ºC'),
	(11794, 109, '2015-01-15 00:16:06.000000', 'temperatura', 860.0000, 'ºC'),
	(11795, 109, '2015-01-15 00:16:07.000000', 'temperatura', 84.0000, 'ºC'),
	(11796, 109, '2015-01-15 00:16:08.000000', 'temperatura', 242.0000, 'ºC'),
	(11797, 109, '2015-01-15 00:16:09.000000', 'temperatura', 958.0000, 'ºC'),
	(11798, 109, '2015-01-15 00:16:10.000000', 'temperatura', 465.0000, 'ºC'),
	(11799, 109, '2015-01-15 00:16:11.000000', 'temperatura', 649.0000, 'ºC'),
	(11800, 109, '2015-01-15 00:16:12.000000', 'temperatura', 653.0000, 'ºC'),
	(11801, 109, '2015-01-15 00:16:13.000000', 'temperatura', 118.0000, 'ºC'),
	(11802, 109, '2015-01-15 00:16:14.000000', 'temperatura', 1030.0000, 'ºC'),
	(11803, 109, '2015-01-15 00:16:15.000000', 'temperatura', 1199.0000, 'ºC'),
	(11804, 109, '2015-01-15 00:16:16.000000', 'temperatura', 506.0000, 'ºC'),
	(11805, 109, '2015-01-15 00:16:17.000000', 'temperatura', 131.0000, 'ºC'),
	(11806, 109, '2015-01-15 00:16:18.000000', 'temperatura', 340.0000, 'ºC'),
	(11807, 109, '2015-01-15 00:16:19.000000', 'temperatura', 105.0000, 'ºC'),
	(11808, 109, '2015-01-15 00:16:20.000000', 'temperatura', 707.0000, 'ºC'),
	(11809, 109, '2015-01-15 00:16:21.000000', 'temperatura', 820.0000, 'ºC'),
	(11810, 109, '2015-01-15 00:16:22.000000', 'temperatura', 780.0000, 'ºC'),
	(11811, 109, '2015-01-15 00:16:23.000000', 'temperatura', 239.0000, 'ºC'),
	(11812, 109, '2015-01-15 00:16:24.000000', 'temperatura', 56.0000, 'ºC'),
	(11813, 109, '2015-01-15 00:16:25.000000', 'temperatura', 765.0000, 'ºC'),
	(11814, 109, '2015-01-15 00:16:26.000000', 'temperatura', 58.0000, 'ºC'),
	(11815, 109, '2015-01-15 00:16:27.000000', 'temperatura', 394.0000, 'ºC'),
	(11816, 109, '2015-01-15 00:16:28.000000', 'temperatura', 596.0000, 'ºC'),
	(11817, 109, '2015-01-15 00:16:29.000000', 'temperatura', 601.0000, 'ºC'),
	(11818, 109, '2015-01-15 00:16:30.000000', 'temperatura', 16.0000, 'ºC'),
	(11819, 109, '2015-01-15 00:16:31.000000', 'temperatura', 678.0000, 'ºC'),
	(11820, 109, '2015-01-15 00:16:32.000000', 'temperatura', 943.0000, 'ºC'),
	(11821, 109, '2015-01-15 00:16:33.000000', 'temperatura', 280.0000, 'ºC'),
	(11822, 109, '2015-01-15 00:16:34.000000', 'temperatura', 974.0000, 'ºC'),
	(11823, 109, '2015-01-15 00:16:35.000000', 'temperatura', 429.0000, 'ºC'),
	(11824, 109, '2015-01-15 00:16:36.000000', 'temperatura', 422.0000, 'ºC'),
	(11825, 109, '2015-01-15 00:16:37.000000', 'temperatura', 824.0000, 'ºC'),
	(11826, 109, '2015-01-15 00:16:38.000000', 'temperatura', 456.0000, 'ºC'),
	(11827, 109, '2015-01-15 00:16:39.000000', 'temperatura', 1008.0000, 'ºC'),
	(11828, 109, '2015-01-15 00:16:40.000000', 'temperatura', 72.0000, 'ºC'),
	(11829, 109, '2015-01-15 00:16:41.000000', 'temperatura', 937.0000, 'ºC'),
	(11830, 109, '2015-01-15 00:16:42.000000', 'temperatura', 871.0000, 'ºC'),
	(11831, 109, '2015-01-15 00:16:43.000000', 'temperatura', 342.0000, 'ºC'),
	(11832, 109, '2015-01-15 00:16:44.000000', 'temperatura', 300.0000, 'ºC'),
	(11833, 109, '2015-01-15 00:16:45.000000', 'temperatura', 473.0000, 'ºC'),
	(11834, 109, '2015-01-15 00:16:46.000000', 'temperatura', 265.0000, 'ºC'),
	(11835, 109, '2015-01-15 00:16:47.000000', 'temperatura', 1106.0000, 'ºC'),
	(11836, 109, '2015-01-15 00:16:48.000000', 'temperatura', 1137.0000, 'ºC'),
	(11837, 109, '2015-01-15 00:16:49.000000', 'temperatura', 1165.0000, 'ºC'),
	(11838, 109, '2015-01-15 00:16:50.000000', 'temperatura', 17.0000, 'ºC'),
	(11839, 109, '2015-01-15 00:16:51.000000', 'temperatura', 189.0000, 'ºC'),
	(11840, 109, '2015-01-15 00:16:52.000000', 'temperatura', 893.0000, 'ºC'),
	(11841, 109, '2015-01-15 00:16:53.000000', 'temperatura', 302.0000, 'ºC'),
	(11842, 109, '2015-01-15 00:16:54.000000', 'temperatura', 30.0000, 'ºC'),
	(11843, 109, '2015-01-15 00:16:55.000000', 'temperatura', 443.0000, 'ºC'),
	(11844, 109, '2015-01-15 00:16:56.000000', 'temperatura', 927.0000, 'ºC'),
	(11845, 109, '2015-01-15 00:16:57.000000', 'temperatura', 907.0000, 'ºC'),
	(11846, 109, '2015-01-15 00:16:58.000000', 'temperatura', 556.0000, 'ºC'),
	(11847, 109, '2015-01-15 00:16:59.000000', 'temperatura', 56.0000, 'ºC'),
	(11848, 109, '2015-01-15 00:17:00.000000', 'temperatura', 1015.0000, 'ºC'),
	(11849, 109, '2015-01-15 00:17:01.000000', 'temperatura', 105.0000, 'ºC'),
	(11850, 109, '2015-01-15 00:17:02.000000', 'temperatura', 1083.0000, 'ºC'),
	(11851, 109, '2015-01-15 00:17:03.000000', 'temperatura', 298.0000, 'ºC'),
	(11852, 109, '2015-01-15 00:17:04.000000', 'temperatura', 643.0000, 'ºC'),
	(11853, 109, '2015-01-15 00:17:05.000000', 'temperatura', 1121.0000, 'ºC'),
	(11854, 109, '2015-01-15 00:17:06.000000', 'temperatura', 78.0000, 'ºC'),
	(11855, 109, '2015-01-15 00:17:07.000000', 'temperatura', 628.0000, 'ºC'),
	(11856, 109, '2015-01-15 00:17:08.000000', 'temperatura', 504.0000, 'ºC'),
	(11857, 109, '2015-01-15 00:17:09.000000', 'temperatura', 638.0000, 'ºC'),
	(11858, 109, '2015-01-15 00:17:10.000000', 'temperatura', 479.0000, 'ºC'),
	(11859, 109, '2015-01-15 00:17:11.000000', 'temperatura', 480.0000, 'ºC'),
	(11860, 109, '2015-01-15 00:17:12.000000', 'temperatura', 964.0000, 'ºC'),
	(11861, 109, '2015-01-15 00:17:13.000000', 'temperatura', 980.0000, 'ºC'),
	(11862, 109, '2015-01-15 00:17:14.000000', 'temperatura', 810.0000, 'ºC'),
	(11863, 109, '2015-01-15 00:17:15.000000', 'temperatura', 1108.0000, 'ºC'),
	(11864, 109, '2015-01-15 00:17:16.000000', 'temperatura', 712.0000, 'ºC'),
	(11865, 109, '2015-01-15 00:17:17.000000', 'temperatura', 236.0000, 'ºC'),
	(11866, 109, '2015-01-15 00:17:18.000000', 'temperatura', 244.0000, 'ºC'),
	(11867, 109, '2015-01-15 00:17:19.000000', 'temperatura', 513.0000, 'ºC'),
	(11868, 109, '2015-01-15 00:17:20.000000', 'temperatura', 634.0000, 'ºC'),
	(11869, 109, '2015-01-15 00:17:21.000000', 'temperatura', 433.0000, 'ºC'),
	(11870, 109, '2015-01-15 00:17:22.000000', 'temperatura', 263.0000, 'ºC'),
	(11871, 109, '2015-01-15 00:17:23.000000', 'temperatura', 16.0000, 'ºC'),
	(11872, 109, '2015-01-15 00:17:24.000000', 'temperatura', 492.0000, 'ºC'),
	(11873, 109, '2015-01-15 00:17:25.000000', 'temperatura', 11.0000, 'ºC'),
	(11874, 109, '2015-01-15 00:17:26.000000', 'temperatura', 978.0000, 'ºC'),
	(11875, 109, '2015-01-15 00:17:27.000000', 'temperatura', 61.0000, 'ºC'),
	(11876, 109, '2015-01-15 00:17:28.000000', 'temperatura', 971.0000, 'ºC'),
	(11877, 109, '2015-01-15 00:17:29.000000', 'temperatura', 1071.0000, 'ºC'),
	(11878, 109, '2015-01-15 00:17:30.000000', 'temperatura', 42.0000, 'ºC'),
	(11879, 109, '2015-01-15 00:17:31.000000', 'temperatura', 599.0000, 'ºC'),
	(11880, 109, '2015-01-15 00:17:32.000000', 'temperatura', 470.0000, 'ºC'),
	(11881, 109, '2015-01-15 00:17:33.000000', 'temperatura', 554.0000, 'ºC'),
	(11882, 109, '2015-01-15 00:17:34.000000', 'temperatura', 160.0000, 'ºC'),
	(11883, 109, '2015-01-15 00:17:35.000000', 'temperatura', 337.0000, 'ºC'),
	(11884, 109, '2015-01-15 00:17:36.000000', 'temperatura', 5.0000, 'ºC'),
	(11885, 109, '2015-01-15 00:17:37.000000', 'temperatura', 217.0000, 'ºC'),
	(11886, 109, '2015-01-15 00:17:38.000000', 'temperatura', 1071.0000, 'ºC'),
	(11887, 109, '2015-01-15 00:17:39.000000', 'temperatura', 1105.0000, 'ºC'),
	(11888, 109, '2015-01-15 00:17:40.000000', 'temperatura', 1113.0000, 'ºC'),
	(11889, 109, '2015-01-15 00:17:41.000000', 'temperatura', 1051.0000, 'ºC'),
	(11890, 109, '2015-01-15 00:17:42.000000', 'temperatura', 717.0000, 'ºC'),
	(11891, 109, '2015-01-15 00:17:43.000000', 'temperatura', 431.0000, 'ºC'),
	(11892, 109, '2015-01-15 00:17:44.000000', 'temperatura', 4.0000, 'ºC'),
	(11893, 109, '2015-01-15 00:17:45.000000', 'temperatura', 1128.0000, 'ºC'),
	(11894, 109, '2015-01-15 00:17:46.000000', 'temperatura', 826.0000, 'ºC'),
	(11895, 109, '2015-01-15 00:17:47.000000', 'temperatura', 750.0000, 'ºC'),
	(11896, 109, '2015-01-15 00:17:48.000000', 'temperatura', 71.0000, 'ºC'),
	(11897, 109, '2015-01-15 00:17:49.000000', 'temperatura', 507.0000, 'ºC'),
	(11898, 109, '2015-01-15 00:17:50.000000', 'temperatura', 1122.0000, 'ºC'),
	(11899, 109, '2015-01-15 00:17:51.000000', 'temperatura', 491.0000, 'ºC'),
	(11900, 109, '2015-01-15 00:17:52.000000', 'temperatura', 287.0000, 'ºC'),
	(11901, 109, '2015-01-15 00:17:53.000000', 'temperatura', 1164.0000, 'ºC'),
	(11902, 109, '2015-01-15 00:17:54.000000', 'temperatura', 161.0000, 'ºC'),
	(11903, 109, '2015-01-15 00:17:55.000000', 'temperatura', 910.0000, 'ºC'),
	(11904, 109, '2015-01-15 00:17:56.000000', 'temperatura', 470.0000, 'ºC'),
	(11905, 109, '2015-01-15 00:17:57.000000', 'temperatura', 819.0000, 'ºC'),
	(11906, 109, '2015-01-15 00:17:58.000000', 'temperatura', 287.0000, 'ºC'),
	(11907, 109, '2015-01-15 00:17:59.000000', 'temperatura', 178.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(11908, 109, '2015-01-15 00:18:00.000000', 'temperatura', 28.0000, 'ºC'),
	(11909, 109, '2015-01-15 00:18:01.000000', 'temperatura', 806.0000, 'ºC'),
	(11910, 109, '2015-01-15 00:18:02.000000', 'temperatura', 349.0000, 'ºC'),
	(11911, 109, '2015-01-15 00:18:03.000000', 'temperatura', 525.0000, 'ºC'),
	(11912, 109, '2015-01-15 00:18:04.000000', 'temperatura', 378.0000, 'ºC'),
	(11913, 109, '2015-01-15 00:18:05.000000', 'temperatura', 317.0000, 'ºC'),
	(11914, 109, '2015-01-15 00:18:06.000000', 'temperatura', 449.0000, 'ºC'),
	(11915, 109, '2015-01-15 00:18:07.000000', 'temperatura', 97.0000, 'ºC'),
	(11916, 109, '2015-01-15 00:18:08.000000', 'temperatura', 337.0000, 'ºC'),
	(11917, 109, '2015-01-15 00:18:09.000000', 'temperatura', 196.0000, 'ºC'),
	(11918, 109, '2015-01-15 00:18:10.000000', 'temperatura', 1168.0000, 'ºC'),
	(11919, 109, '2015-01-15 00:18:11.000000', 'temperatura', 455.0000, 'ºC'),
	(11920, 109, '2015-01-15 00:18:12.000000', 'temperatura', 1169.0000, 'ºC'),
	(11921, 109, '2015-01-15 00:18:13.000000', 'temperatura', 883.0000, 'ºC'),
	(11922, 109, '2015-01-15 00:18:14.000000', 'temperatura', 906.0000, 'ºC'),
	(11923, 109, '2015-01-15 00:18:15.000000', 'temperatura', 684.0000, 'ºC'),
	(11924, 109, '2015-01-15 00:18:16.000000', 'temperatura', 702.0000, 'ºC'),
	(11925, 109, '2015-01-15 00:18:17.000000', 'temperatura', 256.0000, 'ºC'),
	(11926, 109, '2015-01-15 00:18:18.000000', 'temperatura', 376.0000, 'ºC'),
	(11927, 109, '2015-01-15 00:18:19.000000', 'temperatura', 1113.0000, 'ºC'),
	(11928, 109, '2015-01-15 00:18:20.000000', 'temperatura', 838.0000, 'ºC'),
	(11929, 109, '2015-01-15 00:18:21.000000', 'temperatura', 852.0000, 'ºC'),
	(11930, 109, '2015-01-15 00:18:22.000000', 'temperatura', 546.0000, 'ºC'),
	(11931, 109, '2015-01-15 00:18:23.000000', 'temperatura', 175.0000, 'ºC'),
	(11932, 109, '2015-01-15 00:18:24.000000', 'temperatura', 439.0000, 'ºC'),
	(11933, 109, '2015-01-15 00:18:25.000000', 'temperatura', 467.0000, 'ºC'),
	(11934, 109, '2015-01-15 00:18:26.000000', 'temperatura', 1021.0000, 'ºC'),
	(11935, 109, '2015-01-15 00:18:27.000000', 'temperatura', 104.0000, 'ºC'),
	(11936, 109, '2015-01-15 00:18:28.000000', 'temperatura', 1055.0000, 'ºC'),
	(11937, 109, '2015-01-15 00:18:29.000000', 'temperatura', 167.0000, 'ºC'),
	(11938, 109, '2015-01-15 00:18:30.000000', 'temperatura', 68.0000, 'ºC'),
	(11939, 109, '2015-01-15 00:18:31.000000', 'temperatura', 1042.0000, 'ºC'),
	(11940, 109, '2015-01-15 00:18:32.000000', 'temperatura', 206.0000, 'ºC'),
	(11941, 109, '2015-01-15 00:18:33.000000', 'temperatura', 304.0000, 'ºC'),
	(11942, 109, '2015-01-15 00:18:34.000000', 'temperatura', 900.0000, 'ºC'),
	(11943, 109, '2015-01-15 00:18:35.000000', 'temperatura', 1192.0000, 'ºC'),
	(11944, 109, '2015-01-15 00:18:36.000000', 'temperatura', 860.0000, 'ºC'),
	(11945, 109, '2015-01-15 00:18:37.000000', 'temperatura', 724.0000, 'ºC'),
	(11946, 109, '2015-01-15 00:18:38.000000', 'temperatura', 1038.0000, 'ºC'),
	(11947, 109, '2015-01-15 00:18:39.000000', 'temperatura', 622.0000, 'ºC'),
	(11948, 109, '2015-01-15 00:18:40.000000', 'temperatura', 1197.0000, 'ºC'),
	(11949, 109, '2015-01-15 00:18:41.000000', 'temperatura', 518.0000, 'ºC'),
	(11950, 109, '2015-01-15 00:18:42.000000', 'temperatura', 200.0000, 'ºC'),
	(11951, 109, '2015-01-15 00:18:43.000000', 'temperatura', 647.0000, 'ºC'),
	(11952, 109, '2015-01-15 00:18:44.000000', 'temperatura', 237.0000, 'ºC'),
	(11953, 109, '2015-01-15 00:18:45.000000', 'temperatura', 442.0000, 'ºC'),
	(11954, 109, '2015-01-15 00:18:46.000000', 'temperatura', 299.0000, 'ºC'),
	(11955, 109, '2015-01-15 00:18:47.000000', 'temperatura', 171.0000, 'ºC'),
	(11956, 109, '2015-01-15 00:18:48.000000', 'temperatura', 1158.0000, 'ºC'),
	(11957, 109, '2015-01-15 00:18:49.000000', 'temperatura', 479.0000, 'ºC'),
	(11958, 109, '2015-01-15 00:18:50.000000', 'temperatura', 120.0000, 'ºC'),
	(11959, 109, '2015-01-15 00:18:51.000000', 'temperatura', 365.0000, 'ºC'),
	(11960, 109, '2015-01-15 00:18:52.000000', 'temperatura', 265.0000, 'ºC'),
	(11961, 109, '2015-01-15 00:18:53.000000', 'temperatura', 230.0000, 'ºC'),
	(11962, 109, '2015-01-15 00:18:54.000000', 'temperatura', 358.0000, 'ºC'),
	(11963, 109, '2015-01-15 00:18:55.000000', 'temperatura', 1097.0000, 'ºC'),
	(11964, 109, '2015-01-15 00:18:56.000000', 'temperatura', 814.0000, 'ºC'),
	(11965, 109, '2015-01-15 00:18:57.000000', 'temperatura', 780.0000, 'ºC'),
	(11966, 109, '2015-01-15 00:18:58.000000', 'temperatura', 256.0000, 'ºC'),
	(11967, 109, '2015-01-15 00:18:59.000000', 'temperatura', 142.0000, 'ºC'),
	(11968, 109, '2015-01-15 00:19:00.000000', 'temperatura', 1142.0000, 'ºC'),
	(11969, 109, '2015-01-15 00:19:01.000000', 'temperatura', 483.0000, 'ºC'),
	(11970, 109, '2015-01-15 00:19:02.000000', 'temperatura', 189.0000, 'ºC'),
	(11971, 109, '2015-01-15 00:19:03.000000', 'temperatura', 699.0000, 'ºC'),
	(11972, 109, '2015-01-15 00:19:04.000000', 'temperatura', 529.0000, 'ºC'),
	(11973, 109, '2015-01-15 00:19:05.000000', 'temperatura', 549.0000, 'ºC'),
	(11974, 109, '2015-01-15 00:19:06.000000', 'temperatura', 1155.0000, 'ºC'),
	(11975, 109, '2015-01-15 00:19:07.000000', 'temperatura', 532.0000, 'ºC'),
	(11976, 109, '2015-01-15 00:19:08.000000', 'temperatura', 394.0000, 'ºC'),
	(11977, 109, '2015-01-15 00:19:09.000000', 'temperatura', 373.0000, 'ºC'),
	(11978, 109, '2015-01-15 00:19:10.000000', 'temperatura', 686.0000, 'ºC'),
	(11979, 109, '2015-01-15 00:19:11.000000', 'temperatura', 1110.0000, 'ºC'),
	(11980, 109, '2015-01-15 00:19:12.000000', 'temperatura', 1093.0000, 'ºC'),
	(11981, 109, '2015-01-15 00:19:13.000000', 'temperatura', 934.0000, 'ºC'),
	(11982, 109, '2015-01-15 00:19:14.000000', 'temperatura', 193.0000, 'ºC'),
	(11983, 109, '2015-01-15 00:19:15.000000', 'temperatura', 564.0000, 'ºC'),
	(11984, 109, '2015-01-15 00:19:16.000000', 'temperatura', 1039.0000, 'ºC'),
	(11985, 109, '2015-01-15 00:19:17.000000', 'temperatura', 1104.0000, 'ºC'),
	(11986, 109, '2015-01-15 00:19:18.000000', 'temperatura', 5.0000, 'ºC'),
	(11987, 109, '2015-01-15 00:19:19.000000', 'temperatura', 315.0000, 'ºC'),
	(11988, 109, '2015-01-15 00:19:20.000000', 'temperatura', 357.0000, 'ºC'),
	(11989, 109, '2015-01-15 00:19:21.000000', 'temperatura', 842.0000, 'ºC'),
	(11990, 109, '2015-01-15 00:19:22.000000', 'temperatura', 737.0000, 'ºC'),
	(11991, 109, '2015-01-15 00:19:23.000000', 'temperatura', 1163.0000, 'ºC'),
	(11992, 109, '2015-01-15 00:19:24.000000', 'temperatura', 3.0000, 'ºC'),
	(11993, 109, '2015-01-15 00:19:25.000000', 'temperatura', 126.0000, 'ºC'),
	(11994, 109, '2015-01-15 00:19:26.000000', 'temperatura', 624.0000, 'ºC'),
	(11995, 109, '2015-01-15 00:19:27.000000', 'temperatura', 340.0000, 'ºC'),
	(11996, 109, '2015-01-15 00:19:28.000000', 'temperatura', 1030.0000, 'ºC'),
	(11997, 109, '2015-01-15 00:19:29.000000', 'temperatura', 532.0000, 'ºC'),
	(11998, 109, '2015-01-15 00:19:30.000000', 'temperatura', 767.0000, 'ºC'),
	(11999, 109, '2015-01-15 00:19:31.000000', 'temperatura', 1041.0000, 'ºC'),
	(12000, 109, '2015-01-15 00:19:32.000000', 'temperatura', 505.0000, 'ºC'),
	(12001, 109, '2015-01-15 00:19:33.000000', 'temperatura', 600.0000, 'ºC'),
	(12002, 109, '2015-01-15 00:19:34.000000', 'temperatura', 287.0000, 'ºC'),
	(12003, 109, '2015-01-15 00:19:35.000000', 'temperatura', 837.0000, 'ºC'),
	(12004, 109, '2015-01-15 00:19:36.000000', 'temperatura', 924.0000, 'ºC'),
	(12005, 109, '2015-01-15 00:19:37.000000', 'temperatura', 908.0000, 'ºC'),
	(12006, 109, '2015-01-15 00:19:38.000000', 'temperatura', 568.0000, 'ºC'),
	(12007, 109, '2015-01-15 00:19:39.000000', 'temperatura', 117.0000, 'ºC'),
	(12008, 109, '2015-01-15 00:19:40.000000', 'temperatura', 81.0000, 'ºC'),
	(12009, 109, '2015-01-15 00:19:41.000000', 'temperatura', 56.0000, 'ºC'),
	(12010, 109, '2015-01-15 00:19:42.000000', 'temperatura', 37.0000, 'ºC'),
	(12011, 109, '2015-01-15 00:19:43.000000', 'temperatura', 15.0000, 'ºC'),
	(12012, 109, '2015-01-15 00:19:44.000000', 'temperatura', 1168.0000, 'ºC'),
	(12013, 109, '2015-01-15 00:19:45.000000', 'temperatura', 995.0000, 'ºC'),
	(12014, 109, '2015-01-15 00:19:46.000000', 'temperatura', 271.0000, 'ºC'),
	(12015, 109, '2015-01-15 00:19:47.000000', 'temperatura', 771.0000, 'ºC'),
	(12016, 109, '2015-01-15 00:19:48.000000', 'temperatura', 643.0000, 'ºC'),
	(12017, 109, '2015-01-15 00:19:49.000000', 'temperatura', 901.0000, 'ºC'),
	(12018, 109, '2015-01-15 00:19:50.000000', 'temperatura', 178.0000, 'ºC'),
	(12019, 109, '2015-01-15 00:19:51.000000', 'temperatura', 586.0000, 'ºC'),
	(12020, 109, '2015-01-15 00:19:52.000000', 'temperatura', 1197.0000, 'ºC'),
	(12021, 109, '2015-01-15 00:19:53.000000', 'temperatura', 626.0000, 'ºC'),
	(12022, 109, '2015-01-15 00:19:54.000000', 'temperatura', 741.0000, 'ºC'),
	(12023, 109, '2015-01-15 00:19:55.000000', 'temperatura', 628.0000, 'ºC'),
	(12024, 109, '2015-01-15 00:19:56.000000', 'temperatura', 919.0000, 'ºC'),
	(12025, 109, '2015-01-15 00:19:57.000000', 'temperatura', 309.0000, 'ºC'),
	(12026, 109, '2015-01-15 00:19:58.000000', 'temperatura', 1190.0000, 'ºC'),
	(12027, 109, '2015-01-15 00:19:59.000000', 'temperatura', 223.0000, 'ºC'),
	(12028, 109, '2015-01-15 00:20:00.000000', 'temperatura', 1144.0000, 'ºC'),
	(12029, 109, '2015-01-15 00:20:01.000000', 'temperatura', 252.0000, 'ºC'),
	(12030, 109, '2015-01-15 00:20:02.000000', 'temperatura', 229.0000, 'ºC'),
	(12031, 109, '2015-01-15 00:20:03.000000', 'temperatura', 388.0000, 'ºC'),
	(12032, 109, '2015-01-15 00:20:04.000000', 'temperatura', 52.0000, 'ºC'),
	(12033, 109, '2015-01-15 00:20:05.000000', 'temperatura', 300.0000, 'ºC'),
	(12034, 109, '2015-01-15 00:20:06.000000', 'temperatura', 144.0000, 'ºC'),
	(12035, 109, '2015-01-15 00:20:07.000000', 'temperatura', 1018.0000, 'ºC'),
	(12036, 109, '2015-01-15 00:20:08.000000', 'temperatura', 1062.0000, 'ºC'),
	(12037, 109, '2015-01-15 00:20:09.000000', 'temperatura', 1055.0000, 'ºC'),
	(12038, 109, '2015-01-15 00:20:10.000000', 'temperatura', 889.0000, 'ºC'),
	(12039, 109, '2015-01-15 00:20:11.000000', 'temperatura', 80.0000, 'ºC'),
	(12040, 109, '2015-01-15 00:20:12.000000', 'temperatura', 132.0000, 'ºC'),
	(12041, 109, '2015-01-15 00:20:13.000000', 'temperatura', 424.0000, 'ºC'),
	(12042, 109, '2015-01-15 00:20:14.000000', 'temperatura', 523.0000, 'ºC'),
	(12043, 109, '2015-01-15 00:20:15.000000', 'temperatura', 146.0000, 'ºC'),
	(12044, 109, '2015-01-15 00:20:16.000000', 'temperatura', 358.0000, 'ºC'),
	(12045, 109, '2015-01-15 00:20:17.000000', 'temperatura', 154.0000, 'ºC'),
	(12046, 109, '2015-01-15 00:20:18.000000', 'temperatura', 897.0000, 'ºC'),
	(12047, 109, '2015-01-15 00:20:19.000000', 'temperatura', 422.0000, 'ºC'),
	(12048, 109, '2015-01-15 00:20:20.000000', 'temperatura', 619.0000, 'ºC'),
	(12049, 109, '2015-01-15 00:20:21.000000', 'temperatura', 629.0000, 'ºC'),
	(12050, 109, '2015-01-15 00:20:22.000000', 'temperatura', 88.0000, 'ºC'),
	(12051, 109, '2015-01-15 00:20:23.000000', 'temperatura', 955.0000, 'ºC'),
	(12052, 109, '2015-01-15 00:20:24.000000', 'temperatura', 910.0000, 'ºC'),
	(12053, 109, '2015-01-15 00:20:25.000000', 'temperatura', 487.0000, 'ºC'),
	(12054, 109, '2015-01-15 00:20:26.000000', 'temperatura', 905.0000, 'ºC'),
	(12055, 109, '2015-01-15 00:20:27.000000', 'temperatura', 663.0000, 'ºC'),
	(12056, 109, '2015-01-15 00:20:28.000000', 'temperatura', 600.0000, 'ºC'),
	(12057, 109, '2015-01-15 00:20:29.000000', 'temperatura', 1015.0000, 'ºC'),
	(12058, 109, '2015-01-15 00:20:30.000000', 'temperatura', 872.0000, 'ºC'),
	(12059, 109, '2015-01-15 00:20:31.000000', 'temperatura', 118.0000, 'ºC'),
	(12060, 109, '2015-01-15 00:20:32.000000', 'temperatura', 374.0000, 'ºC'),
	(12061, 109, '2015-01-15 00:20:33.000000', 'temperatura', 317.0000, 'ºC'),
	(12062, 109, '2015-01-15 00:20:34.000000', 'temperatura', 462.0000, 'ºC'),
	(12063, 109, '2015-01-15 00:20:35.000000', 'temperatura', 160.0000, 'ºC'),
	(12064, 109, '2015-01-15 00:20:36.000000', 'temperatura', 613.0000, 'ºC'),
	(12065, 109, '2015-01-15 00:20:37.000000', 'temperatura', 187.0000, 'ºC'),
	(12066, 109, '2015-01-15 00:20:38.000000', 'temperatura', 296.0000, 'ºC'),
	(12067, 109, '2015-01-15 00:20:39.000000', 'temperatura', 919.0000, 'ºC'),
	(12068, 109, '2015-01-15 00:20:40.000000', 'temperatura', 109.0000, 'ºC'),
	(12069, 109, '2015-01-15 00:20:41.000000', 'temperatura', 188.0000, 'ºC'),
	(12070, 109, '2015-01-15 00:20:42.000000', 'temperatura', 612.0000, 'ºC'),
	(12071, 109, '2015-01-15 00:20:43.000000', 'temperatura', 97.0000, 'ºC'),
	(12072, 109, '2015-01-15 00:20:44.000000', 'temperatura', 1050.0000, 'ºC'),
	(12073, 109, '2015-01-15 00:20:45.000000', 'temperatura', 159.0000, 'ºC'),
	(12074, 109, '2015-01-15 00:20:46.000000', 'temperatura', 45.0000, 'ºC'),
	(12075, 109, '2015-01-15 00:20:47.000000', 'temperatura', 948.0000, 'ºC'),
	(12076, 109, '2015-01-15 00:20:48.000000', 'temperatura', 1005.0000, 'ºC'),
	(12077, 109, '2015-01-15 00:20:49.000000', 'temperatura', 981.0000, 'ºC'),
	(12078, 109, '2015-01-15 00:20:50.000000', 'temperatura', 691.0000, 'ºC'),
	(12079, 109, '2015-01-15 00:20:51.000000', 'temperatura', 514.0000, 'ºC'),
	(12080, 109, '2015-01-15 00:20:52.000000', 'temperatura', 496.0000, 'ºC'),
	(12081, 109, '2015-01-15 00:20:53.000000', 'temperatura', 938.0000, 'ºC'),
	(12082, 109, '2015-01-15 00:20:54.000000', 'temperatura', 804.0000, 'ºC'),
	(12083, 109, '2015-01-15 00:20:55.000000', 'temperatura', 7.0000, 'ºC'),
	(12084, 109, '2015-01-15 00:20:56.000000', 'temperatura', 23.0000, 'ºC'),
	(12085, 109, '2015-01-15 00:20:57.000000', 'temperatura', 92.0000, 'ºC'),
	(12086, 109, '2015-01-15 00:20:58.000000', 'temperatura', 395.0000, 'ºC'),
	(12087, 109, '2015-01-15 00:20:59.000000', 'temperatura', 497.0000, 'ºC'),
	(12088, 109, '2015-01-15 00:21:00.000000', 'temperatura', 99.0000, 'ºC'),
	(12089, 109, '2015-01-15 00:21:01.000000', 'temperatura', 207.0000, 'ºC'),
	(12090, 109, '2015-01-15 00:21:02.000000', 'temperatura', 738.0000, 'ºC'),
	(12091, 109, '2015-01-15 00:21:03.000000', 'temperatura', 671.0000, 'ºC'),
	(12092, 109, '2015-01-15 00:21:04.000000', 'temperatura', 1141.0000, 'ºC'),
	(12093, 109, '2015-01-15 00:21:05.000000', 'temperatura', 93.0000, 'ºC'),
	(12094, 109, '2015-01-15 00:21:06.000000', 'temperatura', 643.0000, 'ºC'),
	(12095, 109, '2015-01-15 00:21:07.000000', 'temperatura', 536.0000, 'ºC'),
	(12096, 109, '2015-01-15 00:21:08.000000', 'temperatura', 750.0000, 'ºC'),
	(12097, 109, '2015-01-15 00:21:09.000000', 'temperatura', 944.0000, 'ºC'),
	(12098, 109, '2015-01-15 00:21:10.000000', 'temperatura', 69.0000, 'ºC'),
	(12099, 109, '2015-01-15 00:21:11.000000', 'temperatura', 1113.0000, 'ºC'),
	(12100, 109, '2015-01-15 00:21:12.000000', 'temperatura', 559.0000, 'ºC'),
	(12101, 109, '2015-01-15 00:21:13.000000', 'temperatura', 655.0000, 'ºC'),
	(12102, 109, '2015-01-15 00:21:14.000000', 'temperatura', 399.0000, 'ºC'),
	(12103, 109, '2015-01-15 00:21:15.000000', 'temperatura', 30.0000, 'ºC'),
	(12104, 109, '2015-01-15 00:21:16.000000', 'temperatura', 154.0000, 'ºC'),
	(12105, 109, '2015-01-15 00:21:17.000000', 'temperatura', 681.0000, 'ºC'),
	(12106, 109, '2015-01-15 00:21:18.000000', 'temperatura', 542.0000, 'ºC'),
	(12107, 109, '2015-01-15 00:21:19.000000', 'temperatura', 667.0000, 'ºC'),
	(12108, 109, '2015-01-15 00:21:20.000000', 'temperatura', 509.0000, 'ºC'),
	(12109, 109, '2015-01-15 00:21:21.000000', 'temperatura', 544.0000, 'ºC'),
	(12110, 109, '2015-01-15 00:21:22.000000', 'temperatura', 1193.0000, 'ºC'),
	(12111, 109, '2015-01-15 00:21:23.000000', 'temperatura', 733.0000, 'ºC'),
	(12112, 109, '2015-01-15 00:21:24.000000', 'temperatura', 86.0000, 'ºC'),
	(12113, 109, '2015-01-15 00:21:25.000000', 'temperatura', 634.0000, 'ºC'),
	(12114, 109, '2015-01-15 00:21:26.000000', 'temperatura', 510.0000, 'ºC'),
	(12115, 109, '2015-01-15 00:21:27.000000', 'temperatura', 649.0000, 'ºC'),
	(12116, 109, '2015-01-15 00:21:28.000000', 'temperatura', 514.0000, 'ºC'),
	(12117, 109, '2015-01-15 00:21:29.000000', 'temperatura', 624.0000, 'ºC'),
	(12118, 109, '2015-01-15 00:21:30.000000', 'temperatura', 379.0000, 'ºC'),
	(12119, 109, '2015-01-15 00:21:31.000000', 'temperatura', 23.0000, 'ºC'),
	(12120, 109, '2015-01-15 00:21:32.000000', 'temperatura', 179.0000, 'ºC'),
	(12121, 109, '2015-01-15 00:21:33.000000', 'temperatura', 825.0000, 'ºC'),
	(12122, 109, '2015-01-15 00:21:34.000000', 'temperatura', 1191.0000, 'ºC'),
	(12123, 109, '2015-01-15 00:21:35.000000', 'temperatura', 1081.0000, 'ºC'),
	(12124, 109, '2015-01-15 00:21:36.000000', 'temperatura', 630.0000, 'ºC'),
	(12125, 109, '2015-01-15 00:21:37.000000', 'temperatura', 1106.0000, 'ºC'),
	(12126, 109, '2015-01-15 00:21:38.000000', 'temperatura', 44.0000, 'ºC'),
	(12127, 109, '2015-01-15 00:21:39.000000', 'temperatura', 503.0000, 'ºC'),
	(12128, 109, '2015-01-15 00:21:40.000000', 'temperatura', 1180.0000, 'ºC'),
	(12129, 109, '2015-01-15 00:21:41.000000', 'temperatura', 795.0000, 'ºC'),
	(12130, 109, '2015-01-15 00:21:42.000000', 'temperatura', 434.0000, 'ºC'),
	(12131, 109, '2015-01-15 00:21:43.000000', 'temperatura', 987.0000, 'ºC'),
	(12132, 109, '2015-01-15 00:21:44.000000', 'temperatura', 31.0000, 'ºC'),
	(12133, 109, '2015-01-15 00:21:45.000000', 'temperatura', 794.0000, 'ºC'),
	(12134, 109, '2015-01-15 00:21:46.000000', 'temperatura', 277.0000, 'ºC'),
	(12135, 109, '2015-01-15 00:21:47.000000', 'temperatura', 204.0000, 'ºC'),
	(12136, 109, '2015-01-15 00:21:48.000000', 'temperatura', 190.0000, 'ºC'),
	(12137, 109, '2015-01-15 00:21:49.000000', 'temperatura', 339.0000, 'ºC'),
	(12138, 109, '2015-01-15 00:21:50.000000', 'temperatura', 1127.0000, 'ºC'),
	(12139, 109, '2015-01-15 00:21:51.000000', 'temperatura', 1018.0000, 'ºC'),
	(12140, 109, '2015-01-15 00:21:52.000000', 'temperatura', 507.0000, 'ºC'),
	(12141, 109, '2015-01-15 00:21:53.000000', 'temperatura', 684.0000, 'ºC'),
	(12142, 109, '2015-01-15 00:21:54.000000', 'temperatura', 698.0000, 'ºC'),
	(12143, 109, '2015-01-15 00:21:55.000000', 'temperatura', 241.0000, 'ºC'),
	(12144, 109, '2015-01-15 00:21:56.000000', 'temperatura', 308.0000, 'ºC'),
	(12145, 109, '2015-01-15 00:21:57.000000', 'temperatura', 820.0000, 'ºC'),
	(12146, 109, '2015-01-15 00:21:58.000000', 'temperatura', 777.0000, 'ºC'),
	(12147, 109, '2015-01-15 00:21:59.000000', 'temperatura', 223.0000, 'ºC'),
	(12148, 109, '2015-01-15 00:22:00.000000', 'temperatura', 1186.0000, 'ºC'),
	(12149, 109, '2015-01-15 00:22:01.000000', 'temperatura', 460.0000, 'ºC'),
	(12150, 109, '2015-01-15 00:22:02.000000', 'temperatura', 1142.0000, 'ºC'),
	(12151, 109, '2015-01-15 00:22:03.000000', 'temperatura', 733.0000, 'ºC'),
	(12152, 109, '2015-01-15 00:22:04.000000', 'temperatura', 240.0000, 'ºC'),
	(12153, 109, '2015-01-15 00:22:05.000000', 'temperatura', 200.0000, 'ºC'),
	(12154, 109, '2015-01-15 00:22:06.000000', 'temperatura', 282.0000, 'ºC'),
	(12155, 109, '2015-01-15 00:22:07.000000', 'temperatura', 809.0000, 'ºC'),
	(12156, 109, '2015-01-15 00:22:08.000000', 'temperatura', 801.0000, 'ºC'),
	(12157, 109, '2015-01-15 00:22:09.000000', 'temperatura', 376.0000, 'ºC'),
	(12158, 109, '2015-01-15 00:22:10.000000', 'temperatura', 679.0000, 'ºC'),
	(12159, 109, '2015-01-15 00:22:11.000000', 'temperatura', 1066.0000, 'ºC'),
	(12160, 109, '2015-01-15 00:22:12.000000', 'temperatura', 893.0000, 'ºC'),
	(12161, 109, '2015-01-15 00:22:13.000000', 'temperatura', 67.0000, 'ºC'),
	(12162, 109, '2015-01-15 00:22:14.000000', 'temperatura', 56.0000, 'ºC'),
	(12163, 109, '2015-01-15 00:22:15.000000', 'temperatura', 80.0000, 'ºC'),
	(12164, 109, '2015-01-15 00:22:16.000000', 'temperatura', 232.0000, 'ºC'),
	(12165, 109, '2015-01-15 00:22:17.000000', 'temperatura', 922.0000, 'ºC'),
	(12166, 109, '2015-01-15 00:22:18.000000', 'temperatura', 316.0000, 'ºC'),
	(12167, 109, '2015-01-15 00:22:19.000000', 'temperatura', 12.0000, 'ºC'),
	(12168, 109, '2015-01-15 00:22:20.000000', 'temperatura', 313.0000, 'ºC'),
	(12169, 109, '2015-01-15 00:22:21.000000', 'temperatura', 329.0000, 'ºC'),
	(12170, 109, '2015-01-15 00:22:22.000000', 'temperatura', 706.0000, 'ºC'),
	(12171, 109, '2015-01-15 00:22:23.000000', 'temperatura', 144.0000, 'ºC'),
	(12172, 109, '2015-01-15 00:22:24.000000', 'temperatura', 1001.0000, 'ºC'),
	(12173, 109, '2015-01-15 00:22:25.000000', 'temperatura', 975.0000, 'ºC'),
	(12174, 109, '2015-01-15 00:22:26.000000', 'temperatura', 674.0000, 'ºC'),
	(12175, 109, '2015-01-15 00:22:27.000000', 'temperatura', 444.0000, 'ºC'),
	(12176, 109, '2015-01-15 00:22:28.000000', 'temperatura', 200.0000, 'ºC'),
	(12177, 109, '2015-01-15 00:22:29.000000', 'temperatura', 867.0000, 'ºC'),
	(12178, 109, '2015-01-15 00:22:30.000000', 'temperatura', 135.0000, 'ºC'),
	(12179, 109, '2015-01-15 00:22:31.000000', 'temperatura', 476.0000, 'ºC'),
	(12180, 109, '2015-01-15 00:22:32.000000', 'temperatura', 774.0000, 'ºC'),
	(12181, 109, '2015-01-15 00:22:33.000000', 'temperatura', 41.0000, 'ºC'),
	(12182, 109, '2015-01-15 00:22:34.000000', 'temperatura', 287.0000, 'ºC'),
	(12183, 109, '2015-01-15 00:22:35.000000', 'temperatura', 109.0000, 'ºC'),
	(12184, 109, '2015-01-15 00:22:36.000000', 'temperatura', 888.0000, 'ºC'),
	(12185, 109, '2015-01-15 00:22:37.000000', 'temperatura', 511.0000, 'ºC'),
	(12186, 109, '2015-01-15 00:22:38.000000', 'temperatura', 1092.0000, 'ºC'),
	(12187, 109, '2015-01-15 00:22:39.000000', 'temperatura', 327.0000, 'ºC'),
	(12188, 109, '2015-01-15 00:22:40.000000', 'temperatura', 758.0000, 'ºC'),
	(12189, 109, '2015-01-15 00:22:41.000000', 'temperatura', 411.0000, 'ºC'),
	(12190, 109, '2015-01-15 00:22:42.000000', 'temperatura', 981.0000, 'ºC'),
	(12191, 109, '2015-01-15 00:22:43.000000', 'temperatura', 74.0000, 'ºC'),
	(12192, 109, '2015-01-15 00:22:44.000000', 'temperatura', 1026.0000, 'ºC'),
	(12193, 109, '2015-01-15 00:22:45.000000', 'temperatura', 111.0000, 'ºC'),
	(12194, 109, '2015-01-15 00:22:46.000000', 'temperatura', 1074.0000, 'ºC'),
	(12195, 109, '2015-01-15 00:22:47.000000', 'temperatura', 241.0000, 'ºC'),
	(12196, 109, '2015-01-15 00:22:48.000000', 'temperatura', 382.0000, 'ºC'),
	(12197, 109, '2015-01-15 00:22:49.000000', 'temperatura', 1189.0000, 'ºC'),
	(12198, 109, '2015-01-15 00:22:50.000000', 'temperatura', 1197.0000, 'ºC'),
	(12199, 109, '2015-01-15 00:22:51.000000', 'temperatura', 18.0000, 'ºC'),
	(12200, 109, '2015-01-15 00:22:52.000000', 'temperatura', 99.0000, 'ºC'),
	(12201, 109, '2015-01-15 00:22:53.000000', 'temperatura', 441.0000, 'ºC'),
	(12202, 109, '2015-01-15 00:22:54.000000', 'temperatura', 710.0000, 'ºC'),
	(12203, 109, '2015-01-15 00:22:55.000000', 'temperatura', 1028.0000, 'ºC'),
	(12204, 109, '2015-01-15 00:22:56.000000', 'temperatura', 609.0000, 'ºC'),
	(12205, 109, '2015-01-15 00:22:57.000000', 'temperatura', 1164.0000, 'ºC'),
	(12206, 109, '2015-01-15 00:22:58.000000', 'temperatura', 392.0000, 'ºC'),
	(12207, 109, '2015-01-15 00:22:59.000000', 'temperatura', 868.0000, 'ºC'),
	(12208, 109, '2015-01-15 00:23:00.000000', 'temperatura', 765.0000, 'ºC'),
	(12209, 109, '2015-01-15 00:23:01.000000', 'temperatura', 20.0000, 'ºC'),
	(12210, 109, '2015-01-15 00:23:02.000000', 'temperatura', 208.0000, 'ºC'),
	(12211, 109, '2015-01-15 00:23:03.000000', 'temperatura', 978.0000, 'ºC'),
	(12212, 109, '2015-01-15 00:23:04.000000', 'temperatura', 666.0000, 'ºC'),
	(12213, 109, '2015-01-15 00:23:05.000000', 'temperatura', 398.0000, 'ºC'),
	(12214, 109, '2015-01-15 00:23:06.000000', 'temperatura', 1194.0000, 'ºC'),
	(12215, 109, '2015-01-15 00:23:07.000000', 'temperatura', 1175.0000, 'ºC'),
	(12216, 109, '2015-01-15 00:23:08.000000', 'temperatura', 1095.0000, 'ºC'),
	(12217, 109, '2015-01-15 00:23:09.000000', 'temperatura', 751.0000, 'ºC'),
	(12218, 109, '2015-01-15 00:23:10.000000', 'temperatura', 469.0000, 'ºC'),
	(12219, 109, '2015-01-15 00:23:11.000000', 'temperatura', 95.0000, 'ºC'),
	(12220, 109, '2015-01-15 00:23:12.000000', 'temperatura', 267.0000, 'ºC'),
	(12221, 109, '2015-01-15 00:23:13.000000', 'temperatura', 1050.0000, 'ºC'),
	(12222, 109, '2015-01-15 00:23:14.000000', 'temperatura', 850.0000, 'ºC'),
	(12223, 109, '2015-01-15 00:23:15.000000', 'temperatura', 1103.0000, 'ºC'),
	(12224, 109, '2015-01-15 00:23:16.000000', 'temperatura', 562.0000, 'ºC'),
	(12225, 109, '2015-01-15 00:23:17.000000', 'temperatura', 701.0000, 'ºC'),
	(12226, 109, '2015-01-15 00:23:18.000000', 'temperatura', 622.0000, 'ºC'),
	(12227, 109, '2015-01-15 00:23:19.000000', 'temperatura', 1006.0000, 'ºC'),
	(12228, 109, '2015-01-15 00:23:20.000000', 'temperatura', 764.0000, 'ºC'),
	(12229, 109, '2015-01-15 00:23:21.000000', 'temperatura', 802.0000, 'ºC'),
	(12230, 109, '2015-01-15 00:23:22.000000', 'temperatura', 520.0000, 'ºC'),
	(12231, 109, '2015-01-15 00:23:23.000000', 'temperatura', 194.0000, 'ºC'),
	(12232, 109, '2015-01-15 00:23:24.000000', 'temperatura', 611.0000, 'ºC'),
	(12233, 109, '2015-01-15 00:23:25.000000', 'temperatura', 72.0000, 'ºC'),
	(12234, 109, '2015-01-15 00:23:26.000000', 'temperatura', 927.0000, 'ºC'),
	(12235, 109, '2015-01-15 00:23:27.000000', 'temperatura', 821.0000, 'ºC'),
	(12236, 109, '2015-01-15 00:23:28.000000', 'temperatura', 125.0000, 'ºC'),
	(12237, 109, '2015-01-15 00:23:29.000000', 'temperatura', 563.0000, 'ºC'),
	(12238, 109, '2015-01-15 00:23:30.000000', 'temperatura', 39.0000, 'ºC'),
	(12239, 109, '2015-01-15 00:23:31.000000', 'temperatura', 906.0000, 'ºC'),
	(12240, 109, '2015-01-15 00:23:32.000000', 'temperatura', 815.0000, 'ºC'),
	(12241, 109, '2015-01-15 00:23:33.000000', 'temperatura', 157.0000, 'ºC'),
	(12242, 109, '2015-01-15 00:23:34.000000', 'temperatura', 739.0000, 'ºC'),
	(12243, 109, '2015-01-15 00:23:35.000000', 'temperatura', 827.0000, 'ºC'),
	(12244, 109, '2015-01-15 00:23:36.000000', 'temperatura', 719.0000, 'ºC'),
	(12245, 109, '2015-01-15 00:23:37.000000', 'temperatura', 1114.0000, 'ºC'),
	(12246, 109, '2015-01-15 00:23:38.000000', 'temperatura', 1011.0000, 'ºC'),
	(12247, 109, '2015-01-15 00:23:39.000000', 'temperatura', 516.0000, 'ºC'),
	(12248, 109, '2015-01-15 00:23:40.000000', 'temperatura', 747.0000, 'ºC'),
	(12249, 109, '2015-01-15 00:23:41.000000', 'temperatura', 986.0000, 'ºC'),
	(12250, 109, '2015-01-15 00:23:42.000000', 'temperatura', 291.0000, 'ºC'),
	(12251, 109, '2015-01-15 00:23:43.000000', 'temperatura', 897.0000, 'ºC'),
	(12252, 109, '2015-01-15 00:23:44.000000', 'temperatura', 11.0000, 'ºC'),
	(12253, 109, '2015-01-15 00:23:45.000000', 'temperatura', 965.0000, 'ºC'),
	(12254, 109, '2015-01-15 00:23:46.000000', 'temperatura', 1194.0000, 'ºC'),
	(12255, 109, '2015-01-15 00:23:47.000000', 'temperatura', 677.0000, 'ºC'),
	(12256, 109, '2015-01-15 00:23:48.000000', 'temperatura', 1000.0000, 'ºC'),
	(12257, 109, '2015-01-15 00:23:49.000000', 'temperatura', 572.0000, 'ºC'),
	(12258, 109, '2015-01-15 00:23:50.000000', 'temperatura', 1058.0000, 'ºC'),
	(12259, 109, '2015-01-15 00:23:51.000000', 'temperatura', 1174.0000, 'ºC'),
	(12260, 109, '2015-01-15 00:23:52.000000', 'temperatura', 297.0000, 'ºC'),
	(12261, 109, '2015-01-15 00:23:53.000000', 'temperatura', 366.0000, 'ºC'),
	(12262, 109, '2015-01-15 00:23:54.000000', 'temperatura', 937.0000, 'ºC'),
	(12263, 109, '2015-01-15 00:23:55.000000', 'temperatura', 1187.0000, 'ºC'),
	(12264, 109, '2015-01-15 00:23:56.000000', 'temperatura', 725.0000, 'ºC'),
	(12265, 109, '2015-01-15 00:23:57.000000', 'temperatura', 65.0000, 'ºC'),
	(12266, 109, '2015-01-15 00:23:58.000000', 'temperatura', 550.0000, 'ºC'),
	(12267, 109, '2015-01-15 00:23:59.000000', 'temperatura', 154.0000, 'ºC'),
	(12268, 109, '2015-01-15 00:24:00.000000', 'temperatura', 320.0000, 'ºC'),
	(12269, 109, '2015-01-15 00:24:01.000000', 'temperatura', 1142.0000, 'ºC'),
	(12270, 109, '2015-01-15 00:24:02.000000', 'temperatura', 1148.0000, 'ºC'),
	(12271, 109, '2015-01-15 00:24:03.000000', 'temperatura', 1114.0000, 'ºC'),
	(12272, 109, '2015-01-15 00:24:04.000000', 'temperatura', 927.0000, 'ºC'),
	(12273, 109, '2015-01-15 00:24:05.000000', 'temperatura', 93.0000, 'ºC'),
	(12274, 109, '2015-01-15 00:24:06.000000', 'temperatura', 83.0000, 'ºC'),
	(12275, 109, '2015-01-15 00:24:07.000000', 'temperatura', 138.0000, 'ºC'),
	(12276, 109, '2015-01-15 00:24:08.000000', 'temperatura', 443.0000, 'ºC'),
	(12277, 109, '2015-01-15 00:24:09.000000', 'temperatura', 599.0000, 'ºC'),
	(12278, 109, '2015-01-15 00:24:10.000000', 'temperatura', 468.0000, 'ºC'),
	(12279, 109, '2015-01-15 00:24:11.000000', 'temperatura', 542.0000, 'ºC'),
	(12280, 109, '2015-01-15 00:24:12.000000', 'temperatura', 109.0000, 'ºC'),
	(12281, 109, '2015-01-15 00:24:13.000000', 'temperatura', 120.0000, 'ºC'),
	(12282, 109, '2015-01-15 00:24:14.000000', 'temperatura', 272.0000, 'ºC'),
	(12283, 109, '2015-01-15 00:24:15.000000', 'temperatura', 1001.0000, 'ºC'),
	(12284, 109, '2015-01-15 00:24:16.000000', 'temperatura', 589.0000, 'ºC'),
	(12285, 109, '2015-01-15 00:24:17.000000', 'temperatura', 1143.0000, 'ºC'),
	(12286, 109, '2015-01-15 00:24:18.000000', 'temperatura', 350.0000, 'ºC'),
	(12287, 109, '2015-01-15 00:24:19.000000', 'temperatura', 720.0000, 'ºC'),
	(12288, 109, '2015-01-15 00:24:20.000000', 'temperatura', 151.0000, 'ºC'),
	(12289, 109, '2015-01-15 00:24:21.000000', 'temperatura', 996.0000, 'ºC'),
	(12290, 109, '2015-01-15 00:24:22.000000', 'temperatura', 927.0000, 'ºC'),
	(12291, 109, '2015-01-15 00:24:23.000000', 'temperatura', 447.0000, 'ºC'),
	(12292, 109, '2015-01-15 00:24:24.000000', 'temperatura', 655.0000, 'ºC'),
	(12293, 109, '2015-01-15 00:24:25.000000', 'temperatura', 733.0000, 'ºC'),
	(12294, 109, '2015-01-15 00:24:26.000000', 'temperatura', 503.0000, 'ºC'),
	(12295, 109, '2015-01-15 00:24:27.000000', 'temperatura', 315.0000, 'ºC'),
	(12296, 109, '2015-01-15 00:24:28.000000', 'temperatura', 65.0000, 'ºC'),
	(12297, 109, '2015-01-15 00:24:29.000000', 'temperatura', 583.0000, 'ºC'),
	(12298, 109, '2015-01-15 00:24:30.000000', 'temperatura', 321.0000, 'ºC'),
	(12299, 109, '2015-01-15 00:24:31.000000', 'temperatura', 1055.0000, 'ºC'),
	(12300, 109, '2015-01-15 00:24:32.000000', 'temperatura', 712.0000, 'ºC'),
	(12301, 109, '2015-01-15 00:24:33.000000', 'temperatura', 396.0000, 'ºC'),
	(12302, 109, '2015-01-15 00:24:34.000000', 'temperatura', 1045.0000, 'ºC'),
	(12303, 109, '2015-01-15 00:24:35.000000', 'temperatura', 437.0000, 'ºC'),
	(12304, 109, '2015-01-15 00:24:36.000000', 'temperatura', 250.0000, 'ºC'),
	(12305, 109, '2015-01-15 00:24:37.000000', 'temperatura', 1141.0000, 'ºC'),
	(12306, 109, '2015-01-15 00:24:38.000000', 'temperatura', 156.0000, 'ºC'),
	(12307, 109, '2015-01-15 00:24:39.000000', 'temperatura', 958.0000, 'ºC'),
	(12308, 109, '2015-01-15 00:24:40.000000', 'temperatura', 721.0000, 'ºC'),
	(12309, 109, '2015-01-15 00:24:41.000000', 'temperatura', 731.0000, 'ºC'),
	(12310, 109, '2015-01-15 00:24:42.000000', 'temperatura', 294.0000, 'ºC'),
	(12311, 109, '2015-01-15 00:24:43.000000', 'temperatura', 478.0000, 'ºC'),
	(12312, 109, '2015-01-15 00:24:44.000000', 'temperatura', 309.0000, 'ºC'),
	(12313, 109, '2015-01-15 00:24:45.000000', 'temperatura', 109.0000, 'ºC'),
	(12314, 109, '2015-01-15 00:24:46.000000', 'temperatura', 820.0000, 'ºC'),
	(12315, 109, '2015-01-15 00:24:47.000000', 'temperatura', 173.0000, 'ºC'),
	(12316, 109, '2015-01-15 00:24:48.000000', 'temperatura', 804.0000, 'ºC'),
	(12317, 109, '2015-01-15 00:24:49.000000', 'temperatura', 1104.0000, 'ºC'),
	(12318, 109, '2015-01-15 00:24:50.000000', 'temperatura', 709.0000, 'ºC'),
	(12319, 109, '2015-01-15 00:24:51.000000', 'temperatura', 231.0000, 'ºC'),
	(12320, 109, '2015-01-15 00:24:52.000000', 'temperatura', 228.0000, 'ºC'),
	(12321, 109, '2015-01-15 00:24:53.000000', 'temperatura', 450.0000, 'ºC'),
	(12322, 109, '2015-01-15 00:24:54.000000', 'temperatura', 364.0000, 'ºC'),
	(12323, 109, '2015-01-15 00:24:55.000000', 'temperatura', 470.0000, 'ºC'),
	(12324, 109, '2015-01-15 00:24:56.000000', 'temperatura', 59.0000, 'ºC'),
	(12325, 109, '2015-01-15 00:24:57.000000', 'temperatura', 85.0000, 'ºC'),
	(12326, 109, '2015-01-15 00:24:58.000000', 'temperatura', 251.0000, 'ºC'),
	(12327, 109, '2015-01-15 00:24:59.000000', 'temperatura', 998.0000, 'ºC'),
	(12328, 109, '2015-01-15 00:25:00.000000', 'temperatura', 637.0000, 'ºC'),
	(12329, 109, '2015-01-15 00:25:01.000000', 'temperatura', 192.0000, 'ºC'),
	(12330, 109, '2015-01-15 00:25:02.000000', 'temperatura', 250.0000, 'ºC'),
	(12331, 109, '2015-01-15 00:25:03.000000', 'temperatura', 674.0000, 'ºC'),
	(12332, 109, '2015-01-15 00:25:04.000000', 'temperatura', 220.0000, 'ºC'),
	(12333, 109, '2015-01-15 00:25:05.000000', 'temperatura', 278.0000, 'ºC'),
	(12334, 109, '2015-01-15 00:25:06.000000', 'temperatura', 729.0000, 'ºC'),
	(12335, 109, '2015-01-15 00:25:07.000000', 'temperatura', 414.0000, 'ºC'),
	(12336, 109, '2015-01-15 00:25:08.000000', 'temperatura', 1082.0000, 'ºC'),
	(12337, 109, '2015-01-15 00:25:09.000000', 'temperatura', 568.0000, 'ºC'),
	(12338, 109, '2015-01-15 00:25:10.000000', 'temperatura', 797.0000, 'ºC'),
	(12339, 109, '2015-01-15 00:25:11.000000', 'temperatura', 1080.0000, 'ºC'),
	(12340, 109, '2015-01-15 00:25:12.000000', 'temperatura', 608.0000, 'ºC'),
	(12341, 109, '2015-01-15 00:25:13.000000', 'temperatura', 1003.0000, 'ºC'),
	(12342, 109, '2015-01-15 00:25:14.000000', 'temperatura', 792.0000, 'ºC'),
	(12343, 109, '2015-01-15 00:25:15.000000', 'temperatura', 950.0000, 'ºC'),
	(12344, 109, '2015-01-15 00:25:16.000000', 'temperatura', 1174.0000, 'ºC'),
	(12345, 109, '2015-01-15 00:25:17.000000', 'temperatura', 619.0000, 'ºC'),
	(12346, 109, '2015-01-15 00:25:18.000000', 'temperatura', 775.0000, 'ºC'),
	(12347, 109, '2015-01-15 00:25:19.000000', 'temperatura', 821.0000, 'ºC'),
	(12348, 109, '2015-01-15 00:25:20.000000', 'temperatura', 577.0000, 'ºC'),
	(12349, 109, '2015-01-15 00:25:21.000000', 'temperatura', 424.0000, 'ºC'),
	(12350, 109, '2015-01-15 00:25:22.000000', 'temperatura', 388.0000, 'ºC'),
	(12351, 109, '2015-01-15 00:25:23.000000', 'temperatura', 668.0000, 'ºC'),
	(12352, 109, '2015-01-15 00:25:24.000000', 'temperatura', 980.0000, 'ºC'),
	(12353, 109, '2015-01-15 00:25:25.000000', 'temperatura', 493.0000, 'ºC'),
	(12354, 109, '2015-01-15 00:25:26.000000', 'temperatura', 726.0000, 'ºC'),
	(12355, 109, '2015-01-15 00:25:27.000000', 'temperatura', 954.0000, 'ºC'),
	(12356, 109, '2015-01-15 00:25:28.000000', 'temperatura', 191.0000, 'ºC'),
	(12357, 109, '2015-01-15 00:25:29.000000', 'temperatura', 492.0000, 'ºC'),
	(12358, 109, '2015-01-15 00:25:30.000000', 'temperatura', 689.0000, 'ºC'),
	(12359, 109, '2015-01-15 00:25:31.000000', 'temperatura', 769.0000, 'ºC'),
	(12360, 109, '2015-01-15 00:25:32.000000', 'temperatura', 578.0000, 'ºC'),
	(12361, 109, '2015-01-15 00:25:33.000000', 'temperatura', 583.0000, 'ºC'),
	(12362, 109, '2015-01-15 00:25:34.000000', 'temperatura', 1181.0000, 'ºC'),
	(12363, 109, '2015-01-15 00:25:35.000000', 'temperatura', 557.0000, 'ºC'),
	(12364, 109, '2015-01-15 00:25:36.000000', 'temperatura', 442.0000, 'ºC'),
	(12365, 109, '2015-01-15 00:25:37.000000', 'temperatura', 541.0000, 'ºC'),
	(12366, 109, '2015-01-15 00:25:38.000000', 'temperatura', 179.0000, 'ºC'),
	(12367, 109, '2015-01-15 00:25:39.000000', 'temperatura', 472.0000, 'ºC'),
	(12368, 109, '2015-01-15 00:25:40.000000', 'temperatura', 622.0000, 'ºC'),
	(12369, 109, '2015-01-15 00:25:41.000000', 'temperatura', 497.0000, 'ºC'),
	(12370, 109, '2015-01-15 00:25:42.000000', 'temperatura', 620.0000, 'ºC'),
	(12371, 109, '2015-01-15 00:25:43.000000', 'temperatura', 411.0000, 'ºC'),
	(12372, 109, '2015-01-15 00:25:44.000000', 'temperatura', 192.0000, 'ºC'),
	(12373, 109, '2015-01-15 00:25:45.000000', 'temperatura', 929.0000, 'ºC'),
	(12374, 109, '2015-01-15 00:25:46.000000', 'temperatura', 470.0000, 'ºC'),
	(12375, 109, '2015-01-15 00:25:47.000000', 'temperatura', 765.0000, 'ºC'),
	(12376, 109, '2015-01-15 00:25:48.000000', 'temperatura', 14.0000, 'ºC'),
	(12377, 109, '2015-01-15 00:25:49.000000', 'temperatura', 175.0000, 'ºC'),
	(12378, 109, '2015-01-15 00:25:50.000000', 'temperatura', 833.0000, 'ºC'),
	(12379, 109, '2015-01-15 00:25:51.000000', 'temperatura', 41.0000, 'ºC'),
	(12380, 109, '2015-01-15 00:25:52.000000', 'temperatura', 108.0000, 'ºC'),
	(12381, 109, '2015-01-15 00:25:53.000000', 'temperatura', 418.0000, 'ºC'),
	(12382, 109, '2015-01-15 00:25:54.000000', 'temperatura', 566.0000, 'ºC'),
	(12383, 109, '2015-01-15 00:25:55.000000', 'temperatura', 374.0000, 'ºC'),
	(12384, 109, '2015-01-15 00:25:56.000000', 'temperatura', 175.0000, 'ºC'),
	(12385, 109, '2015-01-15 00:25:57.000000', 'temperatura', 952.0000, 'ºC'),
	(12386, 109, '2015-01-15 00:25:58.000000', 'temperatura', 636.0000, 'ºC'),
	(12387, 109, '2015-01-15 00:25:59.000000', 'temperatura', 325.0000, 'ºC'),
	(12388, 109, '2015-01-15 00:26:00.000000', 'temperatura', 918.0000, 'ºC'),
	(12389, 109, '2015-01-15 00:26:01.000000', 'temperatura', 13.0000, 'ºC'),
	(12390, 109, '2015-01-15 00:26:02.000000', 'temperatura', 914.0000, 'ºC'),
	(12391, 109, '2015-01-15 00:26:03.000000', 'temperatura', 929.0000, 'ºC'),
	(12392, 109, '2015-01-15 00:26:04.000000', 'temperatura', 706.0000, 'ºC'),
	(12393, 109, '2015-01-15 00:26:05.000000', 'temperatura', 742.0000, 'ºC'),
	(12394, 109, '2015-01-15 00:26:06.000000', 'temperatura', 392.0000, 'ºC'),
	(12395, 109, '2015-01-15 00:26:07.000000', 'temperatura', 935.0000, 'ºC'),
	(12396, 109, '2015-01-15 00:26:08.000000', 'temperatura', 1100.0000, 'ºC'),
	(12397, 109, '2015-01-15 00:26:09.000000', 'temperatura', 296.0000, 'ºC'),
	(12398, 109, '2015-01-15 00:26:10.000000', 'temperatura', 582.0000, 'ºC'),
	(12399, 109, '2015-01-15 00:26:11.000000', 'temperatura', 820.0000, 'ºC'),
	(12400, 109, '2015-01-15 00:26:12.000000', 'temperatura', 1154.0000, 'ºC'),
	(12401, 109, '2015-01-15 00:26:13.000000', 'temperatura', 911.0000, 'ºC'),
	(12402, 109, '2015-01-15 00:26:14.000000', 'temperatura', 1092.0000, 'ºC'),
	(12403, 109, '2015-01-15 00:26:15.000000', 'temperatura', 327.0000, 'ºC'),
	(12404, 109, '2015-01-15 00:26:16.000000', 'temperatura', 762.0000, 'ºC'),
	(12405, 109, '2015-01-15 00:26:17.000000', 'temperatura', 428.0000, 'ºC'),
	(12406, 109, '2015-01-15 00:26:18.000000', 'temperatura', 1056.0000, 'ºC'),
	(12407, 109, '2015-01-15 00:26:19.000000', 'temperatura', 395.0000, 'ºC'),
	(12408, 109, '2015-01-15 00:26:20.000000', 'temperatura', 10.0000, 'ºC'),
	(12409, 109, '2015-01-15 00:26:21.000000', 'temperatura', 62.0000, 'ºC'),
	(12410, 109, '2015-01-15 00:26:22.000000', 'temperatura', 283.0000, 'ºC'),
	(12411, 109, '2015-01-15 00:26:23.000000', 'temperatura', 31.0000, 'ºC'),
	(12412, 109, '2015-01-15 00:26:24.000000', 'temperatura', 504.0000, 'ºC'),
	(12413, 109, '2015-01-15 00:26:25.000000', 'temperatura', 26.0000, 'ºC'),
	(12414, 109, '2015-01-15 00:26:26.000000', 'temperatura', 1020.0000, 'ºC'),
	(12415, 109, '2015-01-15 00:26:27.000000', 'temperatura', 223.0000, 'ºC'),
	(12416, 109, '2015-01-15 00:26:28.000000', 'temperatura', 455.0000, 'ºC'),
	(12417, 109, '2015-01-15 00:26:29.000000', 'temperatura', 409.0000, 'ºC'),
	(12418, 109, '2015-01-15 00:26:30.000000', 'temperatura', 678.0000, 'ºC'),
	(12419, 109, '2015-01-15 00:26:31.000000', 'temperatura', 963.0000, 'ºC'),
	(12420, 109, '2015-01-15 00:26:32.000000', 'temperatura', 381.0000, 'ºC'),
	(12421, 109, '2015-01-15 00:26:33.000000', 'temperatura', 219.0000, 'ºC'),
	(12422, 109, '2015-01-15 00:26:34.000000', 'temperatura', 1153.0000, 'ºC'),
	(12423, 109, '2015-01-15 00:26:35.000000', 'temperatura', 308.0000, 'ºC'),
	(12424, 109, '2015-01-15 00:26:36.000000', 'temperatura', 483.0000, 'ºC'),
	(12425, 109, '2015-01-15 00:26:37.000000', 'temperatura', 290.0000, 'ºC'),
	(12426, 109, '2015-01-15 00:26:38.000000', 'temperatura', 0.0000, 'ºC'),
	(12427, 109, '2015-01-15 00:26:39.000000', 'temperatura', 330.0000, 'ºC'),
	(12428, 109, '2015-01-15 00:26:40.000000', 'temperatura', 452.0000, 'ºC'),
	(12429, 109, '2015-01-15 00:26:41.000000', 'temperatura', 70.0000, 'ºC'),
	(12430, 109, '2015-01-15 00:26:42.000000', 'temperatura', 194.0000, 'ºC'),
	(12431, 109, '2015-01-15 00:26:43.000000', 'temperatura', 762.0000, 'ºC'),
	(12432, 109, '2015-01-15 00:26:44.000000', 'temperatura', 827.0000, 'ºC'),
	(12433, 109, '2015-01-15 00:26:45.000000', 'temperatura', 649.0000, 'ºC'),
	(12434, 109, '2015-01-15 00:26:46.000000', 'temperatura', 765.0000, 'ºC'),
	(12435, 109, '2015-01-15 00:26:47.000000', 'temperatura', 680.0000, 'ºC'),
	(12436, 109, '2015-01-15 00:26:48.000000', 'temperatura', 1105.0000, 'ºC'),
	(12437, 109, '2015-01-15 00:26:49.000000', 'temperatura', 1085.0000, 'ºC'),
	(12438, 109, '2015-01-15 00:26:50.000000', 'temperatura', 910.0000, 'ºC'),
	(12439, 109, '2015-01-15 00:26:51.000000', 'temperatura', 98.0000, 'ºC'),
	(12440, 109, '2015-01-15 00:26:52.000000', 'temperatura', 157.0000, 'ºC'),
	(12441, 109, '2015-01-15 00:26:53.000000', 'temperatura', 495.0000, 'ºC'),
	(12442, 109, '2015-01-15 00:26:54.000000', 'temperatura', 802.0000, 'ºC'),
	(12443, 109, '2015-01-15 00:26:55.000000', 'temperatura', 127.0000, 'ºC'),
	(12444, 109, '2015-01-15 00:26:56.000000', 'temperatura', 629.0000, 'ºC'),
	(12445, 109, '2015-01-15 00:26:57.000000', 'temperatura', 362.0000, 'ºC'),
	(12446, 109, '2015-01-15 00:26:58.000000', 'temperatura', 1127.0000, 'ºC'),
	(12447, 109, '2015-01-15 00:26:59.000000', 'temperatura', 949.0000, 'ºC'),
	(12448, 109, '2015-01-15 00:27:00.000000', 'temperatura', 166.0000, 'ºC'),
	(12449, 109, '2015-01-15 00:27:01.000000', 'temperatura', 381.0000, 'ºC'),
	(12450, 109, '2015-01-15 00:27:02.000000', 'temperatura', 209.0000, 'ºC'),
	(12451, 109, '2015-01-15 00:27:03.000000', 'temperatura', 1102.0000, 'ºC'),
	(12452, 109, '2015-01-15 00:27:04.000000', 'temperatura', 83.0000, 'ºC'),
	(12453, 109, '2015-01-15 00:27:05.000000', 'temperatura', 710.0000, 'ºC'),
	(12454, 109, '2015-01-15 00:27:06.000000', 'temperatura', 903.0000, 'ºC'),
	(12455, 109, '2015-01-15 00:27:07.000000', 'temperatura', 1186.0000, 'ºC'),
	(12456, 109, '2015-01-15 00:27:08.000000', 'temperatura', 821.0000, 'ºC'),
	(12457, 109, '2015-01-15 00:27:09.000000', 'temperatura', 547.0000, 'ºC'),
	(12458, 109, '2015-01-15 00:27:10.000000', 'temperatura', 274.0000, 'ºC'),
	(12459, 109, '2015-01-15 00:27:11.000000', 'temperatura', 929.0000, 'ºC'),
	(12460, 109, '2015-01-15 00:27:12.000000', 'temperatura', 221.0000, 'ºC'),
	(12461, 109, '2015-01-15 00:27:13.000000', 'temperatura', 720.0000, 'ºC'),
	(12462, 109, '2015-01-15 00:27:14.000000', 'temperatura', 538.0000, 'ºC'),
	(12463, 109, '2015-01-15 00:27:15.000000', 'temperatura', 528.0000, 'ºC'),
	(12464, 109, '2015-01-15 00:27:16.000000', 'temperatura', 1029.0000, 'ºC'),
	(12465, 109, '2015-01-15 00:27:17.000000', 'temperatura', 1160.0000, 'ºC'),
	(12466, 109, '2015-01-15 00:27:18.000000', 'temperatura', 313.0000, 'ºC'),
	(12467, 109, '2015-01-15 00:27:19.000000', 'temperatura', 486.0000, 'ºC'),
	(12468, 109, '2015-01-15 00:27:20.000000', 'temperatura', 291.0000, 'ºC'),
	(12469, 109, '2015-01-15 00:27:21.000000', 'temperatura', 1199.0000, 'ºC'),
	(12470, 109, '2015-01-15 00:27:22.000000', 'temperatura', 320.0000, 'ºC'),
	(12471, 109, '2015-01-15 00:27:23.000000', 'temperatura', 404.0000, 'ºC'),
	(12472, 109, '2015-01-15 00:27:24.000000', 'temperatura', 1063.0000, 'ºC'),
	(12473, 109, '2015-01-15 00:27:25.000000', 'temperatura', 500.0000, 'ºC'),
	(12474, 109, '2015-01-15 00:27:26.000000', 'temperatura', 514.0000, 'ºC'),
	(12475, 109, '2015-01-15 00:27:27.000000', 'temperatura', 1072.0000, 'ºC'),
	(12476, 109, '2015-01-15 00:27:28.000000', 'temperatura', 215.0000, 'ºC'),
	(12477, 109, '2015-01-15 00:27:29.000000', 'temperatura', 263.0000, 'ºC'),
	(12478, 109, '2015-01-15 00:27:30.000000', 'temperatura', 669.0000, 'ºC'),
	(12479, 109, '2015-01-15 00:27:31.000000', 'temperatura', 157.0000, 'ºC'),
	(12480, 109, '2015-01-15 00:27:32.000000', 'temperatura', 1177.0000, 'ºC'),
	(12481, 109, '2015-01-15 00:27:33.000000', 'temperatura', 614.0000, 'ºC'),
	(12482, 109, '2015-01-15 00:27:34.000000', 'temperatura', 739.0000, 'ºC'),
	(12483, 109, '2015-01-15 00:27:35.000000', 'temperatura', 655.0000, 'ºC'),
	(12484, 109, '2015-01-15 00:27:36.000000', 'temperatura', 1060.0000, 'ºC'),
	(12485, 109, '2015-01-15 00:27:37.000000', 'temperatura', 935.0000, 'ºC'),
	(12486, 109, '2015-01-15 00:27:38.000000', 'temperatura', 295.0000, 'ºC'),
	(12487, 109, '2015-01-15 00:27:39.000000', 'temperatura', 1069.0000, 'ºC'),
	(12488, 109, '2015-01-15 00:27:40.000000', 'temperatura', 863.0000, 'ºC'),
	(12489, 109, '2015-01-15 00:27:41.000000', 'temperatura', 1108.0000, 'ºC'),
	(12490, 109, '2015-01-15 00:27:42.000000', 'temperatura', 550.0000, 'ºC'),
	(12491, 109, '2015-01-15 00:27:43.000000', 'temperatura', 627.0000, 'ºC'),
	(12492, 109, '2015-01-15 00:27:44.000000', 'temperatura', 284.0000, 'ºC'),
	(12493, 109, '2015-01-15 00:27:45.000000', 'temperatura', 739.0000, 'ºC'),
	(12494, 109, '2015-01-15 00:27:46.000000', 'temperatura', 447.0000, 'ºC'),
	(12495, 109, '2015-01-15 00:27:47.000000', 'temperatura', 15.0000, 'ºC'),
	(12496, 109, '2015-01-15 00:27:48.000000', 'temperatura', 1135.0000, 'ºC'),
	(12497, 109, '2015-01-15 00:27:49.000000', 'temperatura', 832.0000, 'ºC'),
	(12498, 109, '2015-01-15 00:27:50.000000', 'temperatura', 755.0000, 'ºC'),
	(12499, 109, '2015-01-15 00:27:51.000000', 'temperatura', 79.0000, 'ºC'),
	(12500, 109, '2015-01-15 00:27:52.000000', 'temperatura', 532.0000, 'ºC'),
	(12501, 109, '2015-01-15 00:27:53.000000', 'temperatura', 24.0000, 'ºC'),
	(12502, 109, '2015-01-15 00:27:54.000000', 'temperatura', 924.0000, 'ºC'),
	(12503, 109, '2015-01-15 00:27:55.000000', 'temperatura', 947.0000, 'ºC'),
	(12504, 109, '2015-01-15 00:27:56.000000', 'temperatura', 763.0000, 'ºC'),
	(12505, 109, '2015-01-15 00:27:57.000000', 'temperatura', 976.0000, 'ºC'),
	(12506, 109, '2015-01-15 00:27:58.000000', 'temperatura', 193.0000, 'ºC'),
	(12507, 109, '2015-01-15 00:27:59.000000', 'temperatura', 436.0000, 'ºC'),
	(12508, 109, '2015-01-15 00:28:00.000000', 'temperatura', 401.0000, 'ºC'),
	(12509, 109, '2015-01-15 00:28:01.000000', 'temperatura', 696.0000, 'ºC'),
	(12510, 109, '2015-01-15 00:28:02.000000', 'temperatura', 1080.0000, 'ºC'),
	(12511, 109, '2015-01-15 00:28:03.000000', 'temperatura', 914.0000, 'ºC'),
	(12512, 109, '2015-01-15 00:28:04.000000', 'temperatura', 128.0000, 'ºC'),
	(12513, 109, '2015-01-15 00:28:05.000000', 'temperatura', 299.0000, 'ºC'),
	(12514, 109, '2015-01-15 00:28:06.000000', 'temperatura', 1109.0000, 'ºC'),
	(12515, 109, '2015-01-15 00:28:07.000000', 'temperatura', 1052.0000, 'ºC'),
	(12516, 109, '2015-01-15 00:28:08.000000', 'temperatura', 734.0000, 'ºC'),
	(12517, 109, '2015-01-15 00:28:09.000000', 'temperatura', 512.0000, 'ºC'),
	(12518, 109, '2015-01-15 00:28:10.000000', 'temperatura', 357.0000, 'ºC'),
	(12519, 109, '2015-01-15 00:28:11.000000', 'temperatura', 253.0000, 'ºC'),
	(12520, 109, '2015-01-15 00:28:12.000000', 'temperatura', 192.0000, 'ºC'),
	(12521, 109, '2015-01-15 00:28:13.000000', 'temperatura', 203.0000, 'ºC'),
	(12522, 109, '2015-01-15 00:28:14.000000', 'temperatura', 441.0000, 'ºC'),
	(12523, 109, '2015-01-15 00:28:15.000000', 'temperatura', 396.0000, 'ºC'),
	(12524, 109, '2015-01-15 00:28:16.000000', 'temperatura', 657.0000, 'ºC'),
	(12525, 109, '2015-01-15 00:28:17.000000', 'temperatura', 897.0000, 'ºC'),
	(12526, 109, '2015-01-15 00:28:18.000000', 'temperatura', 116.0000, 'ºC'),
	(12527, 109, '2015-01-15 00:28:19.000000', 'temperatura', 290.0000, 'ºC'),
	(12528, 109, '2015-01-15 00:28:20.000000', 'temperatura', 1100.0000, 'ºC'),
	(12529, 109, '2015-01-15 00:28:21.000000', 'temperatura', 1032.0000, 'ºC'),
	(12530, 109, '2015-01-15 00:28:22.000000', 'temperatura', 661.0000, 'ºC'),
	(12531, 109, '2015-01-15 00:28:23.000000', 'temperatura', 208.0000, 'ºC'),
	(12532, 109, '2015-01-15 00:28:24.000000', 'temperatura', 257.0000, 'ºC'),
	(12533, 109, '2015-01-15 00:28:25.000000', 'temperatura', 664.0000, 'ºC'),
	(12534, 109, '2015-01-15 00:28:26.000000', 'temperatura', 148.0000, 'ºC'),
	(12535, 109, '2015-01-15 00:28:27.000000', 'temperatura', 1149.0000, 'ºC'),
	(12536, 109, '2015-01-15 00:28:28.000000', 'temperatura', 502.0000, 'ºC'),
	(12537, 109, '2015-01-15 00:28:29.000000', 'temperatura', 263.0000, 'ºC'),
	(12538, 109, '2015-01-15 00:28:30.000000', 'temperatura', 1009.0000, 'ºC'),
	(12539, 109, '2015-01-15 00:28:31.000000', 'temperatura', 655.0000, 'ºC'),
	(12540, 109, '2015-01-15 00:28:32.000000', 'temperatura', 251.0000, 'ºC'),
	(12541, 109, '2015-01-15 00:28:33.000000', 'temperatura', 488.0000, 'ºC'),
	(12542, 109, '2015-01-15 00:28:34.000000', 'temperatura', 488.0000, 'ºC'),
	(12543, 109, '2015-01-15 00:28:35.000000', 'temperatura', 977.0000, 'ºC'),
	(12544, 109, '2015-01-15 00:28:36.000000', 'temperatura', 1023.0000, 'ºC'),
	(12545, 109, '2015-01-15 00:28:37.000000', 'temperatura', 982.0000, 'ºC'),
	(12546, 109, '2015-01-15 00:28:38.000000', 'temperatura', 643.0000, 'ºC'),
	(12547, 109, '2015-01-15 00:28:39.000000', 'temperatura', 268.0000, 'ºC'),
	(12548, 109, '2015-01-15 00:28:40.000000', 'temperatura', 611.0000, 'ºC'),
	(12549, 109, '2015-01-15 00:28:41.000000', 'temperatura', 1052.0000, 'ºC'),
	(12550, 109, '2015-01-15 00:28:42.000000', 'temperatura', 1028.0000, 'ºC'),
	(12551, 109, '2015-01-15 00:28:43.000000', 'temperatura', 784.0000, 'ºC'),
	(12552, 109, '2015-01-15 00:28:44.000000', 'temperatura', 838.0000, 'ºC'),
	(12553, 109, '2015-01-15 00:28:45.000000', 'temperatura', 639.0000, 'ºC'),
	(12554, 109, '2015-01-15 00:28:46.000000', 'temperatura', 681.0000, 'ºC'),
	(12555, 109, '2015-01-15 00:28:47.000000', 'temperatura', 288.0000, 'ºC'),
	(12556, 109, '2015-01-15 00:28:48.000000', 'temperatura', 599.0000, 'ºC'),
	(12557, 109, '2015-01-15 00:28:49.000000', 'temperatura', 929.0000, 'ºC'),
	(12558, 109, '2015-01-15 00:28:50.000000', 'temperatura', 450.0000, 'ºC'),
	(12559, 109, '2015-01-15 00:28:51.000000', 'temperatura', 661.0000, 'ºC'),
	(12560, 109, '2015-01-15 00:28:52.000000', 'temperatura', 759.0000, 'ºC'),
	(12561, 109, '2015-01-15 00:28:53.000000', 'temperatura', 610.0000, 'ºC'),
	(12562, 109, '2015-01-15 00:28:54.000000', 'temperatura', 774.0000, 'ºC'),
	(12563, 109, '2015-01-15 00:28:55.000000', 'temperatura', 840.0000, 'ºC'),
	(12564, 109, '2015-01-15 00:28:56.000000', 'temperatura', 677.0000, 'ºC'),
	(12565, 109, '2015-01-15 00:28:57.000000', 'temperatura', 869.0000, 'ºC'),
	(12566, 109, '2015-01-15 00:28:58.000000', 'temperatura', 1112.0000, 'ºC'),
	(12567, 109, '2015-01-15 00:28:59.000000', 'temperatura', 555.0000, 'ºC'),
	(12568, 109, '2015-01-15 00:29:00.000000', 'temperatura', 638.0000, 'ºC'),
	(12569, 109, '2015-01-15 00:29:01.000000', 'temperatura', 324.0000, 'ºC'),
	(12570, 109, '2015-01-15 00:29:02.000000', 'temperatura', 909.0000, 'ºC'),
	(12571, 109, '2015-01-15 00:29:03.000000', 'temperatura', 1174.0000, 'ºC'),
	(12572, 109, '2015-01-15 00:29:04.000000', 'temperatura', 742.0000, 'ºC'),
	(12573, 109, '2015-01-15 00:29:05.000000', 'temperatura', 190.0000, 'ºC'),
	(12574, 109, '2015-01-15 00:29:06.000000', 'temperatura', 1125.0000, 'ºC'),
	(12575, 109, '2015-01-15 00:29:07.000000', 'temperatura', 256.0000, 'ºC'),
	(12576, 109, '2015-01-15 00:29:08.000000', 'temperatura', 305.0000, 'ºC'),
	(12577, 109, '2015-01-15 00:29:09.000000', 'temperatura', 756.0000, 'ºC'),
	(12578, 109, '2015-01-15 00:29:10.000000', 'temperatura', 465.0000, 'ºC'),
	(12579, 109, '2015-01-15 00:29:11.000000', 'temperatura', 57.0000, 'ºC'),
	(12580, 109, '2015-01-15 00:29:12.000000', 'temperatura', 93.0000, 'ºC'),
	(12581, 109, '2015-01-15 00:29:13.000000', 'temperatura', 292.0000, 'ºC'),
	(12582, 109, '2015-01-15 00:29:14.000000', 'temperatura', 1181.0000, 'ºC'),
	(12583, 109, '2015-01-15 00:29:15.000000', 'temperatura', 232.0000, 'ºC'),
	(12584, 109, '2015-01-15 00:29:16.000000', 'temperatura', 16.0000, 'ºC'),
	(12585, 109, '2015-01-15 00:29:17.000000', 'temperatura', 583.0000, 'ºC'),
	(12586, 109, '2015-01-15 00:29:18.000000', 'temperatura', 470.0000, 'ºC'),
	(12587, 109, '2015-01-15 00:29:19.000000', 'temperatura', 602.0000, 'ºC'),
	(12588, 109, '2015-01-15 00:29:20.000000', 'temperatura', 399.0000, 'ºC'),
	(12589, 109, '2015-01-15 00:29:21.000000', 'temperatura', 192.0000, 'ºC'),
	(12590, 109, '2015-01-15 00:29:22.000000', 'temperatura', 962.0000, 'ºC'),
	(12591, 109, '2015-01-15 00:29:23.000000', 'temperatura', 635.0000, 'ºC'),
	(12592, 109, '2015-01-15 00:29:24.000000', 'temperatura', 288.0000, 'ºC'),
	(12593, 109, '2015-01-15 00:29:25.000000', 'temperatura', 737.0000, 'ºC'),
	(12594, 109, '2015-01-15 00:29:26.000000', 'temperatura', 423.0000, 'ºC'),
	(12595, 109, '2015-01-15 00:29:27.000000', 'temperatura', 1103.0000, 'ºC'),
	(12596, 109, '2015-01-15 00:29:28.000000', 'temperatura', 644.0000, 'ºC'),
	(12597, 109, '2015-01-15 00:29:29.000000', 'temperatura', 1115.0000, 'ºC'),
	(12598, 109, '2015-01-15 00:29:30.000000', 'temperatura', 44.0000, 'ºC'),
	(12599, 109, '2015-01-15 00:29:31.000000', 'temperatura', 475.0000, 'ºC'),
	(12600, 109, '2015-01-15 00:29:32.000000', 'temperatura', 1043.0000, 'ºC'),
	(12601, 109, '2015-01-15 00:29:33.000000', 'temperatura', 189.0000, 'ºC'),
	(12602, 109, '2015-01-15 00:29:34.000000', 'temperatura', 216.0000, 'ºC'),
	(12603, 109, '2015-01-15 00:29:35.000000', 'temperatura', 515.0000, 'ºC'),
	(12604, 109, '2015-01-15 00:29:36.000000', 'temperatura', 727.0000, 'ºC'),
	(12605, 109, '2015-01-15 00:29:37.000000', 'temperatura', 889.0000, 'ºC'),
	(12606, 109, '2015-01-15 00:29:38.000000', 'temperatura', 1067.0000, 'ºC'),
	(12607, 109, '2015-01-15 00:29:39.000000', 'temperatura', 266.0000, 'ºC'),
	(12608, 109, '2015-01-15 00:29:40.000000', 'temperatura', 532.0000, 'ºC'),
	(12609, 109, '2015-01-15 00:29:41.000000', 'temperatura', 660.0000, 'ºC'),
	(12610, 109, '2015-01-15 00:29:42.000000', 'temperatura', 506.0000, 'ºC'),
	(12611, 109, '2015-01-15 00:29:43.000000', 'temperatura', 552.0000, 'ºC'),
	(12612, 109, '2015-01-15 00:29:44.000000', 'temperatura', 40.0000, 'ºC'),
	(12613, 109, '2015-01-15 00:29:45.000000', 'temperatura', 946.0000, 'ºC'),
	(12614, 109, '2015-01-15 00:29:46.000000', 'temperatura', 1012.0000, 'ºC'),
	(12615, 109, '2015-01-15 00:29:47.000000', 'temperatura', 1019.0000, 'ºC'),
	(12616, 109, '2015-01-15 00:29:48.000000', 'temperatura', 862.0000, 'ºC'),
	(12617, 109, '2015-01-15 00:29:49.000000', 'temperatura', 52.0000, 'ºC'),
	(12618, 109, '2015-01-15 00:29:50.000000', 'temperatura', 77.0000, 'ºC'),
	(12619, 109, '2015-01-15 00:29:51.000000', 'temperatura', 226.0000, 'ºC'),
	(12620, 109, '2015-01-15 00:29:52.000000', 'temperatura', 902.0000, 'ºC'),
	(12621, 109, '2015-01-15 00:29:53.000000', 'temperatura', 231.0000, 'ºC'),
	(12622, 109, '2015-01-15 00:29:54.000000', 'temperatura', 852.0000, 'ºC'),
	(12623, 109, '2015-01-15 00:29:55.000000', 'temperatura', 1166.0000, 'ºC'),
	(12624, 109, '2015-01-15 00:29:56.000000', 'temperatura', 874.0000, 'ºC'),
	(12625, 109, '2015-01-15 00:29:57.000000', 'temperatura', 875.0000, 'ºC'),
	(12626, 109, '2015-01-15 00:29:58.000000', 'temperatura', 552.0000, 'ºC'),
	(12627, 109, '2015-01-15 00:29:59.000000', 'temperatura', 136.0000, 'ºC'),
	(12628, 109, '2015-01-15 00:30:00.000000', 'temperatura', 224.0000, 'ºC'),
	(12629, 109, '2015-01-15 00:30:01.000000', 'temperatura', 714.0000, 'ºC'),
	(12630, 109, '2015-01-15 00:30:02.000000', 'temperatura', 498.0000, 'ºC'),
	(12631, 109, '2015-01-15 00:30:03.000000', 'temperatura', 347.0000, 'ºC'),
	(12632, 109, '2015-01-15 00:30:04.000000', 'temperatura', 241.0000, 'ºC'),
	(12633, 109, '2015-01-15 00:30:05.000000', 'temperatura', 166.0000, 'ºC'),
	(12634, 109, '2015-01-15 00:30:06.000000', 'temperatura', 105.0000, 'ºC'),
	(12635, 109, '2015-01-15 00:30:07.000000', 'temperatura', 31.0000, 'ºC'),
	(12636, 109, '2015-01-15 00:30:08.000000', 'temperatura', 1039.0000, 'ºC'),
	(12637, 109, '2015-01-15 00:30:09.000000', 'temperatura', 303.0000, 'ºC'),
	(12638, 109, '2015-01-15 00:30:10.000000', 'temperatura', 797.0000, 'ºC'),
	(12639, 109, '2015-01-15 00:30:11.000000', 'temperatura', 675.0000, 'ºC'),
	(12640, 109, '2015-01-15 00:30:12.000000', 'temperatura', 987.0000, 'ºC'),
	(12641, 109, '2015-01-15 00:30:13.000000', 'temperatura', 511.0000, 'ºC'),
	(12642, 109, '2015-01-15 00:30:14.000000', 'temperatura', 795.0000, 'ºC'),
	(12643, 109, '2015-01-15 00:30:15.000000', 'temperatura', 41.0000, 'ºC'),
	(12644, 109, '2015-01-15 00:30:16.000000', 'temperatura', 222.0000, 'ºC'),
	(12645, 109, '2015-01-15 00:30:17.000000', 'temperatura', 986.0000, 'ºC'),
	(12646, 109, '2015-01-15 00:30:18.000000', 'temperatura', 664.0000, 'ºC'),
	(12647, 109, '2015-01-15 00:30:19.000000', 'temperatura', 362.0000, 'ºC'),
	(12648, 109, '2015-01-15 00:30:20.000000', 'temperatura', 1018.0000, 'ºC'),
	(12649, 109, '2015-01-15 00:30:21.000000', 'temperatura', 403.0000, 'ºC'),
	(12650, 109, '2015-01-15 00:30:22.000000', 'temperatura', 165.0000, 'ºC'),
	(12651, 109, '2015-01-15 00:30:23.000000', 'temperatura', 816.0000, 'ºC'),
	(12652, 109, '2015-01-15 00:30:24.000000', 'temperatura', 1187.0000, 'ºC'),
	(12653, 109, '2015-01-15 00:30:25.000000', 'temperatura', 1084.0000, 'ºC'),
	(12654, 109, '2015-01-15 00:30:26.000000', 'temperatura', 661.0000, 'ºC'),
	(12655, 109, '2015-01-15 00:30:27.000000', 'temperatura', 54.0000, 'ºC'),
	(12656, 109, '2015-01-15 00:30:28.000000', 'temperatura', 687.0000, 'ºC'),
	(12657, 109, '2015-01-15 00:30:29.000000', 'temperatura', 871.0000, 'ºC'),
	(12658, 109, '2015-01-15 00:30:30.000000', 'temperatura', 1098.0000, 'ºC'),
	(12659, 109, '2015-01-15 00:30:31.000000', 'temperatura', 478.0000, 'ºC'),
	(12660, 109, '2015-01-15 00:30:32.000000', 'temperatura', 296.0000, 'ºC'),
	(12661, 109, '2015-01-15 00:30:33.000000', 'temperatura', 48.0000, 'ºC'),
	(12662, 109, '2015-01-15 00:30:34.000000', 'temperatura', 550.0000, 'ºC'),
	(12663, 109, '2015-01-15 00:30:35.000000', 'temperatura', 207.0000, 'ºC'),
	(12664, 109, '2015-01-15 00:30:36.000000', 'temperatura', 586.0000, 'ºC'),
	(12665, 109, '2015-01-15 00:30:37.000000', 'temperatura', 1110.0000, 'ºC'),
	(12666, 109, '2015-01-15 00:30:38.000000', 'temperatura', 191.0000, 'ºC'),
	(12667, 109, '2015-01-15 00:30:39.000000', 'temperatura', 25.0000, 'ºC'),
	(12668, 109, '2015-01-15 00:30:40.000000', 'temperatura', 753.0000, 'ºC'),
	(12669, 109, '2015-01-15 00:30:41.000000', 'temperatura', 92.0000, 'ºC'),
	(12670, 109, '2015-01-15 00:30:42.000000', 'temperatura', 600.0000, 'ºC'),
	(12671, 109, '2015-01-15 00:30:43.000000', 'temperatura', 327.0000, 'ºC'),
	(12672, 109, '2015-01-15 00:30:44.000000', 'temperatura', 1033.0000, 'ºC'),
	(12673, 109, '2015-01-15 00:30:45.000000', 'temperatura', 587.0000, 'ºC'),
	(12674, 109, '2015-01-15 00:30:46.000000', 'temperatura', 1036.0000, 'ºC'),
	(12675, 109, '2015-01-15 00:30:47.000000', 'temperatura', 1018.0000, 'ºC'),
	(12676, 109, '2015-01-15 00:30:48.000000', 'temperatura', 782.0000, 'ºC'),
	(12677, 109, '2015-01-15 00:30:49.000000', 'temperatura', 858.0000, 'ºC'),
	(12678, 109, '2015-01-15 00:30:50.000000', 'temperatura', 746.0000, 'ºC'),
	(12679, 109, '2015-01-15 00:30:51.000000', 'temperatura', 1155.0000, 'ºC'),
	(12680, 109, '2015-01-15 00:30:52.000000', 'temperatura', 1136.0000, 'ºC'),
	(12681, 109, '2015-01-15 00:30:53.000000', 'temperatura', 1019.0000, 'ºC'),
	(12682, 109, '2015-01-15 00:30:54.000000', 'temperatura', 484.0000, 'ºC'),
	(12683, 109, '2015-01-15 00:30:55.000000', 'temperatura', 564.0000, 'ºC'),
	(12684, 109, '2015-01-15 00:30:56.000000', 'temperatura', 169.0000, 'ºC'),
	(12685, 109, '2015-01-15 00:30:57.000000', 'temperatura', 352.0000, 'ºC'),
	(12686, 109, '2015-01-15 00:30:58.000000', 'temperatura', 57.0000, 'ºC'),
	(12687, 109, '2015-01-15 00:30:59.000000', 'temperatura', 426.0000, 'ºC'),
	(12688, 109, '2015-01-15 00:31:00.000000', 'temperatura', 762.0000, 'ºC'),
	(12689, 109, '2015-01-15 00:31:01.000000', 'temperatura', 133.0000, 'ºC'),
	(12690, 109, '2015-01-15 00:31:02.000000', 'temperatura', 780.0000, 'ºC'),
	(12691, 109, '2015-01-15 00:31:03.000000', 'temperatura', 1102.0000, 'ºC'),
	(12692, 109, '2015-01-15 00:31:04.000000', 'temperatura', 771.0000, 'ºC'),
	(12693, 109, '2015-01-15 00:31:05.000000', 'temperatura', 549.0000, 'ºC'),
	(12694, 109, '2015-01-15 00:31:06.000000', 'temperatura', 432.0000, 'ºC'),
	(12695, 109, '2015-01-15 00:31:07.000000', 'temperatura', 512.0000, 'ºC'),
	(12696, 109, '2015-01-15 00:31:08.000000', 'temperatura', 66.0000, 'ºC'),
	(12697, 109, '2015-01-15 00:31:09.000000', 'temperatura', 1195.0000, 'ºC'),
	(12698, 109, '2015-01-15 00:31:10.000000', 'temperatura', 976.0000, 'ºC'),
	(12699, 109, '2015-01-15 00:31:11.000000', 'temperatura', 96.0000, 'ºC'),
	(12700, 109, '2015-01-15 00:31:12.000000', 'temperatura', 1154.0000, 'ºC'),
	(12701, 109, '2015-01-15 00:31:13.000000', 'temperatura', 680.0000, 'ºC'),
	(12702, 109, '2015-01-15 00:31:14.000000', 'temperatura', 1141.0000, 'ºC'),
	(12703, 109, '2015-01-15 00:31:15.000000', 'temperatura', 67.0000, 'ºC'),
	(12704, 109, '2015-01-15 00:31:16.000000', 'temperatura', 509.0000, 'ºC'),
	(12705, 109, '2015-01-15 00:31:17.000000', 'temperatura', 1145.0000, 'ºC'),
	(12706, 109, '2015-01-15 00:31:18.000000', 'temperatura', 599.0000, 'ºC'),
	(12707, 109, '2015-01-15 00:31:19.000000', 'temperatura', 761.0000, 'ºC'),
	(12708, 109, '2015-01-15 00:31:20.000000', 'temperatura', 807.0000, 'ºC'),
	(12709, 109, '2015-01-15 00:31:21.000000', 'temperatura', 555.0000, 'ºC'),
	(12710, 109, '2015-01-15 00:31:22.000000', 'temperatura', 352.0000, 'ºC'),
	(12711, 109, '2015-01-15 00:31:23.000000', 'temperatura', 95.0000, 'ºC'),
	(12712, 109, '2015-01-15 00:31:24.000000', 'temperatura', 621.0000, 'ºC'),
	(12713, 109, '2015-01-15 00:31:25.000000', 'temperatura', 422.0000, 'ºC'),
	(12714, 109, '2015-01-15 00:31:26.000000', 'temperatura', 245.0000, 'ºC'),
	(12715, 109, '2015-01-15 00:31:27.000000', 'temperatura', 1160.0000, 'ºC'),
	(12716, 109, '2015-01-15 00:31:28.000000', 'temperatura', 266.0000, 'ºC'),
	(12717, 109, '2015-01-15 00:31:29.000000', 'temperatura', 249.0000, 'ºC'),
	(12718, 109, '2015-01-15 00:31:30.000000', 'temperatura', 450.0000, 'ºC'),
	(12719, 109, '2015-01-15 00:31:31.000000', 'temperatura', 302.0000, 'ºC'),
	(12720, 109, '2015-01-15 00:31:32.000000', 'temperatura', 159.0000, 'ºC'),
	(12721, 109, '2015-01-15 00:31:33.000000', 'temperatura', 1093.0000, 'ºC'),
	(12722, 109, '2015-01-15 00:31:34.000000', 'temperatura', 185.0000, 'ºC'),
	(12723, 109, '2015-01-15 00:31:35.000000', 'temperatura', 48.0000, 'ºC'),
	(12724, 109, '2015-01-15 00:31:36.000000', 'temperatura', 883.0000, 'ºC'),
	(12725, 109, '2015-01-15 00:31:37.000000', 'temperatura', 675.0000, 'ºC'),
	(12726, 109, '2015-01-15 00:31:38.000000', 'temperatura', 726.0000, 'ºC'),
	(12727, 109, '2015-01-15 00:31:39.000000', 'temperatura', 403.0000, 'ºC'),
	(12728, 109, '2015-01-15 00:31:40.000000', 'temperatura', 1040.0000, 'ºC'),
	(12729, 109, '2015-01-15 00:31:41.000000', 'temperatura', 391.0000, 'ºC'),
	(12730, 109, '2015-01-15 00:31:42.000000', 'temperatura', 34.0000, 'ºC'),
	(12731, 109, '2015-01-15 00:31:43.000000', 'temperatura', 197.0000, 'ºC'),
	(12732, 109, '2015-01-15 00:31:44.000000', 'temperatura', 885.0000, 'ºC'),
	(12733, 109, '2015-01-15 00:31:45.000000', 'temperatura', 236.0000, 'ºC'),
	(12734, 109, '2015-01-15 00:31:46.000000', 'temperatura', 924.0000, 'ºC'),
	(12735, 109, '2015-01-15 00:31:47.000000', 'temperatura', 312.0000, 'ºC'),
	(12736, 109, '2015-01-15 00:31:48.000000', 'temperatura', 1188.0000, 'ºC'),
	(12737, 109, '2015-01-15 00:31:49.000000', 'temperatura', 206.0000, 'ºC'),
	(12738, 109, '2015-01-15 00:31:50.000000', 'temperatura', 1067.0000, 'ºC'),
	(12739, 109, '2015-01-15 00:31:51.000000', 'temperatura', 1115.0000, 'ºC'),
	(12740, 109, '2015-01-15 00:31:52.000000', 'temperatura', 1178.0000, 'ºC'),
	(12741, 109, '2015-01-15 00:31:53.000000', 'temperatura', 142.0000, 'ºC'),
	(12742, 109, '2015-01-15 00:31:54.000000', 'temperatura', 777.0000, 'ºC'),
	(12743, 109, '2015-01-15 00:31:55.000000', 'temperatura', 1059.0000, 'ºC'),
	(12744, 109, '2015-01-15 00:31:56.000000', 'temperatura', 567.0000, 'ºC'),
	(12745, 109, '2015-01-15 00:31:57.000000', 'temperatura', 858.0000, 'ºC'),
	(12746, 109, '2015-01-15 00:31:58.000000', 'temperatura', 188.0000, 'ºC'),
	(12747, 109, '2015-01-15 00:31:59.000000', 'temperatura', 766.0000, 'ºC'),
	(12748, 109, '2015-01-15 00:32:00.000000', 'temperatura', 867.0000, 'ºC'),
	(12749, 109, '2015-01-15 00:32:01.000000', 'temperatura', 836.0000, 'ºC'),
	(12750, 109, '2015-01-15 00:32:02.000000', 'temperatura', 383.0000, 'ºC'),
	(12751, 109, '2015-01-15 00:32:03.000000', 'temperatura', 604.0000, 'ºC'),
	(12752, 109, '2015-01-15 00:32:04.000000', 'temperatura', 673.0000, 'ºC'),
	(12753, 109, '2015-01-15 00:32:05.000000', 'temperatura', 352.0000, 'ºC'),
	(12754, 109, '2015-01-15 00:32:06.000000', 'temperatura', 943.0000, 'ºC'),
	(12755, 109, '2015-01-15 00:32:07.000000', 'temperatura', 57.0000, 'ºC'),
	(12756, 109, '2015-01-15 00:32:08.000000', 'temperatura', 1058.0000, 'ºC'),
	(12757, 109, '2015-01-15 00:32:09.000000', 'temperatura', 321.0000, 'ºC'),
	(12758, 109, '2015-01-15 00:32:10.000000', 'temperatura', 832.0000, 'ºC'),
	(12759, 109, '2015-01-15 00:32:11.000000', 'temperatura', 795.0000, 'ºC'),
	(12760, 109, '2015-01-15 00:32:12.000000', 'temperatura', 278.0000, 'ºC'),
	(12761, 109, '2015-01-15 00:32:13.000000', 'temperatura', 209.0000, 'ºC'),
	(12762, 109, '2015-01-15 00:32:14.000000', 'temperatura', 209.0000, 'ºC'),
	(12763, 109, '2015-01-15 00:32:15.000000', 'temperatura', 420.0000, 'ºC'),
	(12764, 109, '2015-01-15 00:32:16.000000', 'temperatura', 275.0000, 'ºC'),
	(12765, 109, '2015-01-15 00:32:17.000000', 'temperatura', 114.0000, 'ºC'),
	(12766, 109, '2015-01-15 00:32:18.000000', 'temperatura', 946.0000, 'ºC'),
	(12767, 109, '2015-01-15 00:32:19.000000', 'temperatura', 787.0000, 'ºC'),
	(12768, 109, '2015-01-15 00:32:20.000000', 'temperatura', 1101.0000, 'ºC'),
	(12769, 109, '2015-01-15 00:32:21.000000', 'temperatura', 741.0000, 'ºC'),
	(12770, 109, '2015-01-15 00:32:22.000000', 'temperatura', 402.0000, 'ºC'),
	(12771, 109, '2015-01-15 00:32:23.000000', 'temperatura', 987.0000, 'ºC'),
	(12772, 109, '2015-01-15 00:32:24.000000', 'temperatura', 131.0000, 'ºC'),
	(12773, 109, '2015-01-15 00:32:25.000000', 'temperatura', 95.0000, 'ºC'),
	(12774, 109, '2015-01-15 00:32:26.000000', 'temperatura', 82.0000, 'ºC'),
	(12775, 109, '2015-01-15 00:32:27.000000', 'temperatura', 127.0000, 'ºC'),
	(12776, 109, '2015-01-15 00:32:28.000000', 'temperatura', 389.0000, 'ºC'),
	(12777, 109, '2015-01-15 00:32:29.000000', 'temperatura', 365.0000, 'ºC'),
	(12778, 109, '2015-01-15 00:32:30.000000', 'temperatura', 656.0000, 'ºC'),
	(12779, 109, '2015-01-15 00:32:31.000000', 'temperatura', 988.0000, 'ºC'),
	(12780, 109, '2015-01-15 00:32:32.000000', 'temperatura', 571.0000, 'ºC'),
	(12781, 109, '2015-01-15 00:32:33.000000', 'temperatura', 1091.0000, 'ºC'),
	(12782, 109, '2015-01-15 00:32:34.000000', 'temperatura', 143.0000, 'ºC'),
	(12783, 109, '2015-01-15 00:32:35.000000', 'temperatura', 1043.0000, 'ºC'),
	(12784, 109, '2015-01-15 00:32:36.000000', 'temperatura', 1187.0000, 'ºC'),
	(12785, 109, '2015-01-15 00:32:37.000000', 'temperatura', 405.0000, 'ºC'),
	(12786, 109, '2015-01-15 00:32:38.000000', 'temperatura', 864.0000, 'ºC'),
	(12787, 109, '2015-01-15 00:32:39.000000', 'temperatura', 705.0000, 'ºC'),
	(12788, 109, '2015-01-15 00:32:40.000000', 'temperatura', 934.0000, 'ºC'),
	(12789, 109, '2015-01-15 00:32:41.000000', 'temperatura', 154.0000, 'ºC'),
	(12790, 109, '2015-01-15 00:32:42.000000', 'temperatura', 368.0000, 'ºC'),
	(12791, 109, '2015-01-15 00:32:43.000000', 'temperatura', 182.0000, 'ºC'),
	(12792, 109, '2015-01-15 00:32:44.000000', 'temperatura', 1004.0000, 'ºC'),
	(12793, 109, '2015-01-15 00:32:45.000000', 'temperatura', 875.0000, 'ºC'),
	(12794, 109, '2015-01-15 00:32:46.000000', 'temperatura', 162.0000, 'ºC'),
	(12795, 109, '2015-01-15 00:32:47.000000', 'temperatura', 586.0000, 'ºC'),
	(12796, 109, '2015-01-15 00:32:48.000000', 'temperatura', 44.0000, 'ºC'),
	(12797, 109, '2015-01-15 00:32:49.000000', 'temperatura', 863.0000, 'ºC'),
	(12798, 109, '2015-01-15 00:32:50.000000', 'temperatura', 582.0000, 'ºC'),
	(12799, 109, '2015-01-15 00:32:51.000000', 'temperatura', 323.0000, 'ºC'),
	(12800, 109, '2015-01-15 00:32:52.000000', 'temperatura', 1071.0000, 'ºC'),
	(12801, 109, '2015-01-15 00:32:53.000000', 'temperatura', 784.0000, 'ºC'),
	(12802, 109, '2015-01-15 00:32:54.000000', 'temperatura', 708.0000, 'ºC'),
	(12803, 109, '2015-01-15 00:32:55.000000', 'temperatura', 1189.0000, 'ºC'),
	(12804, 109, '2015-01-15 00:32:56.000000', 'temperatura', 220.0000, 'ºC'),
	(12805, 109, '2015-01-15 00:32:57.000000', 'temperatura', 1133.0000, 'ºC'),
	(12806, 109, '2015-01-15 00:32:58.000000', 'temperatura', 208.0000, 'ºC'),
	(12807, 109, '2015-01-15 00:32:59.000000', 'temperatura', 39.0000, 'ºC'),
	(12808, 109, '2015-01-15 00:33:00.000000', 'temperatura', 771.0000, 'ºC'),
	(12809, 109, '2015-01-15 00:33:01.000000', 'temperatura', 141.0000, 'ºC'),
	(12810, 109, '2015-01-15 00:33:02.000000', 'temperatura', 790.0000, 'ºC'),
	(12811, 109, '2015-01-15 00:33:03.000000', 'temperatura', 1129.0000, 'ºC'),
	(12812, 109, '2015-01-15 00:33:04.000000', 'temperatura', 875.0000, 'ºC'),
	(12813, 109, '2015-01-15 00:33:05.000000', 'temperatura', 989.0000, 'ºC'),
	(12814, 109, '2015-01-15 00:33:06.000000', 'temperatura', 1118.0000, 'ºC'),
	(12815, 109, '2015-01-15 00:33:07.000000', 'temperatura', 226.0000, 'ºC'),
	(12816, 109, '2015-01-15 00:33:08.000000', 'temperatura', 178.0000, 'ºC'),
	(12817, 109, '2015-01-15 00:33:09.000000', 'temperatura', 209.0000, 'ºC'),
	(12818, 109, '2015-01-15 00:33:10.000000', 'temperatura', 513.0000, 'ºC'),
	(12819, 109, '2015-01-15 00:33:11.000000', 'temperatura', 738.0000, 'ºC'),
	(12820, 109, '2015-01-15 00:33:12.000000', 'temperatura', 953.0000, 'ºC'),
	(12821, 109, '2015-01-15 00:33:13.000000', 'temperatura', 152.0000, 'ºC'),
	(12822, 109, '2015-01-15 00:33:14.000000', 'temperatura', 301.0000, 'ºC'),
	(12823, 109, '2015-01-15 00:33:15.000000', 'temperatura', 1047.0000, 'ºC'),
	(12824, 109, '2015-01-15 00:33:16.000000', 'temperatura', 734.0000, 'ºC'),
	(12825, 109, '2015-01-15 00:33:17.000000', 'temperatura', 532.0000, 'ºC'),
	(12826, 109, '2015-01-15 00:33:18.000000', 'temperatura', 455.0000, 'ºC'),
	(12827, 109, '2015-01-15 00:33:19.000000', 'temperatura', 681.0000, 'ºC'),
	(12828, 109, '2015-01-15 00:33:20.000000', 'temperatura', 841.0000, 'ºC'),
	(12829, 109, '2015-01-15 00:33:21.000000', 'temperatura', 964.0000, 'ºC'),
	(12830, 109, '2015-01-15 00:33:22.000000', 'temperatura', 1094.0000, 'ºC'),
	(12831, 109, '2015-01-15 00:33:23.000000', 'temperatura', 181.0000, 'ºC'),
	(12832, 109, '2015-01-15 00:33:24.000000', 'temperatura', 24.0000, 'ºC'),
	(12833, 109, '2015-01-15 00:33:25.000000', 'temperatura', 776.0000, 'ºC'),
	(12834, 109, '2015-01-15 00:33:26.000000', 'temperatura', 207.0000, 'ºC'),
	(12835, 109, '2015-01-15 00:33:27.000000', 'temperatura', 1110.0000, 'ºC'),
	(12836, 109, '2015-01-15 00:33:28.000000', 'temperatura', 127.0000, 'ºC'),
	(12837, 109, '2015-01-15 00:33:29.000000', 'temperatura', 905.0000, 'ºC'),
	(12838, 109, '2015-01-15 00:33:30.000000', 'temperatura', 548.0000, 'ºC'),
	(12839, 109, '2015-01-15 00:33:31.000000', 'temperatura', 23.0000, 'ºC'),
	(12840, 109, '2015-01-15 00:33:32.000000', 'temperatura', 872.0000, 'ºC'),
	(12841, 109, '2015-01-15 00:33:33.000000', 'temperatura', 690.0000, 'ºC'),
	(12842, 109, '2015-01-15 00:33:34.000000', 'temperatura', 835.0000, 'ºC'),
	(12843, 109, '2015-01-15 00:33:35.000000', 'temperatura', 907.0000, 'ºC'),
	(12844, 109, '2015-01-15 00:33:36.000000', 'temperatura', 829.0000, 'ºC'),
	(12845, 109, '2015-01-15 00:33:37.000000', 'temperatura', 226.0000, 'ºC'),
	(12846, 109, '2015-01-15 00:33:38.000000', 'temperatura', 1043.0000, 'ºC'),
	(12847, 109, '2015-01-15 00:33:39.000000', 'temperatura', 938.0000, 'ºC'),
	(12848, 109, '2015-01-15 00:33:40.000000', 'temperatura', 361.0000, 'ºC'),
	(12849, 109, '2015-01-15 00:33:41.000000', 'temperatura', 190.0000, 'ºC'),
	(12850, 109, '2015-01-15 00:33:42.000000', 'temperatura', 1070.0000, 'ºC'),
	(12851, 109, '2015-01-15 00:33:43.000000', 'temperatura', 1180.0000, 'ºC'),
	(12852, 109, '2015-01-15 00:33:44.000000', 'temperatura', 290.0000, 'ºC'),
	(12853, 109, '2015-01-15 00:33:45.000000', 'temperatura', 311.0000, 'ºC'),
	(12854, 109, '2015-01-15 00:33:46.000000', 'temperatura', 687.0000, 'ºC'),
	(12855, 109, '2015-01-15 00:33:47.000000', 'temperatura', 100.0000, 'ºC'),
	(12856, 109, '2015-01-15 00:33:48.000000', 'temperatura', 838.0000, 'ºC'),
	(12857, 109, '2015-01-15 00:33:49.000000', 'temperatura', 294.0000, 'ºC'),
	(12858, 109, '2015-01-15 00:33:50.000000', 'temperatura', 156.0000, 'ºC'),
	(12859, 109, '2015-01-15 00:33:51.000000', 'temperatura', 1099.0000, 'ºC'),
	(12860, 109, '2015-01-15 00:33:52.000000', 'temperatura', 227.0000, 'ºC'),
	(12861, 109, '2015-01-15 00:33:53.000000', 'temperatura', 238.0000, 'ºC'),
	(12862, 109, '2015-01-15 00:33:54.000000', 'temperatura', 511.0000, 'ºC'),
	(12863, 109, '2015-01-15 00:33:55.000000', 'temperatura', 642.0000, 'ºC'),
	(12864, 109, '2015-01-15 00:33:56.000000', 'temperatura', 478.0000, 'ºC'),
	(12865, 109, '2015-01-15 00:33:57.000000', 'temperatura', 463.0000, 'ºC'),
	(12866, 109, '2015-01-15 00:33:58.000000', 'temperatura', 881.0000, 'ºC'),
	(12867, 109, '2015-01-15 00:33:59.000000', 'temperatura', 618.0000, 'ºC'),
	(12868, 109, '2015-01-15 00:34:00.000000', 'temperatura', 447.0000, 'ºC'),
	(12869, 109, '2015-01-15 00:34:01.000000', 'temperatura', 383.0000, 'ºC'),
	(12870, 109, '2015-01-15 00:34:02.000000', 'temperatura', 574.0000, 'ºC'),
	(12871, 109, '2015-01-15 00:34:03.000000', 'temperatura', 522.0000, 'ºC'),
	(12872, 109, '2015-01-15 00:34:04.000000', 'temperatura', 889.0000, 'ºC'),
	(12873, 109, '2015-01-15 00:34:05.000000', 'temperatura', 477.0000, 'ºC'),
	(12874, 109, '2015-01-15 00:34:06.000000', 'temperatura', 921.0000, 'ºC'),
	(12875, 109, '2015-01-15 00:34:07.000000', 'temperatura', 775.0000, 'ºC'),
	(12876, 109, '2015-01-15 00:34:08.000000', 'temperatura', 1111.0000, 'ºC'),
	(12877, 109, '2015-01-15 00:34:09.000000', 'temperatura', 829.0000, 'ºC'),
	(12878, 109, '2015-01-15 00:34:10.000000', 'temperatura', 815.0000, 'ºC'),
	(12879, 109, '2015-01-15 00:34:11.000000', 'temperatura', 389.0000, 'ºC'),
	(12880, 109, '2015-01-15 00:34:12.000000', 'temperatura', 697.0000, 'ºC'),
	(12881, 109, '2015-01-15 00:34:13.000000', 'temperatura', 1122.0000, 'ºC'),
	(12882, 109, '2015-01-15 00:34:14.000000', 'temperatura', 1120.0000, 'ºC'),
	(12883, 109, '2015-01-15 00:34:15.000000', 'temperatura', 1033.0000, 'ºC'),
	(12884, 109, '2015-01-15 00:34:16.000000', 'temperatura', 607.0000, 'ºC'),
	(12885, 109, '2015-01-15 00:34:17.000000', 'temperatura', 1135.0000, 'ºC'),
	(12886, 109, '2015-01-15 00:34:18.000000', 'temperatura', 253.0000, 'ºC'),
	(12887, 109, '2015-01-15 00:34:19.000000', 'temperatura', 263.0000, 'ºC'),
	(12888, 109, '2015-01-15 00:34:20.000000', 'temperatura', 554.0000, 'ºC'),
	(12889, 109, '2015-01-15 00:34:21.000000', 'temperatura', 783.0000, 'ºC'),
	(12890, 109, '2015-01-15 00:34:22.000000', 'temperatura', 1055.0000, 'ºC'),
	(12891, 109, '2015-01-15 00:34:23.000000', 'temperatura', 527.0000, 'ºC'),
	(12892, 109, '2015-01-15 00:34:24.000000', 'temperatura', 668.0000, 'ºC'),
	(12893, 109, '2015-01-15 00:34:25.000000', 'temperatura', 561.0000, 'ºC'),
	(12894, 109, '2015-01-15 00:34:26.000000', 'temperatura', 802.0000, 'ºC'),
	(12895, 109, '2015-01-15 00:34:27.000000', 'temperatura', 1125.0000, 'ºC'),
	(12896, 109, '2015-01-15 00:34:28.000000', 'temperatura', 820.0000, 'ºC'),
	(12897, 109, '2015-01-15 00:34:29.000000', 'temperatura', 726.0000, 'ºC'),
	(12898, 109, '2015-01-15 00:34:30.000000', 'temperatura', 1171.0000, 'ºC'),
	(12899, 109, '2015-01-15 00:34:31.000000', 'temperatura', 79.0000, 'ºC'),
	(12900, 109, '2015-01-15 00:34:32.000000', 'temperatura', 479.0000, 'ºC'),
	(12901, 109, '2015-01-15 00:34:33.000000', 'temperatura', 962.0000, 'ºC'),
	(12902, 109, '2015-01-15 00:34:34.000000', 'temperatura', 971.0000, 'ºC'),
	(12903, 109, '2015-01-15 00:34:35.000000', 'temperatura', 768.0000, 'ºC'),
	(12904, 109, '2015-01-15 00:34:36.000000', 'temperatura', 931.0000, 'ºC'),
	(12905, 109, '2015-01-15 00:34:37.000000', 'temperatura', 1148.0000, 'ºC'),
	(12906, 109, '2015-01-15 00:34:38.000000', 'temperatura', 550.0000, 'ºC'),
	(12907, 109, '2015-01-15 00:34:39.000000', 'temperatura', 504.0000, 'ºC'),
	(12908, 109, '2015-01-15 00:34:40.000000', 'temperatura', 872.0000, 'ºC'),
	(12909, 109, '2015-01-15 00:34:41.000000', 'temperatura', 449.0000, 'ºC'),
	(12910, 109, '2015-01-15 00:34:42.000000', 'temperatura', 830.0000, 'ºC'),
	(12911, 109, '2015-01-15 00:34:43.000000', 'temperatura', 401.0000, 'ºC'),
	(12912, 109, '2015-01-15 00:34:44.000000', 'temperatura', 719.0000, 'ºC'),
	(12913, 109, '2015-01-15 00:34:45.000000', 'temperatura', 1190.0000, 'ºC'),
	(12914, 109, '2015-01-15 00:34:46.000000', 'temperatura', 192.0000, 'ºC'),
	(12915, 109, '2015-01-15 00:34:47.000000', 'temperatura', 992.0000, 'ºC'),
	(12916, 109, '2015-01-15 00:34:48.000000', 'temperatura', 785.0000, 'ºC'),
	(12917, 109, '2015-01-15 00:34:49.000000', 'temperatura', 949.0000, 'ºC'),
	(12918, 109, '2015-01-15 00:34:50.000000', 'temperatura', 1192.0000, 'ºC'),
	(12919, 109, '2015-01-15 00:34:51.000000', 'temperatura', 712.0000, 'ºC'),
	(12920, 109, '2015-01-15 00:34:52.000000', 'temperatura', 1185.0000, 'ºC'),
	(12921, 109, '2015-01-15 00:34:53.000000', 'temperatura', 188.0000, 'ºC'),
	(12922, 109, '2015-01-15 00:34:54.000000', 'temperatura', 985.0000, 'ºC'),
	(12923, 109, '2015-01-15 00:34:55.000000', 'temperatura', 764.0000, 'ºC'),
	(12924, 109, '2015-01-15 00:34:56.000000', 'temperatura', 865.0000, 'ºC'),
	(12925, 109, '2015-01-15 00:34:57.000000', 'temperatura', 832.0000, 'ºC'),
	(12926, 109, '2015-01-15 00:34:58.000000', 'temperatura', 366.0000, 'ºC'),
	(12927, 109, '2015-01-15 00:34:59.000000', 'temperatura', 534.0000, 'ºC'),
	(12928, 109, '2015-01-15 00:35:00.000000', 'temperatura', 375.0000, 'ºC'),
	(12929, 109, '2015-01-15 00:35:01.000000', 'temperatura', 270.0000, 'ºC'),
	(12930, 109, '2015-01-15 00:35:02.000000', 'temperatura', 228.0000, 'ºC'),
	(12931, 109, '2015-01-15 00:35:03.000000', 'temperatura', 330.0000, 'ºC'),
	(12932, 109, '2015-01-15 00:35:04.000000', 'temperatura', 968.0000, 'ºC'),
	(12933, 109, '2015-01-15 00:35:05.000000', 'temperatura', 250.0000, 'ºC'),
	(12934, 109, '2015-01-15 00:35:06.000000', 'temperatura', 748.0000, 'ºC'),
	(12935, 109, '2015-01-15 00:35:07.000000', 'temperatura', 588.0000, 'ºC'),
	(12936, 109, '2015-01-15 00:35:08.000000', 'temperatura', 698.0000, 'ºC'),
	(12937, 109, '2015-01-15 00:35:09.000000', 'temperatura', 525.0000, 'ºC'),
	(12938, 109, '2015-01-15 00:35:10.000000', 'temperatura', 531.0000, 'ºC'),
	(12939, 109, '2015-01-15 00:35:11.000000', 'temperatura', 1081.0000, 'ºC'),
	(12940, 109, '2015-01-15 00:35:12.000000', 'temperatura', 215.0000, 'ºC'),
	(12941, 109, '2015-01-15 00:35:13.000000', 'temperatura', 229.0000, 'ºC'),
	(12942, 109, '2015-01-15 00:35:14.000000', 'temperatura', 503.0000, 'ºC'),
	(12943, 109, '2015-01-15 00:35:15.000000', 'temperatura', 626.0000, 'ºC'),
	(12944, 109, '2015-01-15 00:35:16.000000', 'temperatura', 421.0000, 'ºC'),
	(12945, 109, '2015-01-15 00:35:17.000000', 'temperatura', 229.0000, 'ºC'),
	(12946, 109, '2015-01-15 00:35:18.000000', 'temperatura', 1081.0000, 'ºC'),
	(12947, 109, '2015-01-15 00:35:19.000000', 'temperatura', 1121.0000, 'ºC'),
	(12948, 109, '2015-01-15 00:35:20.000000', 'temperatura', 1161.0000, 'ºC'),
	(12949, 109, '2015-01-15 00:35:21.000000', 'temperatura', 43.0000, 'ºC'),
	(12950, 109, '2015-01-15 00:35:22.000000', 'temperatura', 331.0000, 'ºC'),
	(12951, 109, '2015-01-15 00:35:23.000000', 'temperatura', 327.0000, 'ºC'),
	(12952, 109, '2015-01-15 00:35:24.000000', 'temperatura', 643.0000, 'ºC'),
	(12953, 109, '2015-01-15 00:35:25.000000', 'temperatura', 1036.0000, 'ºC'),
	(12954, 109, '2015-01-15 00:35:26.000000', 'temperatura', 850.0000, 'ºC'),
	(12955, 109, '2015-01-15 00:35:27.000000', 'temperatura', 1141.0000, 'ºC'),
	(12956, 109, '2015-01-15 00:35:28.000000', 'temperatura', 757.0000, 'ºC'),
	(12957, 109, '2015-01-15 00:35:29.000000', 'temperatura', 361.0000, 'ºC'),
	(12958, 109, '2015-01-15 00:35:30.000000', 'temperatura', 735.0000, 'ºC'),
	(12959, 109, '2015-01-15 00:35:31.000000', 'temperatura', 191.0000, 'ºC'),
	(12960, 109, '2015-01-15 00:35:32.000000', 'temperatura', 1152.0000, 'ºC'),
	(12961, 109, '2015-01-15 00:35:33.000000', 'temperatura', 387.0000, 'ºC'),
	(12962, 109, '2015-01-15 00:35:34.000000', 'temperatura', 882.0000, 'ºC'),
	(12963, 109, '2015-01-15 00:35:35.000000', 'temperatura', 846.0000, 'ºC'),
	(12964, 109, '2015-01-15 00:35:36.000000', 'temperatura', 387.0000, 'ºC'),
	(12965, 109, '2015-01-15 00:35:37.000000', 'temperatura', 596.0000, 'ºC'),
	(12966, 109, '2015-01-15 00:35:38.000000', 'temperatura', 621.0000, 'ºC'),
	(12967, 109, '2015-01-15 00:35:39.000000', 'temperatura', 117.0000, 'ºC'),
	(12968, 109, '2015-01-15 00:35:40.000000', 'temperatura', 1121.0000, 'ºC'),
	(12969, 109, '2015-01-15 00:35:41.000000', 'temperatura', 454.0000, 'ºC'),
	(12970, 109, '2015-01-15 00:35:42.000000', 'temperatura', 110.0000, 'ºC'),
	(12971, 109, '2015-01-15 00:35:43.000000', 'temperatura', 388.0000, 'ºC'),
	(12972, 109, '2015-01-15 00:35:44.000000', 'temperatura', 411.0000, 'ºC'),
	(12973, 109, '2015-01-15 00:35:45.000000', 'temperatura', 892.0000, 'ºC'),
	(12974, 109, '2015-01-15 00:35:46.000000', 'temperatura', 828.0000, 'ºC'),
	(12975, 109, '2015-01-15 00:35:47.000000', 'temperatura', 266.0000, 'ºC'),
	(12976, 109, '2015-01-15 00:35:48.000000', 'temperatura', 44.0000, 'ºC'),
	(12977, 109, '2015-01-15 00:35:49.000000', 'temperatura', 621.0000, 'ºC'),
	(12978, 109, '2015-01-15 00:35:50.000000', 'temperatura', 575.0000, 'ºC'),
	(12979, 109, '2015-01-15 00:35:51.000000', 'temperatura', 1014.0000, 'ºC'),
	(12980, 109, '2015-01-15 00:35:52.000000', 'temperatura', 944.0000, 'ºC'),
	(12981, 109, '2015-01-15 00:35:53.000000', 'temperatura', 477.0000, 'ºC'),
	(12982, 109, '2015-01-15 00:35:54.000000', 'temperatura', 755.0000, 'ºC'),
	(12983, 109, '2015-01-15 00:35:55.000000', 'temperatura', 1146.0000, 'ºC'),
	(12984, 109, '2015-01-15 00:35:56.000000', 'temperatura', 1063.0000, 'ºC'),
	(12985, 109, '2015-01-15 00:35:57.000000', 'temperatura', 679.0000, 'ºC'),
	(12986, 109, '2015-01-15 00:35:58.000000', 'temperatura', 206.0000, 'ºC'),
	(12987, 109, '2015-01-15 00:35:59.000000', 'temperatura', 196.0000, 'ºC'),
	(12988, 109, '2015-01-15 00:36:00.000000', 'temperatura', 359.0000, 'ºC'),
	(12989, 109, '2015-01-15 00:36:01.000000', 'temperatura', 10.0000, 'ºC'),
	(12990, 109, '2015-01-15 00:36:02.000000', 'temperatura', 172.0000, 'ºC'),
	(12991, 109, '2015-01-15 00:36:03.000000', 'temperatura', 830.0000, 'ºC'),
	(12992, 109, '2015-01-15 00:36:04.000000', 'temperatura', 35.0000, 'ºC'),
	(12993, 109, '2015-01-15 00:36:05.000000', 'temperatura', 84.0000, 'ºC'),
	(12994, 109, '2015-01-15 00:36:06.000000', 'temperatura', 318.0000, 'ºC'),
	(12995, 109, '2015-01-15 00:36:07.000000', 'temperatura', 137.0000, 'ºC'),
	(12996, 109, '2015-01-15 00:36:08.000000', 'temperatura', 930.0000, 'ºC'),
	(12997, 109, '2015-01-15 00:36:09.000000', 'temperatura', 642.0000, 'ºC'),
	(12998, 109, '2015-01-15 00:36:10.000000', 'temperatura', 419.0000, 'ºC'),
	(12999, 109, '2015-01-15 00:36:11.000000', 'temperatura', 172.0000, 'ºC'),
	(13000, 109, '2015-01-15 00:36:12.000000', 'temperatura', 800.0000, 'ºC'),
	(13001, 109, '2015-01-15 00:36:13.000000', 'temperatura', 1086.0000, 'ºC'),
	(13002, 109, '2015-01-15 00:36:14.000000', 'temperatura', 630.0000, 'ºC'),
	(13003, 109, '2015-01-15 00:36:15.000000', 'temperatura', 1092.0000, 'ºC'),
	(13004, 109, '2015-01-15 00:36:16.000000', 'temperatura', 1170.0000, 'ºC'),
	(13005, 109, '2015-01-15 00:36:17.000000', 'temperatura', 174.0000, 'ºC'),
	(13006, 109, '2015-01-15 00:36:18.000000', 'temperatura', 963.0000, 'ºC'),
	(13007, 109, '2015-01-15 00:36:19.000000', 'temperatura', 693.0000, 'ºC'),
	(13008, 109, '2015-01-15 00:36:20.000000', 'temperatura', 574.0000, 'ºC'),
	(13009, 109, '2015-01-15 00:36:21.000000', 'temperatura', 795.0000, 'ºC'),
	(13010, 109, '2015-01-15 00:36:22.000000', 'temperatura', 1051.0000, 'ºC'),
	(13011, 109, '2015-01-15 00:36:23.000000', 'temperatura', 470.0000, 'ºC'),
	(13012, 109, '2015-01-15 00:36:24.000000', 'temperatura', 400.0000, 'ºC'),
	(13013, 109, '2015-01-15 00:36:25.000000', 'temperatura', 588.0000, 'ºC'),
	(13014, 109, '2015-01-15 00:36:26.000000', 'temperatura', 540.0000, 'ºC'),
	(13015, 109, '2015-01-15 00:36:27.000000', 'temperatura', 936.0000, 'ºC'),
	(13016, 109, '2015-01-15 00:36:28.000000', 'temperatura', 661.0000, 'ºC'),
	(13017, 109, '2015-01-15 00:36:29.000000', 'temperatura', 497.0000, 'ºC'),
	(13018, 109, '2015-01-15 00:36:30.000000', 'temperatura', 502.0000, 'ºC'),
	(13019, 109, '2015-01-15 00:36:31.000000', 'temperatura', 1019.0000, 'ºC'),
	(13020, 109, '2015-01-15 00:36:32.000000', 'temperatura', 1191.0000, 'ºC'),
	(13021, 109, '2015-01-15 00:36:33.000000', 'temperatura', 498.0000, 'ºC'),
	(13022, 109, '2015-01-15 00:36:34.000000', 'temperatura', 117.0000, 'ºC'),
	(13023, 109, '2015-01-15 00:36:35.000000', 'temperatura', 290.0000, 'ºC'),
	(13024, 109, '2015-01-15 00:36:36.000000', 'temperatura', 1101.0000, 'ºC'),
	(13025, 109, '2015-01-15 00:36:37.000000', 'temperatura', 1036.0000, 'ºC'),
	(13026, 109, '2015-01-15 00:36:38.000000', 'temperatura', 675.0000, 'ºC'),
	(13027, 109, '2015-01-15 00:36:39.000000', 'temperatura', 270.0000, 'ºC'),
	(13028, 109, '2015-01-15 00:36:40.000000', 'temperatura', 526.0000, 'ºC'),
	(13029, 109, '2015-01-15 00:36:41.000000', 'temperatura', 620.0000, 'ºC'),
	(13030, 109, '2015-01-15 00:36:42.000000', 'temperatura', 321.0000, 'ºC'),
	(13031, 109, '2015-01-15 00:36:43.000000', 'temperatura', 946.0000, 'ºC'),
	(13032, 109, '2015-01-15 00:36:44.000000', 'temperatura', 167.0000, 'ºC'),
	(13033, 109, '2015-01-15 00:36:45.000000', 'temperatura', 399.0000, 'ºC'),
	(13034, 109, '2015-01-15 00:36:46.000000', 'temperatura', 294.0000, 'ºC'),
	(13035, 109, '2015-01-15 00:36:47.000000', 'temperatura', 273.0000, 'ºC'),
	(13036, 109, '2015-01-15 00:36:48.000000', 'temperatura', 485.0000, 'ºC'),
	(13037, 109, '2015-01-15 00:36:49.000000', 'temperatura', 404.0000, 'ºC'),
	(13038, 109, '2015-01-15 00:36:50.000000', 'temperatura', 569.0000, 'ºC'),
	(13039, 109, '2015-01-15 00:36:51.000000', 'temperatura', 431.0000, 'ºC'),
	(13040, 109, '2015-01-15 00:36:52.000000', 'temperatura', 448.0000, 'ºC'),
	(13041, 109, '2015-01-15 00:36:53.000000', 'temperatura', 950.0000, 'ºC'),
	(13042, 109, '2015-01-15 00:36:54.000000', 'temperatura', 1005.0000, 'ºC'),
	(13043, 109, '2015-01-15 00:36:55.000000', 'temperatura', 974.0000, 'ºC'),
	(13044, 109, '2015-01-15 00:36:56.000000', 'temperatura', 657.0000, 'ºC'),
	(13045, 109, '2015-01-15 00:36:57.000000', 'temperatura', 363.0000, 'ºC'),
	(13046, 109, '2015-01-15 00:36:58.000000', 'temperatura', 1045.0000, 'ºC'),
	(13047, 109, '2015-01-15 00:36:59.000000', 'temperatura', 537.0000, 'ºC'),
	(13048, 109, '2015-01-15 00:37:00.000000', 'temperatura', 749.0000, 'ºC'),
	(13049, 109, '2015-01-15 00:37:01.000000', 'temperatura', 935.0000, 'ºC'),
	(13050, 109, '2015-01-15 00:37:02.000000', 'temperatura', 30.0000, 'ºC'),
	(13051, 109, '2015-01-15 00:37:03.000000', 'temperatura', 945.0000, 'ºC'),
	(13052, 109, '2015-01-15 00:37:04.000000', 'temperatura', 1037.0000, 'ºC'),
	(13053, 109, '2015-01-15 00:37:05.000000', 'temperatura', 1150.0000, 'ºC'),
	(13054, 109, '2015-01-15 00:37:06.000000', 'temperatura', 241.0000, 'ºC'),
	(13055, 109, '2015-01-15 00:37:07.000000', 'temperatura', 153.0000, 'ºC'),
	(13056, 109, '2015-01-15 00:37:08.000000', 'temperatura', 41.0000, 'ºC'),
	(13057, 109, '2015-01-15 00:37:09.000000', 'temperatura', 949.0000, 'ºC'),
	(13058, 109, '2015-01-15 00:37:10.000000', 'temperatura', 1020.0000, 'ºC'),
	(13059, 109, '2015-01-15 00:37:11.000000', 'temperatura', 1055.0000, 'ºC'),
	(13060, 109, '2015-01-15 00:37:12.000000', 'temperatura', 1016.0000, 'ºC'),
	(13061, 109, '2015-01-15 00:37:13.000000', 'temperatura', 716.0000, 'ºC'),
	(13062, 109, '2015-01-15 00:37:14.000000', 'temperatura', 532.0000, 'ºC'),
	(13063, 109, '2015-01-15 00:37:15.000000', 'temperatura', 514.0000, 'ºC'),
	(13064, 109, '2015-01-15 00:37:16.000000', 'temperatura', 973.0000, 'ºC'),
	(13065, 109, '2015-01-15 00:37:17.000000', 'temperatura', 923.0000, 'ºC'),
	(13066, 109, '2015-01-15 00:37:18.000000', 'temperatura', 496.0000, 'ºC'),
	(13067, 109, '2015-01-15 00:37:19.000000', 'temperatura', 911.0000, 'ºC'),
	(13068, 109, '2015-01-15 00:37:20.000000', 'temperatura', 668.0000, 'ºC'),
	(13069, 109, '2015-01-15 00:37:21.000000', 'temperatura', 610.0000, 'ºC'),
	(13070, 109, '2015-01-15 00:37:22.000000', 'temperatura', 1043.0000, 'ºC'),
	(13071, 109, '2015-01-15 00:37:23.000000', 'temperatura', 987.0000, 'ºC'),
	(13072, 109, '2015-01-15 00:37:24.000000', 'temperatura', 604.0000, 'ºC'),
	(13073, 109, '2015-01-15 00:37:25.000000', 'temperatura', 63.0000, 'ºC'),
	(13074, 109, '2015-01-15 00:37:26.000000', 'temperatura', 903.0000, 'ºC'),
	(13075, 109, '2015-01-15 00:37:27.000000', 'temperatura', 725.0000, 'ºC'),
	(13076, 109, '2015-01-15 00:37:28.000000', 'temperatura', 919.0000, 'ºC'),
	(13077, 109, '2015-01-15 00:37:29.000000', 'temperatura', 19.0000, 'ºC'),
	(13078, 109, '2015-01-15 00:37:30.000000', 'temperatura', 940.0000, 'ºC'),
	(13079, 109, '2015-01-15 00:37:31.000000', 'temperatura', 1045.0000, 'ºC'),
	(13080, 109, '2015-01-15 00:37:32.000000', 'temperatura', 2.0000, 'ºC'),
	(13081, 109, '2015-01-15 00:37:33.000000', 'temperatura', 478.0000, 'ºC'),
	(13082, 109, '2015-01-15 00:37:34.000000', 'temperatura', 1184.0000, 'ºC'),
	(13083, 109, '2015-01-15 00:37:35.000000', 'temperatura', 887.0000, 'ºC'),
	(13084, 109, '2015-01-15 00:37:36.000000', 'temperatura', 884.0000, 'ºC'),
	(13085, 109, '2015-01-15 00:37:37.000000', 'temperatura', 560.0000, 'ºC'),
	(13086, 109, '2015-01-15 00:37:38.000000', 'temperatura', 148.0000, 'ºC'),
	(13087, 109, '2015-01-15 00:37:39.000000', 'temperatura', 262.0000, 'ºC'),
	(13088, 109, '2015-01-15 00:37:40.000000', 'temperatura', 864.0000, 'ºC'),
	(13089, 109, '2015-01-15 00:37:41.000000', 'temperatura', 1133.0000, 'ºC'),
	(13090, 109, '2015-01-15 00:37:42.000000', 'temperatura', 677.0000, 'ºC'),
	(13091, 109, '2015-01-15 00:37:43.000000', 'temperatura', 1184.0000, 'ºC'),
	(13092, 109, '2015-01-15 00:37:44.000000', 'temperatura', 289.0000, 'ºC'),
	(13093, 109, '2015-01-15 00:37:45.000000', 'temperatura', 296.0000, 'ºC'),
	(13094, 109, '2015-01-15 00:37:46.000000', 'temperatura', 611.0000, 'ºC'),
	(13095, 109, '2015-01-15 00:37:47.000000', 'temperatura', 967.0000, 'ºC'),
	(13096, 109, '2015-01-15 00:37:48.000000', 'temperatura', 603.0000, 'ºC'),
	(13097, 109, '2015-01-15 00:37:49.000000', 'temperatura', 113.0000, 'ºC'),
	(13098, 109, '2015-01-15 00:37:50.000000', 'temperatura', 1157.0000, 'ºC'),
	(13099, 109, '2015-01-15 00:37:51.000000', 'temperatura', 649.0000, 'ºC'),
	(13100, 109, '2015-01-15 00:37:52.000000', 'temperatura', 973.0000, 'ºC'),
	(13101, 109, '2015-01-15 00:37:53.000000', 'temperatura', 517.0000, 'ºC'),
	(13102, 109, '2015-01-15 00:37:54.000000', 'temperatura', 867.0000, 'ºC'),
	(13103, 109, '2015-01-15 00:37:55.000000', 'temperatura', 387.0000, 'ºC'),
	(13104, 109, '2015-01-15 00:37:56.000000', 'temperatura', 533.0000, 'ºC'),
	(13105, 109, '2015-01-15 00:37:57.000000', 'temperatura', 304.0000, 'ºC'),
	(13106, 109, '2015-01-15 00:37:58.000000', 'temperatura', 1120.0000, 'ºC'),
	(13107, 109, '2015-01-15 00:37:59.000000', 'temperatura', 1092.0000, 'ºC'),
	(13108, 109, '2015-01-15 00:38:00.000000', 'temperatura', 897.0000, 'ºC'),
	(13109, 109, '2015-01-15 00:38:01.000000', 'temperatura', 13.0000, 'ºC'),
	(13110, 109, '2015-01-15 00:38:02.000000', 'temperatura', 973.0000, 'ºC'),
	(13111, 109, '2015-01-15 00:38:03.000000', 'temperatura', 25.0000, 'ºC'),
	(13112, 109, '2015-01-15 00:38:04.000000', 'temperatura', 808.0000, 'ºC'),
	(13113, 109, '2015-01-15 00:38:05.000000', 'temperatura', 367.0000, 'ºC'),
	(13114, 109, '2015-01-15 00:38:06.000000', 'temperatura', 611.0000, 'ºC'),
	(13115, 109, '2015-01-15 00:38:07.000000', 'temperatura', 753.0000, 'ºC'),
	(13116, 109, '2015-01-15 00:38:08.000000', 'temperatura', 735.0000, 'ºC'),
	(13117, 109, '2015-01-15 00:38:09.000000', 'temperatura', 214.0000, 'ºC'),
	(13118, 109, '2015-01-15 00:38:10.000000', 'temperatura', 66.0000, 'ºC'),
	(13119, 109, '2015-01-15 00:38:11.000000', 'temperatura', 887.0000, 'ºC'),
	(13120, 109, '2015-01-15 00:38:12.000000', 'temperatura', 640.0000, 'ºC'),
	(13121, 109, '2015-01-15 00:38:13.000000', 'temperatura', 537.0000, 'ºC'),
	(13122, 109, '2015-01-15 00:38:14.000000', 'temperatura', 766.0000, 'ºC'),
	(13123, 109, '2015-01-15 00:38:15.000000', 'temperatura', 1021.0000, 'ºC'),
	(13124, 109, '2015-01-15 00:38:16.000000', 'temperatura', 405.0000, 'ºC'),
	(13125, 109, '2015-01-15 00:38:17.000000', 'temperatura', 165.0000, 'ºC'),
	(13126, 109, '2015-01-15 00:38:18.000000', 'temperatura', 809.0000, 'ºC'),
	(13127, 109, '2015-01-15 00:38:19.000000', 'temperatura', 1153.0000, 'ºC'),
	(13128, 109, '2015-01-15 00:38:20.000000', 'temperatura', 937.0000, 'ºC'),
	(13129, 109, '2015-01-15 00:38:21.000000', 'temperatura', 25.0000, 'ºC'),
	(13130, 109, '2015-01-15 00:38:22.000000', 'temperatura', 916.0000, 'ºC'),
	(13131, 109, '2015-01-15 00:38:23.000000', 'temperatura', 905.0000, 'ºC'),
	(13132, 109, '2015-01-15 00:38:24.000000', 'temperatura', 579.0000, 'ºC'),
	(13133, 109, '2015-01-15 00:38:25.000000', 'temperatura', 180.0000, 'ºC'),
	(13134, 109, '2015-01-15 00:38:26.000000', 'temperatura', 364.0000, 'ºC'),
	(13135, 109, '2015-01-15 00:38:27.000000', 'temperatura', 82.0000, 'ºC'),
	(13136, 109, '2015-01-15 00:38:28.000000', 'temperatura', 517.0000, 'ºC'),
	(13137, 109, '2015-01-15 00:38:29.000000', 'temperatura', 1139.0000, 'ºC'),
	(13138, 109, '2015-01-15 00:38:30.000000', 'temperatura', 546.0000, 'ºC'),
	(13139, 109, '2015-01-15 00:38:31.000000', 'temperatura', 511.0000, 'ºC'),
	(13140, 109, '2015-01-15 00:38:32.000000', 'temperatura', 918.0000, 'ºC'),
	(13141, 109, '2015-01-15 00:38:33.000000', 'temperatura', 656.0000, 'ºC'),
	(13142, 109, '2015-01-15 00:38:34.000000', 'temperatura', 529.0000, 'ºC'),
	(13143, 109, '2015-01-15 00:38:35.000000', 'temperatura', 679.0000, 'ºC'),
	(13144, 109, '2015-01-15 00:38:36.000000', 'temperatura', 606.0000, 'ºC'),
	(13145, 109, '2015-01-15 00:38:37.000000', 'temperatura', 995.0000, 'ºC'),
	(13146, 109, '2015-01-15 00:38:38.000000', 'temperatura', 755.0000, 'ºC'),
	(13147, 109, '2015-01-15 00:38:39.000000', 'temperatura', 792.0000, 'ºC'),
	(13148, 109, '2015-01-15 00:38:40.000000', 'temperatura', 493.0000, 'ºC'),
	(13149, 109, '2015-01-15 00:38:41.000000', 'temperatura', 93.0000, 'ºC'),
	(13150, 109, '2015-01-15 00:38:42.000000', 'temperatura', 186.0000, 'ºC'),
	(13151, 109, '2015-01-15 00:38:43.000000', 'temperatura', 650.0000, 'ºC'),
	(13152, 109, '2015-01-15 00:38:44.000000', 'temperatura', 295.0000, 'ºC'),
	(13153, 109, '2015-01-15 00:38:45.000000', 'temperatura', 725.0000, 'ºC'),
	(13154, 109, '2015-01-15 00:38:46.000000', 'temperatura', 342.0000, 'ºC'),
	(13155, 109, '2015-01-15 00:38:47.000000', 'temperatura', 734.0000, 'ºC'),
	(13156, 109, '2015-01-15 00:38:48.000000', 'temperatura', 243.0000, 'ºC'),
	(13157, 109, '2015-01-15 00:38:49.000000', 'temperatura', 216.0000, 'ºC'),
	(13158, 109, '2015-01-15 00:38:50.000000', 'temperatura', 352.0000, 'ºC'),
	(13159, 109, '2015-01-15 00:38:51.000000', 'temperatura', 1110.0000, 'ºC'),
	(13160, 109, '2015-01-15 00:38:52.000000', 'temperatura', 894.0000, 'ºC'),
	(13161, 109, '2015-01-15 00:38:53.000000', 'temperatura', 1142.0000, 'ºC'),
	(13162, 109, '2015-01-15 00:38:54.000000', 'temperatura', 629.0000, 'ºC'),
	(13163, 109, '2015-01-15 00:38:55.000000', 'temperatura', 919.0000, 'ºC'),
	(13164, 109, '2015-01-15 00:38:56.000000', 'temperatura', 310.0000, 'ºC'),
	(13165, 109, '2015-01-15 00:38:57.000000', 'temperatura', 1194.0000, 'ºC'),
	(13166, 109, '2015-01-15 00:38:58.000000', 'temperatura', 239.0000, 'ºC'),
	(13167, 109, '2015-01-15 00:38:59.000000', 'temperatura', 16.0000, 'ºC'),
	(13168, 109, '2015-01-15 00:39:00.000000', 'temperatura', 561.0000, 'ºC'),
	(13169, 109, '2015-01-15 00:39:01.000000', 'temperatura', 359.0000, 'ºC'),
	(13170, 109, '2015-01-15 00:39:02.000000', 'temperatura', 111.0000, 'ºC'),
	(13171, 109, '2015-01-15 00:39:03.000000', 'temperatura', 679.0000, 'ºC'),
	(13172, 109, '2015-01-15 00:39:04.000000', 'temperatura', 662.0000, 'ºC'),
	(13173, 109, '2015-01-15 00:39:05.000000', 'temperatura', 75.0000, 'ºC'),
	(13174, 109, '2015-01-15 00:39:06.000000', 'temperatura', 789.0000, 'ºC'),
	(13175, 109, '2015-01-15 00:39:07.000000', 'temperatura', 120.0000, 'ºC'),
	(13176, 109, '2015-01-15 00:39:08.000000', 'temperatura', 634.0000, 'ºC'),
	(13177, 109, '2015-01-15 00:39:09.000000', 'temperatura', 411.0000, 'ºC'),
	(13178, 109, '2015-01-15 00:39:10.000000', 'temperatura', 154.0000, 'ºC'),
	(13179, 109, '2015-01-15 00:39:11.000000', 'temperatura', 737.0000, 'ºC'),
	(13180, 109, '2015-01-15 00:39:12.000000', 'temperatura', 822.0000, 'ºC'),
	(13181, 109, '2015-01-15 00:39:13.000000', 'temperatura', 700.0000, 'ºC'),
	(13182, 109, '2015-01-15 00:39:14.000000', 'temperatura', 1036.0000, 'ºC'),
	(13183, 109, '2015-01-15 00:39:15.000000', 'temperatura', 680.0000, 'ºC'),
	(13184, 109, '2015-01-15 00:39:16.000000', 'temperatura', 292.0000, 'ºC'),
	(13185, 109, '2015-01-15 00:39:17.000000', 'temperatura', 621.0000, 'ºC'),
	(13186, 109, '2015-01-15 00:39:18.000000', 'temperatura', 1029.0000, 'ºC'),
	(13187, 109, '2015-01-15 00:39:19.000000', 'temperatura', 882.0000, 'ºC'),
	(13188, 109, '2015-01-15 00:39:20.000000', 'temperatura', 125.0000, 'ºC'),
	(13189, 109, '2015-01-15 00:39:21.000000', 'temperatura', 378.0000, 'ºC'),
	(13190, 109, '2015-01-15 00:39:22.000000', 'temperatura', 316.0000, 'ºC'),
	(13191, 109, '2015-01-15 00:39:23.000000', 'temperatura', 445.0000, 'ºC'),
	(13192, 109, '2015-01-15 00:39:24.000000', 'temperatura', 80.0000, 'ºC'),
	(13193, 109, '2015-01-15 00:39:25.000000', 'temperatura', 266.0000, 'ºC'),
	(13194, 109, '2015-01-15 00:39:26.000000', 'temperatura', 1090.0000, 'ºC'),
	(13195, 109, '2015-01-15 00:39:27.000000', 'temperatura', 1051.0000, 'ºC'),
	(13196, 109, '2015-01-15 00:39:28.000000', 'temperatura', 785.0000, 'ºC'),
	(13197, 109, '2015-01-15 00:39:29.000000', 'temperatura', 773.0000, 'ºC'),
	(13198, 109, '2015-01-15 00:39:30.000000', 'temperatura', 312.0000, 'ºC'),
	(13199, 109, '2015-01-15 00:39:31.000000', 'temperatura', 440.0000, 'ºC'),
	(13200, 109, '2015-01-15 00:39:32.000000', 'temperatura', 63.0000, 'ºC'),
	(13201, 109, '2015-01-15 00:39:33.000000', 'temperatura', 199.0000, 'ºC'),
	(13202, 109, '2015-01-15 00:39:34.000000', 'temperatura', 805.0000, 'ºC'),
	(13203, 109, '2015-01-15 00:39:35.000000', 'temperatura', 1027.0000, 'ºC'),
	(13204, 109, '2015-01-15 00:39:36.000000', 'temperatura', 320.0000, 'ºC'),
	(13205, 109, '2015-01-15 00:39:37.000000', 'temperatura', 921.0000, 'ºC'),
	(13206, 109, '2015-01-15 00:39:38.000000', 'temperatura', 43.0000, 'ºC'),
	(13207, 109, '2015-01-15 00:39:39.000000', 'temperatura', 1056.0000, 'ºC'),
	(13208, 109, '2015-01-15 00:39:40.000000', 'temperatura', 349.0000, 'ºC'),
	(13209, 109, '2015-01-15 00:39:41.000000', 'temperatura', 979.0000, 'ºC'),
	(13210, 109, '2015-01-15 00:39:42.000000', 'temperatura', 249.0000, 'ºC'),
	(13211, 109, '2015-01-15 00:39:43.000000', 'temperatura', 706.0000, 'ºC'),
	(13212, 109, '2015-01-15 00:39:44.000000', 'temperatura', 383.0000, 'ºC'),
	(13213, 109, '2015-01-15 00:39:45.000000', 'temperatura', 1001.0000, 'ºC'),
	(13214, 109, '2015-01-15 00:39:46.000000', 'temperatura', 254.0000, 'ºC'),
	(13215, 109, '2015-01-15 00:39:47.000000', 'temperatura', 667.0000, 'ºC'),
	(13216, 109, '2015-01-15 00:39:48.000000', 'temperatura', 175.0000, 'ºC'),
	(13217, 109, '2015-01-15 00:39:49.000000', 'temperatura', 76.0000, 'ºC'),
	(13218, 109, '2015-01-15 00:39:50.000000', 'temperatura', 1054.0000, 'ºC'),
	(13219, 109, '2015-01-15 00:39:51.000000', 'temperatura', 243.0000, 'ºC'),
	(13220, 109, '2015-01-15 00:39:52.000000', 'temperatura', 454.0000, 'ºC'),
	(13221, 109, '2015-01-15 00:39:53.000000', 'temperatura', 343.0000, 'ºC'),
	(13222, 109, '2015-01-15 00:39:54.000000', 'temperatura', 350.0000, 'ºC'),
	(13223, 109, '2015-01-15 00:39:55.000000', 'temperatura', 723.0000, 'ºC'),
	(13224, 109, '2015-01-15 00:39:56.000000', 'temperatura', 166.0000, 'ºC'),
	(13225, 109, '2015-01-15 00:39:57.000000', 'temperatura', 1062.0000, 'ºC'),
	(13226, 109, '2015-01-15 00:39:58.000000', 'temperatura', 10.0000, 'ºC'),
	(13227, 109, '2015-01-15 00:39:59.000000', 'temperatura', 468.0000, 'ºC'),
	(13228, 109, '2015-01-15 00:40:00.000000', 'temperatura', 1108.0000, 'ºC'),
	(13229, 109, '2015-01-15 00:40:01.000000', 'temperatura', 539.0000, 'ºC'),
	(13230, 109, '2015-01-15 00:40:02.000000', 'temperatura', 570.0000, 'ºC'),
	(13231, 109, '2015-01-15 00:40:03.000000', 'temperatura', 35.0000, 'ºC'),
	(13232, 109, '2015-01-15 00:40:04.000000', 'temperatura', 865.0000, 'ºC'),
	(13233, 109, '2015-01-15 00:40:05.000000', 'temperatura', 621.0000, 'ºC'),
	(13234, 109, '2015-01-15 00:40:06.000000', 'temperatura', 508.0000, 'ºC'),
	(13235, 109, '2015-01-15 00:40:07.000000', 'temperatura', 679.0000, 'ºC'),
	(13236, 109, '2015-01-15 00:40:08.000000', 'temperatura', 670.0000, 'ºC'),
	(13237, 109, '2015-01-15 00:40:09.000000', 'temperatura', 117.0000, 'ºC'),
	(13238, 109, '2015-01-15 00:40:10.000000', 'temperatura', 972.0000, 'ºC'),
	(13239, 109, '2015-01-15 00:40:11.000000', 'temperatura', 911.0000, 'ºC'),
	(13240, 109, '2015-01-15 00:40:12.000000', 'temperatura', 438.0000, 'ºC'),
	(13241, 109, '2015-01-15 00:40:13.000000', 'temperatura', 660.0000, 'ºC'),
	(13242, 109, '2015-01-15 00:40:14.000000', 'temperatura', 785.0000, 'ºC'),
	(13243, 109, '2015-01-15 00:40:15.000000', 'temperatura', 748.0000, 'ºC'),
	(13244, 109, '2015-01-15 00:40:16.000000', 'temperatura', 183.0000, 'ºC'),
	(13245, 109, '2015-01-15 00:40:17.000000', 'temperatura', 1074.0000, 'ºC'),
	(13246, 109, '2015-01-15 00:40:18.000000', 'temperatura', 21.0000, 'ºC'),
	(13247, 109, '2015-01-15 00:40:19.000000', 'temperatura', 481.0000, 'ºC'),
	(13248, 109, '2015-01-15 00:40:20.000000', 'temperatura', 1145.0000, 'ºC'),
	(13249, 109, '2015-01-15 00:40:21.000000', 'temperatura', 682.0000, 'ºC'),
	(13250, 109, '2015-01-15 00:40:22.000000', 'temperatura', 1177.0000, 'ºC'),
	(13251, 109, '2015-01-15 00:40:23.000000', 'temperatura', 240.0000, 'ºC'),
	(13252, 109, '2015-01-15 00:40:24.000000', 'temperatura', 68.0000, 'ºC'),
	(13253, 109, '2015-01-15 00:40:25.000000', 'temperatura', 820.0000, 'ºC'),
	(13254, 109, '2015-01-15 00:40:26.000000', 'temperatura', 296.0000, 'ºC'),
	(13255, 109, '2015-01-15 00:40:27.000000', 'temperatura', 221.0000, 'ºC'),
	(13256, 109, '2015-01-15 00:40:28.000000', 'temperatura', 217.0000, 'ºC'),
	(13257, 109, '2015-01-15 00:40:29.000000', 'temperatura', 422.0000, 'ºC'),
	(13258, 109, '2015-01-15 00:40:30.000000', 'temperatura', 261.0000, 'ºC'),
	(13259, 109, '2015-01-15 00:40:31.000000', 'temperatura', 39.0000, 'ºC'),
	(13260, 109, '2015-01-15 00:40:32.000000', 'temperatura', 612.0000, 'ºC'),
	(13261, 109, '2015-01-15 00:40:33.000000', 'temperatura', 546.0000, 'ºC'),
	(13262, 109, '2015-01-15 00:40:34.000000', 'temperatura', 891.0000, 'ºC'),
	(13263, 109, '2015-01-15 00:40:35.000000', 'temperatura', 419.0000, 'ºC'),
	(13264, 109, '2015-01-15 00:40:36.000000', 'temperatura', 622.0000, 'ºC'),
	(13265, 109, '2015-01-15 00:40:37.000000', 'temperatura', 652.0000, 'ºC'),
	(13266, 109, '2015-01-15 00:40:38.000000', 'temperatura', 197.0000, 'ºC'),
	(13267, 109, '2015-01-15 00:40:39.000000', 'temperatura', 229.0000, 'ºC'),
	(13268, 109, '2015-01-15 00:40:40.000000', 'temperatura', 552.0000, 'ºC'),
	(13269, 109, '2015-01-15 00:40:41.000000', 'temperatura', 876.0000, 'ºC'),
	(13270, 109, '2015-01-15 00:40:42.000000', 'temperatura', 323.0000, 'ºC'),
	(13271, 109, '2015-01-15 00:40:43.000000', 'temperatura', 186.0000, 'ºC'),
	(13272, 109, '2015-01-15 00:40:44.000000', 'temperatura', 1163.0000, 'ºC'),
	(13273, 109, '2015-01-15 00:40:45.000000', 'temperatura', 458.0000, 'ºC'),
	(13274, 109, '2015-01-15 00:40:46.000000', 'temperatura', 0.0000, 'ºC'),
	(13275, 109, '2015-01-15 00:40:47.000000', 'temperatura', 1027.0000, 'ºC'),
	(13276, 109, '2015-01-15 00:40:48.000000', 'temperatura', 334.0000, 'ºC'),
	(13277, 109, '2015-01-15 00:40:49.000000', 'temperatura', 989.0000, 'ºC'),
	(13278, 109, '2015-01-15 00:40:50.000000', 'temperatura', 344.0000, 'ºC'),
	(13279, 109, '2015-01-15 00:40:51.000000', 'temperatura', 1156.0000, 'ºC'),
	(13280, 109, '2015-01-15 00:40:52.000000', 'temperatura', 1146.0000, 'ºC'),
	(13281, 109, '2015-01-15 00:40:53.000000', 'temperatura', 1065.0000, 'ºC'),
	(13282, 109, '2015-01-15 00:40:54.000000', 'temperatura', 686.0000, 'ºC'),
	(13283, 109, '2015-01-15 00:40:55.000000', 'temperatura', 235.0000, 'ºC'),
	(13284, 109, '2015-01-15 00:40:56.000000', 'temperatura', 319.0000, 'ºC'),
	(13285, 109, '2015-01-15 00:40:57.000000', 'temperatura', 890.0000, 'ºC'),
	(13286, 109, '2015-01-15 00:40:58.000000', 'temperatura', 1095.0000, 'ºC'),
	(13287, 109, '2015-01-15 00:40:59.000000', 'temperatura', 404.0000, 'ºC'),
	(13288, 109, '2015-01-15 00:41:00.000000', 'temperatura', 1135.0000, 'ºC'),
	(13289, 109, '2015-01-15 00:41:01.000000', 'temperatura', 864.0000, 'ºC'),
	(13290, 109, '2015-01-15 00:41:02.000000', 'temperatura', 916.0000, 'ºC'),
	(13291, 109, '2015-01-15 00:41:03.000000', 'temperatura', 786.0000, 'ºC'),
	(13292, 109, '2015-01-15 00:41:04.000000', 'temperatura', 1185.0000, 'ºC'),
	(13293, 109, '2015-01-15 00:41:05.000000', 'temperatura', 1165.0000, 'ºC'),
	(13294, 109, '2015-01-15 00:41:06.000000', 'temperatura', 1074.0000, 'ºC'),
	(13295, 109, '2015-01-15 00:41:07.000000', 'temperatura', 672.0000, 'ºC'),
	(13296, 109, '2015-01-15 00:41:08.000000', 'temperatura', 139.0000, 'ºC'),
	(13297, 109, '2015-01-15 00:41:09.000000', 'temperatura', 1080.0000, 'ºC'),
	(13298, 109, '2015-01-15 00:41:10.000000', 'temperatura', 185.0000, 'ºC'),
	(13299, 109, '2015-01-15 00:41:11.000000', 'temperatura', 86.0000, 'ºC'),
	(13300, 109, '2015-01-15 00:41:12.000000', 'temperatura', 1073.0000, 'ºC'),
	(13301, 109, '2015-01-15 00:41:13.000000', 'temperatura', 307.0000, 'ºC'),
	(13302, 109, '2015-01-15 00:41:14.000000', 'temperatura', 719.0000, 'ºC'),
	(13303, 109, '2015-01-15 00:41:15.000000', 'temperatura', 272.0000, 'ºC'),
	(13304, 109, '2015-01-15 00:41:16.000000', 'temperatura', 405.0000, 'ºC'),
	(13305, 109, '2015-01-15 00:41:17.000000', 'temperatura', 9.0000, 'ºC'),
	(13306, 109, '2015-01-15 00:41:18.000000', 'temperatura', 32.0000, 'ºC'),
	(13307, 109, '2015-01-15 00:41:19.000000', 'temperatura', 131.0000, 'ºC'),
	(13308, 109, '2015-01-15 00:41:20.000000', 'temperatura', 559.0000, 'ºC'),
	(13309, 109, '2015-01-15 00:41:21.000000', 'temperatura', 5.0000, 'ºC'),
	(13310, 109, '2015-01-15 00:41:22.000000', 'temperatura', 746.0000, 'ºC'),
	(13311, 109, '2015-01-15 00:41:23.000000', 'temperatura', 116.0000, 'ºC'),
	(13312, 109, '2015-01-15 00:41:24.000000', 'temperatura', 745.0000, 'ºC'),
	(13313, 109, '2015-01-15 00:41:25.000000', 'temperatura', 976.0000, 'ºC'),
	(13314, 109, '2015-01-15 00:41:26.000000', 'temperatura', 244.0000, 'ºC'),
	(13315, 109, '2015-01-15 00:41:27.000000', 'temperatura', 694.0000, 'ºC'),
	(13316, 109, '2015-01-15 00:41:28.000000', 'temperatura', 338.0000, 'ºC'),
	(13317, 109, '2015-01-15 00:41:29.000000', 'temperatura', 807.0000, 'ºC'),
	(13318, 109, '2015-01-15 00:41:30.000000', 'temperatura', 623.0000, 'ºC'),
	(13319, 109, '2015-01-15 00:41:31.000000', 'temperatura', 696.0000, 'ºC'),
	(13320, 109, '2015-01-15 00:41:32.000000', 'temperatura', 409.0000, 'ºC'),
	(13321, 109, '2015-01-15 00:41:33.000000', 'temperatura', 1160.0000, 'ºC'),
	(13322, 109, '2015-01-15 00:41:34.000000', 'temperatura', 971.0000, 'ºC'),
	(13323, 109, '2015-01-15 00:41:35.000000', 'temperatura', 175.0000, 'ºC'),
	(13324, 109, '2015-01-15 00:41:36.000000', 'temperatura', 365.0000, 'ºC'),
	(13325, 109, '2015-01-15 00:41:37.000000', 'temperatura', 100.0000, 'ºC'),
	(13326, 109, '2015-01-15 00:41:38.000000', 'temperatura', 606.0000, 'ºC'),
	(13327, 109, '2015-01-15 00:41:39.000000', 'temperatura', 329.0000, 'ºC'),
	(13328, 109, '2015-01-15 00:41:40.000000', 'temperatura', 1030.0000, 'ºC'),
	(13329, 109, '2015-01-15 00:41:41.000000', 'temperatura', 562.0000, 'ºC'),
	(13330, 109, '2015-01-15 00:41:42.000000', 'temperatura', 921.0000, 'ºC'),
	(13331, 109, '2015-01-15 00:41:43.000000', 'temperatura', 519.0000, 'ºC'),
	(13332, 109, '2015-01-15 00:41:44.000000', 'temperatura', 1034.0000, 'ºC'),
	(13333, 109, '2015-01-15 00:41:45.000000', 'temperatura', 14.0000, 'ºC'),
	(13334, 109, '2015-01-15 00:41:46.000000', 'temperatura', 567.0000, 'ºC'),
	(13335, 109, '2015-01-15 00:41:47.000000', 'temperatura', 393.0000, 'ºC'),
	(13336, 109, '2015-01-15 00:41:48.000000', 'temperatura', 264.0000, 'ºC'),
	(13337, 109, '2015-01-15 00:41:49.000000', 'temperatura', 140.0000, 'ºC'),
	(13338, 109, '2015-01-15 00:41:50.000000', 'temperatura', 1112.0000, 'ºC'),
	(13339, 109, '2015-01-15 00:41:51.000000', 'temperatura', 338.0000, 'ºC'),
	(13340, 109, '2015-01-15 00:41:52.000000', 'temperatura', 755.0000, 'ºC'),
	(13341, 109, '2015-01-15 00:41:53.000000', 'temperatura', 360.0000, 'ºC'),
	(13342, 109, '2015-01-15 00:41:54.000000', 'temperatura', 736.0000, 'ºC'),
	(13343, 109, '2015-01-15 00:41:55.000000', 'temperatura', 200.0000, 'ºC'),
	(13344, 109, '2015-01-15 00:41:56.000000', 'temperatura', 1194.0000, 'ºC'),
	(13345, 109, '2015-01-15 00:41:57.000000', 'temperatura', 571.0000, 'ºC'),
	(13346, 109, '2015-01-15 00:41:58.000000', 'temperatura', 471.0000, 'ºC'),
	(13347, 109, '2015-01-15 00:41:59.000000', 'temperatura', 644.0000, 'ºC'),
	(13348, 109, '2015-01-15 00:42:00.000000', 'temperatura', 606.0000, 'ºC'),
	(13349, 109, '2015-01-15 00:42:01.000000', 'temperatura', 1098.0000, 'ºC'),
	(13350, 109, '2015-01-15 00:42:02.000000', 'temperatura', 72.0000, 'ºC'),
	(13351, 109, '2015-01-15 00:42:03.000000', 'temperatura', 668.0000, 'ºC'),
	(13352, 109, '2015-01-15 00:42:04.000000', 'temperatura', 724.0000, 'ºC'),
	(13353, 109, '2015-01-15 00:42:05.000000', 'temperatura', 419.0000, 'ºC'),
	(13354, 109, '2015-01-15 00:42:06.000000', 'temperatura', 1120.0000, 'ºC'),
	(13355, 109, '2015-01-15 00:42:07.000000', 'temperatura', 746.0000, 'ºC'),
	(13356, 109, '2015-01-15 00:42:08.000000', 'temperatura', 371.0000, 'ºC'),
	(13357, 109, '2015-01-15 00:42:09.000000', 'temperatura', 816.0000, 'ºC'),
	(13358, 109, '2015-01-15 00:42:10.000000', 'temperatura', 568.0000, 'ºC'),
	(13359, 109, '2015-01-15 00:42:11.000000', 'temperatura', 391.0000, 'ºC'),
	(13360, 109, '2015-01-15 00:42:12.000000', 'temperatura', 251.0000, 'ºC'),
	(13361, 109, '2015-01-15 00:42:13.000000', 'temperatura', 85.0000, 'ºC'),
	(13362, 109, '2015-01-15 00:42:14.000000', 'temperatura', 870.0000, 'ºC'),
	(13363, 109, '2015-01-15 00:42:15.000000', 'temperatura', 498.0000, 'ºC'),
	(13364, 109, '2015-01-15 00:42:16.000000', 'temperatura', 1078.0000, 'ºC'),
	(13365, 109, '2015-01-15 00:42:17.000000', 'temperatura', 299.0000, 'ºC'),
	(13366, 109, '2015-01-15 00:42:18.000000', 'temperatura', 659.0000, 'ºC'),
	(13367, 109, '2015-01-15 00:42:19.000000', 'temperatura', 1.0000, 'ºC'),
	(13368, 109, '2015-01-15 00:42:20.000000', 'temperatura', 429.0000, 'ºC'),
	(13369, 109, '2015-01-15 00:42:21.000000', 'temperatura', 940.0000, 'ºC'),
	(13370, 109, '2015-01-15 00:42:22.000000', 'temperatura', 1013.0000, 'ºC'),
	(13371, 109, '2015-01-15 00:42:23.000000', 'temperatura', 1045.0000, 'ºC'),
	(13372, 109, '2015-01-15 00:42:24.000000', 'temperatura', 989.0000, 'ºC'),
	(13373, 109, '2015-01-15 00:42:25.000000', 'temperatura', 609.0000, 'ºC'),
	(13374, 109, '2015-01-15 00:42:26.000000', 'temperatura', 80.0000, 'ºC'),
	(13375, 109, '2015-01-15 00:42:27.000000', 'temperatura', 971.0000, 'ºC'),
	(13376, 109, '2015-01-15 00:42:28.000000', 'temperatura', 1016.0000, 'ºC'),
	(13377, 109, '2015-01-15 00:42:29.000000', 'temperatura', 967.0000, 'ºC'),
	(13378, 109, '2015-01-15 00:42:30.000000', 'temperatura', 587.0000, 'ºC'),
	(13379, 109, '2015-01-15 00:42:31.000000', 'temperatura', 35.0000, 'ºC'),
	(13380, 109, '2015-01-15 00:42:32.000000', 'temperatura', 813.0000, 'ºC'),
	(13381, 109, '2015-01-15 00:42:33.000000', 'temperatura', 362.0000, 'ºC'),
	(13382, 109, '2015-01-15 00:42:34.000000', 'temperatura', 570.0000, 'ºC'),
	(13383, 109, '2015-01-15 00:42:35.000000', 'temperatura', 567.0000, 'ºC'),
	(13384, 109, '2015-01-15 00:42:36.000000', 'temperatura', 1124.0000, 'ºC'),
	(13385, 109, '2015-01-15 00:42:37.000000', 'temperatura', 322.0000, 'ºC'),
	(13386, 109, '2015-01-15 00:42:38.000000', 'temperatura', 636.0000, 'ºC'),
	(13387, 109, '2015-01-15 00:42:39.000000', 'temperatura', 1016.0000, 'ºC'),
	(13388, 109, '2015-01-15 00:42:40.000000', 'temperatura', 773.0000, 'ºC'),
	(13389, 109, '2015-01-15 00:42:41.000000', 'temperatura', 816.0000, 'ºC'),
	(13390, 109, '2015-01-15 00:42:42.000000', 'temperatura', 561.0000, 'ºC'),
	(13391, 109, '2015-01-15 00:42:43.000000', 'temperatura', 359.0000, 'ºC'),
	(13392, 109, '2015-01-15 00:42:44.000000', 'temperatura', 110.0000, 'ºC'),
	(13393, 109, '2015-01-15 00:42:45.000000', 'temperatura', 674.0000, 'ºC'),
	(13394, 109, '2015-01-15 00:42:46.000000', 'temperatura', 642.0000, 'ºC'),
	(13395, 109, '2015-01-15 00:42:47.000000', 'temperatura', 1186.0000, 'ºC'),
	(13396, 109, '2015-01-15 00:42:48.000000', 'temperatura', 406.0000, 'ºC'),
	(13397, 109, '2015-01-15 00:42:49.000000', 'temperatura', 873.0000, 'ºC'),
	(13398, 109, '2015-01-15 00:42:50.000000', 'temperatura', 749.0000, 'ºC'),
	(13399, 109, '2015-01-15 00:42:51.000000', 'temperatura', 1125.0000, 'ºC'),
	(13400, 109, '2015-01-15 00:42:52.000000', 'temperatura', 979.0000, 'ºC'),
	(13401, 109, '2015-01-15 00:42:53.000000', 'temperatura', 319.0000, 'ºC'),
	(13402, 109, '2015-01-15 00:42:54.000000', 'temperatura', 1061.0000, 'ºC'),
	(13403, 109, '2015-01-15 00:42:55.000000', 'temperatura', 745.0000, 'ºC'),
	(13404, 109, '2015-01-15 00:42:56.000000', 'temperatura', 546.0000, 'ºC'),
	(13405, 109, '2015-01-15 00:42:57.000000', 'temperatura', 495.0000, 'ºC'),
	(13406, 109, '2015-01-15 00:42:58.000000', 'temperatura', 836.0000, 'ºC'),
	(13407, 109, '2015-01-15 00:42:59.000000', 'temperatura', 298.0000, 'ºC'),
	(13408, 109, '2015-01-15 00:43:00.000000', 'temperatura', 182.0000, 'ºC'),
	(13409, 109, '2015-01-15 00:43:01.000000', 'temperatura', 14.0000, 'ºC'),
	(13410, 109, '2015-01-15 00:43:02.000000', 'temperatura', 726.0000, 'ºC'),
	(13411, 109, '2015-01-15 00:43:03.000000', 'temperatura', 1187.0000, 'ºC'),
	(13412, 109, '2015-01-15 00:43:04.000000', 'temperatura', 158.0000, 'ºC'),
	(13413, 109, '2015-01-15 00:43:05.000000', 'temperatura', 829.0000, 'ºC'),
	(13414, 109, '2015-01-15 00:43:06.000000', 'temperatura', 72.0000, 'ºC'),
	(13415, 109, '2015-01-15 00:43:07.000000', 'temperatura', 273.0000, 'ºC'),
	(13416, 109, '2015-01-15 00:43:08.000000', 'temperatura', 1148.0000, 'ºC'),
	(13417, 109, '2015-01-15 00:43:09.000000', 'temperatura', 124.0000, 'ºC'),
	(13418, 109, '2015-01-15 00:43:10.000000', 'temperatura', 777.0000, 'ºC'),
	(13419, 109, '2015-01-15 00:43:11.000000', 'temperatura', 1112.0000, 'ºC'),
	(13420, 109, '2015-01-15 00:43:12.000000', 'temperatura', 828.0000, 'ºC'),
	(13421, 109, '2015-01-15 00:43:13.000000', 'temperatura', 805.0000, 'ºC'),
	(13422, 109, '2015-01-15 00:43:14.000000', 'temperatura', 343.0000, 'ºC'),
	(13423, 109, '2015-01-15 00:43:15.000000', 'temperatura', 500.0000, 'ºC'),
	(13424, 109, '2015-01-15 00:43:16.000000', 'temperatura', 271.0000, 'ºC'),
	(13425, 109, '2015-01-15 00:43:17.000000', 'temperatura', 1056.0000, 'ºC'),
	(13426, 109, '2015-01-15 00:43:18.000000', 'temperatura', 869.0000, 'ºC'),
	(13427, 109, '2015-01-15 00:43:19.000000', 'temperatura', 1177.0000, 'ºC'),
	(13428, 109, '2015-01-15 00:43:20.000000', 'temperatura', 876.0000, 'ºC'),
	(13429, 109, '2015-01-15 00:43:21.000000', 'temperatura', 853.0000, 'ºC'),
	(13430, 109, '2015-01-15 00:43:22.000000', 'temperatura', 435.0000, 'ºC'),
	(13431, 109, '2015-01-15 00:43:23.000000', 'temperatura', 816.0000, 'ºC'),
	(13432, 109, '2015-01-15 00:43:24.000000', 'temperatura', 377.0000, 'ºC'),
	(13433, 109, '2015-01-15 00:43:25.000000', 'temperatura', 635.0000, 'ºC'),
	(13434, 109, '2015-01-15 00:43:26.000000', 'temperatura', 847.0000, 'ºC'),
	(13435, 109, '2015-01-15 00:43:27.000000', 'temperatura', 1129.0000, 'ºC'),
	(13436, 109, '2015-01-15 00:43:28.000000', 'temperatura', 706.0000, 'ºC'),
	(13437, 109, '2015-01-15 00:43:29.000000', 'temperatura', 144.0000, 'ºC'),
	(13438, 109, '2015-01-15 00:43:30.000000', 'temperatura', 1001.0000, 'ºC'),
	(13439, 109, '2015-01-15 00:43:31.000000', 'temperatura', 975.0000, 'ºC'),
	(13440, 109, '2015-01-15 00:43:32.000000', 'temperatura', 670.0000, 'ºC'),
	(13441, 109, '2015-01-15 00:43:33.000000', 'temperatura', 425.0000, 'ºC'),
	(13442, 109, '2015-01-15 00:43:34.000000', 'temperatura', 119.0000, 'ºC'),
	(13443, 109, '2015-01-15 00:43:35.000000', 'temperatura', 518.0000, 'ºC'),
	(13444, 109, '2015-01-15 00:43:36.000000', 'temperatura', 1033.0000, 'ºC'),
	(13445, 109, '2015-01-15 00:43:37.000000', 'temperatura', 13.0000, 'ºC'),
	(13446, 109, '2015-01-15 00:43:38.000000', 'temperatura', 566.0000, 'ºC'),
	(13447, 109, '2015-01-15 00:43:39.000000', 'temperatura', 393.0000, 'ºC'),
	(13448, 109, '2015-01-15 00:43:40.000000', 'temperatura', 268.0000, 'ºC'),
	(13449, 109, '2015-01-15 00:43:41.000000', 'temperatura', 160.0000, 'ºC'),
	(13450, 109, '2015-01-15 00:43:42.000000', 'temperatura', 1198.0000, 'ºC'),
	(13451, 109, '2015-01-15 00:43:43.000000', 'temperatura', 711.0000, 'ºC'),
	(13452, 109, '2015-01-15 00:43:44.000000', 'temperatura', 1162.0000, 'ºC'),
	(13453, 109, '2015-01-15 00:43:45.000000', 'temperatura', 76.0000, 'ºC'),
	(13454, 109, '2015-01-15 00:43:46.000000', 'temperatura', 495.0000, 'ºC'),
	(13455, 109, '2015-01-15 00:43:47.000000', 'temperatura', 1049.0000, 'ºC'),
	(13456, 109, '2015-01-15 00:43:48.000000', 'temperatura', 160.0000, 'ºC'),
	(13457, 109, '2015-01-15 00:43:49.000000', 'temperatura', 54.0000, 'ºC'),
	(13458, 109, '2015-01-15 00:43:50.000000', 'temperatura', 988.0000, 'ºC'),
	(13459, 109, '2015-01-15 00:43:51.000000', 'temperatura', 1182.0000, 'ºC'),
	(13460, 109, '2015-01-15 00:43:52.000000', 'temperatura', 544.0000, 'ºC'),
	(13461, 109, '2015-01-15 00:43:53.000000', 'temperatura', 377.0000, 'ºC'),
	(13462, 109, '2015-01-15 00:43:54.000000', 'temperatura', 251.0000, 'ºC'),
	(13463, 109, '2015-01-15 00:43:55.000000', 'temperatura', 125.0000, 'ºC'),
	(13464, 109, '2015-01-15 00:43:56.000000', 'temperatura', 1071.0000, 'ºC'),
	(13465, 109, '2015-01-15 00:43:57.000000', 'temperatura', 180.0000, 'ºC'),
	(13466, 109, '2015-01-15 00:43:58.000000', 'temperatura', 91.0000, 'ºC'),
	(13467, 109, '2015-01-15 00:43:59.000000', 'temperatura', 1113.0000, 'ºC'),
	(13468, 109, '2015-01-15 00:44:00.000000', 'temperatura', 494.0000, 'ºC'),
	(13469, 109, '2015-01-15 00:44:01.000000', 'temperatura', 329.0000, 'ºC'),
	(13470, 109, '2015-01-15 00:44:02.000000', 'temperatura', 166.0000, 'ºC'),
	(13471, 109, '2015-01-15 00:44:03.000000', 'temperatura', 1043.0000, 'ºC'),
	(13472, 109, '2015-01-15 00:44:04.000000', 'temperatura', 1116.0000, 'ºC'),
	(13473, 109, '2015-01-15 00:44:05.000000', 'temperatura', 53.0000, 'ºC'),
	(13474, 109, '2015-01-15 00:44:06.000000', 'temperatura', 519.0000, 'ºC'),
	(13475, 109, '2015-01-15 00:44:07.000000', 'temperatura', 35.0000, 'ºC'),
	(13476, 109, '2015-01-15 00:44:08.000000', 'temperatura', 1017.0000, 'ºC'),
	(13477, 109, '2015-01-15 00:44:09.000000', 'temperatura', 182.0000, 'ºC'),
	(13478, 109, '2015-01-15 00:44:10.000000', 'temperatura', 261.0000, 'ºC'),
	(13479, 109, '2015-01-15 00:44:11.000000', 'temperatura', 758.0000, 'ºC'),
	(13480, 109, '2015-01-15 00:44:12.000000', 'temperatura', 607.0000, 'ºC'),
	(13481, 109, '2015-01-15 00:44:13.000000', 'temperatura', 760.0000, 'ºC'),
	(13482, 109, '2015-01-15 00:44:14.000000', 'temperatura', 781.0000, 'ºC'),
	(13483, 109, '2015-01-15 00:44:15.000000', 'temperatura', 425.0000, 'ºC'),
	(13484, 109, '2015-01-15 00:44:16.000000', 'temperatura', 983.0000, 'ºC'),
	(13485, 109, '2015-01-15 00:44:17.000000', 'temperatura', 40.0000, 'ºC'),
	(13486, 109, '2015-01-15 00:44:18.000000', 'temperatura', 851.0000, 'ºC'),
	(13487, 109, '2015-01-15 00:44:19.000000', 'temperatura', 536.0000, 'ºC'),
	(13488, 109, '2015-01-15 00:44:20.000000', 'temperatura', 127.0000, 'ºC'),
	(13489, 109, '2015-01-15 00:44:21.000000', 'temperatura', 229.0000, 'ºC'),
	(13490, 109, '2015-01-15 00:44:22.000000', 'temperatura', 764.0000, 'ºC'),
	(13491, 109, '2015-01-15 00:44:23.000000', 'temperatura', 735.0000, 'ºC'),
	(13492, 109, '2015-01-15 00:44:24.000000', 'temperatura', 180.0000, 'ºC'),
	(13493, 109, '2015-01-15 00:44:25.000000', 'temperatura', 1098.0000, 'ºC'),
	(13494, 109, '2015-01-15 00:44:26.000000', 'temperatura', 151.0000, 'ºC'),
	(13495, 109, '2015-01-15 00:44:27.000000', 'temperatura', 1062.0000, 'ºC'),
	(13496, 109, '2015-01-15 00:44:28.000000', 'temperatura', 58.0000, 'ºC'),
	(13497, 109, '2015-01-15 00:44:29.000000', 'temperatura', 703.0000, 'ºC'),
	(13498, 109, '2015-01-15 00:44:30.000000', 'temperatura', 941.0000, 'ºC'),
	(13499, 109, '2015-01-15 00:44:31.000000', 'temperatura', 197.0000, 'ºC'),
	(13500, 109, '2015-01-15 00:44:32.000000', 'temperatura', 562.0000, 'ºC'),
	(13501, 109, '2015-01-15 00:44:33.000000', 'temperatura', 1019.0000, 'ºC'),
	(13502, 109, '2015-01-15 00:44:34.000000', 'temperatura', 1009.0000, 'ºC'),
	(13503, 109, '2015-01-15 00:44:35.000000', 'temperatura', 788.0000, 'ºC'),
	(13504, 109, '2015-01-15 00:44:36.000000', 'temperatura', 915.0000, 'ºC'),
	(13505, 109, '2015-01-15 00:44:37.000000', 'temperatura', 1013.0000, 'ºC'),
	(13506, 109, '2015-01-15 00:44:38.000000', 'temperatura', 1120.0000, 'ºC'),
	(13507, 109, '2015-01-15 00:44:39.000000', 'temperatura', 161.0000, 'ºC'),
	(13508, 109, '2015-01-15 00:44:40.000000', 'temperatura', 1047.0000, 'ºC'),
	(13509, 109, '2015-01-15 00:44:41.000000', 'temperatura', 1153.0000, 'ºC'),
	(13510, 109, '2015-01-15 00:44:42.000000', 'temperatura', 224.0000, 'ºC'),
	(13511, 109, '2015-01-15 00:44:43.000000', 'temperatura', 63.0000, 'ºC'),
	(13512, 109, '2015-01-15 00:44:44.000000', 'temperatura', 843.0000, 'ºC'),
	(13513, 109, '2015-01-15 00:44:45.000000', 'temperatura', 424.0000, 'ºC'),
	(13514, 109, '2015-01-15 00:44:46.000000', 'temperatura', 793.0000, 'ºC'),
	(13515, 109, '2015-01-15 00:44:47.000000', 'temperatura', 292.0000, 'ºC'),
	(13516, 109, '2015-01-15 00:44:48.000000', 'temperatura', 282.0000, 'ºC'),
	(13517, 109, '2015-01-15 00:44:49.000000', 'temperatura', 537.0000, 'ºC'),
	(13518, 109, '2015-01-15 00:44:50.000000', 'temperatura', 638.0000, 'ºC'),
	(13519, 109, '2015-01-15 00:44:51.000000', 'temperatura', 378.0000, 'ºC'),
	(13520, 109, '2015-01-15 00:44:52.000000', 'temperatura', 1178.0000, 'ºC'),
	(13521, 109, '2015-01-15 00:44:53.000000', 'temperatura', 1157.0000, 'ºC'),
	(13522, 109, '2015-01-15 00:44:54.000000', 'temperatura', 1051.0000, 'ºC'),
	(13523, 109, '2015-01-15 00:44:55.000000', 'temperatura', 584.0000, 'ºC'),
	(13524, 109, '2015-01-15 00:44:56.000000', 'temperatura', 970.0000, 'ºC'),
	(13525, 109, '2015-01-15 00:44:57.000000', 'temperatura', 697.0000, 'ºC'),
	(13526, 109, '2015-01-15 00:44:58.000000', 'temperatura', 574.0000, 'ºC'),
	(13527, 109, '2015-01-15 00:44:59.000000', 'temperatura', 782.0000, 'ºC'),
	(13528, 109, '2015-01-15 00:45:00.000000', 'temperatura', 988.0000, 'ºC'),
	(13529, 109, '2015-01-15 00:45:01.000000', 'temperatura', 193.0000, 'ºC'),
	(13530, 109, '2015-01-15 00:45:02.000000', 'temperatura', 401.0000, 'ºC'),
	(13531, 109, '2015-01-15 00:45:03.000000', 'temperatura', 227.0000, 'ºC'),
	(13532, 109, '2015-01-15 00:45:04.000000', 'temperatura', 1134.0000, 'ºC'),
	(13533, 109, '2015-01-15 00:45:05.000000', 'temperatura', 190.0000, 'ºC'),
	(13534, 109, '2015-01-15 00:45:06.000000', 'temperatura', 1146.0000, 'ºC'),
	(13535, 109, '2015-01-15 00:45:07.000000', 'temperatura', 361.0000, 'ºC'),
	(13536, 109, '2015-01-15 00:45:08.000000', 'temperatura', 768.0000, 'ºC'),
	(13537, 109, '2015-01-15 00:45:09.000000', 'temperatura', 359.0000, 'ºC'),
	(13538, 109, '2015-01-15 00:45:10.000000', 'temperatura', 692.0000, 'ºC'),
	(13539, 109, '2015-01-15 00:45:11.000000', 'temperatura', 1184.0000, 'ºC'),
	(13540, 109, '2015-01-15 00:45:12.000000', 'temperatura', 243.0000, 'ºC'),
	(13541, 109, '2015-01-15 00:45:13.000000', 'temperatura', 64.0000, 'ºC'),
	(13542, 109, '2015-01-15 00:45:14.000000', 'temperatura', 792.0000, 'ºC'),
	(13543, 109, '2015-01-15 00:45:15.000000', 'temperatura', 168.0000, 'ºC'),
	(13544, 109, '2015-01-15 00:45:16.000000', 'temperatura', 863.0000, 'ºC'),
	(13545, 109, '2015-01-15 00:45:17.000000', 'temperatura', 213.0000, 'ºC'),
	(13546, 109, '2015-01-15 00:45:18.000000', 'temperatura', 875.0000, 'ºC'),
	(13547, 109, '2015-01-15 00:45:19.000000', 'temperatura', 137.0000, 'ºC'),
	(13548, 109, '2015-01-15 00:45:20.000000', 'temperatura', 461.0000, 'ºC'),
	(13549, 109, '2015-01-15 00:45:21.000000', 'temperatura', 692.0000, 'ºC'),
	(13550, 109, '2015-01-15 00:45:22.000000', 'temperatura', 880.0000, 'ºC'),
	(13551, 109, '2015-01-15 00:45:23.000000', 'temperatura', 1125.0000, 'ºC'),
	(13552, 109, '2015-01-15 00:45:24.000000', 'temperatura', 584.0000, 'ºC'),
	(13553, 109, '2015-01-15 00:45:25.000000', 'temperatura', 747.0000, 'ºC'),
	(13554, 109, '2015-01-15 00:45:26.000000', 'temperatura', 785.0000, 'ºC'),
	(13555, 109, '2015-01-15 00:45:27.000000', 'temperatura', 482.0000, 'ºC'),
	(13556, 109, '2015-01-15 00:45:28.000000', 'temperatura', 57.0000, 'ºC'),
	(13557, 109, '2015-01-15 00:45:29.000000', 'temperatura', 37.0000, 'ºC'),
	(13558, 109, '2015-01-15 00:45:30.000000', 'temperatura', 16.0000, 'ºC'),
	(13559, 109, '2015-01-15 00:45:31.000000', 'temperatura', 1171.0000, 'ºC'),
	(13560, 109, '2015-01-15 00:45:32.000000', 'temperatura', 1006.0000, 'ºC'),
	(13561, 109, '2015-01-15 00:45:33.000000', 'temperatura', 320.0000, 'ºC'),
	(13562, 109, '2015-01-15 00:45:34.000000', 'temperatura', 979.0000, 'ºC'),
	(13563, 109, '2015-01-15 00:45:35.000000', 'temperatura', 338.0000, 'ºC'),
	(13564, 109, '2015-01-15 00:45:36.000000', 'temperatura', 1154.0000, 'ºC'),
	(13565, 109, '2015-01-15 00:45:37.000000', 'temperatura', 1154.0000, 'ºC'),
	(13566, 109, '2015-01-15 00:45:38.000000', 'temperatura', 1110.0000, 'ºC'),
	(13567, 109, '2015-01-15 00:45:39.000000', 'temperatura', 886.0000, 'ºC'),
	(13568, 109, '2015-01-15 00:45:40.000000', 'temperatura', 1104.0000, 'ºC'),
	(13569, 109, '2015-01-15 00:45:41.000000', 'temperatura', 460.0000, 'ºC'),
	(13570, 109, '2015-01-15 00:45:42.000000', 'temperatura', 191.0000, 'ºC'),
	(13571, 109, '2015-01-15 00:45:43.000000', 'temperatura', 775.0000, 'ºC'),
	(13572, 109, '2015-01-15 00:45:44.000000', 'temperatura', 900.0000, 'ºC'),
	(13573, 109, '2015-01-15 00:45:45.000000', 'temperatura', 977.0000, 'ºC'),
	(13574, 109, '2015-01-15 00:45:46.000000', 'temperatura', 986.0000, 'ºC'),
	(13575, 109, '2015-01-15 00:45:47.000000', 'temperatura', 800.0000, 'ºC'),
	(13576, 109, '2015-01-15 00:45:48.000000', 'temperatura', 1043.0000, 'ºC'),
	(13577, 109, '2015-01-15 00:45:49.000000', 'temperatura', 417.0000, 'ºC'),
	(13578, 109, '2015-01-15 00:45:50.000000', 'temperatura', 153.0000, 'ºC'),
	(13579, 109, '2015-01-15 00:45:51.000000', 'temperatura', 718.0000, 'ºC'),
	(13580, 109, '2015-01-15 00:45:52.000000', 'temperatura', 729.0000, 'ºC'),
	(13581, 109, '2015-01-15 00:45:53.000000', 'temperatura', 292.0000, 'ºC'),
	(13582, 109, '2015-01-15 00:45:54.000000', 'temperatura', 475.0000, 'ºC'),
	(13583, 109, '2015-01-15 00:45:55.000000', 'temperatura', 298.0000, 'ºC'),
	(13584, 109, '2015-01-15 00:45:56.000000', 'temperatura', 67.0000, 'ºC'),
	(13585, 109, '2015-01-15 00:45:57.000000', 'temperatura', 642.0000, 'ºC'),
	(13586, 109, '2015-01-15 00:45:58.000000', 'temperatura', 607.0000, 'ºC'),
	(13587, 109, '2015-01-15 00:45:59.000000', 'temperatura', 1110.0000, 'ºC'),
	(13588, 109, '2015-01-15 00:46:00.000000', 'temperatura', 130.0000, 'ºC'),
	(13589, 109, '2015-01-15 00:46:01.000000', 'temperatura', 922.0000, 'ºC'),
	(13590, 109, '2015-01-15 00:46:02.000000', 'temperatura', 620.0000, 'ºC'),
	(13591, 109, '2015-01-15 00:46:03.000000', 'temperatura', 335.0000, 'ºC'),
	(13592, 109, '2015-01-15 00:46:04.000000', 'temperatura', 1015.0000, 'ºC'),
	(13593, 109, '2015-01-15 00:46:05.000000', 'temperatura', 471.0000, 'ºC'),
	(13594, 109, '2015-01-15 00:46:06.000000', 'temperatura', 510.0000, 'ºC'),
	(13595, 109, '2015-01-15 00:46:07.000000', 'temperatura', 1137.0000, 'ºC'),
	(13596, 109, '2015-01-15 00:46:08.000000', 'temperatura', 556.0000, 'ºC'),
	(13597, 109, '2015-01-15 00:46:09.000000', 'temperatura', 568.0000, 'ºC'),
	(13598, 109, '2015-01-15 00:46:10.000000', 'temperatura', 1173.0000, 'ºC'),
	(13599, 109, '2015-01-15 00:46:11.000000', 'temperatura', 561.0000, 'ºC'),
	(13600, 109, '2015-01-15 00:46:12.000000', 'temperatura', 489.0000, 'ºC'),
	(13601, 109, '2015-01-15 00:46:13.000000', 'temperatura', 762.0000, 'ºC'),
	(13602, 109, '2015-01-15 00:46:14.000000', 'temperatura', 1142.0000, 'ºC'),
	(13603, 109, '2015-01-15 00:46:15.000000', 'temperatura', 1024.0000, 'ºC'),
	(13604, 109, '2015-01-15 00:46:16.000000', 'temperatura', 496.0000, 'ºC'),
	(13605, 109, '2015-01-15 00:46:17.000000', 'temperatura', 609.0000, 'ºC'),
	(13606, 109, '2015-01-15 00:46:18.000000', 'temperatura', 357.0000, 'ºC'),
	(13607, 109, '2015-01-15 00:46:19.000000', 'temperatura', 1159.0000, 'ºC'),
	(13608, 109, '2015-01-15 00:46:20.000000', 'temperatura', 1123.0000, 'ºC'),
	(13609, 109, '2015-01-15 00:46:21.000000', 'temperatura', 940.0000, 'ºC'),
	(13610, 109, '2015-01-15 00:46:22.000000', 'temperatura', 130.0000, 'ºC'),
	(13611, 109, '2015-01-15 00:46:23.000000', 'temperatura', 230.0000, 'ºC'),
	(13612, 109, '2015-01-15 00:46:24.000000', 'temperatura', 762.0000, 'ºC'),
	(13613, 109, '2015-01-15 00:46:25.000000', 'temperatura', 721.0000, 'ºC'),
	(13614, 109, '2015-01-15 00:46:26.000000', 'temperatura', 118.0000, 'ºC'),
	(13615, 109, '2015-01-15 00:46:27.000000', 'temperatura', 828.0000, 'ºC'),
	(13616, 109, '2015-01-15 00:46:28.000000', 'temperatura', 188.0000, 'ºC'),
	(13617, 109, '2015-01-15 00:46:29.000000', 'temperatura', 855.0000, 'ºC'),
	(13618, 109, '2015-01-15 00:46:30.000000', 'temperatura', 111.0000, 'ºC'),
	(13619, 109, '2015-01-15 00:46:31.000000', 'temperatura', 389.0000, 'ºC'),
	(13620, 109, '2015-01-15 00:46:32.000000', 'temperatura', 416.0000, 'ºC'),
	(13621, 109, '2015-01-15 00:46:33.000000', 'temperatura', 911.0000, 'ºC'),
	(13622, 109, '2015-01-15 00:46:34.000000', 'temperatura', 910.0000, 'ºC'),
	(13623, 109, '2015-01-15 00:46:35.000000', 'temperatura', 616.0000, 'ºC'),
	(13624, 109, '2015-01-15 00:46:36.000000', 'temperatura', 350.0000, 'ºC'),
	(13625, 109, '2015-01-15 00:46:37.000000', 'temperatura', 1103.0000, 'ºC'),
	(13626, 109, '2015-01-15 00:46:38.000000', 'temperatura', 866.0000, 'ºC'),
	(13627, 109, '2015-01-15 00:46:39.000000', 'temperatura', 1022.0000, 'ºC'),
	(13628, 109, '2015-01-15 00:46:40.000000', 'temperatura', 110.0000, 'ºC'),
	(13629, 109, '2015-01-15 00:46:41.000000', 'temperatura', 1088.0000, 'ºC'),
	(13630, 109, '2015-01-15 00:46:42.000000', 'temperatura', 307.0000, 'ºC'),
	(13631, 109, '2015-01-15 00:46:43.000000', 'temperatura', 674.0000, 'ºC'),
	(13632, 109, '2015-01-15 00:46:44.000000', 'temperatura', 50.0000, 'ºC'),
	(13633, 109, '2015-01-15 00:46:45.000000', 'temperatura', 629.0000, 'ºC'),
	(13634, 109, '2015-01-15 00:46:46.000000', 'temperatura', 594.0000, 'ºC'),
	(13635, 109, '2015-01-15 00:46:47.000000', 'temperatura', 1083.0000, 'ºC'),
	(13636, 109, '2015-01-15 00:46:48.000000', 'temperatura', 34.0000, 'ºC'),
	(13637, 109, '2015-01-15 00:46:49.000000', 'temperatura', 523.0000, 'ºC'),
	(13638, 109, '2015-01-15 00:46:50.000000', 'temperatura', 111.0000, 'ºC'),
	(13639, 109, '2015-01-15 00:46:51.000000', 'temperatura', 190.0000, 'ºC'),
	(13640, 109, '2015-01-15 00:46:52.000000', 'temperatura', 614.0000, 'ºC'),
	(13641, 109, '2015-01-15 00:46:53.000000', 'temperatura', 103.0000, 'ºC'),
	(13642, 109, '2015-01-15 00:46:54.000000', 'temperatura', 1074.0000, 'ºC'),
	(13643, 109, '2015-01-15 00:46:55.000000', 'temperatura', 259.0000, 'ºC'),
	(13644, 109, '2015-01-15 00:46:56.000000', 'temperatura', 474.0000, 'ºC'),
	(13645, 109, '2015-01-15 00:46:57.000000', 'temperatura', 394.0000, 'ºC'),
	(13646, 109, '2015-01-15 00:46:58.000000', 'temperatura', 549.0000, 'ºC'),
	(13647, 109, '2015-01-15 00:46:59.000000', 'temperatura', 362.0000, 'ºC'),
	(13648, 109, '2015-01-15 00:47:00.000000', 'temperatura', 162.0000, 'ºC'),
	(13649, 109, '2015-01-15 00:47:01.000000', 'temperatura', 928.0000, 'ºC'),
	(13650, 109, '2015-01-15 00:47:02.000000', 'temperatura', 552.0000, 'ºC'),
	(13651, 109, '2015-01-15 00:47:03.000000', 'temperatura', 1177.0000, 'ºC'),
	(13652, 109, '2015-01-15 00:47:04.000000', 'temperatura', 631.0000, 'ºC'),
	(13653, 109, '2015-01-15 00:47:05.000000', 'temperatura', 825.0000, 'ºC'),
	(13654, 109, '2015-01-15 00:47:06.000000', 'temperatura', 1033.0000, 'ºC'),
	(13655, 109, '2015-01-15 00:47:07.000000', 'temperatura', 289.0000, 'ºC'),
	(13656, 109, '2015-01-15 00:47:08.000000', 'temperatura', 749.0000, 'ºC'),
	(13657, 109, '2015-01-15 00:47:09.000000', 'temperatura', 476.0000, 'ºC'),
	(13658, 109, '2015-01-15 00:47:10.000000', 'temperatura', 135.0000, 'ºC'),
	(13659, 109, '2015-01-15 00:47:11.000000', 'temperatura', 448.0000, 'ºC'),
	(13660, 109, '2015-01-15 00:47:12.000000', 'temperatura', 636.0000, 'ºC'),
	(13661, 109, '2015-01-15 00:47:13.000000', 'temperatura', 636.0000, 'ºC'),
	(13662, 109, '2015-01-15 00:47:14.000000', 'temperatura', 72.0000, 'ºC'),
	(13663, 109, '2015-01-15 00:47:15.000000', 'temperatura', 854.0000, 'ºC'),
	(13664, 109, '2015-01-15 00:47:16.000000', 'temperatura', 453.0000, 'ºC'),
	(13665, 109, '2015-01-15 00:47:17.000000', 'temperatura', 902.0000, 'ºC'),
	(13666, 109, '2015-01-15 00:47:18.000000', 'temperatura', 753.0000, 'ºC'),
	(13667, 109, '2015-01-15 00:47:19.000000', 'temperatura', 1059.0000, 'ºC'),
	(13668, 109, '2015-01-15 00:47:20.000000', 'temperatura', 635.0000, 'ºC'),
	(13669, 109, '2015-01-15 00:47:21.000000', 'temperatura', 1198.0000, 'ºC'),
	(13670, 109, '2015-01-15 00:47:22.000000', 'temperatura', 488.0000, 'ºC'),
	(13671, 109, '2015-01-15 00:47:23.000000', 'temperatura', 47.0000, 'ºC'),
	(13672, 109, '2015-01-15 00:47:24.000000', 'temperatura', 1169.0000, 'ºC'),
	(13673, 109, '2015-01-15 00:47:25.000000', 'temperatura', 907.0000, 'ºC'),
	(13674, 109, '2015-01-15 00:47:26.000000', 'temperatura', 1026.0000, 'ºC'),
	(13675, 109, '2015-01-15 00:47:27.000000', 'temperatura', 10.0000, 'ºC'),
	(13676, 109, '2015-01-15 00:47:28.000000', 'temperatura', 574.0000, 'ºC'),
	(13677, 109, '2015-01-15 00:47:29.000000', 'temperatura', 440.0000, 'ºC'),
	(13678, 109, '2015-01-15 00:47:30.000000', 'temperatura', 479.0000, 'ºC'),
	(13679, 109, '2015-01-15 00:47:31.000000', 'temperatura', 1074.0000, 'ºC'),
	(13680, 109, '2015-01-15 00:47:32.000000', 'temperatura', 336.0000, 'ºC'),
	(13681, 109, '2015-01-15 00:47:33.000000', 'temperatura', 857.0000, 'ºC'),
	(13682, 109, '2015-01-15 00:47:34.000000', 'temperatura', 879.0000, 'ºC'),
	(13683, 109, '2015-01-15 00:47:35.000000', 'temperatura', 623.0000, 'ºC'),
	(13684, 109, '2015-01-15 00:47:36.000000', 'temperatura', 478.0000, 'ºC'),
	(13685, 109, '2015-01-15 00:47:37.000000', 'temperatura', 524.0000, 'ºC'),
	(13686, 109, '2015-01-15 00:47:38.000000', 'temperatura', 1186.0000, 'ºC'),
	(13687, 109, '2015-01-15 00:47:39.000000', 'temperatura', 758.0000, 'ºC'),
	(13688, 109, '2015-01-15 00:47:40.000000', 'temperatura', 235.0000, 'ºC'),
	(13689, 109, '2015-01-15 00:47:41.000000', 'temperatura', 98.0000, 'ºC'),
	(13690, 109, '2015-01-15 00:47:42.000000', 'temperatura', 985.0000, 'ºC'),
	(13691, 109, '2015-01-15 00:47:43.000000', 'temperatura', 1032.0000, 'ºC'),
	(13692, 109, '2015-01-15 00:47:44.000000', 'temperatura', 1007.0000, 'ºC'),
	(13693, 109, '2015-01-15 00:47:45.000000', 'temperatura', 739.0000, 'ºC'),
	(13694, 109, '2015-01-15 00:47:46.000000', 'temperatura', 673.0000, 'ºC'),
	(13695, 109, '2015-01-15 00:47:47.000000', 'temperatura', 1149.0000, 'ºC'),
	(13696, 109, '2015-01-15 00:47:48.000000', 'temperatura', 127.0000, 'ºC'),
	(13697, 109, '2015-01-15 00:47:49.000000', 'temperatura', 787.0000, 'ºC'),
	(13698, 109, '2015-01-15 00:47:50.000000', 'temperatura', 1157.0000, 'ºC'),
	(13699, 109, '2015-01-15 00:47:51.000000', 'temperatura', 1022.0000, 'ºC'),
	(13700, 109, '2015-01-15 00:47:52.000000', 'temperatura', 440.0000, 'ºC'),
	(13701, 109, '2015-01-15 00:47:53.000000', 'temperatura', 334.0000, 'ºC'),
	(13702, 109, '2015-01-15 00:47:54.000000', 'temperatura', 350.0000, 'ºC'),
	(13703, 109, '2015-01-15 00:47:55.000000', 'temperatura', 750.0000, 'ºC'),
	(13704, 109, '2015-01-15 00:47:56.000000', 'temperatura', 299.0000, 'ºC'),
	(13705, 109, '2015-01-15 00:47:57.000000', 'temperatura', 446.0000, 'ºC'),
	(13706, 109, '2015-01-15 00:47:58.000000', 'temperatura', 132.0000, 'ºC'),
	(13707, 109, '2015-01-15 00:47:59.000000', 'temperatura', 522.0000, 'ºC'),
	(13708, 109, '2015-01-15 00:48:00.000000', 'temperatura', 1014.0000, 'ºC'),
	(13709, 109, '2015-01-15 00:48:01.000000', 'temperatura', 1104.0000, 'ºC'),
	(13710, 109, '2015-01-15 00:48:02.000000', 'temperatura', 78.0000, 'ºC'),
	(13711, 109, '2015-01-15 00:48:03.000000', 'temperatura', 680.0000, 'ºC'),
	(13712, 109, '2015-01-15 00:48:04.000000', 'temperatura', 767.0000, 'ºC'),
	(13713, 109, '2015-01-15 00:48:05.000000', 'temperatura', 596.0000, 'ºC'),
	(13714, 109, '2015-01-15 00:48:06.000000', 'temperatura', 680.0000, 'ºC'),
	(13715, 109, '2015-01-15 00:48:07.000000', 'temperatura', 412.0000, 'ºC'),
	(13716, 109, '2015-01-15 00:48:08.000000', 'temperatura', 19.0000, 'ºC'),
	(13717, 109, '2015-01-15 00:48:09.000000', 'temperatura', 61.0000, 'ºC'),
	(13718, 109, '2015-01-15 00:48:10.000000', 'temperatura', 246.0000, 'ºC'),
	(13719, 109, '2015-01-15 00:48:11.000000', 'temperatura', 1049.0000, 'ºC'),
	(13720, 109, '2015-01-15 00:48:12.000000', 'temperatura', 907.0000, 'ºC'),
	(13721, 109, '2015-01-15 00:48:13.000000', 'temperatura', 189.0000, 'ºC'),
	(13722, 109, '2015-01-15 00:48:14.000000', 'temperatura', 626.0000, 'ºC'),
	(13723, 109, '2015-01-15 00:48:15.000000', 'temperatura', 164.0000, 'ºC'),
	(13724, 109, '2015-01-15 00:48:16.000000', 'temperatura', 143.0000, 'ºC'),
	(13725, 109, '2015-01-15 00:48:17.000000', 'temperatura', 221.0000, 'ºC'),
	(13726, 109, '2015-01-15 00:48:18.000000', 'temperatura', 678.0000, 'ºC'),
	(13727, 109, '2015-01-15 00:48:19.000000', 'temperatura', 327.0000, 'ºC'),
	(13728, 109, '2015-01-15 00:48:20.000000', 'temperatura', 800.0000, 'ºC'),
	(13729, 109, '2015-01-15 00:48:21.000000', 'temperatura', 623.0000, 'ºC'),
	(13730, 109, '2015-01-15 00:48:22.000000', 'temperatura', 712.0000, 'ºC'),
	(13731, 109, '2015-01-15 00:48:23.000000', 'temperatura', 493.0000, 'ºC'),
	(13732, 109, '2015-01-15 00:48:24.000000', 'temperatura', 330.0000, 'ºC'),
	(13733, 109, '2015-01-15 00:48:25.000000', 'temperatura', 173.0000, 'ºC'),
	(13734, 109, '2015-01-15 00:48:26.000000', 'temperatura', 1072.0000, 'ºC'),
	(13735, 109, '2015-01-15 00:48:27.000000', 'temperatura', 44.0000, 'ºC'),
	(13736, 109, '2015-01-15 00:48:28.000000', 'temperatura', 603.0000, 'ºC'),
	(13737, 109, '2015-01-15 00:48:29.000000', 'temperatura', 484.0000, 'ºC'),
	(13738, 109, '2015-01-15 00:48:30.000000', 'temperatura', 610.0000, 'ºC'),
	(13739, 109, '2015-01-15 00:48:31.000000', 'temperatura', 401.0000, 'ºC'),
	(13740, 109, '2015-01-15 00:48:32.000000', 'temperatura', 173.0000, 'ºC'),
	(13741, 109, '2015-01-15 00:48:33.000000', 'temperatura', 863.0000, 'ºC'),
	(13742, 109, '2015-01-15 00:48:34.000000', 'temperatura', 199.0000, 'ºC'),
	(13743, 109, '2015-01-15 00:48:35.000000', 'temperatura', 805.0000, 'ºC'),
	(13744, 109, '2015-01-15 00:48:36.000000', 'temperatura', 1029.0000, 'ºC'),
	(13745, 109, '2015-01-15 00:48:37.000000', 'temperatura', 331.0000, 'ºC'),
	(13746, 109, '2015-01-15 00:48:38.000000', 'temperatura', 967.0000, 'ºC'),
	(13747, 109, '2015-01-15 00:48:39.000000', 'temperatura', 245.0000, 'ºC'),
	(13748, 109, '2015-01-15 00:48:40.000000', 'temperatura', 723.0000, 'ºC'),
	(13749, 109, '2015-01-15 00:48:41.000000', 'temperatura', 482.0000, 'ºC'),
	(13750, 109, '2015-01-15 00:48:42.000000', 'temperatura', 240.0000, 'ºC'),
	(13751, 109, '2015-01-15 00:48:43.000000', 'temperatura', 953.0000, 'ºC'),
	(13752, 109, '2015-01-15 00:48:44.000000', 'temperatura', 448.0000, 'ºC'),
	(13753, 109, '2015-01-15 00:48:45.000000', 'temperatura', 582.0000, 'ºC'),
	(13754, 109, '2015-01-15 00:48:46.000000', 'temperatura', 365.0000, 'ºC'),
	(13755, 109, '2015-01-15 00:48:47.000000', 'temperatura', 80.0000, 'ºC'),
	(13756, 109, '2015-01-15 00:48:48.000000', 'temperatura', 505.0000, 'ºC'),
	(13757, 109, '2015-01-15 00:48:49.000000', 'temperatura', 1085.0000, 'ºC'),
	(13758, 109, '2015-01-15 00:48:50.000000', 'temperatura', 312.0000, 'ºC'),
	(13759, 109, '2015-01-15 00:48:51.000000', 'temperatura', 703.0000, 'ºC'),
	(13760, 109, '2015-01-15 00:48:52.000000', 'temperatura', 180.0000, 'ºC'),
	(13761, 109, '2015-01-15 00:48:53.000000', 'temperatura', 1193.0000, 'ºC'),
	(13762, 109, '2015-01-15 00:48:54.000000', 'temperatura', 623.0000, 'ºC'),
	(13763, 109, '2015-01-15 00:48:55.000000', 'temperatura', 739.0000, 'ºC'),
	(13764, 109, '2015-01-15 00:48:56.000000', 'temperatura', 625.0000, 'ºC'),
	(13765, 109, '2015-01-15 00:48:57.000000', 'temperatura', 910.0000, 'ºC'),
	(13766, 109, '2015-01-15 00:48:58.000000', 'temperatura', 275.0000, 'ºC'),
	(13767, 109, '2015-01-15 00:48:59.000000', 'temperatura', 1046.0000, 'ºC'),
	(13768, 109, '2015-01-15 00:49:00.000000', 'temperatura', 805.0000, 'ºC'),
	(13769, 109, '2015-01-15 00:49:01.000000', 'temperatura', 888.0000, 'ºC'),
	(13770, 109, '2015-01-15 00:49:02.000000', 'temperatura', 825.0000, 'ºC'),
	(13771, 109, '2015-01-15 00:49:03.000000', 'temperatura', 261.0000, 'ºC'),
	(13772, 109, '2015-01-15 00:49:04.000000', 'temperatura', 30.0000, 'ºC'),
	(13773, 109, '2015-01-15 00:49:05.000000', 'temperatura', 567.0000, 'ºC'),
	(13774, 109, '2015-01-15 00:49:06.000000', 'temperatura', 346.0000, 'ºC'),
	(13775, 109, '2015-01-15 00:49:07.000000', 'temperatura', 28.0000, 'ºC'),
	(13776, 109, '2015-01-15 00:49:08.000000', 'temperatura', 303.0000, 'ºC'),
	(13777, 109, '2015-01-15 00:49:09.000000', 'temperatura', 233.0000, 'ºC'),
	(13778, 109, '2015-01-15 00:49:10.000000', 'temperatura', 255.0000, 'ºC'),
	(13779, 109, '2015-01-15 00:49:11.000000', 'temperatura', 578.0000, 'ºC'),
	(13780, 109, '2015-01-15 00:49:12.000000', 'temperatura', 924.0000, 'ºC'),
	(13781, 109, '2015-01-15 00:49:13.000000', 'temperatura', 489.0000, 'ºC'),
	(13782, 109, '2015-01-15 00:49:14.000000', 'temperatura', 871.0000, 'ºC'),
	(13783, 109, '2015-01-15 00:49:15.000000', 'temperatura', 491.0000, 'ºC'),
	(13784, 109, '2015-01-15 00:49:16.000000', 'temperatura', 1041.0000, 'ºC'),
	(13785, 109, '2015-01-15 00:49:17.000000', 'temperatura', 131.0000, 'ºC'),
	(13786, 109, '2015-01-15 00:49:18.000000', 'temperatura', 1134.0000, 'ºC'),
	(13787, 109, '2015-01-15 00:49:19.000000', 'temperatura', 478.0000, 'ºC'),
	(13788, 109, '2015-01-15 00:49:20.000000', 'temperatura', 189.0000, 'ºC'),
	(13789, 109, '2015-01-15 00:49:21.000000', 'temperatura', 711.0000, 'ºC'),
	(13790, 109, '2015-01-15 00:49:22.000000', 'temperatura', 587.0000, 'ºC'),
	(13791, 109, '2015-01-15 00:49:23.000000', 'temperatura', 803.0000, 'ºC'),
	(13792, 109, '2015-01-15 00:49:24.000000', 'temperatura', 1053.0000, 'ºC'),
	(13793, 109, '2015-01-15 00:49:25.000000', 'temperatura', 459.0000, 'ºC'),
	(13794, 109, '2015-01-15 00:49:26.000000', 'temperatura', 334.0000, 'ºC'),
	(13795, 109, '2015-01-15 00:49:27.000000', 'temperatura', 296.0000, 'ºC'),
	(13796, 109, '2015-01-15 00:49:28.000000', 'temperatura', 477.0000, 'ºC'),
	(13797, 109, '2015-01-15 00:49:29.000000', 'temperatura', 298.0000, 'ºC'),
	(13798, 109, '2015-01-15 00:49:30.000000', 'temperatura', 59.0000, 'ºC'),
	(13799, 109, '2015-01-15 00:49:31.000000', 'temperatura', 601.0000, 'ºC'),
	(13800, 109, '2015-01-15 00:49:32.000000', 'temperatura', 427.0000, 'ºC'),
	(13801, 109, '2015-01-15 00:49:33.000000', 'temperatura', 336.0000, 'ºC'),
	(13802, 109, '2015-01-15 00:49:34.000000', 'temperatura', 396.0000, 'ºC'),
	(13803, 109, '2015-01-15 00:49:35.000000', 'temperatura', 976.0000, 'ºC'),
	(13804, 109, '2015-01-15 00:49:36.000000', 'temperatura', 91.0000, 'ºC'),
	(13805, 109, '2015-01-15 00:49:37.000000', 'temperatura', 1128.0000, 'ºC'),
	(13806, 109, '2015-01-15 00:49:38.000000', 'temperatura', 567.0000, 'ºC'),
	(13807, 109, '2015-01-15 00:49:39.000000', 'temperatura', 651.0000, 'ºC'),
	(13808, 109, '2015-01-15 00:49:40.000000', 'temperatura', 353.0000, 'ºC'),
	(13809, 109, '2015-01-15 00:49:41.000000', 'temperatura', 1015.0000, 'ºC'),
	(13810, 109, '2015-01-15 00:49:42.000000', 'temperatura', 415.0000, 'ºC'),
	(13811, 109, '2015-01-15 00:49:43.000000', 'temperatura', 231.0000, 'ºC'),
	(13812, 109, '2015-01-15 00:49:44.000000', 'temperatura', 1112.0000, 'ºC'),
	(13813, 109, '2015-01-15 00:49:45.000000', 'temperatura', 66.0000, 'ºC'),
	(13814, 109, '2015-01-15 00:49:46.000000', 'temperatura', 593.0000, 'ºC'),
	(13815, 109, '2015-01-15 00:49:47.000000', 'temperatura', 369.0000, 'ºC'),
	(13816, 109, '2015-01-15 00:49:48.000000', 'temperatura', 68.0000, 'ºC'),
	(13817, 109, '2015-01-15 00:49:49.000000', 'temperatura', 432.0000, 'ºC'),
	(13818, 109, '2015-01-15 00:49:50.000000', 'temperatura', 755.0000, 'ºC'),
	(13819, 109, '2015-01-15 00:49:51.000000', 'temperatura', 82.0000, 'ºC'),
	(13820, 109, '2015-01-15 00:49:52.000000', 'temperatura', 543.0000, 'ºC'),
	(13821, 109, '2015-01-15 00:49:53.000000', 'temperatura', 70.0000, 'ºC'),
	(13822, 109, '2015-01-15 00:49:54.000000', 'temperatura', 1124.0000, 'ºC'),
	(13823, 109, '2015-01-15 00:49:55.000000', 'temperatura', 609.0000, 'ºC'),
	(13824, 109, '2015-01-15 00:49:56.000000', 'temperatura', 874.0000, 'ºC'),
	(13825, 109, '2015-01-15 00:49:57.000000', 'temperatura', 145.0000, 'ºC'),
	(13826, 109, '2015-01-15 00:49:58.000000', 'temperatura', 502.0000, 'ºC'),
	(13827, 109, '2015-01-15 00:49:59.000000', 'temperatura', 874.0000, 'ºC'),
	(13828, 109, '2015-01-15 00:50:00.000000', 'temperatura', 466.0000, 'ºC'),
	(13829, 109, '2015-01-15 00:50:01.000000', 'temperatura', 908.0000, 'ºC'),
	(13830, 109, '2015-01-15 00:50:02.000000', 'temperatura', 745.0000, 'ºC'),
	(13831, 109, '2015-01-15 00:50:03.000000', 'temperatura', 999.0000, 'ºC'),
	(13832, 109, '2015-01-15 00:50:04.000000', 'temperatura', 360.0000, 'ºC'),
	(13833, 109, '2015-01-15 00:50:05.000000', 'temperatura', 4.0000, 'ºC'),
	(13834, 109, '2015-01-15 00:50:06.000000', 'temperatura', 139.0000, 'ºC'),
	(13835, 109, '2015-01-15 00:50:07.000000', 'temperatura', 685.0000, 'ºC'),
	(13836, 109, '2015-01-15 00:50:08.000000', 'temperatura', 606.0000, 'ºC'),
	(13837, 109, '2015-01-15 00:50:09.000000', 'temperatura', 979.0000, 'ºC'),
	(13838, 109, '2015-01-15 00:50:10.000000', 'temperatura', 674.0000, 'ºC'),
	(13839, 109, '2015-01-15 00:50:11.000000', 'temperatura', 435.0000, 'ºC'),
	(13840, 109, '2015-01-15 00:50:12.000000', 'temperatura', 155.0000, 'ºC'),
	(13841, 109, '2015-01-15 00:50:13.000000', 'temperatura', 671.0000, 'ºC'),
	(13842, 109, '2015-01-15 00:50:14.000000', 'temperatura', 490.0000, 'ºC'),
	(13843, 109, '2015-01-15 00:50:15.000000', 'temperatura', 435.0000, 'ºC'),
	(13844, 109, '2015-01-15 00:50:16.000000', 'temperatura', 707.0000, 'ºC'),
	(13845, 109, '2015-01-15 00:50:17.000000', 'temperatura', 1030.0000, 'ºC'),
	(13846, 109, '2015-01-15 00:50:18.000000', 'temperatura', 628.0000, 'ºC'),
	(13847, 109, '2015-01-15 00:50:19.000000', 'temperatura', 51.0000, 'ºC'),
	(13848, 109, '2015-01-15 00:50:20.000000', 'temperatura', 774.0000, 'ºC'),
	(13849, 109, '2015-01-15 00:50:21.000000', 'temperatura', 116.0000, 'ºC'),
	(13850, 109, '2015-01-15 00:50:22.000000', 'temperatura', 658.0000, 'ºC'),
	(13851, 109, '2015-01-15 00:50:23.000000', 'temperatura', 543.0000, 'ºC'),
	(13852, 109, '2015-01-15 00:50:24.000000', 'temperatura', 743.0000, 'ºC'),
	(13853, 109, '2015-01-15 00:50:25.000000', 'temperatura', 883.0000, 'ºC'),
	(13854, 109, '2015-01-15 00:50:26.000000', 'temperatura', 990.0000, 'ºC'),
	(13855, 109, '2015-01-15 00:50:27.000000', 'temperatura', 1098.0000, 'ºC'),
	(13856, 109, '2015-01-15 00:50:28.000000', 'temperatura', 124.0000, 'ºC'),
	(13857, 109, '2015-01-15 00:50:29.000000', 'temperatura', 925.0000, 'ºC'),
	(13858, 109, '2015-01-15 00:50:30.000000', 'temperatura', 655.0000, 'ºC'),
	(13859, 109, '2015-01-15 00:50:31.000000', 'temperatura', 498.0000, 'ºC'),
	(13860, 109, '2015-01-15 00:50:32.000000', 'temperatura', 528.0000, 'ºC'),
	(13861, 109, '2015-01-15 00:50:33.000000', 'temperatura', 1147.0000, 'ºC'),
	(13862, 109, '2015-01-15 00:50:34.000000', 'temperatura', 550.0000, 'ºC'),
	(13863, 109, '2015-01-15 00:50:35.000000', 'temperatura', 511.0000, 'ºC'),
	(13864, 109, '2015-01-15 00:50:36.000000', 'temperatura', 906.0000, 'ºC'),
	(13865, 109, '2015-01-15 00:50:37.000000', 'temperatura', 598.0000, 'ºC'),
	(13866, 109, '2015-01-15 00:50:38.000000', 'temperatura', 270.0000, 'ºC'),
	(13867, 109, '2015-01-15 00:50:39.000000', 'temperatura', 756.0000, 'ºC'),
	(13868, 109, '2015-01-15 00:50:40.000000', 'temperatura', 571.0000, 'ºC'),
	(13869, 109, '2015-01-15 00:50:41.000000', 'temperatura', 588.0000, 'ºC'),
	(13870, 109, '2015-01-15 00:50:42.000000', 'temperatura', 26.0000, 'ºC'),
	(13871, 109, '2015-01-15 00:50:43.000000', 'temperatura', 770.0000, 'ºC'),
	(13872, 109, '2015-01-15 00:50:44.000000', 'temperatura', 169.0000, 'ºC'),
	(13873, 109, '2015-01-15 00:50:45.000000', 'temperatura', 936.0000, 'ºC'),
	(13874, 109, '2015-01-15 00:50:46.000000', 'temperatura', 574.0000, 'ºC'),
	(13875, 109, '2015-01-15 00:50:47.000000', 'temperatura', 61.0000, 'ºC'),
	(13876, 109, '2015-01-15 00:50:48.000000', 'temperatura', 983.0000, 'ºC'),
	(13877, 109, '2015-01-15 00:50:49.000000', 'temperatura', 1133.0000, 'ºC'),
	(13878, 109, '2015-01-15 00:50:50.000000', 'temperatura', 316.0000, 'ºC'),
	(13879, 109, '2015-01-15 00:50:51.000000', 'temperatura', 580.0000, 'ºC'),
	(13880, 109, '2015-01-15 00:50:52.000000', 'temperatura', 756.0000, 'ºC'),
	(13881, 109, '2015-01-15 00:50:53.000000', 'temperatura', 838.0000, 'ºC'),
	(13882, 109, '2015-01-15 00:50:54.000000', 'temperatura', 724.0000, 'ºC'),
	(13883, 109, '2015-01-15 00:50:55.000000', 'temperatura', 1106.0000, 'ºC'),
	(13884, 109, '2015-01-15 00:50:56.000000', 'temperatura', 958.0000, 'ºC'),
	(13885, 109, '2015-01-15 00:50:57.000000', 'temperatura', 274.0000, 'ºC'),
	(13886, 109, '2015-01-15 00:50:58.000000', 'temperatura', 895.0000, 'ºC'),
	(13887, 109, '2015-01-15 00:50:59.000000', 'temperatura', 56.0000, 'ºC'),
	(13888, 109, '2015-01-15 00:51:00.000000', 'temperatura', 1194.0000, 'ºC'),
	(13889, 109, '2015-01-15 00:51:01.000000', 'temperatura', 1001.0000, 'ºC'),
	(13890, 109, '2015-01-15 00:51:02.000000', 'temperatura', 224.0000, 'ºC'),
	(13891, 109, '2015-01-15 00:51:03.000000', 'temperatura', 519.0000, 'ºC'),
	(13892, 109, '2015-01-15 00:51:04.000000', 'temperatura', 725.0000, 'ºC'),
	(13893, 109, '2015-01-15 00:51:05.000000', 'temperatura', 866.0000, 'ºC'),
	(13894, 109, '2015-01-15 00:51:06.000000', 'temperatura', 955.0000, 'ºC'),
	(13895, 109, '2015-01-15 00:51:07.000000', 'temperatura', 980.0000, 'ºC'),
	(13896, 109, '2015-01-15 00:51:08.000000', 'temperatura', 834.0000, 'ºC'),
	(13897, 109, '2015-01-15 00:51:09.000000', 'temperatura', 32.0000, 'ºC'),
	(13898, 109, '2015-01-15 00:51:10.000000', 'temperatura', 56.0000, 'ºC'),
	(13899, 109, '2015-01-15 00:51:11.000000', 'temperatura', 184.0000, 'ºC'),
	(13900, 109, '2015-01-15 00:51:12.000000', 'temperatura', 755.0000, 'ºC'),
	(13901, 109, '2015-01-15 00:51:13.000000', 'temperatura', 822.0000, 'ºC'),
	(13902, 109, '2015-01-15 00:51:14.000000', 'temperatura', 645.0000, 'ºC'),
	(13903, 109, '2015-01-15 00:51:15.000000', 'temperatura', 762.0000, 'ºC'),
	(13904, 109, '2015-01-15 00:51:16.000000', 'temperatura', 672.0000, 'ºC'),
	(13905, 109, '2015-01-15 00:51:17.000000', 'temperatura', 1076.0000, 'ºC'),
	(13906, 109, '2015-01-15 00:51:18.000000', 'temperatura', 966.0000, 'ºC'),
	(13907, 109, '2015-01-15 00:51:19.000000', 'temperatura', 401.0000, 'ºC'),
	(13908, 109, '2015-01-15 00:51:20.000000', 'temperatura', 307.0000, 'ºC'),
	(13909, 109, '2015-01-15 00:51:21.000000', 'temperatura', 333.0000, 'ºC'),
	(13910, 109, '2015-01-15 00:51:22.000000', 'temperatura', 744.0000, 'ºC'),
	(13911, 109, '2015-01-15 00:51:23.000000', 'temperatura', 324.0000, 'ºC'),
	(13912, 109, '2015-01-15 00:51:24.000000', 'temperatura', 586.0000, 'ºC'),
	(13913, 109, '2015-01-15 00:51:25.000000', 'temperatura', 757.0000, 'ºC'),
	(13914, 109, '2015-01-15 00:51:26.000000', 'temperatura', 831.0000, 'ºC'),
	(13915, 109, '2015-01-15 00:51:27.000000', 'temperatura', 684.0000, 'ºC'),
	(13916, 109, '2015-01-15 00:51:28.000000', 'temperatura', 926.0000, 'ºC'),
	(13917, 109, '2015-01-15 00:51:29.000000', 'temperatura', 177.0000, 'ºC'),
	(13918, 109, '2015-01-15 00:51:30.000000', 'temperatura', 509.0000, 'ºC'),
	(13919, 109, '2015-01-15 00:51:31.000000', 'temperatura', 817.0000, 'ºC'),
	(13920, 109, '2015-01-15 00:51:32.000000', 'temperatura', 155.0000, 'ºC'),
	(13921, 109, '2015-01-15 00:51:33.000000', 'temperatura', 726.0000, 'ºC'),
	(13922, 109, '2015-01-15 00:51:34.000000', 'temperatura', 765.0000, 'ºC'),
	(13923, 109, '2015-01-15 00:51:35.000000', 'temperatura', 446.0000, 'ºC'),
	(13924, 109, '2015-01-15 00:51:36.000000', 'temperatura', 1136.0000, 'ºC'),
	(13925, 109, '2015-01-15 00:51:37.000000', 'temperatura', 741.0000, 'ºC'),
	(13926, 109, '2015-01-15 00:51:38.000000', 'temperatura', 300.0000, 'ºC'),
	(13927, 109, '2015-01-15 00:51:39.000000', 'temperatura', 478.0000, 'ºC'),
	(13928, 109, '2015-01-15 00:51:40.000000', 'temperatura', 290.0000, 'ºC'),
	(13929, 109, '2015-01-15 00:51:41.000000', 'temperatura', 18.0000, 'ºC'),
	(13930, 109, '2015-01-15 00:51:42.000000', 'temperatura', 421.0000, 'ºC'),
	(13931, 109, '2015-01-15 00:51:43.000000', 'temperatura', 850.0000, 'ºC'),
	(13932, 109, '2015-01-15 00:51:44.000000', 'temperatura', 586.0000, 'ºC'),
	(13933, 109, '2015-01-15 00:51:45.000000', 'temperatura', 380.0000, 'ºC'),
	(13934, 109, '2015-01-15 00:51:46.000000', 'temperatura', 145.0000, 'ºC'),
	(13935, 109, '2015-01-15 00:51:47.000000', 'temperatura', 783.0000, 'ºC'),
	(13936, 109, '2015-01-15 00:51:48.000000', 'temperatura', 1082.0000, 'ºC'),
	(13937, 109, '2015-01-15 00:51:49.000000', 'temperatura', 659.0000, 'ºC'),
	(13938, 109, '2015-01-15 00:51:50.000000', 'temperatura', 53.0000, 'ºC'),
	(13939, 109, '2015-01-15 00:51:51.000000', 'temperatura', 688.0000, 'ºC'),
	(13940, 109, '2015-01-15 00:51:52.000000', 'temperatura', 879.0000, 'ºC'),
	(13941, 109, '2015-01-15 00:51:53.000000', 'temperatura', 1132.0000, 'ºC'),
	(13942, 109, '2015-01-15 00:51:54.000000', 'temperatura', 625.0000, 'ºC'),
	(13943, 109, '2015-01-15 00:51:55.000000', 'temperatura', 929.0000, 'ºC'),
	(13944, 109, '2015-01-15 00:51:56.000000', 'temperatura', 370.0000, 'ºC'),
	(13945, 109, '2015-01-15 00:51:57.000000', 'temperatura', 265.0000, 'ºC'),
	(13946, 109, '2015-01-15 00:51:58.000000', 'temperatura', 214.0000, 'ºC'),
	(13947, 109, '2015-01-15 00:51:59.000000', 'temperatura', 278.0000, 'ºC'),
	(13948, 109, '2015-01-15 00:52:00.000000', 'temperatura', 747.0000, 'ºC'),
	(13949, 109, '2015-01-15 00:52:01.000000', 'temperatura', 500.0000, 'ºC'),
	(13950, 109, '2015-01-15 00:52:02.000000', 'temperatura', 260.0000, 'ºC'),
	(13951, 109, '2015-01-15 00:52:03.000000', 'temperatura', 1001.0000, 'ºC'),
	(13952, 109, '2015-01-15 00:52:04.000000', 'temperatura', 623.0000, 'ºC'),
	(13953, 109, '2015-01-15 00:52:05.000000', 'temperatura', 116.0000, 'ºC'),
	(13954, 109, '2015-01-15 00:52:06.000000', 'temperatura', 1112.0000, 'ºC'),
	(13955, 109, '2015-01-15 00:52:07.000000', 'temperatura', 409.0000, 'ºC'),
	(13956, 109, '2015-01-15 00:52:08.000000', 'temperatura', 1112.0000, 'ºC'),
	(13957, 109, '2015-01-15 00:52:09.000000', 'temperatura', 734.0000, 'ºC'),
	(13958, 109, '2015-01-15 00:52:10.000000', 'temperatura', 332.0000, 'ºC'),
	(13959, 109, '2015-01-15 00:52:11.000000', 'temperatura', 658.0000, 'ºC'),
	(13960, 109, '2015-01-15 00:52:12.000000', 'temperatura', 1097.0000, 'ºC'),
	(13961, 109, '2015-01-15 00:52:13.000000', 'temperatura', 1109.0000, 'ºC'),
	(13962, 109, '2015-01-15 00:52:14.000000', 'temperatura', 1054.0000, 'ºC'),
	(13963, 109, '2015-01-15 00:52:15.000000', 'temperatura', 743.0000, 'ºC'),
	(13964, 109, '2015-01-15 00:52:16.000000', 'temperatura', 557.0000, 'ºC'),
	(13965, 109, '2015-01-15 00:52:17.000000', 'temperatura', 554.0000, 'ºC'),
	(13966, 109, '2015-01-15 00:52:18.000000', 'temperatura', 1100.0000, 'ºC'),
	(13967, 109, '2015-01-15 00:52:19.000000', 'temperatura', 237.0000, 'ºC'),
	(13968, 109, '2015-01-15 00:52:20.000000', 'temperatura', 285.0000, 'ºC'),
	(13969, 109, '2015-01-15 00:52:21.000000', 'temperatura', 717.0000, 'ºC'),
	(13970, 109, '2015-01-15 00:52:22.000000', 'temperatura', 332.0000, 'ºC'),
	(13971, 109, '2015-01-15 00:52:23.000000', 'temperatura', 706.0000, 'ºC'),
	(13972, 109, '2015-01-15 00:52:24.000000', 'temperatura', 137.0000, 'ºC'),
	(13973, 109, '2015-01-15 00:52:25.000000', 'temperatura', 965.0000, 'ºC'),
	(13974, 109, '2015-01-15 00:52:26.000000', 'temperatura', 815.0000, 'ºC'),
	(13975, 109, '2015-01-15 00:52:27.000000', 'temperatura', 1181.0000, 'ºC'),
	(13976, 109, '2015-01-15 00:52:28.000000', 'temperatura', 1060.0000, 'ºC'),
	(13977, 109, '2015-01-15 00:52:29.000000', 'temperatura', 558.0000, 'ºC'),
	(13978, 109, '2015-01-15 00:52:30.000000', 'temperatura', 809.0000, 'ºC'),
	(13979, 109, '2015-01-15 00:52:31.000000', 'temperatura', 1174.0000, 'ºC'),
	(13980, 109, '2015-01-15 00:52:32.000000', 'temperatura', 1044.0000, 'ºC'),
	(13981, 109, '2015-01-15 00:52:33.000000', 'temperatura', 497.0000, 'ºC'),
	(13982, 109, '2015-01-15 00:52:34.000000', 'temperatura', 552.0000, 'ºC'),
	(13983, 109, '2015-01-15 00:52:35.000000', 'temperatura', 70.0000, 'ºC'),
	(13984, 109, '2015-01-15 00:52:36.000000', 'temperatura', 1095.0000, 'ºC'),
	(13985, 109, '2015-01-15 00:52:37.000000', 'temperatura', 466.0000, 'ºC'),
	(13986, 109, '2015-01-15 00:52:38.000000', 'temperatura', 246.0000, 'ºC'),
	(13987, 109, '2015-01-15 00:52:39.000000', 'temperatura', 1033.0000, 'ºC'),
	(13988, 109, '2015-01-15 00:52:40.000000', 'temperatura', 826.0000, 'ºC'),
	(13989, 109, '2015-01-15 00:52:41.000000', 'temperatura', 1031.0000, 'ºC'),
	(13990, 109, '2015-01-15 00:52:42.000000', 'temperatura', 278.0000, 'ºC'),
	(13991, 109, '2015-01-15 00:52:43.000000', 'temperatura', 699.0000, 'ºC'),
	(13992, 109, '2015-01-15 00:52:44.000000', 'temperatura', 259.0000, 'ºC'),
	(13993, 109, '2015-01-15 00:52:45.000000', 'temperatura', 401.0000, 'ºC'),
	(13994, 109, '2015-01-15 00:52:46.000000', 'temperatura', 27.0000, 'ºC'),
	(13995, 109, '2015-01-15 00:52:47.000000', 'temperatura', 132.0000, 'ºC'),
	(13996, 109, '2015-01-15 00:52:48.000000', 'temperatura', 578.0000, 'ºC'),
	(13997, 109, '2015-01-15 00:52:49.000000', 'temperatura', 97.0000, 'ºC'),
	(13998, 109, '2015-01-15 00:52:50.000000', 'temperatura', 1149.0000, 'ºC'),
	(13999, 109, '2015-01-15 00:52:51.000000', 'temperatura', 656.0000, 'ºC'),
	(14000, 109, '2015-01-15 00:52:52.000000', 'temperatura', 1035.0000, 'ºC'),
	(14001, 109, '2015-01-15 00:52:53.000000', 'temperatura', 807.0000, 'ºC'),
	(14002, 109, '2015-01-15 00:52:54.000000', 'temperatura', 929.0000, 'ºC'),
	(14003, 109, '2015-01-15 00:52:55.000000', 'temperatura', 1027.0000, 'ºC'),
	(14004, 109, '2015-01-15 00:52:56.000000', 'temperatura', 1148.0000, 'ºC'),
	(14005, 109, '2015-01-15 00:52:57.000000', 'temperatura', 260.0000, 'ºC'),
	(14006, 109, '2015-01-15 00:52:58.000000', 'temperatura', 257.0000, 'ºC'),
	(14007, 109, '2015-01-15 00:52:59.000000', 'temperatura', 505.0000, 'ºC'),
	(14008, 109, '2015-01-15 00:53:00.000000', 'temperatura', 553.0000, 'ºC'),
	(14009, 109, '2015-01-15 00:53:01.000000', 'temperatura', 53.0000, 'ºC'),
	(14010, 109, '2015-01-15 00:53:02.000000', 'temperatura', 1007.0000, 'ºC'),
	(14011, 109, '2015-01-15 00:53:03.000000', 'temperatura', 77.0000, 'ºC'),
	(14012, 109, '2015-01-15 00:53:04.000000', 'temperatura', 963.0000, 'ºC'),
	(14013, 109, '2015-01-15 00:53:05.000000', 'temperatura', 985.0000, 'ºC'),
	(14014, 109, '2015-01-15 00:53:06.000000', 'temperatura', 836.0000, 'ºC'),
	(14015, 109, '2015-01-15 00:53:07.000000', 'temperatura', 27.0000, 'ºC'),
	(14016, 109, '2015-01-15 00:53:08.000000', 'temperatura', 26.0000, 'ºC'),
	(14017, 109, '2015-01-15 00:53:09.000000', 'temperatura', 51.0000, 'ºC'),
	(14018, 109, '2015-01-15 00:53:10.000000', 'temperatura', 176.0000, 'ºC'),
	(14019, 109, '2015-01-15 00:53:11.000000', 'temperatura', 730.0000, 'ºC'),
	(14020, 109, '2015-01-15 00:53:12.000000', 'temperatura', 722.0000, 'ºC'),
	(14021, 109, '2015-01-15 00:53:13.000000', 'temperatura', 218.0000, 'ºC'),
	(14022, 109, '2015-01-15 00:53:14.000000', 'temperatura', 128.0000, 'ºC'),
	(14023, 109, '2015-01-15 00:53:15.000000', 'temperatura', 1183.0000, 'ºC'),
	(14024, 109, '2015-01-15 00:53:16.000000', 'temperatura', 733.0000, 'ºC'),
	(14025, 109, '2015-01-15 00:53:17.000000', 'temperatura', 118.0000, 'ºC'),
	(14026, 109, '2015-01-15 00:53:18.000000', 'temperatura', 792.0000, 'ºC'),
	(14027, 109, '2015-01-15 00:53:19.000000', 'temperatura', 5.0000, 'ºC'),
	(14028, 109, '2015-01-15 00:53:20.000000', 'temperatura', 51.0000, 'ºC'),
	(14029, 109, '2015-01-15 00:53:21.000000', 'temperatura', 239.0000, 'ºC'),
	(14030, 109, '2015-01-15 00:53:22.000000', 'temperatura', 1043.0000, 'ºC'),
	(14031, 109, '2015-01-15 00:53:23.000000', 'temperatura', 897.0000, 'ºC'),
	(14032, 109, '2015-01-15 00:53:24.000000', 'temperatura', 155.0000, 'ºC'),
	(14033, 109, '2015-01-15 00:53:25.000000', 'temperatura', 488.0000, 'ºC'),
	(14034, 109, '2015-01-15 00:53:26.000000', 'temperatura', 775.0000, 'ºC'),
	(14035, 109, '2015-01-15 00:53:27.000000', 'temperatura', 11.0000, 'ºC'),
	(14036, 109, '2015-01-15 00:53:28.000000', 'temperatura', 130.0000, 'ºC'),
	(14037, 109, '2015-01-15 00:53:29.000000', 'temperatura', 619.0000, 'ºC'),
	(14038, 109, '2015-01-15 00:53:30.000000', 'temperatura', 303.0000, 'ºC'),
	(14039, 109, '2015-01-15 00:53:31.000000', 'temperatura', 860.0000, 'ºC'),
	(14040, 109, '2015-01-15 00:53:32.000000', 'temperatura', 991.0000, 'ºC'),
	(14041, 109, '2015-01-15 00:53:33.000000', 'temperatura', 1176.0000, 'ºC'),
	(14042, 109, '2015-01-15 00:53:34.000000', 'temperatura', 509.0000, 'ºC'),
	(14043, 109, '2015-01-15 00:53:35.000000', 'temperatura', 218.0000, 'ºC'),
	(14044, 109, '2015-01-15 00:53:36.000000', 'temperatura', 763.0000, 'ºC'),
	(14045, 109, '2015-01-15 00:53:37.000000', 'temperatura', 761.0000, 'ºC'),
	(14046, 109, '2015-01-15 00:53:38.000000', 'temperatura', 314.0000, 'ºC'),
	(14047, 109, '2015-01-15 00:53:39.000000', 'temperatura', 491.0000, 'ºC'),
	(14048, 109, '2015-01-15 00:53:40.000000', 'temperatura', 312.0000, 'ºC'),
	(14049, 109, '2015-01-15 00:53:41.000000', 'temperatura', 89.0000, 'ºC'),
	(14050, 109, '2015-01-15 00:53:42.000000', 'temperatura', 708.0000, 'ºC'),
	(14051, 109, '2015-01-15 00:53:43.000000', 'temperatura', 874.0000, 'ºC'),
	(14052, 109, '2015-01-15 00:53:44.000000', 'temperatura', 1047.0000, 'ºC'),
	(14053, 109, '2015-01-15 00:53:45.000000', 'temperatura', 214.0000, 'ºC'),
	(14054, 109, '2015-01-15 00:53:46.000000', 'temperatura', 328.0000, 'ºC'),
	(14055, 109, '2015-01-15 00:53:47.000000', 'temperatura', 1001.0000, 'ºC'),
	(14056, 109, '2015-01-15 00:53:48.000000', 'temperatura', 420.0000, 'ºC'),
	(14057, 109, '2015-01-15 00:53:49.000000', 'temperatura', 299.0000, 'ºC'),
	(14058, 109, '2015-01-15 00:53:50.000000', 'temperatura', 234.0000, 'ºC'),
	(14059, 109, '2015-01-15 00:53:51.000000', 'temperatura', 276.0000, 'ºC'),
	(14060, 109, '2015-01-15 00:53:52.000000', 'temperatura', 676.0000, 'ºC'),
	(14061, 109, '2015-01-15 00:53:53.000000', 'temperatura', 155.0000, 'ºC'),
	(14062, 109, '2015-01-15 00:53:54.000000', 'temperatura', 1147.0000, 'ºC'),
	(14063, 109, '2015-01-15 00:53:55.000000', 'temperatura', 471.0000, 'ºC'),
	(14064, 109, '2015-01-15 00:53:56.000000', 'temperatura', 113.0000, 'ºC'),
	(14065, 109, '2015-01-15 00:53:57.000000', 'temperatura', 353.0000, 'ºC'),
	(14066, 109, '2015-01-15 00:53:58.000000', 'temperatura', 228.0000, 'ºC'),
	(14067, 109, '2015-01-15 00:53:59.000000', 'temperatura', 79.0000, 'ºC'),
	(14068, 109, '2015-01-15 00:54:00.000000', 'temperatura', 911.0000, 'ºC'),
	(14069, 109, '2015-01-15 00:54:01.000000', 'temperatura', 720.0000, 'ºC'),
	(14070, 109, '2015-01-15 00:54:02.000000', 'temperatura', 867.0000, 'ºC'),
	(14071, 109, '2015-01-15 00:54:03.000000', 'temperatura', 974.0000, 'ºC'),
	(14072, 109, '2015-01-15 00:54:04.000000', 'temperatura', 1069.0000, 'ºC'),
	(14073, 109, '2015-01-15 00:54:05.000000', 'temperatura', 26.0000, 'ºC'),
	(14074, 109, '2015-01-15 00:54:06.000000', 'temperatura', 524.0000, 'ºC'),
	(14075, 109, '2015-01-15 00:54:07.000000', 'temperatura', 143.0000, 'ºC'),
	(14076, 109, '2015-01-15 00:54:08.000000', 'temperatura', 342.0000, 'ºC'),
	(14077, 109, '2015-01-15 00:54:09.000000', 'temperatura', 80.0000, 'ºC'),
	(14078, 109, '2015-01-15 00:54:10.000000', 'temperatura', 576.0000, 'ºC'),
	(14079, 109, '2015-01-15 00:54:11.000000', 'temperatura', 239.0000, 'ºC'),
	(14080, 109, '2015-01-15 00:54:12.000000', 'temperatura', 668.0000, 'ºC'),
	(14081, 109, '2015-01-15 00:54:13.000000', 'temperatura', 226.0000, 'ºC'),
	(14082, 109, '2015-01-15 00:54:14.000000', 'temperatura', 324.0000, 'ºC'),
	(14083, 109, '2015-01-15 00:54:15.000000', 'temperatura', 943.0000, 'ºC'),
	(14084, 109, '2015-01-15 00:54:16.000000', 'temperatura', 145.0000, 'ºC'),
	(14085, 109, '2015-01-15 00:54:17.000000', 'temperatura', 296.0000, 'ºC'),
	(14086, 109, '2015-01-15 00:54:18.000000', 'temperatura', 1046.0000, 'ºC'),
	(14087, 109, '2015-01-15 00:54:19.000000', 'temperatura', 740.0000, 'ºC'),
	(14088, 109, '2015-01-15 00:54:20.000000', 'temperatura', 563.0000, 'ºC'),
	(14089, 109, '2015-01-15 00:54:21.000000', 'temperatura', 597.0000, 'ºC'),
	(14090, 109, '2015-01-15 00:54:22.000000', 'temperatura', 96.0000, 'ºC'),
	(14091, 109, '2015-01-15 00:54:23.000000', 'temperatura', 1090.0000, 'ºC'),
	(14092, 109, '2015-01-15 00:54:24.000000', 'temperatura', 363.0000, 'ºC'),
	(14093, 109, '2015-01-15 00:54:25.000000', 'temperatura', 946.0000, 'ºC'),
	(14094, 109, '2015-01-15 00:54:26.000000', 'temperatura', 39.0000, 'ºC'),
	(14095, 109, '2015-01-15 00:54:27.000000', 'temperatura', 958.0000, 'ºC'),
	(14096, 109, '2015-01-15 00:54:28.000000', 'temperatura', 1074.0000, 'ºC'),
	(14097, 109, '2015-01-15 00:54:29.000000', 'temperatura', 96.0000, 'ºC'),
	(14098, 109, '2015-01-15 00:54:30.000000', 'temperatura', 859.0000, 'ºC'),
	(14099, 109, '2015-01-15 00:54:31.000000', 'temperatura', 409.0000, 'ºC'),
	(14100, 109, '2015-01-15 00:54:32.000000', 'temperatura', 669.0000, 'ºC'),
	(14101, 109, '2015-01-15 00:54:33.000000', 'temperatura', 919.0000, 'ºC'),
	(14102, 109, '2015-01-15 00:54:34.000000', 'temperatura', 189.0000, 'ºC'),
	(14103, 109, '2015-01-15 00:54:35.000000', 'temperatura', 585.0000, 'ºC'),
	(14104, 109, '2015-01-15 00:54:36.000000', 'temperatura', 1162.0000, 'ºC'),
	(14105, 109, '2015-01-15 00:54:37.000000', 'temperatura', 453.0000, 'ºC'),
	(14106, 109, '2015-01-15 00:54:38.000000', 'temperatura', 1178.0000, 'ºC'),
	(14107, 109, '2015-01-15 00:54:39.000000', 'temperatura', 935.0000, 'ºC'),
	(14108, 109, '2015-01-15 00:54:40.000000', 'temperatura', 1141.0000, 'ºC'),
	(14109, 109, '2015-01-15 00:54:41.000000', 'temperatura', 498.0000, 'ºC'),
	(14110, 109, '2015-01-15 00:54:42.000000', 'temperatura', 271.0000, 'ºC'),
	(14111, 109, '2015-01-15 00:54:43.000000', 'temperatura', 1059.0000, 'ºC'),
	(14112, 109, '2015-01-15 00:54:44.000000', 'temperatura', 884.0000, 'ºC'),
	(14113, 109, '2015-01-15 00:54:45.000000', 'temperatura', 43.0000, 'ºC'),
	(14114, 109, '2015-01-15 00:54:46.000000', 'temperatura', 1164.0000, 'ºC'),
	(14115, 109, '2015-01-15 00:54:47.000000', 'temperatura', 893.0000, 'ºC'),
	(14116, 109, '2015-01-15 00:54:48.000000', 'temperatura', 971.0000, 'ºC'),
	(14117, 109, '2015-01-15 00:54:49.000000', 'temperatura', 978.0000, 'ºC'),
	(14118, 109, '2015-01-15 00:54:50.000000', 'temperatura', 776.0000, 'ºC'),
	(14119, 109, '2015-01-15 00:54:51.000000', 'temperatura', 946.0000, 'ºC'),
	(14120, 109, '2015-01-15 00:54:52.000000', 'temperatura', 2.0000, 'ºC'),
	(14121, 109, '2015-01-15 00:54:53.000000', 'temperatura', 773.0000, 'ºC'),
	(14122, 109, '2015-01-15 00:54:54.000000', 'temperatura', 259.0000, 'ºC'),
	(14123, 109, '2015-01-15 00:54:55.000000', 'temperatura', 177.0000, 'ºC'),
	(14124, 109, '2015-01-15 00:54:56.000000', 'temperatura', 109.0000, 'ºC'),
	(14125, 109, '2015-01-15 00:54:57.000000', 'temperatura', 13.0000, 'ºC'),
	(14126, 109, '2015-01-15 00:54:58.000000', 'temperatura', 939.0000, 'ºC'),
	(14127, 109, '2015-01-15 00:54:59.000000', 'temperatura', 1056.0000, 'ºC'),
	(14128, 109, '2015-01-15 00:55:00.000000', 'temperatura', 62.0000, 'ºC'),
	(14129, 109, '2015-01-15 00:55:01.000000', 'temperatura', 745.0000, 'ºC'),
	(14130, 109, '2015-01-15 00:55:02.000000', 'temperatura', 1139.0000, 'ºC'),
	(14131, 109, '2015-01-15 00:55:03.000000', 'temperatura', 1061.0000, 'ºC'),
	(14132, 109, '2015-01-15 00:55:04.000000', 'temperatura', 689.0000, 'ºC'),
	(14133, 109, '2015-01-15 00:55:05.000000', 'temperatura', 260.0000, 'ºC'),
	(14134, 109, '2015-01-15 00:55:06.000000', 'temperatura', 434.0000, 'ºC'),
	(14135, 109, '2015-01-15 00:55:07.000000', 'temperatura', 192.0000, 'ºC'),
	(14136, 109, '2015-01-15 00:55:08.000000', 'temperatura', 859.0000, 'ºC'),
	(14137, 109, '2015-01-15 00:55:09.000000', 'temperatura', 121.0000, 'ºC'),
	(14138, 109, '2015-01-15 00:55:10.000000', 'temperatura', 426.0000, 'ºC'),
	(14139, 109, '2015-01-15 00:55:11.000000', 'temperatura', 566.0000, 'ºC'),
	(14140, 109, '2015-01-15 00:55:12.000000', 'temperatura', 354.0000, 'ºC'),
	(14141, 109, '2015-01-15 00:55:13.000000', 'temperatura', 74.0000, 'ºC'),
	(14142, 109, '2015-01-15 00:55:14.000000', 'temperatura', 509.0000, 'ºC'),
	(14143, 109, '2015-01-15 00:55:15.000000', 'temperatura', 1124.0000, 'ºC'),
	(14144, 109, '2015-01-15 00:55:16.000000', 'temperatura', 492.0000, 'ºC'),
	(14145, 109, '2015-01-15 00:55:17.000000', 'temperatura', 289.0000, 'ºC'),
	(14146, 109, '2015-01-15 00:55:18.000000', 'temperatura', 1170.0000, 'ºC'),
	(14147, 109, '2015-01-15 00:55:19.000000', 'temperatura', 182.0000, 'ºC'),
	(14148, 109, '2015-01-15 00:55:20.000000', 'temperatura', 1000.0000, 'ºC'),
	(14149, 109, '2015-01-15 00:55:21.000000', 'temperatura', 854.0000, 'ºC'),
	(14150, 109, '2015-01-15 00:55:22.000000', 'temperatura', 70.0000, 'ºC'),
	(14151, 109, '2015-01-15 00:55:23.000000', 'temperatura', 190.0000, 'ºC'),
	(14152, 109, '2015-01-15 00:55:24.000000', 'temperatura', 742.0000, 'ºC'),
	(14153, 109, '2015-01-15 00:55:25.000000', 'temperatura', 740.0000, 'ºC'),
	(14154, 109, '2015-01-15 00:55:26.000000', 'temperatura', 273.0000, 'ºC'),
	(14155, 109, '2015-01-15 00:55:27.000000', 'temperatura', 347.0000, 'ºC'),
	(14156, 109, '2015-01-15 00:55:28.000000', 'temperatura', 918.0000, 'ºC'),
	(14157, 109, '2015-01-15 00:55:29.000000', 'temperatura', 1146.0000, 'ºC'),
	(14158, 109, '2015-01-15 00:55:30.000000', 'temperatura', 580.0000, 'ºC'),
	(14159, 109, '2015-01-15 00:55:31.000000', 'temperatura', 659.0000, 'ºC'),
	(14160, 109, '2015-01-15 00:55:32.000000', 'temperatura', 358.0000, 'ºC'),
	(14161, 109, '2015-01-15 00:55:33.000000', 'temperatura', 1012.0000, 'ºC'),
	(14162, 109, '2015-01-15 00:55:34.000000', 'temperatura', 386.0000, 'ºC'),
	(14163, 109, '2015-01-15 00:55:35.000000', 'temperatura', 96.0000, 'ºC'),
	(14164, 109, '2015-01-15 00:55:36.000000', 'temperatura', 522.0000, 'ºC'),
	(14165, 109, '2015-01-15 00:55:37.000000', 'temperatura', 1120.0000, 'ºC'),
	(14166, 109, '2015-01-15 00:55:38.000000', 'temperatura', 438.0000, 'ºC'),
	(14167, 109, '2015-01-15 00:55:39.000000', 'temperatura', 30.0000, 'ºC'),
	(14168, 109, '2015-01-15 00:55:40.000000', 'temperatura', 36.0000, 'ºC'),
	(14169, 109, '2015-01-15 00:55:41.000000', 'temperatura', 92.0000, 'ºC'),
	(14170, 109, '2015-01-15 00:55:42.000000', 'temperatura', 350.0000, 'ºC'),
	(14171, 109, '2015-01-15 00:55:43.000000', 'temperatura', 274.0000, 'ºC'),
	(14172, 109, '2015-01-15 00:55:44.000000', 'temperatura', 323.0000, 'ºC'),
	(14173, 109, '2015-01-15 00:55:45.000000', 'temperatura', 791.0000, 'ºC'),
	(14174, 109, '2015-01-15 00:55:46.000000', 'temperatura', 588.0000, 'ºC'),
	(14175, 109, '2015-01-15 00:55:47.000000', 'temperatura', 565.0000, 'ºC'),
	(14176, 109, '2015-01-15 00:55:48.000000', 'temperatura', 1064.0000, 'ºC'),
	(14177, 109, '2015-01-15 00:55:49.000000', 'temperatura', 23.0000, 'ºC'),
	(14178, 109, '2015-01-15 00:55:50.000000', 'temperatura', 525.0000, 'ºC'),
	(14179, 109, '2015-01-15 00:55:51.000000', 'temperatura', 158.0000, 'ºC'),
	(14180, 109, '2015-01-15 00:55:52.000000', 'temperatura', 414.0000, 'ºC'),
	(14181, 109, '2015-01-15 00:55:53.000000', 'temperatura', 398.0000, 'ºC'),
	(14182, 109, '2015-01-15 00:55:54.000000', 'temperatura', 748.0000, 'ºC'),
	(14183, 109, '2015-01-15 00:55:55.000000', 'temperatura', 145.0000, 'ºC'),
	(14184, 109, '2015-01-15 00:55:56.000000', 'temperatura', 882.0000, 'ºC'),
	(14185, 109, '2015-01-15 00:55:57.000000', 'temperatura', 375.0000, 'ºC'),
	(14186, 109, '2015-01-15 00:55:58.000000', 'temperatura', 432.0000, 'ºC'),
	(14187, 109, '2015-01-15 00:55:59.000000', 'temperatura', 1032.0000, 'ºC'),
	(14188, 109, '2015-01-15 00:56:00.000000', 'temperatura', 268.0000, 'ºC'),
	(14189, 109, '2015-01-15 00:56:01.000000', 'temperatura', 644.0000, 'ºC'),
	(14190, 109, '2015-01-15 00:56:02.000000', 'temperatura', 14.0000, 'ºC'),
	(14191, 109, '2015-01-15 00:56:03.000000', 'temperatura', 540.0000, 'ºC'),
	(14192, 109, '2015-01-15 00:56:04.000000', 'temperatura', 257.0000, 'ºC'),
	(14193, 109, '2015-01-15 00:56:05.000000', 'temperatura', 867.0000, 'ºC'),
	(14194, 109, '2015-01-15 00:56:06.000000', 'temperatura', 1163.0000, 'ºC'),
	(14195, 109, '2015-01-15 00:56:07.000000', 'temperatura', 814.0000, 'ºC'),
	(14196, 109, '2015-01-15 00:56:08.000000', 'temperatura', 582.0000, 'ºC'),
	(14197, 109, '2015-01-15 00:56:09.000000', 'temperatura', 468.0000, 'ºC'),
	(14198, 109, '2015-01-15 00:56:10.000000', 'temperatura', 593.0000, 'ºC'),
	(14199, 109, '2015-01-15 00:56:11.000000', 'temperatura', 363.0000, 'ºC'),
	(14200, 109, '2015-01-15 00:56:12.000000', 'temperatura', 35.0000, 'ºC'),
	(14201, 109, '2015-01-15 00:56:13.000000', 'temperatura', 289.0000, 'ºC'),
	(14202, 109, '2015-01-15 00:56:14.000000', 'temperatura', 140.0000, 'ºC'),
	(14203, 109, '2015-01-15 00:56:15.000000', 'temperatura', 1034.0000, 'ºC'),
	(14204, 109, '2015-01-15 00:56:16.000000', 'temperatura', 1148.0000, 'ºC'),
	(14205, 109, '2015-01-15 00:56:17.000000', 'temperatura', 242.0000, 'ºC'),
	(14206, 109, '2015-01-15 00:56:18.000000', 'temperatura', 164.0000, 'ºC'),
	(14207, 109, '2015-01-15 00:56:19.000000', 'temperatura', 95.0000, 'ºC'),
	(14208, 109, '2015-01-15 00:56:20.000000', 'temperatura', 1182.0000, 'ºC'),
	(14209, 109, '2015-01-15 00:56:21.000000', 'temperatura', 827.0000, 'ºC'),
	(14210, 109, '2015-01-15 00:56:22.000000', 'temperatura', 591.0000, 'ºC'),
	(14211, 109, '2015-01-15 00:56:23.000000', 'temperatura', 473.0000, 'ºC'),
	(14212, 109, '2015-01-15 00:56:24.000000', 'temperatura', 593.0000, 'ºC'),
	(14213, 109, '2015-01-15 00:56:25.000000', 'temperatura', 347.0000, 'ºC'),
	(14214, 109, '2015-01-15 00:56:26.000000', 'temperatura', 1157.0000, 'ºC'),
	(14215, 109, '2015-01-15 00:56:27.000000', 'temperatura', 1143.0000, 'ºC'),
	(14216, 109, '2015-01-15 00:56:28.000000', 'temperatura', 1046.0000, 'ºC'),
	(14217, 109, '2015-01-15 00:56:29.000000', 'temperatura', 600.0000, 'ºC'),
	(14218, 109, '2015-01-15 00:56:30.000000', 'temperatura', 1063.0000, 'ºC'),
	(14219, 109, '2015-01-15 00:56:31.000000', 'temperatura', 1115.0000, 'ºC'),
	(14220, 109, '2015-01-15 00:56:32.000000', 'temperatura', 1186.0000, 'ºC'),
	(14221, 109, '2015-01-15 00:56:33.000000', 'temperatura', 187.0000, 'ºC'),
	(14222, 109, '2015-01-15 00:56:34.000000', 'temperatura', 975.0000, 'ºC'),
	(14223, 109, '2015-01-15 00:56:35.000000', 'temperatura', 716.0000, 'ºC'),
	(14224, 109, '2015-01-15 00:56:36.000000', 'temperatura', 654.0000, 'ºC'),
	(14225, 109, '2015-01-15 00:56:37.000000', 'temperatura', 1124.0000, 'ºC'),
	(14226, 109, '2015-01-15 00:56:38.000000', 'temperatura', 57.0000, 'ºC'),
	(14227, 109, '2015-01-15 00:56:39.000000', 'temperatura', 514.0000, 'ºC'),
	(14228, 109, '2015-01-15 00:56:40.000000', 'temperatura', 0.0000, 'ºC'),
	(14229, 109, '2015-01-15 00:56:41.000000', 'temperatura', 858.0000, 'ºC'),
	(14230, 109, '2015-01-15 00:56:42.000000', 'temperatura', 693.0000, 'ºC'),
	(14231, 109, '2015-01-15 00:56:43.000000', 'temperatura', 888.0000, 'ºC'),
	(14232, 109, '2015-01-15 00:56:44.000000', 'temperatura', 1163.0000, 'ºC'),
	(14233, 109, '2015-01-15 00:56:45.000000', 'temperatura', 750.0000, 'ºC'),
	(14234, 109, '2015-01-15 00:56:46.000000', 'temperatura', 261.0000, 'ºC'),
	(14235, 109, '2015-01-15 00:56:47.000000', 'temperatura', 258.0000, 'ºC'),
	(14236, 109, '2015-01-15 00:56:48.000000', 'temperatura', 507.0000, 'ºC'),
	(14237, 109, '2015-01-15 00:56:49.000000', 'temperatura', 559.0000, 'ºC'),
	(14238, 109, '2015-01-15 00:56:50.000000', 'temperatura', 77.0000, 'ºC'),
	(14239, 109, '2015-01-15 00:56:51.000000', 'temperatura', 1109.0000, 'ºC'),
	(14240, 109, '2015-01-15 00:56:52.000000', 'temperatura', 515.0000, 'ºC'),
	(14241, 109, '2015-01-15 00:56:53.000000', 'temperatura', 450.0000, 'ºC'),
	(14242, 109, '2015-01-15 00:56:54.000000', 'temperatura', 703.0000, 'ºC'),
	(14243, 109, '2015-01-15 00:56:55.000000', 'temperatura', 964.0000, 'ºC'),
	(14244, 109, '2015-01-15 00:56:56.000000', 'temperatura', 313.0000, 'ºC'),
	(14245, 109, '2015-01-15 00:56:57.000000', 'temperatura', 1073.0000, 'ºC'),
	(14246, 109, '2015-01-15 00:56:58.000000', 'temperatura', 825.0000, 'ºC'),
	(14247, 109, '2015-01-15 00:56:59.000000', 'temperatura', 907.0000, 'ºC'),
	(14248, 109, '2015-01-15 00:57:00.000000', 'temperatura', 863.0000, 'ºC'),
	(14249, 109, '2015-01-15 00:57:01.000000', 'temperatura', 392.0000, 'ºC'),
	(14250, 109, '2015-01-15 00:57:02.000000', 'temperatura', 574.0000, 'ºC'),
	(14251, 109, '2015-01-15 00:57:03.000000', 'temperatura', 493.0000, 'ºC'),
	(14252, 109, '2015-01-15 00:57:04.000000', 'temperatura', 745.0000, 'ºC'),
	(14253, 109, '2015-01-15 00:57:05.000000', 'temperatura', 1044.0000, 'ºC'),
	(14254, 109, '2015-01-15 00:57:06.000000', 'temperatura', 587.0000, 'ºC'),
	(14255, 109, '2015-01-15 00:57:07.000000', 'temperatura', 1004.0000, 'ºC'),
	(14256, 109, '2015-01-15 00:57:08.000000', 'temperatura', 859.0000, 'ºC'),
	(14257, 109, '2015-01-15 00:57:09.000000', 'temperatura', 85.0000, 'ºC'),
	(14258, 109, '2015-01-15 00:57:10.000000', 'temperatura', 249.0000, 'ºC'),
	(14259, 109, '2015-01-15 00:57:11.000000', 'temperatura', 988.0000, 'ºC'),
	(14260, 109, '2015-01-15 00:57:12.000000', 'temperatura', 593.0000, 'ºC'),
	(14261, 109, '2015-01-15 00:57:13.000000', 'temperatura', 0.0000, 'ºC'),
	(14262, 109, '2015-01-15 00:57:14.000000', 'temperatura', 625.0000, 'ºC'),
	(14263, 109, '2015-01-15 00:57:15.000000', 'temperatura', 726.0000, 'ºC'),
	(14264, 109, '2015-01-15 00:57:16.000000', 'temperatura', 554.0000, 'ºC'),
	(14265, 109, '2015-01-15 00:57:17.000000', 'temperatura', 595.0000, 'ºC'),
	(14266, 109, '2015-01-15 00:57:18.000000', 'temperatura', 110.0000, 'ºC'),
	(14267, 109, '2015-01-15 00:57:19.000000', 'temperatura', 1166.0000, 'ºC'),
	(14268, 109, '2015-01-15 00:57:20.000000', 'temperatura', 701.0000, 'ºC'),
	(14269, 109, '2015-01-15 00:57:21.000000', 'temperatura', 9.0000, 'ºC'),
	(14270, 109, '2015-01-15 00:57:22.000000', 'temperatura', 340.0000, 'ºC'),
	(14271, 109, '2015-01-15 00:57:23.000000', 'temperatura', 473.0000, 'ºC'),
	(14272, 109, '2015-01-15 00:57:24.000000', 'temperatura', 145.0000, 'ºC'),
	(14273, 109, '2015-01-15 00:57:25.000000', 'temperatura', 509.0000, 'ºC'),
	(14274, 109, '2015-01-15 00:57:26.000000', 'temperatura', 910.0000, 'ºC'),
	(14275, 109, '2015-01-15 00:57:27.000000', 'temperatura', 624.0000, 'ºC'),
	(14276, 109, '2015-01-15 00:57:28.000000', 'temperatura', 389.0000, 'ºC'),
	(14277, 109, '2015-01-15 00:57:29.000000', 'temperatura', 73.0000, 'ºC'),
	(14278, 109, '2015-01-15 00:57:30.000000', 'temperatura', 401.0000, 'ºC'),
	(14279, 109, '2015-01-15 00:57:31.000000', 'temperatura', 585.0000, 'ºC'),
	(14280, 109, '2015-01-15 00:57:32.000000', 'temperatura', 522.0000, 'ºC'),
	(14281, 109, '2015-01-15 00:57:33.000000', 'temperatura', 858.0000, 'ºC'),
	(14282, 109, '2015-01-15 00:57:34.000000', 'temperatura', 321.0000, 'ºC'),
	(14283, 109, '2015-01-15 00:57:35.000000', 'temperatura', 234.0000, 'ºC'),
	(14284, 109, '2015-01-15 00:57:36.000000', 'temperatura', 208.0000, 'ºC'),
	(14285, 109, '2015-01-15 00:57:37.000000', 'temperatura', 339.0000, 'ºC'),
	(14286, 109, '2015-01-15 00:57:38.000000', 'temperatura', 1072.0000, 'ºC'),
	(14287, 109, '2015-01-15 00:57:39.000000', 'temperatura', 742.0000, 'ºC'),
	(14288, 109, '2015-01-15 00:57:40.000000', 'temperatura', 495.0000, 'ºC'),
	(14289, 109, '2015-01-15 00:57:41.000000', 'temperatura', 249.0000, 'ºC'),
	(14290, 109, '2015-01-15 00:57:42.000000', 'temperatura', 960.0000, 'ºC'),
	(14291, 109, '2015-01-15 00:57:43.000000', 'temperatura', 454.0000, 'ºC'),
	(14292, 109, '2015-01-15 00:57:44.000000', 'temperatura', 589.0000, 'ºC'),
	(14293, 109, '2015-01-15 00:57:45.000000', 'temperatura', 384.0000, 'ºC'),
	(14294, 109, '2015-01-15 00:57:46.000000', 'temperatura', 154.0000, 'ºC'),
	(14295, 109, '2015-01-15 00:57:47.000000', 'temperatura', 818.0000, 'ºC'),
	(14296, 109, '2015-01-15 00:57:48.000000', 'temperatura', 30.0000, 'ºC'),
	(14297, 109, '2015-01-15 00:57:49.000000', 'temperatura', 95.0000, 'ºC'),
	(14298, 109, '2015-01-15 00:57:50.000000', 'temperatura', 385.0000, 'ºC'),
	(14299, 109, '2015-01-15 00:57:51.000000', 'temperatura', 440.0000, 'ºC'),
	(14300, 109, '2015-01-15 00:57:52.000000', 'temperatura', 1048.0000, 'ºC'),
	(14301, 109, '2015-01-15 00:57:53.000000', 'temperatura', 319.0000, 'ºC'),
	(14302, 109, '2015-01-15 00:57:54.000000', 'temperatura', 851.0000, 'ºC'),
	(14303, 109, '2015-01-15 00:57:55.000000', 'temperatura', 900.0000, 'ºC'),
	(14304, 109, '2015-01-15 00:57:56.000000', 'temperatura', 747.0000, 'ºC'),
	(14305, 109, '2015-01-15 00:57:57.000000', 'temperatura', 1035.0000, 'ºC'),
	(14306, 109, '2015-01-15 00:57:58.000000', 'temperatura', 534.0000, 'ºC'),
	(14307, 109, '2015-01-15 00:57:59.000000', 'temperatura', 767.0000, 'ºC'),
	(14308, 109, '2015-01-15 00:58:00.000000', 'temperatura', 1033.0000, 'ºC'),
	(14309, 109, '2015-01-15 00:58:01.000000', 'temperatura', 462.0000, 'ºC'),
	(14310, 109, '2015-01-15 00:58:02.000000', 'temperatura', 415.0000, 'ºC'),
	(14311, 109, '2015-01-15 00:58:03.000000', 'temperatura', 689.0000, 'ºC'),
	(14312, 109, '2015-01-15 00:58:04.000000', 'temperatura', 998.0000, 'ºC'),
	(14313, 109, '2015-01-15 00:58:05.000000', 'temperatura', 526.0000, 'ºC'),
	(14314, 109, '2015-01-15 00:58:06.000000', 'temperatura', 837.0000, 'ºC'),
	(14315, 109, '2015-01-15 00:58:07.000000', 'temperatura', 205.0000, 'ºC'),
	(14316, 109, '2015-01-15 00:58:08.000000', 'temperatura', 917.0000, 'ºC'),
	(14317, 109, '2015-01-15 00:58:09.000000', 'temperatura', 371.0000, 'ºC'),
	(14318, 109, '2015-01-15 00:58:10.000000', 'temperatura', 305.0000, 'ºC'),
	(14319, 109, '2015-01-15 00:58:11.000000', 'temperatura', 413.0000, 'ºC'),
	(14320, 109, '2015-01-15 00:58:12.000000', 'temperatura', 1151.0000, 'ºC'),
	(14321, 109, '2015-01-15 00:58:13.000000', 'temperatura', 913.0000, 'ºC'),
	(14322, 109, '2015-01-15 00:58:14.000000', 'temperatura', 1116.0000, 'ºC'),
	(14323, 109, '2015-01-15 00:58:15.000000', 'temperatura', 440.0000, 'ºC'),
	(14324, 109, '2015-01-15 00:58:16.000000', 'temperatura', 51.0000, 'ºC'),
	(14325, 109, '2015-01-15 00:58:17.000000', 'temperatura', 137.0000, 'ºC'),
	(14326, 109, '2015-01-15 00:58:18.000000', 'temperatura', 533.0000, 'ºC'),
	(14327, 109, '2015-01-15 00:58:19.000000', 'temperatura', 1054.0000, 'ºC'),
	(14328, 109, '2015-01-15 00:58:20.000000', 'temperatura', 73.0000, 'ºC'),
	(14329, 109, '2015-01-15 00:58:21.000000', 'temperatura', 803.0000, 'ºC'),
	(14330, 109, '2015-01-15 00:58:22.000000', 'temperatura', 195.0000, 'ºC'),
	(14331, 109, '2015-01-15 00:58:23.000000', 'temperatura', 967.0000, 'ºC'),
	(14332, 109, '2015-01-15 00:58:24.000000', 'temperatura', 651.0000, 'ºC'),
	(14333, 109, '2015-01-15 00:58:25.000000', 'temperatura', 355.0000, 'ºC'),
	(14334, 109, '2015-01-15 00:58:26.000000', 'temperatura', 1022.0000, 'ºC'),
	(14335, 109, '2015-01-15 00:58:27.000000', 'temperatura', 447.0000, 'ºC'),
	(14336, 109, '2015-01-15 00:58:28.000000', 'temperatura', 368.0000, 'ºC'),
	(14337, 109, '2015-01-15 00:58:29.000000', 'temperatura', 499.0000, 'ºC'),
	(14338, 109, '2015-01-15 00:58:30.000000', 'temperatura', 193.0000, 'ºC'),
	(14339, 109, '2015-01-15 00:58:31.000000', 'temperatura', 670.0000, 'ºC'),
	(14340, 109, '2015-01-15 00:58:32.000000', 'temperatura', 369.0000, 'ºC'),
	(14341, 109, '2015-01-15 00:58:33.000000', 'temperatura', 1038.0000, 'ºC'),
	(14342, 109, '2015-01-15 00:58:34.000000', 'temperatura', 482.0000, 'ºC'),
	(14343, 109, '2015-01-15 00:58:35.000000', 'temperatura', 496.0000, 'ºC'),
	(14344, 109, '2015-01-15 00:58:36.000000', 'temperatura', 1037.0000, 'ºC'),
	(14345, 109, '2015-01-15 00:58:37.000000', 'temperatura', 96.0000, 'ºC'),
	(14346, 109, '2015-01-15 00:58:38.000000', 'temperatura', 969.0000, 'ºC'),
	(14347, 109, '2015-01-15 00:58:39.000000', 'temperatura', 957.0000, 'ºC'),
	(14348, 109, '2015-01-15 00:58:40.000000', 'temperatura', 680.0000, 'ºC'),
	(14349, 109, '2015-01-15 00:58:41.000000', 'temperatura', 531.0000, 'ºC'),
	(14350, 109, '2015-01-15 00:58:42.000000', 'temperatura', 613.0000, 'ºC'),
	(14351, 109, '2015-01-15 00:58:43.000000', 'temperatura', 273.0000, 'ºC'),
	(14352, 109, '2015-01-15 00:58:44.000000', 'temperatura', 728.0000, 'ºC'),
	(14353, 109, '2015-01-15 00:58:45.000000', 'temperatura', 421.0000, 'ºC'),
	(14354, 109, '2015-01-15 00:58:46.000000', 'temperatura', 1120.0000, 'ºC'),
	(14355, 109, '2015-01-15 00:58:47.000000', 'temperatura', 738.0000, 'ºC'),
	(14356, 109, '2015-01-15 00:58:48.000000', 'temperatura', 332.0000, 'ºC'),
	(14357, 109, '2015-01-15 00:58:49.000000', 'temperatura', 646.0000, 'ºC'),
	(14358, 109, '2015-01-15 00:58:50.000000', 'temperatura', 1034.0000, 'ºC'),
	(14359, 109, '2015-01-15 00:58:51.000000', 'temperatura', 832.0000, 'ºC'),
	(14360, 109, '2015-01-15 00:58:52.000000', 'temperatura', 1057.0000, 'ºC'),
	(14361, 109, '2015-01-15 00:58:53.000000', 'temperatura', 392.0000, 'ºC'),
	(14362, 109, '2015-01-15 00:58:54.000000', 'temperatura', 1187.0000, 'ºC'),
	(14363, 109, '2015-01-15 00:58:55.000000', 'temperatura', 1159.0000, 'ºC'),
	(14364, 109, '2015-01-15 00:58:56.000000', 'temperatura', 1035.0000, 'ºC'),
	(14365, 109, '2015-01-15 00:58:57.000000', 'temperatura', 498.0000, 'ºC'),
	(14366, 109, '2015-01-15 00:58:58.000000', 'temperatura', 588.0000, 'ºC'),
	(14367, 109, '2015-01-15 00:58:59.000000', 'temperatura', 245.0000, 'ºC'),
	(14368, 109, '2015-01-15 00:59:00.000000', 'temperatura', 660.0000, 'ºC'),
	(14369, 109, '2015-01-15 00:59:01.000000', 'temperatura', 167.0000, 'ºC'),
	(14370, 109, '2015-01-15 00:59:02.000000', 'temperatura', 53.0000, 'ºC'),
	(14371, 109, '2015-01-15 00:59:03.000000', 'temperatura', 967.0000, 'ºC'),
	(14372, 109, '2015-01-15 00:59:04.000000', 'temperatura', 1074.0000, 'ºC'),
	(14373, 109, '2015-01-15 00:59:05.000000', 'temperatura', 71.0000, 'ºC'),
	(14374, 109, '2015-01-15 00:59:06.000000', 'temperatura', 733.0000, 'ºC'),
	(14375, 109, '2015-01-15 00:59:07.000000', 'temperatura', 1054.0000, 'ºC'),
	(14376, 109, '2015-01-15 00:59:08.000000', 'temperatura', 673.0000, 'ºC'),
	(14377, 109, '2015-01-15 00:59:09.000000', 'temperatura', 201.0000, 'ºC'),
	(14378, 109, '2015-01-15 00:59:10.000000', 'temperatura', 186.0000, 'ºC'),
	(14379, 109, '2015-01-15 00:59:11.000000', 'temperatura', 330.0000, 'ºC'),
	(14380, 109, '2015-01-15 00:59:12.000000', 'temperatura', 1089.0000, 'ºC'),
	(14381, 109, '2015-01-15 00:59:13.000000', 'temperatura', 859.0000, 'ºC'),
	(14382, 109, '2015-01-15 00:59:14.000000', 'temperatura', 1025.0000, 'ºC'),
	(14383, 109, '2015-01-15 00:59:15.000000', 'temperatura', 151.0000, 'ºC'),
	(14384, 109, '2015-01-15 00:59:16.000000', 'temperatura', 81.0000, 'ºC'),
	(14385, 109, '2015-01-15 00:59:17.000000', 'temperatura', 1153.0000, 'ºC'),
	(14386, 109, '2015-01-15 00:59:18.000000', 'temperatura', 722.0000, 'ºC'),
	(14387, 109, '2015-01-15 00:59:19.000000', 'temperatura', 151.0000, 'ºC'),
	(14388, 109, '2015-01-15 00:59:20.000000', 'temperatura', 989.0000, 'ºC'),
	(14389, 109, '2015-01-15 00:59:21.000000', 'temperatura', 894.0000, 'ºC'),
	(14390, 109, '2015-01-15 00:59:22.000000', 'temperatura', 304.0000, 'ºC'),
	(14391, 109, '2015-01-15 00:59:23.000000', 'temperatura', 39.0000, 'ºC'),
	(14392, 109, '2015-01-15 00:59:24.000000', 'temperatura', 481.0000, 'ºC'),
	(14393, 109, '2015-01-15 00:59:25.000000', 'temperatura', 1092.0000, 'ºC'),
	(14394, 109, '2015-01-15 00:59:26.000000', 'temperatura', 415.0000, 'ºC'),
	(14395, 109, '2015-01-15 00:59:27.000000', 'temperatura', 1198.0000, 'ºC'),
	(14396, 109, '2015-01-15 00:59:28.000000', 'temperatura', 1148.0000, 'ºC'),
	(14397, 109, '2015-01-15 00:59:29.000000', 'temperatura', 944.0000, 'ºC'),
	(14398, 109, '2015-01-15 00:59:30.000000', 'temperatura', 79.0000, 'ºC'),
	(14399, 109, '2015-01-15 00:59:31.000000', 'temperatura', 1162.0000, 'ºC'),
	(14400, 109, '2015-01-15 00:59:32.000000', 'temperatura', 774.0000, 'ºC'),
	(14401, 109, '2015-01-15 00:59:33.000000', 'temperatura', 385.0000, 'ºC'),
	(14402, 109, '2015-01-15 00:59:34.000000', 'temperatura', 802.0000, 'ºC'),
	(14403, 109, '2015-01-15 00:59:35.000000', 'temperatura', 455.0000, 'ºC'),
	(14404, 109, '2015-01-15 00:59:36.000000', 'temperatura', 1069.0000, 'ºC'),
	(14405, 109, '2015-01-15 00:59:37.000000', 'temperatura', 382.0000, 'ºC'),
	(14406, 109, '2015-01-15 00:59:38.000000', 'temperatura', 1101.0000, 'ºC'),
	(14407, 109, '2015-01-15 00:59:39.000000', 'temperatura', 763.0000, 'ºC'),
	(14408, 109, '2015-01-15 00:59:40.000000', 'temperatura', 511.0000, 'ºC'),
	(14409, 109, '2015-01-15 00:59:41.000000', 'temperatura', 267.0000, 'ºC'),
	(14410, 109, '2015-01-15 00:59:42.000000', 'temperatura', 1004.0000, 'ºC'),
	(14411, 109, '2015-01-15 00:59:43.000000', 'temperatura', 618.0000, 'ºC'),
	(14412, 109, '2015-01-15 00:59:44.000000', 'temperatura', 80.0000, 'ºC'),
	(14413, 109, '2015-01-15 00:59:45.000000', 'temperatura', 947.0000, 'ºC'),
	(14414, 109, '2015-01-15 00:59:46.000000', 'temperatura', 894.0000, 'ºC'),
	(14415, 109, '2015-01-15 00:59:47.000000', 'temperatura', 428.0000, 'ºC'),
	(14416, 109, '2015-01-15 00:59:48.000000', 'temperatura', 659.0000, 'ºC'),
	(14417, 109, '2015-01-15 00:59:49.000000', 'temperatura', 813.0000, 'ºC'),
	(14418, 109, '2015-01-15 00:59:50.000000', 'temperatura', 886.0000, 'ºC'),
	(14419, 109, '2015-01-15 00:59:51.000000', 'temperatura', 793.0000, 'ºC'),
	(14420, 109, '2015-01-15 00:59:52.000000', 'temperatura', 107.0000, 'ºC'),
	(14421, 109, '2015-01-15 00:59:53.000000', 'temperatura', 559.0000, 'ºC'),
	(14422, 109, '2015-01-15 00:59:54.000000', 'temperatura', 72.0000, 'ºC'),
	(14423, 109, '2015-01-15 00:59:55.000000', 'temperatura', 1085.0000, 'ºC'),
	(14424, 109, '2015-01-15 00:59:56.000000', 'temperatura', 407.0000, 'ºC'),
	(14425, 109, '2015-01-15 00:59:57.000000', 'temperatura', 1181.0000, 'ºC'),
	(14426, 109, '2015-01-15 00:59:58.000000', 'temperatura', 1085.0000, 'ºC'),
	(14427, 109, '2015-01-15 00:59:59.000000', 'temperatura', 682.0000, 'ºC'),
	(14428, 109, '2015-01-15 01:00:00.000000', 'temperatura', 154.0000, 'ºC'),
	(14429, 109, '2015-01-15 01:00:01.000000', 'temperatura', 1126.0000, 'ºC'),
	(14430, 109, '2015-01-15 01:00:02.000000', 'temperatura', 369.0000, 'ºC'),
	(14431, 109, '2015-01-15 01:00:03.000000', 'temperatura', 866.0000, 'ºC'),
	(14432, 109, '2015-01-15 01:00:04.000000', 'temperatura', 825.0000, 'ºC'),
	(14433, 109, '2015-01-15 01:00:05.000000', 'temperatura', 326.0000, 'ºC'),
	(14434, 109, '2015-01-15 01:00:06.000000', 'temperatura', 354.0000, 'ºC'),
	(14435, 109, '2015-01-15 01:00:07.000000', 'temperatura', 795.0000, 'ºC'),
	(14436, 109, '2015-01-15 01:00:08.000000', 'temperatura', 514.0000, 'ºC'),
	(14437, 109, '2015-01-15 01:00:09.000000', 'temperatura', 186.0000, 'ºC'),
	(14438, 109, '2015-01-15 01:00:10.000000', 'temperatura', 586.0000, 'ºC'),
	(14439, 109, '2015-01-15 01:00:11.000000', 'temperatura', 1172.0000, 'ºC'),
	(14440, 109, '2015-01-15 01:00:12.000000', 'temperatura', 506.0000, 'ºC'),
	(14441, 109, '2015-01-15 01:00:13.000000', 'temperatura', 212.0000, 'ºC'),
	(14442, 109, '2015-01-15 01:00:14.000000', 'temperatura', 742.0000, 'ºC'),
	(14443, 109, '2015-01-15 01:00:15.000000', 'temperatura', 674.0000, 'ºC'),
	(14444, 109, '2015-01-15 01:00:16.000000', 'temperatura', 1144.0000, 'ºC'),
	(14445, 109, '2015-01-15 01:00:17.000000', 'temperatura', 99.0000, 'ºC'),
	(14446, 109, '2015-01-15 01:00:18.000000', 'temperatura', 664.0000, 'ºC'),
	(14447, 109, '2015-01-15 01:00:19.000000', 'temperatura', 624.0000, 'ºC'),
	(14448, 109, '2015-01-15 01:00:20.000000', 'temperatura', 1126.0000, 'ºC'),
	(14449, 109, '2015-01-15 01:00:21.000000', 'temperatura', 161.0000, 'ºC'),
	(14450, 109, '2015-01-15 01:00:22.000000', 'temperatura', 1027.0000, 'ºC'),
	(14451, 109, '2015-01-15 01:00:23.000000', 'temperatura', 1053.0000, 'ºC'),
	(14452, 109, '2015-01-15 01:00:24.000000', 'temperatura', 984.0000, 'ºC'),
	(14453, 109, '2015-01-15 01:00:25.000000', 'temperatura', 562.0000, 'ºC'),
	(14454, 109, '2015-01-15 01:00:26.000000', 'temperatura', 1060.0000, 'ºC'),
	(14455, 109, '2015-01-15 01:00:27.000000', 'temperatura', 11.0000, 'ºC'),
	(14456, 109, '2015-01-15 01:00:28.000000', 'temperatura', 478.0000, 'ºC'),
	(14457, 109, '2015-01-15 01:00:29.000000', 'temperatura', 1157.0000, 'ºC'),
	(14458, 109, '2015-01-15 01:00:30.000000', 'temperatura', 750.0000, 'ºC'),
	(14459, 109, '2015-01-15 01:00:31.000000', 'temperatura', 280.0000, 'ºC'),
	(14460, 109, '2015-01-15 01:00:32.000000', 'temperatura', 353.0000, 'ºC'),
	(14461, 109, '2015-01-15 01:00:33.000000', 'temperatura', 922.0000, 'ºC'),
	(14462, 109, '2015-01-15 01:00:34.000000', 'temperatura', 1153.0000, 'ºC'),
	(14463, 109, '2015-01-15 01:00:35.000000', 'temperatura', 600.0000, 'ºC'),
	(14464, 109, '2015-01-15 01:00:36.000000', 'temperatura', 740.0000, 'ºC'),
	(14465, 109, '2015-01-15 01:00:37.000000', 'temperatura', 702.0000, 'ºC'),
	(14466, 109, '2015-01-15 01:00:38.000000', 'temperatura', 88.0000, 'ºC'),
	(14467, 109, '2015-01-15 01:00:39.000000', 'temperatura', 736.0000, 'ºC'),
	(14468, 109, '2015-01-15 01:00:40.000000', 'temperatura', 1016.0000, 'ºC'),
	(14469, 109, '2015-01-15 01:00:41.000000', 'temperatura', 472.0000, 'ºC'),
	(14470, 109, '2015-01-15 01:00:42.000000', 'temperatura', 515.0000, 'ºC'),
	(14471, 109, '2015-01-15 01:00:43.000000', 'temperatura', 1157.0000, 'ºC'),
	(14472, 109, '2015-01-15 01:00:44.000000', 'temperatura', 640.0000, 'ºC'),
	(14473, 109, '2015-01-15 01:00:45.000000', 'temperatura', 931.0000, 'ºC'),
	(14474, 109, '2015-01-15 01:00:46.000000', 'temperatura', 333.0000, 'ºC'),
	(14475, 109, '2015-01-15 01:00:47.000000', 'temperatura', 74.0000, 'ºC'),
	(14476, 109, '2015-01-15 01:00:48.000000', 'temperatura', 573.0000, 'ºC'),
	(14477, 109, '2015-01-15 01:00:49.000000', 'temperatura', 241.0000, 'ºC'),
	(14478, 109, '2015-01-15 01:00:50.000000', 'temperatura', 687.0000, 'ºC'),
	(14479, 109, '2015-01-15 01:00:51.000000', 'temperatura', 311.0000, 'ºC'),
	(14480, 109, '2015-01-15 01:00:52.000000', 'temperatura', 695.0000, 'ºC'),
	(14481, 109, '2015-01-15 01:00:53.000000', 'temperatura', 145.0000, 'ºC'),
	(14482, 109, '2015-01-15 01:00:54.000000', 'temperatura', 1038.0000, 'ºC'),
	(14483, 109, '2015-01-15 01:00:55.000000', 'temperatura', 1155.0000, 'ºC'),
	(14484, 109, '2015-01-15 01:00:56.000000', 'temperatura', 261.0000, 'ºC'),
	(14485, 109, '2015-01-15 01:00:57.000000', 'temperatura', 243.0000, 'ºC'),
	(14486, 109, '2015-01-15 01:00:58.000000', 'temperatura', 430.0000, 'ºC'),
	(14487, 109, '2015-01-15 01:00:59.000000', 'temperatura', 222.0000, 'ºC'),
	(14488, 109, '2015-01-15 01:01:00.000000', 'temperatura', 1020.0000, 'ºC'),
	(14489, 109, '2015-01-15 01:01:01.000000', 'temperatura', 835.0000, 'ºC'),
	(14490, 109, '2015-01-15 01:01:02.000000', 'temperatura', 1117.0000, 'ºC'),
	(14491, 109, '2015-01-15 01:01:03.000000', 'temperatura', 679.0000, 'ºC'),
	(14492, 109, '2015-01-15 01:01:04.000000', 'temperatura', 46.0000, 'ºC'),
	(14493, 109, '2015-01-15 01:01:05.000000', 'temperatura', 594.0000, 'ºC'),
	(14494, 109, '2015-01-15 01:01:06.000000', 'temperatura', 431.0000, 'ºC'),
	(14495, 109, '2015-01-15 01:01:07.000000', 'temperatura', 374.0000, 'ºC'),
	(14496, 109, '2015-01-15 01:01:08.000000', 'temperatura', 578.0000, 'ºC'),
	(14497, 109, '2015-01-15 01:01:09.000000', 'temperatura', 570.0000, 'ºC'),
	(14498, 109, '2015-01-15 01:01:10.000000', 'temperatura', 1114.0000, 'ºC'),
	(14499, 109, '2015-01-15 01:01:11.000000', 'temperatura', 260.0000, 'ºC'),
	(14500, 109, '2015-01-15 01:01:12.000000', 'temperatura', 361.0000, 'ºC'),
	(14501, 109, '2015-01-15 01:01:13.000000', 'temperatura', 1025.0000, 'ºC'),
	(14502, 109, '2015-01-15 01:01:14.000000', 'temperatura', 444.0000, 'ºC'),
	(14503, 109, '2015-01-15 01:01:15.000000', 'temperatura', 344.0000, 'ºC'),
	(14504, 109, '2015-01-15 01:01:16.000000', 'temperatura', 387.0000, 'ºC'),
	(14505, 109, '2015-01-15 01:01:17.000000', 'temperatura', 903.0000, 'ºC'),
	(14506, 109, '2015-01-15 01:01:18.000000', 'temperatura', 954.0000, 'ºC'),
	(14507, 109, '2015-01-15 01:01:19.000000', 'temperatura', 864.0000, 'ºC'),
	(14508, 109, '2015-01-15 01:01:20.000000', 'temperatura', 256.0000, 'ºC'),
	(14509, 109, '2015-01-15 01:01:21.000000', 'temperatura', 1090.0000, 'ºC'),
	(14510, 109, '2015-01-15 01:01:22.000000', 'temperatura', 1082.0000, 'ºC'),
	(14511, 109, '2015-01-15 01:01:23.000000', 'temperatura', 941.0000, 'ºC'),
	(14512, 109, '2015-01-15 01:01:24.000000', 'temperatura', 258.0000, 'ºC'),
	(14513, 109, '2015-01-15 01:01:25.000000', 'temperatura', 866.0000, 'ºC'),
	(14514, 109, '2015-01-15 01:01:26.000000', 'temperatura', 1159.0000, 'ºC'),
	(14515, 109, '2015-01-15 01:01:27.000000', 'temperatura', 798.0000, 'ºC'),
	(14516, 109, '2015-01-15 01:01:28.000000', 'temperatura', 511.0000, 'ºC'),
	(14517, 109, '2015-01-15 01:01:29.000000', 'temperatura', 164.0000, 'ºC'),
	(14518, 109, '2015-01-15 01:01:30.000000', 'temperatura', 485.0000, 'ºC'),
	(14519, 109, '2015-01-15 01:01:31.000000', 'temperatura', 735.0000, 'ºC'),
	(14520, 109, '2015-01-15 01:01:32.000000', 'temperatura', 1021.0000, 'ºC'),
	(14521, 109, '2015-01-15 01:01:33.000000', 'temperatura', 498.0000, 'ºC'),
	(14522, 109, '2015-01-15 01:01:34.000000', 'temperatura', 629.0000, 'ºC'),
	(14523, 109, '2015-01-15 01:01:35.000000', 'temperatura', 453.0000, 'ºC'),
	(14524, 109, '2015-01-15 01:01:36.000000', 'temperatura', 379.0000, 'ºC'),
	(14525, 109, '2015-01-15 01:01:37.000000', 'temperatura', 533.0000, 'ºC'),
	(14526, 109, '2015-01-15 01:01:38.000000', 'temperatura', 332.0000, 'ºC'),
	(14527, 109, '2015-01-15 01:01:39.000000', 'temperatura', 60.0000, 'ºC'),
	(14528, 109, '2015-01-15 01:01:40.000000', 'temperatura', 504.0000, 'ºC'),
	(14529, 109, '2015-01-15 01:01:41.000000', 'temperatura', 1140.0000, 'ºC'),
	(14530, 109, '2015-01-15 01:01:42.000000', 'temperatura', 588.0000, 'ºC'),
	(14531, 109, '2015-01-15 01:01:43.000000', 'temperatura', 720.0000, 'ºC'),
	(14532, 109, '2015-01-15 01:01:44.000000', 'temperatura', 637.0000, 'ºC'),
	(14533, 109, '2015-01-15 01:01:45.000000', 'temperatura', 1025.0000, 'ºC'),
	(14534, 109, '2015-01-15 01:01:46.000000', 'temperatura', 814.0000, 'ºC'),
	(14535, 109, '2015-01-15 01:01:47.000000', 'temperatura', 998.0000, 'ºC'),
	(14536, 109, '2015-01-15 01:01:48.000000', 'temperatura', 148.0000, 'ºC'),
	(14537, 109, '2015-01-15 01:01:49.000000', 'temperatura', 145.0000, 'ºC'),
	(14538, 109, '2015-01-15 01:01:50.000000', 'temperatura', 281.0000, 'ºC'),
	(14539, 109, '2015-01-15 01:01:51.000000', 'temperatura', 972.0000, 'ºC'),
	(14540, 109, '2015-01-15 01:01:52.000000', 'temperatura', 419.0000, 'ºC'),
	(14541, 109, '2015-01-15 01:01:53.000000', 'temperatura', 377.0000, 'ºC'),
	(14542, 109, '2015-01-15 01:01:54.000000', 'temperatura', 631.0000, 'ºC'),
	(14543, 109, '2015-01-15 01:01:55.000000', 'temperatura', 823.0000, 'ºC'),
	(14544, 109, '2015-01-15 01:01:56.000000', 'temperatura', 1024.0000, 'ºC'),
	(14545, 109, '2015-01-15 01:01:57.000000', 'temperatura', 249.0000, 'ºC'),
	(14546, 109, '2015-01-15 01:01:58.000000', 'temperatura', 575.0000, 'ºC'),
	(14547, 109, '2015-01-15 01:01:59.000000', 'temperatura', 929.0000, 'ºC'),
	(14548, 109, '2015-01-15 01:02:00.000000', 'temperatura', 519.0000, 'ºC'),
	(14549, 109, '2015-01-15 01:02:01.000000', 'temperatura', 1010.0000, 'ºC'),
	(14550, 109, '2015-01-15 01:02:02.000000', 'temperatura', 1095.0000, 'ºC'),
	(14551, 109, '2015-01-15 01:02:03.000000', 'temperatura', 42.0000, 'ºC'),
	(14552, 109, '2015-01-15 01:02:04.000000', 'temperatura', 527.0000, 'ºC'),
	(14553, 109, '2015-01-15 01:02:05.000000', 'temperatura', 109.0000, 'ºC'),
	(14554, 109, '2015-01-15 01:02:06.000000', 'temperatura', 166.0000, 'ºC'),
	(14555, 109, '2015-01-15 01:02:07.000000', 'temperatura', 502.0000, 'ºC'),
	(14556, 109, '2015-01-15 01:02:08.000000', 'temperatura', 812.0000, 'ºC'),
	(14557, 109, '2015-01-15 01:02:09.000000', 'temperatura', 154.0000, 'ºC'),
	(14558, 109, '2015-01-15 01:02:10.000000', 'temperatura', 737.0000, 'ºC'),
	(14559, 109, '2015-01-15 01:02:11.000000', 'temperatura', 822.0000, 'ºC'),
	(14560, 109, '2015-01-15 01:02:12.000000', 'temperatura', 700.0000, 'ºC'),
	(14561, 109, '2015-01-15 01:02:13.000000', 'temperatura', 1036.0000, 'ºC'),
	(14562, 109, '2015-01-15 01:02:14.000000', 'temperatura', 678.0000, 'ºC'),
	(14563, 109, '2015-01-15 01:02:15.000000', 'temperatura', 285.0000, 'ºC'),
	(14564, 109, '2015-01-15 01:02:16.000000', 'temperatura', 590.0000, 'ºC'),
	(14565, 109, '2015-01-15 01:02:17.000000', 'temperatura', 897.0000, 'ºC'),
	(14566, 109, '2015-01-15 01:02:18.000000', 'temperatura', 315.0000, 'ºC'),
	(14567, 109, '2015-01-15 01:02:19.000000', 'temperatura', 85.0000, 'ºC'),
	(14568, 109, '2015-01-15 01:02:20.000000', 'temperatura', 680.0000, 'ºC'),
	(14569, 109, '2015-01-15 01:02:21.000000', 'temperatura', 748.0000, 'ºC'),
	(14570, 109, '2015-01-15 01:02:22.000000', 'temperatura', 497.0000, 'ºC'),
	(14571, 109, '2015-01-15 01:02:23.000000', 'temperatura', 242.0000, 'ºC'),
	(14572, 109, '2015-01-15 01:02:24.000000', 'temperatura', 920.0000, 'ºC'),
	(14573, 109, '2015-01-15 01:02:25.000000', 'temperatura', 274.0000, 'ºC'),
	(14574, 109, '2015-01-15 01:02:26.000000', 'temperatura', 1010.0000, 'ºC'),
	(14575, 109, '2015-01-15 01:02:27.000000', 'temperatura', 630.0000, 'ºC'),
	(14576, 109, '2015-01-15 01:02:28.000000', 'temperatura', 121.0000, 'ºC'),
	(14577, 109, '2015-01-15 01:02:29.000000', 'temperatura', 1115.0000, 'ºC'),
	(14578, 109, '2015-01-15 01:02:30.000000', 'temperatura', 413.0000, 'ºC'),
	(14579, 109, '2015-01-15 01:02:31.000000', 'temperatura', 1121.0000, 'ºC'),
	(14580, 109, '2015-01-15 01:02:32.000000', 'temperatura', 768.0000, 'ºC'),
	(14581, 109, '2015-01-15 01:02:33.000000', 'temperatura', 474.0000, 'ºC'),
	(14582, 109, '2015-01-15 01:02:34.000000', 'temperatura', 68.0000, 'ºC'),
	(14583, 109, '2015-01-15 01:02:35.000000', 'temperatura', 118.0000, 'ºC'),
	(14584, 109, '2015-01-15 01:02:36.000000', 'temperatura', 389.0000, 'ºC'),
	(14585, 109, '2015-01-15 01:02:37.000000', 'temperatura', 390.0000, 'ºC'),
	(14586, 109, '2015-01-15 01:02:38.000000', 'temperatura', 782.0000, 'ºC'),
	(14587, 109, '2015-01-15 01:02:39.000000', 'temperatura', 342.0000, 'ºC'),
	(14588, 109, '2015-01-15 01:02:40.000000', 'temperatura', 563.0000, 'ºC'),
	(14589, 109, '2015-01-15 01:02:41.000000', 'temperatura', 590.0000, 'ºC'),
	(14590, 109, '2015-01-15 01:02:42.000000', 'temperatura', 60.0000, 'ºC'),
	(14591, 109, '2015-01-15 01:02:43.000000', 'temperatura', 933.0000, 'ºC'),
	(14592, 109, '2015-01-15 01:02:44.000000', 'temperatura', 883.0000, 'ºC'),
	(14593, 109, '2015-01-15 01:02:45.000000', 'temperatura', 416.0000, 'ºC'),
	(14594, 109, '2015-01-15 01:02:46.000000', 'temperatura', 632.0000, 'ºC'),
	(14595, 109, '2015-01-15 01:02:47.000000', 'temperatura', 712.0000, 'ºC'),
	(14596, 109, '2015-01-15 01:02:48.000000', 'temperatura', 467.0000, 'ºC'),
	(14597, 109, '2015-01-15 01:02:49.000000', 'temperatura', 197.0000, 'ºC'),
	(14598, 109, '2015-01-15 01:02:50.000000', 'temperatura', 783.0000, 'ºC'),
	(14599, 109, '2015-01-15 01:02:51.000000', 'temperatura', 927.0000, 'ºC'),
	(14600, 109, '2015-01-15 01:02:52.000000', 'temperatura', 1088.0000, 'ºC'),
	(14601, 109, '2015-01-15 01:02:53.000000', 'temperatura', 258.0000, 'ºC'),
	(14602, 109, '2015-01-15 01:02:54.000000', 'temperatura', 427.0000, 'ºC'),
	(14603, 109, '2015-01-15 01:02:55.000000', 'temperatura', 159.0000, 'ºC'),
	(14604, 109, '2015-01-15 01:02:56.000000', 'temperatura', 718.0000, 'ºC'),
	(14605, 109, '2015-01-15 01:02:57.000000', 'temperatura', 711.0000, 'ºC'),
	(14606, 109, '2015-01-15 01:02:58.000000', 'temperatura', 202.0000, 'ºC'),
	(14607, 109, '2015-01-15 01:02:59.000000', 'temperatura', 80.0000, 'ºC'),
	(14608, 109, '2015-01-15 01:03:00.000000', 'temperatura', 991.0000, 'ºC'),
	(14609, 109, '2015-01-15 01:03:01.000000', 'temperatura', 1118.0000, 'ºC'),
	(14610, 109, '2015-01-15 01:03:02.000000', 'temperatura', 218.0000, 'ºC'),
	(14611, 109, '2015-01-15 01:03:03.000000', 'temperatura', 138.0000, 'ºC'),
	(14612, 109, '2015-01-15 01:03:04.000000', 'temperatura', 33.0000, 'ºC'),
	(14613, 109, '2015-01-15 01:03:05.000000', 'temperatura', 952.0000, 'ºC'),
	(14614, 109, '2015-01-15 01:03:06.000000', 'temperatura', 1064.0000, 'ºC'),
	(14615, 109, '2015-01-15 01:03:07.000000', 'temperatura', 61.0000, 'ºC'),
	(14616, 109, '2015-01-15 01:03:08.000000', 'temperatura', 716.0000, 'ºC'),
	(14617, 109, '2015-01-15 01:03:09.000000', 'temperatura', 995.0000, 'ºC'),
	(14618, 109, '2015-01-15 01:03:10.000000', 'temperatura', 429.0000, 'ºC'),
	(14619, 109, '2015-01-15 01:03:11.000000', 'temperatura', 359.0000, 'ºC'),
	(14620, 109, '2015-01-15 01:03:12.000000', 'temperatura', 509.0000, 'ºC'),
	(14621, 109, '2015-01-15 01:03:13.000000', 'temperatura', 268.0000, 'ºC'),
	(14622, 109, '2015-01-15 01:03:14.000000', 'temperatura', 1015.0000, 'ºC'),
	(14623, 109, '2015-01-15 01:03:15.000000', 'temperatura', 672.0000, 'ºC'),
	(14624, 109, '2015-01-15 01:03:16.000000', 'temperatura', 316.0000, 'ºC'),
	(14625, 109, '2015-01-15 01:03:17.000000', 'temperatura', 765.0000, 'ºC'),
	(14626, 109, '2015-01-15 01:03:18.000000', 'temperatura', 476.0000, 'ºC'),
	(14627, 109, '2015-01-15 01:03:19.000000', 'temperatura', 86.0000, 'ºC'),
	(14628, 109, '2015-01-15 01:03:20.000000', 'temperatura', 204.0000, 'ºC'),
	(14629, 109, '2015-01-15 01:03:21.000000', 'temperatura', 759.0000, 'ºC'),
	(14630, 109, '2015-01-15 01:03:22.000000', 'temperatura', 787.0000, 'ºC'),
	(14631, 109, '2015-01-15 01:03:23.000000', 'temperatura', 458.0000, 'ºC'),
	(14632, 109, '2015-01-15 01:03:24.000000', 'temperatura', 1127.0000, 'ºC'),
	(14633, 109, '2015-01-15 01:03:25.000000', 'temperatura', 665.0000, 'ºC'),
	(14634, 109, '2015-01-15 01:03:26.000000', 'temperatura', 1142.0000, 'ºC'),
	(14635, 109, '2015-01-15 01:03:27.000000', 'temperatura', 115.0000, 'ºC'),
	(14636, 109, '2015-01-15 01:03:28.000000', 'temperatura', 750.0000, 'ºC'),
	(14637, 109, '2015-01-15 01:03:29.000000', 'temperatura', 1007.0000, 'ºC'),
	(14638, 109, '2015-01-15 01:03:30.000000', 'temperatura', 382.0000, 'ºC'),
	(14639, 109, '2015-01-15 01:03:31.000000', 'temperatura', 93.0000, 'ºC'),
	(14640, 109, '2015-01-15 01:03:32.000000', 'temperatura', 520.0000, 'ºC'),
	(14641, 109, '2015-01-15 01:03:33.000000', 'temperatura', 1121.0000, 'ºC'),
	(14642, 109, '2015-01-15 01:03:34.000000', 'temperatura', 446.0000, 'ºC'),
	(14643, 109, '2015-01-15 01:03:35.000000', 'temperatura', 65.0000, 'ºC'),
	(14644, 109, '2015-01-15 01:03:36.000000', 'temperatura', 187.0000, 'ºC'),
	(14645, 109, '2015-01-15 01:03:37.000000', 'temperatura', 744.0000, 'ºC'),
	(14646, 109, '2015-01-15 01:03:38.000000', 'temperatura', 756.0000, 'ºC'),
	(14647, 109, '2015-01-15 01:03:39.000000', 'temperatura', 352.0000, 'ºC'),
	(14648, 109, '2015-01-15 01:03:40.000000', 'temperatura', 690.0000, 'ºC'),
	(14649, 109, '2015-01-15 01:03:41.000000', 'temperatura', 1196.0000, 'ºC'),
	(14650, 109, '2015-01-15 01:03:42.000000', 'temperatura', 310.0000, 'ºC'),
	(14651, 109, '2015-01-15 01:03:43.000000', 'temperatura', 361.0000, 'ºC'),
	(14652, 109, '2015-01-15 01:03:44.000000', 'temperatura', 876.0000, 'ºC'),
	(14653, 109, '2015-01-15 01:03:45.000000', 'temperatura', 896.0000, 'ºC'),
	(14654, 109, '2015-01-15 01:03:46.000000', 'temperatura', 655.0000, 'ºC'),
	(14655, 109, '2015-01-15 01:03:47.000000', 'temperatura', 585.0000, 'ºC'),
	(14656, 109, '2015-01-15 01:03:48.000000', 'temperatura', 963.0000, 'ºC'),
	(14657, 109, '2015-01-15 01:03:49.000000', 'temperatura', 660.0000, 'ºC'),
	(14658, 109, '2015-01-15 01:03:50.000000', 'temperatura', 412.0000, 'ºC'),
	(14659, 109, '2015-01-15 01:03:51.000000', 'temperatura', 81.0000, 'ºC'),
	(14660, 109, '2015-01-15 01:03:52.000000', 'temperatura', 367.0000, 'ºC'),
	(14661, 109, '2015-01-15 01:03:53.000000', 'temperatura', 392.0000, 'ºC'),
	(14662, 109, '2015-01-15 01:03:54.000000', 'temperatura', 861.0000, 'ºC'),
	(14663, 109, '2015-01-15 01:03:55.000000', 'temperatura', 730.0000, 'ºC'),
	(14664, 109, '2015-01-15 01:03:56.000000', 'temperatura', 1066.0000, 'ºC'),
	(14665, 109, '2015-01-15 01:03:57.000000', 'temperatura', 740.0000, 'ºC'),
	(14666, 109, '2015-01-15 01:03:58.000000', 'temperatura', 504.0000, 'ºC'),
	(14667, 109, '2015-01-15 01:03:59.000000', 'temperatura', 301.0000, 'ºC'),
	(14668, 109, '2015-01-15 01:04:00.000000', 'temperatura', 1192.0000, 'ºC'),
	(14669, 109, '2015-01-15 01:04:01.000000', 'temperatura', 258.0000, 'ºC'),
	(14670, 109, '2015-01-15 01:04:02.000000', 'temperatura', 114.0000, 'ºC'),
	(14671, 109, '2015-01-15 01:04:03.000000', 'temperatura', 997.0000, 'ºC'),
	(14672, 109, '2015-01-15 01:04:04.000000', 'temperatura', 1042.0000, 'ºC'),
	(14673, 109, '2015-01-15 01:04:05.000000', 'temperatura', 1019.0000, 'ºC'),
	(14674, 109, '2015-01-15 01:04:06.000000', 'temperatura', 772.0000, 'ºC'),
	(14675, 109, '2015-01-15 01:04:07.000000', 'temperatura', 804.0000, 'ºC'),
	(14676, 109, '2015-01-15 01:04:08.000000', 'temperatura', 503.0000, 'ºC'),
	(14677, 109, '2015-01-15 01:04:09.000000', 'temperatura', 106.0000, 'ºC'),
	(14678, 109, '2015-01-15 01:04:10.000000', 'temperatura', 219.0000, 'ºC'),
	(14679, 109, '2015-01-15 01:04:11.000000', 'temperatura', 777.0000, 'ºC'),
	(14680, 109, '2015-01-15 01:04:12.000000', 'temperatura', 829.0000, 'ºC'),
	(14681, 109, '2015-01-15 01:04:13.000000', 'temperatura', 614.0000, 'ºC'),
	(14682, 109, '2015-01-15 01:04:14.000000', 'temperatura', 584.0000, 'ºC'),
	(14683, 109, '2015-01-15 01:04:15.000000', 'temperatura', 1077.0000, 'ºC'),
	(14684, 109, '2015-01-15 01:04:16.000000', 'temperatura', 34.0000, 'ºC'),
	(14685, 109, '2015-01-15 01:04:17.000000', 'temperatura', 542.0000, 'ºC'),
	(14686, 109, '2015-01-15 01:04:18.000000', 'temperatura', 206.0000, 'ºC'),
	(14687, 109, '2015-01-15 01:04:19.000000', 'temperatura', 605.0000, 'ºC'),
	(14688, 109, '2015-01-15 01:04:20.000000', 'temperatura', 6.0000, 'ºC'),
	(14689, 109, '2015-01-15 01:04:21.000000', 'temperatura', 615.0000, 'ºC'),
	(14690, 109, '2015-01-15 01:04:22.000000', 'temperatura', 660.0000, 'ºC'),
	(14691, 109, '2015-01-15 01:04:23.000000', 'temperatura', 257.0000, 'ºC'),
	(14692, 109, '2015-01-15 01:04:24.000000', 'temperatura', 502.0000, 'ºC'),
	(14693, 109, '2015-01-15 01:04:25.000000', 'temperatura', 540.0000, 'ºC'),
	(14694, 109, '2015-01-15 01:04:26.000000', 'temperatura', 1196.0000, 'ºC'),
	(14695, 109, '2015-01-15 01:04:27.000000', 'temperatura', 759.0000, 'ºC'),
	(14696, 109, '2015-01-15 01:04:28.000000', 'temperatura', 209.0000, 'ºC'),
	(14697, 109, '2015-01-15 01:04:29.000000', 'temperatura', 1170.0000, 'ºC'),
	(14698, 109, '2015-01-15 01:04:30.000000', 'temperatura', 421.0000, 'ºC'),
	(14699, 109, '2015-01-15 01:04:31.000000', 'temperatura', 995.0000, 'ºC'),
	(14700, 109, '2015-01-15 01:04:32.000000', 'temperatura', 114.0000, 'ºC'),
	(14701, 109, '2015-01-15 01:04:33.000000', 'temperatura', 1186.0000, 'ºC'),
	(14702, 109, '2015-01-15 01:04:34.000000', 'temperatura', 788.0000, 'ºC'),
	(14703, 109, '2015-01-15 01:04:35.000000', 'temperatura', 383.0000, 'ºC'),
	(14704, 109, '2015-01-15 01:04:36.000000', 'temperatura', 750.0000, 'ºC'),
	(14705, 109, '2015-01-15 01:04:37.000000', 'temperatura', 203.0000, 'ºC'),
	(14706, 109, '2015-01-15 01:04:38.000000', 'temperatura', 1164.0000, 'ºC'),
	(14707, 109, '2015-01-15 01:04:39.000000', 'temperatura', 413.0000, 'ºC'),
	(14708, 109, '2015-01-15 01:04:40.000000', 'temperatura', 973.0000, 'ºC'),
	(14709, 109, '2015-01-15 01:04:41.000000', 'temperatura', 28.0000, 'ºC'),
	(14710, 109, '2015-01-15 01:04:42.000000', 'temperatura', 821.0000, 'ºC'),
	(14711, 109, '2015-01-15 01:04:43.000000', 'temperatura', 419.0000, 'ºC'),
	(14712, 109, '2015-01-15 01:04:44.000000', 'temperatura', 835.0000, 'ºC'),
	(14713, 109, '2015-01-15 01:04:45.000000', 'temperatura', 519.0000, 'ºC'),
	(14714, 109, '2015-01-15 01:04:46.000000', 'temperatura', 91.0000, 'ºC'),
	(14715, 109, '2015-01-15 01:04:47.000000', 'temperatura', 99.0000, 'ºC'),
	(14716, 109, '2015-01-15 01:04:48.000000', 'temperatura', 221.0000, 'ºC'),
	(14717, 109, '2015-01-15 01:04:49.000000', 'temperatura', 811.0000, 'ºC'),
	(14718, 109, '2015-01-15 01:04:50.000000', 'temperatura', 991.0000, 'ºC'),
	(14719, 109, '2015-01-15 01:04:51.000000', 'temperatura', 121.0000, 'ºC'),
	(14720, 109, '2015-01-15 01:04:52.000000', 'temperatura', 34.0000, 'ºC'),
	(14721, 109, '2015-01-15 01:04:53.000000', 'temperatura', 1008.0000, 'ºC'),
	(14722, 109, '2015-01-15 01:04:54.000000', 'temperatura', 137.0000, 'ºC'),
	(14723, 109, '2015-01-15 01:04:55.000000', 'temperatura', 60.0000, 'ºC'),
	(14724, 109, '2015-01-15 01:04:56.000000', 'temperatura', 1091.0000, 'ºC'),
	(14725, 109, '2015-01-15 01:04:57.000000', 'temperatura', 476.0000, 'ºC'),
	(14726, 109, '2015-01-15 01:04:58.000000', 'temperatura', 305.0000, 'ºC'),
	(14727, 109, '2015-01-15 01:04:59.000000', 'temperatura', 100.0000, 'ºC'),
	(14728, 109, '2015-01-15 01:05:00.000000', 'temperatura', 786.0000, 'ºC'),
	(14729, 109, '2015-01-15 01:05:01.000000', 'temperatura', 31.0000, 'ºC'),
	(14730, 109, '2015-01-15 01:05:02.000000', 'temperatura', 196.0000, 'ºC'),
	(14731, 109, '2015-01-15 01:05:03.000000', 'temperatura', 887.0000, 'ºC'),
	(14732, 109, '2015-01-15 01:05:04.000000', 'temperatura', 247.0000, 'ºC'),
	(14733, 109, '2015-01-15 01:05:05.000000', 'temperatura', 977.0000, 'ºC'),
	(14734, 109, '2015-01-15 01:05:06.000000', 'temperatura', 543.0000, 'ºC'),
	(14735, 109, '2015-01-15 01:05:07.000000', 'temperatura', 983.0000, 'ºC'),
	(14736, 109, '2015-01-15 01:05:08.000000', 'temperatura', 888.0000, 'ºC'),
	(14737, 109, '2015-01-15 01:05:09.000000', 'temperatura', 289.0000, 'ºC'),
	(14738, 109, '2015-01-15 01:05:10.000000', 'temperatura', 1185.0000, 'ºC'),
	(14739, 109, '2015-01-15 01:05:11.000000', 'temperatura', 256.0000, 'ºC'),
	(14740, 109, '2015-01-15 01:05:12.000000', 'temperatura', 128.0000, 'ºC'),
	(14741, 109, '2015-01-15 01:05:13.000000', 'temperatura', 1072.0000, 'ºC'),
	(14742, 109, '2015-01-15 01:05:14.000000', 'temperatura', 177.0000, 'ºC'),
	(14743, 109, '2015-01-15 01:05:15.000000', 'temperatura', 69.0000, 'ºC'),
	(14744, 109, '2015-01-15 01:05:16.000000', 'temperatura', 1014.0000, 'ºC'),
	(14745, 109, '2015-01-15 01:05:17.000000', 'temperatura', 65.0000, 'ºC'),
	(14746, 109, '2015-01-15 01:05:18.000000', 'temperatura', 882.0000, 'ºC'),
	(14747, 109, '2015-01-15 01:05:19.000000', 'temperatura', 617.0000, 'ºC'),
	(14748, 109, '2015-01-15 01:05:20.000000', 'temperatura', 438.0000, 'ºC'),
	(14749, 109, '2015-01-15 01:05:21.000000', 'temperatura', 341.0000, 'ºC'),
	(14750, 109, '2015-01-15 01:05:22.000000', 'temperatura', 391.0000, 'ºC'),
	(14751, 109, '2015-01-15 01:05:23.000000', 'temperatura', 932.0000, 'ºC'),
	(14752, 109, '2015-01-15 01:05:24.000000', 'temperatura', 1086.0000, 'ºC'),
	(14753, 109, '2015-01-15 01:05:25.000000', 'temperatura', 234.0000, 'ºC'),
	(14754, 109, '2015-01-15 01:05:26.000000', 'temperatura', 315.0000, 'ºC'),
	(14755, 109, '2015-01-15 01:05:27.000000', 'temperatura', 871.0000, 'ºC'),
	(14756, 109, '2015-01-15 01:05:28.000000', 'temperatura', 1012.0000, 'ºC'),
	(14757, 109, '2015-01-15 01:05:29.000000', 'temperatura', 49.0000, 'ºC'),
	(14758, 109, '2015-01-15 01:05:30.000000', 'temperatura', 807.0000, 'ºC'),
	(14759, 109, '2015-01-15 01:05:31.000000', 'temperatura', 291.0000, 'ºC'),
	(14760, 109, '2015-01-15 01:05:32.000000', 'temperatura', 235.0000, 'ºC'),
	(14761, 109, '2015-01-15 01:05:33.000000', 'temperatura', 302.0000, 'ºC'),
	(14762, 109, '2015-01-15 01:05:34.000000', 'temperatura', 806.0000, 'ºC'),
	(14763, 109, '2015-01-15 01:05:35.000000', 'temperatura', 724.0000, 'ºC'),
	(14764, 109, '2015-01-15 01:05:36.000000', 'temperatura', 3.0000, 'ºC'),
	(14765, 109, '2015-01-15 01:05:37.000000', 'temperatura', 244.0000, 'ºC'),
	(14766, 109, '2015-01-15 01:05:38.000000', 'temperatura', 9.0000, 'ºC'),
	(14767, 109, '2015-01-15 01:05:39.000000', 'temperatura', 517.0000, 'ºC'),
	(14768, 109, '2015-01-15 01:05:40.000000', 'temperatura', 156.0000, 'ºC'),
	(14769, 109, '2015-01-15 01:05:41.000000', 'temperatura', 428.0000, 'ºC'),
	(14770, 109, '2015-01-15 01:05:42.000000', 'temperatura', 476.0000, 'ºC'),
	(14771, 109, '2015-01-15 01:05:43.000000', 'temperatura', 1094.0000, 'ºC'),
	(14772, 109, '2015-01-15 01:05:44.000000', 'temperatura', 444.0000, 'ºC'),
	(14773, 109, '2015-01-15 01:05:45.000000', 'temperatura', 137.0000, 'ºC'),
	(14774, 109, '2015-01-15 01:05:46.000000', 'temperatura', 555.0000, 'ºC'),
	(14775, 109, '2015-01-15 01:05:47.000000', 'temperatura', 1163.0000, 'ºC'),
	(14776, 109, '2015-01-15 01:05:48.000000', 'temperatura', 551.0000, 'ºC'),
	(14777, 109, '2015-01-15 01:05:49.000000', 'temperatura', 466.0000, 'ºC'),
	(14778, 109, '2015-01-15 01:05:50.000000', 'temperatura', 679.0000, 'ºC'),
	(14779, 109, '2015-01-15 01:05:51.000000', 'temperatura', 798.0000, 'ºC'),
	(14780, 109, '2015-01-15 01:05:52.000000', 'temperatura', 750.0000, 'ºC'),
	(14781, 109, '2015-01-15 01:05:53.000000', 'temperatura', 160.0000, 'ºC'),
	(14782, 109, '2015-01-15 01:05:54.000000', 'temperatura', 951.0000, 'ºC'),
	(14783, 109, '2015-01-15 01:05:55.000000', 'temperatura', 675.0000, 'ºC'),
	(14784, 109, '2015-01-15 01:05:56.000000', 'temperatura', 521.0000, 'ºC'),
	(14785, 109, '2015-01-15 01:05:57.000000', 'temperatura', 579.0000, 'ºC'),
	(14786, 109, '2015-01-15 01:05:58.000000', 'temperatura', 135.0000, 'ºC'),
	(14787, 109, '2015-01-15 01:05:59.000000', 'temperatura', 137.0000, 'ºC'),
	(14788, 109, '2015-01-15 01:06:00.000000', 'temperatura', 280.0000, 'ºC'),
	(14789, 109, '2015-01-15 01:06:01.000000', 'temperatura', 991.0000, 'ºC'),
	(14790, 109, '2015-01-15 01:06:02.000000', 'temperatura', 514.0000, 'ºC'),
	(14791, 109, '2015-01-15 01:06:03.000000', 'temperatura', 797.0000, 'ºC'),
	(14792, 109, '2015-01-15 01:06:04.000000', 'temperatura', 42.0000, 'ºC'),
	(14793, 109, '2015-01-15 01:06:05.000000', 'temperatura', 222.0000, 'ºC'),
	(14794, 109, '2015-01-15 01:06:06.000000', 'temperatura', 985.0000, 'ºC'),
	(14795, 109, '2015-01-15 01:06:07.000000', 'temperatura', 659.0000, 'ºC'),
	(14796, 109, '2015-01-15 01:06:08.000000', 'temperatura', 342.0000, 'ºC'),
	(14797, 109, '2015-01-15 01:06:09.000000', 'temperatura', 934.0000, 'ºC'),
	(14798, 109, '2015-01-15 01:06:10.000000', 'temperatura', 41.0000, 'ºC'),
	(14799, 109, '2015-01-15 01:06:11.000000', 'temperatura', 1006.0000, 'ºC'),
	(14800, 109, '2015-01-15 01:06:12.000000', 'temperatura', 108.0000, 'ºC'),
	(14801, 109, '2015-01-15 01:06:13.000000', 'temperatura', 1124.0000, 'ºC'),
	(14802, 109, '2015-01-15 01:06:14.000000', 'temperatura', 494.0000, 'ºC'),
	(14803, 109, '2015-01-15 01:06:15.000000', 'temperatura', 299.0000, 'ºC'),
	(14804, 109, '2015-01-15 01:06:16.000000', 'temperatura', 12.0000, 'ºC'),
	(14805, 109, '2015-01-15 01:06:17.000000', 'temperatura', 364.0000, 'ºC'),
	(14806, 109, '2015-01-15 01:06:18.000000', 'temperatura', 584.0000, 'ºC'),
	(14807, 109, '2015-01-15 01:06:19.000000', 'temperatura', 630.0000, 'ºC'),
	(14808, 109, '2015-01-15 01:06:20.000000', 'temperatura', 198.0000, 'ºC'),
	(14809, 109, '2015-01-15 01:06:21.000000', 'temperatura', 300.0000, 'ºC'),
	(14810, 109, '2015-01-15 01:06:22.000000', 'temperatura', 908.0000, 'ºC'),
	(14811, 109, '2015-01-15 01:06:23.000000', 'temperatura', 40.0000, 'ºC'),
	(14812, 109, '2015-01-15 01:06:24.000000', 'temperatura', 1074.0000, 'ºC'),
	(14813, 109, '2015-01-15 01:06:25.000000', 'temperatura', 453.0000, 'ºC'),
	(14814, 109, '2015-01-15 01:06:26.000000', 'temperatura', 242.0000, 'ºC'),
	(14815, 109, '2015-01-15 01:06:27.000000', 'temperatura', 1053.0000, 'ºC'),
	(14816, 109, '2015-01-15 01:06:28.000000', 'temperatura', 938.0000, 'ºC'),
	(14817, 109, '2015-01-15 01:06:29.000000', 'temperatura', 334.0000, 'ºC'),
	(14818, 109, '2015-01-15 01:06:30.000000', 'temperatura', 54.0000, 'ºC'),
	(14819, 109, '2015-01-15 01:06:31.000000', 'temperatura', 471.0000, 'ºC'),
	(14820, 109, '2015-01-15 01:06:32.000000', 'temperatura', 991.0000, 'ºC'),
	(14821, 109, '2015-01-15 01:06:33.000000', 'temperatura', 1144.0000, 'ºC'),
	(14822, 109, '2015-01-15 01:06:34.000000', 'temperatura', 346.0000, 'ºC'),
	(14823, 109, '2015-01-15 01:06:35.000000', 'temperatura', 699.0000, 'ºC'),
	(14824, 109, '2015-01-15 01:06:36.000000', 'temperatura', 58.0000, 'ºC'),
	(14825, 109, '2015-01-15 01:06:37.000000', 'temperatura', 594.0000, 'ºC'),
	(14826, 109, '2015-01-15 01:06:38.000000', 'temperatura', 398.0000, 'ºC'),
	(14827, 109, '2015-01-15 01:06:39.000000', 'temperatura', 207.0000, 'ºC'),
	(14828, 109, '2015-01-15 01:06:40.000000', 'temperatura', 1042.0000, 'ºC'),
	(14829, 109, '2015-01-15 01:06:41.000000', 'temperatura', 988.0000, 'ºC'),
	(14830, 109, '2015-01-15 01:06:42.000000', 'temperatura', 615.0000, 'ºC'),
	(14831, 109, '2015-01-15 01:06:43.000000', 'temperatura', 113.0000, 'ºC'),
	(14832, 109, '2015-01-15 01:06:44.000000', 'temperatura', 1119.0000, 'ºC'),
	(14833, 109, '2015-01-15 01:06:45.000000', 'temperatura', 458.0000, 'ºC'),
	(14834, 109, '2015-01-15 01:06:46.000000', 'temperatura', 133.0000, 'ºC'),
	(14835, 109, '2015-01-15 01:06:47.000000', 'temperatura', 493.0000, 'ºC'),
	(14836, 109, '2015-01-15 01:06:48.000000', 'temperatura', 865.0000, 'ºC'),
	(14837, 109, '2015-01-15 01:06:49.000000', 'temperatura', 445.0000, 'ºC'),
	(14838, 109, '2015-01-15 01:06:50.000000', 'temperatura', 832.0000, 'ºC'),
	(14839, 109, '2015-01-15 01:06:51.000000', 'temperatura', 424.0000, 'ºC'),
	(14840, 109, '2015-01-15 01:06:52.000000', 'temperatura', 826.0000, 'ºC'),
	(14841, 109, '2015-01-15 01:06:53.000000', 'temperatura', 458.0000, 'ºC'),
	(14842, 109, '2015-01-15 01:06:54.000000', 'temperatura', 1011.0000, 'ºC'),
	(14843, 109, '2015-01-15 01:06:55.000000', 'temperatura', 84.0000, 'ºC'),
	(14844, 109, '2015-01-15 01:06:56.000000', 'temperatura', 987.0000, 'ºC'),
	(14845, 109, '2015-01-15 01:06:57.000000', 'temperatura', 1083.0000, 'ºC'),
	(14846, 109, '2015-01-15 01:06:58.000000', 'temperatura', 56.0000, 'ºC'),
	(14847, 109, '2015-01-15 01:06:59.000000', 'temperatura', 629.0000, 'ºC'),
	(14848, 109, '2015-01-15 01:07:00.000000', 'temperatura', 579.0000, 'ºC'),
	(14849, 109, '2015-01-15 01:07:01.000000', 'temperatura', 1007.0000, 'ºC'),
	(14850, 109, '2015-01-15 01:07:02.000000', 'temperatura', 899.0000, 'ºC'),
	(14851, 109, '2015-01-15 01:07:03.000000', 'temperatura', 277.0000, 'ºC'),
	(14852, 109, '2015-01-15 01:07:04.000000', 'temperatura', 1085.0000, 'ºC'),
	(14853, 109, '2015-01-15 01:07:05.000000', 'temperatura', 996.0000, 'ºC'),
	(14854, 109, '2015-01-15 01:07:06.000000', 'temperatura', 526.0000, 'ºC'),
	(14855, 109, '2015-01-15 01:07:07.000000', 'temperatura', 840.0000, 'ºC'),
	(14856, 109, '2015-01-15 01:07:08.000000', 'temperatura', 225.0000, 'ºC'),
	(14857, 109, '2015-01-15 01:07:09.000000', 'temperatura', 1007.0000, 'ºC'),
	(14858, 109, '2015-01-15 01:07:10.000000', 'temperatura', 758.0000, 'ºC'),
	(14859, 109, '2015-01-15 01:07:11.000000', 'temperatura', 772.0000, 'ºC'),
	(14860, 109, '2015-01-15 01:07:12.000000', 'temperatura', 385.0000, 'ºC'),
	(14861, 109, '2015-01-15 01:07:13.000000', 'temperatura', 809.0000, 'ºC'),
	(14862, 109, '2015-01-15 01:07:14.000000', 'temperatura', 492.0000, 'ºC'),
	(14863, 109, '2015-01-15 01:07:15.000000', 'temperatura', 33.0000, 'ºC'),
	(14864, 109, '2015-01-15 01:07:16.000000', 'temperatura', 1090.0000, 'ºC'),
	(14865, 109, '2015-01-15 01:07:17.000000', 'temperatura', 552.0000, 'ºC'),
	(14866, 109, '2015-01-15 01:07:18.000000', 'temperatura', 689.0000, 'ºC'),
	(14867, 109, '2015-01-15 01:07:19.000000', 'temperatura', 589.0000, 'ºC'),
	(14868, 109, '2015-01-15 01:07:20.000000', 'temperatura', 878.0000, 'ºC'),
	(14869, 109, '2015-01-15 01:07:21.000000', 'temperatura', 225.0000, 'ºC'),
	(14870, 109, '2015-01-15 01:07:22.000000', 'temperatura', 889.0000, 'ºC'),
	(14871, 109, '2015-01-15 01:07:23.000000', 'temperatura', 174.0000, 'ºC'),
	(14872, 109, '2015-01-15 01:07:24.000000', 'temperatura', 601.0000, 'ºC'),
	(14873, 109, '2015-01-15 01:07:25.000000', 'temperatura', 83.0000, 'ºC'),
	(14874, 109, '2015-01-15 01:07:26.000000', 'temperatura', 1013.0000, 'ºC'),
	(14875, 109, '2015-01-15 01:07:27.000000', 'temperatura', 17.0000, 'ºC'),
	(14876, 109, '2015-01-15 01:07:28.000000', 'temperatura', 648.0000, 'ºC'),
	(14877, 109, '2015-01-15 01:07:29.000000', 'temperatura', 788.0000, 'ºC'),
	(14878, 109, '2015-01-15 01:07:30.000000', 'temperatura', 796.0000, 'ºC'),
	(14879, 109, '2015-01-15 01:07:31.000000', 'temperatura', 416.0000, 'ºC'),
	(14880, 109, '2015-01-15 01:07:32.000000', 'temperatura', 893.0000, 'ºC'),
	(14881, 109, '2015-01-15 01:07:33.000000', 'temperatura', 816.0000, 'ºC'),
	(14882, 109, '2015-01-15 01:07:34.000000', 'temperatura', 201.0000, 'ºC'),
	(14883, 109, '2015-01-15 01:07:35.000000', 'temperatura', 957.0000, 'ºC'),
	(14884, 109, '2015-01-15 01:07:36.000000', 'temperatura', 585.0000, 'ºC'),
	(14885, 109, '2015-01-15 01:07:37.000000', 'temperatura', 54.0000, 'ºC'),
	(14886, 109, '2015-01-15 01:07:38.000000', 'temperatura', 913.0000, 'ºC'),
	(14887, 109, '2015-01-15 01:07:39.000000', 'temperatura', 806.0000, 'ºC'),
	(14888, 109, '2015-01-15 01:07:40.000000', 'temperatura', 89.0000, 'ºC'),
	(14889, 109, '2015-01-15 01:07:41.000000', 'temperatura', 431.0000, 'ºC'),
	(14890, 109, '2015-01-15 01:07:42.000000', 'temperatura', 686.0000, 'ºC'),
	(14891, 109, '2015-01-15 01:07:43.000000', 'temperatura', 940.0000, 'ºC'),
	(14892, 109, '2015-01-15 01:07:44.000000', 'temperatura', 242.0000, 'ºC'),
	(14893, 109, '2015-01-15 01:07:45.000000', 'temperatura', 789.0000, 'ºC'),
	(14894, 109, '2015-01-15 01:07:46.000000', 'temperatura', 821.0000, 'ºC'),
	(14895, 109, '2015-01-15 01:07:47.000000', 'temperatura', 536.0000, 'ºC'),
	(14896, 109, '2015-01-15 01:07:48.000000', 'temperatura', 219.0000, 'ºC'),
	(14897, 109, '2015-01-15 01:07:49.000000', 'temperatura', 689.0000, 'ºC'),
	(14898, 109, '2015-01-15 01:07:50.000000', 'temperatura', 388.0000, 'ºC'),
	(14899, 109, '2015-01-15 01:07:51.000000', 'temperatura', 1074.0000, 'ºC'),
	(14900, 109, '2015-01-15 01:07:52.000000', 'temperatura', 608.0000, 'ºC'),
	(14901, 109, '2015-01-15 01:07:53.000000', 'temperatura', 1017.0000, 'ºC'),
	(14902, 109, '2015-01-15 01:07:54.000000', 'temperatura', 860.0000, 'ºC'),
	(14903, 109, '2015-01-15 01:07:55.000000', 'temperatura', 50.0000, 'ºC'),
	(14904, 109, '2015-01-15 01:07:56.000000', 'temperatura', 72.0000, 'ºC'),
	(14905, 109, '2015-01-15 01:07:57.000000', 'temperatura', 212.0000, 'ºC'),
	(14906, 109, '2015-01-15 01:07:58.000000', 'temperatura', 841.0000, 'ºC'),
	(14907, 109, '2015-01-15 01:07:59.000000', 'temperatura', 1170.0000, 'ºC'),
	(14908, 109, '2015-01-15 01:08:00.000000', 'temperatura', 928.0000, 'ºC'),
	(14909, 109, '2015-01-15 01:08:01.000000', 'temperatura', 1130.0000, 'ºC'),
	(14910, 109, '2015-01-15 01:08:02.000000', 'temperatura', 469.0000, 'ºC'),
	(14911, 109, '2015-01-15 01:08:03.000000', 'temperatura', 153.0000, 'ºC'),
	(14912, 109, '2015-01-15 01:08:04.000000', 'temperatura', 558.0000, 'ºC'),
	(14913, 109, '2015-01-15 01:08:05.000000', 'temperatura', 1133.0000, 'ºC'),
	(14914, 109, '2015-01-15 01:08:06.000000', 'temperatura', 390.0000, 'ºC'),
	(14915, 109, '2015-01-15 01:08:07.000000', 'temperatura', 952.0000, 'ºC'),
	(14916, 109, '2015-01-15 01:08:08.000000', 'temperatura', 1189.0000, 'ºC'),
	(14917, 109, '2015-01-15 01:08:09.000000', 'temperatura', 691.0000, 'ºC'),
	(14918, 109, '2015-01-15 01:08:10.000000', 'temperatura', 1089.0000, 'ºC'),
	(14919, 109, '2015-01-15 01:08:11.000000', 'temperatura', 971.0000, 'ºC'),
	(14920, 109, '2015-01-15 01:08:12.000000', 'temperatura', 388.0000, 'ºC'),
	(14921, 109, '2015-01-15 01:08:13.000000', 'temperatura', 227.0000, 'ºC'),
	(14922, 109, '2015-01-15 01:08:14.000000', 'temperatura', 1171.0000, 'ºC'),
	(14923, 109, '2015-01-15 01:08:15.000000', 'temperatura', 374.0000, 'ºC'),
	(14924, 109, '2015-01-15 01:08:16.000000', 'temperatura', 757.0000, 'ºC'),
	(14925, 109, '2015-01-15 01:08:17.000000', 'temperatura', 265.0000, 'ºC'),
	(14926, 109, '2015-01-15 01:08:18.000000', 'temperatura', 252.0000, 'ºC'),
	(14927, 109, '2015-01-15 01:08:19.000000', 'temperatura', 468.0000, 'ºC'),
	(14928, 109, '2015-01-15 01:08:20.000000', 'temperatura', 382.0000, 'ºC'),
	(14929, 109, '2015-01-15 01:08:21.000000', 'temperatura', 510.0000, 'ºC'),
	(14930, 109, '2015-01-15 01:08:22.000000', 'temperatura', 201.0000, 'ºC'),
	(14931, 109, '2015-01-15 01:08:23.000000', 'temperatura', 679.0000, 'ºC'),
	(14932, 109, '2015-01-15 01:08:24.000000', 'temperatura', 389.0000, 'ºC'),
	(14933, 109, '2015-01-15 01:08:25.000000', 'temperatura', 1111.0000, 'ºC'),
	(14934, 109, '2015-01-15 01:08:26.000000', 'temperatura', 789.0000, 'ºC'),
	(14935, 109, '2015-01-15 01:08:27.000000', 'temperatura', 612.0000, 'ºC'),
	(14936, 109, '2015-01-15 01:08:28.000000', 'temperatura', 694.0000, 'ºC'),
	(14937, 109, '2015-01-15 01:08:29.000000', 'temperatura', 436.0000, 'ºC'),
	(14938, 109, '2015-01-15 01:08:30.000000', 'temperatura', 97.0000, 'ºC'),
	(14939, 109, '2015-01-15 01:08:31.000000', 'temperatura', 376.0000, 'ºC'),
	(14940, 109, '2015-01-15 01:08:32.000000', 'temperatura', 392.0000, 'ºC'),
	(14941, 109, '2015-01-15 01:08:33.000000', 'temperatura', 830.0000, 'ºC'),
	(14942, 109, '2015-01-15 01:08:34.000000', 'temperatura', 576.0000, 'ºC'),
	(14943, 109, '2015-01-15 01:08:35.000000', 'temperatura', 392.0000, 'ºC'),
	(14944, 109, '2015-01-15 01:08:36.000000', 'temperatura', 229.0000, 'ºC'),
	(14945, 109, '2015-01-15 01:08:37.000000', 'temperatura', 1173.0000, 'ºC'),
	(14946, 109, '2015-01-15 01:08:38.000000', 'temperatura', 378.0000, 'ºC'),
	(14947, 109, '2015-01-15 01:08:39.000000', 'temperatura', 769.0000, 'ºC'),
	(14948, 109, '2015-01-15 01:08:40.000000', 'temperatura', 313.0000, 'ºC'),
	(14949, 109, '2015-01-15 01:08:41.000000', 'temperatura', 457.0000, 'ºC'),
	(14950, 109, '2015-01-15 01:08:42.000000', 'temperatura', 149.0000, 'ºC'),
	(14951, 109, '2015-01-15 01:08:43.000000', 'temperatura', 573.0000, 'ºC'),
	(14952, 109, '2015-01-15 01:08:44.000000', 'temperatura', 21.0000, 'ºC'),
	(14953, 109, '2015-01-15 01:08:45.000000', 'temperatura', 784.0000, 'ºC'),
	(14954, 109, '2015-01-15 01:08:46.000000', 'temperatura', 257.0000, 'ºC'),
	(14955, 109, '2015-01-15 01:08:47.000000', 'temperatura', 136.0000, 'ºC'),
	(14956, 109, '2015-01-15 01:08:48.000000', 'temperatura', 1107.0000, 'ºC'),
	(14957, 109, '2015-01-15 01:08:49.000000', 'temperatura', 329.0000, 'ºC'),
	(14958, 109, '2015-01-15 01:08:50.000000', 'temperatura', 724.0000, 'ºC'),
	(14959, 109, '2015-01-15 01:08:51.000000', 'temperatura', 235.0000, 'ºC'),
	(14960, 109, '2015-01-15 01:08:52.000000', 'temperatura', 203.0000, 'ºC'),
	(14961, 109, '2015-01-15 01:08:53.000000', 'temperatura', 309.0000, 'ºC'),
	(14962, 109, '2015-01-15 01:08:54.000000', 'temperatura', 936.0000, 'ºC'),
	(14963, 109, '2015-01-15 01:08:55.000000', 'temperatura', 154.0000, 'ºC'),
	(14964, 109, '2015-01-15 01:08:56.000000', 'temperatura', 363.0000, 'ºC'),
	(14965, 109, '2015-01-15 01:08:57.000000', 'temperatura', 154.0000, 'ºC'),
	(14966, 109, '2015-01-15 01:08:58.000000', 'temperatura', 882.0000, 'ºC'),
	(14967, 109, '2015-01-15 01:08:59.000000', 'temperatura', 350.0000, 'ºC'),
	(14968, 109, '2015-01-15 01:09:00.000000', 'temperatura', 303.0000, 'ºC'),
	(14969, 109, '2015-01-15 01:09:01.000000', 'temperatura', 465.0000, 'ºC'),
	(14970, 109, '2015-01-15 01:09:02.000000', 'temperatura', 218.0000, 'ºC'),
	(14971, 109, '2015-01-15 01:09:03.000000', 'temperatura', 893.0000, 'ºC'),
	(14972, 109, '2015-01-15 01:09:04.000000', 'temperatura', 212.0000, 'ºC'),
	(14973, 109, '2015-01-15 01:09:05.000000', 'temperatura', 783.0000, 'ºC'),
	(14974, 109, '2015-01-15 01:09:06.000000', 'temperatura', 879.0000, 'ºC'),
	(14975, 109, '2015-01-15 01:09:07.000000', 'temperatura', 848.0000, 'ºC'),
	(14976, 109, '2015-01-15 01:09:08.000000', 'temperatura', 401.0000, 'ºC'),
	(14977, 109, '2015-01-15 01:09:09.000000', 'temperatura', 662.0000, 'ºC'),
	(14978, 109, '2015-01-15 01:09:10.000000', 'temperatura', 906.0000, 'ºC'),
	(14979, 109, '2015-01-15 01:09:11.000000', 'temperatura', 146.0000, 'ºC'),
	(14980, 109, '2015-01-15 01:09:12.000000', 'temperatura', 412.0000, 'ºC'),
	(14981, 109, '2015-01-15 01:09:13.000000', 'temperatura', 422.0000, 'ºC'),
	(14982, 109, '2015-01-15 01:09:14.000000', 'temperatura', 875.0000, 'ºC'),
	(14983, 109, '2015-01-15 01:09:15.000000', 'temperatura', 711.0000, 'ºC'),
	(14984, 109, '2015-01-15 01:09:16.000000', 'temperatura', 927.0000, 'ºC'),
	(14985, 109, '2015-01-15 01:09:17.000000', 'temperatura', 106.0000, 'ºC'),
	(14986, 109, '2015-01-15 01:09:18.000000', 'temperatura', 149.0000, 'ºC'),
	(14987, 109, '2015-01-15 01:09:19.000000', 'temperatura', 428.0000, 'ºC'),
	(14988, 109, '2015-01-15 01:09:20.000000', 'temperatura', 494.0000, 'ºC'),
	(14989, 109, '2015-01-15 01:09:21.000000', 'temperatura', 1185.0000, 'ºC'),
	(14990, 109, '2015-01-15 01:09:22.000000', 'temperatura', 843.0000, 'ºC'),
	(14991, 109, '2015-01-15 01:09:23.000000', 'temperatura', 663.0000, 'ºC'),
	(14992, 109, '2015-01-15 01:09:24.000000', 'temperatura', 786.0000, 'ºC'),
	(14993, 109, '2015-01-15 01:09:25.000000', 'temperatura', 743.0000, 'ºC'),
	(14994, 109, '2015-01-15 01:09:26.000000', 'temperatura', 154.0000, 'ºC'),
	(14995, 109, '2015-01-15 01:09:27.000000', 'temperatura', 944.0000, 'ºC'),
	(14996, 109, '2015-01-15 01:09:28.000000', 'temperatura', 659.0000, 'ºC'),
	(14997, 109, '2015-01-15 01:09:29.000000', 'temperatura', 462.0000, 'ºC'),
	(14998, 109, '2015-01-15 01:09:30.000000', 'temperatura', 332.0000, 'ºC'),
	(14999, 109, '2015-01-15 01:09:31.000000', 'temperatura', 277.0000, 'ºC'),
	(15000, 109, '2015-01-15 01:09:32.000000', 'temperatura', 390.0000, 'ºC'),
	(15001, 109, '2015-01-15 01:09:33.000000', 'temperatura', 1119.0000, 'ºC'),
	(15002, 109, '2015-01-15 01:09:34.000000', 'temperatura', 823.0000, 'ºC'),
	(15003, 109, '2015-01-15 01:09:35.000000', 'temperatura', 762.0000, 'ºC'),
	(15004, 109, '2015-01-15 01:09:36.000000', 'temperatura', 140.0000, 'ºC'),
	(15005, 109, '2015-01-15 01:09:37.000000', 'temperatura', 814.0000, 'ºC'),
	(15006, 109, '2015-01-15 01:09:38.000000', 'temperatura', 51.0000, 'ºC'),
	(15007, 109, '2015-01-15 01:09:39.000000', 'temperatura', 214.0000, 'ºC'),
	(15008, 109, '2015-01-15 01:09:40.000000', 'temperatura', 915.0000, 'ºC'),
	(15009, 109, '2015-01-15 01:09:41.000000', 'temperatura', 336.0000, 'ºC'),
	(15010, 109, '2015-01-15 01:09:42.000000', 'temperatura', 133.0000, 'ºC'),
	(15011, 109, '2015-01-15 01:09:43.000000', 'temperatura', 861.0000, 'ºC'),
	(15012, 109, '2015-01-15 01:09:44.000000', 'temperatura', 304.0000, 'ºC'),
	(15013, 109, '2015-01-15 01:09:45.000000', 'temperatura', 136.0000, 'ºC'),
	(15014, 109, '2015-01-15 01:09:46.000000', 'temperatura', 971.0000, 'ºC'),
	(15015, 109, '2015-01-15 01:09:47.000000', 'temperatura', 846.0000, 'ºC'),
	(15016, 109, '2015-01-15 01:09:48.000000', 'temperatura', 119.0000, 'ºC'),
	(15017, 109, '2015-01-15 01:09:49.000000', 'temperatura', 458.0000, 'ºC'),
	(15018, 109, '2015-01-15 01:09:50.000000', 'temperatura', 733.0000, 'ºC'),
	(15019, 109, '2015-01-15 01:09:51.000000', 'temperatura', 1093.0000, 'ºC'),
	(15020, 109, '2015-01-15 01:09:52.000000', 'temperatura', 867.0000, 'ºC'),
	(15021, 109, '2015-01-15 01:09:53.000000', 'temperatura', 1056.0000, 'ºC'),
	(15022, 109, '2015-01-15 01:09:54.000000', 'temperatura', 277.0000, 'ºC'),
	(15023, 109, '2015-01-15 01:09:55.000000', 'temperatura', 619.0000, 'ºC'),
	(15024, 109, '2015-01-15 01:09:56.000000', 'temperatura', 1065.0000, 'ºC'),
	(15025, 109, '2015-01-15 01:09:57.000000', 'temperatura', 1067.0000, 'ºC'),
	(15026, 109, '2015-01-15 01:09:58.000000', 'temperatura', 940.0000, 'ºC'),
	(15027, 109, '2015-01-15 01:09:59.000000', 'temperatura', 302.0000, 'ºC'),
	(15028, 109, '2015-01-15 01:10:00.000000', 'temperatura', 1090.0000, 'ºC'),
	(15029, 109, '2015-01-15 01:10:01.000000', 'temperatura', 942.0000, 'ºC'),
	(15030, 109, '2015-01-15 01:10:02.000000', 'temperatura', 242.0000, 'ºC'),
	(15031, 109, '2015-01-15 01:10:03.000000', 'temperatura', 787.0000, 'ºC'),
	(15032, 109, '2015-01-15 01:10:04.000000', 'temperatura', 806.0000, 'ºC'),
	(15033, 109, '2015-01-15 01:10:05.000000', 'temperatura', 470.0000, 'ºC'),
	(15034, 109, '2015-01-15 01:10:06.000000', 'temperatura', 1131.0000, 'ºC'),
	(15035, 109, '2015-01-15 01:10:07.000000', 'temperatura', 648.0000, 'ºC'),
	(15036, 109, '2015-01-15 01:10:08.000000', 'temperatura', 1046.0000, 'ºC'),
	(15037, 109, '2015-01-15 01:10:09.000000', 'temperatura', 888.0000, 'ºC'),
	(15038, 109, '2015-01-15 01:10:10.000000', 'temperatura', 101.0000, 'ºC'),
	(15039, 109, '2015-01-15 01:10:11.000000', 'temperatura', 243.0000, 'ºC'),
	(15040, 109, '2015-01-15 01:10:12.000000', 'temperatura', 910.0000, 'ºC'),
	(15041, 109, '2015-01-15 01:10:13.000000', 'temperatura', 223.0000, 'ºC'),
	(15042, 109, '2015-01-15 01:10:14.000000', 'temperatura', 787.0000, 'ºC'),
	(15043, 109, '2015-01-15 01:10:15.000000', 'temperatura', 867.0000, 'ºC'),
	(15044, 109, '2015-01-15 01:10:16.000000', 'temperatura', 774.0000, 'ºC'),
	(15045, 109, '2015-01-15 01:10:17.000000', 'temperatura', 69.0000, 'ºC'),
	(15046, 109, '2015-01-15 01:10:18.000000', 'temperatura', 423.0000, 'ºC'),
	(15047, 109, '2015-01-15 01:10:19.000000', 'temperatura', 710.0000, 'ºC'),
	(15048, 109, '2015-01-15 01:10:20.000000', 'temperatura', 1080.0000, 'ºC'),
	(15049, 109, '2015-01-15 01:10:21.000000', 'temperatura', 871.0000, 'ºC'),
	(15050, 109, '2015-01-15 01:10:22.000000', 'temperatura', 1116.0000, 'ºC'),
	(15051, 109, '2015-01-15 01:10:23.000000', 'temperatura', 569.0000, 'ºC'),
	(15052, 109, '2015-01-15 01:10:24.000000', 'temperatura', 696.0000, 'ºC'),
	(15053, 109, '2015-01-15 01:10:25.000000', 'temperatura', 573.0000, 'ºC'),
	(15054, 109, '2015-01-15 01:10:26.000000', 'temperatura', 780.0000, 'ºC'),
	(15055, 109, '2015-01-15 01:10:27.000000', 'temperatura', 980.0000, 'ºC'),
	(15056, 109, '2015-01-15 01:10:28.000000', 'temperatura', 159.0000, 'ºC'),
	(15057, 109, '2015-01-15 01:10:29.000000', 'temperatura', 255.0000, 'ºC'),
	(15058, 109, '2015-01-15 01:10:30.000000', 'temperatura', 799.0000, 'ºC'),
	(15059, 109, '2015-01-15 01:10:31.000000', 'temperatura', 831.0000, 'ºC'),
	(15060, 109, '2015-01-15 01:10:32.000000', 'temperatura', 557.0000, 'ºC'),
	(15061, 109, '2015-01-15 01:10:33.000000', 'temperatura', 295.0000, 'ºC'),
	(15062, 109, '2015-01-15 01:10:34.000000', 'temperatura', 1003.0000, 'ºC'),
	(15063, 109, '2015-01-15 01:10:35.000000', 'temperatura', 533.0000, 'ºC'),
	(15064, 109, '2015-01-15 01:10:36.000000', 'temperatura', 853.0000, 'ºC'),
	(15065, 109, '2015-01-15 01:10:37.000000', 'temperatura', 268.0000, 'ºC'),
	(15066, 109, '2015-01-15 01:10:38.000000', 'temperatura', 1181.0000, 'ºC'),
	(15067, 109, '2015-01-15 01:10:39.000000', 'temperatura', 304.0000, 'ºC'),
	(15068, 109, '2015-01-15 01:10:40.000000', 'temperatura', 375.0000, 'ºC'),
	(15069, 109, '2015-01-15 01:10:41.000000', 'temperatura', 962.0000, 'ºC'),
	(15070, 109, '2015-01-15 01:10:42.000000', 'temperatura', 88.0000, 'ºC'),
	(15071, 109, '2015-01-15 01:10:43.000000', 'temperatura', 1152.0000, 'ºC'),
	(15072, 109, '2015-01-15 01:10:44.000000', 'temperatura', 697.0000, 'ºC'),
	(15073, 109, '2015-01-15 01:10:45.000000', 'temperatura', 29.0000, 'ºC'),
	(15074, 109, '2015-01-15 01:10:46.000000', 'temperatura', 456.0000, 'ºC'),
	(15075, 109, '2015-01-15 01:10:47.000000', 'temperatura', 994.0000, 'ºC'),
	(15076, 109, '2015-01-15 01:10:48.000000', 'temperatura', 2.0000, 'ºC'),
	(15077, 109, '2015-01-15 01:10:49.000000', 'temperatura', 628.0000, 'ºC'),
	(15078, 109, '2015-01-15 01:10:50.000000', 'temperatura', 735.0000, 'ºC'),
	(15079, 109, '2015-01-15 01:10:51.000000', 'temperatura', 591.0000, 'ºC'),
	(15080, 109, '2015-01-15 01:10:52.000000', 'temperatura', 750.0000, 'ºC'),
	(15081, 109, '2015-01-15 01:10:53.000000', 'temperatura', 776.0000, 'ºC'),
	(15082, 109, '2015-01-15 01:10:54.000000', 'temperatura', 434.0000, 'ºC'),
	(15083, 109, '2015-01-15 01:10:55.000000', 'temperatura', 1040.0000, 'ºC'),
	(15084, 109, '2015-01-15 01:10:56.000000', 'temperatura', 301.0000, 'ºC'),
	(15085, 109, '2015-01-15 01:10:57.000000', 'temperatura', 786.0000, 'ºC'),
	(15086, 109, '2015-01-15 01:10:58.000000', 'temperatura', 626.0000, 'ºC'),
	(15087, 109, '2015-01-15 01:10:59.000000', 'temperatura', 771.0000, 'ºC'),
	(15088, 109, '2015-01-15 01:11:00.000000', 'temperatura', 778.0000, 'ºC'),
	(15089, 109, '2015-01-15 01:11:01.000000', 'temperatura', 379.0000, 'ºC'),
	(15090, 109, '2015-01-15 01:11:02.000000', 'temperatura', 763.0000, 'ºC'),
	(15091, 109, '2015-01-15 01:11:03.000000', 'temperatura', 277.0000, 'ºC'),
	(15092, 109, '2015-01-15 01:11:04.000000', 'temperatura', 295.0000, 'ºC'),
	(15093, 109, '2015-01-15 01:11:05.000000', 'temperatura', 644.0000, 'ºC'),
	(15094, 109, '2015-01-15 01:11:06.000000', 'temperatura', 1139.0000, 'ºC'),
	(15095, 109, '2015-01-15 01:11:07.000000', 'temperatura', 160.0000, 'ºC'),
	(15096, 109, '2015-01-15 01:11:08.000000', 'temperatura', 985.0000, 'ºC'),
	(15097, 109, '2015-01-15 01:11:09.000000', 'temperatura', 845.0000, 'ºC'),
	(15098, 109, '2015-01-15 01:11:10.000000', 'temperatura', 73.0000, 'ºC'),
	(15099, 109, '2015-01-15 01:11:11.000000', 'temperatura', 228.0000, 'ºC'),
	(15100, 109, '2015-01-15 01:11:12.000000', 'temperatura', 922.0000, 'ºC'),
	(15101, 109, '2015-01-15 01:11:13.000000', 'temperatura', 326.0000, 'ºC'),
	(15102, 109, '2015-01-15 01:11:14.000000', 'temperatura', 64.0000, 'ºC'),
	(15103, 109, '2015-01-15 01:11:15.000000', 'temperatura', 542.0000, 'ºC'),
	(15104, 109, '2015-01-15 01:11:16.000000', 'temperatura', 117.0000, 'ºC'),
	(15105, 109, '2015-01-15 01:11:17.000000', 'temperatura', 162.0000, 'ºC'),
	(15106, 109, '2015-01-15 01:11:18.000000', 'temperatura', 459.0000, 'ºC'),
	(15107, 109, '2015-01-15 01:11:19.000000', 'temperatura', 607.0000, 'ºC'),
	(15108, 109, '2015-01-15 01:11:20.000000', 'temperatura', 462.0000, 'ºC'),
	(15109, 109, '2015-01-15 01:11:21.000000', 'temperatura', 489.0000, 'ºC'),
	(15110, 109, '2015-01-15 01:11:22.000000', 'temperatura', 1058.0000, 'ºC'),
	(15111, 109, '2015-01-15 01:11:23.000000', 'temperatura', 224.0000, 'ºC'),
	(15112, 109, '2015-01-15 01:11:24.000000', 'temperatura', 347.0000, 'ºC'),
	(15113, 109, '2015-01-15 01:11:25.000000', 'temperatura', 1065.0000, 'ºC'),
	(15114, 109, '2015-01-15 01:11:26.000000', 'temperatura', 684.0000, 'ºC'),
	(15115, 109, '2015-01-15 01:11:27.000000', 'temperatura', 226.0000, 'ºC'),
	(15116, 109, '2015-01-15 01:11:28.000000', 'temperatura', 277.0000, 'ºC'),
	(15117, 109, '2015-01-15 01:11:29.000000', 'temperatura', 709.0000, 'ºC'),
	(15118, 109, '2015-01-15 01:11:30.000000', 'temperatura', 313.0000, 'ºC'),
	(15119, 109, '2015-01-15 01:11:31.000000', 'temperatura', 641.0000, 'ºC'),
	(15120, 109, '2015-01-15 01:11:32.000000', 'temperatura', 1064.0000, 'ºC'),
	(15121, 109, '2015-01-15 01:11:33.000000', 'temperatura', 996.0000, 'ºC'),
	(15122, 109, '2015-01-15 01:11:34.000000', 'temperatura', 591.0000, 'ºC'),
	(15123, 109, '2015-01-15 01:11:35.000000', 'temperatura', 1166.0000, 'ºC'),
	(15124, 109, '2015-01-15 01:11:36.000000', 'temperatura', 459.0000, 'ºC'),
	(15125, 109, '2015-01-15 01:11:37.000000', 'temperatura', 1196.0000, 'ºC'),
	(15126, 109, '2015-01-15 01:11:38.000000', 'temperatura', 1006.0000, 'ºC'),
	(15127, 109, '2015-01-15 01:11:39.000000', 'temperatura', 241.0000, 'ºC'),
	(15128, 109, '2015-01-15 01:11:40.000000', 'temperatura', 587.0000, 'ºC'),
	(15129, 109, '2015-01-15 01:11:41.000000', 'temperatura', 1014.0000, 'ºC'),
	(15130, 109, '2015-01-15 01:11:42.000000', 'temperatura', 907.0000, 'ºC'),
	(15131, 109, '2015-01-15 01:11:43.000000', 'temperatura', 294.0000, 'ºC'),
	(15132, 109, '2015-01-15 01:11:44.000000', 'temperatura', 1152.0000, 'ºC'),
	(15133, 109, '2015-01-15 01:11:45.000000', 'temperatura', 75.0000, 'ºC'),
	(15134, 109, '2015-01-15 01:11:46.000000', 'temperatura', 521.0000, 'ºC'),
	(15135, 109, '2015-01-15 01:11:47.000000', 'temperatura', 1181.0000, 'ºC'),
	(15136, 109, '2015-01-15 01:11:48.000000', 'temperatura', 743.0000, 'ºC'),
	(15137, 109, '2015-01-15 01:11:49.000000', 'temperatura', 172.0000, 'ºC'),
	(15138, 109, '2015-01-15 01:11:50.000000', 'temperatura', 1030.0000, 'ºC'),
	(15139, 109, '2015-01-15 01:11:51.000000', 'temperatura', 1035.0000, 'ºC'),
	(15140, 109, '2015-01-15 01:11:52.000000', 'temperatura', 888.0000, 'ºC'),
	(15141, 109, '2015-01-15 01:11:53.000000', 'temperatura', 133.0000, 'ºC'),
	(15142, 109, '2015-01-15 01:11:54.000000', 'temperatura', 401.0000, 'ºC'),
	(15143, 109, '2015-01-15 01:11:55.000000', 'temperatura', 406.0000, 'ºC'),
	(15144, 109, '2015-01-15 01:11:56.000000', 'temperatura', 828.0000, 'ºC'),
	(15145, 109, '2015-01-15 01:11:57.000000', 'temperatura', 522.0000, 'ºC'),
	(15146, 109, '2015-01-15 01:11:58.000000', 'temperatura', 128.0000, 'ºC'),
	(15147, 109, '2015-01-15 01:11:59.000000', 'temperatura', 276.0000, 'ºC'),
	(15148, 109, '2015-01-15 01:12:00.000000', 'temperatura', 995.0000, 'ºC'),
	(15149, 109, '2015-01-15 01:12:01.000000', 'temperatura', 546.0000, 'ºC'),
	(15150, 109, '2015-01-15 01:12:02.000000', 'temperatura', 946.0000, 'ºC'),
	(15151, 109, '2015-01-15 01:12:03.000000', 'temperatura', 695.0000, 'ºC'),
	(15152, 109, '2015-01-15 01:12:04.000000', 'temperatura', 636.0000, 'ºC'),
	(15153, 109, '2015-01-15 01:12:05.000000', 'temperatura', 1095.0000, 'ºC'),
	(15154, 109, '2015-01-15 01:12:06.000000', 'temperatura', 1169.0000, 'ºC'),
	(15155, 109, '2015-01-15 01:12:07.000000', 'temperatura', 161.0000, 'ºC'),
	(15156, 109, '2015-01-15 01:12:08.000000', 'temperatura', 899.0000, 'ºC'),
	(15157, 109, '2015-01-15 01:12:09.000000', 'temperatura', 411.0000, 'ºC'),
	(15158, 109, '2015-01-15 01:12:10.000000', 'temperatura', 557.0000, 'ºC'),
	(15159, 109, '2015-01-15 01:12:11.000000', 'temperatura', 353.0000, 'ºC'),
	(15160, 109, '2015-01-15 01:12:12.000000', 'temperatura', 97.0000, 'ºC'),
	(15161, 109, '2015-01-15 01:12:13.000000', 'temperatura', 624.0000, 'ºC'),
	(15162, 109, '2015-01-15 01:12:14.000000', 'temperatura', 428.0000, 'ºC'),
	(15163, 109, '2015-01-15 01:12:15.000000', 'temperatura', 272.0000, 'ºC'),
	(15164, 109, '2015-01-15 01:12:16.000000', 'temperatura', 74.0000, 'ºC'),
	(15165, 109, '2015-01-15 01:12:17.000000', 'temperatura', 755.0000, 'ºC'),
	(15166, 109, '2015-01-15 01:12:18.000000', 'temperatura', 1156.0000, 'ºC'),
	(15167, 109, '2015-01-15 01:12:19.000000', 'temperatura', 1113.0000, 'ºC'),
	(15168, 109, '2015-01-15 01:12:20.000000', 'temperatura', 899.0000, 'ºC'),
	(15169, 109, '2015-01-15 01:12:21.000000', 'temperatura', 1156.0000, 'ºC'),
	(15170, 109, '2015-01-15 01:12:22.000000', 'temperatura', 685.0000, 'ºC'),
	(15171, 109, '2015-01-15 01:12:23.000000', 'temperatura', 1157.0000, 'ºC'),
	(15172, 109, '2015-01-15 01:12:24.000000', 'temperatura', 128.0000, 'ºC'),
	(15173, 109, '2015-01-15 01:12:25.000000', 'temperatura', 771.0000, 'ºC'),
	(15174, 109, '2015-01-15 01:12:26.000000', 'temperatura', 1073.0000, 'ºC'),
	(15175, 109, '2015-01-15 01:12:27.000000', 'temperatura', 653.0000, 'ºC'),
	(15176, 109, '2015-01-15 01:12:28.000000', 'temperatura', 43.0000, 'ºC'),
	(15177, 109, '2015-01-15 01:12:29.000000', 'temperatura', 660.0000, 'ºC'),
	(15178, 109, '2015-01-15 01:12:30.000000', 'temperatura', 769.0000, 'ºC'),
	(15179, 109, '2015-01-15 01:12:31.000000', 'temperatura', 665.0000, 'ºC'),
	(15180, 109, '2015-01-15 01:12:32.000000', 'temperatura', 1018.0000, 'ºC'),
	(15181, 109, '2015-01-15 01:12:33.000000', 'temperatura', 697.0000, 'ºC'),
	(15182, 109, '2015-01-15 01:12:34.000000', 'temperatura', 433.0000, 'ºC'),
	(15183, 109, '2015-01-15 01:12:35.000000', 'temperatura', 74.0000, 'ºC'),
	(15184, 109, '2015-01-15 01:12:36.000000', 'temperatura', 273.0000, 'ºC'),
	(15185, 109, '2015-01-15 01:12:37.000000', 'temperatura', 1141.0000, 'ºC'),
	(15186, 109, '2015-01-15 01:12:38.000000', 'temperatura', 87.0000, 'ºC'),
	(15187, 109, '2015-01-15 01:12:39.000000', 'temperatura', 612.0000, 'ºC'),
	(15188, 109, '2015-01-15 01:12:40.000000', 'temperatura', 399.0000, 'ºC'),
	(15189, 109, '2015-01-15 01:12:41.000000', 'temperatura', 161.0000, 'ºC'),
	(15190, 109, '2015-01-15 01:12:42.000000', 'temperatura', 806.0000, 'ºC'),
	(15191, 109, '2015-01-15 01:12:43.000000', 'temperatura', 1149.0000, 'ºC'),
	(15192, 109, '2015-01-15 01:12:44.000000', 'temperatura', 927.0000, 'ºC'),
	(15193, 109, '2015-01-15 01:12:45.000000', 'temperatura', 1189.0000, 'ºC'),
	(15194, 109, '2015-01-15 01:12:46.000000', 'temperatura', 763.0000, 'ºC'),
	(15195, 109, '2015-01-15 01:12:47.000000', 'temperatura', 251.0000, 'ºC'),
	(15196, 109, '2015-01-15 01:12:48.000000', 'temperatura', 164.0000, 'ºC'),
	(15197, 109, '2015-01-15 01:12:49.000000', 'temperatura', 66.0000, 'ºC'),
	(15198, 109, '2015-01-15 01:12:50.000000', 'temperatura', 1042.0000, 'ºC'),
	(15199, 109, '2015-01-15 01:12:51.000000', 'temperatura', 211.0000, 'ºC'),
	(15200, 109, '2015-01-15 01:12:52.000000', 'temperatura', 329.0000, 'ºC'),
	(15201, 109, '2015-01-15 01:12:53.000000', 'temperatura', 1015.0000, 'ºC'),
	(15202, 109, '2015-01-15 01:12:54.000000', 'temperatura', 486.0000, 'ºC'),
	(15203, 109, '2015-01-15 01:12:55.000000', 'temperatura', 586.0000, 'ºC'),
	(15204, 109, '2015-01-15 01:12:56.000000', 'temperatura', 271.0000, 'ºC'),
	(15205, 109, '2015-01-15 01:12:57.000000', 'temperatura', 797.0000, 'ºC'),
	(15206, 109, '2015-01-15 01:12:58.000000', 'temperatura', 775.0000, 'ºC'),
	(15207, 109, '2015-01-15 01:12:59.000000', 'temperatura', 283.0000, 'ºC'),
	(15208, 109, '2015-01-15 01:13:00.000000', 'temperatura', 292.0000, 'ºC'),
	(15209, 109, '2015-01-15 01:13:01.000000', 'temperatura', 611.0000, 'ºC'),
	(15210, 109, '2015-01-15 01:13:02.000000', 'temperatura', 980.0000, 'ºC'),
	(15211, 109, '2015-01-15 01:13:03.000000', 'temperatura', 666.0000, 'ºC'),
	(15212, 109, '2015-01-15 01:13:04.000000', 'temperatura', 390.0000, 'ºC'),
	(15213, 109, '2015-01-15 01:13:05.000000', 'temperatura', 1154.0000, 'ºC'),
	(15214, 109, '2015-01-15 01:13:06.000000', 'temperatura', 1002.0000, 'ºC'),
	(15215, 109, '2015-01-15 01:13:07.000000', 'temperatura', 345.0000, 'ºC'),
	(15216, 109, '2015-01-15 01:13:08.000000', 'temperatura', 1123.0000, 'ºC'),
	(15217, 109, '2015-01-15 01:13:09.000000', 'temperatura', 978.0000, 'ºC'),
	(15218, 109, '2015-01-15 01:13:10.000000', 'temperatura', 323.0000, 'ºC'),
	(15219, 109, '2015-01-15 01:13:11.000000', 'temperatura', 1080.0000, 'ºC'),
	(15220, 109, '2015-01-15 01:13:12.000000', 'temperatura', 832.0000, 'ºC'),
	(15221, 109, '2015-01-15 01:13:13.000000', 'temperatura', 920.0000, 'ºC'),
	(15222, 109, '2015-01-15 01:13:14.000000', 'temperatura', 906.0000, 'ºC'),
	(15223, 109, '2015-01-15 01:13:15.000000', 'temperatura', 569.0000, 'ºC'),
	(15224, 109, '2015-01-15 01:13:16.000000', 'temperatura', 127.0000, 'ºC'),
	(15225, 109, '2015-01-15 01:13:17.000000', 'temperatura', 128.0000, 'ºC'),
	(15226, 109, '2015-01-15 01:13:18.000000', 'temperatura', 262.0000, 'ºC'),
	(15227, 109, '2015-01-15 01:13:19.000000', 'temperatura', 926.0000, 'ºC'),
	(15228, 109, '2015-01-15 01:13:20.000000', 'temperatura', 245.0000, 'ºC'),
	(15229, 109, '2015-01-15 01:13:21.000000', 'temperatura', 845.0000, 'ºC'),
	(15230, 109, '2015-01-15 01:13:22.000000', 'temperatura', 1091.0000, 'ºC'),
	(15231, 109, '2015-01-15 01:13:23.000000', 'temperatura', 521.0000, 'ºC'),
	(15232, 109, '2015-01-15 01:13:24.000000', 'temperatura', 533.0000, 'ºC'),
	(15233, 109, '2015-01-15 01:13:25.000000', 'temperatura', 1100.0000, 'ºC'),
	(15234, 109, '2015-01-15 01:13:26.000000', 'temperatura', 304.0000, 'ºC'),
	(15235, 109, '2015-01-15 01:13:27.000000', 'temperatura', 618.0000, 'ºC'),
	(15236, 109, '2015-01-15 01:13:28.000000', 'temperatura', 981.0000, 'ºC'),
	(15237, 109, '2015-01-15 01:13:29.000000', 'temperatura', 652.0000, 'ºC'),
	(15238, 109, '2015-01-15 01:13:30.000000', 'temperatura', 317.0000, 'ºC'),
	(15239, 109, '2015-01-15 01:13:31.000000', 'temperatura', 829.0000, 'ºC'),
	(15240, 109, '2015-01-15 01:13:32.000000', 'temperatura', 796.0000, 'ºC'),
	(15241, 109, '2015-01-15 01:13:33.000000', 'temperatura', 294.0000, 'ºC'),
	(15242, 109, '2015-01-15 01:13:34.000000', 'temperatura', 280.0000, 'ºC'),
	(15243, 109, '2015-01-15 01:13:35.000000', 'temperatura', 520.0000, 'ºC'),
	(15244, 109, '2015-01-15 01:13:36.000000', 'temperatura', 561.0000, 'ºC'),
	(15245, 109, '2015-01-15 01:13:37.000000', 'temperatura', 43.0000, 'ºC'),
	(15246, 109, '2015-01-15 01:13:38.000000', 'temperatura', 933.0000, 'ºC'),
	(15247, 109, '2015-01-15 01:13:39.000000', 'temperatura', 939.0000, 'ºC'),
	(15248, 109, '2015-01-15 01:13:40.000000', 'temperatura', 694.0000, 'ºC'),
	(15249, 109, '2015-01-15 01:13:41.000000', 'temperatura', 654.0000, 'ºC'),
	(15250, 109, '2015-01-15 01:13:42.000000', 'temperatura', 1189.0000, 'ºC'),
	(15251, 109, '2015-01-15 01:13:43.000000', 'temperatura', 382.0000, 'ºC'),
	(15252, 109, '2015-01-15 01:13:44.000000', 'temperatura', 743.0000, 'ºC'),
	(15253, 109, '2015-01-15 01:13:45.000000', 'temperatura', 170.0000, 'ºC'),
	(15254, 109, '2015-01-15 01:13:46.000000', 'temperatura', 1021.0000, 'ºC'),
	(15255, 109, '2015-01-15 01:13:47.000000', 'temperatura', 996.0000, 'ºC'),
	(15256, 109, '2015-01-15 01:13:48.000000', 'temperatura', 718.0000, 'ºC'),
	(15257, 109, '2015-01-15 01:13:49.000000', 'temperatura', 601.0000, 'ºC'),
	(15258, 109, '2015-01-15 01:13:50.000000', 'temperatura', 854.0000, 'ºC'),
	(15259, 109, '2015-01-15 01:13:51.000000', 'temperatura', 68.0000, 'ºC'),
	(15260, 109, '2015-01-15 01:13:52.000000', 'temperatura', 179.0000, 'ºC'),
	(15261, 109, '2015-01-15 01:13:53.000000', 'temperatura', 689.0000, 'ºC'),
	(15262, 109, '2015-01-15 01:13:54.000000', 'temperatura', 508.0000, 'ºC'),
	(15263, 109, '2015-01-15 01:13:55.000000', 'temperatura', 476.0000, 'ºC'),
	(15264, 109, '2015-01-15 01:13:56.000000', 'temperatura', 853.0000, 'ºC'),
	(15265, 109, '2015-01-15 01:13:57.000000', 'temperatura', 441.0000, 'ºC'),
	(15266, 109, '2015-01-15 01:13:58.000000', 'temperatura', 846.0000, 'ºC'),
	(15267, 109, '2015-01-15 01:13:59.000000', 'temperatura', 507.0000, 'ºC'),
	(15268, 109, '2015-01-15 01:14:00.000000', 'temperatura', 0.0000, 'ºC'),
	(15269, 109, '2015-01-15 01:14:01.000000', 'temperatura', 876.0000, 'ºC'),
	(15270, 109, '2015-01-15 01:14:02.000000', 'temperatura', 780.0000, 'ºC'),
	(15271, 109, '2015-01-15 01:14:03.000000', 'temperatura', 75.0000, 'ºC'),
	(15272, 109, '2015-01-15 01:14:04.000000', 'temperatura', 433.0000, 'ºC'),
	(15273, 109, '2015-01-15 01:14:05.000000', 'temperatura', 740.0000, 'ºC'),
	(15274, 109, '2015-01-15 01:14:06.000000', 'temperatura', 4.0000, 'ºC'),
	(15275, 109, '2015-01-15 01:14:07.000000', 'temperatura', 201.0000, 'ºC'),
	(15276, 109, '2015-01-15 01:14:08.000000', 'temperatura', 991.0000, 'ºC'),
	(15277, 109, '2015-01-15 01:14:09.000000', 'temperatura', 752.0000, 'ºC'),
	(15278, 109, '2015-01-15 01:14:10.000000', 'temperatura', 787.0000, 'ºC'),
	(15279, 109, '2015-01-15 01:14:11.000000', 'temperatura', 480.0000, 'ºC'),
	(15280, 109, '2015-01-15 01:14:12.000000', 'temperatura', 41.0000, 'ºC'),
	(15281, 109, '2015-01-15 01:14:13.000000', 'temperatura', 1163.0000, 'ºC'),
	(15282, 109, '2015-01-15 01:14:14.000000', 'temperatura', 895.0000, 'ºC'),
	(15283, 109, '2015-01-15 01:14:15.000000', 'temperatura', 986.0000, 'ºC'),
	(15284, 109, '2015-01-15 01:14:16.000000', 'temperatura', 1044.0000, 'ºC'),
	(15285, 109, '2015-01-15 01:14:17.000000', 'temperatura', 1064.0000, 'ºC'),
	(15286, 109, '2015-01-15 01:14:18.000000', 'temperatura', 987.0000, 'ºC'),
	(15287, 109, '2015-01-15 01:14:19.000000', 'temperatura', 542.0000, 'ºC'),
	(15288, 109, '2015-01-15 01:14:20.000000', 'temperatura', 953.0000, 'ºC'),
	(15289, 109, '2015-01-15 01:14:21.000000', 'temperatura', 737.0000, 'ºC'),
	(15290, 109, '2015-01-15 01:14:22.000000', 'temperatura', 828.0000, 'ºC'),
	(15291, 109, '2015-01-15 01:14:23.000000', 'temperatura', 728.0000, 'ºC'),
	(15292, 109, '2015-01-15 01:14:24.000000', 'temperatura', 1158.0000, 'ºC'),
	(15293, 109, '2015-01-15 01:14:25.000000', 'temperatura', 5.0000, 'ºC'),
	(15294, 109, '2015-01-15 01:14:26.000000', 'temperatura', 152.0000, 'ºC'),
	(15295, 109, '2015-01-15 01:14:27.000000', 'temperatura', 744.0000, 'ºC'),
	(15296, 109, '2015-01-15 01:14:28.000000', 'temperatura', 866.0000, 'ºC'),
	(15297, 109, '2015-01-15 01:14:29.000000', 'temperatura', 897.0000, 'ºC'),
	(15298, 109, '2015-01-15 01:14:30.000000', 'temperatura', 687.0000, 'ºC'),
	(15299, 109, '2015-01-15 01:14:31.000000', 'temperatura', 746.0000, 'ºC'),
	(15300, 109, '2015-01-15 01:14:32.000000', 'temperatura', 468.0000, 'ºC'),
	(15301, 109, '2015-01-15 01:14:33.000000', 'temperatura', 104.0000, 'ºC'),
	(15302, 109, '2015-01-15 01:14:34.000000', 'temperatura', 314.0000, 'ºC'),
	(15303, 109, '2015-01-15 01:14:35.000000', 'temperatura', 60.0000, 'ºC'),
	(15304, 109, '2015-01-15 01:14:36.000000', 'temperatura', 557.0000, 'ºC'),
	(15305, 109, '2015-01-15 01:14:37.000000', 'temperatura', 205.0000, 'ºC'),
	(15306, 109, '2015-01-15 01:14:38.000000', 'temperatura', 558.0000, 'ºC'),
	(15307, 109, '2015-01-15 01:14:39.000000', 'temperatura', 972.0000, 'ºC'),
	(15308, 109, '2015-01-15 01:14:40.000000', 'temperatura', 787.0000, 'ºC'),
	(15309, 109, '2015-01-15 01:14:41.000000', 'temperatura', 1020.0000, 'ºC'),
	(15310, 109, '2015-01-15 01:14:42.000000', 'temperatura', 338.0000, 'ºC'),
	(15311, 109, '2015-01-15 01:14:43.000000', 'temperatura', 1032.0000, 'ºC'),
	(15312, 109, '2015-01-15 01:14:44.000000', 'temperatura', 546.0000, 'ºC'),
	(15313, 109, '2015-01-15 01:14:45.000000', 'temperatura', 833.0000, 'ºC'),
	(15314, 109, '2015-01-15 01:14:46.000000', 'temperatura', 129.0000, 'ºC'),
	(15315, 109, '2015-01-15 01:14:47.000000', 'temperatura', 544.0000, 'ºC'),
	(15316, 109, '2015-01-15 01:14:48.000000', 'temperatura', 1137.0000, 'ºC'),
	(15317, 109, '2015-01-15 01:14:49.000000', 'temperatura', 451.0000, 'ºC'),
	(15318, 109, '2015-01-15 01:14:50.000000', 'temperatura', 43.0000, 'ºC'),
	(15319, 109, '2015-01-15 01:14:51.000000', 'temperatura', 66.0000, 'ºC'),
	(15320, 109, '2015-01-15 01:14:52.000000', 'temperatura', 201.0000, 'ºC'),
	(15321, 109, '2015-01-15 01:14:53.000000', 'temperatura', 806.0000, 'ºC'),
	(15322, 109, '2015-01-15 01:14:54.000000', 'temperatura', 1026.0000, 'ºC'),
	(15323, 109, '2015-01-15 01:14:55.000000', 'temperatura', 316.0000, 'ºC'),
	(15324, 109, '2015-01-15 01:14:56.000000', 'temperatura', 901.0000, 'ºC'),
	(15325, 109, '2015-01-15 01:14:57.000000', 'temperatura', 1158.0000, 'ºC'),
	(15326, 109, '2015-01-15 01:14:58.000000', 'temperatura', 689.0000, 'ºC'),
	(15327, 109, '2015-01-15 01:14:59.000000', 'temperatura', 1169.0000, 'ºC'),
	(15328, 109, '2015-01-15 01:15:00.000000', 'temperatura', 179.0000, 'ºC'),
	(15329, 109, '2015-01-15 01:15:01.000000', 'temperatura', 991.0000, 'ºC'),
	(15330, 109, '2015-01-15 01:15:02.000000', 'temperatura', 816.0000, 'ºC'),
	(15331, 109, '2015-01-15 01:15:03.000000', 'temperatura', 1110.0000, 'ºC'),
	(15332, 109, '2015-01-15 01:15:04.000000', 'temperatura', 701.0000, 'ºC'),
	(15333, 109, '2015-01-15 01:15:05.000000', 'temperatura', 175.0000, 'ºC'),
	(15334, 109, '2015-01-15 01:15:06.000000', 'temperatura', 1175.0000, 'ºC'),
	(15335, 109, '2015-01-15 01:15:07.000000', 'temperatura', 548.0000, 'ºC'),
	(15336, 109, '2015-01-15 01:15:08.000000', 'temperatura', 417.0000, 'ºC'),
	(15337, 109, '2015-01-15 01:15:09.000000', 'temperatura', 441.0000, 'ºC'),
	(15338, 109, '2015-01-15 01:15:10.000000', 'temperatura', 954.0000, 'ºC'),
	(15339, 109, '2015-01-15 01:15:11.000000', 'temperatura', 1047.0000, 'ºC'),
	(15340, 109, '2015-01-15 01:15:12.000000', 'temperatura', 1174.0000, 'ºC'),
	(15341, 109, '2015-01-15 01:15:13.000000', 'temperatura', 327.0000, 'ºC'),
	(15342, 109, '2015-01-15 01:15:14.000000', 'temperatura', 517.0000, 'ºC'),
	(15343, 109, '2015-01-15 01:15:15.000000', 'temperatura', 405.0000, 'ºC'),
	(15344, 109, '2015-01-15 01:15:16.000000', 'temperatura', 473.0000, 'ºC'),
	(15345, 109, '2015-01-15 01:15:17.000000', 'temperatura', 1150.0000, 'ºC'),
	(15346, 109, '2015-01-15 01:15:18.000000', 'temperatura', 734.0000, 'ºC'),
	(15347, 109, '2015-01-15 01:15:19.000000', 'temperatura', 219.0000, 'ºC'),
	(15348, 109, '2015-01-15 01:15:20.000000', 'temperatura', 94.0000, 'ºC'),
	(15349, 109, '2015-01-15 01:15:21.000000', 'temperatura', 1014.0000, 'ºC'),
	(15350, 109, '2015-01-15 01:15:22.000000', 'temperatura', 1189.0000, 'ºC'),
	(15351, 109, '2015-01-15 01:15:23.000000', 'temperatura', 505.0000, 'ºC'),
	(15352, 109, '2015-01-15 01:15:24.000000', 'temperatura', 155.0000, 'ºC'),
	(15353, 109, '2015-01-15 01:15:25.000000', 'temperatura', 463.0000, 'ºC'),
	(15354, 109, '2015-01-15 01:15:26.000000', 'temperatura', 649.0000, 'ºC'),
	(15355, 109, '2015-01-15 01:15:27.000000', 'temperatura', 657.0000, 'ºC'),
	(15356, 109, '2015-01-15 01:15:28.000000', 'temperatura', 140.0000, 'ºC'),
	(15357, 109, '2015-01-15 01:15:29.000000', 'temperatura', 1130.0000, 'ºC'),
	(15358, 109, '2015-01-15 01:15:30.000000', 'temperatura', 429.0000, 'ºC'),
	(15359, 109, '2015-01-15 01:15:31.000000', 'temperatura', 1157.0000, 'ºC'),
	(15360, 109, '2015-01-15 01:15:32.000000', 'temperatura', 896.0000, 'ºC'),
	(15361, 109, '2015-01-15 01:15:33.000000', 'temperatura', 1012.0000, 'ºC'),
	(15362, 109, '2015-01-15 01:15:34.000000', 'temperatura', 1170.0000, 'ºC'),
	(15363, 109, '2015-01-15 01:15:35.000000', 'temperatura', 418.0000, 'ºC'),
	(15364, 109, '2015-01-15 01:15:36.000000', 'temperatura', 977.0000, 'ºC'),
	(15365, 109, '2015-01-15 01:15:37.000000', 'temperatura', 34.0000, 'ºC'),
	(15366, 109, '2015-01-15 01:15:38.000000', 'temperatura', 840.0000, 'ºC'),
	(15367, 109, '2015-01-15 01:15:39.000000', 'temperatura', 498.0000, 'ºC'),
	(15368, 109, '2015-01-15 01:15:40.000000', 'temperatura', 1171.0000, 'ºC'),
	(15369, 109, '2015-01-15 01:15:41.000000', 'temperatura', 760.0000, 'ºC'),
	(15370, 109, '2015-01-15 01:15:42.000000', 'temperatura', 288.0000, 'ºC'),
	(15371, 109, '2015-01-15 01:15:43.000000', 'temperatura', 359.0000, 'ºC'),
	(15372, 109, '2015-01-15 01:15:44.000000', 'temperatura', 933.0000, 'ºC'),
	(15373, 109, '2015-01-15 01:15:45.000000', 'temperatura', 1186.0000, 'ºC'),
	(15374, 109, '2015-01-15 01:15:46.000000', 'temperatura', 734.0000, 'ºC'),
	(15375, 109, '2015-01-15 01:15:47.000000', 'temperatura', 112.0000, 'ºC'),
	(15376, 109, '2015-01-15 01:15:48.000000', 'temperatura', 758.0000, 'ºC'),
	(15377, 109, '2015-01-15 01:15:49.000000', 'temperatura', 1053.0000, 'ºC'),
	(15378, 109, '2015-01-15 01:15:50.000000', 'temperatura', 593.0000, 'ºC'),
	(15379, 109, '2015-01-15 01:15:51.000000', 'temperatura', 1005.0000, 'ºC'),
	(15380, 109, '2015-01-15 01:15:52.000000', 'temperatura', 847.0000, 'ºC'),
	(15381, 109, '2015-01-15 01:15:53.000000', 'temperatura', 22.0000, 'ºC'),
	(15382, 109, '2015-01-15 01:15:54.000000', 'temperatura', 1170.0000, 'ºC'),
	(15383, 109, '2015-01-15 01:15:55.000000', 'temperatura', 983.0000, 'ºC'),
	(15384, 109, '2015-01-15 01:15:56.000000', 'temperatura', 205.0000, 'ºC'),
	(15385, 109, '2015-01-15 01:15:57.000000', 'temperatura', 478.0000, 'ºC'),
	(15386, 109, '2015-01-15 01:15:58.000000', 'temperatura', 574.0000, 'ºC'),
	(15387, 109, '2015-01-15 01:15:59.000000', 'temperatura', 238.0000, 'ºC'),
	(15388, 109, '2015-01-15 01:16:00.000000', 'temperatura', 666.0000, 'ºC'),
	(15389, 109, '2015-01-15 01:16:01.000000', 'temperatura', 219.0000, 'ºC'),
	(15390, 109, '2015-01-15 01:16:02.000000', 'temperatura', 298.0000, 'ºC'),
	(15391, 109, '2015-01-15 01:16:03.000000', 'temperatura', 835.0000, 'ºC'),
	(15392, 109, '2015-01-15 01:16:04.000000', 'temperatura', 878.0000, 'ºC'),
	(15393, 109, '2015-01-15 01:16:05.000000', 'temperatura', 686.0000, 'ºC'),
	(15394, 109, '2015-01-15 01:16:06.000000', 'temperatura', 796.0000, 'ºC'),
	(15395, 109, '2015-01-15 01:16:07.000000', 'temperatura', 724.0000, 'ºC'),
	(15396, 109, '2015-01-15 01:16:08.000000', 'temperatura', 33.0000, 'ºC'),
	(15397, 109, '2015-01-15 01:16:09.000000', 'temperatura', 395.0000, 'ºC'),
	(15398, 109, '2015-01-15 01:16:10.000000', 'temperatura', 674.0000, 'ºC'),
	(15399, 109, '2015-01-15 01:16:11.000000', 'temperatura', 987.0000, 'ºC'),
	(15400, 109, '2015-01-15 01:16:12.000000', 'temperatura', 512.0000, 'ºC'),
	(15401, 109, '2015-01-15 01:16:13.000000', 'temperatura', 800.0000, 'ºC'),
	(15402, 109, '2015-01-15 01:16:14.000000', 'temperatura', 65.0000, 'ºC'),
	(15403, 109, '2015-01-15 01:16:15.000000', 'temperatura', 324.0000, 'ºC'),
	(15404, 109, '2015-01-15 01:16:16.000000', 'temperatura', 225.0000, 'ºC'),
	(15405, 109, '2015-01-15 01:16:17.000000', 'temperatura', 152.0000, 'ºC'),
	(15406, 109, '2015-01-15 01:16:18.000000', 'temperatura', 89.0000, 'ºC'),
	(15407, 109, '2015-01-15 01:16:19.000000', 'temperatura', 1190.0000, 'ºC'),
	(15408, 109, '2015-01-15 01:16:20.000000', 'temperatura', 881.0000, 'ºC'),
	(15409, 109, '2015-01-15 01:16:21.000000', 'temperatura', 837.0000, 'ºC'),
	(15410, 109, '2015-01-15 01:16:22.000000', 'temperatura', 341.0000, 'ºC'),
	(15411, 109, '2015-01-15 01:16:23.000000', 'temperatura', 394.0000, 'ºC'),
	(15412, 109, '2015-01-15 01:16:24.000000', 'temperatura', 947.0000, 'ºC'),
	(15413, 109, '2015-01-15 01:16:25.000000', 'temperatura', 1153.0000, 'ºC'),
	(15414, 109, '2015-01-15 01:16:26.000000', 'temperatura', 527.0000, 'ºC'),
	(15415, 109, '2015-01-15 01:16:27.000000', 'temperatura', 376.0000, 'ºC'),
	(15416, 109, '2015-01-15 01:16:28.000000', 'temperatura', 301.0000, 'ºC'),
	(15417, 109, '2015-01-15 01:16:29.000000', 'temperatura', 376.0000, 'ºC'),
	(15418, 109, '2015-01-15 01:16:30.000000', 'temperatura', 979.0000, 'ºC'),
	(15419, 109, '2015-01-15 01:16:31.000000', 'temperatura', 165.0000, 'ºC'),
	(15420, 109, '2015-01-15 01:16:32.000000', 'temperatura', 291.0000, 'ºC'),
	(15421, 109, '2015-01-15 01:16:33.000000', 'temperatura', 962.0000, 'ºC'),
	(15422, 109, '2015-01-15 01:16:34.000000', 'temperatura', 334.0000, 'ºC'),
	(15423, 109, '2015-01-15 01:16:35.000000', 'temperatura', 1187.0000, 'ºC'),
	(15424, 109, '2015-01-15 01:16:36.000000', 'temperatura', 131.0000, 'ºC'),
	(15425, 109, '2015-01-15 01:16:37.000000', 'temperatura', 695.0000, 'ºC'),
	(15426, 109, '2015-01-15 01:16:38.000000', 'temperatura', 683.0000, 'ºC'),
	(15427, 109, '2015-01-15 01:16:39.000000', 'temperatura', 130.0000, 'ºC'),
	(15428, 109, '2015-01-15 01:16:40.000000', 'temperatura', 1003.0000, 'ºC'),
	(15429, 109, '2015-01-15 01:16:41.000000', 'temperatura', 1026.0000, 'ºC'),
	(15430, 109, '2015-01-15 01:16:42.000000', 'temperatura', 919.0000, 'ºC'),
	(15431, 109, '2015-01-15 01:16:43.000000', 'temperatura', 317.0000, 'ºC'),
	(15432, 109, '2015-01-15 01:16:44.000000', 'temperatura', 29.0000, 'ºC'),
	(15433, 109, '2015-01-15 01:16:45.000000', 'temperatura', 397.0000, 'ºC'),
	(15434, 109, '2015-01-15 01:16:46.000000', 'temperatura', 697.0000, 'ºC'),
	(15435, 109, '2015-01-15 01:16:47.000000', 'temperatura', 1093.0000, 'ºC'),
	(15436, 109, '2015-01-15 01:16:48.000000', 'temperatura', 974.0000, 'ºC'),
	(15437, 109, '2015-01-15 01:16:49.000000', 'temperatura', 392.0000, 'ºC'),
	(15438, 109, '2015-01-15 01:16:50.000000', 'temperatura', 238.0000, 'ºC'),
	(15439, 109, '2015-01-15 01:16:51.000000', 'temperatura', 15.0000, 'ºC'),
	(15440, 109, '2015-01-15 01:16:52.000000', 'temperatura', 561.0000, 'ºC'),
	(15441, 109, '2015-01-15 01:16:53.000000', 'temperatura', 361.0000, 'ºC'),
	(15442, 109, '2015-01-15 01:16:54.000000', 'temperatura', 123.0000, 'ºC'),
	(15443, 109, '2015-01-15 01:16:55.000000', 'temperatura', 731.0000, 'ºC'),
	(15444, 109, '2015-01-15 01:16:56.000000', 'temperatura', 889.0000, 'ºC'),
	(15445, 109, '2015-01-15 01:16:57.000000', 'temperatura', 1052.0000, 'ºC'),
	(15446, 109, '2015-01-15 01:16:58.000000', 'temperatura', 192.0000, 'ºC'),
	(15447, 109, '2015-01-15 01:16:59.000000', 'temperatura', 207.0000, 'ºC'),
	(15448, 109, '2015-01-15 01:17:00.000000', 'temperatura', 458.0000, 'ºC'),
	(15449, 109, '2015-01-15 01:17:01.000000', 'temperatura', 469.0000, 'ºC'),
	(15450, 109, '2015-01-15 01:17:02.000000', 'temperatura', 970.0000, 'ºC'),
	(15451, 109, '2015-01-15 01:17:03.000000', 'temperatura', 1045.0000, 'ºC'),
	(15452, 109, '2015-01-15 01:17:04.000000', 'temperatura', 1114.0000, 'ºC'),
	(15453, 109, '2015-01-15 01:17:05.000000', 'temperatura', 38.0000, 'ºC'),
	(15454, 109, '2015-01-15 01:17:06.000000', 'temperatura', 449.0000, 'ºC'),
	(15455, 109, '2015-01-15 01:17:07.000000', 'temperatura', 931.0000, 'ºC'),
	(15456, 109, '2015-01-15 01:17:08.000000', 'temperatura', 907.0000, 'ºC'),
	(15457, 109, '2015-01-15 01:17:09.000000', 'temperatura', 543.0000, 'ºC'),
	(15458, 109, '2015-01-15 01:17:10.000000', 'temperatura', 1196.0000, 'ºC'),
	(15459, 109, '2015-01-15 01:17:11.000000', 'temperatura', 750.0000, 'ºC'),
	(15460, 109, '2015-01-15 01:17:12.000000', 'temperatura', 162.0000, 'ºC'),
	(15461, 109, '2015-01-15 01:17:13.000000', 'temperatura', 962.0000, 'ºC'),
	(15462, 109, '2015-01-15 01:17:14.000000', 'temperatura', 725.0000, 'ºC'),
	(15463, 109, '2015-01-15 01:17:15.000000', 'temperatura', 738.0000, 'ºC'),
	(15464, 109, '2015-01-15 01:17:16.000000', 'temperatura', 314.0000, 'ºC'),
	(15465, 109, '2015-01-15 01:17:17.000000', 'temperatura', 559.0000, 'ºC'),
	(15466, 109, '2015-01-15 01:17:18.000000', 'temperatura', 652.0000, 'ºC'),
	(15467, 109, '2015-01-15 01:17:19.000000', 'temperatura', 383.0000, 'ºC'),
	(15468, 109, '2015-01-15 01:17:20.000000', 'temperatura', 1162.0000, 'ºC'),
	(15469, 109, '2015-01-15 01:17:21.000000', 'temperatura', 1059.0000, 'ºC'),
	(15470, 109, '2015-01-15 01:17:22.000000', 'temperatura', 609.0000, 'ºC'),
	(15471, 109, '2015-01-15 01:17:23.000000', 'temperatura', 1070.0000, 'ºC'),
	(15472, 109, '2015-01-15 01:17:24.000000', 'temperatura', 1121.0000, 'ºC'),
	(15473, 109, '2015-01-15 01:17:25.000000', 'temperatura', 1199.0000, 'ºC'),
	(15474, 109, '2015-01-15 01:17:26.000000', 'temperatura', 229.0000, 'ºC'),
	(15475, 109, '2015-01-15 01:17:27.000000', 'temperatura', 1151.0000, 'ºC'),
	(15476, 109, '2015-01-15 01:17:28.000000', 'temperatura', 270.0000, 'ºC'),
	(15477, 109, '2015-01-15 01:17:29.000000', 'temperatura', 295.0000, 'ºC'),
	(15478, 109, '2015-01-15 01:17:30.000000', 'temperatura', 664.0000, 'ºC'),
	(15479, 109, '2015-01-15 01:17:31.000000', 'temperatura', 39.0000, 'ºC'),
	(15480, 109, '2015-01-15 01:17:32.000000', 'temperatura', 602.0000, 'ºC'),
	(15481, 109, '2015-01-15 01:17:33.000000', 'temperatura', 492.0000, 'ºC'),
	(15482, 109, '2015-01-15 01:17:34.000000', 'temperatura', 653.0000, 'ºC'),
	(15483, 109, '2015-01-15 01:17:35.000000', 'temperatura', 593.0000, 'ºC'),
	(15484, 109, '2015-01-15 01:17:36.000000', 'temperatura', 1007.0000, 'ºC'),
	(15485, 109, '2015-01-15 01:17:37.000000', 'temperatura', 854.0000, 'ºC'),
	(15486, 109, '2015-01-15 01:17:38.000000', 'temperatura', 50.0000, 'ºC'),
	(15487, 109, '2015-01-15 01:17:39.000000', 'temperatura', 89.0000, 'ºC'),
	(15488, 109, '2015-01-15 01:17:40.000000', 'temperatura', 295.0000, 'ºC'),
	(15489, 109, '2015-01-15 01:17:41.000000', 'temperatura', 7.0000, 'ºC'),
	(15490, 109, '2015-01-15 01:17:42.000000', 'temperatura', 352.0000, 'ºC'),
	(15491, 109, '2015-01-15 01:17:43.000000', 'temperatura', 541.0000, 'ºC'),
	(15492, 109, '2015-01-15 01:17:44.000000', 'temperatura', 447.0000, 'ºC'),
	(15493, 109, '2015-01-15 01:17:45.000000', 'temperatura', 613.0000, 'ºC'),
	(15494, 109, '2015-01-15 01:17:46.000000', 'temperatura', 527.0000, 'ºC'),
	(15495, 109, '2015-01-15 01:17:47.000000', 'temperatura', 794.0000, 'ºC'),
	(15496, 109, '2015-01-15 01:17:48.000000', 'temperatura', 1192.0000, 'ºC'),
	(15497, 109, '2015-01-15 01:17:49.000000', 'temperatura', 1177.0000, 'ºC'),
	(15498, 109, '2015-01-15 01:17:50.000000', 'temperatura', 1111.0000, 'ºC'),
	(15499, 109, '2015-01-15 01:17:51.000000', 'temperatura', 825.0000, 'ºC'),
	(15500, 109, '2015-01-15 01:17:52.000000', 'temperatura', 793.0000, 'ºC'),
	(15501, 109, '2015-01-15 01:17:53.000000', 'temperatura', 291.0000, 'ºC'),
	(15502, 109, '2015-01-15 01:17:54.000000', 'temperatura', 277.0000, 'ºC'),
	(15503, 109, '2015-01-15 01:17:55.000000', 'temperatura', 513.0000, 'ºC'),
	(15504, 109, '2015-01-15 01:17:56.000000', 'temperatura', 534.0000, 'ºC'),
	(15505, 109, '2015-01-15 01:17:57.000000', 'temperatura', 1132.0000, 'ºC'),
	(15506, 109, '2015-01-15 01:17:58.000000', 'temperatura', 459.0000, 'ºC'),
	(15507, 109, '2015-01-15 01:17:59.000000', 'temperatura', 101.0000, 'ºC'),
	(15508, 109, '2015-01-15 01:18:00.000000', 'temperatura', 325.0000, 'ºC'),
	(15509, 109, '2015-01-15 01:18:01.000000', 'temperatura', 125.0000, 'ºC'),
	(15510, 109, '2015-01-15 01:18:02.000000', 'temperatura', 848.0000, 'ºC'),
	(15511, 109, '2015-01-15 01:18:03.000000', 'temperatura', 265.0000, 'ºC'),
	(15512, 109, '2015-01-15 01:18:04.000000', 'temperatura', 1184.0000, 'ºC'),
	(15513, 109, '2015-01-15 01:18:05.000000', 'temperatura', 323.0000, 'ºC'),
	(15514, 109, '2015-01-15 01:18:06.000000', 'temperatura', 464.0000, 'ºC'),
	(15515, 109, '2015-01-15 01:18:07.000000', 'temperatura', 151.0000, 'ºC'),
	(15516, 109, '2015-01-15 01:18:08.000000', 'temperatura', 566.0000, 'ºC'),
	(15517, 109, '2015-01-15 01:18:09.000000', 'temperatura', 1175.0000, 'ºC'),
	(15518, 109, '2015-01-15 01:18:10.000000', 'temperatura', 580.0000, 'ºC'),
	(15519, 109, '2015-01-15 01:18:11.000000', 'temperatura', 575.0000, 'ºC'),
	(15520, 109, '2015-01-15 01:18:12.000000', 'temperatura', 1135.0000, 'ºC'),
	(15521, 109, '2015-01-15 01:18:13.000000', 'temperatura', 349.0000, 'ºC'),
	(15522, 109, '2015-01-15 01:18:14.000000', 'temperatura', 741.0000, 'ºC'),
	(15523, 109, '2015-01-15 01:18:15.000000', 'temperatura', 257.0000, 'ºC'),
	(15524, 109, '2015-01-15 01:18:16.000000', 'temperatura', 265.0000, 'ºC'),
	(15525, 109, '2015-01-15 01:18:17.000000', 'temperatura', 553.0000, 'ºC'),
	(15526, 109, '2015-01-15 01:18:18.000000', 'temperatura', 772.0000, 'ºC'),
	(15527, 109, '2015-01-15 01:18:19.000000', 'temperatura', 1000.0000, 'ºC'),
	(15528, 109, '2015-01-15 01:18:20.000000', 'temperatura', 287.0000, 'ºC'),
	(15529, 109, '2015-01-15 01:18:21.000000', 'temperatura', 834.0000, 'ºC'),
	(15530, 109, '2015-01-15 01:18:22.000000', 'temperatura', 911.0000, 'ºC'),
	(15531, 109, '2015-01-15 01:18:23.000000', 'temperatura', 852.0000, 'ºC'),
	(15532, 109, '2015-01-15 01:18:24.000000', 'temperatura', 330.0000, 'ºC'),
	(15533, 109, '2015-01-15 01:18:25.000000', 'temperatura', 292.0000, 'ºC'),
	(15534, 109, '2015-01-15 01:18:26.000000', 'temperatura', 471.0000, 'ºC'),
	(15535, 109, '2015-01-15 01:18:27.000000', 'temperatura', 282.0000, 'ºC'),
	(15536, 109, '2015-01-15 01:18:28.000000', 'temperatura', 1195.0000, 'ºC'),
	(15537, 109, '2015-01-15 01:18:29.000000', 'temperatura', 329.0000, 'ºC'),
	(15538, 109, '2015-01-15 01:18:30.000000', 'temperatura', 462.0000, 'ºC'),
	(15539, 109, '2015-01-15 01:18:31.000000', 'temperatura', 123.0000, 'ºC'),
	(15540, 109, '2015-01-15 01:18:32.000000', 'temperatura', 430.0000, 'ºC'),
	(15541, 109, '2015-01-15 01:18:33.000000', 'temperatura', 582.0000, 'ºC'),
	(15542, 109, '2015-01-15 01:18:34.000000', 'temperatura', 419.0000, 'ºC'),
	(15543, 109, '2015-01-15 01:18:35.000000', 'temperatura', 350.0000, 'ºC'),
	(15544, 109, '2015-01-15 01:18:36.000000', 'temperatura', 494.0000, 'ºC'),
	(15545, 109, '2015-01-15 01:18:37.000000', 'temperatura', 220.0000, 'ºC'),
	(15546, 109, '2015-01-15 01:18:38.000000', 'temperatura', 817.0000, 'ºC'),
	(15547, 109, '2015-01-15 01:18:39.000000', 'temperatura', 1028.0000, 'ºC'),
	(15548, 109, '2015-01-15 01:18:40.000000', 'temperatura', 288.0000, 'ºC'),
	(15549, 109, '2015-01-15 01:18:41.000000', 'temperatura', 757.0000, 'ºC'),
	(15550, 109, '2015-01-15 01:18:42.000000', 'temperatura', 521.0000, 'ºC'),
	(15551, 109, '2015-01-15 01:18:43.000000', 'temperatura', 336.0000, 'ºC'),
	(15552, 109, '2015-01-15 01:18:44.000000', 'temperatura', 115.0000, 'ºC'),
	(15553, 109, '2015-01-15 01:18:45.000000', 'temperatura', 767.0000, 'ºC'),
	(15554, 109, '2015-01-15 01:18:46.000000', 'temperatura', 1091.0000, 'ºC'),
	(15555, 109, '2015-01-15 01:18:47.000000', 'temperatura', 757.0000, 'ºC'),
	(15556, 109, '2015-01-15 01:18:48.000000', 'temperatura', 511.0000, 'ºC'),
	(15557, 109, '2015-01-15 01:18:49.000000', 'temperatura', 284.0000, 'ºC'),
	(15558, 109, '2015-01-15 01:18:50.000000', 'temperatura', 1089.0000, 'ºC'),
	(15559, 109, '2015-01-15 01:18:51.000000', 'temperatura', 994.0000, 'ºC'),
	(15560, 109, '2015-01-15 01:18:52.000000', 'temperatura', 505.0000, 'ºC'),
	(15561, 109, '2015-01-15 01:18:53.000000', 'temperatura', 740.0000, 'ºC'),
	(15562, 109, '2015-01-15 01:18:54.000000', 'temperatura', 988.0000, 'ºC'),
	(15563, 109, '2015-01-15 01:18:55.000000', 'temperatura', 320.0000, 'ºC'),
	(15564, 109, '2015-01-15 01:18:56.000000', 'temperatura', 1037.0000, 'ºC'),
	(15565, 109, '2015-01-15 01:18:57.000000', 'temperatura', 624.0000, 'ºC'),
	(15566, 109, '2015-01-15 01:18:58.000000', 'temperatura', 12.0000, 'ºC'),
	(15567, 109, '2015-01-15 01:18:59.000000', 'temperatura', 588.0000, 'ºC'),
	(15568, 109, '2015-01-15 01:19:00.000000', 'temperatura', 504.0000, 'ºC'),
	(15569, 109, '2015-01-15 01:19:01.000000', 'temperatura', 757.0000, 'ºC'),
	(15570, 109, '2015-01-15 01:19:02.000000', 'temperatura', 1072.0000, 'ºC'),
	(15571, 109, '2015-01-15 01:19:03.000000', 'temperatura', 688.0000, 'ºC'),
	(15572, 109, '2015-01-15 01:19:04.000000', 'temperatura', 227.0000, 'ºC'),
	(15573, 109, '2015-01-15 01:19:05.000000', 'temperatura', 270.0000, 'ºC'),
	(15574, 109, '2015-01-15 01:19:06.000000', 'temperatura', 670.0000, 'ºC'),
	(15575, 109, '2015-01-15 01:19:07.000000', 'temperatura', 139.0000, 'ºC'),
	(15576, 109, '2015-01-15 01:19:08.000000', 'temperatura', 1089.0000, 'ºC'),
	(15577, 109, '2015-01-15 01:19:09.000000', 'temperatura', 225.0000, 'ºC'),
	(15578, 109, '2015-01-15 01:19:10.000000', 'temperatura', 259.0000, 'ºC'),
	(15579, 109, '2015-01-15 01:19:11.000000', 'temperatura', 623.0000, 'ºC'),
	(15580, 109, '2015-01-15 01:19:12.000000', 'temperatura', 1138.0000, 'ºC'),
	(15581, 109, '2015-01-15 01:19:13.000000', 'temperatura', 220.0000, 'ºC'),
	(15582, 109, '2015-01-15 01:19:14.000000', 'temperatura', 88.0000, 'ºC'),
	(15583, 109, '2015-01-15 01:19:15.000000', 'temperatura', 981.0000, 'ºC'),
	(15584, 109, '2015-01-15 01:19:16.000000', 'temperatura', 1040.0000, 'ºC'),
	(15585, 109, '2015-01-15 01:19:17.000000', 'temperatura', 1060.0000, 'ºC'),
	(15586, 109, '2015-01-15 01:19:18.000000', 'temperatura', 979.0000, 'ºC'),
	(15587, 109, '2015-01-15 01:19:19.000000', 'temperatura', 516.0000, 'ºC'),
	(15588, 109, '2015-01-15 01:19:20.000000', 'temperatura', 845.0000, 'ºC'),
	(15589, 109, '2015-01-15 01:19:21.000000', 'temperatura', 277.0000, 'ºC'),
	(15590, 109, '2015-01-15 01:19:22.000000', 'temperatura', 50.0000, 'ºC'),
	(15591, 109, '2015-01-15 01:19:23.000000', 'temperatura', 621.0000, 'ºC'),
	(15592, 109, '2015-01-15 01:19:24.000000', 'temperatura', 554.0000, 'ºC'),
	(15593, 109, '2015-01-15 01:19:25.000000', 'temperatura', 908.0000, 'ºC'),
	(15594, 109, '2015-01-15 01:19:26.000000', 'temperatura', 478.0000, 'ºC'),
	(15595, 109, '2015-01-15 01:19:27.000000', 'temperatura', 868.0000, 'ºC'),
	(15596, 109, '2015-01-15 01:19:28.000000', 'temperatura', 506.0000, 'ºC'),
	(15597, 109, '2015-01-15 01:19:29.000000', 'temperatura', 1125.0000, 'ºC'),
	(15598, 109, '2015-01-15 01:19:30.000000', 'temperatura', 508.0000, 'ºC'),
	(15599, 109, '2015-01-15 01:19:31.000000', 'temperatura', 364.0000, 'ºC'),
	(15600, 109, '2015-01-15 01:19:32.000000', 'temperatura', 298.0000, 'ºC'),
	(15601, 109, '2015-01-15 01:19:33.000000', 'temperatura', 398.0000, 'ºC'),
	(15602, 109, '2015-01-15 01:19:34.000000', 'temperatura', 1096.0000, 'ºC'),
	(15603, 109, '2015-01-15 01:19:35.000000', 'temperatura', 686.0000, 'ºC'),
	(15604, 109, '2015-01-15 01:19:36.000000', 'temperatura', 144.0000, 'ºC'),
	(15605, 109, '2015-01-15 01:19:37.000000', 'temperatura', 1060.0000, 'ºC'),
	(15606, 109, '2015-01-15 01:19:38.000000', 'temperatura', 71.0000, 'ºC'),
	(15607, 109, '2015-01-15 01:19:39.000000', 'temperatura', 774.0000, 'ºC'),
	(15608, 109, '2015-01-15 01:19:40.000000', 'temperatura', 59.0000, 'ºC'),
	(15609, 109, '2015-01-15 01:19:41.000000', 'temperatura', 373.0000, 'ºC'),
	(15610, 109, '2015-01-15 01:19:42.000000', 'temperatura', 490.0000, 'ºC'),
	(15611, 109, '2015-01-15 01:19:43.000000', 'temperatura', 132.0000, 'ºC'),
	(15612, 109, '2015-01-15 01:19:44.000000', 'temperatura', 391.0000, 'ºC'),
	(15613, 109, '2015-01-15 01:19:45.000000', 'temperatura', 359.0000, 'ºC'),
	(15614, 109, '2015-01-15 01:19:46.000000', 'temperatura', 620.0000, 'ºC'),
	(15615, 109, '2015-01-15 01:19:47.000000', 'temperatura', 825.0000, 'ºC'),
	(15616, 109, '2015-01-15 01:19:48.000000', 'temperatura', 1065.0000, 'ºC'),
	(15617, 109, '2015-01-15 01:19:49.000000', 'temperatura', 452.0000, 'ºC'),
	(15618, 109, '2015-01-15 01:19:50.000000', 'temperatura', 263.0000, 'ºC'),
	(15619, 109, '2015-01-15 01:19:51.000000', 'temperatura', 1159.0000, 'ºC'),
	(15620, 109, '2015-01-15 01:19:52.000000', 'temperatura', 208.0000, 'ºC'),
	(15621, 109, '2015-01-15 01:19:53.000000', 'temperatura', 1165.0000, 'ºC'),
	(15622, 109, '2015-01-15 01:19:54.000000', 'temperatura', 399.0000, 'ºC'),
	(15623, 109, '2015-01-15 01:19:55.000000', 'temperatura', 903.0000, 'ºC'),
	(15624, 109, '2015-01-15 01:19:56.000000', 'temperatura', 917.0000, 'ºC'),
	(15625, 109, '2015-01-15 01:19:57.000000', 'temperatura', 675.0000, 'ºC'),
	(15626, 109, '2015-01-15 01:19:58.000000', 'temperatura', 626.0000, 'ºC'),
	(15627, 109, '2015-01-15 01:19:59.000000', 'temperatura', 1105.0000, 'ºC'),
	(15628, 109, '2015-01-15 01:20:00.000000', 'temperatura', 47.0000, 'ºC'),
	(15629, 109, '2015-01-15 01:20:01.000000', 'temperatura', 520.0000, 'ºC'),
	(15630, 109, '2015-01-15 01:20:02.000000', 'temperatura', 61.0000, 'ºC'),
	(15631, 109, '2015-01-15 01:20:03.000000', 'temperatura', 1145.0000, 'ºC'),
	(15632, 109, '2015-01-15 01:20:04.000000', 'temperatura', 742.0000, 'ºC'),
	(15633, 109, '2015-01-15 01:20:05.000000', 'temperatura', 274.0000, 'ºC'),
	(15634, 109, '2015-01-15 01:20:06.000000', 'temperatura', 348.0000, 'ºC'),
	(15635, 109, '2015-01-15 01:20:07.000000', 'temperatura', 916.0000, 'ºC'),
	(15636, 109, '2015-01-15 01:20:08.000000', 'temperatura', 1137.0000, 'ºC'),
	(15637, 109, '2015-01-15 01:20:09.000000', 'temperatura', 538.0000, 'ºC'),
	(15638, 109, '2015-01-15 01:20:10.000000', 'temperatura', 479.0000, 'ºC'),
	(15639, 109, '2015-01-15 01:20:11.000000', 'temperatura', 781.0000, 'ºC'),
	(15640, 109, '2015-01-15 01:20:12.000000', 'temperatura', 67.0000, 'ºC'),
	(15641, 109, '2015-01-15 01:20:13.000000', 'temperatura', 396.0000, 'ºC'),
	(15642, 109, '2015-01-15 01:20:14.000000', 'temperatura', 577.0000, 'ºC'),
	(15643, 109, '2015-01-15 01:20:15.000000', 'temperatura', 500.0000, 'ºC'),
	(15644, 109, '2015-01-15 01:20:16.000000', 'temperatura', 767.0000, 'ºC'),
	(15645, 109, '2015-01-15 01:20:17.000000', 'temperatura', 1135.0000, 'ºC'),
	(15646, 109, '2015-01-15 01:20:18.000000', 'temperatura', 975.0000, 'ºC'),
	(15647, 109, '2015-01-15 01:20:19.000000', 'temperatura', 269.0000, 'ºC'),
	(15648, 109, '2015-01-15 01:20:20.000000', 'temperatura', 822.0000, 'ºC'),
	(15649, 109, '2015-01-15 01:20:21.000000', 'temperatura', 904.0000, 'ºC'),
	(15650, 109, '2015-01-15 01:20:22.000000', 'temperatura', 853.0000, 'ºC'),
	(15651, 109, '2015-01-15 01:20:23.000000', 'temperatura', 352.0000, 'ºC'),
	(15652, 109, '2015-01-15 01:20:24.000000', 'temperatura', 404.0000, 'ºC'),
	(15653, 109, '2015-01-15 01:20:25.000000', 'temperatura', 964.0000, 'ºC'),
	(15654, 109, '2015-01-15 01:20:26.000000', 'temperatura', 8.0000, 'ºC'),
	(15655, 109, '2015-01-15 01:20:27.000000', 'temperatura', 750.0000, 'ºC'),
	(15656, 109, '2015-01-15 01:20:28.000000', 'temperatura', 126.0000, 'ºC'),
	(15657, 109, '2015-01-15 01:20:29.000000', 'temperatura', 781.0000, 'ºC'),
	(15658, 109, '2015-01-15 01:20:30.000000', 'temperatura', 1129.0000, 'ºC'),
	(15659, 109, '2015-01-15 01:20:31.000000', 'temperatura', 900.0000, 'ºC'),
	(15660, 109, '2015-01-15 01:20:32.000000', 'temperatura', 1113.0000, 'ºC'),
	(15661, 109, '2015-01-15 01:20:33.000000', 'temperatura', 464.0000, 'ºC'),
	(15662, 109, '2015-01-15 01:20:34.000000', 'temperatura', 185.0000, 'ºC'),
	(15663, 109, '2015-01-15 01:20:35.000000', 'temperatura', 733.0000, 'ºC'),
	(15664, 109, '2015-01-15 01:20:36.000000', 'temperatura', 712.0000, 'ºC'),
	(15665, 109, '2015-01-15 01:20:37.000000', 'temperatura', 158.0000, 'ºC'),
	(15666, 109, '2015-01-15 01:20:38.000000', 'temperatura', 1058.0000, 'ºC'),
	(15667, 109, '2015-01-15 01:20:39.000000', 'temperatura', 15.0000, 'ºC'),
	(15668, 109, '2015-01-15 01:20:40.000000', 'temperatura', 500.0000, 'ºC'),
	(15669, 109, '2015-01-15 01:20:41.000000', 'temperatura', 57.0000, 'ºC'),
	(15670, 109, '2015-01-15 01:20:42.000000', 'temperatura', 1184.0000, 'ºC'),
	(15671, 109, '2015-01-15 01:20:43.000000', 'temperatura', 950.0000, 'ºC'),
	(15672, 109, '2015-01-15 01:20:44.000000', 'temperatura', 1199.0000, 'ºC'),
	(15673, 109, '2015-01-15 01:20:45.000000', 'temperatura', 746.0000, 'ºC'),
	(15674, 109, '2015-01-15 01:20:46.000000', 'temperatura', 133.0000, 'ºC'),
	(15675, 109, '2015-01-15 01:20:47.000000', 'temperatura', 828.0000, 'ºC'),
	(15676, 109, '2015-01-15 01:20:48.000000', 'temperatura', 141.0000, 'ºC'),
	(15677, 109, '2015-01-15 01:20:49.000000', 'temperatura', 620.0000, 'ºC'),
	(15678, 109, '2015-01-15 01:20:50.000000', 'temperatura', 280.0000, 'ºC'),
	(15679, 109, '2015-01-15 01:20:51.000000', 'temperatura', 739.0000, 'ºC'),
	(15680, 109, '2015-01-15 01:20:52.000000', 'temperatura', 456.0000, 'ºC'),
	(15681, 109, '2015-01-15 01:20:53.000000', 'temperatura', 64.0000, 'ºC'),
	(15682, 109, '2015-01-15 01:20:54.000000', 'temperatura', 154.0000, 'ºC'),
	(15683, 109, '2015-01-15 01:20:55.000000', 'temperatura', 575.0000, 'ºC'),
	(15684, 109, '2015-01-15 01:20:56.000000', 'temperatura', 17.0000, 'ºC'),
	(15685, 109, '2015-01-15 01:20:57.000000', 'temperatura', 759.0000, 'ºC'),
	(15686, 109, '2015-01-15 01:20:58.000000', 'temperatura', 143.0000, 'ºC'),
	(15687, 109, '2015-01-15 01:20:59.000000', 'temperatura', 838.0000, 'ºC'),
	(15688, 109, '2015-01-15 01:21:00.000000', 'temperatura', 164.0000, 'ºC'),
	(15689, 109, '2015-01-15 01:21:01.000000', 'temperatura', 707.0000, 'ºC'),
	(15690, 109, '2015-01-15 01:21:02.000000', 'temperatura', 643.0000, 'ºC'),
	(15691, 109, '2015-01-15 01:21:03.000000', 'temperatura', 1093.0000, 'ºC'),
	(15692, 109, '2015-01-15 01:21:04.000000', 'temperatura', 1138.0000, 'ºC'),
	(15693, 109, '2015-01-15 01:21:05.000000', 'temperatura', 13.0000, 'ºC'),
	(15694, 109, '2015-01-15 01:21:06.000000', 'temperatura', 250.0000, 'ºC'),
	(15695, 109, '2015-01-15 01:21:07.000000', 'temperatura', 14.0000, 'ºC'),
	(15696, 109, '2015-01-15 01:21:08.000000', 'temperatura', 517.0000, 'ºC'),
	(15697, 109, '2015-01-15 01:21:09.000000', 'temperatura', 146.0000, 'ºC'),
	(15698, 109, '2015-01-15 01:21:10.000000', 'temperatura', 377.0000, 'ºC'),
	(15699, 109, '2015-01-15 01:21:11.000000', 'temperatura', 249.0000, 'ºC'),
	(15700, 109, '2015-01-15 01:21:12.000000', 'temperatura', 112.0000, 'ºC'),
	(15701, 109, '2015-01-15 01:21:13.000000', 'temperatura', 1016.0000, 'ºC'),
	(15702, 109, '2015-01-15 01:21:14.000000', 'temperatura', 1143.0000, 'ºC'),
	(15703, 109, '2015-01-15 01:21:15.000000', 'temperatura', 268.0000, 'ºC'),
	(15704, 109, '2015-01-15 01:21:16.000000', 'temperatura', 313.0000, 'ºC'),
	(15705, 109, '2015-01-15 01:21:17.000000', 'temperatura', 759.0000, 'ºC'),
	(15706, 109, '2015-01-15 01:21:18.000000', 'temperatura', 459.0000, 'ºC'),
	(15707, 109, '2015-01-15 01:21:19.000000', 'temperatura', 18.0000, 'ºC'),
	(15708, 109, '2015-01-15 01:21:20.000000', 'temperatura', 1115.0000, 'ºC'),
	(15709, 109, '2015-01-15 01:21:21.000000', 'temperatura', 720.0000, 'ºC'),
	(15710, 109, '2015-01-15 01:21:22.000000', 'temperatura', 258.0000, 'ºC'),
	(15711, 109, '2015-01-15 01:21:23.000000', 'temperatura', 328.0000, 'ºC'),
	(15712, 109, '2015-01-15 01:21:24.000000', 'temperatura', 866.0000, 'ºC'),
	(15713, 109, '2015-01-15 01:21:25.000000', 'temperatura', 945.0000, 'ºC'),
	(15714, 109, '2015-01-15 01:21:26.000000', 'temperatura', 930.0000, 'ºC'),
	(15715, 109, '2015-01-15 01:21:27.000000', 'temperatura', 614.0000, 'ºC'),
	(15716, 109, '2015-01-15 01:21:28.000000', 'temperatura', 280.0000, 'ºC'),
	(15717, 109, '2015-01-15 01:21:29.000000', 'temperatura', 761.0000, 'ºC'),
	(15718, 109, '2015-01-15 01:21:30.000000', 'temperatura', 563.0000, 'ºC'),
	(15719, 109, '2015-01-15 01:21:31.000000', 'temperatura', 533.0000, 'ºC'),
	(15720, 109, '2015-01-15 01:21:32.000000', 'temperatura', 977.0000, 'ºC'),
	(15721, 109, '2015-01-15 01:21:33.000000', 'temperatura', 888.0000, 'ºC'),
	(15722, 109, '2015-01-15 01:21:34.000000', 'temperatura', 309.0000, 'ºC'),
	(15723, 109, '2015-01-15 01:21:35.000000', 'temperatura', 81.0000, 'ºC'),
	(15724, 109, '2015-01-15 01:21:36.000000', 'temperatura', 679.0000, 'ºC'),
	(15725, 109, '2015-01-15 01:21:37.000000', 'temperatura', 752.0000, 'ºC'),
	(15726, 109, '2015-01-15 01:21:38.000000', 'temperatura', 525.0000, 'ºC'),
	(15727, 109, '2015-01-15 01:21:39.000000', 'temperatura', 367.0000, 'ºC'),
	(15728, 109, '2015-01-15 01:21:40.000000', 'temperatura', 263.0000, 'ºC'),
	(15729, 109, '2015-01-15 01:21:41.000000', 'temperatura', 214.0000, 'ºC'),
	(15730, 109, '2015-01-15 01:21:42.000000', 'temperatura', 280.0000, 'ºC'),
	(15731, 109, '2015-01-15 01:21:43.000000', 'temperatura', 760.0000, 'ºC'),
	(15732, 109, '2015-01-15 01:21:44.000000', 'temperatura', 558.0000, 'ºC'),
	(15733, 109, '2015-01-15 01:21:45.000000', 'temperatura', 511.0000, 'ºC'),
	(15734, 109, '2015-01-15 01:21:46.000000', 'temperatura', 884.0000, 'ºC'),
	(15735, 109, '2015-01-15 01:21:47.000000', 'temperatura', 486.0000, 'ºC'),
	(15736, 109, '2015-01-15 01:21:48.000000', 'temperatura', 980.0000, 'ºC'),
	(15737, 109, '2015-01-15 01:21:49.000000', 'temperatura', 1040.0000, 'ºC'),
	(15738, 109, '2015-01-15 01:21:50.000000', 'temperatura', 1061.0000, 'ºC'),
	(15739, 109, '2015-01-15 01:21:51.000000', 'temperatura', 986.0000, 'ºC'),
	(15740, 109, '2015-01-15 01:21:52.000000', 'temperatura', 547.0000, 'ºC'),
	(15741, 109, '2015-01-15 01:21:53.000000', 'temperatura', 979.0000, 'ºC'),
	(15742, 109, '2015-01-15 01:21:54.000000', 'temperatura', 854.0000, 'ºC'),
	(15743, 109, '2015-01-15 01:21:55.000000', 'temperatura', 135.0000, 'ºC'),
	(15744, 109, '2015-01-15 01:21:56.000000', 'temperatura', 512.0000, 'ºC'),
	(15745, 109, '2015-01-15 01:21:57.000000', 'temperatura', 954.0000, 'ºC'),
	(15746, 109, '2015-01-15 01:21:58.000000', 'temperatura', 835.0000, 'ºC'),
	(15747, 109, '2015-01-15 01:21:59.000000', 'temperatura', 112.0000, 'ºC'),
	(15748, 109, '2015-01-15 01:22:00.000000', 'temperatura', 457.0000, 'ºC'),
	(15749, 109, '2015-01-15 01:22:01.000000', 'temperatura', 747.0000, 'ºC'),
	(15750, 109, '2015-01-15 01:22:02.000000', 'temperatura', 1168.0000, 'ºC'),
	(15751, 109, '2015-01-15 01:22:03.000000', 'temperatura', 1199.0000, 'ºC'),
	(15752, 109, '2015-01-15 01:22:04.000000', 'temperatura', 90.0000, 'ºC'),
	(15753, 109, '2015-01-15 01:22:05.000000', 'temperatura', 452.0000, 'ºC'),
	(15754, 109, '2015-01-15 01:22:06.000000', 'temperatura', 793.0000, 'ºC'),
	(15755, 109, '2015-01-15 01:22:07.000000', 'temperatura', 211.0000, 'ºC'),
	(15756, 109, '2015-01-15 01:22:08.000000', 'temperatura', 1074.0000, 'ºC'),
	(15757, 109, '2015-01-15 01:22:09.000000', 'temperatura', 1136.0000, 'ºC'),
	(15758, 109, '2015-01-15 01:22:10.000000', 'temperatura', 62.0000, 'ºC'),
	(15759, 109, '2015-01-15 01:22:11.000000', 'temperatura', 501.0000, 'ºC'),
	(15760, 109, '2015-01-15 01:22:12.000000', 'temperatura', 1119.0000, 'ºC'),
	(15761, 109, '2015-01-15 01:22:13.000000', 'temperatura', 495.0000, 'ºC'),
	(15762, 109, '2015-01-15 01:22:14.000000', 'temperatura', 315.0000, 'ºC'),
	(15763, 109, '2015-01-15 01:22:15.000000', 'temperatura', 92.0000, 'ºC'),
	(15764, 109, '2015-01-15 01:22:16.000000', 'temperatura', 715.0000, 'ºC'),
	(15765, 109, '2015-01-15 01:22:17.000000', 'temperatura', 901.0000, 'ºC'),
	(15766, 109, '2015-01-15 01:22:18.000000', 'temperatura', 1158.0000, 'ºC'),
	(15767, 109, '2015-01-15 01:22:19.000000', 'temperatura', 689.0000, 'ºC'),
	(15768, 109, '2015-01-15 01:22:20.000000', 'temperatura', 1171.0000, 'ºC'),
	(15769, 109, '2015-01-15 01:22:21.000000', 'temperatura', 189.0000, 'ºC'),
	(15770, 109, '2015-01-15 01:22:22.000000', 'temperatura', 1032.0000, 'ºC'),
	(15771, 109, '2015-01-15 01:22:23.000000', 'temperatura', 995.0000, 'ºC'),
	(15772, 109, '2015-01-15 01:22:24.000000', 'temperatura', 679.0000, 'ºC'),
	(15773, 109, '2015-01-15 01:22:25.000000', 'temperatura', 411.0000, 'ºC'),
	(15774, 109, '2015-01-15 01:22:26.000000', 'temperatura', 17.0000, 'ºC'),
	(15775, 109, '2015-01-15 01:22:27.000000', 'temperatura', 53.0000, 'ºC'),
	(15776, 109, '2015-01-15 01:22:28.000000', 'temperatura', 215.0000, 'ºC'),
	(15777, 109, '2015-01-15 01:22:29.000000', 'temperatura', 918.0000, 'ºC'),
	(15778, 109, '2015-01-15 01:22:30.000000', 'temperatura', 343.0000, 'ºC'),
	(15779, 109, '2015-01-15 01:22:31.000000', 'temperatura', 164.0000, 'ºC'),
	(15780, 109, '2015-01-15 01:22:32.000000', 'temperatura', 989.0000, 'ºC'),
	(15781, 109, '2015-01-15 01:22:33.000000', 'temperatura', 854.0000, 'ºC'),
	(15782, 109, '2015-01-15 01:22:34.000000', 'temperatura', 104.0000, 'ºC'),
	(15783, 109, '2015-01-15 01:22:35.000000', 'temperatura', 357.0000, 'ºC'),
	(15784, 109, '2015-01-15 01:22:36.000000', 'temperatura', 275.0000, 'ºC'),
	(15785, 109, '2015-01-15 01:22:37.000000', 'temperatura', 303.0000, 'ºC'),
	(15786, 109, '2015-01-15 01:22:38.000000', 'temperatura', 690.0000, 'ºC'),
	(15787, 109, '2015-01-15 01:22:39.000000', 'temperatura', 144.0000, 'ºC'),
	(15788, 109, '2015-01-15 01:22:40.000000', 'temperatura', 1050.0000, 'ºC'),
	(15789, 109, '2015-01-15 01:22:41.000000', 'temperatura', 19.0000, 'ºC'),
	(15790, 109, '2015-01-15 01:22:42.000000', 'temperatura', 544.0000, 'ºC'),
	(15791, 109, '2015-01-15 01:22:43.000000', 'temperatura', 262.0000, 'ºC'),
	(15792, 109, '2015-01-15 01:22:44.000000', 'temperatura', 880.0000, 'ºC'),
	(15793, 109, '2015-01-15 01:22:45.000000', 'temperatura', 14.0000, 'ºC'),
	(15794, 109, '2015-01-15 01:22:46.000000', 'temperatura', 1032.0000, 'ºC'),
	(15795, 109, '2015-01-15 01:22:47.000000', 'temperatura', 316.0000, 'ºC'),
	(15796, 109, '2015-01-15 01:22:48.000000', 'temperatura', 886.0000, 'ºC'),
	(15797, 109, '2015-01-15 01:22:49.000000', 'temperatura', 1082.0000, 'ºC'),
	(15798, 109, '2015-01-15 01:22:50.000000', 'temperatura', 354.0000, 'ºC'),
	(15799, 109, '2015-01-15 01:22:51.000000', 'temperatura', 922.0000, 'ºC'),
	(15800, 109, '2015-01-15 01:22:52.000000', 'temperatura', 1151.0000, 'ºC'),
	(15801, 109, '2015-01-15 01:22:53.000000', 'temperatura', 586.0000, 'ºC'),
	(15802, 109, '2015-01-15 01:22:54.000000', 'temperatura', 681.0000, 'ºC'),
	(15803, 109, '2015-01-15 01:22:55.000000', 'temperatura', 447.0000, 'ºC'),
	(15804, 109, '2015-01-15 01:22:56.000000', 'temperatura', 193.0000, 'ºC'),
	(15805, 109, '2015-01-15 01:22:57.000000', 'temperatura', 825.0000, 'ºC'),
	(15806, 109, '2015-01-15 01:22:58.000000', 'temperatura', 1144.0000, 'ºC'),
	(15807, 109, '2015-01-15 01:22:59.000000', 'temperatura', 848.0000, 'ºC'),
	(15808, 109, '2015-01-15 01:23:00.000000', 'temperatura', 808.0000, 'ºC'),
	(15809, 109, '2015-01-15 01:23:01.000000', 'temperatura', 295.0000, 'ºC'),
	(15810, 109, '2015-01-15 01:23:02.000000', 'temperatura', 253.0000, 'ºC'),
	(15811, 109, '2015-01-15 01:23:03.000000', 'temperatura', 381.0000, 'ºC'),
	(15812, 109, '2015-01-15 01:23:04.000000', 'temperatura', 1147.0000, 'ºC'),
	(15813, 109, '2015-01-15 01:23:05.000000', 'temperatura', 992.0000, 'ºC'),
	(15814, 109, '2015-01-15 01:23:06.000000', 'temperatura', 320.0000, 'ºC'),
	(15815, 109, '2015-01-15 01:23:07.000000', 'temperatura', 1022.0000, 'ºC'),
	(15816, 109, '2015-01-15 01:23:08.000000', 'temperatura', 552.0000, 'ºC'),
	(15817, 109, '2015-01-15 01:23:09.000000', 'temperatura', 896.0000, 'ºC'),
	(15818, 109, '2015-01-15 01:23:10.000000', 'temperatura', 421.0000, 'ºC'),
	(15819, 109, '2015-01-15 01:23:11.000000', 'temperatura', 621.0000, 'ºC'),
	(15820, 109, '2015-01-15 01:23:12.000000', 'temperatura', 640.0000, 'ºC'),
	(15821, 109, '2015-01-15 01:23:13.000000', 'temperatura', 138.0000, 'ºC'),
	(15822, 109, '2015-01-15 01:23:14.000000', 'temperatura', 1169.0000, 'ºC'),
	(15823, 109, '2015-01-15 01:23:15.000000', 'temperatura', 632.0000, 'ºC'),
	(15824, 109, '2015-01-15 01:23:16.000000', 'temperatura', 855.0000, 'ºC'),
	(15825, 109, '2015-01-15 01:23:17.000000', 'temperatura', 1177.0000, 'ºC'),
	(15826, 109, '2015-01-15 01:23:18.000000', 'temperatura', 923.0000, 'ºC'),
	(15827, 109, '2015-01-15 01:23:19.000000', 'temperatura', 1082.0000, 'ºC'),
	(15828, 109, '2015-01-15 01:23:20.000000', 'temperatura', 244.0000, 'ºC'),
	(15829, 109, '2015-01-15 01:23:21.000000', 'temperatura', 374.0000, 'ºC'),
	(15830, 109, '2015-01-15 01:23:22.000000', 'temperatura', 1139.0000, 'ºC'),
	(15831, 109, '2015-01-15 01:23:23.000000', 'temperatura', 973.0000, 'ºC'),
	(15832, 109, '2015-01-15 01:23:24.000000', 'temperatura', 246.0000, 'ºC'),
	(15833, 109, '2015-01-15 01:23:25.000000', 'temperatura', 715.0000, 'ºC'),
	(15834, 109, '2015-01-15 01:23:26.000000', 'temperatura', 437.0000, 'ºC'),
	(15835, 109, '2015-01-15 01:23:27.000000', 'temperatura', 41.0000, 'ºC'),
	(15836, 109, '2015-01-15 01:23:28.000000', 'temperatura', 94.0000, 'ºC'),
	(15837, 109, '2015-01-15 01:23:29.000000', 'temperatura', 346.0000, 'ºC'),
	(15838, 109, '2015-01-15 01:23:30.000000', 'temperatura', 250.0000, 'ºC'),
	(15839, 109, '2015-01-15 01:23:31.000000', 'temperatura', 212.0000, 'ºC'),
	(15840, 109, '2015-01-15 01:23:32.000000', 'temperatura', 310.0000, 'ºC'),
	(15841, 109, '2015-01-15 01:23:33.000000', 'temperatura', 916.0000, 'ºC'),
	(15842, 109, '2015-01-15 01:23:34.000000', 'temperatura', 48.0000, 'ºC'),
	(15843, 109, '2015-01-15 01:23:35.000000', 'temperatura', 1095.0000, 'ºC'),
	(15844, 109, '2015-01-15 01:23:36.000000', 'temperatura', 528.0000, 'ºC'),
	(15845, 109, '2015-01-15 01:23:37.000000', 'temperatura', 559.0000, 'ºC'),
	(15846, 109, '2015-01-15 01:23:38.000000', 'temperatura', 11.0000, 'ºC'),
	(15847, 109, '2015-01-15 01:23:39.000000', 'temperatura', 780.0000, 'ºC'),
	(15848, 109, '2015-01-15 01:23:40.000000', 'temperatura', 265.0000, 'ºC'),
	(15849, 109, '2015-01-15 01:23:41.000000', 'temperatura', 188.0000, 'ºC'),
	(15850, 109, '2015-01-15 01:23:42.000000', 'temperatura', 144.0000, 'ºC'),
	(15851, 109, '2015-01-15 01:23:43.000000', 'temperatura', 159.0000, 'ºC'),
	(15852, 109, '2015-01-15 01:23:44.000000', 'temperatura', 360.0000, 'ºC'),
	(15853, 109, '2015-01-15 01:23:45.000000', 'temperatura', 127.0000, 'ºC'),
	(15854, 109, '2015-01-15 01:23:46.000000', 'temperatura', 753.0000, 'ºC'),
	(15855, 109, '2015-01-15 01:23:47.000000', 'temperatura', 985.0000, 'ºC'),
	(15856, 109, '2015-01-15 01:23:48.000000', 'temperatura', 268.0000, 'ºC'),
	(15857, 109, '2015-01-15 01:23:49.000000', 'temperatura', 786.0000, 'ºC'),
	(15858, 109, '2015-01-15 01:23:50.000000', 'temperatura', 725.0000, 'ºC'),
	(15859, 109, '2015-01-15 01:23:51.000000', 'temperatura', 70.0000, 'ºC'),
	(15860, 109, '2015-01-15 01:23:52.000000', 'temperatura', 572.0000, 'ºC'),
	(15861, 109, '2015-01-15 01:23:53.000000', 'temperatura', 252.0000, 'ºC'),
	(15862, 109, '2015-01-15 01:23:54.000000', 'temperatura', 743.0000, 'ºC'),
	(15863, 109, '2015-01-15 01:23:55.000000', 'temperatura', 563.0000, 'ºC'),
	(15864, 109, '2015-01-15 01:23:56.000000', 'temperatura', 583.0000, 'ºC'),
	(15865, 109, '2015-01-15 01:23:57.000000', 'temperatura', 28.0000, 'ºC'),
	(15866, 109, '2015-01-15 01:23:58.000000', 'temperatura', 790.0000, 'ºC'),
	(15867, 109, '2015-01-15 01:23:59.000000', 'temperatura', 267.0000, 'ºC'),
	(15868, 109, '2015-01-15 01:24:00.000000', 'temperatura', 168.0000, 'ºC'),
	(15869, 109, '2015-01-15 01:24:01.000000', 'temperatura', 36.0000, 'ºC'),
	(15870, 109, '2015-01-15 01:24:02.000000', 'temperatura', 877.0000, 'ºC'),
	(15871, 109, '2015-01-15 01:24:03.000000', 'temperatura', 679.0000, 'ºC'),
	(15872, 109, '2015-01-15 01:24:04.000000', 'temperatura', 762.0000, 'ºC'),
	(15873, 109, '2015-01-15 01:24:05.000000', 'temperatura', 574.0000, 'ºC'),
	(15874, 109, '2015-01-15 01:24:06.000000', 'temperatura', 584.0000, 'ºC'),
	(15875, 109, '2015-01-15 01:24:07.000000', 'temperatura', 1.0000, 'ºC'),
	(15876, 109, '2015-01-15 01:24:08.000000', 'temperatura', 654.0000, 'ºC'),
	(15877, 109, '2015-01-15 01:24:09.000000', 'temperatura', 865.0000, 'ºC'),
	(15878, 109, '2015-01-15 01:24:10.000000', 'temperatura', 1163.0000, 'ºC'),
	(15879, 109, '2015-01-15 01:24:11.000000', 'temperatura', 820.0000, 'ºC'),
	(15880, 109, '2015-01-15 01:24:12.000000', 'temperatura', 612.0000, 'ºC'),
	(15881, 109, '2015-01-15 01:24:13.000000', 'temperatura', 601.0000, 'ºC'),
	(15882, 109, '2015-01-15 01:24:14.000000', 'temperatura', 1171.0000, 'ºC'),
	(15883, 109, '2015-01-15 01:24:15.000000', 'temperatura', 450.0000, 'ºC'),
	(15884, 109, '2015-01-15 01:24:16.000000', 'temperatura', 1139.0000, 'ºC'),
	(15885, 109, '2015-01-15 01:24:17.000000', 'temperatura', 746.0000, 'ºC'),
	(15886, 109, '2015-01-15 01:24:18.000000', 'temperatura', 312.0000, 'ºC'),
	(15887, 109, '2015-01-15 01:24:19.000000', 'temperatura', 522.0000, 'ºC'),
	(15888, 109, '2015-01-15 01:24:20.000000', 'temperatura', 476.0000, 'ºC'),
	(15889, 109, '2015-01-15 01:24:21.000000', 'temperatura', 813.0000, 'ºC'),
	(15890, 109, '2015-01-15 01:24:22.000000', 'temperatura', 238.0000, 'ºC'),
	(15891, 109, '2015-01-15 01:24:23.000000', 'temperatura', 1150.0000, 'ºC'),
	(15892, 109, '2015-01-15 01:24:24.000000', 'temperatura', 237.0000, 'ºC'),
	(15893, 109, '2015-01-15 01:24:25.000000', 'temperatura', 134.0000, 'ºC'),
	(15894, 109, '2015-01-15 01:24:26.000000', 'temperatura', 1162.0000, 'ºC'),
	(15895, 109, '2015-01-15 01:24:27.000000', 'temperatura', 610.0000, 'ºC'),
	(15896, 109, '2015-01-15 01:24:28.000000', 'temperatura', 762.0000, 'ºC'),
	(15897, 109, '2015-01-15 01:24:29.000000', 'temperatura', 780.0000, 'ºC'),
	(15898, 109, '2015-01-15 01:24:30.000000', 'temperatura', 416.0000, 'ºC'),
	(15899, 109, '2015-01-15 01:24:31.000000', 'temperatura', 940.0000, 'ºC'),
	(15900, 109, '2015-01-15 01:24:32.000000', 'temperatura', 1052.0000, 'ºC'),
	(15901, 109, '2015-01-15 01:24:33.000000', 'temperatura', 39.0000, 'ºC'),
	(15902, 109, '2015-01-15 01:24:34.000000', 'temperatura', 640.0000, 'ºC'),
	(15903, 109, '2015-01-15 01:24:35.000000', 'temperatura', 684.0000, 'ºC'),
	(15904, 109, '2015-01-15 01:24:36.000000', 'temperatura', 302.0000, 'ºC'),
	(15905, 109, '2015-01-15 01:24:37.000000', 'temperatura', 660.0000, 'ºC'),
	(15906, 109, '2015-01-15 01:24:38.000000', 'temperatura', 1191.0000, 'ºC'),
	(15907, 109, '2015-01-15 01:24:39.000000', 'temperatura', 376.0000, 'ºC'),
	(15908, 109, '2015-01-15 01:24:40.000000', 'temperatura', 709.0000, 'ºC'),
	(15909, 109, '2015-01-15 01:24:41.000000', 'temperatura', 15.0000, 'ºC'),
	(15910, 109, '2015-01-15 01:24:42.000000', 'temperatura', 349.0000, 'ºC'),
	(15911, 109, '2015-01-15 01:24:43.000000', 'temperatura', 500.0000, 'ºC'),
	(15912, 109, '2015-01-15 01:24:44.000000', 'temperatura', 255.0000, 'ºC'),
	(15913, 109, '2015-01-15 01:24:45.000000', 'temperatura', 973.0000, 'ºC'),
	(15914, 109, '2015-01-15 01:24:46.000000', 'temperatura', 504.0000, 'ºC'),
	(15915, 109, '2015-01-15 01:24:47.000000', 'temperatura', 799.0000, 'ºC'),
	(15916, 109, '2015-01-15 01:24:48.000000', 'temperatura', 85.0000, 'ºC'),
	(15917, 109, '2015-01-15 01:24:49.000000', 'temperatura', 428.0000, 'ºC'),
	(15918, 109, '2015-01-15 01:24:50.000000', 'temperatura', 684.0000, 'ºC'),
	(15919, 109, '2015-01-15 01:24:51.000000', 'temperatura', 938.0000, 'ºC'),
	(15920, 109, '2015-01-15 01:24:52.000000', 'temperatura', 236.0000, 'ºC'),
	(15921, 109, '2015-01-15 01:24:53.000000', 'temperatura', 769.0000, 'ºC'),
	(15922, 109, '2015-01-15 01:24:54.000000', 'temperatura', 736.0000, 'ºC'),
	(15923, 109, '2015-01-15 01:24:55.000000', 'temperatura', 175.0000, 'ºC'),
	(15924, 109, '2015-01-15 01:24:56.000000', 'temperatura', 1067.0000, 'ºC'),
	(15925, 109, '2015-01-15 01:24:57.000000', 'temperatura', 10.0000, 'ºC'),
	(15926, 109, '2015-01-15 01:24:58.000000', 'temperatura', 450.0000, 'ºC'),
	(15927, 109, '2015-01-15 01:24:59.000000', 'temperatura', 1020.0000, 'ºC'),
	(15928, 109, '2015-01-15 01:25:00.000000', 'temperatura', 150.0000, 'ºC'),
	(15929, 109, '2015-01-15 01:25:01.000000', 'temperatura', 89.0000, 'ºC'),
	(15930, 109, '2015-01-15 01:25:02.000000', 'temperatura', 1197.0000, 'ºC'),
	(15931, 109, '2015-01-15 01:25:03.000000', 'temperatura', 918.0000, 'ºC'),
	(15932, 109, '2015-01-15 01:25:04.000000', 'temperatura', 1000.0000, 'ºC'),
	(15933, 109, '2015-01-15 01:25:05.000000', 'temperatura', 1045.0000, 'ºC'),
	(15934, 109, '2015-01-15 01:25:06.000000', 'temperatura', 1026.0000, 'ºC'),
	(15935, 109, '2015-01-15 01:25:07.000000', 'temperatura', 797.0000, 'ºC'),
	(15936, 109, '2015-01-15 01:25:08.000000', 'temperatura', 905.0000, 'ºC'),
	(15937, 109, '2015-01-15 01:25:09.000000', 'temperatura', 936.0000, 'ºC'),
	(15938, 109, '2015-01-15 01:25:10.000000', 'temperatura', 765.0000, 'ºC'),
	(15939, 109, '2015-01-15 01:25:11.000000', 'temperatura', 1016.0000, 'ºC'),
	(15940, 109, '2015-01-15 01:25:12.000000', 'temperatura', 386.0000, 'ºC'),
	(15941, 109, '2015-01-15 01:25:13.000000', 'temperatura', 85.0000, 'ºC'),
	(15942, 109, '2015-01-15 01:25:14.000000', 'temperatura', 464.0000, 'ºC'),
	(15943, 109, '2015-01-15 01:25:15.000000', 'temperatura', 868.0000, 'ºC'),
	(15944, 109, '2015-01-15 01:25:16.000000', 'temperatura', 547.0000, 'ºC'),
	(15945, 109, '2015-01-15 01:25:17.000000', 'temperatura', 130.0000, 'ºC'),
	(15946, 109, '2015-01-15 01:25:18.000000', 'temperatura', 212.0000, 'ºC'),
	(15947, 109, '2015-01-15 01:25:19.000000', 'temperatura', 670.0000, 'ºC'),
	(15948, 109, '2015-01-15 01:25:20.000000', 'temperatura', 315.0000, 'ºC'),
	(15949, 109, '2015-01-15 01:25:21.000000', 'temperatura', 765.0000, 'ºC'),
	(15950, 109, '2015-01-15 01:25:22.000000', 'temperatura', 482.0000, 'ºC'),
	(15951, 109, '2015-01-15 01:25:23.000000', 'temperatura', 116.0000, 'ºC'),
	(15952, 109, '2015-01-15 01:25:24.000000', 'temperatura', 335.0000, 'ºC'),
	(15953, 109, '2015-01-15 01:25:25.000000', 'temperatura', 128.0000, 'ºC'),
	(15954, 109, '2015-01-15 01:25:26.000000', 'temperatura', 835.0000, 'ºC'),
	(15955, 109, '2015-01-15 01:25:27.000000', 'temperatura', 192.0000, 'ºC'),
	(15956, 109, '2015-01-15 01:25:28.000000', 'temperatura', 855.0000, 'ºC'),
	(15957, 109, '2015-01-15 01:25:29.000000', 'temperatura', 99.0000, 'ºC'),
	(15958, 109, '2015-01-15 01:25:30.000000', 'temperatura', 332.0000, 'ºC'),
	(15959, 109, '2015-01-15 01:25:31.000000', 'temperatura', 162.0000, 'ºC'),
	(15960, 109, '2015-01-15 01:25:32.000000', 'temperatura', 1016.0000, 'ºC'),
	(15961, 109, '2015-01-15 01:25:33.000000', 'temperatura', 992.0000, 'ºC'),
	(15962, 109, '2015-01-15 01:25:34.000000', 'temperatura', 712.0000, 'ºC'),
	(15963, 109, '2015-01-15 01:25:35.000000', 'temperatura', 587.0000, 'ºC'),
	(15964, 109, '2015-01-15 01:25:36.000000', 'temperatura', 797.0000, 'ºC'),
	(15965, 109, '2015-01-15 01:25:37.000000', 'temperatura', 1027.0000, 'ºC'),
	(15966, 109, '2015-01-15 01:25:38.000000', 'temperatura', 343.0000, 'ºC'),
	(15967, 109, '2015-01-15 01:25:39.000000', 'temperatura', 1034.0000, 'ºC'),
	(15968, 109, '2015-01-15 01:25:40.000000', 'temperatura', 543.0000, 'ºC'),
	(15969, 109, '2015-01-15 01:25:41.000000', 'temperatura', 814.0000, 'ºC'),
	(15970, 109, '2015-01-15 01:25:42.000000', 'temperatura', 39.0000, 'ºC'),
	(15971, 109, '2015-01-15 01:25:43.000000', 'temperatura', 157.0000, 'ºC'),
	(15972, 109, '2015-01-15 01:25:44.000000', 'temperatura', 666.0000, 'ºC'),
	(15973, 109, '2015-01-15 01:25:45.000000', 'temperatura', 459.0000, 'ºC'),
	(15974, 109, '2015-01-15 01:25:46.000000', 'temperatura', 300.0000, 'ºC'),
	(15975, 109, '2015-01-15 01:25:47.000000', 'temperatura', 124.0000, 'ºC'),
	(15976, 109, '2015-01-15 01:25:48.000000', 'temperatura', 917.0000, 'ºC'),
	(15977, 109, '2015-01-15 01:25:49.000000', 'temperatura', 616.0000, 'ºC'),
	(15978, 109, '2015-01-15 01:25:50.000000', 'temperatura', 330.0000, 'ºC'),
	(15979, 109, '2015-01-15 01:25:51.000000', 'temperatura', 1001.0000, 'ºC'),
	(15980, 109, '2015-01-15 01:25:52.000000', 'temperatura', 415.0000, 'ºC'),
	(15981, 109, '2015-01-15 01:25:53.000000', 'temperatura', 275.0000, 'ºC'),
	(15982, 109, '2015-01-15 01:25:54.000000', 'temperatura', 130.0000, 'ºC'),
	(15983, 109, '2015-01-15 01:25:55.000000', 'temperatura', 1025.0000, 'ºC'),
	(15984, 109, '2015-01-15 01:25:56.000000', 'temperatura', 1137.0000, 'ºC'),
	(15985, 109, '2015-01-15 01:25:57.000000', 'temperatura', 208.0000, 'ºC'),
	(15986, 109, '2015-01-15 01:25:58.000000', 'temperatura', 32.0000, 'ºC'),
	(15987, 109, '2015-01-15 01:25:59.000000', 'temperatura', 735.0000, 'ºC'),
	(15988, 109, '2015-01-15 01:26:00.000000', 'temperatura', 1182.0000, 'ºC'),
	(15989, 109, '2015-01-15 01:26:01.000000', 'temperatura', 103.0000, 'ºC'),
	(15990, 109, '2015-01-15 01:26:02.000000', 'temperatura', 570.0000, 'ºC'),
	(15991, 109, '2015-01-15 01:26:03.000000', 'temperatura', 142.0000, 'ºC'),
	(15992, 109, '2015-01-15 01:26:04.000000', 'temperatura', 201.0000, 'ºC'),
	(15993, 109, '2015-01-15 01:26:05.000000', 'temperatura', 578.0000, 'ºC'),
	(15994, 109, '2015-01-15 01:26:06.000000', 'temperatura', 1087.0000, 'ºC'),
	(15995, 109, '2015-01-15 01:26:07.000000', 'temperatura', 102.0000, 'ºC'),
	(15996, 109, '2015-01-15 01:26:08.000000', 'temperatura', 851.0000, 'ºC'),
	(15997, 109, '2015-01-15 01:26:09.000000', 'temperatura', 349.0000, 'ºC'),
	(15998, 109, '2015-01-15 01:26:10.000000', 'temperatura', 394.0000, 'ºC'),
	(15999, 109, '2015-01-15 01:26:11.000000', 'temperatura', 923.0000, 'ºC'),
	(16000, 109, '2015-01-15 01:26:12.000000', 'temperatura', 1032.0000, 'ºC'),
	(16001, 109, '2015-01-15 01:26:13.000000', 'temperatura', 1192.0000, 'ºC'),
	(16002, 109, '2015-01-15 01:26:14.000000', 'temperatura', 463.0000, 'ºC'),
	(16003, 109, '2015-01-15 01:26:15.000000', 'temperatura', 1140.0000, 'ºC'),
	(16004, 109, '2015-01-15 01:26:16.000000', 'temperatura', 713.0000, 'ºC'),
	(16005, 109, '2015-01-15 01:26:17.000000', 'temperatura', 145.0000, 'ºC'),
	(16006, 109, '2015-01-15 01:26:18.000000', 'temperatura', 986.0000, 'ºC'),
	(16007, 109, '2015-01-15 01:26:19.000000', 'temperatura', 894.0000, 'ºC'),
	(16008, 109, '2015-01-15 01:26:20.000000', 'temperatura', 313.0000, 'ºC'),
	(16009, 109, '2015-01-15 01:26:21.000000', 'temperatura', 85.0000, 'ºC'),
	(16010, 109, '2015-01-15 01:26:22.000000', 'temperatura', 685.0000, 'ºC'),
	(16011, 109, '2015-01-15 01:26:23.000000', 'temperatura', 770.0000, 'ºC'),
	(16012, 109, '2015-01-15 01:26:24.000000', 'temperatura', 595.0000, 'ºC'),
	(16013, 109, '2015-01-15 01:26:25.000000', 'temperatura', 668.0000, 'ºC'),
	(16014, 109, '2015-01-15 01:26:26.000000', 'temperatura', 354.0000, 'ºC'),
	(16015, 109, '2015-01-15 01:26:27.000000', 'temperatura', 968.0000, 'ºC'),
	(16016, 109, '2015-01-15 01:26:28.000000', 'temperatura', 179.0000, 'ºC'),
	(16017, 109, '2015-01-15 01:26:29.000000', 'temperatura', 389.0000, 'ºC'),
	(16018, 109, '2015-01-15 01:26:30.000000', 'temperatura', 208.0000, 'ºC'),
	(16019, 109, '2015-01-15 01:26:31.000000', 'temperatura', 1074.0000, 'ºC'),
	(16020, 109, '2015-01-15 01:26:32.000000', 'temperatura', 1147.0000, 'ºC'),
	(16021, 109, '2015-01-15 01:26:33.000000', 'temperatura', 115.0000, 'ºC'),
	(16022, 109, '2015-01-15 01:26:34.000000', 'temperatura', 731.0000, 'ºC'),
	(16023, 109, '2015-01-15 01:26:35.000000', 'temperatura', 913.0000, 'ºC'),
	(16024, 109, '2015-01-15 01:26:36.000000', 'temperatura', 1174.0000, 'ºC'),
	(16025, 109, '2015-01-15 01:26:37.000000', 'temperatura', 730.0000, 'ºC'),
	(16026, 109, '2015-01-15 01:26:38.000000', 'temperatura', 130.0000, 'ºC'),
	(16027, 109, '2015-01-15 01:26:39.000000', 'temperatura', 861.0000, 'ºC'),
	(16028, 109, '2015-01-15 01:26:40.000000', 'temperatura', 312.0000, 'ºC'),
	(16029, 109, '2015-01-15 01:26:41.000000', 'temperatura', 181.0000, 'ºC'),
	(16030, 109, '2015-01-15 01:26:42.000000', 'temperatura', 1169.0000, 'ºC'),
	(16031, 109, '2015-01-15 01:26:43.000000', 'temperatura', 500.0000, 'ºC'),
	(16032, 109, '2015-01-15 01:26:44.000000', 'temperatura', 196.0000, 'ºC'),
	(16033, 109, '2015-01-15 01:26:45.000000', 'temperatura', 679.0000, 'ºC'),
	(16034, 109, '2015-01-15 01:26:46.000000', 'temperatura', 406.0000, 'ºC'),
	(16035, 109, '2015-01-15 01:26:47.000000', 'temperatura', 1195.0000, 'ºC'),
	(16036, 109, '2015-01-15 01:26:48.000000', 'temperatura', 1156.0000, 'ºC'),
	(16037, 109, '2015-01-15 01:26:49.000000', 'temperatura', 995.0000, 'ºC'),
	(16038, 109, '2015-01-15 01:26:50.000000', 'temperatura', 308.0000, 'ºC'),
	(16039, 109, '2015-01-15 01:26:51.000000', 'temperatura', 957.0000, 'ºC'),
	(16040, 109, '2015-01-15 01:26:52.000000', 'temperatura', 261.0000, 'ºC'),
	(16041, 109, '2015-01-15 01:26:53.000000', 'temperatura', 834.0000, 'ºC'),
	(16042, 109, '2015-01-15 01:26:54.000000', 'temperatura', 988.0000, 'ºC'),
	(16043, 109, '2015-01-15 01:26:55.000000', 'temperatura', 39.0000, 'ºC'),
	(16044, 109, '2015-01-15 01:26:56.000000', 'temperatura', 833.0000, 'ºC'),
	(16045, 109, '2015-01-15 01:26:57.000000', 'temperatura', 447.0000, 'ºC'),
	(16046, 109, '2015-01-15 01:26:58.000000', 'temperatura', 937.0000, 'ºC'),
	(16047, 109, '2015-01-15 01:26:59.000000', 'temperatura', 945.0000, 'ºC'),
	(16048, 109, '2015-01-15 01:27:00.000000', 'temperatura', 712.0000, 'ºC'),
	(16049, 109, '2015-01-15 01:27:01.000000', 'temperatura', 727.0000, 'ºC'),
	(16050, 109, '2015-01-15 01:27:02.000000', 'temperatura', 300.0000, 'ºC'),
	(16051, 109, '2015-01-15 01:27:03.000000', 'temperatura', 517.0000, 'ºC'),
	(16052, 109, '2015-01-15 01:27:04.000000', 'temperatura', 487.0000, 'ºC'),
	(16053, 109, '2015-01-15 01:27:05.000000', 'temperatura', 884.0000, 'ºC'),
	(16054, 109, '2015-01-15 01:27:06.000000', 'temperatura', 561.0000, 'ºC'),
	(16055, 109, '2015-01-15 01:27:07.000000', 'temperatura', 154.0000, 'ºC'),
	(16056, 109, '2015-01-15 01:27:08.000000', 'temperatura', 287.0000, 'ºC'),
	(16057, 109, '2015-01-15 01:27:09.000000', 'temperatura', 973.0000, 'ºC'),
	(16058, 109, '2015-01-15 01:27:10.000000', 'temperatura', 403.0000, 'ºC'),
	(16059, 109, '2015-01-15 01:27:11.000000', 'temperatura', 296.0000, 'ºC'),
	(16060, 109, '2015-01-15 01:27:12.000000', 'temperatura', 275.0000, 'ºC'),
	(16061, 109, '2015-01-15 01:27:13.000000', 'temperatura', 484.0000, 'ºC'),
	(16062, 109, '2015-01-15 01:27:14.000000', 'temperatura', 398.0000, 'ºC'),
	(16063, 109, '2015-01-15 01:27:15.000000', 'temperatura', 539.0000, 'ºC'),
	(16064, 109, '2015-01-15 01:27:16.000000', 'temperatura', 301.0000, 'ºC'),
	(16065, 109, '2015-01-15 01:27:17.000000', 'temperatura', 1086.0000, 'ºC'),
	(16066, 109, '2015-01-15 01:27:18.000000', 'temperatura', 930.0000, 'ºC'),
	(16067, 109, '2015-01-15 01:27:19.000000', 'temperatura', 191.0000, 'ºC'),
	(16068, 109, '2015-01-15 01:27:20.000000', 'temperatura', 564.0000, 'ºC'),
	(16069, 109, '2015-01-15 01:27:21.000000', 'temperatura', 1049.0000, 'ºC'),
	(16070, 109, '2015-01-15 01:27:22.000000', 'temperatura', 1155.0000, 'ºC'),
	(16071, 109, '2015-01-15 01:27:23.000000', 'temperatura', 225.0000, 'ºC'),
	(16072, 109, '2015-01-15 01:27:24.000000', 'temperatura', 64.0000, 'ºC'),
	(16073, 109, '2015-01-15 01:27:25.000000', 'temperatura', 843.0000, 'ºC'),
	(16074, 109, '2015-01-15 01:27:26.000000', 'temperatura', 426.0000, 'ºC'),
	(16075, 109, '2015-01-15 01:27:27.000000', 'temperatura', 800.0000, 'ºC'),
	(16076, 109, '2015-01-15 01:27:28.000000', 'temperatura', 322.0000, 'ºC'),
	(16077, 109, '2015-01-15 01:27:29.000000', 'temperatura', 410.0000, 'ºC'),
	(16078, 109, '2015-01-15 01:27:30.000000', 'temperatura', 1086.0000, 'ºC'),
	(16079, 109, '2015-01-15 01:27:31.000000', 'temperatura', 598.0000, 'ºC'),
	(16080, 109, '2015-01-15 01:27:32.000000', 'temperatura', 933.0000, 'ºC'),
	(16081, 109, '2015-01-15 01:27:33.000000', 'temperatura', 473.0000, 'ºC'),
	(16082, 109, '2015-01-15 01:27:34.000000', 'temperatura', 766.0000, 'ºC'),
	(16083, 109, '2015-01-15 01:27:35.000000', 'temperatura', 12.0000, 'ºC'),
	(16084, 109, '2015-01-15 01:27:36.000000', 'temperatura', 164.0000, 'ºC'),
	(16085, 109, '2015-01-15 01:27:37.000000', 'temperatura', 782.0000, 'ºC'),
	(16086, 109, '2015-01-15 01:27:38.000000', 'temperatura', 1019.0000, 'ºC'),
	(16087, 109, '2015-01-15 01:27:39.000000', 'temperatura', 349.0000, 'ºC'),
	(16088, 109, '2015-01-15 01:27:40.000000', 'temperatura', 1088.0000, 'ºC'),
	(16089, 109, '2015-01-15 01:27:41.000000', 'temperatura', 796.0000, 'ºC'),
	(16090, 109, '2015-01-15 01:27:42.000000', 'temperatura', 715.0000, 'ºC'),
	(16091, 109, '2015-01-15 01:27:43.000000', 'temperatura', 1186.0000, 'ºC'),
	(16092, 109, '2015-01-15 01:27:44.000000', 'temperatura', 187.0000, 'ºC'),
	(16093, 109, '2015-01-15 01:27:45.000000', 'temperatura', 977.0000, 'ºC'),
	(16094, 109, '2015-01-15 01:27:46.000000', 'temperatura', 724.0000, 'ºC'),
	(16095, 109, '2015-01-15 01:27:47.000000', 'temperatura', 688.0000, 'ºC'),
	(16096, 109, '2015-01-15 01:27:48.000000', 'temperatura', 72.0000, 'ºC'),
	(16097, 109, '2015-01-15 01:27:49.000000', 'temperatura', 693.0000, 'ºC'),
	(16098, 109, '2015-01-15 01:27:50.000000', 'temperatura', 852.0000, 'ºC'),
	(16099, 109, '2015-01-15 01:27:51.000000', 'temperatura', 982.0000, 'ºC'),
	(16100, 109, '2015-01-15 01:27:52.000000', 'temperatura', 1153.0000, 'ºC'),
	(16101, 109, '2015-01-15 01:27:53.000000', 'temperatura', 419.0000, 'ºC'),
	(16102, 109, '2015-01-15 01:27:54.000000', 'temperatura', 1036.0000, 'ºC'),
	(16103, 109, '2015-01-15 01:27:55.000000', 'temperatura', 324.0000, 'ºC'),
	(16104, 109, '2015-01-15 01:27:56.000000', 'temperatura', 914.0000, 'ºC'),
	(16105, 109, '2015-01-15 01:27:57.000000', 'temperatura', 1199.0000, 'ºC'),
	(16106, 109, '2015-01-15 01:27:58.000000', 'temperatura', 852.0000, 'ºC'),
	(16107, 109, '2015-01-15 01:27:59.000000', 'temperatura', 662.0000, 'ºC'),
	(16108, 109, '2015-01-15 01:28:00.000000', 'temperatura', 757.0000, 'ºC'),
	(16109, 109, '2015-01-15 01:28:01.000000', 'temperatura', 597.0000, 'ºC'),
	(16110, 109, '2015-01-15 01:28:02.000000', 'temperatura', 717.0000, 'ºC'),
	(16111, 109, '2015-01-15 01:28:03.000000', 'temperatura', 592.0000, 'ºC'),
	(16112, 109, '2015-01-15 01:28:04.000000', 'temperatura', 812.0000, 'ºC'),
	(16113, 109, '2015-01-15 01:28:05.000000', 'temperatura', 1084.0000, 'ºC'),
	(16114, 109, '2015-01-15 01:28:06.000000', 'temperatura', 586.0000, 'ºC'),
	(16115, 109, '2015-01-15 01:28:07.000000', 'temperatura', 875.0000, 'ºC'),
	(16116, 109, '2015-01-15 01:28:08.000000', 'temperatura', 221.0000, 'ºC'),
	(16117, 109, '2015-01-15 01:28:09.000000', 'temperatura', 879.0000, 'ºC'),
	(16118, 109, '2015-01-15 01:28:10.000000', 'temperatura', 131.0000, 'ºC'),
	(16119, 109, '2015-01-15 01:28:11.000000', 'temperatura', 419.0000, 'ºC'),
	(16120, 109, '2015-01-15 01:28:12.000000', 'temperatura', 503.0000, 'ºC'),
	(16121, 109, '2015-01-15 01:28:13.000000', 'temperatura', 60.0000, 'ºC'),
	(16122, 109, '2015-01-15 01:28:14.000000', 'temperatura', 1191.0000, 'ºC'),
	(16123, 109, '2015-01-15 01:28:15.000000', 'temperatura', 973.0000, 'ºC'),
	(16124, 109, '2015-01-15 01:28:16.000000', 'temperatura', 95.0000, 'ºC'),
	(16125, 109, '2015-01-15 01:28:17.000000', 'temperatura', 1156.0000, 'ºC'),
	(16126, 109, '2015-01-15 01:28:18.000000', 'temperatura', 696.0000, 'ºC'),
	(16127, 109, '2015-01-15 01:28:19.000000', 'temperatura', 11.0000, 'ºC'),
	(16128, 109, '2015-01-15 01:28:20.000000', 'temperatura', 367.0000, 'ºC'),
	(16129, 109, '2015-01-15 01:28:21.000000', 'temperatura', 604.0000, 'ºC'),
	(16130, 109, '2015-01-15 01:28:22.000000', 'temperatura', 721.0000, 'ºC'),
	(16131, 109, '2015-01-15 01:28:23.000000', 'temperatura', 593.0000, 'ºC'),
	(16132, 109, '2015-01-15 01:28:24.000000', 'temperatura', 800.0000, 'ºC'),
	(16133, 109, '2015-01-15 01:28:25.000000', 'temperatura', 1023.0000, 'ºC'),
	(16134, 109, '2015-01-15 01:28:26.000000', 'temperatura', 313.0000, 'ºC'),
	(16135, 109, '2015-01-15 01:28:27.000000', 'temperatura', 900.0000, 'ºC'),
	(16136, 109, '2015-01-15 01:28:28.000000', 'temperatura', 1159.0000, 'ºC'),
	(16137, 109, '2015-01-15 01:28:29.000000', 'temperatura', 695.0000, 'ºC'),
	(16138, 109, '2015-01-15 01:28:30.000000', 'temperatura', 1198.0000, 'ºC'),
	(16139, 109, '2015-01-15 01:28:31.000000', 'temperatura', 305.0000, 'ºC'),
	(16140, 109, '2015-01-15 01:28:32.000000', 'temperatura', 331.0000, 'ºC'),
	(16141, 109, '2015-01-15 01:28:33.000000', 'temperatura', 740.0000, 'ºC'),
	(16142, 109, '2015-01-15 01:28:34.000000', 'temperatura', 307.0000, 'ºC'),
	(16143, 109, '2015-01-15 01:28:35.000000', 'temperatura', 516.0000, 'ºC'),
	(16144, 109, '2015-01-15 01:28:36.000000', 'temperatura', 459.0000, 'ºC'),
	(16145, 109, '2015-01-15 01:28:37.000000', 'temperatura', 747.0000, 'ºC'),
	(16146, 109, '2015-01-15 01:28:38.000000', 'temperatura', 1161.0000, 'ºC'),
	(16147, 109, '2015-01-15 01:28:39.000000', 'temperatura', 1165.0000, 'ºC'),
	(16148, 109, '2015-01-15 01:28:40.000000', 'temperatura', 1141.0000, 'ºC'),
	(16149, 109, '2015-01-15 01:28:41.000000', 'temperatura', 1011.0000, 'ºC'),
	(16150, 109, '2015-01-15 01:28:42.000000', 'temperatura', 431.0000, 'ºC'),
	(16151, 109, '2015-01-15 01:28:43.000000', 'temperatura', 322.0000, 'ºC'),
	(16152, 109, '2015-01-15 01:28:44.000000', 'temperatura', 317.0000, 'ºC'),
	(16153, 109, '2015-01-15 01:28:45.000000', 'temperatura', 620.0000, 'ºC'),
	(16154, 109, '2015-01-15 01:28:46.000000', 'temperatura', 950.0000, 'ºC'),
	(16155, 109, '2015-01-15 01:28:47.000000', 'temperatura', 490.0000, 'ºC'),
	(16156, 109, '2015-01-15 01:28:48.000000', 'temperatura', 800.0000, 'ºC'),
	(16157, 109, '2015-01-15 01:28:49.000000', 'temperatura', 131.0000, 'ºC'),
	(16158, 109, '2015-01-15 01:28:50.000000', 'temperatura', 655.0000, 'ºC'),
	(16159, 109, '2015-01-15 01:28:51.000000', 'temperatura', 484.0000, 'ºC'),
	(16160, 109, '2015-01-15 01:28:52.000000', 'temperatura', 454.0000, 'ºC'),
	(16161, 109, '2015-01-15 01:28:53.000000', 'temperatura', 820.0000, 'ºC'),
	(16162, 109, '2015-01-15 01:28:54.000000', 'temperatura', 336.0000, 'ºC'),
	(16163, 109, '2015-01-15 01:28:55.000000', 'temperatura', 423.0000, 'ºC'),
	(16164, 109, '2015-01-15 01:28:56.000000', 'temperatura', 1107.0000, 'ºC'),
	(16165, 109, '2015-01-15 01:28:57.000000', 'temperatura', 668.0000, 'ºC'),
	(16166, 109, '2015-01-15 01:28:58.000000', 'temperatura', 17.0000, 'ºC'),
	(16167, 109, '2015-01-15 01:28:59.000000', 'temperatura', 481.0000, 'ºC'),
	(16168, 109, '2015-01-15 01:29:00.000000', 'temperatura', 1157.0000, 'ºC'),
	(16169, 109, '2015-01-15 01:29:01.000000', 'temperatura', 740.0000, 'ºC'),
	(16170, 109, '2015-01-15 01:29:02.000000', 'temperatura', 232.0000, 'ºC'),
	(16171, 109, '2015-01-15 01:29:03.000000', 'temperatura', 141.0000, 'ºC'),
	(16172, 109, '2015-01-15 01:29:04.000000', 'temperatura', 10.0000, 'ºC'),
	(16173, 109, '2015-01-15 01:29:05.000000', 'temperatura', 827.0000, 'ºC'),
	(16174, 109, '2015-01-15 01:29:06.000000', 'temperatura', 504.0000, 'ºC'),
	(16175, 109, '2015-01-15 01:29:07.000000', 'temperatura', 42.0000, 'ºC'),
	(16176, 109, '2015-01-15 01:29:08.000000', 'temperatura', 1096.0000, 'ºC'),
	(16177, 109, '2015-01-15 01:29:09.000000', 'temperatura', 556.0000, 'ºC'),
	(16178, 109, '2015-01-15 01:29:10.000000', 'temperatura', 693.0000, 'ºC'),
	(16179, 109, '2015-01-15 01:29:11.000000', 'temperatura', 597.0000, 'ºC'),
	(16180, 109, '2015-01-15 01:29:12.000000', 'temperatura', 907.0000, 'ºC'),
	(16181, 109, '2015-01-15 01:29:13.000000', 'temperatura', 343.0000, 'ºC'),
	(16182, 109, '2015-01-15 01:29:14.000000', 'temperatura', 194.0000, 'ºC'),
	(16183, 109, '2015-01-15 01:29:15.000000', 'temperatura', 1141.0000, 'ºC'),
	(16184, 109, '2015-01-15 01:29:16.000000', 'temperatura', 324.0000, 'ºC'),
	(16185, 109, '2015-01-15 01:29:17.000000', 'temperatura', 597.0000, 'ºC'),
	(16186, 109, '2015-01-15 01:29:18.000000', 'temperatura', 815.0000, 'ºC'),
	(16187, 109, '2015-01-15 01:29:19.000000', 'temperatura', 1082.0000, 'ºC'),
	(16188, 109, '2015-01-15 01:29:20.000000', 'temperatura', 566.0000, 'ºC'),
	(16189, 109, '2015-01-15 01:29:21.000000', 'temperatura', 785.0000, 'ºC'),
	(16190, 109, '2015-01-15 01:29:22.000000', 'temperatura', 1029.0000, 'ºC'),
	(16191, 109, '2015-01-15 01:29:23.000000', 'temperatura', 391.0000, 'ºC'),
	(16192, 109, '2015-01-15 01:29:24.000000', 'temperatura', 67.0000, 'ºC'),
	(16193, 109, '2015-01-15 01:29:25.000000', 'temperatura', 363.0000, 'ºC'),
	(16194, 109, '2015-01-15 01:29:26.000000', 'temperatura', 415.0000, 'ºC'),
	(16195, 109, '2015-01-15 01:29:27.000000', 'temperatura', 987.0000, 'ºC'),
	(16196, 109, '2015-01-15 01:29:28.000000', 'temperatura', 89.0000, 'ºC'),
	(16197, 109, '2015-01-15 01:29:29.000000', 'temperatura', 1086.0000, 'ºC'),
	(16198, 109, '2015-01-15 01:29:30.000000', 'temperatura', 363.0000, 'ºC'),
	(16199, 109, '2015-01-15 01:29:31.000000', 'temperatura', 959.0000, 'ºC'),
	(16200, 109, '2015-01-15 01:29:32.000000', 'temperatura', 104.0000, 'ºC'),
	(16201, 109, '2015-01-15 01:29:33.000000', 'temperatura', 46.0000, 'ºC'),
	(16202, 109, '2015-01-15 01:29:34.000000', 'temperatura', 1116.0000, 'ºC'),
	(16203, 109, '2015-01-15 01:29:35.000000', 'temperatura', 643.0000, 'ºC'),
	(16204, 109, '2015-01-15 01:29:36.000000', 'temperatura', 1068.0000, 'ºC'),
	(16205, 109, '2015-01-15 01:29:37.000000', 'temperatura', 1013.0000, 'ºC'),
	(16206, 109, '2015-01-15 01:29:38.000000', 'temperatura', 659.0000, 'ºC'),
	(16207, 109, '2015-01-15 01:29:39.000000', 'temperatura', 257.0000, 'ºC'),
	(16208, 109, '2015-01-15 01:29:40.000000', 'temperatura', 510.0000, 'ºC'),
	(16209, 109, '2015-01-15 01:29:41.000000', 'temperatura', 578.0000, 'ºC'),
	(16210, 109, '2015-01-15 01:29:42.000000', 'temperatura', 163.0000, 'ºC'),
	(16211, 109, '2015-01-15 01:29:43.000000', 'temperatura', 279.0000, 'ºC'),
	(16212, 109, '2015-01-15 01:29:44.000000', 'temperatura', 908.0000, 'ºC'),
	(16213, 109, '2015-01-15 01:29:45.000000', 'temperatura', 102.0000, 'ºC'),
	(16214, 109, '2015-01-15 01:29:46.000000', 'temperatura', 187.0000, 'ºC'),
	(16215, 109, '2015-01-15 01:29:47.000000', 'temperatura', 630.0000, 'ºC'),
	(16216, 109, '2015-01-15 01:29:48.000000', 'temperatura', 187.0000, 'ºC'),
	(16217, 109, '2015-01-15 01:29:49.000000', 'temperatura', 249.0000, 'ºC'),
	(16218, 109, '2015-01-15 01:29:50.000000', 'temperatura', 684.0000, 'ºC'),
	(16219, 109, '2015-01-15 01:29:51.000000', 'temperatura', 271.0000, 'ºC'),
	(16220, 109, '2015-01-15 01:29:52.000000', 'temperatura', 506.0000, 'ºC'),
	(16221, 109, '2015-01-15 01:29:53.000000', 'temperatura', 518.0000, 'ºC'),
	(16222, 109, '2015-01-15 01:29:54.000000', 'temperatura', 1070.0000, 'ºC'),
	(16223, 109, '2015-01-15 01:29:55.000000', 'temperatura', 196.0000, 'ºC'),
	(16224, 109, '2015-01-15 01:29:56.000000', 'temperatura', 173.0000, 'ºC'),
	(16225, 109, '2015-01-15 01:29:57.000000', 'temperatura', 276.0000, 'ºC'),
	(16226, 109, '2015-01-15 01:29:58.000000', 'temperatura', 861.0000, 'ºC'),
	(16227, 109, '2015-01-15 01:29:59.000000', 'temperatura', 1080.0000, 'ºC'),
	(16228, 109, '2015-01-15 01:30:00.000000', 'temperatura', 416.0000, 'ºC'),
	(16229, 109, '2015-01-15 01:30:01.000000', 'temperatura', 41.0000, 'ºC'),
	(16230, 109, '2015-01-15 01:30:02.000000', 'temperatura', 156.0000, 'ºC'),
	(16231, 109, '2015-01-15 01:30:03.000000', 'temperatura', 660.0000, 'ºC'),
	(16232, 109, '2015-01-15 01:30:04.000000', 'temperatura', 433.0000, 'ºC'),
	(16233, 109, '2015-01-15 01:30:05.000000', 'temperatura', 186.0000, 'ºC'),
	(16234, 109, '2015-01-15 01:30:06.000000', 'temperatura', 831.0000, 'ºC'),
	(16235, 109, '2015-01-15 01:30:07.000000', 'temperatura', 1198.0000, 'ºC'),
	(16236, 109, '2015-01-15 01:30:08.000000', 'temperatura', 1098.0000, 'ºC'),
	(16237, 109, '2015-01-15 01:30:09.000000', 'temperatura', 697.0000, 'ºC'),
	(16238, 109, '2015-01-15 01:30:10.000000', 'temperatura', 191.0000, 'ºC'),
	(16239, 109, '2015-01-15 01:30:11.000000', 'temperatura', 65.0000, 'ºC'),
	(16240, 109, '2015-01-15 01:30:12.000000', 'temperatura', 950.0000, 'ºC'),
	(16241, 109, '2015-01-15 01:30:13.000000', 'temperatura', 956.0000, 'ºC'),
	(16242, 109, '2015-01-15 01:30:14.000000', 'temperatura', 731.0000, 'ºC'),
	(16243, 109, '2015-01-15 01:30:15.000000', 'temperatura', 790.0000, 'ºC'),
	(16244, 109, '2015-01-15 01:30:16.000000', 'temperatura', 554.0000, 'ºC'),
	(16245, 109, '2015-01-15 01:30:17.000000', 'temperatura', 401.0000, 'ºC'),
	(16246, 109, '2015-01-15 01:30:18.000000', 'temperatura', 343.0000, 'ºC'),
	(16247, 109, '2015-01-15 01:30:19.000000', 'temperatura', 514.0000, 'ºC'),
	(16248, 109, '2015-01-15 01:30:20.000000', 'temperatura', 342.0000, 'ºC'),
	(16249, 109, '2015-01-15 01:30:21.000000', 'temperatura', 167.0000, 'ºC'),
	(16250, 109, '2015-01-15 01:30:22.000000', 'temperatura', 1009.0000, 'ºC'),
	(16251, 109, '2015-01-15 01:30:23.000000', 'temperatura', 944.0000, 'ºC'),
	(16252, 109, '2015-01-15 01:30:24.000000', 'temperatura', 495.0000, 'ºC'),
	(16253, 109, '2015-01-15 01:30:25.000000', 'temperatura', 845.0000, 'ºC'),
	(16254, 109, '2015-01-15 01:30:26.000000', 'temperatura', 339.0000, 'ºC'),
	(16255, 109, '2015-01-15 01:30:27.000000', 'temperatura', 362.0000, 'ºC'),
	(16256, 109, '2015-01-15 01:30:28.000000', 'temperatura', 791.0000, 'ºC'),
	(16257, 109, '2015-01-15 01:30:29.000000', 'temperatura', 472.0000, 'ºC'),
	(16258, 109, '2015-01-15 01:30:30.000000', 'temperatura', 1185.0000, 'ºC'),
	(16259, 109, '2015-01-15 01:30:31.000000', 'temperatura', 911.0000, 'ºC'),
	(16260, 109, '2015-01-15 01:30:32.000000', 'temperatura', 1001.0000, 'ºC'),
	(16261, 109, '2015-01-15 01:30:33.000000', 'temperatura', 1073.0000, 'ºC'),
	(16262, 109, '2015-01-15 01:30:34.000000', 'temperatura', 1162.0000, 'ºC'),
	(16263, 109, '2015-01-15 01:30:35.000000', 'temperatura', 190.0000, 'ºC'),
	(16264, 109, '2015-01-15 01:30:36.000000', 'temperatura', 1067.0000, 'ºC'),
	(16265, 109, '2015-01-15 01:30:37.000000', 'temperatura', 1166.0000, 'ºC'),
	(16266, 109, '2015-01-15 01:30:38.000000', 'temperatura', 227.0000, 'ºC'),
	(16267, 109, '2015-01-15 01:30:39.000000', 'temperatura', 40.0000, 'ºC'),
	(16268, 109, '2015-01-15 01:30:40.000000', 'temperatura', 718.0000, 'ºC'),
	(16269, 109, '2015-01-15 01:30:41.000000', 'temperatura', 1072.0000, 'ºC'),
	(16270, 109, '2015-01-15 01:30:42.000000', 'temperatura', 804.0000, 'ºC'),
	(16271, 109, '2015-01-15 01:30:43.000000', 'temperatura', 805.0000, 'ºC'),
	(16272, 109, '2015-01-15 01:30:44.000000', 'temperatura', 414.0000, 'ºC'),
	(16273, 109, '2015-01-15 01:30:45.000000', 'temperatura', 854.0000, 'ºC'),
	(16274, 109, '2015-01-15 01:30:46.000000', 'temperatura', 628.0000, 'ºC'),
	(16275, 109, '2015-01-15 01:30:47.000000', 'temperatura', 579.0000, 'ºC'),
	(16276, 109, '2015-01-15 01:30:48.000000', 'temperatura', 1011.0000, 'ºC'),
	(16277, 109, '2015-01-15 01:30:49.000000', 'temperatura', 920.0000, 'ºC'),
	(16278, 109, '2015-01-15 01:30:50.000000', 'temperatura', 367.0000, 'ºC'),
	(16279, 109, '2015-01-15 01:30:51.000000', 'temperatura', 275.0000, 'ºC'),
	(16280, 109, '2015-01-15 01:30:52.000000', 'temperatura', 276.0000, 'ºC'),
	(16281, 109, '2015-01-15 01:30:53.000000', 'temperatura', 557.0000, 'ºC'),
	(16282, 109, '2015-01-15 01:30:54.000000', 'temperatura', 754.0000, 'ºC'),
	(16283, 109, '2015-01-15 01:30:55.000000', 'temperatura', 901.0000, 'ºC'),
	(16284, 109, '2015-01-15 01:30:56.000000', 'temperatura', 1042.0000, 'ºC'),
	(16285, 109, '2015-01-15 01:30:57.000000', 'temperatura', 110.0000, 'ºC'),
	(16286, 109, '2015-01-15 01:30:58.000000', 'temperatura', 1023.0000, 'ºC'),
	(16287, 109, '2015-01-15 01:30:59.000000', 'temperatura', 1185.0000, 'ºC'),
	(16288, 109, '2015-01-15 01:31:00.000000', 'temperatura', 458.0000, 'ºC'),
	(16289, 109, '2015-01-15 01:31:01.000000', 'temperatura', 1136.0000, 'ºC'),
	(16290, 109, '2015-01-15 01:31:02.000000', 'temperatura', 704.0000, 'ºC'),
	(16291, 109, '2015-01-15 01:31:03.000000', 'temperatura', 113.0000, 'ºC'),
	(16292, 109, '2015-01-15 01:31:04.000000', 'temperatura', 853.0000, 'ºC'),
	(16293, 109, '2015-01-15 01:31:05.000000', 'temperatura', 327.0000, 'ºC'),
	(16294, 109, '2015-01-15 01:31:06.000000', 'temperatura', 277.0000, 'ºC'),
	(16295, 109, '2015-01-15 01:31:07.000000', 'temperatura', 404.0000, 'ºC'),
	(16296, 109, '2015-01-15 01:31:08.000000', 'temperatura', 1189.0000, 'ºC'),
	(16297, 109, '2015-01-15 01:31:09.000000', 'temperatura', 1135.0000, 'ºC'),
	(16298, 109, '2015-01-15 01:31:10.000000', 'temperatura', 907.0000, 'ºC'),
	(16299, 109, '2015-01-15 01:31:11.000000', 'temperatura', 1133.0000, 'ºC'),
	(16300, 109, '2015-01-15 01:31:12.000000', 'temperatura', 542.0000, 'ºC'),
	(16301, 109, '2015-01-15 01:31:13.000000', 'temperatura', 514.0000, 'ºC'),
	(16302, 109, '2015-01-15 01:31:14.000000', 'temperatura', 943.0000, 'ºC'),
	(16303, 109, '2015-01-15 01:31:15.000000', 'temperatura', 773.0000, 'ºC'),
	(16304, 109, '2015-01-15 01:31:16.000000', 'temperatura', 1035.0000, 'ºC'),
	(16305, 109, '2015-01-15 01:31:17.000000', 'temperatura', 459.0000, 'ºC'),
	(16306, 109, '2015-01-15 01:31:18.000000', 'temperatura', 391.0000, 'ºC'),
	(16307, 109, '2015-01-15 01:31:19.000000', 'temperatura', 578.0000, 'ºC'),
	(16308, 109, '2015-01-15 01:31:20.000000', 'temperatura', 517.0000, 'ºC'),
	(16309, 109, '2015-01-15 01:31:21.000000', 'temperatura', 853.0000, 'ºC'),
	(16310, 109, '2015-01-15 01:31:22.000000', 'temperatura', 312.0000, 'ºC'),
	(16311, 109, '2015-01-15 01:31:23.000000', 'temperatura', 203.0000, 'ºC'),
	(16312, 109, '2015-01-15 01:31:24.000000', 'temperatura', 80.0000, 'ºC'),
	(16313, 109, '2015-01-15 01:31:25.000000', 'temperatura', 991.0000, 'ºC'),
	(16314, 109, '2015-01-15 01:31:26.000000', 'temperatura', 1114.0000, 'ºC'),
	(16315, 109, '2015-01-15 01:31:27.000000', 'temperatura', 199.0000, 'ºC'),
	(16316, 109, '2015-01-15 01:31:28.000000', 'temperatura', 55.0000, 'ºC'),
	(16317, 109, '2015-01-15 01:31:29.000000', 'temperatura', 875.0000, 'ºC'),
	(16318, 109, '2015-01-15 01:31:30.000000', 'temperatura', 613.0000, 'ºC'),
	(16319, 109, '2015-01-15 01:31:31.000000', 'temperatura', 438.0000, 'ºC'),
	(16320, 109, '2015-01-15 01:31:32.000000', 'temperatura', 354.0000, 'ºC'),
	(16321, 109, '2015-01-15 01:31:33.000000', 'temperatura', 457.0000, 'ºC'),
	(16322, 109, '2015-01-15 01:31:34.000000', 'temperatura', 24.0000, 'ºC'),
	(16323, 109, '2015-01-15 01:31:35.000000', 'temperatura', 1147.0000, 'ºC'),
	(16324, 109, '2015-01-15 01:31:36.000000', 'temperatura', 863.0000, 'ºC'),
	(16325, 109, '2015-01-15 01:31:37.000000', 'temperatura', 875.0000, 'ºC'),
	(16326, 109, '2015-01-15 01:31:38.000000', 'temperatura', 588.0000, 'ºC'),
	(16327, 109, '2015-01-15 01:31:39.000000', 'temperatura', 316.0000, 'ºC'),
	(16328, 109, '2015-01-15 01:31:40.000000', 'temperatura', 1015.0000, 'ºC'),
	(16329, 109, '2015-01-15 01:31:41.000000', 'temperatura', 527.0000, 'ºC'),
	(16330, 109, '2015-01-15 01:31:42.000000', 'temperatura', 793.0000, 'ºC'),
	(16331, 109, '2015-01-15 01:31:43.000000', 'temperatura', 1183.0000, 'ºC'),
	(16332, 109, '2015-01-15 01:31:44.000000', 'temperatura', 1139.0000, 'ºC'),
	(16333, 109, '2015-01-15 01:31:45.000000', 'temperatura', 944.0000, 'ºC'),
	(16334, 109, '2015-01-15 01:31:46.000000', 'temperatura', 102.0000, 'ºC'),
	(16335, 109, '2015-01-15 01:31:47.000000', 'temperatura', 81.0000, 'ºC'),
	(16336, 109, '2015-01-15 01:31:48.000000', 'temperatura', 98.0000, 'ºC'),
	(16337, 109, '2015-01-15 01:31:49.000000', 'temperatura', 248.0000, 'ºC'),
	(16338, 109, '2015-01-15 01:31:50.000000', 'temperatura', 945.0000, 'ºC'),
	(16339, 109, '2015-01-15 01:31:51.000000', 'temperatura', 381.0000, 'ºC'),
	(16340, 109, '2015-01-15 01:31:52.000000', 'temperatura', 271.0000, 'ºC'),
	(16341, 109, '2015-01-15 01:31:53.000000', 'temperatura', 214.0000, 'ºC'),
	(16342, 109, '2015-01-15 01:31:54.000000', 'temperatura', 256.0000, 'ºC'),
	(16343, 109, '2015-01-15 01:31:55.000000', 'temperatura', 640.0000, 'ºC'),
	(16344, 109, '2015-01-15 01:31:56.000000', 'temperatura', 31.0000, 'ºC'),
	(16345, 109, '2015-01-15 01:31:57.000000', 'temperatura', 634.0000, 'ºC'),
	(16346, 109, '2015-01-15 01:31:58.000000', 'temperatura', 680.0000, 'ºC'),
	(16347, 109, '2015-01-15 01:31:59.000000', 'temperatura', 299.0000, 'ºC'),
	(16348, 109, '2015-01-15 01:32:00.000000', 'temperatura', 655.0000, 'ºC'),
	(16349, 109, '2015-01-15 01:32:01.000000', 'temperatura', 1177.0000, 'ºC'),
	(16350, 109, '2015-01-15 01:32:02.000000', 'temperatura', 321.0000, 'ºC'),
	(16351, 109, '2015-01-15 01:32:03.000000', 'temperatura', 476.0000, 'ºC'),
	(16352, 109, '2015-01-15 01:32:04.000000', 'temperatura', 216.0000, 'ºC'),
	(16353, 109, '2015-01-15 01:32:05.000000', 'temperatura', 852.0000, 'ºC'),
	(16354, 109, '2015-01-15 01:32:06.000000', 'temperatura', 12.0000, 'ºC'),
	(16355, 109, '2015-01-15 01:32:07.000000', 'temperatura', 1104.0000, 'ºC'),
	(16356, 109, '2015-01-15 01:32:08.000000', 'temperatura', 687.0000, 'ºC'),
	(16357, 109, '2015-01-15 01:32:09.000000', 'temperatura', 121.0000, 'ºC'),
	(16358, 109, '2015-01-15 01:32:10.000000', 'temperatura', 946.0000, 'ºC'),
	(16359, 109, '2015-01-15 01:32:11.000000', 'temperatura', 766.0000, 'ºC'),
	(16360, 109, '2015-01-15 01:32:12.000000', 'temperatura', 993.0000, 'ºC'),
	(16361, 109, '2015-01-15 01:32:13.000000', 'temperatura', 269.0000, 'ºC'),
	(16362, 109, '2015-01-15 01:32:14.000000', 'temperatura', 765.0000, 'ºC'),
	(16363, 109, '2015-01-15 01:32:15.000000', 'temperatura', 618.0000, 'ºC'),
	(16364, 109, '2015-01-15 01:32:16.000000', 'temperatura', 795.0000, 'ºC'),
	(16365, 109, '2015-01-15 01:32:17.000000', 'temperatura', 924.0000, 'ºC'),
	(16366, 109, '2015-01-15 01:32:18.000000', 'temperatura', 1035.0000, 'ºC'),
	(16367, 109, '2015-01-15 01:32:19.000000', 'temperatura', 3.0000, 'ºC'),
	(16368, 109, '2015-01-15 01:32:20.000000', 'temperatura', 512.0000, 'ºC'),
	(16369, 109, '2015-01-15 01:32:21.000000', 'temperatura', 149.0000, 'ºC'),
	(16370, 109, '2015-01-15 01:32:22.000000', 'temperatura', 412.0000, 'ºC'),
	(16371, 109, '2015-01-15 01:32:23.000000', 'temperatura', 412.0000, 'ºC'),
	(16372, 109, '2015-01-15 01:32:24.000000', 'temperatura', 824.0000, 'ºC'),
	(16373, 109, '2015-01-15 01:32:25.000000', 'temperatura', 484.0000, 'ºC'),
	(16374, 109, '2015-01-15 01:32:26.000000', 'temperatura', 1149.0000, 'ºC'),
	(16375, 109, '2015-01-15 01:32:27.000000', 'temperatura', 695.0000, 'ºC'),
	(16376, 109, '2015-01-15 01:32:28.000000', 'temperatura', 28.0000, 'ºC'),
	(16377, 109, '2015-01-15 01:32:29.000000', 'temperatura', 457.0000, 'ºC'),
	(16378, 109, '2015-01-15 01:32:30.000000', 'temperatura', 999.0000, 'ºC'),
	(16379, 109, '2015-01-15 01:32:31.000000', 'temperatura', 27.0000, 'ºC'),
	(16380, 109, '2015-01-15 01:32:32.000000', 'temperatura', 736.0000, 'ºC'),
	(16381, 109, '2015-01-15 01:32:33.000000', 'temperatura', 2.0000, 'ºC'),
	(16382, 109, '2015-01-15 01:32:34.000000', 'temperatura', 200.0000, 'ºC'),
	(16383, 109, '2015-01-15 01:32:35.000000', 'temperatura', 994.0000, 'ºC'),
	(16384, 109, '2015-01-15 01:32:36.000000', 'temperatura', 771.0000, 'ºC'),
	(16385, 109, '2015-01-15 01:32:37.000000', 'temperatura', 874.0000, 'ºC'),
	(16386, 109, '2015-01-15 01:32:38.000000', 'temperatura', 858.0000, 'ºC'),
	(16387, 109, '2015-01-15 01:32:39.000000', 'temperatura', 470.0000, 'ºC'),
	(16388, 109, '2015-01-15 01:32:40.000000', 'temperatura', 975.0000, 'ºC'),
	(16389, 109, '2015-01-15 01:32:41.000000', 'temperatura', 1065.0000, 'ºC'),
	(16390, 109, '2015-01-15 01:32:42.000000', 'temperatura', 1.0000, 'ºC'),
	(16391, 109, '2015-01-15 01:32:43.000000', 'temperatura', 411.0000, 'ºC'),
	(16392, 109, '2015-01-15 01:32:44.000000', 'temperatura', 854.0000, 'ºC'),
	(16393, 109, '2015-01-15 01:32:45.000000', 'temperatura', 634.0000, 'ºC'),
	(16394, 109, '2015-01-15 01:32:46.000000', 'temperatura', 612.0000, 'ºC'),
	(16395, 109, '2015-01-15 01:32:47.000000', 'temperatura', 1157.0000, 'ºC'),
	(16396, 109, '2015-01-15 01:32:48.000000', 'temperatura', 348.0000, 'ºC'),
	(16397, 109, '2015-01-15 01:32:49.000000', 'temperatura', 669.0000, 'ºC'),
	(16398, 109, '2015-01-15 01:32:50.000000', 'temperatura', 1103.0000, 'ºC'),
	(16399, 109, '2015-01-15 01:32:51.000000', 'temperatura', 1108.0000, 'ºC'),
	(16400, 109, '2015-01-15 01:32:52.000000', 'temperatura', 1034.0000, 'ºC'),
	(16401, 109, '2015-01-15 01:32:53.000000', 'temperatura', 644.0000, 'ºC'),
	(16402, 109, '2015-01-15 01:32:54.000000', 'temperatura', 118.0000, 'ºC'),
	(16403, 109, '2015-01-15 01:32:55.000000', 'temperatura', 1061.0000, 'ºC'),
	(16404, 109, '2015-01-15 01:32:56.000000', 'temperatura', 149.0000, 'ºC'),
	(16405, 109, '2015-01-15 01:32:57.000000', 'temperatura', 1165.0000, 'ºC'),
	(16406, 109, '2015-01-15 01:32:58.000000', 'temperatura', 578.0000, 'ºC'),
	(16407, 109, '2015-01-15 01:32:59.000000', 'temperatura', 594.0000, 'ºC'),
	(16408, 109, '2015-01-15 01:33:00.000000', 'temperatura', 35.0000, 'ºC'),
	(16409, 109, '2015-01-15 01:33:01.000000', 'temperatura', 796.0000, 'ºC'),
	(16410, 109, '2015-01-15 01:33:02.000000', 'temperatura', 275.0000, 'ºC'),
	(16411, 109, '2015-01-15 01:33:03.000000', 'temperatura', 185.0000, 'ºC'),
	(16412, 109, '2015-01-15 01:33:04.000000', 'temperatura', 104.0000, 'ºC'),
	(16413, 109, '2015-01-15 01:33:05.000000', 'temperatura', 1163.0000, 'ºC'),
	(16414, 109, '2015-01-15 01:33:06.000000', 'temperatura', 705.0000, 'ºC'),
	(16415, 109, '2015-01-15 01:33:07.000000', 'temperatura', 36.0000, 'ºC'),
	(16416, 109, '2015-01-15 01:33:08.000000', 'temperatura', 466.0000, 'ºC'),
	(16417, 109, '2015-01-15 01:33:09.000000', 'temperatura', 1024.0000, 'ºC'),
	(16418, 109, '2015-01-15 01:33:10.000000', 'temperatura', 122.0000, 'ºC'),
	(16419, 109, '2015-01-15 01:33:11.000000', 'temperatura', 1137.0000, 'ºC'),
	(16420, 109, '2015-01-15 01:33:12.000000', 'temperatura', 522.0000, 'ºC'),
	(16421, 109, '2015-01-15 01:33:13.000000', 'temperatura', 396.0000, 'ºC'),
	(16422, 109, '2015-01-15 01:33:14.000000', 'temperatura', 418.0000, 'ºC'),
	(16423, 109, '2015-01-15 01:33:15.000000', 'temperatura', 901.0000, 'ºC'),
	(16424, 109, '2015-01-15 01:33:16.000000', 'temperatura', 853.0000, 'ºC'),
	(16425, 109, '2015-01-15 01:33:17.000000', 'temperatura', 363.0000, 'ºC'),
	(16426, 109, '2015-01-15 01:33:18.000000', 'temperatura', 457.0000, 'ºC'),
	(16427, 109, '2015-01-15 01:33:19.000000', 'temperatura', 1194.0000, 'ºC'),
	(16428, 109, '2015-01-15 01:33:20.000000', 'temperatura', 999.0000, 'ºC'),
	(16429, 109, '2015-01-15 01:33:21.000000', 'temperatura', 216.0000, 'ºC'),
	(16430, 109, '2015-01-15 01:33:22.000000', 'temperatura', 481.0000, 'ºC'),
	(16431, 109, '2015-01-15 01:33:23.000000', 'temperatura', 559.0000, 'ºC'),
	(16432, 109, '2015-01-15 01:33:24.000000', 'temperatura', 152.0000, 'ºC'),
	(16433, 109, '2015-01-15 01:33:25.000000', 'temperatura', 285.0000, 'ºC'),
	(16434, 109, '2015-01-15 01:33:26.000000', 'temperatura', 967.0000, 'ºC'),
	(16435, 109, '2015-01-15 01:33:27.000000', 'temperatura', 382.0000, 'ºC'),
	(16436, 109, '2015-01-15 01:33:28.000000', 'temperatura', 211.0000, 'ºC'),
	(16437, 109, '2015-01-15 01:33:29.000000', 'temperatura', 1108.0000, 'ºC'),
	(16438, 109, '2015-01-15 01:33:30.000000', 'temperatura', 108.0000, 'ºC'),
	(16439, 109, '2015-01-15 01:33:31.000000', 'temperatura', 816.0000, 'ºC'),
	(16440, 109, '2015-01-15 01:33:32.000000', 'temperatura', 158.0000, 'ºC'),
	(16441, 109, '2015-01-15 01:33:33.000000', 'temperatura', 741.0000, 'ºC'),
	(16442, 109, '2015-01-15 01:33:34.000000', 'temperatura', 830.0000, 'ºC'),
	(16443, 109, '2015-01-15 01:33:35.000000', 'temperatura', 731.0000, 'ºC'),
	(16444, 109, '2015-01-15 01:33:36.000000', 'temperatura', 1162.0000, 'ºC'),
	(16445, 109, '2015-01-15 01:33:37.000000', 'temperatura', 18.0000, 'ºC'),
	(16446, 109, '2015-01-15 01:33:38.000000', 'temperatura', 206.0000, 'ºC'),
	(16447, 109, '2015-01-15 01:33:39.000000', 'temperatura', 976.0000, 'ºC'),
	(16448, 109, '2015-01-15 01:33:40.000000', 'temperatura', 661.0000, 'ºC'),
	(16449, 109, '2015-01-15 01:33:41.000000', 'temperatura', 378.0000, 'ºC'),
	(16450, 109, '2015-01-15 01:33:42.000000', 'temperatura', 1109.0000, 'ºC'),
	(16451, 109, '2015-01-15 01:33:43.000000', 'temperatura', 809.0000, 'ºC'),
	(16452, 109, '2015-01-15 01:33:44.000000', 'temperatura', 722.0000, 'ºC'),
	(16453, 109, '2015-01-15 01:33:45.000000', 'temperatura', 1180.0000, 'ºC'),
	(16454, 109, '2015-01-15 01:33:46.000000', 'temperatura', 135.0000, 'ºC'),
	(16455, 109, '2015-01-15 01:33:47.000000', 'temperatura', 737.0000, 'ºC'),
	(16456, 109, '2015-01-15 01:33:48.000000', 'temperatura', 882.0000, 'ºC'),
	(16457, 109, '2015-01-15 01:33:49.000000', 'temperatura', 996.0000, 'ºC'),
	(16458, 109, '2015-01-15 01:33:50.000000', 'temperatura', 1138.0000, 'ºC'),
	(16459, 109, '2015-01-15 01:33:51.000000', 'temperatura', 300.0000, 'ºC'),
	(16460, 109, '2015-01-15 01:33:52.000000', 'temperatura', 485.0000, 'ºC'),
	(16461, 109, '2015-01-15 01:33:53.000000', 'temperatura', 328.0000, 'ºC'),
	(16462, 109, '2015-01-15 01:33:54.000000', 'temperatura', 187.0000, 'ºC'),
	(16463, 109, '2015-01-15 01:33:55.000000', 'temperatura', 1150.0000, 'ºC'),
	(16464, 109, '2015-01-15 01:33:56.000000', 'temperatura', 388.0000, 'ºC'),
	(16465, 109, '2015-01-15 01:33:57.000000', 'temperatura', 892.0000, 'ºC'),
	(16466, 109, '2015-01-15 01:33:58.000000', 'temperatura', 898.0000, 'ºC'),
	(16467, 109, '2015-01-15 01:33:59.000000', 'temperatura', 611.0000, 'ºC'),
	(16468, 109, '2015-01-15 01:34:00.000000', 'temperatura', 365.0000, 'ºC'),
	(16469, 109, '2015-01-15 01:34:01.000000', 'temperatura', 1191.0000, 'ºC'),
	(16470, 109, '2015-01-15 01:34:02.000000', 'temperatura', 60.0000, 'ºC'),
	(16471, 109, '2015-01-15 01:34:03.000000', 'temperatura', 329.0000, 'ºC'),
	(16472, 109, '2015-01-15 01:34:04.000000', 'temperatura', 265.0000, 'ºC'),
	(16473, 109, '2015-01-15 01:34:05.000000', 'temperatura', 338.0000, 'ºC'),
	(16474, 109, '2015-01-15 01:34:06.000000', 'temperatura', 895.0000, 'ºC'),
	(16475, 109, '2015-01-15 01:34:07.000000', 'temperatura', 1062.0000, 'ºC'),
	(16476, 109, '2015-01-15 01:34:08.000000', 'temperatura', 226.0000, 'ºC'),
	(16477, 109, '2015-01-15 01:34:09.000000', 'temperatura', 345.0000, 'ºC'),
	(16478, 109, '2015-01-15 01:34:10.000000', 'temperatura', 1046.0000, 'ºC'),
	(16479, 109, '2015-01-15 01:34:11.000000', 'temperatura', 597.0000, 'ºC'),
	(16480, 109, '2015-01-15 01:34:12.000000', 'temperatura', 1048.0000, 'ºC'),
	(16481, 109, '2015-01-15 01:34:13.000000', 'temperatura', 1047.0000, 'ºC'),
	(16482, 109, '2015-01-15 01:34:14.000000', 'temperatura', 894.0000, 'ºC'),
	(16483, 109, '2015-01-15 01:34:15.000000', 'temperatura', 128.0000, 'ºC'),
	(16484, 109, '2015-01-15 01:34:16.000000', 'temperatura', 358.0000, 'ºC'),
	(16485, 109, '2015-01-15 01:34:17.000000', 'temperatura', 206.0000, 'ºC'),
	(16486, 109, '2015-01-15 01:34:18.000000', 'temperatura', 1157.0000, 'ºC'),
	(16487, 109, '2015-01-15 01:34:19.000000', 'temperatura', 367.0000, 'ºC'),
	(16488, 109, '2015-01-15 01:34:20.000000', 'temperatura', 766.0000, 'ºC'),
	(16489, 109, '2015-01-15 01:34:21.000000', 'temperatura', 329.0000, 'ºC'),
	(16490, 109, '2015-01-15 01:34:22.000000', 'temperatura', 546.0000, 'ºC'),
	(16491, 109, '2015-01-15 01:34:23.000000', 'temperatura', 543.0000, 'ºC'),
	(16492, 109, '2015-01-15 01:34:24.000000', 'temperatura', 1078.0000, 'ºC'),
	(16493, 109, '2015-01-15 01:34:25.000000', 'temperatura', 160.0000, 'ºC'),
	(16494, 109, '2015-01-15 01:34:26.000000', 'temperatura', 1167.0000, 'ºC'),
	(16495, 109, '2015-01-15 01:34:27.000000', 'temperatura', 558.0000, 'ºC'),
	(16496, 109, '2015-01-15 01:34:28.000000', 'temperatura', 486.0000, 'ºC'),
	(16497, 109, '2015-01-15 01:34:29.000000', 'temperatura', 759.0000, 'ºC'),
	(16498, 109, '2015-01-15 01:34:30.000000', 'temperatura', 1136.0000, 'ºC'),
	(16499, 109, '2015-01-15 01:34:31.000000', 'temperatura', 1003.0000, 'ºC'),
	(16500, 109, '2015-01-15 01:34:32.000000', 'temperatura', 410.0000, 'ºC'),
	(16501, 109, '2015-01-15 01:34:33.000000', 'temperatura', 239.0000, 'ºC'),
	(16502, 109, '2015-01-15 01:34:34.000000', 'temperatura', 1165.0000, 'ºC'),
	(16503, 109, '2015-01-15 01:34:35.000000', 'temperatura', 311.0000, 'ºC'),
	(16504, 109, '2015-01-15 01:34:36.000000', 'temperatura', 458.0000, 'ºC'),
	(16505, 109, '2015-01-15 01:34:37.000000', 'temperatura', 159.0000, 'ºC'),
	(16506, 109, '2015-01-15 01:34:38.000000', 'temperatura', 621.0000, 'ºC'),
	(16507, 109, '2015-01-15 01:34:39.000000', 'temperatura', 228.0000, 'ºC'),
	(16508, 109, '2015-01-15 01:34:40.000000', 'temperatura', 478.0000, 'ºC'),
	(16509, 109, '2015-01-15 01:34:41.000000', 'temperatura', 508.0000, 'ºC'),
	(16510, 109, '2015-01-15 01:34:42.000000', 'temperatura', 1108.0000, 'ºC'),
	(16511, 109, '2015-01-15 01:34:43.000000', 'temperatura', 413.0000, 'ºC'),
	(16512, 109, '2015-01-15 01:34:44.000000', 'temperatura', 1142.0000, 'ºC'),
	(16513, 109, '2015-01-15 01:34:45.000000', 'temperatura', 870.0000, 'ºC'),
	(16514, 109, '2015-01-15 01:34:46.000000', 'temperatura', 926.0000, 'ºC'),
	(16515, 109, '2015-01-15 01:34:47.000000', 'temperatura', 820.0000, 'ºC'),
	(16516, 109, '2015-01-15 01:34:48.000000', 'temperatura', 125.0000, 'ºC'),
	(16517, 109, '2015-01-15 01:34:49.000000', 'temperatura', 562.0000, 'ºC'),
	(16518, 109, '2015-01-15 01:34:50.000000', 'temperatura', 37.0000, 'ºC'),
	(16519, 109, '2015-01-15 01:34:51.000000', 'temperatura', 897.0000, 'ºC'),
	(16520, 109, '2015-01-15 01:34:52.000000', 'temperatura', 778.0000, 'ºC'),
	(16521, 109, '2015-01-15 01:34:53.000000', 'temperatura', 1198.0000, 'ºC'),
	(16522, 109, '2015-01-15 01:34:54.000000', 'temperatura', 56.0000, 'ºC'),
	(16523, 109, '2015-01-15 01:34:55.000000', 'temperatura', 288.0000, 'ºC'),
	(16524, 109, '2015-01-15 01:34:56.000000', 'temperatura', 70.0000, 'ºC'),
	(16525, 109, '2015-01-15 01:34:57.000000', 'temperatura', 686.0000, 'ºC'),
	(16526, 109, '2015-01-15 01:34:58.000000', 'temperatura', 824.0000, 'ºC'),
	(16527, 109, '2015-01-15 01:34:59.000000', 'temperatura', 859.0000, 'ºC'),
	(16528, 109, '2015-01-15 01:35:00.000000', 'temperatura', 625.0000, 'ºC'),
	(16529, 109, '2015-01-15 01:35:01.000000', 'temperatura', 549.0000, 'ºC'),
	(16530, 109, '2015-01-15 01:35:02.000000', 'temperatura', 869.0000, 'ºC'),
	(16531, 109, '2015-01-15 01:35:03.000000', 'temperatura', 297.0000, 'ºC'),
	(16532, 109, '2015-01-15 01:35:04.000000', 'temperatura', 82.0000, 'ºC'),
	(16533, 109, '2015-01-15 01:35:05.000000', 'temperatura', 718.0000, 'ºC'),
	(16534, 109, '2015-01-15 01:35:06.000000', 'temperatura', 944.0000, 'ºC'),
	(16535, 109, '2015-01-15 01:35:07.000000', 'temperatura', 167.0000, 'ºC'),
	(16536, 109, '2015-01-15 01:35:08.000000', 'temperatura', 403.0000, 'ºC'),
	(16537, 109, '2015-01-15 01:35:09.000000', 'temperatura', 313.0000, 'ºC'),
	(16538, 109, '2015-01-15 01:35:10.000000', 'temperatura', 358.0000, 'ºC'),
	(16539, 109, '2015-01-15 01:35:11.000000', 'temperatura', 852.0000, 'ºC'),
	(16540, 109, '2015-01-15 01:35:12.000000', 'temperatura', 785.0000, 'ºC'),
	(16541, 109, '2015-01-15 01:35:13.000000', 'temperatura', 168.0000, 'ºC'),
	(16542, 109, '2015-01-15 01:35:14.000000', 'temperatura', 889.0000, 'ºC'),
	(16543, 109, '2015-01-15 01:35:15.000000', 'temperatura', 340.0000, 'ºC'),
	(16544, 109, '2015-01-15 01:35:16.000000', 'temperatura', 232.0000, 'ºC'),
	(16545, 109, '2015-01-15 01:35:17.000000', 'temperatura', 141.0000, 'ºC'),
	(16546, 109, '2015-01-15 01:35:18.000000', 'temperatura', 11.0000, 'ºC'),
	(16547, 109, '2015-01-15 01:35:19.000000', 'temperatura', 832.0000, 'ºC'),
	(16548, 109, '2015-01-15 01:35:20.000000', 'temperatura', 526.0000, 'ºC'),
	(16549, 109, '2015-01-15 01:35:21.000000', 'temperatura', 134.0000, 'ºC'),
	(16550, 109, '2015-01-15 01:35:22.000000', 'temperatura', 293.0000, 'ºC'),
	(16551, 109, '2015-01-15 01:35:23.000000', 'temperatura', 1063.0000, 'ºC'),
	(16552, 109, '2015-01-15 01:35:24.000000', 'temperatura', 837.0000, 'ºC'),
	(16553, 109, '2015-01-15 01:35:25.000000', 'temperatura', 998.0000, 'ºC'),
	(16554, 109, '2015-01-15 01:35:26.000000', 'temperatura', 81.0000, 'ºC'),
	(16555, 109, '2015-01-15 01:35:27.000000', 'temperatura', 1008.0000, 'ºC'),
	(16556, 109, '2015-01-15 01:35:28.000000', 'temperatura', 1198.0000, 'ºC'),
	(16557, 109, '2015-01-15 01:35:29.000000', 'temperatura', 565.0000, 'ºC'),
	(16558, 109, '2015-01-15 01:35:30.000000', 'temperatura', 434.0000, 'ºC'),
	(16559, 109, '2015-01-15 01:35:31.000000', 'temperatura', 476.0000, 'ºC'),
	(16560, 109, '2015-01-15 01:35:32.000000', 'temperatura', 1079.0000, 'ºC'),
	(16561, 109, '2015-01-15 01:35:33.000000', 'temperatura', 365.0000, 'ºC'),
	(16562, 109, '2015-01-15 01:35:34.000000', 'temperatura', 989.0000, 'ºC'),
	(16563, 109, '2015-01-15 01:35:35.000000', 'temperatura', 250.0000, 'ºC'),
	(16564, 109, '2015-01-15 01:35:36.000000', 'temperatura', 686.0000, 'ºC'),
	(16565, 109, '2015-01-15 01:35:37.000000', 'temperatura', 280.0000, 'ºC'),
	(16566, 109, '2015-01-15 01:35:38.000000', 'temperatura', 542.0000, 'ºC'),
	(16567, 109, '2015-01-15 01:35:39.000000', 'temperatura', 668.0000, 'ºC'),
	(16568, 109, '2015-01-15 01:35:40.000000', 'temperatura', 518.0000, 'ºC'),
	(16569, 109, '2015-01-15 01:35:41.000000', 'temperatura', 583.0000, 'ºC'),
	(16570, 109, '2015-01-15 01:35:42.000000', 'temperatura', 165.0000, 'ºC'),
	(16571, 109, '2015-01-15 01:35:43.000000', 'temperatura', 276.0000, 'ºC'),
	(16572, 109, '2015-01-15 01:35:44.000000', 'temperatura', 885.0000, 'ºC'),
	(16573, 109, '2015-01-15 01:35:45.000000', 'temperatura', 1199.0000, 'ºC'),
	(16574, 109, '2015-01-15 01:35:46.000000', 'temperatura', 940.0000, 'ºC'),
	(16575, 109, '2015-01-15 01:35:47.000000', 'temperatura', 1103.0000, 'ºC'),
	(16576, 109, '2015-01-15 01:35:48.000000', 'temperatura', 294.0000, 'ºC'),
	(16577, 109, '2015-01-15 01:35:49.000000', 'temperatura', 561.0000, 'ºC'),
	(16578, 109, '2015-01-15 01:35:50.000000', 'temperatura', 725.0000, 'ºC'),
	(16579, 109, '2015-01-15 01:35:51.000000', 'temperatura', 741.0000, 'ºC'),
	(16580, 109, '2015-01-15 01:35:52.000000', 'temperatura', 330.0000, 'ºC'),
	(16581, 109, '2015-01-15 01:35:53.000000', 'temperatura', 630.0000, 'ºC'),
	(16582, 109, '2015-01-15 01:35:54.000000', 'temperatura', 958.0000, 'ºC'),
	(16583, 109, '2015-01-15 01:35:55.000000', 'temperatura', 502.0000, 'ºC'),
	(16584, 109, '2015-01-15 01:35:56.000000', 'temperatura', 837.0000, 'ºC'),
	(16585, 109, '2015-01-15 01:35:57.000000', 'temperatura', 279.0000, 'ºC'),
	(16586, 109, '2015-01-15 01:35:58.000000', 'temperatura', 84.0000, 'ºC'),
	(16587, 109, '2015-01-15 01:35:59.000000', 'temperatura', 784.0000, 'ºC'),
	(16588, 109, '2015-01-15 01:36:00.000000', 'temperatura', 70.0000, 'ºC'),
	(16589, 109, '2015-01-15 01:36:01.000000', 'temperatura', 397.0000, 'ºC'),
	(16590, 109, '2015-01-15 01:36:02.000000', 'temperatura', 578.0000, 'ºC'),
	(16591, 109, '2015-01-15 01:36:03.000000', 'temperatura', 497.0000, 'ºC'),
	(16592, 109, '2015-01-15 01:36:04.000000', 'temperatura', 752.0000, 'ºC'),
	(16593, 109, '2015-01-15 01:36:05.000000', 'temperatura', 1069.0000, 'ºC'),
	(16594, 109, '2015-01-15 01:36:06.000000', 'temperatura', 690.0000, 'ºC'),
	(16595, 109, '2015-01-15 01:36:07.000000', 'temperatura', 244.0000, 'ºC'),
	(16596, 109, '2015-01-15 01:36:08.000000', 'temperatura', 348.0000, 'ºC'),
	(16597, 109, '2015-01-15 01:36:09.000000', 'temperatura', 1011.0000, 'ºC'),
	(16598, 109, '2015-01-15 01:36:10.000000', 'temperatura', 410.0000, 'ºC'),
	(16599, 109, '2015-01-15 01:36:11.000000', 'temperatura', 218.0000, 'ºC'),
	(16600, 109, '2015-01-15 01:36:12.000000', 'temperatura', 1061.0000, 'ºC'),
	(16601, 109, '2015-01-15 01:36:13.000000', 'temperatura', 1052.0000, 'ºC'),
	(16602, 109, '2015-01-15 01:36:14.000000', 'temperatura', 878.0000, 'ºC'),
	(16603, 109, '2015-01-15 01:36:15.000000', 'temperatura', 33.0000, 'ºC'),
	(16604, 109, '2015-01-15 01:36:16.000000', 'temperatura', 1133.0000, 'ºC'),
	(16605, 109, '2015-01-15 01:36:17.000000', 'temperatura', 768.0000, 'ºC'),
	(16606, 109, '2015-01-15 01:36:18.000000', 'temperatura', 438.0000, 'ºC'),
	(16607, 109, '2015-01-15 01:36:19.000000', 'temperatura', 1088.0000, 'ºC'),
	(16608, 109, '2015-01-15 01:36:20.000000', 'temperatura', 525.0000, 'ºC'),
	(16609, 109, '2015-01-15 01:36:21.000000', 'temperatura', 564.0000, 'ºC'),
	(16610, 109, '2015-01-15 01:36:22.000000', 'temperatura', 43.0000, 'ºC'),
	(16611, 109, '2015-01-15 01:36:23.000000', 'temperatura', 924.0000, 'ºC'),
	(16612, 109, '2015-01-15 01:36:24.000000', 'temperatura', 894.0000, 'ºC'),
	(16613, 109, '2015-01-15 01:36:25.000000', 'temperatura', 495.0000, 'ºC'),
	(16614, 109, '2015-01-15 01:36:26.000000', 'temperatura', 995.0000, 'ºC'),
	(16615, 109, '2015-01-15 01:36:27.000000', 'temperatura', 1090.0000, 'ºC'),
	(16616, 109, '2015-01-15 01:36:28.000000', 'temperatura', 65.0000, 'ºC'),
	(16617, 109, '2015-01-15 01:36:29.000000', 'temperatura', 656.0000, 'ºC'),
	(16618, 109, '2015-01-15 01:36:30.000000', 'temperatura', 685.0000, 'ºC'),
	(16619, 109, '2015-01-15 01:36:31.000000', 'temperatura', 257.0000, 'ºC'),
	(16620, 109, '2015-01-15 01:36:32.000000', 'temperatura', 431.0000, 'ºC'),
	(16621, 109, '2015-01-15 01:36:33.000000', 'temperatura', 183.0000, 'ºC'),
	(16622, 109, '2015-01-15 01:36:34.000000', 'temperatura', 825.0000, 'ºC'),
	(16623, 109, '2015-01-15 01:36:35.000000', 'temperatura', 1175.0000, 'ºC'),
	(16624, 109, '2015-01-15 01:36:36.000000', 'temperatura', 1001.0000, 'ºC'),
	(16625, 109, '2015-01-15 01:36:37.000000', 'temperatura', 280.0000, 'ºC'),
	(16626, 109, '2015-01-15 01:36:38.000000', 'temperatura', 796.0000, 'ºC'),
	(16627, 109, '2015-01-15 01:36:39.000000', 'temperatura', 742.0000, 'ºC'),
	(16628, 109, '2015-01-15 01:36:40.000000', 'temperatura', 123.0000, 'ºC'),
	(16629, 109, '2015-01-15 01:36:41.000000', 'temperatura', 788.0000, 'ºC'),
	(16630, 109, '2015-01-15 01:36:42.000000', 'temperatura', 1172.0000, 'ºC'),
	(16631, 109, '2015-01-15 01:36:43.000000', 'temperatura', 1097.0000, 'ºC'),
	(16632, 109, '2015-01-15 01:36:44.000000', 'temperatura', 768.0000, 'ºC'),
	(16633, 109, '2015-01-15 01:36:45.000000', 'temperatura', 550.0000, 'ºC'),
	(16634, 109, '2015-01-15 01:36:46.000000', 'temperatura', 448.0000, 'ºC'),
	(16635, 109, '2015-01-15 01:36:47.000000', 'temperatura', 588.0000, 'ºC'),
	(16636, 109, '2015-01-15 01:36:48.000000', 'temperatura', 397.0000, 'ºC'),
	(16637, 109, '2015-01-15 01:36:49.000000', 'temperatura', 224.0000, 'ºC'),
	(16638, 109, '2015-01-15 01:36:50.000000', 'temperatura', 1127.0000, 'ºC'),
	(16639, 109, '2015-01-15 01:36:51.000000', 'temperatura', 163.0000, 'ºC'),
	(16640, 109, '2015-01-15 01:36:52.000000', 'temperatura', 1034.0000, 'ºC'),
	(16641, 109, '2015-01-15 01:36:53.000000', 'temperatura', 1081.0000, 'ºC'),
	(16642, 109, '2015-01-15 01:36:54.000000', 'temperatura', 1106.0000, 'ºC'),
	(16643, 109, '2015-01-15 01:36:55.000000', 'temperatura', 1086.0000, 'ºC'),
	(16644, 109, '2015-01-15 01:36:56.000000', 'temperatura', 912.0000, 'ºC'),
	(16645, 109, '2015-01-15 01:36:57.000000', 'temperatura', 101.0000, 'ºC'),
	(16646, 109, '2015-01-15 01:36:58.000000', 'temperatura', 171.0000, 'ºC'),
	(16647, 109, '2015-01-15 01:36:59.000000', 'temperatura', 553.0000, 'ºC'),
	(16648, 109, '2015-01-15 01:37:00.000000', 'temperatura', 1051.0000, 'ºC'),
	(16649, 109, '2015-01-15 01:37:01.000000', 'temperatura', 1198.0000, 'ºC'),
	(16650, 109, '2015-01-15 01:37:02.000000', 'temperatura', 438.0000, 'ºC'),
	(16651, 109, '2015-01-15 01:37:03.000000', 'temperatura', 997.0000, 'ºC'),
	(16652, 109, '2015-01-15 01:37:04.000000', 'temperatura', 69.0000, 'ºC'),
	(16653, 109, '2015-01-15 01:37:05.000000', 'temperatura', 956.0000, 'ºC'),
	(16654, 109, '2015-01-15 01:37:06.000000', 'temperatura', 974.0000, 'ºC'),
	(16655, 109, '2015-01-15 01:37:07.000000', 'temperatura', 802.0000, 'ºC'),
	(16656, 109, '2015-01-15 01:37:08.000000', 'temperatura', 1088.0000, 'ºC'),
	(16657, 109, '2015-01-15 01:37:09.000000', 'temperatura', 634.0000, 'ºC'),
	(16658, 109, '2015-01-15 01:37:10.000000', 'temperatura', 1107.0000, 'ºC'),
	(16659, 109, '2015-01-15 01:37:11.000000', 'temperatura', 35.0000, 'ºC'),
	(16660, 109, '2015-01-15 01:37:12.000000', 'temperatura', 455.0000, 'ºC'),
	(16661, 109, '2015-01-15 01:37:13.000000', 'temperatura', 970.0000, 'ºC'),
	(16662, 109, '2015-01-15 01:37:14.000000', 'temperatura', 1086.0000, 'ºC'),
	(16663, 109, '2015-01-15 01:37:15.000000', 'temperatura', 119.0000, 'ºC'),
	(16664, 109, '2015-01-15 01:37:16.000000', 'temperatura', 939.0000, 'ºC'),
	(16665, 109, '2015-01-15 01:37:17.000000', 'temperatura', 739.0000, 'ºC'),
	(16666, 109, '2015-01-15 01:37:18.000000', 'temperatura', 876.0000, 'ºC'),
	(16667, 109, '2015-01-15 01:37:19.000000', 'temperatura', 966.0000, 'ºC'),
	(16668, 109, '2015-01-15 01:37:20.000000', 'temperatura', 1004.0000, 'ºC'),
	(16669, 109, '2015-01-15 01:37:21.000000', 'temperatura', 919.0000, 'ºC'),
	(16670, 109, '2015-01-15 01:37:22.000000', 'temperatura', 384.0000, 'ºC'),
	(16671, 109, '2015-01-15 01:37:23.000000', 'temperatura', 363.0000, 'ºC'),
	(16672, 109, '2015-01-15 01:37:24.000000', 'temperatura', 663.0000, 'ºC'),
	(16673, 110, '2015-01-15 00:00:00.000000', 'temperatura', 748.0000, 'ºC'),
	(16674, 110, '2015-01-15 00:00:01.000000', 'temperatura', 657.0000, 'ºC'),
	(16675, 110, '2015-01-15 00:00:02.000000', 'temperatura', 1044.0000, 'ºC'),
	(16676, 110, '2015-01-15 00:00:03.000000', 'temperatura', 849.0000, 'ºC'),
	(16677, 110, '2015-01-15 00:00:04.000000', 'temperatura', 1112.0000, 'ºC'),
	(16678, 110, '2015-01-15 00:00:05.000000', 'temperatura', 614.0000, 'ºC'),
	(16679, 110, '2015-01-15 00:00:06.000000', 'temperatura', 934.0000, 'ºC'),
	(16680, 110, '2015-01-15 00:00:07.000000', 'temperatura', 431.0000, 'ºC'),
	(16681, 110, '2015-01-15 00:00:08.000000', 'temperatura', 552.0000, 'ºC'),
	(16682, 110, '2015-01-15 00:00:09.000000', 'temperatura', 268.0000, 'ºC'),
	(16683, 110, '2015-01-15 00:00:10.000000', 'temperatura', 886.0000, 'ºC'),
	(16684, 110, '2015-01-15 00:00:11.000000', 'temperatura', 26.0000, 'ºC'),
	(16685, 110, '2015-01-15 00:00:12.000000', 'temperatura', 1072.0000, 'ºC'),
	(16686, 110, '2015-01-15 00:00:13.000000', 'temperatura', 482.0000, 'ºC'),
	(16687, 110, '2015-01-15 00:00:14.000000', 'temperatura', 395.0000, 'ºC'),
	(16688, 110, '2015-01-15 00:00:15.000000', 'temperatura', 529.0000, 'ºC'),
	(16689, 110, '2015-01-15 00:00:16.000000', 'temperatura', 260.0000, 'ºC'),
	(16690, 110, '2015-01-15 00:00:17.000000', 'temperatura', 916.0000, 'ºC'),
	(16691, 110, '2015-01-15 00:00:18.000000', 'temperatura', 198.0000, 'ºC'),
	(16692, 110, '2015-01-15 00:00:19.000000', 'temperatura', 642.0000, 'ºC'),
	(16693, 110, '2015-01-15 00:00:20.000000', 'temperatura', 219.0000, 'ºC'),
	(16694, 110, '2015-01-15 00:00:21.000000', 'temperatura', 368.0000, 'ºC'),
	(16695, 110, '2015-01-15 00:00:22.000000', 'temperatura', 1182.0000, 'ºC'),
	(16696, 110, '2015-01-15 00:00:23.000000', 'temperatura', 9.0000, 'ºC'),
	(16697, 110, '2015-01-15 00:00:24.000000', 'temperatura', 99.0000, 'ºC'),
	(16698, 110, '2015-01-15 00:00:25.000000', 'temperatura', 470.0000, 'ºC'),
	(16699, 110, '2015-01-15 00:00:26.000000', 'temperatura', 854.0000, 'ºC'),
	(16700, 110, '2015-01-15 00:00:27.000000', 'temperatura', 459.0000, 'ºC'),
	(16701, 110, '2015-01-15 00:00:28.000000', 'temperatura', 933.0000, 'ºC'),
	(16702, 110, '2015-01-15 00:00:29.000000', 'temperatura', 889.0000, 'ºC'),
	(16703, 110, '2015-01-15 00:00:30.000000', 'temperatura', 445.0000, 'ºC'),
	(16704, 110, '2015-01-15 00:00:31.000000', 'temperatura', 758.0000, 'ºC'),
	(16705, 110, '2015-01-15 00:00:32.000000', 'temperatura', 55.0000, 'ºC'),
	(16706, 110, '2015-01-15 00:00:33.000000', 'temperatura', 401.0000, 'ºC'),
	(16707, 110, '2015-01-15 00:00:34.000000', 'temperatura', 640.0000, 'ºC'),
	(16708, 110, '2015-01-15 00:00:35.000000', 'temperatura', 798.0000, 'ºC'),
	(16709, 110, '2015-01-15 00:00:36.000000', 'temperatura', 872.0000, 'ºC'),
	(16710, 110, '2015-01-15 00:00:37.000000', 'temperatura', 767.0000, 'ºC'),
	(16711, 110, '2015-01-15 00:00:38.000000', 'temperatura', 17.0000, 'ºC'),
	(16712, 110, '2015-01-15 00:00:39.000000', 'temperatura', 187.0000, 'ºC'),
	(16713, 110, '2015-01-15 00:00:40.000000', 'temperatura', 882.0000, 'ºC'),
	(16714, 110, '2015-01-15 00:00:41.000000', 'temperatura', 252.0000, 'ºC'),
	(16715, 110, '2015-01-15 00:00:42.000000', 'temperatura', 1015.0000, 'ºC'),
	(16716, 110, '2015-01-15 00:00:43.000000', 'temperatura', 720.0000, 'ºC'),
	(16717, 110, '2015-01-15 00:00:44.000000', 'temperatura', 557.0000, 'ºC'),
	(16718, 110, '2015-01-15 00:00:45.000000', 'temperatura', 622.0000, 'ºC'),
	(16719, 110, '2015-01-15 00:00:46.000000', 'temperatura', 240.0000, 'ºC'),
	(16720, 110, '2015-01-15 00:00:47.000000', 'temperatura', 534.0000, 'ºC'),
	(16721, 110, '2015-01-15 00:00:48.000000', 'temperatura', 750.0000, 'ºC'),
	(16722, 110, '2015-01-15 00:00:49.000000', 'temperatura', 947.0000, 'ºC'),
	(16723, 110, '2015-01-15 00:00:50.000000', 'temperatura', 88.0000, 'ºC'),
	(16724, 110, '2015-01-15 00:00:51.000000', 'temperatura', 0.0000, 'ºC'),
	(16725, 110, '2015-01-15 00:00:52.000000', 'temperatura', 936.0000, 'ºC'),
	(16726, 110, '2015-01-15 00:00:53.000000', 'temperatura', 1080.0000, 'ºC'),
	(16727, 110, '2015-01-15 00:00:54.000000', 'temperatura', 191.0000, 'ºC'),
	(16728, 110, '2015-01-15 00:00:55.000000', 'temperatura', 115.0000, 'ºC'),
	(16729, 110, '2015-01-15 00:00:56.000000', 'temperatura', 4.0000, 'ºC'),
	(16730, 110, '2015-01-15 00:00:57.000000', 'temperatura', 875.0000, 'ºC'),
	(16731, 110, '2015-01-15 00:00:58.000000', 'temperatura', 762.0000, 'ºC'),
	(16732, 110, '2015-01-15 00:00:59.000000', 'temperatura', 1187.0000, 'ºC'),
	(16733, 110, '2015-01-15 00:01:00.000000', 'temperatura', 51.0000, 'ºC'),
	(16734, 110, '2015-01-15 00:01:01.000000', 'temperatura', 294.0000, 'ºC'),
	(16735, 110, '2015-01-15 00:01:02.000000', 'temperatura', 118.0000, 'ºC'),
	(16736, 110, '2015-01-15 00:01:03.000000', 'temperatura', 908.0000, 'ºC'),
	(16737, 110, '2015-01-15 00:01:04.000000', 'temperatura', 585.0000, 'ºC'),
	(16738, 110, '2015-01-15 00:01:05.000000', 'temperatura', 203.0000, 'ºC'),
	(16739, 110, '2015-01-15 00:01:06.000000', 'temperatura', 460.0000, 'ºC'),
	(16740, 110, '2015-01-15 00:01:07.000000', 'temperatura', 493.0000, 'ºC'),
	(16741, 110, '2015-01-15 00:01:08.000000', 'temperatura', 1085.0000, 'ºC'),
	(16742, 110, '2015-01-15 00:01:09.000000', 'temperatura', 346.0000, 'ºC'),
	(16743, 110, '2015-01-15 00:01:10.000000', 'temperatura', 874.0000, 'ºC'),
	(16744, 110, '2015-01-15 00:01:11.000000', 'temperatura', 935.0000, 'ºC'),
	(16745, 110, '2015-01-15 00:01:12.000000', 'temperatura', 854.0000, 'ºC'),
	(16746, 110, '2015-01-15 00:01:13.000000', 'temperatura', 266.0000, 'ºC'),
	(16747, 110, '2015-01-15 00:01:14.000000', 'temperatura', 1167.0000, 'ºC'),
	(16748, 110, '2015-01-15 00:01:15.000000', 'temperatura', 237.0000, 'ºC'),
	(16749, 110, '2015-01-15 00:01:16.000000', 'temperatura', 87.0000, 'ºC'),
	(16750, 110, '2015-01-15 00:01:17.000000', 'temperatura', 924.0000, 'ºC'),
	(16751, 110, '2015-01-15 00:01:18.000000', 'temperatura', 758.0000, 'ºC'),
	(16752, 110, '2015-01-15 00:01:19.000000', 'temperatura', 1019.0000, 'ºC'),
	(16753, 110, '2015-01-15 00:01:20.000000', 'temperatura', 422.0000, 'ºC'),
	(16754, 110, '2015-01-15 00:01:21.000000', 'temperatura', 251.0000, 'ºC'),
	(16755, 110, '2015-01-15 00:01:22.000000', 'temperatura', 1192.0000, 'ºC'),
	(16756, 110, '2015-01-15 00:01:23.000000', 'temperatura', 408.0000, 'ºC'),
	(16757, 110, '2015-01-15 00:01:24.000000', 'temperatura', 865.0000, 'ºC'),
	(16758, 110, '2015-01-15 00:01:25.000000', 'temperatura', 699.0000, 'ºC'),
	(16759, 110, '2015-01-15 00:01:26.000000', 'temperatura', 902.0000, 'ºC'),
	(16760, 110, '2015-01-15 00:01:27.000000', 'temperatura', 12.0000, 'ºC'),
	(16761, 110, '2015-01-15 00:01:28.000000', 'temperatura', 957.0000, 'ºC'),
	(16762, 110, '2015-01-15 00:01:29.000000', 'temperatura', 1149.0000, 'ºC'),
	(16763, 110, '2015-01-15 00:01:30.000000', 'temperatura', 473.0000, 'ºC'),
	(16764, 110, '2015-01-15 00:01:31.000000', 'temperatura', 117.0000, 'ºC'),
	(16765, 110, '2015-01-15 00:01:32.000000', 'temperatura', 370.0000, 'ºC'),
	(16766, 110, '2015-01-15 00:01:33.000000', 'temperatura', 297.0000, 'ºC'),
	(16767, 110, '2015-01-15 00:01:34.000000', 'temperatura', 377.0000, 'ºC'),
	(16768, 110, '2015-01-15 00:01:35.000000', 'temperatura', 995.0000, 'ºC'),
	(16769, 110, '2015-01-15 00:01:36.000000', 'temperatura', 245.0000, 'ºC'),
	(16770, 110, '2015-01-15 00:01:37.000000', 'temperatura', 639.0000, 'ºC'),
	(16771, 110, '2015-01-15 00:01:38.000000', 'temperatura', 62.0000, 'ºC'),
	(16772, 110, '2015-01-15 00:01:39.000000', 'temperatura', 794.0000, 'ºC'),
	(16773, 110, '2015-01-15 00:01:40.000000', 'temperatura', 183.0000, 'ºC'),
	(16774, 110, '2015-01-15 00:01:41.000000', 'temperatura', 933.0000, 'ºC'),
	(16775, 110, '2015-01-15 00:01:42.000000', 'temperatura', 517.0000, 'ºC'),
	(16776, 110, '2015-01-15 00:01:43.000000', 'temperatura', 987.0000, 'ºC'),
	(16777, 110, '2015-01-15 00:01:44.000000', 'temperatura', 985.0000, 'ºC'),
	(16778, 110, '2015-01-15 00:01:45.000000', 'temperatura', 762.0000, 'ºC'),
	(16779, 110, '2015-01-15 00:01:46.000000', 'temperatura', 857.0000, 'ºC'),
	(16780, 110, '2015-01-15 00:01:47.000000', 'temperatura', 798.0000, 'ºC'),
	(16781, 110, '2015-01-15 00:01:48.000000', 'temperatura', 219.0000, 'ºC'),
	(16782, 110, '2015-01-15 00:01:49.000000', 'temperatura', 1105.0000, 'ºC'),
	(16783, 110, '2015-01-15 00:01:50.000000', 'temperatura', 65.0000, 'ºC'),
	(16784, 110, '2015-01-15 00:01:51.000000', 'temperatura', 612.0000, 'ºC'),
	(16785, 110, '2015-01-15 00:01:52.000000', 'temperatura', 463.0000, 'ºC'),
	(16786, 110, '2015-01-15 00:01:53.000000', 'temperatura', 482.0000, 'ºC'),
	(16787, 110, '2015-01-15 00:01:54.000000', 'temperatura', 1022.0000, 'ºC'),
	(16788, 110, '2015-01-15 00:01:55.000000', 'temperatura', 62.0000, 'ºC'),
	(16789, 110, '2015-01-15 00:01:56.000000', 'temperatura', 844.0000, 'ºC'),
	(16790, 110, '2015-01-15 00:01:57.000000', 'temperatura', 436.0000, 'ºC'),
	(16791, 110, '2015-01-15 00:01:58.000000', 'temperatura', 848.0000, 'ºC'),
	(16792, 110, '2015-01-15 00:01:59.000000', 'temperatura', 532.0000, 'ºC'),
	(16793, 110, '2015-01-15 00:02:00.000000', 'temperatura', 118.0000, 'ºC'),
	(16794, 110, '2015-01-15 00:02:01.000000', 'temperatura', 194.0000, 'ºC'),
	(16795, 110, '2015-01-15 00:02:02.000000', 'temperatura', 617.0000, 'ºC'),
	(16796, 110, '2015-01-15 00:02:03.000000', 'temperatura', 103.0000, 'ºC'),
	(16797, 110, '2015-01-15 00:02:04.000000', 'temperatura', 1064.0000, 'ºC'),
	(16798, 110, '2015-01-15 00:02:05.000000', 'temperatura', 211.0000, 'ºC'),
	(16799, 110, '2015-01-15 00:02:06.000000', 'temperatura', 263.0000, 'ºC'),
	(16800, 110, '2015-01-15 00:02:07.000000', 'temperatura', 682.0000, 'ºC'),
	(16801, 110, '2015-01-15 00:02:08.000000', 'temperatura', 221.0000, 'ºC'),
	(16802, 110, '2015-01-15 00:02:09.000000', 'temperatura', 261.0000, 'ºC'),
	(16803, 110, '2015-01-15 00:02:10.000000', 'temperatura', 641.0000, 'ºC'),
	(16804, 110, '2015-01-15 00:02:11.000000', 'temperatura', 24.0000, 'ºC'),
	(16805, 110, '2015-01-15 00:02:12.000000', 'temperatura', 598.0000, 'ºC'),
	(16806, 110, '2015-01-15 00:02:13.000000', 'temperatura', 516.0000, 'ºC'),
	(16807, 110, '2015-01-15 00:02:14.000000', 'temperatura', 788.0000, 'ºC'),
	(16808, 110, '2015-01-15 00:02:15.000000', 'temperatura', 1193.0000, 'ºC'),
	(16809, 110, '2015-01-15 00:02:16.000000', 'temperatura', 1.0000, 'ºC'),
	(16810, 110, '2015-01-15 00:02:17.000000', 'temperatura', 27.0000, 'ºC'),
	(16811, 110, '2015-01-15 00:02:18.000000', 'temperatura', 131.0000, 'ºC'),
	(16812, 110, '2015-01-15 00:02:19.000000', 'temperatura', 577.0000, 'ºC'),
	(16813, 110, '2015-01-15 00:02:20.000000', 'temperatura', 92.0000, 'ºC'),
	(16814, 110, '2015-01-15 00:02:21.000000', 'temperatura', 1129.0000, 'ºC'),
	(16815, 110, '2015-01-15 00:02:22.000000', 'temperatura', 571.0000, 'ºC'),
	(16816, 110, '2015-01-15 00:02:23.000000', 'temperatura', 666.0000, 'ºC'),
	(16817, 110, '2015-01-15 00:02:24.000000', 'temperatura', 418.0000, 'ºC'),
	(16818, 110, '2015-01-15 00:02:25.000000', 'temperatura', 93.0000, 'ºC'),
	(16819, 110, '2015-01-15 00:02:26.000000', 'temperatura', 411.0000, 'ºC'),
	(16820, 110, '2015-01-15 00:02:27.000000', 'temperatura', 578.0000, 'ºC'),
	(16821, 110, '2015-01-15 00:02:28.000000', 'temperatura', 458.0000, 'ºC'),
	(16822, 110, '2015-01-15 00:02:29.000000', 'temperatura', 555.0000, 'ºC'),
	(16823, 110, '2015-01-15 00:02:30.000000', 'temperatura', 204.0000, 'ºC'),
	(16824, 110, '2015-01-15 00:02:31.000000', 'temperatura', 553.0000, 'ºC'),
	(16825, 110, '2015-01-15 00:02:32.000000', 'temperatura', 954.0000, 'ºC'),
	(16826, 110, '2015-01-15 00:02:33.000000', 'temperatura', 713.0000, 'ºC'),
	(16827, 110, '2015-01-15 00:02:34.000000', 'temperatura', 704.0000, 'ºC'),
	(16828, 110, '2015-01-15 00:02:35.000000', 'temperatura', 180.0000, 'ºC'),
	(16829, 110, '2015-01-15 00:02:36.000000', 'temperatura', 1190.0000, 'ºC'),
	(16830, 110, '2015-01-15 00:02:37.000000', 'temperatura', 609.0000, 'ºC'),
	(16831, 110, '2015-01-15 00:02:38.000000', 'temperatura', 676.0000, 'ºC'),
	(16832, 110, '2015-01-15 00:02:39.000000', 'temperatura', 355.0000, 'ºC'),
	(16833, 110, '2015-01-15 00:02:40.000000', 'temperatura', 948.0000, 'ºC'),
	(16834, 110, '2015-01-15 00:02:41.000000', 'temperatura', 74.0000, 'ºC'),
	(16835, 110, '2015-01-15 00:02:42.000000', 'temperatura', 1126.0000, 'ºC'),
	(16836, 110, '2015-01-15 00:02:43.000000', 'temperatura', 611.0000, 'ºC'),
	(16837, 110, '2015-01-15 00:02:44.000000', 'temperatura', 875.0000, 'ºC'),
	(16838, 110, '2015-01-15 00:02:45.000000', 'temperatura', 145.0000, 'ºC'),
	(16839, 110, '2015-01-15 00:02:46.000000', 'temperatura', 500.0000, 'ºC'),
	(16840, 110, '2015-01-15 00:02:47.000000', 'temperatura', 865.0000, 'ºC'),
	(16841, 110, '2015-01-15 00:02:48.000000', 'temperatura', 427.0000, 'ºC'),
	(16842, 110, '2015-01-15 00:02:49.000000', 'temperatura', 737.0000, 'ºC'),
	(16843, 110, '2015-01-15 00:02:50.000000', 'temperatura', 8.0000, 'ºC'),
	(16844, 110, '2015-01-15 00:02:51.000000', 'temperatura', 228.0000, 'ºC'),
	(16845, 110, '2015-01-15 00:02:52.000000', 'temperatura', 1119.0000, 'ºC'),
	(16846, 110, '2015-01-15 00:02:53.000000', 'temperatura', 108.0000, 'ºC'),
	(16847, 110, '2015-01-15 00:02:54.000000', 'temperatura', 787.0000, 'ºC'),
	(16848, 110, '2015-01-15 00:02:55.000000', 'temperatura', 8.0000, 'ºC'),
	(16849, 110, '2015-01-15 00:02:56.000000', 'temperatura', 83.0000, 'ºC'),
	(16850, 110, '2015-01-15 00:02:57.000000', 'temperatura', 390.0000, 'ºC'),
	(16851, 110, '2015-01-15 00:02:58.000000', 'temperatura', 500.0000, 'ºC'),
	(16852, 110, '2015-01-15 00:02:59.000000', 'temperatura', 132.0000, 'ºC'),
	(16853, 110, '2015-01-15 00:03:00.000000', 'temperatura', 361.0000, 'ºC'),
	(16854, 110, '2015-01-15 00:03:01.000000', 'temperatura', 210.0000, 'ºC'),
	(16855, 110, '2015-01-15 00:03:02.000000', 'temperatura', 1166.0000, 'ºC'),
	(16856, 110, '2015-01-15 00:03:03.000000', 'temperatura', 402.0000, 'ºC'),
	(16857, 110, '2015-01-15 00:03:04.000000', 'temperatura', 911.0000, 'ºC'),
	(16858, 110, '2015-01-15 00:03:05.000000', 'temperatura', 950.0000, 'ºC'),
	(16859, 110, '2015-01-15 00:03:06.000000', 'temperatura', 819.0000, 'ºC'),
	(16860, 110, '2015-01-15 00:03:07.000000', 'temperatura', 43.0000, 'ºC'),
	(16861, 110, '2015-01-15 00:03:08.000000', 'temperatura', 158.0000, 'ºC'),
	(16862, 110, '2015-01-15 00:03:09.000000', 'temperatura', 665.0000, 'ºC'),
	(16863, 110, '2015-01-15 00:03:10.000000', 'temperatura', 448.0000, 'ºC'),
	(16864, 110, '2015-01-15 00:03:11.000000', 'temperatura', 247.0000, 'ºC'),
	(16865, 110, '2015-01-15 00:03:12.000000', 'temperatura', 1092.0000, 'ºC'),
	(16866, 110, '2015-01-15 00:03:13.000000', 'temperatura', 1118.0000, 'ºC'),
	(16867, 110, '2015-01-15 00:03:14.000000', 'temperatura', 1114.0000, 'ºC'),
	(16868, 110, '2015-01-15 00:03:15.000000', 'temperatura', 1018.0000, 'ºC'),
	(16869, 110, '2015-01-15 00:03:16.000000', 'temperatura', 549.0000, 'ºC'),
	(16870, 110, '2015-01-15 00:03:17.000000', 'temperatura', 892.0000, 'ºC'),
	(16871, 110, '2015-01-15 00:03:18.000000', 'temperatura', 411.0000, 'ºC'),
	(16872, 110, '2015-01-15 00:03:19.000000', 'temperatura', 580.0000, 'ºC'),
	(16873, 110, '2015-01-15 00:03:20.000000', 'temperatura', 466.0000, 'ºC'),
	(16874, 110, '2015-01-15 00:03:21.000000', 'temperatura', 592.0000, 'ºC'),
	(16875, 110, '2015-01-15 00:03:22.000000', 'temperatura', 361.0000, 'ºC'),
	(16876, 110, '2015-01-15 00:03:23.000000', 'temperatura', 32.0000, 'ºC'),
	(16877, 110, '2015-01-15 00:03:24.000000', 'temperatura', 275.0000, 'ºC'),
	(16878, 110, '2015-01-15 00:03:25.000000', 'temperatura', 79.0000, 'ºC'),
	(16879, 110, '2015-01-15 00:03:26.000000', 'temperatura', 772.0000, 'ºC'),
	(16880, 110, '2015-01-15 00:03:27.000000', 'temperatura', 21.0000, 'ºC'),
	(16881, 110, '2015-01-15 00:03:28.000000', 'temperatura', 192.0000, 'ºC'),
	(16882, 110, '2015-01-15 00:03:29.000000', 'temperatura', 898.0000, 'ºC'),
	(16883, 110, '2015-01-15 00:03:30.000000', 'temperatura', 312.0000, 'ºC'),
	(16884, 110, '2015-01-15 00:03:31.000000', 'temperatura', 67.0000, 'ºC'),
	(16885, 110, '2015-01-15 00:03:32.000000', 'temperatura', 600.0000, 'ºC'),
	(16886, 110, '2015-01-15 00:03:33.000000', 'temperatura', 398.0000, 'ºC'),
	(16887, 110, '2015-01-15 00:03:34.000000', 'temperatura', 191.0000, 'ºC'),
	(16888, 110, '2015-01-15 00:03:35.000000', 'temperatura', 962.0000, 'ºC'),
	(16889, 110, '2015-01-15 00:03:36.000000', 'temperatura', 635.0000, 'ºC'),
	(16890, 110, '2015-01-15 00:03:37.000000', 'temperatura', 293.0000, 'ºC'),
	(16891, 110, '2015-01-15 00:03:38.000000', 'temperatura', 759.0000, 'ºC'),
	(16892, 110, '2015-01-15 00:03:39.000000', 'temperatura', 517.0000, 'ºC'),
	(16893, 110, '2015-01-15 00:03:40.000000', 'temperatura', 308.0000, 'ºC'),
	(16894, 110, '2015-01-15 00:03:41.000000', 'temperatura', 1190.0000, 'ºC'),
	(16895, 110, '2015-01-15 00:03:42.000000', 'temperatura', 228.0000, 'ºC'),
	(16896, 110, '2015-01-15 00:03:43.000000', 'temperatura', 1170.0000, 'ºC'),
	(16897, 110, '2015-01-15 00:03:44.000000', 'temperatura', 364.0000, 'ºC'),
	(16898, 110, '2015-01-15 00:03:45.000000', 'temperatura', 714.0000, 'ºC'),
	(16899, 110, '2015-01-15 00:03:46.000000', 'temperatura', 77.0000, 'ºC'),
	(16900, 110, '2015-01-15 00:03:47.000000', 'temperatura', 643.0000, 'ºC'),
	(16901, 110, '2015-01-15 00:03:48.000000', 'temperatura', 585.0000, 'ºC'),
	(16902, 110, '2015-01-15 00:03:49.000000', 'temperatura', 997.0000, 'ºC'),
	(16903, 110, '2015-01-15 00:03:50.000000', 'temperatura', 830.0000, 'ºC'),
	(16904, 110, '2015-01-15 00:03:51.000000', 'temperatura', 1158.0000, 'ºC'),
	(16905, 110, '2015-01-15 00:03:52.000000', 'temperatura', 902.0000, 'ºC'),
	(16906, 110, '2015-01-15 00:03:53.000000', 'temperatura', 1034.0000, 'ºC'),
	(16907, 110, '2015-01-15 00:03:54.000000', 'temperatura', 67.0000, 'ºC'),
	(16908, 110, '2015-01-15 00:03:55.000000', 'temperatura', 832.0000, 'ºC'),
	(16909, 110, '2015-01-15 00:03:56.000000', 'temperatura', 359.0000, 'ºC'),
	(16910, 110, '2015-01-15 00:03:57.000000', 'temperatura', 498.0000, 'ºC'),
	(16911, 110, '2015-01-15 00:03:58.000000', 'temperatura', 216.0000, 'ºC'),
	(16912, 110, '2015-01-15 00:03:59.000000', 'temperatura', 788.0000, 'ºC'),
	(16913, 110, '2015-01-15 00:04:00.000000', 'temperatura', 891.0000, 'ºC'),
	(16914, 110, '2015-01-15 00:04:01.000000', 'temperatura', 890.0000, 'ºC'),
	(16915, 110, '2015-01-15 00:04:02.000000', 'temperatura', 576.0000, 'ºC'),
	(16916, 110, '2015-01-15 00:04:03.000000', 'temperatura', 214.0000, 'ºC'),
	(16917, 110, '2015-01-15 00:04:04.000000', 'temperatura', 542.0000, 'ºC'),
	(16918, 110, '2015-01-15 00:04:05.000000', 'temperatura', 870.0000, 'ºC'),
	(16919, 110, '2015-01-15 00:04:06.000000', 'temperatura', 322.0000, 'ºC'),
	(16920, 110, '2015-01-15 00:04:07.000000', 'temperatura', 202.0000, 'ºC'),
	(16921, 110, '2015-01-15 00:04:08.000000', 'temperatura', 45.0000, 'ºC'),
	(16922, 110, '2015-01-15 00:04:09.000000', 'temperatura', 821.0000, 'ºC'),
	(16923, 110, '2015-01-15 00:04:10.000000', 'temperatura', 367.0000, 'ºC'),
	(16924, 110, '2015-01-15 00:04:11.000000', 'temperatura', 573.0000, 'ºC'),
	(16925, 110, '2015-01-15 00:04:12.000000', 'temperatura', 567.0000, 'ºC'),
	(16926, 110, '2015-01-15 00:04:13.000000', 'temperatura', 1115.0000, 'ºC'),
	(16927, 110, '2015-01-15 00:04:14.000000', 'temperatura', 275.0000, 'ºC'),
	(16928, 110, '2015-01-15 00:04:15.000000', 'temperatura', 429.0000, 'ºC'),
	(16929, 110, '2015-01-15 00:04:16.000000', 'temperatura', 119.0000, 'ºC'),
	(16930, 110, '2015-01-15 00:04:17.000000', 'temperatura', 512.0000, 'ºC'),
	(16931, 110, '2015-01-15 00:04:18.000000', 'temperatura', 1001.0000, 'ºC'),
	(16932, 110, '2015-01-15 00:04:19.000000', 'temperatura', 1070.0000, 'ºC'),
	(16933, 110, '2015-01-15 00:04:20.000000', 'temperatura', 1146.0000, 'ºC'),
	(16934, 110, '2015-01-15 00:04:21.000000', 'temperatura', 123.0000, 'ºC'),
	(16935, 110, '2015-01-15 00:04:22.000000', 'temperatura', 778.0000, 'ºC'),
	(16936, 110, '2015-01-15 00:04:23.000000', 'temperatura', 1120.0000, 'ºC'),
	(16937, 110, '2015-01-15 00:04:24.000000', 'temperatura', 866.0000, 'ºC'),
	(16938, 110, '2015-01-15 00:04:25.000000', 'temperatura', 969.0000, 'ºC'),
	(16939, 110, '2015-01-15 00:04:26.000000', 'temperatura', 1051.0000, 'ºC'),
	(16940, 110, '2015-01-15 00:04:27.000000', 'temperatura', 1147.0000, 'ºC'),
	(16941, 110, '2015-01-15 00:04:28.000000', 'temperatura', 181.0000, 'ºC'),
	(16942, 110, '2015-01-15 00:04:29.000000', 'temperatura', 1065.0000, 'ºC'),
	(16943, 110, '2015-01-15 00:04:30.000000', 'temperatura', 1183.0000, 'ºC'),
	(16944, 110, '2015-01-15 00:04:31.000000', 'temperatura', 319.0000, 'ºC'),
	(16945, 110, '2015-01-15 00:04:32.000000', 'temperatura', 449.0000, 'ºC'),
	(16946, 110, '2015-01-15 00:04:33.000000', 'temperatura', 86.0000, 'ºC'),
	(16947, 110, '2015-01-15 00:04:34.000000', 'temperatura', 283.0000, 'ºC'),
	(16948, 110, '2015-01-15 00:04:35.000000', 'temperatura', 1157.0000, 'ºC'),
	(16949, 110, '2015-01-15 00:04:36.000000', 'temperatura', 136.0000, 'ºC'),
	(16950, 110, '2015-01-15 00:04:37.000000', 'temperatura', 813.0000, 'ºC'),
	(16951, 110, '2015-01-15 00:04:38.000000', 'temperatura', 54.0000, 'ºC'),
	(16952, 110, '2015-01-15 00:04:39.000000', 'temperatura', 235.0000, 'ºC'),
	(16953, 110, '2015-01-15 00:04:40.000000', 'temperatura', 1011.0000, 'ºC'),
	(16954, 110, '2015-01-15 00:04:41.000000', 'temperatura', 752.0000, 'ºC'),
	(16955, 110, '2015-01-15 00:04:42.000000', 'temperatura', 725.0000, 'ºC'),
	(16956, 110, '2015-01-15 00:04:43.000000', 'temperatura', 172.0000, 'ºC'),
	(16957, 110, '2015-01-15 00:04:44.000000', 'temperatura', 1087.0000, 'ºC'),
	(16958, 110, '2015-01-15 00:04:45.000000', 'temperatura', 117.0000, 'ºC'),
	(16959, 110, '2015-01-15 00:04:46.000000', 'temperatura', 925.0000, 'ºC'),
	(16960, 110, '2015-01-15 00:04:47.000000', 'temperatura', 675.0000, 'ºC'),
	(16961, 110, '2015-01-15 00:04:48.000000', 'temperatura', 602.0000, 'ºC'),
	(16962, 110, '2015-01-15 00:04:49.000000', 'temperatura', 984.0000, 'ºC'),
	(16963, 110, '2015-01-15 00:04:50.000000', 'temperatura', 715.0000, 'ºC'),
	(16964, 110, '2015-01-15 00:04:51.000000', 'temperatura', 622.0000, 'ºC'),
	(16965, 110, '2015-01-15 00:04:52.000000', 'temperatura', 968.0000, 'ºC'),
	(16966, 110, '2015-01-15 00:04:53.000000', 'temperatura', 571.0000, 'ºC'),
	(16967, 110, '2015-01-15 00:04:54.000000', 'temperatura', 1155.0000, 'ºC'),
	(16968, 110, '2015-01-15 00:04:55.000000', 'temperatura', 460.0000, 'ºC'),
	(16969, 110, '2015-01-15 00:04:56.000000', 'temperatura', 38.0000, 'ºC'),
	(16970, 110, '2015-01-15 00:04:57.000000', 'temperatura', 10.0000, 'ºC'),
	(16971, 110, '2015-01-15 00:04:58.000000', 'temperatura', 1136.0000, 'ºC'),
	(16972, 110, '2015-01-15 00:04:59.000000', 'temperatura', 850.0000, 'ºC'),
	(16973, 110, '2015-01-15 00:05:00.000000', 'temperatura', 843.0000, 'ºC'),
	(16974, 110, '2015-01-15 00:05:01.000000', 'temperatura', 465.0000, 'ºC'),
	(16975, 110, '2015-01-15 00:05:02.000000', 'temperatura', 995.0000, 'ºC'),
	(16976, 110, '2015-01-15 00:05:03.000000', 'temperatura', 1182.0000, 'ºC'),
	(16977, 110, '2015-01-15 00:05:04.000000', 'temperatura', 523.0000, 'ºC'),
	(16978, 110, '2015-01-15 00:05:05.000000', 'temperatura', 273.0000, 'ºC'),
	(16979, 110, '2015-01-15 00:05:06.000000', 'temperatura', 995.0000, 'ºC'),
	(16980, 110, '2015-01-15 00:05:07.000000', 'temperatura', 555.0000, 'ºC'),
	(16981, 110, '2015-01-15 00:05:08.000000', 'temperatura', 992.0000, 'ºC'),
	(16982, 110, '2015-01-15 00:05:09.000000', 'temperatura', 894.0000, 'ºC'),
	(16983, 110, '2015-01-15 00:05:10.000000', 'temperatura', 294.0000, 'ºC'),
	(16984, 110, '2015-01-15 00:05:11.000000', 'temperatura', 1191.0000, 'ºC'),
	(16985, 110, '2015-01-15 00:05:12.000000', 'temperatura', 274.0000, 'ºC'),
	(16986, 110, '2015-01-15 00:05:13.000000', 'temperatura', 197.0000, 'ºC'),
	(16987, 110, '2015-01-15 00:05:14.000000', 'temperatura', 165.0000, 'ºC'),
	(16988, 110, '2015-01-15 00:05:15.000000', 'temperatura', 232.0000, 'ºC'),
	(16989, 110, '2015-01-15 00:05:16.000000', 'temperatura', 666.0000, 'ºC'),
	(16990, 110, '2015-01-15 00:05:17.000000', 'temperatura', 234.0000, 'ºC'),
	(16991, 110, '2015-01-15 00:05:18.000000', 'temperatura', 374.0000, 'ºC'),
	(16992, 110, '2015-01-15 00:05:19.000000', 'temperatura', 1169.0000, 'ºC'),
	(16993, 110, '2015-01-15 00:05:20.000000', 'temperatura', 1124.0000, 'ºC'),
	(16994, 110, '2015-01-15 00:05:21.000000', 'temperatura', 914.0000, 'ºC'),
	(16995, 110, '2015-01-15 00:05:22.000000', 'temperatura', 1199.0000, 'ºC'),
	(16996, 110, '2015-01-15 00:05:23.000000', 'temperatura', 853.0000, 'ºC'),
	(16997, 110, '2015-01-15 00:05:24.000000', 'temperatura', 670.0000, 'ºC'),
	(16998, 110, '2015-01-15 00:05:25.000000', 'temperatura', 789.0000, 'ºC'),
	(16999, 110, '2015-01-15 00:05:26.000000', 'temperatura', 737.0000, 'ºC'),
	(17000, 110, '2015-01-15 00:05:27.000000', 'temperatura', 118.0000, 'ºC'),
	(17001, 110, '2015-01-15 00:05:28.000000', 'temperatura', 778.0000, 'ºC'),
	(17002, 110, '2015-01-15 00:05:29.000000', 'temperatura', 1138.0000, 'ºC'),
	(17003, 110, '2015-01-15 00:05:30.000000', 'temperatura', 957.0000, 'ºC'),
	(17004, 110, '2015-01-15 00:05:31.000000', 'temperatura', 169.0000, 'ºC'),
	(17005, 110, '2015-01-15 00:05:32.000000', 'temperatura', 375.0000, 'ºC'),
	(17006, 110, '2015-01-15 00:05:33.000000', 'temperatura', 169.0000, 'ºC'),
	(17007, 110, '2015-01-15 00:05:34.000000', 'temperatura', 921.0000, 'ºC'),
	(17008, 110, '2015-01-15 00:05:35.000000', 'temperatura', 498.0000, 'ºC'),
	(17009, 110, '2015-01-15 00:05:36.000000', 'temperatura', 929.0000, 'ºC'),
	(17010, 110, '2015-01-15 00:05:37.000000', 'temperatura', 751.0000, 'ºC'),
	(17011, 110, '2015-01-15 00:05:38.000000', 'temperatura', 970.0000, 'ºC'),
	(17012, 110, '2015-01-15 00:05:39.000000', 'temperatura', 196.0000, 'ºC'),
	(17013, 110, '2015-01-15 00:05:40.000000', 'temperatura', 472.0000, 'ºC'),
	(17014, 110, '2015-01-15 00:05:41.000000', 'temperatura', 573.0000, 'ºC'),
	(17015, 110, '2015-01-15 00:05:42.000000', 'temperatura', 249.0000, 'ºC'),
	(17016, 110, '2015-01-15 00:05:43.000000', 'temperatura', 725.0000, 'ºC'),
	(17017, 110, '2015-01-15 00:05:44.000000', 'temperatura', 479.0000, 'ºC'),
	(17018, 110, '2015-01-15 00:05:45.000000', 'temperatura', 219.0000, 'ºC'),
	(17019, 110, '2015-01-15 00:05:46.000000', 'temperatura', 861.0000, 'ºC'),
	(17020, 110, '2015-01-15 00:05:47.000000', 'temperatura', 47.0000, 'ºC'),
	(17021, 110, '2015-01-15 00:05:48.000000', 'temperatura', 53.0000, 'ºC'),
	(17022, 110, '2015-01-15 00:05:49.000000', 'temperatura', 125.0000, 'ºC'),
	(17023, 110, '2015-01-15 00:05:50.000000', 'temperatura', 468.0000, 'ºC'),
	(17024, 110, '2015-01-15 00:05:51.000000', 'temperatura', 764.0000, 'ºC'),
	(17025, 110, '2015-01-15 00:05:52.000000', 'temperatura', 15.0000, 'ºC'),
	(17026, 110, '2015-01-15 00:05:53.000000', 'temperatura', 185.0000, 'ºC'),
	(17027, 110, '2015-01-15 00:05:54.000000', 'temperatura', 878.0000, 'ºC'),
	(17028, 110, '2015-01-15 00:05:55.000000', 'temperatura', 238.0000, 'ºC'),
	(17029, 110, '2015-01-15 00:05:56.000000', 'temperatura', 956.0000, 'ºC'),
	(17030, 110, '2015-01-15 00:05:57.000000', 'temperatura', 467.0000, 'ºC'),
	(17031, 110, '2015-01-15 00:05:58.000000', 'temperatura', 666.0000, 'ºC'),
	(17032, 110, '2015-01-15 00:05:59.000000', 'temperatura', 729.0000, 'ºC'),
	(17033, 110, '2015-01-15 00:06:00.000000', 'temperatura', 447.0000, 'ºC'),
	(17034, 110, '2015-01-15 00:06:01.000000', 'temperatura', 49.0000, 'ºC'),
	(17035, 110, '2015-01-15 00:06:02.000000', 'temperatura', 105.0000, 'ºC'),
	(17036, 110, '2015-01-15 00:06:03.000000', 'temperatura', 378.0000, 'ºC'),
	(17037, 110, '2015-01-15 00:06:04.000000', 'temperatura', 375.0000, 'ºC'),
	(17038, 110, '2015-01-15 00:06:05.000000', 'temperatura', 741.0000, 'ºC'),
	(17039, 110, '2015-01-15 00:06:06.000000', 'temperatura', 180.0000, 'ºC'),
	(17040, 110, '2015-01-15 00:06:07.000000', 'temperatura', 1079.0000, 'ºC'),
	(17041, 110, '2015-01-15 00:06:08.000000', 'temperatura', 53.0000, 'ºC'),
	(17042, 110, '2015-01-15 00:06:09.000000', 'temperatura', 632.0000, 'ºC'),
	(17043, 110, '2015-01-15 00:06:10.000000', 'temperatura', 598.0000, 'ºC'),
	(17044, 110, '2015-01-15 00:06:11.000000', 'temperatura', 1098.0000, 'ºC'),
	(17045, 110, '2015-01-15 00:06:12.000000', 'temperatura', 94.0000, 'ºC'),
	(17046, 110, '2015-01-15 00:06:13.000000', 'temperatura', 776.0000, 'ºC'),
	(17047, 110, '2015-01-15 00:06:14.000000', 'temperatura', 0.0000, 'ºC'),
	(17048, 110, '2015-01-15 00:06:15.000000', 'temperatura', 72.0000, 'ºC'),
	(17049, 110, '2015-01-15 00:06:16.000000', 'temperatura', 363.0000, 'ºC'),
	(17050, 110, '2015-01-15 00:06:17.000000', 'temperatura', 396.0000, 'ºC'),
	(17051, 110, '2015-01-15 00:06:18.000000', 'temperatura', 893.0000, 'ºC'),
	(17052, 110, '2015-01-15 00:06:19.000000', 'temperatura', 879.0000, 'ºC'),
	(17053, 110, '2015-01-15 00:06:20.000000', 'temperatura', 517.0000, 'ºC'),
	(17054, 110, '2015-01-15 00:06:21.000000', 'temperatura', 1148.0000, 'ºC'),
	(17055, 110, '2015-01-15 00:06:22.000000', 'temperatura', 591.0000, 'ºC'),
	(17056, 110, '2015-01-15 00:06:23.000000', 'temperatura', 709.0000, 'ºC'),
	(17057, 110, '2015-01-15 00:06:24.000000', 'temperatura', 575.0000, 'ºC'),
	(17058, 110, '2015-01-15 00:06:25.000000', 'temperatura', 747.0000, 'ºC'),
	(17059, 110, '2015-01-15 00:06:26.000000', 'temperatura', 810.0000, 'ºC'),
	(17060, 110, '2015-01-15 00:06:27.000000', 'temperatura', 610.0000, 'ºC'),
	(17061, 110, '2015-01-15 00:06:28.000000', 'temperatura', 621.0000, 'ºC'),
	(17062, 110, '2015-01-15 00:06:29.000000', 'temperatura', 74.0000, 'ºC'),
	(17063, 110, '2015-01-15 00:06:30.000000', 'temperatura', 909.0000, 'ºC'),
	(17064, 110, '2015-01-15 00:06:31.000000', 'temperatura', 724.0000, 'ºC'),
	(17065, 110, '2015-01-15 00:06:32.000000', 'temperatura', 891.0000, 'ºC'),
	(17066, 110, '2015-01-15 00:06:33.000000', 'temperatura', 1083.0000, 'ºC'),
	(17067, 110, '2015-01-15 00:06:34.000000', 'temperatura', 345.0000, 'ºC'),
	(17068, 110, '2015-01-15 00:06:35.000000', 'temperatura', 877.0000, 'ºC'),
	(17069, 110, '2015-01-15 00:06:36.000000', 'temperatura', 950.0000, 'ºC'),
	(17070, 110, '2015-01-15 00:06:37.000000', 'temperatura', 917.0000, 'ºC'),
	(17071, 110, '2015-01-15 00:06:38.000000', 'temperatura', 538.0000, 'ºC'),
	(17072, 110, '2015-01-15 00:06:39.000000', 'temperatura', 1138.0000, 'ºC'),
	(17073, 110, '2015-01-15 00:06:40.000000', 'temperatura', 478.0000, 'ºC'),
	(17074, 110, '2015-01-15 00:06:41.000000', 'temperatura', 174.0000, 'ºC'),
	(17075, 110, '2015-01-15 00:06:42.000000', 'temperatura', 637.0000, 'ºC'),
	(17076, 110, '2015-01-15 00:06:43.000000', 'temperatura', 265.0000, 'ºC'),
	(17077, 110, '2015-01-15 00:06:44.000000', 'temperatura', 615.0000, 'ºC'),
	(17078, 110, '2015-01-15 00:06:45.000000', 'temperatura', 1078.0000, 'ºC'),
	(17079, 110, '2015-01-15 00:06:46.000000', 'temperatura', 1148.0000, 'ºC'),
	(17080, 110, '2015-01-15 00:06:47.000000', 'temperatura', 105.0000, 'ºC'),
	(17081, 110, '2015-01-15 00:06:48.000000', 'temperatura', 680.0000, 'ºC'),
	(17082, 110, '2015-01-15 00:06:49.000000', 'temperatura', 686.0000, 'ºC'),
	(17083, 110, '2015-01-15 00:06:50.000000', 'temperatura', 190.0000, 'ºC'),
	(17084, 110, '2015-01-15 00:06:51.000000', 'temperatura', 94.0000, 'ºC'),
	(17085, 110, '2015-01-15 00:06:52.000000', 'temperatura', 1099.0000, 'ºC'),
	(17086, 110, '2015-01-15 00:06:53.000000', 'temperatura', 412.0000, 'ºC'),
	(17087, 110, '2015-01-15 00:06:54.000000', 'temperatura', 1167.0000, 'ºC'),
	(17088, 110, '2015-01-15 00:06:55.000000', 'temperatura', 998.0000, 'ºC'),
	(17089, 110, '2015-01-15 00:06:56.000000', 'temperatura', 291.0000, 'ºC'),
	(17090, 110, '2015-01-15 00:06:57.000000', 'temperatura', 861.0000, 'ºC'),
	(17091, 110, '2015-01-15 00:06:58.000000', 'temperatura', 1031.0000, 'ºC'),
	(17092, 110, '2015-01-15 00:06:59.000000', 'temperatura', 175.0000, 'ºC'),
	(17093, 110, '2015-01-15 00:07:00.000000', 'temperatura', 179.0000, 'ºC'),
	(17094, 110, '2015-01-15 00:07:01.000000', 'temperatura', 373.0000, 'ºC'),
	(17095, 110, '2015-01-15 00:07:02.000000', 'temperatura', 129.0000, 'ºC'),
	(17096, 110, '2015-01-15 00:07:03.000000', 'temperatura', 726.0000, 'ºC'),
	(17097, 110, '2015-01-15 00:07:04.000000', 'temperatura', 845.0000, 'ºC'),
	(17098, 110, '2015-01-15 00:07:05.000000', 'temperatura', 845.0000, 'ºC'),
	(17099, 110, '2015-01-15 00:07:06.000000', 'temperatura', 493.0000, 'ºC'),
	(17100, 110, '2015-01-15 00:07:07.000000', 'temperatura', 1131.0000, 'ºC'),
	(17101, 110, '2015-01-15 00:07:08.000000', 'temperatura', 576.0000, 'ºC'),
	(17102, 110, '2015-01-15 00:07:09.000000', 'temperatura', 686.0000, 'ºC'),
	(17103, 110, '2015-01-15 00:07:10.000000', 'temperatura', 502.0000, 'ºC'),
	(17104, 110, '2015-01-15 00:07:11.000000', 'temperatura', 455.0000, 'ºC'),
	(17105, 110, '2015-01-15 00:07:12.000000', 'temperatura', 767.0000, 'ºC'),
	(17106, 110, '2015-01-15 00:07:13.000000', 'temperatura', 71.0000, 'ºC'),
	(17107, 110, '2015-01-15 00:07:14.000000', 'temperatura', 455.0000, 'ºC'),
	(17108, 110, '2015-01-15 00:07:15.000000', 'temperatura', 864.0000, 'ºC'),
	(17109, 110, '2015-01-15 00:07:16.000000', 'temperatura', 555.0000, 'ºC'),
	(17110, 110, '2015-01-15 00:07:17.000000', 'temperatura', 181.0000, 'ºC'),
	(17111, 110, '2015-01-15 00:07:18.000000', 'temperatura', 443.0000, 'ºC'),
	(17112, 110, '2015-01-15 00:07:19.000000', 'temperatura', 471.0000, 'ºC'),
	(17113, 110, '2015-01-15 00:07:20.000000', 'temperatura', 1026.0000, 'ºC'),
	(17114, 110, '2015-01-15 00:07:21.000000', 'temperatura', 119.0000, 'ºC'),
	(17115, 110, '2015-01-15 00:07:22.000000', 'temperatura', 1117.0000, 'ºC'),
	(17116, 110, '2015-01-15 00:07:23.000000', 'temperatura', 429.0000, 'ºC'),
	(17117, 110, '2015-01-15 00:07:24.000000', 'temperatura', 1192.0000, 'ºC'),
	(17118, 110, '2015-01-15 00:07:25.000000', 'temperatura', 1075.0000, 'ºC'),
	(17119, 110, '2015-01-15 00:07:26.000000', 'temperatura', 601.0000, 'ºC'),
	(17120, 110, '2015-01-15 00:07:27.000000', 'temperatura', 979.0000, 'ºC'),
	(17121, 110, '2015-01-15 00:07:28.000000', 'temperatura', 691.0000, 'ºC'),
	(17122, 110, '2015-01-15 00:07:29.000000', 'temperatura', 522.0000, 'ºC'),
	(17123, 110, '2015-01-15 00:07:30.000000', 'temperatura', 535.0000, 'ºC'),
	(17124, 110, '2015-01-15 00:07:31.000000', 'temperatura', 1112.0000, 'ºC'),
	(17125, 110, '2015-01-15 00:07:32.000000', 'temperatura', 355.0000, 'ºC'),
	(17126, 110, '2015-01-15 00:07:33.000000', 'temperatura', 837.0000, 'ºC'),
	(17127, 110, '2015-01-15 00:07:34.000000', 'temperatura', 724.0000, 'ºC'),
	(17128, 110, '2015-01-15 00:07:35.000000', 'temperatura', 1107.0000, 'ºC'),
	(17129, 110, '2015-01-15 00:07:36.000000', 'temperatura', 965.0000, 'ºC'),
	(17130, 110, '2015-01-15 00:07:37.000000', 'temperatura', 305.0000, 'ºC'),
	(17131, 110, '2015-01-15 00:07:38.000000', 'temperatura', 1028.0000, 'ºC'),
	(17132, 110, '2015-01-15 00:07:39.000000', 'temperatura', 626.0000, 'ºC'),
	(17133, 110, '2015-01-15 00:07:40.000000', 'temperatura', 46.0000, 'ºC'),
	(17134, 110, '2015-01-15 00:07:41.000000', 'temperatura', 751.0000, 'ºC'),
	(17135, 110, '2015-01-15 00:07:42.000000', 'temperatura', 20.0000, 'ºC'),
	(17136, 110, '2015-01-15 00:07:43.000000', 'temperatura', 246.0000, 'ºC'),
	(17137, 110, '2015-01-15 00:07:44.000000', 'temperatura', 1172.0000, 'ºC'),
	(17138, 110, '2015-01-15 00:07:45.000000', 'temperatura', 322.0000, 'ºC'),
	(17139, 110, '2015-01-15 00:07:46.000000', 'temperatura', 496.0000, 'ºC'),
	(17140, 110, '2015-01-15 00:07:47.000000', 'temperatura', 314.0000, 'ºC'),
	(17141, 110, '2015-01-15 00:07:48.000000', 'temperatura', 81.0000, 'ºC'),
	(17142, 110, '2015-01-15 00:07:49.000000', 'temperatura', 666.0000, 'ºC'),
	(17143, 110, '2015-01-15 00:07:50.000000', 'temperatura', 686.0000, 'ºC'),
	(17144, 110, '2015-01-15 00:07:51.000000', 'temperatura', 232.0000, 'ºC'),
	(17145, 110, '2015-01-15 00:07:52.000000', 'temperatura', 302.0000, 'ºC'),
	(17146, 110, '2015-01-15 00:07:53.000000', 'temperatura', 814.0000, 'ºC'),
	(17147, 110, '2015-01-15 00:07:54.000000', 'temperatura', 766.0000, 'ºC'),
	(17148, 110, '2015-01-15 00:07:55.000000', 'temperatura', 187.0000, 'ºC'),
	(17149, 110, '2015-01-15 00:07:56.000000', 'temperatura', 1037.0000, 'ºC'),
	(17150, 110, '2015-01-15 00:07:57.000000', 'temperatura', 1026.0000, 'ºC'),
	(17151, 110, '2015-01-15 00:07:58.000000', 'temperatura', 817.0000, 'ºC'),
	(17152, 110, '2015-01-15 00:07:59.000000', 'temperatura', 1009.0000, 'ºC'),
	(17153, 110, '2015-01-15 00:08:00.000000', 'temperatura', 194.0000, 'ºC'),
	(17154, 110, '2015-01-15 00:08:01.000000', 'temperatura', 346.0000, 'ºC'),
	(17155, 110, '2015-01-15 00:08:02.000000', 'temperatura', 1145.0000, 'ºC'),
	(17156, 110, '2015-01-15 00:08:03.000000', 'temperatura', 1089.0000, 'ºC'),
	(17157, 110, '2015-01-15 00:08:04.000000', 'temperatura', 809.0000, 'ºC'),
	(17158, 110, '2015-01-15 00:08:05.000000', 'temperatura', 779.0000, 'ºC'),
	(17159, 110, '2015-01-15 00:08:06.000000', 'temperatura', 267.0000, 'ºC'),
	(17160, 110, '2015-01-15 00:08:07.000000', 'temperatura', 201.0000, 'ºC'),
	(17161, 110, '2015-01-15 00:08:08.000000', 'temperatura', 203.0000, 'ºC'),
	(17162, 110, '2015-01-15 00:08:09.000000', 'temperatura', 411.0000, 'ºC'),
	(17163, 110, '2015-01-15 00:08:10.000000', 'temperatura', 248.0000, 'ºC'),
	(17164, 110, '2015-01-15 00:08:11.000000', 'temperatura', 7.0000, 'ºC'),
	(17165, 110, '2015-01-15 00:08:12.000000', 'temperatura', 494.0000, 'ºC'),
	(17166, 110, '2015-01-15 00:08:13.000000', 'temperatura', 46.0000, 'ºC'),
	(17167, 110, '2015-01-15 00:08:14.000000', 'temperatura', 1150.0000, 'ºC'),
	(17168, 110, '2015-01-15 00:08:15.000000', 'temperatura', 811.0000, 'ºC'),
	(17169, 110, '2015-01-15 00:08:16.000000', 'temperatura', 604.0000, 'ºC'),
	(17170, 110, '2015-01-15 00:08:17.000000', 'temperatura', 591.0000, 'ºC'),
	(17171, 110, '2015-01-15 00:08:18.000000', 'temperatura', 1144.0000, 'ºC'),
	(17172, 110, '2015-01-15 00:08:19.000000', 'temperatura', 345.0000, 'ºC'),
	(17173, 110, '2015-01-15 00:08:20.000000', 'temperatura', 696.0000, 'ºC'),
	(17174, 110, '2015-01-15 00:08:21.000000', 'temperatura', 45.0000, 'ºC'),
	(17175, 110, '2015-01-15 00:08:22.000000', 'temperatura', 537.0000, 'ºC'),
	(17176, 110, '2015-01-15 00:08:23.000000', 'temperatura', 152.0000, 'ºC'),
	(17177, 110, '2015-01-15 00:08:24.000000', 'temperatura', 347.0000, 'ºC'),
	(17178, 110, '2015-01-15 00:08:25.000000', 'temperatura', 79.0000, 'ºC'),
	(17179, 110, '2015-01-15 00:08:26.000000', 'temperatura', 557.0000, 'ºC'),
	(17180, 110, '2015-01-15 00:08:27.000000', 'temperatura', 147.0000, 'ºC'),
	(17181, 110, '2015-01-15 00:08:28.000000', 'temperatura', 264.0000, 'ºC'),
	(17182, 110, '2015-01-15 00:08:29.000000', 'temperatura', 880.0000, 'ºC'),
	(17183, 110, '2015-01-15 00:08:30.000000', 'temperatura', 10.0000, 'ºC'),
	(17184, 110, '2015-01-15 00:08:31.000000', 'temperatura', 1009.0000, 'ºC'),
	(17185, 110, '2015-01-15 00:08:32.000000', 'temperatura', 214.0000, 'ºC'),
	(17186, 110, '2015-01-15 00:08:33.000000', 'temperatura', 445.0000, 'ºC'),
	(17187, 110, '2015-01-15 00:08:34.000000', 'temperatura', 382.0000, 'ºC'),
	(17188, 110, '2015-01-15 00:08:35.000000', 'temperatura', 575.0000, 'ºC'),
	(17189, 110, '2015-01-15 00:08:36.000000', 'temperatura', 529.0000, 'ºC'),
	(17190, 110, '2015-01-15 00:08:37.000000', 'temperatura', 922.0000, 'ºC'),
	(17191, 110, '2015-01-15 00:08:38.000000', 'temperatura', 625.0000, 'ºC'),
	(17192, 110, '2015-01-15 00:08:39.000000', 'temperatura', 357.0000, 'ºC'),
	(17193, 110, '2015-01-15 00:08:40.000000', 'temperatura', 1111.0000, 'ºC'),
	(17194, 110, '2015-01-15 00:08:41.000000', 'temperatura', 884.0000, 'ºC'),
	(17195, 110, '2015-01-15 00:08:42.000000', 'temperatura', 1090.0000, 'ºC'),
	(17196, 110, '2015-01-15 00:08:43.000000', 'temperatura', 397.0000, 'ºC'),
	(17197, 110, '2015-01-15 00:08:44.000000', 'temperatura', 1117.0000, 'ºC'),
	(17198, 110, '2015-01-15 00:08:45.000000', 'temperatura', 795.0000, 'ºC'),
	(17199, 110, '2015-01-15 00:08:46.000000', 'temperatura', 625.0000, 'ºC'),
	(17200, 110, '2015-01-15 00:08:47.000000', 'temperatura', 740.0000, 'ºC'),
	(17201, 110, '2015-01-15 00:08:48.000000', 'temperatura', 625.0000, 'ºC'),
	(17202, 110, '2015-01-15 00:08:49.000000', 'temperatura', 907.0000, 'ºC'),
	(17203, 110, '2015-01-15 00:08:50.000000', 'temperatura', 259.0000, 'ºC'),
	(17204, 110, '2015-01-15 00:08:51.000000', 'temperatura', 975.0000, 'ºC'),
	(17205, 110, '2015-01-15 00:08:52.000000', 'temperatura', 500.0000, 'ºC'),
	(17206, 110, '2015-01-15 00:08:53.000000', 'temperatura', 774.0000, 'ºC'),
	(17207, 110, '2015-01-15 00:08:54.000000', 'temperatura', 1171.0000, 'ºC'),
	(17208, 110, '2015-01-15 00:08:55.000000', 'temperatura', 1132.0000, 'ºC'),
	(17209, 110, '2015-01-15 00:08:56.000000', 'temperatura', 949.0000, 'ºC'),
	(17210, 110, '2015-01-15 00:08:57.000000', 'temperatura', 149.0000, 'ºC'),
	(17211, 110, '2015-01-15 00:08:58.000000', 'temperatura', 298.0000, 'ºC'),
	(17212, 110, '2015-01-15 00:08:59.000000', 'temperatura', 1042.0000, 'ºC'),
	(17213, 110, '2015-01-15 00:09:00.000000', 'temperatura', 718.0000, 'ºC'),
	(17214, 110, '2015-01-15 00:09:01.000000', 'temperatura', 463.0000, 'ºC'),
	(17215, 110, '2015-01-15 00:09:02.000000', 'temperatura', 163.0000, 'ºC'),
	(17216, 110, '2015-01-15 00:09:03.000000', 'temperatura', 627.0000, 'ºC'),
	(17217, 110, '2015-01-15 00:09:04.000000', 'temperatura', 244.0000, 'ºC'),
	(17218, 110, '2015-01-15 00:09:05.000000', 'temperatura', 540.0000, 'ºC'),
	(17219, 110, '2015-01-15 00:09:06.000000', 'temperatura', 768.0000, 'ºC'),
	(17220, 110, '2015-01-15 00:09:07.000000', 'temperatura', 1020.0000, 'ºC'),
	(17221, 110, '2015-01-15 00:09:08.000000', 'temperatura', 399.0000, 'ºC'),
	(17222, 110, '2015-01-15 00:09:09.000000', 'temperatura', 135.0000, 'ºC'),
	(17223, 110, '2015-01-15 00:09:10.000000', 'temperatura', 679.0000, 'ºC'),
	(17224, 110, '2015-01-15 00:09:11.000000', 'temperatura', 591.0000, 'ºC'),
	(17225, 110, '2015-01-15 00:09:12.000000', 'temperatura', 918.0000, 'ºC'),
	(17226, 110, '2015-01-15 00:09:13.000000', 'temperatura', 419.0000, 'ºC'),
	(17227, 110, '2015-01-15 00:09:14.000000', 'temperatura', 539.0000, 'ºC'),
	(17228, 110, '2015-01-15 00:09:15.000000', 'temperatura', 239.0000, 'ºC'),
	(17229, 110, '2015-01-15 00:09:16.000000', 'temperatura', 780.0000, 'ºC'),
	(17230, 110, '2015-01-15 00:09:17.000000', 'temperatura', 781.0000, 'ºC'),
	(17231, 110, '2015-01-15 00:09:18.000000', 'temperatura', 367.0000, 'ºC'),
	(17232, 110, '2015-01-15 00:09:19.000000', 'temperatura', 693.0000, 'ºC'),
	(17233, 110, '2015-01-15 00:09:20.000000', 'temperatura', 1165.0000, 'ºC'),
	(17234, 110, '2015-01-15 00:09:21.000000', 'temperatura', 148.0000, 'ºC'),
	(17235, 110, '2015-01-15 00:09:22.000000', 'temperatura', 843.0000, 'ºC'),
	(17236, 110, '2015-01-15 00:09:23.000000', 'temperatura', 173.0000, 'ºC'),
	(17237, 110, '2015-01-15 00:09:24.000000', 'temperatura', 735.0000, 'ºC'),
	(17238, 110, '2015-01-15 00:09:25.000000', 'temperatura', 755.0000, 'ºC'),
	(17239, 110, '2015-01-15 00:09:26.000000', 'temperatura', 374.0000, 'ºC'),
	(17240, 110, '2015-01-15 00:09:27.000000', 'temperatura', 803.0000, 'ºC'),
	(17241, 110, '2015-01-15 00:09:28.000000', 'temperatura', 494.0000, 'ºC'),
	(17242, 110, '2015-01-15 00:09:29.000000', 'temperatura', 60.0000, 'ºC'),
	(17243, 110, '2015-01-15 00:09:30.000000', 'temperatura', 18.0000, 'ºC'),
	(17244, 110, '2015-01-15 00:09:31.000000', 'temperatura', 1111.0000, 'ºC'),
	(17245, 110, '2015-01-15 00:09:32.000000', 'temperatura', 704.0000, 'ºC'),
	(17246, 110, '2015-01-15 00:09:33.000000', 'temperatura', 186.0000, 'ºC'),
	(17247, 110, '2015-01-15 00:09:34.000000', 'temperatura', 20.0000, 'ºC'),
	(17248, 110, '2015-01-15 00:09:35.000000', 'temperatura', 741.0000, 'ºC'),
	(17249, 110, '2015-01-15 00:09:36.000000', 'temperatura', 48.0000, 'ºC'),
	(17250, 110, '2015-01-15 00:09:37.000000', 'temperatura', 416.0000, 'ºC'),
	(17251, 110, '2015-01-15 00:09:38.000000', 'temperatura', 736.0000, 'ºC'),
	(17252, 110, '2015-01-15 00:09:39.000000', 'temperatura', 33.0000, 'ºC'),
	(17253, 110, '2015-01-15 00:09:40.000000', 'temperatura', 359.0000, 'ºC'),
	(17254, 110, '2015-01-15 00:09:41.000000', 'temperatura', 493.0000, 'ºC'),
	(17255, 110, '2015-01-15 00:09:42.000000', 'temperatura', 192.0000, 'ºC'),
	(17256, 110, '2015-01-15 00:09:43.000000', 'temperatura', 681.0000, 'ºC'),
	(17257, 110, '2015-01-15 00:09:44.000000', 'temperatura', 427.0000, 'ºC'),
	(17258, 110, '2015-01-15 00:09:45.000000', 'temperatura', 96.0000, 'ºC'),
	(17259, 110, '2015-01-15 00:09:46.000000', 'temperatura', 396.0000, 'ºC'),
	(17260, 110, '2015-01-15 00:09:47.000000', 'temperatura', 495.0000, 'ºC'),
	(17261, 110, '2015-01-15 00:09:48.000000', 'temperatura', 86.0000, 'ºC'),
	(17262, 110, '2015-01-15 00:09:49.000000', 'temperatura', 145.0000, 'ºC'),
	(17263, 110, '2015-01-15 00:09:50.000000', 'temperatura', 467.0000, 'ºC'),
	(17264, 110, '2015-01-15 00:09:51.000000', 'temperatura', 701.0000, 'ºC'),
	(17265, 110, '2015-01-15 00:09:52.000000', 'temperatura', 903.0000, 'ºC'),
	(17266, 110, '2015-01-15 00:09:53.000000', 'temperatura', 13.0000, 'ºC'),
	(17267, 110, '2015-01-15 00:09:54.000000', 'temperatura', 957.0000, 'ºC'),
	(17268, 110, '2015-01-15 00:09:55.000000', 'temperatura', 1147.0000, 'ºC'),
	(17269, 110, '2015-01-15 00:09:56.000000', 'temperatura', 465.0000, 'ºC'),
	(17270, 110, '2015-01-15 00:09:57.000000', 'temperatura', 85.0000, 'ºC'),
	(17271, 110, '2015-01-15 00:09:58.000000', 'temperatura', 230.0000, 'ºC'),
	(17272, 110, '2015-01-15 00:09:59.000000', 'temperatura', 895.0000, 'ºC'),
	(17273, 110, '2015-01-15 00:10:00.000000', 'temperatura', 186.0000, 'ºC'),
	(17274, 110, '2015-01-15 00:10:01.000000', 'temperatura', 644.0000, 'ºC'),
	(17275, 110, '2015-01-15 00:10:02.000000', 'temperatura', 264.0000, 'ºC'),
	(17276, 110, '2015-01-15 00:10:03.000000', 'temperatura', 588.0000, 'ºC'),
	(17277, 110, '2015-01-15 00:10:04.000000', 'temperatura', 948.0000, 'ºC'),
	(17278, 110, '2015-01-15 00:10:05.000000', 'temperatura', 579.0000, 'ºC'),
	(17279, 110, '2015-01-15 00:10:06.000000', 'temperatura', 49.0000, 'ºC'),
	(17280, 110, '2015-01-15 00:10:07.000000', 'temperatura', 909.0000, 'ºC'),
	(17281, 110, '2015-01-15 00:10:08.000000', 'temperatura', 797.0000, 'ºC'),
	(17282, 110, '2015-01-15 00:10:09.000000', 'temperatura', 59.0000, 'ºC'),
	(17283, 110, '2015-01-15 00:10:10.000000', 'temperatura', 305.0000, 'ºC'),
	(17284, 110, '2015-01-15 00:10:11.000000', 'temperatura', 149.0000, 'ºC'),
	(17285, 110, '2015-01-15 00:10:12.000000', 'temperatura', 1028.0000, 'ºC'),
	(17286, 110, '2015-01-15 00:10:13.000000', 'temperatura', 1096.0000, 'ºC'),
	(17287, 110, '2015-01-15 00:10:14.000000', 'temperatura', 1194.0000, 'ºC'),
	(17288, 110, '2015-01-15 00:10:15.000000', 'temperatura', 283.0000, 'ºC'),
	(17289, 110, '2015-01-15 00:10:16.000000', 'temperatura', 233.0000, 'ºC'),
	(17290, 110, '2015-01-15 00:10:17.000000', 'temperatura', 316.0000, 'ºC'),
	(17291, 110, '2015-01-15 00:10:18.000000', 'temperatura', 882.0000, 'ºC'),
	(17292, 110, '2015-01-15 00:10:19.000000', 'temperatura', 1064.0000, 'ºC'),
	(17293, 110, '2015-01-15 00:10:20.000000', 'temperatura', 273.0000, 'ºC'),
	(17294, 110, '2015-01-15 00:10:21.000000', 'temperatura', 574.0000, 'ºC'),
	(17295, 110, '2015-01-15 00:10:22.000000', 'temperatura', 850.0000, 'ºC'),
	(17296, 110, '2015-01-15 00:10:23.000000', 'temperatura', 130.0000, 'ºC'),
	(17297, 110, '2015-01-15 00:10:24.000000', 'temperatura', 501.0000, 'ºC'),
	(17298, 110, '2015-01-15 00:10:25.000000', 'temperatura', 915.0000, 'ºC'),
	(17299, 110, '2015-01-15 00:10:26.000000', 'temperatura', 674.0000, 'ºC'),
	(17300, 110, '2015-01-15 00:10:27.000000', 'temperatura', 626.0000, 'ºC'),
	(17301, 110, '2015-01-15 00:10:28.000000', 'temperatura', 1106.0000, 'ºC'),
	(17302, 110, '2015-01-15 00:10:29.000000', 'temperatura', 53.0000, 'ºC'),
	(17303, 110, '2015-01-15 00:10:30.000000', 'temperatura', 547.0000, 'ºC'),
	(17304, 110, '2015-01-15 00:10:31.000000', 'temperatura', 179.0000, 'ºC'),
	(17305, 110, '2015-01-15 00:10:32.000000', 'temperatura', 453.0000, 'ºC'),
	(17306, 110, '2015-01-15 00:10:33.000000', 'temperatura', 528.0000, 'ºC'),
	(17307, 110, '2015-01-15 00:10:34.000000', 'temperatura', 84.0000, 'ºC'),
	(17308, 110, '2015-01-15 00:10:35.000000', 'temperatura', 35.0000, 'ºC'),
	(17309, 110, '2015-01-15 00:10:36.000000', 'temperatura', 1125.0000, 'ºC'),
	(17310, 110, '2015-01-15 00:10:37.000000', 'temperatura', 719.0000, 'ºC'),
	(17311, 110, '2015-01-15 00:10:38.000000', 'temperatura', 219.0000, 'ºC'),
	(17312, 110, '2015-01-15 00:10:39.000000', 'temperatura', 139.0000, 'ºC'),
	(17313, 110, '2015-01-15 00:10:40.000000', 'temperatura', 38.0000, 'ºC'),
	(17314, 110, '2015-01-15 00:10:41.000000', 'temperatura', 974.0000, 'ºC'),
	(17315, 110, '2015-01-15 00:10:42.000000', 'temperatura', 1155.0000, 'ºC'),
	(17316, 110, '2015-01-15 00:10:43.000000', 'temperatura', 455.0000, 'ºC'),
	(17317, 110, '2015-01-15 00:10:44.000000', 'temperatura', 11.0000, 'ºC'),
	(17318, 110, '2015-01-15 00:10:45.000000', 'temperatura', 1089.0000, 'ºC'),
	(17319, 110, '2015-01-15 00:10:46.000000', 'temperatura', 614.0000, 'ºC'),
	(17320, 110, '2015-01-15 00:10:47.000000', 'temperatura', 1001.0000, 'ºC'),
	(17321, 110, '2015-01-15 00:10:48.000000', 'temperatura', 767.0000, 'ºC'),
	(17322, 110, '2015-01-15 00:10:49.000000', 'temperatura', 829.0000, 'ºC'),
	(17323, 110, '2015-01-15 00:10:50.000000', 'temperatura', 648.0000, 'ºC'),
	(17324, 110, '2015-01-15 00:10:51.000000', 'temperatura', 752.0000, 'ºC'),
	(17325, 110, '2015-01-15 00:10:52.000000', 'temperatura', 616.0000, 'ºC'),
	(17326, 110, '2015-01-15 00:10:53.000000', 'temperatura', 824.0000, 'ºC'),
	(17327, 110, '2015-01-15 00:10:54.000000', 'temperatura', 1072.0000, 'ºC'),
	(17328, 110, '2015-01-15 00:10:55.000000', 'temperatura', 488.0000, 'ºC'),
	(17329, 110, '2015-01-15 00:10:56.000000', 'temperatura', 423.0000, 'ºC'),
	(17330, 110, '2015-01-15 00:10:57.000000', 'temperatura', 655.0000, 'ºC'),
	(17331, 110, '2015-01-15 00:10:58.000000', 'temperatura', 805.0000, 'ºC'),
	(17332, 110, '2015-01-15 00:10:59.000000', 'temperatura', 862.0000, 'ºC'),
	(17333, 110, '2015-01-15 00:11:00.000000', 'temperatura', 694.0000, 'ºC'),
	(17334, 110, '2015-01-15 00:11:01.000000', 'temperatura', 884.0000, 'ºC'),
	(17335, 110, '2015-01-15 00:11:02.000000', 'temperatura', 1138.0000, 'ºC'),
	(17336, 110, '2015-01-15 00:11:03.000000', 'temperatura', 639.0000, 'ºC'),
	(17337, 110, '2015-01-15 00:11:04.000000', 'temperatura', 982.0000, 'ºC'),
	(17338, 110, '2015-01-15 00:11:05.000000', 'temperatura', 593.0000, 'ºC'),
	(17339, 110, '2015-01-15 00:11:06.000000', 'temperatura', 20.0000, 'ºC'),
	(17340, 110, '2015-01-15 00:11:07.000000', 'temperatura', 722.0000, 'ºC'),
	(17341, 110, '2015-01-15 00:11:08.000000', 'temperatura', 1151.0000, 'ºC'),
	(17342, 110, '2015-01-15 00:11:09.000000', 'temperatura', 1189.0000, 'ºC'),
	(17343, 110, '2015-01-15 00:11:10.000000', 'temperatura', 90.0000, 'ºC'),
	(17344, 110, '2015-01-15 00:11:11.000000', 'temperatura', 487.0000, 'ºC'),
	(17345, 110, '2015-01-15 00:11:12.000000', 'temperatura', 965.0000, 'ºC'),
	(17346, 110, '2015-01-15 00:11:13.000000', 'temperatura', 964.0000, 'ºC'),
	(17347, 110, '2015-01-15 00:11:14.000000', 'temperatura', 725.0000, 'ºC'),
	(17348, 110, '2015-01-15 00:11:15.000000', 'temperatura', 735.0000, 'ºC'),
	(17349, 110, '2015-01-15 00:11:16.000000', 'temperatura', 301.0000, 'ºC'),
	(17350, 110, '2015-01-15 00:11:17.000000', 'temperatura', 498.0000, 'ºC'),
	(17351, 110, '2015-01-15 00:11:18.000000', 'temperatura', 387.0000, 'ºC'),
	(17352, 110, '2015-01-15 00:11:19.000000', 'temperatura', 443.0000, 'ºC'),
	(17353, 110, '2015-01-15 00:11:20.000000', 'temperatura', 1055.0000, 'ºC'),
	(17354, 110, '2015-01-15 00:11:21.000000', 'temperatura', 345.0000, 'ºC'),
	(17355, 110, '2015-01-15 00:11:22.000000', 'temperatura', 961.0000, 'ºC'),
	(17356, 110, '2015-01-15 00:11:23.000000', 'temperatura', 170.0000, 'ºC'),
	(17357, 110, '2015-01-15 00:11:24.000000', 'temperatura', 369.0000, 'ºC'),
	(17358, 110, '2015-01-15 00:11:25.000000', 'temperatura', 137.0000, 'ºC'),
	(17359, 110, '2015-01-15 00:11:26.000000', 'temperatura', 776.0000, 'ºC'),
	(17360, 110, '2015-01-15 00:11:27.000000', 'temperatura', 1071.0000, 'ºC'),
	(17361, 110, '2015-01-15 00:11:28.000000', 'temperatura', 628.0000, 'ºC'),
	(17362, 110, '2015-01-15 00:11:29.000000', 'temperatura', 1125.0000, 'ºC'),
	(17363, 110, '2015-01-15 00:11:30.000000', 'temperatura', 143.0000, 'ºC'),
	(17364, 110, '2015-01-15 00:11:31.000000', 'temperatura', 940.0000, 'ºC'),
	(17365, 110, '2015-01-15 00:11:32.000000', 'temperatura', 673.0000, 'ºC'),
	(17366, 110, '2015-01-15 00:11:33.000000', 'temperatura', 543.0000, 'ºC'),
	(17367, 110, '2015-01-15 00:11:34.000000', 'temperatura', 696.0000, 'ºC'),
	(17368, 110, '2015-01-15 00:11:35.000000', 'temperatura', 651.0000, 'ºC'),
	(17369, 110, '2015-01-15 00:11:36.000000', 'temperatura', 1170.0000, 'ºC'),
	(17370, 110, '2015-01-15 00:11:37.000000', 'temperatura', 296.0000, 'ºC'),
	(17371, 110, '2015-01-15 00:11:38.000000', 'temperatura', 371.0000, 'ºC'),
	(17372, 110, '2015-01-15 00:11:39.000000', 'temperatura', 969.0000, 'ºC'),
	(17373, 110, '2015-01-15 00:11:40.000000', 'temperatura', 132.0000, 'ºC'),
	(17374, 110, '2015-01-15 00:11:41.000000', 'temperatura', 154.0000, 'ºC'),
	(17375, 110, '2015-01-15 00:11:42.000000', 'temperatura', 372.0000, 'ºC'),
	(17376, 110, '2015-01-15 00:11:43.000000', 'temperatura', 199.0000, 'ºC'),
	(17377, 110, '2015-01-15 00:11:44.000000', 'temperatura', 1082.0000, 'ºC'),
	(17378, 110, '2015-01-15 00:11:45.000000', 'temperatura', 11.0000, 'ºC'),
	(17379, 110, '2015-01-15 00:11:46.000000', 'temperatura', 412.0000, 'ºC'),
	(17380, 110, '2015-01-15 00:11:47.000000', 'temperatura', 825.0000, 'ºC'),
	(17381, 110, '2015-01-15 00:11:48.000000', 'temperatura', 491.0000, 'ºC'),
	(17382, 110, '2015-01-15 00:11:49.000000', 'temperatura', 1178.0000, 'ºC'),
	(17383, 110, '2015-01-15 00:11:50.000000', 'temperatura', 820.0000, 'ºC'),
	(17384, 110, '2015-01-15 00:11:51.000000', 'temperatura', 564.0000, 'ºC'),
	(17385, 110, '2015-01-15 00:11:52.000000', 'temperatura', 362.0000, 'ºC'),
	(17386, 110, '2015-01-15 00:11:53.000000', 'temperatura', 118.0000, 'ºC'),
	(17387, 110, '2015-01-15 00:11:54.000000', 'temperatura', 705.0000, 'ºC'),
	(17388, 110, '2015-01-15 00:11:55.000000', 'temperatura', 772.0000, 'ºC'),
	(17389, 110, '2015-01-15 00:11:56.000000', 'temperatura', 547.0000, 'ºC'),
	(17390, 110, '2015-01-15 00:11:57.000000', 'temperatura', 418.0000, 'ºC'),
	(17391, 110, '2015-01-15 00:11:58.000000', 'temperatura', 451.0000, 'ºC'),
	(17392, 110, '2015-01-15 00:11:59.000000', 'temperatura', 1002.0000, 'ºC'),
	(17393, 110, '2015-01-15 00:12:00.000000', 'temperatura', 55.0000, 'ºC'),
	(17394, 110, '2015-01-15 00:12:01.000000', 'temperatura', 872.0000, 'ºC'),
	(17395, 110, '2015-01-15 00:12:02.000000', 'temperatura', 593.0000, 'ºC'),
	(17396, 110, '2015-01-15 00:12:03.000000', 'temperatura', 350.0000, 'ºC'),
	(17397, 110, '2015-01-15 00:12:04.000000', 'temperatura', 1171.0000, 'ºC'),
	(17398, 110, '2015-01-15 00:12:05.000000', 'temperatura', 6.0000, 'ºC'),
	(17399, 110, '2015-01-15 00:12:06.000000', 'temperatura', 116.0000, 'ºC'),
	(17400, 110, '2015-01-15 00:12:07.000000', 'temperatura', 563.0000, 'ºC'),
	(17401, 110, '2015-01-15 00:12:08.000000', 'temperatura', 67.0000, 'ºC'),
	(17402, 110, '2015-01-15 00:12:09.000000', 'temperatura', 1045.0000, 'ºC'),
	(17403, 110, '2015-01-15 00:12:10.000000', 'temperatura', 228.0000, 'ºC'),
	(17404, 110, '2015-01-15 00:12:11.000000', 'temperatura', 402.0000, 'ºC'),
	(17405, 110, '2015-01-15 00:12:12.000000', 'temperatura', 128.0000, 'ºC'),
	(17406, 110, '2015-01-15 00:12:13.000000', 'temperatura', 635.0000, 'ºC'),
	(17407, 110, '2015-01-15 00:12:14.000000', 'temperatura', 392.0000, 'ºC'),
	(17408, 110, '2015-01-15 00:12:15.000000', 'temperatura', 56.0000, 'ºC'),
	(17409, 110, '2015-01-15 00:12:16.000000', 'temperatura', 303.0000, 'ºC'),
	(17410, 110, '2015-01-15 00:12:17.000000', 'temperatura', 148.0000, 'ºC'),
	(17411, 110, '2015-01-15 00:12:18.000000', 'temperatura', 1033.0000, 'ºC'),
	(17412, 110, '2015-01-15 00:12:19.000000', 'temperatura', 1123.0000, 'ºC'),
	(17413, 110, '2015-01-15 00:12:20.000000', 'temperatura', 113.0000, 'ºC'),
	(17414, 110, '2015-01-15 00:12:21.000000', 'temperatura', 797.0000, 'ºC'),
	(17415, 110, '2015-01-15 00:12:22.000000', 'temperatura', 46.0000, 'ºC'),
	(17416, 110, '2015-01-15 00:12:23.000000', 'temperatura', 241.0000, 'ºC'),
	(17417, 110, '2015-01-15 00:12:24.000000', 'temperatura', 1067.0000, 'ºC'),
	(17418, 110, '2015-01-15 00:12:25.000000', 'temperatura', 1012.0000, 'ºC'),
	(17419, 110, '2015-01-15 00:12:26.000000', 'temperatura', 660.0000, 'ºC'),
	(17420, 110, '2015-01-15 00:12:27.000000', 'temperatura', 262.0000, 'ºC'),
	(17421, 110, '2015-01-15 00:12:28.000000', 'temperatura', 534.0000, 'ºC'),
	(17422, 110, '2015-01-15 00:12:29.000000', 'temperatura', 683.0000, 'ºC'),
	(17423, 110, '2015-01-15 00:12:30.000000', 'temperatura', 613.0000, 'ºC'),
	(17424, 110, '2015-01-15 00:12:31.000000', 'temperatura', 1019.0000, 'ºC'),
	(17425, 110, '2015-01-15 00:12:32.000000', 'temperatura', 853.0000, 'ºC'),
	(17426, 110, '2015-01-15 00:12:33.000000', 'temperatura', 10.0000, 'ºC'),
	(17427, 110, '2015-01-15 00:12:34.000000', 'temperatura', 1091.0000, 'ºC'),
	(17428, 110, '2015-01-15 00:12:35.000000', 'temperatura', 627.0000, 'ºC'),
	(17429, 110, '2015-01-15 00:12:36.000000', 'temperatura', 1060.0000, 'ºC'),
	(17430, 110, '2015-01-15 00:12:37.000000', 'temperatura', 1022.0000, 'ºC'),
	(17431, 110, '2015-01-15 00:12:38.000000', 'temperatura', 730.0000, 'ºC'),
	(17432, 110, '2015-01-15 00:12:39.000000', 'temperatura', 583.0000, 'ºC'),
	(17433, 110, '2015-01-15 00:12:40.000000', 'temperatura', 724.0000, 'ºC'),
	(17434, 110, '2015-01-15 00:12:41.000000', 'temperatura', 674.0000, 'ºC'),
	(17435, 110, '2015-01-15 00:12:42.000000', 'temperatura', 1199.0000, 'ºC'),
	(17436, 110, '2015-01-15 00:12:43.000000', 'temperatura', 372.0000, 'ºC'),
	(17437, 110, '2015-01-15 00:12:44.000000', 'temperatura', 666.0000, 'ºC'),
	(17438, 110, '2015-01-15 00:12:45.000000', 'temperatura', 1011.0000, 'ºC'),
	(17439, 110, '2015-01-15 00:12:46.000000', 'temperatura', 660.0000, 'ºC'),
	(17440, 110, '2015-01-15 00:12:47.000000', 'temperatura', 266.0000, 'ºC'),
	(17441, 110, '2015-01-15 00:12:48.000000', 'temperatura', 551.0000, 'ºC'),
	(17442, 110, '2015-01-15 00:12:49.000000', 'temperatura', 755.0000, 'ºC'),
	(17443, 110, '2015-01-15 00:12:50.000000', 'temperatura', 926.0000, 'ºC'),
	(17444, 110, '2015-01-15 00:12:51.000000', 'temperatura', 1165.0000, 'ºC'),
	(17445, 110, '2015-01-15 00:12:52.000000', 'temperatura', 647.0000, 'ºC'),
	(17446, 110, '2015-01-15 00:12:53.000000', 'temperatura', 940.0000, 'ºC'),
	(17447, 110, '2015-01-15 00:12:54.000000', 'temperatura', 358.0000, 'ºC'),
	(17448, 110, '2015-01-15 00:12:55.000000', 'temperatura', 172.0000, 'ºC'),
	(17449, 110, '2015-01-15 00:12:56.000000', 'temperatura', 988.0000, 'ºC'),
	(17450, 110, '2015-01-15 00:12:57.000000', 'temperatura', 823.0000, 'ºC'),
	(17451, 110, '2015-01-15 00:12:58.000000', 'temperatura', 1152.0000, 'ºC'),
	(17452, 110, '2015-01-15 00:12:59.000000', 'temperatura', 891.0000, 'ºC'),
	(17453, 110, '2015-01-15 00:13:00.000000', 'temperatura', 1001.0000, 'ºC'),
	(17454, 110, '2015-01-15 00:13:01.000000', 'temperatura', 1132.0000, 'ºC'),
	(17455, 110, '2015-01-15 00:13:02.000000', 'temperatura', 257.0000, 'ºC'),
	(17456, 110, '2015-01-15 00:13:03.000000', 'temperatura', 288.0000, 'ºC'),
	(17457, 110, '2015-01-15 00:13:04.000000', 'temperatura', 671.0000, 'ºC'),
	(17458, 110, '2015-01-15 00:13:05.000000', 'temperatura', 93.0000, 'ºC'),
	(17459, 110, '2015-01-15 00:13:06.000000', 'temperatura', 851.0000, 'ºC'),
	(17460, 110, '2015-01-15 00:13:07.000000', 'temperatura', 377.0000, 'ºC'),
	(17461, 110, '2015-01-15 00:13:08.000000', 'temperatura', 534.0000, 'ºC'),
	(17462, 110, '2015-01-15 00:13:09.000000', 'temperatura', 339.0000, 'ºC'),
	(17463, 110, '2015-01-15 00:13:10.000000', 'temperatura', 94.0000, 'ºC'),
	(17464, 110, '2015-01-15 00:13:11.000000', 'temperatura', 652.0000, 'ºC'),
	(17465, 110, '2015-01-15 00:13:12.000000', 'temperatura', 580.0000, 'ºC'),
	(17466, 110, '2015-01-15 00:13:13.000000', 'temperatura', 942.0000, 'ºC'),
	(17467, 110, '2015-01-15 00:13:14.000000', 'temperatura', 571.0000, 'ºC'),
	(17468, 110, '2015-01-15 00:13:15.000000', 'temperatura', 32.0000, 'ºC'),
	(17469, 110, '2015-01-15 00:13:16.000000', 'temperatura', 844.0000, 'ºC'),
	(17470, 110, '2015-01-15 00:13:17.000000', 'temperatura', 526.0000, 'ºC'),
	(17471, 110, '2015-01-15 00:13:18.000000', 'temperatura', 101.0000, 'ºC'),
	(17472, 110, '2015-01-15 00:13:19.000000', 'temperatura', 124.0000, 'ºC'),
	(17473, 110, '2015-01-15 00:13:20.000000', 'temperatura', 319.0000, 'ºC'),
	(17474, 110, '2015-01-15 00:13:21.000000', 'temperatura', 23.0000, 'ºC'),
	(17475, 110, '2015-01-15 00:13:22.000000', 'temperatura', 360.0000, 'ºC'),
	(17476, 110, '2015-01-15 00:13:23.000000', 'temperatura', 531.0000, 'ºC'),
	(17477, 110, '2015-01-15 00:13:24.000000', 'temperatura', 374.0000, 'ºC'),
	(17478, 110, '2015-01-15 00:13:25.000000', 'temperatura', 277.0000, 'ºC'),
	(17479, 110, '2015-01-15 00:13:26.000000', 'temperatura', 264.0000, 'ºC'),
	(17480, 110, '2015-01-15 00:13:27.000000', 'temperatura', 491.0000, 'ºC'),
	(17481, 110, '2015-01-15 00:13:28.000000', 'temperatura', 461.0000, 'ºC'),
	(17482, 110, '2015-01-15 00:13:29.000000', 'temperatura', 832.0000, 'ºC'),
	(17483, 110, '2015-01-15 00:13:30.000000', 'temperatura', 380.0000, 'ºC'),
	(17484, 110, '2015-01-15 00:13:31.000000', 'temperatura', 605.0000, 'ºC'),
	(17485, 110, '2015-01-15 00:13:32.000000', 'temperatura', 686.0000, 'ºC'),
	(17486, 110, '2015-01-15 00:13:33.000000', 'temperatura', 413.0000, 'ºC'),
	(17487, 110, '2015-01-15 00:13:34.000000', 'temperatura', 9.0000, 'ºC'),
	(17488, 110, '2015-01-15 00:13:35.000000', 'temperatura', 8.0000, 'ºC'),
	(17489, 110, '2015-01-15 00:13:36.000000', 'temperatura', 12.0000, 'ºC'),
	(17490, 110, '2015-01-15 00:13:37.000000', 'temperatura', 35.0000, 'ºC'),
	(17491, 110, '2015-01-15 00:13:38.000000', 'temperatura', 142.0000, 'ºC'),
	(17492, 110, '2015-01-15 00:13:39.000000', 'temperatura', 603.0000, 'ºC'),
	(17493, 110, '2015-01-15 00:13:40.000000', 'temperatura', 191.0000, 'ºC'),
	(17494, 110, '2015-01-15 00:13:41.000000', 'temperatura', 345.0000, 'ºC'),
	(17495, 110, '2015-01-15 00:13:42.000000', 'temperatura', 1152.0000, 'ºC'),
	(17496, 110, '2015-01-15 00:13:43.000000', 'temperatura', 1128.0000, 'ºC'),
	(17497, 110, '2015-01-15 00:13:44.000000', 'temperatura', 982.0000, 'ºC'),
	(17498, 110, '2015-01-15 00:13:45.000000', 'temperatura', 329.0000, 'ºC'),
	(17499, 110, '2015-01-15 00:13:46.000000', 'temperatura', 1098.0000, 'ºC'),
	(17500, 110, '2015-01-15 00:13:47.000000', 'temperatura', 905.0000, 'ºC'),
	(17501, 110, '2015-01-15 00:13:48.000000', 'temperatura', 29.0000, 'ºC'),
	(17502, 110, '2015-01-15 00:13:49.000000', 'temperatura', 1030.0000, 'ºC'),
	(17503, 110, '2015-01-15 00:13:50.000000', 'temperatura', 265.0000, 'ºC'),
	(17504, 110, '2015-01-15 00:13:51.000000', 'temperatura', 633.0000, 'ºC'),
	(17505, 110, '2015-01-15 00:13:52.000000', 'temperatura', 1173.0000, 'ºC'),
	(17506, 110, '2015-01-15 00:13:53.000000', 'temperatura', 365.0000, 'ºC'),
	(17507, 110, '2015-01-15 00:13:54.000000', 'temperatura', 709.0000, 'ºC'),
	(17508, 110, '2015-01-15 00:13:55.000000', 'temperatura', 48.0000, 'ºC'),
	(17509, 110, '2015-01-15 00:13:56.000000', 'temperatura', 514.0000, 'ºC'),
	(17510, 110, '2015-01-15 00:13:57.000000', 'temperatura', 26.0000, 'ºC'),
	(17511, 110, '2015-01-15 00:13:58.000000', 'temperatura', 989.0000, 'ºC'),
	(17512, 110, '2015-01-15 00:13:59.000000', 'temperatura', 69.0000, 'ºC'),
	(17513, 110, '2015-01-15 00:14:00.000000', 'temperatura', 977.0000, 'ºC'),
	(17514, 110, '2015-01-15 00:14:01.000000', 'temperatura', 1081.0000, 'ºC'),
	(17515, 110, '2015-01-15 00:14:02.000000', 'temperatura', 73.0000, 'ºC'),
	(17516, 110, '2015-01-15 00:14:03.000000', 'temperatura', 721.0000, 'ºC'),
	(17517, 110, '2015-01-15 00:14:04.000000', 'temperatura', 987.0000, 'ºC'),
	(17518, 110, '2015-01-15 00:14:05.000000', 'temperatura', 374.0000, 'ºC'),
	(17519, 110, '2015-01-15 00:14:06.000000', 'temperatura', 109.0000, 'ºC'),
	(17520, 110, '2015-01-15 00:14:07.000000', 'temperatura', 623.0000, 'ºC'),
	(17521, 110, '2015-01-15 00:14:08.000000', 'temperatura', 390.0000, 'ºC'),
	(17522, 110, '2015-01-15 00:14:09.000000', 'temperatura', 82.0000, 'ºC'),
	(17523, 110, '2015-01-15 00:14:10.000000', 'temperatura', 441.0000, 'ºC'),
	(17524, 110, '2015-01-15 00:14:11.000000', 'temperatura', 760.0000, 'ºC'),
	(17525, 110, '2015-01-15 00:14:12.000000', 'temperatura', 77.0000, 'ºC'),
	(17526, 110, '2015-01-15 00:14:13.000000', 'temperatura', 506.0000, 'ºC'),
	(17527, 110, '2015-01-15 00:14:14.000000', 'temperatura', 1097.0000, 'ºC'),
	(17528, 110, '2015-01-15 00:14:15.000000', 'temperatura', 368.0000, 'ºC'),
	(17529, 110, '2015-01-15 00:14:16.000000', 'temperatura', 950.0000, 'ºC'),
	(17530, 110, '2015-01-15 00:14:17.000000', 'temperatura', 45.0000, 'ºC'),
	(17531, 110, '2015-01-15 00:14:18.000000', 'temperatura', 976.0000, 'ºC'),
	(17532, 110, '2015-01-15 00:14:19.000000', 'temperatura', 1147.0000, 'ºC'),
	(17533, 110, '2015-01-15 00:14:20.000000', 'temperatura', 407.0000, 'ºC'),
	(17534, 110, '2015-01-15 00:14:21.000000', 'temperatura', 994.0000, 'ºC'),
	(17535, 110, '2015-01-15 00:14:22.000000', 'temperatura', 149.0000, 'ºC'),
	(17536, 110, '2015-01-15 00:14:23.000000', 'temperatura', 163.0000, 'ºC'),
	(17537, 110, '2015-01-15 00:14:24.000000', 'temperatura', 368.0000, 'ºC'),
	(17538, 110, '2015-01-15 00:14:25.000000', 'temperatura', 153.0000, 'ºC'),
	(17539, 110, '2015-01-15 00:14:26.000000', 'temperatura', 862.0000, 'ºC'),
	(17540, 110, '2015-01-15 00:14:27.000000', 'temperatura', 252.0000, 'ºC'),
	(17541, 110, '2015-01-15 00:14:28.000000', 'temperatura', 1073.0000, 'ºC'),
	(17542, 110, '2015-01-15 00:14:29.000000', 'temperatura', 1008.0000, 'ºC'),
	(17543, 110, '2015-01-15 00:14:30.000000', 'temperatura', 625.0000, 'ºC'),
	(17544, 110, '2015-01-15 00:14:31.000000', 'temperatura', 99.0000, 'ºC'),
	(17545, 110, '2015-01-15 00:14:32.000000', 'temperatura', 1021.0000, 'ºC'),
	(17546, 110, '2015-01-15 00:14:33.000000', 'temperatura', 8.0000, 'ºC'),
	(17547, 110, '2015-01-15 00:14:34.000000', 'temperatura', 578.0000, 'ºC'),
	(17548, 110, '2015-01-15 00:14:35.000000', 'temperatura', 465.0000, 'ºC'),
	(17549, 110, '2015-01-15 00:14:36.000000', 'temperatura', 591.0000, 'ºC'),
	(17550, 110, '2015-01-15 00:14:37.000000', 'temperatura', 360.0000, 'ºC'),
	(17551, 110, '2015-01-15 00:14:38.000000', 'temperatura', 28.0000, 'ºC'),
	(17552, 110, '2015-01-15 00:14:39.000000', 'temperatura', 260.0000, 'ºC'),
	(17553, 110, '2015-01-15 00:14:40.000000', 'temperatura', 16.0000, 'ºC'),
	(17554, 110, '2015-01-15 00:14:41.000000', 'temperatura', 499.0000, 'ºC'),
	(17555, 110, '2015-01-15 00:14:42.000000', 'temperatura', 50.0000, 'ºC'),
	(17556, 110, '2015-01-15 00:14:43.000000', 'temperatura', 1155.0000, 'ºC'),
	(17557, 110, '2015-01-15 00:14:44.000000', 'temperatura', 822.0000, 'ºC'),
	(17558, 110, '2015-01-15 00:14:45.000000', 'temperatura', 647.0000, 'ºC'),
	(17559, 110, '2015-01-15 00:14:46.000000', 'temperatura', 770.0000, 'ºC'),
	(17560, 110, '2015-01-15 00:14:47.000000', 'temperatura', 709.0000, 'ºC'),
	(17561, 110, '2015-01-15 00:14:48.000000', 'temperatura', 35.0000, 'ºC'),
	(17562, 110, '2015-01-15 00:14:49.000000', 'temperatura', 447.0000, 'ºC'),
	(17563, 110, '2015-01-15 00:14:50.000000', 'temperatura', 931.0000, 'ºC'),
	(17564, 110, '2015-01-15 00:14:51.000000', 'temperatura', 915.0000, 'ºC'),
	(17565, 110, '2015-01-15 00:14:52.000000', 'temperatura', 581.0000, 'ºC'),
	(17566, 110, '2015-01-15 00:14:53.000000', 'temperatura', 160.0000, 'ºC'),
	(17567, 110, '2015-01-15 00:14:54.000000', 'temperatura', 259.0000, 'ºC'),
	(17568, 110, '2015-01-15 00:14:55.000000', 'temperatura', 817.0000, 'ºC'),
	(17569, 110, '2015-01-15 00:14:56.000000', 'temperatura', 907.0000, 'ºC'),
	(17570, 110, '2015-01-15 00:14:57.000000', 'temperatura', 886.0000, 'ºC'),
	(17571, 110, '2015-01-15 00:14:58.000000', 'temperatura', 510.0000, 'ºC'),
	(17572, 110, '2015-01-15 00:14:59.000000', 'temperatura', 1091.0000, 'ºC'),
	(17573, 110, '2015-01-15 00:15:00.000000', 'temperatura', 325.0000, 'ºC'),
	(17574, 110, '2015-01-15 00:15:01.000000', 'temperatura', 752.0000, 'ºC'),
	(17575, 110, '2015-01-15 00:15:02.000000', 'temperatura', 385.0000, 'ºC'),
	(17576, 110, '2015-01-15 00:15:03.000000', 'temperatura', 871.0000, 'ºC'),
	(17577, 110, '2015-01-15 00:15:04.000000', 'temperatura', 801.0000, 'ºC'),
	(17578, 110, '2015-01-15 00:15:05.000000', 'temperatura', 193.0000, 'ºC'),
	(17579, 110, '2015-01-15 00:15:06.000000', 'temperatura', 960.0000, 'ºC'),
	(17580, 110, '2015-01-15 00:15:07.000000', 'temperatura', 622.0000, 'ºC'),
	(17581, 110, '2015-01-15 00:15:08.000000', 'temperatura', 232.0000, 'ºC'),
	(17582, 110, '2015-01-15 00:15:09.000000', 'temperatura', 495.0000, 'ºC'),
	(17583, 110, '2015-01-15 00:15:10.000000', 'temperatura', 579.0000, 'ºC'),
	(17584, 110, '2015-01-15 00:15:11.000000', 'temperatura', 209.0000, 'ºC'),
	(17585, 110, '2015-01-15 00:15:12.000000', 'temperatura', 509.0000, 'ºC'),
	(17586, 110, '2015-01-15 00:15:13.000000', 'temperatura', 717.0000, 'ºC'),
	(17587, 110, '2015-01-15 00:15:14.000000', 'temperatura', 859.0000, 'ºC'),
	(17588, 110, '2015-01-15 00:15:15.000000', 'temperatura', 943.0000, 'ºC'),
	(17589, 110, '2015-01-15 00:15:16.000000', 'temperatura', 940.0000, 'ºC'),
	(17590, 110, '2015-01-15 00:15:17.000000', 'temperatura', 671.0000, 'ºC'),
	(17591, 110, '2015-01-15 00:15:18.000000', 'temperatura', 536.0000, 'ºC'),
	(17592, 110, '2015-01-15 00:15:19.000000', 'temperatura', 668.0000, 'ºC'),
	(17593, 110, '2015-01-15 00:15:20.000000', 'temperatura', 531.0000, 'ºC'),
	(17594, 110, '2015-01-15 00:15:21.000000', 'temperatura', 651.0000, 'ºC'),
	(17595, 110, '2015-01-15 00:15:22.000000', 'temperatura', 464.0000, 'ºC'),
	(17596, 110, '2015-01-15 00:15:23.000000', 'temperatura', 367.0000, 'ºC'),
	(17597, 110, '2015-01-15 00:15:24.000000', 'temperatura', 445.0000, 'ºC'),
	(17598, 110, '2015-01-15 00:15:25.000000', 'temperatura', 1122.0000, 'ºC'),
	(17599, 110, '2015-01-15 00:15:26.000000', 'temperatura', 677.0000, 'ºC'),
	(17600, 110, '2015-01-15 00:15:27.000000', 'temperatura', 18.0000, 'ºC'),
	(17601, 110, '2015-01-15 00:15:28.000000', 'temperatura', 461.0000, 'ºC'),
	(17602, 110, '2015-01-15 00:15:29.000000', 'temperatura', 1049.0000, 'ºC'),
	(17603, 110, '2015-01-15 00:15:30.000000', 'temperatura', 265.0000, 'ºC'),
	(17604, 110, '2015-01-15 00:15:31.000000', 'temperatura', 577.0000, 'ºC'),
	(17605, 110, '2015-01-15 00:15:32.000000', 'temperatura', 890.0000, 'ºC'),
	(17606, 110, '2015-01-15 00:15:33.000000', 'temperatura', 322.0000, 'ºC'),
	(17607, 110, '2015-01-15 00:15:34.000000', 'temperatura', 138.0000, 'ºC'),
	(17608, 110, '2015-01-15 00:15:35.000000', 'temperatura', 925.0000, 'ºC'),
	(17609, 110, '2015-01-15 00:15:36.000000', 'temperatura', 611.0000, 'ºC'),
	(17610, 110, '2015-01-15 00:15:37.000000', 'temperatura', 281.0000, 'ºC'),
	(17611, 110, '2015-01-15 00:15:38.000000', 'temperatura', 774.0000, 'ºC'),
	(17612, 110, '2015-01-15 00:15:39.000000', 'temperatura', 625.0000, 'ºC'),
	(17613, 110, '2015-01-15 00:15:40.000000', 'temperatura', 806.0000, 'ºC'),
	(17614, 110, '2015-01-15 00:15:41.000000', 'temperatura', 956.0000, 'ºC'),
	(17615, 110, '2015-01-15 00:15:42.000000', 'temperatura', 1162.0000, 'ºC'),
	(17616, 110, '2015-01-15 00:15:43.000000', 'temperatura', 544.0000, 'ºC'),
	(17617, 110, '2015-01-15 00:15:44.000000', 'temperatura', 432.0000, 'ºC'),
	(17618, 110, '2015-01-15 00:15:45.000000', 'temperatura', 531.0000, 'ºC'),
	(17619, 110, '2015-01-15 00:15:46.000000', 'temperatura', 157.0000, 'ºC'),
	(17620, 110, '2015-01-15 00:15:47.000000', 'temperatura', 395.0000, 'ºC'),
	(17621, 110, '2015-01-15 00:15:48.000000', 'temperatura', 303.0000, 'ºC'),
	(17622, 110, '2015-01-15 00:15:49.000000', 'temperatura', 330.0000, 'ºC'),
	(17623, 110, '2015-01-15 00:15:50.000000', 'temperatura', 742.0000, 'ºC'),
	(17624, 110, '2015-01-15 00:15:51.000000', 'temperatura', 321.0000, 'ºC'),
	(17625, 110, '2015-01-15 00:15:52.000000', 'temperatura', 578.0000, 'ºC'),
	(17626, 110, '2015-01-15 00:15:53.000000', 'temperatura', 729.0000, 'ºC'),
	(17627, 110, '2015-01-15 00:15:54.000000', 'temperatura', 709.0000, 'ºC'),
	(17628, 110, '2015-01-15 00:15:55.000000', 'temperatura', 161.0000, 'ºC'),
	(17629, 110, '2015-01-15 00:15:56.000000', 'temperatura', 1080.0000, 'ºC'),
	(17630, 110, '2015-01-15 00:15:57.000000', 'temperatura', 115.0000, 'ºC'),
	(17631, 110, '2015-01-15 00:15:58.000000', 'temperatura', 934.0000, 'ºC'),
	(17632, 110, '2015-01-15 00:15:59.000000', 'temperatura', 729.0000, 'ºC'),
	(17633, 110, '2015-01-15 00:16:00.000000', 'temperatura', 841.0000, 'ºC'),
	(17634, 110, '2015-01-15 00:16:01.000000', 'temperatura', 820.0000, 'ºC'),
	(17635, 110, '2015-01-15 00:16:02.000000', 'temperatura', 377.0000, 'ºC'),
	(17636, 110, '2015-01-15 00:16:03.000000', 'temperatura', 627.0000, 'ºC'),
	(17637, 110, '2015-01-15 00:16:04.000000', 'temperatura', 803.0000, 'ºC'),
	(17638, 110, '2015-01-15 00:16:05.000000', 'temperatura', 937.0000, 'ºC'),
	(17639, 110, '2015-01-15 00:16:06.000000', 'temperatura', 1074.0000, 'ºC'),
	(17640, 110, '2015-01-15 00:16:07.000000', 'temperatura', 161.0000, 'ºC'),
	(17641, 110, '2015-01-15 00:16:08.000000', 'temperatura', 1183.0000, 'ºC'),
	(17642, 110, '2015-01-15 00:16:09.000000', 'temperatura', 631.0000, 'ºC'),
	(17643, 110, '2015-01-15 00:16:10.000000', 'temperatura', 808.0000, 'ºC'),
	(17644, 110, '2015-01-15 00:16:11.000000', 'temperatura', 947.0000, 'ºC'),
	(17645, 110, '2015-01-15 00:16:12.000000', 'temperatura', 1110.0000, 'ºC'),
	(17646, 110, '2015-01-15 00:16:13.000000', 'temperatura', 313.0000, 'ºC'),
	(17647, 110, '2015-01-15 00:16:14.000000', 'temperatura', 632.0000, 'ºC'),
	(17648, 110, '2015-01-15 00:16:15.000000', 'temperatura', 1022.0000, 'ºC'),
	(17649, 110, '2015-01-15 00:16:16.000000', 'temperatura', 817.0000, 'ºC'),
	(17650, 110, '2015-01-15 00:16:17.000000', 'temperatura', 1019.0000, 'ºC'),
	(17651, 110, '2015-01-15 00:16:18.000000', 'temperatura', 243.0000, 'ºC'),
	(17652, 110, '2015-01-15 00:16:19.000000', 'temperatura', 559.0000, 'ºC'),
	(17653, 110, '2015-01-15 00:16:20.000000', 'temperatura', 868.0000, 'ºC'),
	(17654, 110, '2015-01-15 00:16:21.000000', 'temperatura', 264.0000, 'ºC'),
	(17655, 110, '2015-01-15 00:16:22.000000', 'temperatura', 1113.0000, 'ºC'),
	(17656, 110, '2015-01-15 00:16:23.000000', 'temperatura', 1177.0000, 'ºC'),
	(17657, 110, '2015-01-15 00:16:24.000000', 'temperatura', 145.0000, 'ºC'),
	(17658, 110, '2015-01-15 00:16:25.000000', 'temperatura', 794.0000, 'ºC'),
	(17659, 110, '2015-01-15 00:16:26.000000', 'temperatura', 1135.0000, 'ºC'),
	(17660, 110, '2015-01-15 00:16:27.000000', 'temperatura', 893.0000, 'ºC'),
	(17661, 110, '2015-01-15 00:16:28.000000', 'temperatura', 1063.0000, 'ºC'),
	(17662, 110, '2015-01-15 00:16:29.000000', 'temperatura', 236.0000, 'ºC'),
	(17663, 110, '2015-01-15 00:16:30.000000', 'temperatura', 389.0000, 'ºC'),
	(17664, 110, '2015-01-15 00:16:31.000000', 'temperatura', 39.0000, 'ºC'),
	(17665, 110, '2015-01-15 00:16:32.000000', 'temperatura', 229.0000, 'ºC'),
	(17666, 110, '2015-01-15 00:16:33.000000', 'temperatura', 1030.0000, 'ºC'),
	(17667, 110, '2015-01-15 00:16:34.000000', 'temperatura', 861.0000, 'ºC'),
	(17668, 110, '2015-01-15 00:16:35.000000', 'temperatura', 18.0000, 'ºC'),
	(17669, 110, '2015-01-15 00:16:36.000000', 'temperatura', 1106.0000, 'ºC'),
	(17670, 110, '2015-01-15 00:16:37.000000', 'temperatura', 678.0000, 'ºC'),
	(17671, 110, '2015-01-15 00:16:38.000000', 'temperatura', 70.0000, 'ºC'),
	(17672, 110, '2015-01-15 00:16:39.000000', 'temperatura', 720.0000, 'ºC'),
	(17673, 110, '2015-01-15 00:16:40.000000', 'temperatura', 987.0000, 'ºC'),
	(17674, 110, '2015-01-15 00:16:41.000000', 'temperatura', 376.0000, 'ºC'),
	(17675, 110, '2015-01-15 00:16:42.000000', 'temperatura', 118.0000, 'ºC'),
	(17676, 110, '2015-01-15 00:16:43.000000', 'temperatura', 664.0000, 'ºC'),
	(17677, 110, '2015-01-15 00:16:44.000000', 'temperatura', 566.0000, 'ºC'),
	(17678, 110, '2015-01-15 00:16:45.000000', 'temperatura', 840.0000, 'ºC'),
	(17679, 110, '2015-01-15 00:16:46.000000', 'temperatura', 103.0000, 'ºC'),
	(17680, 110, '2015-01-15 00:16:47.000000', 'temperatura', 394.0000, 'ºC'),
	(17681, 110, '2015-01-15 00:16:48.000000', 'temperatura', 463.0000, 'ºC'),
	(17682, 110, '2015-01-15 00:16:49.000000', 'temperatura', 1135.0000, 'ºC'),
	(17683, 110, '2015-01-15 00:16:50.000000', 'temperatura', 684.0000, 'ºC'),
	(17684, 110, '2015-01-15 00:16:51.000000', 'temperatura', 14.0000, 'ºC'),
	(17685, 110, '2015-01-15 00:16:52.000000', 'temperatura', 421.0000, 'ºC'),
	(17686, 110, '2015-01-15 00:16:53.000000', 'temperatura', 862.0000, 'ºC'),
	(17687, 110, '2015-01-15 00:16:54.000000', 'temperatura', 648.0000, 'ºC'),
	(17688, 110, '2015-01-15 00:16:55.000000', 'temperatura', 653.0000, 'ºC'),
	(17689, 110, '2015-01-15 00:16:56.000000', 'temperatura', 124.0000, 'ºC'),
	(17690, 110, '2015-01-15 00:16:57.000000', 'temperatura', 1059.0000, 'ºC'),
	(17691, 110, '2015-01-15 00:16:58.000000', 'temperatura', 125.0000, 'ºC'),
	(17692, 110, '2015-01-15 00:16:59.000000', 'temperatura', 1047.0000, 'ºC'),
	(17693, 110, '2015-01-15 00:17:00.000000', 'temperatura', 61.0000, 'ºC'),
	(17694, 110, '2015-01-15 00:17:01.000000', 'temperatura', 765.0000, 'ºC'),
	(17695, 110, '2015-01-15 00:17:02.000000', 'temperatura', 43.0000, 'ºC'),
	(17696, 110, '2015-01-15 00:17:03.000000', 'temperatura', 321.0000, 'ºC'),
	(17697, 110, '2015-01-15 00:17:04.000000', 'temperatura', 274.0000, 'ºC'),
	(17698, 110, '2015-01-15 00:17:05.000000', 'temperatura', 408.0000, 'ºC'),
	(17699, 110, '2015-01-15 00:17:06.000000', 'temperatura', 18.0000, 'ºC'),
	(17700, 110, '2015-01-15 00:17:07.000000', 'temperatura', 67.0000, 'ºC'),
	(17701, 110, '2015-01-15 00:17:08.000000', 'temperatura', 282.0000, 'ºC'),
	(17702, 110, '2015-01-15 00:17:09.000000', 'temperatura', 10.0000, 'ºC'),
	(17703, 110, '2015-01-15 00:17:10.000000', 'temperatura', 406.0000, 'ºC'),
	(17704, 110, '2015-01-15 00:17:11.000000', 'temperatura', 798.0000, 'ºC'),
	(17705, 110, '2015-01-15 00:17:12.000000', 'temperatura', 375.0000, 'ºC'),
	(17706, 110, '2015-01-15 00:17:13.000000', 'temperatura', 681.0000, 'ºC'),
	(17707, 110, '2015-01-15 00:17:14.000000', 'temperatura', 1082.0000, 'ºC'),
	(17708, 110, '2015-01-15 00:17:15.000000', 'temperatura', 966.0000, 'ºC'),
	(17709, 110, '2015-01-15 00:17:16.000000', 'temperatura', 384.0000, 'ºC'),
	(17710, 110, '2015-01-15 00:17:17.000000', 'temperatura', 224.0000, 'ºC'),
	(17711, 110, '2015-01-15 00:17:18.000000', 'temperatura', 1167.0000, 'ºC'),
	(17712, 110, '2015-01-15 00:17:19.000000', 'temperatura', 366.0000, 'ºC'),
	(17713, 110, '2015-01-15 00:17:20.000000', 'temperatura', 726.0000, 'ºC'),
	(17714, 110, '2015-01-15 00:17:21.000000', 'temperatura', 136.0000, 'ºC'),
	(17715, 110, '2015-01-15 00:17:22.000000', 'temperatura', 900.0000, 'ºC'),
	(17716, 110, '2015-01-15 00:17:23.000000', 'temperatura', 494.0000, 'ºC'),
	(17717, 110, '2015-01-15 00:17:24.000000', 'temperatura', 970.0000, 'ºC'),
	(17718, 110, '2015-01-15 00:17:25.000000', 'temperatura', 969.0000, 'ºC'),
	(17719, 110, '2015-01-15 00:17:26.000000', 'temperatura', 735.0000, 'ºC'),
	(17720, 110, '2015-01-15 00:17:27.000000', 'temperatura', 769.0000, 'ºC'),
	(17721, 110, '2015-01-15 00:17:28.000000', 'temperatura', 440.0000, 'ºC'),
	(17722, 110, '2015-01-15 00:17:29.000000', 'temperatura', 1092.0000, 'ºC'),
	(17723, 110, '2015-01-15 00:17:30.000000', 'temperatura', 543.0000, 'ºC'),
	(17724, 110, '2015-01-15 00:17:31.000000', 'temperatura', 639.0000, 'ºC'),
	(17725, 110, '2015-01-15 00:17:32.000000', 'temperatura', 368.0000, 'ºC'),
	(17726, 110, '2015-01-15 00:17:33.000000', 'temperatura', 1121.0000, 'ºC'),
	(17727, 110, '2015-01-15 00:17:34.000000', 'temperatura', 903.0000, 'ºC'),
	(17728, 110, '2015-01-15 00:17:35.000000', 'temperatura', 1152.0000, 'ºC'),
	(17729, 110, '2015-01-15 00:17:36.000000', 'temperatura', 652.0000, 'ºC'),
	(17730, 110, '2015-01-15 00:17:37.000000', 'temperatura', 1005.0000, 'ºC'),
	(17731, 110, '2015-01-15 00:17:38.000000', 'temperatura', 667.0000, 'ºC'),
	(17732, 110, '2015-01-15 00:17:39.000000', 'temperatura', 324.0000, 'ºC'),
	(17733, 110, '2015-01-15 00:17:40.000000', 'temperatura', 816.0000, 'ºC'),
	(17734, 110, '2015-01-15 00:17:41.000000', 'temperatura', 709.0000, 'ºC'),
	(17735, 110, '2015-01-15 00:17:42.000000', 'temperatura', 1100.0000, 'ºC'),
	(17736, 110, '2015-01-15 00:17:43.000000', 'temperatura', 970.0000, 'ºC'),
	(17737, 110, '2015-01-15 00:17:44.000000', 'temperatura', 354.0000, 'ºC'),
	(17738, 110, '2015-01-15 00:17:45.000000', 'temperatura', 59.0000, 'ºC'),
	(17739, 110, '2015-01-15 00:17:46.000000', 'temperatura', 432.0000, 'ºC'),
	(17740, 110, '2015-01-15 00:17:47.000000', 'temperatura', 784.0000, 'ºC'),
	(17741, 110, '2015-01-15 00:17:48.000000', 'temperatura', 227.0000, 'ºC'),
	(17742, 110, '2015-01-15 00:17:49.000000', 'temperatura', 1180.0000, 'ºC'),
	(17743, 110, '2015-01-15 00:17:50.000000', 'temperatura', 421.0000, 'ºC'),
	(17744, 110, '2015-01-15 00:17:51.000000', 'temperatura', 964.0000, 'ºC'),
	(17745, 110, '2015-01-15 00:17:52.000000', 'temperatura', 1159.0000, 'ºC'),
	(17746, 110, '2015-01-15 00:17:53.000000', 'temperatura', 501.0000, 'ºC'),
	(17747, 110, '2015-01-15 00:17:54.000000', 'temperatura', 232.0000, 'ºC'),
	(17748, 110, '2015-01-15 00:17:55.000000', 'temperatura', 855.0000, 'ºC'),
	(17749, 110, '2015-01-15 00:17:56.000000', 'temperatura', 1180.0000, 'ºC'),
	(17750, 110, '2015-01-15 00:17:57.000000', 'temperatura', 936.0000, 'ºC'),
	(17751, 110, '2015-01-15 00:17:58.000000', 'temperatura', 1140.0000, 'ºC'),
	(17752, 110, '2015-01-15 00:17:59.000000', 'temperatura', 493.0000, 'ºC'),
	(17753, 110, '2015-01-15 00:18:00.000000', 'temperatura', 245.0000, 'ºC'),
	(17754, 110, '2015-01-15 00:18:01.000000', 'temperatura', 947.0000, 'ºC'),
	(17755, 110, '2015-01-15 00:18:02.000000', 'temperatura', 402.0000, 'ºC'),
	(17756, 110, '2015-01-15 00:18:03.000000', 'temperatura', 370.0000, 'ºC'),
	(17757, 110, '2015-01-15 00:18:04.000000', 'temperatura', 644.0000, 'ºC'),
	(17758, 110, '2015-01-15 00:18:05.000000', 'temperatura', 909.0000, 'ºC'),
	(17759, 110, '2015-01-15 00:18:06.000000', 'temperatura', 216.0000, 'ºC'),
	(17760, 110, '2015-01-15 00:18:07.000000', 'temperatura', 753.0000, 'ºC'),
	(17761, 110, '2015-01-15 00:18:08.000000', 'temperatura', 718.0000, 'ºC'),
	(17762, 110, '2015-01-15 00:18:09.000000', 'temperatura', 130.0000, 'ºC'),
	(17763, 110, '2015-01-15 00:18:10.000000', 'temperatura', 899.0000, 'ºC'),
	(17764, 110, '2015-01-15 00:18:11.000000', 'temperatura', 504.0000, 'ºC'),
	(17765, 110, '2015-01-15 00:18:12.000000', 'temperatura', 1023.0000, 'ºC'),
	(17766, 110, '2015-01-15 00:18:13.000000', 'temperatura', 4.0000, 'ºC'),
	(17767, 110, '2015-01-15 00:18:14.000000', 'temperatura', 551.0000, 'ºC'),
	(17768, 110, '2015-01-15 00:18:15.000000', 'temperatura', 346.0000, 'ºC'),
	(17769, 110, '2015-01-15 00:18:16.000000', 'temperatura', 75.0000, 'ºC'),
	(17770, 110, '2015-01-15 00:18:17.000000', 'temperatura', 538.0000, 'ºC'),
	(17771, 110, '2015-01-15 00:18:18.000000', 'temperatura', 65.0000, 'ºC'),
	(17772, 110, '2015-01-15 00:18:19.000000', 'temperatura', 1110.0000, 'ºC'),
	(17773, 110, '2015-01-15 00:18:20.000000', 'temperatura', 556.0000, 'ºC'),
	(17774, 110, '2015-01-15 00:18:21.000000', 'temperatura', 652.0000, 'ºC'),
	(17775, 110, '2015-01-15 00:18:22.000000', 'temperatura', 393.0000, 'ºC'),
	(17776, 110, '2015-01-15 00:18:23.000000', 'temperatura', 7.0000, 'ºC'),
	(17777, 110, '2015-01-15 00:18:24.000000', 'temperatura', 56.0000, 'ºC'),
	(17778, 110, '2015-01-15 00:18:25.000000', 'temperatura', 260.0000, 'ºC'),
	(17779, 110, '2015-01-15 00:18:26.000000', 'temperatura', 1135.0000, 'ºC'),
	(17780, 110, '2015-01-15 00:18:27.000000', 'temperatura', 94.0000, 'ºC'),
	(17781, 110, '2015-01-15 00:18:28.000000', 'temperatura', 664.0000, 'ºC'),
	(17782, 110, '2015-01-15 00:18:29.000000', 'temperatura', 641.0000, 'ºC'),
	(17783, 110, '2015-01-15 00:18:30.000000', 'temperatura', 14.0000, 'ºC'),
	(17784, 110, '2015-01-15 00:18:31.000000', 'temperatura', 546.0000, 'ºC'),
	(17785, 110, '2015-01-15 00:18:32.000000', 'temperatura', 289.0000, 'ºC'),
	(17786, 110, '2015-01-15 00:18:33.000000', 'temperatura', 1006.0000, 'ºC'),
	(17787, 110, '2015-01-15 00:18:34.000000', 'temperatura', 564.0000, 'ºC'),
	(17788, 110, '2015-01-15 00:18:35.000000', 'temperatura', 1002.0000, 'ºC'),
	(17789, 110, '2015-01-15 00:18:36.000000', 'temperatura', 917.0000, 'ºC'),
	(17790, 110, '2015-01-15 00:18:37.000000', 'temperatura', 381.0000, 'ºC'),
	(17791, 110, '2015-01-15 00:18:38.000000', 'temperatura', 356.0000, 'ºC'),
	(17792, 110, '2015-01-15 00:18:39.000000', 'temperatura', 636.0000, 'ºC'),
	(17793, 110, '2015-01-15 00:18:40.000000', 'temperatura', 914.0000, 'ºC'),
	(17794, 110, '2015-01-15 00:18:41.000000', 'temperatura', 263.0000, 'ºC'),
	(17795, 110, '2015-01-15 00:18:42.000000', 'temperatura', 971.0000, 'ºC'),
	(17796, 110, '2015-01-15 00:18:43.000000', 'temperatura', 469.0000, 'ºC'),
	(17797, 110, '2015-01-15 00:18:44.000000', 'temperatura', 632.0000, 'ºC'),
	(17798, 110, '2015-01-15 00:18:45.000000', 'temperatura', 554.0000, 'ºC'),
	(17799, 110, '2015-01-15 00:18:46.000000', 'temperatura', 874.0000, 'ºC'),
	(17800, 110, '2015-01-15 00:18:47.000000', 'temperatura', 309.0000, 'ºC'),
	(17801, 110, '2015-01-15 00:18:48.000000', 'temperatura', 121.0000, 'ºC'),
	(17802, 110, '2015-01-15 00:18:49.000000', 'temperatura', 880.0000, 'ºC'),
	(17803, 110, '2015-01-15 00:18:50.000000', 'temperatura', 438.0000, 'ºC'),
	(17804, 110, '2015-01-15 00:18:51.000000', 'temperatura', 748.0000, 'ºC'),
	(17805, 110, '2015-01-15 00:18:52.000000', 'temperatura', 29.0000, 'ºC'),
	(17806, 110, '2015-01-15 00:18:53.000000', 'temperatura', 300.0000, 'ºC'),
	(17807, 110, '2015-01-15 00:18:54.000000', 'temperatura', 214.0000, 'ºC'),
	(17808, 110, '2015-01-15 00:18:55.000000', 'temperatura', 169.0000, 'ºC'),
	(17809, 110, '2015-01-15 00:18:56.000000', 'temperatura', 204.0000, 'ºC'),
	(17810, 110, '2015-01-15 00:18:57.000000', 'temperatura', 515.0000, 'ºC'),
	(17811, 110, '2015-01-15 00:18:58.000000', 'temperatura', 763.0000, 'ºC'),
	(17812, 110, '2015-01-15 00:18:59.000000', 'temperatura', 1070.0000, 'ºC'),
	(17813, 110, '2015-01-15 00:19:00.000000', 'temperatura', 661.0000, 'ºC'),
	(17814, 110, '2015-01-15 00:19:01.000000', 'temperatura', 96.0000, 'ºC'),
	(17815, 110, '2015-01-15 00:19:02.000000', 'temperatura', 898.0000, 'ºC'),
	(17816, 110, '2015-01-15 00:19:03.000000', 'temperatura', 603.0000, 'ºC'),
	(17817, 110, '2015-01-15 00:19:04.000000', 'temperatura', 323.0000, 'ºC'),
	(17818, 110, '2015-01-15 00:19:05.000000', 'temperatura', 1003.0000, 'ºC'),
	(17819, 110, '2015-01-15 00:19:06.000000', 'temperatura', 450.0000, 'ºC'),
	(17820, 110, '2015-01-15 00:19:07.000000', 'temperatura', 439.0000, 'ºC'),
	(17821, 110, '2015-01-15 00:19:08.000000', 'temperatura', 846.0000, 'ºC'),
	(17822, 110, '2015-01-15 00:19:09.000000', 'temperatura', 514.0000, 'ºC'),
	(17823, 110, '2015-01-15 00:19:10.000000', 'temperatura', 31.0000, 'ºC'),
	(17824, 110, '2015-01-15 00:19:11.000000', 'temperatura', 1015.0000, 'ºC'),
	(17825, 110, '2015-01-15 00:19:12.000000', 'temperatura', 183.0000, 'ºC'),
	(17826, 110, '2015-01-15 00:19:13.000000', 'temperatura', 269.0000, 'ºC'),
	(17827, 110, '2015-01-15 00:19:14.000000', 'temperatura', 796.0000, 'ºC'),
	(17828, 110, '2015-01-15 00:19:15.000000', 'temperatura', 776.0000, 'ºC'),
	(17829, 110, '2015-01-15 00:19:16.000000', 'temperatura', 292.0000, 'ºC'),
	(17830, 110, '2015-01-15 00:19:17.000000', 'temperatura', 333.0000, 'ºC'),
	(17831, 110, '2015-01-15 00:19:18.000000', 'temperatura', 787.0000, 'ºC'),
	(17832, 110, '2015-01-15 00:19:19.000000', 'temperatura', 539.0000, 'ºC'),
	(17833, 110, '2015-01-15 00:19:20.000000', 'temperatura', 333.0000, 'ºC'),
	(17834, 110, '2015-01-15 00:19:21.000000', 'temperatura', 48.0000, 'ºC'),
	(17835, 110, '2015-01-15 00:19:22.000000', 'temperatura', 443.0000, 'ºC'),
	(17836, 110, '2015-01-15 00:19:23.000000', 'temperatura', 872.0000, 'ºC'),
	(17837, 110, '2015-01-15 00:19:24.000000', 'temperatura', 629.0000, 'ºC'),
	(17838, 110, '2015-01-15 00:19:25.000000', 'temperatura', 532.0000, 'ºC'),
	(17839, 110, '2015-01-15 00:19:26.000000', 'temperatura', 772.0000, 'ºC'),
	(17840, 110, '2015-01-15 00:19:27.000000', 'temperatura', 1067.0000, 'ºC'),
	(17841, 110, '2015-01-15 00:19:28.000000', 'temperatura', 617.0000, 'ºC'),
	(17842, 110, '2015-01-15 00:19:29.000000', 'temperatura', 1085.0000, 'ºC'),
	(17843, 110, '2015-01-15 00:19:30.000000', 'temperatura', 1173.0000, 'ºC'),
	(17844, 110, '2015-01-15 00:19:31.000000', 'temperatura', 211.0000, 'ºC'),
	(17845, 110, '2015-01-15 00:19:32.000000', 'temperatura', 1137.0000, 'ºC'),
	(17846, 110, '2015-01-15 00:19:33.000000', 'temperatura', 252.0000, 'ºC'),
	(17847, 110, '2015-01-15 00:19:34.000000', 'temperatura', 249.0000, 'ºC'),
	(17848, 110, '2015-01-15 00:19:35.000000', 'temperatura', 491.0000, 'ºC'),
	(17849, 110, '2015-01-15 00:19:36.000000', 'temperatura', 506.0000, 'ºC'),
	(17850, 110, '2015-01-15 00:19:37.000000', 'temperatura', 1059.0000, 'ºC'),
	(17851, 110, '2015-01-15 00:19:38.000000', 'temperatura', 179.0000, 'ºC'),
	(17852, 110, '2015-01-15 00:19:39.000000', 'temperatura', 116.0000, 'ºC'),
	(17853, 110, '2015-01-15 00:19:40.000000', 'temperatura', 47.0000, 'ºC'),
	(17854, 110, '2015-01-15 00:19:41.000000', 'temperatura', 1084.0000, 'ºC'),
	(17855, 110, '2015-01-15 00:19:42.000000', 'temperatura', 479.0000, 'ºC'),
	(17856, 110, '2015-01-15 00:19:43.000000', 'temperatura', 346.0000, 'ºC'),
	(17857, 110, '2015-01-15 00:19:44.000000', 'temperatura', 290.0000, 'ºC'),
	(17858, 110, '2015-01-15 00:19:45.000000', 'temperatura', 416.0000, 'ºC'),
	(17859, 110, '2015-01-15 00:19:46.000000', 'temperatura', 11.0000, 'ºC'),
	(17860, 110, '2015-01-15 00:19:47.000000', 'temperatura', 4.0000, 'ºC'),
	(17861, 110, '2015-01-15 00:19:48.000000', 'temperatura', 1190.0000, 'ºC'),
	(17862, 110, '2015-01-15 00:19:49.000000', 'temperatura', 1138.0000, 'ºC'),
	(17863, 110, '2015-01-15 00:19:50.000000', 'temperatura', 919.0000, 'ºC'),
	(17864, 110, '2015-01-15 00:19:51.000000', 'temperatura', 1185.0000, 'ºC'),
	(17865, 110, '2015-01-15 00:19:52.000000', 'temperatura', 765.0000, 'ºC'),
	(17866, 110, '2015-01-15 00:19:53.000000', 'temperatura', 271.0000, 'ºC'),
	(17867, 110, '2015-01-15 00:19:54.000000', 'temperatura', 260.0000, 'ºC'),
	(17868, 110, '2015-01-15 00:19:55.000000', 'temperatura', 487.0000, 'ºC'),
	(17869, 110, '2015-01-15 00:19:56.000000', 'temperatura', 457.0000, 'ºC'),
	(17870, 110, '2015-01-15 00:19:57.000000', 'temperatura', 826.0000, 'ºC'),
	(17871, 110, '2015-01-15 00:19:58.000000', 'temperatura', 358.0000, 'ºC'),
	(17872, 110, '2015-01-15 00:19:59.000000', 'temperatura', 512.0000, 'ºC'),
	(17873, 110, '2015-01-15 00:20:00.000000', 'temperatura', 288.0000, 'ºC'),
	(17874, 110, '2015-01-15 00:20:01.000000', 'temperatura', 1105.0000, 'ºC'),
	(17875, 110, '2015-01-15 00:20:02.000000', 'temperatura', 1060.0000, 'ºC'),
	(17876, 110, '2015-01-15 00:20:03.000000', 'temperatura', 787.0000, 'ºC'),
	(17877, 110, '2015-01-15 00:20:04.000000', 'temperatura', 754.0000, 'ºC'),
	(17878, 110, '2015-01-15 00:20:05.000000', 'temperatura', 209.0000, 'ºC'),
	(17879, 110, '2015-01-15 00:20:06.000000', 'temperatura', 1185.0000, 'ºC'),
	(17880, 110, '2015-01-15 00:20:07.000000', 'temperatura', 499.0000, 'ºC'),
	(17881, 110, '2015-01-15 00:20:08.000000', 'temperatura', 139.0000, 'ºC'),
	(17882, 110, '2015-01-15 00:20:09.000000', 'temperatura', 401.0000, 'ºC'),
	(17883, 110, '2015-01-15 00:20:10.000000', 'temperatura', 388.0000, 'ºC'),
	(17884, 110, '2015-01-15 00:20:11.000000', 'temperatura', 736.0000, 'ºC'),
	(17885, 110, '2015-01-15 00:20:12.000000', 'temperatura', 117.0000, 'ºC'),
	(17886, 110, '2015-01-15 00:20:13.000000', 'temperatura', 778.0000, 'ºC'),
	(17887, 110, '2015-01-15 00:20:14.000000', 'temperatura', 1137.0000, 'ºC'),
	(17888, 110, '2015-01-15 00:20:15.000000', 'temperatura', 955.0000, 'ºC'),
	(17889, 110, '2015-01-15 00:20:16.000000', 'temperatura', 163.0000, 'ºC'),
	(17890, 110, '2015-01-15 00:20:17.000000', 'temperatura', 352.0000, 'ºC'),
	(17891, 110, '2015-01-15 00:20:18.000000', 'temperatura', 71.0000, 'ºC'),
	(17892, 110, '2015-01-15 00:20:19.000000', 'temperatura', 500.0000, 'ºC'),
	(17893, 110, '2015-01-15 00:20:20.000000', 'temperatura', 1088.0000, 'ºC'),
	(17894, 110, '2015-01-15 00:20:21.000000', 'temperatura', 338.0000, 'ºC'),
	(17895, 110, '2015-01-15 00:20:22.000000', 'temperatura', 830.0000, 'ºC'),
	(17896, 110, '2015-01-15 00:20:23.000000', 'temperatura', 734.0000, 'ºC'),
	(17897, 110, '2015-01-15 00:20:24.000000', 'temperatura', 1182.0000, 'ºC'),
	(17898, 110, '2015-01-15 00:20:25.000000', 'temperatura', 110.0000, 'ºC'),
	(17899, 110, '2015-01-15 00:20:26.000000', 'temperatura', 603.0000, 'ºC'),
	(17900, 110, '2015-01-15 00:20:27.000000', 'temperatura', 286.0000, 'ºC'),
	(17901, 110, '2015-01-15 00:20:28.000000', 'temperatura', 819.0000, 'ºC'),
	(17902, 110, '2015-01-15 00:20:29.000000', 'temperatura', 839.0000, 'ºC'),
	(17903, 110, '2015-01-15 00:20:30.000000', 'temperatura', 540.0000, 'ºC'),
	(17904, 110, '2015-01-15 00:20:31.000000', 'temperatura', 183.0000, 'ºC'),
	(17905, 110, '2015-01-15 00:20:32.000000', 'temperatura', 496.0000, 'ºC'),
	(17906, 110, '2015-01-15 00:20:33.000000', 'temperatura', 732.0000, 'ºC'),
	(17907, 110, '2015-01-15 00:20:34.000000', 'temperatura', 973.0000, 'ºC'),
	(17908, 110, '2015-01-15 00:20:35.000000', 'temperatura', 269.0000, 'ºC'),
	(17909, 110, '2015-01-15 00:20:36.000000', 'temperatura', 827.0000, 'ºC'),
	(17910, 110, '2015-01-15 00:20:37.000000', 'temperatura', 930.0000, 'ºC'),
	(17911, 110, '2015-01-15 00:20:38.000000', 'temperatura', 967.0000, 'ºC'),
	(17912, 110, '2015-01-15 00:20:39.000000', 'temperatura', 845.0000, 'ºC'),
	(17913, 110, '2015-01-15 00:20:40.000000', 'temperatura', 123.0000, 'ºC'),
	(17914, 110, '2015-01-15 00:20:41.000000', 'temperatura', 484.0000, 'ºC'),
	(17915, 110, '2015-01-15 00:20:42.000000', 'temperatura', 850.0000, 'ºC'),
	(17916, 110, '2015-01-15 00:20:43.000000', 'temperatura', 397.0000, 'ºC'),
	(17917, 110, '2015-01-15 00:20:44.000000', 'temperatura', 637.0000, 'ºC'),
	(17918, 110, '2015-01-15 00:20:45.000000', 'temperatura', 796.0000, 'ºC'),
	(17919, 110, '2015-01-15 00:20:46.000000', 'temperatura', 868.0000, 'ºC'),
	(17920, 110, '2015-01-15 00:20:47.000000', 'temperatura', 751.0000, 'ºC'),
	(17921, 110, '2015-01-15 00:20:48.000000', 'temperatura', 1153.0000, 'ºC'),
	(17922, 110, '2015-01-15 00:20:49.000000', 'temperatura', 1114.0000, 'ºC'),
	(17923, 110, '2015-01-15 00:20:50.000000', 'temperatura', 909.0000, 'ºC'),
	(17924, 110, '2015-01-15 00:20:51.000000', 'temperatura', 5.0000, 'ºC'),
	(17925, 110, '2015-01-15 00:20:52.000000', 'temperatura', 899.0000, 'ºC'),
	(17926, 110, '2015-01-15 00:20:53.000000', 'temperatura', 880.0000, 'ºC'),
	(17927, 110, '2015-01-15 00:20:54.000000', 'temperatura', 504.0000, 'ºC'),
	(17928, 110, '2015-01-15 00:20:55.000000', 'temperatura', 1082.0000, 'ºC'),
	(17929, 110, '2015-01-15 00:20:56.000000', 'temperatura', 297.0000, 'ºC'),
	(17930, 110, '2015-01-15 00:20:57.000000', 'temperatura', 639.0000, 'ºC'),
	(17931, 110, '2015-01-15 00:20:58.000000', 'temperatura', 1106.0000, 'ºC'),
	(17932, 110, '2015-01-15 00:20:59.000000', 'temperatura', 13.0000, 'ºC'),
	(17933, 110, '2015-01-15 00:21:00.000000', 'temperatura', 345.0000, 'ºC'),
	(17934, 110, '2015-01-15 00:21:01.000000', 'temperatura', 490.0000, 'ºC'),
	(17935, 110, '2015-01-15 00:21:02.000000', 'temperatura', 215.0000, 'ºC'),
	(17936, 110, '2015-01-15 00:21:03.000000', 'temperatura', 805.0000, 'ºC'),
	(17937, 110, '2015-01-15 00:21:04.000000', 'temperatura', 981.0000, 'ºC'),
	(17938, 110, '2015-01-15 00:21:05.000000', 'temperatura', 88.0000, 'ºC'),
	(17939, 110, '2015-01-15 00:21:06.000000', 'temperatura', 1100.0000, 'ºC'),
	(17940, 110, '2015-01-15 00:21:07.000000', 'temperatura', 434.0000, 'ºC'),
	(17941, 110, '2015-01-15 00:21:08.000000', 'temperatura', 72.0000, 'ºC'),
	(17942, 110, '2015-01-15 00:21:09.000000', 'temperatura', 258.0000, 'ºC'),
	(17943, 110, '2015-01-15 00:21:10.000000', 'temperatura', 1073.0000, 'ºC'),
	(17944, 110, '2015-01-15 00:21:11.000000', 'temperatura', 994.0000, 'ºC'),
	(17945, 110, '2015-01-15 00:21:12.000000', 'temperatura', 550.0000, 'ºC'),
	(17946, 110, '2015-01-15 00:21:13.000000', 'temperatura', 970.0000, 'ºC'),
	(17947, 110, '2015-01-15 00:21:14.000000', 'temperatura', 802.0000, 'ºC'),
	(17948, 110, '2015-01-15 00:21:15.000000', 'temperatura', 1098.0000, 'ºC'),
	(17949, 110, '2015-01-15 00:21:16.000000', 'temperatura', 683.0000, 'ºC'),
	(17950, 110, '2015-01-15 00:21:17.000000', 'temperatura', 123.0000, 'ºC'),
	(17951, 110, '2015-01-15 00:21:18.000000', 'temperatura', 967.0000, 'ºC'),
	(17952, 110, '2015-01-15 00:21:19.000000', 'temperatura', 866.0000, 'ºC'),
	(17953, 110, '2015-01-15 00:21:20.000000', 'temperatura', 230.0000, 'ºC'),
	(17954, 110, '2015-01-15 00:21:21.000000', 'temperatura', 951.0000, 'ºC'),
	(17955, 110, '2015-01-15 00:21:22.000000', 'temperatura', 465.0000, 'ºC'),
	(17956, 110, '2015-01-15 00:21:23.000000', 'temperatura', 672.0000, 'ºC'),
	(17957, 110, '2015-01-15 00:21:24.000000', 'temperatura', 768.0000, 'ºC'),
	(17958, 110, '2015-01-15 00:21:25.000000', 'temperatura', 624.0000, 'ºC'),
	(17959, 110, '2015-01-15 00:21:26.000000', 'temperatura', 816.0000, 'ºC'),
	(17960, 110, '2015-01-15 00:21:27.000000', 'temperatura', 1009.0000, 'ºC'),
	(17961, 110, '2015-01-15 00:21:28.000000', 'temperatura', 196.0000, 'ºC'),
	(17962, 110, '2015-01-15 00:21:29.000000', 'temperatura', 354.0000, 'ºC'),
	(17963, 110, '2015-01-15 00:21:30.000000', 'temperatura', 1183.0000, 'ºC'),
	(17964, 110, '2015-01-15 00:21:31.000000', 'temperatura', 52.0000, 'ºC'),
	(17965, 110, '2015-01-15 00:21:32.000000', 'temperatura', 314.0000, 'ºC'),
	(17966, 110, '2015-01-15 00:21:33.000000', 'temperatura', 212.0000, 'ºC'),
	(17967, 110, '2015-01-15 00:21:34.000000', 'temperatura', 121.0000, 'ºC'),
	(17968, 110, '2015-01-15 00:21:35.000000', 'temperatura', 1168.0000, 'ºC'),
	(17969, 110, '2015-01-15 00:21:36.000000', 'temperatura', 679.0000, 'ºC'),
	(17970, 110, '2015-01-15 00:21:37.000000', 'temperatura', 1092.0000, 'ºC'),
	(17971, 110, '2015-01-15 00:21:38.000000', 'temperatura', 1024.0000, 'ºC'),
	(17972, 110, '2015-01-15 00:21:39.000000', 'temperatura', 642.0000, 'ºC'),
	(17973, 110, '2015-01-15 00:21:40.000000', 'temperatura', 139.0000, 'ºC'),
	(17974, 110, '2015-01-15 00:21:41.000000', 'temperatura', 1168.0000, 'ºC'),
	(17975, 110, '2015-01-15 00:21:42.000000', 'temperatura', 626.0000, 'ºC'),
	(17976, 110, '2015-01-15 00:21:43.000000', 'temperatura', 825.0000, 'ºC'),
	(17977, 110, '2015-01-15 00:21:44.000000', 'temperatura', 1047.0000, 'ºC'),
	(17978, 110, '2015-01-15 00:21:45.000000', 'temperatura', 363.0000, 'ºC'),
	(17979, 110, '2015-01-15 00:21:46.000000', 'temperatura', 1071.0000, 'ºC'),
	(17980, 110, '2015-01-15 00:21:47.000000', 'temperatura', 670.0000, 'ºC'),
	(17981, 110, '2015-01-15 00:21:48.000000', 'temperatura', 134.0000, 'ºC'),
	(17982, 110, '2015-01-15 00:21:49.000000', 'temperatura', 1063.0000, 'ºC'),
	(17983, 110, '2015-01-15 00:21:50.000000', 'temperatura', 111.0000, 'ºC'),
	(17984, 110, '2015-01-15 00:21:51.000000', 'temperatura', 968.0000, 'ºC'),
	(17985, 110, '2015-01-15 00:21:52.000000', 'temperatura', 906.0000, 'ºC'),
	(17986, 110, '2015-01-15 00:21:53.000000', 'temperatura', 428.0000, 'ºC'),
	(17987, 110, '2015-01-15 00:21:54.000000', 'temperatura', 624.0000, 'ºC'),
	(17988, 110, '2015-01-15 00:21:55.000000', 'temperatura', 634.0000, 'ºC'),
	(17989, 110, '2015-01-15 00:21:56.000000', 'temperatura', 99.0000, 'ºC'),
	(17990, 110, '2015-01-15 00:21:57.000000', 'temperatura', 992.0000, 'ºC'),
	(17991, 110, '2015-01-15 00:21:58.000000', 'temperatura', 1063.0000, 'ºC'),
	(17992, 110, '2015-01-15 00:21:59.000000', 'temperatura', 1142.0000, 'ºC'),
	(17993, 110, '2015-01-15 00:22:00.000000', 'temperatura', 122.0000, 'ºC'),
	(17994, 110, '2015-01-15 00:22:01.000000', 'temperatura', 784.0000, 'ºC'),
	(17995, 110, '2015-01-15 00:22:02.000000', 'temperatura', 1154.0000, 'ºC'),
	(17996, 110, '2015-01-15 00:22:03.000000', 'temperatura', 1020.0000, 'ºC'),
	(17997, 110, '2015-01-15 00:22:04.000000', 'temperatura', 438.0000, 'ºC'),
	(17998, 110, '2015-01-15 00:22:05.000000', 'temperatura', 332.0000, 'ºC'),
	(17999, 110, '2015-01-15 00:22:06.000000', 'temperatura', 344.0000, 'ºC'),
	(18000, 110, '2015-01-15 00:22:07.000000', 'temperatura', 724.0000, 'ºC'),
	(18001, 110, '2015-01-15 00:22:08.000000', 'temperatura', 191.0000, 'ºC'),
	(18002, 110, '2015-01-15 00:22:09.000000', 'temperatura', 1183.0000, 'ºC'),
	(18003, 110, '2015-01-15 00:22:10.000000', 'temperatura', 543.0000, 'ºC'),
	(18004, 110, '2015-01-15 00:22:11.000000', 'temperatura', 368.0000, 'ºC'),
	(18005, 110, '2015-01-15 00:22:12.000000', 'temperatura', 208.0000, 'ºC'),
	(18006, 110, '2015-01-15 00:22:13.000000', 'temperatura', 1137.0000, 'ºC'),
	(18007, 110, '2015-01-15 00:22:14.000000', 'temperatura', 264.0000, 'ºC'),
	(18008, 110, '2015-01-15 00:22:15.000000', 'temperatura', 308.0000, 'ºC'),
	(18009, 110, '2015-01-15 00:22:16.000000', 'temperatura', 750.0000, 'ºC'),
	(18010, 110, '2015-01-15 00:22:17.000000', 'temperatura', 424.0000, 'ºC'),
	(18011, 110, '2015-01-15 00:22:18.000000', 'temperatura', 1071.0000, 'ºC'),
	(18012, 110, '2015-01-15 00:22:19.000000', 'temperatura', 486.0000, 'ºC'),
	(18013, 110, '2015-01-15 00:22:20.000000', 'temperatura', 414.0000, 'ºC'),
	(18014, 110, '2015-01-15 00:22:21.000000', 'temperatura', 614.0000, 'ºC'),
	(18015, 110, '2015-01-15 00:22:22.000000', 'temperatura', 628.0000, 'ºC'),
	(18016, 110, '2015-01-15 00:22:23.000000', 'temperatura', 100.0000, 'ºC'),
	(18017, 110, '2015-01-15 00:22:24.000000', 'temperatura', 1017.0000, 'ºC'),
	(18018, 110, '2015-01-15 00:22:25.000000', 'temperatura', 1183.0000, 'ºC'),
	(18019, 110, '2015-01-15 00:22:26.000000', 'temperatura', 465.0000, 'ºC'),
	(18020, 110, '2015-01-15 00:22:27.000000', 'temperatura', 1176.0000, 'ºC'),
	(18021, 110, '2015-01-15 00:22:28.000000', 'temperatura', 885.0000, 'ºC'),
	(18022, 110, '2015-01-15 00:22:29.000000', 'temperatura', 898.0000, 'ºC'),
	(18023, 110, '2015-01-15 00:22:30.000000', 'temperatura', 634.0000, 'ºC'),
	(18024, 110, '2015-01-15 00:22:31.000000', 'temperatura', 477.0000, 'ºC'),
	(18025, 110, '2015-01-15 00:22:32.000000', 'temperatura', 483.0000, 'ºC'),
	(18026, 110, '2015-01-15 00:22:33.000000', 'temperatura', 986.0000, 'ºC'),
	(18027, 110, '2015-01-15 00:22:34.000000', 'temperatura', 1082.0000, 'ºC'),
	(18028, 110, '2015-01-15 00:22:35.000000', 'temperatura', 53.0000, 'ºC'),
	(18029, 110, '2015-01-15 00:22:36.000000', 'temperatura', 619.0000, 'ºC'),
	(18030, 110, '2015-01-15 00:22:37.000000', 'temperatura', 538.0000, 'ºC'),
	(18031, 110, '2015-01-15 00:22:38.000000', 'temperatura', 832.0000, 'ºC'),
	(18032, 110, '2015-01-15 00:22:39.000000', 'temperatura', 146.0000, 'ºC'),
	(18033, 110, '2015-01-15 00:22:40.000000', 'temperatura', 637.0000, 'ºC'),
	(18034, 110, '2015-01-15 00:22:41.000000', 'temperatura', 344.0000, 'ºC'),
	(18035, 110, '2015-01-15 00:22:42.000000', 'temperatura', 1012.0000, 'ºC'),
	(18036, 110, '2015-01-15 00:22:43.000000', 'temperatura', 427.0000, 'ºC'),
	(18037, 110, '2015-01-15 00:22:44.000000', 'temperatura', 298.0000, 'ºC'),
	(18038, 110, '2015-01-15 00:22:45.000000', 'temperatura', 211.0000, 'ºC'),
	(18039, 110, '2015-01-15 00:22:46.000000', 'temperatura', 162.0000, 'ºC'),
	(18040, 110, '2015-01-15 00:22:47.000000', 'temperatura', 176.0000, 'ºC'),
	(18041, 110, '2015-01-15 00:22:48.000000', 'temperatura', 395.0000, 'ºC'),
	(18042, 110, '2015-01-15 00:22:49.000000', 'temperatura', 247.0000, 'ºC'),
	(18043, 110, '2015-01-15 00:22:50.000000', 'temperatura', 51.0000, 'ºC'),
	(18044, 110, '2015-01-15 00:22:51.000000', 'temperatura', 716.0000, 'ºC'),
	(18045, 110, '2015-01-15 00:22:52.000000', 'temperatura', 1028.0000, 'ºC'),
	(18046, 110, '2015-01-15 00:22:53.000000', 'temperatura', 590.0000, 'ºC'),
	(18047, 110, '2015-01-15 00:22:54.000000', 'temperatura', 1069.0000, 'ºC'),
	(18048, 110, '2015-01-15 00:22:55.000000', 'temperatura', 1176.0000, 'ºC'),
	(18049, 110, '2015-01-15 00:22:56.000000', 'temperatura', 274.0000, 'ºC'),
	(18050, 110, '2015-01-15 00:22:57.000000', 'temperatura', 240.0000, 'ºC'),
	(18051, 110, '2015-01-15 00:22:58.000000', 'temperatura', 380.0000, 'ºC'),
	(18052, 110, '2015-01-15 00:22:59.000000', 'temperatura', 1180.0000, 'ºC'),
	(18053, 110, '2015-01-15 00:23:00.000000', 'temperatura', 1162.0000, 'ºC'),
	(18054, 110, '2015-01-15 00:23:01.000000', 'temperatura', 1071.0000, 'ºC'),
	(18055, 110, '2015-01-15 00:23:02.000000', 'temperatura', 667.0000, 'ºC'),
	(18056, 110, '2015-01-15 00:23:03.000000', 'temperatura', 123.0000, 'ºC'),
	(18057, 110, '2015-01-15 00:23:04.000000', 'temperatura', 1014.0000, 'ºC'),
	(18058, 110, '2015-01-15 00:23:05.000000', 'temperatura', 1100.0000, 'ºC'),
	(18059, 110, '2015-01-15 00:23:06.000000', 'temperatura', 60.0000, 'ºC'),
	(18060, 110, '2015-01-15 00:23:07.000000', 'temperatura', 600.0000, 'ºC'),
	(18061, 110, '2015-01-15 00:23:08.000000', 'temperatura', 422.0000, 'ºC'),
	(18062, 110, '2015-01-15 00:23:09.000000', 'temperatura', 312.0000, 'ºC'),
	(18063, 110, '2015-01-15 00:23:10.000000', 'temperatura', 291.0000, 'ºC'),
	(18064, 110, '2015-01-15 00:23:11.000000', 'temperatura', 522.0000, 'ºC'),
	(18065, 110, '2015-01-15 00:23:12.000000', 'temperatura', 536.0000, 'ºC'),
	(18066, 110, '2015-01-15 00:23:13.000000', 'temperatura', 1117.0000, 'ºC'),
	(18067, 110, '2015-01-15 00:23:14.000000', 'temperatura', 375.0000, 'ºC'),
	(18068, 110, '2015-01-15 00:23:15.000000', 'temperatura', 925.0000, 'ºC'),
	(18069, 110, '2015-01-15 00:23:16.000000', 'temperatura', 1102.0000, 'ºC'),
	(18070, 110, '2015-01-15 00:23:17.000000', 'temperatura', 336.0000, 'ºC'),
	(18071, 110, '2015-01-15 00:23:18.000000', 'temperatura', 774.0000, 'ºC'),
	(18072, 110, '2015-01-15 00:23:19.000000', 'temperatura', 462.0000, 'ºC'),
	(18073, 110, '2015-01-15 00:23:20.000000', 'temperatura', 1190.0000, 'ºC'),
	(18074, 110, '2015-01-15 00:23:21.000000', 'temperatura', 965.0000, 'ºC'),
	(18075, 110, '2015-01-15 00:23:22.000000', 'temperatura', 54.0000, 'ºC'),
	(18076, 110, '2015-01-15 00:23:23.000000', 'temperatura', 977.0000, 'ºC'),
	(18077, 110, '2015-01-15 00:23:24.000000', 'temperatura', 1124.0000, 'ºC'),
	(18078, 110, '2015-01-15 00:23:25.000000', 'temperatura', 291.0000, 'ºC'),
	(18079, 110, '2015-01-15 00:23:26.000000', 'temperatura', 480.0000, 'ºC'),
	(18080, 110, '2015-01-15 00:23:27.000000', 'temperatura', 331.0000, 'ºC'),
	(18081, 110, '2015-01-15 00:23:28.000000', 'temperatura', 213.0000, 'ºC'),
	(18082, 110, '2015-01-15 00:23:29.000000', 'temperatura', 75.0000, 'ºC'),
	(18083, 110, '2015-01-15 00:23:30.000000', 'temperatura', 935.0000, 'ºC'),
	(18084, 110, '2015-01-15 00:23:31.000000', 'temperatura', 851.0000, 'ºC'),
	(18085, 110, '2015-01-15 00:23:32.000000', 'temperatura', 251.0000, 'ºC'),
	(18086, 110, '2015-01-15 00:23:33.000000', 'temperatura', 1103.0000, 'ºC'),
	(18087, 110, '2015-01-15 00:23:34.000000', 'temperatura', 1161.0000, 'ºC'),
	(18088, 110, '2015-01-15 00:23:35.000000', 'temperatura', 97.0000, 'ºC'),
	(18089, 110, '2015-01-15 00:23:36.000000', 'temperatura', 604.0000, 'ºC'),
	(18090, 110, '2015-01-15 00:23:37.000000', 'temperatura', 327.0000, 'ºC'),
	(18091, 110, '2015-01-15 00:23:38.000000', 'temperatura', 1024.0000, 'ºC'),
	(18092, 110, '2015-01-15 00:23:39.000000', 'temperatura', 538.0000, 'ºC'),
	(18093, 110, '2015-01-15 00:23:40.000000', 'temperatura', 821.0000, 'ºC'),
	(18094, 110, '2015-01-15 00:23:41.000000', 'temperatura', 90.0000, 'ºC'),
	(18095, 110, '2015-01-15 00:23:42.000000', 'temperatura', 388.0000, 'ºC'),
	(18096, 110, '2015-01-15 00:23:43.000000', 'temperatura', 470.0000, 'ºC'),
	(18097, 110, '2015-01-15 00:23:44.000000', 'temperatura', 1185.0000, 'ºC'),
	(18098, 110, '2015-01-15 00:23:45.000000', 'temperatura', 916.0000, 'ºC'),
	(18099, 110, '2015-01-15 00:23:46.000000', 'temperatura', 1026.0000, 'ºC'),
	(18100, 110, '2015-01-15 00:23:47.000000', 'temperatura', 1181.0000, 'ºC'),
	(18101, 110, '2015-01-15 00:23:48.000000', 'temperatura', 430.0000, 'ºC'),
	(18102, 110, '2015-01-15 00:23:49.000000', 'temperatura', 1007.0000, 'ºC'),
	(18103, 110, '2015-01-15 00:23:50.000000', 'temperatura', 143.0000, 'ºC'),
	(18104, 110, '2015-01-15 00:23:51.000000', 'temperatura', 97.0000, 'ºC'),
	(18105, 110, '2015-01-15 00:23:52.000000', 'temperatura', 57.0000, 'ºC'),
	(18106, 110, '2015-01-15 00:23:53.000000', 'temperatura', 1195.0000, 'ºC'),
	(18107, 110, '2015-01-15 00:23:54.000000', 'temperatura', 1002.0000, 'ºC'),
	(18108, 110, '2015-01-15 00:23:55.000000', 'temperatura', 227.0000, 'ºC'),
	(18109, 110, '2015-01-15 00:23:56.000000', 'temperatura', 531.0000, 'ºC'),
	(18110, 110, '2015-01-15 00:23:57.000000', 'temperatura', 773.0000, 'ºC'),
	(18111, 110, '2015-01-15 00:23:58.000000', 'temperatura', 1072.0000, 'ºC'),
	(18112, 110, '2015-01-15 00:23:59.000000', 'temperatura', 644.0000, 'ºC'),
	(18113, 110, '2015-01-15 00:24:00.000000', 'temperatura', 3.0000, 'ºC'),
	(18114, 110, '2015-01-15 00:24:01.000000', 'temperatura', 484.0000, 'ºC'),
	(18115, 110, '2015-01-15 00:24:02.000000', 'temperatura', 11.0000, 'ºC'),
	(18116, 110, '2015-01-15 00:24:03.000000', 'temperatura', 1004.0000, 'ºC'),
	(18117, 110, '2015-01-15 00:24:04.000000', 'temperatura', 186.0000, 'ºC'),
	(18118, 110, '2015-01-15 00:24:05.000000', 'temperatura', 321.0000, 'ºC'),
	(18119, 110, '2015-01-15 00:24:06.000000', 'temperatura', 1047.0000, 'ºC'),
	(18120, 110, '2015-01-15 00:24:07.000000', 'temperatura', 670.0000, 'ºC'),
	(18121, 110, '2015-01-15 00:24:08.000000', 'temperatura', 211.0000, 'ºC'),
	(18122, 110, '2015-01-15 00:24:09.000000', 'temperatura', 244.0000, 'ºC'),
	(18123, 110, '2015-01-15 00:24:10.000000', 'temperatura', 590.0000, 'ºC'),
	(18124, 110, '2015-01-15 00:24:11.000000', 'temperatura', 1017.0000, 'ºC'),
	(18125, 110, '2015-01-15 00:24:12.000000', 'temperatura', 917.0000, 'ºC'),
	(18126, 110, '2015-01-15 00:24:13.000000', 'temperatura', 334.0000, 'ºC'),
	(18127, 110, '2015-01-15 00:24:14.000000', 'temperatura', 120.0000, 'ºC'),
	(18128, 110, '2015-01-15 00:24:15.000000', 'temperatura', 799.0000, 'ºC'),
	(18129, 110, '2015-01-15 00:24:16.000000', 'temperatura', 34.0000, 'ºC'),
	(18130, 110, '2015-01-15 00:24:17.000000', 'temperatura', 173.0000, 'ºC'),
	(18131, 110, '2015-01-15 00:24:18.000000', 'temperatura', 764.0000, 'ºC'),
	(18132, 110, '2015-01-15 00:24:19.000000', 'temperatura', 900.0000, 'ºC'),
	(18133, 110, '2015-01-15 00:24:20.000000', 'temperatura', 1011.0000, 'ºC'),
	(18134, 110, '2015-01-15 00:24:21.000000', 'temperatura', 1156.0000, 'ºC'),
	(18135, 110, '2015-01-15 00:24:22.000000', 'temperatura', 348.0000, 'ºC'),
	(18136, 110, '2015-01-15 00:24:23.000000', 'temperatura', 670.0000, 'ºC'),
	(18137, 110, '2015-01-15 00:24:24.000000', 'temperatura', 1106.0000, 'ºC'),
	(18138, 110, '2015-01-15 00:24:25.000000', 'temperatura', 1123.0000, 'ºC'),
	(18139, 110, '2015-01-15 00:24:26.000000', 'temperatura', 1095.0000, 'ºC'),
	(18140, 110, '2015-01-15 00:24:27.000000', 'temperatura', 906.0000, 'ºC'),
	(18141, 110, '2015-01-15 00:24:28.000000', 'temperatura', 48.0000, 'ºC'),
	(18142, 110, '2015-01-15 00:24:29.000000', 'temperatura', 1121.0000, 'ºC'),
	(18143, 110, '2015-01-15 00:24:30.000000', 'temperatura', 663.0000, 'ºC'),
	(18144, 110, '2015-01-15 00:24:31.000000', 'temperatura', 1151.0000, 'ºC'),
	(18145, 110, '2015-01-15 00:24:32.000000', 'temperatura', 168.0000, 'ºC'),
	(18146, 110, '2015-01-15 00:24:33.000000', 'temperatura', 986.0000, 'ºC'),
	(18147, 110, '2015-01-15 00:24:34.000000', 'temperatura', 826.0000, 'ºC'),
	(18148, 110, '2015-01-15 00:24:35.000000', 'temperatura', 1171.0000, 'ºC'),
	(18149, 110, '2015-01-15 00:24:36.000000', 'temperatura', 981.0000, 'ºC'),
	(18150, 110, '2015-01-15 00:24:37.000000', 'temperatura', 192.0000, 'ºC'),
	(18151, 110, '2015-01-15 00:24:38.000000', 'temperatura', 416.0000, 'ºC'),
	(18152, 110, '2015-01-15 00:24:39.000000', 'temperatura', 306.0000, 'ºC'),
	(18153, 110, '2015-01-15 00:24:40.000000', 'temperatura', 281.0000, 'ºC'),
	(18154, 110, '2015-01-15 00:24:41.000000', 'temperatura', 488.0000, 'ºC'),
	(18155, 110, '2015-01-15 00:24:42.000000', 'temperatura', 396.0000, 'ºC'),
	(18156, 110, '2015-01-15 00:24:43.000000', 'temperatura', 516.0000, 'ºC'),
	(18157, 110, '2015-01-15 00:24:44.000000', 'temperatura', 195.0000, 'ºC'),
	(18158, 110, '2015-01-15 00:24:45.000000', 'temperatura', 625.0000, 'ºC'),
	(18159, 110, '2015-01-15 00:24:46.000000', 'temperatura', 141.0000, 'ºC'),
	(18160, 110, '2015-01-15 00:24:47.000000', 'temperatura', 30.0000, 'ºC'),
	(18161, 110, '2015-01-15 00:24:48.000000', 'temperatura', 927.0000, 'ºC'),
	(18162, 110, '2015-01-15 00:24:49.000000', 'temperatura', 947.0000, 'ºC'),
	(18163, 110, '2015-01-15 00:24:50.000000', 'temperatura', 753.0000, 'ºC'),
	(18164, 110, '2015-01-15 00:24:51.000000', 'temperatura', 925.0000, 'ºC'),
	(18165, 110, '2015-01-15 00:24:52.000000', 'temperatura', 1165.0000, 'ºC'),
	(18166, 110, '2015-01-15 00:24:53.000000', 'temperatura', 653.0000, 'ºC'),
	(18167, 110, '2015-01-15 00:24:54.000000', 'temperatura', 971.0000, 'ºC'),
	(18168, 110, '2015-01-15 00:24:55.000000', 'temperatura', 497.0000, 'ºC'),
	(18169, 110, '2015-01-15 00:24:56.000000', 'temperatura', 773.0000, 'ºC'),
	(18170, 110, '2015-01-15 00:24:57.000000', 'temperatura', 1174.0000, 'ºC'),
	(18171, 110, '2015-01-15 00:24:58.000000', 'temperatura', 1150.0000, 'ºC'),
	(18172, 110, '2015-01-15 00:24:59.000000', 'temperatura', 1031.0000, 'ºC'),
	(18173, 110, '2015-01-15 00:25:00.000000', 'temperatura', 506.0000, 'ºC'),
	(18174, 110, '2015-01-15 00:25:01.000000', 'temperatura', 635.0000, 'ºC'),
	(18175, 110, '2015-01-15 00:25:02.000000', 'temperatura', 457.0000, 'ºC'),
	(18176, 110, '2015-01-15 00:25:03.000000', 'temperatura', 383.0000, 'ºC'),
	(18177, 110, '2015-01-15 00:25:04.000000', 'temperatura', 544.0000, 'ºC'),
	(18178, 110, '2015-01-15 00:25:05.000000', 'temperatura', 372.0000, 'ºC'),
	(18179, 110, '2015-01-15 00:25:06.000000', 'temperatura', 227.0000, 'ºC'),
	(18180, 110, '2015-01-15 00:25:07.000000', 'temperatura', 21.0000, 'ºC'),
	(18181, 110, '2015-01-15 00:25:08.000000', 'temperatura', 623.0000, 'ºC'),
	(18182, 110, '2015-01-15 00:25:09.000000', 'temperatura', 654.0000, 'ºC'),
	(18183, 110, '2015-01-15 00:25:10.000000', 'temperatura', 202.0000, 'ºC'),
	(18184, 110, '2015-01-15 00:25:11.000000', 'temperatura', 248.0000, 'ºC'),
	(18185, 110, '2015-01-15 00:25:12.000000', 'temperatura', 634.0000, 'ºC'),
	(18186, 110, '2015-01-15 00:25:13.000000', 'temperatura', 27.0000, 'ºC'),
	(18187, 110, '2015-01-15 00:25:14.000000', 'temperatura', 633.0000, 'ºC'),
	(18188, 110, '2015-01-15 00:25:15.000000', 'temperatura', 683.0000, 'ºC'),
	(18189, 110, '2015-01-15 00:25:16.000000', 'temperatura', 319.0000, 'ºC'),
	(18190, 110, '2015-01-15 00:25:17.000000', 'temperatura', 746.0000, 'ºC'),
	(18191, 110, '2015-01-15 00:25:18.000000', 'temperatura', 375.0000, 'ºC'),
	(18192, 110, '2015-01-15 00:25:19.000000', 'temperatura', 835.0000, 'ºC'),
	(18193, 110, '2015-01-15 00:25:20.000000', 'temperatura', 652.0000, 'ºC'),
	(18194, 110, '2015-01-15 00:25:21.000000', 'temperatura', 753.0000, 'ºC'),
	(18195, 110, '2015-01-15 00:25:22.000000', 'temperatura', 612.0000, 'ºC'),
	(18196, 110, '2015-01-15 00:25:23.000000', 'temperatura', 801.0000, 'ºC'),
	(18197, 110, '2015-01-15 00:25:24.000000', 'temperatura', 968.0000, 'ºC'),
	(18198, 110, '2015-01-15 00:25:25.000000', 'temperatura', 39.0000, 'ºC'),
	(18199, 110, '2015-01-15 00:25:26.000000', 'temperatura', 889.0000, 'ºC'),
	(18200, 110, '2015-01-15 00:25:27.000000', 'temperatura', 731.0000, 'ºC'),
	(18201, 110, '2015-01-15 00:25:28.000000', 'temperatura', 989.0000, 'ºC'),
	(18202, 110, '2015-01-15 00:25:29.000000', 'temperatura', 351.0000, 'ºC'),
	(18203, 110, '2015-01-15 00:25:30.000000', 'temperatura', 1189.0000, 'ºC'),
	(18204, 110, '2015-01-15 00:25:31.000000', 'temperatura', 94.0000, 'ºC'),
	(18205, 110, '2015-01-15 00:25:32.000000', 'temperatura', 503.0000, 'ºC'),
	(18206, 110, '2015-01-15 00:25:33.000000', 'temperatura', 1031.0000, 'ºC'),
	(18207, 110, '2015-01-15 00:25:34.000000', 'temperatura', 49.0000, 'ºC'),
	(18208, 110, '2015-01-15 00:25:35.000000', 'temperatura', 750.0000, 'ºC'),
	(18209, 110, '2015-01-15 00:25:36.000000', 'temperatura', 7.0000, 'ºC'),
	(18210, 110, '2015-01-15 00:25:37.000000', 'temperatura', 183.0000, 'ºC'),
	(18211, 110, '2015-01-15 00:25:38.000000', 'temperatura', 893.0000, 'ºC'),
	(18212, 110, '2015-01-15 00:25:39.000000', 'temperatura', 319.0000, 'ºC'),
	(18213, 110, '2015-01-15 00:25:40.000000', 'temperatura', 116.0000, 'ºC'),
	(18214, 110, '2015-01-15 00:25:41.000000', 'temperatura', 825.0000, 'ºC'),
	(18215, 110, '2015-01-15 00:25:42.000000', 'temperatura', 175.0000, 'ºC'),
	(18216, 110, '2015-01-15 00:25:43.000000', 'temperatura', 803.0000, 'ºC'),
	(18217, 110, '2015-01-15 00:25:44.000000', 'temperatura', 1088.0000, 'ºC'),
	(18218, 110, '2015-01-15 00:25:45.000000', 'temperatura', 633.0000, 'ºC'),
	(18219, 110, '2015-01-15 00:25:46.000000', 'temperatura', 1101.0000, 'ºC'),
	(18220, 110, '2015-01-15 00:25:47.000000', 'temperatura', 8.0000, 'ºC'),
	(18221, 110, '2015-01-15 00:25:48.000000', 'temperatura', 337.0000, 'ºC'),
	(18222, 110, '2015-01-15 00:25:49.000000', 'temperatura', 461.0000, 'ºC'),
	(18223, 110, '2015-01-15 00:25:50.000000', 'temperatura', 94.0000, 'ºC'),
	(18224, 110, '2015-01-15 00:25:51.000000', 'temperatura', 287.0000, 'ºC'),
	(18225, 110, '2015-01-15 00:25:52.000000', 'temperatura', 1156.0000, 'ºC'),
	(18226, 110, '2015-01-15 00:25:53.000000', 'temperatura', 118.0000, 'ºC'),
	(18227, 110, '2015-01-15 00:25:54.000000', 'temperatura', 724.0000, 'ºC'),
	(18228, 110, '2015-01-15 00:25:55.000000', 'temperatura', 865.0000, 'ºC'),
	(18229, 110, '2015-01-15 00:25:56.000000', 'temperatura', 955.0000, 'ºC'),
	(18230, 110, '2015-01-15 00:25:57.000000', 'temperatura', 980.0000, 'ºC'),
	(18231, 110, '2015-01-15 00:25:58.000000', 'temperatura', 833.0000, 'ºC'),
	(18232, 110, '2015-01-15 00:25:59.000000', 'temperatura', 28.0000, 'ºC'),
	(18233, 110, '2015-01-15 00:26:00.000000', 'temperatura', 42.0000, 'ºC'),
	(18234, 110, '2015-01-15 00:26:01.000000', 'temperatura', 126.0000, 'ºC'),
	(18235, 110, '2015-01-15 00:26:02.000000', 'temperatura', 506.0000, 'ºC'),
	(18236, 110, '2015-01-15 00:26:03.000000', 'temperatura', 951.0000, 'ºC'),
	(18237, 110, '2015-01-15 00:26:04.000000', 'temperatura', 837.0000, 'ºC'),
	(18238, 110, '2015-01-15 00:26:05.000000', 'temperatura', 135.0000, 'ºC'),
	(18239, 110, '2015-01-15 00:26:06.000000', 'temperatura', 563.0000, 'ºC'),
	(18240, 110, '2015-01-15 00:26:07.000000', 'temperatura', 10.0000, 'ºC'),
	(18241, 110, '2015-01-15 00:26:08.000000', 'temperatura', 764.0000, 'ºC'),
	(18242, 110, '2015-01-15 00:26:09.000000', 'temperatura', 187.0000, 'ºC'),
	(18243, 110, '2015-01-15 00:26:10.000000', 'temperatura', 1047.0000, 'ºC'),
	(18244, 110, '2015-01-15 00:26:11.000000', 'temperatura', 1072.0000, 'ºC'),
	(18245, 110, '2015-01-15 00:26:12.000000', 'temperatura', 1019.0000, 'ºC'),
	(18246, 110, '2015-01-15 00:26:13.000000', 'temperatura', 682.0000, 'ºC'),
	(18247, 110, '2015-01-15 00:26:14.000000', 'temperatura', 351.0000, 'ºC'),
	(18248, 110, '2015-01-15 00:26:15.000000', 'temperatura', 909.0000, 'ºC'),
	(18249, 110, '2015-01-15 00:26:16.000000', 'temperatura', 1094.0000, 'ºC'),
	(18250, 110, '2015-01-15 00:26:17.000000', 'temperatura', 342.0000, 'ºC'),
	(18251, 110, '2015-01-15 00:26:18.000000', 'temperatura', 829.0000, 'ºC'),
	(18252, 110, '2015-01-15 00:26:19.000000', 'temperatura', 719.0000, 'ºC'),
	(18253, 110, '2015-01-15 00:26:20.000000', 'temperatura', 1109.0000, 'ºC'),
	(18254, 110, '2015-01-15 00:26:21.000000', 'temperatura', 987.0000, 'ºC'),
	(18255, 110, '2015-01-15 00:26:22.000000', 'temperatura', 408.0000, 'ºC'),
	(18256, 110, '2015-01-15 00:26:23.000000', 'temperatura', 282.0000, 'ºC'),
	(18257, 110, '2015-01-15 00:26:24.000000', 'temperatura', 185.0000, 'ºC'),
	(18258, 110, '2015-01-15 00:26:25.000000', 'temperatura', 78.0000, 'ºC'),
	(18259, 110, '2015-01-15 00:26:26.000000', 'temperatura', 1036.0000, 'ºC'),
	(18260, 110, '2015-01-15 00:26:27.000000', 'temperatura', 146.0000, 'ºC'),
	(18261, 110, '2015-01-15 00:26:28.000000', 'temperatura', 23.0000, 'ºC'),
	(18262, 110, '2015-01-15 00:26:29.000000', 'temperatura', 876.0000, 'ºC'),
	(18263, 110, '2015-01-15 00:26:30.000000', 'temperatura', 712.0000, 'ºC'),
	(18264, 110, '2015-01-15 00:26:31.000000', 'temperatura', 933.0000, 'ºC'),
	(18265, 110, '2015-01-15 00:26:32.000000', 'temperatura', 129.0000, 'ºC'),
	(18266, 110, '2015-01-15 00:26:33.000000', 'temperatura', 248.0000, 'ºC'),
	(18267, 110, '2015-01-15 00:26:34.000000', 'temperatura', 852.0000, 'ºC'),
	(18268, 110, '2015-01-15 00:26:35.000000', 'temperatura', 1115.0000, 'ºC'),
	(18269, 110, '2015-01-15 00:26:36.000000', 'temperatura', 621.0000, 'ºC'),
	(18270, 110, '2015-01-15 00:26:37.000000', 'temperatura', 959.0000, 'ºC'),
	(18271, 110, '2015-01-15 00:26:38.000000', 'temperatura', 534.0000, 'ºC'),
	(18272, 110, '2015-01-15 00:26:39.000000', 'temperatura', 992.0000, 'ºC'),
	(18273, 110, '2015-01-15 00:26:40.000000', 'temperatura', 958.0000, 'ºC'),
	(18274, 110, '2015-01-15 00:26:41.000000', 'temperatura', 615.0000, 'ºC'),
	(18275, 110, '2015-01-15 00:26:42.000000', 'temperatura', 202.0000, 'ºC'),
	(18276, 110, '2015-01-15 00:26:43.000000', 'temperatura', 363.0000, 'ºC'),
	(18277, 110, '2015-01-15 00:26:44.000000', 'temperatura', 13.0000, 'ºC'),
	(18278, 110, '2015-01-15 00:26:45.000000', 'temperatura', 174.0000, 'ºC'),
	(18279, 110, '2015-01-15 00:26:46.000000', 'temperatura', 832.0000, 'ºC'),
	(18280, 110, '2015-01-15 00:26:47.000000', 'temperatura', 38.0000, 'ºC'),
	(18281, 110, '2015-01-15 00:26:48.000000', 'temperatura', 95.0000, 'ºC'),
	(18282, 110, '2015-01-15 00:26:49.000000', 'temperatura', 361.0000, 'ºC'),
	(18283, 110, '2015-01-15 00:26:50.000000', 'temperatura', 320.0000, 'ºC'),
	(18284, 110, '2015-01-15 00:26:51.000000', 'temperatura', 517.0000, 'ºC'),
	(18285, 110, '2015-01-15 00:26:52.000000', 'temperatura', 427.0000, 'ºC'),
	(18286, 110, '2015-01-15 00:26:53.000000', 'temperatura', 583.0000, 'ºC'),
	(18287, 110, '2015-01-15 00:26:54.000000', 'temperatura', 434.0000, 'ºC'),
	(18288, 110, '2015-01-15 00:26:55.000000', 'temperatura', 421.0000, 'ºC'),
	(18289, 110, '2015-01-15 00:26:56.000000', 'temperatura', 806.0000, 'ºC'),
	(18290, 110, '2015-01-15 00:26:57.000000', 'temperatura', 366.0000, 'ºC'),
	(18291, 110, '2015-01-15 00:26:58.000000', 'temperatura', 613.0000, 'ºC'),
	(18292, 110, '2015-01-15 00:26:59.000000', 'temperatura', 769.0000, 'ºC'),
	(18293, 110, '2015-01-15 00:27:00.000000', 'temperatura', 807.0000, 'ºC'),
	(18294, 110, '2015-01-15 00:27:01.000000', 'temperatura', 526.0000, 'ºC'),
	(18295, 110, '2015-01-15 00:27:02.000000', 'temperatura', 211.0000, 'ºC'),
	(18296, 110, '2015-01-15 00:27:03.000000', 'temperatura', 679.0000, 'ºC'),
	(18297, 110, '2015-01-15 00:27:04.000000', 'temperatura', 361.0000, 'ºC'),
	(18298, 110, '2015-01-15 00:27:05.000000', 'temperatura', 969.0000, 'ºC'),
	(18299, 110, '2015-01-15 00:27:06.000000', 'temperatura', 163.0000, 'ºC'),
	(18300, 110, '2015-01-15 00:27:07.000000', 'temperatura', 308.0000, 'ºC'),
	(18301, 110, '2015-01-15 00:27:08.000000', 'temperatura', 1053.0000, 'ºC'),
	(18302, 110, '2015-01-15 00:27:09.000000', 'temperatura', 741.0000, 'ºC'),
	(18303, 110, '2015-01-15 00:27:10.000000', 'temperatura', 545.0000, 'ºC'),
	(18304, 110, '2015-01-15 00:27:11.000000', 'temperatura', 504.0000, 'ºC'),
	(18305, 110, '2015-01-15 00:27:12.000000', 'temperatura', 886.0000, 'ºC'),
	(18306, 110, '2015-01-15 00:27:13.000000', 'temperatura', 516.0000, 'ºC'),
	(18307, 110, '2015-01-15 00:27:14.000000', 'temperatura', 1126.0000, 'ºC'),
	(18308, 110, '2015-01-15 00:27:15.000000', 'temperatura', 479.0000, 'ºC'),
	(18309, 110, '2015-01-15 00:27:16.000000', 'temperatura', 218.0000, 'ºC'),
	(18310, 110, '2015-01-15 00:27:17.000000', 'temperatura', 856.0000, 'ºC'),
	(18311, 110, '2015-01-15 00:27:18.000000', 'temperatura', 25.0000, 'ºC'),
	(18312, 110, '2015-01-15 00:27:19.000000', 'temperatura', 1158.0000, 'ºC'),
	(18313, 110, '2015-01-15 00:27:20.000000', 'temperatura', 916.0000, 'ºC'),
	(18314, 110, '2015-01-15 00:27:21.000000', 'temperatura', 1106.0000, 'ºC'),
	(18315, 110, '2015-01-15 00:27:22.000000', 'temperatura', 383.0000, 'ºC'),
	(18316, 110, '2015-01-15 00:27:23.000000', 'temperatura', 997.0000, 'ºC'),
	(18317, 110, '2015-01-15 00:27:24.000000', 'temperatura', 238.0000, 'ºC'),
	(18318, 110, '2015-01-15 00:27:25.000000', 'temperatura', 598.0000, 'ºC'),
	(18319, 110, '2015-01-15 00:27:26.000000', 'temperatura', 1078.0000, 'ºC'),
	(18320, 110, '2015-01-15 00:27:27.000000', 'temperatura', 1194.0000, 'ºC'),
	(18321, 110, '2015-01-15 00:27:28.000000', 'temperatura', 336.0000, 'ºC'),
	(18322, 110, '2015-01-15 00:27:29.000000', 'temperatura', 499.0000, 'ºC'),
	(18323, 110, '2015-01-15 00:27:30.000000', 'temperatura', 287.0000, 'ºC'),
	(18324, 110, '2015-01-15 00:27:31.000000', 'temperatura', 1140.0000, 'ºC'),
	(18325, 110, '2015-01-15 00:27:32.000000', 'temperatura', 40.0000, 'ºC'),
	(18326, 110, '2015-01-15 00:27:33.000000', 'temperatura', 379.0000, 'ºC'),
	(18327, 110, '2015-01-15 00:27:34.000000', 'temperatura', 578.0000, 'ºC'),
	(18328, 110, '2015-01-15 00:27:35.000000', 'temperatura', 552.0000, 'ºC'),
	(18329, 110, '2015-01-15 00:27:36.000000', 'temperatura', 1027.0000, 'ºC'),
	(18330, 110, '2015-01-15 00:27:37.000000', 'temperatura', 1080.0000, 'ºC'),
	(18331, 110, '2015-01-15 00:27:38.000000', 'temperatura', 1117.0000, 'ºC'),
	(18332, 110, '2015-01-15 00:27:39.000000', 'temperatura', 1146.0000, 'ºC'),
	(18333, 110, '2015-01-15 00:27:40.000000', 'temperatura', 1181.0000, 'ºC'),
	(18334, 110, '2015-01-15 00:27:41.000000', 'temperatura', 68.0000, 'ºC'),
	(18335, 110, '2015-01-15 00:27:42.000000', 'temperatura', 398.0000, 'ºC'),
	(18336, 110, '2015-01-15 00:27:43.000000', 'temperatura', 584.0000, 'ºC'),
	(18337, 110, '2015-01-15 00:27:44.000000', 'temperatura', 526.0000, 'ºC'),
	(18338, 110, '2015-01-15 00:27:45.000000', 'temperatura', 881.0000, 'ºC'),
	(18339, 110, '2015-01-15 00:27:46.000000', 'temperatura', 425.0000, 'ºC'),
	(18340, 110, '2015-01-15 00:27:47.000000', 'temperatura', 682.0000, 'ºC'),
	(18341, 110, '2015-01-15 00:27:48.000000', 'temperatura', 936.0000, 'ºC'),
	(18342, 110, '2015-01-15 00:27:49.000000', 'temperatura', 236.0000, 'ºC'),
	(18343, 110, '2015-01-15 00:27:50.000000', 'temperatura', 773.0000, 'ºC'),
	(18344, 110, '2015-01-15 00:27:51.000000', 'temperatura', 757.0000, 'ºC'),
	(18345, 110, '2015-01-15 00:27:52.000000', 'temperatura', 267.0000, 'ºC'),
	(18346, 110, '2015-01-15 00:27:53.000000', 'temperatura', 263.0000, 'ºC'),
	(18347, 110, '2015-01-15 00:27:54.000000', 'temperatura', 516.0000, 'ºC'),
	(18348, 110, '2015-01-15 00:27:55.000000', 'temperatura', 590.0000, 'ºC'),
	(18349, 110, '2015-01-15 00:27:56.000000', 'temperatura', 203.0000, 'ºC'),
	(18350, 110, '2015-01-15 00:27:57.000000', 'temperatura', 447.0000, 'ºC'),
	(18351, 110, '2015-01-15 00:27:58.000000', 'temperatura', 425.0000, 'ºC'),
	(18352, 110, '2015-01-15 00:27:59.000000', 'temperatura', 783.0000, 'ºC'),
	(18353, 110, '2015-01-15 00:28:00.000000', 'temperatura', 243.0000, 'ºC'),
	(18354, 110, '2015-01-15 00:28:01.000000', 'temperatura', 68.0000, 'ºC'),
	(18355, 110, '2015-01-15 00:28:02.000000', 'temperatura', 808.0000, 'ºC'),
	(18356, 110, '2015-01-15 00:28:03.000000', 'temperatura', 238.0000, 'ºC'),
	(18357, 110, '2015-01-15 00:28:04.000000', 'temperatura', 1165.0000, 'ºC'),
	(18358, 110, '2015-01-15 00:28:05.000000', 'temperatura', 310.0000, 'ºC'),
	(18359, 110, '2015-01-15 00:28:06.000000', 'temperatura', 459.0000, 'ºC'),
	(18360, 110, '2015-01-15 00:28:07.000000', 'temperatura', 165.0000, 'ºC'),
	(18361, 110, '2015-01-15 00:28:08.000000', 'temperatura', 650.0000, 'ºC'),
	(18362, 110, '2015-01-15 00:28:09.000000', 'temperatura', 353.0000, 'ºC'),
	(18363, 110, '2015-01-15 00:28:10.000000', 'temperatura', 1014.0000, 'ºC'),
	(18364, 110, '2015-01-15 00:28:11.000000', 'temperatura', 415.0000, 'ºC'),
	(18365, 110, '2015-01-15 00:28:12.000000', 'temperatura', 232.0000, 'ºC'),
	(18366, 110, '2015-01-15 00:28:13.000000', 'temperatura', 1114.0000, 'ºC'),
	(18367, 110, '2015-01-15 00:28:14.000000', 'temperatura', 77.0000, 'ºC'),
	(18368, 110, '2015-01-15 00:28:15.000000', 'temperatura', 643.0000, 'ºC'),
	(18369, 110, '2015-01-15 00:28:16.000000', 'temperatura', 585.0000, 'ºC'),
	(18370, 110, '2015-01-15 00:28:17.000000', 'temperatura', 996.0000, 'ºC'),
	(18371, 110, '2015-01-15 00:28:18.000000', 'temperatura', 825.0000, 'ºC'),
	(18372, 110, '2015-01-15 00:28:19.000000', 'temperatura', 1138.0000, 'ºC'),
	(18373, 110, '2015-01-15 00:28:20.000000', 'temperatura', 816.0000, 'ºC'),
	(18374, 110, '2015-01-15 00:28:21.000000', 'temperatura', 665.0000, 'ºC'),
	(18375, 110, '2015-01-15 00:28:22.000000', 'temperatura', 878.0000, 'ºC'),
	(18376, 110, '2015-01-15 00:28:23.000000', 'temperatura', 1195.0000, 'ºC'),
	(18377, 110, '2015-01-15 00:28:24.000000', 'temperatura', 942.0000, 'ºC'),
	(18378, 110, '2015-01-15 00:28:25.000000', 'temperatura', 1125.0000, 'ºC'),
	(18379, 110, '2015-01-15 00:28:26.000000', 'temperatura', 398.0000, 'ºC'),
	(18380, 110, '2015-01-15 00:28:27.000000', 'temperatura', 1019.0000, 'ºC'),
	(18381, 110, '2015-01-15 00:28:28.000000', 'temperatura', 299.0000, 'ºC'),
	(18382, 110, '2015-01-15 00:28:29.000000', 'temperatura', 839.0000, 'ºC'),
	(18383, 110, '2015-01-15 00:28:30.000000', 'temperatura', 901.0000, 'ºC'),
	(18384, 110, '2015-01-15 00:28:31.000000', 'temperatura', 786.0000, 'ºC'),
	(18385, 110, '2015-01-15 00:28:32.000000', 'temperatura', 27.0000, 'ºC'),
	(18386, 110, '2015-01-15 00:28:33.000000', 'temperatura', 179.0000, 'ºC'),
	(18387, 110, '2015-01-15 00:28:34.000000', 'temperatura', 813.0000, 'ºC'),
	(18388, 110, '2015-01-15 00:28:35.000000', 'temperatura', 1128.0000, 'ºC'),
	(18389, 110, '2015-01-15 00:28:36.000000', 'temperatura', 804.0000, 'ºC'),
	(18390, 110, '2015-01-15 00:28:37.000000', 'temperatura', 633.0000, 'ºC'),
	(18391, 110, '2015-01-15 00:28:38.000000', 'temperatura', 757.0000, 'ºC'),
	(18392, 110, '2015-01-15 00:28:39.000000', 'temperatura', 683.0000, 'ºC'),
	(18393, 110, '2015-01-15 00:28:40.000000', 'temperatura', 1147.0000, 'ºC'),
	(18394, 110, '2015-01-15 00:28:41.000000', 'temperatura', 84.0000, 'ºC'),
	(18395, 110, '2015-01-15 00:28:42.000000', 'temperatura', 582.0000, 'ºC'),
	(18396, 110, '2015-01-15 00:28:43.000000', 'temperatura', 256.0000, 'ºC'),
	(18397, 110, '2015-01-15 00:28:44.000000', 'temperatura', 737.0000, 'ºC'),
	(18398, 110, '2015-01-15 00:28:45.000000', 'temperatura', 516.0000, 'ºC'),
	(18399, 110, '2015-01-15 00:28:46.000000', 'temperatura', 371.0000, 'ºC'),
	(18400, 110, '2015-01-15 00:28:47.000000', 'temperatura', 307.0000, 'ºC'),
	(18401, 110, '2015-01-15 00:28:48.000000', 'temperatura', 422.0000, 'ºC'),
	(18402, 110, '2015-01-15 00:28:49.000000', 'temperatura', 1188.0000, 'ºC'),
	(18403, 110, '2015-01-15 00:28:50.000000', 'temperatura', 1078.0000, 'ºC'),
	(18404, 110, '2015-01-15 00:28:51.000000', 'temperatura', 623.0000, 'ºC'),
	(18405, 110, '2015-01-15 00:28:52.000000', 'temperatura', 1084.0000, 'ºC'),
	(18406, 110, '2015-01-15 00:28:53.000000', 'temperatura', 1149.0000, 'ºC'),
	(18407, 110, '2015-01-15 00:28:54.000000', 'temperatura', 95.0000, 'ºC'),
	(18408, 110, '2015-01-15 00:28:55.000000', 'temperatura', 627.0000, 'ºC'),
	(18409, 110, '2015-01-15 00:28:56.000000', 'temperatura', 451.0000, 'ºC'),
	(18410, 110, '2015-01-15 00:28:57.000000', 'temperatura', 376.0000, 'ºC'),
	(18411, 110, '2015-01-15 00:28:58.000000', 'temperatura', 529.0000, 'ºC'),
	(18412, 110, '2015-01-15 00:28:59.000000', 'temperatura', 315.0000, 'ºC'),
	(18413, 110, '2015-01-15 00:29:00.000000', 'temperatura', 1188.0000, 'ºC'),
	(18414, 110, '2015-01-15 00:29:01.000000', 'temperatura', 196.0000, 'ºC'),
	(18415, 110, '2015-01-15 00:29:02.000000', 'temperatura', 1019.0000, 'ºC'),
	(18416, 110, '2015-01-15 00:29:03.000000', 'temperatura', 904.0000, 'ºC'),
	(18417, 110, '2015-01-15 00:29:04.000000', 'temperatura', 266.0000, 'ºC'),
	(18418, 110, '2015-01-15 00:29:05.000000', 'temperatura', 1016.0000, 'ºC'),
	(18419, 110, '2015-01-15 00:29:06.000000', 'temperatura', 685.0000, 'ºC'),
	(18420, 110, '2015-01-15 00:29:07.000000', 'temperatura', 375.0000, 'ºC'),
	(18421, 110, '2015-01-15 00:29:08.000000', 'temperatura', 1023.0000, 'ºC'),
	(18422, 110, '2015-01-15 00:29:09.000000', 'temperatura', 390.0000, 'ºC'),
	(18423, 110, '2015-01-15 00:29:10.000000', 'temperatura', 81.0000, 'ºC'),
	(18424, 110, '2015-01-15 00:29:11.000000', 'temperatura', 438.0000, 'ºC'),
	(18425, 110, '2015-01-15 00:29:12.000000', 'temperatura', 744.0000, 'ºC'),
	(18426, 110, '2015-01-15 00:29:13.000000', 'temperatura', 7.0000, 'ºC'),
	(18427, 110, '2015-01-15 00:29:14.000000', 'temperatura', 205.0000, 'ºC'),
	(18428, 110, '2015-01-15 00:29:15.000000', 'temperatura', 1003.0000, 'ºC'),
	(18429, 110, '2015-01-15 00:29:16.000000', 'temperatura', 803.0000, 'ºC'),
	(18430, 110, '2015-01-15 00:29:17.000000', 'temperatura', 1004.0000, 'ºC'),
	(18431, 110, '2015-01-15 00:29:18.000000', 'temperatura', 211.0000, 'ºC'),
	(18432, 110, '2015-01-15 00:29:19.000000', 'temperatura', 446.0000, 'ºC'),
	(18433, 110, '2015-01-15 00:29:20.000000', 'temperatura', 395.0000, 'ºC'),
	(18434, 110, '2015-01-15 00:29:21.000000', 'temperatura', 640.0000, 'ºC'),
	(18435, 110, '2015-01-15 00:29:22.000000', 'temperatura', 815.0000, 'ºC'),
	(18436, 110, '2015-01-15 00:29:23.000000', 'temperatura', 954.0000, 'ºC'),
	(18437, 110, '2015-01-15 00:29:24.000000', 'temperatura', 1126.0000, 'ºC'),
	(18438, 110, '2015-01-15 00:29:25.000000', 'temperatura', 370.0000, 'ºC'),
	(18439, 110, '2015-01-15 00:29:26.000000', 'temperatura', 870.0000, 'ºC'),
	(18440, 110, '2015-01-15 00:29:27.000000', 'temperatura', 843.0000, 'ºC'),
	(18441, 110, '2015-01-15 00:29:28.000000', 'temperatura', 405.0000, 'ºC'),
	(18442, 110, '2015-01-15 00:29:29.000000', 'temperatura', 695.0000, 'ºC'),
	(18443, 110, '2015-01-15 00:29:30.000000', 'temperatura', 1059.0000, 'ºC'),
	(18444, 110, '2015-01-15 00:29:31.000000', 'temperatura', 814.0000, 'ºC'),
	(18445, 110, '2015-01-15 00:29:32.000000', 'temperatura', 891.0000, 'ºC'),
	(18446, 110, '2015-01-15 00:29:33.000000', 'temperatura', 813.0000, 'ºC'),
	(18447, 110, '2015-01-15 00:29:34.000000', 'temperatura', 192.0000, 'ºC'),
	(18448, 110, '2015-01-15 00:29:35.000000', 'temperatura', 922.0000, 'ºC'),
	(18449, 110, '2015-01-15 00:29:36.000000', 'temperatura', 433.0000, 'ºC'),
	(18450, 110, '2015-01-15 00:29:37.000000', 'temperatura', 602.0000, 'ºC'),
	(18451, 110, '2015-01-15 00:29:38.000000', 'temperatura', 509.0000, 'ºC'),
	(18452, 110, '2015-01-15 00:29:39.000000', 'temperatura', 739.0000, 'ºC'),
	(18453, 110, '2015-01-15 00:29:40.000000', 'temperatura', 970.0000, 'ºC'),
	(18454, 110, '2015-01-15 00:29:41.000000', 'temperatura', 234.0000, 'ºC'),
	(18455, 110, '2015-01-15 00:29:42.000000', 'temperatura', 660.0000, 'ºC'),
	(18456, 110, '2015-01-15 00:29:43.000000', 'temperatura', 200.0000, 'ºC'),
	(18457, 110, '2015-01-15 00:29:44.000000', 'temperatura', 219.0000, 'ºC'),
	(18458, 110, '2015-01-15 00:29:45.000000', 'temperatura', 494.0000, 'ºC'),
	(18459, 110, '2015-01-15 00:29:46.000000', 'temperatura', 617.0000, 'ºC'),
	(18460, 110, '2015-01-15 00:29:47.000000', 'temperatura', 400.0000, 'ºC'),
	(18461, 110, '2015-01-15 00:29:48.000000', 'temperatura', 152.0000, 'ºC'),
	(18462, 110, '2015-01-15 00:29:49.000000', 'temperatura', 760.0000, 'ºC'),
	(18463, 110, '2015-01-15 00:29:50.000000', 'temperatura', 944.0000, 'ºC'),
	(18464, 110, '2015-01-15 00:29:51.000000', 'temperatura', 41.0000, 'ºC'),
	(18465, 110, '2015-01-15 00:29:52.000000', 'temperatura', 974.0000, 'ºC'),
	(18466, 110, '2015-01-15 00:29:53.000000', 'temperatura', 1148.0000, 'ºC'),
	(18467, 110, '2015-01-15 00:29:54.000000', 'temperatura', 418.0000, 'ºC'),
	(18468, 110, '2015-01-15 00:29:55.000000', 'temperatura', 1046.0000, 'ºC'),
	(18469, 110, '2015-01-15 00:29:56.000000', 'temperatura', 377.0000, 'ºC'),
	(18470, 110, '2015-01-15 00:29:57.000000', 'temperatura', 1145.0000, 'ºC'),
	(18471, 110, '2015-01-15 00:29:58.000000', 'temperatura', 998.0000, 'ºC'),
	(18472, 110, '2015-01-15 00:29:59.000000', 'temperatura', 353.0000, 'ºC'),
	(18473, 110, '2015-01-15 00:30:00.000000', 'temperatura', 1172.0000, 'ºC'),
	(18474, 110, '2015-01-15 00:30:01.000000', 'temperatura', 0.0000, 'ºC'),
	(18475, 110, '2015-01-15 00:30:02.000000', 'temperatura', 85.0000, 'ºC'),
	(18476, 110, '2015-01-15 00:30:03.000000', 'temperatura', 426.0000, 'ºC'),
	(18477, 110, '2015-01-15 00:30:04.000000', 'temperatura', 674.0000, 'ºC'),
	(18478, 110, '2015-01-15 00:30:05.000000', 'temperatura', 893.0000, 'ºC'),
	(18479, 110, '2015-01-15 00:30:06.000000', 'temperatura', 42.0000, 'ºC'),
	(18480, 110, '2015-01-15 00:30:07.000000', 'temperatura', 1134.0000, 'ºC'),
	(18481, 110, '2015-01-15 00:30:08.000000', 'temperatura', 745.0000, 'ºC'),
	(18482, 110, '2015-01-15 00:30:09.000000', 'temperatura', 323.0000, 'ºC'),
	(18483, 110, '2015-01-15 00:30:10.000000', 'temperatura', 579.0000, 'ºC'),
	(18484, 110, '2015-01-15 00:30:11.000000', 'temperatura', 726.0000, 'ºC'),
	(18485, 110, '2015-01-15 00:30:12.000000', 'temperatura', 694.0000, 'ºC'),
	(18486, 110, '2015-01-15 00:30:13.000000', 'temperatura', 94.0000, 'ºC'),
	(18487, 110, '2015-01-15 00:30:14.000000', 'temperatura', 786.0000, 'ºC'),
	(18488, 110, '2015-01-15 00:30:15.000000', 'temperatura', 49.0000, 'ºC'),
	(18489, 110, '2015-01-15 00:30:16.000000', 'temperatura', 287.0000, 'ºC'),
	(18490, 110, '2015-01-15 00:30:17.000000', 'temperatura', 89.0000, 'ºC'),
	(18491, 110, '2015-01-15 00:30:18.000000', 'temperatura', 787.0000, 'ºC'),
	(18492, 110, '2015-01-15 00:30:19.000000', 'temperatura', 65.0000, 'ºC'),
	(18493, 110, '2015-01-15 00:30:20.000000', 'temperatura', 367.0000, 'ºC'),
	(18494, 110, '2015-01-15 00:30:21.000000', 'temperatura', 438.0000, 'ºC'),
	(18495, 110, '2015-01-15 00:30:22.000000', 'temperatura', 1090.0000, 'ºC'),
	(18496, 110, '2015-01-15 00:30:23.000000', 'temperatura', 535.0000, 'ºC'),
	(18497, 110, '2015-01-15 00:30:24.000000', 'temperatura', 608.0000, 'ºC'),
	(18498, 110, '2015-01-15 00:30:25.000000', 'temperatura', 237.0000, 'ºC'),
	(18499, 110, '2015-01-15 00:30:26.000000', 'temperatura', 558.0000, 'ºC'),
	(18500, 110, '2015-01-15 00:30:27.000000', 'temperatura', 883.0000, 'ºC'),
	(18501, 110, '2015-01-15 00:30:28.000000', 'temperatura', 339.0000, 'ºC'),
	(18502, 110, '2015-01-15 00:30:29.000000', 'temperatura', 245.0000, 'ºC'),
	(18503, 110, '2015-01-15 00:30:30.000000', 'temperatura', 211.0000, 'ºC'),
	(18504, 110, '2015-01-15 00:30:31.000000', 'temperatura', 321.0000, 'ºC'),
	(18505, 110, '2015-01-15 00:30:32.000000', 'temperatura', 973.0000, 'ºC'),
	(18506, 110, '2015-01-15 00:30:33.000000', 'temperatura', 300.0000, 'ºC'),
	(18507, 110, '2015-01-15 00:30:34.000000', 'temperatura', 984.0000, 'ºC'),
	(18508, 110, '2015-01-15 00:30:35.000000', 'temperatura', 418.0000, 'ºC'),
	(18509, 110, '2015-01-15 00:30:36.000000', 'temperatura', 340.0000, 'ºC'),
	(18510, 110, '2015-01-15 00:30:37.000000', 'temperatura', 444.0000, 'ºC'),
	(18511, 110, '2015-01-15 00:30:38.000000', 'temperatura', 3.0000, 'ºC'),
	(18512, 110, '2015-01-15 00:30:39.000000', 'temperatura', 1083.0000, 'ºC'),
	(18513, 110, '2015-01-15 00:30:40.000000', 'temperatura', 608.0000, 'ºC'),
	(18514, 110, '2015-01-15 00:30:41.000000', 'temperatura', 991.0000, 'ºC'),
	(18515, 110, '2015-01-15 00:30:42.000000', 'temperatura', 733.0000, 'ºC'),
	(18516, 110, '2015-01-15 00:30:43.000000', 'temperatura', 689.0000, 'ºC'),
	(18517, 110, '2015-01-15 00:30:44.000000', 'temperatura', 49.0000, 'ºC'),
	(18518, 110, '2015-01-15 00:30:45.000000', 'temperatura', 576.0000, 'ºC'),
	(18519, 110, '2015-01-15 00:30:46.000000', 'temperatura', 336.0000, 'ºC'),
	(18520, 110, '2015-01-15 00:30:47.000000', 'temperatura', 1151.0000, 'ºC'),
	(18521, 110, '2015-01-15 00:30:48.000000', 'temperatura', 1148.0000, 'ºC'),
	(18522, 110, '2015-01-15 00:30:49.000000', 'temperatura', 1089.0000, 'ºC'),
	(18523, 110, '2015-01-15 00:30:50.000000', 'temperatura', 802.0000, 'ºC'),
	(18524, 110, '2015-01-15 00:30:51.000000', 'temperatura', 744.0000, 'ºC'),
	(18525, 110, '2015-01-15 00:30:52.000000', 'temperatura', 112.0000, 'ºC'),
	(18526, 110, '2015-01-15 00:30:53.000000', 'temperatura', 729.0000, 'ºC'),
	(18527, 110, '2015-01-15 00:30:54.000000', 'temperatura', 909.0000, 'ºC'),
	(18528, 110, '2015-01-15 00:30:55.000000', 'temperatura', 1159.0000, 'ºC'),
	(18529, 110, '2015-01-15 00:30:56.000000', 'temperatura', 670.0000, 'ºC'),
	(18530, 110, '2015-01-15 00:30:57.000000', 'temperatura', 1072.0000, 'ºC'),
	(18531, 110, '2015-01-15 00:30:58.000000', 'temperatura', 952.0000, 'ºC'),
	(18532, 110, '2015-01-15 00:30:59.000000', 'temperatura', 344.0000, 'ºC'),
	(18533, 110, '2015-01-15 00:31:00.000000', 'temperatura', 62.0000, 'ºC'),
	(18534, 110, '2015-01-15 00:31:01.000000', 'temperatura', 482.0000, 'ºC'),
	(18535, 110, '2015-01-15 00:31:02.000000', 'temperatura', 1023.0000, 'ºC'),
	(18536, 110, '2015-01-15 00:31:03.000000', 'temperatura', 68.0000, 'ºC'),
	(18537, 110, '2015-01-15 00:31:04.000000', 'temperatura', 872.0000, 'ºC'),
	(18538, 110, '2015-01-15 00:31:05.000000', 'temperatura', 558.0000, 'ºC'),
	(18539, 110, '2015-01-15 00:31:06.000000', 'temperatura', 172.0000, 'ºC'),
	(18540, 110, '2015-01-15 00:31:07.000000', 'temperatura', 387.0000, 'ºC'),
	(18541, 110, '2015-01-15 00:31:08.000000', 'temperatura', 220.0000, 'ºC'),
	(18542, 110, '2015-01-15 00:31:09.000000', 'temperatura', 1138.0000, 'ºC'),
	(18543, 110, '2015-01-15 00:31:10.000000', 'temperatura', 232.0000, 'ºC'),
	(18544, 110, '2015-01-15 00:31:11.000000', 'temperatura', 145.0000, 'ºC'),
	(18545, 110, '2015-01-15 00:31:12.000000', 'temperatura', 28.0000, 'ºC'),
	(18546, 110, '2015-01-15 00:31:13.000000', 'temperatura', 908.0000, 'ºC'),
	(18547, 110, '2015-01-15 00:31:14.000000', 'temperatura', 856.0000, 'ºC'),
	(18548, 110, '2015-01-15 00:31:15.000000', 'temperatura', 356.0000, 'ºC'),
	(18549, 110, '2015-01-15 00:31:16.000000', 'temperatura', 411.0000, 'ºC'),
	(18550, 110, '2015-01-15 00:31:17.000000', 'temperatura', 988.0000, 'ºC'),
	(18551, 110, '2015-01-15 00:31:18.000000', 'temperatura', 108.0000, 'ºC'),
	(18552, 110, '2015-01-15 00:31:19.000000', 'temperatura', 1179.0000, 'ºC'),
	(18553, 110, '2015-01-15 00:31:20.000000', 'temperatura', 768.0000, 'ºC'),
	(18554, 110, '2015-01-15 00:31:21.000000', 'temperatura', 304.0000, 'ºC'),
	(18555, 110, '2015-01-15 00:31:22.000000', 'temperatura', 418.0000, 'ºC'),
	(18556, 110, '2015-01-15 00:31:23.000000', 'temperatura', 1178.0000, 'ºC'),
	(18557, 110, '2015-01-15 00:31:24.000000', 'temperatura', 1037.0000, 'ºC'),
	(18558, 110, '2015-01-15 00:31:25.000000', 'temperatura', 452.0000, 'ºC'),
	(18559, 110, '2015-01-15 00:31:26.000000', 'temperatura', 351.0000, 'ºC'),
	(18560, 110, '2015-01-15 00:31:27.000000', 'temperatura', 396.0000, 'ºC'),
	(18561, 110, '2015-01-15 00:31:28.000000', 'temperatura', 928.0000, 'ºC'),
	(18562, 110, '2015-01-15 00:31:29.000000', 'temperatura', 1055.0000, 'ºC'),
	(18563, 110, '2015-01-15 00:31:30.000000', 'temperatura', 88.0000, 'ºC'),
	(18564, 110, '2015-01-15 00:31:31.000000', 'temperatura', 877.0000, 'ºC'),
	(18565, 110, '2015-01-15 00:31:32.000000', 'temperatura', 523.0000, 'ºC'),
	(18566, 110, '2015-01-15 00:31:33.000000', 'temperatura', 1184.0000, 'ºC'),
	(18567, 110, '2015-01-15 00:31:34.000000', 'temperatura', 752.0000, 'ºC'),
	(18568, 110, '2015-01-15 00:31:35.000000', 'temperatura', 210.0000, 'ºC'),
	(18569, 110, '2015-01-15 00:31:36.000000', 'temperatura', 1192.0000, 'ºC'),
	(18570, 110, '2015-01-15 00:31:37.000000', 'temperatura', 531.0000, 'ºC'),
	(18571, 110, '2015-01-15 00:31:38.000000', 'temperatura', 282.0000, 'ºC'),
	(18572, 110, '2015-01-15 00:31:39.000000', 'temperatura', 1014.0000, 'ºC'),
	(18573, 110, '2015-01-15 00:31:40.000000', 'temperatura', 627.0000, 'ºC'),
	(18574, 110, '2015-01-15 00:31:41.000000', 'temperatura', 94.0000, 'ºC'),
	(18575, 110, '2015-01-15 00:31:42.000000', 'temperatura', 987.0000, 'ºC'),
	(18576, 110, '2015-01-15 00:31:43.000000', 'temperatura', 1057.0000, 'ºC'),
	(18577, 110, '2015-01-15 00:31:44.000000', 'temperatura', 1121.0000, 'ºC'),
	(18578, 110, '2015-01-15 00:31:45.000000', 'temperatura', 36.0000, 'ºC'),
	(18579, 110, '2015-01-15 00:31:46.000000', 'temperatura', 417.0000, 'ºC'),
	(18580, 110, '2015-01-15 00:31:47.000000', 'temperatura', 780.0000, 'ºC'),
	(18581, 110, '2015-01-15 00:31:48.000000', 'temperatura', 247.0000, 'ºC'),
	(18582, 110, '2015-01-15 00:31:49.000000', 'temperatura', 98.0000, 'ºC'),
	(18583, 110, '2015-01-15 00:31:50.000000', 'temperatura', 947.0000, 'ºC'),
	(18584, 110, '2015-01-15 00:31:51.000000', 'temperatura', 844.0000, 'ºC'),
	(18585, 110, '2015-01-15 00:31:52.000000', 'temperatura', 176.0000, 'ºC'),
	(18586, 110, '2015-01-15 00:31:53.000000', 'temperatura', 752.0000, 'ºC'),
	(18587, 110, '2015-01-15 00:31:54.000000', 'temperatura', 830.0000, 'ºC'),
	(18588, 110, '2015-01-15 00:31:55.000000', 'temperatura', 696.0000, 'ºC'),
	(18589, 110, '2015-01-15 00:31:56.000000', 'temperatura', 988.0000, 'ºC'),
	(18590, 110, '2015-01-15 00:31:57.000000', 'temperatura', 455.0000, 'ºC'),
	(18591, 110, '2015-01-15 00:31:58.000000', 'temperatura', 509.0000, 'ºC'),
	(18592, 110, '2015-01-15 00:31:59.000000', 'temperatura', 1181.0000, 'ºC'),
	(18593, 110, '2015-01-15 00:32:00.000000', 'temperatura', 778.0000, 'ºC'),
	(18594, 110, '2015-01-15 00:32:01.000000', 'temperatura', 348.0000, 'ºC'),
	(18595, 110, '2015-01-15 00:32:02.000000', 'temperatura', 609.0000, 'ºC'),
	(18596, 110, '2015-01-15 00:32:03.000000', 'temperatura', 799.0000, 'ºC'),
	(18597, 110, '2015-01-15 00:32:04.000000', 'temperatura', 969.0000, 'ºC'),
	(18598, 110, '2015-01-15 00:32:05.000000', 'temperatura', 47.0000, 'ºC'),
	(18599, 110, '2015-01-15 00:32:06.000000', 'temperatura', 929.0000, 'ºC'),
	(18600, 110, '2015-01-15 00:32:07.000000', 'temperatura', 905.0000, 'ºC'),
	(18601, 110, '2015-01-15 00:32:08.000000', 'temperatura', 537.0000, 'ºC'),
	(18602, 110, '2015-01-15 00:32:09.000000', 'temperatura', 1170.0000, 'ºC'),
	(18603, 110, '2015-01-15 00:32:10.000000', 'temperatura', 640.0000, 'ºC'),
	(18604, 110, '2015-01-15 00:32:11.000000', 'temperatura', 891.0000, 'ºC'),
	(18605, 110, '2015-01-15 00:32:12.000000', 'temperatura', 135.0000, 'ºC'),
	(18606, 110, '2015-01-15 00:32:13.000000', 'temperatura', 405.0000, 'ºC'),
	(18607, 110, '2015-01-15 00:32:14.000000', 'temperatura', 418.0000, 'ºC'),
	(18608, 110, '2015-01-15 00:32:15.000000', 'temperatura', 874.0000, 'ºC'),
	(18609, 110, '2015-01-15 00:32:16.000000', 'temperatura', 720.0000, 'ºC'),
	(18610, 110, '2015-01-15 00:32:17.000000', 'temperatura', 975.0000, 'ºC'),
	(18611, 110, '2015-01-15 00:32:18.000000', 'temperatura', 317.0000, 'ºC'),
	(18612, 110, '2015-01-15 00:32:19.000000', 'temperatura', 1062.0000, 'ºC'),
	(18613, 110, '2015-01-15 00:32:20.000000', 'temperatura', 760.0000, 'ºC'),
	(18614, 110, '2015-01-15 00:32:21.000000', 'temperatura', 614.0000, 'ºC'),
	(18615, 110, '2015-01-15 00:32:22.000000', 'temperatura', 788.0000, 'ºC'),
	(18616, 110, '2015-01-15 00:32:23.000000', 'temperatura', 902.0000, 'ºC'),
	(18617, 110, '2015-01-15 00:32:24.000000', 'temperatura', 945.0000, 'ºC'),
	(18618, 110, '2015-01-15 00:32:25.000000', 'temperatura', 818.0000, 'ºC'),
	(18619, 110, '2015-01-15 00:32:26.000000', 'temperatura', 56.0000, 'ºC'),
	(18620, 110, '2015-01-15 00:32:27.000000', 'temperatura', 226.0000, 'ºC'),
	(18621, 110, '2015-01-15 00:32:28.000000', 'temperatura', 963.0000, 'ºC'),
	(18622, 110, '2015-01-15 00:32:29.000000', 'temperatura', 537.0000, 'ºC'),
	(18623, 110, '2015-01-15 00:32:30.000000', 'temperatura', 998.0000, 'ºC'),
	(18624, 110, '2015-01-15 00:32:31.000000', 'temperatura', 978.0000, 'ºC'),
	(18625, 110, '2015-01-15 00:32:32.000000', 'temperatura', 696.0000, 'ºC'),
	(18626, 110, '2015-01-15 00:32:33.000000', 'temperatura', 545.0000, 'ºC'),
	(18627, 110, '2015-01-15 00:32:34.000000', 'temperatura', 641.0000, 'ºC'),
	(18628, 110, '2015-01-15 00:32:35.000000', 'temperatura', 368.0000, 'ºC'),
	(18629, 110, '2015-01-15 00:32:36.000000', 'temperatura', 1119.0000, 'ºC'),
	(18630, 110, '2015-01-15 00:32:37.000000', 'temperatura', 892.0000, 'ºC'),
	(18631, 110, '2015-01-15 00:32:38.000000', 'temperatura', 1103.0000, 'ºC'),
	(18632, 110, '2015-01-15 00:32:39.000000', 'temperatura', 440.0000, 'ºC'),
	(18633, 110, '2015-01-15 00:32:40.000000', 'temperatura', 89.0000, 'ºC'),
	(18634, 110, '2015-01-15 00:32:41.000000', 'temperatura', 328.0000, 'ºC'),
	(18635, 110, '2015-01-15 00:32:42.000000', 'temperatura', 171.0000, 'ºC'),
	(18636, 110, '2015-01-15 00:32:43.000000', 'temperatura', 1073.0000, 'ºC'),
	(18637, 110, '2015-01-15 00:32:44.000000', 'temperatura', 50.0000, 'ºC'),
	(18638, 110, '2015-01-15 00:32:45.000000', 'temperatura', 634.0000, 'ºC'),
	(18639, 110, '2015-01-15 00:32:46.000000', 'temperatura', 620.0000, 'ºC'),
	(18640, 110, '2015-01-15 00:32:47.000000', 'temperatura', 1199.0000, 'ºC'),
	(18641, 110, '2015-01-15 00:32:48.000000', 'temperatura', 535.0000, 'ºC'),
	(18642, 110, '2015-01-15 00:32:49.000000', 'temperatura', 279.0000, 'ºC'),
	(18643, 110, '2015-01-15 00:32:50.000000', 'temperatura', 988.0000, 'ºC'),
	(18644, 110, '2015-01-15 00:32:51.000000', 'temperatura', 506.0000, 'ºC'),
	(18645, 110, '2015-01-15 00:32:52.000000', 'temperatura', 768.0000, 'ºC'),
	(18646, 110, '2015-01-15 00:32:53.000000', 'temperatura', 1119.0000, 'ºC'),
	(18647, 110, '2015-01-15 00:32:54.000000', 'temperatura', 893.0000, 'ºC'),
	(18648, 110, '2015-01-15 00:32:55.000000', 'temperatura', 1108.0000, 'ºC'),
	(18649, 110, '2015-01-15 00:32:56.000000', 'temperatura', 460.0000, 'ºC'),
	(18650, 110, '2015-01-15 00:32:57.000000', 'temperatura', 178.0000, 'ºC'),
	(18651, 110, '2015-01-15 00:32:58.000000', 'temperatura', 711.0000, 'ºC'),
	(18652, 110, '2015-01-15 00:32:59.000000', 'temperatura', 619.0000, 'ºC'),
	(18653, 110, '2015-01-15 00:33:00.000000', 'temperatura', 966.0000, 'ºC'),
	(18654, 110, '2015-01-15 00:33:01.000000', 'temperatura', 571.0000, 'ºC'),
	(18655, 110, '2015-01-15 00:33:02.000000', 'temperatura', 1159.0000, 'ºC'),
	(18656, 110, '2015-01-15 00:33:03.000000', 'temperatura', 484.0000, 'ºC'),
	(18657, 110, '2015-01-15 00:33:04.000000', 'temperatura', 140.0000, 'ºC'),
	(18658, 110, '2015-01-15 00:33:05.000000', 'temperatura', 451.0000, 'ºC'),
	(18659, 110, '2015-01-15 00:33:06.000000', 'temperatura', 634.0000, 'ºC'),
	(18660, 110, '2015-01-15 00:33:07.000000', 'temperatura', 620.0000, 'ºC'),
	(18661, 110, '2015-01-15 00:33:08.000000', 'temperatura', 1197.0000, 'ºC'),
	(18662, 110, '2015-01-15 00:33:09.000000', 'temperatura', 525.0000, 'ºC'),
	(18663, 110, '2015-01-15 00:33:10.000000', 'temperatura', 234.0000, 'ºC'),
	(18664, 110, '2015-01-15 00:33:11.000000', 'temperatura', 797.0000, 'ºC'),
	(18665, 110, '2015-01-15 00:33:12.000000', 'temperatura', 884.0000, 'ºC'),
	(18666, 110, '2015-01-15 00:33:13.000000', 'temperatura', 831.0000, 'ºC'),
	(18667, 110, '2015-01-15 00:33:14.000000', 'temperatura', 301.0000, 'ºC'),
	(18668, 110, '2015-01-15 00:33:15.000000', 'temperatura', 211.0000, 'ºC'),
	(18669, 110, '2015-01-15 00:33:16.000000', 'temperatura', 156.0000, 'ºC'),
	(18670, 110, '2015-01-15 00:33:17.000000', 'temperatura', 146.0000, 'ºC'),
	(18671, 110, '2015-01-15 00:33:18.000000', 'temperatura', 260.0000, 'ºC'),
	(18672, 110, '2015-01-15 00:33:19.000000', 'temperatura', 866.0000, 'ºC'),
	(18673, 110, '2015-01-15 00:33:20.000000', 'temperatura', 1150.0000, 'ºC'),
	(18674, 110, '2015-01-15 00:33:21.000000', 'temperatura', 751.0000, 'ºC'),
	(18675, 110, '2015-01-15 00:33:22.000000', 'temperatura', 308.0000, 'ºC'),
	(18676, 110, '2015-01-15 00:33:23.000000', 'temperatura', 485.0000, 'ºC'),
	(18677, 110, '2015-01-15 00:33:24.000000', 'temperatura', 303.0000, 'ºC'),
	(18678, 110, '2015-01-15 00:33:25.000000', 'temperatura', 61.0000, 'ºC'),
	(18679, 110, '2015-01-15 00:33:26.000000', 'temperatura', 596.0000, 'ºC'),
	(18680, 110, '2015-01-15 00:33:27.000000', 'temperatura', 396.0000, 'ºC'),
	(18681, 110, '2015-01-15 00:33:28.000000', 'temperatura', 195.0000, 'ºC'),
	(18682, 110, '2015-01-15 00:33:29.000000', 'temperatura', 987.0000, 'ºC'),
	(18683, 110, '2015-01-15 00:33:30.000000', 'temperatura', 749.0000, 'ºC'),
	(18684, 110, '2015-01-15 00:33:31.000000', 'temperatura', 787.0000, 'ºC'),
	(18685, 110, '2015-01-15 00:33:32.000000', 'temperatura', 487.0000, 'ºC'),
	(18686, 110, '2015-01-15 00:33:33.000000', 'temperatura', 76.0000, 'ºC'),
	(18687, 110, '2015-01-15 00:33:34.000000', 'temperatura', 118.0000, 'ºC'),
	(18688, 110, '2015-01-15 00:33:35.000000', 'temperatura', 363.0000, 'ºC'),
	(18689, 110, '2015-01-15 00:33:36.000000', 'temperatura', 260.0000, 'ºC'),
	(18690, 110, '2015-01-15 00:33:37.000000', 'temperatura', 211.0000, 'ºC'),
	(18691, 110, '2015-01-15 00:33:38.000000', 'temperatura', 275.0000, 'ºC'),
	(18692, 110, '2015-01-15 00:33:39.000000', 'temperatura', 745.0000, 'ºC'),
	(18693, 110, '2015-01-15 00:33:40.000000', 'temperatura', 499.0000, 'ºC'),
	(18694, 110, '2015-01-15 00:33:41.000000', 'temperatura', 260.0000, 'ºC'),
	(18695, 110, '2015-01-15 00:33:42.000000', 'temperatura', 1005.0000, 'ºC'),
	(18696, 110, '2015-01-15 00:33:43.000000', 'temperatura', 643.0000, 'ºC'),
	(18697, 110, '2015-01-15 00:33:44.000000', 'temperatura', 204.0000, 'ºC'),
	(18698, 110, '2015-01-15 00:33:45.000000', 'temperatura', 288.0000, 'ºC'),
	(18699, 110, '2015-01-15 00:33:46.000000', 'temperatura', 830.0000, 'ºC'),
	(18700, 110, '2015-01-15 00:33:47.000000', 'temperatura', 885.0000, 'ºC'),
	(18701, 110, '2015-01-15 00:33:48.000000', 'temperatura', 738.0000, 'ºC'),
	(18702, 110, '2015-01-15 00:33:49.000000', 'temperatura', 1036.0000, 'ºC'),
	(18703, 110, '2015-01-15 00:33:50.000000', 'temperatura', 566.0000, 'ºC'),
	(18704, 110, '2015-01-15 00:33:51.000000', 'temperatura', 923.0000, 'ºC'),
	(18705, 110, '2015-01-15 00:33:52.000000', 'temperatura', 518.0000, 'ºC'),
	(18706, 110, '2015-01-15 00:33:53.000000', 'temperatura', 1020.0000, 'ºC'),
	(18707, 110, '2015-01-15 00:33:54.000000', 'temperatura', 1145.0000, 'ºC'),
	(18708, 110, '2015-01-15 00:33:55.000000', 'temperatura', 268.0000, 'ºC'),
	(18709, 110, '2015-01-15 00:33:56.000000', 'temperatura', 304.0000, 'ºC'),
	(18710, 110, '2015-01-15 00:33:57.000000', 'temperatura', 718.0000, 'ºC'),
	(18711, 110, '2015-01-15 00:33:58.000000', 'temperatura', 277.0000, 'ºC'),
	(18712, 110, '2015-01-15 00:33:59.000000', 'temperatura', 434.0000, 'ºC'),
	(18713, 110, '2015-01-15 00:34:00.000000', 'temperatura', 137.0000, 'ºC'),
	(18714, 110, '2015-01-15 00:34:01.000000', 'temperatura', 583.0000, 'ºC'),
	(18715, 110, '2015-01-15 00:34:02.000000', 'temperatura', 104.0000, 'ºC'),
	(18716, 110, '2015-01-15 00:34:03.000000', 'temperatura', 1174.0000, 'ºC'),
	(18717, 110, '2015-01-15 00:34:04.000000', 'temperatura', 757.0000, 'ºC'),
	(18718, 110, '2015-01-15 00:34:05.000000', 'temperatura', 264.0000, 'ºC'),
	(18719, 110, '2015-01-15 00:34:06.000000', 'temperatura', 247.0000, 'ºC'),
	(18720, 110, '2015-01-15 00:34:07.000000', 'temperatura', 446.0000, 'ºC'),
	(18721, 110, '2015-01-15 00:34:08.000000', 'temperatura', 289.0000, 'ºC'),
	(18722, 110, '2015-01-15 00:34:09.000000', 'temperatura', 109.0000, 'ºC'),
	(18723, 110, '2015-01-15 00:34:10.000000', 'temperatura', 876.0000, 'ºC'),
	(18724, 110, '2015-01-15 00:34:11.000000', 'temperatura', 456.0000, 'ºC'),
	(18725, 110, '2015-01-15 00:34:12.000000', 'temperatura', 852.0000, 'ºC'),
	(18726, 110, '2015-01-15 00:34:13.000000', 'temperatura', 491.0000, 'ºC'),
	(18727, 110, '2015-01-15 00:34:14.000000', 'temperatura', 1100.0000, 'ºC'),
	(18728, 110, '2015-01-15 00:34:15.000000', 'temperatura', 427.0000, 'ºC'),
	(18729, 110, '2015-01-15 00:34:16.000000', 'temperatura', 35.0000, 'ºC'),
	(18730, 110, '2015-01-15 00:34:17.000000', 'temperatura', 94.0000, 'ºC'),
	(18731, 110, '2015-01-15 00:34:18.000000', 'temperatura', 366.0000, 'ºC'),
	(18732, 110, '2015-01-15 00:34:19.000000', 'temperatura', 351.0000, 'ºC'),
	(18733, 110, '2015-01-15 00:34:20.000000', 'temperatura', 655.0000, 'ºC'),
	(18734, 110, '2015-01-15 00:34:21.000000', 'temperatura', 1021.0000, 'ºC'),
	(18735, 110, '2015-01-15 00:34:22.000000', 'temperatura', 744.0000, 'ºC'),
	(18736, 110, '2015-01-15 00:34:23.000000', 'temperatura', 654.0000, 'ºC'),
	(18737, 110, '2015-01-15 00:34:24.000000', 'temperatura', 1041.0000, 'ºC'),
	(18738, 110, '2015-01-15 00:34:25.000000', 'temperatura', 841.0000, 'ºC'),
	(18739, 110, '2015-01-15 00:34:26.000000', 'temperatura', 1084.0000, 'ºC'),
	(18740, 110, '2015-01-15 00:34:27.000000', 'temperatura', 496.0000, 'ºC'),
	(18741, 110, '2015-01-15 00:34:28.000000', 'temperatura', 430.0000, 'ºC'),
	(18742, 110, '2015-01-15 00:34:29.000000', 'temperatura', 661.0000, 'ºC'),
	(18743, 110, '2015-01-15 00:34:30.000000', 'temperatura', 814.0000, 'ºC'),
	(18744, 110, '2015-01-15 00:34:31.000000', 'temperatura', 890.0000, 'ºC'),
	(18745, 110, '2015-01-15 00:34:32.000000', 'temperatura', 810.0000, 'ºC'),
	(18746, 110, '2015-01-15 00:34:33.000000', 'temperatura', 178.0000, 'ºC'),
	(18747, 110, '2015-01-15 00:34:34.000000', 'temperatura', 863.0000, 'ºC'),
	(18748, 110, '2015-01-15 00:34:35.000000', 'temperatura', 179.0000, 'ºC'),
	(18749, 110, '2015-01-15 00:34:36.000000', 'temperatura', 709.0000, 'ºC'),
	(18750, 110, '2015-01-15 00:34:37.000000', 'temperatura', 608.0000, 'ºC'),
	(18751, 110, '2015-01-15 00:34:38.000000', 'temperatura', 914.0000, 'ºC'),
	(18752, 110, '2015-01-15 00:34:39.000000', 'temperatura', 344.0000, 'ºC'),
	(18753, 110, '2015-01-15 00:34:40.000000', 'temperatura', 180.0000, 'ºC'),
	(18754, 110, '2015-01-15 00:34:41.000000', 'temperatura', 1067.0000, 'ºC'),
	(18755, 110, '2015-01-15 00:34:42.000000', 'temperatura', 1196.0000, 'ºC'),
	(18756, 110, '2015-01-15 00:34:43.000000', 'temperatura', 382.0000, 'ºC'),
	(18757, 110, '2015-01-15 00:34:44.000000', 'temperatura', 720.0000, 'ºC'),
	(18758, 110, '2015-01-15 00:34:45.000000', 'temperatura', 55.0000, 'ºC'),
	(18759, 110, '2015-01-15 00:34:46.000000', 'temperatura', 514.0000, 'ºC'),
	(18760, 110, '2015-01-15 00:34:47.000000', 'temperatura', 5.0000, 'ºC'),
	(18761, 110, '2015-01-15 00:34:48.000000', 'temperatura', 887.0000, 'ºC'),
	(18762, 110, '2015-01-15 00:34:49.000000', 'temperatura', 818.0000, 'ºC'),
	(18763, 110, '2015-01-15 00:34:50.000000', 'temperatura', 229.0000, 'ºC'),
	(18764, 110, '2015-01-15 00:34:51.000000', 'temperatura', 1093.0000, 'ºC'),
	(18765, 110, '2015-01-15 00:34:52.000000', 'temperatura', 1180.0000, 'ºC'),
	(18766, 110, '2015-01-15 00:34:53.000000', 'temperatura', 219.0000, 'ºC'),
	(18767, 110, '2015-01-15 00:34:54.000000', 'temperatura', 1157.0000, 'ºC'),
	(18768, 110, '2015-01-15 00:34:55.000000', 'temperatura', 326.0000, 'ºC'),
	(18769, 110, '2015-01-15 00:34:56.000000', 'temperatura', 563.0000, 'ºC'),
	(18770, 110, '2015-01-15 00:34:57.000000', 'temperatura', 634.0000, 'ºC'),
	(18771, 110, '2015-01-15 00:34:58.000000', 'temperatura', 285.0000, 'ºC'),
	(18772, 110, '2015-01-15 00:34:59.000000', 'temperatura', 721.0000, 'ºC'),
	(18773, 110, '2015-01-15 00:35:00.000000', 'temperatura', 350.0000, 'ºC'),
	(18774, 110, '2015-01-15 00:35:01.000000', 'temperatura', 787.0000, 'ºC'),
	(18775, 110, '2015-01-15 00:35:02.000000', 'temperatura', 487.0000, 'ºC'),
	(18776, 110, '2015-01-15 00:35:03.000000', 'temperatura', 76.0000, 'ºC'),
	(18777, 110, '2015-01-15 00:35:04.000000', 'temperatura', 119.0000, 'ºC'),
	(18778, 110, '2015-01-15 00:35:05.000000', 'temperatura', 366.0000, 'ºC'),
	(18779, 110, '2015-01-15 00:35:06.000000', 'temperatura', 274.0000, 'ºC'),
	(18780, 110, '2015-01-15 00:35:07.000000', 'temperatura', 272.0000, 'ºC'),
	(18781, 110, '2015-01-15 00:35:08.000000', 'temperatura', 537.0000, 'ºC'),
	(18782, 110, '2015-01-15 00:35:09.000000', 'temperatura', 671.0000, 'ºC'),
	(18783, 110, '2015-01-15 00:35:10.000000', 'temperatura', 544.0000, 'ºC'),
	(18784, 110, '2015-01-15 00:35:11.000000', 'temperatura', 708.0000, 'ºC'),
	(18785, 110, '2015-01-15 00:35:12.000000', 'temperatura', 709.0000, 'ºC'),
	(18786, 110, '2015-01-15 00:35:13.000000', 'temperatura', 223.0000, 'ºC'),
	(18787, 110, '2015-01-15 00:35:14.000000', 'temperatura', 187.0000, 'ºC'),
	(18788, 110, '2015-01-15 00:35:15.000000', 'temperatura', 265.0000, 'ºC'),
	(18789, 110, '2015-01-15 00:35:16.000000', 'temperatura', 767.0000, 'ºC'),
	(18790, 110, '2015-01-15 00:35:17.000000', 'temperatura', 638.0000, 'ºC'),
	(18791, 110, '2015-01-15 00:35:18.000000', 'temperatura', 892.0000, 'ºC'),
	(18792, 110, '2015-01-15 00:35:19.000000', 'temperatura', 147.0000, 'ºC'),
	(18793, 110, '2015-01-15 00:35:20.000000', 'temperatura', 457.0000, 'ºC'),
	(18794, 110, '2015-01-15 00:35:21.000000', 'temperatura', 645.0000, 'ºC'),
	(18795, 110, '2015-01-15 00:35:22.000000', 'temperatura', 654.0000, 'ºC'),
	(18796, 110, '2015-01-15 00:35:23.000000', 'temperatura', 137.0000, 'ºC'),
	(18797, 110, '2015-01-15 00:35:24.000000', 'temperatura', 1122.0000, 'ºC'),
	(18798, 110, '2015-01-15 00:35:25.000000', 'temperatura', 400.0000, 'ºC'),
	(18799, 110, '2015-01-15 00:35:26.000000', 'temperatura', 1036.0000, 'ºC'),
	(18800, 110, '2015-01-15 00:35:27.000000', 'temperatura', 381.0000, 'ºC'),
	(18801, 110, '2015-01-15 00:35:28.000000', 'temperatura', 1198.0000, 'ºC'),
	(18802, 110, '2015-01-15 00:35:29.000000', 'temperatura', 48.0000, 'ºC'),
	(18803, 110, '2015-01-15 00:35:30.000000', 'temperatura', 244.0000, 'ºC'),
	(18804, 110, '2015-01-15 00:35:31.000000', 'temperatura', 1078.0000, 'ºC'),
	(18805, 110, '2015-01-15 00:35:32.000000', 'temperatura', 1059.0000, 'ºC'),
	(18806, 110, '2015-01-15 00:35:33.000000', 'temperatura', 863.0000, 'ºC'),
	(18807, 110, '2015-01-15 00:35:34.000000', 'temperatura', 1136.0000, 'ºC'),
	(18808, 110, '2015-01-15 00:35:35.000000', 'temperatura', 693.0000, 'ºC'),
	(18809, 110, '2015-01-15 00:35:36.000000', 'temperatura', 58.0000, 'ºC'),
	(18810, 110, '2015-01-15 00:35:37.000000', 'temperatura', 612.0000, 'ºC'),
	(18811, 110, '2015-01-15 00:35:38.000000', 'temperatura', 487.0000, 'ºC'),
	(18812, 110, '2015-01-15 00:35:39.000000', 'temperatura', 600.0000, 'ºC'),
	(18813, 110, '2015-01-15 00:35:40.000000', 'temperatura', 339.0000, 'ºC'),
	(18814, 110, '2015-01-15 00:35:41.000000', 'temperatura', 1097.0000, 'ºC'),
	(18815, 110, '2015-01-15 00:35:42.000000', 'temperatura', 867.0000, 'ºC'),
	(18816, 110, '2015-01-15 00:35:43.000000', 'temperatura', 1046.0000, 'ºC'),
	(18817, 110, '2015-01-15 00:35:44.000000', 'temperatura', 226.0000, 'ºC'),
	(18818, 110, '2015-01-15 00:35:45.000000', 'temperatura', 396.0000, 'ºC'),
	(18819, 110, '2015-01-15 00:35:46.000000', 'temperatura', 103.0000, 'ºC'),
	(18820, 110, '2015-01-15 00:35:47.000000', 'temperatura', 525.0000, 'ºC'),
	(18821, 110, '2015-01-15 00:35:48.000000', 'temperatura', 1118.0000, 'ºC'),
	(18822, 110, '2015-01-15 00:35:49.000000', 'temperatura', 413.0000, 'ºC'),
	(18823, 110, '2015-01-15 00:35:50.000000', 'temperatura', 1113.0000, 'ºC'),
	(18824, 110, '2015-01-15 00:35:51.000000', 'temperatura', 728.0000, 'ºC'),
	(18825, 110, '2015-01-15 00:35:52.000000', 'temperatura', 302.0000, 'ºC'),
	(18826, 110, '2015-01-15 00:35:53.000000', 'temperatura', 526.0000, 'ºC'),
	(18827, 110, '2015-01-15 00:35:54.000000', 'temperatura', 524.0000, 'ºC'),
	(18828, 110, '2015-01-15 00:35:55.000000', 'temperatura', 1041.0000, 'ºC'),
	(18829, 110, '2015-01-15 00:35:56.000000', 'temperatura', 34.0000, 'ºC'),
	(18830, 110, '2015-01-15 00:35:57.000000', 'temperatura', 647.0000, 'ºC'),
	(18831, 110, '2015-01-15 00:35:58.000000', 'temperatura', 734.0000, 'ºC'),
	(18832, 110, '2015-01-15 00:35:59.000000', 'temperatura', 530.0000, 'ºC'),
	(18833, 110, '2015-01-15 00:36:00.000000', 'temperatura', 446.0000, 'ºC'),
	(18834, 110, '2015-01-15 00:36:01.000000', 'temperatura', 643.0000, 'ºC'),
	(18835, 110, '2015-01-15 00:36:02.000000', 'temperatura', 678.0000, 'ºC'),
	(18836, 110, '2015-01-15 00:36:03.000000', 'temperatura', 262.0000, 'ºC'),
	(18837, 110, '2015-01-15 00:36:04.000000', 'temperatura', 474.0000, 'ºC'),
	(18838, 110, '2015-01-15 00:36:05.000000', 'temperatura', 387.0000, 'ºC'),
	(18839, 110, '2015-01-15 00:36:06.000000', 'temperatura', 512.0000, 'ºC'),
	(18840, 110, '2015-01-15 00:36:07.000000', 'temperatura', 200.0000, 'ºC'),
	(18841, 110, '2015-01-15 00:36:08.000000', 'temperatura', 666.0000, 'ºC'),
	(18842, 110, '2015-01-15 00:36:09.000000', 'temperatura', 329.0000, 'ºC'),
	(18843, 110, '2015-01-15 00:36:10.000000', 'temperatura', 847.0000, 'ºC'),
	(18844, 110, '2015-01-15 00:36:11.000000', 'temperatura', 847.0000, 'ºC'),
	(18845, 110, '2015-01-15 00:36:12.000000', 'temperatura', 496.0000, 'ºC'),
	(18846, 110, '2015-01-15 00:36:13.000000', 'temperatura', 1141.0000, 'ºC'),
	(18847, 110, '2015-01-15 00:36:14.000000', 'temperatura', 617.0000, 'ºC'),
	(18848, 110, '2015-01-15 00:36:15.000000', 'temperatura', 862.0000, 'ºC'),
	(18849, 110, '2015-01-15 00:36:16.000000', 'temperatura', 60.0000, 'ºC'),
	(18850, 110, '2015-01-15 00:36:17.000000', 'temperatura', 116.0000, 'ºC'),
	(18851, 110, '2015-01-15 00:36:18.000000', 'temperatura', 398.0000, 'ºC'),
	(18852, 110, '2015-01-15 00:36:19.000000', 'temperatura', 445.0000, 'ºC'),
	(18853, 110, '2015-01-15 00:36:20.000000', 'temperatura', 1028.0000, 'ºC'),
	(18854, 110, '2015-01-15 00:36:21.000000', 'temperatura', 208.0000, 'ºC'),
	(18855, 110, '2015-01-15 00:36:22.000000', 'temperatura', 357.0000, 'ºC'),
	(18856, 110, '2015-01-15 00:36:23.000000', 'temperatura', 1159.0000, 'ºC'),
	(18857, 110, '2015-01-15 00:36:24.000000', 'temperatura', 1127.0000, 'ºC'),
	(18858, 110, '2015-01-15 00:36:25.000000', 'temperatura', 958.0000, 'ºC'),
	(18859, 110, '2015-01-15 00:36:26.000000', 'temperatura', 208.0000, 'ºC'),
	(18860, 110, '2015-01-15 00:36:27.000000', 'temperatura', 565.0000, 'ºC'),
	(18861, 110, '2015-01-15 00:36:28.000000', 'temperatura', 1005.0000, 'ºC'),
	(18862, 110, '2015-01-15 00:36:29.000000', 'temperatura', 928.0000, 'ºC'),
	(18863, 110, '2015-01-15 00:36:30.000000', 'temperatura', 428.0000, 'ºC'),
	(18864, 110, '2015-01-15 00:36:31.000000', 'temperatura', 556.0000, 'ºC'),
	(18865, 110, '2015-01-15 00:36:32.000000', 'temperatura', 298.0000, 'ºC'),
	(18866, 110, '2015-01-15 00:36:33.000000', 'temperatura', 1019.0000, 'ºC'),
	(18867, 110, '2015-01-15 00:36:34.000000', 'temperatura', 605.0000, 'ºC'),
	(18868, 110, '2015-01-15 00:36:35.000000', 'temperatura', 1165.0000, 'ºC'),
	(18869, 110, '2015-01-15 00:36:36.000000', 'temperatura', 412.0000, 'ºC'),
	(18870, 110, '2015-01-15 00:36:37.000000', 'temperatura', 968.0000, 'ºC'),
	(18871, 110, '2015-01-15 00:36:38.000000', 'temperatura', 1.0000, 'ºC'),
	(18872, 110, '2015-01-15 00:36:39.000000', 'temperatura', 703.0000, 'ºC'),
	(18873, 110, '2015-01-15 00:36:40.000000', 'temperatura', 1111.0000, 'ºC'),
	(18874, 110, '2015-01-15 00:36:41.000000', 'temperatura', 1046.0000, 'ºC'),
	(18875, 110, '2015-01-15 00:36:42.000000', 'temperatura', 699.0000, 'ºC'),
	(18876, 110, '2015-01-15 00:36:43.000000', 'temperatura', 355.0000, 'ºC'),
	(18877, 110, '2015-01-15 00:36:44.000000', 'temperatura', 881.0000, 'ºC'),
	(18878, 110, '2015-01-15 00:36:45.000000', 'temperatura', 940.0000, 'ºC'),
	(18879, 110, '2015-01-15 00:36:46.000000', 'temperatura', 859.0000, 'ºC'),
	(18880, 110, '2015-01-15 00:36:47.000000', 'temperatura', 276.0000, 'ºC'),
	(18881, 110, '2015-01-15 00:36:48.000000', 'temperatura', 3.0000, 'ºC'),
	(18882, 110, '2015-01-15 00:36:49.000000', 'temperatura', 388.0000, 'ºC'),
	(18883, 110, '2015-01-15 00:36:50.000000', 'temperatura', 731.0000, 'ºC'),
	(18884, 110, '2015-01-15 00:36:51.000000', 'temperatura', 91.0000, 'ºC'),
	(18885, 110, '2015-01-15 00:36:52.000000', 'temperatura', 665.0000, 'ºC'),
	(18886, 110, '2015-01-15 00:36:53.000000', 'temperatura', 650.0000, 'ºC'),
	(18887, 110, '2015-01-15 00:36:54.000000', 'temperatura', 57.0000, 'ºC'),
	(18888, 110, '2015-01-15 00:36:55.000000', 'temperatura', 733.0000, 'ºC'),
	(18889, 110, '2015-01-15 00:36:56.000000', 'temperatura', 1097.0000, 'ºC'),
	(18890, 110, '2015-01-15 00:36:57.000000', 'temperatura', 887.0000, 'ºC'),
	(18891, 110, '2015-01-15 00:36:58.000000', 'temperatura', 1144.0000, 'ºC'),
	(18892, 110, '2015-01-15 00:36:59.000000', 'temperatura', 661.0000, 'ºC'),
	(18893, 110, '2015-01-15 00:37:00.000000', 'temperatura', 1073.0000, 'ºC'),
	(18894, 110, '2015-01-15 00:37:01.000000', 'temperatura', 983.0000, 'ºC'),
	(18895, 110, '2015-01-15 00:37:02.000000', 'temperatura', 495.0000, 'ºC'),
	(18896, 110, '2015-01-15 00:37:03.000000', 'temperatura', 729.0000, 'ºC'),
	(18897, 110, '2015-01-15 00:37:04.000000', 'temperatura', 960.0000, 'ºC'),
	(18898, 110, '2015-01-15 00:37:05.000000', 'temperatura', 212.0000, 'ºC'),
	(18899, 110, '2015-01-15 00:37:06.000000', 'temperatura', 583.0000, 'ºC'),
	(18900, 110, '2015-01-15 00:37:07.000000', 'temperatura', 1078.0000, 'ºC'),
	(18901, 110, '2015-01-15 00:37:08.000000', 'temperatura', 43.0000, 'ºC'),
	(18902, 110, '2015-01-15 00:37:09.000000', 'temperatura', 579.0000, 'ºC'),
	(18903, 110, '2015-01-15 00:37:10.000000', 'temperatura', 368.0000, 'ºC'),
	(18904, 110, '2015-01-15 00:37:11.000000', 'temperatura', 102.0000, 'ºC'),
	(18905, 110, '2015-01-15 00:37:12.000000', 'temperatura', 609.0000, 'ºC'),
	(18906, 110, '2015-01-15 00:37:13.000000', 'temperatura', 338.0000, 'ºC'),
	(18907, 110, '2015-01-15 00:37:14.000000', 'temperatura', 1064.0000, 'ºC'),
	(18908, 110, '2015-01-15 00:37:15.000000', 'temperatura', 705.0000, 'ºC'),
	(18909, 110, '2015-01-15 00:37:16.000000', 'temperatura', 333.0000, 'ºC'),
	(18910, 110, '2015-01-15 00:37:17.000000', 'temperatura', 753.0000, 'ºC'),
	(18911, 110, '2015-01-15 00:37:18.000000', 'temperatura', 365.0000, 'ºC'),
	(18912, 110, '2015-01-15 00:37:19.000000', 'temperatura', 765.0000, 'ºC'),
	(18913, 110, '2015-01-15 00:37:20.000000', 'temperatura', 334.0000, 'ºC'),
	(18914, 110, '2015-01-15 00:37:21.000000', 'temperatura', 572.0000, 'ºC'),
	(18915, 110, '2015-01-15 00:37:22.000000', 'temperatura', 659.0000, 'ºC'),
	(18916, 110, '2015-01-15 00:37:23.000000', 'temperatura', 381.0000, 'ºC'),
	(18917, 110, '2015-01-15 00:37:24.000000', 'temperatura', 1129.0000, 'ºC'),
	(18918, 110, '2015-01-15 00:37:25.000000', 'temperatura', 900.0000, 'ºC'),
	(18919, 110, '2015-01-15 00:37:26.000000', 'temperatura', 1115.0000, 'ºC'),
	(18920, 110, '2015-01-15 00:37:27.000000', 'temperatura', 473.0000, 'ºC'),
	(18921, 110, '2015-01-15 00:37:28.000000', 'temperatura', 223.0000, 'ºC'),
	(18922, 110, '2015-01-15 00:37:29.000000', 'temperatura', 897.0000, 'ºC'),
	(18923, 110, '2015-01-15 00:37:30.000000', 'temperatura', 216.0000, 'ºC'),
	(18924, 110, '2015-01-15 00:37:31.000000', 'temperatura', 788.0000, 'ºC'),
	(18925, 110, '2015-01-15 00:37:32.000000', 'temperatura', 895.0000, 'ºC'),
	(18926, 110, '2015-01-15 00:37:33.000000', 'temperatura', 911.0000, 'ºC'),
	(18927, 110, '2015-01-15 00:37:34.000000', 'temperatura', 672.0000, 'ºC'),
	(18928, 110, '2015-01-15 00:37:35.000000', 'temperatura', 627.0000, 'ºC'),
	(18929, 110, '2015-01-15 00:37:36.000000', 'temperatura', 1119.0000, 'ºC'),
	(18930, 110, '2015-01-15 00:37:37.000000', 'temperatura', 115.0000, 'ºC'),
	(18931, 110, '2015-01-15 00:37:38.000000', 'temperatura', 818.0000, 'ºC'),
	(18932, 110, '2015-01-15 00:37:39.000000', 'temperatura', 147.0000, 'ºC'),
	(18933, 110, '2015-01-15 00:37:40.000000', 'temperatura', 680.0000, 'ºC'),
	(18934, 110, '2015-01-15 00:37:41.000000', 'temperatura', 559.0000, 'ºC'),
	(18935, 110, '2015-01-15 00:37:42.000000', 'temperatura', 758.0000, 'ºC'),
	(18936, 110, '2015-01-15 00:37:43.000000', 'temperatura', 912.0000, 'ºC'),
	(18937, 110, '2015-01-15 00:37:44.000000', 'temperatura', 1087.0000, 'ºC'),
	(18938, 110, '2015-01-15 00:37:45.000000', 'temperatura', 297.0000, 'ºC'),
	(18939, 110, '2015-01-15 00:37:46.000000', 'temperatura', 627.0000, 'ºC'),
	(18940, 110, '2015-01-15 00:37:47.000000', 'temperatura', 1044.0000, 'ºC'),
	(18941, 110, '2015-01-15 00:37:48.000000', 'temperatura', 938.0000, 'ºC'),
	(18942, 110, '2015-01-15 00:37:49.000000', 'temperatura', 359.0000, 'ºC'),
	(18943, 110, '2015-01-15 00:37:50.000000', 'temperatura', 183.0000, 'ºC'),
	(18944, 110, '2015-01-15 00:37:51.000000', 'temperatura', 1038.0000, 'ºC'),
	(18945, 110, '2015-01-15 00:37:52.000000', 'temperatura', 1043.0000, 'ºC'),
	(18946, 110, '2015-01-15 00:37:53.000000', 'temperatura', 899.0000, 'ºC'),
	(18947, 110, '2015-01-15 00:37:54.000000', 'temperatura', 165.0000, 'ºC'),
	(18948, 110, '2015-01-15 00:37:55.000000', 'temperatura', 532.0000, 'ºC'),
	(18949, 110, '2015-01-15 00:37:56.000000', 'temperatura', 964.0000, 'ºC'),
	(18950, 110, '2015-01-15 00:37:57.000000', 'temperatura', 826.0000, 'ºC'),
	(18951, 110, '2015-01-15 00:37:58.000000', 'temperatura', 36.0000, 'ºC'),
	(18952, 110, '2015-01-15 00:37:59.000000', 'temperatura', 102.0000, 'ºC'),
	(18953, 110, '2015-01-15 00:38:00.000000', 'temperatura', 402.0000, 'ºC'),
	(18954, 110, '2015-01-15 00:38:01.000000', 'temperatura', 505.0000, 'ºC'),
	(18955, 110, '2015-01-15 00:38:02.000000', 'temperatura', 119.0000, 'ºC'),
	(18956, 110, '2015-01-15 00:38:03.000000', 'temperatura', 283.0000, 'ºC'),
	(18957, 110, '2015-01-15 00:38:04.000000', 'temperatura', 1058.0000, 'ºC'),
	(18958, 110, '2015-01-15 00:38:05.000000', 'temperatura', 841.0000, 'ºC'),
	(18959, 110, '2015-01-15 00:38:06.000000', 'temperatura', 1033.0000, 'ºC'),
	(18960, 110, '2015-01-15 00:38:07.000000', 'temperatura', 241.0000, 'ºC'),
	(18961, 110, '2015-01-15 00:38:08.000000', 'temperatura', 508.0000, 'ºC'),
	(18962, 110, '2015-01-15 00:38:09.000000', 'temperatura', 618.0000, 'ºC'),
	(18963, 110, '2015-01-15 00:38:10.000000', 'temperatura', 367.0000, 'ºC'),
	(18964, 110, '2015-01-15 00:38:11.000000', 'temperatura', 1181.0000, 'ºC'),
	(18965, 110, '2015-01-15 00:38:12.000000', 'temperatura', 3.0000, 'ºC'),
	(18966, 110, '2015-01-15 00:38:13.000000', 'temperatura', 72.0000, 'ºC'),
	(18967, 110, '2015-01-15 00:38:14.000000', 'temperatura', 351.0000, 'ºC'),
	(18968, 110, '2015-01-15 00:38:15.000000', 'temperatura', 342.0000, 'ºC'),
	(18969, 110, '2015-01-15 00:38:16.000000', 'temperatura', 656.0000, 'ºC'),
	(18970, 110, '2015-01-15 00:38:17.000000', 'temperatura', 1053.0000, 'ºC'),
	(18971, 110, '2015-01-15 00:38:18.000000', 'temperatura', 898.0000, 'ºC'),
	(18972, 110, '2015-01-15 00:38:19.000000', 'temperatura', 134.0000, 'ºC'),
	(18973, 110, '2015-01-15 00:38:20.000000', 'temperatura', 374.0000, 'ºC'),
	(18974, 110, '2015-01-15 00:38:21.000000', 'temperatura', 271.0000, 'ºC'),
	(18975, 110, '2015-01-15 00:38:22.000000', 'temperatura', 231.0000, 'ºC'),
	(18976, 110, '2015-01-15 00:38:23.000000', 'temperatura', 345.0000, 'ºC'),
	(18977, 110, '2015-01-15 00:38:24.000000', 'temperatura', 1032.0000, 'ºC'),
	(18978, 110, '2015-01-15 00:38:25.000000', 'temperatura', 524.0000, 'ºC'),
	(18979, 110, '2015-01-15 00:38:26.000000', 'temperatura', 723.0000, 'ºC'),
	(18980, 110, '2015-01-15 00:38:27.000000', 'temperatura', 846.0000, 'ºC'),
	(18981, 110, '2015-01-15 00:38:28.000000', 'temperatura', 861.0000, 'ºC'),
	(18982, 110, '2015-01-15 00:38:29.000000', 'temperatura', 567.0000, 'ºC'),
	(18983, 110, '2015-01-15 00:38:30.000000', 'temperatura', 254.0000, 'ºC'),
	(18984, 110, '2015-01-15 00:38:31.000000', 'temperatura', 768.0000, 'ºC'),
	(18985, 110, '2015-01-15 00:38:32.000000', 'temperatura', 678.0000, 'ºC'),
	(18986, 110, '2015-01-15 00:38:33.000000', 'temperatura', 1088.0000, 'ºC'),
	(18987, 110, '2015-01-15 00:38:34.000000', 'temperatura', 1006.0000, 'ºC'),
	(18988, 110, '2015-01-15 00:38:35.000000', 'temperatura', 566.0000, 'ºC'),
	(18989, 110, '2015-01-15 00:38:36.000000', 'temperatura', 1013.0000, 'ºC'),
	(18990, 110, '2015-01-15 00:38:37.000000', 'temperatura', 969.0000, 'ºC'),
	(18991, 110, '2015-01-15 00:38:38.000000', 'temperatura', 607.0000, 'ºC'),
	(18992, 110, '2015-01-15 00:38:39.000000', 'temperatura', 128.0000, 'ºC'),
	(18993, 110, '2015-01-15 00:38:40.000000', 'temperatura', 19.0000, 'ºC'),
	(18994, 110, '2015-01-15 00:38:41.000000', 'temperatura', 910.0000, 'ºC'),
	(18995, 110, '2015-01-15 00:38:42.000000', 'temperatura', 894.0000, 'ºC'),
	(18996, 110, '2015-01-15 00:38:43.000000', 'temperatura', 542.0000, 'ºC'),
	(18997, 110, '2015-01-15 00:38:44.000000', 'temperatura', 30.0000, 'ºC'),
	(18998, 110, '2015-01-15 00:38:45.000000', 'temperatura', 921.0000, 'ºC'),
	(18999, 110, '2015-01-15 00:38:46.000000', 'temperatura', 917.0000, 'ºC'),
	(19000, 110, '2015-01-15 00:38:47.000000', 'temperatura', 622.0000, 'ºC'),
	(19001, 110, '2015-01-15 00:38:48.000000', 'temperatura', 361.0000, 'ºC'),
	(19002, 110, '2015-01-15 00:38:49.000000', 'temperatura', 1140.0000, 'ºC'),
	(19003, 110, '2015-01-15 00:38:50.000000', 'temperatura', 1018.0000, 'ºC'),
	(19004, 110, '2015-01-15 00:38:51.000000', 'temperatura', 470.0000, 'ºC'),
	(19005, 110, '2015-01-15 00:38:52.000000', 'temperatura', 494.0000, 'ºC'),
	(19006, 110, '2015-01-15 00:38:53.000000', 'temperatura', 1062.0000, 'ºC'),
	(19007, 110, '2015-01-15 00:38:54.000000', 'temperatura', 230.0000, 'ºC'),
	(19008, 110, '2015-01-15 00:38:55.000000', 'temperatura', 363.0000, 'ºC'),
	(19009, 110, '2015-01-15 00:38:56.000000', 'temperatura', 1126.0000, 'ºC'),
	(19010, 110, '2015-01-15 00:38:57.000000', 'temperatura', 941.0000, 'ºC'),
	(19011, 110, '2015-01-15 00:38:58.000000', 'temperatura', 129.0000, 'ºC'),
	(19012, 110, '2015-01-15 00:38:59.000000', 'temperatura', 222.0000, 'ºC'),
	(19013, 110, '2015-01-15 00:39:00.000000', 'temperatura', 722.0000, 'ºC'),
	(19014, 110, '2015-01-15 00:39:01.000000', 'temperatura', 547.0000, 'ºC'),
	(19015, 110, '2015-01-15 00:39:02.000000', 'temperatura', 570.0000, 'ºC'),
	(19016, 110, '2015-01-15 00:39:03.000000', 'temperatura', 9.0000, 'ºC'),
	(19017, 110, '2015-01-15 00:39:04.000000', 'temperatura', 736.0000, 'ºC'),
	(19018, 110, '2015-01-15 00:39:05.000000', 'temperatura', 54.0000, 'ºC'),
	(19019, 110, '2015-01-15 00:39:06.000000', 'temperatura', 462.0000, 'ºC'),
	(19020, 110, '2015-01-15 00:39:07.000000', 'temperatura', 950.0000, 'ºC'),
	(19021, 110, '2015-01-15 00:39:08.000000', 'temperatura', 961.0000, 'ºC'),
	(19022, 110, '2015-01-15 00:39:09.000000', 'temperatura', 759.0000, 'ºC'),
	(19023, 110, '2015-01-15 00:39:10.000000', 'temperatura', 911.0000, 'ºC'),
	(19024, 110, '2015-01-15 00:39:11.000000', 'temperatura', 1079.0000, 'ºC'),
	(19025, 110, '2015-01-15 00:39:12.000000', 'temperatura', 261.0000, 'ºC'),
	(19026, 110, '2015-01-15 00:39:13.000000', 'temperatura', 468.0000, 'ºC'),
	(19027, 110, '2015-01-15 00:39:14.000000', 'temperatura', 360.0000, 'ºC'),
	(19028, 110, '2015-01-15 00:39:15.000000', 'temperatura', 397.0000, 'ºC'),
	(19029, 110, '2015-01-15 00:39:16.000000', 'temperatura', 906.0000, 'ºC'),
	(19030, 110, '2015-01-15 00:39:17.000000', 'temperatura', 937.0000, 'ºC'),
	(19031, 110, '2015-01-15 00:39:18.000000', 'temperatura', 768.0000, 'ºC'),
	(19032, 110, '2015-01-15 00:39:19.000000', 'temperatura', 1028.0000, 'ºC'),
	(19033, 110, '2015-01-15 00:39:20.000000', 'temperatura', 437.0000, 'ºC'),
	(19034, 110, '2015-01-15 00:39:21.000000', 'temperatura', 303.0000, 'ºC'),
	(19035, 110, '2015-01-15 00:39:22.000000', 'temperatura', 205.0000, 'ºC'),
	(19036, 110, '2015-01-15 00:39:23.000000', 'temperatura', 116.0000, 'ºC'),
	(19037, 110, '2015-01-15 00:39:24.000000', 'temperatura', 1165.0000, 'ºC'),
	(19038, 110, '2015-01-15 00:39:25.000000', 'temperatura', 677.0000, 'ºC'),
	(19039, 110, '2015-01-15 00:39:26.000000', 'temperatura', 1091.0000, 'ºC'),
	(19040, 110, '2015-01-15 00:39:27.000000', 'temperatura', 1025.0000, 'ºC'),
	(19041, 110, '2015-01-15 00:39:28.000000', 'temperatura', 653.0000, 'ºC'),
	(19042, 110, '2015-01-15 00:39:29.000000', 'temperatura', 192.0000, 'ºC'),
	(19043, 110, '2015-01-15 00:39:30.000000', 'temperatura', 199.0000, 'ºC'),
	(19044, 110, '2015-01-15 00:39:31.000000', 'temperatura', 419.0000, 'ºC'),
	(19045, 110, '2015-01-15 00:39:32.000000', 'temperatura', 299.0000, 'ºC'),
	(19046, 110, '2015-01-15 00:39:33.000000', 'temperatura', 239.0000, 'ºC'),
	(19047, 110, '2015-01-15 00:39:34.000000', 'temperatura', 299.0000, 'ºC'),
	(19048, 110, '2015-01-15 00:39:35.000000', 'temperatura', 776.0000, 'ºC'),
	(19049, 110, '2015-01-15 00:39:36.000000', 'temperatura', 585.0000, 'ºC'),
	(19050, 110, '2015-01-15 00:39:37.000000', 'temperatura', 598.0000, 'ºC'),
	(19051, 110, '2015-01-15 00:39:38.000000', 'temperatura', 36.0000, 'ºC'),
	(19052, 110, '2015-01-15 00:39:39.000000', 'temperatura', 785.0000, 'ºC'),
	(19053, 110, '2015-01-15 00:39:40.000000', 'temperatura', 218.0000, 'ºC'),
	(19054, 110, '2015-01-15 00:39:41.000000', 'temperatura', 1137.0000, 'ºC'),
	(19055, 110, '2015-01-15 00:39:42.000000', 'temperatura', 233.0000, 'ºC'),
	(19056, 110, '2015-01-15 00:39:43.000000', 'temperatura', 151.0000, 'ºC'),
	(19057, 110, '2015-01-15 00:39:44.000000', 'temperatura', 59.0000, 'ºC'),
	(19058, 110, '2015-01-15 00:39:45.000000', 'temperatura', 1041.0000, 'ºC'),
	(19059, 110, '2015-01-15 00:39:46.000000', 'temperatura', 231.0000, 'ºC'),
	(19060, 110, '2015-01-15 00:39:47.000000', 'temperatura', 431.0000, 'ºC'),
	(19061, 110, '2015-01-15 00:39:48.000000', 'temperatura', 262.0000, 'ºC'),
	(19062, 110, '2015-01-15 00:39:49.000000', 'temperatura', 17.0000, 'ºC'),
	(19063, 110, '2015-01-15 00:39:50.000000', 'temperatura', 501.0000, 'ºC'),
	(19064, 110, '2015-01-15 00:39:51.000000', 'temperatura', 53.0000, 'ºC'),
	(19065, 110, '2015-01-15 00:39:52.000000', 'temperatura', 1163.0000, 'ºC'),
	(19066, 110, '2015-01-15 00:39:53.000000', 'temperatura', 856.0000, 'ºC'),
	(19067, 110, '2015-01-15 00:39:54.000000', 'temperatura', 792.0000, 'ºC'),
	(19068, 110, '2015-01-15 00:39:55.000000', 'temperatura', 191.0000, 'ºC'),
	(19069, 110, '2015-01-15 00:39:56.000000', 'temperatura', 982.0000, 'ºC'),
	(19070, 110, '2015-01-15 00:39:57.000000', 'temperatura', 734.0000, 'ºC'),
	(19071, 110, '2015-01-15 00:39:58.000000', 'temperatura', 728.0000, 'ºC'),
	(19072, 110, '2015-01-15 00:39:59.000000', 'temperatura', 238.0000, 'ºC'),
	(19073, 110, '2015-01-15 00:40:00.000000', 'temperatura', 205.0000, 'ºC'),
	(19074, 110, '2015-01-15 00:40:01.000000', 'temperatura', 311.0000, 'ºC'),
	(19075, 110, '2015-01-15 00:40:02.000000', 'temperatura', 942.0000, 'ºC'),
	(19076, 110, '2015-01-15 00:40:03.000000', 'temperatura', 178.0000, 'ºC'),
	(19077, 110, '2015-01-15 00:40:04.000000', 'temperatura', 463.0000, 'ºC'),
	(19078, 110, '2015-01-15 00:40:05.000000', 'temperatura', 580.0000, 'ºC'),
	(19079, 110, '2015-01-15 00:40:06.000000', 'temperatura', 315.0000, 'ºC'),
	(19080, 110, '2015-01-15 00:40:07.000000', 'temperatura', 1033.0000, 'ºC'),
	(19081, 110, '2015-01-15 00:40:08.000000', 'temperatura', 620.0000, 'ºC'),
	(19082, 110, '2015-01-15 00:40:09.000000', 'temperatura', 3.0000, 'ºC'),
	(19083, 110, '2015-01-15 00:40:10.000000', 'temperatura', 554.0000, 'ºC'),
	(19084, 110, '2015-01-15 00:40:11.000000', 'temperatura', 363.0000, 'ºC'),
	(19085, 110, '2015-01-15 00:40:12.000000', 'temperatura', 152.0000, 'ºC'),
	(19086, 110, '2015-01-15 00:40:13.000000', 'temperatura', 872.0000, 'ºC'),
	(19087, 110, '2015-01-15 00:40:14.000000', 'temperatura', 303.0000, 'ºC'),
	(19088, 110, '2015-01-15 00:40:15.000000', 'temperatura', 99.0000, 'ºC'),
	(19089, 110, '2015-01-15 00:40:16.000000', 'temperatura', 789.0000, 'ºC'),
	(19090, 110, '2015-01-15 00:40:17.000000', 'temperatura', 49.0000, 'ºC'),
	(19091, 110, '2015-01-15 00:40:18.000000', 'temperatura', 279.0000, 'ºC'),
	(19092, 110, '2015-01-15 00:40:19.000000', 'temperatura', 47.0000, 'ºC'),
	(19093, 110, '2015-01-15 00:40:20.000000', 'temperatura', 599.0000, 'ºC'),
	(19094, 110, '2015-01-15 00:40:21.000000', 'temperatura', 453.0000, 'ºC'),
	(19095, 110, '2015-01-15 00:40:22.000000', 'temperatura', 470.0000, 'ºC'),
	(19096, 110, '2015-01-15 00:40:23.000000', 'temperatura', 990.0000, 'ºC'),
	(19097, 110, '2015-01-15 00:40:24.000000', 'temperatura', 1142.0000, 'ºC'),
	(19098, 110, '2015-01-15 00:40:25.000000', 'temperatura', 340.0000, 'ºC'),
	(19099, 110, '2015-01-15 00:40:26.000000', 'temperatura', 673.0000, 'ºC'),
	(19100, 110, '2015-01-15 00:40:27.000000', 'temperatura', 1148.0000, 'ºC'),
	(19101, 110, '2015-01-15 00:40:28.000000', 'temperatura', 122.0000, 'ºC'),
	(19102, 110, '2015-01-15 00:40:29.000000', 'temperatura', 764.0000, 'ºC'),
	(19103, 110, '2015-01-15 00:40:30.000000', 'temperatura', 1056.0000, 'ºC'),
	(19104, 110, '2015-01-15 00:40:31.000000', 'temperatura', 588.0000, 'ºC'),
	(19105, 110, '2015-01-15 00:40:32.000000', 'temperatura', 974.0000, 'ºC'),
	(19106, 110, '2015-01-15 00:40:33.000000', 'temperatura', 707.0000, 'ºC'),
	(19107, 110, '2015-01-15 00:40:34.000000', 'temperatura', 610.0000, 'ºC'),
	(19108, 110, '2015-01-15 00:40:35.000000', 'temperatura', 933.0000, 'ºC'),
	(19109, 110, '2015-01-15 00:40:36.000000', 'temperatura', 433.0000, 'ºC'),
	(19110, 110, '2015-01-15 00:40:37.000000', 'temperatura', 568.0000, 'ºC'),
	(19111, 110, '2015-01-15 00:40:38.000000', 'temperatura', 341.0000, 'ºC'),
	(19112, 110, '2015-01-15 00:40:39.000000', 'temperatura', 2.0000, 'ºC'),
	(19113, 110, '2015-01-15 00:40:40.000000', 'temperatura', 188.0000, 'ºC'),
	(19114, 110, '2015-01-15 00:40:41.000000', 'temperatura', 935.0000, 'ºC'),
	(19115, 110, '2015-01-15 00:40:42.000000', 'temperatura', 512.0000, 'ºC'),
	(19116, 110, '2015-01-15 00:40:43.000000', 'temperatura', 954.0000, 'ºC'),
	(19117, 110, '2015-01-15 00:40:44.000000', 'temperatura', 837.0000, 'ºC'),
	(19118, 110, '2015-01-15 00:40:45.000000', 'temperatura', 121.0000, 'ºC'),
	(19119, 110, '2015-01-15 00:40:46.000000', 'temperatura', 497.0000, 'ºC'),
	(19120, 110, '2015-01-15 00:40:47.000000', 'temperatura', 921.0000, 'ºC'),
	(19121, 110, '2015-01-15 00:40:48.000000', 'temperatura', 714.0000, 'ºC'),
	(19122, 110, '2015-01-15 00:40:49.000000', 'temperatura', 807.0000, 'ºC'),
	(19123, 110, '2015-01-15 00:40:50.000000', 'temperatura', 694.0000, 'ºC'),
	(19124, 110, '2015-01-15 00:40:51.000000', 'temperatura', 1051.0000, 'ºC'),
	(19125, 110, '2015-01-15 00:40:52.000000', 'temperatura', 775.0000, 'ºC'),
	(19126, 110, '2015-01-15 00:40:53.000000', 'temperatura', 719.0000, 'ºC'),
	(19127, 110, '2015-01-15 00:40:54.000000', 'temperatura', 71.0000, 'ºC'),
	(19128, 110, '2015-01-15 00:40:55.000000', 'temperatura', 597.0000, 'ºC'),
	(19129, 110, '2015-01-15 00:40:56.000000', 'temperatura', 376.0000, 'ºC'),
	(19130, 110, '2015-01-15 00:40:57.000000', 'temperatura', 88.0000, 'ºC'),
	(19131, 110, '2015-01-15 00:40:58.000000', 'temperatura', 512.0000, 'ºC'),
	(19132, 110, '2015-01-15 00:40:59.000000', 'temperatura', 1097.0000, 'ºC'),
	(19133, 110, '2015-01-15 00:41:00.000000', 'temperatura', 351.0000, 'ºC'),
	(19134, 110, '2015-01-15 00:41:01.000000', 'temperatura', 862.0000, 'ºC'),
	(19135, 110, '2015-01-15 00:41:02.000000', 'temperatura', 858.0000, 'ºC'),
	(19136, 110, '2015-01-15 00:41:03.000000', 'temperatura', 506.0000, 'ºC'),
	(19137, 110, '2015-01-15 00:41:04.000000', 'temperatura', 1154.0000, 'ºC'),
	(19138, 110, '2015-01-15 00:41:05.000000', 'temperatura', 655.0000, 'ºC'),
	(19139, 110, '2015-01-15 00:41:06.000000', 'temperatura', 1013.0000, 'ºC'),
	(19140, 110, '2015-01-15 00:41:07.000000', 'temperatura', 701.0000, 'ºC'),
	(19141, 110, '2015-01-15 00:41:08.000000', 'temperatura', 464.0000, 'ºC'),
	(19142, 110, '2015-01-15 00:41:09.000000', 'temperatura', 219.0000, 'ºC'),
	(19143, 110, '2015-01-15 00:41:10.000000', 'temperatura', 905.0000, 'ºC'),
	(19144, 110, '2015-01-15 00:41:11.000000', 'temperatura', 269.0000, 'ºC'),
	(19145, 110, '2015-01-15 00:41:12.000000', 'temperatura', 1028.0000, 'ºC'),
	(19146, 110, '2015-01-15 00:41:13.000000', 'temperatura', 734.0000, 'ºC'),
	(19147, 110, '2015-01-15 00:41:14.000000', 'temperatura', 589.0000, 'ºC'),
	(19148, 110, '2015-01-15 00:41:15.000000', 'temperatura', 741.0000, 'ºC'),
	(19149, 110, '2015-01-15 00:41:16.000000', 'temperatura', 739.0000, 'ºC'),
	(19150, 110, '2015-01-15 00:41:17.000000', 'temperatura', 273.0000, 'ºC'),
	(19151, 110, '2015-01-15 00:41:18.000000', 'temperatura', 349.0000, 'ºC'),
	(19152, 110, '2015-01-15 00:41:19.000000', 'temperatura', 927.0000, 'ºC'),
	(19153, 110, '2015-01-15 00:41:20.000000', 'temperatura', 1189.0000, 'ºC'),
	(19154, 110, '2015-01-15 00:41:21.000000', 'temperatura', 765.0000, 'ºC'),
	(19155, 110, '2015-01-15 00:41:22.000000', 'temperatura', 256.0000, 'ºC'),
	(19156, 110, '2015-01-15 00:41:23.000000', 'temperatura', 187.0000, 'ºC'),
	(19157, 110, '2015-01-15 00:41:24.000000', 'temperatura', 168.0000, 'ºC'),
	(19158, 110, '2015-01-15 00:41:25.000000', 'temperatura', 280.0000, 'ºC'),
	(19159, 110, '2015-01-15 00:41:26.000000', 'temperatura', 894.0000, 'ºC'),
	(19160, 110, '2015-01-15 00:41:27.000000', 'temperatura', 32.0000, 'ºC'),
	(19161, 110, '2015-01-15 00:41:28.000000', 'temperatura', 1077.0000, 'ºC'),
	(19162, 110, '2015-01-15 00:41:29.000000', 'temperatura', 490.0000, 'ºC'),
	(19163, 110, '2015-01-15 00:41:30.000000', 'temperatura', 418.0000, 'ºC'),
	(19164, 110, '2015-01-15 00:41:31.000000', 'temperatura', 623.0000, 'ºC'),
	(19165, 110, '2015-01-15 00:41:32.000000', 'temperatura', 659.0000, 'ºC'),
	(19166, 110, '2015-01-15 00:41:33.000000', 'temperatura', 227.0000, 'ºC'),
	(19167, 110, '2015-01-15 00:41:34.000000', 'temperatura', 357.0000, 'ºC'),
	(19168, 110, '2015-01-15 00:41:35.000000', 'temperatura', 1106.0000, 'ºC'),
	(19169, 110, '2015-01-15 00:41:36.000000', 'temperatura', 861.0000, 'ºC'),
	(19170, 110, '2015-01-15 00:41:37.000000', 'temperatura', 986.0000, 'ºC'),
	(19171, 110, '2015-01-15 00:41:38.000000', 'temperatura', 1147.0000, 'ºC'),
	(19172, 110, '2015-01-15 00:41:39.000000', 'temperatura', 377.0000, 'ºC'),
	(19173, 110, '2015-01-15 00:41:40.000000', 'temperatura', 845.0000, 'ºC'),
	(19174, 110, '2015-01-15 00:41:41.000000', 'temperatura', 695.0000, 'ºC'),
	(19175, 110, '2015-01-15 00:41:42.000000', 'temperatura', 940.0000, 'ºC'),
	(19176, 110, '2015-01-15 00:41:43.000000', 'temperatura', 214.0000, 'ºC'),
	(19177, 110, '2015-01-15 00:41:44.000000', 'temperatura', 653.0000, 'ºC'),
	(19178, 110, '2015-01-15 00:41:45.000000', 'temperatura', 222.0000, 'ºC'),
	(19179, 110, '2015-01-15 00:41:46.000000', 'temperatura', 351.0000, 'ºC'),
	(19180, 110, '2015-01-15 00:41:47.000000', 'temperatura', 1088.0000, 'ºC'),
	(19181, 110, '2015-01-15 00:41:48.000000', 'temperatura', 791.0000, 'ºC'),
	(19182, 110, '2015-01-15 00:41:49.000000', 'temperatura', 689.0000, 'ºC'),
	(19183, 110, '2015-01-15 00:41:50.000000', 'temperatura', 1075.0000, 'ºC'),
	(19184, 110, '2015-01-15 00:41:51.000000', 'temperatura', 907.0000, 'ºC'),
	(19185, 110, '2015-01-15 00:41:52.000000', 'temperatura', 111.0000, 'ºC'),
	(19186, 110, '2015-01-15 00:41:53.000000', 'temperatura', 236.0000, 'ºC'),
	(19187, 110, '2015-01-15 00:41:54.000000', 'temperatura', 846.0000, 'ºC'),
	(19188, 110, '2015-01-15 00:41:55.000000', 'temperatura', 1123.0000, 'ºC'),
	(19189, 110, '2015-01-15 00:41:56.000000', 'temperatura', 677.0000, 'ºC'),
	(19190, 110, '2015-01-15 00:41:57.000000', 'temperatura', 18.0000, 'ºC'),
	(19191, 110, '2015-01-15 00:41:58.000000', 'temperatura', 458.0000, 'ºC'),
	(19192, 110, '2015-01-15 00:41:59.000000', 'temperatura', 1035.0000, 'ºC'),
	(19193, 110, '2015-01-15 00:42:00.000000', 'temperatura', 202.0000, 'ºC'),
	(19194, 110, '2015-01-15 00:42:01.000000', 'temperatura', 306.0000, 'ºC'),
	(19195, 110, '2015-01-15 00:42:02.000000', 'temperatura', 925.0000, 'ºC'),
	(19196, 110, '2015-01-15 00:42:03.000000', 'temperatura', 107.0000, 'ºC'),
	(19197, 110, '2015-01-15 00:42:04.000000', 'temperatura', 162.0000, 'ºC'),
	(19198, 110, '2015-01-15 00:42:05.000000', 'temperatura', 487.0000, 'ºC'),
	(19199, 110, '2015-01-15 00:42:06.000000', 'temperatura', 752.0000, 'ºC'),
	(19200, 110, '2015-01-15 00:42:07.000000', 'temperatura', 1101.0000, 'ºC'),
	(19201, 110, '2015-01-15 00:42:08.000000', 'temperatura', 846.0000, 'ºC'),
	(19202, 110, '2015-01-15 00:42:09.000000', 'temperatura', 929.0000, 'ºC'),
	(19203, 110, '2015-01-15 00:42:10.000000', 'temperatura', 907.0000, 'ºC'),
	(19204, 110, '2015-01-15 00:42:11.000000', 'temperatura', 551.0000, 'ºC'),
	(19205, 110, '2015-01-15 00:42:12.000000', 'temperatura', 31.0000, 'ºC'),
	(19206, 110, '2015-01-15 00:42:13.000000', 'temperatura', 906.0000, 'ºC'),
	(19207, 110, '2015-01-15 00:42:14.000000', 'temperatura', 835.0000, 'ºC'),
	(19208, 110, '2015-01-15 00:42:15.000000', 'temperatura', 259.0000, 'ºC'),
	(19209, 110, '2015-01-15 00:42:16.000000', 'temperatura', 1189.0000, 'ºC'),
	(19210, 110, '2015-01-15 00:42:17.000000', 'temperatura', 370.0000, 'ºC'),
	(19211, 110, '2015-01-15 00:42:18.000000', 'temperatura', 685.0000, 'ºC'),
	(19212, 110, '2015-01-15 00:42:19.000000', 'temperatura', 1114.0000, 'ºC'),
	(19213, 110, '2015-01-15 00:42:20.000000', 'temperatura', 1115.0000, 'ºC'),
	(19214, 110, '2015-01-15 00:42:21.000000', 'temperatura', 1035.0000, 'ºC'),
	(19215, 110, '2015-01-15 00:42:22.000000', 'temperatura', 629.0000, 'ºC'),
	(19216, 110, '2015-01-15 00:42:23.000000', 'temperatura', 40.0000, 'ºC'),
	(19217, 110, '2015-01-15 00:42:24.000000', 'temperatura', 713.0000, 'ºC'),
	(19218, 110, '2015-01-15 00:42:25.000000', 'temperatura', 1048.0000, 'ºC'),
	(19219, 110, '2015-01-15 00:42:26.000000', 'temperatura', 702.0000, 'ºC'),
	(19220, 110, '2015-01-15 00:42:27.000000', 'temperatura', 364.0000, 'ºC'),
	(19221, 110, '2015-01-15 00:42:28.000000', 'temperatura', 914.0000, 'ºC'),
	(19222, 110, '2015-01-15 00:42:29.000000', 'temperatura', 1079.0000, 'ºC'),
	(19223, 110, '2015-01-15 00:42:30.000000', 'temperatura', 255.0000, 'ºC'),
	(19224, 110, '2015-01-15 00:42:31.000000', 'temperatura', 439.0000, 'ºC'),
	(19225, 110, '2015-01-15 00:42:32.000000', 'temperatura', 230.0000, 'ºC'),
	(19226, 110, '2015-01-15 00:42:33.000000', 'temperatura', 1035.0000, 'ºC'),
	(19227, 110, '2015-01-15 00:42:34.000000', 'temperatura', 882.0000, 'ºC'),
	(19228, 110, '2015-01-15 00:42:35.000000', 'temperatura', 109.0000, 'ºC'),
	(19229, 110, '2015-01-15 00:42:36.000000', 'temperatura', 296.0000, 'ºC'),
	(19230, 110, '2015-01-15 00:42:37.000000', 'temperatura', 1157.0000, 'ºC'),
	(19231, 110, '2015-01-15 00:42:38.000000', 'temperatura', 97.0000, 'ºC'),
	(19232, 110, '2015-01-15 00:42:39.000000', 'temperatura', 612.0000, 'ºC'),
	(19233, 110, '2015-01-15 00:42:40.000000', 'temperatura', 370.0000, 'ºC'),
	(19234, 110, '2015-01-15 00:42:41.000000', 'temperatura', 14.0000, 'ºC'),
	(19235, 110, '2015-01-15 00:42:42.000000', 'temperatura', 159.0000, 'ºC'),
	(19236, 110, '2015-01-15 00:42:43.000000', 'temperatura', 756.0000, 'ºC'),
	(19237, 110, '2015-01-15 00:42:44.000000', 'temperatura', 904.0000, 'ºC'),
	(19238, 110, '2015-01-15 00:42:45.000000', 'temperatura', 1050.0000, 'ºC'),
	(19239, 110, '2015-01-15 00:42:46.000000', 'temperatura', 140.0000, 'ºC'),
	(19240, 110, '2015-01-15 00:42:47.000000', 'temperatura', 1148.0000, 'ºC'),
	(19241, 110, '2015-01-15 00:42:48.000000', 'temperatura', 524.0000, 'ºC'),
	(19242, 110, '2015-01-15 00:42:49.000000', 'temperatura', 374.0000, 'ºC'),
	(19243, 110, '2015-01-15 00:42:50.000000', 'temperatura', 301.0000, 'ºC'),
	(19244, 110, '2015-01-15 00:42:51.000000', 'temperatura', 382.0000, 'ºC'),
	(19245, 110, '2015-01-15 00:42:52.000000', 'temperatura', 1009.0000, 'ºC'),
	(19246, 110, '2015-01-15 00:42:53.000000', 'temperatura', 297.0000, 'ºC'),
	(19247, 110, '2015-01-15 00:42:54.000000', 'temperatura', 858.0000, 'ºC'),
	(19248, 110, '2015-01-15 00:42:55.000000', 'temperatura', 1002.0000, 'ºC'),
	(19249, 110, '2015-01-15 00:42:56.000000', 'temperatura', 36.0000, 'ºC'),
	(19250, 110, '2015-01-15 00:42:57.000000', 'temperatura', 773.0000, 'ºC'),
	(19251, 110, '2015-01-15 00:42:58.000000', 'temperatura', 158.0000, 'ºC'),
	(19252, 110, '2015-01-15 00:42:59.000000', 'temperatura', 872.0000, 'ºC'),
	(19253, 110, '2015-01-15 00:43:00.000000', 'temperatura', 285.0000, 'ºC'),
	(19254, 110, '2015-01-15 00:43:01.000000', 'temperatura', 10.0000, 'ºC'),
	(19255, 110, '2015-01-15 00:43:02.000000', 'temperatura', 394.0000, 'ºC'),
	(19256, 110, '2015-01-15 00:43:03.000000', 'temperatura', 742.0000, 'ºC'),
	(19257, 110, '2015-01-15 00:43:04.000000', 'temperatura', 127.0000, 'ºC'),
	(19258, 110, '2015-01-15 00:43:05.000000', 'temperatura', 810.0000, 'ºC'),
	(19259, 110, '2015-01-15 00:43:06.000000', 'temperatura', 68.0000, 'ºC'),
	(19260, 110, '2015-01-15 00:43:07.000000', 'temperatura', 314.0000, 'ºC'),
	(19261, 110, '2015-01-15 00:43:08.000000', 'temperatura', 163.0000, 'ºC'),
	(19262, 110, '2015-01-15 00:43:09.000000', 'temperatura', 1075.0000, 'ºC'),
	(19263, 110, '2015-01-15 00:43:10.000000', 'temperatura', 88.0000, 'ºC'),
	(19264, 110, '2015-01-15 00:43:11.000000', 'temperatura', 815.0000, 'ºC'),
	(19265, 110, '2015-01-15 00:43:12.000000', 'temperatura', 213.0000, 'ºC'),
	(19266, 110, '2015-01-15 00:43:13.000000', 'temperatura', 1018.0000, 'ºC'),
	(19267, 110, '2015-01-15 00:43:14.000000', 'temperatura', 854.0000, 'ºC'),
	(19268, 110, '2015-01-15 00:43:15.000000', 'temperatura', 17.0000, 'ºC'),
	(19269, 110, '2015-01-15 00:43:16.000000', 'temperatura', 1123.0000, 'ºC'),
	(19270, 110, '2015-01-15 00:43:17.000000', 'temperatura', 763.0000, 'ºC'),
	(19271, 110, '2015-01-15 00:43:18.000000', 'temperatura', 448.0000, 'ºC'),
	(19272, 110, '2015-01-15 00:43:19.000000', 'temperatura', 1152.0000, 'ºC'),
	(19273, 110, '2015-01-15 00:43:20.000000', 'temperatura', 816.0000, 'ºC'),
	(19274, 110, '2015-01-15 00:43:21.000000', 'temperatura', 625.0000, 'ºC'),
	(19275, 110, '2015-01-15 00:43:22.000000', 'temperatura', 679.0000, 'ºC'),
	(19276, 110, '2015-01-15 00:43:23.000000', 'temperatura', 319.0000, 'ºC'),
	(19277, 110, '2015-01-15 00:43:24.000000', 'temperatura', 758.0000, 'ºC'),
	(19278, 110, '2015-01-15 00:43:25.000000', 'temperatura', 435.0000, 'ºC'),
	(19279, 110, '2015-01-15 00:43:26.000000', 'temperatura', 1101.0000, 'ºC'),
	(19280, 110, '2015-01-15 00:43:27.000000', 'temperatura', 602.0000, 'ºC'),
	(19281, 110, '2015-01-15 00:43:28.000000', 'temperatura', 906.0000, 'ºC'),
	(19282, 110, '2015-01-15 00:43:29.000000', 'temperatura', 326.0000, 'ºC'),
	(19283, 110, '2015-01-15 00:43:30.000000', 'temperatura', 112.0000, 'ºC'),
	(19284, 110, '2015-01-15 00:43:31.000000', 'temperatura', 783.0000, 'ºC'),
	(19285, 110, '2015-01-15 00:43:32.000000', 'temperatura', 1181.0000, 'ºC'),
	(19286, 110, '2015-01-15 00:43:33.000000', 'temperatura', 1155.0000, 'ºC'),
	(19287, 110, '2015-01-15 00:43:34.000000', 'temperatura', 1034.0000, 'ºC'),
	(19288, 110, '2015-01-15 00:43:35.000000', 'temperatura', 503.0000, 'ºC'),
	(19289, 110, '2015-01-15 00:43:36.000000', 'temperatura', 613.0000, 'ºC'),
	(19290, 110, '2015-01-15 00:43:37.000000', 'temperatura', 360.0000, 'ºC'),
	(19291, 110, '2015-01-15 00:43:38.000000', 'temperatura', 1158.0000, 'ºC'),
	(19292, 110, '2015-01-15 00:43:39.000000', 'temperatura', 1112.0000, 'ºC'),
	(19293, 110, '2015-01-15 00:43:40.000000', 'temperatura', 885.0000, 'ºC'),
	(19294, 110, '2015-01-15 00:43:41.000000', 'temperatura', 1091.0000, 'ºC'),
	(19295, 110, '2015-01-15 00:43:42.000000', 'temperatura', 401.0000, 'ºC'),
	(19296, 110, '2015-01-15 00:43:43.000000', 'temperatura', 1132.0000, 'ºC'),
	(19297, 110, '2015-01-15 00:43:44.000000', 'temperatura', 856.0000, 'ºC'),
	(19298, 110, '2015-01-15 00:43:45.000000', 'temperatura', 886.0000, 'ºC'),
	(19299, 110, '2015-01-15 00:43:46.000000', 'temperatura', 663.0000, 'ºC'),
	(19300, 110, '2015-01-15 00:43:47.000000', 'temperatura', 655.0000, 'ºC'),
	(19301, 110, '2015-01-15 00:43:48.000000', 'temperatura', 90.0000, 'ºC'),
	(19302, 110, '2015-01-15 00:43:49.000000', 'temperatura', 883.0000, 'ºC'),
	(19303, 110, '2015-01-15 00:43:50.000000', 'temperatura', 548.0000, 'ºC'),
	(19304, 110, '2015-01-15 00:43:51.000000', 'temperatura', 91.0000, 'ºC'),
	(19305, 110, '2015-01-15 00:43:52.000000', 'temperatura', 13.0000, 'ºC'),
	(19306, 110, '2015-01-15 00:43:53.000000', 'temperatura', 990.0000, 'ºC'),
	(19307, 110, '2015-01-15 00:43:54.000000', 'temperatura', 112.0000, 'ºC'),
	(19308, 110, '2015-01-15 00:43:55.000000', 'temperatura', 1189.0000, 'ºC'),
	(19309, 110, '2015-01-15 00:43:56.000000', 'temperatura', 813.0000, 'ºC'),
	(19310, 110, '2015-01-15 00:43:57.000000', 'temperatura', 495.0000, 'ºC'),
	(19311, 110, '2015-01-15 00:43:58.000000', 'temperatura', 40.0000, 'ºC'),
	(19312, 110, '2015-01-15 00:43:59.000000', 'temperatura', 1114.0000, 'ºC'),
	(19313, 110, '2015-01-15 00:44:00.000000', 'temperatura', 649.0000, 'ºC'),
	(19314, 110, '2015-01-15 00:44:01.000000', 'temperatura', 1103.0000, 'ºC'),
	(19315, 110, '2015-01-15 00:44:02.000000', 'temperatura', 1170.0000, 'ºC'),
	(19316, 110, '2015-01-15 00:44:03.000000', 'temperatura', 141.0000, 'ºC'),
	(19317, 110, '2015-01-15 00:44:04.000000', 'temperatura', 796.0000, 'ºC'),
	(19318, 110, '2015-01-15 00:44:05.000000', 'temperatura', 1156.0000, 'ºC'),
	(19319, 110, '2015-01-15 00:44:06.000000', 'temperatura', 993.0000, 'ºC'),
	(19320, 110, '2015-01-15 00:44:07.000000', 'temperatura', 298.0000, 'ºC'),
	(19321, 110, '2015-01-15 00:44:08.000000', 'temperatura', 910.0000, 'ºC'),
	(19322, 110, '2015-01-15 00:44:09.000000', 'temperatura', 58.0000, 'ºC'),
	(19323, 110, '2015-01-15 00:44:10.000000', 'temperatura', 1159.0000, 'ºC'),
	(19324, 110, '2015-01-15 00:44:11.000000', 'temperatura', 820.0000, 'ºC'),
	(19325, 110, '2015-01-15 00:44:12.000000', 'temperatura', 627.0000, 'ºC'),
	(19326, 110, '2015-01-15 00:44:13.000000', 'temperatura', 674.0000, 'ºC'),
	(19327, 110, '2015-01-15 00:44:14.000000', 'temperatura', 289.0000, 'ºC'),
	(19328, 110, '2015-01-15 00:44:15.000000', 'temperatura', 625.0000, 'ºC'),
	(19329, 110, '2015-01-15 00:44:16.000000', 'temperatura', 1059.0000, 'ºC'),
	(19330, 110, '2015-01-15 00:44:17.000000', 'temperatura', 1020.0000, 'ºC'),
	(19331, 110, '2015-01-15 00:44:18.000000', 'temperatura', 723.0000, 'ºC'),
	(19332, 110, '2015-01-15 00:44:19.000000', 'temperatura', 554.0000, 'ºC'),
	(19333, 110, '2015-01-15 00:44:20.000000', 'temperatura', 604.0000, 'ºC'),
	(19334, 110, '2015-01-15 00:44:21.000000', 'temperatura', 158.0000, 'ºC'),
	(19335, 110, '2015-01-15 00:44:22.000000', 'temperatura', 178.0000, 'ºC'),
	(19336, 110, '2015-01-15 00:44:23.000000', 'temperatura', 415.0000, 'ºC'),
	(19337, 110, '2015-01-15 00:44:24.000000', 'temperatura', 342.0000, 'ºC'),
	(19338, 110, '2015-01-15 00:44:25.000000', 'temperatura', 466.0000, 'ºC'),
	(19339, 110, '2015-01-15 00:44:26.000000', 'temperatura', 105.0000, 'ºC'),
	(19340, 110, '2015-01-15 00:44:27.000000', 'temperatura', 327.0000, 'ºC'),
	(19341, 110, '2015-01-15 00:44:28.000000', 'temperatura', 122.0000, 'ºC'),
	(19342, 110, '2015-01-15 00:44:29.000000', 'temperatura', 829.0000, 'ºC'),
	(19343, 110, '2015-01-15 00:44:30.000000', 'temperatura', 179.0000, 'ºC'),
	(19344, 110, '2015-01-15 00:44:31.000000', 'temperatura', 811.0000, 'ºC'),
	(19345, 110, '2015-01-15 00:44:32.000000', 'temperatura', 1116.0000, 'ºC'),
	(19346, 110, '2015-01-15 00:44:33.000000', 'temperatura', 747.0000, 'ºC'),
	(19347, 110, '2015-01-15 00:44:34.000000', 'temperatura', 388.0000, 'ºC'),
	(19348, 110, '2015-01-15 00:44:35.000000', 'temperatura', 899.0000, 'ºC'),
	(19349, 110, '2015-01-15 00:44:36.000000', 'temperatura', 933.0000, 'ºC'),
	(19350, 110, '2015-01-15 00:44:37.000000', 'temperatura', 770.0000, 'ºC'),
	(19351, 110, '2015-01-15 00:44:38.000000', 'temperatura', 1050.0000, 'ºC'),
	(19352, 110, '2015-01-15 00:44:39.000000', 'temperatura', 539.0000, 'ºC'),
	(19353, 110, '2015-01-15 00:44:40.000000', 'temperatura', 745.0000, 'ºC'),
	(19354, 110, '2015-01-15 00:44:41.000000', 'temperatura', 910.0000, 'ºC'),
	(19355, 110, '2015-01-15 00:44:42.000000', 'temperatura', 1114.0000, 'ºC'),
	(19356, 110, '2015-01-15 00:44:43.000000', 'temperatura', 440.0000, 'ºC'),
	(19357, 110, '2015-01-15 00:44:44.000000', 'temperatura', 61.0000, 'ºC'),
	(19358, 110, '2015-01-15 00:44:45.000000', 'temperatura', 185.0000, 'ºC'),
	(19359, 110, '2015-01-15 00:44:46.000000', 'temperatura', 740.0000, 'ºC'),
	(19360, 110, '2015-01-15 00:44:47.000000', 'temperatura', 749.0000, 'ºC'),
	(19361, 110, '2015-01-15 00:44:48.000000', 'temperatura', 324.0000, 'ºC'),
	(19362, 110, '2015-01-15 00:44:49.000000', 'temperatura', 575.0000, 'ºC'),
	(19363, 110, '2015-01-15 00:44:50.000000', 'temperatura', 700.0000, 'ºC'),
	(19364, 110, '2015-01-15 00:44:51.000000', 'temperatura', 579.0000, 'ºC'),
	(19365, 110, '2015-01-15 00:44:52.000000', 'temperatura', 795.0000, 'ºC'),
	(19366, 110, '2015-01-15 00:44:53.000000', 'temperatura', 1039.0000, 'ºC'),
	(19367, 110, '2015-01-15 00:44:54.000000', 'temperatura', 412.0000, 'ºC'),
	(19368, 110, '2015-01-15 00:44:55.000000', 'temperatura', 140.0000, 'ºC'),
	(19369, 110, '2015-01-15 00:44:56.000000', 'temperatura', 668.0000, 'ºC'),
	(19370, 110, '2015-01-15 00:44:57.000000', 'temperatura', 518.0000, 'ºC'),
	(19371, 110, '2015-01-15 00:44:58.000000', 'temperatura', 589.0000, 'ºC'),
	(19372, 110, '2015-01-15 00:44:59.000000', 'temperatura', 189.0000, 'ºC'),
	(19373, 110, '2015-01-15 00:45:00.000000', 'temperatura', 378.0000, 'ºC'),
	(19374, 110, '2015-01-15 00:45:01.000000', 'temperatura', 125.0000, 'ºC'),
	(19375, 110, '2015-01-15 00:45:02.000000', 'temperatura', 693.0000, 'ºC'),
	(19376, 110, '2015-01-15 00:45:03.000000', 'temperatura', 688.0000, 'ºC'),
	(19377, 110, '2015-01-15 00:45:04.000000', 'temperatura', 163.0000, 'ºC'),
	(19378, 110, '2015-01-15 00:45:05.000000', 'temperatura', 1151.0000, 'ºC'),
	(19379, 110, '2015-01-15 00:45:06.000000', 'temperatura', 465.0000, 'ºC'),
	(19380, 110, '2015-01-15 00:45:07.000000', 'temperatura', 75.0000, 'ºC'),
	(19381, 110, '2015-01-15 00:45:08.000000', 'temperatura', 181.0000, 'ºC'),
	(19382, 110, '2015-01-15 00:45:09.000000', 'temperatura', 680.0000, 'ºC'),
	(19383, 110, '2015-01-15 00:45:10.000000', 'temperatura', 456.0000, 'ºC'),
	(19384, 110, '2015-01-15 00:45:11.000000', 'temperatura', 240.0000, 'ºC'),
	(19385, 110, '2015-01-15 00:45:12.000000', 'temperatura', 1035.0000, 'ºC'),
	(19386, 110, '2015-01-15 00:45:13.000000', 'temperatura', 853.0000, 'ºC'),
	(19387, 110, '2015-01-15 00:45:14.000000', 'temperatura', 1162.0000, 'ºC'),
	(19388, 110, '2015-01-15 00:45:15.000000', 'temperatura', 851.0000, 'ºC'),
	(19389, 110, '2015-01-15 00:45:16.000000', 'temperatura', 771.0000, 'ºC'),
	(19390, 110, '2015-01-15 00:45:17.000000', 'temperatura', 101.0000, 'ºC'),
	(19391, 110, '2015-01-15 00:45:18.000000', 'temperatura', 593.0000, 'ºC'),
	(19392, 110, '2015-01-15 00:45:19.000000', 'temperatura', 260.0000, 'ºC'),
	(19393, 110, '2015-01-15 00:45:20.000000', 'temperatura', 725.0000, 'ºC'),
	(19394, 110, '2015-01-15 00:45:21.000000', 'temperatura', 445.0000, 'ºC'),
	(19395, 110, '2015-01-15 00:45:22.000000', 'temperatura', 51.0000, 'ºC'),
	(19396, 110, '2015-01-15 00:45:23.000000', 'temperatura', 121.0000, 'ºC'),
	(19397, 110, '2015-01-15 00:45:24.000000', 'temperatura', 454.0000, 'ºC'),
	(19398, 110, '2015-01-15 00:45:25.000000', 'temperatura', 705.0000, 'ºC'),
	(19399, 110, '2015-01-15 00:45:26.000000', 'temperatura', 962.0000, 'ºC'),
	(19400, 110, '2015-01-15 00:45:27.000000', 'temperatura', 297.0000, 'ºC'),
	(19401, 110, '2015-01-15 00:45:28.000000', 'temperatura', 1001.0000, 'ºC'),
	(19402, 110, '2015-01-15 00:45:29.000000', 'temperatura', 515.0000, 'ºC'),
	(19403, 110, '2015-01-15 00:45:30.000000', 'temperatura', 773.0000, 'ºC'),
	(19404, 110, '2015-01-15 00:45:31.000000', 'temperatura', 1121.0000, 'ºC'),
	(19405, 110, '2015-01-15 00:45:32.000000', 'temperatura', 884.0000, 'ºC'),
	(19406, 110, '2015-01-15 00:45:33.000000', 'temperatura', 1057.0000, 'ºC'),
	(19407, 110, '2015-01-15 00:45:34.000000', 'temperatura', 235.0000, 'ºC'),
	(19408, 110, '2015-01-15 00:45:35.000000', 'temperatura', 406.0000, 'ºC'),
	(19409, 110, '2015-01-15 00:45:36.000000', 'temperatura', 125.0000, 'ºC'),
	(19410, 110, '2015-01-15 00:45:37.000000', 'temperatura', 609.0000, 'ºC'),
	(19411, 110, '2015-01-15 00:45:38.000000', 'temperatura', 268.0000, 'ºC'),
	(19412, 110, '2015-01-15 00:45:39.000000', 'temperatura', 715.0000, 'ºC'),
	(19413, 110, '2015-01-15 00:45:40.000000', 'temperatura', 370.0000, 'ºC'),
	(19414, 110, '2015-01-15 00:45:41.000000', 'temperatura', 908.0000, 'ºC'),
	(19415, 110, '2015-01-15 00:45:42.000000', 'temperatura', 1030.0000, 'ºC'),
	(19416, 110, '2015-01-15 00:45:43.000000', 'temperatura', 24.0000, 'ºC'),
	(19417, 110, '2015-01-15 00:45:44.000000', 'temperatura', 633.0000, 'ºC'),
	(19418, 110, '2015-01-15 00:45:45.000000', 'temperatura', 692.0000, 'ºC'),
	(19419, 110, '2015-01-15 00:45:46.000000', 'temperatura', 362.0000, 'ºC'),
	(19420, 110, '2015-01-15 00:45:47.000000', 'temperatura', 933.0000, 'ºC'),
	(19421, 110, '2015-01-15 00:45:48.000000', 'temperatura', 1179.0000, 'ºC'),
	(19422, 110, '2015-01-15 00:45:49.000000', 'temperatura', 699.0000, 'ºC'),
	(19423, 110, '2015-01-15 00:45:50.000000', 'temperatura', 1159.0000, 'ºC'),
	(19424, 110, '2015-01-15 00:45:51.000000', 'temperatura', 96.0000, 'ºC'),
	(19425, 110, '2015-01-15 00:45:52.000000', 'temperatura', 602.0000, 'ºC'),
	(19426, 110, '2015-01-15 00:45:53.000000', 'temperatura', 326.0000, 'ºC'),
	(19427, 110, '2015-01-15 00:45:54.000000', 'temperatura', 1023.0000, 'ºC'),
	(19428, 110, '2015-01-15 00:45:55.000000', 'temperatura', 537.0000, 'ºC'),
	(19429, 110, '2015-01-15 00:45:56.000000', 'temperatura', 817.0000, 'ºC'),
	(19430, 110, '2015-01-15 00:45:57.000000', 'temperatura', 76.0000, 'ºC'),
	(19431, 110, '2015-01-15 00:45:58.000000', 'temperatura', 330.0000, 'ºC'),
	(19432, 110, '2015-01-15 00:45:59.000000', 'temperatura', 220.0000, 'ºC'),
	(19433, 110, '2015-01-15 00:46:00.000000', 'temperatura', 113.0000, 'ºC'),
	(19434, 110, '2015-01-15 00:46:01.000000', 'temperatura', 1106.0000, 'ºC'),
	(19435, 110, '2015-01-15 00:46:02.000000', 'temperatura', 390.0000, 'ºC'),
	(19436, 110, '2015-01-15 00:46:03.000000', 'temperatura', 1034.0000, 'ºC'),
	(19437, 110, '2015-01-15 00:46:04.000000', 'temperatura', 399.0000, 'ºC'),
	(19438, 110, '2015-01-15 00:46:05.000000', 'temperatura', 95.0000, 'ºC'),
	(19439, 110, '2015-01-15 00:46:06.000000', 'temperatura', 477.0000, 'ºC'),
	(19440, 110, '2015-01-15 00:46:07.000000', 'temperatura', 903.0000, 'ºC'),
	(19441, 110, '2015-01-15 00:46:08.000000', 'temperatura', 682.0000, 'ºC'),
	(19442, 110, '2015-01-15 00:46:09.000000', 'temperatura', 704.0000, 'ºC'),
	(19443, 110, '2015-01-15 00:46:10.000000', 'temperatura', 274.0000, 'ºC'),
	(19444, 110, '2015-01-15 00:46:11.000000', 'temperatura', 459.0000, 'ºC'),
	(19445, 110, '2015-01-15 00:46:12.000000', 'temperatura', 273.0000, 'ºC'),
	(19446, 110, '2015-01-15 00:46:13.000000', 'temperatura', 1190.0000, 'ºC'),
	(19447, 110, '2015-01-15 00:46:14.000000', 'temperatura', 332.0000, 'ºC'),
	(19448, 110, '2015-01-15 00:46:15.000000', 'temperatura', 489.0000, 'ºC'),
	(19449, 110, '2015-01-15 00:46:16.000000', 'temperatura', 251.0000, 'ºC'),
	(19450, 110, '2015-01-15 00:46:17.000000', 'temperatura', 987.0000, 'ºC'),
	(19451, 110, '2015-01-15 00:46:18.000000', 'temperatura', 584.0000, 'ºC'),
	(19452, 110, '2015-01-15 00:46:19.000000', 'temperatura', 1157.0000, 'ºC'),
	(19453, 110, '2015-01-15 00:46:20.000000', 'temperatura', 434.0000, 'ºC'),
	(19454, 110, '2015-01-15 00:46:21.000000', 'temperatura', 1100.0000, 'ºC'),
	(19455, 110, '2015-01-15 00:46:22.000000', 'temperatura', 596.0000, 'ºC'),
	(19456, 110, '2015-01-15 00:46:23.000000', 'temperatura', 884.0000, 'ºC'),
	(19457, 110, '2015-01-15 00:46:24.000000', 'temperatura', 230.0000, 'ºC'),
	(19458, 110, '2015-01-15 00:46:25.000000', 'temperatura', 901.0000, 'ºC'),
	(19459, 110, '2015-01-15 00:46:26.000000', 'temperatura', 216.0000, 'ºC'),
	(19460, 110, '2015-01-15 00:46:27.000000', 'temperatura', 778.0000, 'ºC'),
	(19461, 110, '2015-01-15 00:46:28.000000', 'temperatura', 840.0000, 'ºC'),
	(19462, 110, '2015-01-15 00:46:29.000000', 'temperatura', 667.0000, 'ºC'),
	(19463, 110, '2015-01-15 00:46:30.000000', 'temperatura', 815.0000, 'ºC'),
	(19464, 110, '2015-01-15 00:46:31.000000', 'temperatura', 877.0000, 'ºC'),
	(19465, 110, '2015-01-15 00:46:32.000000', 'temperatura', 738.0000, 'ºC'),
	(19466, 110, '2015-01-15 00:46:33.000000', 'temperatura', 1061.0000, 'ºC'),
	(19467, 110, '2015-01-15 00:46:34.000000', 'temperatura', 692.0000, 'ºC'),
	(19468, 110, '2015-01-15 00:46:35.000000', 'temperatura', 277.0000, 'ºC'),
	(19469, 110, '2015-01-15 00:46:36.000000', 'temperatura', 509.0000, 'ºC'),
	(19470, 110, '2015-01-15 00:46:37.000000', 'temperatura', 515.0000, 'ºC'),
	(19471, 110, '2015-01-15 00:46:38.000000', 'temperatura', 1050.0000, 'ºC'),
	(19472, 110, '2015-01-15 00:46:39.000000', 'temperatura', 103.0000, 'ºC'),
	(19473, 110, '2015-01-15 00:46:40.000000', 'temperatura', 965.0000, 'ºC'),
	(19474, 110, '2015-01-15 00:46:41.000000', 'temperatura', 919.0000, 'ºC'),
	(19475, 110, '2015-01-15 00:46:42.000000', 'temperatura', 498.0000, 'ºC'),
	(19476, 110, '2015-01-15 00:46:43.000000', 'temperatura', 934.0000, 'ºC'),
	(19477, 110, '2015-01-15 00:46:44.000000', 'temperatura', 778.0000, 'ºC'),
	(19478, 110, '2015-01-15 00:46:45.000000', 'temperatura', 1086.0000, 'ºC'),
	(19479, 110, '2015-01-15 00:46:46.000000', 'temperatura', 697.0000, 'ºC'),
	(19480, 110, '2015-01-15 00:46:47.000000', 'temperatura', 227.0000, 'ºC'),
	(19481, 110, '2015-01-15 00:46:48.000000', 'temperatura', 247.0000, 'ºC'),
	(19482, 110, '2015-01-15 00:46:49.000000', 'temperatura', 552.0000, 'ºC'),
	(19483, 110, '2015-01-15 00:46:50.000000', 'temperatura', 821.0000, 'ºC'),
	(19484, 110, '2015-01-15 00:46:51.000000', 'temperatura', 51.0000, 'ºC'),
	(19485, 110, '2015-01-15 00:46:52.000000', 'temperatura', 191.0000, 'ºC'),
	(19486, 110, '2015-01-15 00:46:53.000000', 'temperatura', 803.0000, 'ºC'),
	(19487, 110, '2015-01-15 00:46:54.000000', 'temperatura', 1042.0000, 'ºC'),
	(19488, 110, '2015-01-15 00:46:55.000000', 'temperatura', 400.0000, 'ºC'),
	(19489, 110, '2015-01-15 00:46:56.000000', 'temperatura', 74.0000, 'ºC'),
	(19490, 110, '2015-01-15 00:46:57.000000', 'temperatura', 373.0000, 'ºC'),
	(19491, 110, '2015-01-15 00:46:58.000000', 'temperatura', 442.0000, 'ºC'),
	(19492, 110, '2015-01-15 00:46:59.000000', 'temperatura', 1090.0000, 'ºC'),
	(19493, 110, '2015-01-15 00:47:00.000000', 'temperatura', 525.0000, 'ºC'),
	(19494, 110, '2015-01-15 00:47:01.000000', 'temperatura', 556.0000, 'ºC'),
	(19495, 110, '2015-01-15 00:47:02.000000', 'temperatura', 4.0000, 'ºC'),
	(19496, 110, '2015-01-15 00:47:03.000000', 'temperatura', 755.0000, 'ºC'),
	(19497, 110, '2015-01-15 00:47:04.000000', 'temperatura', 165.0000, 'ºC'),
	(19498, 110, '2015-01-15 00:47:05.000000', 'temperatura', 957.0000, 'ºC'),
	(19499, 110, '2015-01-15 00:47:06.000000', 'temperatura', 692.0000, 'ºC'),
	(19500, 110, '2015-01-15 00:47:07.000000', 'temperatura', 588.0000, 'ºC'),
	(19501, 110, '2015-01-15 00:47:08.000000', 'temperatura', 867.0000, 'ºC'),
	(19502, 110, '2015-01-15 00:47:09.000000', 'temperatura', 170.0000, 'ºC'),
	(19503, 110, '2015-01-15 00:47:10.000000', 'temperatura', 650.0000, 'ºC'),
	(19504, 110, '2015-01-15 00:47:11.000000', 'temperatura', 342.0000, 'ºC'),
	(19505, 110, '2015-01-15 00:47:12.000000', 'temperatura', 959.0000, 'ºC'),
	(19506, 110, '2015-01-15 00:47:13.000000', 'temperatura', 169.0000, 'ºC'),
	(19507, 110, '2015-01-15 00:47:14.000000', 'temperatura', 367.0000, 'ºC'),
	(19508, 110, '2015-01-15 00:47:15.000000', 'temperatura', 132.0000, 'ºC'),
	(19509, 110, '2015-01-15 00:47:16.000000', 'temperatura', 758.0000, 'ºC'),
	(19510, 110, '2015-01-15 00:47:17.000000', 'temperatura', 994.0000, 'ºC'),
	(19511, 110, '2015-01-15 00:47:18.000000', 'temperatura', 296.0000, 'ºC'),
	(19512, 110, '2015-01-15 00:47:19.000000', 'temperatura', 899.0000, 'ºC'),
	(19513, 110, '2015-01-15 00:47:20.000000', 'temperatura', 8.0000, 'ºC'),
	(19514, 110, '2015-01-15 00:47:21.000000', 'temperatura', 942.0000, 'ºC'),
	(19515, 110, '2015-01-15 00:47:22.000000', 'temperatura', 1089.0000, 'ºC'),
	(19516, 110, '2015-01-15 00:47:23.000000', 'temperatura', 216.0000, 'ºC'),
	(19517, 110, '2015-01-15 00:47:24.000000', 'temperatura', 216.0000, 'ºC'),
	(19518, 110, '2015-01-15 00:47:25.000000', 'temperatura', 432.0000, 'ºC'),
	(19519, 110, '2015-01-15 00:47:26.000000', 'temperatura', 312.0000, 'ºC'),
	(19520, 110, '2015-01-15 00:47:27.000000', 'temperatura', 263.0000, 'ºC'),
	(19521, 110, '2015-01-15 00:47:28.000000', 'temperatura', 381.0000, 'ºC'),
	(19522, 110, '2015-01-15 00:47:29.000000', 'temperatura', 1118.0000, 'ºC'),
	(19523, 110, '2015-01-15 00:47:30.000000', 'temperatura', 844.0000, 'ºC'),
	(19524, 110, '2015-01-15 00:47:31.000000', 'temperatura', 869.0000, 'ºC'),
	(19525, 110, '2015-01-15 00:47:32.000000', 'temperatura', 613.0000, 'ºC'),
	(19526, 110, '2015-01-15 00:47:33.000000', 'temperatura', 460.0000, 'ºC'),
	(19527, 110, '2015-01-15 00:47:34.000000', 'temperatura', 460.0000, 'ºC'),
	(19528, 110, '2015-01-15 00:47:35.000000', 'temperatura', 921.0000, 'ºC'),
	(19529, 110, '2015-01-15 00:47:36.000000', 'temperatura', 826.0000, 'ºC'),
	(19530, 110, '2015-01-15 00:47:37.000000', 'temperatura', 166.0000, 'ºC'),
	(19531, 110, '2015-01-15 00:47:38.000000', 'temperatura', 755.0000, 'ºC'),
	(19532, 110, '2015-01-15 00:47:39.000000', 'temperatura', 876.0000, 'ºC'),
	(19533, 110, '2015-01-15 00:47:40.000000', 'temperatura', 914.0000, 'ºC'),
	(19534, 110, '2015-01-15 00:47:41.000000', 'temperatura', 745.0000, 'ºC'),
	(19535, 110, '2015-01-15 00:47:42.000000', 'temperatura', 983.0000, 'ºC'),
	(19536, 110, '2015-01-15 00:47:43.000000', 'temperatura', 280.0000, 'ºC'),
	(19537, 110, '2015-01-15 00:47:44.000000', 'temperatura', 852.0000, 'ºC'),
	(19538, 110, '2015-01-15 00:47:45.000000', 'temperatura', 1019.0000, 'ºC'),
	(19539, 110, '2015-01-15 00:47:46.000000', 'temperatura', 138.0000, 'ºC'),
	(19540, 110, '2015-01-15 00:47:47.000000', 'temperatura', 37.0000, 'ºC'),
	(19541, 110, '2015-01-15 00:47:48.000000', 'temperatura', 971.0000, 'ºC'),
	(19542, 110, '2015-01-15 00:47:49.000000', 'temperatura', 1145.0000, 'ºC'),
	(19543, 110, '2015-01-15 00:47:50.000000', 'temperatura', 412.0000, 'ºC'),
	(19544, 110, '2015-01-15 00:47:51.000000', 'temperatura', 1027.0000, 'ºC'),
	(19545, 110, '2015-01-15 00:47:52.000000', 'temperatura', 300.0000, 'ºC'),
	(19546, 110, '2015-01-15 00:47:53.000000', 'temperatura', 816.0000, 'ºC'),
	(19547, 110, '2015-01-15 00:47:54.000000', 'temperatura', 784.0000, 'ºC'),
	(19548, 110, '2015-01-15 00:47:55.000000', 'temperatura', 272.0000, 'ºC'),
	(19549, 110, '2015-01-15 00:47:56.000000', 'temperatura', 207.0000, 'ºC'),
	(19550, 110, '2015-01-15 00:47:57.000000', 'temperatura', 219.0000, 'ºC'),
	(19551, 110, '2015-01-15 00:47:58.000000', 'temperatura', 476.0000, 'ºC'),
	(19552, 110, '2015-01-15 00:47:59.000000', 'temperatura', 523.0000, 'ºC'),
	(19553, 110, '2015-01-15 00:48:00.000000', 'temperatura', 1187.0000, 'ºC'),
	(19554, 110, '2015-01-15 00:48:01.000000', 'temperatura', 768.0000, 'ºC'),
	(19555, 110, '2015-01-15 00:48:02.000000', 'temperatura', 280.0000, 'ºC'),
	(19556, 110, '2015-01-15 00:48:03.000000', 'temperatura', 295.0000, 'ºC'),
	(19557, 110, '2015-01-15 00:48:04.000000', 'temperatura', 636.0000, 'ºC'),
	(19558, 110, '2015-01-15 00:48:05.000000', 'temperatura', 1096.0000, 'ºC'),
	(19559, 110, '2015-01-15 00:48:06.000000', 'temperatura', 1172.0000, 'ºC'),
	(19560, 110, '2015-01-15 00:48:07.000000', 'temperatura', 174.0000, 'ºC'),
	(19561, 110, '2015-01-15 00:48:08.000000', 'temperatura', 955.0000, 'ºC'),
	(19562, 110, '2015-01-15 00:48:09.000000', 'temperatura', 651.0000, 'ºC'),
	(19563, 110, '2015-01-15 00:48:10.000000', 'temperatura', 393.0000, 'ºC'),
	(19564, 110, '2015-01-15 00:48:11.000000', 'temperatura', 13.0000, 'ºC'),
	(19565, 110, '2015-01-15 00:48:12.000000', 'temperatura', 87.0000, 'ºC'),
	(19566, 110, '2015-01-15 00:48:13.000000', 'temperatura', 396.0000, 'ºC'),
	(19567, 110, '2015-01-15 00:48:14.000000', 'temperatura', 521.0000, 'ºC'),
	(19568, 110, '2015-01-15 00:48:15.000000', 'temperatura', 217.0000, 'ºC'),
	(19569, 110, '2015-01-15 00:48:16.000000', 'temperatura', 722.0000, 'ºC'),
	(19570, 110, '2015-01-15 00:48:17.000000', 'temperatura', 560.0000, 'ºC'),
	(19571, 110, '2015-01-15 00:48:18.000000', 'temperatura', 633.0000, 'ºC'),
	(19572, 110, '2015-01-15 00:48:19.000000', 'temperatura', 285.0000, 'ºC'),
	(19573, 110, '2015-01-15 00:48:20.000000', 'temperatura', 728.0000, 'ºC'),
	(19574, 110, '2015-01-15 00:48:21.000000', 'temperatura', 384.0000, 'ºC'),
	(19575, 110, '2015-01-15 00:48:22.000000', 'temperatura', 939.0000, 'ºC'),
	(19576, 110, '2015-01-15 00:48:23.000000', 'temperatura', 1141.0000, 'ºC'),
	(19577, 110, '2015-01-15 00:48:24.000000', 'temperatura', 489.0000, 'ºC'),
	(19578, 110, '2015-01-15 00:48:25.000000', 'temperatura', 222.0000, 'ºC'),
	(19579, 110, '2015-01-15 00:48:26.000000', 'temperatura', 845.0000, 'ºC'),
	(19580, 110, '2015-01-15 00:48:27.000000', 'temperatura', 1157.0000, 'ºC'),
	(19581, 110, '2015-01-15 00:48:28.000000', 'temperatura', 854.0000, 'ºC'),
	(19582, 110, '2015-01-15 00:48:29.000000', 'temperatura', 796.0000, 'ºC'),
	(19583, 110, '2015-01-15 00:48:30.000000', 'temperatura', 219.0000, 'ºC'),
	(19584, 110, '2015-01-15 00:48:31.000000', 'temperatura', 1110.0000, 'ºC'),
	(19585, 110, '2015-01-15 00:48:32.000000', 'temperatura', 91.0000, 'ºC'),
	(19586, 110, '2015-01-15 00:48:33.000000', 'temperatura', 728.0000, 'ºC'),
	(19587, 110, '2015-01-15 00:48:34.000000', 'temperatura', 966.0000, 'ºC'),
	(19588, 110, '2015-01-15 00:48:35.000000', 'temperatura', 246.0000, 'ºC'),
	(19589, 110, '2015-01-15 00:48:36.000000', 'temperatura', 734.0000, 'ºC'),
	(19590, 110, '2015-01-15 00:48:37.000000', 'temperatura', 533.0000, 'ºC'),
	(19591, 110, '2015-01-15 00:48:38.000000', 'temperatura', 461.0000, 'ºC'),
	(19592, 110, '2015-01-15 00:48:39.000000', 'temperatura', 709.0000, 'ºC'),
	(19593, 110, '2015-01-15 00:48:40.000000', 'temperatura', 964.0000, 'ºC'),
	(19594, 110, '2015-01-15 00:48:41.000000', 'temperatura', 290.0000, 'ºC'),
	(19595, 110, '2015-01-15 00:48:42.000000', 'temperatura', 962.0000, 'ºC'),
	(19596, 110, '2015-01-15 00:48:43.000000', 'temperatura', 337.0000, 'ºC'),
	(19597, 110, '2015-01-15 00:48:44.000000', 'temperatura', 3.0000, 'ºC'),
	(19598, 110, '2015-01-15 00:48:45.000000', 'temperatura', 201.0000, 'ºC'),
	(19599, 110, '2015-01-15 00:48:46.000000', 'temperatura', 999.0000, 'ºC'),
	(19600, 110, '2015-01-15 00:48:47.000000', 'temperatura', 791.0000, 'ºC'),
	(19601, 110, '2015-01-15 00:48:48.000000', 'temperatura', 959.0000, 'ºC'),
	(19602, 110, '2015-01-15 00:48:49.000000', 'temperatura', 24.0000, 'ºC'),
	(19603, 110, '2015-01-15 00:48:50.000000', 'temperatura', 843.0000, 'ºC'),
	(19604, 110, '2015-01-15 00:48:51.000000', 'temperatura', 544.0000, 'ºC'),
	(19605, 110, '2015-01-15 00:48:52.000000', 'temperatura', 190.0000, 'ºC'),
	(19606, 110, '2015-01-15 00:48:53.000000', 'temperatura', 519.0000, 'ºC'),
	(19607, 110, '2015-01-15 00:48:54.000000', 'temperatura', 827.0000, 'ºC'),
	(19608, 110, '2015-01-15 00:48:55.000000', 'temperatura', 177.0000, 'ºC'),
	(19609, 110, '2015-01-15 00:48:56.000000', 'temperatura', 805.0000, 'ºC'),
	(19610, 110, '2015-01-15 00:48:57.000000', 'temperatura', 1096.0000, 'ºC'),
	(19611, 110, '2015-01-15 00:48:58.000000', 'temperatura', 663.0000, 'ºC'),
	(19612, 110, '2015-01-15 00:48:59.000000', 'temperatura', 29.0000, 'ºC'),
	(19613, 110, '2015-01-15 00:49:00.000000', 'temperatura', 556.0000, 'ºC'),
	(19614, 110, '2015-01-15 00:49:01.000000', 'temperatura', 292.0000, 'ºC'),
	(19615, 110, '2015-01-15 00:49:02.000000', 'temperatura', 992.0000, 'ºC'),
	(19616, 110, '2015-01-15 00:49:03.000000', 'temperatura', 486.0000, 'ºC'),
	(19617, 110, '2015-01-15 00:49:04.000000', 'temperatura', 655.0000, 'ºC'),
	(19618, 110, '2015-01-15 00:49:05.000000', 'temperatura', 617.0000, 'ºC'),
	(19619, 110, '2015-01-15 00:49:06.000000', 'temperatura', 1119.0000, 'ºC'),
	(19620, 110, '2015-01-15 00:49:07.000000', 'temperatura', 146.0000, 'ºC'),
	(19621, 110, '2015-01-15 00:49:08.000000', 'temperatura', 973.0000, 'ºC'),
	(19622, 110, '2015-01-15 00:49:09.000000', 'temperatura', 829.0000, 'ºC'),
	(19623, 110, '2015-01-15 00:49:10.000000', 'temperatura', 24.0000, 'ºC'),
	(19624, 110, '2015-01-15 00:49:11.000000', 'temperatura', 34.0000, 'ºC'),
	(19625, 110, '2015-01-15 00:49:12.000000', 'temperatura', 99.0000, 'ºC'),
	(19626, 110, '2015-01-15 00:49:13.000000', 'temperatura', 395.0000, 'ºC'),
	(19627, 110, '2015-01-15 00:49:14.000000', 'temperatura', 478.0000, 'ºC'),
	(19628, 110, '2015-01-15 00:49:15.000000', 'temperatura', 4.0000, 'ºC'),
	(19629, 110, '2015-01-15 00:49:16.000000', 'temperatura', 987.0000, 'ºC'),
	(19630, 110, '2015-01-15 00:49:17.000000', 'temperatura', 122.0000, 'ºC'),
	(19631, 110, '2015-01-15 00:49:18.000000', 'temperatura', 53.0000, 'ºC'),
	(19632, 110, '2015-01-15 00:49:19.000000', 'temperatura', 1097.0000, 'ºC'),
	(19633, 110, '2015-01-15 00:49:20.000000', 'temperatura', 526.0000, 'ºC'),
	(19634, 110, '2015-01-15 00:49:21.000000', 'temperatura', 539.0000, 'ºC'),
	(19635, 110, '2015-01-15 00:49:22.000000', 'temperatura', 1119.0000, 'ºC'),
	(19636, 110, '2015-01-15 00:49:23.000000', 'temperatura', 379.0000, 'ºC'),
	(19637, 110, '2015-01-15 00:49:24.000000', 'temperatura', 940.0000, 'ºC'),
	(19638, 110, '2015-01-15 00:49:25.000000', 'temperatura', 1160.0000, 'ºC'),
	(19639, 110, '2015-01-15 00:49:26.000000', 'temperatura', 584.0000, 'ºC'),
	(19640, 110, '2015-01-15 00:49:27.000000', 'temperatura', 637.0000, 'ºC'),
	(19641, 110, '2015-01-15 00:49:28.000000', 'temperatura', 235.0000, 'ºC'),
	(19642, 110, '2015-01-15 00:49:29.000000', 'temperatura', 465.0000, 'ºC'),
	(19643, 110, '2015-01-15 00:49:30.000000', 'temperatura', 422.0000, 'ºC'),
	(19644, 110, '2015-01-15 00:49:31.000000', 'temperatura', 713.0000, 'ºC'),
	(19645, 110, '2015-01-15 00:49:32.000000', 'temperatura', 1099.0000, 'ºC'),
	(19646, 110, '2015-01-15 00:49:33.000000', 'temperatura', 957.0000, 'ºC'),
	(19647, 110, '2015-01-15 00:49:34.000000', 'temperatura', 290.0000, 'ºC'),
	(19648, 110, '2015-01-15 00:49:35.000000', 'temperatura', 979.0000, 'ºC'),
	(19649, 110, '2015-01-15 00:49:36.000000', 'temperatura', 425.0000, 'ºC'),
	(19650, 110, '2015-01-15 00:49:37.000000', 'temperatura', 387.0000, 'ºC'),
	(19651, 110, '2015-01-15 00:49:38.000000', 'temperatura', 661.0000, 'ºC'),
	(19652, 110, '2015-01-15 00:49:39.000000', 'temperatura', 943.0000, 'ºC'),
	(19653, 110, '2015-01-15 00:49:40.000000', 'temperatura', 334.0000, 'ºC'),
	(19654, 110, '2015-01-15 00:49:41.000000', 'temperatura', 43.0000, 'ºC'),
	(19655, 110, '2015-01-15 00:49:42.000000', 'temperatura', 412.0000, 'ºC'),
	(19656, 110, '2015-01-15 00:49:43.000000', 'temperatura', 732.0000, 'ºC'),
	(19657, 110, '2015-01-15 00:49:44.000000', 'temperatura', 22.0000, 'ºC'),
	(19658, 110, '2015-01-15 00:49:45.000000', 'temperatura', 318.0000, 'ºC'),
	(19659, 110, '2015-01-15 00:49:46.000000', 'temperatura', 322.0000, 'ºC'),
	(19660, 110, '2015-01-15 00:49:47.000000', 'temperatura', 657.0000, 'ºC'),
	(19661, 110, '2015-01-15 00:49:48.000000', 'temperatura', 1120.0000, 'ºC'),
	(19662, 110, '2015-01-15 00:49:49.000000', 'temperatura', 27.0000, 'ºC'),
	(19663, 110, '2015-01-15 00:49:50.000000', 'temperatura', 378.0000, 'ºC'),
	(19664, 110, '2015-01-15 00:49:51.000000', 'temperatura', 610.0000, 'ºC'),
	(19665, 110, '2015-01-15 00:49:52.000000', 'temperatura', 717.0000, 'ºC'),
	(19666, 110, '2015-01-15 00:49:53.000000', 'temperatura', 555.0000, 'ºC'),
	(19667, 110, '2015-01-15 00:49:54.000000', 'temperatura', 626.0000, 'ºC'),
	(19668, 110, '2015-01-15 00:49:55.000000', 'temperatura', 264.0000, 'ºC'),
	(19669, 110, '2015-01-15 00:49:56.000000', 'temperatura', 643.0000, 'ºC'),
	(19670, 110, '2015-01-15 00:49:57.000000', 'temperatura', 22.0000, 'ºC'),
	(19671, 110, '2015-01-15 00:49:58.000000', 'temperatura', 581.0000, 'ºC'),
	(19672, 110, '2015-01-15 00:49:59.000000', 'temperatura', 441.0000, 'ºC'),
	(19673, 110, '2015-01-15 00:50:00.000000', 'temperatura', 464.0000, 'ºC'),
	(19674, 110, '2015-01-15 00:50:01.000000', 'temperatura', 997.0000, 'ºC'),
	(19675, 110, '2015-01-15 00:50:02.000000', 'temperatura', 1191.0000, 'ºC'),
	(19676, 110, '2015-01-15 00:50:03.000000', 'temperatura', 565.0000, 'ºC'),
	(19677, 110, '2015-01-15 00:50:04.000000', 'temperatura', 455.0000, 'ºC'),
	(19678, 110, '2015-01-15 00:50:05.000000', 'temperatura', 577.0000, 'ºC'),
	(19679, 110, '2015-01-15 00:50:06.000000', 'temperatura', 324.0000, 'ºC'),
	(19680, 110, '2015-01-15 00:50:07.000000', 'temperatura', 1086.0000, 'ºC'),
	(19681, 110, '2015-01-15 00:50:08.000000', 'temperatura', 862.0000, 'ºC'),
	(19682, 110, '2015-01-15 00:50:09.000000', 'temperatura', 1051.0000, 'ºC'),
	(19683, 110, '2015-01-15 00:50:10.000000', 'temperatura', 269.0000, 'ºC'),
	(19684, 110, '2015-01-15 00:50:11.000000', 'temperatura', 595.0000, 'ºC'),
	(19685, 110, '2015-01-15 00:50:12.000000', 'temperatura', 966.0000, 'ºC'),
	(19686, 110, '2015-01-15 00:50:13.000000', 'temperatura', 647.0000, 'ºC'),
	(19687, 110, '2015-01-15 00:50:14.000000', 'temperatura', 336.0000, 'ºC'),
	(19688, 110, '2015-01-15 00:50:15.000000', 'temperatura', 939.0000, 'ºC'),
	(19689, 110, '2015-01-15 00:50:16.000000', 'temperatura', 89.0000, 'ºC'),
	(19690, 110, '2015-01-15 00:50:17.000000', 'temperatura', 29.0000, 'ºC'),
	(19691, 110, '2015-01-15 00:50:18.000000', 'temperatura', 1077.0000, 'ºC'),
	(19692, 110, '2015-01-15 00:50:19.000000', 'temperatura', 501.0000, 'ºC'),
	(19693, 110, '2015-01-15 00:50:20.000000', 'temperatura', 473.0000, 'ºC'),
	(19694, 110, '2015-01-15 00:50:21.000000', 'temperatura', 864.0000, 'ºC'),
	(19695, 110, '2015-01-15 00:50:22.000000', 'temperatura', 502.0000, 'ºC'),
	(19696, 110, '2015-01-15 00:50:23.000000', 'temperatura', 1118.0000, 'ºC'),
	(19697, 110, '2015-01-15 00:50:24.000000', 'temperatura', 486.0000, 'ºC'),
	(19698, 110, '2015-01-15 00:50:25.000000', 'temperatura', 274.0000, 'ºC'),
	(19699, 110, '2015-01-15 00:50:26.000000', 'temperatura', 1113.0000, 'ºC'),
	(19700, 110, '2015-01-15 00:50:27.000000', 'temperatura', 1142.0000, 'ºC'),
	(19701, 110, '2015-01-15 00:50:28.000000', 'temperatura', 1174.0000, 'ºC'),
	(19702, 110, '2015-01-15 00:50:29.000000', 'temperatura', 45.0000, 'ºC'),
	(19703, 110, '2015-01-15 00:50:30.000000', 'temperatura', 303.0000, 'ºC'),
	(19704, 110, '2015-01-15 00:50:31.000000', 'temperatura', 179.0000, 'ºC'),
	(19705, 110, '2015-01-15 00:50:32.000000', 'temperatura', 1186.0000, 'ºC'),
	(19706, 110, '2015-01-15 00:50:33.000000', 'temperatura', 593.0000, 'ºC'),
	(19707, 110, '2015-01-15 00:50:34.000000', 'temperatura', 608.0000, 'ºC'),
	(19708, 110, '2015-01-15 00:50:35.000000', 'temperatura', 64.0000, 'ºC'),
	(19709, 110, '2015-01-15 00:50:36.000000', 'temperatura', 894.0000, 'ºC'),
	(19710, 110, '2015-01-15 00:50:37.000000', 'temperatura', 678.0000, 'ºC'),
	(19711, 110, '2015-01-15 00:50:38.000000', 'temperatura', 709.0000, 'ºC'),
	(19712, 110, '2015-01-15 00:50:39.000000', 'temperatura', 310.0000, 'ºC'),
	(19713, 110, '2015-01-15 00:50:40.000000', 'temperatura', 626.0000, 'ºC'),
	(19714, 110, '2015-01-15 00:50:41.000000', 'temperatura', 998.0000, 'ºC'),
	(19715, 110, '2015-01-15 00:50:42.000000', 'temperatura', 714.0000, 'ºC'),
	(19716, 110, '2015-01-15 00:50:43.000000', 'temperatura', 577.0000, 'ºC'),
	(19717, 110, '2015-01-15 00:50:44.000000', 'temperatura', 742.0000, 'ºC'),
	(19718, 110, '2015-01-15 00:50:45.000000', 'temperatura', 780.0000, 'ºC'),
	(19719, 110, '2015-01-15 00:50:46.000000', 'temperatura', 477.0000, 'ºC'),
	(19720, 110, '2015-01-15 00:50:47.000000', 'temperatura', 42.0000, 'ºC'),
	(19721, 110, '2015-01-15 00:50:48.000000', 'temperatura', 1181.0000, 'ºC'),
	(19722, 110, '2015-01-15 00:50:49.000000', 'temperatura', 978.0000, 'ºC'),
	(19723, 110, '2015-01-15 00:50:50.000000', 'temperatura', 149.0000, 'ºC'),
	(19724, 110, '2015-01-15 00:50:51.000000', 'temperatura', 212.0000, 'ºC'),
	(19725, 110, '2015-01-15 00:50:52.000000', 'temperatura', 612.0000, 'ºC'),
	(19726, 110, '2015-01-15 00:50:53.000000', 'temperatura', 24.0000, 'ºC'),
	(19727, 110, '2015-01-15 00:50:54.000000', 'temperatura', 686.0000, 'ºC'),
	(19728, 110, '2015-01-15 00:50:55.000000', 'temperatura', 960.0000, 'ºC'),
	(19729, 110, '2015-01-15 00:50:56.000000', 'temperatura', 341.0000, 'ºC'),
	(19730, 110, '2015-01-15 00:50:57.000000', 'temperatura', 26.0000, 'ºC'),
	(19731, 110, '2015-01-15 00:50:58.000000', 'temperatura', 306.0000, 'ºC'),
	(19732, 110, '2015-01-15 00:50:59.000000', 'temperatura', 252.0000, 'ºC'),
	(19733, 110, '2015-01-15 00:51:00.000000', 'temperatura', 344.0000, 'ºC'),
	(19734, 110, '2015-01-15 00:51:01.000000', 'temperatura', 965.0000, 'ºC'),
	(19735, 110, '2015-01-15 00:51:02.000000', 'temperatura', 194.0000, 'ºC'),
	(19736, 110, '2015-01-15 00:51:03.000000', 'temperatura', 473.0000, 'ºC'),
	(19737, 110, '2015-01-15 00:51:04.000000', 'temperatura', 583.0000, 'ºC'),
	(19738, 110, '2015-01-15 00:51:05.000000', 'temperatura', 297.0000, 'ºC'),
	(19739, 110, '2015-01-15 00:51:06.000000', 'temperatura', 937.0000, 'ºC'),
	(19740, 110, '2015-01-15 00:51:07.000000', 'temperatura', 196.0000, 'ºC'),
	(19741, 110, '2015-01-15 00:51:08.000000', 'temperatura', 567.0000, 'ºC'),
	(19742, 110, '2015-01-15 00:51:09.000000', 'temperatura', 1050.0000, 'ºC'),
	(19743, 110, '2015-01-15 00:51:10.000000', 'temperatura', 1150.0000, 'ºC'),
	(19744, 110, '2015-01-15 00:51:11.000000', 'temperatura', 198.0000, 'ºC'),
	(19745, 110, '2015-01-15 00:51:12.000000', 'temperatura', 1143.0000, 'ºC'),
	(19746, 110, '2015-01-15 00:51:13.000000', 'temperatura', 322.0000, 'ºC'),
	(19747, 110, '2015-01-15 00:51:14.000000', 'temperatura', 579.0000, 'ºC'),
	(19748, 110, '2015-01-15 00:51:15.000000', 'temperatura', 732.0000, 'ºC'),
	(19749, 110, '2015-01-15 00:51:16.000000', 'temperatura', 722.0000, 'ºC'),
	(19750, 110, '2015-01-15 00:51:17.000000', 'temperatura', 214.0000, 'ºC'),
	(19751, 110, '2015-01-15 00:51:18.000000', 'temperatura', 103.0000, 'ºC'),
	(19752, 110, '2015-01-15 00:51:19.000000', 'temperatura', 1076.0000, 'ºC'),
	(19753, 110, '2015-01-15 00:51:20.000000', 'temperatura', 273.0000, 'ºC'),
	(19754, 110, '2015-01-15 00:51:21.000000', 'temperatura', 534.0000, 'ºC'),
	(19755, 110, '2015-01-15 00:51:22.000000', 'temperatura', 654.0000, 'ºC'),
	(19756, 110, '2015-01-15 00:51:23.000000', 'temperatura', 467.0000, 'ºC'),
	(19757, 110, '2015-01-15 00:51:24.000000', 'temperatura', 372.0000, 'ºC'),
	(19758, 110, '2015-01-15 00:51:25.000000', 'temperatura', 461.0000, 'ºC'),
	(19759, 110, '2015-01-15 00:51:26.000000', 'temperatura', 1190.0000, 'ºC'),
	(19760, 110, '2015-01-15 00:51:27.000000', 'temperatura', 969.0000, 'ºC'),
	(19761, 110, '2015-01-15 00:51:28.000000', 'temperatura', 73.0000, 'ºC'),
	(19762, 110, '2015-01-15 00:51:29.000000', 'temperatura', 1060.0000, 'ºC'),
	(19763, 110, '2015-01-15 00:51:30.000000', 'temperatura', 283.0000, 'ºC'),
	(19764, 110, '2015-01-15 00:51:31.000000', 'temperatura', 633.0000, 'ºC'),
	(19765, 110, '2015-01-15 00:51:32.000000', 'temperatura', 1119.0000, 'ºC'),
	(19766, 110, '2015-01-15 00:51:33.000000', 'temperatura', 96.0000, 'ºC'),
	(19767, 110, '2015-01-15 00:51:34.000000', 'temperatura', 725.0000, 'ºC'),
	(19768, 110, '2015-01-15 00:51:35.000000', 'temperatura', 937.0000, 'ºC'),
	(19769, 110, '2015-01-15 00:51:36.000000', 'temperatura', 109.0000, 'ºC'),
	(19770, 110, '2015-01-15 00:51:37.000000', 'temperatura', 134.0000, 'ºC'),
	(19771, 110, '2015-01-15 00:51:38.000000', 'temperatura', 346.0000, 'ºC'),
	(19772, 110, '2015-01-15 00:51:39.000000', 'temperatura', 128.0000, 'ºC'),
	(19773, 110, '2015-01-15 00:51:40.000000', 'temperatura', 803.0000, 'ºC'),
	(19774, 110, '2015-01-15 00:51:41.000000', 'temperatura', 32.0000, 'ºC'),
	(19775, 110, '2015-01-15 00:51:42.000000', 'temperatura', 153.0000, 'ºC'),
	(19776, 110, '2015-01-15 00:51:43.000000', 'temperatura', 666.0000, 'ºC'),
	(19777, 110, '2015-01-15 00:51:44.000000', 'temperatura', 474.0000, 'ºC'),
	(19778, 110, '2015-01-15 00:51:45.000000', 'temperatura', 373.0000, 'ºC'),
	(19779, 110, '2015-01-15 00:51:46.000000', 'temperatura', 442.0000, 'ºC'),
	(19780, 110, '2015-01-15 00:51:47.000000', 'temperatura', 1091.0000, 'ºC'),
	(19781, 110, '2015-01-15 00:51:48.000000', 'temperatura', 532.0000, 'ºC'),
	(19782, 110, '2015-01-15 00:51:49.000000', 'temperatura', 587.0000, 'ºC'),
	(19783, 110, '2015-01-15 00:51:50.000000', 'temperatura', 139.0000, 'ºC'),
	(19784, 110, '2015-01-15 00:51:51.000000', 'temperatura', 133.0000, 'ºC'),
	(19785, 110, '2015-01-15 00:51:52.000000', 'temperatura', 250.0000, 'ºC'),
	(19786, 110, '2015-01-15 00:51:53.000000', 'temperatura', 850.0000, 'ºC'),
	(19787, 110, '2015-01-15 00:51:54.000000', 'temperatura', 1102.0000, 'ºC'),
	(19788, 110, '2015-01-15 00:51:55.000000', 'temperatura', 560.0000, 'ºC'),
	(19789, 110, '2015-01-15 00:51:56.000000', 'temperatura', 696.0000, 'ºC'),
	(19790, 110, '2015-01-15 00:51:57.000000', 'temperatura', 599.0000, 'ºC'),
	(19791, 110, '2015-01-15 00:51:58.000000', 'temperatura', 908.0000, 'ºC'),
	(19792, 110, '2015-01-15 00:51:59.000000', 'temperatura', 342.0000, 'ºC'),
	(19793, 110, '2015-01-15 00:52:00.000000', 'temperatura', 186.0000, 'ºC'),
	(19794, 110, '2015-01-15 00:52:01.000000', 'temperatura', 1105.0000, 'ºC'),
	(19795, 110, '2015-01-15 00:52:02.000000', 'temperatura', 170.0000, 'ºC'),
	(19796, 110, '2015-01-15 00:52:03.000000', 'temperatura', 1134.0000, 'ºC'),
	(19797, 110, '2015-01-15 00:52:04.000000', 'temperatura', 359.0000, 'ºC'),
	(19798, 110, '2015-01-15 00:52:05.000000', 'temperatura', 794.0000, 'ºC'),
	(19799, 110, '2015-01-15 00:52:06.000000', 'temperatura', 496.0000, 'ºC'),
	(19800, 110, '2015-01-15 00:52:07.000000', 'temperatura', 95.0000, 'ºC'),
	(19801, 110, '2015-01-15 00:52:08.000000', 'temperatura', 189.0000, 'ºC'),
	(19802, 110, '2015-01-15 00:52:09.000000', 'temperatura', 661.0000, 'ºC'),
	(19803, 110, '2015-01-15 00:52:10.000000', 'temperatura', 338.0000, 'ºC'),
	(19804, 110, '2015-01-15 00:52:11.000000', 'temperatura', 909.0000, 'ºC'),
	(19805, 110, '2015-01-15 00:52:12.000000', 'temperatura', 1130.0000, 'ºC'),
	(19806, 110, '2015-01-15 00:52:13.000000', 'temperatura', 526.0000, 'ºC'),
	(19807, 110, '2015-01-15 00:52:14.000000', 'temperatura', 438.0000, 'ºC'),
	(19808, 110, '2015-01-15 00:52:15.000000', 'temperatura', 612.0000, 'ºC'),
	(19809, 110, '2015-01-15 00:52:16.000000', 'temperatura', 546.0000, 'ºC'),
	(19810, 110, '2015-01-15 00:52:17.000000', 'temperatura', 897.0000, 'ºC'),
	(19811, 110, '2015-01-15 00:52:18.000000', 'temperatura', 448.0000, 'ºC'),
	(19812, 110, '2015-01-15 00:52:19.000000', 'temperatura', 749.0000, 'ºC'),
	(19813, 110, '2015-01-15 00:52:20.000000', 'temperatura', 0.0000, 'ºC'),
	(19814, 110, '2015-01-15 00:52:21.000000', 'temperatura', 154.0000, 'ºC'),
	(19815, 110, '2015-01-15 00:52:22.000000', 'temperatura', 772.0000, 'ºC'),
	(19816, 110, '2015-01-15 00:52:23.000000', 'temperatura', 997.0000, 'ºC'),
	(19817, 110, '2015-01-15 00:52:24.000000', 'temperatura', 268.0000, 'ºC'),
	(19818, 110, '2015-01-15 00:52:25.000000', 'temperatura', 751.0000, 'ºC'),
	(19819, 110, '2015-01-15 00:52:26.000000', 'temperatura', 549.0000, 'ºC'),
	(19820, 110, '2015-01-15 00:52:27.000000', 'temperatura', 496.0000, 'ºC'),
	(19821, 110, '2015-01-15 00:52:28.000000', 'temperatura', 831.0000, 'ºC'),
	(19822, 110, '2015-01-15 00:52:29.000000', 'temperatura', 268.0000, 'ºC'),
	(19823, 110, '2015-01-15 00:52:30.000000', 'temperatura', 49.0000, 'ºC'),
	(19824, 110, '2015-01-15 00:52:31.000000', 'temperatura', 641.0000, 'ºC'),
	(19825, 110, '2015-01-15 00:52:32.000000', 'temperatura', 660.0000, 'ºC'),
	(19826, 110, '2015-01-15 00:52:33.000000', 'temperatura', 176.0000, 'ºC'),
	(19827, 110, '2015-01-15 00:52:34.000000', 'temperatura', 101.0000, 'ºC'),
	(19828, 110, '2015-01-15 00:52:35.000000', 'temperatura', 1178.0000, 'ºC'),
	(19829, 110, '2015-01-15 00:52:36.000000', 'temperatura', 785.0000, 'ºC'),
	(19830, 110, '2015-01-15 00:52:37.000000', 'temperatura', 394.0000, 'ºC'),
	(19831, 110, '2015-01-15 00:52:38.000000', 'temperatura', 814.0000, 'ºC'),
	(19832, 110, '2015-01-15 00:52:39.000000', 'temperatura', 488.0000, 'ºC'),
	(19833, 110, '2015-01-15 00:52:40.000000', 'temperatura', 1.0000, 'ºC'),
	(19834, 110, '2015-01-15 00:52:41.000000', 'temperatura', 940.0000, 'ºC'),
	(19835, 110, '2015-01-15 00:52:42.000000', 'temperatura', 1097.0000, 'ºC'),
	(19836, 110, '2015-01-15 00:52:43.000000', 'temperatura', 264.0000, 'ºC'),
	(19837, 110, '2015-01-15 00:52:44.000000', 'temperatura', 430.0000, 'ºC'),
	(19838, 110, '2015-01-15 00:52:45.000000', 'temperatura', 161.0000, 'ºC'),
	(19839, 110, '2015-01-15 00:52:46.000000', 'temperatura', 714.0000, 'ºC'),
	(19840, 110, '2015-01-15 00:52:47.000000', 'temperatura', 686.0000, 'ºC'),
	(19841, 110, '2015-01-15 00:52:48.000000', 'temperatura', 91.0000, 'ºC'),
	(19842, 110, '2015-01-15 00:52:49.000000', 'temperatura', 795.0000, 'ºC'),
	(19843, 110, '2015-01-15 00:52:50.000000', 'temperatura', 102.0000, 'ºC'),
	(19844, 110, '2015-01-15 00:52:51.000000', 'temperatura', 524.0000, 'ºC'),
	(19845, 110, '2015-01-15 00:52:52.000000', 'temperatura', 1118.0000, 'ºC'),
	(19846, 110, '2015-01-15 00:52:53.000000', 'temperatura', 418.0000, 'ºC'),
	(19847, 110, '2015-01-15 00:52:54.000000', 'temperatura', 1138.0000, 'ºC'),
	(19848, 110, '2015-01-15 00:52:55.000000', 'temperatura', 835.0000, 'ºC'),
	(19849, 110, '2015-01-15 00:52:56.000000', 'temperatura', 763.0000, 'ºC'),
	(19850, 110, '2015-01-15 00:52:57.000000', 'temperatura', 110.0000, 'ºC'),
	(19851, 110, '2015-01-15 00:52:58.000000', 'temperatura', 662.0000, 'ºC'),
	(19852, 110, '2015-01-15 00:52:59.000000', 'temperatura', 581.0000, 'ºC'),
	(19853, 110, '2015-01-15 00:53:00.000000', 'temperatura', 918.0000, 'ºC'),
	(19854, 110, '2015-01-15 00:53:01.000000', 'temperatura', 449.0000, 'ºC'),
	(19855, 110, '2015-01-15 00:53:02.000000', 'temperatura', 690.0000, 'ºC'),
	(19856, 110, '2015-01-15 00:53:03.000000', 'temperatura', 903.0000, 'ºC'),
	(19857, 110, '2015-01-15 00:53:04.000000', 'temperatura', 46.0000, 'ºC'),
	(19858, 110, '2015-01-15 00:53:05.000000', 'temperatura', 1123.0000, 'ºC'),
	(19859, 110, '2015-01-15 00:53:06.000000', 'temperatura', 675.0000, 'ºC'),
	(19860, 110, '2015-01-15 00:53:07.000000', 'temperatura', 10.0000, 'ºC'),
	(19861, 110, '2015-01-15 00:53:08.000000', 'temperatura', 422.0000, 'ºC'),
	(19862, 110, '2015-01-15 00:53:09.000000', 'temperatura', 882.0000, 'ºC'),
	(19863, 110, '2015-01-15 00:53:10.000000', 'temperatura', 746.0000, 'ºC'),
	(19864, 110, '2015-01-15 00:53:11.000000', 'temperatura', 1085.0000, 'ºC'),
	(19865, 110, '2015-01-15 00:53:12.000000', 'temperatura', 787.0000, 'ºC'),
	(19866, 110, '2015-01-15 00:53:13.000000', 'temperatura', 679.0000, 'ºC'),
	(19867, 110, '2015-01-15 00:53:14.000000', 'temperatura', 1034.0000, 'ºC'),
	(19868, 110, '2015-01-15 00:53:15.000000', 'temperatura', 735.0000, 'ºC'),
	(19869, 110, '2015-01-15 00:53:16.000000', 'temperatura', 574.0000, 'ºC'),
	(19870, 110, '2015-01-15 00:53:17.000000', 'temperatura', 665.0000, 'ºC'),
	(19871, 110, '2015-01-15 00:53:18.000000', 'temperatura', 402.0000, 'ºC'),
	(19872, 110, '2015-01-15 00:53:19.000000', 'temperatura', 16.0000, 'ºC'),
	(19873, 110, '2015-01-15 00:53:20.000000', 'temperatura', 73.0000, 'ºC'),
	(19874, 110, '2015-01-15 00:53:21.000000', 'temperatura', 321.0000, 'ºC'),
	(19875, 110, '2015-01-15 00:53:22.000000', 'temperatura', 183.0000, 'ºC'),
	(19876, 110, '2015-01-15 00:53:23.000000', 'temperatura', 1155.0000, 'ºC'),
	(19877, 110, '2015-01-15 00:53:24.000000', 'temperatura', 425.0000, 'ºC'),
	(19878, 110, '2015-01-15 00:53:25.000000', 'temperatura', 1062.0000, 'ºC'),
	(19879, 110, '2015-01-15 00:53:26.000000', 'temperatura', 436.0000, 'ºC'),
	(19880, 110, '2015-01-15 00:53:27.000000', 'temperatura', 195.0000, 'ºC'),
	(19881, 110, '2015-01-15 00:53:28.000000', 'temperatura', 867.0000, 'ºC'),
	(19882, 110, '2015-01-15 00:53:29.000000', 'temperatura', 151.0000, 'ºC'),
	(19883, 110, '2015-01-15 00:53:30.000000', 'temperatura', 554.0000, 'ºC'),
	(19884, 110, '2015-01-15 00:53:31.000000', 'temperatura', 1120.0000, 'ºC'),
	(19885, 110, '2015-01-15 00:53:32.000000', 'temperatura', 335.0000, 'ºC'),
	(19886, 110, '2015-01-15 00:53:33.000000', 'temperatura', 717.0000, 'ºC'),
	(19887, 110, '2015-01-15 00:53:34.000000', 'temperatura', 178.0000, 'ºC'),
	(19888, 110, '2015-01-15 00:53:35.000000', 'temperatura', 1142.0000, 'ºC'),
	(19889, 110, '2015-01-15 00:53:36.000000', 'temperatura', 376.0000, 'ºC'),
	(19890, 110, '2015-01-15 00:53:37.000000', 'temperatura', 855.0000, 'ºC'),
	(19891, 110, '2015-01-15 00:53:38.000000', 'temperatura', 746.0000, 'ºC'),
	(19892, 110, '2015-01-15 00:53:39.000000', 'temperatura', 1167.0000, 'ºC'),
	(19893, 110, '2015-01-15 00:53:40.000000', 'temperatura', 1195.0000, 'ºC'),
	(19894, 110, '2015-01-15 00:53:41.000000', 'temperatura', 77.0000, 'ºC'),
	(19895, 110, '2015-01-15 00:53:42.000000', 'temperatura', 400.0000, 'ºC'),
	(19896, 110, '2015-01-15 00:53:43.000000', 'temperatura', 568.0000, 'ºC'),
	(19897, 110, '2015-01-15 00:53:44.000000', 'temperatura', 441.0000, 'ºC'),
	(19898, 110, '2015-01-15 00:53:45.000000', 'temperatura', 503.0000, 'ºC'),
	(19899, 110, '2015-01-15 00:53:46.000000', 'temperatura', 1192.0000, 'ºC'),
	(19900, 110, '2015-01-15 00:53:47.000000', 'temperatura', 852.0000, 'ºC'),
	(19901, 110, '2015-01-15 00:53:48.000000', 'temperatura', 683.0000, 'ºC'),
	(19902, 110, '2015-01-15 00:53:49.000000', 'temperatura', 861.0000, 'ºC'),
	(19903, 110, '2015-01-15 00:53:50.000000', 'temperatura', 1057.0000, 'ºC'),
	(19904, 110, '2015-01-15 00:53:51.000000', 'temperatura', 304.0000, 'ºC'),
	(19905, 110, '2015-01-15 00:53:52.000000', 'temperatura', 747.0000, 'ºC'),
	(19906, 110, '2015-01-15 00:53:53.000000', 'temperatura', 425.0000, 'ºC'),
	(19907, 110, '2015-01-15 00:53:54.000000', 'temperatura', 1085.0000, 'ºC'),
	(19908, 110, '2015-01-15 00:53:55.000000', 'temperatura', 550.0000, 'ºC'),
	(19909, 110, '2015-01-15 00:53:56.000000', 'temperatura', 694.0000, 'ºC'),
	(19910, 110, '2015-01-15 00:53:57.000000', 'temperatura', 620.0000, 'ºC'),
	(19911, 110, '2015-01-15 00:53:58.000000', 'temperatura', 1019.0000, 'ºC'),
	(19912, 110, '2015-01-15 00:53:59.000000', 'temperatura', 838.0000, 'ºC'),
	(19913, 110, '2015-01-15 00:54:00.000000', 'temperatura', 1131.0000, 'ºC'),
	(19914, 110, '2015-01-15 00:54:01.000000', 'temperatura', 741.0000, 'ºC'),
	(19915, 110, '2015-01-15 00:54:02.000000', 'temperatura', 312.0000, 'ºC'),
	(19916, 110, '2015-01-15 00:54:03.000000', 'temperatura', 537.0000, 'ºC'),
	(19917, 110, '2015-01-15 00:54:04.000000', 'temperatura', 549.0000, 'ºC'),
	(19918, 110, '2015-01-15 00:54:05.000000', 'temperatura', 1135.0000, 'ºC'),
	(19919, 110, '2015-01-15 00:54:06.000000', 'temperatura', 427.0000, 'ºC'),
	(19920, 110, '2015-01-15 00:54:07.000000', 'temperatura', 1131.0000, 'ºC'),
	(19921, 110, '2015-01-15 00:54:08.000000', 'temperatura', 776.0000, 'ºC'),
	(19922, 110, '2015-01-15 00:54:09.000000', 'temperatura', 486.0000, 'ºC'),
	(19923, 110, '2015-01-15 00:54:10.000000', 'temperatura', 103.0000, 'ºC'),
	(19924, 110, '2015-01-15 00:54:11.000000', 'temperatura', 258.0000, 'ºC'),
	(19925, 110, '2015-01-15 00:54:12.000000', 'temperatura', 981.0000, 'ºC'),
	(19926, 110, '2015-01-15 00:54:13.000000', 'temperatura', 533.0000, 'ºC'),
	(19927, 110, '2015-01-15 00:54:14.000000', 'temperatura', 919.0000, 'ºC'),
	(19928, 110, '2015-01-15 00:54:15.000000', 'temperatura', 600.0000, 'ºC'),
	(19929, 110, '2015-01-15 00:54:16.000000', 'temperatura', 242.0000, 'ºC'),
	(19930, 110, '2015-01-15 00:54:17.000000', 'temperatura', 613.0000, 'ºC'),
	(19931, 110, '2015-01-15 00:54:18.000000', 'temperatura', 1137.0000, 'ºC'),
	(19932, 110, '2015-01-15 00:54:19.000000', 'temperatura', 245.0000, 'ºC'),
	(19933, 110, '2015-01-15 00:54:20.000000', 'temperatura', 217.0000, 'ºC'),
	(19934, 110, '2015-01-15 00:54:21.000000', 'temperatura', 350.0000, 'ºC'),
	(19935, 110, '2015-01-15 00:54:22.000000', 'temperatura', 1099.0000, 'ºC'),
	(19936, 110, '2015-01-15 00:54:23.000000', 'temperatura', 847.0000, 'ºC'),
	(19937, 110, '2015-01-15 00:54:24.000000', 'temperatura', 936.0000, 'ºC'),
	(19938, 110, '2015-01-15 00:54:25.000000', 'temperatura', 942.0000, 'ºC'),
	(19939, 110, '2015-01-15 00:54:26.000000', 'temperatura', 700.0000, 'ºC'),
	(19940, 110, '2015-01-15 00:54:27.000000', 'temperatura', 677.0000, 'ºC'),
	(19941, 110, '2015-01-15 00:54:28.000000', 'temperatura', 85.0000, 'ºC'),
	(19942, 110, '2015-01-15 00:54:29.000000', 'temperatura', 793.0000, 'ºC'),
	(19943, 110, '2015-01-15 00:54:30.000000', 'temperatura', 111.0000, 'ºC'),
	(19944, 110, '2015-01-15 00:54:31.000000', 'temperatura', 578.0000, 'ºC'),
	(19945, 110, '2015-01-15 00:54:32.000000', 'temperatura', 155.0000, 'ºC'),
	(19946, 110, '2015-01-15 00:54:33.000000', 'temperatura', 241.0000, 'ºC'),
	(19947, 110, '2015-01-15 00:54:34.000000', 'temperatura', 743.0000, 'ºC'),
	(19948, 110, '2015-01-15 00:54:35.000000', 'temperatura', 590.0000, 'ºC'),
	(19949, 110, '2015-01-15 00:54:36.000000', 'temperatura', 722.0000, 'ºC'),
	(19950, 110, '2015-01-15 00:54:37.000000', 'temperatura', 640.0000, 'ºC'),
	(19951, 110, '2015-01-15 00:54:38.000000', 'temperatura', 1036.0000, 'ºC'),
	(19952, 110, '2015-01-15 00:54:39.000000', 'temperatura', 860.0000, 'ºC'),
	(19953, 110, '2015-01-15 00:54:40.000000', 'temperatura', 1192.0000, 'ºC'),
	(19954, 110, '2015-01-15 00:54:41.000000', 'temperatura', 979.0000, 'ºC'),
	(19955, 110, '2015-01-15 00:54:42.000000', 'temperatura', 120.0000, 'ºC'),
	(19956, 110, '2015-01-15 00:54:43.000000', 'temperatura', 65.0000, 'ºC'),
	(19957, 110, '2015-01-15 00:54:44.000000', 'temperatura', 1163.0000, 'ºC'),
	(19958, 110, '2015-01-15 00:54:45.000000', 'temperatura', 822.0000, 'ºC'),
	(19959, 110, '2015-01-15 00:54:46.000000', 'temperatura', 622.0000, 'ºC'),
	(19960, 110, '2015-01-15 00:54:47.000000', 'temperatura', 643.0000, 'ºC'),
	(19961, 110, '2015-01-15 00:54:48.000000', 'temperatura', 152.0000, 'ºC'),
	(19962, 110, '2015-01-15 00:54:49.000000', 'temperatura', 30.0000, 'ºC'),
	(19963, 110, '2015-01-15 00:54:50.000000', 'temperatura', 896.0000, 'ºC'),
	(19964, 110, '2015-01-15 00:54:51.000000', 'temperatura', 788.0000, 'ºC'),
	(19965, 110, '2015-01-15 00:54:52.000000', 'temperatura', 52.0000, 'ºC'),
	(19966, 110, '2015-01-15 00:54:53.000000', 'temperatura', 299.0000, 'ºC'),
	(19967, 110, '2015-01-15 00:54:54.000000', 'temperatura', 137.0000, 'ºC'),
	(19968, 110, '2015-01-15 00:54:55.000000', 'temperatura', 991.0000, 'ºC'),
	(19969, 110, '2015-01-15 00:54:56.000000', 'temperatura', 945.0000, 'ºC'),
	(19970, 110, '2015-01-15 00:54:57.000000', 'temperatura', 552.0000, 'ºC'),
	(19971, 110, '2015-01-15 00:54:58.000000', 'temperatura', 1125.0000, 'ºC'),
	(19972, 110, '2015-01-15 00:54:59.000000', 'temperatura', 372.0000, 'ºC'),
	(19973, 110, '2015-01-15 00:55:00.000000', 'temperatura', 883.0000, 'ºC'),
	(19974, 110, '2015-01-15 00:55:01.000000', 'temperatura', 898.0000, 'ºC'),
	(19975, 110, '2015-01-15 00:55:02.000000', 'temperatura', 644.0000, 'ºC'),
	(19976, 110, '2015-01-15 00:55:03.000000', 'temperatura', 525.0000, 'ºC'),
	(19977, 110, '2015-01-15 00:55:04.000000', 'temperatura', 696.0000, 'ºC'),
	(19978, 110, '2015-01-15 00:55:05.000000', 'temperatura', 704.0000, 'ºC'),
	(19979, 110, '2015-01-15 00:55:06.000000', 'temperatura', 232.0000, 'ºC'),
	(19980, 110, '2015-01-15 00:55:07.000000', 'temperatura', 247.0000, 'ºC'),
	(19981, 110, '2015-01-15 00:55:08.000000', 'temperatura', 542.0000, 'ºC'),
	(19982, 110, '2015-01-15 00:55:09.000000', 'temperatura', 771.0000, 'ºC'),
	(19983, 110, '2015-01-15 00:55:10.000000', 'temperatura', 1026.0000, 'ºC'),
	(19984, 110, '2015-01-15 00:55:11.000000', 'temperatura', 418.0000, 'ºC'),
	(19985, 110, '2015-01-15 00:55:12.000000', 'temperatura', 212.0000, 'ºC'),
	(19986, 110, '2015-01-15 00:55:13.000000', 'temperatura', 1009.0000, 'ºC'),
	(19987, 110, '2015-01-15 00:55:14.000000', 'temperatura', 807.0000, 'ºC'),
	(19988, 110, '2015-01-15 00:55:15.000000', 'temperatura', 1011.0000, 'ºC'),
	(19989, 110, '2015-01-15 00:55:16.000000', 'temperatura', 235.0000, 'ºC'),
	(19990, 110, '2015-01-15 00:55:17.000000', 'temperatura', 541.0000, 'ºC'),
	(19991, 110, '2015-01-15 00:55:18.000000', 'temperatura', 802.0000, 'ºC'),
	(19992, 110, '2015-01-15 00:55:19.000000', 'temperatura', 1185.0000, 'ºC'),
	(19993, 110, '2015-01-15 00:55:20.000000', 'temperatura', 1120.0000, 'ºC'),
	(19994, 110, '2015-01-15 00:55:21.000000', 'temperatura', 845.0000, 'ºC'),
	(19995, 110, '2015-01-15 00:55:22.000000', 'temperatura', 865.0000, 'ºC'),
	(19996, 110, '2015-01-15 00:55:23.000000', 'temperatura', 592.0000, 'ºC'),
	(19997, 110, '2015-01-15 00:55:24.000000', 'temperatura', 365.0000, 'ºC'),
	(19998, 110, '2015-01-15 00:55:25.000000', 'temperatura', 47.0000, 'ºC'),
	(19999, 110, '2015-01-15 00:55:26.000000', 'temperatura', 344.0000, 'ºC'),
	(20000, 110, '2015-01-15 00:55:27.000000', 'temperatura', 378.0000, 'ºC'),
	(20001, 110, '2015-01-15 00:55:28.000000', 'temperatura', 858.0000, 'ºC'),
	(20002, 110, '2015-01-15 00:55:29.000000', 'temperatura', 757.0000, 'ºC'),
	(20003, 110, '2015-01-15 00:55:30.000000', 'temperatura', 14.0000, 'ºC'),
	(20004, 110, '2015-01-15 00:55:31.000000', 'temperatura', 196.0000, 'ºC'),
	(20005, 110, '2015-01-15 00:55:32.000000', 'temperatura', 940.0000, 'ºC'),
	(20006, 110, '2015-01-15 00:55:33.000000', 'temperatura', 511.0000, 'ºC'),
	(20007, 110, '2015-01-15 00:55:34.000000', 'temperatura', 936.0000, 'ºC'),
	(20008, 110, '2015-01-15 00:55:35.000000', 'temperatura', 746.0000, 'ºC'),
	(20009, 110, '2015-01-15 00:55:36.000000', 'temperatura', 926.0000, 'ºC'),
	(20010, 110, '2015-01-15 00:55:37.000000', 'temperatura', 1190.0000, 'ºC'),
	(20011, 110, '2015-01-15 00:55:38.000000', 'temperatura', 774.0000, 'ºC'),
	(20012, 110, '2015-01-15 00:55:39.000000', 'temperatura', 298.0000, 'ºC'),
	(20013, 110, '2015-01-15 00:55:40.000000', 'temperatura', 371.0000, 'ºC'),
	(20014, 110, '2015-01-15 00:55:41.000000', 'temperatura', 960.0000, 'ºC'),
	(20015, 110, '2015-01-15 00:55:42.000000', 'temperatura', 89.0000, 'ºC'),
	(20016, 110, '2015-01-15 00:55:43.000000', 'temperatura', 1163.0000, 'ºC'),
	(20017, 110, '2015-01-15 00:55:44.000000', 'temperatura', 752.0000, 'ºC'),
	(20018, 110, '2015-01-15 00:55:45.000000', 'temperatura', 269.0000, 'ºC'),
	(20019, 110, '2015-01-15 00:55:46.000000', 'temperatura', 291.0000, 'ºC'),
	(20020, 110, '2015-01-15 00:55:47.000000', 'temperatura', 649.0000, 'ºC'),
	(20021, 110, '2015-01-15 00:55:48.000000', 'temperatura', 1172.0000, 'ºC'),
	(20022, 110, '2015-01-15 00:55:49.000000', 'temperatura', 315.0000, 'ºC'),
	(20023, 110, '2015-01-15 00:55:50.000000', 'temperatura', 456.0000, 'ºC'),
	(20024, 110, '2015-01-15 00:55:51.000000', 'temperatura', 138.0000, 'ºC'),
	(20025, 110, '2015-01-15 00:55:52.000000', 'temperatura', 524.0000, 'ºC'),
	(20026, 110, '2015-01-15 00:55:53.000000', 'temperatura', 1005.0000, 'ºC'),
	(20027, 110, '2015-01-15 00:55:54.000000', 'temperatura', 1053.0000, 'ºC'),
	(20028, 110, '2015-01-15 00:55:55.000000', 'temperatura', 1051.0000, 'ºC'),
	(20029, 110, '2015-01-15 00:55:56.000000', 'temperatura', 898.0000, 'ºC'),
	(20030, 110, '2015-01-15 00:55:57.000000', 'temperatura', 138.0000, 'ºC'),
	(20031, 110, '2015-01-15 00:55:58.000000', 'temperatura', 394.0000, 'ºC'),
	(20032, 110, '2015-01-15 00:55:59.000000', 'temperatura', 357.0000, 'ºC'),
	(20033, 110, '2015-01-15 00:56:00.000000', 'temperatura', 603.0000, 'ºC'),
	(20034, 110, '2015-01-15 00:56:01.000000', 'temperatura', 745.0000, 'ºC'),
	(20035, 110, '2015-01-15 00:56:02.000000', 'temperatura', 718.0000, 'ºC'),
	(20036, 110, '2015-01-15 00:56:03.000000', 'temperatura', 156.0000, 'ºC'),
	(20037, 110, '2015-01-15 00:56:04.000000', 'temperatura', 1026.0000, 'ºC'),
	(20038, 110, '2015-01-15 00:56:05.000000', 'temperatura', 1061.0000, 'ºC'),
	(20039, 110, '2015-01-15 00:56:06.000000', 'temperatura', 1030.0000, 'ºC'),
	(20040, 110, '2015-01-15 00:56:07.000000', 'temperatura', 765.0000, 'ºC'),
	(20041, 110, '2015-01-15 00:56:08.000000', 'temperatura', 737.0000, 'ºC'),
	(20042, 110, '2015-01-15 00:56:09.000000', 'temperatura', 188.0000, 'ºC'),
	(20043, 110, '2015-01-15 00:56:10.000000', 'temperatura', 1131.0000, 'ºC'),
	(20044, 110, '2015-01-15 00:56:11.000000', 'temperatura', 293.0000, 'ºC'),
	(20045, 110, '2015-01-15 00:56:12.000000', 'temperatura', 473.0000, 'ºC'),
	(20046, 110, '2015-01-15 00:56:13.000000', 'temperatura', 283.0000, 'ºC'),
	(20047, 110, '2015-01-15 00:56:14.000000', 'temperatura', 0.0000, 'ºC'),
	(20048, 110, '2015-01-15 00:56:15.000000', 'temperatura', 351.0000, 'ºC'),
	(20049, 110, '2015-01-15 00:56:16.000000', 'temperatura', 554.0000, 'ºC'),
	(20050, 110, '2015-01-15 00:56:17.000000', 'temperatura', 518.0000, 'ºC'),
	(20051, 110, '2015-01-15 00:56:18.000000', 'temperatura', 930.0000, 'ºC'),
	(20052, 110, '2015-01-15 00:56:19.000000', 'temperatura', 697.0000, 'ºC'),
	(20053, 110, '2015-01-15 00:56:20.000000', 'temperatura', 694.0000, 'ºC'),
	(20054, 110, '2015-01-15 00:56:21.000000', 'temperatura', 179.0000, 'ºC'),
	(20055, 110, '2015-01-15 00:56:22.000000', 'temperatura', 15.0000, 'ºC'),
	(20056, 110, '2015-01-15 00:56:23.000000', 'temperatura', 737.0000, 'ºC'),
	(20057, 110, '2015-01-15 00:56:24.000000', 'temperatura', 42.0000, 'ºC'),
	(20058, 110, '2015-01-15 00:56:25.000000', 'temperatura', 399.0000, 'ºC'),
	(20059, 110, '2015-01-15 00:56:26.000000', 'temperatura', 670.0000, 'ºC'),
	(20060, 110, '2015-01-15 00:56:27.000000', 'temperatura', 951.0000, 'ºC'),
	(20061, 110, '2015-01-15 00:56:28.000000', 'temperatura', 347.0000, 'ºC'),
	(20062, 110, '2015-01-15 00:56:29.000000', 'temperatura', 82.0000, 'ºC'),
	(20063, 110, '2015-01-15 00:56:30.000000', 'temperatura', 571.0000, 'ºC'),
	(20064, 110, '2015-01-15 00:56:31.000000', 'temperatura', 208.0000, 'ºC'),
	(20065, 110, '2015-01-15 00:56:32.000000', 'temperatura', 529.0000, 'ºC'),
	(20066, 110, '2015-01-15 00:56:33.000000', 'temperatura', 819.0000, 'ºC'),
	(20067, 110, '2015-01-15 00:56:34.000000', 'temperatura', 110.0000, 'ºC'),
	(20068, 110, '2015-01-15 00:56:35.000000', 'temperatura', 493.0000, 'ºC'),
	(20069, 110, '2015-01-15 00:56:36.000000', 'temperatura', 935.0000, 'ºC'),
	(20070, 110, '2015-01-15 00:56:37.000000', 'temperatura', 799.0000, 'ºC'),
	(20071, 110, '2015-01-15 00:56:38.000000', 'temperatura', 1187.0000, 'ºC'),
	(20072, 110, '2015-01-15 00:56:39.000000', 'temperatura', 1142.0000, 'ºC'),
	(20073, 110, '2015-01-15 00:56:40.000000', 'temperatura', 947.0000, 'ºC'),
	(20074, 110, '2015-01-15 00:56:41.000000', 'temperatura', 110.0000, 'ºC'),
	(20075, 110, '2015-01-15 00:56:42.000000', 'temperatura', 112.0000, 'ºC'),
	(20076, 110, '2015-01-15 00:56:43.000000', 'temperatura', 228.0000, 'ºC'),
	(20077, 110, '2015-01-15 00:56:44.000000', 'temperatura', 803.0000, 'ºC'),
	(20078, 110, '2015-01-15 00:56:45.000000', 'temperatura', 934.0000, 'ºC'),
	(20079, 110, '2015-01-15 00:56:46.000000', 'temperatura', 1063.0000, 'ºC'),
	(20080, 110, '2015-01-15 00:56:47.000000', 'temperatura', 111.0000, 'ºC'),
	(20081, 110, '2015-01-15 00:56:48.000000', 'temperatura', 968.0000, 'ºC'),
	(20082, 110, '2015-01-15 00:56:49.000000', 'temperatura', 908.0000, 'ºC'),
	(20083, 110, '2015-01-15 00:56:50.000000', 'temperatura', 434.0000, 'ºC'),
	(20084, 110, '2015-01-15 00:56:51.000000', 'temperatura', 646.0000, 'ºC'),
	(20085, 110, '2015-01-15 00:56:52.000000', 'temperatura', 730.0000, 'ºC'),
	(20086, 110, '2015-01-15 00:56:53.000000', 'temperatura', 514.0000, 'ºC'),
	(20087, 110, '2015-01-15 00:56:54.000000', 'temperatura', 379.0000, 'ºC'),
	(20088, 110, '2015-01-15 00:56:55.000000', 'temperatura', 355.0000, 'ºC'),
	(20089, 110, '2015-01-15 00:56:56.000000', 'temperatura', 637.0000, 'ºC'),
	(20090, 110, '2015-01-15 00:56:57.000000', 'temperatura', 922.0000, 'ºC'),
	(20091, 110, '2015-01-15 00:56:58.000000', 'temperatura', 298.0000, 'ºC'),
	(20092, 110, '2015-01-15 00:56:59.000000', 'temperatura', 1127.0000, 'ºC'),
	(20093, 110, '2015-01-15 00:57:00.000000', 'temperatura', 1140.0000, 'ºC'),
	(20094, 110, '2015-01-15 00:57:01.000000', 'temperatura', 1119.0000, 'ºC'),
	(20095, 110, '2015-01-15 00:57:02.000000', 'temperatura', 974.0000, 'ºC'),
	(20096, 110, '2015-01-15 00:57:03.000000', 'temperatura', 316.0000, 'ºC'),
	(20097, 110, '2015-01-15 00:57:04.000000', 'temperatura', 1056.0000, 'ºC'),
	(20098, 110, '2015-01-15 00:57:05.000000', 'temperatura', 732.0000, 'ºC'),
	(20099, 110, '2015-01-15 00:57:06.000000', 'temperatura', 495.0000, 'ºC'),
	(20100, 110, '2015-01-15 00:57:07.000000', 'temperatura', 279.0000, 'ºC'),
	(20101, 110, '2015-01-15 00:57:08.000000', 'temperatura', 1108.0000, 'ºC'),
	(20102, 110, '2015-01-15 00:57:09.000000', 'temperatura', 1106.0000, 'ºC'),
	(20103, 110, '2015-01-15 00:57:10.000000', 'temperatura', 1006.0000, 'ºC'),
	(20104, 110, '2015-01-15 00:57:11.000000', 'temperatura', 514.0000, 'ºC'),
	(20105, 110, '2015-01-15 00:57:12.000000', 'temperatura', 751.0000, 'ºC'),
	(20106, 110, '2015-01-15 00:57:13.000000', 'temperatura', 1014.0000, 'ºC'),
	(20107, 110, '2015-01-15 00:57:14.000000', 'temperatura', 416.0000, 'ºC'),
	(20108, 110, '2015-01-15 00:57:15.000000', 'temperatura', 239.0000, 'ºC'),
	(20109, 110, '2015-01-15 00:57:16.000000', 'temperatura', 1149.0000, 'ºC'),
	(20110, 110, '2015-01-15 00:57:17.000000', 'temperatura', 227.0000, 'ºC'),
	(20111, 110, '2015-01-15 00:57:18.000000', 'temperatura', 87.0000, 'ºC'),
	(20112, 110, '2015-01-15 00:57:19.000000', 'temperatura', 958.0000, 'ºC'),
	(20113, 110, '2015-01-15 00:57:20.000000', 'temperatura', 927.0000, 'ºC'),
	(20114, 110, '2015-01-15 00:57:21.000000', 'temperatura', 563.0000, 'ºC'),
	(20115, 110, '2015-01-15 00:57:22.000000', 'temperatura', 34.0000, 'ºC'),
	(20116, 110, '2015-01-15 00:57:23.000000', 'temperatura', 881.0000, 'ºC'),
	(20117, 110, '2015-01-15 00:57:24.000000', 'temperatura', 703.0000, 'ºC'),
	(20118, 110, '2015-01-15 00:57:25.000000', 'temperatura', 871.0000, 'ºC'),
	(20119, 110, '2015-01-15 00:57:26.000000', 'temperatura', 1048.0000, 'ºC'),
	(20120, 110, '2015-01-15 00:57:27.000000', 'temperatura', 227.0000, 'ºC'),
	(20121, 110, '2015-01-15 00:57:28.000000', 'temperatura', 393.0000, 'ºC'),
	(20122, 110, '2015-01-15 00:57:29.000000', 'temperatura', 83.0000, 'ºC'),
	(20123, 110, '2015-01-15 00:57:30.000000', 'temperatura', 438.0000, 'ºC'),
	(20124, 110, '2015-01-15 00:57:31.000000', 'temperatura', 742.0000, 'ºC'),
	(20125, 110, '2015-01-15 00:57:32.000000', 'temperatura', 1197.0000, 'ºC'),
	(20126, 110, '2015-01-15 00:57:33.000000', 'temperatura', 159.0000, 'ºC'),
	(20127, 110, '2015-01-15 00:57:34.000000', 'temperatura', 803.0000, 'ºC'),
	(20128, 110, '2015-01-15 00:57:35.000000', 'temperatura', 1139.0000, 'ºC'),
	(20129, 110, '2015-01-15 00:57:36.000000', 'temperatura', 888.0000, 'ºC'),
	(20130, 110, '2015-01-15 00:57:37.000000', 'temperatura', 1024.0000, 'ºC'),
	(20131, 110, '2015-01-15 00:57:38.000000', 'temperatura', 56.0000, 'ºC'),
	(20132, 110, '2015-01-15 00:57:39.000000', 'temperatura', 808.0000, 'ºC'),
	(20133, 110, '2015-01-15 00:57:40.000000', 'temperatura', 273.0000, 'ºC'),
	(20134, 110, '2015-01-15 00:57:41.000000', 'temperatura', 142.0000, 'ºC'),
	(20135, 110, '2015-01-15 00:57:42.000000', 'temperatura', 1092.0000, 'ºC'),
	(20136, 110, '2015-01-15 00:57:43.000000', 'temperatura', 233.0000, 'ºC'),
	(20137, 110, '2015-01-15 00:57:44.000000', 'temperatura', 290.0000, 'ºC'),
	(20138, 110, '2015-01-15 00:57:45.000000', 'temperatura', 752.0000, 'ºC'),
	(20139, 110, '2015-01-15 00:57:46.000000', 'temperatura', 488.0000, 'ºC'),
	(20140, 110, '2015-01-15 00:57:47.000000', 'temperatura', 186.0000, 'ºC'),
	(20141, 110, '2015-01-15 00:57:48.000000', 'temperatura', 668.0000, 'ºC'),
	(20142, 110, '2015-01-15 00:57:49.000000', 'temperatura', 380.0000, 'ºC'),
	(20143, 110, '2015-01-15 00:57:50.000000', 'temperatura', 1097.0000, 'ºC'),
	(20144, 110, '2015-01-15 00:57:51.000000', 'temperatura', 747.0000, 'ºC'),
	(20145, 110, '2015-01-15 00:57:52.000000', 'temperatura', 444.0000, 'ºC'),
	(20146, 110, '2015-01-15 00:57:53.000000', 'temperatura', 1179.0000, 'ºC'),
	(20147, 110, '2015-01-15 00:57:54.000000', 'temperatura', 963.0000, 'ºC'),
	(20148, 110, '2015-01-15 00:57:55.000000', 'temperatura', 78.0000, 'ºC'),
	(20149, 110, '2015-01-15 00:57:56.000000', 'temperatura', 1104.0000, 'ºC'),
	(20150, 110, '2015-01-15 00:57:57.000000', 'temperatura', 485.0000, 'ºC'),
	(20151, 110, '2015-01-15 00:57:58.000000', 'temperatura', 315.0000, 'ºC'),
	(20152, 110, '2015-01-15 00:57:59.000000', 'temperatura', 118.0000, 'ºC'),
	(20153, 110, '2015-01-15 00:58:00.000000', 'temperatura', 849.0000, 'ºC'),
	(20154, 110, '2015-01-15 00:58:01.000000', 'temperatura', 289.0000, 'ºC'),
	(20155, 110, '2015-01-15 00:58:02.000000', 'temperatura', 98.0000, 'ºC'),
	(20156, 110, '2015-01-15 00:58:03.000000', 'temperatura', 823.0000, 'ºC'),
	(20157, 110, '2015-01-15 00:58:04.000000', 'temperatura', 224.0000, 'ºC'),
	(20158, 110, '2015-01-15 00:58:05.000000', 'temperatura', 1049.0000, 'ºC'),
	(20159, 110, '2015-01-15 00:58:06.000000', 'temperatura', 975.0000, 'ºC'),
	(20160, 110, '2015-01-15 00:58:07.000000', 'temperatura', 526.0000, 'ºC'),
	(20161, 110, '2015-01-15 00:58:08.000000', 'temperatura', 907.0000, 'ºC'),
	(20162, 110, '2015-01-15 00:58:09.000000', 'temperatura', 559.0000, 'ºC'),
	(20163, 110, '2015-01-15 00:58:10.000000', 'temperatura', 72.0000, 'ºC'),
	(20164, 110, '2015-01-15 00:58:11.000000', 'temperatura', 1084.0000, 'ºC'),
	(20165, 110, '2015-01-15 00:58:12.000000', 'temperatura', 405.0000, 'ºC'),
	(20166, 110, '2015-01-15 00:58:13.000000', 'temperatura', 1175.0000, 'ºC'),
	(20167, 110, '2015-01-15 00:58:14.000000', 'temperatura', 1059.0000, 'ºC'),
	(20168, 110, '2015-01-15 00:58:15.000000', 'temperatura', 573.0000, 'ºC'),
	(20169, 110, '2015-01-15 00:58:16.000000', 'temperatura', 886.0000, 'ºC'),
	(20170, 110, '2015-01-15 00:58:17.000000', 'temperatura', 312.0000, 'ºC'),
	(20171, 110, '2015-01-15 00:58:18.000000', 'temperatura', 105.0000, 'ºC'),
	(20172, 110, '2015-01-15 00:58:19.000000', 'temperatura', 786.0000, 'ºC'),
	(20173, 110, '2015-01-15 00:58:20.000000', 'temperatura', 18.0000, 'ºC'),
	(20174, 110, '2015-01-15 00:58:21.000000', 'temperatura', 132.0000, 'ºC'),
	(20175, 110, '2015-01-15 00:58:22.000000', 'temperatura', 608.0000, 'ºC'),
	(20176, 110, '2015-01-15 00:58:23.000000', 'temperatura', 242.0000, 'ºC'),
	(20177, 110, '2015-01-15 00:58:24.000000', 'temperatura', 588.0000, 'ºC'),
	(20178, 110, '2015-01-15 00:58:25.000000', 'temperatura', 1013.0000, 'ºC'),
	(20179, 110, '2015-01-15 00:58:26.000000', 'temperatura', 902.0000, 'ºC'),
	(20180, 110, '2015-01-15 00:58:27.000000', 'temperatura', 272.0000, 'ºC'),
	(20181, 110, '2015-01-15 00:58:28.000000', 'temperatura', 1056.0000, 'ºC'),
	(20182, 110, '2015-01-15 00:58:29.000000', 'temperatura', 862.0000, 'ºC'),
	(20183, 110, '2015-01-15 00:58:30.000000', 'temperatura', 1145.0000, 'ºC'),
	(20184, 110, '2015-01-15 00:58:31.000000', 'temperatura', 738.0000, 'ºC'),
	(20185, 110, '2015-01-15 00:58:32.000000', 'temperatura', 258.0000, 'ºC'),
	(20186, 110, '2015-01-15 00:58:33.000000', 'temperatura', 274.0000, 'ºC'),
	(20187, 110, '2015-01-15 00:58:34.000000', 'temperatura', 599.0000, 'ºC'),
	(20188, 110, '2015-01-15 00:58:35.000000', 'temperatura', 972.0000, 'ºC'),
	(20189, 110, '2015-01-15 00:58:36.000000', 'temperatura', 663.0000, 'ºC'),
	(20190, 110, '2015-01-15 00:58:37.000000', 'temperatura', 399.0000, 'ºC'),
	(20191, 110, '2015-01-15 00:58:38.000000', 'temperatura', 8.0000, 'ºC'),
	(20192, 110, '2015-01-15 00:58:39.000000', 'temperatura', 44.0000, 'ºC'),
	(20193, 110, '2015-01-15 00:58:40.000000', 'temperatura', 197.0000, 'ºC'),
	(20194, 110, '2015-01-15 00:58:41.000000', 'temperatura', 852.0000, 'ºC'),
	(20195, 110, '2015-01-15 00:58:42.000000', 'temperatura', 71.0000, 'ºC'),
	(20196, 110, '2015-01-15 00:58:43.000000', 'temperatura', 200.0000, 'ºC'),
	(20197, 110, '2015-01-15 00:58:44.000000', 'temperatura', 785.0000, 'ºC'),
	(20198, 110, '2015-01-15 00:58:45.000000', 'temperatura', 928.0000, 'ºC'),
	(20199, 110, '2015-01-15 00:58:46.000000', 'temperatura', 1084.0000, 'ºC'),
	(20200, 110, '2015-01-15 00:58:47.000000', 'temperatura', 238.0000, 'ºC'),
	(20201, 110, '2015-01-15 00:58:48.000000', 'temperatura', 340.0000, 'ºC'),
	(20202, 110, '2015-01-15 00:58:49.000000', 'temperatura', 984.0000, 'ºC'),
	(20203, 110, '2015-01-15 00:58:50.000000', 'temperatura', 301.0000, 'ºC'),
	(20204, 110, '2015-01-15 00:58:51.000000', 'temperatura', 954.0000, 'ºC'),
	(20205, 110, '2015-01-15 00:58:52.000000', 'temperatura', 268.0000, 'ºC'),
	(20206, 110, '2015-01-15 00:58:53.000000', 'temperatura', 878.0000, 'ºC'),
	(20207, 110, '2015-01-15 00:58:54.000000', 'temperatura', 1187.0000, 'ºC'),
	(20208, 110, '2015-01-15 00:58:55.000000', 'temperatura', 899.0000, 'ºC'),
	(20209, 110, '2015-01-15 00:58:56.000000', 'temperatura', 938.0000, 'ºC'),
	(20210, 110, '2015-01-15 00:58:57.000000', 'temperatura', 791.0000, 'ºC'),
	(20211, 110, '2015-01-15 00:58:58.000000', 'temperatura', 1143.0000, 'ºC'),
	(20212, 110, '2015-01-15 00:58:59.000000', 'temperatura', 943.0000, 'ºC'),
	(20213, 110, '2015-01-15 00:59:00.000000', 'temperatura', 87.0000, 'ºC'),
	(20214, 110, '2015-01-15 00:59:01.000000', 'temperatura', 5.0000, 'ºC'),
	(20215, 110, '2015-01-15 00:59:02.000000', 'temperatura', 965.0000, 'ºC'),
	(20216, 110, '2015-01-15 00:59:03.000000', 'temperatura', 11.0000, 'ºC'),
	(20217, 110, '2015-01-15 00:59:04.000000', 'temperatura', 759.0000, 'ºC'),
	(20218, 110, '2015-01-15 00:59:05.000000', 'temperatura', 161.0000, 'ºC'),
	(20219, 110, '2015-01-15 00:59:06.000000', 'temperatura', 931.0000, 'ºC'),
	(20220, 110, '2015-01-15 00:59:07.000000', 'temperatura', 571.0000, 'ºC'),
	(20221, 110, '2015-01-15 00:59:08.000000', 'temperatura', 64.0000, 'ºC'),
	(20222, 110, '2015-01-15 00:59:09.000000', 'temperatura', 1006.0000, 'ºC'),
	(20223, 110, '2015-01-15 00:59:10.000000', 'temperatura', 38.0000, 'ºC'),
	(20224, 110, '2015-01-15 00:59:11.000000', 'temperatura', 775.0000, 'ºC'),
	(20225, 110, '2015-01-15 00:59:12.000000', 'temperatura', 162.0000, 'ºC'),
	(20226, 110, '2015-01-15 00:59:13.000000', 'temperatura', 882.0000, 'ºC'),
	(20227, 110, '2015-01-15 00:59:14.000000', 'temperatura', 328.0000, 'ºC'),
	(20228, 110, '2015-01-15 00:59:15.000000', 'temperatura', 193.0000, 'ºC'),
	(20229, 110, '2015-01-15 00:59:16.000000', 'temperatura', 1182.0000, 'ºC'),
	(20230, 110, '2015-01-15 00:59:17.000000', 'temperatura', 531.0000, 'ºC'),
	(20231, 110, '2015-01-15 00:59:18.000000', 'temperatura', 308.0000, 'ºC'),
	(20232, 110, '2015-01-15 00:59:19.000000', 'temperatura', 1149.0000, 'ºC'),
	(20233, 110, '2015-01-15 00:59:20.000000', 'temperatura', 20.0000, 'ºC'),
	(20234, 110, '2015-01-15 00:59:21.000000', 'temperatura', 256.0000, 'ºC'),
	(20235, 110, '2015-01-15 00:59:22.000000', 'temperatura', 20.0000, 'ºC'),
	(20236, 110, '2015-01-15 00:59:23.000000', 'temperatura', 531.0000, 'ºC'),
	(20237, 110, '2015-01-15 00:59:24.000000', 'temperatura', 198.0000, 'ºC'),
	(20238, 110, '2015-01-15 00:59:25.000000', 'temperatura', 597.0000, 'ºC'),
	(20239, 110, '2015-01-15 00:59:26.000000', 'temperatura', 1190.0000, 'ºC'),
	(20240, 110, '2015-01-15 00:59:27.000000', 'temperatura', 560.0000, 'ºC'),
	(20241, 110, '2015-01-15 00:59:28.000000', 'temperatura', 429.0000, 'ºC'),
	(20242, 110, '2015-01-15 00:59:29.000000', 'temperatura', 464.0000, 'ºC'),
	(20243, 110, '2015-01-15 00:59:30.000000', 'temperatura', 1037.0000, 'ºC'),
	(20244, 110, '2015-01-15 00:59:31.000000', 'temperatura', 194.0000, 'ºC'),
	(20245, 110, '2015-01-15 00:59:32.000000', 'temperatura', 260.0000, 'ºC'),
	(20246, 110, '2015-01-15 00:59:33.000000', 'temperatura', 718.0000, 'ºC'),
	(20247, 110, '2015-01-15 00:59:34.000000', 'temperatura', 410.0000, 'ºC'),
	(20248, 110, '2015-01-15 00:59:35.000000', 'temperatura', 1096.0000, 'ºC'),
	(20249, 110, '2015-01-15 00:59:36.000000', 'temperatura', 651.0000, 'ºC'),
	(20250, 110, '2015-01-15 00:59:37.000000', 'temperatura', 1168.0000, 'ºC'),
	(20251, 110, '2015-01-15 00:59:38.000000', 'temperatura', 285.0000, 'ºC'),
	(20252, 110, '2015-01-15 00:59:39.000000', 'temperatura', 324.0000, 'ºC'),
	(20253, 110, '2015-01-15 00:59:40.000000', 'temperatura', 766.0000, 'ºC'),
	(20254, 110, '2015-01-15 00:59:41.000000', 'temperatura', 456.0000, 'ºC'),
	(20255, 110, '2015-01-15 00:59:42.000000', 'temperatura', 1183.0000, 'ºC'),
	(20256, 110, '2015-01-15 00:59:43.000000', 'temperatura', 947.0000, 'ºC'),
	(20257, 110, '2015-01-15 00:59:44.000000', 'temperatura', 1185.0000, 'ºC'),
	(20258, 110, '2015-01-15 00:59:45.000000', 'temperatura', 687.0000, 'ºC'),
	(20259, 110, '2015-01-15 00:59:46.000000', 'temperatura', 1080.0000, 'ºC'),
	(20260, 110, '2015-01-15 00:59:47.000000', 'temperatura', 937.0000, 'ºC'),
	(20261, 110, '2015-01-15 00:59:48.000000', 'temperatura', 249.0000, 'ºC'),
	(20262, 110, '2015-01-15 00:59:49.000000', 'temperatura', 834.0000, 'ºC'),
	(20263, 110, '2015-01-15 00:59:50.000000', 'temperatura', 1024.0000, 'ºC'),
	(20264, 110, '2015-01-15 00:59:51.000000', 'temperatura', 219.0000, 'ºC'),
	(20265, 110, '2015-01-15 00:59:52.000000', 'temperatura', 423.0000, 'ºC'),
	(20266, 110, '2015-01-15 00:59:53.000000', 'temperatura', 258.0000, 'ºC'),
	(20267, 110, '2015-01-15 00:59:54.000000', 'temperatura', 21.0000, 'ºC'),
	(20268, 110, '2015-01-15 00:59:55.000000', 'temperatura', 533.0000, 'ºC'),
	(20269, 110, '2015-01-15 00:59:56.000000', 'temperatura', 201.0000, 'ºC'),
	(20270, 110, '2015-01-15 00:59:57.000000', 'temperatura', 606.0000, 'ºC'),
	(20271, 110, '2015-01-15 00:59:58.000000', 'temperatura', 27.0000, 'ºC'),
	(20272, 110, '2015-01-15 00:59:59.000000', 'temperatura', 718.0000, 'ºC'),
	(20273, 110, '2015-01-15 01:00:00.000000', 'temperatura', 1109.0000, 'ºC'),
	(20274, 110, '2015-01-15 01:00:01.000000', 'temperatura', 994.0000, 'ºC'),
	(20275, 110, '2015-01-15 01:00:02.000000', 'temperatura', 440.0000, 'ºC'),
	(20276, 110, '2015-01-15 01:00:03.000000', 'temperatura', 421.0000, 'ºC'),
	(20277, 110, '2015-01-15 01:00:04.000000', 'temperatura', 783.0000, 'ºC'),
	(20278, 110, '2015-01-15 01:00:05.000000', 'temperatura', 253.0000, 'ºC'),
	(20279, 110, '2015-01-15 01:00:06.000000', 'temperatura', 116.0000, 'ºC'),
	(20280, 110, '2015-01-15 01:00:07.000000', 'temperatura', 1020.0000, 'ºC'),
	(20281, 110, '2015-01-15 01:00:08.000000', 'temperatura', 1156.0000, 'ºC'),
	(20282, 110, '2015-01-15 01:00:09.000000', 'temperatura', 318.0000, 'ºC'),
	(20283, 110, '2015-01-15 01:00:10.000000', 'temperatura', 522.0000, 'ºC'),
	(20284, 110, '2015-01-15 01:00:11.000000', 'temperatura', 457.0000, 'ºC'),
	(20285, 110, '2015-01-15 01:00:12.000000', 'temperatura', 721.0000, 'ºC'),
	(20286, 110, '2015-01-15 01:00:13.000000', 'temperatura', 1032.0000, 'ºC'),
	(20287, 110, '2015-01-15 01:00:14.000000', 'temperatura', 597.0000, 'ºC'),
	(20288, 110, '2015-01-15 01:00:15.000000', 'temperatura', 1091.0000, 'ºC'),
	(20289, 110, '2015-01-15 01:00:16.000000', 'temperatura', 65.0000, 'ºC'),
	(20290, 110, '2015-01-15 01:00:17.000000', 'temperatura', 652.0000, 'ºC'),
	(20291, 110, '2015-01-15 01:00:18.000000', 'temperatura', 664.0000, 'ºC'),
	(20292, 110, '2015-01-15 01:00:19.000000', 'temperatura', 164.0000, 'ºC'),
	(20293, 110, '2015-01-15 01:00:20.000000', 'temperatura', 31.0000, 'ºC'),
	(20294, 110, '2015-01-15 01:00:21.000000', 'temperatura', 865.0000, 'ºC'),
	(20295, 110, '2015-01-15 01:00:22.000000', 'temperatura', 629.0000, 'ºC'),
	(20296, 110, '2015-01-15 01:00:23.000000', 'temperatura', 551.0000, 'ºC'),
	(20297, 110, '2015-01-15 01:00:24.000000', 'temperatura', 868.0000, 'ºC'),
	(20298, 110, '2015-01-15 01:00:25.000000', 'temperatura', 289.0000, 'ºC'),
	(20299, 110, '2015-01-15 01:00:26.000000', 'temperatura', 42.0000, 'ºC'),
	(20300, 110, '2015-01-15 01:00:27.000000', 'temperatura', 544.0000, 'ºC'),
	(20301, 110, '2015-01-15 01:00:28.000000', 'temperatura', 192.0000, 'ºC'),
	(20302, 110, '2015-01-15 01:00:29.000000', 'temperatura', 528.0000, 'ºC'),
	(20303, 110, '2015-01-15 01:00:30.000000', 'temperatura', 864.0000, 'ºC'),
	(20304, 110, '2015-01-15 01:00:31.000000', 'temperatura', 339.0000, 'ºC'),
	(20305, 110, '2015-01-15 01:00:32.000000', 'temperatura', 301.0000, 'ºC'),
	(20306, 110, '2015-01-15 01:00:33.000000', 'temperatura', 488.0000, 'ºC'),
	(20307, 110, '2015-01-15 01:00:34.000000', 'temperatura', 339.0000, 'ºC'),
	(20308, 110, '2015-01-15 01:00:35.000000', 'temperatura', 231.0000, 'ºC'),
	(20309, 110, '2015-01-15 01:00:36.000000', 'temperatura', 137.0000, 'ºC'),
	(20310, 110, '2015-01-15 01:00:37.000000', 'temperatura', 1193.0000, 'ºC'),
	(20311, 110, '2015-01-15 01:00:38.000000', 'temperatura', 755.0000, 'ºC'),
	(20312, 110, '2015-01-15 01:00:39.000000', 'temperatura', 196.0000, 'ºC'),
	(20313, 110, '2015-01-15 01:00:40.000000', 'temperatura', 1117.0000, 'ºC'),
	(20314, 110, '2015-01-15 01:00:41.000000', 'temperatura', 197.0000, 'ºC'),
	(20315, 110, '2015-01-15 01:00:42.000000', 'temperatura', 36.0000, 'ºC'),
	(20316, 110, '2015-01-15 01:00:43.000000', 'temperatura', 786.0000, 'ºC'),
	(20317, 110, '2015-01-15 01:00:44.000000', 'temperatura', 226.0000, 'ºC'),
	(20318, 110, '2015-01-15 01:00:45.000000', 'temperatura', 1170.0000, 'ºC'),
	(20319, 110, '2015-01-15 01:00:46.000000', 'temperatura', 373.0000, 'ºC'),
	(20320, 110, '2015-01-15 01:00:47.000000', 'temperatura', 756.0000, 'ºC'),
	(20321, 110, '2015-01-15 01:00:48.000000', 'temperatura', 259.0000, 'ºC'),
	(20322, 110, '2015-01-15 01:00:49.000000', 'temperatura', 230.0000, 'ºC'),
	(20323, 110, '2015-01-15 01:00:50.000000', 'temperatura', 373.0000, 'ºC'),
	(20324, 110, '2015-01-15 01:00:51.000000', 'temperatura', 1177.0000, 'ºC'),
	(20325, 110, '2015-01-15 01:00:52.000000', 'temperatura', 1166.0000, 'ºC'),
	(20326, 110, '2015-01-15 01:00:53.000000', 'temperatura', 1098.0000, 'ºC'),
	(20327, 110, '2015-01-15 01:00:54.000000', 'temperatura', 795.0000, 'ºC'),
	(20328, 110, '2015-01-15 01:00:55.000000', 'temperatura', 678.0000, 'ºC'),
	(20329, 110, '2015-01-15 01:00:56.000000', 'temperatura', 1009.0000, 'ºC'),
	(20330, 110, '2015-01-15 01:00:57.000000', 'temperatura', 608.0000, 'ºC'),
	(20331, 110, '2015-01-15 01:00:58.000000', 'temperatura', 16.0000, 'ºC'),
	(20332, 110, '2015-01-15 01:00:59.000000', 'temperatura', 654.0000, 'ºC'),
	(20333, 110, '2015-01-15 01:01:00.000000', 'temperatura', 825.0000, 'ºC'),
	(20334, 110, '2015-01-15 01:01:01.000000', 'temperatura', 964.0000, 'ºC'),
	(20335, 110, '2015-01-15 01:01:02.000000', 'temperatura', 1147.0000, 'ºC'),
	(20336, 110, '2015-01-15 01:01:03.000000', 'temperatura', 440.0000, 'ºC'),
	(20337, 110, '2015-01-15 01:01:04.000000', 'temperatura', 1163.0000, 'ºC'),
	(20338, 110, '2015-01-15 01:01:05.000000', 'temperatura', 893.0000, 'ºC'),
	(20339, 110, '2015-01-15 01:01:06.000000', 'temperatura', 978.0000, 'ºC'),
	(20340, 110, '2015-01-15 01:01:07.000000', 'temperatura', 1012.0000, 'ºC'),
	(20341, 110, '2015-01-15 01:01:08.000000', 'temperatura', 925.0000, 'ºC'),
	(20342, 110, '2015-01-15 01:01:09.000000', 'temperatura', 389.0000, 'ºC'),
	(20343, 110, '2015-01-15 01:01:10.000000', 'temperatura', 372.0000, 'ºC'),
	(20344, 110, '2015-01-15 01:01:11.000000', 'temperatura', 695.0000, 'ºC'),
	(20345, 110, '2015-01-15 01:01:12.000000', 'temperatura', 1158.0000, 'ºC'),
	(20346, 110, '2015-01-15 01:01:13.000000', 'temperatura', 107.0000, 'ºC'),
	(20347, 110, '2015-01-15 01:01:14.000000', 'temperatura', 659.0000, 'ºC'),
	(20348, 110, '2015-01-15 01:01:15.000000', 'temperatura', 574.0000, 'ºC'),
	(20349, 110, '2015-01-15 01:01:16.000000', 'temperatura', 895.0000, 'ºC'),
	(20350, 110, '2015-01-15 01:01:17.000000', 'temperatura', 351.0000, 'ºC'),
	(20351, 110, '2015-01-15 01:01:18.000000', 'temperatura', 273.0000, 'ºC'),
	(20352, 110, '2015-01-15 01:01:19.000000', 'temperatura', 311.0000, 'ºC'),
	(20353, 110, '2015-01-15 01:01:20.000000', 'temperatura', 739.0000, 'ºC'),
	(20354, 110, '2015-01-15 01:01:21.000000', 'temperatura', 360.0000, 'ºC'),
	(20355, 110, '2015-01-15 01:01:22.000000', 'temperatura', 784.0000, 'ºC'),
	(20356, 110, '2015-01-15 01:01:23.000000', 'temperatura', 442.0000, 'ºC'),
	(20357, 110, '2015-01-15 01:01:24.000000', 'temperatura', 1056.0000, 'ºC'),
	(20358, 110, '2015-01-15 01:01:25.000000', 'temperatura', 357.0000, 'ºC'),
	(20359, 110, '2015-01-15 01:01:26.000000', 'temperatura', 1015.0000, 'ºC'),
	(20360, 110, '2015-01-15 01:01:27.000000', 'temperatura', 407.0000, 'ºC'),
	(20361, 110, '2015-01-15 01:01:28.000000', 'temperatura', 188.0000, 'ºC'),
	(20362, 110, '2015-01-15 01:01:29.000000', 'temperatura', 918.0000, 'ºC'),
	(20363, 110, '2015-01-15 01:01:30.000000', 'temperatura', 430.0000, 'ºC'),
	(20364, 110, '2015-01-15 01:01:31.000000', 'temperatura', 596.0000, 'ºC'),
	(20365, 110, '2015-01-15 01:01:32.000000', 'temperatura', 489.0000, 'ºC'),
	(20366, 110, '2015-01-15 01:01:33.000000', 'temperatura', 659.0000, 'ºC'),
	(20367, 110, '2015-01-15 01:01:34.000000', 'temperatura', 629.0000, 'ºC'),
	(20368, 110, '2015-01-15 01:01:35.000000', 'temperatura', 1168.0000, 'ºC'),
	(20369, 110, '2015-01-15 01:01:36.000000', 'temperatura', 353.0000, 'ºC'),
	(20370, 110, '2015-01-15 01:01:37.000000', 'temperatura', 661.0000, 'ºC'),
	(20371, 110, '2015-01-15 01:01:38.000000', 'temperatura', 1046.0000, 'ºC'),
	(20372, 110, '2015-01-15 01:01:39.000000', 'temperatura', 850.0000, 'ºC'),
	(20373, 110, '2015-01-15 01:01:40.000000', 'temperatura', 1109.0000, 'ºC'),
	(20374, 110, '2015-01-15 01:01:41.000000', 'temperatura', 598.0000, 'ºC'),
	(20375, 110, '2015-01-15 01:01:42.000000', 'temperatura', 862.0000, 'ºC'),
	(20376, 110, '2015-01-15 01:01:43.000000', 'temperatura', 118.0000, 'ºC'),
	(20377, 110, '2015-01-15 01:01:44.000000', 'temperatura', 403.0000, 'ºC'),
	(20378, 110, '2015-01-15 01:01:45.000000', 'temperatura', 461.0000, 'ºC'),
	(20379, 110, '2015-01-15 01:01:46.000000', 'temperatura', 1099.0000, 'ºC'),
	(20380, 110, '2015-01-15 01:01:47.000000', 'temperatura', 511.0000, 'ºC'),
	(20381, 110, '2015-01-15 01:01:48.000000', 'temperatura', 457.0000, 'ºC'),
	(20382, 110, '2015-01-15 01:01:49.000000', 'temperatura', 755.0000, 'ºC'),
	(20383, 110, '2015-01-15 01:01:50.000000', 'temperatura', 6.0000, 'ºC'),
	(20384, 110, '2015-01-15 01:01:51.000000', 'temperatura', 162.0000, 'ºC'),
	(20385, 110, '2015-01-15 01:01:52.000000', 'temperatura', 792.0000, 'ºC'),
	(20386, 110, '2015-01-15 01:01:53.000000', 'temperatura', 1078.0000, 'ºC'),
	(20387, 110, '2015-01-15 01:01:54.000000', 'temperatura', 612.0000, 'ºC'),
	(20388, 110, '2015-01-15 01:01:55.000000', 'temperatura', 1026.0000, 'ºC'),
	(20389, 110, '2015-01-15 01:01:56.000000', 'temperatura', 895.0000, 'ºC'),
	(20390, 110, '2015-01-15 01:01:57.000000', 'temperatura', 199.0000, 'ºC'),
	(20391, 110, '2015-01-15 01:01:58.000000', 'temperatura', 708.0000, 'ºC'),
	(20392, 110, '2015-01-15 01:01:59.000000', 'temperatura', 542.0000, 'ºC'),
	(20393, 110, '2015-01-15 01:02:00.000000', 'temperatura', 590.0000, 'ºC'),
	(20394, 110, '2015-01-15 01:02:01.000000', 'temperatura', 125.0000, 'ºC'),
	(20395, 110, '2015-01-15 01:02:02.000000', 'temperatura', 55.0000, 'ºC'),
	(20396, 110, '2015-01-15 01:02:03.000000', 'temperatura', 1101.0000, 'ºC'),
	(20397, 110, '2015-01-15 01:02:04.000000', 'temperatura', 540.0000, 'ºC'),
	(20398, 110, '2015-01-15 01:02:05.000000', 'temperatura', 599.0000, 'ºC'),
	(20399, 110, '2015-01-15 01:02:06.000000', 'temperatura', 176.0000, 'ºC'),
	(20400, 110, '2015-01-15 01:02:07.000000', 'temperatura', 283.0000, 'ºC'),
	(20401, 110, '2015-01-15 01:02:08.000000', 'temperatura', 886.0000, 'ºC'),
	(20402, 110, '2015-01-15 01:02:09.000000', 'temperatura', 1181.0000, 'ºC'),
	(20403, 110, '2015-01-15 01:02:10.000000', 'temperatura', 850.0000, 'ºC'),
	(20404, 110, '2015-01-15 01:02:11.000000', 'temperatura', 707.0000, 'ºC'),
	(20405, 110, '2015-01-15 01:02:12.000000', 'temperatura', 984.0000, 'ºC'),
	(20406, 110, '2015-01-15 01:02:13.000000', 'temperatura', 401.0000, 'ºC'),
	(20407, 110, '2015-01-15 01:02:14.000000', 'temperatura', 252.0000, 'ºC'),
	(20408, 110, '2015-01-15 01:02:15.000000', 'temperatura', 57.0000, 'ºC'),
	(20409, 110, '2015-01-15 01:02:16.000000', 'temperatura', 731.0000, 'ºC'),
	(20410, 110, '2015-01-15 01:02:17.000000', 'temperatura', 1082.0000, 'ºC'),
	(20411, 110, '2015-01-15 01:02:18.000000', 'temperatura', 819.0000, 'ºC'),
	(20412, 110, '2015-01-15 01:02:19.000000', 'temperatura', 850.0000, 'ºC'),
	(20413, 110, '2015-01-15 01:02:20.000000', 'temperatura', 593.0000, 'ºC'),
	(20414, 110, '2015-01-15 01:02:21.000000', 'temperatura', 415.0000, 'ºC'),
	(20415, 110, '2015-01-15 01:02:22.000000', 'temperatura', 299.0000, 'ºC'),
	(20416, 110, '2015-01-15 01:02:23.000000', 'temperatura', 248.0000, 'ºC'),
	(20417, 110, '2015-01-15 01:02:24.000000', 'temperatura', 344.0000, 'ºC'),
	(20418, 110, '2015-01-15 01:02:25.000000', 'temperatura', 979.0000, 'ºC'),
	(20419, 110, '2015-01-15 01:02:26.000000', 'temperatura', 260.0000, 'ºC'),
	(20420, 110, '2015-01-15 01:02:27.000000', 'temperatura', 765.0000, 'ºC'),
	(20421, 110, '2015-01-15 01:02:28.000000', 'temperatura', 646.0000, 'ºC'),
	(20422, 110, '2015-01-15 01:02:29.000000', 'temperatura', 936.0000, 'ºC'),
	(20423, 110, '2015-01-15 01:02:30.000000', 'temperatura', 341.0000, 'ºC'),
	(20424, 110, '2015-01-15 01:02:31.000000', 'temperatura', 99.0000, 'ºC'),
	(20425, 110, '2015-01-15 01:02:32.000000', 'temperatura', 674.0000, 'ºC'),
	(20426, 110, '2015-01-15 01:02:33.000000', 'temperatura', 671.0000, 'ºC'),
	(20427, 110, '2015-01-15 01:02:34.000000', 'temperatura', 134.0000, 'ºC'),
	(20428, 110, '2015-01-15 01:02:35.000000', 'temperatura', 1057.0000, 'ºC'),
	(20429, 110, '2015-01-15 01:02:36.000000', 'temperatura', 86.0000, 'ºC'),
	(20430, 110, '2015-01-15 01:02:37.000000', 'temperatura', 858.0000, 'ºC'),
	(20431, 110, '2015-01-15 01:02:38.000000', 'temperatura', 433.0000, 'ºC'),
	(20432, 110, '2015-01-15 01:02:39.000000', 'temperatura', 792.0000, 'ºC'),
	(20433, 110, '2015-01-15 01:02:40.000000', 'temperatura', 259.0000, 'ºC'),
	(20434, 110, '2015-01-15 01:02:41.000000', 'temperatura', 122.0000, 'ºC'),
	(20435, 110, '2015-01-15 01:02:42.000000', 'temperatura', 1032.0000, 'ºC'),
	(20436, 110, '2015-01-15 01:02:43.000000', 'temperatura', 1193.0000, 'ºC'),
	(20437, 110, '2015-01-15 01:02:44.000000', 'temperatura', 471.0000, 'ºC'),
	(20438, 110, '2015-01-15 01:02:45.000000', 'temperatura', 1176.0000, 'ºC'),
	(20439, 110, '2015-01-15 01:02:46.000000', 'temperatura', 870.0000, 'ºC'),
	(20440, 110, '2015-01-15 01:02:47.000000', 'temperatura', 820.0000, 'ºC'),
	(20441, 110, '2015-01-15 01:02:48.000000', 'temperatura', 292.0000, 'ºC'),
	(20442, 110, '2015-01-15 01:02:49.000000', 'temperatura', 198.0000, 'ºC'),
	(20443, 110, '2015-01-15 01:02:50.000000', 'temperatura', 115.0000, 'ºC'),
	(20444, 110, '2015-01-15 01:02:51.000000', 'temperatura', 1183.0000, 'ºC'),
	(20445, 110, '2015-01-15 01:02:52.000000', 'temperatura', 772.0000, 'ºC'),
	(20446, 110, '2015-01-15 01:02:53.000000', 'temperatura', 309.0000, 'ºC'),
	(20447, 110, '2015-01-15 01:02:54.000000', 'temperatura', 430.0000, 'ºC'),
	(20448, 110, '2015-01-15 01:02:55.000000', 'temperatura', 24.0000, 'ºC'),
	(20449, 110, '2015-01-15 01:02:56.000000', 'temperatura', 32.0000, 'ºC'),
	(20450, 110, '2015-01-15 01:02:57.000000', 'temperatura', 89.0000, 'ºC'),
	(20451, 110, '2015-01-15 01:02:58.000000', 'temperatura', 347.0000, 'ºC'),
	(20452, 110, '2015-01-15 01:02:59.000000', 'temperatura', 270.0000, 'ºC'),
	(20453, 110, '2015-01-15 01:03:00.000000', 'temperatura', 309.0000, 'ºC'),
	(20454, 110, '2015-01-15 01:03:01.000000', 'temperatura', 735.0000, 'ºC'),
	(20455, 110, '2015-01-15 01:03:02.000000', 'temperatura', 351.0000, 'ºC'),
	(20456, 110, '2015-01-15 01:03:03.000000', 'temperatura', 749.0000, 'ºC'),
	(20457, 110, '2015-01-15 01:03:04.000000', 'temperatura', 293.0000, 'ºC'),
	(20458, 110, '2015-01-15 01:03:05.000000', 'temperatura', 420.0000, 'ºC'),
	(20459, 110, '2015-01-15 01:03:06.000000', 'temperatura', 19.0000, 'ºC'),
	(20460, 110, '2015-01-15 01:03:07.000000', 'temperatura', 36.0000, 'ºC'),
	(20461, 110, '2015-01-15 01:03:08.000000', 'temperatura', 123.0000, 'ºC'),
	(20462, 110, '2015-01-15 01:03:09.000000', 'temperatura', 508.0000, 'ºC'),
	(20463, 110, '2015-01-15 01:03:10.000000', 'temperatura', 970.0000, 'ºC'),
	(20464, 110, '2015-01-15 01:03:11.000000', 'temperatura', 928.0000, 'ºC'),
	(20465, 110, '2015-01-15 01:03:12.000000', 'temperatura', 531.0000, 'ºC'),
	(20466, 110, '2015-01-15 01:03:13.000000', 'temperatura', 1070.0000, 'ºC'),
	(20467, 110, '2015-01-15 01:03:14.000000', 'temperatura', 156.0000, 'ºC'),
	(20468, 110, '2015-01-15 01:03:15.000000', 'temperatura', 1174.0000, 'ºC'),
	(20469, 110, '2015-01-15 01:03:16.000000', 'temperatura', 599.0000, 'ºC'),
	(20470, 110, '2015-01-15 01:03:17.000000', 'temperatura', 676.0000, 'ºC'),
	(20471, 110, '2015-01-15 01:03:18.000000', 'temperatura', 383.0000, 'ºC'),
	(20472, 110, '2015-01-15 01:03:19.000000', 'temperatura', 1085.0000, 'ºC'),
	(20473, 110, '2015-01-15 01:03:20.000000', 'temperatura', 679.0000, 'ºC'),
	(20474, 110, '2015-01-15 01:03:21.000000', 'temperatura', 141.0000, 'ºC'),
	(20475, 110, '2015-01-15 01:03:22.000000', 'temperatura', 1068.0000, 'ºC'),
	(20476, 110, '2015-01-15 01:03:23.000000', 'temperatura', 117.0000, 'ºC'),
	(20477, 110, '2015-01-15 01:03:24.000000', 'temperatura', 983.0000, 'ºC'),
	(20478, 110, '2015-01-15 01:03:25.000000', 'temperatura', 964.0000, 'ºC'),
	(20479, 110, '2015-01-15 01:03:26.000000', 'temperatura', 670.0000, 'ºC'),
	(20480, 110, '2015-01-15 01:03:27.000000', 'temperatura', 459.0000, 'ºC'),
	(20481, 110, '2015-01-15 01:03:28.000000', 'temperatura', 287.0000, 'ºC'),
	(20482, 110, '2015-01-15 01:03:29.000000', 'temperatura', 56.0000, 'ºC'),
	(20483, 110, '2015-01-15 01:03:30.000000', 'temperatura', 623.0000, 'ºC'),
	(20484, 110, '2015-01-15 01:03:31.000000', 'temperatura', 544.0000, 'ºC'),
	(20485, 110, '2015-01-15 01:03:32.000000', 'temperatura', 853.0000, 'ºC'),
	(20486, 110, '2015-01-15 01:03:33.000000', 'temperatura', 233.0000, 'ºC'),
	(20487, 110, '2015-01-15 01:03:34.000000', 'temperatura', 1006.0000, 'ºC'),
	(20488, 110, '2015-01-15 01:03:35.000000', 'temperatura', 733.0000, 'ºC'),
	(20489, 110, '2015-01-15 01:03:36.000000', 'temperatura', 646.0000, 'ºC'),
	(20490, 110, '2015-01-15 01:03:37.000000', 'temperatura', 1033.0000, 'ºC'),
	(20491, 110, '2015-01-15 01:03:38.000000', 'temperatura', 825.0000, 'ºC'),
	(20492, 110, '2015-01-15 01:03:39.000000', 'temperatura', 1028.0000, 'ºC'),
	(20493, 110, '2015-01-15 01:03:40.000000', 'temperatura', 263.0000, 'ºC'),
	(20494, 110, '2015-01-15 01:03:41.000000', 'temperatura', 635.0000, 'ºC'),
	(20495, 110, '2015-01-15 01:03:42.000000', 'temperatura', 1186.0000, 'ºC'),
	(20496, 110, '2015-01-15 01:03:43.000000', 'temperatura', 426.0000, 'ºC'),
	(20497, 110, '2015-01-15 01:03:44.000000', 'temperatura', 972.0000, 'ºC'),
	(20498, 110, '2015-01-15 01:03:45.000000', 'temperatura', 1182.0000, 'ºC'),
	(20499, 110, '2015-01-15 01:03:46.000000', 'temperatura', 597.0000, 'ºC'),
	(20500, 110, '2015-01-15 01:03:47.000000', 'temperatura', 637.0000, 'ºC'),
	(20501, 110, '2015-01-15 01:03:48.000000', 'temperatura', 197.0000, 'ºC'),
	(20502, 110, '2015-01-15 01:03:49.000000', 'temperatura', 272.0000, 'ºC'),
	(20503, 110, '2015-01-15 01:03:50.000000', 'temperatura', 769.0000, 'ºC'),
	(20504, 110, '2015-01-15 01:03:51.000000', 'temperatura', 633.0000, 'ºC'),
	(20505, 110, '2015-01-15 01:03:52.000000', 'temperatura', 855.0000, 'ºC'),
	(20506, 110, '2015-01-15 01:03:53.000000', 'temperatura', 1177.0000, 'ºC'),
	(20507, 110, '2015-01-15 01:03:54.000000', 'temperatura', 920.0000, 'ºC'),
	(20508, 110, '2015-01-15 01:03:55.000000', 'temperatura', 1069.0000, 'ºC'),
	(20509, 110, '2015-01-15 01:03:56.000000', 'temperatura', 187.0000, 'ºC'),
	(20510, 110, '2015-01-15 01:03:57.000000', 'temperatura', 129.0000, 'ºC'),
	(20511, 110, '2015-01-15 01:03:58.000000', 'temperatura', 84.0000, 'ºC'),
	(20512, 110, '2015-01-15 01:03:59.000000', 'temperatura', 34.0000, 'ºC'),
	(20513, 110, '2015-01-15 01:04:00.000000', 'temperatura', 1120.0000, 'ºC'),
	(20514, 110, '2015-01-15 01:04:01.000000', 'temperatura', 697.0000, 'ºC'),
	(20515, 110, '2015-01-15 01:04:02.000000', 'temperatura', 128.0000, 'ºC'),
	(20516, 110, '2015-01-15 01:04:03.000000', 'temperatura', 947.0000, 'ºC'),
	(20517, 110, '2015-01-15 01:04:04.000000', 'temperatura', 751.0000, 'ºC'),
	(20518, 110, '2015-01-15 01:04:05.000000', 'temperatura', 914.0000, 'ºC'),
	(20519, 110, '2015-01-15 01:04:06.000000', 'temperatura', 1117.0000, 'ºC'),
	(20520, 110, '2015-01-15 01:04:07.000000', 'temperatura', 443.0000, 'ºC'),
	(20521, 110, '2015-01-15 01:04:08.000000', 'temperatura', 67.0000, 'ºC'),
	(20522, 110, '2015-01-15 01:04:09.000000', 'temperatura', 206.0000, 'ºC'),
	(20523, 110, '2015-01-15 01:04:10.000000', 'temperatura', 828.0000, 'ºC'),
	(20524, 110, '2015-01-15 01:04:11.000000', 'temperatura', 1124.0000, 'ºC'),
	(20525, 110, '2015-01-15 01:04:12.000000', 'temperatura', 737.0000, 'ºC'),
	(20526, 110, '2015-01-15 01:04:13.000000', 'temperatura', 314.0000, 'ºC'),
	(20527, 110, '2015-01-15 01:04:14.000000', 'temperatura', 559.0000, 'ºC'),
	(20528, 110, '2015-01-15 01:04:15.000000', 'temperatura', 654.0000, 'ºC'),
	(20529, 110, '2015-01-15 01:04:16.000000', 'temperatura', 391.0000, 'ºC'),
	(20530, 110, '2015-01-15 01:04:17.000000', 'temperatura', 1195.0000, 'ºC'),
	(20531, 110, '2015-01-15 01:04:18.000000', 'temperatura', 2.0000, 'ºC'),
	(20532, 110, '2015-01-15 01:04:19.000000', 'temperatura', 27.0000, 'ºC'),
	(20533, 110, '2015-01-15 01:04:20.000000', 'temperatura', 128.0000, 'ºC'),
	(20534, 110, '2015-01-15 01:04:21.000000', 'temperatura', 560.0000, 'ºC'),
	(20535, 110, '2015-01-15 01:04:22.000000', 'temperatura', 17.0000, 'ºC'),
	(20536, 110, '2015-01-15 01:04:23.000000', 'temperatura', 807.0000, 'ºC'),
	(20537, 110, '2015-01-15 01:04:24.000000', 'temperatura', 381.0000, 'ºC'),
	(20538, 110, '2015-01-15 01:04:25.000000', 'temperatura', 687.0000, 'ºC'),
	(20539, 110, '2015-01-15 01:04:26.000000', 'temperatura', 1090.0000, 'ºC'),
	(20540, 110, '2015-01-15 01:04:27.000000', 'temperatura', 993.0000, 'ºC'),
	(20541, 110, '2015-01-15 01:04:28.000000', 'temperatura', 492.0000, 'ºC'),
	(20542, 110, '2015-01-15 01:04:29.000000', 'temperatura', 684.0000, 'ºC'),
	(20543, 110, '2015-01-15 01:04:30.000000', 'temperatura', 744.0000, 'ºC'),
	(20544, 110, '2015-01-15 01:04:31.000000', 'temperatura', 466.0000, 'ºC'),
	(20545, 110, '2015-01-15 01:04:32.000000', 'temperatura', 101.0000, 'ºC'),
	(20546, 110, '2015-01-15 01:04:33.000000', 'temperatura', 309.0000, 'ºC'),
	(20547, 110, '2015-01-15 01:04:34.000000', 'temperatura', 41.0000, 'ºC'),
	(20548, 110, '2015-01-15 01:04:35.000000', 'temperatura', 477.0000, 'ºC'),
	(20549, 110, '2015-01-15 01:04:36.000000', 'temperatura', 1064.0000, 'ºC'),
	(20550, 110, '2015-01-15 01:04:37.000000', 'temperatura', 288.0000, 'ºC'),
	(20551, 110, '2015-01-15 01:04:38.000000', 'temperatura', 649.0000, 'ºC'),
	(20552, 110, '2015-01-15 01:04:39.000000', 'temperatura', 1180.0000, 'ºC'),
	(20553, 110, '2015-01-15 01:04:40.000000', 'temperatura', 356.0000, 'ºC'),
	(20554, 110, '2015-01-15 01:04:41.000000', 'temperatura', 638.0000, 'ºC'),
	(20555, 110, '2015-01-15 01:04:42.000000', 'temperatura', 924.0000, 'ºC'),
	(20556, 110, '2015-01-15 01:04:43.000000', 'temperatura', 304.0000, 'ºC'),
	(20557, 110, '2015-01-15 01:04:44.000000', 'temperatura', 1152.0000, 'ºC'),
	(20558, 110, '2015-01-15 01:04:45.000000', 'temperatura', 47.0000, 'ºC'),
	(20559, 110, '2015-01-15 01:04:46.000000', 'temperatura', 381.0000, 'ºC'),
	(20560, 110, '2015-01-15 01:04:47.000000', 'temperatura', 564.0000, 'ºC'),
	(20561, 110, '2015-01-15 01:04:48.000000', 'temperatura', 477.0000, 'ºC'),
	(20562, 110, '2015-01-15 01:04:49.000000', 'temperatura', 693.0000, 'ºC'),
	(20563, 110, '2015-01-15 01:04:50.000000', 'temperatura', 836.0000, 'ºC'),
	(20564, 110, '2015-01-15 01:04:51.000000', 'temperatura', 899.0000, 'ºC'),
	(20565, 110, '2015-01-15 01:04:52.000000', 'temperatura', 791.0000, 'ºC'),
	(20566, 110, '2015-01-15 01:04:53.000000', 'temperatura', 55.0000, 'ºC'),
	(20567, 110, '2015-01-15 01:04:54.000000', 'temperatura', 304.0000, 'ºC'),
	(20568, 110, '2015-01-15 01:04:55.000000', 'temperatura', 155.0000, 'ºC'),
	(20569, 110, '2015-01-15 01:04:56.000000', 'temperatura', 1064.0000, 'ºC'),
	(20570, 110, '2015-01-15 01:04:57.000000', 'temperatura', 55.0000, 'ºC'),
	(20571, 110, '2015-01-15 01:04:58.000000', 'temperatura', 682.0000, 'ºC'),
	(20572, 110, '2015-01-15 01:04:59.000000', 'temperatura', 847.0000, 'ºC'),
	(20573, 110, '2015-01-15 01:05:00.000000', 'temperatura', 990.0000, 'ºC'),
	(20574, 110, '2015-01-15 01:05:01.000000', 'temperatura', 7.0000, 'ºC'),
	(20575, 110, '2015-01-15 01:05:02.000000', 'temperatura', 668.0000, 'ºC'),
	(20576, 110, '2015-01-15 01:05:03.000000', 'temperatura', 920.0000, 'ºC'),
	(20577, 110, '2015-01-15 01:05:04.000000', 'temperatura', 197.0000, 'ºC'),
	(20578, 110, '2015-01-15 01:05:05.000000', 'temperatura', 624.0000, 'ºC'),
	(20579, 110, '2015-01-15 01:05:06.000000', 'temperatura', 130.0000, 'ºC'),
	(20580, 110, '2015-01-15 01:05:07.000000', 'temperatura', 1179.0000, 'ºC'),
	(20581, 110, '2015-01-15 01:05:08.000000', 'temperatura', 704.0000, 'ºC'),
	(20582, 110, '2015-01-15 01:05:09.000000', 'temperatura', 1186.0000, 'ºC'),
	(20583, 110, '2015-01-15 01:05:10.000000', 'temperatura', 219.0000, 'ºC'),
	(20584, 110, '2015-01-15 01:05:11.000000', 'temperatura', 1136.0000, 'ºC'),
	(20585, 110, '2015-01-15 01:05:12.000000', 'temperatura', 225.0000, 'ºC'),
	(20586, 110, '2015-01-15 01:05:13.000000', 'temperatura', 118.0000, 'ºC'),
	(20587, 110, '2015-01-15 01:05:14.000000', 'temperatura', 1114.0000, 'ºC'),
	(20588, 110, '2015-01-15 01:05:15.000000', 'temperatura', 418.0000, 'ºC'),
	(20589, 110, '2015-01-15 01:05:16.000000', 'temperatura', 1147.0000, 'ºC'),
	(20590, 110, '2015-01-15 01:05:17.000000', 'temperatura', 884.0000, 'ºC'),
	(20591, 110, '2015-01-15 01:05:18.000000', 'temperatura', 978.0000, 'ºC'),
	(20592, 110, '2015-01-15 01:05:19.000000', 'temperatura', 1037.0000, 'ºC'),
	(20593, 110, '2015-01-15 01:05:20.000000', 'temperatura', 1052.0000, 'ºC'),
	(20594, 110, '2015-01-15 01:05:21.000000', 'temperatura', 948.0000, 'ºC'),
	(20595, 110, '2015-01-15 01:05:22.000000', 'temperatura', 386.0000, 'ºC'),
	(20596, 110, '2015-01-15 01:05:23.000000', 'temperatura', 286.0000, 'ºC'),
	(20597, 110, '2015-01-15 01:05:24.000000', 'temperatura', 271.0000, 'ºC'),
	(20598, 110, '2015-01-15 01:05:25.000000', 'temperatura', 498.0000, 'ºC'),
	(20599, 110, '2015-01-15 01:05:26.000000', 'temperatura', 479.0000, 'ºC'),
	(20600, 110, '2015-01-15 01:05:27.000000', 'temperatura', 900.0000, 'ºC'),
	(20601, 110, '2015-01-15 01:05:28.000000', 'temperatura', 664.0000, 'ºC'),
	(20602, 110, '2015-01-15 01:05:29.000000', 'temperatura', 621.0000, 'ºC'),
	(20603, 110, '2015-01-15 01:05:30.000000', 'temperatura', 1114.0000, 'ºC'),
	(20604, 110, '2015-01-15 01:05:31.000000', 'temperatura', 106.0000, 'ºC'),
	(20605, 110, '2015-01-15 01:05:32.000000', 'temperatura', 788.0000, 'ºC'),
	(20606, 110, '2015-01-15 01:05:33.000000', 'temperatura', 25.0000, 'ºC'),
	(20607, 110, '2015-01-15 01:05:34.000000', 'temperatura', 159.0000, 'ºC'),
	(20608, 110, '2015-01-15 01:05:35.000000', 'temperatura', 721.0000, 'ºC'),
	(20609, 110, '2015-01-15 01:05:36.000000', 'temperatura', 727.0000, 'ºC'),
	(20610, 110, '2015-01-15 01:05:37.000000', 'temperatura', 276.0000, 'ºC'),
	(20611, 110, '2015-01-15 01:05:38.000000', 'temperatura', 397.0000, 'ºC'),
	(20612, 110, '2015-01-15 01:05:39.000000', 'temperatura', 1156.0000, 'ºC'),
	(20613, 110, '2015-01-15 01:05:40.000000', 'temperatura', 992.0000, 'ºC'),
	(20614, 110, '2015-01-15 01:05:41.000000', 'temperatura', 291.0000, 'ºC'),
	(20615, 110, '2015-01-15 01:05:42.000000', 'temperatura', 878.0000, 'ºC'),
	(20616, 110, '2015-01-15 01:05:43.000000', 'temperatura', 1120.0000, 'ºC'),
	(20617, 110, '2015-01-15 01:05:44.000000', 'temperatura', 565.0000, 'ºC'),
	(20618, 110, '2015-01-15 01:05:45.000000', 'temperatura', 668.0000, 'ºC'),
	(20619, 110, '2015-01-15 01:05:46.000000', 'temperatura', 443.0000, 'ºC'),
	(20620, 110, '2015-01-15 01:05:47.000000', 'temperatura', 211.0000, 'ºC'),
	(20621, 110, '2015-01-15 01:05:48.000000', 'temperatura', 926.0000, 'ºC'),
	(20622, 110, '2015-01-15 01:05:49.000000', 'temperatura', 401.0000, 'ºC'),
	(20623, 110, '2015-01-15 01:05:50.000000', 'temperatura', 424.0000, 'ºC'),
	(20624, 110, '2015-01-15 01:05:51.000000', 'temperatura', 919.0000, 'ºC'),
	(20625, 110, '2015-01-15 01:05:52.000000', 'temperatura', 923.0000, 'ºC'),
	(20626, 110, '2015-01-15 01:05:53.000000', 'temperatura', 657.0000, 'ºC'),
	(20627, 110, '2015-01-15 01:05:54.000000', 'temperatura', 517.0000, 'ºC'),
	(20628, 110, '2015-01-15 01:05:55.000000', 'temperatura', 616.0000, 'ºC'),
	(20629, 110, '2015-01-15 01:05:56.000000', 'temperatura', 330.0000, 'ºC'),
	(20630, 110, '2015-01-15 01:05:57.000000', 'temperatura', 1001.0000, 'ºC'),
	(20631, 110, '2015-01-15 01:05:58.000000', 'temperatura', 416.0000, 'ºC'),
	(20632, 110, '2015-01-15 01:05:59.000000', 'temperatura', 279.0000, 'ºC'),
	(20633, 110, '2015-01-15 01:06:00.000000', 'temperatura', 148.0000, 'ºC'),
	(20634, 110, '2015-01-15 01:06:01.000000', 'temperatura', 1102.0000, 'ºC'),
	(20635, 110, '2015-01-15 01:06:02.000000', 'temperatura', 265.0000, 'ºC'),
	(20636, 110, '2015-01-15 01:06:03.000000', 'temperatura', 420.0000, 'ºC'),
	(20637, 110, '2015-01-15 01:06:04.000000', 'temperatura', 107.0000, 'ºC'),
	(20638, 110, '2015-01-15 01:06:05.000000', 'temperatura', 476.0000, 'ºC'),
	(20639, 110, '2015-01-15 01:06:06.000000', 'temperatura', 860.0000, 'ºC'),
	(20640, 110, '2015-01-15 01:06:07.000000', 'temperatura', 471.0000, 'ºC'),
	(20641, 110, '2015-01-15 01:06:08.000000', 'temperatura', 975.0000, 'ºC'),
	(20642, 110, '2015-01-15 01:06:09.000000', 'temperatura', 1065.0000, 'ºC'),
	(20643, 110, '2015-01-15 01:06:10.000000', 'temperatura', 1198.0000, 'ºC'),
	(20644, 110, '2015-01-15 01:06:11.000000', 'temperatura', 394.0000, 'ºC'),
	(20645, 110, '2015-01-15 01:06:12.000000', 'temperatura', 779.0000, 'ºC'),
	(20646, 110, '2015-01-15 01:06:13.000000', 'temperatura', 314.0000, 'ºC'),
	(20647, 110, '2015-01-15 01:06:14.000000', 'temperatura', 431.0000, 'ºC'),
	(20648, 110, '2015-01-15 01:06:15.000000', 'temperatura', 14.0000, 'ºC'),
	(20649, 110, '2015-01-15 01:06:16.000000', 'temperatura', 1179.0000, 'ºC'),
	(20650, 110, '2015-01-15 01:06:17.000000', 'temperatura', 1054.0000, 'ºC'),
	(20651, 110, '2015-01-15 01:06:18.000000', 'temperatura', 531.0000, 'ºC'),
	(20652, 110, '2015-01-15 01:06:19.000000', 'temperatura', 695.0000, 'ºC'),
	(20653, 110, '2015-01-15 01:06:20.000000', 'temperatura', 684.0000, 'ºC'),
	(20654, 110, '2015-01-15 01:06:21.000000', 'temperatura', 133.0000, 'ºC'),
	(20655, 110, '2015-01-15 01:06:22.000000', 'temperatura', 1015.0000, 'ºC'),
	(20656, 110, '2015-01-15 01:06:23.000000', 'temperatura', 1076.0000, 'ºC'),
	(20657, 110, '2015-01-15 01:06:24.000000', 'temperatura', 1136.0000, 'ºC'),
	(20658, 110, '2015-01-15 01:06:25.000000', 'temperatura', 53.0000, 'ºC'),
	(20659, 110, '2015-01-15 01:06:26.000000', 'temperatura', 457.0000, 'ºC'),
	(20660, 110, '2015-01-15 01:06:27.000000', 'temperatura', 928.0000, 'ºC'),
	(20661, 110, '2015-01-15 01:06:28.000000', 'temperatura', 869.0000, 'ºC'),
	(20662, 110, '2015-01-15 01:06:29.000000', 'temperatura', 362.0000, 'ºC'),
	(20663, 110, '2015-01-15 01:06:30.000000', 'temperatura', 404.0000, 'ºC'),
	(20664, 110, '2015-01-15 01:06:31.000000', 'temperatura', 932.0000, 'ºC'),
	(20665, 110, '2015-01-15 01:06:32.000000', 'temperatura', 1049.0000, 'ºC'),
	(20666, 110, '2015-01-15 01:06:33.000000', 'temperatura', 51.0000, 'ºC'),
	(20667, 110, '2015-01-15 01:06:34.000000', 'temperatura', 707.0000, 'ºC'),
	(20668, 110, '2015-01-15 01:06:35.000000', 'temperatura', 982.0000, 'ºC'),
	(20669, 110, '2015-01-15 01:06:36.000000', 'temperatura', 389.0000, 'ºC'),
	(20670, 110, '2015-01-15 01:06:37.000000', 'temperatura', 199.0000, 'ºC'),
	(20671, 110, '2015-01-15 01:06:38.000000', 'temperatura', 1031.0000, 'ºC'),
	(20672, 110, '2015-01-15 01:06:39.000000', 'temperatura', 958.0000, 'ºC'),
	(20673, 110, '2015-01-15 01:06:40.000000', 'temperatura', 497.0000, 'ºC'),
	(20674, 110, '2015-01-15 01:06:41.000000', 'temperatura', 810.0000, 'ºC'),
	(20675, 110, '2015-01-15 01:06:42.000000', 'temperatura', 162.0000, 'ºC'),
	(20676, 110, '2015-01-15 01:06:43.000000', 'temperatura', 781.0000, 'ºC'),
	(20677, 110, '2015-01-15 01:06:44.000000', 'temperatura', 1017.0000, 'ºC'),
	(20678, 110, '2015-01-15 01:06:45.000000', 'temperatura', 345.0000, 'ºC'),
	(20679, 110, '2015-01-15 01:06:46.000000', 'temperatura', 1072.0000, 'ºC'),
	(20680, 110, '2015-01-15 01:06:47.000000', 'temperatura', 728.0000, 'ºC'),
	(20681, 110, '2015-01-15 01:06:48.000000', 'temperatura', 423.0000, 'ºC'),
	(20682, 110, '2015-01-15 01:06:49.000000', 'temperatura', 1133.0000, 'ºC'),
	(20683, 110, '2015-01-15 01:06:50.000000', 'temperatura', 795.0000, 'ºC'),
	(20684, 110, '2015-01-15 01:06:51.000000', 'temperatura', 579.0000, 'ºC'),
	(20685, 110, '2015-01-15 01:06:52.000000', 'temperatura', 509.0000, 'ºC'),
	(20686, 110, '2015-01-15 01:06:53.000000', 'temperatura', 809.0000, 'ºC'),
	(20687, 110, '2015-01-15 01:06:54.000000', 'temperatura', 119.0000, 'ºC'),
	(20688, 110, '2015-01-15 01:06:55.000000', 'temperatura', 570.0000, 'ºC'),
	(20689, 110, '2015-01-15 01:06:56.000000', 'temperatura', 90.0000, 'ºC'),
	(20690, 110, '2015-01-15 01:06:57.000000', 'temperatura', 1144.0000, 'ºC'),
	(20691, 110, '2015-01-15 01:06:58.000000', 'temperatura', 648.0000, 'ºC'),
	(20692, 110, '2015-01-15 01:06:59.000000', 'temperatura', 1009.0000, 'ºC'),
	(20693, 110, '2015-01-15 01:07:00.000000', 'temperatura', 700.0000, 'ºC'),
	(20694, 110, '2015-01-15 01:07:01.000000', 'temperatura', 473.0000, 'ºC'),
	(20695, 110, '2015-01-15 01:07:02.000000', 'temperatura', 269.0000, 'ºC'),
	(20696, 110, '2015-01-15 01:07:03.000000', 'temperatura', 1123.0000, 'ºC'),
	(20697, 110, '2015-01-15 01:07:04.000000', 'temperatura', 11.0000, 'ºC'),
	(20698, 110, '2015-01-15 01:07:05.000000', 'temperatura', 287.0000, 'ºC'),
	(20699, 110, '2015-01-15 01:07:06.000000', 'temperatura', 203.0000, 'ºC'),
	(20700, 110, '2015-01-15 01:07:07.000000', 'temperatura', 152.0000, 'ºC'),
	(20701, 110, '2015-01-15 01:07:08.000000', 'temperatura', 153.0000, 'ºC'),
	(20702, 110, '2015-01-15 01:07:09.000000', 'temperatura', 308.0000, 'ºC'),
	(20703, 110, '2015-01-15 01:07:10.000000', 'temperatura', 1084.0000, 'ºC'),
	(20704, 110, '2015-01-15 01:07:11.000000', 'temperatura', 896.0000, 'ºC'),
	(20705, 110, '2015-01-15 01:07:12.000000', 'temperatura', 30.0000, 'ºC'),
	(20706, 110, '2015-01-15 01:07:13.000000', 'temperatura', 1060.0000, 'ºC'),
	(20707, 110, '2015-01-15 01:07:14.000000', 'temperatura', 411.0000, 'ºC'),
	(20708, 110, '2015-01-15 01:07:15.000000', 'temperatura', 75.0000, 'ºC'),
	(20709, 110, '2015-01-15 01:07:16.000000', 'temperatura', 342.0000, 'ºC'),
	(20710, 110, '2015-01-15 01:07:17.000000', 'temperatura', 285.0000, 'ºC'),
	(20711, 110, '2015-01-15 01:07:18.000000', 'temperatura', 400.0000, 'ºC'),
	(20712, 110, '2015-01-15 01:07:19.000000', 'temperatura', 1145.0000, 'ºC'),
	(20713, 110, '2015-01-15 01:07:20.000000', 'temperatura', 928.0000, 'ºC'),
	(20714, 110, '2015-01-15 01:07:21.000000', 'temperatura', 3.0000, 'ºC'),
	(20715, 110, '2015-01-15 01:07:22.000000', 'temperatura', 834.0000, 'ºC'),
	(20716, 110, '2015-01-15 01:07:23.000000', 'temperatura', 562.0000, 'ºC'),
	(20717, 110, '2015-01-15 01:07:24.000000', 'temperatura', 307.0000, 'ºC'),
	(20718, 110, '2015-01-15 01:07:25.000000', 'temperatura', 1048.0000, 'ºC'),
	(20719, 110, '2015-01-15 01:07:26.000000', 'temperatura', 720.0000, 'ºC'),
	(20720, 110, '2015-01-15 01:07:27.000000', 'temperatura', 457.0000, 'ºC'),
	(20721, 110, '2015-01-15 01:07:28.000000', 'temperatura', 124.0000, 'ºC'),
	(20722, 110, '2015-01-15 01:07:29.000000', 'temperatura', 450.0000, 'ºC'),
	(20723, 110, '2015-01-15 01:07:30.000000', 'temperatura', 677.0000, 'ºC'),
	(20724, 110, '2015-01-15 01:07:31.000000', 'temperatura', 837.0000, 'ºC'),
	(20725, 110, '2015-01-15 01:07:32.000000', 'temperatura', 953.0000, 'ºC'),
	(20726, 110, '2015-01-15 01:07:33.000000', 'temperatura', 1056.0000, 'ºC'),
	(20727, 110, '2015-01-15 01:07:34.000000', 'temperatura', 22.0000, 'ºC'),
	(20728, 110, '2015-01-15 01:07:35.000000', 'temperatura', 542.0000, 'ºC'),
	(20729, 110, '2015-01-15 01:07:36.000000', 'temperatura', 246.0000, 'ºC'),
	(20730, 110, '2015-01-15 01:07:37.000000', 'temperatura', 806.0000, 'ºC'),
	(20731, 110, '2015-01-15 01:07:38.000000', 'temperatura', 889.0000, 'ºC'),
	(20732, 110, '2015-01-15 01:07:39.000000', 'temperatura', 827.0000, 'ºC'),
	(20733, 110, '2015-01-15 01:07:40.000000', 'temperatura', 269.0000, 'ºC'),
	(20734, 110, '2015-01-15 01:07:41.000000', 'temperatura', 65.0000, 'ºC'),
	(20735, 110, '2015-01-15 01:07:42.000000', 'temperatura', 720.0000, 'ºC'),
	(20736, 110, '2015-01-15 01:07:43.000000', 'temperatura', 1004.0000, 'ºC'),
	(20737, 110, '2015-01-15 01:07:44.000000', 'temperatura', 461.0000, 'ºC'),
	(20738, 110, '2015-01-15 01:07:45.000000', 'temperatura', 491.0000, 'ºC'),
	(20739, 110, '2015-01-15 01:07:46.000000', 'temperatura', 1075.0000, 'ºC'),
	(20740, 110, '2015-01-15 01:07:47.000000', 'temperatura', 303.0000, 'ºC'),
	(20741, 110, '2015-01-15 01:07:48.000000', 'temperatura', 692.0000, 'ºC'),
	(20742, 110, '2015-01-15 01:07:49.000000', 'temperatura', 148.0000, 'ºC'),
	(20743, 110, '2015-01-15 01:07:50.000000', 'temperatura', 1068.0000, 'ºC'),
	(20744, 110, '2015-01-15 01:07:51.000000', 'temperatura', 95.0000, 'ºC'),
	(20745, 110, '2015-01-15 01:07:52.000000', 'temperatura', 870.0000, 'ºC'),
	(20746, 110, '2015-01-15 01:07:53.000000', 'temperatura', 467.0000, 'ºC'),
	(20747, 110, '2015-01-15 01:07:54.000000', 'temperatura', 925.0000, 'ºC'),
	(20748, 110, '2015-01-15 01:07:55.000000', 'temperatura', 823.0000, 'ºC'),
	(20749, 110, '2015-01-15 01:07:56.000000', 'temperatura', 140.0000, 'ºC'),
	(20750, 110, '2015-01-15 01:07:57.000000', 'temperatura', 632.0000, 'ºC'),
	(20751, 110, '2015-01-15 01:07:58.000000', 'temperatura', 340.0000, 'ºC'),
	(20752, 110, '2015-01-15 01:07:59.000000', 'temperatura', 1004.0000, 'ºC'),
	(20753, 110, '2015-01-15 01:08:00.000000', 'temperatura', 400.0000, 'ºC'),
	(20754, 110, '2015-01-15 01:08:01.000000', 'temperatura', 188.0000, 'ºC'),
	(20755, 110, '2015-01-15 01:08:02.000000', 'temperatura', 941.0000, 'ºC'),
	(20756, 110, '2015-01-15 01:08:03.000000', 'temperatura', 542.0000, 'ºC'),
	(20757, 110, '2015-01-15 01:08:04.000000', 'temperatura', 1087.0000, 'ºC'),
	(20758, 110, '2015-01-15 01:08:05.000000', 'temperatura', 212.0000, 'ºC'),
	(20759, 110, '2015-01-15 01:08:06.000000', 'temperatura', 196.0000, 'ºC'),
	(20760, 110, '2015-01-15 01:08:07.000000', 'temperatura', 347.0000, 'ºC'),
	(20761, 110, '2015-01-15 01:08:08.000000', 'temperatura', 1145.0000, 'ºC'),
	(20762, 110, '2015-01-15 01:08:09.000000', 'temperatura', 1086.0000, 'ºC'),
	(20763, 110, '2015-01-15 01:08:10.000000', 'temperatura', 793.0000, 'ºC'),
	(20764, 110, '2015-01-15 01:08:11.000000', 'temperatura', 711.0000, 'ºC'),
	(20765, 110, '2015-01-15 01:08:12.000000', 'temperatura', 1174.0000, 'ºC'),
	(20766, 110, '2015-01-15 01:08:13.000000', 'temperatura', 138.0000, 'ºC'),
	(20767, 110, '2015-01-15 01:08:14.000000', 'temperatura', 767.0000, 'ºC'),
	(20768, 110, '2015-01-15 01:08:15.000000', 'temperatura', 1023.0000, 'ºC'),
	(20769, 110, '2015-01-15 01:08:16.000000', 'temperatura', 414.0000, 'ºC'),
	(20770, 110, '2015-01-15 01:08:17.000000', 'temperatura', 200.0000, 'ºC'),
	(20771, 110, '2015-01-15 01:08:18.000000', 'temperatura', 959.0000, 'ºC'),
	(20772, 110, '2015-01-15 01:08:19.000000', 'temperatura', 596.0000, 'ºC'),
	(20773, 110, '2015-01-15 01:08:20.000000', 'temperatura', 102.0000, 'ºC'),
	(20774, 110, '2015-01-15 01:08:21.000000', 'temperatura', 1126.0000, 'ºC'),
	(20775, 110, '2015-01-15 01:08:22.000000', 'temperatura', 521.0000, 'ºC'),
	(20776, 110, '2015-01-15 01:08:23.000000', 'temperatura', 428.0000, 'ºC'),
	(20777, 110, '2015-01-15 01:08:24.000000', 'temperatura', 580.0000, 'ºC'),
	(20778, 110, '2015-01-15 01:08:25.000000', 'temperatura', 413.0000, 'ºC'),
	(20779, 110, '2015-01-15 01:08:26.000000', 'temperatura', 329.0000, 'ºC'),
	(20780, 110, '2015-01-15 01:08:27.000000', 'temperatura', 403.0000, 'ºC'),
	(20781, 110, '2015-01-15 01:08:28.000000', 'temperatura', 1031.0000, 'ºC'),
	(20782, 110, '2015-01-15 01:08:29.000000', 'temperatura', 346.0000, 'ºC'),
	(20783, 110, '2015-01-15 01:08:30.000000', 'temperatura', 1038.0000, 'ºC'),
	(20784, 110, '2015-01-15 01:08:31.000000', 'temperatura', 550.0000, 'ºC'),
	(20785, 110, '2015-01-15 01:08:32.000000', 'temperatura', 839.0000, 'ºC'),
	(20786, 110, '2015-01-15 01:08:33.000000', 'temperatura', 143.0000, 'ºC'),
	(20787, 110, '2015-01-15 01:08:34.000000', 'temperatura', 600.0000, 'ºC'),
	(20788, 110, '2015-01-15 01:08:35.000000', 'temperatura', 173.0000, 'ºC'),
	(20789, 110, '2015-01-15 01:08:36.000000', 'temperatura', 266.0000, 'ºC'),
	(20790, 110, '2015-01-15 01:08:37.000000', 'temperatura', 808.0000, 'ºC'),
	(20791, 110, '2015-01-15 01:08:38.000000', 'temperatura', 845.0000, 'ºC'),
	(20792, 110, '2015-01-15 01:08:39.000000', 'temperatura', 603.0000, 'ºC'),
	(20793, 110, '2015-01-15 01:08:40.000000', 'temperatura', 479.0000, 'ºC'),
	(20794, 110, '2015-01-15 01:08:41.000000', 'temperatura', 585.0000, 'ºC'),
	(20795, 110, '2015-01-15 01:08:42.000000', 'temperatura', 292.0000, 'ºC'),
	(20796, 110, '2015-01-15 01:08:43.000000', 'temperatura', 902.0000, 'ºC'),
	(20797, 110, '2015-01-15 01:08:44.000000', 'temperatura', 36.0000, 'ºC'),
	(20798, 110, '2015-01-15 01:08:45.000000', 'temperatura', 1076.0000, 'ºC'),
	(20799, 110, '2015-01-15 01:08:46.000000', 'temperatura', 470.0000, 'ºC'),
	(20800, 110, '2015-01-15 01:08:47.000000', 'temperatura', 322.0000, 'ºC'),
	(20801, 110, '2015-01-15 01:08:48.000000', 'temperatura', 203.0000, 'ºC'),
	(20802, 110, '2015-01-15 01:08:49.000000', 'temperatura', 48.0000, 'ºC'),
	(20803, 110, '2015-01-15 01:08:50.000000', 'temperatura', 830.0000, 'ºC'),
	(20804, 110, '2015-01-15 01:08:51.000000', 'temperatura', 408.0000, 'ºC'),
	(20805, 110, '2015-01-15 01:08:52.000000', 'temperatura', 749.0000, 'ºC'),
	(20806, 110, '2015-01-15 01:08:53.000000', 'temperatura', 121.0000, 'ºC'),
	(20807, 110, '2015-01-15 01:08:54.000000', 'temperatura', 759.0000, 'ºC'),
	(20808, 110, '2015-01-15 01:08:55.000000', 'temperatura', 1031.0000, 'ºC'),
	(20809, 110, '2015-01-15 01:08:56.000000', 'temperatura', 482.0000, 'ºC'),
	(20810, 110, '2015-01-15 01:08:57.000000', 'temperatura', 514.0000, 'ºC'),
	(20811, 110, '2015-01-15 01:08:58.000000', 'temperatura', 1125.0000, 'ºC'),
	(20812, 110, '2015-01-15 01:08:59.000000', 'temperatura', 486.0000, 'ºC'),
	(20813, 110, '2015-01-15 01:09:00.000000', 'temperatura', 253.0000, 'ºC'),
	(20814, 110, '2015-01-15 01:09:01.000000', 'temperatura', 1009.0000, 'ºC'),
	(20815, 110, '2015-01-15 01:09:02.000000', 'temperatura', 684.0000, 'ºC'),
	(20816, 110, '2015-01-15 01:09:03.000000', 'temperatura', 397.0000, 'ºC'),
	(20817, 110, '2015-01-15 01:09:04.000000', 'temperatura', 1130.0000, 'ºC'),
	(20818, 110, '2015-01-15 01:09:05.000000', 'temperatura', 863.0000, 'ºC'),
	(20819, 110, '2015-01-15 01:09:06.000000', 'temperatura', 923.0000, 'ºC'),
	(20820, 110, '2015-01-15 01:09:07.000000', 'temperatura', 828.0000, 'ºC'),
	(20821, 110, '2015-01-15 01:09:08.000000', 'temperatura', 169.0000, 'ºC'),
	(20822, 110, '2015-01-15 01:09:09.000000', 'temperatura', 763.0000, 'ºC'),
	(20823, 110, '2015-01-15 01:09:10.000000', 'temperatura', 909.0000, 'ºC'),
	(20824, 110, '2015-01-15 01:09:11.000000', 'temperatura', 1056.0000, 'ºC'),
	(20825, 110, '2015-01-15 01:09:12.000000', 'temperatura', 153.0000, 'ºC'),
	(20826, 110, '2015-01-15 01:09:13.000000', 'temperatura', 0.0000, 'ºC'),
	(20827, 110, '2015-01-15 01:09:14.000000', 'temperatura', 738.0000, 'ºC'),
	(20828, 110, '2015-01-15 01:09:15.000000', 'temperatura', 93.0000, 'ºC'),
	(20829, 110, '2015-01-15 01:09:16.000000', 'temperatura', 649.0000, 'ºC'),
	(20830, 110, '2015-01-15 01:09:17.000000', 'temperatura', 568.0000, 'ºC'),
	(20831, 110, '2015-01-15 01:09:18.000000', 'temperatura', 895.0000, 'ºC'),
	(20832, 110, '2015-01-15 01:09:19.000000', 'temperatura', 370.0000, 'ºC'),
	(20833, 110, '2015-01-15 01:09:20.000000', 'temperatura', 364.0000, 'ºC'),
	(20834, 110, '2015-01-15 01:09:21.000000', 'temperatura', 712.0000, 'ºC'),
	(20835, 110, '2015-01-15 01:09:22.000000', 'temperatura', 70.0000, 'ºC'),
	(20836, 110, '2015-01-15 01:09:23.000000', 'temperatura', 614.0000, 'ºC'),
	(20837, 110, '2015-01-15 01:09:24.000000', 'temperatura', 462.0000, 'ºC'),
	(20838, 110, '2015-01-15 01:09:25.000000', 'temperatura', 466.0000, 'ºC'),
	(20839, 110, '2015-01-15 01:09:26.000000', 'temperatura', 947.0000, 'ºC'),
	(20840, 110, '2015-01-15 01:09:27.000000', 'temperatura', 935.0000, 'ºC'),
	(20841, 110, '2015-01-15 01:09:28.000000', 'temperatura', 634.0000, 'ºC'),
	(20842, 110, '2015-01-15 01:09:29.000000', 'temperatura', 366.0000, 'ºC'),
	(20843, 110, '2015-01-15 01:09:30.000000', 'temperatura', 1128.0000, 'ºC'),
	(20844, 110, '2015-01-15 01:09:31.000000', 'temperatura', 942.0000, 'ºC'),
	(20845, 110, '2015-01-15 01:09:32.000000', 'temperatura', 125.0000, 'ºC'),
	(20846, 110, '2015-01-15 01:09:33.000000', 'temperatura', 202.0000, 'ºC'),
	(20847, 110, '2015-01-15 01:09:34.000000', 'temperatura', 636.0000, 'ºC'),
	(20848, 110, '2015-01-15 01:09:35.000000', 'temperatura', 172.0000, 'ºC'),
	(20849, 110, '2015-01-15 01:09:36.000000', 'temperatura', 155.0000, 'ºC'),
	(20850, 110, '2015-01-15 01:09:37.000000', 'temperatura', 260.0000, 'ºC'),
	(20851, 110, '2015-01-15 01:09:38.000000', 'temperatura', 833.0000, 'ºC'),
	(20852, 110, '2015-01-15 01:09:39.000000', 'temperatura', 988.0000, 'ºC'),
	(20853, 110, '2015-01-15 01:09:40.000000', 'temperatura', 42.0000, 'ºC'),
	(20854, 110, '2015-01-15 01:09:41.000000', 'temperatura', 846.0000, 'ºC'),
	(20855, 110, '2015-01-15 01:09:42.000000', 'temperatura', 504.0000, 'ºC'),
	(20856, 110, '2015-01-15 01:09:43.000000', 'temperatura', 1183.0000, 'ºC'),
	(20857, 110, '2015-01-15 01:09:44.000000', 'temperatura', 802.0000, 'ºC'),
	(20858, 110, '2015-01-15 01:09:45.000000', 'temperatura', 463.0000, 'ºC'),
	(20859, 110, '2015-01-15 01:09:46.000000', 'temperatura', 1107.0000, 'ºC'),
	(20860, 110, '2015-01-15 01:09:47.000000', 'temperatura', 548.0000, 'ºC'),
	(20861, 110, '2015-01-15 01:09:48.000000', 'temperatura', 620.0000, 'ºC'),
	(20862, 110, '2015-01-15 01:09:49.000000', 'temperatura', 256.0000, 'ºC'),
	(20863, 110, '2015-01-15 01:09:50.000000', 'temperatura', 620.0000, 'ºC'),
	(20864, 110, '2015-01-15 01:09:51.000000', 'temperatura', 1134.0000, 'ºC'),
	(20865, 110, '2015-01-15 01:09:52.000000', 'temperatura', 212.0000, 'ºC'),
	(20866, 110, '2015-01-15 01:09:53.000000', 'temperatura', 55.0000, 'ºC'),
	(20867, 110, '2015-01-15 01:09:54.000000', 'temperatura', 840.0000, 'ºC'),
	(20868, 110, '2015-01-15 01:09:55.000000', 'temperatura', 437.0000, 'ºC'),
	(20869, 110, '2015-01-15 01:09:56.000000', 'temperatura', 863.0000, 'ºC'),
	(20870, 110, '2015-01-15 01:09:57.000000', 'temperatura', 607.0000, 'ºC'),
	(20871, 110, '2015-01-15 01:09:58.000000', 'temperatura', 445.0000, 'ºC'),
	(20872, 110, '2015-01-15 01:09:59.000000', 'temperatura', 407.0000, 'ºC'),
	(20873, 110, '2015-01-15 01:10:00.000000', 'temperatura', 698.0000, 'ºC'),
	(20874, 110, '2015-01-15 01:10:01.000000', 'temperatura', 1072.0000, 'ºC'),
	(20875, 110, '2015-01-15 01:10:02.000000', 'temperatura', 867.0000, 'ºC'),
	(20876, 110, '2015-01-15 01:10:03.000000', 'temperatura', 1117.0000, 'ºC'),
	(20877, 110, '2015-01-15 01:10:04.000000', 'temperatura', 587.0000, 'ºC'),
	(20878, 110, '2015-01-15 01:10:05.000000', 'temperatura', 784.0000, 'ºC'),
	(20879, 110, '2015-01-15 01:10:06.000000', 'temperatura', 957.0000, 'ºC'),
	(20880, 110, '2015-01-15 01:10:07.000000', 'temperatura', 35.0000, 'ºC'),
	(20881, 110, '2015-01-15 01:10:08.000000', 'temperatura', 906.0000, 'ºC'),
	(20882, 110, '2015-01-15 01:10:09.000000', 'temperatura', 824.0000, 'ºC'),
	(20883, 110, '2015-01-15 01:10:10.000000', 'temperatura', 204.0000, 'ºC'),
	(20884, 110, '2015-01-15 01:10:11.000000', 'temperatura', 947.0000, 'ºC'),
	(20885, 110, '2015-01-15 01:10:12.000000', 'temperatura', 524.0000, 'ºC'),
	(20886, 110, '2015-01-15 01:10:13.000000', 'temperatura', 979.0000, 'ºC'),
	(20887, 110, '2015-01-15 01:10:14.000000', 'temperatura', 924.0000, 'ºC'),
	(20888, 110, '2015-01-15 01:10:15.000000', 'temperatura', 485.0000, 'ºC'),
	(20889, 110, '2015-01-15 01:10:16.000000', 'temperatura', 854.0000, 'ºC'),
	(20890, 110, '2015-01-15 01:10:17.000000', 'temperatura', 413.0000, 'ºC'),
	(20891, 110, '2015-01-15 01:10:18.000000', 'temperatura', 706.0000, 'ºC'),
	(20892, 110, '2015-01-15 01:10:19.000000', 'temperatura', 1090.0000, 'ºC'),
	(20893, 110, '2015-01-15 01:10:20.000000', 'temperatura', 931.0000, 'ºC'),
	(20894, 110, '2015-01-15 01:10:21.000000', 'temperatura', 187.0000, 'ºC'),
	(20895, 110, '2015-01-15 01:10:22.000000', 'temperatura', 544.0000, 'ºC'),
	(20896, 110, '2015-01-15 01:10:23.000000', 'temperatura', 960.0000, 'ºC'),
	(20897, 110, '2015-01-15 01:10:24.000000', 'temperatura', 767.0000, 'ºC'),
	(20898, 110, '2015-01-15 01:10:25.000000', 'temperatura', 955.0000, 'ºC'),
	(20899, 110, '2015-01-15 01:10:26.000000', 'temperatura', 77.0000, 'ºC'),
	(20900, 110, '2015-01-15 01:10:27.000000', 'temperatura', 1119.0000, 'ºC'),
	(20901, 110, '2015-01-15 01:10:28.000000', 'temperatura', 566.0000, 'ºC'),
	(20902, 110, '2015-01-15 01:10:29.000000', 'temperatura', 674.0000, 'ºC'),
	(20903, 110, '2015-01-15 01:10:30.000000', 'temperatura', 470.0000, 'ºC'),
	(20904, 110, '2015-01-15 01:10:31.000000', 'temperatura', 330.0000, 'ºC'),
	(20905, 110, '2015-01-15 01:10:32.000000', 'temperatura', 241.0000, 'ºC'),
	(20906, 110, '2015-01-15 01:10:33.000000', 'temperatura', 215.0000, 'ºC'),
	(20907, 110, '2015-01-15 01:10:34.000000', 'temperatura', 351.0000, 'ºC'),
	(20908, 110, '2015-01-15 01:10:35.000000', 'temperatura', 1113.0000, 'ºC'),
	(20909, 110, '2015-01-15 01:10:36.000000', 'temperatura', 913.0000, 'ºC'),
	(20910, 110, '2015-01-15 01:10:37.000000', 'temperatura', 27.0000, 'ºC'),
	(20911, 110, '2015-01-15 01:10:38.000000', 'temperatura', 993.0000, 'ºC'),
	(20912, 110, '2015-01-15 01:10:39.000000', 'temperatura', 88.0000, 'ºC'),
	(20913, 110, '2015-01-15 01:10:40.000000', 'temperatura', 1061.0000, 'ºC'),
	(20914, 110, '2015-01-15 01:10:41.000000', 'temperatura', 240.0000, 'ºC'),
	(20915, 110, '2015-01-15 01:10:42.000000', 'temperatura', 419.0000, 'ºC'),
	(20916, 110, '2015-01-15 01:10:43.000000', 'temperatura', 177.0000, 'ºC'),
	(20917, 110, '2015-01-15 01:10:44.000000', 'temperatura', 826.0000, 'ºC'),
	(20918, 110, '2015-01-15 01:10:45.000000', 'temperatura', 1199.0000, 'ºC'),
	(20919, 110, '2015-01-15 01:10:46.000000', 'temperatura', 1117.0000, 'ºC'),
	(20920, 110, '2015-01-15 01:10:47.000000', 'temperatura', 789.0000, 'ºC'),
	(20921, 110, '2015-01-15 01:10:48.000000', 'temperatura', 594.0000, 'ºC'),
	(20922, 110, '2015-01-15 01:10:49.000000', 'temperatura', 606.0000, 'ºC'),
	(20923, 110, '2015-01-15 01:10:50.000000', 'temperatura', 46.0000, 'ºC'),
	(20924, 110, '2015-01-15 01:10:51.000000', 'temperatura', 815.0000, 'ºC'),
	(20925, 110, '2015-01-15 01:10:52.000000', 'temperatura', 334.0000, 'ºC'),
	(20926, 110, '2015-01-15 01:10:53.000000', 'temperatura', 428.0000, 'ºC'),
	(20927, 110, '2015-01-15 01:10:54.000000', 'temperatura', 1140.0000, 'ºC'),
	(20928, 110, '2015-01-15 01:10:55.000000', 'temperatura', 813.0000, 'ºC'),
	(20929, 110, '2015-01-15 01:10:56.000000', 'temperatura', 648.0000, 'ºC'),
	(20930, 110, '2015-01-15 01:10:57.000000', 'temperatura', 799.0000, 'ºC'),
	(20931, 110, '2015-01-15 01:10:58.000000', 'temperatura', 851.0000, 'ºC'),
	(20932, 110, '2015-01-15 01:10:59.000000', 'temperatura', 660.0000, 'ºC'),
	(20933, 110, '2015-01-15 01:11:00.000000', 'temperatura', 747.0000, 'ºC'),
	(20934, 110, '2015-01-15 01:11:01.000000', 'temperatura', 555.0000, 'ºC'),
	(20935, 110, '2015-01-15 01:11:02.000000', 'temperatura', 535.0000, 'ºC'),
	(20936, 110, '2015-01-15 01:11:03.000000', 'temperatura', 1009.0000, 'ºC'),
	(20937, 110, '2015-01-15 01:11:04.000000', 'temperatura', 1043.0000, 'ºC'),
	(20938, 110, '2015-01-15 01:11:05.000000', 'temperatura', 989.0000, 'ºC'),
	(20939, 110, '2015-01-15 01:11:06.000000', 'temperatura', 617.0000, 'ºC'),
	(20940, 110, '2015-01-15 01:11:07.000000', 'temperatura', 117.0000, 'ºC'),
	(20941, 110, '2015-01-15 01:11:08.000000', 'temperatura', 1133.0000, 'ºC'),
	(20942, 110, '2015-01-15 01:11:09.000000', 'temperatura', 517.0000, 'ºC'),
	(20943, 110, '2015-01-15 01:11:10.000000', 'temperatura', 385.0000, 'ºC'),
	(20944, 110, '2015-01-15 01:11:11.000000', 'temperatura', 374.0000, 'ºC'),
	(20945, 110, '2015-01-15 01:11:12.000000', 'temperatura', 714.0000, 'ºC'),
	(20946, 110, '2015-01-15 01:11:13.000000', 'temperatura', 51.0000, 'ºC'),
	(20947, 110, '2015-01-15 01:11:14.000000', 'temperatura', 514.0000, 'ºC'),
	(20948, 110, '2015-01-15 01:11:15.000000', 'temperatura', 15.0000, 'ºC'),
	(20949, 110, '2015-01-15 01:11:16.000000', 'temperatura', 934.0000, 'ºC'),
	(20950, 110, '2015-01-15 01:11:17.000000', 'temperatura', 1027.0000, 'ºC'),
	(20951, 110, '2015-01-15 01:11:18.000000', 'temperatura', 1132.0000, 'ºC'),
	(20952, 110, '2015-01-15 01:11:19.000000', 'temperatura', 180.0000, 'ºC'),
	(20953, 110, '2015-01-15 01:11:20.000000', 'temperatura', 1105.0000, 'ºC'),
	(20954, 110, '2015-01-15 01:11:21.000000', 'temperatura', 185.0000, 'ºC'),
	(20955, 110, '2015-01-15 01:11:22.000000', 'temperatura', 9.0000, 'ºC'),
	(20956, 110, '2015-01-15 01:11:23.000000', 'temperatura', 691.0000, 'ºC'),
	(20957, 110, '2015-01-15 01:11:24.000000', 'temperatura', 1028.0000, 'ºC'),
	(20958, 110, '2015-01-15 01:11:25.000000', 'temperatura', 670.0000, 'ºC'),
	(20959, 110, '2015-01-15 01:11:26.000000', 'temperatura', 264.0000, 'ºC'),
	(20960, 110, '2015-01-15 01:11:27.000000', 'temperatura', 513.0000, 'ºC'),
	(20961, 110, '2015-01-15 01:11:28.000000', 'temperatura', 571.0000, 'ºC'),
	(20962, 110, '2015-01-15 01:11:29.000000', 'temperatura', 119.0000, 'ºC'),
	(20963, 110, '2015-01-15 01:11:30.000000', 'temperatura', 83.0000, 'ºC'),
	(20964, 110, '2015-01-15 01:11:31.000000', 'temperatura', 59.0000, 'ºC'),
	(20965, 110, '2015-01-15 01:11:32.000000', 'temperatura', 46.0000, 'ºC'),
	(20966, 110, '2015-01-15 01:11:33.000000', 'temperatura', 55.0000, 'ºC'),
	(20967, 110, '2015-01-15 01:11:34.000000', 'temperatura', 137.0000, 'ºC'),
	(20968, 110, '2015-01-15 01:11:35.000000', 'temperatura', 518.0000, 'ºC'),
	(20969, 110, '2015-01-15 01:11:36.000000', 'temperatura', 981.0000, 'ºC'),
	(20970, 110, '2015-01-15 01:11:37.000000', 'temperatura', 950.0000, 'ºC'),
	(20971, 110, '2015-01-15 01:11:38.000000', 'temperatura', 610.0000, 'ºC'),
	(20972, 110, '2015-01-15 01:11:39.000000', 'temperatura', 200.0000, 'ºC'),
	(20973, 110, '2015-01-15 01:11:40.000000', 'temperatura', 369.0000, 'ºC'),
	(20974, 110, '2015-01-15 01:11:41.000000', 'temperatura', 47.0000, 'ºC'),
	(20975, 110, '2015-01-15 01:11:42.000000', 'temperatura', 330.0000, 'ºC'),
	(20976, 110, '2015-01-15 01:11:43.000000', 'temperatura', 308.0000, 'ºC'),
	(20977, 110, '2015-01-15 01:11:44.000000', 'temperatura', 549.0000, 'ºC'),
	(20978, 110, '2015-01-15 01:11:45.000000', 'temperatura', 621.0000, 'ºC'),
	(20979, 110, '2015-01-15 01:11:46.000000', 'temperatura', 259.0000, 'ºC'),
	(20980, 110, '2015-01-15 01:11:47.000000', 'temperatura', 632.0000, 'ºC'),
	(20981, 110, '2015-01-15 01:11:48.000000', 'temperatura', 1184.0000, 'ºC'),
	(20982, 110, '2015-01-15 01:11:49.000000', 'temperatura', 424.0000, 'ºC'),
	(20983, 110, '2015-01-15 01:11:50.000000', 'temperatura', 971.0000, 'ºC'),
	(20984, 110, '2015-01-15 01:11:51.000000', 'temperatura', 1182.0000, 'ºC'),
	(20985, 110, '2015-01-15 01:11:52.000000', 'temperatura', 599.0000, 'ºC'),
	(20986, 110, '2015-01-15 01:11:53.000000', 'temperatura', 647.0000, 'ºC'),
	(20987, 110, '2015-01-15 01:11:54.000000', 'temperatura', 239.0000, 'ºC'),
	(20988, 110, '2015-01-15 01:11:55.000000', 'temperatura', 456.0000, 'ºC'),
	(20989, 110, '2015-01-15 01:11:56.000000', 'temperatura', 362.0000, 'ºC'),
	(20990, 110, '2015-01-15 01:11:57.000000', 'temperatura', 445.0000, 'ºC'),
	(20991, 110, '2015-01-15 01:11:58.000000', 'temperatura', 1138.0000, 'ºC'),
	(20992, 110, '2015-01-15 01:11:59.000000', 'temperatura', 755.0000, 'ºC'),
	(20993, 110, '2015-01-15 01:12:00.000000', 'temperatura', 363.0000, 'ºC'),
	(20994, 110, '2015-01-15 01:12:01.000000', 'temperatura', 751.0000, 'ºC'),
	(20995, 110, '2015-01-15 01:12:02.000000', 'temperatura', 266.0000, 'ºC'),
	(20996, 110, '2015-01-15 01:12:03.000000', 'temperatura', 278.0000, 'ºC'),
	(20997, 110, '2015-01-15 01:12:04.000000', 'temperatura', 593.0000, 'ºC'),
	(20998, 110, '2015-01-15 01:12:05.000000', 'temperatura', 929.0000, 'ºC'),
	(20999, 110, '2015-01-15 01:12:06.000000', 'temperatura', 466.0000, 'ºC'),
	(21000, 110, '2015-01-15 01:12:07.000000', 'temperatura', 745.0000, 'ºC'),
	(21001, 110, '2015-01-15 01:12:08.000000', 'temperatura', 1129.0000, 'ºC'),
	(21002, 110, '2015-01-15 01:12:09.000000', 'temperatura', 1010.0000, 'ºC'),
	(21003, 110, '2015-01-15 01:12:10.000000', 'temperatura', 462.0000, 'ºC'),
	(21004, 110, '2015-01-15 01:12:11.000000', 'temperatura', 480.0000, 'ºC'),
	(21005, 110, '2015-01-15 01:12:12.000000', 'temperatura', 1016.0000, 'ºC'),
	(21006, 110, '2015-01-15 01:12:13.000000', 'temperatura', 38.0000, 'ºC'),
	(21007, 110, '2015-01-15 01:12:14.000000', 'temperatura', 745.0000, 'ºC'),
	(21008, 110, '2015-01-15 01:12:15.000000', 'temperatura', 9.0000, 'ºC'),
	(21009, 110, '2015-01-15 01:12:16.000000', 'temperatura', 211.0000, 'ºC'),
	(21010, 110, '2015-01-15 01:12:17.000000', 'temperatura', 1031.0000, 'ºC'),
	(21011, 110, '2015-01-15 01:12:18.000000', 'temperatura', 922.0000, 'ºC'),
	(21012, 110, '2015-01-15 01:12:19.000000', 'temperatura', 315.0000, 'ºC'),
	(21013, 110, '2015-01-15 01:12:20.000000', 'temperatura', 11.0000, 'ºC'),
	(21014, 110, '2015-01-15 01:12:21.000000', 'temperatura', 310.0000, 'ºC'),
	(21015, 110, '2015-01-15 01:12:22.000000', 'temperatura', 317.0000, 'ºC'),
	(21016, 110, '2015-01-15 01:12:23.000000', 'temperatura', 655.0000, 'ºC'),
	(21017, 110, '2015-01-15 01:12:24.000000', 'temperatura', 1125.0000, 'ºC'),
	(21018, 110, '2015-01-15 01:12:25.000000', 'temperatura', 60.0000, 'ºC'),
	(21019, 110, '2015-01-15 01:12:26.000000', 'temperatura', 526.0000, 'ºC'),
	(21020, 110, '2015-01-15 01:12:27.000000', 'temperatura', 50.0000, 'ºC'),
	(21021, 110, '2015-01-15 01:12:28.000000', 'temperatura', 1073.0000, 'ºC'),
	(21022, 110, '2015-01-15 01:12:29.000000', 'temperatura', 417.0000, 'ºC'),
	(21023, 110, '2015-01-15 01:12:30.000000', 'temperatura', 63.0000, 'ºC'),
	(21024, 110, '2015-01-15 01:12:31.000000', 'temperatura', 268.0000, 'ºC'),
	(21025, 110, '2015-01-15 01:12:32.000000', 'temperatura', 1150.0000, 'ºC'),
	(21026, 110, '2015-01-15 01:12:33.000000', 'temperatura', 147.0000, 'ºC'),
	(21027, 110, '2015-01-15 01:12:34.000000', 'temperatura', 884.0000, 'ºC'),
	(21028, 110, '2015-01-15 01:12:35.000000', 'temperatura', 379.0000, 'ºC'),
	(21029, 110, '2015-01-15 01:12:36.000000', 'temperatura', 445.0000, 'ºC'),
	(21030, 110, '2015-01-15 01:12:37.000000', 'temperatura', 1087.0000, 'ºC'),
	(21031, 110, '2015-01-15 01:12:38.000000', 'temperatura', 501.0000, 'ºC'),
	(21032, 110, '2015-01-15 01:12:39.000000', 'temperatura', 446.0000, 'ºC'),
	(21033, 110, '2015-01-15 01:12:40.000000', 'temperatura', 728.0000, 'ºC'),
	(21034, 110, '2015-01-15 01:12:41.000000', 'temperatura', 1103.0000, 'ºC'),
	(21035, 110, '2015-01-15 01:12:42.000000', 'temperatura', 932.0000, 'ºC'),
	(21036, 110, '2015-01-15 01:12:43.000000', 'temperatura', 152.0000, 'ºC'),
	(21037, 110, '2015-01-15 01:12:44.000000', 'temperatura', 363.0000, 'ºC'),
	(21038, 110, '2015-01-15 01:12:45.000000', 'temperatura', 161.0000, 'ºC'),
	(21039, 110, '2015-01-15 01:12:46.000000', 'temperatura', 915.0000, 'ºC'),
	(21040, 110, '2015-01-15 01:12:47.000000', 'temperatura', 492.0000, 'ºC'),
	(21041, 110, '2015-01-15 01:12:48.000000', 'temperatura', 917.0000, 'ºC'),
	(21042, 110, '2015-01-15 01:12:49.000000', 'temperatura', 708.0000, 'ºC'),
	(21043, 110, '2015-01-15 01:12:50.000000', 'temperatura', 791.0000, 'ºC'),
	(21044, 110, '2015-01-15 01:12:51.000000', 'temperatura', 631.0000, 'ºC'),
	(21045, 110, '2015-01-15 01:12:52.000000', 'temperatura', 781.0000, 'ºC'),
	(21046, 110, '2015-01-15 01:12:53.000000', 'temperatura', 813.0000, 'ºC'),
	(21047, 110, '2015-01-15 01:12:54.000000', 'temperatura', 524.0000, 'ºC'),
	(21048, 110, '2015-01-15 01:12:55.000000', 'temperatura', 180.0000, 'ºC'),
	(21049, 110, '2015-01-15 01:12:56.000000', 'temperatura', 528.0000, 'ºC'),
	(21050, 110, '2015-01-15 01:12:57.000000', 'temperatura', 902.0000, 'ºC'),
	(21051, 110, '2015-01-15 01:12:58.000000', 'temperatura', 524.0000, 'ºC'),
	(21052, 110, '2015-01-15 01:12:59.000000', 'temperatura', 1116.0000, 'ºC'),
	(21053, 110, '2015-01-15 01:13:00.000000', 'temperatura', 409.0000, 'ºC'),
	(21054, 110, '2015-01-15 01:13:01.000000', 'temperatura', 1098.0000, 'ºC'),
	(21055, 110, '2015-01-15 01:13:02.000000', 'temperatura', 663.0000, 'ºC'),
	(21056, 110, '2015-01-15 01:13:03.000000', 'temperatura', 19.0000, 'ºC'),
	(21057, 110, '2015-01-15 01:13:04.000000', 'temperatura', 510.0000, 'ºC'),
	(21058, 110, '2015-01-15 01:13:05.000000', 'temperatura', 91.0000, 'ºC'),
	(21059, 110, '2015-01-15 01:13:06.000000', 'temperatura', 126.0000, 'ºC'),
	(21060, 110, '2015-01-15 01:13:07.000000', 'temperatura', 359.0000, 'ºC'),
	(21061, 110, '2015-01-15 01:13:08.000000', 'temperatura', 218.0000, 'ºC'),
	(21062, 110, '2015-01-15 01:13:09.000000', 'temperatura', 12.0000, 'ºC'),
	(21063, 110, '2015-01-15 01:13:10.000000', 'temperatura', 607.0000, 'ºC'),
	(21064, 110, '2015-01-15 01:13:11.000000', 'temperatura', 599.0000, 'ºC'),
	(21065, 110, '2015-01-15 01:13:12.000000', 'temperatura', 1175.0000, 'ºC'),
	(21066, 110, '2015-01-15 01:13:13.000000', 'temperatura', 477.0000, 'ºC'),
	(21067, 110, '2015-01-15 01:13:14.000000', 'temperatura', 59.0000, 'ºC'),
	(21068, 110, '2015-01-15 01:13:15.000000', 'temperatura', 68.0000, 'ºC'),
	(21069, 110, '2015-01-15 01:13:16.000000', 'temperatura', 162.0000, 'ºC'),
	(21070, 110, '2015-01-15 01:13:17.000000', 'temperatura', 606.0000, 'ºC'),
	(21071, 110, '2015-01-15 01:13:18.000000', 'temperatura', 144.0000, 'ºC'),
	(21072, 110, '2015-01-15 01:13:19.000000', 'temperatura', 104.0000, 'ºC'),
	(21073, 110, '2015-01-15 01:13:20.000000', 'temperatura', 86.0000, 'ºC'),
	(21074, 110, '2015-01-15 01:13:21.000000', 'temperatura', 122.0000, 'ºC'),
	(21075, 110, '2015-01-15 01:13:22.000000', 'temperatura', 350.0000, 'ºC'),
	(21076, 110, '2015-01-15 01:13:23.000000', 'temperatura', 185.0000, 'ºC'),
	(21077, 110, '2015-01-15 01:13:24.000000', 'temperatura', 1077.0000, 'ºC'),
	(21078, 110, '2015-01-15 01:13:25.000000', 'temperatura', 31.0000, 'ºC'),
	(21079, 110, '2015-01-15 01:13:26.000000', 'temperatura', 523.0000, 'ºC'),
	(21080, 110, '2015-01-15 01:13:27.000000', 'temperatura', 124.0000, 'ºC'),
	(21081, 110, '2015-01-15 01:13:28.000000', 'temperatura', 250.0000, 'ºC'),
	(21082, 110, '2015-01-15 01:13:29.000000', 'temperatura', 881.0000, 'ºC'),
	(21083, 110, '2015-01-15 01:13:30.000000', 'temperatura', 54.0000, 'ºC'),
	(21084, 110, '2015-01-15 01:13:31.000000', 'temperatura', 26.0000, 'ºC'),
	(21085, 110, '2015-01-15 01:13:32.000000', 'temperatura', 1170.0000, 'ºC'),
	(21086, 110, '2015-01-15 01:13:33.000000', 'temperatura', 974.0000, 'ºC'),
	(21087, 110, '2015-01-15 01:13:34.000000', 'temperatura', 160.0000, 'ºC'),
	(21088, 110, '2015-01-15 01:13:35.000000', 'temperatura', 278.0000, 'ºC'),
	(21089, 110, '2015-01-15 01:13:36.000000', 'temperatura', 912.0000, 'ºC'),
	(21090, 110, '2015-01-15 01:13:37.000000', 'temperatura', 126.0000, 'ºC'),
	(21091, 110, '2015-01-15 01:13:38.000000', 'temperatura', 294.0000, 'ºC'),
	(21092, 110, '2015-01-15 01:13:39.000000', 'temperatura', 1094.0000, 'ºC'),
	(21093, 110, '2015-01-15 01:13:40.000000', 'temperatura', 987.0000, 'ºC'),
	(21094, 110, '2015-01-15 01:13:41.000000', 'temperatura', 454.0000, 'ºC'),
	(21095, 110, '2015-01-15 01:13:42.000000', 'temperatura', 510.0000, 'ºC'),
	(21096, 110, '2015-01-15 01:13:43.000000', 'temperatura', 1188.0000, 'ºC'),
	(21097, 110, '2015-01-15 01:13:44.000000', 'temperatura', 810.0000, 'ºC'),
	(21098, 110, '2015-01-15 01:13:45.000000', 'temperatura', 485.0000, 'ºC'),
	(21099, 110, '2015-01-15 01:13:46.000000', 'temperatura', 1198.0000, 'ºC'),
	(21100, 110, '2015-01-15 01:13:47.000000', 'temperatura', 935.0000, 'ºC'),
	(21101, 110, '2015-01-15 01:13:48.000000', 'temperatura', 1080.0000, 'ºC'),
	(21102, 110, '2015-01-15 01:13:49.000000', 'temperatura', 195.0000, 'ºC'),
	(21103, 110, '2015-01-15 01:13:50.000000', 'temperatura', 135.0000, 'ºC'),
	(21104, 110, '2015-01-15 01:13:51.000000', 'temperatura', 89.0000, 'ºC'),
	(21105, 110, '2015-01-15 01:13:52.000000', 'temperatura', 44.0000, 'ºC'),
	(21106, 110, '2015-01-15 01:13:53.000000', 'temperatura', 1152.0000, 'ºC'),
	(21107, 110, '2015-01-15 01:13:54.000000', 'temperatura', 830.0000, 'ºC'),
	(21108, 110, '2015-01-15 01:13:55.000000', 'temperatura', 694.0000, 'ºC'),
	(21109, 110, '2015-01-15 01:13:56.000000', 'temperatura', 982.0000, 'ºC'),
	(21110, 110, '2015-01-15 01:13:57.000000', 'temperatura', 427.0000, 'ºC'),
	(21111, 110, '2015-01-15 01:13:58.000000', 'temperatura', 391.0000, 'ºC'),
	(21112, 110, '2015-01-15 01:13:59.000000', 'temperatura', 676.0000, 'ºC'),
	(21113, 110, '2015-01-15 01:14:00.000000', 'temperatura', 1004.0000, 'ºC'),
	(21114, 110, '2015-01-15 01:14:01.000000', 'temperatura', 593.0000, 'ºC'),
	(21115, 110, '2015-01-15 01:14:02.000000', 'temperatura', 1156.0000, 'ºC'),
	(21116, 110, '2015-01-15 01:14:03.000000', 'temperatura', 399.0000, 'ºC'),
	(21117, 110, '2015-01-15 01:14:04.000000', 'temperatura', 927.0000, 'ºC'),
	(21118, 110, '2015-01-15 01:14:05.000000', 'temperatura', 1038.0000, 'ºC'),
	(21119, 110, '2015-01-15 01:14:06.000000', 'temperatura', 9.0000, 'ºC'),
	(21120, 110, '2015-01-15 01:14:07.000000', 'temperatura', 533.0000, 'ºC'),
	(21121, 110, '2015-01-15 01:14:08.000000', 'temperatura', 238.0000, 'ºC'),
	(21122, 110, '2015-01-15 01:14:09.000000', 'temperatura', 793.0000, 'ºC'),
	(21123, 110, '2015-01-15 01:14:10.000000', 'temperatura', 850.0000, 'ºC'),
	(21124, 110, '2015-01-15 01:14:11.000000', 'temperatura', 673.0000, 'ºC'),
	(21125, 110, '2015-01-15 01:14:12.000000', 'temperatura', 814.0000, 'ºC'),
	(21126, 110, '2015-01-15 01:14:13.000000', 'temperatura', 851.0000, 'ºC'),
	(21127, 110, '2015-01-15 01:14:14.000000', 'temperatura', 616.0000, 'ºC'),
	(21128, 110, '2015-01-15 01:14:15.000000', 'temperatura', 525.0000, 'ºC'),
	(21129, 110, '2015-01-15 01:14:16.000000', 'temperatura', 777.0000, 'ºC'),
	(21130, 110, '2015-01-15 01:14:17.000000', 'temperatura', 1110.0000, 'ºC'),
	(21131, 110, '2015-01-15 01:14:18.000000', 'temperatura', 819.0000, 'ºC'),
	(21132, 110, '2015-01-15 01:14:19.000000', 'temperatura', 767.0000, 'ºC'),
	(21133, 110, '2015-01-15 01:14:20.000000', 'temperatura', 180.0000, 'ºC'),
	(21134, 110, '2015-01-15 01:14:21.000000', 'temperatura', 999.0000, 'ºC'),
	(21135, 110, '2015-01-15 01:14:22.000000', 'temperatura', 854.0000, 'ºC'),
	(21136, 110, '2015-01-15 01:14:23.000000', 'temperatura', 74.0000, 'ºC'),
	(21137, 110, '2015-01-15 01:14:24.000000', 'temperatura', 210.0000, 'ºC'),
	(21138, 110, '2015-01-15 01:14:25.000000', 'temperatura', 827.0000, 'ºC'),
	(21139, 110, '2015-01-15 01:14:26.000000', 'temperatura', 1107.0000, 'ºC'),
	(21140, 110, '2015-01-15 01:14:27.000000', 'temperatura', 654.0000, 'ºC'),
	(21141, 110, '2015-01-15 01:14:28.000000', 'temperatura', 1149.0000, 'ºC'),
	(21142, 110, '2015-01-15 01:14:29.000000', 'temperatura', 182.0000, 'ºC'),
	(21143, 110, '2015-01-15 01:14:30.000000', 'temperatura', 1064.0000, 'ºC'),
	(21144, 110, '2015-01-15 01:14:31.000000', 'temperatura', 1176.0000, 'ºC'),
	(21145, 110, '2015-01-15 01:14:32.000000', 'temperatura', 289.0000, 'ºC'),
	(21146, 110, '2015-01-15 01:14:33.000000', 'temperatura', 317.0000, 'ºC'),
	(21147, 110, '2015-01-15 01:14:34.000000', 'temperatura', 718.0000, 'ºC'),
	(21148, 110, '2015-01-15 01:14:35.000000', 'temperatura', 239.0000, 'ºC'),
	(21149, 110, '2015-01-15 01:14:36.000000', 'temperatura', 244.0000, 'ºC'),
	(21150, 110, '2015-01-15 01:14:37.000000', 'temperatura', 501.0000, 'ºC'),
	(21151, 110, '2015-01-15 01:14:38.000000', 'temperatura', 576.0000, 'ºC'),
	(21152, 110, '2015-01-15 01:14:39.000000', 'temperatura', 178.0000, 'ºC'),
	(21153, 110, '2015-01-15 01:14:40.000000', 'temperatura', 359.0000, 'ºC'),
	(21154, 110, '2015-01-15 01:14:41.000000', 'temperatura', 65.0000, 'ºC'),
	(21155, 110, '2015-01-15 01:14:42.000000', 'temperatura', 448.0000, 'ºC'),
	(21156, 110, '2015-01-15 01:14:43.000000', 'temperatura', 843.0000, 'ºC'),
	(21157, 110, '2015-01-15 01:14:44.000000', 'temperatura', 475.0000, 'ºC'),
	(21158, 110, '2015-01-15 01:14:45.000000', 'temperatura', 1044.0000, 'ºC'),
	(21159, 110, '2015-01-15 01:14:46.000000', 'temperatura', 196.0000, 'ºC'),
	(21160, 110, '2015-01-15 01:14:47.000000', 'temperatura', 250.0000, 'ºC'),
	(21161, 110, '2015-01-15 01:14:48.000000', 'temperatura', 661.0000, 'ºC'),
	(21162, 110, '2015-01-15 01:14:49.000000', 'temperatura', 155.0000, 'ºC'),
	(21163, 110, '2015-01-15 01:14:50.000000', 'temperatura', 1192.0000, 'ºC'),
	(21164, 110, '2015-01-15 01:14:51.000000', 'temperatura', 697.0000, 'ºC'),
	(21165, 110, '2015-01-15 01:14:52.000000', 'temperatura', 1108.0000, 'ºC'),
	(21166, 110, '2015-01-15 01:14:53.000000', 'temperatura', 1052.0000, 'ºC'),
	(21167, 110, '2015-01-15 01:14:54.000000', 'temperatura', 736.0000, 'ºC'),
	(21168, 110, '2015-01-15 01:14:55.000000', 'temperatura', 526.0000, 'ºC'),
	(21169, 110, '2015-01-15 01:14:56.000000', 'temperatura', 419.0000, 'ºC'),
	(21170, 110, '2015-01-15 01:14:57.000000', 'temperatura', 521.0000, 'ºC'),
	(21171, 110, '2015-01-15 01:14:58.000000', 'temperatura', 147.0000, 'ºC'),
	(21172, 110, '2015-01-15 01:14:59.000000', 'temperatura', 372.0000, 'ºC'),
	(21173, 110, '2015-01-15 01:15:00.000000', 'temperatura', 221.0000, 'ºC'),
	(21174, 110, '2015-01-15 01:15:01.000000', 'temperatura', 1189.0000, 'ºC'),
	(21175, 110, '2015-01-15 01:15:02.000000', 'temperatura', 483.0000, 'ºC'),
	(21176, 110, '2015-01-15 01:15:03.000000', 'temperatura', 49.0000, 'ºC'),
	(21177, 110, '2015-01-15 01:15:04.000000', 'temperatura', 1194.0000, 'ºC'),
	(21178, 110, '2015-01-15 01:15:05.000000', 'temperatura', 1026.0000, 'ºC'),
	(21179, 110, '2015-01-15 01:15:06.000000', 'temperatura', 348.0000, 'ºC'),
	(21180, 110, '2015-01-15 01:15:07.000000', 'temperatura', 1063.0000, 'ºC'),
	(21181, 110, '2015-01-15 01:15:08.000000', 'temperatura', 673.0000, 'ºC'),
	(21182, 110, '2015-01-15 01:15:09.000000', 'temperatura', 174.0000, 'ºC'),
	(21183, 110, '2015-01-15 01:15:10.000000', 'temperatura', 54.0000, 'ºC'),
	(21184, 110, '2015-01-15 01:15:11.000000', 'temperatura', 948.0000, 'ºC'),
	(21185, 110, '2015-01-15 01:15:12.000000', 'temperatura', 978.0000, 'ºC'),
	(21186, 110, '2015-01-15 01:15:13.000000', 'temperatura', 845.0000, 'ºC'),
	(21187, 110, '2015-01-15 01:15:14.000000', 'temperatura', 93.0000, 'ºC'),
	(21188, 110, '2015-01-15 01:15:15.000000', 'temperatura', 329.0000, 'ºC'),
	(21189, 110, '2015-01-15 01:15:16.000000', 'temperatura', 166.0000, 'ºC'),
	(21190, 110, '2015-01-15 01:15:17.000000', 'temperatura', 1045.0000, 'ºC'),
	(21191, 110, '2015-01-15 01:15:18.000000', 'temperatura', 1126.0000, 'ºC'),
	(21192, 110, '2015-01-15 01:15:19.000000', 'temperatura', 95.0000, 'ºC'),
	(21193, 110, '2015-01-15 01:15:20.000000', 'temperatura', 697.0000, 'ºC'),
	(21194, 110, '2015-01-15 01:15:21.000000', 'temperatura', 800.0000, 'ºC'),
	(21195, 110, '2015-01-15 01:15:22.000000', 'temperatura', 711.0000, 'ºC'),
	(21196, 110, '2015-01-15 01:15:23.000000', 'temperatura', 1156.0000, 'ºC'),
	(21197, 110, '2015-01-15 01:15:24.000000', 'temperatura', 45.0000, 'ºC'),
	(21198, 110, '2015-01-15 01:15:25.000000', 'temperatura', 360.0000, 'ºC'),
	(21199, 110, '2015-01-15 01:15:26.000000', 'temperatura', 463.0000, 'ºC'),
	(21200, 110, '2015-01-15 01:15:27.000000', 'temperatura', 38.0000, 'ºC'),
	(21201, 110, '2015-01-15 01:15:28.000000', 'temperatura', 0.0000, 'ºC'),
	(21202, 110, '2015-01-15 01:15:29.000000', 'temperatura', 1085.0000, 'ºC'),
	(21203, 110, '2015-01-15 01:15:30.000000', 'temperatura', 627.0000, 'ºC'),
	(21204, 110, '2015-01-15 01:15:31.000000', 'temperatura', 1079.0000, 'ºC'),
	(21205, 110, '2015-01-15 01:15:32.000000', 'temperatura', 1117.0000, 'ºC'),
	(21206, 110, '2015-01-15 01:15:33.000000', 'temperatura', 1149.0000, 'ºC'),
	(21207, 110, '2015-01-15 01:15:34.000000', 'temperatura', 1193.0000, 'ºC'),
	(21208, 110, '2015-01-15 01:15:35.000000', 'temperatura', 121.0000, 'ºC'),
	(21209, 110, '2015-01-15 01:15:36.000000', 'temperatura', 623.0000, 'ºC'),
	(21210, 110, '2015-01-15 01:15:37.000000', 'temperatura', 353.0000, 'ºC'),
	(21211, 110, '2015-01-15 01:15:38.000000', 'temperatura', 1097.0000, 'ºC'),
	(21212, 110, '2015-01-15 01:15:39.000000', 'temperatura', 827.0000, 'ºC'),
	(21213, 110, '2015-01-15 01:15:40.000000', 'temperatura', 846.0000, 'ºC'),
	(21214, 110, '2015-01-15 01:15:41.000000', 'temperatura', 549.0000, 'ºC'),
	(21215, 110, '2015-01-15 01:15:42.000000', 'temperatura', 205.0000, 'ºC'),
	(21216, 110, '2015-01-15 01:15:43.000000', 'temperatura', 582.0000, 'ºC'),
	(21217, 110, '2015-01-15 01:15:44.000000', 'temperatura', 1093.0000, 'ºC'),
	(21218, 110, '2015-01-15 01:15:45.000000', 'temperatura', 120.0000, 'ºC'),
	(21219, 110, '2015-01-15 01:15:46.000000', 'temperatura', 920.0000, 'ºC'),
	(21220, 110, '2015-01-15 01:15:47.000000', 'temperatura', 641.0000, 'ºC'),
	(21221, 110, '2015-01-15 01:15:48.000000', 'temperatura', 446.0000, 'ºC'),
	(21222, 110, '2015-01-15 01:15:49.000000', 'temperatura', 308.0000, 'ºC'),
	(21223, 110, '2015-01-15 01:15:50.000000', 'temperatura', 201.0000, 'ºC'),
	(21224, 110, '2015-01-15 01:15:51.000000', 'temperatura', 82.0000, 'ºC'),
	(21225, 110, '2015-01-15 01:15:52.000000', 'temperatura', 1008.0000, 'ºC'),
	(21226, 110, '2015-01-15 01:15:53.000000', 'temperatura', 1193.0000, 'ºC'),
	(21227, 110, '2015-01-15 01:15:54.000000', 'temperatura', 542.0000, 'ºC'),
	(21228, 110, '2015-01-15 01:15:55.000000', 'temperatura', 332.0000, 'ºC'),
	(21229, 110, '2015-01-15 01:15:56.000000', 'temperatura', 34.0000, 'ºC'),
	(21230, 110, '2015-01-15 01:15:57.000000', 'temperatura', 377.0000, 'ºC'),
	(21231, 110, '2015-01-15 01:15:58.000000', 'temperatura', 581.0000, 'ºC'),
	(21232, 110, '2015-01-15 01:15:59.000000', 'temperatura', 575.0000, 'ºC'),
	(21233, 110, '2015-01-15 01:16:00.000000', 'temperatura', 1131.0000, 'ºC'),
	(21234, 110, '2015-01-15 01:16:01.000000', 'temperatura', 334.0000, 'ºC'),
	(21235, 110, '2015-01-15 01:16:02.000000', 'temperatura', 675.0000, 'ºC'),
	(21236, 110, '2015-01-15 01:16:03.000000', 'temperatura', 1172.0000, 'ºC'),
	(21237, 110, '2015-01-15 01:16:04.000000', 'temperatura', 239.0000, 'ºC'),
	(21238, 110, '2015-01-15 01:16:05.000000', 'temperatura', 78.0000, 'ºC'),
	(21239, 110, '2015-01-15 01:16:06.000000', 'temperatura', 873.0000, 'ºC'),
	(21240, 110, '2015-01-15 01:16:07.000000', 'temperatura', 533.0000, 'ºC'),
	(21241, 110, '2015-01-15 01:16:08.000000', 'temperatura', 45.0000, 'ºC'),
	(21242, 110, '2015-01-15 01:16:09.000000', 'temperatura', 1028.0000, 'ºC'),
	(21243, 110, '2015-01-15 01:16:10.000000', 'temperatura', 204.0000, 'ºC'),
	(21244, 110, '2015-01-15 01:16:11.000000', 'temperatura', 336.0000, 'ºC'),
	(21245, 110, '2015-01-15 01:16:12.000000', 'temperatura', 1067.0000, 'ºC'),
	(21246, 110, '2015-01-15 01:16:13.000000', 'temperatura', 731.0000, 'ºC'),
	(21247, 110, '2015-01-15 01:16:14.000000', 'temperatura', 454.0000, 'ºC'),
	(21248, 110, '2015-01-15 01:16:15.000000', 'temperatura', 76.0000, 'ºC'),
	(21249, 110, '2015-01-15 01:16:16.000000', 'temperatura', 221.0000, 'ºC'),
	(21250, 110, '2015-01-15 01:16:17.000000', 'temperatura', 875.0000, 'ºC'),
	(21251, 110, '2015-01-15 01:16:18.000000', 'temperatura', 114.0000, 'ºC'),
	(21252, 110, '2015-01-15 01:16:19.000000', 'temperatura', 347.0000, 'ºC'),
	(21253, 110, '2015-01-15 01:16:20.000000', 'temperatura', 191.0000, 'ºC'),
	(21254, 110, '2015-01-15 01:16:21.000000', 'temperatura', 1113.0000, 'ºC'),
	(21255, 110, '2015-01-15 01:16:22.000000', 'temperatura', 195.0000, 'ºC'),
	(21256, 110, '2015-01-15 01:16:23.000000', 'temperatura', 35.0000, 'ºC'),
	(21257, 110, '2015-01-15 01:16:24.000000', 'temperatura', 793.0000, 'ºC'),
	(21258, 110, '2015-01-15 01:16:25.000000', 'temperatura', 257.0000, 'ºC'),
	(21259, 110, '2015-01-15 01:16:26.000000', 'temperatura', 108.0000, 'ºC'),
	(21260, 110, '2015-01-15 01:16:27.000000', 'temperatura', 970.0000, 'ºC'),
	(21261, 110, '2015-01-15 01:16:28.000000', 'temperatura', 928.0000, 'ºC'),
	(21262, 110, '2015-01-15 01:16:29.000000', 'temperatura', 528.0000, 'ºC'),
	(21263, 110, '2015-01-15 01:16:30.000000', 'temperatura', 1058.0000, 'ºC'),
	(21264, 110, '2015-01-15 01:16:31.000000', 'temperatura', 106.0000, 'ºC'),
	(21265, 110, '2015-01-15 01:16:32.000000', 'temperatura', 958.0000, 'ºC'),
	(21266, 110, '2015-01-15 01:16:33.000000', 'temperatura', 873.0000, 'ºC'),
	(21267, 110, '2015-01-15 01:16:34.000000', 'temperatura', 289.0000, 'ºC'),
	(21268, 110, '2015-01-15 01:16:35.000000', 'temperatura', 30.0000, 'ºC'),
	(21269, 110, '2015-01-15 01:16:36.000000', 'temperatura', 480.0000, 'ºC'),
	(21270, 110, '2015-01-15 01:16:37.000000', 'temperatura', 1112.0000, 'ºC'),
	(21271, 110, '2015-01-15 01:16:38.000000', 'temperatura', 520.0000, 'ºC'),
	(21272, 110, '2015-01-15 01:16:39.000000', 'temperatura', 464.0000, 'ºC'),
	(21273, 110, '2015-01-15 01:16:40.000000', 'temperatura', 760.0000, 'ºC'),
	(21274, 110, '2015-01-15 01:16:41.000000', 'temperatura', 8.0000, 'ºC'),
	(21275, 110, '2015-01-15 01:16:42.000000', 'temperatura', 163.0000, 'ºC'),
	(21276, 110, '2015-01-15 01:16:43.000000', 'temperatura', 789.0000, 'ºC'),
	(21277, 110, '2015-01-15 01:16:44.000000', 'temperatura', 1056.0000, 'ºC'),
	(21278, 110, '2015-01-15 01:16:45.000000', 'temperatura', 514.0000, 'ºC'),
	(21279, 110, '2015-01-15 01:16:46.000000', 'temperatura', 604.0000, 'ºC'),
	(21280, 110, '2015-01-15 01:16:47.000000', 'temperatura', 277.0000, 'ºC'),
	(21281, 110, '2015-01-15 01:16:48.000000', 'temperatura', 776.0000, 'ºC'),
	(21282, 110, '2015-01-15 01:16:49.000000', 'temperatura', 646.0000, 'ºC'),
	(21283, 110, '2015-01-15 01:16:50.000000', 'temperatura', 904.0000, 'ºC'),
	(21284, 110, '2015-01-15 01:16:51.000000', 'temperatura', 182.0000, 'ºC'),
	(21285, 110, '2015-01-15 01:16:52.000000', 'temperatura', 597.0000, 'ºC'),
	(21286, 110, '2015-01-15 01:16:53.000000', 'temperatura', 40.0000, 'ºC'),
	(21287, 110, '2015-01-15 01:16:54.000000', 'temperatura', 808.0000, 'ºC'),
	(21288, 110, '2015-01-15 01:16:55.000000', 'temperatura', 324.0000, 'ºC'),
	(21289, 110, '2015-01-15 01:16:56.000000', 'temperatura', 394.0000, 'ºC'),
	(21290, 110, '2015-01-15 01:16:57.000000', 'temperatura', 997.0000, 'ºC'),
	(21291, 110, '2015-01-15 01:16:58.000000', 'temperatura', 206.0000, 'ºC'),
	(21292, 110, '2015-01-15 01:16:59.000000', 'temperatura', 439.0000, 'ºC'),
	(21293, 110, '2015-01-15 01:17:00.000000', 'temperatura', 379.0000, 'ºC'),
	(21294, 110, '2015-01-15 01:17:01.000000', 'temperatura', 576.0000, 'ºC'),
	(21295, 110, '2015-01-15 01:17:02.000000', 'temperatura', 546.0000, 'ºC'),
	(21296, 110, '2015-01-15 01:17:03.000000', 'temperatura', 1000.0000, 'ºC'),
	(21297, 110, '2015-01-15 01:17:04.000000', 'temperatura', 963.0000, 'ºC'),
	(21298, 110, '2015-01-15 01:17:05.000000', 'temperatura', 615.0000, 'ºC'),
	(21299, 110, '2015-01-15 01:17:06.000000', 'temperatura', 186.0000, 'ºC'),
	(21300, 110, '2015-01-15 01:17:07.000000', 'temperatura', 287.0000, 'ºC'),
	(21301, 110, '2015-01-15 01:17:08.000000', 'temperatura', 875.0000, 'ºC'),
	(21302, 110, '2015-01-15 01:17:09.000000', 'temperatura', 1116.0000, 'ºC'),
	(21303, 110, '2015-01-15 01:17:10.000000', 'temperatura', 557.0000, 'ºC'),
	(21304, 110, '2015-01-15 01:17:11.000000', 'temperatura', 638.0000, 'ºC'),
	(21305, 110, '2015-01-15 01:17:12.000000', 'temperatura', 319.0000, 'ºC'),
	(21306, 110, '2015-01-15 01:17:13.000000', 'temperatura', 881.0000, 'ºC'),
	(21307, 110, '2015-01-15 01:17:14.000000', 'temperatura', 1048.0000, 'ºC'),
	(21308, 110, '2015-01-15 01:17:15.000000', 'temperatura', 200.0000, 'ºC'),
	(21309, 110, '2015-01-15 01:17:16.000000', 'temperatura', 253.0000, 'ºC'),
	(21310, 110, '2015-01-15 01:17:17.000000', 'temperatura', 667.0000, 'ºC'),
	(21311, 110, '2015-01-15 01:17:18.000000', 'temperatura', 175.0000, 'ºC'),
	(21312, 110, '2015-01-15 01:17:19.000000', 'temperatura', 77.0000, 'ºC'),
	(21313, 110, '2015-01-15 01:17:20.000000', 'temperatura', 1060.0000, 'ºC'),
	(21314, 110, '2015-01-15 01:17:21.000000', 'temperatura', 269.0000, 'ºC'),
	(21315, 110, '2015-01-15 01:17:22.000000', 'temperatura', 564.0000, 'ºC'),
	(21316, 110, '2015-01-15 01:17:23.000000', 'temperatura', 815.0000, 'ºC'),
	(21317, 110, '2015-01-15 01:17:24.000000', 'temperatura', 1185.0000, 'ºC'),
	(21318, 110, '2015-01-15 01:17:25.000000', 'temperatura', 1079.0000, 'ºC'),
	(21319, 110, '2015-01-15 01:17:26.000000', 'temperatura', 640.0000, 'ºC'),
	(21320, 110, '2015-01-15 01:17:27.000000', 'temperatura', 1163.0000, 'ºC'),
	(21321, 110, '2015-01-15 01:17:28.000000', 'temperatura', 297.0000, 'ºC'),
	(21322, 110, '2015-01-15 01:17:29.000000', 'temperatura', 394.0000, 'ºC'),
	(21323, 110, '2015-01-15 01:17:30.000000', 'temperatura', 1081.0000, 'ºC'),
	(21324, 110, '2015-01-15 01:17:31.000000', 'temperatura', 623.0000, 'ºC'),
	(21325, 110, '2015-01-15 01:17:32.000000', 'temperatura', 1073.0000, 'ºC'),
	(21326, 110, '2015-01-15 01:17:33.000000', 'temperatura', 1098.0000, 'ºC'),
	(21327, 110, '2015-01-15 01:17:34.000000', 'temperatura', 1069.0000, 'ºC'),
	(21328, 110, '2015-01-15 01:17:35.000000', 'temperatura', 851.0000, 'ºC'),
	(21329, 110, '2015-01-15 01:17:36.000000', 'temperatura', 1048.0000, 'ºC'),
	(21330, 110, '2015-01-15 01:17:37.000000', 'temperatura', 287.0000, 'ºC'),
	(21331, 110, '2015-01-15 01:17:38.000000', 'temperatura', 691.0000, 'ºC'),
	(21332, 110, '2015-01-15 01:17:39.000000', 'temperatura', 195.0000, 'ºC'),
	(21333, 110, '2015-01-15 01:17:40.000000', 'temperatura', 101.0000, 'ºC'),
	(21334, 110, '2015-01-15 01:17:41.000000', 'temperatura', 1124.0000, 'ºC'),
	(21335, 110, '2015-01-15 01:17:42.000000', 'temperatura', 514.0000, 'ºC'),
	(21336, 110, '2015-01-15 01:17:43.000000', 'temperatura', 400.0000, 'ºC'),
	(21337, 110, '2015-01-15 01:17:44.000000', 'temperatura', 458.0000, 'ºC'),
	(21338, 110, '2015-01-15 01:17:45.000000', 'temperatura', 1092.0000, 'ºC'),
	(21339, 110, '2015-01-15 01:17:46.000000', 'temperatura', 487.0000, 'ºC'),
	(21340, 110, '2015-01-15 01:17:47.000000', 'temperatura', 359.0000, 'ºC'),
	(21341, 110, '2015-01-15 01:17:48.000000', 'temperatura', 336.0000, 'ºC'),
	(21342, 110, '2015-01-15 01:17:49.000000', 'temperatura', 601.0000, 'ºC'),
	(21343, 110, '2015-01-15 01:17:50.000000', 'temperatura', 798.0000, 'ºC'),
	(21344, 110, '2015-01-15 01:17:51.000000', 'temperatura', 987.0000, 'ºC'),
	(21345, 110, '2015-01-15 01:17:52.000000', 'temperatura', 142.0000, 'ºC'),
	(21346, 110, '2015-01-15 01:17:53.000000', 'temperatura', 150.0000, 'ºC'),
	(21347, 110, '2015-01-15 01:17:54.000000', 'temperatura', 325.0000, 'ºC'),
	(21348, 110, '2015-01-15 01:17:55.000000', 'temperatura', 1176.0000, 'ºC'),
	(21349, 110, '2015-01-15 01:17:56.000000', 'temperatura', 107.0000, 'ºC'),
	(21350, 110, '2015-01-15 01:17:57.000000', 'temperatura', 604.0000, 'ºC'),
	(21351, 110, '2015-01-15 01:17:58.000000', 'temperatura', 301.0000, 'ºC'),
	(21352, 110, '2015-01-15 01:17:59.000000', 'temperatura', 891.0000, 'ºC'),
	(21353, 110, '2015-01-15 01:18:00.000000', 'temperatura', 1156.0000, 'ºC'),
	(21354, 110, '2015-01-15 01:18:01.000000', 'temperatura', 707.0000, 'ºC'),
	(21355, 110, '2015-01-15 01:18:02.000000', 'temperatura', 67.0000, 'ºC'),
	(21356, 110, '2015-01-15 01:18:03.000000', 'temperatura', 613.0000, 'ºC'),
	(21357, 110, '2015-01-15 01:18:04.000000', 'temperatura', 466.0000, 'ºC'),
	(21358, 110, '2015-01-15 01:18:05.000000', 'temperatura', 489.0000, 'ºC'),
	(21359, 110, '2015-01-15 01:18:06.000000', 'temperatura', 1051.0000, 'ºC'),
	(21360, 110, '2015-01-15 01:18:07.000000', 'temperatura', 188.0000, 'ºC'),
	(21361, 110, '2015-01-15 01:18:08.000000', 'temperatura', 185.0000, 'ºC'),
	(21362, 110, '2015-01-15 01:18:09.000000', 'temperatura', 362.0000, 'ºC'),
	(21363, 110, '2015-01-15 01:18:10.000000', 'temperatura', 56.0000, 'ºC'),
	(21364, 110, '2015-01-15 01:18:11.000000', 'temperatura', 393.0000, 'ºC'),
	(21365, 110, '2015-01-15 01:18:12.000000', 'temperatura', 599.0000, 'ºC'),
	(21366, 110, '2015-01-15 01:18:13.000000', 'temperatura', 614.0000, 'ºC'),
	(21367, 110, '2015-01-15 01:18:14.000000', 'temperatura', 75.0000, 'ºC'),
	(21368, 110, '2015-01-15 01:18:15.000000', 'temperatura', 935.0000, 'ºC'),
	(21369, 110, '2015-01-15 01:18:16.000000', 'temperatura', 849.0000, 'ºC'),
	(21370, 110, '2015-01-15 01:18:17.000000', 'temperatura', 239.0000, 'ºC'),
	(21371, 110, '2015-01-15 01:18:18.000000', 'temperatura', 1051.0000, 'ºC'),
	(21372, 110, '2015-01-15 01:18:19.000000', 'temperatura', 936.0000, 'ºC'),
	(21373, 110, '2015-01-15 01:18:20.000000', 'temperatura', 328.0000, 'ºC'),
	(21374, 110, '2015-01-15 01:18:21.000000', 'temperatura', 32.0000, 'ºC'),
	(21375, 110, '2015-01-15 01:18:22.000000', 'temperatura', 377.0000, 'ºC'),
	(21376, 110, '2015-01-15 01:18:23.000000', 'temperatura', 591.0000, 'ºC'),
	(21377, 110, '2015-01-15 01:18:24.000000', 'temperatura', 623.0000, 'ºC'),
	(21378, 110, '2015-01-15 01:18:25.000000', 'temperatura', 144.0000, 'ºC'),
	(21379, 110, '2015-01-15 01:18:26.000000', 'temperatura', 50.0000, 'ºC'),
	(21380, 110, '2015-01-15 01:18:27.000000', 'temperatura', 1019.0000, 'ºC'),
	(21381, 110, '2015-01-15 01:18:28.000000', 'temperatura', 144.0000, 'ºC'),
	(21382, 110, '2015-01-15 01:18:29.000000', 'temperatura', 64.0000, 'ºC'),
	(21383, 110, '2015-01-15 01:18:30.000000', 'temperatura', 1090.0000, 'ºC'),
	(21384, 110, '2015-01-15 01:18:31.000000', 'temperatura', 457.0000, 'ºC'),
	(21385, 110, '2015-01-15 01:18:32.000000', 'temperatura', 214.0000, 'ºC'),
	(21386, 110, '2015-01-15 01:18:33.000000', 'temperatura', 903.0000, 'ºC'),
	(21387, 110, '2015-01-15 01:18:34.000000', 'temperatura', 272.0000, 'ºC'),
	(21388, 110, '2015-01-15 01:18:35.000000', 'temperatura', 1051.0000, 'ºC'),
	(21389, 110, '2015-01-15 01:18:36.000000', 'temperatura', 840.0000, 'ºC'),
	(21390, 110, '2015-01-15 01:18:37.000000', 'temperatura', 1048.0000, 'ºC'),
	(21391, 110, '2015-01-15 01:18:38.000000', 'temperatura', 321.0000, 'ºC'),
	(21392, 110, '2015-01-15 01:18:39.000000', 'temperatura', 859.0000, 'ºC'),
	(21393, 110, '2015-01-15 01:18:40.000000', 'temperatura', 934.0000, 'ºC'),
	(21394, 110, '2015-01-15 01:18:41.000000', 'temperatura', 892.0000, 'ºC'),
	(21395, 110, '2015-01-15 01:18:42.000000', 'temperatura', 461.0000, 'ºC'),
	(21396, 110, '2015-01-15 01:18:43.000000', 'temperatura', 828.0000, 'ºC'),
	(21397, 110, '2015-01-15 01:18:44.000000', 'temperatura', 359.0000, 'ºC'),
	(21398, 110, '2015-01-15 01:18:45.000000', 'temperatura', 511.0000, 'ºC'),
	(21399, 110, '2015-01-15 01:18:46.000000', 'temperatura', 277.0000, 'ºC'),
	(21400, 110, '2015-01-15 01:18:47.000000', 'temperatura', 1053.0000, 'ºC'),
	(21401, 110, '2015-01-15 01:18:48.000000', 'temperatura', 835.0000, 'ºC'),
	(21402, 110, '2015-01-15 01:18:49.000000', 'temperatura', 1017.0000, 'ºC'),
	(21403, 110, '2015-01-15 01:18:50.000000', 'temperatura', 182.0000, 'ºC'),
	(21404, 110, '2015-01-15 01:18:51.000000', 'temperatura', 258.0000, 'ºC'),
	(21405, 110, '2015-01-15 01:18:52.000000', 'temperatura', 745.0000, 'ºC'),
	(21406, 110, '2015-01-15 01:18:53.000000', 'temperatura', 551.0000, 'ºC'),
	(21407, 110, '2015-01-15 01:18:54.000000', 'temperatura', 521.0000, 'ºC'),
	(21408, 110, '2015-01-15 01:18:55.000000', 'temperatura', 950.0000, 'ºC'),
	(21409, 110, '2015-01-15 01:18:56.000000', 'temperatura', 791.0000, 'ºC'),
	(21410, 110, '2015-01-15 01:18:57.000000', 'temperatura', 1105.0000, 'ºC'),
	(21411, 110, '2015-01-15 01:18:58.000000', 'temperatura', 752.0000, 'ºC'),
	(21412, 110, '2015-01-15 01:18:59.000000', 'temperatura', 445.0000, 'ºC'),
	(21413, 110, '2015-01-15 01:19:00.000000', 'temperatura', 1169.0000, 'ºC'),
	(21414, 110, '2015-01-15 01:19:01.000000', 'temperatura', 911.0000, 'ºC'),
	(21415, 110, '2015-01-15 01:19:02.000000', 'temperatura', 1049.0000, 'ºC'),
	(21416, 110, '2015-01-15 01:19:03.000000', 'temperatura', 111.0000, 'ºC'),
	(21417, 110, '2015-01-15 01:19:04.000000', 'temperatura', 1008.0000, 'ºC'),
	(21418, 110, '2015-01-15 01:19:05.000000', 'temperatura', 1110.0000, 'ºC'),
	(21419, 110, '2015-01-15 01:19:06.000000', 'temperatura', 125.0000, 'ºC'),
	(21420, 110, '2015-01-15 01:19:07.000000', 'temperatura', 894.0000, 'ºC'),
	(21421, 110, '2015-01-15 01:19:08.000000', 'temperatura', 496.0000, 'ºC'),
	(21422, 110, '2015-01-15 01:19:09.000000', 'temperatura', 1000.0000, 'ºC'),
	(21423, 110, '2015-01-15 01:19:10.000000', 'temperatura', 1113.0000, 'ºC'),
	(21424, 110, '2015-01-15 01:19:11.000000', 'temperatura', 164.0000, 'ºC'),
	(21425, 110, '2015-01-15 01:19:12.000000', 'temperatura', 1083.0000, 'ºC'),
	(21426, 110, '2015-01-15 01:19:13.000000', 'temperatura', 122.0000, 'ºC'),
	(21427, 110, '2015-01-15 01:19:14.000000', 'temperatura', 962.0000, 'ºC'),
	(21428, 110, '2015-01-15 01:19:15.000000', 'temperatura', 843.0000, 'ºC'),
	(21429, 110, '2015-01-15 01:19:16.000000', 'temperatura', 132.0000, 'ºC'),
	(21430, 110, '2015-01-15 01:19:17.000000', 'temperatura', 529.0000, 'ºC'),
	(21431, 110, '2015-01-15 01:19:18.000000', 'temperatura', 1050.0000, 'ºC'),
	(21432, 110, '2015-01-15 01:19:19.000000', 'temperatura', 64.0000, 'ºC'),
	(21433, 110, '2015-01-15 01:19:20.000000', 'temperatura', 771.0000, 'ºC'),
	(21434, 110, '2015-01-15 01:19:21.000000', 'temperatura', 62.0000, 'ºC'),
	(21435, 110, '2015-01-15 01:19:22.000000', 'temperatura', 397.0000, 'ºC'),
	(21436, 110, '2015-01-15 01:19:23.000000', 'temperatura', 600.0000, 'ºC'),
	(21437, 110, '2015-01-15 01:19:24.000000', 'temperatura', 610.0000, 'ºC'),
	(21438, 110, '2015-01-15 01:19:25.000000', 'temperatura', 50.0000, 'ºC'),
	(21439, 110, '2015-01-15 01:19:26.000000', 'temperatura', 820.0000, 'ºC'),
	(21440, 110, '2015-01-15 01:19:27.000000', 'temperatura', 352.0000, 'ºC'),
	(21441, 110, '2015-01-15 01:19:28.000000', 'temperatura', 501.0000, 'ºC'),
	(21442, 110, '2015-01-15 01:19:29.000000', 'temperatura', 249.0000, 'ºC'),
	(21443, 110, '2015-01-15 01:19:30.000000', 'temperatura', 940.0000, 'ºC'),
	(21444, 110, '2015-01-15 01:19:31.000000', 'temperatura', 356.0000, 'ºC'),
	(21445, 110, '2015-01-15 01:19:32.000000', 'temperatura', 158.0000, 'ºC'),
	(21446, 110, '2015-01-15 01:19:33.000000', 'temperatura', 924.0000, 'ºC'),
	(21447, 110, '2015-01-15 01:19:34.000000', 'temperatura', 548.0000, 'ºC'),
	(21448, 110, '2015-01-15 01:19:35.000000', 'temperatura', 1167.0000, 'ºC'),
	(21449, 110, '2015-01-15 01:19:36.000000', 'temperatura', 593.0000, 'ºC'),
	(21450, 110, '2015-01-15 01:19:37.000000', 'temperatura', 665.0000, 'ºC'),
	(21451, 110, '2015-01-15 01:19:38.000000', 'temperatura', 345.0000, 'ºC'),
	(21452, 110, '2015-01-15 01:19:39.000000', 'temperatura', 929.0000, 'ºC'),
	(21453, 110, '2015-01-15 01:19:40.000000', 'temperatura', 13.0000, 'ºC'),
	(21454, 110, '2015-01-15 01:19:41.000000', 'temperatura', 877.0000, 'ºC'),
	(21455, 110, '2015-01-15 01:19:42.000000', 'temperatura', 748.0000, 'ºC'),
	(21456, 110, '2015-01-15 01:19:43.000000', 'temperatura', 1107.0000, 'ºC'),
	(21457, 110, '2015-01-15 01:19:44.000000', 'temperatura', 894.0000, 'ºC'),
	(21458, 110, '2015-01-15 01:19:45.000000', 'temperatura', 1149.0000, 'ºC'),
	(21459, 110, '2015-01-15 01:19:46.000000', 'temperatura', 664.0000, 'ºC'),
	(21460, 110, '2015-01-15 01:19:47.000000', 'temperatura', 1073.0000, 'ºC'),
	(21461, 110, '2015-01-15 01:19:48.000000', 'temperatura', 973.0000, 'ºC'),
	(21462, 110, '2015-01-15 01:19:49.000000', 'temperatura', 446.0000, 'ºC'),
	(21463, 110, '2015-01-15 01:19:50.000000', 'temperatura', 513.0000, 'ºC'),
	(21464, 110, '2015-01-15 01:19:51.000000', 'temperatura', 28.0000, 'ºC'),
	(21465, 110, '2015-01-15 01:19:52.000000', 'temperatura', 999.0000, 'ºC'),
	(21466, 110, '2015-01-15 01:19:53.000000', 'temperatura', 112.0000, 'ºC'),
	(21467, 110, '2015-01-15 01:19:54.000000', 'temperatura', 1166.0000, 'ºC'),
	(21468, 110, '2015-01-15 01:19:55.000000', 'temperatura', 693.0000, 'ºC'),
	(21469, 110, '2015-01-15 01:19:56.000000', 'temperatura', 1168.0000, 'ºC'),
	(21470, 110, '2015-01-15 01:19:57.000000', 'temperatura', 160.0000, 'ºC'),
	(21471, 110, '2015-01-15 01:19:58.000000', 'temperatura', 898.0000, 'ºC'),
	(21472, 110, '2015-01-15 01:19:59.000000', 'temperatura', 408.0000, 'ºC'),
	(21473, 110, '2015-01-15 01:20:00.000000', 'temperatura', 548.0000, 'ºC'),
	(21474, 110, '2015-01-15 01:20:01.000000', 'temperatura', 317.0000, 'ºC'),
	(21475, 110, '2015-01-15 01:20:02.000000', 'temperatura', 1141.0000, 'ºC'),
	(21476, 110, '2015-01-15 01:20:03.000000', 'temperatura', 1155.0000, 'ºC'),
	(21477, 110, '2015-01-15 01:20:04.000000', 'temperatura', 1154.0000, 'ºC'),
	(21478, 110, '2015-01-15 01:20:05.000000', 'temperatura', 1105.0000, 'ºC'),
	(21479, 110, '2015-01-15 01:20:06.000000', 'temperatura', 862.0000, 'ºC'),
	(21480, 110, '2015-01-15 01:20:07.000000', 'temperatura', 996.0000, 'ºC'),
	(21481, 110, '2015-01-15 01:20:08.000000', 'temperatura', 1194.0000, 'ºC'),
	(21482, 110, '2015-01-15 01:20:09.000000', 'temperatura', 584.0000, 'ºC'),
	(21483, 110, '2015-01-15 01:20:10.000000', 'temperatura', 537.0000, 'ºC'),
	(21484, 110, '2015-01-15 01:20:11.000000', 'temperatura', 936.0000, 'ºC'),
	(21485, 110, '2015-01-15 01:20:12.000000', 'temperatura', 669.0000, 'ºC'),
	(21486, 110, '2015-01-15 01:20:13.000000', 'temperatura', 535.0000, 'ºC'),
	(21487, 110, '2015-01-15 01:20:14.000000', 'temperatura', 671.0000, 'ºC'),
	(21488, 110, '2015-01-15 01:20:15.000000', 'temperatura', 550.0000, 'ºC'),
	(21489, 110, '2015-01-15 01:20:16.000000', 'temperatura', 739.0000, 'ºC'),
	(21490, 110, '2015-01-15 01:20:17.000000', 'temperatura', 844.0000, 'ºC'),
	(21491, 110, '2015-01-15 01:20:18.000000', 'temperatura', 803.0000, 'ºC'),
	(21492, 110, '2015-01-15 01:20:19.000000', 'temperatura', 283.0000, 'ºC'),
	(21493, 110, '2015-01-15 01:20:20.000000', 'temperatura', 209.0000, 'ºC'),
	(21494, 110, '2015-01-15 01:20:21.000000', 'temperatura', 194.0000, 'ºC'),
	(21495, 110, '2015-01-15 01:20:22.000000', 'temperatura', 346.0000, 'ºC'),
	(21496, 110, '2015-01-15 01:20:23.000000', 'temperatura', 1147.0000, 'ºC'),
	(21497, 110, '2015-01-15 01:20:24.000000', 'temperatura', 1099.0000, 'ºC'),
	(21498, 110, '2015-01-15 01:20:25.000000', 'temperatura', 852.0000, 'ºC'),
	(21499, 110, '2015-01-15 01:20:26.000000', 'temperatura', 964.0000, 'ºC'),
	(21500, 110, '2015-01-15 01:20:27.000000', 'temperatura', 1063.0000, 'ºC'),
	(21501, 110, '2015-01-15 01:20:28.000000', 'temperatura', 26.0000, 'ºC'),
	(21502, 110, '2015-01-15 01:20:29.000000', 'temperatura', 541.0000, 'ºC'),
	(21503, 110, '2015-01-15 01:20:30.000000', 'temperatura', 226.0000, 'ºC'),
	(21504, 110, '2015-01-15 01:20:31.000000', 'temperatura', 708.0000, 'ºC'),
	(21505, 110, '2015-01-15 01:20:32.000000', 'temperatura', 465.0000, 'ºC'),
	(21506, 110, '2015-01-15 01:20:33.000000', 'temperatura', 198.0000, 'ºC'),
	(21507, 110, '2015-01-15 01:20:34.000000', 'temperatura', 796.0000, 'ºC'),
	(21508, 110, '2015-01-15 01:20:35.000000', 'temperatura', 988.0000, 'ºC'),
	(21509, 110, '2015-01-15 01:20:36.000000', 'temperatura', 154.0000, 'ºC'),
	(21510, 110, '2015-01-15 01:20:37.000000', 'temperatura', 205.0000, 'ºC'),
	(21511, 110, '2015-01-15 01:20:38.000000', 'temperatura', 562.0000, 'ºC'),
	(21512, 110, '2015-01-15 01:20:39.000000', 'temperatura', 996.0000, 'ºC'),
	(21513, 110, '2015-01-15 01:20:40.000000', 'temperatura', 895.0000, 'ºC'),
	(21514, 110, '2015-01-15 01:20:41.000000', 'temperatura', 289.0000, 'ºC'),
	(21515, 110, '2015-01-15 01:20:42.000000', 'temperatura', 1161.0000, 'ºC'),
	(21516, 110, '2015-01-15 01:20:43.000000', 'temperatura', 139.0000, 'ºC'),
	(21517, 110, '2015-01-15 01:20:44.000000', 'temperatura', 811.0000, 'ºC'),
	(21518, 110, '2015-01-15 01:20:45.000000', 'temperatura', 38.0000, 'ºC'),
	(21519, 110, '2015-01-15 01:20:46.000000', 'temperatura', 160.0000, 'ºC'),
	(21520, 110, '2015-01-15 01:20:47.000000', 'temperatura', 685.0000, 'ºC'),
	(21521, 110, '2015-01-15 01:20:48.000000', 'temperatura', 545.0000, 'ºC'),
	(21522, 110, '2015-01-15 01:20:49.000000', 'temperatura', 670.0000, 'ºC'),
	(21523, 110, '2015-01-15 01:20:50.000000', 'temperatura', 515.0000, 'ºC'),
	(21524, 110, '2015-01-15 01:20:51.000000', 'temperatura', 566.0000, 'ºC'),
	(21525, 110, '2015-01-15 01:20:52.000000', 'temperatura', 86.0000, 'ºC'),
	(21526, 110, '2015-01-15 01:20:53.000000', 'temperatura', 1131.0000, 'ºC'),
	(21527, 110, '2015-01-15 01:20:54.000000', 'temperatura', 598.0000, 'ºC'),
	(21528, 110, '2015-01-15 01:20:55.000000', 'temperatura', 796.0000, 'ºC'),
	(21529, 110, '2015-01-15 01:20:56.000000', 'temperatura', 987.0000, 'ºC'),
	(21530, 110, '2015-01-15 01:20:57.000000', 'temperatura', 146.0000, 'ºC'),
	(21531, 110, '2015-01-15 01:20:58.000000', 'temperatura', 171.0000, 'ºC'),
	(21532, 110, '2015-01-15 01:20:59.000000', 'temperatura', 418.0000, 'ºC'),
	(21533, 110, '2015-01-15 01:21:00.000000', 'temperatura', 378.0000, 'ºC'),
	(21534, 110, '2015-01-15 01:21:01.000000', 'temperatura', 637.0000, 'ºC'),
	(21535, 110, '2015-01-15 01:21:02.000000', 'temperatura', 851.0000, 'ºC'),
	(21536, 110, '2015-01-15 01:21:03.000000', 'temperatura', 1144.0000, 'ºC'),
	(21537, 110, '2015-01-15 01:21:04.000000', 'temperatura', 766.0000, 'ºC'),
	(21538, 110, '2015-01-15 01:21:05.000000', 'temperatura', 399.0000, 'ºC'),
	(21539, 110, '2015-01-15 01:21:06.000000', 'temperatura', 899.0000, 'ºC'),
	(21540, 110, '2015-01-15 01:21:07.000000', 'temperatura', 899.0000, 'ºC'),
	(21541, 110, '2015-01-15 01:21:08.000000', 'temperatura', 596.0000, 'ºC'),
	(21542, 110, '2015-01-15 01:21:09.000000', 'temperatura', 284.0000, 'ºC'),
	(21543, 110, '2015-01-15 01:21:10.000000', 'temperatura', 835.0000, 'ºC'),
	(21544, 110, '2015-01-15 01:21:11.000000', 'temperatura', 922.0000, 'ºC'),
	(21545, 110, '2015-01-15 01:21:12.000000', 'temperatura', 904.0000, 'ºC'),
	(21546, 110, '2015-01-15 01:21:13.000000', 'temperatura', 555.0000, 'ºC'),
	(21547, 110, '2015-01-15 01:21:14.000000', 'temperatura', 66.0000, 'ºC'),
	(21548, 110, '2015-01-15 01:21:15.000000', 'temperatura', 1064.0000, 'ºC'),
	(21549, 110, '2015-01-15 01:21:16.000000', 'temperatura', 322.0000, 'ºC'),
	(21550, 110, '2015-01-15 01:21:17.000000', 'temperatura', 819.0000, 'ºC'),
	(21551, 110, '2015-01-15 01:21:18.000000', 'temperatura', 729.0000, 'ºC'),
	(21552, 110, '2015-01-15 01:21:19.000000', 'temperatura', 1188.0000, 'ºC'),
	(21553, 110, '2015-01-15 01:21:20.000000', 'temperatura', 156.0000, 'ºC'),
	(21554, 110, '2015-01-15 01:21:21.000000', 'temperatura', 815.0000, 'ºC'),
	(21555, 110, '2015-01-15 01:21:22.000000', 'temperatura', 6.0000, 'ºC'),
	(21556, 110, '2015-01-15 01:21:23.000000', 'temperatura', 1186.0000, 'ºC'),
	(21557, 110, '2015-01-15 01:21:24.000000', 'temperatura', 1111.0000, 'ºC'),
	(21558, 110, '2015-01-15 01:21:25.000000', 'temperatura', 800.0000, 'ºC'),
	(21559, 110, '2015-01-15 01:21:26.000000', 'temperatura', 667.0000, 'ºC'),
	(21560, 110, '2015-01-15 01:21:27.000000', 'temperatura', 934.0000, 'ºC'),
	(21561, 110, '2015-01-15 01:21:28.000000', 'temperatura', 269.0000, 'ºC'),
	(21562, 110, '2015-01-15 01:21:29.000000', 'temperatura', 944.0000, 'ºC'),
	(21563, 110, '2015-01-15 01:21:30.000000', 'temperatura', 312.0000, 'ºC'),
	(21564, 110, '2015-01-15 01:21:31.000000', 'temperatura', 1131.0000, 'ºC'),
	(21565, 110, '2015-01-15 01:21:32.000000', 'temperatura', 1117.0000, 'ºC'),
	(21566, 110, '2015-01-15 01:21:33.000000', 'temperatura', 994.0000, 'ºC'),
	(21567, 110, '2015-01-15 01:21:34.000000', 'temperatura', 417.0000, 'ºC'),
	(21568, 110, '2015-01-15 01:21:35.000000', 'temperatura', 306.0000, 'ºC'),
	(21569, 110, '2015-01-15 01:21:36.000000', 'temperatura', 280.0000, 'ºC'),
	(21570, 110, '2015-01-15 01:21:37.000000', 'temperatura', 483.0000, 'ºC'),
	(21571, 110, '2015-01-15 01:21:38.000000', 'temperatura', 373.0000, 'ºC'),
	(21572, 110, '2015-01-15 01:21:39.000000', 'temperatura', 417.0000, 'ºC'),
	(21573, 110, '2015-01-15 01:21:40.000000', 'temperatura', 966.0000, 'ºC'),
	(21574, 110, '2015-01-15 01:21:41.000000', 'temperatura', 1181.0000, 'ºC'),
	(21575, 110, '2015-01-15 01:21:42.000000', 'temperatura', 607.0000, 'ºC'),
	(21576, 110, '2015-01-15 01:21:43.000000', 'temperatura', 692.0000, 'ºC'),
	(21577, 110, '2015-01-15 01:21:44.000000', 'temperatura', 438.0000, 'ºC'),
	(21578, 110, '2015-01-15 01:21:45.000000', 'temperatura', 116.0000, 'ºC'),
	(21579, 110, '2015-01-15 01:21:46.000000', 'temperatura', 466.0000, 'ºC'),
	(21580, 110, '2015-01-15 01:21:47.000000', 'temperatura', 782.0000, 'ºC'),
	(21581, 110, '2015-01-15 01:21:48.000000', 'temperatura', 115.0000, 'ºC'),
	(21582, 110, '2015-01-15 01:21:49.000000', 'temperatura', 627.0000, 'ºC'),
	(21583, 110, '2015-01-15 01:21:50.000000', 'temperatura', 389.0000, 'ºC'),
	(21584, 110, '2015-01-15 01:21:51.000000', 'temperatura', 67.0000, 'ºC'),
	(21585, 110, '2015-01-15 01:21:52.000000', 'temperatura', 367.0000, 'ºC'),
	(21586, 110, '2015-01-15 01:21:53.000000', 'temperatura', 433.0000, 'ºC'),
	(21587, 110, '2015-01-15 01:21:54.000000', 'temperatura', 1067.0000, 'ºC'),
	(21588, 110, '2015-01-15 01:21:55.000000', 'temperatura', 437.0000, 'ºC'),
	(21589, 110, '2015-01-15 01:21:56.000000', 'temperatura', 182.0000, 'ºC'),
	(21590, 110, '2015-01-15 01:21:57.000000', 'temperatura', 801.0000, 'ºC'),
	(21591, 110, '2015-01-15 01:21:58.000000', 'temperatura', 1060.0000, 'ºC'),
	(21592, 110, '2015-01-15 01:21:59.000000', 'temperatura', 495.0000, 'ºC'),
	(21593, 110, '2015-01-15 01:22:00.000000', 'temperatura', 497.0000, 'ºC'),
	(21594, 110, '2015-01-15 01:22:01.000000', 'temperatura', 1000.0000, 'ºC'),
	(21595, 110, '2015-01-15 01:22:02.000000', 'temperatura', 1109.0000, 'ºC'),
	(21596, 110, '2015-01-15 01:22:03.000000', 'temperatura', 145.0000, 'ºC'),
	(21597, 110, '2015-01-15 01:22:04.000000', 'temperatura', 1000.0000, 'ºC'),
	(21598, 110, '2015-01-15 01:22:05.000000', 'temperatura', 963.0000, 'ºC'),
	(21599, 110, '2015-01-15 01:22:06.000000', 'temperatura', 616.0000, 'ºC'),
	(21600, 110, '2015-01-15 01:22:07.000000', 'temperatura', 194.0000, 'ºC'),
	(21601, 110, '2015-01-15 01:22:08.000000', 'temperatura', 320.0000, 'ºC'),
	(21602, 110, '2015-01-15 01:22:09.000000', 'temperatura', 1020.0000, 'ºC'),
	(21603, 110, '2015-01-15 01:22:10.000000', 'temperatura', 540.0000, 'ºC'),
	(21604, 110, '2015-01-15 01:22:11.000000', 'temperatura', 839.0000, 'ºC'),
	(21605, 110, '2015-01-15 01:22:12.000000', 'temperatura', 176.0000, 'ºC'),
	(21606, 110, '2015-01-15 01:22:13.000000', 'temperatura', 764.0000, 'ºC'),
	(21607, 110, '2015-01-15 01:22:14.000000', 'temperatura', 892.0000, 'ºC'),
	(21608, 110, '2015-01-15 01:22:15.000000', 'temperatura', 967.0000, 'ºC'),
	(21609, 110, '2015-01-15 01:22:16.000000', 'temperatura', 960.0000, 'ºC'),
	(21610, 110, '2015-01-15 01:22:17.000000', 'temperatura', 700.0000, 'ºC'),
	(21611, 110, '2015-01-15 01:22:18.000000', 'temperatura', 620.0000, 'ºC'),
	(21612, 110, '2015-01-15 01:22:19.000000', 'temperatura', 1001.0000, 'ºC'),
	(21613, 110, '2015-01-15 01:22:20.000000', 'temperatura', 746.0000, 'ºC'),
	(21614, 110, '2015-01-15 01:22:21.000000', 'temperatura', 729.0000, 'ºC'),
	(21615, 110, '2015-01-15 01:22:22.000000', 'temperatura', 206.0000, 'ºC'),
	(21616, 110, '2015-01-15 01:22:23.000000', 'temperatura', 44.0000, 'ºC'),
	(21617, 110, '2015-01-15 01:22:24.000000', 'temperatura', 804.0000, 'ºC'),
	(21618, 110, '2015-01-15 01:22:25.000000', 'temperatura', 286.0000, 'ºC'),
	(21619, 110, '2015-01-15 01:22:26.000000', 'temperatura', 221.0000, 'ºC'),
	(21620, 110, '2015-01-15 01:22:27.000000', 'temperatura', 246.0000, 'ºC'),
	(21621, 110, '2015-01-15 01:22:28.000000', 'temperatura', 566.0000, 'ºC'),
	(21622, 110, '2015-01-15 01:22:29.000000', 'temperatura', 894.0000, 'ºC'),
	(21623, 110, '2015-01-15 01:22:30.000000', 'temperatura', 371.0000, 'ºC'),
	(21624, 110, '2015-01-15 01:22:31.000000', 'temperatura', 374.0000, 'ºC'),
	(21625, 110, '2015-01-15 01:22:32.000000', 'temperatura', 758.0000, 'ºC'),
	(21626, 110, '2015-01-15 01:22:33.000000', 'temperatura', 269.0000, 'ºC'),
	(21627, 110, '2015-01-15 01:22:34.000000', 'temperatura', 270.0000, 'ºC'),
	(21628, 110, '2015-01-15 01:22:35.000000', 'temperatura', 546.0000, 'ºC'),
	(21629, 110, '2015-01-15 01:22:36.000000', 'temperatura', 718.0000, 'ºC'),
	(21630, 110, '2015-01-15 01:22:37.000000', 'temperatura', 755.0000, 'ºC'),
	(21631, 110, '2015-01-15 01:22:38.000000', 'temperatura', 419.0000, 'ºC'),
	(21632, 110, '2015-01-15 01:22:39.000000', 'temperatura', 1031.0000, 'ºC'),
	(21633, 110, '2015-01-15 01:22:40.000000', 'temperatura', 300.0000, 'ºC'),
	(21634, 110, '2015-01-15 01:22:41.000000', 'temperatura', 806.0000, 'ºC'),
	(21635, 110, '2015-01-15 01:22:42.000000', 'temperatura', 733.0000, 'ºC'),
	(21636, 110, '2015-01-15 01:22:43.000000', 'temperatura', 46.0000, 'ºC'),
	(21637, 110, '2015-01-15 01:22:44.000000', 'temperatura', 431.0000, 'ºC'),
	(21638, 110, '2015-01-15 01:22:45.000000', 'temperatura', 816.0000, 'ºC'),
	(21639, 110, '2015-01-15 01:22:46.000000', 'temperatura', 390.0000, 'ºC'),
	(21640, 110, '2015-01-15 01:22:47.000000', 'temperatura', 701.0000, 'ºC'),
	(21641, 110, '2015-01-15 01:22:48.000000', 'temperatura', 1137.0000, 'ºC'),
	(21642, 110, '2015-01-15 01:22:49.000000', 'temperatura', 1182.0000, 'ºC'),
	(21643, 110, '2015-01-15 01:22:50.000000', 'temperatura', 98.0000, 'ºC'),
	(21644, 110, '2015-01-15 01:22:51.000000', 'temperatura', 544.0000, 'ºC'),
	(21645, 110, '2015-01-15 01:22:52.000000', 'temperatura', 26.0000, 'ºC'),
	(21646, 110, '2015-01-15 01:22:53.000000', 'temperatura', 901.0000, 'ºC'),
	(21647, 110, '2015-01-15 01:22:54.000000', 'temperatura', 826.0000, 'ºC'),
	(21648, 110, '2015-01-15 01:22:55.000000', 'temperatura', 228.0000, 'ºC'),
	(21649, 110, '2015-01-15 01:22:56.000000', 'temperatura', 1064.0000, 'ºC'),
	(21650, 110, '2015-01-15 01:22:57.000000', 'temperatura', 1037.0000, 'ºC'),
	(21651, 110, '2015-01-15 01:22:58.000000', 'temperatura', 793.0000, 'ºC'),
	(21652, 110, '2015-01-15 01:22:59.000000', 'temperatura', 854.0000, 'ºC'),
	(21653, 110, '2015-01-15 01:23:00.000000', 'temperatura', 693.0000, 'ºC'),
	(21654, 110, '2015-01-15 01:23:01.000000', 'temperatura', 903.0000, 'ºC'),
	(21655, 110, '2015-01-15 01:23:02.000000', 'temperatura', 36.0000, 'ºC'),
	(21656, 110, '2015-01-15 01:23:03.000000', 'temperatura', 1070.0000, 'ºC'),
	(21657, 110, '2015-01-15 01:23:04.000000', 'temperatura', 444.0000, 'ºC'),
	(21658, 110, '2015-01-15 01:23:05.000000', 'temperatura', 212.0000, 'ºC'),
	(21659, 110, '2015-01-15 01:23:06.000000', 'temperatura', 925.0000, 'ºC'),
	(21660, 110, '2015-01-15 01:23:07.000000', 'temperatura', 392.0000, 'ºC'),
	(21661, 110, '2015-01-15 01:23:08.000000', 'temperatura', 385.0000, 'ºC'),
	(21662, 110, '2015-01-15 01:23:09.000000', 'temperatura', 751.0000, 'ºC'),
	(21663, 110, '2015-01-15 01:23:10.000000', 'temperatura', 200.0000, 'ºC'),
	(21664, 110, '2015-01-15 01:23:11.000000', 'temperatura', 1149.0000, 'ºC'),
	(21665, 110, '2015-01-15 01:23:12.000000', 'temperatura', 344.0000, 'ºC'),
	(21666, 110, '2015-01-15 01:23:13.000000', 'temperatura', 674.0000, 'ºC'),
	(21667, 110, '2015-01-15 01:23:14.000000', 'temperatura', 1139.0000, 'ºC'),
	(21668, 110, '2015-01-15 01:23:15.000000', 'temperatura', 71.0000, 'ºC'),
	(21669, 110, '2015-01-15 01:23:16.000000', 'temperatura', 540.0000, 'ºC'),
	(21670, 110, '2015-01-15 01:23:17.000000', 'temperatura', 88.0000, 'ºC'),
	(21671, 110, '2015-01-15 01:23:18.000000', 'temperatura', 19.0000, 'ºC'),
	(21672, 110, '2015-01-15 01:23:19.000000', 'temperatura', 1033.0000, 'ºC'),
	(21673, 110, '2015-01-15 01:23:20.000000', 'temperatura', 308.0000, 'ºC'),
	(21674, 110, '2015-01-15 01:23:21.000000', 'temperatura', 843.0000, 'ºC'),
	(21675, 110, '2015-01-15 01:23:22.000000', 'temperatura', 891.0000, 'ºC'),
	(21676, 110, '2015-01-15 01:23:23.000000', 'temperatura', 725.0000, 'ºC'),
	(21677, 110, '2015-01-15 01:23:24.000000', 'temperatura', 954.0000, 'ºC'),
	(21678, 110, '2015-01-15 01:23:25.000000', 'temperatura', 197.0000, 'ºC'),
	(21679, 110, '2015-01-15 01:23:26.000000', 'temperatura', 520.0000, 'ºC'),
	(21680, 110, '2015-01-15 01:23:27.000000', 'temperatura', 813.0000, 'ºC'),
	(21681, 110, '2015-01-15 01:23:28.000000', 'temperatura', 102.0000, 'ºC'),
	(21682, 110, '2015-01-15 01:23:29.000000', 'temperatura', 474.0000, 'ºC'),
	(21683, 110, '2015-01-15 01:23:30.000000', 'temperatura', 863.0000, 'ºC'),
	(21684, 110, '2015-01-15 01:23:31.000000', 'temperatura', 493.0000, 'ºC'),
	(21685, 110, '2015-01-15 01:23:32.000000', 'temperatura', 1077.0000, 'ºC'),
	(21686, 110, '2015-01-15 01:23:33.000000', 'temperatura', 306.0000, 'ºC'),
	(21687, 110, '2015-01-15 01:23:34.000000', 'temperatura', 700.0000, 'ºC'),
	(21688, 110, '2015-01-15 01:23:35.000000', 'temperatura', 183.0000, 'ºC'),
	(21689, 110, '2015-01-15 01:23:36.000000', 'temperatura', 14.0000, 'ºC'),
	(21690, 110, '2015-01-15 01:23:37.000000', 'temperatura', 722.0000, 'ºC'),
	(21691, 110, '2015-01-15 01:23:38.000000', 'temperatura', 1169.0000, 'ºC'),
	(21692, 110, '2015-01-15 01:23:39.000000', 'temperatura', 80.0000, 'ºC'),
	(21693, 110, '2015-01-15 01:23:40.000000', 'temperatura', 495.0000, 'ºC'),
	(21694, 110, '2015-01-15 01:23:41.000000', 'temperatura', 1032.0000, 'ºC'),
	(21695, 110, '2015-01-15 01:23:42.000000', 'temperatura', 77.0000, 'ºC'),
	(21696, 110, '2015-01-15 01:23:43.000000', 'temperatura', 889.0000, 'ºC'),
	(21697, 110, '2015-01-15 01:23:44.000000', 'temperatura', 615.0000, 'ºC'),
	(21698, 110, '2015-01-15 01:23:45.000000', 'temperatura', 408.0000, 'ºC'),
	(21699, 110, '2015-01-15 01:23:46.000000', 'temperatura', 196.0000, 'ºC'),
	(21700, 110, '2015-01-15 01:23:47.000000', 'temperatura', 958.0000, 'ºC'),
	(21701, 110, '2015-01-15 01:23:48.000000', 'temperatura', 601.0000, 'ºC'),
	(21702, 110, '2015-01-15 01:23:49.000000', 'temperatura', 131.0000, 'ºC'),
	(21703, 110, '2015-01-15 01:23:50.000000', 'temperatura', 54.0000, 'ºC'),
	(21704, 110, '2015-01-15 01:23:51.000000', 'temperatura', 1075.0000, 'ºC'),
	(21705, 110, '2015-01-15 01:23:52.000000', 'temperatura', 416.0000, 'ºC'),
	(21706, 110, '2015-01-15 01:23:53.000000', 'temperatura', 56.0000, 'ºC'),
	(21707, 110, '2015-01-15 01:23:54.000000', 'temperatura', 230.0000, 'ºC'),
	(21708, 110, '2015-01-15 01:23:55.000000', 'temperatura', 985.0000, 'ºC'),
	(21709, 110, '2015-01-15 01:23:56.000000', 'temperatura', 634.0000, 'ºC'),
	(21710, 110, '2015-01-15 01:23:57.000000', 'temperatura', 217.0000, 'ºC'),
	(21711, 110, '2015-01-15 01:23:58.000000', 'temperatura', 385.0000, 'ºC'),
	(21712, 110, '2015-01-15 01:23:59.000000', 'temperatura', 71.0000, 'ºC'),
	(21713, 110, '2015-01-15 01:24:00.000000', 'temperatura', 403.0000, 'ºC'),
	(21714, 110, '2015-01-15 01:24:01.000000', 'temperatura', 601.0000, 'ºC'),
	(21715, 110, '2015-01-15 01:24:02.000000', 'temperatura', 596.0000, 'ºC'),
	(21716, 110, '2015-01-15 01:24:03.000000', 'temperatura', 1177.0000, 'ºC'),
	(21717, 110, '2015-01-15 01:24:04.000000', 'temperatura', 496.0000, 'ºC'),
	(21718, 110, '2015-01-15 01:24:05.000000', 'temperatura', 153.0000, 'ºC'),
	(21719, 110, '2015-01-15 01:24:06.000000', 'temperatura', 475.0000, 'ºC'),
	(21720, 110, '2015-01-15 01:24:07.000000', 'temperatura', 717.0000, 'ºC'),
	(21721, 110, '2015-01-15 01:24:08.000000', 'temperatura', 960.0000, 'ºC'),
	(21722, 110, '2015-01-15 01:24:09.000000', 'temperatura', 249.0000, 'ºC'),
	(21723, 110, '2015-01-15 01:24:10.000000', 'temperatura', 766.0000, 'ºC'),
	(21724, 110, '2015-01-15 01:24:11.000000', 'temperatura', 682.0000, 'ºC'),
	(21725, 110, '2015-01-15 01:24:12.000000', 'temperatura', 1115.0000, 'ºC'),
	(21726, 110, '2015-01-15 01:24:13.000000', 'temperatura', 1130.0000, 'ºC'),
	(21727, 110, '2015-01-15 01:24:14.000000', 'temperatura', 1106.0000, 'ºC'),
	(21728, 110, '2015-01-15 01:24:15.000000', 'temperatura', 938.0000, 'ºC'),
	(21729, 110, '2015-01-15 01:24:16.000000', 'temperatura', 173.0000, 'ºC'),
	(21730, 110, '2015-01-15 01:24:17.000000', 'temperatura', 452.0000, 'ºC'),
	(21731, 110, '2015-01-15 01:24:18.000000', 'temperatura', 539.0000, 'ºC'),
	(21732, 110, '2015-01-15 01:24:19.000000', 'temperatura', 143.0000, 'ºC'),
	(21733, 110, '2015-01-15 01:24:20.000000', 'temperatura', 295.0000, 'ºC'),
	(21734, 110, '2015-01-15 01:24:21.000000', 'temperatura', 1049.0000, 'ºC'),
	(21735, 110, '2015-01-15 01:24:22.000000', 'temperatura', 761.0000, 'ºC'),
	(21736, 110, '2015-01-15 01:24:23.000000', 'temperatura', 656.0000, 'ºC'),
	(21737, 110, '2015-01-15 01:24:24.000000', 'temperatura', 1000.0000, 'ºC'),
	(21738, 110, '2015-01-15 01:24:25.000000', 'temperatura', 631.0000, 'ºC'),
	(21739, 110, '2015-01-15 01:24:26.000000', 'temperatura', 155.0000, 'ºC'),
	(21740, 110, '2015-01-15 01:24:27.000000', 'temperatura', 82.0000, 'ºC'),
	(21741, 110, '2015-01-15 01:24:28.000000', 'temperatura', 1146.0000, 'ºC'),
	(21742, 110, '2015-01-15 01:24:29.000000', 'temperatura', 685.0000, 'ºC'),
	(21743, 110, '2015-01-15 01:24:30.000000', 'temperatura', 1187.0000, 'ºC'),
	(21744, 110, '2015-01-15 01:24:31.000000', 'temperatura', 280.0000, 'ºC'),
	(21745, 110, '2015-01-15 01:24:32.000000', 'temperatura', 240.0000, 'ºC'),
	(21746, 110, '2015-01-15 01:24:33.000000', 'temperatura', 360.0000, 'ºC'),
	(21747, 110, '2015-01-15 01:24:34.000000', 'temperatura', 1080.0000, 'ºC'),
	(21748, 110, '2015-01-15 01:24:35.000000', 'temperatura', 722.0000, 'ºC'),
	(21749, 110, '2015-01-15 01:24:36.000000', 'temperatura', 368.0000, 'ºC'),
	(21750, 110, '2015-01-15 01:24:37.000000', 'temperatura', 876.0000, 'ºC'),
	(21751, 110, '2015-01-15 01:24:38.000000', 'temperatura', 876.0000, 'ºC'),
	(21752, 110, '2015-01-15 01:24:39.000000', 'temperatura', 555.0000, 'ºC'),
	(21753, 110, '2015-01-15 01:24:40.000000', 'temperatura', 145.0000, 'ºC'),
	(21754, 110, '2015-01-15 01:24:41.000000', 'temperatura', 259.0000, 'ºC'),
	(21755, 110, '2015-01-15 01:24:42.000000', 'temperatura', 863.0000, 'ºC'),
	(21756, 110, '2015-01-15 01:24:43.000000', 'temperatura', 1138.0000, 'ºC'),
	(21757, 110, '2015-01-15 01:24:44.000000', 'temperatura', 699.0000, 'ºC'),
	(21758, 110, '2015-01-15 01:24:45.000000', 'temperatura', 84.0000, 'ºC'),
	(21759, 110, '2015-01-15 01:24:46.000000', 'temperatura', 724.0000, 'ºC'),
	(21760, 110, '2015-01-15 01:24:47.000000', 'temperatura', 968.0000, 'ºC'),
	(21761, 110, '2015-01-15 01:24:48.000000', 'temperatura', 270.0000, 'ºC'),
	(21762, 110, '2015-01-15 01:24:49.000000', 'temperatura', 846.0000, 'ºC'),
	(21763, 110, '2015-01-15 01:24:50.000000', 'temperatura', 1021.0000, 'ºC'),
	(21764, 110, '2015-01-15 01:24:51.000000', 'temperatura', 165.0000, 'ºC'),
	(21765, 110, '2015-01-15 01:24:52.000000', 'temperatura', 165.0000, 'ºC'),
	(21766, 110, '2015-01-15 01:24:53.000000', 'temperatura', 328.0000, 'ºC'),
	(21767, 110, '2015-01-15 01:24:54.000000', 'temperatura', 1145.0000, 'ºC'),
	(21768, 110, '2015-01-15 01:24:55.000000', 'temperatura', 1144.0000, 'ºC'),
	(21769, 110, '2015-01-15 01:24:56.000000', 'temperatura', 1087.0000, 'ºC'),
	(21770, 110, '2015-01-15 01:24:57.000000', 'temperatura', 800.0000, 'ºC'),
	(21771, 110, '2015-01-15 01:24:58.000000', 'temperatura', 742.0000, 'ºC'),
	(21772, 110, '2015-01-15 01:24:59.000000', 'temperatura', 109.0000, 'ºC'),
	(21773, 110, '2015-01-15 01:25:00.000000', 'temperatura', 721.0000, 'ºC'),
	(21774, 110, '2015-01-15 01:25:01.000000', 'temperatura', 877.0000, 'ºC'),
	(21775, 110, '2015-01-15 01:25:02.000000', 'temperatura', 1025.0000, 'ºC'),
	(21776, 110, '2015-01-15 01:25:03.000000', 'temperatura', 94.0000, 'ºC'),
	(21777, 110, '2015-01-15 01:25:04.000000', 'temperatura', 993.0000, 'ºC'),
	(21778, 110, '2015-01-15 01:25:05.000000', 'temperatura', 1086.0000, 'ºC'),
	(21779, 110, '2015-01-15 01:25:06.000000', 'temperatura', 49.0000, 'ºC'),
	(21780, 110, '2015-01-15 01:25:07.000000', 'temperatura', 589.0000, 'ºC'),
	(21781, 110, '2015-01-15 01:25:08.000000', 'temperatura', 400.0000, 'ºC'),
	(21782, 110, '2015-01-15 01:25:09.000000', 'temperatura', 232.0000, 'ºC'),
	(21783, 110, '2015-01-15 01:25:10.000000', 'temperatura', 1161.0000, 'ºC'),
	(21784, 110, '2015-01-15 01:25:11.000000', 'temperatura', 308.0000, 'ºC'),
	(21785, 110, '2015-01-15 01:25:12.000000', 'temperatura', 459.0000, 'ºC'),
	(21786, 110, '2015-01-15 01:25:13.000000', 'temperatura', 169.0000, 'ºC'),
	(21787, 110, '2015-01-15 01:25:14.000000', 'temperatura', 670.0000, 'ºC'),
	(21788, 110, '2015-01-15 01:25:15.000000', 'temperatura', 444.0000, 'ºC'),
	(21789, 110, '2015-01-15 01:25:16.000000', 'temperatura', 209.0000, 'ºC'),
	(21790, 110, '2015-01-15 01:25:17.000000', 'temperatura', 913.0000, 'ºC'),
	(21791, 110, '2015-01-15 01:25:18.000000', 'temperatura', 341.0000, 'ºC'),
	(21792, 110, '2015-01-15 01:25:19.000000', 'temperatura', 166.0000, 'ºC'),
	(21793, 110, '2015-01-15 01:25:20.000000', 'temperatura', 1008.0000, 'ºC'),
	(21794, 110, '2015-01-15 01:25:21.000000', 'temperatura', 942.0000, 'ºC'),
	(21795, 110, '2015-01-15 01:25:22.000000', 'temperatura', 485.0000, 'ºC'),
	(21796, 110, '2015-01-15 01:25:23.000000', 'temperatura', 802.0000, 'ºC'),
	(21797, 110, '2015-01-15 01:25:24.000000', 'temperatura', 155.0000, 'ºC'),
	(21798, 110, '2015-01-15 01:25:25.000000', 'temperatura', 770.0000, 'ºC'),
	(21799, 110, '2015-01-15 01:25:26.000000', 'temperatura', 986.0000, 'ºC'),
	(21800, 110, '2015-01-15 01:25:27.000000', 'temperatura', 219.0000, 'ºC'),
	(21801, 110, '2015-01-15 01:25:28.000000', 'temperatura', 540.0000, 'ºC'),
	(21802, 110, '2015-01-15 01:25:29.000000', 'temperatura', 840.0000, 'ºC'),
	(21803, 110, '2015-01-15 01:25:30.000000', 'temperatura', 182.0000, 'ºC'),
	(21804, 110, '2015-01-15 01:25:31.000000', 'temperatura', 791.0000, 'ºC'),
	(21805, 110, '2015-01-15 01:25:32.000000', 'temperatura', 1008.0000, 'ºC'),
	(21806, 110, '2015-01-15 01:25:33.000000', 'temperatura', 269.0000, 'ºC'),
	(21807, 110, '2015-01-15 01:25:34.000000', 'temperatura', 720.0000, 'ºC'),
	(21808, 110, '2015-01-15 01:25:35.000000', 'temperatura', 393.0000, 'ºC'),
	(21809, 110, '2015-01-15 01:25:36.000000', 'temperatura', 1008.0000, 'ºC'),
	(21810, 110, '2015-01-15 01:25:37.000000', 'temperatura', 261.0000, 'ºC'),
	(21811, 110, '2015-01-15 01:25:38.000000', 'temperatura', 681.0000, 'ºC'),
	(21812, 110, '2015-01-15 01:25:39.000000', 'temperatura', 222.0000, 'ºC'),
	(21813, 110, '2015-01-15 01:25:40.000000', 'temperatura', 269.0000, 'ºC'),
	(21814, 110, '2015-01-15 01:25:41.000000', 'temperatura', 677.0000, 'ºC'),
	(21815, 110, '2015-01-15 01:25:42.000000', 'temperatura', 180.0000, 'ºC'),
	(21816, 110, '2015-01-15 01:25:43.000000', 'temperatura', 70.0000, 'ºC'),
	(21817, 110, '2015-01-15 01:25:44.000000', 'temperatura', 1009.0000, 'ºC'),
	(21818, 110, '2015-01-15 01:25:45.000000', 'temperatura', 37.0000, 'ºC'),
	(21819, 110, '2015-01-15 01:25:46.000000', 'temperatura', 760.0000, 'ºC'),
	(21820, 110, '2015-01-15 01:25:47.000000', 'temperatura', 88.0000, 'ºC'),
	(21821, 110, '2015-01-15 01:25:48.000000', 'temperatura', 559.0000, 'ºC'),
	(21822, 110, '2015-01-15 01:25:49.000000', 'temperatura', 132.0000, 'ºC'),
	(21823, 110, '2015-01-15 01:25:50.000000', 'temperatura', 185.0000, 'ºC'),
	(21824, 110, '2015-01-15 01:25:51.000000', 'temperatura', 529.0000, 'ºC'),
	(21825, 110, '2015-01-15 01:25:52.000000', 'temperatura', 891.0000, 'ºC'),
	(21826, 110, '2015-01-15 01:25:53.000000', 'temperatura', 467.0000, 'ºC'),
	(21827, 110, '2015-01-15 01:25:54.000000', 'temperatura', 864.0000, 'ºC'),
	(21828, 110, '2015-01-15 01:25:55.000000', 'temperatura', 521.0000, 'ºC'),
	(21829, 110, '2015-01-15 01:25:56.000000', 'temperatura', 12.0000, 'ºC'),
	(21830, 110, '2015-01-15 01:25:57.000000', 'temperatura', 896.0000, 'ºC'),
	(21831, 110, '2015-01-15 01:25:58.000000', 'temperatura', 844.0000, 'ºC'),
	(21832, 110, '2015-01-15 01:25:59.000000', 'temperatura', 333.0000, 'ºC'),
	(21833, 110, '2015-01-15 01:26:00.000000', 'temperatura', 333.0000, 'ºC'),
	(21834, 110, '2015-01-15 01:26:01.000000', 'temperatura', 666.0000, 'ºC'),
	(21835, 110, '2015-01-15 01:26:02.000000', 'temperatura', 1134.0000, 'ºC'),
	(21836, 110, '2015-01-15 01:26:03.000000', 'temperatura', 71.0000, 'ºC'),
	(21837, 110, '2015-01-15 01:26:04.000000', 'temperatura', 556.0000, 'ºC'),
	(21838, 110, '2015-01-15 01:26:05.000000', 'temperatura', 164.0000, 'ºC'),
	(21839, 110, '2015-01-15 01:26:06.000000', 'temperatura', 355.0000, 'ºC'),
	(21840, 110, '2015-01-15 01:26:07.000000', 'temperatura', 84.0000, 'ºC'),
	(21841, 110, '2015-01-15 01:26:08.000000', 'temperatura', 553.0000, 'ºC'),
	(21842, 110, '2015-01-15 01:26:09.000000', 'temperatura', 114.0000, 'ºC'),
	(21843, 110, '2015-01-15 01:26:10.000000', 'temperatura', 110.0000, 'ºC'),
	(21844, 110, '2015-01-15 01:26:11.000000', 'temperatura', 212.0000, 'ºC'),
	(21845, 110, '2015-01-15 01:26:12.000000', 'temperatura', 729.0000, 'ºC'),
	(21846, 110, '2015-01-15 01:26:13.000000', 'temperatura', 609.0000, 'ºC'),
	(21847, 110, '2015-01-15 01:26:14.000000', 'temperatura', 859.0000, 'ºC'),
	(21848, 110, '2015-01-15 01:26:15.000000', 'temperatura', 68.0000, 'ºC'),
	(21849, 110, '2015-01-15 01:26:16.000000', 'temperatura', 164.0000, 'ºC'),
	(21850, 110, '2015-01-15 01:26:17.000000', 'temperatura', 617.0000, 'ºC'),
	(21851, 110, '2015-01-15 01:26:18.000000', 'temperatura', 193.0000, 'ºC'),
	(21852, 110, '2015-01-15 01:26:19.000000', 'temperatura', 316.0000, 'ºC'),
	(21853, 110, '2015-01-15 01:26:20.000000', 'temperatura', 1000.0000, 'ºC'),
	(21854, 110, '2015-01-15 01:26:21.000000', 'temperatura', 451.0000, 'ºC'),
	(21855, 110, '2015-01-15 01:26:22.000000', 'temperatura', 456.0000, 'ºC'),
	(21856, 110, '2015-01-15 01:26:23.000000', 'temperatura', 929.0000, 'ºC'),
	(21857, 110, '2015-01-15 01:26:24.000000', 'temperatura', 877.0000, 'ºC'),
	(21858, 110, '2015-01-15 01:26:25.000000', 'temperatura', 400.0000, 'ºC'),
	(21859, 110, '2015-01-15 01:26:26.000000', 'temperatura', 568.0000, 'ºC'),
	(21860, 110, '2015-01-15 01:26:27.000000', 'temperatura', 443.0000, 'ºC'),
	(21861, 110, '2015-01-15 01:26:28.000000', 'temperatura', 509.0000, 'ºC'),
	(21862, 110, '2015-01-15 01:26:29.000000', 'temperatura', 18.0000, 'ºC'),
	(21863, 110, '2015-01-15 01:26:30.000000', 'temperatura', 964.0000, 'ºC'),
	(21864, 110, '2015-01-15 01:26:31.000000', 'temperatura', 1166.0000, 'ºC'),
	(21865, 110, '2015-01-15 01:26:32.000000', 'temperatura', 537.0000, 'ºC'),
	(21866, 110, '2015-01-15 01:26:33.000000', 'temperatura', 387.0000, 'ºC'),
	(21867, 110, '2015-01-15 01:26:34.000000', 'temperatura', 327.0000, 'ºC'),
	(21868, 110, '2015-01-15 01:26:35.000000', 'temperatura', 472.0000, 'ºC'),
	(21869, 110, '2015-01-15 01:26:36.000000', 'temperatura', 181.0000, 'ºC'),
	(21870, 110, '2015-01-15 01:26:37.000000', 'temperatura', 687.0000, 'ºC'),
	(21871, 110, '2015-01-15 01:26:38.000000', 'temperatura', 495.0000, 'ºC'),
	(21872, 110, '2015-01-15 01:26:39.000000', 'temperatura', 416.0000, 'ºC'),
	(21873, 110, '2015-01-15 01:26:40.000000', 'temperatura', 592.0000, 'ºC'),
	(21874, 110, '2015-01-15 01:26:41.000000', 'temperatura', 515.0000, 'ºC'),
	(21875, 110, '2015-01-15 01:26:42.000000', 'temperatura', 797.0000, 'ºC'),
	(21876, 110, '2015-01-15 01:26:43.000000', 'temperatura', 41.0000, 'ºC'),
	(21877, 110, '2015-01-15 01:26:44.000000', 'temperatura', 215.0000, 'ºC'),
	(21878, 110, '2015-01-15 01:26:45.000000', 'temperatura', 954.0000, 'ºC'),
	(21879, 110, '2015-01-15 01:26:46.000000', 'temperatura', 523.0000, 'ºC'),
	(21880, 110, '2015-01-15 01:26:47.000000', 'temperatura', 955.0000, 'ºC'),
	(21881, 110, '2015-01-15 01:26:48.000000', 'temperatura', 804.0000, 'ºC'),
	(21882, 110, '2015-01-15 01:26:49.000000', 'temperatura', 1158.0000, 'ºC'),
	(21883, 110, '2015-01-15 01:26:50.000000', 'temperatura', 977.0000, 'ºC'),
	(21884, 110, '2015-01-15 01:26:51.000000', 'temperatura', 213.0000, 'ºC'),
	(21885, 110, '2015-01-15 01:26:52.000000', 'temperatura', 532.0000, 'ºC'),
	(21886, 110, '2015-01-15 01:26:53.000000', 'temperatura', 823.0000, 'ºC'),
	(21887, 110, '2015-01-15 01:26:54.000000', 'temperatura', 119.0000, 'ºC'),
	(21888, 110, '2015-01-15 01:26:55.000000', 'temperatura', 525.0000, 'ºC'),
	(21889, 110, '2015-01-15 01:26:56.000000', 'temperatura', 1071.0000, 'ºC'),
	(21890, 110, '2015-01-15 01:26:57.000000', 'temperatura', 178.0000, 'ºC'),
	(21891, 110, '2015-01-15 01:26:58.000000', 'temperatura', 79.0000, 'ºC'),
	(21892, 110, '2015-01-15 01:26:59.000000', 'temperatura', 1063.0000, 'ºC'),
	(21893, 110, '2015-01-15 01:27:00.000000', 'temperatura', 276.0000, 'ºC'),
	(21894, 110, '2015-01-15 01:27:01.000000', 'temperatura', 593.0000, 'ºC'),
	(21895, 110, '2015-01-15 01:27:02.000000', 'temperatura', 935.0000, 'ºC'),
	(21896, 110, '2015-01-15 01:27:03.000000', 'temperatura', 500.0000, 'ºC'),
	(21897, 110, '2015-01-15 01:27:04.000000', 'temperatura', 893.0000, 'ºC'),
	(21898, 110, '2015-01-15 01:27:05.000000', 'temperatura', 566.0000, 'ºC'),
	(21899, 110, '2015-01-15 01:27:06.000000', 'temperatura', 152.0000, 'ºC'),
	(21900, 110, '2015-01-15 01:27:07.000000', 'temperatura', 264.0000, 'ºC'),
	(21901, 110, '2015-01-15 01:27:08.000000', 'temperatura', 864.0000, 'ºC'),
	(21902, 110, '2015-01-15 01:27:09.000000', 'temperatura', 1130.0000, 'ºC'),
	(21903, 110, '2015-01-15 01:27:10.000000', 'temperatura', 655.0000, 'ºC'),
	(21904, 110, '2015-01-15 01:27:11.000000', 'temperatura', 1088.0000, 'ºC'),
	(21905, 110, '2015-01-15 01:27:12.000000', 'temperatura', 1075.0000, 'ºC'),
	(21906, 110, '2015-01-15 01:27:13.000000', 'temperatura', 910.0000, 'ºC'),
	(21907, 110, '2015-01-15 01:27:14.000000', 'temperatura', 128.0000, 'ºC'),
	(21908, 110, '2015-01-15 01:27:15.000000', 'temperatura', 311.0000, 'ºC'),
	(21909, 110, '2015-01-15 01:27:16.000000', 'temperatura', 1172.0000, 'ºC'),
	(21910, 110, '2015-01-15 01:27:17.000000', 'temperatura', 127.0000, 'ºC'),
	(21911, 110, '2015-01-15 01:27:18.000000', 'temperatura', 717.0000, 'ºC'),
	(21912, 110, '2015-01-15 01:27:19.000000', 'temperatura', 806.0000, 'ºC'),
	(21913, 110, '2015-01-15 01:27:20.000000', 'temperatura', 680.0000, 'ºC'),
	(21914, 110, '2015-01-15 01:27:21.000000', 'temperatura', 981.0000, 'ºC'),
	(21915, 110, '2015-01-15 01:27:22.000000', 'temperatura', 468.0000, 'ºC'),
	(21916, 110, '2015-01-15 01:27:23.000000', 'temperatura', 598.0000, 'ºC'),
	(21917, 110, '2015-01-15 01:27:24.000000', 'temperatura', 386.0000, 'ºC'),
	(21918, 110, '2015-01-15 01:27:25.000000', 'temperatura', 134.0000, 'ºC'),
	(21919, 110, '2015-01-15 01:27:26.000000', 'temperatura', 714.0000, 'ºC'),
	(21920, 110, '2015-01-15 01:27:27.000000', 'temperatura', 769.0000, 'ºC'),
	(21921, 110, '2015-01-15 01:27:28.000000', 'temperatura', 502.0000, 'ºC'),
	(21922, 110, '2015-01-15 01:27:29.000000', 'temperatura', 203.0000, 'ºC'),
	(21923, 110, '2015-01-15 01:27:30.000000', 'temperatura', 709.0000, 'ºC'),
	(21924, 110, '2015-01-15 01:27:31.000000', 'temperatura', 539.0000, 'ºC'),
	(21925, 110, '2015-01-15 01:27:32.000000', 'temperatura', 569.0000, 'ºC'),
	(21926, 110, '2015-01-15 01:27:33.000000', 'temperatura', 28.0000, 'ºC'),
	(21927, 110, '2015-01-15 01:27:34.000000', 'temperatura', 832.0000, 'ºC'),
	(21928, 110, '2015-01-15 01:27:35.000000', 'temperatura', 479.0000, 'ºC'),
	(21929, 110, '2015-01-15 01:27:36.000000', 'temperatura', 1098.0000, 'ºC'),
	(21930, 110, '2015-01-15 01:27:37.000000', 'temperatura', 455.0000, 'ºC'),
	(21931, 110, '2015-01-15 01:27:38.000000', 'temperatura', 182.0000, 'ºC'),
	(21932, 110, '2015-01-15 01:27:39.000000', 'temperatura', 743.0000, 'ºC'),
	(21933, 110, '2015-01-15 01:27:40.000000', 'temperatura', 772.0000, 'ºC'),
	(21934, 110, '2015-01-15 01:27:41.000000', 'temperatura', 430.0000, 'ºC'),
	(21935, 110, '2015-01-15 01:27:42.000000', 'temperatura', 1034.0000, 'ºC'),
	(21936, 110, '2015-01-15 01:27:43.000000', 'temperatura', 282.0000, 'ºC'),
	(21937, 110, '2015-01-15 01:27:44.000000', 'temperatura', 710.0000, 'ºC'),
	(21938, 110, '2015-01-15 01:27:45.000000', 'temperatura', 303.0000, 'ºC'),
	(21939, 110, '2015-01-15 01:27:46.000000', 'temperatura', 584.0000, 'ºC'),
	(21940, 110, '2015-01-15 01:27:47.000000', 'temperatura', 811.0000, 'ºC'),
	(21941, 110, '2015-01-15 01:27:48.000000', 'temperatura', 1106.0000, 'ºC'),
	(21942, 110, '2015-01-15 01:27:49.000000', 'temperatura', 698.0000, 'ºC'),
	(21943, 110, '2015-01-15 01:27:50.000000', 'temperatura', 173.0000, 'ºC'),
	(21944, 110, '2015-01-15 01:27:51.000000', 'temperatura', 1170.0000, 'ºC'),
	(21945, 110, '2015-01-15 01:27:52.000000', 'temperatura', 532.0000, 'ºC'),
	(21946, 110, '2015-01-15 01:27:53.000000', 'temperatura', 352.0000, 'ºC'),
	(21947, 110, '2015-01-15 01:27:54.000000', 'temperatura', 165.0000, 'ºC'),
	(21948, 110, '2015-01-15 01:27:55.000000', 'temperatura', 969.0000, 'ºC'),
	(21949, 110, '2015-01-15 01:27:56.000000', 'temperatura', 748.0000, 'ºC'),
	(21950, 110, '2015-01-15 01:27:57.000000', 'temperatura', 835.0000, 'ºC'),
	(21951, 110, '2015-01-15 01:27:58.000000', 'temperatura', 730.0000, 'ºC'),
	(21952, 110, '2015-01-15 01:27:59.000000', 'temperatura', 1147.0000, 'ºC'),
	(21953, 110, '2015-01-15 01:28:00.000000', 'temperatura', 1146.0000, 'ºC'),
	(21954, 110, '2015-01-15 01:28:01.000000', 'temperatura', 1090.0000, 'ºC'),
	(21955, 110, '2015-01-15 01:28:02.000000', 'temperatura', 812.0000, 'ºC'),
	(21956, 110, '2015-01-15 01:28:03.000000', 'temperatura', 790.0000, 'ºC'),
	(21957, 110, '2015-01-15 01:28:04.000000', 'temperatura', 315.0000, 'ºC'),
	(21958, 110, '2015-01-15 01:28:05.000000', 'temperatura', 407.0000, 'ºC'),
	(21959, 110, '2015-01-15 01:28:06.000000', 'temperatura', 1088.0000, 'ºC'),
	(21960, 110, '2015-01-15 01:28:07.000000', 'temperatura', 622.0000, 'ºC'),
	(21961, 110, '2015-01-15 01:28:08.000000', 'temperatura', 1045.0000, 'ºC'),
	(21962, 110, '2015-01-15 01:28:09.000000', 'temperatura', 959.0000, 'ºC'),
	(21963, 110, '2015-01-15 01:28:10.000000', 'temperatura', 461.0000, 'ºC'),
	(21964, 110, '2015-01-15 01:28:11.000000', 'temperatura', 629.0000, 'ºC'),
	(21965, 110, '2015-01-15 01:28:12.000000', 'temperatura', 560.0000, 'ºC'),
	(21966, 110, '2015-01-15 01:28:13.000000', 'temperatura', 916.0000, 'ºC'),
	(21967, 110, '2015-01-15 01:28:14.000000', 'temperatura', 502.0000, 'ºC'),
	(21968, 110, '2015-01-15 01:28:15.000000', 'temperatura', 959.0000, 'ºC'),
	(21969, 110, '2015-01-15 01:28:16.000000', 'temperatura', 891.0000, 'ºC'),
	(21970, 110, '2015-01-15 01:28:17.000000', 'temperatura', 379.0000, 'ºC'),
	(21971, 110, '2015-01-15 01:28:18.000000', 'temperatura', 424.0000, 'ºC'),
	(21972, 110, '2015-01-15 01:28:19.000000', 'temperatura', 982.0000, 'ºC'),
	(21973, 110, '2015-01-15 01:28:20.000000', 'temperatura', 38.0000, 'ºC'),
	(21974, 110, '2015-01-15 01:28:21.000000', 'temperatura', 845.0000, 'ºC'),
	(21975, 110, '2015-01-15 01:28:22.000000', 'temperatura', 512.0000, 'ºC'),
	(21976, 110, '2015-01-15 01:28:23.000000', 'temperatura', 25.0000, 'ºC'),
	(21977, 110, '2015-01-15 01:28:24.000000', 'temperatura', 988.0000, 'ºC'),
	(21978, 110, '2015-01-15 01:28:25.000000', 'temperatura', 65.0000, 'ºC'),
	(21979, 110, '2015-01-15 01:28:26.000000', 'temperatura', 961.0000, 'ºC'),
	(21980, 110, '2015-01-15 01:28:27.000000', 'temperatura', 1013.0000, 'ºC'),
	(21981, 110, '2015-01-15 01:28:28.000000', 'temperatura', 983.0000, 'ºC'),
	(21982, 110, '2015-01-15 01:28:29.000000', 'temperatura', 677.0000, 'ºC'),
	(21983, 110, '2015-01-15 01:28:30.000000', 'temperatura', 436.0000, 'ºC'),
	(21984, 110, '2015-01-15 01:28:31.000000', 'temperatura', 147.0000, 'ºC'),
	(21985, 110, '2015-01-15 01:28:32.000000', 'temperatura', 629.0000, 'ºC'),
	(21986, 110, '2015-01-15 01:28:33.000000', 'temperatura', 306.0000, 'ºC'),
	(21987, 110, '2015-01-15 01:28:34.000000', 'temperatura', 844.0000, 'ºC'),
	(21988, 110, '2015-01-15 01:28:35.000000', 'temperatura', 903.0000, 'ºC'),
	(21989, 110, '2015-01-15 01:28:36.000000', 'temperatura', 782.0000, 'ºC'),
	(21990, 110, '2015-01-15 01:28:37.000000', 'temperatura', 2.0000, 'ºC'),
	(21991, 110, '2015-01-15 01:28:38.000000', 'temperatura', 63.0000, 'ºC'),
	(21992, 110, '2015-01-15 01:28:39.000000', 'temperatura', 308.0000, 'ºC'),
	(21993, 110, '2015-01-15 01:28:40.000000', 'temperatura', 155.0000, 'ºC'),
	(21994, 110, '2015-01-15 01:28:41.000000', 'temperatura', 1049.0000, 'ºC'),
	(21995, 110, '2015-01-15 01:28:42.000000', 'temperatura', 1182.0000, 'ºC'),
	(21996, 110, '2015-01-15 01:28:43.000000', 'temperatura', 361.0000, 'ºC'),
	(21997, 110, '2015-01-15 01:28:44.000000', 'temperatura', 663.0000, 'ºC'),
	(21998, 110, '2015-01-15 01:28:45.000000', 'temperatura', 1030.0000, 'ºC'),
	(21999, 110, '2015-01-15 01:28:46.000000', 'temperatura', 762.0000, 'ºC'),
	(22000, 110, '2015-01-15 01:28:47.000000', 'temperatura', 720.0000, 'ºC'),
	(22001, 110, '2015-01-15 01:28:48.000000', 'temperatura', 113.0000, 'ºC'),
	(22002, 110, '2015-01-15 01:28:49.000000', 'temperatura', 808.0000, 'ºC'),
	(22003, 110, '2015-01-15 01:28:50.000000', 'temperatura', 102.0000, 'ºC'),
	(22004, 110, '2015-01-15 01:28:51.000000', 'temperatura', 484.0000, 'ºC'),
	(22005, 110, '2015-01-15 01:28:52.000000', 'temperatura', 917.0000, 'ºC'),
	(22006, 110, '2015-01-15 01:28:53.000000', 'temperatura', 733.0000, 'ºC'),
	(22007, 110, '2015-01-15 01:28:54.000000', 'temperatura', 916.0000, 'ºC'),
	(22008, 110, '2015-01-15 01:28:55.000000', 'temperatura', 1179.0000, 'ºC'),
	(22009, 110, '2015-01-15 01:28:56.000000', 'temperatura', 747.0000, 'ºC'),
	(22010, 110, '2015-01-15 01:28:57.000000', 'temperatura', 200.0000, 'ºC'),
	(22011, 110, '2015-01-15 01:28:58.000000', 'temperatura', 1157.0000, 'ºC'),
	(22012, 110, '2015-01-15 01:28:59.000000', 'temperatura', 388.0000, 'ºC'),
	(22013, 110, '2015-01-15 01:29:00.000000', 'temperatura', 869.0000, 'ºC'),
	(22014, 110, '2015-01-15 01:29:01.000000', 'temperatura', 781.0000, 'ºC'),
	(22015, 110, '2015-01-15 01:29:02.000000', 'temperatura', 99.0000, 'ºC'),
	(22016, 110, '2015-01-15 01:29:03.000000', 'temperatura', 553.0000, 'ºC'),
	(22017, 110, '2015-01-15 01:29:04.000000', 'temperatura', 70.0000, 'ºC'),
	(22018, 110, '2015-01-15 01:29:05.000000', 'temperatura', 1091.0000, 'ºC'),
	(22019, 110, '2015-01-15 01:29:06.000000', 'temperatura', 444.0000, 'ºC'),
	(22020, 110, '2015-01-15 01:29:07.000000', 'temperatura', 146.0000, 'ºC'),
	(22021, 110, '2015-01-15 01:29:08.000000', 'temperatura', 601.0000, 'ºC'),
	(22022, 110, '2015-01-15 01:29:09.000000', 'temperatura', 167.0000, 'ºC'),
	(22023, 110, '2015-01-15 01:29:10.000000', 'temperatura', 233.0000, 'ºC'),
	(22024, 110, '2015-01-15 01:29:11.000000', 'temperatura', 664.0000, 'ºC'),
	(22025, 110, '2015-01-15 01:29:12.000000', 'temperatura', 222.0000, 'ºC'),
	(22026, 110, '2015-01-15 01:29:13.000000', 'temperatura', 317.0000, 'ºC'),
	(22027, 110, '2015-01-15 01:29:14.000000', 'temperatura', 920.0000, 'ºC'),
	(22028, 110, '2015-01-15 01:29:15.000000', 'temperatura', 49.0000, 'ºC'),
	(22029, 110, '2015-01-15 01:29:16.000000', 'temperatura', 1086.0000, 'ºC'),
	(22030, 110, '2015-01-15 01:29:17.000000', 'temperatura', 484.0000, 'ºC'),
	(22031, 110, '2015-01-15 01:29:18.000000', 'temperatura', 360.0000, 'ºC'),
	(22032, 110, '2015-01-15 01:29:19.000000', 'temperatura', 350.0000, 'ºC'),
	(22033, 110, '2015-01-15 01:29:20.000000', 'temperatura', 672.0000, 'ºC'),
	(22034, 110, '2015-01-15 01:29:21.000000', 'temperatura', 1111.0000, 'ºC'),
	(22035, 110, '2015-01-15 01:29:22.000000', 'temperatura', 1138.0000, 'ºC'),
	(22036, 110, '2015-01-15 01:29:23.000000', 'temperatura', 1157.0000, 'ºC'),
	(22037, 110, '2015-01-15 01:29:24.000000', 'temperatura', 1170.0000, 'ºC'),
	(22038, 110, '2015-01-15 01:29:25.000000', 'temperatura', 1182.0000, 'ºC'),
	(22039, 110, '2015-01-15 01:29:26.000000', 'temperatura', 1198.0000, 'ºC'),
	(22040, 110, '2015-01-15 01:29:27.000000', 'temperatura', 47.0000, 'ºC'),
	(22041, 110, '2015-01-15 01:29:28.000000', 'temperatura', 240.0000, 'ºC'),
	(22042, 110, '2015-01-15 01:29:29.000000', 'temperatura', 1061.0000, 'ºC'),
	(22043, 110, '2015-01-15 01:29:30.000000', 'temperatura', 983.0000, 'ºC'),
	(22044, 110, '2015-01-15 01:29:31.000000', 'temperatura', 535.0000, 'ºC'),
	(22045, 110, '2015-01-15 01:29:32.000000', 'temperatura', 926.0000, 'ºC'),
	(22046, 110, '2015-01-15 01:29:33.000000', 'temperatura', 623.0000, 'ºC'),
	(22047, 110, '2015-01-15 01:29:34.000000', 'temperatura', 340.0000, 'ºC'),
	(22048, 110, '2015-01-15 01:29:35.000000', 'temperatura', 1030.0000, 'ºC'),
	(22049, 110, '2015-01-15 01:29:36.000000', 'temperatura', 530.0000, 'ºC'),
	(22050, 110, '2015-01-15 01:29:37.000000', 'temperatura', 760.0000, 'ºC'),
	(22051, 110, '2015-01-15 01:29:38.000000', 'temperatura', 1011.0000, 'ºC'),
	(22052, 110, '2015-01-15 01:29:39.000000', 'temperatura', 377.0000, 'ºC'),
	(22053, 110, '2015-01-15 01:29:40.000000', 'temperatura', 50.0000, 'ºC'),
	(22054, 110, '2015-01-15 01:29:41.000000', 'temperatura', 320.0000, 'ºC'),
	(22055, 110, '2015-01-15 01:29:42.000000', 'temperatura', 252.0000, 'ºC'),
	(22056, 110, '2015-01-15 01:29:43.000000', 'temperatura', 300.0000, 'ºC'),
	(22057, 110, '2015-01-15 01:29:44.000000', 'temperatura', 746.0000, 'ºC'),
	(22058, 110, '2015-01-15 01:29:45.000000', 'temperatura', 427.0000, 'ºC'),
	(22059, 110, '2015-01-15 01:29:46.000000', 'temperatura', 1101.0000, 'ºC'),
	(22060, 110, '2015-01-15 01:29:47.000000', 'temperatura', 624.0000, 'ºC'),
	(22061, 110, '2015-01-15 01:29:48.000000', 'temperatura', 1017.0000, 'ºC'),
	(22062, 110, '2015-01-15 01:29:49.000000', 'temperatura', 815.0000, 'ºC'),
	(22063, 110, '2015-01-15 01:29:50.000000', 'temperatura', 1021.0000, 'ºC'),
	(22064, 110, '2015-01-15 01:29:51.000000', 'temperatura', 264.0000, 'ºC'),
	(22065, 110, '2015-01-15 01:29:52.000000', 'temperatura', 654.0000, 'ºC'),
	(22066, 110, '2015-01-15 01:29:53.000000', 'temperatura', 81.0000, 'ºC'),
	(22067, 110, '2015-01-15 01:29:54.000000', 'temperatura', 842.0000, 'ºC'),
	(22068, 110, '2015-01-15 01:29:55.000000', 'temperatura', 369.0000, 'ºC'),
	(22069, 110, '2015-01-15 01:29:56.000000', 'temperatura', 518.0000, 'ºC'),
	(22070, 110, '2015-01-15 01:29:57.000000', 'temperatura', 285.0000, 'ºC'),
	(22071, 110, '2015-01-15 01:29:58.000000', 'temperatura', 1070.0000, 'ºC'),
	(22072, 110, '2015-01-15 01:29:59.000000', 'temperatura', 896.0000, 'ºC'),
	(22073, 110, '2015-01-15 01:30:00.000000', 'temperatura', 69.0000, 'ºC'),
	(22074, 110, '2015-01-15 01:30:01.000000', 'temperatura', 60.0000, 'ºC'),
	(22075, 110, '2015-01-15 01:30:02.000000', 'temperatura', 94.0000, 'ºC'),
	(22076, 110, '2015-01-15 01:30:03.000000', 'temperatura', 287.0000, 'ºC'),
	(22077, 110, '2015-01-15 01:30:04.000000', 'temperatura', 1157.0000, 'ºC'),
	(22078, 110, '2015-01-15 01:30:05.000000', 'temperatura', 122.0000, 'ºC'),
	(22079, 110, '2015-01-15 01:30:06.000000', 'temperatura', 741.0000, 'ºC'),
	(22080, 110, '2015-01-15 01:30:07.000000', 'temperatura', 938.0000, 'ºC'),
	(22081, 110, '2015-01-15 01:30:08.000000', 'temperatura', 69.0000, 'ºC'),
	(22082, 110, '2015-01-15 01:30:09.000000', 'temperatura', 1131.0000, 'ºC'),
	(22083, 110, '2015-01-15 01:30:10.000000', 'temperatura', 649.0000, 'ºC'),
	(22084, 110, '2015-01-15 01:30:11.000000', 'temperatura', 1053.0000, 'ºC'),
	(22085, 110, '2015-01-15 01:30:12.000000', 'temperatura', 916.0000, 'ºC'),
	(22086, 110, '2015-01-15 01:30:13.000000', 'temperatura', 222.0000, 'ºC'),
	(22087, 110, '2015-01-15 01:30:14.000000', 'temperatura', 764.0000, 'ºC'),
	(22088, 110, '2015-01-15 01:30:15.000000', 'temperatura', 754.0000, 'ºC'),
	(22089, 110, '2015-01-15 01:30:16.000000', 'temperatura', 278.0000, 'ºC'),
	(22090, 110, '2015-01-15 01:30:17.000000', 'temperatura', 329.0000, 'ºC'),
	(22091, 110, '2015-01-15 01:30:18.000000', 'temperatura', 812.0000, 'ºC'),
	(22092, 110, '2015-01-15 01:30:19.000000', 'temperatura', 671.0000, 'ºC'),
	(22093, 110, '2015-01-15 01:30:20.000000', 'temperatura', 923.0000, 'ºC'),
	(22094, 110, '2015-01-15 01:30:21.000000', 'temperatura', 200.0000, 'ºC'),
	(22095, 110, '2015-01-15 01:30:22.000000', 'temperatura', 631.0000, 'ºC'),
	(22096, 110, '2015-01-15 01:30:23.000000', 'temperatura', 158.0000, 'ºC'),
	(22097, 110, '2015-01-15 01:30:24.000000', 'temperatura', 95.0000, 'ºC'),
	(22098, 110, '2015-01-15 01:30:25.000000', 'temperatura', 2.0000, 'ºC'),
	(22099, 110, '2015-01-15 01:30:26.000000', 'temperatura', 924.0000, 'ºC'),
	(22100, 110, '2015-01-15 01:30:27.000000', 'temperatura', 1017.0000, 'ºC'),
	(22101, 110, '2015-01-15 01:30:28.000000', 'temperatura', 1112.0000, 'ºC'),
	(22102, 110, '2015-01-15 01:30:29.000000', 'temperatura', 111.0000, 'ºC'),
	(22103, 110, '2015-01-15 01:30:30.000000', 'temperatura', 820.0000, 'ºC'),
	(22104, 110, '2015-01-15 01:30:31.000000', 'temperatura', 166.0000, 'ºC'),
	(22105, 110, '2015-01-15 01:30:32.000000', 'temperatura', 771.0000, 'ºC'),
	(22106, 110, '2015-01-15 01:30:33.000000', 'temperatura', 957.0000, 'ºC'),
	(22107, 110, '2015-01-15 01:30:34.000000', 'temperatura', 71.0000, 'ºC'),
	(22108, 110, '2015-01-15 01:30:35.000000', 'temperatura', 1087.0000, 'ºC'),
	(22109, 110, '2015-01-15 01:30:36.000000', 'temperatura', 420.0000, 'ºC'),
	(22110, 110, '2015-01-15 01:30:37.000000', 'temperatura', 42.0000, 'ºC'),
	(22111, 110, '2015-01-15 01:30:38.000000', 'temperatura', 148.0000, 'ºC'),
	(22112, 110, '2015-01-15 01:30:39.000000', 'temperatura', 615.0000, 'ºC'),
	(22113, 110, '2015-01-15 01:30:40.000000', 'temperatura', 234.0000, 'ºC'),
	(22114, 110, '2015-01-15 01:30:41.000000', 'temperatura', 522.0000, 'ºC'),
	(22115, 110, '2015-01-15 01:30:42.000000', 'temperatura', 710.0000, 'ºC'),
	(22116, 110, '2015-01-15 01:30:43.000000', 'temperatura', 785.0000, 'ºC'),
	(22117, 110, '2015-01-15 01:30:44.000000', 'temperatura', 595.0000, 'ºC'),
	(22118, 110, '2015-01-15 01:30:45.000000', 'temperatura', 623.0000, 'ºC'),
	(22119, 110, '2015-01-15 01:30:46.000000', 'temperatura', 127.0000, 'ºC'),
	(22120, 110, '2015-01-15 01:30:47.000000', 'temperatura', 1168.0000, 'ºC'),
	(22121, 110, '2015-01-15 01:30:48.000000', 'temperatura', 659.0000, 'ºC'),
	(22122, 110, '2015-01-15 01:30:49.000000', 'temperatura', 991.0000, 'ºC'),
	(22123, 110, '2015-01-15 01:30:50.000000', 'temperatura', 580.0000, 'ºC'),
	(22124, 110, '2015-01-15 01:30:51.000000', 'temperatura', 1128.0000, 'ºC'),
	(22125, 110, '2015-01-15 01:30:52.000000', 'temperatura', 298.0000, 'ºC'),
	(22126, 110, '2015-01-15 01:30:53.000000', 'temperatura', 508.0000, 'ºC'),
	(22127, 110, '2015-01-15 01:30:54.000000', 'temperatura', 448.0000, 'ºC'),
	(22128, 110, '2015-01-15 01:30:55.000000', 'temperatura', 715.0000, 'ºC'),
	(22129, 110, '2015-01-15 01:30:56.000000', 'temperatura', 1034.0000, 'ºC'),
	(22130, 110, '2015-01-15 01:30:57.000000', 'temperatura', 622.0000, 'ºC'),
	(22131, 110, '2015-01-15 01:30:58.000000', 'temperatura', 11.0000, 'ºC'),
	(22132, 110, '2015-01-15 01:30:59.000000', 'temperatura', 587.0000, 'ºC'),
	(22133, 110, '2015-01-15 01:31:00.000000', 'temperatura', 502.0000, 'ºC'),
	(22134, 110, '2015-01-15 01:31:01.000000', 'temperatura', 752.0000, 'ºC'),
	(22135, 110, '2015-01-15 01:31:02.000000', 'temperatura', 1056.0000, 'ºC'),
	(22136, 110, '2015-01-15 01:31:03.000000', 'temperatura', 621.0000, 'ºC'),
	(22137, 110, '2015-01-15 01:31:04.000000', 'temperatura', 1141.0000, 'ºC'),
	(22138, 110, '2015-01-15 01:31:05.000000', 'temperatura', 240.0000, 'ºC'),
	(22139, 110, '2015-01-15 01:31:06.000000', 'temperatura', 179.0000, 'ºC'),
	(22140, 110, '2015-01-15 01:31:07.000000', 'temperatura', 177.0000, 'ºC'),
	(22141, 110, '2015-01-15 01:31:08.000000', 'temperatura', 347.0000, 'ºC'),
	(22142, 110, '2015-01-15 01:31:09.000000', 'temperatura', 3.0000, 'ºC'),
	(22143, 110, '2015-01-15 01:31:10.000000', 'temperatura', 177.0000, 'ºC'),
	(22144, 110, '2015-01-15 01:31:11.000000', 'temperatura', 874.0000, 'ºC'),
	(22145, 110, '2015-01-15 01:31:12.000000', 'temperatura', 243.0000, 'ºC'),
	(22146, 110, '2015-01-15 01:31:13.000000', 'temperatura', 990.0000, 'ºC'),
	(22147, 110, '2015-01-15 01:31:14.000000', 'temperatura', 623.0000, 'ºC'),
	(22148, 110, '2015-01-15 01:31:15.000000', 'temperatura', 145.0000, 'ºC'),
	(22149, 110, '2015-01-15 01:31:16.000000', 'temperatura', 57.0000, 'ºC'),
	(22150, 110, '2015-01-15 01:31:17.000000', 'temperatura', 1049.0000, 'ºC'),
	(22151, 110, '2015-01-15 01:31:18.000000', 'temperatura', 275.0000, 'ºC'),
	(22152, 110, '2015-01-15 01:31:19.000000', 'temperatura', 628.0000, 'ºC'),
	(22153, 110, '2015-01-15 01:31:20.000000', 'temperatura', 1118.0000, 'ºC'),
	(22154, 110, '2015-01-15 01:31:21.000000', 'temperatura', 103.0000, 'ºC'),
	(22155, 110, '2015-01-15 01:31:22.000000', 'temperatura', 764.0000, 'ºC'),
	(22156, 110, '2015-01-15 01:31:23.000000', 'temperatura', 1112.0000, 'ºC'),
	(22157, 110, '2015-01-15 01:31:24.000000', 'temperatura', 867.0000, 'ºC'),
	(22158, 110, '2015-01-15 01:31:25.000000', 'temperatura', 1001.0000, 'ºC'),
	(22159, 110, '2015-01-15 01:31:26.000000', 'temperatura', 4.0000, 'ºC'),
	(22160, 110, '2015-01-15 01:31:27.000000', 'temperatura', 616.0000, 'ºC'),
	(22161, 110, '2015-01-15 01:31:28.000000', 'temperatura', 671.0000, 'ºC'),
	(22162, 110, '2015-01-15 01:31:29.000000', 'temperatura', 306.0000, 'ºC'),
	(22163, 110, '2015-01-15 01:31:30.000000', 'temperatura', 717.0000, 'ºC'),
	(22164, 110, '2015-01-15 01:31:31.000000', 'temperatura', 269.0000, 'ºC'),
	(22165, 110, '2015-01-15 01:31:32.000000', 'temperatura', 394.0000, 'ºC'),
	(22166, 110, '2015-01-15 01:31:33.000000', 'temperatura', 1163.0000, 'ºC'),
	(22167, 110, '2015-01-15 01:31:34.000000', 'temperatura', 1034.0000, 'ºC'),
	(22168, 110, '2015-01-15 01:31:35.000000', 'temperatura', 479.0000, 'ºC'),
	(22169, 110, '2015-01-15 01:31:36.000000', 'temperatura', 497.0000, 'ºC'),
	(22170, 110, '2015-01-15 01:31:37.000000', 'temperatura', 1046.0000, 'ºC'),
	(22171, 110, '2015-01-15 01:31:38.000000', 'temperatura', 142.0000, 'ºC'),
	(22172, 110, '2015-01-15 01:31:39.000000', 'temperatura', 1171.0000, 'ºC'),
	(22173, 110, '2015-01-15 01:31:40.000000', 'temperatura', 629.0000, 'ºC'),
	(22174, 110, '2015-01-15 01:31:41.000000', 'temperatura', 833.0000, 'ºC'),
	(22175, 110, '2015-01-15 01:31:42.000000', 'temperatura', 1078.0000, 'ºC'),
	(22176, 110, '2015-01-15 01:31:43.000000', 'temperatura', 491.0000, 'ºC'),
	(22177, 110, '2015-01-15 01:31:44.000000', 'temperatura', 420.0000, 'ºC'),
	(22178, 110, '2015-01-15 01:31:45.000000', 'temperatura', 630.0000, 'ºC'),
	(22179, 110, '2015-01-15 01:31:46.000000', 'temperatura', 692.0000, 'ºC'),
	(22180, 110, '2015-01-15 01:31:47.000000', 'temperatura', 367.0000, 'ºC'),
	(22181, 110, '2015-01-15 01:31:48.000000', 'temperatura', 960.0000, 'ºC'),
	(22182, 110, '2015-01-15 01:31:49.000000', 'temperatura', 100.0000, 'ºC'),
	(22183, 110, '2015-01-15 01:31:50.000000', 'temperatura', 22.0000, 'ºC'),
	(22184, 110, '2015-01-15 01:31:51.000000', 'temperatura', 1011.0000, 'ºC'),
	(22185, 110, '2015-01-15 01:31:52.000000', 'temperatura', 188.0000, 'ºC'),
	(22186, 110, '2015-01-15 01:31:53.000000', 'temperatura', 306.0000, 'ºC'),
	(22187, 110, '2015-01-15 01:31:54.000000', 'temperatura', 969.0000, 'ºC'),
	(22188, 110, '2015-01-15 01:31:55.000000', 'temperatura', 327.0000, 'ºC'),
	(22189, 110, '2015-01-15 01:31:56.000000', 'temperatura', 1129.0000, 'ºC'),
	(22190, 110, '2015-01-15 01:31:57.000000', 'temperatura', 1063.0000, 'ºC'),
	(22191, 110, '2015-01-15 01:31:58.000000', 'temperatura', 728.0000, 'ºC'),
	(22192, 110, '2015-01-15 01:31:59.000000', 'temperatura', 452.0000, 'ºC'),
	(22193, 110, '2015-01-15 01:32:00.000000', 'temperatura', 78.0000, 'ºC'),
	(22194, 110, '2015-01-15 01:32:01.000000', 'temperatura', 235.0000, 'ºC'),
	(22195, 110, '2015-01-15 01:32:02.000000', 'temperatura', 940.0000, 'ºC'),
	(22196, 110, '2015-01-15 01:32:03.000000', 'temperatura', 397.0000, 'ºC'),
	(22197, 110, '2015-01-15 01:32:04.000000', 'temperatura', 363.0000, 'ºC'),
	(22198, 110, '2015-01-15 01:32:05.000000', 'temperatura', 627.0000, 'ºC'),
	(22199, 110, '2015-01-15 01:32:06.000000', 'temperatura', 847.0000, 'ºC'),
	(22200, 110, '2015-01-15 01:32:07.000000', 'temperatura', 1152.0000, 'ºC'),
	(22201, 110, '2015-01-15 01:32:08.000000', 'temperatura', 819.0000, 'ºC'),
	(22202, 110, '2015-01-15 01:32:09.000000', 'temperatura', 642.0000, 'ºC'),
	(22203, 110, '2015-01-15 01:32:10.000000', 'temperatura', 752.0000, 'ºC'),
	(22204, 110, '2015-01-15 01:32:11.000000', 'temperatura', 634.0000, 'ºC'),
	(22205, 110, '2015-01-15 01:32:12.000000', 'temperatura', 917.0000, 'ºC'),
	(22206, 110, '2015-01-15 01:32:13.000000', 'temperatura', 282.0000, 'ºC'),
	(22207, 110, '2015-01-15 01:32:14.000000', 'temperatura', 1062.0000, 'ºC'),
	(22208, 110, '2015-01-15 01:32:15.000000', 'temperatura', 862.0000, 'ºC'),
	(22209, 110, '2015-01-15 01:32:16.000000', 'temperatura', 1123.0000, 'ºC'),
	(22210, 110, '2015-01-15 01:32:17.000000', 'temperatura', 633.0000, 'ºC'),
	(22211, 110, '2015-01-15 01:32:18.000000', 'temperatura', 995.0000, 'ºC'),
	(22212, 110, '2015-01-15 01:32:19.000000', 'temperatura', 677.0000, 'ºC'),
	(22213, 110, '2015-01-15 01:32:20.000000', 'temperatura', 399.0000, 'ºC'),
	(22214, 110, '2015-01-15 01:32:21.000000', 'temperatura', 1164.0000, 'ºC'),
	(22215, 110, '2015-01-15 01:32:22.000000', 'temperatura', 1024.0000, 'ºC'),
	(22216, 110, '2015-01-15 01:32:23.000000', 'temperatura', 431.0000, 'ºC'),
	(22217, 110, '2015-01-15 01:32:24.000000', 'temperatura', 281.0000, 'ºC'),
	(22218, 110, '2015-01-15 01:32:25.000000', 'temperatura', 113.0000, 'ºC'),
	(22219, 110, '2015-01-15 01:32:26.000000', 'temperatura', 924.0000, 'ºC'),
	(22220, 110, '2015-01-15 01:32:27.000000', 'temperatura', 679.0000, 'ºC'),
	(22221, 110, '2015-01-15 01:32:28.000000', 'temperatura', 624.0000, 'ºC'),
	(22222, 110, '2015-01-15 01:32:29.000000', 'temperatura', 1083.0000, 'ºC'),
	(22223, 110, '2015-01-15 01:32:30.000000', 'temperatura', 1143.0000, 'ºC'),
	(22224, 110, '2015-01-15 01:32:31.000000', 'temperatura', 67.0000, 'ºC'),
	(22225, 110, '2015-01-15 01:32:32.000000', 'temperatura', 508.0000, 'ºC'),
	(22226, 110, '2015-01-15 01:32:33.000000', 'temperatura', 1137.0000, 'ºC'),
	(22227, 110, '2015-01-15 01:32:34.000000', 'temperatura', 562.0000, 'ºC'),
	(22228, 110, '2015-01-15 01:32:35.000000', 'temperatura', 599.0000, 'ºC'),
	(22229, 110, '2015-01-15 01:32:36.000000', 'temperatura', 108.0000, 'ºC'),
	(22230, 110, '2015-01-15 01:32:37.000000', 'temperatura', 1146.0000, 'ºC'),
	(22231, 110, '2015-01-15 01:32:38.000000', 'temperatura', 605.0000, 'ºC'),
	(22232, 110, '2015-01-15 01:32:39.000000', 'temperatura', 787.0000, 'ºC'),
	(22233, 110, '2015-01-15 01:32:40.000000', 'temperatura', 923.0000, 'ºC'),
	(22234, 110, '2015-01-15 01:32:41.000000', 'temperatura', 1052.0000, 'ºC'),
	(22235, 110, '2015-01-15 01:32:42.000000', 'temperatura', 92.0000, 'ºC'),
	(22236, 110, '2015-01-15 01:32:43.000000', 'temperatura', 905.0000, 'ºC'),
	(22237, 110, '2015-01-15 01:32:44.000000', 'temperatura', 651.0000, 'ºC'),
	(22238, 110, '2015-01-15 01:32:45.000000', 'temperatura', 541.0000, 'ºC'),
	(22239, 110, '2015-01-15 01:32:46.000000', 'temperatura', 752.0000, 'ºC'),
	(22240, 110, '2015-01-15 01:32:47.000000', 'temperatura', 936.0000, 'ºC'),
	(22241, 110, '2015-01-15 01:32:48.000000', 'temperatura', 27.0000, 'ºC'),
	(22242, 111, '2015-01-15 00:00:00.000000', 'temperatura', 946.0000, 'ºC'),
	(22243, 111, '2015-01-15 00:00:01.000000', 'temperatura', 756.0000, 'ºC'),
	(22244, 111, '2015-01-15 00:00:02.000000', 'temperatura', 943.0000, 'ºC'),
	(22245, 111, '2015-01-15 00:00:03.000000', 'temperatura', 46.0000, 'ºC'),
	(22246, 111, '2015-01-15 00:00:04.000000', 'temperatura', 1003.0000, 'ºC'),
	(22247, 111, '2015-01-15 00:00:05.000000', 'temperatura', 77.0000, 'ºC'),
	(22248, 111, '2015-01-15 00:00:06.000000', 'temperatura', 976.0000, 'ºC'),
	(22249, 111, '2015-01-15 00:00:07.000000', 'temperatura', 1051.0000, 'ºC'),
	(22250, 111, '2015-01-15 00:00:08.000000', 'temperatura', 1126.0000, 'ºC'),
	(22251, 111, '2015-01-15 00:00:09.000000', 'temperatura', 78.0000, 'ºC'),
	(22252, 111, '2015-01-15 00:00:10.000000', 'temperatura', 614.0000, 'ºC'),
	(22253, 111, '2015-01-15 00:00:11.000000', 'temperatura', 437.0000, 'ºC'),
	(22254, 111, '2015-01-15 00:00:12.000000', 'temperatura', 342.0000, 'ºC'),
	(22255, 111, '2015-01-15 00:00:13.000000', 'temperatura', 398.0000, 'ºC'),
	(22256, 111, '2015-01-15 00:00:14.000000', 'temperatura', 965.0000, 'ºC'),
	(22257, 111, '2015-01-15 00:00:15.000000', 'temperatura', 32.0000, 'ºC'),
	(22258, 111, '2015-01-15 00:00:16.000000', 'temperatura', 867.0000, 'ºC'),
	(22259, 111, '2015-01-15 00:00:17.000000', 'temperatura', 639.0000, 'ºC'),
	(22260, 111, '2015-01-15 00:00:18.000000', 'temperatura', 592.0000, 'ºC'),
	(22261, 111, '2015-01-15 00:00:19.000000', 'temperatura', 1046.0000, 'ºC'),
	(22262, 111, '2015-01-15 00:00:20.000000', 'temperatura', 1052.0000, 'ºC'),
	(22263, 111, '2015-01-15 00:00:21.000000', 'temperatura', 926.0000, 'ºC'),
	(22264, 111, '2015-01-15 00:00:22.000000', 'temperatura', 271.0000, 'ºC'),
	(22265, 111, '2015-01-15 00:00:23.000000', 'temperatura', 979.0000, 'ºC'),
	(22266, 111, '2015-01-15 00:00:24.000000', 'temperatura', 484.0000, 'ºC'),
	(22267, 111, '2015-01-15 00:00:25.000000', 'temperatura', 681.0000, 'ºC'),
	(22268, 111, '2015-01-15 00:00:26.000000', 'temperatura', 753.0000, 'ºC'),
	(22269, 111, '2015-01-15 00:00:27.000000', 'temperatura', 523.0000, 'ºC'),
	(22270, 111, '2015-01-15 00:00:28.000000', 'temperatura', 356.0000, 'ºC'),
	(22271, 111, '2015-01-15 00:00:29.000000', 'temperatura', 210.0000, 'ºC'),
	(22272, 111, '2015-01-15 00:00:30.000000', 'temperatura', 1185.0000, 'ºC'),
	(22273, 111, '2015-01-15 00:00:31.000000', 'temperatura', 494.0000, 'ºC'),
	(22274, 111, '2015-01-15 00:00:32.000000', 'temperatura', 117.0000, 'ºC'),
	(22275, 111, '2015-01-15 00:00:33.000000', 'temperatura', 302.0000, 'ºC'),
	(22276, 111, '2015-01-15 00:00:34.000000', 'temperatura', 1161.0000, 'ºC'),
	(22277, 111, '2015-01-15 00:00:35.000000', 'temperatura', 100.0000, 'ºC'),
	(22278, 111, '2015-01-15 00:00:36.000000', 'temperatura', 616.0000, 'ºC'),
	(22279, 111, '2015-01-15 00:00:37.000000', 'temperatura', 380.0000, 'ºC'),
	(22280, 111, '2015-01-15 00:00:38.000000', 'temperatura', 54.0000, 'ºC'),
	(22281, 111, '2015-01-15 00:00:39.000000', 'temperatura', 331.0000, 'ºC'),
	(22282, 111, '2015-01-15 00:00:40.000000', 'temperatura', 295.0000, 'ºC'),
	(22283, 111, '2015-01-15 00:00:41.000000', 'temperatura', 480.0000, 'ºC'),
	(22284, 111, '2015-01-15 00:00:42.000000', 'temperatura', 315.0000, 'ºC'),
	(22285, 111, '2015-01-15 00:00:43.000000', 'temperatura', 136.0000, 'ºC'),
	(22286, 111, '2015-01-15 00:00:44.000000', 'temperatura', 934.0000, 'ºC'),
	(22287, 111, '2015-01-15 00:00:45.000000', 'temperatura', 662.0000, 'ºC'),
	(22288, 111, '2015-01-15 00:00:46.000000', 'temperatura', 510.0000, 'ºC'),
	(22289, 111, '2015-01-15 00:00:47.000000', 'temperatura', 565.0000, 'ºC'),
	(22290, 111, '2015-01-15 00:00:48.000000', 'temperatura', 94.0000, 'ºC'),
	(22291, 111, '2015-01-15 00:00:49.000000', 'temperatura', 1175.0000, 'ºC'),
	(22292, 111, '2015-01-15 00:00:50.000000', 'temperatura', 794.0000, 'ºC'),
	(22293, 111, '2015-01-15 00:00:51.000000', 'temperatura', 447.0000, 'ºC'),
	(22294, 111, '2015-01-15 00:00:52.000000', 'temperatura', 1052.0000, 'ºC'),
	(22295, 111, '2015-01-15 00:00:53.000000', 'temperatura', 321.0000, 'ºC'),
	(22296, 111, '2015-01-15 00:00:54.000000', 'temperatura', 849.0000, 'ºC'),
	(22297, 111, '2015-01-15 00:00:55.000000', 'temperatura', 882.0000, 'ºC'),
	(22298, 111, '2015-01-15 00:00:56.000000', 'temperatura', 664.0000, 'ºC'),
	(22299, 111, '2015-01-15 00:00:57.000000', 'temperatura', 675.0000, 'ºC'),
	(22300, 111, '2015-01-15 00:00:58.000000', 'temperatura', 182.0000, 'ºC'),
	(22301, 111, '2015-01-15 00:00:59.000000', 'temperatura', 84.0000, 'ºC'),
	(22302, 111, '2015-01-15 00:01:00.000000', 'temperatura', 1077.0000, 'ºC'),
	(22303, 111, '2015-01-15 00:01:01.000000', 'temperatura', 333.0000, 'ºC'),
	(22304, 111, '2015-01-15 00:01:02.000000', 'temperatura', 836.0000, 'ºC'),
	(22305, 111, '2015-01-15 00:01:03.000000', 'temperatura', 779.0000, 'ºC'),
	(22306, 111, '2015-01-15 00:01:04.000000', 'temperatura', 188.0000, 'ºC'),
	(22307, 111, '2015-01-15 00:01:05.000000', 'temperatura', 1002.0000, 'ºC'),
	(22308, 111, '2015-01-15 00:01:06.000000', 'temperatura', 847.0000, 'ºC'),
	(22309, 111, '2015-01-15 00:01:07.000000', 'temperatura', 30.0000, 'ºC'),
	(22310, 111, '2015-01-15 00:01:08.000000', 'temperatura', 10.0000, 'ºC'),
	(22311, 111, '2015-01-15 00:01:09.000000', 'temperatura', 1159.0000, 'ºC'),
	(22312, 111, '2015-01-15 00:01:10.000000', 'temperatura', 966.0000, 'ºC'),
	(22313, 111, '2015-01-15 00:01:11.000000', 'temperatura', 153.0000, 'ºC'),
	(22314, 111, '2015-01-15 00:01:12.000000', 'temperatura', 269.0000, 'ºC'),
	(22315, 111, '2015-01-15 00:01:13.000000', 'temperatura', 886.0000, 'ºC'),
	(22316, 111, '2015-01-15 00:01:14.000000', 'temperatura', 25.0000, 'ºC'),
	(22317, 111, '2015-01-15 00:01:15.000000', 'temperatura', 1064.0000, 'ºC'),
	(22318, 111, '2015-01-15 00:01:16.000000', 'temperatura', 448.0000, 'ºC'),
	(22319, 111, '2015-01-15 00:01:17.000000', 'temperatura', 249.0000, 'ºC'),
	(22320, 111, '2015-01-15 00:01:18.000000', 'temperatura', 1101.0000, 'ºC'),
	(22321, 111, '2015-01-15 00:01:19.000000', 'temperatura', 1159.0000, 'ºC'),
	(22322, 111, '2015-01-15 00:01:20.000000', 'temperatura', 90.0000, 'ºC'),
	(22323, 111, '2015-01-15 00:01:21.000000', 'temperatura', 575.0000, 'ºC'),
	(22324, 111, '2015-01-15 00:01:22.000000', 'temperatura', 204.0000, 'ºC'),
	(22325, 111, '2015-01-15 00:01:23.000000', 'temperatura', 499.0000, 'ºC'),
	(22326, 111, '2015-01-15 00:01:24.000000', 'temperatura', 680.0000, 'ºC'),
	(22327, 111, '2015-01-15 00:01:25.000000', 'temperatura', 705.0000, 'ºC'),
	(22328, 111, '2015-01-15 00:01:26.000000', 'temperatura', 285.0000, 'ºC'),
	(22329, 111, '2015-01-15 00:01:27.000000', 'temperatura', 510.0000, 'ºC'),
	(22330, 111, '2015-01-15 00:01:28.000000', 'temperatura', 496.0000, 'ºC'),
	(22331, 111, '2015-01-15 00:01:29.000000', 'temperatura', 951.0000, 'ºC'),
	(22332, 111, '2015-01-15 00:01:30.000000', 'temperatura', 866.0000, 'ºC'),
	(22333, 111, '2015-01-15 00:01:31.000000', 'temperatura', 277.0000, 'ºC'),
	(22334, 111, '2015-01-15 00:01:32.000000', 'temperatura', 1186.0000, 'ºC'),
	(22335, 111, '2015-01-15 00:01:33.000000', 'temperatura', 303.0000, 'ºC'),
	(22336, 111, '2015-01-15 00:01:34.000000', 'temperatura', 356.0000, 'ºC'),
	(22337, 111, '2015-01-15 00:01:35.000000', 'temperatura', 874.0000, 'ºC'),
	(22338, 111, '2015-01-15 00:01:36.000000', 'temperatura', 900.0000, 'ºC'),
	(22339, 111, '2015-01-15 00:01:37.000000', 'temperatura', 678.0000, 'ºC'),
	(22340, 111, '2015-01-15 00:01:38.000000', 'temperatura', 689.0000, 'ºC'),
	(22341, 111, '2015-01-15 00:01:39.000000', 'temperatura', 215.0000, 'ºC'),
	(22342, 111, '2015-01-15 00:01:40.000000', 'temperatura', 208.0000, 'ºC'),
	(22343, 111, '2015-01-15 00:01:41.000000', 'temperatura', 394.0000, 'ºC'),
	(22344, 111, '2015-01-15 00:01:42.000000', 'temperatura', 147.0000, 'ºC'),
	(22345, 111, '2015-01-15 00:01:43.000000', 'temperatura', 755.0000, 'ºC'),
	(22346, 111, '2015-01-15 00:01:44.000000', 'temperatura', 934.0000, 'ºC'),
	(22347, 111, '2015-01-15 00:01:45.000000', 'temperatura', 7.0000, 'ºC'),
	(22348, 111, '2015-01-15 00:01:46.000000', 'temperatura', 833.0000, 'ºC'),
	(22349, 111, '2015-01-15 00:01:47.000000', 'temperatura', 543.0000, 'ºC'),
	(22350, 111, '2015-01-15 00:01:48.000000', 'temperatura', 215.0000, 'ºC'),
	(22351, 111, '2015-01-15 00:01:49.000000', 'temperatura', 649.0000, 'ºC'),
	(22352, 111, '2015-01-15 00:01:50.000000', 'temperatura', 200.0000, 'ºC'),
	(22353, 111, '2015-01-15 00:01:51.000000', 'temperatura', 253.0000, 'ºC'),
	(22354, 111, '2015-01-15 00:01:52.000000', 'temperatura', 666.0000, 'ºC'),
	(22355, 111, '2015-01-15 00:01:53.000000', 'temperatura', 173.0000, 'ºC'),
	(22356, 111, '2015-01-15 00:01:54.000000', 'temperatura', 67.0000, 'ºC'),
	(22357, 111, '2015-01-15 00:01:55.000000', 'temperatura', 1017.0000, 'ºC'),
	(22358, 111, '2015-01-15 00:01:56.000000', 'temperatura', 85.0000, 'ºC'),
	(22359, 111, '2015-01-15 00:01:57.000000', 'temperatura', 973.0000, 'ºC'),
	(22360, 111, '2015-01-15 00:01:58.000000', 'temperatura', 1009.0000, 'ºC'),
	(22361, 111, '2015-01-15 00:01:59.000000', 'temperatura', 929.0000, 'ºC'),
	(22362, 111, '2015-01-15 00:02:00.000000', 'temperatura', 417.0000, 'ºC'),
	(22363, 111, '2015-01-15 00:02:01.000000', 'temperatura', 498.0000, 'ºC'),
	(22364, 111, '2015-01-15 00:02:02.000000', 'temperatura', 39.0000, 'ºC'),
	(22365, 111, '2015-01-15 00:02:03.000000', 'temperatura', 1102.0000, 'ºC'),
	(22366, 111, '2015-01-15 00:02:04.000000', 'temperatura', 595.0000, 'ºC'),
	(22367, 111, '2015-01-15 00:02:05.000000', 'temperatura', 868.0000, 'ºC'),
	(22368, 111, '2015-01-15 00:02:06.000000', 'temperatura', 156.0000, 'ºC'),
	(22369, 111, '2015-01-15 00:02:07.000000', 'temperatura', 576.0000, 'ºC'),
	(22370, 111, '2015-01-15 00:02:08.000000', 'temperatura', 11.0000, 'ºC'),
	(22371, 111, '2015-01-15 00:02:09.000000', 'temperatura', 730.0000, 'ºC'),
	(22372, 111, '2015-01-15 00:02:10.000000', 'temperatura', 18.0000, 'ºC'),
	(22373, 111, '2015-01-15 00:02:11.000000', 'temperatura', 298.0000, 'ºC'),
	(22374, 111, '2015-01-15 00:02:12.000000', 'temperatura', 237.0000, 'ºC'),
	(22375, 111, '2015-01-15 00:02:13.000000', 'temperatura', 294.0000, 'ºC'),
	(22376, 111, '2015-01-15 00:02:14.000000', 'temperatura', 758.0000, 'ºC'),
	(22377, 111, '2015-01-15 00:02:15.000000', 'temperatura', 510.0000, 'ºC'),
	(22378, 111, '2015-01-15 00:02:16.000000', 'temperatura', 274.0000, 'ºC'),
	(22379, 111, '2015-01-15 00:02:17.000000', 'temperatura', 1042.0000, 'ºC'),
	(22380, 111, '2015-01-15 00:02:18.000000', 'temperatura', 787.0000, 'ºC'),
	(22381, 111, '2015-01-15 00:02:19.000000', 'temperatura', 812.0000, 'ºC'),
	(22382, 111, '2015-01-15 00:02:20.000000', 'temperatura', 498.0000, 'ºC'),
	(22383, 111, '2015-01-15 00:02:21.000000', 'temperatura', 55.0000, 'ºC'),
	(22384, 111, '2015-01-15 00:02:22.000000', 'temperatura', 1180.0000, 'ºC'),
	(22385, 111, '2015-01-15 00:02:23.000000', 'temperatura', 936.0000, 'ºC'),
	(22386, 111, '2015-01-15 00:02:24.000000', 'temperatura', 1142.0000, 'ºC'),
	(22387, 111, '2015-01-15 00:02:25.000000', 'temperatura', 501.0000, 'ºC'),
	(22388, 111, '2015-01-15 00:02:26.000000', 'temperatura', 281.0000, 'ºC'),
	(22389, 111, '2015-01-15 00:02:27.000000', 'temperatura', 1103.0000, 'ºC'),
	(22390, 111, '2015-01-15 00:02:28.000000', 'temperatura', 1070.0000, 'ºC'),
	(22391, 111, '2015-01-15 00:02:29.000000', 'temperatura', 841.0000, 'ºC'),
	(22392, 111, '2015-01-15 00:02:30.000000', 'temperatura', 997.0000, 'ºC'),
	(22393, 111, '2015-01-15 00:02:31.000000', 'temperatura', 62.0000, 'ºC'),
	(22394, 111, '2015-01-15 00:02:32.000000', 'temperatura', 920.0000, 'ºC'),
	(22395, 111, '2015-01-15 00:02:33.000000', 'temperatura', 812.0000, 'ºC'),
	(22396, 111, '2015-01-15 00:02:34.000000', 'temperatura', 104.0000, 'ºC'),
	(22397, 111, '2015-01-15 00:02:35.000000', 'temperatura', 483.0000, 'ºC'),
	(22398, 111, '2015-01-15 00:02:36.000000', 'temperatura', 904.0000, 'ºC'),
	(22399, 111, '2015-01-15 00:02:37.000000', 'temperatura', 671.0000, 'ºC'),
	(22400, 111, '2015-01-15 00:02:38.000000', 'temperatura', 643.0000, 'ºC'),
	(22401, 111, '2015-01-15 00:02:39.000000', 'temperatura', 3.0000, 'ºC'),
	(22402, 111, '2015-01-15 00:02:40.000000', 'temperatura', 488.0000, 'ºC'),
	(22403, 111, '2015-01-15 00:02:41.000000', 'temperatura', 31.0000, 'ºC'),
	(22404, 111, '2015-01-15 00:02:42.000000', 'temperatura', 1090.0000, 'ºC'),
	(22405, 111, '2015-01-15 00:02:43.000000', 'temperatura', 557.0000, 'ºC'),
	(22406, 111, '2015-01-15 00:02:44.000000', 'temperatura', 715.0000, 'ºC'),
	(22407, 111, '2015-01-15 00:02:45.000000', 'temperatura', 706.0000, 'ºC'),
	(22408, 111, '2015-01-15 00:02:46.000000', 'temperatura', 187.0000, 'ºC'),
	(22409, 111, '2015-01-15 00:02:47.000000', 'temperatura', 16.0000, 'ºC'),
	(22410, 111, '2015-01-15 00:02:48.000000', 'temperatura', 720.0000, 'ºC'),
	(22411, 111, '2015-01-15 00:02:49.000000', 'temperatura', 1151.0000, 'ºC'),
	(22412, 111, '2015-01-15 00:02:50.000000', 'temperatura', 1198.0000, 'ºC'),
	(22413, 111, '2015-01-15 00:02:51.000000', 'temperatura', 136.0000, 'ºC'),
	(22414, 111, '2015-01-15 00:02:52.000000', 'temperatura', 685.0000, 'ºC'),
	(22415, 111, '2015-01-15 00:02:53.000000', 'temperatura', 617.0000, 'ºC'),
	(22416, 111, '2015-01-15 00:02:54.000000', 'temperatura', 1033.0000, 'ºC'),
	(22417, 111, '2015-01-15 00:02:55.000000', 'temperatura', 915.0000, 'ºC'),
	(22418, 111, '2015-01-15 00:02:56.000000', 'temperatura', 275.0000, 'ºC'),
	(22419, 111, '2015-01-15 00:02:57.000000', 'temperatura', 1030.0000, 'ºC'),
	(22420, 111, '2015-01-15 00:02:58.000000', 'temperatura', 725.0000, 'ºC'),
	(22421, 111, '2015-01-15 00:02:59.000000', 'temperatura', 536.0000, 'ºC'),
	(22422, 111, '2015-01-15 00:03:00.000000', 'temperatura', 506.0000, 'ºC'),
	(22423, 111, '2015-01-15 00:03:01.000000', 'temperatura', 924.0000, 'ºC'),
	(22424, 111, '2015-01-15 00:03:02.000000', 'temperatura', 700.0000, 'ºC'),
	(22425, 111, '2015-01-15 00:03:03.000000', 'temperatura', 727.0000, 'ºC'),
	(22426, 111, '2015-01-15 00:03:04.000000', 'temperatura', 339.0000, 'ºC'),
	(22427, 111, '2015-01-15 00:03:05.000000', 'temperatura', 713.0000, 'ºC'),
	(22428, 111, '2015-01-15 00:03:06.000000', 'temperatura', 147.0000, 'ºC'),
	(22429, 111, '2015-01-15 00:03:07.000000', 'temperatura', 997.0000, 'ºC'),
	(22430, 111, '2015-01-15 00:03:08.000000', 'temperatura', 945.0000, 'ºC'),
	(22431, 111, '2015-01-15 00:03:09.000000', 'temperatura', 536.0000, 'ºC'),
	(22432, 111, '2015-01-15 00:03:10.000000', 'temperatura', 1043.0000, 'ºC'),
	(22433, 111, '2015-01-15 00:03:11.000000', 'temperatura', 10.0000, 'ºC'),
	(22434, 111, '2015-01-15 00:03:12.000000', 'temperatura', 519.0000, 'ºC'),
	(22435, 111, '2015-01-15 00:03:13.000000', 'temperatura', 167.0000, 'ºC'),
	(22436, 111, '2015-01-15 00:03:14.000000', 'temperatura', 477.0000, 'ºC'),
	(22437, 111, '2015-01-15 00:03:15.000000', 'temperatura', 687.0000, 'ºC'),
	(22438, 111, '2015-01-15 00:03:16.000000', 'temperatura', 805.0000, 'ºC'),
	(22439, 111, '2015-01-15 00:03:17.000000', 'temperatura', 764.0000, 'ºC'),
	(22440, 111, '2015-01-15 00:03:18.000000', 'temperatura', 205.0000, 'ºC'),
	(22441, 111, '2015-01-15 00:03:19.000000', 'temperatura', 1136.0000, 'ºC'),
	(22442, 111, '2015-01-15 00:03:20.000000', 'temperatura', 262.0000, 'ºC'),
	(22443, 111, '2015-01-15 00:03:21.000000', 'temperatura', 303.0000, 'ºC'),
	(22444, 111, '2015-01-15 00:03:22.000000', 'temperatura', 728.0000, 'ºC'),
	(22445, 111, '2015-01-15 00:03:23.000000', 'temperatura', 333.0000, 'ºC'),
	(22446, 111, '2015-01-15 00:03:24.000000', 'temperatura', 680.0000, 'ºC'),
	(22447, 111, '2015-01-15 00:03:25.000000', 'temperatura', 2.0000, 'ºC'),
	(22448, 111, '2015-01-15 00:03:26.000000', 'temperatura', 370.0000, 'ºC'),
	(22449, 111, '2015-01-15 00:03:27.000000', 'temperatura', 644.0000, 'ºC'),
	(22450, 111, '2015-01-15 00:03:28.000000', 'temperatura', 913.0000, 'ºC'),
	(22451, 111, '2015-01-15 00:03:29.000000', 'temperatura', 232.0000, 'ºC'),
	(22452, 111, '2015-01-15 00:03:30.000000', 'temperatura', 823.0000, 'ºC'),
	(22453, 111, '2015-01-15 00:03:31.000000', 'temperatura', 1019.0000, 'ºC'),
	(22454, 111, '2015-01-15 00:03:32.000000', 'temperatura', 227.0000, 'ºC'),
	(22455, 111, '2015-01-15 00:03:33.000000', 'temperatura', 477.0000, 'ºC'),
	(22456, 111, '2015-01-15 00:03:34.000000', 'temperatura', 503.0000, 'ºC'),
	(22457, 111, '2015-01-15 00:03:35.000000', 'temperatura', 1088.0000, 'ºC'),
	(22458, 111, '2015-01-15 00:03:36.000000', 'temperatura', 329.0000, 'ºC'),
	(22459, 111, '2015-01-15 00:03:37.000000', 'temperatura', 782.0000, 'ºC'),
	(22460, 111, '2015-01-15 00:03:38.000000', 'temperatura', 525.0000, 'ºC'),
	(22461, 111, '2015-01-15 00:03:39.000000', 'temperatura', 280.0000, 'ºC'),
	(22462, 111, '2015-01-15 00:03:40.000000', 'temperatura', 1025.0000, 'ºC'),
	(22463, 111, '2015-01-15 00:03:41.000000', 'temperatura', 684.0000, 'ºC'),
	(22464, 111, '2015-01-15 00:03:42.000000', 'temperatura', 347.0000, 'ºC'),
	(22465, 111, '2015-01-15 00:03:43.000000', 'temperatura', 882.0000, 'ºC'),
	(22466, 111, '2015-01-15 00:03:44.000000', 'temperatura', 972.0000, 'ºC'),
	(22467, 111, '2015-01-15 00:03:45.000000', 'temperatura', 1014.0000, 'ºC'),
	(22468, 111, '2015-01-15 00:03:46.000000', 'temperatura', 955.0000, 'ºC'),
	(22469, 111, '2015-01-15 00:03:47.000000', 'temperatura', 533.0000, 'ºC'),
	(22470, 111, '2015-01-15 00:03:48.000000', 'temperatura', 1001.0000, 'ºC'),
	(22471, 111, '2015-01-15 00:03:49.000000', 'temperatura', 1007.0000, 'ºC'),
	(22472, 111, '2015-01-15 00:03:50.000000', 'temperatura', 831.0000, 'ºC'),
	(22473, 111, '2015-01-15 00:03:51.000000', 'temperatura', 1135.0000, 'ºC'),
	(22474, 111, '2015-01-15 00:03:52.000000', 'temperatura', 782.0000, 'ºC'),
	(22475, 111, '2015-01-15 00:03:53.000000', 'temperatura', 507.0000, 'ºC'),
	(22476, 111, '2015-01-15 00:03:54.000000', 'temperatura', 187.0000, 'ºC'),
	(22477, 111, '2015-01-15 00:03:55.000000', 'temperatura', 617.0000, 'ºC'),
	(22478, 111, '2015-01-15 00:03:56.000000', 'temperatura', 122.0000, 'ºC'),
	(22479, 111, '2015-01-15 00:03:57.000000', 'temperatura', 1159.0000, 'ºC'),
	(22480, 111, '2015-01-15 00:03:58.000000', 'temperatura', 630.0000, 'ºC'),
	(22481, 111, '2015-01-15 00:03:59.000000', 'temperatura', 873.0000, 'ºC'),
	(22482, 111, '2015-01-15 00:04:00.000000', 'temperatura', 77.0000, 'ºC'),
	(22483, 111, '2015-01-15 00:04:01.000000', 'temperatura', 165.0000, 'ºC'),
	(22484, 111, '2015-01-15 00:04:02.000000', 'temperatura', 593.0000, 'ºC'),
	(22485, 111, '2015-01-15 00:04:03.000000', 'temperatura', 73.0000, 'ºC'),
	(22486, 111, '2015-01-15 00:04:04.000000', 'temperatura', 987.0000, 'ºC'),
	(22487, 111, '2015-01-15 00:04:05.000000', 'temperatura', 1118.0000, 'ºC'),
	(22488, 111, '2015-01-15 00:04:06.000000', 'temperatura', 226.0000, 'ºC'),
	(22489, 111, '2015-01-15 00:04:07.000000', 'temperatura', 179.0000, 'ºC'),
	(22490, 111, '2015-01-15 00:04:08.000000', 'temperatura', 215.0000, 'ºC'),
	(22491, 111, '2015-01-15 00:04:09.000000', 'temperatura', 541.0000, 'ºC'),
	(22492, 111, '2015-01-15 00:04:10.000000', 'temperatura', 858.0000, 'ºC'),
	(22493, 111, '2015-01-15 00:04:11.000000', 'temperatura', 271.0000, 'ºC'),
	(22494, 111, '2015-01-15 00:04:12.000000', 'temperatura', 1178.0000, 'ºC'),
	(22495, 111, '2015-01-15 00:04:13.000000', 'temperatura', 278.0000, 'ºC'),
	(22496, 111, '2015-01-15 00:04:14.000000', 'temperatura', 256.0000, 'ºC'),
	(22497, 111, '2015-01-15 00:04:15.000000', 'temperatura', 449.0000, 'ºC'),
	(22498, 111, '2015-01-15 00:04:16.000000', 'temperatura', 277.0000, 'ºC'),
	(22499, 111, '2015-01-15 00:04:17.000000', 'temperatura', 36.0000, 'ºC'),
	(22500, 111, '2015-01-15 00:04:18.000000', 'temperatura', 552.0000, 'ºC'),
	(22501, 111, '2015-01-15 00:04:19.000000', 'temperatura', 251.0000, 'ºC'),
	(22502, 111, '2015-01-15 00:04:20.000000', 'temperatura', 798.0000, 'ºC'),
	(22503, 111, '2015-01-15 00:04:21.000000', 'temperatura', 839.0000, 'ºC'),
	(22504, 111, '2015-01-15 00:04:22.000000', 'temperatura', 602.0000, 'ºC'),
	(22505, 111, '2015-01-15 00:04:23.000000', 'temperatura', 494.0000, 'ºC'),
	(22506, 111, '2015-01-15 00:04:24.000000', 'temperatura', 664.0000, 'ºC'),
	(22507, 111, '2015-01-15 00:04:25.000000', 'temperatura', 639.0000, 'ºC'),
	(22508, 111, '2015-01-15 00:04:26.000000', 'temperatura', 5.0000, 'ºC'),
	(22509, 111, '2015-01-15 00:04:27.000000', 'temperatura', 508.0000, 'ºC'),
	(22510, 111, '2015-01-15 00:04:28.000000', 'temperatura', 123.0000, 'ºC'),
	(22511, 111, '2015-01-15 00:04:29.000000', 'temperatura', 294.0000, 'ºC'),
	(22512, 111, '2015-01-15 00:04:30.000000', 'temperatura', 1102.0000, 'ºC'),
	(22513, 111, '2015-01-15 00:04:31.000000', 'temperatura', 1027.0000, 'ºC'),
	(22514, 111, '2015-01-15 00:04:32.000000', 'temperatura', 630.0000, 'ºC'),
	(22515, 111, '2015-01-15 00:04:33.000000', 'temperatura', 70.0000, 'ºC'),
	(22516, 111, '2015-01-15 00:04:34.000000', 'temperatura', 860.0000, 'ºC'),
	(22517, 111, '2015-01-15 00:04:35.000000', 'temperatura', 492.0000, 'ºC'),
	(22518, 111, '2015-01-15 00:04:36.000000', 'temperatura', 1082.0000, 'ºC'),
	(22519, 111, '2015-01-15 00:04:37.000000', 'temperatura', 331.0000, 'ºC'),
	(22520, 111, '2015-01-15 00:04:38.000000', 'temperatura', 810.0000, 'ºC'),
	(22521, 111, '2015-01-15 00:04:39.000000', 'temperatura', 657.0000, 'ºC'),
	(22522, 111, '2015-01-15 00:04:40.000000', 'temperatura', 857.0000, 'ºC'),
	(22523, 111, '2015-01-15 00:04:41.000000', 'temperatura', 1113.0000, 'ºC'),
	(22524, 111, '2015-01-15 00:04:42.000000', 'temperatura', 596.0000, 'ºC'),
	(22525, 111, '2015-01-15 00:04:43.000000', 'temperatura', 840.0000, 'ºC'),
	(22526, 111, '2015-01-15 00:04:44.000000', 'temperatura', 14.0000, 'ºC'),
	(22527, 111, '2015-01-15 00:04:45.000000', 'temperatura', 1150.0000, 'ºC'),
	(22528, 111, '2015-01-15 00:04:46.000000', 'temperatura', 908.0000, 'ºC'),
	(22529, 111, '2015-01-15 00:04:47.000000', 'temperatura', 1089.0000, 'ºC'),
	(22530, 111, '2015-01-15 00:04:48.000000', 'temperatura', 325.0000, 'ºC'),
	(22531, 111, '2015-01-15 00:04:49.000000', 'temperatura', 755.0000, 'ºC'),
	(22532, 111, '2015-01-15 00:04:50.000000', 'temperatura', 404.0000, 'ºC'),
	(22533, 111, '2015-01-15 00:04:51.000000', 'temperatura', 953.0000, 'ºC'),
	(22534, 111, '2015-01-15 00:04:52.000000', 'temperatura', 1155.0000, 'ºC'),
	(22535, 111, '2015-01-15 00:04:53.000000', 'temperatura', 515.0000, 'ºC'),
	(22536, 111, '2015-01-15 00:04:54.000000', 'temperatura', 313.0000, 'ºC'),
	(22537, 111, '2015-01-15 00:04:55.000000', 'temperatura', 18.0000, 'ºC'),
	(22538, 111, '2015-01-15 00:04:56.000000', 'temperatura', 350.0000, 'ºC'),
	(22539, 111, '2015-01-15 00:04:57.000000', 'temperatura', 500.0000, 'ºC'),
	(22540, 111, '2015-01-15 00:04:58.000000', 'temperatura', 248.0000, 'ºC'),
	(22541, 111, '2015-01-15 00:04:59.000000', 'temperatura', 941.0000, 'ºC'),
	(22542, 111, '2015-01-15 00:05:00.000000', 'temperatura', 361.0000, 'ºC'),
	(22543, 111, '2015-01-15 00:05:01.000000', 'temperatura', 183.0000, 'ºC'),
	(22544, 111, '2015-01-15 00:05:02.000000', 'temperatura', 1031.0000, 'ºC'),
	(22545, 111, '2015-01-15 00:05:03.000000', 'temperatura', 1007.0000, 'ºC'),
	(22546, 111, '2015-01-15 00:05:04.000000', 'temperatura', 743.0000, 'ºC'),
	(22547, 111, '2015-01-15 00:05:05.000000', 'temperatura', 693.0000, 'ºC'),
	(22548, 111, '2015-01-15 00:05:06.000000', 'temperatura', 38.0000, 'ºC'),
	(22549, 111, '2015-01-15 00:05:07.000000', 'temperatura', 513.0000, 'ºC'),
	(22550, 111, '2015-01-15 00:05:08.000000', 'temperatura', 49.0000, 'ºC'),
	(22551, 111, '2015-01-15 00:05:09.000000', 'temperatura', 1106.0000, 'ºC'),
	(22552, 111, '2015-01-15 00:05:10.000000', 'temperatura', 586.0000, 'ºC'),
	(22553, 111, '2015-01-15 00:05:11.000000', 'temperatura', 812.0000, 'ºC'),
	(22554, 111, '2015-01-15 00:05:12.000000', 'temperatura', 1101.0000, 'ºC'),
	(22555, 111, '2015-01-15 00:05:13.000000', 'temperatura', 671.0000, 'ºC'),
	(22556, 111, '2015-01-15 00:05:14.000000', 'temperatura', 53.0000, 'ºC'),
	(22557, 111, '2015-01-15 00:05:15.000000', 'temperatura', 650.0000, 'ºC'),
	(22558, 111, '2015-01-15 00:05:16.000000', 'temperatura', 694.0000, 'ºC'),
	(22559, 111, '2015-01-15 00:05:17.000000', 'temperatura', 319.0000, 'ºC'),
	(22560, 111, '2015-01-15 00:05:18.000000', 'temperatura', 715.0000, 'ºC'),
	(22561, 111, '2015-01-15 00:05:19.000000', 'temperatura', 216.0000, 'ºC'),
	(22562, 111, '2015-01-15 00:05:20.000000', 'temperatura', 135.0000, 'ºC'),
	(22563, 111, '2015-01-15 00:05:21.000000', 'temperatura', 30.0000, 'ºC'),
	(22564, 111, '2015-01-15 00:05:22.000000', 'temperatura', 943.0000, 'ºC'),
	(22565, 111, '2015-01-15 00:05:23.000000', 'temperatura', 1026.0000, 'ºC'),
	(22566, 111, '2015-01-15 00:05:24.000000', 'temperatura', 1101.0000, 'ºC'),
	(22567, 111, '2015-01-15 00:05:25.000000', 'temperatura', 30.0000, 'ºC'),
	(22568, 111, '2015-01-15 00:05:26.000000', 'temperatura', 446.0000, 'ºC'),
	(22569, 111, '2015-01-15 00:05:27.000000', 'temperatura', 939.0000, 'ºC'),
	(22570, 111, '2015-01-15 00:05:28.000000', 'temperatura', 961.0000, 'ºC'),
	(22571, 111, '2015-01-15 00:05:29.000000', 'temperatura', 785.0000, 'ºC'),
	(22572, 111, '2015-01-15 00:05:30.000000', 'temperatura', 1043.0000, 'ºC'),
	(22573, 111, '2015-01-15 00:05:31.000000', 'temperatura', 462.0000, 'ºC'),
	(22574, 111, '2015-01-15 00:05:32.000000', 'temperatura', 381.0000, 'ºC'),
	(22575, 111, '2015-01-15 00:05:33.000000', 'temperatura', 521.0000, 'ºC'),
	(22576, 111, '2015-01-15 00:05:34.000000', 'temperatura', 261.0000, 'ºC'),
	(22577, 111, '2015-01-15 00:05:35.000000', 'temperatura', 942.0000, 'ºC'),
	(22578, 111, '2015-01-15 00:05:36.000000', 'temperatura', 328.0000, 'ºC'),
	(22579, 111, '2015-01-15 00:05:37.000000', 'temperatura', 14.0000, 'ºC'),
	(22580, 111, '2015-01-15 00:05:38.000000', 'temperatura', 288.0000, 'ºC'),
	(22581, 111, '2015-01-15 00:05:39.000000', 'temperatura', 196.0000, 'ºC'),
	(22582, 111, '2015-01-15 00:05:40.000000', 'temperatura', 119.0000, 'ºC'),
	(22583, 111, '2015-01-15 00:05:41.000000', 'temperatura', 7.0000, 'ºC'),
	(22584, 111, '2015-01-15 00:05:42.000000', 'temperatura', 877.0000, 'ºC'),
	(22585, 111, '2015-01-15 00:05:43.000000', 'temperatura', 764.0000, 'ºC'),
	(22586, 111, '2015-01-15 00:05:44.000000', 'temperatura', 1192.0000, 'ºC'),
	(22587, 111, '2015-01-15 00:05:45.000000', 'temperatura', 67.0000, 'ºC'),
	(22588, 111, '2015-01-15 00:05:46.000000', 'temperatura', 360.0000, 'ºC'),
	(22589, 111, '2015-01-15 00:05:47.000000', 'temperatura', 398.0000, 'ºC'),
	(22590, 111, '2015-01-15 00:05:48.000000', 'temperatura', 912.0000, 'ºC'),
	(22591, 111, '2015-01-15 00:05:49.000000', 'temperatura', 967.0000, 'ºC'),
	(22592, 111, '2015-01-15 00:05:50.000000', 'temperatura', 897.0000, 'ºC'),
	(22593, 111, '2015-01-15 00:05:51.000000', 'temperatura', 387.0000, 'ºC'),
	(22594, 111, '2015-01-15 00:05:52.000000', 'temperatura', 446.0000, 'ºC'),
	(22595, 111, '2015-01-15 00:05:53.000000', 'temperatura', 1067.0000, 'ºC'),
	(22596, 111, '2015-01-15 00:05:54.000000', 'temperatura', 398.0000, 'ºC'),
	(22597, 111, '2015-01-15 00:05:55.000000', 'temperatura', 1191.0000, 'ºC'),
	(22598, 111, '2015-01-15 00:05:56.000000', 'temperatura', 1159.0000, 'ºC'),
	(22599, 111, '2015-01-15 00:05:57.000000', 'temperatura', 1024.0000, 'ºC'),
	(22600, 111, '2015-01-15 00:05:58.000000', 'temperatura', 443.0000, 'ºC'),
	(22601, 111, '2015-01-15 00:05:59.000000', 'temperatura', 344.0000, 'ºC'),
	(22602, 111, '2015-01-15 00:06:00.000000', 'temperatura', 392.0000, 'ºC'),
	(22603, 111, '2015-01-15 00:06:01.000000', 'temperatura', 927.0000, 'ºC'),
	(22604, 111, '2015-01-15 00:06:02.000000', 'temperatura', 1061.0000, 'ºC'),
	(22605, 111, '2015-01-15 00:06:03.000000', 'temperatura', 123.0000, 'ºC'),
	(22606, 111, '2015-01-15 00:06:04.000000', 'temperatura', 1034.0000, 'ºC'),
	(22607, 111, '2015-01-15 00:06:05.000000', 'temperatura', 0.0000, 'ºC'),
	(22608, 111, '2015-01-15 00:06:06.000000', 'temperatura', 501.0000, 'ºC'),
	(22609, 111, '2015-01-15 00:06:07.000000', 'temperatura', 103.0000, 'ºC'),
	(22610, 111, '2015-01-15 00:06:08.000000', 'temperatura', 213.0000, 'ºC'),
	(22611, 111, '2015-01-15 00:06:09.000000', 'temperatura', 755.0000, 'ºC'),
	(22612, 111, '2015-01-15 00:06:10.000000', 'temperatura', 737.0000, 'ºC'),
	(22613, 111, '2015-01-15 00:06:11.000000', 'temperatura', 222.0000, 'ºC'),
	(22614, 111, '2015-01-15 00:06:12.000000', 'temperatura', 101.0000, 'ºC'),
	(22615, 111, '2015-01-15 00:06:13.000000', 'temperatura', 1037.0000, 'ºC'),
	(22616, 111, '2015-01-15 00:06:14.000000', 'temperatura', 84.0000, 'ºC'),
	(22617, 111, '2015-01-15 00:06:15.000000', 'temperatura', 909.0000, 'ºC'),
	(22618, 111, '2015-01-15 00:06:16.000000', 'temperatura', 695.0000, 'ºC'),
	(22619, 111, '2015-01-15 00:06:17.000000', 'temperatura', 749.0000, 'ºC'),
	(22620, 111, '2015-01-15 00:06:18.000000', 'temperatura', 458.0000, 'ºC'),
	(22621, 111, '2015-01-15 00:06:19.000000', 'temperatura', 44.0000, 'ºC'),
	(22622, 111, '2015-01-15 00:06:20.000000', 'temperatura', 46.0000, 'ºC'),
	(22623, 111, '2015-01-15 00:06:21.000000', 'temperatura', 101.0000, 'ºC'),
	(22624, 111, '2015-01-15 00:06:22.000000', 'temperatura', 364.0000, 'ºC'),
	(22625, 111, '2015-01-15 00:06:23.000000', 'temperatura', 321.0000, 'ºC'),
	(22626, 111, '2015-01-15 00:06:24.000000', 'temperatura', 512.0000, 'ºC'),
	(22627, 111, '2015-01-15 00:06:25.000000', 'temperatura', 398.0000, 'ºC'),
	(22628, 111, '2015-01-15 00:06:26.000000', 'temperatura', 456.0000, 'ºC'),
	(22629, 111, '2015-01-15 00:06:27.000000', 'temperatura', 1086.0000, 'ºC'),
	(22630, 111, '2015-01-15 00:06:28.000000', 'temperatura', 462.0000, 'ºC'),
	(22631, 111, '2015-01-15 00:06:29.000000', 'temperatura', 255.0000, 'ºC'),
	(22632, 111, '2015-01-15 00:06:30.000000', 'temperatura', 1086.0000, 'ºC'),
	(22633, 111, '2015-01-15 00:06:31.000000', 'temperatura', 1065.0000, 'ºC'),
	(22634, 111, '2015-01-15 00:06:32.000000', 'temperatura', 870.0000, 'ºC'),
	(22635, 111, '2015-01-15 00:06:33.000000', 'temperatura', 1156.0000, 'ºC'),
	(22636, 111, '2015-01-15 00:06:34.000000', 'temperatura', 770.0000, 'ºC'),
	(22637, 111, '2015-01-15 00:06:35.000000', 'temperatura', 381.0000, 'ºC'),
	(22638, 111, '2015-01-15 00:06:36.000000', 'temperatura', 798.0000, 'ºC'),
	(22639, 111, '2015-01-15 00:06:37.000000', 'temperatura', 448.0000, 'ºC'),
	(22640, 111, '2015-01-15 00:06:38.000000', 'temperatura', 1044.0000, 'ºC'),
	(22641, 111, '2015-01-15 00:06:39.000000', 'temperatura', 278.0000, 'ºC'),
	(22642, 111, '2015-01-15 00:06:40.000000', 'temperatura', 658.0000, 'ºC'),
	(22643, 111, '2015-01-15 00:06:41.000000', 'temperatura', 55.0000, 'ºC'),
	(22644, 111, '2015-01-15 00:06:42.000000', 'temperatura', 705.0000, 'ºC'),
	(22645, 111, '2015-01-15 00:06:43.000000', 'temperatura', 958.0000, 'ºC'),
	(22646, 111, '2015-01-15 00:06:44.000000', 'temperatura', 274.0000, 'ºC'),
	(22647, 111, '2015-01-15 00:06:45.000000', 'temperatura', 899.0000, 'ºC'),
	(22648, 111, '2015-01-15 00:06:46.000000', 'temperatura', 73.0000, 'ºC'),
	(22649, 111, '2015-01-15 00:06:47.000000', 'temperatura', 70.0000, 'ºC'),
	(22650, 111, '2015-01-15 00:06:48.000000', 'temperatura', 132.0000, 'ºC'),
	(22651, 111, '2015-01-15 00:06:49.000000', 'temperatura', 448.0000, 'ºC'),
	(22652, 111, '2015-01-15 00:06:50.000000', 'temperatura', 645.0000, 'ºC'),
	(22653, 111, '2015-01-15 00:06:51.000000', 'temperatura', 680.0000, 'ºC'),
	(22654, 111, '2015-01-15 00:06:52.000000', 'temperatura', 267.0000, 'ºC'),
	(22655, 111, '2015-01-15 00:06:53.000000', 'temperatura', 497.0000, 'ºC'),
	(22656, 111, '2015-01-15 00:06:54.000000', 'temperatura', 482.0000, 'ºC'),
	(22657, 111, '2015-01-15 00:06:55.000000', 'temperatura', 920.0000, 'ºC'),
	(22658, 111, '2015-01-15 00:06:56.000000', 'temperatura', 755.0000, 'ºC'),
	(22659, 111, '2015-01-15 00:06:57.000000', 'temperatura', 1015.0000, 'ºC'),
	(22660, 111, '2015-01-15 00:06:58.000000', 'temperatura', 412.0000, 'ºC'),
	(22661, 111, '2015-01-15 00:06:59.000000', 'temperatura', 212.0000, 'ºC'),
	(22662, 111, '2015-01-15 00:07:00.000000', 'temperatura', 1028.0000, 'ºC'),
	(22663, 111, '2015-01-15 00:07:01.000000', 'temperatura', 905.0000, 'ºC'),
	(22664, 111, '2015-01-15 00:07:02.000000', 'temperatura', 242.0000, 'ºC'),
	(22665, 111, '2015-01-15 00:07:03.000000', 'temperatura', 893.0000, 'ºC'),
	(22666, 111, '2015-01-15 00:07:04.000000', 'temperatura', 139.0000, 'ºC'),
	(22667, 111, '2015-01-15 00:07:05.000000', 'temperatura', 415.0000, 'ºC'),
	(22668, 111, '2015-01-15 00:07:06.000000', 'temperatura', 462.0000, 'ºC'),
	(22669, 111, '2015-01-15 00:07:07.000000', 'temperatura', 1064.0000, 'ºC'),
	(22670, 111, '2015-01-15 00:07:08.000000', 'temperatura', 335.0000, 'ºC'),
	(22671, 111, '2015-01-15 00:07:09.000000', 'temperatura', 884.0000, 'ºC'),
	(22672, 111, '2015-01-15 00:07:10.000000', 'temperatura', 1014.0000, 'ºC'),
	(22673, 111, '2015-01-15 00:07:11.000000', 'temperatura', 20.0000, 'ºC'),
	(22674, 111, '2015-01-15 00:07:12.000000', 'temperatura', 660.0000, 'ºC'),
	(22675, 111, '2015-01-15 00:07:13.000000', 'temperatura', 838.0000, 'ºC'),
	(22676, 111, '2015-01-15 00:07:14.000000', 'temperatura', 1010.0000, 'ºC'),
	(22677, 111, '2015-01-15 00:07:15.000000', 'temperatura', 139.0000, 'ºC'),
	(22678, 111, '2015-01-15 00:07:16.000000', 'temperatura', 63.0000, 'ºC'),
	(22679, 111, '2015-01-15 00:07:17.000000', 'temperatura', 1097.0000, 'ºC'),
	(22680, 111, '2015-01-15 00:07:18.000000', 'temperatura', 500.0000, 'ºC'),
	(22681, 111, '2015-01-15 00:07:19.000000', 'temperatura', 409.0000, 'ºC'),
	(22682, 111, '2015-01-15 00:07:20.000000', 'temperatura', 545.0000, 'ºC'),
	(22683, 111, '2015-01-15 00:07:21.000000', 'temperatura', 299.0000, 'ºC'),
	(22684, 111, '2015-01-15 00:07:22.000000', 'temperatura', 1060.0000, 'ºC'),
	(22685, 111, '2015-01-15 00:07:23.000000', 'temperatura', 802.0000, 'ºC'),
	(22686, 111, '2015-01-15 00:07:24.000000', 'temperatura', 832.0000, 'ºC'),
	(22687, 111, '2015-01-15 00:07:25.000000', 'temperatura', 554.0000, 'ºC'),
	(22688, 111, '2015-01-15 00:07:26.000000', 'temperatura', 275.0000, 'ºC'),
	(22689, 111, '2015-01-15 00:07:27.000000', 'temperatura', 914.0000, 'ºC'),
	(22690, 111, '2015-01-15 00:07:28.000000', 'temperatura', 146.0000, 'ºC'),
	(22691, 111, '2015-01-15 00:07:29.000000', 'temperatura', 386.0000, 'ºC'),
	(22692, 111, '2015-01-15 00:07:30.000000', 'temperatura', 293.0000, 'ºC'),
	(22693, 111, '2015-01-15 00:07:31.000000', 'temperatura', 306.0000, 'ºC'),
	(22694, 111, '2015-01-15 00:07:32.000000', 'temperatura', 654.0000, 'ºC'),
	(22695, 111, '2015-01-15 00:07:33.000000', 'temperatura', 1153.0000, 'ºC'),
	(22696, 111, '2015-01-15 00:07:34.000000', 'temperatura', 201.0000, 'ºC'),
	(22697, 111, '2015-01-15 00:07:35.000000', 'temperatura', 1148.0000, 'ºC'),
	(22698, 111, '2015-01-15 00:07:36.000000', 'temperatura', 338.0000, 'ºC'),
	(22699, 111, '2015-01-15 00:07:37.000000', 'temperatura', 645.0000, 'ºC'),
	(22700, 111, '2015-01-15 00:07:38.000000', 'temperatura', 1012.0000, 'ºC'),
	(22701, 111, '2015-01-15 00:07:39.000000', 'temperatura', 726.0000, 'ºC'),
	(22702, 111, '2015-01-15 00:07:40.000000', 'temperatura', 594.0000, 'ºC'),
	(22703, 111, '2015-01-15 00:07:41.000000', 'temperatura', 795.0000, 'ºC'),
	(22704, 111, '2015-01-15 00:07:42.000000', 'temperatura', 990.0000, 'ºC'),
	(22705, 111, '2015-01-15 00:07:43.000000', 'temperatura', 166.0000, 'ºC'),
	(22706, 111, '2015-01-15 00:07:44.000000', 'temperatura', 260.0000, 'ºC'),
	(22707, 111, '2015-01-15 00:07:45.000000', 'temperatura', 803.0000, 'ºC'),
	(22708, 111, '2015-01-15 00:07:46.000000', 'temperatura', 834.0000, 'ºC'),
	(22709, 111, '2015-01-15 00:07:47.000000', 'temperatura', 562.0000, 'ºC'),
	(22710, 111, '2015-01-15 00:07:48.000000', 'temperatura', 308.0000, 'ºC'),
	(22711, 111, '2015-01-15 00:07:49.000000', 'temperatura', 1054.0000, 'ºC'),
	(22712, 111, '2015-01-15 00:07:50.000000', 'temperatura', 748.0000, 'ºC'),
	(22713, 111, '2015-01-15 00:07:51.000000', 'temperatura', 576.0000, 'ºC'),
	(22714, 111, '2015-01-15 00:07:52.000000', 'temperatura', 639.0000, 'ºC'),
	(22715, 111, '2015-01-15 00:07:53.000000', 'temperatura', 269.0000, 'ºC'),
	(22716, 111, '2015-01-15 00:07:54.000000', 'temperatura', 625.0000, 'ºC'),
	(22717, 111, '2015-01-15 00:07:55.000000', 'temperatura', 1121.0000, 'ºC'),
	(22718, 111, '2015-01-15 00:07:56.000000', 'temperatura', 128.0000, 'ºC'),
	(22719, 111, '2015-01-15 00:07:57.000000', 'temperatura', 880.0000, 'ºC'),
	(22720, 111, '2015-01-15 00:07:58.000000', 'temperatura', 417.0000, 'ºC'),
	(22721, 111, '2015-01-15 00:07:59.000000', 'temperatura', 644.0000, 'ºC'),
	(22722, 111, '2015-01-15 00:08:00.000000', 'temperatura', 769.0000, 'ºC'),
	(22723, 111, '2015-01-15 00:08:01.000000', 'temperatura', 716.0000, 'ºC'),
	(22724, 111, '2015-01-15 00:08:02.000000', 'temperatura', 72.0000, 'ºC'),
	(22725, 111, '2015-01-15 00:08:03.000000', 'temperatura', 615.0000, 'ºC'),
	(22726, 111, '2015-01-15 00:08:04.000000', 'temperatura', 456.0000, 'ºC'),
	(22727, 111, '2015-01-15 00:08:05.000000', 'temperatura', 439.0000, 'ºC'),
	(22728, 111, '2015-01-15 00:08:06.000000', 'temperatura', 825.0000, 'ºC'),
	(22729, 111, '2015-01-15 00:08:07.000000', 'temperatura', 407.0000, 'ºC'),
	(22730, 111, '2015-01-15 00:08:08.000000', 'temperatura', 762.0000, 'ºC'),
	(22731, 111, '2015-01-15 00:08:09.000000', 'temperatura', 191.0000, 'ºC'),
	(22732, 111, '2015-01-15 00:08:10.000000', 'temperatura', 1068.0000, 'ºC'),
	(22733, 111, '2015-01-15 00:08:11.000000', 'temperatura', 1167.0000, 'ºC'),
	(22734, 111, '2015-01-15 00:08:12.000000', 'temperatura', 233.0000, 'ºC'),
	(22735, 111, '2015-01-15 00:08:13.000000', 'temperatura', 64.0000, 'ºC'),
	(22736, 111, '2015-01-15 00:08:14.000000', 'temperatura', 823.0000, 'ºC'),
	(22737, 111, '2015-01-15 00:08:15.000000', 'temperatura', 324.0000, 'ºC'),
	(22738, 111, '2015-01-15 00:08:16.000000', 'temperatura', 352.0000, 'ºC'),
	(22739, 111, '2015-01-15 00:08:17.000000', 'temperatura', 788.0000, 'ºC'),
	(22740, 111, '2015-01-15 00:08:18.000000', 'temperatura', 484.0000, 'ºC'),
	(22741, 111, '2015-01-15 00:08:19.000000', 'temperatura', 58.0000, 'ºC'),
	(22742, 111, '2015-01-15 00:08:20.000000', 'temperatura', 37.0000, 'ºC'),
	(22743, 111, '2015-01-15 00:08:21.000000', 'temperatura', 13.0000, 'ºC'),
	(22744, 111, '2015-01-15 00:08:22.000000', 'temperatura', 1152.0000, 'ºC'),
	(22745, 111, '2015-01-15 00:08:23.000000', 'temperatura', 924.0000, 'ºC'),
	(22746, 111, '2015-01-15 00:08:24.000000', 'temperatura', 1165.0000, 'ºC'),
	(22747, 111, '2015-01-15 00:08:25.000000', 'temperatura', 651.0000, 'ºC'),
	(22748, 111, '2015-01-15 00:08:26.000000', 'temperatura', 960.0000, 'ºC'),
	(22749, 111, '2015-01-15 00:08:27.000000', 'temperatura', 449.0000, 'ºC'),
	(22750, 111, '2015-01-15 00:08:28.000000', 'temperatura', 564.0000, 'ºC'),
	(22751, 111, '2015-01-15 00:08:29.000000', 'temperatura', 275.0000, 'ºC'),
	(22752, 111, '2015-01-15 00:08:30.000000', 'temperatura', 884.0000, 'ºC'),
	(22753, 111, '2015-01-15 00:08:31.000000', 'temperatura', 1196.0000, 'ºC'),
	(22754, 111, '2015-01-15 00:08:32.000000', 'temperatura', 926.0000, 'ºC'),
	(22755, 111, '2015-01-15 00:08:33.000000', 'temperatura', 1042.0000, 'ºC'),
	(22756, 111, '2015-01-15 00:08:34.000000', 'temperatura', 36.0000, 'ºC'),
	(22757, 111, '2015-01-15 00:08:35.000000', 'temperatura', 652.0000, 'ºC'),
	(22758, 111, '2015-01-15 00:08:36.000000', 'temperatura', 754.0000, 'ºC'),
	(22759, 111, '2015-01-15 00:08:37.000000', 'temperatura', 612.0000, 'ºC'),
	(22760, 111, '2015-01-15 00:08:38.000000', 'temperatura', 799.0000, 'ºC'),
	(22761, 111, '2015-01-15 00:08:39.000000', 'temperatura', 959.0000, 'ºC'),
	(22762, 111, '2015-01-15 00:08:40.000000', 'temperatura', 0.0000, 'ºC'),
	(22763, 111, '2015-01-15 00:08:41.000000', 'temperatura', 721.0000, 'ºC'),
	(22764, 111, '2015-01-15 00:08:42.000000', 'temperatura', 6.0000, 'ºC'),
	(22765, 111, '2015-01-15 00:08:43.000000', 'temperatura', 269.0000, 'ºC'),
	(22766, 111, '2015-01-15 00:08:44.000000', 'temperatura', 125.0000, 'ºC'),
	(22767, 111, '2015-01-15 00:08:45.000000', 'temperatura', 1020.0000, 'ºC'),
	(22768, 111, '2015-01-15 00:08:46.000000', 'temperatura', 1124.0000, 'ºC'),
	(22769, 111, '2015-01-15 00:08:47.000000', 'temperatura', 161.0000, 'ºC'),
	(22770, 111, '2015-01-15 00:08:48.000000', 'temperatura', 1035.0000, 'ºC'),
	(22771, 111, '2015-01-15 00:08:49.000000', 'temperatura', 1092.0000, 'ºC'),
	(22772, 111, '2015-01-15 00:08:50.000000', 'temperatura', 1157.0000, 'ºC'),
	(22773, 111, '2015-01-15 00:08:51.000000', 'temperatura', 107.0000, 'ºC'),
	(22774, 111, '2015-01-15 00:08:52.000000', 'temperatura', 664.0000, 'ºC'),
	(22775, 111, '2015-01-15 00:08:53.000000', 'temperatura', 601.0000, 'ºC'),
	(22776, 111, '2015-01-15 00:08:54.000000', 'temperatura', 1012.0000, 'ºC'),
	(22777, 111, '2015-01-15 00:08:55.000000', 'temperatura', 860.0000, 'ºC'),
	(22778, 111, '2015-01-15 00:08:56.000000', 'temperatura', 63.0000, 'ºC'),
	(22779, 111, '2015-01-15 00:08:57.000000', 'temperatura', 135.0000, 'ºC'),
	(22780, 111, '2015-01-15 00:08:58.000000', 'temperatura', 485.0000, 'ºC'),
	(22781, 111, '2015-01-15 00:08:59.000000', 'temperatura', 822.0000, 'ºC'),
	(22782, 111, '2015-01-15 00:09:00.000000', 'temperatura', 253.0000, 'ºC'),
	(22783, 111, '2015-01-15 00:09:01.000000', 'temperatura', 2.0000, 'ºC'),
	(22784, 111, '2015-01-15 00:09:02.000000', 'temperatura', 453.0000, 'ºC'),
	(22785, 111, '2015-01-15 00:09:03.000000', 'temperatura', 1058.0000, 'ºC'),
	(22786, 111, '2015-01-15 00:09:04.000000', 'temperatura', 332.0000, 'ºC'),
	(22787, 111, '2015-01-15 00:09:05.000000', 'temperatura', 885.0000, 'ºC'),
	(22788, 111, '2015-01-15 00:09:06.000000', 'temperatura', 1031.0000, 'ºC'),
	(22789, 111, '2015-01-15 00:09:07.000000', 'temperatura', 102.0000, 'ºC'),
	(22790, 111, '2015-01-15 00:09:08.000000', 'temperatura', 1014.0000, 'ºC'),
	(22791, 111, '2015-01-15 00:09:09.000000', 'temperatura', 1167.0000, 'ºC'),
	(22792, 111, '2015-01-15 00:09:10.000000', 'temperatura', 392.0000, 'ºC'),
	(22793, 111, '2015-01-15 00:09:11.000000', 'temperatura', 862.0000, 'ºC'),
	(22794, 111, '2015-01-15 00:09:12.000000', 'temperatura', 733.0000, 'ºC'),
	(22795, 111, '2015-01-15 00:09:13.000000', 'temperatura', 1079.0000, 'ºC'),
	(22796, 111, '2015-01-15 00:09:14.000000', 'temperatura', 799.0000, 'ºC'),
	(22797, 111, '2015-01-15 00:09:15.000000', 'temperatura', 756.0000, 'ºC'),
	(22798, 111, '2015-01-15 00:09:16.000000', 'temperatura', 184.0000, 'ºC'),
	(22799, 111, '2015-01-15 00:09:17.000000', 'temperatura', 1051.0000, 'ºC'),
	(22800, 111, '2015-01-15 00:09:18.000000', 'temperatura', 1105.0000, 'ºC'),
	(22801, 111, '2015-01-15 00:09:19.000000', 'temperatura', 1171.0000, 'ºC'),
	(22802, 111, '2015-01-15 00:09:20.000000', 'temperatura', 141.0000, 'ºC'),
	(22803, 111, '2015-01-15 00:09:21.000000', 'temperatura', 792.0000, 'ºC'),
	(22804, 111, '2015-01-15 00:09:22.000000', 'temperatura', 1139.0000, 'ºC'),
	(22805, 111, '2015-01-15 00:09:23.000000', 'temperatura', 920.0000, 'ºC'),
	(22806, 111, '2015-01-15 00:09:24.000000', 'temperatura', 1184.0000, 'ºC'),
	(22807, 111, '2015-01-15 00:09:25.000000', 'temperatura', 758.0000, 'ºC'),
	(22808, 111, '2015-01-15 00:09:26.000000', 'temperatura', 240.0000, 'ºC'),
	(22809, 111, '2015-01-15 00:09:27.000000', 'temperatura', 126.0000, 'ºC'),
	(22810, 111, '2015-01-15 00:09:28.000000', 'temperatura', 1111.0000, 'ºC'),
	(22811, 111, '2015-01-15 00:09:29.000000', 'temperatura', 379.0000, 'ºC'),
	(22812, 111, '2015-01-15 00:09:30.000000', 'temperatura', 961.0000, 'ºC'),
	(22813, 111, '2015-01-15 00:09:31.000000', 'temperatura', 68.0000, 'ºC'),
	(22814, 111, '2015-01-15 00:09:32.000000', 'temperatura', 1057.0000, 'ºC'),
	(22815, 111, '2015-01-15 00:09:33.000000', 'temperatura', 281.0000, 'ºC'),
	(22816, 111, '2015-01-15 00:09:34.000000', 'temperatura', 636.0000, 'ºC'),
	(22817, 111, '2015-01-15 00:09:35.000000', 'temperatura', 1138.0000, 'ºC'),
	(22818, 111, '2015-01-15 00:09:36.000000', 'temperatura', 181.0000, 'ºC'),
	(22819, 111, '2015-01-15 00:09:37.000000', 'temperatura', 1091.0000, 'ºC'),
	(22820, 111, '2015-01-15 00:09:38.000000', 'temperatura', 112.0000, 'ºC'),
	(22821, 111, '2015-01-15 00:09:39.000000', 'temperatura', 887.0000, 'ºC'),
	(22822, 111, '2015-01-15 00:09:40.000000', 'temperatura', 500.0000, 'ºC'),
	(22823, 111, '2015-01-15 00:09:41.000000', 'temperatura', 1040.0000, 'ºC'),
	(22824, 111, '2015-01-15 00:09:42.000000', 'temperatura', 102.0000, 'ºC'),
	(22825, 111, '2015-01-15 00:09:43.000000', 'temperatura', 988.0000, 'ºC'),
	(22826, 111, '2015-01-15 00:09:44.000000', 'temperatura', 1037.0000, 'ºC'),
	(22827, 111, '2015-01-15 00:09:45.000000', 'temperatura', 1022.0000, 'ºC'),
	(22828, 111, '2015-01-15 00:09:46.000000', 'temperatura', 798.0000, 'ºC'),
	(22829, 111, '2015-01-15 00:09:47.000000', 'temperatura', 924.0000, 'ºC'),
	(22830, 111, '2015-01-15 00:09:48.000000', 'temperatura', 1028.0000, 'ºC'),
	(22831, 111, '2015-01-15 00:09:49.000000', 'temperatura', 1166.0000, 'ºC'),
	(22832, 111, '2015-01-15 00:09:50.000000', 'temperatura', 348.0000, 'ºC'),
	(22833, 111, '2015-01-15 00:09:51.000000', 'temperatura', 643.0000, 'ºC'),
	(22834, 111, '2015-01-15 00:09:52.000000', 'temperatura', 972.0000, 'ºC'),
	(22835, 111, '2015-01-15 00:09:53.000000', 'temperatura', 533.0000, 'ºC'),
	(22836, 111, '2015-01-15 00:09:54.000000', 'temperatura', 947.0000, 'ºC'),
	(22837, 111, '2015-01-15 00:09:55.000000', 'temperatura', 738.0000, 'ºC'),
	(22838, 111, '2015-01-15 00:09:56.000000', 'temperatura', 848.0000, 'ºC'),
	(22839, 111, '2015-01-15 00:09:57.000000', 'temperatura', 826.0000, 'ºC'),
	(22840, 111, '2015-01-15 00:09:58.000000', 'temperatura', 386.0000, 'ºC'),
	(22841, 111, '2015-01-15 00:09:59.000000', 'temperatura', 653.0000, 'ºC'),
	(22842, 111, '2015-01-15 00:10:00.000000', 'temperatura', 909.0000, 'ºC'),
	(22843, 111, '2015-01-15 00:10:01.000000', 'temperatura', 184.0000, 'ºC'),
	(22844, 111, '2015-01-15 00:10:02.000000', 'temperatura', 597.0000, 'ºC'),
	(22845, 111, '2015-01-15 00:10:03.000000', 'temperatura', 30.0000, 'ºC'),
	(22846, 111, '2015-01-15 00:10:04.000000', 'temperatura', 760.0000, 'ºC'),
	(22847, 111, '2015-01-15 00:10:05.000000', 'temperatura', 111.0000, 'ºC'),
	(22848, 111, '2015-01-15 00:10:06.000000', 'temperatura', 676.0000, 'ºC'),
	(22849, 111, '2015-01-15 00:10:07.000000', 'temperatura', 646.0000, 'ºC'),
	(22850, 111, '2015-01-15 00:10:08.000000', 'temperatura', 5.0000, 'ºC'),
	(22851, 111, '2015-01-15 00:10:09.000000', 'temperatura', 486.0000, 'ºC'),
	(22852, 111, '2015-01-15 00:10:10.000000', 'temperatura', 16.0000, 'ºC'),
	(22853, 111, '2015-01-15 00:10:11.000000', 'temperatura', 1021.0000, 'ºC'),
	(22854, 111, '2015-01-15 00:10:12.000000', 'temperatura', 257.0000, 'ºC'),
	(22855, 111, '2015-01-15 00:10:13.000000', 'temperatura', 622.0000, 'ºC'),
	(22856, 111, '2015-01-15 00:10:14.000000', 'temperatura', 1141.0000, 'ºC'),
	(22857, 111, '2015-01-15 00:10:15.000000', 'temperatura', 241.0000, 'ºC'),
	(22858, 111, '2015-01-15 00:10:16.000000', 'temperatura', 182.0000, 'ºC'),
	(22859, 111, '2015-01-15 00:10:17.000000', 'temperatura', 188.0000, 'ºC'),
	(22860, 111, '2015-01-15 00:10:18.000000', 'temperatura', 394.0000, 'ºC'),
	(22861, 111, '2015-01-15 00:10:19.000000', 'temperatura', 208.0000, 'ºC'),
	(22862, 111, '2015-01-15 00:10:20.000000', 'temperatura', 1059.0000, 'ºC'),
	(22863, 111, '2015-01-15 00:10:21.000000', 'temperatura', 1071.0000, 'ºC'),
	(22864, 111, '2015-01-15 00:10:22.000000', 'temperatura', 977.0000, 'ºC'),
	(22865, 111, '2015-01-15 00:10:23.000000', 'temperatura', 473.0000, 'ºC'),
	(22866, 111, '2015-01-15 00:10:24.000000', 'temperatura', 636.0000, 'ºC'),
	(22867, 111, '2015-01-15 00:10:25.000000', 'temperatura', 561.0000, 'ºC'),
	(22868, 111, '2015-01-15 00:10:26.000000', 'temperatura', 899.0000, 'ºC'),
	(22869, 111, '2015-01-15 00:10:27.000000', 'temperatura', 412.0000, 'ºC'),
	(22870, 111, '2015-01-15 00:10:28.000000', 'temperatura', 561.0000, 'ºC'),
	(22871, 111, '2015-01-15 00:10:29.000000', 'temperatura', 371.0000, 'ºC'),
	(22872, 111, '2015-01-15 00:10:30.000000', 'temperatura', 174.0000, 'ºC'),
	(22873, 111, '2015-01-15 00:10:31.000000', 'temperatura', 955.0000, 'ºC'),
	(22874, 111, '2015-01-15 00:10:32.000000', 'temperatura', 654.0000, 'ºC'),
	(22875, 111, '2015-01-15 00:10:33.000000', 'temperatura', 405.0000, 'ºC'),
	(22876, 111, '2015-01-15 00:10:34.000000', 'temperatura', 66.0000, 'ºC'),
	(22877, 111, '2015-01-15 00:10:35.000000', 'temperatura', 313.0000, 'ºC'),
	(22878, 111, '2015-01-15 00:10:36.000000', 'temperatura', 170.0000, 'ºC'),
	(22879, 111, '2015-01-15 00:10:37.000000', 'temperatura', 1109.0000, 'ºC'),
	(22880, 111, '2015-01-15 00:10:38.000000', 'temperatura', 237.0000, 'ºC'),
	(22881, 111, '2015-01-15 00:10:39.000000', 'temperatura', 259.0000, 'ºC'),
	(22882, 111, '2015-01-15 00:10:40.000000', 'temperatura', 586.0000, 'ºC'),
	(22883, 111, '2015-01-15 00:10:41.000000', 'temperatura', 951.0000, 'ºC'),
	(22884, 111, '2015-01-15 00:10:42.000000', 'temperatura', 598.0000, 'ºC'),
	(22885, 111, '2015-01-15 00:10:43.000000', 'temperatura', 139.0000, 'ºC'),
	(22886, 111, '2015-01-15 00:10:44.000000', 'temperatura', 102.0000, 'ºC'),
	(22887, 111, '2015-01-15 00:10:45.000000', 'temperatura', 94.0000, 'ºC'),
	(22888, 111, '2015-01-15 00:10:46.000000', 'temperatura', 165.0000, 'ºC'),
	(22889, 111, '2015-01-15 00:10:47.000000', 'temperatura', 543.0000, 'ºC'),
	(22890, 111, '2015-01-15 00:10:48.000000', 'temperatura', 1018.0000, 'ºC'),
	(22891, 111, '2015-01-15 00:10:49.000000', 'temperatura', 1064.0000, 'ºC'),
	(22892, 111, '2015-01-15 00:10:50.000000', 'temperatura', 1065.0000, 'ºC'),
	(22893, 111, '2015-01-15 00:10:51.000000', 'temperatura', 934.0000, 'ºC'),
	(22894, 111, '2015-01-15 00:10:52.000000', 'temperatura', 274.0000, 'ºC'),
	(22895, 111, '2015-01-15 00:10:53.000000', 'temperatura', 970.0000, 'ºC'),
	(22896, 111, '2015-01-15 00:10:54.000000', 'temperatura', 428.0000, 'ºC'),
	(22897, 111, '2015-01-15 00:10:55.000000', 'temperatura', 429.0000, 'ºC'),
	(22898, 111, '2015-01-15 00:10:56.000000', 'temperatura', 864.0000, 'ºC'),
	(22899, 111, '2015-01-15 00:10:57.000000', 'temperatura', 631.0000, 'ºC'),
	(22900, 111, '2015-01-15 00:10:58.000000', 'temperatura', 565.0000, 'ºC'),
	(22901, 111, '2015-01-15 00:10:59.000000', 'temperatura', 932.0000, 'ºC'),
	(22902, 111, '2015-01-15 00:11:00.000000', 'temperatura', 566.0000, 'ºC'),
	(22903, 111, '2015-01-15 00:11:01.000000', 'temperatura', 36.0000, 'ºC'),
	(22904, 111, '2015-01-15 00:11:02.000000', 'temperatura', 882.0000, 'ºC'),
	(22905, 111, '2015-01-15 00:11:03.000000', 'temperatura', 704.0000, 'ºC'),
	(22906, 111, '2015-01-15 00:11:04.000000', 'temperatura', 873.0000, 'ºC'),
	(22907, 111, '2015-01-15 00:11:05.000000', 'temperatura', 1055.0000, 'ºC'),
	(22908, 111, '2015-01-15 00:11:06.000000', 'temperatura', 255.0000, 'ºC'),
	(22909, 111, '2015-01-15 00:11:07.000000', 'temperatura', 513.0000, 'ºC'),
	(22910, 111, '2015-01-15 00:11:08.000000', 'temperatura', 599.0000, 'ºC'),
	(22911, 111, '2015-01-15 00:11:09.000000', 'temperatura', 254.0000, 'ºC'),
	(22912, 111, '2015-01-15 00:11:10.000000', 'temperatura', 677.0000, 'ºC'),
	(22913, 111, '2015-01-15 00:11:11.000000', 'temperatura', 222.0000, 'ºC'),
	(22914, 111, '2015-01-15 00:11:12.000000', 'temperatura', 279.0000, 'ºC'),
	(22915, 111, '2015-01-15 00:11:13.000000', 'temperatura', 729.0000, 'ºC'),
	(22916, 111, '2015-01-15 00:11:14.000000', 'temperatura', 409.0000, 'ºC'),
	(22917, 111, '2015-01-15 00:11:15.000000', 'temperatura', 1059.0000, 'ºC'),
	(22918, 111, '2015-01-15 00:11:16.000000', 'temperatura', 468.0000, 'ºC'),
	(22919, 111, '2015-01-15 00:11:17.000000', 'temperatura', 362.0000, 'ºC'),
	(22920, 111, '2015-01-15 00:11:18.000000', 'temperatura', 406.0000, 'ºC'),
	(22921, 111, '2015-01-15 00:11:19.000000', 'temperatura', 946.0000, 'ºC'),
	(22922, 111, '2015-01-15 00:11:20.000000', 'temperatura', 1114.0000, 'ºC'),
	(22923, 111, '2015-01-15 00:11:21.000000', 'temperatura', 331.0000, 'ºC'),
	(22924, 111, '2015-01-15 00:11:22.000000', 'temperatura', 716.0000, 'ºC'),
	(22925, 111, '2015-01-15 00:11:23.000000', 'temperatura', 184.0000, 'ºC'),
	(22926, 111, '2015-01-15 00:11:24.000000', 'temperatura', 1174.0000, 'ºC'),
	(22927, 111, '2015-01-15 00:11:25.000000', 'temperatura', 518.0000, 'ºC'),
	(22928, 111, '2015-01-15 00:11:26.000000', 'temperatura', 270.0000, 'ºC'),
	(22929, 111, '2015-01-15 00:11:27.000000', 'temperatura', 994.0000, 'ºC'),
	(22930, 111, '2015-01-15 00:11:28.000000', 'temperatura', 562.0000, 'ºC'),
	(22931, 111, '2015-01-15 00:11:29.000000', 'temperatura', 1028.0000, 'ºC'),
	(22932, 111, '2015-01-15 00:11:30.000000', 'temperatura', 1056.0000, 'ºC'),
	(22933, 111, '2015-01-15 00:11:31.000000', 'temperatura', 995.0000, 'ºC'),
	(22934, 111, '2015-01-15 00:11:32.000000', 'temperatura', 608.0000, 'ºC'),
	(22935, 111, '2015-01-15 00:11:33.000000', 'temperatura', 54.0000, 'ºC'),
	(22936, 111, '2015-01-15 00:11:34.000000', 'temperatura', 849.0000, 'ºC'),
	(22937, 111, '2015-01-15 00:11:35.000000', 'temperatura', 481.0000, 'ºC'),
	(22938, 111, '2015-01-15 00:11:36.000000', 'temperatura', 1060.0000, 'ºC'),
	(22939, 111, '2015-01-15 00:11:37.000000', 'temperatura', 258.0000, 'ºC'),
	(22940, 111, '2015-01-15 00:11:38.000000', 'temperatura', 508.0000, 'ºC'),
	(22941, 111, '2015-01-15 00:11:39.000000', 'temperatura', 568.0000, 'ºC'),
	(22942, 111, '2015-01-15 00:11:40.000000', 'temperatura', 117.0000, 'ºC'),
	(22943, 111, '2015-01-15 00:11:41.000000', 'temperatura', 79.0000, 'ºC'),
	(22944, 111, '2015-01-15 00:11:42.000000', 'temperatura', 47.0000, 'ºC'),
	(22945, 111, '2015-01-15 00:11:43.000000', 'temperatura', 1198.0000, 'ºC'),
	(22946, 111, '2015-01-15 00:11:44.000000', 'temperatura', 1048.0000, 'ºC'),
	(22947, 111, '2015-01-15 00:11:45.000000', 'temperatura', 446.0000, 'ºC'),
	(22948, 111, '2015-01-15 00:11:46.000000', 'temperatura', 289.0000, 'ºC'),
	(22949, 111, '2015-01-15 00:11:47.000000', 'temperatura', 109.0000, 'ºC'),
	(22950, 111, '2015-01-15 00:11:48.000000', 'temperatura', 875.0000, 'ºC'),
	(22951, 111, '2015-01-15 00:11:49.000000', 'temperatura', 448.0000, 'ºC'),
	(22952, 111, '2015-01-15 00:11:50.000000', 'temperatura', 817.0000, 'ºC'),
	(22953, 111, '2015-01-15 00:11:51.000000', 'temperatura', 342.0000, 'ºC'),
	(22954, 111, '2015-01-15 00:11:52.000000', 'temperatura', 457.0000, 'ºC'),
	(22955, 111, '2015-01-15 00:11:53.000000', 'temperatura', 61.0000, 'ºC'),
	(22956, 111, '2015-01-15 00:11:54.000000', 'temperatura', 136.0000, 'ºC'),
	(22957, 111, '2015-01-15 00:11:55.000000', 'temperatura', 495.0000, 'ºC'),
	(22958, 111, '2015-01-15 00:11:56.000000', 'temperatura', 869.0000, 'ºC'),
	(22959, 111, '2015-01-15 00:11:57.000000', 'temperatura', 462.0000, 'ºC'),
	(22960, 111, '2015-01-15 00:11:58.000000', 'temperatura', 903.0000, 'ºC'),
	(22961, 111, '2015-01-15 00:11:59.000000', 'temperatura', 728.0000, 'ºC'),
	(22962, 111, '2015-01-15 00:12:00.000000', 'temperatura', 931.0000, 'ºC'),
	(22963, 111, '2015-01-15 00:12:01.000000', 'temperatura', 72.0000, 'ºC'),
	(22964, 111, '2015-01-15 00:12:02.000000', 'temperatura', 1167.0000, 'ºC'),
	(22965, 111, '2015-01-15 00:12:03.000000', 'temperatura', 820.0000, 'ºC'),
	(22966, 111, '2015-01-15 00:12:04.000000', 'temperatura', 600.0000, 'ºC'),
	(22967, 111, '2015-01-15 00:12:05.000000', 'temperatura', 540.0000, 'ºC'),
	(22968, 111, '2015-01-15 00:12:06.000000', 'temperatura', 901.0000, 'ºC'),
	(22969, 111, '2015-01-15 00:12:07.000000', 'temperatura', 484.0000, 'ºC'),
	(22970, 111, '2015-01-15 00:12:08.000000', 'temperatura', 918.0000, 'ºC'),
	(22971, 111, '2015-01-15 00:12:09.000000', 'temperatura', 740.0000, 'ºC'),
	(22972, 111, '2015-01-15 00:12:10.000000', 'temperatura', 945.0000, 'ºC'),
	(22973, 111, '2015-01-15 00:12:11.000000', 'temperatura', 106.0000, 'ºC'),
	(22974, 111, '2015-01-15 00:12:12.000000', 'temperatura', 96.0000, 'ºC'),
	(22975, 111, '2015-01-15 00:12:13.000000', 'temperatura', 163.0000, 'ºC'),
	(22976, 111, '2015-01-15 00:12:14.000000', 'temperatura', 527.0000, 'ºC'),
	(22977, 111, '2015-01-15 00:12:15.000000', 'temperatura', 947.0000, 'ºC'),
	(22978, 111, '2015-01-15 00:12:16.000000', 'temperatura', 756.0000, 'ºC'),
	(22979, 111, '2015-01-15 00:12:17.000000', 'temperatura', 937.0000, 'ºC'),
	(22980, 111, '2015-01-15 00:12:18.000000', 'temperatura', 17.0000, 'ºC'),
	(22981, 111, '2015-01-15 00:12:19.000000', 'temperatura', 874.0000, 'ºC'),
	(22982, 111, '2015-01-15 00:12:20.000000', 'temperatura', 720.0000, 'ºC'),
	(22983, 111, '2015-01-15 00:12:21.000000', 'temperatura', 980.0000, 'ºC'),
	(22984, 111, '2015-01-15 00:12:22.000000', 'temperatura', 338.0000, 'ºC'),
	(22985, 111, '2015-01-15 00:12:23.000000', 'temperatura', 1153.0000, 'ºC'),
	(22986, 111, '2015-01-15 00:12:24.000000', 'temperatura', 1149.0000, 'ºC'),
	(22987, 111, '2015-01-15 00:12:25.000000', 'temperatura', 1089.0000, 'ºC'),
	(22988, 111, '2015-01-15 00:12:26.000000', 'temperatura', 798.0000, 'ºC'),
	(22989, 111, '2015-01-15 00:12:27.000000', 'temperatura', 724.0000, 'ºC'),
	(22990, 111, '2015-01-15 00:12:28.000000', 'temperatura', 25.0000, 'ºC'),
	(22991, 111, '2015-01-15 00:12:29.000000', 'temperatura', 355.0000, 'ºC'),
	(22992, 111, '2015-01-15 00:12:30.000000', 'temperatura', 502.0000, 'ºC'),
	(22993, 111, '2015-01-15 00:12:31.000000', 'temperatura', 242.0000, 'ºC'),
	(22994, 111, '2015-01-15 00:12:32.000000', 'temperatura', 907.0000, 'ºC'),
	(22995, 111, '2015-01-15 00:12:33.000000', 'temperatura', 209.0000, 'ºC'),
	(22996, 111, '2015-01-15 00:12:34.000000', 'temperatura', 726.0000, 'ºC'),
	(22997, 111, '2015-01-15 00:12:35.000000', 'temperatura', 601.0000, 'ºC'),
	(22998, 111, '2015-01-15 00:12:36.000000', 'temperatura', 827.0000, 'ºC'),
	(22999, 111, '2015-01-15 00:12:37.000000', 'temperatura', 1136.0000, 'ºC'),
	(23000, 111, '2015-01-15 00:12:38.000000', 'temperatura', 796.0000, 'ºC'),
	(23001, 111, '2015-01-15 00:12:39.000000', 'temperatura', 573.0000, 'ºC'),
	(23002, 111, '2015-01-15 00:12:40.000000', 'temperatura', 477.0000, 'ºC'),
	(23003, 111, '2015-01-15 00:12:41.000000', 'temperatura', 668.0000, 'ºC'),
	(23004, 111, '2015-01-15 00:12:42.000000', 'temperatura', 710.0000, 'ºC'),
	(23005, 111, '2015-01-15 00:12:43.000000', 'temperatura', 345.0000, 'ºC'),
	(23006, 111, '2015-01-15 00:12:44.000000', 'temperatura', 794.0000, 'ºC'),
	(23007, 111, '2015-01-15 00:12:45.000000', 'temperatura', 538.0000, 'ºC'),
	(23008, 111, '2015-01-15 00:12:46.000000', 'temperatura', 307.0000, 'ºC'),
	(23009, 111, '2015-01-15 00:12:47.000000', 'temperatura', 1123.0000, 'ºC'),
	(23010, 111, '2015-01-15 00:12:48.000000', 'temperatura', 1093.0000, 'ºC'),
	(23011, 111, '2015-01-15 00:12:49.000000', 'temperatura', 899.0000, 'ºC'),
	(23012, 111, '2015-01-15 00:12:50.000000', 'temperatura', 14.0000, 'ºC'),
	(23013, 111, '2015-01-15 00:12:51.000000', 'temperatura', 976.0000, 'ºC'),
	(23014, 111, '2015-01-15 00:12:52.000000', 'temperatura', 35.0000, 'ºC'),
	(23015, 111, '2015-01-15 00:12:53.000000', 'temperatura', 850.0000, 'ºC'),
	(23016, 111, '2015-01-15 00:12:54.000000', 'temperatura', 547.0000, 'ºC'),
	(23017, 111, '2015-01-15 00:12:55.000000', 'temperatura', 182.0000, 'ºC'),
	(23018, 111, '2015-01-15 00:12:56.000000', 'temperatura', 471.0000, 'ºC'),
	(23019, 111, '2015-01-15 00:12:57.000000', 'temperatura', 609.0000, 'ºC'),
	(23020, 111, '2015-01-15 00:12:58.000000', 'temperatura', 434.0000, 'ºC'),
	(23021, 111, '2015-01-15 00:12:59.000000', 'temperatura', 343.0000, 'ºC'),
	(23022, 111, '2015-01-15 00:13:00.000000', 'temperatura', 412.0000, 'ºC'),
	(23023, 111, '2015-01-15 00:13:01.000000', 'temperatura', 1033.0000, 'ºC'),
	(23024, 111, '2015-01-15 00:13:02.000000', 'temperatura', 328.0000, 'ºC'),
	(23025, 111, '2015-01-15 00:13:03.000000', 'temperatura', 944.0000, 'ºC'),
	(23026, 111, '2015-01-15 00:13:04.000000', 'temperatura', 133.0000, 'ºC'),
	(23027, 111, '2015-01-15 00:13:05.000000', 'temperatura', 237.0000, 'ºC'),
	(23028, 111, '2015-01-15 00:13:06.000000', 'temperatura', 784.0000, 'ºC'),
	(23029, 111, '2015-01-15 00:13:07.000000', 'temperatura', 812.0000, 'ºC'),
	(23030, 111, '2015-01-15 00:13:08.000000', 'temperatura', 506.0000, 'ºC'),
	(23031, 111, '2015-01-15 00:13:09.000000', 'temperatura', 97.0000, 'ºC'),
	(23032, 111, '2015-01-15 00:13:10.000000', 'temperatura', 168.0000, 'ºC'),
	(23033, 111, '2015-01-15 00:13:11.000000', 'temperatura', 549.0000, 'ºC'),
	(23034, 111, '2015-01-15 00:13:12.000000', 'temperatura', 1042.0000, 'ºC'),
	(23035, 111, '2015-01-15 00:13:13.000000', 'temperatura', 1163.0000, 'ºC'),
	(23036, 111, '2015-01-15 00:13:14.000000', 'temperatura', 291.0000, 'ºC'),
	(23037, 111, '2015-01-15 00:13:15.000000', 'temperatura', 366.0000, 'ºC'),
	(23038, 111, '2015-01-15 00:13:16.000000', 'temperatura', 958.0000, 'ºC'),
	(23039, 111, '2015-01-15 00:13:17.000000', 'temperatura', 92.0000, 'ºC'),
	(23040, 111, '2015-01-15 00:13:18.000000', 'temperatura', 1188.0000, 'ºC'),
	(23041, 111, '2015-01-15 00:13:19.000000', 'temperatura', 864.0000, 'ºC'),
	(23042, 111, '2015-01-15 00:13:20.000000', 'temperatura', 755.0000, 'ºC'),
	(23043, 111, '2015-01-15 00:13:21.000000', 'temperatura', 1184.0000, 'ºC'),
	(23044, 111, '2015-01-15 00:13:22.000000', 'temperatura', 55.0000, 'ºC'),
	(23045, 111, '2015-01-15 00:13:23.000000', 'temperatura', 323.0000, 'ºC'),
	(23046, 111, '2015-01-15 00:13:24.000000', 'temperatura', 252.0000, 'ºC'),
	(23047, 111, '2015-01-15 00:13:25.000000', 'temperatura', 293.0000, 'ºC'),
	(23048, 111, '2015-01-15 00:13:26.000000', 'temperatura', 708.0000, 'ºC'),
	(23049, 111, '2015-01-15 00:13:27.000000', 'temperatura', 259.0000, 'ºC'),
	(23050, 111, '2015-01-15 00:13:28.000000', 'temperatura', 375.0000, 'ºC'),
	(23051, 111, '2015-01-15 00:13:29.000000', 'temperatura', 1098.0000, 'ºC'),
	(23052, 111, '2015-01-15 00:13:30.000000', 'temperatura', 767.0000, 'ºC'),
	(23053, 111, '2015-01-15 00:13:31.000000', 'temperatura', 539.0000, 'ºC'),
	(23054, 111, '2015-01-15 00:13:32.000000', 'temperatura', 394.0000, 'ºC'),
	(23055, 111, '2015-01-15 00:13:33.000000', 'temperatura', 356.0000, 'ºC'),
	(23056, 111, '2015-01-15 00:13:34.000000', 'temperatura', 597.0000, 'ºC'),
	(23057, 111, '2015-01-15 00:13:35.000000', 'temperatura', 719.0000, 'ºC'),
	(23058, 111, '2015-01-15 00:13:36.000000', 'temperatura', 606.0000, 'ºC'),
	(23059, 111, '2015-01-15 00:13:37.000000', 'temperatura', 870.0000, 'ºC'),
	(23060, 111, '2015-01-15 00:13:38.000000', 'temperatura', 135.0000, 'ºC'),
	(23061, 111, '2015-01-15 00:13:39.000000', 'temperatura', 465.0000, 'ºC'),
	(23062, 111, '2015-01-15 00:13:40.000000', 'temperatura', 722.0000, 'ºC'),
	(23063, 111, '2015-01-15 00:13:41.000000', 'temperatura', 1015.0000, 'ºC'),
	(23064, 111, '2015-01-15 00:13:42.000000', 'temperatura', 508.0000, 'ºC'),
	(23065, 111, '2015-01-15 00:13:43.000000', 'temperatura', 697.0000, 'ºC'),
	(23066, 111, '2015-01-15 00:13:44.000000', 'temperatura', 763.0000, 'ºC'),
	(23067, 111, '2015-01-15 00:13:45.000000', 'temperatura', 522.0000, 'ºC'),
	(23068, 111, '2015-01-15 00:13:46.000000', 'temperatura', 324.0000, 'ºC'),
	(23069, 111, '2015-01-15 00:13:47.000000', 'temperatura', 55.0000, 'ºC'),
	(23070, 111, '2015-01-15 00:13:48.000000', 'temperatura', 501.0000, 'ºC'),
	(23071, 111, '2015-01-15 00:13:49.000000', 'temperatura', 1140.0000, 'ºC'),
	(23072, 111, '2015-01-15 00:13:50.000000', 'temperatura', 598.0000, 'ºC'),
	(23073, 111, '2015-01-15 00:13:51.000000', 'temperatura', 771.0000, 'ºC'),
	(23074, 111, '2015-01-15 00:13:52.000000', 'temperatura', 860.0000, 'ºC'),
	(23075, 111, '2015-01-15 00:13:53.000000', 'temperatura', 789.0000, 'ºC'),
	(23076, 111, '2015-01-15 00:13:54.000000', 'temperatura', 166.0000, 'ºC'),
	(23077, 111, '2015-01-15 00:13:55.000000', 'temperatura', 862.0000, 'ºC'),
	(23078, 111, '2015-01-15 00:13:56.000000', 'temperatura', 212.0000, 'ºC'),
	(23079, 111, '2015-01-15 00:13:57.000000', 'temperatura', 875.0000, 'ºC'),
	(23080, 111, '2015-01-15 00:13:58.000000', 'temperatura', 139.0000, 'ºC'),
	(23081, 111, '2015-01-15 00:13:59.000000', 'temperatura', 472.0000, 'ºC'),
	(23082, 111, '2015-01-15 00:14:00.000000', 'temperatura', 741.0000, 'ºC'),
	(23083, 111, '2015-01-15 00:14:01.000000', 'temperatura', 1089.0000, 'ºC'),
	(23084, 111, '2015-01-15 00:14:02.000000', 'temperatura', 825.0000, 'ºC'),
	(23085, 111, '2015-01-15 00:14:03.000000', 'temperatura', 856.0000, 'ºC'),
	(23086, 111, '2015-01-15 00:14:04.000000', 'temperatura', 609.0000, 'ºC'),
	(23087, 111, '2015-01-15 00:14:05.000000', 'temperatura', 475.0000, 'ºC'),
	(23088, 111, '2015-01-15 00:14:06.000000', 'temperatura', 548.0000, 'ºC'),
	(23089, 111, '2015-01-15 00:14:07.000000', 'temperatura', 117.0000, 'ºC'),
	(23090, 111, '2015-01-15 00:14:08.000000', 'temperatura', 140.0000, 'ºC'),
	(23091, 111, '2015-01-15 00:14:09.000000', 'temperatura', 349.0000, 'ºC'),
	(23092, 111, '2015-01-15 00:14:10.000000', 'temperatura', 128.0000, 'ºC'),
	(23093, 111, '2015-01-15 00:14:11.000000', 'temperatura', 792.0000, 'ºC'),
	(23094, 111, '2015-01-15 00:14:12.000000', 'temperatura', 1176.0000, 'ºC'),
	(23095, 111, '2015-01-15 00:14:13.000000', 'temperatura', 1103.0000, 'ºC'),
	(23096, 111, '2015-01-15 00:14:14.000000', 'temperatura', 789.0000, 'ºC'),
	(23097, 111, '2015-01-15 00:14:15.000000', 'temperatura', 637.0000, 'ºC'),
	(23098, 111, '2015-01-15 00:14:16.000000', 'temperatura', 819.0000, 'ºC'),
	(23099, 111, '2015-01-15 00:14:17.000000', 'temperatura', 983.0000, 'ºC'),
	(23100, 111, '2015-01-15 00:14:18.000000', 'temperatura', 58.0000, 'ºC'),
	(23101, 111, '2015-01-15 00:14:19.000000', 'temperatura', 944.0000, 'ºC'),
	(23102, 111, '2015-01-15 00:14:20.000000', 'temperatura', 945.0000, 'ºC'),
	(23103, 111, '2015-01-15 00:14:21.000000', 'temperatura', 695.0000, 'ºC'),
	(23104, 111, '2015-01-15 00:14:22.000000', 'temperatura', 642.0000, 'ºC'),
	(23105, 111, '2015-01-15 00:14:23.000000', 'temperatura', 1123.0000, 'ºC'),
	(23106, 111, '2015-01-15 00:14:24.000000', 'temperatura', 88.0000, 'ºC'),
	(23107, 111, '2015-01-15 00:14:25.000000', 'temperatura', 673.0000, 'ºC'),
	(23108, 111, '2015-01-15 00:14:26.000000', 'temperatura', 702.0000, 'ºC'),
	(23109, 111, '2015-01-15 00:14:27.000000', 'temperatura', 290.0000, 'ºC'),
	(23110, 111, '2015-01-15 00:14:28.000000', 'temperatura', 544.0000, 'ºC'),
	(23111, 111, '2015-01-15 00:14:29.000000', 'temperatura', 650.0000, 'ºC'),
	(23112, 111, '2015-01-15 00:14:30.000000', 'temperatura', 419.0000, 'ºC'),
	(23113, 111, '2015-01-15 00:14:31.000000', 'temperatura', 144.0000, 'ºC'),
	(23114, 111, '2015-01-15 00:14:32.000000', 'temperatura', 667.0000, 'ºC'),
	(23115, 111, '2015-01-15 00:14:33.000000', 'temperatura', 502.0000, 'ºC'),
	(23116, 111, '2015-01-15 00:14:34.000000', 'temperatura', 507.0000, 'ºC'),
	(23117, 111, '2015-01-15 00:14:35.000000', 'temperatura', 1033.0000, 'ºC'),
	(23118, 111, '2015-01-15 00:14:36.000000', 'temperatura', 43.0000, 'ºC'),
	(23119, 111, '2015-01-15 00:14:37.000000', 'temperatura', 716.0000, 'ºC'),
	(23120, 111, '2015-01-15 00:14:38.000000', 'temperatura', 1052.0000, 'ºC'),
	(23121, 111, '2015-01-15 00:14:39.000000', 'temperatura', 713.0000, 'ºC'),
	(23122, 111, '2015-01-15 00:14:40.000000', 'temperatura', 410.0000, 'ºC'),
	(23123, 111, '2015-01-15 00:14:41.000000', 'temperatura', 1111.0000, 'ºC'),
	(23124, 111, '2015-01-15 00:14:42.000000', 'temperatura', 724.0000, 'ºC'),
	(23125, 111, '2015-01-15 00:14:43.000000', 'temperatura', 287.0000, 'ºC'),
	(23126, 111, '2015-01-15 00:14:44.000000', 'temperatura', 466.0000, 'ºC'),
	(23127, 111, '2015-01-15 00:14:45.000000', 'temperatura', 269.0000, 'ºC'),
	(23128, 111, '2015-01-15 00:14:46.000000', 'temperatura', 1147.0000, 'ºC'),
	(23129, 111, '2015-01-15 00:14:47.000000', 'temperatura', 127.0000, 'ºC'),
	(23130, 111, '2015-01-15 00:14:48.000000', 'temperatura', 795.0000, 'ºC'),
	(23131, 111, '2015-01-15 00:14:49.000000', 'temperatura', 1196.0000, 'ºC'),
	(23132, 111, '2015-01-15 00:14:50.000000', 'temperatura', 1196.0000, 'ºC'),
	(23133, 111, '2015-01-15 00:14:51.000000', 'temperatura', 1191.0000, 'ºC'),
	(23134, 111, '2015-01-15 00:14:52.000000', 'temperatura', 1169.0000, 'ºC'),
	(23135, 111, '2015-01-15 00:14:53.000000', 'temperatura', 1071.0000, 'ºC'),
	(23136, 111, '2015-01-15 00:14:54.000000', 'temperatura', 650.0000, 'ºC'),
	(23137, 111, '2015-01-15 00:14:55.000000', 'temperatura', 38.0000, 'ºC'),
	(23138, 111, '2015-01-15 00:14:56.000000', 'temperatura', 641.0000, 'ºC'),
	(23139, 111, '2015-01-15 00:14:57.000000', 'temperatura', 688.0000, 'ºC'),
	(23140, 111, '2015-01-15 00:14:58.000000', 'temperatura', 321.0000, 'ºC'),
	(23141, 111, '2015-01-15 00:14:59.000000', 'temperatura', 742.0000, 'ºC'),
	(23142, 111, '2015-01-15 00:15:00.000000', 'temperatura', 345.0000, 'ºC'),
	(23143, 111, '2015-01-15 00:15:01.000000', 'temperatura', 699.0000, 'ºC'),
	(23144, 111, '2015-01-15 00:15:02.000000', 'temperatura', 63.0000, 'ºC'),
	(23145, 111, '2015-01-15 00:15:03.000000', 'temperatura', 619.0000, 'ºC'),
	(23146, 111, '2015-01-15 00:15:04.000000', 'temperatura', 506.0000, 'ºC'),
	(23147, 111, '2015-01-15 00:15:05.000000', 'temperatura', 672.0000, 'ºC'),
	(23148, 111, '2015-01-15 00:15:06.000000', 'temperatura', 643.0000, 'ºC'),
	(23149, 111, '2015-01-15 00:15:07.000000', 'temperatura', 2.0000, 'ºC'),
	(23150, 111, '2015-01-15 00:15:08.000000', 'temperatura', 478.0000, 'ºC'),
	(23151, 111, '2015-01-15 00:15:09.000000', 'temperatura', 1188.0000, 'ºC'),
	(23152, 111, '2015-01-15 00:15:10.000000', 'temperatura', 904.0000, 'ºC'),
	(23153, 111, '2015-01-15 00:15:11.000000', 'temperatura', 957.0000, 'ºC'),
	(23154, 111, '2015-01-15 00:15:12.000000', 'temperatura', 876.0000, 'ºC'),
	(23155, 111, '2015-01-15 00:15:13.000000', 'temperatura', 307.0000, 'ºC'),
	(23156, 111, '2015-01-15 00:15:14.000000', 'temperatura', 108.0000, 'ºC'),
	(23157, 111, '2015-01-15 00:15:15.000000', 'temperatura', 817.0000, 'ºC'),
	(23158, 111, '2015-01-15 00:15:16.000000', 'temperatura', 165.0000, 'ºC'),
	(23159, 111, '2015-01-15 00:15:17.000000', 'temperatura', 775.0000, 'ºC'),
	(23160, 111, '2015-01-15 00:15:18.000000', 'temperatura', 978.0000, 'ºC'),
	(23161, 111, '2015-01-15 00:15:19.000000', 'temperatura', 168.0000, 'ºC'),
	(23162, 111, '2015-01-15 00:15:20.000000', 'temperatura', 306.0000, 'ºC'),
	(23163, 111, '2015-01-15 00:15:21.000000', 'temperatura', 1026.0000, 'ºC'),
	(23164, 111, '2015-01-15 00:15:22.000000', 'temperatura', 614.0000, 'ºC'),
	(23165, 111, '2015-01-15 00:15:23.000000', 'temperatura', 1193.0000, 'ºC'),
	(23166, 111, '2015-01-15 00:15:24.000000', 'temperatura', 524.0000, 'ºC'),
	(23167, 111, '2015-01-15 00:15:25.000000', 'temperatura', 239.0000, 'ºC'),
	(23168, 111, '2015-01-15 00:15:26.000000', 'temperatura', 824.0000, 'ºC'),
	(23169, 111, '2015-01-15 00:15:27.000000', 'temperatura', 1002.0000, 'ºC'),
	(23170, 111, '2015-01-15 00:15:28.000000', 'temperatura', 141.0000, 'ºC'),
	(23171, 111, '2015-01-15 00:15:29.000000', 'temperatura', 99.0000, 'ºC'),
	(23172, 111, '2015-01-15 00:15:30.000000', 'temperatura', 74.0000, 'ºC'),
	(23173, 111, '2015-01-15 00:15:31.000000', 'temperatura', 71.0000, 'ºC'),
	(23174, 111, '2015-01-15 00:15:32.000000', 'temperatura', 136.0000, 'ºC'),
	(23175, 111, '2015-01-15 00:15:33.000000', 'temperatura', 466.0000, 'ºC'),
	(23176, 111, '2015-01-15 00:15:34.000000', 'temperatura', 721.0000, 'ºC'),
	(23177, 111, '2015-01-15 00:15:35.000000', 'temperatura', 1008.0000, 'ºC'),
	(23178, 111, '2015-01-15 00:15:36.000000', 'temperatura', 479.0000, 'ºC'),
	(23179, 111, '2015-01-15 00:15:37.000000', 'temperatura', 573.0000, 'ºC'),
	(23180, 111, '2015-01-15 00:15:38.000000', 'temperatura', 226.0000, 'ºC'),
	(23181, 111, '2015-01-15 00:15:39.000000', 'temperatura', 612.0000, 'ºC'),
	(23182, 111, '2015-01-15 00:15:40.000000', 'temperatura', 1182.0000, 'ºC'),
	(23183, 111, '2015-01-15 00:15:41.000000', 'temperatura', 475.0000, 'ºC'),
	(23184, 111, '2015-01-15 00:15:42.000000', 'temperatura', 28.0000, 'ºC'),
	(23185, 111, '2015-01-15 00:15:43.000000', 'temperatura', 1117.0000, 'ºC'),
	(23186, 111, '2015-01-15 00:15:44.000000', 'temperatura', 703.0000, 'ºC'),
	(23187, 111, '2015-01-15 00:15:45.000000', 'temperatura', 163.0000, 'ºC'),
	(23188, 111, '2015-01-15 00:15:46.000000', 'temperatura', 1108.0000, 'ºC'),
	(23189, 111, '2015-01-15 00:15:47.000000', 'temperatura', 250.0000, 'ºC'),
	(23190, 111, '2015-01-15 00:15:48.000000', 'temperatura', 329.0000, 'ºC'),
	(23191, 111, '2015-01-15 00:15:49.000000', 'temperatura', 893.0000, 'ºC'),
	(23192, 111, '2015-01-15 00:15:50.000000', 'temperatura', 1079.0000, 'ºC'),
	(23193, 111, '2015-01-15 00:15:51.000000', 'temperatura', 315.0000, 'ºC'),
	(23194, 111, '2015-01-15 00:15:52.000000', 'temperatura', 739.0000, 'ºC'),
	(23195, 111, '2015-01-15 00:15:53.000000', 'temperatura', 353.0000, 'ºC'),
	(23196, 111, '2015-01-15 00:15:54.000000', 'temperatura', 748.0000, 'ºC'),
	(23197, 111, '2015-01-15 00:15:55.000000', 'temperatura', 279.0000, 'ºC'),
	(23198, 111, '2015-01-15 00:15:56.000000', 'temperatura', 352.0000, 'ºC'),
	(23199, 111, '2015-01-15 00:15:57.000000', 'temperatura', 924.0000, 'ºC'),
	(23200, 111, '2015-01-15 00:15:58.000000', 'temperatura', 1163.0000, 'ºC'),
	(23201, 111, '2015-01-15 00:15:59.000000', 'temperatura', 644.0000, 'ºC'),
	(23202, 111, '2015-01-15 00:16:00.000000', 'temperatura', 931.0000, 'ºC'),
	(23203, 111, '2015-01-15 00:16:01.000000', 'temperatura', 326.0000, 'ºC'),
	(23204, 111, '2015-01-15 00:16:02.000000', 'temperatura', 36.0000, 'ºC'),
	(23205, 111, '2015-01-15 00:16:03.000000', 'temperatura', 403.0000, 'ºC'),
	(23206, 111, '2015-01-15 00:16:04.000000', 'temperatura', 709.0000, 'ºC'),
	(23207, 111, '2015-01-15 00:16:05.000000', 'temperatura', 1136.0000, 'ºC'),
	(23208, 111, '2015-01-15 00:16:06.000000', 'temperatura', 1153.0000, 'ºC'),
	(23209, 111, '2015-01-15 00:16:07.000000', 'temperatura', 1160.0000, 'ºC'),
	(23210, 111, '2015-01-15 00:16:08.000000', 'temperatura', 1138.0000, 'ºC'),
	(23211, 111, '2015-01-15 00:16:09.000000', 'temperatura', 1013.0000, 'ºC'),
	(23212, 111, '2015-01-15 00:16:10.000000', 'temperatura', 449.0000, 'ºC'),
	(23213, 111, '2015-01-15 00:16:11.000000', 'temperatura', 408.0000, 'ºC'),
	(23214, 111, '2015-01-15 00:16:12.000000', 'temperatura', 694.0000, 'ºC'),
	(23215, 111, '2015-01-15 00:16:13.000000', 'temperatura', 1045.0000, 'ºC'),
	(23216, 111, '2015-01-15 00:16:14.000000', 'temperatura', 743.0000, 'ºC'),
	(23217, 111, '2015-01-15 00:16:15.000000', 'temperatura', 582.0000, 'ºC'),
	(23218, 111, '2015-01-15 00:16:16.000000', 'temperatura', 680.0000, 'ºC'),
	(23219, 111, '2015-01-15 00:16:17.000000', 'temperatura', 454.0000, 'ºC'),
	(23220, 111, '2015-01-15 00:16:18.000000', 'temperatura', 232.0000, 'ºC'),
	(23221, 111, '2015-01-15 00:16:19.000000', 'temperatura', 998.0000, 'ºC'),
	(23222, 111, '2015-01-15 00:16:20.000000', 'temperatura', 693.0000, 'ºC'),
	(23223, 111, '2015-01-15 00:16:21.000000', 'temperatura', 472.0000, 'ºC'),
	(23224, 111, '2015-01-15 00:16:22.000000', 'temperatura', 284.0000, 'ºC'),
	(23225, 111, '2015-01-15 00:16:23.000000', 'temperatura', 3.0000, 'ºC'),
	(23226, 111, '2015-01-15 00:16:24.000000', 'temperatura', 364.0000, 'ºC'),
	(23227, 111, '2015-01-15 00:16:25.000000', 'temperatura', 613.0000, 'ºC'),
	(23228, 111, '2015-01-15 00:16:26.000000', 'temperatura', 772.0000, 'ºC'),
	(23229, 111, '2015-01-15 00:16:27.000000', 'temperatura', 823.0000, 'ºC'),
	(23230, 111, '2015-01-15 00:16:28.000000', 'temperatura', 599.0000, 'ºC'),
	(23231, 111, '2015-01-15 00:16:29.000000', 'temperatura', 527.0000, 'ºC'),
	(23232, 111, '2015-01-15 00:16:30.000000', 'temperatura', 840.0000, 'ºC'),
	(23233, 111, '2015-01-15 00:16:31.000000', 'temperatura', 218.0000, 'ºC'),
	(23234, 111, '2015-01-15 00:16:32.000000', 'temperatura', 972.0000, 'ºC'),
	(23235, 111, '2015-01-15 00:16:33.000000', 'temperatura', 604.0000, 'ºC'),
	(23236, 111, '2015-01-15 00:16:34.000000', 'temperatura', 105.0000, 'ºC'),
	(23237, 111, '2015-01-15 00:16:35.000000', 'temperatura', 1115.0000, 'ºC'),
	(23238, 111, '2015-01-15 00:16:36.000000', 'temperatura', 460.0000, 'ºC'),
	(23239, 111, '2015-01-15 00:16:37.000000', 'temperatura', 155.0000, 'ºC'),
	(23240, 111, '2015-01-15 00:16:38.000000', 'temperatura', 595.0000, 'ºC'),
	(23241, 111, '2015-01-15 00:16:39.000000', 'temperatura', 113.0000, 'ºC'),
	(23242, 111, '2015-01-15 00:16:40.000000', 'temperatura', 1179.0000, 'ºC'),
	(23243, 111, '2015-01-15 00:16:41.000000', 'temperatura', 757.0000, 'ºC'),
	(23244, 111, '2015-01-15 00:16:42.000000', 'temperatura', 250.0000, 'ºC'),
	(23245, 111, '2015-01-15 00:16:43.000000', 'temperatura', 177.0000, 'ºC'),
	(23246, 111, '2015-01-15 00:16:44.000000', 'temperatura', 137.0000, 'ºC'),
	(23247, 111, '2015-01-15 00:16:45.000000', 'temperatura', 153.0000, 'ºC'),
	(23248, 111, '2015-01-15 00:16:46.000000', 'temperatura', 354.0000, 'ºC'),
	(23249, 111, '2015-01-15 00:16:47.000000', 'temperatura', 113.0000, 'ºC'),
	(23250, 111, '2015-01-15 00:16:48.000000', 'temperatura', 703.0000, 'ºC'),
	(23251, 111, '2015-01-15 00:16:49.000000', 'temperatura', 776.0000, 'ºC'),
	(23252, 111, '2015-01-15 00:16:50.000000', 'temperatura', 571.0000, 'ºC'),
	(23253, 111, '2015-01-15 00:16:51.000000', 'temperatura', 528.0000, 'ºC'),
	(23254, 111, '2015-01-15 00:16:52.000000', 'temperatura', 929.0000, 'ºC'),
	(23255, 111, '2015-01-15 00:16:53.000000', 'temperatura', 661.0000, 'ºC'),
	(23256, 111, '2015-01-15 00:16:54.000000', 'temperatura', 520.0000, 'ºC'),
	(23257, 111, '2015-01-15 00:16:55.000000', 'temperatura', 616.0000, 'ºC'),
	(23258, 111, '2015-01-15 00:16:56.000000', 'temperatura', 321.0000, 'ºC'),
	(23259, 111, '2015-01-15 00:16:57.000000', 'temperatura', 957.0000, 'ºC'),
	(23260, 111, '2015-01-15 00:16:58.000000', 'temperatura', 224.0000, 'ºC'),
	(23261, 111, '2015-01-15 00:16:59.000000', 'temperatura', 649.0000, 'ºC'),
	(23262, 111, '2015-01-15 00:17:00.000000', 'temperatura', 172.0000, 'ºC'),
	(23263, 111, '2015-01-15 00:17:01.000000', 'temperatura', 115.0000, 'ºC'),
	(23264, 111, '2015-01-15 00:17:02.000000', 'temperatura', 59.0000, 'ºC'),
	(23265, 111, '2015-01-15 00:17:03.000000', 'temperatura', 1149.0000, 'ºC'),
	(23266, 111, '2015-01-15 00:17:04.000000', 'temperatura', 769.0000, 'ºC'),
	(23267, 111, '2015-01-15 00:17:05.000000', 'temperatura', 400.0000, 'ºC'),
	(23268, 111, '2015-01-15 00:17:06.000000', 'temperatura', 891.0000, 'ºC'),
	(23269, 111, '2015-01-15 00:17:07.000000', 'temperatura', 858.0000, 'ºC'),
	(23270, 111, '2015-01-15 00:17:08.000000', 'temperatura', 417.0000, 'ºC'),
	(23271, 111, '2015-01-15 00:17:09.000000', 'temperatura', 711.0000, 'ºC'),
	(23272, 111, '2015-01-15 00:17:10.000000', 'temperatura', 1106.0000, 'ºC'),
	(23273, 111, '2015-01-15 00:17:11.000000', 'temperatura', 995.0000, 'ºC'),
	(23274, 111, '2015-01-15 00:17:12.000000', 'temperatura', 457.0000, 'ºC'),
	(23275, 111, '2015-01-15 00:17:13.000000', 'temperatura', 500.0000, 'ºC'),
	(23276, 111, '2015-01-15 00:17:14.000000', 'temperatura', 1130.0000, 'ºC'),
	(23277, 111, '2015-01-15 00:17:15.000000', 'temperatura', 551.0000, 'ºC'),
	(23278, 111, '2015-01-15 00:17:16.000000', 'temperatura', 566.0000, 'ºC'),
	(23279, 111, '2015-01-15 00:17:17.000000', 'temperatura', 1176.0000, 'ºC'),
	(23280, 111, '2015-01-15 00:17:18.000000', 'temperatura', 585.0000, 'ºC'),
	(23281, 111, '2015-01-15 00:17:19.000000', 'temperatura', 597.0000, 'ºC'),
	(23282, 111, '2015-01-15 00:17:20.000000', 'temperatura', 31.0000, 'ºC'),
	(23283, 111, '2015-01-15 00:17:21.000000', 'temperatura', 764.0000, 'ºC'),
	(23284, 111, '2015-01-15 00:17:22.000000', 'temperatura', 125.0000, 'ºC'),
	(23285, 111, '2015-01-15 00:17:23.000000', 'temperatura', 736.0000, 'ºC'),
	(23286, 111, '2015-01-15 00:17:24.000000', 'temperatura', 906.0000, 'ºC'),
	(23287, 111, '2015-01-15 00:17:25.000000', 'temperatura', 1124.0000, 'ºC'),
	(23288, 111, '2015-01-15 00:17:26.000000', 'temperatura', 500.0000, 'ºC'),
	(23289, 111, '2015-01-15 00:17:27.000000', 'temperatura', 329.0000, 'ºC'),
	(23290, 111, '2015-01-15 00:17:28.000000', 'temperatura', 144.0000, 'ºC'),
	(23291, 111, '2015-01-15 00:17:29.000000', 'temperatura', 933.0000, 'ºC'),
	(23292, 111, '2015-01-15 00:17:30.000000', 'temperatura', 635.0000, 'ºC'),
	(23293, 111, '2015-01-15 00:17:31.000000', 'temperatura', 377.0000, 'ºC'),
	(23294, 111, '2015-01-15 00:17:32.000000', 'temperatura', 1179.0000, 'ºC'),
	(23295, 111, '2015-01-15 00:17:33.000000', 'temperatura', 1163.0000, 'ºC'),
	(23296, 111, '2015-01-15 00:17:34.000000', 'temperatura', 1082.0000, 'ºC'),
	(23297, 111, '2015-01-15 00:17:35.000000', 'temperatura', 721.0000, 'ºC'),
	(23298, 111, '2015-01-15 00:17:36.000000', 'temperatura', 358.0000, 'ºC'),
	(23299, 111, '2015-01-15 00:17:37.000000', 'temperatura', 828.0000, 'ºC'),
	(23300, 111, '2015-01-15 00:17:38.000000', 'temperatura', 666.0000, 'ºC'),
	(23301, 111, '2015-01-15 00:17:39.000000', 'temperatura', 846.0000, 'ºC'),
	(23302, 111, '2015-01-15 00:17:40.000000', 'temperatura', 1033.0000, 'ºC'),
	(23303, 111, '2015-01-15 00:17:41.000000', 'temperatura', 226.0000, 'ºC'),
	(23304, 111, '2015-01-15 00:17:42.000000', 'temperatura', 431.0000, 'ºC'),
	(23305, 111, '2015-01-15 00:17:43.000000', 'temperatura', 280.0000, 'ºC'),
	(23306, 111, '2015-01-15 00:17:44.000000', 'temperatura', 107.0000, 'ºC'),
	(23307, 111, '2015-01-15 00:17:45.000000', 'temperatura', 894.0000, 'ºC'),
	(23308, 111, '2015-01-15 00:17:46.000000', 'temperatura', 551.0000, 'ºC'),
	(23309, 111, '2015-01-15 00:17:47.000000', 'temperatura', 73.0000, 'ºC'),
	(23310, 111, '2015-01-15 00:17:48.000000', 'temperatura', 1112.0000, 'ºC'),
	(23311, 111, '2015-01-15 00:17:49.000000', 'temperatura', 541.0000, 'ºC'),
	(23312, 111, '2015-01-15 00:17:50.000000', 'temperatura', 569.0000, 'ºC'),
	(23313, 111, '2015-01-15 00:17:51.000000', 'temperatura', 21.0000, 'ºC'),
	(23314, 111, '2015-01-15 00:17:52.000000', 'temperatura', 801.0000, 'ºC'),
	(23315, 111, '2015-01-15 00:17:53.000000', 'temperatura', 341.0000, 'ºC'),
	(23316, 111, '2015-01-15 00:17:54.000000', 'temperatura', 504.0000, 'ºC'),
	(23317, 111, '2015-01-15 00:17:55.000000', 'temperatura', 298.0000, 'ºC'),
	(23318, 111, '2015-01-15 00:17:56.000000', 'temperatura', 1179.0000, 'ºC'),
	(23319, 111, '2015-01-15 00:17:57.000000', 'temperatura', 199.0000, 'ºC'),
	(23320, 111, '2015-01-15 00:17:58.000000', 'temperatura', 1060.0000, 'ºC'),
	(23321, 111, '2015-01-15 00:17:59.000000', 'temperatura', 1101.0000, 'ºC'),
	(23322, 111, '2015-01-15 00:18:00.000000', 'temperatura', 1129.0000, 'ºC'),
	(23323, 111, '2015-01-15 00:18:01.000000', 'temperatura', 1140.0000, 'ºC'),
	(23324, 111, '2015-01-15 00:18:02.000000', 'temperatura', 1116.0000, 'ºC'),
	(23325, 111, '2015-01-15 00:18:03.000000', 'temperatura', 960.0000, 'ºC'),
	(23326, 111, '2015-01-15 00:18:04.000000', 'temperatura', 253.0000, 'ºC'),
	(23327, 111, '2015-01-15 00:18:05.000000', 'temperatura', 784.0000, 'ºC'),
	(23328, 111, '2015-01-15 00:18:06.000000', 'temperatura', 761.0000, 'ºC'),
	(23329, 111, '2015-01-15 00:18:07.000000', 'temperatura', 256.0000, 'ºC'),
	(23330, 111, '2015-01-15 00:18:08.000000', 'temperatura', 194.0000, 'ºC'),
	(23331, 111, '2015-01-15 00:18:09.000000', 'temperatura', 205.0000, 'ºC'),
	(23332, 111, '2015-01-15 00:18:10.000000', 'temperatura', 445.0000, 'ºC'),
	(23333, 111, '2015-01-15 00:18:11.000000', 'temperatura', 408.0000, 'ºC'),
	(23334, 111, '2015-01-15 00:18:12.000000', 'temperatura', 706.0000, 'ºC'),
	(23335, 111, '2015-01-15 00:18:13.000000', 'temperatura', 1107.0000, 'ºC'),
	(23336, 111, '2015-01-15 00:18:14.000000', 'temperatura', 1017.0000, 'ºC'),
	(23337, 111, '2015-01-15 00:18:15.000000', 'temperatura', 564.0000, 'ºC'),
	(23338, 111, '2015-01-15 00:18:16.000000', 'temperatura', 970.0000, 'ºC'),
	(23339, 111, '2015-01-15 00:18:17.000000', 'temperatura', 758.0000, 'ºC'),
	(23340, 111, '2015-01-15 00:18:18.000000', 'temperatura', 883.0000, 'ºC'),
	(23341, 111, '2015-01-15 00:18:19.000000', 'temperatura', 939.0000, 'ºC'),
	(23342, 111, '2015-01-15 00:18:20.000000', 'temperatura', 848.0000, 'ºC'),
	(23343, 111, '2015-01-15 00:18:21.000000', 'temperatura', 223.0000, 'ºC'),
	(23344, 111, '2015-01-15 00:18:22.000000', 'temperatura', 970.0000, 'ºC'),
	(23345, 111, '2015-01-15 00:18:23.000000', 'temperatura', 582.0000, 'ºC'),
	(23346, 111, '2015-01-15 00:18:24.000000', 'temperatura', 1199.0000, 'ºC'),
	(23347, 111, '2015-01-15 00:18:25.000000', 'temperatura', 650.0000, 'ºC'),
	(23348, 111, '2015-01-15 00:18:26.000000', 'temperatura', 852.0000, 'ºC'),
	(23349, 111, '2015-01-15 00:18:27.000000', 'temperatura', 1113.0000, 'ºC'),
	(23350, 111, '2015-01-15 00:18:28.000000', 'temperatura', 609.0000, 'ºC'),
	(23351, 111, '2015-01-15 00:18:29.000000', 'temperatura', 908.0000, 'ºC'),
	(23352, 111, '2015-01-15 00:18:30.000000', 'temperatura', 312.0000, 'ºC'),
	(23353, 111, '2015-01-15 00:18:31.000000', 'temperatura', 37.0000, 'ºC'),
	(23354, 111, '2015-01-15 00:18:32.000000', 'temperatura', 451.0000, 'ºC'),
	(23355, 111, '2015-01-15 00:18:33.000000', 'temperatura', 943.0000, 'ºC'),
	(23356, 111, '2015-01-15 00:18:34.000000', 'temperatura', 962.0000, 'ºC'),
	(23357, 111, '2015-01-15 00:18:35.000000', 'temperatura', 782.0000, 'ºC'),
	(23358, 111, '2015-01-15 00:18:36.000000', 'temperatura', 1027.0000, 'ºC'),
	(23359, 111, '2015-01-15 00:18:37.000000', 'temperatura', 386.0000, 'ºC'),
	(23360, 111, '2015-01-15 00:18:38.000000', 'temperatura', 51.0000, 'ºC'),
	(23361, 111, '2015-01-15 00:18:39.000000', 'temperatura', 297.0000, 'ºC'),
	(23362, 111, '2015-01-15 00:18:40.000000', 'temperatura', 133.0000, 'ºC'),
	(23363, 111, '2015-01-15 00:18:41.000000', 'temperatura', 973.0000, 'ºC'),
	(23364, 111, '2015-01-15 00:18:42.000000', 'temperatura', 870.0000, 'ºC'),
	(23365, 111, '2015-01-15 00:18:43.000000', 'temperatura', 228.0000, 'ºC'),
	(23366, 111, '2015-01-15 00:18:44.000000', 'temperatura', 931.0000, 'ºC'),
	(23367, 111, '2015-01-15 00:18:45.000000', 'temperatura', 370.0000, 'ºC'),
	(23368, 111, '2015-01-15 00:18:46.000000', 'temperatura', 261.0000, 'ºC'),
	(23369, 111, '2015-01-15 00:18:47.000000', 'temperatura', 192.0000, 'ºC'),
	(23370, 111, '2015-01-15 00:18:48.000000', 'temperatura', 180.0000, 'ºC'),
	(23371, 111, '2015-01-15 00:18:49.000000', 'temperatura', 323.0000, 'ºC'),
	(23372, 111, '2015-01-15 00:18:50.000000', 'temperatura', 1074.0000, 'ºC'),
	(23373, 111, '2015-01-15 00:18:51.000000', 'temperatura', 803.0000, 'ºC'),
	(23374, 111, '2015-01-15 00:18:52.000000', 'temperatura', 795.0000, 'ºC'),
	(23375, 111, '2015-01-15 00:18:53.000000', 'temperatura', 368.0000, 'ºC'),
	(23376, 111, '2015-01-15 00:18:54.000000', 'temperatura', 652.0000, 'ºC'),
	(23377, 111, '2015-01-15 00:18:55.000000', 'temperatura', 956.0000, 'ºC'),
	(23378, 111, '2015-01-15 00:18:56.000000', 'temperatura', 425.0000, 'ºC'),
	(23379, 111, '2015-01-15 00:18:57.000000', 'temperatura', 457.0000, 'ºC'),
	(23380, 111, '2015-01-15 00:18:58.000000', 'temperatura', 1012.0000, 'ºC'),
	(23381, 111, '2015-01-15 00:18:59.000000', 'temperatura', 89.0000, 'ºC'),
	(23382, 111, '2015-01-15 00:19:00.000000', 'temperatura', 1009.0000, 'ºC'),
	(23383, 111, '2015-01-15 00:19:01.000000', 'temperatura', 1179.0000, 'ºC'),
	(23384, 111, '2015-01-15 00:19:02.000000', 'temperatura', 470.0000, 'ºC'),
	(23385, 111, '2015-01-15 00:19:03.000000', 'temperatura', 12.0000, 'ºC'),
	(23386, 111, '2015-01-15 00:19:04.000000', 'temperatura', 1051.0000, 'ºC'),
	(23387, 111, '2015-01-15 00:19:05.000000', 'temperatura', 418.0000, 'ºC'),
	(23388, 111, '2015-01-15 00:19:06.000000', 'temperatura', 137.0000, 'ºC'),
	(23389, 111, '2015-01-15 00:19:07.000000', 'temperatura', 631.0000, 'ºC'),
	(23390, 111, '2015-01-15 00:19:08.000000', 'temperatura', 347.0000, 'ºC'),
	(23391, 111, '2015-01-15 00:19:09.000000', 'temperatura', 1042.0000, 'ºC'),
	(23392, 111, '2015-01-15 00:19:10.000000', 'temperatura', 568.0000, 'ºC'),
	(23393, 111, '2015-01-15 00:19:11.000000', 'temperatura', 913.0000, 'ºC'),
	(23394, 111, '2015-01-15 00:19:12.000000', 'temperatura', 464.0000, 'ºC'),
	(23395, 111, '2015-01-15 00:19:13.000000', 'temperatura', 782.0000, 'ºC'),
	(23396, 111, '2015-01-15 00:19:14.000000', 'temperatura', 119.0000, 'ºC'),
	(23397, 111, '2015-01-15 00:19:15.000000', 'temperatura', 649.0000, 'ºC'),
	(23398, 111, '2015-01-15 00:19:16.000000', 'temperatura', 488.0000, 'ºC'),
	(23399, 111, '2015-01-15 00:19:17.000000', 'temperatura', 494.0000, 'ºC'),
	(23400, 111, '2015-01-15 00:19:18.000000', 'temperatura', 1006.0000, 'ºC'),
	(23401, 111, '2015-01-15 00:19:19.000000', 'temperatura', 1151.0000, 'ºC'),
	(23402, 111, '2015-01-15 00:19:20.000000', 'temperatura', 334.0000, 'ºC'),
	(23403, 111, '2015-01-15 00:19:21.000000', 'temperatura', 620.0000, 'ºC'),
	(23404, 111, '2015-01-15 00:19:22.000000', 'temperatura', 899.0000, 'ºC'),
	(23405, 111, '2015-01-15 00:19:23.000000', 'temperatura', 236.0000, 'ºC'),
	(23406, 111, '2015-01-15 00:19:24.000000', 'temperatura', 883.0000, 'ºC'),
	(23407, 111, '2015-01-15 00:19:25.000000', 'temperatura', 109.0000, 'ºC'),
	(23408, 111, '2015-01-15 00:19:26.000000', 'temperatura', 297.0000, 'ºC'),
	(23409, 111, '2015-01-15 00:19:27.000000', 'temperatura', 1155.0000, 'ºC'),
	(23410, 111, '2015-01-15 00:19:28.000000', 'temperatura', 87.0000, 'ºC'),
	(23411, 111, '2015-01-15 00:19:29.000000', 'temperatura', 569.0000, 'ºC'),
	(23412, 111, '2015-01-15 00:19:30.000000', 'temperatura', 186.0000, 'ºC'),
	(23413, 111, '2015-01-15 00:19:31.000000', 'temperatura', 421.0000, 'ºC'),
	(23414, 111, '2015-01-15 00:19:32.000000', 'temperatura', 350.0000, 'ºC'),
	(23415, 111, '2015-01-15 00:19:33.000000', 'temperatura', 488.0000, 'ºC'),
	(23416, 111, '2015-01-15 00:19:34.000000', 'temperatura', 192.0000, 'ºC'),
	(23417, 111, '2015-01-15 00:19:35.000000', 'temperatura', 694.0000, 'ºC'),
	(23418, 111, '2015-01-15 00:19:36.000000', 'temperatura', 493.0000, 'ºC'),
	(23419, 111, '2015-01-15 00:19:37.000000', 'temperatura', 386.0000, 'ºC'),
	(23420, 111, '2015-01-15 00:19:38.000000', 'temperatura', 452.0000, 'ºC'),
	(23421, 111, '2015-01-15 00:19:39.000000', 'temperatura', 1100.0000, 'ºC'),
	(23422, 111, '2015-01-15 00:19:40.000000', 'temperatura', 546.0000, 'ºC'),
	(23423, 111, '2015-01-15 00:19:41.000000', 'temperatura', 632.0000, 'ºC'),
	(23424, 111, '2015-01-15 00:19:42.000000', 'temperatura', 320.0000, 'ºC'),
	(23425, 111, '2015-01-15 00:19:43.000000', 'temperatura', 905.0000, 'ºC'),
	(23426, 111, '2015-01-15 00:19:44.000000', 'temperatura', 1165.0000, 'ºC'),
	(23427, 111, '2015-01-15 00:19:45.000000', 'temperatura', 711.0000, 'ºC'),
	(23428, 111, '2015-01-15 00:19:46.000000', 'temperatura', 59.0000, 'ºC'),
	(23429, 111, '2015-01-15 00:19:47.000000', 'temperatura', 563.0000, 'ºC'),
	(23430, 111, '2015-01-15 00:19:48.000000', 'temperatura', 241.0000, 'ºC'),
	(23431, 111, '2015-01-15 00:19:49.000000', 'temperatura', 715.0000, 'ºC'),
	(23432, 111, '2015-01-15 00:19:50.000000', 'temperatura', 451.0000, 'ºC'),
	(23433, 111, '2015-01-15 00:19:51.000000', 'temperatura', 111.0000, 'ºC'),
	(23434, 111, '2015-01-15 00:19:52.000000', 'temperatura', 402.0000, 'ºC'),
	(23435, 111, '2015-01-15 00:19:53.000000', 'temperatura', 478.0000, 'ºC'),
	(23436, 111, '2015-01-15 00:19:54.000000', 'temperatura', 1186.0000, 'ºC'),
	(23437, 111, '2015-01-15 00:19:55.000000', 'temperatura', 895.0000, 'ºC'),
	(23438, 111, '2015-01-15 00:19:56.000000', 'temperatura', 917.0000, 'ºC'),
	(23439, 111, '2015-01-15 00:19:57.000000', 'temperatura', 701.0000, 'ºC'),
	(23440, 111, '2015-01-15 00:19:58.000000', 'temperatura', 753.0000, 'ºC'),
	(23441, 111, '2015-01-15 00:19:59.000000', 'temperatura', 463.0000, 'ºC'),
	(23442, 111, '2015-01-15 00:20:00.000000', 'temperatura', 56.0000, 'ºC'),
	(23443, 111, '2015-01-15 00:20:01.000000', 'temperatura', 94.0000, 'ºC'),
	(23444, 111, '2015-01-15 00:20:02.000000', 'temperatura', 301.0000, 'ºC'),
	(23445, 111, '2015-01-15 00:20:03.000000', 'temperatura', 22.0000, 'ºC'),
	(23446, 111, '2015-01-15 00:20:04.000000', 'temperatura', 409.0000, 'ºC'),
	(23447, 111, '2015-01-15 00:20:05.000000', 'temperatura', 781.0000, 'ºC'),
	(23448, 111, '2015-01-15 00:20:06.000000', 'temperatura', 275.0000, 'ºC'),
	(23449, 111, '2015-01-15 00:20:07.000000', 'temperatura', 235.0000, 'ºC'),
	(23450, 111, '2015-01-15 00:20:08.000000', 'temperatura', 348.0000, 'ºC'),
	(23451, 111, '2015-01-15 00:20:09.000000', 'temperatura', 1039.0000, 'ºC'),
	(23452, 111, '2015-01-15 00:20:10.000000', 'temperatura', 548.0000, 'ºC'),
	(23453, 111, '2015-01-15 00:20:11.000000', 'temperatura', 825.0000, 'ºC'),
	(23454, 111, '2015-01-15 00:20:12.000000', 'temperatura', 81.0000, 'ºC'),
	(23455, 111, '2015-01-15 00:20:13.000000', 'temperatura', 331.0000, 'ºC'),
	(23456, 111, '2015-01-15 00:20:14.000000', 'temperatura', 213.0000, 'ºC'),
	(23457, 111, '2015-01-15 00:20:15.000000', 'temperatura', 71.0000, 'ºC'),
	(23458, 111, '2015-01-15 00:20:16.000000', 'temperatura', 919.0000, 'ºC'),
	(23459, 111, '2015-01-15 00:20:17.000000', 'temperatura', 779.0000, 'ºC'),
	(23460, 111, '2015-01-15 00:20:18.000000', 'temperatura', 1142.0000, 'ºC'),
	(23461, 111, '2015-01-15 00:20:19.000000', 'temperatura', 973.0000, 'ºC'),
	(23462, 111, '2015-01-15 00:20:20.000000', 'temperatura', 239.0000, 'ºC'),
	(23463, 111, '2015-01-15 00:20:21.000000', 'temperatura', 677.0000, 'ºC'),
	(23464, 111, '2015-01-15 00:20:22.000000', 'temperatura', 269.0000, 'ºC'),
	(23465, 111, '2015-01-15 00:20:23.000000', 'temperatura', 512.0000, 'ºC'),
	(23466, 111, '2015-01-15 00:20:24.000000', 'temperatura', 556.0000, 'ºC'),
	(23467, 111, '2015-01-15 00:20:25.000000', 'temperatura', 45.0000, 'ºC'),
	(23468, 111, '2015-01-15 00:20:26.000000', 'temperatura', 957.0000, 'ºC'),
	(23469, 111, '2015-01-15 00:20:27.000000', 'temperatura', 1052.0000, 'ºC'),
	(23470, 111, '2015-01-15 00:20:28.000000', 'temperatura', 1186.0000, 'ºC'),
	(23471, 111, '2015-01-15 00:20:29.000000', 'temperatura', 377.0000, 'ºC'),
	(23472, 111, '2015-01-15 00:20:30.000000', 'temperatura', 727.0000, 'ºC'),
	(23473, 111, '2015-01-15 00:20:31.000000', 'temperatura', 106.0000, 'ºC'),
	(23474, 111, '2015-01-15 00:20:32.000000', 'temperatura', 747.0000, 'ºC'),
	(23475, 111, '2015-01-15 00:20:33.000000', 'temperatura', 1019.0000, 'ºC'),
	(23476, 111, '2015-01-15 00:20:34.000000', 'temperatura', 456.0000, 'ºC'),
	(23477, 111, '2015-01-15 00:20:35.000000', 'temperatura', 422.0000, 'ºC'),
	(23478, 111, '2015-01-15 00:20:36.000000', 'temperatura', 740.0000, 'ºC'),
	(23479, 111, '2015-01-15 00:20:37.000000', 'temperatura', 38.0000, 'ºC'),
	(23480, 111, '2015-01-15 00:20:38.000000', 'temperatura', 371.0000, 'ºC'),
	(23481, 111, '2015-01-15 00:20:39.000000', 'temperatura', 542.0000, 'ºC'),
	(23482, 111, '2015-01-15 00:20:40.000000', 'temperatura', 394.0000, 'ºC'),
	(23483, 111, '2015-01-15 00:20:41.000000', 'temperatura', 347.0000, 'ºC'),
	(23484, 111, '2015-01-15 00:20:42.000000', 'temperatura', 554.0000, 'ºC'),
	(23485, 111, '2015-01-15 00:20:43.000000', 'temperatura', 528.0000, 'ºC'),
	(23486, 111, '2015-01-15 00:20:44.000000', 'temperatura', 981.0000, 'ºC'),
	(23487, 111, '2015-01-15 00:20:45.000000', 'temperatura', 920.0000, 'ºC'),
	(23488, 111, '2015-01-15 00:20:46.000000', 'temperatura', 458.0000, 'ºC'),
	(23489, 111, '2015-01-15 00:20:47.000000', 'temperatura', 730.0000, 'ºC'),
	(23490, 111, '2015-01-15 00:20:48.000000', 'temperatura', 1078.0000, 'ºC'),
	(23491, 111, '2015-01-15 00:20:49.000000', 'temperatura', 801.0000, 'ºC'),
	(23492, 111, '2015-01-15 00:20:50.000000', 'temperatura', 770.0000, 'ºC'),
	(23493, 111, '2015-01-15 00:20:51.000000', 'temperatura', 247.0000, 'ºC'),
	(23494, 111, '2015-01-15 00:20:52.000000', 'temperatura', 127.0000, 'ºC'),
	(23495, 111, '2015-01-15 00:20:53.000000', 'temperatura', 1095.0000, 'ºC'),
	(23496, 111, '2015-01-15 00:20:54.000000', 'temperatura', 295.0000, 'ºC'),
	(23497, 111, '2015-01-15 00:20:55.000000', 'temperatura', 588.0000, 'ºC'),
	(23498, 111, '2015-01-15 00:20:56.000000', 'temperatura', 858.0000, 'ºC'),
	(23499, 111, '2015-01-15 00:20:57.000000', 'temperatura', 125.0000, 'ºC'),
	(23500, 111, '2015-01-15 00:20:58.000000', 'temperatura', 453.0000, 'ºC'),
	(23501, 111, '2015-01-15 00:20:59.000000', 'temperatura', 690.0000, 'ºC'),
	(23502, 111, '2015-01-15 00:21:00.000000', 'temperatura', 891.0000, 'ºC'),
	(23503, 111, '2015-01-15 00:21:01.000000', 'temperatura', 1184.0000, 'ºC'),
	(23504, 111, '2015-01-15 00:21:02.000000', 'temperatura', 851.0000, 'ºC'),
	(23505, 111, '2015-01-15 00:21:03.000000', 'temperatura', 701.0000, 'ºC'),
	(23506, 111, '2015-01-15 00:21:04.000000', 'temperatura', 954.0000, 'ºC'),
	(23507, 111, '2015-01-15 00:21:05.000000', 'temperatura', 265.0000, 'ºC'),
	(23508, 111, '2015-01-15 00:21:06.000000', 'temperatura', 865.0000, 'ºC'),
	(23509, 111, '2015-01-15 00:21:07.000000', 'temperatura', 1132.0000, 'ºC'),
	(23510, 111, '2015-01-15 00:21:08.000000', 'temperatura', 663.0000, 'ºC'),
	(23511, 111, '2015-01-15 00:21:09.000000', 'temperatura', 1122.0000, 'ºC'),
	(23512, 111, '2015-01-15 00:21:10.000000', 'temperatura', 20.0000, 'ºC'),
	(23513, 111, '2015-01-15 00:21:11.000000', 'temperatura', 337.0000, 'ºC'),
	(23514, 111, '2015-01-15 00:21:12.000000', 'temperatura', 423.0000, 'ºC'),
	(23515, 111, '2015-01-15 00:21:13.000000', 'temperatura', 1107.0000, 'ºC'),
	(23516, 111, '2015-01-15 00:21:14.000000', 'temperatura', 665.0000, 'ºC'),
	(23517, 111, '2015-01-15 00:21:15.000000', 'temperatura', 4.0000, 'ºC'),
	(23518, 111, '2015-01-15 00:21:16.000000', 'temperatura', 427.0000, 'ºC'),
	(23519, 111, '2015-01-15 00:21:17.000000', 'temperatura', 921.0000, 'ºC'),
	(23520, 111, '2015-01-15 00:21:18.000000', 'temperatura', 924.0000, 'ºC'),
	(23521, 111, '2015-01-15 00:21:19.000000', 'temperatura', 661.0000, 'ºC'),
	(23522, 111, '2015-01-15 00:21:20.000000', 'temperatura', 531.0000, 'ºC'),
	(23523, 111, '2015-01-15 00:21:21.000000', 'temperatura', 672.0000, 'ºC'),
	(23524, 111, '2015-01-15 00:21:22.000000', 'temperatura', 568.0000, 'ºC'),
	(23525, 111, '2015-01-15 00:21:23.000000', 'temperatura', 826.0000, 'ºC'),
	(23526, 111, '2015-01-15 00:21:24.000000', 'temperatura', 24.0000, 'ºC'),
	(23527, 111, '2015-01-15 00:21:25.000000', 'temperatura', 42.0000, 'ºC'),
	(23528, 111, '2015-01-15 00:21:26.000000', 'temperatura', 138.0000, 'ºC'),
	(23529, 111, '2015-01-15 00:21:27.000000', 'temperatura', 566.0000, 'ºC'),
	(23530, 111, '2015-01-15 00:21:28.000000', 'temperatura', 15.0000, 'ºC'),
	(23531, 111, '2015-01-15 00:21:29.000000', 'temperatura', 778.0000, 'ºC'),
	(23532, 111, '2015-01-15 00:21:30.000000', 'temperatura', 248.0000, 'ºC'),
	(23533, 111, '2015-01-15 00:21:31.000000', 'temperatura', 103.0000, 'ºC'),
	(23534, 111, '2015-01-15 00:21:32.000000', 'temperatura', 973.0000, 'ºC'),
	(23535, 111, '2015-01-15 00:21:33.000000', 'temperatura', 955.0000, 'ºC'),
	(23536, 111, '2015-01-15 00:21:34.000000', 'temperatura', 656.0000, 'ºC'),
	(23537, 111, '2015-01-15 00:21:35.000000', 'temperatura', 416.0000, 'ºC'),
	(23538, 111, '2015-01-15 00:21:36.000000', 'temperatura', 114.0000, 'ºC'),
	(23539, 111, '2015-01-15 00:21:37.000000', 'temperatura', 521.0000, 'ºC'),
	(23540, 111, '2015-01-15 00:21:38.000000', 'temperatura', 1066.0000, 'ºC'),
	(23541, 111, '2015-01-15 00:21:39.000000', 'temperatura', 165.0000, 'ºC'),
	(23542, 111, '2015-01-15 00:21:40.000000', 'temperatura', 28.0000, 'ºC'),
	(23543, 111, '2015-01-15 00:21:41.000000', 'temperatura', 846.0000, 'ºC'),
	(23544, 111, '2015-01-15 00:21:42.000000', 'temperatura', 548.0000, 'ºC'),
	(23545, 111, '2015-01-15 00:21:43.000000', 'temperatura', 201.0000, 'ºC'),
	(23546, 111, '2015-01-15 00:21:44.000000', 'temperatura', 564.0000, 'ºC'),
	(23547, 111, '2015-01-15 00:21:45.000000', 'temperatura', 1014.0000, 'ºC'),
	(23548, 111, '2015-01-15 00:21:46.000000', 'temperatura', 981.0000, 'ºC'),
	(23549, 111, '2015-01-15 00:21:47.000000', 'temperatura', 663.0000, 'ºC'),
	(23550, 111, '2015-01-15 00:21:48.000000', 'temperatura', 374.0000, 'ºC'),
	(23551, 111, '2015-01-15 00:21:49.000000', 'temperatura', 1081.0000, 'ºC'),
	(23552, 111, '2015-01-15 00:21:50.000000', 'temperatura', 683.0000, 'ºC'),
	(23553, 111, '2015-01-15 00:21:51.000000', 'temperatura', 172.0000, 'ºC'),
	(23554, 111, '2015-01-15 00:21:52.000000', 'temperatura', 11.0000, 'ºC'),
	(23555, 111, '2015-01-15 00:21:53.000000', 'temperatura', 741.0000, 'ºC'),
	(23556, 111, '2015-01-15 00:21:54.000000', 'temperatura', 72.0000, 'ºC'),
	(23557, 111, '2015-01-15 00:21:55.000000', 'temperatura', 535.0000, 'ºC'),
	(23558, 111, '2015-01-15 00:21:56.000000', 'temperatura', 63.0000, 'ºC'),
	(23559, 111, '2015-01-15 00:21:57.000000', 'temperatura', 1107.0000, 'ºC'),
	(23560, 111, '2015-01-15 00:21:58.000000', 'temperatura', 549.0000, 'ºC'),
	(23561, 111, '2015-01-15 00:21:59.000000', 'temperatura', 626.0000, 'ºC'),
	(23562, 111, '2015-01-15 00:22:00.000000', 'temperatura', 281.0000, 'ºC'),
	(23563, 111, '2015-01-15 00:22:01.000000', 'temperatura', 727.0000, 'ºC'),
	(23564, 111, '2015-01-15 00:22:02.000000', 'temperatura', 392.0000, 'ºC'),
	(23565, 111, '2015-01-15 00:22:03.000000', 'temperatura', 980.0000, 'ºC'),
	(23566, 111, '2015-01-15 00:22:04.000000', 'temperatura', 125.0000, 'ºC'),
	(23567, 111, '2015-01-15 00:22:05.000000', 'temperatura', 87.0000, 'ºC'),
	(23568, 111, '2015-01-15 00:22:06.000000', 'temperatura', 59.0000, 'ºC'),
	(23569, 111, '2015-01-15 00:22:07.000000', 'temperatura', 33.0000, 'ºC'),
	(23570, 111, '2015-01-15 00:22:08.000000', 'temperatura', 1191.0000, 'ºC'),
	(23571, 111, '2015-01-15 00:22:09.000000', 'temperatura', 1056.0000, 'ºC'),
	(23572, 111, '2015-01-15 00:22:10.000000', 'temperatura', 509.0000, 'ºC'),
	(23573, 111, '2015-01-15 00:22:11.000000', 'temperatura', 576.0000, 'ºC'),
	(23574, 111, '2015-01-15 00:22:12.000000', 'temperatura', 156.0000, 'ºC'),
	(23575, 111, '2015-01-15 00:22:13.000000', 'temperatura', 249.0000, 'ºC'),
	(23576, 111, '2015-01-15 00:22:14.000000', 'temperatura', 779.0000, 'ºC'),
	(23577, 111, '2015-01-15 00:22:15.000000', 'temperatura', 748.0000, 'ºC'),
	(23578, 111, '2015-01-15 00:22:16.000000', 'temperatura', 204.0000, 'ºC'),
	(23579, 111, '2015-01-15 00:22:17.000000', 'temperatura', 1176.0000, 'ºC'),
	(23580, 111, '2015-01-15 00:22:18.000000', 'temperatura', 467.0000, 'ºC'),
	(23581, 111, '2015-01-15 00:22:19.000000', 'temperatura', 8.0000, 'ºC'),
	(23582, 111, '2015-01-15 00:22:20.000000', 'temperatura', 1039.0000, 'ºC'),
	(23583, 111, '2015-01-15 00:22:21.000000', 'temperatura', 373.0000, 'ºC'),
	(23584, 111, '2015-01-15 00:22:22.000000', 'temperatura', 1149.0000, 'ºC'),
	(23585, 111, '2015-01-15 00:22:23.000000', 'temperatura', 1026.0000, 'ºC'),
	(23586, 111, '2015-01-15 00:22:24.000000', 'temperatura', 485.0000, 'ºC'),
	(23587, 111, '2015-01-15 00:22:25.000000', 'temperatura', 545.0000, 'ºC'),
	(23588, 111, '2015-01-15 00:22:26.000000', 'temperatura', 73.0000, 'ºC'),
	(23589, 111, '2015-01-15 00:22:27.000000', 'temperatura', 1131.0000, 'ºC'),
	(23590, 111, '2015-01-15 00:22:28.000000', 'temperatura', 633.0000, 'ºC'),
	(23591, 111, '2015-01-15 00:22:29.000000', 'temperatura', 975.0000, 'ºC'),
	(23592, 111, '2015-01-15 00:22:30.000000', 'temperatura', 577.0000, 'ºC'),
	(23593, 111, '2015-01-15 00:22:31.000000', 'temperatura', 1162.0000, 'ºC'),
	(23594, 111, '2015-01-15 00:22:32.000000', 'temperatura', 476.0000, 'ºC'),
	(23595, 111, '2015-01-15 00:22:33.000000', 'temperatura', 96.0000, 'ºC'),
	(23596, 111, '2015-01-15 00:22:34.000000', 'temperatura', 251.0000, 'ºC'),
	(23597, 111, '2015-01-15 00:22:35.000000', 'temperatura', 967.0000, 'ºC'),
	(23598, 111, '2015-01-15 00:22:36.000000', 'temperatura', 485.0000, 'ºC'),
	(23599, 111, '2015-01-15 00:22:37.000000', 'temperatura', 723.0000, 'ºC'),
	(23600, 111, '2015-01-15 00:22:38.000000', 'temperatura', 963.0000, 'ºC'),
	(23601, 111, '2015-01-15 00:22:39.000000', 'temperatura', 243.0000, 'ºC'),
	(23602, 111, '2015-01-15 00:22:40.000000', 'temperatura', 727.0000, 'ºC'),
	(23603, 111, '2015-01-15 00:22:41.000000', 'temperatura', 508.0000, 'ºC'),
	(23604, 111, '2015-01-15 00:22:42.000000', 'temperatura', 361.0000, 'ºC'),
	(23605, 111, '2015-01-15 00:22:43.000000', 'temperatura', 279.0000, 'ºC'),
	(23606, 111, '2015-01-15 00:22:44.000000', 'temperatura', 312.0000, 'ºC'),
	(23607, 111, '2015-01-15 00:22:45.000000', 'temperatura', 725.0000, 'ºC'),
	(23608, 111, '2015-01-15 00:22:46.000000', 'temperatura', 291.0000, 'ºC'),
	(23609, 111, '2015-01-15 00:22:47.000000', 'temperatura', 478.0000, 'ºC'),
	(23610, 111, '2015-01-15 00:22:48.000000', 'temperatura', 317.0000, 'ºC'),
	(23611, 111, '2015-01-15 00:22:49.000000', 'temperatura', 154.0000, 'ºC'),
	(23612, 111, '2015-01-15 00:22:50.000000', 'temperatura', 1020.0000, 'ºC'),
	(23613, 111, '2015-01-15 00:22:51.000000', 'temperatura', 1039.0000, 'ºC'),
	(23614, 111, '2015-01-15 00:22:52.000000', 'temperatura', 933.0000, 'ºC'),
	(23615, 111, '2015-01-15 00:22:53.000000', 'temperatura', 348.0000, 'ºC'),
	(23616, 111, '2015-01-15 00:22:54.000000', 'temperatura', 141.0000, 'ºC'),
	(23617, 111, '2015-01-15 00:22:55.000000', 'temperatura', 862.0000, 'ºC'),
	(23618, 111, '2015-01-15 00:22:56.000000', 'temperatura', 290.0000, 'ºC'),
	(23619, 111, '2015-01-15 00:22:57.000000', 'temperatura', 62.0000, 'ºC'),
	(23620, 111, '2015-01-15 00:22:58.000000', 'temperatura', 643.0000, 'ºC'),
	(23621, 111, '2015-01-15 00:22:59.000000', 'temperatura', 630.0000, 'ºC'),
	(23622, 111, '2015-01-15 00:23:00.000000', 'temperatura', 19.0000, 'ºC'),
	(23623, 111, '2015-01-15 00:23:01.000000', 'temperatura', 606.0000, 'ºC'),
	(23624, 111, '2015-01-15 00:23:02.000000', 'temperatura', 575.0000, 'ºC'),
	(23625, 111, '2015-01-15 00:23:03.000000', 'temperatura', 1058.0000, 'ºC'),
	(23626, 111, '2015-01-15 00:23:04.000000', 'temperatura', 1164.0000, 'ºC'),
	(23627, 111, '2015-01-15 00:23:05.000000', 'temperatura', 247.0000, 'ºC'),
	(23628, 111, '2015-01-15 00:23:06.000000', 'temperatura', 144.0000, 'ºC'),
	(23629, 111, '2015-01-15 00:23:07.000000', 'temperatura', 1177.0000, 'ºC'),
	(23630, 111, '2015-01-15 00:23:08.000000', 'temperatura', 657.0000, 'ºC'),
	(23631, 111, '2015-01-15 00:23:09.000000', 'temperatura', 953.0000, 'ºC'),
	(23632, 111, '2015-01-15 00:23:10.000000', 'temperatura', 395.0000, 'ºC'),
	(23633, 111, '2015-01-15 00:23:11.000000', 'temperatura', 315.0000, 'ºC'),
	(23634, 111, '2015-01-15 00:23:12.000000', 'temperatura', 392.0000, 'ºC'),
	(23635, 111, '2015-01-15 00:23:13.000000', 'temperatura', 1016.0000, 'ºC'),
	(23636, 111, '2015-01-15 00:23:14.000000', 'temperatura', 305.0000, 'ºC'),
	(23637, 111, '2015-01-15 00:23:15.000000', 'temperatura', 875.0000, 'ºC'),
	(23638, 111, '2015-01-15 00:23:16.000000', 'temperatura', 1060.0000, 'ºC'),
	(23639, 111, '2015-01-15 00:23:17.000000', 'temperatura', 278.0000, 'ºC'),
	(23640, 111, '2015-01-15 00:23:18.000000', 'temperatura', 609.0000, 'ºC'),
	(23641, 111, '2015-01-15 00:23:19.000000', 'temperatura', 1010.0000, 'ºC'),
	(23642, 111, '2015-01-15 00:23:20.000000', 'temperatura', 827.0000, 'ºC'),
	(23643, 111, '2015-01-15 00:23:21.000000', 'temperatura', 1102.0000, 'ºC'),
	(23644, 111, '2015-01-15 00:23:22.000000', 'temperatura', 632.0000, 'ºC'),
	(23645, 111, '2015-01-15 00:23:23.000000', 'temperatura', 1052.0000, 'ºC'),
	(23646, 111, '2015-01-15 00:23:24.000000', 'temperatura', 965.0000, 'ºC'),
	(23647, 111, '2015-01-15 00:23:25.000000', 'temperatura', 470.0000, 'ºC'),
	(23648, 111, '2015-01-15 00:23:26.000000', 'temperatura', 657.0000, 'ºC'),
	(23649, 111, '2015-01-15 00:23:27.000000', 'temperatura', 672.0000, 'ºC'),
	(23650, 111, '2015-01-15 00:23:28.000000', 'temperatura', 193.0000, 'ºC'),
	(23651, 111, '2015-01-15 00:23:29.000000', 'temperatura', 147.0000, 'ºC'),
	(23652, 111, '2015-01-15 00:23:30.000000', 'temperatura', 158.0000, 'ºC'),
	(23653, 111, '2015-01-15 00:23:31.000000', 'temperatura', 347.0000, 'ºC'),
	(23654, 111, '2015-01-15 00:23:32.000000', 'temperatura', 65.0000, 'ºC'),
	(23655, 111, '2015-01-15 00:23:33.000000', 'temperatura', 482.0000, 'ºC'),
	(23656, 111, '2015-01-15 00:23:34.000000', 'temperatura', 1017.0000, 'ºC'),
	(23657, 111, '2015-01-15 00:23:35.000000', 'temperatura', 38.0000, 'ºC'),
	(23658, 111, '2015-01-15 00:23:36.000000', 'temperatura', 742.0000, 'ºC'),
	(23659, 111, '2015-01-15 00:23:37.000000', 'temperatura', 1195.0000, 'ºC'),
	(23660, 111, '2015-01-15 00:23:38.000000', 'temperatura', 150.0000, 'ºC'),
	(23661, 111, '2015-01-15 00:23:39.000000', 'temperatura', 767.0000, 'ºC'),
	(23662, 111, '2015-01-15 00:23:40.000000', 'temperatura', 984.0000, 'ºC'),
	(23663, 111, '2015-01-15 00:23:41.000000', 'temperatura', 221.0000, 'ºC'),
	(23664, 111, '2015-01-15 00:23:42.000000', 'temperatura', 555.0000, 'ºC'),
	(23665, 111, '2015-01-15 00:23:43.000000', 'temperatura', 909.0000, 'ºC'),
	(23666, 111, '2015-01-15 00:23:44.000000', 'temperatura', 481.0000, 'ºC'),
	(23667, 111, '2015-01-15 00:23:45.000000', 'temperatura', 881.0000, 'ºC'),
	(23668, 111, '2015-01-15 00:23:46.000000', 'temperatura', 561.0000, 'ºC'),
	(23669, 111, '2015-01-15 00:23:47.000000', 'temperatura', 160.0000, 'ºC'),
	(23670, 111, '2015-01-15 00:23:48.000000', 'temperatura', 321.0000, 'ºC'),
	(23671, 111, '2015-01-15 00:23:49.000000', 'temperatura', 1126.0000, 'ºC'),
	(23672, 111, '2015-01-15 00:23:50.000000', 'temperatura', 1066.0000, 'ºC'),
	(23673, 111, '2015-01-15 00:23:51.000000', 'temperatura', 751.0000, 'ºC'),
	(23674, 111, '2015-01-15 00:23:52.000000', 'temperatura', 561.0000, 'ºC'),
	(23675, 111, '2015-01-15 00:23:53.000000', 'temperatura', 550.0000, 'ºC'),
	(23676, 111, '2015-01-15 00:23:54.000000', 'temperatura', 1067.0000, 'ºC'),
	(23677, 111, '2015-01-15 00:23:55.000000', 'temperatura', 88.0000, 'ºC'),
	(23678, 111, '2015-01-15 00:23:56.000000', 'temperatura', 839.0000, 'ºC'),
	(23679, 111, '2015-01-15 00:23:57.000000', 'temperatura', 332.0000, 'ºC'),
	(23680, 111, '2015-01-15 00:23:58.000000', 'temperatura', 342.0000, 'ºC'),
	(23681, 111, '2015-01-15 00:23:59.000000', 'temperatura', 715.0000, 'ºC'),
	(23682, 111, '2015-01-15 00:24:00.000000', 'temperatura', 152.0000, 'ºC'),
	(23683, 111, '2015-01-15 00:24:01.000000', 'temperatura', 1012.0000, 'ºC'),
	(23684, 111, '2015-01-15 00:24:02.000000', 'temperatura', 1006.0000, 'ºC'),
	(23685, 111, '2015-01-15 00:24:03.000000', 'temperatura', 795.0000, 'ºC'),
	(23686, 111, '2015-01-15 00:24:04.000000', 'temperatura', 958.0000, 'ºC'),
	(23687, 111, '2015-01-15 00:24:05.000000', 'temperatura', 3.0000, 'ºC'),
	(23688, 111, '2015-01-15 00:24:06.000000', 'temperatura', 745.0000, 'ºC'),
	(23689, 111, '2015-01-15 00:24:07.000000', 'temperatura', 113.0000, 'ºC'),
	(23690, 111, '2015-01-15 00:24:08.000000', 'temperatura', 733.0000, 'ºC'),
	(23691, 111, '2015-01-15 00:24:09.000000', 'temperatura', 926.0000, 'ºC'),
	(23692, 111, '2015-01-15 00:24:10.000000', 'temperatura', 30.0000, 'ºC'),
	(23693, 111, '2015-01-15 00:24:11.000000', 'temperatura', 975.0000, 'ºC'),
	(23694, 111, '2015-01-15 00:24:12.000000', 'temperatura', 1186.0000, 'ºC'),
	(23695, 111, '2015-01-15 00:24:13.000000', 'temperatura', 604.0000, 'ºC'),
	(23696, 111, '2015-01-15 00:24:14.000000', 'temperatura', 664.0000, 'ºC'),
	(23697, 111, '2015-01-15 00:24:15.000000', 'temperatura', 307.0000, 'ºC'),
	(23698, 111, '2015-01-15 00:24:16.000000', 'temperatura', 744.0000, 'ºC'),
	(23699, 111, '2015-01-15 00:24:17.000000', 'temperatura', 400.0000, 'ºC'),
	(23700, 111, '2015-01-15 00:24:18.000000', 'temperatura', 967.0000, 'ºC'),
	(23701, 111, '2015-01-15 00:24:19.000000', 'temperatura', 38.0000, 'ºC'),
	(23702, 111, '2015-01-15 00:24:20.000000', 'temperatura', 889.0000, 'ºC'),
	(23703, 111, '2015-01-15 00:24:21.000000', 'temperatura', 729.0000, 'ºC'),
	(23704, 111, '2015-01-15 00:24:22.000000', 'temperatura', 980.0000, 'ºC'),
	(23705, 111, '2015-01-15 00:24:23.000000', 'temperatura', 314.0000, 'ºC'),
	(23706, 111, '2015-01-15 00:24:24.000000', 'temperatura', 1028.0000, 'ºC'),
	(23707, 111, '2015-01-15 00:24:25.000000', 'temperatura', 600.0000, 'ºC'),
	(23708, 111, '2015-01-15 00:24:26.000000', 'temperatura', 1118.0000, 'ºC'),
	(23709, 111, '2015-01-15 00:24:27.000000', 'temperatura', 190.0000, 'ºC'),
	(23710, 111, '2015-01-15 00:24:28.000000', 'temperatura', 1197.0000, 'ºC'),
	(23711, 111, '2015-01-15 00:24:29.000000', 'temperatura', 616.0000, 'ºC'),
	(23712, 111, '2015-01-15 00:24:30.000000', 'temperatura', 688.0000, 'ºC'),
	(23713, 111, '2015-01-15 00:24:31.000000', 'temperatura', 394.0000, 'ºC'),
	(23714, 111, '2015-01-15 00:24:32.000000', 'temperatura', 1107.0000, 'ºC'),
	(23715, 111, '2015-01-15 00:24:33.000000', 'temperatura', 753.0000, 'ºC'),
	(23716, 111, '2015-01-15 00:24:34.000000', 'temperatura', 444.0000, 'ºC'),
	(23717, 111, '2015-01-15 00:24:35.000000', 'temperatura', 1160.0000, 'ºC'),
	(23718, 111, '2015-01-15 00:24:36.000000', 'temperatura', 870.0000, 'ºC'),
	(23719, 111, '2015-01-15 00:24:37.000000', 'temperatura', 871.0000, 'ºC'),
	(23720, 111, '2015-01-15 00:24:38.000000', 'temperatura', 546.0000, 'ºC'),
	(23721, 111, '2015-01-15 00:24:39.000000', 'temperatura', 116.0000, 'ºC'),
	(23722, 111, '2015-01-15 00:24:40.000000', 'temperatura', 144.0000, 'ºC'),
	(23723, 111, '2015-01-15 00:24:41.000000', 'temperatura', 371.0000, 'ºC'),
	(23724, 111, '2015-01-15 00:24:42.000000', 'temperatura', 224.0000, 'ºC'),
	(23725, 111, '2015-01-15 00:24:43.000000', 'temperatura', 7.0000, 'ºC'),
	(23726, 111, '2015-01-15 00:24:44.000000', 'temperatura', 565.0000, 'ºC'),
	(23727, 111, '2015-01-15 00:24:45.000000', 'temperatura', 403.0000, 'ºC'),
	(23728, 111, '2015-01-15 00:24:46.000000', 'temperatura', 319.0000, 'ºC'),
	(23729, 111, '2015-01-15 00:24:47.000000', 'temperatura', 388.0000, 'ºC'),
	(23730, 111, '2015-01-15 00:24:48.000000', 'temperatura', 982.0000, 'ºC'),
	(23731, 111, '2015-01-15 00:24:49.000000', 'temperatura', 147.0000, 'ºC'),
	(23732, 111, '2015-01-15 00:24:50.000000', 'temperatura', 190.0000, 'ºC'),
	(23733, 111, '2015-01-15 00:24:51.000000', 'temperatura', 510.0000, 'ºC'),
	(23734, 111, '2015-01-15 00:24:52.000000', 'temperatura', 779.0000, 'ºC'),
	(23735, 111, '2015-01-15 00:24:53.000000', 'temperatura', 1165.0000, 'ºC'),
	(23736, 111, '2015-01-15 00:24:54.000000', 'temperatura', 1090.0000, 'ºC'),
	(23737, 111, '2015-01-15 00:24:55.000000', 'temperatura', 753.0000, 'ºC'),
	(23738, 111, '2015-01-15 00:24:56.000000', 'temperatura', 499.0000, 'ºC'),
	(23739, 111, '2015-01-15 00:24:57.000000', 'temperatura', 235.0000, 'ºC'),
	(23740, 111, '2015-01-15 00:24:58.000000', 'temperatura', 877.0000, 'ºC'),
	(23741, 111, '2015-01-15 00:24:59.000000', 'temperatura', 81.0000, 'ºC'),
	(23742, 111, '2015-01-15 00:25:00.000000', 'temperatura', 175.0000, 'ºC'),
	(23743, 111, '2015-01-15 00:25:01.000000', 'temperatura', 631.0000, 'ºC'),
	(23744, 111, '2015-01-15 00:25:02.000000', 'temperatura', 233.0000, 'ºC'),
	(23745, 111, '2015-01-15 00:25:03.000000', 'temperatura', 473.0000, 'ºC'),
	(23746, 111, '2015-01-15 00:25:04.000000', 'temperatura', 465.0000, 'ºC'),
	(23747, 111, '2015-01-15 00:25:05.000000', 'temperatura', 905.0000, 'ºC'),
	(23748, 111, '2015-01-15 00:25:06.000000', 'temperatura', 732.0000, 'ºC'),
	(23749, 111, '2015-01-15 00:25:07.000000', 'temperatura', 946.0000, 'ºC'),
	(23750, 111, '2015-01-15 00:25:08.000000', 'temperatura', 132.0000, 'ºC'),
	(23751, 111, '2015-01-15 00:25:09.000000', 'temperatura', 225.0000, 'ºC'),
	(23752, 111, '2015-01-15 00:25:10.000000', 'temperatura', 728.0000, 'ºC'),
	(23753, 111, '2015-01-15 00:25:11.000000', 'temperatura', 565.0000, 'ºC'),
	(23754, 111, '2015-01-15 00:25:12.000000', 'temperatura', 641.0000, 'ºC'),
	(23755, 111, '2015-01-15 00:25:13.000000', 'temperatura', 310.0000, 'ºC'),
	(23756, 111, '2015-01-15 00:25:14.000000', 'temperatura', 829.0000, 'ºC'),
	(23757, 111, '2015-01-15 00:25:15.000000', 'temperatura', 815.0000, 'ºC'),
	(23758, 111, '2015-01-15 00:25:16.000000', 'temperatura', 388.0000, 'ºC'),
	(23759, 111, '2015-01-15 00:25:17.000000', 'temperatura', 696.0000, 'ºC'),
	(23760, 111, '2015-01-15 00:25:18.000000', 'temperatura', 1118.0000, 'ºC'),
	(23761, 111, '2015-01-15 00:25:19.000000', 'temperatura', 1103.0000, 'ºC'),
	(23762, 111, '2015-01-15 00:25:20.000000', 'temperatura', 959.0000, 'ºC'),
	(23763, 111, '2015-01-15 00:25:21.000000', 'temperatura', 289.0000, 'ºC'),
	(23764, 111, '2015-01-15 00:25:22.000000', 'temperatura', 968.0000, 'ºC'),
	(23765, 111, '2015-01-15 00:25:23.000000', 'temperatura', 375.0000, 'ºC'),
	(23766, 111, '2015-01-15 00:25:24.000000', 'temperatura', 170.0000, 'ºC'),
	(23767, 111, '2015-01-15 00:25:25.000000', 'temperatura', 927.0000, 'ºC'),
	(23768, 111, '2015-01-15 00:25:26.000000', 'temperatura', 526.0000, 'ºC'),
	(23769, 111, '2015-01-15 00:25:27.000000', 'temperatura', 1048.0000, 'ºC'),
	(23770, 111, '2015-01-15 00:25:28.000000', 'temperatura', 64.0000, 'ºC'),
	(23771, 111, '2015-01-15 00:25:29.000000', 'temperatura', 776.0000, 'ºC'),
	(23772, 111, '2015-01-15 00:25:30.000000', 'temperatura', 90.0000, 'ºC'),
	(23773, 111, '2015-01-15 00:25:31.000000', 'temperatura', 522.0000, 'ºC'),
	(23774, 111, '2015-01-15 00:25:32.000000', 'temperatura', 1139.0000, 'ºC'),
	(23775, 111, '2015-01-15 00:25:33.000000', 'temperatura', 530.0000, 'ºC'),
	(23776, 111, '2015-01-15 00:25:34.000000', 'temperatura', 434.0000, 'ºC'),
	(23777, 111, '2015-01-15 00:25:35.000000', 'temperatura', 579.0000, 'ºC'),
	(23778, 111, '2015-01-15 00:25:36.000000', 'temperatura', 393.0000, 'ºC'),
	(23779, 111, '2015-01-15 00:25:37.000000', 'temperatura', 230.0000, 'ºC'),
	(23780, 111, '2015-01-15 00:25:38.000000', 'temperatura', 1172.0000, 'ºC'),
	(23781, 111, '2015-01-15 00:25:39.000000', 'temperatura', 371.0000, 'ºC'),
	(23782, 111, '2015-01-15 00:25:40.000000', 'temperatura', 741.0000, 'ºC'),
	(23783, 111, '2015-01-15 00:25:41.000000', 'temperatura', 189.0000, 'ºC'),
	(23784, 111, '2015-01-15 00:25:42.000000', 'temperatura', 1125.0000, 'ºC'),
	(23785, 111, '2015-01-15 00:25:43.000000', 'temperatura', 260.0000, 'ºC'),
	(23786, 111, '2015-01-15 00:25:44.000000', 'temperatura', 322.0000, 'ºC'),
	(23787, 111, '2015-01-15 00:25:45.000000', 'temperatura', 832.0000, 'ºC'),
	(23788, 111, '2015-01-15 00:25:46.000000', 'temperatura', 794.0000, 'ºC'),
	(23789, 111, '2015-01-15 00:25:47.000000', 'temperatura', 276.0000, 'ºC'),
	(23790, 111, '2015-01-15 00:25:48.000000', 'temperatura', 196.0000, 'ºC'),
	(23791, 111, '2015-01-15 00:25:49.000000', 'temperatura', 154.0000, 'ºC'),
	(23792, 111, '2015-01-15 00:25:50.000000', 'temperatura', 181.0000, 'ºC'),
	(23793, 111, '2015-01-15 00:25:51.000000', 'temperatura', 443.0000, 'ºC'),
	(23794, 111, '2015-01-15 00:25:52.000000', 'temperatura', 472.0000, 'ºC'),
	(23795, 111, '2015-01-15 00:25:53.000000', 'temperatura', 1032.0000, 'ºC'),
	(23796, 111, '2015-01-15 00:25:54.000000', 'temperatura', 145.0000, 'ºC'),
	(23797, 111, '2015-01-15 00:25:55.000000', 'temperatura', 30.0000, 'ºC'),
	(23798, 111, '2015-01-15 00:25:56.000000', 'temperatura', 913.0000, 'ºC'),
	(23799, 111, '2015-01-15 00:25:57.000000', 'temperatura', 879.0000, 'ºC'),
	(23800, 111, '2015-01-15 00:25:58.000000', 'temperatura', 453.0000, 'ºC'),
	(23801, 111, '2015-01-15 00:25:59.000000', 'temperatura', 831.0000, 'ºC'),
	(23802, 111, '2015-01-15 00:26:00.000000', 'temperatura', 394.0000, 'ºC'),
	(23803, 111, '2015-01-15 00:26:01.000000', 'temperatura', 679.0000, 'ºC'),
	(23804, 111, '2015-01-15 00:26:02.000000', 'temperatura', 1015.0000, 'ºC'),
	(23805, 111, '2015-01-15 00:26:03.000000', 'temperatura', 635.0000, 'ºC'),
	(23806, 111, '2015-01-15 00:26:04.000000', 'temperatura', 134.0000, 'ºC'),
	(23807, 111, '2015-01-15 00:26:05.000000', 'temperatura', 1163.0000, 'ºC'),
	(23808, 111, '2015-01-15 00:26:06.000000', 'temperatura', 614.0000, 'ºC'),
	(23809, 111, '2015-01-15 00:26:07.000000', 'temperatura', 783.0000, 'ºC'),
	(23810, 111, '2015-01-15 00:26:08.000000', 'temperatura', 873.0000, 'ºC'),
	(23811, 111, '2015-01-15 00:26:09.000000', 'temperatura', 817.0000, 'ºC'),
	(23812, 111, '2015-01-15 00:26:10.000000', 'temperatura', 266.0000, 'ºC'),
	(23813, 111, '2015-01-15 00:26:11.000000', 'temperatura', 78.0000, 'ºC'),
	(23814, 111, '2015-01-15 00:26:12.000000', 'temperatura', 792.0000, 'ºC'),
	(23815, 111, '2015-01-15 00:26:13.000000', 'temperatura', 128.0000, 'ºC'),
	(23816, 111, '2015-01-15 00:26:14.000000', 'temperatura', 666.0000, 'ºC'),
	(23817, 111, '2015-01-15 00:26:15.000000', 'temperatura', 546.0000, 'ºC'),
	(23818, 111, '2015-01-15 00:26:16.000000', 'temperatura', 731.0000, 'ºC'),
	(23819, 111, '2015-01-15 00:26:17.000000', 'temperatura', 818.0000, 'ºC'),
	(23820, 111, '2015-01-15 00:26:18.000000', 'temperatura', 699.0000, 'ºC'),
	(23821, 111, '2015-01-15 00:26:19.000000', 'temperatura', 1039.0000, 'ºC'),
	(23822, 111, '2015-01-15 00:26:20.000000', 'temperatura', 698.0000, 'ºC'),
	(23823, 111, '2015-01-15 00:26:21.000000', 'temperatura', 373.0000, 'ºC'),
	(23824, 111, '2015-01-15 00:26:22.000000', 'temperatura', 971.0000, 'ºC'),
	(23825, 111, '2015-01-15 00:26:23.000000', 'temperatura', 136.0000, 'ºC'),
	(23826, 111, '2015-01-15 00:26:24.000000', 'temperatura', 168.0000, 'ºC'),
	(23827, 111, '2015-01-15 00:26:25.000000', 'temperatura', 434.0000, 'ºC'),
	(23828, 111, '2015-01-15 00:26:26.000000', 'temperatura', 464.0000, 'ºC'),
	(23829, 111, '2015-01-15 00:26:27.000000', 'temperatura', 1019.0000, 'ºC'),
	(23830, 111, '2015-01-15 00:26:28.000000', 'temperatura', 105.0000, 'ºC'),
	(23831, 111, '2015-01-15 00:26:29.000000', 'temperatura', 1068.0000, 'ºC'),
	(23832, 111, '2015-01-15 00:26:30.000000', 'temperatura', 225.0000, 'ºC'),
	(23833, 111, '2015-01-15 00:26:31.000000', 'temperatura', 321.0000, 'ºC'),
	(23834, 111, '2015-01-15 00:26:32.000000', 'temperatura', 932.0000, 'ºC'),
	(23835, 111, '2015-01-15 00:26:33.000000', 'temperatura', 97.0000, 'ºC'),
	(23836, 111, '2015-01-15 00:26:34.000000', 'temperatura', 90.0000, 'ºC'),
	(23837, 111, '2015-01-15 00:26:35.000000', 'temperatura', 159.0000, 'ºC'),
	(23838, 111, '2015-01-15 00:26:36.000000', 'temperatura', 524.0000, 'ºC'),
	(23839, 111, '2015-01-15 00:26:37.000000', 'temperatura', 945.0000, 'ºC'),
	(23840, 111, '2015-01-15 00:26:38.000000', 'temperatura', 755.0000, 'ºC'),
	(23841, 111, '2015-01-15 00:26:39.000000', 'temperatura', 941.0000, 'ºC'),
	(23842, 111, '2015-01-15 00:26:40.000000', 'temperatura', 37.0000, 'ºC'),
	(23843, 111, '2015-01-15 00:26:41.000000', 'temperatura', 966.0000, 'ºC'),
	(23844, 111, '2015-01-15 00:26:42.000000', 'temperatura', 1119.0000, 'ºC'),
	(23845, 111, '2015-01-15 00:26:43.000000', 'temperatura', 296.0000, 'ºC'),
	(23846, 111, '2015-01-15 00:26:44.000000', 'temperatura', 525.0000, 'ºC'),
	(23847, 111, '2015-01-15 00:26:45.000000', 'temperatura', 535.0000, 'ºC'),
	(23848, 111, '2015-01-15 00:26:46.000000', 'temperatura', 1104.0000, 'ºC'),
	(23849, 111, '2015-01-15 00:26:47.000000', 'temperatura', 313.0000, 'ºC'),
	(23850, 111, '2015-01-15 00:26:48.000000', 'temperatura', 653.0000, 'ºC'),
	(23851, 111, '2015-01-15 00:26:49.000000', 'temperatura', 1128.0000, 'ºC'),
	(23852, 111, '2015-01-15 00:26:50.000000', 'temperatura', 82.0000, 'ºC'),
	(23853, 111, '2015-01-15 00:26:51.000000', 'temperatura', 624.0000, 'ºC'),
	(23854, 111, '2015-01-15 00:26:52.000000', 'temperatura', 475.0000, 'ºC'),
	(23855, 111, '2015-01-15 00:26:53.000000', 'temperatura', 505.0000, 'ºC'),
	(23856, 111, '2015-01-15 00:26:54.000000', 'temperatura', 1100.0000, 'ºC'),
	(23857, 111, '2015-01-15 00:26:55.000000', 'temperatura', 384.0000, 'ºC'),
	(23858, 111, '2015-01-15 00:26:56.000000', 'temperatura', 1023.0000, 'ºC'),
	(23859, 111, '2015-01-15 00:26:57.000000', 'temperatura', 364.0000, 'ºC'),
	(23860, 111, '2015-01-15 00:26:58.000000', 'temperatura', 1152.0000, 'ºC'),
	(23861, 111, '2015-01-15 00:26:59.000000', 'temperatura', 1067.0000, 'ºC'),
	(23862, 111, '2015-01-15 00:27:00.000000', 'temperatura', 678.0000, 'ºC'),
	(23863, 111, '2015-01-15 00:27:01.000000', 'temperatura', 192.0000, 'ºC'),
	(23864, 111, '2015-01-15 00:27:02.000000', 'temperatura', 124.0000, 'ºC'),
	(23865, 111, '2015-01-15 00:27:03.000000', 'temperatura', 48.0000, 'ºC'),
	(23866, 111, '2015-01-15 00:27:04.000000', 'temperatura', 1066.0000, 'ºC'),
	(23867, 111, '2015-01-15 00:27:05.000000', 'temperatura', 385.0000, 'ºC'),
	(23868, 111, '2015-01-15 00:27:06.000000', 'temperatura', 1131.0000, 'ºC'),
	(23869, 111, '2015-01-15 00:27:07.000000', 'temperatura', 899.0000, 'ºC'),
	(23870, 111, '2015-01-15 00:27:08.000000', 'temperatura', 1101.0000, 'ºC'),
	(23871, 111, '2015-01-15 00:27:09.000000', 'temperatura', 409.0000, 'ºC'),
	(23872, 111, '2015-01-15 00:27:10.000000', 'temperatura', 1144.0000, 'ºC'),
	(23873, 111, '2015-01-15 00:27:11.000000', 'temperatura', 891.0000, 'ºC'),
	(23874, 111, '2015-01-15 00:27:12.000000', 'temperatura', 1023.0000, 'ºC'),
	(23875, 111, '2015-01-15 00:27:13.000000', 'temperatura', 46.0000, 'ºC'),
	(23876, 111, '2015-01-15 00:27:14.000000', 'temperatura', 758.0000, 'ºC'),
	(23877, 111, '2015-01-15 00:27:15.000000', 'temperatura', 54.0000, 'ºC'),
	(23878, 111, '2015-01-15 00:27:16.000000', 'temperatura', 395.0000, 'ºC'),
	(23879, 111, '2015-01-15 00:27:17.000000', 'temperatura', 613.0000, 'ºC'),
	(23880, 111, '2015-01-15 00:27:18.000000', 'temperatura', 681.0000, 'ºC'),
	(23881, 111, '2015-01-15 00:27:19.000000', 'temperatura', 367.0000, 'ºC'),
	(23882, 111, '2015-01-15 00:27:20.000000', 'temperatura', 994.0000, 'ºC'),
	(23883, 111, '2015-01-15 00:27:21.000000', 'temperatura', 269.0000, 'ºC'),
	(23884, 111, '2015-01-15 00:27:22.000000', 'temperatura', 763.0000, 'ºC'),
	(23885, 111, '2015-01-15 00:27:23.000000', 'temperatura', 610.0000, 'ºC'),
	(23886, 111, '2015-01-15 00:27:24.000000', 'temperatura', 760.0000, 'ºC'),
	(23887, 111, '2015-01-15 00:27:25.000000', 'temperatura', 772.0000, 'ºC'),
	(23888, 111, '2015-01-15 00:27:26.000000', 'temperatura', 378.0000, 'ºC'),
	(23889, 111, '2015-01-15 00:27:27.000000', 'temperatura', 776.0000, 'ºC'),
	(23890, 111, '2015-01-15 00:27:28.000000', 'temperatura', 348.0000, 'ºC'),
	(23891, 111, '2015-01-15 00:27:29.000000', 'temperatura', 611.0000, 'ºC'),
	(23892, 111, '2015-01-15 00:27:30.000000', 'temperatura', 811.0000, 'ºC'),
	(23893, 111, '2015-01-15 00:27:31.000000', 'temperatura', 1021.0000, 'ºC'),
	(23894, 111, '2015-01-15 00:27:32.000000', 'temperatura', 274.0000, 'ºC'),
	(23895, 111, '2015-01-15 00:27:33.000000', 'temperatura', 708.0000, 'ºC'),
	(23896, 111, '2015-01-15 00:27:34.000000', 'temperatura', 320.0000, 'ºC'),
	(23897, 111, '2015-01-15 00:27:35.000000', 'temperatura', 676.0000, 'ºC'),
	(23898, 111, '2015-01-15 00:27:36.000000', 'temperatura', 19.0000, 'ºC'),
	(23899, 111, '2015-01-15 00:27:37.000000', 'temperatura', 469.0000, 'ºC'),
	(23900, 111, '2015-01-15 00:27:38.000000', 'temperatura', 1089.0000, 'ºC'),
	(23901, 111, '2015-01-15 00:27:39.000000', 'temperatura', 439.0000, 'ºC'),
	(23902, 111, '2015-01-15 00:27:40.000000', 'temperatura', 128.0000, 'ºC'),
	(23903, 111, '2015-01-15 00:27:41.000000', 'temperatura', 523.0000, 'ºC'),
	(23904, 111, '2015-01-15 00:27:42.000000', 'temperatura', 1031.0000, 'ºC'),
	(23905, 111, '2015-01-15 00:27:43.000000', 'temperatura', 1187.0000, 'ºC'),
	(23906, 111, '2015-01-15 00:27:44.000000', 'temperatura', 441.0000, 'ºC'),
	(23907, 111, '2015-01-15 00:27:45.000000', 'temperatura', 1046.0000, 'ºC'),
	(23908, 111, '2015-01-15 00:27:46.000000', 'temperatura', 308.0000, 'ºC'),
	(23909, 111, '2015-01-15 00:27:47.000000', 'temperatura', 800.0000, 'ºC'),
	(23910, 111, '2015-01-15 00:27:48.000000', 'temperatura', 680.0000, 'ºC'),
	(23911, 111, '2015-01-15 00:27:49.000000', 'temperatura', 998.0000, 'ºC'),
	(23912, 111, '2015-01-15 00:27:50.000000', 'temperatura', 550.0000, 'ºC'),
	(23913, 111, '2015-01-15 00:27:51.000000', 'temperatura', 957.0000, 'ºC'),
	(23914, 111, '2015-01-15 00:27:52.000000', 'temperatura', 734.0000, 'ºC'),
	(23915, 111, '2015-01-15 00:27:53.000000', 'temperatura', 800.0000, 'ºC'),
	(23916, 111, '2015-01-15 00:27:54.000000', 'temperatura', 598.0000, 'ºC'),
	(23917, 111, '2015-01-15 00:27:55.000000', 'temperatura', 593.0000, 'ºC'),
	(23918, 111, '2015-01-15 00:27:56.000000', 'temperatura', 1169.0000, 'ºC'),
	(23919, 111, '2015-01-15 00:27:57.000000', 'temperatura', 466.0000, 'ºC'),
	(23920, 111, '2015-01-15 00:27:58.000000', 'temperatura', 24.0000, 'ºC'),
	(23921, 111, '2015-01-15 00:27:59.000000', 'temperatura', 1123.0000, 'ºC'),
	(23922, 111, '2015-01-15 00:28:00.000000', 'temperatura', 744.0000, 'ºC'),
	(23923, 111, '2015-01-15 00:28:01.000000', 'temperatura', 351.0000, 'ºC'),
	(23924, 111, '2015-01-15 00:28:02.000000', 'temperatura', 723.0000, 'ºC'),
	(23925, 111, '2015-01-15 00:28:03.000000', 'temperatura', 163.0000, 'ºC'),
	(23926, 111, '2015-01-15 00:28:04.000000', 'temperatura', 1046.0000, 'ºC'),
	(23927, 111, '2015-01-15 00:28:05.000000', 'temperatura', 1141.0000, 'ºC'),
	(23928, 111, '2015-01-15 00:28:06.000000', 'temperatura', 170.0000, 'ºC'),
	(23929, 111, '2015-01-15 00:28:07.000000', 'temperatura', 1026.0000, 'ºC'),
	(23930, 111, '2015-01-15 00:28:08.000000', 'temperatura', 1019.0000, 'ºC'),
	(23931, 111, '2015-01-15 00:28:09.000000', 'temperatura', 820.0000, 'ºC'),
	(23932, 111, '2015-01-15 00:28:10.000000', 'temperatura', 1042.0000, 'ºC'),
	(23933, 111, '2015-01-15 00:28:11.000000', 'temperatura', 351.0000, 'ºC'),
	(23934, 111, '2015-01-15 00:28:12.000000', 'temperatura', 1028.0000, 'ºC'),
	(23935, 111, '2015-01-15 00:28:13.000000', 'temperatura', 489.0000, 'ºC'),
	(23936, 111, '2015-01-15 00:28:14.000000', 'temperatura', 560.0000, 'ºC'),
	(23937, 111, '2015-01-15 00:28:15.000000', 'temperatura', 135.0000, 'ºC'),
	(23938, 111, '2015-01-15 00:28:16.000000', 'temperatura', 194.0000, 'ºC'),
	(23939, 111, '2015-01-15 00:28:17.000000', 'temperatura', 566.0000, 'ºC'),
	(23940, 111, '2015-01-15 00:28:18.000000', 'temperatura', 1050.0000, 'ºC'),
	(23941, 111, '2015-01-15 00:28:19.000000', 'temperatura', 1151.0000, 'ºC'),
	(23942, 111, '2015-01-15 00:28:20.000000', 'temperatura', 205.0000, 'ºC'),
	(23943, 111, '2015-01-15 00:28:21.000000', 'temperatura', 1172.0000, 'ºC'),
	(23944, 111, '2015-01-15 00:28:22.000000', 'temperatura', 448.0000, 'ºC'),
	(23945, 111, '2015-01-15 00:28:23.000000', 'temperatura', 1123.0000, 'ºC'),
	(23946, 111, '2015-01-15 00:28:24.000000', 'temperatura', 674.0000, 'ºC'),
	(23947, 111, '2015-01-15 00:28:25.000000', 'temperatura', 1198.0000, 'ºC'),
	(23948, 111, '2015-01-15 00:28:26.000000', 'temperatura', 371.0000, 'ºC'),
	(23949, 111, '2015-01-15 00:28:27.000000', 'temperatura', 662.0000, 'ºC'),
	(23950, 111, '2015-01-15 00:28:28.000000', 'temperatura', 998.0000, 'ºC'),
	(23951, 111, '2015-01-15 00:28:29.000000', 'temperatura', 605.0000, 'ºC'),
	(23952, 111, '2015-01-15 00:28:30.000000', 'temperatura', 29.0000, 'ºC'),
	(23953, 111, '2015-01-15 00:28:31.000000', 'temperatura', 731.0000, 'ºC'),
	(23954, 111, '2015-01-15 00:28:32.000000', 'temperatura', 1169.0000, 'ºC'),
	(23955, 111, '2015-01-15 00:28:33.000000', 'temperatura', 52.0000, 'ºC'),
	(23956, 111, '2015-01-15 00:28:34.000000', 'temperatura', 352.0000, 'ºC'),
	(23957, 111, '2015-01-15 00:28:35.000000', 'temperatura', 405.0000, 'ºC'),
	(23958, 111, '2015-01-15 00:28:36.000000', 'temperatura', 972.0000, 'ºC'),
	(23959, 111, '2015-01-15 00:28:37.000000', 'temperatura', 42.0000, 'ºC'),
	(23960, 111, '2015-01-15 00:28:38.000000', 'temperatura', 898.0000, 'ºC'),
	(23961, 111, '2015-01-15 00:28:39.000000', 'temperatura', 762.0000, 'ºC'),
	(23962, 111, '2015-01-15 00:28:40.000000', 'temperatura', 1117.0000, 'ºC'),
	(23963, 111, '2015-01-15 00:28:41.000000', 'temperatura', 900.0000, 'ºC'),
	(23964, 111, '2015-01-15 00:28:42.000000', 'temperatura', 1148.0000, 'ºC'),
	(23965, 111, '2015-01-15 00:28:43.000000', 'temperatura', 641.0000, 'ºC'),
	(23966, 111, '2015-01-15 00:28:44.000000', 'temperatura', 961.0000, 'ºC'),
	(23967, 111, '2015-01-15 00:28:45.000000', 'temperatura', 485.0000, 'ºC'),
	(23968, 111, '2015-01-15 00:28:46.000000', 'temperatura', 741.0000, 'ºC'),
	(23969, 111, '2015-01-15 00:28:47.000000', 'temperatura', 1050.0000, 'ºC'),
	(23970, 111, '2015-01-15 00:28:48.000000', 'temperatura', 630.0000, 'ºC'),
	(23971, 111, '2015-01-15 00:28:49.000000', 'temperatura', 1197.0000, 'ºC'),
	(23972, 111, '2015-01-15 00:28:50.000000', 'temperatura', 499.0000, 'ºC'),
	(23973, 111, '2015-01-15 00:28:51.000000', 'temperatura', 102.0000, 'ºC'),
	(23974, 111, '2015-01-15 00:28:52.000000', 'temperatura', 212.0000, 'ºC'),
	(23975, 111, '2015-01-15 00:28:53.000000', 'temperatura', 757.0000, 'ºC'),
	(23976, 111, '2015-01-15 00:28:54.000000', 'temperatura', 748.0000, 'ºC'),
	(23977, 111, '2015-01-15 00:28:55.000000', 'temperatura', 272.0000, 'ºC'),
	(23978, 111, '2015-01-15 00:28:56.000000', 'temperatura', 314.0000, 'ºC'),
	(23979, 111, '2015-01-15 00:28:57.000000', 'temperatura', 755.0000, 'ºC'),
	(23980, 111, '2015-01-15 00:28:58.000000', 'temperatura', 434.0000, 'ºC'),
	(23981, 111, '2015-01-15 00:28:59.000000', 'temperatura', 1104.0000, 'ºC'),
	(23982, 111, '2015-01-15 00:29:00.000000', 'temperatura', 617.0000, 'ºC'),
	(23983, 111, '2015-01-15 00:29:01.000000', 'temperatura', 976.0000, 'ºC'),
	(23984, 111, '2015-01-15 00:29:02.000000', 'temperatura', 631.0000, 'ºC'),
	(23985, 111, '2015-01-15 00:29:03.000000', 'temperatura', 225.0000, 'ºC'),
	(23986, 111, '2015-01-15 00:29:04.000000', 'temperatura', 431.0000, 'ºC'),
	(23987, 111, '2015-01-15 00:29:05.000000', 'temperatura', 284.0000, 'ºC'),
	(23988, 111, '2015-01-15 00:29:06.000000', 'temperatura', 124.0000, 'ºC'),
	(23989, 111, '2015-01-15 00:29:07.000000', 'temperatura', 971.0000, 'ºC'),
	(23990, 111, '2015-01-15 00:29:08.000000', 'temperatura', 885.0000, 'ºC'),
	(23991, 111, '2015-01-15 00:29:09.000000', 'temperatura', 310.0000, 'ºC'),
	(23992, 111, '2015-01-15 00:29:10.000000', 'temperatura', 94.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(23993, 111, '2015-01-15 00:29:11.000000', 'temperatura', 744.0000, 'ºC'),
	(23994, 111, '2015-01-15 00:29:12.000000', 'temperatura', 1036.0000, 'ºC'),
	(23995, 111, '2015-01-15 00:29:13.000000', 'temperatura', 549.0000, 'ºC'),
	(23996, 111, '2015-01-15 00:29:14.000000', 'temperatura', 837.0000, 'ºC'),
	(23997, 111, '2015-01-15 00:29:15.000000', 'temperatura', 140.0000, 'ºC'),
	(23998, 111, '2015-01-15 00:29:16.000000', 'temperatura', 590.0000, 'ºC'),
	(23999, 111, '2015-01-15 00:29:17.000000', 'temperatura', 129.0000, 'ºC'),
	(24000, 111, '2015-01-15 00:29:18.000000', 'temperatura', 74.0000, 'ºC'),
	(24001, 111, '2015-01-15 00:29:19.000000', 'temperatura', 1186.0000, 'ºC'),
	(24002, 111, '2015-01-15 00:29:20.000000', 'temperatura', 907.0000, 'ºC'),
	(24003, 111, '2015-01-15 00:29:21.000000', 'temperatura', 978.0000, 'ºC'),
	(24004, 111, '2015-01-15 00:29:22.000000', 'temperatura', 969.0000, 'ºC'),
	(24005, 111, '2015-01-15 00:29:23.000000', 'temperatura', 714.0000, 'ºC'),
	(24006, 111, '2015-01-15 00:29:24.000000', 'temperatura', 660.0000, 'ºC'),
	(24007, 111, '2015-01-15 00:29:25.000000', 'temperatura', 1160.0000, 'ºC'),
	(24008, 111, '2015-01-15 00:29:26.000000', 'temperatura', 222.0000, 'ºC'),
	(24009, 111, '2015-01-15 00:29:27.000000', 'temperatura', 31.0000, 'ºC'),
	(24010, 111, '2015-01-15 00:29:28.000000', 'temperatura', 688.0000, 'ºC'),
	(24011, 111, '2015-01-15 00:29:29.000000', 'temperatura', 947.0000, 'ºC'),
	(24012, 111, '2015-01-15 00:29:30.000000', 'temperatura', 272.0000, 'ºC'),
	(24013, 111, '2015-01-15 00:29:31.000000', 'temperatura', 920.0000, 'ºC'),
	(24014, 111, '2015-01-15 00:29:32.000000', 'temperatura', 186.0000, 'ºC'),
	(24015, 111, '2015-01-15 00:29:33.000000', 'temperatura', 569.0000, 'ºC'),
	(24016, 111, '2015-01-15 00:29:34.000000', 'temperatura', 1086.0000, 'ºC'),
	(24017, 111, '2015-01-15 00:29:35.000000', 'temperatura', 124.0000, 'ºC'),
	(24018, 111, '2015-01-15 00:29:36.000000', 'temperatura', 965.0000, 'ºC'),
	(24019, 111, '2015-01-15 00:29:37.000000', 'temperatura', 852.0000, 'ºC'),
	(24020, 111, '2015-01-15 00:29:38.000000', 'temperatura', 166.0000, 'ºC'),
	(24021, 111, '2015-01-15 00:29:39.000000', 'temperatura', 673.0000, 'ºC'),
	(24022, 111, '2015-01-15 00:29:40.000000', 'temperatura', 467.0000, 'ºC'),
	(24023, 111, '2015-01-15 00:29:41.000000', 'temperatura', 319.0000, 'ºC'),
	(24024, 111, '2015-01-15 00:29:42.000000', 'temperatura', 193.0000, 'ºC'),
	(24025, 111, '2015-01-15 00:29:43.000000', 'temperatura', 11.0000, 'ºC'),
	(24026, 111, '2015-01-15 00:29:44.000000', 'temperatura', 673.0000, 'ºC'),
	(24027, 111, '2015-01-15 00:29:45.000000', 'temperatura', 934.0000, 'ºC'),
	(24028, 111, '2015-01-15 00:29:46.000000', 'temperatura', 251.0000, 'ºC'),
	(24029, 111, '2015-01-15 00:29:47.000000', 'temperatura', 853.0000, 'ºC'),
	(24030, 111, '2015-01-15 00:29:48.000000', 'temperatura', 1112.0000, 'ºC'),
	(24031, 111, '2015-01-15 00:29:49.000000', 'temperatura', 603.0000, 'ºC'),
	(24032, 111, '2015-01-15 00:29:50.000000', 'temperatura', 879.0000, 'ºC'),
	(24033, 111, '2015-01-15 00:29:51.000000', 'temperatura', 187.0000, 'ºC'),
	(24034, 111, '2015-01-15 00:29:52.000000', 'temperatura', 696.0000, 'ºC'),
	(24035, 111, '2015-01-15 00:29:53.000000', 'temperatura', 522.0000, 'ºC'),
	(24036, 111, '2015-01-15 00:29:54.000000', 'temperatura', 523.0000, 'ºC'),
	(24037, 111, '2015-01-15 00:29:55.000000', 'temperatura', 1048.0000, 'ºC'),
	(24038, 111, '2015-01-15 00:29:56.000000', 'temperatura', 73.0000, 'ºC'),
	(24039, 111, '2015-01-15 00:29:57.000000', 'temperatura', 819.0000, 'ºC'),
	(24040, 111, '2015-01-15 00:29:58.000000', 'temperatura', 280.0000, 'ºC'),
	(24041, 111, '2015-01-15 00:29:59.000000', 'temperatura', 141.0000, 'ºC'),
	(24042, 111, '2015-01-15 00:30:00.000000', 'temperatura', 1066.0000, 'ºC'),
	(24043, 111, '2015-01-15 00:30:01.000000', 'temperatura', 109.0000, 'ºC'),
	(24044, 111, '2015-01-15 00:30:02.000000', 'temperatura', 944.0000, 'ºC'),
	(24045, 111, '2015-01-15 00:30:03.000000', 'temperatura', 797.0000, 'ºC'),
	(24046, 111, '2015-01-15 00:30:04.000000', 'temperatura', 1153.0000, 'ºC'),
	(24047, 111, '2015-01-15 00:30:05.000000', 'temperatura', 973.0000, 'ºC'),
	(24048, 111, '2015-01-15 00:30:06.000000', 'temperatura', 206.0000, 'ºC'),
	(24049, 111, '2015-01-15 00:30:07.000000', 'temperatura', 512.0000, 'ºC'),
	(24050, 111, '2015-01-15 00:30:08.000000', 'temperatura', 744.0000, 'ºC'),
	(24051, 111, '2015-01-15 00:30:09.000000', 'temperatura', 985.0000, 'ºC'),
	(24052, 111, '2015-01-15 00:30:10.000000', 'temperatura', 291.0000, 'ºC'),
	(24053, 111, '2015-01-15 00:30:11.000000', 'temperatura', 901.0000, 'ºC'),
	(24054, 111, '2015-01-15 00:30:12.000000', 'temperatura', 35.0000, 'ºC'),
	(24055, 111, '2015-01-15 00:30:13.000000', 'temperatura', 1071.0000, 'ºC'),
	(24056, 111, '2015-01-15 00:30:14.000000', 'temperatura', 449.0000, 'ºC'),
	(24057, 111, '2015-01-15 00:30:15.000000', 'temperatura', 235.0000, 'ºC'),
	(24058, 111, '2015-01-15 00:30:16.000000', 'temperatura', 1025.0000, 'ºC'),
	(24059, 111, '2015-01-15 00:30:17.000000', 'temperatura', 824.0000, 'ºC'),
	(24060, 111, '2015-01-15 00:30:18.000000', 'temperatura', 1045.0000, 'ºC'),
	(24061, 111, '2015-01-15 00:30:19.000000', 'temperatura', 352.0000, 'ºC'),
	(24062, 111, '2015-01-15 00:30:20.000000', 'temperatura', 1024.0000, 'ºC'),
	(24063, 111, '2015-01-15 00:30:21.000000', 'temperatura', 466.0000, 'ºC'),
	(24064, 111, '2015-01-15 00:30:22.000000', 'temperatura', 460.0000, 'ºC'),
	(24065, 111, '2015-01-15 00:30:23.000000', 'temperatura', 901.0000, 'ºC'),
	(24066, 111, '2015-01-15 00:30:24.000000', 'temperatura', 726.0000, 'ºC'),
	(24067, 111, '2015-01-15 00:30:25.000000', 'temperatura', 927.0000, 'ºC'),
	(24068, 111, '2015-01-15 00:30:26.000000', 'temperatura', 59.0000, 'ºC'),
	(24069, 111, '2015-01-15 00:30:27.000000', 'temperatura', 1115.0000, 'ºC'),
	(24070, 111, '2015-01-15 00:30:28.000000', 'temperatura', 597.0000, 'ºC'),
	(24071, 111, '2015-01-15 00:30:29.000000', 'temperatura', 839.0000, 'ºC'),
	(24072, 111, '2015-01-15 00:30:30.000000', 'temperatura', 5.0000, 'ºC'),
	(24073, 111, '2015-01-15 00:30:31.000000', 'temperatura', 1110.0000, 'ºC'),
	(24074, 111, '2015-01-15 00:30:32.000000', 'temperatura', 733.0000, 'ºC'),
	(24075, 111, '2015-01-15 00:30:33.000000', 'temperatura', 338.0000, 'ºC'),
	(24076, 111, '2015-01-15 00:30:34.000000', 'temperatura', 691.0000, 'ºC'),
	(24077, 111, '2015-01-15 00:30:35.000000', 'temperatura', 40.0000, 'ºC'),
	(24078, 111, '2015-01-15 00:30:36.000000', 'temperatura', 529.0000, 'ºC'),
	(24079, 111, '2015-01-15 00:30:37.000000', 'temperatura', 124.0000, 'ºC'),
	(24080, 111, '2015-01-15 00:30:38.000000', 'temperatura', 234.0000, 'ºC'),
	(24081, 111, '2015-01-15 00:30:39.000000', 'temperatura', 798.0000, 'ºC'),
	(24082, 111, '2015-01-15 00:30:40.000000', 'temperatura', 887.0000, 'ºC'),
	(24083, 111, '2015-01-15 00:30:41.000000', 'temperatura', 843.0000, 'ºC'),
	(24084, 111, '2015-01-15 00:30:42.000000', 'temperatura', 355.0000, 'ºC'),
	(24085, 111, '2015-01-15 00:30:43.000000', 'temperatura', 444.0000, 'ºC'),
	(24086, 111, '2015-01-15 00:30:44.000000', 'temperatura', 1159.0000, 'ºC'),
	(24087, 111, '2015-01-15 00:30:45.000000', 'temperatura', 862.0000, 'ºC'),
	(24088, 111, '2015-01-15 00:30:46.000000', 'temperatura', 832.0000, 'ºC'),
	(24089, 111, '2015-01-15 00:30:47.000000', 'temperatura', 376.0000, 'ºC'),
	(24090, 111, '2015-01-15 00:30:48.000000', 'temperatura', 582.0000, 'ºC'),
	(24091, 111, '2015-01-15 00:30:49.000000', 'temperatura', 586.0000, 'ºC'),
	(24092, 111, '2015-01-15 00:30:50.000000', 'temperatura', 1181.0000, 'ºC'),
	(24093, 111, '2015-01-15 00:30:51.000000', 'temperatura', 550.0000, 'ºC'),
	(24094, 111, '2015-01-15 00:30:52.000000', 'temperatura', 406.0000, 'ºC'),
	(24095, 111, '2015-01-15 00:30:53.000000', 'temperatura', 381.0000, 'ºC'),
	(24096, 111, '2015-01-15 00:30:54.000000', 'temperatura', 686.0000, 'ºC'),
	(24097, 111, '2015-01-15 00:30:55.000000', 'temperatura', 1089.0000, 'ºC'),
	(24098, 111, '2015-01-15 00:30:56.000000', 'temperatura', 986.0000, 'ºC'),
	(24099, 111, '2015-01-15 00:30:57.000000', 'temperatura', 465.0000, 'ºC'),
	(24100, 111, '2015-01-15 00:30:58.000000', 'temperatura', 567.0000, 'ºC'),
	(24101, 111, '2015-01-15 00:30:59.000000', 'temperatura', 242.0000, 'ºC'),
	(24102, 111, '2015-01-15 00:31:00.000000', 'temperatura', 708.0000, 'ºC'),
	(24103, 111, '2015-01-15 00:31:01.000000', 'temperatura', 414.0000, 'ºC'),
	(24104, 111, '2015-01-15 00:31:02.000000', 'temperatura', 1147.0000, 'ºC'),
	(24105, 111, '2015-01-15 00:31:03.000000', 'temperatura', 892.0000, 'ºC'),
	(24106, 111, '2015-01-15 00:31:04.000000', 'temperatura', 1023.0000, 'ºC'),
	(24107, 111, '2015-01-15 00:31:05.000000', 'temperatura', 36.0000, 'ºC'),
	(24108, 111, '2015-01-15 00:31:06.000000', 'temperatura', 711.0000, 'ºC'),
	(24109, 111, '2015-01-15 00:31:07.000000', 'temperatura', 1050.0000, 'ºC'),
	(24110, 111, '2015-01-15 00:31:08.000000', 'temperatura', 719.0000, 'ºC'),
	(24111, 111, '2015-01-15 00:31:09.000000', 'temperatura', 443.0000, 'ºC'),
	(24112, 111, '2015-01-15 00:31:10.000000', 'temperatura', 57.0000, 'ºC'),
	(24113, 111, '2015-01-15 00:31:11.000000', 'temperatura', 158.0000, 'ºC'),
	(24114, 111, '2015-01-15 00:31:12.000000', 'temperatura', 620.0000, 'ºC'),
	(24115, 111, '2015-01-15 00:31:13.000000', 'temperatura', 226.0000, 'ºC'),
	(24116, 111, '2015-01-15 00:31:14.000000', 'temperatura', 469.0000, 'ºC'),
	(24117, 111, '2015-01-15 00:31:15.000000', 'temperatura', 467.0000, 'ºC'),
	(24118, 111, '2015-01-15 00:31:16.000000', 'temperatura', 928.0000, 'ºC'),
	(24119, 111, '2015-01-15 00:31:17.000000', 'temperatura', 841.0000, 'ºC'),
	(24120, 111, '2015-01-15 00:31:18.000000', 'temperatura', 220.0000, 'ºC'),
	(24121, 111, '2015-01-15 00:31:19.000000', 'temperatura', 980.0000, 'ºC'),
	(24122, 111, '2015-01-15 00:31:20.000000', 'temperatura', 640.0000, 'ºC'),
	(24123, 111, '2015-01-15 00:31:21.000000', 'temperatura', 262.0000, 'ºC'),
	(24124, 111, '2015-01-15 00:31:22.000000', 'temperatura', 588.0000, 'ºC'),
	(24125, 111, '2015-01-15 00:31:23.000000', 'temperatura', 957.0000, 'ºC'),
	(24126, 111, '2015-01-15 00:31:24.000000', 'temperatura', 619.0000, 'ºC'),
	(24127, 111, '2015-01-15 00:31:25.000000', 'temperatura', 227.0000, 'ºC'),
	(24128, 111, '2015-01-15 00:31:26.000000', 'temperatura', 476.0000, 'ºC'),
	(24129, 111, '2015-01-15 00:31:27.000000', 'temperatura', 499.0000, 'ºC'),
	(24130, 111, '2015-01-15 00:31:28.000000', 'temperatura', 1069.0000, 'ºC'),
	(24131, 111, '2015-01-15 00:31:29.000000', 'temperatura', 250.0000, 'ºC'),
	(24132, 111, '2015-01-15 00:31:30.000000', 'temperatura', 442.0000, 'ºC'),
	(24133, 111, '2015-01-15 00:31:31.000000', 'temperatura', 262.0000, 'ºC'),
	(24134, 111, '2015-01-15 00:31:32.000000', 'temperatura', 1183.0000, 'ºC'),
	(24135, 111, '2015-01-15 00:31:33.000000', 'temperatura', 329.0000, 'ºC'),
	(24136, 111, '2015-01-15 00:31:34.000000', 'temperatura', 497.0000, 'ºC'),
	(24137, 111, '2015-01-15 00:31:35.000000', 'temperatura', 298.0000, 'ºC'),
	(24138, 111, '2015-01-15 00:31:36.000000', 'temperatura', 1199.0000, 'ºC'),
	(24139, 111, '2015-01-15 00:31:37.000000', 'temperatura', 303.0000, 'ºC'),
	(24140, 111, '2015-01-15 00:31:38.000000', 'temperatura', 320.0000, 'ºC'),
	(24141, 111, '2015-01-15 00:31:39.000000', 'temperatura', 688.0000, 'ºC'),
	(24142, 111, '2015-01-15 00:31:40.000000', 'temperatura', 83.0000, 'ºC'),
	(24143, 111, '2015-01-15 00:31:41.000000', 'temperatura', 752.0000, 'ºC'),
	(24144, 111, '2015-01-15 00:31:42.000000', 'temperatura', 1112.0000, 'ºC'),
	(24145, 111, '2015-01-15 00:31:43.000000', 'temperatura', 903.0000, 'ºC'),
	(24146, 111, '2015-01-15 00:31:44.000000', 'temperatura', 1181.0000, 'ºC'),
	(24147, 111, '2015-01-15 00:31:45.000000', 'temperatura', 796.0000, 'ºC'),
	(24148, 111, '2015-01-15 00:31:46.000000', 'temperatura', 437.0000, 'ºC'),
	(24149, 111, '2015-01-15 00:31:47.000000', 'temperatura', 997.0000, 'ºC'),
	(24150, 111, '2015-01-15 00:31:48.000000', 'temperatura', 76.0000, 'ºC'),
	(24151, 111, '2015-01-15 00:31:49.000000', 'temperatura', 987.0000, 'ºC'),
	(24152, 111, '2015-01-15 00:31:50.000000', 'temperatura', 1109.0000, 'ºC'),
	(24153, 111, '2015-01-15 00:31:51.000000', 'temperatura', 183.0000, 'ºC'),
	(24154, 111, '2015-01-15 00:31:52.000000', 'temperatura', 1189.0000, 'ºC'),
	(24155, 111, '2015-01-15 00:31:53.000000', 'temperatura', 595.0000, 'ºC'),
	(24156, 111, '2015-01-15 00:31:54.000000', 'temperatura', 609.0000, 'ºC'),
	(24157, 111, '2015-01-15 00:31:55.000000', 'temperatura', 61.0000, 'ºC'),
	(24158, 111, '2015-01-15 00:31:56.000000', 'temperatura', 879.0000, 'ºC'),
	(24159, 111, '2015-01-15 00:31:57.000000', 'temperatura', 612.0000, 'ºC'),
	(24160, 111, '2015-01-15 00:31:58.000000', 'temperatura', 422.0000, 'ºC'),
	(24161, 111, '2015-01-15 00:31:59.000000', 'temperatura', 274.0000, 'ºC'),
	(24162, 111, '2015-01-15 00:32:00.000000', 'temperatura', 104.0000, 'ºC'),
	(24163, 111, '2015-01-15 00:32:01.000000', 'temperatura', 898.0000, 'ºC'),
	(24164, 111, '2015-01-15 00:32:02.000000', 'temperatura', 579.0000, 'ºC'),
	(24165, 111, '2015-01-15 00:32:03.000000', 'temperatura', 203.0000, 'ºC'),
	(24166, 111, '2015-01-15 00:32:04.000000', 'temperatura', 479.0000, 'ºC'),
	(24167, 111, '2015-01-15 00:32:05.000000', 'temperatura', 585.0000, 'ºC'),
	(24168, 111, '2015-01-15 00:32:06.000000', 'temperatura', 288.0000, 'ºC'),
	(24169, 111, '2015-01-15 00:32:07.000000', 'temperatura', 886.0000, 'ºC'),
	(24170, 111, '2015-01-15 00:32:08.000000', 'temperatura', 1169.0000, 'ºC'),
	(24171, 111, '2015-01-15 00:32:09.000000', 'temperatura', 784.0000, 'ºC'),
	(24172, 111, '2015-01-15 00:32:10.000000', 'temperatura', 414.0000, 'ºC'),
	(24173, 111, '2015-01-15 00:32:11.000000', 'temperatura', 918.0000, 'ºC'),
	(24174, 111, '2015-01-15 00:32:12.000000', 'temperatura', 948.0000, 'ºC'),
	(24175, 111, '2015-01-15 00:32:13.000000', 'temperatura', 788.0000, 'ºC'),
	(24176, 111, '2015-01-15 00:32:14.000000', 'temperatura', 1096.0000, 'ºC'),
	(24177, 111, '2015-01-15 00:32:15.000000', 'temperatura', 718.0000, 'ºC'),
	(24178, 111, '2015-01-15 00:32:16.000000', 'temperatura', 301.0000, 'ºC'),
	(24179, 111, '2015-01-15 00:32:17.000000', 'temperatura', 554.0000, 'ºC'),
	(24180, 111, '2015-01-15 00:32:18.000000', 'temperatura', 664.0000, 'ºC'),
	(24181, 111, '2015-01-15 00:32:19.000000', 'temperatura', 459.0000, 'ºC'),
	(24182, 111, '2015-01-15 00:32:20.000000', 'temperatura', 305.0000, 'ºC'),
	(24183, 111, '2015-01-15 00:32:21.000000', 'temperatura', 149.0000, 'ºC'),
	(24184, 111, '2015-01-15 00:32:22.000000', 'temperatura', 1029.0000, 'ºC'),
	(24185, 111, '2015-01-15 00:32:23.000000', 'temperatura', 1100.0000, 'ºC'),
	(24186, 111, '2015-01-15 00:32:24.000000', 'temperatura', 14.0000, 'ºC'),
	(24187, 111, '2015-01-15 00:32:25.000000', 'temperatura', 371.0000, 'ºC'),
	(24188, 111, '2015-01-15 00:32:26.000000', 'temperatura', 611.0000, 'ºC'),
	(24189, 111, '2015-01-15 00:32:27.000000', 'temperatura', 744.0000, 'ºC'),
	(24190, 111, '2015-01-15 00:32:28.000000', 'temperatura', 689.0000, 'ºC'),
	(24191, 111, '2015-01-15 00:32:29.000000', 'temperatura', 13.0000, 'ºC'),
	(24192, 111, '2015-01-15 00:32:30.000000', 'temperatura', 399.0000, 'ºC'),
	(24193, 111, '2015-01-15 00:32:31.000000', 'temperatura', 757.0000, 'ºC'),
	(24194, 111, '2015-01-15 00:32:32.000000', 'temperatura', 186.0000, 'ºC'),
	(24195, 111, '2015-01-15 00:32:33.000000', 'temperatura', 1062.0000, 'ºC'),
	(24196, 111, '2015-01-15 00:32:34.000000', 'temperatura', 1153.0000, 'ºC'),
	(24197, 111, '2015-01-15 00:32:35.000000', 'temperatura', 179.0000, 'ºC'),
	(24198, 111, '2015-01-15 00:32:36.000000', 'temperatura', 1037.0000, 'ºC'),
	(24199, 111, '2015-01-15 00:32:37.000000', 'temperatura', 1047.0000, 'ºC'),
	(24200, 111, '2015-01-15 00:32:38.000000', 'temperatura', 925.0000, 'ºC'),
	(24201, 111, '2015-01-15 00:32:39.000000', 'temperatura', 285.0000, 'ºC'),
	(24202, 111, '2015-01-15 00:32:40.000000', 'temperatura', 1049.0000, 'ºC'),
	(24203, 111, '2015-01-15 00:32:41.000000', 'temperatura', 793.0000, 'ºC'),
	(24204, 111, '2015-01-15 00:32:42.000000', 'temperatura', 815.0000, 'ºC'),
	(24205, 111, '2015-01-15 00:32:43.000000', 'temperatura', 499.0000, 'ºC'),
	(24206, 111, '2015-01-15 00:32:44.000000', 'temperatura', 50.0000, 'ºC'),
	(24207, 111, '2015-01-15 00:32:45.000000', 'temperatura', 1154.0000, 'ºC'),
	(24208, 111, '2015-01-15 00:32:46.000000', 'temperatura', 821.0000, 'ºC'),
	(24209, 111, '2015-01-15 00:32:47.000000', 'temperatura', 642.0000, 'ºC'),
	(24210, 111, '2015-01-15 00:32:48.000000', 'temperatura', 746.0000, 'ºC'),
	(24211, 111, '2015-01-15 00:32:49.000000', 'temperatura', 608.0000, 'ºC'),
	(24212, 111, '2015-01-15 00:32:50.000000', 'temperatura', 800.0000, 'ºC'),
	(24213, 111, '2015-01-15 00:32:51.000000', 'temperatura', 977.0000, 'ºC'),
	(24214, 111, '2015-01-15 00:32:52.000000', 'temperatura', 85.0000, 'ºC'),
	(24215, 111, '2015-01-15 00:32:53.000000', 'temperatura', 1094.0000, 'ºC'),
	(24216, 111, '2015-01-15 00:32:54.000000', 'temperatura', 417.0000, 'ºC'),
	(24217, 111, '2015-01-15 00:32:55.000000', 'temperatura', 2.0000, 'ºC'),
	(24218, 111, '2015-01-15 00:32:56.000000', 'temperatura', 1162.0000, 'ºC'),
	(24219, 111, '2015-01-15 00:32:57.000000', 'temperatura', 1002.0000, 'ºC'),
	(24220, 111, '2015-01-15 00:32:58.000000', 'temperatura', 327.0000, 'ºC'),
	(24221, 111, '2015-01-15 00:32:59.000000', 'temperatura', 1029.0000, 'ºC'),
	(24222, 111, '2015-01-15 00:33:00.000000', 'temperatura', 563.0000, 'ºC'),
	(24223, 111, '2015-01-15 00:33:01.000000', 'temperatura', 929.0000, 'ºC'),
	(24224, 111, '2015-01-15 00:33:02.000000', 'temperatura', 555.0000, 'ºC'),
	(24225, 111, '2015-01-15 00:33:03.000000', 'temperatura', 1188.0000, 'ºC'),
	(24226, 111, '2015-01-15 00:33:04.000000', 'temperatura', 675.0000, 'ºC'),
	(24227, 111, '2015-01-15 00:33:05.000000', 'temperatura', 1011.0000, 'ºC'),
	(24228, 111, '2015-01-15 00:33:06.000000', 'temperatura', 633.0000, 'ºC'),
	(24229, 111, '2015-01-15 00:33:07.000000', 'temperatura', 131.0000, 'ºC'),
	(24230, 111, '2015-01-15 00:33:08.000000', 'temperatura', 1157.0000, 'ºC'),
	(24231, 111, '2015-01-15 00:33:09.000000', 'temperatura', 592.0000, 'ºC'),
	(24232, 111, '2015-01-15 00:33:10.000000', 'temperatura', 688.0000, 'ºC'),
	(24233, 111, '2015-01-15 00:33:11.000000', 'temperatura', 465.0000, 'ºC'),
	(24234, 111, '2015-01-15 00:33:12.000000', 'temperatura', 260.0000, 'ºC'),
	(24235, 111, '2015-01-15 00:33:13.000000', 'temperatura', 1107.0000, 'ºC'),
	(24236, 111, '2015-01-15 00:33:14.000000', 'temperatura', 1157.0000, 'ºC'),
	(24237, 111, '2015-01-15 00:33:15.000000', 'temperatura', 65.0000, 'ºC'),
	(24238, 111, '2015-01-15 00:33:16.000000', 'temperatura', 455.0000, 'ºC'),
	(24239, 111, '2015-01-15 00:33:17.000000', 'temperatura', 877.0000, 'ºC'),
	(24240, 111, '2015-01-15 00:33:18.000000', 'temperatura', 624.0000, 'ºC'),
	(24241, 111, '2015-01-15 00:33:19.000000', 'temperatura', 488.0000, 'ºC'),
	(24242, 111, '2015-01-15 00:33:20.000000', 'temperatura', 567.0000, 'ºC'),
	(24243, 111, '2015-01-15 00:33:21.000000', 'temperatura', 171.0000, 'ºC'),
	(24244, 111, '2015-01-15 00:33:22.000000', 'temperatura', 357.0000, 'ºC'),
	(24245, 111, '2015-01-15 00:33:23.000000', 'temperatura', 70.0000, 'ºC'),
	(24246, 111, '2015-01-15 00:33:24.000000', 'temperatura', 481.0000, 'ºC'),
	(24247, 111, '2015-01-15 00:33:25.000000', 'temperatura', 995.0000, 'ºC'),
	(24248, 111, '2015-01-15 00:33:26.000000', 'temperatura', 1133.0000, 'ºC'),
	(24249, 111, '2015-01-15 00:33:27.000000', 'temperatura', 279.0000, 'ºC'),
	(24250, 111, '2015-01-15 00:33:28.000000', 'temperatura', 398.0000, 'ºC'),
	(24251, 111, '2015-01-15 00:33:29.000000', 'temperatura', 1151.0000, 'ºC'),
	(24252, 111, '2015-01-15 00:33:30.000000', 'temperatura', 963.0000, 'ºC'),
	(24253, 111, '2015-01-15 00:33:31.000000', 'temperatura', 164.0000, 'ºC'),
	(24254, 111, '2015-01-15 00:33:32.000000', 'temperatura', 332.0000, 'ºC'),
	(24255, 111, '2015-01-15 00:33:33.000000', 'temperatura', 1166.0000, 'ºC'),
	(24256, 111, '2015-01-15 00:33:34.000000', 'temperatura', 36.0000, 'ºC'),
	(24257, 111, '2015-01-15 00:33:35.000000', 'temperatura', 283.0000, 'ºC'),
	(24258, 111, '2015-01-15 00:33:36.000000', 'temperatura', 106.0000, 'ºC'),
	(24259, 111, '2015-01-15 00:33:37.000000', 'temperatura', 884.0000, 'ºC'),
	(24260, 111, '2015-01-15 00:33:38.000000', 'temperatura', 500.0000, 'ºC'),
	(24261, 111, '2015-01-15 00:33:39.000000', 'temperatura', 1049.0000, 'ºC'),
	(24262, 111, '2015-01-15 00:33:40.000000', 'temperatura', 144.0000, 'ºC'),
	(24263, 111, '2015-01-15 00:33:41.000000', 'temperatura', 1173.0000, 'ºC'),
	(24264, 111, '2015-01-15 00:33:42.000000', 'temperatura', 635.0000, 'ºC'),
	(24265, 111, '2015-01-15 00:33:43.000000', 'temperatura', 855.0000, 'ºC'),
	(24266, 111, '2015-01-15 00:33:44.000000', 'temperatura', 1170.0000, 'ºC'),
	(24267, 111, '2015-01-15 00:33:45.000000', 'temperatura', 886.0000, 'ºC'),
	(24268, 111, '2015-01-15 00:33:46.000000', 'temperatura', 920.0000, 'ºC'),
	(24269, 111, '2015-01-15 00:33:47.000000', 'temperatura', 742.0000, 'ºC'),
	(24270, 111, '2015-01-15 00:33:48.000000', 'temperatura', 953.0000, 'ºC'),
	(24271, 111, '2015-01-15 00:33:49.000000', 'temperatura', 137.0000, 'ºC'),
	(24272, 111, '2015-01-15 00:33:50.000000', 'temperatura', 227.0000, 'ºC'),
	(24273, 111, '2015-01-15 00:33:51.000000', 'temperatura', 725.0000, 'ºC'),
	(24274, 111, '2015-01-15 00:33:52.000000', 'temperatura', 542.0000, 'ºC'),
	(24275, 111, '2015-01-15 00:33:53.000000', 'temperatura', 538.0000, 'ºC'),
	(24276, 111, '2015-01-15 00:33:54.000000', 'temperatura', 1064.0000, 'ºC'),
	(24277, 111, '2015-01-15 00:33:55.000000', 'temperatura', 107.0000, 'ºC'),
	(24278, 111, '2015-01-15 00:33:56.000000', 'temperatura', 944.0000, 'ºC'),
	(24279, 111, '2015-01-15 00:33:57.000000', 'temperatura', 797.0000, 'ºC'),
	(24280, 111, '2015-01-15 00:33:58.000000', 'temperatura', 1154.0000, 'ºC'),
	(24281, 111, '2015-01-15 00:33:59.000000', 'temperatura', 981.0000, 'ºC'),
	(24282, 111, '2015-01-15 00:34:00.000000', 'temperatura', 241.0000, 'ºC'),
	(24283, 111, '2015-01-15 00:34:01.000000', 'temperatura', 664.0000, 'ºC'),
	(24284, 111, '2015-01-15 00:34:02.000000', 'temperatura', 199.0000, 'ºC'),
	(24285, 111, '2015-01-15 00:34:03.000000', 'temperatura', 201.0000, 'ºC'),
	(24286, 111, '2015-01-15 00:34:04.000000', 'temperatura', 410.0000, 'ºC'),
	(24287, 111, '2015-01-15 00:34:05.000000', 'temperatura', 247.0000, 'ºC'),
	(24288, 111, '2015-01-15 00:34:06.000000', 'temperatura', 6.0000, 'ºC'),
	(24289, 111, '2015-01-15 00:34:07.000000', 'temperatura', 488.0000, 'ºC'),
	(24290, 111, '2015-01-15 00:34:08.000000', 'temperatura', 23.0000, 'ºC'),
	(24291, 111, '2015-01-15 00:34:09.000000', 'temperatura', 1051.0000, 'ºC'),
	(24292, 111, '2015-01-15 00:34:10.000000', 'temperatura', 385.0000, 'ºC'),
	(24293, 111, '2015-01-15 00:34:11.000000', 'temperatura', 1174.0000, 'ºC'),
	(24294, 111, '2015-01-15 00:34:12.000000', 'temperatura', 1115.0000, 'ºC'),
	(24295, 111, '2015-01-15 00:34:13.000000', 'temperatura', 856.0000, 'ºC'),
	(24296, 111, '2015-01-15 00:34:14.000000', 'temperatura', 933.0000, 'ºC'),
	(24297, 111, '2015-01-15 00:34:15.000000', 'temperatura', 897.0000, 'ºC'),
	(24298, 111, '2015-01-15 00:34:16.000000', 'temperatura', 486.0000, 'ºC'),
	(24299, 111, '2015-01-15 00:34:17.000000', 'temperatura', 941.0000, 'ºC'),
	(24300, 111, '2015-01-15 00:34:18.000000', 'temperatura', 849.0000, 'ºC'),
	(24301, 111, '2015-01-15 00:34:19.000000', 'temperatura', 221.0000, 'ºC'),
	(24302, 111, '2015-01-15 00:34:20.000000', 'temperatura', 959.0000, 'ºC'),
	(24303, 111, '2015-01-15 00:34:21.000000', 'temperatura', 530.0000, 'ºC'),
	(24304, 111, '2015-01-15 00:34:22.000000', 'temperatura', 976.0000, 'ºC'),
	(24305, 111, '2015-01-15 00:34:23.000000', 'temperatura', 892.0000, 'ºC'),
	(24306, 111, '2015-01-15 00:34:24.000000', 'temperatura', 331.0000, 'ºC'),
	(24307, 111, '2015-01-15 00:34:25.000000', 'temperatura', 178.0000, 'ºC'),
	(24308, 111, '2015-01-15 00:34:26.000000', 'temperatura', 1100.0000, 'ºC'),
	(24309, 111, '2015-01-15 00:34:27.000000', 'temperatura', 166.0000, 'ºC'),
	(24310, 111, '2015-01-15 00:34:28.000000', 'temperatura', 1132.0000, 'ºC'),
	(24311, 111, '2015-01-15 00:34:29.000000', 'temperatura', 360.0000, 'ºC'),
	(24312, 111, '2015-01-15 00:34:30.000000', 'temperatura', 804.0000, 'ºC'),
	(24313, 111, '2015-01-15 00:34:31.000000', 'temperatura', 540.0000, 'ºC'),
	(24314, 111, '2015-01-15 00:34:32.000000', 'temperatura', 288.0000, 'ºC'),
	(24315, 111, '2015-01-15 00:34:33.000000', 'temperatura', 1020.0000, 'ºC'),
	(24316, 111, '2015-01-15 00:34:34.000000', 'temperatura', 637.0000, 'ºC'),
	(24317, 111, '2015-01-15 00:34:35.000000', 'temperatura', 127.0000, 'ºC'),
	(24318, 111, '2015-01-15 00:34:36.000000', 'temperatura', 1126.0000, 'ºC'),
	(24319, 111, '2015-01-15 00:34:37.000000', 'temperatura', 447.0000, 'ºC'),
	(24320, 111, '2015-01-15 00:34:38.000000', 'temperatura', 58.0000, 'ºC'),
	(24321, 111, '2015-01-15 00:34:39.000000', 'temperatura', 148.0000, 'ºC'),
	(24322, 111, '2015-01-15 00:34:40.000000', 'temperatura', 568.0000, 'ºC'),
	(24323, 111, '2015-01-15 00:34:41.000000', 'temperatura', 1197.0000, 'ºC'),
	(24324, 111, '2015-01-15 00:34:42.000000', 'temperatura', 680.0000, 'ºC'),
	(24325, 111, '2015-01-15 00:34:43.000000', 'temperatura', 1010.0000, 'ºC'),
	(24326, 111, '2015-01-15 00:34:44.000000', 'temperatura', 610.0000, 'ºC'),
	(24327, 111, '2015-01-15 00:34:45.000000', 'temperatura', 21.0000, 'ºC'),
	(24328, 111, '2015-01-15 00:34:46.000000', 'temperatura', 675.0000, 'ºC'),
	(24329, 111, '2015-01-15 00:34:47.000000', 'temperatura', 913.0000, 'ºC'),
	(24330, 111, '2015-01-15 00:34:48.000000', 'temperatura', 140.0000, 'ºC'),
	(24331, 111, '2015-01-15 00:34:49.000000', 'temperatura', 360.0000, 'ºC'),
	(24332, 111, '2015-01-15 00:34:50.000000', 'temperatura', 180.0000, 'ºC'),
	(24333, 111, '2015-01-15 00:34:51.000000', 'temperatura', 1023.0000, 'ºC'),
	(24334, 111, '2015-01-15 00:34:52.000000', 'temperatura', 974.0000, 'ºC'),
	(24335, 111, '2015-01-15 00:34:53.000000', 'temperatura', 600.0000, 'ºC'),
	(24336, 111, '2015-01-15 00:34:54.000000', 'temperatura', 81.0000, 'ºC'),
	(24337, 111, '2015-01-15 00:34:55.000000', 'temperatura', 1006.0000, 'ºC'),
	(24338, 111, '2015-01-15 00:34:56.000000', 'temperatura', 1187.0000, 'ºC'),
	(24339, 111, '2015-01-15 00:34:57.000000', 'temperatura', 517.0000, 'ºC'),
	(24340, 111, '2015-01-15 00:34:58.000000', 'temperatura', 224.0000, 'ºC'),
	(24341, 111, '2015-01-15 00:34:59.000000', 'temperatura', 770.0000, 'ºC'),
	(24342, 111, '2015-01-15 00:35:00.000000', 'temperatura', 779.0000, 'ºC'),
	(24343, 111, '2015-01-15 00:35:01.000000', 'temperatura', 384.0000, 'ºC'),
	(24344, 111, '2015-01-15 00:35:02.000000', 'temperatura', 782.0000, 'ºC'),
	(24345, 111, '2015-01-15 00:35:03.000000', 'temperatura', 362.0000, 'ºC'),
	(24346, 111, '2015-01-15 00:35:04.000000', 'temperatura', 663.0000, 'ºC'),
	(24347, 111, '2015-01-15 00:35:05.000000', 'temperatura', 1032.0000, 'ºC'),
	(24348, 111, '2015-01-15 00:35:06.000000', 'temperatura', 768.0000, 'ºC'),
	(24349, 111, '2015-01-15 00:35:07.000000', 'temperatura', 746.0000, 'ºC'),
	(24350, 111, '2015-01-15 00:35:08.000000', 'temperatura', 225.0000, 'ºC'),
	(24351, 111, '2015-01-15 00:35:09.000000', 'temperatura', 89.0000, 'ºC'),
	(24352, 111, '2015-01-15 00:35:10.000000', 'temperatura', 969.0000, 'ºC'),
	(24353, 111, '2015-01-15 00:35:11.000000', 'temperatura', 979.0000, 'ºC'),
	(24354, 111, '2015-01-15 00:35:12.000000', 'temperatura', 789.0000, 'ºC'),
	(24355, 111, '2015-01-15 00:35:13.000000', 'temperatura', 1007.0000, 'ºC'),
	(24356, 111, '2015-01-15 00:35:14.000000', 'temperatura', 271.0000, 'ºC'),
	(24357, 111, '2015-01-15 00:35:15.000000', 'temperatura', 734.0000, 'ºC'),
	(24358, 111, '2015-01-15 00:35:16.000000', 'temperatura', 457.0000, 'ºC'),
	(24359, 111, '2015-01-15 00:35:17.000000', 'temperatura', 83.0000, 'ºC'),
	(24360, 111, '2015-01-15 00:35:18.000000', 'temperatura', 245.0000, 'ºC'),
	(24361, 111, '2015-01-15 00:35:19.000000', 'temperatura', 978.0000, 'ºC'),
	(24362, 111, '2015-01-15 00:35:20.000000', 'temperatura', 556.0000, 'ºC'),
	(24363, 111, '2015-01-15 00:35:21.000000', 'temperatura', 1044.0000, 'ºC'),
	(24364, 111, '2015-01-15 00:35:22.000000', 'temperatura', 1154.0000, 'ºC'),
	(24365, 111, '2015-01-15 00:35:23.000000', 'temperatura', 240.0000, 'ºC'),
	(24366, 111, '2015-01-15 00:35:24.000000', 'temperatura', 138.0000, 'ºC'),
	(24367, 111, '2015-01-15 00:35:25.000000', 'temperatura', 1168.0000, 'ºC'),
	(24368, 111, '2015-01-15 00:35:26.000000', 'temperatura', 629.0000, 'ºC'),
	(24369, 111, '2015-01-15 00:35:27.000000', 'temperatura', 840.0000, 'ºC'),
	(24370, 111, '2015-01-15 00:35:28.000000', 'temperatura', 1116.0000, 'ºC'),
	(24371, 111, '2015-01-15 00:35:29.000000', 'temperatura', 657.0000, 'ºC'),
	(24372, 111, '2015-01-15 00:35:30.000000', 'temperatura', 1140.0000, 'ºC'),
	(24373, 111, '2015-01-15 00:35:31.000000', 'temperatura', 129.0000, 'ºC'),
	(24374, 111, '2015-01-15 00:35:32.000000', 'temperatura', 826.0000, 'ºC'),
	(24375, 111, '2015-01-15 00:35:33.000000', 'temperatura', 145.0000, 'ºC'),
	(24376, 111, '2015-01-15 00:35:34.000000', 'temperatura', 646.0000, 'ºC'),
	(24377, 111, '2015-01-15 00:35:35.000000', 'temperatura', 396.0000, 'ºC'),
	(24378, 111, '2015-01-15 00:35:36.000000', 'temperatura', 43.0000, 'ºC'),
	(24379, 111, '2015-01-15 00:35:37.000000', 'temperatura', 227.0000, 'ºC'),
	(24380, 111, '2015-01-15 00:35:38.000000', 'temperatura', 1007.0000, 'ºC'),
	(24381, 111, '2015-01-15 00:35:39.000000', 'temperatura', 753.0000, 'ºC'),
	(24382, 111, '2015-01-15 00:35:40.000000', 'temperatura', 746.0000, 'ºC'),
	(24383, 111, '2015-01-15 00:35:41.000000', 'temperatura', 273.0000, 'ºC'),
	(24384, 111, '2015-01-15 00:35:42.000000', 'temperatura', 324.0000, 'ºC'),
	(24385, 111, '2015-01-15 00:35:43.000000', 'temperatura', 805.0000, 'ºC'),
	(24386, 111, '2015-01-15 00:35:44.000000', 'temperatura', 652.0000, 'ºC'),
	(24387, 111, '2015-01-15 00:35:45.000000', 'temperatura', 844.0000, 'ºC'),
	(24388, 111, '2015-01-15 00:35:46.000000', 'temperatura', 1066.0000, 'ºC'),
	(24389, 111, '2015-01-15 00:35:47.000000', 'temperatura', 397.0000, 'ºC'),
	(24390, 111, '2015-01-15 00:35:48.000000', 'temperatura', 1187.0000, 'ºC'),
	(24391, 111, '2015-01-15 00:35:49.000000', 'temperatura', 1144.0000, 'ºC'),
	(24392, 111, '2015-01-15 00:35:50.000000', 'temperatura', 962.0000, 'ºC'),
	(24393, 111, '2015-01-15 00:35:51.000000', 'temperatura', 177.0000, 'ºC'),
	(24394, 111, '2015-01-15 00:35:52.000000', 'temperatura', 400.0000, 'ºC'),
	(24395, 111, '2015-01-15 00:35:53.000000', 'temperatura', 268.0000, 'ºC'),
	(24396, 111, '2015-01-15 00:35:54.000000', 'temperatura', 140.0000, 'ºC'),
	(24397, 111, '2015-01-15 00:35:55.000000', 'temperatura', 1097.0000, 'ºC'),
	(24398, 111, '2015-01-15 00:35:56.000000', 'temperatura', 264.0000, 'ºC'),
	(24399, 111, '2015-01-15 00:35:57.000000', 'temperatura', 430.0000, 'ºC'),
	(24400, 111, '2015-01-15 00:35:58.000000', 'temperatura', 161.0000, 'ºC'),
	(24401, 111, '2015-01-15 00:35:59.000000', 'temperatura', 713.0000, 'ºC'),
	(24402, 111, '2015-01-15 00:36:00.000000', 'temperatura', 684.0000, 'ºC'),
	(24403, 111, '2015-01-15 00:36:01.000000', 'temperatura', 81.0000, 'ºC'),
	(24404, 111, '2015-01-15 00:36:02.000000', 'temperatura', 753.0000, 'ºC'),
	(24405, 111, '2015-01-15 00:36:03.000000', 'temperatura', 1122.0000, 'ºC'),
	(24406, 111, '2015-01-15 00:36:04.000000', 'temperatura', 950.0000, 'ºC'),
	(24407, 111, '2015-01-15 00:36:05.000000', 'temperatura', 187.0000, 'ºC'),
	(24408, 111, '2015-01-15 00:36:06.000000', 'temperatura', 483.0000, 'ºC'),
	(24409, 111, '2015-01-15 00:36:07.000000', 'temperatura', 658.0000, 'ºC'),
	(24410, 111, '2015-01-15 00:36:08.000000', 'temperatura', 638.0000, 'ºC'),
	(24411, 111, '2015-01-15 00:36:09.000000', 'temperatura', 17.0000, 'ºC'),
	(24412, 111, '2015-01-15 00:36:10.000000', 'temperatura', 572.0000, 'ºC'),
	(24413, 111, '2015-01-15 00:36:11.000000', 'temperatura', 410.0000, 'ºC'),
	(24414, 111, '2015-01-15 00:36:12.000000', 'temperatura', 336.0000, 'ºC'),
	(24415, 111, '2015-01-15 00:36:13.000000', 'temperatura', 450.0000, 'ºC'),
	(24416, 111, '2015-01-15 00:36:14.000000', 'temperatura', 43.0000, 'ºC'),
	(24417, 111, '2015-01-15 00:36:15.000000', 'temperatura', 66.0000, 'ºC'),
	(24418, 111, '2015-01-15 00:36:16.000000', 'temperatura', 200.0000, 'ºC'),
	(24419, 111, '2015-01-15 00:36:17.000000', 'temperatura', 801.0000, 'ºC'),
	(24420, 111, '2015-01-15 00:36:18.000000', 'temperatura', 1009.0000, 'ºC'),
	(24421, 111, '2015-01-15 00:36:19.000000', 'temperatura', 241.0000, 'ºC'),
	(24422, 111, '2015-01-15 00:36:20.000000', 'temperatura', 578.0000, 'ºC'),
	(24423, 111, '2015-01-15 00:36:21.000000', 'temperatura', 967.0000, 'ºC'),
	(24424, 111, '2015-01-15 00:36:22.000000', 'temperatura', 701.0000, 'ºC'),
	(24425, 111, '2015-01-15 00:36:23.000000', 'temperatura', 607.0000, 'ºC'),
	(24426, 111, '2015-01-15 00:36:24.000000', 'temperatura', 930.0000, 'ºC'),
	(24427, 111, '2015-01-15 00:36:25.000000', 'temperatura', 429.0000, 'ºC'),
	(24428, 111, '2015-01-15 00:36:26.000000', 'temperatura', 556.0000, 'ºC'),
	(24429, 111, '2015-01-15 00:36:27.000000', 'temperatura', 293.0000, 'ºC'),
	(24430, 111, '2015-01-15 00:36:28.000000', 'temperatura', 999.0000, 'ºC'),
	(24431, 111, '2015-01-15 00:36:29.000000', 'temperatura', 517.0000, 'ºC'),
	(24432, 111, '2015-01-15 00:36:30.000000', 'temperatura', 790.0000, 'ºC'),
	(24433, 111, '2015-01-15 00:36:31.000000', 'temperatura', 1197.0000, 'ºC'),
	(24434, 111, '2015-01-15 00:36:32.000000', 'temperatura', 16.0000, 'ºC'),
	(24435, 111, '2015-01-15 00:36:33.000000', 'temperatura', 91.0000, 'ºC'),
	(24436, 111, '2015-01-15 00:36:34.000000', 'temperatura', 408.0000, 'ºC'),
	(24437, 111, '2015-01-15 00:36:35.000000', 'temperatura', 566.0000, 'ºC'),
	(24438, 111, '2015-01-15 00:36:36.000000', 'temperatura', 407.0000, 'ºC'),
	(24439, 111, '2015-01-15 00:36:37.000000', 'temperatura', 339.0000, 'ºC'),
	(24440, 111, '2015-01-15 00:36:38.000000', 'temperatura', 472.0000, 'ºC'),
	(24441, 111, '2015-01-15 00:36:39.000000', 'temperatura', 144.0000, 'ºC'),
	(24442, 111, '2015-01-15 00:36:40.000000', 'temperatura', 503.0000, 'ºC'),
	(24443, 111, '2015-01-15 00:36:41.000000', 'temperatura', 885.0000, 'ºC'),
	(24444, 111, '2015-01-15 00:36:42.000000', 'temperatura', 516.0000, 'ºC'),
	(24445, 111, '2015-01-15 00:36:43.000000', 'temperatura', 1126.0000, 'ºC'),
	(24446, 111, '2015-01-15 00:36:44.000000', 'temperatura', 483.0000, 'ºC'),
	(24447, 111, '2015-01-15 00:36:45.000000', 'temperatura', 239.0000, 'ºC'),
	(24448, 111, '2015-01-15 00:36:46.000000', 'temperatura', 945.0000, 'ºC'),
	(24449, 111, '2015-01-15 00:36:47.000000', 'temperatura', 409.0000, 'ºC'),
	(24450, 111, '2015-01-15 00:36:48.000000', 'temperatura', 410.0000, 'ºC'),
	(24451, 111, '2015-01-15 00:36:49.000000', 'temperatura', 824.0000, 'ºC'),
	(24452, 111, '2015-01-15 00:36:50.000000', 'temperatura', 491.0000, 'ºC'),
	(24453, 111, '2015-01-15 00:36:51.000000', 'temperatura', 1182.0000, 'ºC'),
	(24454, 111, '2015-01-15 00:36:52.000000', 'temperatura', 836.0000, 'ºC'),
	(24455, 111, '2015-01-15 00:36:53.000000', 'temperatura', 637.0000, 'ºC'),
	(24456, 111, '2015-01-15 00:36:54.000000', 'temperatura', 677.0000, 'ºC'),
	(24457, 111, '2015-01-15 00:36:55.000000', 'temperatura', 276.0000, 'ºC'),
	(24458, 111, '2015-01-15 00:36:56.000000', 'temperatura', 549.0000, 'ºC'),
	(24459, 111, '2015-01-15 00:36:57.000000', 'temperatura', 716.0000, 'ºC'),
	(24460, 111, '2015-01-15 00:36:58.000000', 'temperatura', 736.0000, 'ºC'),
	(24461, 111, '2015-01-15 00:36:59.000000', 'temperatura', 333.0000, 'ºC'),
	(24462, 111, '2015-01-15 00:37:00.000000', 'temperatura', 656.0000, 'ºC'),
	(24463, 111, '2015-01-15 00:37:01.000000', 'temperatura', 1080.0000, 'ºC'),
	(24464, 111, '2015-01-15 00:37:02.000000', 'temperatura', 1034.0000, 'ºC'),
	(24465, 111, '2015-01-15 00:37:03.000000', 'temperatura', 732.0000, 'ºC'),
	(24466, 111, '2015-01-15 00:37:04.000000', 'temperatura', 558.0000, 'ºC'),
	(24467, 111, '2015-01-15 00:37:05.000000', 'temperatura', 594.0000, 'ºC'),
	(24468, 111, '2015-01-15 00:37:06.000000', 'temperatura', 98.0000, 'ºC'),
	(24469, 111, '2015-01-15 00:37:07.000000', 'temperatura', 1106.0000, 'ºC'),
	(24470, 111, '2015-01-15 00:37:08.000000', 'temperatura', 439.0000, 'ºC'),
	(24471, 111, '2015-01-15 00:37:09.000000', 'temperatura', 76.0000, 'ºC'),
	(24472, 111, '2015-01-15 00:37:10.000000', 'temperatura', 262.0000, 'ºC'),
	(24473, 111, '2015-01-15 00:37:11.000000', 'temperatura', 1083.0000, 'ºC'),
	(24474, 111, '2015-01-15 00:37:12.000000', 'temperatura', 1030.0000, 'ºC'),
	(24475, 111, '2015-01-15 00:37:13.000000', 'temperatura', 700.0000, 'ºC'),
	(24476, 111, '2015-01-15 00:37:14.000000', 'temperatura', 411.0000, 'ºC'),
	(24477, 111, '2015-01-15 00:37:15.000000', 'temperatura', 1158.0000, 'ºC'),
	(24478, 111, '2015-01-15 00:37:16.000000', 'temperatura', 955.0000, 'ºC'),
	(24479, 111, '2015-01-15 00:37:17.000000', 'temperatura', 101.0000, 'ºC'),
	(24480, 111, '2015-01-15 00:37:18.000000', 'temperatura', 40.0000, 'ºC'),
	(24481, 111, '2015-01-15 00:37:19.000000', 'temperatura', 1097.0000, 'ºC'),
	(24482, 111, '2015-01-15 00:37:20.000000', 'temperatura', 566.0000, 'ºC'),
	(24483, 111, '2015-01-15 00:37:21.000000', 'temperatura', 740.0000, 'ºC'),
	(24484, 111, '2015-01-15 00:37:22.000000', 'temperatura', 801.0000, 'ºC'),
	(24485, 111, '2015-01-15 00:37:23.000000', 'temperatura', 588.0000, 'ºC'),
	(24486, 111, '2015-01-15 00:37:24.000000', 'temperatura', 536.0000, 'ºC'),
	(24487, 111, '2015-01-15 00:37:25.000000', 'temperatura', 918.0000, 'ºC'),
	(24488, 111, '2015-01-15 00:37:26.000000', 'temperatura', 581.0000, 'ºC'),
	(24489, 111, '2015-01-15 00:37:27.000000', 'temperatura', 151.0000, 'ºC'),
	(24490, 111, '2015-01-15 00:37:28.000000', 'temperatura', 213.0000, 'ºC'),
	(24491, 111, '2015-01-15 00:37:29.000000', 'temperatura', 613.0000, 'ºC'),
	(24492, 111, '2015-01-15 00:37:30.000000', 'temperatura', 26.0000, 'ºC'),
	(24493, 111, '2015-01-15 00:37:31.000000', 'temperatura', 693.0000, 'ºC'),
	(24494, 111, '2015-01-15 00:37:32.000000', 'temperatura', 984.0000, 'ºC'),
	(24495, 111, '2015-01-15 00:37:33.000000', 'temperatura', 445.0000, 'ºC'),
	(24496, 111, '2015-01-15 00:37:34.000000', 'temperatura', 473.0000, 'ºC'),
	(24497, 111, '2015-01-15 00:37:35.000000', 'temperatura', 1032.0000, 'ºC'),
	(24498, 111, '2015-01-15 00:37:36.000000', 'temperatura', 138.0000, 'ºC'),
	(24499, 111, '2015-01-15 00:37:37.000000', 'temperatura', 1196.0000, 'ºC'),
	(24500, 111, '2015-01-15 00:37:38.000000', 'temperatura', 766.0000, 'ºC'),
	(24501, 111, '2015-01-15 00:37:39.000000', 'temperatura', 243.0000, 'ºC'),
	(24502, 111, '2015-01-15 00:37:40.000000', 'temperatura', 119.0000, 'ºC'),
	(24503, 111, '2015-01-15 00:37:41.000000', 'temperatura', 1066.0000, 'ºC'),
	(24504, 111, '2015-01-15 00:37:42.000000', 'temperatura', 172.0000, 'ºC'),
	(24505, 111, '2015-01-15 00:37:43.000000', 'temperatura', 61.0000, 'ºC'),
	(24506, 111, '2015-01-15 00:37:44.000000', 'temperatura', 993.0000, 'ºC'),
	(24507, 111, '2015-01-15 00:37:45.000000', 'temperatura', 1182.0000, 'ºC'),
	(24508, 111, '2015-01-15 00:37:46.000000', 'temperatura', 531.0000, 'ºC'),
	(24509, 111, '2015-01-15 00:37:47.000000', 'temperatura', 309.0000, 'ºC'),
	(24510, 111, '2015-01-15 00:37:48.000000', 'temperatura', 1154.0000, 'ºC'),
	(24511, 111, '2015-01-15 00:37:49.000000', 'temperatura', 44.0000, 'ºC'),
	(24512, 111, '2015-01-15 00:37:50.000000', 'temperatura', 357.0000, 'ºC'),
	(24513, 111, '2015-01-15 00:37:51.000000', 'temperatura', 456.0000, 'ºC'),
	(24514, 111, '2015-01-15 00:37:52.000000', 'temperatura', 8.0000, 'ºC'),
	(24515, 111, '2015-01-15 00:37:53.000000', 'temperatura', 1073.0000, 'ºC'),
	(24516, 111, '2015-01-15 00:37:54.000000', 'temperatura', 543.0000, 'ºC'),
	(24517, 111, '2015-01-15 00:37:55.000000', 'temperatura', 696.0000, 'ºC'),
	(24518, 111, '2015-01-15 00:37:56.000000', 'temperatura', 649.0000, 'ºC'),
	(24519, 111, '2015-01-15 00:37:57.000000', 'temperatura', 1159.0000, 'ºC'),
	(24520, 111, '2015-01-15 00:37:58.000000', 'temperatura', 249.0000, 'ºC'),
	(24521, 111, '2015-01-15 00:37:59.000000', 'temperatura', 167.0000, 'ºC'),
	(24522, 111, '2015-01-15 00:38:00.000000', 'temperatura', 90.0000, 'ºC'),
	(24523, 111, '2015-01-15 00:38:01.000000', 'temperatura', 1147.0000, 'ºC'),
	(24524, 111, '2015-01-15 00:38:02.000000', 'temperatura', 667.0000, 'ºC'),
	(24525, 111, '2015-01-15 00:38:03.000000', 'temperatura', 1093.0000, 'ºC'),
	(24526, 111, '2015-01-15 00:38:04.000000', 'temperatura', 1068.0000, 'ºC'),
	(24527, 111, '2015-01-15 00:38:05.000000', 'temperatura', 858.0000, 'ºC'),
	(24528, 111, '2015-01-15 00:38:06.000000', 'temperatura', 1088.0000, 'ºC'),
	(24529, 111, '2015-01-15 00:38:07.000000', 'temperatura', 468.0000, 'ºC'),
	(24530, 111, '2015-01-15 00:38:08.000000', 'temperatura', 275.0000, 'ºC'),
	(24531, 111, '2015-01-15 00:38:09.000000', 'temperatura', 1174.0000, 'ºC'),
	(24532, 111, '2015-01-15 00:38:10.000000', 'temperatura', 242.0000, 'ºC'),
	(24533, 111, '2015-01-15 00:38:11.000000', 'temperatura', 90.0000, 'ºC'),
	(24534, 111, '2015-01-15 00:38:12.000000', 'temperatura', 926.0000, 'ºC'),
	(24535, 111, '2015-01-15 00:38:13.000000', 'temperatura', 760.0000, 'ºC'),
	(24536, 111, '2015-01-15 00:38:14.000000', 'temperatura', 1021.0000, 'ºC'),
	(24537, 111, '2015-01-15 00:38:15.000000', 'temperatura', 427.0000, 'ºC'),
	(24538, 111, '2015-01-15 00:38:16.000000', 'temperatura', 270.0000, 'ºC'),
	(24539, 111, '2015-01-15 00:38:17.000000', 'temperatura', 71.0000, 'ºC'),
	(24540, 111, '2015-01-15 00:38:18.000000', 'temperatura', 746.0000, 'ºC'),
	(24541, 111, '2015-01-15 00:38:19.000000', 'temperatura', 1117.0000, 'ºC'),
	(24542, 111, '2015-01-15 00:38:20.000000', 'temperatura', 947.0000, 'ºC'),
	(24543, 111, '2015-01-15 00:38:21.000000', 'temperatura', 187.0000, 'ºC'),
	(24544, 111, '2015-01-15 00:38:22.000000', 'temperatura', 493.0000, 'ºC'),
	(24545, 111, '2015-01-15 00:38:23.000000', 'temperatura', 703.0000, 'ºC'),
	(24546, 111, '2015-01-15 00:38:24.000000', 'temperatura', 836.0000, 'ºC'),
	(24547, 111, '2015-01-15 00:38:25.000000', 'temperatura', 874.0000, 'ºC'),
	(24548, 111, '2015-01-15 00:38:26.000000', 'temperatura', 662.0000, 'ºC'),
	(24549, 111, '2015-01-15 00:38:27.000000', 'temperatura', 688.0000, 'ºC'),
	(24550, 111, '2015-01-15 00:38:28.000000', 'temperatura', 255.0000, 'ºC'),
	(24551, 111, '2015-01-15 00:38:29.000000', 'temperatura', 411.0000, 'ºC'),
	(24552, 111, '2015-01-15 00:38:30.000000', 'temperatura', 92.0000, 'ºC'),
	(24553, 111, '2015-01-15 00:38:31.000000', 'temperatura', 426.0000, 'ºC'),
	(24554, 111, '2015-01-15 00:38:32.000000', 'temperatura', 655.0000, 'ºC'),
	(24555, 111, '2015-01-15 00:38:33.000000', 'temperatura', 796.0000, 'ºC'),
	(24556, 111, '2015-01-15 00:38:34.000000', 'temperatura', 817.0000, 'ºC'),
	(24557, 111, '2015-01-15 00:38:35.000000', 'temperatura', 495.0000, 'ºC'),
	(24558, 111, '2015-01-15 00:38:36.000000', 'temperatura', 27.0000, 'ºC'),
	(24559, 111, '2015-01-15 00:38:37.000000', 'temperatura', 1048.0000, 'ºC'),
	(24560, 111, '2015-01-15 00:38:38.000000', 'temperatura', 362.0000, 'ºC'),
	(24561, 111, '2015-01-15 00:38:39.000000', 'temperatura', 1065.0000, 'ºC'),
	(24562, 111, '2015-01-15 00:38:40.000000', 'temperatura', 642.0000, 'ºC'),
	(24563, 111, '2015-01-15 00:38:41.000000', 'temperatura', 14.0000, 'ºC'),
	(24564, 111, '2015-01-15 00:38:42.000000', 'temperatura', 546.0000, 'ºC'),
	(24565, 111, '2015-01-15 00:38:43.000000', 'temperatura', 286.0000, 'ºC'),
	(24566, 111, '2015-01-15 00:38:44.000000', 'temperatura', 994.0000, 'ºC'),
	(24567, 111, '2015-01-15 00:38:45.000000', 'temperatura', 514.0000, 'ºC'),
	(24568, 111, '2015-01-15 00:38:46.000000', 'temperatura', 786.0000, 'ºC'),
	(24569, 111, '2015-01-15 00:38:47.000000', 'temperatura', 1190.0000, 'ºC'),
	(24570, 111, '2015-01-15 00:38:48.000000', 'temperatura', 1192.0000, 'ºC'),
	(24571, 111, '2015-01-15 00:38:49.000000', 'temperatura', 1188.0000, 'ºC'),
	(24572, 111, '2015-01-15 00:38:50.000000', 'temperatura', 1168.0000, 'ºC'),
	(24573, 111, '2015-01-15 00:38:51.000000', 'temperatura', 1075.0000, 'ºC'),
	(24574, 111, '2015-01-15 00:38:52.000000', 'temperatura', 672.0000, 'ºC'),
	(24575, 111, '2015-01-15 00:38:53.000000', 'temperatura', 136.0000, 'ºC'),
	(24576, 111, '2015-01-15 00:38:54.000000', 'temperatura', 1066.0000, 'ºC'),
	(24577, 111, '2015-01-15 00:38:55.000000', 'temperatura', 119.0000, 'ºC'),
	(24578, 111, '2015-01-15 00:38:56.000000', 'temperatura', 1000.0000, 'ºC'),
	(24579, 111, '2015-01-15 00:38:57.000000', 'temperatura', 1043.0000, 'ºC'),
	(24580, 111, '2015-01-15 00:38:58.000000', 'temperatura', 1016.0000, 'ºC'),
	(24581, 111, '2015-01-15 00:38:59.000000', 'temperatura', 751.0000, 'ºC'),
	(24582, 111, '2015-01-15 00:39:00.000000', 'temperatura', 709.0000, 'ºC'),
	(24583, 111, '2015-01-15 00:39:01.000000', 'temperatura', 92.0000, 'ºC'),
	(24584, 111, '2015-01-15 00:39:02.000000', 'temperatura', 734.0000, 'ºC'),
	(24585, 111, '2015-01-15 00:39:03.000000', 'temperatura', 993.0000, 'ºC'),
	(24586, 111, '2015-01-15 00:39:04.000000', 'temperatura', 364.0000, 'ºC'),
	(24587, 111, '2015-01-15 00:39:05.000000', 'temperatura', 40.0000, 'ºC'),
	(24588, 111, '2015-01-15 00:39:06.000000', 'temperatura', 312.0000, 'ºC'),
	(24589, 111, '2015-01-15 00:39:07.000000', 'temperatura', 237.0000, 'ºC'),
	(24590, 111, '2015-01-15 00:39:08.000000', 'temperatura', 252.0000, 'ºC'),
	(24591, 111, '2015-01-15 00:39:09.000000', 'temperatura', 548.0000, 'ºC'),
	(24592, 111, '2015-01-15 00:39:10.000000', 'temperatura', 787.0000, 'ºC'),
	(24593, 111, '2015-01-15 00:39:11.000000', 'temperatura', 1090.0000, 'ºC'),
	(24594, 111, '2015-01-15 00:39:12.000000', 'temperatura', 690.0000, 'ºC'),
	(24595, 111, '2015-01-15 00:39:13.000000', 'temperatura', 179.0000, 'ºC'),
	(24596, 111, '2015-01-15 00:39:14.000000', 'temperatura', 24.0000, 'ºC'),
	(24597, 111, '2015-01-15 00:39:15.000000', 'temperatura', 787.0000, 'ºC'),
	(24598, 111, '2015-01-15 00:39:16.000000', 'temperatura', 260.0000, 'ºC'),
	(24599, 111, '2015-01-15 00:39:17.000000', 'temperatura', 141.0000, 'ºC'),
	(24600, 111, '2015-01-15 00:39:18.000000', 'temperatura', 1127.0000, 'ºC'),
	(24601, 111, '2015-01-15 00:39:19.000000', 'temperatura', 412.0000, 'ºC'),
	(24602, 111, '2015-01-15 00:39:20.000000', 'temperatura', 1081.0000, 'ºC'),
	(24603, 111, '2015-01-15 00:39:21.000000', 'temperatura', 566.0000, 'ºC'),
	(24604, 111, '2015-01-15 00:39:22.000000', 'temperatura', 791.0000, 'ºC'),
	(24605, 111, '2015-01-15 00:39:23.000000', 'temperatura', 1056.0000, 'ºC'),
	(24606, 111, '2015-01-15 00:39:24.000000', 'temperatura', 507.0000, 'ºC'),
	(24607, 111, '2015-01-15 00:39:25.000000', 'temperatura', 568.0000, 'ºC'),
	(24608, 111, '2015-01-15 00:39:26.000000', 'temperatura', 119.0000, 'ºC'),
	(24609, 111, '2015-01-15 00:39:27.000000', 'temperatura', 91.0000, 'ºC'),
	(24610, 111, '2015-01-15 00:39:28.000000', 'temperatura', 99.0000, 'ºC'),
	(24611, 111, '2015-01-15 00:39:29.000000', 'temperatura', 224.0000, 'ºC'),
	(24612, 111, '2015-01-15 00:39:30.000000', 'temperatura', 823.0000, 'ºC'),
	(24613, 111, '2015-01-15 00:39:31.000000', 'temperatura', 1042.0000, 'ºC'),
	(24614, 111, '2015-01-15 00:39:32.000000', 'temperatura', 342.0000, 'ºC'),
	(24615, 111, '2015-01-15 00:39:33.000000', 'temperatura', 985.0000, 'ºC'),
	(24616, 111, '2015-01-15 00:39:34.000000', 'temperatura', 299.0000, 'ºC'),
	(24617, 111, '2015-01-15 00:39:35.000000', 'temperatura', 940.0000, 'ºC'),
	(24618, 111, '2015-01-15 00:39:36.000000', 'temperatura', 204.0000, 'ºC'),
	(24619, 111, '2015-01-15 00:39:37.000000', 'temperatura', 602.0000, 'ºC'),
	(24620, 111, '2015-01-15 00:39:38.000000', 'temperatura', 1197.0000, 'ºC'),
	(24621, 111, '2015-01-15 00:39:39.000000', 'temperatura', 582.0000, 'ºC'),
	(24622, 111, '2015-01-15 00:39:40.000000', 'temperatura', 517.0000, 'ºC'),
	(24623, 111, '2015-01-15 00:39:41.000000', 'temperatura', 842.0000, 'ºC'),
	(24624, 111, '2015-01-15 00:39:42.000000', 'temperatura', 256.0000, 'ºC'),
	(24625, 111, '2015-01-15 00:39:43.000000', 'temperatura', 1157.0000, 'ºC'),
	(24626, 111, '2015-01-15 00:39:44.000000', 'temperatura', 216.0000, 'ºC'),
	(24627, 111, '2015-01-15 00:39:45.000000', 'temperatura', 8.0000, 'ºC'),
	(24628, 111, '2015-01-15 00:39:46.000000', 'temperatura', 594.0000, 'ºC'),
	(24629, 111, '2015-01-15 00:39:47.000000', 'temperatura', 547.0000, 'ºC'),
	(24630, 111, '2015-01-15 00:39:48.000000', 'temperatura', 952.0000, 'ºC'),
	(24631, 111, '2015-01-15 00:39:49.000000', 'temperatura', 721.0000, 'ºC'),
	(24632, 111, '2015-01-15 00:39:50.000000', 'temperatura', 750.0000, 'ºC'),
	(24633, 111, '2015-01-15 00:39:51.000000', 'temperatura', 385.0000, 'ºC'),
	(24634, 111, '2015-01-15 00:39:52.000000', 'temperatura', 877.0000, 'ºC'),
	(24635, 111, '2015-01-15 00:39:53.000000', 'temperatura', 829.0000, 'ºC'),
	(24636, 111, '2015-01-15 00:39:54.000000', 'temperatura', 317.0000, 'ºC'),
	(24637, 111, '2015-01-15 00:39:55.000000', 'temperatura', 296.0000, 'ºC'),
	(24638, 111, '2015-01-15 00:39:56.000000', 'temperatura', 532.0000, 'ºC'),
	(24639, 111, '2015-01-15 00:39:57.000000', 'temperatura', 571.0000, 'ºC'),
	(24640, 111, '2015-01-15 00:39:58.000000', 'temperatura', 61.0000, 'ºC'),
	(24641, 111, '2015-01-15 00:39:59.000000', 'temperatura', 990.0000, 'ºC'),
	(24642, 111, '2015-01-15 00:40:00.000000', 'temperatura', 1170.0000, 'ºC'),
	(24643, 111, '2015-01-15 00:40:01.000000', 'temperatura', 480.0000, 'ºC'),
	(24644, 111, '2015-01-15 00:40:02.000000', 'temperatura', 88.0000, 'ºC'),
	(24645, 111, '2015-01-15 00:40:03.000000', 'temperatura', 204.0000, 'ºC'),
	(24646, 111, '2015-01-15 00:40:04.000000', 'temperatura', 754.0000, 'ºC'),
	(24647, 111, '2015-01-15 00:40:05.000000', 'temperatura', 759.0000, 'ºC'),
	(24648, 111, '2015-01-15 00:40:06.000000', 'temperatura', 335.0000, 'ºC'),
	(24649, 111, '2015-01-15 00:40:07.000000', 'temperatura', 596.0000, 'ºC'),
	(24650, 111, '2015-01-15 00:40:08.000000', 'temperatura', 776.0000, 'ºC'),
	(24651, 111, '2015-01-15 00:40:09.000000', 'temperatura', 894.0000, 'ºC'),
	(24652, 111, '2015-01-15 00:40:10.000000', 'temperatura', 941.0000, 'ºC'),
	(24653, 111, '2015-01-15 00:40:11.000000', 'temperatura', 823.0000, 'ºC'),
	(24654, 111, '2015-01-15 00:40:12.000000', 'temperatura', 92.0000, 'ºC'),
	(24655, 111, '2015-01-15 00:40:13.000000', 'temperatura', 392.0000, 'ºC'),
	(24656, 111, '2015-01-15 00:40:14.000000', 'temperatura', 484.0000, 'ºC'),
	(24657, 111, '2015-01-15 00:40:15.000000', 'temperatura', 47.0000, 'ºC'),
	(24658, 111, '2015-01-15 00:40:16.000000', 'temperatura', 1181.0000, 'ºC'),
	(24659, 111, '2015-01-15 00:40:17.000000', 'temperatura', 965.0000, 'ºC'),
	(24660, 111, '2015-01-15 00:40:18.000000', 'temperatura', 81.0000, 'ºC'),
	(24661, 111, '2015-01-15 00:40:19.000000', 'temperatura', 1111.0000, 'ºC'),
	(24662, 111, '2015-01-15 00:40:20.000000', 'temperatura', 514.0000, 'ºC'),
	(24663, 111, '2015-01-15 00:40:21.000000', 'temperatura', 435.0000, 'ºC'),
	(24664, 111, '2015-01-15 00:40:22.000000', 'temperatura', 635.0000, 'ºC'),
	(24665, 111, '2015-01-15 00:40:23.000000', 'temperatura', 669.0000, 'ºC'),
	(24666, 111, '2015-01-15 00:40:24.000000', 'temperatura', 243.0000, 'ºC'),
	(24667, 111, '2015-01-15 00:40:25.000000', 'temperatura', 409.0000, 'ºC'),
	(24668, 111, '2015-01-15 00:40:26.000000', 'temperatura', 115.0000, 'ºC'),
	(24669, 111, '2015-01-15 00:40:27.000000', 'temperatura', 548.0000, 'ºC'),
	(24670, 111, '2015-01-15 00:40:28.000000', 'temperatura', 1195.0000, 'ºC'),
	(24671, 111, '2015-01-15 00:40:29.000000', 'temperatura', 731.0000, 'ºC'),
	(24672, 111, '2015-01-15 00:40:30.000000', 'temperatura', 73.0000, 'ºC'),
	(24673, 111, '2015-01-15 00:40:31.000000', 'temperatura', 570.0000, 'ºC'),
	(24674, 111, '2015-01-15 00:40:32.000000', 'temperatura', 233.0000, 'ºC'),
	(24675, 111, '2015-01-15 00:40:33.000000', 'temperatura', 654.0000, 'ºC'),
	(24676, 111, '2015-01-15 00:40:34.000000', 'temperatura', 173.0000, 'ºC'),
	(24677, 111, '2015-01-15 00:40:35.000000', 'temperatura', 104.0000, 'ºC'),
	(24678, 111, '2015-01-15 00:40:36.000000', 'temperatura', 3.0000, 'ºC'),
	(24679, 111, '2015-01-15 00:40:37.000000', 'temperatura', 901.0000, 'ºC'),
	(24680, 111, '2015-01-15 00:40:38.000000', 'temperatura', 898.0000, 'ºC'),
	(24681, 111, '2015-01-15 00:40:39.000000', 'temperatura', 586.0000, 'ºC'),
	(24682, 111, '2015-01-15 00:40:40.000000', 'temperatura', 239.0000, 'ºC'),
	(24683, 111, '2015-01-15 00:40:41.000000', 'temperatura', 635.0000, 'ºC'),
	(24684, 111, '2015-01-15 00:40:42.000000', 'temperatura', 61.0000, 'ºC'),
	(24685, 111, '2015-01-15 00:40:43.000000', 'temperatura', 800.0000, 'ºC'),
	(24686, 111, '2015-01-15 00:40:44.000000', 'temperatura', 219.0000, 'ºC'),
	(24687, 111, '2015-01-15 00:40:45.000000', 'temperatura', 1094.0000, 'ºC'),
	(24688, 111, '2015-01-15 00:40:46.000000', 'temperatura', 12.0000, 'ºC'),
	(24689, 111, '2015-01-15 00:40:47.000000', 'temperatura', 380.0000, 'ºC'),
	(24690, 111, '2015-01-15 00:40:48.000000', 'temperatura', 666.0000, 'ºC'),
	(24691, 111, '2015-01-15 00:40:49.000000', 'temperatura', 988.0000, 'ºC'),
	(24692, 111, '2015-01-15 00:40:50.000000', 'temperatura', 545.0000, 'ºC'),
	(24693, 111, '2015-01-15 00:40:51.000000', 'temperatura', 962.0000, 'ºC'),
	(24694, 111, '2015-01-15 00:40:52.000000', 'temperatura', 775.0000, 'ºC'),
	(24695, 111, '2015-01-15 00:40:53.000000', 'temperatura', 990.0000, 'ºC'),
	(24696, 111, '2015-01-15 00:40:54.000000', 'temperatura', 226.0000, 'ºC'),
	(24697, 111, '2015-01-15 00:40:55.000000', 'temperatura', 558.0000, 'ºC'),
	(24698, 111, '2015-01-15 00:40:56.000000', 'temperatura', 916.0000, 'ºC'),
	(24699, 111, '2015-01-15 00:40:57.000000', 'temperatura', 503.0000, 'ºC'),
	(24700, 111, '2015-01-15 00:40:58.000000', 'temperatura', 968.0000, 'ºC'),
	(24701, 111, '2015-01-15 00:40:59.000000', 'temperatura', 933.0000, 'ºC'),
	(24702, 111, '2015-01-15 00:41:00.000000', 'temperatura', 559.0000, 'ºC'),
	(24703, 111, '2015-01-15 00:41:01.000000', 'temperatura', 1198.0000, 'ºC'),
	(24704, 111, '2015-01-15 00:41:02.000000', 'temperatura', 713.0000, 'ºC'),
	(24705, 111, '2015-01-15 00:41:03.000000', 'temperatura', 1170.0000, 'ºC'),
	(24706, 111, '2015-01-15 00:41:04.000000', 'temperatura', 113.0000, 'ºC'),
	(24707, 111, '2015-01-15 00:41:05.000000', 'temperatura', 653.0000, 'ºC'),
	(24708, 111, '2015-01-15 00:41:06.000000', 'temperatura', 530.0000, 'ºC'),
	(24709, 111, '2015-01-15 00:41:07.000000', 'temperatura', 689.0000, 'ºC'),
	(24710, 111, '2015-01-15 00:41:08.000000', 'temperatura', 657.0000, 'ºC'),
	(24711, 111, '2015-01-15 00:41:09.000000', 'temperatura', 18.0000, 'ºC'),
	(24712, 111, '2015-01-15 00:41:10.000000', 'temperatura', 518.0000, 'ºC'),
	(24713, 111, '2015-01-15 00:41:11.000000', 'temperatura', 136.0000, 'ºC'),
	(24714, 111, '2015-01-15 00:41:12.000000', 'temperatura', 327.0000, 'ºC'),
	(24715, 111, '2015-01-15 00:41:13.000000', 'temperatura', 28.0000, 'ºC'),
	(24716, 111, '2015-01-15 00:41:14.000000', 'temperatura', 358.0000, 'ºC'),
	(24717, 111, '2015-01-15 00:41:15.000000', 'temperatura', 507.0000, 'ºC'),
	(24718, 111, '2015-01-15 00:41:16.000000', 'temperatura', 263.0000, 'ºC'),
	(24719, 111, '2015-01-15 00:41:17.000000', 'temperatura', 993.0000, 'ºC'),
	(24720, 111, '2015-01-15 00:41:18.000000', 'temperatura', 578.0000, 'ºC'),
	(24721, 111, '2015-01-15 00:41:19.000000', 'temperatura', 1111.0000, 'ºC'),
	(24722, 111, '2015-01-15 00:41:20.000000', 'temperatura', 221.0000, 'ºC'),
	(24723, 111, '2015-01-15 00:41:21.000000', 'temperatura', 172.0000, 'ºC'),
	(24724, 111, '2015-01-15 00:41:22.000000', 'temperatura', 197.0000, 'ºC'),
	(24725, 111, '2015-01-15 00:41:23.000000', 'temperatura', 470.0000, 'ºC'),
	(24726, 111, '2015-01-15 00:41:24.000000', 'temperatura', 560.0000, 'ºC'),
	(24727, 111, '2015-01-15 00:41:25.000000', 'temperatura', 192.0000, 'ºC'),
	(24728, 111, '2015-01-15 00:41:26.000000', 'temperatura', 479.0000, 'ºC'),
	(24729, 111, '2015-01-15 00:41:27.000000', 'temperatura', 621.0000, 'ºC'),
	(24730, 111, '2015-01-15 00:41:28.000000', 'temperatura', 466.0000, 'ºC'),
	(24731, 111, '2015-01-15 00:41:29.000000', 'temperatura', 466.0000, 'ºC'),
	(24732, 111, '2015-01-15 00:41:30.000000', 'temperatura', 936.0000, 'ºC'),
	(24733, 111, '2015-01-15 00:41:31.000000', 'temperatura', 883.0000, 'ºC'),
	(24734, 111, '2015-01-15 00:41:32.000000', 'temperatura', 407.0000, 'ºC'),
	(24735, 111, '2015-01-15 00:41:33.000000', 'temperatura', 586.0000, 'ºC'),
	(24736, 111, '2015-01-15 00:41:34.000000', 'temperatura', 510.0000, 'ºC'),
	(24737, 111, '2015-01-15 00:41:35.000000', 'temperatura', 793.0000, 'ºC'),
	(24738, 111, '2015-01-15 00:41:36.000000', 'temperatura', 37.0000, 'ºC'),
	(24739, 111, '2015-01-15 00:41:37.000000', 'temperatura', 205.0000, 'ºC'),
	(24740, 111, '2015-01-15 00:41:38.000000', 'temperatura', 915.0000, 'ºC'),
	(24741, 111, '2015-01-15 00:41:39.000000', 'temperatura', 361.0000, 'ºC'),
	(24742, 111, '2015-01-15 00:41:40.000000', 'temperatura', 258.0000, 'ºC'),
	(24743, 111, '2015-01-15 00:41:41.000000', 'temperatura', 208.0000, 'ºC'),
	(24744, 111, '2015-01-15 00:41:42.000000', 'temperatura', 268.0000, 'ºC'),
	(24745, 111, '2015-01-15 00:41:43.000000', 'temperatura', 717.0000, 'ºC'),
	(24746, 111, '2015-01-15 00:41:44.000000', 'temperatura', 380.0000, 'ºC'),
	(24747, 111, '2015-01-15 00:41:45.000000', 'temperatura', 951.0000, 'ºC'),
	(24748, 111, '2015-01-15 00:41:46.000000', 'temperatura', 15.0000, 'ºC'),
	(24749, 111, '2015-01-15 00:41:47.000000', 'temperatura', 823.0000, 'ºC'),
	(24750, 111, '2015-01-15 00:41:48.000000', 'temperatura', 471.0000, 'ºC'),
	(24751, 111, '2015-01-15 00:41:49.000000', 'temperatura', 1086.0000, 'ºC'),
	(24752, 111, '2015-01-15 00:41:50.000000', 'temperatura', 417.0000, 'ºC'),
	(24753, 111, '2015-01-15 00:41:51.000000', 'temperatura', 26.0000, 'ºC'),
	(24754, 111, '2015-01-15 00:41:52.000000', 'temperatura', 81.0000, 'ºC'),
	(24755, 111, '2015-01-15 00:41:53.000000', 'temperatura', 328.0000, 'ºC'),
	(24756, 111, '2015-01-15 00:41:54.000000', 'temperatura', 195.0000, 'ºC'),
	(24757, 111, '2015-01-15 00:41:55.000000', 'temperatura', 1195.0000, 'ºC'),
	(24758, 111, '2015-01-15 00:41:56.000000', 'temperatura', 587.0000, 'ºC'),
	(24759, 111, '2015-01-15 00:41:57.000000', 'temperatura', 551.0000, 'ºC'),
	(24760, 111, '2015-01-15 00:41:58.000000', 'temperatura', 997.0000, 'ºC'),
	(24761, 111, '2015-01-15 00:41:59.000000', 'temperatura', 932.0000, 'ºC'),
	(24762, 111, '2015-01-15 00:42:00.000000', 'temperatura', 469.0000, 'ºC'),
	(24763, 111, '2015-01-15 00:42:01.000000', 'temperatura', 751.0000, 'ºC'),
	(24764, 111, '2015-01-15 00:42:02.000000', 'temperatura', 1146.0000, 'ºC'),
	(24765, 111, '2015-01-15 00:42:03.000000', 'temperatura', 1080.0000, 'ºC'),
	(24766, 111, '2015-01-15 00:42:04.000000', 'temperatura', 762.0000, 'ºC'),
	(24767, 111, '2015-01-15 00:42:05.000000', 'temperatura', 572.0000, 'ºC'),
	(24768, 111, '2015-01-15 00:42:06.000000', 'temperatura', 574.0000, 'ºC'),
	(24769, 111, '2015-01-15 00:42:07.000000', 'temperatura', 1153.0000, 'ºC'),
	(24770, 111, '2015-01-15 00:42:08.000000', 'temperatura', 446.0000, 'ºC'),
	(24771, 111, '2015-01-15 00:42:09.000000', 'temperatura', 1169.0000, 'ºC'),
	(24772, 111, '2015-01-15 00:42:10.000000', 'temperatura', 909.0000, 'ºC'),
	(24773, 111, '2015-01-15 00:42:11.000000', 'temperatura', 1038.0000, 'ºC'),
	(24774, 111, '2015-01-15 00:42:12.000000', 'temperatura', 62.0000, 'ºC'),
	(24775, 111, '2015-01-15 00:42:13.000000', 'temperatura', 796.0000, 'ºC'),
	(24776, 111, '2015-01-15 00:42:14.000000', 'temperatura', 195.0000, 'ºC'),
	(24777, 111, '2015-01-15 00:42:15.000000', 'temperatura', 988.0000, 'ºC'),
	(24778, 111, '2015-01-15 00:42:16.000000', 'temperatura', 756.0000, 'ºC'),
	(24779, 111, '2015-01-15 00:42:17.000000', 'temperatura', 817.0000, 'ºC'),
	(24780, 111, '2015-01-15 00:42:18.000000', 'temperatura', 618.0000, 'ºC'),
	(24781, 111, '2015-01-15 00:42:19.000000', 'temperatura', 639.0000, 'ºC'),
	(24782, 111, '2015-01-15 00:42:20.000000', 'temperatura', 139.0000, 'ºC'),
	(24783, 111, '2015-01-15 00:42:21.000000', 'temperatura', 1181.0000, 'ºC'),
	(24784, 111, '2015-01-15 00:42:22.000000', 'temperatura', 689.0000, 'ºC'),
	(24785, 111, '2015-01-15 00:42:23.000000', 'temperatura', 1103.0000, 'ºC'),
	(24786, 111, '2015-01-15 00:42:24.000000', 'temperatura', 1047.0000, 'ºC'),
	(24787, 111, '2015-01-15 00:42:25.000000', 'temperatura', 728.0000, 'ºC'),
	(24788, 111, '2015-01-15 00:42:26.000000', 'temperatura', 499.0000, 'ºC'),
	(24789, 111, '2015-01-15 00:42:27.000000', 'temperatura', 313.0000, 'ºC'),
	(24790, 111, '2015-01-15 00:42:28.000000', 'temperatura', 68.0000, 'ºC'),
	(24791, 111, '2015-01-15 00:42:29.000000', 'temperatura', 601.0000, 'ºC'),
	(24792, 111, '2015-01-15 00:42:30.000000', 'temperatura', 399.0000, 'ºC'),
	(24793, 111, '2015-01-15 00:42:31.000000', 'temperatura', 196.0000, 'ºC'),
	(24794, 111, '2015-01-15 00:42:32.000000', 'temperatura', 982.0000, 'ºC'),
	(24795, 111, '2015-01-15 00:42:33.000000', 'temperatura', 722.0000, 'ºC'),
	(24796, 111, '2015-01-15 00:42:34.000000', 'temperatura', 665.0000, 'ºC'),
	(24797, 111, '2015-01-15 00:42:35.000000', 'temperatura', 1158.0000, 'ºC'),
	(24798, 111, '2015-01-15 00:42:36.000000', 'temperatura', 196.0000, 'ºC'),
	(24799, 111, '2015-01-15 00:42:37.000000', 'temperatura', 1106.0000, 'ºC'),
	(24800, 111, '2015-01-15 00:42:38.000000', 'temperatura', 145.0000, 'ºC'),
	(24801, 111, '2015-01-15 00:42:39.000000', 'temperatura', 1007.0000, 'ºC'),
	(24802, 111, '2015-01-15 00:42:40.000000', 'temperatura', 1001.0000, 'ºC'),
	(24803, 111, '2015-01-15 00:42:41.000000', 'temperatura', 783.0000, 'ºC'),
	(24804, 111, '2015-01-15 00:42:42.000000', 'temperatura', 913.0000, 'ºC'),
	(24805, 111, '2015-01-15 00:42:43.000000', 'temperatura', 1016.0000, 'ºC'),
	(24806, 111, '2015-01-15 00:42:44.000000', 'temperatura', 1143.0000, 'ºC'),
	(24807, 111, '2015-01-15 00:42:45.000000', 'temperatura', 268.0000, 'ºC'),
	(24808, 111, '2015-01-15 00:42:46.000000', 'temperatura', 312.0000, 'ºC'),
	(24809, 111, '2015-01-15 00:42:47.000000', 'temperatura', 754.0000, 'ºC'),
	(24810, 111, '2015-01-15 00:42:48.000000', 'temperatura', 434.0000, 'ºC'),
	(24811, 111, '2015-01-15 00:42:49.000000', 'temperatura', 1108.0000, 'ºC'),
	(24812, 111, '2015-01-15 00:42:50.000000', 'temperatura', 638.0000, 'ºC'),
	(24813, 111, '2015-01-15 00:42:51.000000', 'temperatura', 1066.0000, 'ºC'),
	(24814, 111, '2015-01-15 00:42:52.000000', 'temperatura', 1018.0000, 'ºC'),
	(24815, 111, '2015-01-15 00:42:53.000000', 'temperatura', 692.0000, 'ºC'),
	(24816, 111, '2015-01-15 00:42:54.000000', 'temperatura', 409.0000, 'ºC'),
	(24817, 111, '2015-01-15 00:42:55.000000', 'temperatura', 1166.0000, 'ºC'),
	(24818, 111, '2015-01-15 00:42:56.000000', 'temperatura', 1004.0000, 'ºC'),
	(24819, 111, '2015-01-15 00:42:57.000000', 'temperatura', 323.0000, 'ºC'),
	(24820, 111, '2015-01-15 00:42:58.000000', 'temperatura', 1002.0000, 'ºC'),
	(24821, 111, '2015-01-15 00:42:59.000000', 'temperatura', 442.0000, 'ºC'),
	(24822, 111, '2015-01-15 00:43:00.000000', 'temperatura', 406.0000, 'ºC'),
	(24823, 111, '2015-01-15 00:43:01.000000', 'temperatura', 705.0000, 'ºC'),
	(24824, 111, '2015-01-15 00:43:02.000000', 'temperatura', 1105.0000, 'ºC'),
	(24825, 111, '2015-01-15 00:43:03.000000', 'temperatura', 1014.0000, 'ºC'),
	(24826, 111, '2015-01-15 00:43:04.000000', 'temperatura', 553.0000, 'ºC'),
	(24827, 111, '2015-01-15 00:43:05.000000', 'temperatura', 923.0000, 'ºC'),
	(24828, 111, '2015-01-15 00:43:06.000000', 'temperatura', 559.0000, 'ºC'),
	(24829, 111, '2015-01-15 00:43:07.000000', 'temperatura', 27.0000, 'ºC'),
	(24830, 111, '2015-01-15 00:43:08.000000', 'temperatura', 855.0000, 'ºC'),
	(24831, 111, '2015-01-15 00:43:09.000000', 'temperatura', 597.0000, 'ºC'),
	(24832, 111, '2015-01-15 00:43:10.000000', 'temperatura', 420.0000, 'ºC'),
	(24833, 111, '2015-01-15 00:43:11.000000', 'temperatura', 307.0000, 'ºC'),
	(24834, 111, '2015-01-15 00:43:12.000000', 'temperatura', 279.0000, 'ºC'),
	(24835, 111, '2015-01-15 00:43:13.000000', 'temperatura', 473.0000, 'ºC'),
	(24836, 111, '2015-01-15 00:43:14.000000', 'temperatura', 328.0000, 'ºC'),
	(24837, 111, '2015-01-15 00:43:15.000000', 'temperatura', 222.0000, 'ºC'),
	(24838, 111, '2015-01-15 00:43:16.000000', 'temperatura', 126.0000, 'ºC'),
	(24839, 111, '2015-01-15 00:43:17.000000', 'temperatura', 1164.0000, 'ºC'),
	(24840, 111, '2015-01-15 00:43:18.000000', 'temperatura', 642.0000, 'ºC'),
	(24841, 111, '2015-01-15 00:43:19.000000', 'temperatura', 918.0000, 'ºC'),
	(24842, 111, '2015-01-15 00:43:20.000000', 'temperatura', 267.0000, 'ºC'),
	(24843, 111, '2015-01-15 00:43:21.000000', 'temperatura', 981.0000, 'ºC'),
	(24844, 111, '2015-01-15 00:43:22.000000', 'temperatura', 503.0000, 'ºC'),
	(24845, 111, '2015-01-15 00:43:23.000000', 'temperatura', 771.0000, 'ºC'),
	(24846, 111, '2015-01-15 00:43:24.000000', 'temperatura', 1149.0000, 'ºC'),
	(24847, 111, '2015-01-15 00:43:25.000000', 'temperatura', 1030.0000, 'ºC'),
	(24848, 111, '2015-01-15 00:43:26.000000', 'temperatura', 505.0000, 'ºC'),
	(24849, 111, '2015-01-15 00:43:27.000000', 'temperatura', 637.0000, 'ºC'),
	(24850, 111, '2015-01-15 00:43:28.000000', 'temperatura', 470.0000, 'ºC'),
	(24851, 111, '2015-01-15 00:43:29.000000', 'temperatura', 440.0000, 'ºC'),
	(24852, 111, '2015-01-15 00:43:30.000000', 'temperatura', 791.0000, 'ºC'),
	(24853, 111, '2015-01-15 00:43:31.000000', 'temperatura', 233.0000, 'ºC'),
	(24854, 111, '2015-01-15 00:43:32.000000', 'temperatura', 1195.0000, 'ºC'),
	(24855, 111, '2015-01-15 00:43:33.000000', 'temperatura', 475.0000, 'ºC'),
	(24856, 111, '2015-01-15 00:43:34.000000', 'temperatura', 1192.0000, 'ºC'),
	(24857, 111, '2015-01-15 00:43:35.000000', 'temperatura', 936.0000, 'ºC'),
	(24858, 111, '2015-01-15 00:43:36.000000', 'temperatura', 1106.0000, 'ºC'),
	(24859, 111, '2015-01-15 00:43:37.000000', 'temperatura', 320.0000, 'ºC'),
	(24860, 111, '2015-01-15 00:43:38.000000', 'temperatura', 682.0000, 'ºC'),
	(24861, 111, '2015-01-15 00:43:39.000000', 'temperatura', 50.0000, 'ºC'),
	(24862, 111, '2015-01-15 00:43:40.000000', 'temperatura', 607.0000, 'ºC'),
	(24863, 111, '2015-01-15 00:43:41.000000', 'temperatura', 485.0000, 'ºC'),
	(24864, 111, '2015-01-15 00:43:42.000000', 'temperatura', 604.0000, 'ºC'),
	(24865, 111, '2015-01-15 00:43:43.000000', 'temperatura', 364.0000, 'ºC'),
	(24866, 111, '2015-01-15 00:43:44.000000', 'temperatura', 11.0000, 'ºC'),
	(24867, 111, '2015-01-15 00:43:45.000000', 'temperatura', 162.0000, 'ºC'),
	(24868, 111, '2015-01-15 00:43:46.000000', 'temperatura', 780.0000, 'ºC'),
	(24869, 111, '2015-01-15 00:43:47.000000', 'temperatura', 1012.0000, 'ºC'),
	(24870, 111, '2015-01-15 00:43:48.000000', 'temperatura', 322.0000, 'ºC'),
	(24871, 111, '2015-01-15 00:43:49.000000', 'temperatura', 974.0000, 'ºC'),
	(24872, 111, '2015-01-15 00:43:50.000000', 'temperatura', 307.0000, 'ºC'),
	(24873, 111, '2015-01-15 00:43:51.000000', 'temperatura', 1010.0000, 'ºC'),
	(24874, 111, '2015-01-15 00:43:52.000000', 'temperatura', 530.0000, 'ºC'),
	(24875, 111, '2015-01-15 00:43:53.000000', 'temperatura', 821.0000, 'ºC'),
	(24876, 111, '2015-01-15 00:43:54.000000', 'temperatura', 115.0000, 'ºC'),
	(24877, 111, '2015-01-15 00:43:55.000000', 'temperatura', 512.0000, 'ºC'),
	(24878, 111, '2015-01-15 00:43:56.000000', 'temperatura', 1015.0000, 'ºC'),
	(24879, 111, '2015-01-15 00:43:57.000000', 'temperatura', 1142.0000, 'ºC'),
	(24880, 111, '2015-01-15 00:43:58.000000', 'temperatura', 264.0000, 'ºC'),
	(24881, 111, '2015-01-15 00:43:59.000000', 'temperatura', 297.0000, 'ºC'),
	(24882, 111, '2015-01-15 00:44:00.000000', 'temperatura', 690.0000, 'ºC'),
	(24883, 111, '2015-01-15 00:44:01.000000', 'temperatura', 161.0000, 'ºC'),
	(24884, 111, '2015-01-15 00:44:02.000000', 'temperatura', 1134.0000, 'ºC'),
	(24885, 111, '2015-01-15 00:44:03.000000', 'temperatura', 388.0000, 'ºC'),
	(24886, 111, '2015-01-15 00:44:04.000000', 'temperatura', 938.0000, 'ºC'),
	(24887, 111, '2015-01-15 00:44:05.000000', 'temperatura', 1129.0000, 'ºC'),
	(24888, 111, '2015-01-15 00:44:06.000000', 'temperatura', 429.0000, 'ºC'),
	(24889, 111, '2015-01-15 00:44:07.000000', 'temperatura', 1159.0000, 'ºC'),
	(24890, 111, '2015-01-15 00:44:08.000000', 'temperatura', 908.0000, 'ºC'),
	(24891, 111, '2015-01-15 00:44:09.000000', 'temperatura', 1063.0000, 'ºC'),
	(24892, 111, '2015-01-15 00:44:10.000000', 'temperatura', 194.0000, 'ºC'),
	(24893, 111, '2015-01-15 00:44:11.000000', 'temperatura', 180.0000, 'ºC'),
	(24894, 111, '2015-01-15 00:44:12.000000', 'temperatura', 319.0000, 'ºC'),
	(24895, 111, '2015-01-15 00:44:13.000000', 'temperatura', 1057.0000, 'ºC'),
	(24896, 111, '2015-01-15 00:44:14.000000', 'temperatura', 726.0000, 'ºC'),
	(24897, 111, '2015-01-15 00:44:15.000000', 'temperatura', 459.0000, 'ºC'),
	(24898, 111, '2015-01-15 00:44:16.000000', 'temperatura', 119.0000, 'ºC'),
	(24899, 111, '2015-01-15 00:44:17.000000', 'temperatura', 416.0000, 'ºC'),
	(24900, 111, '2015-01-15 00:44:18.000000', 'temperatura', 526.0000, 'ºC'),
	(24901, 111, '2015-01-15 00:44:19.000000', 'temperatura', 180.0000, 'ºC'),
	(24902, 111, '2015-01-15 00:44:20.000000', 'temperatura', 522.0000, 'ºC'),
	(24903, 111, '2015-01-15 00:44:21.000000', 'temperatura', 873.0000, 'ºC'),
	(24904, 111, '2015-01-15 00:44:22.000000', 'temperatura', 398.0000, 'ºC'),
	(24905, 111, '2015-01-15 00:44:23.000000', 'temperatura', 573.0000, 'ºC'),
	(24906, 111, '2015-01-15 00:44:24.000000', 'temperatura', 473.0000, 'ºC'),
	(24907, 111, '2015-01-15 00:44:25.000000', 'temperatura', 644.0000, 'ºC'),
	(24908, 111, '2015-01-15 00:44:26.000000', 'temperatura', 602.0000, 'ºC'),
	(24909, 111, '2015-01-15 00:44:27.000000', 'temperatura', 1079.0000, 'ºC'),
	(24910, 111, '2015-01-15 00:44:28.000000', 'temperatura', 1190.0000, 'ºC'),
	(24911, 111, '2015-01-15 00:44:29.000000', 'temperatura', 312.0000, 'ºC'),
	(24912, 111, '2015-01-15 00:44:30.000000', 'temperatura', 392.0000, 'ºC'),
	(24913, 111, '2015-01-15 00:44:31.000000', 'temperatura', 1024.0000, 'ºC'),
	(24914, 111, '2015-01-15 00:44:32.000000', 'temperatura', 347.0000, 'ºC'),
	(24915, 111, '2015-01-15 00:44:33.000000', 'temperatura', 1060.0000, 'ºC'),
	(24916, 111, '2015-01-15 00:44:34.000000', 'temperatura', 660.0000, 'ºC'),
	(24917, 111, '2015-01-15 00:44:35.000000', 'temperatura', 123.0000, 'ºC'),
	(24918, 111, '2015-01-15 00:44:36.000000', 'temperatura', 1034.0000, 'ºC'),
	(24919, 111, '2015-01-15 00:44:37.000000', 'temperatura', 3.0000, 'ºC'),
	(24920, 111, '2015-01-15 00:44:38.000000', 'temperatura', 512.0000, 'ºC'),
	(24921, 111, '2015-01-15 00:44:39.000000', 'temperatura', 151.0000, 'ºC'),
	(24922, 111, '2015-01-15 00:44:40.000000', 'temperatura', 418.0000, 'ºC'),
	(24923, 111, '2015-01-15 00:44:41.000000', 'temperatura', 441.0000, 'ºC'),
	(24924, 111, '2015-01-15 00:44:42.000000', 'temperatura', 950.0000, 'ºC'),
	(24925, 111, '2015-01-15 00:44:43.000000', 'temperatura', 1026.0000, 'ºC'),
	(24926, 111, '2015-01-15 00:44:44.000000', 'temperatura', 1083.0000, 'ºC'),
	(24927, 111, '2015-01-15 00:44:45.000000', 'temperatura', 1135.0000, 'ºC'),
	(24928, 111, '2015-01-15 00:44:46.000000', 'temperatura', 27.0000, 'ºC'),
	(24929, 111, '2015-01-15 00:44:47.000000', 'temperatura', 333.0000, 'ºC'),
	(24930, 111, '2015-01-15 00:44:48.000000', 'temperatura', 383.0000, 'ºC'),
	(24931, 111, '2015-01-15 00:44:49.000000', 'temperatura', 915.0000, 'ºC'),
	(24932, 111, '2015-01-15 00:44:50.000000', 'temperatura', 1029.0000, 'ºC'),
	(24933, 111, '2015-01-15 00:44:51.000000', 'temperatura', 0.0000, 'ºC'),
	(24934, 111, '2015-01-15 00:44:52.000000', 'temperatura', 513.0000, 'ºC'),
	(24935, 111, '2015-01-15 00:44:53.000000', 'temperatura', 167.0000, 'ºC'),
	(24936, 111, '2015-01-15 00:44:54.000000', 'temperatura', 495.0000, 'ºC'),
	(24937, 111, '2015-01-15 00:44:55.000000', 'temperatura', 776.0000, 'ºC'),
	(24938, 111, '2015-01-15 00:44:56.000000', 'temperatura', 1197.0000, 'ºC'),
	(24939, 111, '2015-01-15 00:44:57.000000', 'temperatura', 54.0000, 'ºC'),
	(24940, 111, '2015-01-15 00:44:58.000000', 'temperatura', 283.0000, 'ºC'),
	(24941, 111, '2015-01-15 00:44:59.000000', 'temperatura', 51.0000, 'ºC'),
	(24942, 111, '2015-01-15 00:45:00.000000', 'temperatura', 607.0000, 'ºC'),
	(24943, 111, '2015-01-15 00:45:01.000000', 'temperatura', 484.0000, 'ºC'),
	(24944, 111, '2015-01-15 00:45:02.000000', 'temperatura', 599.0000, 'ºC'),
	(24945, 111, '2015-01-15 00:45:03.000000', 'temperatura', 345.0000, 'ºC'),
	(24946, 111, '2015-01-15 00:45:04.000000', 'temperatura', 1128.0000, 'ºC'),
	(24947, 111, '2015-01-15 00:45:05.000000', 'temperatura', 1005.0000, 'ºC'),
	(24948, 111, '2015-01-15 00:45:06.000000', 'temperatura', 442.0000, 'ºC'),
	(24949, 111, '2015-01-15 00:45:07.000000', 'temperatura', 394.0000, 'ºC'),
	(24950, 111, '2015-01-15 00:45:08.000000', 'temperatura', 647.0000, 'ºC'),
	(24951, 111, '2015-01-15 00:45:09.000000', 'temperatura', 851.0000, 'ºC'),
	(24952, 111, '2015-01-15 00:45:10.000000', 'temperatura', 1114.0000, 'ºC'),
	(24953, 111, '2015-01-15 00:45:11.000000', 'temperatura', 617.0000, 'ºC'),
	(24954, 111, '2015-01-15 00:45:12.000000', 'temperatura', 946.0000, 'ºC'),
	(24955, 111, '2015-01-15 00:45:13.000000', 'temperatura', 478.0000, 'ºC'),
	(24956, 111, '2015-01-15 00:45:14.000000', 'temperatura', 753.0000, 'ºC'),
	(24957, 111, '2015-01-15 00:45:15.000000', 'temperatura', 1130.0000, 'ºC'),
	(24958, 111, '2015-01-15 00:45:16.000000', 'temperatura', 992.0000, 'ºC'),
	(24959, 111, '2015-01-15 00:45:17.000000', 'temperatura', 371.0000, 'ºC'),
	(24960, 111, '2015-01-15 00:45:18.000000', 'temperatura', 80.0000, 'ºC'),
	(24961, 111, '2015-01-15 00:45:19.000000', 'temperatura', 485.0000, 'ºC'),
	(24962, 111, '2015-01-15 00:45:20.000000', 'temperatura', 988.0000, 'ºC'),
	(24963, 111, '2015-01-15 00:45:21.000000', 'temperatura', 1083.0000, 'ºC'),
	(24964, 111, '2015-01-15 00:45:22.000000', 'temperatura', 53.0000, 'ºC'),
	(24965, 111, '2015-01-15 00:45:23.000000', 'temperatura', 615.0000, 'ºC'),
	(24966, 111, '2015-01-15 00:45:24.000000', 'temperatura', 519.0000, 'ºC'),
	(24967, 111, '2015-01-15 00:45:25.000000', 'temperatura', 751.0000, 'ºC'),
	(24968, 111, '2015-01-15 00:45:26.000000', 'temperatura', 998.0000, 'ºC'),
	(24969, 111, '2015-01-15 00:45:27.000000', 'temperatura', 337.0000, 'ºC'),
	(24970, 111, '2015-01-15 00:45:28.000000', 'temperatura', 1093.0000, 'ºC'),
	(24971, 111, '2015-01-15 00:45:29.000000', 'temperatura', 855.0000, 'ºC'),
	(24972, 111, '2015-01-15 00:45:30.000000', 'temperatura', 994.0000, 'ºC'),
	(24973, 111, '2015-01-15 00:45:31.000000', 'temperatura', 4.0000, 'ºC'),
	(24974, 111, '2015-01-15 00:45:32.000000', 'temperatura', 642.0000, 'ºC'),
	(24975, 111, '2015-01-15 00:45:33.000000', 'temperatura', 799.0000, 'ºC'),
	(24976, 111, '2015-01-15 00:45:34.000000', 'temperatura', 868.0000, 'ºC'),
	(24977, 111, '2015-01-15 00:45:35.000000', 'temperatura', 742.0000, 'ºC'),
	(24978, 111, '2015-01-15 00:45:36.000000', 'temperatura', 1109.0000, 'ºC'),
	(24979, 111, '2015-01-15 00:45:37.000000', 'temperatura', 918.0000, 'ºC'),
	(24980, 111, '2015-01-15 00:45:38.000000', 'temperatura', 64.0000, 'ºC'),
	(24981, 111, '2015-01-15 00:45:39.000000', 'temperatura', 1167.0000, 'ºC'),
	(24982, 111, '2015-01-15 00:45:40.000000', 'temperatura', 843.0000, 'ºC'),
	(24983, 111, '2015-01-15 00:45:41.000000', 'temperatura', 716.0000, 'ºC'),
	(24984, 111, '2015-01-15 00:45:42.000000', 'temperatura', 1049.0000, 'ºC'),
	(24985, 111, '2015-01-15 00:45:43.000000', 'temperatura', 697.0000, 'ºC'),
	(24986, 111, '2015-01-15 00:45:44.000000', 'temperatura', 339.0000, 'ºC'),
	(24987, 111, '2015-01-15 00:45:45.000000', 'temperatura', 805.0000, 'ºC'),
	(24988, 111, '2015-01-15 00:45:46.000000', 'temperatura', 610.0000, 'ºC'),
	(24989, 111, '2015-01-15 00:45:47.000000', 'temperatura', 636.0000, 'ºC'),
	(24990, 111, '2015-01-15 00:45:48.000000', 'temperatura', 150.0000, 'ºC'),
	(24991, 111, '2015-01-15 00:45:49.000000', 'temperatura', 40.0000, 'ºC'),
	(24992, 111, '2015-01-15 00:45:50.000000', 'temperatura', 953.0000, 'ºC'),
	(24993, 111, '2015-01-15 00:45:51.000000', 'temperatura', 1046.0000, 'ºC'),
	(24994, 111, '2015-01-15 00:45:52.000000', 'temperatura', 1169.0000, 'ºC'),
	(24995, 111, '2015-01-15 00:45:53.000000', 'temperatura', 308.0000, 'ºC'),
	(24996, 111, '2015-01-15 00:45:54.000000', 'temperatura', 433.0000, 'ºC'),
	(24997, 111, '2015-01-15 00:45:55.000000', 'temperatura', 42.0000, 'ºC'),
	(24998, 111, '2015-01-15 00:45:56.000000', 'temperatura', 110.0000, 'ºC'),
	(24999, 111, '2015-01-15 00:45:57.000000', 'temperatura', 428.0000, 'ºC'),
	(25000, 111, '2015-01-15 00:45:58.000000', 'temperatura', 607.0000, 'ºC'),
	(25001, 111, '2015-01-15 00:45:59.000000', 'temperatura', 554.0000, 'ºC'),
	(25002, 111, '2015-01-15 00:46:00.000000', 'temperatura', 948.0000, 'ºC'),
	(25003, 111, '2015-01-15 00:46:01.000000', 'temperatura', 677.0000, 'ºC'),
	(25004, 111, '2015-01-15 00:46:02.000000', 'temperatura', 544.0000, 'ºC'),
	(25005, 111, '2015-01-15 00:46:03.000000', 'temperatura', 689.0000, 'ºC'),
	(25006, 111, '2015-01-15 00:46:04.000000', 'temperatura', 612.0000, 'ºC'),
	(25007, 111, '2015-01-15 00:46:05.000000', 'temperatura', 995.0000, 'ºC'),
	(25008, 111, '2015-01-15 00:46:06.000000', 'temperatura', 738.0000, 'ºC'),
	(25009, 111, '2015-01-15 00:46:07.000000', 'temperatura', 707.0000, 'ºC'),
	(25010, 111, '2015-01-15 00:46:08.000000', 'temperatura', 121.0000, 'ºC'),
	(25011, 111, '2015-01-15 00:46:09.000000', 'temperatura', 884.0000, 'ºC'),
	(25012, 111, '2015-01-15 00:46:10.000000', 'temperatura', 457.0000, 'ºC'),
	(25013, 111, '2015-01-15 00:46:11.000000', 'temperatura', 834.0000, 'ºC'),
	(25014, 111, '2015-01-15 00:46:12.000000', 'temperatura', 399.0000, 'ºC'),
	(25015, 111, '2015-01-15 00:46:13.000000', 'temperatura', 696.0000, 'ºC'),
	(25016, 111, '2015-01-15 00:46:14.000000', 'temperatura', 1082.0000, 'ºC'),
	(25017, 111, '2015-01-15 00:46:15.000000', 'temperatura', 922.0000, 'ºC'),
	(25018, 111, '2015-01-15 00:46:16.000000', 'temperatura', 163.0000, 'ºC'),
	(25019, 111, '2015-01-15 00:46:17.000000', 'temperatura', 450.0000, 'ºC'),
	(25020, 111, '2015-01-15 00:46:18.000000', 'temperatura', 561.0000, 'ºC'),
	(25021, 111, '2015-01-15 00:46:19.000000', 'temperatura', 258.0000, 'ºC'),
	(25022, 111, '2015-01-15 00:46:20.000000', 'temperatura', 807.0000, 'ºC'),
	(25023, 111, '2015-01-15 00:46:21.000000', 'temperatura', 861.0000, 'ºC'),
	(25024, 111, '2015-01-15 00:46:22.000000', 'temperatura', 684.0000, 'ºC'),
	(25025, 111, '2015-01-15 00:46:23.000000', 'temperatura', 836.0000, 'ºC'),
	(25026, 111, '2015-01-15 00:46:24.000000', 'temperatura', 930.0000, 'ºC'),
	(25027, 111, '2015-01-15 00:46:25.000000', 'temperatura', 943.0000, 'ºC'),
	(25028, 111, '2015-01-15 00:46:26.000000', 'temperatura', 726.0000, 'ºC'),
	(25029, 111, '2015-01-15 00:46:27.000000', 'temperatura', 800.0000, 'ºC'),
	(25030, 111, '2015-01-15 00:46:28.000000', 'temperatura', 623.0000, 'ºC'),
	(25031, 111, '2015-01-15 00:46:29.000000', 'temperatura', 714.0000, 'ºC'),
	(25032, 111, '2015-01-15 00:46:30.000000', 'temperatura', 501.0000, 'ºC'),
	(25033, 111, '2015-01-15 00:46:31.000000', 'temperatura', 366.0000, 'ºC'),
	(25034, 111, '2015-01-15 00:46:32.000000', 'temperatura', 328.0000, 'ºC'),
	(25035, 111, '2015-01-15 00:46:33.000000', 'temperatura', 543.0000, 'ºC'),
	(25036, 111, '2015-01-15 00:46:34.000000', 'temperatura', 531.0000, 'ºC'),
	(25037, 111, '2015-01-15 00:46:35.000000', 'temperatura', 1027.0000, 'ºC'),
	(25038, 111, '2015-01-15 00:46:36.000000', 'temperatura', 1141.0000, 'ºC'),
	(25039, 111, '2015-01-15 00:46:37.000000', 'temperatura', 227.0000, 'ºC'),
	(25040, 111, '2015-01-15 00:46:38.000000', 'temperatura', 112.0000, 'ºC'),
	(25041, 111, '2015-01-15 00:46:39.000000', 'temperatura', 1077.0000, 'ºC'),
	(25042, 111, '2015-01-15 00:46:40.000000', 'temperatura', 252.0000, 'ºC'),
	(25043, 111, '2015-01-15 00:46:41.000000', 'temperatura', 428.0000, 'ºC'),
	(25044, 111, '2015-01-15 00:46:42.000000', 'temperatura', 185.0000, 'ºC'),
	(25045, 111, '2015-01-15 00:46:43.000000', 'temperatura', 843.0000, 'ºC'),
	(25046, 111, '2015-01-15 00:46:44.000000', 'temperatura', 59.0000, 'ºC'),
	(25047, 111, '2015-01-15 00:46:45.000000', 'temperatura', 165.0000, 'ºC'),
	(25048, 111, '2015-01-15 00:46:46.000000', 'temperatura', 651.0000, 'ºC'),
	(25049, 111, '2015-01-15 00:46:47.000000', 'temperatura', 359.0000, 'ºC'),
	(25050, 111, '2015-01-15 00:46:48.000000', 'temperatura', 1041.0000, 'ºC'),
	(25051, 111, '2015-01-15 00:46:49.000000', 'temperatura', 530.0000, 'ºC'),
	(25052, 111, '2015-01-15 00:46:50.000000', 'temperatura', 728.0000, 'ºC'),
	(25053, 111, '2015-01-15 00:46:51.000000', 'temperatura', 852.0000, 'ºC'),
	(25054, 111, '2015-01-15 00:46:52.000000', 'temperatura', 876.0000, 'ºC'),
	(25055, 111, '2015-01-15 00:46:53.000000', 'temperatura', 624.0000, 'ºC'),
	(25056, 111, '2015-01-15 00:46:54.000000', 'temperatura', 494.0000, 'ºC'),
	(25057, 111, '2015-01-15 00:46:55.000000', 'temperatura', 595.0000, 'ºC'),
	(25058, 111, '2015-01-15 00:46:56.000000', 'temperatura', 297.0000, 'ºC'),
	(25059, 111, '2015-01-15 00:46:57.000000', 'temperatura', 897.0000, 'ºC'),
	(25060, 111, '2015-01-15 00:46:58.000000', 'temperatura', 1198.0000, 'ºC'),
	(25061, 111, '2015-01-15 00:46:59.000000', 'temperatura', 898.0000, 'ºC'),
	(25062, 111, '2015-01-15 00:47:00.000000', 'temperatura', 895.0000, 'ºC'),
	(25063, 111, '2015-01-15 00:47:01.000000', 'temperatura', 581.0000, 'ºC'),
	(25064, 111, '2015-01-15 00:47:02.000000', 'temperatura', 221.0000, 'ºC'),
	(25065, 111, '2015-01-15 00:47:03.000000', 'temperatura', 562.0000, 'ºC'),
	(25066, 111, '2015-01-15 00:47:04.000000', 'temperatura', 949.0000, 'ºC'),
	(25067, 111, '2015-01-15 00:47:05.000000', 'temperatura', 657.0000, 'ºC'),
	(25068, 111, '2015-01-15 00:47:06.000000', 'temperatura', 441.0000, 'ºC'),
	(25069, 111, '2015-01-15 00:47:07.000000', 'temperatura', 233.0000, 'ºC'),
	(25070, 111, '2015-01-15 00:47:08.000000', 'temperatura', 1041.0000, 'ºC'),
	(25071, 111, '2015-01-15 00:47:09.000000', 'temperatura', 907.0000, 'ºC'),
	(25072, 111, '2015-01-15 00:47:10.000000', 'temperatura', 215.0000, 'ºC'),
	(25073, 111, '2015-01-15 00:47:11.000000', 'temperatura', 753.0000, 'ºC'),
	(25074, 111, '2015-01-15 00:47:12.000000', 'temperatura', 721.0000, 'ºC'),
	(25075, 111, '2015-01-15 00:47:13.000000', 'temperatura', 147.0000, 'ºC'),
	(25076, 111, '2015-01-15 00:47:14.000000', 'temperatura', 972.0000, 'ºC'),
	(25077, 111, '2015-01-15 00:47:15.000000', 'temperatura', 821.0000, 'ºC'),
	(25078, 111, '2015-01-15 00:47:16.000000', 'temperatura', 1190.0000, 'ºC'),
	(25079, 111, '2015-01-15 00:47:17.000000', 'temperatura', 1087.0000, 'ºC'),
	(25080, 111, '2015-01-15 00:47:18.000000', 'temperatura', 665.0000, 'ºC'),
	(25081, 111, '2015-01-15 00:47:19.000000', 'temperatura', 64.0000, 'ºC'),
	(25082, 111, '2015-01-15 00:47:20.000000', 'temperatura', 726.0000, 'ºC'),
	(25083, 111, '2015-01-15 00:47:21.000000', 'temperatura', 1040.0000, 'ºC'),
	(25084, 111, '2015-01-15 00:47:22.000000', 'temperatura', 621.0000, 'ºC'),
	(25085, 111, '2015-01-15 00:47:23.000000', 'temperatura', 1185.0000, 'ºC'),
	(25086, 111, '2015-01-15 00:47:24.000000', 'temperatura', 464.0000, 'ºC'),
	(25087, 111, '2015-01-15 00:47:25.000000', 'temperatura', 1165.0000, 'ºC'),
	(25088, 111, '2015-01-15 00:47:26.000000', 'temperatura', 833.0000, 'ºC'),
	(25089, 111, '2015-01-15 00:47:27.000000', 'temperatura', 672.0000, 'ºC'),
	(25090, 111, '2015-01-15 00:47:28.000000', 'temperatura', 861.0000, 'ºC'),
	(25091, 111, '2015-01-15 00:47:29.000000', 'temperatura', 1089.0000, 'ºC'),
	(25092, 111, '2015-01-15 00:47:30.000000', 'temperatura', 461.0000, 'ºC'),
	(25093, 111, '2015-01-15 00:47:31.000000', 'temperatura', 240.0000, 'ºC'),
	(25094, 111, '2015-01-15 00:47:32.000000', 'temperatura', 1019.0000, 'ºC'),
	(25095, 111, '2015-01-15 00:47:33.000000', 'temperatura', 774.0000, 'ºC'),
	(25096, 111, '2015-01-15 00:47:34.000000', 'temperatura', 813.0000, 'ºC'),
	(25097, 111, '2015-01-15 00:47:35.000000', 'temperatura', 544.0000, 'ºC'),
	(25098, 111, '2015-01-15 00:47:36.000000', 'temperatura', 280.0000, 'ºC'),
	(25099, 111, '2015-01-15 00:47:37.000000', 'temperatura', 971.0000, 'ºC'),
	(25100, 111, '2015-01-15 00:47:38.000000', 'temperatura', 413.0000, 'ºC'),
	(25101, 111, '2015-01-15 00:47:39.000000', 'temperatura', 353.0000, 'ºC'),
	(25102, 111, '2015-01-15 00:47:40.000000', 'temperatura', 526.0000, 'ºC'),
	(25103, 111, '2015-01-15 00:47:41.000000', 'temperatura', 371.0000, 'ºC'),
	(25104, 111, '2015-01-15 00:47:42.000000', 'temperatura', 276.0000, 'ºC'),
	(25105, 111, '2015-01-15 00:47:43.000000', 'temperatura', 270.0000, 'ºC'),
	(25106, 111, '2015-01-15 00:47:44.000000', 'temperatura', 523.0000, 'ºC'),
	(25107, 111, '2015-01-15 00:47:45.000000', 'temperatura', 605.0000, 'ºC'),
	(25108, 111, '2015-01-15 00:47:46.000000', 'temperatura', 255.0000, 'ºC'),
	(25109, 111, '2015-01-15 00:47:47.000000', 'temperatura', 663.0000, 'ºC'),
	(25110, 111, '2015-01-15 00:47:48.000000', 'temperatura', 151.0000, 'ºC'),
	(25111, 111, '2015-01-15 00:47:49.000000', 'temperatura', 1167.0000, 'ºC'),
	(25112, 111, '2015-01-15 00:47:50.000000', 'temperatura', 581.0000, 'ºC'),
	(25113, 111, '2015-01-15 00:47:51.000000', 'temperatura', 604.0000, 'ºC'),
	(25114, 111, '2015-01-15 00:47:52.000000', 'temperatura', 78.0000, 'ºC'),
	(25115, 111, '2015-01-15 00:47:53.000000', 'temperatura', 979.0000, 'ºC'),
	(25116, 111, '2015-01-15 00:47:54.000000', 'temperatura', 1060.0000, 'ºC'),
	(25117, 111, '2015-01-15 00:47:55.000000', 'temperatura', 1166.0000, 'ºC'),
	(25118, 111, '2015-01-15 00:47:56.000000', 'temperatura', 250.0000, 'ºC'),
	(25119, 111, '2015-01-15 00:47:57.000000', 'temperatura', 152.0000, 'ºC'),
	(25120, 111, '2015-01-15 00:47:58.000000', 'temperatura', 12.0000, 'ºC'),
	(25121, 111, '2015-01-15 00:47:59.000000', 'temperatura', 802.0000, 'ºC'),
	(25122, 111, '2015-01-15 00:48:00.000000', 'temperatura', 374.0000, 'ºC'),
	(25123, 111, '2015-01-15 00:48:01.000000', 'temperatura', 664.0000, 'ºC'),
	(25124, 111, '2015-01-15 00:48:02.000000', 'temperatura', 999.0000, 'ºC'),
	(25125, 111, '2015-01-15 00:48:03.000000', 'temperatura', 606.0000, 'ºC'),
	(25126, 111, '2015-01-15 00:48:04.000000', 'temperatura', 32.0000, 'ºC'),
	(25127, 111, '2015-01-15 00:48:05.000000', 'temperatura', 743.0000, 'ºC'),
	(25128, 111, '2015-01-15 00:48:06.000000', 'temperatura', 17.0000, 'ºC'),
	(25129, 111, '2015-01-15 00:48:07.000000', 'temperatura', 260.0000, 'ºC'),
	(25130, 111, '2015-01-15 00:48:08.000000', 'temperatura', 49.0000, 'ºC'),
	(25131, 111, '2015-01-15 00:48:09.000000', 'temperatura', 663.0000, 'ºC'),
	(25132, 111, '2015-01-15 00:48:10.000000', 'temperatura', 769.0000, 'ºC'),
	(25133, 111, '2015-01-15 00:48:11.000000', 'temperatura', 657.0000, 'ºC'),
	(25134, 111, '2015-01-15 00:48:12.000000', 'temperatura', 977.0000, 'ºC'),
	(25135, 111, '2015-01-15 00:48:13.000000', 'temperatura', 517.0000, 'ºC'),
	(25136, 111, '2015-01-15 00:48:14.000000', 'temperatura', 852.0000, 'ºC'),
	(25137, 111, '2015-01-15 00:48:15.000000', 'temperatura', 312.0000, 'ºC'),
	(25138, 111, '2015-01-15 00:48:16.000000', 'temperatura', 202.0000, 'ºC'),
	(25139, 111, '2015-01-15 00:48:17.000000', 'temperatura', 78.0000, 'ºC'),
	(25140, 111, '2015-01-15 00:48:18.000000', 'temperatura', 981.0000, 'ºC'),
	(25141, 111, '2015-01-15 00:48:19.000000', 'temperatura', 1074.0000, 'ºC'),
	(25142, 111, '2015-01-15 00:48:20.000000', 'temperatura', 28.0000, 'ºC'),
	(25143, 111, '2015-01-15 00:48:21.000000', 'temperatura', 516.0000, 'ºC'),
	(25144, 111, '2015-01-15 00:48:22.000000', 'temperatura', 99.0000, 'ºC'),
	(25145, 111, '2015-01-15 00:48:23.000000', 'temperatura', 146.0000, 'ºC'),
	(25146, 111, '2015-01-15 00:48:24.000000', 'temperatura', 435.0000, 'ºC'),
	(25147, 111, '2015-01-15 00:48:25.000000', 'temperatura', 536.0000, 'ºC'),
	(25148, 111, '2015-01-15 00:48:26.000000', 'temperatura', 174.0000, 'ºC'),
	(25149, 111, '2015-01-15 00:48:27.000000', 'temperatura', 466.0000, 'ºC'),
	(25150, 111, '2015-01-15 00:48:28.000000', 'temperatura', 607.0000, 'ºC'),
	(25151, 111, '2015-01-15 00:48:29.000000', 'temperatura', 437.0000, 'ºC'),
	(25152, 111, '2015-01-15 00:48:30.000000', 'temperatura', 363.0000, 'ºC'),
	(25153, 111, '2015-01-15 00:48:31.000000', 'temperatura', 505.0000, 'ºC'),
	(25154, 111, '2015-01-15 00:48:32.000000', 'temperatura', 237.0000, 'ºC'),
	(25155, 111, '2015-01-15 00:48:33.000000', 'temperatura', 869.0000, 'ºC'),
	(25156, 111, '2015-01-15 00:48:34.000000', 'temperatura', 35.0000, 'ºC'),
	(25157, 111, '2015-01-15 00:48:35.000000', 'temperatura', 1170.0000, 'ºC'),
	(25158, 111, '2015-01-15 00:48:36.000000', 'temperatura', 945.0000, 'ºC'),
	(25159, 111, '2015-01-15 00:48:37.000000', 'temperatura', 15.0000, 'ºC'),
	(25160, 111, '2015-01-15 00:48:38.000000', 'temperatura', 839.0000, 'ºC'),
	(25161, 111, '2015-01-15 00:48:39.000000', 'temperatura', 553.0000, 'ºC'),
	(25162, 111, '2015-01-15 00:48:40.000000', 'temperatura', 249.0000, 'ºC'),
	(25163, 111, '2015-01-15 00:48:41.000000', 'temperatura', 784.0000, 'ºC'),
	(25164, 111, '2015-01-15 00:48:42.000000', 'temperatura', 773.0000, 'ºC'),
	(25165, 111, '2015-01-15 00:48:43.000000', 'temperatura', 315.0000, 'ºC'),
	(25166, 111, '2015-01-15 00:48:44.000000', 'temperatura', 455.0000, 'ºC'),
	(25167, 111, '2015-01-15 00:48:45.000000', 'temperatura', 131.0000, 'ºC'),
	(25168, 111, '2015-01-15 00:48:46.000000', 'temperatura', 492.0000, 'ºC'),
	(25169, 111, '2015-01-15 00:48:47.000000', 'temperatura', 868.0000, 'ºC'),
	(25170, 111, '2015-01-15 00:48:48.000000', 'temperatura', 464.0000, 'ºC'),
	(25171, 111, '2015-01-15 00:48:49.000000', 'temperatura', 917.0000, 'ºC'),
	(25172, 111, '2015-01-15 00:48:50.000000', 'temperatura', 793.0000, 'ºC'),
	(25173, 111, '2015-01-15 00:48:51.000000', 'temperatura', 15.0000, 'ºC'),
	(25174, 111, '2015-01-15 00:48:52.000000', 'temperatura', 97.0000, 'ºC'),
	(25175, 111, '2015-01-15 00:48:53.000000', 'temperatura', 440.0000, 'ºC'),
	(25176, 111, '2015-01-15 00:48:54.000000', 'temperatura', 707.0000, 'ºC'),
	(25177, 111, '2015-01-15 00:48:55.000000', 'temperatura', 1018.0000, 'ºC'),
	(25178, 111, '2015-01-15 00:48:56.000000', 'temperatura', 571.0000, 'ºC'),
	(25179, 111, '2015-01-15 00:48:57.000000', 'temperatura', 999.0000, 'ºC'),
	(25180, 111, '2015-01-15 00:48:58.000000', 'temperatura', 884.0000, 'ºC'),
	(25181, 111, '2015-01-15 00:48:59.000000', 'temperatura', 222.0000, 'ºC'),
	(25182, 111, '2015-01-15 00:49:00.000000', 'temperatura', 859.0000, 'ºC'),
	(25183, 111, '2015-01-15 00:49:01.000000', 'temperatura', 27.0000, 'ºC'),
	(25184, 111, '2015-01-15 00:49:02.000000', 'temperatura', 1162.0000, 'ºC'),
	(25185, 111, '2015-01-15 00:49:03.000000', 'temperatura', 930.0000, 'ºC'),
	(25186, 111, '2015-01-15 00:49:04.000000', 'temperatura', 1164.0000, 'ºC'),
	(25187, 111, '2015-01-15 00:49:05.000000', 'temperatura', 630.0000, 'ºC'),
	(25188, 111, '2015-01-15 00:49:06.000000', 'temperatura', 858.0000, 'ºC'),
	(25189, 111, '2015-01-15 00:49:07.000000', 'temperatura', 1199.0000, 'ºC'),
	(25190, 111, '2015-01-15 00:49:08.000000', 'temperatura', 1023.0000, 'ºC'),
	(25191, 111, '2015-01-15 00:49:09.000000', 'temperatura', 317.0000, 'ºC'),
	(25192, 111, '2015-01-15 00:49:10.000000', 'temperatura', 920.0000, 'ºC'),
	(25193, 111, '2015-01-15 00:49:11.000000', 'temperatura', 46.0000, 'ºC'),
	(25194, 111, '2015-01-15 00:49:12.000000', 'temperatura', 1070.0000, 'ºC'),
	(25195, 111, '2015-01-15 00:49:13.000000', 'temperatura', 414.0000, 'ºC'),
	(25196, 111, '2015-01-15 00:49:14.000000', 'temperatura', 59.0000, 'ºC'),
	(25197, 111, '2015-01-15 00:49:15.000000', 'temperatura', 252.0000, 'ºC'),
	(25198, 111, '2015-01-15 00:49:16.000000', 'temperatura', 1087.0000, 'ºC'),
	(25199, 111, '2015-01-15 00:49:17.000000', 'temperatura', 1079.0000, 'ºC'),
	(25200, 111, '2015-01-15 00:49:18.000000', 'temperatura', 936.0000, 'ºC'),
	(25201, 111, '2015-01-15 00:49:19.000000', 'temperatura', 241.0000, 'ºC'),
	(25202, 111, '2015-01-15 00:49:20.000000', 'temperatura', 797.0000, 'ºC'),
	(25203, 111, '2015-01-15 00:49:21.000000', 'temperatura', 865.0000, 'ºC'),
	(25204, 111, '2015-01-15 00:49:22.000000', 'temperatura', 732.0000, 'ºC'),
	(25205, 111, '2015-01-15 00:49:23.000000', 'temperatura', 1064.0000, 'ºC'),
	(25206, 111, '2015-01-15 00:49:24.000000', 'temperatura', 728.0000, 'ºC'),
	(25207, 111, '2015-01-15 00:49:25.000000', 'temperatura', 446.0000, 'ºC'),
	(25208, 111, '2015-01-15 00:49:26.000000', 'temperatura', 48.0000, 'ºC'),
	(25209, 111, '2015-01-15 00:49:27.000000', 'temperatura', 100.0000, 'ºC'),
	(25210, 111, '2015-01-15 00:49:28.000000', 'temperatura', 359.0000, 'ºC'),
	(25211, 111, '2015-01-15 00:49:29.000000', 'temperatura', 295.0000, 'ºC'),
	(25212, 111, '2015-01-15 00:49:30.000000', 'temperatura', 397.0000, 'ºC'),
	(25213, 111, '2015-01-15 00:49:31.000000', 'temperatura', 1102.0000, 'ºC'),
	(25214, 111, '2015-01-15 00:49:32.000000', 'temperatura', 718.0000, 'ºC'),
	(25215, 111, '2015-01-15 00:49:33.000000', 'temperatura', 286.0000, 'ºC'),
	(25216, 111, '2015-01-15 00:49:34.000000', 'temperatura', 474.0000, 'ºC'),
	(25217, 111, '2015-01-15 00:49:35.000000', 'temperatura', 314.0000, 'ºC'),
	(25218, 111, '2015-01-15 00:49:36.000000', 'temperatura', 149.0000, 'ºC'),
	(25219, 111, '2015-01-15 00:49:37.000000', 'temperatura', 1004.0000, 'ºC'),
	(25220, 111, '2015-01-15 00:49:38.000000', 'temperatura', 975.0000, 'ºC'),
	(25221, 111, '2015-01-15 00:49:39.000000', 'temperatura', 661.0000, 'ºC'),
	(25222, 111, '2015-01-15 00:49:40.000000', 'temperatura', 382.0000, 'ºC'),
	(25223, 111, '2015-01-15 00:49:41.000000', 'temperatura', 1125.0000, 'ºC'),
	(25224, 111, '2015-01-15 00:49:42.000000', 'temperatura', 880.0000, 'ºC'),
	(25225, 111, '2015-01-15 00:49:43.000000', 'temperatura', 1026.0000, 'ºC'),
	(25226, 111, '2015-01-15 00:49:44.000000', 'temperatura', 93.0000, 'ºC'),
	(25227, 111, '2015-01-15 00:49:45.000000', 'temperatura', 984.0000, 'ºC'),
	(25228, 111, '2015-01-15 00:49:46.000000', 'temperatura', 1043.0000, 'ºC'),
	(25229, 111, '2015-01-15 00:49:47.000000', 'temperatura', 1063.0000, 'ºC'),
	(25230, 111, '2015-01-15 00:49:48.000000', 'temperatura', 988.0000, 'ºC'),
	(25231, 111, '2015-01-15 00:49:49.000000', 'temperatura', 553.0000, 'ºC'),
	(25232, 111, '2015-01-15 00:49:50.000000', 'temperatura', 998.0000, 'ºC'),
	(25233, 111, '2015-01-15 00:49:51.000000', 'temperatura', 934.0000, 'ºC'),
	(25234, 111, '2015-01-15 00:49:52.000000', 'temperatura', 477.0000, 'ºC'),
	(25235, 111, '2015-01-15 00:49:53.000000', 'temperatura', 784.0000, 'ºC'),
	(25236, 111, '2015-01-15 00:49:54.000000', 'temperatura', 89.0000, 'ºC'),
	(25237, 111, '2015-01-15 00:49:55.000000', 'temperatura', 492.0000, 'ºC'),
	(25238, 111, '2015-01-15 00:49:56.000000', 'temperatura', 993.0000, 'ºC'),
	(25239, 111, '2015-01-15 00:49:57.000000', 'temperatura', 1089.0000, 'ºC'),
	(25240, 111, '2015-01-15 00:49:58.000000', 'temperatura', 66.0000, 'ºC'),
	(25241, 111, '2015-01-15 00:49:59.000000', 'temperatura', 665.0000, 'ºC'),
	(25242, 111, '2015-01-15 00:50:00.000000', 'temperatura', 728.0000, 'ºC'),
	(25243, 111, '2015-01-15 00:50:01.000000', 'temperatura', 447.0000, 'ºC'),
	(25244, 111, '2015-01-15 00:50:02.000000', 'temperatura', 49.0000, 'ºC'),
	(25245, 111, '2015-01-15 00:50:03.000000', 'temperatura', 104.0000, 'ºC'),
	(25246, 111, '2015-01-15 00:50:04.000000', 'temperatura', 375.0000, 'ºC'),
	(25247, 111, '2015-01-15 00:50:05.000000', 'temperatura', 364.0000, 'ºC'),
	(25248, 111, '2015-01-15 00:50:06.000000', 'temperatura', 693.0000, 'ºC'),
	(25249, 111, '2015-01-15 00:50:07.000000', 'temperatura', 1175.0000, 'ºC'),
	(25250, 111, '2015-01-15 00:50:08.000000', 'temperatura', 195.0000, 'ºC'),
	(25251, 111, '2015-01-15 00:50:09.000000', 'temperatura', 1051.0000, 'ºC'),
	(25252, 111, '2015-01-15 00:50:10.000000', 'temperatura', 1071.0000, 'ºC'),
	(25253, 111, '2015-01-15 00:50:11.000000', 'temperatura', 1001.0000, 'ºC'),
	(25254, 111, '2015-01-15 00:50:12.000000', 'temperatura', 593.0000, 'ºC'),
	(25255, 111, '2015-01-15 00:50:13.000000', 'temperatura', 1164.0000, 'ºC'),
	(25256, 111, '2015-01-15 00:50:14.000000', 'temperatura', 441.0000, 'ºC'),
	(25257, 111, '2015-01-15 00:50:15.000000', 'temperatura', 1115.0000, 'ºC'),
	(25258, 111, '2015-01-15 00:50:16.000000', 'temperatura', 651.0000, 'ºC'),
	(25259, 111, '2015-01-15 00:50:17.000000', 'temperatura', 1111.0000, 'ºC'),
	(25260, 111, '2015-01-15 00:50:18.000000', 'temperatura', 4.0000, 'ºC'),
	(25261, 111, '2015-01-15 00:50:19.000000', 'temperatura', 286.0000, 'ºC'),
	(25262, 111, '2015-01-15 00:50:20.000000', 'temperatura', 218.0000, 'ºC'),
	(25263, 111, '2015-01-15 00:50:21.000000', 'temperatura', 233.0000, 'ºC'),
	(25264, 111, '2015-01-15 00:50:22.000000', 'temperatura', 510.0000, 'ºC'),
	(25265, 111, '2015-01-15 00:50:23.000000', 'temperatura', 651.0000, 'ºC'),
	(25266, 111, '2015-01-15 00:50:24.000000', 'temperatura', 527.0000, 'ºC'),
	(25267, 111, '2015-01-15 00:50:25.000000', 'temperatura', 681.0000, 'ºC'),
	(25268, 111, '2015-01-15 00:50:26.000000', 'temperatura', 627.0000, 'ºC'),
	(25269, 111, '2015-01-15 00:50:27.000000', 'temperatura', 1092.0000, 'ºC'),
	(25270, 111, '2015-01-15 00:50:28.000000', 'temperatura', 1181.0000, 'ºC'),
	(25271, 111, '2015-01-15 00:50:29.000000', 'temperatura', 229.0000, 'ºC'),
	(25272, 111, '2015-01-15 00:50:30.000000', 'temperatura', 1.0000, 'ºC'),
	(25273, 111, '2015-01-15 00:50:31.000000', 'temperatura', 521.0000, 'ºC'),
	(25274, 111, '2015-01-15 00:50:32.000000', 'temperatura', 202.0000, 'ºC'),
	(25275, 111, '2015-01-15 00:50:33.000000', 'temperatura', 648.0000, 'ºC'),
	(25276, 111, '2015-01-15 00:50:34.000000', 'temperatura', 234.0000, 'ºC'),
	(25277, 111, '2015-01-15 00:50:35.000000', 'temperatura', 426.0000, 'ºC'),
	(25278, 111, '2015-01-15 00:50:36.000000', 'temperatura', 228.0000, 'ºC'),
	(25279, 111, '2015-01-15 00:50:37.000000', 'temperatura', 1062.0000, 'ºC'),
	(25280, 111, '2015-01-15 00:50:38.000000', 'temperatura', 1026.0000, 'ºC'),
	(25281, 111, '2015-01-15 00:50:39.000000', 'temperatura', 745.0000, 'ºC'),
	(25282, 111, '2015-01-15 00:50:40.000000', 'temperatura', 649.0000, 'ºC'),
	(25283, 111, '2015-01-15 00:50:41.000000', 'temperatura', 1008.0000, 'ºC'),
	(25284, 111, '2015-01-15 00:50:42.000000', 'temperatura', 694.0000, 'ºC'),
	(25285, 111, '2015-01-15 00:50:43.000000', 'temperatura', 448.0000, 'ºC'),
	(25286, 111, '2015-01-15 00:50:44.000000', 'temperatura', 157.0000, 'ºC'),
	(25287, 111, '2015-01-15 00:50:45.000000', 'temperatura', 642.0000, 'ºC'),
	(25288, 111, '2015-01-15 00:50:46.000000', 'temperatura', 342.0000, 'ºC'),
	(25289, 111, '2015-01-15 00:50:47.000000', 'temperatura', 981.0000, 'ºC'),
	(25290, 111, '2015-01-15 00:50:48.000000', 'temperatura', 282.0000, 'ºC'),
	(25291, 111, '2015-01-15 00:50:49.000000', 'temperatura', 864.0000, 'ºC'),
	(25292, 111, '2015-01-15 00:50:50.000000', 'temperatura', 1078.0000, 'ºC'),
	(25293, 111, '2015-01-15 00:50:51.000000', 'temperatura', 399.0000, 'ºC'),
	(25294, 111, '2015-01-15 00:50:52.000000', 'temperatura', 1160.0000, 'ºC'),
	(25295, 111, '2015-01-15 00:50:53.000000', 'temperatura', 1003.0000, 'ºC'),
	(25296, 111, '2015-01-15 00:50:54.000000', 'temperatura', 336.0000, 'ºC'),
	(25297, 111, '2015-01-15 00:50:55.000000', 'temperatura', 1069.0000, 'ºC'),
	(25298, 111, '2015-01-15 00:50:56.000000', 'temperatura', 741.0000, 'ºC'),
	(25299, 111, '2015-01-15 00:50:57.000000', 'temperatura', 497.0000, 'ºC'),
	(25300, 111, '2015-01-15 00:50:58.000000', 'temperatura', 262.0000, 'ºC'),
	(25301, 111, '2015-01-15 00:50:59.000000', 'temperatura', 1022.0000, 'ºC'),
	(25302, 111, '2015-01-15 00:51:00.000000', 'temperatura', 723.0000, 'ºC'),
	(25303, 111, '2015-01-15 00:51:01.000000', 'temperatura', 551.0000, 'ºC'),
	(25304, 111, '2015-01-15 00:51:02.000000', 'temperatura', 586.0000, 'ºC'),
	(25305, 111, '2015-01-15 00:51:03.000000', 'temperatura', 78.0000, 'ºC'),
	(25306, 111, '2015-01-15 00:51:04.000000', 'temperatura', 1032.0000, 'ºC'),
	(25307, 111, '2015-01-15 00:51:05.000000', 'temperatura', 125.0000, 'ºC'),
	(25308, 111, '2015-01-15 00:51:06.000000', 'temperatura', 1130.0000, 'ºC'),
	(25309, 111, '2015-01-15 00:51:07.000000', 'temperatura', 477.0000, 'ºC'),
	(25310, 111, '2015-01-15 00:51:08.000000', 'temperatura', 196.0000, 'ºC'),
	(25311, 111, '2015-01-15 00:51:09.000000', 'temperatura', 748.0000, 'ºC'),
	(25312, 111, '2015-01-15 00:51:10.000000', 'temperatura', 752.0000, 'ºC'),
	(25313, 111, '2015-01-15 00:51:11.000000', 'temperatura', 316.0000, 'ºC'),
	(25314, 111, '2015-01-15 00:51:12.000000', 'temperatura', 526.0000, 'ºC'),
	(25315, 111, '2015-01-15 00:51:13.000000', 'temperatura', 481.0000, 'ºC'),
	(25316, 111, '2015-01-15 00:51:14.000000', 'temperatura', 826.0000, 'ºC'),
	(25317, 111, '2015-01-15 00:51:15.000000', 'temperatura', 290.0000, 'ºC'),
	(25318, 111, '2015-01-15 00:51:16.000000', 'temperatura', 171.0000, 'ºC'),
	(25319, 111, '2015-01-15 00:51:17.000000', 'temperatura', 1184.0000, 'ºC'),
	(25320, 111, '2015-01-15 00:51:18.000000', 'temperatura', 609.0000, 'ºC'),
	(25321, 111, '2015-01-15 00:51:19.000000', 'temperatura', 694.0000, 'ºC'),
	(25322, 111, '2015-01-15 00:51:20.000000', 'temperatura', 441.0000, 'ºC'),
	(25323, 111, '2015-01-15 00:51:21.000000', 'temperatura', 127.0000, 'ºC'),
	(25324, 111, '2015-01-15 00:51:22.000000', 'temperatura', 511.0000, 'ºC'),
	(25325, 111, '2015-01-15 00:51:23.000000', 'temperatura', 973.0000, 'ºC'),
	(25326, 111, '2015-01-15 00:51:24.000000', 'temperatura', 935.0000, 'ºC'),
	(25327, 111, '2015-01-15 00:51:25.000000', 'temperatura', 557.0000, 'ºC'),
	(25328, 111, '2015-01-15 00:51:26.000000', 'temperatura', 1178.0000, 'ºC'),
	(25329, 111, '2015-01-15 00:51:27.000000', 'temperatura', 618.0000, 'ºC'),
	(25330, 111, '2015-01-15 00:51:28.000000', 'temperatura', 760.0000, 'ºC'),
	(25331, 111, '2015-01-15 00:51:29.000000', 'temperatura', 745.0000, 'ºC'),
	(25332, 111, '2015-01-15 00:51:30.000000', 'temperatura', 247.0000, 'ºC'),
	(25333, 111, '2015-01-15 00:51:31.000000', 'temperatura', 199.0000, 'ºC'),
	(25334, 111, '2015-01-15 00:51:32.000000', 'temperatura', 256.0000, 'ºC'),
	(25335, 111, '2015-01-15 00:51:33.000000', 'temperatura', 683.0000, 'ºC'),
	(25336, 111, '2015-01-15 00:51:34.000000', 'temperatura', 248.0000, 'ºC'),
	(25337, 111, '2015-01-15 00:51:35.000000', 'temperatura', 389.0000, 'ºC'),
	(25338, 111, '2015-01-15 00:51:36.000000', 'temperatura', 3.0000, 'ºC'),
	(25339, 111, '2015-01-15 00:51:37.000000', 'temperatura', 47.0000, 'ºC'),
	(25340, 111, '2015-01-15 00:51:38.000000', 'temperatura', 227.0000, 'ºC'),
	(25341, 111, '2015-01-15 00:51:39.000000', 'temperatura', 995.0000, 'ºC'),
	(25342, 111, '2015-01-15 00:51:40.000000', 'temperatura', 696.0000, 'ºC'),
	(25343, 111, '2015-01-15 00:51:41.000000', 'temperatura', 495.0000, 'ºC'),
	(25344, 111, '2015-01-15 00:51:42.000000', 'temperatura', 385.0000, 'ºC'),
	(25345, 111, '2015-01-15 00:51:43.000000', 'temperatura', 443.0000, 'ºC'),
	(25346, 111, '2015-01-15 00:51:44.000000', 'temperatura', 1062.0000, 'ºC'),
	(25347, 111, '2015-01-15 00:51:45.000000', 'temperatura', 379.0000, 'ºC'),
	(25348, 111, '2015-01-15 00:51:46.000000', 'temperatura', 1112.0000, 'ºC'),
	(25349, 111, '2015-01-15 00:51:47.000000', 'temperatura', 821.0000, 'ºC'),
	(25350, 111, '2015-01-15 00:51:48.000000', 'temperatura', 768.0000, 'ºC'),
	(25351, 111, '2015-01-15 00:51:49.000000', 'temperatura', 181.0000, 'ºC'),
	(25352, 111, '2015-01-15 00:51:50.000000', 'temperatura', 998.0000, 'ºC'),
	(25353, 111, '2015-01-15 00:51:51.000000', 'temperatura', 851.0000, 'ºC'),
	(25354, 111, '2015-01-15 00:51:52.000000', 'temperatura', 58.0000, 'ºC'),
	(25355, 111, '2015-01-15 00:51:53.000000', 'temperatura', 140.0000, 'ºC'),
	(25356, 111, '2015-01-15 00:51:54.000000', 'temperatura', 525.0000, 'ºC'),
	(25357, 111, '2015-01-15 00:51:55.000000', 'temperatura', 1005.0000, 'ºC'),
	(25358, 111, '2015-01-15 00:51:56.000000', 'temperatura', 1051.0000, 'ºC'),
	(25359, 111, '2015-01-15 00:51:57.000000', 'temperatura', 1042.0000, 'ºC'),
	(25360, 111, '2015-01-15 00:51:58.000000', 'temperatura', 857.0000, 'ºC'),
	(25361, 111, '2015-01-15 00:51:59.000000', 'temperatura', 1159.0000, 'ºC'),
	(25362, 111, '2015-01-15 00:52:00.000000', 'temperatura', 826.0000, 'ºC'),
	(25363, 111, '2015-01-15 00:52:01.000000', 'temperatura', 651.0000, 'ºC'),
	(25364, 111, '2015-01-15 00:52:02.000000', 'temperatura', 779.0000, 'ºC'),
	(25365, 111, '2015-01-15 00:52:03.000000', 'temperatura', 744.0000, 'ºC'),
	(25366, 111, '2015-01-15 00:52:04.000000', 'temperatura', 181.0000, 'ºC'),
	(25367, 111, '2015-01-15 00:52:05.000000', 'temperatura', 1072.0000, 'ºC'),
	(25368, 111, '2015-01-15 00:52:06.000000', 'temperatura', 21.0000, 'ºC'),
	(25369, 111, '2015-01-15 00:52:07.000000', 'temperatura', 487.0000, 'ºC'),
	(25370, 111, '2015-01-15 00:52:08.000000', 'temperatura', 1173.0000, 'ºC'),
	(25371, 111, '2015-01-15 00:52:09.000000', 'temperatura', 803.0000, 'ºC'),
	(25372, 111, '2015-01-15 00:52:10.000000', 'temperatura', 500.0000, 'ºC'),
	(25373, 111, '2015-01-15 00:52:11.000000', 'temperatura', 89.0000, 'ºC'),
	(25374, 111, '2015-01-15 00:52:12.000000', 'temperatura', 147.0000, 'ºC'),
	(25375, 111, '2015-01-15 00:52:13.000000', 'temperatura', 469.0000, 'ºC'),
	(25376, 111, '2015-01-15 00:52:14.000000', 'temperatura', 704.0000, 'ºC'),
	(25377, 111, '2015-01-15 00:52:15.000000', 'temperatura', 911.0000, 'ºC'),
	(25378, 111, '2015-01-15 00:52:16.000000', 'temperatura', 46.0000, 'ºC'),
	(25379, 111, '2015-01-15 00:52:17.000000', 'temperatura', 1096.0000, 'ºC'),
	(25380, 111, '2015-01-15 00:52:18.000000', 'temperatura', 545.0000, 'ºC'),
	(25381, 111, '2015-01-15 00:52:19.000000', 'temperatura', 635.0000, 'ºC'),
	(25382, 111, '2015-01-15 00:52:20.000000', 'temperatura', 341.0000, 'ºC'),
	(25383, 111, '2015-01-15 00:52:21.000000', 'temperatura', 1000.0000, 'ºC'),
	(25384, 111, '2015-01-15 00:52:22.000000', 'temperatura', 376.0000, 'ºC'),
	(25385, 111, '2015-01-15 00:52:23.000000', 'temperatura', 83.0000, 'ºC'),
	(25386, 111, '2015-01-15 00:52:24.000000', 'temperatura', 488.0000, 'ºC'),
	(25387, 111, '2015-01-15 00:52:25.000000', 'temperatura', 993.0000, 'ºC'),
	(25388, 111, '2015-01-15 00:52:26.000000', 'temperatura', 1099.0000, 'ºC'),
	(25389, 111, '2015-01-15 00:52:27.000000', 'temperatura', 116.0000, 'ºC'),
	(25390, 111, '2015-01-15 00:52:28.000000', 'temperatura', 886.0000, 'ºC'),
	(25391, 111, '2015-01-15 00:52:29.000000', 'temperatura', 479.0000, 'ºC'),
	(25392, 111, '2015-01-15 00:52:30.000000', 'temperatura', 941.0000, 'ºC'),
	(25393, 111, '2015-01-15 00:52:31.000000', 'temperatura', 867.0000, 'ºC'),
	(25394, 111, '2015-01-15 00:52:32.000000', 'temperatura', 315.0000, 'ºC'),
	(25395, 111, '2015-01-15 00:52:33.000000', 'temperatura', 171.0000, 'ºC'),
	(25396, 111, '2015-01-15 00:52:34.000000', 'temperatura', 1111.0000, 'ºC'),
	(25397, 111, '2015-01-15 00:52:35.000000', 'temperatura', 243.0000, 'ºC'),
	(25398, 111, '2015-01-15 00:52:36.000000', 'temperatura', 281.0000, 'ºC'),
	(25399, 111, '2015-01-15 00:52:37.000000', 'temperatura', 677.0000, 'ºC'),
	(25400, 111, '2015-01-15 00:52:38.000000', 'temperatura', 145.0000, 'ºC'),
	(25401, 111, '2015-01-15 00:52:39.000000', 'temperatura', 1091.0000, 'ºC'),
	(25402, 111, '2015-01-15 00:52:40.000000', 'temperatura', 222.0000, 'ºC'),
	(25403, 111, '2015-01-15 00:52:41.000000', 'temperatura', 237.0000, 'ºC'),
	(25404, 111, '2015-01-15 00:52:42.000000', 'temperatura', 521.0000, 'ºC'),
	(25405, 111, '2015-01-15 00:52:43.000000', 'temperatura', 694.0000, 'ºC'),
	(25406, 111, '2015-01-15 00:52:44.000000', 'temperatura', 708.0000, 'ºC'),
	(25407, 111, '2015-01-15 00:52:45.000000', 'temperatura', 258.0000, 'ºC'),
	(25408, 111, '2015-01-15 00:52:46.000000', 'temperatura', 367.0000, 'ºC'),
	(25409, 111, '2015-01-15 00:52:47.000000', 'temperatura', 1060.0000, 'ºC'),
	(25410, 111, '2015-01-15 00:52:48.000000', 'temperatura', 600.0000, 'ºC'),
	(25411, 111, '2015-01-15 00:52:49.000000', 'temperatura', 1022.0000, 'ºC'),
	(25412, 111, '2015-01-15 00:52:50.000000', 'temperatura', 910.0000, 'ºC'),
	(25413, 111, '2015-01-15 00:52:51.000000', 'temperatura', 285.0000, 'ºC'),
	(25414, 111, '2015-01-15 00:52:52.000000', 'temperatura', 1094.0000, 'ºC'),
	(25415, 111, '2015-01-15 00:52:53.000000', 'temperatura', 1016.0000, 'ºC'),
	(25416, 111, '2015-01-15 00:52:54.000000', 'temperatura', 600.0000, 'ºC'),
	(25417, 111, '2015-01-15 00:52:55.000000', 'temperatura', 1152.0000, 'ºC'),
	(25418, 111, '2015-01-15 00:52:56.000000', 'temperatura', 361.0000, 'ºC'),
	(25419, 111, '2015-01-15 00:52:57.000000', 'temperatura', 750.0000, 'ºC'),
	(25420, 111, '2015-01-15 00:52:58.000000', 'temperatura', 267.0000, 'ºC'),
	(25421, 111, '2015-01-15 00:52:59.000000', 'temperatura', 287.0000, 'ºC'),
	(25422, 111, '2015-01-15 00:53:00.000000', 'temperatura', 634.0000, 'ºC'),
	(25423, 111, '2015-01-15 00:53:01.000000', 'temperatura', 1109.0000, 'ºC'),
	(25424, 111, '2015-01-15 00:53:02.000000', 'temperatura', 42.0000, 'ºC'),
	(25425, 111, '2015-01-15 00:53:03.000000', 'temperatura', 485.0000, 'ºC'),
	(25426, 111, '2015-01-15 00:53:04.000000', 'temperatura', 1100.0000, 'ºC'),
	(25427, 111, '2015-01-15 00:53:05.000000', 'temperatura', 443.0000, 'ºC'),
	(25428, 111, '2015-01-15 00:53:06.000000', 'temperatura', 116.0000, 'ºC'),
	(25429, 111, '2015-01-15 00:53:07.000000', 'temperatura', 453.0000, 'ºC'),
	(25430, 111, '2015-01-15 00:53:08.000000', 'temperatura', 717.0000, 'ºC'),
	(25431, 111, '2015-01-15 00:53:09.000000', 'temperatura', 1028.0000, 'ºC'),
	(25432, 111, '2015-01-15 00:53:10.000000', 'temperatura', 589.0000, 'ºC'),
	(25433, 111, '2015-01-15 00:53:11.000000', 'temperatura', 1061.0000, 'ºC'),
	(25434, 111, '2015-01-15 00:53:12.000000', 'temperatura', 1141.0000, 'ºC'),
	(25435, 111, '2015-01-15 00:53:13.000000', 'temperatura', 119.0000, 'ºC'),
	(25436, 111, '2015-01-15 00:53:14.000000', 'temperatura', 773.0000, 'ºC'),
	(25437, 111, '2015-01-15 00:53:15.000000', 'temperatura', 1110.0000, 'ºC'),
	(25438, 111, '2015-01-15 00:53:16.000000', 'temperatura', 832.0000, 'ºC'),
	(25439, 111, '2015-01-15 00:53:17.000000', 'temperatura', 831.0000, 'ºC'),
	(25440, 111, '2015-01-15 00:53:18.000000', 'temperatura', 457.0000, 'ºC'),
	(25441, 111, '2015-01-15 00:53:19.000000', 'temperatura', 994.0000, 'ºC'),
	(25442, 111, '2015-01-15 00:53:20.000000', 'temperatura', 1199.0000, 'ºC'),
	(25443, 111, '2015-01-15 00:53:21.000000', 'temperatura', 612.0000, 'ºC'),
	(25444, 111, '2015-01-15 00:53:22.000000', 'temperatura', 664.0000, 'ºC'),
	(25445, 111, '2015-01-15 00:53:23.000000', 'temperatura', 286.0000, 'ºC'),
	(25446, 111, '2015-01-15 00:53:24.000000', 'temperatura', 638.0000, 'ºC'),
	(25447, 111, '2015-01-15 00:53:25.000000', 'temperatura', 1132.0000, 'ºC'),
	(25448, 111, '2015-01-15 00:53:26.000000', 'temperatura', 147.0000, 'ºC'),
	(25449, 111, '2015-01-15 00:53:27.000000', 'temperatura', 939.0000, 'ºC'),
	(25450, 111, '2015-01-15 00:53:28.000000', 'temperatura', 655.0000, 'ºC'),
	(25451, 111, '2015-01-15 00:53:29.000000', 'temperatura', 459.0000, 'ºC'),
	(25452, 111, '2015-01-15 00:53:30.000000', 'temperatura', 330.0000, 'ºC'),
	(25453, 111, '2015-01-15 00:53:31.000000', 'temperatura', 274.0000, 'ºC'),
	(25454, 111, '2015-01-15 00:53:32.000000', 'temperatura', 380.0000, 'ºC'),
	(25455, 111, '2015-01-15 00:53:33.000000', 'temperatura', 1079.0000, 'ºC'),
	(25456, 111, '2015-01-15 00:53:34.000000', 'temperatura', 653.0000, 'ºC'),
	(25457, 111, '2015-01-15 00:53:35.000000', 'temperatura', 30.0000, 'ºC'),
	(25458, 111, '2015-01-15 00:53:36.000000', 'temperatura', 594.0000, 'ºC'),
	(25459, 111, '2015-01-15 00:53:37.000000', 'temperatura', 477.0000, 'ºC'),
	(25460, 111, '2015-01-15 00:53:38.000000', 'temperatura', 606.0000, 'ºC'),
	(25461, 111, '2015-01-15 00:53:39.000000', 'temperatura', 399.0000, 'ºC'),
	(25462, 111, '2015-01-15 00:53:40.000000', 'temperatura', 176.0000, 'ºC'),
	(25463, 111, '2015-01-15 00:53:41.000000', 'temperatura', 886.0000, 'ºC'),
	(25464, 111, '2015-01-15 00:53:42.000000', 'temperatura', 299.0000, 'ºC'),
	(25465, 111, '2015-01-15 00:53:43.000000', 'temperatura', 41.0000, 'ºC'),
	(25466, 111, '2015-01-15 00:53:44.000000', 'temperatura', 508.0000, 'ºC'),
	(25467, 111, '2015-01-15 00:53:45.000000', 'temperatura', 18.0000, 'ºC'),
	(25468, 111, '2015-01-15 00:53:46.000000', 'temperatura', 967.0000, 'ºC'),
	(25469, 111, '2015-01-15 00:53:47.000000', 'temperatura', 1181.0000, 'ºC'),
	(25470, 111, '2015-01-15 00:53:48.000000', 'temperatura', 603.0000, 'ºC'),
	(25471, 111, '2015-01-15 00:53:49.000000', 'temperatura', 675.0000, 'ºC'),
	(25472, 111, '2015-01-15 00:53:50.000000', 'temperatura', 364.0000, 'ºC'),
	(25473, 111, '2015-01-15 00:53:51.000000', 'temperatura', 998.0000, 'ºC'),
	(25474, 111, '2015-01-15 00:53:52.000000', 'temperatura', 296.0000, 'ºC'),
	(25475, 111, '2015-01-15 00:53:53.000000', 'temperatura', 888.0000, 'ºC'),
	(25476, 111, '2015-01-15 00:53:54.000000', 'temperatura', 1153.0000, 'ºC'),
	(25477, 111, '2015-01-15 00:53:55.000000', 'temperatura', 702.0000, 'ºC'),
	(25478, 111, '2015-01-15 00:53:56.000000', 'temperatura', 51.0000, 'ºC'),
	(25479, 111, '2015-01-15 00:53:57.000000', 'temperatura', 549.0000, 'ºC'),
	(25480, 111, '2015-01-15 00:53:58.000000', 'temperatura', 194.0000, 'ºC'),
	(25481, 111, '2015-01-15 00:53:59.000000', 'temperatura', 524.0000, 'ºC'),
	(25482, 111, '2015-01-15 00:54:00.000000', 'temperatura', 835.0000, 'ºC'),
	(25483, 111, '2015-01-15 00:54:01.000000', 'temperatura', 207.0000, 'ºC'),
	(25484, 111, '2015-01-15 00:54:02.000000', 'temperatura', 931.0000, 'ºC'),
	(25485, 111, '2015-01-15 00:54:03.000000', 'temperatura', 433.0000, 'ºC'),
	(25486, 111, '2015-01-15 00:54:04.000000', 'temperatura', 575.0000, 'ºC'),
	(25487, 111, '2015-01-15 00:54:05.000000', 'temperatura', 373.0000, 'ºC'),
	(25488, 111, '2015-01-15 00:54:06.000000', 'temperatura', 143.0000, 'ºC'),
	(25489, 111, '2015-01-15 00:54:07.000000', 'temperatura', 794.0000, 'ºC'),
	(25490, 111, '2015-01-15 00:54:08.000000', 'temperatura', 1144.0000, 'ºC'),
	(25491, 111, '2015-01-15 00:54:09.000000', 'temperatura', 938.0000, 'ºC'),
	(25492, 111, '2015-01-15 00:54:10.000000', 'temperatura', 57.0000, 'ºC'),
	(25493, 111, '2015-01-15 00:54:11.000000', 'temperatura', 1071.0000, 'ºC'),
	(25494, 111, '2015-01-15 00:54:12.000000', 'temperatura', 384.0000, 'ºC'),
	(25495, 111, '2015-01-15 00:54:13.000000', 'temperatura', 1107.0000, 'ºC'),
	(25496, 111, '2015-01-15 00:54:14.000000', 'temperatura', 783.0000, 'ºC'),
	(25497, 111, '2015-01-15 00:54:15.000000', 'temperatura', 597.0000, 'ºC'),
	(25498, 111, '2015-01-15 00:54:16.000000', 'temperatura', 634.0000, 'ºC'),
	(25499, 111, '2015-01-15 00:54:17.000000', 'temperatura', 182.0000, 'ºC'),
	(25500, 111, '2015-01-15 00:54:18.000000', 'temperatura', 206.0000, 'ºC'),
	(25501, 111, '2015-01-15 00:54:19.000000', 'temperatura', 485.0000, 'ºC'),
	(25502, 111, '2015-01-15 00:54:20.000000', 'temperatura', 609.0000, 'ºC'),
	(25503, 111, '2015-01-15 00:54:21.000000', 'temperatura', 392.0000, 'ºC'),
	(25504, 111, '2015-01-15 00:54:22.000000', 'temperatura', 131.0000, 'ºC'),
	(25505, 111, '2015-01-15 00:54:23.000000', 'temperatura', 679.0000, 'ºC'),
	(25506, 111, '2015-01-15 00:54:24.000000', 'temperatura', 602.0000, 'ºC'),
	(25507, 111, '2015-01-15 00:54:25.000000', 'temperatura', 976.0000, 'ºC'),
	(25508, 111, '2015-01-15 00:54:26.000000', 'temperatura', 675.0000, 'ºC'),
	(25509, 111, '2015-01-15 00:54:27.000000', 'temperatura', 446.0000, 'ºC'),
	(25510, 111, '2015-01-15 00:54:28.000000', 'temperatura', 206.0000, 'ºC'),
	(25511, 111, '2015-01-15 00:54:29.000000', 'temperatura', 894.0000, 'ºC'),
	(25512, 111, '2015-01-15 00:54:30.000000', 'temperatura', 252.0000, 'ºC'),
	(25513, 111, '2015-01-15 00:54:31.000000', 'temperatura', 978.0000, 'ºC'),
	(25514, 111, '2015-01-15 00:54:32.000000', 'temperatura', 532.0000, 'ºC'),
	(25515, 111, '2015-01-15 00:54:33.000000', 'temperatura', 930.0000, 'ºC'),
	(25516, 111, '2015-01-15 00:54:34.000000', 'temperatura', 654.0000, 'ºC'),
	(25517, 111, '2015-01-15 00:54:35.000000', 'temperatura', 478.0000, 'ºC'),
	(25518, 111, '2015-01-15 00:54:36.000000', 'temperatura', 430.0000, 'ºC'),
	(25519, 111, '2015-01-15 00:54:37.000000', 'temperatura', 714.0000, 'ºC'),
	(25520, 111, '2015-01-15 00:54:38.000000', 'temperatura', 1084.0000, 'ºC'),
	(25521, 111, '2015-01-15 00:54:39.000000', 'temperatura', 876.0000, 'ºC'),
	(25522, 111, '2015-01-15 00:54:40.000000', 'temperatura', 1130.0000, 'ºC'),
	(25523, 111, '2015-01-15 00:54:41.000000', 'temperatura', 623.0000, 'ºC'),
	(25524, 111, '2015-01-15 00:54:42.000000', 'temperatura', 923.0000, 'ºC'),
	(25525, 111, '2015-01-15 00:54:43.000000', 'temperatura', 349.0000, 'ºC'),
	(25526, 111, '2015-01-15 00:54:44.000000', 'temperatura', 174.0000, 'ºC'),
	(25527, 111, '2015-01-15 00:54:45.000000', 'temperatura', 1023.0000, 'ºC'),
	(25528, 111, '2015-01-15 00:54:46.000000', 'temperatura', 994.0000, 'ºC'),
	(25529, 111, '2015-01-15 00:54:47.000000', 'temperatura', 703.0000, 'ºC'),
	(25530, 111, '2015-01-15 00:54:48.000000', 'temperatura', 531.0000, 'ºC'),
	(25531, 111, '2015-01-15 00:54:49.000000', 'temperatura', 547.0000, 'ºC'),
	(25532, 111, '2015-01-15 00:54:50.000000', 'temperatura', 1142.0000, 'ºC'),
	(25533, 111, '2015-01-15 00:54:51.000000', 'temperatura', 470.0000, 'ºC'),
	(25534, 111, '2015-01-15 00:54:52.000000', 'temperatura', 124.0000, 'ºC'),
	(25535, 111, '2015-01-15 00:54:53.000000', 'temperatura', 412.0000, 'ºC'),
	(25536, 111, '2015-01-15 00:54:54.000000', 'temperatura', 489.0000, 'ºC'),
	(25537, 111, '2015-01-15 00:54:55.000000', 'temperatura', 11.0000, 'ºC'),
	(25538, 111, '2015-01-15 00:54:56.000000', 'temperatura', 985.0000, 'ºC'),
	(25539, 111, '2015-01-15 00:54:57.000000', 'temperatura', 96.0000, 'ºC'),
	(25540, 111, '2015-01-15 00:54:58.000000', 'temperatura', 1122.0000, 'ºC'),
	(25541, 111, '2015-01-15 00:54:59.000000', 'temperatura', 525.0000, 'ºC'),
	(25542, 111, '2015-01-15 00:55:00.000000', 'temperatura', 458.0000, 'ºC'),
	(25543, 111, '2015-01-15 00:55:01.000000', 'temperatura', 718.0000, 'ºC'),
	(25544, 111, '2015-01-15 00:55:02.000000', 'temperatura', 1014.0000, 'ºC'),
	(25545, 111, '2015-01-15 00:55:03.000000', 'temperatura', 515.0000, 'ºC'),
	(25546, 111, '2015-01-15 00:55:04.000000', 'temperatura', 736.0000, 'ºC'),
	(25547, 111, '2015-01-15 00:55:05.000000', 'temperatura', 935.0000, 'ºC'),
	(25548, 111, '2015-01-15 00:55:06.000000', 'temperatura', 68.0000, 'ºC'),
	(25549, 111, '2015-01-15 00:55:07.000000', 'temperatura', 1134.0000, 'ºC'),
	(25550, 111, '2015-01-15 00:55:08.000000', 'temperatura', 667.0000, 'ºC'),
	(25551, 111, '2015-01-15 00:55:09.000000', 'temperatura', 1133.0000, 'ºC'),
	(25552, 111, '2015-01-15 00:55:10.000000', 'temperatura', 66.0000, 'ºC'),
	(25553, 111, '2015-01-15 00:55:11.000000', 'temperatura', 532.0000, 'ºC'),
	(25554, 111, '2015-01-15 00:55:12.000000', 'temperatura', 60.0000, 'ºC'),
	(25555, 111, '2015-01-15 00:55:13.000000', 'temperatura', 1107.0000, 'ºC'),
	(25556, 111, '2015-01-15 00:55:14.000000', 'temperatura', 554.0000, 'ºC'),
	(25557, 111, '2015-01-15 00:55:15.000000', 'temperatura', 650.0000, 'ºC'),
	(25558, 111, '2015-01-15 00:55:16.000000', 'temperatura', 390.0000, 'ºC'),
	(25559, 111, '2015-01-15 00:55:17.000000', 'temperatura', 1199.0000, 'ºC'),
	(25560, 111, '2015-01-15 00:55:18.000000', 'temperatura', 27.0000, 'ºC'),
	(25561, 111, '2015-01-15 00:55:19.000000', 'temperatura', 136.0000, 'ºC'),
	(25562, 111, '2015-01-15 00:55:20.000000', 'temperatura', 600.0000, 'ºC'),
	(25563, 111, '2015-01-15 00:55:21.000000', 'temperatura', 193.0000, 'ºC'),
	(25564, 111, '2015-01-15 00:55:22.000000', 'temperatura', 364.0000, 'ºC'),
	(25565, 111, '2015-01-15 00:55:23.000000', 'temperatura', 40.0000, 'ºC'),
	(25566, 111, '2015-01-15 00:55:24.000000', 'temperatura', 312.0000, 'ºC'),
	(25567, 111, '2015-01-15 00:55:25.000000', 'temperatura', 241.0000, 'ºC'),
	(25568, 111, '2015-01-15 00:55:26.000000', 'temperatura', 268.0000, 'ºC'),
	(25569, 111, '2015-01-15 00:55:27.000000', 'temperatura', 617.0000, 'ºC'),
	(25570, 111, '2015-01-15 00:55:28.000000', 'temperatura', 1081.0000, 'ºC'),
	(25571, 111, '2015-01-15 00:55:29.000000', 'temperatura', 1155.0000, 'ºC'),
	(25572, 111, '2015-01-15 00:55:30.000000', 'temperatura', 134.0000, 'ºC'),
	(25573, 111, '2015-01-15 00:55:31.000000', 'temperatura', 803.0000, 'ºC'),
	(25574, 111, '2015-01-15 00:55:32.000000', 'temperatura', 16.0000, 'ºC'),
	(25575, 111, '2015-01-15 00:55:33.000000', 'temperatura', 70.0000, 'ºC'),
	(25576, 111, '2015-01-15 00:55:34.000000', 'temperatura', 302.0000, 'ºC'),
	(25577, 111, '2015-01-15 00:55:35.000000', 'temperatura', 101.0000, 'ºC'),
	(25578, 111, '2015-01-15 00:55:36.000000', 'temperatura', 799.0000, 'ºC'),
	(25579, 111, '2015-01-15 00:55:37.000000', 'temperatura', 93.0000, 'ºC'),
	(25580, 111, '2015-01-15 00:55:38.000000', 'temperatura', 470.0000, 'ºC'),
	(25581, 111, '2015-01-15 00:55:39.000000', 'temperatura', 870.0000, 'ºC'),
	(25582, 111, '2015-01-15 00:55:40.000000', 'temperatura', 541.0000, 'ºC'),
	(25583, 111, '2015-01-15 00:55:41.000000', 'temperatura', 96.0000, 'ºC'),
	(25584, 111, '2015-01-15 00:55:42.000000', 'temperatura', 56.0000, 'ºC'),
	(25585, 111, '2015-01-15 00:55:43.000000', 'temperatura', 1194.0000, 'ºC'),
	(25586, 111, '2015-01-15 00:55:44.000000', 'temperatura', 1001.0000, 'ºC'),
	(25587, 111, '2015-01-15 00:55:45.000000', 'temperatura', 226.0000, 'ºC'),
	(25588, 111, '2015-01-15 00:55:46.000000', 'temperatura', 527.0000, 'ºC'),
	(25589, 111, '2015-01-15 00:55:47.000000', 'temperatura', 756.0000, 'ºC'),
	(25590, 111, '2015-01-15 00:55:48.000000', 'temperatura', 1002.0000, 'ºC'),
	(25591, 111, '2015-01-15 00:55:49.000000', 'temperatura', 341.0000, 'ºC'),
	(25592, 111, '2015-01-15 00:55:50.000000', 'temperatura', 1099.0000, 'ºC'),
	(25593, 111, '2015-01-15 00:55:51.000000', 'temperatura', 874.0000, 'ºC'),
	(25594, 111, '2015-01-15 00:55:52.000000', 'temperatura', 1071.0000, 'ºC'),
	(25595, 111, '2015-01-15 00:55:53.000000', 'temperatura', 333.0000, 'ºC'),
	(25596, 111, '2015-01-15 00:55:54.000000', 'temperatura', 855.0000, 'ºC'),
	(25597, 111, '2015-01-15 00:55:55.000000', 'temperatura', 877.0000, 'ºC'),
	(25598, 111, '2015-01-15 00:55:56.000000', 'temperatura', 620.0000, 'ºC'),
	(25599, 111, '2015-01-15 00:55:57.000000', 'temperatura', 467.0000, 'ºC'),
	(25600, 111, '2015-01-15 00:55:58.000000', 'temperatura', 478.0000, 'ºC'),
	(25601, 111, '2015-01-15 00:55:59.000000', 'temperatura', 987.0000, 'ºC'),
	(25602, 111, '2015-01-15 00:56:00.000000', 'temperatura', 1104.0000, 'ºC'),
	(25603, 111, '2015-01-15 00:56:01.000000', 'temperatura', 159.0000, 'ºC'),
	(25604, 111, '2015-01-15 00:56:02.000000', 'temperatura', 1084.0000, 'ºC'),
	(25605, 111, '2015-01-15 00:56:03.000000', 'temperatura', 141.0000, 'ºC'),
	(25606, 111, '2015-01-15 00:56:04.000000', 'temperatura', 1054.0000, 'ºC'),
	(25607, 111, '2015-01-15 00:56:05.000000', 'temperatura', 49.0000, 'ºC'),
	(25608, 111, '2015-01-15 00:56:06.000000', 'temperatura', 682.0000, 'ºC'),
	(25609, 111, '2015-01-15 00:56:07.000000', 'temperatura', 863.0000, 'ºC'),
	(25610, 111, '2015-01-15 00:56:08.000000', 'temperatura', 1070.0000, 'ºC'),
	(25611, 111, '2015-01-15 00:56:09.000000', 'temperatura', 362.0000, 'ºC'),
	(25612, 111, '2015-01-15 00:56:10.000000', 'temperatura', 1001.0000, 'ºC'),
	(25613, 111, '2015-01-15 00:56:11.000000', 'temperatura', 317.0000, 'ºC'),
	(25614, 111, '2015-01-15 00:56:12.000000', 'temperatura', 985.0000, 'ºC'),
	(25615, 111, '2015-01-15 00:56:13.000000', 'temperatura', 374.0000, 'ºC'),
	(25616, 111, '2015-01-15 00:56:14.000000', 'temperatura', 114.0000, 'ºC'),
	(25617, 111, '2015-01-15 00:56:15.000000', 'temperatura', 649.0000, 'ºC'),
	(25618, 111, '2015-01-15 00:56:16.000000', 'temperatura', 506.0000, 'ºC'),
	(25619, 111, '2015-01-15 00:56:17.000000', 'temperatura', 580.0000, 'ºC'),
	(25620, 111, '2015-01-15 00:56:18.000000', 'temperatura', 185.0000, 'ºC'),
	(25621, 111, '2015-01-15 00:56:19.000000', 'temperatura', 386.0000, 'ºC'),
	(25622, 111, '2015-01-15 00:56:20.000000', 'temperatura', 177.0000, 'ºC'),
	(25623, 111, '2015-01-15 00:56:21.000000', 'temperatura', 924.0000, 'ºC'),
	(25624, 111, '2015-01-15 00:56:22.000000', 'temperatura', 492.0000, 'ºC'),
	(25625, 111, '2015-01-15 00:56:23.000000', 'temperatura', 888.0000, 'ºC'),
	(25626, 111, '2015-01-15 00:56:24.000000', 'temperatura', 563.0000, 'ºC'),
	(25627, 111, '2015-01-15 00:56:25.000000', 'temperatura', 154.0000, 'ºC'),
	(25628, 111, '2015-01-15 00:56:26.000000', 'temperatura', 281.0000, 'ºC'),
	(25629, 111, '2015-01-15 00:56:27.000000', 'temperatura', 944.0000, 'ºC'),
	(25630, 111, '2015-01-15 00:56:28.000000', 'temperatura', 278.0000, 'ºC'),
	(25631, 111, '2015-01-15 00:56:29.000000', 'temperatura', 958.0000, 'ºC'),
	(25632, 111, '2015-01-15 00:56:30.000000', 'temperatura', 355.0000, 'ºC'),
	(25633, 111, '2015-01-15 00:56:31.000000', 'temperatura', 102.0000, 'ºC'),
	(25634, 111, '2015-01-15 00:56:32.000000', 'temperatura', 647.0000, 'ºC'),
	(25635, 111, '2015-01-15 00:56:33.000000', 'temperatura', 529.0000, 'ºC'),
	(25636, 111, '2015-01-15 00:56:34.000000', 'temperatura', 705.0000, 'ºC'),
	(25637, 111, '2015-01-15 00:56:35.000000', 'temperatura', 738.0000, 'ºC'),
	(25638, 111, '2015-01-15 00:56:36.000000', 'temperatura', 376.0000, 'ºC'),
	(25639, 111, '2015-01-15 00:56:37.000000', 'temperatura', 867.0000, 'ºC'),
	(25640, 111, '2015-01-15 00:56:38.000000', 'temperatura', 809.0000, 'ºC'),
	(25641, 111, '2015-01-15 00:56:39.000000', 'temperatura', 242.0000, 'ºC'),
	(25642, 111, '2015-01-15 00:56:40.000000', 'temperatura', 1184.0000, 'ºC'),
	(25643, 111, '2015-01-15 00:56:41.000000', 'temperatura', 395.0000, 'ºC'),
	(25644, 111, '2015-01-15 00:56:42.000000', 'temperatura', 824.0000, 'ºC'),
	(25645, 111, '2015-01-15 00:56:43.000000', 'temperatura', 536.0000, 'ºC'),
	(25646, 111, '2015-01-15 00:56:44.000000', 'temperatura', 208.0000, 'ºC'),
	(25647, 111, '2015-01-15 00:56:45.000000', 'temperatura', 634.0000, 'ºC'),
	(25648, 111, '2015-01-15 00:56:46.000000', 'temperatura', 143.0000, 'ºC'),
	(25649, 111, '2015-01-15 00:56:47.000000', 'temperatura', 17.0000, 'ºC'),
	(25650, 111, '2015-01-15 00:56:48.000000', 'temperatura', 856.0000, 'ºC'),
	(25651, 111, '2015-01-15 00:56:49.000000', 'temperatura', 628.0000, 'ºC'),
	(25652, 111, '2015-01-15 00:56:50.000000', 'temperatura', 571.0000, 'ºC'),
	(25653, 111, '2015-01-15 00:56:51.000000', 'temperatura', 974.0000, 'ºC'),
	(25654, 111, '2015-01-15 00:56:52.000000', 'temperatura', 758.0000, 'ºC'),
	(25655, 111, '2015-01-15 00:56:53.000000', 'temperatura', 869.0000, 'ºC'),
	(25656, 111, '2015-01-15 00:56:54.000000', 'temperatura', 869.0000, 'ºC'),
	(25657, 111, '2015-01-15 00:56:55.000000', 'temperatura', 541.0000, 'ºC'),
	(25658, 111, '2015-01-15 00:56:56.000000', 'temperatura', 98.0000, 'ºC'),
	(25659, 111, '2015-01-15 00:56:57.000000', 'temperatura', 66.0000, 'ºC'),
	(25660, 111, '2015-01-15 00:56:58.000000', 'temperatura', 39.0000, 'ºC'),
	(25661, 111, '2015-01-15 00:56:59.000000', 'temperatura', 1196.0000, 'ºC'),
	(25662, 111, '2015-01-15 00:57:00.000000', 'temperatura', 1066.0000, 'ºC'),
	(25663, 111, '2015-01-15 00:57:01.000000', 'temperatura', 540.0000, 'ºC'),
	(25664, 111, '2015-01-15 00:57:02.000000', 'temperatura', 703.0000, 'ºC'),
	(25665, 111, '2015-01-15 00:57:03.000000', 'temperatura', 697.0000, 'ºC'),
	(25666, 111, '2015-01-15 00:57:04.000000', 'temperatura', 174.0000, 'ºC'),
	(25667, 111, '2015-01-15 00:57:05.000000', 'temperatura', 1179.0000, 'ºC'),
	(25668, 111, '2015-01-15 00:57:06.000000', 'temperatura', 574.0000, 'ºC'),
	(25669, 111, '2015-01-15 00:57:07.000000', 'temperatura', 532.0000, 'ºC'),
	(25670, 111, '2015-01-15 00:57:08.000000', 'temperatura', 941.0000, 'ºC'),
	(25671, 111, '2015-01-15 00:57:09.000000', 'temperatura', 709.0000, 'ºC'),
	(25672, 111, '2015-01-15 00:57:10.000000', 'temperatura', 722.0000, 'ºC'),
	(25673, 111, '2015-01-15 00:57:11.000000', 'temperatura', 282.0000, 'ºC'),
	(25674, 111, '2015-01-15 00:57:12.000000', 'temperatura', 446.0000, 'ºC'),
	(25675, 111, '2015-01-15 00:57:13.000000', 'temperatura', 185.0000, 'ºC'),
	(25676, 111, '2015-01-15 00:57:14.000000', 'temperatura', 787.0000, 'ºC'),
	(25677, 111, '2015-01-15 00:57:15.000000', 'temperatura', 981.0000, 'ºC'),
	(25678, 111, '2015-01-15 00:57:16.000000', 'temperatura', 143.0000, 'ºC'),
	(25679, 111, '2015-01-15 00:57:17.000000', 'temperatura', 171.0000, 'ºC'),
	(25680, 111, '2015-01-15 00:57:18.000000', 'temperatura', 430.0000, 'ºC'),
	(25681, 111, '2015-01-15 00:57:19.000000', 'temperatura', 436.0000, 'ºC'),
	(25682, 111, '2015-01-15 00:57:20.000000', 'temperatura', 889.0000, 'ºC'),
	(25683, 111, '2015-01-15 00:57:21.000000', 'temperatura', 737.0000, 'ºC'),
	(25684, 111, '2015-01-15 00:57:22.000000', 'temperatura', 1022.0000, 'ºC'),
	(25685, 111, '2015-01-15 00:57:23.000000', 'temperatura', 496.0000, 'ºC'),
	(25686, 111, '2015-01-15 00:57:24.000000', 'temperatura', 617.0000, 'ºC'),
	(25687, 111, '2015-01-15 00:57:25.000000', 'temperatura', 397.0000, 'ºC'),
	(25688, 111, '2015-01-15 00:57:26.000000', 'temperatura', 132.0000, 'ºC'),
	(25689, 111, '2015-01-15 00:57:27.000000', 'temperatura', 672.0000, 'ºC'),
	(25690, 111, '2015-01-15 00:57:28.000000', 'temperatura', 563.0000, 'ºC'),
	(25691, 111, '2015-01-15 00:57:29.000000', 'temperatura', 800.0000, 'ºC'),
	(25692, 111, '2015-01-15 00:57:30.000000', 'temperatura', 1110.0000, 'ºC'),
	(25693, 111, '2015-01-15 00:57:31.000000', 'temperatura', 751.0000, 'ºC'),
	(25694, 111, '2015-01-15 00:57:32.000000', 'temperatura', 427.0000, 'ºC'),
	(25695, 111, '2015-01-15 00:57:33.000000', 'temperatura', 1081.0000, 'ºC'),
	(25696, 111, '2015-01-15 00:57:34.000000', 'temperatura', 527.0000, 'ºC'),
	(25697, 111, '2015-01-15 00:57:35.000000', 'temperatura', 589.0000, 'ºC'),
	(25698, 111, '2015-01-15 00:57:36.000000', 'temperatura', 168.0000, 'ºC'),
	(25699, 111, '2015-01-15 00:57:37.000000', 'temperatura', 271.0000, 'ºC'),
	(25700, 111, '2015-01-15 00:57:38.000000', 'temperatura', 854.0000, 'ºC'),
	(25701, 111, '2015-01-15 00:57:39.000000', 'temperatura', 1056.0000, 'ºC'),
	(25702, 111, '2015-01-15 00:57:40.000000', 'temperatura', 321.0000, 'ºC'),
	(25703, 111, '2015-01-15 00:57:41.000000', 'temperatura', 835.0000, 'ºC'),
	(25704, 111, '2015-01-15 00:57:42.000000', 'temperatura', 814.0000, 'ºC'),
	(25705, 111, '2015-01-15 00:57:43.000000', 'temperatura', 365.0000, 'ºC'),
	(25706, 111, '2015-01-15 00:57:44.000000', 'temperatura', 584.0000, 'ºC'),
	(25707, 111, '2015-01-15 00:57:45.000000', 'temperatura', 626.0000, 'ºC'),
	(25708, 111, '2015-01-15 00:57:46.000000', 'temperatura', 176.0000, 'ºC'),
	(25709, 111, '2015-01-15 00:57:47.000000', 'temperatura', 204.0000, 'ºC'),
	(25710, 111, '2015-01-15 00:57:48.000000', 'temperatura', 494.0000, 'ºC'),
	(25711, 111, '2015-01-15 00:57:49.000000', 'temperatura', 659.0000, 'ºC'),
	(25712, 111, '2015-01-15 00:57:50.000000', 'temperatura', 613.0000, 'ºC'),
	(25713, 111, '2015-01-15 00:57:51.000000', 'temperatura', 1089.0000, 'ºC'),
	(25714, 111, '2015-01-15 00:57:52.000000', 'temperatura', 6.0000, 'ºC'),
	(25715, 111, '2015-01-15 00:57:53.000000', 'temperatura', 362.0000, 'ºC'),
	(25716, 111, '2015-01-15 00:57:54.000000', 'temperatura', 595.0000, 'ºC'),
	(25717, 111, '2015-01-15 00:57:55.000000', 'temperatura', 690.0000, 'ºC'),
	(25718, 111, '2015-01-15 00:57:56.000000', 'temperatura', 463.0000, 'ºC'),
	(25719, 111, '2015-01-15 00:57:57.000000', 'temperatura', 248.0000, 'ºC'),
	(25720, 111, '2015-01-15 00:57:58.000000', 'temperatura', 1053.0000, 'ºC'),
	(25721, 111, '2015-01-15 00:57:59.000000', 'temperatura', 918.0000, 'ºC'),
	(25722, 111, '2015-01-15 00:58:00.000000', 'temperatura', 231.0000, 'ºC'),
	(25723, 111, '2015-01-15 00:58:01.000000', 'temperatura', 804.0000, 'ºC'),
	(25724, 111, '2015-01-15 00:58:02.000000', 'temperatura', 925.0000, 'ºC'),
	(25725, 111, '2015-01-15 00:58:03.000000', 'temperatura', 1013.0000, 'ºC'),
	(25726, 111, '2015-01-15 00:58:04.000000', 'temperatura', 1093.0000, 'ºC'),
	(25727, 111, '2015-01-15 00:58:05.000000', 'temperatura', 24.0000, 'ºC'),
	(25728, 111, '2015-01-15 00:58:06.000000', 'temperatura', 442.0000, 'ºC'),
	(25729, 111, '2015-01-15 00:58:07.000000', 'temperatura', 938.0000, 'ºC'),
	(25730, 111, '2015-01-15 00:58:08.000000', 'temperatura', 965.0000, 'ºC'),
	(25731, 111, '2015-01-15 00:58:09.000000', 'temperatura', 811.0000, 'ºC'),
	(25732, 111, '2015-01-15 00:58:10.000000', 'temperatura', 1159.0000, 'ºC'),
	(25733, 111, '2015-01-15 00:58:11.000000', 'temperatura', 963.0000, 'ºC'),
	(25734, 111, '2015-01-15 00:58:12.000000', 'temperatura', 140.0000, 'ºC'),
	(25735, 111, '2015-01-15 00:58:13.000000', 'temperatura', 212.0000, 'ºC'),
	(25736, 111, '2015-01-15 00:58:14.000000', 'temperatura', 639.0000, 'ºC'),
	(25737, 111, '2015-01-15 00:58:15.000000', 'temperatura', 161.0000, 'ºC'),
	(25738, 111, '2015-01-15 00:58:16.000000', 'temperatura', 87.0000, 'ºC'),
	(25739, 111, '2015-01-15 00:58:17.000000', 'temperatura', 1153.0000, 'ºC'),
	(25740, 111, '2015-01-15 00:58:18.000000', 'temperatura', 703.0000, 'ºC'),
	(25741, 111, '2015-01-15 00:58:19.000000', 'temperatura', 57.0000, 'ºC'),
	(25742, 111, '2015-01-15 00:58:20.000000', 'temperatura', 575.0000, 'ºC'),
	(25743, 111, '2015-01-15 00:58:21.000000', 'temperatura', 305.0000, 'ºC'),
	(25744, 111, '2015-01-15 00:58:22.000000', 'temperatura', 1002.0000, 'ºC'),
	(25745, 111, '2015-01-15 00:58:23.000000', 'temperatura', 495.0000, 'ºC'),
	(25746, 111, '2015-01-15 00:58:24.000000', 'temperatura', 668.0000, 'ºC'),
	(25747, 111, '2015-01-15 00:58:25.000000', 'temperatura', 658.0000, 'ºC'),
	(25748, 111, '2015-01-15 00:58:26.000000', 'temperatura', 85.0000, 'ºC'),
	(25749, 111, '2015-01-15 00:58:27.000000', 'temperatura', 851.0000, 'ºC'),
	(25750, 111, '2015-01-15 00:58:28.000000', 'temperatura', 403.0000, 'ºC'),
	(25751, 111, '2015-01-15 00:58:29.000000', 'temperatura', 662.0000, 'ºC'),
	(25752, 111, '2015-01-15 00:58:30.000000', 'temperatura', 900.0000, 'ºC'),
	(25753, 111, '2015-01-15 00:58:31.000000', 'temperatura', 114.0000, 'ºC'),
	(25754, 111, '2015-01-15 00:58:32.000000', 'temperatura', 273.0000, 'ºC'),
	(25755, 111, '2015-01-15 00:58:33.000000', 'temperatura', 1022.0000, 'ºC'),
	(25756, 111, '2015-01-15 00:58:34.000000', 'temperatura', 692.0000, 'ºC'),
	(25757, 111, '2015-01-15 00:58:35.000000', 'temperatura', 393.0000, 'ºC'),
	(25758, 111, '2015-01-15 00:58:36.000000', 'temperatura', 1089.0000, 'ºC'),
	(25759, 111, '2015-01-15 00:58:37.000000', 'temperatura', 668.0000, 'ºC'),
	(25760, 111, '2015-01-15 00:58:38.000000', 'temperatura', 74.0000, 'ºC'),
	(25761, 111, '2015-01-15 00:58:39.000000', 'temperatura', 764.0000, 'ºC'),
	(25762, 111, '2015-01-15 00:58:40.000000', 'temperatura', 1.0000, 'ºC'),
	(25763, 111, '2015-01-15 00:58:41.000000', 'temperatura', 112.0000, 'ºC'),
	(25764, 111, '2015-01-15 00:58:42.000000', 'temperatura', 560.0000, 'ºC'),
	(25765, 111, '2015-01-15 00:58:43.000000', 'temperatura', 62.0000, 'ºC'),
	(25766, 111, '2015-01-15 00:58:44.000000', 'temperatura', 1031.0000, 'ºC'),
	(25767, 111, '2015-01-15 00:58:45.000000', 'temperatura', 170.0000, 'ºC'),
	(25768, 111, '2015-01-15 00:58:46.000000', 'temperatura', 157.0000, 'ºC'),
	(25769, 111, '2015-01-15 00:58:47.000000', 'temperatura', 278.0000, 'ºC'),
	(25770, 111, '2015-01-15 00:58:48.000000', 'temperatura', 917.0000, 'ºC'),
	(25771, 111, '2015-01-15 00:58:49.000000', 'temperatura', 151.0000, 'ºC'),
	(25772, 111, '2015-01-15 00:58:50.000000', 'temperatura', 404.0000, 'ºC'),
	(25773, 111, '2015-01-15 00:58:51.000000', 'temperatura', 368.0000, 'ºC'),
	(25774, 111, '2015-01-15 00:58:52.000000', 'temperatura', 627.0000, 'ºC'),
	(25775, 111, '2015-01-15 00:58:53.000000', 'temperatura', 833.0000, 'ºC'),
	(25776, 111, '2015-01-15 00:58:54.000000', 'temperatura', 1086.0000, 'ºC'),
	(25777, 111, '2015-01-15 00:58:55.000000', 'temperatura', 530.0000, 'ºC'),
	(25778, 111, '2015-01-15 00:58:56.000000', 'temperatura', 594.0000, 'ºC'),
	(25779, 111, '2015-01-15 00:58:57.000000', 'temperatura', 179.0000, 'ºC'),
	(25780, 111, '2015-01-15 00:58:58.000000', 'temperatura', 312.0000, 'ºC'),
	(25781, 111, '2015-01-15 00:58:59.000000', 'temperatura', 1027.0000, 'ºC'),
	(25782, 111, '2015-01-15 00:59:00.000000', 'temperatura', 596.0000, 'ºC'),
	(25783, 111, '2015-01-15 00:59:01.000000', 'temperatura', 1101.0000, 'ºC'),
	(25784, 111, '2015-01-15 00:59:02.000000', 'temperatura', 118.0000, 'ºC'),
	(25785, 111, '2015-01-15 00:59:03.000000', 'temperatura', 887.0000, 'ºC'),
	(25786, 111, '2015-01-15 00:59:04.000000', 'temperatura', 480.0000, 'ºC'),
	(25787, 111, '2015-01-15 00:59:05.000000', 'temperatura', 940.0000, 'ºC'),
	(25788, 111, '2015-01-15 00:59:06.000000', 'temperatura', 860.0000, 'ºC'),
	(25789, 111, '2015-01-15 00:59:07.000000', 'temperatura', 282.0000, 'ºC'),
	(25790, 111, '2015-01-15 00:59:08.000000', 'temperatura', 29.0000, 'ºC'),
	(25791, 111, '2015-01-15 00:59:09.000000', 'temperatura', 499.0000, 'ºC'),
	(25792, 111, '2015-01-15 00:59:10.000000', 'temperatura', 11.0000, 'ºC'),
	(25793, 111, '2015-01-15 00:59:11.000000', 'temperatura', 956.0000, 'ºC'),
	(25794, 111, '2015-01-15 00:59:12.000000', 'temperatura', 1150.0000, 'ºC'),
	(25795, 111, '2015-01-15 00:59:13.000000', 'temperatura', 481.0000, 'ºC'),
	(25796, 111, '2015-01-15 00:59:14.000000', 'temperatura', 155.0000, 'ºC'),
	(25797, 111, '2015-01-15 00:59:15.000000', 'temperatura', 535.0000, 'ºC'),
	(25798, 111, '2015-01-15 00:59:16.000000', 'temperatura', 1007.0000, 'ºC'),
	(25799, 111, '2015-01-15 00:59:17.000000', 'temperatura', 1034.0000, 'ºC'),
	(25800, 111, '2015-01-15 00:59:18.000000', 'temperatura', 949.0000, 'ºC'),
	(25801, 111, '2015-01-15 00:59:19.000000', 'temperatura', 441.0000, 'ºC'),
	(25802, 111, '2015-01-15 00:59:20.000000', 'temperatura', 561.0000, 'ºC'),
	(25803, 111, '2015-01-15 00:59:21.000000', 'temperatura', 282.0000, 'ºC'),
	(25804, 111, '2015-01-15 00:59:22.000000', 'temperatura', 928.0000, 'ºC'),
	(25805, 111, '2015-01-15 00:59:23.000000', 'temperatura', 195.0000, 'ºC'),
	(25806, 111, '2015-01-15 00:59:24.000000', 'temperatura', 590.0000, 'ºC'),
	(25807, 111, '2015-01-15 00:59:25.000000', 'temperatura', 1166.0000, 'ºC'),
	(25808, 111, '2015-01-15 00:59:26.000000', 'temperatura', 461.0000, 'ºC'),
	(25809, 111, '2015-01-15 00:59:27.000000', 'temperatura', 5.0000, 'ºC'),
	(25810, 111, '2015-01-15 00:59:28.000000', 'temperatura', 1044.0000, 'ºC'),
	(25811, 111, '2015-01-15 00:59:29.000000', 'temperatura', 407.0000, 'ºC'),
	(25812, 111, '2015-01-15 00:59:30.000000', 'temperatura', 103.0000, 'ºC'),
	(25813, 111, '2015-01-15 00:59:31.000000', 'temperatura', 492.0000, 'ºC'),
	(25814, 111, '2015-01-15 00:59:32.000000', 'temperatura', 953.0000, 'ºC'),
	(25815, 111, '2015-01-15 00:59:33.000000', 'temperatura', 891.0000, 'ºC'),
	(25816, 111, '2015-01-15 00:59:34.000000', 'temperatura', 396.0000, 'ºC'),
	(25817, 111, '2015-01-15 00:59:35.000000', 'temperatura', 506.0000, 'ºC'),
	(25818, 111, '2015-01-15 00:59:36.000000', 'temperatura', 143.0000, 'ºC'),
	(25819, 111, '2015-01-15 00:59:37.000000', 'temperatura', 399.0000, 'ºC'),
	(25820, 111, '2015-01-15 00:59:38.000000', 'temperatura', 364.0000, 'ºC'),
	(25821, 111, '2015-01-15 00:59:39.000000', 'temperatura', 624.0000, 'ºC'),
	(25822, 111, '2015-01-15 00:59:40.000000', 'temperatura', 829.0000, 'ºC'),
	(25823, 111, '2015-01-15 00:59:41.000000', 'temperatura', 1072.0000, 'ºC'),
	(25824, 111, '2015-01-15 00:59:42.000000', 'temperatura', 476.0000, 'ºC'),
	(25825, 111, '2015-01-15 00:59:43.000000', 'temperatura', 364.0000, 'ºC'),
	(25826, 111, '2015-01-15 00:59:44.000000', 'temperatura', 394.0000, 'ºC'),
	(25827, 111, '2015-01-15 00:59:45.000000', 'temperatura', 877.0000, 'ºC'),
	(25828, 111, '2015-01-15 00:59:46.000000', 'temperatura', 805.0000, 'ºC'),
	(25829, 111, '2015-01-15 00:59:47.000000', 'temperatura', 196.0000, 'ºC'),
	(25830, 111, '2015-01-15 00:59:48.000000', 'temperatura', 962.0000, 'ºC'),
	(25831, 111, '2015-01-15 00:59:49.000000', 'temperatura', 623.0000, 'ºC'),
	(25832, 111, '2015-01-15 00:59:50.000000', 'temperatura', 228.0000, 'ºC'),
	(25833, 111, '2015-01-15 00:59:51.000000', 'temperatura', 474.0000, 'ºC'),
	(25834, 111, '2015-01-15 00:59:52.000000', 'temperatura', 485.0000, 'ºC'),
	(25835, 111, '2015-01-15 00:59:53.000000', 'temperatura', 1006.0000, 'ºC'),
	(25836, 111, '2015-01-15 00:59:54.000000', 'temperatura', 1175.0000, 'ºC'),
	(25837, 111, '2015-01-15 00:59:55.000000', 'temperatura', 456.0000, 'ºC'),
	(25838, 111, '2015-01-15 00:59:56.000000', 'temperatura', 1156.0000, 'ºC'),
	(25839, 111, '2015-01-15 00:59:57.000000', 'temperatura', 813.0000, 'ºC'),
	(25840, 111, '2015-01-15 00:59:58.000000', 'temperatura', 597.0000, 'ºC'),
	(25841, 111, '2015-01-15 00:59:59.000000', 'temperatura', 548.0000, 'ºC'),
	(25842, 111, '2015-01-15 01:00:00.000000', 'temperatura', 949.0000, 'ºC'),
	(25843, 111, '2015-01-15 01:00:01.000000', 'temperatura', 703.0000, 'ºC'),
	(25844, 111, '2015-01-15 01:00:02.000000', 'temperatura', 668.0000, 'ºC'),
	(25845, 111, '2015-01-15 01:00:03.000000', 'temperatura', 32.0000, 'ºC'),
	(25846, 111, '2015-01-15 01:00:04.000000', 'temperatura', 556.0000, 'ºC'),
	(25847, 111, '2015-01-15 01:00:05.000000', 'temperatura', 283.0000, 'ºC'),
	(25848, 111, '2015-01-15 01:00:06.000000', 'temperatura', 949.0000, 'ºC'),
	(25849, 111, '2015-01-15 01:00:07.000000', 'temperatura', 296.0000, 'ºC'),
	(25850, 111, '2015-01-15 01:00:08.000000', 'temperatura', 1036.0000, 'ºC'),
	(25851, 111, '2015-01-15 01:00:09.000000', 'temperatura', 689.0000, 'ºC'),
	(25852, 111, '2015-01-15 01:00:10.000000', 'temperatura', 341.0000, 'ºC'),
	(25853, 111, '2015-01-15 01:00:11.000000', 'temperatura', 836.0000, 'ºC'),
	(25854, 111, '2015-01-15 01:00:12.000000', 'temperatura', 758.0000, 'ºC'),
	(25855, 111, '2015-01-15 01:00:13.000000', 'temperatura', 84.0000, 'ºC'),
	(25856, 111, '2015-01-15 01:00:14.000000', 'temperatura', 547.0000, 'ºC'),
	(25857, 111, '2015-01-15 01:00:15.000000', 'temperatura', 82.0000, 'ºC'),
	(25858, 111, '2015-01-15 01:00:16.000000', 'temperatura', 1169.0000, 'ºC'),
	(25859, 111, '2015-01-15 01:00:17.000000', 'temperatura', 799.0000, 'ºC'),
	(25860, 111, '2015-01-15 01:00:18.000000', 'temperatura', 490.0000, 'ºC'),
	(25861, 111, '2015-01-15 01:00:19.000000', 'temperatura', 53.0000, 'ºC'),
	(25862, 111, '2015-01-15 01:00:20.000000', 'temperatura', 1194.0000, 'ºC'),
	(25863, 111, '2015-01-15 01:00:21.000000', 'temperatura', 1014.0000, 'ºC'),
	(25864, 111, '2015-01-15 01:00:22.000000', 'temperatura', 288.0000, 'ºC'),
	(25865, 111, '2015-01-15 01:00:23.000000', 'temperatura', 800.0000, 'ºC'),
	(25866, 111, '2015-01-15 01:00:24.000000', 'temperatura', 736.0000, 'ºC'),
	(25867, 111, '2015-01-15 01:00:25.000000', 'temperatura', 81.0000, 'ºC'),
	(25868, 111, '2015-01-15 01:00:26.000000', 'temperatura', 598.0000, 'ºC'),
	(25869, 111, '2015-01-15 01:00:27.000000', 'temperatura', 348.0000, 'ºC'),
	(25870, 111, '2015-01-15 01:00:28.000000', 'temperatura', 1146.0000, 'ºC'),
	(25871, 111, '2015-01-15 01:00:29.000000', 'temperatura', 1085.0000, 'ºC'),
	(25872, 111, '2015-01-15 01:00:30.000000', 'temperatura', 790.0000, 'ºC'),
	(25873, 111, '2015-01-15 01:00:31.000000', 'temperatura', 695.0000, 'ºC'),
	(25874, 111, '2015-01-15 01:00:32.000000', 'temperatura', 1104.0000, 'ºC'),
	(25875, 111, '2015-01-15 01:00:33.000000', 'temperatura', 1037.0000, 'ºC'),
	(25876, 111, '2015-01-15 01:00:34.000000', 'temperatura', 673.0000, 'ºC'),
	(25877, 111, '2015-01-15 01:00:35.000000', 'temperatura', 256.0000, 'ºC'),
	(25878, 111, '2015-01-15 01:00:36.000000', 'temperatura', 459.0000, 'ºC'),
	(25879, 111, '2015-01-15 01:00:37.000000', 'temperatura', 326.0000, 'ºC'),
	(25880, 111, '2015-01-15 01:00:38.000000', 'temperatura', 257.0000, 'ºC'),
	(25881, 111, '2015-01-15 01:00:39.000000', 'temperatura', 305.0000, 'ºC'),
	(25882, 111, '2015-01-15 01:00:40.000000', 'temperatura', 757.0000, 'ºC'),
	(25883, 111, '2015-01-15 01:00:41.000000', 'temperatura', 471.0000, 'ºC'),
	(25884, 111, '2015-01-15 01:00:42.000000', 'temperatura', 83.0000, 'ºC'),
	(25885, 111, '2015-01-15 01:00:43.000000', 'temperatura', 202.0000, 'ºC'),
	(25886, 111, '2015-01-15 01:00:44.000000', 'temperatura', 760.0000, 'ºC'),
	(25887, 111, '2015-01-15 01:00:45.000000', 'temperatura', 797.0000, 'ºC'),
	(25888, 111, '2015-01-15 01:00:46.000000', 'temperatura', 504.0000, 'ºC'),
	(25889, 111, '2015-01-15 01:00:47.000000', 'temperatura', 131.0000, 'ºC'),
	(25890, 111, '2015-01-15 01:00:48.000000', 'temperatura', 343.0000, 'ºC'),
	(25891, 111, '2015-01-15 01:00:49.000000', 'temperatura', 123.0000, 'ºC'),
	(25892, 111, '2015-01-15 01:00:50.000000', 'temperatura', 787.0000, 'ºC'),
	(25893, 111, '2015-01-15 01:00:51.000000', 'temperatura', 1165.0000, 'ºC'),
	(25894, 111, '2015-01-15 01:00:52.000000', 'temperatura', 1066.0000, 'ºC'),
	(25895, 111, '2015-01-15 01:00:53.000000', 'temperatura', 635.0000, 'ºC'),
	(25896, 111, '2015-01-15 01:00:54.000000', 'temperatura', 1176.0000, 'ºC'),
	(25897, 111, '2015-01-15 01:00:55.000000', 'temperatura', 377.0000, 'ºC'),
	(25898, 111, '2015-01-15 01:00:56.000000', 'temperatura', 756.0000, 'ºC'),
	(25899, 111, '2015-01-15 01:00:57.000000', 'temperatura', 250.0000, 'ºC'),
	(25900, 111, '2015-01-15 01:00:58.000000', 'temperatura', 181.0000, 'ºC'),
	(25901, 111, '2015-01-15 01:00:59.000000', 'temperatura', 158.0000, 'ºC'),
	(25902, 111, '2015-01-15 01:01:00.000000', 'temperatura', 246.0000, 'ºC'),
	(25903, 111, '2015-01-15 01:01:01.000000', 'temperatura', 759.0000, 'ºC'),
	(25904, 111, '2015-01-15 01:01:02.000000', 'temperatura', 654.0000, 'ºC'),
	(25905, 111, '2015-01-15 01:01:03.000000', 'temperatura', 996.0000, 'ºC'),
	(25906, 111, '2015-01-15 01:01:04.000000', 'temperatura', 618.0000, 'ºC'),
	(25907, 111, '2015-01-15 01:01:05.000000', 'temperatura', 103.0000, 'ºC'),
	(25908, 111, '2015-01-15 01:01:06.000000', 'temperatura', 1063.0000, 'ºC'),
	(25909, 111, '2015-01-15 01:01:07.000000', 'temperatura', 205.0000, 'ºC'),
	(25910, 111, '2015-01-15 01:01:08.000000', 'temperatura', 237.0000, 'ºC'),
	(25911, 111, '2015-01-15 01:01:09.000000', 'temperatura', 572.0000, 'ºC'),
	(25912, 111, '2015-01-15 01:01:10.000000', 'temperatura', 950.0000, 'ºC'),
	(25913, 111, '2015-01-15 01:01:11.000000', 'temperatura', 632.0000, 'ºC'),
	(25914, 111, '2015-01-15 01:01:12.000000', 'temperatura', 310.0000, 'ºC'),
	(25915, 111, '2015-01-15 01:01:13.000000', 'temperatura', 855.0000, 'ºC'),
	(25916, 111, '2015-01-15 01:01:14.000000', 'temperatura', 947.0000, 'ºC'),
	(25917, 111, '2015-01-15 01:01:15.000000', 'temperatura', 971.0000, 'ºC'),
	(25918, 111, '2015-01-15 01:01:16.000000', 'temperatura', 815.0000, 'ºC'),
	(25919, 111, '2015-01-15 01:01:17.000000', 'temperatura', 1161.0000, 'ºC'),
	(25920, 111, '2015-01-15 01:01:18.000000', 'temperatura', 959.0000, 'ºC'),
	(25921, 111, '2015-01-15 01:01:19.000000', 'temperatura', 113.0000, 'ºC'),
	(25922, 111, '2015-01-15 01:01:20.000000', 'temperatura', 88.0000, 'ºC'),
	(25923, 111, '2015-01-15 01:01:21.000000', 'temperatura', 101.0000, 'ºC'),
	(25924, 111, '2015-01-15 01:01:22.000000', 'temperatura', 243.0000, 'ºC'),
	(25925, 111, '2015-01-15 01:01:23.000000', 'temperatura', 913.0000, 'ºC'),
	(25926, 111, '2015-01-15 01:01:24.000000', 'temperatura', 235.0000, 'ºC'),
	(25927, 111, '2015-01-15 01:01:25.000000', 'temperatura', 837.0000, 'ºC'),
	(25928, 111, '2015-01-15 01:01:26.000000', 'temperatura', 1080.0000, 'ºC'),
	(25929, 111, '2015-01-15 01:01:27.000000', 'temperatura', 490.0000, 'ºC'),
	(25930, 111, '2015-01-15 01:01:28.000000', 'temperatura', 410.0000, 'ºC'),
	(25931, 111, '2015-01-15 01:01:29.000000', 'temperatura', 582.0000, 'ºC'),
	(25932, 111, '2015-01-15 01:01:30.000000', 'temperatura', 480.0000, 'ºC'),
	(25933, 111, '2015-01-15 01:01:31.000000', 'temperatura', 655.0000, 'ºC'),
	(25934, 111, '2015-01-15 01:01:32.000000', 'temperatura', 635.0000, 'ºC'),
	(25935, 111, '2015-01-15 01:01:33.000000', 'temperatura', 12.0000, 'ºC'),
	(25936, 111, '2015-01-15 01:01:34.000000', 'temperatura', 555.0000, 'ºC'),
	(25937, 111, '2015-01-15 01:01:35.000000', 'temperatura', 339.0000, 'ºC'),
	(25938, 111, '2015-01-15 01:01:36.000000', 'temperatura', 31.0000, 'ºC'),
	(25939, 111, '2015-01-15 01:01:37.000000', 'temperatura', 336.0000, 'ºC'),
	(25940, 111, '2015-01-15 01:01:38.000000', 'temperatura', 390.0000, 'ºC'),
	(25941, 111, '2015-01-15 01:01:39.000000', 'temperatura', 943.0000, 'ºC'),
	(25942, 111, '2015-01-15 01:01:40.000000', 'temperatura', 1145.0000, 'ºC'),
	(25943, 111, '2015-01-15 01:01:41.000000', 'temperatura', 495.0000, 'ºC'),
	(25944, 111, '2015-01-15 01:01:42.000000', 'temperatura', 243.0000, 'ºC'),
	(25945, 111, '2015-01-15 01:01:43.000000', 'temperatura', 929.0000, 'ºC'),
	(25946, 111, '2015-01-15 01:01:44.000000', 'temperatura', 316.0000, 'ºC'),
	(25947, 111, '2015-01-15 01:01:45.000000', 'temperatura', 1196.0000, 'ºC'),
	(25948, 111, '2015-01-15 01:01:46.000000', 'temperatura', 230.0000, 'ºC'),
	(25949, 111, '2015-01-15 01:01:47.000000', 'temperatura', 1165.0000, 'ºC'),
	(25950, 111, '2015-01-15 01:01:48.000000', 'temperatura', 333.0000, 'ºC'),
	(25951, 111, '2015-01-15 01:01:49.000000', 'temperatura', 572.0000, 'ºC'),
	(25952, 111, '2015-01-15 01:01:50.000000', 'temperatura', 663.0000, 'ºC'),
	(25953, 111, '2015-01-15 01:01:51.000000', 'temperatura', 397.0000, 'ºC'),
	(25954, 111, '2015-01-15 01:01:52.000000', 'temperatura', 1199.0000, 'ºC'),
	(25955, 111, '2015-01-15 01:01:53.000000', 'temperatura', 3.0000, 'ºC'),
	(25956, 111, '2015-01-15 01:01:54.000000', 'temperatura', 21.0000, 'ºC'),
	(25957, 111, '2015-01-15 01:01:55.000000', 'temperatura', 93.0000, 'ºC'),
	(25958, 111, '2015-01-15 01:01:56.000000', 'temperatura', 403.0000, 'ºC'),
	(25959, 111, '2015-01-15 01:01:57.000000', 'temperatura', 538.0000, 'ºC'),
	(25960, 111, '2015-01-15 01:01:58.000000', 'temperatura', 280.0000, 'ºC'),
	(25961, 111, '2015-01-15 01:01:59.000000', 'temperatura', 988.0000, 'ºC'),
	(25962, 111, '2015-01-15 01:02:00.000000', 'temperatura', 502.0000, 'ºC'),
	(25963, 111, '2015-01-15 01:02:01.000000', 'temperatura', 744.0000, 'ºC'),
	(25964, 111, '2015-01-15 01:02:02.000000', 'temperatura', 1017.0000, 'ºC'),
	(25965, 111, '2015-01-15 01:02:03.000000', 'temperatura', 454.0000, 'ºC'),
	(25966, 111, '2015-01-15 01:02:04.000000', 'temperatura', 417.0000, 'ºC'),
	(25967, 111, '2015-01-15 01:02:05.000000', 'temperatura', 723.0000, 'ºC'),
	(25968, 111, '2015-01-15 01:02:06.000000', 'temperatura', 1165.0000, 'ºC'),
	(25969, 111, '2015-01-15 01:02:07.000000', 'temperatura', 57.0000, 'ºC'),
	(25970, 111, '2015-01-15 01:02:08.000000', 'temperatura', 391.0000, 'ºC'),
	(25971, 111, '2015-01-15 01:02:09.000000', 'temperatura', 584.0000, 'ºC'),
	(25972, 111, '2015-01-15 01:02:10.000000', 'temperatura', 547.0000, 'ºC'),
	(25973, 111, '2015-01-15 01:02:11.000000', 'temperatura', 985.0000, 'ºC'),
	(25974, 111, '2015-01-15 01:02:12.000000', 'temperatura', 883.0000, 'ºC'),
	(25975, 111, '2015-01-15 01:02:13.000000', 'temperatura', 261.0000, 'ºC'),
	(25976, 111, '2015-01-15 01:02:14.000000', 'temperatura', 1058.0000, 'ºC'),
	(25977, 111, '2015-01-15 01:02:15.000000', 'temperatura', 907.0000, 'ºC'),
	(25978, 111, '2015-01-15 01:02:16.000000', 'temperatura', 163.0000, 'ºC'),
	(25979, 111, '2015-01-15 01:02:17.000000', 'temperatura', 492.0000, 'ºC'),
	(25980, 111, '2015-01-15 01:02:18.000000', 'temperatura', 773.0000, 'ºC'),
	(25981, 111, '2015-01-15 01:02:19.000000', 'temperatura', 1187.0000, 'ºC'),
	(25982, 111, '2015-01-15 01:02:20.000000', 'temperatura', 18.0000, 'ºC'),
	(25983, 111, '2015-01-15 01:02:21.000000', 'temperatura', 128.0000, 'ºC'),
	(25984, 111, '2015-01-15 01:02:22.000000', 'temperatura', 586.0000, 'ºC'),
	(25985, 111, '2015-01-15 01:02:23.000000', 'temperatura', 149.0000, 'ºC'),
	(25986, 111, '2015-01-15 01:02:24.000000', 'temperatura', 188.0000, 'ºC'),
	(25987, 111, '2015-01-15 01:02:25.000000', 'temperatura', 491.0000, 'ºC'),
	(25988, 111, '2015-01-15 01:02:26.000000', 'temperatura', 694.0000, 'ºC'),
	(25989, 111, '2015-01-15 01:02:27.000000', 'temperatura', 795.0000, 'ºC'),
	(25990, 111, '2015-01-15 01:02:28.000000', 'temperatura', 697.0000, 'ºC'),
	(25991, 111, '2015-01-15 01:02:29.000000', 'temperatura', 1097.0000, 'ºC'),
	(25992, 111, '2015-01-15 01:02:30.000000', 'temperatura', 996.0000, 'ºC'),
	(25993, 111, '2015-01-15 01:02:31.000000', 'temperatura', 491.0000, 'ºC'),
	(25994, 111, '2015-01-15 01:02:32.000000', 'temperatura', 665.0000, 'ºC'),
	(25995, 111, '2015-01-15 01:02:33.000000', 'temperatura', 652.0000, 'ºC'),
	(25996, 111, '2015-01-15 01:02:34.000000', 'temperatura', 66.0000, 'ºC'),
	(25997, 111, '2015-01-15 01:02:35.000000', 'temperatura', 775.0000, 'ºC'),
	(25998, 111, '2015-01-15 01:02:36.000000', 'temperatura', 77.0000, 'ºC'),
	(25999, 111, '2015-01-15 01:02:37.000000', 'temperatura', 460.0000, 'ºC'),
	(26000, 111, '2015-01-15 01:02:38.000000', 'temperatura', 871.0000, 'ºC'),
	(26001, 111, '2015-01-15 01:02:39.000000', 'temperatura', 575.0000, 'ºC'),
	(26002, 111, '2015-01-15 01:02:40.000000', 'temperatura', 262.0000, 'ºC'),
	(26003, 111, '2015-01-15 01:02:41.000000', 'temperatura', 785.0000, 'ºC'),
	(26004, 111, '2015-01-15 01:02:42.000000', 'temperatura', 742.0000, 'ºC'),
	(26005, 111, '2015-01-15 01:02:43.000000', 'temperatura', 153.0000, 'ºC'),
	(26006, 111, '2015-01-15 01:02:44.000000', 'temperatura', 941.0000, 'ºC'),
	(26007, 111, '2015-01-15 01:02:45.000000', 'temperatura', 645.0000, 'ºC'),
	(26008, 111, '2015-01-15 01:02:46.000000', 'temperatura', 404.0000, 'ºC'),
	(26009, 111, '2015-01-15 01:02:47.000000', 'temperatura', 86.0000, 'ºC'),
	(26010, 111, '2015-01-15 01:02:48.000000', 'temperatura', 418.0000, 'ºC'),
	(26011, 111, '2015-01-15 01:02:49.000000', 'temperatura', 632.0000, 'ºC'),
	(26012, 111, '2015-01-15 01:02:50.000000', 'temperatura', 705.0000, 'ºC'),
	(26013, 111, '2015-01-15 01:02:51.000000', 'temperatura', 432.0000, 'ºC'),
	(26014, 111, '2015-01-15 01:02:52.000000', 'temperatura', 43.0000, 'ºC'),
	(26015, 111, '2015-01-15 01:02:53.000000', 'temperatura', 120.0000, 'ºC'),
	(26016, 111, '2015-01-15 01:02:54.000000', 'temperatura', 472.0000, 'ºC'),
	(26017, 111, '2015-01-15 01:02:55.000000', 'temperatura', 801.0000, 'ºC'),
	(26018, 111, '2015-01-15 01:02:56.000000', 'temperatura', 188.0000, 'ºC'),
	(26019, 111, '2015-01-15 01:02:57.000000', 'temperatura', 939.0000, 'ºC'),
	(26020, 111, '2015-01-15 01:02:58.000000', 'temperatura', 530.0000, 'ºC'),
	(26021, 111, '2015-01-15 01:02:59.000000', 'temperatura', 1035.0000, 'ºC'),
	(26022, 111, '2015-01-15 01:03:00.000000', 'temperatura', 1187.0000, 'ºC'),
	(26023, 111, '2015-01-15 01:03:01.000000', 'temperatura', 428.0000, 'ºC'),
	(26024, 111, '2015-01-15 01:03:02.000000', 'temperatura', 980.0000, 'ºC'),
	(26025, 111, '2015-01-15 01:03:03.000000', 'temperatura', 15.0000, 'ºC'),
	(26026, 111, '2015-01-15 01:03:04.000000', 'temperatura', 738.0000, 'ºC'),
	(26027, 111, '2015-01-15 01:03:05.000000', 'temperatura', 45.0000, 'ºC'),
	(26028, 111, '2015-01-15 01:03:06.000000', 'temperatura', 410.0000, 'ºC'),
	(26029, 111, '2015-01-15 01:03:07.000000', 'temperatura', 717.0000, 'ºC'),
	(26030, 111, '2015-01-15 01:03:08.000000', 'temperatura', 1155.0000, 'ºC'),
	(26031, 111, '2015-01-15 01:03:09.000000', 'temperatura', 26.0000, 'ºC'),
	(26032, 111, '2015-01-15 01:03:10.000000', 'temperatura', 262.0000, 'ºC'),
	(26033, 111, '2015-01-15 01:03:11.000000', 'temperatura', 36.0000, 'ºC'),
	(26034, 111, '2015-01-15 01:03:12.000000', 'temperatura', 592.0000, 'ºC'),
	(26035, 111, '2015-01-15 01:03:13.000000', 'temperatura', 454.0000, 'ºC'),
	(26036, 111, '2015-01-15 01:03:14.000000', 'temperatura', 496.0000, 'ºC'),
	(26037, 111, '2015-01-15 01:03:15.000000', 'temperatura', 1117.0000, 'ºC'),
	(26038, 111, '2015-01-15 01:03:16.000000', 'temperatura', 498.0000, 'ºC'),
	(26039, 111, '2015-01-15 01:03:17.000000', 'temperatura', 341.0000, 'ºC'),
	(26040, 111, '2015-01-15 01:03:18.000000', 'temperatura', 210.0000, 'ºC'),
	(26041, 111, '2015-01-15 01:03:19.000000', 'temperatura', 28.0000, 'ºC'),
	(26042, 111, '2015-01-15 01:03:20.000000', 'temperatura', 709.0000, 'ºC'),
	(26043, 111, '2015-01-15 01:03:21.000000', 'temperatura', 1063.0000, 'ºC'),
	(26044, 111, '2015-01-15 01:03:22.000000', 'temperatura', 790.0000, 'ºC'),
	(26045, 111, '2015-01-15 01:03:23.000000', 'temperatura', 758.0000, 'ºC'),
	(26046, 111, '2015-01-15 01:03:24.000000', 'temperatura', 222.0000, 'ºC'),
	(26047, 111, '2015-01-15 01:03:25.000000', 'temperatura', 38.0000, 'ºC'),
	(26048, 111, '2015-01-15 01:03:26.000000', 'temperatura', 722.0000, 'ºC'),
	(26049, 111, '2015-01-15 01:03:27.000000', 'temperatura', 1097.0000, 'ºC'),
	(26050, 111, '2015-01-15 01:03:28.000000', 'temperatura', 920.0000, 'ºC'),
	(26051, 111, '2015-01-15 01:03:29.000000', 'temperatura', 108.0000, 'ºC'),
	(26052, 111, '2015-01-15 01:03:30.000000', 'temperatura', 182.0000, 'ºC'),
	(26053, 111, '2015-01-15 01:03:31.000000', 'temperatura', 586.0000, 'ºC'),
	(26054, 111, '2015-01-15 01:03:32.000000', 'temperatura', 1187.0000, 'ºC'),
	(26055, 111, '2015-01-15 01:03:33.000000', 'temperatura', 575.0000, 'ºC'),
	(26056, 111, '2015-01-15 01:03:34.000000', 'temperatura', 513.0000, 'ºC'),
	(26057, 111, '2015-01-15 01:03:35.000000', 'temperatura', 843.0000, 'ºC'),
	(26058, 111, '2015-01-15 01:03:36.000000', 'temperatura', 277.0000, 'ºC'),
	(26059, 111, '2015-01-15 01:03:37.000000', 'temperatura', 57.0000, 'ºC'),
	(26060, 111, '2015-01-15 01:03:38.000000', 'temperatura', 652.0000, 'ºC'),
	(26061, 111, '2015-01-15 01:03:39.000000', 'temperatura', 692.0000, 'ºC'),
	(26062, 111, '2015-01-15 01:03:40.000000', 'temperatura', 303.0000, 'ºC'),
	(26063, 111, '2015-01-15 01:03:41.000000', 'temperatura', 638.0000, 'ºC'),
	(26064, 111, '2015-01-15 01:03:42.000000', 'temperatura', 1082.0000, 'ºC'),
	(26065, 111, '2015-01-15 01:03:43.000000', 'temperatura', 1096.0000, 'ºC'),
	(26066, 111, '2015-01-15 01:03:44.000000', 'temperatura', 1037.0000, 'ºC'),
	(26067, 111, '2015-01-15 01:03:45.000000', 'temperatura', 697.0000, 'ºC'),
	(26068, 111, '2015-01-15 01:03:46.000000', 'temperatura', 372.0000, 'ºC'),
	(26069, 111, '2015-01-15 01:03:47.000000', 'temperatura', 971.0000, 'ºC'),
	(26070, 111, '2015-01-15 01:03:48.000000', 'temperatura', 138.0000, 'ºC'),
	(26071, 111, '2015-01-15 01:03:49.000000', 'temperatura', 178.0000, 'ºC'),
	(26072, 111, '2015-01-15 01:03:50.000000', 'temperatura', 478.0000, 'ºC'),
	(26073, 111, '2015-01-15 01:03:51.000000', 'temperatura', 654.0000, 'ºC'),
	(26074, 111, '2015-01-15 01:03:52.000000', 'temperatura', 638.0000, 'ºC'),
	(26075, 111, '2015-01-15 01:03:53.000000', 'temperatura', 27.0000, 'ºC'),
	(26076, 111, '2015-01-15 01:03:54.000000', 'temperatura', 624.0000, 'ºC'),
	(26077, 111, '2015-01-15 01:03:55.000000', 'temperatura', 637.0000, 'ºC'),
	(26078, 111, '2015-01-15 01:03:56.000000', 'temperatura', 114.0000, 'ºC'),
	(26079, 111, '2015-01-15 01:03:57.000000', 'temperatura', 1062.0000, 'ºC'),
	(26080, 111, '2015-01-15 01:03:58.000000', 'temperatura', 167.0000, 'ºC'),
	(26081, 111, '2015-01-15 01:03:59.000000', 'temperatura', 48.0000, 'ºC'),
	(26082, 111, '2015-01-15 01:04:00.000000', 'temperatura', 942.0000, 'ºC'),
	(26083, 111, '2015-01-15 01:04:01.000000', 'temperatura', 967.0000, 'ºC'),
	(26084, 111, '2015-01-15 01:04:02.000000', 'temperatura', 808.0000, 'ºC'),
	(26085, 111, '2015-01-15 01:04:03.000000', 'temperatura', 1140.0000, 'ºC'),
	(26086, 111, '2015-01-15 01:04:04.000000', 'temperatura', 878.0000, 'ºC'),
	(26087, 111, '2015-01-15 01:04:05.000000', 'temperatura', 967.0000, 'ºC'),
	(26088, 111, '2015-01-15 01:04:06.000000', 'temperatura', 1004.0000, 'ºC'),
	(26089, 111, '2015-01-15 01:04:07.000000', 'temperatura', 921.0000, 'ºC'),
	(26090, 111, '2015-01-15 01:04:08.000000', 'temperatura', 392.0000, 'ºC'),
	(26091, 111, '2015-01-15 01:04:09.000000', 'temperatura', 397.0000, 'ºC'),
	(26092, 111, '2015-01-15 01:04:10.000000', 'temperatura', 808.0000, 'ºC'),
	(26093, 111, '2015-01-15 01:04:11.000000', 'temperatura', 452.0000, 'ºC'),
	(26094, 111, '2015-01-15 01:04:12.000000', 'temperatura', 1037.0000, 'ºC'),
	(26095, 111, '2015-01-15 01:04:13.000000', 'temperatura', 229.0000, 'ºC'),
	(26096, 111, '2015-01-15 01:04:14.000000', 'temperatura', 436.0000, 'ºC'),
	(26097, 111, '2015-01-15 01:04:15.000000', 'temperatura', 294.0000, 'ºC'),
	(26098, 111, '2015-01-15 01:04:16.000000', 'temperatura', 160.0000, 'ºC'),
	(26099, 111, '2015-01-15 01:04:17.000000', 'temperatura', 1118.0000, 'ºC'),
	(26100, 111, '2015-01-15 01:04:18.000000', 'temperatura', 313.0000, 'ºC'),
	(26101, 111, '2015-01-15 01:04:19.000000', 'temperatura', 608.0000, 'ºC'),
	(26102, 111, '2015-01-15 01:04:20.000000', 'temperatura', 905.0000, 'ºC'),
	(26103, 111, '2015-01-15 01:04:21.000000', 'temperatura', 300.0000, 'ºC'),
	(26104, 111, '2015-01-15 01:04:22.000000', 'temperatura', 1186.0000, 'ºC'),
	(26105, 111, '2015-01-15 01:04:23.000000', 'temperatura', 228.0000, 'ºC'),
	(26106, 111, '2015-01-15 01:04:24.000000', 'temperatura', 1185.0000, 'ºC'),
	(26107, 111, '2015-01-15 01:04:25.000000', 'temperatura', 442.0000, 'ºC'),
	(26108, 111, '2015-01-15 01:04:26.000000', 'temperatura', 1055.0000, 'ºC'),
	(26109, 111, '2015-01-15 01:04:27.000000', 'temperatura', 347.0000, 'ºC'),
	(26110, 111, '2015-01-15 01:04:28.000000', 'temperatura', 974.0000, 'ºC'),
	(26111, 111, '2015-01-15 01:04:29.000000', 'temperatura', 227.0000, 'ºC'),
	(26112, 111, '2015-01-15 01:04:30.000000', 'temperatura', 615.0000, 'ºC'),
	(26113, 111, '2015-01-15 01:04:31.000000', 'temperatura', 1193.0000, 'ºC'),
	(26114, 111, '2015-01-15 01:04:32.000000', 'temperatura', 520.0000, 'ºC'),
	(26115, 111, '2015-01-15 01:04:33.000000', 'temperatura', 222.0000, 'ºC'),
	(26116, 111, '2015-01-15 01:04:34.000000', 'temperatura', 752.0000, 'ºC'),
	(26117, 111, '2015-01-15 01:04:35.000000', 'temperatura', 693.0000, 'ºC'),
	(26118, 111, '2015-01-15 01:04:36.000000', 'temperatura', 11.0000, 'ºC'),
	(26119, 111, '2015-01-15 01:04:37.000000', 'temperatura', 374.0000, 'ºC'),
	(26120, 111, '2015-01-15 01:04:38.000000', 'temperatura', 637.0000, 'ºC'),
	(26121, 111, '2015-01-15 01:04:39.000000', 'temperatura', 866.0000, 'ºC'),
	(26122, 111, '2015-01-15 01:04:40.000000', 'temperatura', 18.0000, 'ºC'),
	(26123, 111, '2015-01-15 01:04:41.000000', 'temperatura', 1095.0000, 'ºC'),
	(26124, 111, '2015-01-15 01:04:42.000000', 'temperatura', 620.0000, 'ºC'),
	(26125, 111, '2015-01-15 01:04:43.000000', 'temperatura', 1014.0000, 'ºC'),
	(26126, 111, '2015-01-15 01:04:44.000000', 'temperatura', 811.0000, 'ºC'),
	(26127, 111, '2015-01-15 01:04:45.000000', 'temperatura', 1014.0000, 'ºC'),
	(26128, 111, '2015-01-15 01:04:46.000000', 'temperatura', 237.0000, 'ºC'),
	(26129, 111, '2015-01-15 01:04:47.000000', 'temperatura', 543.0000, 'ºC'),
	(26130, 111, '2015-01-15 01:04:48.000000', 'temperatura', 805.0000, 'ºC'),
	(26131, 111, '2015-01-15 01:04:49.000000', 'temperatura', 1196.0000, 'ºC'),
	(26132, 111, '2015-01-15 01:04:50.000000', 'temperatura', 1165.0000, 'ºC'),
	(26133, 111, '2015-01-15 01:04:51.000000', 'temperatura', 1040.0000, 'ºC'),
	(26134, 111, '2015-01-15 01:04:52.000000', 'temperatura', 502.0000, 'ºC'),
	(26135, 111, '2015-01-15 01:04:53.000000', 'temperatura', 593.0000, 'ºC'),
	(26136, 111, '2015-01-15 01:04:54.000000', 'temperatura', 260.0000, 'ºC'),
	(26137, 111, '2015-01-15 01:04:55.000000', 'temperatura', 720.0000, 'ºC'),
	(26138, 111, '2015-01-15 01:04:56.000000', 'temperatura', 421.0000, 'ºC'),
	(26139, 111, '2015-01-15 01:04:57.000000', 'temperatura', 1144.0000, 'ºC'),
	(26140, 111, '2015-01-15 01:04:58.000000', 'temperatura', 860.0000, 'ºC'),
	(26141, 111, '2015-01-15 01:04:59.000000', 'temperatura', 868.0000, 'ºC'),
	(26142, 111, '2015-01-15 01:05:00.000000', 'temperatura', 562.0000, 'ºC'),
	(26143, 111, '2015-01-15 01:05:01.000000', 'temperatura', 206.0000, 'ºC'),
	(26144, 111, '2015-01-15 01:05:02.000000', 'temperatura', 544.0000, 'ºC'),
	(26145, 111, '2015-01-15 01:05:03.000000', 'temperatura', 904.0000, 'ºC'),
	(26146, 111, '2015-01-15 01:05:04.000000', 'temperatura', 487.0000, 'ºC'),
	(26147, 111, '2015-01-15 01:05:05.000000', 'temperatura', 923.0000, 'ºC'),
	(26148, 111, '2015-01-15 01:05:06.000000', 'temperatura', 756.0000, 'ºC'),
	(26149, 111, '2015-01-15 01:05:07.000000', 'temperatura', 1012.0000, 'ºC'),
	(26150, 111, '2015-01-15 01:05:08.000000', 'temperatura', 392.0000, 'ºC'),
	(26151, 111, '2015-01-15 01:05:09.000000', 'temperatura', 125.0000, 'ºC'),
	(26152, 111, '2015-01-15 01:05:10.000000', 'temperatura', 649.0000, 'ºC'),
	(26153, 111, '2015-01-15 01:05:11.000000', 'temperatura', 471.0000, 'ºC'),
	(26154, 111, '2015-01-15 01:05:12.000000', 'temperatura', 408.0000, 'ºC'),
	(26155, 111, '2015-01-15 01:05:13.000000', 'temperatura', 626.0000, 'ºC'),
	(26156, 111, '2015-01-15 01:05:14.000000', 'temperatura', 709.0000, 'ºC'),
	(26157, 111, '2015-01-15 01:05:15.000000', 'temperatura', 467.0000, 'ºC'),
	(26158, 111, '2015-01-15 01:05:16.000000', 'temperatura', 210.0000, 'ºC'),
	(26159, 111, '2015-01-15 01:05:17.000000', 'temperatura', 848.0000, 'ºC'),
	(26160, 111, '2015-01-15 01:05:18.000000', 'temperatura', 11.0000, 'ºC'),
	(26161, 111, '2015-01-15 01:05:19.000000', 'temperatura', 1113.0000, 'ºC'),
	(26162, 111, '2015-01-15 01:05:20.000000', 'temperatura', 729.0000, 'ºC'),
	(26163, 111, '2015-01-15 01:05:21.000000', 'temperatura', 310.0000, 'ºC'),
	(26164, 111, '2015-01-15 01:05:22.000000', 'temperatura', 560.0000, 'ºC'),
	(26165, 111, '2015-01-15 01:05:23.000000', 'temperatura', 673.0000, 'ºC'),
	(26166, 111, '2015-01-15 01:05:24.000000', 'temperatura', 483.0000, 'ºC'),
	(26167, 111, '2015-01-15 01:05:25.000000', 'temperatura', 398.0000, 'ºC'),
	(26168, 111, '2015-01-15 01:05:26.000000', 'temperatura', 542.0000, 'ºC'),
	(26169, 111, '2015-01-15 01:05:27.000000', 'temperatura', 314.0000, 'ºC'),
	(26170, 111, '2015-01-15 01:05:28.000000', 'temperatura', 1147.0000, 'ºC'),
	(26171, 111, '2015-01-15 01:05:29.000000', 'temperatura', 1191.0000, 'ºC'),
	(26172, 111, '2015-01-15 01:05:30.000000', 'temperatura', 116.0000, 'ºC'),
	(26173, 111, '2015-01-15 01:05:31.000000', 'temperatura', 609.0000, 'ºC'),
	(26174, 111, '2015-01-15 01:05:32.000000', 'temperatura', 297.0000, 'ºC'),
	(26175, 111, '2015-01-15 01:05:33.000000', 'temperatura', 856.0000, 'ºC'),
	(26176, 111, '2015-01-15 01:05:34.000000', 'temperatura', 992.0000, 'ºC'),
	(26177, 111, '2015-01-15 01:05:35.000000', 'temperatura', 1193.0000, 'ºC'),
	(26178, 111, '2015-01-15 01:05:36.000000', 'temperatura', 591.0000, 'ºC'),
	(26179, 111, '2015-01-15 01:05:37.000000', 'temperatura', 574.0000, 'ºC'),
	(26180, 111, '2015-01-15 01:05:38.000000', 'temperatura', 1097.0000, 'ºC'),
	(26181, 111, '2015-01-15 01:05:39.000000', 'temperatura', 164.0000, 'ºC'),
	(26182, 111, '2015-01-15 01:05:40.000000', 'temperatura', 1131.0000, 'ºC'),
	(26183, 111, '2015-01-15 01:05:41.000000', 'temperatura', 361.0000, 'ºC'),
	(26184, 111, '2015-01-15 01:05:42.000000', 'temperatura', 812.0000, 'ºC'),
	(26185, 111, '2015-01-15 01:05:43.000000', 'temperatura', 578.0000, 'ºC'),
	(26186, 111, '2015-01-15 01:05:44.000000', 'temperatura', 456.0000, 'ºC'),
	(26187, 111, '2015-01-15 01:05:45.000000', 'temperatura', 547.0000, 'ºC'),
	(26188, 111, '2015-01-15 01:05:46.000000', 'temperatura', 165.0000, 'ºC'),
	(26189, 111, '2015-01-15 01:05:47.000000', 'temperatura', 385.0000, 'ºC'),
	(26190, 111, '2015-01-15 01:05:48.000000', 'temperatura', 229.0000, 'ºC'),
	(26191, 111, '2015-01-15 01:05:49.000000', 'temperatura', 1193.0000, 'ºC'),
	(26192, 111, '2015-01-15 01:05:50.000000', 'temperatura', 478.0000, 'ºC'),
	(26193, 111, '2015-01-15 01:05:51.000000', 'temperatura', 13.0000, 'ºC'),
	(26194, 111, '2015-01-15 01:05:52.000000', 'temperatura', 1031.0000, 'ºC'),
	(26195, 111, '2015-01-15 01:05:53.000000', 'temperatura', 318.0000, 'ºC'),
	(26196, 111, '2015-01-15 01:05:54.000000', 'temperatura', 895.0000, 'ºC'),
	(26197, 111, '2015-01-15 01:05:55.000000', 'temperatura', 1124.0000, 'ºC'),
	(26198, 111, '2015-01-15 01:05:56.000000', 'temperatura', 536.0000, 'ºC'),
	(26199, 111, '2015-01-15 01:05:57.000000', 'temperatura', 505.0000, 'ºC'),
	(26200, 111, '2015-01-15 01:05:58.000000', 'temperatura', 921.0000, 'ºC'),
	(26201, 111, '2015-01-15 01:05:59.000000', 'temperatura', 689.0000, 'ºC'),
	(26202, 111, '2015-01-15 01:06:00.000000', 'temperatura', 684.0000, 'ºC'),
	(26203, 111, '2015-01-15 01:06:01.000000', 'temperatura', 152.0000, 'ºC'),
	(26204, 111, '2015-01-15 01:06:02.000000', 'temperatura', 1108.0000, 'ºC'),
	(26205, 111, '2015-01-15 01:06:03.000000', 'temperatura', 283.0000, 'ºC'),
	(26206, 111, '2015-01-15 01:06:04.000000', 'temperatura', 494.0000, 'ºC'),
	(26207, 111, '2015-01-15 01:06:05.000000', 'temperatura', 422.0000, 'ºC'),
	(26208, 111, '2015-01-15 01:06:06.000000', 'temperatura', 628.0000, 'ºC'),
	(26209, 111, '2015-01-15 01:06:07.000000', 'temperatura', 674.0000, 'ºC'),
	(26210, 111, '2015-01-15 01:06:08.000000', 'temperatura', 287.0000, 'ºC'),
	(26211, 111, '2015-01-15 01:06:09.000000', 'temperatura', 615.0000, 'ºC'),
	(26212, 111, '2015-01-15 01:06:10.000000', 'temperatura', 1013.0000, 'ºC'),
	(26213, 111, '2015-01-15 01:06:11.000000', 'temperatura', 822.0000, 'ºC'),
	(26214, 111, '2015-01-15 01:06:12.000000', 'temperatura', 1070.0000, 'ºC'),
	(26215, 111, '2015-01-15 01:06:13.000000', 'temperatura', 483.0000, 'ºC'),
	(26216, 111, '2015-01-15 01:06:14.000000', 'temperatura', 407.0000, 'ºC'),
	(26217, 111, '2015-01-15 01:06:15.000000', 'temperatura', 588.0000, 'ºC'),
	(26218, 111, '2015-01-15 01:06:16.000000', 'temperatura', 518.0000, 'ºC'),
	(26219, 111, '2015-01-15 01:06:17.000000', 'temperatura', 828.0000, 'ºC'),
	(26220, 111, '2015-01-15 01:06:18.000000', 'temperatura', 187.0000, 'ºC'),
	(26221, 111, '2015-01-15 01:06:19.000000', 'temperatura', 848.0000, 'ºC'),
	(26222, 111, '2015-01-15 01:06:20.000000', 'temperatura', 83.0000, 'ºC'),
	(26223, 111, '2015-01-15 01:06:21.000000', 'temperatura', 272.0000, 'ºC'),
	(26224, 111, '2015-01-15 01:06:22.000000', 'temperatura', 1110.0000, 'ºC'),
	(26225, 111, '2015-01-15 01:06:23.000000', 'temperatura', 1135.0000, 'ºC'),
	(26226, 111, '2015-01-15 01:06:24.000000', 'temperatura', 1144.0000, 'ºC'),
	(26227, 111, '2015-01-15 01:06:25.000000', 'temperatura', 1115.0000, 'ºC'),
	(26228, 111, '2015-01-15 01:06:26.000000', 'temperatura', 945.0000, 'ºC'),
	(26229, 111, '2015-01-15 01:06:27.000000', 'temperatura', 179.0000, 'ºC'),
	(26230, 111, '2015-01-15 01:06:28.000000', 'temperatura', 463.0000, 'ºC'),
	(26231, 111, '2015-01-15 01:06:29.000000', 'temperatura', 576.0000, 'ºC'),
	(26232, 111, '2015-01-15 01:06:30.000000', 'temperatura', 293.0000, 'ºC'),
	(26233, 111, '2015-01-15 01:06:31.000000', 'temperatura', 937.0000, 'ºC'),
	(26234, 111, '2015-01-15 01:06:32.000000', 'temperatura', 208.0000, 'ºC'),
	(26235, 111, '2015-01-15 01:06:33.000000', 'temperatura', 629.0000, 'ºC'),
	(26236, 111, '2015-01-15 01:06:34.000000', 'temperatura', 120.0000, 'ºC'),
	(26237, 111, '2015-01-15 01:06:35.000000', 'temperatura', 1115.0000, 'ºC'),
	(26238, 111, '2015-01-15 01:06:36.000000', 'temperatura', 415.0000, 'ºC'),
	(26239, 111, '2015-01-15 01:06:37.000000', 'temperatura', 1130.0000, 'ºC'),
	(26240, 111, '2015-01-15 01:06:38.000000', 'temperatura', 807.0000, 'ºC'),
	(26241, 111, '2015-01-15 01:06:39.000000', 'temperatura', 647.0000, 'ºC'),
	(26242, 111, '2015-01-15 01:06:40.000000', 'temperatura', 812.0000, 'ºC'),
	(26243, 111, '2015-01-15 01:06:41.000000', 'temperatura', 920.0000, 'ºC'),
	(26244, 111, '2015-01-15 01:06:42.000000', 'temperatura', 965.0000, 'ºC'),
	(26245, 111, '2015-01-15 01:06:43.000000', 'temperatura', 864.0000, 'ºC'),
	(26246, 111, '2015-01-15 01:06:44.000000', 'temperatura', 228.0000, 'ºC'),
	(26247, 111, '2015-01-15 01:06:45.000000', 'temperatura', 948.0000, 'ºC'),
	(26248, 111, '2015-01-15 01:06:46.000000', 'temperatura', 457.0000, 'ºC'),
	(26249, 111, '2015-01-15 01:06:47.000000', 'temperatura', 640.0000, 'ºC'),
	(26250, 111, '2015-01-15 01:06:48.000000', 'temperatura', 632.0000, 'ºC'),
	(26251, 111, '2015-01-15 01:06:49.000000', 'temperatura', 38.0000, 'ºC'),
	(26252, 111, '2015-01-15 01:06:50.000000', 'temperatura', 696.0000, 'ºC'),
	(26253, 111, '2015-01-15 01:06:51.000000', 'temperatura', 966.0000, 'ºC'),
	(26254, 111, '2015-01-15 01:06:52.000000', 'temperatura', 344.0000, 'ºC'),
	(26255, 111, '2015-01-15 01:06:53.000000', 'temperatura', 20.0000, 'ºC'),
	(26256, 111, '2015-01-15 01:06:54.000000', 'temperatura', 271.0000, 'ºC'),
	(26257, 111, '2015-01-15 01:06:55.000000', 'temperatura', 94.0000, 'ºC'),
	(26258, 111, '2015-01-15 01:06:56.000000', 'temperatura', 857.0000, 'ºC'),
	(26259, 111, '2015-01-15 01:06:57.000000', 'temperatura', 404.0000, 'ºC'),
	(26260, 111, '2015-01-15 01:06:58.000000', 'temperatura', 651.0000, 'ºC'),
	(26261, 111, '2015-01-15 01:06:59.000000', 'temperatura', 844.0000, 'ºC'),
	(26262, 111, '2015-01-15 01:07:00.000000', 'temperatura', 1067.0000, 'ºC'),
	(26263, 111, '2015-01-15 01:07:01.000000', 'temperatura', 401.0000, 'ºC'),
	(26264, 111, '2015-01-15 01:07:02.000000', 'temperatura', 8.0000, 'ºC'),
	(26265, 111, '2015-01-15 01:07:03.000000', 'temperatura', 35.0000, 'ºC'),
	(26266, 111, '2015-01-15 01:07:04.000000', 'temperatura', 152.0000, 'ºC'),
	(26267, 111, '2015-01-15 01:07:05.000000', 'temperatura', 657.0000, 'ºC'),
	(26268, 111, '2015-01-15 01:07:06.000000', 'temperatura', 431.0000, 'ºC'),
	(26269, 111, '2015-01-15 01:07:07.000000', 'temperatura', 181.0000, 'ºC'),
	(26270, 111, '2015-01-15 01:07:08.000000', 'temperatura', 815.0000, 'ºC'),
	(26271, 111, '2015-01-15 01:07:09.000000', 'temperatura', 1132.0000, 'ºC'),
	(26272, 111, '2015-01-15 01:07:10.000000', 'temperatura', 816.0000, 'ºC'),
	(26273, 111, '2015-01-15 01:07:11.000000', 'temperatura', 685.0000, 'ºC'),
	(26274, 111, '2015-01-15 01:07:12.000000', 'temperatura', 977.0000, 'ºC'),
	(26275, 111, '2015-01-15 01:07:13.000000', 'temperatura', 432.0000, 'ºC'),
	(26276, 111, '2015-01-15 01:07:14.000000', 'temperatura', 428.0000, 'ºC'),
	(26277, 111, '2015-01-15 01:07:15.000000', 'temperatura', 843.0000, 'ºC'),
	(26278, 111, '2015-01-15 01:07:16.000000', 'temperatura', 532.0000, 'ºC'),
	(26279, 111, '2015-01-15 01:07:17.000000', 'temperatura', 130.0000, 'ºC'),
	(26280, 111, '2015-01-15 01:07:18.000000', 'temperatura', 256.0000, 'ºC'),
	(26281, 111, '2015-01-15 01:07:19.000000', 'temperatura', 889.0000, 'ºC'),
	(26282, 111, '2015-01-15 01:07:20.000000', 'temperatura', 78.0000, 'ºC'),
	(26283, 111, '2015-01-15 01:07:21.000000', 'temperatura', 126.0000, 'ºC'),
	(26284, 111, '2015-01-15 01:07:22.000000', 'temperatura', 395.0000, 'ºC'),
	(26285, 111, '2015-01-15 01:07:23.000000', 'temperatura', 396.0000, 'ºC'),
	(26286, 111, '2015-01-15 01:07:24.000000', 'temperatura', 795.0000, 'ºC'),
	(26287, 111, '2015-01-15 01:07:25.000000', 'temperatura', 391.0000, 'ºC'),
	(26288, 111, '2015-01-15 01:07:26.000000', 'temperatura', 767.0000, 'ºC'),
	(26289, 111, '2015-01-15 01:07:27.000000', 'temperatura', 263.0000, 'ºC'),
	(26290, 111, '2015-01-15 01:07:28.000000', 'temperatura', 216.0000, 'ºC'),
	(26291, 111, '2015-01-15 01:07:29.000000', 'temperatura', 289.0000, 'ºC'),
	(26292, 111, '2015-01-15 01:07:30.000000', 'temperatura', 800.0000, 'ºC'),
	(26293, 111, '2015-01-15 01:07:31.000000', 'temperatura', 733.0000, 'ºC'),
	(26294, 111, '2015-01-15 01:07:32.000000', 'temperatura', 63.0000, 'ºC'),
	(26295, 111, '2015-01-15 01:07:33.000000', 'temperatura', 519.0000, 'ºC'),
	(26296, 111, '2015-01-15 01:07:34.000000', 'temperatura', 7.0000, 'ºC'),
	(26297, 111, '2015-01-15 01:07:35.000000', 'temperatura', 876.0000, 'ºC'),
	(26298, 111, '2015-01-15 01:07:36.000000', 'temperatura', 759.0000, 'ºC'),
	(26299, 111, '2015-01-15 01:07:37.000000', 'temperatura', 1170.0000, 'ºC'),
	(26300, 111, '2015-01-15 01:07:38.000000', 'temperatura', 1174.0000, 'ºC'),
	(26301, 111, '2015-01-15 01:07:39.000000', 'temperatura', 1160.0000, 'ºC'),
	(26302, 111, '2015-01-15 01:07:40.000000', 'temperatura', 1077.0000, 'ºC'),
	(26303, 111, '2015-01-15 01:07:41.000000', 'temperatura', 708.0000, 'ºC'),
	(26304, 111, '2015-01-15 01:07:42.000000', 'temperatura', 306.0000, 'ºC'),
	(26305, 111, '2015-01-15 01:07:43.000000', 'temperatura', 610.0000, 'ºC'),
	(26306, 111, '2015-01-15 01:07:44.000000', 'temperatura', 931.0000, 'ºC'),
	(26307, 111, '2015-01-15 01:07:45.000000', 'temperatura', 427.0000, 'ºC'),
	(26308, 111, '2015-01-15 01:07:46.000000', 'temperatura', 540.0000, 'ºC'),
	(26309, 111, '2015-01-15 01:07:47.000000', 'temperatura', 222.0000, 'ºC'),
	(26310, 111, '2015-01-15 01:07:48.000000', 'temperatura', 689.0000, 'ºC'),
	(26311, 111, '2015-01-15 01:07:49.000000', 'temperatura', 379.0000, 'ºC'),
	(26312, 111, '2015-01-15 01:07:50.000000', 'temperatura', 1028.0000, 'ºC'),
	(26313, 111, '2015-01-15 01:07:51.000000', 'temperatura', 402.0000, 'ºC'),
	(26314, 111, '2015-01-15 01:07:52.000000', 'temperatura', 130.0000, 'ºC'),
	(26315, 111, '2015-01-15 01:07:53.000000', 'temperatura', 643.0000, 'ºC'),
	(26316, 111, '2015-01-15 01:07:54.000000', 'temperatura', 424.0000, 'ºC'),
	(26317, 111, '2015-01-15 01:07:55.000000', 'temperatura', 192.0000, 'ºC'),
	(26318, 111, '2015-01-15 01:07:56.000000', 'temperatura', 890.0000, 'ºC'),
	(26319, 111, '2015-01-15 01:07:57.000000', 'temperatura', 275.0000, 'ºC'),
	(26320, 111, '2015-01-15 01:07:58.000000', 'temperatura', 1103.0000, 'ºC'),
	(26321, 111, '2015-01-15 01:07:59.000000', 'temperatura', 1090.0000, 'ºC'),
	(26322, 111, '2015-01-15 01:08:00.000000', 'temperatura', 945.0000, 'ºC'),
	(26323, 111, '2015-01-15 01:08:01.000000', 'temperatura', 252.0000, 'ºC'),
	(26324, 111, '2015-01-15 01:08:02.000000', 'temperatura', 826.0000, 'ºC'),
	(26325, 111, '2015-01-15 01:08:03.000000', 'temperatura', 973.0000, 'ºC'),
	(26326, 111, '2015-01-15 01:08:04.000000', 'temperatura', 1189.0000, 'ºC'),
	(26327, 111, '2015-01-15 01:08:05.000000', 'temperatura', 628.0000, 'ºC'),
	(26328, 111, '2015-01-15 01:08:06.000000', 'temperatura', 771.0000, 'ºC'),
	(26329, 111, '2015-01-15 01:08:07.000000', 'temperatura', 772.0000, 'ºC'),
	(26330, 111, '2015-01-15 01:08:08.000000', 'temperatura', 347.0000, 'ºC'),
	(26331, 111, '2015-01-15 01:08:09.000000', 'temperatura', 621.0000, 'ºC'),
	(26332, 111, '2015-01-15 01:08:10.000000', 'temperatura', 863.0000, 'ºC'),
	(26333, 111, '2015-01-15 01:08:11.000000', 'temperatura', 52.0000, 'ºC'),
	(26334, 111, '2015-01-15 01:08:12.000000', 'temperatura', 74.0000, 'ºC'),
	(26335, 111, '2015-01-15 01:08:13.000000', 'temperatura', 214.0000, 'ºC'),
	(26336, 111, '2015-01-15 01:08:14.000000', 'temperatura', 847.0000, 'ºC'),
	(26337, 111, '2015-01-15 01:08:15.000000', 'temperatura', 1194.0000, 'ºC'),
	(26338, 111, '2015-01-15 01:08:16.000000', 'temperatura', 1032.0000, 'ºC'),
	(26339, 111, '2015-01-15 01:08:17.000000', 'temperatura', 375.0000, 'ºC'),
	(26340, 111, '2015-01-15 01:08:18.000000', 'temperatura', 1180.0000, 'ºC'),
	(26341, 111, '2015-01-15 01:08:19.000000', 'temperatura', 1176.0000, 'ºC'),
	(26342, 111, '2015-01-15 01:08:20.000000', 'temperatura', 1141.0000, 'ºC'),
	(26343, 111, '2015-01-15 01:08:21.000000', 'temperatura', 978.0000, 'ºC'),
	(26344, 111, '2015-01-15 01:08:22.000000', 'temperatura', 267.0000, 'ºC'),
	(26345, 111, '2015-01-15 01:08:23.000000', 'temperatura', 800.0000, 'ºC'),
	(26346, 111, '2015-01-15 01:08:24.000000', 'temperatura', 802.0000, 'ºC'),
	(26347, 111, '2015-01-15 01:08:25.000000', 'temperatura', 410.0000, 'ºC'),
	(26348, 111, '2015-01-15 01:08:26.000000', 'temperatura', 844.0000, 'ºC'),
	(26349, 111, '2015-01-15 01:08:27.000000', 'temperatura', 590.0000, 'ºC'),
	(26350, 111, '2015-01-15 01:08:28.000000', 'temperatura', 417.0000, 'ºC'),
	(26351, 111, '2015-01-15 01:08:29.000000', 'temperatura', 318.0000, 'ºC'),
	(26352, 111, '2015-01-15 01:08:30.000000', 'temperatura', 337.0000, 'ºC'),
	(26353, 111, '2015-01-15 01:08:31.000000', 'temperatura', 733.0000, 'ºC'),
	(26354, 111, '2015-01-15 01:08:32.000000', 'temperatura', 253.0000, 'ºC'),
	(26355, 111, '2015-01-15 01:08:33.000000', 'temperatura', 268.0000, 'ºC'),
	(26356, 111, '2015-01-15 01:08:34.000000', 'temperatura', 582.0000, 'ºC'),
	(26357, 111, '2015-01-15 01:08:35.000000', 'temperatura', 907.0000, 'ºC'),
	(26358, 111, '2015-01-15 01:08:36.000000', 'temperatura', 388.0000, 'ºC'),
	(26359, 111, '2015-01-15 01:08:37.000000', 'temperatura', 421.0000, 'ºC'),
	(26360, 111, '2015-01-15 01:08:38.000000', 'temperatura', 943.0000, 'ºC'),
	(26361, 111, '2015-01-15 01:08:39.000000', 'temperatura', 1051.0000, 'ºC'),
	(26362, 111, '2015-01-15 01:08:40.000000', 'temperatura', 25.0000, 'ºC'),
	(26363, 111, '2015-01-15 01:08:41.000000', 'temperatura', 572.0000, 'ºC'),
	(26364, 111, '2015-01-15 01:08:42.000000', 'temperatura', 385.0000, 'ºC'),
	(26365, 111, '2015-01-15 01:08:43.000000', 'temperatura', 211.0000, 'ºC'),
	(26366, 111, '2015-01-15 01:08:44.000000', 'temperatura', 1100.0000, 'ºC'),
	(26367, 111, '2015-01-15 01:08:45.000000', 'temperatura', 67.0000, 'ºC'),
	(26368, 111, '2015-01-15 01:08:46.000000', 'temperatura', 638.0000, 'ºC'),
	(26369, 111, '2015-01-15 01:08:47.000000', 'temperatura', 588.0000, 'ºC'),
	(26370, 111, '2015-01-15 01:08:48.000000', 'temperatura', 1028.0000, 'ºC'),
	(26371, 111, '2015-01-15 01:08:49.000000', 'temperatura', 977.0000, 'ºC'),
	(26372, 111, '2015-01-15 01:08:50.000000', 'temperatura', 602.0000, 'ºC'),
	(26373, 111, '2015-01-15 01:08:51.000000', 'temperatura', 80.0000, 'ºC'),
	(26374, 111, '2015-01-15 01:08:52.000000', 'temperatura', 995.0000, 'ºC'),
	(26375, 111, '2015-01-15 01:08:53.000000', 'temperatura', 1134.0000, 'ºC'),
	(26376, 111, '2015-01-15 01:08:54.000000', 'temperatura', 288.0000, 'ºC'),
	(26377, 111, '2015-01-15 01:08:55.000000', 'temperatura', 435.0000, 'ºC'),
	(26378, 111, '2015-01-15 01:08:56.000000', 'temperatura', 113.0000, 'ºC'),
	(26379, 111, '2015-01-15 01:08:57.000000', 'temperatura', 460.0000, 'ºC'),
	(26380, 111, '2015-01-15 01:08:58.000000', 'temperatura', 760.0000, 'ºC'),
	(26381, 111, '2015-01-15 01:08:59.000000', 'temperatura', 20.0000, 'ºC'),
	(26382, 111, '2015-01-15 01:09:00.000000', 'temperatura', 222.0000, 'ºC'),
	(26383, 111, '2015-01-15 01:09:01.000000', 'temperatura', 1052.0000, 'ºC'),
	(26384, 111, '2015-01-15 01:09:02.000000', 'temperatura', 993.0000, 'ºC'),
	(26385, 111, '2015-01-15 01:09:03.000000', 'temperatura', 610.0000, 'ºC'),
	(26386, 111, '2015-01-15 01:09:04.000000', 'temperatura', 69.0000, 'ºC'),
	(26387, 111, '2015-01-15 01:09:05.000000', 'temperatura', 918.0000, 'ºC'),
	(26388, 111, '2015-01-15 01:09:06.000000', 'temperatura', 783.0000, 'ºC'),
	(26389, 111, '2015-01-15 01:09:07.000000', 'temperatura', 1161.0000, 'ºC'),
	(26390, 111, '2015-01-15 01:09:08.000000', 'temperatura', 1058.0000, 'ºC'),
	(26391, 111, '2015-01-15 01:09:09.000000', 'temperatura', 607.0000, 'ºC'),
	(26392, 111, '2015-01-15 01:09:10.000000', 'temperatura', 1061.0000, 'ºC'),
	(26393, 111, '2015-01-15 01:09:11.000000', 'temperatura', 1085.0000, 'ºC'),
	(26394, 111, '2015-01-15 01:09:12.000000', 'temperatura', 1043.0000, 'ºC'),
	(26395, 111, '2015-01-15 01:09:13.000000', 'temperatura', 762.0000, 'ºC'),
	(26396, 111, '2015-01-15 01:09:14.000000', 'temperatura', 679.0000, 'ºC'),
	(26397, 111, '2015-01-15 01:09:15.000000', 'temperatura', 1109.0000, 'ºC'),
	(26398, 111, '2015-01-15 01:09:16.000000', 'temperatura', 1111.0000, 'ºC'),
	(26399, 111, '2015-01-15 01:09:17.000000', 'temperatura', 1026.0000, 'ºC'),
	(26400, 111, '2015-01-15 01:09:18.000000', 'temperatura', 600.0000, 'ºC'),
	(26401, 111, '2015-01-15 01:09:19.000000', 'temperatura', 1121.0000, 'ºC'),
	(26402, 111, '2015-01-15 01:09:20.000000', 'temperatura', 205.0000, 'ºC'),
	(26403, 111, '2015-01-15 01:09:21.000000', 'temperatura', 62.0000, 'ºC'),
	(26404, 111, '2015-01-15 01:09:22.000000', 'temperatura', 895.0000, 'ºC'),
	(26405, 111, '2015-01-15 01:09:23.000000', 'temperatura', 690.0000, 'ºC'),
	(26406, 111, '2015-01-15 01:09:24.000000', 'temperatura', 767.0000, 'ºC'),
	(26407, 111, '2015-01-15 01:09:25.000000', 'temperatura', 566.0000, 'ºC'),
	(26408, 111, '2015-01-15 01:09:26.000000', 'temperatura', 529.0000, 'ºC'),
	(26409, 111, '2015-01-15 01:09:27.000000', 'temperatura', 949.0000, 'ºC'),
	(26410, 111, '2015-01-15 01:09:28.000000', 'temperatura', 757.0000, 'ºC'),
	(26411, 111, '2015-01-15 01:09:29.000000', 'temperatura', 939.0000, 'ºC'),
	(26412, 111, '2015-01-15 01:09:30.000000', 'temperatura', 25.0000, 'ºC'),
	(26413, 111, '2015-01-15 01:09:31.000000', 'temperatura', 907.0000, 'ºC'),
	(26414, 111, '2015-01-15 01:09:32.000000', 'temperatura', 862.0000, 'ºC'),
	(26415, 111, '2015-01-15 01:09:33.000000', 'temperatura', 390.0000, 'ºC'),
	(26416, 111, '2015-01-15 01:09:34.000000', 'temperatura', 564.0000, 'ºC'),
	(26417, 111, '2015-01-15 01:09:35.000000', 'temperatura', 449.0000, 'ºC'),
	(26418, 111, '2015-01-15 01:09:36.000000', 'temperatura', 555.0000, 'ºC'),
	(26419, 111, '2015-01-15 01:09:37.000000', 'temperatura', 230.0000, 'ºC'),
	(26420, 111, '2015-01-15 01:09:38.000000', 'temperatura', 682.0000, 'ºC'),
	(26421, 111, '2015-01-15 01:09:39.000000', 'temperatura', 323.0000, 'ºC'),
	(26422, 111, '2015-01-15 01:09:40.000000', 'temperatura', 769.0000, 'ºC'),
	(26423, 111, '2015-01-15 01:09:41.000000', 'temperatura', 477.0000, 'ºC'),
	(26424, 111, '2015-01-15 01:09:42.000000', 'temperatura', 76.0000, 'ºC'),
	(26425, 111, '2015-01-15 01:09:43.000000', 'temperatura', 151.0000, 'ºC'),
	(26426, 111, '2015-01-15 01:09:44.000000', 'temperatura', 529.0000, 'ºC'),
	(26427, 111, '2015-01-15 01:09:45.000000', 'temperatura', 992.0000, 'ºC'),
	(26428, 111, '2015-01-15 01:09:46.000000', 'temperatura', 975.0000, 'ºC'),
	(26429, 111, '2015-01-15 01:09:47.000000', 'temperatura', 697.0000, 'ºC'),
	(26430, 111, '2015-01-15 01:09:48.000000', 'temperatura', 562.0000, 'ºC'),
	(26431, 111, '2015-01-15 01:09:49.000000', 'temperatura', 721.0000, 'ºC'),
	(26432, 111, '2015-01-15 01:09:50.000000', 'temperatura', 718.0000, 'ºC'),
	(26433, 111, '2015-01-15 01:09:51.000000', 'temperatura', 228.0000, 'ºC'),
	(26434, 111, '2015-01-15 01:09:52.000000', 'temperatura', 186.0000, 'ºC'),
	(26435, 111, '2015-01-15 01:09:53.000000', 'temperatura', 247.0000, 'ºC'),
	(26436, 111, '2015-01-15 01:09:54.000000', 'temperatura', 678.0000, 'ºC'),
	(26437, 111, '2015-01-15 01:09:55.000000', 'temperatura', 249.0000, 'ºC'),
	(26438, 111, '2015-01-15 01:09:56.000000', 'temperatura', 411.0000, 'ºC'),
	(26439, 111, '2015-01-15 01:09:57.000000', 'temperatura', 109.0000, 'ºC'),
	(26440, 111, '2015-01-15 01:09:58.000000', 'temperatura', 514.0000, 'ºC'),
	(26441, 111, '2015-01-15 01:09:59.000000', 'temperatura', 1042.0000, 'ºC'),
	(26442, 111, '2015-01-15 01:10:00.000000', 'temperatura', 69.0000, 'ºC'),
	(26443, 111, '2015-01-15 01:10:01.000000', 'temperatura', 819.0000, 'ºC'),
	(26444, 111, '2015-01-15 01:10:02.000000', 'temperatura', 288.0000, 'ºC'),
	(26445, 111, '2015-01-15 01:10:03.000000', 'temperatura', 184.0000, 'ºC'),
	(26446, 111, '2015-01-15 01:10:04.000000', 'temperatura', 58.0000, 'ºC'),
	(26447, 111, '2015-01-15 01:10:05.000000', 'temperatura', 937.0000, 'ºC'),
	(26448, 111, '2015-01-15 01:10:06.000000', 'temperatura', 910.0000, 'ºC'),
	(26449, 111, '2015-01-15 01:10:07.000000', 'temperatura', 540.0000, 'ºC'),
	(26450, 111, '2015-01-15 01:10:08.000000', 'temperatura', 1170.0000, 'ºC'),
	(26451, 111, '2015-01-15 01:10:09.000000', 'temperatura', 632.0000, 'ºC'),
	(26452, 111, '2015-01-15 01:10:10.000000', 'temperatura', 849.0000, 'ºC'),
	(26453, 111, '2015-01-15 01:10:11.000000', 'temperatura', 1151.0000, 'ºC'),
	(26454, 111, '2015-01-15 01:10:12.000000', 'temperatura', 806.0000, 'ºC'),
	(26455, 111, '2015-01-15 01:10:13.000000', 'temperatura', 578.0000, 'ºC'),
	(26456, 111, '2015-01-15 01:10:14.000000', 'temperatura', 474.0000, 'ºC'),
	(26457, 111, '2015-01-15 01:10:15.000000', 'temperatura', 636.0000, 'ºC'),
	(26458, 111, '2015-01-15 01:10:16.000000', 'temperatura', 558.0000, 'ºC'),
	(26459, 111, '2015-01-15 01:10:17.000000', 'temperatura', 882.0000, 'ºC'),
	(26460, 111, '2015-01-15 01:10:18.000000', 'temperatura', 337.0000, 'ºC'),
	(26461, 111, '2015-01-15 01:10:19.000000', 'temperatura', 241.0000, 'ºC'),
	(26462, 111, '2015-01-15 01:10:20.000000', 'temperatura', 193.0000, 'ºC'),
	(26463, 111, '2015-01-15 01:10:21.000000', 'temperatura', 243.0000, 'ºC'),
	(26464, 111, '2015-01-15 01:10:22.000000', 'temperatura', 635.0000, 'ºC'),
	(26465, 111, '2015-01-15 01:10:23.000000', 'temperatura', 49.0000, 'ºC'),
	(26466, 111, '2015-01-15 01:10:24.000000', 'temperatura', 738.0000, 'ºC'),
	(26467, 111, '2015-01-15 01:10:25.000000', 'temperatura', 1144.0000, 'ºC'),
	(26468, 111, '2015-01-15 01:10:26.000000', 'temperatura', 1105.0000, 'ºC'),
	(26469, 111, '2015-01-15 01:10:27.000000', 'temperatura', 894.0000, 'ºC'),
	(26470, 111, '2015-01-15 01:10:28.000000', 'temperatura', 1155.0000, 'ºC'),
	(26471, 111, '2015-01-15 01:10:29.000000', 'temperatura', 694.0000, 'ºC'),
	(26472, 111, '2015-01-15 01:10:30.000000', 'temperatura', 7.0000, 'ºC'),
	(26473, 111, '2015-01-15 01:10:31.000000', 'temperatura', 351.0000, 'ºC'),
	(26474, 111, '2015-01-15 01:10:32.000000', 'temperatura', 534.0000, 'ºC'),
	(26475, 111, '2015-01-15 01:10:33.000000', 'temperatura', 417.0000, 'ºC'),
	(26476, 111, '2015-01-15 01:10:34.000000', 'temperatura', 484.0000, 'ºC'),
	(26477, 111, '2015-01-15 01:10:35.000000', 'temperatura', 1170.0000, 'ºC'),
	(26478, 111, '2015-01-15 01:10:36.000000', 'temperatura', 798.0000, 'ºC'),
	(26479, 111, '2015-01-15 01:10:37.000000', 'temperatura', 482.0000, 'ºC'),
	(26480, 111, '2015-01-15 01:10:38.000000', 'temperatura', 17.0000, 'ºC'),
	(26481, 111, '2015-01-15 01:10:39.000000', 'temperatura', 1039.0000, 'ºC'),
	(26482, 111, '2015-01-15 01:10:40.000000', 'temperatura', 343.0000, 'ºC'),
	(26483, 111, '2015-01-15 01:10:41.000000', 'temperatura', 999.0000, 'ºC'),
	(26484, 111, '2015-01-15 01:10:42.000000', 'temperatura', 366.0000, 'ºC'),
	(26485, 111, '2015-01-15 01:10:43.000000', 'temperatura', 35.0000, 'ºC'),
	(26486, 111, '2015-01-15 01:10:44.000000', 'temperatura', 277.0000, 'ºC'),
	(26487, 111, '2015-01-15 01:10:45.000000', 'temperatura', 80.0000, 'ºC'),
	(26488, 111, '2015-01-15 01:10:46.000000', 'temperatura', 769.0000, 'ºC'),
	(26489, 111, '2015-01-15 01:10:47.000000', 'temperatura', 4.0000, 'ºC'),
	(26490, 111, '2015-01-15 01:10:48.000000', 'temperatura', 116.0000, 'ºC'),
	(26491, 111, '2015-01-15 01:10:49.000000', 'temperatura', 568.0000, 'ºC'),
	(26492, 111, '2015-01-15 01:10:50.000000', 'temperatura', 93.0000, 'ºC'),
	(26493, 111, '2015-01-15 01:10:51.000000', 'temperatura', 1162.0000, 'ºC'),
	(26494, 111, '2015-01-15 01:10:52.000000', 'temperatura', 731.0000, 'ºC'),
	(26495, 111, '2015-01-15 01:10:53.000000', 'temperatura', 170.0000, 'ºC'),
	(26496, 111, '2015-01-15 01:10:54.000000', 'temperatura', 1056.0000, 'ºC'),
	(26497, 111, '2015-01-15 01:10:55.000000', 'temperatura', 1172.0000, 'ºC'),
	(26498, 111, '2015-01-15 01:10:56.000000', 'temperatura', 291.0000, 'ºC'),
	(26499, 111, '2015-01-15 01:10:57.000000', 'temperatura', 341.0000, 'ºC'),
	(26500, 111, '2015-01-15 01:10:58.000000', 'temperatura', 832.0000, 'ºC'),
	(26501, 111, '2015-01-15 01:10:59.000000', 'temperatura', 738.0000, 'ºC'),
	(26502, 111, '2015-01-15 01:11:00.000000', 'temperatura', 1192.0000, 'ºC'),
	(26503, 111, '2015-01-15 01:11:01.000000', 'temperatura', 149.0000, 'ºC'),
	(26504, 111, '2015-01-15 01:11:02.000000', 'temperatura', 768.0000, 'ºC'),
	(26505, 111, '2015-01-15 01:11:03.000000', 'temperatura', 992.0000, 'ºC'),
	(26506, 111, '2015-01-15 01:11:04.000000', 'temperatura', 258.0000, 'ºC'),
	(26507, 111, '2015-01-15 01:11:05.000000', 'temperatura', 716.0000, 'ºC'),
	(26508, 111, '2015-01-15 01:11:06.000000', 'temperatura', 407.0000, 'ºC'),
	(26509, 111, '2015-01-15 01:11:07.000000', 'temperatura', 1086.0000, 'ºC'),
	(26510, 111, '2015-01-15 01:11:08.000000', 'temperatura', 608.0000, 'ºC'),
	(26511, 111, '2015-01-15 01:11:09.000000', 'temperatura', 986.0000, 'ºC'),
	(26512, 111, '2015-01-15 01:11:10.000000', 'temperatura', 703.0000, 'ºC'),
	(26513, 111, '2015-01-15 01:11:11.000000', 'temperatura', 559.0000, 'ºC'),
	(26514, 111, '2015-01-15 01:11:12.000000', 'temperatura', 686.0000, 'ºC'),
	(26515, 111, '2015-01-15 01:11:13.000000', 'temperatura', 555.0000, 'ºC'),
	(26516, 111, '2015-01-15 01:11:14.000000', 'temperatura', 715.0000, 'ºC'),
	(26517, 111, '2015-01-15 01:11:15.000000', 'temperatura', 712.0000, 'ºC'),
	(26518, 111, '2015-01-15 01:11:16.000000', 'temperatura', 217.0000, 'ºC'),
	(26519, 111, '2015-01-15 01:11:17.000000', 'temperatura', 149.0000, 'ºC'),
	(26520, 111, '2015-01-15 01:11:18.000000', 'temperatura', 94.0000, 'ºC'),
	(26521, 111, '2015-01-15 01:11:19.000000', 'temperatura', 23.0000, 'ºC'),
	(26522, 111, '2015-01-15 01:11:20.000000', 'temperatura', 1032.0000, 'ºC'),
	(26523, 111, '2015-01-15 01:11:21.000000', 'temperatura', 294.0000, 'ºC'),
	(26524, 111, '2015-01-15 01:11:22.000000', 'temperatura', 775.0000, 'ºC'),
	(26525, 111, '2015-01-15 01:11:23.000000', 'temperatura', 591.0000, 'ºC'),
	(26526, 111, '2015-01-15 01:11:24.000000', 'temperatura', 632.0000, 'ºC'),
	(26527, 111, '2015-01-15 01:11:25.000000', 'temperatura', 185.0000, 'ºC'),
	(26528, 111, '2015-01-15 01:11:26.000000', 'temperatura', 233.0000, 'ºC'),
	(26529, 111, '2015-01-15 01:11:27.000000', 'temperatura', 608.0000, 'ºC'),
	(26530, 111, '2015-01-15 01:11:28.000000', 'temperatura', 1140.0000, 'ºC'),
	(26531, 111, '2015-01-15 01:11:29.000000', 'temperatura', 280.0000, 'ºC'),
	(26532, 111, '2015-01-15 01:11:30.000000', 'temperatura', 378.0000, 'ºC'),
	(26533, 111, '2015-01-15 01:11:31.000000', 'temperatura', 1050.0000, 'ºC'),
	(26534, 111, '2015-01-15 01:11:32.000000', 'temperatura', 518.0000, 'ºC'),
	(26535, 111, '2015-01-15 01:11:33.000000', 'temperatura', 639.0000, 'ºC'),
	(26536, 111, '2015-01-15 01:11:34.000000', 'temperatura', 443.0000, 'ºC'),
	(26537, 111, '2015-01-15 01:11:35.000000', 'temperatura', 297.0000, 'ºC'),
	(26538, 111, '2015-01-15 01:11:36.000000', 'temperatura', 155.0000, 'ºC'),
	(26539, 111, '2015-01-15 01:11:37.000000', 'temperatura', 1087.0000, 'ºC'),
	(26540, 111, '2015-01-15 01:11:38.000000', 'temperatura', 172.0000, 'ºC'),
	(26541, 111, '2015-01-15 01:11:39.000000', 'temperatura', 1196.0000, 'ºC'),
	(26542, 111, '2015-01-15 01:11:40.000000', 'temperatura', 668.0000, 'ºC'),
	(26543, 111, '2015-01-15 01:11:41.000000', 'temperatura', 949.0000, 'ºC'),
	(26544, 111, '2015-01-15 01:11:42.000000', 'temperatura', 345.0000, 'ºC'),
	(26545, 111, '2015-01-15 01:11:43.000000', 'temperatura', 76.0000, 'ºC'),
	(26546, 111, '2015-01-15 01:11:44.000000', 'temperatura', 547.0000, 'ºC'),
	(26547, 111, '2015-01-15 01:11:45.000000', 'temperatura', 106.0000, 'ºC'),
	(26548, 111, '2015-01-15 01:11:46.000000', 'temperatura', 91.0000, 'ºC'),
	(26549, 111, '2015-01-15 01:11:47.000000', 'temperatura', 137.0000, 'ºC'),
	(26550, 111, '2015-01-15 01:11:48.000000', 'temperatura', 413.0000, 'ºC'),
	(26551, 111, '2015-01-15 01:11:49.000000', 'temperatura', 453.0000, 'ºC'),
	(26552, 111, '2015-01-15 01:11:50.000000', 'temperatura', 1027.0000, 'ºC'),
	(26553, 111, '2015-01-15 01:11:51.000000', 'temperatura', 177.0000, 'ºC'),
	(26554, 111, '2015-01-15 01:11:52.000000', 'temperatura', 206.0000, 'ºC'),
	(26555, 111, '2015-01-15 01:11:53.000000', 'temperatura', 499.0000, 'ºC'),
	(26556, 111, '2015-01-15 01:11:54.000000', 'temperatura', 677.0000, 'ºC'),
	(26557, 111, '2015-01-15 01:11:55.000000', 'temperatura', 691.0000, 'ºC'),
	(26558, 111, '2015-01-15 01:11:56.000000', 'temperatura', 221.0000, 'ºC'),
	(26559, 111, '2015-01-15 01:11:57.000000', 'temperatura', 234.0000, 'ºC'),
	(26560, 111, '2015-01-15 01:11:58.000000', 'temperatura', 508.0000, 'ºC'),
	(26561, 111, '2015-01-15 01:11:59.000000', 'temperatura', 640.0000, 'ºC'),
	(26562, 111, '2015-01-15 01:12:00.000000', 'temperatura', 475.0000, 'ºC'),
	(26563, 111, '2015-01-15 01:12:01.000000', 'temperatura', 454.0000, 'ºC'),
	(26564, 111, '2015-01-15 01:12:02.000000', 'temperatura', 846.0000, 'ºC'),
	(26565, 111, '2015-01-15 01:12:03.000000', 'temperatura', 467.0000, 'ºC'),
	(26566, 111, '2015-01-15 01:12:04.000000', 'temperatura', 1000.0000, 'ºC'),
	(26567, 111, '2015-01-15 01:12:05.000000', 'temperatura', 1199.0000, 'ºC'),
	(26568, 111, '2015-01-15 01:12:06.000000', 'temperatura', 595.0000, 'ºC'),
	(26569, 111, '2015-01-15 01:12:07.000000', 'temperatura', 578.0000, 'ºC'),
	(26570, 111, '2015-01-15 01:12:08.000000', 'temperatura', 1107.0000, 'ºC'),
	(26571, 111, '2015-01-15 01:12:09.000000', 'temperatura', 203.0000, 'ºC'),
	(26572, 111, '2015-01-15 01:12:10.000000', 'temperatura', 91.0000, 'ºC'),
	(26573, 111, '2015-01-15 01:12:11.000000', 'temperatura', 1047.0000, 'ºC'),
	(26574, 111, '2015-01-15 01:12:12.000000', 'temperatura', 164.0000, 'ºC'),
	(26575, 111, '2015-01-15 01:12:13.000000', 'temperatura', 78.0000, 'ºC'),
	(26576, 111, '2015-01-15 01:12:14.000000', 'temperatura', 1101.0000, 'ºC'),
	(26577, 111, '2015-01-15 01:12:15.000000', 'temperatura', 469.0000, 'ºC'),
	(26578, 111, '2015-01-15 01:12:16.000000', 'temperatura', 242.0000, 'ºC'),
	(26579, 111, '2015-01-15 01:12:17.000000', 'temperatura', 1005.0000, 'ºC'),
	(26580, 111, '2015-01-15 01:12:18.000000', 'temperatura', 698.0000, 'ºC'),
	(26581, 111, '2015-01-15 01:12:19.000000', 'temperatura', 477.0000, 'ºC'),
	(26582, 111, '2015-01-15 01:12:20.000000', 'temperatura', 290.0000, 'ºC'),
	(26583, 111, '2015-01-15 01:12:21.000000', 'temperatura', 19.0000, 'ºC'),
	(26584, 111, '2015-01-15 01:12:22.000000', 'temperatura', 426.0000, 'ºC'),
	(26585, 111, '2015-01-15 01:12:23.000000', 'temperatura', 873.0000, 'ºC'),
	(26586, 111, '2015-01-15 01:12:24.000000', 'temperatura', 690.0000, 'ºC'),
	(26587, 111, '2015-01-15 01:12:25.000000', 'temperatura', 830.0000, 'ºC'),
	(26588, 111, '2015-01-15 01:12:26.000000', 'temperatura', 882.0000, 'ºC'),
	(26589, 111, '2015-01-15 01:12:27.000000', 'temperatura', 720.0000, 'ºC'),
	(26590, 111, '2015-01-15 01:12:28.000000', 'temperatura', 952.0000, 'ºC'),
	(26591, 111, '2015-01-15 01:12:29.000000', 'temperatura', 203.0000, 'ºC'),
	(26592, 111, '2015-01-15 01:12:30.000000', 'temperatura', 560.0000, 'ºC'),
	(26593, 111, '2015-01-15 01:12:31.000000', 'temperatura', 991.0000, 'ºC'),
	(26594, 111, '2015-01-15 01:12:32.000000', 'temperatura', 874.0000, 'ºC'),
	(26595, 111, '2015-01-15 01:12:33.000000', 'temperatura', 199.0000, 'ºC'),
	(26596, 111, '2015-01-15 01:12:34.000000', 'temperatura', 774.0000, 'ºC'),
	(26597, 111, '2015-01-15 01:12:35.000000', 'temperatura', 872.0000, 'ºC'),
	(26598, 111, '2015-01-15 01:12:36.000000', 'temperatura', 838.0000, 'ºC'),
	(26599, 111, '2015-01-15 01:12:37.000000', 'temperatura', 375.0000, 'ºC'),
	(26600, 111, '2015-01-15 01:12:38.000000', 'temperatura', 561.0000, 'ºC'),
	(26601, 111, '2015-01-15 01:12:39.000000', 'temperatura', 483.0000, 'ºC'),
	(26602, 111, '2015-01-15 01:12:40.000000', 'temperatura', 730.0000, 'ºC'),
	(26603, 111, '2015-01-15 01:12:41.000000', 'temperatura', 1000.0000, 'ºC'),
	(26604, 111, '2015-01-15 01:12:42.000000', 'temperatura', 414.0000, 'ºC'),
	(26605, 111, '2015-01-15 01:12:43.000000', 'temperatura', 268.0000, 'ºC'),
	(26606, 111, '2015-01-15 01:12:44.000000', 'temperatura', 101.0000, 'ºC'),
	(26607, 111, '2015-01-15 01:12:45.000000', 'temperatura', 901.0000, 'ºC'),
	(26608, 111, '2015-01-15 01:12:46.000000', 'temperatura', 601.0000, 'ºC'),
	(26609, 111, '2015-01-15 01:12:47.000000', 'temperatura', 301.0000, 'ºC'),
	(26610, 111, '2015-01-15 01:12:48.000000', 'temperatura', 906.0000, 'ºC'),
	(26611, 111, '2015-01-15 01:12:49.000000', 'temperatura', 24.0000, 'ºC'),
	(26612, 111, '2015-01-15 01:12:50.000000', 'temperatura', 1005.0000, 'ºC'),
	(26613, 111, '2015-01-15 01:12:51.000000', 'temperatura', 154.0000, 'ºC'),
	(26614, 111, '2015-01-15 01:12:52.000000', 'temperatura', 154.0000, 'ºC'),
	(26615, 111, '2015-01-15 01:12:53.000000', 'temperatura', 309.0000, 'ºC'),
	(26616, 111, '2015-01-15 01:12:54.000000', 'temperatura', 1085.0000, 'ºC'),
	(26617, 111, '2015-01-15 01:12:55.000000', 'temperatura', 898.0000, 'ºC'),
	(26618, 111, '2015-01-15 01:12:56.000000', 'temperatura', 36.0000, 'ºC'),
	(26619, 111, '2015-01-15 01:12:57.000000', 'temperatura', 1086.0000, 'ºC'),
	(26620, 111, '2015-01-15 01:12:58.000000', 'temperatura', 524.0000, 'ºC'),
	(26621, 111, '2015-01-15 01:12:59.000000', 'temperatura', 560.0000, 'ºC'),
	(26622, 111, '2015-01-15 01:13:00.000000', 'temperatura', 29.0000, 'ºC'),
	(26623, 111, '2015-01-15 01:13:01.000000', 'temperatura', 865.0000, 'ºC'),
	(26624, 111, '2015-01-15 01:13:02.000000', 'temperatura', 638.0000, 'ºC'),
	(26625, 111, '2015-01-15 01:13:03.000000', 'temperatura', 596.0000, 'ºC'),
	(26626, 111, '2015-01-15 01:13:04.000000', 'temperatura', 1065.0000, 'ºC'),
	(26627, 111, '2015-01-15 01:13:05.000000', 'temperatura', 1140.0000, 'ºC'),
	(26628, 111, '2015-01-15 01:13:06.000000', 'temperatura', 105.0000, 'ºC'),
	(26629, 111, '2015-01-15 01:13:07.000000', 'temperatura', 705.0000, 'ºC'),
	(26630, 111, '2015-01-15 01:13:08.000000', 'temperatura', 811.0000, 'ºC'),
	(26631, 111, '2015-01-15 01:13:09.000000', 'temperatura', 741.0000, 'ºC'),
	(26632, 111, '2015-01-15 01:13:10.000000', 'temperatura', 74.0000, 'ºC'),
	(26633, 111, '2015-01-15 01:13:11.000000', 'temperatura', 545.0000, 'ºC'),
	(26634, 111, '2015-01-15 01:13:12.000000', 'temperatura', 104.0000, 'ºC'),
	(26635, 111, '2015-01-15 01:13:13.000000', 'temperatura', 85.0000, 'ºC'),
	(26636, 111, '2015-01-15 01:13:14.000000', 'temperatura', 113.0000, 'ºC'),
	(26637, 111, '2015-01-15 01:13:15.000000', 'temperatura', 312.0000, 'ºC'),
	(26638, 111, '2015-01-15 01:13:16.000000', 'temperatura', 21.0000, 'ºC'),
	(26639, 111, '2015-01-15 01:13:17.000000', 'temperatura', 369.0000, 'ºC'),
	(26640, 111, '2015-01-15 01:13:18.000000', 'temperatura', 583.0000, 'ºC'),
	(26641, 111, '2015-01-15 01:13:19.000000', 'temperatura', 610.0000, 'ºC'),
	(26642, 111, '2015-01-15 01:13:20.000000', 'temperatura', 102.0000, 'ºC'),
	(26643, 111, '2015-01-15 01:13:21.000000', 'temperatura', 1077.0000, 'ºC'),
	(26644, 111, '2015-01-15 01:13:22.000000', 'temperatura', 283.0000, 'ºC'),
	(26645, 111, '2015-01-15 01:13:23.000000', 'temperatura', 582.0000, 'ºC'),
	(26646, 111, '2015-01-15 01:13:24.000000', 'temperatura', 864.0000, 'ºC'),
	(26647, 111, '2015-01-15 01:13:25.000000', 'temperatura', 173.0000, 'ºC'),
	(26648, 111, '2015-01-15 01:13:26.000000', 'temperatura', 672.0000, 'ºC'),
	(26649, 111, '2015-01-15 01:13:27.000000', 'temperatura', 443.0000, 'ºC'),
	(26650, 111, '2015-01-15 01:13:28.000000', 'temperatura', 199.0000, 'ºC'),
	(26651, 111, '2015-01-15 01:13:29.000000', 'temperatura', 865.0000, 'ºC'),
	(26652, 111, '2015-01-15 01:13:30.000000', 'temperatura', 130.0000, 'ºC'),
	(26653, 111, '2015-01-15 01:13:31.000000', 'temperatura', 457.0000, 'ºC'),
	(26654, 111, '2015-01-15 01:13:32.000000', 'temperatura', 696.0000, 'ºC'),
	(26655, 111, '2015-01-15 01:13:33.000000', 'temperatura', 908.0000, 'ºC'),
	(26656, 111, '2015-01-15 01:13:34.000000', 'temperatura', 53.0000, 'ºC'),
	(26657, 111, '2015-01-15 01:13:35.000000', 'temperatura', 1143.0000, 'ºC'),
	(26658, 111, '2015-01-15 01:13:36.000000', 'temperatura', 754.0000, 'ºC'),
	(26659, 111, '2015-01-15 01:13:37.000000', 'temperatura', 344.0000, 'ºC'),
	(26660, 111, '2015-01-15 01:13:38.000000', 'temperatura', 657.0000, 'ºC'),
	(26661, 111, '2015-01-15 01:13:39.000000', 'temperatura', 1053.0000, 'ºC'),
	(26662, 111, '2015-01-15 01:13:40.000000', 'temperatura', 896.0000, 'ºC'),
	(26663, 111, '2015-01-15 01:13:41.000000', 'temperatura', 120.0000, 'ºC'),
	(26664, 111, '2015-01-15 01:13:42.000000', 'temperatura', 314.0000, 'ºC'),
	(26665, 111, '2015-01-15 01:13:43.000000', 'temperatura', 8.0000, 'ºC'),
	(26666, 111, '2015-01-15 01:13:44.000000', 'temperatura', 301.0000, 'ºC'),
	(26667, 111, '2015-01-15 01:13:45.000000', 'temperatura', 281.0000, 'ºC'),
	(26668, 111, '2015-01-15 01:13:46.000000', 'temperatura', 503.0000, 'ºC'),
	(26669, 111, '2015-01-15 01:13:47.000000', 'temperatura', 474.0000, 'ºC'),
	(26670, 111, '2015-01-15 01:13:48.000000', 'temperatura', 861.0000, 'ºC'),
	(26671, 111, '2015-01-15 01:13:49.000000', 'temperatura', 481.0000, 'ºC'),
	(26672, 111, '2015-01-15 01:13:50.000000', 'temperatura', 1025.0000, 'ºC'),
	(26673, 111, '2015-01-15 01:13:51.000000', 'temperatura', 82.0000, 'ºC'),
	(26674, 111, '2015-01-15 01:13:52.000000', 'temperatura', 937.0000, 'ºC'),
	(26675, 111, '2015-01-15 01:13:53.000000', 'temperatura', 838.0000, 'ºC'),
	(26676, 111, '2015-01-15 01:13:54.000000', 'temperatura', 179.0000, 'ºC'),
	(26677, 111, '2015-01-15 01:13:55.000000', 'temperatura', 782.0000, 'ºC'),
	(26678, 111, '2015-01-15 01:13:56.000000', 'temperatura', 975.0000, 'ºC'),
	(26679, 111, '2015-01-15 01:13:57.000000', 'temperatura', 129.0000, 'ºC'),
	(26680, 111, '2015-01-15 01:13:58.000000', 'temperatura', 120.0000, 'ºC'),
	(26681, 111, '2015-01-15 01:13:59.000000', 'temperatura', 216.0000, 'ºC'),
	(26682, 111, '2015-01-15 01:14:00.000000', 'temperatura', 717.0000, 'ºC'),
	(26683, 111, '2015-01-15 01:14:01.000000', 'temperatura', 541.0000, 'ºC'),
	(26684, 111, '2015-01-15 01:14:02.000000', 'temperatura', 551.0000, 'ºC'),
	(26685, 111, '2015-01-15 01:14:03.000000', 'temperatura', 1134.0000, 'ºC'),
	(26686, 111, '2015-01-15 01:14:04.000000', 'temperatura', 416.0000, 'ºC'),
	(26687, 111, '2015-01-15 01:14:05.000000', 'temperatura', 1079.0000, 'ºC'),
	(26688, 111, '2015-01-15 01:14:06.000000', 'temperatura', 549.0000, 'ºC'),
	(26689, 111, '2015-01-15 01:14:07.000000', 'temperatura', 706.0000, 'ºC'),
	(26690, 111, '2015-01-15 01:14:08.000000', 'temperatura', 683.0000, 'ºC'),
	(26691, 111, '2015-01-15 01:14:09.000000', 'temperatura', 98.0000, 'ºC'),
	(26692, 111, '2015-01-15 01:14:10.000000', 'temperatura', 844.0000, 'ºC'),
	(26693, 111, '2015-01-15 01:14:11.000000', 'temperatura', 325.0000, 'ºC'),
	(26694, 111, '2015-01-15 01:14:12.000000', 'temperatura', 295.0000, 'ºC'),
	(26695, 111, '2015-01-15 01:14:13.000000', 'temperatura', 500.0000, 'ºC'),
	(26696, 111, '2015-01-15 01:14:14.000000', 'temperatura', 414.0000, 'ºC'),
	(26697, 111, '2015-01-15 01:14:15.000000', 'temperatura', 571.0000, 'ºC'),
	(26698, 111, '2015-01-15 01:14:16.000000', 'temperatura', 412.0000, 'ºC'),
	(26699, 111, '2015-01-15 01:14:17.000000', 'temperatura', 350.0000, 'ºC'),
	(26700, 111, '2015-01-15 01:14:18.000000', 'temperatura', 515.0000, 'ºC'),
	(26701, 111, '2015-01-15 01:14:19.000000', 'temperatura', 327.0000, 'ºC'),
	(26702, 111, '2015-01-15 01:14:20.000000', 'temperatura', 87.0000, 'ºC'),
	(26703, 111, '2015-01-15 01:14:21.000000', 'temperatura', 656.0000, 'ºC'),
	(26704, 111, '2015-01-15 01:14:22.000000', 'temperatura', 619.0000, 'ºC'),
	(26705, 111, '2015-01-15 01:14:23.000000', 'temperatura', 1129.0000, 'ºC'),
	(26706, 111, '2015-01-15 01:14:24.000000', 'temperatura', 188.0000, 'ºC'),
	(26707, 111, '2015-01-15 01:14:25.000000', 'temperatura', 1155.0000, 'ºC'),
	(26708, 111, '2015-01-15 01:14:26.000000', 'temperatura', 411.0000, 'ºC'),
	(26709, 111, '2015-01-15 01:14:27.000000', 'temperatura', 988.0000, 'ºC'),
	(26710, 111, '2015-01-15 01:14:28.000000', 'temperatura', 111.0000, 'ºC'),
	(26711, 111, '2015-01-15 01:14:29.000000', 'temperatura', 1188.0000, 'ºC'),
	(26712, 111, '2015-01-15 01:14:30.000000', 'temperatura', 811.0000, 'ºC'),
	(26713, 111, '2015-01-15 01:14:31.000000', 'temperatura', 490.0000, 'ºC'),
	(26714, 111, '2015-01-15 01:14:32.000000', 'temperatura', 16.0000, 'ºC'),
	(26715, 111, '2015-01-15 01:14:33.000000', 'temperatura', 1011.0000, 'ºC'),
	(26716, 111, '2015-01-15 01:14:34.000000', 'temperatura', 206.0000, 'ºC'),
	(26717, 111, '2015-01-15 01:14:35.000000', 'temperatura', 400.0000, 'ºC'),
	(26718, 111, '2015-01-15 01:14:36.000000', 'temperatura', 184.0000, 'ºC'),
	(26719, 111, '2015-01-15 01:14:37.000000', 'temperatura', 917.0000, 'ºC'),
	(26720, 111, '2015-01-15 01:14:38.000000', 'temperatura', 437.0000, 'ºC'),
	(26721, 111, '2015-01-15 01:14:39.000000', 'temperatura', 632.0000, 'ºC'),
	(26722, 111, '2015-01-15 01:14:40.000000', 'temperatura', 649.0000, 'ºC'),
	(26723, 111, '2015-01-15 01:14:41.000000', 'temperatura', 152.0000, 'ºC'),
	(26724, 111, '2015-01-15 01:14:42.000000', 'temperatura', 13.0000, 'ºC'),
	(26725, 111, '2015-01-15 01:14:43.000000', 'temperatura', 809.0000, 'ºC'),
	(26726, 111, '2015-01-15 01:14:44.000000', 'temperatura', 406.0000, 'ºC'),
	(26727, 111, '2015-01-15 01:14:45.000000', 'temperatura', 803.0000, 'ºC'),
	(26728, 111, '2015-01-15 01:14:46.000000', 'temperatura', 398.0000, 'ºC'),
	(26729, 111, '2015-01-15 01:14:47.000000', 'temperatura', 783.0000, 'ºC'),
	(26730, 111, '2015-01-15 01:14:48.000000', 'temperatura', 322.0000, 'ºC'),
	(26731, 111, '2015-01-15 01:14:49.000000', 'temperatura', 460.0000, 'ºC'),
	(26732, 111, '2015-01-15 01:14:50.000000', 'temperatura', 133.0000, 'ºC'),
	(26733, 111, '2015-01-15 01:14:51.000000', 'temperatura', 486.0000, 'ºC'),
	(26734, 111, '2015-01-15 01:14:52.000000', 'temperatura', 832.0000, 'ºC'),
	(26735, 111, '2015-01-15 01:14:53.000000', 'temperatura', 303.0000, 'ºC'),
	(26736, 111, '2015-01-15 01:14:54.000000', 'temperatura', 221.0000, 'ºC'),
	(26737, 111, '2015-01-15 01:14:55.000000', 'temperatura', 194.0000, 'ºC'),
	(26738, 111, '2015-01-15 01:14:56.000000', 'temperatura', 307.0000, 'ºC'),
	(26739, 111, '2015-01-15 01:14:57.000000', 'temperatura', 953.0000, 'ºC'),
	(26740, 111, '2015-01-15 01:14:58.000000', 'temperatura', 244.0000, 'ºC'),
	(26741, 111, '2015-01-15 01:14:59.000000', 'temperatura', 762.0000, 'ºC'),
	(26742, 111, '2015-01-15 01:15:00.000000', 'temperatura', 679.0000, 'ºC'),
	(26743, 111, '2015-01-15 01:15:01.000000', 'temperatura', 1111.0000, 'ºC'),
	(26744, 111, '2015-01-15 01:15:02.000000', 'temperatura', 1117.0000, 'ºC'),
	(26745, 111, '2015-01-15 01:15:03.000000', 'temperatura', 1054.0000, 'ºC'),
	(26746, 111, '2015-01-15 01:15:04.000000', 'temperatura', 719.0000, 'ºC'),
	(26747, 111, '2015-01-15 01:15:05.000000', 'temperatura', 432.0000, 'ºC'),
	(26748, 111, '2015-01-15 01:15:06.000000', 'temperatura', 4.0000, 'ºC'),
	(26749, 111, '2015-01-15 01:15:07.000000', 'temperatura', 1125.0000, 'ºC'),
	(26750, 111, '2015-01-15 01:15:08.000000', 'temperatura', 812.0000, 'ºC'),
	(26751, 111, '2015-01-15 01:15:09.000000', 'temperatura', 686.0000, 'ºC'),
	(26752, 111, '2015-01-15 01:15:10.000000', 'temperatura', 994.0000, 'ºC'),
	(26753, 111, '2015-01-15 01:15:11.000000', 'temperatura', 515.0000, 'ºC'),
	(26754, 111, '2015-01-15 01:15:12.000000', 'temperatura', 790.0000, 'ºC'),
	(26755, 111, '2015-01-15 01:15:13.000000', 'temperatura', 9.0000, 'ºC'),
	(26756, 111, '2015-01-15 01:15:14.000000', 'temperatura', 73.0000, 'ºC'),
	(26757, 111, '2015-01-15 01:15:15.000000', 'temperatura', 341.0000, 'ºC'),
	(26758, 111, '2015-01-15 01:15:16.000000', 'temperatura', 283.0000, 'ºC'),
	(26759, 111, '2015-01-15 01:15:17.000000', 'temperatura', 396.0000, 'ºC'),
	(26760, 111, '2015-01-15 01:15:18.000000', 'temperatura', 1131.0000, 'ºC'),
	(26761, 111, '2015-01-15 01:15:19.000000', 'temperatura', 866.0000, 'ºC'),
	(26762, 111, '2015-01-15 01:15:20.000000', 'temperatura', 939.0000, 'ºC'),
	(26763, 111, '2015-01-15 01:15:21.000000', 'temperatura', 898.0000, 'ºC'),
	(26764, 111, '2015-01-15 01:15:22.000000', 'temperatura', 472.0000, 'ºC'),
	(26765, 111, '2015-01-15 01:15:23.000000', 'temperatura', 866.0000, 'ºC'),
	(26766, 111, '2015-01-15 01:15:24.000000', 'temperatura', 514.0000, 'ºC'),
	(26767, 111, '2015-01-15 01:15:25.000000', 'temperatura', 1174.0000, 'ºC'),
	(26768, 111, '2015-01-15 01:15:26.000000', 'temperatura', 727.0000, 'ºC'),
	(26769, 111, '2015-01-15 01:15:27.000000', 'temperatura', 116.0000, 'ºC'),
	(26770, 111, '2015-01-15 01:15:28.000000', 'temperatura', 798.0000, 'ºC'),
	(26771, 111, '2015-01-15 01:15:29.000000', 'temperatura', 41.0000, 'ºC'),
	(26772, 111, '2015-01-15 01:15:30.000000', 'temperatura', 211.0000, 'ºC'),
	(26773, 111, '2015-01-15 01:15:31.000000', 'temperatura', 935.0000, 'ºC'),
	(26774, 111, '2015-01-15 01:15:32.000000', 'temperatura', 442.0000, 'ºC'),
	(26775, 111, '2015-01-15 01:15:33.000000', 'temperatura', 604.0000, 'ºC'),
	(26776, 111, '2015-01-15 01:15:34.000000', 'temperatura', 493.0000, 'ºC'),
	(26777, 111, '2015-01-15 01:15:35.000000', 'temperatura', 657.0000, 'ºC'),
	(26778, 111, '2015-01-15 01:15:36.000000', 'temperatura', 603.0000, 'ºC'),
	(26779, 111, '2015-01-15 01:15:37.000000', 'temperatura', 1048.0000, 'ºC'),
	(26780, 111, '2015-01-15 01:15:38.000000', 'temperatura', 1028.0000, 'ºC'),
	(26781, 111, '2015-01-15 01:15:39.000000', 'temperatura', 798.0000, 'ºC'),
	(26782, 111, '2015-01-15 01:15:40.000000', 'temperatura', 907.0000, 'ºC'),
	(26783, 111, '2015-01-15 01:15:41.000000', 'temperatura', 942.0000, 'ºC'),
	(26784, 111, '2015-01-15 01:15:42.000000', 'temperatura', 787.0000, 'ºC'),
	(26785, 111, '2015-01-15 01:15:43.000000', 'temperatura', 1113.0000, 'ºC'),
	(26786, 111, '2015-01-15 01:15:44.000000', 'temperatura', 803.0000, 'ºC'),
	(26787, 111, '2015-01-15 01:15:45.000000', 'temperatura', 675.0000, 'ºC'),
	(26788, 111, '2015-01-15 01:15:46.000000', 'temperatura', 966.0000, 'ºC'),
	(26789, 111, '2015-01-15 01:15:47.000000', 'temperatura', 408.0000, 'ºC'),
	(26790, 111, '2015-01-15 01:15:48.000000', 'temperatura', 343.0000, 'ºC'),
	(26791, 111, '2015-01-15 01:15:49.000000', 'temperatura', 491.0000, 'ºC'),
	(26792, 111, '2015-01-15 01:15:50.000000', 'temperatura', 225.0000, 'ºC'),
	(26793, 111, '2015-01-15 01:15:51.000000', 'temperatura', 853.0000, 'ºC'),
	(26794, 111, '2015-01-15 01:15:52.000000', 'temperatura', 1191.0000, 'ºC'),
	(26795, 111, '2015-01-15 01:15:53.000000', 'temperatura', 996.0000, 'ºC'),
	(26796, 111, '2015-01-15 01:15:54.000000', 'temperatura', 209.0000, 'ºC'),
	(26797, 111, '2015-01-15 01:15:55.000000', 'temperatura', 457.0000, 'ºC'),
	(26798, 111, '2015-01-15 01:15:56.000000', 'temperatura', 457.0000, 'ºC'),
	(26799, 111, '2015-01-15 01:15:57.000000', 'temperatura', 917.0000, 'ºC'),
	(26800, 111, '2015-01-15 01:15:58.000000', 'temperatura', 814.0000, 'ºC'),
	(26801, 111, '2015-01-15 01:15:59.000000', 'temperatura', 119.0000, 'ºC'),
	(26802, 111, '2015-01-15 01:16:00.000000', 'temperatura', 553.0000, 'ºC'),
	(26803, 111, '2015-01-15 01:16:01.000000', 'temperatura', 8.0000, 'ºC'),
	(26804, 111, '2015-01-15 01:16:02.000000', 'temperatura', 783.0000, 'ºC'),
	(26805, 111, '2015-01-15 01:16:03.000000', 'temperatura', 289.0000, 'ºC'),
	(26806, 111, '2015-01-15 01:16:04.000000', 'temperatura', 297.0000, 'ºC'),
	(26807, 111, '2015-01-15 01:16:05.000000', 'temperatura', 619.0000, 'ºC'),
	(26808, 111, '2015-01-15 01:16:06.000000', 'temperatura', 1005.0000, 'ºC'),
	(26809, 111, '2015-01-15 01:16:07.000000', 'temperatura', 767.0000, 'ºC'),
	(26810, 111, '2015-01-15 01:16:08.000000', 'temperatura', 823.0000, 'ºC'),
	(26811, 111, '2015-01-15 01:16:09.000000', 'temperatura', 613.0000, 'ºC'),
	(26812, 111, '2015-01-15 01:16:10.000000', 'temperatura', 598.0000, 'ºC'),
	(26813, 111, '2015-01-15 01:16:11.000000', 'temperatura', 1149.0000, 'ºC'),
	(26814, 111, '2015-01-15 01:16:12.000000', 'temperatura', 352.0000, 'ºC'),
	(26815, 111, '2015-01-15 01:16:13.000000', 'temperatura', 712.0000, 'ºC'),
	(26816, 111, '2015-01-15 01:16:14.000000', 'temperatura', 108.0000, 'ºC'),
	(26817, 111, '2015-01-15 01:16:15.000000', 'temperatura', 802.0000, 'ºC'),
	(26818, 111, '2015-01-15 01:16:16.000000', 'temperatura', 88.0000, 'ºC'),
	(26819, 111, '2015-01-15 01:16:17.000000', 'temperatura', 433.0000, 'ºC'),
	(26820, 111, '2015-01-15 01:16:18.000000', 'temperatura', 703.0000, 'ºC'),
	(26821, 111, '2015-01-15 01:16:19.000000', 'temperatura', 1018.0000, 'ºC'),
	(26822, 111, '2015-01-15 01:16:20.000000', 'temperatura', 578.0000, 'ºC'),
	(26823, 111, '2015-01-15 01:16:21.000000', 'temperatura', 1039.0000, 'ºC'),
	(26824, 111, '2015-01-15 01:16:22.000000', 'temperatura', 1060.0000, 'ºC'),
	(26825, 111, '2015-01-15 01:16:23.000000', 'temperatura', 985.0000, 'ºC'),
	(26826, 111, '2015-01-15 01:16:24.000000', 'temperatura', 546.0000, 'ºC'),
	(26827, 111, '2015-01-15 01:16:25.000000', 'temperatura', 975.0000, 'ºC'),
	(26828, 111, '2015-01-15 01:16:26.000000', 'temperatura', 836.0000, 'ºC'),
	(26829, 111, '2015-01-15 01:16:27.000000', 'temperatura', 57.0000, 'ºC'),
	(26830, 111, '2015-01-15 01:16:28.000000', 'temperatura', 176.0000, 'ºC'),
	(26831, 111, '2015-01-15 01:16:29.000000', 'temperatura', 709.0000, 'ºC'),
	(26832, 111, '2015-01-15 01:16:30.000000', 'temperatura', 619.0000, 'ºC'),
	(26833, 111, '2015-01-15 01:16:31.000000', 'temperatura', 967.0000, 'ºC'),
	(26834, 111, '2015-01-15 01:16:32.000000', 'temperatura', 580.0000, 'ºC'),
	(26835, 111, '2015-01-15 01:16:33.000000', 'temperatura', 1198.0000, 'ºC'),
	(26836, 111, '2015-01-15 01:16:34.000000', 'temperatura', 651.0000, 'ºC'),
	(26837, 111, '2015-01-15 01:16:35.000000', 'temperatura', 860.0000, 'ºC'),
	(26838, 111, '2015-01-15 01:16:36.000000', 'temperatura', 1148.0000, 'ºC'),
	(26839, 111, '2015-01-15 01:16:37.000000', 'temperatura', 759.0000, 'ºC'),
	(26840, 111, '2015-01-15 01:16:38.000000', 'temperatura', 352.0000, 'ºC'),
	(26841, 111, '2015-01-15 01:16:39.000000', 'temperatura', 685.0000, 'ºC'),
	(26842, 111, '2015-01-15 01:16:40.000000', 'temperatura', 1170.0000, 'ºC'),
	(26843, 111, '2015-01-15 01:16:41.000000', 'temperatura', 195.0000, 'ºC'),
	(26844, 111, '2015-01-15 01:16:42.000000', 'temperatura', 1063.0000, 'ºC'),
	(26845, 111, '2015-01-15 01:16:43.000000', 'temperatura', 1134.0000, 'ºC'),
	(26846, 111, '2015-01-15 01:16:44.000000', 'temperatura', 79.0000, 'ºC'),
	(26847, 111, '2015-01-15 01:16:45.000000', 'temperatura', 594.0000, 'ºC'),
	(26848, 111, '2015-01-15 01:16:46.000000', 'temperatura', 336.0000, 'ºC'),
	(26849, 111, '2015-01-15 01:16:47.000000', 'temperatura', 1096.0000, 'ºC'),
	(26850, 111, '2015-01-15 01:16:48.000000', 'temperatura', 874.0000, 'ºC'),
	(26851, 111, '2015-01-15 01:16:49.000000', 'temperatura', 1081.0000, 'ºC'),
	(26852, 111, '2015-01-15 01:16:50.000000', 'temperatura', 385.0000, 'ºC'),
	(26853, 111, '2015-01-15 01:16:51.000000', 'temperatura', 1080.0000, 'ºC'),
	(26854, 111, '2015-01-15 01:16:52.000000', 'temperatura', 647.0000, 'ºC'),
	(26855, 111, '2015-01-15 01:16:53.000000', 'temperatura', 1194.0000, 'ºC'),
	(26856, 111, '2015-01-15 01:16:54.000000', 'temperatura', 431.0000, 'ºC'),
	(26857, 111, '2015-01-15 01:16:55.000000', 'temperatura', 971.0000, 'ºC'),
	(26858, 111, '2015-01-15 01:16:56.000000', 'temperatura', 1165.0000, 'ºC'),
	(26859, 111, '2015-01-15 01:16:57.000000', 'temperatura', 512.0000, 'ºC'),
	(26860, 111, '2015-01-15 01:16:58.000000', 'temperatura', 267.0000, 'ºC'),
	(26861, 111, '2015-01-15 01:16:59.000000', 'temperatura', 997.0000, 'ºC'),
	(26862, 111, '2015-01-15 01:17:00.000000', 'temperatura', 583.0000, 'ºC'),
	(26863, 111, '2015-01-15 01:17:01.000000', 'temperatura', 1128.0000, 'ºC'),
	(26864, 111, '2015-01-15 01:17:02.000000', 'temperatura', 290.0000, 'ºC'),
	(26865, 111, '2015-01-15 01:17:03.000000', 'temperatura', 465.0000, 'ºC'),
	(26866, 111, '2015-01-15 01:17:04.000000', 'temperatura', 257.0000, 'ºC'),
	(26867, 111, '2015-01-15 01:17:05.000000', 'temperatura', 1088.0000, 'ºC'),
	(26868, 111, '2015-01-15 01:17:06.000000', 'temperatura', 1072.0000, 'ºC'),
	(26869, 111, '2015-01-15 01:17:07.000000', 'temperatura', 896.0000, 'ºC'),
	(26870, 111, '2015-01-15 01:17:08.000000', 'temperatura', 62.0000, 'ºC'),
	(26871, 111, '2015-01-15 01:17:09.000000', 'temperatura', 26.0000, 'ºC'),
	(26872, 111, '2015-01-15 01:17:10.000000', 'temperatura', 1143.0000, 'ºC'),
	(26873, 111, '2015-01-15 01:17:11.000000', 'temperatura', 840.0000, 'ºC'),
	(26874, 111, '2015-01-15 01:17:12.000000', 'temperatura', 769.0000, 'ºC'),
	(26875, 111, '2015-01-15 01:17:13.000000', 'temperatura', 126.0000, 'ºC'),
	(26876, 111, '2015-01-15 01:17:14.000000', 'temperatura', 725.0000, 'ºC'),
	(26877, 111, '2015-01-15 01:17:15.000000', 'temperatura', 845.0000, 'ºC'),
	(26878, 111, '2015-01-15 01:17:16.000000', 'temperatura', 850.0000, 'ºC'),
	(26879, 111, '2015-01-15 01:17:17.000000', 'temperatura', 515.0000, 'ºC'),
	(26880, 111, '2015-01-15 01:17:18.000000', 'temperatura', 25.0000, 'ºC'),
	(26881, 111, '2015-01-15 01:17:19.000000', 'temperatura', 981.0000, 'ºC'),
	(26882, 111, '2015-01-15 01:17:20.000000', 'temperatura', 29.0000, 'ºC'),
	(26883, 111, '2015-01-15 01:17:21.000000', 'temperatura', 803.0000, 'ºC'),
	(26884, 111, '2015-01-15 01:17:22.000000', 'temperatura', 329.0000, 'ºC'),
	(26885, 111, '2015-01-15 01:17:23.000000', 'temperatura', 438.0000, 'ºC'),
	(26886, 111, '2015-01-15 01:17:24.000000', 'temperatura', 2.0000, 'ºC'),
	(26887, 111, '2015-01-15 01:17:25.000000', 'temperatura', 1096.0000, 'ºC'),
	(26888, 111, '2015-01-15 01:17:26.000000', 'temperatura', 674.0000, 'ºC'),
	(26889, 111, '2015-01-15 01:17:27.000000', 'temperatura', 82.0000, 'ºC'),
	(26890, 111, '2015-01-15 01:17:28.000000', 'temperatura', 789.0000, 'ºC'),
	(26891, 111, '2015-01-15 01:17:29.000000', 'temperatura', 98.0000, 'ºC'),
	(26892, 111, '2015-01-15 01:17:30.000000', 'temperatura', 525.0000, 'ºC'),
	(26893, 111, '2015-01-15 01:17:31.000000', 'temperatura', 1131.0000, 'ºC'),
	(26894, 111, '2015-01-15 01:17:32.000000', 'temperatura', 479.0000, 'ºC'),
	(26895, 111, '2015-01-15 01:17:33.000000', 'temperatura', 205.0000, 'ºC'),
	(26896, 111, '2015-01-15 01:17:34.000000', 'temperatura', 787.0000, 'ºC'),
	(26897, 111, '2015-01-15 01:17:35.000000', 'temperatura', 921.0000, 'ºC'),
	(26898, 111, '2015-01-15 01:17:36.000000', 'temperatura', 1044.0000, 'ºC'),
	(26899, 111, '2015-01-15 01:17:37.000000', 'temperatura', 60.0000, 'ºC'),
	(26900, 111, '2015-01-15 01:17:38.000000', 'temperatura', 766.0000, 'ºC'),
	(26901, 111, '2015-01-15 01:17:39.000000', 'temperatura', 49.0000, 'ºC'),
	(26902, 111, '2015-01-15 01:17:40.000000', 'temperatura', 351.0000, 'ºC'),
	(26903, 111, '2015-01-15 01:17:41.000000', 'temperatura', 406.0000, 'ºC'),
	(26904, 111, '2015-01-15 01:17:42.000000', 'temperatura', 979.0000, 'ºC'),
	(26905, 111, '2015-01-15 01:17:43.000000', 'temperatura', 75.0000, 'ºC'),
	(26906, 111, '2015-01-15 01:17:44.000000', 'temperatura', 1040.0000, 'ºC'),
	(26907, 111, '2015-01-15 01:17:45.000000', 'temperatura', 175.0000, 'ºC'),
	(26908, 111, '2015-01-15 01:17:46.000000', 'temperatura', 155.0000, 'ºC'),
	(26909, 111, '2015-01-15 01:17:47.000000', 'temperatura', 249.0000, 'ºC'),
	(26910, 111, '2015-01-15 01:17:48.000000', 'temperatura', 782.0000, 'ºC'),
	(26911, 111, '2015-01-15 01:17:49.000000', 'temperatura', 765.0000, 'ºC'),
	(26912, 111, '2015-01-15 01:17:50.000000', 'temperatura', 278.0000, 'ºC'),
	(26913, 111, '2015-01-15 01:17:51.000000', 'temperatura', 295.0000, 'ºC'),
	(26914, 111, '2015-01-15 01:17:52.000000', 'temperatura', 640.0000, 'ºC'),
	(26915, 111, '2015-01-15 01:17:53.000000', 'temperatura', 1118.0000, 'ºC'),
	(26916, 111, '2015-01-15 01:17:54.000000', 'temperatura', 69.0000, 'ºC'),
	(26917, 111, '2015-01-15 01:17:55.000000', 'temperatura', 590.0000, 'ºC'),
	(26918, 111, '2015-01-15 01:17:56.000000', 'temperatura', 346.0000, 'ºC'),
	(26919, 111, '2015-01-15 01:17:57.000000', 'temperatura', 1160.0000, 'ºC'),
	(26920, 111, '2015-01-15 01:17:58.000000', 'temperatura', 1161.0000, 'ºC'),
	(26921, 111, '2015-01-15 01:17:59.000000', 'temperatura', 1125.0000, 'ºC'),
	(26922, 111, '2015-01-15 01:18:00.000000', 'temperatura', 943.0000, 'ºC'),
	(26923, 111, '2015-01-15 01:18:01.000000', 'temperatura', 142.0000, 'ºC'),
	(26924, 111, '2015-01-15 01:18:02.000000', 'temperatura', 281.0000, 'ºC'),
	(26925, 111, '2015-01-15 01:18:03.000000', 'temperatura', 981.0000, 'ºC'),
	(26926, 111, '2015-01-15 01:18:04.000000', 'temperatura', 462.0000, 'ºC'),
	(26927, 111, '2015-01-15 01:18:05.000000', 'temperatura', 567.0000, 'ºC'),
	(26928, 111, '2015-01-15 01:18:06.000000', 'temperatura', 251.0000, 'ºC'),
	(26929, 111, '2015-01-15 01:18:07.000000', 'temperatura', 752.0000, 'ºC'),
	(26930, 111, '2015-01-15 01:18:08.000000', 'temperatura', 608.0000, 'ºC'),
	(26931, 111, '2015-01-15 01:18:09.000000', 'temperatura', 783.0000, 'ºC'),
	(26932, 111, '2015-01-15 01:18:10.000000', 'temperatura', 894.0000, 'ºC'),
	(26933, 111, '2015-01-15 01:18:11.000000', 'temperatura', 920.0000, 'ºC'),
	(26934, 111, '2015-01-15 01:18:12.000000', 'temperatura', 719.0000, 'ºC'),
	(26935, 111, '2015-01-15 01:18:13.000000', 'temperatura', 837.0000, 'ºC'),
	(26936, 111, '2015-01-15 01:18:14.000000', 'temperatura', 828.0000, 'ºC'),
	(26937, 111, '2015-01-15 01:18:15.000000', 'temperatura', 430.0000, 'ºC'),
	(26938, 111, '2015-01-15 01:18:16.000000', 'temperatura', 866.0000, 'ºC'),
	(26939, 111, '2015-01-15 01:18:17.000000', 'temperatura', 642.0000, 'ºC'),
	(26940, 111, '2015-01-15 01:18:18.000000', 'temperatura', 610.0000, 'ºC'),
	(26941, 111, '2015-01-15 01:18:19.000000', 'temperatura', 1126.0000, 'ºC'),
	(26942, 111, '2015-01-15 01:18:20.000000', 'temperatura', 199.0000, 'ºC'),
	(26943, 111, '2015-01-15 01:18:21.000000', 'temperatura', 19.0000, 'ºC'),
	(26944, 111, '2015-01-15 01:18:22.000000', 'temperatura', 696.0000, 'ºC'),
	(26945, 111, '2015-01-15 01:18:23.000000', 'temperatura', 1026.0000, 'ºC'),
	(26946, 111, '2015-01-15 01:18:24.000000', 'temperatura', 640.0000, 'ºC'),
	(26947, 111, '2015-01-15 01:18:25.000000', 'temperatura', 125.0000, 'ºC'),
	(26948, 111, '2015-01-15 01:18:26.000000', 'temperatura', 1103.0000, 'ºC'),
	(26949, 111, '2015-01-15 01:18:27.000000', 'temperatura', 341.0000, 'ºC'),
	(26950, 111, '2015-01-15 01:18:28.000000', 'temperatura', 798.0000, 'ºC'),
	(26951, 111, '2015-01-15 01:18:29.000000', 'temperatura', 565.0000, 'ºC'),
	(26952, 111, '2015-01-15 01:18:30.000000', 'temperatura', 432.0000, 'ºC'),
	(26953, 111, '2015-01-15 01:18:31.000000', 'temperatura', 464.0000, 'ºC'),
	(26954, 111, '2015-01-15 01:18:32.000000', 'temperatura', 1026.0000, 'ºC'),
	(26955, 111, '2015-01-15 01:18:33.000000', 'temperatura', 140.0000, 'ºC'),
	(26956, 111, '2015-01-15 01:18:34.000000', 'temperatura', 21.0000, 'ºC'),
	(26957, 111, '2015-01-15 01:18:35.000000', 'temperatura', 886.0000, 'ºC'),
	(26958, 111, '2015-01-15 01:18:36.000000', 'temperatura', 765.0000, 'ºC'),
	(26959, 111, '2015-01-15 01:18:37.000000', 'temperatura', 1171.0000, 'ºC'),
	(26960, 111, '2015-01-15 01:18:38.000000', 'temperatura', 1158.0000, 'ºC'),
	(26961, 111, '2015-01-15 01:18:39.000000', 'temperatura', 1078.0000, 'ºC'),
	(26962, 111, '2015-01-15 01:18:40.000000', 'temperatura', 715.0000, 'ºC'),
	(26963, 111, '2015-01-15 01:18:41.000000', 'temperatura', 343.0000, 'ºC'),
	(26964, 111, '2015-01-15 01:18:42.000000', 'temperatura', 769.0000, 'ºC'),
	(26965, 111, '2015-01-15 01:18:43.000000', 'temperatura', 417.0000, 'ºC'),
	(26966, 111, '2015-01-15 01:18:44.000000', 'temperatura', 979.0000, 'ºC'),
	(26967, 111, '2015-01-15 01:18:45.000000', 'temperatura', 43.0000, 'ºC'),
	(26968, 111, '2015-01-15 01:18:46.000000', 'temperatura', 878.0000, 'ºC'),
	(26969, 111, '2015-01-15 01:18:47.000000', 'temperatura', 663.0000, 'ºC'),
	(26970, 111, '2015-01-15 01:18:48.000000', 'temperatura', 681.0000, 'ºC'),
	(26971, 111, '2015-01-15 01:18:49.000000', 'temperatura', 216.0000, 'ºC'),
	(26972, 111, '2015-01-15 01:18:50.000000', 'temperatura', 236.0000, 'ºC'),
	(26973, 111, '2015-01-15 01:18:51.000000', 'temperatura', 535.0000, 'ºC'),
	(26974, 111, '2015-01-15 01:18:52.000000', 'temperatura', 765.0000, 'ºC'),
	(26975, 111, '2015-01-15 01:18:53.000000', 'temperatura', 1021.0000, 'ºC'),
	(26976, 111, '2015-01-15 01:18:54.000000', 'temperatura', 409.0000, 'ºC'),
	(26977, 111, '2015-01-15 01:18:55.000000', 'temperatura', 185.0000, 'ºC'),
	(26978, 111, '2015-01-15 01:18:56.000000', 'temperatura', 897.0000, 'ºC'),
	(26979, 111, '2015-01-15 01:18:57.000000', 'temperatura', 331.0000, 'ºC'),
	(26980, 111, '2015-01-15 01:18:58.000000', 'temperatura', 163.0000, 'ºC'),
	(26981, 111, '2015-01-15 01:18:59.000000', 'temperatura', 1024.0000, 'ºC'),
	(26982, 111, '2015-01-15 01:19:00.000000', 'temperatura', 1032.0000, 'ºC'),
	(26983, 111, '2015-01-15 01:19:01.000000', 'temperatura', 887.0000, 'ºC'),
	(26984, 111, '2015-01-15 01:19:02.000000', 'temperatura', 139.0000, 'ºC'),
	(26985, 111, '2015-01-15 01:19:03.000000', 'temperatura', 437.0000, 'ºC'),
	(26986, 111, '2015-01-15 01:19:04.000000', 'temperatura', 568.0000, 'ºC'),
	(26987, 111, '2015-01-15 01:19:05.000000', 'temperatura', 328.0000, 'ºC'),
	(26988, 111, '2015-01-15 01:19:06.000000', 'temperatura', 1136.0000, 'ºC'),
	(26989, 111, '2015-01-15 01:19:07.000000', 'temperatura', 1098.0000, 'ºC'),
	(26990, 111, '2015-01-15 01:19:08.000000', 'temperatura', 880.0000, 'ºC'),
	(26991, 111, '2015-01-15 01:19:09.000000', 'temperatura', 1109.0000, 'ºC'),
	(26992, 111, '2015-01-15 01:19:10.000000', 'temperatura', 505.0000, 'ºC'),
	(26993, 111, '2015-01-15 01:19:11.000000', 'temperatura', 399.0000, 'ºC'),
	(26994, 111, '2015-01-15 01:19:12.000000', 'temperatura', 481.0000, 'ºC'),
	(26995, 111, '2015-01-15 01:19:13.000000', 'temperatura', 10.0000, 'ºC'),
	(26996, 111, '2015-01-15 01:19:14.000000', 'temperatura', 1005.0000, 'ºC'),
	(26997, 111, '2015-01-15 01:19:15.000000', 'temperatura', 198.0000, 'ºC'),
	(26998, 111, '2015-01-15 01:19:16.000000', 'temperatura', 373.0000, 'ºC'),
	(26999, 111, '2015-01-15 01:19:17.000000', 'temperatura', 71.0000, 'ºC'),
	(27000, 111, '2015-01-15 01:19:18.000000', 'temperatura', 437.0000, 'ºC'),
	(27001, 111, '2015-01-15 01:19:19.000000', 'temperatura', 773.0000, 'ºC'),
	(27002, 111, '2015-01-15 01:19:20.000000', 'temperatura', 155.0000, 'ºC'),
	(27003, 111, '2015-01-15 01:19:21.000000', 'temperatura', 856.0000, 'ºC'),
	(27004, 111, '2015-01-15 01:19:22.000000', 'temperatura', 213.0000, 'ºC'),
	(27005, 111, '2015-01-15 01:19:23.000000', 'temperatura', 901.0000, 'ºC'),
	(27006, 111, '2015-01-15 01:19:24.000000', 'temperatura', 266.0000, 'ºC'),
	(27007, 111, '2015-01-15 01:19:25.000000', 'temperatura', 1027.0000, 'ºC'),
	(27008, 111, '2015-01-15 01:19:26.000000', 'temperatura', 737.0000, 'ºC'),
	(27009, 111, '2015-01-15 01:19:27.000000', 'temperatura', 604.0000, 'ºC'),
	(27010, 111, '2015-01-15 01:19:28.000000', 'temperatura', 810.0000, 'ºC'),
	(27011, 111, '2015-01-15 01:19:29.000000', 'temperatura', 1037.0000, 'ºC'),
	(27012, 111, '2015-01-15 01:19:30.000000', 'temperatura', 358.0000, 'ºC'),
	(27013, 111, '2015-01-15 01:19:31.000000', 'temperatura', 1079.0000, 'ºC'),
	(27014, 111, '2015-01-15 01:19:32.000000', 'temperatura', 722.0000, 'ºC'),
	(27015, 111, '2015-01-15 01:19:33.000000', 'temperatura', 374.0000, 'ºC'),
	(27016, 111, '2015-01-15 01:19:34.000000', 'temperatura', 902.0000, 'ºC'),
	(27017, 111, '2015-01-15 01:19:35.000000', 'temperatura', 990.0000, 'ºC'),
	(27018, 111, '2015-01-15 01:19:36.000000', 'temperatura', 1045.0000, 'ºC'),
	(27019, 111, '2015-01-15 01:19:37.000000', 'temperatura', 1053.0000, 'ºC'),
	(27020, 111, '2015-01-15 01:19:38.000000', 'temperatura', 933.0000, 'ºC'),
	(27021, 111, '2015-01-15 01:19:39.000000', 'temperatura', 305.0000, 'ºC'),
	(27022, 111, '2015-01-15 01:19:40.000000', 'temperatura', 1126.0000, 'ºC'),
	(27023, 111, '2015-01-15 01:19:41.000000', 'temperatura', 1116.0000, 'ºC'),
	(27024, 111, '2015-01-15 01:19:42.000000', 'temperatura', 1004.0000, 'ºC'),
	(27025, 111, '2015-01-15 01:19:43.000000', 'temperatura', 470.0000, 'ºC'),
	(27026, 111, '2015-01-15 01:19:44.000000', 'temperatura', 540.0000, 'ºC'),
	(27027, 111, '2015-01-15 01:19:45.000000', 'temperatura', 90.0000, 'ºC'),
	(27028, 111, '2015-01-15 01:19:46.000000', 'temperatura', 30.0000, 'ºC'),
	(27029, 111, '2015-01-15 01:19:47.000000', 'temperatura', 1080.0000, 'ºC'),
	(27030, 111, '2015-01-15 01:19:48.000000', 'temperatura', 511.0000, 'ºC'),
	(27031, 111, '2015-01-15 01:19:49.000000', 'temperatura', 513.0000, 'ºC'),
	(27032, 111, '2015-01-15 01:19:50.000000', 'temperatura', 1036.0000, 'ºC'),
	(27033, 111, '2015-01-15 01:19:51.000000', 'temperatura', 42.0000, 'ºC'),
	(27034, 111, '2015-01-15 01:19:52.000000', 'temperatura', 700.0000, 'ºC'),
	(27035, 111, '2015-01-15 01:19:53.000000', 'temperatura', 976.0000, 'ºC'),
	(27036, 111, '2015-01-15 01:19:54.000000', 'temperatura', 382.0000, 'ºC'),
	(27037, 111, '2015-01-15 01:19:55.000000', 'temperatura', 180.0000, 'ºC'),
	(27038, 111, '2015-01-15 01:19:56.000000', 'temperatura', 956.0000, 'ºC'),
	(27039, 111, '2015-01-15 01:19:57.000000', 'temperatura', 638.0000, 'ºC'),
	(27040, 111, '2015-01-15 01:19:58.000000', 'temperatura', 325.0000, 'ºC'),
	(27041, 111, '2015-01-15 01:19:59.000000', 'temperatura', 912.0000, 'ºC'),
	(27042, 111, '2015-01-15 01:20:00.000000', 'temperatura', 1185.0000, 'ºC'),
	(27043, 111, '2015-01-15 01:20:01.000000', 'temperatura', 791.0000, 'ºC'),
	(27044, 111, '2015-01-15 01:20:02.000000', 'temperatura', 398.0000, 'ºC'),
	(27045, 111, '2015-01-15 01:20:03.000000', 'temperatura', 820.0000, 'ºC'),
	(27046, 111, '2015-01-15 01:20:04.000000', 'temperatura', 503.0000, 'ºC'),
	(27047, 111, '2015-01-15 01:20:05.000000', 'temperatura', 59.0000, 'ºC'),
	(27048, 111, '2015-01-15 01:20:06.000000', 'temperatura', 1186.0000, 'ºC'),
	(27049, 111, '2015-01-15 01:20:07.000000', 'temperatura', 952.0000, 'ºC'),
	(27050, 111, '2015-01-15 01:20:08.000000', 'temperatura', 4.0000, 'ºC'),
	(27051, 111, '2015-01-15 01:20:09.000000', 'temperatura', 763.0000, 'ºC'),
	(27052, 111, '2015-01-15 01:20:10.000000', 'temperatura', 205.0000, 'ºC'),
	(27053, 111, '2015-01-15 01:20:11.000000', 'temperatura', 1136.0000, 'ºC'),
	(27054, 111, '2015-01-15 01:20:12.000000', 'temperatura', 265.0000, 'ºC'),
	(27055, 111, '2015-01-15 01:20:13.000000', 'temperatura', 317.0000, 'ºC'),
	(27056, 111, '2015-01-15 01:20:14.000000', 'temperatura', 791.0000, 'ºC'),
	(27057, 111, '2015-01-15 01:20:15.000000', 'temperatura', 603.0000, 'ºC'),
	(27058, 111, '2015-01-15 01:20:16.000000', 'temperatura', 644.0000, 'ºC'),
	(27059, 111, '2015-01-15 01:20:17.000000', 'temperatura', 212.0000, 'ºC'),
	(27060, 111, '2015-01-15 01:20:18.000000', 'temperatura', 328.0000, 'ºC'),
	(27061, 111, '2015-01-15 01:20:19.000000', 'temperatura', 1005.0000, 'ºC'),
	(27062, 111, '2015-01-15 01:20:20.000000', 'temperatura', 440.0000, 'ºC'),
	(27063, 111, '2015-01-15 01:20:21.000000', 'temperatura', 384.0000, 'ºC'),
	(27064, 111, '2015-01-15 01:20:22.000000', 'temperatura', 603.0000, 'ºC'),
	(27065, 111, '2015-01-15 01:20:23.000000', 'temperatura', 663.0000, 'ºC'),
	(27066, 111, '2015-01-15 01:20:24.000000', 'temperatura', 306.0000, 'ºC'),
	(27067, 111, '2015-01-15 01:20:25.000000', 'temperatura', 743.0000, 'ºC'),
	(27068, 111, '2015-01-15 01:20:26.000000', 'temperatura', 398.0000, 'ºC'),
	(27069, 111, '2015-01-15 01:20:27.000000', 'temperatura', 959.0000, 'ºC'),
	(27070, 111, '2015-01-15 01:20:28.000000', 'temperatura', 1.0000, 'ºC'),
	(27071, 111, '2015-01-15 01:20:29.000000', 'temperatura', 729.0000, 'ºC'),
	(27072, 111, '2015-01-15 01:20:30.000000', 'temperatura', 44.0000, 'ºC'),
	(27073, 111, '2015-01-15 01:20:31.000000', 'temperatura', 431.0000, 'ºC'),
	(27074, 111, '2015-01-15 01:20:32.000000', 'temperatura', 826.0000, 'ºC'),
	(27075, 111, '2015-01-15 01:20:33.000000', 'temperatura', 435.0000, 'ºC'),
	(27076, 111, '2015-01-15 01:20:34.000000', 'temperatura', 897.0000, 'ºC'),
	(27077, 111, '2015-01-15 01:20:35.000000', 'temperatura', 782.0000, 'ºC'),
	(27078, 111, '2015-01-15 01:20:36.000000', 'temperatura', 20.0000, 'ºC'),
	(27079, 111, '2015-01-15 01:20:37.000000', 'temperatura', 153.0000, 'ºC'),
	(27080, 111, '2015-01-15 01:20:38.000000', 'temperatura', 707.0000, 'ºC'),
	(27081, 111, '2015-01-15 01:20:39.000000', 'temperatura', 677.0000, 'ºC'),
	(27082, 111, '2015-01-15 01:20:40.000000', 'temperatura', 63.0000, 'ºC'),
	(27083, 111, '2015-01-15 01:20:41.000000', 'temperatura', 685.0000, 'ºC'),
	(27084, 111, '2015-01-15 01:20:42.000000', 'temperatura', 837.0000, 'ºC'),
	(27085, 111, '2015-01-15 01:20:43.000000', 'temperatura', 928.0000, 'ºC'),
	(27086, 111, '2015-01-15 01:20:44.000000', 'temperatura', 933.0000, 'ºC'),
	(27087, 111, '2015-01-15 01:20:45.000000', 'temperatura', 678.0000, 'ºC'),
	(27088, 111, '2015-01-15 01:20:46.000000', 'temperatura', 595.0000, 'ºC'),
	(27089, 111, '2015-01-15 01:20:47.000000', 'temperatura', 938.0000, 'ºC'),
	(27090, 111, '2015-01-15 01:20:48.000000', 'temperatura', 508.0000, 'ºC'),
	(27091, 111, '2015-01-15 01:20:49.000000', 'temperatura', 927.0000, 'ºC'),
	(27092, 111, '2015-01-15 01:20:50.000000', 'temperatura', 711.0000, 'ºC'),
	(27093, 111, '2015-01-15 01:20:51.000000', 'temperatura', 773.0000, 'ºC'),
	(27094, 111, '2015-01-15 01:20:52.000000', 'temperatura', 532.0000, 'ºC'),
	(27095, 111, '2015-01-15 01:20:53.000000', 'temperatura', 342.0000, 'ºC'),
	(27096, 111, '2015-01-15 01:20:54.000000', 'temperatura', 114.0000, 'ºC'),
	(27097, 111, '2015-01-15 01:20:55.000000', 'temperatura', 746.0000, 'ºC'),
	(27098, 111, '2015-01-15 01:20:56.000000', 'temperatura', 988.0000, 'ºC'),
	(27099, 111, '2015-01-15 01:20:57.000000', 'temperatura', 302.0000, 'ºC'),
	(27100, 111, '2015-01-15 01:20:58.000000', 'temperatura', 946.0000, 'ºC'),
	(27101, 111, '2015-01-15 01:20:59.000000', 'temperatura', 223.0000, 'ºC'),
	(27102, 111, '2015-01-15 01:21:00.000000', 'temperatura', 680.0000, 'ºC'),
	(27103, 111, '2015-01-15 01:21:01.000000', 'temperatura', 331.0000, 'ºC'),
	(27104, 111, '2015-01-15 01:21:02.000000', 'temperatura', 815.0000, 'ºC'),
	(27105, 111, '2015-01-15 01:21:03.000000', 'temperatura', 683.0000, 'ºC'),
	(27106, 111, '2015-01-15 01:21:04.000000', 'temperatura', 970.0000, 'ºC'),
	(27107, 111, '2015-01-15 01:21:05.000000', 'temperatura', 402.0000, 'ºC'),
	(27108, 111, '2015-01-15 01:21:06.000000', 'temperatura', 302.0000, 'ºC'),
	(27109, 111, '2015-01-15 01:21:07.000000', 'temperatura', 304.0000, 'ºC'),
	(27110, 111, '2015-01-15 01:21:08.000000', 'temperatura', 612.0000, 'ºC'),
	(27111, 111, '2015-01-15 01:21:09.000000', 'temperatura', 951.0000, 'ºC'),
	(27112, 111, '2015-01-15 01:21:10.000000', 'temperatura', 520.0000, 'ºC'),
	(27113, 111, '2015-01-15 01:21:11.000000', 'temperatura', 946.0000, 'ºC'),
	(27114, 111, '2015-01-15 01:21:12.000000', 'temperatura', 770.0000, 'ºC'),
	(27115, 111, '2015-01-15 01:21:13.000000', 'temperatura', 1013.0000, 'ºC'),
	(27116, 111, '2015-01-15 01:21:14.000000', 'temperatura', 356.0000, 'ºC'),
	(27117, 111, '2015-01-15 01:21:15.000000', 'temperatura', 1139.0000, 'ºC'),
	(27118, 111, '2015-01-15 01:21:16.000000', 'temperatura', 1030.0000, 'ºC'),
	(27119, 111, '2015-01-15 01:21:17.000000', 'temperatura', 534.0000, 'ºC'),
	(27120, 111, '2015-01-15 01:21:18.000000', 'temperatura', 780.0000, 'ºC'),
	(27121, 111, '2015-01-15 01:21:19.000000', 'temperatura', 1099.0000, 'ºC'),
	(27122, 111, '2015-01-15 01:21:20.000000', 'temperatura', 757.0000, 'ºC'),
	(27123, 111, '2015-01-15 01:21:21.000000', 'temperatura', 486.0000, 'ºC'),
	(27124, 111, '2015-01-15 01:21:22.000000', 'temperatura', 161.0000, 'ºC'),
	(27125, 111, '2015-01-15 01:21:23.000000', 'temperatura', 546.0000, 'ºC'),
	(27126, 111, '2015-01-15 01:21:24.000000', 'temperatura', 1050.0000, 'ºC'),
	(27127, 111, '2015-01-15 01:21:25.000000', 'temperatura', 11.0000, 'ºC'),
	(27128, 111, '2015-01-15 01:21:26.000000', 'temperatura', 505.0000, 'ºC'),
	(27129, 111, '2015-01-15 01:21:27.000000', 'temperatura', 94.0000, 'ºC'),
	(27130, 111, '2015-01-15 01:21:28.000000', 'temperatura', 155.0000, 'ºC'),
	(27131, 111, '2015-01-15 01:21:29.000000', 'temperatura', 494.0000, 'ºC'),
	(27132, 111, '2015-01-15 01:21:30.000000', 'temperatura', 806.0000, 'ºC'),
	(27133, 111, '2015-01-15 01:21:31.000000', 'temperatura', 147.0000, 'ºC'),
	(27134, 111, '2015-01-15 01:21:32.000000', 'temperatura', 720.0000, 'ºC'),
	(27135, 111, '2015-01-15 01:21:33.000000', 'temperatura', 758.0000, 'ºC'),
	(27136, 111, '2015-01-15 01:21:34.000000', 'temperatura', 429.0000, 'ºC'),
	(27137, 111, '2015-01-15 01:21:35.000000', 'temperatura', 1074.0000, 'ºC'),
	(27138, 111, '2015-01-15 01:21:36.000000', 'temperatura', 482.0000, 'ºC'),
	(27139, 111, '2015-01-15 01:21:37.000000', 'temperatura', 389.0000, 'ºC'),
	(27140, 111, '2015-01-15 01:21:38.000000', 'temperatura', 501.0000, 'ºC'),
	(27141, 111, '2015-01-15 01:21:39.000000', 'temperatura', 138.0000, 'ºC'),
	(27142, 111, '2015-01-15 01:21:40.000000', 'temperatura', 389.0000, 'ºC'),
	(27143, 111, '2015-01-15 01:21:41.000000', 'temperatura', 330.0000, 'ºC'),
	(27144, 111, '2015-01-15 01:21:42.000000', 'temperatura', 486.0000, 'ºC'),
	(27145, 111, '2015-01-15 01:21:43.000000', 'temperatura', 237.0000, 'ºC'),
	(27146, 111, '2015-01-15 01:21:44.000000', 'temperatura', 929.0000, 'ºC'),
	(27147, 111, '2015-01-15 01:21:45.000000', 'temperatura', 333.0000, 'ºC'),
	(27148, 111, '2015-01-15 01:21:46.000000', 'temperatura', 79.0000, 'ºC'),
	(27149, 111, '2015-01-15 01:21:47.000000', 'temperatura', 599.0000, 'ºC'),
	(27150, 111, '2015-01-15 01:21:48.000000', 'temperatura', 356.0000, 'ºC'),
	(27151, 111, '2015-01-15 01:21:49.000000', 'temperatura', 1184.0000, 'ºC'),
	(27152, 111, '2015-01-15 01:21:50.000000', 'temperatura', 54.0000, 'ºC'),
	(27153, 111, '2015-01-15 01:21:51.000000', 'temperatura', 317.0000, 'ºC'),
	(27154, 111, '2015-01-15 01:21:52.000000', 'temperatura', 224.0000, 'ºC'),
	(27155, 111, '2015-01-15 01:21:53.000000', 'temperatura', 169.0000, 'ºC'),
	(27156, 111, '2015-01-15 01:21:54.000000', 'temperatura', 175.0000, 'ºC'),
	(27157, 111, '2015-01-15 01:21:55.000000', 'temperatura', 368.0000, 'ºC'),
	(27158, 111, '2015-01-15 01:21:56.000000', 'temperatura', 116.0000, 'ºC'),
	(27159, 111, '2015-01-15 01:21:57.000000', 'temperatura', 674.0000, 'ºC'),
	(27160, 111, '2015-01-15 01:21:58.000000', 'temperatura', 625.0000, 'ºC'),
	(27161, 111, '2015-01-15 01:21:59.000000', 'temperatura', 1103.0000, 'ºC'),
	(27162, 111, '2015-01-15 01:22:00.000000', 'temperatura', 38.0000, 'ºC'),
	(27163, 111, '2015-01-15 01:22:01.000000', 'temperatura', 485.0000, 'ºC'),
	(27164, 111, '2015-01-15 01:22:02.000000', 'temperatura', 1110.0000, 'ºC'),
	(27165, 111, '2015-01-15 01:22:03.000000', 'temperatura', 496.0000, 'ºC'),
	(27166, 111, '2015-01-15 01:22:04.000000', 'temperatura', 351.0000, 'ºC'),
	(27167, 111, '2015-01-15 01:22:05.000000', 'temperatura', 269.0000, 'ºC'),
	(27168, 111, '2015-01-15 01:22:06.000000', 'temperatura', 290.0000, 'ºC'),
	(27169, 111, '2015-01-15 01:22:07.000000', 'temperatura', 643.0000, 'ºC'),
	(27170, 111, '2015-01-15 01:22:08.000000', 'temperatura', 1146.0000, 'ºC'),
	(27171, 111, '2015-01-15 01:22:09.000000', 'temperatura', 204.0000, 'ºC'),
	(27172, 111, '2015-01-15 01:22:10.000000', 'temperatura', 1180.0000, 'ºC'),
	(27173, 111, '2015-01-15 01:22:11.000000', 'temperatura', 491.0000, 'ºC'),
	(27174, 111, '2015-01-15 01:22:12.000000', 'temperatura', 114.0000, 'ºC'),
	(27175, 111, '2015-01-15 01:22:13.000000', 'temperatura', 298.0000, 'ºC'),
	(27176, 111, '2015-01-15 01:22:14.000000', 'temperatura', 1148.0000, 'ºC'),
	(27177, 111, '2015-01-15 01:22:15.000000', 'temperatura', 47.0000, 'ºC'),
	(27178, 111, '2015-01-15 01:22:16.000000', 'temperatura', 390.0000, 'ºC'),
	(27179, 111, '2015-01-15 01:22:17.000000', 'temperatura', 610.0000, 'ºC'),
	(27180, 111, '2015-01-15 01:22:18.000000', 'temperatura', 683.0000, 'ºC'),
	(27181, 111, '2015-01-15 01:22:19.000000', 'temperatura', 382.0000, 'ºC'),
	(27182, 111, '2015-01-15 01:22:20.000000', 'temperatura', 1063.0000, 'ºC'),
	(27183, 111, '2015-01-15 01:22:21.000000', 'temperatura', 571.0000, 'ºC'),
	(27184, 111, '2015-01-15 01:22:22.000000', 'temperatura', 865.0000, 'ºC'),
	(27185, 111, '2015-01-15 01:22:23.000000', 'temperatura', 211.0000, 'ºC'),
	(27186, 111, '2015-01-15 01:22:24.000000', 'temperatura', 863.0000, 'ºC'),
	(27187, 111, '2015-01-15 01:22:25.000000', 'temperatura', 83.0000, 'ºC'),
	(27188, 111, '2015-01-15 01:22:26.000000', 'temperatura', 226.0000, 'ºC'),
	(27189, 111, '2015-01-15 01:22:27.000000', 'temperatura', 882.0000, 'ºC'),
	(27190, 111, '2015-01-15 01:22:28.000000', 'temperatura', 133.0000, 'ºC'),
	(27191, 111, '2015-01-15 01:22:29.000000', 'temperatura', 418.0000, 'ºC'),
	(27192, 111, '2015-01-15 01:22:30.000000', 'temperatura', 493.0000, 'ºC'),
	(27193, 111, '2015-01-15 01:22:31.000000', 'temperatura', 12.0000, 'ºC'),
	(27194, 111, '2015-01-15 01:22:32.000000', 'temperatura', 981.0000, 'ºC'),
	(27195, 111, '2015-01-15 01:22:33.000000', 'temperatura', 68.0000, 'ºC'),
	(27196, 111, '2015-01-15 01:22:34.000000', 'temperatura', 997.0000, 'ºC'),
	(27197, 111, '2015-01-15 01:22:35.000000', 'temperatura', 1182.0000, 'ºC'),
	(27198, 111, '2015-01-15 01:22:36.000000', 'temperatura', 522.0000, 'ºC'),
	(27199, 111, '2015-01-15 01:22:37.000000', 'temperatura', 262.0000, 'ºC'),
	(27200, 111, '2015-01-15 01:22:38.000000', 'temperatura', 945.0000, 'ºC'),
	(27201, 111, '2015-01-15 01:22:39.000000', 'temperatura', 342.0000, 'ºC'),
	(27202, 111, '2015-01-15 01:22:40.000000', 'temperatura', 72.0000, 'ºC'),
	(27203, 111, '2015-01-15 01:22:41.000000', 'temperatura', 537.0000, 'ºC'),
	(27204, 111, '2015-01-15 01:22:42.000000', 'temperatura', 68.0000, 'ºC'),
	(27205, 111, '2015-01-15 01:22:43.000000', 'temperatura', 1131.0000, 'ºC'),
	(27206, 111, '2015-01-15 01:22:44.000000', 'temperatura', 652.0000, 'ºC'),
	(27207, 111, '2015-01-15 01:22:45.000000', 'temperatura', 1065.0000, 'ºC'),
	(27208, 111, '2015-01-15 01:22:46.000000', 'temperatura', 973.0000, 'ºC'),
	(27209, 111, '2015-01-15 01:22:47.000000', 'temperatura', 467.0000, 'ºC'),
	(27210, 111, '2015-01-15 01:22:48.000000', 'temperatura', 617.0000, 'ºC'),
	(27211, 111, '2015-01-15 01:22:49.000000', 'temperatura', 484.0000, 'ºC'),
	(27212, 111, '2015-01-15 01:22:50.000000', 'temperatura', 572.0000, 'ºC'),
	(27213, 111, '2015-01-15 01:22:51.000000', 'temperatura', 208.0000, 'ºC'),
	(27214, 111, '2015-01-15 01:22:52.000000', 'temperatura', 525.0000, 'ºC'),
	(27215, 111, '2015-01-15 01:22:53.000000', 'temperatura', 799.0000, 'ºC'),
	(27216, 111, '2015-01-15 01:22:54.000000', 'temperatura', 21.0000, 'ºC'),
	(27217, 111, '2015-01-15 01:22:55.000000', 'temperatura', 107.0000, 'ºC'),
	(27218, 111, '2015-01-15 01:22:56.000000', 'temperatura', 475.0000, 'ºC'),
	(27219, 111, '2015-01-15 01:22:57.000000', 'temperatura', 855.0000, 'ºC'),
	(27220, 111, '2015-01-15 01:22:58.000000', 'temperatura', 450.0000, 'ºC'),
	(27221, 111, '2015-01-15 01:22:59.000000', 'temperatura', 883.0000, 'ºC'),
	(27222, 111, '2015-01-15 01:23:00.000000', 'temperatura', 668.0000, 'ºC'),
	(27223, 111, '2015-01-15 01:23:01.000000', 'temperatura', 690.0000, 'ºC'),
	(27224, 111, '2015-01-15 01:23:02.000000', 'temperatura', 245.0000, 'ºC'),
	(27225, 111, '2015-01-15 01:23:03.000000', 'temperatura', 357.0000, 'ºC'),
	(27226, 111, '2015-01-15 01:23:04.000000', 'temperatura', 1051.0000, 'ºC'),
	(27227, 111, '2015-01-15 01:23:05.000000', 'temperatura', 584.0000, 'ºC'),
	(27228, 111, '2015-01-15 01:23:06.000000', 'temperatura', 968.0000, 'ºC'),
	(27229, 111, '2015-01-15 01:23:07.000000', 'temperatura', 688.0000, 'ºC'),
	(27230, 111, '2015-01-15 01:23:08.000000', 'temperatura', 535.0000, 'ºC'),
	(27231, 111, '2015-01-15 01:23:09.000000', 'temperatura', 612.0000, 'ºC'),
	(27232, 111, '2015-01-15 01:23:10.000000', 'temperatura', 257.0000, 'ºC'),
	(27233, 111, '2015-01-15 01:23:11.000000', 'temperatura', 651.0000, 'ºC'),
	(27234, 111, '2015-01-15 01:23:12.000000', 'temperatura', 81.0000, 'ºC'),
	(27235, 111, '2015-01-15 01:23:13.000000', 'temperatura', 855.0000, 'ºC'),
	(27236, 111, '2015-01-15 01:23:14.000000', 'temperatura', 433.0000, 'ºC'),
	(27237, 111, '2015-01-15 01:23:15.000000', 'temperatura', 800.0000, 'ºC'),
	(27238, 111, '2015-01-15 01:23:16.000000', 'temperatura', 302.0000, 'ºC'),
	(27239, 111, '2015-01-15 01:23:17.000000', 'temperatura', 309.0000, 'ºC'),
	(27240, 111, '2015-01-15 01:23:18.000000', 'temperatura', 640.0000, 'ºC'),
	(27241, 111, '2015-01-15 01:23:19.000000', 'temperatura', 1074.0000, 'ºC'),
	(27242, 111, '2015-01-15 01:23:20.000000', 'temperatura', 1052.0000, 'ºC'),
	(27243, 111, '2015-01-15 01:23:21.000000', 'temperatura', 838.0000, 'ºC'),
	(27244, 111, '2015-01-15 01:23:22.000000', 'temperatura', 1035.0000, 'ºC'),
	(27245, 111, '2015-01-15 01:23:23.000000', 'temperatura', 262.0000, 'ºC'),
	(27246, 111, '2015-01-15 01:23:24.000000', 'temperatura', 605.0000, 'ºC'),
	(27247, 111, '2015-01-15 01:23:25.000000', 'temperatura', 1039.0000, 'ºC'),
	(27248, 111, '2015-01-15 01:23:26.000000', 'temperatura', 983.0000, 'ºC'),
	(27249, 111, '2015-01-15 01:23:27.000000', 'temperatura', 595.0000, 'ºC'),
	(27250, 111, '2015-01-15 01:23:28.000000', 'temperatura', 28.0000, 'ºC'),
	(27251, 111, '2015-01-15 01:23:29.000000', 'temperatura', 756.0000, 'ºC'),
	(27252, 111, '2015-01-15 01:23:30.000000', 'temperatura', 95.0000, 'ºC'),
	(27253, 111, '2015-01-15 01:23:31.000000', 'temperatura', 610.0000, 'ºC'),
	(27254, 111, '2015-01-15 01:23:32.000000', 'temperatura', 362.0000, 'ºC'),
	(27255, 111, '2015-01-15 01:23:33.000000', 'temperatura', 1184.0000, 'ºC'),
	(27256, 111, '2015-01-15 01:23:34.000000', 'temperatura', 32.0000, 'ºC'),
	(27257, 111, '2015-01-15 01:23:35.000000', 'temperatura', 209.0000, 'ºC'),
	(27258, 111, '2015-01-15 01:23:36.000000', 'temperatura', 951.0000, 'ºC'),
	(27259, 111, '2015-01-15 01:23:37.000000', 'temperatura', 529.0000, 'ºC'),
	(27260, 111, '2015-01-15 01:23:38.000000', 'temperatura', 990.0000, 'ºC'),
	(27261, 111, '2015-01-15 01:23:39.000000', 'temperatura', 963.0000, 'ºC'),
	(27262, 111, '2015-01-15 01:23:40.000000', 'temperatura', 646.0000, 'ºC'),
	(27263, 111, '2015-01-15 01:23:41.000000', 'temperatura', 344.0000, 'ºC'),
	(27264, 111, '2015-01-15 01:23:42.000000', 'temperatura', 981.0000, 'ºC'),
	(27265, 111, '2015-01-15 01:23:43.000000', 'temperatura', 273.0000, 'ºC'),
	(27266, 111, '2015-01-15 01:23:44.000000', 'temperatura', 822.0000, 'ºC'),
	(27267, 111, '2015-01-15 01:23:45.000000', 'temperatura', 890.0000, 'ºC'),
	(27268, 111, '2015-01-15 01:23:46.000000', 'temperatura', 788.0000, 'ºC'),
	(27269, 111, '2015-01-15 01:23:47.000000', 'temperatura', 69.0000, 'ºC'),
	(27270, 111, '2015-01-15 01:23:48.000000', 'temperatura', 384.0000, 'ºC'),
	(27271, 111, '2015-01-15 01:23:49.000000', 'temperatura', 510.0000, 'ºC'),
	(27272, 111, '2015-01-15 01:23:50.000000', 'temperatura', 199.0000, 'ºC'),
	(27273, 111, '2015-01-15 01:23:51.000000', 'temperatura', 664.0000, 'ºC'),
	(27274, 111, '2015-01-15 01:23:52.000000', 'temperatura', 325.0000, 'ºC'),
	(27275, 111, '2015-01-15 01:23:53.000000', 'temperatura', 832.0000, 'ºC'),
	(27276, 111, '2015-01-15 01:23:54.000000', 'temperatura', 785.0000, 'ºC'),
	(27277, 111, '2015-01-15 01:23:55.000000', 'temperatura', 231.0000, 'ºC'),
	(27278, 111, '2015-01-15 01:23:56.000000', 'temperatura', 1199.0000, 'ºC'),
	(27279, 111, '2015-01-15 01:23:57.000000', 'temperatura', 502.0000, 'ºC'),
	(27280, 111, '2015-01-15 01:23:58.000000', 'temperatura', 113.0000, 'ºC'),
	(27281, 111, '2015-01-15 01:23:59.000000', 'temperatura', 260.0000, 'ºC'),
	(27282, 111, '2015-01-15 01:24:00.000000', 'temperatura', 961.0000, 'ºC'),
	(27283, 111, '2015-01-15 01:24:01.000000', 'temperatura', 427.0000, 'ºC'),
	(27284, 111, '2015-01-15 01:24:02.000000', 'temperatura', 451.0000, 'ºC'),
	(27285, 111, '2015-01-15 01:24:03.000000', 'temperatura', 973.0000, 'ºC'),
	(27286, 111, '2015-01-15 01:24:04.000000', 'temperatura', 1114.0000, 'ºC'),
	(27287, 111, '2015-01-15 01:24:05.000000', 'temperatura', 252.0000, 'ºC'),
	(27288, 111, '2015-01-15 01:24:06.000000', 'temperatura', 318.0000, 'ºC'),
	(27289, 111, '2015-01-15 01:24:07.000000', 'temperatura', 834.0000, 'ºC'),
	(27290, 111, '2015-01-15 01:24:08.000000', 'temperatura', 815.0000, 'ºC'),
	(27291, 111, '2015-01-15 01:24:09.000000', 'temperatura', 376.0000, 'ºC'),
	(27292, 111, '2015-01-15 01:24:10.000000', 'temperatura', 635.0000, 'ºC'),
	(27293, 111, '2015-01-15 01:24:11.000000', 'temperatura', 845.0000, 'ºC'),
	(27294, 111, '2015-01-15 01:24:12.000000', 'temperatura', 1123.0000, 'ºC'),
	(27295, 111, '2015-01-15 01:24:13.000000', 'temperatura', 682.0000, 'ºC'),
	(27296, 111, '2015-01-15 01:24:14.000000', 'temperatura', 38.0000, 'ºC'),
	(27297, 111, '2015-01-15 01:24:15.000000', 'temperatura', 548.0000, 'ºC'),
	(27298, 111, '2015-01-15 01:24:16.000000', 'temperatura', 223.0000, 'ºC'),
	(27299, 111, '2015-01-15 01:24:17.000000', 'temperatura', 673.0000, 'ºC'),
	(27300, 111, '2015-01-15 01:24:18.000000', 'temperatura', 297.0000, 'ºC'),
	(27301, 111, '2015-01-15 01:24:19.000000', 'temperatura', 666.0000, 'ºC'),
	(27302, 111, '2015-01-15 01:24:20.000000', 'temperatura', 39.0000, 'ºC'),
	(27303, 111, '2015-01-15 01:24:21.000000', 'temperatura', 596.0000, 'ºC'),
	(27304, 111, '2015-01-15 01:24:22.000000', 'temperatura', 465.0000, 'ºC'),
	(27305, 111, '2015-01-15 01:24:23.000000', 'temperatura', 537.0000, 'ºC'),
	(27306, 111, '2015-01-15 01:24:24.000000', 'temperatura', 91.0000, 'ºC'),
	(27307, 111, '2015-01-15 01:24:25.000000', 'temperatura', 44.0000, 'ºC'),
	(27308, 111, '2015-01-15 01:24:26.000000', 'temperatura', 1148.0000, 'ºC'),
	(27309, 111, '2015-01-15 01:24:27.000000', 'temperatura', 808.0000, 'ºC'),
	(27310, 111, '2015-01-15 01:24:28.000000', 'temperatura', 597.0000, 'ºC'),
	(27311, 111, '2015-01-15 01:24:29.000000', 'temperatura', 559.0000, 'ºC'),
	(27312, 111, '2015-01-15 01:24:30.000000', 'temperatura', 1008.0000, 'ºC'),
	(27313, 111, '2015-01-15 01:24:31.000000', 'temperatura', 961.0000, 'ºC'),
	(27314, 111, '2015-01-15 01:24:32.000000', 'temperatura', 583.0000, 'ºC'),
	(27315, 111, '2015-01-15 01:24:33.000000', 'temperatura', 32.0000, 'ºC'),
	(27316, 111, '2015-01-15 01:24:34.000000', 'temperatura', 811.0000, 'ºC'),
	(27317, 111, '2015-01-15 01:24:35.000000', 'temperatura', 360.0000, 'ºC'),
	(27318, 111, '2015-01-15 01:24:36.000000', 'temperatura', 569.0000, 'ºC'),
	(27319, 111, '2015-01-15 01:24:37.000000', 'temperatura', 563.0000, 'ºC'),
	(27320, 111, '2015-01-15 01:24:38.000000', 'temperatura', 1110.0000, 'ºC'),
	(27321, 111, '2015-01-15 01:24:39.000000', 'temperatura', 261.0000, 'ºC'),
	(27322, 111, '2015-01-15 01:24:40.000000', 'temperatura', 376.0000, 'ºC'),
	(27323, 111, '2015-01-15 01:24:41.000000', 'temperatura', 1097.0000, 'ºC'),
	(27324, 111, '2015-01-15 01:24:42.000000', 'temperatura', 756.0000, 'ºC'),
	(27325, 111, '2015-01-15 01:24:43.000000', 'temperatura', 491.0000, 'ºC'),
	(27326, 111, '2015-01-15 01:24:44.000000', 'temperatura', 187.0000, 'ºC'),
	(27327, 111, '2015-01-15 01:24:45.000000', 'temperatura', 665.0000, 'ºC'),
	(27328, 111, '2015-01-15 01:24:46.000000', 'temperatura', 362.0000, 'ºC'),
	(27329, 111, '2015-01-15 01:24:47.000000', 'temperatura', 1017.0000, 'ºC'),
	(27330, 111, '2015-01-15 01:24:48.000000', 'temperatura', 397.0000, 'ºC'),
	(27331, 111, '2015-01-15 01:24:49.000000', 'temperatura', 136.0000, 'ºC'),
	(27332, 111, '2015-01-15 01:24:50.000000', 'temperatura', 688.0000, 'ºC'),
	(27333, 111, '2015-01-15 01:24:51.000000', 'temperatura', 632.0000, 'ºC'),
	(27334, 111, '2015-01-15 01:24:52.000000', 'temperatura', 1096.0000, 'ºC'),
	(27335, 111, '2015-01-15 01:24:53.000000', 'temperatura', 1186.0000, 'ºC'),
	(27336, 111, '2015-01-15 01:24:54.000000', 'temperatura', 244.0000, 'ºC'),
	(27337, 111, '2015-01-15 01:24:55.000000', 'temperatura', 62.0000, 'ºC'),
	(27338, 111, '2015-01-15 01:24:56.000000', 'temperatura', 776.0000, 'ºC'),
	(27339, 111, '2015-01-15 01:24:57.000000', 'temperatura', 97.0000, 'ºC'),
	(27340, 111, '2015-01-15 01:24:58.000000', 'temperatura', 558.0000, 'ºC'),
	(27341, 111, '2015-01-15 01:24:59.000000', 'temperatura', 99.0000, 'ºC'),
	(27342, 111, '2015-01-15 01:25:00.000000', 'temperatura', 20.0000, 'ºC'),
	(27343, 111, '2015-01-15 01:25:01.000000', 'temperatura', 1003.0000, 'ºC'),
	(27344, 111, '2015-01-15 01:25:02.000000', 'temperatura', 154.0000, 'ºC'),
	(27345, 111, '2015-01-15 01:25:03.000000', 'temperatura', 165.0000, 'ºC'),
	(27346, 111, '2015-01-15 01:25:04.000000', 'temperatura', 360.0000, 'ºC'),
	(27347, 111, '2015-01-15 01:25:05.000000', 'temperatura', 108.0000, 'ºC'),
	(27348, 111, '2015-01-15 01:25:06.000000', 'temperatura', 662.0000, 'ºC'),
	(27349, 111, '2015-01-15 01:25:07.000000', 'temperatura', 584.0000, 'ºC'),
	(27350, 111, '2015-01-15 01:25:08.000000', 'temperatura', 936.0000, 'ºC'),
	(27351, 111, '2015-01-15 01:25:09.000000', 'temperatura', 529.0000, 'ºC'),
	(27352, 111, '2015-01-15 01:25:10.000000', 'temperatura', 1036.0000, 'ºC'),
	(27353, 111, '2015-01-15 01:25:11.000000', 'temperatura', 1196.0000, 'ºC'),
	(27354, 111, '2015-01-15 01:25:12.000000', 'temperatura', 470.0000, 'ºC'),
	(27355, 111, '2015-01-15 01:25:13.000000', 'temperatura', 1164.0000, 'ºC'),
	(27356, 111, '2015-01-15 01:25:14.000000', 'temperatura', 810.0000, 'ºC'),
	(27357, 111, '2015-01-15 01:25:15.000000', 'temperatura', 557.0000, 'ºC'),
	(27358, 111, '2015-01-15 01:25:16.000000', 'temperatura', 358.0000, 'ºC'),
	(27359, 111, '2015-01-15 01:25:17.000000', 'temperatura', 120.0000, 'ºC'),
	(27360, 111, '2015-01-15 01:25:18.000000', 'temperatura', 726.0000, 'ºC'),
	(27361, 111, '2015-01-15 01:25:19.000000', 'temperatura', 868.0000, 'ºC'),
	(27362, 111, '2015-01-15 01:25:20.000000', 'temperatura', 965.0000, 'ºC'),
	(27363, 111, '2015-01-15 01:25:21.000000', 'temperatura', 1020.0000, 'ºC'),
	(27364, 111, '2015-01-15 01:25:22.000000', 'temperatura', 1006.0000, 'ºC'),
	(27365, 111, '2015-01-15 01:25:23.000000', 'temperatura', 769.0000, 'ºC'),
	(27366, 111, '2015-01-15 01:25:24.000000', 'temperatura', 828.0000, 'ºC'),
	(27367, 111, '2015-01-15 01:25:25.000000', 'temperatura', 632.0000, 'ºC'),
	(27368, 111, '2015-01-15 01:25:26.000000', 'temperatura', 678.0000, 'ºC'),
	(27369, 111, '2015-01-15 01:25:27.000000', 'temperatura', 293.0000, 'ºC'),
	(27370, 111, '2015-01-15 01:25:28.000000', 'temperatura', 634.0000, 'ºC'),
	(27371, 111, '2015-01-15 01:25:29.000000', 'temperatura', 1091.0000, 'ºC'),
	(27372, 111, '2015-01-15 01:25:30.000000', 'temperatura', 1152.0000, 'ºC'),
	(27373, 111, '2015-01-15 01:25:31.000000', 'temperatura', 89.0000, 'ºC'),
	(27374, 111, '2015-01-15 01:25:32.000000', 'temperatura', 590.0000, 'ºC'),
	(27375, 111, '2015-01-15 01:25:33.000000', 'temperatura', 283.0000, 'ºC'),
	(27376, 111, '2015-01-15 01:25:34.000000', 'temperatura', 844.0000, 'ºC'),
	(27377, 111, '2015-01-15 01:25:35.000000', 'temperatura', 973.0000, 'ºC'),
	(27378, 111, '2015-01-15 01:25:36.000000', 'temperatura', 1134.0000, 'ºC'),
	(27379, 111, '2015-01-15 01:25:37.000000', 'temperatura', 350.0000, 'ºC'),
	(27380, 111, '2015-01-15 01:25:38.000000', 'temperatura', 749.0000, 'ºC'),
	(27381, 111, '2015-01-15 01:25:39.000000', 'temperatura', 297.0000, 'ºC'),
	(27382, 111, '2015-01-15 01:25:40.000000', 'temperatura', 440.0000, 'ºC'),
	(27383, 111, '2015-01-15 01:25:41.000000', 'temperatura', 106.0000, 'ºC'),
	(27384, 111, '2015-01-15 01:25:42.000000', 'temperatura', 412.0000, 'ºC'),
	(27385, 111, '2015-01-15 01:25:43.000000', 'temperatura', 541.0000, 'ºC'),
	(27386, 111, '2015-01-15 01:25:44.000000', 'temperatura', 270.0000, 'ºC'),
	(27387, 111, '2015-01-15 01:25:45.000000', 'temperatura', 929.0000, 'ºC'),
	(27388, 111, '2015-01-15 01:25:46.000000', 'temperatura', 234.0000, 'ºC'),
	(27389, 111, '2015-01-15 01:25:47.000000', 'temperatura', 783.0000, 'ºC'),
	(27390, 111, '2015-01-15 01:25:48.000000', 'temperatura', 816.0000, 'ºC'),
	(27391, 111, '2015-01-15 01:25:49.000000', 'temperatura', 529.0000, 'ºC'),
	(27392, 111, '2015-01-15 01:25:50.000000', 'temperatura', 200.0000, 'ºC'),
	(27393, 111, '2015-01-15 01:25:51.000000', 'temperatura', 614.0000, 'ºC'),
	(27394, 111, '2015-01-15 01:25:52.000000', 'temperatura', 69.0000, 'ºC'),
	(27395, 111, '2015-01-15 01:25:53.000000', 'temperatura', 905.0000, 'ºC'),
	(27396, 111, '2015-01-15 01:25:54.000000', 'temperatura', 719.0000, 'ºC'),
	(27397, 111, '2015-01-15 01:25:55.000000', 'temperatura', 878.0000, 'ºC'),
	(27398, 111, '2015-01-15 01:25:56.000000', 'temperatura', 1033.0000, 'ºC'),
	(27399, 111, '2015-01-15 01:25:57.000000', 'temperatura', 131.0000, 'ºC'),
	(27400, 111, '2015-01-15 01:25:58.000000', 'temperatura', 1157.0000, 'ºC'),
	(27401, 111, '2015-01-15 01:25:59.000000', 'temperatura', 595.0000, 'ºC'),
	(27402, 111, '2015-01-15 01:26:00.000000', 'temperatura', 703.0000, 'ºC'),
	(27403, 111, '2015-01-15 01:26:01.000000', 'temperatura', 529.0000, 'ºC'),
	(27404, 111, '2015-01-15 01:26:02.000000', 'temperatura', 538.0000, 'ºC'),
	(27405, 111, '2015-01-15 01:26:03.000000', 'temperatura', 1102.0000, 'ºC'),
	(27406, 111, '2015-01-15 01:26:04.000000', 'temperatura', 299.0000, 'ºC'),
	(27407, 111, '2015-01-15 01:26:05.000000', 'temperatura', 588.0000, 'ºC'),
	(27408, 111, '2015-01-15 01:26:06.000000', 'temperatura', 845.0000, 'ºC'),
	(27409, 111, '2015-01-15 01:26:07.000000', 'temperatura', 60.0000, 'ºC'),
	(27410, 111, '2015-01-15 01:26:08.000000', 'temperatura', 165.0000, 'ºC'),
	(27411, 111, '2015-01-15 01:26:09.000000', 'temperatura', 646.0000, 'ºC'),
	(27412, 111, '2015-01-15 01:26:10.000000', 'temperatura', 336.0000, 'ºC'),
	(27413, 111, '2015-01-15 01:26:11.000000', 'temperatura', 941.0000, 'ºC'),
	(27414, 111, '2015-01-15 01:26:12.000000', 'temperatura', 97.0000, 'ºC'),
	(27415, 111, '2015-01-15 01:26:13.000000', 'temperatura', 64.0000, 'ºC'),
	(27416, 111, '2015-01-15 01:26:14.000000', 'temperatura', 28.0000, 'ºC'),
	(27417, 111, '2015-01-15 01:26:15.000000', 'temperatura', 1150.0000, 'ºC'),
	(27418, 111, '2015-01-15 01:26:16.000000', 'temperatura', 867.0000, 'ºC'),
	(27419, 111, '2015-01-15 01:26:17.000000', 'temperatura', 885.0000, 'ºC'),
	(27420, 111, '2015-01-15 01:26:18.000000', 'temperatura', 624.0000, 'ºC'),
	(27421, 111, '2015-01-15 01:26:19.000000', 'temperatura', 465.0000, 'ºC'),
	(27422, 111, '2015-01-15 01:26:20.000000', 'temperatura', 456.0000, 'ºC'),
	(27423, 111, '2015-01-15 01:26:21.000000', 'temperatura', 882.0000, 'ºC'),
	(27424, 111, '2015-01-15 01:26:22.000000', 'temperatura', 646.0000, 'ºC'),
	(27425, 111, '2015-01-15 01:26:23.000000', 'temperatura', 583.0000, 'ºC'),
	(27426, 111, '2015-01-15 01:26:24.000000', 'temperatura', 978.0000, 'ºC'),
	(27427, 111, '2015-01-15 01:26:25.000000', 'temperatura', 739.0000, 'ºC'),
	(27428, 111, '2015-01-15 01:26:26.000000', 'temperatura', 763.0000, 'ºC'),
	(27429, 111, '2015-01-15 01:26:27.000000', 'temperatura', 400.0000, 'ºC'),
	(27430, 111, '2015-01-15 01:26:28.000000', 'temperatura', 909.0000, 'ºC'),
	(27431, 111, '2015-01-15 01:26:29.000000', 'temperatura', 948.0000, 'ºC'),
	(27432, 111, '2015-01-15 01:26:30.000000', 'temperatura', 811.0000, 'ºC'),
	(27433, 111, '2015-01-15 01:26:31.000000', 'temperatura', 12.0000, 'ºC'),
	(27434, 111, '2015-01-15 01:26:32.000000', 'temperatura', 29.0000, 'ºC'),
	(27435, 111, '2015-01-15 01:26:33.000000', 'temperatura', 108.0000, 'ºC'),
	(27436, 111, '2015-01-15 01:26:34.000000', 'temperatura', 454.0000, 'ºC'),
	(27437, 111, '2015-01-15 01:26:35.000000', 'temperatura', 746.0000, 'ºC'),
	(27438, 111, '2015-01-15 01:26:36.000000', 'temperatura', 1167.0000, 'ºC'),
	(27439, 111, '2015-01-15 01:26:37.000000', 'temperatura', 0.0000, 'ºC'),
	(27440, 111, '2015-01-15 01:26:38.000000', 'temperatura', 101.0000, 'ºC'),
	(27441, 111, '2015-01-15 01:26:39.000000', 'temperatura', 503.0000, 'ºC'),
	(27442, 111, '2015-01-15 01:26:40.000000', 'temperatura', 1011.0000, 'ºC'),
	(27443, 111, '2015-01-15 01:26:41.000000', 'temperatura', 1149.0000, 'ºC'),
	(27444, 111, '2015-01-15 01:26:42.000000', 'temperatura', 312.0000, 'ºC'),
	(27445, 111, '2015-01-15 01:26:43.000000', 'temperatura', 514.0000, 'ºC'),
	(27446, 111, '2015-01-15 01:26:44.000000', 'temperatura', 434.0000, 'ºC'),
	(27447, 111, '2015-01-15 01:26:45.000000', 'temperatura', 628.0000, 'ºC'),
	(27448, 111, '2015-01-15 01:26:46.000000', 'temperatura', 637.0000, 'ºC'),
	(27449, 111, '2015-01-15 01:26:47.000000', 'temperatura', 105.0000, 'ºC'),
	(27450, 111, '2015-01-15 01:26:48.000000', 'temperatura', 1012.0000, 'ºC'),
	(27451, 111, '2015-01-15 01:26:49.000000', 'temperatura', 1144.0000, 'ºC'),
	(27452, 111, '2015-01-15 01:26:50.000000', 'temperatura', 286.0000, 'ºC'),
	(27453, 111, '2015-01-15 01:26:51.000000', 'temperatura', 399.0000, 'ºC'),
	(27454, 111, '2015-01-15 01:26:52.000000', 'temperatura', 1139.0000, 'ºC'),
	(27455, 111, '2015-01-15 01:26:53.000000', 'temperatura', 898.0000, 'ºC'),
	(27456, 111, '2015-01-15 01:26:54.000000', 'temperatura', 1074.0000, 'ºC'),
	(27457, 111, '2015-01-15 01:26:55.000000', 'temperatura', 277.0000, 'ºC'),
	(27458, 111, '2015-01-15 01:26:56.000000', 'temperatura', 561.0000, 'ºC'),
	(27459, 111, '2015-01-15 01:26:57.000000', 'temperatura', 777.0000, 'ºC'),
	(27460, 111, '2015-01-15 01:26:58.000000', 'temperatura', 1001.0000, 'ºC'),
	(27461, 111, '2015-01-15 01:26:59.000000', 'temperatura', 276.0000, 'ºC'),
	(27462, 111, '2015-01-15 01:27:00.000000', 'temperatura', 777.0000, 'ºC'),
	(27463, 111, '2015-01-15 01:27:01.000000', 'temperatura', 657.0000, 'ºC'),
	(27464, 111, '2015-01-15 01:27:02.000000', 'temperatura', 953.0000, 'ºC'),
	(27465, 111, '2015-01-15 01:27:03.000000', 'temperatura', 394.0000, 'ºC'),
	(27466, 111, '2015-01-15 01:27:04.000000', 'temperatura', 312.0000, 'ºC'),
	(27467, 111, '2015-01-15 01:27:05.000000', 'temperatura', 381.0000, 'ºC'),
	(27468, 111, '2015-01-15 01:27:06.000000', 'temperatura', 967.0000, 'ºC'),
	(27469, 111, '2015-01-15 01:27:07.000000', 'temperatura', 91.0000, 'ºC'),
	(27470, 111, '2015-01-15 01:27:08.000000', 'temperatura', 1157.0000, 'ºC'),
	(27471, 111, '2015-01-15 01:27:09.000000', 'temperatura', 711.0000, 'ºC'),
	(27472, 111, '2015-01-15 01:27:10.000000', 'temperatura', 84.0000, 'ºC'),
	(27473, 111, '2015-01-15 01:27:11.000000', 'temperatura', 688.0000, 'ºC'),
	(27474, 111, '2015-01-15 01:27:12.000000', 'temperatura', 790.0000, 'ºC'),
	(27475, 111, '2015-01-15 01:27:13.000000', 'temperatura', 687.0000, 'ºC'),
	(27476, 111, '2015-01-15 01:27:14.000000', 'temperatura', 1063.0000, 'ºC'),
	(27477, 111, '2015-01-15 01:27:15.000000', 'temperatura', 857.0000, 'ºC'),
	(27478, 111, '2015-01-15 01:27:16.000000', 'temperatura', 1094.0000, 'ºC'),
	(27479, 111, '2015-01-15 01:27:17.000000', 'temperatura', 502.0000, 'ºC'),
	(27480, 111, '2015-01-15 01:27:18.000000', 'temperatura', 426.0000, 'ºC'),
	(27481, 111, '2015-01-15 01:27:19.000000', 'temperatura', 625.0000, 'ºC'),
	(27482, 111, '2015-01-15 01:27:20.000000', 'temperatura', 650.0000, 'ºC'),
	(27483, 111, '2015-01-15 01:27:21.000000', 'temperatura', 172.0000, 'ºC'),
	(27484, 111, '2015-01-15 01:27:22.000000', 'temperatura', 113.0000, 'ºC'),
	(27485, 111, '2015-01-15 01:27:23.000000', 'temperatura', 48.0000, 'ºC'),
	(27486, 111, '2015-01-15 01:27:24.000000', 'temperatura', 1102.0000, 'ºC'),
	(27487, 111, '2015-01-15 01:27:25.000000', 'temperatura', 566.0000, 'ºC'),
	(27488, 111, '2015-01-15 01:27:26.000000', 'temperatura', 726.0000, 'ºC'),
	(27489, 111, '2015-01-15 01:27:27.000000', 'temperatura', 731.0000, 'ºC'),
	(27490, 111, '2015-01-15 01:27:28.000000', 'temperatura', 278.0000, 'ºC'),
	(27491, 111, '2015-01-15 01:27:29.000000', 'temperatura', 397.0000, 'ºC'),
	(27492, 111, '2015-01-15 01:27:30.000000', 'temperatura', 1150.0000, 'ºC'),
	(27493, 111, '2015-01-15 01:27:31.000000', 'temperatura', 963.0000, 'ºC'),
	(27494, 111, '2015-01-15 01:27:32.000000', 'temperatura', 163.0000, 'ºC'),
	(27495, 111, '2015-01-15 01:27:33.000000', 'temperatura', 328.0000, 'ºC'),
	(27496, 111, '2015-01-15 01:27:34.000000', 'temperatura', 1150.0000, 'ºC'),
	(27497, 111, '2015-01-15 01:27:35.000000', 'temperatura', 1166.0000, 'ºC'),
	(27498, 111, '2015-01-15 01:27:36.000000', 'temperatura', 1181.0000, 'ºC'),
	(27499, 111, '2015-01-15 01:27:37.000000', 'temperatura', 7.0000, 'ºC'),
	(27500, 111, '2015-01-15 01:27:38.000000', 'temperatura', 95.0000, 'ºC'),
	(27501, 111, '2015-01-15 01:27:39.000000', 'temperatura', 451.0000, 'ºC'),
	(27502, 111, '2015-01-15 01:27:40.000000', 'temperatura', 773.0000, 'ºC'),
	(27503, 111, '2015-01-15 01:27:41.000000', 'temperatura', 113.0000, 'ºC'),
	(27504, 111, '2015-01-15 01:27:42.000000', 'temperatura', 648.0000, 'ºC'),
	(27505, 111, '2015-01-15 01:27:43.000000', 'temperatura', 498.0000, 'ºC'),
	(27506, 111, '2015-01-15 01:27:44.000000', 'temperatura', 549.0000, 'ºC'),
	(27507, 111, '2015-01-15 01:27:45.000000', 'temperatura', 51.0000, 'ºC'),
	(27508, 111, '2015-01-15 01:27:46.000000', 'temperatura', 1010.0000, 'ºC'),
	(27509, 111, '2015-01-15 01:27:47.000000', 'temperatura', 95.0000, 'ºC'),
	(27510, 111, '2015-01-15 01:27:48.000000', 'temperatura', 1045.0000, 'ºC'),
	(27511, 111, '2015-01-15 01:27:49.000000', 'temperatura', 141.0000, 'ºC'),
	(27512, 111, '2015-01-15 01:27:50.000000', 'temperatura', 1172.0000, 'ºC'),
	(27513, 111, '2015-01-15 01:27:51.000000', 'temperatura', 638.0000, 'ºC'),
	(27514, 111, '2015-01-15 01:27:52.000000', 'temperatura', 873.0000, 'ºC'),
	(27515, 111, '2015-01-15 01:27:53.000000', 'temperatura', 53.0000, 'ºC'),
	(27516, 111, '2015-01-15 01:27:54.000000', 'temperatura', 45.0000, 'ºC'),
	(27517, 111, '2015-01-15 01:27:55.000000', 'temperatura', 67.0000, 'ºC'),
	(27518, 111, '2015-01-15 01:27:56.000000', 'temperatura', 199.0000, 'ºC'),
	(27519, 111, '2015-01-15 01:27:57.000000', 'temperatura', 794.0000, 'ºC'),
	(27520, 111, '2015-01-15 01:27:58.000000', 'temperatura', 975.0000, 'ºC'),
	(27521, 111, '2015-01-15 01:27:59.000000', 'temperatura', 94.0000, 'ºC'),
	(27522, 111, '2015-01-15 01:28:00.000000', 'temperatura', 1146.0000, 'ºC'),
	(27523, 111, '2015-01-15 01:28:01.000000', 'temperatura', 648.0000, 'ºC'),
	(27524, 111, '2015-01-15 01:28:02.000000', 'temperatura', 1001.0000, 'ºC'),
	(27525, 111, '2015-01-15 01:28:03.000000', 'temperatura', 663.0000, 'ºC'),
	(27526, 111, '2015-01-15 01:28:04.000000', 'temperatura', 314.0000, 'ºC'),
	(27527, 111, '2015-01-15 01:28:05.000000', 'temperatura', 779.0000, 'ºC'),
	(27528, 111, '2015-01-15 01:28:06.000000', 'temperatura', 555.0000, 'ºC'),
	(27529, 111, '2015-01-15 01:28:07.000000', 'temperatura', 439.0000, 'ºC'),
	(27530, 111, '2015-01-15 01:28:08.000000', 'temperatura', 530.0000, 'ºC'),
	(27531, 111, '2015-01-15 01:28:09.000000', 'temperatura', 133.0000, 'ºC'),
	(27532, 111, '2015-01-15 01:28:10.000000', 'temperatura', 274.0000, 'ºC'),
	(27533, 111, '2015-01-15 01:28:11.000000', 'temperatura', 974.0000, 'ºC'),
	(27534, 111, '2015-01-15 01:28:12.000000', 'temperatura', 448.0000, 'ºC'),
	(27535, 111, '2015-01-15 01:28:13.000000', 'temperatura', 518.0000, 'ºC'),
	(27536, 111, '2015-01-15 01:28:14.000000', 'temperatura', 48.0000, 'ºC'),
	(27537, 111, '2015-01-15 01:28:15.000000', 'temperatura', 1086.0000, 'ºC'),
	(27538, 111, '2015-01-15 01:28:16.000000', 'temperatura', 487.0000, 'ºC'),
	(27539, 111, '2015-01-15 01:28:17.000000', 'temperatura', 379.0000, 'ºC'),
	(27540, 111, '2015-01-15 01:28:18.000000', 'temperatura', 433.0000, 'ºC'),
	(27541, 111, '2015-01-15 01:28:19.000000', 'temperatura', 1029.0000, 'ºC'),
	(27542, 111, '2015-01-15 01:28:20.000000', 'temperatura', 245.0000, 'ºC'),
	(27543, 111, '2015-01-15 01:28:21.000000', 'temperatura', 539.0000, 'ºC'),
	(27544, 111, '2015-01-15 01:28:22.000000', 'temperatura', 762.0000, 'ºC'),
	(27545, 111, '2015-01-15 01:28:23.000000', 'temperatura', 991.0000, 'ºC'),
	(27546, 111, '2015-01-15 01:28:24.000000', 'temperatura', 271.0000, 'ºC'),
	(27547, 111, '2015-01-15 01:28:25.000000', 'temperatura', 781.0000, 'ºC'),
	(27548, 111, '2015-01-15 01:28:26.000000', 'temperatura', 696.0000, 'ºC'),
	(27549, 111, '2015-01-15 01:28:27.000000', 'temperatura', 1134.0000, 'ºC'),
	(27550, 111, '2015-01-15 01:28:28.000000', 'temperatura', 1182.0000, 'ºC'),
	(27551, 111, '2015-01-15 01:28:29.000000', 'temperatura', 109.0000, 'ºC'),
	(27552, 111, '2015-01-15 01:28:30.000000', 'temperatura', 598.0000, 'ºC'),
	(27553, 111, '2015-01-15 01:28:31.000000', 'temperatura', 266.0000, 'ºC'),
	(27554, 111, '2015-01-15 01:28:32.000000', 'temperatura', 734.0000, 'ºC'),
	(27555, 111, '2015-01-15 01:28:33.000000', 'temperatura', 475.0000, 'ºC'),
	(27556, 112, '2015-01-15 00:00:00.000000', 'temperatura', 646.0000, 'ºC'),
	(27557, 112, '2015-01-15 00:00:01.000000', 'temperatura', 307.0000, 'ºC'),
	(27558, 112, '2015-01-15 00:00:02.000000', 'temperatura', 798.0000, 'ºC'),
	(27559, 112, '2015-01-15 00:00:03.000000', 'temperatura', 671.0000, 'ºC'),
	(27560, 112, '2015-01-15 00:00:04.000000', 'temperatura', 960.0000, 'ºC'),
	(27561, 112, '2015-01-15 00:00:05.000000', 'temperatura', 390.0000, 'ºC'),
	(27562, 112, '2015-01-15 00:00:06.000000', 'temperatura', 267.0000, 'ºC'),
	(27563, 112, '2015-01-15 00:00:07.000000', 'temperatura', 168.0000, 'ºC'),
	(27564, 112, '2015-01-15 00:00:08.000000', 'temperatura', 38.0000, 'ºC'),
	(27565, 112, '2015-01-15 00:00:09.000000', 'temperatura', 886.0000, 'ºC'),
	(27566, 112, '2015-01-15 00:00:10.000000', 'temperatura', 717.0000, 'ºC'),
	(27567, 112, '2015-01-15 00:00:11.000000', 'temperatura', 927.0000, 'ºC'),
	(27568, 112, '2015-01-15 00:00:12.000000', 'temperatura', 86.0000, 'ºC'),
	(27569, 112, '2015-01-15 00:00:13.000000', 'temperatura', 49.0000, 'ºC'),
	(27570, 112, '2015-01-15 00:00:14.000000', 'temperatura', 1189.0000, 'ºC'),
	(27571, 112, '2015-01-15 00:00:15.000000', 'temperatura', 999.0000, 'ºC'),
	(27572, 112, '2015-01-15 00:00:16.000000', 'temperatura', 226.0000, 'ºC'),
	(27573, 112, '2015-01-15 00:00:17.000000', 'temperatura', 532.0000, 'ºC'),
	(27574, 112, '2015-01-15 00:00:18.000000', 'temperatura', 786.0000, 'ºC'),
	(27575, 112, '2015-01-15 00:00:19.000000', 'temperatura', 1132.0000, 'ºC'),
	(27576, 112, '2015-01-15 00:00:20.000000', 'temperatura', 903.0000, 'ºC'),
	(27577, 112, '2015-01-15 00:00:21.000000', 'temperatura', 1118.0000, 'ºC'),
	(27578, 112, '2015-01-15 00:00:22.000000', 'temperatura', 482.0000, 'ºC'),
	(27579, 112, '2015-01-15 00:00:23.000000', 'temperatura', 257.0000, 'ºC'),
	(27580, 112, '2015-01-15 00:00:24.000000', 'temperatura', 1039.0000, 'ºC'),
	(27581, 112, '2015-01-15 00:00:25.000000', 'temperatura', 825.0000, 'ºC'),
	(27582, 112, '2015-01-15 00:00:26.000000', 'temperatura', 1009.0000, 'ºC'),
	(27583, 112, '2015-01-15 00:00:27.000000', 'temperatura', 169.0000, 'ºC'),
	(27584, 112, '2015-01-15 00:00:28.000000', 'temperatura', 219.0000, 'ºC'),
	(27585, 112, '2015-01-15 00:00:29.000000', 'temperatura', 588.0000, 'ºC'),
	(27586, 112, '2015-01-15 00:00:30.000000', 'temperatura', 1083.0000, 'ºC'),
	(27587, 112, '2015-01-15 00:00:31.000000', 'temperatura', 54.0000, 'ºC'),
	(27588, 112, '2015-01-15 00:00:32.000000', 'temperatura', 621.0000, 'ºC'),
	(27589, 112, '2015-01-15 00:00:33.000000', 'temperatura', 544.0000, 'ºC'),
	(27590, 112, '2015-01-15 00:00:34.000000', 'temperatura', 858.0000, 'ºC'),
	(27591, 112, '2015-01-15 00:00:35.000000', 'temperatura', 259.0000, 'ºC'),
	(27592, 112, '2015-01-15 00:00:36.000000', 'temperatura', 1123.0000, 'ºC'),
	(27593, 112, '2015-01-15 00:00:37.000000', 'temperatura', 35.0000, 'ºC'),
	(27594, 112, '2015-01-15 00:00:38.000000', 'temperatura', 409.0000, 'ºC'),
	(27595, 112, '2015-01-15 00:00:39.000000', 'temperatura', 738.0000, 'ºC'),
	(27596, 112, '2015-01-15 00:00:40.000000', 'temperatura', 63.0000, 'ºC'),
	(27597, 112, '2015-01-15 00:00:41.000000', 'temperatura', 503.0000, 'ºC'),
	(27598, 112, '2015-01-15 00:00:42.000000', 'temperatura', 1125.0000, 'ºC'),
	(27599, 112, '2015-01-15 00:00:43.000000', 'temperatura', 516.0000, 'ºC'),
	(27600, 112, '2015-01-15 00:00:44.000000', 'temperatura', 407.0000, 'ºC'),
	(27601, 112, '2015-01-15 00:00:45.000000', 'temperatura', 489.0000, 'ºC'),
	(27602, 112, '2015-01-15 00:00:46.000000', 'temperatura', 24.0000, 'ºC'),
	(27603, 112, '2015-01-15 00:00:47.000000', 'temperatura', 1054.0000, 'ºC'),
	(27604, 112, '2015-01-15 00:00:48.000000', 'temperatura', 397.0000, 'ºC'),
	(27605, 112, '2015-01-15 00:00:49.000000', 'temperatura', 25.0000, 'ºC'),
	(27606, 112, '2015-01-15 00:00:50.000000', 'temperatura', 136.0000, 'ºC'),
	(27607, 112, '2015-01-15 00:00:51.000000', 'temperatura', 603.0000, 'ºC'),
	(27608, 112, '2015-01-15 00:00:52.000000', 'temperatura', 208.0000, 'ºC'),
	(27609, 112, '2015-01-15 00:00:53.000000', 'temperatura', 433.0000, 'ºC'),
	(27610, 112, '2015-01-15 00:00:54.000000', 'temperatura', 338.0000, 'ºC'),
	(27611, 112, '2015-01-15 00:00:55.000000', 'temperatura', 395.0000, 'ºC'),
	(27612, 112, '2015-01-15 00:00:56.000000', 'temperatura', 962.0000, 'ºC'),
	(27613, 112, '2015-01-15 00:00:57.000000', 'temperatura', 23.0000, 'ºC'),
	(27614, 112, '2015-01-15 00:00:58.000000', 'temperatura', 829.0000, 'ºC'),
	(27615, 112, '2015-01-15 00:00:59.000000', 'temperatura', 478.0000, 'ºC'),
	(27616, 112, '2015-01-15 00:01:00.000000', 'temperatura', 1103.0000, 'ºC'),
	(27617, 112, '2015-01-15 00:01:01.000000', 'temperatura', 481.0000, 'ºC'),
	(27618, 112, '2015-01-15 00:01:02.000000', 'temperatura', 298.0000, 'ºC'),
	(27619, 112, '2015-01-15 00:01:03.000000', 'temperatura', 45.0000, 'ºC'),
	(27620, 112, '2015-01-15 00:01:04.000000', 'temperatura', 531.0000, 'ºC'),
	(27621, 112, '2015-01-15 00:01:05.000000', 'temperatura', 123.0000, 'ºC'),
	(27622, 112, '2015-01-15 00:01:06.000000', 'temperatura', 220.0000, 'ºC'),
	(27623, 112, '2015-01-15 00:01:07.000000', 'temperatura', 733.0000, 'ºC'),
	(27624, 112, '2015-01-15 00:01:08.000000', 'temperatura', 607.0000, 'ºC'),
	(27625, 112, '2015-01-15 00:01:09.000000', 'temperatura', 834.0000, 'ºC'),
	(27626, 112, '2015-01-15 00:01:10.000000', 'temperatura', 1152.0000, 'ºC'),
	(27627, 112, '2015-01-15 00:01:11.000000', 'temperatura', 859.0000, 'ºC'),
	(27628, 112, '2015-01-15 00:01:12.000000', 'temperatura', 838.0000, 'ºC'),
	(27629, 112, '2015-01-15 00:01:13.000000', 'temperatura', 414.0000, 'ºC'),
	(27630, 112, '2015-01-15 00:01:14.000000', 'temperatura', 756.0000, 'ºC'),
	(27631, 112, '2015-01-15 00:01:15.000000', 'temperatura', 140.0000, 'ºC'),
	(27632, 112, '2015-01-15 00:01:16.000000', 'temperatura', 832.0000, 'ºC'),
	(27633, 112, '2015-01-15 00:01:17.000000', 'temperatura', 140.0000, 'ºC'),
	(27634, 112, '2015-01-15 00:01:18.000000', 'temperatura', 606.0000, 'ºC'),
	(27635, 112, '2015-01-15 00:01:19.000000', 'temperatura', 209.0000, 'ºC'),
	(27636, 112, '2015-01-15 00:01:20.000000', 'temperatura', 429.0000, 'ºC'),
	(27637, 112, '2015-01-15 00:01:21.000000', 'temperatura', 320.0000, 'ºC'),
	(27638, 112, '2015-01-15 00:01:22.000000', 'temperatura', 311.0000, 'ºC'),
	(27639, 112, '2015-01-15 00:01:23.000000', 'temperatura', 596.0000, 'ºC'),
	(27640, 112, '2015-01-15 00:01:24.000000', 'temperatura', 847.0000, 'ºC'),
	(27641, 112, '2015-01-15 00:01:25.000000', 'temperatura', 48.0000, 'ºC'),
	(27642, 112, '2015-01-15 00:01:26.000000', 'temperatura', 98.0000, 'ºC'),
	(27643, 112, '2015-01-15 00:01:27.000000', 'temperatura', 346.0000, 'ºC'),
	(27644, 112, '2015-01-15 00:01:28.000000', 'temperatura', 237.0000, 'ºC'),
	(27645, 112, '2015-01-15 00:01:29.000000', 'temperatura', 150.0000, 'ºC'),
	(27646, 112, '2015-01-15 00:01:30.000000', 'temperatura', 36.0000, 'ºC'),
	(27647, 112, '2015-01-15 00:01:31.000000', 'temperatura', 933.0000, 'ºC'),
	(27648, 112, '2015-01-15 00:01:32.000000', 'temperatura', 957.0000, 'ºC'),
	(27649, 112, '2015-01-15 00:01:33.000000', 'temperatura', 787.0000, 'ºC'),
	(27650, 112, '2015-01-15 00:01:34.000000', 'temperatura', 1064.0000, 'ºC'),
	(27651, 112, '2015-01-15 00:01:35.000000', 'temperatura', 559.0000, 'ºC'),
	(27652, 112, '2015-01-15 00:01:36.000000', 'temperatura', 802.0000, 'ºC'),
	(27653, 112, '2015-01-15 00:01:37.000000', 'temperatura', 1134.0000, 'ºC'),
	(27654, 112, '2015-01-15 00:01:38.000000', 'temperatura', 867.0000, 'ºC'),
	(27655, 112, '2015-01-15 00:01:39.000000', 'temperatura', 931.0000, 'ºC'),
	(27656, 112, '2015-01-15 00:01:40.000000', 'temperatura', 855.0000, 'ºC'),
	(27657, 112, '2015-01-15 00:01:41.000000', 'temperatura', 282.0000, 'ºC'),
	(27658, 112, '2015-01-15 00:01:42.000000', 'temperatura', 44.0000, 'ºC'),
	(27659, 112, '2015-01-15 00:01:43.000000', 'temperatura', 578.0000, 'ºC'),
	(27660, 112, '2015-01-15 00:01:44.000000', 'temperatura', 355.0000, 'ºC'),
	(27661, 112, '2015-01-15 00:01:45.000000', 'temperatura', 44.0000, 'ºC'),
	(27662, 112, '2015-01-15 00:01:46.000000', 'temperatura', 356.0000, 'ºC'),
	(27663, 112, '2015-01-15 00:01:47.000000', 'temperatura', 446.0000, 'ºC'),
	(27664, 112, '2015-01-15 00:01:48.000000', 'temperatura', 1162.0000, 'ºC'),
	(27665, 112, '2015-01-15 00:01:49.000000', 'temperatura', 873.0000, 'ºC'),
	(27666, 112, '2015-01-15 00:01:50.000000', 'temperatura', 882.0000, 'ºC'),
	(27667, 112, '2015-01-15 00:01:51.000000', 'temperatura', 590.0000, 'ºC'),
	(27668, 112, '2015-01-15 00:01:52.000000', 'temperatura', 305.0000, 'ºC'),
	(27669, 112, '2015-01-15 00:01:53.000000', 'temperatura', 957.0000, 'ºC'),
	(27670, 112, '2015-01-15 00:01:54.000000', 'temperatura', 269.0000, 'ºC'),
	(27671, 112, '2015-01-15 00:01:55.000000', 'temperatura', 874.0000, 'ºC'),
	(27672, 112, '2015-01-15 00:01:56.000000', 'temperatura', 1162.0000, 'ºC'),
	(27673, 112, '2015-01-15 00:01:57.000000', 'temperatura', 790.0000, 'ºC'),
	(27674, 112, '2015-01-15 00:01:58.000000', 'temperatura', 465.0000, 'ºC'),
	(27675, 112, '2015-01-15 00:01:59.000000', 'temperatura', 1155.0000, 'ºC'),
	(27676, 112, '2015-01-15 00:02:00.000000', 'temperatura', 782.0000, 'ºC'),
	(27677, 112, '2015-01-15 00:02:01.000000', 'temperatura', 445.0000, 'ºC'),
	(27678, 112, '2015-01-15 00:02:02.000000', 'temperatura', 1079.0000, 'ºC'),
	(27679, 112, '2015-01-15 00:02:03.000000', 'temperatura', 463.0000, 'ºC'),
	(27680, 112, '2015-01-15 00:02:04.000000', 'temperatura', 275.0000, 'ºC'),
	(27681, 112, '2015-01-15 00:02:05.000000', 'temperatura', 1190.0000, 'ºC'),
	(27682, 112, '2015-01-15 00:02:06.000000', 'temperatura', 323.0000, 'ºC'),
	(27683, 112, '2015-01-15 00:02:07.000000', 'temperatura', 447.0000, 'ºC'),
	(27684, 112, '2015-01-15 00:02:08.000000', 'temperatura', 68.0000, 'ºC'),
	(27685, 112, '2015-01-15 00:02:09.000000', 'temperatura', 196.0000, 'ºC'),
	(27686, 112, '2015-01-15 00:02:10.000000', 'temperatura', 778.0000, 'ºC'),
	(27687, 112, '2015-01-15 00:02:11.000000', 'temperatura', 903.0000, 'ºC'),
	(27688, 112, '2015-01-15 00:02:12.000000', 'temperatura', 979.0000, 'ºC'),
	(27689, 112, '2015-01-15 00:02:13.000000', 'temperatura', 989.0000, 'ºC'),
	(27690, 112, '2015-01-15 00:02:14.000000', 'temperatura', 808.0000, 'ºC'),
	(27691, 112, '2015-01-15 00:02:15.000000', 'temperatura', 1074.0000, 'ºC'),
	(27692, 112, '2015-01-15 00:02:16.000000', 'temperatura', 547.0000, 'ºC'),
	(27693, 112, '2015-01-15 00:02:17.000000', 'temperatura', 713.0000, 'ºC'),
	(27694, 112, '2015-01-15 00:02:18.000000', 'temperatura', 722.0000, 'ºC'),
	(27695, 112, '2015-01-15 00:02:19.000000', 'temperatura', 274.0000, 'ºC'),
	(27696, 112, '2015-01-15 00:02:20.000000', 'temperatura', 405.0000, 'ºC'),
	(27697, 112, '2015-01-15 00:02:21.000000', 'temperatura', 2.0000, 'ºC'),
	(27698, 112, '2015-01-15 00:02:22.000000', 'temperatura', 1198.0000, 'ºC'),
	(27699, 112, '2015-01-15 00:02:23.000000', 'temperatura', 1182.0000, 'ºC'),
	(27700, 112, '2015-01-15 00:02:24.000000', 'temperatura', 1116.0000, 'ºC'),
	(27701, 112, '2015-01-15 00:02:25.000000', 'temperatura', 835.0000, 'ºC'),
	(27702, 112, '2015-01-15 00:02:26.000000', 'temperatura', 827.0000, 'ºC'),
	(27703, 112, '2015-01-15 00:02:27.000000', 'temperatura', 431.0000, 'ºC'),
	(27704, 112, '2015-01-15 00:02:28.000000', 'temperatura', 873.0000, 'ºC'),
	(27705, 112, '2015-01-15 00:02:29.000000', 'temperatura', 673.0000, 'ºC'),
	(27706, 112, '2015-01-15 00:02:30.000000', 'temperatura', 746.0000, 'ºC'),
	(27707, 112, '2015-01-15 00:02:31.000000', 'temperatura', 511.0000, 'ºC'),
	(27708, 112, '2015-01-15 00:02:32.000000', 'temperatura', 320.0000, 'ºC'),
	(27709, 112, '2015-01-15 00:02:33.000000', 'temperatura', 68.0000, 'ºC'),
	(27710, 112, '2015-01-15 00:02:34.000000', 'temperatura', 579.0000, 'ºC'),
	(27711, 112, '2015-01-15 00:02:35.000000', 'temperatura', 290.0000, 'ºC'),
	(27712, 112, '2015-01-15 00:02:36.000000', 'temperatura', 915.0000, 'ºC'),
	(27713, 112, '2015-01-15 00:02:37.000000', 'temperatura', 104.0000, 'ºC'),
	(27714, 112, '2015-01-15 00:02:38.000000', 'temperatura', 177.0000, 'ºC'),
	(27715, 112, '2015-01-15 00:02:39.000000', 'temperatura', 571.0000, 'ºC'),
	(27716, 112, '2015-01-15 00:02:40.000000', 'temperatura', 1128.0000, 'ºC'),
	(27717, 112, '2015-01-15 00:02:41.000000', 'temperatura', 325.0000, 'ºC'),
	(27718, 112, '2015-01-15 00:02:42.000000', 'temperatura', 643.0000, 'ºC'),
	(27719, 112, '2015-01-15 00:02:43.000000', 'temperatura', 1038.0000, 'ºC'),
	(27720, 112, '2015-01-15 00:02:44.000000', 'temperatura', 862.0000, 'ºC'),
	(27721, 112, '2015-01-15 00:02:45.000000', 'temperatura', 1199.0000, 'ºC'),
	(27722, 112, '2015-01-15 00:02:46.000000', 'temperatura', 1007.0000, 'ºC'),
	(27723, 112, '2015-01-15 00:02:47.000000', 'temperatura', 238.0000, 'ºC'),
	(27724, 112, '2015-01-15 00:02:48.000000', 'temperatura', 569.0000, 'ºC'),
	(27725, 112, '2015-01-15 00:02:49.000000', 'temperatura', 935.0000, 'ºC'),
	(27726, 112, '2015-01-15 00:02:50.000000', 'temperatura', 565.0000, 'ºC'),
	(27727, 112, '2015-01-15 00:02:51.000000', 'temperatura', 23.0000, 'ºC'),
	(27728, 112, '2015-01-15 00:02:52.000000', 'temperatura', 818.0000, 'ºC'),
	(27729, 112, '2015-01-15 00:02:53.000000', 'temperatura', 421.0000, 'ºC'),
	(27730, 112, '2015-01-15 00:02:54.000000', 'temperatura', 853.0000, 'ºC'),
	(27731, 112, '2015-01-15 00:02:55.000000', 'temperatura', 600.0000, 'ºC'),
	(27732, 112, '2015-01-15 00:02:56.000000', 'temperatura', 444.0000, 'ºC'),
	(27733, 112, '2015-01-15 00:02:57.000000', 'temperatura', 420.0000, 'ºC'),
	(27734, 112, '2015-01-15 00:02:58.000000', 'temperatura', 767.0000, 'ºC'),
	(27735, 112, '2015-01-15 00:02:59.000000', 'temperatura', 178.0000, 'ºC'),
	(27736, 112, '2015-01-15 00:03:00.000000', 'temperatura', 987.0000, 'ºC'),
	(27737, 112, '2015-01-15 00:03:01.000000', 'temperatura', 802.0000, 'ºC'),
	(27738, 112, '2015-01-15 00:03:02.000000', 'temperatura', 1052.0000, 'ºC'),
	(27739, 112, '2015-01-15 00:03:03.000000', 'temperatura', 452.0000, 'ºC'),
	(27740, 112, '2015-01-15 00:03:04.000000', 'temperatura', 304.0000, 'ºC'),
	(27741, 112, '2015-01-15 00:03:05.000000', 'temperatura', 164.0000, 'ºC'),
	(27742, 112, '2015-01-15 00:03:06.000000', 'temperatura', 1111.0000, 'ºC'),
	(27743, 112, '2015-01-15 00:03:07.000000', 'temperatura', 264.0000, 'ºC'),
	(27744, 112, '2015-01-15 00:03:08.000000', 'temperatura', 388.0000, 'ºC'),
	(27745, 112, '2015-01-15 00:03:09.000000', 'temperatura', 1148.0000, 'ºC'),
	(27746, 112, '2015-01-15 00:03:10.000000', 'temperatura', 975.0000, 'ºC'),
	(27747, 112, '2015-01-15 00:03:11.000000', 'temperatura', 233.0000, 'ºC'),
	(27748, 112, '2015-01-15 00:03:12.000000', 'temperatura', 640.0000, 'ºC'),
	(27749, 112, '2015-01-15 00:03:13.000000', 'temperatura', 102.0000, 'ºC'),
	(27750, 112, '2015-01-15 00:03:14.000000', 'temperatura', 992.0000, 'ºC'),
	(27751, 112, '2015-01-15 00:03:15.000000', 'temperatura', 1053.0000, 'ºC'),
	(27752, 112, '2015-01-15 00:03:16.000000', 'temperatura', 1089.0000, 'ºC'),
	(27753, 112, '2015-01-15 00:03:17.000000', 'temperatura', 1089.0000, 'ºC'),
	(27754, 112, '2015-01-15 00:03:18.000000', 'temperatura', 976.0000, 'ºC'),
	(27755, 112, '2015-01-15 00:03:19.000000', 'temperatura', 416.0000, 'ºC'),
	(27756, 112, '2015-01-15 00:03:20.000000', 'temperatura', 351.0000, 'ºC'),
	(27757, 112, '2015-01-15 00:03:21.000000', 'temperatura', 509.0000, 'ºC'),
	(27758, 112, '2015-01-15 00:03:22.000000', 'temperatura', 292.0000, 'ºC'),
	(27759, 112, '2015-01-15 00:03:23.000000', 'temperatura', 1133.0000, 'ºC'),
	(27760, 112, '2015-01-15 00:03:24.000000', 'temperatura', 1188.0000, 'ºC'),
	(27761, 112, '2015-01-15 00:03:25.000000', 'temperatura', 141.0000, 'ºC'),
	(27762, 112, '2015-01-15 00:03:26.000000', 'temperatura', 745.0000, 'ºC'),
	(27763, 112, '2015-01-15 00:03:27.000000', 'temperatura', 899.0000, 'ºC'),
	(27764, 112, '2015-01-15 00:03:28.000000', 'temperatura', 1062.0000, 'ºC'),
	(27765, 112, '2015-01-15 00:03:29.000000', 'temperatura', 213.0000, 'ºC'),
	(27766, 112, '2015-01-15 00:03:30.000000', 'temperatura', 280.0000, 'ºC'),
	(27767, 112, '2015-01-15 00:03:31.000000', 'temperatura', 763.0000, 'ºC'),
	(27768, 112, '2015-01-15 00:03:32.000000', 'temperatura', 575.0000, 'ºC'),
	(27769, 112, '2015-01-15 00:03:33.000000', 'temperatura', 587.0000, 'ºC'),
	(27770, 112, '2015-01-15 00:03:34.000000', 'temperatura', 10.0000, 'ºC'),
	(27771, 112, '2015-01-15 00:03:35.000000', 'temperatura', 690.0000, 'ºC'),
	(27772, 112, '2015-01-15 00:03:36.000000', 'temperatura', 1019.0000, 'ºC'),
	(27773, 112, '2015-01-15 00:03:37.000000', 'temperatura', 624.0000, 'ºC'),
	(27774, 112, '2015-01-15 00:03:38.000000', 'temperatura', 66.0000, 'ºC'),
	(27775, 112, '2015-01-15 00:03:39.000000', 'temperatura', 859.0000, 'ºC'),
	(27776, 112, '2015-01-15 00:03:40.000000', 'temperatura', 499.0000, 'ºC'),
	(27777, 112, '2015-01-15 00:03:41.000000', 'temperatura', 1115.0000, 'ºC'),
	(27778, 112, '2015-01-15 00:03:42.000000', 'temperatura', 480.0000, 'ºC'),
	(27779, 112, '2015-01-15 00:03:43.000000', 'temperatura', 254.0000, 'ºC'),
	(27780, 112, '2015-01-15 00:03:44.000000', 'temperatura', 1033.0000, 'ºC'),
	(27781, 112, '2015-01-15 00:03:45.000000', 'temperatura', 801.0000, 'ºC'),
	(27782, 112, '2015-01-15 00:03:46.000000', 'temperatura', 907.0000, 'ºC'),
	(27783, 112, '2015-01-15 00:03:47.000000', 'temperatura', 932.0000, 'ºC'),
	(27784, 112, '2015-01-15 00:03:48.000000', 'temperatura', 740.0000, 'ºC'),
	(27785, 112, '2015-01-15 00:03:49.000000', 'temperatura', 904.0000, 'ºC'),
	(27786, 112, '2015-01-15 00:03:50.000000', 'temperatura', 1102.0000, 'ºC'),
	(27787, 112, '2015-01-15 00:03:51.000000', 'temperatura', 398.0000, 'ºC'),
	(27788, 112, '2015-01-15 00:03:52.000000', 'temperatura', 1083.0000, 'ºC'),
	(27789, 112, '2015-01-15 00:03:53.000000', 'temperatura', 620.0000, 'ºC'),
	(27790, 112, '2015-01-15 00:03:54.000000', 'temperatura', 1055.0000, 'ºC'),
	(27791, 112, '2015-01-15 00:03:55.000000', 'temperatura', 1015.0000, 'ºC'),
	(27792, 112, '2015-01-15 00:03:56.000000', 'temperatura', 711.0000, 'ºC'),
	(27793, 112, '2015-01-15 00:03:57.000000', 'temperatura', 510.0000, 'ºC'),
	(27794, 112, '2015-01-15 00:03:58.000000', 'temperatura', 417.0000, 'ºC'),
	(27795, 112, '2015-01-15 00:03:59.000000', 'temperatura', 554.0000, 'ºC'),
	(27796, 112, '2015-01-15 00:04:00.000000', 'temperatura', 321.0000, 'ºC'),
	(27797, 112, '2015-01-15 00:04:01.000000', 'temperatura', 1142.0000, 'ºC'),
	(27798, 112, '2015-01-15 00:04:02.000000', 'temperatura', 1150.0000, 'ºC'),
	(27799, 112, '2015-01-15 00:04:03.000000', 'temperatura', 1125.0000, 'ºC'),
	(27800, 112, '2015-01-15 00:04:04.000000', 'temperatura', 976.0000, 'ºC'),
	(27801, 112, '2015-01-15 00:04:05.000000', 'temperatura', 304.0000, 'ºC'),
	(27802, 112, '2015-01-15 00:04:06.000000', 'temperatura', 991.0000, 'ºC'),
	(27803, 112, '2015-01-15 00:04:07.000000', 'temperatura', 446.0000, 'ºC'),
	(27804, 112, '2015-01-15 00:04:08.000000', 'temperatura', 457.0000, 'ºC'),
	(27805, 112, '2015-01-15 00:04:09.000000', 'temperatura', 947.0000, 'ºC'),
	(27806, 112, '2015-01-15 00:04:10.000000', 'temperatura', 967.0000, 'ºC'),
	(27807, 112, '2015-01-15 00:04:11.000000', 'temperatura', 792.0000, 'ºC'),
	(27808, 112, '2015-01-15 00:04:12.000000', 'temperatura', 1060.0000, 'ºC'),
	(27809, 112, '2015-01-15 00:04:13.000000', 'temperatura', 525.0000, 'ºC'),
	(27810, 112, '2015-01-15 00:04:14.000000', 'temperatura', 645.0000, 'ºC'),
	(27811, 112, '2015-01-15 00:04:15.000000', 'temperatura', 451.0000, 'ºC'),
	(27812, 112, '2015-01-15 00:04:16.000000', 'temperatura', 321.0000, 'ºC'),
	(27813, 112, '2015-01-15 00:04:17.000000', 'temperatura', 253.0000, 'ºC'),
	(27814, 112, '2015-01-15 00:04:18.000000', 'temperatura', 303.0000, 'ºC'),
	(27815, 112, '2015-01-15 00:04:19.000000', 'temperatura', 758.0000, 'ºC'),
	(27816, 112, '2015-01-15 00:04:20.000000', 'temperatura', 479.0000, 'ºC'),
	(27817, 112, '2015-01-15 00:04:21.000000', 'temperatura', 121.0000, 'ºC'),
	(27818, 112, '2015-01-15 00:04:22.000000', 'temperatura', 367.0000, 'ºC'),
	(27819, 112, '2015-01-15 00:04:23.000000', 'temperatura', 276.0000, 'ºC'),
	(27820, 112, '2015-01-15 00:04:24.000000', 'temperatura', 278.0000, 'ºC'),
	(27821, 112, '2015-01-15 00:04:25.000000', 'temperatura', 563.0000, 'ºC'),
	(27822, 112, '2015-01-15 00:04:26.000000', 'temperatura', 780.0000, 'ºC'),
	(27823, 112, '2015-01-15 00:04:27.000000', 'temperatura', 1011.0000, 'ºC'),
	(27824, 112, '2015-01-15 00:04:28.000000', 'temperatura', 314.0000, 'ºC'),
	(27825, 112, '2015-01-15 00:04:29.000000', 'temperatura', 941.0000, 'ºC'),
	(27826, 112, '2015-01-15 00:04:30.000000', 'temperatura', 162.0000, 'ºC'),
	(27827, 112, '2015-01-15 00:04:31.000000', 'temperatura', 388.0000, 'ºC'),
	(27828, 112, '2015-01-15 00:04:32.000000', 'temperatura', 253.0000, 'ºC'),
	(27829, 112, '2015-01-15 00:04:33.000000', 'temperatura', 103.0000, 'ºC'),
	(27830, 112, '2015-01-15 00:04:34.000000', 'temperatura', 958.0000, 'ºC'),
	(27831, 112, '2015-01-15 00:04:35.000000', 'temperatura', 881.0000, 'ºC'),
	(27832, 112, '2015-01-15 00:04:36.000000', 'temperatura', 329.0000, 'ºC'),
	(27833, 112, '2015-01-15 00:04:37.000000', 'temperatura', 204.0000, 'ºC'),
	(27834, 112, '2015-01-15 00:04:38.000000', 'temperatura', 34.0000, 'ºC'),
	(27835, 112, '2015-01-15 00:04:39.000000', 'temperatura', 759.0000, 'ºC'),
	(27836, 112, '2015-01-15 00:04:40.000000', 'temperatura', 93.0000, 'ºC'),
	(27837, 112, '2015-01-15 00:04:41.000000', 'temperatura', 586.0000, 'ºC'),
	(27838, 112, '2015-01-15 00:04:42.000000', 'temperatura', 255.0000, 'ºC'),
	(27839, 112, '2015-01-15 00:04:43.000000', 'temperatura', 714.0000, 'ºC'),
	(27840, 112, '2015-01-15 00:04:44.000000', 'temperatura', 408.0000, 'ºC'),
	(27841, 112, '2015-01-15 00:04:45.000000', 'temperatura', 1099.0000, 'ºC'),
	(27842, 112, '2015-01-15 00:04:46.000000', 'temperatura', 671.0000, 'ºC'),
	(27843, 112, '2015-01-15 00:04:47.000000', 'temperatura', 57.0000, 'ºC'),
	(27844, 112, '2015-01-15 00:04:48.000000', 'temperatura', 675.0000, 'ºC'),
	(27845, 112, '2015-01-15 00:04:49.000000', 'temperatura', 803.0000, 'ºC'),
	(27846, 112, '2015-01-15 00:04:50.000000', 'temperatura', 790.0000, 'ºC'),
	(27847, 112, '2015-01-15 00:04:51.000000', 'temperatura', 341.0000, 'ºC'),
	(27848, 112, '2015-01-15 00:04:52.000000', 'temperatura', 538.0000, 'ºC'),
	(27849, 112, '2015-01-15 00:04:53.000000', 'temperatura', 467.0000, 'ºC'),
	(27850, 112, '2015-01-15 00:04:54.000000', 'temperatura', 721.0000, 'ºC'),
	(27851, 112, '2015-01-15 00:04:55.000000', 'temperatura', 1003.0000, 'ºC'),
	(27852, 112, '2015-01-15 00:04:56.000000', 'temperatura', 455.0000, 'ºC'),
	(27853, 112, '2015-01-15 00:04:57.000000', 'temperatura', 467.0000, 'ºC'),
	(27854, 112, '2015-01-15 00:04:58.000000', 'temperatura', 970.0000, 'ºC'),
	(27855, 112, '2015-01-15 00:04:59.000000', 'temperatura', 1047.0000, 'ºC'),
	(27856, 112, '2015-01-15 00:05:00.000000', 'temperatura', 1128.0000, 'ºC'),
	(27857, 112, '2015-01-15 00:05:01.000000', 'temperatura', 98.0000, 'ºC'),
	(27858, 112, '2015-01-15 00:05:02.000000', 'temperatura', 708.0000, 'ºC'),
	(27859, 112, '2015-01-15 00:05:03.000000', 'temperatura', 845.0000, 'ºC'),
	(27860, 112, '2015-01-15 00:05:04.000000', 'temperatura', 903.0000, 'ºC'),
	(27861, 112, '2015-01-15 00:05:05.000000', 'temperatura', 780.0000, 'ºC'),
	(27862, 112, '2015-01-15 00:05:06.000000', 'temperatura', 1190.0000, 'ºC'),
	(27863, 112, '2015-01-15 00:05:07.000000', 'temperatura', 11.0000, 'ºC'),
	(27864, 112, '2015-01-15 00:05:08.000000', 'temperatura', 86.0000, 'ºC'),
	(27865, 112, '2015-01-15 00:05:09.000000', 'temperatura', 398.0000, 'ºC'),
	(27866, 112, '2015-01-15 00:05:10.000000', 'temperatura', 533.0000, 'ºC'),
	(27867, 112, '2015-01-15 00:05:11.000000', 'temperatura', 271.0000, 'ºC'),
	(27868, 112, '2015-01-15 00:05:12.000000', 'temperatura', 957.0000, 'ºC'),
	(27869, 112, '2015-01-15 00:05:13.000000', 'temperatura', 374.0000, 'ºC'),
	(27870, 112, '2015-01-15 00:05:14.000000', 'temperatura', 199.0000, 'ºC'),
	(27871, 112, '2015-01-15 00:05:15.000000', 'temperatura', 1072.0000, 'ºC'),
	(27872, 112, '2015-01-15 00:05:16.000000', 'temperatura', 1164.0000, 'ºC'),
	(27873, 112, '2015-01-15 00:05:17.000000', 'temperatura', 204.0000, 'ºC'),
	(27874, 112, '2015-01-15 00:05:18.000000', 'temperatura', 1129.0000, 'ºC'),
	(27875, 112, '2015-01-15 00:05:19.000000', 'temperatura', 233.0000, 'ºC'),
	(27876, 112, '2015-01-15 00:05:20.000000', 'temperatura', 180.0000, 'ºC'),
	(27877, 112, '2015-01-15 00:05:21.000000', 'temperatura', 201.0000, 'ºC'),
	(27878, 112, '2015-01-15 00:05:22.000000', 'temperatura', 465.0000, 'ºC'),
	(27879, 112, '2015-01-15 00:05:23.000000', 'temperatura', 522.0000, 'ºC'),
	(27880, 112, '2015-01-15 00:05:24.000000', 'temperatura', 15.0000, 'ºC'),
	(27881, 112, '2015-01-15 00:05:25.000000', 'temperatura', 908.0000, 'ºC'),
	(27882, 112, '2015-01-15 00:05:26.000000', 'temperatura', 899.0000, 'ºC'),
	(27883, 112, '2015-01-15 00:05:27.000000', 'temperatura', 571.0000, 'ºC'),
	(27884, 112, '2015-01-15 00:05:28.000000', 'temperatura', 157.0000, 'ºC'),
	(27885, 112, '2015-01-15 00:05:29.000000', 'temperatura', 273.0000, 'ºC'),
	(27886, 112, '2015-01-15 00:05:30.000000', 'temperatura', 895.0000, 'ºC'),
	(27887, 112, '2015-01-15 00:05:31.000000', 'temperatura', 58.0000, 'ºC'),
	(27888, 112, '2015-01-15 00:05:32.000000', 'temperatura', 3.0000, 'ºC'),
	(27889, 112, '2015-01-15 00:05:33.000000', 'temperatura', 1042.0000, 'ºC'),
	(27890, 112, '2015-01-15 00:05:34.000000', 'temperatura', 401.0000, 'ºC'),
	(27891, 112, '2015-01-15 00:05:35.000000', 'temperatura', 78.0000, 'ºC'),
	(27892, 112, '2015-01-15 00:05:36.000000', 'temperatura', 391.0000, 'ºC'),
	(27893, 112, '2015-01-15 00:05:37.000000', 'temperatura', 518.0000, 'ºC'),
	(27894, 112, '2015-01-15 00:05:38.000000', 'temperatura', 219.0000, 'ºC'),
	(27895, 112, '2015-01-15 00:05:39.000000', 'temperatura', 742.0000, 'ºC'),
	(27896, 112, '2015-01-15 00:05:40.000000', 'temperatura', 652.0000, 'ºC'),
	(27897, 112, '2015-01-15 00:05:41.000000', 'temperatura', 1035.0000, 'ºC'),
	(27898, 112, '2015-01-15 00:05:42.000000', 'temperatura', 822.0000, 'ºC'),
	(27899, 112, '2015-01-15 00:05:43.000000', 'temperatura', 1002.0000, 'ºC'),
	(27900, 112, '2015-01-15 00:05:44.000000', 'temperatura', 146.0000, 'ºC'),
	(27901, 112, '2015-01-15 00:05:45.000000', 'temperatura', 126.0000, 'ºC'),
	(27902, 112, '2015-01-15 00:05:46.000000', 'temperatura', 192.0000, 'ºC'),
	(27903, 112, '2015-01-15 00:05:47.000000', 'temperatura', 581.0000, 'ºC'),
	(27904, 112, '2015-01-15 00:05:48.000000', 'temperatura', 1129.0000, 'ºC'),
	(27905, 112, '2015-01-15 00:05:49.000000', 'temperatura', 305.0000, 'ºC'),
	(27906, 112, '2015-01-15 00:05:50.000000', 'temperatura', 536.0000, 'ºC'),
	(27907, 112, '2015-01-15 00:05:51.000000', 'temperatura', 567.0000, 'ºC'),
	(27908, 112, '2015-01-15 00:05:52.000000', 'temperatura', 28.0000, 'ºC'),
	(27909, 112, '2015-01-15 00:05:53.000000', 'temperatura', 840.0000, 'ºC'),
	(27910, 112, '2015-01-15 00:05:54.000000', 'temperatura', 516.0000, 'ºC'),
	(27911, 112, '2015-01-15 00:05:55.000000', 'temperatura', 60.0000, 'ºC'),
	(27912, 112, '2015-01-15 00:05:56.000000', 'temperatura', 1155.0000, 'ºC'),
	(27913, 112, '2015-01-15 00:05:57.000000', 'temperatura', 793.0000, 'ºC'),
	(27914, 112, '2015-01-15 00:05:58.000000', 'temperatura', 500.0000, 'ºC'),
	(27915, 112, '2015-01-15 00:05:59.000000', 'temperatura', 124.0000, 'ºC'),
	(27916, 112, '2015-01-15 00:06:00.000000', 'temperatura', 319.0000, 'ºC'),
	(27917, 112, '2015-01-15 00:06:01.000000', 'temperatura', 24.0000, 'ºC'),
	(27918, 112, '2015-01-15 00:06:02.000000', 'temperatura', 365.0000, 'ºC'),
	(27919, 112, '2015-01-15 00:06:03.000000', 'temperatura', 553.0000, 'ºC'),
	(27920, 112, '2015-01-15 00:06:04.000000', 'temperatura', 469.0000, 'ºC'),
	(27921, 112, '2015-01-15 00:06:05.000000', 'temperatura', 685.0000, 'ºC'),
	(27922, 112, '2015-01-15 00:06:06.000000', 'temperatura', 821.0000, 'ºC'),
	(27923, 112, '2015-01-15 00:06:07.000000', 'temperatura', 849.0000, 'ºC'),
	(27924, 112, '2015-01-15 00:06:08.000000', 'temperatura', 585.0000, 'ºC'),
	(27925, 112, '2015-01-15 00:06:09.000000', 'temperatura', 375.0000, 'ºC'),
	(27926, 112, '2015-01-15 00:06:10.000000', 'temperatura', 124.0000, 'ºC'),
	(27927, 112, '2015-01-15 00:06:11.000000', 'temperatura', 693.0000, 'ºC'),
	(27928, 112, '2015-01-15 00:06:12.000000', 'temperatura', 695.0000, 'ºC'),
	(27929, 112, '2015-01-15 00:06:13.000000', 'temperatura', 195.0000, 'ºC'),
	(27930, 112, '2015-01-15 00:06:14.000000', 'temperatura', 90.0000, 'ºC'),
	(27931, 112, '2015-01-15 00:06:15.000000', 'temperatura', 1068.0000, 'ºC'),
	(27932, 112, '2015-01-15 00:06:16.000000', 'temperatura', 268.0000, 'ºC'),
	(27933, 112, '2015-01-15 00:06:17.000000', 'temperatura', 537.0000, 'ºC'),
	(27934, 112, '2015-01-15 00:06:18.000000', 'temperatura', 682.0000, 'ºC'),
	(27935, 112, '2015-01-15 00:06:19.000000', 'temperatura', 601.0000, 'ºC'),
	(27936, 112, '2015-01-15 00:06:20.000000', 'temperatura', 957.0000, 'ºC'),
	(27937, 112, '2015-01-15 00:06:21.000000', 'temperatura', 583.0000, 'ºC'),
	(27938, 112, '2015-01-15 00:06:22.000000', 'temperatura', 45.0000, 'ºC'),
	(27939, 112, '2015-01-15 00:06:23.000000', 'temperatura', 878.0000, 'ºC'),
	(27940, 112, '2015-01-15 00:06:24.000000', 'temperatura', 654.0000, 'ºC'),
	(27941, 112, '2015-01-15 00:06:25.000000', 'temperatura', 637.0000, 'ºC'),
	(27942, 112, '2015-01-15 00:06:26.000000', 'temperatura', 22.0000, 'ºC'),
	(27943, 112, '2015-01-15 00:06:27.000000', 'temperatura', 600.0000, 'ºC'),
	(27944, 112, '2015-01-15 00:06:28.000000', 'temperatura', 535.0000, 'ºC'),
	(27945, 112, '2015-01-15 00:06:29.000000', 'temperatura', 876.0000, 'ºC'),
	(27946, 112, '2015-01-15 00:06:30.000000', 'temperatura', 377.0000, 'ºC'),
	(27947, 112, '2015-01-15 00:06:31.000000', 'temperatura', 455.0000, 'ºC'),
	(27948, 112, '2015-01-15 00:06:32.000000', 'temperatura', 1145.0000, 'ºC'),
	(27949, 112, '2015-01-15 00:06:33.000000', 'temperatura', 760.0000, 'ºC'),
	(27950, 112, '2015-01-15 00:06:34.000000', 'temperatura', 366.0000, 'ºC'),
	(27951, 112, '2015-01-15 00:06:35.000000', 'temperatura', 751.0000, 'ºC'),
	(27952, 112, '2015-01-15 00:06:36.000000', 'temperatura', 256.0000, 'ºC'),
	(27953, 112, '2015-01-15 00:06:37.000000', 'temperatura', 228.0000, 'ºC'),
	(27954, 112, '2015-01-15 00:06:38.000000', 'temperatura', 374.0000, 'ºC'),
	(27955, 112, '2015-01-15 00:06:39.000000', 'temperatura', 1184.0000, 'ºC'),
	(27956, 112, '2015-01-15 00:06:40.000000', 'temperatura', 1198.0000, 'ºC'),
	(27957, 112, '2015-01-15 00:06:41.000000', 'temperatura', 41.0000, 'ºC'),
	(27958, 112, '2015-01-15 00:06:42.000000', 'temperatura', 213.0000, 'ºC'),
	(27959, 112, '2015-01-15 00:06:43.000000', 'temperatura', 939.0000, 'ºC'),
	(27960, 112, '2015-01-15 00:06:44.000000', 'temperatura', 458.0000, 'ºC'),
	(27961, 112, '2015-01-15 00:06:45.000000', 'temperatura', 675.0000, 'ºC'),
	(27962, 112, '2015-01-15 00:06:46.000000', 'temperatura', 798.0000, 'ºC'),
	(27963, 112, '2015-01-15 00:06:47.000000', 'temperatura', 769.0000, 'ºC'),
	(27964, 112, '2015-01-15 00:06:48.000000', 'temperatura', 249.0000, 'ºC'),
	(27965, 112, '2015-01-15 00:06:49.000000', 'temperatura', 141.0000, 'ºC'),
	(27966, 112, '2015-01-15 00:06:50.000000', 'temperatura', 1158.0000, 'ºC'),
	(27967, 112, '2015-01-15 00:06:51.000000', 'temperatura', 565.0000, 'ºC'),
	(27968, 112, '2015-01-15 00:06:52.000000', 'temperatura', 554.0000, 'ºC'),
	(27969, 112, '2015-01-15 00:06:53.000000', 'temperatura', 1077.0000, 'ºC'),
	(27970, 112, '2015-01-15 00:06:54.000000', 'temperatura', 121.0000, 'ºC'),
	(27971, 112, '2015-01-15 00:06:55.000000', 'temperatura', 974.0000, 'ºC'),
	(27972, 112, '2015-01-15 00:06:56.000000', 'temperatura', 907.0000, 'ºC'),
	(27973, 112, '2015-01-15 00:06:57.000000', 'temperatura', 413.0000, 'ºC'),
	(27974, 112, '2015-01-15 00:06:58.000000', 'temperatura', 547.0000, 'ºC'),
	(27975, 112, '2015-01-15 00:06:59.000000', 'temperatura', 295.0000, 'ºC'),
	(27976, 112, '2015-01-15 00:07:00.000000', 'temperatura', 1035.0000, 'ºC'),
	(27977, 112, '2015-01-15 00:07:01.000000', 'temperatura', 691.0000, 'ºC'),
	(27978, 112, '2015-01-15 00:07:02.000000', 'temperatura', 348.0000, 'ºC'),
	(27979, 112, '2015-01-15 00:07:03.000000', 'temperatura', 871.0000, 'ºC'),
	(27980, 112, '2015-01-15 00:07:04.000000', 'temperatura', 908.0000, 'ºC'),
	(27981, 112, '2015-01-15 00:07:05.000000', 'temperatura', 731.0000, 'ºC'),
	(27982, 112, '2015-01-15 00:07:06.000000', 'temperatura', 929.0000, 'ºC'),
	(27983, 112, '2015-01-15 00:07:07.000000', 'temperatura', 52.0000, 'ºC'),
	(27984, 112, '2015-01-15 00:07:08.000000', 'temperatura', 1073.0000, 'ºC'),
	(27985, 112, '2015-01-15 00:07:09.000000', 'temperatura', 412.0000, 'ºC'),
	(27986, 112, '2015-01-15 00:07:10.000000', 'temperatura', 38.0000, 'ºC'),
	(27987, 112, '2015-01-15 00:07:11.000000', 'temperatura', 158.0000, 'ºC'),
	(27988, 112, '2015-01-15 00:07:12.000000', 'temperatura', 676.0000, 'ºC'),
	(27989, 112, '2015-01-15 00:07:13.000000', 'temperatura', 508.0000, 'ºC'),
	(27990, 112, '2015-01-15 00:07:14.000000', 'temperatura', 509.0000, 'ºC'),
	(27991, 112, '2015-01-15 00:07:15.000000', 'temperatura', 1024.0000, 'ºC'),
	(27992, 112, '2015-01-15 00:07:16.000000', 'temperatura', 1193.0000, 'ºC'),
	(27993, 112, '2015-01-15 00:07:17.000000', 'temperatura', 492.0000, 'ºC'),
	(27994, 112, '2015-01-15 00:07:18.000000', 'temperatura', 83.0000, 'ºC'),
	(27995, 112, '2015-01-15 00:07:19.000000', 'temperatura', 139.0000, 'ºC'),
	(27996, 112, '2015-01-15 00:07:20.000000', 'temperatura', 445.0000, 'ºC'),
	(27997, 112, '2015-01-15 00:07:21.000000', 'temperatura', 611.0000, 'ºC'),
	(27998, 112, '2015-01-15 00:07:22.000000', 'temperatura', 519.0000, 'ºC'),
	(27999, 112, '2015-01-15 00:07:23.000000', 'temperatura', 761.0000, 'ºC'),
	(28000, 112, '2015-01-15 00:07:24.000000', 'temperatura', 1049.0000, 'ºC'),
	(28001, 112, '2015-01-15 00:07:25.000000', 'temperatura', 561.0000, 'ºC'),
	(28002, 112, '2015-01-15 00:07:26.000000', 'temperatura', 861.0000, 'ºC'),
	(28003, 112, '2015-01-15 00:07:27.000000', 'temperatura', 221.0000, 'ºC'),
	(28004, 112, '2015-01-15 00:07:28.000000', 'temperatura', 922.0000, 'ºC'),
	(28005, 112, '2015-01-15 00:07:29.000000', 'temperatura', 347.0000, 'ºC'),
	(28006, 112, '2015-01-15 00:07:30.000000', 'temperatura', 171.0000, 'ºC'),
	(28007, 112, '2015-01-15 00:07:31.000000', 'temperatura', 1013.0000, 'ºC'),
	(28008, 112, '2015-01-15 00:07:32.000000', 'temperatura', 953.0000, 'ºC'),
	(28009, 112, '2015-01-15 00:07:33.000000', 'temperatura', 526.0000, 'ºC'),
	(28010, 112, '2015-01-15 00:07:34.000000', 'temperatura', 971.0000, 'ºC'),
	(28011, 112, '2015-01-15 00:07:35.000000', 'temperatura', 879.0000, 'ºC'),
	(28012, 112, '2015-01-15 00:07:36.000000', 'temperatura', 281.0000, 'ºC'),
	(28013, 112, '2015-01-15 00:07:37.000000', 'temperatura', 1171.0000, 'ºC'),
	(28014, 112, '2015-01-15 00:07:38.000000', 'temperatura', 210.0000, 'ºC'),
	(28015, 112, '2015-01-15 00:07:39.000000', 'temperatura', 1140.0000, 'ºC'),
	(28016, 112, '2015-01-15 00:07:40.000000', 'temperatura', 271.0000, 'ºC'),
	(28017, 112, '2015-01-15 00:07:41.000000', 'temperatura', 333.0000, 'ºC'),
	(28018, 112, '2015-01-15 00:07:42.000000', 'temperatura', 852.0000, 'ºC'),
	(28019, 112, '2015-01-15 00:07:43.000000', 'temperatura', 863.0000, 'ºC'),
	(28020, 112, '2015-01-15 00:07:44.000000', 'temperatura', 559.0000, 'ºC'),
	(28021, 112, '2015-01-15 00:07:45.000000', 'temperatura', 208.0000, 'ºC'),
	(28022, 112, '2015-01-15 00:07:46.000000', 'temperatura', 564.0000, 'ºC'),
	(28023, 112, '2015-01-15 00:07:47.000000', 'temperatura', 995.0000, 'ºC'),
	(28024, 112, '2015-01-15 00:07:48.000000', 'temperatura', 885.0000, 'ºC'),
	(28025, 112, '2015-01-15 00:07:49.000000', 'temperatura', 241.0000, 'ºC'),
	(28026, 112, '2015-01-15 00:07:50.000000', 'temperatura', 951.0000, 'ºC'),
	(28027, 112, '2015-01-15 00:07:51.000000', 'temperatura', 431.0000, 'ºC'),
	(28028, 112, '2015-01-15 00:07:52.000000', 'temperatura', 504.0000, 'ºC'),
	(28029, 112, '2015-01-15 00:07:53.000000', 'temperatura', 26.0000, 'ºC'),
	(28030, 112, '2015-01-15 00:07:54.000000', 'temperatura', 1019.0000, 'ºC'),
	(28031, 112, '2015-01-15 00:07:55.000000', 'temperatura', 219.0000, 'ºC'),
	(28032, 112, '2015-01-15 00:07:56.000000', 'temperatura', 435.0000, 'ºC'),
	(28033, 112, '2015-01-15 00:07:57.000000', 'temperatura', 322.0000, 'ºC'),
	(28034, 112, '2015-01-15 00:07:58.000000', 'temperatura', 306.0000, 'ºC'),
	(28035, 112, '2015-01-15 00:07:59.000000', 'temperatura', 562.0000, 'ºC'),
	(28036, 112, '2015-01-15 00:08:00.000000', 'temperatura', 692.0000, 'ºC'),
	(28037, 112, '2015-01-15 00:08:01.000000', 'temperatura', 573.0000, 'ºC'),
	(28038, 112, '2015-01-15 00:08:02.000000', 'temperatura', 793.0000, 'ºC'),
	(28039, 112, '2015-01-15 00:08:03.000000', 'temperatura', 1046.0000, 'ºC'),
	(28040, 112, '2015-01-15 00:08:04.000000', 'temperatura', 449.0000, 'ºC'),
	(28041, 112, '2015-01-15 00:08:05.000000', 'temperatura', 310.0000, 'ºC'),
	(28042, 112, '2015-01-15 00:08:06.000000', 'temperatura', 204.0000, 'ºC'),
	(28043, 112, '2015-01-15 00:08:07.000000', 'temperatura', 90.0000, 'ºC'),
	(28044, 112, '2015-01-15 00:08:08.000000', 'temperatura', 1040.0000, 'ºC'),
	(28045, 112, '2015-01-15 00:08:09.000000', 'temperatura', 129.0000, 'ºC'),
	(28046, 112, '2015-01-15 00:08:10.000000', 'temperatura', 1126.0000, 'ºC'),
	(28047, 112, '2015-01-15 00:08:11.000000', 'temperatura', 444.0000, 'ºC'),
	(28048, 112, '2015-01-15 00:08:12.000000', 'temperatura', 42.0000, 'ºC'),
	(28049, 112, '2015-01-15 00:08:13.000000', 'temperatura', 77.0000, 'ºC'),
	(28050, 112, '2015-01-15 00:08:14.000000', 'temperatura', 259.0000, 'ºC'),
	(28051, 112, '2015-01-15 00:08:15.000000', 'temperatura', 1067.0000, 'ºC'),
	(28052, 112, '2015-01-15 00:08:16.000000', 'temperatura', 960.0000, 'ºC'),
	(28053, 112, '2015-01-15 00:08:17.000000', 'temperatura', 396.0000, 'ºC'),
	(28054, 112, '2015-01-15 00:08:18.000000', 'temperatura', 303.0000, 'ºC'),
	(28055, 112, '2015-01-15 00:08:19.000000', 'temperatura', 326.0000, 'ºC'),
	(28056, 112, '2015-01-15 00:08:20.000000', 'temperatura', 723.0000, 'ºC'),
	(28057, 112, '2015-01-15 00:08:21.000000', 'temperatura', 239.0000, 'ºC'),
	(28058, 112, '2015-01-15 00:08:22.000000', 'temperatura', 224.0000, 'ºC'),
	(28059, 112, '2015-01-15 00:08:23.000000', 'temperatura', 405.0000, 'ºC'),
	(28060, 112, '2015-01-15 00:08:24.000000', 'temperatura', 151.0000, 'ºC'),
	(28061, 112, '2015-01-15 00:08:25.000000', 'temperatura', 742.0000, 'ºC'),
	(28062, 112, '2015-01-15 00:08:26.000000', 'temperatura', 859.0000, 'ºC'),
	(28063, 112, '2015-01-15 00:08:27.000000', 'temperatura', 869.0000, 'ºC'),
	(28064, 112, '2015-01-15 00:08:28.000000', 'temperatura', 569.0000, 'ºC'),
	(28065, 112, '2015-01-15 00:08:29.000000', 'temperatura', 237.0000, 'ºC'),
	(28066, 112, '2015-01-15 00:08:30.000000', 'temperatura', 679.0000, 'ºC'),
	(28067, 112, '2015-01-15 00:08:31.000000', 'temperatura', 285.0000, 'ºC'),
	(28068, 112, '2015-01-15 00:08:32.000000', 'temperatura', 588.0000, 'ºC'),
	(28069, 112, '2015-01-15 00:08:33.000000', 'temperatura', 884.0000, 'ºC'),
	(28070, 112, '2015-01-15 00:08:34.000000', 'temperatura', 256.0000, 'ºC'),
	(28071, 112, '2015-01-15 00:08:35.000000', 'temperatura', 1032.0000, 'ºC'),
	(28072, 112, '2015-01-15 00:08:36.000000', 'temperatura', 790.0000, 'ºC'),
	(28073, 112, '2015-01-15 00:08:37.000000', 'temperatura', 855.0000, 'ºC'),
	(28074, 112, '2015-01-15 00:08:38.000000', 'temperatura', 704.0000, 'ºC'),
	(28075, 112, '2015-01-15 00:08:39.000000', 'temperatura', 956.0000, 'ºC'),
	(28076, 112, '2015-01-15 00:08:40.000000', 'temperatura', 268.0000, 'ºC'),
	(28077, 112, '2015-01-15 00:08:41.000000', 'temperatura', 874.0000, 'ºC'),
	(28078, 112, '2015-01-15 00:08:42.000000', 'temperatura', 1165.0000, 'ºC'),
	(28079, 112, '2015-01-15 00:08:43.000000', 'temperatura', 805.0000, 'ºC'),
	(28080, 112, '2015-01-15 00:08:44.000000', 'temperatura', 531.0000, 'ºC'),
	(28081, 112, '2015-01-15 00:08:45.000000', 'temperatura', 241.0000, 'ºC'),
	(28082, 112, '2015-01-15 00:08:46.000000', 'temperatura', 814.0000, 'ºC'),
	(28083, 112, '2015-01-15 00:08:47.000000', 'temperatura', 944.0000, 'ºC'),
	(28084, 112, '2015-01-15 00:08:48.000000', 'temperatura', 1081.0000, 'ºC'),
	(28085, 112, '2015-01-15 00:08:49.000000', 'temperatura', 171.0000, 'ºC'),
	(28086, 112, '2015-01-15 00:08:50.000000', 'temperatura', 15.0000, 'ºC'),
	(28087, 112, '2015-01-15 00:08:51.000000', 'temperatura', 761.0000, 'ºC'),
	(28088, 112, '2015-01-15 00:08:52.000000', 'temperatura', 159.0000, 'ºC'),
	(28089, 112, '2015-01-15 00:08:53.000000', 'temperatura', 914.0000, 'ºC'),
	(28090, 112, '2015-01-15 00:08:54.000000', 'temperatura', 494.0000, 'ºC'),
	(28091, 112, '2015-01-15 00:08:55.000000', 'temperatura', 927.0000, 'ºC'),
	(28092, 112, '2015-01-15 00:08:56.000000', 'temperatura', 755.0000, 'ºC'),
	(28093, 112, '2015-01-15 00:08:57.000000', 'temperatura', 996.0000, 'ºC'),
	(28094, 112, '2015-01-15 00:08:58.000000', 'temperatura', 313.0000, 'ºC'),
	(28095, 112, '2015-01-15 00:08:59.000000', 'temperatura', 978.0000, 'ºC'),
	(28096, 112, '2015-01-15 00:09:00.000000', 'temperatura', 350.0000, 'ºC'),
	(28097, 112, '2015-01-15 00:09:01.000000', 'temperatura', 16.0000, 'ºC'),
	(28098, 112, '2015-01-15 00:09:02.000000', 'temperatura', 232.0000, 'ºC'),
	(28099, 112, '2015-01-15 00:09:03.000000', 'temperatura', 1112.0000, 'ºC'),
	(28100, 112, '2015-01-15 00:09:04.000000', 'temperatura', 63.0000, 'ºC'),
	(28101, 112, '2015-01-15 00:09:05.000000', 'temperatura', 579.0000, 'ºC'),
	(28102, 112, '2015-01-15 00:09:06.000000', 'temperatura', 309.0000, 'ºC'),
	(28103, 112, '2015-01-15 00:09:07.000000', 'temperatura', 1008.0000, 'ºC'),
	(28104, 112, '2015-01-15 00:09:08.000000', 'temperatura', 514.0000, 'ºC'),
	(28105, 112, '2015-01-15 00:09:09.000000', 'temperatura', 745.0000, 'ºC'),
	(28106, 112, '2015-01-15 00:09:10.000000', 'temperatura', 985.0000, 'ºC'),
	(28107, 112, '2015-01-15 00:09:11.000000', 'temperatura', 292.0000, 'ºC'),
	(28108, 112, '2015-01-15 00:09:12.000000', 'temperatura', 904.0000, 'ºC'),
	(28109, 112, '2015-01-15 00:09:13.000000', 'temperatura', 44.0000, 'ºC'),
	(28110, 112, '2015-01-15 00:09:14.000000', 'temperatura', 1109.0000, 'ºC'),
	(28111, 112, '2015-01-15 00:09:15.000000', 'temperatura', 614.0000, 'ºC'),
	(28112, 112, '2015-01-15 00:09:16.000000', 'temperatura', 942.0000, 'ºC'),
	(28113, 112, '2015-01-15 00:09:17.000000', 'temperatura', 471.0000, 'ºC'),
	(28114, 112, '2015-01-15 00:09:18.000000', 'temperatura', 727.0000, 'ºC'),
	(28115, 112, '2015-01-15 00:09:19.000000', 'temperatura', 1022.0000, 'ºC'),
	(28116, 112, '2015-01-15 00:09:20.000000', 'temperatura', 530.0000, 'ºC'),
	(28117, 112, '2015-01-15 00:09:21.000000', 'temperatura', 785.0000, 'ºC'),
	(28118, 112, '2015-01-15 00:09:22.000000', 'temperatura', 1135.0000, 'ºC'),
	(28119, 112, '2015-01-15 00:09:23.000000', 'temperatura', 923.0000, 'ºC'),
	(28120, 112, '2015-01-15 00:09:24.000000', 'temperatura', 8.0000, 'ºC'),
	(28121, 112, '2015-01-15 00:09:25.000000', 'temperatura', 872.0000, 'ºC'),
	(28122, 112, '2015-01-15 00:09:26.000000', 'temperatura', 737.0000, 'ºC'),
	(28123, 112, '2015-01-15 00:09:27.000000', 'temperatura', 1068.0000, 'ºC'),
	(28124, 112, '2015-01-15 00:09:28.000000', 'temperatura', 729.0000, 'ºC'),
	(28125, 112, '2015-01-15 00:09:29.000000', 'temperatura', 444.0000, 'ºC'),
	(28126, 112, '2015-01-15 00:09:30.000000', 'temperatura', 31.0000, 'ºC'),
	(28127, 112, '2015-01-15 00:09:31.000000', 'temperatura', 24.0000, 'ºC'),
	(28128, 112, '2015-01-15 00:09:32.000000', 'temperatura', 28.0000, 'ºC'),
	(28129, 112, '2015-01-15 00:09:33.000000', 'temperatura', 66.0000, 'ºC'),
	(28130, 112, '2015-01-15 00:09:34.000000', 'temperatura', 250.0000, 'ºC'),
	(28131, 112, '2015-01-15 00:09:35.000000', 'temperatura', 1052.0000, 'ºC'),
	(28132, 112, '2015-01-15 00:09:36.000000', 'temperatura', 910.0000, 'ºC'),
	(28133, 112, '2015-01-15 00:09:37.000000', 'temperatura', 193.0000, 'ºC'),
	(28134, 112, '2015-01-15 00:09:38.000000', 'temperatura', 638.0000, 'ºC'),
	(28135, 112, '2015-01-15 00:09:39.000000', 'temperatura', 210.0000, 'ºC'),
	(28136, 112, '2015-01-15 00:09:40.000000', 'temperatura', 337.0000, 'ºC'),
	(28137, 112, '2015-01-15 00:09:41.000000', 'temperatura', 1056.0000, 'ºC'),
	(28138, 112, '2015-01-15 00:09:42.000000', 'temperatura', 670.0000, 'ºC'),
	(28139, 112, '2015-01-15 00:09:43.000000', 'temperatura', 184.0000, 'ºC'),
	(28140, 112, '2015-01-15 00:09:44.000000', 'temperatura', 107.0000, 'ºC'),
	(28141, 112, '2015-01-15 00:09:45.000000', 'temperatura', 1185.0000, 'ºC'),
	(28142, 112, '2015-01-15 00:09:46.000000', 'temperatura', 805.0000, 'ºC'),
	(28143, 112, '2015-01-15 00:09:47.000000', 'temperatura', 469.0000, 'ºC'),
	(28144, 112, '2015-01-15 00:09:48.000000', 'temperatura', 1130.0000, 'ºC'),
	(28145, 112, '2015-01-15 00:09:49.000000', 'temperatura', 645.0000, 'ºC'),
	(28146, 112, '2015-01-15 00:09:50.000000', 'temperatura', 1035.0000, 'ºC'),
	(28147, 112, '2015-01-15 00:09:51.000000', 'temperatura', 842.0000, 'ºC'),
	(28148, 112, '2015-01-15 00:09:52.000000', 'temperatura', 1105.0000, 'ºC'),
	(28149, 112, '2015-01-15 00:09:53.000000', 'temperatura', 599.0000, 'ºC'),
	(28150, 112, '2015-01-15 00:09:54.000000', 'temperatura', 882.0000, 'ºC'),
	(28151, 112, '2015-01-15 00:09:55.000000', 'temperatura', 212.0000, 'ºC'),
	(28152, 112, '2015-01-15 00:09:56.000000', 'temperatura', 813.0000, 'ºC'),
	(28153, 112, '2015-01-15 00:09:57.000000', 'temperatura', 1030.0000, 'ºC'),
	(28154, 112, '2015-01-15 00:09:58.000000', 'temperatura', 310.0000, 'ºC'),
	(28155, 112, '2015-01-15 00:09:59.000000', 'temperatura', 863.0000, 'ºC'),
	(28156, 112, '2015-01-15 00:10:00.000000', 'temperatura', 985.0000, 'ºC'),
	(28157, 112, '2015-01-15 00:10:01.000000', 'temperatura', 1137.0000, 'ºC'),
	(28158, 112, '2015-01-15 00:10:02.000000', 'temperatura', 329.0000, 'ºC'),
	(28159, 112, '2015-01-15 00:10:03.000000', 'temperatura', 633.0000, 'ºC'),
	(28160, 112, '2015-01-15 00:10:04.000000', 'temperatura', 982.0000, 'ºC'),
	(28161, 112, '2015-01-15 00:10:05.000000', 'temperatura', 609.0000, 'ºC'),
	(28162, 112, '2015-01-15 00:10:06.000000', 'temperatura', 99.0000, 'ºC'),
	(28163, 112, '2015-01-15 00:10:07.000000', 'temperatura', 1068.0000, 'ºC'),
	(28164, 112, '2015-01-15 00:10:08.000000', 'temperatura', 243.0000, 'ºC'),
	(28165, 112, '2015-01-15 00:10:09.000000', 'temperatura', 412.0000, 'ºC'),
	(28166, 112, '2015-01-15 00:10:10.000000', 'temperatura', 130.0000, 'ºC'),
	(28167, 112, '2015-01-15 00:10:11.000000', 'temperatura', 615.0000, 'ºC'),
	(28168, 112, '2015-01-15 00:10:12.000000', 'temperatura', 285.0000, 'ºC'),
	(28169, 112, '2015-01-15 00:10:13.000000', 'temperatura', 781.0000, 'ºC'),
	(28170, 112, '2015-01-15 00:10:14.000000', 'temperatura', 650.0000, 'ºC'),
	(28171, 112, '2015-01-15 00:10:15.000000', 'temperatura', 908.0000, 'ºC'),
	(28172, 112, '2015-01-15 00:10:16.000000', 'temperatura', 192.0000, 'ºC'),
	(28173, 112, '2015-01-15 00:10:17.000000', 'temperatura', 636.0000, 'ºC'),
	(28174, 112, '2015-01-15 00:10:18.000000', 'temperatura', 203.0000, 'ºC'),
	(28175, 112, '2015-01-15 00:10:19.000000', 'temperatura', 309.0000, 'ºC'),
	(28176, 112, '2015-01-15 00:10:20.000000', 'temperatura', 938.0000, 'ºC'),
	(28177, 112, '2015-01-15 00:10:21.000000', 'temperatura', 161.0000, 'ºC'),
	(28178, 112, '2015-01-15 00:10:22.000000', 'temperatura', 391.0000, 'ºC'),
	(28179, 112, '2015-01-15 00:10:23.000000', 'temperatura', 271.0000, 'ºC'),
	(28180, 112, '2015-01-15 00:10:24.000000', 'temperatura', 186.0000, 'ºC'),
	(28181, 112, '2015-01-15 00:10:25.000000', 'temperatura', 116.0000, 'ºC'),
	(28182, 112, '2015-01-15 00:10:26.000000', 'temperatura', 23.0000, 'ºC'),
	(28183, 112, '2015-01-15 00:10:27.000000', 'temperatura', 966.0000, 'ºC'),
	(28184, 112, '2015-01-15 00:10:28.000000', 'temperatura', 1160.0000, 'ºC'),
	(28185, 112, '2015-01-15 00:10:29.000000', 'temperatura', 506.0000, 'ºC'),
	(28186, 112, '2015-01-15 00:10:30.000000', 'temperatura', 248.0000, 'ºC'),
	(28187, 112, '2015-01-15 00:10:31.000000', 'temperatura', 922.0000, 'ºC'),
	(28188, 112, '2015-01-15 00:10:32.000000', 'temperatura', 267.0000, 'ºC'),
	(28189, 112, '2015-01-15 00:10:33.000000', 'temperatura', 970.0000, 'ºC'),
	(28190, 112, '2015-01-15 00:10:34.000000', 'temperatura', 451.0000, 'ºC'),
	(28191, 112, '2015-01-15 00:10:35.000000', 'temperatura', 544.0000, 'ºC'),
	(28192, 112, '2015-01-15 00:10:36.000000', 'temperatura', 168.0000, 'ºC'),
	(28193, 112, '2015-01-15 00:10:37.000000', 'temperatura', 406.0000, 'ºC'),
	(28194, 112, '2015-01-15 00:10:38.000000', 'temperatura', 330.0000, 'ºC'),
	(28195, 112, '2015-01-15 00:10:39.000000', 'temperatura', 431.0000, 'ºC'),
	(28196, 112, '2015-01-15 00:10:40.000000', 'temperatura', 1168.0000, 'ºC'),
	(28197, 112, '2015-01-15 00:10:41.000000', 'temperatura', 944.0000, 'ºC'),
	(28198, 112, '2015-01-15 00:10:42.000000', 'temperatura', 17.0000, 'ºC'),
	(28199, 112, '2015-01-15 00:10:43.000000', 'temperatura', 855.0000, 'ºC'),
	(28200, 112, '2015-01-15 00:10:44.000000', 'temperatura', 625.0000, 'ºC'),
	(28201, 112, '2015-01-15 00:10:45.000000', 'temperatura', 559.0000, 'ºC'),
	(28202, 112, '2015-01-15 00:10:46.000000', 'temperatura', 920.0000, 'ºC'),
	(28203, 112, '2015-01-15 00:10:47.000000', 'temperatura', 525.0000, 'ºC'),
	(28204, 112, '2015-01-15 00:10:48.000000', 'temperatura', 1066.0000, 'ºC'),
	(28205, 112, '2015-01-15 00:10:49.000000', 'temperatura', 155.0000, 'ºC'),
	(28206, 112, '2015-01-15 00:10:50.000000', 'temperatura', 1176.0000, 'ºC'),
	(28207, 112, '2015-01-15 00:10:51.000000', 'temperatura', 618.0000, 'ºC'),
	(28208, 112, '2015-01-15 00:10:52.000000', 'temperatura', 763.0000, 'ºC'),
	(28209, 112, '2015-01-15 00:10:53.000000', 'temperatura', 761.0000, 'ºC'),
	(28210, 112, '2015-01-15 00:10:54.000000', 'temperatura', 316.0000, 'ºC'),
	(28211, 112, '2015-01-15 00:10:55.000000', 'temperatura', 499.0000, 'ºC'),
	(28212, 112, '2015-01-15 00:10:56.000000', 'temperatura', 346.0000, 'ºC'),
	(28213, 112, '2015-01-15 00:10:57.000000', 'temperatura', 234.0000, 'ºC'),
	(28214, 112, '2015-01-15 00:10:58.000000', 'temperatura', 133.0000, 'ºC'),
	(28215, 112, '2015-01-15 00:10:59.000000', 'temperatura', 1162.0000, 'ºC'),
	(28216, 112, '2015-01-15 00:11:00.000000', 'temperatura', 614.0000, 'ºC'),
	(28217, 112, '2015-01-15 00:11:01.000000', 'temperatura', 782.0000, 'ºC'),
	(28218, 112, '2015-01-15 00:11:02.000000', 'temperatura', 869.0000, 'ºC'),
	(28219, 112, '2015-01-15 00:11:03.000000', 'temperatura', 800.0000, 'ºC'),
	(28220, 112, '2015-01-15 00:11:04.000000', 'temperatura', 194.0000, 'ºC'),
	(28221, 112, '2015-01-15 00:11:05.000000', 'temperatura', 971.0000, 'ºC'),
	(28222, 112, '2015-01-15 00:11:06.000000', 'temperatura', 674.0000, 'ºC'),
	(28223, 112, '2015-01-15 00:11:07.000000', 'temperatura', 458.0000, 'ºC'),
	(28224, 112, '2015-01-15 00:11:08.000000', 'temperatura', 265.0000, 'ºC'),
	(28225, 112, '2015-01-15 00:11:09.000000', 'temperatura', 1155.0000, 'ºC'),
	(28226, 112, '2015-01-15 00:11:10.000000', 'temperatura', 181.0000, 'ºC'),
	(28227, 112, '2015-01-15 00:11:11.000000', 'temperatura', 1037.0000, 'ºC'),
	(28228, 112, '2015-01-15 00:11:12.000000', 'temperatura', 1045.0000, 'ºC'),
	(28229, 112, '2015-01-15 00:11:13.000000', 'temperatura', 915.0000, 'ºC'),
	(28230, 112, '2015-01-15 00:11:14.000000', 'temperatura', 239.0000, 'ºC'),
	(28231, 112, '2015-01-15 00:11:15.000000', 'temperatura', 850.0000, 'ºC'),
	(28232, 112, '2015-01-15 00:11:16.000000', 'temperatura', 1135.0000, 'ºC'),
	(28233, 112, '2015-01-15 00:11:17.000000', 'temperatura', 725.0000, 'ºC'),
	(28234, 112, '2015-01-15 00:11:18.000000', 'temperatura', 223.0000, 'ºC'),
	(28235, 112, '2015-01-15 00:11:19.000000', 'temperatura', 137.0000, 'ºC'),
	(28236, 112, '2015-01-15 00:11:20.000000', 'temperatura', 17.0000, 'ºC'),
	(28237, 112, '2015-01-15 00:11:21.000000', 'temperatura', 876.0000, 'ºC'),
	(28238, 112, '2015-01-15 00:11:22.000000', 'temperatura', 727.0000, 'ºC'),
	(28239, 112, '2015-01-15 00:11:23.000000', 'temperatura', 1009.0000, 'ºC'),
	(28240, 112, '2015-01-15 00:11:24.000000', 'temperatura', 466.0000, 'ºC'),
	(28241, 112, '2015-01-15 00:11:25.000000', 'temperatura', 501.0000, 'ºC'),
	(28242, 112, '2015-01-15 00:11:26.000000', 'temperatura', 1107.0000, 'ºC'),
	(28243, 112, '2015-01-15 00:11:27.000000', 'temperatura', 434.0000, 'ºC'),
	(28244, 112, '2015-01-15 00:11:28.000000', 'temperatura', 49.0000, 'ºC'),
	(28245, 112, '2015-01-15 00:11:29.000000', 'temperatura', 143.0000, 'ºC'),
	(28246, 112, '2015-01-15 00:11:30.000000', 'temperatura', 570.0000, 'ºC'),
	(28247, 112, '2015-01-15 00:11:31.000000', 'temperatura', 23.0000, 'ºC'),
	(28248, 112, '2015-01-15 00:11:32.000000', 'temperatura', 803.0000, 'ºC'),
	(28249, 112, '2015-01-15 00:11:33.000000', 'temperatura', 349.0000, 'ºC'),
	(28250, 112, '2015-01-15 00:11:34.000000', 'temperatura', 534.0000, 'ºC'),
	(28251, 112, '2015-01-15 00:11:35.000000', 'temperatura', 424.0000, 'ºC'),
	(28252, 112, '2015-01-15 00:11:36.000000', 'temperatura', 520.0000, 'ºC'),
	(28253, 112, '2015-01-15 00:11:37.000000', 'temperatura', 128.0000, 'ºC'),
	(28254, 112, '2015-01-15 00:11:38.000000', 'temperatura', 281.0000, 'ºC'),
	(28255, 112, '2015-01-15 00:11:39.000000', 'temperatura', 1019.0000, 'ºC'),
	(28256, 112, '2015-01-15 00:11:40.000000', 'temperatura', 653.0000, 'ºC'),
	(28257, 112, '2015-01-15 00:11:41.000000', 'temperatura', 209.0000, 'ºC'),
	(28258, 112, '2015-01-15 00:11:42.000000', 'temperatura', 289.0000, 'ºC'),
	(28259, 112, '2015-01-15 00:11:43.000000', 'temperatura', 815.0000, 'ºC'),
	(28260, 112, '2015-01-15 00:11:44.000000', 'temperatura', 809.0000, 'ºC'),
	(28261, 112, '2015-01-15 00:11:45.000000', 'temperatura', 401.0000, 'ºC'),
	(28262, 112, '2015-01-15 00:11:46.000000', 'temperatura', 776.0000, 'ºC'),
	(28263, 112, '2015-01-15 00:11:47.000000', 'temperatura', 281.0000, 'ºC'),
	(28264, 112, '2015-01-15 00:11:48.000000', 'temperatura', 278.0000, 'ºC'),
	(28265, 112, '2015-01-15 00:11:49.000000', 'temperatura', 544.0000, 'ºC'),
	(28266, 112, '2015-01-15 00:11:50.000000', 'temperatura', 690.0000, 'ºC'),
	(28267, 112, '2015-01-15 00:11:51.000000', 'temperatura', 618.0000, 'ºC'),
	(28268, 112, '2015-01-15 00:11:52.000000', 'temperatura', 1018.0000, 'ºC'),
	(28269, 112, '2015-01-15 00:11:53.000000', 'temperatura', 839.0000, 'ºC'),
	(28270, 112, '2015-01-15 00:11:54.000000', 'temperatura', 1142.0000, 'ºC'),
	(28271, 112, '2015-01-15 00:11:55.000000', 'temperatura', 792.0000, 'ºC'),
	(28272, 112, '2015-01-15 00:11:56.000000', 'temperatura', 534.0000, 'ºC'),
	(28273, 112, '2015-01-15 00:11:57.000000', 'temperatura', 296.0000, 'ºC'),
	(28274, 112, '2015-01-15 00:11:58.000000', 'temperatura', 1077.0000, 'ºC'),
	(28275, 112, '2015-01-15 00:11:59.000000', 'temperatura', 898.0000, 'ºC'),
	(28276, 112, '2015-01-15 00:12:00.000000', 'temperatura', 59.0000, 'ºC'),
	(28277, 112, '2015-01-15 00:12:01.000000', 'temperatura', 1.0000, 'ºC'),
	(28278, 112, '2015-01-15 00:12:02.000000', 'temperatura', 1028.0000, 'ºC'),
	(28279, 112, '2015-01-15 00:12:03.000000', 'temperatura', 338.0000, 'ºC'),
	(28280, 112, '2015-01-15 00:12:04.000000', 'temperatura', 1007.0000, 'ºC'),
	(28281, 112, '2015-01-15 00:12:05.000000', 'temperatura', 420.0000, 'ºC'),
	(28282, 112, '2015-01-15 00:12:06.000000', 'temperatura', 282.0000, 'ºC'),
	(28283, 112, '2015-01-15 00:12:07.000000', 'temperatura', 150.0000, 'ºC'),
	(28284, 112, '2015-01-15 00:12:08.000000', 'temperatura', 1102.0000, 'ºC'),
	(28285, 112, '2015-01-15 00:12:09.000000', 'temperatura', 262.0000, 'ºC'),
	(28286, 112, '2015-01-15 00:12:10.000000', 'temperatura', 405.0000, 'ºC'),
	(28287, 112, '2015-01-15 00:12:11.000000', 'temperatura', 39.0000, 'ºC'),
	(28288, 112, '2015-01-15 00:12:12.000000', 'temperatura', 181.0000, 'ºC'),
	(28289, 112, '2015-01-15 00:12:13.000000', 'temperatura', 786.0000, 'ºC'),
	(28290, 112, '2015-01-15 00:12:14.000000', 'temperatura', 990.0000, 'ºC'),
	(28291, 112, '2015-01-15 00:12:15.000000', 'temperatura', 191.0000, 'ºC'),
	(28292, 112, '2015-01-15 00:12:16.000000', 'temperatura', 387.0000, 'ºC'),
	(28293, 112, '2015-01-15 00:12:17.000000', 'temperatura', 160.0000, 'ºC'),
	(28294, 112, '2015-01-15 00:12:18.000000', 'temperatura', 840.0000, 'ºC'),
	(28295, 112, '2015-01-15 00:12:19.000000', 'temperatura', 122.0000, 'ºC'),
	(28296, 112, '2015-01-15 00:12:20.000000', 'temperatura', 490.0000, 'ºC'),
	(28297, 112, '2015-01-15 00:12:21.000000', 'temperatura', 886.0000, 'ºC'),
	(28298, 112, '2015-01-15 00:12:22.000000', 'temperatura', 561.0000, 'ºC'),
	(28299, 112, '2015-01-15 00:12:23.000000', 'temperatura', 147.0000, 'ºC'),
	(28300, 112, '2015-01-15 00:12:24.000000', 'temperatura', 252.0000, 'ºC'),
	(28301, 112, '2015-01-15 00:12:25.000000', 'temperatura', 821.0000, 'ºC'),
	(28302, 112, '2015-01-15 00:12:26.000000', 'temperatura', 946.0000, 'ºC'),
	(28303, 112, '2015-01-15 00:12:27.000000', 'temperatura', 1071.0000, 'ºC'),
	(28304, 112, '2015-01-15 00:12:28.000000', 'temperatura', 116.0000, 'ºC'),
	(28305, 112, '2015-01-15 00:12:29.000000', 'temperatura', 968.0000, 'ºC'),
	(28306, 112, '2015-01-15 00:12:30.000000', 'temperatura', 891.0000, 'ºC'),
	(28307, 112, '2015-01-15 00:12:31.000000', 'temperatura', 351.0000, 'ºC'),
	(28308, 112, '2015-01-15 00:12:32.000000', 'temperatura', 282.0000, 'ºC'),
	(28309, 112, '2015-01-15 00:12:33.000000', 'temperatura', 359.0000, 'ºC'),
	(28310, 112, '2015-01-15 00:12:34.000000', 'temperatura', 950.0000, 'ºC'),
	(28311, 112, '2015-01-15 00:12:35.000000', 'temperatura', 71.0000, 'ºC'),
	(28312, 112, '2015-01-15 00:12:36.000000', 'temperatura', 1107.0000, 'ºC'),
	(28313, 112, '2015-01-15 00:12:37.000000', 'temperatura', 524.0000, 'ºC'),
	(28314, 112, '2015-01-15 00:12:38.000000', 'temperatura', 498.0000, 'ºC'),
	(28315, 112, '2015-01-15 00:12:39.000000', 'temperatura', 918.0000, 'ºC'),
	(28316, 112, '2015-01-15 00:12:40.000000', 'temperatura', 698.0000, 'ºC'),
	(28317, 112, '2015-01-15 00:12:41.000000', 'temperatura', 736.0000, 'ºC'),
	(28318, 112, '2015-01-15 00:12:42.000000', 'temperatura', 387.0000, 'ºC'),
	(28319, 112, '2015-01-15 00:12:43.000000', 'temperatura', 928.0000, 'ºC'),
	(28320, 112, '2015-01-15 00:12:44.000000', 'temperatura', 1080.0000, 'ºC'),
	(28321, 112, '2015-01-15 00:12:45.000000', 'temperatura', 217.0000, 'ºC'),
	(28322, 112, '2015-01-15 00:12:46.000000', 'temperatura', 244.0000, 'ºC'),
	(28323, 112, '2015-01-15 00:12:47.000000', 'temperatura', 571.0000, 'ºC'),
	(28324, 112, '2015-01-15 00:12:48.000000', 'temperatura', 924.0000, 'ºC'),
	(28325, 112, '2015-01-15 00:12:49.000000', 'temperatura', 505.0000, 'ºC'),
	(28326, 112, '2015-01-15 00:12:50.000000', 'temperatura', 956.0000, 'ºC'),
	(28327, 112, '2015-01-15 00:12:51.000000', 'temperatura', 863.0000, 'ºC'),
	(28328, 112, '2015-01-15 00:12:52.000000', 'temperatura', 247.0000, 'ºC'),
	(28329, 112, '2015-01-15 00:12:53.000000', 'temperatura', 1046.0000, 'ºC'),
	(28330, 112, '2015-01-15 00:12:54.000000', 'temperatura', 890.0000, 'ºC'),
	(28331, 112, '2015-01-15 00:12:55.000000', 'temperatura', 114.0000, 'ºC'),
	(28332, 112, '2015-01-15 00:12:56.000000', 'temperatura', 300.0000, 'ºC'),
	(28333, 112, '2015-01-15 00:12:57.000000', 'temperatura', 1157.0000, 'ºC'),
	(28334, 112, '2015-01-15 00:12:58.000000', 'temperatura', 87.0000, 'ºC'),
	(28335, 112, '2015-01-15 00:12:59.000000', 'temperatura', 566.0000, 'ºC'),
	(28336, 112, '2015-01-15 00:13:00.000000', 'temperatura', 167.0000, 'ºC'),
	(28337, 112, '2015-01-15 00:13:01.000000', 'temperatura', 339.0000, 'ºC'),
	(28338, 112, '2015-01-15 00:13:02.000000', 'temperatura', 1193.0000, 'ºC'),
	(28339, 112, '2015-01-15 00:13:03.000000', 'temperatura', 151.0000, 'ºC'),
	(28340, 112, '2015-01-15 00:13:04.000000', 'temperatura', 776.0000, 'ºC'),
	(28341, 112, '2015-01-15 00:13:05.000000', 'temperatura', 1028.0000, 'ºC'),
	(28342, 112, '2015-01-15 00:13:06.000000', 'temperatura', 412.0000, 'ºC'),
	(28343, 112, '2015-01-15 00:13:07.000000', 'temperatura', 176.0000, 'ºC'),
	(28344, 112, '2015-01-15 00:13:08.000000', 'temperatura', 846.0000, 'ºC'),
	(28345, 112, '2015-01-15 00:13:09.000000', 'temperatura', 104.0000, 'ºC'),
	(28346, 112, '2015-01-15 00:13:10.000000', 'temperatura', 379.0000, 'ºC'),
	(28347, 112, '2015-01-15 00:13:11.000000', 'temperatura', 385.0000, 'ºC'),
	(28348, 112, '2015-01-15 00:13:12.000000', 'temperatura', 787.0000, 'ºC'),
	(28349, 112, '2015-01-15 00:13:13.000000', 'temperatura', 382.0000, 'ºC'),
	(28350, 112, '2015-01-15 00:13:14.000000', 'temperatura', 749.0000, 'ºC'),
	(28351, 112, '2015-01-15 00:13:15.000000', 'temperatura', 200.0000, 'ºC'),
	(28352, 112, '2015-01-15 00:13:16.000000', 'temperatura', 1154.0000, 'ºC'),
	(28353, 112, '2015-01-15 00:13:17.000000', 'temperatura', 369.0000, 'ºC'),
	(28354, 112, '2015-01-15 00:13:18.000000', 'temperatura', 785.0000, 'ºC'),
	(28355, 112, '2015-01-15 00:13:19.000000', 'temperatura', 417.0000, 'ºC'),
	(28356, 112, '2015-01-15 00:13:20.000000', 'temperatura', 933.0000, 'ºC'),
	(28357, 112, '2015-01-15 00:13:21.000000', 'temperatura', 1012.0000, 'ºC'),
	(28358, 112, '2015-01-15 00:13:22.000000', 'temperatura', 1064.0000, 'ºC'),
	(28359, 112, '2015-01-15 00:13:23.000000', 'temperatura', 1084.0000, 'ºC'),
	(28360, 112, '2015-01-15 00:13:24.000000', 'temperatura', 1027.0000, 'ºC'),
	(28361, 112, '2015-01-15 00:13:25.000000', 'temperatura', 683.0000, 'ºC'),
	(28362, 112, '2015-01-15 00:13:26.000000', 'temperatura', 334.0000, 'ºC'),
	(28363, 112, '2015-01-15 00:13:27.000000', 'temperatura', 824.0000, 'ºC'),
	(28364, 112, '2015-01-15 00:13:28.000000', 'temperatura', 718.0000, 'ºC'),
	(28365, 112, '2015-01-15 00:13:29.000000', 'temperatura', 1118.0000, 'ºC'),
	(28366, 112, '2015-01-15 00:13:30.000000', 'temperatura', 1036.0000, 'ºC'),
	(28367, 112, '2015-01-15 00:13:31.000000', 'temperatura', 625.0000, 'ºC'),
	(28368, 112, '2015-01-15 00:13:32.000000', 'temperatura', 18.0000, 'ºC'),
	(28369, 112, '2015-01-15 00:13:33.000000', 'temperatura', 618.0000, 'ºC'),
	(28370, 112, '2015-01-15 00:13:34.000000', 'temperatura', 634.0000, 'ºC'),
	(28371, 112, '2015-01-15 00:13:35.000000', 'temperatura', 119.0000, 'ºC'),
	(28372, 112, '2015-01-15 00:13:36.000000', 'temperatura', 1093.0000, 'ºC'),
	(28373, 112, '2015-01-15 00:13:37.000000', 'temperatura', 307.0000, 'ºC'),
	(28374, 112, '2015-01-15 00:13:38.000000', 'temperatura', 656.0000, 'ºC'),
	(28375, 112, '2015-01-15 00:13:39.000000', 'temperatura', 1159.0000, 'ºC'),
	(28376, 112, '2015-01-15 00:13:40.000000', 'temperatura', 229.0000, 'ºC'),
	(28377, 112, '2015-01-15 00:13:41.000000', 'temperatura', 70.0000, 'ºC'),
	(28378, 112, '2015-01-15 00:13:42.000000', 'temperatura', 861.0000, 'ºC'),
	(28379, 112, '2015-01-15 00:13:43.000000', 'temperatura', 498.0000, 'ºC'),
	(28380, 112, '2015-01-15 00:13:44.000000', 'temperatura', 1105.0000, 'ºC'),
	(28381, 112, '2015-01-15 00:13:45.000000', 'temperatura', 433.0000, 'ºC'),
	(28382, 112, '2015-01-15 00:13:46.000000', 'temperatura', 48.0000, 'ºC'),
	(28383, 112, '2015-01-15 00:13:47.000000', 'temperatura', 143.0000, 'ºC'),
	(28384, 112, '2015-01-15 00:13:48.000000', 'temperatura', 572.0000, 'ºC'),
	(28385, 112, '2015-01-15 00:13:49.000000', 'temperatura', 30.0000, 'ºC'),
	(28386, 112, '2015-01-15 00:13:50.000000', 'temperatura', 837.0000, 'ºC'),
	(28387, 112, '2015-01-15 00:13:51.000000', 'temperatura', 494.0000, 'ºC'),
	(28388, 112, '2015-01-15 00:13:52.000000', 'temperatura', 1159.0000, 'ºC'),
	(28389, 112, '2015-01-15 00:13:53.000000', 'temperatura', 712.0000, 'ºC'),
	(28390, 112, '2015-01-15 00:13:54.000000', 'temperatura', 87.0000, 'ºC'),
	(28391, 112, '2015-01-15 00:13:55.000000', 'temperatura', 698.0000, 'ºC'),
	(28392, 112, '2015-01-15 00:13:56.000000', 'temperatura', 829.0000, 'ºC'),
	(28393, 112, '2015-01-15 00:13:57.000000', 'temperatura', 852.0000, 'ºC'),
	(28394, 112, '2015-01-15 00:13:58.000000', 'temperatura', 572.0000, 'ºC'),
	(28395, 112, '2015-01-15 00:13:59.000000', 'temperatura', 306.0000, 'ºC'),
	(28396, 112, '2015-01-15 00:14:00.000000', 'temperatura', 1015.0000, 'ºC'),
	(28397, 112, '2015-01-15 00:14:01.000000', 'temperatura', 557.0000, 'ºC'),
	(28398, 112, '2015-01-15 00:14:02.000000', 'temperatura', 942.0000, 'ºC'),
	(28399, 112, '2015-01-15 00:14:03.000000', 'temperatura', 637.0000, 'ºC'),
	(28400, 112, '2015-01-15 00:14:04.000000', 'temperatura', 361.0000, 'ºC'),
	(28401, 112, '2015-01-15 00:14:05.000000', 'temperatura', 1094.0000, 'ºC'),
	(28402, 112, '2015-01-15 00:14:06.000000', 'temperatura', 789.0000, 'ºC'),
	(28403, 112, '2015-01-15 00:14:07.000000', 'temperatura', 664.0000, 'ºC'),
	(28404, 112, '2015-01-15 00:14:08.000000', 'temperatura', 952.0000, 'ºC'),
	(28405, 112, '2015-01-15 00:14:09.000000', 'temperatura', 370.0000, 'ºC'),
	(28406, 112, '2015-01-15 00:14:10.000000', 'temperatura', 193.0000, 'ºC'),
	(28407, 112, '2015-01-15 00:14:11.000000', 'temperatura', 1055.0000, 'ºC'),
	(28408, 112, '2015-01-15 00:14:12.000000', 'temperatura', 1099.0000, 'ºC'),
	(28409, 112, '2015-01-15 00:14:13.000000', 'temperatura', 1130.0000, 'ºC'),
	(28410, 112, '2015-01-15 00:14:14.000000', 'temperatura', 1154.0000, 'ºC'),
	(28411, 112, '2015-01-15 00:14:15.000000', 'temperatura', 1180.0000, 'ºC'),
	(28412, 112, '2015-01-15 00:14:16.000000', 'temperatura', 39.0000, 'ºC'),
	(28413, 112, '2015-01-15 00:14:17.000000', 'temperatura', 253.0000, 'ºC'),
	(28414, 112, '2015-01-15 00:14:18.000000', 'temperatura', 1150.0000, 'ºC'),
	(28415, 112, '2015-01-15 00:14:19.000000', 'temperatura', 190.0000, 'ºC'),
	(28416, 112, '2015-01-15 00:14:20.000000', 'temperatura', 1101.0000, 'ºC'),
	(28417, 112, '2015-01-15 00:14:21.000000', 'temperatura', 135.0000, 'ºC'),
	(28418, 112, '2015-01-15 00:14:22.000000', 'temperatura', 971.0000, 'ºC'),
	(28419, 112, '2015-01-15 00:14:23.000000', 'temperatura', 853.0000, 'ºC'),
	(28420, 112, '2015-01-15 00:14:24.000000', 'temperatura', 153.0000, 'ºC'),
	(28421, 112, '2015-01-15 00:14:25.000000', 'temperatura', 606.0000, 'ºC'),
	(28422, 112, '2015-01-15 00:14:26.000000', 'temperatura', 171.0000, 'ºC'),
	(28423, 112, '2015-01-15 00:14:27.000000', 'temperatura', 236.0000, 'ºC'),
	(28424, 112, '2015-01-15 00:14:28.000000', 'temperatura', 668.0000, 'ºC'),
	(28425, 112, '2015-01-15 00:14:29.000000', 'temperatura', 234.0000, 'ºC'),
	(28426, 112, '2015-01-15 00:14:30.000000', 'temperatura', 365.0000, 'ºC'),
	(28427, 112, '2015-01-15 00:14:31.000000', 'temperatura', 1125.0000, 'ºC'),
	(28428, 112, '2015-01-15 00:14:32.000000', 'temperatura', 930.0000, 'ºC'),
	(28429, 112, '2015-01-15 00:14:33.000000', 'temperatura', 76.0000, 'ºC'),
	(28430, 112, '2015-01-15 00:14:34.000000', 'temperatura', 1192.0000, 'ºC'),
	(28431, 112, '2015-01-15 00:14:35.000000', 'temperatura', 929.0000, 'ºC'),
	(28432, 112, '2015-01-15 00:14:36.000000', 'temperatura', 1073.0000, 'ºC'),
	(28433, 112, '2015-01-15 00:14:37.000000', 'temperatura', 177.0000, 'ºC'),
	(28434, 112, '2015-01-15 00:14:38.000000', 'temperatura', 66.0000, 'ºC'),
	(28435, 112, '2015-01-15 00:14:39.000000', 'temperatura', 1002.0000, 'ºC'),
	(28436, 112, '2015-01-15 00:14:40.000000', 'temperatura', 11.0000, 'ºC'),
	(28437, 112, '2015-01-15 00:14:41.000000', 'temperatura', 647.0000, 'ºC'),
	(28438, 112, '2015-01-15 00:14:42.000000', 'temperatura', 806.0000, 'ºC'),
	(28439, 112, '2015-01-15 00:14:43.000000', 'temperatura', 889.0000, 'ºC'),
	(28440, 112, '2015-01-15 00:14:44.000000', 'temperatura', 825.0000, 'ºC'),
	(28441, 112, '2015-01-15 00:14:45.000000', 'temperatura', 262.0000, 'ºC'),
	(28442, 112, '2015-01-15 00:14:46.000000', 'temperatura', 34.0000, 'ºC'),
	(28443, 112, '2015-01-15 00:14:47.000000', 'temperatura', 585.0000, 'ºC'),
	(28444, 112, '2015-01-15 00:14:48.000000', 'temperatura', 422.0000, 'ºC'),
	(28445, 112, '2015-01-15 00:14:49.000000', 'temperatura', 356.0000, 'ºC'),
	(28446, 112, '2015-01-15 00:14:50.000000', 'temperatura', 514.0000, 'ºC'),
	(28447, 112, '2015-01-15 00:14:51.000000', 'temperatura', 302.0000, 'ºC'),
	(28448, 112, '2015-01-15 00:14:52.000000', 'temperatura', 1169.0000, 'ºC'),
	(28449, 112, '2015-01-15 00:14:53.000000', 'temperatura', 140.0000, 'ºC'),
	(28450, 112, '2015-01-15 00:14:54.000000', 'temperatura', 795.0000, 'ºC'),
	(28451, 112, '2015-01-15 00:14:55.000000', 'temperatura', 1154.0000, 'ºC'),
	(28452, 112, '2015-01-15 00:14:56.000000', 'temperatura', 985.0000, 'ºC'),
	(28453, 112, '2015-01-15 00:14:57.000000', 'temperatura', 264.0000, 'ºC'),
	(28454, 112, '2015-01-15 00:14:58.000000', 'temperatura', 765.0000, 'ºC'),
	(28455, 112, '2015-01-15 00:14:59.000000', 'temperatura', 633.0000, 'ºC'),
	(28456, 112, '2015-01-15 00:15:00.000000', 'temperatura', 872.0000, 'ºC'),
	(28457, 112, '2015-01-15 00:15:01.000000', 'temperatura', 59.0000, 'ºC'),
	(28458, 112, '2015-01-15 00:15:02.000000', 'temperatura', 81.0000, 'ºC'),
	(28459, 112, '2015-01-15 00:15:03.000000', 'temperatura', 227.0000, 'ºC'),
	(28460, 112, '2015-01-15 00:15:04.000000', 'temperatura', 894.0000, 'ºC'),
	(28461, 112, '2015-01-15 00:15:05.000000', 'temperatura', 188.0000, 'ºC'),
	(28462, 112, '2015-01-15 00:15:06.000000', 'temperatura', 658.0000, 'ºC'),
	(28463, 112, '2015-01-15 00:15:07.000000', 'temperatura', 326.0000, 'ºC'),
	(28464, 112, '2015-01-15 00:15:08.000000', 'temperatura', 857.0000, 'ºC'),
	(28465, 112, '2015-01-15 00:15:09.000000', 'temperatura', 906.0000, 'ºC'),
	(28466, 112, '2015-01-15 00:15:10.000000', 'temperatura', 761.0000, 'ºC'),
	(28467, 112, '2015-01-15 00:15:11.000000', 'temperatura', 1089.0000, 'ºC'),
	(28468, 112, '2015-01-15 00:15:12.000000', 'temperatura', 760.0000, 'ºC'),
	(28469, 112, '2015-01-15 00:15:13.000000', 'temperatura', 533.0000, 'ºC'),
	(28470, 112, '2015-01-15 00:15:14.000000', 'temperatura', 385.0000, 'ºC'),
	(28471, 112, '2015-01-15 00:15:15.000000', 'temperatura', 327.0000, 'ºC'),
	(28472, 112, '2015-01-15 00:15:16.000000', 'temperatura', 480.0000, 'ºC'),
	(28473, 112, '2015-01-15 00:15:17.000000', 'temperatura', 221.0000, 'ºC'),
	(28474, 112, '2015-01-15 00:15:18.000000', 'temperatura', 866.0000, 'ºC'),
	(28475, 112, '2015-01-15 00:15:19.000000', 'temperatura', 65.0000, 'ºC'),
	(28476, 112, '2015-01-15 00:15:20.000000', 'temperatura', 129.0000, 'ºC'),
	(28477, 112, '2015-01-15 00:15:21.000000', 'temperatura', 450.0000, 'ºC'),
	(28478, 112, '2015-01-15 00:15:22.000000', 'temperatura', 663.0000, 'ºC'),
	(28479, 112, '2015-01-15 00:15:23.000000', 'temperatura', 765.0000, 'ºC'),
	(28480, 112, '2015-01-15 00:15:24.000000', 'temperatura', 636.0000, 'ºC'),
	(28481, 112, '2015-01-15 00:15:25.000000', 'temperatura', 884.0000, 'ºC'),
	(28482, 112, '2015-01-15 00:15:26.000000', 'temperatura', 115.0000, 'ºC'),
	(28483, 112, '2015-01-15 00:15:27.000000', 'temperatura', 323.0000, 'ºC'),
	(28484, 112, '2015-01-15 00:15:28.000000', 'temperatura', 70.0000, 'ºC'),
	(28485, 112, '2015-01-15 00:15:29.000000', 'temperatura', 580.0000, 'ºC'),
	(28486, 112, '2015-01-15 00:15:30.000000', 'temperatura', 291.0000, 'ºC'),
	(28487, 112, '2015-01-15 00:15:31.000000', 'temperatura', 916.0000, 'ºC'),
	(28488, 112, '2015-01-15 00:15:32.000000', 'temperatura', 109.0000, 'ºC'),
	(28489, 112, '2015-01-15 00:15:33.000000', 'temperatura', 197.0000, 'ºC'),
	(28490, 112, '2015-01-15 00:15:34.000000', 'temperatura', 658.0000, 'ºC'),
	(28491, 112, '2015-01-15 00:15:35.000000', 'temperatura', 300.0000, 'ºC'),
	(28492, 112, '2015-01-15 00:15:36.000000', 'temperatura', 725.0000, 'ºC'),
	(28493, 112, '2015-01-15 00:15:37.000000', 'temperatura', 325.0000, 'ºC'),
	(28494, 112, '2015-01-15 00:15:38.000000', 'temperatura', 650.0000, 'ºC'),
	(28495, 112, '2015-01-15 00:15:39.000000', 'temperatura', 1075.0000, 'ºC'),
	(28496, 112, '2015-01-15 00:15:40.000000', 'temperatura', 1028.0000, 'ºC'),
	(28497, 112, '2015-01-15 00:15:41.000000', 'temperatura', 713.0000, 'ºC'),
	(28498, 112, '2015-01-15 00:15:42.000000', 'temperatura', 481.0000, 'ºC'),
	(28499, 112, '2015-01-15 00:15:43.000000', 'temperatura', 266.0000, 'ºC'),
	(28500, 112, '2015-01-15 00:15:44.000000', 'temperatura', 1087.0000, 'ºC'),
	(28501, 112, '2015-01-15 00:15:45.000000', 'temperatura', 1039.0000, 'ºC'),
	(28502, 112, '2015-01-15 00:15:46.000000', 'temperatura', 734.0000, 'ºC'),
	(28503, 112, '2015-01-15 00:15:47.000000', 'temperatura', 554.0000, 'ºC'),
	(28504, 112, '2015-01-15 00:15:48.000000', 'temperatura', 569.0000, 'ºC'),
	(28505, 112, '2015-01-15 00:15:49.000000', 'temperatura', 1185.0000, 'ºC'),
	(28506, 112, '2015-01-15 00:15:50.000000', 'temperatura', 616.0000, 'ºC'),
	(28507, 112, '2015-01-15 00:15:51.000000', 'temperatura', 727.0000, 'ºC'),
	(28508, 112, '2015-01-15 00:15:52.000000', 'temperatura', 589.0000, 'ºC'),
	(28509, 112, '2015-01-15 00:15:53.000000', 'temperatura', 762.0000, 'ºC'),
	(28510, 112, '2015-01-15 00:15:54.000000', 'temperatura', 845.0000, 'ºC'),
	(28511, 112, '2015-01-15 00:15:55.000000', 'temperatura', 739.0000, 'ºC'),
	(28512, 112, '2015-01-15 00:15:56.000000', 'temperatura', 1162.0000, 'ºC'),
	(28513, 112, '2015-01-15 00:15:57.000000', 'temperatura', 1193.0000, 'ºC'),
	(28514, 112, '2015-01-15 00:15:58.000000', 'temperatura', 80.0000, 'ºC'),
	(28515, 112, '2015-01-15 00:15:59.000000', 'temperatura', 421.0000, 'ºC'),
	(28516, 112, '2015-01-15 00:16:00.000000', 'temperatura', 664.0000, 'ºC'),
	(28517, 112, '2015-01-15 00:16:01.000000', 'temperatura', 857.0000, 'ºC'),
	(28518, 112, '2015-01-15 00:16:02.000000', 'temperatura', 1093.0000, 'ºC'),
	(28519, 112, '2015-01-15 00:16:03.000000', 'temperatura', 493.0000, 'ºC'),
	(28520, 112, '2015-01-15 00:16:04.000000', 'temperatura', 390.0000, 'ºC'),
	(28521, 112, '2015-01-15 00:16:05.000000', 'temperatura', 472.0000, 'ºC'),
	(28522, 112, '2015-01-15 00:16:06.000000', 'temperatura', 1190.0000, 'ºC'),
	(28523, 112, '2015-01-15 00:16:07.000000', 'temperatura', 932.0000, 'ºC'),
	(28524, 112, '2015-01-15 00:16:08.000000', 'temperatura', 1092.0000, 'ºC'),
	(28525, 112, '2015-01-15 00:16:09.000000', 'temperatura', 264.0000, 'ºC'),
	(28526, 112, '2015-01-15 00:16:10.000000', 'temperatura', 444.0000, 'ºC'),
	(28527, 112, '2015-01-15 00:16:11.000000', 'temperatura', 231.0000, 'ºC'),
	(28528, 112, '2015-01-15 00:16:12.000000', 'temperatura', 1022.0000, 'ºC'),
	(28529, 112, '2015-01-15 00:16:13.000000', 'temperatura', 815.0000, 'ºC'),
	(28530, 112, '2015-01-15 00:16:14.000000', 'temperatura', 1013.0000, 'ºC'),
	(28531, 112, '2015-01-15 00:16:15.000000', 'temperatura', 221.0000, 'ºC'),
	(28532, 112, '2015-01-15 00:16:16.000000', 'temperatura', 466.0000, 'ºC'),
	(28533, 112, '2015-01-15 00:16:17.000000', 'temperatura', 467.0000, 'ºC'),
	(28534, 112, '2015-01-15 00:16:18.000000', 'temperatura', 936.0000, 'ºC'),
	(28535, 112, '2015-01-15 00:16:19.000000', 'temperatura', 881.0000, 'ºC'),
	(28536, 112, '2015-01-15 00:16:20.000000', 'temperatura', 398.0000, 'ºC'),
	(28537, 112, '2015-01-15 00:16:21.000000', 'temperatura', 546.0000, 'ºC'),
	(28538, 112, '2015-01-15 00:16:22.000000', 'temperatura', 337.0000, 'ºC'),
	(28539, 112, '2015-01-15 00:16:23.000000', 'temperatura', 47.0000, 'ºC'),
	(28540, 112, '2015-01-15 00:16:24.000000', 'temperatura', 423.0000, 'ºC'),
	(28541, 112, '2015-01-15 00:16:25.000000', 'temperatura', 775.0000, 'ºC'),
	(28542, 112, '2015-01-15 00:16:26.000000', 'temperatura', 207.0000, 'ºC'),
	(28543, 112, '2015-01-15 00:16:27.000000', 'temperatura', 1109.0000, 'ºC'),
	(28544, 112, '2015-01-15 00:16:28.000000', 'temperatura', 128.0000, 'ºC'),
	(28545, 112, '2015-01-15 00:16:29.000000', 'temperatura', 910.0000, 'ºC'),
	(28546, 112, '2015-01-15 00:16:30.000000', 'temperatura', 569.0000, 'ºC'),
	(28547, 112, '2015-01-15 00:16:31.000000', 'temperatura', 115.0000, 'ºC'),
	(28548, 112, '2015-01-15 00:16:32.000000', 'temperatura', 70.0000, 'ºC'),
	(28549, 112, '2015-01-15 00:16:33.000000', 'temperatura', 5.0000, 'ºC'),
	(28550, 112, '2015-01-15 00:16:34.000000', 'temperatura', 1014.0000, 'ºC'),
	(28551, 112, '2015-01-15 00:16:35.000000', 'temperatura', 255.0000, 'ºC'),
	(28552, 112, '2015-01-15 00:16:36.000000', 'temperatura', 636.0000, 'ºC'),
	(28553, 112, '2015-01-15 00:16:37.000000', 'temperatura', 16.0000, 'ºC'),
	(28554, 112, '2015-01-15 00:16:38.000000', 'temperatura', 573.0000, 'ºC'),
	(28555, 112, '2015-01-15 00:16:39.000000', 'temperatura', 415.0000, 'ºC'),
	(28556, 112, '2015-01-15 00:16:40.000000', 'temperatura', 359.0000, 'ºC'),
	(28557, 112, '2015-01-15 00:16:41.000000', 'temperatura', 550.0000, 'ºC'),
	(28558, 112, '2015-01-15 00:16:42.000000', 'temperatura', 473.0000, 'ºC'),
	(28559, 112, '2015-01-15 00:16:43.000000', 'temperatura', 715.0000, 'ºC'),
	(28560, 112, '2015-01-15 00:16:44.000000', 'temperatura', 959.0000, 'ºC'),
	(28561, 112, '2015-01-15 00:16:45.000000', 'temperatura', 247.0000, 'ºC'),
	(28562, 112, '2015-01-15 00:16:46.000000', 'temperatura', 761.0000, 'ºC'),
	(28563, 112, '2015-01-15 00:16:47.000000', 'temperatura', 665.0000, 'ºC'),
	(28564, 112, '2015-01-15 00:16:48.000000', 'temperatura', 1040.0000, 'ºC'),
	(28565, 112, '2015-01-15 00:16:49.000000', 'temperatura', 807.0000, 'ºC'),
	(28566, 112, '2015-01-15 00:16:50.000000', 'temperatura', 915.0000, 'ºC'),
	(28567, 112, '2015-01-15 00:16:51.000000', 'temperatura', 955.0000, 'ºC'),
	(28568, 112, '2015-01-15 00:16:52.000000', 'temperatura', 831.0000, 'ºC'),
	(28569, 112, '2015-01-15 00:16:53.000000', 'temperatura', 91.0000, 'ºC'),
	(28570, 112, '2015-01-15 00:16:54.000000', 'temperatura', 363.0000, 'ºC'),
	(28571, 112, '2015-01-15 00:16:55.000000', 'temperatura', 343.0000, 'ºC'),
	(28572, 112, '2015-01-15 00:16:56.000000', 'temperatura', 625.0000, 'ºC'),
	(28573, 112, '2015-01-15 00:16:57.000000', 'temperatura', 898.0000, 'ºC'),
	(28574, 112, '2015-01-15 00:16:58.000000', 'temperatura', 216.0000, 'ºC'),
	(28575, 112, '2015-01-15 00:16:59.000000', 'temperatura', 786.0000, 'ºC'),
	(28576, 112, '2015-01-15 00:17:00.000000', 'temperatura', 882.0000, 'ºC'),
	(28577, 112, '2015-01-15 00:17:01.000000', 'temperatura', 851.0000, 'ºC'),
	(28578, 112, '2015-01-15 00:17:02.000000', 'temperatura', 411.0000, 'ºC'),
	(28579, 112, '2015-01-15 00:17:03.000000', 'temperatura', 702.0000, 'ºC'),
	(28580, 112, '2015-01-15 00:17:04.000000', 'temperatura', 1076.0000, 'ºC'),
	(28581, 112, '2015-01-15 00:17:05.000000', 'temperatura', 877.0000, 'ºC'),
	(28582, 112, '2015-01-15 00:17:06.000000', 'temperatura', 1155.0000, 'ºC'),
	(28583, 112, '2015-01-15 00:17:07.000000', 'temperatura', 746.0000, 'ºC'),
	(28584, 112, '2015-01-15 00:17:08.000000', 'temperatura', 267.0000, 'ºC'),
	(28585, 112, '2015-01-15 00:17:09.000000', 'temperatura', 296.0000, 'ºC'),
	(28586, 112, '2015-01-15 00:17:10.000000', 'temperatura', 680.0000, 'ºC'),
	(28587, 112, '2015-01-15 00:17:11.000000', 'temperatura', 113.0000, 'ºC'),
	(28588, 112, '2015-01-15 00:17:12.000000', 'temperatura', 924.0000, 'ºC'),
	(28589, 112, '2015-01-15 00:17:13.000000', 'temperatura', 683.0000, 'ºC'),
	(28590, 112, '2015-01-15 00:17:14.000000', 'temperatura', 644.0000, 'ºC'),
	(28591, 112, '2015-01-15 00:17:15.000000', 'temperatura', 1169.0000, 'ºC'),
	(28592, 112, '2015-01-15 00:17:16.000000', 'temperatura', 316.0000, 'ºC'),
	(28593, 112, '2015-01-15 00:17:17.000000', 'temperatura', 471.0000, 'ºC'),
	(28594, 112, '2015-01-15 00:17:18.000000', 'temperatura', 210.0000, 'ºC'),
	(28595, 112, '2015-01-15 00:17:19.000000', 'temperatura', 835.0000, 'ºC'),
	(28596, 112, '2015-01-15 00:17:20.000000', 'temperatura', 1145.0000, 'ºC'),
	(28597, 112, '2015-01-15 00:17:21.000000', 'temperatura', 822.0000, 'ºC'),
	(28598, 112, '2015-01-15 00:17:22.000000', 'temperatura', 676.0000, 'ºC'),
	(28599, 112, '2015-01-15 00:17:23.000000', 'temperatura', 912.0000, 'ºC'),
	(28600, 112, '2015-01-15 00:17:24.000000', 'temperatura', 135.0000, 'ºC'),
	(28601, 112, '2015-01-15 00:17:25.000000', 'temperatura', 339.0000, 'ºC'),
	(28602, 112, '2015-01-15 00:17:26.000000', 'temperatura', 89.0000, 'ºC'),
	(28603, 112, '2015-01-15 00:17:27.000000', 'temperatura', 628.0000, 'ºC'),
	(28604, 112, '2015-01-15 00:17:28.000000', 'temperatura', 474.0000, 'ºC'),
	(28605, 112, '2015-01-15 00:17:29.000000', 'temperatura', 488.0000, 'ºC'),
	(28606, 112, '2015-01-15 00:17:30.000000', 'temperatura', 1018.0000, 'ºC'),
	(28607, 112, '2015-01-15 00:17:31.000000', 'temperatura', 25.0000, 'ºC'),
	(28608, 112, '2015-01-15 00:17:32.000000', 'temperatura', 672.0000, 'ºC'),
	(28609, 112, '2015-01-15 00:17:33.000000', 'temperatura', 887.0000, 'ºC'),
	(28610, 112, '2015-01-15 00:17:34.000000', 'temperatura', 18.0000, 'ºC'),
	(28611, 112, '2015-01-15 00:17:35.000000', 'temperatura', 1032.0000, 'ºC'),
	(28612, 112, '2015-01-15 00:17:36.000000', 'temperatura', 305.0000, 'ºC'),
	(28613, 112, '2015-01-15 00:17:37.000000', 'temperatura', 831.0000, 'ºC'),
	(28614, 112, '2015-01-15 00:17:38.000000', 'temperatura', 839.0000, 'ºC'),
	(28615, 112, '2015-01-15 00:17:39.000000', 'temperatura', 502.0000, 'ºC'),
	(28616, 112, '2015-01-15 00:17:40.000000', 'temperatura', 1194.0000, 'ºC'),
	(28617, 112, '2015-01-15 00:17:41.000000', 'temperatura', 863.0000, 'ºC'),
	(28618, 112, '2015-01-15 00:17:42.000000', 'temperatura', 735.0000, 'ºC'),
	(28619, 112, '2015-01-15 00:17:43.000000', 'temperatura', 1086.0000, 'ºC'),
	(28620, 112, '2015-01-15 00:17:44.000000', 'temperatura', 827.0000, 'ºC'),
	(28621, 112, '2015-01-15 00:17:45.000000', 'temperatura', 878.0000, 'ºC'),
	(28622, 112, '2015-01-15 00:17:46.000000', 'temperatura', 709.0000, 'ºC'),
	(28623, 112, '2015-01-15 00:17:47.000000', 'temperatura', 911.0000, 'ºC'),
	(28624, 112, '2015-01-15 00:17:48.000000', 'temperatura', 29.0000, 'ºC'),
	(28625, 112, '2015-01-15 00:17:49.000000', 'temperatura', 1013.0000, 'ºC'),
	(28626, 112, '2015-01-15 00:17:50.000000', 'temperatura', 177.0000, 'ºC'),
	(28627, 112, '2015-01-15 00:17:51.000000', 'temperatura', 248.0000, 'ºC'),
	(28628, 112, '2015-01-15 00:17:52.000000', 'temperatura', 710.0000, 'ºC'),
	(28629, 112, '2015-01-15 00:17:53.000000', 'temperatura', 405.0000, 'ºC'),
	(28630, 112, '2015-01-15 00:17:54.000000', 'temperatura', 1096.0000, 'ºC'),
	(28631, 112, '2015-01-15 00:17:55.000000', 'temperatura', 666.0000, 'ºC'),
	(28632, 112, '2015-01-15 00:17:56.000000', 'temperatura', 41.0000, 'ºC'),
	(28633, 112, '2015-01-15 00:17:57.000000', 'temperatura', 610.0000, 'ºC'),
	(28634, 112, '2015-01-15 00:17:58.000000', 'temperatura', 527.0000, 'ºC'),
	(28635, 112, '2015-01-15 00:17:59.000000', 'temperatura', 806.0000, 'ºC'),
	(28636, 112, '2015-01-15 00:18:00.000000', 'temperatura', 48.0000, 'ºC'),
	(28637, 112, '2015-01-15 00:18:01.000000', 'temperatura', 225.0000, 'ºC'),
	(28638, 112, '2015-01-15 00:18:02.000000', 'temperatura', 978.0000, 'ºC'),
	(28639, 112, '2015-01-15 00:18:03.000000', 'temperatura', 618.0000, 'ºC'),
	(28640, 112, '2015-01-15 00:18:04.000000', 'temperatura', 156.0000, 'ºC'),
	(28641, 112, '2015-01-15 00:18:05.000000', 'temperatura', 126.0000, 'ºC'),
	(28642, 112, '2015-01-15 00:18:06.000000', 'temperatura', 163.0000, 'ºC'),
	(28643, 112, '2015-01-15 00:18:07.000000', 'temperatura', 436.0000, 'ºC'),
	(28644, 112, '2015-01-15 00:18:08.000000', 'temperatura', 494.0000, 'ºC'),
	(28645, 112, '2015-01-15 00:18:09.000000', 'temperatura', 1160.0000, 'ºC'),
	(28646, 112, '2015-01-15 00:18:10.000000', 'temperatura', 719.0000, 'ºC'),
	(28647, 112, '2015-01-15 00:18:11.000000', 'temperatura', 115.0000, 'ºC'),
	(28648, 112, '2015-01-15 00:18:12.000000', 'temperatura', 821.0000, 'ºC'),
	(28649, 112, '2015-01-15 00:18:13.000000', 'temperatura', 160.0000, 'ºC'),
	(28650, 112, '2015-01-15 00:18:14.000000', 'temperatura', 736.0000, 'ºC'),
	(28651, 112, '2015-01-15 00:18:15.000000', 'temperatura', 800.0000, 'ºC'),
	(28652, 112, '2015-01-15 00:18:16.000000', 'temperatura', 595.0000, 'ºC'),
	(28653, 112, '2015-01-15 00:18:17.000000', 'temperatura', 575.0000, 'ºC'),
	(28654, 112, '2015-01-15 00:18:18.000000', 'temperatura', 1090.0000, 'ºC'),
	(28655, 112, '2015-01-15 00:18:19.000000', 'temperatura', 123.0000, 'ºC'),
	(28656, 112, '2015-01-15 00:18:20.000000', 'temperatura', 949.0000, 'ºC'),
	(28657, 112, '2015-01-15 00:18:21.000000', 'temperatura', 776.0000, 'ºC'),
	(28658, 112, '2015-01-15 00:18:22.000000', 'temperatura', 1032.0000, 'ºC'),
	(28659, 112, '2015-01-15 00:18:23.000000', 'temperatura', 433.0000, 'ºC'),
	(28660, 112, '2015-01-15 00:18:24.000000', 'temperatura', 268.0000, 'ºC'),
	(28661, 112, '2015-01-15 00:18:25.000000', 'temperatura', 44.0000, 'ºC'),
	(28662, 112, '2015-01-15 00:18:26.000000', 'temperatura', 615.0000, 'ºC'),
	(28663, 112, '2015-01-15 00:18:27.000000', 'temperatura', 542.0000, 'ºC'),
	(28664, 112, '2015-01-15 00:18:28.000000', 'temperatura', 869.0000, 'ºC'),
	(28665, 112, '2015-01-15 00:18:29.000000', 'temperatura', 316.0000, 'ºC'),
	(28666, 112, '2015-01-15 00:18:30.000000', 'temperatura', 176.0000, 'ºC'),
	(28667, 112, '2015-01-15 00:18:31.000000', 'temperatura', 1131.0000, 'ºC'),
	(28668, 112, '2015-01-15 00:18:32.000000', 'temperatura', 326.0000, 'ºC'),
	(28669, 112, '2015-01-15 00:18:33.000000', 'temperatura', 639.0000, 'ºC'),
	(28670, 112, '2015-01-15 00:18:34.000000', 'temperatura', 1019.0000, 'ºC'),
	(28671, 112, '2015-01-15 00:18:35.000000', 'temperatura', 776.0000, 'ºC'),
	(28672, 112, '2015-01-15 00:18:36.000000', 'temperatura', 825.0000, 'ºC'),
	(28673, 112, '2015-01-15 00:18:37.000000', 'temperatura', 598.0000, 'ºC'),
	(28674, 112, '2015-01-15 00:18:38.000000', 'temperatura', 515.0000, 'ºC'),
	(28675, 112, '2015-01-15 00:18:39.000000', 'temperatura', 779.0000, 'ºC'),
	(28676, 112, '2015-01-15 00:18:40.000000', 'temperatura', 1154.0000, 'ºC'),
	(28677, 112, '2015-01-15 00:18:41.000000', 'temperatura', 1033.0000, 'ºC'),
	(28678, 112, '2015-01-15 00:18:42.000000', 'temperatura', 503.0000, 'ºC'),
	(28679, 112, '2015-01-15 00:18:43.000000', 'temperatura', 616.0000, 'ºC'),
	(28680, 112, '2015-01-15 00:18:44.000000', 'temperatura', 373.0000, 'ºC'),
	(28681, 112, '2015-01-15 00:18:45.000000', 'temperatura', 16.0000, 'ºC'),
	(28682, 112, '2015-01-15 00:18:46.000000', 'temperatura', 164.0000, 'ºC'),
	(28683, 112, '2015-01-15 00:18:47.000000', 'temperatura', 770.0000, 'ºC'),
	(28684, 112, '2015-01-15 00:18:48.000000', 'temperatura', 957.0000, 'ºC'),
	(28685, 112, '2015-01-15 00:18:49.000000', 'temperatura', 78.0000, 'ºC'),
	(28686, 112, '2015-01-15 00:18:50.000000', 'temperatura', 1118.0000, 'ºC'),
	(28687, 112, '2015-01-15 00:18:51.000000', 'temperatura', 558.0000, 'ºC'),
	(28688, 112, '2015-01-15 00:18:52.000000', 'temperatura', 634.0000, 'ºC'),
	(28689, 112, '2015-01-15 00:18:53.000000', 'temperatura', 297.0000, 'ºC'),
	(28690, 112, '2015-01-15 00:18:54.000000', 'temperatura', 783.0000, 'ºC'),
	(28691, 112, '2015-01-15 00:18:55.000000', 'temperatura', 625.0000, 'ºC'),
	(28692, 112, '2015-01-15 00:18:56.000000', 'temperatura', 778.0000, 'ºC'),
	(28693, 112, '2015-01-15 00:18:57.000000', 'temperatura', 813.0000, 'ºC'),
	(28694, 112, '2015-01-15 00:18:58.000000', 'temperatura', 533.0000, 'ºC'),
	(28695, 112, '2015-01-15 00:18:59.000000', 'temperatura', 226.0000, 'ºC'),
	(28696, 112, '2015-01-15 00:19:00.000000', 'temperatura', 732.0000, 'ºC'),
	(28697, 112, '2015-01-15 00:19:01.000000', 'temperatura', 581.0000, 'ºC'),
	(28698, 112, '2015-01-15 00:19:02.000000', 'temperatura', 709.0000, 'ºC'),
	(28699, 112, '2015-01-15 00:19:03.000000', 'temperatura', 603.0000, 'ºC'),
	(28700, 112, '2015-01-15 00:19:04.000000', 'temperatura', 887.0000, 'ºC'),
	(28701, 112, '2015-01-15 00:19:05.000000', 'temperatura', 228.0000, 'ºC'),
	(28702, 112, '2015-01-15 00:19:06.000000', 'temperatura', 878.0000, 'ºC'),
	(28703, 112, '2015-01-15 00:19:07.000000', 'temperatura', 107.0000, 'ºC'),
	(28704, 112, '2015-01-15 00:19:08.000000', 'temperatura', 304.0000, 'ºC'),
	(28705, 112, '2015-01-15 00:19:09.000000', 'temperatura', 1196.0000, 'ºC'),
	(28706, 112, '2015-01-15 00:19:10.000000', 'temperatura', 272.0000, 'ºC'),
	(28707, 112, '2015-01-15 00:19:11.000000', 'temperatura', 169.0000, 'ºC'),
	(28708, 112, '2015-01-15 00:19:12.000000', 'temperatura', 31.0000, 'ºC'),
	(28709, 112, '2015-01-15 00:19:13.000000', 'temperatura', 850.0000, 'ºC'),
	(28710, 112, '2015-01-15 00:19:14.000000', 'temperatura', 556.0000, 'ºC'),
	(28711, 112, '2015-01-15 00:19:15.000000', 'temperatura', 229.0000, 'ºC'),
	(28712, 112, '2015-01-15 00:19:16.000000', 'temperatura', 680.0000, 'ºC'),
	(28713, 112, '2015-01-15 00:19:17.000000', 'temperatura', 312.0000, 'ºC'),
	(28714, 112, '2015-01-15 00:19:18.000000', 'temperatura', 722.0000, 'ºC'),
	(28715, 112, '2015-01-15 00:19:19.000000', 'temperatura', 274.0000, 'ºC'),
	(28716, 112, '2015-01-15 00:19:20.000000', 'temperatura', 405.0000, 'ºC'),
	(28717, 112, '2015-01-15 00:19:21.000000', 'temperatura', 4.0000, 'ºC'),
	(28718, 112, '2015-01-15 00:19:22.000000', 'temperatura', 5.0000, 'ºC'),
	(28719, 112, '2015-01-15 00:19:23.000000', 'temperatura', 14.0000, 'ºC'),
	(28720, 112, '2015-01-15 00:19:24.000000', 'temperatura', 55.0000, 'ºC'),
	(28721, 112, '2015-01-15 00:19:25.000000', 'temperatura', 235.0000, 'ºC'),
	(28722, 112, '2015-01-15 00:19:26.000000', 'temperatura', 1008.0000, 'ºC'),
	(28723, 112, '2015-01-15 00:19:27.000000', 'temperatura', 735.0000, 'ºC'),
	(28724, 112, '2015-01-15 00:19:28.000000', 'temperatura', 651.0000, 'ºC'),
	(28725, 112, '2015-01-15 00:19:29.000000', 'temperatura', 1053.0000, 'ºC'),
	(28726, 112, '2015-01-15 00:19:30.000000', 'temperatura', 910.0000, 'ºC'),
	(28727, 112, '2015-01-15 00:19:31.000000', 'temperatura', 193.0000, 'ºC'),
	(28728, 112, '2015-01-15 00:19:32.000000', 'temperatura', 637.0000, 'ºC'),
	(28729, 112, '2015-01-15 00:19:33.000000', 'temperatura', 203.0000, 'ºC'),
	(28730, 112, '2015-01-15 00:19:34.000000', 'temperatura', 307.0000, 'ºC'),
	(28731, 112, '2015-01-15 00:19:35.000000', 'temperatura', 924.0000, 'ºC'),
	(28732, 112, '2015-01-15 00:19:36.000000', 'temperatura', 101.0000, 'ºC'),
	(28733, 112, '2015-01-15 00:19:37.000000', 'temperatura', 135.0000, 'ºC'),
	(28734, 112, '2015-01-15 00:19:38.000000', 'temperatura', 370.0000, 'ºC'),
	(28735, 112, '2015-01-15 00:19:39.000000', 'temperatura', 246.0000, 'ºC'),
	(28736, 112, '2015-01-15 00:19:40.000000', 'temperatura', 121.0000, 'ºC'),
	(28737, 112, '2015-01-15 00:19:41.000000', 'temperatura', 1066.0000, 'ºC'),
	(28738, 112, '2015-01-15 00:19:42.000000', 'temperatura', 169.0000, 'ºC'),
	(28739, 112, '2015-01-15 00:19:43.000000', 'temperatura', 46.0000, 'ºC'),
	(28740, 112, '2015-01-15 00:19:44.000000', 'temperatura', 925.0000, 'ºC'),
	(28741, 112, '2015-01-15 00:19:45.000000', 'temperatura', 887.0000, 'ºC'),
	(28742, 112, '2015-01-15 00:19:46.000000', 'temperatura', 460.0000, 'ºC'),
	(28743, 112, '2015-01-15 00:19:47.000000', 'temperatura', 840.0000, 'ºC'),
	(28744, 112, '2015-01-15 00:19:48.000000', 'temperatura', 420.0000, 'ºC'),
	(28745, 112, '2015-01-15 00:19:49.000000', 'temperatura', 780.0000, 'ºC'),
	(28746, 112, '2015-01-15 00:19:50.000000', 'temperatura', 243.0000, 'ºC'),
	(28747, 112, '2015-01-15 00:19:51.000000', 'temperatura', 73.0000, 'ºC'),
	(28748, 112, '2015-01-15 00:19:52.000000', 'temperatura', 837.0000, 'ºC'),
	(28749, 112, '2015-01-15 00:19:53.000000', 'temperatura', 366.0000, 'ºC'),
	(28750, 112, '2015-01-15 00:19:54.000000', 'temperatura', 518.0000, 'ºC'),
	(28751, 112, '2015-01-15 00:19:55.000000', 'temperatura', 293.0000, 'ºC'),
	(28752, 112, '2015-01-15 00:19:56.000000', 'temperatura', 1113.0000, 'ºC'),
	(28753, 112, '2015-01-15 00:19:57.000000', 'temperatura', 1086.0000, 'ºC'),
	(28754, 112, '2015-01-15 00:19:58.000000', 'temperatura', 890.0000, 'ºC'),
	(28755, 112, '2015-01-15 00:19:59.000000', 'temperatura', 1193.0000, 'ºC'),
	(28756, 112, '2015-01-15 00:20:00.000000', 'temperatura', 897.0000, 'ºC'),
	(28757, 112, '2015-01-15 00:20:01.000000', 'temperatura', 907.0000, 'ºC'),
	(28758, 112, '2015-01-15 00:20:02.000000', 'temperatura', 643.0000, 'ºC'),
	(28759, 112, '2015-01-15 00:20:03.000000', 'temperatura', 496.0000, 'ºC'),
	(28760, 112, '2015-01-15 00:20:04.000000', 'temperatura', 553.0000, 'ºC'),
	(28761, 112, '2015-01-15 00:20:05.000000', 'temperatura', 74.0000, 'ºC'),
	(28762, 112, '2015-01-15 00:20:06.000000', 'temperatura', 1115.0000, 'ºC'),
	(28763, 112, '2015-01-15 00:20:07.000000', 'temperatura', 551.0000, 'ºC'),
	(28764, 112, '2015-01-15 00:20:08.000000', 'temperatura', 610.0000, 'ºC'),
	(28765, 112, '2015-01-15 00:20:09.000000', 'temperatura', 196.0000, 'ºC'),
	(28766, 112, '2015-01-15 00:20:10.000000', 'temperatura', 354.0000, 'ºC'),
	(28767, 112, '2015-01-15 00:20:11.000000', 'temperatura', 1180.0000, 'ºC'),
	(28768, 112, '2015-01-15 00:20:12.000000', 'temperatura', 39.0000, 'ºC'),
	(28769, 112, '2015-01-15 00:20:13.000000', 'temperatura', 257.0000, 'ºC'),
	(28770, 112, '2015-01-15 00:20:14.000000', 'temperatura', 1169.0000, 'ºC'),
	(28771, 112, '2015-01-15 00:20:15.000000', 'temperatura', 274.0000, 'ºC'),
	(28772, 112, '2015-01-15 00:20:16.000000', 'temperatura', 262.0000, 'ºC'),
	(28773, 112, '2015-01-15 00:20:17.000000', 'temperatura', 489.0000, 'ºC'),
	(28774, 112, '2015-01-15 00:20:18.000000', 'temperatura', 461.0000, 'ºC'),
	(28775, 112, '2015-01-15 00:20:19.000000', 'temperatura', 838.0000, 'ºC'),
	(28776, 112, '2015-01-15 00:20:20.000000', 'temperatura', 408.0000, 'ºC'),
	(28777, 112, '2015-01-15 00:20:21.000000', 'temperatura', 727.0000, 'ºC'),
	(28778, 112, '2015-01-15 00:20:22.000000', 'temperatura', 11.0000, 'ºC'),
	(28779, 112, '2015-01-15 00:20:23.000000', 'temperatura', 276.0000, 'ºC'),
	(28780, 112, '2015-01-15 00:20:24.000000', 'temperatura', 146.0000, 'ºC'),
	(28781, 112, '2015-01-15 00:20:25.000000', 'temperatura', 1104.0000, 'ºC'),
	(28782, 112, '2015-01-15 00:20:26.000000', 'temperatura', 282.0000, 'ºC'),
	(28783, 112, '2015-01-15 00:20:27.000000', 'temperatura', 496.0000, 'ºC'),
	(28784, 112, '2015-01-15 00:20:28.000000', 'temperatura', 437.0000, 'ºC'),
	(28785, 112, '2015-01-15 00:20:29.000000', 'temperatura', 695.0000, 'ºC'),
	(28786, 112, '2015-01-15 00:20:30.000000', 'temperatura', 965.0000, 'ºC'),
	(28787, 112, '2015-01-15 00:20:31.000000', 'temperatura', 340.0000, 'ºC'),
	(28788, 112, '2015-01-15 00:20:32.000000', 'temperatura', 6.0000, 'ºC'),
	(28789, 112, '2015-01-15 00:20:33.000000', 'temperatura', 210.0000, 'ºC'),
	(28790, 112, '2015-01-15 00:20:34.000000', 'temperatura', 1035.0000, 'ºC'),
	(28791, 112, '2015-01-15 00:20:35.000000', 'temperatura', 944.0000, 'ºC'),
	(28792, 112, '2015-01-15 00:20:36.000000', 'temperatura', 416.0000, 'ºC'),
	(28793, 112, '2015-01-15 00:20:37.000000', 'temperatura', 450.0000, 'ºC'),
	(28794, 112, '2015-01-15 00:20:38.000000', 'temperatura', 999.0000, 'ºC'),
	(28795, 112, '2015-01-15 00:20:39.000000', 'temperatura', 48.0000, 'ºC'),
	(28796, 112, '2015-01-15 00:20:40.000000', 'temperatura', 842.0000, 'ºC'),
	(28797, 112, '2015-01-15 00:20:41.000000', 'temperatura', 465.0000, 'ºC'),
	(28798, 112, '2015-01-15 00:20:42.000000', 'temperatura', 1002.0000, 'ºC'),
	(28799, 112, '2015-01-15 00:20:43.000000', 'temperatura', 13.0000, 'ºC'),
	(28800, 112, '2015-01-15 00:20:44.000000', 'temperatura', 663.0000, 'ºC'),
	(28801, 112, '2015-01-15 00:20:45.000000', 'temperatura', 873.0000, 'ºC'),
	(28802, 112, '2015-01-15 00:20:46.000000', 'temperatura', 1179.0000, 'ºC'),
	(28803, 112, '2015-01-15 00:20:47.000000', 'temperatura', 875.0000, 'ºC'),
	(28804, 112, '2015-01-15 00:20:48.000000', 'temperatura', 838.0000, 'ºC'),
	(28805, 112, '2015-01-15 00:20:49.000000', 'temperatura', 365.0000, 'ºC'),
	(28806, 112, '2015-01-15 00:20:50.000000', 'temperatura', 510.0000, 'ºC'),
	(28807, 112, '2015-01-15 00:20:51.000000', 'temperatura', 259.0000, 'ºC'),
	(28808, 112, '2015-01-15 00:20:52.000000', 'temperatura', 963.0000, 'ºC'),
	(28809, 112, '2015-01-15 00:20:53.000000', 'temperatura', 441.0000, 'ºC'),
	(28810, 112, '2015-01-15 00:20:54.000000', 'temperatura', 517.0000, 'ºC'),
	(28811, 112, '2015-01-15 00:20:55.000000', 'temperatura', 62.0000, 'ºC'),
	(28812, 112, '2015-01-15 00:20:56.000000', 'temperatura', 1157.0000, 'ºC'),
	(28813, 112, '2015-01-15 00:20:57.000000', 'temperatura', 802.0000, 'ºC'),
	(28814, 112, '2015-01-15 00:20:58.000000', 'temperatura', 539.0000, 'ºC'),
	(28815, 112, '2015-01-15 00:20:59.000000', 'temperatura', 291.0000, 'ºC'),
	(28816, 112, '2015-01-15 00:21:00.000000', 'temperatura', 1039.0000, 'ºC'),
	(28817, 112, '2015-01-15 00:21:01.000000', 'temperatura', 722.0000, 'ºC'),
	(28818, 112, '2015-01-15 00:21:02.000000', 'temperatura', 491.0000, 'ºC'),
	(28819, 112, '2015-01-15 00:21:03.000000', 'temperatura', 292.0000, 'ºC'),
	(28820, 112, '2015-01-15 00:21:04.000000', 'temperatura', 1185.0000, 'ºC'),
	(28821, 112, '2015-01-15 00:21:05.000000', 'temperatura', 250.0000, 'ºC'),
	(28822, 112, '2015-01-15 00:21:06.000000', 'temperatura', 96.0000, 'ºC'),
	(28823, 112, '2015-01-15 00:21:07.000000', 'temperatura', 929.0000, 'ºC'),
	(28824, 112, '2015-01-15 00:21:08.000000', 'temperatura', 760.0000, 'ºC'),
	(28825, 112, '2015-01-15 00:21:09.000000', 'temperatura', 1013.0000, 'ºC'),
	(28826, 112, '2015-01-15 00:21:10.000000', 'temperatura', 387.0000, 'ºC'),
	(28827, 112, '2015-01-15 00:21:11.000000', 'temperatura', 94.0000, 'ºC'),
	(28828, 112, '2015-01-15 00:21:12.000000', 'temperatura', 511.0000, 'ºC'),
	(28829, 112, '2015-01-15 00:21:13.000000', 'temperatura', 1073.0000, 'ºC'),
	(28830, 112, '2015-01-15 00:21:14.000000', 'temperatura', 233.0000, 'ºC'),
	(28831, 112, '2015-01-15 00:21:15.000000', 'temperatura', 347.0000, 'ºC'),
	(28832, 112, '2015-01-15 00:21:16.000000', 'temperatura', 1037.0000, 'ºC'),
	(28833, 112, '2015-01-15 00:21:17.000000', 'temperatura', 544.0000, 'ºC'),
	(28834, 112, '2015-01-15 00:21:18.000000', 'temperatura', 808.0000, 'ºC'),
	(28835, 112, '2015-01-15 00:21:19.000000', 'temperatura', 9.0000, 'ºC'),
	(28836, 112, '2015-01-15 00:21:20.000000', 'temperatura', 20.0000, 'ºC'),
	(28837, 112, '2015-01-15 00:21:21.000000', 'temperatura', 74.0000, 'ºC'),
	(28838, 112, '2015-01-15 00:21:22.000000', 'temperatura', 311.0000, 'ºC'),
	(28839, 112, '2015-01-15 00:21:23.000000', 'temperatura', 133.0000, 'ºC'),
	(28840, 112, '2015-01-15 00:21:24.000000', 'temperatura', 931.0000, 'ºC'),
	(28841, 112, '2015-01-15 00:21:25.000000', 'temperatura', 659.0000, 'ºC'),
	(28842, 112, '2015-01-15 00:21:26.000000', 'temperatura', 502.0000, 'ºC'),
	(28843, 112, '2015-01-15 00:21:27.000000', 'temperatura', 533.0000, 'ºC'),
	(28844, 112, '2015-01-15 00:21:28.000000', 'temperatura', 1162.0000, 'ºC'),
	(28845, 112, '2015-01-15 00:21:29.000000', 'temperatura', 608.0000, 'ºC'),
	(28846, 112, '2015-01-15 00:21:30.000000', 'temperatura', 758.0000, 'ºC'),
	(28847, 112, '2015-01-15 00:21:31.000000', 'temperatura', 765.0000, 'ºC'),
	(28848, 112, '2015-01-15 00:21:32.000000', 'temperatura', 350.0000, 'ºC'),
	(28849, 112, '2015-01-15 00:21:33.000000', 'temperatura', 655.0000, 'ºC'),
	(28850, 112, '2015-01-15 00:21:34.000000', 'temperatura', 1029.0000, 'ºC'),
	(28851, 112, '2015-01-15 00:21:35.000000', 'temperatura', 778.0000, 'ºC'),
	(28852, 112, '2015-01-15 00:21:36.000000', 'temperatura', 802.0000, 'ºC'),
	(28853, 112, '2015-01-15 00:21:37.000000', 'temperatura', 479.0000, 'ºC'),
	(28854, 112, '2015-01-15 00:21:38.000000', 'temperatura', 1190.0000, 'ºC'),
	(28855, 112, '2015-01-15 00:21:39.000000', 'temperatura', 913.0000, 'ºC'),
	(28856, 112, '2015-01-15 00:21:40.000000', 'temperatura', 993.0000, 'ºC'),
	(28857, 112, '2015-01-15 00:21:41.000000', 'temperatura', 1029.0000, 'ºC'),
	(28858, 112, '2015-01-15 00:21:42.000000', 'temperatura', 966.0000, 'ºC'),
	(28859, 112, '2015-01-15 00:21:43.000000', 'temperatura', 542.0000, 'ºC'),
	(28860, 112, '2015-01-15 00:21:44.000000', 'temperatura', 1013.0000, 'ºC'),
	(28861, 112, '2015-01-15 00:21:45.000000', 'temperatura', 1041.0000, 'ºC'),
	(28862, 112, '2015-01-15 00:21:46.000000', 'temperatura', 967.0000, 'ºC'),
	(28863, 112, '2015-01-15 00:21:47.000000', 'temperatura', 513.0000, 'ºC'),
	(28864, 112, '2015-01-15 00:21:48.000000', 'temperatura', 865.0000, 'ºC'),
	(28865, 112, '2015-01-15 00:21:49.000000', 'temperatura', 386.0000, 'ºC'),
	(28866, 112, '2015-01-15 00:21:50.000000', 'temperatura', 535.0000, 'ºC'),
	(28867, 112, '2015-01-15 00:21:51.000000', 'temperatura', 316.0000, 'ºC'),
	(28868, 112, '2015-01-15 00:21:52.000000', 'temperatura', 1176.0000, 'ºC'),
	(28869, 112, '2015-01-15 00:21:53.000000', 'temperatura', 134.0000, 'ºC'),
	(28870, 112, '2015-01-15 00:21:54.000000', 'temperatura', 740.0000, 'ºC'),
	(28871, 112, '2015-01-15 00:21:55.000000', 'temperatura', 899.0000, 'ºC'),
	(28872, 112, '2015-01-15 00:21:56.000000', 'temperatura', 1078.0000, 'ºC'),
	(28873, 112, '2015-01-15 00:21:57.000000', 'temperatura', 293.0000, 'ºC'),
	(28874, 112, '2015-01-15 00:21:58.000000', 'temperatura', 630.0000, 'ºC'),
	(28875, 112, '2015-01-15 00:21:59.000000', 'temperatura', 1070.0000, 'ºC'),
	(28876, 112, '2015-01-15 00:22:00.000000', 'temperatura', 1063.0000, 'ºC'),
	(28877, 112, '2015-01-15 00:22:01.000000', 'temperatura', 904.0000, 'ºC'),
	(28878, 112, '2015-01-15 00:22:02.000000', 'temperatura', 133.0000, 'ºC'),
	(28879, 112, '2015-01-15 00:22:03.000000', 'temperatura', 355.0000, 'ºC'),
	(28880, 112, '2015-01-15 00:22:04.000000', 'temperatura', 174.0000, 'ºC'),
	(28881, 112, '2015-01-15 00:22:05.000000', 'temperatura', 1005.0000, 'ºC'),
	(28882, 112, '2015-01-15 00:22:06.000000', 'temperatura', 906.0000, 'ºC'),
	(28883, 112, '2015-01-15 00:22:07.000000', 'temperatura', 313.0000, 'ºC'),
	(28884, 112, '2015-01-15 00:22:08.000000', 'temperatura', 48.0000, 'ºC'),
	(28885, 112, '2015-01-15 00:22:09.000000', 'temperatura', 502.0000, 'ºC'),
	(28886, 112, '2015-01-15 00:22:10.000000', 'temperatura', 1165.0000, 'ºC'),
	(28887, 112, '2015-01-15 00:22:11.000000', 'temperatura', 720.0000, 'ºC'),
	(28888, 112, '2015-01-15 00:22:12.000000', 'temperatura', 105.0000, 'ºC'),
	(28889, 112, '2015-01-15 00:22:13.000000', 'temperatura', 766.0000, 'ºC'),
	(28890, 112, '2015-01-15 00:22:14.000000', 'temperatura', 1115.0000, 'ºC'),
	(28891, 112, '2015-01-15 00:22:15.000000', 'temperatura', 878.0000, 'ºC'),
	(28892, 112, '2015-01-15 00:22:16.000000', 'temperatura', 1047.0000, 'ºC'),
	(28893, 112, '2015-01-15 00:22:17.000000', 'temperatura', 201.0000, 'ºC'),
	(28894, 112, '2015-01-15 00:22:18.000000', 'temperatura', 263.0000, 'ºC'),
	(28895, 112, '2015-01-15 00:22:19.000000', 'temperatura', 712.0000, 'ºC'),
	(28896, 112, '2015-01-15 00:22:20.000000', 'temperatura', 374.0000, 'ºC'),
	(28897, 112, '2015-01-15 00:22:21.000000', 'temperatura', 933.0000, 'ºC'),
	(28898, 112, '2015-01-15 00:22:22.000000', 'temperatura', 1144.0000, 'ºC'),
	(28899, 112, '2015-01-15 00:22:23.000000', 'temperatura', 520.0000, 'ºC'),
	(28900, 112, '2015-01-15 00:22:24.000000', 'temperatura', 370.0000, 'ºC'),
	(28901, 112, '2015-01-15 00:22:25.000000', 'temperatura', 289.0000, 'ºC'),
	(28902, 112, '2015-01-15 00:22:26.000000', 'temperatura', 335.0000, 'ºC'),
	(28903, 112, '2015-01-15 00:22:27.000000', 'temperatura', 809.0000, 'ºC'),
	(28904, 112, '2015-01-15 00:22:28.000000', 'temperatura', 639.0000, 'ºC'),
	(28905, 112, '2015-01-15 00:22:29.000000', 'temperatura', 769.0000, 'ºC'),
	(28906, 112, '2015-01-15 00:22:30.000000', 'temperatura', 731.0000, 'ºC'),
	(28907, 112, '2015-01-15 00:22:31.000000', 'temperatura', 147.0000, 'ºC'),
	(28908, 112, '2015-01-15 00:22:32.000000', 'temperatura', 942.0000, 'ºC'),
	(28909, 112, '2015-01-15 00:22:33.000000', 'temperatura', 670.0000, 'ºC'),
	(28910, 112, '2015-01-15 00:22:34.000000', 'temperatura', 523.0000, 'ºC'),
	(28911, 112, '2015-01-15 00:22:35.000000', 'temperatura', 608.0000, 'ºC'),
	(28912, 112, '2015-01-15 00:22:36.000000', 'temperatura', 270.0000, 'ºC'),
	(28913, 112, '2015-01-15 00:22:37.000000', 'temperatura', 726.0000, 'ºC'),
	(28914, 112, '2015-01-15 00:22:38.000000', 'temperatura', 421.0000, 'ºC'),
	(28915, 112, '2015-01-15 00:22:39.000000', 'temperatura', 1127.0000, 'ºC'),
	(28916, 112, '2015-01-15 00:22:40.000000', 'temperatura', 775.0000, 'ºC'),
	(28917, 112, '2015-01-15 00:22:41.000000', 'temperatura', 493.0000, 'ºC'),
	(28918, 112, '2015-01-15 00:22:42.000000', 'temperatura', 139.0000, 'ºC'),
	(28919, 112, '2015-01-15 00:22:43.000000', 'temperatura', 417.0000, 'ºC'),
	(28920, 112, '2015-01-15 00:22:44.000000', 'temperatura', 470.0000, 'ºC'),
	(28921, 112, '2015-01-15 00:22:45.000000', 'temperatura', 1101.0000, 'ºC'),
	(28922, 112, '2015-01-15 00:22:46.000000', 'temperatura', 492.0000, 'ºC'),
	(28923, 112, '2015-01-15 00:22:47.000000', 'temperatura', 360.0000, 'ºC'),
	(28924, 112, '2015-01-15 00:22:48.000000', 'temperatura', 322.0000, 'ºC'),
	(28925, 112, '2015-01-15 00:22:49.000000', 'temperatura', 530.0000, 'ºC'),
	(28926, 112, '2015-01-15 00:22:50.000000', 'temperatura', 485.0000, 'ºC'),
	(28927, 112, '2015-01-15 00:22:51.000000', 'temperatura', 836.0000, 'ºC'),
	(28928, 112, '2015-01-15 00:22:52.000000', 'temperatura', 325.0000, 'ºC'),
	(28929, 112, '2015-01-15 00:22:53.000000', 'temperatura', 319.0000, 'ºC'),
	(28930, 112, '2015-01-15 00:22:54.000000', 'temperatura', 619.0000, 'ºC'),
	(28931, 112, '2015-01-15 00:22:55.000000', 'temperatura', 937.0000, 'ºC'),
	(28932, 112, '2015-01-15 00:22:56.000000', 'temperatura', 432.0000, 'ºC'),
	(28933, 112, '2015-01-15 00:22:57.000000', 'temperatura', 547.0000, 'ºC'),
	(28934, 112, '2015-01-15 00:22:58.000000', 'temperatura', 242.0000, 'ºC'),
	(28935, 112, '2015-01-15 00:22:59.000000', 'temperatura', 768.0000, 'ºC'),
	(28936, 112, '2015-01-15 00:23:00.000000', 'temperatura', 713.0000, 'ºC'),
	(28937, 112, '2015-01-15 00:23:01.000000', 'temperatura', 61.0000, 'ºC'),
	(28938, 112, '2015-01-15 00:23:02.000000', 'temperatura', 567.0000, 'ºC'),
	(28939, 112, '2015-01-15 00:23:03.000000', 'temperatura', 252.0000, 'ºC'),
	(28940, 112, '2015-01-15 00:23:04.000000', 'temperatura', 761.0000, 'ºC'),
	(28941, 112, '2015-01-15 00:23:05.000000', 'temperatura', 649.0000, 'ºC'),
	(28942, 112, '2015-01-15 00:23:06.000000', 'temperatura', 964.0000, 'ºC'),
	(28943, 112, '2015-01-15 00:23:07.000000', 'temperatura', 471.0000, 'ºC'),
	(28944, 112, '2015-01-15 00:23:08.000000', 'temperatura', 664.0000, 'ºC'),
	(28945, 112, '2015-01-15 00:23:09.000000', 'temperatura', 709.0000, 'ºC'),
	(28946, 112, '2015-01-15 00:23:10.000000', 'temperatura', 352.0000, 'ºC'),
	(28947, 112, '2015-01-15 00:23:11.000000', 'temperatura', 834.0000, 'ºC'),
	(28948, 112, '2015-01-15 00:23:12.000000', 'temperatura', 716.0000, 'ºC'),
	(28949, 112, '2015-01-15 00:23:13.000000', 'temperatura', 1076.0000, 'ºC'),
	(28950, 112, '2015-01-15 00:23:14.000000', 'temperatura', 833.0000, 'ºC'),
	(28951, 112, '2015-01-15 00:23:15.000000', 'temperatura', 937.0000, 'ºC'),
	(28952, 112, '2015-01-15 00:23:16.000000', 'temperatura', 988.0000, 'ºC'),
	(28953, 112, '2015-01-15 00:23:17.000000', 'temperatura', 928.0000, 'ºC'),
	(28954, 112, '2015-01-15 00:23:18.000000', 'temperatura', 476.0000, 'ºC'),
	(28955, 112, '2015-01-15 00:23:19.000000', 'temperatura', 796.0000, 'ºC'),
	(28956, 112, '2015-01-15 00:23:20.000000', 'temperatura', 154.0000, 'ºC'),
	(28957, 112, '2015-01-15 00:23:21.000000', 'temperatura', 782.0000, 'ºC'),
	(28958, 112, '2015-01-15 00:23:22.000000', 'temperatura', 1050.0000, 'ºC'),
	(28959, 112, '2015-01-15 00:23:23.000000', 'temperatura', 506.0000, 'ºC'),
	(28960, 112, '2015-01-15 00:23:24.000000', 'temperatura', 577.0000, 'ºC'),
	(28961, 112, '2015-01-15 00:23:25.000000', 'temperatura', 169.0000, 'ºC'),
	(28962, 112, '2015-01-15 00:23:26.000000', 'temperatura', 315.0000, 'ºC'),
	(28963, 112, '2015-01-15 00:23:27.000000', 'temperatura', 1068.0000, 'ºC'),
	(28964, 112, '2015-01-15 00:23:28.000000', 'temperatura', 794.0000, 'ºC'),
	(28965, 112, '2015-01-15 00:23:29.000000', 'temperatura', 769.0000, 'ºC'),
	(28966, 112, '2015-01-15 00:23:30.000000', 'temperatura', 262.0000, 'ºC'),
	(28967, 112, '2015-01-15 00:23:31.000000', 'temperatura', 203.0000, 'ºC'),
	(28968, 112, '2015-01-15 00:23:32.000000', 'temperatura', 230.0000, 'ºC'),
	(28969, 112, '2015-01-15 00:23:33.000000', 'temperatura', 540.0000, 'ºC'),
	(28970, 112, '2015-01-15 00:23:34.000000', 'temperatura', 810.0000, 'ºC'),
	(28971, 112, '2015-01-15 00:23:35.000000', 'temperatura', 34.0000, 'ºC'),
	(28972, 112, '2015-01-15 00:23:36.000000', 'temperatura', 137.0000, 'ºC'),
	(28973, 112, '2015-01-15 00:23:37.000000', 'temperatura', 586.0000, 'ºC'),
	(28974, 112, '2015-01-15 00:23:38.000000', 'temperatura', 118.0000, 'ºC'),
	(28975, 112, '2015-01-15 00:23:39.000000', 'temperatura', 34.0000, 'ºC'),
	(28976, 112, '2015-01-15 00:23:40.000000', 'temperatura', 1017.0000, 'ºC'),
	(28977, 112, '2015-01-15 00:23:41.000000', 'temperatura', 181.0000, 'ºC'),
	(28978, 112, '2015-01-15 00:23:42.000000', 'temperatura', 254.0000, 'ºC'),
	(28979, 112, '2015-01-15 00:23:43.000000', 'temperatura', 727.0000, 'ºC'),
	(28980, 112, '2015-01-15 00:23:44.000000', 'temperatura', 474.0000, 'ºC'),
	(28981, 112, '2015-01-15 00:23:45.000000', 'temperatura', 192.0000, 'ºC'),
	(28982, 112, '2015-01-15 00:23:46.000000', 'temperatura', 736.0000, 'ºC'),
	(28983, 112, '2015-01-15 00:23:47.000000', 'temperatura', 706.0000, 'ºC'),
	(28984, 112, '2015-01-15 00:23:48.000000', 'temperatura', 124.0000, 'ºC'),
	(28985, 112, '2015-01-15 00:23:49.000000', 'temperatura', 901.0000, 'ºC'),
	(28986, 112, '2015-01-15 00:23:50.000000', 'temperatura', 535.0000, 'ºC'),
	(28987, 112, '2015-01-15 00:23:51.000000', 'temperatura', 1171.0000, 'ºC'),
	(28988, 112, '2015-01-15 00:23:52.000000', 'temperatura', 650.0000, 'ºC'),
	(28989, 112, '2015-01-15 00:23:53.000000', 'temperatura', 940.0000, 'ºC'),
	(28990, 112, '2015-01-15 00:23:54.000000', 'temperatura', 347.0000, 'ºC'),
	(28991, 112, '2015-01-15 00:23:55.000000', 'temperatura', 117.0000, 'ºC'),
	(28992, 112, '2015-01-15 00:23:56.000000', 'temperatura', 746.0000, 'ºC'),
	(28993, 112, '2015-01-15 00:23:57.000000', 'temperatura', 977.0000, 'ºC'),
	(28994, 112, '2015-01-15 00:23:58.000000', 'temperatura', 249.0000, 'ºC'),
	(28995, 112, '2015-01-15 00:23:59.000000', 'temperatura', 714.0000, 'ºC'),
	(28996, 112, '2015-01-15 00:24:00.000000', 'temperatura', 425.0000, 'ºC'),
	(28997, 112, '2015-01-15 00:24:01.000000', 'temperatura', 1181.0000, 'ºC'),
	(28998, 112, '2015-01-15 00:24:02.000000', 'temperatura', 1030.0000, 'ºC'),
	(28999, 112, '2015-01-15 00:24:03.000000', 'temperatura', 407.0000, 'ºC'),
	(29000, 112, '2015-01-15 00:24:04.000000', 'temperatura', 149.0000, 'ºC'),
	(29001, 112, '2015-01-15 00:24:05.000000', 'temperatura', 721.0000, 'ºC'),
	(29002, 112, '2015-01-15 00:24:06.000000', 'temperatura', 762.0000, 'ºC'),
	(29003, 112, '2015-01-15 00:24:07.000000', 'temperatura', 444.0000, 'ºC'),
	(29004, 112, '2015-01-15 00:24:08.000000', 'temperatura', 1137.0000, 'ºC'),
	(29005, 112, '2015-01-15 00:24:09.000000', 'temperatura', 752.0000, 'ºC'),
	(29006, 112, '2015-01-15 00:24:10.000000', 'temperatura', 352.0000, 'ºC'),
	(29007, 112, '2015-01-15 00:24:11.000000', 'temperatura', 702.0000, 'ºC'),
	(29008, 112, '2015-01-15 00:24:12.000000', 'temperatura', 57.0000, 'ºC'),
	(29009, 112, '2015-01-15 00:24:13.000000', 'temperatura', 579.0000, 'ºC'),
	(29010, 112, '2015-01-15 00:24:14.000000', 'temperatura', 326.0000, 'ºC'),
	(29011, 112, '2015-01-15 00:24:15.000000', 'temperatura', 1090.0000, 'ºC'),
	(29012, 112, '2015-01-15 00:24:16.000000', 'temperatura', 874.0000, 'ºC'),
	(29013, 112, '2015-01-15 00:24:17.000000', 'temperatura', 1101.0000, 'ºC'),
	(29014, 112, '2015-01-15 00:24:18.000000', 'temperatura', 484.0000, 'ºC'),
	(29015, 112, '2015-01-15 00:24:19.000000', 'temperatura', 316.0000, 'ºC'),
	(29016, 112, '2015-01-15 00:24:20.000000', 'temperatura', 130.0000, 'ºC'),
	(29017, 112, '2015-01-15 00:24:21.000000', 'temperatura', 903.0000, 'ºC'),
	(29018, 112, '2015-01-15 00:24:22.000000', 'temperatura', 524.0000, 'ºC'),
	(29019, 112, '2015-01-15 00:24:23.000000', 'temperatura', 1111.0000, 'ºC'),
	(29020, 112, '2015-01-15 00:24:24.000000', 'temperatura', 386.0000, 'ºC'),
	(29021, 112, '2015-01-15 00:24:25.000000', 'temperatura', 998.0000, 'ºC'),
	(29022, 112, '2015-01-15 00:24:26.000000', 'temperatura', 229.0000, 'ºC'),
	(29023, 112, '2015-01-15 00:24:27.000000', 'temperatura', 555.0000, 'ºC'),
	(29024, 112, '2015-01-15 00:24:28.000000', 'temperatura', 886.0000, 'ºC'),
	(29025, 112, '2015-01-15 00:24:29.000000', 'temperatura', 368.0000, 'ºC'),
	(29026, 112, '2015-01-15 00:24:30.000000', 'temperatura', 381.0000, 'ºC'),
	(29027, 112, '2015-01-15 00:24:31.000000', 'temperatura', 803.0000, 'ºC'),
	(29028, 112, '2015-01-15 00:24:32.000000', 'temperatura', 473.0000, 'ºC'),
	(29029, 112, '2015-01-15 00:24:33.000000', 'temperatura', 1156.0000, 'ºC'),
	(29030, 112, '2015-01-15 00:24:34.000000', 'temperatura', 762.0000, 'ºC'),
	(29031, 112, '2015-01-15 00:24:35.000000', 'temperatura', 340.0000, 'ºC'),
	(29032, 112, '2015-01-15 00:24:36.000000', 'temperatura', 616.0000, 'ºC'),
	(29033, 112, '2015-01-15 00:24:37.000000', 'temperatura', 861.0000, 'ºC'),
	(29034, 112, '2015-01-15 00:24:38.000000', 'temperatura', 59.0000, 'ºC'),
	(29035, 112, '2015-01-15 00:24:39.000000', 'temperatura', 111.0000, 'ºC'),
	(29036, 112, '2015-01-15 00:24:40.000000', 'temperatura', 380.0000, 'ºC'),
	(29037, 112, '2015-01-15 00:24:41.000000', 'temperatura', 368.0000, 'ºC'),
	(29038, 112, '2015-01-15 00:24:42.000000', 'temperatura', 699.0000, 'ºC'),
	(29039, 112, '2015-01-15 00:24:43.000000', 'temperatura', 1194.0000, 'ºC'),
	(29040, 112, '2015-01-15 00:24:44.000000', 'temperatura', 270.0000, 'ºC'),
	(29041, 112, '2015-01-15 00:24:45.000000', 'temperatura', 171.0000, 'ºC'),
	(29042, 112, '2015-01-15 00:24:46.000000', 'temperatura', 45.0000, 'ºC'),
	(29043, 112, '2015-01-15 00:24:47.000000', 'temperatura', 913.0000, 'ºC'),
	(29044, 112, '2015-01-15 00:24:48.000000', 'temperatura', 830.0000, 'ºC'),
	(29045, 112, '2015-01-15 00:24:49.000000', 'temperatura', 210.0000, 'ºC'),
	(29046, 112, '2015-01-15 00:24:50.000000', 'temperatura', 960.0000, 'ºC'),
	(29047, 112, '2015-01-15 00:24:51.000000', 'temperatura', 574.0000, 'ºC'),
	(29048, 112, '2015-01-15 00:24:52.000000', 'temperatura', 1187.0000, 'ºC'),
	(29049, 112, '2015-01-15 00:24:53.000000', 'temperatura', 615.0000, 'ºC'),
	(29050, 112, '2015-01-15 00:24:54.000000', 'temperatura', 715.0000, 'ºC'),
	(29051, 112, '2015-01-15 00:24:55.000000', 'temperatura', 528.0000, 'ºC'),
	(29052, 112, '2015-01-15 00:24:56.000000', 'temperatura', 497.0000, 'ºC'),
	(29053, 112, '2015-01-15 00:24:57.000000', 'temperatura', 902.0000, 'ºC'),
	(29054, 112, '2015-01-15 00:24:58.000000', 'temperatura', 617.0000, 'ºC'),
	(29055, 112, '2015-01-15 00:24:59.000000', 'temperatura', 381.0000, 'ºC'),
	(29056, 112, '2015-01-15 00:25:00.000000', 'temperatura', 55.0000, 'ºC'),
	(29057, 112, '2015-01-15 00:25:01.000000', 'temperatura', 333.0000, 'ºC'),
	(29058, 112, '2015-01-15 00:25:02.000000', 'temperatura', 301.0000, 'ºC'),
	(29059, 112, '2015-01-15 00:25:03.000000', 'temperatura', 506.0000, 'ºC'),
	(29060, 112, '2015-01-15 00:25:04.000000', 'temperatura', 429.0000, 'ºC'),
	(29061, 112, '2015-01-15 00:25:05.000000', 'temperatura', 628.0000, 'ºC'),
	(29062, 112, '2015-01-15 00:25:06.000000', 'temperatura', 650.0000, 'ºC'),
	(29063, 112, '2015-01-15 00:25:07.000000', 'temperatura', 170.0000, 'ºC'),
	(29064, 112, '2015-01-15 00:25:08.000000', 'temperatura', 99.0000, 'ºC'),
	(29065, 112, '2015-01-15 00:25:09.000000', 'temperatura', 1184.0000, 'ºC'),
	(29066, 112, '2015-01-15 00:25:10.000000', 'temperatura', 823.0000, 'ºC'),
	(29067, 112, '2015-01-15 00:25:11.000000', 'temperatura', 565.0000, 'ºC'),
	(29068, 112, '2015-01-15 00:25:12.000000', 'temperatura', 358.0000, 'ºC'),
	(29069, 112, '2015-01-15 00:25:13.000000', 'temperatura', 96.0000, 'ºC'),
	(29070, 112, '2015-01-15 00:25:14.000000', 'temperatura', 605.0000, 'ºC'),
	(29071, 112, '2015-01-15 00:25:15.000000', 'temperatura', 339.0000, 'ºC'),
	(29072, 112, '2015-01-15 00:25:16.000000', 'temperatura', 1080.0000, 'ºC'),
	(29073, 112, '2015-01-15 00:25:17.000000', 'temperatura', 784.0000, 'ºC'),
	(29074, 112, '2015-01-15 00:25:18.000000', 'temperatura', 682.0000, 'ºC'),
	(29075, 112, '2015-01-15 00:25:19.000000', 'temperatura', 1056.0000, 'ºC'),
	(29076, 112, '2015-01-15 00:25:20.000000', 'temperatura', 834.0000, 'ºC'),
	(29077, 112, '2015-01-15 00:25:21.000000', 'temperatura', 1002.0000, 'ºC'),
	(29078, 112, '2015-01-15 00:25:22.000000', 'temperatura', 107.0000, 'ºC'),
	(29079, 112, '2015-01-15 00:25:23.000000', 'temperatura', 1133.0000, 'ºC'),
	(29080, 112, '2015-01-15 00:25:24.000000', 'temperatura', 542.0000, 'ºC'),
	(29081, 112, '2015-01-15 00:25:25.000000', 'temperatura', 512.0000, 'ºC'),
	(29082, 112, '2015-01-15 00:25:26.000000', 'temperatura', 936.0000, 'ºC'),
	(29083, 112, '2015-01-15 00:25:27.000000', 'temperatura', 745.0000, 'ºC'),
	(29084, 112, '2015-01-15 00:25:28.000000', 'temperatura', 918.0000, 'ºC'),
	(29085, 112, '2015-01-15 00:25:29.000000', 'temperatura', 1154.0000, 'ºC'),
	(29086, 112, '2015-01-15 00:25:30.000000', 'temperatura', 617.0000, 'ºC'),
	(29087, 112, '2015-01-15 00:25:31.000000', 'temperatura', 821.0000, 'ºC'),
	(29088, 112, '2015-01-15 00:25:32.000000', 'temperatura', 1058.0000, 'ºC'),
	(29089, 112, '2015-01-15 00:25:33.000000', 'temperatura', 425.0000, 'ºC'),
	(29090, 112, '2015-01-15 00:25:34.000000', 'temperatura', 151.0000, 'ºC'),
	(29091, 112, '2015-01-15 00:25:35.000000', 'temperatura', 683.0000, 'ºC'),
	(29092, 112, '2015-01-15 00:25:36.000000', 'temperatura', 562.0000, 'ºC'),
	(29093, 112, '2015-01-15 00:25:37.000000', 'temperatura', 761.0000, 'ºC'),
	(29094, 112, '2015-01-15 00:25:38.000000', 'temperatura', 921.0000, 'ºC'),
	(29095, 112, '2015-01-15 00:25:39.000000', 'temperatura', 1120.0000, 'ºC'),
	(29096, 112, '2015-01-15 00:25:40.000000', 'temperatura', 437.0000, 'ºC'),
	(29097, 112, '2015-01-15 00:25:41.000000', 'temperatura', 27.0000, 'ºC'),
	(29098, 112, '2015-01-15 00:25:42.000000', 'temperatura', 23.0000, 'ºC'),
	(29099, 112, '2015-01-15 00:25:43.000000', 'temperatura', 36.0000, 'ºC'),
	(29100, 112, '2015-01-15 00:25:44.000000', 'temperatura', 112.0000, 'ºC'),
	(29101, 112, '2015-01-15 00:25:45.000000', 'temperatura', 454.0000, 'ºC'),
	(29102, 112, '2015-01-15 00:25:46.000000', 'temperatura', 731.0000, 'ºC'),
	(29103, 112, '2015-01-15 00:25:47.000000', 'temperatura', 1096.0000, 'ºC'),
	(29104, 112, '2015-01-15 00:25:48.000000', 'temperatura', 889.0000, 'ºC'),
	(29105, 112, '2015-01-15 00:25:49.000000', 'temperatura', 1154.0000, 'ºC'),
	(29106, 112, '2015-01-15 00:25:50.000000', 'temperatura', 706.0000, 'ºC'),
	(29107, 112, '2015-01-15 00:25:51.000000', 'temperatura', 66.0000, 'ºC'),
	(29108, 112, '2015-01-15 00:25:52.000000', 'temperatura', 616.0000, 'ºC'),
	(29109, 112, '2015-01-15 00:25:53.000000', 'temperatura', 480.0000, 'ºC'),
	(29110, 112, '2015-01-15 00:25:54.000000', 'temperatura', 553.0000, 'ºC'),
	(29111, 112, '2015-01-15 00:25:55.000000', 'temperatura', 124.0000, 'ºC'),
	(29112, 112, '2015-01-15 00:25:56.000000', 'temperatura', 163.0000, 'ºC'),
	(29113, 112, '2015-01-15 00:25:57.000000', 'temperatura', 444.0000, 'ºC'),
	(29114, 112, '2015-01-15 00:25:58.000000', 'temperatura', 533.0000, 'ºC'),
	(29115, 112, '2015-01-15 00:25:59.000000', 'temperatura', 130.0000, 'ºC'),
	(29116, 112, '2015-01-15 00:26:00.000000', 'temperatura', 255.0000, 'ºC'),
	(29117, 112, '2015-01-15 00:26:01.000000', 'temperatura', 883.0000, 'ºC'),
	(29118, 112, '2015-01-15 00:26:02.000000', 'temperatura', 51.0000, 'ºC'),
	(29119, 112, '2015-01-15 00:26:03.000000', 'temperatura', 5.0000, 'ºC'),
	(29120, 112, '2015-01-15 00:26:04.000000', 'temperatura', 1074.0000, 'ºC'),
	(29121, 112, '2015-01-15 00:26:05.000000', 'temperatura', 556.0000, 'ºC'),
	(29122, 112, '2015-01-15 00:26:06.000000', 'temperatura', 758.0000, 'ºC'),
	(29123, 112, '2015-01-15 00:26:07.000000', 'temperatura', 925.0000, 'ºC'),
	(29124, 112, '2015-01-15 00:26:08.000000', 'temperatura', 1148.0000, 'ºC'),
	(29125, 112, '2015-01-15 00:26:09.000000', 'temperatura', 567.0000, 'ºC'),
	(29126, 112, '2015-01-15 00:26:10.000000', 'temperatura', 593.0000, 'ºC'),
	(29127, 112, '2015-01-15 00:26:11.000000', 'temperatura', 63.0000, 'ºC'),
	(29128, 112, '2015-01-15 00:26:12.000000', 'temperatura', 935.0000, 'ºC'),
	(29129, 112, '2015-01-15 00:26:13.000000', 'temperatura', 886.0000, 'ºC'),
	(29130, 112, '2015-01-15 00:26:14.000000', 'temperatura', 428.0000, 'ºC'),
	(29131, 112, '2015-01-15 00:26:15.000000', 'temperatura', 681.0000, 'ºC'),
	(29132, 112, '2015-01-15 00:26:16.000000', 'temperatura', 923.0000, 'ºC'),
	(29133, 112, '2015-01-15 00:26:17.000000', 'temperatura', 173.0000, 'ºC'),
	(29134, 112, '2015-01-15 00:26:18.000000', 'temperatura', 495.0000, 'ºC'),
	(29135, 112, '2015-01-15 00:26:19.000000', 'temperatura', 759.0000, 'ºC'),
	(29136, 112, '2015-01-15 00:26:20.000000', 'temperatura', 1108.0000, 'ºC'),
	(29137, 112, '2015-01-15 00:26:21.000000', 'temperatura', 864.0000, 'ºC'),
	(29138, 112, '2015-01-15 00:26:22.000000', 'temperatura', 999.0000, 'ºC'),
	(29139, 112, '2015-01-15 00:26:23.000000', 'temperatura', 0.0000, 'ºC'),
	(29140, 112, '2015-01-15 00:26:24.000000', 'temperatura', 604.0000, 'ºC'),
	(29141, 112, '2015-01-15 00:26:25.000000', 'temperatura', 619.0000, 'ºC'),
	(29142, 112, '2015-01-15 00:26:26.000000', 'temperatura', 87.0000, 'ºC'),
	(29143, 112, '2015-01-15 00:26:27.000000', 'temperatura', 977.0000, 'ºC'),
	(29144, 112, '2015-01-15 00:26:28.000000', 'temperatura', 1025.0000, 'ºC'),
	(29145, 112, '2015-01-15 00:26:29.000000', 'temperatura', 995.0000, 'ºC'),
	(29146, 112, '2015-01-15 00:26:30.000000', 'temperatura', 698.0000, 'ºC'),
	(29147, 112, '2015-01-15 00:26:31.000000', 'temperatura', 506.0000, 'ºC'),
	(29148, 112, '2015-01-15 00:26:32.000000', 'temperatura', 438.0000, 'ºC'),
	(29149, 112, '2015-01-15 00:26:33.000000', 'temperatura', 671.0000, 'ºC'),
	(29150, 112, '2015-01-15 00:26:34.000000', 'temperatura', 842.0000, 'ºC'),
	(29151, 112, '2015-01-15 00:26:35.000000', 'temperatura', 997.0000, 'ºC'),
	(29152, 112, '2015-01-15 00:26:36.000000', 'temperatura', 60.0000, 'ºC'),
	(29153, 112, '2015-01-15 00:26:37.000000', 'temperatura', 907.0000, 'ºC'),
	(29154, 112, '2015-01-15 00:26:38.000000', 'temperatura', 759.0000, 'ºC'),
	(29155, 112, '2015-01-15 00:26:39.000000', 'temperatura', 1072.0000, 'ºC'),
	(29156, 112, '2015-01-15 00:26:40.000000', 'temperatura', 686.0000, 'ºC'),
	(29157, 112, '2015-01-15 00:26:41.000000', 'temperatura', 214.0000, 'ºC'),
	(29158, 112, '2015-01-15 00:26:42.000000', 'temperatura', 214.0000, 'ºC'),
	(29159, 112, '2015-01-15 00:26:43.000000', 'temperatura', 427.0000, 'ºC'),
	(29160, 112, '2015-01-15 00:26:44.000000', 'temperatura', 295.0000, 'ºC'),
	(29161, 112, '2015-01-15 00:26:45.000000', 'temperatura', 192.0000, 'ºC'),
	(29162, 112, '2015-01-15 00:26:46.000000', 'temperatura', 78.0000, 'ºC'),
	(29163, 112, '2015-01-15 00:26:47.000000', 'temperatura', 1013.0000, 'ºC'),
	(29164, 112, '2015-01-15 00:26:48.000000', 'temperatura', 34.0000, 'ºC'),
	(29165, 112, '2015-01-15 00:26:49.000000', 'temperatura', 729.0000, 'ºC'),
	(29166, 112, '2015-01-15 00:26:50.000000', 'temperatura', 1143.0000, 'ºC'),
	(29167, 112, '2015-01-15 00:26:51.000000', 'temperatura', 1128.0000, 'ºC'),
	(29168, 112, '2015-01-15 00:26:52.000000', 'temperatura', 1014.0000, 'ºC'),
	(29169, 112, '2015-01-15 00:26:53.000000', 'temperatura', 484.0000, 'ºC'),
	(29170, 112, '2015-01-15 00:26:54.000000', 'temperatura', 578.0000, 'ºC'),
	(29171, 112, '2015-01-15 00:26:55.000000', 'temperatura', 238.0000, 'ºC'),
	(29172, 112, '2015-01-15 00:26:56.000000', 'temperatura', 656.0000, 'ºC'),
	(29173, 112, '2015-01-15 00:26:57.000000', 'temperatura', 169.0000, 'ºC'),
	(29174, 112, '2015-01-15 00:26:58.000000', 'temperatura', 78.0000, 'ºC'),
	(29175, 112, '2015-01-15 00:26:59.000000', 'temperatura', 1082.0000, 'ºC'),
	(29176, 112, '2015-01-15 00:27:00.000000', 'temperatura', 377.0000, 'ºC'),
	(29177, 112, '2015-01-15 00:27:01.000000', 'temperatura', 1041.0000, 'ºC'),
	(29178, 112, '2015-01-15 00:27:02.000000', 'temperatura', 473.0000, 'ºC'),
	(29179, 112, '2015-01-15 00:27:03.000000', 'temperatura', 442.0000, 'ºC'),
	(29180, 112, '2015-01-15 00:27:04.000000', 'temperatura', 790.0000, 'ºC'),
	(29181, 112, '2015-01-15 00:27:05.000000', 'temperatura', 226.0000, 'ºC'),
	(29182, 112, '2015-01-15 00:27:06.000000', 'temperatura', 1160.0000, 'ºC'),
	(29183, 112, '2015-01-15 00:27:07.000000', 'temperatura', 322.0000, 'ºC'),
	(29184, 112, '2015-01-15 00:27:08.000000', 'temperatura', 531.0000, 'ºC'),
	(29185, 112, '2015-01-15 00:27:09.000000', 'temperatura', 491.0000, 'ºC'),
	(29186, 112, '2015-01-15 00:27:10.000000', 'temperatura', 860.0000, 'ºC'),
	(29187, 112, '2015-01-15 00:27:11.000000', 'temperatura', 429.0000, 'ºC'),
	(29188, 112, '2015-01-15 00:27:12.000000', 'temperatura', 765.0000, 'ºC'),
	(29189, 112, '2015-01-15 00:27:13.000000', 'temperatura', 140.0000, 'ºC'),
	(29190, 112, '2015-01-15 00:27:14.000000', 'temperatura', 806.0000, 'ºC'),
	(29191, 112, '2015-01-15 00:27:15.000000', 'temperatura', 10.0000, 'ºC'),
	(29192, 112, '2015-01-15 00:27:16.000000', 'temperatura', 33.0000, 'ºC'),
	(29193, 112, '2015-01-15 00:27:17.000000', 'temperatura', 134.0000, 'ºC'),
	(29194, 112, '2015-01-15 00:27:18.000000', 'temperatura', 571.0000, 'ºC'),
	(29195, 112, '2015-01-15 00:27:19.000000', 'temperatura', 54.0000, 'ºC'),
	(29196, 112, '2015-01-15 00:27:20.000000', 'temperatura', 957.0000, 'ºC'),
	(29197, 112, '2015-01-15 00:27:21.000000', 'temperatura', 1024.0000, 'ºC'),
	(29198, 112, '2015-01-15 00:27:22.000000', 'temperatura', 1048.0000, 'ºC'),
	(29199, 112, '2015-01-15 00:27:23.000000', 'temperatura', 970.0000, 'ºC'),
	(29200, 112, '2015-01-15 00:27:24.000000', 'temperatura', 508.0000, 'ºC'),
	(29201, 112, '2015-01-15 00:27:25.000000', 'temperatura', 829.0000, 'ºC'),
	(29202, 112, '2015-01-15 00:27:26.000000', 'temperatura', 221.0000, 'ºC'),
	(29203, 112, '2015-01-15 00:27:27.000000', 'temperatura', 1020.0000, 'ºC'),
	(29204, 112, '2015-01-15 00:27:28.000000', 'temperatura', 836.0000, 'ºC'),
	(29205, 112, '2015-01-15 00:27:29.000000', 'temperatura', 1122.0000, 'ºC'),
	(29206, 112, '2015-01-15 00:27:30.000000', 'temperatura', 704.0000, 'ºC'),
	(29207, 112, '2015-01-15 00:27:31.000000', 'temperatura', 152.0000, 'ºC'),
	(29208, 112, '2015-01-15 00:27:32.000000', 'temperatura', 1048.0000, 'ºC'),
	(29209, 112, '2015-01-15 00:27:33.000000', 'temperatura', 1184.0000, 'ºC'),
	(29210, 112, '2015-01-15 00:27:34.000000', 'temperatura', 379.0000, 'ºC'),
	(29211, 112, '2015-01-15 00:27:35.000000', 'temperatura', 744.0000, 'ºC'),
	(29212, 112, '2015-01-15 00:27:36.000000', 'temperatura', 184.0000, 'ºC'),
	(29213, 112, '2015-01-15 00:27:37.000000', 'temperatura', 1088.0000, 'ºC'),
	(29214, 112, '2015-01-15 00:27:38.000000', 'temperatura', 90.0000, 'ºC'),
	(29215, 112, '2015-01-15 00:27:39.000000', 'temperatura', 784.0000, 'ºC'),
	(29216, 112, '2015-01-15 00:27:40.000000', 'temperatura', 52.0000, 'ºC'),
	(29217, 112, '2015-01-15 00:27:41.000000', 'temperatura', 310.0000, 'ºC'),
	(29218, 112, '2015-01-15 00:27:42.000000', 'temperatura', 193.0000, 'ºC'),
	(29219, 112, '2015-01-15 00:27:43.000000', 'temperatura', 37.0000, 'ºC'),
	(29220, 112, '2015-01-15 00:27:44.000000', 'temperatura', 804.0000, 'ºC'),
	(29221, 112, '2015-01-15 00:27:45.000000', 'temperatura', 310.0000, 'ºC'),
	(29222, 112, '2015-01-15 00:27:46.000000', 'temperatura', 338.0000, 'ºC'),
	(29223, 112, '2015-01-15 00:27:47.000000', 'temperatura', 762.0000, 'ºC'),
	(29224, 112, '2015-01-15 00:27:48.000000', 'temperatura', 398.0000, 'ºC'),
	(29225, 112, '2015-01-15 00:27:49.000000', 'temperatura', 902.0000, 'ºC'),
	(29226, 112, '2015-01-15 00:27:50.000000', 'temperatura', 918.0000, 'ºC'),
	(29227, 112, '2015-01-15 00:27:51.000000', 'temperatura', 683.0000, 'ºC'),
	(29228, 112, '2015-01-15 00:27:52.000000', 'temperatura', 660.0000, 'ºC'),
	(29229, 112, '2015-01-15 00:27:53.000000', 'temperatura', 53.0000, 'ºC'),
	(29230, 112, '2015-01-15 00:27:54.000000', 'temperatura', 686.0000, 'ºC'),
	(29231, 112, '2015-01-15 00:27:55.000000', 'temperatura', 871.0000, 'ºC'),
	(29232, 112, '2015-01-15 00:27:56.000000', 'temperatura', 1096.0000, 'ºC'),
	(29233, 112, '2015-01-15 00:27:57.000000', 'temperatura', 468.0000, 'ºC'),
	(29234, 112, '2015-01-15 00:27:58.000000', 'temperatura', 251.0000, 'ºC'),
	(29235, 112, '2015-01-15 00:27:59.000000', 'temperatura', 1054.0000, 'ºC'),
	(29236, 112, '2015-01-15 00:28:00.000000', 'temperatura', 918.0000, 'ºC'),
	(29237, 112, '2015-01-15 00:28:01.000000', 'temperatura', 228.0000, 'ºC'),
	(29238, 112, '2015-01-15 00:28:02.000000', 'temperatura', 787.0000, 'ºC'),
	(29239, 112, '2015-01-15 00:28:03.000000', 'temperatura', 852.0000, 'ºC'),
	(29240, 112, '2015-01-15 00:28:04.000000', 'temperatura', 700.0000, 'ºC'),
	(29241, 112, '2015-01-15 00:28:05.000000', 'temperatura', 944.0000, 'ºC'),
	(29242, 112, '2015-01-15 00:28:06.000000', 'temperatura', 221.0000, 'ºC'),
	(29243, 112, '2015-01-15 00:28:07.000000', 'temperatura', 675.0000, 'ºC'),
	(29244, 112, '2015-01-15 00:28:08.000000', 'temperatura', 309.0000, 'ºC'),
	(29245, 112, '2015-01-15 00:28:09.000000', 'temperatura', 722.0000, 'ºC'),
	(29246, 112, '2015-01-15 00:28:10.000000', 'temperatura', 285.0000, 'ºC'),
	(29247, 112, '2015-01-15 00:28:11.000000', 'temperatura', 458.0000, 'ºC'),
	(29248, 112, '2015-01-15 00:28:12.000000', 'temperatura', 237.0000, 'ºC'),
	(29249, 112, '2015-01-15 00:28:13.000000', 'temperatura', 1011.0000, 'ºC'),
	(29250, 112, '2015-01-15 00:28:14.000000', 'temperatura', 745.0000, 'ºC'),
	(29251, 112, '2015-01-15 00:28:15.000000', 'temperatura', 692.0000, 'ºC'),
	(29252, 112, '2015-01-15 00:28:16.000000', 'temperatura', 26.0000, 'ºC'),
	(29253, 112, '2015-01-15 00:28:17.000000', 'temperatura', 453.0000, 'ºC'),
	(29254, 112, '2015-01-15 00:28:18.000000', 'temperatura', 986.0000, 'ºC'),
	(29255, 112, '2015-01-15 00:28:19.000000', 'temperatura', 1175.0000, 'ºC'),
	(29256, 112, '2015-01-15 00:28:20.000000', 'temperatura', 516.0000, 'ºC'),
	(29257, 112, '2015-01-15 00:28:21.000000', 'temperatura', 257.0000, 'ºC'),
	(29258, 112, '2015-01-15 00:28:22.000000', 'temperatura', 935.0000, 'ºC'),
	(29259, 112, '2015-01-15 00:28:23.000000', 'temperatura', 307.0000, 'ºC'),
	(29260, 112, '2015-01-15 00:28:24.000000', 'temperatura', 1130.0000, 'ºC'),
	(29261, 112, '2015-01-15 00:28:25.000000', 'temperatura', 1129.0000, 'ºC'),
	(29262, 112, '2015-01-15 00:28:26.000000', 'temperatura', 1058.0000, 'ºC'),
	(29263, 112, '2015-01-15 00:28:27.000000', 'temperatura', 700.0000, 'ºC'),
	(29264, 112, '2015-01-15 00:28:28.000000', 'temperatura', 328.0000, 'ºC'),
	(29265, 112, '2015-01-15 00:28:29.000000', 'temperatura', 742.0000, 'ºC'),
	(29266, 112, '2015-01-15 00:28:30.000000', 'temperatura', 325.0000, 'ºC'),
	(29267, 112, '2015-01-15 00:28:31.000000', 'temperatura', 600.0000, 'ºC'),
	(29268, 112, '2015-01-15 00:28:32.000000', 'temperatura', 825.0000, 'ºC'),
	(29269, 112, '2015-01-15 00:28:33.000000', 'temperatura', 1124.0000, 'ºC'),
	(29270, 112, '2015-01-15 00:28:34.000000', 'temperatura', 747.0000, 'ºC'),
	(29271, 112, '2015-01-15 00:28:35.000000', 'temperatura', 362.0000, 'ºC'),
	(29272, 112, '2015-01-15 00:28:36.000000', 'temperatura', 769.0000, 'ºC'),
	(29273, 112, '2015-01-15 00:28:37.000000', 'temperatura', 359.0000, 'ºC'),
	(29274, 112, '2015-01-15 00:28:38.000000', 'temperatura', 690.0000, 'ºC'),
	(29275, 112, '2015-01-15 00:28:39.000000', 'temperatura', 1175.0000, 'ºC'),
	(29276, 112, '2015-01-15 00:28:40.000000', 'temperatura', 202.0000, 'ºC'),
	(29277, 112, '2015-01-15 00:28:41.000000', 'temperatura', 1088.0000, 'ºC'),
	(29278, 112, '2015-01-15 00:28:42.000000', 'temperatura', 33.0000, 'ºC'),
	(29279, 112, '2015-01-15 00:28:43.000000', 'temperatura', 501.0000, 'ºC'),
	(29280, 112, '2015-01-15 00:28:44.000000', 'temperatura', 6.0000, 'ºC'),
	(29281, 112, '2015-01-15 00:28:45.000000', 'temperatura', 928.0000, 'ºC'),
	(29282, 112, '2015-01-15 00:28:46.000000', 'temperatura', 1024.0000, 'ºC'),
	(29283, 112, '2015-01-15 00:28:47.000000', 'temperatura', 1137.0000, 'ºC'),
	(29284, 112, '2015-01-15 00:28:48.000000', 'temperatura', 213.0000, 'ºC'),
	(29285, 112, '2015-01-15 00:28:49.000000', 'temperatura', 56.0000, 'ºC'),
	(29286, 112, '2015-01-15 00:28:50.000000', 'temperatura', 839.0000, 'ºC'),
	(29287, 112, '2015-01-15 00:28:51.000000', 'temperatura', 427.0000, 'ºC'),
	(29288, 112, '2015-01-15 00:28:52.000000', 'temperatura', 819.0000, 'ºC'),
	(29289, 112, '2015-01-15 00:28:53.000000', 'temperatura', 417.0000, 'ºC'),
	(29290, 112, '2015-01-15 00:28:54.000000', 'temperatura', 825.0000, 'ºC'),
	(29291, 112, '2015-01-15 00:28:55.000000', 'temperatura', 477.0000, 'ºC'),
	(29292, 112, '2015-01-15 00:28:56.000000', 'temperatura', 1111.0000, 'ºC'),
	(29293, 112, '2015-01-15 00:28:57.000000', 'temperatura', 521.0000, 'ºC'),
	(29294, 112, '2015-01-15 00:28:58.000000', 'temperatura', 476.0000, 'ºC'),
	(29295, 112, '2015-01-15 00:28:59.000000', 'temperatura', 818.0000, 'ºC'),
	(29296, 112, '2015-01-15 00:29:00.000000', 'temperatura', 262.0000, 'ºC'),
	(29297, 112, '2015-01-15 00:29:01.000000', 'temperatura', 54.0000, 'ºC'),
	(29298, 112, '2015-01-15 00:29:02.000000', 'temperatura', 688.0000, 'ºC'),
	(29299, 112, '2015-01-15 00:29:03.000000', 'temperatura', 876.0000, 'ºC'),
	(29300, 112, '2015-01-15 00:29:04.000000', 'temperatura', 1118.0000, 'ºC'),
	(29301, 112, '2015-01-15 00:29:05.000000', 'temperatura', 561.0000, 'ºC'),
	(29302, 112, '2015-01-15 00:29:06.000000', 'temperatura', 653.0000, 'ºC'),
	(29303, 112, '2015-01-15 00:29:07.000000', 'temperatura', 382.0000, 'ºC'),
	(29304, 112, '2015-01-15 00:29:08.000000', 'temperatura', 1153.0000, 'ºC'),
	(29305, 112, '2015-01-15 00:29:09.000000', 'temperatura', 1019.0000, 'ºC'),
	(29306, 112, '2015-01-15 00:29:10.000000', 'temperatura', 436.0000, 'ºC'),
	(29307, 112, '2015-01-15 00:29:11.000000', 'temperatura', 325.0000, 'ºC'),
	(29308, 112, '2015-01-15 00:29:12.000000', 'temperatura', 315.0000, 'ºC'),
	(29309, 112, '2015-01-15 00:29:13.000000', 'temperatura', 601.0000, 'ºC'),
	(29310, 112, '2015-01-15 00:29:14.000000', 'temperatura', 861.0000, 'ºC'),
	(29311, 112, '2015-01-15 00:29:15.000000', 'temperatura', 102.0000, 'ºC'),
	(29312, 112, '2015-01-15 00:29:16.000000', 'temperatura', 327.0000, 'ºC'),
	(29313, 112, '2015-01-15 00:29:17.000000', 'temperatura', 129.0000, 'ºC'),
	(29314, 112, '2015-01-15 00:29:18.000000', 'temperatura', 865.0000, 'ºC'),
	(29315, 112, '2015-01-15 00:29:19.000000', 'temperatura', 338.0000, 'ºC'),
	(29316, 112, '2015-01-15 00:29:20.000000', 'temperatura', 294.0000, 'ºC'),
	(29317, 112, '2015-01-15 00:29:21.000000', 'temperatura', 457.0000, 'ºC'),
	(29318, 112, '2015-01-15 00:29:22.000000', 'temperatura', 205.0000, 'ºC'),
	(29319, 112, '2015-01-15 00:29:23.000000', 'temperatura', 855.0000, 'ºC'),
	(29320, 112, '2015-01-15 00:29:24.000000', 'temperatura', 59.0000, 'ºC'),
	(29321, 112, '2015-01-15 00:29:25.000000', 'temperatura', 133.0000, 'ºC'),
	(29322, 112, '2015-01-15 00:29:26.000000', 'temperatura', 487.0000, 'ºC'),
	(29323, 112, '2015-01-15 00:29:27.000000', 'temperatura', 838.0000, 'ºC'),
	(29324, 112, '2015-01-15 00:29:28.000000', 'temperatura', 329.0000, 'ºC'),
	(29325, 112, '2015-01-15 00:29:29.000000', 'temperatura', 332.0000, 'ºC'),
	(29326, 112, '2015-01-15 00:29:30.000000', 'temperatura', 675.0000, 'ºC'),
	(29327, 112, '2015-01-15 00:29:31.000000', 'temperatura', 1178.0000, 'ºC'),
	(29328, 112, '2015-01-15 00:29:32.000000', 'temperatura', 266.0000, 'ºC'),
	(29329, 112, '2015-01-15 00:29:33.000000', 'temperatura', 198.0000, 'ºC'),
	(29330, 112, '2015-01-15 00:29:34.000000', 'temperatura', 192.0000, 'ºC'),
	(29331, 112, '2015-01-15 00:29:35.000000', 'temperatura', 366.0000, 'ºC'),
	(29332, 112, '2015-01-15 00:29:36.000000', 'temperatura', 56.0000, 'ºC'),
	(29333, 112, '2015-01-15 00:29:37.000000', 'temperatura', 380.0000, 'ºC'),
	(29334, 112, '2015-01-15 00:29:38.000000', 'temperatura', 532.0000, 'ºC'),
	(29335, 112, '2015-01-15 00:29:39.000000', 'temperatura', 321.0000, 'ºC'),
	(29336, 112, '2015-01-15 00:29:40.000000', 'temperatura', 12.0000, 'ºC'),
	(29337, 112, '2015-01-15 00:29:41.000000', 'temperatura', 295.0000, 'ºC'),
	(29338, 112, '2015-01-15 00:29:42.000000', 'temperatura', 239.0000, 'ºC'),
	(29339, 112, '2015-01-15 00:29:43.000000', 'temperatura', 312.0000, 'ºC'),
	(29340, 112, '2015-01-15 00:29:44.000000', 'temperatura', 842.0000, 'ºC'),
	(29341, 112, '2015-01-15 00:29:45.000000', 'temperatura', 875.0000, 'ºC'),
	(29342, 112, '2015-01-15 00:29:46.000000', 'temperatura', 652.0000, 'ºC'),
	(29343, 112, '2015-01-15 00:29:47.000000', 'temperatura', 632.0000, 'ºC'),
	(29344, 112, '2015-01-15 00:29:48.000000', 'temperatura', 5.0000, 'ºC'),
	(29345, 112, '2015-01-15 00:29:49.000000', 'temperatura', 532.0000, 'ºC'),
	(29346, 112, '2015-01-15 00:29:50.000000', 'temperatura', 243.0000, 'ºC'),
	(29347, 112, '2015-01-15 00:29:51.000000', 'temperatura', 821.0000, 'ºC'),
	(29348, 112, '2015-01-15 00:29:52.000000', 'temperatura', 976.0000, 'ºC'),
	(29349, 112, '2015-01-15 00:29:53.000000', 'temperatura', 18.0000, 'ºC'),
	(29350, 112, '2015-01-15 00:29:54.000000', 'temperatura', 764.0000, 'ºC'),
	(29351, 112, '2015-01-15 00:29:55.000000', 'temperatura', 164.0000, 'ºC'),
	(29352, 112, '2015-01-15 00:29:56.000000', 'temperatura', 930.0000, 'ºC'),
	(29353, 112, '2015-01-15 00:29:57.000000', 'temperatura', 560.0000, 'ºC'),
	(29354, 112, '2015-01-15 00:29:58.000000', 'temperatura', 10.0000, 'ºC'),
	(29355, 112, '2015-01-15 00:29:59.000000', 'temperatura', 770.0000, 'ºC'),
	(29356, 112, '2015-01-15 00:30:00.000000', 'temperatura', 220.0000, 'ºC'),
	(29357, 112, '2015-01-15 00:30:01.000000', 'temperatura', 1189.0000, 'ºC'),
	(29358, 112, '2015-01-15 00:30:02.000000', 'temperatura', 486.0000, 'ºC'),
	(29359, 112, '2015-01-15 00:30:03.000000', 'temperatura', 63.0000, 'ºC'),
	(29360, 112, '2015-01-15 00:30:04.000000', 'temperatura', 58.0000, 'ºC'),
	(29361, 112, '2015-01-15 00:30:05.000000', 'temperatura', 100.0000, 'ºC'),
	(29362, 112, '2015-01-15 00:30:06.000000', 'temperatura', 326.0000, 'ºC'),
	(29363, 112, '2015-01-15 00:30:07.000000', 'temperatura', 131.0000, 'ºC'),
	(29364, 112, '2015-01-15 00:30:08.000000', 'temperatura', 876.0000, 'ºC'),
	(29365, 112, '2015-01-15 00:30:09.000000', 'temperatura', 390.0000, 'ºC'),
	(29366, 112, '2015-01-15 00:30:10.000000', 'temperatura', 523.0000, 'ºC'),
	(29367, 112, '2015-01-15 00:30:11.000000', 'temperatura', 247.0000, 'ºC'),
	(29368, 112, '2015-01-15 00:30:12.000000', 'temperatura', 864.0000, 'ºC'),
	(29369, 112, '2015-01-15 00:30:13.000000', 'temperatura', 1178.0000, 'ºC'),
	(29370, 112, '2015-01-15 00:30:14.000000', 'temperatura', 901.0000, 'ºC'),
	(29371, 112, '2015-01-15 00:30:15.000000', 'temperatura', 970.0000, 'ºC'),
	(29372, 112, '2015-01-15 00:30:16.000000', 'temperatura', 948.0000, 'ºC'),
	(29373, 112, '2015-01-15 00:30:17.000000', 'temperatura', 630.0000, 'ºC'),
	(29374, 112, '2015-01-15 00:30:18.000000', 'temperatura', 306.0000, 'ºC'),
	(29375, 112, '2015-01-15 00:30:19.000000', 'temperatura', 843.0000, 'ºC'),
	(29376, 112, '2015-01-15 00:30:20.000000', 'temperatura', 896.0000, 'ºC'),
	(29377, 112, '2015-01-15 00:30:21.000000', 'temperatura', 751.0000, 'ºC'),
	(29378, 112, '2015-01-15 00:30:22.000000', 'temperatura', 1067.0000, 'ºC'),
	(29379, 112, '2015-01-15 00:30:23.000000', 'temperatura', 682.0000, 'ºC'),
	(29380, 112, '2015-01-15 00:30:24.000000', 'temperatura', 209.0000, 'ºC'),
	(29381, 112, '2015-01-15 00:30:25.000000', 'temperatura', 201.0000, 'ºC'),
	(29382, 112, '2015-01-15 00:30:26.000000', 'temperatura', 380.0000, 'ºC'),
	(29383, 112, '2015-01-15 00:30:27.000000', 'temperatura', 95.0000, 'ºC'),
	(29384, 112, '2015-01-15 00:30:28.000000', 'temperatura', 537.0000, 'ºC'),
	(29385, 112, '2015-01-15 00:30:29.000000', 'temperatura', 1199.0000, 'ºC'),
	(29386, 112, '2015-01-15 00:30:30.000000', 'temperatura', 785.0000, 'ºC'),
	(29387, 112, '2015-01-15 00:30:31.000000', 'temperatura', 329.0000, 'ºC'),
	(29388, 112, '2015-01-15 00:30:32.000000', 'temperatura', 492.0000, 'ºC'),
	(29389, 112, '2015-01-15 00:30:33.000000', 'temperatura', 273.0000, 'ºC'),
	(29390, 112, '2015-01-15 00:30:34.000000', 'temperatura', 1090.0000, 'ºC'),
	(29391, 112, '2015-01-15 00:30:35.000000', 'temperatura', 1029.0000, 'ºC'),
	(29392, 112, '2015-01-15 00:30:36.000000', 'temperatura', 679.0000, 'ºC'),
	(29393, 112, '2015-01-15 00:30:37.000000', 'temperatura', 306.0000, 'ºC'),
	(29394, 112, '2015-01-15 00:30:38.000000', 'temperatura', 693.0000, 'ºC'),
	(29395, 112, '2015-01-15 00:30:39.000000', 'temperatura', 148.0000, 'ºC'),
	(29396, 112, '2015-01-15 00:30:40.000000', 'temperatura', 1061.0000, 'ºC'),
	(29397, 112, '2015-01-15 00:30:41.000000', 'temperatura', 63.0000, 'ºC'),
	(29398, 112, '2015-01-15 00:30:42.000000', 'temperatura', 732.0000, 'ºC'),
	(29399, 112, '2015-01-15 00:30:43.000000', 'temperatura', 1073.0000, 'ºC'),
	(29400, 112, '2015-01-15 00:30:44.000000', 'temperatura', 770.0000, 'ºC'),
	(29401, 112, '2015-01-15 00:30:45.000000', 'temperatura', 632.0000, 'ºC'),
	(29402, 112, '2015-01-15 00:30:46.000000', 'temperatura', 851.0000, 'ºC'),
	(29403, 112, '2015-01-15 00:30:47.000000', 'temperatura', 1159.0000, 'ºC'),
	(29404, 112, '2015-01-15 00:30:48.000000', 'temperatura', 844.0000, 'ºC'),
	(29405, 112, '2015-01-15 00:30:49.000000', 'temperatura', 741.0000, 'ºC'),
	(29406, 112, '2015-01-15 00:30:50.000000', 'temperatura', 1173.0000, 'ºC'),
	(29407, 112, '2015-01-15 00:30:51.000000', 'temperatura', 46.0000, 'ºC'),
	(29408, 112, '2015-01-15 00:30:52.000000', 'temperatura', 308.0000, 'ºC'),
	(29409, 112, '2015-01-15 00:30:53.000000', 'temperatura', 202.0000, 'ºC'),
	(29410, 112, '2015-01-15 00:30:54.000000', 'temperatura', 87.0000, 'ºC'),
	(29411, 112, '2015-01-15 00:30:55.000000', 'temperatura', 1029.0000, 'ºC'),
	(29412, 112, '2015-01-15 00:30:56.000000', 'temperatura', 84.0000, 'ºC'),
	(29413, 112, '2015-01-15 00:30:57.000000', 'temperatura', 933.0000, 'ºC'),
	(29414, 112, '2015-01-15 00:30:58.000000', 'temperatura', 816.0000, 'ºC'),
	(29415, 112, '2015-01-15 00:30:59.000000', 'temperatura', 79.0000, 'ºC'),
	(29416, 112, '2015-01-15 00:31:00.000000', 'temperatura', 349.0000, 'ºC'),
	(29417, 112, '2015-01-15 00:31:01.000000', 'temperatura', 306.0000, 'ºC'),
	(29418, 112, '2015-01-15 00:31:02.000000', 'temperatura', 487.0000, 'ºC'),
	(29419, 112, '2015-01-15 00:31:03.000000', 'temperatura', 315.0000, 'ºC'),
	(29420, 112, '2015-01-15 00:31:04.000000', 'temperatura', 114.0000, 'ºC'),
	(29421, 112, '2015-01-15 00:31:05.000000', 'temperatura', 825.0000, 'ºC'),
	(29422, 112, '2015-01-15 00:31:06.000000', 'temperatura', 186.0000, 'ºC'),
	(29423, 112, '2015-01-15 00:31:07.000000', 'temperatura', 856.0000, 'ºC'),
	(29424, 112, '2015-01-15 00:31:08.000000', 'temperatura', 123.0000, 'ºC'),
	(29425, 112, '2015-01-15 00:31:09.000000', 'temperatura', 448.0000, 'ºC'),
	(29426, 112, '2015-01-15 00:31:10.000000', 'temperatura', 672.0000, 'ºC'),
	(29427, 112, '2015-01-15 00:31:11.000000', 'temperatura', 813.0000, 'ºC'),
	(29428, 112, '2015-01-15 00:31:12.000000', 'temperatura', 852.0000, 'ºC'),
	(29429, 112, '2015-01-15 00:31:13.000000', 'temperatura', 623.0000, 'ºC'),
	(29430, 112, '2015-01-15 00:31:14.000000', 'temperatura', 557.0000, 'ºC'),
	(29431, 112, '2015-01-15 00:31:15.000000', 'temperatura', 918.0000, 'ºC'),
	(29432, 112, '2015-01-15 00:31:16.000000', 'temperatura', 520.0000, 'ºC'),
	(29433, 112, '2015-01-15 00:31:17.000000', 'temperatura', 1047.0000, 'ºC'),
	(29434, 112, '2015-01-15 00:31:18.000000', 'temperatura', 73.0000, 'ºC'),
	(29435, 112, '2015-01-15 00:31:19.000000', 'temperatura', 828.0000, 'ºC'),
	(29436, 112, '2015-01-15 00:31:20.000000', 'temperatura', 318.0000, 'ºC'),
	(29437, 112, '2015-01-15 00:31:21.000000', 'temperatura', 308.0000, 'ºC'),
	(29438, 112, '2015-01-15 00:31:22.000000', 'temperatura', 588.0000, 'ºC'),
	(29439, 112, '2015-01-15 00:31:23.000000', 'temperatura', 814.0000, 'ºC'),
	(29440, 112, '2015-01-15 00:31:24.000000', 'temperatura', 1107.0000, 'ºC'),
	(29441, 112, '2015-01-15 00:31:25.000000', 'temperatura', 693.0000, 'ºC'),
	(29442, 112, '2015-01-15 00:31:26.000000', 'temperatura', 145.0000, 'ºC'),
	(29443, 112, '2015-01-15 00:31:27.000000', 'temperatura', 1046.0000, 'ºC'),
	(29444, 112, '2015-01-15 00:31:28.000000', 'temperatura', 1197.0000, 'ºC'),
	(29445, 112, '2015-01-15 00:31:29.000000', 'temperatura', 445.0000, 'ºC'),
	(29446, 112, '2015-01-15 00:31:30.000000', 'temperatura', 1038.0000, 'ºC'),
	(29447, 112, '2015-01-15 00:31:31.000000', 'temperatura', 252.0000, 'ºC'),
	(29448, 112, '2015-01-15 00:31:32.000000', 'temperatura', 549.0000, 'ºC'),
	(29449, 112, '2015-01-15 00:31:33.000000', 'temperatura', 787.0000, 'ºC'),
	(29450, 112, '2015-01-15 00:31:34.000000', 'temperatura', 1088.0000, 'ºC'),
	(29451, 112, '2015-01-15 00:31:35.000000', 'temperatura', 680.0000, 'ºC'),
	(29452, 112, '2015-01-15 00:31:36.000000', 'temperatura', 136.0000, 'ºC'),
	(29453, 112, '2015-01-15 00:31:37.000000', 'temperatura', 1041.0000, 'ºC'),
	(29454, 112, '2015-01-15 00:31:38.000000', 'temperatura', 1199.0000, 'ºC'),
	(29455, 112, '2015-01-15 00:31:39.000000', 'temperatura', 471.0000, 'ºC'),
	(29456, 112, '2015-01-15 00:31:40.000000', 'temperatura', 1161.0000, 'ºC'),
	(29457, 112, '2015-01-15 00:31:41.000000', 'temperatura', 791.0000, 'ºC'),
	(29458, 112, '2015-01-15 00:31:42.000000', 'temperatura', 471.0000, 'ºC'),
	(29459, 112, '2015-01-15 00:31:43.000000', 'temperatura', 1184.0000, 'ºC'),
	(29460, 112, '2015-01-15 00:31:44.000000', 'temperatura', 907.0000, 'ºC'),
	(29461, 112, '2015-01-15 00:31:45.000000', 'temperatura', 982.0000, 'ºC'),
	(29462, 112, '2015-01-15 00:31:46.000000', 'temperatura', 990.0000, 'ºC'),
	(29463, 112, '2015-01-15 00:31:47.000000', 'temperatura', 803.0000, 'ºC'),
	(29464, 112, '2015-01-15 00:31:48.000000', 'temperatura', 1046.0000, 'ºC'),
	(29465, 112, '2015-01-15 00:31:49.000000', 'temperatura', 424.0000, 'ºC'),
	(29466, 112, '2015-01-15 00:31:50.000000', 'temperatura', 182.0000, 'ºC'),
	(29467, 112, '2015-01-15 00:31:51.000000', 'temperatura', 836.0000, 'ºC'),
	(29468, 112, '2015-01-15 00:31:52.000000', 'temperatura', 35.0000, 'ºC'),
	(29469, 112, '2015-01-15 00:31:53.000000', 'temperatura', 68.0000, 'ºC'),
	(29470, 112, '2015-01-15 00:31:54.000000', 'temperatura', 237.0000, 'ºC'),
	(29471, 112, '2015-01-15 00:31:55.000000', 'temperatura', 981.0000, 'ºC'),
	(29472, 112, '2015-01-15 00:31:56.000000', 'temperatura', 595.0000, 'ºC'),
	(29473, 112, '2015-01-15 00:31:57.000000', 'temperatura', 33.0000, 'ºC'),
	(29474, 112, '2015-01-15 00:31:58.000000', 'temperatura', 782.0000, 'ºC'),
	(29475, 112, '2015-01-15 00:31:59.000000', 'temperatura', 209.0000, 'ºC'),
	(29476, 112, '2015-01-15 00:32:00.000000', 'temperatura', 1100.0000, 'ºC'),
	(29477, 112, '2015-01-15 00:32:01.000000', 'temperatura', 74.0000, 'ºC'),
	(29478, 112, '2015-01-15 00:32:02.000000', 'temperatura', 671.0000, 'ºC'),
	(29479, 112, '2015-01-15 00:32:03.000000', 'temperatura', 732.0000, 'ºC'),
	(29480, 112, '2015-01-15 00:32:04.000000', 'temperatura', 449.0000, 'ºC'),
	(29481, 112, '2015-01-15 00:32:05.000000', 'temperatura', 51.0000, 'ºC'),
	(29482, 112, '2015-01-15 00:32:06.000000', 'temperatura', 105.0000, 'ºC'),
	(29483, 112, '2015-01-15 00:32:07.000000', 'temperatura', 376.0000, 'ºC'),
	(29484, 112, '2015-01-15 00:32:08.000000', 'temperatura', 362.0000, 'ºC'),
	(29485, 112, '2015-01-15 00:32:09.000000', 'temperatura', 686.0000, 'ºC'),
	(29486, 112, '2015-01-15 00:32:10.000000', 'temperatura', 1143.0000, 'ºC'),
	(29487, 112, '2015-01-15 00:32:11.000000', 'temperatura', 56.0000, 'ºC'),
	(29488, 112, '2015-01-15 00:32:12.000000', 'temperatura', 452.0000, 'ºC'),
	(29489, 112, '2015-01-15 00:32:13.000000', 'temperatura', 892.0000, 'ºC'),
	(29490, 112, '2015-01-15 00:32:14.000000', 'temperatura', 706.0000, 'ºC'),
	(29491, 112, '2015-01-15 00:32:15.000000', 'temperatura', 852.0000, 'ºC'),
	(29492, 112, '2015-01-15 00:32:16.000000', 'temperatura', 946.0000, 'ºC'),
	(29493, 112, '2015-01-15 00:32:17.000000', 'temperatura', 972.0000, 'ºC'),
	(29494, 112, '2015-01-15 00:32:18.000000', 'temperatura', 825.0000, 'ºC'),
	(29495, 112, '2015-01-15 00:32:19.000000', 'temperatura', 9.0000, 'ºC'),
	(29496, 112, '2015-01-15 00:32:20.000000', 'temperatura', 1171.0000, 'ºC'),
	(29497, 112, '2015-01-15 00:32:21.000000', 'temperatura', 1028.0000, 'ºC'),
	(29498, 112, '2015-01-15 00:32:22.000000', 'temperatura', 426.0000, 'ºC'),
	(29499, 112, '2015-01-15 00:32:23.000000', 'temperatura', 249.0000, 'ºC'),
	(29500, 112, '2015-01-15 00:32:24.000000', 'temperatura', 1166.0000, 'ºC'),
	(29501, 112, '2015-01-15 00:32:25.000000', 'temperatura', 284.0000, 'ºC'),
	(29502, 112, '2015-01-15 00:32:26.000000', 'temperatura', 323.0000, 'ºC'),
	(29503, 112, '2015-01-15 00:32:27.000000', 'temperatura', 763.0000, 'ºC'),
	(29504, 112, '2015-01-15 00:32:28.000000', 'temperatura', 447.0000, 'ºC'),
	(29505, 112, '2015-01-15 00:32:29.000000', 'temperatura', 1145.0000, 'ºC'),
	(29506, 112, '2015-01-15 00:32:30.000000', 'temperatura', 786.0000, 'ºC'),
	(29507, 112, '2015-01-15 00:32:31.000000', 'temperatura', 495.0000, 'ºC'),
	(29508, 112, '2015-01-15 00:32:32.000000', 'temperatura', 116.0000, 'ºC'),
	(29509, 112, '2015-01-15 00:32:33.000000', 'temperatura', 297.0000, 'ºC'),
	(29510, 112, '2015-01-15 00:32:34.000000', 'temperatura', 1136.0000, 'ºC'),
	(29511, 112, '2015-01-15 00:32:35.000000', 'temperatura', 1190.0000, 'ºC'),
	(29512, 112, '2015-01-15 00:32:36.000000', 'temperatura', 143.0000, 'ºC'),
	(29513, 112, '2015-01-15 00:32:37.000000', 'temperatura', 744.0000, 'ºC'),
	(29514, 112, '2015-01-15 00:32:38.000000', 'temperatura', 893.0000, 'ºC'),
	(29515, 112, '2015-01-15 00:32:39.000000', 'temperatura', 1034.0000, 'ºC'),
	(29516, 112, '2015-01-15 00:32:40.000000', 'temperatura', 92.0000, 'ºC'),
	(29517, 112, '2015-01-15 00:32:41.000000', 'temperatura', 956.0000, 'ºC'),
	(29518, 112, '2015-01-15 00:32:42.000000', 'temperatura', 906.0000, 'ºC'),
	(29519, 112, '2015-01-15 00:32:43.000000', 'temperatura', 464.0000, 'ºC'),
	(29520, 112, '2015-01-15 00:32:44.000000', 'temperatura', 803.0000, 'ºC'),
	(29521, 112, '2015-01-15 00:32:45.000000', 'temperatura', 221.0000, 'ºC'),
	(29522, 112, '2015-01-15 00:32:46.000000', 'temperatura', 1096.0000, 'ºC'),
	(29523, 112, '2015-01-15 00:32:47.000000', 'temperatura', 20.0000, 'ºC'),
	(29524, 112, '2015-01-15 00:32:48.000000', 'temperatura', 411.0000, 'ºC'),
	(29525, 112, '2015-01-15 00:32:49.000000', 'temperatura', 796.0000, 'ºC'),
	(29526, 112, '2015-01-15 00:32:50.000000', 'temperatura', 347.0000, 'ºC'),
	(29527, 112, '2015-01-15 00:32:51.000000', 'temperatura', 547.0000, 'ºC'),
	(29528, 112, '2015-01-15 00:32:52.000000', 'temperatura', 496.0000, 'ºC'),
	(29529, 112, '2015-01-15 00:32:53.000000', 'temperatura', 838.0000, 'ºC'),
	(29530, 112, '2015-01-15 00:32:54.000000', 'temperatura', 301.0000, 'ºC'),
	(29531, 112, '2015-01-15 00:32:55.000000', 'temperatura', 194.0000, 'ºC'),
	(29532, 112, '2015-01-15 00:32:56.000000', 'temperatura', 69.0000, 'ºC'),
	(29533, 112, '2015-01-15 00:32:57.000000', 'temperatura', 961.0000, 'ºC'),
	(29534, 112, '2015-01-15 00:32:58.000000', 'temperatura', 999.0000, 'ºC'),
	(29535, 112, '2015-01-15 00:32:59.000000', 'temperatura', 915.0000, 'ºC'),
	(29536, 112, '2015-01-15 00:33:00.000000', 'temperatura', 375.0000, 'ºC'),
	(29537, 112, '2015-01-15 00:33:01.000000', 'temperatura', 331.0000, 'ºC'),
	(29538, 112, '2015-01-15 00:33:02.000000', 'temperatura', 532.0000, 'ºC'),
	(29539, 112, '2015-01-15 00:33:03.000000', 'temperatura', 468.0000, 'ºC'),
	(29540, 112, '2015-01-15 00:33:04.000000', 'temperatura', 745.0000, 'ºC'),
	(29541, 112, '2015-01-15 00:33:05.000000', 'temperatura', 1119.0000, 'ºC'),
	(29542, 112, '2015-01-15 00:33:06.000000', 'temperatura', 962.0000, 'ºC'),
	(29543, 112, '2015-01-15 00:33:07.000000', 'temperatura', 252.0000, 'ºC'),
	(29544, 112, '2015-01-15 00:33:08.000000', 'temperatura', 777.0000, 'ºC'),
	(29545, 112, '2015-01-15 00:33:09.000000', 'temperatura', 729.0000, 'ºC'),
	(29546, 112, '2015-01-15 00:33:10.000000', 'temperatura', 116.0000, 'ºC'),
	(29547, 112, '2015-01-15 00:33:11.000000', 'temperatura', 792.0000, 'ºC'),
	(29548, 112, '2015-01-15 00:33:12.000000', 'temperatura', 12.0000, 'ºC'),
	(29549, 112, '2015-01-15 00:33:13.000000', 'temperatura', 87.0000, 'ºC'),
	(29550, 112, '2015-01-15 00:33:14.000000', 'temperatura', 398.0000, 'ºC'),
	(29551, 112, '2015-01-15 00:33:15.000000', 'temperatura', 527.0000, 'ºC'),
	(29552, 112, '2015-01-15 00:33:16.000000', 'temperatura', 245.0000, 'ºC'),
	(29553, 112, '2015-01-15 00:33:17.000000', 'temperatura', 843.0000, 'ºC'),
	(29554, 112, '2015-01-15 00:33:18.000000', 'temperatura', 1080.0000, 'ºC'),
	(29555, 112, '2015-01-15 00:33:19.000000', 'temperatura', 474.0000, 'ºC'),
	(29556, 112, '2015-01-15 00:33:20.000000', 'temperatura', 330.0000, 'ºC'),
	(29557, 112, '2015-01-15 00:33:21.000000', 'temperatura', 226.0000, 'ºC'),
	(29558, 112, '2015-01-15 00:33:22.000000', 'temperatura', 142.0000, 'ºC'),
	(29559, 112, '2015-01-15 00:33:23.000000', 'temperatura', 34.0000, 'ºC'),
	(29560, 112, '2015-01-15 00:33:24.000000', 'temperatura', 943.0000, 'ºC'),
	(29561, 112, '2015-01-15 00:33:25.000000', 'temperatura', 1016.0000, 'ºC'),
	(29562, 112, '2015-01-15 00:33:26.000000', 'temperatura', 1049.0000, 'ºC'),
	(29563, 112, '2015-01-15 00:33:27.000000', 'temperatura', 999.0000, 'ºC'),
	(29564, 112, '2015-01-15 00:33:28.000000', 'temperatura', 649.0000, 'ºC'),
	(29565, 112, '2015-01-15 00:33:29.000000', 'temperatura', 249.0000, 'ºC'),
	(29566, 112, '2015-01-15 00:33:30.000000', 'temperatura', 496.0000, 'ºC'),
	(29567, 112, '2015-01-15 00:33:31.000000', 'temperatura', 534.0000, 'ºC'),
	(29568, 112, '2015-01-15 00:33:32.000000', 'temperatura', 1184.0000, 'ºC'),
	(29569, 112, '2015-01-15 00:33:33.000000', 'temperatura', 719.0000, 'ºC'),
	(29570, 112, '2015-01-15 00:33:34.000000', 'temperatura', 44.0000, 'ºC'),
	(29571, 112, '2015-01-15 00:33:35.000000', 'temperatura', 461.0000, 'ºC'),
	(29572, 112, '2015-01-15 00:33:36.000000', 'temperatura', 975.0000, 'ºC'),
	(29573, 112, '2015-01-15 00:33:37.000000', 'temperatura', 1091.0000, 'ºC'),
	(29574, 112, '2015-01-15 00:33:38.000000', 'temperatura', 132.0000, 'ºC'),
	(29575, 112, '2015-01-15 00:33:39.000000', 'temperatura', 988.0000, 'ºC'),
	(29576, 112, '2015-01-15 00:33:40.000000', 'temperatura', 945.0000, 'ºC'),
	(29577, 112, '2015-01-15 00:33:41.000000', 'temperatura', 559.0000, 'ºC'),
	(29578, 112, '2015-01-15 00:33:42.000000', 'temperatura', 1162.0000, 'ºC'),
	(29579, 112, '2015-01-15 00:33:43.000000', 'temperatura', 532.0000, 'ºC'),
	(29580, 112, '2015-01-15 00:33:44.000000', 'temperatura', 377.0000, 'ºC'),
	(29581, 112, '2015-01-15 00:33:45.000000', 'temperatura', 290.0000, 'ºC'),
	(29582, 112, '2015-01-15 00:33:46.000000', 'temperatura', 316.0000, 'ºC'),
	(29583, 112, '2015-01-15 00:33:47.000000', 'temperatura', 713.0000, 'ºC'),
	(29584, 112, '2015-01-15 00:33:48.000000', 'temperatura', 218.0000, 'ºC'),
	(29585, 112, '2015-01-15 00:33:49.000000', 'temperatura', 151.0000, 'ºC'),
	(29586, 112, '2015-01-15 00:33:50.000000', 'temperatura', 99.0000, 'ºC'),
	(29587, 112, '2015-01-15 00:33:51.000000', 'temperatura', 45.0000, 'ºC'),
	(29588, 112, '2015-01-15 00:33:52.000000', 'temperatura', 1129.0000, 'ºC'),
	(29589, 112, '2015-01-15 00:33:53.000000', 'temperatura', 709.0000, 'ºC'),
	(29590, 112, '2015-01-15 00:33:54.000000', 'temperatura', 160.0000, 'ºC'),
	(29591, 112, '2015-01-15 00:33:55.000000', 'temperatura', 1075.0000, 'ºC'),
	(29592, 112, '2015-01-15 00:33:56.000000', 'temperatura', 92.0000, 'ºC'),
	(29593, 112, '2015-01-15 00:33:57.000000', 'temperatura', 838.0000, 'ºC'),
	(29594, 112, '2015-01-15 00:33:58.000000', 'temperatura', 312.0000, 'ºC'),
	(29595, 112, '2015-01-15 00:33:59.000000', 'temperatura', 250.0000, 'ºC'),
	(29596, 112, '2015-01-15 00:34:00.000000', 'temperatura', 312.0000, 'ºC'),
	(29597, 112, '2015-01-15 00:34:01.000000', 'temperatura', 811.0000, 'ºC'),
	(29598, 112, '2015-01-15 00:34:02.000000', 'temperatura', 720.0000, 'ºC'),
	(29599, 112, '2015-01-15 00:34:03.000000', 'temperatura', 1167.0000, 'ºC'),
	(29600, 112, '2015-01-15 00:34:04.000000', 'temperatura', 75.0000, 'ºC'),
	(29601, 112, '2015-01-15 00:34:05.000000', 'temperatura', 474.0000, 'ºC'),
	(29602, 112, '2015-01-15 00:34:06.000000', 'temperatura', 945.0000, 'ºC'),
	(29603, 112, '2015-01-15 00:34:07.000000', 'temperatura', 902.0000, 'ºC'),
	(29604, 112, '2015-01-15 00:34:08.000000', 'temperatura', 479.0000, 'ºC'),
	(29605, 112, '2015-01-15 00:34:09.000000', 'temperatura', 888.0000, 'ºC'),
	(29606, 112, '2015-01-15 00:34:10.000000', 'temperatura', 605.0000, 'ºC'),
	(29607, 112, '2015-01-15 00:34:11.000000', 'temperatura', 360.0000, 'ºC'),
	(29608, 112, '2015-01-15 00:34:12.000000', 'temperatura', 1185.0000, 'ºC'),
	(29609, 112, '2015-01-15 00:34:13.000000', 'temperatura', 46.0000, 'ºC'),
	(29610, 112, '2015-01-15 00:34:14.000000', 'temperatura', 276.0000, 'ºC'),
	(29611, 112, '2015-01-15 00:34:15.000000', 'temperatura', 42.0000, 'ºC'),
	(29612, 112, '2015-01-15 00:34:16.000000', 'temperatura', 583.0000, 'ºC'),
	(29613, 112, '2015-01-15 00:34:17.000000', 'temperatura', 389.0000, 'ºC'),
	(29614, 112, '2015-01-15 00:34:18.000000', 'temperatura', 195.0000, 'ºC'),
	(29615, 112, '2015-01-15 00:34:19.000000', 'temperatura', 1011.0000, 'ºC'),
	(29616, 112, '2015-01-15 00:34:20.000000', 'temperatura', 868.0000, 'ºC'),
	(29617, 112, '2015-01-15 00:34:21.000000', 'temperatura', 110.0000, 'ºC'),
	(29618, 112, '2015-01-15 00:34:22.000000', 'temperatura', 348.0000, 'ºC'),
	(29619, 112, '2015-01-15 00:34:23.000000', 'temperatura', 207.0000, 'ºC'),
	(29620, 112, '2015-01-15 00:34:24.000000', 'temperatura', 1192.0000, 'ºC'),
	(29621, 112, '2015-01-15 00:34:25.000000', 'temperatura', 540.0000, 'ºC'),
	(29622, 112, '2015-01-15 00:34:26.000000', 'temperatura', 324.0000, 'ºC'),
	(29623, 112, '2015-01-15 00:34:27.000000', 'temperatura', 3.0000, 'ºC'),
	(29624, 112, '2015-01-15 00:34:28.000000', 'temperatura', 241.0000, 'ºC'),
	(29625, 112, '2015-01-15 00:34:29.000000', 'temperatura', 1198.0000, 'ºC'),
	(29626, 112, '2015-01-15 00:34:30.000000', 'temperatura', 469.0000, 'ºC'),
	(29627, 112, '2015-01-15 00:34:31.000000', 'temperatura', 1148.0000, 'ºC'),
	(29628, 112, '2015-01-15 00:34:32.000000', 'temperatura', 737.0000, 'ºC'),
	(29629, 112, '2015-01-15 00:34:33.000000', 'temperatura', 239.0000, 'ºC'),
	(29630, 112, '2015-01-15 00:34:34.000000', 'temperatura', 185.0000, 'ºC'),
	(29631, 112, '2015-01-15 00:34:35.000000', 'temperatura', 209.0000, 'ºC'),
	(29632, 112, '2015-01-15 00:34:36.000000', 'temperatura', 491.0000, 'ºC'),
	(29633, 112, '2015-01-15 00:34:37.000000', 'temperatura', 628.0000, 'ºC'),
	(29634, 112, '2015-01-15 00:34:38.000000', 'temperatura', 467.0000, 'ºC'),
	(29635, 112, '2015-01-15 00:34:39.000000', 'temperatura', 452.0000, 'ºC'),
	(29636, 112, '2015-01-15 00:34:40.000000', 'temperatura', 858.0000, 'ºC'),
	(29637, 112, '2015-01-15 00:34:41.000000', 'temperatura', 537.0000, 'ºC'),
	(29638, 112, '2015-01-15 00:34:42.000000', 'temperatura', 110.0000, 'ºC'),
	(29639, 112, '2015-01-15 00:34:43.000000', 'temperatura', 142.0000, 'ºC'),
	(29640, 112, '2015-01-15 00:34:44.000000', 'temperatura', 379.0000, 'ºC'),
	(29641, 112, '2015-01-15 00:34:45.000000', 'temperatura', 268.0000, 'ºC'),
	(29642, 112, '2015-01-15 00:34:46.000000', 'temperatura', 205.0000, 'ºC'),
	(29643, 112, '2015-01-15 00:34:47.000000', 'temperatura', 220.0000, 'ºC'),
	(29644, 112, '2015-01-15 00:34:48.000000', 'temperatura', 486.0000, 'ºC'),
	(29645, 112, '2015-01-15 00:34:49.000000', 'temperatura', 573.0000, 'ºC'),
	(29646, 112, '2015-01-15 00:34:50.000000', 'temperatura', 205.0000, 'ºC'),
	(29647, 112, '2015-01-15 00:34:51.000000', 'temperatura', 509.0000, 'ºC'),
	(29648, 112, '2015-01-15 00:34:52.000000', 'temperatura', 727.0000, 'ºC'),
	(29649, 112, '2015-01-15 00:34:53.000000', 'temperatura', 912.0000, 'ºC'),
	(29650, 112, '2015-01-15 00:34:54.000000', 'temperatura', 1179.0000, 'ºC'),
	(29651, 112, '2015-01-15 00:34:55.000000', 'temperatura', 758.0000, 'ºC'),
	(29652, 112, '2015-01-15 00:34:56.000000', 'temperatura', 252.0000, 'ºC'),
	(29653, 112, '2015-01-15 00:34:57.000000', 'temperatura', 189.0000, 'ºC'),
	(29654, 112, '2015-01-15 00:34:58.000000', 'temperatura', 189.0000, 'ºC'),
	(29655, 112, '2015-01-15 00:34:59.000000', 'temperatura', 379.0000, 'ºC'),
	(29656, 112, '2015-01-15 00:35:00.000000', 'temperatura', 130.0000, 'ºC'),
	(29657, 112, '2015-01-15 00:35:01.000000', 'temperatura', 712.0000, 'ºC'),
	(29658, 112, '2015-01-15 00:35:02.000000', 'temperatura', 772.0000, 'ºC'),
	(29659, 112, '2015-01-15 00:35:03.000000', 'temperatura', 522.0000, 'ºC'),
	(29660, 112, '2015-01-15 00:35:04.000000', 'temperatura', 296.0000, 'ºC'),
	(29661, 112, '2015-01-15 00:35:05.000000', 'temperatura', 1114.0000, 'ºC'),
	(29662, 112, '2015-01-15 00:35:06.000000', 'temperatura', 1085.0000, 'ºC'),
	(29663, 112, '2015-01-15 00:35:07.000000', 'temperatura', 881.0000, 'ºC'),
	(29664, 112, '2015-01-15 00:35:08.000000', 'temperatura', 1150.0000, 'ºC'),
	(29665, 112, '2015-01-15 00:35:09.000000', 'temperatura', 708.0000, 'ºC'),
	(29666, 112, '2015-01-15 00:35:10.000000', 'temperatura', 91.0000, 'ºC'),
	(29667, 112, '2015-01-15 00:35:11.000000', 'temperatura', 731.0000, 'ºC'),
	(29668, 112, '2015-01-15 00:35:12.000000', 'temperatura', 984.0000, 'ºC'),
	(29669, 112, '2015-01-15 00:35:13.000000', 'temperatura', 325.0000, 'ºC'),
	(29670, 112, '2015-01-15 00:35:14.000000', 'temperatura', 1073.0000, 'ºC'),
	(29671, 112, '2015-01-15 00:35:15.000000', 'temperatura', 792.0000, 'ºC'),
	(29672, 112, '2015-01-15 00:35:16.000000', 'temperatura', 741.0000, 'ºC'),
	(29673, 112, '2015-01-15 00:35:17.000000', 'temperatura', 131.0000, 'ºC'),
	(29674, 112, '2015-01-15 00:35:18.000000', 'temperatura', 832.0000, 'ºC'),
	(29675, 112, '2015-01-15 00:35:19.000000', 'temperatura', 167.0000, 'ºC'),
	(29676, 112, '2015-01-15 00:35:20.000000', 'temperatura', 740.0000, 'ºC'),
	(29677, 112, '2015-01-15 00:35:21.000000', 'temperatura', 801.0000, 'ºC'),
	(29678, 112, '2015-01-15 00:35:22.000000', 'temperatura', 584.0000, 'ºC'),
	(29679, 112, '2015-01-15 00:35:23.000000', 'temperatura', 519.0000, 'ºC'),
	(29680, 112, '2015-01-15 00:35:24.000000', 'temperatura', 843.0000, 'ºC'),
	(29681, 112, '2015-01-15 00:35:25.000000', 'temperatura', 258.0000, 'ºC'),
	(29682, 112, '2015-01-15 00:35:26.000000', 'temperatura', 1163.0000, 'ºC'),
	(29683, 112, '2015-01-15 00:35:27.000000', 'temperatura', 239.0000, 'ºC'),
	(29684, 112, '2015-01-15 00:35:28.000000', 'temperatura', 106.0000, 'ºC'),
	(29685, 112, '2015-01-15 00:35:29.000000', 'temperatura', 1013.0000, 'ºC'),
	(29686, 112, '2015-01-15 00:35:30.000000', 'temperatura', 1147.0000, 'ºC'),
	(29687, 112, '2015-01-15 00:35:31.000000', 'temperatura', 297.0000, 'ºC'),
	(29688, 112, '2015-01-15 00:35:32.000000', 'temperatura', 443.0000, 'ºC'),
	(29689, 112, '2015-01-15 00:35:33.000000', 'temperatura', 127.0000, 'ºC'),
	(29690, 112, '2015-01-15 00:35:34.000000', 'temperatura', 504.0000, 'ºC'),
	(29691, 112, '2015-01-15 00:35:35.000000', 'temperatura', 942.0000, 'ºC'),
	(29692, 112, '2015-01-15 00:35:36.000000', 'temperatura', 796.0000, 'ºC'),
	(29693, 112, '2015-01-15 00:35:37.000000', 'temperatura', 1155.0000, 'ºC'),
	(29694, 112, '2015-01-15 00:35:38.000000', 'temperatura', 990.0000, 'ºC'),
	(29695, 112, '2015-01-15 00:35:39.000000', 'temperatura', 283.0000, 'ºC'),
	(29696, 112, '2015-01-15 00:35:40.000000', 'temperatura', 847.0000, 'ºC'),
	(29697, 112, '2015-01-15 00:35:41.000000', 'temperatura', 985.0000, 'ºC'),
	(29698, 112, '2015-01-15 00:35:42.000000', 'temperatura', 1184.0000, 'ºC'),
	(29699, 112, '2015-01-15 00:35:43.000000', 'temperatura', 568.0000, 'ºC'),
	(29700, 112, '2015-01-15 00:35:44.000000', 'temperatura', 488.0000, 'ºC'),
	(29701, 112, '2015-01-15 00:35:45.000000', 'temperatura', 737.0000, 'ºC'),
	(29702, 112, '2015-01-15 00:35:46.000000', 'temperatura', 1019.0000, 'ºC'),
	(29703, 112, '2015-01-15 00:35:47.000000', 'temperatura', 488.0000, 'ºC'),
	(29704, 112, '2015-01-15 00:35:48.000000', 'temperatura', 581.0000, 'ºC'),
	(29705, 112, '2015-01-15 00:35:49.000000', 'temperatura', 242.0000, 'ºC'),
	(29706, 112, '2015-01-15 00:35:50.000000', 'temperatura', 669.0000, 'ºC'),
	(29707, 112, '2015-01-15 00:35:51.000000', 'temperatura', 220.0000, 'ºC'),
	(29708, 112, '2015-01-15 00:35:52.000000', 'temperatura', 293.0000, 'ºC'),
	(29709, 112, '2015-01-15 00:35:53.000000', 'temperatura', 807.0000, 'ºC'),
	(29710, 112, '2015-01-15 00:35:54.000000', 'temperatura', 756.0000, 'ºC'),
	(29711, 112, '2015-01-15 00:35:55.000000', 'temperatura', 160.0000, 'ºC'),
	(29712, 112, '2015-01-15 00:35:56.000000', 'temperatura', 932.0000, 'ºC'),
	(29713, 112, '2015-01-15 00:35:57.000000', 'temperatura', 580.0000, 'ºC'),
	(29714, 112, '2015-01-15 00:35:58.000000', 'temperatura', 103.0000, 'ºC'),
	(29715, 112, '2015-01-15 00:35:59.000000', 'temperatura', 1176.0000, 'ºC'),
	(29716, 112, '2015-01-15 00:36:00.000000', 'temperatura', 773.0000, 'ºC'),
	(29717, 112, '2015-01-15 00:36:01.000000', 'temperatura', 337.0000, 'ºC'),
	(29718, 112, '2015-01-15 00:36:02.000000', 'temperatura', 568.0000, 'ºC'),
	(29719, 112, '2015-01-15 00:36:03.000000', 'temperatura', 629.0000, 'ºC'),
	(29720, 112, '2015-01-15 00:36:04.000000', 'temperatura', 240.0000, 'ºC'),
	(29721, 112, '2015-01-15 00:36:05.000000', 'temperatura', 514.0000, 'ºC'),
	(29722, 112, '2015-01-15 00:36:06.000000', 'temperatura', 650.0000, 'ºC'),
	(29723, 112, '2015-01-15 00:36:07.000000', 'temperatura', 509.0000, 'ºC'),
	(29724, 112, '2015-01-15 00:36:08.000000', 'temperatura', 595.0000, 'ºC'),
	(29725, 112, '2015-01-15 00:36:09.000000', 'temperatura', 249.0000, 'ºC'),
	(29726, 112, '2015-01-15 00:36:10.000000', 'temperatura', 660.0000, 'ºC'),
	(29727, 112, '2015-01-15 00:36:11.000000', 'temperatura', 152.0000, 'ºC'),
	(29728, 112, '2015-01-15 00:36:12.000000', 'temperatura', 1181.0000, 'ºC'),
	(29729, 112, '2015-01-15 00:36:13.000000', 'temperatura', 650.0000, 'ºC'),
	(29730, 112, '2015-01-15 00:36:14.000000', 'temperatura', 909.0000, 'ºC'),
	(29731, 112, '2015-01-15 00:36:15.000000', 'temperatura', 193.0000, 'ºC'),
	(29732, 112, '2015-01-15 00:36:16.000000', 'temperatura', 637.0000, 'ºC'),
	(29733, 112, '2015-01-15 00:36:17.000000', 'temperatura', 210.0000, 'ºC'),
	(29734, 112, '2015-01-15 00:36:18.000000', 'temperatura', 338.0000, 'ºC'),
	(29735, 112, '2015-01-15 00:36:19.000000', 'temperatura', 1060.0000, 'ºC'),
	(29736, 112, '2015-01-15 00:36:20.000000', 'temperatura', 688.0000, 'ºC'),
	(29737, 112, '2015-01-15 00:36:21.000000', 'temperatura', 261.0000, 'ºC'),
	(29738, 112, '2015-01-15 00:36:22.000000', 'temperatura', 441.0000, 'ºC'),
	(29739, 112, '2015-01-15 00:36:23.000000', 'temperatura', 222.0000, 'ºC'),
	(29740, 112, '2015-01-15 00:36:24.000000', 'temperatura', 987.0000, 'ºC'),
	(29741, 112, '2015-01-15 00:36:25.000000', 'temperatura', 668.0000, 'ºC'),
	(29742, 112, '2015-01-15 00:36:26.000000', 'temperatura', 382.0000, 'ºC'),
	(29743, 112, '2015-01-15 00:36:27.000000', 'temperatura', 1106.0000, 'ºC'),
	(29744, 112, '2015-01-15 00:36:28.000000', 'temperatura', 785.0000, 'ºC'),
	(29745, 112, '2015-01-15 00:36:29.000000', 'temperatura', 605.0000, 'ºC'),
	(29746, 112, '2015-01-15 00:36:30.000000', 'temperatura', 672.0000, 'ºC'),
	(29747, 112, '2015-01-15 00:36:31.000000', 'temperatura', 347.0000, 'ºC'),
	(29748, 112, '2015-01-15 00:36:32.000000', 'temperatura', 917.0000, 'ºC'),
	(29749, 112, '2015-01-15 00:36:33.000000', 'temperatura', 1143.0000, 'ºC'),
	(29750, 112, '2015-01-15 00:36:34.000000', 'temperatura', 568.0000, 'ºC'),
	(29751, 112, '2015-01-15 00:36:35.000000', 'temperatura', 611.0000, 'ºC'),
	(29752, 112, '2015-01-15 00:36:36.000000', 'temperatura', 151.0000, 'ºC'),
	(29753, 112, '2015-01-15 00:36:37.000000', 'temperatura', 122.0000, 'ºC'),
	(29754, 112, '2015-01-15 00:36:38.000000', 'temperatura', 158.0000, 'ºC'),
	(29755, 112, '2015-01-15 00:36:39.000000', 'temperatura', 424.0000, 'ºC'),
	(29756, 112, '2015-01-15 00:36:40.000000', 'temperatura', 446.0000, 'ºC'),
	(29757, 112, '2015-01-15 00:36:41.000000', 'temperatura', 959.0000, 'ºC'),
	(29758, 112, '2015-01-15 00:36:42.000000', 'temperatura', 1058.0000, 'ºC'),
	(29759, 112, '2015-01-15 00:36:43.000000', 'temperatura', 14.0000, 'ºC'),
	(29760, 112, '2015-01-15 00:36:44.000000', 'temperatura', 496.0000, 'ºC'),
	(29761, 112, '2015-01-15 00:36:45.000000', 'temperatura', 39.0000, 'ºC'),
	(29762, 112, '2015-01-15 00:36:46.000000', 'temperatura', 1108.0000, 'ºC'),
	(29763, 112, '2015-01-15 00:36:47.000000', 'temperatura', 623.0000, 'ºC'),
	(29764, 112, '2015-01-15 00:36:48.000000', 'temperatura', 989.0000, 'ºC'),
	(29765, 112, '2015-01-15 00:36:49.000000', 'temperatura', 680.0000, 'ºC'),
	(29766, 112, '2015-01-15 00:36:50.000000', 'temperatura', 431.0000, 'ºC'),
	(29767, 112, '2015-01-15 00:36:51.000000', 'temperatura', 115.0000, 'ºC'),
	(29768, 112, '2015-01-15 00:36:52.000000', 'temperatura', 482.0000, 'ºC'),
	(29769, 112, '2015-01-15 00:36:53.000000', 'temperatura', 867.0000, 'ºC'),
	(29770, 112, '2015-01-15 00:36:54.000000', 'temperatura', 491.0000, 'ºC'),
	(29771, 112, '2015-01-15 00:36:55.000000', 'temperatura', 1052.0000, 'ºC'),
	(29772, 112, '2015-01-15 00:36:56.000000', 'temperatura', 187.0000, 'ºC'),
	(29773, 112, '2015-01-15 00:36:57.000000', 'temperatura', 181.0000, 'ºC'),
	(29774, 112, '2015-01-15 00:36:58.000000', 'temperatura', 343.0000, 'ºC'),
	(29775, 112, '2015-01-15 00:36:59.000000', 'temperatura', 1174.0000, 'ºC'),
	(29776, 112, '2015-01-15 00:37:00.000000', 'temperatura', 42.0000, 'ºC'),
	(29777, 112, '2015-01-15 00:37:01.000000', 'temperatura', 287.0000, 'ºC'),
	(29778, 112, '2015-01-15 00:37:02.000000', 'temperatura', 108.0000, 'ºC'),
	(29779, 112, '2015-01-15 00:37:03.000000', 'temperatura', 882.0000, 'ºC'),
	(29780, 112, '2015-01-15 00:37:04.000000', 'temperatura', 484.0000, 'ºC'),
	(29781, 112, '2015-01-15 00:37:05.000000', 'temperatura', 978.0000, 'ºC'),
	(29782, 112, '2015-01-15 00:37:06.000000', 'temperatura', 1035.0000, 'ºC'),
	(29783, 112, '2015-01-15 00:37:07.000000', 'temperatura', 1045.0000, 'ºC'),
	(29784, 112, '2015-01-15 00:37:08.000000', 'temperatura', 918.0000, 'ºC'),
	(29785, 112, '2015-01-15 00:37:09.000000', 'temperatura', 255.0000, 'ºC'),
	(29786, 112, '2015-01-15 00:37:10.000000', 'temperatura', 922.0000, 'ºC'),
	(29787, 112, '2015-01-15 00:37:11.000000', 'temperatura', 246.0000, 'ºC'),
	(29788, 112, '2015-01-15 00:37:12.000000', 'temperatura', 863.0000, 'ºC'),
	(29789, 112, '2015-01-15 00:37:13.000000', 'temperatura', 1180.0000, 'ºC'),
	(29790, 112, '2015-01-15 00:37:14.000000', 'temperatura', 912.0000, 'ºC'),
	(29791, 112, '2015-01-15 00:37:15.000000', 'temperatura', 1020.0000, 'ºC'),
	(29792, 112, '2015-01-15 00:37:16.000000', 'temperatura', 1163.0000, 'ºC'),
	(29793, 112, '2015-01-15 00:37:17.000000', 'temperatura', 356.0000, 'ºC'),
	(29794, 112, '2015-01-15 00:37:18.000000', 'temperatura', 692.0000, 'ºC'),
	(29795, 112, '2015-01-15 00:37:19.000000', 'temperatura', 1192.0000, 'ºC'),
	(29796, 112, '2015-01-15 00:37:20.000000', 'temperatura', 283.0000, 'ºC'),
	(29797, 112, '2015-01-15 00:37:21.000000', 'temperatura', 239.0000, 'ºC'),
	(29798, 112, '2015-01-15 00:37:22.000000', 'temperatura', 350.0000, 'ºC'),
	(29799, 112, '2015-01-15 00:37:23.000000', 'temperatura', 1030.0000, 'ºC'),
	(29800, 112, '2015-01-15 00:37:24.000000', 'temperatura', 502.0000, 'ºC'),
	(29801, 112, '2015-01-15 00:37:25.000000', 'temperatura', 620.0000, 'ºC'),
	(29802, 112, '2015-01-15 00:37:26.000000', 'temperatura', 395.0000, 'ºC'),
	(29803, 112, '2015-01-15 00:37:27.000000', 'temperatura', 115.0000, 'ºC'),
	(29804, 112, '2015-01-15 00:37:28.000000', 'temperatura', 590.0000, 'ºC'),
	(29805, 112, '2015-01-15 00:37:29.000000', 'temperatura', 205.0000, 'ºC'),
	(29806, 112, '2015-01-15 00:37:30.000000', 'temperatura', 456.0000, 'ºC'),
	(29807, 112, '2015-01-15 00:37:31.000000', 'temperatura', 464.0000, 'ºC'),
	(29808, 112, '2015-01-15 00:37:32.000000', 'temperatura', 952.0000, 'ºC'),
	(29809, 112, '2015-01-15 00:37:33.000000', 'temperatura', 971.0000, 'ºC'),
	(29810, 112, '2015-01-15 00:37:34.000000', 'temperatura', 797.0000, 'ºC'),
	(29811, 112, '2015-01-15 00:37:35.000000', 'temperatura', 1073.0000, 'ºC'),
	(29812, 112, '2015-01-15 00:37:36.000000', 'temperatura', 574.0000, 'ºC'),
	(29813, 112, '2015-01-15 00:37:37.000000', 'temperatura', 852.0000, 'ºC'),
	(29814, 112, '2015-01-15 00:37:38.000000', 'temperatura', 139.0000, 'ºC'),
	(29815, 112, '2015-01-15 00:37:39.000000', 'temperatura', 539.0000, 'ºC'),
	(29816, 112, '2015-01-15 00:37:40.000000', 'temperatura', 1078.0000, 'ºC'),
	(29817, 112, '2015-01-15 00:37:41.000000', 'temperatura', 173.0000, 'ºC'),
	(29818, 112, '2015-01-15 00:37:42.000000', 'temperatura', 32.0000, 'ºC'),
	(29819, 112, '2015-01-15 00:37:43.000000', 'temperatura', 843.0000, 'ºC'),
	(29820, 112, '2015-01-15 00:37:44.000000', 'temperatura', 520.0000, 'ºC'),
	(29821, 112, '2015-01-15 00:37:45.000000', 'temperatura', 71.0000, 'ºC'),
	(29822, 112, '2015-01-15 00:37:46.000000', 'temperatura', 1196.0000, 'ºC'),
	(29823, 112, '2015-01-15 00:37:47.000000', 'temperatura', 969.0000, 'ºC'),
	(29824, 112, '2015-01-15 00:37:48.000000', 'temperatura', 56.0000, 'ºC'),
	(29825, 112, '2015-01-15 00:37:49.000000', 'temperatura', 973.0000, 'ºC'),
	(29826, 112, '2015-01-15 00:37:50.000000', 'temperatura', 1100.0000, 'ºC'),
	(29827, 112, '2015-01-15 00:37:51.000000', 'temperatura', 180.0000, 'ºC'),
	(29828, 112, '2015-01-15 00:37:52.000000', 'temperatura', 1199.0000, 'ºC'),
	(29829, 112, '2015-01-15 00:37:53.000000', 'temperatura', 657.0000, 'ºC'),
	(29830, 112, '2015-01-15 00:37:54.000000', 'temperatura', 890.0000, 'ºC'),
	(29831, 112, '2015-01-15 00:37:55.000000', 'temperatura', 76.0000, 'ºC'),
	(29832, 112, '2015-01-15 00:37:56.000000', 'temperatura', 113.0000, 'ºC'),
	(29833, 112, '2015-01-15 00:37:57.000000', 'temperatura', 338.0000, 'ºC'),
	(29834, 112, '2015-01-15 00:37:58.000000', 'temperatura', 152.0000, 'ºC'),
	(29835, 112, '2015-01-15 00:37:59.000000', 'temperatura', 945.0000, 'ºC'),
	(29836, 112, '2015-01-15 00:38:00.000000', 'temperatura', 669.0000, 'ºC'),
	(29837, 112, '2015-01-15 00:38:01.000000', 'temperatura', 512.0000, 'ºC'),
	(29838, 112, '2015-01-15 00:38:02.000000', 'temperatura', 553.0000, 'ºC'),
	(29839, 112, '2015-01-15 00:38:03.000000', 'temperatura', 30.0000, 'ºC'),
	(29840, 112, '2015-01-15 00:38:04.000000', 'temperatura', 892.0000, 'ºC'),
	(29841, 112, '2015-01-15 00:38:05.000000', 'temperatura', 769.0000, 'ºC'),
	(29842, 112, '2015-01-15 00:38:06.000000', 'temperatura', 1169.0000, 'ºC'),
	(29843, 112, '2015-01-15 00:38:07.000000', 'temperatura', 1138.0000, 'ºC'),
	(29844, 112, '2015-01-15 00:38:08.000000', 'temperatura', 983.0000, 'ºC'),
	(29845, 112, '2015-01-15 00:38:09.000000', 'temperatura', 301.0000, 'ºC'),
	(29846, 112, '2015-01-15 00:38:10.000000', 'temperatura', 958.0000, 'ºC'),
	(29847, 112, '2015-01-15 00:38:11.000000', 'temperatura', 287.0000, 'ºC'),
	(29848, 112, '2015-01-15 00:38:12.000000', 'temperatura', 963.0000, 'ºC'),
	(29849, 112, '2015-01-15 00:38:13.000000', 'temperatura', 355.0000, 'ºC'),
	(29850, 112, '2015-01-15 00:38:14.000000', 'temperatura', 87.0000, 'ºC'),
	(29851, 112, '2015-01-15 00:38:15.000000', 'temperatura', 570.0000, 'ºC'),
	(29852, 112, '2015-01-15 00:38:16.000000', 'temperatura', 190.0000, 'ºC'),
	(29853, 112, '2015-01-15 00:38:17.000000', 'temperatura', 439.0000, 'ºC'),
	(29854, 112, '2015-01-15 00:38:18.000000', 'temperatura', 426.0000, 'ºC'),
	(29855, 112, '2015-01-15 00:38:19.000000', 'temperatura', 813.0000, 'ºC'),
	(29856, 112, '2015-01-15 00:38:20.000000', 'temperatura', 386.0000, 'ºC'),
	(29857, 112, '2015-01-15 00:38:21.000000', 'temperatura', 693.0000, 'ºC'),
	(29858, 112, '2015-01-15 00:38:22.000000', 'temperatura', 1108.0000, 'ºC'),
	(29859, 112, '2015-01-15 00:38:23.000000', 'temperatura', 1060.0000, 'ºC'),
	(29860, 112, '2015-01-15 00:38:24.000000', 'temperatura', 777.0000, 'ºC'),
	(29861, 112, '2015-01-15 00:38:25.000000', 'temperatura', 708.0000, 'ºC'),
	(29862, 112, '2015-01-15 00:38:26.000000', 'temperatura', 6.0000, 'ºC'),
	(29863, 112, '2015-01-15 00:38:27.000000', 'temperatura', 308.0000, 'ºC'),
	(29864, 112, '2015-01-15 00:38:28.000000', 'temperatura', 320.0000, 'ºC'),
	(29865, 112, '2015-01-15 00:38:29.000000', 'temperatura', 680.0000, 'ºC'),
	(29866, 112, '2015-01-15 00:38:30.000000', 'temperatura', 37.0000, 'ºC'),
	(29867, 112, '2015-01-15 00:38:31.000000', 'temperatura', 549.0000, 'ºC'),
	(29868, 112, '2015-01-15 00:38:32.000000', 'temperatura', 232.0000, 'ºC'),
	(29869, 112, '2015-01-15 00:38:33.000000', 'temperatura', 716.0000, 'ºC'),
	(29870, 112, '2015-01-15 00:38:34.000000', 'temperatura', 482.0000, 'ºC'),
	(29871, 112, '2015-01-15 00:38:35.000000', 'temperatura', 265.0000, 'ºC'),
	(29872, 112, '2015-01-15 00:38:36.000000', 'temperatura', 1079.0000, 'ºC'),
	(29873, 112, '2015-01-15 00:38:37.000000', 'temperatura', 1000.0000, 'ºC'),
	(29874, 112, '2015-01-15 00:38:38.000000', 'temperatura', 564.0000, 'ºC'),
	(29875, 112, '2015-01-15 00:38:39.000000', 'temperatura', 1020.0000, 'ºC'),
	(29876, 112, '2015-01-15 00:38:40.000000', 'temperatura', 1010.0000, 'ºC'),
	(29877, 112, '2015-01-15 00:38:41.000000', 'temperatura', 791.0000, 'ºC'),
	(29878, 112, '2015-01-15 00:38:42.000000', 'temperatura', 926.0000, 'ºC'),
	(29879, 112, '2015-01-15 00:38:43.000000', 'temperatura', 1056.0000, 'ºC'),
	(29880, 112, '2015-01-15 00:38:44.000000', 'temperatura', 103.0000, 'ºC'),
	(29881, 112, '2015-01-15 00:38:45.000000', 'temperatura', 949.0000, 'ºC'),
	(29882, 112, '2015-01-15 00:38:46.000000', 'temperatura', 835.0000, 'ºC'),
	(29883, 112, '2015-01-15 00:38:47.000000', 'temperatura', 127.0000, 'ºC'),
	(29884, 112, '2015-01-15 00:38:48.000000', 'temperatura', 531.0000, 'ºC'),
	(29885, 112, '2015-01-15 00:38:49.000000', 'temperatura', 1073.0000, 'ºC'),
	(29886, 112, '2015-01-15 00:38:50.000000', 'temperatura', 173.0000, 'ºC'),
	(29887, 112, '2015-01-15 00:38:51.000000', 'temperatura', 48.0000, 'ºC'),
	(29888, 112, '2015-01-15 00:38:52.000000', 'temperatura', 922.0000, 'ºC'),
	(29889, 112, '2015-01-15 00:38:53.000000', 'temperatura', 867.0000, 'ºC'),
	(29890, 112, '2015-01-15 00:38:54.000000', 'temperatura', 370.0000, 'ºC'),
	(29891, 112, '2015-01-15 00:38:55.000000', 'temperatura', 448.0000, 'ºC'),
	(29892, 112, '2015-01-15 00:38:56.000000', 'temperatura', 1133.0000, 'ºC'),
	(29893, 112, '2015-01-15 00:38:57.000000', 'temperatura', 719.0000, 'ºC'),
	(29894, 112, '2015-01-15 00:38:58.000000', 'temperatura', 199.0000, 'ºC'),
	(29895, 112, '2015-01-15 00:38:59.000000', 'temperatura', 38.0000, 'ºC'),
	(29896, 112, '2015-01-15 00:39:00.000000', 'temperatura', 792.0000, 'ºC'),
	(29897, 112, '2015-01-15 00:39:01.000000', 'temperatura', 249.0000, 'ºC'),
	(29898, 112, '2015-01-15 00:39:02.000000', 'temperatura', 66.0000, 'ºC'),
	(29899, 112, '2015-01-15 00:39:03.000000', 'temperatura', 787.0000, 'ºC'),
	(29900, 112, '2015-01-15 00:39:04.000000', 'temperatura', 136.0000, 'ºC'),
	(29901, 112, '2015-01-15 00:39:05.000000', 'temperatura', 718.0000, 'ºC'),
	(29902, 112, '2015-01-15 00:39:06.000000', 'temperatura', 785.0000, 'ºC'),
	(29903, 112, '2015-01-15 00:39:07.000000', 'temperatura', 570.0000, 'ºC'),
	(29904, 112, '2015-01-15 00:39:08.000000', 'temperatura', 495.0000, 'ºC'),
	(29905, 112, '2015-01-15 00:39:09.000000', 'temperatura', 767.0000, 'ºC'),
	(29906, 112, '2015-01-15 00:39:10.000000', 'temperatura', 1149.0000, 'ºC'),
	(29907, 112, '2015-01-15 00:39:11.000000', 'temperatura', 1045.0000, 'ºC'),
	(29908, 112, '2015-01-15 00:39:12.000000', 'temperatura', 580.0000, 'ºC'),
	(29909, 112, '2015-01-15 00:39:13.000000', 'temperatura', 966.0000, 'ºC'),
	(29910, 112, '2015-01-15 00:39:14.000000', 'temperatura', 691.0000, 'ºC'),
	(29911, 112, '2015-01-15 00:39:15.000000', 'temperatura', 555.0000, 'ºC'),
	(29912, 112, '2015-01-15 00:39:16.000000', 'temperatura', 702.0000, 'ºC'),
	(29913, 112, '2015-01-15 00:39:17.000000', 'temperatura', 648.0000, 'ºC'),
	(29914, 112, '2015-01-15 00:39:18.000000', 'temperatura', 1133.0000, 'ºC'),
	(29915, 112, '2015-01-15 00:39:19.000000', 'temperatura', 123.0000, 'ºC'),
	(29916, 112, '2015-01-15 00:39:20.000000', 'temperatura', 816.0000, 'ºC'),
	(29917, 112, '2015-01-15 00:39:21.000000', 'temperatura', 111.0000, 'ºC'),
	(29918, 112, '2015-01-15 00:39:22.000000', 'temperatura', 507.0000, 'ºC'),
	(29919, 112, '2015-01-15 00:39:23.000000', 'temperatura', 1001.0000, 'ºC'),
	(29920, 112, '2015-01-15 00:39:24.000000', 'temperatura', 1087.0000, 'ºC'),
	(29921, 112, '2015-01-15 00:39:25.000000', 'temperatura', 33.0000, 'ºC'),
	(29922, 112, '2015-01-15 00:39:26.000000', 'temperatura', 504.0000, 'ºC'),
	(29923, 112, '2015-01-15 00:39:27.000000', 'temperatura', 21.0000, 'ºC'),
	(29924, 112, '2015-01-15 00:39:28.000000', 'temperatura', 994.0000, 'ºC'),
	(29925, 112, '2015-01-15 00:39:29.000000', 'temperatura', 108.0000, 'ºC'),
	(29926, 112, '2015-01-15 00:39:30.000000', 'temperatura', 1159.0000, 'ºC'),
	(29927, 112, '2015-01-15 00:39:31.000000', 'temperatura', 672.0000, 'ºC'),
	(29928, 112, '2015-01-15 00:39:32.000000', 'temperatura', 1084.0000, 'ºC'),
	(29929, 112, '2015-01-15 00:39:33.000000', 'temperatura', 1004.0000, 'ºC'),
	(29930, 112, '2015-01-15 00:39:34.000000', 'temperatura', 568.0000, 'ºC'),
	(29931, 112, '2015-01-15 00:39:35.000000', 'temperatura', 1028.0000, 'ºC'),
	(29932, 112, '2015-01-15 00:39:36.000000', 'temperatura', 1038.0000, 'ºC'),
	(29933, 112, '2015-01-15 00:39:37.000000', 'temperatura', 906.0000, 'ºC'),
	(29934, 112, '2015-01-15 00:39:38.000000', 'temperatura', 215.0000, 'ºC'),
	(29935, 112, '2015-01-15 00:39:39.000000', 'temperatura', 757.0000, 'ºC'),
	(29936, 112, '2015-01-15 00:39:40.000000', 'temperatura', 742.0000, 'ºC'),
	(29937, 112, '2015-01-15 00:39:41.000000', 'temperatura', 240.0000, 'ºC'),
	(29938, 112, '2015-01-15 00:39:42.000000', 'temperatura', 174.0000, 'ºC'),
	(29939, 112, '2015-01-15 00:39:43.000000', 'temperatura', 149.0000, 'ºC'),
	(29940, 112, '2015-01-15 00:39:44.000000', 'temperatura', 223.0000, 'ºC'),
	(29941, 112, '2015-01-15 00:39:45.000000', 'temperatura', 669.0000, 'ºC'),
	(29942, 112, '2015-01-15 00:39:46.000000', 'temperatura', 279.0000, 'ºC'),
	(29943, 112, '2015-01-15 00:39:47.000000', 'temperatura', 585.0000, 'ºC'),
	(29944, 112, '2015-01-15 00:39:48.000000', 'temperatura', 890.0000, 'ºC'),
	(29945, 112, '2015-01-15 00:39:49.000000', 'temperatura', 295.0000, 'ºC'),
	(29946, 112, '2015-01-15 00:39:50.000000', 'temperatura', 6.0000, 'ºC'),
	(29947, 112, '2015-01-15 00:39:51.000000', 'temperatura', 344.0000, 'ºC'),
	(29948, 112, '2015-01-15 00:39:52.000000', 'temperatura', 504.0000, 'ºC'),
	(29949, 112, '2015-01-15 00:39:53.000000', 'temperatura', 287.0000, 'ºC'),
	(29950, 112, '2015-01-15 00:39:54.000000', 'temperatura', 1123.0000, 'ºC'),
	(29951, 112, '2015-01-15 00:39:55.000000', 'temperatura', 1156.0000, 'ºC'),
	(29952, 112, '2015-01-15 00:39:56.000000', 'temperatura', 12.0000, 'ºC'),
	(29953, 112, '2015-01-15 00:39:57.000000', 'temperatura', 193.0000, 'ºC'),
	(29954, 112, '2015-01-15 00:39:58.000000', 'temperatura', 928.0000, 'ºC'),
	(29955, 112, '2015-01-15 00:39:59.000000', 'temperatura', 462.0000, 'ºC'),
	(29956, 112, '2015-01-15 00:40:00.000000', 'temperatura', 728.0000, 'ºC'),
	(29957, 112, '2015-01-15 00:40:01.000000', 'temperatura', 1054.0000, 'ºC'),
	(29958, 112, '2015-01-15 00:40:02.000000', 'temperatura', 685.0000, 'ºC'),
	(29959, 112, '2015-01-15 00:40:03.000000', 'temperatura', 262.0000, 'ºC'),
	(29960, 112, '2015-01-15 00:40:04.000000', 'temperatura', 459.0000, 'ºC'),
	(29961, 112, '2015-01-15 00:40:05.000000', 'temperatura', 307.0000, 'ºC'),
	(29962, 112, '2015-01-15 00:40:06.000000', 'temperatura', 160.0000, 'ºC'),
	(29963, 112, '2015-01-15 00:40:07.000000', 'temperatura', 1080.0000, 'ºC'),
	(29964, 112, '2015-01-15 00:40:08.000000', 'temperatura', 118.0000, 'ºC'),
	(29965, 112, '2015-01-15 00:40:09.000000', 'temperatura', 954.0000, 'ºC'),
	(29966, 112, '2015-01-15 00:40:10.000000', 'temperatura', 813.0000, 'ºC'),
	(29967, 112, '2015-01-15 00:40:11.000000', 'temperatura', 5.0000, 'ºC'),
	(29968, 112, '2015-01-15 00:40:12.000000', 'temperatura', 1188.0000, 'ºC'),
	(29969, 112, '2015-01-15 00:40:13.000000', 'temperatura', 1126.0000, 'ºC'),
	(29970, 112, '2015-01-15 00:40:14.000000', 'temperatura', 865.0000, 'ºC'),
	(29971, 112, '2015-01-15 00:40:15.000000', 'temperatura', 947.0000, 'ºC'),
	(29972, 112, '2015-01-15 00:40:16.000000', 'temperatura', 939.0000, 'ºC'),
	(29973, 112, '2015-01-15 00:40:17.000000', 'temperatura', 656.0000, 'ºC'),
	(29974, 112, '2015-01-15 00:40:18.000000', 'temperatura', 464.0000, 'ºC'),
	(29975, 112, '2015-01-15 00:40:19.000000', 'temperatura', 353.0000, 'ºC'),
	(29976, 112, '2015-01-15 00:40:20.000000', 'temperatura', 371.0000, 'ºC'),
	(29977, 112, '2015-01-15 00:40:21.000000', 'temperatura', 799.0000, 'ºC'),
	(29978, 112, '2015-01-15 00:40:22.000000', 'temperatura', 480.0000, 'ºC'),
	(29979, 112, '2015-01-15 00:40:23.000000', 'temperatura', 3.0000, 'ºC'),
	(29980, 112, '2015-01-15 00:40:24.000000', 'temperatura', 977.0000, 'ºC'),
	(29981, 112, '2015-01-15 00:40:25.000000', 'temperatura', 78.0000, 'ºC'),
	(29982, 112, '2015-01-15 00:40:26.000000', 'temperatura', 1059.0000, 'ºC'),
	(29983, 112, '2015-01-15 00:40:27.000000', 'temperatura', 260.0000, 'ºC'),
	(29984, 112, '2015-01-15 00:40:28.000000', 'temperatura', 526.0000, 'ºC'),
	(29985, 112, '2015-01-15 00:40:29.000000', 'temperatura', 650.0000, 'ºC'),
	(29986, 112, '2015-01-15 00:40:30.000000', 'temperatura', 471.0000, 'ºC'),
	(29987, 112, '2015-01-15 00:40:31.000000', 'temperatura', 405.0000, 'ºC'),
	(29988, 112, '2015-01-15 00:40:32.000000', 'temperatura', 615.0000, 'ºC'),
	(29989, 112, '2015-01-15 00:40:33.000000', 'temperatura', 661.0000, 'ºC'),
	(29990, 112, '2015-01-15 00:40:34.000000', 'temperatura', 259.0000, 'ºC'),
	(29991, 112, '2015-01-15 00:40:35.000000', 'temperatura', 512.0000, 'ºC'),
	(29992, 112, '2015-01-15 00:40:36.000000', 'temperatura', 584.0000, 'ºC'),
	(29993, 112, '2015-01-15 00:40:37.000000', 'temperatura', 184.0000, 'ºC'),
	(29994, 112, '2015-01-15 00:40:38.000000', 'temperatura', 369.0000, 'ºC'),
	(29995, 112, '2015-01-15 00:40:39.000000', 'temperatura', 95.0000, 'ºC'),
	(29996, 112, '2015-01-15 00:40:40.000000', 'temperatura', 567.0000, 'ºC'),
	(29997, 112, '2015-01-15 00:40:41.000000', 'temperatura', 151.0000, 'ºC'),
	(29998, 112, '2015-01-15 00:40:42.000000', 'temperatura', 253.0000, 'ºC'),
	(29999, 112, '2015-01-15 00:40:43.000000', 'temperatura', 814.0000, 'ºC'),
	(30000, 112, '2015-01-15 00:40:44.000000', 'temperatura', 910.0000, 'ºC'),
	(30001, 112, '2015-01-15 00:40:45.000000', 'temperatura', 908.0000, 'ºC'),
	(30002, 112, '2015-01-15 00:40:46.000000', 'temperatura', 612.0000, 'ºC'),
	(30003, 112, '2015-01-15 00:40:47.000000', 'temperatura', 336.0000, 'ºC'),
	(30004, 112, '2015-01-15 00:40:48.000000', 'temperatura', 1046.0000, 'ºC'),
	(30005, 112, '2015-01-15 00:40:49.000000', 'temperatura', 620.0000, 'ºC'),
	(30006, 112, '2015-01-15 00:40:50.000000', 'temperatura', 1163.0000, 'ºC'),
	(30007, 112, '2015-01-15 00:40:51.000000', 'temperatura', 356.0000, 'ºC'),
	(30008, 112, '2015-01-15 00:40:52.000000', 'temperatura', 691.0000, 'ºC'),
	(30009, 112, '2015-01-15 00:40:53.000000', 'temperatura', 1186.0000, 'ºC'),
	(30010, 112, '2015-01-15 00:40:54.000000', 'temperatura', 259.0000, 'ºC'),
	(30011, 112, '2015-01-15 00:40:55.000000', 'temperatura', 136.0000, 'ºC'),
	(30012, 112, '2015-01-15 00:40:56.000000', 'temperatura', 1104.0000, 'ºC'),
	(30013, 112, '2015-01-15 00:40:57.000000', 'temperatura', 313.0000, 'ºC'),
	(30014, 112, '2015-01-15 00:40:58.000000', 'temperatura', 653.0000, 'ºC'),
	(30015, 112, '2015-01-15 00:40:59.000000', 'temperatura', 1126.0000, 'ºC'),
	(30016, 112, '2015-01-15 00:41:00.000000', 'temperatura', 71.0000, 'ºC'),
	(30017, 112, '2015-01-15 00:41:01.000000', 'temperatura', 579.0000, 'ºC'),
	(30018, 112, '2015-01-15 00:41:02.000000', 'temperatura', 280.0000, 'ºC'),
	(30019, 112, '2015-01-15 00:41:03.000000', 'temperatura', 864.0000, 'ºC'),
	(30020, 112, '2015-01-15 00:41:04.000000', 'temperatura', 1081.0000, 'ºC'),
	(30021, 112, '2015-01-15 00:41:05.000000', 'temperatura', 414.0000, 'ºC'),
	(30022, 112, '2015-01-15 00:41:06.000000', 'temperatura', 27.0000, 'ºC'),
	(30023, 112, '2015-01-15 00:41:07.000000', 'temperatura', 95.0000, 'ºC'),
	(30024, 112, '2015-01-15 00:41:08.000000', 'temperatura', 394.0000, 'ºC'),
	(30025, 112, '2015-01-15 00:41:09.000000', 'temperatura', 487.0000, 'ºC'),
	(30026, 112, '2015-01-15 00:41:10.000000', 'temperatura', 52.0000, 'ºC'),
	(30027, 112, '2015-01-15 00:41:11.000000', 'temperatura', 1.0000, 'ºC'),
	(30028, 112, '2015-01-15 00:41:12.000000', 'temperatura', 1050.0000, 'ºC'),
	(30029, 112, '2015-01-15 00:41:13.000000', 'temperatura', 448.0000, 'ºC'),
	(30030, 112, '2015-01-15 00:41:14.000000', 'temperatura', 291.0000, 'ºC'),
	(30031, 112, '2015-01-15 00:41:15.000000', 'temperatura', 109.0000, 'ºC'),
	(30032, 112, '2015-01-15 00:41:16.000000', 'temperatura', 874.0000, 'ºC'),
	(30033, 112, '2015-01-15 00:41:17.000000', 'temperatura', 445.0000, 'ºC'),
	(30034, 112, '2015-01-15 00:41:18.000000', 'temperatura', 802.0000, 'ºC'),
	(30035, 112, '2015-01-15 00:41:19.000000', 'temperatura', 277.0000, 'ºC'),
	(30036, 112, '2015-01-15 00:41:20.000000', 'temperatura', 181.0000, 'ºC'),
	(30037, 112, '2015-01-15 00:41:21.000000', 'temperatura', 71.0000, 'ºC'),
	(30038, 112, '2015-01-15 00:41:22.000000', 'temperatura', 1014.0000, 'ºC'),
	(30039, 112, '2015-01-15 00:41:23.000000', 'temperatura', 57.0000, 'ºC'),
	(30040, 112, '2015-01-15 00:41:24.000000', 'temperatura', 843.0000, 'ºC'),
	(30041, 112, '2015-01-15 00:41:25.000000', 'temperatura', 447.0000, 'ºC'),
	(30042, 112, '2015-01-15 00:41:26.000000', 'temperatura', 905.0000, 'ºC'),
	(30043, 112, '2015-01-15 00:41:27.000000', 'temperatura', 783.0000, 'ºC'),
	(30044, 112, '2015-01-15 00:41:28.000000', 'temperatura', 1.0000, 'ºC'),
	(30045, 112, '2015-01-15 00:41:29.000000', 'temperatura', 57.0000, 'ºC'),
	(30046, 112, '2015-01-15 00:41:30.000000', 'temperatura', 282.0000, 'ºC'),
	(30047, 112, '2015-01-15 00:41:31.000000', 'temperatura', 39.0000, 'ºC'),
	(30048, 112, '2015-01-15 00:41:32.000000', 'temperatura', 550.0000, 'ºC'),
	(30049, 112, '2015-01-15 00:41:33.000000', 'temperatura', 234.0000, 'ºC'),
	(30050, 112, '2015-01-15 00:41:34.000000', 'temperatura', 720.0000, 'ºC'),
	(30051, 112, '2015-01-15 00:41:35.000000', 'temperatura', 500.0000, 'ºC'),
	(30052, 112, '2015-01-15 00:41:36.000000', 'temperatura', 339.0000, 'ºC'),
	(30053, 112, '2015-01-15 00:41:37.000000', 'temperatura', 196.0000, 'ºC'),
	(30054, 112, '2015-01-15 00:41:38.000000', 'temperatura', 1164.0000, 'ºC'),
	(30055, 112, '2015-01-15 00:41:39.000000', 'temperatura', 430.0000, 'ºC'),
	(30056, 112, '2015-01-15 00:41:40.000000', 'temperatura', 1061.0000, 'ºC'),
	(30057, 112, '2015-01-15 00:41:41.000000', 'temperatura', 415.0000, 'ºC'),
	(30058, 112, '2015-01-15 00:41:42.000000', 'temperatura', 90.0000, 'ºC'),
	(30059, 112, '2015-01-15 00:41:43.000000', 'temperatura', 409.0000, 'ºC'),
	(30060, 112, '2015-01-15 00:41:44.000000', 'temperatura', 573.0000, 'ºC'),
	(30061, 112, '2015-01-15 00:41:45.000000', 'temperatura', 440.0000, 'ºC'),
	(30062, 112, '2015-01-15 00:41:46.000000', 'temperatura', 482.0000, 'ºC'),
	(30063, 112, '2015-01-15 00:41:47.000000', 'temperatura', 1091.0000, 'ºC'),
	(30064, 112, '2015-01-15 00:41:48.000000', 'temperatura', 409.0000, 'ºC'),
	(30065, 112, '2015-01-15 00:41:49.000000', 'temperatura', 1174.0000, 'ºC'),
	(30066, 112, '2015-01-15 00:41:50.000000', 'temperatura', 1043.0000, 'ºC'),
	(30067, 112, '2015-01-15 00:41:51.000000', 'temperatura', 494.0000, 'ºC'),
	(30068, 112, '2015-01-15 00:41:52.000000', 'temperatura', 542.0000, 'ºC'),
	(30069, 112, '2015-01-15 00:41:53.000000', 'temperatura', 27.0000, 'ºC'),
	(30070, 112, '2015-01-15 00:41:54.000000', 'temperatura', 911.0000, 'ºC'),
	(30071, 112, '2015-01-15 00:41:55.000000', 'temperatura', 875.0000, 'ºC'),
	(30072, 112, '2015-01-15 00:41:56.000000', 'temperatura', 443.0000, 'ºC'),
	(30073, 112, '2015-01-15 00:41:57.000000', 'temperatura', 790.0000, 'ºC'),
	(30074, 112, '2015-01-15 00:41:58.000000', 'temperatura', 222.0000, 'ºC'),
	(30075, 112, '2015-01-15 00:41:59.000000', 'temperatura', 1142.0000, 'ºC'),
	(30076, 112, '2015-01-15 00:42:00.000000', 'temperatura', 242.0000, 'ºC'),
	(30077, 112, '2015-01-15 00:42:01.000000', 'temperatura', 185.0000, 'ºC'),
	(30078, 112, '2015-01-15 00:42:02.000000', 'temperatura', 198.0000, 'ºC'),
	(30079, 112, '2015-01-15 00:42:03.000000', 'temperatura', 438.0000, 'ºC'),
	(30080, 112, '2015-01-15 00:42:04.000000', 'temperatura', 397.0000, 'ºC'),
	(30081, 112, '2015-01-15 00:42:05.000000', 'temperatura', 669.0000, 'ºC'),
	(30082, 112, '2015-01-15 00:42:06.000000', 'temperatura', 955.0000, 'ºC'),
	(30083, 112, '2015-01-15 00:42:07.000000', 'temperatura', 370.0000, 'ºC'),
	(30084, 112, '2015-01-15 00:42:08.000000', 'temperatura', 185.0000, 'ºC'),
	(30085, 112, '2015-01-15 00:42:09.000000', 'temperatura', 1015.0000, 'ºC'),
	(30086, 112, '2015-01-15 00:42:10.000000', 'temperatura', 922.0000, 'ºC'),
	(30087, 112, '2015-01-15 00:42:11.000000', 'temperatura', 364.0000, 'ºC'),
	(30088, 112, '2015-01-15 00:42:12.000000', 'temperatura', 257.0000, 'ºC'),
	(30089, 112, '2015-01-15 00:42:13.000000', 'temperatura', 191.0000, 'ºC'),
	(30090, 112, '2015-01-15 00:42:14.000000', 'temperatura', 184.0000, 'ºC'),
	(30091, 112, '2015-01-15 00:42:15.000000', 'temperatura', 349.0000, 'ºC'),
	(30092, 112, '2015-01-15 00:42:16.000000', 'temperatura', 1195.0000, 'ºC'),
	(30093, 112, '2015-01-15 00:42:17.000000', 'temperatura', 126.0000, 'ºC'),
	(30094, 112, '2015-01-15 00:42:18.000000', 'temperatura', 648.0000, 'ºC'),
	(30095, 112, '2015-01-15 00:42:19.000000', 'temperatura', 463.0000, 'ºC'),
	(30096, 112, '2015-01-15 00:42:20.000000', 'temperatura', 371.0000, 'ºC'),
	(30097, 112, '2015-01-15 00:42:21.000000', 'temperatura', 467.0000, 'ºC'),
	(30098, 112, '2015-01-15 00:42:22.000000', 'temperatura', 20.0000, 'ºC'),
	(30099, 112, '2015-01-15 00:42:23.000000', 'temperatura', 1101.0000, 'ºC'),
	(30100, 112, '2015-01-15 00:42:24.000000', 'temperatura', 646.0000, 'ºC'),
	(30101, 112, '2015-01-15 00:42:25.000000', 'temperatura', 1126.0000, 'ºC'),
	(30102, 112, '2015-01-15 00:42:26.000000', 'temperatura', 95.0000, 'ºC'),
	(30103, 112, '2015-01-15 00:42:27.000000', 'temperatura', 697.0000, 'ºC'),
	(30104, 112, '2015-01-15 00:42:28.000000', 'temperatura', 801.0000, 'ºC'),
	(30105, 112, '2015-01-15 00:42:29.000000', 'temperatura', 712.0000, 'ºC'),
	(30106, 112, '2015-01-15 00:42:30.000000', 'temperatura', 1158.0000, 'ºC'),
	(30107, 112, '2015-01-15 00:42:31.000000', 'temperatura', 55.0000, 'ºC'),
	(30108, 112, '2015-01-15 00:42:32.000000', 'temperatura', 402.0000, 'ºC'),
	(30109, 112, '2015-01-15 00:42:33.000000', 'temperatura', 645.0000, 'ºC'),
	(30110, 112, '2015-01-15 00:42:34.000000', 'temperatura', 821.0000, 'ºC'),
	(30111, 112, '2015-01-15 00:42:35.000000', 'temperatura', 971.0000, 'ºC'),
	(30112, 112, '2015-01-15 00:42:36.000000', 'temperatura', 1193.0000, 'ºC'),
	(30113, 112, '2015-01-15 00:42:37.000000', 'temperatura', 651.0000, 'ºC'),
	(30114, 112, '2015-01-15 00:42:38.000000', 'temperatura', 876.0000, 'ºC'),
	(30115, 112, '2015-01-15 00:42:39.000000', 'temperatura', 28.0000, 'ºC'),
	(30116, 112, '2015-01-15 00:42:40.000000', 'temperatura', 1111.0000, 'ºC'),
	(30117, 112, '2015-01-15 00:42:41.000000', 'temperatura', 673.0000, 'ºC'),
	(30118, 112, '2015-01-15 00:42:42.000000', 'temperatura', 32.0000, 'ºC'),
	(30119, 112, '2015-01-15 00:42:43.000000', 'temperatura', 540.0000, 'ºC'),
	(30120, 112, '2015-01-15 00:42:44.000000', 'temperatura', 208.0000, 'ºC'),
	(30121, 112, '2015-01-15 00:42:45.000000', 'temperatura', 617.0000, 'ºC'),
	(30122, 112, '2015-01-15 00:42:46.000000', 'temperatura', 64.0000, 'ºC'),
	(30123, 112, '2015-01-15 00:42:47.000000', 'temperatura', 869.0000, 'ºC'),
	(30124, 112, '2015-01-15 00:42:48.000000', 'temperatura', 555.0000, 'ºC'),
	(30125, 112, '2015-01-15 00:42:49.000000', 'temperatura', 166.0000, 'ºC'),
	(30126, 112, '2015-01-15 00:42:50.000000', 'temperatura', 366.0000, 'ºC'),
	(30127, 112, '2015-01-15 00:42:51.000000', 'temperatura', 132.0000, 'ºC'),
	(30128, 112, '2015-01-15 00:42:52.000000', 'temperatura', 761.0000, 'ºC'),
	(30129, 112, '2015-01-15 00:42:53.000000', 'temperatura', 1012.0000, 'ºC'),
	(30130, 112, '2015-01-15 00:42:54.000000', 'temperatura', 376.0000, 'ºC'),
	(30131, 112, '2015-01-15 00:42:55.000000', 'temperatura', 45.0000, 'ºC'),
	(30132, 112, '2015-01-15 00:42:56.000000', 'temperatura', 298.0000, 'ºC'),
	(30133, 112, '2015-01-15 00:42:57.000000', 'temperatura', 155.0000, 'ºC'),
	(30134, 112, '2015-01-15 00:42:58.000000', 'temperatura', 1084.0000, 'ºC'),
	(30135, 112, '2015-01-15 00:42:59.000000', 'temperatura', 152.0000, 'ºC'),
	(30136, 112, '2015-01-15 00:43:00.000000', 'temperatura', 1109.0000, 'ºC'),
	(30137, 112, '2015-01-15 00:43:01.000000', 'temperatura', 291.0000, 'ºC'),
	(30138, 112, '2015-01-15 00:43:02.000000', 'temperatura', 527.0000, 'ºC'),
	(30139, 112, '2015-01-15 00:43:03.000000', 'temperatura', 564.0000, 'ºC'),
	(30140, 112, '2015-01-15 00:43:04.000000', 'temperatura', 38.0000, 'ºC'),
	(30141, 112, '2015-01-15 00:43:05.000000', 'temperatura', 901.0000, 'ºC'),
	(30142, 112, '2015-01-15 00:43:06.000000', 'temperatura', 790.0000, 'ºC'),
	(30143, 112, '2015-01-15 00:43:07.000000', 'temperatura', 47.0000, 'ºC'),
	(30144, 112, '2015-01-15 00:43:08.000000', 'temperatura', 267.0000, 'ºC'),
	(30145, 112, '2015-01-15 00:43:09.000000', 'temperatura', 1196.0000, 'ºC'),
	(30146, 112, '2015-01-15 00:43:10.000000', 'temperatura', 377.0000, 'ºC'),
	(30147, 112, '2015-01-15 00:43:11.000000', 'temperatura', 699.0000, 'ºC'),
	(30148, 112, '2015-01-15 00:43:12.000000', 'temperatura', 1162.0000, 'ºC'),
	(30149, 112, '2015-01-15 00:43:13.000000', 'temperatura', 116.0000, 'ºC'),
	(30150, 112, '2015-01-15 00:43:14.000000', 'temperatura', 692.0000, 'ºC'),
	(30151, 112, '2015-01-15 00:43:15.000000', 'temperatura', 716.0000, 'ºC'),
	(30152, 112, '2015-01-15 00:43:16.000000', 'temperatura', 302.0000, 'ºC'),
	(30153, 112, '2015-01-15 00:43:17.000000', 'temperatura', 561.0000, 'ºC'),
	(30154, 112, '2015-01-15 00:43:18.000000', 'temperatura', 702.0000, 'ºC'),
	(30155, 112, '2015-01-15 00:43:19.000000', 'temperatura', 626.0000, 'ºC'),
	(30156, 112, '2015-01-15 00:43:20.000000', 'temperatura', 1025.0000, 'ºC'),
	(30157, 112, '2015-01-15 00:43:21.000000', 'temperatura', 847.0000, 'ºC'),
	(30158, 112, '2015-01-15 00:43:22.000000', 'temperatura', 1163.0000, 'ºC'),
	(30159, 112, '2015-01-15 00:43:23.000000', 'temperatura', 872.0000, 'ºC'),
	(30160, 112, '2015-01-15 00:43:24.000000', 'temperatura', 871.0000, 'ºC'),
	(30161, 112, '2015-01-15 00:43:25.000000', 'temperatura', 540.0000, 'ºC'),
	(30162, 112, '2015-01-15 00:43:26.000000', 'temperatura', 90.0000, 'ºC'),
	(30163, 112, '2015-01-15 00:43:27.000000', 'temperatura', 28.0000, 'ºC'),
	(30164, 112, '2015-01-15 00:43:28.000000', 'temperatura', 1073.0000, 'ºC'),
	(30165, 112, '2015-01-15 00:43:29.000000', 'temperatura', 480.0000, 'ºC'),
	(30166, 112, '2015-01-15 00:43:30.000000', 'temperatura', 383.0000, 'ºC'),
	(30167, 112, '2015-01-15 00:43:31.000000', 'temperatura', 475.0000, 'ºC'),
	(30168, 112, '2015-01-15 00:43:32.000000', 'temperatura', 26.0000, 'ºC'),
	(30169, 112, '2015-01-15 00:43:33.000000', 'temperatura', 1104.0000, 'ºC'),
	(30170, 112, '2015-01-15 00:43:34.000000', 'temperatura', 645.0000, 'ºC'),
	(30171, 112, '2015-01-15 00:43:35.000000', 'temperatura', 1114.0000, 'ºC'),
	(30172, 112, '2015-01-15 00:43:36.000000', 'temperatura', 33.0000, 'ºC'),
	(30173, 112, '2015-01-15 00:43:37.000000', 'temperatura', 426.0000, 'ºC'),
	(30174, 112, '2015-01-15 00:43:38.000000', 'temperatura', 831.0000, 'ºC'),
	(30175, 112, '2015-01-15 00:43:39.000000', 'temperatura', 477.0000, 'ºC'),
	(30176, 112, '2015-01-15 00:43:40.000000', 'temperatura', 1092.0000, 'ºC'),
	(30177, 112, '2015-01-15 00:43:41.000000', 'temperatura', 432.0000, 'ºC'),
	(30178, 112, '2015-01-15 00:43:42.000000', 'temperatura', 81.0000, 'ºC'),
	(30179, 112, '2015-01-15 00:43:43.000000', 'temperatura', 313.0000, 'ºC'),
	(30180, 112, '2015-01-15 00:43:44.000000', 'temperatura', 121.0000, 'ºC'),
	(30181, 112, '2015-01-15 00:43:45.000000', 'temperatura', 866.0000, 'ºC'),
	(30182, 112, '2015-01-15 00:43:46.000000', 'temperatura', 370.0000, 'ºC'),
	(30183, 112, '2015-01-15 00:43:47.000000', 'temperatura', 450.0000, 'ºC'),
	(30184, 112, '2015-01-15 00:43:48.000000', 'temperatura', 1140.0000, 'ºC'),
	(30185, 112, '2015-01-15 00:43:49.000000', 'temperatura', 751.0000, 'ºC'),
	(30186, 112, '2015-01-15 00:43:50.000000', 'temperatura', 334.0000, 'ºC'),
	(30187, 112, '2015-01-15 00:43:51.000000', 'temperatura', 618.0000, 'ºC'),
	(30188, 112, '2015-01-15 00:43:52.000000', 'temperatura', 887.0000, 'ºC'),
	(30189, 112, '2015-01-15 00:43:53.000000', 'temperatura', 184.0000, 'ºC'),
	(30190, 112, '2015-01-15 00:43:54.000000', 'temperatura', 658.0000, 'ºC'),
	(30191, 112, '2015-01-15 00:43:55.000000', 'temperatura', 337.0000, 'ºC'),
	(30192, 112, '2015-01-15 00:43:56.000000', 'temperatura', 912.0000, 'ºC'),
	(30193, 112, '2015-01-15 00:43:57.000000', 'temperatura', 1152.0000, 'ºC'),
	(30194, 112, '2015-01-15 00:43:58.000000', 'temperatura', 624.0000, 'ºC'),
	(30195, 112, '2015-01-15 00:43:59.000000', 'temperatura', 862.0000, 'ºC'),
	(30196, 112, '2015-01-15 00:44:00.000000', 'temperatura', 42.0000, 'ºC'),
	(30197, 112, '2015-01-15 00:44:01.000000', 'temperatura', 22.0000, 'ºC'),
	(30198, 112, '2015-01-15 00:44:02.000000', 'temperatura', 1186.0000, 'ºC'),
	(30199, 112, '2015-01-15 00:44:03.000000', 'temperatura', 1065.0000, 'ºC'),
	(30200, 112, '2015-01-15 00:44:04.000000', 'temperatura', 566.0000, 'ºC'),
	(30201, 112, '2015-01-15 00:44:05.000000', 'temperatura', 836.0000, 'ºC'),
	(30202, 112, '2015-01-15 00:44:06.000000', 'temperatura', 83.0000, 'ºC'),
	(30203, 112, '2015-01-15 00:44:07.000000', 'temperatura', 306.0000, 'ºC'),
	(30204, 112, '2015-01-15 00:44:08.000000', 'temperatura', 82.0000, 'ºC'),
	(30205, 112, '2015-01-15 00:44:09.000000', 'temperatura', 694.0000, 'ºC'),
	(30206, 112, '2015-01-15 00:44:10.000000', 'temperatura', 825.0000, 'ºC'),
	(30207, 112, '2015-01-15 00:44:11.000000', 'temperatura', 844.0000, 'ºC'),
	(30208, 112, '2015-01-15 00:44:12.000000', 'temperatura', 546.0000, 'ºC'),
	(30209, 112, '2015-01-15 00:44:13.000000', 'temperatura', 199.0000, 'ºC'),
	(30210, 112, '2015-01-15 00:44:14.000000', 'temperatura', 555.0000, 'ºC'),
	(30211, 112, '2015-01-15 00:44:15.000000', 'temperatura', 979.0000, 'ºC'),
	(30212, 112, '2015-01-15 00:44:16.000000', 'temperatura', 832.0000, 'ºC'),
	(30213, 112, '2015-01-15 00:44:17.000000', 'temperatura', 21.0000, 'ºC'),
	(30214, 112, '2015-01-15 00:44:18.000000', 'temperatura', 11.0000, 'ºC'),
	(30215, 112, '2015-01-15 00:44:19.000000', 'temperatura', 1192.0000, 'ºC'),
	(30216, 112, '2015-01-15 00:44:20.000000', 'temperatura', 1127.0000, 'ºC'),
	(30217, 112, '2015-01-15 00:44:21.000000', 'temperatura', 861.0000, 'ºC'),
	(30218, 112, '2015-01-15 00:44:22.000000', 'temperatura', 922.0000, 'ºC'),
	(30219, 112, '2015-01-15 00:44:23.000000', 'temperatura', 829.0000, 'ºC'),
	(30220, 112, '2015-01-15 00:44:24.000000', 'temperatura', 180.0000, 'ºC'),
	(30221, 112, '2015-01-15 00:44:25.000000', 'temperatura', 812.0000, 'ºC'),
	(30222, 112, '2015-01-15 00:44:26.000000', 'temperatura', 1122.0000, 'ºC'),
	(30223, 112, '2015-01-15 00:44:27.000000', 'temperatura', 775.0000, 'ºC'),
	(30224, 112, '2015-01-15 00:44:28.000000', 'temperatura', 508.0000, 'ºC'),
	(30225, 112, '2015-01-15 00:44:29.000000', 'temperatura', 217.0000, 'ºC'),
	(30226, 112, '2015-01-15 00:44:30.000000', 'temperatura', 761.0000, 'ºC'),
	(30227, 112, '2015-01-15 00:44:31.000000', 'temperatura', 755.0000, 'ºC'),
	(30228, 112, '2015-01-15 00:44:32.000000', 'temperatura', 293.0000, 'ºC'),
	(30229, 112, '2015-01-15 00:44:33.000000', 'temperatura', 400.0000, 'ºC'),
	(30230, 112, '2015-01-15 00:44:34.000000', 'temperatura', 1121.0000, 'ºC'),
	(30231, 112, '2015-01-15 00:44:35.000000', 'temperatura', 805.0000, 'ºC'),
	(30232, 112, '2015-01-15 00:44:36.000000', 'temperatura', 665.0000, 'ºC'),
	(30233, 112, '2015-01-15 00:44:37.000000', 'temperatura', 908.0000, 'ºC'),
	(30234, 112, '2015-01-15 00:44:38.000000', 'temperatura', 146.0000, 'ºC'),
	(30235, 112, '2015-01-15 00:44:39.000000', 'temperatura', 406.0000, 'ºC'),
	(30236, 112, '2015-01-15 00:44:40.000000', 'temperatura', 394.0000, 'ºC'),
	(30237, 112, '2015-01-15 00:44:41.000000', 'temperatura', 753.0000, 'ºC'),
	(30238, 112, '2015-01-15 00:44:42.000000', 'temperatura', 183.0000, 'ºC'),
	(30239, 112, '2015-01-15 00:44:43.000000', 'temperatura', 1055.0000, 'ºC'),
	(30240, 112, '2015-01-15 00:44:44.000000', 'temperatura', 1126.0000, 'ºC'),
	(30241, 112, '2015-01-15 00:44:45.000000', 'temperatura', 67.0000, 'ºC'),
	(30242, 112, '2015-01-15 00:44:46.000000', 'temperatura', 558.0000, 'ºC'),
	(30243, 112, '2015-01-15 00:44:47.000000', 'temperatura', 189.0000, 'ºC'),
	(30244, 112, '2015-01-15 00:44:48.000000', 'temperatura', 470.0000, 'ºC'),
	(30245, 112, '2015-01-15 00:44:49.000000', 'temperatura', 583.0000, 'ºC'),
	(30246, 112, '2015-01-15 00:44:50.000000', 'temperatura', 308.0000, 'ºC'),
	(30247, 112, '2015-01-15 00:44:51.000000', 'temperatura', 990.0000, 'ºC'),
	(30248, 112, '2015-01-15 00:44:52.000000', 'temperatura', 429.0000, 'ºC'),
	(30249, 112, '2015-01-15 00:44:53.000000', 'temperatura', 372.0000, 'ºC'),
	(30250, 112, '2015-01-15 00:44:54.000000', 'temperatura', 576.0000, 'ºC'),
	(30251, 112, '2015-01-15 00:44:55.000000', 'temperatura', 566.0000, 'ºC'),
	(30252, 112, '2015-01-15 00:44:56.000000', 'temperatura', 1099.0000, 'ºC'),
	(30253, 112, '2015-01-15 00:44:57.000000', 'temperatura', 201.0000, 'ºC'),
	(30254, 112, '2015-01-15 00:44:58.000000', 'temperatura', 106.0000, 'ºC'),
	(30255, 112, '2015-01-15 00:44:59.000000', 'temperatura', 1127.0000, 'ºC'),
	(30256, 112, '2015-01-15 00:45:00.000000', 'temperatura', 520.0000, 'ºC'),
	(30257, 112, '2015-01-15 00:45:01.000000', 'temperatura', 417.0000, 'ºC'),
	(30258, 112, '2015-01-15 00:45:02.000000', 'temperatura', 528.0000, 'ºC'),
	(30259, 112, '2015-01-15 00:45:03.000000', 'temperatura', 186.0000, 'ºC'),
	(30260, 112, '2015-01-15 00:45:04.000000', 'temperatura', 550.0000, 'ºC'),
	(30261, 112, '2015-01-15 00:45:05.000000', 'temperatura', 992.0000, 'ºC'),
	(30262, 112, '2015-01-15 00:45:06.000000', 'temperatura', 911.0000, 'ºC'),
	(30263, 112, '2015-01-15 00:45:07.000000', 'temperatura', 378.0000, 'ºC'),
	(30264, 112, '2015-01-15 00:45:08.000000', 'temperatura', 359.0000, 'ºC'),
	(30265, 112, '2015-01-15 00:45:09.000000', 'temperatura', 659.0000, 'ºC'),
	(30266, 112, '2015-01-15 00:45:10.000000', 'temperatura', 1020.0000, 'ºC'),
	(30267, 112, '2015-01-15 00:45:11.000000', 'temperatura', 721.0000, 'ºC'),
	(30268, 112, '2015-01-15 00:45:12.000000', 'temperatura', 549.0000, 'ºC'),
	(30269, 112, '2015-01-15 00:45:13.000000', 'temperatura', 581.0000, 'ºC'),
	(30270, 112, '2015-01-15 00:45:14.000000', 'temperatura', 57.0000, 'ºC'),
	(30271, 112, '2015-01-15 00:45:15.000000', 'temperatura', 942.0000, 'ºC'),
	(30272, 112, '2015-01-15 00:45:16.000000', 'temperatura', 939.0000, 'ºC'),
	(30273, 112, '2015-01-15 00:45:17.000000', 'temperatura', 672.0000, 'ºC'),
	(30274, 112, '2015-01-15 00:45:18.000000', 'temperatura', 540.0000, 'ºC'),
	(30275, 112, '2015-01-15 00:45:19.000000', 'temperatura', 688.0000, 'ºC'),
	(30276, 112, '2015-01-15 00:45:20.000000', 'temperatura', 621.0000, 'ºC'),
	(30277, 112, '2015-01-15 00:45:21.000000', 'temperatura', 1038.0000, 'ºC'),
	(30278, 112, '2015-01-15 00:45:22.000000', 'temperatura', 930.0000, 'ºC'),
	(30279, 112, '2015-01-15 00:45:23.000000', 'temperatura', 337.0000, 'ºC'),
	(30280, 112, '2015-01-15 00:45:24.000000', 'temperatura', 96.0000, 'ºC'),
	(30281, 112, '2015-01-15 00:45:25.000000', 'temperatura', 670.0000, 'ºC'),
	(30282, 112, '2015-01-15 00:45:26.000000', 'temperatura', 662.0000, 'ºC'),
	(30283, 112, '2015-01-15 00:45:27.000000', 'temperatura', 101.0000, 'ºC'),
	(30284, 112, '2015-01-15 00:45:28.000000', 'temperatura', 918.0000, 'ºC'),
	(30285, 112, '2015-01-15 00:45:29.000000', 'temperatura', 690.0000, 'ºC'),
	(30286, 112, '2015-01-15 00:45:30.000000', 'temperatura', 694.0000, 'ºC'),
	(30287, 112, '2015-01-15 00:45:31.000000', 'temperatura', 200.0000, 'ºC'),
	(30288, 112, '2015-01-15 00:45:32.000000', 'temperatura', 120.0000, 'ºC'),
	(30289, 112, '2015-01-15 00:45:33.000000', 'temperatura', 0.0000, 'ºC'),
	(30290, 112, '2015-01-15 00:45:34.000000', 'temperatura', 841.0000, 'ºC'),
	(30291, 112, '2015-01-15 00:45:35.000000', 'temperatura', 606.0000, 'ºC'),
	(30292, 112, '2015-01-15 00:45:36.000000', 'temperatura', 509.0000, 'ºC'),
	(30293, 112, '2015-01-15 00:45:37.000000', 'temperatura', 726.0000, 'ºC'),
	(30294, 112, '2015-01-15 00:45:38.000000', 'temperatura', 905.0000, 'ºC'),
	(30295, 112, '2015-01-15 00:45:39.000000', 'temperatura', 1147.0000, 'ºC'),
	(30296, 112, '2015-01-15 00:45:40.000000', 'temperatura', 620.0000, 'ºC'),
	(30297, 112, '2015-01-15 00:45:41.000000', 'temperatura', 858.0000, 'ºC'),
	(30298, 112, '2015-01-15 00:45:42.000000', 'temperatura', 34.0000, 'ºC'),
	(30299, 112, '2015-01-15 00:45:43.000000', 'temperatura', 1193.0000, 'ºC'),
	(30300, 112, '2015-01-15 00:45:44.000000', 'temperatura', 1064.0000, 'ºC'),
	(30301, 112, '2015-01-15 00:45:45.000000', 'temperatura', 544.0000, 'ºC'),
	(30302, 112, '2015-01-15 00:45:46.000000', 'temperatura', 727.0000, 'ºC'),
	(30303, 112, '2015-01-15 00:45:47.000000', 'temperatura', 805.0000, 'ºC'),
	(30304, 112, '2015-01-15 00:45:48.000000', 'temperatura', 645.0000, 'ºC'),
	(30305, 112, '2015-01-15 00:45:49.000000', 'temperatura', 810.0000, 'ºC'),
	(30306, 112, '2015-01-15 00:45:50.000000', 'temperatura', 915.0000, 'ºC'),
	(30307, 112, '2015-01-15 00:45:51.000000', 'temperatura', 946.0000, 'ºC'),
	(30308, 112, '2015-01-15 00:45:52.000000', 'temperatura', 785.0000, 'ºC'),
	(30309, 112, '2015-01-15 00:45:53.000000', 'temperatura', 1088.0000, 'ºC'),
	(30310, 112, '2015-01-15 00:45:54.000000', 'temperatura', 687.0000, 'ºC'),
	(30311, 112, '2015-01-15 00:45:55.000000', 'temperatura', 169.0000, 'ºC'),
	(30312, 112, '2015-01-15 00:45:56.000000', 'temperatura', 1186.0000, 'ºC'),
	(30313, 112, '2015-01-15 00:45:57.000000', 'temperatura', 623.0000, 'ºC'),
	(30314, 112, '2015-01-15 00:45:58.000000', 'temperatura', 758.0000, 'ºC'),
	(30315, 112, '2015-01-15 00:45:59.000000', 'temperatura', 721.0000, 'ºC'),
	(30316, 112, '2015-01-15 00:46:00.000000', 'temperatura', 132.0000, 'ºC'),
	(30317, 112, '2015-01-15 00:46:01.000000', 'temperatura', 898.0000, 'ºC'),
	(30318, 112, '2015-01-15 00:46:02.000000', 'temperatura', 492.0000, 'ºC'),
	(30319, 112, '2015-01-15 00:46:03.000000', 'temperatura', 967.0000, 'ºC'),
	(30320, 112, '2015-01-15 00:46:04.000000', 'temperatura', 961.0000, 'ºC'),
	(30321, 112, '2015-01-15 00:46:05.000000', 'temperatura', 704.0000, 'ºC'),
	(30322, 112, '2015-01-15 00:46:06.000000', 'temperatura', 637.0000, 'ºC'),
	(30323, 112, '2015-01-15 00:46:07.000000', 'temperatura', 1075.0000, 'ºC'),
	(30324, 112, '2015-01-15 00:46:08.000000', 'temperatura', 1065.0000, 'ºC'),
	(30325, 112, '2015-01-15 00:46:09.000000', 'temperatura', 901.0000, 'ºC'),
	(30326, 112, '2015-01-15 00:46:10.000000', 'temperatura', 111.0000, 'ºC'),
	(30327, 112, '2015-01-15 00:46:11.000000', 'temperatura', 253.0000, 'ºC'),
	(30328, 112, '2015-01-15 00:46:12.000000', 'temperatura', 931.0000, 'ºC'),
	(30329, 112, '2015-01-15 00:46:13.000000', 'temperatura', 296.0000, 'ºC'),
	(30330, 112, '2015-01-15 00:46:14.000000', 'temperatura', 1088.0000, 'ºC'),
	(30331, 112, '2015-01-15 00:46:15.000000', 'temperatura', 951.0000, 'ºC'),
	(30332, 112, '2015-01-15 00:46:16.000000', 'temperatura', 291.0000, 'ºC'),
	(30333, 112, '2015-01-15 00:46:17.000000', 'temperatura', 1005.0000, 'ºC'),
	(30334, 112, '2015-01-15 00:46:18.000000', 'temperatura', 553.0000, 'ºC'),
	(30335, 112, '2015-01-15 00:46:19.000000', 'temperatura', 949.0000, 'ºC'),
	(30336, 112, '2015-01-15 00:46:20.000000', 'temperatura', 686.0000, 'ºC'),
	(30337, 112, '2015-01-15 00:46:21.000000', 'temperatura', 582.0000, 'ºC'),
	(30338, 112, '2015-01-15 00:46:22.000000', 'temperatura', 856.0000, 'ºC'),
	(30339, 112, '2015-01-15 00:46:23.000000', 'temperatura', 132.0000, 'ºC'),
	(30340, 112, '2015-01-15 00:46:24.000000', 'temperatura', 492.0000, 'ºC'),
	(30341, 112, '2015-01-15 00:46:25.000000', 'temperatura', 865.0000, 'ºC'),
	(30342, 112, '2015-01-15 00:46:26.000000', 'temperatura', 451.0000, 'ºC'),
	(30343, 112, '2015-01-15 00:46:27.000000', 'temperatura', 858.0000, 'ºC'),
	(30344, 112, '2015-01-15 00:46:28.000000', 'temperatura', 538.0000, 'ºC'),
	(30345, 112, '2015-01-15 00:46:29.000000', 'temperatura', 116.0000, 'ºC'),
	(30346, 112, '2015-01-15 00:46:30.000000', 'temperatura', 169.0000, 'ºC'),
	(30347, 112, '2015-01-15 00:46:31.000000', 'temperatura', 497.0000, 'ºC'),
	(30348, 112, '2015-01-15 00:46:32.000000', 'temperatura', 778.0000, 'ºC'),
	(30349, 112, '2015-01-15 00:46:33.000000', 'temperatura', 0.0000, 'ºC'),
	(30350, 112, '2015-01-15 00:46:34.000000', 'temperatura', 64.0000, 'ºC'),
	(30351, 112, '2015-01-15 00:46:35.000000', 'temperatura', 322.0000, 'ºC'),
	(30352, 112, '2015-01-15 00:46:36.000000', 'temperatura', 218.0000, 'ºC'),
	(30353, 112, '2015-01-15 00:46:37.000000', 'temperatura', 126.0000, 'ºC'),
	(30354, 112, '2015-01-15 00:46:38.000000', 'temperatura', 1176.0000, 'ºC'),
	(30355, 112, '2015-01-15 00:46:39.000000', 'temperatura', 703.0000, 'ºC'),
	(30356, 112, '2015-01-15 00:46:40.000000', 'temperatura', 1186.0000, 'ºC'),
	(30357, 112, '2015-01-15 00:46:41.000000', 'temperatura', 222.0000, 'ºC'),
	(30358, 112, '2015-01-15 00:46:42.000000', 'temperatura', 1154.0000, 'ºC'),
	(30359, 112, '2015-01-15 00:46:43.000000', 'temperatura', 303.0000, 'ºC'),
	(30360, 112, '2015-01-15 00:46:44.000000', 'temperatura', 454.0000, 'ºC'),
	(30361, 112, '2015-01-15 00:46:45.000000', 'temperatura', 163.0000, 'ºC'),
	(30362, 112, '2015-01-15 00:46:46.000000', 'temperatura', 654.0000, 'ºC'),
	(30363, 112, '2015-01-15 00:46:47.000000', 'temperatura', 382.0000, 'ºC'),
	(30364, 112, '2015-01-15 00:46:48.000000', 'temperatura', 1148.0000, 'ºC'),
	(30365, 112, '2015-01-15 00:46:49.000000', 'temperatura', 994.0000, 'ºC'),
	(30366, 112, '2015-01-15 00:46:50.000000', 'temperatura', 328.0000, 'ºC'),
	(30367, 112, '2015-01-15 00:46:51.000000', 'temperatura', 1057.0000, 'ºC'),
	(30368, 112, '2015-01-15 00:46:52.000000', 'temperatura', 701.0000, 'ºC'),
	(30369, 112, '2015-01-15 00:46:53.000000', 'temperatura', 335.0000, 'ºC'),
	(30370, 112, '2015-01-15 00:46:54.000000', 'temperatura', 772.0000, 'ºC'),
	(30371, 112, '2015-01-15 00:46:55.000000', 'temperatura', 456.0000, 'ºC'),
	(30372, 112, '2015-01-15 00:46:56.000000', 'temperatura', 1163.0000, 'ºC'),
	(30373, 112, '2015-01-15 00:46:57.000000', 'temperatura', 848.0000, 'ºC'),
	(30374, 112, '2015-01-15 00:46:58.000000', 'temperatura', 752.0000, 'ºC'),
	(30375, 112, '2015-01-15 00:46:59.000000', 'temperatura', 17.0000, 'ºC'),
	(30376, 112, '2015-01-15 00:47:00.000000', 'temperatura', 228.0000, 'ºC'),
	(30377, 112, '2015-01-15 00:47:01.000000', 'temperatura', 1092.0000, 'ºC'),
	(30378, 112, '2015-01-15 00:47:02.000000', 'temperatura', 1175.0000, 'ºC'),
	(30379, 112, '2015-01-15 00:47:03.000000', 'temperatura', 201.0000, 'ºC'),
	(30380, 112, '2015-01-15 00:47:04.000000', 'temperatura', 1079.0000, 'ºC'),
	(30381, 112, '2015-01-15 00:47:05.000000', 'temperatura', 1191.0000, 'ºC'),
	(30382, 112, '2015-01-15 00:47:06.000000', 'temperatura', 320.0000, 'ºC'),
	(30383, 112, '2015-01-15 00:47:07.000000', 'temperatura', 426.0000, 'ºC'),
	(30384, 112, '2015-01-15 00:47:08.000000', 'temperatura', 1171.0000, 'ºC'),
	(30385, 112, '2015-01-15 00:47:09.000000', 'temperatura', 978.0000, 'ºC'),
	(30386, 112, '2015-01-15 00:47:10.000000', 'temperatura', 177.0000, 'ºC'),
	(30387, 112, '2015-01-15 00:47:11.000000', 'temperatura', 350.0000, 'ºC'),
	(30388, 112, '2015-01-15 00:47:12.000000', 'temperatura', 22.0000, 'ºC'),
	(30389, 112, '2015-01-15 00:47:13.000000', 'temperatura', 260.0000, 'ºC'),
	(30390, 112, '2015-01-15 00:47:14.000000', 'temperatura', 36.0000, 'ºC'),
	(30391, 112, '2015-01-15 00:47:15.000000', 'temperatura', 597.0000, 'ºC'),
	(30392, 112, '2015-01-15 00:47:16.000000', 'temperatura', 480.0000, 'ºC'),
	(30393, 112, '2015-01-15 00:47:17.000000', 'temperatura', 609.0000, 'ºC'),
	(30394, 112, '2015-01-15 00:47:18.000000', 'temperatura', 407.0000, 'ºC'),
	(30395, 112, '2015-01-15 00:47:19.000000', 'temperatura', 208.0000, 'ºC'),
	(30396, 112, '2015-01-15 00:47:20.000000', 'temperatura', 1018.0000, 'ºC'),
	(30397, 112, '2015-01-15 00:47:21.000000', 'temperatura', 869.0000, 'ºC'),
	(30398, 112, '2015-01-15 00:47:22.000000', 'temperatura', 90.0000, 'ºC'),
	(30399, 112, '2015-01-15 00:47:23.000000', 'temperatura', 246.0000, 'ºC'),
	(30400, 112, '2015-01-15 00:47:24.000000', 'temperatura', 957.0000, 'ºC'),
	(30401, 112, '2015-01-15 00:47:25.000000', 'temperatura', 448.0000, 'ºC'),
	(30402, 112, '2015-01-15 00:47:26.000000', 'temperatura', 569.0000, 'ºC'),
	(30403, 112, '2015-01-15 00:47:27.000000', 'temperatura', 304.0000, 'ºC'),
	(30404, 112, '2015-01-15 00:47:28.000000', 'temperatura', 1011.0000, 'ºC'),
	(30405, 112, '2015-01-15 00:47:29.000000', 'temperatura', 545.0000, 'ºC'),
	(30406, 112, '2015-01-15 00:47:30.000000', 'temperatura', 894.0000, 'ºC'),
	(30407, 112, '2015-01-15 00:47:31.000000', 'temperatura', 433.0000, 'ºC'),
	(30408, 112, '2015-01-15 00:47:32.000000', 'temperatura', 685.0000, 'ºC'),
	(30409, 112, '2015-01-15 00:47:33.000000', 'temperatura', 925.0000, 'ºC'),
	(30410, 112, '2015-01-15 00:47:34.000000', 'temperatura', 172.0000, 'ºC'),
	(30411, 112, '2015-01-15 00:47:35.000000', 'temperatura', 485.0000, 'ºC'),
	(30412, 112, '2015-01-15 00:47:36.000000', 'temperatura', 710.0000, 'ºC'),
	(30413, 112, '2015-01-15 00:47:37.000000', 'temperatura', 895.0000, 'ºC'),
	(30414, 112, '2015-01-15 00:47:38.000000', 'temperatura', 1146.0000, 'ºC'),
	(30415, 112, '2015-01-15 00:47:39.000000', 'temperatura', 644.0000, 'ºC'),
	(30416, 112, '2015-01-15 00:47:40.000000', 'temperatura', 981.0000, 'ºC'),
	(30417, 112, '2015-01-15 00:47:41.000000', 'temperatura', 577.0000, 'ºC'),
	(30418, 112, '2015-01-15 00:47:42.000000', 'temperatura', 1141.0000, 'ºC'),
	(30419, 112, '2015-01-15 00:47:43.000000', 'temperatura', 373.0000, 'ºC'),
	(30420, 112, '2015-01-15 00:47:44.000000', 'temperatura', 844.0000, 'ºC'),
	(30421, 112, '2015-01-15 00:47:45.000000', 'temperatura', 699.0000, 'ºC'),
	(30422, 112, '2015-01-15 00:47:46.000000', 'temperatura', 966.0000, 'ºC'),
	(30423, 112, '2015-01-15 00:47:47.000000', 'temperatura', 332.0000, 'ºC'),
	(30424, 112, '2015-01-15 00:47:48.000000', 'temperatura', 1162.0000, 'ºC'),
	(30425, 112, '2015-01-15 00:47:49.000000', 'temperatura', 15.0000, 'ºC'),
	(30426, 112, '2015-01-15 00:47:50.000000', 'temperatura', 188.0000, 'ºC'),
	(30427, 112, '2015-01-15 00:47:51.000000', 'temperatura', 895.0000, 'ºC'),
	(30428, 112, '2015-01-15 00:47:52.000000', 'temperatura', 312.0000, 'ºC'),
	(30429, 112, '2015-01-15 00:47:53.000000', 'temperatura', 75.0000, 'ºC'),
	(30430, 112, '2015-01-15 00:47:54.000000', 'temperatura', 640.0000, 'ºC'),
	(30431, 112, '2015-01-15 00:47:55.000000', 'temperatura', 574.0000, 'ºC'),
	(30432, 112, '2015-01-15 00:47:56.000000', 'temperatura', 953.0000, 'ºC'),
	(30433, 112, '2015-01-15 00:47:57.000000', 'temperatura', 640.0000, 'ºC'),
	(30434, 112, '2015-01-15 00:47:58.000000', 'temperatura', 345.0000, 'ºC'),
	(30435, 112, '2015-01-15 00:47:59.000000', 'temperatura', 1006.0000, 'ºC'),
	(30436, 112, '2015-01-15 00:48:00.000000', 'temperatura', 395.0000, 'ºC'),
	(30437, 112, '2015-01-15 00:48:01.000000', 'temperatura', 156.0000, 'ºC'),
	(30438, 112, '2015-01-15 00:48:02.000000', 'temperatura', 796.0000, 'ºC'),
	(30439, 112, '2015-01-15 00:48:03.000000', 'temperatura', 1112.0000, 'ºC'),
	(30440, 112, '2015-01-15 00:48:04.000000', 'temperatura', 771.0000, 'ºC'),
	(30441, 112, '2015-01-15 00:48:05.000000', 'temperatura', 522.0000, 'ºC'),
	(30442, 112, '2015-01-15 00:48:06.000000', 'temperatura', 298.0000, 'ºC'),
	(30443, 112, '2015-01-15 00:48:07.000000', 'temperatura', 1125.0000, 'ºC'),
	(30444, 112, '2015-01-15 00:48:08.000000', 'temperatura', 1132.0000, 'ºC'),
	(30445, 112, '2015-01-15 00:48:09.000000', 'temperatura', 1084.0000, 'ºC'),
	(30446, 112, '2015-01-15 00:48:10.000000', 'temperatura', 826.0000, 'ºC'),
	(30447, 112, '2015-01-15 00:48:11.000000', 'temperatura', 879.0000, 'ºC'),
	(30448, 112, '2015-01-15 00:48:12.000000', 'temperatura', 717.0000, 'ºC'),
	(30449, 112, '2015-01-15 00:48:13.000000', 'temperatura', 948.0000, 'ºC'),
	(30450, 112, '2015-01-15 00:48:14.000000', 'temperatura', 191.0000, 'ºC'),
	(30451, 112, '2015-01-15 00:48:15.000000', 'temperatura', 509.0000, 'ºC'),
	(30452, 112, '2015-01-15 00:48:16.000000', 'temperatura', 772.0000, 'ºC'),
	(30453, 112, '2015-01-15 00:48:17.000000', 'temperatura', 1135.0000, 'ºC'),
	(30454, 112, '2015-01-15 00:48:18.000000', 'temperatura', 959.0000, 'ºC'),
	(30455, 112, '2015-01-15 00:48:19.000000', 'temperatura', 189.0000, 'ºC'),
	(30456, 112, '2015-01-15 00:48:20.000000', 'temperatura', 469.0000, 'ºC'),
	(30457, 112, '2015-01-15 00:48:21.000000', 'temperatura', 579.0000, 'ºC'),
	(30458, 112, '2015-01-15 00:48:22.000000', 'temperatura', 289.0000, 'ºC'),
	(30459, 112, '2015-01-15 00:48:23.000000', 'temperatura', 907.0000, 'ºC'),
	(30460, 112, '2015-01-15 00:48:24.000000', 'temperatura', 67.0000, 'ºC'),
	(30461, 112, '2015-01-15 00:48:25.000000', 'temperatura', 17.0000, 'ºC'),
	(30462, 112, '2015-01-15 00:48:26.000000', 'temperatura', 1085.0000, 'ºC'),
	(30463, 112, '2015-01-15 00:48:27.000000', 'temperatura', 575.0000, 'ºC'),
	(30464, 112, '2015-01-15 00:48:28.000000', 'temperatura', 818.0000, 'ºC'),
	(30465, 112, '2015-01-15 00:48:29.000000', 'temperatura', 1167.0000, 'ºC'),
	(30466, 112, '2015-01-15 00:48:30.000000', 'temperatura', 982.0000, 'ºC'),
	(30467, 112, '2015-01-15 00:48:31.000000', 'temperatura', 207.0000, 'ºC'),
	(30468, 112, '2015-01-15 00:48:32.000000', 'temperatura', 492.0000, 'ºC'),
	(30469, 112, '2015-01-15 00:48:33.000000', 'temperatura', 637.0000, 'ºC'),
	(30470, 112, '2015-01-15 00:48:34.000000', 'temperatura', 513.0000, 'ºC'),
	(30471, 112, '2015-01-15 00:48:35.000000', 'temperatura', 651.0000, 'ºC'),
	(30472, 112, '2015-01-15 00:48:36.000000', 'temperatura', 519.0000, 'ºC'),
	(30473, 112, '2015-01-15 00:48:37.000000', 'temperatura', 640.0000, 'ºC'),
	(30474, 112, '2015-01-15 00:48:38.000000', 'temperatura', 443.0000, 'ºC'),
	(30475, 112, '2015-01-15 00:48:39.000000', 'temperatura', 298.0000, 'ºC'),
	(30476, 112, '2015-01-15 00:48:40.000000', 'temperatura', 159.0000, 'ºC'),
	(30477, 112, '2015-01-15 00:48:41.000000', 'temperatura', 1101.0000, 'ºC'),
	(30478, 112, '2015-01-15 00:48:42.000000', 'temperatura', 228.0000, 'ºC'),
	(30479, 112, '2015-01-15 00:48:43.000000', 'temperatura', 240.0000, 'ºC'),
	(30480, 112, '2015-01-15 00:48:44.000000', 'temperatura', 515.0000, 'ºC'),
	(30481, 112, '2015-01-15 00:48:45.000000', 'temperatura', 655.0000, 'ºC'),
	(30482, 112, '2015-01-15 00:48:46.000000', 'temperatura', 533.0000, 'ºC'),
	(30483, 112, '2015-01-15 00:48:47.000000', 'temperatura', 698.0000, 'ºC'),
	(30484, 112, '2015-01-15 00:48:48.000000', 'temperatura', 693.0000, 'ºC'),
	(30485, 112, '2015-01-15 00:48:49.000000', 'temperatura', 171.0000, 'ºC'),
	(30486, 112, '2015-01-15 00:48:50.000000', 'temperatura', 1177.0000, 'ºC'),
	(30487, 112, '2015-01-15 00:48:51.000000', 'temperatura', 571.0000, 'ºC'),
	(30488, 112, '2015-01-15 00:48:52.000000', 'temperatura', 525.0000, 'ºC'),
	(30489, 112, '2015-01-15 00:48:53.000000', 'temperatura', 913.0000, 'ºC'),
	(30490, 112, '2015-01-15 00:48:54.000000', 'temperatura', 589.0000, 'ºC'),
	(30491, 112, '2015-01-15 00:48:55.000000', 'temperatura', 208.0000, 'ºC'),
	(30492, 112, '2015-01-15 00:48:56.000000', 'temperatura', 475.0000, 'ºC'),
	(30493, 112, '2015-01-15 00:48:57.000000', 'temperatura', 549.0000, 'ºC'),
	(30494, 112, '2015-01-15 00:48:58.000000', 'temperatura', 121.0000, 'ºC'),
	(30495, 112, '2015-01-15 00:48:59.000000', 'temperatura', 157.0000, 'ºC'),
	(30496, 112, '2015-01-15 00:49:00.000000', 'temperatura', 425.0000, 'ºC'),
	(30497, 112, '2015-01-15 00:49:01.000000', 'temperatura', 455.0000, 'ºC'),
	(30498, 112, '2015-01-15 00:49:02.000000', 'temperatura', 1001.0000, 'ºC'),
	(30499, 112, '2015-01-15 00:49:03.000000', 'temperatura', 39.0000, 'ºC'),
	(30500, 112, '2015-01-15 00:49:04.000000', 'temperatura', 794.0000, 'ºC'),
	(30501, 112, '2015-01-15 00:49:05.000000', 'temperatura', 251.0000, 'ºC'),
	(30502, 112, '2015-01-15 00:49:06.000000', 'temperatura', 74.0000, 'ºC'),
	(30503, 112, '2015-01-15 00:49:07.000000', 'temperatura', 820.0000, 'ºC'),
	(30504, 112, '2015-01-15 00:49:08.000000', 'temperatura', 277.0000, 'ºC'),
	(30505, 112, '2015-01-15 00:49:09.000000', 'temperatura', 125.0000, 'ºC'),
	(30506, 112, '2015-01-15 00:49:10.000000', 'temperatura', 996.0000, 'ºC'),
	(30507, 112, '2015-01-15 00:49:11.000000', 'temperatura', 1006.0000, 'ºC'),
	(30508, 112, '2015-01-15 00:49:12.000000', 'temperatura', 844.0000, 'ºC'),
	(30509, 112, '2015-01-15 00:49:13.000000', 'temperatura', 1199.0000, 'ºC'),
	(30510, 112, '2015-01-15 00:49:14.000000', 'temperatura', 1064.0000, 'ºC'),
	(30511, 112, '2015-01-15 00:49:15.000000', 'temperatura', 522.0000, 'ºC'),
	(30512, 112, '2015-01-15 00:49:16.000000', 'temperatura', 620.0000, 'ºC'),
	(30513, 112, '2015-01-15 00:49:17.000000', 'temperatura', 335.0000, 'ºC'),
	(30514, 112, '2015-01-15 00:49:18.000000', 'temperatura', 1016.0000, 'ºC'),
	(30515, 112, '2015-01-15 00:49:19.000000', 'temperatura', 474.0000, 'ºC'),
	(30516, 112, '2015-01-15 00:49:20.000000', 'temperatura', 521.0000, 'ºC'),
	(30517, 112, '2015-01-15 00:49:21.000000', 'temperatura', 1186.0000, 'ºC'),
	(30518, 112, '2015-01-15 00:49:22.000000', 'temperatura', 767.0000, 'ºC'),
	(30519, 112, '2015-01-15 00:49:23.000000', 'temperatura', 276.0000, 'ºC'),
	(30520, 112, '2015-01-15 00:49:24.000000', 'temperatura', 282.0000, 'ºC'),
	(30521, 112, '2015-01-15 00:49:25.000000', 'temperatura', 581.0000, 'ºC'),
	(30522, 112, '2015-01-15 00:49:26.000000', 'temperatura', 861.0000, 'ºC'),
	(30523, 112, '2015-01-15 00:49:27.000000', 'temperatura', 161.0000, 'ºC'),
	(30524, 112, '2015-01-15 00:49:28.000000', 'temperatura', 624.0000, 'ºC'),
	(30525, 112, '2015-01-15 00:49:29.000000', 'temperatura', 236.0000, 'ºC'),
	(30526, 112, '2015-01-15 00:49:30.000000', 'temperatura', 508.0000, 'ºC'),
	(30527, 112, '2015-01-15 00:49:31.000000', 'temperatura', 634.0000, 'ºC'),
	(30528, 112, '2015-01-15 00:49:32.000000', 'temperatura', 447.0000, 'ºC'),
	(30529, 112, '2015-01-15 00:49:33.000000', 'temperatura', 332.0000, 'ºC'),
	(30530, 112, '2015-01-15 00:49:34.000000', 'temperatura', 318.0000, 'ºC'),
	(30531, 112, '2015-01-15 00:49:35.000000', 'temperatura', 598.0000, 'ºC'),
	(30532, 112, '2015-01-15 00:49:36.000000', 'temperatura', 835.0000, 'ºC'),
	(30533, 112, '2015-01-15 00:49:37.000000', 'temperatura', 1180.0000, 'ºC'),
	(30534, 112, '2015-01-15 00:49:38.000000', 'temperatura', 996.0000, 'ºC'),
	(30535, 112, '2015-01-15 00:49:39.000000', 'temperatura', 240.0000, 'ºC'),
	(30536, 112, '2015-01-15 00:49:40.000000', 'temperatura', 614.0000, 'ºC'),
	(30537, 112, '2015-01-15 00:49:41.000000', 'temperatura', 1151.0000, 'ºC'),
	(30538, 112, '2015-01-15 00:49:42.000000', 'temperatura', 312.0000, 'ºC'),
	(30539, 112, '2015-01-15 00:49:43.000000', 'temperatura', 507.0000, 'ºC'),
	(30540, 112, '2015-01-15 00:49:44.000000', 'temperatura', 399.0000, 'ºC'),
	(30541, 112, '2015-01-15 00:49:45.000000', 'temperatura', 474.0000, 'ºC'),
	(30542, 112, '2015-01-15 00:49:46.000000', 'temperatura', 1176.0000, 'ºC'),
	(30543, 112, '2015-01-15 00:49:47.000000', 'temperatura', 859.0000, 'ºC'),
	(30544, 112, '2015-01-15 00:49:48.000000', 'temperatura', 768.0000, 'ºC'),
	(30545, 112, '2015-01-15 00:49:49.000000', 'temperatura', 64.0000, 'ºC'),
	(30546, 112, '2015-01-15 00:49:50.000000', 'temperatura', 415.0000, 'ºC'),
	(30547, 112, '2015-01-15 00:49:51.000000', 'temperatura', 684.0000, 'ºC'),
	(30548, 112, '2015-01-15 00:49:52.000000', 'temperatura', 975.0000, 'ºC'),
	(30549, 112, '2015-01-15 00:49:53.000000', 'temperatura', 423.0000, 'ºC'),
	(30550, 112, '2015-01-15 00:49:54.000000', 'temperatura', 391.0000, 'ºC'),
	(30551, 112, '2015-01-15 00:49:55.000000', 'temperatura', 686.0000, 'ºC'),
	(30552, 112, '2015-01-15 00:49:56.000000', 'temperatura', 1056.0000, 'ºC'),
	(30553, 112, '2015-01-15 00:49:57.000000', 'temperatura', 824.0000, 'ºC'),
	(30554, 112, '2015-01-15 00:49:58.000000', 'temperatura', 951.0000, 'ºC'),
	(30555, 112, '2015-01-15 00:49:59.000000', 'temperatura', 1086.0000, 'ºC'),
	(30556, 112, '2015-01-15 00:50:00.000000', 'temperatura', 176.0000, 'ºC'),
	(30557, 112, '2015-01-15 00:50:01.000000', 'temperatura', 23.0000, 'ºC'),
	(30558, 112, '2015-01-15 00:50:02.000000', 'temperatura', 789.0000, 'ºC'),
	(30559, 112, '2015-01-15 00:50:03.000000', 'temperatura', 274.0000, 'ºC'),
	(30560, 112, '2015-01-15 00:50:04.000000', 'temperatura', 204.0000, 'ºC'),
	(30561, 112, '2015-01-15 00:50:05.000000', 'temperatura', 201.0000, 'ºC'),
	(30562, 112, '2015-01-15 00:50:06.000000', 'temperatura', 391.0000, 'ºC'),
	(30563, 112, '2015-01-15 00:50:07.000000', 'temperatura', 152.0000, 'ºC'),
	(30564, 112, '2015-01-15 00:50:08.000000', 'temperatura', 787.0000, 'ºC'),
	(30565, 112, '2015-01-15 00:50:09.000000', 'temperatura', 1080.0000, 'ºC'),
	(30566, 112, '2015-01-15 00:50:10.000000', 'temperatura', 640.0000, 'ºC'),
	(30567, 112, '2015-01-15 00:50:11.000000', 'temperatura', 1162.0000, 'ºC'),
	(30568, 112, '2015-01-15 00:50:12.000000', 'temperatura', 291.0000, 'ºC'),
	(30569, 112, '2015-01-15 00:50:13.000000', 'temperatura', 369.0000, 'ºC'),
	(30570, 112, '2015-01-15 00:50:14.000000', 'temperatura', 972.0000, 'ºC'),
	(30571, 112, '2015-01-15 00:50:15.000000', 'temperatura', 154.0000, 'ºC'),
	(30572, 112, '2015-01-15 00:50:16.000000', 'temperatura', 256.0000, 'ºC'),
	(30573, 112, '2015-01-15 00:50:17.000000', 'temperatura', 817.0000, 'ºC'),
	(30574, 112, '2015-01-15 00:50:18.000000', 'temperatura', 918.0000, 'ºC'),
	(30575, 112, '2015-01-15 00:50:19.000000', 'temperatura', 939.0000, 'ºC'),
	(30576, 112, '2015-01-15 00:50:20.000000', 'temperatura', 740.0000, 'ºC'),
	(30577, 112, '2015-01-15 00:50:21.000000', 'temperatura', 883.0000, 'ºC'),
	(30578, 112, '2015-01-15 00:50:22.000000', 'temperatura', 997.0000, 'ºC'),
	(30579, 112, '2015-01-15 00:50:23.000000', 'temperatura', 1134.0000, 'ºC'),
	(30580, 112, '2015-01-15 00:50:24.000000', 'temperatura', 282.0000, 'ºC'),
	(30581, 112, '2015-01-15 00:50:25.000000', 'temperatura', 407.0000, 'ºC'),
	(30582, 112, '2015-01-15 00:50:26.000000', 'temperatura', 1191.0000, 'ºC'),
	(30583, 112, '2015-01-15 00:50:27.000000', 'temperatura', 1134.0000, 'ºC'),
	(30584, 112, '2015-01-15 00:50:28.000000', 'temperatura', 899.0000, 'ºC'),
	(30585, 112, '2015-01-15 00:50:29.000000', 'temperatura', 1094.0000, 'ºC'),
	(30586, 112, '2015-01-15 00:50:30.000000', 'temperatura', 374.0000, 'ºC'),
	(30587, 112, '2015-01-15 00:50:31.000000', 'temperatura', 987.0000, 'ºC'),
	(30588, 112, '2015-01-15 00:50:32.000000', 'temperatura', 216.0000, 'ºC'),
	(30589, 112, '2015-01-15 00:50:33.000000', 'temperatura', 517.0000, 'ºC'),
	(30590, 112, '2015-01-15 00:50:34.000000', 'temperatura', 738.0000, 'ºC'),
	(30591, 112, '2015-01-15 00:50:35.000000', 'temperatura', 938.0000, 'ºC'),
	(30592, 112, '2015-01-15 00:50:36.000000', 'temperatura', 76.0000, 'ºC'),
	(30593, 112, '2015-01-15 00:50:37.000000', 'temperatura', 1166.0000, 'ºC'),
	(30594, 112, '2015-01-15 00:50:38.000000', 'temperatura', 803.0000, 'ºC'),
	(30595, 112, '2015-01-15 00:50:39.000000', 'temperatura', 518.0000, 'ºC'),
	(30596, 112, '2015-01-15 00:50:40.000000', 'temperatura', 183.0000, 'ºC'),
	(30597, 112, '2015-01-15 00:50:41.000000', 'temperatura', 561.0000, 'ºC'),
	(30598, 112, '2015-01-15 00:50:42.000000', 'temperatura', 1058.0000, 'ºC'),
	(30599, 112, '2015-01-15 00:50:43.000000', 'temperatura', 5.0000, 'ºC'),
	(30600, 112, '2015-01-15 00:50:44.000000', 'temperatura', 453.0000, 'ºC'),
	(30601, 112, '2015-01-15 00:50:45.000000', 'temperatura', 1049.0000, 'ºC'),
	(30602, 112, '2015-01-15 00:50:46.000000', 'temperatura', 287.0000, 'ºC'),
	(30603, 112, '2015-01-15 00:50:47.000000', 'temperatura', 689.0000, 'ºC'),
	(30604, 112, '2015-01-15 00:50:48.000000', 'temperatura', 186.0000, 'ºC'),
	(30605, 112, '2015-01-15 00:50:49.000000', 'temperatura', 63.0000, 'ºC'),
	(30606, 112, '2015-01-15 00:50:50.000000', 'temperatura', 957.0000, 'ºC'),
	(30607, 112, '2015-01-15 00:50:51.000000', 'temperatura', 997.0000, 'ºC'),
	(30608, 112, '2015-01-15 00:50:52.000000', 'temperatura', 913.0000, 'ºC'),
	(30609, 112, '2015-01-15 00:50:53.000000', 'temperatura', 374.0000, 'ºC'),
	(30610, 112, '2015-01-15 00:50:54.000000', 'temperatura', 334.0000, 'ºC'),
	(30611, 112, '2015-01-15 00:50:55.000000', 'temperatura', 548.0000, 'ºC'),
	(30612, 112, '2015-01-15 00:50:56.000000', 'temperatura', 538.0000, 'ºC'),
	(30613, 112, '2015-01-15 00:50:57.000000', 'temperatura', 1045.0000, 'ºC'),
	(30614, 112, '2015-01-15 00:50:58.000000', 'temperatura', 14.0000, 'ºC'),
	(30615, 112, '2015-01-15 00:50:59.000000', 'temperatura', 536.0000, 'ºC'),
	(30616, 112, '2015-01-15 00:51:00.000000', 'temperatura', 236.0000, 'ºC'),
	(30617, 112, '2015-01-15 00:51:01.000000', 'temperatura', 774.0000, 'ºC'),
	(30618, 112, '2015-01-15 00:51:02.000000', 'temperatura', 764.0000, 'ºC'),
	(30619, 112, '2015-01-15 00:51:03.000000', 'temperatura', 298.0000, 'ºC'),
	(30620, 112, '2015-01-15 00:51:04.000000', 'temperatura', 397.0000, 'ºC'),
	(30621, 112, '2015-01-15 00:51:05.000000', 'temperatura', 1093.0000, 'ºC'),
	(30622, 112, '2015-01-15 00:51:06.000000', 'temperatura', 672.0000, 'ºC'),
	(30623, 112, '2015-01-15 00:51:07.000000', 'temperatura', 84.0000, 'ºC'),
	(30624, 112, '2015-01-15 00:51:08.000000', 'temperatura', 802.0000, 'ºC'),
	(30625, 112, '2015-01-15 00:51:09.000000', 'temperatura', 159.0000, 'ºC'),
	(30626, 112, '2015-01-15 00:51:10.000000', 'temperatura', 789.0000, 'ºC'),
	(30627, 112, '2015-01-15 00:51:11.000000', 'temperatura', 1070.0000, 'ºC'),
	(30628, 112, '2015-01-15 00:51:12.000000', 'temperatura', 582.0000, 'ºC'),
	(30629, 112, '2015-01-15 00:51:13.000000', 'temperatura', 903.0000, 'ºC'),
	(30630, 112, '2015-01-15 00:51:14.000000', 'temperatura', 369.0000, 'ºC'),
	(30631, 112, '2015-01-15 00:51:15.000000', 'temperatura', 336.0000, 'ºC'),
	(30632, 112, '2015-01-15 00:51:16.000000', 'temperatura', 574.0000, 'ºC'),
	(30633, 112, '2015-01-15 00:51:17.000000', 'temperatura', 663.0000, 'ºC'),
	(30634, 112, '2015-01-15 00:51:18.000000', 'temperatura', 392.0000, 'ºC'),
	(30635, 112, '2015-01-15 00:51:19.000000', 'temperatura', 1172.0000, 'ºC'),
	(30636, 112, '2015-01-15 00:51:20.000000', 'temperatura', 1086.0000, 'ºC'),
	(30637, 112, '2015-01-15 00:51:21.000000', 'temperatura', 714.0000, 'ºC'),
	(30638, 112, '2015-01-15 00:51:22.000000', 'temperatura', 311.0000, 'ºC'),
	(30639, 112, '2015-01-15 00:51:23.000000', 'temperatura', 616.0000, 'ºC'),
	(30640, 112, '2015-01-15 00:51:24.000000', 'temperatura', 945.0000, 'ºC'),
	(30641, 112, '2015-01-15 00:51:25.000000', 'temperatura', 480.0000, 'ºC'),
	(30642, 112, '2015-01-15 00:51:26.000000', 'temperatura', 765.0000, 'ºC'),
	(30643, 112, '2015-01-15 00:51:27.000000', 'temperatura', 1183.0000, 'ºC'),
	(30644, 112, '2015-01-15 00:51:28.000000', 'temperatura', 22.0000, 'ºC'),
	(30645, 112, '2015-01-15 00:51:29.000000', 'temperatura', 160.0000, 'ºC'),
	(30646, 112, '2015-01-15 00:51:30.000000', 'temperatura', 736.0000, 'ºC'),
	(30647, 112, '2015-01-15 00:51:31.000000', 'temperatura', 802.0000, 'ºC'),
	(30648, 112, '2015-01-15 00:51:32.000000', 'temperatura', 602.0000, 'ºC'),
	(30649, 112, '2015-01-15 00:51:33.000000', 'temperatura', 604.0000, 'ºC'),
	(30650, 112, '2015-01-15 00:51:34.000000', 'temperatura', 14.0000, 'ºC'),
	(30651, 112, '2015-01-15 00:51:35.000000', 'temperatura', 659.0000, 'ºC'),
	(30652, 112, '2015-01-15 00:51:36.000000', 'temperatura', 852.0000, 'ºC'),
	(30653, 112, '2015-01-15 00:51:37.000000', 'temperatura', 1085.0000, 'ºC'),
	(30654, 112, '2015-01-15 00:51:38.000000', 'temperatura', 470.0000, 'ºC'),
	(30655, 112, '2015-01-15 00:51:39.000000', 'temperatura', 296.0000, 'ºC'),
	(30656, 112, '2015-01-15 00:51:40.000000', 'temperatura', 71.0000, 'ºC'),
	(30657, 112, '2015-01-15 00:51:41.000000', 'temperatura', 666.0000, 'ºC'),
	(30658, 112, '2015-01-15 00:51:42.000000', 'temperatura', 719.0000, 'ºC'),
	(30659, 112, '2015-01-15 00:51:43.000000', 'temperatura', 396.0000, 'ºC'),
	(30660, 112, '2015-01-15 00:51:44.000000', 'temperatura', 1024.0000, 'ºC'),
	(30661, 112, '2015-01-15 00:51:45.000000', 'temperatura', 331.0000, 'ºC'),
	(30662, 112, '2015-01-15 00:51:46.000000', 'temperatura', 984.0000, 'ºC'),
	(30663, 112, '2015-01-15 00:51:47.000000', 'temperatura', 327.0000, 'ºC'),
	(30664, 112, '2015-01-15 00:51:48.000000', 'temperatura', 1083.0000, 'ºC'),
	(30665, 112, '2015-01-15 00:51:49.000000', 'temperatura', 836.0000, 'ºC'),
	(30666, 112, '2015-01-15 00:51:50.000000', 'temperatura', 932.0000, 'ºC'),
	(30667, 112, '2015-01-15 00:51:51.000000', 'temperatura', 951.0000, 'ºC'),
	(30668, 112, '2015-01-15 00:51:52.000000', 'temperatura', 760.0000, 'ºC'),
	(30669, 112, '2015-01-15 00:51:53.000000', 'temperatura', 946.0000, 'ºC'),
	(30670, 112, '2015-01-15 00:51:54.000000', 'temperatura', 52.0000, 'ºC'),
	(30671, 112, '2015-01-15 00:51:55.000000', 'temperatura', 1021.0000, 'ºC'),
	(30672, 112, '2015-01-15 00:51:56.000000', 'temperatura', 151.0000, 'ºC'),
	(30673, 112, '2015-01-15 00:51:57.000000', 'temperatura', 92.0000, 'ºC'),
	(30674, 112, '2015-01-15 00:51:58.000000', 'temperatura', 5.0000, 'ºC'),
	(30675, 112, '2015-01-15 00:51:59.000000', 'temperatura', 953.0000, 'ºC'),
	(30676, 112, '2015-01-15 00:52:00.000000', 'temperatura', 1150.0000, 'ºC'),
	(30677, 112, '2015-01-15 00:52:01.000000', 'temperatura', 491.0000, 'ºC'),
	(30678, 112, '2015-01-15 00:52:02.000000', 'temperatura', 206.0000, 'ºC'),
	(30679, 112, '2015-01-15 00:52:03.000000', 'temperatura', 758.0000, 'ºC'),
	(30680, 112, '2015-01-15 00:52:04.000000', 'temperatura', 771.0000, 'ºC'),
	(30681, 112, '2015-01-15 00:52:05.000000', 'temperatura', 384.0000, 'ºC'),
	(30682, 112, '2015-01-15 00:52:06.000000', 'temperatura', 807.0000, 'ºC'),
	(30683, 112, '2015-01-15 00:52:07.000000', 'temperatura', 484.0000, 'ºC'),
	(30684, 112, '2015-01-15 00:52:08.000000', 'temperatura', 0.0000, 'ºC'),
	(30685, 112, '2015-01-15 00:52:09.000000', 'temperatura', 950.0000, 'ºC'),
	(30686, 112, '2015-01-15 00:52:10.000000', 'temperatura', 1148.0000, 'ºC'),
	(30687, 112, '2015-01-15 00:52:11.000000', 'temperatura', 489.0000, 'ºC'),
	(30688, 112, '2015-01-15 00:52:12.000000', 'temperatura', 204.0000, 'ºC'),
	(30689, 112, '2015-01-15 00:52:13.000000', 'temperatura', 754.0000, 'ºC'),
	(30690, 112, '2015-01-15 00:52:14.000000', 'temperatura', 758.0000, 'ºC'),
	(30691, 112, '2015-01-15 00:52:15.000000', 'temperatura', 329.0000, 'ºC'),
	(30692, 112, '2015-01-15 00:52:16.000000', 'temperatura', 571.0000, 'ºC'),
	(30693, 112, '2015-01-15 00:52:17.000000', 'temperatura', 671.0000, 'ºC'),
	(30694, 112, '2015-01-15 00:52:18.000000', 'temperatura', 439.0000, 'ºC'),
	(30695, 112, '2015-01-15 00:52:19.000000', 'temperatura', 183.0000, 'ºC'),
	(30696, 112, '2015-01-15 00:52:20.000000', 'temperatura', 799.0000, 'ºC'),
	(30697, 112, '2015-01-15 00:52:21.000000', 'temperatura', 1045.0000, 'ºC'),
	(30698, 112, '2015-01-15 00:52:22.000000', 'temperatura', 431.0000, 'ºC'),
	(30699, 112, '2015-01-15 00:52:23.000000', 'temperatura', 220.0000, 'ºC'),
	(30700, 112, '2015-01-15 00:52:24.000000', 'temperatura', 1007.0000, 'ºC'),
	(30701, 112, '2015-01-15 00:52:25.000000', 'temperatura', 773.0000, 'ºC'),
	(30702, 112, '2015-01-15 00:52:26.000000', 'temperatura', 848.0000, 'ºC'),
	(30703, 112, '2015-01-15 00:52:27.000000', 'temperatura', 722.0000, 'ºC'),
	(30704, 112, '2015-01-15 00:52:28.000000', 'temperatura', 1066.0000, 'ºC'),
	(30705, 112, '2015-01-15 00:52:29.000000', 'temperatura', 763.0000, 'ºC'),
	(30706, 112, '2015-01-15 00:52:30.000000', 'temperatura', 617.0000, 'ºC'),
	(30707, 112, '2015-01-15 00:52:31.000000', 'temperatura', 796.0000, 'ºC'),
	(30708, 112, '2015-01-15 00:52:32.000000', 'temperatura', 929.0000, 'ºC'),
	(30709, 112, '2015-01-15 00:52:33.000000', 'temperatura', 1061.0000, 'ºC'),
	(30710, 112, '2015-01-15 00:52:34.000000', 'temperatura', 115.0000, 'ºC'),
	(30711, 112, '2015-01-15 00:52:35.000000', 'temperatura', 992.0000, 'ºC'),
	(30712, 112, '2015-01-15 00:52:36.000000', 'temperatura', 1019.0000, 'ºC'),
	(30713, 112, '2015-01-15 00:52:37.000000', 'temperatura', 916.0000, 'ºC'),
	(30714, 112, '2015-01-15 00:52:38.000000', 'temperatura', 327.0000, 'ºC'),
	(30715, 112, '2015-01-15 00:52:39.000000', 'temperatura', 86.0000, 'ºC'),
	(30716, 112, '2015-01-15 00:52:40.000000', 'temperatura', 648.0000, 'ºC'),
	(30717, 112, '2015-01-15 00:52:41.000000', 'temperatura', 585.0000, 'ºC'),
	(30718, 112, '2015-01-15 00:52:42.000000', 'temperatura', 980.0000, 'ºC'),
	(30719, 112, '2015-01-15 00:52:43.000000', 'temperatura', 747.0000, 'ºC'),
	(30720, 112, '2015-01-15 00:52:44.000000', 'temperatura', 795.0000, 'ºC'),
	(30721, 112, '2015-01-15 00:52:45.000000', 'temperatura', 533.0000, 'ºC'),
	(30722, 112, '2015-01-15 00:52:46.000000', 'temperatura', 282.0000, 'ºC'),
	(30723, 112, '2015-01-15 00:52:47.000000', 'temperatura', 1010.0000, 'ºC'),
	(30724, 112, '2015-01-15 00:52:48.000000', 'temperatura', 607.0000, 'ºC'),
	(30725, 112, '2015-01-15 00:52:49.000000', 'temperatura', 3.0000, 'ºC'),
	(30726, 112, '2015-01-15 00:52:50.000000', 'temperatura', 597.0000, 'ºC'),
	(30727, 112, '2015-01-15 00:52:51.000000', 'temperatura', 576.0000, 'ºC'),
	(30728, 112, '2015-01-15 00:52:52.000000', 'temperatura', 1089.0000, 'ºC'),
	(30729, 112, '2015-01-15 00:52:53.000000', 'temperatura', 118.0000, 'ºC'),
	(30730, 112, '2015-01-15 00:52:54.000000', 'temperatura', 922.0000, 'ºC'),
	(30731, 112, '2015-01-15 00:52:55.000000', 'temperatura', 658.0000, 'ºC'),
	(30732, 112, '2015-01-15 00:52:56.000000', 'temperatura', 524.0000, 'ºC'),
	(30733, 112, '2015-01-15 00:52:57.000000', 'temperatura', 645.0000, 'ºC'),
	(30734, 112, '2015-01-15 00:52:58.000000', 'temperatura', 456.0000, 'ºC'),
	(30735, 112, '2015-01-15 00:52:59.000000', 'temperatura', 346.0000, 'ºC'),
	(30736, 112, '2015-01-15 00:53:00.000000', 'temperatura', 359.0000, 'ºC'),
	(30737, 112, '2015-01-15 00:53:01.000000', 'temperatura', 761.0000, 'ºC'),
	(30738, 112, '2015-01-15 00:53:02.000000', 'temperatura', 328.0000, 'ºC'),
	(30739, 112, '2015-01-15 00:53:03.000000', 'temperatura', 558.0000, 'ºC'),
	(30740, 112, '2015-01-15 00:53:04.000000', 'temperatura', 607.0000, 'ºC'),
	(30741, 112, '2015-01-15 00:53:05.000000', 'temperatura', 162.0000, 'ºC'),
	(30742, 112, '2015-01-15 00:53:06.000000', 'temperatura', 188.0000, 'ºC'),
	(30743, 112, '2015-01-15 00:53:07.000000', 'temperatura', 453.0000, 'ºC'),
	(30744, 112, '2015-01-15 00:53:08.000000', 'temperatura', 502.0000, 'ºC'),
	(30745, 112, '2015-01-15 00:53:09.000000', 'temperatura', 1151.0000, 'ºC'),
	(30746, 112, '2015-01-15 00:53:10.000000', 'temperatura', 651.0000, 'ºC'),
	(30747, 112, '2015-01-15 00:53:11.000000', 'temperatura', 1000.0000, 'ºC'),
	(30748, 112, '2015-01-15 00:53:12.000000', 'temperatura', 651.0000, 'ºC'),
	(30749, 112, '2015-01-15 00:53:13.000000', 'temperatura', 253.0000, 'ºC'),
	(30750, 112, '2015-01-15 00:53:14.000000', 'temperatura', 513.0000, 'ºC'),
	(30751, 112, '2015-01-15 00:53:15.000000', 'temperatura', 606.0000, 'ºC'),
	(30752, 112, '2015-01-15 00:53:16.000000', 'temperatura', 290.0000, 'ºC'),
	(30753, 112, '2015-01-15 00:53:17.000000', 'temperatura', 835.0000, 'ºC'),
	(30754, 112, '2015-01-15 00:53:18.000000', 'temperatura', 907.0000, 'ºC'),
	(30755, 112, '2015-01-15 00:53:19.000000', 'temperatura', 827.0000, 'ºC'),
	(30756, 112, '2015-01-15 00:53:20.000000', 'temperatura', 216.0000, 'ºC'),
	(30757, 112, '2015-01-15 00:53:21.000000', 'temperatura', 997.0000, 'ºC'),
	(30758, 112, '2015-01-15 00:53:22.000000', 'temperatura', 741.0000, 'ºC'),
	(30759, 112, '2015-01-15 00:53:23.000000', 'temperatura', 714.0000, 'ºC'),
	(30760, 112, '2015-01-15 00:53:24.000000', 'temperatura', 148.0000, 'ºC'),
	(30761, 112, '2015-01-15 00:53:25.000000', 'temperatura', 997.0000, 'ºC'),
	(30762, 112, '2015-01-15 00:53:26.000000', 'temperatura', 943.0000, 'ºC'),
	(30763, 112, '2015-01-15 00:53:27.000000', 'temperatura', 523.0000, 'ºC'),
	(30764, 112, '2015-01-15 00:53:28.000000', 'temperatura', 986.0000, 'ºC'),
	(30765, 112, '2015-01-15 00:53:29.000000', 'temperatura', 961.0000, 'ºC'),
	(30766, 112, '2015-01-15 00:53:30.000000', 'temperatura', 648.0000, 'ºC'),
	(30767, 112, '2015-01-15 00:53:31.000000', 'temperatura', 360.0000, 'ºC'),
	(30768, 112, '2015-01-15 00:53:32.000000', 'temperatura', 1053.0000, 'ºC'),
	(30769, 112, '2015-01-15 00:53:33.000000', 'temperatura', 588.0000, 'ºC'),
	(30770, 112, '2015-01-15 00:53:34.000000', 'temperatura', 981.0000, 'ºC'),
	(30771, 112, '2015-01-15 00:53:35.000000', 'temperatura', 741.0000, 'ºC'),
	(30772, 112, '2015-01-15 00:53:36.000000', 'temperatura', 761.0000, 'ºC'),
	(30773, 112, '2015-01-15 00:53:37.000000', 'temperatura', 384.0000, 'ºC'),
	(30774, 112, '2015-01-15 00:53:38.000000', 'temperatura', 837.0000, 'ºC'),
	(30775, 112, '2015-01-15 00:53:39.000000', 'temperatura', 634.0000, 'ºC'),
	(30776, 112, '2015-01-15 00:53:40.000000', 'temperatura', 661.0000, 'ºC'),
	(30777, 112, '2015-01-15 00:53:41.000000', 'temperatura', 200.0000, 'ºC'),
	(30778, 112, '2015-01-15 00:53:42.000000', 'temperatura', 220.0000, 'ºC'),
	(30779, 112, '2015-01-15 00:53:43.000000', 'temperatura', 500.0000, 'ºC'),
	(30780, 112, '2015-01-15 00:53:44.000000', 'temperatura', 640.0000, 'ºC'),
	(30781, 112, '2015-01-15 00:53:45.000000', 'temperatura', 502.0000, 'ºC'),
	(30782, 112, '2015-01-15 00:53:46.000000', 'temperatura', 589.0000, 'ºC'),
	(30783, 112, '2015-01-15 00:53:47.000000', 'temperatura', 239.0000, 'ºC'),
	(30784, 112, '2015-01-15 00:53:48.000000', 'temperatura', 631.0000, 'ºC'),
	(30785, 112, '2015-01-15 00:53:49.000000', 'temperatura', 38.0000, 'ºC'),
	(30786, 112, '2015-01-15 00:53:50.000000', 'temperatura', 697.0000, 'ºC'),
	(30787, 112, '2015-01-15 00:53:51.000000', 'temperatura', 973.0000, 'ºC'),
	(30788, 112, '2015-01-15 00:53:52.000000', 'temperatura', 373.0000, 'ºC'),
	(30789, 112, '2015-01-15 00:53:53.000000', 'temperatura', 146.0000, 'ºC'),
	(30790, 112, '2015-01-15 00:53:54.000000', 'temperatura', 810.0000, 'ºC'),
	(30791, 112, '2015-01-15 00:53:55.000000', 'temperatura', 15.0000, 'ºC'),
	(30792, 112, '2015-01-15 00:53:56.000000', 'temperatura', 43.0000, 'ºC'),
	(30793, 112, '2015-01-15 00:53:57.000000', 'temperatura', 174.0000, 'ºC'),
	(30794, 112, '2015-01-15 00:53:58.000000', 'temperatura', 738.0000, 'ºC'),
	(30795, 112, '2015-01-15 00:53:59.000000', 'temperatura', 769.0000, 'ºC'),
	(30796, 112, '2015-01-15 00:54:00.000000', 'temperatura', 432.0000, 'ºC'),
	(30797, 112, '2015-01-15 00:54:01.000000', 'temperatura', 1055.0000, 'ºC'),
	(30798, 112, '2015-01-15 00:54:02.000000', 'temperatura', 377.0000, 'ºC'),
	(30799, 112, '2015-01-15 00:54:03.000000', 'temperatura', 1123.0000, 'ºC'),
	(30800, 112, '2015-01-15 00:54:04.000000', 'temperatura', 882.0000, 'ºC'),
	(30801, 112, '2015-01-15 00:54:05.000000', 'temperatura', 1044.0000, 'ºC'),
	(30802, 112, '2015-01-15 00:54:06.000000', 'temperatura', 173.0000, 'ºC'),
	(30803, 112, '2015-01-15 00:54:07.000000', 'temperatura', 133.0000, 'ºC'),
	(30804, 112, '2015-01-15 00:54:08.000000', 'temperatura', 147.0000, 'ºC'),
	(30805, 112, '2015-01-15 00:54:09.000000', 'temperatura', 337.0000, 'ºC'),
	(30806, 112, '2015-01-15 00:54:10.000000', 'temperatura', 45.0000, 'ºC'),
	(30807, 112, '2015-01-15 00:54:11.000000', 'temperatura', 414.0000, 'ºC'),
	(30808, 112, '2015-01-15 00:54:12.000000', 'temperatura', 735.0000, 'ºC'),
	(30809, 112, '2015-01-15 00:54:13.000000', 'temperatura', 34.0000, 'ºC'),
	(30810, 112, '2015-01-15 00:54:14.000000', 'temperatura', 365.0000, 'ºC'),
	(30811, 112, '2015-01-15 00:54:15.000000', 'temperatura', 525.0000, 'ºC'),
	(30812, 112, '2015-01-15 00:54:16.000000', 'temperatura', 328.0000, 'ºC'),
	(30813, 112, '2015-01-15 00:54:17.000000', 'temperatura', 66.0000, 'ºC'),
	(30814, 112, '2015-01-15 00:54:18.000000', 'temperatura', 547.0000, 'ºC'),
	(30815, 112, '2015-01-15 00:54:19.000000', 'temperatura', 137.0000, 'ºC'),
	(30816, 112, '2015-01-15 00:54:20.000000', 'temperatura', 247.0000, 'ºC'),
	(30817, 112, '2015-01-15 00:54:21.000000', 'temperatura', 821.0000, 'ºC'),
	(30818, 112, '2015-01-15 00:54:22.000000', 'temperatura', 967.0000, 'ºC'),
	(30819, 112, '2015-01-15 00:54:23.000000', 'temperatura', 1171.0000, 'ºC'),
	(30820, 112, '2015-01-15 00:54:24.000000', 'temperatura', 555.0000, 'ºC'),
	(30821, 112, '2015-01-15 00:54:25.000000', 'temperatura', 464.0000, 'ºC'),
	(30822, 112, '2015-01-15 00:54:26.000000', 'temperatura', 655.0000, 'ºC'),
	(30823, 112, '2015-01-15 00:54:27.000000', 'temperatura', 683.0000, 'ºC'),
	(30824, 112, '2015-01-15 00:54:28.000000', 'temperatura', 251.0000, 'ºC'),
	(30825, 112, '2015-01-15 00:54:29.000000', 'temperatura', 405.0000, 'ºC'),
	(30826, 112, '2015-01-15 00:54:30.000000', 'temperatura', 71.0000, 'ºC'),
	(30827, 112, '2015-01-15 00:54:31.000000', 'temperatura', 344.0000, 'ºC'),
	(30828, 112, '2015-01-15 00:54:32.000000', 'temperatura', 304.0000, 'ºC'),
	(30829, 112, '2015-01-15 00:54:33.000000', 'temperatura', 492.0000, 'ºC'),
	(30830, 112, '2015-01-15 00:54:34.000000', 'temperatura', 347.0000, 'ºC'),
	(30831, 112, '2015-01-15 00:54:35.000000', 'temperatura', 257.0000, 'ºC'),
	(30832, 112, '2015-01-15 00:54:36.000000', 'temperatura', 248.0000, 'ºC'),
	(30833, 112, '2015-01-15 00:54:37.000000', 'temperatura', 470.0000, 'ºC'),
	(30834, 112, '2015-01-15 00:54:38.000000', 'temperatura', 405.0000, 'ºC'),
	(30835, 112, '2015-01-15 00:54:39.000000', 'temperatura', 617.0000, 'ºC'),
	(30836, 112, '2015-01-15 00:54:40.000000', 'temperatura', 670.0000, 'ºC'),
	(30837, 112, '2015-01-15 00:54:41.000000', 'temperatura', 298.0000, 'ºC'),
	(30838, 112, '2015-01-15 00:54:42.000000', 'temperatura', 682.0000, 'ºC'),
	(30839, 112, '2015-01-15 00:54:43.000000', 'temperatura', 118.0000, 'ºC'),
	(30840, 112, '2015-01-15 00:54:44.000000', 'temperatura', 944.0000, 'ºC'),
	(30841, 112, '2015-01-15 00:54:45.000000', 'temperatura', 764.0000, 'ºC'),
	(30842, 112, '2015-01-15 00:54:46.000000', 'temperatura', 989.0000, 'ºC'),
	(30843, 112, '2015-01-15 00:54:47.000000', 'temperatura', 254.0000, 'ºC'),
	(30844, 112, '2015-01-15 00:54:48.000000', 'temperatura', 703.0000, 'ºC'),
	(30845, 112, '2015-01-15 00:54:49.000000', 'temperatura', 352.0000, 'ºC'),
	(30846, 112, '2015-01-15 00:54:50.000000', 'temperatura', 853.0000, 'ºC'),
	(30847, 112, '2015-01-15 00:54:51.000000', 'temperatura', 810.0000, 'ºC'),
	(30848, 112, '2015-01-15 00:54:52.000000', 'temperatura', 289.0000, 'ºC'),
	(30849, 112, '2015-01-15 00:54:53.000000', 'temperatura', 218.0000, 'ºC'),
	(30850, 112, '2015-01-15 00:54:54.000000', 'temperatura', 225.0000, 'ºC'),
	(30851, 112, '2015-01-15 00:54:55.000000', 'temperatura', 468.0000, 'ºC'),
	(30852, 112, '2015-01-15 00:54:56.000000', 'temperatura', 468.0000, 'ºC'),
	(30853, 112, '2015-01-15 00:54:57.000000', 'temperatura', 934.0000, 'ºC'),
	(30854, 112, '2015-01-15 00:54:58.000000', 'temperatura', 866.0000, 'ºC'),
	(30855, 112, '2015-01-15 00:54:59.000000', 'temperatura', 329.0000, 'ºC'),
	(30856, 112, '2015-01-15 00:55:00.000000', 'temperatura', 247.0000, 'ºC'),
	(30857, 112, '2015-01-15 00:55:01.000000', 'temperatura', 250.0000, 'ºC'),
	(30858, 112, '2015-01-15 00:55:02.000000', 'temperatura', 509.0000, 'ºC'),
	(30859, 112, '2015-01-15 00:55:03.000000', 'temperatura', 594.0000, 'ºC'),
	(30860, 112, '2015-01-15 00:55:04.000000', 'temperatura', 243.0000, 'ºC'),
	(30861, 112, '2015-01-15 00:55:05.000000', 'temperatura', 636.0000, 'ºC'),
	(30862, 112, '2015-01-15 00:55:06.000000', 'temperatura', 52.0000, 'ºC'),
	(30863, 112, '2015-01-15 00:55:07.000000', 'temperatura', 750.0000, 'ºC'),
	(30864, 112, '2015-01-15 00:55:08.000000', 'temperatura', 1195.0000, 'ºC'),
	(30865, 112, '2015-01-15 00:55:09.000000', 'temperatura', 127.0000, 'ºC'),
	(30866, 112, '2015-01-15 00:55:10.000000', 'temperatura', 648.0000, 'ºC'),
	(30867, 112, '2015-01-15 00:55:11.000000', 'temperatura', 463.0000, 'ºC'),
	(30868, 112, '2015-01-15 00:55:12.000000', 'temperatura', 368.0000, 'ºC'),
	(30869, 112, '2015-01-15 00:55:13.000000', 'temperatura', 453.0000, 'ºC'),
	(30870, 112, '2015-01-15 00:55:14.000000', 'temperatura', 1160.0000, 'ºC'),
	(30871, 112, '2015-01-15 00:55:15.000000', 'temperatura', 843.0000, 'ºC'),
	(30872, 112, '2015-01-15 00:55:16.000000', 'temperatura', 735.0000, 'ºC'),
	(30873, 112, '2015-01-15 00:55:17.000000', 'temperatura', 1147.0000, 'ºC'),
	(30874, 112, '2015-01-15 00:55:18.000000', 'temperatura', 1131.0000, 'ºC'),
	(30875, 112, '2015-01-15 00:55:19.000000', 'temperatura', 1015.0000, 'ºC'),
	(30876, 112, '2015-01-15 00:55:20.000000', 'temperatura', 480.0000, 'ºC'),
	(30877, 112, '2015-01-15 00:55:21.000000', 'temperatura', 558.0000, 'ºC'),
	(30878, 112, '2015-01-15 00:55:22.000000', 'temperatura', 151.0000, 'ºC'),
	(30879, 112, '2015-01-15 00:55:23.000000', 'temperatura', 279.0000, 'ºC'),
	(30880, 112, '2015-01-15 00:55:24.000000', 'temperatura', 943.0000, 'ºC'),
	(30881, 112, '2015-01-15 00:55:25.000000', 'temperatura', 279.0000, 'ºC'),
	(30882, 112, '2015-01-15 00:55:26.000000', 'temperatura', 965.0000, 'ºC'),
	(30883, 112, '2015-01-15 00:55:27.000000', 'temperatura', 388.0000, 'ºC'),
	(30884, 112, '2015-01-15 00:55:28.000000', 'temperatura', 246.0000, 'ºC'),
	(30885, 112, '2015-01-15 00:55:29.000000', 'temperatura', 66.0000, 'ºC'),
	(30886, 112, '2015-01-15 00:55:30.000000', 'temperatura', 795.0000, 'ºC'),
	(30887, 112, '2015-01-15 00:55:31.000000', 'temperatura', 177.0000, 'ºC'),
	(30888, 112, '2015-01-15 00:55:32.000000', 'temperatura', 899.0000, 'ºC'),
	(30889, 112, '2015-01-15 00:55:33.000000', 'temperatura', 365.0000, 'ºC'),
	(30890, 112, '2015-01-15 00:55:34.000000', 'temperatura', 329.0000, 'ºC'),
	(30891, 112, '2015-01-15 00:55:35.000000', 'temperatura', 551.0000, 'ºC'),
	(30892, 112, '2015-01-15 00:55:36.000000', 'temperatura', 569.0000, 'ºC'),
	(30893, 112, '2015-01-15 00:55:37.000000', 'temperatura', 1191.0000, 'ºC'),
	(30894, 112, '2015-01-15 00:55:38.000000', 'temperatura', 651.0000, 'ºC'),
	(30895, 112, '2015-01-15 00:55:39.000000', 'temperatura', 881.0000, 'ºC'),
	(30896, 112, '2015-01-15 00:55:40.000000', 'temperatura', 53.0000, 'ºC'),
	(30897, 112, '2015-01-15 00:55:41.000000', 'temperatura', 21.0000, 'ºC'),
	(30898, 112, '2015-01-15 00:55:42.000000', 'temperatura', 1147.0000, 'ºC'),
	(30899, 112, '2015-01-15 00:55:43.000000', 'temperatura', 872.0000, 'ºC'),
	(30900, 112, '2015-01-15 00:55:44.000000', 'temperatura', 919.0000, 'ºC'),
	(30901, 112, '2015-01-15 00:55:45.000000', 'temperatura', 780.0000, 'ºC'),
	(30902, 112, '2015-01-15 00:55:46.000000', 'temperatura', 1143.0000, 'ºC'),
	(30903, 112, '2015-01-15 00:55:47.000000', 'temperatura', 978.0000, 'ºC'),
	(30904, 112, '2015-01-15 00:55:48.000000', 'temperatura', 259.0000, 'ºC'),
	(30905, 112, '2015-01-15 00:55:49.000000', 'temperatura', 762.0000, 'ºC'),
	(30906, 112, '2015-01-15 00:55:50.000000', 'temperatura', 632.0000, 'ºC'),
	(30907, 112, '2015-01-15 00:55:51.000000', 'temperatura', 874.0000, 'ºC'),
	(30908, 112, '2015-01-15 00:55:52.000000', 'temperatura', 77.0000, 'ºC'),
	(30909, 112, '2015-01-15 00:55:53.000000', 'temperatura', 164.0000, 'ºC'),
	(30910, 112, '2015-01-15 00:55:54.000000', 'temperatura', 591.0000, 'ºC'),
	(30911, 112, '2015-01-15 00:55:55.000000', 'temperatura', 60.0000, 'ºC'),
	(30912, 112, '2015-01-15 00:55:56.000000', 'temperatura', 930.0000, 'ºC'),
	(30913, 112, '2015-01-15 00:55:57.000000', 'temperatura', 867.0000, 'ºC'),
	(30914, 112, '2015-01-15 00:55:58.000000', 'temperatura', 349.0000, 'ºC'),
	(30915, 112, '2015-01-15 00:55:59.000000', 'temperatura', 345.0000, 'ºC'),
	(30916, 112, '2015-01-15 00:56:00.000000', 'temperatura', 676.0000, 'ºC'),
	(30917, 112, '2015-01-15 00:56:01.000000', 'temperatura', 1147.0000, 'ºC'),
	(30918, 112, '2015-01-15 00:56:02.000000', 'temperatura', 107.0000, 'ºC'),
	(30919, 112, '2015-01-15 00:56:03.000000', 'temperatura', 693.0000, 'ºC'),
	(30920, 112, '2015-01-15 00:56:04.000000', 'temperatura', 747.0000, 'ºC'),
	(30921, 112, '2015-01-15 00:56:05.000000', 'temperatura', 457.0000, 'ºC'),
	(30922, 112, '2015-01-15 00:56:06.000000', 'temperatura', 45.0000, 'ºC'),
	(30923, 112, '2015-01-15 00:56:07.000000', 'temperatura', 54.0000, 'ºC'),
	(30924, 112, '2015-01-15 00:56:08.000000', 'temperatura', 136.0000, 'ºC'),
	(30925, 112, '2015-01-15 00:56:09.000000', 'temperatura', 517.0000, 'ºC'),
	(30926, 112, '2015-01-15 00:56:10.000000', 'temperatura', 979.0000, 'ºC'),
	(30927, 112, '2015-01-15 00:56:11.000000', 'temperatura', 944.0000, 'ºC'),
	(30928, 112, '2015-01-15 00:56:12.000000', 'temperatura', 585.0000, 'ºC'),
	(30929, 112, '2015-01-15 00:56:13.000000', 'temperatura', 94.0000, 'ºC'),
	(30930, 112, '2015-01-15 00:56:14.000000', 'temperatura', 1116.0000, 'ºC'),
	(30931, 112, '2015-01-15 00:56:15.000000', 'temperatura', 496.0000, 'ºC'),
	(30932, 112, '2015-01-15 00:56:16.000000', 'temperatura', 335.0000, 'ºC'),
	(30933, 112, '2015-01-15 00:56:17.000000', 'temperatura', 186.0000, 'ºC'),
	(30934, 112, '2015-01-15 00:56:18.000000', 'temperatura', 1125.0000, 'ºC'),
	(30935, 112, '2015-01-15 00:56:19.000000', 'temperatura', 267.0000, 'ºC'),
	(30936, 112, '2015-01-15 00:56:20.000000', 'temperatura', 360.0000, 'ºC'),
	(30937, 112, '2015-01-15 00:56:21.000000', 'temperatura', 1001.0000, 'ºC'),
	(30938, 112, '2015-01-15 00:56:22.000000', 'temperatura', 327.0000, 'ºC'),
	(30939, 112, '2015-01-15 00:56:23.000000', 'temperatura', 1030.0000, 'ºC'),
	(30940, 112, '2015-01-15 00:56:24.000000', 'temperatura', 572.0000, 'ºC'),
	(30941, 112, '2015-01-15 00:56:25.000000', 'temperatura', 968.0000, 'ºC'),
	(30942, 112, '2015-01-15 00:56:26.000000', 'temperatura', 726.0000, 'ºC'),
	(30943, 112, '2015-01-15 00:56:27.000000', 'temperatura', 728.0000, 'ºC'),
	(30944, 112, '2015-01-15 00:56:28.000000', 'temperatura', 262.0000, 'ºC'),
	(30945, 112, '2015-01-15 00:56:29.000000', 'temperatura', 326.0000, 'ºC'),
	(30946, 112, '2015-01-15 00:56:30.000000', 'temperatura', 844.0000, 'ºC'),
	(30947, 112, '2015-01-15 00:56:31.000000', 'temperatura', 842.0000, 'ºC'),
	(30948, 112, '2015-01-15 00:56:32.000000', 'temperatura', 481.0000, 'ºC'),
	(30949, 112, '2015-01-15 00:56:33.000000', 'temperatura', 1078.0000, 'ºC'),
	(30950, 112, '2015-01-15 00:56:34.000000', 'temperatura', 347.0000, 'ºC'),
	(30951, 112, '2015-01-15 00:56:35.000000', 'temperatura', 904.0000, 'ºC'),
	(30952, 112, '2015-01-15 00:56:36.000000', 'temperatura', 1078.0000, 'ºC'),
	(30953, 112, '2015-01-15 00:56:37.000000', 'temperatura', 277.0000, 'ºC'),
	(30954, 112, '2015-01-15 00:56:38.000000', 'temperatura', 554.0000, 'ºC'),
	(30955, 112, '2015-01-15 00:56:39.000000', 'temperatura', 739.0000, 'ºC'),
	(30956, 112, '2015-01-15 00:56:40.000000', 'temperatura', 834.0000, 'ºC'),
	(30957, 112, '2015-01-15 00:56:41.000000', 'temperatura', 752.0000, 'ºC'),
	(30958, 112, '2015-01-15 00:56:42.000000', 'temperatura', 59.0000, 'ºC'),
	(30959, 112, '2015-01-15 00:56:43.000000', 'temperatura', 439.0000, 'ºC'),
	(30960, 112, '2015-01-15 00:56:44.000000', 'temperatura', 819.0000, 'ºC'),
	(30961, 112, '2015-01-15 00:56:45.000000', 'temperatura', 379.0000, 'ºC'),
	(30962, 112, '2015-01-15 00:56:46.000000', 'temperatura', 638.0000, 'ºC'),
	(30963, 112, '2015-01-15 00:56:47.000000', 'temperatura', 852.0000, 'ºC'),
	(30964, 112, '2015-01-15 00:56:48.000000', 'temperatura', 1148.0000, 'ºC'),
	(30965, 112, '2015-01-15 00:56:49.000000', 'temperatura', 785.0000, 'ºC'),
	(30966, 112, '2015-01-15 00:56:50.000000', 'temperatura', 479.0000, 'ºC'),
	(30967, 112, '2015-01-15 00:56:51.000000', 'temperatura', 42.0000, 'ºC'),
	(30968, 112, '2015-01-15 00:56:52.000000', 'temperatura', 1171.0000, 'ºC'),
	(30969, 112, '2015-01-15 00:56:53.000000', 'temperatura', 932.0000, 'ºC'),
	(30970, 112, '2015-01-15 00:56:54.000000', 'temperatura', 1148.0000, 'ºC'),
	(30971, 112, '2015-01-15 00:56:55.000000', 'temperatura', 545.0000, 'ºC'),
	(30972, 112, '2015-01-15 00:56:56.000000', 'temperatura', 481.0000, 'ºC'),
	(30973, 112, '2015-01-15 00:56:57.000000', 'temperatura', 772.0000, 'ºC'),
	(30974, 112, '2015-01-15 00:56:58.000000', 'temperatura', 15.0000, 'ºC'),
	(30975, 112, '2015-01-15 00:56:59.000000', 'temperatura', 160.0000, 'ºC'),
	(30976, 112, '2015-01-15 00:57:00.000000', 'temperatura', 757.0000, 'ºC'),
	(30977, 112, '2015-01-15 00:57:01.000000', 'temperatura', 906.0000, 'ºC'),
	(30978, 112, '2015-01-15 00:57:02.000000', 'temperatura', 1060.0000, 'ºC'),
	(30979, 112, '2015-01-15 00:57:03.000000', 'temperatura', 179.0000, 'ºC'),
	(30980, 112, '2015-01-15 00:57:04.000000', 'temperatura', 119.0000, 'ºC'),
	(30981, 112, '2015-01-15 00:57:05.000000', 'temperatura', 58.0000, 'ºC'),
	(30982, 112, '2015-01-15 00:57:06.000000', 'temperatura', 1131.0000, 'ºC'),
	(30983, 112, '2015-01-15 00:57:07.000000', 'temperatura', 685.0000, 'ºC'),
	(30984, 112, '2015-01-15 00:57:08.000000', 'temperatura', 31.0000, 'ºC'),
	(30985, 112, '2015-01-15 00:57:09.000000', 'temperatura', 499.0000, 'ºC'),
	(30986, 112, '2015-01-15 00:57:10.000000', 'temperatura', 4.0000, 'ºC'),
	(30987, 112, '2015-01-15 00:57:11.000000', 'temperatura', 923.0000, 'ºC'),
	(30988, 112, '2015-01-15 00:57:12.000000', 'temperatura', 1004.0000, 'ºC'),
	(30989, 112, '2015-01-15 00:57:13.000000', 'temperatura', 1050.0000, 'ºC'),
	(30990, 112, '2015-01-15 00:57:14.000000', 'temperatura', 1040.0000, 'ºC'),
	(30991, 112, '2015-01-15 00:57:15.000000', 'temperatura', 848.0000, 'ºC'),
	(30992, 112, '2015-01-15 00:57:16.000000', 'temperatura', 1122.0000, 'ºC'),
	(30993, 108, '2015-02-01 00:00:00.000000', 'temperatura', 1164.0000, 'ºC'),
	(30994, 108, '2015-02-01 00:00:01.000000', 'temperatura', 224.0000, 'ºC'),
	(30995, 108, '2015-02-01 00:00:02.000000', 'temperatura', 26.0000, 'ºC'),
	(30996, 108, '2015-02-01 00:00:03.000000', 'temperatura', 660.0000, 'ºC'),
	(30997, 108, '2015-02-01 00:00:04.000000', 'temperatura', 824.0000, 'ºC'),
	(30998, 108, '2015-02-01 00:00:05.000000', 'temperatura', 938.0000, 'ºC'),
	(30999, 108, '2015-02-01 00:00:06.000000', 'temperatura', 1018.0000, 'ºC'),
	(31000, 108, '2015-02-01 00:00:07.000000', 'temperatura', 1078.0000, 'ºC'),
	(31001, 108, '2015-02-01 00:00:08.000000', 'temperatura', 1135.0000, 'ºC'),
	(31002, 108, '2015-02-01 00:00:09.000000', 'temperatura', 44.0000, 'ºC'),
	(31003, 108, '2015-02-01 00:00:10.000000', 'temperatura', 416.0000, 'ºC'),
	(31004, 108, '2015-02-01 00:00:11.000000', 'temperatura', 746.0000, 'ºC'),
	(31005, 108, '2015-02-01 00:00:12.000000', 'temperatura', 85.0000, 'ºC'),
	(31006, 108, '2015-02-01 00:00:13.000000', 'temperatura', 586.0000, 'ºC'),
	(31007, 108, '2015-02-01 00:00:14.000000', 'temperatura', 274.0000, 'ºC'),
	(31008, 108, '2015-02-01 00:00:15.000000', 'temperatura', 814.0000, 'ºC'),
	(31009, 108, '2015-02-01 00:00:16.000000', 'temperatura', 850.0000, 'ºC'),
	(31010, 108, '2015-02-01 00:00:17.000000', 'temperatura', 609.0000, 'ºC'),
	(31011, 108, '2015-02-01 00:00:18.000000', 'temperatura', 495.0000, 'ºC'),
	(31012, 108, '2015-02-01 00:00:19.000000', 'temperatura', 650.0000, 'ºC'),
	(31013, 108, '2015-02-01 00:00:20.000000', 'temperatura', 563.0000, 'ºC'),
	(31014, 108, '2015-02-01 00:00:21.000000', 'temperatura', 865.0000, 'ºC'),
	(31015, 108, '2015-02-01 00:00:22.000000', 'temperatura', 239.0000, 'ºC'),
	(31016, 108, '2015-02-01 00:00:23.000000', 'temperatura', 999.0000, 'ºC'),
	(31017, 108, '2015-02-01 00:00:24.000000', 'temperatura', 680.0000, 'ºC'),
	(31018, 108, '2015-02-01 00:00:25.000000', 'temperatura', 404.0000, 'ºC'),
	(31019, 108, '2015-02-01 00:00:26.000000', 'temperatura', 1179.0000, 'ºC'),
	(31020, 108, '2015-02-01 00:00:27.000000', 'temperatura', 1086.0000, 'ºC'),
	(31021, 108, '2015-02-01 00:00:28.000000', 'temperatura', 691.0000, 'ºC'),
	(31022, 108, '2015-02-01 00:00:29.000000', 'temperatura', 198.0000, 'ºC'),
	(31023, 108, '2015-02-01 00:00:30.000000', 'temperatura', 116.0000, 'ºC'),
	(31024, 108, '2015-02-01 00:00:31.000000', 'temperatura', 1189.0000, 'ºC'),
	(31025, 108, '2015-02-01 00:00:32.000000', 'temperatura', 798.0000, 'ºC'),
	(31026, 108, '2015-02-01 00:00:33.000000', 'temperatura', 421.0000, 'ºC'),
	(31027, 108, '2015-02-01 00:00:34.000000', 'temperatura', 913.0000, 'ºC'),
	(31028, 108, '2015-02-01 00:00:35.000000', 'temperatura', 902.0000, 'ºC'),
	(31029, 108, '2015-02-01 00:00:36.000000', 'temperatura', 572.0000, 'ºC'),
	(31030, 108, '2015-02-01 00:00:37.000000', 'temperatura', 154.0000, 'ºC'),
	(31031, 108, '2015-02-01 00:00:38.000000', 'temperatura', 257.0000, 'ºC'),
	(31032, 108, '2015-02-01 00:00:39.000000', 'temperatura', 820.0000, 'ºC'),
	(31033, 108, '2015-02-01 00:00:40.000000', 'temperatura', 930.0000, 'ºC'),
	(31034, 108, '2015-02-01 00:00:41.000000', 'temperatura', 991.0000, 'ºC'),
	(31035, 108, '2015-02-01 00:00:42.000000', 'temperatura', 966.0000, 'ºC'),
	(31036, 108, '2015-02-01 00:00:43.000000', 'temperatura', 657.0000, 'ºC'),
	(31037, 108, '2015-02-01 00:00:44.000000', 'temperatura', 389.0000, 'ºC'),
	(31038, 108, '2015-02-01 00:00:45.000000', 'temperatura', 1174.0000, 'ºC'),
	(31039, 108, '2015-02-01 00:00:46.000000', 'temperatura', 1103.0000, 'ºC'),
	(31040, 108, '2015-02-01 00:00:47.000000', 'temperatura', 794.0000, 'ºC'),
	(31041, 108, '2015-02-01 00:00:48.000000', 'temperatura', 660.0000, 'ºC'),
	(31042, 108, '2015-02-01 00:00:49.000000', 'temperatura', 918.0000, 'ºC'),
	(31043, 108, '2015-02-01 00:00:50.000000', 'temperatura', 214.0000, 'ºC'),
	(31044, 108, '2015-02-01 00:00:51.000000', 'temperatura', 713.0000, 'ºC'),
	(31045, 108, '2015-02-01 00:00:52.000000', 'temperatura', 523.0000, 'ºC'),
	(31046, 108, '2015-02-01 00:00:53.000000', 'temperatura', 479.0000, 'ºC'),
	(31047, 108, '2015-02-01 00:00:54.000000', 'temperatura', 824.0000, 'ºC'),
	(31048, 108, '2015-02-01 00:00:55.000000', 'temperatura', 284.0000, 'ºC'),
	(31049, 108, '2015-02-01 00:00:56.000000', 'temperatura', 149.0000, 'ºC'),
	(31050, 108, '2015-02-01 00:00:57.000000', 'temperatura', 1094.0000, 'ºC'),
	(31051, 108, '2015-02-01 00:00:58.000000', 'temperatura', 223.0000, 'ºC'),
	(31052, 108, '2015-02-01 00:00:59.000000', 'temperatura', 233.0000, 'ºC'),
	(31053, 108, '2015-02-01 00:01:00.000000', 'temperatura', 499.0000, 'ºC'),
	(31054, 108, '2015-02-01 00:01:01.000000', 'temperatura', 594.0000, 'ºC'),
	(31055, 108, '2015-02-01 00:01:02.000000', 'temperatura', 273.0000, 'ºC'),
	(31056, 108, '2015-02-01 00:01:03.000000', 'temperatura', 782.0000, 'ºC'),
	(31057, 108, '2015-02-01 00:01:04.000000', 'temperatura', 694.0000, 'ºC'),
	(31058, 108, '2015-02-01 00:01:05.000000', 'temperatura', 1126.0000, 'ºC'),
	(31059, 108, '2015-02-01 00:01:06.000000', 'temperatura', 1147.0000, 'ºC'),
	(31060, 108, '2015-02-01 00:01:07.000000', 'temperatura', 1158.0000, 'ºC'),
	(31061, 108, '2015-02-01 00:01:08.000000', 'temperatura', 1151.0000, 'ºC'),
	(31062, 108, '2015-02-01 00:01:09.000000', 'temperatura', 1081.0000, 'ºC'),
	(31063, 108, '2015-02-01 00:01:10.000000', 'temperatura', 754.0000, 'ºC'),
	(31064, 108, '2015-02-01 00:01:11.000000', 'temperatura', 524.0000, 'ºC'),
	(31065, 108, '2015-02-01 00:01:12.000000', 'temperatura', 361.0000, 'ºC'),
	(31066, 108, '2015-02-01 00:01:13.000000', 'temperatura', 231.0000, 'ºC'),
	(31067, 108, '2015-02-01 00:01:14.000000', 'temperatura', 76.0000, 'ºC'),
	(31068, 108, '2015-02-01 00:01:15.000000', 'temperatura', 885.0000, 'ºC'),
	(31069, 108, '2015-02-01 00:01:16.000000', 'temperatura', 600.0000, 'ºC'),
	(31070, 108, '2015-02-01 00:01:17.000000', 'temperatura', 343.0000, 'ºC'),
	(31071, 108, '2015-02-01 00:01:18.000000', 'temperatura', 1116.0000, 'ºC'),
	(31072, 108, '2015-02-01 00:01:19.000000', 'temperatura', 953.0000, 'ºC'),
	(31073, 108, '2015-02-01 00:01:20.000000', 'temperatura', 216.0000, 'ºC'),
	(31074, 108, '2015-02-01 00:01:21.000000', 'temperatura', 620.0000, 'ºC'),
	(31075, 108, '2015-02-01 00:01:22.000000', 'temperatura', 54.0000, 'ºC'),
	(31076, 108, '2015-02-01 00:01:23.000000', 'temperatura', 810.0000, 'ºC'),
	(31077, 108, '2015-02-01 00:01:24.000000', 'temperatura', 290.0000, 'ºC'),
	(31078, 108, '2015-02-01 00:01:25.000000', 'temperatura', 222.0000, 'ºC'),
	(31079, 108, '2015-02-01 00:01:26.000000', 'temperatura', 237.0000, 'ºC'),
	(31080, 108, '2015-02-01 00:01:27.000000', 'temperatura', 521.0000, 'ºC'),
	(31081, 108, '2015-02-01 00:01:28.000000', 'temperatura', 694.0000, 'ºC'),
	(31082, 108, '2015-02-01 00:01:29.000000', 'temperatura', 708.0000, 'ºC'),
	(31083, 108, '2015-02-01 00:01:30.000000', 'temperatura', 257.0000, 'ºC'),
	(31084, 108, '2015-02-01 00:01:31.000000', 'temperatura', 364.0000, 'ºC'),
	(31085, 108, '2015-02-01 00:01:32.000000', 'temperatura', 1050.0000, 'ºC'),
	(31086, 108, '2015-02-01 00:01:33.000000', 'temperatura', 556.0000, 'ºC'),
	(31087, 108, '2015-02-01 00:01:34.000000', 'temperatura', 830.0000, 'ºC'),
	(31088, 108, '2015-02-01 00:01:35.000000', 'temperatura', 83.0000, 'ºC'),
	(31089, 108, '2015-02-01 00:01:36.000000', 'temperatura', 327.0000, 'ºC'),
	(31090, 108, '2015-02-01 00:01:37.000000', 'temperatura', 186.0000, 'ºC'),
	(31091, 108, '2015-02-01 00:01:38.000000', 'temperatura', 1151.0000, 'ºC'),
	(31092, 108, '2015-02-01 00:01:39.000000', 'temperatura', 397.0000, 'ºC'),
	(31093, 108, '2015-02-01 00:01:40.000000', 'temperatura', 931.0000, 'ºC'),
	(31094, 108, '2015-02-01 00:01:41.000000', 'temperatura', 1066.0000, 'ºC'),
	(31095, 108, '2015-02-01 00:01:42.000000', 'temperatura', 136.0000, 'ºC'),
	(31096, 108, '2015-02-01 00:01:43.000000', 'temperatura', 1081.0000, 'ºC'),
	(31097, 108, '2015-02-01 00:01:44.000000', 'temperatura', 200.0000, 'ºC'),
	(31098, 108, '2015-02-01 00:01:45.000000', 'temperatura', 156.0000, 'ºC'),
	(31099, 108, '2015-02-01 00:01:46.000000', 'temperatura', 183.0000, 'ºC'),
	(31100, 108, '2015-02-01 00:01:47.000000', 'temperatura', 445.0000, 'ºC'),
	(31101, 108, '2015-02-01 00:01:48.000000', 'temperatura', 476.0000, 'ºC'),
	(31102, 108, '2015-02-01 00:01:49.000000', 'temperatura', 1046.0000, 'ºC'),
	(31103, 108, '2015-02-01 00:01:50.000000', 'temperatura', 201.0000, 'ºC'),
	(31104, 108, '2015-02-01 00:01:51.000000', 'temperatura', 268.0000, 'ºC'),
	(31105, 108, '2015-02-01 00:01:52.000000', 'temperatura', 739.0000, 'ºC'),
	(31106, 108, '2015-02-01 00:01:53.000000', 'temperatura', 492.0000, 'ºC'),
	(31107, 108, '2015-02-01 00:01:54.000000', 'temperatura', 244.0000, 'ºC'),
	(31108, 108, '2015-02-01 00:01:55.000000', 'temperatura', 944.0000, 'ºC'),
	(31109, 108, '2015-02-01 00:01:56.000000', 'temperatura', 389.0000, 'ºC'),
	(31110, 108, '2015-02-01 00:01:57.000000', 'temperatura', 313.0000, 'ºC'),
	(31111, 108, '2015-02-01 00:01:58.000000', 'temperatura', 399.0000, 'ºC'),
	(31112, 108, '2015-02-01 00:01:59.000000', 'temperatura', 1058.0000, 'ºC'),
	(31113, 108, '2015-02-01 00:02:00.000000', 'temperatura', 492.0000, 'ºC'),
	(31114, 108, '2015-02-01 00:02:01.000000', 'temperatura', 488.0000, 'ºC'),
	(31115, 108, '2015-02-01 00:02:02.000000', 'temperatura', 963.0000, 'ºC'),
	(31116, 108, '2015-02-01 00:02:03.000000', 'temperatura', 950.0000, 'ºC'),
	(31117, 108, '2015-02-01 00:02:04.000000', 'temperatura', 662.0000, 'ºC'),
	(31118, 108, '2015-02-01 00:02:05.000000', 'temperatura', 462.0000, 'ºC'),
	(31119, 108, '2015-02-01 00:02:06.000000', 'temperatura', 323.0000, 'ºC'),
	(31120, 108, '2015-02-01 00:02:07.000000', 'temperatura', 229.0000, 'ºC'),
	(31121, 108, '2015-02-01 00:02:08.000000', 'temperatura', 178.0000, 'ºC'),
	(31122, 108, '2015-02-01 00:02:09.000000', 'temperatura', 201.0000, 'ºC'),
	(31123, 108, '2015-02-01 00:02:10.000000', 'temperatura', 474.0000, 'ºC'),
	(31124, 108, '2015-02-01 00:02:11.000000', 'temperatura', 566.0000, 'ºC'),
	(31125, 108, '2015-02-01 00:02:12.000000', 'temperatura', 210.0000, 'ºC'),
	(31126, 108, '2015-02-01 00:02:13.000000', 'temperatura', 551.0000, 'ºC'),
	(31127, 108, '2015-02-01 00:02:14.000000', 'temperatura', 928.0000, 'ºC'),
	(31128, 108, '2015-02-01 00:02:15.000000', 'temperatura', 587.0000, 'ºC'),
	(31129, 108, '2015-02-01 00:02:16.000000', 'temperatura', 149.0000, 'ºC'),
	(31130, 108, '2015-02-01 00:02:17.000000', 'temperatura', 188.0000, 'ºC'),
	(31131, 108, '2015-02-01 00:02:18.000000', 'temperatura', 490.0000, 'ºC'),
	(31132, 108, '2015-02-01 00:02:19.000000', 'temperatura', 687.0000, 'ºC'),
	(31133, 108, '2015-02-01 00:02:20.000000', 'temperatura', 768.0000, 'ºC'),
	(31134, 108, '2015-02-01 00:02:21.000000', 'temperatura', 578.0000, 'ºC'),
	(31135, 108, '2015-02-01 00:02:22.000000', 'temperatura', 588.0000, 'ºC'),
	(31136, 108, '2015-02-01 00:02:23.000000', 'temperatura', 7.0000, 'ºC'),
	(31137, 108, '2015-02-01 00:02:24.000000', 'temperatura', 672.0000, 'ºC'),
	(31138, 108, '2015-02-01 00:02:25.000000', 'temperatura', 939.0000, 'ºC'),
	(31139, 108, '2015-02-01 00:02:26.000000', 'temperatura', 278.0000, 'ºC'),
	(31140, 108, '2015-02-01 00:02:27.000000', 'temperatura', 975.0000, 'ºC'),
	(31141, 108, '2015-02-01 00:02:28.000000', 'temperatura', 441.0000, 'ºC'),
	(31142, 108, '2015-02-01 00:02:29.000000', 'temperatura', 480.0000, 'ºC'),
	(31143, 108, '2015-02-01 00:02:30.000000', 'temperatura', 1077.0000, 'ºC'),
	(31144, 108, '2015-02-01 00:02:31.000000', 'temperatura', 347.0000, 'ºC'),
	(31145, 108, '2015-02-01 00:02:32.000000', 'temperatura', 904.0000, 'ºC'),
	(31146, 108, '2015-02-01 00:02:33.000000', 'temperatura', 1080.0000, 'ºC'),
	(31147, 108, '2015-02-01 00:02:34.000000', 'temperatura', 286.0000, 'ºC'),
	(31148, 108, '2015-02-01 00:02:35.000000', 'temperatura', 592.0000, 'ºC'),
	(31149, 108, '2015-02-01 00:02:36.000000', 'temperatura', 902.0000, 'ºC'),
	(31150, 108, '2015-02-01 00:02:37.000000', 'temperatura', 336.0000, 'ºC'),
	(31151, 108, '2015-02-01 00:02:38.000000', 'temperatura', 175.0000, 'ºC'),
	(31152, 108, '2015-02-01 00:02:39.000000', 'temperatura', 1066.0000, 'ºC'),
	(31153, 108, '2015-02-01 00:02:40.000000', 'temperatura', 4.0000, 'ºC'),
	(31154, 108, '2015-02-01 00:02:41.000000', 'temperatura', 423.0000, 'ºC'),
	(31155, 108, '2015-02-01 00:02:42.000000', 'temperatura', 906.0000, 'ºC'),
	(31156, 108, '2015-02-01 00:02:43.000000', 'temperatura', 858.0000, 'ºC'),
	(31157, 108, '2015-02-01 00:02:44.000000', 'temperatura', 374.0000, 'ºC'),
	(31158, 108, '2015-02-01 00:02:45.000000', 'temperatura', 497.0000, 'ºC'),
	(31159, 108, '2015-02-01 00:02:46.000000', 'temperatura', 162.0000, 'ºC'),
	(31160, 108, '2015-02-01 00:02:47.000000', 'temperatura', 522.0000, 'ºC'),
	(31161, 108, '2015-02-01 00:02:48.000000', 'temperatura', 923.0000, 'ºC'),
	(31162, 108, '2015-02-01 00:02:49.000000', 'temperatura', 649.0000, 'ºC'),
	(31163, 108, '2015-02-01 00:02:50.000000', 'temperatura', 475.0000, 'ºC'),
	(31164, 108, '2015-02-01 00:02:51.000000', 'temperatura', 431.0000, 'ºC'),
	(31165, 108, '2015-02-01 00:02:52.000000', 'temperatura', 731.0000, 'ºC'),
	(31166, 108, '2015-02-01 00:02:53.000000', 'temperatura', 1160.0000, 'ºC'),
	(31167, 108, '2015-02-01 00:02:54.000000', 'temperatura', 9.0000, 'ºC'),
	(31168, 108, '2015-02-01 00:02:55.000000', 'temperatura', 166.0000, 'ºC'),
	(31169, 108, '2015-02-01 00:02:56.000000', 'temperatura', 802.0000, 'ºC'),
	(31170, 108, '2015-02-01 00:02:57.000000', 'temperatura', 1113.0000, 'ºC'),
	(31171, 108, '2015-02-01 00:02:58.000000', 'temperatura', 761.0000, 'ºC'),
	(31172, 108, '2015-02-01 00:02:59.000000', 'temperatura', 467.0000, 'ºC'),
	(31173, 108, '2015-02-01 00:03:00.000000', 'temperatura', 53.0000, 'ºC'),
	(31174, 108, '2015-02-01 00:03:01.000000', 'temperatura', 63.0000, 'ºC'),
	(31175, 108, '2015-02-01 00:03:02.000000', 'temperatura', 157.0000, 'ºC'),
	(31176, 108, '2015-02-01 00:03:03.000000', 'temperatura', 598.0000, 'ºC'),
	(31177, 108, '2015-02-01 00:03:04.000000', 'temperatura', 116.0000, 'ºC'),
	(31178, 108, '2015-02-01 00:03:05.000000', 'temperatura', 1190.0000, 'ºC'),
	(31179, 108, '2015-02-01 00:03:06.000000', 'temperatura', 800.0000, 'ºC'),
	(31180, 108, '2015-02-01 00:03:07.000000', 'temperatura', 431.0000, 'ºC'),
	(31181, 108, '2015-02-01 00:03:08.000000', 'temperatura', 956.0000, 'ºC'),
	(31182, 108, '2015-02-01 00:03:09.000000', 'temperatura', 1088.0000, 'ºC'),
	(31183, 108, '2015-02-01 00:03:10.000000', 'temperatura', 173.0000, 'ºC'),
	(31184, 108, '2015-02-01 00:03:11.000000', 'temperatura', 1.0000, 'ºC'),
	(31185, 108, '2015-02-01 00:03:12.000000', 'temperatura', 687.0000, 'ºC'),
	(31186, 108, '2015-02-01 00:03:13.000000', 'temperatura', 1032.0000, 'ºC'),
	(31187, 108, '2015-02-01 00:03:14.000000', 'temperatura', 700.0000, 'ºC'),
	(31188, 108, '2015-02-01 00:03:15.000000', 'temperatura', 404.0000, 'ºC'),
	(31189, 108, '2015-02-01 00:03:16.000000', 'temperatura', 1120.0000, 'ºC'),
	(31190, 108, '2015-02-01 00:03:17.000000', 'temperatura', 790.0000, 'ºC'),
	(31191, 108, '2015-02-01 00:03:18.000000', 'temperatura', 590.0000, 'ºC'),
	(31192, 108, '2015-02-01 00:03:19.000000', 'temperatura', 582.0000, 'ºC'),
	(31193, 108, '2015-02-01 00:03:20.000000', 'temperatura', 1141.0000, 'ºC'),
	(31194, 108, '2015-02-01 00:03:21.000000', 'temperatura', 358.0000, 'ºC'),
	(31195, 108, '2015-02-01 00:03:22.000000', 'temperatura', 770.0000, 'ºC'),
	(31196, 108, '2015-02-01 00:03:23.000000', 'temperatura', 374.0000, 'ºC'),
	(31197, 108, '2015-02-01 00:03:24.000000', 'temperatura', 763.0000, 'ºC'),
	(31198, 108, '2015-02-01 00:03:25.000000', 'temperatura', 292.0000, 'ºC'),
	(31199, 108, '2015-02-01 00:03:26.000000', 'temperatura', 370.0000, 'ºC'),
	(31200, 108, '2015-02-01 00:03:27.000000', 'temperatura', 974.0000, 'ºC'),
	(31201, 108, '2015-02-01 00:03:28.000000', 'temperatura', 163.0000, 'ºC'),
	(31202, 108, '2015-02-01 00:03:29.000000', 'temperatura', 291.0000, 'ºC'),
	(31203, 108, '2015-02-01 00:03:30.000000', 'temperatura', 966.0000, 'ºC'),
	(31204, 108, '2015-02-01 00:03:31.000000', 'temperatura', 357.0000, 'ºC'),
	(31205, 108, '2015-02-01 00:03:32.000000', 'temperatura', 87.0000, 'ºC'),
	(31206, 108, '2015-02-01 00:03:33.000000', 'temperatura', 566.0000, 'ºC'),
	(31207, 108, '2015-02-01 00:03:34.000000', 'temperatura', 169.0000, 'ºC'),
	(31208, 108, '2015-02-01 00:03:35.000000', 'temperatura', 348.0000, 'ºC'),
	(31209, 108, '2015-02-01 00:03:36.000000', 'temperatura', 33.0000, 'ºC'),
	(31210, 108, '2015-02-01 00:03:37.000000', 'temperatura', 321.0000, 'ºC'),
	(31211, 108, '2015-02-01 00:03:38.000000', 'temperatura', 309.0000, 'ºC'),
	(31212, 108, '2015-02-01 00:03:39.000000', 'temperatura', 580.0000, 'ºC'),
	(31213, 108, '2015-02-01 00:03:40.000000', 'temperatura', 772.0000, 'ºC'),
	(31214, 108, '2015-02-01 00:03:41.000000', 'temperatura', 924.0000, 'ºC'),
	(31215, 108, '2015-02-01 00:03:42.000000', 'temperatura', 1104.0000, 'ºC'),
	(31216, 108, '2015-02-01 00:03:43.000000', 'temperatura', 347.0000, 'ºC'),
	(31217, 108, '2015-02-01 00:03:44.000000', 'temperatura', 826.0000, 'ºC'),
	(31218, 108, '2015-02-01 00:03:45.000000', 'temperatura', 687.0000, 'ºC'),
	(31219, 108, '2015-02-01 00:03:46.000000', 'temperatura', 957.0000, 'ºC'),
	(31220, 108, '2015-02-01 00:03:47.000000', 'temperatura', 324.0000, 'ºC'),
	(31221, 108, '2015-02-01 00:03:48.000000', 'temperatura', 1148.0000, 'ºC'),
	(31222, 108, '2015-02-01 00:03:49.000000', 'temperatura', 1172.0000, 'ºC'),
	(31223, 108, '2015-02-01 00:03:50.000000', 'temperatura', 16.0000, 'ºC'),
	(31224, 108, '2015-02-01 00:03:51.000000', 'temperatura', 165.0000, 'ºC'),
	(31225, 108, '2015-02-01 00:03:52.000000', 'temperatura', 779.0000, 'ºC'),
	(31226, 108, '2015-02-01 00:03:53.000000', 'temperatura', 998.0000, 'ºC'),
	(31227, 108, '2015-02-01 00:03:54.000000', 'temperatura', 253.0000, 'ºC'),
	(31228, 108, '2015-02-01 00:03:55.000000', 'temperatura', 670.0000, 'ºC'),
	(31229, 108, '2015-02-01 00:03:56.000000', 'temperatura', 195.0000, 'ºC'),
	(31230, 108, '2015-02-01 00:03:57.000000', 'temperatura', 163.0000, 'ºC'),
	(31231, 108, '2015-02-01 00:03:58.000000', 'temperatura', 230.0000, 'ºC'),
	(31232, 108, '2015-02-01 00:03:59.000000', 'temperatura', 661.0000, 'ºC'),
	(31233, 108, '2015-02-01 00:04:00.000000', 'temperatura', 219.0000, 'ºC'),
	(31234, 108, '2015-02-01 00:04:01.000000', 'temperatura', 309.0000, 'ºC'),
	(31235, 108, '2015-02-01 00:04:02.000000', 'temperatura', 889.0000, 'ºC'),
	(31236, 108, '2015-02-01 00:04:03.000000', 'temperatura', 1119.0000, 'ºC'),
	(31237, 108, '2015-02-01 00:04:04.000000', 'temperatura', 528.0000, 'ºC'),
	(31238, 108, '2015-02-01 00:04:05.000000', 'temperatura', 482.0000, 'ºC'),
	(31239, 108, '2015-02-01 00:04:06.000000', 'temperatura', 828.0000, 'ºC'),
	(31240, 108, '2015-02-01 00:04:07.000000', 'temperatura', 295.0000, 'ºC'),
	(31241, 108, '2015-02-01 00:04:08.000000', 'temperatura', 193.0000, 'ºC'),
	(31242, 108, '2015-02-01 00:04:09.000000', 'temperatura', 79.0000, 'ºC'),
	(31243, 108, '2015-02-01 00:04:10.000000', 'temperatura', 1016.0000, 'ºC'),
	(31244, 108, '2015-02-01 00:04:11.000000', 'temperatura', 43.0000, 'ºC'),
	(31245, 108, '2015-02-01 00:04:12.000000', 'temperatura', 769.0000, 'ºC'),
	(31246, 108, '2015-02-01 00:04:13.000000', 'temperatura', 117.0000, 'ºC'),
	(31247, 108, '2015-02-01 00:04:14.000000', 'temperatura', 679.0000, 'ºC'),
	(31248, 108, '2015-02-01 00:04:15.000000', 'temperatura', 646.0000, 'ºC'),
	(31249, 108, '2015-02-01 00:04:16.000000', 'temperatura', 1190.0000, 'ºC'),
	(31250, 108, '2015-02-01 00:04:17.000000', 'temperatura', 414.0000, 'ºC'),
	(31251, 108, '2015-02-01 00:04:18.000000', 'temperatura', 898.0000, 'ºC'),
	(31252, 108, '2015-02-01 00:04:19.000000', 'temperatura', 851.0000, 'ºC'),
	(31253, 108, '2015-02-01 00:04:20.000000', 'temperatura', 361.0000, 'ºC'),
	(31254, 108, '2015-02-01 00:04:21.000000', 'temperatura', 455.0000, 'ºC'),
	(31255, 108, '2015-02-01 00:04:22.000000', 'temperatura', 1189.0000, 'ºC'),
	(31256, 108, '2015-02-01 00:04:23.000000', 'temperatura', 980.0000, 'ºC'),
	(31257, 108, '2015-02-01 00:04:24.000000', 'temperatura', 134.0000, 'ºC'),
	(31258, 108, '2015-02-01 00:04:25.000000', 'temperatura', 132.0000, 'ºC'),
	(31259, 108, '2015-02-01 00:04:26.000000', 'temperatura', 257.0000, 'ºC'),
	(31260, 108, '2015-02-01 00:04:27.000000', 'temperatura', 891.0000, 'ºC'),
	(31261, 108, '2015-02-01 00:04:28.000000', 'temperatura', 82.0000, 'ºC'),
	(31262, 108, '2015-02-01 00:04:29.000000', 'temperatura', 138.0000, 'ºC'),
	(31263, 108, '2015-02-01 00:04:30.000000', 'temperatura', 446.0000, 'ºC'),
	(31264, 108, '2015-02-01 00:04:31.000000', 'temperatura', 615.0000, 'ºC'),
	(31265, 108, '2015-02-01 00:04:32.000000', 'temperatura', 537.0000, 'ºC'),
	(31266, 108, '2015-02-01 00:04:33.000000', 'temperatura', 839.0000, 'ºC'),
	(31267, 108, '2015-02-01 00:04:34.000000', 'temperatura', 188.0000, 'ºC'),
	(31268, 108, '2015-02-01 00:04:35.000000', 'temperatura', 823.0000, 'ºC'),
	(31269, 108, '2015-02-01 00:04:36.000000', 'temperatura', 1150.0000, 'ºC'),
	(31270, 108, '2015-02-01 00:04:37.000000', 'temperatura', 882.0000, 'ºC'),
	(31271, 108, '2015-02-01 00:04:38.000000', 'temperatura', 962.0000, 'ºC'),
	(31272, 108, '2015-02-01 00:04:39.000000', 'temperatura', 965.0000, 'ºC'),
	(31273, 108, '2015-02-01 00:04:40.000000', 'temperatura', 738.0000, 'ºC'),
	(31274, 108, '2015-02-01 00:04:41.000000', 'temperatura', 797.0000, 'ºC'),
	(31275, 108, '2015-02-01 00:04:42.000000', 'temperatura', 571.0000, 'ºC'),
	(31276, 108, '2015-02-01 00:04:43.000000', 'temperatura', 466.0000, 'ºC'),
	(31277, 108, '2015-02-01 00:04:44.000000', 'temperatura', 618.0000, 'ºC'),
	(31278, 108, '2015-02-01 00:04:45.000000', 'temperatura', 490.0000, 'ºC'),
	(31279, 108, '2015-02-01 00:04:46.000000', 'temperatura', 598.0000, 'ºC'),
	(31280, 108, '2015-02-01 00:04:47.000000', 'temperatura', 318.0000, 'ºC'),
	(31281, 108, '2015-02-01 00:04:48.000000', 'temperatura', 999.0000, 'ºC'),
	(31282, 108, '2015-02-01 00:04:49.000000', 'temperatura', 439.0000, 'ºC'),
	(31283, 108, '2015-02-01 00:04:50.000000', 'temperatura', 401.0000, 'ºC'),
	(31284, 108, '2015-02-01 00:04:51.000000', 'temperatura', 688.0000, 'ºC'),
	(31285, 108, '2015-02-01 00:04:52.000000', 'temperatura', 1039.0000, 'ºC'),
	(31286, 108, '2015-02-01 00:04:53.000000', 'temperatura', 731.0000, 'ºC'),
	(31287, 108, '2015-02-01 00:04:54.000000', 'temperatura', 539.0000, 'ºC'),
	(31288, 108, '2015-02-01 00:04:55.000000', 'temperatura', 502.0000, 'ºC'),
	(31289, 108, '2015-02-01 00:04:56.000000', 'temperatura', 894.0000, 'ºC'),
	(31290, 108, '2015-02-01 00:04:57.000000', 'temperatura', 566.0000, 'ºC'),
	(31291, 108, '2015-02-01 00:04:58.000000', 'temperatura', 147.0000, 'ºC'),
	(31292, 108, '2015-02-01 00:04:59.000000', 'temperatura', 236.0000, 'ºC'),
	(31293, 108, '2015-02-01 00:05:00.000000', 'temperatura', 741.0000, 'ºC'),
	(31294, 108, '2015-02-01 00:05:01.000000', 'temperatura', 597.0000, 'ºC'),
	(31295, 108, '2015-02-01 00:05:02.000000', 'temperatura', 762.0000, 'ºC'),
	(31296, 108, '2015-02-01 00:05:03.000000', 'temperatura', 822.0000, 'ºC'),
	(31297, 108, '2015-02-01 00:05:04.000000', 'temperatura', 623.0000, 'ºC'),
	(31298, 108, '2015-02-01 00:05:05.000000', 'temperatura', 651.0000, 'ºC'),
	(31299, 108, '2015-02-01 00:05:06.000000', 'temperatura', 186.0000, 'ºC'),
	(31300, 108, '2015-02-01 00:05:07.000000', 'temperatura', 176.0000, 'ºC'),
	(31301, 108, '2015-02-01 00:05:08.000000', 'temperatura', 322.0000, 'ºC'),
	(31302, 108, '2015-02-01 00:05:09.000000', 'temperatura', 1084.0000, 'ºC'),
	(31303, 108, '2015-02-01 00:05:10.000000', 'temperatura', 855.0000, 'ºC'),
	(31304, 108, '2015-02-01 00:05:11.000000', 'temperatura', 1024.0000, 'ºC'),
	(31305, 108, '2015-02-01 00:05:12.000000', 'temperatura', 155.0000, 'ºC'),
	(31306, 108, '2015-02-01 00:05:13.000000', 'temperatura', 104.0000, 'ºC'),
	(31307, 108, '2015-02-01 00:05:14.000000', 'temperatura', 55.0000, 'ºC'),
	(31308, 108, '2015-02-01 00:05:15.000000', 'temperatura', 1165.0000, 'ºC'),
	(31309, 108, '2015-02-01 00:05:16.000000', 'temperatura', 861.0000, 'ºC'),
	(31310, 108, '2015-02-01 00:05:17.000000', 'temperatura', 811.0000, 'ºC'),
	(31311, 108, '2015-02-01 00:05:18.000000', 'temperatura', 273.0000, 'ºC'),
	(31312, 108, '2015-02-01 00:05:19.000000', 'temperatura', 130.0000, 'ºC'),
	(31313, 108, '2015-02-01 00:05:20.000000', 'temperatura', 1031.0000, 'ºC'),
	(31314, 108, '2015-02-01 00:05:21.000000', 'temperatura', 1169.0000, 'ºC'),
	(31315, 108, '2015-02-01 00:05:22.000000', 'temperatura', 349.0000, 'ºC'),
	(31316, 108, '2015-02-01 00:05:23.000000', 'temperatura', 640.0000, 'ºC'),
	(31317, 108, '2015-02-01 00:05:24.000000', 'temperatura', 953.0000, 'ºC'),
	(31318, 108, '2015-02-01 00:05:25.000000', 'temperatura', 445.0000, 'ºC'),
	(31319, 108, '2015-02-01 00:05:26.000000', 'temperatura', 569.0000, 'ºC'),
	(31320, 108, '2015-02-01 00:05:27.000000', 'temperatura', 308.0000, 'ºC'),
	(31321, 108, '2015-02-01 00:05:28.000000', 'temperatura', 1033.0000, 'ºC'),
	(31322, 108, '2015-02-01 00:05:29.000000', 'temperatura', 643.0000, 'ºC'),
	(31323, 108, '2015-02-01 00:05:30.000000', 'temperatura', 118.0000, 'ºC'),
	(31324, 108, '2015-02-01 00:05:31.000000', 'temperatura', 1061.0000, 'ºC'),
	(31325, 108, '2015-02-01 00:05:32.000000', 'temperatura', 149.0000, 'ºC'),
	(31326, 108, '2015-02-01 00:05:33.000000', 'temperatura', 1165.0000, 'ºC'),
	(31327, 108, '2015-02-01 00:05:34.000000', 'temperatura', 579.0000, 'ºC'),
	(31328, 108, '2015-02-01 00:05:35.000000', 'temperatura', 601.0000, 'ºC'),
	(31329, 108, '2015-02-01 00:05:36.000000', 'temperatura', 66.0000, 'ºC'),
	(31330, 108, '2015-02-01 00:05:37.000000', 'temperatura', 928.0000, 'ºC'),
	(31331, 108, '2015-02-01 00:05:38.000000', 'temperatura', 844.0000, 'ºC'),
	(31332, 108, '2015-02-01 00:05:39.000000', 'temperatura', 238.0000, 'ºC'),
	(31333, 108, '2015-02-01 00:05:40.000000', 'temperatura', 1055.0000, 'ºC'),
	(31334, 108, '2015-02-01 00:05:41.000000', 'temperatura', 964.0000, 'ºC'),
	(31335, 108, '2015-02-01 00:05:42.000000', 'temperatura', 456.0000, 'ºC'),
	(31336, 108, '2015-02-01 00:05:43.000000', 'temperatura', 586.0000, 'ºC'),
	(31337, 108, '2015-02-01 00:05:44.000000', 'temperatura', 362.0000, 'ºC'),
	(31338, 108, '2015-02-01 00:05:45.000000', 'temperatura', 53.0000, 'ºC'),
	(31339, 108, '2015-02-01 00:05:46.000000', 'temperatura', 378.0000, 'ºC'),
	(31340, 108, '2015-02-01 00:05:47.000000', 'temperatura', 532.0000, 'ºC'),
	(31341, 108, '2015-02-01 00:05:48.000000', 'temperatura', 329.0000, 'ºC'),
	(31342, 108, '2015-02-01 00:05:49.000000', 'temperatura', 47.0000, 'ºC'),
	(31343, 108, '2015-02-01 00:05:50.000000', 'temperatura', 448.0000, 'ºC'),
	(31344, 108, '2015-02-01 00:05:51.000000', 'temperatura', 900.0000, 'ºC'),
	(31345, 108, '2015-02-01 00:05:52.000000', 'temperatura', 758.0000, 'ºC'),
	(31346, 108, '2015-02-01 00:05:53.000000', 'temperatura', 1092.0000, 'ºC'),
	(31347, 108, '2015-02-01 00:05:54.000000', 'temperatura', 783.0000, 'ºC'),
	(31348, 108, '2015-02-01 00:05:55.000000', 'temperatura', 640.0000, 'ºC'),
	(31349, 108, '2015-02-01 00:05:56.000000', 'temperatura', 852.0000, 'ºC'),
	(31350, 108, '2015-02-01 00:05:57.000000', 'temperatura', 1139.0000, 'ºC'),
	(31351, 108, '2015-02-01 00:05:58.000000', 'temperatura', 741.0000, 'ºC'),
	(31352, 108, '2015-02-01 00:05:59.000000', 'temperatura', 289.0000, 'ºC'),
	(31353, 108, '2015-02-01 00:06:00.000000', 'temperatura', 421.0000, 'ºC'),
	(31354, 108, '2015-02-01 00:06:01.000000', 'temperatura', 39.0000, 'ºC'),
	(31355, 108, '2015-02-01 00:06:02.000000', 'temperatura', 131.0000, 'ºC'),
	(31356, 108, '2015-02-01 00:06:03.000000', 'temperatura', 541.0000, 'ºC'),
	(31357, 108, '2015-02-01 00:06:04.000000', 'temperatura', 1110.0000, 'ºC'),
	(31358, 108, '2015-02-01 00:06:05.000000', 'temperatura', 328.0000, 'ºC'),
	(31359, 108, '2015-02-01 00:06:06.000000', 'temperatura', 711.0000, 'ºC'),
	(31360, 108, '2015-02-01 00:06:07.000000', 'temperatura', 171.0000, 'ºC'),
	(31361, 108, '2015-02-01 00:06:08.000000', 'temperatura', 1125.0000, 'ºC'),
	(31362, 108, '2015-02-01 00:06:09.000000', 'temperatura', 311.0000, 'ºC'),
	(31363, 108, '2015-02-01 00:06:10.000000', 'temperatura', 578.0000, 'ºC'),
	(31364, 108, '2015-02-01 00:06:11.000000', 'temperatura', 761.0000, 'ºC'),
	(31365, 108, '2015-02-01 00:06:12.000000', 'temperatura', 871.0000, 'ºC'),
	(31366, 108, '2015-02-01 00:06:13.000000', 'temperatura', 871.0000, 'ºC'),
	(31367, 108, '2015-02-01 00:06:14.000000', 'temperatura', 545.0000, 'ºC'),
	(31368, 108, '2015-02-01 00:06:15.000000', 'temperatura', 110.0000, 'ºC'),
	(31369, 108, '2015-02-01 00:06:16.000000', 'temperatura', 116.0000, 'ºC'),
	(31370, 108, '2015-02-01 00:06:17.000000', 'temperatura', 253.0000, 'ºC'),
	(31371, 108, '2015-02-01 00:06:18.000000', 'temperatura', 914.0000, 'ºC'),
	(31372, 108, '2015-02-01 00:06:19.000000', 'temperatura', 212.0000, 'ºC'),
	(31373, 108, '2015-02-01 00:06:20.000000', 'temperatura', 720.0000, 'ºC'),
	(31374, 108, '2015-02-01 00:06:21.000000', 'temperatura', 564.0000, 'ºC'),
	(31375, 108, '2015-02-01 00:06:22.000000', 'temperatura', 662.0000, 'ºC'),
	(31376, 108, '2015-02-01 00:06:23.000000', 'temperatura', 416.0000, 'ºC'),
	(31377, 108, '2015-02-01 00:06:24.000000', 'temperatura', 95.0000, 'ºC'),
	(31378, 108, '2015-02-01 00:06:25.000000', 'temperatura', 429.0000, 'ºC'),
	(31379, 108, '2015-02-01 00:06:26.000000', 'temperatura', 662.0000, 'ºC'),
	(31380, 108, '2015-02-01 00:06:27.000000', 'temperatura', 820.0000, 'ºC'),
	(31381, 108, '2015-02-01 00:06:28.000000', 'temperatura', 916.0000, 'ºC'),
	(31382, 108, '2015-02-01 00:06:29.000000', 'temperatura', 920.0000, 'ºC'),
	(31383, 108, '2015-02-01 00:06:30.000000', 'temperatura', 654.0000, 'ºC'),
	(31384, 108, '2015-02-01 00:06:31.000000', 'temperatura', 510.0000, 'ºC'),
	(31385, 108, '2015-02-01 00:06:32.000000', 'temperatura', 589.0000, 'ºC'),
	(31386, 108, '2015-02-01 00:06:33.000000', 'temperatura', 213.0000, 'ºC'),
	(31387, 108, '2015-02-01 00:06:34.000000', 'temperatura', 501.0000, 'ºC'),
	(31388, 108, '2015-02-01 00:06:35.000000', 'temperatura', 664.0000, 'ºC'),
	(31389, 108, '2015-02-01 00:06:36.000000', 'temperatura', 621.0000, 'ºC'),
	(31390, 108, '2015-02-01 00:06:37.000000', 'temperatura', 1110.0000, 'ºC'),
	(31391, 108, '2015-02-01 00:06:38.000000', 'temperatura', 88.0000, 'ºC'),
	(31392, 108, '2015-02-01 00:06:39.000000', 'temperatura', 713.0000, 'ºC'),
	(31393, 108, '2015-02-01 00:06:40.000000', 'temperatura', 899.0000, 'ºC'),
	(31394, 108, '2015-02-01 00:06:41.000000', 'temperatura', 1158.0000, 'ºC'),
	(31395, 108, '2015-02-01 00:06:42.000000', 'temperatura', 691.0000, 'ºC'),
	(31396, 108, '2015-02-01 00:06:43.000000', 'temperatura', 1182.0000, 'ºC'),
	(31397, 108, '2015-02-01 00:06:44.000000', 'temperatura', 240.0000, 'ºC'),
	(31398, 108, '2015-02-01 00:06:45.000000', 'temperatura', 51.0000, 'ºC'),
	(31399, 108, '2015-02-01 00:06:46.000000', 'temperatura', 738.0000, 'ºC'),
	(31400, 108, '2015-02-01 00:06:47.000000', 'temperatura', 1139.0000, 'ºC'),
	(31401, 108, '2015-02-01 00:06:48.000000', 'temperatura', 1080.0000, 'ºC'),
	(31402, 108, '2015-02-01 00:06:49.000000', 'temperatura', 782.0000, 'ºC'),
	(31403, 108, '2015-02-01 00:06:50.000000', 'temperatura', 672.0000, 'ºC'),
	(31404, 108, '2015-02-01 00:06:51.000000', 'temperatura', 1013.0000, 'ºC'),
	(31405, 108, '2015-02-01 00:06:52.000000', 'temperatura', 649.0000, 'ºC'),
	(31406, 108, '2015-02-01 00:06:53.000000', 'temperatura', 209.0000, 'ºC'),
	(31407, 108, '2015-02-01 00:06:54.000000', 'temperatura', 295.0000, 'ºC'),
	(31408, 108, '2015-02-01 00:06:55.000000', 'temperatura', 852.0000, 'ºC'),
	(31409, 108, '2015-02-01 00:06:56.000000', 'temperatura', 975.0000, 'ºC'),
	(31410, 108, '2015-02-01 00:06:57.000000', 'temperatura', 1118.0000, 'ºC'),
	(31411, 108, '2015-02-01 00:06:58.000000', 'temperatura', 264.0000, 'ºC'),
	(31412, 108, '2015-02-01 00:06:59.000000', 'temperatura', 369.0000, 'ºC'),
	(31413, 108, '2015-02-01 00:07:00.000000', 'temperatura', 1052.0000, 'ºC'),
	(31414, 108, '2015-02-01 00:07:01.000000', 'temperatura', 555.0000, 'ºC'),
	(31415, 108, '2015-02-01 00:07:02.000000', 'temperatura', 817.0000, 'ºC'),
	(31416, 108, '2015-02-01 00:07:03.000000', 'temperatura', 22.0000, 'ºC'),
	(31417, 108, '2015-02-01 00:07:04.000000', 'temperatura', 59.0000, 'ºC'),
	(31418, 108, '2015-02-01 00:07:05.000000', 'temperatura', 232.0000, 'ºC'),
	(31419, 108, '2015-02-01 00:07:06.000000', 'temperatura', 981.0000, 'ºC'),
	(31420, 108, '2015-02-01 00:07:07.000000', 'temperatura', 609.0000, 'ºC'),
	(31421, 108, '2015-02-01 00:07:08.000000', 'temperatura', 104.0000, 'ºC'),
	(31422, 108, '2015-02-01 00:07:09.000000', 'temperatura', 1094.0000, 'ºC'),
	(31423, 108, '2015-02-01 00:07:10.000000', 'temperatura', 357.0000, 'ºC'),
	(31424, 108, '2015-02-01 00:07:11.000000', 'temperatura', 906.0000, 'ºC'),
	(31425, 108, '2015-02-01 00:07:12.000000', 'temperatura', 1057.0000, 'ºC'),
	(31426, 108, '2015-02-01 00:07:13.000000', 'temperatura', 167.0000, 'ºC'),
	(31427, 108, '2015-02-01 00:07:14.000000', 'temperatura', 66.0000, 'ºC'),
	(31428, 108, '2015-02-01 00:07:15.000000', 'temperatura', 1030.0000, 'ºC'),
	(31429, 108, '2015-02-01 00:07:16.000000', 'temperatura', 151.0000, 'ºC'),
	(31430, 108, '2015-02-01 00:07:17.000000', 'temperatura', 64.0000, 'ºC'),
	(31431, 108, '2015-02-01 00:07:18.000000', 'temperatura', 1070.0000, 'ºC'),
	(31432, 108, '2015-02-01 00:07:19.000000', 'temperatura', 360.0000, 'ºC'),
	(31433, 108, '2015-02-01 00:07:20.000000', 'temperatura', 987.0000, 'ºC'),
	(31434, 108, '2015-02-01 00:07:21.000000', 'temperatura', 256.0000, 'ºC'),
	(31435, 108, '2015-02-01 00:07:22.000000', 'temperatura', 722.0000, 'ºC'),
	(31436, 108, '2015-02-01 00:07:23.000000', 'temperatura', 440.0000, 'ºC'),
	(31437, 108, '2015-02-01 00:07:24.000000', 'temperatura', 36.0000, 'ºC'),
	(31438, 108, '2015-02-01 00:07:25.000000', 'temperatura', 58.0000, 'ºC'),
	(31439, 108, '2015-02-01 00:07:26.000000', 'temperatura', 185.0000, 'ºC'),
	(31440, 108, '2015-02-01 00:07:27.000000', 'temperatura', 749.0000, 'ºC'),
	(31441, 108, '2015-02-01 00:07:28.000000', 'temperatura', 791.0000, 'ºC'),
	(31442, 108, '2015-02-01 00:07:29.000000', 'temperatura', 508.0000, 'ºC'),
	(31443, 108, '2015-02-01 00:07:30.000000', 'temperatura', 168.0000, 'ºC'),
	(31444, 108, '2015-02-01 00:07:31.000000', 'temperatura', 517.0000, 'ºC'),
	(31445, 108, '2015-02-01 00:07:32.000000', 'temperatura', 882.0000, 'ºC'),
	(31446, 108, '2015-02-01 00:07:33.000000', 'temperatura', 458.0000, 'ºC'),
	(31447, 108, '2015-02-01 00:07:34.000000', 'temperatura', 846.0000, 'ºC'),
	(31448, 108, '2015-02-01 00:07:35.000000', 'temperatura', 457.0000, 'ºC'),
	(31449, 108, '2015-02-01 00:07:36.000000', 'temperatura', 947.0000, 'ºC'),
	(31450, 108, '2015-02-01 00:07:37.000000', 'temperatura', 965.0000, 'ºC'),
	(31451, 108, '2015-02-01 00:07:38.000000', 'temperatura', 785.0000, 'ºC'),
	(31452, 108, '2015-02-01 00:07:39.000000', 'temperatura', 1029.0000, 'ºC'),
	(31453, 108, '2015-02-01 00:07:40.000000', 'temperatura', 392.0000, 'ºC'),
	(31454, 108, '2015-02-01 00:07:41.000000', 'temperatura', 72.0000, 'ºC'),
	(31455, 108, '2015-02-01 00:07:42.000000', 'temperatura', 384.0000, 'ºC'),
	(31456, 108, '2015-02-01 00:07:43.000000', 'temperatura', 506.0000, 'ºC'),
	(31457, 108, '2015-02-01 00:07:44.000000', 'temperatura', 179.0000, 'ºC'),
	(31458, 108, '2015-02-01 00:07:45.000000', 'temperatura', 579.0000, 'ºC'),
	(31459, 108, '2015-02-01 00:07:46.000000', 'temperatura', 1156.0000, 'ºC'),
	(31460, 108, '2015-02-01 00:07:47.000000', 'temperatura', 446.0000, 'ºC'),
	(31461, 108, '2015-02-01 00:07:48.000000', 'temperatura', 1162.0000, 'ºC'),
	(31462, 108, '2015-02-01 00:07:49.000000', 'temperatura', 870.0000, 'ºC'),
	(31463, 108, '2015-02-01 00:07:50.000000', 'temperatura', 868.0000, 'ºC'),
	(31464, 108, '2015-02-01 00:07:51.000000', 'temperatura', 528.0000, 'ºC'),
	(31465, 108, '2015-02-01 00:07:52.000000', 'temperatura', 37.0000, 'ºC'),
	(31466, 108, '2015-02-01 00:07:53.000000', 'temperatura', 1001.0000, 'ºC'),
	(31467, 108, '2015-02-01 00:07:54.000000', 'temperatura', 94.0000, 'ºC'),
	(31468, 108, '2015-02-01 00:07:55.000000', 'temperatura', 1070.0000, 'ºC'),
	(31469, 108, '2015-02-01 00:07:56.000000', 'temperatura', 268.0000, 'ºC'),
	(31470, 108, '2015-02-01 00:07:57.000000', 'temperatura', 532.0000, 'ºC'),
	(31471, 108, '2015-02-01 00:07:58.000000', 'temperatura', 655.0000, 'ºC'),
	(31472, 108, '2015-02-01 00:07:59.000000', 'temperatura', 478.0000, 'ºC'),
	(31473, 108, '2015-02-01 00:08:00.000000', 'temperatura', 427.0000, 'ºC'),
	(31474, 108, '2015-02-01 00:08:01.000000', 'temperatura', 699.0000, 'ºC'),
	(31475, 108, '2015-02-01 00:08:02.000000', 'temperatura', 1017.0000, 'ºC'),
	(31476, 108, '2015-02-01 00:08:03.000000', 'temperatura', 587.0000, 'ºC'),
	(31477, 108, '2015-02-01 00:08:04.000000', 'temperatura', 1087.0000, 'ºC'),
	(31478, 108, '2015-02-01 00:08:05.000000', 'temperatura', 73.0000, 'ºC'),
	(31479, 108, '2015-02-01 00:08:06.000000', 'temperatura', 704.0000, 'ºC'),
	(31480, 108, '2015-02-01 00:08:07.000000', 'temperatura', 900.0000, 'ºC'),
	(31481, 108, '2015-02-01 00:08:08.000000', 'temperatura', 1190.0000, 'ºC'),
	(31482, 108, '2015-02-01 00:08:09.000000', 'temperatura', 851.0000, 'ºC'),
	(31483, 108, '2015-02-01 00:08:10.000000', 'temperatura', 684.0000, 'ºC'),
	(31484, 108, '2015-02-01 00:08:11.000000', 'temperatura', 866.0000, 'ºC'),
	(31485, 108, '2015-02-01 00:08:12.000000', 'temperatura', 1081.0000, 'ºC'),
	(31486, 108, '2015-02-01 00:08:13.000000', 'temperatura', 406.0000, 'ºC'),
	(31487, 108, '2015-02-01 00:08:14.000000', 'temperatura', 1186.0000, 'ºC'),
	(31488, 108, '2015-02-01 00:08:15.000000', 'temperatura', 1114.0000, 'ºC'),
	(31489, 108, '2015-02-01 00:08:16.000000', 'temperatura', 815.0000, 'ºC'),
	(31490, 108, '2015-02-01 00:08:17.000000', 'temperatura', 730.0000, 'ºC'),
	(31491, 108, '2015-02-01 00:08:18.000000', 'temperatura', 5.0000, 'ºC'),
	(31492, 108, '2015-02-01 00:08:19.000000', 'temperatura', 237.0000, 'ºC'),
	(31493, 108, '2015-02-01 00:08:20.000000', 'temperatura', 1172.0000, 'ºC'),
	(31494, 108, '2015-02-01 00:08:21.000000', 'temperatura', 346.0000, 'ºC'),
	(31495, 108, '2015-02-01 00:08:22.000000', 'temperatura', 617.0000, 'ºC'),
	(31496, 108, '2015-02-01 00:08:23.000000', 'temperatura', 846.0000, 'ºC'),
	(31497, 108, '2015-02-01 00:08:24.000000', 'temperatura', 1180.0000, 'ºC'),
	(31498, 108, '2015-02-01 00:08:25.000000', 'temperatura', 961.0000, 'ºC'),
	(31499, 108, '2015-02-01 00:08:26.000000', 'temperatura', 67.0000, 'ºC'),
	(31500, 108, '2015-02-01 00:08:27.000000', 'temperatura', 1051.0000, 'ºC'),
	(31501, 108, '2015-02-01 00:08:28.000000', 'temperatura', 257.0000, 'ºC'),
	(31502, 108, '2015-02-01 00:08:29.000000', 'temperatura', 531.0000, 'ºC'),
	(31503, 108, '2015-02-01 00:08:30.000000', 'temperatura', 685.0000, 'ºC'),
	(31504, 108, '2015-02-01 00:08:31.000000', 'temperatura', 632.0000, 'ºC'),
	(31505, 108, '2015-02-01 00:08:32.000000', 'temperatura', 1105.0000, 'ºC'),
	(31506, 108, '2015-02-01 00:08:33.000000', 'temperatura', 31.0000, 'ºC'),
	(31507, 108, '2015-02-01 00:08:34.000000', 'temperatura', 441.0000, 'ºC'),
	(31508, 108, '2015-02-01 00:08:35.000000', 'temperatura', 913.0000, 'ºC'),
	(31509, 108, '2015-02-01 00:08:36.000000', 'temperatura', 842.0000, 'ºC'),
	(31510, 108, '2015-02-01 00:08:37.000000', 'temperatura', 273.0000, 'ºC'),
	(31511, 108, '2015-02-01 00:08:38.000000', 'temperatura', 40.0000, 'ºC'),
	(31512, 108, '2015-02-01 00:08:39.000000', 'temperatura', 578.0000, 'ºC'),
	(31513, 108, '2015-02-01 00:08:40.000000', 'temperatura', 374.0000, 'ºC'),
	(31514, 108, '2015-02-01 00:08:41.000000', 'temperatura', 135.0000, 'ºC'),
	(31515, 108, '2015-02-01 00:08:42.000000', 'temperatura', 752.0000, 'ºC'),
	(31516, 108, '2015-02-01 00:08:43.000000', 'temperatura', 957.0000, 'ºC'),
	(31517, 108, '2015-02-01 00:08:44.000000', 'temperatura', 129.0000, 'ºC'),
	(31518, 108, '2015-02-01 00:08:45.000000', 'temperatura', 175.0000, 'ºC'),
	(31519, 108, '2015-02-01 00:08:46.000000', 'temperatura', 487.0000, 'ºC'),
	(31520, 108, '2015-02-01 00:08:47.000000', 'temperatura', 713.0000, 'ºC'),
	(31521, 108, '2015-02-01 00:08:48.000000', 'temperatura', 905.0000, 'ºC'),
	(31522, 108, '2015-02-01 00:08:49.000000', 'temperatura', 1187.0000, 'ºC'),
	(31523, 108, '2015-02-01 00:08:50.000000', 'temperatura', 819.0000, 'ºC'),
	(31524, 108, '2015-02-01 00:08:51.000000', 'temperatura', 533.0000, 'ºC'),
	(31525, 108, '2015-02-01 00:08:52.000000', 'temperatura', 209.0000, 'ºC'),
	(31526, 108, '2015-02-01 00:08:53.000000', 'temperatura', 646.0000, 'ºC'),
	(31527, 108, '2015-02-01 00:08:54.000000', 'temperatura', 202.0000, 'ºC'),
	(31528, 108, '2015-02-01 00:08:55.000000', 'temperatura', 274.0000, 'ºC'),
	(31529, 108, '2015-02-01 00:08:56.000000', 'temperatura', 766.0000, 'ºC'),
	(31530, 108, '2015-02-01 00:08:57.000000', 'temperatura', 607.0000, 'ºC'),
	(31531, 108, '2015-02-01 00:08:58.000000', 'temperatura', 736.0000, 'ºC'),
	(31532, 108, '2015-02-01 00:08:59.000000', 'temperatura', 661.0000, 'ºC'),
	(31533, 108, '2015-02-01 00:09:00.000000', 'temperatura', 1098.0000, 'ºC'),
	(31534, 108, '2015-02-01 00:09:01.000000', 'temperatura', 1109.0000, 'ºC'),
	(31535, 108, '2015-02-01 00:09:02.000000', 'temperatura', 1051.0000, 'ºC'),
	(31536, 108, '2015-02-01 00:09:03.000000', 'temperatura', 727.0000, 'ºC'),
	(31537, 108, '2015-02-01 00:09:04.000000', 'temperatura', 485.0000, 'ºC'),
	(31538, 108, '2015-02-01 00:09:05.000000', 'temperatura', 242.0000, 'ºC'),
	(31539, 108, '2015-02-01 00:09:06.000000', 'temperatura', 957.0000, 'ºC'),
	(31540, 108, '2015-02-01 00:09:07.000000', 'temperatura', 461.0000, 'ºC'),
	(31541, 108, '2015-02-01 00:09:08.000000', 'temperatura', 633.0000, 'ºC'),
	(31542, 108, '2015-02-01 00:09:09.000000', 'temperatura', 584.0000, 'ºC'),
	(31543, 108, '2015-02-01 00:09:10.000000', 'temperatura', 1022.0000, 'ºC'),
	(31544, 108, '2015-02-01 00:09:11.000000', 'temperatura', 959.0000, 'ºC'),
	(31545, 108, '2015-02-01 00:09:12.000000', 'temperatura', 530.0000, 'ºC'),
	(31546, 108, '2015-02-01 00:09:13.000000', 'temperatura', 974.0000, 'ºC'),
	(31547, 108, '2015-02-01 00:09:14.000000', 'temperatura', 879.0000, 'ºC'),
	(31548, 108, '2015-02-01 00:09:15.000000', 'temperatura', 275.0000, 'ºC'),
	(31549, 108, '2015-02-01 00:09:16.000000', 'temperatura', 1139.0000, 'ºC'),
	(31550, 108, '2015-02-01 00:09:17.000000', 'temperatura', 70.0000, 'ºC'),
	(31551, 108, '2015-02-01 00:09:18.000000', 'temperatura', 532.0000, 'ºC'),
	(31552, 108, '2015-02-01 00:09:19.000000', 'temperatura', 50.0000, 'ºC'),
	(31553, 108, '2015-02-01 00:09:20.000000', 'temperatura', 1055.0000, 'ºC'),
	(31554, 108, '2015-02-01 00:09:21.000000', 'temperatura', 326.0000, 'ºC'),
	(31555, 108, '2015-02-01 00:09:22.000000', 'temperatura', 865.0000, 'ºC'),
	(31556, 108, '2015-02-01 00:09:23.000000', 'temperatura', 948.0000, 'ºC'),
	(31557, 108, '2015-02-01 00:09:24.000000', 'temperatura', 947.0000, 'ºC'),
	(31558, 108, '2015-02-01 00:09:25.000000', 'temperatura', 691.0000, 'ºC'),
	(31559, 108, '2015-02-01 00:09:26.000000', 'temperatura', 613.0000, 'ºC'),
	(31560, 108, '2015-02-01 00:09:27.000000', 'temperatura', 993.0000, 'ºC'),
	(31561, 108, '2015-02-01 00:09:28.000000', 'temperatura', 725.0000, 'ºC'),
	(31562, 108, '2015-02-01 00:09:29.000000', 'temperatura', 649.0000, 'ºC'),
	(31563, 108, '2015-02-01 00:09:30.000000', 'temperatura', 1070.0000, 'ºC'),
	(31564, 108, '2015-02-01 00:09:31.000000', 'temperatura', 1002.0000, 'ºC'),
	(31565, 108, '2015-02-01 00:09:32.000000', 'temperatura', 603.0000, 'ºC'),
	(31566, 108, '2015-02-01 00:09:33.000000', 'temperatura', 9.0000, 'ºC'),
	(31567, 108, '2015-02-01 00:09:34.000000', 'temperatura', 637.0000, 'ºC'),
	(31568, 108, '2015-02-01 00:09:35.000000', 'temperatura', 759.0000, 'ºC'),
	(31569, 108, '2015-02-01 00:09:36.000000', 'temperatura', 683.0000, 'ºC'),
	(31570, 108, '2015-02-01 00:09:37.000000', 'temperatura', 1141.0000, 'ºC'),
	(31571, 108, '2015-02-01 00:09:38.000000', 'temperatura', 55.0000, 'ºC'),
	(31572, 108, '2015-02-01 00:09:39.000000', 'temperatura', 454.0000, 'ºC'),
	(31573, 108, '2015-02-01 00:09:40.000000', 'temperatura', 903.0000, 'ºC'),
	(31574, 108, '2015-02-01 00:09:41.000000', 'temperatura', 756.0000, 'ºC'),
	(31575, 108, '2015-02-01 00:09:42.000000', 'temperatura', 1069.0000, 'ºC'),
	(31576, 108, '2015-02-01 00:09:43.000000', 'temperatura', 679.0000, 'ºC'),
	(31577, 108, '2015-02-01 00:09:44.000000', 'temperatura', 188.0000, 'ºC'),
	(31578, 108, '2015-02-01 00:09:45.000000', 'temperatura', 105.0000, 'ºC'),
	(31579, 108, '2015-02-01 00:09:46.000000', 'temperatura', 1162.0000, 'ºC'),
	(31580, 108, '2015-02-01 00:09:47.000000', 'temperatura', 692.0000, 'ºC'),
	(31581, 108, '2015-02-01 00:09:48.000000', 'temperatura', 1178.0000, 'ºC'),
	(31582, 108, '2015-02-01 00:09:49.000000', 'temperatura', 212.0000, 'ºC'),
	(31583, 108, '2015-02-01 00:09:50.000000', 'temperatura', 1127.0000, 'ºC'),
	(31584, 108, '2015-02-01 00:09:51.000000', 'temperatura', 199.0000, 'ºC'),
	(31585, 108, '2015-02-01 00:09:52.000000', 'temperatura', 17.0000, 'ºC'),
	(31586, 108, '2015-02-01 00:09:53.000000', 'temperatura', 685.0000, 'ºC'),
	(31587, 108, '2015-02-01 00:09:54.000000', 'temperatura', 978.0000, 'ºC'),
	(31588, 108, '2015-02-01 00:09:55.000000', 'temperatura', 433.0000, 'ºC'),
	(31589, 108, '2015-02-01 00:09:56.000000', 'temperatura', 433.0000, 'ºC'),
	(31590, 108, '2015-02-01 00:09:57.000000', 'temperatura', 864.0000, 'ºC'),
	(31591, 108, '2015-02-01 00:09:58.000000', 'temperatura', 624.0000, 'ºC'),
	(31592, 108, '2015-02-01 00:09:59.000000', 'temperatura', 526.0000, 'ºC'),
	(31593, 108, '2015-02-01 00:10:00.000000', 'temperatura', 760.0000, 'ºC'),
	(31594, 108, '2015-02-01 00:10:01.000000', 'temperatura', 1022.0000, 'ºC'),
	(31595, 108, '2015-02-01 00:10:02.000000', 'temperatura', 432.0000, 'ºC'),
	(31596, 108, '2015-02-01 00:10:03.000000', 'temperatura', 295.0000, 'ºC'),
	(31597, 108, '2015-02-01 00:10:04.000000', 'temperatura', 177.0000, 'ºC'),
	(31598, 108, '2015-02-01 00:10:05.000000', 'temperatura', 2.0000, 'ºC'),
	(31599, 108, '2015-02-01 00:10:06.000000', 'temperatura', 680.0000, 'ºC'),
	(31600, 108, '2015-02-01 00:10:07.000000', 'temperatura', 995.0000, 'ºC'),
	(31601, 108, '2015-02-01 00:10:08.000000', 'temperatura', 533.0000, 'ºC'),
	(31602, 108, '2015-02-01 00:10:09.000000', 'temperatura', 883.0000, 'ºC'),
	(31603, 108, '2015-02-01 00:10:10.000000', 'temperatura', 416.0000, 'ºC'),
	(31604, 108, '2015-02-01 00:10:11.000000', 'temperatura', 630.0000, 'ºC'),
	(31605, 108, '2015-02-01 00:10:12.000000', 'temperatura', 701.0000, 'ºC'),
	(31606, 108, '2015-02-01 00:10:13.000000', 'temperatura', 419.0000, 'ºC'),
	(31607, 108, '2015-02-01 00:10:14.000000', 'temperatura', 1189.0000, 'ºC'),
	(31608, 108, '2015-02-01 00:10:15.000000', 'temperatura', 1090.0000, 'ºC'),
	(31609, 108, '2015-02-01 00:10:16.000000', 'temperatura', 686.0000, 'ºC'),
	(31610, 108, '2015-02-01 00:10:17.000000', 'temperatura', 157.0000, 'ºC'),
	(31611, 108, '2015-02-01 00:10:18.000000', 'temperatura', 1129.0000, 'ºC'),
	(31612, 108, '2015-02-01 00:10:19.000000', 'temperatura', 373.0000, 'ºC'),
	(31613, 108, '2015-02-01 00:10:20.000000', 'temperatura', 879.0000, 'ºC'),
	(31614, 108, '2015-02-01 00:10:21.000000', 'temperatura', 875.0000, 'ºC'),
	(31615, 108, '2015-02-01 00:10:22.000000', 'temperatura', 542.0000, 'ºC'),
	(31616, 108, '2015-02-01 00:10:23.000000', 'temperatura', 83.0000, 'ºC'),
	(31617, 108, '2015-02-01 00:10:24.000000', 'temperatura', 1190.0000, 'ºC'),
	(31618, 108, '2015-02-01 00:10:25.000000', 'temperatura', 901.0000, 'ºC'),
	(31619, 108, '2015-02-01 00:10:26.000000', 'temperatura', 937.0000, 'ºC'),
	(31620, 108, '2015-02-01 00:10:27.000000', 'temperatura', 783.0000, 'ºC'),
	(31621, 108, '2015-02-01 00:10:28.000000', 'temperatura', 1104.0000, 'ºC'),
	(31622, 108, '2015-02-01 00:10:29.000000', 'temperatura', 770.0000, 'ºC'),
	(31623, 108, '2015-02-01 00:10:30.000000', 'temperatura', 538.0000, 'ºC'),
	(31624, 108, '2015-02-01 00:10:31.000000', 'temperatura', 380.0000, 'ºC'),
	(31625, 108, '2015-02-01 00:10:32.000000', 'temperatura', 288.0000, 'ºC'),
	(31626, 108, '2015-02-01 00:10:33.000000', 'temperatura', 301.0000, 'ºC'),
	(31627, 108, '2015-02-01 00:10:34.000000', 'temperatura', 641.0000, 'ºC'),
	(31628, 108, '2015-02-01 00:10:35.000000', 'temperatura', 1101.0000, 'ºC'),
	(31629, 108, '2015-02-01 00:10:36.000000', 'temperatura', 1183.0000, 'ºC'),
	(31630, 108, '2015-02-01 00:10:37.000000', 'temperatura', 211.0000, 'ºC'),
	(31631, 108, '2015-02-01 00:10:38.000000', 'temperatura', 1108.0000, 'ºC'),
	(31632, 108, '2015-02-01 00:10:39.000000', 'temperatura', 105.0000, 'ºC'),
	(31633, 108, '2015-02-01 00:10:40.000000', 'temperatura', 804.0000, 'ºC'),
	(31634, 108, '2015-02-01 00:10:41.000000', 'temperatura', 107.0000, 'ºC'),
	(31635, 108, '2015-02-01 00:10:42.000000', 'temperatura', 521.0000, 'ºC'),
	(31636, 108, '2015-02-01 00:10:43.000000', 'temperatura', 1084.0000, 'ºC'),
	(31637, 108, '2015-02-01 00:10:44.000000', 'temperatura', 260.0000, 'ºC'),
	(31638, 108, '2015-02-01 00:10:45.000000', 'temperatura', 445.0000, 'ºC'),
	(31639, 108, '2015-02-01 00:10:46.000000', 'temperatura', 249.0000, 'ºC'),
	(31640, 108, '2015-02-01 00:10:47.000000', 'temperatura', 1109.0000, 'ºC'),
	(31641, 108, '2015-02-01 00:10:48.000000', 'temperatura', 1197.0000, 'ºC'),
	(31642, 108, '2015-02-01 00:10:49.000000', 'temperatura', 260.0000, 'ºC'),
	(31643, 108, '2015-02-01 00:10:50.000000', 'temperatura', 108.0000, 'ºC'),
	(31644, 108, '2015-02-01 00:10:51.000000', 'temperatura', 961.0000, 'ºC'),
	(31645, 108, '2015-02-01 00:10:52.000000', 'temperatura', 881.0000, 'ºC'),
	(31646, 108, '2015-02-01 00:10:53.000000', 'temperatura', 321.0000, 'ºC'),
	(31647, 108, '2015-02-01 00:10:54.000000', 'temperatura', 165.0000, 'ºC'),
	(31648, 108, '2015-02-01 00:10:55.000000', 'temperatura', 1061.0000, 'ºC'),
	(31649, 108, '2015-02-01 00:10:56.000000', 'temperatura', 12.0000, 'ºC'),
	(31650, 108, '2015-02-01 00:10:57.000000', 'temperatura', 478.0000, 'ºC'),
	(31651, 108, '2015-02-01 00:10:58.000000', 'temperatura', 1153.0000, 'ºC'),
	(31652, 108, '2015-02-01 00:10:59.000000', 'temperatura', 730.0000, 'ºC'),
	(31653, 108, '2015-02-01 00:11:00.000000', 'temperatura', 193.0000, 'ºC'),
	(31654, 108, '2015-02-01 00:11:01.000000', 'temperatura', 1174.0000, 'ºC'),
	(31655, 108, '2015-02-01 00:11:02.000000', 'temperatura', 490.0000, 'ºC'),
	(31656, 108, '2015-02-01 00:11:03.000000', 'temperatura', 132.0000, 'ºC'),
	(31657, 108, '2015-02-01 00:11:04.000000', 'temperatura', 388.0000, 'ºC'),
	(31658, 108, '2015-02-01 00:11:05.000000', 'temperatura', 347.0000, 'ºC'),
	(31659, 108, '2015-02-01 00:11:06.000000', 'temperatura', 570.0000, 'ºC'),
	(31660, 108, '2015-02-01 00:11:07.000000', 'temperatura', 609.0000, 'ºC'),
	(31661, 108, '2015-02-01 00:11:08.000000', 'temperatura', 137.0000, 'ºC'),
	(31662, 108, '2015-02-01 00:11:09.000000', 'temperatura', 58.0000, 'ºC'),
	(31663, 108, '2015-02-01 00:11:10.000000', 'temperatura', 1080.0000, 'ºC'),
	(31664, 108, '2015-02-01 00:11:11.000000', 'temperatura', 425.0000, 'ºC'),
	(31665, 108, '2015-02-01 00:11:12.000000', 'temperatura', 88.0000, 'ºC'),
	(31666, 108, '2015-02-01 00:11:13.000000', 'temperatura', 364.0000, 'ºC'),
	(31667, 108, '2015-02-01 00:11:14.000000', 'temperatura', 355.0000, 'ºC'),
	(31668, 108, '2015-02-01 00:11:15.000000', 'temperatura', 686.0000, 'ºC'),
	(31669, 108, '2015-02-01 00:11:16.000000', 'temperatura', 1163.0000, 'ºC'),
	(31670, 108, '2015-02-01 00:11:17.000000', 'temperatura', 158.0000, 'ºC'),
	(31671, 108, '2015-02-01 00:11:18.000000', 'temperatura', 903.0000, 'ºC'),
	(31672, 108, '2015-02-01 00:11:19.000000', 'temperatura', 443.0000, 'ºC'),
	(31673, 108, '2015-02-01 00:11:20.000000', 'temperatura', 704.0000, 'ºC'),
	(31674, 108, '2015-02-01 00:11:21.000000', 'temperatura', 991.0000, 'ºC'),
	(31675, 108, '2015-02-01 00:11:22.000000', 'temperatura', 442.0000, 'ºC'),
	(31676, 108, '2015-02-01 00:11:23.000000', 'temperatura', 440.0000, 'ºC'),
	(31677, 108, '2015-02-01 00:11:24.000000', 'temperatura', 874.0000, 'ºC'),
	(31678, 108, '2015-02-01 00:11:25.000000', 'temperatura', 650.0000, 'ºC'),
	(31679, 108, '2015-02-01 00:11:26.000000', 'temperatura', 629.0000, 'ºC'),
	(31680, 108, '2015-02-01 00:11:27.000000', 'temperatura', 1195.0000, 'ºC'),
	(31681, 108, '2015-02-01 00:11:28.000000', 'temperatura', 489.0000, 'ºC'),
	(31682, 108, '2015-02-01 00:11:29.000000', 'temperatura', 61.0000, 'ºC'),
	(31683, 108, '2015-02-01 00:11:30.000000', 'temperatura', 39.0000, 'ºC'),
	(31684, 108, '2015-02-01 00:11:31.000000', 'temperatura', 11.0000, 'ºC'),
	(31685, 108, '2015-02-01 00:11:32.000000', 'temperatura', 1139.0000, 'ºC'),
	(31686, 108, '2015-02-01 00:11:33.000000', 'temperatura', 863.0000, 'ºC'),
	(31687, 108, '2015-02-01 00:11:34.000000', 'temperatura', 899.0000, 'ºC'),
	(31688, 108, '2015-02-01 00:11:35.000000', 'temperatura', 706.0000, 'ºC'),
	(31689, 108, '2015-02-01 00:11:36.000000', 'temperatura', 833.0000, 'ºC'),
	(31690, 108, '2015-02-01 00:11:37.000000', 'temperatura', 850.0000, 'ºC'),
	(31691, 108, '2015-02-01 00:11:38.000000', 'temperatura', 549.0000, 'ºC'),
	(31692, 108, '2015-02-01 00:11:39.000000', 'temperatura', 198.0000, 'ºC'),
	(31693, 108, '2015-02-01 00:11:40.000000', 'temperatura', 541.0000, 'ºC'),
	(31694, 108, '2015-02-01 00:11:41.000000', 'temperatura', 914.0000, 'ºC'),
	(31695, 108, '2015-02-01 00:11:42.000000', 'temperatura', 547.0000, 'ºC'),
	(31696, 108, '2015-02-01 00:11:43.000000', 'temperatura', 1194.0000, 'ºC'),
	(31697, 108, '2015-02-01 00:11:44.000000', 'temperatura', 728.0000, 'ºC'),
	(31698, 108, '2015-02-01 00:11:45.000000', 'temperatura', 61.0000, 'ºC'),
	(31699, 108, '2015-02-01 00:11:46.000000', 'temperatura', 521.0000, 'ºC'),
	(31700, 108, '2015-02-01 00:11:47.000000', 'temperatura', 21.0000, 'ºC'),
	(31701, 108, '2015-02-01 00:11:48.000000', 'temperatura', 942.0000, 'ºC'),
	(31702, 108, '2015-02-01 00:11:49.000000', 'temperatura', 1050.0000, 'ºC'),
	(31703, 108, '2015-02-01 00:11:50.000000', 'temperatura', 25.0000, 'ºC'),
	(31704, 108, '2015-02-01 00:11:51.000000', 'temperatura', 573.0000, 'ºC'),
	(31705, 108, '2015-02-01 00:11:52.000000', 'temperatura', 391.0000, 'ºC'),
	(31706, 108, '2015-02-01 00:11:53.000000', 'temperatura', 238.0000, 'ºC'),
	(31707, 108, '2015-02-01 00:11:54.000000', 'temperatura', 17.0000, 'ºC'),
	(31708, 108, '2015-02-01 00:11:55.000000', 'temperatura', 573.0000, 'ºC'),
	(31709, 108, '2015-02-01 00:11:56.000000', 'temperatura', 413.0000, 'ºC'),
	(31710, 108, '2015-02-01 00:11:57.000000', 'temperatura', 346.0000, 'ºC'),
	(31711, 108, '2015-02-01 00:11:58.000000', 'temperatura', 492.0000, 'ºC'),
	(31712, 108, '2015-02-01 00:11:59.000000', 'temperatura', 221.0000, 'ºC'),
	(31713, 108, '2015-02-01 00:12:00.000000', 'temperatura', 829.0000, 'ºC'),
	(31714, 108, '2015-02-01 00:12:01.000000', 'temperatura', 1083.0000, 'ºC'),
	(31715, 108, '2015-02-01 00:12:02.000000', 'temperatura', 528.0000, 'ºC'),
	(31716, 108, '2015-02-01 00:12:03.000000', 'temperatura', 593.0000, 'ºC'),
	(31717, 108, '2015-02-01 00:12:04.000000', 'temperatura', 180.0000, 'ºC'),
	(31718, 108, '2015-02-01 00:12:05.000000', 'temperatura', 322.0000, 'ºC'),
	(31719, 108, '2015-02-01 00:12:06.000000', 'temperatura', 1072.0000, 'ºC'),
	(31720, 108, '2015-02-01 00:12:07.000000', 'temperatura', 795.0000, 'ºC'),
	(31721, 108, '2015-02-01 00:12:08.000000', 'temperatura', 758.0000, 'ºC'),
	(31722, 108, '2015-02-01 00:12:09.000000', 'temperatura', 207.0000, 'ºC'),
	(31723, 108, '2015-02-01 00:12:10.000000', 'temperatura', 1159.0000, 'ºC'),
	(31724, 108, '2015-02-01 00:12:11.000000', 'temperatura', 375.0000, 'ºC'),
	(31725, 108, '2015-02-01 00:12:12.000000', 'temperatura', 799.0000, 'ºC'),
	(31726, 108, '2015-02-01 00:12:13.000000', 'temperatura', 472.0000, 'ºC'),
	(31727, 108, '2015-02-01 00:12:14.000000', 'temperatura', 1163.0000, 'ºC'),
	(31728, 108, '2015-02-01 00:12:15.000000', 'temperatura', 798.0000, 'ºC'),
	(31729, 108, '2015-02-01 00:12:16.000000', 'temperatura', 504.0000, 'ºC'),
	(31730, 108, '2015-02-01 00:12:17.000000', 'temperatura', 127.0000, 'ºC'),
	(31731, 108, '2015-02-01 00:12:18.000000', 'temperatura', 321.0000, 'ºC'),
	(31732, 108, '2015-02-01 00:12:19.000000', 'temperatura', 24.0000, 'ºC'),
	(31733, 108, '2015-02-01 00:12:20.000000', 'temperatura', 360.0000, 'ºC'),
	(31734, 108, '2015-02-01 00:12:21.000000', 'temperatura', 526.0000, 'ºC'),
	(31735, 108, '2015-02-01 00:12:22.000000', 'temperatura', 352.0000, 'ºC'),
	(31736, 108, '2015-02-01 00:12:23.000000', 'temperatura', 184.0000, 'ºC'),
	(31737, 108, '2015-02-01 00:12:24.000000', 'temperatura', 1064.0000, 'ºC'),
	(31738, 108, '2015-02-01 00:12:25.000000', 'temperatura', 1166.0000, 'ºC'),
	(31739, 108, '2015-02-01 00:12:26.000000', 'temperatura', 242.0000, 'ºC'),
	(31740, 108, '2015-02-01 00:12:27.000000', 'temperatura', 110.0000, 'ºC'),
	(31741, 108, '2015-02-01 00:12:28.000000', 'temperatura', 1026.0000, 'ºC'),
	(31742, 108, '2015-02-01 00:12:29.000000', 'temperatura', 0.0000, 'ºC'),
	(31743, 108, '2015-02-01 00:12:30.000000', 'temperatura', 522.0000, 'ºC'),
	(31744, 108, '2015-02-01 00:12:31.000000', 'temperatura', 212.0000, 'ºC'),
	(31745, 108, '2015-02-01 00:12:32.000000', 'temperatura', 692.0000, 'ºC'),
	(31746, 108, '2015-02-01 00:12:33.000000', 'temperatura', 425.0000, 'ºC'),
	(31747, 108, '2015-02-01 00:12:34.000000', 'temperatura', 50.0000, 'ºC'),
	(31748, 108, '2015-02-01 00:12:35.000000', 'temperatura', 175.0000, 'ºC'),
	(31749, 108, '2015-02-01 00:12:36.000000', 'temperatura', 727.0000, 'ºC'),
	(31750, 108, '2015-02-01 00:12:37.000000', 'temperatura', 708.0000, 'ºC'),
	(31751, 108, '2015-02-01 00:12:38.000000', 'temperatura', 161.0000, 'ºC'),
	(31752, 108, '2015-02-01 00:12:39.000000', 'temperatura', 1083.0000, 'ºC'),
	(31753, 108, '2015-02-01 00:12:40.000000', 'temperatura', 131.0000, 'ºC'),
	(31754, 108, '2015-02-01 00:12:41.000000', 'temperatura', 1008.0000, 'ºC'),
	(31755, 108, '2015-02-01 00:12:42.000000', 'temperatura', 1045.0000, 'ºC'),
	(31756, 108, '2015-02-01 00:12:43.000000', 'temperatura', 1002.0000, 'ºC'),
	(31757, 108, '2015-02-01 00:12:44.000000', 'temperatura', 674.0000, 'ºC'),
	(31758, 108, '2015-02-01 00:12:45.000000', 'temperatura', 367.0000, 'ºC'),
	(31759, 108, '2015-02-01 00:12:46.000000', 'temperatura', 1012.0000, 'ºC'),
	(31760, 108, '2015-02-01 00:12:47.000000', 'temperatura', 361.0000, 'ºC'),
	(31761, 108, '2015-02-01 00:12:48.000000', 'temperatura', 1169.0000, 'ºC'),
	(31762, 108, '2015-02-01 00:12:49.000000', 'temperatura', 1162.0000, 'ºC'),
	(31763, 108, '2015-02-01 00:12:50.000000', 'temperatura', 1103.0000, 'ºC'),
	(31764, 108, '2015-02-01 00:12:51.000000', 'temperatura', 832.0000, 'ºC'),
	(31765, 108, '2015-02-01 00:12:52.000000', 'temperatura', 850.0000, 'ºC'),
	(31766, 108, '2015-02-01 00:12:53.000000', 'temperatura', 553.0000, 'ºC'),
	(31767, 108, '2015-02-01 00:12:54.000000', 'temperatura', 215.0000, 'ºC'),
	(31768, 108, '2015-02-01 00:12:55.000000', 'temperatura', 619.0000, 'ºC'),
	(31769, 108, '2015-02-01 00:12:56.000000', 'temperatura', 49.0000, 'ºC'),
	(31770, 108, '2015-02-01 00:12:57.000000', 'temperatura', 790.0000, 'ºC'),
	(31771, 108, '2015-02-01 00:12:58.000000', 'temperatura', 203.0000, 'ºC'),
	(31772, 108, '2015-02-01 00:12:59.000000', 'temperatura', 1046.0000, 'ºC'),
	(31773, 108, '2015-02-01 00:13:00.000000', 'temperatura', 1019.0000, 'ºC'),
	(31774, 108, '2015-02-01 00:13:01.000000', 'temperatura', 759.0000, 'ºC'),
	(31775, 108, '2015-02-01 00:13:02.000000', 'temperatura', 738.0000, 'ºC'),
	(31776, 108, '2015-02-01 00:13:03.000000', 'temperatura', 214.0000, 'ºC'),
	(31777, 108, '2015-02-01 00:13:04.000000', 'temperatura', 58.0000, 'ºC'),
	(31778, 108, '2015-02-01 00:13:05.000000', 'temperatura', 849.0000, 'ºC'),
	(31779, 108, '2015-02-01 00:13:06.000000', 'temperatura', 470.0000, 'ºC'),
	(31780, 108, '2015-02-01 00:13:07.000000', 'temperatura', 1004.0000, 'ºC'),
	(31781, 108, '2015-02-01 00:13:08.000000', 'temperatura', 12.0000, 'ºC'),
	(31782, 108, '2015-02-01 00:13:09.000000', 'temperatura', 649.0000, 'ºC'),
	(31783, 108, '2015-02-01 00:13:10.000000', 'temperatura', 808.0000, 'ºC'),
	(31784, 108, '2015-02-01 00:13:11.000000', 'temperatura', 892.0000, 'ºC'),
	(31785, 108, '2015-02-01 00:13:12.000000', 'temperatura', 837.0000, 'ºC'),
	(31786, 108, '2015-02-01 00:13:13.000000', 'temperatura', 309.0000, 'ºC'),
	(31787, 108, '2015-02-01 00:13:14.000000', 'temperatura', 237.0000, 'ºC'),
	(31788, 108, '2015-02-01 00:13:15.000000', 'temperatura', 256.0000, 'ºC'),
	(31789, 108, '2015-02-01 00:13:16.000000', 'temperatura', 568.0000, 'ºC'),
	(31790, 108, '2015-02-01 00:13:17.000000', 'temperatura', 875.0000, 'ºC'),
	(31791, 108, '2015-02-01 00:13:18.000000', 'temperatura', 272.0000, 'ºC'),
	(31792, 108, '2015-02-01 00:13:19.000000', 'temperatura', 1135.0000, 'ºC'),
	(31793, 108, '2015-02-01 00:13:20.000000', 'temperatura', 59.0000, 'ºC'),
	(31794, 108, '2015-02-01 00:13:21.000000', 'temperatura', 490.0000, 'ºC'),
	(31795, 108, '2015-02-01 00:13:22.000000', 'temperatura', 1075.0000, 'ºC'),
	(31796, 108, '2015-02-01 00:13:23.000000', 'temperatura', 306.0000, 'ºC'),
	(31797, 108, '2015-02-01 00:13:24.000000', 'temperatura', 704.0000, 'ºC'),
	(31798, 108, '2015-02-01 00:13:25.000000', 'temperatura', 205.0000, 'ºC'),
	(31799, 108, '2015-02-01 00:13:26.000000', 'temperatura', 111.0000, 'ºC'),
	(31800, 108, '2015-02-01 00:13:27.000000', 'temperatura', 1141.0000, 'ºC'),
	(31801, 108, '2015-02-01 00:13:28.000000', 'temperatura', 575.0000, 'ºC'),
	(31802, 108, '2015-02-01 00:13:29.000000', 'temperatura', 649.0000, 'ºC'),
	(31803, 108, '2015-02-01 00:13:30.000000', 'temperatura', 321.0000, 'ºC'),
	(31804, 108, '2015-02-01 00:13:31.000000', 'temperatura', 860.0000, 'ºC'),
	(31805, 108, '2015-02-01 00:13:32.000000', 'temperatura', 937.0000, 'ºC'),
	(31806, 108, '2015-02-01 00:13:33.000000', 'temperatura', 906.0000, 'ºC'),
	(31807, 108, '2015-02-01 00:13:34.000000', 'temperatura', 521.0000, 'ºC'),
	(31808, 108, '2015-02-01 00:13:35.000000', 'temperatura', 1085.0000, 'ºC'),
	(31809, 108, '2015-02-01 00:13:36.000000', 'temperatura', 263.0000, 'ºC'),
	(31810, 108, '2015-02-01 00:13:37.000000', 'temperatura', 461.0000, 'ºC'),
	(31811, 108, '2015-02-01 00:13:38.000000', 'temperatura', 318.0000, 'ºC'),
	(31812, 108, '2015-02-01 00:13:39.000000', 'temperatura', 205.0000, 'ºC'),
	(31813, 108, '2015-02-01 00:13:40.000000', 'temperatura', 73.0000, 'ºC'),
	(31814, 108, '2015-02-01 00:13:41.000000', 'temperatura', 951.0000, 'ºC'),
	(31815, 108, '2015-02-01 00:13:42.000000', 'temperatura', 935.0000, 'ºC'),
	(31816, 108, '2015-02-01 00:13:43.000000', 'temperatura', 623.0000, 'ºC'),
	(31817, 108, '2015-02-01 00:13:44.000000', 'temperatura', 311.0000, 'ºC'),
	(31818, 108, '2015-02-01 00:13:45.000000', 'temperatura', 885.0000, 'ºC'),
	(31819, 108, '2015-02-01 00:13:46.000000', 'temperatura', 1095.0000, 'ºC'),
	(31820, 108, '2015-02-01 00:13:47.000000', 'temperatura', 418.0000, 'ºC'),
	(31821, 108, '2015-02-01 00:13:48.000000', 'temperatura', 6.0000, 'ºC'),
	(31822, 108, '2015-02-01 00:13:49.000000', 'temperatura', 1177.0000, 'ºC'),
	(31823, 108, '2015-02-01 00:13:50.000000', 'temperatura', 1067.0000, 'ºC'),
	(31824, 108, '2015-02-01 00:13:51.000000', 'temperatura', 605.0000, 'ºC'),
	(31825, 108, '2015-02-01 00:13:52.000000', 'temperatura', 1024.0000, 'ºC'),
	(31826, 108, '2015-02-01 00:13:53.000000', 'temperatura', 907.0000, 'ºC'),
	(31827, 108, '2015-02-01 00:13:54.000000', 'temperatura', 264.0000, 'ºC'),
	(31828, 108, '2015-02-01 00:13:55.000000', 'temperatura', 1000.0000, 'ºC'),
	(31829, 108, '2015-02-01 00:13:56.000000', 'temperatura', 609.0000, 'ºC'),
	(31830, 108, '2015-02-01 00:13:57.000000', 'temperatura', 45.0000, 'ºC'),
	(31831, 108, '2015-02-01 00:13:58.000000', 'temperatura', 796.0000, 'ºC'),
	(31832, 108, '2015-02-01 00:13:59.000000', 'temperatura', 247.0000, 'ºC'),
	(31833, 108, '2015-02-01 00:14:00.000000', 'temperatura', 49.0000, 'ºC'),
	(31834, 108, '2015-02-01 00:14:01.000000', 'temperatura', 705.0000, 'ºC'),
	(31835, 108, '2015-02-01 00:14:02.000000', 'temperatura', 977.0000, 'ºC'),
	(31836, 108, '2015-02-01 00:14:03.000000', 'temperatura', 371.0000, 'ºC'),
	(31837, 108, '2015-02-01 00:14:04.000000', 'temperatura', 123.0000, 'ºC'),
	(31838, 108, '2015-02-01 00:14:05.000000', 'temperatura', 705.0000, 'ºC'),
	(31839, 108, '2015-02-01 00:14:06.000000', 'temperatura', 757.0000, 'ºC'),
	(31840, 108, '2015-02-01 00:14:07.000000', 'temperatura', 470.0000, 'ºC'),
	(31841, 108, '2015-02-01 00:14:08.000000', 'temperatura', 79.0000, 'ºC'),
	(31842, 108, '2015-02-01 00:14:09.000000', 'temperatura', 184.0000, 'ºC'),
	(31843, 108, '2015-02-01 00:14:10.000000', 'temperatura', 685.0000, 'ºC'),
	(31844, 108, '2015-02-01 00:14:11.000000', 'temperatura', 475.0000, 'ºC'),
	(31845, 108, '2015-02-01 00:14:12.000000', 'temperatura', 318.0000, 'ºC'),
	(31846, 108, '2015-02-01 00:14:13.000000', 'temperatura', 168.0000, 'ºC'),
	(31847, 108, '2015-02-01 00:14:14.000000', 'temperatura', 1085.0000, 'ºC'),
	(31848, 108, '2015-02-01 00:14:15.000000', 'temperatura', 122.0000, 'ºC'),
	(31849, 108, '2015-02-01 00:14:16.000000', 'temperatura', 957.0000, 'ºC'),
	(31850, 108, '2015-02-01 00:14:17.000000', 'temperatura', 818.0000, 'ºC'),
	(31851, 108, '2015-02-01 00:14:18.000000', 'temperatura', 19.0000, 'ºC'),
	(31852, 108, '2015-02-01 00:14:19.000000', 'temperatura', 44.0000, 'ºC'),
	(31853, 108, '2015-02-01 00:14:20.000000', 'temperatura', 161.0000, 'ºC'),
	(31854, 108, '2015-02-01 00:14:21.000000', 'temperatura', 673.0000, 'ºC'),
	(31855, 108, '2015-02-01 00:14:22.000000', 'temperatura', 481.0000, 'ºC'),
	(31856, 108, '2015-02-01 00:14:23.000000', 'temperatura', 389.0000, 'ºC'),
	(31857, 108, '2015-02-01 00:14:24.000000', 'temperatura', 503.0000, 'ºC'),
	(31858, 108, '2015-02-01 00:14:25.000000', 'temperatura', 147.0000, 'ºC'),
	(31859, 108, '2015-02-01 00:14:26.000000', 'temperatura', 429.0000, 'ºC'),
	(31860, 108, '2015-02-01 00:14:27.000000', 'temperatura', 504.0000, 'ºC'),
	(31861, 108, '2015-02-01 00:14:28.000000', 'temperatura', 31.0000, 'ºC'),
	(31862, 108, '2015-02-01 00:14:29.000000', 'temperatura', 1047.0000, 'ºC'),
	(31863, 108, '2015-02-01 00:14:30.000000', 'temperatura', 340.0000, 'ºC'),
	(31864, 108, '2015-02-01 00:14:31.000000', 'temperatura', 962.0000, 'ºC'),
	(31865, 108, '2015-02-01 00:14:32.000000', 'temperatura', 188.0000, 'ºC'),
	(31866, 108, '2015-02-01 00:14:33.000000', 'temperatura', 457.0000, 'ºC'),
	(31867, 108, '2015-02-01 00:14:34.000000', 'temperatura', 519.0000, 'ºC'),
	(31868, 108, '2015-02-01 00:14:35.000000', 'temperatura', 24.0000, 'ºC'),
	(31869, 108, '2015-02-01 00:14:36.000000', 'temperatura', 963.0000, 'ºC'),
	(31870, 108, '2015-02-01 00:14:37.000000', 'temperatura', 1143.0000, 'ºC'),
	(31871, 108, '2015-02-01 00:14:38.000000', 'temperatura', 429.0000, 'ºC'),
	(31872, 108, '2015-02-01 00:14:39.000000', 'temperatura', 1116.0000, 'ºC'),
	(31873, 108, '2015-02-01 00:14:40.000000', 'temperatura', 695.0000, 'ºC'),
	(31874, 108, '2015-02-01 00:14:41.000000', 'temperatura', 125.0000, 'ºC'),
	(31875, 108, '2015-02-01 00:14:42.000000', 'temperatura', 942.0000, 'ºC'),
	(31876, 108, '2015-02-01 00:14:43.000000', 'temperatura', 734.0000, 'ºC'),
	(31877, 108, '2015-02-01 00:14:44.000000', 'temperatura', 846.0000, 'ºC'),
	(31878, 108, '2015-02-01 00:14:45.000000', 'temperatura', 828.0000, 'ºC'),
	(31879, 108, '2015-02-01 00:14:46.000000', 'temperatura', 402.0000, 'ºC'),
	(31880, 108, '2015-02-01 00:14:47.000000', 'temperatura', 726.0000, 'ºC'),
	(31881, 108, '2015-02-01 00:14:48.000000', 'temperatura', 26.0000, 'ºC'),
	(31882, 108, '2015-02-01 00:14:49.000000', 'temperatura', 351.0000, 'ºC'),
	(31883, 108, '2015-02-01 00:14:50.000000', 'temperatura', 479.0000, 'ºC'),
	(31884, 108, '2015-02-01 00:14:51.000000', 'temperatura', 142.0000, 'ºC'),
	(31885, 108, '2015-02-01 00:14:52.000000', 'temperatura', 471.0000, 'ºC'),
	(31886, 108, '2015-02-01 00:14:53.000000', 'temperatura', 733.0000, 'ºC'),
	(31887, 108, '2015-02-01 00:14:54.000000', 'temperatura', 1050.0000, 'ºC'),
	(31888, 108, '2015-02-01 00:14:55.000000', 'temperatura', 651.0000, 'ºC'),
	(31889, 108, '2015-02-01 00:14:56.000000', 'temperatura', 108.0000, 'ºC'),
	(31890, 108, '2015-02-01 00:14:57.000000', 'temperatura', 988.0000, 'ºC'),
	(31891, 108, '2015-02-01 00:14:58.000000', 'temperatura', 1014.0000, 'ºC'),
	(31892, 108, '2015-02-01 00:14:59.000000', 'temperatura', 907.0000, 'ºC'),
	(31893, 108, '2015-02-01 00:15:00.000000', 'temperatura', 293.0000, 'ºC'),
	(31894, 108, '2015-02-01 00:15:01.000000', 'temperatura', 1147.0000, 'ºC'),
	(31895, 108, '2015-02-01 00:15:02.000000', 'temperatura', 55.0000, 'ºC'),
	(31896, 108, '2015-02-01 00:15:03.000000', 'temperatura', 434.0000, 'ºC'),
	(31897, 108, '2015-02-01 00:15:04.000000', 'temperatura', 807.0000, 'ºC'),
	(31898, 108, '2015-02-01 00:15:05.000000', 'temperatura', 333.0000, 'ºC'),
	(31899, 108, '2015-02-01 00:15:06.000000', 'temperatura', 445.0000, 'ºC'),
	(31900, 108, '2015-02-01 00:15:07.000000', 'temperatura', 24.0000, 'ºC'),
	(31901, 108, '2015-02-01 00:15:08.000000', 'temperatura', 1186.0000, 'ºC'),
	(31902, 108, '2015-02-01 00:15:09.000000', 'temperatura', 1061.0000, 'ºC'),
	(31903, 108, '2015-02-01 00:15:10.000000', 'temperatura', 547.0000, 'ºC'),
	(31904, 108, '2015-02-01 00:15:11.000000', 'temperatura', 752.0000, 'ºC'),
	(31905, 108, '2015-02-01 00:15:12.000000', 'temperatura', 920.0000, 'ºC'),
	(31906, 108, '2015-02-01 00:15:13.000000', 'temperatura', 1145.0000, 'ºC'),
	(31907, 108, '2015-02-01 00:15:14.000000', 'temperatura', 564.0000, 'ºC'),
	(31908, 108, '2015-02-01 00:15:15.000000', 'temperatura', 585.0000, 'ºC'),
	(31909, 108, '2015-02-01 00:15:16.000000', 'temperatura', 35.0000, 'ºC'),
	(31910, 108, '2015-02-01 00:15:17.000000', 'temperatura', 819.0000, 'ºC'),
	(31911, 108, '2015-02-01 00:15:18.000000', 'temperatura', 391.0000, 'ºC'),
	(31912, 108, '2015-02-01 00:15:19.000000', 'temperatura', 698.0000, 'ºC'),
	(31913, 108, '2015-02-01 00:15:20.000000', 'temperatura', 1117.0000, 'ºC'),
	(31914, 108, '2015-02-01 00:15:21.000000', 'temperatura', 1092.0000, 'ºC'),
	(31915, 108, '2015-02-01 00:15:22.000000', 'temperatura', 911.0000, 'ºC'),
	(31916, 108, '2015-02-01 00:15:23.000000', 'temperatura', 79.0000, 'ºC'),
	(31917, 108, '2015-02-01 00:15:24.000000', 'temperatura', 62.0000, 'ºC'),
	(31918, 108, '2015-02-01 00:15:25.000000', 'temperatura', 72.0000, 'ºC'),
	(31919, 108, '2015-02-01 00:15:26.000000', 'temperatura', 177.0000, 'ºC'),
	(31920, 108, '2015-02-01 00:15:27.000000', 'temperatura', 669.0000, 'ºC'),
	(31921, 108, '2015-02-01 00:15:28.000000', 'temperatura', 415.0000, 'ºC'),
	(31922, 108, '2015-02-01 00:15:29.000000', 'temperatura', 68.0000, 'ºC'),
	(31923, 108, '2015-02-01 00:15:30.000000', 'temperatura', 295.0000, 'ºC'),
	(31924, 108, '2015-02-01 00:15:31.000000', 'temperatura', 72.0000, 'ºC'),
	(31925, 108, '2015-02-01 00:15:32.000000', 'temperatura', 677.0000, 'ºC'),
	(31926, 108, '2015-02-01 00:15:33.000000', 'temperatura', 768.0000, 'ºC'),
	(31927, 108, '2015-02-01 00:15:34.000000', 'temperatura', 608.0000, 'ºC'),
	(31928, 108, '2015-02-01 00:15:35.000000', 'temperatura', 740.0000, 'ºC'),
	(31929, 108, '2015-02-01 00:15:36.000000', 'temperatura', 674.0000, 'ºC'),
	(31930, 108, '2015-02-01 00:15:37.000000', 'temperatura', 1152.0000, 'ºC'),
	(31931, 108, '2015-02-01 00:15:38.000000', 'temperatura', 139.0000, 'ºC'),
	(31932, 108, '2015-02-01 00:15:39.000000', 'temperatura', 837.0000, 'ºC'),
	(31933, 108, '2015-02-01 00:15:40.000000', 'temperatura', 172.0000, 'ºC'),
	(31934, 108, '2015-02-01 00:15:41.000000', 'temperatura', 747.0000, 'ºC'),
	(31935, 108, '2015-02-01 00:15:42.000000', 'temperatura', 819.0000, 'ºC'),
	(31936, 108, '2015-02-01 00:15:43.000000', 'temperatura', 653.0000, 'ºC'),
	(31937, 108, '2015-02-01 00:15:44.000000', 'temperatura', 811.0000, 'ºC'),
	(31938, 108, '2015-02-01 00:15:45.000000', 'temperatura', 896.0000, 'ºC'),
	(31939, 108, '2015-02-01 00:15:46.000000', 'temperatura', 847.0000, 'ºC'),
	(31940, 108, '2015-02-01 00:15:47.000000', 'temperatura', 349.0000, 'ºC'),
	(31941, 108, '2015-02-01 00:15:48.000000', 'temperatura', 405.0000, 'ºC'),
	(31942, 108, '2015-02-01 00:15:49.000000', 'temperatura', 976.0000, 'ºC'),
	(31943, 108, '2015-02-01 00:15:50.000000', 'temperatura', 65.0000, 'ºC'),
	(31944, 108, '2015-02-01 00:15:51.000000', 'temperatura', 1000.0000, 'ºC'),
	(31945, 108, '2015-02-01 00:15:52.000000', 'temperatura', 5.0000, 'ºC'),
	(31946, 108, '2015-02-01 00:15:53.000000', 'temperatura', 626.0000, 'ºC'),
	(31947, 108, '2015-02-01 00:15:54.000000', 'temperatura', 716.0000, 'ºC'),
	(31948, 108, '2015-02-01 00:15:55.000000', 'temperatura', 500.0000, 'ºC'),
	(31949, 108, '2015-02-01 00:15:56.000000', 'temperatura', 355.0000, 'ºC'),
	(31950, 108, '2015-02-01 00:15:57.000000', 'temperatura', 274.0000, 'ºC'),
	(31951, 108, '2015-02-01 00:15:58.000000', 'temperatura', 307.0000, 'ºC'),
	(31952, 108, '2015-02-01 00:15:59.000000', 'temperatura', 711.0000, 'ºC'),
	(31953, 108, '2015-02-01 00:16:00.000000', 'temperatura', 236.0000, 'ºC'),
	(31954, 108, '2015-02-01 00:16:01.000000', 'temperatura', 249.0000, 'ºC'),
	(31955, 108, '2015-02-01 00:16:02.000000', 'temperatura', 535.0000, 'ºC'),
	(31956, 108, '2015-02-01 00:16:03.000000', 'temperatura', 731.0000, 'ºC'),
	(31957, 108, '2015-02-01 00:16:04.000000', 'temperatura', 848.0000, 'ºC'),
	(31958, 108, '2015-02-01 00:16:05.000000', 'temperatura', 847.0000, 'ºC'),
	(31959, 108, '2015-02-01 00:16:06.000000', 'temperatura', 494.0000, 'ºC'),
	(31960, 108, '2015-02-01 00:16:07.000000', 'temperatura', 1129.0000, 'ºC'),
	(31961, 108, '2015-02-01 00:16:08.000000', 'temperatura', 562.0000, 'ºC'),
	(31962, 108, '2015-02-01 00:16:09.000000', 'temperatura', 626.0000, 'ºC'),
	(31963, 108, '2015-02-01 00:16:10.000000', 'temperatura', 242.0000, 'ºC'),
	(31964, 108, '2015-02-01 00:16:11.000000', 'temperatura', 533.0000, 'ºC'),
	(31965, 108, '2015-02-01 00:16:12.000000', 'temperatura', 741.0000, 'ºC'),
	(31966, 108, '2015-02-01 00:16:13.000000', 'temperatura', 907.0000, 'ºC'),
	(31967, 108, '2015-02-01 00:16:14.000000', 'temperatura', 1112.0000, 'ºC'),
	(31968, 108, '2015-02-01 00:16:15.000000', 'temperatura', 440.0000, 'ºC'),
	(31969, 108, '2015-02-01 00:16:16.000000', 'temperatura', 65.0000, 'ºC'),
	(31970, 108, '2015-02-01 00:16:17.000000', 'temperatura', 204.0000, 'ºC'),
	(31971, 108, '2015-02-01 00:16:18.000000', 'temperatura', 827.0000, 'ºC'),
	(31972, 108, '2015-02-01 00:16:19.000000', 'temperatura', 1122.0000, 'ºC'),
	(31973, 108, '2015-02-01 00:16:20.000000', 'temperatura', 730.0000, 'ºC'),
	(31974, 108, '2015-02-01 00:16:21.000000', 'temperatura', 287.0000, 'ºC'),
	(31975, 108, '2015-02-01 00:16:22.000000', 'temperatura', 442.0000, 'ºC'),
	(31976, 108, '2015-02-01 00:16:23.000000', 'temperatura', 150.0000, 'ºC'),
	(31977, 108, '2015-02-01 00:16:24.000000', 'temperatura', 626.0000, 'ºC'),
	(31978, 108, '2015-02-01 00:16:25.000000', 'temperatura', 281.0000, 'ºC'),
	(31979, 108, '2015-02-01 00:16:26.000000', 'temperatura', 727.0000, 'ºC'),
	(31980, 108, '2015-02-01 00:16:27.000000', 'temperatura', 394.0000, 'ºC'),
	(31981, 108, '2015-02-01 00:16:28.000000', 'temperatura', 988.0000, 'ºC'),
	(31982, 108, '2015-02-01 00:16:29.000000', 'temperatura', 159.0000, 'ºC'),
	(31983, 108, '2015-02-01 00:16:30.000000', 'temperatura', 230.0000, 'ºC'),
	(31984, 108, '2015-02-01 00:16:31.000000', 'temperatura', 676.0000, 'ºC'),
	(31985, 108, '2015-02-01 00:16:32.000000', 'temperatura', 289.0000, 'ºC'),
	(31986, 108, '2015-02-01 00:16:33.000000', 'temperatura', 619.0000, 'ºC'),
	(31987, 108, '2015-02-01 00:16:34.000000', 'temperatura', 1029.0000, 'ºC'),
	(31988, 108, '2015-02-01 00:16:35.000000', 'temperatura', 887.0000, 'ºC'),
	(31989, 108, '2015-02-01 00:16:36.000000', 'temperatura', 150.0000, 'ºC'),
	(31990, 108, '2015-02-01 00:16:37.000000', 'temperatura', 488.0000, 'ºC'),
	(31991, 108, '2015-02-01 00:16:38.000000', 'temperatura', 790.0000, 'ºC'),
	(31992, 108, '2015-02-01 00:16:39.000000', 'temperatura', 89.0000, 'ºC'),
	(31993, 108, '2015-02-01 00:16:40.000000', 'temperatura', 473.0000, 'ºC'),
	(31994, 108, '2015-02-01 00:16:41.000000', 'temperatura', 899.0000, 'ºC'),
	(31995, 108, '2015-02-01 00:16:42.000000', 'temperatura', 675.0000, 'ºC'),
	(31996, 108, '2015-02-01 00:16:43.000000', 'temperatura', 679.0000, 'ºC'),
	(31997, 108, '2015-02-01 00:16:44.000000', 'temperatura', 170.0000, 'ºC'),
	(31998, 108, '2015-02-01 00:16:45.000000', 'temperatura', 13.0000, 'ºC'),
	(31999, 108, '2015-02-01 00:16:46.000000', 'temperatura', 755.0000, 'ºC'),
	(32000, 108, '2015-02-01 00:16:47.000000', 'temperatura', 138.0000, 'ºC'),
	(32001, 108, '2015-02-01 00:16:48.000000', 'temperatura', 824.0000, 'ºC'),
	(32002, 108, '2015-02-01 00:16:49.000000', 'temperatura', 109.0000, 'ºC'),
	(32003, 108, '2015-02-01 00:16:50.000000', 'temperatura', 472.0000, 'ºC'),
	(32004, 108, '2015-02-01 00:16:51.000000', 'temperatura', 833.0000, 'ºC'),
	(32005, 108, '2015-02-01 00:16:52.000000', 'temperatura', 350.0000, 'ºC'),
	(32006, 108, '2015-02-01 00:16:53.000000', 'temperatura', 451.0000, 'ºC'),
	(32007, 108, '2015-02-01 00:16:54.000000', 'temperatura', 7.0000, 'ºC'),
	(32008, 108, '2015-02-01 00:16:55.000000', 'temperatura', 1081.0000, 'ºC'),
	(32009, 108, '2015-02-01 00:16:56.000000', 'temperatura', 585.0000, 'ºC'),
	(32010, 108, '2015-02-01 00:16:57.000000', 'temperatura', 883.0000, 'ºC'),
	(32011, 108, '2015-02-01 00:16:58.000000', 'temperatura', 258.0000, 'ºC'),
	(32012, 108, '2015-02-01 00:16:59.000000', 'temperatura', 1043.0000, 'ºC'),
	(32013, 108, '2015-02-01 00:17:00.000000', 'temperatura', 843.0000, 'ºC'),
	(32014, 108, '2015-02-01 00:17:01.000000', 'temperatura', 1084.0000, 'ºC'),
	(32015, 108, '2015-02-01 00:17:02.000000', 'temperatura', 492.0000, 'ºC'),
	(32016, 108, '2015-02-01 00:17:03.000000', 'temperatura', 408.0000, 'ºC'),
	(32017, 108, '2015-02-01 00:17:04.000000', 'temperatura', 564.0000, 'ºC'),
	(32018, 108, '2015-02-01 00:17:05.000000', 'temperatura', 398.0000, 'ºC'),
	(32019, 108, '2015-02-01 00:17:06.000000', 'temperatura', 299.0000, 'ºC'),
	(32020, 108, '2015-02-01 00:17:07.000000', 'temperatura', 301.0000, 'ºC'),
	(32021, 108, '2015-02-01 00:17:08.000000', 'temperatura', 607.0000, 'ºC'),
	(32022, 108, '2015-02-01 00:17:09.000000', 'temperatura', 934.0000, 'ºC'),
	(32023, 108, '2015-02-01 00:17:10.000000', 'temperatura', 449.0000, 'ºC'),
	(32024, 108, '2015-02-01 00:17:11.000000', 'temperatura', 644.0000, 'ºC'),
	(32025, 108, '2015-02-01 00:17:12.000000', 'temperatura', 672.0000, 'ºC'),
	(32026, 108, '2015-02-01 00:17:13.000000', 'temperatura', 229.0000, 'ºC'),
	(32027, 108, '2015-02-01 00:17:14.000000', 'temperatura', 329.0000, 'ºC'),
	(32028, 108, '2015-02-01 00:17:15.000000', 'temperatura', 960.0000, 'ºC'),
	(32029, 108, '2015-02-01 00:17:16.000000', 'temperatura', 211.0000, 'ºC'),
	(32030, 108, '2015-02-01 00:17:17.000000', 'temperatura', 576.0000, 'ºC'),
	(32031, 108, '2015-02-01 00:17:18.000000', 'temperatura', 1047.0000, 'ºC'),
	(32032, 108, '2015-02-01 00:17:19.000000', 'temperatura', 1110.0000, 'ºC'),
	(32033, 108, '2015-02-01 00:17:20.000000', 'temperatura', 9.0000, 'ºC'),
	(32034, 108, '2015-02-01 00:17:21.000000', 'temperatura', 315.0000, 'ºC'),
	(32035, 108, '2015-02-01 00:17:22.000000', 'temperatura', 347.0000, 'ºC'),
	(32036, 108, '2015-02-01 00:17:23.000000', 'temperatura', 793.0000, 'ºC'),
	(32037, 108, '2015-02-01 00:17:24.000000', 'temperatura', 522.0000, 'ºC'),
	(32038, 108, '2015-02-01 00:17:25.000000', 'temperatura', 231.0000, 'ºC'),
	(32039, 108, '2015-02-01 00:17:26.000000', 'temperatura', 793.0000, 'ºC'),
	(32040, 108, '2015-02-01 00:17:27.000000', 'temperatura', 869.0000, 'ºC'),
	(32041, 108, '2015-02-01 00:17:28.000000', 'temperatura', 768.0000, 'ºC'),
	(32042, 108, '2015-02-01 00:17:29.000000', 'temperatura', 32.0000, 'ºC'),
	(32043, 108, '2015-02-01 00:17:30.000000', 'temperatura', 257.0000, 'ºC'),
	(32044, 108, '2015-02-01 00:17:31.000000', 'temperatura', 1190.0000, 'ºC'),
	(32045, 108, '2015-02-01 00:17:32.000000', 'temperatura', 379.0000, 'ºC'),
	(32046, 108, '2015-02-01 00:17:33.000000', 'temperatura', 727.0000, 'ºC'),
	(32047, 108, '2015-02-01 00:17:34.000000', 'temperatura', 99.0000, 'ºC'),
	(32048, 108, '2015-02-01 00:17:35.000000', 'temperatura', 713.0000, 'ºC'),
	(32049, 108, '2015-02-01 00:17:36.000000', 'temperatura', 869.0000, 'ºC'),
	(32050, 108, '2015-02-01 00:17:37.000000', 'temperatura', 1006.0000, 'ºC'),
	(32051, 108, '2015-02-01 00:17:38.000000', 'temperatura', 23.0000, 'ºC'),
	(32052, 108, '2015-02-01 00:17:39.000000', 'temperatura', 696.0000, 'ºC'),
	(32053, 108, '2015-02-01 00:17:40.000000', 'temperatura', 1013.0000, 'ºC'),
	(32054, 108, '2015-02-01 00:17:41.000000', 'temperatura', 578.0000, 'ºC'),
	(32055, 108, '2015-02-01 00:17:42.000000', 'temperatura', 1052.0000, 'ºC'),
	(32056, 108, '2015-02-01 00:17:43.000000', 'temperatura', 1127.0000, 'ºC'),
	(32057, 108, '2015-02-01 00:17:44.000000', 'temperatura', 81.0000, 'ºC'),
	(32058, 108, '2015-02-01 00:17:45.000000', 'temperatura', 621.0000, 'ºC'),
	(32059, 108, '2015-02-01 00:17:46.000000', 'temperatura', 464.0000, 'ºC'),
	(32060, 108, '2015-02-01 00:17:47.000000', 'temperatura', 456.0000, 'ºC'),
	(32061, 108, '2015-02-01 00:17:48.000000', 'temperatura', 890.0000, 'ºC'),
	(32062, 108, '2015-02-01 00:17:49.000000', 'temperatura', 682.0000, 'ºC'),
	(32063, 108, '2015-02-01 00:17:50.000000', 'temperatura', 740.0000, 'ºC'),
	(32064, 108, '2015-02-01 00:17:51.000000', 'temperatura', 453.0000, 'ºC'),
	(32065, 108, '2015-02-01 00:17:52.000000', 'temperatura', 46.0000, 'ºC'),
	(32066, 108, '2015-02-01 00:17:53.000000', 'temperatura', 73.0000, 'ºC'),
	(32067, 108, '2015-02-01 00:17:54.000000', 'temperatura', 226.0000, 'ºC'),
	(32068, 108, '2015-02-01 00:17:55.000000', 'temperatura', 912.0000, 'ºC'),
	(32069, 108, '2015-02-01 00:17:56.000000', 'temperatura', 282.0000, 'ºC'),
	(32070, 108, '2015-02-01 00:17:57.000000', 'temperatura', 1073.0000, 'ºC'),
	(32071, 108, '2015-02-01 00:17:58.000000', 'temperatura', 921.0000, 'ºC'),
	(32072, 108, '2015-02-01 00:17:59.000000', 'temperatura', 185.0000, 'ºC'),
	(32073, 108, '2015-02-01 00:18:00.000000', 'temperatura', 564.0000, 'ºC'),
	(32074, 108, '2015-02-01 00:18:01.000000', 'temperatura', 1065.0000, 'ºC'),
	(32075, 108, '2015-02-01 00:18:02.000000', 'temperatura', 31.0000, 'ºC'),
	(32076, 108, '2015-02-01 00:18:03.000000', 'temperatura', 564.0000, 'ºC'),
	(32077, 108, '2015-02-01 00:18:04.000000', 'temperatura', 328.0000, 'ºC'),
	(32078, 108, '2015-02-01 00:18:05.000000', 'temperatura', 1147.0000, 'ºC'),
	(32079, 108, '2015-02-01 00:18:06.000000', 'temperatura', 1150.0000, 'ºC'),
	(32080, 108, '2015-02-01 00:18:07.000000', 'temperatura', 1113.0000, 'ºC'),
	(32081, 108, '2015-02-01 00:18:08.000000', 'temperatura', 912.0000, 'ºC'),
	(32082, 108, '2015-02-01 00:18:09.000000', 'temperatura', 25.0000, 'ºC'),
	(32083, 108, '2015-02-01 00:18:10.000000', 'temperatura', 987.0000, 'ºC'),
	(32084, 108, '2015-02-01 00:18:11.000000', 'temperatura', 60.0000, 'ºC'),
	(32085, 108, '2015-02-01 00:18:12.000000', 'temperatura', 941.0000, 'ºC'),
	(32086, 108, '2015-02-01 00:18:13.000000', 'temperatura', 925.0000, 'ºC'),
	(32087, 108, '2015-02-01 00:18:14.000000', 'temperatura', 604.0000, 'ºC'),
	(32088, 108, '2015-02-01 00:18:15.000000', 'temperatura', 245.0000, 'ºC'),
	(32089, 108, '2015-02-01 00:18:16.000000', 'temperatura', 611.0000, 'ºC'),
	(32090, 108, '2015-02-01 00:18:17.000000', 'temperatura', 1123.0000, 'ºC'),
	(32091, 108, '2015-02-01 00:18:18.000000', 'temperatura', 180.0000, 'ºC'),
	(32092, 108, '2015-02-01 00:18:19.000000', 'temperatura', 1134.0000, 'ºC'),
	(32093, 108, '2015-02-01 00:18:20.000000', 'temperatura', 331.0000, 'ºC'),
	(32094, 108, '2015-02-01 00:18:21.000000', 'temperatura', 653.0000, 'ºC'),
	(32095, 108, '2015-02-01 00:18:22.000000', 'temperatura', 1073.0000, 'ºC'),
	(32096, 108, '2015-02-01 00:18:23.000000', 'temperatura', 1007.0000, 'ºC'),
	(32097, 108, '2015-02-01 00:18:24.000000', 'temperatura', 614.0000, 'ºC'),
	(32098, 108, '2015-02-01 00:18:25.000000', 'temperatura', 52.0000, 'ºC'),
	(32099, 108, '2015-02-01 00:18:26.000000', 'temperatura', 817.0000, 'ºC'),
	(32100, 108, '2015-02-01 00:18:27.000000', 'temperatura', 330.0000, 'ºC'),
	(32101, 108, '2015-02-01 00:18:28.000000', 'temperatura', 399.0000, 'ºC'),
	(32102, 108, '2015-02-01 00:18:29.000000', 'temperatura', 1006.0000, 'ºC'),
	(32103, 108, '2015-02-01 00:18:30.000000', 'temperatura', 234.0000, 'ºC'),
	(32104, 108, '2015-02-01 00:18:31.000000', 'temperatura', 552.0000, 'ºC'),
	(32105, 108, '2015-02-01 00:18:32.000000', 'temperatura', 858.0000, 'ºC'),
	(32106, 108, '2015-02-01 00:18:33.000000', 'temperatura', 234.0000, 'ºC'),
	(32107, 108, '2015-02-01 00:18:34.000000', 'temperatura', 998.0000, 'ºC'),
	(32108, 108, '2015-02-01 00:18:35.000000', 'temperatura', 687.0000, 'ºC'),
	(32109, 108, '2015-02-01 00:18:36.000000', 'temperatura', 442.0000, 'ºC'),
	(32110, 108, '2015-02-01 00:18:37.000000', 'temperatura', 149.0000, 'ºC'),
	(32111, 108, '2015-02-01 00:18:38.000000', 'temperatura', 618.0000, 'ºC'),
	(32112, 108, '2015-02-01 00:18:39.000000', 'temperatura', 247.0000, 'ºC'),
	(32113, 108, '2015-02-01 00:18:40.000000', 'temperatura', 579.0000, 'ºC'),
	(32114, 108, '2015-02-01 00:18:41.000000', 'temperatura', 957.0000, 'ºC'),
	(32115, 108, '2015-02-01 00:18:42.000000', 'temperatura', 645.0000, 'ºC'),
	(32116, 108, '2015-02-01 00:18:43.000000', 'temperatura', 357.0000, 'ºC'),
	(32117, 108, '2015-02-01 00:18:44.000000', 'temperatura', 1049.0000, 'ºC'),
	(32118, 108, '2015-02-01 00:18:45.000000', 'temperatura', 577.0000, 'ºC'),
	(32119, 108, '2015-02-01 00:18:46.000000', 'temperatura', 936.0000, 'ºC'),
	(32120, 108, '2015-02-01 00:18:47.000000', 'temperatura', 552.0000, 'ºC'),
	(32121, 108, '2015-02-01 00:18:48.000000', 'temperatura', 1151.0000, 'ºC'),
	(32122, 108, '2015-02-01 00:18:49.000000', 'temperatura', 499.0000, 'ºC'),
	(32123, 108, '2015-02-01 00:18:50.000000', 'temperatura', 244.0000, 'ºC'),
	(32124, 108, '2015-02-01 00:18:51.000000', 'temperatura', 924.0000, 'ºC'),
	(32125, 108, '2015-02-01 00:18:52.000000', 'temperatura', 287.0000, 'ºC'),
	(32126, 108, '2015-02-01 00:18:53.000000', 'temperatura', 1066.0000, 'ºC'),
	(32127, 108, '2015-02-01 00:18:54.000000', 'temperatura', 868.0000, 'ºC'),
	(32128, 108, '2015-02-01 00:18:55.000000', 'temperatura', 1142.0000, 'ºC'),
	(32129, 108, '2015-02-01 00:18:56.000000', 'temperatura', 709.0000, 'ºC'),
	(32130, 108, '2015-02-01 00:18:57.000000', 'temperatura', 118.0000, 'ºC'),
	(32131, 108, '2015-02-01 00:18:58.000000', 'temperatura', 863.0000, 'ºC'),
	(32132, 108, '2015-02-01 00:18:59.000000', 'temperatura', 361.0000, 'ºC'),
	(32133, 108, '2015-02-01 00:19:00.000000', 'temperatura', 415.0000, 'ºC'),
	(32134, 108, '2015-02-01 00:19:01.000000', 'temperatura', 994.0000, 'ºC'),
	(32135, 108, '2015-02-01 00:19:02.000000', 'temperatura', 126.0000, 'ºC'),
	(32136, 108, '2015-02-01 00:19:03.000000', 'temperatura', 47.0000, 'ºC'),
	(32137, 108, '2015-02-01 00:19:04.000000', 'temperatura', 1060.0000, 'ºC'),
	(32138, 108, '2015-02-01 00:19:05.000000', 'temperatura', 360.0000, 'ºC'),
	(32139, 108, '2015-02-01 00:19:06.000000', 'temperatura', 1017.0000, 'ºC'),
	(32140, 108, '2015-02-01 00:19:07.000000', 'temperatura', 408.0000, 'ºC'),
	(32141, 108, '2015-02-01 00:19:08.000000', 'temperatura', 190.0000, 'ºC'),
	(32142, 108, '2015-02-01 00:19:09.000000', 'temperatura', 925.0000, 'ºC'),
	(32143, 108, '2015-02-01 00:19:10.000000', 'temperatura', 455.0000, 'ºC'),
	(32144, 108, '2015-02-01 00:19:11.000000', 'temperatura', 701.0000, 'ºC'),
	(32145, 108, '2015-02-01 00:19:12.000000', 'temperatura', 940.0000, 'ºC'),
	(32146, 108, '2015-02-01 00:19:13.000000', 'temperatura', 196.0000, 'ºC'),
	(32147, 108, '2015-02-01 00:19:14.000000', 'temperatura', 562.0000, 'ºC'),
	(32148, 108, '2015-02-01 00:19:15.000000', 'temperatura', 1023.0000, 'ºC'),
	(32149, 108, '2015-02-01 00:19:16.000000', 'temperatura', 1028.0000, 'ºC'),
	(32150, 108, '2015-02-01 00:19:17.000000', 'temperatura', 870.0000, 'ºC'),
	(32151, 108, '2015-02-01 00:19:18.000000', 'temperatura', 69.0000, 'ºC'),
	(32152, 108, '2015-02-01 00:19:19.000000', 'temperatura', 134.0000, 'ºC'),
	(32153, 108, '2015-02-01 00:19:20.000000', 'temperatura', 464.0000, 'ºC'),
	(32154, 108, '2015-02-01 00:19:21.000000', 'temperatura', 718.0000, 'ºC'),
	(32155, 108, '2015-02-01 00:19:22.000000', 'temperatura', 997.0000, 'ºC'),
	(32156, 108, '2015-02-01 00:19:23.000000', 'temperatura', 434.0000, 'ºC'),
	(32157, 108, '2015-02-01 00:19:24.000000', 'temperatura', 381.0000, 'ºC'),
	(32158, 108, '2015-02-01 00:19:25.000000', 'temperatura', 601.0000, 'ºC'),
	(32159, 108, '2015-02-01 00:19:26.000000', 'temperatura', 663.0000, 'ºC'),
	(32160, 108, '2015-02-01 00:19:27.000000', 'temperatura', 313.0000, 'ºC'),
	(32161, 108, '2015-02-01 00:19:28.000000', 'temperatura', 774.0000, 'ºC'),
	(32162, 108, '2015-02-01 00:19:29.000000', 'temperatura', 534.0000, 'ºC'),
	(32163, 108, '2015-02-01 00:19:30.000000', 'temperatura', 346.0000, 'ºC'),
	(32164, 108, '2015-02-01 00:19:31.000000', 'temperatura', 129.0000, 'ºC'),
	(32165, 108, '2015-02-01 00:19:32.000000', 'temperatura', 807.0000, 'ºC'),
	(32166, 108, '2015-02-01 00:19:33.000000', 'temperatura', 50.0000, 'ºC'),
	(32167, 108, '2015-02-01 00:19:34.000000', 'temperatura', 229.0000, 'ºC'),
	(32168, 108, '2015-02-01 00:19:35.000000', 'temperatura', 994.0000, 'ºC'),
	(32169, 108, '2015-02-01 00:19:36.000000', 'temperatura', 683.0000, 'ºC'),
	(32170, 108, '2015-02-01 00:19:37.000000', 'temperatura', 433.0000, 'ºC'),
	(32171, 108, '2015-02-01 00:19:38.000000', 'temperatura', 117.0000, 'ºC'),
	(32172, 108, '2015-02-01 00:19:39.000000', 'temperatura', 486.0000, 'ºC'),
	(32173, 108, '2015-02-01 00:19:40.000000', 'temperatura', 880.0000, 'ºC'),
	(32174, 108, '2015-02-01 00:19:41.000000', 'temperatura', 544.0000, 'ºC'),
	(32175, 108, '2015-02-01 00:19:42.000000', 'temperatura', 78.0000, 'ºC'),
	(32176, 108, '2015-02-01 00:19:43.000000', 'temperatura', 1159.0000, 'ºC'),
	(32177, 108, '2015-02-01 00:19:44.000000', 'temperatura', 762.0000, 'ºC'),
	(32178, 108, '2015-02-01 00:19:45.000000', 'temperatura', 334.0000, 'ºC'),
	(32179, 108, '2015-02-01 00:19:46.000000', 'temperatura', 585.0000, 'ºC'),
	(32180, 108, '2015-02-01 00:19:47.000000', 'temperatura', 724.0000, 'ºC'),
	(32181, 108, '2015-02-01 00:19:48.000000', 'temperatura', 663.0000, 'ºC'),
	(32182, 108, '2015-02-01 00:19:49.000000', 'temperatura', 1146.0000, 'ºC'),
	(32183, 108, '2015-02-01 00:19:50.000000', 'temperatura', 140.0000, 'ºC'),
	(32184, 108, '2015-02-01 00:19:51.000000', 'temperatura', 862.0000, 'ºC'),
	(32185, 108, '2015-02-01 00:19:52.000000', 'temperatura', 293.0000, 'ºC'),
	(32186, 108, '2015-02-01 00:19:53.000000', 'temperatura', 78.0000, 'ºC'),
	(32187, 108, '2015-02-01 00:19:54.000000', 'temperatura', 712.0000, 'ºC'),
	(32188, 108, '2015-02-01 00:19:55.000000', 'temperatura', 925.0000, 'ºC'),
	(32189, 108, '2015-02-01 00:19:56.000000', 'temperatura', 91.0000, 'ºC'),
	(32190, 108, '2015-02-01 00:19:57.000000', 'temperatura', 80.0000, 'ºC'),
	(32191, 108, '2015-02-01 00:19:58.000000', 'temperatura', 127.0000, 'ºC'),
	(32192, 108, '2015-02-01 00:19:59.000000', 'temperatura', 397.0000, 'ºC'),
	(32193, 108, '2015-02-01 00:20:00.000000', 'temperatura', 403.0000, 'ºC'),
	(32194, 108, '2015-02-01 00:20:01.000000', 'temperatura', 826.0000, 'ºC'),
	(32195, 108, '2015-02-01 00:20:02.000000', 'temperatura', 522.0000, 'ºC'),
	(32196, 108, '2015-02-01 00:20:03.000000', 'temperatura', 130.0000, 'ºC'),
	(32197, 108, '2015-02-01 00:20:04.000000', 'temperatura', 286.0000, 'ºC'),
	(32198, 108, '2015-02-01 00:20:05.000000', 'temperatura', 1041.0000, 'ºC'),
	(32199, 108, '2015-02-01 00:20:06.000000', 'temperatura', 745.0000, 'ºC'),
	(32200, 108, '2015-02-01 00:20:07.000000', 'temperatura', 604.0000, 'ºC'),
	(32201, 108, '2015-02-01 00:20:08.000000', 'temperatura', 785.0000, 'ºC'),
	(32202, 108, '2015-02-01 00:20:09.000000', 'temperatura', 913.0000, 'ºC'),
	(32203, 108, '2015-02-01 00:20:10.000000', 'temperatura', 1009.0000, 'ºC'),
	(32204, 108, '2015-02-01 00:20:11.000000', 'temperatura', 1108.0000, 'ºC'),
	(32205, 108, '2015-02-01 00:20:12.000000', 'temperatura', 113.0000, 'ºC'),
	(32206, 108, '2015-02-01 00:20:13.000000', 'temperatura', 841.0000, 'ºC'),
	(32207, 108, '2015-02-01 00:20:14.000000', 'temperatura', 269.0000, 'ºC'),
	(32208, 108, '2015-02-01 00:20:15.000000', 'temperatura', 19.0000, 'ºC'),
	(32209, 108, '2015-02-01 00:20:16.000000', 'temperatura', 491.0000, 'ºC'),
	(32210, 108, '2015-02-01 00:20:17.000000', 'temperatura', 1198.0000, 'ºC'),
	(32211, 108, '2015-02-01 00:20:18.000000', 'temperatura', 918.0000, 'ºC'),
	(32212, 108, '2015-02-01 00:20:19.000000', 'temperatura', 998.0000, 'ºC'),
	(32213, 108, '2015-02-01 00:20:20.000000', 'temperatura', 1035.0000, 'ºC'),
	(32214, 108, '2015-02-01 00:20:21.000000', 'temperatura', 980.0000, 'ºC'),
	(32215, 108, '2015-02-01 00:20:22.000000', 'temperatura', 597.0000, 'ºC'),
	(32216, 108, '2015-02-01 00:20:23.000000', 'temperatura', 43.0000, 'ºC'),
	(32217, 108, '2015-02-01 00:20:24.000000', 'temperatura', 828.0000, 'ºC'),
	(32218, 108, '2015-02-01 00:20:25.000000', 'temperatura', 410.0000, 'ºC'),
	(32219, 108, '2015-02-01 00:20:26.000000', 'temperatura', 768.0000, 'ºC'),
	(32220, 108, '2015-02-01 00:20:27.000000', 'temperatura', 210.0000, 'ºC'),
	(32221, 108, '2015-02-01 00:20:28.000000', 'temperatura', 1144.0000, 'ºC'),
	(32222, 108, '2015-02-01 00:20:29.000000', 'temperatura', 293.0000, 'ºC'),
	(32223, 108, '2015-02-01 00:20:30.000000', 'temperatura', 432.0000, 'ºC'),
	(32224, 108, '2015-02-01 00:20:31.000000', 'temperatura', 84.0000, 'ºC'),
	(32225, 108, '2015-02-01 00:20:32.000000', 'temperatura', 324.0000, 'ºC'),
	(32226, 108, '2015-02-01 00:20:33.000000', 'temperatura', 166.0000, 'ºC'),
	(32227, 108, '2015-02-01 00:20:34.000000', 'temperatura', 1060.0000, 'ºC'),
	(32228, 108, '2015-02-01 00:20:35.000000', 'temperatura', 3.0000, 'ºC'),
	(32229, 108, '2015-02-01 00:20:36.000000', 'temperatura', 437.0000, 'ºC'),
	(32230, 108, '2015-02-01 00:20:37.000000', 'temperatura', 976.0000, 'ºC'),
	(32231, 108, '2015-02-01 00:20:38.000000', 'temperatura', 1169.0000, 'ºC'),
	(32232, 108, '2015-02-01 00:20:39.000000', 'temperatura', 516.0000, 'ºC'),
	(32233, 108, '2015-02-01 00:20:40.000000', 'temperatura', 275.0000, 'ºC'),
	(32234, 108, '2015-02-01 00:20:41.000000', 'temperatura', 1025.0000, 'ºC'),
	(32235, 108, '2015-02-01 00:20:42.000000', 'temperatura', 703.0000, 'ºC'),
	(32236, 108, '2015-02-01 00:20:43.000000', 'temperatura', 442.0000, 'ºC'),
	(32237, 108, '2015-02-01 00:20:44.000000', 'temperatura', 99.0000, 'ºC'),
	(32238, 108, '2015-02-01 00:20:45.000000', 'temperatura', 372.0000, 'ºC'),
	(32239, 108, '2015-02-01 00:20:46.000000', 'temperatura', 361.0000, 'ºC'),
	(32240, 108, '2015-02-01 00:20:47.000000', 'temperatura', 691.0000, 'ºC'),
	(32241, 108, '2015-02-01 00:20:48.000000', 'temperatura', 1173.0000, 'ºC'),
	(32242, 108, '2015-02-01 00:20:49.000000', 'temperatura', 192.0000, 'ºC'),
	(32243, 108, '2015-02-01 00:20:50.000000', 'temperatura', 1042.0000, 'ºC'),
	(32244, 108, '2015-02-01 00:20:51.000000', 'temperatura', 1036.0000, 'ºC'),
	(32245, 108, '2015-02-01 00:20:52.000000', 'temperatura', 852.0000, 'ºC'),
	(32246, 108, '2015-02-01 00:20:53.000000', 'temperatura', 1155.0000, 'ºC'),
	(32247, 108, '2015-02-01 00:20:54.000000', 'temperatura', 819.0000, 'ºC'),
	(32248, 108, '2015-02-01 00:20:55.000000', 'temperatura', 629.0000, 'ºC'),
	(32249, 108, '2015-02-01 00:20:56.000000', 'temperatura', 688.0000, 'ºC'),
	(32250, 108, '2015-02-01 00:20:57.000000', 'temperatura', 356.0000, 'ºC'),
	(32251, 108, '2015-02-01 00:20:58.000000', 'temperatura', 915.0000, 'ºC'),
	(32252, 108, '2015-02-01 00:20:59.000000', 'temperatura', 1107.0000, 'ºC'),
	(32253, 108, '2015-02-01 00:21:00.000000', 'temperatura', 391.0000, 'ºC'),
	(32254, 108, '2015-02-01 00:21:01.000000', 'temperatura', 1034.0000, 'ºC'),
	(32255, 108, '2015-02-01 00:21:02.000000', 'temperatura', 397.0000, 'ºC'),
	(32256, 108, '2015-02-01 00:21:03.000000', 'temperatura', 84.0000, 'ºC'),
	(32257, 108, '2015-02-01 00:21:04.000000', 'temperatura', 430.0000, 'ºC'),
	(32258, 108, '2015-02-01 00:21:05.000000', 'temperatura', 700.0000, 'ºC'),
	(32259, 108, '2015-02-01 00:21:06.000000', 'temperatura', 1009.0000, 'ºC'),
	(32260, 108, '2015-02-01 00:21:07.000000', 'temperatura', 544.0000, 'ºC'),
	(32261, 108, '2015-02-01 00:21:08.000000', 'temperatura', 895.0000, 'ºC'),
	(32262, 108, '2015-02-01 00:21:09.000000', 'temperatura', 442.0000, 'ºC'),
	(32263, 108, '2015-02-01 00:21:10.000000', 'temperatura', 725.0000, 'ºC'),
	(32264, 108, '2015-02-01 00:21:11.000000', 'temperatura', 1102.0000, 'ºC'),
	(32265, 108, '2015-02-01 00:21:12.000000', 'temperatura', 935.0000, 'ºC'),
	(32266, 108, '2015-02-01 00:21:13.000000', 'temperatura', 170.0000, 'ºC'),
	(32267, 108, '2015-02-01 00:21:14.000000', 'temperatura', 446.0000, 'ºC'),
	(32268, 108, '2015-02-01 00:21:15.000000', 'temperatura', 518.0000, 'ºC'),
	(32269, 108, '2015-02-01 00:21:16.000000', 'temperatura', 52.0000, 'ºC'),
	(32270, 108, '2015-02-01 00:21:17.000000', 'temperatura', 1109.0000, 'ºC'),
	(32271, 108, '2015-02-01 00:21:18.000000', 'temperatura', 590.0000, 'ºC'),
	(32272, 108, '2015-02-01 00:21:19.000000', 'temperatura', 822.0000, 'ºC'),
	(32273, 108, '2015-02-01 00:21:20.000000', 'temperatura', 1140.0000, 'ºC'),
	(32274, 108, '2015-02-01 00:21:21.000000', 'temperatura', 833.0000, 'ºC'),
	(32275, 108, '2015-02-01 00:21:22.000000', 'temperatura', 747.0000, 'ºC'),
	(32276, 108, '2015-02-01 00:21:23.000000', 'temperatura', 37.0000, 'ºC'),
	(32277, 108, '2015-02-01 00:21:24.000000', 'temperatura', 345.0000, 'ºC'),
	(32278, 108, '2015-02-01 00:21:25.000000', 'temperatura', 413.0000, 'ºC'),
	(32279, 108, '2015-02-01 00:21:26.000000', 'temperatura', 1032.0000, 'ºC'),
	(32280, 108, '2015-02-01 00:21:27.000000', 'temperatura', 319.0000, 'ºC'),
	(32281, 108, '2015-02-01 00:21:28.000000', 'temperatura', 903.0000, 'ºC'),
	(32282, 108, '2015-02-01 00:21:29.000000', 'temperatura', 1155.0000, 'ºC'),
	(32283, 108, '2015-02-01 00:21:30.000000', 'temperatura', 668.0000, 'ºC'),
	(32284, 108, '2015-02-01 00:21:31.000000', 'temperatura', 1077.0000, 'ºC'),
	(32285, 108, '2015-02-01 00:21:32.000000', 'temperatura', 982.0000, 'ºC'),
	(32286, 108, '2015-02-01 00:21:33.000000', 'temperatura', 478.0000, 'ºC'),
	(32287, 108, '2015-02-01 00:21:34.000000', 'temperatura', 644.0000, 'ºC'),
	(32288, 108, '2015-02-01 00:21:35.000000', 'temperatura', 589.0000, 'ºC'),
	(32289, 108, '2015-02-01 00:21:36.000000', 'temperatura', 1013.0000, 'ºC'),
	(32290, 108, '2015-02-01 00:21:37.000000', 'temperatura', 896.0000, 'ºC'),
	(32291, 108, '2015-02-01 00:21:38.000000', 'temperatura', 242.0000, 'ºC'),
	(32292, 108, '2015-02-01 00:21:39.000000', 'temperatura', 923.0000, 'ºC'),
	(32293, 108, '2015-02-01 00:21:40.000000', 'temperatura', 290.0000, 'ºC'),
	(32294, 108, '2015-02-01 00:21:41.000000', 'temperatura', 1079.0000, 'ºC'),
	(32295, 108, '2015-02-01 00:21:42.000000', 'temperatura', 928.0000, 'ºC'),
	(32296, 108, '2015-02-01 00:21:43.000000', 'temperatura', 201.0000, 'ºC'),
	(32297, 108, '2015-02-01 00:21:44.000000', 'temperatura', 623.0000, 'ºC'),
	(32298, 108, '2015-02-01 00:21:45.000000', 'temperatura', 111.0000, 'ºC'),
	(32299, 108, '2015-02-01 00:21:46.000000', 'temperatura', 1088.0000, 'ºC'),
	(32300, 108, '2015-02-01 00:21:47.000000', 'temperatura', 308.0000, 'ºC'),
	(32301, 108, '2015-02-01 00:21:48.000000', 'temperatura', 674.0000, 'ºC'),
	(32302, 108, '2015-02-01 00:21:49.000000', 'temperatura', 47.0000, 'ºC'),
	(32303, 108, '2015-02-01 00:21:50.000000', 'temperatura', 616.0000, 'ºC'),
	(32304, 108, '2015-02-01 00:21:51.000000', 'temperatura', 537.0000, 'ºC'),
	(32305, 108, '2015-02-01 00:21:52.000000', 'temperatura', 840.0000, 'ºC'),
	(32306, 108, '2015-02-01 00:21:53.000000', 'temperatura', 190.0000, 'ºC'),
	(32307, 108, '2015-02-01 00:21:54.000000', 'temperatura', 827.0000, 'ºC'),
	(32308, 108, '2015-02-01 00:21:55.000000', 'temperatura', 1168.0000, 'ºC'),
	(32309, 108, '2015-02-01 00:21:56.000000', 'temperatura', 960.0000, 'ºC'),
	(32310, 108, '2015-02-01 00:21:57.000000', 'temperatura', 95.0000, 'ºC'),
	(32311, 108, '2015-02-01 00:21:58.000000', 'temperatura', 1197.0000, 'ºC'),
	(32312, 108, '2015-02-01 00:21:59.000000', 'temperatura', 899.0000, 'ºC'),
	(32313, 108, '2015-02-01 00:22:00.000000', 'temperatura', 907.0000, 'ºC'),
	(32314, 108, '2015-02-01 00:22:01.000000', 'temperatura', 637.0000, 'ºC'),
	(32315, 108, '2015-02-01 00:22:02.000000', 'temperatura', 465.0000, 'ºC'),
	(32316, 108, '2015-02-01 00:22:03.000000', 'temperatura', 415.0000, 'ºC'),
	(32317, 108, '2015-02-01 00:22:04.000000', 'temperatura', 682.0000, 'ºC'),
	(32318, 108, '2015-02-01 00:22:05.000000', 'temperatura', 962.0000, 'ºC'),
	(32319, 108, '2015-02-01 00:22:06.000000', 'temperatura', 367.0000, 'ºC'),
	(32320, 108, '2015-02-01 00:22:07.000000', 'temperatura', 151.0000, 'ºC'),
	(32321, 108, '2015-02-01 00:22:08.000000', 'temperatura', 852.0000, 'ºC'),
	(32322, 108, '2015-02-01 00:22:09.000000', 'temperatura', 206.0000, 'ºC'),
	(32323, 108, '2015-02-01 00:22:10.000000', 'temperatura', 877.0000, 'ºC'),
	(32324, 108, '2015-02-01 00:22:11.000000', 'temperatura', 165.0000, 'ºC'),
	(32325, 108, '2015-02-01 00:22:12.000000', 'temperatura', 596.0000, 'ºC'),
	(32326, 108, '2015-02-01 00:22:13.000000', 'temperatura', 85.0000, 'ºC'),
	(32327, 108, '2015-02-01 00:22:14.000000', 'temperatura', 1038.0000, 'ºC'),
	(32328, 108, '2015-02-01 00:22:15.000000', 'temperatura', 134.0000, 'ºC'),
	(32329, 108, '2015-02-01 00:22:16.000000', 'temperatura', 1159.0000, 'ºC'),
	(32330, 108, '2015-02-01 00:22:17.000000', 'temperatura', 591.0000, 'ºC'),
	(32331, 108, '2015-02-01 00:22:18.000000', 'temperatura', 681.0000, 'ºC'),
	(32332, 108, '2015-02-01 00:22:19.000000', 'temperatura', 430.0000, 'ºC'),
	(32333, 108, '2015-02-01 00:22:20.000000', 'temperatura', 109.0000, 'ºC'),
	(32334, 108, '2015-02-01 00:22:21.000000', 'temperatura', 456.0000, 'ºC'),
	(32335, 108, '2015-02-01 00:22:22.000000', 'temperatura', 753.0000, 'ºC'),
	(32336, 108, '2015-02-01 00:22:23.000000', 'temperatura', 1198.0000, 'ºC'),
	(32337, 108, '2015-02-01 00:22:24.000000', 'temperatura', 132.0000, 'ºC'),
	(32338, 108, '2015-02-01 00:22:25.000000', 'temperatura', 665.0000, 'ºC'),
	(32339, 108, '2015-02-01 00:22:26.000000', 'temperatura', 531.0000, 'ºC'),
	(32340, 108, '2015-02-01 00:22:27.000000', 'temperatura', 660.0000, 'ºC'),
	(32341, 108, '2015-02-01 00:22:28.000000', 'temperatura', 507.0000, 'ºC'),
	(32342, 108, '2015-02-01 00:22:29.000000', 'temperatura', 556.0000, 'ºC'),
	(32343, 108, '2015-02-01 00:22:30.000000', 'temperatura', 60.0000, 'ºC'),
	(32344, 108, '2015-02-01 00:22:31.000000', 'temperatura', 1032.0000, 'ºC'),
	(32345, 108, '2015-02-01 00:22:32.000000', 'temperatura', 182.0000, 'ºC'),
	(32346, 108, '2015-02-01 00:22:33.000000', 'temperatura', 214.0000, 'ºC'),
	(32347, 108, '2015-02-01 00:22:34.000000', 'temperatura', 523.0000, 'ºC'),
	(32348, 108, '2015-02-01 00:22:35.000000', 'temperatura', 773.0000, 'ºC'),
	(32349, 108, '2015-02-01 00:22:36.000000', 'temperatura', 1096.0000, 'ºC'),
	(32350, 108, '2015-02-01 00:22:37.000000', 'temperatura', 762.0000, 'ºC'),
	(32351, 108, '2015-02-01 00:22:38.000000', 'temperatura', 524.0000, 'ºC'),
	(32352, 108, '2015-02-01 00:22:39.000000', 'temperatura', 333.0000, 'ºC'),
	(32353, 108, '2015-02-01 00:22:40.000000', 'temperatura', 93.0000, 'ºC'),
	(32354, 108, '2015-02-01 00:22:41.000000', 'temperatura', 668.0000, 'ºC'),
	(32355, 108, '2015-02-01 00:22:42.000000', 'temperatura', 659.0000, 'ºC'),
	(32356, 108, '2015-02-01 00:22:43.000000', 'temperatura', 95.0000, 'ºC'),
	(32357, 108, '2015-02-01 00:22:44.000000', 'temperatura', 895.0000, 'ºC'),
	(32358, 108, '2015-02-01 00:22:45.000000', 'temperatura', 592.0000, 'ºC'),
	(32359, 108, '2015-02-01 00:22:46.000000', 'temperatura', 274.0000, 'ºC'),
	(32360, 108, '2015-02-01 00:22:47.000000', 'temperatura', 797.0000, 'ºC'),
	(32361, 108, '2015-02-01 00:22:48.000000', 'temperatura', 763.0000, 'ºC'),
	(32362, 108, '2015-02-01 00:22:49.000000', 'temperatura', 225.0000, 'ºC'),
	(32363, 108, '2015-02-01 00:22:50.000000', 'temperatura', 36.0000, 'ºC'),
	(32364, 108, '2015-02-01 00:22:51.000000', 'temperatura', 706.0000, 'ºC'),
	(32365, 108, '2015-02-01 00:22:52.000000', 'temperatura', 1023.0000, 'ºC'),
	(32366, 108, '2015-02-01 00:22:53.000000', 'temperatura', 596.0000, 'ºC'),
	(32367, 108, '2015-02-01 00:22:54.000000', 'temperatura', 1112.0000, 'ºC'),
	(32368, 108, '2015-02-01 00:22:55.000000', 'temperatura', 171.0000, 'ºC'),
	(32369, 108, '2015-02-01 00:22:56.000000', 'temperatura', 1120.0000, 'ºC'),
	(32370, 108, '2015-02-01 00:22:57.000000', 'temperatura', 289.0000, 'ºC'),
	(32371, 108, '2015-02-01 00:22:58.000000', 'temperatura', 484.0000, 'ºC'),
	(32372, 108, '2015-02-01 00:22:59.000000', 'temperatura', 356.0000, 'ºC'),
	(32373, 108, '2015-02-01 00:23:00.000000', 'temperatura', 327.0000, 'ºC'),
	(32374, 108, '2015-02-01 00:23:01.000000', 'temperatura', 569.0000, 'ºC'),
	(32375, 108, '2015-02-01 00:23:02.000000', 'temperatura', 665.0000, 'ºC'),
	(32376, 108, '2015-02-01 00:23:03.000000', 'temperatura', 417.0000, 'ºC'),
	(32377, 108, '2015-02-01 00:23:04.000000', 'temperatura', 91.0000, 'ºC'),
	(32378, 108, '2015-02-01 00:23:05.000000', 'temperatura', 405.0000, 'ºC'),
	(32379, 108, '2015-02-01 00:23:06.000000', 'temperatura', 552.0000, 'ºC'),
	(32380, 108, '2015-02-01 00:23:07.000000', 'temperatura', 345.0000, 'ºC'),
	(32381, 108, '2015-02-01 00:23:08.000000', 'temperatura', 68.0000, 'ºC'),
	(32382, 108, '2015-02-01 00:23:09.000000', 'temperatura', 508.0000, 'ºC'),
	(32383, 108, '2015-02-01 00:23:10.000000', 'temperatura', 1136.0000, 'ºC'),
	(32384, 108, '2015-02-01 00:23:11.000000', 'temperatura', 556.0000, 'ºC'),
	(32385, 108, '2015-02-01 00:23:12.000000', 'temperatura', 572.0000, 'ºC'),
	(32386, 108, '2015-02-01 00:23:13.000000', 'temperatura', 1192.0000, 'ºC'),
	(32387, 108, '2015-02-01 00:23:14.000000', 'temperatura', 647.0000, 'ºC'),
	(32388, 108, '2015-02-01 00:23:15.000000', 'temperatura', 858.0000, 'ºC'),
	(32389, 108, '2015-02-01 00:23:16.000000', 'temperatura', 1151.0000, 'ºC'),
	(32390, 108, '2015-02-01 00:23:17.000000', 'temperatura', 783.0000, 'ºC'),
	(32391, 108, '2015-02-01 00:23:18.000000', 'temperatura', 459.0000, 'ºC'),
	(32392, 108, '2015-02-01 00:23:19.000000', 'temperatura', 1149.0000, 'ºC'),
	(32393, 108, '2015-02-01 00:23:20.000000', 'temperatura', 767.0000, 'ºC'),
	(32394, 108, '2015-02-01 00:23:21.000000', 'temperatura', 389.0000, 'ºC'),
	(32395, 108, '2015-02-01 00:23:22.000000', 'temperatura', 844.0000, 'ºC'),
	(32396, 108, '2015-02-01 00:23:23.000000', 'temperatura', 652.0000, 'ºC'),
	(32397, 108, '2015-02-01 00:23:24.000000', 'temperatura', 729.0000, 'ºC'),
	(32398, 108, '2015-02-01 00:23:25.000000', 'temperatura', 492.0000, 'ºC'),
	(32399, 108, '2015-02-01 00:23:26.000000', 'temperatura', 273.0000, 'ºC'),
	(32400, 108, '2015-02-01 00:23:27.000000', 'temperatura', 1089.0000, 'ºC'),
	(32401, 108, '2015-02-01 00:23:28.000000', 'temperatura', 1025.0000, 'ºC'),
	(32402, 108, '2015-02-01 00:23:29.000000', 'temperatura', 657.0000, 'ºC'),
	(32403, 108, '2015-02-01 00:23:30.000000', 'temperatura', 214.0000, 'ºC'),
	(32404, 108, '2015-02-01 00:23:31.000000', 'temperatura', 298.0000, 'ºC'),
	(32405, 108, '2015-02-01 00:23:32.000000', 'temperatura', 850.0000, 'ºC'),
	(32406, 108, '2015-02-01 00:23:33.000000', 'temperatura', 957.0000, 'ºC'),
	(32407, 108, '2015-02-01 00:23:34.000000', 'temperatura', 1033.0000, 'ºC'),
	(32408, 108, '2015-02-01 00:23:35.000000', 'temperatura', 1097.0000, 'ºC'),
	(32409, 108, '2015-02-01 00:23:36.000000', 'temperatura', 1184.0000, 'ºC'),
	(32410, 108, '2015-02-01 00:23:37.000000', 'temperatura', 231.0000, 'ºC'),
	(32411, 108, '2015-02-01 00:23:38.000000', 'temperatura', 2.0000, 'ºC'),
	(32412, 108, '2015-02-01 00:23:39.000000', 'temperatura', 517.0000, 'ºC'),
	(32413, 108, '2015-02-01 00:23:40.000000', 'temperatura', 180.0000, 'ºC'),
	(32414, 108, '2015-02-01 00:23:41.000000', 'temperatura', 552.0000, 'ºC'),
	(32415, 108, '2015-02-01 00:23:42.000000', 'temperatura', 1017.0000, 'ºC'),
	(32416, 108, '2015-02-01 00:23:43.000000', 'temperatura', 1031.0000, 'ºC'),
	(32417, 108, '2015-02-01 00:23:44.000000', 'temperatura', 903.0000, 'ºC'),
	(32418, 108, '2015-02-01 00:23:45.000000', 'temperatura', 222.0000, 'ºC'),
	(32419, 108, '2015-02-01 00:23:46.000000', 'temperatura', 804.0000, 'ºC'),
	(32420, 108, '2015-02-01 00:23:47.000000', 'temperatura', 954.0000, 'ºC'),
	(32421, 108, '2015-02-01 00:23:48.000000', 'temperatura', 1156.0000, 'ºC'),
	(32422, 108, '2015-02-01 00:23:49.000000', 'temperatura', 521.0000, 'ºC'),
	(32423, 108, '2015-02-01 00:23:50.000000', 'temperatura', 337.0000, 'ºC'),
	(32424, 108, '2015-02-01 00:23:51.000000', 'temperatura', 120.0000, 'ºC'),
	(32425, 108, '2015-02-01 00:23:52.000000', 'temperatura', 792.0000, 'ºC'),
	(32426, 108, '2015-02-01 00:23:53.000000', 'temperatura', 1.0000, 'ºC'),
	(32427, 108, '2015-02-01 00:23:54.000000', 'temperatura', 31.0000, 'ºC'),
	(32428, 108, '2015-02-01 00:23:55.000000', 'temperatura', 150.0000, 'ºC'),
	(32429, 108, '2015-02-01 00:23:56.000000', 'temperatura', 659.0000, 'ºC'),
	(32430, 108, '2015-02-01 00:23:57.000000', 'temperatura', 446.0000, 'ºC'),
	(32431, 108, '2015-02-01 00:23:58.000000', 'temperatura', 253.0000, 'ºC'),
	(32432, 108, '2015-02-01 00:23:59.000000', 'temperatura', 1126.0000, 'ºC'),
	(32433, 108, '2015-02-01 00:24:00.000000', 'temperatura', 71.0000, 'ºC'),
	(32434, 108, '2015-02-01 00:24:01.000000', 'temperatura', 577.0000, 'ºC'),
	(32435, 108, '2015-02-01 00:24:02.000000', 'temperatura', 275.0000, 'ºC'),
	(32436, 108, '2015-02-01 00:24:03.000000', 'temperatura', 844.0000, 'ºC'),
	(32437, 108, '2015-02-01 00:24:04.000000', 'temperatura', 996.0000, 'ºC'),
	(32438, 108, '2015-02-01 00:24:05.000000', 'temperatura', 48.0000, 'ºC'),
	(32439, 108, '2015-02-01 00:24:06.000000', 'temperatura', 852.0000, 'ºC'),
	(32440, 108, '2015-02-01 00:24:07.000000', 'temperatura', 517.0000, 'ºC'),
	(32441, 108, '2015-02-01 00:24:08.000000', 'temperatura', 31.0000, 'ºC'),
	(32442, 108, '2015-02-01 00:24:09.000000', 'temperatura', 1003.0000, 'ºC'),
	(32443, 108, '2015-02-01 00:24:10.000000', 'temperatura', 123.0000, 'ºC'),
	(32444, 108, '2015-02-01 00:24:11.000000', 'temperatura', 7.0000, 'ºC'),
	(32445, 108, '2015-02-01 00:24:12.000000', 'temperatura', 868.0000, 'ºC'),
	(32446, 108, '2015-02-01 00:24:13.000000', 'temperatura', 718.0000, 'ºC'),
	(32447, 108, '2015-02-01 00:24:14.000000', 'temperatura', 985.0000, 'ºC'),
	(32448, 108, '2015-02-01 00:24:15.000000', 'temperatura', 374.0000, 'ºC'),
	(32449, 108, '2015-02-01 00:24:16.000000', 'temperatura', 115.0000, 'ºC'),
	(32450, 108, '2015-02-01 00:24:17.000000', 'temperatura', 652.0000, 'ºC'),
	(32451, 108, '2015-02-01 00:24:18.000000', 'temperatura', 515.0000, 'ºC'),
	(32452, 108, '2015-02-01 00:24:19.000000', 'temperatura', 621.0000, 'ºC'),
	(32453, 108, '2015-02-01 00:24:20.000000', 'temperatura', 362.0000, 'ºC'),
	(32454, 108, '2015-02-01 00:24:21.000000', 'temperatura', 1146.0000, 'ºC'),
	(32455, 108, '2015-02-01 00:24:22.000000', 'temperatura', 1044.0000, 'ºC'),
	(32456, 108, '2015-02-01 00:24:23.000000', 'temperatura', 584.0000, 'ºC'),
	(32457, 108, '2015-02-01 00:24:24.000000', 'temperatura', 987.0000, 'ºC'),
	(32458, 108, '2015-02-01 00:24:25.000000', 'temperatura', 782.0000, 'ºC'),
	(32459, 108, '2015-02-01 00:24:26.000000', 'temperatura', 951.0000, 'ºC'),
	(32460, 108, '2015-02-01 00:24:27.000000', 'temperatura', 8.0000, 'ºC'),
	(32461, 108, '2015-02-01 00:24:28.000000', 'temperatura', 788.0000, 'ºC'),
	(32462, 108, '2015-02-01 00:24:29.000000', 'temperatura', 318.0000, 'ºC'),
	(32463, 108, '2015-02-01 00:24:30.000000', 'temperatura', 424.0000, 'ºC'),
	(32464, 108, '2015-02-01 00:24:31.000000', 'temperatura', 1170.0000, 'ºC'),
	(32465, 108, '2015-02-01 00:24:32.000000', 'temperatura', 976.0000, 'ºC'),
	(32466, 108, '2015-02-01 00:24:33.000000', 'temperatura', 170.0000, 'ºC'),
	(32467, 108, '2015-02-01 00:24:34.000000', 'temperatura', 323.0000, 'ºC'),
	(32468, 108, '2015-02-01 00:24:35.000000', 'temperatura', 1107.0000, 'ºC'),
	(32469, 108, '2015-02-01 00:24:36.000000', 'temperatura', 964.0000, 'ºC'),
	(32470, 108, '2015-02-01 00:24:37.000000', 'temperatura', 302.0000, 'ºC'),
	(32471, 108, '2015-02-01 00:24:38.000000', 'temperatura', 1017.0000, 'ºC'),
	(32472, 108, '2015-02-01 00:24:39.000000', 'temperatura', 581.0000, 'ºC'),
	(32473, 108, '2015-02-01 00:24:40.000000', 'temperatura', 1055.0000, 'ºC'),
	(32474, 108, '2015-02-01 00:24:41.000000', 'temperatura', 1130.0000, 'ºC'),
	(32475, 108, '2015-02-01 00:24:42.000000', 'temperatura', 88.0000, 'ºC'),
	(32476, 108, '2015-02-01 00:24:43.000000', 'temperatura', 648.0000, 'ºC'),
	(32477, 108, '2015-02-01 00:24:44.000000', 'temperatura', 577.0000, 'ºC'),
	(32478, 108, '2015-02-01 00:24:45.000000', 'temperatura', 941.0000, 'ºC'),
	(32479, 108, '2015-02-01 00:24:46.000000', 'temperatura', 574.0000, 'ºC'),
	(32480, 108, '2015-02-01 00:24:47.000000', 'temperatura', 50.0000, 'ºC'),
	(32481, 108, '2015-02-01 00:24:48.000000', 'temperatura', 929.0000, 'ºC'),
	(32482, 108, '2015-02-01 00:24:49.000000', 'temperatura', 894.0000, 'ºC'),
	(32483, 108, '2015-02-01 00:24:50.000000', 'temperatura', 485.0000, 'ºC'),
	(32484, 108, '2015-02-01 00:24:51.000000', 'temperatura', 944.0000, 'ºC'),
	(32485, 108, '2015-02-01 00:24:52.000000', 'temperatura', 863.0000, 'ºC'),
	(32486, 108, '2015-02-01 00:24:53.000000', 'temperatura', 285.0000, 'ºC'),
	(32487, 108, '2015-02-01 00:24:54.000000', 'temperatura', 34.0000, 'ºC'),
	(32488, 108, '2015-02-01 00:24:55.000000', 'temperatura', 518.0000, 'ºC'),
	(32489, 108, '2015-02-01 00:24:56.000000', 'temperatura', 89.0000, 'ºC'),
	(32490, 108, '2015-02-01 00:24:57.000000', 'temperatura', 89.0000, 'ºC'),
	(32491, 108, '2015-02-01 00:24:58.000000', 'temperatura', 178.0000, 'ºC'),
	(32492, 108, '2015-02-01 00:24:59.000000', 'temperatura', 623.0000, 'ºC'),
	(32493, 108, '2015-02-01 00:25:00.000000', 'temperatura', 184.0000, 'ºC'),
	(32494, 108, '2015-02-01 00:25:01.000000', 'temperatura', 249.0000, 'ºC'),
	(32495, 108, '2015-02-01 00:25:02.000000', 'temperatura', 694.0000, 'ºC'),
	(32496, 108, '2015-02-01 00:25:03.000000', 'temperatura', 322.0000, 'ºC'),
	(32497, 108, '2015-02-01 00:25:04.000000', 'temperatura', 730.0000, 'ºC'),
	(32498, 108, '2015-02-01 00:25:05.000000', 'temperatura', 284.0000, 'ºC'),
	(32499, 108, '2015-02-01 00:25:06.000000', 'temperatura', 429.0000, 'ºC'),
	(32500, 108, '2015-02-01 00:25:07.000000', 'temperatura', 93.0000, 'ºC'),
	(32501, 108, '2015-02-01 00:25:08.000000', 'temperatura', 381.0000, 'ºC'),
	(32502, 108, '2015-02-01 00:25:09.000000', 'temperatura', 426.0000, 'ºC'),
	(32503, 108, '2015-02-01 00:25:10.000000', 'temperatura', 987.0000, 'ºC'),
	(32504, 108, '2015-02-01 00:25:11.000000', 'temperatura', 59.0000, 'ºC'),
	(32505, 108, '2015-02-01 00:25:12.000000', 'temperatura', 933.0000, 'ºC'),
	(32506, 108, '2015-02-01 00:25:13.000000', 'temperatura', 889.0000, 'ºC'),
	(32507, 108, '2015-02-01 00:25:14.000000', 'temperatura', 448.0000, 'ºC'),
	(32508, 108, '2015-02-01 00:25:15.000000', 'temperatura', 771.0000, 'ºC'),
	(32509, 108, '2015-02-01 00:25:16.000000', 'temperatura', 114.0000, 'ºC'),
	(32510, 108, '2015-02-01 00:25:17.000000', 'temperatura', 658.0000, 'ºC'),
	(32511, 108, '2015-02-01 00:25:18.000000', 'temperatura', 546.0000, 'ºC'),
	(32512, 108, '2015-02-01 00:25:19.000000', 'temperatura', 758.0000, 'ºC'),
	(32513, 108, '2015-02-01 00:25:20.000000', 'temperatura', 950.0000, 'ºC'),
	(32514, 108, '2015-02-01 00:25:21.000000', 'temperatura', 80.0000, 'ºC'),
	(32515, 108, '2015-02-01 00:25:22.000000', 'temperatura', 1148.0000, 'ºC'),
	(32516, 108, '2015-02-01 00:25:23.000000', 'temperatura', 703.0000, 'ºC'),
	(32517, 108, '2015-02-01 00:25:24.000000', 'temperatura', 70.0000, 'ºC'),
	(32518, 108, '2015-02-01 00:25:25.000000', 'temperatura', 642.0000, 'ºC'),
	(32519, 108, '2015-02-01 00:25:26.000000', 'temperatura', 600.0000, 'ºC'),
	(32520, 108, '2015-02-01 00:25:27.000000', 'temperatura', 1074.0000, 'ºC'),
	(32521, 108, '2015-02-01 00:25:28.000000', 'temperatura', 1169.0000, 'ºC'),
	(32522, 108, '2015-02-01 00:25:29.000000', 'temperatura', 226.0000, 'ºC'),
	(32523, 108, '2015-02-01 00:25:30.000000', 'temperatura', 23.0000, 'ºC'),
	(32524, 108, '2015-02-01 00:25:31.000000', 'temperatura', 638.0000, 'ºC'),
	(32525, 108, '2015-02-01 00:25:32.000000', 'temperatura', 720.0000, 'ºC'),
	(32526, 108, '2015-02-01 00:25:33.000000', 'temperatura', 489.0000, 'ºC'),
	(32527, 108, '2015-02-01 00:25:34.000000', 'temperatura', 282.0000, 'ºC'),
	(32528, 108, '2015-02-01 00:25:35.000000', 'temperatura', 1147.0000, 'ºC'),
	(32529, 108, '2015-02-01 00:25:36.000000', 'temperatura', 86.0000, 'ºC'),
	(32530, 108, '2015-02-01 00:25:37.000000', 'temperatura', 591.0000, 'ºC'),
	(32531, 108, '2015-02-01 00:25:38.000000', 'temperatura', 298.0000, 'ºC'),
	(32532, 108, '2015-02-01 00:25:39.000000', 'temperatura', 918.0000, 'ºC'),
	(32533, 108, '2015-02-01 00:25:40.000000', 'temperatura', 96.0000, 'ºC'),
	(32534, 108, '2015-02-01 00:25:41.000000', 'temperatura', 126.0000, 'ºC'),
	(32535, 108, '2015-02-01 00:25:42.000000', 'temperatura', 341.0000, 'ºC'),
	(32536, 108, '2015-02-01 00:25:43.000000', 'temperatura', 130.0000, 'ºC'),
	(32537, 108, '2015-02-01 00:25:44.000000', 'temperatura', 826.0000, 'ºC'),
	(32538, 108, '2015-02-01 00:25:45.000000', 'temperatura', 139.0000, 'ºC'),
	(32539, 108, '2015-02-01 00:25:46.000000', 'temperatura', 620.0000, 'ºC'),
	(32540, 108, '2015-02-01 00:25:47.000000', 'temperatura', 284.0000, 'ºC'),
	(32541, 108, '2015-02-01 00:25:48.000000', 'temperatura', 758.0000, 'ºC'),
	(32542, 108, '2015-02-01 00:25:49.000000', 'temperatura', 540.0000, 'ºC'),
	(32543, 108, '2015-02-01 00:25:50.000000', 'temperatura', 425.0000, 'ºC'),
	(32544, 108, '2015-02-01 00:25:51.000000', 'temperatura', 504.0000, 'ºC'),
	(32545, 108, '2015-02-01 00:25:52.000000', 'temperatura', 49.0000, 'ºC'),
	(32546, 108, '2015-02-01 00:25:53.000000', 'temperatura', 1133.0000, 'ºC'),
	(32547, 108, '2015-02-01 00:25:54.000000', 'temperatura', 720.0000, 'ºC'),
	(32548, 108, '2015-02-01 00:25:55.000000', 'temperatura', 199.0000, 'ºC'),
	(32549, 108, '2015-02-01 00:25:56.000000', 'temperatura', 35.0000, 'ºC'),
	(32550, 108, '2015-02-01 00:25:57.000000', 'temperatura', 778.0000, 'ºC'),
	(32551, 108, '2015-02-01 00:25:58.000000', 'temperatura', 185.0000, 'ºC'),
	(32552, 108, '2015-02-01 00:25:59.000000', 'temperatura', 994.0000, 'ºC'),
	(32553, 108, '2015-02-01 00:26:00.000000', 'temperatura', 816.0000, 'ºC'),
	(32554, 108, '2015-02-01 00:26:01.000000', 'temperatura', 1097.0000, 'ºC'),
	(32555, 108, '2015-02-01 00:26:02.000000', 'temperatura', 639.0000, 'ºC'),
	(32556, 108, '2015-02-01 00:26:03.000000', 'temperatura', 1103.0000, 'ºC'),
	(32557, 108, '2015-02-01 00:26:04.000000', 'temperatura', 1199.0000, 'ºC'),
	(32558, 108, '2015-02-01 00:26:05.000000', 'temperatura', 287.0000, 'ºC'),
	(32559, 108, '2015-02-01 00:26:06.000000', 'temperatura', 237.0000, 'ºC'),
	(32560, 108, '2015-02-01 00:26:07.000000', 'temperatura', 325.0000, 'ºC'),
	(32561, 108, '2015-02-01 00:26:08.000000', 'temperatura', 914.0000, 'ºC'),
	(32562, 108, '2015-02-01 00:26:09.000000', 'temperatura', 1195.0000, 'ºC'),
	(32563, 108, '2015-02-01 00:26:10.000000', 'temperatura', 836.0000, 'ºC'),
	(32564, 108, '2015-02-01 00:26:11.000000', 'temperatura', 594.0000, 'ºC'),
	(32565, 108, '2015-02-01 00:26:12.000000', 'temperatura', 462.0000, 'ºC'),
	(32566, 108, '2015-02-01 00:26:13.000000', 'temperatura', 531.0000, 'ºC'),
	(32567, 108, '2015-02-01 00:26:14.000000', 'temperatura', 67.0000, 'ºC'),
	(32568, 108, '2015-02-01 00:26:15.000000', 'temperatura', 1144.0000, 'ºC'),
	(32569, 108, '2015-02-01 00:26:16.000000', 'temperatura', 720.0000, 'ºC'),
	(32570, 108, '2015-02-01 00:26:17.000000', 'temperatura', 168.0000, 'ºC'),
	(32571, 108, '2015-02-01 00:26:18.000000', 'temperatura', 1079.0000, 'ºC'),
	(32572, 108, '2015-02-01 00:26:19.000000', 'temperatura', 93.0000, 'ºC'),
	(32573, 108, '2015-02-01 00:26:20.000000', 'temperatura', 830.0000, 'ºC'),
	(32574, 108, '2015-02-01 00:26:21.000000', 'temperatura', 269.0000, 'ºC'),
	(32575, 108, '2015-02-01 00:26:22.000000', 'temperatura', 57.0000, 'ºC'),
	(32576, 108, '2015-02-01 00:26:23.000000', 'temperatura', 680.0000, 'ºC'),
	(32577, 108, '2015-02-01 00:26:24.000000', 'temperatura', 828.0000, 'ºC'),
	(32578, 108, '2015-02-01 00:26:25.000000', 'temperatura', 901.0000, 'ºC'),
	(32579, 108, '2015-02-01 00:26:26.000000', 'temperatura', 822.0000, 'ºC'),
	(32580, 108, '2015-02-01 00:26:27.000000', 'temperatura', 209.0000, 'ºC'),
	(32581, 108, '2015-02-01 00:26:28.000000', 'temperatura', 978.0000, 'ºC'),
	(32582, 108, '2015-02-01 00:26:29.000000', 'temperatura', 664.0000, 'ºC'),
	(32583, 108, '2015-02-01 00:26:30.000000', 'temperatura', 387.0000, 'ºC'),
	(32584, 108, '2015-02-01 00:26:31.000000', 'temperatura', 1141.0000, 'ºC'),
	(32585, 108, '2015-02-01 00:26:32.000000', 'temperatura', 946.0000, 'ºC'),
	(32586, 108, '2015-02-01 00:26:33.000000', 'temperatura', 109.0000, 'ºC'),
	(32587, 108, '2015-02-01 00:26:34.000000', 'temperatura', 108.0000, 'ºC'),
	(32588, 108, '2015-02-01 00:26:35.000000', 'temperatura', 214.0000, 'ºC'),
	(32589, 108, '2015-02-01 00:26:36.000000', 'temperatura', 747.0000, 'ºC'),
	(32590, 108, '2015-02-01 00:26:37.000000', 'temperatura', 691.0000, 'ºC'),
	(32591, 108, '2015-02-01 00:26:38.000000', 'temperatura', 16.0000, 'ºC'),
	(32592, 108, '2015-02-01 00:26:39.000000', 'temperatura', 407.0000, 'ºC'),
	(32593, 108, '2015-02-01 00:26:40.000000', 'temperatura', 789.0000, 'ºC'),
	(32594, 108, '2015-02-01 00:26:41.000000', 'temperatura', 325.0000, 'ºC'),
	(32595, 108, '2015-02-01 00:26:42.000000', 'temperatura', 457.0000, 'ºC'),
	(32596, 108, '2015-02-01 00:26:43.000000', 'temperatura', 111.0000, 'ºC'),
	(32597, 108, '2015-02-01 00:26:44.000000', 'temperatura', 382.0000, 'ºC'),
	(32598, 108, '2015-02-01 00:26:45.000000', 'temperatura', 381.0000, 'ºC'),
	(32599, 108, '2015-02-01 00:26:46.000000', 'temperatura', 759.0000, 'ºC'),
	(32600, 108, '2015-02-01 00:26:47.000000', 'temperatura', 254.0000, 'ºC'),
	(32601, 108, '2015-02-01 00:26:48.000000', 'temperatura', 192.0000, 'ºC'),
	(32602, 108, '2015-02-01 00:26:49.000000', 'temperatura', 200.0000, 'ºC'),
	(32603, 108, '2015-02-01 00:26:50.000000', 'temperatura', 424.0000, 'ºC'),
	(32604, 108, '2015-02-01 00:26:51.000000', 'temperatura', 319.0000, 'ºC'),
	(32605, 108, '2015-02-01 00:26:52.000000', 'temperatura', 323.0000, 'ºC'),
	(32606, 108, '2015-02-01 00:26:53.000000', 'temperatura', 658.0000, 'ºC'),
	(32607, 108, '2015-02-01 00:26:54.000000', 'temperatura', 1121.0000, 'ºC'),
	(32608, 108, '2015-02-01 00:26:55.000000', 'temperatura', 32.0000, 'ºC'),
	(32609, 108, '2015-02-01 00:26:56.000000', 'temperatura', 397.0000, 'ºC'),
	(32610, 108, '2015-02-01 00:26:57.000000', 'temperatura', 691.0000, 'ºC'),
	(32611, 108, '2015-02-01 00:26:58.000000', 'temperatura', 1063.0000, 'ºC'),
	(32612, 108, '2015-02-01 00:26:59.000000', 'temperatura', 844.0000, 'ºC'),
	(32613, 108, '2015-02-01 00:27:00.000000', 'temperatura', 1032.0000, 'ºC'),
	(32614, 108, '2015-02-01 00:27:01.000000', 'temperatura', 229.0000, 'ºC'),
	(32615, 108, '2015-02-01 00:27:02.000000', 'temperatura', 449.0000, 'ºC'),
	(32616, 108, '2015-02-01 00:27:03.000000', 'temperatura', 357.0000, 'ºC'),
	(32617, 108, '2015-02-01 00:27:04.000000', 'temperatura', 438.0000, 'ºC'),
	(32618, 108, '2015-02-01 00:27:05.000000', 'temperatura', 1122.0000, 'ºC'),
	(32619, 108, '2015-02-01 00:27:06.000000', 'temperatura', 694.0000, 'ºC'),
	(32620, 108, '2015-02-01 00:27:07.000000', 'temperatura', 106.0000, 'ºC'),
	(32621, 108, '2015-02-01 00:27:08.000000', 'temperatura', 847.0000, 'ºC'),
	(32622, 108, '2015-02-01 00:27:09.000000', 'temperatura', 318.0000, 'ºC'),
	(32623, 108, '2015-02-01 00:27:10.000000', 'temperatura', 250.0000, 'ºC'),
	(32624, 108, '2015-02-01 00:27:11.000000', 'temperatura', 296.0000, 'ºC'),
	(32625, 108, '2015-02-01 00:27:12.000000', 'temperatura', 731.0000, 'ºC'),
	(32626, 108, '2015-02-01 00:27:13.000000', 'temperatura', 367.0000, 'ºC'),
	(32627, 108, '2015-02-01 00:27:14.000000', 'temperatura', 842.0000, 'ºC'),
	(32628, 108, '2015-02-01 00:27:15.000000', 'temperatura', 708.0000, 'ºC'),
	(32629, 108, '2015-02-01 00:27:16.000000', 'temperatura', 1016.0000, 'ºC'),
	(32630, 108, '2015-02-01 00:27:17.000000', 'temperatura', 557.0000, 'ºC'),
	(32631, 108, '2015-02-01 00:27:18.000000', 'temperatura', 936.0000, 'ºC'),
	(32632, 108, '2015-02-01 00:27:19.000000', 'temperatura', 611.0000, 'ºC'),
	(32633, 108, '2015-02-01 00:27:20.000000', 'temperatura', 245.0000, 'ºC'),
	(32634, 108, '2015-02-01 00:27:21.000000', 'temperatura', 595.0000, 'ºC'),
	(32635, 108, '2015-02-01 00:27:22.000000', 'temperatura', 1041.0000, 'ºC'),
	(32636, 108, '2015-02-01 00:27:23.000000', 'temperatura', 1020.0000, 'ºC'),
	(32637, 108, '2015-02-01 00:27:24.000000', 'temperatura', 778.0000, 'ºC'),
	(32638, 108, '2015-02-01 00:27:25.000000', 'temperatura', 829.0000, 'ºC'),
	(32639, 108, '2015-02-01 00:27:26.000000', 'temperatura', 611.0000, 'ºC'),
	(32640, 108, '2015-02-01 00:27:27.000000', 'temperatura', 571.0000, 'ºC'),
	(32641, 108, '2015-02-01 00:27:28.000000', 'temperatura', 1020.0000, 'ºC'),
	(32642, 108, '2015-02-01 00:27:29.000000', 'temperatura', 990.0000, 'ºC'),
	(32643, 108, '2015-02-01 00:27:30.000000', 'temperatura', 691.0000, 'ºC'),
	(32644, 108, '2015-02-01 00:27:31.000000', 'temperatura', 484.0000, 'ºC'),
	(32645, 108, '2015-02-01 00:27:32.000000', 'temperatura', 348.0000, 'ºC'),
	(32646, 108, '2015-02-01 00:27:33.000000', 'temperatura', 290.0000, 'ºC'),
	(32647, 108, '2015-02-01 00:27:34.000000', 'temperatura', 407.0000, 'ºC'),
	(32648, 108, '2015-02-01 00:27:35.000000', 'temperatura', 1165.0000, 'ºC'),
	(32649, 108, '2015-02-01 00:27:36.000000', 'temperatura', 1003.0000, 'ºC'),
	(32650, 108, '2015-02-01 00:27:37.000000', 'temperatura', 321.0000, 'ºC'),
	(32651, 108, '2015-02-01 00:27:38.000000', 'temperatura', 997.0000, 'ºC'),
	(32652, 108, '2015-02-01 00:27:39.000000', 'temperatura', 421.0000, 'ºC'),
	(32653, 108, '2015-02-01 00:27:40.000000', 'temperatura', 317.0000, 'ºC'),
	(32654, 108, '2015-02-01 00:27:41.000000', 'temperatura', 323.0000, 'ºC'),
	(32655, 108, '2015-02-01 00:27:42.000000', 'temperatura', 663.0000, 'ºC'),
	(32656, 108, '2015-02-01 00:27:43.000000', 'temperatura', 1146.0000, 'ºC'),
	(32657, 108, '2015-02-01 00:27:44.000000', 'temperatura', 142.0000, 'ºC'),
	(32658, 108, '2015-02-01 00:27:45.000000', 'temperatura', 873.0000, 'ºC'),
	(32659, 108, '2015-02-01 00:27:46.000000', 'temperatura', 339.0000, 'ºC'),
	(32660, 108, '2015-02-01 00:27:47.000000', 'temperatura', 277.0000, 'ºC'),
	(32661, 108, '2015-02-01 00:27:48.000000', 'temperatura', 366.0000, 'ºC'),
	(32662, 108, '2015-02-01 00:27:49.000000', 'temperatura', 1002.0000, 'ºC'),
	(32663, 108, '2015-02-01 00:27:50.000000', 'temperatura', 311.0000, 'ºC'),
	(32664, 108, '2015-02-01 00:27:51.000000', 'temperatura', 949.0000, 'ºC'),
	(32665, 108, '2015-02-01 00:27:52.000000', 'temperatura', 212.0000, 'ºC'),
	(32666, 108, '2015-02-01 00:27:53.000000', 'temperatura', 613.0000, 'ºC'),
	(32667, 108, '2015-02-01 00:27:54.000000', 'temperatura', 30.0000, 'ºC'),
	(32668, 108, '2015-02-01 00:27:55.000000', 'temperatura', 710.0000, 'ºC'),
	(32669, 108, '2015-02-01 00:27:56.000000', 'temperatura', 1063.0000, 'ºC'),
	(32670, 108, '2015-02-01 00:27:57.000000', 'temperatura', 783.0000, 'ºC'),
	(32671, 108, '2015-02-01 00:27:58.000000', 'temperatura', 728.0000, 'ºC'),
	(32672, 108, '2015-02-01 00:27:59.000000', 'temperatura', 90.0000, 'ºC'),
	(32673, 108, '2015-02-01 00:28:00.000000', 'temperatura', 667.0000, 'ºC'),
	(32674, 108, '2015-02-01 00:28:01.000000', 'temperatura', 666.0000, 'ºC'),
	(32675, 108, '2015-02-01 00:28:02.000000', 'temperatura', 129.0000, 'ºC'),
	(32676, 108, '2015-02-01 00:28:03.000000', 'temperatura', 1047.0000, 'ºC'),
	(32677, 108, '2015-02-01 00:28:04.000000', 'temperatura', 49.0000, 'ºC'),
	(32678, 108, '2015-02-01 00:28:05.000000', 'temperatura', 705.0000, 'ºC'),
	(32679, 108, '2015-02-01 00:28:06.000000', 'temperatura', 979.0000, 'ºC'),
	(32680, 108, '2015-02-01 00:28:07.000000', 'temperatura', 381.0000, 'ºC'),
	(32681, 108, '2015-02-01 00:28:08.000000', 'temperatura', 166.0000, 'ºC'),
	(32682, 108, '2015-02-01 00:28:09.000000', 'temperatura', 888.0000, 'ºC'),
	(32683, 108, '2015-02-01 00:28:10.000000', 'temperatura', 343.0000, 'ºC'),
	(32684, 108, '2015-02-01 00:28:11.000000', 'temperatura', 252.0000, 'ºC'),
	(32685, 108, '2015-02-01 00:28:12.000000', 'temperatura', 233.0000, 'ºC'),
	(32686, 108, '2015-02-01 00:28:13.000000', 'temperatura', 409.0000, 'ºC'),
	(32687, 108, '2015-02-01 00:28:14.000000', 'temperatura', 147.0000, 'ºC'),
	(32688, 108, '2015-02-01 00:28:15.000000', 'temperatura', 706.0000, 'ºC'),
	(32689, 108, '2015-02-01 00:28:16.000000', 'temperatura', 690.0000, 'ºC'),
	(32690, 108, '2015-02-01 00:28:17.000000', 'temperatura', 135.0000, 'ºC'),
	(32691, 108, '2015-02-01 00:28:18.000000', 'temperatura', 1003.0000, 'ºC'),
	(32692, 108, '2015-02-01 00:28:19.000000', 'temperatura', 1010.0000, 'ºC'),
	(32693, 108, '2015-02-01 00:28:20.000000', 'temperatura', 841.0000, 'ºC'),
	(32694, 108, '2015-02-01 00:28:21.000000', 'temperatura', 1176.0000, 'ºC'),
	(32695, 108, '2015-02-01 00:28:22.000000', 'temperatura', 957.0000, 'ºC'),
	(32696, 108, '2015-02-01 00:28:23.000000', 'temperatura', 59.0000, 'ºC'),
	(32697, 108, '2015-02-01 00:28:24.000000', 'temperatura', 1024.0000, 'ºC'),
	(32698, 108, '2015-02-01 00:28:25.000000', 'temperatura', 143.0000, 'ºC'),
	(32699, 108, '2015-02-01 00:28:26.000000', 'temperatura', 44.0000, 'ºC'),
	(32700, 108, '2015-02-01 00:28:27.000000', 'temperatura', 991.0000, 'ºC'),
	(32701, 108, '2015-02-01 00:28:28.000000', 'temperatura', 24.0000, 'ºC'),
	(32702, 108, '2015-02-01 00:28:29.000000', 'temperatura', 749.0000, 'ºC'),
	(32703, 108, '2015-02-01 00:28:30.000000', 'temperatura', 70.0000, 'ºC'),
	(32704, 108, '2015-02-01 00:28:31.000000', 'temperatura', 507.0000, 'ºC'),
	(32705, 108, '2015-02-01 00:28:32.000000', 'temperatura', 1124.0000, 'ºC'),
	(32706, 108, '2015-02-01 00:28:33.000000', 'temperatura', 501.0000, 'ºC'),
	(32707, 108, '2015-02-01 00:28:34.000000', 'temperatura', 333.0000, 'ºC'),
	(32708, 108, '2015-02-01 00:28:35.000000', 'temperatura', 160.0000, 'ºC'),
	(32709, 108, '2015-02-01 00:28:36.000000', 'temperatura', 1004.0000, 'ºC'),
	(32710, 108, '2015-02-01 00:28:37.000000', 'temperatura', 942.0000, 'ºC'),
	(32711, 108, '2015-02-01 00:28:38.000000', 'temperatura', 496.0000, 'ºC'),
	(32712, 108, '2015-02-01 00:28:39.000000', 'temperatura', 853.0000, 'ºC'),
	(32713, 108, '2015-02-01 00:28:40.000000', 'temperatura', 381.0000, 'ºC'),
	(32714, 108, '2015-02-01 00:28:41.000000', 'temperatura', 545.0000, 'ºC'),
	(32715, 108, '2015-02-01 00:28:42.000000', 'temperatura', 384.0000, 'ºC'),
	(32716, 108, '2015-02-01 00:28:43.000000', 'temperatura', 286.0000, 'ºC'),
	(32717, 108, '2015-02-01 00:28:44.000000', 'temperatura', 277.0000, 'ºC'),
	(32718, 108, '2015-02-01 00:28:45.000000', 'temperatura', 526.0000, 'ºC'),
	(32719, 108, '2015-02-01 00:28:46.000000', 'temperatura', 601.0000, 'ºC'),
	(32720, 108, '2015-02-01 00:28:47.000000', 'temperatura', 229.0000, 'ºC'),
	(32721, 108, '2015-02-01 00:28:48.000000', 'temperatura', 540.0000, 'ºC'),
	(32722, 108, '2015-02-01 00:28:49.000000', 'temperatura', 814.0000, 'ºC'),
	(32723, 108, '2015-02-01 00:28:50.000000', 'temperatura', 49.0000, 'ºC'),
	(32724, 108, '2015-02-01 00:28:51.000000', 'temperatura', 204.0000, 'ºC'),
	(32725, 108, '2015-02-01 00:28:52.000000', 'temperatura', 873.0000, 'ºC'),
	(32726, 108, '2015-02-01 00:28:53.000000', 'temperatura', 155.0000, 'ºC'),
	(32727, 108, '2015-02-01 00:28:54.000000', 'temperatura', 557.0000, 'ºC'),
	(32728, 108, '2015-02-01 00:28:55.000000', 'temperatura', 1119.0000, 'ºC'),
	(32729, 108, '2015-02-01 00:28:56.000000', 'temperatura', 327.0000, 'ºC'),
	(32730, 108, '2015-02-01 00:28:57.000000', 'temperatura', 678.0000, 'ºC'),
	(32731, 108, '2015-02-01 00:28:58.000000', 'temperatura', 7.0000, 'ºC'),
	(32732, 108, '2015-02-01 00:28:59.000000', 'temperatura', 404.0000, 'ºC'),
	(32733, 108, '2015-02-01 00:29:00.000000', 'temperatura', 798.0000, 'ºC'),
	(32734, 108, '2015-02-01 00:29:01.000000', 'temperatura', 381.0000, 'ºC'),
	(32735, 108, '2015-02-01 00:29:02.000000', 'temperatura', 709.0000, 'ºC'),
	(32736, 108, '2015-02-01 00:29:03.000000', 'temperatura', 3.0000, 'ºC'),
	(32737, 108, '2015-02-01 00:29:04.000000', 'temperatura', 289.0000, 'ºC'),
	(32738, 108, '2015-02-01 00:29:05.000000', 'temperatura', 238.0000, 'ºC'),
	(32739, 108, '2015-02-01 00:29:06.000000', 'temperatura', 324.0000, 'ºC'),
	(32740, 108, '2015-02-01 00:29:07.000000', 'temperatura', 905.0000, 'ºC'),
	(32741, 108, '2015-02-01 00:29:08.000000', 'temperatura', 1152.0000, 'ºC'),
	(32742, 108, '2015-02-01 00:29:09.000000', 'temperatura', 647.0000, 'ºC'),
	(32743, 108, '2015-02-01 00:29:10.000000', 'temperatura', 977.0000, 'ºC'),
	(32744, 108, '2015-02-01 00:29:11.000000', 'temperatura', 547.0000, 'ºC'),
	(32745, 108, '2015-02-01 00:29:12.000000', 'temperatura', 1005.0000, 'ºC'),
	(32746, 108, '2015-02-01 00:29:13.000000', 'temperatura', 986.0000, 'ºC'),
	(32747, 108, '2015-02-01 00:29:14.000000', 'temperatura', 712.0000, 'ºC'),
	(32748, 108, '2015-02-01 00:29:15.000000', 'temperatura', 604.0000, 'ºC'),
	(32749, 108, '2015-02-01 00:29:16.000000', 'temperatura', 886.0000, 'ºC'),
	(32750, 108, '2015-02-01 00:29:17.000000', 'temperatura', 219.0000, 'ºC'),
	(32751, 108, '2015-02-01 00:29:18.000000', 'temperatura', 836.0000, 'ºC'),
	(32752, 108, '2015-02-01 00:29:19.000000', 'temperatura', 1123.0000, 'ºC'),
	(32753, 108, '2015-02-01 00:29:20.000000', 'temperatura', 710.0000, 'ºC'),
	(32754, 108, '2015-02-01 00:29:21.000000', 'temperatura', 181.0000, 'ºC'),
	(32755, 108, '2015-02-01 00:29:22.000000', 'temperatura', 1174.0000, 'ºC'),
	(32756, 108, '2015-02-01 00:29:23.000000', 'temperatura', 529.0000, 'ºC'),
	(32757, 108, '2015-02-01 00:29:24.000000', 'temperatura', 325.0000, 'ºC'),
	(32758, 108, '2015-02-01 00:29:25.000000', 'temperatura', 36.0000, 'ºC'),
	(32759, 108, '2015-02-01 00:29:26.000000', 'temperatura', 405.0000, 'ºC'),
	(32760, 108, '2015-02-01 00:29:27.000000', 'temperatura', 718.0000, 'ºC'),
	(32761, 108, '2015-02-01 00:29:28.000000', 'temperatura', 1175.0000, 'ºC'),
	(32762, 108, '2015-02-01 00:29:29.000000', 'temperatura', 121.0000, 'ºC'),
	(32763, 108, '2015-02-01 00:29:30.000000', 'temperatura', 681.0000, 'ºC'),
	(32764, 108, '2015-02-01 00:29:31.000000', 'temperatura', 641.0000, 'ºC'),
	(32765, 108, '2015-02-01 00:29:32.000000', 'temperatura', 1165.0000, 'ºC'),
	(32766, 108, '2015-02-01 00:29:33.000000', 'temperatura', 303.0000, 'ºC'),
	(32767, 108, '2015-02-01 00:29:34.000000', 'temperatura', 417.0000, 'ºC'),
	(32768, 108, '2015-02-01 00:29:35.000000', 'temperatura', 1180.0000, 'ºC'),
	(32769, 108, '2015-02-01 00:29:36.000000', 'temperatura', 1047.0000, 'ºC'),
	(32770, 108, '2015-02-01 00:29:37.000000', 'temperatura', 498.0000, 'ºC'),
	(32771, 108, '2015-02-01 00:29:38.000000', 'temperatura', 549.0000, 'ºC'),
	(32772, 108, '2015-02-01 00:29:39.000000', 'temperatura', 51.0000, 'ºC'),
	(32773, 108, '2015-02-01 00:29:40.000000', 'temperatura', 1006.0000, 'ºC'),
	(32774, 108, '2015-02-01 00:29:41.000000', 'temperatura', 81.0000, 'ºC'),
	(32775, 108, '2015-02-01 00:29:42.000000', 'temperatura', 987.0000, 'ºC'),
	(32776, 108, '2015-02-01 00:29:43.000000', 'temperatura', 1091.0000, 'ºC'),
	(32777, 108, '2015-02-01 00:29:44.000000', 'temperatura', 94.0000, 'ºC'),
	(32778, 108, '2015-02-01 00:29:45.000000', 'temperatura', 797.0000, 'ºC'),
	(32779, 108, '2015-02-01 00:29:46.000000', 'temperatura', 103.0000, 'ºC'),
	(32780, 108, '2015-02-01 00:29:47.000000', 'temperatura', 525.0000, 'ºC'),
	(32781, 108, '2015-02-01 00:29:48.000000', 'temperatura', 1117.0000, 'ºC'),
	(32782, 108, '2015-02-01 00:29:49.000000', 'temperatura', 411.0000, 'ºC'),
	(32783, 108, '2015-02-01 00:29:50.000000', 'temperatura', 1103.0000, 'ºC'),
	(32784, 108, '2015-02-01 00:29:51.000000', 'temperatura', 685.0000, 'ºC'),
	(32785, 108, '2015-02-01 00:29:52.000000', 'temperatura', 114.0000, 'ºC'),
	(32786, 108, '2015-02-01 00:29:53.000000', 'temperatura', 915.0000, 'ºC'),
	(32787, 108, '2015-02-01 00:29:54.000000', 'temperatura', 633.0000, 'ºC'),
	(32788, 108, '2015-02-01 00:29:55.000000', 'temperatura', 420.0000, 'ºC'),
	(32789, 108, '2015-02-01 00:29:56.000000', 'temperatura', 204.0000, 'ºC'),
	(32790, 108, '2015-02-01 00:29:57.000000', 'temperatura', 962.0000, 'ºC'),
	(32791, 108, '2015-02-01 00:29:58.000000', 'temperatura', 595.0000, 'ºC'),
	(32792, 108, '2015-02-01 00:29:59.000000', 'temperatura', 89.0000, 'ºC'),
	(32793, 108, '2015-02-01 00:30:00.000000', 'temperatura', 1063.0000, 'ºC'),
	(32794, 108, '2015-02-01 00:30:01.000000', 'temperatura', 248.0000, 'ºC'),
	(32795, 108, '2015-02-01 00:30:02.000000', 'temperatura', 450.0000, 'ºC'),
	(32796, 108, '2015-02-01 00:30:03.000000', 'temperatura', 307.0000, 'ºC'),
	(32797, 108, '2015-02-01 00:30:04.000000', 'temperatura', 188.0000, 'ºC'),
	(32798, 108, '2015-02-01 00:30:05.000000', 'temperatura', 17.0000, 'ºC'),
	(32799, 108, '2015-02-01 00:30:06.000000', 'temperatura', 721.0000, 'ºC'),
	(32800, 108, '2015-02-01 00:30:07.000000', 'temperatura', 1154.0000, 'ºC'),
	(32801, 108, '2015-02-01 00:30:08.000000', 'temperatura', 7.0000, 'ºC'),
	(32802, 108, '2015-02-01 00:30:09.000000', 'temperatura', 175.0000, 'ºC'),
	(32803, 108, '2015-02-01 00:30:10.000000', 'temperatura', 853.0000, 'ºC'),
	(32804, 108, '2015-02-01 00:30:11.000000', 'temperatura', 141.0000, 'ºC'),
	(32805, 108, '2015-02-01 00:30:12.000000', 'temperatura', 549.0000, 'ºC'),
	(32806, 108, '2015-02-01 00:30:13.000000', 'temperatura', 1120.0000, 'ºC'),
	(32807, 108, '2015-02-01 00:30:14.000000', 'temperatura', 355.0000, 'ºC'),
	(32808, 108, '2015-02-01 00:30:15.000000', 'temperatura', 816.0000, 'ºC'),
	(32809, 108, '2015-02-01 00:30:16.000000', 'temperatura', 615.0000, 'ºC'),
	(32810, 108, '2015-02-01 00:30:17.000000', 'temperatura', 629.0000, 'ºC'),
	(32811, 108, '2015-02-01 00:30:18.000000', 'temperatura', 98.0000, 'ºC'),
	(32812, 108, '2015-02-01 00:30:19.000000', 'temperatura', 1003.0000, 'ºC'),
	(32813, 108, '2015-02-01 00:30:20.000000', 'temperatura', 1122.0000, 'ºC'),
	(32814, 108, '2015-02-01 00:30:21.000000', 'temperatura', 200.0000, 'ºC'),
	(32815, 108, '2015-02-01 00:30:22.000000', 'temperatura', 38.0000, 'ºC'),
	(32816, 108, '2015-02-01 00:30:23.000000', 'temperatura', 787.0000, 'ºC'),
	(32817, 108, '2015-02-01 00:30:24.000000', 'temperatura', 225.0000, 'ºC'),
	(32818, 108, '2015-02-01 00:30:25.000000', 'temperatura', 1163.0000, 'ºC'),
	(32819, 108, '2015-02-01 00:30:26.000000', 'temperatura', 339.0000, 'ºC'),
	(32820, 108, '2015-02-01 00:30:27.000000', 'temperatura', 607.0000, 'ºC'),
	(32821, 108, '2015-02-01 00:30:28.000000', 'temperatura', 821.0000, 'ºC'),
	(32822, 108, '2015-02-01 00:30:29.000000', 'temperatura', 1082.0000, 'ºC'),
	(32823, 108, '2015-02-01 00:30:30.000000', 'temperatura', 548.0000, 'ºC'),
	(32824, 108, '2015-02-01 00:30:31.000000', 'temperatura', 697.0000, 'ºC'),
	(32825, 108, '2015-02-01 00:30:32.000000', 'temperatura', 638.0000, 'ºC'),
	(32826, 108, '2015-02-01 00:30:33.000000', 'temperatura', 1102.0000, 'ºC'),
	(32827, 108, '2015-02-01 00:30:34.000000', 'temperatura', 1195.0000, 'ºC'),
	(32828, 108, '2015-02-01 00:30:35.000000', 'temperatura', 270.0000, 'ºC'),
	(32829, 108, '2015-02-01 00:30:36.000000', 'temperatura', 164.0000, 'ºC'),
	(32830, 108, '2015-02-01 00:30:37.000000', 'temperatura', 11.0000, 'ºC'),
	(32831, 108, '2015-02-01 00:30:38.000000', 'temperatura', 766.0000, 'ºC'),
	(32832, 108, '2015-02-01 00:30:39.000000', 'temperatura', 196.0000, 'ºC'),
	(32833, 108, '2015-02-01 00:30:40.000000', 'temperatura', 1082.0000, 'ºC'),
	(32834, 108, '2015-02-01 00:30:41.000000', 'temperatura', 23.0000, 'ºC'),
	(32835, 108, '2015-02-01 00:30:42.000000', 'temperatura', 471.0000, 'ºC'),
	(32836, 108, '2015-02-01 00:30:43.000000', 'temperatura', 1084.0000, 'ºC'),
	(32837, 108, '2015-02-01 00:30:44.000000', 'temperatura', 409.0000, 'ºC'),
	(32838, 108, '2015-02-01 00:30:45.000000', 'temperatura', 1194.0000, 'ºC'),
	(32839, 108, '2015-02-01 00:30:46.000000', 'temperatura', 1142.0000, 'ºC'),
	(32840, 108, '2015-02-01 00:30:47.000000', 'temperatura', 927.0000, 'ºC'),
	(32841, 108, '2015-02-01 00:30:48.000000', 'temperatura', 11.0000, 'ºC'),
	(32842, 108, '2015-02-01 00:30:49.000000', 'temperatura', 876.0000, 'ºC'),
	(32843, 108, '2015-02-01 00:30:50.000000', 'temperatura', 745.0000, 'ºC'),
	(32844, 108, '2015-02-01 00:30:51.000000', 'temperatura', 1096.0000, 'ºC'),
	(32845, 108, '2015-02-01 00:30:52.000000', 'temperatura', 849.0000, 'ºC'),
	(32846, 108, '2015-02-01 00:30:53.000000', 'temperatura', 956.0000, 'ºC'),
	(32847, 108, '2015-02-01 00:30:54.000000', 'temperatura', 1033.0000, 'ºC'),
	(32848, 108, '2015-02-01 00:30:55.000000', 'temperatura', 1099.0000, 'ºC'),
	(32849, 108, '2015-02-01 00:30:56.000000', 'temperatura', 1196.0000, 'ºC'),
	(32850, 108, '2015-02-01 00:30:57.000000', 'temperatura', 285.0000, 'ºC'),
	(32851, 108, '2015-02-01 00:30:58.000000', 'temperatura', 235.0000, 'ºC'),
	(32852, 108, '2015-02-01 00:30:59.000000', 'temperatura', 323.0000, 'ºC'),
	(32853, 108, '2015-02-01 00:31:00.000000', 'temperatura', 910.0000, 'ºC'),
	(32854, 108, '2015-02-01 00:31:01.000000', 'temperatura', 1181.0000, 'ºC'),
	(32855, 108, '2015-02-01 00:31:02.000000', 'temperatura', 777.0000, 'ºC'),
	(32856, 108, '2015-02-01 00:31:03.000000', 'temperatura', 342.0000, 'ºC'),
	(32857, 108, '2015-02-01 00:31:04.000000', 'temperatura', 578.0000, 'ºC'),
	(32858, 108, '2015-02-01 00:31:05.000000', 'temperatura', 666.0000, 'ºC'),
	(32859, 108, '2015-02-01 00:31:06.000000', 'temperatura', 397.0000, 'ºC'),
	(32860, 108, '2015-02-01 00:31:07.000000', 'temperatura', 1187.0000, 'ºC'),
	(32861, 108, '2015-02-01 00:31:08.000000', 'temperatura', 1142.0000, 'ºC'),
	(32862, 108, '2015-02-01 00:31:09.000000', 'temperatura', 953.0000, 'ºC'),
	(32863, 108, '2015-02-01 00:31:10.000000', 'temperatura', 139.0000, 'ºC'),
	(32864, 108, '2015-02-01 00:31:11.000000', 'temperatura', 238.0000, 'ºC'),
	(32865, 108, '2015-02-01 00:31:12.000000', 'temperatura', 771.0000, 'ºC'),
	(32866, 108, '2015-02-01 00:31:13.000000', 'temperatura', 741.0000, 'ºC'),
	(32867, 108, '2015-02-01 00:31:14.000000', 'temperatura', 192.0000, 'ºC'),
	(32868, 108, '2015-02-01 00:31:15.000000', 'temperatura', 1139.0000, 'ºC'),
	(32869, 108, '2015-02-01 00:31:16.000000', 'temperatura', 317.0000, 'ºC'),
	(32870, 108, '2015-02-01 00:31:17.000000', 'temperatura', 572.0000, 'ºC'),
	(32871, 108, '2015-02-01 00:31:18.000000', 'temperatura', 706.0000, 'ºC'),
	(32872, 108, '2015-02-01 00:31:19.000000', 'temperatura', 616.0000, 'ºC'),
	(32873, 108, '2015-02-01 00:31:20.000000', 'temperatura', 963.0000, 'ºC'),
	(32874, 108, '2015-02-01 00:31:21.000000', 'temperatura', 566.0000, 'ºC'),
	(32875, 108, '2015-02-01 00:31:22.000000', 'temperatura', 1140.0000, 'ºC'),
	(32876, 108, '2015-02-01 00:31:23.000000', 'temperatura', 406.0000, 'ºC'),
	(32877, 108, '2015-02-01 00:31:24.000000', 'temperatura', 1010.0000, 'ºC'),
	(32878, 108, '2015-02-01 00:31:25.000000', 'temperatura', 232.0000, 'ºC'),
	(32879, 108, '2015-02-01 00:31:26.000000', 'temperatura', 531.0000, 'ºC'),
	(32880, 108, '2015-02-01 00:31:27.000000', 'temperatura', 761.0000, 'ºC'),
	(32881, 108, '2015-02-01 00:31:28.000000', 'temperatura', 1009.0000, 'ºC'),
	(32882, 108, '2015-02-01 00:31:29.000000', 'temperatura', 365.0000, 'ºC'),
	(32883, 108, '2015-02-01 00:31:30.000000', 'temperatura', 1198.0000, 'ºC'),
	(32884, 108, '2015-02-01 00:31:31.000000', 'temperatura', 94.0000, 'ºC'),
	(32885, 108, '2015-02-01 00:31:32.000000', 'temperatura', 479.0000, 'ºC'),
	(32886, 108, '2015-02-01 00:31:33.000000', 'temperatura', 913.0000, 'ºC'),
	(32887, 108, '2015-02-01 00:31:34.000000', 'temperatura', 728.0000, 'ºC'),
	(32888, 108, '2015-02-01 00:31:35.000000', 'temperatura', 900.0000, 'ºC'),
	(32889, 108, '2015-02-01 00:31:36.000000', 'temperatura', 1117.0000, 'ºC'),
	(32890, 108, '2015-02-01 00:31:37.000000', 'temperatura', 488.0000, 'ºC'),
	(32891, 108, '2015-02-01 00:31:38.000000', 'temperatura', 287.0000, 'ºC'),
	(32892, 108, '2015-02-01 00:31:39.000000', 'temperatura', 1172.0000, 'ºC'),
	(32893, 108, '2015-02-01 00:31:40.000000', 'temperatura', 201.0000, 'ºC'),
	(32894, 108, '2015-02-01 00:31:41.000000', 'temperatura', 1088.0000, 'ºC'),
	(32895, 108, '2015-02-01 00:31:42.000000', 'temperatura', 37.0000, 'ºC'),
	(32896, 108, '2015-02-01 00:31:43.000000', 'temperatura', 523.0000, 'ºC'),
	(32897, 108, '2015-02-01 00:31:44.000000', 'temperatura', 102.0000, 'ºC'),
	(32898, 108, '2015-02-01 00:31:45.000000', 'temperatura', 144.0000, 'ºC'),
	(32899, 108, '2015-02-01 00:31:46.000000', 'temperatura', 414.0000, 'ºC'),
	(32900, 108, '2015-02-01 00:31:47.000000', 'temperatura', 439.0000, 'ºC'),
	(32901, 108, '2015-02-01 00:31:48.000000', 'temperatura', 953.0000, 'ºC'),
	(32902, 108, '2015-02-01 00:31:49.000000', 'temperatura', 1048.0000, 'ºC'),
	(32903, 108, '2015-02-01 00:31:50.000000', 'temperatura', 1181.0000, 'ºC'),
	(32904, 108, '2015-02-01 00:31:51.000000', 'temperatura', 361.0000, 'ºC'),
	(32905, 108, '2015-02-01 00:31:52.000000', 'temperatura', 661.0000, 'ºC'),
	(32906, 108, '2015-02-01 00:31:53.000000', 'temperatura', 1025.0000, 'ºC'),
	(32907, 108, '2015-02-01 00:31:54.000000', 'temperatura', 741.0000, 'ºC'),
	(32908, 108, '2015-02-01 00:31:55.000000', 'temperatura', 631.0000, 'ºC'),
	(32909, 108, '2015-02-01 00:31:56.000000', 'temperatura', 931.0000, 'ºC'),
	(32910, 108, '2015-02-01 00:31:57.000000', 'temperatura', 362.0000, 'ºC'),
	(32911, 108, '2015-02-01 00:31:58.000000', 'temperatura', 216.0000, 'ºC'),
	(32912, 108, '2015-02-01 00:31:59.000000', 'temperatura', 1198.0000, 'ºC'),
	(32913, 108, '2015-02-01 00:32:00.000000', 'temperatura', 543.0000, 'ºC'),
	(32914, 108, '2015-02-01 00:32:01.000000', 'temperatura', 322.0000, 'ºC'),
	(32915, 108, '2015-02-01 00:32:02.000000', 'temperatura', 1179.0000, 'ºC'),
	(32916, 108, '2015-02-01 00:32:03.000000', 'temperatura', 129.0000, 'ºC'),
	(32917, 108, '2015-02-01 00:32:04.000000', 'temperatura', 709.0000, 'ºC'),
	(32918, 108, '2015-02-01 00:32:05.000000', 'temperatura', 758.0000, 'ºC'),
	(32919, 108, '2015-02-01 00:32:06.000000', 'temperatura', 463.0000, 'ºC'),
	(32920, 108, '2015-02-01 00:32:07.000000', 'temperatura', 43.0000, 'ºC'),
	(32921, 108, '2015-02-01 00:32:08.000000', 'temperatura', 26.0000, 'ºC'),
	(32922, 108, '2015-02-01 00:32:09.000000', 'temperatura', 0.0000, 'ºC'),
	(32923, 108, '2015-02-01 00:32:10.000000', 'temperatura', 1124.0000, 'ºC'),
	(32924, 108, '2015-02-01 00:32:11.000000', 'temperatura', 820.0000, 'ºC'),
	(32925, 108, '2015-02-01 00:32:12.000000', 'temperatura', 728.0000, 'ºC'),
	(32926, 108, '2015-02-01 00:32:13.000000', 'temperatura', 1180.0000, 'ºC'),
	(32927, 108, '2015-02-01 00:32:14.000000', 'temperatura', 118.0000, 'ºC'),
	(32928, 108, '2015-02-01 00:32:15.000000', 'temperatura', 650.0000, 'ºC'),
	(32929, 108, '2015-02-01 00:32:16.000000', 'temperatura', 497.0000, 'ºC'),
	(32930, 108, '2015-02-01 00:32:17.000000', 'temperatura', 536.0000, 'ºC'),
	(32931, 108, '2015-02-01 00:32:18.000000', 'temperatura', 1190.0000, 'ºC'),
	(32932, 108, '2015-02-01 00:32:19.000000', 'temperatura', 744.0000, 'ºC'),
	(32933, 108, '2015-02-01 00:32:20.000000', 'temperatura', 148.0000, 'ºC'),
	(32934, 108, '2015-02-01 00:32:21.000000', 'temperatura', 910.0000, 'ºC'),
	(32935, 108, '2015-02-01 00:32:22.000000', 'temperatura', 507.0000, 'ºC'),
	(32936, 108, '2015-02-01 00:32:23.000000', 'temperatura', 1005.0000, 'ºC'),
	(32937, 108, '2015-02-01 00:32:24.000000', 'temperatura', 1106.0000, 'ºC'),
	(32938, 108, '2015-02-01 00:32:25.000000', 'temperatura', 114.0000, 'ºC'),
	(32939, 108, '2015-02-01 00:32:26.000000', 'temperatura', 854.0000, 'ºC'),
	(32940, 108, '2015-02-01 00:32:27.000000', 'temperatura', 325.0000, 'ºC'),
	(32941, 108, '2015-02-01 00:32:28.000000', 'temperatura', 267.0000, 'ºC'),
	(32942, 108, '2015-02-01 00:32:29.000000', 'temperatura', 361.0000, 'ºC'),
	(32943, 108, '2015-02-01 00:32:30.000000', 'temperatura', 1004.0000, 'ºC'),
	(32944, 108, '2015-02-01 00:32:31.000000', 'temperatura', 336.0000, 'ºC'),
	(32945, 108, '2015-02-01 00:32:32.000000', 'temperatura', 1068.0000, 'ºC'),
	(32946, 108, '2015-02-01 00:32:33.000000', 'temperatura', 734.0000, 'ºC'),
	(32947, 108, '2015-02-01 00:32:34.000000', 'temperatura', 467.0000, 'ºC'),
	(32948, 108, '2015-02-01 00:32:35.000000', 'temperatura', 132.0000, 'ºC'),
	(32949, 108, '2015-02-01 00:32:36.000000', 'temperatura', 459.0000, 'ºC'),
	(32950, 108, '2015-02-01 00:32:37.000000', 'temperatura', 698.0000, 'ºC'),
	(32951, 108, '2015-02-01 00:32:38.000000', 'temperatura', 917.0000, 'ºC'),
	(32952, 108, '2015-02-01 00:32:39.000000', 'temperatura', 88.0000, 'ºC'),
	(32953, 108, '2015-02-01 00:32:40.000000', 'temperatura', 91.0000, 'ºC'),
	(32954, 108, '2015-02-01 00:32:41.000000', 'temperatura', 192.0000, 'ºC'),
	(32955, 108, '2015-02-01 00:32:42.000000', 'temperatura', 688.0000, 'ºC'),
	(32956, 108, '2015-02-01 00:32:43.000000', 'temperatura', 466.0000, 'ºC'),
	(32957, 108, '2015-02-01 00:32:44.000000', 'temperatura', 263.0000, 'ºC'),
	(32958, 108, '2015-02-01 00:32:45.000000', 'temperatura', 1119.0000, 'ºC'),
	(32959, 108, '2015-02-01 00:32:46.000000', 'temperatura', 5.0000, 'ºC'),
	(32960, 108, '2015-02-01 00:32:47.000000', 'temperatura', 269.0000, 'ºC'),
	(32961, 108, '2015-02-01 00:32:48.000000', 'temperatura', 129.0000, 'ºC'),
	(32962, 108, '2015-02-01 00:32:49.000000', 'temperatura', 1042.0000, 'ºC'),
	(32963, 108, '2015-02-01 00:32:50.000000', 'temperatura', 21.0000, 'ºC'),
	(32964, 108, '2015-02-01 00:32:51.000000', 'temperatura', 582.0000, 'ºC'),
	(32965, 108, '2015-02-01 00:32:52.000000', 'temperatura', 445.0000, 'ºC'),
	(32966, 108, '2015-02-01 00:32:53.000000', 'temperatura', 482.0000, 'ºC'),
	(32967, 108, '2015-02-01 00:32:54.000000', 'temperatura', 1072.0000, 'ºC'),
	(32968, 108, '2015-02-01 00:32:55.000000', 'temperatura', 318.0000, 'ºC'),
	(32969, 108, '2015-02-01 00:32:56.000000', 'temperatura', 773.0000, 'ºC'),
	(32970, 108, '2015-02-01 00:32:57.000000', 'temperatura', 513.0000, 'ºC'),
	(32971, 108, '2015-02-01 00:32:58.000000', 'temperatura', 245.0000, 'ºC'),
	(32972, 108, '2015-02-01 00:32:59.000000', 'temperatura', 887.0000, 'ºC'),
	(32973, 108, '2015-02-01 00:33:00.000000', 'temperatura', 100.0000, 'ºC'),
	(32974, 108, '2015-02-01 00:33:01.000000', 'temperatura', 240.0000, 'ºC'),
	(32975, 108, '2015-02-01 00:33:02.000000', 'temperatura', 898.0000, 'ºC'),
	(32976, 108, '2015-02-01 00:33:03.000000', 'temperatura', 174.0000, 'ºC'),
	(32977, 108, '2015-02-01 00:33:04.000000', 'temperatura', 576.0000, 'ºC'),
	(32978, 108, '2015-02-01 00:33:05.000000', 'temperatura', 1159.0000, 'ºC'),
	(32979, 108, '2015-02-01 00:33:06.000000', 'temperatura', 468.0000, 'ºC'),
	(32980, 108, '2015-02-01 00:33:07.000000', 'temperatura', 64.0000, 'ºC'),
	(32981, 108, '2015-02-01 00:33:08.000000', 'temperatura', 114.0000, 'ºC'),
	(32982, 108, '2015-02-01 00:33:09.000000', 'temperatura', 381.0000, 'ºC'),
	(32983, 108, '2015-02-01 00:33:10.000000', 'temperatura', 361.0000, 'ºC'),
	(32984, 108, '2015-02-01 00:33:11.000000', 'temperatura', 663.0000, 'ºC'),
	(32985, 108, '2015-02-01 00:33:12.000000', 'temperatura', 1033.0000, 'ºC'),
	(32986, 108, '2015-02-01 00:33:13.000000', 'temperatura', 775.0000, 'ºC'),
	(32987, 108, '2015-02-01 00:33:14.000000', 'temperatura', 779.0000, 'ºC'),
	(32988, 108, '2015-02-01 00:33:15.000000', 'temperatura', 371.0000, 'ºC'),
	(32989, 108, '2015-02-01 00:33:16.000000', 'temperatura', 717.0000, 'ºC'),
	(32990, 108, '2015-02-01 00:33:17.000000', 'temperatura', 71.0000, 'ºC'),
	(32991, 108, '2015-02-01 00:33:18.000000', 'temperatura', 605.0000, 'ºC'),
	(32992, 108, '2015-02-01 00:33:19.000000', 'temperatura', 415.0000, 'ºC'),
	(32993, 108, '2015-02-01 00:33:20.000000', 'temperatura', 259.0000, 'ºC'),
	(32994, 108, '2015-02-01 00:33:21.000000', 'temperatura', 50.0000, 'ºC'),
	(32995, 108, '2015-02-01 00:33:22.000000', 'temperatura', 673.0000, 'ºC'),
	(32996, 108, '2015-02-01 00:33:23.000000', 'temperatura', 815.0000, 'ºC'),
	(32997, 108, '2015-02-01 00:33:24.000000', 'temperatura', 857.0000, 'ºC'),
	(32998, 108, '2015-02-01 00:33:25.000000', 'temperatura', 640.0000, 'ºC'),
	(32999, 108, '2015-02-01 00:33:26.000000', 'temperatura', 631.0000, 'ºC'),
	(33000, 108, '2015-02-01 00:33:27.000000', 'temperatura', 33.0000, 'ºC'),
	(33001, 108, '2015-02-01 00:33:28.000000', 'temperatura', 675.0000, 'ºC'),
	(33002, 108, '2015-02-01 00:33:29.000000', 'temperatura', 874.0000, 'ºC'),
	(33003, 108, '2015-02-01 00:33:30.000000', 'temperatura', 1148.0000, 'ºC'),
	(33004, 108, '2015-02-01 00:33:31.000000', 'temperatura', 718.0000, 'ºC'),
	(33005, 108, '2015-02-01 00:33:32.000000', 'temperatura', 148.0000, 'ºC'),
	(33006, 108, '2015-02-01 00:33:33.000000', 'temperatura', 986.0000, 'ºC'),
	(33007, 108, '2015-02-01 00:33:34.000000', 'temperatura', 888.0000, 'ºC'),
	(33008, 108, '2015-02-01 00:33:35.000000', 'temperatura', 280.0000, 'ºC'),
	(33009, 108, '2015-02-01 00:33:36.000000', 'temperatura', 1136.0000, 'ºC'),
	(33010, 108, '2015-02-01 00:33:37.000000', 'temperatura', 40.0000, 'ºC'),
	(33011, 108, '2015-02-01 00:33:38.000000', 'temperatura', 395.0000, 'ºC'),
	(33012, 108, '2015-02-01 00:33:39.000000', 'temperatura', 653.0000, 'ºC'),
	(33013, 108, '2015-02-01 00:33:40.000000', 'temperatura', 881.0000, 'ºC'),
	(33014, 108, '2015-02-01 00:33:41.000000', 'temperatura', 48.0000, 'ºC'),
	(33015, 108, '2015-02-01 00:33:42.000000', 'temperatura', 1196.0000, 'ºC'),
	(33016, 108, '2015-02-01 00:33:43.000000', 'temperatura', 1038.0000, 'ºC'),
	(33017, 108, '2015-02-01 00:33:44.000000', 'temperatura', 401.0000, 'ºC'),
	(33018, 108, '2015-02-01 00:33:45.000000', 'temperatura', 90.0000, 'ºC'),
	(33019, 108, '2015-02-01 00:33:46.000000', 'temperatura', 451.0000, 'ºC'),
	(33020, 108, '2015-02-01 00:33:47.000000', 'temperatura', 782.0000, 'ºC'),
	(33021, 108, '2015-02-01 00:33:48.000000', 'temperatura', 161.0000, 'ºC'),
	(33022, 108, '2015-02-01 00:33:49.000000', 'temperatura', 857.0000, 'ºC'),
	(33023, 108, '2015-02-01 00:33:50.000000', 'temperatura', 202.0000, 'ºC'),
	(33024, 108, '2015-02-01 00:33:51.000000', 'temperatura', 842.0000, 'ºC'),
	(33025, 108, '2015-02-01 00:33:52.000000', 'temperatura', 3.0000, 'ºC'),
	(33026, 108, '2015-02-01 00:33:53.000000', 'temperatura', 1092.0000, 'ºC'),
	(33027, 108, '2015-02-01 00:33:54.000000', 'temperatura', 649.0000, 'ºC'),
	(33028, 108, '2015-02-01 00:33:55.000000', 'temperatura', 1172.0000, 'ºC'),
	(33029, 108, '2015-02-01 00:33:56.000000', 'temperatura', 313.0000, 'ºC'),
	(33030, 108, '2015-02-01 00:33:57.000000', 'temperatura', 450.0000, 'ºC'),
	(33031, 108, '2015-02-01 00:33:58.000000', 'temperatura', 113.0000, 'ºC'),
	(33032, 108, '2015-02-01 00:33:59.000000', 'temperatura', 412.0000, 'ºC'),
	(33033, 108, '2015-02-01 00:34:00.000000', 'temperatura', 523.0000, 'ºC'),
	(33034, 108, '2015-02-01 00:34:01.000000', 'temperatura', 179.0000, 'ºC'),
	(33035, 108, '2015-02-01 00:34:02.000000', 'temperatura', 528.0000, 'ºC'),
	(33036, 108, '2015-02-01 00:34:03.000000', 'temperatura', 902.0000, 'ºC'),
	(33037, 108, '2015-02-01 00:34:04.000000', 'temperatura', 529.0000, 'ºC'),
	(33038, 108, '2015-02-01 00:34:05.000000', 'temperatura', 1136.0000, 'ºC'),
	(33039, 108, '2015-02-01 00:34:06.000000', 'temperatura', 496.0000, 'ºC'),
	(33040, 108, '2015-02-01 00:34:07.000000', 'temperatura', 273.0000, 'ºC'),
	(33041, 108, '2015-02-01 00:34:08.000000', 'temperatura', 1078.0000, 'ºC'),
	(33042, 108, '2015-02-01 00:34:09.000000', 'temperatura', 972.0000, 'ºC'),
	(33043, 108, '2015-02-01 00:34:10.000000', 'temperatura', 424.0000, 'ºC'),
	(33044, 108, '2015-02-01 00:34:11.000000', 'temperatura', 405.0000, 'ºC'),
	(33045, 108, '2015-02-01 00:34:12.000000', 'temperatura', 753.0000, 'ºC'),
	(33046, 108, '2015-02-01 00:34:13.000000', 'temperatura', 151.0000, 'ºC'),
	(33047, 108, '2015-02-01 00:34:14.000000', 'temperatura', 895.0000, 'ºC'),
	(33048, 108, '2015-02-01 00:34:15.000000', 'temperatura', 426.0000, 'ºC'),
	(33049, 108, '2015-02-01 00:34:16.000000', 'temperatura', 642.0000, 'ºC'),
	(33050, 108, '2015-02-01 00:34:17.000000', 'temperatura', 734.0000, 'ºC'),
	(33051, 108, '2015-02-01 00:34:18.000000', 'temperatura', 545.0000, 'ºC'),
	(33052, 108, '2015-02-01 00:34:19.000000', 'temperatura', 523.0000, 'ºC'),
	(33053, 108, '2015-02-01 00:34:20.000000', 'temperatura', 979.0000, 'ºC'),
	(33054, 108, '2015-02-01 00:34:21.000000', 'temperatura', 927.0000, 'ºC'),
	(33055, 108, '2015-02-01 00:34:22.000000', 'temperatura', 500.0000, 'ºC'),
	(33056, 108, '2015-02-01 00:34:23.000000', 'temperatura', 919.0000, 'ºC'),
	(33057, 108, '2015-02-01 00:34:24.000000', 'temperatura', 693.0000, 'ºC'),
	(33058, 108, '2015-02-01 00:34:25.000000', 'temperatura', 711.0000, 'ºC'),
	(33059, 108, '2015-02-01 00:34:26.000000', 'temperatura', 276.0000, 'ºC'),
	(33060, 108, '2015-02-01 00:34:27.000000', 'temperatura', 449.0000, 'ºC'),
	(33061, 108, '2015-02-01 00:34:28.000000', 'temperatura', 215.0000, 'ºC'),
	(33062, 108, '2015-02-01 00:34:29.000000', 'temperatura', 931.0000, 'ºC'),
	(33063, 108, '2015-02-01 00:34:30.000000', 'temperatura', 409.0000, 'ºC'),
	(33064, 108, '2015-02-01 00:34:31.000000', 'temperatura', 455.0000, 'ºC'),
	(33065, 108, '2015-02-01 00:34:32.000000', 'temperatura', 1046.0000, 'ºC'),
	(33066, 108, '2015-02-01 00:34:33.000000', 'temperatura', 268.0000, 'ºC'),
	(33067, 108, '2015-02-01 00:34:34.000000', 'temperatura', 600.0000, 'ºC'),
	(33068, 108, '2015-02-01 00:34:35.000000', 'temperatura', 999.0000, 'ºC'),
	(33069, 108, '2015-02-01 00:34:36.000000', 'temperatura', 793.0000, 'ºC'),
	(33070, 108, '2015-02-01 00:34:37.000000', 'temperatura', 971.0000, 'ºC'),
	(33071, 108, '2015-02-01 00:34:38.000000', 'temperatura', 76.0000, 'ºC'),
	(33072, 108, '2015-02-01 00:34:39.000000', 'temperatura', 1068.0000, 'ºC'),
	(33073, 108, '2015-02-01 00:34:40.000000', 'temperatura', 311.0000, 'ºC'),
	(33074, 108, '2015-02-01 00:34:41.000000', 'temperatura', 751.0000, 'ºC'),
	(33075, 108, '2015-02-01 00:34:42.000000', 'temperatura', 423.0000, 'ºC'),
	(33076, 108, '2015-02-01 00:34:43.000000', 'temperatura', 1064.0000, 'ºC'),
	(33077, 108, '2015-02-01 00:34:44.000000', 'temperatura', 451.0000, 'ºC'),
	(33078, 108, '2015-02-01 00:34:45.000000', 'temperatura', 261.0000, 'ºC'),
	(33079, 108, '2015-02-01 00:34:46.000000', 'temperatura', 1155.0000, 'ºC'),
	(33080, 108, '2015-02-01 00:34:47.000000', 'temperatura', 192.0000, 'ºC'),
	(33081, 108, '2015-02-01 00:34:48.000000', 'temperatura', 1096.0000, 'ºC'),
	(33082, 108, '2015-02-01 00:34:49.000000', 'temperatura', 104.0000, 'ºC'),
	(33083, 108, '2015-02-01 00:34:50.000000', 'temperatura', 831.0000, 'ºC'),
	(33084, 108, '2015-02-01 00:34:51.000000', 'temperatura', 246.0000, 'ºC'),
	(33085, 108, '2015-02-01 00:34:52.000000', 'temperatura', 1137.0000, 'ºC'),
	(33086, 108, '2015-02-01 00:34:53.000000', 'temperatura', 146.0000, 'ºC'),
	(33087, 108, '2015-02-01 00:34:54.000000', 'temperatura', 919.0000, 'ºC'),
	(33088, 108, '2015-02-01 00:34:55.000000', 'temperatura', 557.0000, 'ºC'),
	(33089, 108, '2015-02-01 00:34:56.000000', 'temperatura', 31.0000, 'ºC'),
	(33090, 108, '2015-02-01 00:34:57.000000', 'temperatura', 882.0000, 'ºC'),
	(33091, 108, '2015-02-01 00:34:58.000000', 'temperatura', 719.0000, 'ºC'),
	(33092, 108, '2015-02-01 00:34:59.000000', 'temperatura', 949.0000, 'ºC'),
	(33093, 108, '2015-02-01 00:35:00.000000', 'temperatura', 189.0000, 'ºC'),
	(33094, 108, '2015-02-01 00:35:01.000000', 'temperatura', 499.0000, 'ºC'),
	(33095, 108, '2015-02-01 00:35:02.000000', 'temperatura', 727.0000, 'ºC'),
	(33096, 108, '2015-02-01 00:35:03.000000', 'temperatura', 941.0000, 'ºC'),
	(33097, 108, '2015-02-01 00:35:04.000000', 'temperatura', 123.0000, 'ºC'),
	(33098, 108, '2015-02-01 00:35:05.000000', 'temperatura', 193.0000, 'ºC'),
	(33099, 108, '2015-02-01 00:35:06.000000', 'temperatura', 596.0000, 'ºC'),
	(33100, 108, '2015-02-01 00:35:07.000000', 'temperatura', 1.0000, 'ºC'),
	(33101, 108, '2015-02-01 00:35:08.000000', 'temperatura', 619.0000, 'ºC'),
	(33102, 108, '2015-02-01 00:35:09.000000', 'temperatura', 693.0000, 'ºC'),
	(33103, 108, '2015-02-01 00:35:10.000000', 'temperatura', 409.0000, 'ºC'),
	(33104, 108, '2015-02-01 00:35:11.000000', 'temperatura', 1167.0000, 'ºC'),
	(33105, 108, '2015-02-01 00:35:12.000000', 'temperatura', 1006.0000, 'ºC'),
	(33106, 108, '2015-02-01 00:35:13.000000', 'temperatura', 329.0000, 'ºC'),
	(33107, 108, '2015-02-01 00:35:14.000000', 'temperatura', 1027.0000, 'ºC'),
	(33108, 108, '2015-02-01 00:35:15.000000', 'temperatura', 550.0000, 'ºC'),
	(33109, 108, '2015-02-01 00:35:16.000000', 'temperatura', 869.0000, 'ºC'),
	(33110, 108, '2015-02-01 00:35:17.000000', 'temperatura', 294.0000, 'ºC'),
	(33111, 108, '2015-02-01 00:35:18.000000', 'temperatura', 66.0000, 'ºC'),
	(33112, 108, '2015-02-01 00:35:19.000000', 'temperatura', 646.0000, 'ºC'),
	(33113, 108, '2015-02-01 00:35:20.000000', 'temperatura', 634.0000, 'ºC'),
	(33114, 108, '2015-02-01 00:35:21.000000', 'temperatura', 33.0000, 'ºC'),
	(33115, 108, '2015-02-01 00:35:22.000000', 'temperatura', 661.0000, 'ºC'),
	(33116, 108, '2015-02-01 00:35:23.000000', 'temperatura', 808.0000, 'ºC'),
	(33117, 108, '2015-02-01 00:35:24.000000', 'temperatura', 859.0000, 'ºC'),
	(33118, 108, '2015-02-01 00:35:25.000000', 'temperatura', 670.0000, 'ºC'),
	(33119, 108, '2015-02-01 00:35:26.000000', 'temperatura', 775.0000, 'ºC'),
	(33120, 108, '2015-02-01 00:35:27.000000', 'temperatura', 663.0000, 'ºC'),
	(33121, 108, '2015-02-01 00:35:28.000000', 'temperatura', 991.0000, 'ºC'),
	(33122, 108, '2015-02-01 00:35:29.000000', 'temperatura', 567.0000, 'ºC'),
	(33123, 108, '2015-02-01 00:35:30.000000', 'temperatura', 1061.0000, 'ºC'),
	(33124, 108, '2015-02-01 00:35:31.000000', 'temperatura', 4.0000, 'ºC'),
	(33125, 108, '2015-02-01 00:35:32.000000', 'temperatura', 439.0000, 'ºC'),
	(33126, 108, '2015-02-01 00:35:33.000000', 'temperatura', 983.0000, 'ºC'),
	(33127, 108, '2015-02-01 00:35:34.000000', 'temperatura', 1199.0000, 'ºC'),
	(33128, 108, '2015-02-01 00:35:35.000000', 'temperatura', 645.0000, 'ºC'),
	(33129, 108, '2015-02-01 00:35:36.000000', 'temperatura', 828.0000, 'ºC'),
	(33130, 108, '2015-02-01 00:35:37.000000', 'temperatura', 1005.0000, 'ºC'),
	(33131, 108, '2015-02-01 00:35:38.000000', 'temperatura', 142.0000, 'ºC'),
	(33132, 108, '2015-02-01 00:35:39.000000', 'temperatura', 98.0000, 'ºC'),
	(33133, 108, '2015-02-01 00:35:40.000000', 'temperatura', 61.0000, 'ºC'),
	(33134, 108, '2015-02-01 00:35:41.000000', 'temperatura', 15.0000, 'ºC'),
	(33135, 108, '2015-02-01 00:35:42.000000', 'temperatura', 1090.0000, 'ºC'),
	(33136, 108, '2015-02-01 00:35:43.000000', 'temperatura', 604.0000, 'ºC'),
	(33137, 108, '2015-02-01 00:35:44.000000', 'temperatura', 953.0000, 'ºC'),
	(33138, 108, '2015-02-01 00:35:45.000000', 'temperatura', 553.0000, 'ºC'),
	(33139, 108, '2015-02-01 00:35:46.000000', 'temperatura', 1106.0000, 'ºC'),
	(33140, 108, '2015-02-01 00:35:47.000000', 'temperatura', 270.0000, 'ºC'),
	(33141, 108, '2015-02-01 00:35:48.000000', 'temperatura', 433.0000, 'ºC'),
	(33142, 108, '2015-02-01 00:35:49.000000', 'temperatura', 157.0000, 'ºC'),
	(33143, 108, '2015-02-01 00:35:50.000000', 'temperatura', 685.0000, 'ºC'),
	(33144, 108, '2015-02-01 00:35:51.000000', 'temperatura', 553.0000, 'ºC'),
	(33145, 108, '2015-02-01 00:35:52.000000', 'temperatura', 713.0000, 'ºC'),
	(33146, 108, '2015-02-01 00:35:53.000000', 'temperatura', 704.0000, 'ºC'),
	(33147, 108, '2015-02-01 00:35:54.000000', 'temperatura', 184.0000, 'ºC'),
	(33148, 108, '2015-02-01 00:35:55.000000', 'temperatura', 6.0000, 'ºC'),
	(33149, 108, '2015-02-01 00:35:56.000000', 'temperatura', 679.0000, 'ºC'),
	(33150, 108, '2015-02-01 00:35:57.000000', 'temperatura', 980.0000, 'ºC'),
	(33151, 108, '2015-02-01 00:35:58.000000', 'temperatura', 461.0000, 'ºC'),
	(33152, 108, '2015-02-01 00:35:59.000000', 'temperatura', 565.0000, 'ºC'),
	(33153, 108, '2015-02-01 00:36:00.000000', 'temperatura', 244.0000, 'ºC'),
	(33154, 108, '2015-02-01 00:36:01.000000', 'temperatura', 725.0000, 'ºC'),
	(33155, 108, '2015-02-01 00:36:02.000000', 'temperatura', 494.0000, 'ºC'),
	(33156, 108, '2015-02-01 00:36:03.000000', 'temperatura', 296.0000, 'ºC'),
	(33157, 108, '2015-02-01 00:36:04.000000', 'temperatura', 1199.0000, 'ºC'),
	(33158, 108, '2015-02-01 00:36:05.000000', 'temperatura', 306.0000, 'ºC'),
	(33159, 108, '2015-02-01 00:36:06.000000', 'temperatura', 334.0000, 'ºC'),
	(33160, 108, '2015-02-01 00:36:07.000000', 'temperatura', 754.0000, 'ºC'),
	(33161, 108, '2015-02-01 00:36:08.000000', 'temperatura', 367.0000, 'ºC'),
	(33162, 108, '2015-02-01 00:36:09.000000', 'temperatura', 775.0000, 'ºC'),
	(33163, 108, '2015-02-01 00:36:10.000000', 'temperatura', 374.0000, 'ºC'),
	(33164, 108, '2015-02-01 00:36:11.000000', 'temperatura', 746.0000, 'ºC'),
	(33165, 108, '2015-02-01 00:36:12.000000', 'temperatura', 210.0000, 'ºC'),
	(33166, 108, '2015-02-01 00:36:13.000000', 'temperatura', 11.0000, 'ºC'),
	(33167, 108, '2015-02-01 00:36:14.000000', 'temperatura', 627.0000, 'ºC'),
	(33168, 108, '2015-02-01 00:36:15.000000', 'temperatura', 704.0000, 'ºC'),
	(33169, 108, '2015-02-01 00:36:16.000000', 'temperatura', 436.0000, 'ºC'),
	(33170, 108, '2015-02-01 00:36:17.000000', 'temperatura', 71.0000, 'ºC'),
	(33171, 108, '2015-02-01 00:36:18.000000', 'temperatura', 245.0000, 'ºC'),
	(33172, 108, '2015-02-01 00:36:19.000000', 'temperatura', 1012.0000, 'ºC'),
	(33173, 108, '2015-02-01 00:36:20.000000', 'temperatura', 729.0000, 'ºC'),
	(33174, 108, '2015-02-01 00:36:21.000000', 'temperatura', 606.0000, 'ºC'),
	(33175, 108, '2015-02-01 00:36:22.000000', 'temperatura', 845.0000, 'ºC'),
	(33176, 108, '2015-02-01 00:36:23.000000', 'temperatura', 7.0000, 'ºC'),
	(33177, 108, '2015-02-01 00:36:24.000000', 'temperatura', 1102.0000, 'ºC'),
	(33178, 108, '2015-02-01 00:36:25.000000', 'temperatura', 691.0000, 'ºC'),
	(33179, 108, '2015-02-01 00:36:26.000000', 'temperatura', 146.0000, 'ºC'),
	(33180, 108, '2015-02-01 00:36:27.000000', 'temperatura', 1060.0000, 'ºC'),
	(33181, 108, '2015-02-01 00:36:28.000000', 'temperatura', 61.0000, 'ºC'),
	(33182, 108, '2015-02-01 00:36:29.000000', 'temperatura', 727.0000, 'ºC'),
	(33183, 108, '2015-02-01 00:36:30.000000', 'temperatura', 1053.0000, 'ºC'),
	(33184, 108, '2015-02-01 00:36:31.000000', 'temperatura', 685.0000, 'ºC'),
	(33185, 108, '2015-02-01 00:36:32.000000', 'temperatura', 266.0000, 'ºC'),
	(33186, 108, '2015-02-01 00:36:33.000000', 'temperatura', 476.0000, 'ºC'),
	(33187, 108, '2015-02-01 00:36:34.000000', 'temperatura', 382.0000, 'ºC'),
	(33188, 108, '2015-02-01 00:36:35.000000', 'temperatura', 481.0000, 'ºC'),
	(33189, 108, '2015-02-01 00:36:36.000000', 'temperatura', 61.0000, 'ºC'),
	(33190, 108, '2015-02-01 00:36:37.000000', 'temperatura', 60.0000, 'ºC'),
	(33191, 108, '2015-02-01 00:36:38.000000', 'temperatura', 120.0000, 'ºC'),
	(33192, 108, '2015-02-01 00:36:39.000000', 'temperatura', 420.0000, 'ºC'),
	(33193, 108, '2015-02-01 00:36:40.000000', 'temperatura', 540.0000, 'ºC'),
	(33194, 108, '2015-02-01 00:36:41.000000', 'temperatura', 241.0000, 'ºC'),
	(33195, 108, '2015-02-01 00:36:42.000000', 'temperatura', 784.0000, 'ºC'),
	(33196, 108, '2015-02-01 00:36:43.000000', 'temperatura', 798.0000, 'ºC'),
	(33197, 108, '2015-02-01 00:36:44.000000', 'temperatura', 438.0000, 'ºC'),
	(33198, 108, '2015-02-01 00:36:45.000000', 'temperatura', 995.0000, 'ºC'),
	(33199, 108, '2015-02-01 00:36:46.000000', 'temperatura', 65.0000, 'ºC'),
	(33200, 108, '2015-02-01 00:36:47.000000', 'temperatura', 937.0000, 'ºC'),
	(33201, 108, '2015-02-01 00:36:48.000000', 'temperatura', 892.0000, 'ºC'),
	(33202, 108, '2015-02-01 00:36:49.000000', 'temperatura', 451.0000, 'ºC'),
	(33203, 108, '2015-02-01 00:36:50.000000', 'temperatura', 780.0000, 'ºC'),
	(33204, 108, '2015-02-01 00:36:51.000000', 'temperatura', 147.0000, 'ºC'),
	(33205, 108, '2015-02-01 00:36:52.000000', 'temperatura', 795.0000, 'ºC'),
	(33206, 108, '2015-02-01 00:36:53.000000', 'temperatura', 1132.0000, 'ºC'),
	(33207, 108, '2015-02-01 00:36:54.000000', 'temperatura', 879.0000, 'ºC'),
	(33208, 108, '2015-02-01 00:36:55.000000', 'temperatura', 999.0000, 'ºC'),
	(33209, 108, '2015-02-01 00:36:56.000000', 'temperatura', 1157.0000, 'ºC'),
	(33210, 108, '2015-02-01 00:36:57.000000', 'temperatura', 390.0000, 'ºC'),
	(33211, 108, '2015-02-01 00:36:58.000000', 'temperatura', 881.0000, 'ºC'),
	(33212, 108, '2015-02-01 00:36:59.000000', 'temperatura', 833.0000, 'ºC'),
	(33213, 108, '2015-02-01 00:37:00.000000', 'temperatura', 322.0000, 'ºC'),
	(33214, 108, '2015-02-01 00:37:01.000000', 'temperatura', 312.0000, 'ºC'),
	(33215, 108, '2015-02-01 00:37:02.000000', 'temperatura', 594.0000, 'ºC'),
	(33216, 108, '2015-02-01 00:37:03.000000', 'temperatura', 834.0000, 'ºC'),
	(33217, 108, '2015-02-01 00:37:04.000000', 'temperatura', 1188.0000, 'ºC'),
	(33218, 108, '2015-02-01 00:37:05.000000', 'temperatura', 1040.0000, 'ºC'),
	(33219, 108, '2015-02-01 00:37:06.000000', 'temperatura', 436.0000, 'ºC'),
	(33220, 108, '2015-02-01 00:37:07.000000', 'temperatura', 261.0000, 'ºC'),
	(33221, 108, '2015-02-01 00:37:08.000000', 'temperatura', 1199.0000, 'ºC'),
	(33222, 108, '2015-02-01 00:37:09.000000', 'temperatura', 411.0000, 'ºC'),
	(33223, 108, '2015-02-01 00:37:10.000000', 'temperatura', 860.0000, 'ºC'),
	(33224, 108, '2015-02-01 00:37:11.000000', 'temperatura', 668.0000, 'ºC'),
	(33225, 108, '2015-02-01 00:37:12.000000', 'temperatura', 760.0000, 'ºC'),
	(33226, 108, '2015-02-01 00:37:13.000000', 'temperatura', 598.0000, 'ºC'),
	(33227, 108, '2015-02-01 00:37:14.000000', 'temperatura', 708.0000, 'ºC'),
	(33228, 108, '2015-02-01 00:37:15.000000', 'temperatura', 547.0000, 'ºC'),
	(33229, 108, '2015-02-01 00:37:16.000000', 'temperatura', 612.0000, 'ºC'),
	(33230, 108, '2015-02-01 00:37:17.000000', 'temperatura', 221.0000, 'ºC'),
	(33231, 108, '2015-02-01 00:37:18.000000', 'temperatura', 466.0000, 'ºC'),
	(33232, 108, '2015-02-01 00:37:19.000000', 'temperatura', 471.0000, 'ºC'),
	(33233, 108, '2015-02-01 00:37:20.000000', 'temperatura', 956.0000, 'ºC'),
	(33234, 108, '2015-02-01 00:37:21.000000', 'temperatura', 970.0000, 'ºC'),
	(33235, 108, '2015-02-01 00:37:22.000000', 'temperatura', 779.0000, 'ºC'),
	(33236, 108, '2015-02-01 00:37:23.000000', 'temperatura', 987.0000, 'ºC'),
	(33237, 108, '2015-02-01 00:37:24.000000', 'temperatura', 199.0000, 'ºC'),
	(33238, 108, '2015-02-01 00:37:25.000000', 'temperatura', 433.0000, 'ºC'),
	(33239, 108, '2015-02-01 00:37:26.000000', 'temperatura', 368.0000, 'ºC'),
	(33240, 108, '2015-02-01 00:37:27.000000', 'temperatura', 543.0000, 'ºC'),
	(33241, 108, '2015-02-01 00:37:28.000000', 'temperatura', 412.0000, 'ºC'),
	(33242, 108, '2015-02-01 00:37:29.000000', 'temperatura', 432.0000, 'ºC'),
	(33243, 108, '2015-02-01 00:37:30.000000', 'temperatura', 923.0000, 'ºC'),
	(33244, 108, '2015-02-01 00:37:31.000000', 'temperatura', 918.0000, 'ºC'),
	(33245, 108, '2015-02-01 00:37:32.000000', 'temperatura', 623.0000, 'ºC'),
	(33246, 108, '2015-02-01 00:37:33.000000', 'temperatura', 363.0000, 'ºC'),
	(33247, 108, '2015-02-01 00:37:34.000000', 'temperatura', 1144.0000, 'ºC'),
	(33248, 108, '2015-02-01 00:37:35.000000', 'temperatura', 1033.0000, 'ºC'),
	(33249, 108, '2015-02-01 00:37:36.000000', 'temperatura', 532.0000, 'ºC'),
	(33250, 108, '2015-02-01 00:37:37.000000', 'temperatura', 762.0000, 'ºC'),
	(33251, 108, '2015-02-01 00:37:38.000000', 'temperatura', 1015.0000, 'ºC'),
	(33252, 108, '2015-02-01 00:37:39.000000', 'temperatura', 391.0000, 'ºC'),
	(33253, 108, '2015-02-01 00:37:40.000000', 'temperatura', 110.0000, 'ºC'),
	(33254, 108, '2015-02-01 00:37:41.000000', 'temperatura', 577.0000, 'ºC'),
	(33255, 108, '2015-02-01 00:37:42.000000', 'temperatura', 156.0000, 'ºC'),
	(33256, 108, '2015-02-01 00:37:43.000000', 'temperatura', 250.0000, 'ºC'),
	(33257, 108, '2015-02-01 00:37:44.000000', 'temperatura', 781.0000, 'ºC'),
	(33258, 108, '2015-02-01 00:37:45.000000', 'temperatura', 755.0000, 'ºC'),
	(33259, 108, '2015-02-01 00:37:46.000000', 'temperatura', 235.0000, 'ºC'),
	(33260, 108, '2015-02-01 00:37:47.000000', 'temperatura', 111.0000, 'ºC'),
	(33261, 108, '2015-02-01 00:37:48.000000', 'temperatura', 1049.0000, 'ºC'),
	(33262, 108, '2015-02-01 00:37:49.000000', 'temperatura', 114.0000, 'ºC'),
	(33263, 108, '2015-02-01 00:37:50.000000', 'temperatura', 1023.0000, 'ºC'),
	(33264, 108, '2015-02-01 00:37:51.000000', 'temperatura', 1175.0000, 'ºC'),
	(33265, 108, '2015-02-01 00:37:52.000000', 'temperatura', 405.0000, 'ºC'),
	(33266, 108, '2015-02-01 00:37:53.000000', 'temperatura', 900.0000, 'ºC'),
	(33267, 108, '2015-02-01 00:37:54.000000', 'temperatura', 888.0000, 'ºC'),
	(33268, 108, '2015-02-01 00:37:55.000000', 'temperatura', 539.0000, 'ºC'),
	(33269, 108, '2015-02-01 00:37:56.000000', 'temperatura', 31.0000, 'ºC'),
	(33270, 108, '2015-02-01 00:37:57.000000', 'temperatura', 937.0000, 'ºC'),
	(33271, 108, '2015-02-01 00:37:58.000000', 'temperatura', 995.0000, 'ºC'),
	(33272, 108, '2015-02-01 00:37:59.000000', 'temperatura', 964.0000, 'ºC'),
	(33273, 108, '2015-02-01 00:38:00.000000', 'temperatura', 637.0000, 'ºC'),
	(33274, 108, '2015-02-01 00:38:01.000000', 'temperatura', 290.0000, 'ºC'),
	(33275, 108, '2015-02-01 00:38:02.000000', 'temperatura', 743.0000, 'ºC'),
	(33276, 108, '2015-02-01 00:38:03.000000', 'temperatura', 444.0000, 'ºC'),
	(33277, 108, '2015-02-01 00:38:04.000000', 'temperatura', 1190.0000, 'ºC'),
	(33278, 108, '2015-02-01 00:38:05.000000', 'temperatura', 1021.0000, 'ºC'),
	(33279, 108, '2015-02-01 00:38:06.000000', 'temperatura', 334.0000, 'ºC'),
	(33280, 108, '2015-02-01 00:38:07.000000', 'temperatura', 1007.0000, 'ºC'),
	(33281, 108, '2015-02-01 00:38:08.000000', 'temperatura', 435.0000, 'ºC'),
	(33282, 108, '2015-02-01 00:38:09.000000', 'temperatura', 353.0000, 'ºC'),
	(33283, 108, '2015-02-01 00:38:10.000000', 'temperatura', 460.0000, 'ºC'),
	(33284, 108, '2015-02-01 00:38:11.000000', 'temperatura', 44.0000, 'ºC'),
	(33285, 108, '2015-02-01 00:38:12.000000', 'temperatura', 39.0000, 'ºC'),
	(33286, 108, '2015-02-01 00:38:13.000000', 'temperatura', 64.0000, 'ºC'),
	(33287, 108, '2015-02-01 00:38:14.000000', 'temperatura', 204.0000, 'ºC'),
	(33288, 108, '2015-02-01 00:38:15.000000', 'temperatura', 830.0000, 'ºC'),
	(33289, 108, '2015-02-01 00:38:16.000000', 'temperatura', 1137.0000, 'ºC'),
	(33290, 108, '2015-02-01 00:38:17.000000', 'temperatura', 794.0000, 'ºC'),
	(33291, 108, '2015-02-01 00:38:18.000000', 'temperatura', 560.0000, 'ºC'),
	(33292, 108, '2015-02-01 00:38:19.000000', 'temperatura', 417.0000, 'ºC'),
	(33293, 108, '2015-02-01 00:38:20.000000', 'temperatura', 409.0000, 'ºC'),
	(33294, 108, '2015-02-01 00:38:21.000000', 'temperatura', 791.0000, 'ºC'),
	(33295, 108, '2015-02-01 00:38:22.000000', 'temperatura', 332.0000, 'ºC'),
	(33296, 108, '2015-02-01 00:38:23.000000', 'temperatura', 484.0000, 'ºC'),
	(33297, 108, '2015-02-01 00:38:24.000000', 'temperatura', 227.0000, 'ºC'),
	(33298, 108, '2015-02-01 00:38:25.000000', 'temperatura', 883.0000, 'ºC'),
	(33299, 108, '2015-02-01 00:38:26.000000', 'temperatura', 136.0000, 'ºC'),
	(33300, 108, '2015-02-01 00:38:27.000000', 'temperatura', 429.0000, 'ºC'),
	(33301, 108, '2015-02-01 00:38:28.000000', 'temperatura', 539.0000, 'ºC'),
	(33302, 108, '2015-02-01 00:38:29.000000', 'temperatura', 210.0000, 'ºC'),
	(33303, 108, '2015-02-01 00:38:30.000000', 'temperatura', 633.0000, 'ºC'),
	(33304, 108, '2015-02-01 00:38:31.000000', 'temperatura', 134.0000, 'ºC'),
	(33305, 108, '2015-02-01 00:38:32.000000', 'temperatura', 1173.0000, 'ºC'),
	(33306, 108, '2015-02-01 00:38:33.000000', 'temperatura', 661.0000, 'ºC'),
	(33307, 108, '2015-02-01 00:38:34.000000', 'temperatura', 988.0000, 'ºC'),
	(33308, 108, '2015-02-01 00:38:35.000000', 'temperatura', 557.0000, 'ºC'),
	(33309, 108, '2015-02-01 00:38:36.000000', 'temperatura', 1021.0000, 'ºC'),
	(33310, 108, '2015-02-01 00:38:37.000000', 'temperatura', 1035.0000, 'ºC'),
	(33311, 108, '2015-02-01 00:38:38.000000', 'temperatura', 912.0000, 'ºC'),
	(33312, 108, '2015-02-01 00:38:39.000000', 'temperatura', 258.0000, 'ºC'),
	(33313, 108, '2015-02-01 00:38:40.000000', 'temperatura', 951.0000, 'ºC'),
	(33314, 108, '2015-02-01 00:38:41.000000', 'temperatura', 382.0000, 'ºC'),
	(33315, 108, '2015-02-01 00:38:42.000000', 'temperatura', 260.0000, 'ºC'),
	(33316, 108, '2015-02-01 00:38:43.000000', 'temperatura', 152.0000, 'ºC'),
	(33317, 108, '2015-02-01 00:38:44.000000', 'temperatura', 1183.0000, 'ºC'),
	(33318, 108, '2015-02-01 00:38:45.000000', 'temperatura', 658.0000, 'ºC'),
	(33319, 108, '2015-02-01 00:38:46.000000', 'temperatura', 942.0000, 'ºC'),
	(33320, 108, '2015-02-01 00:38:47.000000', 'temperatura', 334.0000, 'ºC'),
	(33321, 108, '2015-02-01 00:38:48.000000', 'temperatura', 47.0000, 'ºC'),
	(33322, 108, '2015-02-01 00:38:49.000000', 'temperatura', 435.0000, 'ºC'),
	(33323, 108, '2015-02-01 00:38:50.000000', 'temperatura', 832.0000, 'ºC'),
	(33324, 108, '2015-02-01 00:38:51.000000', 'temperatura', 456.0000, 'ºC'),
	(33325, 108, '2015-02-01 00:38:52.000000', 'temperatura', 986.0000, 'ºC'),
	(33326, 108, '2015-02-01 00:38:53.000000', 'temperatura', 1160.0000, 'ºC'),
	(33327, 108, '2015-02-01 00:38:54.000000', 'temperatura', 443.0000, 'ºC'),
	(33328, 108, '2015-02-01 00:38:55.000000', 'temperatura', 1136.0000, 'ºC'),
	(33329, 108, '2015-02-01 00:38:56.000000', 'temperatura', 751.0000, 'ºC'),
	(33330, 108, '2015-02-01 00:38:57.000000', 'temperatura', 347.0000, 'ºC'),
	(33331, 108, '2015-02-01 00:38:58.000000', 'temperatura', 682.0000, 'ºC'),
	(33332, 108, '2015-02-01 00:38:59.000000', 'temperatura', 1171.0000, 'ºC'),
	(33333, 108, '2015-02-01 00:39:00.000000', 'temperatura', 207.0000, 'ºC'),
	(33334, 108, '2015-02-01 00:39:01.000000', 'temperatura', 1126.0000, 'ºC'),
	(33335, 108, '2015-02-01 00:39:02.000000', 'temperatura', 207.0000, 'ºC'),
	(33336, 108, '2015-02-01 00:39:03.000000', 'temperatura', 59.0000, 'ºC'),
	(33337, 108, '2015-02-01 00:39:04.000000', 'temperatura', 876.0000, 'ºC'),
	(33338, 108, '2015-02-01 00:39:05.000000', 'temperatura', 602.0000, 'ºC'),
	(33339, 108, '2015-02-01 00:39:06.000000', 'temperatura', 383.0000, 'ºC'),
	(33340, 108, '2015-02-01 00:39:07.000000', 'temperatura', 110.0000, 'ºC'),
	(33341, 108, '2015-02-01 00:39:08.000000', 'temperatura', 599.0000, 'ºC'),
	(33342, 108, '2015-02-01 00:39:09.000000', 'temperatura', 266.0000, 'ºC'),
	(33343, 108, '2015-02-01 00:39:10.000000', 'temperatura', 734.0000, 'ºC'),
	(33344, 108, '2015-02-01 00:39:11.000000', 'temperatura', 474.0000, 'ºC'),
	(33345, 108, '2015-02-01 00:39:12.000000', 'temperatura', 168.0000, 'ºC'),
	(33346, 108, '2015-02-01 00:39:13.000000', 'temperatura', 618.0000, 'ºC'),
	(33347, 108, '2015-02-01 00:39:14.000000', 'temperatura', 188.0000, 'ºC'),
	(33348, 108, '2015-02-01 00:39:15.000000', 'temperatura', 287.0000, 'ºC'),
	(33349, 108, '2015-02-01 00:39:16.000000', 'temperatura', 872.0000, 'ºC'),
	(33350, 108, '2015-02-01 00:39:17.000000', 'temperatura', 1098.0000, 'ºC'),
	(33351, 108, '2015-02-01 00:39:18.000000', 'temperatura', 476.0000, 'ºC'),
	(33352, 108, '2015-02-01 00:39:19.000000', 'temperatura', 284.0000, 'ºC'),
	(33353, 108, '2015-02-01 00:39:20.000000', 'temperatura', 1194.0000, 'ºC'),
	(33354, 108, '2015-02-01 00:39:21.000000', 'temperatura', 318.0000, 'ºC'),
	(33355, 108, '2015-02-01 00:39:22.000000', 'temperatura', 408.0000, 'ºC'),
	(33356, 108, '2015-02-01 00:39:23.000000', 'temperatura', 1088.0000, 'ºC'),
	(33357, 108, '2015-02-01 00:39:24.000000', 'temperatura', 617.0000, 'ºC'),
	(33358, 108, '2015-02-01 00:39:25.000000', 'temperatura', 1022.0000, 'ºC'),
	(33359, 108, '2015-02-01 00:39:26.000000', 'temperatura', 860.0000, 'ºC'),
	(33360, 108, '2015-02-01 00:39:27.000000', 'temperatura', 34.0000, 'ºC'),
	(33361, 108, '2015-02-01 00:39:28.000000', 'temperatura', 1191.0000, 'ºC'),
	(33362, 108, '2015-02-01 00:39:29.000000', 'temperatura', 1055.0000, 'ºC'),
	(33363, 108, '2015-02-01 00:39:30.000000', 'temperatura', 500.0000, 'ºC'),
	(33364, 108, '2015-02-01 00:39:31.000000', 'temperatura', 534.0000, 'ºC'),
	(33365, 108, '2015-02-01 00:39:32.000000', 'temperatura', 1173.0000, 'ºC'),
	(33366, 108, '2015-02-01 00:39:33.000000', 'temperatura', 661.0000, 'ºC'),
	(33367, 108, '2015-02-01 00:39:34.000000', 'temperatura', 989.0000, 'ºC'),
	(33368, 108, '2015-02-01 00:39:35.000000', 'temperatura', 561.0000, 'ºC'),
	(33369, 108, '2015-02-01 00:39:36.000000', 'temperatura', 1039.0000, 'ºC'),
	(33370, 108, '2015-02-01 00:39:37.000000', 'temperatura', 1113.0000, 'ºC'),
	(33371, 108, '2015-02-01 00:39:38.000000', 'temperatura', 50.0000, 'ºC'),
	(33372, 108, '2015-02-01 00:39:39.000000', 'temperatura', 510.0000, 'ºC'),
	(33373, 108, '2015-02-01 00:39:40.000000', 'temperatura', 2.0000, 'ºC'),
	(33374, 108, '2015-02-01 00:39:41.000000', 'temperatura', 881.0000, 'ºC'),
	(33375, 108, '2015-02-01 00:39:42.000000', 'temperatura', 798.0000, 'ºC'),
	(33376, 108, '2015-02-01 00:39:43.000000', 'temperatura', 149.0000, 'ºC'),
	(33377, 108, '2015-02-01 00:39:44.000000', 'temperatura', 752.0000, 'ºC'),
	(33378, 108, '2015-02-01 00:39:45.000000', 'temperatura', 910.0000, 'ºC'),
	(33379, 108, '2015-02-01 00:39:46.000000', 'temperatura', 1098.0000, 'ºC'),
	(33380, 108, '2015-02-01 00:39:47.000000', 'temperatura', 360.0000, 'ºC'),
	(33381, 108, '2015-02-01 00:39:48.000000', 'temperatura', 907.0000, 'ºC'),
	(33382, 108, '2015-02-01 00:39:49.000000', 'temperatura', 1056.0000, 'ºC'),
	(33383, 108, '2015-02-01 00:39:50.000000', 'temperatura', 159.0000, 'ºC'),
	(33384, 108, '2015-02-01 00:39:51.000000', 'temperatura', 25.0000, 'ºC'),
	(33385, 108, '2015-02-01 00:39:52.000000', 'temperatura', 852.0000, 'ºC'),
	(33386, 108, '2015-02-01 00:39:53.000000', 'temperatura', 585.0000, 'ºC'),
	(33387, 108, '2015-02-01 00:39:54.000000', 'temperatura', 369.0000, 'ºC'),
	(33388, 108, '2015-02-01 00:39:55.000000', 'temperatura', 92.0000, 'ºC'),
	(33389, 108, '2015-02-01 00:39:56.000000', 'temperatura', 554.0000, 'ºC'),
	(33390, 108, '2015-02-01 00:39:57.000000', 'temperatura', 95.0000, 'ºC'),
	(33391, 108, '2015-02-01 00:39:58.000000', 'temperatura', 13.0000, 'ºC'),
	(33392, 108, '2015-02-01 00:39:59.000000', 'temperatura', 981.0000, 'ºC'),
	(33393, 108, '2015-02-01 00:40:00.000000', 'temperatura', 68.0000, 'ºC'),
	(33394, 108, '2015-02-01 00:40:01.000000', 'temperatura', 996.0000, 'ºC'),
	(33395, 108, '2015-02-01 00:40:02.000000', 'temperatura', 1175.0000, 'ºC'),
	(33396, 108, '2015-02-01 00:40:03.000000', 'temperatura', 490.0000, 'ºC'),
	(33397, 108, '2015-02-01 00:40:04.000000', 'temperatura', 123.0000, 'ºC'),
	(33398, 108, '2015-02-01 00:40:05.000000', 'temperatura', 348.0000, 'ºC'),
	(33399, 108, '2015-02-01 00:40:06.000000', 'temperatura', 168.0000, 'ºC'),
	(33400, 108, '2015-02-01 00:40:07.000000', 'temperatura', 1000.0000, 'ºC'),
	(33401, 108, '2015-02-01 00:40:08.000000', 'temperatura', 895.0000, 'ºC'),
	(33402, 108, '2015-02-01 00:40:09.000000', 'temperatura', 276.0000, 'ºC'),
	(33403, 108, '2015-02-01 00:40:10.000000', 'temperatura', 1095.0000, 'ºC'),
	(33404, 108, '2015-02-01 00:40:11.000000', 'temperatura', 1048.0000, 'ºC'),
	(33405, 108, '2015-02-01 00:40:12.000000', 'temperatura', 754.0000, 'ºC'),
	(33406, 108, '2015-02-01 00:40:13.000000', 'temperatura', 626.0000, 'ºC'),
	(33407, 108, '2015-02-01 00:40:14.000000', 'temperatura', 868.0000, 'ºC'),
	(33408, 108, '2015-02-01 00:40:15.000000', 'temperatura', 64.0000, 'ºC'),
	(33409, 108, '2015-02-01 00:40:16.000000', 'temperatura', 114.0000, 'ºC'),
	(33410, 108, '2015-02-01 00:40:17.000000', 'temperatura', 381.0000, 'ºC'),
	(33411, 108, '2015-02-01 00:40:18.000000', 'temperatura', 361.0000, 'ºC'),
	(33412, 108, '2015-02-01 00:40:19.000000', 'temperatura', 663.0000, 'ºC'),
	(33413, 108, '2015-02-01 00:40:20.000000', 'temperatura', 1031.0000, 'ºC'),
	(33414, 108, '2015-02-01 00:40:21.000000', 'temperatura', 770.0000, 'ºC'),
	(33415, 108, '2015-02-01 00:40:22.000000', 'temperatura', 755.0000, 'ºC'),
	(33416, 108, '2015-02-01 00:40:23.000000', 'temperatura', 267.0000, 'ºC'),
	(33417, 108, '2015-02-01 00:40:24.000000', 'temperatura', 268.0000, 'ºC'),
	(33418, 108, '2015-02-01 00:40:25.000000', 'temperatura', 540.0000, 'ºC'),
	(33419, 108, '2015-02-01 00:40:26.000000', 'temperatura', 698.0000, 'ºC'),
	(33420, 108, '2015-02-01 00:40:27.000000', 'temperatura', 668.0000, 'ºC'),
	(33421, 108, '2015-02-01 00:40:28.000000', 'temperatura', 49.0000, 'ºC'),
	(33422, 108, '2015-02-01 00:40:29.000000', 'temperatura', 640.0000, 'ºC'),
	(33423, 108, '2015-02-01 00:40:30.000000', 'temperatura', 653.0000, 'ºC'),
	(33424, 108, '2015-02-01 00:40:31.000000', 'temperatura', 146.0000, 'ºC'),
	(33425, 108, '2015-02-01 00:40:32.000000', 'temperatura', 1172.0000, 'ºC'),
	(33426, 108, '2015-02-01 00:40:33.000000', 'temperatura', 623.0000, 'ºC'),
	(33427, 108, '2015-02-01 00:40:34.000000', 'temperatura', 801.0000, 'ºC'),
	(33428, 108, '2015-02-01 00:40:35.000000', 'temperatura', 934.0000, 'ºC'),
	(33429, 108, '2015-02-01 00:40:36.000000', 'temperatura', 1069.0000, 'ºC'),
	(33430, 108, '2015-02-01 00:40:37.000000', 'temperatura', 144.0000, 'ºC'),
	(33431, 108, '2015-02-01 00:40:38.000000', 'temperatura', 1112.0000, 'ºC'),
	(33432, 108, '2015-02-01 00:40:39.000000', 'temperatura', 330.0000, 'ºC'),
	(33433, 108, '2015-02-01 00:40:40.000000', 'temperatura', 714.0000, 'ºC'),
	(33434, 108, '2015-02-01 00:40:41.000000', 'temperatura', 182.0000, 'ºC'),
	(33435, 108, '2015-02-01 00:40:42.000000', 'temperatura', 1166.0000, 'ºC'),
	(33436, 108, '2015-02-01 00:40:43.000000', 'temperatura', 488.0000, 'ºC'),
	(33437, 108, '2015-02-01 00:40:44.000000', 'temperatura', 139.0000, 'ºC'),
	(33438, 108, '2015-02-01 00:40:45.000000', 'temperatura', 433.0000, 'ºC'),
	(33439, 108, '2015-02-01 00:40:46.000000', 'temperatura', 547.0000, 'ºC'),
	(33440, 108, '2015-02-01 00:40:47.000000', 'temperatura', 237.0000, 'ºC'),
	(33441, 108, '2015-02-01 00:40:48.000000', 'temperatura', 747.0000, 'ºC'),
	(33442, 108, '2015-02-01 00:40:49.000000', 'temperatura', 621.0000, 'ºC'),
	(33443, 108, '2015-02-01 00:40:50.000000', 'temperatura', 865.0000, 'ºC'),
	(33444, 108, '2015-02-01 00:40:51.000000', 'temperatura', 64.0000, 'ºC'),
	(33445, 108, '2015-02-01 00:40:52.000000', 'temperatura', 126.0000, 'ºC'),
	(33446, 108, '2015-02-01 00:40:53.000000', 'temperatura', 439.0000, 'ºC'),
	(33447, 108, '2015-02-01 00:40:54.000000', 'temperatura', 615.0000, 'ºC'),
	(33448, 108, '2015-02-01 00:40:55.000000', 'temperatura', 559.0000, 'ºC'),
	(33449, 108, '2015-02-01 00:40:56.000000', 'temperatura', 951.0000, 'ºC'),
	(33450, 108, '2015-02-01 00:40:57.000000', 'temperatura', 678.0000, 'ºC'),
	(33451, 108, '2015-02-01 00:40:58.000000', 'temperatura', 536.0000, 'ºC'),
	(33452, 108, '2015-02-01 00:40:59.000000', 'temperatura', 649.0000, 'ºC'),
	(33453, 108, '2015-02-01 00:41:00.000000', 'temperatura', 437.0000, 'ºC'),
	(33454, 108, '2015-02-01 00:41:01.000000', 'temperatura', 237.0000, 'ºC'),
	(33455, 108, '2015-02-01 00:41:02.000000', 'temperatura', 1074.0000, 'ºC'),
	(33456, 108, '2015-02-01 00:41:03.000000', 'temperatura', 1060.0000, 'ºC'),
	(33457, 108, '2015-02-01 00:41:04.000000', 'temperatura', 881.0000, 'ºC'),
	(33458, 108, '2015-02-01 00:41:05.000000', 'temperatura', 23.0000, 'ºC'),
	(33459, 108, '2015-02-01 00:41:06.000000', 'temperatura', 1074.0000, 'ºC'),
	(33460, 108, '2015-02-01 00:41:07.000000', 'temperatura', 501.0000, 'ºC'),
	(33461, 108, '2015-02-01 00:41:08.000000', 'temperatura', 483.0000, 'ºC'),
	(33462, 108, '2015-02-01 00:41:09.000000', 'temperatura', 911.0000, 'ºC'),
	(33463, 108, '2015-02-01 00:41:10.000000', 'temperatura', 707.0000, 'ºC'),
	(33464, 108, '2015-02-01 00:41:11.000000', 'temperatura', 801.0000, 'ºC'),
	(33465, 108, '2015-02-01 00:41:12.000000', 'temperatura', 686.0000, 'ºC'),
	(33466, 108, '2015-02-01 00:41:13.000000', 'temperatura', 1027.0000, 'ºC'),
	(33467, 108, '2015-02-01 00:41:14.000000', 'temperatura', 677.0000, 'ºC'),
	(33468, 108, '2015-02-01 00:41:15.000000', 'temperatura', 307.0000, 'ºC'),
	(33469, 108, '2015-02-01 00:41:16.000000', 'temperatura', 703.0000, 'ºC'),
	(33470, 108, '2015-02-01 00:41:17.000000', 'temperatura', 193.0000, 'ºC'),
	(33471, 108, '2015-02-01 00:41:18.000000', 'temperatura', 57.0000, 'ºC'),
	(33472, 108, '2015-02-01 00:41:19.000000', 'temperatura', 906.0000, 'ºC'),
	(33473, 108, '2015-02-01 00:41:20.000000', 'temperatura', 761.0000, 'ºC'),
	(33474, 108, '2015-02-01 00:41:21.000000', 'temperatura', 1086.0000, 'ºC'),
	(33475, 108, '2015-02-01 00:41:22.000000', 'temperatura', 748.0000, 'ºC'),
	(33476, 108, '2015-02-01 00:41:23.000000', 'temperatura', 482.0000, 'ºC'),
	(33477, 108, '2015-02-01 00:41:24.000000', 'temperatura', 169.0000, 'ºC'),
	(33478, 108, '2015-02-01 00:41:25.000000', 'temperatura', 597.0000, 'ºC'),
	(33479, 108, '2015-02-01 00:41:26.000000', 'temperatura', 80.0000, 'ºC'),
	(33480, 108, '2015-02-01 00:41:27.000000', 'temperatura', 1010.0000, 'ºC'),
	(33481, 108, '2015-02-01 00:41:28.000000', 'temperatura', 10.0000, 'ºC'),
	(33482, 108, '2015-02-01 00:41:29.000000', 'temperatura', 621.0000, 'ºC'),
	(33483, 108, '2015-02-01 00:41:30.000000', 'temperatura', 674.0000, 'ºC'),
	(33484, 108, '2015-02-01 00:41:31.000000', 'temperatura', 308.0000, 'ºC'),
	(33485, 108, '2015-02-01 00:41:32.000000', 'temperatura', 719.0000, 'ºC'),
	(33486, 108, '2015-02-01 00:41:33.000000', 'temperatura', 273.0000, 'ºC'),
	(33487, 108, '2015-02-01 00:41:34.000000', 'temperatura', 407.0000, 'ºC'),
	(33488, 108, '2015-02-01 00:41:35.000000', 'temperatura', 16.0000, 'ºC'),
	(33489, 108, '2015-02-01 00:41:36.000000', 'temperatura', 59.0000, 'ºC'),
	(33490, 108, '2015-02-01 00:41:37.000000', 'temperatura', 247.0000, 'ºC'),
	(33491, 108, '2015-02-01 00:41:38.000000', 'temperatura', 1061.0000, 'ºC'),
	(33492, 108, '2015-02-01 00:41:39.000000', 'temperatura', 963.0000, 'ºC'),
	(33493, 108, '2015-02-01 00:41:40.000000', 'temperatura', 433.0000, 'ºC'),
	(33494, 108, '2015-02-01 00:41:41.000000', 'temperatura', 476.0000, 'ºC'),
	(33495, 108, '2015-02-01 00:41:42.000000', 'temperatura', 1083.0000, 'ºC'),
	(33496, 108, '2015-02-01 00:41:43.000000', 'temperatura', 389.0000, 'ºC'),
	(33497, 108, '2015-02-01 00:41:44.000000', 'temperatura', 1093.0000, 'ºC'),
	(33498, 108, '2015-02-01 00:41:45.000000', 'temperatura', 701.0000, 'ºC'),
	(33499, 108, '2015-02-01 00:41:46.000000', 'temperatura', 227.0000, 'ºC'),
	(33500, 108, '2015-02-01 00:41:47.000000', 'temperatura', 231.0000, 'ºC'),
	(33501, 108, '2015-02-01 00:41:48.000000', 'temperatura', 474.0000, 'ºC'),
	(33502, 108, '2015-02-01 00:41:49.000000', 'temperatura', 478.0000, 'ºC'),
	(33503, 108, '2015-02-01 00:41:50.000000', 'temperatura', 970.0000, 'ºC'),
	(33504, 108, '2015-02-01 00:41:51.000000', 'temperatura', 1017.0000, 'ºC'),
	(33505, 108, '2015-02-01 00:41:52.000000', 'temperatura', 975.0000, 'ºC'),
	(33506, 108, '2015-02-01 00:41:53.000000', 'temperatura', 623.0000, 'ºC'),
	(33507, 108, '2015-02-01 00:41:54.000000', 'temperatura', 193.0000, 'ºC'),
	(33508, 108, '2015-02-01 00:41:55.000000', 'temperatura', 297.0000, 'ºC'),
	(33509, 108, '2015-02-01 00:41:56.000000', 'temperatura', 906.0000, 'ºC'),
	(33510, 108, '2015-02-01 00:41:57.000000', 'temperatura', 37.0000, 'ºC'),
	(33511, 108, '2015-02-01 00:41:58.000000', 'temperatura', 1070.0000, 'ºC'),
	(33512, 108, '2015-02-01 00:41:59.000000', 'temperatura', 438.0000, 'ºC'),
	(33513, 108, '2015-02-01 00:42:00.000000', 'temperatura', 182.0000, 'ºC'),
	(33514, 108, '2015-02-01 00:42:01.000000', 'temperatura', 795.0000, 'ºC'),
	(33515, 108, '2015-02-01 00:42:02.000000', 'temperatura', 1031.0000, 'ºC'),
	(33516, 108, '2015-02-01 00:42:03.000000', 'temperatura', 371.0000, 'ºC'),
	(33517, 108, '2015-02-01 00:42:04.000000', 'temperatura', 1162.0000, 'ºC'),
	(33518, 108, '2015-02-01 00:42:05.000000', 'temperatura', 1097.0000, 'ºC'),
	(33519, 108, '2015-02-01 00:42:06.000000', 'temperatura', 800.0000, 'ºC'),
	(33520, 108, '2015-02-01 00:42:07.000000', 'temperatura', 708.0000, 'ºC'),
	(33521, 108, '2015-02-01 00:42:08.000000', 'temperatura', 1143.0000, 'ºC'),
	(33522, 108, '2015-02-01 00:42:09.000000', 'temperatura', 1190.0000, 'ºC'),
	(33523, 108, '2015-02-01 00:42:10.000000', 'temperatura', 122.0000, 'ºC'),
	(33524, 108, '2015-02-01 00:42:11.000000', 'temperatura', 639.0000, 'ºC'),
	(33525, 108, '2015-02-01 00:42:12.000000', 'temperatura', 432.0000, 'ºC'),
	(33526, 108, '2015-02-01 00:42:13.000000', 'temperatura', 243.0000, 'ºC'),
	(33527, 108, '2015-02-01 00:42:14.000000', 'temperatura', 1119.0000, 'ºC'),
	(33528, 108, '2015-02-01 00:42:15.000000', 'temperatura', 66.0000, 'ºC'),
	(33529, 108, '2015-02-01 00:42:16.000000', 'temperatura', 574.0000, 'ºC'),
	(33530, 108, '2015-02-01 00:42:17.000000', 'temperatura', 274.0000, 'ºC'),
	(33531, 108, '2015-02-01 00:42:18.000000', 'temperatura', 849.0000, 'ºC'),
	(33532, 108, '2015-02-01 00:42:19.000000', 'temperatura', 1022.0000, 'ºC'),
	(33533, 108, '2015-02-01 00:42:20.000000', 'temperatura', 163.0000, 'ºC'),
	(33534, 108, '2015-02-01 00:42:21.000000', 'temperatura', 149.0000, 'ºC'),
	(33535, 108, '2015-02-01 00:42:22.000000', 'temperatura', 256.0000, 'ºC'),
	(33536, 108, '2015-02-01 00:42:23.000000', 'temperatura', 834.0000, 'ºC'),
	(33537, 108, '2015-02-01 00:42:24.000000', 'temperatura', 1004.0000, 'ºC'),
	(33538, 108, '2015-02-01 00:42:25.000000', 'temperatura', 118.0000, 'ºC'),
	(33539, 108, '2015-02-01 00:42:26.000000', 'temperatura', 1179.0000, 'ºC'),
	(33540, 108, '2015-02-01 00:42:27.000000', 'temperatura', 739.0000, 'ºC'),
	(33541, 108, '2015-02-01 00:42:28.000000', 'temperatura', 160.0000, 'ºC'),
	(33542, 108, '2015-02-01 00:42:29.000000', 'temperatura', 982.0000, 'ºC'),
	(33543, 108, '2015-02-01 00:42:30.000000', 'temperatura', 833.0000, 'ºC'),
	(33544, 108, '2015-02-01 00:42:31.000000', 'temperatura', 16.0000, 'ºC'),
	(33545, 108, '2015-02-01 00:42:32.000000', 'temperatura', 1185.0000, 'ºC'),
	(33546, 108, '2015-02-01 00:42:33.000000', 'temperatura', 1074.0000, 'ºC'),
	(33547, 108, '2015-02-01 00:42:34.000000', 'temperatura', 619.0000, 'ºC'),
	(33548, 108, '2015-02-01 00:42:35.000000', 'temperatura', 1072.0000, 'ºC'),
	(33549, 108, '2015-02-01 00:42:36.000000', 'temperatura', 1105.0000, 'ºC'),
	(33550, 108, '2015-02-01 00:42:37.000000', 'temperatura', 1108.0000, 'ºC'),
	(33551, 108, '2015-02-01 00:42:38.000000', 'temperatura', 1025.0000, 'ºC'),
	(33552, 108, '2015-02-01 00:42:39.000000', 'temperatura', 601.0000, 'ºC'),
	(33553, 108, '2015-02-01 00:42:40.000000', 'temperatura', 1130.0000, 'ºC'),
	(33554, 108, '2015-02-01 00:42:41.000000', 'temperatura', 250.0000, 'ºC'),
	(33555, 108, '2015-02-01 00:42:42.000000', 'temperatura', 258.0000, 'ºC'),
	(33556, 108, '2015-02-01 00:42:43.000000', 'temperatura', 541.0000, 'ºC'),
	(33557, 108, '2015-02-01 00:42:44.000000', 'temperatura', 732.0000, 'ºC'),
	(33558, 108, '2015-02-01 00:42:45.000000', 'temperatura', 837.0000, 'ºC'),
	(33559, 108, '2015-02-01 00:42:46.000000', 'temperatura', 792.0000, 'ºC'),
	(33560, 108, '2015-02-01 00:42:47.000000', 'temperatura', 247.0000, 'ºC'),
	(33561, 108, '2015-02-01 00:42:48.000000', 'temperatura', 60.0000, 'ºC'),
	(33562, 108, '2015-02-01 00:42:49.000000', 'temperatura', 760.0000, 'ºC'),
	(33563, 108, '2015-02-01 00:42:50.000000', 'temperatura', 22.0000, 'ºC'),
	(33564, 108, '2015-02-01 00:42:51.000000', 'temperatura', 228.0000, 'ºC'),
	(33565, 108, '2015-02-01 00:42:52.000000', 'temperatura', 1077.0000, 'ºC'),
	(33566, 108, '2015-02-01 00:42:53.000000', 'temperatura', 1099.0000, 'ºC'),
	(33567, 108, '2015-02-01 00:42:54.000000', 'temperatura', 1066.0000, 'ºC'),
	(33568, 108, '2015-02-01 00:42:55.000000', 'temperatura', 831.0000, 'ºC'),
	(33569, 108, '2015-02-01 00:42:56.000000', 'temperatura', 960.0000, 'ºC'),
	(33570, 108, '2015-02-01 00:42:57.000000', 'temperatura', 1107.0000, 'ºC'),
	(33571, 108, '2015-02-01 00:42:58.000000', 'temperatura', 257.0000, 'ºC'),
	(33572, 108, '2015-02-01 00:42:59.000000', 'temperatura', 364.0000, 'ºC'),
	(33573, 108, '2015-02-01 00:43:00.000000', 'temperatura', 1047.0000, 'ºC'),
	(33574, 108, '2015-02-01 00:43:01.000000', 'temperatura', 546.0000, 'ºC'),
	(33575, 108, '2015-02-01 00:43:02.000000', 'temperatura', 790.0000, 'ºC'),
	(33576, 108, '2015-02-01 00:43:03.000000', 'temperatura', 1111.0000, 'ºC'),
	(33577, 108, '2015-02-01 00:43:04.000000', 'temperatura', 785.0000, 'ºC'),
	(33578, 108, '2015-02-01 00:43:05.000000', 'temperatura', 593.0000, 'ºC'),
	(33579, 108, '2015-02-01 00:43:06.000000', 'temperatura', 611.0000, 'ºC'),
	(33580, 108, '2015-02-01 00:43:07.000000', 'temperatura', 78.0000, 'ºC'),
	(33581, 108, '2015-02-01 00:43:08.000000', 'temperatura', 955.0000, 'ºC'),
	(33582, 108, '2015-02-01 00:43:09.000000', 'temperatura', 942.0000, 'ºC'),
	(33583, 108, '2015-02-01 00:43:10.000000', 'temperatura', 647.0000, 'ºC'),
	(33584, 108, '2015-02-01 00:43:11.000000', 'temperatura', 409.0000, 'ºC'),
	(33585, 108, '2015-02-01 00:43:12.000000', 'temperatura', 105.0000, 'ºC'),
	(33586, 108, '2015-02-01 00:43:13.000000', 'temperatura', 498.0000, 'ºC'),
	(33587, 108, '2015-02-01 00:43:14.000000', 'temperatura', 975.0000, 'ºC'),
	(33588, 108, '2015-02-01 00:43:15.000000', 'temperatura', 981.0000, 'ºC'),
	(33589, 108, '2015-02-01 00:43:16.000000', 'temperatura', 783.0000, 'ºC'),
	(33590, 108, '2015-02-01 00:43:17.000000', 'temperatura', 972.0000, 'ºC'),
	(33591, 108, '2015-02-01 00:43:18.000000', 'temperatura', 110.0000, 'ºC'),
	(33592, 108, '2015-02-01 00:43:19.000000', 'temperatura', 37.0000, 'ºC'),
	(33593, 108, '2015-02-01 00:43:20.000000', 'temperatura', 1054.0000, 'ºC'),
	(33594, 108, '2015-02-01 00:43:21.000000', 'temperatura', 359.0000, 'ºC'),
	(33595, 108, '2015-02-01 00:43:22.000000', 'temperatura', 1032.0000, 'ºC'),
	(33596, 108, '2015-02-01 00:43:23.000000', 'temperatura', 485.0000, 'ºC'),
	(33597, 108, '2015-02-01 00:43:24.000000', 'temperatura', 529.0000, 'ºC'),
	(33598, 108, '2015-02-01 00:43:25.000000', 'temperatura', 1189.0000, 'ºC'),
	(33599, 108, '2015-02-01 00:43:26.000000', 'temperatura', 762.0000, 'ºC'),
	(33600, 108, '2015-02-01 00:43:27.000000', 'temperatura', 240.0000, 'ºC'),
	(33601, 108, '2015-02-01 00:43:28.000000', 'temperatura', 116.0000, 'ºC'),
	(33602, 108, '2015-02-01 00:43:29.000000', 'temperatura', 1061.0000, 'ºC'),
	(33603, 108, '2015-02-01 00:43:30.000000', 'temperatura', 157.0000, 'ºC'),
	(33604, 108, '2015-02-01 00:43:31.000000', 'temperatura', 3.0000, 'ºC'),
	(33605, 108, '2015-02-01 00:43:32.000000', 'temperatura', 745.0000, 'ºC'),
	(33606, 108, '2015-02-01 00:43:33.000000', 'temperatura', 116.0000, 'ºC'),
	(33607, 108, '2015-02-01 00:43:34.000000', 'temperatura', 747.0000, 'ºC'),
	(33608, 108, '2015-02-01 00:43:35.000000', 'temperatura', 987.0000, 'ºC'),
	(33609, 108, '2015-02-01 00:43:36.000000', 'temperatura', 296.0000, 'ºC'),
	(33610, 108, '2015-02-01 00:43:37.000000', 'temperatura', 918.0000, 'ºC'),
	(33611, 108, '2015-02-01 00:43:38.000000', 'temperatura', 101.0000, 'ºC'),
	(33612, 108, '2015-02-01 00:43:39.000000', 'temperatura', 154.0000, 'ºC'),
	(33613, 108, '2015-02-01 00:43:40.000000', 'temperatura', 466.0000, 'ºC'),
	(33614, 108, '2015-02-01 00:43:41.000000', 'temperatura', 668.0000, 'ºC'),
	(33615, 108, '2015-02-01 00:43:42.000000', 'temperatura', 741.0000, 'ºC'),
	(33616, 108, '2015-02-01 00:43:43.000000', 'temperatura', 505.0000, 'ºC'),
	(33617, 108, '2015-02-01 00:43:44.000000', 'temperatura', 300.0000, 'ºC'),
	(33618, 108, '2015-02-01 00:43:45.000000', 'temperatura', 1184.0000, 'ºC'),
	(33619, 108, '2015-02-01 00:43:46.000000', 'temperatura', 223.0000, 'ºC'),
	(33620, 108, '2015-02-01 00:43:47.000000', 'temperatura', 1163.0000, 'ºC'),
	(33621, 108, '2015-02-01 00:43:48.000000', 'temperatura', 347.0000, 'ºC'),
	(33622, 108, '2015-02-01 00:43:49.000000', 'temperatura', 648.0000, 'ºC'),
	(33623, 108, '2015-02-01 00:43:50.000000', 'temperatura', 997.0000, 'ºC'),
	(33624, 108, '2015-02-01 00:43:51.000000', 'temperatura', 640.0000, 'ºC'),
	(33625, 108, '2015-02-01 00:43:52.000000', 'temperatura', 212.0000, 'ºC'),
	(33626, 108, '2015-02-01 00:43:53.000000', 'temperatura', 339.0000, 'ºC'),
	(33627, 108, '2015-02-01 00:43:54.000000', 'temperatura', 1062.0000, 'ºC'),
	(33628, 108, '2015-02-01 00:43:55.000000', 'temperatura', 690.0000, 'ºC'),
	(33629, 108, '2015-02-01 00:43:56.000000', 'temperatura', 268.0000, 'ºC'),
	(33630, 108, '2015-02-01 00:43:57.000000', 'temperatura', 468.0000, 'ºC'),
	(33631, 108, '2015-02-01 00:43:58.000000', 'temperatura', 337.0000, 'ºC'),
	(33632, 108, '2015-02-01 00:43:59.000000', 'temperatura', 280.0000, 'ºC'),
	(33633, 108, '2015-02-01 00:44:00.000000', 'temperatura', 391.0000, 'ºC'),
	(33634, 108, '2015-02-01 00:44:01.000000', 'temperatura', 1114.0000, 'ºC'),
	(33635, 108, '2015-02-01 00:44:02.000000', 'temperatura', 798.0000, 'ºC'),
	(33636, 108, '2015-02-01 00:44:03.000000', 'temperatura', 649.0000, 'ºC'),
	(33637, 108, '2015-02-01 00:44:04.000000', 'temperatura', 851.0000, 'ºC'),
	(33638, 108, '2015-02-01 00:44:05.000000', 'temperatura', 1110.0000, 'ºC'),
	(33639, 108, '2015-02-01 00:44:06.000000', 'temperatura', 595.0000, 'ºC'),
	(33640, 108, '2015-02-01 00:44:07.000000', 'temperatura', 846.0000, 'ºC'),
	(33641, 108, '2015-02-01 00:44:08.000000', 'temperatura', 44.0000, 'ºC'),
	(33642, 108, '2015-02-01 00:44:09.000000', 'temperatura', 85.0000, 'ºC'),
	(33643, 108, '2015-02-01 00:44:10.000000', 'temperatura', 293.0000, 'ºC'),
	(33644, 108, '2015-02-01 00:44:11.000000', 'temperatura', 11.0000, 'ºC'),
	(33645, 108, '2015-02-01 00:44:12.000000', 'temperatura', 375.0000, 'ºC'),
	(33646, 108, '2015-02-01 00:44:13.000000', 'temperatura', 642.0000, 'ºC'),
	(33647, 108, '2015-02-01 00:44:14.000000', 'temperatura', 887.0000, 'ºC'),
	(33648, 108, '2015-02-01 00:44:15.000000', 'temperatura', 109.0000, 'ºC'),
	(33649, 108, '2015-02-01 00:44:16.000000', 'temperatura', 283.0000, 'ºC'),
	(33650, 108, '2015-02-01 00:44:17.000000', 'temperatura', 1088.0000, 'ºC'),
	(33651, 108, '2015-02-01 00:44:18.000000', 'temperatura', 993.0000, 'ºC'),
	(33652, 108, '2015-02-01 00:44:19.000000', 'temperatura', 503.0000, 'ºC'),
	(33653, 108, '2015-02-01 00:44:20.000000', 'temperatura', 736.0000, 'ºC'),
	(33654, 108, '2015-02-01 00:44:21.000000', 'temperatura', 971.0000, 'ºC'),
	(33655, 108, '2015-02-01 00:44:22.000000', 'temperatura', 245.0000, 'ºC'),
	(33656, 108, '2015-02-01 00:44:23.000000', 'temperatura', 716.0000, 'ºC'),
	(33657, 108, '2015-02-01 00:44:24.000000', 'temperatura', 444.0000, 'ºC'),
	(33658, 108, '2015-02-01 00:44:25.000000', 'temperatura', 71.0000, 'ºC'),
	(33659, 108, '2015-02-01 00:44:26.000000', 'temperatura', 223.0000, 'ºC'),
	(33660, 108, '2015-02-01 00:44:27.000000', 'temperatura', 906.0000, 'ºC'),
	(33661, 108, '2015-02-01 00:44:28.000000', 'temperatura', 259.0000, 'ºC'),
	(33662, 108, '2015-02-01 00:44:29.000000', 'temperatura', 978.0000, 'ºC'),
	(33663, 108, '2015-02-01 00:44:30.000000', 'temperatura', 512.0000, 'ºC'),
	(33664, 108, '2015-02-01 00:44:31.000000', 'temperatura', 829.0000, 'ºC'),
	(33665, 108, '2015-02-01 00:44:32.000000', 'temperatura', 208.0000, 'ºC'),
	(33666, 108, '2015-02-01 00:44:33.000000', 'temperatura', 955.0000, 'ºC'),
	(33667, 108, '2015-02-01 00:44:34.000000', 'temperatura', 549.0000, 'ºC'),
	(33668, 108, '2015-02-01 00:44:35.000000', 'temperatura', 1082.0000, 'ºC'),
	(33669, 108, '2015-02-01 00:44:36.000000', 'temperatura', 164.0000, 'ºC'),
	(33670, 108, '2015-02-01 00:44:37.000000', 'temperatura', 1176.0000, 'ºC'),
	(33671, 108, '2015-02-01 00:44:38.000000', 'temperatura', 585.0000, 'ºC'),
	(33672, 108, '2015-02-01 00:44:39.000000', 'temperatura', 601.0000, 'ºC'),
	(33673, 108, '2015-02-01 00:44:40.000000', 'temperatura', 49.0000, 'ºC'),
	(33674, 108, '2015-02-01 00:44:41.000000', 'temperatura', 845.0000, 'ºC'),
	(33675, 108, '2015-02-01 00:44:42.000000', 'temperatura', 475.0000, 'ºC'),
	(33676, 108, '2015-02-01 00:44:43.000000', 'temperatura', 1042.0000, 'ºC'),
	(33677, 108, '2015-02-01 00:44:44.000000', 'temperatura', 186.0000, 'ºC'),
	(33678, 108, '2015-02-01 00:44:45.000000', 'temperatura', 203.0000, 'ºC'),
	(33679, 108, '2015-02-01 00:44:46.000000', 'temperatura', 457.0000, 'ºC'),
	(33680, 108, '2015-02-01 00:44:47.000000', 'temperatura', 478.0000, 'ºC'),
	(33681, 108, '2015-02-01 00:44:48.000000', 'temperatura', 1020.0000, 'ºC'),
	(33682, 108, '2015-02-01 00:44:49.000000', 'temperatura', 67.0000, 'ºC'),
	(33683, 108, '2015-02-01 00:44:50.000000', 'temperatura', 877.0000, 'ºC'),
	(33684, 108, '2015-02-01 00:44:51.000000', 'temperatura', 582.0000, 'ºC'),
	(33685, 108, '2015-02-01 00:44:52.000000', 'temperatura', 279.0000, 'ºC'),
	(33686, 108, '2015-02-01 00:44:53.000000', 'temperatura', 849.0000, 'ºC'),
	(33687, 108, '2015-02-01 00:44:54.000000', 'temperatura', 1008.0000, 'ºC'),
	(33688, 108, '2015-02-01 00:44:55.000000', 'temperatura', 92.0000, 'ºC'),
	(33689, 108, '2015-02-01 00:44:56.000000', 'temperatura', 1040.0000, 'ºC'),
	(33690, 108, '2015-02-01 00:44:57.000000', 'temperatura', 123.0000, 'ºC'),
	(33691, 108, '2015-02-01 00:44:58.000000', 'temperatura', 1094.0000, 'ºC'),
	(33692, 108, '2015-02-01 00:44:59.000000', 'temperatura', 301.0000, 'ºC'),
	(33693, 108, '2015-02-01 00:45:00.000000', 'temperatura', 624.0000, 'ºC'),
	(33694, 108, '2015-02-01 00:45:01.000000', 'temperatura', 1016.0000, 'ºC'),
	(33695, 108, '2015-02-01 00:45:02.000000', 'temperatura', 810.0000, 'ºC'),
	(33696, 108, '2015-02-01 00:45:03.000000', 'temperatura', 1005.0000, 'ºC'),
	(33697, 108, '2015-02-01 00:45:04.000000', 'temperatura', 192.0000, 'ºC'),
	(33698, 108, '2015-02-01 00:45:05.000000', 'temperatura', 345.0000, 'ºC'),
	(33699, 108, '2015-02-01 00:45:06.000000', 'temperatura', 1152.0000, 'ºC'),
	(33700, 108, '2015-02-01 00:45:07.000000', 'temperatura', 1126.0000, 'ºC'),
	(33701, 108, '2015-02-01 00:45:08.000000', 'temperatura', 972.0000, 'ºC'),
	(33702, 108, '2015-02-01 00:45:09.000000', 'temperatura', 283.0000, 'ºC'),
	(33703, 108, '2015-02-01 00:45:10.000000', 'temperatura', 900.0000, 'ºC'),
	(33704, 108, '2015-02-01 00:45:11.000000', 'temperatura', 51.0000, 'ºC'),
	(33705, 108, '2015-02-01 00:45:12.000000', 'temperatura', 1155.0000, 'ºC'),
	(33706, 108, '2015-02-01 00:45:13.000000', 'temperatura', 822.0000, 'ºC'),
	(33707, 108, '2015-02-01 00:45:14.000000', 'temperatura', 644.0000, 'ºC'),
	(33708, 108, '2015-02-01 00:45:15.000000', 'temperatura', 758.0000, 'ºC'),
	(33709, 108, '2015-02-01 00:45:16.000000', 'temperatura', 655.0000, 'ºC'),
	(33710, 108, '2015-02-01 00:45:17.000000', 'temperatura', 1004.0000, 'ºC'),
	(33711, 108, '2015-02-01 00:45:18.000000', 'temperatura', 654.0000, 'ºC'),
	(33712, 108, '2015-02-01 00:45:19.000000', 'temperatura', 258.0000, 'ºC'),
	(33713, 108, '2015-02-01 00:45:20.000000', 'temperatura', 528.0000, 'ºC'),
	(33714, 108, '2015-02-01 00:45:21.000000', 'temperatura', 665.0000, 'ºC'),
	(33715, 108, '2015-02-01 00:45:22.000000', 'temperatura', 545.0000, 'ºC'),
	(33716, 108, '2015-02-01 00:45:23.000000', 'temperatura', 730.0000, 'ºC'),
	(33717, 108, '2015-02-01 00:45:24.000000', 'temperatura', 814.0000, 'ºC'),
	(33718, 108, '2015-02-01 00:45:25.000000', 'temperatura', 682.0000, 'ºC'),
	(33719, 108, '2015-02-01 00:45:26.000000', 'temperatura', 968.0000, 'ºC'),
	(33720, 108, '2015-02-01 00:45:27.000000', 'temperatura', 393.0000, 'ºC'),
	(33721, 108, '2015-02-01 00:45:28.000000', 'temperatura', 264.0000, 'ºC'),
	(33722, 108, '2015-02-01 00:45:29.000000', 'temperatura', 141.0000, 'ºC'),
	(33723, 108, '2015-02-01 00:45:30.000000', 'temperatura', 1115.0000, 'ºC'),
	(33724, 108, '2015-02-01 00:45:31.000000', 'temperatura', 352.0000, 'ºC'),
	(33725, 108, '2015-02-01 00:45:32.000000', 'temperatura', 815.0000, 'ºC'),
	(33726, 108, '2015-02-01 00:45:33.000000', 'temperatura', 620.0000, 'ºC'),
	(33727, 108, '2015-02-01 00:45:34.000000', 'temperatura', 654.0000, 'ºC'),
	(33728, 108, '2015-02-01 00:45:35.000000', 'temperatura', 212.0000, 'ºC'),
	(33729, 108, '2015-02-01 00:45:36.000000', 'temperatura', 297.0000, 'ºC'),
	(33730, 108, '2015-02-01 00:45:37.000000', 'temperatura', 849.0000, 'ºC'),
	(33731, 108, '2015-02-01 00:45:38.000000', 'temperatura', 953.0000, 'ºC'),
	(33732, 108, '2015-02-01 00:45:39.000000', 'temperatura', 1021.0000, 'ºC'),
	(33733, 108, '2015-02-01 00:45:40.000000', 'temperatura', 1048.0000, 'ºC'),
	(33734, 108, '2015-02-01 00:45:41.000000', 'temperatura', 975.0000, 'ºC'),
	(33735, 108, '2015-02-01 00:45:42.000000', 'temperatura', 532.0000, 'ºC'),
	(33736, 108, '2015-02-01 00:45:43.000000', 'temperatura', 937.0000, 'ºC'),
	(33737, 108, '2015-02-01 00:45:44.000000', 'temperatura', 688.0000, 'ºC'),
	(33738, 108, '2015-02-01 00:45:45.000000', 'temperatura', 632.0000, 'ºC'),
	(33739, 108, '2015-02-01 00:45:46.000000', 'temperatura', 1094.0000, 'ºC'),
	(33740, 108, '2015-02-01 00:45:47.000000', 'temperatura', 1175.0000, 'ºC'),
	(33741, 108, '2015-02-01 00:45:48.000000', 'temperatura', 194.0000, 'ºC'),
	(33742, 108, '2015-02-01 00:45:49.000000', 'temperatura', 1043.0000, 'ºC'),
	(33743, 108, '2015-02-01 00:45:50.000000', 'temperatura', 1037.0000, 'ºC'),
	(33744, 108, '2015-02-01 00:45:51.000000', 'temperatura', 856.0000, 'ºC'),
	(33745, 108, '2015-02-01 00:45:52.000000', 'temperatura', 1168.0000, 'ºC'),
	(33746, 108, '2015-02-01 00:45:53.000000', 'temperatura', 875.0000, 'ºC'),
	(33747, 108, '2015-02-01 00:45:54.000000', 'temperatura', 870.0000, 'ºC'),
	(33748, 108, '2015-02-01 00:45:55.000000', 'temperatura', 526.0000, 'ºC'),
	(33749, 108, '2015-02-01 00:45:56.000000', 'temperatura', 19.0000, 'ºC'),
	(33750, 108, '2015-02-01 00:45:57.000000', 'temperatura', 919.0000, 'ºC'),
	(33751, 108, '2015-02-01 00:45:58.000000', 'temperatura', 940.0000, 'ºC'),
	(33752, 108, '2015-02-01 00:45:59.000000', 'temperatura', 743.0000, 'ºC'),
	(33753, 108, '2015-02-01 00:46:00.000000', 'temperatura', 895.0000, 'ºC'),
	(33754, 108, '2015-02-01 00:46:01.000000', 'temperatura', 1047.0000, 'ºC'),
	(33755, 108, '2015-02-01 00:46:02.000000', 'temperatura', 150.0000, 'ºC'),
	(33756, 108, '2015-02-01 00:46:03.000000', 'temperatura', 10.0000, 'ºC'),
	(33757, 108, '2015-02-01 00:46:04.000000', 'temperatura', 801.0000, 'ºC'),
	(33758, 108, '2015-02-01 00:46:05.000000', 'temperatura', 376.0000, 'ºC'),
	(33759, 108, '2015-02-01 00:46:06.000000', 'temperatura', 675.0000, 'ºC'),
	(33760, 108, '2015-02-01 00:46:07.000000', 'temperatura', 1049.0000, 'ºC'),
	(33761, 108, '2015-02-01 00:46:08.000000', 'temperatura', 822.0000, 'ºC'),
	(33762, 108, '2015-02-01 00:46:09.000000', 'temperatura', 964.0000, 'ºC'),
	(33763, 108, '2015-02-01 00:46:10.000000', 'temperatura', 1154.0000, 'ºC'),
	(33764, 108, '2015-02-01 00:46:11.000000', 'temperatura', 477.0000, 'ºC'),
	(33765, 108, '2015-02-01 00:46:12.000000', 'temperatura', 124.0000, 'ºC'),
	(33766, 108, '2015-02-01 00:46:13.000000', 'temperatura', 389.0000, 'ºC'),
	(33767, 108, '2015-02-01 00:46:14.000000', 'temperatura', 373.0000, 'ºC'),
	(33768, 108, '2015-02-01 00:46:15.000000', 'temperatura', 701.0000, 'ºC'),
	(33769, 108, '2015-02-01 00:46:16.000000', 'temperatura', 1185.0000, 'ºC'),
	(33770, 108, '2015-02-01 00:46:17.000000', 'temperatura', 225.0000, 'ºC'),
	(33771, 108, '2015-02-01 00:46:18.000000', 'temperatura', 1167.0000, 'ºC'),
	(33772, 108, '2015-02-01 00:46:19.000000', 'temperatura', 364.0000, 'ºC'),
	(33773, 108, '2015-02-01 00:46:20.000000', 'temperatura', 717.0000, 'ºC'),
	(33774, 108, '2015-02-01 00:46:21.000000', 'temperatura', 95.0000, 'ºC'),
	(33775, 108, '2015-02-01 00:46:22.000000', 'temperatura', 725.0000, 'ºC'),
	(33776, 108, '2015-02-01 00:46:23.000000', 'temperatura', 939.0000, 'ºC'),
	(33777, 108, '2015-02-01 00:46:24.000000', 'temperatura', 120.0000, 'ºC'),
	(33778, 108, '2015-02-01 00:46:25.000000', 'temperatura', 186.0000, 'ºC'),
	(33779, 108, '2015-02-01 00:46:26.000000', 'temperatura', 571.0000, 'ºC'),
	(33780, 108, '2015-02-01 00:46:27.000000', 'temperatura', 1095.0000, 'ºC'),
	(33781, 108, '2015-02-01 00:46:28.000000', 'temperatura', 165.0000, 'ºC'),
	(33782, 108, '2015-02-01 00:46:29.000000', 'temperatura', 1141.0000, 'ºC'),
	(33783, 108, '2015-02-01 00:46:30.000000', 'temperatura', 408.0000, 'ºC'),
	(33784, 108, '2015-02-01 00:46:31.000000', 'temperatura', 1020.0000, 'ºC'),
	(33785, 108, '2015-02-01 00:46:32.000000', 'temperatura', 277.0000, 'ºC'),
	(33786, 108, '2015-02-01 00:46:33.000000', 'temperatura', 724.0000, 'ºC'),
	(33787, 108, '2015-02-01 00:46:34.000000', 'temperatura', 389.0000, 'ºC'),
	(33788, 108, '2015-02-01 00:46:35.000000', 'temperatura', 975.0000, 'ºC'),
	(33789, 108, '2015-02-01 00:46:36.000000', 'temperatura', 108.0000, 'ºC'),
	(33790, 108, '2015-02-01 00:46:37.000000', 'temperatura', 17.0000, 'ºC'),
	(33791, 108, '2015-02-01 00:46:38.000000', 'temperatura', 961.0000, 'ºC'),
	(33792, 108, '2015-02-01 00:46:39.000000', 'temperatura', 1156.0000, 'ºC'),
	(33793, 108, '2015-02-01 00:46:40.000000', 'temperatura', 496.0000, 'ºC'),
	(33794, 108, '2015-02-01 00:46:41.000000', 'temperatura', 214.0000, 'ºC'),
	(33795, 108, '2015-02-01 00:46:42.000000', 'temperatura', 781.0000, 'ºC'),
	(33796, 108, '2015-02-01 00:46:43.000000', 'temperatura', 863.0000, 'ºC'),
	(33797, 108, '2015-02-01 00:46:44.000000', 'temperatura', 772.0000, 'ºC'),
	(33798, 108, '2015-02-01 00:46:45.000000', 'temperatura', 73.0000, 'ºC'),
	(33799, 108, '2015-02-01 00:46:46.000000', 'temperatura', 448.0000, 'ºC'),
	(33800, 108, '2015-02-01 00:46:47.000000', 'temperatura', 821.0000, 'ºC'),
	(33801, 108, '2015-02-01 00:46:48.000000', 'temperatura', 362.0000, 'ºC'),
	(33802, 108, '2015-02-01 00:46:49.000000', 'temperatura', 546.0000, 'ºC'),
	(33803, 108, '2015-02-01 00:46:50.000000', 'temperatura', 445.0000, 'ºC'),
	(33804, 108, '2015-02-01 00:46:51.000000', 'temperatura', 588.0000, 'ºC'),
	(33805, 108, '2015-02-01 00:46:52.000000', 'temperatura', 407.0000, 'ºC'),
	(33806, 108, '2015-02-01 00:46:53.000000', 'temperatura', 271.0000, 'ºC'),
	(33807, 108, '2015-02-01 00:46:54.000000', 'temperatura', 134.0000, 'ºC'),
	(33808, 108, '2015-02-01 00:46:55.000000', 'temperatura', 1057.0000, 'ºC'),
	(33809, 108, '2015-02-01 00:46:56.000000', 'temperatura', 86.0000, 'ºC'),
	(33810, 108, '2015-02-01 00:46:57.000000', 'temperatura', 858.0000, 'ºC'),
	(33811, 108, '2015-02-01 00:46:58.000000', 'temperatura', 433.0000, 'ºC'),
	(33812, 108, '2015-02-01 00:46:59.000000', 'temperatura', 792.0000, 'ºC'),
	(33813, 108, '2015-02-01 00:47:00.000000', 'temperatura', 262.0000, 'ºC'),
	(33814, 108, '2015-02-01 00:47:01.000000', 'temperatura', 132.0000, 'ºC'),
	(33815, 108, '2015-02-01 00:47:02.000000', 'temperatura', 1077.0000, 'ºC'),
	(33816, 108, '2015-02-01 00:47:03.000000', 'temperatura', 187.0000, 'ºC'),
	(33817, 108, '2015-02-01 00:47:04.000000', 'temperatura', 107.0000, 'ºC'),
	(33818, 108, '2015-02-01 00:47:05.000000', 'temperatura', 1172.0000, 'ºC'),
	(33819, 108, '2015-02-01 00:47:06.000000', 'temperatura', 738.0000, 'ºC'),
	(33820, 108, '2015-02-01 00:47:07.000000', 'temperatura', 178.0000, 'ºC'),
	(33821, 108, '2015-02-01 00:47:08.000000', 'temperatura', 1077.0000, 'ºC'),
	(33822, 108, '2015-02-01 00:47:09.000000', 'temperatura', 49.0000, 'ºC'),
	(33823, 108, '2015-02-01 00:47:10.000000', 'temperatura', 616.0000, 'ºC'),
	(33824, 108, '2015-02-01 00:47:11.000000', 'temperatura', 532.0000, 'ºC'),
	(33825, 108, '2015-02-01 00:47:12.000000', 'temperatura', 813.0000, 'ºC'),
	(33826, 108, '2015-02-01 00:47:13.000000', 'temperatura', 69.0000, 'ºC'),
	(33827, 108, '2015-02-01 00:47:14.000000', 'temperatura', 305.0000, 'ºC'),
	(33828, 108, '2015-02-01 00:47:15.000000', 'temperatura', 119.0000, 'ºC'),
	(33829, 108, '2015-02-01 00:47:16.000000', 'temperatura', 882.0000, 'ºC'),
	(33830, 108, '2015-02-01 00:47:17.000000', 'temperatura', 453.0000, 'ºC'),
	(33831, 108, '2015-02-01 00:47:18.000000', 'temperatura', 821.0000, 'ºC'),
	(33832, 108, '2015-02-01 00:47:19.000000', 'temperatura', 346.0000, 'ºC'),
	(33833, 108, '2015-02-01 00:47:20.000000', 'temperatura', 468.0000, 'ºC'),
	(33834, 108, '2015-02-01 00:47:21.000000', 'temperatura', 104.0000, 'ºC'),
	(33835, 108, '2015-02-01 00:47:22.000000', 'temperatura', 314.0000, 'ºC'),
	(33836, 108, '2015-02-01 00:47:23.000000', 'temperatura', 61.0000, 'ºC'),
	(33837, 108, '2015-02-01 00:47:24.000000', 'temperatura', 560.0000, 'ºC'),
	(33838, 108, '2015-02-01 00:47:25.000000', 'temperatura', 220.0000, 'ºC'),
	(33839, 108, '2015-02-01 00:47:26.000000', 'temperatura', 621.0000, 'ºC'),
	(33840, 108, '2015-02-01 00:47:27.000000', 'temperatura', 47.0000, 'ºC'),
	(33841, 108, '2015-02-01 00:47:28.000000', 'temperatura', 769.0000, 'ºC'),
	(33842, 108, '2015-02-01 00:47:29.000000', 'temperatura', 106.0000, 'ºC'),
	(33843, 108, '2015-02-01 00:47:30.000000', 'temperatura', 625.0000, 'ºC'),
	(33844, 108, '2015-02-01 00:47:31.000000', 'temperatura', 405.0000, 'ºC'),
	(33845, 108, '2015-02-01 00:47:32.000000', 'temperatura', 150.0000, 'ºC'),
	(33846, 108, '2015-02-01 00:47:33.000000', 'temperatura', 738.0000, 'ºC'),
	(33847, 108, '2015-02-01 00:47:34.000000', 'temperatura', 840.0000, 'ºC'),
	(33848, 108, '2015-02-01 00:47:35.000000', 'temperatura', 786.0000, 'ºC'),
	(33849, 108, '2015-02-01 00:47:36.000000', 'temperatura', 211.0000, 'ºC'),
	(33850, 108, '2015-02-01 00:47:37.000000', 'temperatura', 1099.0000, 'ºC'),
	(33851, 108, '2015-02-01 00:47:38.000000', 'temperatura', 60.0000, 'ºC'),
	(33852, 108, '2015-02-01 00:47:39.000000', 'temperatura', 606.0000, 'ºC'),
	(33853, 108, '2015-02-01 00:47:40.000000', 'temperatura', 451.0000, 'ºC'),
	(33854, 108, '2015-02-01 00:47:41.000000', 'temperatura', 436.0000, 'ºC'),
	(33855, 108, '2015-02-01 00:47:42.000000', 'temperatura', 827.0000, 'ºC'),
	(33856, 108, '2015-02-01 00:47:43.000000', 'temperatura', 429.0000, 'ºC'),
	(33857, 108, '2015-02-01 00:47:44.000000', 'temperatura', 862.0000, 'ºC'),
	(33858, 108, '2015-02-01 00:47:45.000000', 'temperatura', 624.0000, 'ºC'),
	(33859, 108, '2015-02-01 00:47:46.000000', 'temperatura', 533.0000, 'ºC'),
	(33860, 108, '2015-02-01 00:47:47.000000', 'temperatura', 797.0000, 'ºC'),
	(33861, 108, '2015-02-01 00:47:48.000000', 'temperatura', 1184.0000, 'ºC'),
	(33862, 108, '2015-02-01 00:47:49.000000', 'temperatura', 1129.0000, 'ºC'),
	(33863, 108, '2015-02-01 00:47:50.000000', 'temperatura', 895.0000, 'ºC'),
	(33864, 108, '2015-02-01 00:47:51.000000', 'temperatura', 1087.0000, 'ºC'),
	(33865, 108, '2015-02-01 00:47:52.000000', 'temperatura', 353.0000, 'ºC'),
	(33866, 108, '2015-02-01 00:47:53.000000', 'temperatura', 902.0000, 'ºC'),
	(33867, 108, '2015-02-01 00:47:54.000000', 'temperatura', 1050.0000, 'ºC'),
	(33868, 108, '2015-02-01 00:47:55.000000', 'temperatura', 148.0000, 'ºC'),
	(33869, 108, '2015-02-01 00:47:56.000000', 'temperatura', 1188.0000, 'ºC'),
	(33870, 108, '2015-02-01 00:47:57.000000', 'temperatura', 698.0000, 'ºC'),
	(33871, 108, '2015-02-01 00:47:58.000000', 'temperatura', 1126.0000, 'ºC'),
	(33872, 108, '2015-02-01 00:47:59.000000', 'temperatura', 1135.0000, 'ºC'),
	(33873, 108, '2015-02-01 00:48:00.000000', 'temperatura', 1100.0000, 'ºC'),
	(33874, 108, '2015-02-01 00:48:01.000000', 'temperatura', 895.0000, 'ºC'),
	(33875, 108, '2015-02-01 00:48:02.000000', 'temperatura', 1173.0000, 'ºC'),
	(33876, 108, '2015-02-01 00:48:03.000000', 'temperatura', 783.0000, 'ºC'),
	(33877, 108, '2015-02-01 00:48:04.000000', 'temperatura', 398.0000, 'ºC'),
	(33878, 108, '2015-02-01 00:48:05.000000', 'temperatura', 839.0000, 'ºC'),
	(33879, 108, '2015-02-01 00:48:06.000000', 'temperatura', 604.0000, 'ºC'),
	(33880, 108, '2015-02-01 00:48:07.000000', 'temperatura', 503.0000, 'ºC'),
	(33881, 108, '2015-02-01 00:48:08.000000', 'temperatura', 703.0000, 'ºC'),
	(33882, 108, '2015-02-01 00:48:09.000000', 'temperatura', 805.0000, 'ºC'),
	(33883, 108, '2015-02-01 00:48:10.000000', 'temperatura', 717.0000, 'ºC'),
	(33884, 108, '2015-02-01 00:48:11.000000', 'temperatura', 1169.0000, 'ºC'),
	(33885, 108, '2015-02-01 00:48:12.000000', 'temperatura', 98.0000, 'ºC'),
	(33886, 108, '2015-02-01 00:48:13.000000', 'temperatura', 581.0000, 'ºC'),
	(33887, 108, '2015-02-01 00:48:14.000000', 'temperatura', 212.0000, 'ºC'),
	(33888, 108, '2015-02-01 00:48:15.000000', 'temperatura', 519.0000, 'ºC'),
	(33889, 108, '2015-02-01 00:48:16.000000', 'temperatura', 759.0000, 'ºC'),
	(33890, 108, '2015-02-01 00:48:17.000000', 'temperatura', 1039.0000, 'ºC'),
	(33891, 108, '2015-02-01 00:48:18.000000', 'temperatura', 517.0000, 'ºC'),
	(33892, 108, '2015-02-01 00:48:19.000000', 'temperatura', 667.0000, 'ºC'),
	(33893, 108, '2015-02-01 00:48:20.000000', 'temperatura', 586.0000, 'ºC'),
	(33894, 108, '2015-02-01 00:48:21.000000', 'temperatura', 930.0000, 'ºC'),
	(33895, 108, '2015-02-01 00:48:22.000000', 'temperatura', 494.0000, 'ºC'),
	(33896, 108, '2015-02-01 00:48:23.000000', 'temperatura', 878.0000, 'ºC'),
	(33897, 108, '2015-02-01 00:48:24.000000', 'temperatura', 507.0000, 'ºC'),
	(33898, 108, '2015-02-01 00:48:25.000000', 'temperatura', 1105.0000, 'ºC'),
	(33899, 108, '2015-02-01 00:48:26.000000', 'temperatura', 402.0000, 'ºC'),
	(33900, 108, '2015-02-01 00:48:27.000000', 'temperatura', 1095.0000, 'ºC'),
	(33901, 108, '2015-02-01 00:48:28.000000', 'temperatura', 669.0000, 'ºC'),
	(33902, 108, '2015-02-01 00:48:29.000000', 'temperatura', 61.0000, 'ºC'),
	(33903, 108, '2015-02-01 00:48:30.000000', 'temperatura', 699.0000, 'ºC'),
	(33904, 108, '2015-02-01 00:48:31.000000', 'temperatura', 912.0000, 'ºC'),
	(33905, 108, '2015-02-01 00:48:32.000000', 'temperatura', 64.0000, 'ºC'),
	(33906, 108, '2015-02-01 00:48:33.000000', 'temperatura', 1185.0000, 'ºC'),
	(33907, 108, '2015-02-01 00:48:34.000000', 'temperatura', 934.0000, 'ºC'),
	(33908, 108, '2015-02-01 00:48:35.000000', 'temperatura', 1114.0000, 'ºC'),
	(33909, 108, '2015-02-01 00:48:36.000000', 'temperatura', 370.0000, 'ºC'),
	(33910, 108, '2015-02-01 00:48:37.000000', 'temperatura', 909.0000, 'ºC'),
	(33911, 108, '2015-02-01 00:48:38.000000', 'temperatura', 1034.0000, 'ºC'),
	(33912, 108, '2015-02-01 00:48:39.000000', 'temperatura', 44.0000, 'ºC'),
	(33913, 108, '2015-02-01 00:48:40.000000', 'temperatura', 717.0000, 'ºC'),
	(33914, 108, '2015-02-01 00:48:41.000000', 'temperatura', 1056.0000, 'ºC'),
	(33915, 108, '2015-02-01 00:48:42.000000', 'temperatura', 728.0000, 'ºC'),
	(33916, 108, '2015-02-01 00:48:43.000000', 'temperatura', 471.0000, 'ºC'),
	(33917, 108, '2015-02-01 00:48:44.000000', 'temperatura', 173.0000, 'ºC'),
	(33918, 108, '2015-02-01 00:48:45.000000', 'temperatura', 654.0000, 'ºC'),
	(33919, 108, '2015-02-01 00:48:46.000000', 'temperatura', 349.0000, 'ºC'),
	(33920, 108, '2015-02-01 00:48:47.000000', 'temperatura', 986.0000, 'ºC'),
	(33921, 108, '2015-02-01 00:48:48.000000', 'temperatura', 281.0000, 'ºC'),
	(33922, 108, '2015-02-01 00:48:49.000000', 'temperatura', 849.0000, 'ºC'),
	(33923, 108, '2015-02-01 00:48:50.000000', 'temperatura', 1001.0000, 'ºC'),
	(33924, 108, '2015-02-01 00:48:51.000000', 'temperatura', 61.0000, 'ºC'),
	(33925, 108, '2015-02-01 00:48:52.000000', 'temperatura', 900.0000, 'ºC'),
	(33926, 108, '2015-02-01 00:48:53.000000', 'temperatura', 717.0000, 'ºC'),
	(33927, 108, '2015-02-01 00:48:54.000000', 'temperatura', 886.0000, 'ºC'),
	(33928, 108, '2015-02-01 00:48:55.000000', 'temperatura', 1080.0000, 'ºC'),
	(33929, 108, '2015-02-01 00:48:56.000000', 'temperatura', 344.0000, 'ºC'),
	(33930, 108, '2015-02-01 00:48:57.000000', 'temperatura', 879.0000, 'ºC'),
	(33931, 108, '2015-02-01 00:48:58.000000', 'temperatura', 966.0000, 'ºC'),
	(33932, 108, '2015-02-01 00:48:59.000000', 'temperatura', 991.0000, 'ºC'),
	(33933, 108, '2015-02-01 00:49:00.000000', 'temperatura', 860.0000, 'ºC'),
	(33934, 108, '2015-02-01 00:49:01.000000', 'temperatura', 126.0000, 'ºC'),
	(33935, 108, '2015-02-01 00:49:02.000000', 'temperatura', 449.0000, 'ºC'),
	(33936, 108, '2015-02-01 00:49:03.000000', 'temperatura', 670.0000, 'ºC'),
	(33937, 108, '2015-02-01 00:49:04.000000', 'temperatura', 805.0000, 'ºC'),
	(33938, 108, '2015-02-01 00:49:05.000000', 'temperatura', 812.0000, 'ºC'),
	(33939, 108, '2015-02-01 00:49:06.000000', 'temperatura', 448.0000, 'ºC'),
	(33940, 108, '2015-02-01 00:49:07.000000', 'temperatura', 1002.0000, 'ºC'),
	(33941, 108, '2015-02-01 00:49:08.000000', 'temperatura', 67.0000, 'ºC'),
	(33942, 108, '2015-02-01 00:49:09.000000', 'temperatura', 931.0000, 'ºC'),
	(33943, 108, '2015-02-01 00:49:10.000000', 'temperatura', 853.0000, 'ºC'),
	(33944, 108, '2015-02-01 00:49:11.000000', 'temperatura', 273.0000, 'ºC'),
	(33945, 108, '2015-02-01 00:49:12.000000', 'temperatura', 8.0000, 'ºC'),
	(33946, 108, '2015-02-01 00:49:13.000000', 'temperatura', 419.0000, 'ºC'),
	(33947, 108, '2015-02-01 00:49:14.000000', 'temperatura', 872.0000, 'ºC'),
	(33948, 108, '2015-02-01 00:49:15.000000', 'temperatura', 704.0000, 'ºC'),
	(33949, 108, '2015-02-01 00:49:16.000000', 'temperatura', 903.0000, 'ºC'),
	(33950, 108, '2015-02-01 00:49:17.000000', 'temperatura', 3.0000, 'ºC'),
	(33951, 108, '2015-02-01 00:49:18.000000', 'temperatura', 909.0000, 'ºC'),
	(33952, 108, '2015-02-01 00:49:19.000000', 'temperatura', 937.0000, 'ºC'),
	(33953, 108, '2015-02-01 00:49:20.000000', 'temperatura', 759.0000, 'ºC'),
	(33954, 108, '2015-02-01 00:49:21.000000', 'temperatura', 982.0000, 'ºC'),
	(33955, 108, '2015-02-01 00:49:22.000000', 'temperatura', 235.0000, 'ºC'),
	(33956, 108, '2015-02-01 00:49:23.000000', 'temperatura', 629.0000, 'ºC'),
	(33957, 108, '2015-02-01 00:49:24.000000', 'temperatura', 39.0000, 'ºC'),
	(33958, 108, '2015-02-01 00:49:25.000000', 'temperatura', 710.0000, 'ºC'),
	(33959, 108, '2015-02-01 00:49:26.000000', 'temperatura', 1032.0000, 'ºC'),
	(33960, 108, '2015-02-01 00:49:27.000000', 'temperatura', 633.0000, 'ºC'),
	(33961, 108, '2015-02-01 00:49:28.000000', 'temperatura', 70.0000, 'ºC'),
	(33962, 108, '2015-02-01 00:49:29.000000', 'temperatura', 851.0000, 'ºC'),
	(33963, 108, '2015-02-01 00:49:30.000000', 'temperatura', 444.0000, 'ºC'),
	(33964, 108, '2015-02-01 00:49:31.000000', 'temperatura', 868.0000, 'ºC'),
	(33965, 108, '2015-02-01 00:49:32.000000', 'temperatura', 607.0000, 'ºC'),
	(33966, 108, '2015-02-01 00:49:33.000000', 'temperatura', 431.0000, 'ºC'),
	(33967, 108, '2015-02-01 00:49:34.000000', 'temperatura', 336.0000, 'ºC'),
	(33968, 108, '2015-02-01 00:49:35.000000', 'temperatura', 389.0000, 'ºC'),
	(33969, 108, '2015-02-01 00:49:36.000000', 'temperatura', 935.0000, 'ºC'),
	(33970, 108, '2015-02-01 00:49:37.000000', 'temperatura', 1110.0000, 'ºC'),
	(33971, 108, '2015-02-01 00:49:38.000000', 'temperatura', 346.0000, 'ºC'),
	(33972, 108, '2015-02-01 00:49:39.000000', 'temperatura', 800.0000, 'ºC'),
	(33973, 108, '2015-02-01 00:49:40.000000', 'temperatura', 564.0000, 'ºC'),
	(33974, 108, '2015-02-01 00:49:41.000000', 'temperatura', 420.0000, 'ºC'),
	(33975, 108, '2015-02-01 00:49:42.000000', 'temperatura', 410.0000, 'ºC'),
	(33976, 108, '2015-02-01 00:49:43.000000', 'temperatura', 789.0000, 'ºC'),
	(33977, 108, '2015-02-01 00:49:44.000000', 'temperatura', 317.0000, 'ºC'),
	(33978, 108, '2015-02-01 00:49:45.000000', 'temperatura', 416.0000, 'ºC'),
	(33979, 108, '2015-02-01 00:49:46.000000', 'temperatura', 1130.0000, 'ºC'),
	(33980, 108, '2015-02-01 00:49:47.000000', 'temperatura', 802.0000, 'ºC'),
	(33981, 108, '2015-02-01 00:49:48.000000', 'temperatura', 622.0000, 'ºC'),
	(33982, 108, '2015-02-01 00:49:49.000000', 'temperatura', 706.0000, 'ºC'),
	(33983, 108, '2015-02-01 00:49:50.000000', 'temperatura', 461.0000, 'ºC'),
	(33984, 108, '2015-02-01 00:49:51.000000', 'temperatura', 189.0000, 'ºC'),
	(33985, 108, '2015-02-01 00:49:52.000000', 'temperatura', 761.0000, 'ºC'),
	(33986, 108, '2015-02-01 00:49:53.000000', 'temperatura', 841.0000, 'ºC'),
	(33987, 108, '2015-02-01 00:49:54.000000', 'temperatura', 723.0000, 'ºC'),
	(33988, 108, '2015-02-01 00:49:55.000000', 'temperatura', 1092.0000, 'ºC'),
	(33989, 108, '2015-02-01 00:49:56.000000', 'temperatura', 893.0000, 'ºC'),
	(33990, 108, '2015-02-01 00:49:57.000000', 'temperatura', 1187.0000, 'ºC'),
	(33991, 108, '2015-02-01 00:49:58.000000', 'temperatura', 858.0000, 'ºC'),
	(33992, 108, '2015-02-01 00:49:59.000000', 'temperatura', 728.0000, 'ºC'),
	(33993, 108, '2015-02-01 00:50:00.000000', 'temperatura', 1068.0000, 'ºC'),
	(33994, 108, '2015-02-01 00:50:01.000000', 'temperatura', 755.0000, 'ºC'),
	(33995, 108, '2015-02-01 00:50:02.000000', 'temperatura', 574.0000, 'ºC'),
	(33996, 108, '2015-02-01 00:50:03.000000', 'temperatura', 604.0000, 'ºC'),
	(33997, 108, '2015-02-01 00:50:04.000000', 'temperatura', 101.0000, 'ºC'),
	(33998, 108, '2015-02-01 00:50:05.000000', 'temperatura', 1091.0000, 'ºC'),
	(33999, 108, '2015-02-01 00:50:06.000000', 'temperatura', 351.0000, 'ºC'),
	(34000, 108, '2015-02-01 00:50:07.000000', 'temperatura', 886.0000, 'ºC'),
	(34001, 108, '2015-02-01 00:50:08.000000', 'temperatura', 974.0000, 'ºC'),
	(34002, 108, '2015-02-01 00:50:09.000000', 'temperatura', 1014.0000, 'ºC'),
	(34003, 108, '2015-02-01 00:50:10.000000', 'temperatura', 948.0000, 'ºC'),
	(34004, 108, '2015-02-01 00:50:11.000000', 'temperatura', 498.0000, 'ºC'),
	(34005, 108, '2015-02-01 00:50:12.000000', 'temperatura', 847.0000, 'ºC'),
	(34006, 108, '2015-02-01 00:50:13.000000', 'temperatura', 341.0000, 'ºC'),
	(34007, 108, '2015-02-01 00:50:14.000000', 'temperatura', 365.0000, 'ºC'),
	(34008, 108, '2015-02-01 00:50:15.000000', 'temperatura', 803.0000, 'ºC'),
	(34009, 108, '2015-02-01 00:50:16.000000', 'temperatura', 520.0000, 'ºC'),
	(34010, 108, '2015-02-01 00:50:17.000000', 'temperatura', 193.0000, 'ºC'),
	(34011, 108, '2015-02-01 00:50:18.000000', 'temperatura', 605.0000, 'ºC'),
	(34012, 108, '2015-02-01 00:50:19.000000', 'temperatura', 48.0000, 'ºC'),
	(34013, 108, '2015-02-01 00:50:20.000000', 'temperatura', 823.0000, 'ºC'),
	(34014, 108, '2015-02-01 00:50:21.000000', 'temperatura', 374.0000, 'ºC'),
	(34015, 108, '2015-02-01 00:50:22.000000', 'temperatura', 600.0000, 'ºC'),
	(34016, 108, '2015-02-01 00:50:23.000000', 'temperatura', 677.0000, 'ºC'),
	(34017, 108, '2015-02-01 00:50:24.000000', 'temperatura', 387.0000, 'ºC'),
	(34018, 108, '2015-02-01 00:50:25.000000', 'temperatura', 1106.0000, 'ºC'),
	(34019, 108, '2015-02-01 00:50:26.000000', 'temperatura', 770.0000, 'ºC'),
	(34020, 108, '2015-02-01 00:50:27.000000', 'temperatura', 530.0000, 'ºC'),
	(34021, 108, '2015-02-01 00:50:28.000000', 'temperatura', 343.0000, 'ºC'),
	(34022, 108, '2015-02-01 00:50:29.000000', 'temperatura', 124.0000, 'ºC'),
	(34023, 108, '2015-02-01 00:50:30.000000', 'temperatura', 792.0000, 'ºC'),
	(34024, 108, '2015-02-01 00:50:31.000000', 'temperatura', 1186.0000, 'ºC'),
	(34025, 108, '2015-02-01 00:50:32.000000', 'temperatura', 1158.0000, 'ºC'),
	(34026, 108, '2015-02-01 00:50:33.000000', 'temperatura', 1030.0000, 'ºC'),
	(34027, 108, '2015-02-01 00:50:34.000000', 'temperatura', 476.0000, 'ºC'),
	(34028, 108, '2015-02-01 00:50:35.000000', 'temperatura', 490.0000, 'ºC'),
	(34029, 108, '2015-02-01 00:50:36.000000', 'temperatura', 1025.0000, 'ºC'),
	(34030, 108, '2015-02-01 00:50:37.000000', 'temperatura', 52.0000, 'ºC'),
	(34031, 108, '2015-02-01 00:50:38.000000', 'temperatura', 789.0000, 'ºC'),
	(34032, 108, '2015-02-01 00:50:39.000000', 'temperatura', 189.0000, 'ºC'),
	(34033, 108, '2015-02-01 00:50:40.000000', 'temperatura', 978.0000, 'ºC'),
	(34034, 108, '2015-02-01 00:50:41.000000', 'temperatura', 725.0000, 'ºC'),
	(34035, 108, '2015-02-01 00:50:42.000000', 'temperatura', 692.0000, 'ºC'),
	(34036, 108, '2015-02-01 00:50:43.000000', 'temperatura', 83.0000, 'ºC'),
	(34037, 108, '2015-02-01 00:50:44.000000', 'temperatura', 739.0000, 'ºC'),
	(34038, 108, '2015-02-01 00:50:45.000000', 'temperatura', 1049.0000, 'ºC'),
	(34039, 108, '2015-02-01 00:50:46.000000', 'temperatura', 626.0000, 'ºC'),
	(34040, 108, '2015-02-01 00:50:47.000000', 'temperatura', 1184.0000, 'ºC'),
	(34041, 108, '2015-02-01 00:50:48.000000', 'temperatura', 442.0000, 'ºC'),
	(34042, 108, '2015-02-01 00:50:49.000000', 'temperatura', 1060.0000, 'ºC'),
	(34043, 108, '2015-02-01 00:50:50.000000', 'temperatura', 372.0000, 'ºC'),
	(34044, 108, '2015-02-01 00:50:51.000000', 'temperatura', 1081.0000, 'ºC'),
	(34045, 108, '2015-02-01 00:50:52.000000', 'temperatura', 692.0000, 'ºC'),
	(34046, 108, '2015-02-01 00:50:53.000000', 'temperatura', 217.0000, 'ºC'),
	(34047, 108, '2015-02-01 00:50:54.000000', 'temperatura', 207.0000, 'ºC'),
	(34048, 108, '2015-02-01 00:50:55.000000', 'temperatura', 388.0000, 'ºC'),
	(34049, 108, '2015-02-01 00:50:56.000000', 'temperatura', 116.0000, 'ºC'),
	(34050, 108, '2015-02-01 00:50:57.000000', 'temperatura', 620.0000, 'ºC'),
	(34051, 108, '2015-02-01 00:50:58.000000', 'temperatura', 349.0000, 'ºC'),
	(34052, 108, '2015-02-01 00:50:59.000000', 'temperatura', 1089.0000, 'ºC'),
	(34053, 108, '2015-02-01 00:51:00.000000', 'temperatura', 795.0000, 'ºC'),
	(34054, 108, '2015-02-01 00:51:01.000000', 'temperatura', 712.0000, 'ºC'),
	(34055, 108, '2015-02-01 00:51:02.000000', 'temperatura', 1173.0000, 'ºC'),
	(34056, 108, '2015-02-01 00:51:03.000000', 'temperatura', 129.0000, 'ºC'),
	(34057, 108, '2015-02-01 00:51:04.000000', 'temperatura', 726.0000, 'ºC'),
	(34058, 108, '2015-02-01 00:51:05.000000', 'temperatura', 843.0000, 'ºC'),
	(34059, 108, '2015-02-01 00:51:06.000000', 'temperatura', 837.0000, 'ºC'),
	(34060, 108, '2015-02-01 00:51:07.000000', 'temperatura', 459.0000, 'ºC'),
	(34061, 108, '2015-02-01 00:51:08.000000', 'temperatura', 982.0000, 'ºC'),
	(34062, 108, '2015-02-01 00:51:09.000000', 'temperatura', 1133.0000, 'ºC'),
	(34063, 108, '2015-02-01 00:51:10.000000', 'temperatura', 319.0000, 'ºC'),
	(34064, 108, '2015-02-01 00:51:11.000000', 'temperatura', 599.0000, 'ºC'),
	(34065, 108, '2015-02-01 00:51:12.000000', 'temperatura', 836.0000, 'ºC'),
	(34066, 108, '2015-02-01 00:51:13.000000', 'temperatura', 1183.0000, 'ºC'),
	(34067, 108, '2015-02-01 00:51:14.000000', 'temperatura', 1007.0000, 'ºC'),
	(34068, 108, '2015-02-01 00:51:15.000000', 'temperatura', 288.0000, 'ºC'),
	(34069, 108, '2015-02-01 00:51:16.000000', 'temperatura', 817.0000, 'ºC'),
	(34070, 108, '2015-02-01 00:51:17.000000', 'temperatura', 825.0000, 'ºC'),
	(34071, 108, '2015-02-01 00:51:18.000000', 'temperatura', 472.0000, 'ºC'),
	(34072, 108, '2015-02-01 00:51:19.000000', 'temperatura', 1086.0000, 'ºC'),
	(34073, 108, '2015-02-01 00:51:20.000000', 'temperatura', 415.0000, 'ºC'),
	(34074, 108, '2015-02-01 00:51:21.000000', 'temperatura', 15.0000, 'ºC'),
	(34075, 108, '2015-02-01 00:51:22.000000', 'temperatura', 34.0000, 'ºC'),
	(34076, 108, '2015-02-01 00:51:23.000000', 'temperatura', 122.0000, 'ºC'),
	(34077, 108, '2015-02-01 00:51:24.000000', 'temperatura', 511.0000, 'ºC'),
	(34078, 108, '2015-02-01 00:51:25.000000', 'temperatura', 988.0000, 'ºC'),
	(34079, 108, '2015-02-01 00:51:26.000000', 'temperatura', 1010.0000, 'ºC'),
	(34080, 108, '2015-02-01 00:51:27.000000', 'temperatura', 883.0000, 'ºC'),
	(34081, 108, '2015-02-01 00:51:28.000000', 'temperatura', 189.0000, 'ºC'),
	(34082, 108, '2015-02-01 00:51:29.000000', 'temperatura', 695.0000, 'ºC'),
	(34083, 108, '2015-02-01 00:51:30.000000', 'temperatura', 508.0000, 'ºC'),
	(34084, 108, '2015-02-01 00:51:31.000000', 'temperatura', 455.0000, 'ºC'),
	(34085, 108, '2015-02-01 00:51:32.000000', 'temperatura', 754.0000, 'ºC'),
	(34086, 108, '2015-02-01 00:51:33.000000', 'temperatura', 3.0000, 'ºC'),
	(34087, 108, '2015-02-01 00:51:34.000000', 'temperatura', 156.0000, 'ºC'),
	(34088, 108, '2015-02-01 00:51:35.000000', 'temperatura', 770.0000, 'ºC'),
	(34089, 108, '2015-02-01 00:51:36.000000', 'temperatura', 983.0000, 'ºC'),
	(34090, 108, '2015-02-01 00:51:37.000000', 'temperatura', 206.0000, 'ºC'),
	(34091, 108, '2015-02-01 00:51:38.000000', 'temperatura', 483.0000, 'ºC'),
	(34092, 108, '2015-02-01 00:51:39.000000', 'temperatura', 596.0000, 'ºC'),
	(34093, 108, '2015-02-01 00:51:40.000000', 'temperatura', 330.0000, 'ºC'),
	(34094, 108, '2015-02-01 00:51:41.000000', 'temperatura', 1063.0000, 'ºC'),
	(34095, 108, '2015-02-01 00:51:42.000000', 'temperatura', 728.0000, 'ºC'),
	(34096, 108, '2015-02-01 00:51:43.000000', 'temperatura', 450.0000, 'ºC'),
	(34097, 108, '2015-02-01 00:51:44.000000', 'temperatura', 67.0000, 'ºC'),
	(34098, 108, '2015-02-01 00:51:45.000000', 'temperatura', 186.0000, 'ºC'),
	(34099, 108, '2015-02-01 00:51:46.000000', 'temperatura', 731.0000, 'ºC'),
	(34100, 108, '2015-02-01 00:51:47.000000', 'temperatura', 696.0000, 'ºC'),
	(34101, 108, '2015-02-01 00:51:48.000000', 'temperatura', 85.0000, 'ºC'),
	(34102, 108, '2015-02-01 00:51:49.000000', 'temperatura', 741.0000, 'ºC'),
	(34103, 108, '2015-02-01 00:51:50.000000', 'temperatura', 1049.0000, 'ºC'),
	(34104, 108, '2015-02-01 00:51:51.000000', 'temperatura', 623.0000, 'ºC'),
	(34105, 108, '2015-02-01 00:51:52.000000', 'temperatura', 1168.0000, 'ºC'),
	(34106, 108, '2015-02-01 00:51:53.000000', 'temperatura', 373.0000, 'ºC'),
	(34107, 108, '2015-02-01 00:51:54.000000', 'temperatura', 759.0000, 'ºC'),
	(34108, 108, '2015-02-01 00:51:55.000000', 'temperatura', 277.0000, 'ºC'),
	(34109, 108, '2015-02-01 00:51:56.000000', 'temperatura', 311.0000, 'ºC'),
	(34110, 108, '2015-02-01 00:51:57.000000', 'temperatura', 721.0000, 'ºC'),
	(34111, 108, '2015-02-01 00:51:58.000000', 'temperatura', 274.0000, 'ºC'),
	(34112, 108, '2015-02-01 00:51:59.000000', 'temperatura', 408.0000, 'ºC'),
	(34113, 108, '2015-02-01 00:52:00.000000', 'temperatura', 18.0000, 'ºC'),
	(34114, 108, '2015-02-01 00:52:01.000000', 'temperatura', 67.0000, 'ºC'),
	(34115, 108, '2015-02-01 00:52:02.000000', 'temperatura', 281.0000, 'ºC'),
	(34116, 108, '2015-02-01 00:52:03.000000', 'temperatura', 4.0000, 'ºC'),
	(34117, 108, '2015-02-01 00:52:04.000000', 'temperatura', 377.0000, 'ºC'),
	(34118, 108, '2015-02-01 00:52:05.000000', 'temperatura', 674.0000, 'ºC'),
	(34119, 108, '2015-02-01 00:52:06.000000', 'temperatura', 1040.0000, 'ºC'),
	(34120, 108, '2015-02-01 00:52:07.000000', 'temperatura', 780.0000, 'ºC'),
	(34121, 108, '2015-02-01 00:52:08.000000', 'temperatura', 781.0000, 'ºC'),
	(34122, 108, '2015-02-01 00:52:09.000000', 'temperatura', 363.0000, 'ºC'),
	(34123, 108, '2015-02-01 00:52:10.000000', 'temperatura', 675.0000, 'ºC'),
	(34124, 108, '2015-02-01 00:52:11.000000', 'temperatura', 1084.0000, 'ºC'),
	(34125, 108, '2015-02-01 00:52:12.000000', 'temperatura', 996.0000, 'ºC'),
	(34126, 108, '2015-02-01 00:52:13.000000', 'temperatura', 527.0000, 'ºC'),
	(34127, 108, '2015-02-01 00:52:14.000000', 'temperatura', 850.0000, 'ºC'),
	(34128, 108, '2015-02-01 00:52:15.000000', 'temperatura', 270.0000, 'ºC'),
	(34129, 108, '2015-02-01 00:52:16.000000', 'temperatura', 1199.0000, 'ºC'),
	(34130, 108, '2015-02-01 00:52:17.000000', 'temperatura', 387.0000, 'ºC'),
	(34131, 108, '2015-02-01 00:52:18.000000', 'temperatura', 738.0000, 'ºC'),
	(34132, 108, '2015-02-01 00:52:19.000000', 'temperatura', 129.0000, 'ºC'),
	(34133, 108, '2015-02-01 00:52:20.000000', 'temperatura', 834.0000, 'ºC'),
	(34134, 108, '2015-02-01 00:52:21.000000', 'temperatura', 181.0000, 'ºC'),
	(34135, 108, '2015-02-01 00:52:22.000000', 'temperatura', 805.0000, 'ºC'),
	(34136, 108, '2015-02-01 00:52:23.000000', 'temperatura', 1082.0000, 'ºC'),
	(34137, 108, '2015-02-01 00:52:24.000000', 'temperatura', 596.0000, 'ºC'),
	(34138, 108, '2015-02-01 00:52:25.000000', 'temperatura', 933.0000, 'ºC'),
	(34139, 108, '2015-02-01 00:52:26.000000', 'temperatura', 476.0000, 'ºC'),
	(34140, 108, '2015-02-01 00:52:27.000000', 'temperatura', 784.0000, 'ºC'),
	(34141, 108, '2015-02-01 00:52:28.000000', 'temperatura', 92.0000, 'ºC'),
	(34142, 108, '2015-02-01 00:52:29.000000', 'temperatura', 508.0000, 'ºC'),
	(34143, 108, '2015-02-01 00:52:30.000000', 'temperatura', 1067.0000, 'ºC'),
	(34144, 108, '2015-02-01 00:52:31.000000', 'temperatura', 209.0000, 'ºC'),
	(34145, 108, '2015-02-01 00:52:32.000000', 'temperatura', 244.0000, 'ºC'),
	(34146, 108, '2015-02-01 00:52:33.000000', 'temperatura', 595.0000, 'ºC'),
	(34147, 108, '2015-02-01 00:52:34.000000', 'temperatura', 1042.0000, 'ºC'),
	(34148, 108, '2015-02-01 00:52:35.000000', 'temperatura', 1027.0000, 'ºC'),
	(34149, 108, '2015-02-01 00:52:36.000000', 'temperatura', 807.0000, 'ºC'),
	(34150, 108, '2015-02-01 00:52:37.000000', 'temperatura', 956.0000, 'ºC'),
	(34151, 108, '2015-02-01 00:52:38.000000', 'temperatura', 1161.0000, 'ºC'),
	(34152, 108, '2015-02-01 00:52:39.000000', 'temperatura', 534.0000, 'ºC'),
	(34153, 108, '2015-02-01 00:52:40.000000', 'temperatura', 390.0000, 'ºC'),
	(34154, 108, '2015-02-01 00:52:41.000000', 'temperatura', 349.0000, 'ºC'),
	(34155, 108, '2015-02-01 00:52:42.000000', 'temperatura', 576.0000, 'ºC'),
	(34156, 108, '2015-02-01 00:52:43.000000', 'temperatura', 631.0000, 'ºC'),
	(34157, 108, '2015-02-01 00:52:44.000000', 'temperatura', 230.0000, 'ºC'),
	(34158, 108, '2015-02-01 00:52:45.000000', 'temperatura', 457.0000, 'ºC'),
	(34159, 108, '2015-02-01 00:52:46.000000', 'temperatura', 395.0000, 'ºC'),
	(34160, 108, '2015-02-01 00:52:47.000000', 'temperatura', 605.0000, 'ºC'),
	(34161, 108, '2015-02-01 00:52:48.000000', 'temperatura', 640.0000, 'ºC'),
	(34162, 108, '2015-02-01 00:52:49.000000', 'temperatura', 185.0000, 'ºC'),
	(34163, 108, '2015-02-01 00:52:50.000000', 'temperatura', 204.0000, 'ºC'),
	(34164, 108, '2015-02-01 00:52:51.000000', 'temperatura', 466.0000, 'ºC'),
	(34165, 108, '2015-02-01 00:52:52.000000', 'temperatura', 520.0000, 'ºC'),
	(34166, 108, '2015-02-01 00:52:53.000000', 'temperatura', 2.0000, 'ºC'),
	(34167, 108, '2015-02-01 00:52:54.000000', 'temperatura', 848.0000, 'ºC'),
	(34168, 108, '2015-02-01 00:52:55.000000', 'temperatura', 637.0000, 'ºC'),
	(34169, 108, '2015-02-01 00:52:56.000000', 'temperatura', 642.0000, 'ºC'),
	(34170, 108, '2015-02-01 00:52:57.000000', 'temperatura', 101.0000, 'ºC'),
	(34171, 108, '2015-02-01 00:52:58.000000', 'temperatura', 976.0000, 'ºC'),
	(34172, 108, '2015-02-01 00:52:59.000000', 'temperatura', 980.0000, 'ºC'),
	(34173, 108, '2015-02-01 00:53:00.000000', 'temperatura', 770.0000, 'ºC'),
	(34174, 108, '2015-02-01 00:53:01.000000', 'temperatura', 910.0000, 'ºC'),
	(34175, 108, '2015-02-01 00:53:02.000000', 'temperatura', 1044.0000, 'ºC'),
	(34176, 108, '2015-02-01 00:53:03.000000', 'temperatura', 88.0000, 'ºC'),
	(34177, 108, '2015-02-01 00:53:04.000000', 'temperatura', 909.0000, 'ºC'),
	(34178, 108, '2015-02-01 00:53:05.000000', 'temperatura', 683.0000, 'ºC'),
	(34179, 108, '2015-02-01 00:53:06.000000', 'temperatura', 686.0000, 'ºC'),
	(34180, 108, '2015-02-01 00:53:07.000000', 'temperatura', 182.0000, 'ºC'),
	(34181, 108, '2015-02-01 00:53:08.000000', 'temperatura', 54.0000, 'ºC'),
	(34182, 108, '2015-02-01 00:53:09.000000', 'temperatura', 925.0000, 'ºC'),
	(34183, 108, '2015-02-01 00:53:10.000000', 'temperatura', 864.0000, 'ºC'),
	(34184, 108, '2015-02-01 00:53:11.000000', 'temperatura', 345.0000, 'ºC'),
	(34185, 108, '2015-02-01 00:53:12.000000', 'temperatura', 334.0000, 'ºC'),
	(34186, 108, '2015-02-01 00:53:13.000000', 'temperatura', 637.0000, 'ºC'),
	(34187, 108, '2015-02-01 00:53:14.000000', 'temperatura', 980.0000, 'ºC'),
	(34188, 108, '2015-02-01 00:53:15.000000', 'temperatura', 591.0000, 'ºC'),
	(34189, 108, '2015-02-01 00:53:16.000000', 'temperatura', 14.0000, 'ºC'),
	(34190, 108, '2015-02-01 00:53:17.000000', 'temperatura', 698.0000, 'ºC'),
	(34191, 108, '2015-02-01 00:53:18.000000', 'temperatura', 1047.0000, 'ºC'),
	(34192, 108, '2015-02-01 00:53:19.000000', 'temperatura', 742.0000, 'ºC'),
	(34193, 108, '2015-02-01 00:53:20.000000', 'temperatura', 568.0000, 'ºC'),
	(34194, 108, '2015-02-01 00:53:21.000000', 'temperatura', 618.0000, 'ºC'),
	(34195, 108, '2015-02-01 00:53:22.000000', 'temperatura', 184.0000, 'ºC'),
	(34196, 108, '2015-02-01 00:53:23.000000', 'temperatura', 267.0000, 'ºC'),
	(34197, 108, '2015-02-01 00:53:24.000000', 'temperatura', 783.0000, 'ºC'),
	(34198, 108, '2015-02-01 00:53:25.000000', 'temperatura', 715.0000, 'ºC'),
	(34199, 108, '2015-02-01 00:53:26.000000', 'temperatura', 25.0000, 'ºC'),
	(34200, 108, '2015-02-01 00:53:27.000000', 'temperatura', 382.0000, 'ºC'),
	(34201, 108, '2015-02-01 00:53:28.000000', 'temperatura', 637.0000, 'ºC'),
	(34202, 108, '2015-02-01 00:53:29.000000', 'temperatura', 837.0000, 'ºC'),
	(34203, 108, '2015-02-01 00:53:30.000000', 'temperatura', 1075.0000, 'ºC'),
	(34204, 108, '2015-02-01 00:53:31.000000', 'temperatura', 466.0000, 'ºC'),
	(34205, 108, '2015-02-01 00:53:32.000000', 'temperatura', 307.0000, 'ºC'),
	(34206, 108, '2015-02-01 00:53:33.000000', 'temperatura', 135.0000, 'ºC'),
	(34207, 108, '2015-02-01 00:53:34.000000', 'temperatura', 953.0000, 'ºC'),
	(34208, 108, '2015-02-01 00:53:35.000000', 'temperatura', 764.0000, 'ºC'),
	(34209, 108, '2015-02-01 00:53:36.000000', 'temperatura', 958.0000, 'ºC'),
	(34210, 108, '2015-02-01 00:53:37.000000', 'temperatura', 101.0000, 'ºC'),
	(34211, 108, '2015-02-01 00:53:38.000000', 'temperatura', 32.0000, 'ºC'),
	(34212, 108, '2015-02-01 00:53:39.000000', 'temperatura', 1056.0000, 'ºC'),
	(34213, 108, '2015-02-01 00:53:40.000000', 'temperatura', 385.0000, 'ºC'),
	(34214, 108, '2015-02-01 00:53:41.000000', 'temperatura', 1156.0000, 'ºC'),
	(34215, 108, '2015-02-01 00:53:42.000000', 'temperatura', 1024.0000, 'ºC'),
	(34216, 108, '2015-02-01 00:53:43.000000', 'temperatura', 456.0000, 'ºC'),
	(34217, 108, '2015-02-01 00:53:44.000000', 'temperatura', 409.0000, 'ºC'),
	(34218, 108, '2015-02-01 00:53:45.000000', 'temperatura', 675.0000, 'ºC'),
	(34219, 108, '2015-02-01 00:53:46.000000', 'temperatura', 947.0000, 'ºC'),
	(34220, 108, '2015-02-01 00:53:47.000000', 'temperatura', 314.0000, 'ºC'),
	(34221, 108, '2015-02-01 00:53:48.000000', 'temperatura', 1128.0000, 'ºC'),
	(34222, 108, '2015-02-01 00:53:49.000000', 'temperatura', 1097.0000, 'ºC'),
	(34223, 108, '2015-02-01 00:53:50.000000', 'temperatura', 901.0000, 'ºC'),
	(34224, 108, '2015-02-01 00:53:51.000000', 'temperatura', 15.0000, 'ºC'),
	(34225, 108, '2015-02-01 00:53:52.000000', 'temperatura', 972.0000, 'ºC'),
	(34226, 108, '2015-02-01 00:53:53.000000', 'temperatura', 15.0000, 'ºC'),
	(34227, 108, '2015-02-01 00:53:54.000000', 'temperatura', 760.0000, 'ºC'),
	(34228, 108, '2015-02-01 00:53:55.000000', 'temperatura', 155.0000, 'ºC'),
	(34229, 108, '2015-02-01 00:53:56.000000', 'temperatura', 897.0000, 'ºC'),
	(34230, 108, '2015-02-01 00:53:57.000000', 'temperatura', 420.0000, 'ºC'),
	(34231, 108, '2015-02-01 00:53:58.000000', 'temperatura', 609.0000, 'ºC'),
	(34232, 108, '2015-02-01 00:53:59.000000', 'temperatura', 586.0000, 'ºC'),
	(34233, 108, '2015-02-01 00:54:00.000000', 'temperatura', 1102.0000, 'ºC'),
	(34234, 108, '2015-02-01 00:54:01.000000', 'temperatura', 153.0000, 'ºC'),
	(34235, 108, '2015-02-01 00:54:02.000000', 'temperatura', 1060.0000, 'ºC'),
	(34236, 108, '2015-02-01 00:54:03.000000', 'temperatura', 43.0000, 'ºC'),
	(34237, 108, '2015-02-01 00:54:04.000000', 'temperatura', 634.0000, 'ºC'),
	(34238, 108, '2015-02-01 00:54:05.000000', 'temperatura', 641.0000, 'ºC'),
	(34239, 108, '2015-02-01 00:54:06.000000', 'temperatura', 106.0000, 'ºC'),
	(34240, 108, '2015-02-01 00:54:07.000000', 'temperatura', 1007.0000, 'ºC'),
	(34241, 108, '2015-02-01 00:54:08.000000', 'temperatura', 1115.0000, 'ºC'),
	(34242, 108, '2015-02-01 00:54:09.000000', 'temperatura', 158.0000, 'ºC'),
	(34243, 108, '2015-02-01 00:54:10.000000', 'temperatura', 1043.0000, 'ºC'),
	(34244, 108, '2015-02-01 00:54:11.000000', 'temperatura', 1143.0000, 'ºC'),
	(34245, 108, '2015-02-01 00:54:12.000000', 'temperatura', 185.0000, 'ºC'),
	(34246, 108, '2015-02-01 00:54:13.000000', 'temperatura', 1097.0000, 'ºC'),
	(34247, 108, '2015-02-01 00:54:14.000000', 'temperatura', 131.0000, 'ºC'),
	(34248, 108, '2015-02-01 00:54:15.000000', 'temperatura', 966.0000, 'ºC'),
	(34249, 108, '2015-02-01 00:54:16.000000', 'temperatura', 836.0000, 'ºC'),
	(34250, 108, '2015-02-01 00:54:17.000000', 'temperatura', 83.0000, 'ºC'),
	(34251, 108, '2015-02-01 00:54:18.000000', 'temperatura', 306.0000, 'ºC'),
	(34252, 108, '2015-02-01 00:54:19.000000', 'temperatura', 81.0000, 'ºC'),
	(34253, 108, '2015-02-01 00:54:20.000000', 'temperatura', 689.0000, 'ºC'),
	(34254, 108, '2015-02-01 00:54:21.000000', 'temperatura', 800.0000, 'ºC'),
	(34255, 108, '2015-02-01 00:54:22.000000', 'temperatura', 736.0000, 'ºC'),
	(34256, 108, '2015-02-01 00:54:23.000000', 'temperatura', 81.0000, 'ºC'),
	(34257, 108, '2015-02-01 00:54:24.000000', 'temperatura', 597.0000, 'ºC'),
	(34258, 108, '2015-02-01 00:54:25.000000', 'temperatura', 342.0000, 'ºC'),
	(34259, 108, '2015-02-01 00:54:26.000000', 'temperatura', 1119.0000, 'ºC'),
	(34260, 108, '2015-02-01 00:54:27.000000', 'temperatura', 968.0000, 'ºC'),
	(34261, 108, '2015-02-01 00:54:28.000000', 'temperatura', 285.0000, 'ºC'),
	(34262, 108, '2015-02-01 00:54:29.000000', 'temperatura', 921.0000, 'ºC'),
	(34263, 108, '2015-02-01 00:54:30.000000', 'temperatura', 149.0000, 'ºC'),
	(34264, 108, '2015-02-01 00:54:31.000000', 'temperatura', 384.0000, 'ºC'),
	(34265, 108, '2015-02-01 00:54:32.000000', 'temperatura', 274.0000, 'ºC'),
	(34266, 108, '2015-02-01 00:54:33.000000', 'temperatura', 216.0000, 'ºC'),
	(34267, 108, '2015-02-01 00:54:34.000000', 'temperatura', 261.0000, 'ºC'),
	(34268, 108, '2015-02-01 00:54:35.000000', 'temperatura', 655.0000, 'ºC'),
	(34269, 108, '2015-02-01 00:54:36.000000', 'temperatura', 93.0000, 'ºC'),
	(34270, 108, '2015-02-01 00:54:37.000000', 'temperatura', 899.0000, 'ºC'),
	(34271, 108, '2015-02-01 00:54:38.000000', 'temperatura', 620.0000, 'ºC'),
	(34272, 108, '2015-02-01 00:54:39.000000', 'temperatura', 402.0000, 'ºC'),
	(34273, 108, '2015-02-01 00:54:40.000000', 'temperatura', 150.0000, 'ºC'),
	(34274, 108, '2015-02-01 00:54:41.000000', 'temperatura', 746.0000, 'ºC'),
	(34275, 108, '2015-02-01 00:54:42.000000', 'temperatura', 878.0000, 'ºC'),
	(34276, 108, '2015-02-01 00:54:43.000000', 'temperatura', 954.0000, 'ºC'),
	(34277, 108, '2015-02-01 00:54:44.000000', 'temperatura', 937.0000, 'ºC'),
	(34278, 108, '2015-02-01 00:54:45.000000', 'temperatura', 621.0000, 'ºC'),
	(34279, 108, '2015-02-01 00:54:46.000000', 'temperatura', 298.0000, 'ºC'),
	(34280, 108, '2015-02-01 00:54:47.000000', 'temperatura', 824.0000, 'ºC'),
	(34281, 108, '2015-02-01 00:54:48.000000', 'temperatura', 829.0000, 'ºC'),
	(34282, 108, '2015-02-01 00:54:49.000000', 'temperatura', 471.0000, 'ºC'),
	(34283, 108, '2015-02-01 00:54:50.000000', 'temperatura', 1068.0000, 'ºC'),
	(34284, 108, '2015-02-01 00:54:51.000000', 'temperatura', 331.0000, 'ºC'),
	(34285, 108, '2015-02-01 00:54:52.000000', 'temperatura', 848.0000, 'ºC'),
	(34286, 108, '2015-02-01 00:54:53.000000', 'temperatura', 850.0000, 'ºC'),
	(34287, 108, '2015-02-01 00:54:54.000000', 'temperatura', 504.0000, 'ºC'),
	(34288, 108, '2015-02-01 00:54:55.000000', 'temperatura', 1173.0000, 'ºC'),
	(34289, 108, '2015-02-01 00:54:56.000000', 'temperatura', 753.0000, 'ºC'),
	(34290, 108, '2015-02-01 00:54:57.000000', 'temperatura', 246.0000, 'ºC'),
	(34291, 108, '2015-02-01 00:54:58.000000', 'temperatura', 171.0000, 'ºC'),
	(34292, 108, '2015-02-01 00:54:59.000000', 'temperatura', 118.0000, 'ºC'),
	(34293, 108, '2015-02-01 00:55:00.000000', 'temperatura', 78.0000, 'ºC'),
	(34294, 108, '2015-02-01 00:55:01.000000', 'temperatura', 38.0000, 'ºC'),
	(34295, 108, '2015-02-01 00:55:02.000000', 'temperatura', 1154.0000, 'ºC'),
	(34296, 108, '2015-02-01 00:55:03.000000', 'temperatura', 856.0000, 'ºC'),
	(34297, 108, '2015-02-01 00:55:04.000000', 'temperatura', 821.0000, 'ºC'),
	(34298, 108, '2015-02-01 00:55:05.000000', 'temperatura', 335.0000, 'ºC'),
	(34299, 108, '2015-02-01 00:55:06.000000', 'temperatura', 414.0000, 'ºC'),
	(34300, 108, '2015-02-01 00:55:07.000000', 'temperatura', 1065.0000, 'ºC'),
	(34301, 108, '2015-02-01 00:55:08.000000', 'temperatura', 482.0000, 'ºC'),
	(34302, 108, '2015-02-01 00:55:09.000000', 'temperatura', 416.0000, 'ºC'),
	(34303, 108, '2015-02-01 00:55:10.000000', 'temperatura', 636.0000, 'ºC'),
	(34304, 108, '2015-02-01 00:55:11.000000', 'temperatura', 734.0000, 'ºC'),
	(34305, 108, '2015-02-01 00:55:12.000000', 'temperatura', 560.0000, 'ºC'),
	(34306, 108, '2015-02-01 00:55:13.000000', 'temperatura', 600.0000, 'ºC'),
	(34307, 108, '2015-02-01 00:55:14.000000', 'temperatura', 119.0000, 'ºC'),
	(34308, 108, '2015-02-01 00:55:15.000000', 'temperatura', 1195.0000, 'ºC'),
	(34309, 108, '2015-02-01 00:55:16.000000', 'temperatura', 819.0000, 'ºC'),
	(34310, 108, '2015-02-01 00:55:17.000000', 'temperatura', 509.0000, 'ºC'),
	(34311, 108, '2015-02-01 00:55:18.000000', 'temperatura', 90.0000, 'ºC'),
	(34312, 108, '2015-02-01 00:55:19.000000', 'temperatura', 121.0000, 'ºC'),
	(34313, 108, '2015-02-01 00:55:20.000000', 'temperatura', 338.0000, 'ºC'),
	(34314, 108, '2015-02-01 00:55:21.000000', 'temperatura', 126.0000, 'ºC'),
	(34315, 108, '2015-02-01 00:55:22.000000', 'temperatura', 818.0000, 'ºC'),
	(34316, 108, '2015-02-01 00:55:23.000000', 'temperatura', 114.0000, 'ºC'),
	(34317, 108, '2015-02-01 00:55:24.000000', 'temperatura', 515.0000, 'ºC'),
	(34318, 108, '2015-02-01 00:55:25.000000', 'temperatura', 1034.0000, 'ºC'),
	(34319, 108, '2015-02-01 00:55:26.000000', 'temperatura', 24.0000, 'ºC'),
	(34320, 108, '2015-02-01 00:55:27.000000', 'temperatura', 621.0000, 'ºC'),
	(34321, 108, '2015-02-01 00:55:28.000000', 'temperatura', 633.0000, 'ºC'),
	(34322, 108, '2015-02-01 00:55:29.000000', 'temperatura', 102.0000, 'ºC'),
	(34323, 108, '2015-02-01 00:55:30.000000', 'temperatura', 1011.0000, 'ºC'),
	(34324, 108, '2015-02-01 00:55:31.000000', 'temperatura', 1149.0000, 'ºC'),
	(34325, 108, '2015-02-01 00:55:32.000000', 'temperatura', 312.0000, 'ºC'),
	(34326, 108, '2015-02-01 00:55:33.000000', 'temperatura', 514.0000, 'ºC'),
	(34327, 108, '2015-02-01 00:55:34.000000', 'temperatura', 436.0000, 'ºC'),
	(34328, 108, '2015-02-01 00:55:35.000000', 'temperatura', 637.0000, 'ºC'),
	(34329, 108, '2015-02-01 00:55:36.000000', 'temperatura', 677.0000, 'ºC'),
	(34330, 108, '2015-02-01 00:55:37.000000', 'temperatura', 277.0000, 'ºC'),
	(34331, 108, '2015-02-01 00:55:38.000000', 'temperatura', 553.0000, 'ºC'),
	(34332, 108, '2015-02-01 00:55:39.000000', 'temperatura', 734.0000, 'ºC'),
	(34333, 108, '2015-02-01 00:55:40.000000', 'temperatura', 810.0000, 'ºC'),
	(34334, 108, '2015-02-01 00:55:41.000000', 'temperatura', 650.0000, 'ºC'),
	(34335, 108, '2015-02-01 00:55:42.000000', 'temperatura', 821.0000, 'ºC'),
	(34336, 108, '2015-02-01 00:55:43.000000', 'temperatura', 953.0000, 'ºC'),
	(34337, 108, '2015-02-01 00:55:44.000000', 'temperatura', 1105.0000, 'ºC'),
	(34338, 108, '2015-02-01 00:55:45.000000', 'temperatura', 266.0000, 'ºC'),
	(34339, 108, '2015-02-01 00:55:46.000000', 'temperatura', 413.0000, 'ºC'),
	(34340, 108, '2015-02-01 00:55:47.000000', 'temperatura', 70.0000, 'ºC'),
	(34341, 108, '2015-02-01 00:55:48.000000', 'temperatura', 312.0000, 'ºC'),
	(34342, 108, '2015-02-01 00:55:49.000000', 'temperatura', 148.0000, 'ºC'),
	(34343, 108, '2015-02-01 00:55:50.000000', 'temperatura', 1008.0000, 'ºC'),
	(34344, 108, '2015-02-01 00:55:51.000000', 'temperatura', 993.0000, 'ºC'),
	(34345, 108, '2015-02-01 00:55:52.000000', 'temperatura', 743.0000, 'ºC'),
	(34346, 108, '2015-02-01 00:55:53.000000', 'temperatura', 737.0000, 'ºC'),
	(34347, 108, '2015-02-01 00:55:54.000000', 'temperatura', 255.0000, 'ºC'),
	(34348, 108, '2015-02-01 00:55:55.000000', 'temperatura', 266.0000, 'ºC'),
	(34349, 108, '2015-02-01 00:55:56.000000', 'temperatura', 567.0000, 'ºC'),
	(34350, 108, '2015-02-01 00:55:57.000000', 'temperatura', 836.0000, 'ºC'),
	(34351, 108, '2015-02-01 00:55:58.000000', 'temperatura', 79.0000, 'ºC'),
	(34352, 108, '2015-02-01 00:55:59.000000', 'temperatura', 288.0000, 'ºC'),
	(34353, 108, '2015-02-01 00:56:00.000000', 'temperatura', 6.0000, 'ºC'),
	(34354, 108, '2015-02-01 00:56:01.000000', 'temperatura', 363.0000, 'ºC'),
	(34355, 108, '2015-02-01 00:56:02.000000', 'temperatura', 597.0000, 'ºC'),
	(34356, 108, '2015-02-01 00:56:03.000000', 'temperatura', 697.0000, 'ºC'),
	(34357, 108, '2015-02-01 00:56:04.000000', 'temperatura', 497.0000, 'ºC'),
	(34358, 108, '2015-02-01 00:56:05.000000', 'temperatura', 392.0000, 'ºC'),
	(34359, 108, '2015-02-01 00:56:06.000000', 'temperatura', 470.0000, 'ºC'),
	(34360, 108, '2015-02-01 00:56:07.000000', 'temperatura', 1175.0000, 'ºC'),
	(34361, 108, '2015-02-01 00:56:08.000000', 'temperatura', 865.0000, 'ºC'),
	(34362, 108, '2015-02-01 00:56:09.000000', 'temperatura', 802.0000, 'ºC'),
	(34363, 108, '2015-02-01 00:56:10.000000', 'temperatura', 214.0000, 'ºC'),
	(34364, 108, '2015-02-01 00:56:11.000000', 'temperatura', 1066.0000, 'ºC'),
	(34365, 108, '2015-02-01 00:56:12.000000', 'temperatura', 1088.0000, 'ºC'),
	(34366, 108, '2015-02-01 00:56:13.000000', 'temperatura', 1041.0000, 'ºC'),
	(34367, 108, '2015-02-01 00:56:14.000000', 'temperatura', 743.0000, 'ºC'),
	(34368, 108, '2015-02-01 00:56:15.000000', 'temperatura', 593.0000, 'ºC'),
	(34369, 108, '2015-02-01 00:56:16.000000', 'temperatura', 734.0000, 'ºC'),
	(34370, 108, '2015-02-01 00:56:17.000000', 'temperatura', 692.0000, 'ºC'),
	(34371, 108, '2015-02-01 00:56:18.000000', 'temperatura', 60.0000, 'ºC'),
	(34372, 108, '2015-02-01 00:56:19.000000', 'temperatura', 626.0000, 'ºC'),
	(34373, 108, '2015-02-01 00:56:20.000000', 'temperatura', 548.0000, 'ºC'),
	(34374, 108, '2015-02-01 00:56:21.000000', 'temperatura', 864.0000, 'ºC'),
	(34375, 108, '2015-02-01 00:56:22.000000', 'temperatura', 275.0000, 'ºC'),
	(34376, 108, '2015-02-01 00:56:23.000000', 'temperatura', 1183.0000, 'ºC'),
	(34377, 108, '2015-02-01 00:56:24.000000', 'temperatura', 293.0000, 'ºC'),
	(34378, 108, '2015-02-01 00:56:25.000000', 'temperatura', 316.0000, 'ºC'),
	(34379, 108, '2015-02-01 00:56:26.000000', 'temperatura', 701.0000, 'ºC'),
	(34380, 108, '2015-02-01 00:56:27.000000', 'temperatura', 159.0000, 'ºC'),
	(34381, 108, '2015-02-01 00:56:28.000000', 'temperatura', 1093.0000, 'ºC'),
	(34382, 108, '2015-02-01 00:56:29.000000', 'temperatura', 186.0000, 'ºC'),
	(34383, 108, '2015-02-01 00:56:30.000000', 'temperatura', 53.0000, 'ºC'),
	(34384, 108, '2015-02-01 00:56:31.000000', 'temperatura', 906.0000, 'ºC'),
	(34385, 108, '2015-02-01 00:56:32.000000', 'temperatura', 774.0000, 'ºC'),
	(34386, 108, '2015-02-01 00:56:33.000000', 'temperatura', 1151.0000, 'ºC'),
	(34387, 108, '2015-02-01 00:56:34.000000', 'temperatura', 1032.0000, 'ºC'),
	(34388, 108, '2015-02-01 00:56:35.000000', 'temperatura', 508.0000, 'ºC'),
	(34389, 108, '2015-02-01 00:56:36.000000', 'temperatura', 644.0000, 'ºC'),
	(34390, 108, '2015-02-01 00:56:37.000000', 'temperatura', 496.0000, 'ºC'),
	(34391, 108, '2015-02-01 00:56:38.000000', 'temperatura', 549.0000, 'ºC'),
	(34392, 108, '2015-02-01 00:56:39.000000', 'temperatura', 57.0000, 'ºC'),
	(34393, 108, '2015-02-01 00:56:40.000000', 'temperatura', 1038.0000, 'ºC'),
	(34394, 108, '2015-02-01 00:56:41.000000', 'temperatura', 220.0000, 'ºC'),
	(34395, 108, '2015-02-01 00:56:42.000000', 'temperatura', 388.0000, 'ºC'),
	(34396, 108, '2015-02-01 00:56:43.000000', 'temperatura', 79.0000, 'ºC'),
	(34397, 108, '2015-02-01 00:56:44.000000', 'temperatura', 432.0000, 'ºC'),
	(34398, 108, '2015-02-01 00:56:45.000000', 'temperatura', 722.0000, 'ºC'),
	(34399, 108, '2015-02-01 00:56:46.000000', 'temperatura', 1115.0000, 'ºC'),
	(34400, 108, '2015-02-01 00:56:47.000000', 'temperatura', 1008.0000, 'ºC'),
	(34401, 108, '2015-02-01 00:56:48.000000', 'temperatura', 497.0000, 'ºC'),
	(34402, 108, '2015-02-01 00:56:49.000000', 'temperatura', 663.0000, 'ºC'),
	(34403, 108, '2015-02-01 00:56:50.000000', 'temperatura', 622.0000, 'ºC'),
	(34404, 108, '2015-02-01 00:56:51.000000', 'temperatura', 1122.0000, 'ºC'),
	(34405, 108, '2015-02-01 00:56:52.000000', 'temperatura', 143.0000, 'ºC'),
	(34406, 108, '2015-02-01 00:56:53.000000', 'temperatura', 951.0000, 'ºC'),
	(34407, 108, '2015-02-01 00:56:54.000000', 'temperatura', 727.0000, 'ºC'),
	(34408, 108, '2015-02-01 00:56:55.000000', 'temperatura', 781.0000, 'ºC'),
	(34409, 108, '2015-02-01 00:56:56.000000', 'temperatura', 526.0000, 'ºC'),
	(34410, 108, '2015-02-01 00:56:57.000000', 'temperatura', 289.0000, 'ºC'),
	(34411, 108, '2015-02-01 00:56:58.000000', 'temperatura', 1067.0000, 'ºC'),
	(34412, 108, '2015-02-01 00:56:59.000000', 'temperatura', 866.0000, 'ºC'),
	(34413, 108, '2015-02-01 00:57:00.000000', 'temperatura', 1130.0000, 'ºC'),
	(34414, 108, '2015-02-01 00:57:01.000000', 'temperatura', 653.0000, 'ºC'),
	(34415, 108, '2015-02-01 00:57:02.000000', 'temperatura', 1077.0000, 'ºC'),
	(34416, 108, '2015-02-01 00:57:03.000000', 'temperatura', 1024.0000, 'ºC'),
	(34417, 108, '2015-02-01 00:57:04.000000', 'temperatura', 689.0000, 'ºC'),
	(34418, 108, '2015-02-01 00:57:05.000000', 'temperatura', 374.0000, 'ºC'),
	(34419, 108, '2015-02-01 00:57:06.000000', 'temperatura', 1006.0000, 'ºC'),
	(34420, 108, '2015-02-01 00:57:07.000000', 'temperatura', 305.0000, 'ºC'),
	(34421, 108, '2015-02-01 00:57:08.000000', 'temperatura', 910.0000, 'ºC'),
	(34422, 108, '2015-02-01 00:57:09.000000', 'temperatura', 33.0000, 'ºC'),
	(34423, 108, '2015-02-01 00:57:10.000000', 'temperatura', 1037.0000, 'ºC'),
	(34424, 108, '2015-02-01 00:57:11.000000', 'temperatura', 284.0000, 'ºC'),
	(34425, 108, '2015-02-01 00:57:12.000000', 'temperatura', 713.0000, 'ºC'),
	(34426, 108, '2015-02-01 00:57:13.000000', 'temperatura', 311.0000, 'ºC'),
	(34427, 108, '2015-02-01 00:57:14.000000', 'temperatura', 618.0000, 'ºC'),
	(34428, 108, '2015-02-01 00:57:15.000000', 'temperatura', 957.0000, 'ºC'),
	(34429, 108, '2015-02-01 00:57:16.000000', 'temperatura', 533.0000, 'ºC'),
	(34430, 108, '2015-02-01 00:57:17.000000', 'temperatura', 993.0000, 'ºC'),
	(34431, 108, '2015-02-01 00:57:18.000000', 'temperatura', 967.0000, 'ºC'),
	(34432, 108, '2015-02-01 00:57:19.000000', 'temperatura', 657.0000, 'ºC'),
	(34433, 108, '2015-02-01 00:57:20.000000', 'temperatura', 385.0000, 'ºC'),
	(34434, 108, '2015-02-01 00:57:21.000000', 'temperatura', 1154.0000, 'ºC'),
	(34435, 108, '2015-02-01 00:57:22.000000', 'temperatura', 1015.0000, 'ºC'),
	(34436, 108, '2015-02-01 00:57:23.000000', 'temperatura', 414.0000, 'ºC'),
	(34437, 108, '2015-02-01 00:57:24.000000', 'temperatura', 224.0000, 'ºC'),
	(34438, 108, '2015-02-01 00:57:25.000000', 'temperatura', 1081.0000, 'ºC'),
	(34439, 108, '2015-02-01 00:57:26.000000', 'temperatura', 1131.0000, 'ºC'),
	(34440, 108, '2015-02-01 00:57:27.000000', 'temperatura', 12.0000, 'ºC'),
	(34441, 108, '2015-02-01 00:57:28.000000', 'temperatura', 270.0000, 'ºC'),
	(34442, 108, '2015-02-01 00:57:29.000000', 'temperatura', 115.0000, 'ºC'),
	(34443, 108, '2015-02-01 00:57:30.000000', 'temperatura', 964.0000, 'ºC'),
	(34444, 108, '2015-02-01 00:57:31.000000', 'temperatura', 878.0000, 'ºC'),
	(34445, 108, '2015-02-01 00:57:32.000000', 'temperatura', 296.0000, 'ºC'),
	(34446, 108, '2015-02-01 00:57:33.000000', 'temperatura', 46.0000, 'ºC'),
	(34447, 108, '2015-02-01 00:57:34.000000', 'temperatura', 545.0000, 'ºC'),
	(34448, 108, '2015-02-01 00:57:35.000000', 'temperatura', 187.0000, 'ºC'),
	(34449, 108, '2015-02-01 00:57:36.000000', 'temperatura', 502.0000, 'ºC'),
	(34450, 108, '2015-02-01 00:57:37.000000', 'temperatura', 748.0000, 'ºC'),
	(34451, 108, '2015-02-01 00:57:38.000000', 'temperatura', 1034.0000, 'ºC'),
	(34452, 108, '2015-02-01 00:57:39.000000', 'temperatura', 526.0000, 'ºC'),
	(34453, 108, '2015-02-01 00:57:40.000000', 'temperatura', 728.0000, 'ºC'),
	(34454, 108, '2015-02-01 00:57:41.000000', 'temperatura', 862.0000, 'ºC'),
	(34455, 108, '2015-02-01 00:57:42.000000', 'temperatura', 928.0000, 'ºC'),
	(34456, 108, '2015-02-01 00:57:43.000000', 'temperatura', 852.0000, 'ºC'),
	(34457, 108, '2015-02-01 00:57:44.000000', 'temperatura', 279.0000, 'ºC'),
	(34458, 108, '2015-02-01 00:57:45.000000', 'temperatura', 40.0000, 'ºC'),
	(34459, 108, '2015-02-01 00:57:46.000000', 'temperatura', 561.0000, 'ºC'),
	(34460, 108, '2015-02-01 00:57:47.000000', 'temperatura', 289.0000, 'ºC'),
	(34461, 108, '2015-02-01 00:57:48.000000', 'temperatura', 959.0000, 'ºC'),
	(34462, 108, '2015-02-01 00:57:49.000000', 'temperatura', 331.0000, 'ºC'),
	(34463, 108, '2015-02-01 00:57:50.000000', 'temperatura', 1179.0000, 'ºC'),
	(34464, 108, '2015-02-01 00:57:51.000000', 'temperatura', 101.0000, 'ºC'),
	(34465, 108, '2015-02-01 00:57:52.000000', 'temperatura', 567.0000, 'ºC'),
	(34466, 108, '2015-02-01 00:57:53.000000', 'temperatura', 136.0000, 'ºC'),
	(34467, 108, '2015-02-01 00:57:54.000000', 'temperatura', 177.0000, 'ºC'),
	(34468, 108, '2015-02-01 00:57:55.000000', 'temperatura', 477.0000, 'ºC'),
	(34469, 108, '2015-02-01 00:57:56.000000', 'temperatura', 657.0000, 'ºC'),
	(34470, 108, '2015-02-01 00:57:57.000000', 'temperatura', 652.0000, 'ºC'),
	(34471, 108, '2015-02-01 00:57:58.000000', 'temperatura', 89.0000, 'ºC'),
	(34472, 108, '2015-02-01 00:57:59.000000', 'temperatura', 890.0000, 'ºC'),
	(34473, 108, '2015-02-01 00:58:00.000000', 'temperatura', 584.0000, 'ºC'),
	(34474, 108, '2015-02-01 00:58:01.000000', 'temperatura', 250.0000, 'ºC'),
	(34475, 108, '2015-02-01 00:58:02.000000', 'temperatura', 698.0000, 'ºC'),
	(34476, 108, '2015-02-01 00:58:03.000000', 'temperatura', 341.0000, 'ºC'),
	(34477, 108, '2015-02-01 00:58:04.000000', 'temperatura', 810.0000, 'ºC'),
	(34478, 108, '2015-02-01 00:58:05.000000', 'temperatura', 627.0000, 'ºC'),
	(34479, 108, '2015-02-01 00:58:06.000000', 'temperatura', 707.0000, 'ºC'),
	(34480, 108, '2015-02-01 00:58:07.000000', 'temperatura', 454.0000, 'ºC'),
	(34481, 108, '2015-02-01 00:58:08.000000', 'temperatura', 148.0000, 'ºC'),
	(34482, 108, '2015-02-01 00:58:09.000000', 'temperatura', 580.0000, 'ºC'),
	(34483, 108, '2015-02-01 00:58:10.000000', 'temperatura', 56.0000, 'ºC'),
	(34484, 108, '2015-02-01 00:58:11.000000', 'temperatura', 943.0000, 'ºC'),
	(34485, 108, '2015-02-01 00:58:12.000000', 'temperatura', 945.0000, 'ºC'),
	(34486, 108, '2015-02-01 00:58:13.000000', 'temperatura', 696.0000, 'ºC'),
	(34487, 108, '2015-02-01 00:58:14.000000', 'temperatura', 645.0000, 'ºC'),
	(34488, 108, '2015-02-01 00:58:15.000000', 'temperatura', 1140.0000, 'ºC'),
	(34489, 108, '2015-02-01 00:58:16.000000', 'temperatura', 166.0000, 'ºC'),
	(34490, 108, '2015-02-01 00:58:17.000000', 'temperatura', 1011.0000, 'ºC'),
	(34491, 108, '2015-02-01 00:58:18.000000', 'temperatura', 958.0000, 'ºC'),
	(34492, 108, '2015-02-01 00:58:19.000000', 'temperatura', 557.0000, 'ºC'),
	(34493, 108, '2015-02-01 00:58:20.000000', 'temperatura', 1113.0000, 'ºC'),
	(34494, 108, '2015-02-01 00:58:21.000000', 'temperatura', 294.0000, 'ºC'),
	(34495, 108, '2015-02-01 00:58:22.000000', 'temperatura', 530.0000, 'ºC'),
	(34496, 108, '2015-02-01 00:58:23.000000', 'temperatura', 568.0000, 'ºC'),
	(34497, 108, '2015-02-01 00:58:24.000000', 'temperatura', 53.0000, 'ºC'),
	(34498, 108, '2015-02-01 00:58:25.000000', 'temperatura', 961.0000, 'ºC'),
	(34499, 108, '2015-02-01 00:58:26.000000', 'temperatura', 1046.0000, 'ºC'),
	(34500, 108, '2015-02-01 00:58:27.000000', 'temperatura', 1149.0000, 'ºC'),
	(34501, 108, '2015-02-01 00:58:28.000000', 'temperatura', 205.0000, 'ºC'),
	(34502, 108, '2015-02-01 00:58:29.000000', 'temperatura', 1178.0000, 'ºC'),
	(34503, 108, '2015-02-01 00:58:30.000000', 'temperatura', 475.0000, 'ºC'),
	(34504, 108, '2015-02-01 00:58:31.000000', 'temperatura', 44.0000, 'ºC'),
	(34505, 108, '2015-02-01 00:58:32.000000', 'temperatura', 1193.0000, 'ºC'),
	(34506, 108, '2015-02-01 00:58:33.000000', 'temperatura', 1035.0000, 'ºC'),
	(34507, 108, '2015-02-01 00:58:34.000000', 'temperatura', 396.0000, 'ºC'),
	(34508, 108, '2015-02-01 00:58:35.000000', 'temperatura', 75.0000, 'ºC'),
	(34509, 108, '2015-02-01 00:58:36.000000', 'temperatura', 387.0000, 'ºC'),
	(34510, 108, '2015-02-01 00:58:37.000000', 'temperatura', 512.0000, 'ºC'),
	(34511, 108, '2015-02-01 00:58:38.000000', 'temperatura', 200.0000, 'ºC'),
	(34512, 108, '2015-02-01 00:58:39.000000', 'temperatura', 666.0000, 'ºC'),
	(34513, 108, '2015-02-01 00:58:40.000000', 'temperatura', 327.0000, 'ºC'),
	(34514, 108, '2015-02-01 00:58:41.000000', 'temperatura', 838.0000, 'ºC'),
	(34515, 108, '2015-02-01 00:58:42.000000', 'temperatura', 810.0000, 'ºC'),
	(34516, 108, '2015-02-01 00:58:43.000000', 'temperatura', 335.0000, 'ºC'),
	(34517, 108, '2015-02-01 00:58:44.000000', 'temperatura', 447.0000, 'ºC'),
	(34518, 108, '2015-02-01 00:58:45.000000', 'temperatura', 32.0000, 'ºC'),
	(34519, 108, '2015-02-01 00:58:46.000000', 'temperatura', 18.0000, 'ºC'),
	(34520, 108, '2015-02-01 00:58:47.000000', 'temperatura', 1196.0000, 'ºC'),
	(34521, 108, '2015-02-01 00:58:48.000000', 'temperatura', 1126.0000, 'ºC'),
	(34522, 108, '2015-02-01 00:58:49.000000', 'temperatura', 840.0000, 'ºC'),
	(34523, 108, '2015-02-01 00:58:50.000000', 'temperatura', 825.0000, 'ºC'),
	(34524, 108, '2015-02-01 00:58:51.000000', 'temperatura', 404.0000, 'ºC'),
	(34525, 108, '2015-02-01 00:58:52.000000', 'temperatura', 747.0000, 'ºC'),
	(34526, 108, '2015-02-01 00:58:53.000000', 'temperatura', 123.0000, 'ºC'),
	(34527, 108, '2015-02-01 00:58:54.000000', 'temperatura', 774.0000, 'ºC'),
	(34528, 108, '2015-02-01 00:58:55.000000', 'temperatura', 1102.0000, 'ºC'),
	(34529, 108, '2015-02-01 00:58:56.000000', 'temperatura', 790.0000, 'ºC'),
	(34530, 108, '2015-02-01 00:58:57.000000', 'temperatura', 642.0000, 'ºC'),
	(34531, 108, '2015-02-01 00:58:58.000000', 'temperatura', 841.0000, 'ºC'),
	(34532, 108, '2015-02-01 00:58:59.000000', 'temperatura', 1081.0000, 'ºC'),
	(34533, 108, '2015-02-01 00:59:00.000000', 'temperatura', 481.0000, 'ºC'),
	(34534, 108, '2015-02-01 00:59:01.000000', 'temperatura', 363.0000, 'ºC'),
	(34535, 108, '2015-02-01 00:59:02.000000', 'temperatura', 374.0000, 'ºC'),
	(34536, 108, '2015-02-01 00:59:03.000000', 'temperatura', 781.0000, 'ºC'),
	(34537, 108, '2015-02-01 00:59:04.000000', 'temperatura', 384.0000, 'ºC'),
	(34538, 108, '2015-02-01 00:59:05.000000', 'temperatura', 775.0000, 'ºC'),
	(34539, 108, '2015-02-01 00:59:06.000000', 'temperatura', 325.0000, 'ºC'),
	(34540, 108, '2015-02-01 00:59:07.000000', 'temperatura', 502.0000, 'ºC'),
	(34541, 108, '2015-02-01 00:59:08.000000', 'temperatura', 335.0000, 'ºC'),
	(34542, 108, '2015-02-01 00:59:09.000000', 'temperatura', 167.0000, 'ºC'),
	(34543, 108, '2015-02-01 00:59:10.000000', 'temperatura', 1034.0000, 'ºC'),
	(34544, 108, '2015-02-01 00:59:11.000000', 'temperatura', 1068.0000, 'ºC'),
	(34545, 108, '2015-02-01 00:59:12.000000', 'temperatura', 1040.0000, 'ºC'),
	(34546, 108, '2015-02-01 00:59:13.000000', 'temperatura', 795.0000, 'ºC'),
	(34547, 108, '2015-02-01 00:59:14.000000', 'temperatura', 854.0000, 'ºC'),
	(34548, 108, '2015-02-01 00:59:15.000000', 'temperatura', 687.0000, 'ºC'),
	(34549, 108, '2015-02-01 00:59:16.000000', 'temperatura', 874.0000, 'ºC'),
	(34550, 108, '2015-02-01 00:59:17.000000', 'temperatura', 1110.0000, 'ºC'),
	(34551, 108, '2015-02-01 00:59:18.000000', 'temperatura', 530.0000, 'ºC'),
	(34552, 108, '2015-02-01 00:59:19.000000', 'temperatura', 518.0000, 'ºC'),
	(34553, 108, '2015-02-01 00:59:20.000000', 'temperatura', 1002.0000, 'ºC'),
	(34554, 108, '2015-02-01 00:59:21.000000', 'temperatura', 1057.0000, 'ºC'),
	(34555, 108, '2015-02-01 00:59:22.000000', 'temperatura', 1077.0000, 'ºC'),
	(34556, 108, '2015-02-01 00:59:23.000000', 'temperatura', 1017.0000, 'ºC'),
	(34557, 108, '2015-02-01 00:59:24.000000', 'temperatura', 655.0000, 'ºC'),
	(34558, 108, '2015-02-01 00:59:25.000000', 'temperatura', 225.0000, 'ºC'),
	(34559, 108, '2015-02-01 00:59:26.000000', 'temperatura', 362.0000, 'ºC'),
	(34560, 108, '2015-02-01 00:59:27.000000', 'temperatura', 1132.0000, 'ºC'),
	(34561, 108, '2015-02-01 00:59:28.000000', 'temperatura', 975.0000, 'ºC'),
	(34562, 108, '2015-02-01 00:59:29.000000', 'temperatura', 280.0000, 'ºC'),
	(34563, 108, '2015-02-01 00:59:30.000000', 'temperatura', 874.0000, 'ºC'),
	(34564, 108, '2015-02-01 00:59:31.000000', 'temperatura', 1132.0000, 'ºC'),
	(34565, 108, '2015-02-01 00:59:32.000000', 'temperatura', 639.0000, 'ºC'),
	(34566, 108, '2015-02-01 00:59:33.000000', 'temperatura', 1000.0000, 'ºC'),
	(34567, 108, '2015-02-01 00:59:34.000000', 'temperatura', 682.0000, 'ºC'),
	(34568, 108, '2015-02-01 00:59:35.000000', 'temperatura', 413.0000, 'ºC'),
	(34569, 108, '2015-02-01 00:59:36.000000', 'temperatura', 18.0000, 'ºC'),
	(34570, 108, '2015-02-01 00:59:37.000000', 'temperatura', 50.0000, 'ºC'),
	(34571, 108, '2015-02-01 00:59:38.000000', 'temperatura', 197.0000, 'ºC'),
	(34572, 108, '2015-02-01 00:59:39.000000', 'temperatura', 836.0000, 'ºC'),
	(34573, 108, '2015-02-01 00:59:40.000000', 'temperatura', 1189.0000, 'ºC'),
	(34574, 108, '2015-02-01 00:59:41.000000', 'temperatura', 1036.0000, 'ºC'),
	(34575, 108, '2015-02-01 00:59:42.000000', 'temperatura', 415.0000, 'ºC'),
	(34576, 108, '2015-02-01 00:59:43.000000', 'temperatura', 169.0000, 'ºC'),
	(34577, 108, '2015-02-01 00:59:44.000000', 'temperatura', 801.0000, 'ºC'),
	(34578, 108, '2015-02-01 00:59:45.000000', 'temperatura', 1096.0000, 'ºC'),
	(34579, 108, '2015-02-01 00:59:46.000000', 'temperatura', 679.0000, 'ºC'),
	(34580, 108, '2015-02-01 00:59:47.000000', 'temperatura', 109.0000, 'ºC'),
	(34581, 108, '2015-02-01 00:59:48.000000', 'temperatura', 908.0000, 'ºC'),
	(34582, 108, '2015-02-01 00:59:49.000000', 'temperatura', 612.0000, 'ºC'),
	(34583, 108, '2015-02-01 00:59:50.000000', 'temperatura', 338.0000, 'ºC'),
	(34584, 108, '2015-02-01 00:59:51.000000', 'temperatura', 1054.0000, 'ºC'),
	(34585, 108, '2015-02-01 00:59:52.000000', 'temperatura', 654.0000, 'ºC'),
	(34586, 108, '2015-02-01 00:59:53.000000', 'temperatura', 112.0000, 'ºC'),
	(34587, 108, '2015-02-01 00:59:54.000000', 'temperatura', 996.0000, 'ºC'),
	(34588, 108, '2015-02-01 00:59:55.000000', 'temperatura', 1046.0000, 'ºC'),
	(34589, 108, '2015-02-01 00:59:56.000000', 'temperatura', 1043.0000, 'ºC'),
	(34590, 108, '2015-02-01 00:59:57.000000', 'temperatura', 877.0000, 'ºC'),
	(34591, 108, '2015-02-01 00:59:58.000000', 'temperatura', 58.0000, 'ºC'),
	(34592, 108, '2015-02-01 00:59:59.000000', 'temperatura', 60.0000, 'ºC'),
	(34593, 108, '2015-02-01 01:00:00.000000', 'temperatura', 127.0000, 'ºC'),
	(34594, 108, '2015-02-01 01:00:01.000000', 'temperatura', 456.0000, 'ºC'),
	(34595, 108, '2015-02-01 01:00:02.000000', 'temperatura', 698.0000, 'ºC'),
	(34596, 108, '2015-02-01 01:00:03.000000', 'temperatura', 922.0000, 'ºC'),
	(34597, 108, '2015-02-01 01:00:04.000000', 'temperatura', 117.0000, 'ºC'),
	(34598, 108, '2015-02-01 01:00:05.000000', 'temperatura', 220.0000, 'ºC'),
	(34599, 108, '2015-02-01 01:00:06.000000', 'temperatura', 749.0000, 'ºC'),
	(34600, 108, '2015-02-01 01:00:07.000000', 'temperatura', 686.0000, 'ºC'),
	(34601, 108, '2015-02-01 01:00:08.000000', 'temperatura', 1185.0000, 'ºC'),
	(34602, 108, '2015-02-01 01:00:09.000000', 'temperatura', 267.0000, 'ºC'),
	(34603, 108, '2015-02-01 01:00:10.000000', 'temperatura', 179.0000, 'ºC'),
	(34604, 108, '2015-02-01 01:00:11.000000', 'temperatura', 94.0000, 'ºC'),
	(34605, 108, '2015-02-01 01:00:12.000000', 'temperatura', 1136.0000, 'ºC'),
	(34606, 108, '2015-02-01 01:00:13.000000', 'temperatura', 595.0000, 'ºC'),
	(34607, 108, '2015-02-01 01:00:14.000000', 'temperatura', 771.0000, 'ºC'),
	(34608, 108, '2015-02-01 01:00:15.000000', 'temperatura', 869.0000, 'ºC'),
	(34609, 108, '2015-02-01 01:00:16.000000', 'temperatura', 831.0000, 'ºC'),
	(34610, 108, '2015-02-01 01:00:17.000000', 'temperatura', 351.0000, 'ºC'),
	(34611, 108, '2015-02-01 01:00:18.000000', 'temperatura', 460.0000, 'ºC'),
	(34612, 108, '2015-02-01 01:00:19.000000', 'temperatura', 49.0000, 'ºC'),
	(34613, 108, '2015-02-01 01:00:20.000000', 'temperatura', 67.0000, 'ºC'),
	(34614, 108, '2015-02-01 01:00:21.000000', 'temperatura', 188.0000, 'ºC'),
	(34615, 108, '2015-02-01 01:00:22.000000', 'temperatura', 740.0000, 'ºC'),
	(34616, 108, '2015-02-01 01:00:23.000000', 'temperatura', 736.0000, 'ºC'),
	(34617, 108, '2015-02-01 01:00:24.000000', 'temperatura', 262.0000, 'ºC'),
	(34618, 108, '2015-02-01 01:00:25.000000', 'temperatura', 300.0000, 'ºC'),
	(34619, 108, '2015-02-01 01:00:26.000000', 'temperatura', 717.0000, 'ºC'),
	(34620, 108, '2015-02-01 01:00:27.000000', 'temperatura', 286.0000, 'ºC'),
	(34621, 108, '2015-02-01 01:00:28.000000', 'temperatura', 480.0000, 'ºC'),
	(34622, 108, '2015-02-01 01:00:29.000000', 'temperatura', 341.0000, 'ºC'),
	(34623, 108, '2015-02-01 01:00:30.000000', 'temperatura', 267.0000, 'ºC'),
	(34624, 108, '2015-02-01 01:00:31.000000', 'temperatura', 310.0000, 'ºC'),
	(34625, 108, '2015-02-01 01:00:32.000000', 'temperatura', 751.0000, 'ºC'),
	(34626, 108, '2015-02-01 01:00:33.000000', 'temperatura', 424.0000, 'ºC'),
	(34627, 108, '2015-02-01 01:00:34.000000', 'temperatura', 1068.0000, 'ºC'),
	(34628, 108, '2015-02-01 01:00:35.000000', 'temperatura', 469.0000, 'ºC'),
	(34629, 108, '2015-02-01 01:00:36.000000', 'temperatura', 340.0000, 'ºC'),
	(34630, 108, '2015-02-01 01:00:37.000000', 'temperatura', 295.0000, 'ºC'),
	(34631, 108, '2015-02-01 01:00:38.000000', 'temperatura', 455.0000, 'ºC'),
	(34632, 108, '2015-02-01 01:00:39.000000', 'temperatura', 192.0000, 'ºC'),
	(34633, 108, '2015-02-01 01:00:40.000000', 'temperatura', 796.0000, 'ºC'),
	(34634, 108, '2015-02-01 01:00:41.000000', 'temperatura', 1001.0000, 'ºC'),
	(34635, 108, '2015-02-01 01:00:42.000000', 'temperatura', 221.0000, 'ºC'),
	(34636, 108, '2015-02-01 01:00:43.000000', 'temperatura', 502.0000, 'ºC'),
	(34637, 108, '2015-02-01 01:00:44.000000', 'temperatura', 647.0000, 'ºC'),
	(34638, 108, '2015-02-01 01:00:45.000000', 'temperatura', 528.0000, 'ºC'),
	(34639, 108, '2015-02-01 01:00:46.000000', 'temperatura', 701.0000, 'ºC'),
	(34640, 108, '2015-02-01 01:00:47.000000', 'temperatura', 721.0000, 'ºC'),
	(34641, 108, '2015-02-01 01:00:48.000000', 'temperatura', 304.0000, 'ºC'),
	(34642, 108, '2015-02-01 01:00:49.000000', 'temperatura', 557.0000, 'ºC'),
	(34643, 108, '2015-02-01 01:00:50.000000', 'temperatura', 672.0000, 'ºC'),
	(34644, 108, '2015-02-01 01:00:51.000000', 'temperatura', 490.0000, 'ºC'),
	(34645, 108, '2015-02-01 01:00:52.000000', 'temperatura', 436.0000, 'ºC'),
	(34646, 108, '2015-02-01 01:00:53.000000', 'temperatura', 711.0000, 'ºC'),
	(34647, 108, '2015-02-01 01:00:54.000000', 'temperatura', 1046.0000, 'ºC'),
	(34648, 108, '2015-02-01 01:00:55.000000', 'temperatura', 698.0000, 'ºC'),
	(34649, 108, '2015-02-01 01:00:56.000000', 'temperatura', 351.0000, 'ºC'),
	(34650, 108, '2015-02-01 01:00:57.000000', 'temperatura', 864.0000, 'ºC'),
	(34651, 108, '2015-02-01 01:00:58.000000', 'temperatura', 867.0000, 'ºC'),
	(34652, 108, '2015-02-01 01:00:59.000000', 'temperatura', 543.0000, 'ºC'),
	(34653, 108, '2015-02-01 01:01:00.000000', 'temperatura', 116.0000, 'ºC'),
	(34654, 108, '2015-02-01 01:01:01.000000', 'temperatura', 152.0000, 'ºC'),
	(34655, 108, '2015-02-01 01:01:02.000000', 'temperatura', 413.0000, 'ºC'),
	(34656, 108, '2015-02-01 01:01:03.000000', 'temperatura', 409.0000, 'ºC'),
	(34657, 108, '2015-02-01 01:01:04.000000', 'temperatura', 805.0000, 'ºC'),
	(34658, 108, '2015-02-01 01:01:05.000000', 'temperatura', 397.0000, 'ºC'),
	(34659, 108, '2015-02-01 01:01:06.000000', 'temperatura', 773.0000, 'ºC'),
	(34660, 108, '2015-02-01 01:01:07.000000', 'temperatura', 272.0000, 'ºC'),
	(34661, 108, '2015-02-01 01:01:08.000000', 'temperatura', 244.0000, 'ºC'),
	(34662, 108, '2015-02-01 01:01:09.000000', 'temperatura', 404.0000, 'ºC'),
	(34663, 108, '2015-02-01 01:01:10.000000', 'temperatura', 87.0000, 'ºC'),
	(34664, 108, '2015-02-01 01:01:11.000000', 'temperatura', 426.0000, 'ºC'),
	(34665, 108, '2015-02-01 01:01:12.000000', 'temperatura', 669.0000, 'ºC'),
	(34666, 108, '2015-02-01 01:01:13.000000', 'temperatura', 868.0000, 'ºC'),
	(34667, 108, '2015-02-01 01:01:14.000000', 'temperatura', 1132.0000, 'ºC'),
	(34668, 108, '2015-02-01 01:01:15.000000', 'temperatura', 658.0000, 'ºC'),
	(34669, 108, '2015-02-01 01:01:16.000000', 'temperatura', 1096.0000, 'ºC'),
	(34670, 108, '2015-02-01 01:01:17.000000', 'temperatura', 1103.0000, 'ºC'),
	(34671, 108, '2015-02-01 01:01:18.000000', 'temperatura', 1031.0000, 'ºC'),
	(34672, 108, '2015-02-01 01:01:19.000000', 'temperatura', 643.0000, 'ºC'),
	(34673, 108, '2015-02-01 01:01:20.000000', 'temperatura', 124.0000, 'ºC'),
	(34674, 108, '2015-02-01 01:01:21.000000', 'temperatura', 1090.0000, 'ºC'),
	(34675, 108, '2015-02-01 01:01:22.000000', 'temperatura', 279.0000, 'ºC'),
	(34676, 108, '2015-02-01 01:01:23.000000', 'temperatura', 525.0000, 'ºC'),
	(34677, 108, '2015-02-01 01:01:24.000000', 'temperatura', 590.0000, 'ºC'),
	(34678, 108, '2015-02-01 01:01:25.000000', 'temperatura', 175.0000, 'ºC'),
	(34679, 108, '2015-02-01 01:01:26.000000', 'temperatura', 307.0000, 'ºC'),
	(34680, 108, '2015-02-01 01:01:27.000000', 'temperatura', 1011.0000, 'ºC'),
	(34681, 108, '2015-02-01 01:01:28.000000', 'temperatura', 532.0000, 'ºC'),
	(34682, 108, '2015-02-01 01:01:29.000000', 'temperatura', 830.0000, 'ºC'),
	(34683, 108, '2015-02-01 01:01:30.000000', 'temperatura', 152.0000, 'ºC'),
	(34684, 108, '2015-02-01 01:01:31.000000', 'temperatura', 673.0000, 'ºC'),
	(34685, 108, '2015-02-01 01:01:32.000000', 'temperatura', 509.0000, 'ºC'),
	(34686, 108, '2015-02-01 01:01:33.000000', 'temperatura', 524.0000, 'ºC'),
	(34687, 108, '2015-02-01 01:01:34.000000', 'temperatura', 1097.0000, 'ºC'),
	(34688, 108, '2015-02-01 01:01:35.000000', 'temperatura', 310.0000, 'ºC'),
	(34689, 108, '2015-02-01 01:01:36.000000', 'temperatura', 662.0000, 'ºC'),
	(34690, 108, '2015-02-01 01:01:37.000000', 'temperatura', 1181.0000, 'ºC'),
	(34691, 108, '2015-02-01 01:01:38.000000', 'temperatura', 317.0000, 'ºC'),
	(34692, 108, '2015-02-01 01:01:39.000000', 'temperatura', 442.0000, 'ºC'),
	(34693, 108, '2015-02-01 01:01:40.000000', 'temperatura', 60.0000, 'ºC'),
	(34694, 108, '2015-02-01 01:01:41.000000', 'temperatura', 177.0000, 'ºC'),
	(34695, 108, '2015-02-01 01:01:42.000000', 'temperatura', 703.0000, 'ºC'),
	(34696, 108, '2015-02-01 01:01:43.000000', 'temperatura', 587.0000, 'ºC'),
	(34697, 108, '2015-02-01 01:01:44.000000', 'temperatura', 825.0000, 'ºC'),
	(34698, 108, '2015-02-01 01:01:45.000000', 'temperatura', 1163.0000, 'ºC'),
	(34699, 108, '2015-02-01 01:01:46.000000', 'temperatura', 942.0000, 'ºC'),
	(34700, 108, '2015-02-01 01:01:47.000000', 'temperatura', 20.0000, 'ºC'),
	(34701, 108, '2015-02-01 01:01:48.000000', 'temperatura', 877.0000, 'ºC'),
	(34702, 108, '2015-02-01 01:01:49.000000', 'temperatura', 723.0000, 'ºC'),
	(34703, 108, '2015-02-01 01:01:50.000000', 'temperatura', 987.0000, 'ºC'),
	(34704, 108, '2015-02-01 01:01:51.000000', 'temperatura', 364.0000, 'ºC'),
	(34705, 108, '2015-02-01 01:01:52.000000', 'temperatura', 60.0000, 'ºC'),
	(34706, 108, '2015-02-01 01:01:53.000000', 'temperatura', 410.0000, 'ºC'),
	(34707, 108, '2015-02-01 01:01:54.000000', 'temperatura', 669.0000, 'ºC'),
	(34708, 108, '2015-02-01 01:01:55.000000', 'temperatura', 916.0000, 'ºC'),
	(34709, 108, '2015-02-01 01:01:56.000000', 'temperatura', 175.0000, 'ºC'),
	(34710, 108, '2015-02-01 01:01:57.000000', 'temperatura', 526.0000, 'ºC'),
	(34711, 108, '2015-02-01 01:01:58.000000', 'temperatura', 904.0000, 'ºC'),
	(34712, 108, '2015-02-01 01:01:59.000000', 'temperatura', 543.0000, 'ºC'),
	(34713, 108, '2015-02-01 01:02:00.000000', 'temperatura', 6.0000, 'ºC'),
	(34714, 108, '2015-02-01 01:02:01.000000', 'temperatura', 798.0000, 'ºC'),
	(34715, 108, '2015-02-01 01:02:02.000000', 'temperatura', 376.0000, 'ºC'),
	(34716, 108, '2015-02-01 01:02:03.000000', 'temperatura', 686.0000, 'ºC'),
	(34717, 108, '2015-02-01 01:02:04.000000', 'temperatura', 1100.0000, 'ºC'),
	(34718, 108, '2015-02-01 01:02:05.000000', 'temperatura', 1043.0000, 'ºC'),
	(34719, 108, '2015-02-01 01:02:06.000000', 'temperatura', 716.0000, 'ºC'),
	(34720, 108, '2015-02-01 01:02:07.000000', 'temperatura', 453.0000, 'ºC'),
	(34721, 108, '2015-02-01 01:02:08.000000', 'temperatura', 118.0000, 'ºC'),
	(34722, 108, '2015-02-01 01:02:09.000000', 'temperatura', 431.0000, 'ºC'),
	(34723, 108, '2015-02-01 01:02:10.000000', 'temperatura', 600.0000, 'ºC'),
	(34724, 108, '2015-02-01 01:02:11.000000', 'temperatura', 507.0000, 'ºC'),
	(34725, 108, '2015-02-01 01:02:12.000000', 'temperatura', 737.0000, 'ºC'),
	(34726, 108, '2015-02-01 01:02:13.000000', 'temperatura', 965.0000, 'ºC'),
	(34727, 108, '2015-02-01 01:02:14.000000', 'temperatura', 215.0000, 'ºC'),
	(34728, 108, '2015-02-01 01:02:15.000000', 'temperatura', 580.0000, 'ºC'),
	(34729, 108, '2015-02-01 01:02:16.000000', 'temperatura', 1054.0000, 'ºC'),
	(34730, 108, '2015-02-01 01:02:17.000000', 'temperatura', 1132.0000, 'ºC'),
	(34731, 108, '2015-02-01 01:02:18.000000', 'temperatura', 97.0000, 'ºC'),
	(34732, 108, '2015-02-01 01:02:19.000000', 'temperatura', 689.0000, 'ºC'),
	(34733, 108, '2015-02-01 01:02:20.000000', 'temperatura', 756.0000, 'ºC'),
	(34734, 108, '2015-02-01 01:02:21.000000', 'temperatura', 515.0000, 'ºC'),
	(34735, 108, '2015-02-01 01:02:22.000000', 'temperatura', 304.0000, 'ºC'),
	(34736, 108, '2015-02-01 01:02:23.000000', 'temperatura', 1178.0000, 'ºC'),
	(34737, 108, '2015-02-01 01:02:24.000000', 'temperatura', 179.0000, 'ºC'),
	(34738, 108, '2015-02-01 01:02:25.000000', 'temperatura', 961.0000, 'ºC'),
	(34739, 108, '2015-02-01 01:02:26.000000', 'temperatura', 668.0000, 'ºC'),
	(34740, 108, '2015-02-01 01:02:27.000000', 'temperatura', 459.0000, 'ºC'),
	(34741, 108, '2015-02-01 01:02:28.000000', 'temperatura', 291.0000, 'ºC'),
	(34742, 108, '2015-02-01 01:02:29.000000', 'temperatura', 78.0000, 'ºC'),
	(34743, 108, '2015-02-01 01:02:30.000000', 'temperatura', 720.0000, 'ºC'),
	(34744, 108, '2015-02-01 01:02:31.000000', 'temperatura', 964.0000, 'ºC'),
	(34745, 108, '2015-02-01 01:02:32.000000', 'temperatura', 259.0000, 'ºC'),
	(34746, 108, '2015-02-01 01:02:33.000000', 'temperatura', 805.0000, 'ºC'),
	(34747, 108, '2015-02-01 01:02:34.000000', 'temperatura', 850.0000, 'ºC'),
	(34748, 108, '2015-02-01 01:02:35.000000', 'temperatura', 634.0000, 'ºC'),
	(34749, 108, '2015-02-01 01:02:36.000000', 'temperatura', 622.0000, 'ºC'),
	(34750, 108, '2015-02-01 01:02:37.000000', 'temperatura', 6.0000, 'ºC'),
	(34751, 108, '2015-02-01 01:02:38.000000', 'temperatura', 566.0000, 'ºC'),
	(34752, 108, '2015-02-01 01:02:39.000000', 'temperatura', 410.0000, 'ºC'),
	(34753, 108, '2015-02-01 01:02:40.000000', 'temperatura', 355.0000, 'ºC'),
	(34754, 108, '2015-02-01 01:02:41.000000', 'temperatura', 545.0000, 'ºC'),
	(34755, 108, '2015-02-01 01:02:42.000000', 'temperatura', 460.0000, 'ºC'),
	(34756, 108, '2015-02-01 01:02:43.000000', 'temperatura', 664.0000, 'ºC'),
	(34757, 108, '2015-02-01 01:02:44.000000', 'temperatura', 742.0000, 'ºC'),
	(34758, 108, '2015-02-01 01:02:45.000000', 'temperatura', 516.0000, 'ºC'),
	(34759, 108, '2015-02-01 01:02:46.000000', 'temperatura', 357.0000, 'ºC'),
	(34760, 108, '2015-02-01 01:02:47.000000', 'temperatura', 237.0000, 'ºC'),
	(34761, 108, '2015-02-01 01:02:48.000000', 'temperatura', 115.0000, 'ºC'),
	(34762, 108, '2015-02-01 01:02:49.000000', 'temperatura', 1063.0000, 'ºC'),
	(34763, 108, '2015-02-01 01:02:50.000000', 'temperatura', 172.0000, 'ºC'),
	(34764, 108, '2015-02-01 01:02:51.000000', 'temperatura', 72.0000, 'ºC'),
	(34765, 108, '2015-02-01 01:02:52.000000', 'temperatura', 1044.0000, 'ºC'),
	(34766, 108, '2015-02-01 01:02:53.000000', 'temperatura', 205.0000, 'ºC'),
	(34767, 108, '2015-02-01 01:02:54.000000', 'temperatura', 291.0000, 'ºC'),
	(34768, 108, '2015-02-01 01:02:55.000000', 'temperatura', 843.0000, 'ºC'),
	(34769, 108, '2015-02-01 01:02:56.000000', 'temperatura', 944.0000, 'ºC'),
	(34770, 108, '2015-02-01 01:02:57.000000', 'temperatura', 989.0000, 'ºC'),
	(34771, 108, '2015-02-01 01:02:58.000000', 'temperatura', 915.0000, 'ºC'),
	(34772, 108, '2015-02-01 01:02:59.000000', 'temperatura', 406.0000, 'ºC'),
	(34773, 108, '2015-02-01 01:03:00.000000', 'temperatura', 486.0000, 'ºC'),
	(34774, 108, '2015-02-01 01:03:01.000000', 'temperatura', 14.0000, 'ºC'),
	(34775, 108, '2015-02-01 01:03:02.000000', 'temperatura', 1010.0000, 'ºC'),
	(34776, 108, '2015-02-01 01:03:03.000000', 'temperatura', 211.0000, 'ºC'),
	(34777, 108, '2015-02-01 01:03:04.000000', 'temperatura', 425.0000, 'ºC'),
	(34778, 108, '2015-02-01 01:03:05.000000', 'temperatura', 294.0000, 'ºC'),
	(34779, 108, '2015-02-01 01:03:06.000000', 'temperatura', 192.0000, 'ºC'),
	(34780, 108, '2015-02-01 01:03:07.000000', 'temperatura', 82.0000, 'ºC'),
	(34781, 108, '2015-02-01 01:03:08.000000', 'temperatura', 1031.0000, 'ºC'),
	(34782, 108, '2015-02-01 01:03:09.000000', 'temperatura', 112.0000, 'ºC'),
	(34783, 108, '2015-02-01 01:03:10.000000', 'temperatura', 1066.0000, 'ºC'),
	(34784, 108, '2015-02-01 01:03:11.000000', 'temperatura', 197.0000, 'ºC'),
	(34785, 108, '2015-02-01 01:03:12.000000', 'temperatura', 187.0000, 'ºC'),
	(34786, 108, '2015-02-01 01:03:13.000000', 'temperatura', 343.0000, 'ºC'),
	(34787, 108, '2015-02-01 01:03:14.000000', 'temperatura', 1156.0000, 'ºC'),
	(34788, 108, '2015-02-01 01:03:15.000000', 'temperatura', 1153.0000, 'ºC'),
	(34789, 108, '2015-02-01 01:03:16.000000', 'temperatura', 1094.0000, 'ºC'),
	(34790, 108, '2015-02-01 01:03:17.000000', 'temperatura', 813.0000, 'ºC'),
	(34791, 108, '2015-02-01 01:03:18.000000', 'temperatura', 784.0000, 'ºC'),
	(34792, 108, '2015-02-01 01:03:19.000000', 'temperatura', 281.0000, 'ºC'),
	(34793, 108, '2015-02-01 01:03:20.000000', 'temperatura', 255.0000, 'ºC'),
	(34794, 108, '2015-02-01 01:03:21.000000', 'temperatura', 433.0000, 'ºC'),
	(34795, 108, '2015-02-01 01:03:22.000000', 'temperatura', 201.0000, 'ºC'),
	(34796, 108, '2015-02-01 01:03:23.000000', 'temperatura', 903.0000, 'ºC'),
	(34797, 108, '2015-02-01 01:03:24.000000', 'temperatura', 316.0000, 'ºC'),
	(34798, 108, '2015-02-01 01:03:25.000000', 'temperatura', 68.0000, 'ºC'),
	(34799, 108, '2015-02-01 01:03:26.000000', 'temperatura', 595.0000, 'ºC'),
	(34800, 108, '2015-02-01 01:03:27.000000', 'temperatura', 373.0000, 'ºC'),
	(34801, 108, '2015-02-01 01:03:28.000000', 'temperatura', 78.0000, 'ºC'),
	(34802, 108, '2015-02-01 01:03:29.000000', 'temperatura', 471.0000, 'ºC'),
	(34803, 108, '2015-02-01 01:03:30.000000', 'temperatura', 924.0000, 'ºC'),
	(34804, 108, '2015-02-01 01:03:31.000000', 'temperatura', 807.0000, 'ºC'),
	(34805, 108, '2015-02-01 01:03:32.000000', 'temperatura', 61.0000, 'ºC'),
	(34806, 108, '2015-02-01 01:03:33.000000', 'temperatura', 286.0000, 'ºC'),
	(34807, 108, '2015-02-01 01:03:34.000000', 'temperatura', 46.0000, 'ºC'),
	(34808, 108, '2015-02-01 01:03:35.000000', 'temperatura', 576.0000, 'ºC'),
	(34809, 108, '2015-02-01 01:03:36.000000', 'temperatura', 339.0000, 'ºC'),
	(34810, 108, '2015-02-01 01:03:37.000000', 'temperatura', 1167.0000, 'ºC'),
	(34811, 108, '2015-02-01 01:03:38.000000', 'temperatura', 20.0000, 'ºC'),
	(34812, 108, '2015-02-01 01:03:39.000000', 'temperatura', 200.0000, 'ºC'),
	(34813, 108, '2015-02-01 01:03:40.000000', 'temperatura', 939.0000, 'ºC'),
	(34814, 108, '2015-02-01 01:03:41.000000', 'temperatura', 497.0000, 'ºC'),
	(34815, 108, '2015-02-01 01:03:42.000000', 'temperatura', 870.0000, 'ºC'),
	(34816, 108, '2015-02-01 01:03:43.000000', 'temperatura', 456.0000, 'ºC'),
	(34817, 108, '2015-02-01 01:03:44.000000', 'temperatura', 874.0000, 'ºC'),
	(34818, 108, '2015-02-01 01:03:45.000000', 'temperatura', 599.0000, 'ºC'),
	(34819, 108, '2015-02-01 01:03:46.000000', 'temperatura', 377.0000, 'ºC'),
	(34820, 108, '2015-02-01 01:03:47.000000', 'temperatura', 86.0000, 'ºC'),
	(34821, 108, '2015-02-01 01:03:48.000000', 'temperatura', 500.0000, 'ºC'),
	(34822, 108, '2015-02-01 01:03:49.000000', 'temperatura', 1044.0000, 'ºC'),
	(34823, 108, '2015-02-01 01:03:50.000000', 'temperatura', 118.0000, 'ºC'),
	(34824, 108, '2015-02-01 01:03:51.000000', 'temperatura', 1061.0000, 'ºC'),
	(34825, 108, '2015-02-01 01:03:52.000000', 'temperatura', 152.0000, 'ºC'),
	(34826, 108, '2015-02-01 01:03:53.000000', 'temperatura', 1178.0000, 'ºC'),
	(34827, 108, '2015-02-01 01:03:54.000000', 'temperatura', 632.0000, 'ºC'),
	(34828, 108, '2015-02-01 01:03:55.000000', 'temperatura', 828.0000, 'ºC'),
	(34829, 108, '2015-02-01 01:03:56.000000', 'temperatura', 1045.0000, 'ºC'),
	(34830, 108, '2015-02-01 01:03:57.000000', 'temperatura', 342.0000, 'ºC'),
	(34831, 108, '2015-02-01 01:03:58.000000', 'temperatura', 975.0000, 'ºC'),
	(34832, 108, '2015-02-01 01:03:59.000000', 'temperatura', 250.0000, 'ºC'),
	(34833, 108, '2015-02-01 01:04:00.000000', 'temperatura', 726.0000, 'ºC'),
	(34834, 108, '2015-02-01 01:04:01.000000', 'temperatura', 480.0000, 'ºC'),
	(34835, 108, '2015-02-01 01:04:02.000000', 'temperatura', 221.0000, 'ºC'),
	(34836, 108, '2015-02-01 01:04:03.000000', 'temperatura', 866.0000, 'ºC'),
	(34837, 108, '2015-02-01 01:04:04.000000', 'temperatura', 66.0000, 'ºC'),
	(34838, 108, '2015-02-01 01:04:05.000000', 'temperatura', 133.0000, 'ºC'),
	(34839, 108, '2015-02-01 01:04:06.000000', 'temperatura', 467.0000, 'ºC'),
	(34840, 108, '2015-02-01 01:04:07.000000', 'temperatura', 737.0000, 'ºC'),
	(34841, 108, '2015-02-01 01:04:08.000000', 'temperatura', 1085.0000, 'ºC'),
	(34842, 108, '2015-02-01 01:04:09.000000', 'temperatura', 815.0000, 'ºC'),
	(34843, 108, '2015-02-01 01:04:10.000000', 'temperatura', 819.0000, 'ºC'),
	(34844, 108, '2015-02-01 01:04:11.000000', 'temperatura', 450.0000, 'ºC'),
	(34845, 108, '2015-02-01 01:04:12.000000', 'temperatura', 993.0000, 'ºC'),
	(34846, 108, '2015-02-01 01:04:13.000000', 'temperatura', 17.0000, 'ºC'),
	(34847, 108, '2015-02-01 01:04:14.000000', 'temperatura', 707.0000, 'ºC'),
	(34848, 108, '2015-02-01 01:04:15.000000', 'temperatura', 1086.0000, 'ºC'),
	(34849, 108, '2015-02-01 01:04:16.000000', 'temperatura', 907.0000, 'ºC'),
	(34850, 108, '2015-02-01 01:04:17.000000', 'temperatura', 77.0000, 'ºC'),
	(34851, 108, '2015-02-01 01:04:18.000000', 'temperatura', 64.0000, 'ºC'),
	(34852, 108, '2015-02-01 01:04:19.000000', 'temperatura', 89.0000, 'ºC'),
	(34853, 108, '2015-02-01 01:04:20.000000', 'temperatura', 254.0000, 'ºC'),
	(34854, 108, '2015-02-01 01:04:21.000000', 'temperatura', 1003.0000, 'ºC'),
	(34855, 108, '2015-02-01 01:04:22.000000', 'temperatura', 654.0000, 'ºC'),
	(34856, 108, '2015-02-01 01:04:23.000000', 'temperatura', 261.0000, 'ºC'),
	(34857, 108, '2015-02-01 01:04:24.000000', 'temperatura', 544.0000, 'ºC'),
	(34858, 108, '2015-02-01 01:04:25.000000', 'temperatura', 735.0000, 'ºC'),
	(34859, 108, '2015-02-01 01:04:26.000000', 'temperatura', 846.0000, 'ºC'),
	(34860, 108, '2015-02-01 01:04:27.000000', 'temperatura', 827.0000, 'ºC'),
	(34861, 108, '2015-02-01 01:04:28.000000', 'temperatura', 396.0000, 'ºC'),
	(34862, 108, '2015-02-01 01:04:29.000000', 'temperatura', 699.0000, 'ºC'),
	(34863, 108, '2015-02-01 01:04:30.000000', 'temperatura', 1108.0000, 'ºC'),
	(34864, 108, '2015-02-01 01:04:31.000000', 'temperatura', 1045.0000, 'ºC'),
	(34865, 108, '2015-02-01 01:04:32.000000', 'temperatura', 702.0000, 'ºC'),
	(34866, 108, '2015-02-01 01:04:33.000000', 'temperatura', 374.0000, 'ºC'),
	(34867, 108, '2015-02-01 01:04:34.000000', 'temperatura', 966.0000, 'ºC'),
	(34868, 108, '2015-02-01 01:04:35.000000', 'temperatura', 109.0000, 'ºC'),
	(34869, 108, '2015-02-01 01:04:36.000000', 'temperatura', 48.0000, 'ºC'),
	(34870, 108, '2015-02-01 01:04:37.000000', 'temperatura', 1113.0000, 'ºC'),
	(34871, 108, '2015-02-01 01:04:38.000000', 'temperatura', 621.0000, 'ºC'),
	(34872, 108, '2015-02-01 01:04:39.000000', 'temperatura', 967.0000, 'ºC'),
	(34873, 108, '2015-02-01 01:04:40.000000', 'temperatura', 573.0000, 'ºC'),
	(34874, 108, '2015-02-01 01:04:41.000000', 'temperatura', 1163.0000, 'ºC'),
	(34875, 108, '2015-02-01 01:04:42.000000', 'temperatura', 498.0000, 'ºC'),
	(34876, 108, '2015-02-01 01:04:43.000000', 'temperatura', 199.0000, 'ºC'),
	(34877, 108, '2015-02-01 01:04:44.000000', 'temperatura', 705.0000, 'ºC'),
	(34878, 108, '2015-02-01 01:04:45.000000', 'temperatura', 527.0000, 'ºC'),
	(34879, 108, '2015-02-01 01:04:46.000000', 'temperatura', 519.0000, 'ºC'),
	(34880, 108, '2015-02-01 01:04:47.000000', 'temperatura', 1017.0000, 'ºC'),
	(34881, 108, '2015-02-01 01:04:48.000000', 'temperatura', 1127.0000, 'ºC'),
	(34882, 108, '2015-02-01 01:04:49.000000', 'temperatura', 184.0000, 'ºC'),
	(34883, 108, '2015-02-01 01:04:50.000000', 'temperatura', 1139.0000, 'ºC'),
	(34884, 108, '2015-02-01 01:04:51.000000', 'temperatura', 344.0000, 'ºC'),
	(34885, 108, '2015-02-01 01:04:52.000000', 'temperatura', 705.0000, 'ºC'),
	(34886, 108, '2015-02-01 01:04:53.000000', 'temperatura', 93.0000, 'ºC'),
	(34887, 108, '2015-02-01 01:04:54.000000', 'temperatura', 752.0000, 'ºC'),
	(34888, 108, '2015-02-01 01:04:55.000000', 'temperatura', 1081.0000, 'ºC'),
	(34889, 108, '2015-02-01 01:04:56.000000', 'temperatura', 748.0000, 'ºC'),
	(34890, 108, '2015-02-01 01:04:57.000000', 'temperatura', 499.0000, 'ºC'),
	(34891, 108, '2015-02-01 01:04:58.000000', 'temperatura', 251.0000, 'ºC'),
	(34892, 108, '2015-02-01 01:04:59.000000', 'temperatura', 957.0000, 'ºC'),
	(34893, 108, '2015-02-01 01:05:00.000000', 'temperatura', 432.0000, 'ºC'),
	(34894, 108, '2015-02-01 01:05:01.000000', 'temperatura', 492.0000, 'ºC'),
	(34895, 108, '2015-02-01 01:05:02.000000', 'temperatura', 1162.0000, 'ºC'),
	(34896, 108, '2015-02-01 01:05:03.000000', 'temperatura', 736.0000, 'ºC'),
	(34897, 108, '2015-02-01 01:05:04.000000', 'temperatura', 193.0000, 'ºC'),
	(34898, 108, '2015-02-01 01:05:05.000000', 'temperatura', 1158.0000, 'ºC'),
	(34899, 108, '2015-02-01 01:05:06.000000', 'temperatura', 412.0000, 'ºC'),
	(34900, 108, '2015-02-01 01:05:07.000000', 'temperatura', 987.0000, 'ºC'),
	(34901, 108, '2015-02-01 01:05:08.000000', 'temperatura', 99.0000, 'ºC'),
	(34902, 108, '2015-02-01 01:05:09.000000', 'temperatura', 1133.0000, 'ºC'),
	(34903, 108, '2015-02-01 01:05:10.000000', 'temperatura', 568.0000, 'ºC'),
	(34904, 108, '2015-02-01 01:05:11.000000', 'temperatura', 642.0000, 'ºC'),
	(34905, 108, '2015-02-01 01:05:12.000000', 'temperatura', 309.0000, 'ºC'),
	(34906, 108, '2015-02-01 01:05:13.000000', 'temperatura', 817.0000, 'ºC'),
	(34907, 108, '2015-02-01 01:05:14.000000', 'temperatura', 760.0000, 'ºC'),
	(34908, 108, '2015-02-01 01:05:15.000000', 'temperatura', 151.0000, 'ºC'),
	(34909, 108, '2015-02-01 01:05:16.000000', 'temperatura', 873.0000, 'ºC'),
	(34910, 108, '2015-02-01 01:05:17.000000', 'temperatura', 312.0000, 'ºC'),
	(34911, 108, '2015-02-01 01:05:18.000000', 'temperatura', 141.0000, 'ºC'),
	(34912, 108, '2015-02-01 01:05:19.000000', 'temperatura', 970.0000, 'ºC'),
	(34913, 108, '2015-02-01 01:05:20.000000', 'temperatura', 827.0000, 'ºC'),
	(34914, 108, '2015-02-01 01:05:21.000000', 'temperatura', 25.0000, 'ºC'),
	(34915, 108, '2015-02-01 01:05:22.000000', 'temperatura', 47.0000, 'ºC'),
	(34916, 108, '2015-02-01 01:05:23.000000', 'temperatura', 160.0000, 'ºC'),
	(34917, 108, '2015-02-01 01:05:24.000000', 'temperatura', 659.0000, 'ºC'),
	(34918, 108, '2015-02-01 01:05:25.000000', 'temperatura', 416.0000, 'ºC'),
	(34919, 108, '2015-02-01 01:05:26.000000', 'temperatura', 105.0000, 'ºC'),
	(34920, 108, '2015-02-01 01:05:27.000000', 'temperatura', 477.0000, 'ºC'),
	(34921, 108, '2015-02-01 01:05:28.000000', 'temperatura', 871.0000, 'ºC'),
	(34922, 108, '2015-02-01 01:05:29.000000', 'temperatura', 522.0000, 'ºC'),
	(34923, 108, '2015-02-01 01:05:30.000000', 'temperatura', 1199.0000, 'ºC'),
	(34924, 108, '2015-02-01 01:05:31.000000', 'temperatura', 829.0000, 'ºC'),
	(34925, 108, '2015-02-01 01:05:32.000000', 'temperatura', 548.0000, 'ºC'),
	(34926, 108, '2015-02-01 01:05:33.000000', 'temperatura', 253.0000, 'ºC'),
	(34927, 108, '2015-02-01 01:05:34.000000', 'temperatura', 822.0000, 'ºC'),
	(34928, 108, '2015-02-01 01:05:35.000000', 'temperatura', 954.0000, 'ºC'),
	(34929, 108, '2015-02-01 01:05:36.000000', 'temperatura', 1101.0000, 'ºC'),
	(34930, 108, '2015-02-01 01:05:37.000000', 'temperatura', 246.0000, 'ºC'),
	(34931, 108, '2015-02-01 01:05:38.000000', 'temperatura', 325.0000, 'ºC'),
	(34932, 108, '2015-02-01 01:05:39.000000', 'temperatura', 887.0000, 'ºC'),
	(34933, 108, '2015-02-01 01:05:40.000000', 'temperatura', 1062.0000, 'ºC'),
	(34934, 108, '2015-02-01 01:05:41.000000', 'temperatura', 250.0000, 'ºC'),
	(34935, 108, '2015-02-01 01:05:42.000000', 'temperatura', 464.0000, 'ºC'),
	(34936, 108, '2015-02-01 01:05:43.000000', 'temperatura', 372.0000, 'ºC'),
	(34937, 108, '2015-02-01 01:05:44.000000', 'temperatura', 469.0000, 'ºC'),
	(34938, 108, '2015-02-01 01:05:45.000000', 'temperatura', 29.0000, 'ºC'),
	(34939, 108, '2015-02-01 01:05:46.000000', 'temperatura', 1139.0000, 'ºC'),
	(34940, 108, '2015-02-01 01:05:47.000000', 'temperatura', 810.0000, 'ºC'),
	(34941, 108, '2015-02-01 01:05:48.000000', 'temperatura', 631.0000, 'ºC'),
	(34942, 108, '2015-02-01 01:05:49.000000', 'temperatura', 726.0000, 'ºC'),
	(34943, 108, '2015-02-01 01:05:50.000000', 'temperatura', 538.0000, 'ºC'),
	(34944, 108, '2015-02-01 01:05:51.000000', 'temperatura', 513.0000, 'ºC'),
	(34945, 108, '2015-02-01 01:05:52.000000', 'temperatura', 949.0000, 'ºC'),
	(34946, 108, '2015-02-01 01:05:53.000000', 'temperatura', 807.0000, 'ºC'),
	(34947, 108, '2015-02-01 01:05:54.000000', 'temperatura', 1190.0000, 'ºC'),
	(34948, 108, '2015-02-01 01:05:55.000000', 'temperatura', 1130.0000, 'ºC'),
	(34949, 108, '2015-02-01 01:05:56.000000', 'temperatura', 880.0000, 'ºC'),
	(34950, 108, '2015-02-01 01:05:57.000000', 'temperatura', 1010.0000, 'ºC'),
	(34951, 108, '2015-02-01 01:05:58.000000', 'temperatura', 11.0000, 'ºC'),
	(34952, 108, '2015-02-01 01:05:59.000000', 'temperatura', 626.0000, 'ºC'),
	(34953, 108, '2015-02-01 01:06:00.000000', 'temperatura', 698.0000, 'ºC'),
	(34954, 108, '2015-02-01 01:06:01.000000', 'temperatura', 411.0000, 'ºC'),
	(34955, 108, '2015-02-01 01:06:02.000000', 'temperatura', 1164.0000, 'ºC'),
	(34956, 108, '2015-02-01 01:06:03.000000', 'temperatura', 987.0000, 'ºC'),
	(34957, 108, '2015-02-01 01:06:04.000000', 'temperatura', 242.0000, 'ºC'),
	(34958, 108, '2015-02-01 01:06:05.000000', 'temperatura', 651.0000, 'ºC'),
	(34959, 108, '2015-02-01 01:06:06.000000', 'temperatura', 128.0000, 'ºC'),
	(34960, 108, '2015-02-01 01:06:07.000000', 'temperatura', 1087.0000, 'ºC'),
	(34961, 108, '2015-02-01 01:06:08.000000', 'temperatura', 254.0000, 'ºC'),
	(34962, 108, '2015-02-01 01:06:09.000000', 'temperatura', 407.0000, 'ºC'),
	(34963, 108, '2015-02-01 01:06:10.000000', 'temperatura', 73.0000, 'ºC'),
	(34964, 108, '2015-02-01 01:06:11.000000', 'temperatura', 344.0000, 'ºC'),
	(34965, 108, '2015-02-01 01:06:12.000000', 'temperatura', 304.0000, 'ºC'),
	(34966, 108, '2015-02-01 01:06:13.000000', 'temperatura', 486.0000, 'ºC'),
	(34967, 108, '2015-02-01 01:06:14.000000', 'temperatura', 319.0000, 'ºC'),
	(34968, 108, '2015-02-01 01:06:15.000000', 'temperatura', 136.0000, 'ºC'),
	(34969, 108, '2015-02-01 01:06:16.000000', 'temperatura', 926.0000, 'ºC'),
	(34970, 108, '2015-02-01 01:06:17.000000', 'temperatura', 621.0000, 'ºC'),
	(34971, 108, '2015-02-01 01:06:18.000000', 'temperatura', 328.0000, 'ºC'),
	(34972, 108, '2015-02-01 01:06:19.000000', 'temperatura', 976.0000, 'ºC'),
	(34973, 108, '2015-02-01 01:06:20.000000', 'temperatura', 296.0000, 'ºC'),
	(34974, 108, '2015-02-01 01:06:21.000000', 'temperatura', 952.0000, 'ºC'),
	(34975, 108, '2015-02-01 01:06:22.000000', 'temperatura', 272.0000, 'ºC'),
	(34976, 108, '2015-02-01 01:06:23.000000', 'temperatura', 904.0000, 'ºC'),
	(34977, 108, '2015-02-01 01:06:24.000000', 'temperatura', 106.0000, 'ºC'),
	(34978, 108, '2015-02-01 01:06:25.000000', 'temperatura', 216.0000, 'ºC'),
	(34979, 108, '2015-02-01 01:06:26.000000', 'temperatura', 766.0000, 'ºC'),
	(34980, 108, '2015-02-01 01:06:27.000000', 'temperatura', 781.0000, 'ºC'),
	(34981, 108, '2015-02-01 01:06:28.000000', 'temperatura', 407.0000, 'ºC'),
	(34982, 108, '2015-02-01 01:06:29.000000', 'temperatura', 895.0000, 'ºC'),
	(34983, 108, '2015-02-01 01:06:30.000000', 'temperatura', 851.0000, 'ºC'),
	(34984, 108, '2015-02-01 01:06:31.000000', 'temperatura', 373.0000, 'ºC'),
	(34985, 108, '2015-02-01 01:06:32.000000', 'temperatura', 510.0000, 'ºC'),
	(34986, 108, '2015-02-01 01:06:33.000000', 'temperatura', 234.0000, 'ºC'),
	(34987, 108, '2015-02-01 01:06:34.000000', 'temperatura', 841.0000, 'ºC'),
	(34988, 108, '2015-02-01 01:06:35.000000', 'temperatura', 1103.0000, 'ºC'),
	(34989, 108, '2015-02-01 01:06:36.000000', 'temperatura', 590.0000, 'ºC'),
	(34990, 108, '2015-02-01 01:06:37.000000', 'temperatura', 844.0000, 'ºC'),
	(34991, 108, '2015-02-01 01:06:38.000000', 'temperatura', 48.0000, 'ºC'),
	(34992, 108, '2015-02-01 01:06:39.000000', 'temperatura', 109.0000, 'ºC'),
	(34993, 108, '2015-02-01 01:06:40.000000', 'temperatura', 400.0000, 'ºC'),
	(34994, 108, '2015-02-01 01:06:41.000000', 'temperatura', 476.0000, 'ºC'),
	(34995, 108, '2015-02-01 01:06:42.000000', 'temperatura', 1179.0000, 'ºC'),
	(34996, 108, '2015-02-01 01:06:43.000000', 'temperatura', 867.0000, 'ºC'),
	(34997, 108, '2015-02-01 01:06:44.000000', 'temperatura', 801.0000, 'ºC'),
	(34998, 108, '2015-02-01 01:06:45.000000', 'temperatura', 202.0000, 'ºC'),
	(34999, 108, '2015-02-01 01:06:46.000000', 'temperatura', 1009.0000, 'ºC'),
	(35000, 108, '2015-02-01 01:06:47.000000', 'temperatura', 839.0000, 'ºC'),
	(35001, 108, '2015-02-01 01:06:48.000000', 'temperatura', 1167.0000, 'ºC'),
	(35002, 108, '2015-02-01 01:06:49.000000', 'temperatura', 921.0000, 'ºC'),
	(35003, 108, '2015-02-01 01:06:50.000000', 'temperatura', 1105.0000, 'ºC'),
	(35004, 108, '2015-02-01 01:06:51.000000', 'temperatura', 362.0000, 'ºC'),
	(35005, 108, '2015-02-01 01:06:52.000000', 'temperatura', 895.0000, 'ºC'),
	(35006, 108, '2015-02-01 01:06:53.000000', 'temperatura', 989.0000, 'ºC'),
	(35007, 108, '2015-02-01 01:06:54.000000', 'temperatura', 1062.0000, 'ºC'),
	(35008, 108, '2015-02-01 01:06:55.000000', 'temperatura', 1141.0000, 'ºC'),
	(35009, 108, '2015-02-01 01:06:56.000000', 'temperatura', 120.0000, 'ºC'),
	(35010, 108, '2015-02-01 01:06:57.000000', 'temperatura', 777.0000, 'ºC'),
	(35011, 108, '2015-02-01 01:06:58.000000', 'temperatura', 1126.0000, 'ºC'),
	(35012, 108, '2015-02-01 01:06:59.000000', 'temperatura', 898.0000, 'ºC'),
	(35013, 108, '2015-02-01 01:07:00.000000', 'temperatura', 1115.0000, 'ºC'),
	(35014, 108, '2015-02-01 01:07:01.000000', 'temperatura', 480.0000, 'ºC'),
	(35015, 108, '2015-02-01 01:07:02.000000', 'temperatura', 255.0000, 'ºC'),
	(35016, 108, '2015-02-01 01:07:03.000000', 'temperatura', 1036.0000, 'ºC'),
	(35017, 108, '2015-02-01 01:07:04.000000', 'temperatura', 815.0000, 'ºC'),
	(35018, 108, '2015-02-01 01:07:05.000000', 'temperatura', 970.0000, 'ºC'),
	(35019, 108, '2015-02-01 01:07:06.000000', 'temperatura', 3.0000, 'ºC'),
	(35020, 108, '2015-02-01 01:07:07.000000', 'temperatura', 707.0000, 'ºC'),
	(35021, 108, '2015-02-01 01:07:08.000000', 'temperatura', 1125.0000, 'ºC'),
	(35022, 108, '2015-02-01 01:07:09.000000', 'temperatura', 1104.0000, 'ºC'),
	(35023, 108, '2015-02-01 01:07:10.000000', 'temperatura', 944.0000, 'ºC'),
	(35024, 108, '2015-02-01 01:07:11.000000', 'temperatura', 211.0000, 'ºC'),
	(35025, 108, '2015-02-01 01:07:12.000000', 'temperatura', 623.0000, 'ºC'),
	(35026, 108, '2015-02-01 01:07:13.000000', 'temperatura', 83.0000, 'ºC'),
	(35027, 108, '2015-02-01 01:07:14.000000', 'temperatura', 948.0000, 'ºC'),
	(35028, 108, '2015-02-01 01:07:15.000000', 'temperatura', 890.0000, 'ºC'),
	(35029, 108, '2015-02-01 01:07:16.000000', 'temperatura', 407.0000, 'ºC'),
	(35030, 108, '2015-02-01 01:07:17.000000', 'temperatura', 567.0000, 'ºC'),
	(35031, 108, '2015-02-01 01:07:18.000000', 'temperatura', 413.0000, 'ºC'),
	(35032, 108, '2015-02-01 01:07:19.000000', 'temperatura', 364.0000, 'ºC'),
	(35033, 108, '2015-02-01 01:07:20.000000', 'temperatura', 581.0000, 'ºC'),
	(35034, 108, '2015-02-01 01:07:21.000000', 'temperatura', 612.0000, 'ºC'),
	(35035, 108, '2015-02-01 01:07:22.000000', 'temperatura', 120.0000, 'ºC'),
	(35036, 108, '2015-02-01 01:07:23.000000', 'temperatura', 1166.0000, 'ºC'),
	(35037, 108, '2015-02-01 01:07:24.000000', 'temperatura', 667.0000, 'ºC'),
	(35038, 108, '2015-02-01 01:07:25.000000', 'temperatura', 1039.0000, 'ºC'),
	(35039, 108, '2015-02-01 01:07:26.000000', 'temperatura', 796.0000, 'ºC'),
	(35040, 108, '2015-02-01 01:07:27.000000', 'temperatura', 863.0000, 'ºC'),
	(35041, 108, '2015-02-01 01:07:28.000000', 'temperatura', 727.0000, 'ºC'),
	(35042, 108, '2015-02-01 01:07:29.000000', 'temperatura', 1047.0000, 'ºC'),
	(35043, 108, '2015-02-01 01:07:30.000000', 'temperatura', 653.0000, 'ºC'),
	(35044, 108, '2015-02-01 01:07:31.000000', 'temperatura', 127.0000, 'ºC'),
	(35045, 108, '2015-02-01 01:07:32.000000', 'temperatura', 1073.0000, 'ºC'),
	(35046, 108, '2015-02-01 01:07:33.000000', 'temperatura', 188.0000, 'ºC'),
	(35047, 108, '2015-02-01 01:07:34.000000', 'temperatura', 119.0000, 'ºC'),
	(35048, 108, '2015-02-01 01:07:35.000000', 'temperatura', 30.0000, 'ºC'),
	(35049, 108, '2015-02-01 01:07:36.000000', 'temperatura', 997.0000, 'ºC'),
	(35050, 108, '2015-02-01 01:07:37.000000', 'temperatura', 95.0000, 'ºC'),
	(35051, 108, '2015-02-01 01:07:38.000000', 'temperatura', 1083.0000, 'ºC'),
	(35052, 108, '2015-02-01 01:07:39.000000', 'temperatura', 333.0000, 'ºC'),
	(35053, 108, '2015-02-01 01:07:40.000000', 'temperatura', 816.0000, 'ºC'),
	(35054, 108, '2015-02-01 01:07:41.000000', 'temperatura', 679.0000, 'ºC'),
	(35055, 108, '2015-02-01 01:07:42.000000', 'temperatura', 950.0000, 'ºC'),
	(35056, 108, '2015-02-01 01:07:43.000000', 'temperatura', 311.0000, 'ºC'),
	(35057, 108, '2015-02-01 01:07:44.000000', 'temperatura', 1105.0000, 'ºC'),
	(35058, 108, '2015-02-01 01:07:45.000000', 'temperatura', 994.0000, 'ºC'),
	(35059, 108, '2015-02-01 01:07:46.000000', 'temperatura', 454.0000, 'ºC'),
	(35060, 108, '2015-02-01 01:07:47.000000', 'temperatura', 490.0000, 'ºC'),
	(35061, 108, '2015-02-01 01:07:48.000000', 'temperatura', 1090.0000, 'ºC'),
	(35062, 108, '2015-02-01 01:07:49.000000', 'temperatura', 379.0000, 'ºC'),
	(35063, 108, '2015-02-01 01:07:50.000000', 'temperatura', 1024.0000, 'ºC'),
	(35064, 108, '2015-02-01 01:07:51.000000', 'temperatura', 383.0000, 'ºC'),
	(35065, 108, '2015-02-01 01:07:52.000000', 'temperatura', 46.0000, 'ºC'),
	(35066, 108, '2015-02-01 01:07:53.000000', 'temperatura', 280.0000, 'ºC'),
	(35067, 108, '2015-02-01 01:07:54.000000', 'temperatura', 62.0000, 'ºC'),
	(35068, 108, '2015-02-01 01:07:55.000000', 'temperatura', 670.0000, 'ºC'),
	(35069, 108, '2015-02-01 01:07:56.000000', 'temperatura', 764.0000, 'ºC'),
	(35070, 108, '2015-02-01 01:07:57.000000', 'temperatura', 613.0000, 'ºC'),
	(35071, 108, '2015-02-01 01:07:58.000000', 'temperatura', 773.0000, 'ºC'),
	(35072, 108, '2015-02-01 01:07:59.000000', 'temperatura', 827.0000, 'ºC'),
	(35073, 108, '2015-02-01 01:08:00.000000', 'temperatura', 618.0000, 'ºC'),
	(35074, 108, '2015-02-01 01:08:01.000000', 'temperatura', 607.0000, 'ºC'),
	(35075, 108, '2015-02-01 01:08:02.000000', 'temperatura', 1183.0000, 'ºC'),
	(35076, 108, '2015-02-01 01:08:03.000000', 'temperatura', 493.0000, 'ºC'),
	(35077, 108, '2015-02-01 01:08:04.000000', 'temperatura', 117.0000, 'ºC'),
	(35078, 108, '2015-02-01 01:08:05.000000', 'temperatura', 307.0000, 'ºC'),
	(35079, 108, '2015-02-01 01:08:06.000000', 'temperatura', 1183.0000, 'ºC'),
	(35080, 108, '2015-02-01 01:08:07.000000', 'temperatura', 195.0000, 'ºC'),
	(35081, 108, '2015-02-01 01:08:08.000000', 'temperatura', 1025.0000, 'ºC'),
	(35082, 108, '2015-02-01 01:08:09.000000', 'temperatura', 941.0000, 'ºC'),
	(35083, 108, '2015-02-01 01:08:10.000000', 'temperatura', 433.0000, 'ºC'),
	(35084, 108, '2015-02-01 01:08:11.000000', 'temperatura', 539.0000, 'ºC'),
	(35085, 108, '2015-02-01 01:08:12.000000', 'temperatura', 198.0000, 'ºC'),
	(35086, 108, '2015-02-01 01:08:13.000000', 'temperatura', 575.0000, 'ºC'),
	(35087, 108, '2015-02-01 01:08:14.000000', 'temperatura', 1079.0000, 'ºC'),
	(35088, 108, '2015-02-01 01:08:15.000000', 'temperatura', 71.0000, 'ºC'),
	(35089, 108, '2015-02-01 01:08:16.000000', 'temperatura', 718.0000, 'ºC'),
	(35090, 108, '2015-02-01 01:08:17.000000', 'temperatura', 979.0000, 'ºC'),
	(35091, 108, '2015-02-01 01:08:18.000000', 'temperatura', 339.0000, 'ºC'),
	(35092, 108, '2015-02-01 01:08:19.000000', 'temperatura', 1160.0000, 'ºC'),
	(35093, 108, '2015-02-01 01:08:20.000000', 'temperatura', 1182.0000, 'ºC'),
	(35094, 108, '2015-02-01 01:08:21.000000', 'temperatura', 33.0000, 'ºC'),
	(35095, 108, '2015-02-01 01:08:22.000000', 'temperatura', 217.0000, 'ºC'),
	(35096, 108, '2015-02-01 01:08:23.000000', 'temperatura', 987.0000, 'ºC'),
	(35097, 108, '2015-02-01 01:08:24.000000', 'temperatura', 687.0000, 'ºC'),
	(35098, 108, '2015-02-01 01:08:25.000000', 'temperatura', 471.0000, 'ºC'),
	(35099, 108, '2015-02-01 01:08:26.000000', 'temperatura', 297.0000, 'ºC'),
	(35100, 108, '2015-02-01 01:08:27.000000', 'temperatura', 70.0000, 'ºC'),
	(35101, 108, '2015-02-01 01:08:28.000000', 'temperatura', 663.0000, 'ºC'),
	(35102, 108, '2015-02-01 01:08:29.000000', 'temperatura', 703.0000, 'ºC'),
	(35103, 108, '2015-02-01 01:08:30.000000', 'temperatura', 325.0000, 'ºC'),
	(35104, 108, '2015-02-01 01:08:31.000000', 'temperatura', 719.0000, 'ºC'),
	(35105, 108, '2015-02-01 01:08:32.000000', 'temperatura', 218.0000, 'ºC'),
	(35106, 108, '2015-02-01 01:08:33.000000', 'temperatura', 136.0000, 'ºC'),
	(35107, 108, '2015-02-01 01:08:34.000000', 'temperatura', 24.0000, 'ºC'),
	(35108, 108, '2015-02-01 01:08:35.000000', 'temperatura', 916.0000, 'ºC'),
	(35109, 108, '2015-02-01 01:08:36.000000', 'temperatura', 905.0000, 'ºC'),
	(35110, 108, '2015-02-01 01:08:37.000000', 'temperatura', 579.0000, 'ºC'),
	(35111, 108, '2015-02-01 01:08:38.000000', 'temperatura', 182.0000, 'ºC'),
	(35112, 108, '2015-02-01 01:08:39.000000', 'temperatura', 371.0000, 'ºC'),
	(35113, 108, '2015-02-01 01:08:40.000000', 'temperatura', 111.0000, 'ºC'),
	(35114, 108, '2015-02-01 01:08:41.000000', 'temperatura', 641.0000, 'ºC'),
	(35115, 108, '2015-02-01 01:08:42.000000', 'temperatura', 474.0000, 'ºC'),
	(35116, 108, '2015-02-01 01:08:43.000000', 'temperatura', 446.0000, 'ºC'),
	(35117, 108, '2015-02-01 01:08:44.000000', 'temperatura', 808.0000, 'ºC'),
	(35118, 108, '2015-02-01 01:08:45.000000', 'temperatura', 304.0000, 'ºC'),
	(35119, 108, '2015-02-01 01:08:46.000000', 'temperatura', 295.0000, 'ºC'),
	(35120, 108, '2015-02-01 01:08:47.000000', 'temperatura', 566.0000, 'ºC'),
	(35121, 108, '2015-02-01 01:08:48.000000', 'temperatura', 743.0000, 'ºC'),
	(35122, 108, '2015-02-01 01:08:49.000000', 'temperatura', 819.0000, 'ºC'),
	(35123, 108, '2015-02-01 01:08:50.000000', 'temperatura', 665.0000, 'ºC'),
	(35124, 108, '2015-02-01 01:08:51.000000', 'temperatura', 868.0000, 'ºC'),
	(35125, 108, '2015-02-01 01:08:52.000000', 'temperatura', 1144.0000, 'ºC'),
	(35126, 108, '2015-02-01 01:08:53.000000', 'temperatura', 720.0000, 'ºC'),
	(35127, 108, '2015-02-01 01:08:54.000000', 'temperatura', 165.0000, 'ºC'),
	(35128, 108, '2015-02-01 01:08:55.000000', 'temperatura', 1068.0000, 'ºC'),
	(35129, 108, '2015-02-01 01:08:56.000000', 'temperatura', 43.0000, 'ºC'),
	(35130, 108, '2015-02-01 01:08:57.000000', 'temperatura', 614.0000, 'ºC'),
	(35131, 108, '2015-02-01 01:08:58.000000', 'temperatura', 541.0000, 'ºC'),
	(35132, 108, '2015-02-01 01:08:59.000000', 'temperatura', 861.0000, 'ºC'),
	(35133, 108, '2015-02-01 01:09:00.000000', 'temperatura', 285.0000, 'ºC'),
	(35134, 108, '2015-02-01 01:09:01.000000', 'temperatura', 43.0000, 'ºC'),
	(35135, 108, '2015-02-01 01:09:02.000000', 'temperatura', 559.0000, 'ºC'),
	(35136, 108, '2015-02-01 01:09:03.000000', 'temperatura', 268.0000, 'ºC'),
	(35137, 108, '2015-02-01 01:09:04.000000', 'temperatura', 864.0000, 'ºC'),
	(35138, 108, '2015-02-01 01:09:05.000000', 'temperatura', 1114.0000, 'ºC'),
	(35139, 108, '2015-02-01 01:09:06.000000', 'temperatura', 578.0000, 'ºC'),
	(35140, 108, '2015-02-01 01:09:07.000000', 'temperatura', 750.0000, 'ºC'),
	(35141, 108, '2015-02-01 01:09:08.000000', 'temperatura', 818.0000, 'ºC'),
	(35142, 108, '2015-02-01 01:09:09.000000', 'temperatura', 637.0000, 'ºC'),
	(35143, 108, '2015-02-01 01:09:10.000000', 'temperatura', 735.0000, 'ºC'),
	(35144, 108, '2015-02-01 01:09:11.000000', 'temperatura', 564.0000, 'ºC'),
	(35145, 108, '2015-02-01 01:09:12.000000', 'temperatura', 615.0000, 'ºC'),
	(35146, 108, '2015-02-01 01:09:13.000000', 'temperatura', 185.0000, 'ºC'),
	(35147, 108, '2015-02-01 01:09:14.000000', 'temperatura', 281.0000, 'ºC'),
	(35148, 108, '2015-02-01 01:09:15.000000', 'temperatura', 849.0000, 'ºC'),
	(35149, 108, '2015-02-01 01:09:16.000000', 'temperatura', 1003.0000, 'ºC'),
	(35150, 108, '2015-02-01 01:09:17.000000', 'temperatura', 69.0000, 'ºC'),
	(35151, 108, '2015-02-01 01:09:18.000000', 'temperatura', 934.0000, 'ºC'),
	(35152, 108, '2015-02-01 01:09:19.000000', 'temperatura', 866.0000, 'ºC'),
	(35153, 108, '2015-02-01 01:09:20.000000', 'temperatura', 330.0000, 'ºC'),
	(35154, 108, '2015-02-01 01:09:21.000000', 'temperatura', 250.0000, 'ºC'),
	(35155, 108, '2015-02-01 01:09:22.000000', 'temperatura', 263.0000, 'ºC'),
	(35156, 108, '2015-02-01 01:09:23.000000', 'temperatura', 563.0000, 'ºC'),
	(35157, 108, '2015-02-01 01:09:24.000000', 'temperatura', 826.0000, 'ºC'),
	(35158, 108, '2015-02-01 01:09:25.000000', 'temperatura', 41.0000, 'ºC'),
	(35159, 108, '2015-02-01 01:09:26.000000', 'temperatura', 130.0000, 'ºC'),
	(35160, 108, '2015-02-01 01:09:27.000000', 'temperatura', 525.0000, 'ºC'),
	(35161, 108, '2015-02-01 01:09:28.000000', 'temperatura', 1035.0000, 'ºC'),
	(35162, 108, '2015-02-01 01:09:29.000000', 'temperatura', 0.0000, 'ºC'),
	(35163, 108, '2015-02-01 01:09:30.000000', 'temperatura', 497.0000, 'ºC'),
	(35164, 108, '2015-02-01 01:09:31.000000', 'temperatura', 84.0000, 'ºC'),
	(35165, 108, '2015-02-01 01:09:32.000000', 'temperatura', 130.0000, 'ºC'),
	(35166, 108, '2015-02-01 01:09:33.000000', 'temperatura', 400.0000, 'ºC'),
	(35167, 108, '2015-02-01 01:09:34.000000', 'temperatura', 408.0000, 'ºC'),
	(35168, 108, '2015-02-01 01:09:35.000000', 'temperatura', 843.0000, 'ºC'),
	(35169, 108, '2015-02-01 01:09:36.000000', 'temperatura', 590.0000, 'ºC'),
	(35170, 108, '2015-02-01 01:09:37.000000', 'temperatura', 421.0000, 'ºC'),
	(35171, 108, '2015-02-01 01:09:38.000000', 'temperatura', 335.0000, 'ºC'),
	(35172, 108, '2015-02-01 01:09:39.000000', 'temperatura', 415.0000, 'ºC'),
	(35173, 108, '2015-02-01 01:09:40.000000', 'temperatura', 1071.0000, 'ºC'),
	(35174, 108, '2015-02-01 01:09:41.000000', 'temperatura', 510.0000, 'ºC'),
	(35175, 108, '2015-02-01 01:09:42.000000', 'temperatura', 536.0000, 'ºC'),
	(35176, 108, '2015-02-01 01:09:43.000000', 'temperatura', 1150.0000, 'ºC'),
	(35177, 108, '2015-02-01 01:09:44.000000', 'temperatura', 544.0000, 'ºC'),
	(35178, 108, '2015-02-01 01:09:45.000000', 'temperatura', 469.0000, 'ºC'),
	(35179, 108, '2015-02-01 01:09:46.000000', 'temperatura', 716.0000, 'ºC'),
	(35180, 108, '2015-02-01 01:09:47.000000', 'temperatura', 972.0000, 'ºC'),
	(35181, 108, '2015-02-01 01:09:48.000000', 'temperatura', 314.0000, 'ºC'),
	(35182, 108, '2015-02-01 01:09:49.000000', 'temperatura', 1055.0000, 'ºC'),
	(35183, 108, '2015-02-01 01:09:50.000000', 'temperatura', 734.0000, 'ºC'),
	(35184, 108, '2015-02-01 01:09:51.000000', 'temperatura', 505.0000, 'ºC'),
	(35185, 108, '2015-02-01 01:09:52.000000', 'temperatura', 324.0000, 'ºC'),
	(35186, 108, '2015-02-01 01:09:53.000000', 'temperatura', 106.0000, 'ºC'),
	(35187, 108, '2015-02-01 01:09:54.000000', 'temperatura', 756.0000, 'ºC'),
	(35188, 108, '2015-02-01 01:09:55.000000', 'temperatura', 1063.0000, 'ºC'),
	(35189, 108, '2015-02-01 01:09:56.000000', 'temperatura', 648.0000, 'ºC'),
	(35190, 108, '2015-02-01 01:09:57.000000', 'temperatura', 51.0000, 'ºC'),
	(35191, 108, '2015-02-01 01:09:58.000000', 'temperatura', 712.0000, 'ºC'),
	(35192, 108, '2015-02-01 01:09:59.000000', 'temperatura', 1006.0000, 'ºC'),
	(35193, 108, '2015-02-01 01:10:00.000000', 'temperatura', 498.0000, 'ºC'),
	(35194, 108, '2015-02-01 01:10:01.000000', 'temperatura', 669.0000, 'ºC'),
	(35195, 108, '2015-02-01 01:10:02.000000', 'temperatura', 652.0000, 'ºC'),
	(35196, 108, '2015-02-01 01:10:03.000000', 'temperatura', 53.0000, 'ºC'),
	(35197, 108, '2015-02-01 01:10:04.000000', 'temperatura', 712.0000, 'ºC'),
	(35198, 108, '2015-02-01 01:10:05.000000', 'temperatura', 998.0000, 'ºC'),
	(35199, 108, '2015-02-01 01:10:06.000000', 'temperatura', 458.0000, 'ºC'),
	(35200, 108, '2015-02-01 01:10:07.000000', 'temperatura', 495.0000, 'ºC'),
	(35201, 108, '2015-02-01 01:10:08.000000', 'temperatura', 1103.0000, 'ºC'),
	(35202, 108, '2015-02-01 01:10:09.000000', 'temperatura', 429.0000, 'ºC'),
	(35203, 108, '2015-02-01 01:10:10.000000', 'temperatura', 35.0000, 'ºC'),
	(35204, 108, '2015-02-01 01:10:11.000000', 'temperatura', 91.0000, 'ºC'),
	(35205, 108, '2015-02-01 01:10:12.000000', 'temperatura', 348.0000, 'ºC'),
	(35206, 108, '2015-02-01 01:10:13.000000', 'temperatura', 267.0000, 'ºC'),
	(35207, 108, '2015-02-01 01:10:14.000000', 'temperatura', 292.0000, 'ºC'),
	(35208, 108, '2015-02-01 01:10:15.000000', 'temperatura', 660.0000, 'ºC'),
	(35209, 108, '2015-02-01 01:10:16.000000', 'temperatura', 23.0000, 'ºC'),
	(35210, 108, '2015-02-01 01:10:17.000000', 'temperatura', 536.0000, 'ºC'),
	(35211, 108, '2015-02-01 01:10:18.000000', 'temperatura', 212.0000, 'ºC'),
	(35212, 108, '2015-02-01 01:10:19.000000', 'temperatura', 651.0000, 'ºC'),
	(35213, 108, '2015-02-01 01:10:20.000000', 'temperatura', 222.0000, 'ºC'),
	(35214, 108, '2015-02-01 01:10:21.000000', 'temperatura', 355.0000, 'ºC'),
	(35215, 108, '2015-02-01 01:10:22.000000', 'temperatura', 1110.0000, 'ºC'),
	(35216, 108, '2015-02-01 01:10:23.000000', 'temperatura', 885.0000, 'ºC'),
	(35217, 108, '2015-02-01 01:10:24.000000', 'temperatura', 1094.0000, 'ºC'),
	(35218, 108, '2015-02-01 01:10:25.000000', 'temperatura', 418.0000, 'ºC'),
	(35219, 108, '2015-02-01 01:10:26.000000', 'temperatura', 9.0000, 'ºC'),
	(35220, 108, '2015-02-01 01:10:27.000000', 'temperatura', 1192.0000, 'ºC'),
	(35221, 108, '2015-02-01 01:10:28.000000', 'temperatura', 1132.0000, 'ºC'),
	(35222, 108, '2015-02-01 01:10:29.000000', 'temperatura', 884.0000, 'ºC'),
	(35223, 108, '2015-02-01 01:10:30.000000', 'temperatura', 1023.0000, 'ºC'),
	(35224, 108, '2015-02-01 01:10:31.000000', 'temperatura', 65.0000, 'ºC'),
	(35225, 108, '2015-02-01 01:10:32.000000', 'temperatura', 858.0000, 'ºC'),
	(35226, 108, '2015-02-01 01:10:33.000000', 'temperatura', 495.0000, 'ºC'),
	(35227, 108, '2015-02-01 01:10:34.000000', 'temperatura', 1103.0000, 'ºC'),
	(35228, 108, '2015-02-01 01:10:35.000000', 'temperatura', 429.0000, 'ºC'),
	(35229, 108, '2015-02-01 01:10:36.000000', 'temperatura', 38.0000, 'ºC'),
	(35230, 108, '2015-02-01 01:10:37.000000', 'temperatura', 101.0000, 'ºC'),
	(35231, 108, '2015-02-01 01:10:38.000000', 'temperatura', 394.0000, 'ºC'),
	(35232, 108, '2015-02-01 01:10:39.000000', 'temperatura', 468.0000, 'ºC'),
	(35233, 108, '2015-02-01 01:10:40.000000', 'temperatura', 1158.0000, 'ºC'),
	(35234, 108, '2015-02-01 01:10:41.000000', 'temperatura', 787.0000, 'ºC'),
	(35235, 108, '2015-02-01 01:10:42.000000', 'temperatura', 460.0000, 'ºC'),
	(35236, 108, '2015-02-01 01:10:43.000000', 'temperatura', 1140.0000, 'ºC'),
	(35237, 108, '2015-02-01 01:10:44.000000', 'temperatura', 720.0000, 'ºC'),
	(35238, 108, '2015-02-01 01:10:45.000000', 'temperatura', 180.0000, 'ºC'),
	(35239, 108, '2015-02-01 01:10:46.000000', 'temperatura', 1139.0000, 'ºC'),
	(35240, 108, '2015-02-01 01:10:47.000000', 'temperatura', 357.0000, 'ºC'),
	(35241, 108, '2015-02-01 01:10:48.000000', 'temperatura', 770.0000, 'ºC'),
	(35242, 108, '2015-02-01 01:10:49.000000', 'temperatura', 378.0000, 'ºC'),
	(35243, 108, '2015-02-01 01:10:50.000000', 'temperatura', 781.0000, 'ºC'),
	(35244, 108, '2015-02-01 01:10:51.000000', 'temperatura', 372.0000, 'ºC'),
	(35245, 108, '2015-02-01 01:10:52.000000', 'temperatura', 719.0000, 'ºC'),
	(35246, 108, '2015-02-01 01:10:53.000000', 'temperatura', 78.0000, 'ºC'),
	(35247, 108, '2015-02-01 01:10:54.000000', 'temperatura', 633.0000, 'ºC'),
	(35248, 108, '2015-02-01 01:10:55.000000', 'temperatura', 530.0000, 'ºC'),
	(35249, 108, '2015-02-01 01:10:56.000000', 'temperatura', 754.0000, 'ºC'),
	(35250, 108, '2015-02-01 01:10:57.000000', 'temperatura', 979.0000, 'ºC'),
	(35251, 108, '2015-02-01 01:10:58.000000', 'temperatura', 234.0000, 'ºC'),
	(35252, 108, '2015-02-01 01:10:59.000000', 'temperatura', 635.0000, 'ºC'),
	(35253, 108, '2015-02-01 01:11:00.000000', 'temperatura', 72.0000, 'ºC'),
	(35254, 108, '2015-02-01 01:11:01.000000', 'temperatura', 856.0000, 'ºC'),
	(35255, 108, '2015-02-01 01:11:02.000000', 'temperatura', 463.0000, 'ºC'),
	(35256, 108, '2015-02-01 01:11:03.000000', 'temperatura', 947.0000, 'ºC'),
	(35257, 108, '2015-02-01 01:11:04.000000', 'temperatura', 946.0000, 'ºC'),
	(35258, 108, '2015-02-01 01:11:05.000000', 'temperatura', 691.0000, 'ºC'),
	(35259, 108, '2015-02-01 01:11:06.000000', 'temperatura', 617.0000, 'ºC'),
	(35260, 108, '2015-02-01 01:11:07.000000', 'temperatura', 1011.0000, 'ºC'),
	(35261, 108, '2015-02-01 01:11:08.000000', 'temperatura', 805.0000, 'ºC'),
	(35262, 108, '2015-02-01 01:11:09.000000', 'temperatura', 993.0000, 'ºC'),
	(35263, 108, '2015-02-01 01:11:10.000000', 'temperatura', 151.0000, 'ºC'),
	(35264, 108, '2015-02-01 01:11:11.000000', 'temperatura', 175.0000, 'ºC'),
	(35265, 108, '2015-02-01 01:11:12.000000', 'temperatura', 425.0000, 'ºC'),
	(35266, 108, '2015-02-01 01:11:13.000000', 'temperatura', 399.0000, 'ºC'),
	(35267, 108, '2015-02-01 01:11:14.000000', 'temperatura', 719.0000, 'ºC'),
	(35268, 108, '2015-02-01 01:11:15.000000', 'temperatura', 0.0000, 'ºC'),
	(35269, 108, '2015-02-01 01:11:16.000000', 'temperatura', 243.0000, 'ºC'),
	(35270, 108, '2015-02-01 01:11:17.000000', 'temperatura', 17.0000, 'ºC'),
	(35271, 108, '2015-02-01 01:11:18.000000', 'temperatura', 555.0000, 'ºC'),
	(35272, 108, '2015-02-01 01:11:19.000000', 'temperatura', 326.0000, 'ºC'),
	(35273, 108, '2015-02-01 01:11:20.000000', 'temperatura', 1166.0000, 'ºC'),
	(35274, 108, '2015-02-01 01:11:21.000000', 'temperatura', 53.0000, 'ºC'),
	(35275, 108, '2015-02-01 01:11:22.000000', 'temperatura', 366.0000, 'ºC'),
	(35276, 108, '2015-02-01 01:11:23.000000', 'temperatura', 473.0000, 'ºC'),
	(35277, 108, '2015-02-01 01:11:24.000000', 'temperatura', 68.0000, 'ºC'),
	(35278, 108, '2015-02-01 01:11:25.000000', 'temperatura', 121.0000, 'ºC'),
	(35279, 108, '2015-02-01 01:11:26.000000', 'temperatura', 400.0000, 'ºC'),
	(35280, 108, '2015-02-01 01:11:27.000000', 'temperatura', 440.0000, 'ºC'),
	(35281, 108, '2015-02-01 01:11:28.000000', 'temperatura', 1000.0000, 'ºC'),
	(35282, 108, '2015-02-01 01:11:29.000000', 'temperatura', 79.0000, 'ºC'),
	(35283, 108, '2015-02-01 01:11:30.000000', 'temperatura', 998.0000, 'ºC'),
	(35284, 108, '2015-02-01 01:11:31.000000', 'temperatura', 1153.0000, 'ºC'),
	(35285, 108, '2015-02-01 01:11:32.000000', 'temperatura', 370.0000, 'ºC'),
	(35286, 108, '2015-02-01 01:11:33.000000', 'temperatura', 794.0000, 'ºC'),
	(35287, 108, '2015-02-01 01:11:34.000000', 'temperatura', 458.0000, 'ºC'),
	(35288, 108, '2015-02-01 01:11:35.000000', 'temperatura', 1108.0000, 'ºC'),
	(35289, 108, '2015-02-01 01:11:36.000000', 'temperatura', 569.0000, 'ºC'),
	(35290, 108, '2015-02-01 01:11:37.000000', 'temperatura', 722.0000, 'ºC'),
	(35291, 108, '2015-02-01 01:11:38.000000', 'temperatura', 701.0000, 'ºC'),
	(35292, 108, '2015-02-01 01:11:39.000000', 'temperatura', 139.0000, 'ºC'),
	(35293, 108, '2015-02-01 01:11:40.000000', 'temperatura', 993.0000, 'ºC'),
	(35294, 108, '2015-02-01 01:11:41.000000', 'temperatura', 950.0000, 'ºC'),
	(35295, 108, '2015-02-01 01:11:42.000000', 'temperatura', 571.0000, 'ºC'),
	(35296, 108, '2015-02-01 01:11:43.000000', 'temperatura', 7.0000, 'ºC'),
	(35297, 108, '2015-02-01 01:11:44.000000', 'temperatura', 723.0000, 'ºC'),
	(35298, 108, '2015-02-01 01:11:45.000000', 'temperatura', 1192.0000, 'ºC'),
	(35299, 108, '2015-02-01 01:11:46.000000', 'temperatura', 194.0000, 'ºC'),
	(35300, 108, '2015-02-01 01:11:47.000000', 'temperatura', 994.0000, 'ºC'),
	(35301, 108, '2015-02-01 01:11:48.000000', 'temperatura', 789.0000, 'ºC'),
	(35302, 108, '2015-02-01 01:11:49.000000', 'temperatura', 963.0000, 'ºC'),
	(35303, 108, '2015-02-01 01:11:50.000000', 'temperatura', 47.0000, 'ºC'),
	(35304, 108, '2015-02-01 01:11:51.000000', 'temperatura', 947.0000, 'ºC'),
	(35305, 108, '2015-02-01 01:11:52.000000', 'temperatura', 995.0000, 'ºC'),
	(35306, 108, '2015-02-01 01:11:53.000000', 'temperatura', 936.0000, 'ºC'),
	(35307, 108, '2015-02-01 01:11:54.000000', 'temperatura', 495.0000, 'ºC'),
	(35308, 108, '2015-02-01 01:11:55.000000', 'temperatura', 867.0000, 'ºC'),
	(35309, 108, '2015-02-01 01:11:56.000000', 'temperatura', 452.0000, 'ºC'),
	(35310, 108, '2015-02-01 01:11:57.000000', 'temperatura', 860.0000, 'ºC'),
	(35311, 108, '2015-02-01 01:11:58.000000', 'temperatura', 545.0000, 'ºC'),
	(35312, 108, '2015-02-01 01:11:59.000000', 'temperatura', 142.0000, 'ºC'),
	(35313, 108, '2015-02-01 01:12:00.000000', 'temperatura', 278.0000, 'ºC'),
	(35314, 108, '2015-02-01 01:12:01.000000', 'temperatura', 966.0000, 'ºC'),
	(35315, 108, '2015-02-01 01:12:02.000000', 'temperatura', 394.0000, 'ºC'),
	(35316, 108, '2015-02-01 01:12:03.000000', 'temperatura', 275.0000, 'ºC'),
	(35317, 108, '2015-02-01 01:12:04.000000', 'temperatura', 192.0000, 'ºC'),
	(35318, 108, '2015-02-01 01:12:05.000000', 'temperatura', 136.0000, 'ºC'),
	(35319, 108, '2015-02-01 01:12:06.000000', 'temperatura', 104.0000, 'ºC'),
	(35320, 108, '2015-02-01 01:12:07.000000', 'temperatura', 111.0000, 'ºC'),
	(35321, 108, '2015-02-01 01:12:08.000000', 'temperatura', 245.0000, 'ºC'),
	(35322, 108, '2015-02-01 01:12:09.000000', 'temperatura', 894.0000, 'ºC'),
	(35323, 108, '2015-02-01 01:12:10.000000', 'temperatura', 136.0000, 'ºC'),
	(35324, 108, '2015-02-01 01:12:11.000000', 'temperatura', 395.0000, 'ºC'),
	(35325, 108, '2015-02-01 01:12:12.000000', 'temperatura', 370.0000, 'ºC'),
	(35326, 108, '2015-02-01 01:12:13.000000', 'temperatura', 666.0000, 'ºC'),
	(35327, 108, '2015-02-01 01:12:14.000000', 'temperatura', 1021.0000, 'ºC'),
	(35328, 108, '2015-02-01 01:12:15.000000', 'temperatura', 705.0000, 'ºC'),
	(35329, 108, '2015-02-01 01:12:16.000000', 'temperatura', 465.0000, 'ºC'),
	(35330, 108, '2015-02-01 01:12:17.000000', 'temperatura', 211.0000, 'ºC'),
	(35331, 108, '2015-02-01 01:12:18.000000', 'temperatura', 860.0000, 'ºC'),
	(35332, 108, '2015-02-01 01:12:19.000000', 'temperatura', 67.0000, 'ºC'),
	(35333, 108, '2015-02-01 01:12:20.000000', 'temperatura', 157.0000, 'ºC'),
	(35334, 108, '2015-02-01 01:12:21.000000', 'temperatura', 584.0000, 'ºC'),
	(35335, 108, '2015-02-01 01:12:22.000000', 'temperatura', 51.0000, 'ºC'),
	(35336, 108, '2015-02-01 01:12:23.000000', 'temperatura', 900.0000, 'ºC'),
	(35337, 108, '2015-02-01 01:12:24.000000', 'temperatura', 751.0000, 'ºC'),
	(35338, 108, '2015-02-01 01:12:25.000000', 'temperatura', 1052.0000, 'ºC'),
	(35339, 108, '2015-02-01 01:12:26.000000', 'temperatura', 609.0000, 'ºC'),
	(35340, 108, '2015-02-01 01:12:27.000000', 'temperatura', 1092.0000, 'ºC'),
	(35341, 108, '2015-02-01 01:12:28.000000', 'temperatura', 30.0000, 'ºC'),
	(35342, 108, '2015-02-01 01:12:29.000000', 'temperatura', 475.0000, 'ºC'),
	(35343, 108, '2015-02-01 01:12:30.000000', 'temperatura', 1086.0000, 'ºC'),
	(35344, 108, '2015-02-01 01:12:31.000000', 'temperatura', 407.0000, 'ºC'),
	(35345, 108, '2015-02-01 01:12:32.000000', 'temperatura', 1176.0000, 'ºC'),
	(35346, 108, '2015-02-01 01:12:33.000000', 'temperatura', 1059.0000, 'ºC'),
	(35347, 108, '2015-02-01 01:12:34.000000', 'temperatura', 568.0000, 'ºC'),
	(35348, 108, '2015-02-01 01:12:35.000000', 'temperatura', 862.0000, 'ºC'),
	(35349, 108, '2015-02-01 01:12:36.000000', 'temperatura', 206.0000, 'ºC'),
	(35350, 108, '2015-02-01 01:12:37.000000', 'temperatura', 845.0000, 'ºC'),
	(35351, 108, '2015-02-01 01:12:38.000000', 'temperatura', 9.0000, 'ºC'),
	(35352, 108, '2015-02-01 01:12:39.000000', 'temperatura', 1111.0000, 'ºC'),
	(35353, 108, '2015-02-01 01:12:40.000000', 'temperatura', 728.0000, 'ºC'),
	(35354, 108, '2015-02-01 01:12:41.000000', 'temperatura', 308.0000, 'ºC'),
	(35355, 108, '2015-02-01 01:12:42.000000', 'temperatura', 554.0000, 'ºC'),
	(35356, 108, '2015-02-01 01:12:43.000000', 'temperatura', 649.0000, 'ºC'),
	(35357, 108, '2015-02-01 01:12:44.000000', 'temperatura', 383.0000, 'ºC'),
	(35358, 108, '2015-02-01 01:12:45.000000', 'temperatura', 1167.0000, 'ºC'),
	(35359, 108, '2015-02-01 01:12:46.000000', 'temperatura', 1089.0000, 'ºC'),
	(35360, 108, '2015-02-01 01:12:47.000000', 'temperatura', 742.0000, 'ºC'),
	(35361, 108, '2015-02-01 01:12:48.000000', 'temperatura', 443.0000, 'ºC'),
	(35362, 108, '2015-02-01 01:12:49.000000', 'temperatura', 1192.0000, 'ºC'),
	(35363, 108, '2015-02-01 01:12:50.000000', 'temperatura', 1032.0000, 'ºC'),
	(35364, 108, '2015-02-01 01:12:51.000000', 'temperatura', 385.0000, 'ºC'),
	(35365, 108, '2015-02-01 01:12:52.000000', 'temperatura', 29.0000, 'ºC'),
	(35366, 108, '2015-02-01 01:12:53.000000', 'temperatura', 191.0000, 'ºC'),
	(35367, 108, '2015-02-01 01:12:54.000000', 'temperatura', 868.0000, 'ºC'),
	(35368, 108, '2015-02-01 01:12:55.000000', 'temperatura', 168.0000, 'ºC'),
	(35369, 108, '2015-02-01 01:12:56.000000', 'temperatura', 638.0000, 'ºC'),
	(35370, 108, '2015-02-01 01:12:57.000000', 'temperatura', 283.0000, 'ºC'),
	(35371, 108, '2015-02-01 01:12:58.000000', 'temperatura', 704.0000, 'ºC'),
	(35372, 108, '2015-02-01 01:12:59.000000', 'temperatura', 272.0000, 'ºC'),
	(35373, 108, '2015-02-01 01:13:00.000000', 'temperatura', 448.0000, 'ºC'),
	(35374, 108, '2015-02-01 01:13:01.000000', 'temperatura', 223.0000, 'ºC'),
	(35375, 108, '2015-02-01 01:13:02.000000', 'temperatura', 972.0000, 'ºC'),
	(35376, 108, '2015-02-01 01:13:03.000000', 'temperatura', 593.0000, 'ºC'),
	(35377, 108, '2015-02-01 01:13:04.000000', 'temperatura', 50.0000, 'ºC'),
	(35378, 108, '2015-02-01 01:13:05.000000', 'temperatura', 871.0000, 'ºC'),
	(35379, 108, '2015-02-01 01:13:06.000000', 'temperatura', 607.0000, 'ºC'),
	(35380, 108, '2015-02-01 01:13:07.000000', 'temperatura', 423.0000, 'ºC'),
	(35381, 108, '2015-02-01 01:13:08.000000', 'temperatura', 292.0000, 'ºC'),
	(35382, 108, '2015-02-01 01:13:09.000000', 'temperatura', 191.0000, 'ºC'),
	(35383, 108, '2015-02-01 01:13:10.000000', 'temperatura', 81.0000, 'ºC'),
	(35384, 108, '2015-02-01 01:13:11.000000', 'temperatura', 1031.0000, 'ºC'),
	(35385, 108, '2015-02-01 01:13:12.000000', 'temperatura', 111.0000, 'ºC'),
	(35386, 108, '2015-02-01 01:13:13.000000', 'temperatura', 1065.0000, 'ºC'),
	(35387, 108, '2015-02-01 01:13:14.000000', 'temperatura', 194.0000, 'ºC'),
	(35388, 108, '2015-02-01 01:13:15.000000', 'temperatura', 173.0000, 'ºC'),
	(35389, 108, '2015-02-01 01:13:16.000000', 'temperatura', 284.0000, 'ºC'),
	(35390, 108, '2015-02-01 01:13:17.000000', 'temperatura', 904.0000, 'ºC'),
	(35391, 108, '2015-02-01 01:13:18.000000', 'temperatura', 66.0000, 'ºC'),
	(35392, 108, '2015-02-01 01:13:19.000000', 'temperatura', 18.0000, 'ºC'),
	(35393, 108, '2015-02-01 01:13:20.000000', 'temperatura', 1094.0000, 'ºC'),
	(35394, 108, '2015-02-01 01:13:21.000000', 'temperatura', 615.0000, 'ºC'),
	(35395, 108, '2015-02-01 01:13:22.000000', 'temperatura', 994.0000, 'ºC'),
	(35396, 108, '2015-02-01 01:13:23.000000', 'temperatura', 728.0000, 'ºC'),
	(35397, 108, '2015-02-01 01:13:24.000000', 'temperatura', 656.0000, 'ºC'),
	(35398, 108, '2015-02-01 01:13:25.000000', 'temperatura', 1096.0000, 'ºC'),
	(35399, 108, '2015-02-01 01:13:26.000000', 'temperatura', 1113.0000, 'ºC'),
	(35400, 108, '2015-02-01 01:13:27.000000', 'temperatura', 1078.0000, 'ºC'),
	(35401, 108, '2015-02-01 01:13:28.000000', 'temperatura', 853.0000, 'ºC'),
	(35402, 108, '2015-02-01 01:13:29.000000', 'temperatura', 1031.0000, 'ºC'),
	(35403, 108, '2015-02-01 01:13:30.000000', 'temperatura', 197.0000, 'ºC'),
	(35404, 108, '2015-02-01 01:13:31.000000', 'temperatura', 292.0000, 'ºC'),
	(35405, 108, '2015-02-01 01:13:32.000000', 'temperatura', 871.0000, 'ºC'),
	(35406, 108, '2015-02-01 01:13:33.000000', 'temperatura', 1079.0000, 'ºC'),
	(35407, 108, '2015-02-01 01:13:34.000000', 'temperatura', 382.0000, 'ºC'),
	(35408, 108, '2015-02-01 01:13:35.000000', 'temperatura', 1075.0000, 'ºC'),
	(35409, 108, '2015-02-01 01:13:36.000000', 'temperatura', 628.0000, 'ºC'),
	(35410, 108, '2015-02-01 01:13:37.000000', 'temperatura', 1115.0000, 'ºC'),
	(35411, 108, '2015-02-01 01:13:38.000000', 'temperatura', 94.0000, 'ºC'),
	(35412, 108, '2015-02-01 01:13:39.000000', 'temperatura', 723.0000, 'ºC'),
	(35413, 108, '2015-02-01 01:13:40.000000', 'temperatura', 936.0000, 'ºC'),
	(35414, 108, '2015-02-01 01:13:41.000000', 'temperatura', 109.0000, 'ºC'),
	(35415, 108, '2015-02-01 01:13:42.000000', 'temperatura', 138.0000, 'ºC'),
	(35416, 108, '2015-02-01 01:13:43.000000', 'temperatura', 362.0000, 'ºC'),
	(35417, 108, '2015-02-01 01:13:44.000000', 'temperatura', 200.0000, 'ºC'),
	(35418, 108, '2015-02-01 01:13:45.000000', 'temperatura', 1111.0000, 'ºC'),
	(35419, 108, '2015-02-01 01:13:46.000000', 'temperatura', 158.0000, 'ºC'),
	(35420, 108, '2015-02-01 01:13:47.000000', 'temperatura', 1058.0000, 'ºC'),
	(35421, 108, '2015-02-01 01:13:48.000000', 'temperatura', 17.0000, 'ºC'),
	(35422, 108, '2015-02-01 01:13:49.000000', 'temperatura', 508.0000, 'ºC'),
	(35423, 108, '2015-02-01 01:13:50.000000', 'temperatura', 93.0000, 'ºC'),
	(35424, 108, '2015-02-01 01:13:51.000000', 'temperatura', 140.0000, 'ºC'),
	(35425, 108, '2015-02-01 01:13:52.000000', 'temperatura', 421.0000, 'ºC'),
	(35426, 108, '2015-02-01 01:13:53.000000', 'temperatura', 485.0000, 'ºC'),
	(35427, 108, '2015-02-01 01:13:54.000000', 'temperatura', 1162.0000, 'ºC'),
	(35428, 108, '2015-02-01 01:13:55.000000', 'temperatura', 758.0000, 'ºC'),
	(35429, 108, '2015-02-01 01:13:56.000000', 'temperatura', 302.0000, 'ºC'),
	(35430, 108, '2015-02-01 01:13:57.000000', 'temperatura', 436.0000, 'ºC'),
	(35431, 108, '2015-02-01 01:13:58.000000', 'temperatura', 75.0000, 'ºC'),
	(35432, 108, '2015-02-01 01:13:59.000000', 'temperatura', 267.0000, 'ºC'),
	(35433, 108, '2015-02-01 01:14:00.000000', 'temperatura', 1112.0000, 'ºC'),
	(35434, 108, '2015-02-01 01:14:01.000000', 'temperatura', 1158.0000, 'ºC'),
	(35435, 108, '2015-02-01 01:14:02.000000', 'temperatura', 55.0000, 'ºC'),
	(35436, 108, '2015-02-01 01:14:03.000000', 'temperatura', 400.0000, 'ºC'),
	(35437, 108, '2015-02-01 01:14:04.000000', 'temperatura', 637.0000, 'ºC'),
	(35438, 108, '2015-02-01 01:14:05.000000', 'temperatura', 784.0000, 'ºC'),
	(35439, 108, '2015-02-01 01:14:06.000000', 'temperatura', 809.0000, 'ºC'),
	(35440, 108, '2015-02-01 01:14:07.000000', 'temperatura', 494.0000, 'ºC'),
	(35441, 108, '2015-02-01 01:14:08.000000', 'temperatura', 45.0000, 'ºC'),
	(35442, 108, '2015-02-01 01:14:09.000000', 'temperatura', 1142.0000, 'ºC'),
	(35443, 108, '2015-02-01 01:14:10.000000', 'temperatura', 776.0000, 'ºC'),
	(35444, 108, '2015-02-01 01:14:11.000000', 'temperatura', 453.0000, 'ºC'),
	(35445, 108, '2015-02-01 01:14:12.000000', 'temperatura', 1139.0000, 'ºC'),
	(35446, 108, '2015-02-01 01:14:13.000000', 'temperatura', 737.0000, 'ºC'),
	(35447, 108, '2015-02-01 01:14:14.000000', 'temperatura', 268.0000, 'ºC'),
	(35448, 108, '2015-02-01 01:14:15.000000', 'temperatura', 329.0000, 'ºC'),
	(35449, 108, '2015-02-01 01:14:16.000000', 'temperatura', 844.0000, 'ºC'),
	(35450, 108, '2015-02-01 01:14:17.000000', 'temperatura', 830.0000, 'ºC'),
	(35451, 108, '2015-02-01 01:14:18.000000', 'temperatura', 421.0000, 'ºC'),
	(35452, 108, '2015-02-01 01:14:19.000000', 'temperatura', 814.0000, 'ºC'),
	(35453, 108, '2015-02-01 01:14:20.000000', 'temperatura', 406.0000, 'ºC'),
	(35454, 108, '2015-02-01 01:14:21.000000', 'temperatura', 790.0000, 'ºC'),
	(35455, 108, '2015-02-01 01:14:22.000000', 'temperatura', 331.0000, 'ºC'),
	(35456, 108, '2015-02-01 01:14:23.000000', 'temperatura', 485.0000, 'ºC'),
	(35457, 108, '2015-02-01 01:14:24.000000', 'temperatura', 234.0000, 'ºC'),
	(35458, 108, '2015-02-01 01:14:25.000000', 'temperatura', 914.0000, 'ºC'),
	(35459, 108, '2015-02-01 01:14:26.000000', 'temperatura', 268.0000, 'ºC'),
	(35460, 108, '2015-02-01 01:14:27.000000', 'temperatura', 1001.0000, 'ºC'),
	(35461, 108, '2015-02-01 01:14:28.000000', 'temperatura', 601.0000, 'ºC'),
	(35462, 108, '2015-02-01 01:14:29.000000', 'temperatura', 0.0000, 'ºC'),
	(35463, 108, '2015-02-01 01:14:30.000000', 'temperatura', 599.0000, 'ºC'),
	(35464, 108, '2015-02-01 01:14:31.000000', 'temperatura', 595.0000, 'ºC'),
	(35465, 108, '2015-02-01 01:14:32.000000', 'temperatura', 1178.0000, 'ºC'),
	(35466, 108, '2015-02-01 01:14:33.000000', 'temperatura', 506.0000, 'ºC'),
	(35467, 108, '2015-02-01 01:14:34.000000', 'temperatura', 198.0000, 'ºC'),
	(35468, 108, '2015-02-01 01:14:35.000000', 'temperatura', 671.0000, 'ºC'),
	(35469, 108, '2015-02-01 01:14:36.000000', 'temperatura', 361.0000, 'ºC'),
	(35470, 108, '2015-02-01 01:14:37.000000', 'temperatura', 995.0000, 'ºC'),
	(35471, 108, '2015-02-01 01:14:38.000000', 'temperatura', 290.0000, 'ºC'),
	(35472, 108, '2015-02-01 01:14:39.000000', 'temperatura', 867.0000, 'ºC'),
	(35473, 108, '2015-02-01 01:14:40.000000', 'temperatura', 1067.0000, 'ºC'),
	(35474, 108, '2015-02-01 01:14:41.000000', 'temperatura', 332.0000, 'ºC'),
	(35475, 108, '2015-02-01 01:14:42.000000', 'temperatura', 860.0000, 'ºC'),
	(35476, 108, '2015-02-01 01:14:43.000000', 'temperatura', 904.0000, 'ºC'),
	(35477, 108, '2015-02-01 01:14:44.000000', 'temperatura', 742.0000, 'ºC'),
	(35478, 108, '2015-02-01 01:14:45.000000', 'temperatura', 999.0000, 'ºC'),
	(35479, 108, '2015-02-01 01:14:46.000000', 'temperatura', 369.0000, 'ºC'),
	(35480, 108, '2015-02-01 01:14:47.000000', 'temperatura', 48.0000, 'ºC'),
	(35481, 108, '2015-02-01 01:14:48.000000', 'temperatura', 334.0000, 'ºC'),
	(35482, 108, '2015-02-01 01:14:49.000000', 'temperatura', 328.0000, 'ºC'),
	(35483, 108, '2015-02-01 01:14:50.000000', 'temperatura', 639.0000, 'ºC'),
	(35484, 108, '2015-02-01 01:14:51.000000', 'temperatura', 1009.0000, 'ºC'),
	(35485, 108, '2015-02-01 01:14:52.000000', 'temperatura', 731.0000, 'ºC'),
	(35486, 108, '2015-02-01 01:14:53.000000', 'temperatura', 626.0000, 'ºC'),
	(35487, 108, '2015-02-01 01:14:54.000000', 'temperatura', 939.0000, 'ºC'),
	(35488, 108, '2015-02-01 01:14:55.000000', 'temperatura', 416.0000, 'ºC'),
	(35489, 108, '2015-02-01 01:14:56.000000', 'temperatura', 465.0000, 'ºC'),
	(35490, 108, '2015-02-01 01:14:57.000000', 'temperatura', 1077.0000, 'ºC'),
	(35491, 108, '2015-02-01 01:14:58.000000', 'temperatura', 391.0000, 'ºC'),
	(35492, 108, '2015-02-01 01:14:59.000000', 'temperatura', 1126.0000, 'ºC'),
	(35493, 108, '2015-02-01 01:15:00.000000', 'temperatura', 856.0000, 'ºC'),
	(35494, 108, '2015-02-01 01:15:01.000000', 'temperatura', 904.0000, 'ºC'),
	(35495, 108, '2015-02-01 01:15:02.000000', 'temperatura', 752.0000, 'ºC'),
	(35496, 108, '2015-02-01 01:15:03.000000', 'temperatura', 1048.0000, 'ºC'),
	(35497, 108, '2015-02-01 01:15:04.000000', 'temperatura', 585.0000, 'ºC'),
	(35498, 108, '2015-02-01 01:15:05.000000', 'temperatura', 982.0000, 'ºC'),
	(35499, 108, '2015-02-01 01:15:06.000000', 'temperatura', 756.0000, 'ºC'),
	(35500, 108, '2015-02-01 01:15:07.000000', 'temperatura', 835.0000, 'ºC'),
	(35501, 108, '2015-02-01 01:15:08.000000', 'temperatura', 707.0000, 'ºC'),
	(35502, 108, '2015-02-01 01:15:09.000000', 'temperatura', 1031.0000, 'ºC'),
	(35503, 108, '2015-02-01 01:15:10.000000', 'temperatura', 634.0000, 'ºC'),
	(35504, 108, '2015-02-01 01:15:11.000000', 'temperatura', 77.0000, 'ºC'),
	(35505, 108, '2015-02-01 01:15:12.000000', 'temperatura', 882.0000, 'ºC'),
	(35506, 108, '2015-02-01 01:15:13.000000', 'temperatura', 582.0000, 'ºC'),
	(35507, 108, '2015-02-01 01:15:14.000000', 'temperatura', 262.0000, 'ºC'),
	(35508, 108, '2015-02-01 01:15:15.000000', 'temperatura', 766.0000, 'ºC'),
	(35509, 108, '2015-02-01 01:15:16.000000', 'temperatura', 644.0000, 'ºC'),
	(35510, 108, '2015-02-01 01:15:17.000000', 'temperatura', 924.0000, 'ºC'),
	(35511, 108, '2015-02-01 01:15:18.000000', 'temperatura', 289.0000, 'ºC'),
	(35512, 108, '2015-02-01 01:15:19.000000', 'temperatura', 1071.0000, 'ºC'),
	(35513, 108, '2015-02-01 01:15:20.000000', 'temperatura', 891.0000, 'ºC'),
	(35514, 108, '2015-02-01 01:15:21.000000', 'temperatura', 43.0000, 'ºC'),
	(35515, 108, '2015-02-01 01:15:22.000000', 'temperatura', 1142.0000, 'ºC'),
	(35516, 108, '2015-02-01 01:15:23.000000', 'temperatura', 780.0000, 'ºC'),
	(35517, 108, '2015-02-01 01:15:24.000000', 'temperatura', 477.0000, 'ºC'),
	(35518, 108, '2015-02-01 01:15:25.000000', 'temperatura', 44.0000, 'ºC'),
	(35519, 108, '2015-02-01 01:15:26.000000', 'temperatura', 1192.0000, 'ºC'),
	(35520, 108, '2015-02-01 01:15:27.000000', 'temperatura', 1026.0000, 'ºC'),
	(35521, 108, '2015-02-01 01:15:28.000000', 'temperatura', 355.0000, 'ºC'),
	(35522, 108, '2015-02-01 01:15:29.000000', 'temperatura', 1096.0000, 'ºC'),
	(35523, 108, '2015-02-01 01:15:30.000000', 'temperatura', 817.0000, 'ºC'),
	(35524, 108, '2015-02-01 01:15:31.000000', 'temperatura', 797.0000, 'ºC'),
	(35525, 108, '2015-02-01 01:15:32.000000', 'temperatura', 336.0000, 'ºC'),
	(35526, 108, '2015-02-01 01:15:33.000000', 'temperatura', 489.0000, 'ºC'),
	(35527, 108, '2015-02-01 01:15:34.000000', 'temperatura', 236.0000, 'ºC'),
	(35528, 108, '2015-02-01 01:15:35.000000', 'temperatura', 913.0000, 'ºC'),
	(35529, 108, '2015-02-01 01:15:36.000000', 'temperatura', 258.0000, 'ºC'),
	(35530, 108, '2015-02-01 01:15:37.000000', 'temperatura', 954.0000, 'ºC'),
	(35531, 108, '2015-02-01 01:15:38.000000', 'temperatura', 394.0000, 'ºC'),
	(35532, 108, '2015-02-01 01:15:39.000000', 'temperatura', 311.0000, 'ºC'),
	(35533, 108, '2015-02-01 01:15:40.000000', 'temperatura', 372.0000, 'ºC'),
	(35534, 108, '2015-02-01 01:15:41.000000', 'temperatura', 927.0000, 'ºC'),
	(35535, 108, '2015-02-01 01:15:42.000000', 'temperatura', 1119.0000, 'ºC'),
	(35536, 108, '2015-02-01 01:15:43.000000', 'temperatura', 414.0000, 'ºC'),
	(35537, 108, '2015-02-01 01:15:44.000000', 'temperatura', 1114.0000, 'ºC'),
	(35538, 108, '2015-02-01 01:15:45.000000', 'temperatura', 727.0000, 'ºC'),
	(35539, 108, '2015-02-01 01:15:46.000000', 'temperatura', 295.0000, 'ºC'),
	(35540, 108, '2015-02-01 01:15:47.000000', 'temperatura', 494.0000, 'ºC'),
	(35541, 108, '2015-02-01 01:15:48.000000', 'temperatura', 384.0000, 'ºC'),
	(35542, 108, '2015-02-01 01:15:49.000000', 'temperatura', 438.0000, 'ºC'),
	(35543, 108, '2015-02-01 01:15:50.000000', 'temperatura', 1041.0000, 'ºC'),
	(35544, 108, '2015-02-01 01:15:51.000000', 'temperatura', 293.0000, 'ºC'),
	(35545, 108, '2015-02-01 01:15:52.000000', 'temperatura', 740.0000, 'ºC'),
	(35546, 108, '2015-02-01 01:15:53.000000', 'temperatura', 420.0000, 'ºC'),
	(35547, 108, '2015-02-01 01:15:54.000000', 'temperatura', 1083.0000, 'ºC'),
	(35548, 108, '2015-02-01 01:15:55.000000', 'temperatura', 556.0000, 'ºC'),
	(35549, 108, '2015-02-01 01:15:56.000000', 'temperatura', 732.0000, 'ºC'),
	(35550, 108, '2015-02-01 01:15:57.000000', 'temperatura', 789.0000, 'ºC'),
	(35551, 108, '2015-02-01 01:15:58.000000', 'temperatura', 553.0000, 'ºC'),
	(35552, 108, '2015-02-01 01:15:59.000000', 'temperatura', 398.0000, 'ºC'),
	(35553, 108, '2015-02-01 01:16:00.000000', 'temperatura', 332.0000, 'ºC'),
	(35554, 108, '2015-02-01 01:16:01.000000', 'temperatura', 464.0000, 'ºC'),
	(35555, 108, '2015-02-01 01:16:02.000000', 'temperatura', 125.0000, 'ºC'),
	(35556, 108, '2015-02-01 01:16:03.000000', 'temperatura', 435.0000, 'ºC'),
	(35557, 108, '2015-02-01 01:16:04.000000', 'temperatura', 600.0000, 'ºC'),
	(35558, 108, '2015-02-01 01:16:05.000000', 'temperatura', 494.0000, 'ºC'),
	(35559, 108, '2015-02-01 01:16:06.000000', 'temperatura', 670.0000, 'ºC'),
	(35560, 108, '2015-02-01 01:16:07.000000', 'temperatura', 670.0000, 'ºC'),
	(35561, 108, '2015-02-01 01:16:08.000000', 'temperatura', 138.0000, 'ºC'),
	(35562, 108, '2015-02-01 01:16:09.000000', 'temperatura', 1083.0000, 'ºC'),
	(35563, 108, '2015-02-01 01:16:10.000000', 'temperatura', 201.0000, 'ºC'),
	(35564, 108, '2015-02-01 01:16:11.000000', 'temperatura', 158.0000, 'ºC'),
	(35565, 108, '2015-02-01 01:16:12.000000', 'temperatura', 186.0000, 'ºC'),
	(35566, 108, '2015-02-01 01:16:13.000000', 'temperatura', 457.0000, 'ºC'),
	(35567, 108, '2015-02-01 01:16:14.000000', 'temperatura', 526.0000, 'ºC'),
	(35568, 108, '2015-02-01 01:16:15.000000', 'temperatura', 59.0000, 'ºC'),
	(35569, 108, '2015-02-01 01:16:16.000000', 'temperatura', 1118.0000, 'ºC'),
	(35570, 108, '2015-02-01 01:16:17.000000', 'temperatura', 614.0000, 'ºC'),
	(35571, 108, '2015-02-01 01:16:18.000000', 'temperatura', 919.0000, 'ºC'),
	(35572, 108, '2015-02-01 01:16:19.000000', 'temperatura', 350.0000, 'ºC'),
	(35573, 108, '2015-02-01 01:16:20.000000', 'temperatura', 193.0000, 'ºC'),
	(35574, 108, '2015-02-01 01:16:21.000000', 'temperatura', 1118.0000, 'ºC'),
	(35575, 108, '2015-02-01 01:16:22.000000', 'temperatura', 212.0000, 'ºC'),
	(35576, 108, '2015-02-01 01:16:23.000000', 'temperatura', 107.0000, 'ºC'),
	(35577, 108, '2015-02-01 01:16:24.000000', 'temperatura', 1098.0000, 'ºC'),
	(35578, 108, '2015-02-01 01:16:25.000000', 'temperatura', 369.0000, 'ºC'),
	(35579, 108, '2015-02-01 01:16:26.000000', 'temperatura', 951.0000, 'ºC'),
	(35580, 108, '2015-02-01 01:16:27.000000', 'temperatura', 51.0000, 'ºC'),
	(35581, 108, '2015-02-01 01:16:28.000000', 'temperatura', 999.0000, 'ºC'),
	(35582, 108, '2015-02-01 01:16:29.000000', 'temperatura', 45.0000, 'ºC'),
	(35583, 108, '2015-02-01 01:16:30.000000', 'temperatura', 830.0000, 'ºC'),
	(35584, 108, '2015-02-01 01:16:31.000000', 'temperatura', 414.0000, 'ºC'),
	(35585, 108, '2015-02-01 01:16:32.000000', 'temperatura', 779.0000, 'ºC'),
	(35586, 108, '2015-02-01 01:16:33.000000', 'temperatura', 255.0000, 'ºC'),
	(35587, 108, '2015-02-01 01:16:34.000000', 'temperatura', 139.0000, 'ºC'),
	(35588, 108, '2015-02-01 01:16:35.000000', 'temperatura', 1129.0000, 'ºC'),
	(35589, 108, '2015-02-01 01:16:36.000000', 'temperatura', 430.0000, 'ºC'),
	(35590, 108, '2015-02-01 01:16:37.000000', 'temperatura', 1164.0000, 'ºC'),
	(35591, 108, '2015-02-01 01:16:38.000000', 'temperatura', 928.0000, 'ºC'),
	(35592, 108, '2015-02-01 01:16:39.000000', 'temperatura', 1151.0000, 'ºC'),
	(35593, 108, '2015-02-01 01:16:40.000000', 'temperatura', 573.0000, 'ºC'),
	(35594, 108, '2015-02-01 01:16:41.000000', 'temperatura', 610.0000, 'ºC'),
	(35595, 108, '2015-02-01 01:16:42.000000', 'temperatura', 131.0000, 'ºC'),
	(35596, 108, '2015-02-01 01:16:43.000000', 'temperatura', 27.0000, 'ºC'),
	(35597, 108, '2015-02-01 01:16:44.000000', 'temperatura', 940.0000, 'ºC'),
	(35598, 108, '2015-02-01 01:16:45.000000', 'temperatura', 1022.0000, 'ºC'),
	(35599, 108, '2015-02-01 01:16:46.000000', 'temperatura', 1088.0000, 'ºC'),
	(35600, 108, '2015-02-01 01:16:47.000000', 'temperatura', 1174.0000, 'ºC'),
	(35601, 108, '2015-02-01 01:16:48.000000', 'temperatura', 207.0000, 'ºC'),
	(35602, 108, '2015-02-01 01:16:49.000000', 'temperatura', 1115.0000, 'ºC'),
	(35603, 108, '2015-02-01 01:16:50.000000', 'temperatura', 154.0000, 'ºC'),
	(35604, 108, '2015-02-01 01:16:51.000000', 'temperatura', 1026.0000, 'ºC'),
	(35605, 108, '2015-02-01 01:16:52.000000', 'temperatura', 1070.0000, 'ºC'),
	(35606, 108, '2015-02-01 01:16:53.000000', 'temperatura', 1071.0000, 'ºC'),
	(35607, 108, '2015-02-01 01:16:54.000000', 'temperatura', 945.0000, 'ºC'),
	(35608, 108, '2015-02-01 01:16:55.000000', 'temperatura', 313.0000, 'ºC'),
	(35609, 108, '2015-02-01 01:16:56.000000', 'temperatura', 1132.0000, 'ºC'),
	(35610, 108, '2015-02-01 01:16:57.000000', 'temperatura', 1121.0000, 'ºC'),
	(35611, 108, '2015-02-01 01:16:58.000000', 'temperatura', 1010.0000, 'ºC'),
	(35612, 108, '2015-02-01 01:16:59.000000', 'temperatura', 485.0000, 'ºC'),
	(35613, 108, '2015-02-01 01:17:00.000000', 'temperatura', 597.0000, 'ºC'),
	(35614, 108, '2015-02-01 01:17:01.000000', 'temperatura', 332.0000, 'ºC'),
	(35615, 108, '2015-02-01 01:17:02.000000', 'temperatura', 1067.0000, 'ºC'),
	(35616, 108, '2015-02-01 01:17:03.000000', 'temperatura', 739.0000, 'ºC'),
	(35617, 108, '2015-02-01 01:17:04.000000', 'temperatura', 495.0000, 'ºC'),
	(35618, 108, '2015-02-01 01:17:05.000000', 'temperatura', 258.0000, 'ºC'),
	(35619, 108, '2015-02-01 01:17:06.000000', 'temperatura', 1005.0000, 'ºC'),
	(35620, 108, '2015-02-01 01:17:07.000000', 'temperatura', 654.0000, 'ºC'),
	(35621, 108, '2015-02-01 01:17:08.000000', 'temperatura', 253.0000, 'ºC'),
	(35622, 108, '2015-02-01 01:17:09.000000', 'temperatura', 506.0000, 'ºC'),
	(35623, 108, '2015-02-01 01:17:10.000000', 'temperatura', 571.0000, 'ºC'),
	(35624, 108, '2015-02-01 01:17:11.000000', 'temperatura', 136.0000, 'ºC'),
	(35625, 108, '2015-02-01 01:17:12.000000', 'temperatura', 170.0000, 'ºC'),
	(35626, 108, '2015-02-01 01:17:13.000000', 'temperatura', 441.0000, 'ºC'),
	(35627, 108, '2015-02-01 01:17:14.000000', 'temperatura', 496.0000, 'ºC'),
	(35628, 108, '2015-02-01 01:17:15.000000', 'temperatura', 1158.0000, 'ºC'),
	(35629, 108, '2015-02-01 01:17:16.000000', 'temperatura', 704.0000, 'ºC'),
	(35630, 108, '2015-02-01 01:17:17.000000', 'temperatura', 46.0000, 'ºC'),
	(35631, 108, '2015-02-01 01:17:18.000000', 'temperatura', 516.0000, 'ºC'),
	(35632, 108, '2015-02-01 01:17:19.000000', 'temperatura', 45.0000, 'ºC'),
	(35633, 108, '2015-02-01 01:17:20.000000', 'temperatura', 1079.0000, 'ºC'),
	(35634, 108, '2015-02-01 01:17:21.000000', 'temperatura', 457.0000, 'ºC'),
	(35635, 108, '2015-02-01 01:17:22.000000', 'temperatura', 250.0000, 'ºC'),
	(35636, 108, '2015-02-01 01:17:23.000000', 'temperatura', 1079.0000, 'ºC'),
	(35637, 108, '2015-02-01 01:17:24.000000', 'temperatura', 1045.0000, 'ºC'),
	(35638, 108, '2015-02-01 01:17:25.000000', 'temperatura', 789.0000, 'ºC'),
	(35639, 108, '2015-02-01 01:17:26.000000', 'temperatura', 812.0000, 'ºC'),
	(35640, 108, '2015-02-01 01:17:27.000000', 'temperatura', 493.0000, 'ºC'),
	(35641, 108, '2015-02-01 01:17:28.000000', 'temperatura', 30.0000, 'ºC'),
	(35642, 108, '2015-02-01 01:17:29.000000', 'temperatura', 1070.0000, 'ºC'),
	(35643, 108, '2015-02-01 01:17:30.000000', 'temperatura', 460.0000, 'ºC'),
	(35644, 108, '2015-02-01 01:17:31.000000', 'temperatura', 290.0000, 'ºC'),
	(35645, 108, '2015-02-01 01:17:32.000000', 'temperatura', 72.0000, 'ºC'),
	(35646, 108, '2015-02-01 01:17:33.000000', 'temperatura', 689.0000, 'ºC'),
	(35647, 108, '2015-02-01 01:17:34.000000', 'temperatura', 831.0000, 'ºC'),
	(35648, 108, '2015-02-01 01:17:35.000000', 'temperatura', 887.0000, 'ºC'),
	(35649, 108, '2015-02-01 01:17:36.000000', 'temperatura', 741.0000, 'ºC'),
	(35650, 108, '2015-02-01 01:17:37.000000', 'temperatura', 1048.0000, 'ºC'),
	(35651, 108, '2015-02-01 01:17:38.000000', 'temperatura', 616.0000, 'ºC'),
	(35652, 108, '2015-02-01 01:17:39.000000', 'temperatura', 1137.0000, 'ºC'),
	(35653, 108, '2015-02-01 01:17:40.000000', 'temperatura', 235.0000, 'ºC'),
	(35654, 108, '2015-02-01 01:17:41.000000', 'temperatura', 168.0000, 'ºC'),
	(35655, 108, '2015-02-01 01:17:42.000000', 'temperatura', 133.0000, 'ºC'),
	(35656, 108, '2015-02-01 01:17:43.000000', 'temperatura', 164.0000, 'ºC'),
	(35657, 108, '2015-02-01 01:17:44.000000', 'temperatura', 421.0000, 'ºC'),
	(35658, 109, '2015-02-01 00:00:00.000000', 'temperatura', 797.0000, 'ºC'),
	(35659, 109, '2015-02-01 00:00:01.000000', 'temperatura', 351.0000, 'ºC'),
	(35660, 109, '2015-02-01 00:00:02.000000', 'temperatura', 564.0000, 'ºC'),
	(35661, 109, '2015-02-01 00:00:03.000000', 'temperatura', 567.0000, 'ºC'),
	(35662, 109, '2015-02-01 00:00:04.000000', 'temperatura', 1144.0000, 'ºC'),
	(35663, 109, '2015-02-01 00:00:05.000000', 'temperatura', 421.0000, 'ºC'),
	(35664, 109, '2015-02-01 00:00:06.000000', 'temperatura', 1073.0000, 'ºC'),
	(35665, 109, '2015-02-01 00:00:07.000000', 'temperatura', 501.0000, 'ºC'),
	(35666, 109, '2015-02-01 00:00:08.000000', 'temperatura', 489.0000, 'ºC'),
	(35667, 109, '2015-02-01 00:00:09.000000', 'temperatura', 941.0000, 'ºC'),
	(35668, 109, '2015-02-01 00:00:10.000000', 'temperatura', 840.0000, 'ºC'),
	(35669, 109, '2015-02-01 00:00:11.000000', 'temperatura', 175.0000, 'ºC'),
	(35670, 109, '2015-02-01 00:00:12.000000', 'temperatura', 755.0000, 'ºC'),
	(35671, 109, '2015-02-01 00:00:13.000000', 'temperatura', 853.0000, 'ºC'),
	(35672, 109, '2015-02-01 00:00:14.000000', 'temperatura', 799.0000, 'ºC'),
	(35673, 109, '2015-02-01 00:00:15.000000', 'temperatura', 235.0000, 'ºC'),
	(35674, 109, '2015-02-01 00:00:16.000000', 'temperatura', 1180.0000, 'ºC'),
	(35675, 109, '2015-02-01 00:00:17.000000', 'temperatura', 395.0000, 'ºC'),
	(35676, 109, '2015-02-01 00:00:18.000000', 'temperatura', 836.0000, 'ºC'),
	(35677, 109, '2015-02-01 00:00:19.000000', 'temperatura', 593.0000, 'ºC'),
	(35678, 109, '2015-02-01 00:00:20.000000', 'temperatura', 460.0000, 'ºC'),
	(35679, 109, '2015-02-01 00:00:21.000000', 'temperatura', 522.0000, 'ºC'),
	(35680, 109, '2015-02-01 00:00:22.000000', 'temperatura', 29.0000, 'ºC'),
	(35681, 109, '2015-02-01 00:00:23.000000', 'temperatura', 978.0000, 'ºC'),
	(35682, 109, '2015-02-01 00:00:24.000000', 'temperatura', 7.0000, 'ºC'),
	(35683, 109, '2015-02-01 00:00:25.000000', 'temperatura', 698.0000, 'ºC'),
	(35684, 109, '2015-02-01 00:00:26.000000', 'temperatura', 1071.0000, 'ºC'),
	(35685, 109, '2015-02-01 00:00:27.000000', 'temperatura', 862.0000, 'ºC'),
	(35686, 109, '2015-02-01 00:00:28.000000', 'temperatura', 1096.0000, 'ºC'),
	(35687, 109, '2015-02-01 00:00:29.000000', 'temperatura', 494.0000, 'ºC'),
	(35688, 109, '2015-02-01 00:00:30.000000', 'temperatura', 383.0000, 'ºC'),
	(35689, 109, '2015-02-01 00:00:31.000000', 'temperatura', 434.0000, 'ºC'),
	(35690, 109, '2015-02-01 00:00:32.000000', 'temperatura', 1020.0000, 'ºC'),
	(35691, 109, '2015-02-01 00:00:33.000000', 'temperatura', 200.0000, 'ºC'),
	(35692, 109, '2015-02-01 00:00:34.000000', 'temperatura', 340.0000, 'ºC'),
	(35693, 109, '2015-02-01 00:00:35.000000', 'temperatura', 1103.0000, 'ºC'),
	(35694, 109, '2015-02-01 00:00:36.000000', 'temperatura', 892.0000, 'ºC'),
	(35695, 109, '2015-02-01 00:00:37.000000', 'temperatura', 1155.0000, 'ºC'),
	(35696, 109, '2015-02-01 00:00:38.000000', 'temperatura', 696.0000, 'ºC'),
	(35697, 109, '2015-02-01 00:00:39.000000', 'temperatura', 16.0000, 'ºC'),
	(35698, 109, '2015-02-01 00:00:40.000000', 'temperatura', 393.0000, 'ºC'),
	(35699, 109, '2015-02-01 00:00:41.000000', 'temperatura', 718.0000, 'ºC'),
	(35700, 109, '2015-02-01 00:00:42.000000', 'temperatura', 12.0000, 'ºC'),
	(35701, 109, '2015-02-01 00:00:43.000000', 'temperatura', 307.0000, 'ºC'),
	(35702, 109, '2015-02-01 00:00:44.000000', 'temperatura', 300.0000, 'ºC'),
	(35703, 109, '2015-02-01 00:00:45.000000', 'temperatura', 581.0000, 'ºC'),
	(35704, 109, '2015-02-01 00:00:46.000000', 'temperatura', 803.0000, 'ºC'),
	(35705, 109, '2015-02-01 00:00:47.000000', 'temperatura', 1072.0000, 'ºC'),
	(35706, 109, '2015-02-01 00:00:48.000000', 'temperatura', 553.0000, 'ºC'),
	(35707, 109, '2015-02-01 00:00:49.000000', 'temperatura', 750.0000, 'ºC'),
	(35708, 109, '2015-02-01 00:00:50.000000', 'temperatura', 891.0000, 'ºC'),
	(35709, 109, '2015-02-01 00:00:51.000000', 'temperatura', 1005.0000, 'ºC'),
	(35710, 109, '2015-02-01 00:00:52.000000', 'temperatura', 1151.0000, 'ºC'),
	(35711, 109, '2015-02-01 00:00:53.000000', 'temperatura', 341.0000, 'ºC'),
	(35712, 109, '2015-02-01 00:00:54.000000', 'temperatura', 655.0000, 'ºC'),
	(35713, 109, '2015-02-01 00:00:55.000000', 'temperatura', 1051.0000, 'ºC'),
	(35714, 109, '2015-02-01 00:00:56.000000', 'temperatura', 890.0000, 'ºC'),
	(35715, 109, '2015-02-01 00:00:57.000000', 'temperatura', 97.0000, 'ºC'),
	(35716, 109, '2015-02-01 00:00:58.000000', 'temperatura', 217.0000, 'ºC'),
	(35717, 109, '2015-02-01 00:00:59.000000', 'temperatura', 792.0000, 'ºC'),
	(35718, 109, '2015-02-01 00:01:00.000000', 'temperatura', 912.0000, 'ºC'),
	(35719, 109, '2015-02-01 00:01:01.000000', 'temperatura', 984.0000, 'ºC'),
	(35720, 109, '2015-02-01 00:01:02.000000', 'temperatura', 983.0000, 'ºC'),
	(35721, 109, '2015-02-01 00:01:03.000000', 'temperatura', 763.0000, 'ºC'),
	(35722, 109, '2015-02-01 00:01:04.000000', 'temperatura', 869.0000, 'ºC'),
	(35723, 109, '2015-02-01 00:01:05.000000', 'temperatura', 857.0000, 'ºC'),
	(35724, 109, '2015-02-01 00:01:06.000000', 'temperatura', 476.0000, 'ºC'),
	(35725, 109, '2015-02-01 00:01:07.000000', 'temperatura', 1012.0000, 'ºC'),
	(35726, 109, '2015-02-01 00:01:08.000000', 'temperatura', 31.0000, 'ºC'),
	(35727, 109, '2015-02-01 00:01:09.000000', 'temperatura', 721.0000, 'ºC'),
	(35728, 109, '2015-02-01 00:01:10.000000', 'temperatura', 1110.0000, 'ºC'),
	(35729, 109, '2015-02-01 00:01:11.000000', 'temperatura', 988.0000, 'ºC'),
	(35730, 109, '2015-02-01 00:01:12.000000', 'temperatura', 409.0000, 'ºC'),
	(35731, 109, '2015-02-01 00:01:13.000000', 'temperatura', 282.0000, 'ºC'),
	(35732, 109, '2015-02-01 00:01:14.000000', 'temperatura', 184.0000, 'ºC'),
	(35733, 109, '2015-02-01 00:01:15.000000', 'temperatura', 76.0000, 'ºC'),
	(35734, 109, '2015-02-01 00:01:16.000000', 'temperatura', 1029.0000, 'ºC'),
	(35735, 109, '2015-02-01 00:01:17.000000', 'temperatura', 116.0000, 'ºC'),
	(35736, 109, '2015-02-01 00:01:18.000000', 'temperatura', 1094.0000, 'ºC'),
	(35737, 109, '2015-02-01 00:01:19.000000', 'temperatura', 324.0000, 'ºC'),
	(35738, 109, '2015-02-01 00:01:20.000000', 'temperatura', 737.0000, 'ºC'),
	(35739, 109, '2015-02-01 00:01:21.000000', 'temperatura', 312.0000, 'ºC'),
	(35740, 109, '2015-02-01 00:01:22.000000', 'temperatura', 551.0000, 'ºC'),
	(35741, 109, '2015-02-01 00:01:23.000000', 'temperatura', 619.0000, 'ºC'),
	(35742, 109, '2015-02-01 00:01:24.000000', 'temperatura', 241.0000, 'ºC'),
	(35743, 109, '2015-02-01 00:01:25.000000', 'temperatura', 552.0000, 'ºC'),
	(35744, 109, '2015-02-01 00:01:26.000000', 'temperatura', 835.0000, 'ºC'),
	(35745, 109, '2015-02-01 00:01:27.000000', 'temperatura', 118.0000, 'ºC'),
	(35746, 109, '2015-02-01 00:01:28.000000', 'temperatura', 487.0000, 'ºC'),
	(35747, 109, '2015-02-01 00:01:29.000000', 'temperatura', 883.0000, 'ºC'),
	(35748, 109, '2015-02-01 00:01:30.000000', 'temperatura', 553.0000, 'ºC'),
	(35749, 109, '2015-02-01 00:01:31.000000', 'temperatura', 118.0000, 'ºC'),
	(35750, 109, '2015-02-01 00:01:32.000000', 'temperatura', 131.0000, 'ºC'),
	(35751, 109, '2015-02-01 00:01:33.000000', 'temperatura', 301.0000, 'ºC'),
	(35752, 109, '2015-02-01 00:01:34.000000', 'temperatura', 1114.0000, 'ºC'),
	(35753, 109, '2015-02-01 00:01:35.000000', 'temperatura', 1068.0000, 'ºC'),
	(35754, 109, '2015-02-01 00:01:36.000000', 'temperatura', 797.0000, 'ºC'),
	(35755, 109, '2015-02-01 00:01:37.000000', 'temperatura', 782.0000, 'ºC'),
	(35756, 109, '2015-02-01 00:01:38.000000', 'temperatura', 320.0000, 'ºC'),
	(35757, 109, '2015-02-01 00:01:39.000000', 'temperatura', 456.0000, 'ºC'),
	(35758, 109, '2015-02-01 00:01:40.000000', 'temperatura', 119.0000, 'ºC'),
	(35759, 109, '2015-02-01 00:01:41.000000', 'temperatura', 427.0000, 'ºC'),
	(35760, 109, '2015-02-01 00:01:42.000000', 'temperatura', 578.0000, 'ºC'),
	(35761, 109, '2015-02-01 00:01:43.000000', 'temperatura', 412.0000, 'ºC'),
	(35762, 109, '2015-02-01 00:01:44.000000', 'temperatura', 326.0000, 'ºC'),
	(35763, 109, '2015-02-01 00:01:45.000000', 'temperatura', 392.0000, 'ºC'),
	(35764, 109, '2015-02-01 00:01:46.000000', 'temperatura', 985.0000, 'ºC'),
	(35765, 109, '2015-02-01 00:01:47.000000', 'temperatura', 149.0000, 'ºC'),
	(35766, 109, '2015-02-01 00:01:48.000000', 'temperatura', 191.0000, 'ºC'),
	(35767, 109, '2015-02-01 00:01:49.000000', 'temperatura', 507.0000, 'ºC'),
	(35768, 109, '2015-02-01 00:01:50.000000', 'temperatura', 765.0000, 'ºC'),
	(35769, 109, '2015-02-01 00:01:51.000000', 'temperatura', 1104.0000, 'ºC'),
	(35770, 109, '2015-02-01 00:01:52.000000', 'temperatura', 827.0000, 'ºC'),
	(35771, 109, '2015-02-01 00:01:53.000000', 'temperatura', 822.0000, 'ºC'),
	(35772, 109, '2015-02-01 00:01:54.000000', 'temperatura', 431.0000, 'ºC'),
	(35773, 109, '2015-02-01 00:01:55.000000', 'temperatura', 888.0000, 'ºC'),
	(35774, 109, '2015-02-01 00:01:56.000000', 'temperatura', 746.0000, 'ºC'),
	(35775, 109, '2015-02-01 00:01:57.000000', 'temperatura', 1070.0000, 'ºC'),
	(35776, 109, '2015-02-01 00:01:58.000000', 'temperatura', 710.0000, 'ºC'),
	(35777, 109, '2015-02-01 00:01:59.000000', 'temperatura', 342.0000, 'ºC'),
	(35778, 109, '2015-02-01 00:02:00.000000', 'temperatura', 778.0000, 'ºC'),
	(35779, 109, '2015-02-01 00:02:01.000000', 'temperatura', 466.0000, 'ºC'),
	(35780, 109, '2015-02-01 00:02:02.000000', 'temperatura', 1196.0000, 'ºC'),
	(35781, 109, '2015-02-01 00:02:03.000000', 'temperatura', 985.0000, 'ºC'),
	(35782, 109, '2015-02-01 00:02:04.000000', 'temperatura', 135.0000, 'ºC'),
	(35783, 109, '2015-02-01 00:02:05.000000', 'temperatura', 121.0000, 'ºC'),
	(35784, 109, '2015-02-01 00:02:06.000000', 'temperatura', 200.0000, 'ºC'),
	(35785, 109, '2015-02-01 00:02:07.000000', 'temperatura', 639.0000, 'ºC'),
	(35786, 109, '2015-02-01 00:02:08.000000', 'temperatura', 194.0000, 'ºC'),
	(35787, 109, '2015-02-01 00:02:09.000000', 'temperatura', 252.0000, 'ºC'),
	(35788, 109, '2015-02-01 00:02:10.000000', 'temperatura', 681.0000, 'ºC'),
	(35789, 109, '2015-02-01 00:02:11.000000', 'temperatura', 248.0000, 'ºC'),
	(35790, 109, '2015-02-01 00:02:12.000000', 'temperatura', 398.0000, 'ºC'),
	(35791, 109, '2015-02-01 00:02:13.000000', 'temperatura', 46.0000, 'ºC'),
	(35792, 109, '2015-02-01 00:02:14.000000', 'temperatura', 237.0000, 'ºC'),
	(35793, 109, '2015-02-01 00:02:15.000000', 'temperatura', 1047.0000, 'ºC'),
	(35794, 109, '2015-02-01 00:02:16.000000', 'temperatura', 925.0000, 'ºC'),
	(35795, 109, '2015-02-01 00:02:17.000000', 'temperatura', 286.0000, 'ºC'),
	(35796, 109, '2015-02-01 00:02:18.000000', 'temperatura', 1054.0000, 'ºC'),
	(35797, 109, '2015-02-01 00:02:19.000000', 'temperatura', 812.0000, 'ºC'),
	(35798, 109, '2015-02-01 00:02:20.000000', 'temperatura', 898.0000, 'ºC'),
	(35799, 109, '2015-02-01 00:02:21.000000', 'temperatura', 856.0000, 'ºC'),
	(35800, 109, '2015-02-01 00:02:22.000000', 'temperatura', 388.0000, 'ºC'),
	(35801, 109, '2015-02-01 00:02:23.000000', 'temperatura', 569.0000, 'ºC'),
	(35802, 109, '2015-02-01 00:02:24.000000', 'temperatura', 484.0000, 'ºC'),
	(35803, 109, '2015-02-01 00:02:25.000000', 'temperatura', 714.0000, 'ºC'),
	(35804, 109, '2015-02-01 00:02:26.000000', 'temperatura', 916.0000, 'ºC'),
	(35805, 109, '2015-02-01 00:02:27.000000', 'temperatura', 41.0000, 'ºC'),
	(35806, 109, '2015-02-01 00:02:28.000000', 'temperatura', 1057.0000, 'ºC'),
	(35807, 109, '2015-02-01 00:02:29.000000', 'temperatura', 361.0000, 'ºC'),
	(35808, 109, '2015-02-01 00:02:30.000000', 'temperatura', 1036.0000, 'ºC'),
	(35809, 109, '2015-02-01 00:02:31.000000', 'temperatura', 498.0000, 'ºC'),
	(35810, 109, '2015-02-01 00:02:32.000000', 'temperatura', 583.0000, 'ºC'),
	(35811, 109, '2015-02-01 00:02:33.000000', 'temperatura', 222.0000, 'ºC'),
	(35812, 109, '2015-02-01 00:02:34.000000', 'temperatura', 559.0000, 'ºC'),
	(35813, 109, '2015-02-01 00:02:35.000000', 'temperatura', 930.0000, 'ºC'),
	(35814, 109, '2015-02-01 00:02:36.000000', 'temperatura', 572.0000, 'ºC'),
	(35815, 109, '2015-02-01 00:02:37.000000', 'temperatura', 73.0000, 'ºC'),
	(35816, 109, '2015-02-01 00:02:38.000000', 'temperatura', 1051.0000, 'ºC'),
	(35817, 109, '2015-02-01 00:02:39.000000', 'temperatura', 234.0000, 'ºC'),
	(35818, 109, '2015-02-01 00:02:40.000000', 'temperatura', 419.0000, 'ºC'),
	(35819, 109, '2015-02-01 00:02:41.000000', 'temperatura', 191.0000, 'ºC'),
	(35820, 109, '2015-02-01 00:02:42.000000', 'temperatura', 900.0000, 'ºC'),
	(35821, 109, '2015-02-01 00:02:43.000000', 'temperatura', 328.0000, 'ºC'),
	(35822, 109, '2015-02-01 00:02:44.000000', 'temperatura', 140.0000, 'ºC'),
	(35823, 109, '2015-02-01 00:02:45.000000', 'temperatura', 919.0000, 'ºC'),
	(35824, 109, '2015-02-01 00:02:46.000000', 'temperatura', 572.0000, 'ºC'),
	(35825, 109, '2015-02-01 00:02:47.000000', 'temperatura', 105.0000, 'ºC'),
	(35826, 109, '2015-02-01 00:02:48.000000', 'temperatura', 10.0000, 'ºC'),
	(35827, 109, '2015-02-01 00:02:49.000000', 'temperatura', 934.0000, 'ºC'),
	(35828, 109, '2015-02-01 00:02:50.000000', 'temperatura', 1042.0000, 'ºC'),
	(35829, 109, '2015-02-01 00:02:51.000000', 'temperatura', 10.0000, 'ºC'),
	(35830, 109, '2015-02-01 00:02:52.000000', 'temperatura', 523.0000, 'ºC'),
	(35831, 109, '2015-02-01 00:02:53.000000', 'temperatura', 186.0000, 'ºC'),
	(35832, 109, '2015-02-01 00:02:54.000000', 'temperatura', 562.0000, 'ºC'),
	(35833, 109, '2015-02-01 00:02:55.000000', 'temperatura', 1052.0000, 'ºC'),
	(35834, 109, '2015-02-01 00:02:56.000000', 'temperatura', 1172.0000, 'ºC'),
	(35835, 109, '2015-02-01 00:02:57.000000', 'temperatura', 308.0000, 'ºC'),
	(35836, 109, '2015-02-01 00:02:58.000000', 'temperatura', 423.0000, 'ºC'),
	(35837, 109, '2015-02-01 00:02:59.000000', 'temperatura', 1191.0000, 'ºC'),
	(35838, 109, '2015-02-01 00:03:00.000000', 'temperatura', 1088.0000, 'ºC'),
	(35839, 109, '2015-02-01 00:03:01.000000', 'temperatura', 665.0000, 'ºC'),
	(35840, 109, '2015-02-01 00:03:02.000000', 'temperatura', 63.0000, 'ºC'),
	(35841, 109, '2015-02-01 00:03:03.000000', 'temperatura', 722.0000, 'ºC'),
	(35842, 109, '2015-02-01 00:03:04.000000', 'temperatura', 1020.0000, 'ºC'),
	(35843, 109, '2015-02-01 00:03:05.000000', 'temperatura', 534.0000, 'ºC'),
	(35844, 109, '2015-02-01 00:03:06.000000', 'temperatura', 810.0000, 'ºC'),
	(35845, 109, '2015-02-01 00:03:07.000000', 'temperatura', 49.0000, 'ºC'),
	(35846, 109, '2015-02-01 00:03:08.000000', 'temperatura', 214.0000, 'ºC'),
	(35847, 109, '2015-02-01 00:03:09.000000', 'temperatura', 926.0000, 'ºC'),
	(35848, 109, '2015-02-01 00:03:10.000000', 'temperatura', 388.0000, 'ºC'),
	(35849, 109, '2015-02-01 00:03:11.000000', 'temperatura', 361.0000, 'ºC'),
	(35850, 109, '2015-02-01 00:03:12.000000', 'temperatura', 643.0000, 'ºC'),
	(35851, 109, '2015-02-01 00:03:13.000000', 'temperatura', 933.0000, 'ºC'),
	(35852, 109, '2015-02-01 00:03:14.000000', 'temperatura', 336.0000, 'ºC'),
	(35853, 109, '2015-02-01 00:03:15.000000', 'temperatura', 80.0000, 'ºC'),
	(35854, 109, '2015-02-01 00:03:16.000000', 'temperatura', 593.0000, 'ºC'),
	(35855, 109, '2015-02-01 00:03:17.000000', 'temperatura', 327.0000, 'ºC'),
	(35856, 109, '2015-02-01 00:03:18.000000', 'temperatura', 1055.0000, 'ºC'),
	(35857, 109, '2015-02-01 00:03:19.000000', 'temperatura', 697.0000, 'ºC'),
	(35858, 109, '2015-02-01 00:03:20.000000', 'temperatura', 320.0000, 'ºC'),
	(35859, 109, '2015-02-01 00:03:21.000000', 'temperatura', 707.0000, 'ºC'),
	(35860, 109, '2015-02-01 00:03:22.000000', 'temperatura', 178.0000, 'ºC'),
	(35861, 109, '2015-02-01 00:03:23.000000', 'temperatura', 1167.0000, 'ºC'),
	(35862, 109, '2015-02-01 00:03:24.000000', 'temperatura', 501.0000, 'ºC'),
	(35863, 109, '2015-02-01 00:03:25.000000', 'temperatura', 204.0000, 'ºC'),
	(35864, 109, '2015-02-01 00:03:26.000000', 'temperatura', 719.0000, 'ºC'),
	(35865, 109, '2015-02-01 00:03:27.000000', 'temperatura', 584.0000, 'ºC'),
	(35866, 109, '2015-02-01 00:03:28.000000', 'temperatura', 764.0000, 'ºC'),
	(35867, 109, '2015-02-01 00:03:29.000000', 'temperatura', 868.0000, 'ºC'),
	(35868, 109, '2015-02-01 00:03:30.000000', 'temperatura', 850.0000, 'ºC'),
	(35869, 109, '2015-02-01 00:03:31.000000', 'temperatura', 444.0000, 'ºC'),
	(35870, 109, '2015-02-01 00:03:32.000000', 'temperatura', 870.0000, 'ºC'),
	(35871, 109, '2015-02-01 00:03:33.000000', 'temperatura', 621.0000, 'ºC'),
	(35872, 109, '2015-02-01 00:03:34.000000', 'temperatura', 494.0000, 'ºC'),
	(35873, 109, '2015-02-01 00:03:35.000000', 'temperatura', 609.0000, 'ºC'),
	(35874, 109, '2015-02-01 00:03:36.000000', 'temperatura', 362.0000, 'ºC'),
	(35875, 109, '2015-02-01 00:03:37.000000', 'temperatura', 1184.0000, 'ºC'),
	(35876, 109, '2015-02-01 00:03:38.000000', 'temperatura', 33.0000, 'ºC'),
	(35877, 109, '2015-02-01 00:03:39.000000', 'temperatura', 214.0000, 'ºC'),
	(35878, 109, '2015-02-01 00:03:40.000000', 'temperatura', 971.0000, 'ºC'),
	(35879, 109, '2015-02-01 00:03:41.000000', 'temperatura', 612.0000, 'ºC'),
	(35880, 109, '2015-02-01 00:03:42.000000', 'temperatura', 150.0000, 'ºC'),
	(35881, 109, '2015-02-01 00:03:43.000000', 'temperatura', 115.0000, 'ºC'),
	(35882, 109, '2015-02-01 00:03:44.000000', 'temperatura', 124.0000, 'ºC'),
	(35883, 109, '2015-02-01 00:03:45.000000', 'temperatura', 276.0000, 'ºC'),
	(35884, 109, '2015-02-01 00:03:46.000000', 'temperatura', 1009.0000, 'ºC'),
	(35885, 109, '2015-02-01 00:03:47.000000', 'temperatura', 619.0000, 'ºC'),
	(35886, 109, '2015-02-01 00:03:48.000000', 'temperatura', 66.0000, 'ºC'),
	(35887, 109, '2015-02-01 00:03:49.000000', 'temperatura', 875.0000, 'ºC'),
	(35888, 109, '2015-02-01 00:03:50.000000', 'temperatura', 578.0000, 'ºC'),
	(35889, 109, '2015-02-01 00:03:51.000000', 'temperatura', 264.0000, 'ºC'),
	(35890, 109, '2015-02-01 00:03:52.000000', 'temperatura', 786.0000, 'ºC'),
	(35891, 109, '2015-02-01 00:03:53.000000', 'temperatura', 741.0000, 'ºC'),
	(35892, 109, '2015-02-01 00:03:54.000000', 'temperatura', 147.0000, 'ºC'),
	(35893, 109, '2015-02-01 00:03:55.000000', 'temperatura', 911.0000, 'ºC'),
	(35894, 109, '2015-02-01 00:03:56.000000', 'temperatura', 516.0000, 'ºC'),
	(35895, 109, '2015-02-01 00:03:57.000000', 'temperatura', 1048.0000, 'ºC'),
	(35896, 109, '2015-02-01 00:03:58.000000', 'temperatura', 92.0000, 'ºC'),
	(35897, 109, '2015-02-01 00:03:59.000000', 'temperatura', 916.0000, 'ºC'),
	(35898, 109, '2015-02-01 00:04:00.000000', 'temperatura', 706.0000, 'ºC'),
	(35899, 109, '2015-02-01 00:04:01.000000', 'temperatura', 780.0000, 'ºC'),
	(35900, 109, '2015-02-01 00:04:02.000000', 'temperatura', 586.0000, 'ºC'),
	(35901, 109, '2015-02-01 00:04:03.000000', 'temperatura', 588.0000, 'ºC'),
	(35902, 109, '2015-02-01 00:04:04.000000', 'temperatura', 1182.0000, 'ºC'),
	(35903, 109, '2015-02-01 00:04:05.000000', 'temperatura', 547.0000, 'ºC'),
	(35904, 109, '2015-02-01 00:04:06.000000', 'temperatura', 390.0000, 'ºC'),
	(35905, 109, '2015-02-01 00:04:07.000000', 'temperatura', 308.0000, 'ºC'),
	(35906, 109, '2015-02-01 00:04:08.000000', 'temperatura', 370.0000, 'ºC'),
	(35907, 109, '2015-02-01 00:04:09.000000', 'temperatura', 926.0000, 'ºC'),
	(35908, 109, '2015-02-01 00:04:10.000000', 'temperatura', 1123.0000, 'ºC'),
	(35909, 109, '2015-02-01 00:04:11.000000', 'temperatura', 436.0000, 'ºC'),
	(35910, 109, '2015-02-01 00:04:12.000000', 'temperatura', 13.0000, 'ºC'),
	(35911, 109, '2015-02-01 00:04:13.000000', 'temperatura', 1158.0000, 'ºC'),
	(35912, 109, '2015-02-01 00:04:14.000000', 'temperatura', 953.0000, 'ºC'),
	(35913, 109, '2015-02-01 00:04:15.000000', 'temperatura', 89.0000, 'ºC'),
	(35914, 109, '2015-02-01 00:04:16.000000', 'temperatura', 1185.0000, 'ºC'),
	(35915, 109, '2015-02-01 00:04:17.000000', 'temperatura', 861.0000, 'ºC'),
	(35916, 109, '2015-02-01 00:04:18.000000', 'temperatura', 749.0000, 'ºC'),
	(35917, 109, '2015-02-01 00:04:19.000000', 'temperatura', 1162.0000, 'ºC'),
	(35918, 109, '2015-02-01 00:04:20.000000', 'temperatura', 1163.0000, 'ºC'),
	(35919, 109, '2015-02-01 00:04:21.000000', 'temperatura', 1130.0000, 'ºC'),
	(35920, 109, '2015-02-01 00:04:22.000000', 'temperatura', 961.0000, 'ºC'),
	(35921, 109, '2015-02-01 00:04:23.000000', 'temperatura', 215.0000, 'ºC'),
	(35922, 109, '2015-02-01 00:04:24.000000', 'temperatura', 594.0000, 'ºC'),
	(35923, 109, '2015-02-01 00:04:25.000000', 'temperatura', 1124.0000, 'ºC'),
	(35924, 109, '2015-02-01 00:04:26.000000', 'temperatura', 239.0000, 'ºC'),
	(35925, 109, '2015-02-01 00:04:27.000000', 'temperatura', 225.0000, 'ºC'),
	(35926, 109, '2015-02-01 00:04:28.000000', 'temperatura', 406.0000, 'ºC'),
	(35927, 109, '2015-02-01 00:04:29.000000', 'temperatura', 157.0000, 'ºC'),
	(35928, 109, '2015-02-01 00:04:30.000000', 'temperatura', 765.0000, 'ºC'),
	(35929, 109, '2015-02-01 00:04:31.000000', 'temperatura', 957.0000, 'ºC'),
	(35930, 109, '2015-02-01 00:04:32.000000', 'temperatura', 89.0000, 'ºC'),
	(35931, 109, '2015-02-01 00:04:33.000000', 'temperatura', 1173.0000, 'ºC'),
	(35932, 109, '2015-02-01 00:04:34.000000', 'temperatura', 800.0000, 'ºC'),
	(35933, 109, '2015-02-01 00:04:35.000000', 'temperatura', 481.0000, 'ºC'),
	(35934, 109, '2015-02-01 00:04:36.000000', 'temperatura', 6.0000, 'ºC'),
	(35935, 109, '2015-02-01 00:04:37.000000', 'temperatura', 986.0000, 'ºC'),
	(35936, 109, '2015-02-01 00:04:38.000000', 'temperatura', 115.0000, 'ºC'),
	(35937, 109, '2015-02-01 00:04:39.000000', 'temperatura', 17.0000, 'ºC'),
	(35938, 109, '2015-02-01 00:04:40.000000', 'temperatura', 940.0000, 'ºC'),
	(35939, 109, '2015-02-01 00:04:41.000000', 'temperatura', 1050.0000, 'ºC'),
	(35940, 109, '2015-02-01 00:04:42.000000', 'temperatura', 32.0000, 'ºC'),
	(35941, 109, '2015-02-01 00:04:43.000000', 'temperatura', 609.0000, 'ºC'),
	(35942, 109, '2015-02-01 00:04:44.000000', 'temperatura', 548.0000, 'ºC'),
	(35943, 109, '2015-02-01 00:04:45.000000', 'temperatura', 913.0000, 'ºC'),
	(35944, 109, '2015-02-01 00:04:46.000000', 'temperatura', 522.0000, 'ºC'),
	(35945, 109, '2015-02-01 00:04:47.000000', 'temperatura', 1074.0000, 'ºC'),
	(35946, 109, '2015-02-01 00:04:48.000000', 'temperatura', 203.0000, 'ºC'),
	(35947, 109, '2015-02-01 00:04:49.000000', 'temperatura', 194.0000, 'ºC'),
	(35948, 109, '2015-02-01 00:04:50.000000', 'temperatura', 360.0000, 'ºC'),
	(35949, 109, '2015-02-01 00:04:51.000000', 'temperatura', 20.0000, 'ºC'),
	(35950, 109, '2015-02-01 00:04:52.000000', 'temperatura', 221.0000, 'ºC'),
	(35951, 109, '2015-02-01 00:04:53.000000', 'temperatura', 1046.0000, 'ºC'),
	(35952, 109, '2015-02-01 00:04:54.000000', 'temperatura', 969.0000, 'ºC'),
	(35953, 109, '2015-02-01 00:04:55.000000', 'temperatura', 505.0000, 'ºC'),
	(35954, 109, '2015-02-01 00:04:56.000000', 'temperatura', 817.0000, 'ºC'),
	(35955, 109, '2015-02-01 00:04:57.000000', 'temperatura', 173.0000, 'ºC'),
	(35956, 109, '2015-02-01 00:04:58.000000', 'temperatura', 813.0000, 'ºC'),
	(35957, 109, '2015-02-01 00:04:59.000000', 'temperatura', 1147.0000, 'ºC'),
	(35958, 109, '2015-02-01 00:05:00.000000', 'temperatura', 897.0000, 'ºC'),
	(35959, 109, '2015-02-01 00:05:01.000000', 'temperatura', 1044.0000, 'ºC'),
	(35960, 109, '2015-02-01 00:05:02.000000', 'temperatura', 128.0000, 'ºC'),
	(35961, 109, '2015-02-01 00:05:03.000000', 'temperatura', 1110.0000, 'ºC'),
	(35962, 109, '2015-02-01 00:05:04.000000', 'temperatura', 365.0000, 'ºC'),
	(35963, 109, '2015-02-01 00:05:05.000000', 'temperatura', 898.0000, 'ºC'),
	(35964, 109, '2015-02-01 00:05:06.000000', 'temperatura', 994.0000, 'ºC'),
	(35965, 109, '2015-02-01 00:05:07.000000', 'temperatura', 1077.0000, 'ºC'),
	(35966, 109, '2015-02-01 00:05:08.000000', 'temperatura', 5.0000, 'ºC'),
	(35967, 109, '2015-02-01 00:05:09.000000', 'temperatura', 394.0000, 'ºC'),
	(35968, 109, '2015-02-01 00:05:10.000000', 'temperatura', 753.0000, 'ºC'),
	(35969, 109, '2015-02-01 00:05:11.000000', 'temperatura', 187.0000, 'ºC'),
	(35970, 109, '2015-02-01 00:05:12.000000', 'temperatura', 1075.0000, 'ºC'),
	(35971, 109, '2015-02-01 00:05:13.000000', 'temperatura', 13.0000, 'ºC'),
	(35972, 109, '2015-02-01 00:05:14.000000', 'temperatura', 442.0000, 'ºC'),
	(35973, 109, '2015-02-01 00:05:15.000000', 'temperatura', 969.0000, 'ºC'),
	(35974, 109, '2015-02-01 00:05:16.000000', 'temperatura', 1121.0000, 'ºC'),
	(35975, 109, '2015-02-01 00:05:17.000000', 'temperatura', 300.0000, 'ºC'),
	(35976, 109, '2015-02-01 00:05:18.000000', 'temperatura', 538.0000, 'ºC'),
	(35977, 109, '2015-02-01 00:05:19.000000', 'temperatura', 590.0000, 'ºC'),
	(35978, 109, '2015-02-01 00:05:20.000000', 'temperatura', 135.0000, 'ºC'),
	(35979, 109, '2015-02-01 00:05:21.000000', 'temperatura', 107.0000, 'ºC'),
	(35980, 109, '2015-02-01 00:05:22.000000', 'temperatura', 131.0000, 'ºC'),
	(35981, 109, '2015-02-01 00:05:23.000000', 'temperatura', 332.0000, 'ºC'),
	(35982, 109, '2015-02-01 00:05:24.000000', 'temperatura', 70.0000, 'ºC'),
	(35983, 109, '2015-02-01 00:05:25.000000', 'temperatura', 555.0000, 'ºC'),
	(35984, 109, '2015-02-01 00:05:26.000000', 'temperatura', 163.0000, 'ºC'),
	(35985, 109, '2015-02-01 00:05:27.000000', 'temperatura', 350.0000, 'ºC'),
	(35986, 109, '2015-02-01 00:05:28.000000', 'temperatura', 65.0000, 'ºC'),
	(35987, 109, '2015-02-01 00:05:29.000000', 'temperatura', 472.0000, 'ºC'),
	(35988, 109, '2015-02-01 00:05:30.000000', 'temperatura', 968.0000, 'ºC'),
	(35989, 109, '2015-02-01 00:05:31.000000', 'temperatura', 1023.0000, 'ºC'),
	(35990, 109, '2015-02-01 00:05:32.000000', 'temperatura', 1012.0000, 'ºC'),
	(35991, 109, '2015-02-01 00:05:33.000000', 'temperatura', 791.0000, 'ºC'),
	(35992, 109, '2015-02-01 00:05:34.000000', 'temperatura', 922.0000, 'ºC'),
	(35993, 109, '2015-02-01 00:05:35.000000', 'temperatura', 1034.0000, 'ºC'),
	(35994, 109, '2015-02-01 00:05:36.000000', 'temperatura', 6.0000, 'ºC'),
	(35995, 109, '2015-02-01 00:05:37.000000', 'temperatura', 526.0000, 'ºC'),
	(35996, 109, '2015-02-01 00:05:38.000000', 'temperatura', 216.0000, 'ºC'),
	(35997, 109, '2015-02-01 00:05:39.000000', 'temperatura', 702.0000, 'ºC'),
	(35998, 109, '2015-02-01 00:05:40.000000', 'temperatura', 462.0000, 'ºC'),
	(35999, 109, '2015-02-01 00:05:41.000000', 'temperatura', 207.0000, 'ºC'),
	(36000, 109, '2015-02-01 00:05:42.000000', 'temperatura', 846.0000, 'ºC'),
	(36001, 109, '2015-02-01 00:05:43.000000', 'temperatura', 10.0000, 'ºC'),
	(36002, 109, '2015-02-01 00:05:44.000000', 'temperatura', 1113.0000, 'ºC'),
	(36003, 109, '2015-02-01 00:05:45.000000', 'temperatura', 737.0000, 'ºC'),
	(36004, 109, '2015-02-01 00:05:46.000000', 'temperatura', 345.0000, 'ºC'),
	(36005, 109, '2015-02-01 00:05:47.000000', 'temperatura', 714.0000, 'ºC'),
	(36006, 109, '2015-02-01 00:05:48.000000', 'temperatura', 138.0000, 'ºC'),
	(36007, 109, '2015-02-01 00:05:49.000000', 'temperatura', 947.0000, 'ºC'),
	(36008, 109, '2015-02-01 00:05:50.000000', 'temperatura', 721.0000, 'ºC'),
	(36009, 109, '2015-02-01 00:05:51.000000', 'temperatura', 764.0000, 'ºC'),
	(36010, 109, '2015-02-01 00:05:52.000000', 'temperatura', 458.0000, 'ºC'),
	(36011, 109, '2015-02-01 00:05:53.000000', 'temperatura', 1198.0000, 'ºC'),
	(36012, 109, '2015-02-01 00:05:54.000000', 'temperatura', 1016.0000, 'ºC'),
	(36013, 109, '2015-02-01 00:05:55.000000', 'temperatura', 288.0000, 'ºC'),
	(36014, 109, '2015-02-01 00:05:56.000000', 'temperatura', 791.0000, 'ºC'),
	(36015, 109, '2015-02-01 00:05:57.000000', 'temperatura', 692.0000, 'ºC'),
	(36016, 109, '2015-02-01 00:05:58.000000', 'temperatura', 1089.0000, 'ºC'),
	(36017, 109, '2015-02-01 00:05:59.000000', 'temperatura', 969.0000, 'ºC'),
	(36018, 109, '2015-02-01 00:06:00.000000', 'temperatura', 378.0000, 'ºC'),
	(36019, 109, '2015-02-01 00:06:01.000000', 'temperatura', 185.0000, 'ºC'),
	(36020, 109, '2015-02-01 00:06:02.000000', 'temperatura', 992.0000, 'ºC'),
	(36021, 109, '2015-02-01 00:06:03.000000', 'temperatura', 804.0000, 'ºC'),
	(36022, 109, '2015-02-01 00:06:04.000000', 'temperatura', 1044.0000, 'ºC'),
	(36023, 109, '2015-02-01 00:06:05.000000', 'temperatura', 410.0000, 'ºC'),
	(36024, 109, '2015-02-01 00:06:06.000000', 'temperatura', 117.0000, 'ºC'),
	(36025, 109, '2015-02-01 00:06:07.000000', 'temperatura', 558.0000, 'ºC'),
	(36026, 109, '2015-02-01 00:06:08.000000', 'temperatura', 38.0000, 'ºC'),
	(36027, 109, '2015-02-01 00:06:09.000000', 'temperatura', 916.0000, 'ºC'),
	(36028, 109, '2015-02-01 00:06:10.000000', 'temperatura', 868.0000, 'ºC'),
	(36029, 109, '2015-02-01 00:06:11.000000', 'temperatura', 393.0000, 'ºC'),
	(36030, 109, '2015-02-01 00:06:12.000000', 'temperatura', 560.0000, 'ºC'),
	(36031, 109, '2015-02-01 00:06:13.000000', 'temperatura', 421.0000, 'ºC'),
	(36032, 109, '2015-02-01 00:06:14.000000', 'temperatura', 425.0000, 'ºC'),
	(36033, 109, '2015-02-01 00:06:15.000000', 'temperatura', 865.0000, 'ºC'),
	(36034, 109, '2015-02-01 00:06:16.000000', 'temperatura', 648.0000, 'ºC'),
	(36035, 109, '2015-02-01 00:06:17.000000', 'temperatura', 648.0000, 'ºC'),
	(36036, 109, '2015-02-01 00:06:18.000000', 'temperatura', 95.0000, 'ºC'),
	(36037, 109, '2015-02-01 00:06:19.000000', 'temperatura', 932.0000, 'ºC'),
	(36038, 109, '2015-02-01 00:06:20.000000', 'temperatura', 777.0000, 'ºC'),
	(36039, 109, '2015-02-01 00:06:21.000000', 'temperatura', 1090.0000, 'ºC'),
	(36040, 109, '2015-02-01 00:06:22.000000', 'temperatura', 720.0000, 'ºC'),
	(36041, 109, '2015-02-01 00:06:23.000000', 'temperatura', 329.0000, 'ºC'),
	(36042, 109, '2015-02-01 00:06:24.000000', 'temperatura', 687.0000, 'ºC'),
	(36043, 109, '2015-02-01 00:06:25.000000', 'temperatura', 47.0000, 'ºC'),
	(36044, 109, '2015-02-01 00:06:26.000000', 'temperatura', 574.0000, 'ºC'),
	(36045, 109, '2015-02-01 00:06:27.000000', 'temperatura', 328.0000, 'ºC'),
	(36046, 109, '2015-02-01 00:06:28.000000', 'temperatura', 1122.0000, 'ºC'),
	(36047, 109, '2015-02-01 00:06:29.000000', 'temperatura', 1025.0000, 'ºC'),
	(36048, 109, '2015-02-01 00:06:30.000000', 'temperatura', 558.0000, 'ºC'),
	(36049, 109, '2015-02-01 00:06:31.000000', 'temperatura', 917.0000, 'ºC'),
	(36050, 109, '2015-02-01 00:06:32.000000', 'temperatura', 510.0000, 'ºC'),
	(36051, 109, '2015-02-01 00:06:33.000000', 'temperatura', 999.0000, 'ºC'),
	(36052, 109, '2015-02-01 00:06:34.000000', 'temperatura', 1068.0000, 'ºC'),
	(36053, 109, '2015-02-01 00:06:35.000000', 'temperatura', 1144.0000, 'ºC'),
	(36054, 109, '2015-02-01 00:06:36.000000', 'temperatura', 115.0000, 'ºC'),
	(36055, 109, '2015-02-01 00:06:37.000000', 'temperatura', 743.0000, 'ºC'),
	(36056, 109, '2015-02-01 00:06:38.000000', 'temperatura', 970.0000, 'ºC'),
	(36057, 109, '2015-02-01 00:06:39.000000', 'temperatura', 223.0000, 'ºC'),
	(36058, 109, '2015-02-01 00:06:40.000000', 'temperatura', 605.0000, 'ºC'),
	(36059, 109, '2015-02-01 00:06:41.000000', 'temperatura', 1156.0000, 'ºC'),
	(36060, 109, '2015-02-01 00:06:42.000000', 'temperatura', 366.0000, 'ºC'),
	(36061, 109, '2015-02-01 00:06:43.000000', 'temperatura', 761.0000, 'ºC'),
	(36062, 109, '2015-02-01 00:06:44.000000', 'temperatura', 310.0000, 'ºC'),
	(36063, 109, '2015-02-01 00:06:45.000000', 'temperatura', 467.0000, 'ºC'),
	(36064, 109, '2015-02-01 00:06:46.000000', 'temperatura', 203.0000, 'ºC'),
	(36065, 109, '2015-02-01 00:06:47.000000', 'temperatura', 817.0000, 'ºC'),
	(36066, 109, '2015-02-01 00:06:48.000000', 'temperatura', 1074.0000, 'ºC'),
	(36067, 109, '2015-02-01 00:06:49.000000', 'temperatura', 519.0000, 'ºC'),
	(36068, 109, '2015-02-01 00:06:50.000000', 'temperatura', 576.0000, 'ºC'),
	(36069, 109, '2015-02-01 00:06:51.000000', 'temperatura', 122.0000, 'ºC'),
	(36070, 109, '2015-02-01 00:06:52.000000', 'temperatura', 82.0000, 'ºC'),
	(36071, 109, '2015-02-01 00:06:53.000000', 'temperatura', 45.0000, 'ºC'),
	(36072, 109, '2015-02-01 00:06:54.000000', 'temperatura', 1181.0000, 'ºC'),
	(36073, 109, '2015-02-01 00:06:55.000000', 'temperatura', 969.0000, 'ºC'),
	(36074, 109, '2015-02-01 00:06:56.000000', 'temperatura', 105.0000, 'ºC'),
	(36075, 109, '2015-02-01 00:06:57.000000', 'temperatura', 15.0000, 'ºC'),
	(36076, 109, '2015-02-01 00:06:58.000000', 'temperatura', 963.0000, 'ºC'),
	(36077, 109, '2015-02-01 00:06:59.000000', 'temperatura', 1170.0000, 'ºC'),
	(36078, 109, '2015-02-01 00:07:00.000000', 'temperatura', 561.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(36079, 109, '2015-02-01 00:07:01.000000', 'temperatura', 496.0000, 'ºC'),
	(36080, 109, '2015-02-01 00:07:02.000000', 'temperatura', 798.0000, 'ºC'),
	(36081, 109, '2015-02-01 00:07:03.000000', 'temperatura', 100.0000, 'ºC'),
	(36082, 109, '2015-02-01 00:07:04.000000', 'temperatura', 509.0000, 'ºC'),
	(36083, 109, '2015-02-01 00:07:05.000000', 'temperatura', 1047.0000, 'ºC'),
	(36084, 109, '2015-02-01 00:07:06.000000', 'temperatura', 105.0000, 'ºC'),
	(36085, 109, '2015-02-01 00:07:07.000000', 'temperatura', 986.0000, 'ºC'),
	(36086, 109, '2015-02-01 00:07:08.000000', 'temperatura', 1017.0000, 'ºC'),
	(36087, 109, '2015-02-01 00:07:09.000000', 'temperatura', 927.0000, 'ºC'),
	(36088, 109, '2015-02-01 00:07:10.000000', 'temperatura', 384.0000, 'ºC'),
	(36089, 109, '2015-02-01 00:07:11.000000', 'temperatura', 338.0000, 'ºC'),
	(36090, 109, '2015-02-01 00:07:12.000000', 'temperatura', 541.0000, 'ºC'),
	(36091, 109, '2015-02-01 00:07:13.000000', 'temperatura', 491.0000, 'ºC'),
	(36092, 109, '2015-02-01 00:07:14.000000', 'temperatura', 834.0000, 'ºC'),
	(36093, 109, '2015-02-01 00:07:15.000000', 'temperatura', 294.0000, 'ºC'),
	(36094, 109, '2015-02-01 00:07:16.000000', 'temperatura', 171.0000, 'ºC'),
	(36095, 109, '2015-02-01 00:07:17.000000', 'temperatura', 1171.0000, 'ºC'),
	(36096, 109, '2015-02-01 00:07:18.000000', 'temperatura', 545.0000, 'ºC'),
	(36097, 109, '2015-02-01 00:07:19.000000', 'temperatura', 410.0000, 'ºC'),
	(36098, 109, '2015-02-01 00:07:20.000000', 'temperatura', 415.0000, 'ºC'),
	(36099, 109, '2015-02-01 00:07:21.000000', 'temperatura', 848.0000, 'ºC'),
	(36100, 109, '2015-02-01 00:07:22.000000', 'temperatura', 596.0000, 'ºC'),
	(36101, 109, '2015-02-01 00:07:23.000000', 'temperatura', 434.0000, 'ºC'),
	(36102, 109, '2015-02-01 00:07:24.000000', 'temperatura', 382.0000, 'ºC'),
	(36103, 109, '2015-02-01 00:07:25.000000', 'temperatura', 612.0000, 'ºC'),
	(36104, 109, '2015-02-01 00:07:26.000000', 'temperatura', 711.0000, 'ºC'),
	(36105, 109, '2015-02-01 00:07:27.000000', 'temperatura', 522.0000, 'ºC'),
	(36106, 109, '2015-02-01 00:07:28.000000', 'temperatura', 476.0000, 'ºC'),
	(36107, 109, '2015-02-01 00:07:29.000000', 'temperatura', 814.0000, 'ºC'),
	(36108, 109, '2015-02-01 00:07:30.000000', 'temperatura', 242.0000, 'ºC'),
	(36109, 109, '2015-02-01 00:07:31.000000', 'temperatura', 1171.0000, 'ºC'),
	(36110, 109, '2015-02-01 00:07:32.000000', 'temperatura', 326.0000, 'ºC'),
	(36111, 109, '2015-02-01 00:07:33.000000', 'temperatura', 520.0000, 'ºC'),
	(36112, 109, '2015-02-01 00:07:34.000000', 'temperatura', 424.0000, 'ºC'),
	(36113, 109, '2015-02-01 00:07:35.000000', 'temperatura', 558.0000, 'ºC'),
	(36114, 109, '2015-02-01 00:07:36.000000', 'temperatura', 320.0000, 'ºC'),
	(36115, 109, '2015-02-01 00:07:37.000000', 'temperatura', 1127.0000, 'ºC'),
	(36116, 109, '2015-02-01 00:07:38.000000', 'temperatura', 1073.0000, 'ºC'),
	(36117, 109, '2015-02-01 00:07:39.000000', 'temperatura', 785.0000, 'ºC'),
	(36118, 109, '2015-02-01 00:07:40.000000', 'temperatura', 705.0000, 'ºC'),
	(36119, 109, '2015-02-01 00:07:41.000000', 'temperatura', 1173.0000, 'ºC'),
	(36120, 109, '2015-02-01 00:07:42.000000', 'temperatura', 148.0000, 'ºC'),
	(36121, 109, '2015-02-01 00:07:43.000000', 'temperatura', 822.0000, 'ºC'),
	(36122, 109, '2015-02-01 00:07:44.000000', 'temperatura', 68.0000, 'ºC'),
	(36123, 109, '2015-02-01 00:07:45.000000', 'temperatura', 274.0000, 'ºC'),
	(36124, 109, '2015-02-01 00:07:46.000000', 'temperatura', 1166.0000, 'ºC'),
	(36125, 109, '2015-02-01 00:07:47.000000', 'temperatura', 211.0000, 'ºC'),
	(36126, 109, '2015-02-01 00:07:48.000000', 'temperatura', 1155.0000, 'ºC'),
	(36127, 109, '2015-02-01 00:07:49.000000', 'temperatura', 344.0000, 'ºC'),
	(36128, 109, '2015-02-01 00:07:50.000000', 'temperatura', 653.0000, 'ºC'),
	(36129, 109, '2015-02-01 00:07:51.000000', 'temperatura', 1036.0000, 'ºC'),
	(36130, 109, '2015-02-01 00:07:52.000000', 'temperatura', 819.0000, 'ºC'),
	(36131, 109, '2015-02-01 00:07:53.000000', 'temperatura', 988.0000, 'ºC'),
	(36132, 109, '2015-02-01 00:07:54.000000', 'temperatura', 83.0000, 'ºC'),
	(36133, 109, '2015-02-01 00:07:55.000000', 'temperatura', 1053.0000, 'ºC'),
	(36134, 109, '2015-02-01 00:07:56.000000', 'temperatura', 216.0000, 'ºC'),
	(36135, 109, '2015-02-01 00:07:57.000000', 'temperatura', 321.0000, 'ºC'),
	(36136, 109, '2015-02-01 00:07:58.000000', 'temperatura', 957.0000, 'ºC'),
	(36137, 109, '2015-02-01 00:07:59.000000', 'temperatura', 223.0000, 'ºC'),
	(36138, 109, '2015-02-01 00:08:00.000000', 'temperatura', 644.0000, 'ºC'),
	(36139, 109, '2015-02-01 00:08:01.000000', 'temperatura', 150.0000, 'ºC'),
	(36140, 109, '2015-02-01 00:08:02.000000', 'temperatura', 20.0000, 'ºC'),
	(36141, 109, '2015-02-01 00:08:03.000000', 'temperatura', 850.0000, 'ºC'),
	(36142, 109, '2015-02-01 00:08:04.000000', 'temperatura', 592.0000, 'ºC'),
	(36143, 109, '2015-02-01 00:08:05.000000', 'temperatura', 411.0000, 'ºC'),
	(36144, 109, '2015-02-01 00:08:06.000000', 'temperatura', 278.0000, 'ºC'),
	(36145, 109, '2015-02-01 00:08:07.000000', 'temperatura', 156.0000, 'ºC'),
	(36146, 109, '2015-02-01 00:08:08.000000', 'temperatura', 1147.0000, 'ºC'),
	(36147, 109, '2015-02-01 00:08:09.000000', 'temperatura', 469.0000, 'ºC'),
	(36148, 109, '2015-02-01 00:08:10.000000', 'temperatura', 104.0000, 'ºC'),
	(36149, 109, '2015-02-01 00:08:11.000000', 'temperatura', 312.0000, 'ºC'),
	(36150, 109, '2015-02-01 00:08:12.000000', 'temperatura', 48.0000, 'ºC'),
	(36151, 109, '2015-02-01 00:08:13.000000', 'temperatura', 505.0000, 'ºC'),
	(36152, 109, '2015-02-01 00:08:14.000000', 'temperatura', 1184.0000, 'ºC'),
	(36153, 109, '2015-02-01 00:08:15.000000', 'temperatura', 803.0000, 'ºC'),
	(36154, 109, '2015-02-01 00:08:16.000000', 'temperatura', 466.0000, 'ºC'),
	(36155, 109, '2015-02-01 00:08:17.000000', 'temperatura', 1119.0000, 'ºC'),
	(36156, 109, '2015-02-01 00:08:18.000000', 'temperatura', 600.0000, 'ºC'),
	(36157, 109, '2015-02-01 00:08:19.000000', 'temperatura', 842.0000, 'ºC'),
	(36158, 109, '2015-02-01 00:08:20.000000', 'temperatura', 12.0000, 'ºC'),
	(36159, 109, '2015-02-01 00:08:21.000000', 'temperatura', 1134.0000, 'ºC'),
	(36160, 109, '2015-02-01 00:08:22.000000', 'temperatura', 836.0000, 'ºC'),
	(36161, 109, '2015-02-01 00:08:23.000000', 'temperatura', 775.0000, 'ºC'),
	(36162, 109, '2015-02-01 00:08:24.000000', 'temperatura', 170.0000, 'ºC'),
	(36163, 109, '2015-02-01 00:08:25.000000', 'temperatura', 926.0000, 'ºC'),
	(36164, 109, '2015-02-01 00:08:26.000000', 'temperatura', 521.0000, 'ºC'),
	(36165, 109, '2015-02-01 00:08:27.000000', 'temperatura', 1029.0000, 'ºC'),
	(36166, 109, '2015-02-01 00:08:28.000000', 'temperatura', 1180.0000, 'ºC'),
	(36167, 109, '2015-02-01 00:08:29.000000', 'temperatura', 413.0000, 'ºC'),
	(36168, 109, '2015-02-01 00:08:30.000000', 'temperatura', 925.0000, 'ºC'),
	(36169, 109, '2015-02-01 00:08:31.000000', 'temperatura', 988.0000, 'ºC'),
	(36170, 109, '2015-02-01 00:08:32.000000', 'temperatura', 963.0000, 'ºC'),
	(36171, 109, '2015-02-01 00:08:33.000000', 'temperatura', 653.0000, 'ºC'),
	(36172, 109, '2015-02-01 00:08:34.000000', 'temperatura', 377.0000, 'ºC'),
	(36173, 109, '2015-02-01 00:08:35.000000', 'temperatura', 1127.0000, 'ºC'),
	(36174, 109, '2015-02-01 00:08:36.000000', 'temperatura', 903.0000, 'ºC'),
	(36175, 109, '2015-02-01 00:08:37.000000', 'temperatura', 1135.0000, 'ºC'),
	(36176, 109, '2015-02-01 00:08:38.000000', 'temperatura', 566.0000, 'ºC'),
	(36177, 109, '2015-02-01 00:08:39.000000', 'temperatura', 626.0000, 'ºC'),
	(36178, 109, '2015-02-01 00:08:40.000000', 'temperatura', 232.0000, 'ºC'),
	(36179, 109, '2015-02-01 00:08:41.000000', 'temperatura', 481.0000, 'ºC'),
	(36180, 109, '2015-02-01 00:08:42.000000', 'temperatura', 511.0000, 'ºC'),
	(36181, 109, '2015-02-01 00:08:43.000000', 'temperatura', 1114.0000, 'ºC'),
	(36182, 109, '2015-02-01 00:08:44.000000', 'temperatura', 437.0000, 'ºC'),
	(36183, 109, '2015-02-01 00:08:45.000000', 'temperatura', 42.0000, 'ºC'),
	(36184, 109, '2015-02-01 00:08:46.000000', 'temperatura', 100.0000, 'ºC'),
	(36185, 109, '2015-02-01 00:08:47.000000', 'temperatura', 373.0000, 'ºC'),
	(36186, 109, '2015-02-01 00:08:48.000000', 'temperatura', 366.0000, 'ºC'),
	(36187, 109, '2015-02-01 00:08:49.000000', 'temperatura', 713.0000, 'ºC'),
	(36188, 109, '2015-02-01 00:08:50.000000', 'temperatura', 66.0000, 'ºC'),
	(36189, 109, '2015-02-01 00:08:51.000000', 'temperatura', 594.0000, 'ºC'),
	(36190, 109, '2015-02-01 00:08:52.000000', 'temperatura', 371.0000, 'ºC'),
	(36191, 109, '2015-02-01 00:08:53.000000', 'temperatura', 74.0000, 'ºC'),
	(36192, 109, '2015-02-01 00:08:54.000000', 'temperatura', 457.0000, 'ºC'),
	(36193, 109, '2015-02-01 00:08:55.000000', 'temperatura', 865.0000, 'ºC'),
	(36194, 109, '2015-02-01 00:08:56.000000', 'temperatura', 552.0000, 'ºC'),
	(36195, 109, '2015-02-01 00:08:57.000000', 'temperatura', 167.0000, 'ºC'),
	(36196, 109, '2015-02-01 00:08:58.000000', 'temperatura', 377.0000, 'ºC'),
	(36197, 109, '2015-02-01 00:08:59.000000', 'temperatura', 188.0000, 'ºC'),
	(36198, 109, '2015-02-01 00:09:00.000000', 'temperatura', 1007.0000, 'ºC'),
	(36199, 109, '2015-02-01 00:09:01.000000', 'temperatura', 873.0000, 'ºC'),
	(36200, 109, '2015-02-01 00:09:02.000000', 'temperatura', 145.0000, 'ºC'),
	(36201, 109, '2015-02-01 00:09:03.000000', 'temperatura', 504.0000, 'ºC'),
	(36202, 109, '2015-02-01 00:09:04.000000', 'temperatura', 888.0000, 'ºC'),
	(36203, 109, '2015-02-01 00:09:05.000000', 'temperatura', 526.0000, 'ºC'),
	(36204, 109, '2015-02-01 00:09:06.000000', 'temperatura', 1167.0000, 'ºC'),
	(36205, 109, '2015-02-01 00:09:07.000000', 'temperatura', 660.0000, 'ºC'),
	(36206, 109, '2015-02-01 00:09:08.000000', 'temperatura', 997.0000, 'ºC'),
	(36207, 109, '2015-02-01 00:09:09.000000', 'temperatura', 605.0000, 'ºC'),
	(36208, 109, '2015-02-01 00:09:10.000000', 'temperatura', 35.0000, 'ºC'),
	(36209, 109, '2015-02-01 00:09:11.000000', 'temperatura', 760.0000, 'ºC'),
	(36210, 109, '2015-02-01 00:09:12.000000', 'temperatura', 97.0000, 'ºC'),
	(36211, 109, '2015-02-01 00:09:13.000000', 'temperatura', 603.0000, 'ºC'),
	(36212, 109, '2015-02-01 00:09:14.000000', 'temperatura', 327.0000, 'ºC'),
	(36213, 109, '2015-02-01 00:09:15.000000', 'temperatura', 1025.0000, 'ºC'),
	(36214, 109, '2015-02-01 00:09:16.000000', 'temperatura', 544.0000, 'ºC'),
	(36215, 109, '2015-02-01 00:09:17.000000', 'temperatura', 847.0000, 'ºC'),
	(36216, 109, '2015-02-01 00:09:18.000000', 'temperatura', 201.0000, 'ºC'),
	(36217, 109, '2015-02-01 00:09:19.000000', 'temperatura', 866.0000, 'ºC'),
	(36218, 109, '2015-02-01 00:09:20.000000', 'temperatura', 128.0000, 'ºC'),
	(36219, 109, '2015-02-01 00:09:21.000000', 'temperatura', 442.0000, 'ºC'),
	(36220, 109, '2015-02-01 00:09:22.000000', 'temperatura', 626.0000, 'ºC'),
	(36221, 109, '2015-02-01 00:09:23.000000', 'temperatura', 603.0000, 'ºC'),
	(36222, 109, '2015-02-01 00:09:24.000000', 'temperatura', 1139.0000, 'ºC'),
	(36223, 109, '2015-02-01 00:09:25.000000', 'temperatura', 286.0000, 'ºC'),
	(36224, 109, '2015-02-01 00:09:26.000000', 'temperatura', 413.0000, 'ºC'),
	(36225, 109, '2015-02-01 00:09:27.000000', 'temperatura', 6.0000, 'ºC'),
	(36226, 109, '2015-02-01 00:09:28.000000', 'temperatura', 1192.0000, 'ºC'),
	(36227, 109, '2015-02-01 00:09:29.000000', 'temperatura', 1145.0000, 'ºC'),
	(36228, 109, '2015-02-01 00:09:30.000000', 'temperatura', 947.0000, 'ºC'),
	(36229, 109, '2015-02-01 00:09:31.000000', 'temperatura', 103.0000, 'ºC'),
	(36230, 109, '2015-02-01 00:09:32.000000', 'temperatura', 73.0000, 'ºC'),
	(36231, 109, '2015-02-01 00:09:33.000000', 'temperatura', 56.0000, 'ºC'),
	(36232, 109, '2015-02-01 00:09:34.000000', 'temperatura', 61.0000, 'ºC'),
	(36233, 109, '2015-02-01 00:09:35.000000', 'temperatura', 139.0000, 'ºC'),
	(36234, 109, '2015-02-01 00:09:36.000000', 'temperatura', 510.0000, 'ºC'),
	(36235, 109, '2015-02-01 00:09:37.000000', 'temperatura', 934.0000, 'ºC'),
	(36236, 109, '2015-02-01 00:09:38.000000', 'temperatura', 743.0000, 'ºC'),
	(36237, 109, '2015-02-01 00:09:39.000000', 'temperatura', 911.0000, 'ºC'),
	(36238, 109, '2015-02-01 00:09:40.000000', 'temperatura', 1126.0000, 'ºC'),
	(36239, 109, '2015-02-01 00:09:41.000000', 'temperatura', 497.0000, 'ºC'),
	(36240, 109, '2015-02-01 00:09:42.000000', 'temperatura', 306.0000, 'ºC'),
	(36241, 109, '2015-02-01 00:09:43.000000', 'temperatura', 43.0000, 'ºC'),
	(36242, 109, '2015-02-01 00:09:44.000000', 'temperatura', 496.0000, 'ºC'),
	(36243, 109, '2015-02-01 00:09:45.000000', 'temperatura', 1152.0000, 'ºC'),
	(36244, 109, '2015-02-01 00:09:46.000000', 'temperatura', 674.0000, 'ºC'),
	(36245, 109, '2015-02-01 00:09:47.000000', 'temperatura', 1112.0000, 'ºC'),
	(36246, 109, '2015-02-01 00:09:48.000000', 'temperatura', 1141.0000, 'ºC'),
	(36247, 109, '2015-02-01 00:09:49.000000', 'temperatura', 1167.0000, 'ºC'),
	(36248, 109, '2015-02-01 00:09:50.000000', 'temperatura', 15.0000, 'ºC'),
	(36249, 109, '2015-02-01 00:09:51.000000', 'temperatura', 172.0000, 'ºC'),
	(36250, 109, '2015-02-01 00:09:52.000000', 'temperatura', 818.0000, 'ºC'),
	(36251, 109, '2015-02-01 00:09:53.000000', 'temperatura', 1172.0000, 'ºC'),
	(36252, 109, '2015-02-01 00:09:54.000000', 'temperatura', 1009.0000, 'ºC'),
	(36253, 109, '2015-02-01 00:09:55.000000', 'temperatura', 328.0000, 'ºC'),
	(36254, 109, '2015-02-01 00:09:56.000000', 'temperatura', 1014.0000, 'ºC'),
	(36255, 109, '2015-02-01 00:09:57.000000', 'temperatura', 487.0000, 'ºC'),
	(36256, 109, '2015-02-01 00:09:58.000000', 'temperatura', 593.0000, 'ºC'),
	(36257, 109, '2015-02-01 00:09:59.000000', 'temperatura', 306.0000, 'ºC'),
	(36258, 109, '2015-02-01 00:10:00.000000', 'temperatura', 949.0000, 'ºC'),
	(36259, 109, '2015-02-01 00:10:01.000000', 'temperatura', 229.0000, 'ºC'),
	(36260, 109, '2015-02-01 00:10:02.000000', 'temperatura', 696.0000, 'ºC'),
	(36261, 109, '2015-02-01 00:10:03.000000', 'temperatura', 397.0000, 'ºC'),
	(36262, 109, '2015-02-01 00:10:04.000000', 'temperatura', 1094.0000, 'ºC'),
	(36263, 109, '2015-02-01 00:10:05.000000', 'temperatura', 681.0000, 'ºC'),
	(36264, 109, '2015-02-01 00:10:06.000000', 'temperatura', 124.0000, 'ºC'),
	(36265, 109, '2015-02-01 00:10:07.000000', 'temperatura', 979.0000, 'ºC'),
	(36266, 109, '2015-02-01 00:10:08.000000', 'temperatura', 921.0000, 'ºC'),
	(36267, 109, '2015-02-01 00:10:09.000000', 'temperatura', 471.0000, 'ºC'),
	(36268, 109, '2015-02-01 00:10:10.000000', 'temperatura', 791.0000, 'ºC'),
	(36269, 109, '2015-02-01 00:10:11.000000', 'temperatura', 143.0000, 'ºC'),
	(36270, 109, '2015-02-01 00:10:12.000000', 'temperatura', 741.0000, 'ºC'),
	(36271, 109, '2015-02-01 00:10:13.000000', 'temperatura', 879.0000, 'ºC'),
	(36272, 109, '2015-02-01 00:10:14.000000', 'temperatura', 972.0000, 'ºC'),
	(36273, 109, '2015-02-01 00:10:15.000000', 'temperatura', 1022.0000, 'ºC'),
	(36274, 109, '2015-02-01 00:10:16.000000', 'temperatura', 994.0000, 'ºC'),
	(36275, 109, '2015-02-01 00:10:17.000000', 'temperatura', 704.0000, 'ºC'),
	(36276, 109, '2015-02-01 00:10:18.000000', 'temperatura', 538.0000, 'ºC'),
	(36277, 109, '2015-02-01 00:10:19.000000', 'temperatura', 581.0000, 'ºC'),
	(36278, 109, '2015-02-01 00:10:20.000000', 'temperatura', 89.0000, 'ºC'),
	(36279, 109, '2015-02-01 00:10:21.000000', 'temperatura', 1104.0000, 'ºC'),
	(36280, 109, '2015-02-01 00:10:22.000000', 'temperatura', 454.0000, 'ºC'),
	(36281, 109, '2015-02-01 00:10:23.000000', 'temperatura', 157.0000, 'ºC'),
	(36282, 109, '2015-02-01 00:10:24.000000', 'temperatura', 625.0000, 'ºC'),
	(36283, 109, '2015-02-01 00:10:25.000000', 'temperatura', 253.0000, 'ºC'),
	(36284, 109, '2015-02-01 00:10:26.000000', 'temperatura', 590.0000, 'ºC'),
	(36285, 109, '2015-02-01 00:10:27.000000', 'temperatura', 991.0000, 'ºC'),
	(36286, 109, '2015-02-01 00:10:28.000000', 'temperatura', 786.0000, 'ºC'),
	(36287, 109, '2015-02-01 00:10:29.000000', 'temperatura', 958.0000, 'ºC'),
	(36288, 109, '2015-02-01 00:10:30.000000', 'temperatura', 33.0000, 'ºC'),
	(36289, 109, '2015-02-01 00:10:31.000000', 'temperatura', 892.0000, 'ºC'),
	(36290, 109, '2015-02-01 00:10:32.000000', 'temperatura', 762.0000, 'ºC'),
	(36291, 109, '2015-02-01 00:10:33.000000', 'temperatura', 1135.0000, 'ºC'),
	(36292, 109, '2015-02-01 00:10:34.000000', 'temperatura', 989.0000, 'ºC'),
	(36293, 109, '2015-02-01 00:10:35.000000', 'temperatura', 339.0000, 'ºC'),
	(36294, 109, '2015-02-01 00:10:36.000000', 'temperatura', 1129.0000, 'ºC'),
	(36295, 109, '2015-02-01 00:10:37.000000', 'temperatura', 1030.0000, 'ºC'),
	(36296, 109, '2015-02-01 00:10:38.000000', 'temperatura', 564.0000, 'ºC'),
	(36297, 109, '2015-02-01 00:10:39.000000', 'temperatura', 927.0000, 'ºC'),
	(36298, 109, '2015-02-01 00:10:40.000000', 'temperatura', 547.0000, 'ºC'),
	(36299, 109, '2015-02-01 00:10:41.000000', 'temperatura', 1155.0000, 'ºC'),
	(36300, 109, '2015-02-01 00:10:42.000000', 'temperatura', 532.0000, 'ºC'),
	(36301, 109, '2015-02-01 00:10:43.000000', 'temperatura', 398.0000, 'ºC'),
	(36302, 109, '2015-02-01 00:10:44.000000', 'temperatura', 393.0000, 'ºC'),
	(36303, 109, '2015-02-01 00:10:45.000000', 'temperatura', 771.0000, 'ºC'),
	(36304, 109, '2015-02-01 00:10:46.000000', 'temperatura', 276.0000, 'ºC'),
	(36305, 109, '2015-02-01 00:10:47.000000', 'temperatura', 270.0000, 'ºC'),
	(36306, 109, '2015-02-01 00:10:48.000000', 'temperatura', 521.0000, 'ºC'),
	(36307, 109, '2015-02-01 00:10:49.000000', 'temperatura', 594.0000, 'ºC'),
	(36308, 109, '2015-02-01 00:10:50.000000', 'temperatura', 208.0000, 'ºC'),
	(36309, 109, '2015-02-01 00:10:51.000000', 'temperatura', 460.0000, 'ºC'),
	(36310, 109, '2015-02-01 00:10:52.000000', 'temperatura', 477.0000, 'ºC'),
	(36311, 109, '2015-02-01 00:10:53.000000', 'temperatura', 1005.0000, 'ºC'),
	(36312, 109, '2015-02-01 00:10:54.000000', 'temperatura', 1195.0000, 'ºC'),
	(36313, 109, '2015-02-01 00:10:55.000000', 'temperatura', 561.0000, 'ºC'),
	(36314, 109, '2015-02-01 00:10:56.000000', 'temperatura', 420.0000, 'ºC'),
	(36315, 109, '2015-02-01 00:10:57.000000', 'temperatura', 416.0000, 'ºC'),
	(36316, 109, '2015-02-01 00:10:58.000000', 'temperatura', 821.0000, 'ºC'),
	(36317, 109, '2015-02-01 00:10:59.000000', 'temperatura', 458.0000, 'ºC'),
	(36318, 109, '2015-02-01 00:11:00.000000', 'temperatura', 1029.0000, 'ºC'),
	(36319, 109, '2015-02-01 00:11:01.000000', 'temperatura', 171.0000, 'ºC'),
	(36320, 109, '2015-02-01 00:11:02.000000', 'temperatura', 170.0000, 'ºC'),
	(36321, 109, '2015-02-01 00:11:03.000000', 'temperatura', 336.0000, 'ºC'),
	(36322, 109, '2015-02-01 00:11:04.000000', 'temperatura', 1169.0000, 'ºC'),
	(36323, 109, '2015-02-01 00:11:05.000000', 'temperatura', 39.0000, 'ºC'),
	(36324, 109, '2015-02-01 00:11:06.000000', 'temperatura', 289.0000, 'ºC'),
	(36325, 109, '2015-02-01 00:11:07.000000', 'temperatura', 129.0000, 'ºC'),
	(36326, 109, '2015-02-01 00:11:08.000000', 'temperatura', 977.0000, 'ºC'),
	(36327, 109, '2015-02-01 00:11:09.000000', 'temperatura', 897.0000, 'ºC'),
	(36328, 109, '2015-02-01 00:11:10.000000', 'temperatura', 358.0000, 'ºC'),
	(36329, 109, '2015-02-01 00:11:11.000000', 'temperatura', 297.0000, 'ºC'),
	(36330, 109, '2015-02-01 00:11:12.000000', 'temperatura', 411.0000, 'ºC'),
	(36331, 109, '2015-02-01 00:11:13.000000', 'temperatura', 1164.0000, 'ºC'),
	(36332, 109, '2015-02-01 00:11:14.000000', 'temperatura', 987.0000, 'ºC'),
	(36333, 109, '2015-02-01 00:11:15.000000', 'temperatura', 244.0000, 'ºC'),
	(36334, 109, '2015-02-01 00:11:16.000000', 'temperatura', 660.0000, 'ºC'),
	(36335, 109, '2015-02-01 00:11:17.000000', 'temperatura', 167.0000, 'ºC'),
	(36336, 109, '2015-02-01 00:11:18.000000', 'temperatura', 58.0000, 'ºC'),
	(36337, 109, '2015-02-01 00:11:19.000000', 'temperatura', 990.0000, 'ºC'),
	(36338, 109, '2015-02-01 00:11:20.000000', 'temperatura', 1174.0000, 'ºC'),
	(36339, 109, '2015-02-01 00:11:21.000000', 'temperatura', 501.0000, 'ºC'),
	(36340, 109, '2015-02-01 00:11:22.000000', 'temperatura', 186.0000, 'ºC'),
	(36341, 109, '2015-02-01 00:11:23.000000', 'temperatura', 625.0000, 'ºC'),
	(36342, 109, '2015-02-01 00:11:24.000000', 'temperatura', 167.0000, 'ºC'),
	(36343, 109, '2015-02-01 00:11:25.000000', 'temperatura', 160.0000, 'ºC'),
	(36344, 109, '2015-02-01 00:11:26.000000', 'temperatura', 300.0000, 'ºC'),
	(36345, 109, '2015-02-01 00:11:27.000000', 'temperatura', 1020.0000, 'ºC'),
	(36346, 109, '2015-02-01 00:11:28.000000', 'temperatura', 601.0000, 'ºC'),
	(36347, 109, '2015-02-01 00:11:29.000000', 'temperatura', 1143.0000, 'ºC'),
	(36348, 109, '2015-02-01 00:11:30.000000', 'temperatura', 316.0000, 'ºC'),
	(36349, 109, '2015-02-01 00:11:31.000000', 'temperatura', 551.0000, 'ºC'),
	(36350, 109, '2015-02-01 00:11:32.000000', 'temperatura', 609.0000, 'ºC'),
	(36351, 109, '2015-02-01 00:11:33.000000', 'temperatura', 192.0000, 'ºC'),
	(36352, 109, '2015-02-01 00:11:34.000000', 'temperatura', 331.0000, 'ºC'),
	(36353, 109, '2015-02-01 00:11:35.000000', 'temperatura', 1080.0000, 'ºC'),
	(36354, 109, '2015-02-01 00:11:36.000000', 'temperatura', 810.0000, 'ºC'),
	(36355, 109, '2015-02-01 00:11:37.000000', 'temperatura', 808.0000, 'ºC'),
	(36356, 109, '2015-02-01 00:11:38.000000', 'temperatura', 410.0000, 'ºC'),
	(36357, 109, '2015-02-01 00:11:39.000000', 'temperatura', 826.0000, 'ºC'),
	(36358, 109, '2015-02-01 00:11:40.000000', 'temperatura', 501.0000, 'ºC'),
	(36359, 109, '2015-02-01 00:11:41.000000', 'temperatura', 30.0000, 'ºC'),
	(36360, 109, '2015-02-01 00:11:42.000000', 'temperatura', 1045.0000, 'ºC'),
	(36361, 109, '2015-02-01 00:11:43.000000', 'temperatura', 338.0000, 'ºC'),
	(36362, 109, '2015-02-01 00:11:44.000000', 'temperatura', 955.0000, 'ºC'),
	(36363, 109, '2015-02-01 00:11:45.000000', 'temperatura', 161.0000, 'ºC'),
	(36364, 109, '2015-02-01 00:11:46.000000', 'temperatura', 341.0000, 'ºC'),
	(36365, 109, '2015-02-01 00:11:47.000000', 'temperatura', 24.0000, 'ºC'),
	(36366, 109, '2015-02-01 00:11:48.000000', 'temperatura', 297.0000, 'ºC'),
	(36367, 109, '2015-02-01 00:11:49.000000', 'temperatura', 213.0000, 'ºC'),
	(36368, 109, '2015-02-01 00:11:50.000000', 'temperatura', 173.0000, 'ºC'),
	(36369, 109, '2015-02-01 00:11:51.000000', 'temperatura', 227.0000, 'ºC'),
	(36370, 109, '2015-02-01 00:11:52.000000', 'temperatura', 618.0000, 'ºC'),
	(36371, 109, '2015-02-01 00:11:53.000000', 'temperatura', 9.0000, 'ºC'),
	(36372, 109, '2015-02-01 00:11:54.000000', 'temperatura', 593.0000, 'ºC'),
	(36373, 109, '2015-02-01 00:11:55.000000', 'temperatura', 537.0000, 'ºC'),
	(36374, 109, '2015-02-01 00:11:56.000000', 'temperatura', 908.0000, 'ºC'),
	(36375, 109, '2015-02-01 00:11:57.000000', 'temperatura', 530.0000, 'ºC'),
	(36376, 109, '2015-02-01 00:11:58.000000', 'temperatura', 1127.0000, 'ºC'),
	(36377, 109, '2015-02-01 00:11:59.000000', 'temperatura', 444.0000, 'ºC'),
	(36378, 109, '2015-02-01 00:12:00.000000', 'temperatura', 41.0000, 'ºC'),
	(36379, 109, '2015-02-01 00:12:01.000000', 'temperatura', 73.0000, 'ºC'),
	(36380, 109, '2015-02-01 00:12:02.000000', 'temperatura', 244.0000, 'ºC'),
	(36381, 109, '2015-02-01 00:12:03.000000', 'temperatura', 998.0000, 'ºC'),
	(36382, 109, '2015-02-01 00:12:04.000000', 'temperatura', 661.0000, 'ºC'),
	(36383, 109, '2015-02-01 00:12:05.000000', 'temperatura', 311.0000, 'ºC'),
	(36384, 109, '2015-02-01 00:12:06.000000', 'temperatura', 770.0000, 'ºC'),
	(36385, 109, '2015-02-01 00:12:07.000000', 'temperatura', 520.0000, 'ºC'),
	(36386, 109, '2015-02-01 00:12:08.000000', 'temperatura', 291.0000, 'ºC'),
	(36387, 109, '2015-02-01 00:12:09.000000', 'temperatura', 1097.0000, 'ºC'),
	(36388, 109, '2015-02-01 00:12:10.000000', 'temperatura', 1009.0000, 'ºC'),
	(36389, 109, '2015-02-01 00:12:11.000000', 'temperatura', 557.0000, 'ºC'),
	(36390, 109, '2015-02-01 00:12:12.000000', 'temperatura', 960.0000, 'ºC'),
	(36391, 109, '2015-02-01 00:12:13.000000', 'temperatura', 726.0000, 'ºC'),
	(36392, 109, '2015-02-01 00:12:14.000000', 'temperatura', 753.0000, 'ºC'),
	(36393, 109, '2015-02-01 00:12:15.000000', 'temperatura', 389.0000, 'ºC'),
	(36394, 109, '2015-02-01 00:12:16.000000', 'temperatura', 883.0000, 'ºC'),
	(36395, 109, '2015-02-01 00:12:17.000000', 'temperatura', 852.0000, 'ºC'),
	(36396, 109, '2015-02-01 00:12:18.000000', 'temperatura', 409.0000, 'ºC'),
	(36397, 109, '2015-02-01 00:12:19.000000', 'temperatura', 688.0000, 'ºC'),
	(36398, 109, '2015-02-01 00:12:20.000000', 'temperatura', 1016.0000, 'ºC'),
	(36399, 109, '2015-02-01 00:12:21.000000', 'temperatura', 616.0000, 'ºC'),
	(36400, 109, '2015-02-01 00:12:22.000000', 'temperatura', 34.0000, 'ºC'),
	(36401, 109, '2015-02-01 00:12:23.000000', 'temperatura', 723.0000, 'ºC'),
	(36402, 109, '2015-02-01 00:12:24.000000', 'temperatura', 1112.0000, 'ºC'),
	(36403, 109, '2015-02-01 00:12:25.000000', 'temperatura', 994.0000, 'ºC'),
	(36404, 109, '2015-02-01 00:12:26.000000', 'temperatura', 432.0000, 'ºC'),
	(36405, 109, '2015-02-01 00:12:27.000000', 'temperatura', 379.0000, 'ºC'),
	(36406, 109, '2015-02-01 00:12:28.000000', 'temperatura', 599.0000, 'ºC'),
	(36407, 109, '2015-02-01 00:12:29.000000', 'temperatura', 659.0000, 'ºC'),
	(36408, 109, '2015-02-01 00:12:30.000000', 'temperatura', 299.0000, 'ºC'),
	(36409, 109, '2015-02-01 00:12:31.000000', 'temperatura', 719.0000, 'ºC'),
	(36410, 109, '2015-02-01 00:12:32.000000', 'temperatura', 296.0000, 'ºC'),
	(36411, 109, '2015-02-01 00:12:33.000000', 'temperatura', 525.0000, 'ºC'),
	(36412, 109, '2015-02-01 00:12:34.000000', 'temperatura', 538.0000, 'ºC'),
	(36413, 109, '2015-02-01 00:12:35.000000', 'temperatura', 1114.0000, 'ºC'),
	(36414, 109, '2015-02-01 00:12:36.000000', 'temperatura', 358.0000, 'ºC'),
	(36415, 109, '2015-02-01 00:12:37.000000', 'temperatura', 847.0000, 'ºC'),
	(36416, 109, '2015-02-01 00:12:38.000000', 'temperatura', 764.0000, 'ºC'),
	(36417, 109, '2015-02-01 00:12:39.000000', 'temperatura', 77.0000, 'ºC'),
	(36418, 109, '2015-02-01 00:12:40.000000', 'temperatura', 496.0000, 'ºC'),
	(36419, 109, '2015-02-01 00:12:41.000000', 'temperatura', 1048.0000, 'ºC'),
	(36420, 109, '2015-02-01 00:12:42.000000', 'temperatura', 152.0000, 'ºC'),
	(36421, 109, '2015-02-01 00:12:43.000000', 'temperatura', 16.0000, 'ºC'),
	(36422, 109, '2015-02-01 00:12:44.000000', 'temperatura', 823.0000, 'ºC'),
	(36423, 109, '2015-02-01 00:12:45.000000', 'temperatura', 470.0000, 'ºC'),
	(36424, 109, '2015-02-01 00:12:46.000000', 'temperatura', 1082.0000, 'ºC'),
	(36425, 109, '2015-02-01 00:12:47.000000', 'temperatura', 402.0000, 'ºC'),
	(36426, 109, '2015-02-01 00:12:48.000000', 'temperatura', 1162.0000, 'ºC'),
	(36427, 109, '2015-02-01 00:12:49.000000', 'temperatura', 1004.0000, 'ºC'),
	(36428, 109, '2015-02-01 00:12:50.000000', 'temperatura', 334.0000, 'ºC'),
	(36429, 109, '2015-02-01 00:12:51.000000', 'temperatura', 1060.0000, 'ºC'),
	(36430, 109, '2015-02-01 00:12:52.000000', 'temperatura', 700.0000, 'ºC'),
	(36431, 109, '2015-02-01 00:12:53.000000', 'temperatura', 319.0000, 'ºC'),
	(36432, 109, '2015-02-01 00:12:54.000000', 'temperatura', 695.0000, 'ºC'),
	(36433, 109, '2015-02-01 00:12:55.000000', 'temperatura', 118.0000, 'ºC'),
	(36434, 109, '2015-02-01 00:12:56.000000', 'temperatura', 906.0000, 'ºC'),
	(36435, 109, '2015-02-01 00:12:57.000000', 'temperatura', 578.0000, 'ºC'),
	(36436, 109, '2015-02-01 00:12:58.000000', 'temperatura', 171.0000, 'ºC'),
	(36437, 109, '2015-02-01 00:12:59.000000', 'temperatura', 324.0000, 'ºC'),
	(36438, 109, '2015-02-01 00:13:00.000000', 'temperatura', 1104.0000, 'ºC'),
	(36439, 109, '2015-02-01 00:13:01.000000', 'temperatura', 952.0000, 'ºC'),
	(36440, 109, '2015-02-01 00:13:02.000000', 'temperatura', 246.0000, 'ºC'),
	(36441, 109, '2015-02-01 00:13:03.000000', 'temperatura', 773.0000, 'ºC'),
	(36442, 109, '2015-02-01 00:13:04.000000', 'temperatura', 730.0000, 'ºC'),
	(36443, 109, '2015-02-01 00:13:05.000000', 'temperatura', 130.0000, 'ºC'),
	(36444, 109, '2015-02-01 00:13:06.000000', 'temperatura', 862.0000, 'ºC'),
	(36445, 109, '2015-02-01 00:13:07.000000', 'temperatura', 318.0000, 'ºC'),
	(36446, 109, '2015-02-01 00:13:08.000000', 'temperatura', 205.0000, 'ºC'),
	(36447, 109, '2015-02-01 00:13:09.000000', 'temperatura', 73.0000, 'ºC'),
	(36448, 109, '2015-02-01 00:13:10.000000', 'temperatura', 952.0000, 'ºC'),
	(36449, 109, '2015-02-01 00:13:11.000000', 'temperatura', 939.0000, 'ºC'),
	(36450, 109, '2015-02-01 00:13:12.000000', 'temperatura', 640.0000, 'ºC'),
	(36451, 109, '2015-02-01 00:13:13.000000', 'temperatura', 384.0000, 'ºC'),
	(36452, 109, '2015-02-01 00:13:14.000000', 'temperatura', 0.0000, 'ºC'),
	(36453, 109, '2015-02-01 00:13:15.000000', 'temperatura', 49.0000, 'ºC'),
	(36454, 109, '2015-02-01 00:13:16.000000', 'temperatura', 245.0000, 'ºC'),
	(36455, 109, '2015-02-01 00:13:17.000000', 'temperatura', 1078.0000, 'ºC'),
	(36456, 109, '2015-02-01 00:13:18.000000', 'temperatura', 1056.0000, 'ºC'),
	(36457, 109, '2015-02-01 00:13:19.000000', 'temperatura', 845.0000, 'ºC'),
	(36458, 109, '2015-02-01 00:13:20.000000', 'temperatura', 1058.0000, 'ºC'),
	(36459, 109, '2015-02-01 00:13:21.000000', 'temperatura', 355.0000, 'ºC'),
	(36460, 109, '2015-02-01 00:13:22.000000', 'temperatura', 1001.0000, 'ºC'),
	(36461, 109, '2015-02-01 00:13:23.000000', 'temperatura', 340.0000, 'ºC'),
	(36462, 109, '2015-02-01 00:13:24.000000', 'temperatura', 1098.0000, 'ºC'),
	(36463, 109, '2015-02-01 00:13:25.000000', 'temperatura', 872.0000, 'ºC'),
	(36464, 109, '2015-02-01 00:13:26.000000', 'temperatura', 1066.0000, 'ºC'),
	(36465, 109, '2015-02-01 00:13:27.000000', 'temperatura', 312.0000, 'ºC'),
	(36466, 109, '2015-02-01 00:13:28.000000', 'temperatura', 765.0000, 'ºC'),
	(36467, 109, '2015-02-01 00:13:29.000000', 'temperatura', 487.0000, 'ºC'),
	(36468, 109, '2015-02-01 00:13:30.000000', 'temperatura', 143.0000, 'ºC'),
	(36469, 109, '2015-02-01 00:13:31.000000', 'temperatura', 455.0000, 'ºC'),
	(36470, 109, '2015-02-01 00:13:32.000000', 'temperatura', 644.0000, 'ºC'),
	(36471, 109, '2015-02-01 00:13:33.000000', 'temperatura', 655.0000, 'ºC'),
	(36472, 109, '2015-02-01 00:13:34.000000', 'temperatura', 143.0000, 'ºC'),
	(36473, 109, '2015-02-01 00:13:35.000000', 'temperatura', 1152.0000, 'ºC'),
	(36474, 109, '2015-02-01 00:13:36.000000', 'temperatura', 533.0000, 'ºC'),
	(36475, 109, '2015-02-01 00:13:37.000000', 'temperatura', 410.0000, 'ºC'),
	(36476, 109, '2015-02-01 00:13:38.000000', 'temperatura', 448.0000, 'ºC'),
	(36477, 109, '2015-02-01 00:13:39.000000', 'temperatura', 1014.0000, 'ºC'),
	(36478, 109, '2015-02-01 00:13:40.000000', 'temperatura', 125.0000, 'ºC'),
	(36479, 109, '2015-02-01 00:13:41.000000', 'temperatura', 1183.0000, 'ºC'),
	(36480, 109, '2015-02-01 00:13:42.000000', 'temperatura', 740.0000, 'ºC'),
	(36481, 109, '2015-02-01 00:13:43.000000', 'temperatura', 154.0000, 'ºC'),
	(36482, 109, '2015-02-01 00:13:44.000000', 'temperatura', 947.0000, 'ºC'),
	(36483, 109, '2015-02-01 00:13:45.000000', 'temperatura', 677.0000, 'ºC'),
	(36484, 109, '2015-02-01 00:13:46.000000', 'temperatura', 543.0000, 'ºC'),
	(36485, 109, '2015-02-01 00:13:47.000000', 'temperatura', 686.0000, 'ºC'),
	(36486, 109, '2015-02-01 00:13:48.000000', 'temperatura', 599.0000, 'ºC'),
	(36487, 109, '2015-02-01 00:13:49.000000', 'temperatura', 940.0000, 'ºC'),
	(36488, 109, '2015-02-01 00:13:50.000000', 'temperatura', 504.0000, 'ºC'),
	(36489, 109, '2015-02-01 00:13:51.000000', 'temperatura', 899.0000, 'ºC'),
	(36490, 109, '2015-02-01 00:13:52.000000', 'temperatura', 583.0000, 'ºC'),
	(36491, 109, '2015-02-01 00:13:53.000000', 'temperatura', 217.0000, 'ºC'),
	(36492, 109, '2015-02-01 00:13:54.000000', 'temperatura', 540.0000, 'ºC'),
	(36493, 109, '2015-02-01 00:13:55.000000', 'temperatura', 846.0000, 'ºC'),
	(36494, 109, '2015-02-01 00:13:56.000000', 'temperatura', 213.0000, 'ºC'),
	(36495, 109, '2015-02-01 00:13:57.000000', 'temperatura', 927.0000, 'ºC'),
	(36496, 109, '2015-02-01 00:13:58.000000', 'temperatura', 396.0000, 'ºC'),
	(36497, 109, '2015-02-01 00:13:59.000000', 'temperatura', 398.0000, 'ºC'),
	(36498, 109, '2015-02-01 00:14:00.000000', 'temperatura', 804.0000, 'ºC'),
	(36499, 109, '2015-02-01 00:14:01.000000', 'temperatura', 428.0000, 'ºC'),
	(36500, 109, '2015-02-01 00:14:02.000000', 'temperatura', 929.0000, 'ºC'),
	(36501, 109, '2015-02-01 00:14:03.000000', 'temperatura', 959.0000, 'ºC'),
	(36502, 109, '2015-02-01 00:14:04.000000', 'temperatura', 808.0000, 'ºC'),
	(36503, 109, '2015-02-01 00:14:05.000000', 'temperatura', 1165.0000, 'ºC'),
	(36504, 109, '2015-02-01 00:14:06.000000', 'temperatura', 1000.0000, 'ºC'),
	(36505, 109, '2015-02-01 00:14:07.000000', 'temperatura', 304.0000, 'ºC'),
	(36506, 109, '2015-02-01 00:14:08.000000', 'temperatura', 924.0000, 'ºC'),
	(36507, 109, '2015-02-01 00:14:09.000000', 'temperatura', 107.0000, 'ºC'),
	(36508, 109, '2015-02-01 00:14:10.000000', 'temperatura', 164.0000, 'ºC'),
	(36509, 109, '2015-02-01 00:14:11.000000', 'temperatura', 498.0000, 'ºC'),
	(36510, 109, '2015-02-01 00:14:12.000000', 'temperatura', 799.0000, 'ºC'),
	(36511, 109, '2015-02-01 00:14:13.000000', 'temperatura', 102.0000, 'ºC'),
	(36512, 109, '2015-02-01 00:14:14.000000', 'temperatura', 513.0000, 'ºC'),
	(36513, 109, '2015-02-01 00:14:15.000000', 'temperatura', 1060.0000, 'ºC'),
	(36514, 109, '2015-02-01 00:14:16.000000', 'temperatura', 162.0000, 'ºC'),
	(36515, 109, '2015-02-01 00:14:17.000000', 'temperatura', 31.0000, 'ºC'),
	(36516, 109, '2015-02-01 00:14:18.000000', 'temperatura', 867.0000, 'ºC'),
	(36517, 109, '2015-02-01 00:14:19.000000', 'temperatura', 643.0000, 'ºC'),
	(36518, 109, '2015-02-01 00:14:20.000000', 'temperatura', 613.0000, 'ºC'),
	(36519, 109, '2015-02-01 00:14:21.000000', 'temperatura', 1139.0000, 'ºC'),
	(36520, 109, '2015-02-01 00:14:22.000000', 'temperatura', 256.0000, 'ºC'),
	(36521, 109, '2015-02-01 00:14:23.000000', 'temperatura', 264.0000, 'ºC'),
	(36522, 109, '2015-02-01 00:14:24.000000', 'temperatura', 553.0000, 'ºC'),
	(36523, 109, '2015-02-01 00:14:25.000000', 'temperatura', 771.0000, 'ºC'),
	(36524, 109, '2015-02-01 00:14:26.000000', 'temperatura', 1000.0000, 'ºC'),
	(36525, 109, '2015-02-01 00:14:27.000000', 'temperatura', 285.0000, 'ºC'),
	(36526, 109, '2015-02-01 00:14:28.000000', 'temperatura', 826.0000, 'ºC'),
	(36527, 109, '2015-02-01 00:14:29.000000', 'temperatura', 874.0000, 'ºC'),
	(36528, 109, '2015-02-01 00:14:30.000000', 'temperatura', 695.0000, 'ºC'),
	(36529, 109, '2015-02-01 00:14:31.000000', 'temperatura', 854.0000, 'ºC'),
	(36530, 109, '2015-02-01 00:14:32.000000', 'temperatura', 984.0000, 'ºC'),
	(36531, 109, '2015-02-01 00:14:33.000000', 'temperatura', 1158.0000, 'ºC'),
	(36532, 109, '2015-02-01 00:14:34.000000', 'temperatura', 439.0000, 'ºC'),
	(36533, 109, '2015-02-01 00:14:35.000000', 'temperatura', 1123.0000, 'ºC'),
	(36534, 109, '2015-02-01 00:14:36.000000', 'temperatura', 698.0000, 'ºC'),
	(36535, 109, '2015-02-01 00:14:37.000000', 'temperatura', 122.0000, 'ºC'),
	(36536, 109, '2015-02-01 00:14:38.000000', 'temperatura', 917.0000, 'ºC'),
	(36537, 109, '2015-02-01 00:14:39.000000', 'temperatura', 621.0000, 'ºC'),
	(36538, 109, '2015-02-01 00:14:40.000000', 'temperatura', 351.0000, 'ºC'),
	(36539, 109, '2015-02-01 00:14:41.000000', 'temperatura', 1093.0000, 'ºC'),
	(36540, 109, '2015-02-01 00:14:42.000000', 'temperatura', 813.0000, 'ºC'),
	(36541, 109, '2015-02-01 00:14:43.000000', 'temperatura', 787.0000, 'ºC'),
	(36542, 109, '2015-02-01 00:14:44.000000', 'temperatura', 298.0000, 'ºC'),
	(36543, 109, '2015-02-01 00:14:45.000000', 'temperatura', 327.0000, 'ºC'),
	(36544, 109, '2015-02-01 00:14:46.000000', 'temperatura', 741.0000, 'ºC'),
	(36545, 109, '2015-02-01 00:14:47.000000', 'temperatura', 326.0000, 'ºC'),
	(36546, 109, '2015-02-01 00:14:48.000000', 'temperatura', 606.0000, 'ºC'),
	(36547, 109, '2015-02-01 00:14:49.000000', 'temperatura', 853.0000, 'ºC'),
	(36548, 109, '2015-02-01 00:14:50.000000', 'temperatura', 47.0000, 'ºC'),
	(36549, 109, '2015-02-01 00:14:51.000000', 'temperatura', 76.0000, 'ºC'),
	(36550, 109, '2015-02-01 00:14:52.000000', 'temperatura', 241.0000, 'ºC'),
	(36551, 109, '2015-02-01 00:14:53.000000', 'temperatura', 978.0000, 'ºC'),
	(36552, 109, '2015-02-01 00:14:54.000000', 'temperatura', 567.0000, 'ºC'),
	(36553, 109, '2015-02-01 00:14:55.000000', 'temperatura', 1100.0000, 'ºC'),
	(36554, 109, '2015-02-01 00:14:56.000000', 'temperatura', 202.0000, 'ºC'),
	(36555, 109, '2015-02-01 00:14:57.000000', 'temperatura', 111.0000, 'ºC'),
	(36556, 109, '2015-02-01 00:14:58.000000', 'temperatura', 1149.0000, 'ºC'),
	(36557, 109, '2015-02-01 00:14:59.000000', 'temperatura', 614.0000, 'ºC'),
	(36558, 109, '2015-02-01 00:15:00.000000', 'temperatura', 823.0000, 'ºC'),
	(36559, 109, '2015-02-01 00:15:01.000000', 'temperatura', 1072.0000, 'ºC'),
	(36560, 109, '2015-02-01 00:15:02.000000', 'temperatura', 492.0000, 'ºC'),
	(36561, 109, '2015-02-01 00:15:03.000000', 'temperatura', 443.0000, 'ºC'),
	(36562, 109, '2015-02-01 00:15:04.000000', 'temperatura', 741.0000, 'ºC'),
	(36563, 109, '2015-02-01 00:15:05.000000', 'temperatura', 1176.0000, 'ºC'),
	(36564, 109, '2015-02-01 00:15:06.000000', 'temperatura', 59.0000, 'ºC'),
	(36565, 109, '2015-02-01 00:15:07.000000', 'temperatura', 366.0000, 'ºC'),
	(36566, 109, '2015-02-01 00:15:08.000000', 'temperatura', 454.0000, 'ºC'),
	(36567, 109, '2015-02-01 00:15:09.000000', 'temperatura', 1172.0000, 'ºC'),
	(36568, 109, '2015-02-01 00:15:10.000000', 'temperatura', 899.0000, 'ºC'),
	(36569, 109, '2015-02-01 00:15:11.000000', 'temperatura', 979.0000, 'ºC'),
	(36570, 109, '2015-02-01 00:15:12.000000', 'temperatura', 1000.0000, 'ºC'),
	(36571, 109, '2015-02-01 00:15:13.000000', 'temperatura', 861.0000, 'ºC'),
	(36572, 109, '2015-02-01 00:15:14.000000', 'temperatura', 106.0000, 'ºC'),
	(36573, 109, '2015-02-01 00:15:15.000000', 'temperatura', 349.0000, 'ºC'),
	(36574, 109, '2015-02-01 00:15:16.000000', 'temperatura', 228.0000, 'ºC'),
	(36575, 109, '2015-02-01 00:15:17.000000', 'temperatura', 94.0000, 'ºC'),
	(36576, 109, '2015-02-01 00:15:18.000000', 'temperatura', 984.0000, 'ºC'),
	(36577, 109, '2015-02-01 00:15:19.000000', 'temperatura', 1039.0000, 'ºC'),
	(36578, 109, '2015-02-01 00:15:20.000000', 'temperatura', 1044.0000, 'ºC'),
	(36579, 109, '2015-02-01 00:15:21.000000', 'temperatura', 902.0000, 'ºC'),
	(36580, 109, '2015-02-01 00:15:22.000000', 'temperatura', 179.0000, 'ºC'),
	(36581, 109, '2015-02-01 00:15:23.000000', 'temperatura', 591.0000, 'ºC'),
	(36582, 109, '2015-02-01 00:15:24.000000', 'temperatura', 16.0000, 'ºC'),
	(36583, 109, '2015-02-01 00:15:25.000000', 'temperatura', 709.0000, 'ºC'),
	(36584, 109, '2015-02-01 00:15:26.000000', 'temperatura', 1099.0000, 'ºC'),
	(36585, 109, '2015-02-01 00:15:27.000000', 'temperatura', 967.0000, 'ºC'),
	(36586, 109, '2015-02-01 00:15:28.000000', 'temperatura', 338.0000, 'ºC'),
	(36587, 109, '2015-02-01 00:15:29.000000', 'temperatura', 1191.0000, 'ºC'),
	(36588, 109, '2015-02-01 00:15:30.000000', 'temperatura', 141.0000, 'ºC'),
	(36589, 109, '2015-02-01 00:15:31.000000', 'temperatura', 731.0000, 'ºC'),
	(36590, 109, '2015-02-01 00:15:32.000000', 'temperatura', 834.0000, 'ºC'),
	(36591, 109, '2015-02-01 00:15:33.000000', 'temperatura', 776.0000, 'ºC'),
	(36592, 109, '2015-02-01 00:15:34.000000', 'temperatura', 181.0000, 'ºC'),
	(36593, 109, '2015-02-01 00:15:35.000000', 'temperatura', 976.0000, 'ºC'),
	(36594, 109, '2015-02-01 00:15:36.000000', 'temperatura', 737.0000, 'ºC'),
	(36595, 109, '2015-02-01 00:15:37.000000', 'temperatura', 758.0000, 'ºC'),
	(36596, 109, '2015-02-01 00:15:38.000000', 'temperatura', 379.0000, 'ºC'),
	(36597, 109, '2015-02-01 00:15:39.000000', 'temperatura', 822.0000, 'ºC'),
	(36598, 109, '2015-02-01 00:15:40.000000', 'temperatura', 573.0000, 'ºC'),
	(36599, 109, '2015-02-01 00:15:41.000000', 'temperatura', 400.0000, 'ºC'),
	(36600, 109, '2015-02-01 00:15:42.000000', 'temperatura', 283.0000, 'ºC'),
	(36601, 109, '2015-02-01 00:15:43.000000', 'temperatura', 213.0000, 'ºC'),
	(36602, 109, '2015-02-01 00:15:44.000000', 'temperatura', 216.0000, 'ºC'),
	(36603, 109, '2015-02-01 00:15:45.000000', 'temperatura', 442.0000, 'ºC'),
	(36604, 109, '2015-02-01 00:15:46.000000', 'temperatura', 363.0000, 'ºC'),
	(36605, 109, '2015-02-01 00:15:47.000000', 'temperatura', 491.0000, 'ºC'),
	(36606, 109, '2015-02-01 00:15:48.000000', 'temperatura', 165.0000, 'ºC'),
	(36607, 109, '2015-02-01 00:15:49.000000', 'temperatura', 552.0000, 'ºC'),
	(36608, 109, '2015-02-01 00:15:50.000000', 'temperatura', 1065.0000, 'ºC'),
	(36609, 109, '2015-02-01 00:15:51.000000', 'temperatura', 70.0000, 'ºC'),
	(36610, 109, '2015-02-01 00:15:52.000000', 'temperatura', 755.0000, 'ºC'),
	(36611, 109, '2015-02-01 00:15:53.000000', 'temperatura', 1167.0000, 'ºC'),
	(36612, 109, '2015-02-01 00:15:54.000000', 'temperatura', 1170.0000, 'ºC'),
	(36613, 109, '2015-02-01 00:15:55.000000', 'temperatura', 1151.0000, 'ºC'),
	(36614, 109, '2015-02-01 00:15:56.000000', 'temperatura', 1045.0000, 'ºC'),
	(36615, 109, '2015-02-01 00:15:57.000000', 'temperatura', 571.0000, 'ºC'),
	(36616, 109, '2015-02-01 00:15:58.000000', 'temperatura', 920.0000, 'ºC'),
	(36617, 109, '2015-02-01 00:15:59.000000', 'temperatura', 488.0000, 'ºC'),
	(36618, 109, '2015-02-01 00:16:00.000000', 'temperatura', 880.0000, 'ºC'),
	(36619, 109, '2015-02-01 00:16:01.000000', 'temperatura', 537.0000, 'ºC'),
	(36620, 109, '2015-02-01 00:16:02.000000', 'temperatura', 47.0000, 'ºC'),
	(36621, 109, '2015-02-01 00:16:03.000000', 'temperatura', 1021.0000, 'ºC'),
	(36622, 109, '2015-02-01 00:16:04.000000', 'temperatura', 168.0000, 'ºC'),
	(36623, 109, '2015-02-01 00:16:05.000000', 'temperatura', 175.0000, 'ºC'),
	(36624, 109, '2015-02-01 00:16:06.000000', 'temperatura', 373.0000, 'ºC'),
	(36625, 109, '2015-02-01 00:16:07.000000', 'temperatura', 139.0000, 'ºC'),
	(36626, 109, '2015-02-01 00:16:08.000000', 'temperatura', 777.0000, 'ºC'),
	(36627, 109, '2015-02-01 00:16:09.000000', 'temperatura', 1069.0000, 'ºC'),
	(36628, 109, '2015-02-01 00:16:10.000000', 'temperatura', 612.0000, 'ºC'),
	(36629, 109, '2015-02-01 00:16:11.000000', 'temperatura', 1056.0000, 'ºC'),
	(36630, 109, '2015-02-01 00:16:12.000000', 'temperatura', 1046.0000, 'ºC'),
	(36631, 109, '2015-02-01 00:16:13.000000', 'temperatura', 860.0000, 'ºC'),
	(36632, 109, '2015-02-01 00:16:14.000000', 'temperatura', 1162.0000, 'ºC'),
	(36633, 109, '2015-02-01 00:16:15.000000', 'temperatura', 830.0000, 'ºC'),
	(36634, 109, '2015-02-01 00:16:16.000000', 'temperatura', 665.0000, 'ºC'),
	(36635, 109, '2015-02-01 00:16:17.000000', 'temperatura', 835.0000, 'ºC'),
	(36636, 109, '2015-02-01 00:16:18.000000', 'temperatura', 982.0000, 'ºC'),
	(36637, 109, '2015-02-01 00:16:19.000000', 'temperatura', 6.0000, 'ºC'),
	(36638, 109, '2015-02-01 00:16:20.000000', 'temperatura', 685.0000, 'ºC'),
	(36639, 109, '2015-02-01 00:16:21.000000', 'temperatura', 1006.0000, 'ºC'),
	(36640, 109, '2015-02-01 00:16:22.000000', 'temperatura', 576.0000, 'ºC'),
	(36641, 109, '2015-02-01 00:16:23.000000', 'temperatura', 1063.0000, 'ºC'),
	(36642, 109, '2015-02-01 00:16:24.000000', 'temperatura', 1187.0000, 'ºC'),
	(36643, 109, '2015-02-01 00:16:25.000000', 'temperatura', 349.0000, 'ºC'),
	(36644, 109, '2015-02-01 00:16:26.000000', 'temperatura', 581.0000, 'ºC'),
	(36645, 109, '2015-02-01 00:16:27.000000', 'temperatura', 660.0000, 'ºC'),
	(36646, 109, '2015-02-01 00:16:28.000000', 'temperatura', 358.0000, 'ºC'),
	(36647, 109, '2015-02-01 00:16:29.000000', 'temperatura', 1011.0000, 'ºC'),
	(36648, 109, '2015-02-01 00:16:30.000000', 'temperatura', 379.0000, 'ºC'),
	(36649, 109, '2015-02-01 00:16:31.000000', 'temperatura', 63.0000, 'ºC'),
	(36650, 109, '2015-02-01 00:16:32.000000', 'temperatura', 381.0000, 'ºC'),
	(36651, 109, '2015-02-01 00:16:33.000000', 'temperatura', 516.0000, 'ºC'),
	(36652, 109, '2015-02-01 00:16:34.000000', 'temperatura', 235.0000, 'ºC'),
	(36653, 109, '2015-02-01 00:16:35.000000', 'temperatura', 829.0000, 'ºC'),
	(36654, 109, '2015-02-01 00:16:36.000000', 'temperatura', 1040.0000, 'ºC'),
	(36655, 109, '2015-02-01 00:16:37.000000', 'temperatura', 315.0000, 'ºC'),
	(36656, 109, '2015-02-01 00:16:38.000000', 'temperatura', 856.0000, 'ºC'),
	(36657, 109, '2015-02-01 00:16:39.000000', 'temperatura', 934.0000, 'ºC'),
	(36658, 109, '2015-02-01 00:16:40.000000', 'temperatura', 901.0000, 'ºC'),
	(36659, 109, '2015-02-01 00:16:41.000000', 'temperatura', 505.0000, 'ºC'),
	(36660, 109, '2015-02-01 00:16:42.000000', 'temperatura', 1024.0000, 'ºC'),
	(36661, 109, '2015-02-01 00:16:43.000000', 'temperatura', 6.0000, 'ºC'),
	(36662, 109, '2015-02-01 00:16:44.000000', 'temperatura', 556.0000, 'ºC'),
	(36663, 109, '2015-02-01 00:16:45.000000', 'temperatura', 363.0000, 'ºC'),
	(36664, 109, '2015-02-01 00:16:46.000000', 'temperatura', 147.0000, 'ºC'),
	(36665, 109, '2015-02-01 00:16:47.000000', 'temperatura', 849.0000, 'ºC'),
	(36666, 109, '2015-02-01 00:16:48.000000', 'temperatura', 204.0000, 'ºC'),
	(36667, 109, '2015-02-01 00:16:49.000000', 'temperatura', 871.0000, 'ºC'),
	(36668, 109, '2015-02-01 00:16:50.000000', 'temperatura', 144.0000, 'ºC'),
	(36669, 109, '2015-02-01 00:16:51.000000', 'temperatura', 509.0000, 'ºC'),
	(36670, 109, '2015-02-01 00:16:52.000000', 'temperatura', 912.0000, 'ºC'),
	(36671, 109, '2015-02-01 00:16:53.000000', 'temperatura', 633.0000, 'ºC'),
	(36672, 109, '2015-02-01 00:16:54.000000', 'temperatura', 432.0000, 'ºC'),
	(36673, 109, '2015-02-01 00:16:55.000000', 'temperatura', 262.0000, 'ºC'),
	(36674, 109, '2015-02-01 00:16:56.000000', 'temperatura', 11.0000, 'ºC'),
	(36675, 109, '2015-02-01 00:16:57.000000', 'temperatura', 473.0000, 'ºC'),
	(36676, 109, '2015-02-01 00:16:58.000000', 'temperatura', 1132.0000, 'ºC'),
	(36677, 109, '2015-02-01 00:16:59.000000', 'temperatura', 640.0000, 'ºC'),
	(36678, 109, '2015-02-01 00:17:00.000000', 'temperatura', 1004.0000, 'ºC'),
	(36679, 109, '2015-02-01 00:17:01.000000', 'temperatura', 700.0000, 'ºC'),
	(36680, 109, '2015-02-01 00:17:02.000000', 'temperatura', 490.0000, 'ºC'),
	(36681, 109, '2015-02-01 00:17:03.000000', 'temperatura', 350.0000, 'ºC'),
	(36682, 109, '2015-02-01 00:17:04.000000', 'temperatura', 282.0000, 'ºC'),
	(36683, 109, '2015-02-01 00:17:05.000000', 'temperatura', 360.0000, 'ºC'),
	(36684, 109, '2015-02-01 00:17:06.000000', 'temperatura', 953.0000, 'ºC'),
	(36685, 109, '2015-02-01 00:17:07.000000', 'temperatura', 87.0000, 'ºC'),
	(36686, 109, '2015-02-01 00:17:08.000000', 'temperatura', 1177.0000, 'ºC'),
	(36687, 109, '2015-02-01 00:17:09.000000', 'temperatura', 825.0000, 'ºC'),
	(36688, 109, '2015-02-01 00:17:10.000000', 'temperatura', 594.0000, 'ºC'),
	(36689, 109, '2015-02-01 00:17:11.000000', 'temperatura', 495.0000, 'ºC'),
	(36690, 109, '2015-02-01 00:17:12.000000', 'temperatura', 696.0000, 'ºC'),
	(36691, 109, '2015-02-01 00:17:13.000000', 'temperatura', 792.0000, 'ºC'),
	(36692, 109, '2015-02-01 00:17:14.000000', 'temperatura', 674.0000, 'ºC'),
	(36693, 109, '2015-02-01 00:17:15.000000', 'temperatura', 993.0000, 'ºC'),
	(36694, 109, '2015-02-01 00:17:16.000000', 'temperatura', 545.0000, 'ºC'),
	(36695, 109, '2015-02-01 00:17:17.000000', 'temperatura', 946.0000, 'ºC'),
	(36696, 109, '2015-02-01 00:17:18.000000', 'temperatura', 697.0000, 'ºC'),
	(36697, 109, '2015-02-01 00:17:19.000000', 'temperatura', 648.0000, 'ºC'),
	(36698, 109, '2015-02-01 00:17:20.000000', 'temperatura', 1148.0000, 'ºC'),
	(36699, 109, '2015-02-01 00:17:21.000000', 'temperatura', 197.0000, 'ºC'),
	(36700, 109, '2015-02-01 00:17:22.000000', 'temperatura', 1141.0000, 'ºC'),
	(36701, 109, '2015-02-01 00:17:23.000000', 'temperatura', 315.0000, 'ºC'),
	(36702, 109, '2015-02-01 00:17:24.000000', 'temperatura', 551.0000, 'ºC'),
	(36703, 109, '2015-02-01 00:17:25.000000', 'temperatura', 611.0000, 'ºC'),
	(36704, 109, '2015-02-01 00:17:26.000000', 'temperatura', 204.0000, 'ºC'),
	(36705, 109, '2015-02-01 00:17:27.000000', 'temperatura', 387.0000, 'ºC'),
	(36706, 109, '2015-02-01 00:17:28.000000', 'temperatura', 121.0000, 'ºC'),
	(36707, 109, '2015-02-01 00:17:29.000000', 'temperatura', 648.0000, 'ºC'),
	(36708, 109, '2015-02-01 00:17:30.000000', 'temperatura', 474.0000, 'ºC'),
	(36709, 109, '2015-02-01 00:17:31.000000', 'temperatura', 430.0000, 'ºC'),
	(36710, 109, '2015-02-01 00:17:32.000000', 'temperatura', 725.0000, 'ºC'),
	(36711, 109, '2015-02-01 00:17:33.000000', 'temperatura', 1137.0000, 'ºC'),
	(36712, 109, '2015-02-01 00:17:34.000000', 'temperatura', 1112.0000, 'ºC'),
	(36713, 109, '2015-02-01 00:17:35.000000', 'temperatura', 948.0000, 'ºC'),
	(36714, 109, '2015-02-01 00:17:36.000000', 'temperatura', 204.0000, 'ºC'),
	(36715, 109, '2015-02-01 00:17:37.000000', 'temperatura', 579.0000, 'ºC'),
	(36716, 109, '2015-02-01 00:17:38.000000', 'temperatura', 1083.0000, 'ºC'),
	(36717, 109, '2015-02-01 00:17:39.000000', 'temperatura', 78.0000, 'ºC'),
	(36718, 109, '2015-02-01 00:17:40.000000', 'temperatura', 741.0000, 'ºC'),
	(36719, 109, '2015-02-01 00:17:41.000000', 'temperatura', 1070.0000, 'ºC'),
	(36720, 109, '2015-02-01 00:17:42.000000', 'temperatura', 731.0000, 'ºC'),
	(36721, 109, '2015-02-01 00:17:43.000000', 'temperatura', 443.0000, 'ºC'),
	(36722, 109, '2015-02-01 00:17:44.000000', 'temperatura', 24.0000, 'ºC'),
	(36723, 109, '2015-02-01 00:17:45.000000', 'temperatura', 1190.0000, 'ºC'),
	(36724, 109, '2015-02-01 00:17:46.000000', 'temperatura', 1078.0000, 'ºC'),
	(36725, 109, '2015-02-01 00:17:47.000000', 'temperatura', 623.0000, 'ºC'),
	(36726, 109, '2015-02-01 00:17:48.000000', 'temperatura', 1080.0000, 'ºC'),
	(36727, 109, '2015-02-01 00:17:49.000000', 'temperatura', 1131.0000, 'ºC'),
	(36728, 109, '2015-02-01 00:17:50.000000', 'temperatura', 17.0000, 'ºC'),
	(36729, 109, '2015-02-01 00:17:51.000000', 'temperatura', 294.0000, 'ºC'),
	(36730, 109, '2015-02-01 00:17:52.000000', 'temperatura', 217.0000, 'ºC'),
	(36731, 109, '2015-02-01 00:17:53.000000', 'temperatura', 204.0000, 'ºC'),
	(36732, 109, '2015-02-01 00:17:54.000000', 'temperatura', 368.0000, 'ºC'),
	(36733, 109, '2015-02-01 00:17:55.000000', 'temperatura', 28.0000, 'ºC'),
	(36734, 109, '2015-02-01 00:17:56.000000', 'temperatura', 239.0000, 'ºC'),
	(36735, 109, '2015-02-01 00:17:57.000000', 'temperatura', 1110.0000, 'ºC'),
	(36736, 109, '2015-02-01 00:17:58.000000', 'temperatura', 35.0000, 'ºC'),
	(36737, 109, '2015-02-01 00:17:59.000000', 'temperatura', 443.0000, 'ºC'),
	(36738, 109, '2015-02-01 00:18:00.000000', 'temperatura', 913.0000, 'ºC'),
	(36739, 109, '2015-02-01 00:18:01.000000', 'temperatura', 835.0000, 'ºC'),
	(36740, 109, '2015-02-01 00:18:02.000000', 'temperatura', 239.0000, 'ºC'),
	(36741, 109, '2015-02-01 00:18:03.000000', 'temperatura', 1087.0000, 'ºC'),
	(36742, 109, '2015-02-01 00:18:04.000000', 'temperatura', 1120.0000, 'ºC'),
	(36743, 109, '2015-02-01 00:18:05.000000', 'temperatura', 1139.0000, 'ºC'),
	(36744, 109, '2015-02-01 00:18:06.000000', 'temperatura', 1136.0000, 'ºC'),
	(36745, 109, '2015-02-01 00:18:07.000000', 'temperatura', 1064.0000, 'ºC'),
	(36746, 109, '2015-02-01 00:18:08.000000', 'temperatura', 712.0000, 'ºC'),
	(36747, 109, '2015-02-01 00:18:09.000000', 'temperatura', 370.0000, 'ºC'),
	(36748, 109, '2015-02-01 00:18:10.000000', 'temperatura', 912.0000, 'ºC'),
	(36749, 109, '2015-02-01 00:18:11.000000', 'temperatura', 1053.0000, 'ºC'),
	(36750, 109, '2015-02-01 00:18:12.000000', 'temperatura', 127.0000, 'ºC'),
	(36751, 109, '2015-02-01 00:18:13.000000', 'temperatura', 1076.0000, 'ºC'),
	(36752, 109, '2015-02-01 00:18:14.000000', 'temperatura', 202.0000, 'ºC'),
	(36753, 109, '2015-02-01 00:18:15.000000', 'temperatura', 180.0000, 'ºC'),
	(36754, 109, '2015-02-01 00:18:16.000000', 'temperatura', 295.0000, 'ºC'),
	(36755, 109, '2015-02-01 00:18:17.000000', 'temperatura', 938.0000, 'ºC'),
	(36756, 109, '2015-02-01 00:18:18.000000', 'temperatura', 203.0000, 'ºC'),
	(36757, 109, '2015-02-01 00:18:19.000000', 'temperatura', 601.0000, 'ºC'),
	(36758, 109, '2015-02-01 00:18:20.000000', 'temperatura', 1199.0000, 'ºC'),
	(36759, 109, '2015-02-01 00:18:21.000000', 'temperatura', 591.0000, 'ºC'),
	(36760, 109, '2015-02-01 00:18:22.000000', 'temperatura', 560.0000, 'ºC'),
	(36761, 109, '2015-02-01 00:18:23.000000', 'temperatura', 1028.0000, 'ºC'),
	(36762, 109, '2015-02-01 00:18:24.000000', 'temperatura', 1062.0000, 'ºC'),
	(36763, 109, '2015-02-01 00:18:25.000000', 'temperatura', 1023.0000, 'ºC'),
	(36764, 109, '2015-02-01 00:18:26.000000', 'temperatura', 730.0000, 'ºC'),
	(36765, 109, '2015-02-01 00:18:27.000000', 'temperatura', 584.0000, 'ºC'),
	(36766, 109, '2015-02-01 00:18:28.000000', 'temperatura', 727.0000, 'ºC'),
	(36767, 109, '2015-02-01 00:18:29.000000', 'temperatura', 686.0000, 'ºC'),
	(36768, 109, '2015-02-01 00:18:30.000000', 'temperatura', 47.0000, 'ºC'),
	(36769, 109, '2015-02-01 00:18:31.000000', 'temperatura', 578.0000, 'ºC'),
	(36770, 109, '2015-02-01 00:18:32.000000', 'temperatura', 350.0000, 'ºC'),
	(36771, 109, '2015-02-01 00:18:33.000000', 'temperatura', 15.0000, 'ºC'),
	(36772, 109, '2015-02-01 00:18:34.000000', 'temperatura', 228.0000, 'ºC'),
	(36773, 109, '2015-02-01 00:18:35.000000', 'temperatura', 1096.0000, 'ºC'),
	(36774, 109, '2015-02-01 00:18:36.000000', 'temperatura', 1195.0000, 'ºC'),
	(36775, 109, '2015-02-01 00:18:37.000000', 'temperatura', 289.0000, 'ºC'),
	(36776, 109, '2015-02-01 00:18:38.000000', 'temperatura', 259.0000, 'ºC'),
	(36777, 109, '2015-02-01 00:18:39.000000', 'temperatura', 430.0000, 'ºC'),
	(36778, 109, '2015-02-01 00:18:40.000000', 'temperatura', 173.0000, 'ºC'),
	(36779, 109, '2015-02-01 00:18:41.000000', 'temperatura', 776.0000, 'ºC'),
	(36780, 109, '2015-02-01 00:18:42.000000', 'temperatura', 962.0000, 'ºC'),
	(36781, 109, '2015-02-01 00:18:43.000000', 'temperatura', 80.0000, 'ºC'),
	(36782, 109, '2015-02-01 00:18:44.000000', 'temperatura', 1117.0000, 'ºC'),
	(36783, 109, '2015-02-01 00:18:45.000000', 'temperatura', 544.0000, 'ºC'),
	(36784, 109, '2015-02-01 00:18:46.000000', 'temperatura', 570.0000, 'ºC'),
	(36785, 109, '2015-02-01 00:18:47.000000', 'temperatura', 19.0000, 'ºC'),
	(36786, 109, '2015-02-01 00:18:48.000000', 'temperatura', 785.0000, 'ºC'),
	(36787, 109, '2015-02-01 00:18:49.000000', 'temperatura', 269.0000, 'ºC'),
	(36788, 109, '2015-02-01 00:18:50.000000', 'temperatura', 189.0000, 'ºC'),
	(36789, 109, '2015-02-01 00:18:51.000000', 'temperatura', 138.0000, 'ºC'),
	(36790, 109, '2015-02-01 00:18:52.000000', 'temperatura', 124.0000, 'ºC'),
	(36791, 109, '2015-02-01 00:18:53.000000', 'temperatura', 207.0000, 'ºC'),
	(36792, 109, '2015-02-01 00:18:54.000000', 'temperatura', 664.0000, 'ºC'),
	(36793, 109, '2015-02-01 00:18:55.000000', 'temperatura', 298.0000, 'ºC'),
	(36794, 109, '2015-02-01 00:18:56.000000', 'temperatura', 698.0000, 'ºC'),
	(36795, 109, '2015-02-01 00:18:57.000000', 'temperatura', 199.0000, 'ºC'),
	(36796, 109, '2015-02-01 00:18:58.000000', 'temperatura', 99.0000, 'ºC'),
	(36797, 109, '2015-02-01 00:18:59.000000', 'temperatura', 1098.0000, 'ºC'),
	(36798, 109, '2015-02-01 00:19:00.000000', 'temperatura', 394.0000, 'ºC'),
	(36799, 109, '2015-02-01 00:19:01.000000', 'temperatura', 1077.0000, 'ºC'),
	(36800, 109, '2015-02-01 00:19:02.000000', 'temperatura', 602.0000, 'ºC'),
	(36801, 109, '2015-02-01 00:19:03.000000', 'temperatura', 982.0000, 'ºC'),
	(36802, 109, '2015-02-01 00:19:04.000000', 'temperatura', 701.0000, 'ºC'),
	(36803, 109, '2015-02-01 00:19:05.000000', 'temperatura', 563.0000, 'ºC'),
	(36804, 109, '2015-02-01 00:19:06.000000', 'temperatura', 711.0000, 'ºC'),
	(36805, 109, '2015-02-01 00:19:07.000000', 'temperatura', 667.0000, 'ºC'),
	(36806, 109, '2015-02-01 00:19:08.000000', 'temperatura', 2.0000, 'ºC'),
	(36807, 109, '2015-02-01 00:19:09.000000', 'temperatura', 410.0000, 'ºC'),
	(36808, 109, '2015-02-01 00:19:10.000000', 'temperatura', 842.0000, 'ºC'),
	(36809, 109, '2015-02-01 00:19:11.000000', 'temperatura', 583.0000, 'ºC'),
	(36810, 109, '2015-02-01 00:19:12.000000', 'temperatura', 391.0000, 'ºC'),
	(36811, 109, '2015-02-01 00:19:13.000000', 'temperatura', 204.0000, 'ºC'),
	(36812, 109, '2015-02-01 00:19:14.000000', 'temperatura', 1048.0000, 'ºC'),
	(36813, 109, '2015-02-01 00:19:15.000000', 'temperatura', 1027.0000, 'ºC'),
	(36814, 109, '2015-02-01 00:19:16.000000', 'temperatura', 794.0000, 'ºC'),
	(36815, 109, '2015-02-01 00:19:17.000000', 'temperatura', 888.0000, 'ºC'),
	(36816, 109, '2015-02-01 00:19:18.000000', 'temperatura', 859.0000, 'ºC'),
	(36817, 109, '2015-02-01 00:19:19.000000', 'temperatura', 430.0000, 'ºC'),
	(36818, 109, '2015-02-01 00:19:20.000000', 'temperatura', 775.0000, 'ºC'),
	(36819, 109, '2015-02-01 00:19:21.000000', 'temperatura', 185.0000, 'ºC'),
	(36820, 109, '2015-02-01 00:19:22.000000', 'temperatura', 1001.0000, 'ºC'),
	(36821, 109, '2015-02-01 00:19:23.000000', 'temperatura', 850.0000, 'ºC'),
	(36822, 109, '2015-02-01 00:19:24.000000', 'temperatura', 48.0000, 'ºC'),
	(36823, 109, '2015-02-01 00:19:25.000000', 'temperatura', 90.0000, 'ºC'),
	(36824, 109, '2015-02-01 00:19:26.000000', 'temperatura', 309.0000, 'ºC'),
	(36825, 109, '2015-02-01 00:19:27.000000', 'temperatura', 73.0000, 'ºC'),
	(36826, 109, '2015-02-01 00:19:28.000000', 'temperatura', 638.0000, 'ºC'),
	(36827, 109, '2015-02-01 00:19:29.000000', 'temperatura', 572.0000, 'ºC'),
	(36828, 109, '2015-02-01 00:19:30.000000', 'temperatura', 945.0000, 'ºC'),
	(36829, 109, '2015-02-01 00:19:31.000000', 'temperatura', 610.0000, 'ºC'),
	(36830, 109, '2015-02-01 00:19:32.000000', 'temperatura', 214.0000, 'ºC'),
	(36831, 109, '2015-02-01 00:19:33.000000', 'temperatura', 441.0000, 'ºC'),
	(36832, 109, '2015-02-01 00:19:34.000000', 'temperatura', 365.0000, 'ºC'),
	(36833, 109, '2015-02-01 00:19:35.000000', 'temperatura', 501.0000, 'ºC'),
	(36834, 109, '2015-02-01 00:19:36.000000', 'temperatura', 210.0000, 'ºC'),
	(36835, 109, '2015-02-01 00:19:37.000000', 'temperatura', 748.0000, 'ºC'),
	(36836, 109, '2015-02-01 00:19:38.000000', 'temperatura', 709.0000, 'ºC'),
	(36837, 109, '2015-02-01 00:19:39.000000', 'temperatura', 104.0000, 'ºC'),
	(36838, 109, '2015-02-01 00:19:40.000000', 'temperatura', 794.0000, 'ºC'),
	(36839, 109, '2015-02-01 00:19:41.000000', 'temperatura', 59.0000, 'ºC'),
	(36840, 109, '2015-02-01 00:19:42.000000', 'temperatura', 314.0000, 'ºC'),
	(36841, 109, '2015-02-01 00:19:43.000000', 'temperatura', 194.0000, 'ºC'),
	(36842, 109, '2015-02-01 00:19:44.000000', 'temperatura', 27.0000, 'ºC'),
	(36843, 109, '2015-02-01 00:19:45.000000', 'temperatura', 755.0000, 'ºC'),
	(36844, 109, '2015-02-01 00:19:46.000000', 'temperatura', 92.0000, 'ºC'),
	(36845, 109, '2015-02-01 00:19:47.000000', 'temperatura', 596.0000, 'ºC'),
	(36846, 109, '2015-02-01 00:19:48.000000', 'temperatura', 304.0000, 'ºC'),
	(36847, 109, '2015-02-01 00:19:49.000000', 'temperatura', 933.0000, 'ºC'),
	(36848, 109, '2015-02-01 00:19:50.000000', 'temperatura', 155.0000, 'ºC'),
	(36849, 109, '2015-02-01 00:19:51.000000', 'temperatura', 377.0000, 'ºC'),
	(36850, 109, '2015-02-01 00:19:52.000000', 'temperatura', 219.0000, 'ºC'),
	(36851, 109, '2015-02-01 00:19:53.000000', 'temperatura', 1164.0000, 'ºC'),
	(36852, 109, '2015-02-01 00:19:54.000000', 'temperatura', 366.0000, 'ºC'),
	(36853, 109, '2015-02-01 00:19:55.000000', 'temperatura', 735.0000, 'ºC'),
	(36854, 109, '2015-02-01 00:19:56.000000', 'temperatura', 180.0000, 'ºC'),
	(36855, 109, '2015-02-01 00:19:57.000000', 'temperatura', 1093.0000, 'ºC'),
	(36856, 109, '2015-02-01 00:19:58.000000', 'temperatura', 125.0000, 'ºC'),
	(36857, 109, '2015-02-01 00:19:59.000000', 'temperatura', 949.0000, 'ºC'),
	(36858, 109, '2015-02-01 00:20:00.000000', 'temperatura', 771.0000, 'ºC'),
	(36859, 109, '2015-02-01 00:20:01.000000', 'temperatura', 1010.0000, 'ºC'),
	(36860, 109, '2015-02-01 00:20:02.000000', 'temperatura', 334.0000, 'ºC'),
	(36861, 109, '2015-02-01 00:20:03.000000', 'temperatura', 1044.0000, 'ºC'),
	(36862, 109, '2015-02-01 00:20:04.000000', 'temperatura', 615.0000, 'ºC'),
	(36863, 109, '2015-02-01 00:20:05.000000', 'temperatura', 1144.0000, 'ºC'),
	(36864, 109, '2015-02-01 00:20:06.000000', 'temperatura', 277.0000, 'ºC'),
	(36865, 109, '2015-02-01 00:20:07.000000', 'temperatura', 354.0000, 'ºC'),
	(36866, 109, '2015-02-01 00:20:08.000000', 'temperatura', 938.0000, 'ºC'),
	(36867, 109, '2015-02-01 00:20:09.000000', 'temperatura', 27.0000, 'ºC'),
	(36868, 109, '2015-02-01 00:20:10.000000', 'temperatura', 924.0000, 'ºC'),
	(36869, 109, '2015-02-01 00:20:11.000000', 'temperatura', 937.0000, 'ºC'),
	(36870, 109, '2015-02-01 00:20:12.000000', 'temperatura', 715.0000, 'ºC'),
	(36871, 109, '2015-02-01 00:20:13.000000', 'temperatura', 765.0000, 'ºC'),
	(36872, 109, '2015-02-01 00:20:14.000000', 'temperatura', 482.0000, 'ºC'),
	(36873, 109, '2015-02-01 00:20:15.000000', 'temperatura', 113.0000, 'ºC'),
	(36874, 109, '2015-02-01 00:20:16.000000', 'temperatura', 319.0000, 'ºC'),
	(36875, 109, '2015-02-01 00:20:17.000000', 'temperatura', 59.0000, 'ºC'),
	(36876, 109, '2015-02-01 00:20:18.000000', 'temperatura', 539.0000, 'ºC'),
	(36877, 109, '2015-02-01 00:20:19.000000', 'temperatura', 118.0000, 'ºC'),
	(36878, 109, '2015-02-01 00:20:20.000000', 'temperatura', 172.0000, 'ºC'),
	(36879, 109, '2015-02-01 00:20:21.000000', 'temperatura', 507.0000, 'ºC'),
	(36880, 109, '2015-02-01 00:20:22.000000', 'temperatura', 820.0000, 'ºC'),
	(36881, 109, '2015-02-01 00:20:23.000000', 'temperatura', 179.0000, 'ºC'),
	(36882, 109, '2015-02-01 00:20:24.000000', 'temperatura', 837.0000, 'ºC'),
	(36883, 109, '2015-02-01 00:20:25.000000', 'temperatura', 47.0000, 'ºC'),
	(36884, 109, '2015-02-01 00:20:26.000000', 'temperatura', 126.0000, 'ºC'),
	(36885, 109, '2015-02-01 00:20:27.000000', 'temperatura', 489.0000, 'ºC'),
	(36886, 109, '2015-02-01 00:20:28.000000', 'temperatura', 866.0000, 'ºC'),
	(36887, 109, '2015-02-01 00:20:29.000000', 'temperatura', 466.0000, 'ºC'),
	(36888, 109, '2015-02-01 00:20:30.000000', 'temperatura', 932.0000, 'ºC'),
	(36889, 109, '2015-02-01 00:20:31.000000', 'temperatura', 863.0000, 'ºC'),
	(36890, 109, '2015-02-01 00:20:32.000000', 'temperatura', 319.0000, 'ºC'),
	(36891, 109, '2015-02-01 00:20:33.000000', 'temperatura', 207.0000, 'ºC'),
	(36892, 109, '2015-02-01 00:20:34.000000', 'temperatura', 80.0000, 'ºC'),
	(36893, 109, '2015-02-01 00:20:35.000000', 'temperatura', 976.0000, 'ºC'),
	(36894, 109, '2015-02-01 00:20:36.000000', 'temperatura', 1043.0000, 'ºC'),
	(36895, 109, '2015-02-01 00:20:37.000000', 'temperatura', 1086.0000, 'ºC'),
	(36896, 109, '2015-02-01 00:20:38.000000', 'temperatura', 1103.0000, 'ºC'),
	(36897, 109, '2015-02-01 00:20:39.000000', 'temperatura', 1057.0000, 'ºC'),
	(36898, 109, '2015-02-01 00:20:40.000000', 'temperatura', 778.0000, 'ºC'),
	(36899, 109, '2015-02-01 00:20:41.000000', 'temperatura', 718.0000, 'ºC'),
	(36900, 109, '2015-02-01 00:20:42.000000', 'temperatura', 55.0000, 'ºC'),
	(36901, 109, '2015-02-01 00:20:43.000000', 'temperatura', 524.0000, 'ºC'),
	(36902, 109, '2015-02-01 00:20:44.000000', 'temperatura', 57.0000, 'ºC'),
	(36903, 109, '2015-02-01 00:20:45.000000', 'temperatura', 1111.0000, 'ºC'),
	(36904, 109, '2015-02-01 00:20:46.000000', 'temperatura', 583.0000, 'ºC'),
	(36905, 109, '2015-02-01 00:20:47.000000', 'temperatura', 786.0000, 'ºC'),
	(36906, 109, '2015-02-01 00:20:48.000000', 'temperatura', 978.0000, 'ºC'),
	(36907, 109, '2015-02-01 00:20:49.000000', 'temperatura', 134.0000, 'ºC'),
	(36908, 109, '2015-02-01 00:20:50.000000', 'temperatura', 135.0000, 'ºC'),
	(36909, 109, '2015-02-01 00:20:51.000000', 'temperatura', 274.0000, 'ºC'),
	(36910, 109, '2015-02-01 00:20:52.000000', 'temperatura', 964.0000, 'ºC'),
	(36911, 109, '2015-02-01 00:20:53.000000', 'temperatura', 400.0000, 'ºC'),
	(36912, 109, '2015-02-01 00:20:54.000000', 'temperatura', 309.0000, 'ºC'),
	(36913, 109, '2015-02-01 00:20:55.000000', 'temperatura', 345.0000, 'ºC'),
	(36914, 109, '2015-02-01 00:20:56.000000', 'temperatura', 798.0000, 'ºC'),
	(36915, 109, '2015-02-01 00:20:57.000000', 'temperatura', 557.0000, 'ºC'),
	(36916, 109, '2015-02-01 00:20:58.000000', 'temperatura', 389.0000, 'ºC'),
	(36917, 109, '2015-02-01 00:20:59.000000', 'temperatura', 277.0000, 'ºC'),
	(36918, 109, '2015-02-01 00:21:00.000000', 'temperatura', 216.0000, 'ºC'),
	(36919, 109, '2015-02-01 00:21:01.000000', 'temperatura', 251.0000, 'ºC'),
	(36920, 109, '2015-02-01 00:21:02.000000', 'temperatura', 607.0000, 'ºC'),
	(36921, 109, '2015-02-01 00:21:03.000000', 'temperatura', 1084.0000, 'ºC'),
	(36922, 109, '2015-02-01 00:21:04.000000', 'temperatura', 1199.0000, 'ºC'),
	(36923, 109, '2015-02-01 00:21:05.000000', 'temperatura', 341.0000, 'ºC'),
	(36924, 109, '2015-02-01 00:21:06.000000', 'temperatura', 510.0000, 'ºC'),
	(36925, 109, '2015-02-01 00:21:07.000000', 'temperatura', 329.0000, 'ºC'),
	(36926, 109, '2015-02-01 00:21:08.000000', 'temperatura', 115.0000, 'ºC'),
	(36927, 109, '2015-02-01 00:21:09.000000', 'temperatura', 790.0000, 'ºC'),
	(36928, 109, '2015-02-01 00:21:10.000000', 'temperatura', 3.0000, 'ºC'),
	(36929, 109, '2015-02-01 00:21:11.000000', 'temperatura', 46.0000, 'ºC'),
	(36930, 109, '2015-02-01 00:21:12.000000', 'temperatura', 222.0000, 'ºC'),
	(36931, 109, '2015-02-01 00:21:13.000000', 'temperatura', 974.0000, 'ºC'),
	(36932, 109, '2015-02-01 00:21:14.000000', 'temperatura', 604.0000, 'ºC'),
	(36933, 109, '2015-02-01 00:21:15.000000', 'temperatura', 99.0000, 'ºC'),
	(36934, 109, '2015-02-01 00:21:16.000000', 'temperatura', 1081.0000, 'ºC'),
	(36935, 109, '2015-02-01 00:21:17.000000', 'temperatura', 311.0000, 'ºC'),
	(36936, 109, '2015-02-01 00:21:18.000000', 'temperatura', 713.0000, 'ºC'),
	(36937, 109, '2015-02-01 00:21:19.000000', 'temperatura', 233.0000, 'ºC'),
	(36938, 109, '2015-02-01 00:21:20.000000', 'temperatura', 228.0000, 'ºC'),
	(36939, 109, '2015-02-01 00:21:21.000000', 'temperatura', 438.0000, 'ºC'),
	(36940, 109, '2015-02-01 00:21:22.000000', 'temperatura', 306.0000, 'ºC'),
	(36941, 109, '2015-02-01 00:21:23.000000', 'temperatura', 219.0000, 'ºC'),
	(36942, 109, '2015-02-01 00:21:24.000000', 'temperatura', 178.0000, 'ºC'),
	(36943, 109, '2015-02-01 00:21:25.000000', 'temperatura', 233.0000, 'ºC'),
	(36944, 109, '2015-02-01 00:21:26.000000', 'temperatura', 631.0000, 'ºC'),
	(36945, 109, '2015-02-01 00:21:27.000000', 'temperatura', 58.0000, 'ºC'),
	(36946, 109, '2015-02-01 00:21:28.000000', 'temperatura', 796.0000, 'ºC'),
	(36947, 109, '2015-02-01 00:21:29.000000', 'temperatura', 206.0000, 'ºC'),
	(36948, 109, '2015-02-01 00:21:30.000000', 'temperatura', 1043.0000, 'ºC'),
	(36949, 109, '2015-02-01 00:21:31.000000', 'temperatura', 997.0000, 'ºC'),
	(36950, 109, '2015-02-01 00:21:32.000000', 'temperatura', 657.0000, 'ºC'),
	(36951, 109, '2015-02-01 00:21:33.000000', 'temperatura', 293.0000, 'ºC'),
	(36952, 109, '2015-02-01 00:21:34.000000', 'temperatura', 696.0000, 'ºC'),
	(36953, 109, '2015-02-01 00:21:35.000000', 'temperatura', 203.0000, 'ºC'),
	(36954, 109, '2015-02-01 00:21:36.000000', 'temperatura', 127.0000, 'ºC'),
	(36955, 109, '2015-02-01 00:21:37.000000', 'temperatura', 27.0000, 'ºC'),
	(36956, 109, '2015-02-01 00:21:38.000000', 'temperatura', 953.0000, 'ºC'),
	(36957, 109, '2015-02-01 00:21:39.000000', 'temperatura', 1085.0000, 'ºC'),
	(36958, 109, '2015-02-01 00:21:40.000000', 'temperatura', 166.0000, 'ºC'),
	(36959, 109, '2015-02-01 00:21:41.000000', 'temperatura', 1177.0000, 'ºC'),
	(36960, 109, '2015-02-01 00:21:42.000000', 'temperatura', 585.0000, 'ºC'),
	(36961, 109, '2015-02-01 00:21:43.000000', 'temperatura', 597.0000, 'ºC'),
	(36962, 109, '2015-02-01 00:21:44.000000', 'temperatura', 30.0000, 'ºC'),
	(36963, 109, '2015-02-01 00:21:45.000000', 'temperatura', 757.0000, 'ºC'),
	(36964, 109, '2015-02-01 00:21:46.000000', 'temperatura', 99.0000, 'ºC'),
	(36965, 109, '2015-02-01 00:21:47.000000', 'temperatura', 623.0000, 'ºC'),
	(36966, 109, '2015-02-01 00:21:48.000000', 'temperatura', 421.0000, 'ºC'),
	(36967, 109, '2015-02-01 00:21:49.000000', 'temperatura', 233.0000, 'ºC'),
	(36968, 109, '2015-02-01 00:21:50.000000', 'temperatura', 1106.0000, 'ºC'),
	(36969, 109, '2015-02-01 00:21:51.000000', 'temperatura', 28.0000, 'ºC'),
	(36970, 109, '2015-02-01 00:21:52.000000', 'temperatura', 425.0000, 'ºC'),
	(36971, 109, '2015-02-01 00:21:53.000000', 'temperatura', 839.0000, 'ºC'),
	(36972, 109, '2015-02-01 00:21:54.000000', 'temperatura', 521.0000, 'ºC'),
	(36973, 109, '2015-02-01 00:21:55.000000', 'temperatura', 89.0000, 'ºC'),
	(36974, 109, '2015-02-01 00:21:56.000000', 'temperatura', 82.0000, 'ºC'),
	(36975, 109, '2015-02-01 00:21:57.000000', 'temperatura', 145.0000, 'ºC'),
	(36976, 109, '2015-02-01 00:21:58.000000', 'temperatura', 478.0000, 'ºC'),
	(36977, 109, '2015-02-01 00:21:59.000000', 'temperatura', 754.0000, 'ºC'),
	(36978, 109, '2015-02-01 00:22:00.000000', 'temperatura', 1138.0000, 'ºC'),
	(36979, 109, '2015-02-01 00:22:01.000000', 'temperatura', 1028.0000, 'ºC'),
	(36980, 109, '2015-02-01 00:22:02.000000', 'temperatura', 527.0000, 'ºC'),
	(36981, 109, '2015-02-01 00:22:03.000000', 'temperatura', 750.0000, 'ºC'),
	(36982, 109, '2015-02-01 00:22:04.000000', 'temperatura', 971.0000, 'ºC'),
	(36983, 109, '2015-02-01 00:22:05.000000', 'temperatura', 204.0000, 'ºC'),
	(36984, 109, '2015-02-01 00:22:06.000000', 'temperatura', 508.0000, 'ºC'),
	(36985, 109, '2015-02-01 00:22:07.000000', 'temperatura', 730.0000, 'ºC'),
	(36986, 109, '2015-02-01 00:22:08.000000', 'temperatura', 927.0000, 'ºC'),
	(36987, 109, '2015-02-01 00:22:09.000000', 'temperatura', 44.0000, 'ºC'),
	(36988, 109, '2015-02-01 00:22:10.000000', 'temperatura', 1038.0000, 'ºC'),
	(36989, 109, '2015-02-01 00:22:11.000000', 'temperatura', 261.0000, 'ºC'),
	(36990, 109, '2015-02-01 00:22:12.000000', 'temperatura', 590.0000, 'ºC'),
	(36991, 109, '2015-02-01 00:22:13.000000', 'temperatura', 966.0000, 'ºC'),
	(36992, 109, '2015-02-01 00:22:14.000000', 'temperatura', 664.0000, 'ºC'),
	(36993, 109, '2015-02-01 00:22:15.000000', 'temperatura', 420.0000, 'ºC'),
	(36994, 109, '2015-02-01 00:22:16.000000', 'temperatura', 111.0000, 'ºC'),
	(36995, 109, '2015-02-01 00:22:17.000000', 'temperatura', 495.0000, 'ºC'),
	(36996, 109, '2015-02-01 00:22:18.000000', 'temperatura', 942.0000, 'ºC'),
	(36997, 109, '2015-02-01 00:22:19.000000', 'temperatura', 827.0000, 'ºC'),
	(36998, 109, '2015-02-01 00:22:20.000000', 'temperatura', 110.0000, 'ºC'),
	(36999, 109, '2015-02-01 00:22:21.000000', 'temperatura', 467.0000, 'ºC'),
	(37000, 109, '2015-02-01 00:22:22.000000', 'temperatura', 808.0000, 'ºC'),
	(37001, 109, '2015-02-01 00:22:23.000000', 'temperatura', 240.0000, 'ºC'),
	(37002, 109, '2015-02-01 00:22:24.000000', 'temperatura', 1177.0000, 'ºC'),
	(37003, 109, '2015-02-01 00:22:25.000000', 'temperatura', 366.0000, 'ºC'),
	(37004, 109, '2015-02-01 00:22:26.000000', 'temperatura', 700.0000, 'ºC'),
	(37005, 109, '2015-02-01 00:22:27.000000', 'temperatura', 3.0000, 'ºC'),
	(37006, 109, '2015-02-01 00:22:28.000000', 'temperatura', 315.0000, 'ºC'),
	(37007, 109, '2015-02-01 00:22:29.000000', 'temperatura', 365.0000, 'ºC'),
	(37008, 109, '2015-02-01 00:22:30.000000', 'temperatura', 879.0000, 'ºC'),
	(37009, 109, '2015-02-01 00:22:31.000000', 'temperatura', 904.0000, 'ºC'),
	(37010, 109, '2015-02-01 00:22:32.000000', 'temperatura', 682.0000, 'ºC'),
	(37011, 109, '2015-02-01 00:22:33.000000', 'temperatura', 697.0000, 'ºC'),
	(37012, 109, '2015-02-01 00:22:34.000000', 'temperatura', 242.0000, 'ºC'),
	(37013, 109, '2015-02-01 00:22:35.000000', 'temperatura', 318.0000, 'ºC'),
	(37014, 109, '2015-02-01 00:22:36.000000', 'temperatura', 864.0000, 'ºC'),
	(37015, 109, '2015-02-01 00:22:37.000000', 'temperatura', 968.0000, 'ºC'),
	(37016, 109, '2015-02-01 00:22:38.000000', 'temperatura', 1050.0000, 'ºC'),
	(37017, 109, '2015-02-01 00:22:39.000000', 'temperatura', 1144.0000, 'ºC'),
	(37018, 109, '2015-02-01 00:22:40.000000', 'temperatura', 173.0000, 'ºC'),
	(37019, 109, '2015-02-01 00:22:41.000000', 'temperatura', 1033.0000, 'ºC'),
	(37020, 109, '2015-02-01 00:22:42.000000', 'temperatura', 1044.0000, 'ºC'),
	(37021, 109, '2015-02-01 00:22:43.000000', 'temperatura', 922.0000, 'ºC'),
	(37022, 109, '2015-02-01 00:22:44.000000', 'temperatura', 280.0000, 'ºC'),
	(37023, 109, '2015-02-01 00:22:45.000000', 'temperatura', 1035.0000, 'ºC'),
	(37024, 109, '2015-02-01 00:22:46.000000', 'temperatura', 733.0000, 'ºC'),
	(37025, 109, '2015-02-01 00:22:47.000000', 'temperatura', 563.0000, 'ºC'),
	(37026, 109, '2015-02-01 00:22:48.000000', 'temperatura', 615.0000, 'ºC'),
	(37027, 109, '2015-02-01 00:22:49.000000', 'temperatura', 189.0000, 'ºC'),
	(37028, 109, '2015-02-01 00:22:50.000000', 'temperatura', 299.0000, 'ºC'),
	(37029, 109, '2015-02-01 00:22:51.000000', 'temperatura', 927.0000, 'ºC'),
	(37030, 109, '2015-02-01 00:22:52.000000', 'temperatura', 140.0000, 'ºC'),
	(37031, 109, '2015-02-01 00:22:53.000000', 'temperatura', 320.0000, 'ºC'),
	(37032, 109, '2015-02-01 00:22:54.000000', 'temperatura', 1179.0000, 'ºC'),
	(37033, 109, '2015-02-01 00:22:55.000000', 'temperatura', 137.0000, 'ºC'),
	(37034, 109, '2015-02-01 00:22:56.000000', 'temperatura', 747.0000, 'ºC'),
	(37035, 109, '2015-02-01 00:22:57.000000', 'temperatura', 925.0000, 'ºC'),
	(37036, 109, '2015-02-01 00:22:58.000000', 'temperatura', 1185.0000, 'ºC'),
	(37037, 109, '2015-02-01 00:22:59.000000', 'temperatura', 752.0000, 'ºC'),
	(37038, 109, '2015-02-01 00:23:00.000000', 'temperatura', 202.0000, 'ºC'),
	(37039, 109, '2015-02-01 00:23:01.000000', 'temperatura', 1157.0000, 'ºC'),
	(37040, 109, '2015-02-01 00:23:02.000000', 'temperatura', 378.0000, 'ºC'),
	(37041, 109, '2015-02-01 00:23:03.000000', 'temperatura', 820.0000, 'ºC'),
	(37042, 109, '2015-02-01 00:23:04.000000', 'temperatura', 567.0000, 'ºC'),
	(37043, 109, '2015-02-01 00:23:05.000000', 'temperatura', 376.0000, 'ºC'),
	(37044, 109, '2015-02-01 00:23:06.000000', 'temperatura', 177.0000, 'ºC'),
	(37045, 109, '2015-02-01 00:23:07.000000', 'temperatura', 960.0000, 'ºC'),
	(37046, 109, '2015-02-01 00:23:08.000000', 'temperatura', 670.0000, 'ºC'),
	(37047, 109, '2015-02-01 00:23:09.000000', 'temperatura', 469.0000, 'ºC'),
	(37048, 109, '2015-02-01 00:23:10.000000', 'temperatura', 335.0000, 'ºC'),
	(37049, 109, '2015-02-01 00:23:11.000000', 'temperatura', 269.0000, 'ºC'),
	(37050, 109, '2015-02-01 00:23:12.000000', 'temperatura', 341.0000, 'ºC'),
	(37051, 109, '2015-02-01 00:23:13.000000', 'temperatura', 896.0000, 'ºC'),
	(37052, 109, '2015-02-01 00:23:14.000000', 'temperatura', 1060.0000, 'ºC'),
	(37053, 109, '2015-02-01 00:23:15.000000', 'temperatura', 212.0000, 'ºC'),
	(37054, 109, '2015-02-01 00:23:16.000000', 'temperatura', 282.0000, 'ºC'),
	(37055, 109, '2015-02-01 00:23:17.000000', 'temperatura', 774.0000, 'ºC'),
	(37056, 109, '2015-02-01 00:23:18.000000', 'temperatura', 626.0000, 'ºC'),
	(37057, 109, '2015-02-01 00:23:19.000000', 'temperatura', 806.0000, 'ºC'),
	(37058, 109, '2015-02-01 00:23:20.000000', 'temperatura', 953.0000, 'ºC'),
	(37059, 109, '2015-02-01 00:23:21.000000', 'temperatura', 1146.0000, 'ºC'),
	(37060, 109, '2015-02-01 00:23:22.000000', 'temperatura', 474.0000, 'ºC'),
	(37061, 109, '2015-02-01 00:23:23.000000', 'temperatura', 131.0000, 'ºC'),
	(37062, 109, '2015-02-01 00:23:24.000000', 'temperatura', 435.0000, 'ºC'),
	(37063, 109, '2015-02-01 00:23:25.000000', 'temperatura', 583.0000, 'ºC'),
	(37064, 109, '2015-02-01 00:23:26.000000', 'temperatura', 411.0000, 'ºC'),
	(37065, 109, '2015-02-01 00:23:27.000000', 'temperatura', 304.0000, 'ºC'),
	(37066, 109, '2015-02-01 00:23:28.000000', 'temperatura', 288.0000, 'ºC'),
	(37067, 109, '2015-02-01 00:23:29.000000', 'temperatura', 530.0000, 'ºC'),
	(37068, 109, '2015-02-01 00:23:30.000000', 'temperatura', 584.0000, 'ºC'),
	(37069, 109, '2015-02-01 00:23:31.000000', 'temperatura', 133.0000, 'ºC'),
	(37070, 109, '2015-02-01 00:23:32.000000', 'temperatura', 111.0000, 'ºC'),
	(37071, 109, '2015-02-01 00:23:33.000000', 'temperatura', 158.0000, 'ºC'),
	(37072, 109, '2015-02-01 00:23:34.000000', 'temperatura', 459.0000, 'ºC'),
	(37073, 109, '2015-02-01 00:23:35.000000', 'temperatura', 619.0000, 'ºC'),
	(37074, 109, '2015-02-01 00:23:36.000000', 'temperatura', 517.0000, 'ºC'),
	(37075, 109, '2015-02-01 00:23:37.000000', 'temperatura', 732.0000, 'ºC'),
	(37076, 109, '2015-02-01 00:23:38.000000', 'temperatura', 908.0000, 'ºC'),
	(37077, 109, '2015-02-01 00:23:39.000000', 'temperatura', 1147.0000, 'ºC'),
	(37078, 109, '2015-02-01 00:23:40.000000', 'temperatura', 608.0000, 'ºC'),
	(37079, 109, '2015-02-01 00:23:41.000000', 'temperatura', 802.0000, 'ºC'),
	(37080, 109, '2015-02-01 00:23:42.000000', 'temperatura', 985.0000, 'ºC'),
	(37081, 109, '2015-02-01 00:23:43.000000', 'temperatura', 121.0000, 'ºC'),
	(37082, 109, '2015-02-01 00:23:44.000000', 'temperatura', 49.0000, 'ºC'),
	(37083, 109, '2015-02-01 00:23:45.000000', 'temperatura', 1084.0000, 'ºC'),
	(37084, 109, '2015-02-01 00:23:46.000000', 'temperatura', 473.0000, 'ºC'),
	(37085, 109, '2015-02-01 00:23:47.000000', 'temperatura', 311.0000, 'ºC'),
	(37086, 109, '2015-02-01 00:23:48.000000', 'temperatura', 139.0000, 'ºC'),
	(37087, 109, '2015-02-01 00:23:49.000000', 'temperatura', 964.0000, 'ºC'),
	(37088, 109, '2015-02-01 00:23:50.000000', 'temperatura', 802.0000, 'ºC'),
	(37089, 109, '2015-02-01 00:23:51.000000', 'temperatura', 1119.0000, 'ºC'),
	(37090, 109, '2015-02-01 00:23:52.000000', 'temperatura', 791.0000, 'ºC'),
	(37091, 109, '2015-02-01 00:23:53.000000', 'temperatura', 598.0000, 'ºC'),
	(37092, 109, '2015-02-01 00:23:54.000000', 'temperatura', 618.0000, 'ºC'),
	(37093, 109, '2015-02-01 00:23:55.000000', 'temperatura', 94.0000, 'ºC'),
	(37094, 109, '2015-02-01 00:23:56.000000', 'temperatura', 1018.0000, 'ºC'),
	(37095, 109, '2015-02-01 00:23:57.000000', 'temperatura', 9.0000, 'ºC'),
	(37096, 109, '2015-02-01 00:23:58.000000', 'temperatura', 590.0000, 'ºC'),
	(37097, 109, '2015-02-01 00:23:59.000000', 'temperatura', 523.0000, 'ºC'),
	(37098, 109, '2015-02-01 00:24:00.000000', 'temperatura', 847.0000, 'ºC'),
	(37099, 109, '2015-02-01 00:24:01.000000', 'temperatura', 265.0000, 'ºC'),
	(37100, 109, '2015-02-01 00:24:02.000000', 'temperatura', 1184.0000, 'ºC'),
	(37101, 109, '2015-02-01 00:24:03.000000', 'temperatura', 326.0000, 'ºC'),
	(37102, 109, '2015-02-01 00:24:04.000000', 'temperatura', 480.0000, 'ºC'),
	(37103, 109, '2015-02-01 00:24:05.000000', 'temperatura', 221.0000, 'ºC'),
	(37104, 109, '2015-02-01 00:24:06.000000', 'temperatura', 868.0000, 'ºC'),
	(37105, 109, '2015-02-01 00:24:07.000000', 'temperatura', 75.0000, 'ºC'),
	(37106, 109, '2015-02-01 00:24:08.000000', 'temperatura', 171.0000, 'ºC'),
	(37107, 109, '2015-02-01 00:24:09.000000', 'temperatura', 630.0000, 'ºC'),
	(37108, 109, '2015-02-01 00:24:10.000000', 'temperatura', 240.0000, 'ºC'),
	(37109, 109, '2015-02-01 00:24:11.000000', 'temperatura', 510.0000, 'ºC'),
	(37110, 109, '2015-02-01 00:24:12.000000', 'temperatura', 631.0000, 'ºC'),
	(37111, 109, '2015-02-01 00:24:13.000000', 'temperatura', 425.0000, 'ºC'),
	(37112, 109, '2015-02-01 00:24:14.000000', 'temperatura', 232.0000, 'ºC'),
	(37113, 109, '2015-02-01 00:24:15.000000', 'temperatura', 1085.0000, 'ºC'),
	(37114, 109, '2015-02-01 00:24:16.000000', 'temperatura', 1130.0000, 'ºC'),
	(37115, 109, '2015-02-01 00:24:17.000000', 'temperatura', 1196.0000, 'ºC'),
	(37116, 109, '2015-02-01 00:24:18.000000', 'temperatura', 189.0000, 'ºC'),
	(37117, 109, '2015-02-01 00:24:19.000000', 'temperatura', 957.0000, 'ºC'),
	(37118, 109, '2015-02-01 00:24:20.000000', 'temperatura', 621.0000, 'ºC'),
	(37119, 109, '2015-02-01 00:24:21.000000', 'temperatura', 234.0000, 'ºC'),
	(37120, 109, '2015-02-01 00:24:22.000000', 'temperatura', 507.0000, 'ºC'),
	(37121, 109, '2015-02-01 00:24:23.000000', 'temperatura', 634.0000, 'ºC'),
	(37122, 109, '2015-02-01 00:24:24.000000', 'temperatura', 451.0000, 'ºC'),
	(37123, 109, '2015-02-01 00:24:25.000000', 'temperatura', 353.0000, 'ºC'),
	(37124, 109, '2015-02-01 00:24:26.000000', 'temperatura', 414.0000, 'ºC'),
	(37125, 109, '2015-02-01 00:24:27.000000', 'temperatura', 1009.0000, 'ºC'),
	(37126, 109, '2015-02-01 00:24:28.000000', 'temperatura', 202.0000, 'ºC'),
	(37127, 109, '2015-02-01 00:24:29.000000', 'temperatura', 387.0000, 'ºC'),
	(37128, 109, '2015-02-01 00:24:30.000000', 'temperatura', 127.0000, 'ºC'),
	(37129, 109, '2015-02-01 00:24:31.000000', 'temperatura', 676.0000, 'ºC'),
	(37130, 109, '2015-02-01 00:24:32.000000', 'temperatura', 599.0000, 'ºC'),
	(37131, 109, '2015-02-01 00:24:33.000000', 'temperatura', 966.0000, 'ºC'),
	(37132, 109, '2015-02-01 00:24:34.000000', 'temperatura', 635.0000, 'ºC'),
	(37133, 109, '2015-02-01 00:24:35.000000', 'temperatura', 277.0000, 'ºC'),
	(37134, 109, '2015-02-01 00:24:36.000000', 'temperatura', 679.0000, 'ºC'),
	(37135, 109, '2015-02-01 00:24:37.000000', 'temperatura', 166.0000, 'ºC'),
	(37136, 109, '2015-02-01 00:24:38.000000', 'temperatura', 1191.0000, 'ºC'),
	(37137, 109, '2015-02-01 00:24:39.000000', 'temperatura', 661.0000, 'ºC'),
	(37138, 109, '2015-02-01 00:24:40.000000', 'temperatura', 930.0000, 'ºC'),
	(37139, 109, '2015-02-01 00:24:41.000000', 'temperatura', 267.0000, 'ºC'),
	(37140, 109, '2015-02-01 00:24:42.000000', 'temperatura', 945.0000, 'ºC'),
	(37141, 109, '2015-02-01 00:24:43.000000', 'temperatura', 326.0000, 'ºC'),
	(37142, 109, '2015-02-01 00:24:44.000000', 'temperatura', 1197.0000, 'ºC'),
	(37143, 109, '2015-02-01 00:24:45.000000', 'temperatura', 207.0000, 'ºC'),
	(37144, 109, '2015-02-01 00:24:46.000000', 'temperatura', 1044.0000, 'ºC'),
	(37145, 109, '2015-02-01 00:24:47.000000', 'temperatura', 998.0000, 'ºC'),
	(37146, 109, '2015-02-01 00:24:48.000000', 'temperatura', 658.0000, 'ºC'),
	(37147, 109, '2015-02-01 00:24:49.000000', 'temperatura', 298.0000, 'ºC'),
	(37148, 109, '2015-02-01 00:24:50.000000', 'temperatura', 716.0000, 'ºC'),
	(37149, 109, '2015-02-01 00:24:51.000000', 'temperatura', 286.0000, 'ºC'),
	(37150, 109, '2015-02-01 00:24:52.000000', 'temperatura', 482.0000, 'ºC'),
	(37151, 109, '2015-02-01 00:24:53.000000', 'temperatura', 351.0000, 'ºC'),
	(37152, 109, '2015-02-01 00:24:54.000000', 'temperatura', 313.0000, 'ºC'),
	(37153, 109, '2015-02-01 00:24:55.000000', 'temperatura', 511.0000, 'ºC'),
	(37154, 109, '2015-02-01 00:24:56.000000', 'temperatura', 418.0000, 'ºC'),
	(37155, 109, '2015-02-01 00:24:57.000000', 'temperatura', 557.0000, 'ºC'),
	(37156, 109, '2015-02-01 00:24:58.000000', 'temperatura', 330.0000, 'ºC'),
	(37157, 109, '2015-02-01 00:24:59.000000', 'temperatura', 1180.0000, 'ºC'),
	(37158, 109, '2015-02-01 00:25:00.000000', 'temperatura', 112.0000, 'ºC'),
	(37159, 109, '2015-02-01 00:25:01.000000', 'temperatura', 619.0000, 'ºC'),
	(37160, 109, '2015-02-01 00:25:02.000000', 'temperatura', 358.0000, 'ºC'),
	(37161, 109, '2015-02-01 00:25:03.000000', 'temperatura', 1137.0000, 'ºC'),
	(37162, 109, '2015-02-01 00:25:04.000000', 'temperatura', 1008.0000, 'ºC'),
	(37163, 109, '2015-02-01 00:25:05.000000', 'temperatura', 432.0000, 'ºC'),
	(37164, 109, '2015-02-01 00:25:06.000000', 'temperatura', 334.0000, 'ºC'),
	(37165, 109, '2015-02-01 00:25:07.000000', 'temperatura', 375.0000, 'ºC'),
	(37166, 109, '2015-02-01 00:25:08.000000', 'temperatura', 874.0000, 'ºC'),
	(37167, 109, '2015-02-01 00:25:09.000000', 'temperatura', 847.0000, 'ºC'),
	(37168, 109, '2015-02-01 00:25:10.000000', 'temperatura', 412.0000, 'ºC'),
	(37169, 109, '2015-02-01 00:25:11.000000', 'temperatura', 718.0000, 'ºC'),
	(37170, 109, '2015-02-01 00:25:12.000000', 'temperatura', 1158.0000, 'ºC'),
	(37171, 109, '2015-02-01 00:25:13.000000', 'temperatura', 33.0000, 'ºC'),
	(37172, 109, '2015-02-01 00:25:14.000000', 'temperatura', 295.0000, 'ºC'),
	(37173, 109, '2015-02-01 00:25:15.000000', 'temperatura', 173.0000, 'ºC'),
	(37174, 109, '2015-02-01 00:25:16.000000', 'temperatura', 1183.0000, 'ºC'),
	(37175, 109, '2015-02-01 00:25:17.000000', 'temperatura', 597.0000, 'ºC'),
	(37176, 109, '2015-02-01 00:25:18.000000', 'temperatura', 635.0000, 'ºC'),
	(37177, 109, '2015-02-01 00:25:19.000000', 'temperatura', 185.0000, 'ºC'),
	(37178, 109, '2015-02-01 00:25:20.000000', 'temperatura', 222.0000, 'ºC'),
	(37179, 109, '2015-02-01 00:25:21.000000', 'temperatura', 553.0000, 'ºC'),
	(37180, 109, '2015-02-01 00:25:22.000000', 'temperatura', 900.0000, 'ºC'),
	(37181, 109, '2015-02-01 00:25:23.000000', 'temperatura', 441.0000, 'ºC'),
	(37182, 109, '2015-02-01 00:25:24.000000', 'temperatura', 708.0000, 'ºC'),
	(37183, 109, '2015-02-01 00:25:25.000000', 'temperatura', 1015.0000, 'ºC'),
	(37184, 109, '2015-02-01 00:25:26.000000', 'temperatura', 552.0000, 'ºC'),
	(37185, 109, '2015-02-01 00:25:27.000000', 'temperatura', 916.0000, 'ºC'),
	(37186, 109, '2015-02-01 00:25:28.000000', 'temperatura', 524.0000, 'ºC'),
	(37187, 109, '2015-02-01 00:25:29.000000', 'temperatura', 1072.0000, 'ºC'),
	(37188, 109, '2015-02-01 00:25:30.000000', 'temperatura', 189.0000, 'ºC'),
	(37189, 109, '2015-02-01 00:25:31.000000', 'temperatura', 131.0000, 'ºC'),
	(37190, 109, '2015-02-01 00:25:32.000000', 'temperatura', 87.0000, 'ºC'),
	(37191, 109, '2015-02-01 00:25:33.000000', 'temperatura', 44.0000, 'ºC'),
	(37192, 109, '2015-02-01 00:25:34.000000', 'temperatura', 1159.0000, 'ºC'),
	(37193, 109, '2015-02-01 00:25:35.000000', 'temperatura', 862.0000, 'ºC'),
	(37194, 109, '2015-02-01 00:25:36.000000', 'temperatura', 835.0000, 'ºC'),
	(37195, 109, '2015-02-01 00:25:37.000000', 'temperatura', 390.0000, 'ºC'),
	(37196, 109, '2015-02-01 00:25:38.000000', 'temperatura', 644.0000, 'ºC'),
	(37197, 109, '2015-02-01 00:25:39.000000', 'temperatura', 850.0000, 'ºC'),
	(37198, 109, '2015-02-01 00:25:40.000000', 'temperatura', 1120.0000, 'ºC'),
	(37199, 109, '2015-02-01 00:25:41.000000', 'temperatura', 652.0000, 'ºC'),
	(37200, 109, '2015-02-01 00:25:42.000000', 'temperatura', 1099.0000, 'ºC'),
	(37201, 109, '2015-02-01 00:25:43.000000', 'temperatura', 1140.0000, 'ºC'),
	(37202, 109, '2015-02-01 00:25:44.000000', 'temperatura', 3.0000, 'ºC'),
	(37203, 109, '2015-02-01 00:25:45.000000', 'temperatura', 196.0000, 'ºC'),
	(37204, 109, '2015-02-01 00:25:46.000000', 'temperatura', 969.0000, 'ºC'),
	(37205, 109, '2015-02-01 00:25:47.000000', 'temperatura', 661.0000, 'ºC'),
	(37206, 109, '2015-02-01 00:25:48.000000', 'temperatura', 395.0000, 'ºC'),
	(37207, 109, '2015-02-01 00:25:49.000000', 'temperatura', 1195.0000, 'ºC'),
	(37208, 109, '2015-02-01 00:25:50.000000', 'temperatura', 1190.0000, 'ºC'),
	(37209, 109, '2015-02-01 00:25:51.000000', 'temperatura', 1165.0000, 'ºC'),
	(37210, 109, '2015-02-01 00:25:52.000000', 'temperatura', 1056.0000, 'ºC'),
	(37211, 109, '2015-02-01 00:25:53.000000', 'temperatura', 584.0000, 'ºC'),
	(37212, 109, '2015-02-01 00:25:54.000000', 'temperatura', 952.0000, 'ºC'),
	(37213, 109, '2015-02-01 00:25:55.000000', 'temperatura', 610.0000, 'ºC'),
	(37214, 109, '2015-02-01 00:25:56.000000', 'temperatura', 194.0000, 'ºC'),
	(37215, 109, '2015-02-01 00:25:57.000000', 'temperatura', 340.0000, 'ºC'),
	(37216, 109, '2015-02-01 00:25:58.000000', 'temperatura', 1120.0000, 'ºC'),
	(37217, 109, '2015-02-01 00:25:59.000000', 'temperatura', 979.0000, 'ºC'),
	(37218, 109, '2015-02-01 00:26:00.000000', 'temperatura', 336.0000, 'ºC'),
	(37219, 109, '2015-02-01 00:26:01.000000', 'temperatura', 1142.0000, 'ºC'),
	(37220, 109, '2015-02-01 00:26:02.000000', 'temperatura', 1102.0000, 'ºC'),
	(37221, 109, '2015-02-01 00:26:03.000000', 'temperatura', 887.0000, 'ºC'),
	(37222, 109, '2015-02-01 00:26:04.000000', 'temperatura', 1127.0000, 'ºC'),
	(37223, 109, '2015-02-01 00:26:05.000000', 'temperatura', 574.0000, 'ºC'),
	(37224, 109, '2015-02-01 00:26:06.000000', 'temperatura', 689.0000, 'ºC'),
	(37225, 109, '2015-02-01 00:26:07.000000', 'temperatura', 525.0000, 'ºC'),
	(37226, 109, '2015-02-01 00:26:08.000000', 'temperatura', 560.0000, 'ºC'),
	(37227, 109, '2015-02-01 00:26:09.000000', 'temperatura', 23.0000, 'ºC'),
	(37228, 109, '2015-02-01 00:26:10.000000', 'temperatura', 838.0000, 'ºC'),
	(37229, 109, '2015-02-01 00:26:11.000000', 'temperatura', 522.0000, 'ºC'),
	(37230, 109, '2015-02-01 00:26:12.000000', 'temperatura', 95.0000, 'ºC'),
	(37231, 109, '2015-02-01 00:26:13.000000', 'temperatura', 111.0000, 'ºC'),
	(37232, 109, '2015-02-01 00:26:14.000000', 'temperatura', 272.0000, 'ºC'),
	(37233, 109, '2015-02-01 00:26:15.000000', 'temperatura', 1024.0000, 'ºC'),
	(37234, 109, '2015-02-01 00:26:16.000000', 'temperatura', 705.0000, 'ºC'),
	(37235, 109, '2015-02-01 00:26:17.000000', 'temperatura', 454.0000, 'ºC'),
	(37236, 109, '2015-02-01 00:26:18.000000', 'temperatura', 157.0000, 'ºC'),
	(37237, 109, '2015-02-01 00:26:19.000000', 'temperatura', 621.0000, 'ºC'),
	(37238, 109, '2015-02-01 00:26:20.000000', 'temperatura', 236.0000, 'ºC'),
	(37239, 109, '2015-02-01 00:26:21.000000', 'temperatura', 518.0000, 'ºC'),
	(37240, 109, '2015-02-01 00:26:22.000000', 'temperatura', 683.0000, 'ºC'),
	(37241, 109, '2015-02-01 00:26:23.000000', 'temperatura', 663.0000, 'ºC'),
	(37242, 109, '2015-02-01 00:26:24.000000', 'temperatura', 63.0000, 'ºC'),
	(37243, 109, '2015-02-01 00:26:25.000000', 'temperatura', 730.0000, 'ºC'),
	(37244, 109, '2015-02-01 00:26:26.000000', 'temperatura', 1058.0000, 'ºC'),
	(37245, 109, '2015-02-01 00:26:27.000000', 'temperatura', 703.0000, 'ºC'),
	(37246, 109, '2015-02-01 00:26:28.000000', 'temperatura', 340.0000, 'ºC'),
	(37247, 109, '2015-02-01 00:26:29.000000', 'temperatura', 791.0000, 'ºC'),
	(37248, 109, '2015-02-01 00:26:30.000000', 'temperatura', 534.0000, 'ºC'),
	(37249, 109, '2015-02-01 00:26:31.000000', 'temperatura', 300.0000, 'ºC'),
	(37250, 109, '2015-02-01 00:26:32.000000', 'temperatura', 1096.0000, 'ºC'),
	(37251, 109, '2015-02-01 00:26:33.000000', 'temperatura', 982.0000, 'ºC'),
	(37252, 109, '2015-02-01 00:26:34.000000', 'temperatura', 424.0000, 'ºC'),
	(37253, 109, '2015-02-01 00:26:35.000000', 'temperatura', 373.0000, 'ºC'),
	(37254, 109, '2015-02-01 00:26:36.000000', 'temperatura', 593.0000, 'ºC'),
	(37255, 109, '2015-02-01 00:26:37.000000', 'temperatura', 647.0000, 'ºC'),
	(37256, 109, '2015-02-01 00:26:38.000000', 'temperatura', 257.0000, 'ºC'),
	(37257, 109, '2015-02-01 00:26:39.000000', 'temperatura', 542.0000, 'ºC'),
	(37258, 109, '2015-02-01 00:26:40.000000', 'temperatura', 743.0000, 'ºC'),
	(37259, 109, '2015-02-01 00:26:41.000000', 'temperatura', 889.0000, 'ºC'),
	(37260, 109, '2015-02-01 00:26:42.000000', 'temperatura', 1015.0000, 'ºC'),
	(37261, 109, '2015-02-01 00:26:43.000000', 'temperatura', 7.0000, 'ºC'),
	(37262, 109, '2015-02-01 00:26:44.000000', 'temperatura', 594.0000, 'ºC'),
	(37263, 109, '2015-02-01 00:26:45.000000', 'temperatura', 547.0000, 'ºC'),
	(37264, 109, '2015-02-01 00:26:46.000000', 'temperatura', 955.0000, 'ºC'),
	(37265, 109, '2015-02-01 00:26:47.000000', 'temperatura', 734.0000, 'ºC'),
	(37266, 109, '2015-02-01 00:26:48.000000', 'temperatura', 806.0000, 'ºC'),
	(37267, 109, '2015-02-01 00:26:49.000000', 'temperatura', 627.0000, 'ºC'),
	(37268, 109, '2015-02-01 00:26:50.000000', 'temperatura', 719.0000, 'ºC'),
	(37269, 109, '2015-02-01 00:26:51.000000', 'temperatura', 512.0000, 'ºC'),
	(37270, 109, '2015-02-01 00:26:52.000000', 'temperatura', 404.0000, 'ºC'),
	(37271, 109, '2015-02-01 00:26:53.000000', 'temperatura', 487.0000, 'ºC'),
	(37272, 109, '2015-02-01 00:26:54.000000', 'temperatura', 22.0000, 'ºC'),
	(37273, 109, '2015-02-01 00:26:55.000000', 'temperatura', 1049.0000, 'ºC'),
	(37274, 109, '2015-02-01 00:26:56.000000', 'temperatura', 378.0000, 'ºC'),
	(37275, 109, '2015-02-01 00:26:57.000000', 'temperatura', 1144.0000, 'ºC'),
	(37276, 109, '2015-02-01 00:26:58.000000', 'temperatura', 987.0000, 'ºC'),
	(37277, 109, '2015-02-01 00:26:59.000000', 'temperatura', 304.0000, 'ºC'),
	(37278, 109, '2015-02-01 00:27:00.000000', 'temperatura', 958.0000, 'ºC'),
	(37279, 109, '2015-02-01 00:27:01.000000', 'temperatura', 278.0000, 'ºC'),
	(37280, 109, '2015-02-01 00:27:02.000000', 'temperatura', 919.0000, 'ºC'),
	(37281, 109, '2015-02-01 00:27:03.000000', 'temperatura', 162.0000, 'ºC'),
	(37282, 109, '2015-02-01 00:27:04.000000', 'temperatura', 453.0000, 'ºC'),
	(37283, 109, '2015-02-01 00:27:05.000000', 'temperatura', 579.0000, 'ºC'),
	(37284, 109, '2015-02-01 00:27:06.000000', 'temperatura', 337.0000, 'ºC'),
	(37285, 109, '2015-02-01 00:27:07.000000', 'temperatura', 1149.0000, 'ºC'),
	(37286, 109, '2015-02-01 00:27:08.000000', 'temperatura', 1135.0000, 'ºC'),
	(37287, 109, '2015-02-01 00:27:09.000000', 'temperatura', 1028.0000, 'ºC'),
	(37288, 109, '2015-02-01 00:27:10.000000', 'temperatura', 534.0000, 'ºC'),
	(37289, 109, '2015-02-01 00:27:11.000000', 'temperatura', 785.0000, 'ºC'),
	(37290, 109, '2015-02-01 00:27:12.000000', 'temperatura', 1127.0000, 'ºC'),
	(37291, 109, '2015-02-01 00:27:13.000000', 'temperatura', 879.0000, 'ºC'),
	(37292, 109, '2015-02-01 00:27:14.000000', 'temperatura', 1016.0000, 'ºC'),
	(37293, 109, '2015-02-01 00:27:15.000000', 'temperatura', 42.0000, 'ºC'),
	(37294, 109, '2015-02-01 00:27:16.000000', 'temperatura', 762.0000, 'ºC'),
	(37295, 109, '2015-02-01 00:27:17.000000', 'temperatura', 86.0000, 'ºC'),
	(37296, 109, '2015-02-01 00:27:18.000000', 'temperatura', 545.0000, 'ºC'),
	(37297, 109, '2015-02-01 00:27:19.000000', 'temperatura', 65.0000, 'ºC'),
	(37298, 109, '2015-02-01 00:27:20.000000', 'temperatura', 1092.0000, 'ºC'),
	(37299, 109, '2015-02-01 00:27:21.000000', 'temperatura', 467.0000, 'ºC'),
	(37300, 109, '2015-02-01 00:27:22.000000', 'temperatura', 259.0000, 'ºC'),
	(37301, 109, '2015-02-01 00:27:23.000000', 'temperatura', 1096.0000, 'ºC'),
	(37302, 109, '2015-02-01 00:27:24.000000', 'temperatura', 1100.0000, 'ºC'),
	(37303, 109, '2015-02-01 00:27:25.000000', 'temperatura', 1014.0000, 'ºC'),
	(37304, 109, '2015-02-01 00:27:26.000000', 'temperatura', 571.0000, 'ºC'),
	(37305, 109, '2015-02-01 00:27:27.000000', 'temperatura', 1011.0000, 'ºC'),
	(37306, 109, '2015-02-01 00:27:28.000000', 'temperatura', 946.0000, 'ºC'),
	(37307, 109, '2015-02-01 00:27:29.000000', 'temperatura', 494.0000, 'ºC'),
	(37308, 109, '2015-02-01 00:27:30.000000', 'temperatura', 834.0000, 'ºC'),
	(37309, 109, '2015-02-01 00:27:31.000000', 'temperatura', 288.0000, 'ºC'),
	(37310, 109, '2015-02-01 00:27:32.000000', 'temperatura', 138.0000, 'ºC'),
	(37311, 109, '2015-02-01 00:27:33.000000', 'temperatura', 1027.0000, 'ºC'),
	(37312, 109, '2015-02-01 00:27:34.000000', 'temperatura', 1121.0000, 'ºC'),
	(37313, 109, '2015-02-01 00:27:35.000000', 'temperatura', 124.0000, 'ºC'),
	(37314, 109, '2015-02-01 00:27:36.000000', 'temperatura', 860.0000, 'ºC'),
	(37315, 109, '2015-02-01 00:27:37.000000', 'temperatura', 325.0000, 'ºC'),
	(37316, 109, '2015-02-01 00:27:38.000000', 'temperatura', 247.0000, 'ºC'),
	(37317, 109, '2015-02-01 00:27:39.000000', 'temperatura', 262.0000, 'ºC'),
	(37318, 109, '2015-02-01 00:27:40.000000', 'temperatura', 569.0000, 'ºC'),
	(37319, 109, '2015-02-01 00:27:41.000000', 'temperatura', 861.0000, 'ºC'),
	(37320, 109, '2015-02-01 00:27:42.000000', 'temperatura', 196.0000, 'ºC'),
	(37321, 109, '2015-02-01 00:27:43.000000', 'temperatura', 800.0000, 'ºC'),
	(37322, 109, '2015-02-01 00:27:44.000000', 'temperatura', 1013.0000, 'ºC'),
	(37323, 109, '2015-02-01 00:27:45.000000', 'temperatura', 264.0000, 'ºC'),
	(37324, 109, '2015-02-01 00:27:46.000000', 'temperatura', 684.0000, 'ºC'),
	(37325, 109, '2015-02-01 00:27:47.000000', 'temperatura', 225.0000, 'ºC'),
	(37326, 109, '2015-02-01 00:27:48.000000', 'temperatura', 275.0000, 'ºC'),
	(37327, 109, '2015-02-01 00:27:49.000000', 'temperatura', 700.0000, 'ºC'),
	(37328, 109, '2015-02-01 00:27:50.000000', 'temperatura', 275.0000, 'ºC'),
	(37329, 109, '2015-02-01 00:27:51.000000', 'temperatura', 476.0000, 'ºC'),
	(37330, 109, '2015-02-01 00:27:52.000000', 'temperatura', 355.0000, 'ºC'),
	(37331, 109, '2015-02-01 00:27:53.000000', 'temperatura', 350.0000, 'ºC'),
	(37332, 109, '2015-02-01 00:27:54.000000', 'temperatura', 684.0000, 'ºC'),
	(37333, 109, '2015-02-01 00:27:55.000000', 'temperatura', 1169.0000, 'ºC'),
	(37334, 109, '2015-02-01 00:27:56.000000', 'temperatura', 195.0000, 'ºC'),
	(37335, 109, '2015-02-01 00:27:57.000000', 'temperatura', 1068.0000, 'ºC'),
	(37336, 109, '2015-02-01 00:27:58.000000', 'temperatura', 1158.0000, 'ºC'),
	(37337, 109, '2015-02-01 00:27:59.000000', 'temperatura', 183.0000, 'ºC'),
	(37338, 109, '2015-02-01 00:28:00.000000', 'temperatura', 1045.0000, 'ºC'),
	(37339, 109, '2015-02-01 00:28:01.000000', 'temperatura', 1073.0000, 'ºC'),
	(37340, 109, '2015-02-01 00:28:02.000000', 'temperatura', 1033.0000, 'ºC'),
	(37341, 109, '2015-02-01 00:28:03.000000', 'temperatura', 745.0000, 'ºC'),
	(37342, 109, '2015-02-01 00:28:04.000000', 'temperatura', 628.0000, 'ºC'),
	(37343, 109, '2015-02-01 00:28:05.000000', 'temperatura', 906.0000, 'ºC'),
	(37344, 109, '2015-02-01 00:28:06.000000', 'temperatura', 246.0000, 'ºC'),
	(37345, 109, '2015-02-01 00:28:07.000000', 'temperatura', 911.0000, 'ºC'),
	(37346, 109, '2015-02-01 00:28:08.000000', 'temperatura', 220.0000, 'ºC'),
	(37347, 109, '2015-02-01 00:28:09.000000', 'temperatura', 764.0000, 'ºC'),
	(37348, 109, '2015-02-01 00:28:10.000000', 'temperatura', 764.0000, 'ºC'),
	(37349, 109, '2015-02-01 00:28:11.000000', 'temperatura', 326.0000, 'ºC'),
	(37350, 109, '2015-02-01 00:28:12.000000', 'temperatura', 538.0000, 'ºC'),
	(37351, 109, '2015-02-01 00:28:13.000000', 'temperatura', 515.0000, 'ºC'),
	(37352, 109, '2015-02-01 00:28:14.000000', 'temperatura', 960.0000, 'ºC'),
	(37353, 109, '2015-02-01 00:28:15.000000', 'temperatura', 855.0000, 'ºC'),
	(37354, 109, '2015-02-01 00:28:16.000000', 'temperatura', 198.0000, 'ºC'),
	(37355, 109, '2015-02-01 00:28:17.000000', 'temperatura', 824.0000, 'ºC'),
	(37356, 109, '2015-02-01 00:28:18.000000', 'temperatura', 1125.0000, 'ºC'),
	(37357, 109, '2015-02-01 00:28:19.000000', 'temperatura', 754.0000, 'ºC'),
	(37358, 109, '2015-02-01 00:28:20.000000', 'temperatura', 397.0000, 'ºC'),
	(37359, 109, '2015-02-01 00:28:21.000000', 'temperatura', 921.0000, 'ºC'),
	(37360, 109, '2015-02-01 00:28:22.000000', 'temperatura', 1015.0000, 'ºC'),
	(37361, 109, '2015-02-01 00:28:23.000000', 'temperatura', 1113.0000, 'ºC'),
	(37362, 109, '2015-02-01 00:28:24.000000', 'temperatura', 119.0000, 'ºC'),
	(37363, 109, '2015-02-01 00:28:25.000000', 'temperatura', 856.0000, 'ºC'),
	(37364, 109, '2015-02-01 00:28:26.000000', 'temperatura', 323.0000, 'ºC'),
	(37365, 109, '2015-02-01 00:28:27.000000', 'temperatura', 249.0000, 'ºC'),
	(37366, 109, '2015-02-01 00:28:28.000000', 'temperatura', 277.0000, 'ºC'),
	(37367, 109, '2015-02-01 00:28:29.000000', 'temperatura', 639.0000, 'ºC'),
	(37368, 109, '2015-02-01 00:28:30.000000', 'temperatura', 1165.0000, 'ºC'),
	(37369, 109, '2015-02-01 00:28:31.000000', 'temperatura', 306.0000, 'ºC'),
	(37370, 109, '2015-02-01 00:28:32.000000', 'temperatura', 435.0000, 'ºC'),
	(37371, 109, '2015-02-01 00:28:33.000000', 'temperatura', 60.0000, 'ºC'),
	(37372, 109, '2015-02-01 00:28:34.000000', 'temperatura', 193.0000, 'ºC'),
	(37373, 109, '2015-02-01 00:28:35.000000', 'temperatura', 786.0000, 'ºC'),
	(37374, 109, '2015-02-01 00:28:36.000000', 'temperatura', 952.0000, 'ºC'),
	(37375, 109, '2015-02-01 00:28:37.000000', 'temperatura', 3.0000, 'ºC'),
	(37376, 109, '2015-02-01 00:28:38.000000', 'temperatura', 758.0000, 'ºC'),
	(37377, 109, '2015-02-01 00:28:39.000000', 'temperatura', 182.0000, 'ºC'),
	(37378, 109, '2015-02-01 00:28:40.000000', 'temperatura', 1035.0000, 'ºC'),
	(37379, 109, '2015-02-01 00:28:41.000000', 'temperatura', 1032.0000, 'ºC'),
	(37380, 109, '2015-02-01 00:28:42.000000', 'temperatura', 856.0000, 'ºC'),
	(37381, 109, '2015-02-01 00:28:43.000000', 'temperatura', 1182.0000, 'ºC'),
	(37382, 109, '2015-02-01 00:28:44.000000', 'temperatura', 945.0000, 'ºC'),
	(37383, 109, '2015-02-01 00:28:45.000000', 'temperatura', 1177.0000, 'ºC'),
	(37384, 109, '2015-02-01 00:28:46.000000', 'temperatura', 650.0000, 'ºC'),
	(37385, 109, '2015-02-01 00:28:47.000000', 'temperatura', 920.0000, 'ºC'),
	(37386, 109, '2015-02-01 00:28:48.000000', 'temperatura', 249.0000, 'ºC'),
	(37387, 109, '2015-02-01 00:28:49.000000', 'temperatura', 886.0000, 'ºC'),
	(37388, 109, '2015-02-01 00:28:50.000000', 'temperatura', 85.0000, 'ºC'),
	(37389, 109, '2015-02-01 00:28:51.000000', 'temperatura', 167.0000, 'ºC'),
	(37390, 109, '2015-02-01 00:28:52.000000', 'temperatura', 579.0000, 'ºC'),
	(37391, 109, '2015-02-01 00:28:53.000000', 'temperatura', 1197.0000, 'ºC'),
	(37392, 109, '2015-02-01 00:28:54.000000', 'temperatura', 648.0000, 'ºC'),
	(37393, 109, '2015-02-01 00:28:55.000000', 'temperatura', 848.0000, 'ºC'),
	(37394, 109, '2015-02-01 00:28:56.000000', 'temperatura', 1097.0000, 'ºC'),
	(37395, 109, '2015-02-01 00:28:57.000000', 'temperatura', 540.0000, 'ºC'),
	(37396, 109, '2015-02-01 00:28:58.000000', 'temperatura', 613.0000, 'ºC'),
	(37397, 109, '2015-02-01 00:28:59.000000', 'temperatura', 242.0000, 'ºC'),
	(37398, 109, '2015-02-01 00:29:00.000000', 'temperatura', 574.0000, 'ºC'),
	(37399, 109, '2015-02-01 00:29:01.000000', 'temperatura', 942.0000, 'ºC'),
	(37400, 109, '2015-02-01 00:29:02.000000', 'temperatura', 588.0000, 'ºC'),
	(37401, 109, '2015-02-01 00:29:03.000000', 'temperatura', 115.0000, 'ºC'),
	(37402, 109, '2015-02-01 00:29:04.000000', 'temperatura', 13.0000, 'ºC'),
	(37403, 109, '2015-02-01 00:29:05.000000', 'temperatura', 919.0000, 'ºC'),
	(37404, 109, '2015-02-01 00:29:06.000000', 'temperatura', 958.0000, 'ºC'),
	(37405, 109, '2015-02-01 00:29:07.000000', 'temperatura', 833.0000, 'ºC'),
	(37406, 109, '2015-02-01 00:29:08.000000', 'temperatura', 90.0000, 'ºC'),
	(37407, 109, '2015-02-01 00:29:09.000000', 'temperatura', 352.0000, 'ºC'),
	(37408, 109, '2015-02-01 00:29:10.000000', 'temperatura', 292.0000, 'ºC'),
	(37409, 109, '2015-02-01 00:29:11.000000', 'temperatura', 404.0000, 'ºC'),
	(37410, 109, '2015-02-01 00:29:12.000000', 'temperatura', 1144.0000, 'ºC'),
	(37411, 109, '2015-02-01 00:29:13.000000', 'temperatura', 909.0000, 'ºC'),
	(37412, 109, '2015-02-01 00:29:14.000000', 'temperatura', 1113.0000, 'ºC'),
	(37413, 109, '2015-02-01 00:29:15.000000', 'temperatura', 440.0000, 'ºC'),
	(37414, 109, '2015-02-01 00:29:16.000000', 'temperatura', 61.0000, 'ºC'),
	(37415, 109, '2015-02-01 00:29:17.000000', 'temperatura', 186.0000, 'ºC'),
	(37416, 109, '2015-02-01 00:29:18.000000', 'temperatura', 746.0000, 'ºC'),
	(37417, 109, '2015-02-01 00:29:19.000000', 'temperatura', 773.0000, 'ºC'),
	(37418, 109, '2015-02-01 00:29:20.000000', 'temperatura', 427.0000, 'ºC'),
	(37419, 109, '2015-02-01 00:29:21.000000', 'temperatura', 1016.0000, 'ºC'),
	(37420, 109, '2015-02-01 00:29:22.000000', 'temperatura', 200.0000, 'ºC'),
	(37421, 109, '2015-02-01 00:29:23.000000', 'temperatura', 353.0000, 'ºC'),
	(37422, 109, '2015-02-01 00:29:24.000000', 'temperatura', 1167.0000, 'ºC'),
	(37423, 109, '2015-02-01 00:29:25.000000', 'temperatura', 1173.0000, 'ºC'),
	(37424, 109, '2015-02-01 00:29:26.000000', 'temperatura', 1167.0000, 'ºC'),
	(37425, 109, '2015-02-01 00:29:27.000000', 'temperatura', 1115.0000, 'ºC'),
	(37426, 109, '2015-02-01 00:29:28.000000', 'temperatura', 875.0000, 'ºC'),
	(37427, 109, '2015-02-01 00:29:29.000000', 'temperatura', 1029.0000, 'ºC'),
	(37428, 109, '2015-02-01 00:29:30.000000', 'temperatura', 122.0000, 'ºC'),
	(37429, 109, '2015-02-01 00:29:31.000000', 'temperatura', 1125.0000, 'ºC'),
	(37430, 109, '2015-02-01 00:29:32.000000', 'temperatura', 458.0000, 'ºC'),
	(37431, 109, '2015-02-01 00:29:33.000000', 'temperatura', 117.0000, 'ºC'),
	(37432, 109, '2015-02-01 00:29:34.000000', 'temperatura', 409.0000, 'ºC'),
	(37433, 109, '2015-02-01 00:29:35.000000', 'temperatura', 494.0000, 'ºC'),
	(37434, 109, '2015-02-01 00:29:36.000000', 'temperatura', 45.0000, 'ºC'),
	(37435, 109, '2015-02-01 00:29:37.000000', 'temperatura', 1145.0000, 'ºC'),
	(37436, 109, '2015-02-01 00:29:38.000000', 'temperatura', 788.0000, 'ºC'),
	(37437, 109, '2015-02-01 00:29:39.000000', 'temperatura', 508.0000, 'ºC'),
	(37438, 109, '2015-02-01 00:29:40.000000', 'temperatura', 176.0000, 'ºC'),
	(37439, 109, '2015-02-01 00:29:41.000000', 'temperatura', 555.0000, 'ºC'),
	(37440, 109, '2015-02-01 00:29:42.000000', 'temperatura', 1047.0000, 'ºC'),
	(37441, 109, '2015-02-01 00:29:43.000000', 'temperatura', 1170.0000, 'ºC'),
	(37442, 109, '2015-02-01 00:29:44.000000', 'temperatura', 312.0000, 'ºC'),
	(37443, 109, '2015-02-01 00:29:45.000000', 'temperatura', 451.0000, 'ºC'),
	(37444, 109, '2015-02-01 00:29:46.000000', 'temperatura', 119.0000, 'ºC'),
	(37445, 109, '2015-02-01 00:29:47.000000', 'temperatura', 442.0000, 'ºC'),
	(37446, 109, '2015-02-01 00:29:48.000000', 'temperatura', 653.0000, 'ºC'),
	(37447, 109, '2015-02-01 00:29:49.000000', 'temperatura', 740.0000, 'ºC'),
	(37448, 109, '2015-02-01 00:29:50.000000', 'temperatura', 542.0000, 'ºC'),
	(37449, 109, '2015-02-01 00:29:51.000000', 'temperatura', 489.0000, 'ºC'),
	(37450, 109, '2015-02-01 00:29:52.000000', 'temperatura', 820.0000, 'ºC'),
	(37451, 109, '2015-02-01 00:29:53.000000', 'temperatura', 234.0000, 'ºC'),
	(37452, 109, '2015-02-01 00:29:54.000000', 'temperatura', 1112.0000, 'ºC'),
	(37453, 109, '2015-02-01 00:29:55.000000', 'temperatura', 58.0000, 'ºC'),
	(37454, 109, '2015-02-01 00:29:56.000000', 'temperatura', 555.0000, 'ºC'),
	(37455, 109, '2015-02-01 00:29:57.000000', 'temperatura', 201.0000, 'ºC'),
	(37456, 109, '2015-02-01 00:29:58.000000', 'temperatura', 541.0000, 'ºC'),
	(37457, 109, '2015-02-01 00:29:59.000000', 'temperatura', 902.0000, 'ºC'),
	(37458, 109, '2015-02-01 00:30:00.000000', 'temperatura', 487.0000, 'ºC'),
	(37459, 109, '2015-02-01 00:30:01.000000', 'temperatura', 931.0000, 'ºC'),
	(37460, 109, '2015-02-01 00:30:02.000000', 'temperatura', 792.0000, 'ºC'),
	(37461, 109, '2015-02-01 00:30:03.000000', 'temperatura', 1168.0000, 'ºC'),
	(37462, 109, '2015-02-01 00:30:04.000000', 'temperatura', 1066.0000, 'ºC'),
	(37463, 109, '2015-02-01 00:30:05.000000', 'temperatura', 625.0000, 'ºC'),
	(37464, 109, '2015-02-01 00:30:06.000000', 'temperatura', 1129.0000, 'ºC'),
	(37465, 109, '2015-02-01 00:30:07.000000', 'temperatura', 170.0000, 'ºC'),
	(37466, 109, '2015-02-01 00:30:08.000000', 'temperatura', 1063.0000, 'ºC'),
	(37467, 109, '2015-02-01 00:30:09.000000', 'temperatura', 4.0000, 'ºC'),
	(37468, 109, '2015-02-01 00:30:10.000000', 'temperatura', 435.0000, 'ºC'),
	(37469, 109, '2015-02-01 00:30:11.000000', 'temperatura', 960.0000, 'ºC'),
	(37470, 109, '2015-02-01 00:30:12.000000', 'temperatura', 1097.0000, 'ºC'),
	(37471, 109, '2015-02-01 00:30:13.000000', 'temperatura', 206.0000, 'ºC'),
	(37472, 109, '2015-02-01 00:30:14.000000', 'temperatura', 138.0000, 'ºC'),
	(37473, 109, '2015-02-01 00:30:15.000000', 'temperatura', 72.0000, 'ºC'),
	(37474, 109, '2015-02-01 00:30:16.000000', 'temperatura', 1148.0000, 'ºC'),
	(37475, 109, '2015-02-01 00:30:17.000000', 'temperatura', 724.0000, 'ºC'),
	(37476, 109, '2015-02-01 00:30:18.000000', 'temperatura', 178.0000, 'ºC'),
	(37477, 109, '2015-02-01 00:30:19.000000', 'temperatura', 1118.0000, 'ºC'),
	(37478, 109, '2015-02-01 00:30:20.000000', 'temperatura', 257.0000, 'ºC'),
	(37479, 109, '2015-02-01 00:30:21.000000', 'temperatura', 331.0000, 'ºC'),
	(37480, 109, '2015-02-01 00:30:22.000000', 'temperatura', 885.0000, 'ºC'),
	(37481, 109, '2015-02-01 00:30:23.000000', 'temperatura', 1032.0000, 'ºC'),
	(37482, 109, '2015-02-01 00:30:24.000000', 'temperatura', 105.0000, 'ºC'),
	(37483, 109, '2015-02-01 00:30:25.000000', 'temperatura', 1032.0000, 'ºC'),
	(37484, 109, '2015-02-01 00:30:26.000000', 'temperatura', 43.0000, 'ºC'),
	(37485, 109, '2015-02-01 00:30:27.000000', 'temperatura', 719.0000, 'ºC'),
	(37486, 109, '2015-02-01 00:30:28.000000', 'temperatura', 1068.0000, 'ºC'),
	(37487, 109, '2015-02-01 00:30:29.000000', 'temperatura', 781.0000, 'ºC'),
	(37488, 109, '2015-02-01 00:30:30.000000', 'temperatura', 704.0000, 'ºC'),
	(37489, 109, '2015-02-01 00:30:31.000000', 'temperatura', 1177.0000, 'ºC'),
	(37490, 109, '2015-02-01 00:30:32.000000', 'temperatura', 173.0000, 'ºC'),
	(37491, 109, '2015-02-01 00:30:33.000000', 'temperatura', 935.0000, 'ºC'),
	(37492, 109, '2015-02-01 00:30:34.000000', 'temperatura', 556.0000, 'ºC'),
	(37493, 109, '2015-02-01 00:30:35.000000', 'temperatura', 1177.0000, 'ºC'),
	(37494, 109, '2015-02-01 00:30:36.000000', 'temperatura', 615.0000, 'ºC'),
	(37495, 109, '2015-02-01 00:30:37.000000', 'temperatura', 745.0000, 'ºC'),
	(37496, 109, '2015-02-01 00:30:38.000000', 'temperatura', 682.0000, 'ºC'),
	(37497, 109, '2015-02-01 00:30:39.000000', 'temperatura', 1173.0000, 'ºC'),
	(37498, 109, '2015-02-01 00:30:40.000000', 'temperatura', 222.0000, 'ºC'),
	(37499, 109, '2015-02-01 00:30:41.000000', 'temperatura', 1191.0000, 'ºC'),
	(37500, 109, '2015-02-01 00:30:42.000000', 'temperatura', 489.0000, 'ºC'),
	(37501, 109, '2015-02-01 00:30:43.000000', 'temperatura', 74.0000, 'ºC'),
	(37502, 109, '2015-02-01 00:30:44.000000', 'temperatura', 103.0000, 'ºC'),
	(37503, 109, '2015-02-01 00:30:45.000000', 'temperatura', 294.0000, 'ºC'),
	(37504, 109, '2015-02-01 00:30:46.000000', 'temperatura', 1161.0000, 'ºC'),
	(37505, 109, '2015-02-01 00:30:47.000000', 'temperatura', 124.0000, 'ºC'),
	(37506, 109, '2015-02-01 00:30:48.000000', 'temperatura', 735.0000, 'ºC'),
	(37507, 109, '2015-02-01 00:30:49.000000', 'temperatura', 906.0000, 'ºC'),
	(37508, 109, '2015-02-01 00:30:50.000000', 'temperatura', 1126.0000, 'ºC'),
	(37509, 109, '2015-02-01 00:30:51.000000', 'temperatura', 513.0000, 'ºC'),
	(37510, 109, '2015-02-01 00:30:52.000000', 'temperatura', 387.0000, 'ºC'),
	(37511, 109, '2015-02-01 00:30:53.000000', 'temperatura', 397.0000, 'ºC'),
	(37512, 109, '2015-02-01 00:30:54.000000', 'temperatura', 826.0000, 'ºC'),
	(37513, 109, '2015-02-01 00:30:55.000000', 'temperatura', 536.0000, 'ºC'),
	(37514, 109, '2015-02-01 00:30:56.000000', 'temperatura', 204.0000, 'ºC'),
	(37515, 109, '2015-02-01 00:30:57.000000', 'temperatura', 614.0000, 'ºC'),
	(37516, 109, '2015-02-01 00:30:58.000000', 'temperatura', 58.0000, 'ºC'),
	(37517, 109, '2015-02-01 00:30:59.000000', 'temperatura', 849.0000, 'ºC'),
	(37518, 109, '2015-02-01 00:31:00.000000', 'temperatura', 470.0000, 'ºC'),
	(37519, 109, '2015-02-01 00:31:01.000000', 'temperatura', 1005.0000, 'ºC'),
	(37520, 109, '2015-02-01 00:31:02.000000', 'temperatura', 14.0000, 'ºC'),
	(37521, 109, '2015-02-01 00:31:03.000000', 'temperatura', 655.0000, 'ºC'),
	(37522, 109, '2015-02-01 00:31:04.000000', 'temperatura', 832.0000, 'ºC'),
	(37523, 109, '2015-02-01 00:31:05.000000', 'temperatura', 998.0000, 'ºC'),
	(37524, 109, '2015-02-01 00:31:06.000000', 'temperatura', 94.0000, 'ºC'),
	(37525, 109, '2015-02-01 00:31:07.000000', 'temperatura', 1075.0000, 'ºC'),
	(37526, 109, '2015-02-01 00:31:08.000000', 'temperatura', 293.0000, 'ºC'),
	(37527, 109, '2015-02-01 00:31:09.000000', 'temperatura', 643.0000, 'ºC'),
	(37528, 109, '2015-02-01 00:31:10.000000', 'temperatura', 1135.0000, 'ºC'),
	(37529, 109, '2015-02-01 00:31:11.000000', 'temperatura', 147.0000, 'ºC'),
	(37530, 109, '2015-02-01 00:31:12.000000', 'temperatura', 929.0000, 'ºC'),
	(37531, 109, '2015-02-01 00:31:13.000000', 'temperatura', 604.0000, 'ºC'),
	(37532, 109, '2015-02-01 00:31:14.000000', 'temperatura', 235.0000, 'ºC'),
	(37533, 109, '2015-02-01 00:31:15.000000', 'temperatura', 565.0000, 'ºC'),
	(37534, 109, '2015-02-01 00:31:16.000000', 'temperatura', 918.0000, 'ºC'),
	(37535, 109, '2015-02-01 00:31:17.000000', 'temperatura', 497.0000, 'ºC'),
	(37536, 109, '2015-02-01 00:31:18.000000', 'temperatura', 933.0000, 'ºC'),
	(37537, 109, '2015-02-01 00:31:19.000000', 'temperatura', 772.0000, 'ºC'),
	(37538, 109, '2015-02-01 00:31:20.000000', 'temperatura', 1064.0000, 'ºC'),
	(37539, 109, '2015-02-01 00:31:21.000000', 'temperatura', 604.0000, 'ºC'),
	(37540, 109, '2015-02-01 00:31:22.000000', 'temperatura', 1027.0000, 'ºC'),
	(37541, 109, '2015-02-01 00:31:23.000000', 'temperatura', 922.0000, 'ºC'),
	(37542, 109, '2015-02-01 00:31:24.000000', 'temperatura', 332.0000, 'ºC'),
	(37543, 109, '2015-02-01 00:31:25.000000', 'temperatura', 96.0000, 'ºC'),
	(37544, 109, '2015-02-01 00:31:26.000000', 'temperatura', 682.0000, 'ºC'),
	(37545, 109, '2015-02-01 00:31:27.000000', 'temperatura', 724.0000, 'ºC'),
	(37546, 109, '2015-02-01 00:31:28.000000', 'temperatura', 373.0000, 'ºC'),
	(37547, 109, '2015-02-01 00:31:29.000000', 'temperatura', 894.0000, 'ºC'),
	(37548, 109, '2015-02-01 00:31:30.000000', 'temperatura', 949.0000, 'ºC'),
	(37549, 109, '2015-02-01 00:31:31.000000', 'temperatura', 867.0000, 'ºC'),
	(37550, 109, '2015-02-01 00:31:32.000000', 'temperatura', 289.0000, 'ºC'),
	(37551, 109, '2015-02-01 00:31:33.000000', 'temperatura', 43.0000, 'ºC'),
	(37552, 109, '2015-02-01 00:31:34.000000', 'temperatura', 548.0000, 'ºC'),
	(37553, 109, '2015-02-01 00:31:35.000000', 'temperatura', 213.0000, 'ºC'),
	(37554, 109, '2015-02-01 00:31:36.000000', 'temperatura', 620.0000, 'ºC'),
	(37555, 109, '2015-02-01 00:31:37.000000', 'temperatura', 62.0000, 'ºC'),
	(37556, 109, '2015-02-01 00:31:38.000000', 'temperatura', 850.0000, 'ºC'),
	(37557, 109, '2015-02-01 00:31:39.000000', 'temperatura', 463.0000, 'ºC'),
	(37558, 109, '2015-02-01 00:31:40.000000', 'temperatura', 967.0000, 'ºC'),
	(37559, 109, '2015-02-01 00:31:41.000000', 'temperatura', 1045.0000, 'ºC'),
	(37560, 109, '2015-02-01 00:31:42.000000', 'temperatura', 1124.0000, 'ºC'),
	(37561, 109, '2015-02-01 00:31:43.000000', 'temperatura', 87.0000, 'ºC'),
	(37562, 109, '2015-02-01 00:31:44.000000', 'temperatura', 662.0000, 'ºC'),
	(37563, 109, '2015-02-01 00:31:45.000000', 'temperatura', 651.0000, 'ºC'),
	(37564, 109, '2015-02-01 00:31:46.000000', 'temperatura', 67.0000, 'ºC'),
	(37565, 109, '2015-02-01 00:31:47.000000', 'temperatura', 784.0000, 'ºC'),
	(37566, 109, '2015-02-01 00:31:48.000000', 'temperatura', 118.0000, 'ºC'),
	(37567, 109, '2015-02-01 00:31:49.000000', 'temperatura', 638.0000, 'ºC'),
	(37568, 109, '2015-02-01 00:31:50.000000', 'temperatura', 437.0000, 'ºC'),
	(37569, 109, '2015-02-01 00:31:51.000000', 'temperatura', 271.0000, 'ºC'),
	(37570, 109, '2015-02-01 00:31:52.000000', 'temperatura', 44.0000, 'ºC'),
	(37571, 109, '2015-02-01 00:31:53.000000', 'temperatura', 610.0000, 'ºC'),
	(37572, 109, '2015-02-01 00:31:54.000000', 'temperatura', 516.0000, 'ºC'),
	(37573, 109, '2015-02-01 00:31:55.000000', 'temperatura', 752.0000, 'ºC'),
	(37574, 109, '2015-02-01 00:31:56.000000', 'temperatura', 1014.0000, 'ºC'),
	(37575, 109, '2015-02-01 00:31:57.000000', 'temperatura', 412.0000, 'ºC'),
	(37576, 109, '2015-02-01 00:31:58.000000', 'temperatura', 219.0000, 'ºC'),
	(37577, 109, '2015-02-01 00:31:59.000000', 'temperatura', 1062.0000, 'ºC'),
	(37578, 109, '2015-02-01 00:32:00.000000', 'temperatura', 1051.0000, 'ºC'),
	(37579, 109, '2015-02-01 00:32:01.000000', 'temperatura', 869.0000, 'ºC'),
	(37580, 109, '2015-02-01 00:32:02.000000', 'temperatura', 1191.0000, 'ºC'),
	(37581, 109, '2015-02-01 00:32:03.000000', 'temperatura', 952.0000, 'ºC'),
	(37582, 109, '2015-02-01 00:32:04.000000', 'temperatura', 1185.0000, 'ºC'),
	(37583, 109, '2015-02-01 00:32:05.000000', 'temperatura', 671.0000, 'ºC'),
	(37584, 109, '2015-02-01 00:32:06.000000', 'temperatura', 999.0000, 'ºC'),
	(37585, 109, '2015-02-01 00:32:07.000000', 'temperatura', 582.0000, 'ºC'),
	(37586, 109, '2015-02-01 00:32:08.000000', 'temperatura', 1115.0000, 'ºC'),
	(37587, 109, '2015-02-01 00:32:09.000000', 'temperatura', 229.0000, 'ºC'),
	(37588, 109, '2015-02-01 00:32:10.000000', 'temperatura', 200.0000, 'ºC'),
	(37589, 109, '2015-02-01 00:32:11.000000', 'temperatura', 315.0000, 'ºC'),
	(37590, 109, '2015-02-01 00:32:12.000000', 'temperatura', 973.0000, 'ºC'),
	(37591, 109, '2015-02-01 00:32:13.000000', 'temperatura', 324.0000, 'ºC'),
	(37592, 109, '2015-02-01 00:32:14.000000', 'temperatura', 1099.0000, 'ºC'),
	(37593, 109, '2015-02-01 00:32:15.000000', 'temperatura', 922.0000, 'ºC'),
	(37594, 109, '2015-02-01 00:32:16.000000', 'temperatura', 116.0000, 'ºC'),
	(37595, 109, '2015-02-01 00:32:17.000000', 'temperatura', 212.0000, 'ºC'),
	(37596, 109, '2015-02-01 00:32:18.000000', 'temperatura', 714.0000, 'ºC'),
	(37597, 109, '2015-02-01 00:32:19.000000', 'temperatura', 533.0000, 'ºC'),
	(37598, 109, '2015-02-01 00:32:20.000000', 'temperatura', 523.0000, 'ºC'),
	(37599, 109, '2015-02-01 00:32:21.000000', 'temperatura', 1018.0000, 'ºC'),
	(37600, 109, '2015-02-01 00:32:22.000000', 'temperatura', 1121.0000, 'ºC'),
	(37601, 109, '2015-02-01 00:32:23.000000', 'temperatura', 153.0000, 'ºC'),
	(37602, 109, '2015-02-01 00:32:24.000000', 'temperatura', 1001.0000, 'ºC'),
	(37603, 109, '2015-02-01 00:32:25.000000', 'temperatura', 947.0000, 'ºC'),
	(37604, 109, '2015-02-01 00:32:26.000000', 'temperatura', 533.0000, 'ºC'),
	(37605, 109, '2015-02-01 00:32:27.000000', 'temperatura', 1026.0000, 'ºC'),
	(37606, 109, '2015-02-01 00:32:28.000000', 'temperatura', 1131.0000, 'ºC'),
	(37607, 109, '2015-02-01 00:32:29.000000', 'temperatura', 175.0000, 'ºC'),
	(37608, 109, '2015-02-01 00:32:30.000000', 'temperatura', 1083.0000, 'ºC'),
	(37609, 109, '2015-02-01 00:32:31.000000', 'temperatura', 92.0000, 'ºC'),
	(37610, 109, '2015-02-01 00:32:32.000000', 'temperatura', 810.0000, 'ºC'),
	(37611, 109, '2015-02-01 00:32:33.000000', 'temperatura', 177.0000, 'ºC'),
	(37612, 109, '2015-02-01 00:32:34.000000', 'temperatura', 854.0000, 'ºC'),
	(37613, 109, '2015-02-01 00:32:35.000000', 'temperatura', 142.0000, 'ºC'),
	(37614, 109, '2015-02-01 00:32:36.000000', 'temperatura', 545.0000, 'ºC'),
	(37615, 109, '2015-02-01 00:32:37.000000', 'temperatura', 1101.0000, 'ºC'),
	(37616, 109, '2015-02-01 00:32:38.000000', 'temperatura', 269.0000, 'ºC'),
	(37617, 109, '2015-02-01 00:32:39.000000', 'temperatura', 443.0000, 'ºC'),
	(37618, 109, '2015-02-01 00:32:40.000000', 'temperatura', 208.0000, 'ºC'),
	(37619, 109, '2015-02-01 00:32:41.000000', 'temperatura', 912.0000, 'ºC'),
	(37620, 109, '2015-02-01 00:32:42.000000', 'temperatura', 336.0000, 'ºC'),
	(37621, 109, '2015-02-01 00:32:43.000000', 'temperatura', 145.0000, 'ºC'),
	(37622, 109, '2015-02-01 00:32:44.000000', 'temperatura', 917.0000, 'ºC'),
	(37623, 109, '2015-02-01 00:32:45.000000', 'temperatura', 551.0000, 'ºC'),
	(37624, 109, '2015-02-01 00:32:46.000000', 'temperatura', 4.0000, 'ºC'),
	(37625, 109, '2015-02-01 00:32:47.000000', 'temperatura', 767.0000, 'ºC'),
	(37626, 109, '2015-02-01 00:32:48.000000', 'temperatura', 225.0000, 'ºC'),
	(37627, 109, '2015-02-01 00:32:49.000000', 'temperatura', 23.0000, 'ºC'),
	(37628, 109, '2015-02-01 00:32:50.000000', 'temperatura', 642.0000, 'ºC'),
	(37629, 109, '2015-02-01 00:32:51.000000', 'temperatura', 739.0000, 'ºC'),
	(37630, 109, '2015-02-01 00:32:52.000000', 'temperatura', 572.0000, 'ºC'),
	(37631, 109, '2015-02-01 00:32:53.000000', 'temperatura', 642.0000, 'ºC'),
	(37632, 109, '2015-02-01 00:32:54.000000', 'temperatura', 296.0000, 'ºC'),
	(37633, 109, '2015-02-01 00:32:55.000000', 'temperatura', 752.0000, 'ºC'),
	(37634, 109, '2015-02-01 00:32:56.000000', 'temperatura', 475.0000, 'ºC'),
	(37635, 109, '2015-02-01 00:32:57.000000', 'temperatura', 119.0000, 'ºC'),
	(37636, 109, '2015-02-01 00:32:58.000000', 'temperatura', 371.0000, 'ºC'),
	(37637, 109, '2015-02-01 00:32:59.000000', 'temperatura', 296.0000, 'ºC'),
	(37638, 109, '2015-02-01 00:33:00.000000', 'temperatura', 370.0000, 'ºC'),
	(37639, 109, '2015-02-01 00:33:01.000000', 'temperatura', 961.0000, 'ºC'),
	(37640, 109, '2015-02-01 00:33:02.000000', 'temperatura', 96.0000, 'ºC'),
	(37641, 109, '2015-02-01 00:33:03.000000', 'temperatura', 1196.0000, 'ºC'),
	(37642, 109, '2015-02-01 00:33:04.000000', 'temperatura', 895.0000, 'ºC'),
	(37643, 109, '2015-02-01 00:33:05.000000', 'temperatura', 887.0000, 'ºC'),
	(37644, 109, '2015-02-01 00:33:06.000000', 'temperatura', 550.0000, 'ºC'),
	(37645, 109, '2015-02-01 00:33:07.000000', 'temperatura', 88.0000, 'ºC'),
	(37646, 109, '2015-02-01 00:33:08.000000', 'temperatura', 1192.0000, 'ºC'),
	(37647, 109, '2015-02-01 00:33:09.000000', 'temperatura', 895.0000, 'ºC'),
	(37648, 109, '2015-02-01 00:33:10.000000', 'temperatura', 902.0000, 'ºC'),
	(37649, 109, '2015-02-01 00:33:11.000000', 'temperatura', 624.0000, 'ºC'),
	(37650, 109, '2015-02-01 00:33:12.000000', 'temperatura', 415.0000, 'ºC'),
	(37651, 109, '2015-02-01 00:33:13.000000', 'temperatura', 201.0000, 'ºC'),
	(37652, 109, '2015-02-01 00:33:14.000000', 'temperatura', 964.0000, 'ºC'),
	(37653, 109, '2015-02-01 00:33:15.000000', 'temperatura', 616.0000, 'ºC'),
	(37654, 109, '2015-02-01 00:33:16.000000', 'temperatura', 186.0000, 'ºC'),
	(37655, 109, '2015-02-01 00:33:17.000000', 'temperatura', 286.0000, 'ºC'),
	(37656, 109, '2015-02-01 00:33:18.000000', 'temperatura', 873.0000, 'ºC'),
	(37657, 109, '2015-02-01 00:33:19.000000', 'temperatura', 1107.0000, 'ºC'),
	(37658, 109, '2015-02-01 00:33:20.000000', 'temperatura', 518.0000, 'ºC'),
	(37659, 109, '2015-02-01 00:33:21.000000', 'temperatura', 466.0000, 'ºC'),
	(37660, 109, '2015-02-01 00:33:22.000000', 'temperatura', 780.0000, 'ºC'),
	(37661, 109, '2015-02-01 00:33:23.000000', 'temperatura', 99.0000, 'ºC'),
	(37662, 109, '2015-02-01 00:33:24.000000', 'temperatura', 558.0000, 'ºC'),
	(37663, 109, '2015-02-01 00:33:25.000000', 'temperatura', 91.0000, 'ºC'),
	(37664, 109, '2015-02-01 00:33:26.000000', 'temperatura', 1183.0000, 'ºC'),
	(37665, 109, '2015-02-01 00:33:27.000000', 'temperatura', 843.0000, 'ºC'),
	(37666, 109, '2015-02-01 00:33:28.000000', 'temperatura', 667.0000, 'ºC'),
	(37667, 109, '2015-02-01 00:33:29.000000', 'temperatura', 808.0000, 'ºC'),
	(37668, 109, '2015-02-01 00:33:30.000000', 'temperatura', 837.0000, 'ºC'),
	(37669, 109, '2015-02-01 00:33:31.000000', 'temperatura', 561.0000, 'ºC'),
	(37670, 109, '2015-02-01 00:33:32.000000', 'temperatura', 294.0000, 'ºC'),
	(37671, 109, '2015-02-01 00:33:33.000000', 'temperatura', 990.0000, 'ºC'),
	(37672, 109, '2015-02-01 00:33:34.000000', 'temperatura', 468.0000, 'ºC'),
	(37673, 109, '2015-02-01 00:33:35.000000', 'temperatura', 571.0000, 'ºC'),
	(37674, 109, '2015-02-01 00:33:36.000000', 'temperatura', 250.0000, 'ºC'),
	(37675, 109, '2015-02-01 00:33:37.000000', 'temperatura', 737.0000, 'ºC'),
	(37676, 109, '2015-02-01 00:33:38.000000', 'temperatura', 535.0000, 'ºC'),
	(37677, 109, '2015-02-01 00:33:39.000000', 'temperatura', 464.0000, 'ºC'),
	(37678, 109, '2015-02-01 00:33:40.000000', 'temperatura', 716.0000, 'ºC'),
	(37679, 109, '2015-02-01 00:33:41.000000', 'temperatura', 988.0000, 'ºC'),
	(37680, 109, '2015-02-01 00:33:42.000000', 'temperatura', 391.0000, 'ºC'),
	(37681, 109, '2015-02-01 00:33:43.000000', 'temperatura', 193.0000, 'ºC'),
	(37682, 109, '2015-02-01 00:33:44.000000', 'temperatura', 993.0000, 'ºC'),
	(37683, 109, '2015-02-01 00:33:45.000000', 'temperatura', 786.0000, 'ºC'),
	(37684, 109, '2015-02-01 00:33:46.000000', 'temperatura', 951.0000, 'ºC'),
	(37685, 109, '2015-02-01 00:33:47.000000', 'temperatura', 1197.0000, 'ºC'),
	(37686, 109, '2015-02-01 00:33:48.000000', 'temperatura', 732.0000, 'ºC'),
	(37687, 109, '2015-02-01 00:33:49.000000', 'temperatura', 70.0000, 'ºC'),
	(37688, 109, '2015-02-01 00:33:50.000000', 'temperatura', 553.0000, 'ºC'),
	(37689, 109, '2015-02-01 00:33:51.000000', 'temperatura', 158.0000, 'ºC'),
	(37690, 109, '2015-02-01 00:33:52.000000', 'temperatura', 329.0000, 'ºC'),
	(37691, 109, '2015-02-01 00:33:53.000000', 'temperatura', 1172.0000, 'ºC'),
	(37692, 109, '2015-02-01 00:33:54.000000', 'temperatura', 75.0000, 'ºC'),
	(37693, 109, '2015-02-01 00:33:55.000000', 'temperatura', 458.0000, 'ºC'),
	(37694, 109, '2015-02-01 00:33:56.000000', 'temperatura', 865.0000, 'ºC'),
	(37695, 109, '2015-02-01 00:33:57.000000', 'temperatura', 553.0000, 'ºC'),
	(37696, 109, '2015-02-01 00:33:58.000000', 'temperatura', 169.0000, 'ºC'),
	(37697, 109, '2015-02-01 00:33:59.000000', 'temperatura', 388.0000, 'ºC'),
	(37698, 109, '2015-02-01 00:34:00.000000', 'temperatura', 234.0000, 'ºC'),
	(37699, 109, '2015-02-01 00:34:01.000000', 'temperatura', 5.0000, 'ºC'),
	(37700, 109, '2015-02-01 00:34:02.000000', 'temperatura', 522.0000, 'ºC'),
	(37701, 109, '2015-02-01 00:34:03.000000', 'temperatura', 198.0000, 'ºC'),
	(37702, 109, '2015-02-01 00:34:04.000000', 'temperatura', 623.0000, 'ºC'),
	(37703, 109, '2015-02-01 00:34:05.000000', 'temperatura', 124.0000, 'ºC'),
	(37704, 109, '2015-02-01 00:34:06.000000', 'temperatura', 1150.0000, 'ºC'),
	(37705, 109, '2015-02-01 00:34:07.000000', 'temperatura', 580.0000, 'ºC'),
	(37706, 109, '2015-02-01 00:34:08.000000', 'temperatura', 651.0000, 'ºC'),
	(37707, 109, '2015-02-01 00:34:09.000000', 'temperatura', 315.0000, 'ºC'),
	(37708, 109, '2015-02-01 00:34:10.000000', 'temperatura', 823.0000, 'ºC'),
	(37709, 109, '2015-02-01 00:34:11.000000', 'temperatura', 770.0000, 'ºC'),
	(37710, 109, '2015-02-01 00:34:12.000000', 'temperatura', 180.0000, 'ºC'),
	(37711, 109, '2015-02-01 00:34:13.000000', 'temperatura', 990.0000, 'ºC'),
	(37712, 109, '2015-02-01 00:34:14.000000', 'temperatura', 812.0000, 'ºC'),
	(37713, 109, '2015-02-01 00:34:15.000000', 'temperatura', 1089.0000, 'ºC'),
	(37714, 109, '2015-02-01 00:34:16.000000', 'temperatura', 611.0000, 'ºC'),
	(37715, 109, '2015-02-01 00:34:17.000000', 'temperatura', 990.0000, 'ºC'),
	(37716, 109, '2015-02-01 00:34:18.000000', 'temperatura', 717.0000, 'ºC'),
	(37717, 109, '2015-02-01 00:34:19.000000', 'temperatura', 613.0000, 'ºC'),
	(37718, 109, '2015-02-01 00:34:20.000000', 'temperatura', 916.0000, 'ºC'),
	(37719, 109, '2015-02-01 00:34:21.000000', 'temperatura', 342.0000, 'ºC'),
	(37720, 109, '2015-02-01 00:34:22.000000', 'temperatura', 162.0000, 'ºC'),
	(37721, 109, '2015-02-01 00:34:23.000000', 'temperatura', 986.0000, 'ºC'),
	(37722, 109, '2015-02-01 00:34:24.000000', 'temperatura', 843.0000, 'ºC'),
	(37723, 109, '2015-02-01 00:34:25.000000', 'temperatura', 58.0000, 'ºC'),
	(37724, 109, '2015-02-01 00:34:26.000000', 'temperatura', 160.0000, 'ºC'),
	(37725, 109, '2015-02-01 00:34:27.000000', 'temperatura', 627.0000, 'ºC'),
	(37726, 109, '2015-02-01 00:34:28.000000', 'temperatura', 257.0000, 'ºC'),
	(37727, 109, '2015-02-01 00:34:29.000000', 'temperatura', 605.0000, 'ºC'),
	(37728, 109, '2015-02-01 00:34:30.000000', 'temperatura', 1053.0000, 'ºC'),
	(37729, 109, '2015-02-01 00:34:31.000000', 'temperatura', 1049.0000, 'ºC'),
	(37730, 109, '2015-02-01 00:34:32.000000', 'temperatura', 887.0000, 'ºC'),
	(37731, 109, '2015-02-01 00:34:33.000000', 'temperatura', 89.0000, 'ºC'),
	(37732, 109, '2015-02-01 00:34:34.000000', 'temperatura', 183.0000, 'ºC'),
	(37733, 109, '2015-02-01 00:34:35.000000', 'temperatura', 648.0000, 'ºC'),
	(37734, 109, '2015-02-01 00:34:36.000000', 'temperatura', 292.0000, 'ºC'),
	(37735, 109, '2015-02-01 00:34:37.000000', 'temperatura', 717.0000, 'ºC'),
	(37736, 109, '2015-02-01 00:34:38.000000', 'temperatura', 310.0000, 'ºC'),
	(37737, 109, '2015-02-01 00:34:39.000000', 'temperatura', 600.0000, 'ºC'),
	(37738, 109, '2015-02-01 00:34:40.000000', 'temperatura', 868.0000, 'ºC'),
	(37739, 109, '2015-02-01 00:34:41.000000', 'temperatura', 142.0000, 'ºC'),
	(37740, 109, '2015-02-01 00:34:42.000000', 'temperatura', 508.0000, 'ºC'),
	(37741, 109, '2015-02-01 00:34:43.000000', 'temperatura', 915.0000, 'ºC'),
	(37742, 109, '2015-02-01 00:34:44.000000', 'temperatura', 650.0000, 'ºC'),
	(37743, 109, '2015-02-01 00:34:45.000000', 'temperatura', 506.0000, 'ºC'),
	(37744, 109, '2015-02-01 00:34:46.000000', 'temperatura', 580.0000, 'ºC'),
	(37745, 109, '2015-02-01 00:34:47.000000', 'temperatura', 183.0000, 'ºC'),
	(37746, 109, '2015-02-01 00:34:48.000000', 'temperatura', 377.0000, 'ºC'),
	(37747, 109, '2015-02-01 00:34:49.000000', 'temperatura', 135.0000, 'ºC'),
	(37748, 109, '2015-02-01 00:34:50.000000', 'temperatura', 746.0000, 'ºC'),
	(37749, 109, '2015-02-01 00:34:51.000000', 'temperatura', 923.0000, 'ºC'),
	(37750, 109, '2015-02-01 00:34:52.000000', 'temperatura', 1180.0000, 'ºC'),
	(37751, 109, '2015-02-01 00:34:53.000000', 'temperatura', 729.0000, 'ºC'),
	(37752, 109, '2015-02-01 00:34:54.000000', 'temperatura', 106.0000, 'ºC'),
	(37753, 109, '2015-02-01 00:34:55.000000', 'temperatura', 743.0000, 'ºC'),
	(37754, 109, '2015-02-01 00:34:56.000000', 'temperatura', 998.0000, 'ºC'),
	(37755, 109, '2015-02-01 00:34:57.000000', 'temperatura', 363.0000, 'ºC'),
	(37756, 109, '2015-02-01 00:34:58.000000', 'temperatura', 21.0000, 'ºC'),
	(37757, 109, '2015-02-01 00:34:59.000000', 'temperatura', 216.0000, 'ºC'),
	(37758, 109, '2015-02-01 00:35:00.000000', 'temperatura', 1018.0000, 'ºC'),
	(37759, 109, '2015-02-01 00:35:01.000000', 'temperatura', 843.0000, 'ºC'),
	(37760, 109, '2015-02-01 00:35:02.000000', 'temperatura', 1160.0000, 'ºC'),
	(37761, 109, '2015-02-01 00:35:03.000000', 'temperatura', 871.0000, 'ºC'),
	(37762, 109, '2015-02-01 00:35:04.000000', 'temperatura', 876.0000, 'ºC'),
	(37763, 109, '2015-02-01 00:35:05.000000', 'temperatura', 570.0000, 'ºC'),
	(37764, 109, '2015-02-01 00:35:06.000000', 'temperatura', 220.0000, 'ºC'),
	(37765, 109, '2015-02-01 00:35:07.000000', 'temperatura', 591.0000, 'ºC'),
	(37766, 109, '2015-02-01 00:35:08.000000', 'temperatura', 1097.0000, 'ºC'),
	(37767, 109, '2015-02-01 00:35:09.000000', 'temperatura', 112.0000, 'ºC'),
	(37768, 109, '2015-02-01 00:35:10.000000', 'temperatura', 869.0000, 'ºC'),
	(37769, 109, '2015-02-01 00:35:11.000000', 'temperatura', 409.0000, 'ºC'),
	(37770, 109, '2015-02-01 00:35:12.000000', 'temperatura', 639.0000, 'ºC'),
	(37771, 109, '2015-02-01 00:35:13.000000', 'temperatura', 767.0000, 'ºC'),
	(37772, 109, '2015-02-01 00:35:14.000000', 'temperatura', 719.0000, 'ºC'),
	(37773, 109, '2015-02-01 00:35:15.000000', 'temperatura', 96.0000, 'ºC'),
	(37774, 109, '2015-02-01 00:35:16.000000', 'temperatura', 724.0000, 'ºC'),
	(37775, 109, '2015-02-01 00:35:17.000000', 'temperatura', 933.0000, 'ºC'),
	(37776, 109, '2015-02-01 00:35:18.000000', 'temperatura', 94.0000, 'ºC'),
	(37777, 109, '2015-02-01 00:35:19.000000', 'temperatura', 72.0000, 'ºC'),
	(37778, 109, '2015-02-01 00:35:20.000000', 'temperatura', 78.0000, 'ºC'),
	(37779, 109, '2015-02-01 00:35:21.000000', 'temperatura', 172.0000, 'ºC'),
	(37780, 109, '2015-02-01 00:35:22.000000', 'temperatura', 630.0000, 'ºC'),
	(37781, 109, '2015-02-01 00:35:23.000000', 'temperatura', 233.0000, 'ºC'),
	(37782, 109, '2015-02-01 00:35:24.000000', 'temperatura', 475.0000, 'ºC'),
	(37783, 109, '2015-02-01 00:35:25.000000', 'temperatura', 475.0000, 'ºC'),
	(37784, 109, '2015-02-01 00:35:26.000000', 'temperatura', 954.0000, 'ºC'),
	(37785, 109, '2015-02-01 00:35:27.000000', 'temperatura', 943.0000, 'ºC'),
	(37786, 109, '2015-02-01 00:35:28.000000', 'temperatura', 655.0000, 'ºC'),
	(37787, 109, '2015-02-01 00:35:29.000000', 'temperatura', 445.0000, 'ºC'),
	(37788, 109, '2015-02-01 00:35:30.000000', 'temperatura', 260.0000, 'ºC'),
	(37789, 109, '2015-02-01 00:35:31.000000', 'temperatura', 1167.0000, 'ºC'),
	(37790, 109, '2015-02-01 00:35:32.000000', 'temperatura', 255.0000, 'ºC'),
	(37791, 109, '2015-02-01 00:35:33.000000', 'temperatura', 176.0000, 'ºC'),
	(37792, 109, '2015-02-01 00:35:34.000000', 'temperatura', 113.0000, 'ºC'),
	(37793, 109, '2015-02-01 00:35:35.000000', 'temperatura', 41.0000, 'ºC'),
	(37794, 109, '2015-02-01 00:35:36.000000', 'temperatura', 1063.0000, 'ºC'),
	(37795, 109, '2015-02-01 00:35:37.000000', 'temperatura', 393.0000, 'ºC'),
	(37796, 109, '2015-02-01 00:35:38.000000', 'temperatura', 1177.0000, 'ºC'),
	(37797, 109, '2015-02-01 00:35:39.000000', 'temperatura', 1107.0000, 'ºC'),
	(37798, 109, '2015-02-01 00:35:40.000000', 'temperatura', 805.0000, 'ºC'),
	(37799, 109, '2015-02-01 00:35:41.000000', 'temperatura', 705.0000, 'ºC'),
	(37800, 109, '2015-02-01 00:35:42.000000', 'temperatura', 1111.0000, 'ºC'),
	(37801, 109, '2015-02-01 00:35:43.000000', 'temperatura', 1040.0000, 'ºC'),
	(37802, 109, '2015-02-01 00:35:44.000000', 'temperatura', 667.0000, 'ºC'),
	(37803, 109, '2015-02-01 00:35:45.000000', 'temperatura', 215.0000, 'ºC'),
	(37804, 109, '2015-02-01 00:35:46.000000', 'temperatura', 277.0000, 'ºC'),
	(37805, 109, '2015-02-01 00:35:47.000000', 'temperatura', 739.0000, 'ºC'),
	(37806, 109, '2015-02-01 00:35:48.000000', 'temperatura', 465.0000, 'ºC'),
	(37807, 109, '2015-02-01 00:35:49.000000', 'temperatura', 106.0000, 'ºC'),
	(37808, 109, '2015-02-01 00:35:50.000000', 'temperatura', 339.0000, 'ºC'),
	(37809, 109, '2015-02-01 00:35:51.000000', 'temperatura', 175.0000, 'ºC'),
	(37810, 109, '2015-02-01 00:35:52.000000', 'temperatura', 1057.0000, 'ºC'),
	(37811, 109, '2015-02-01 00:35:53.000000', 'temperatura', 1164.0000, 'ºC'),
	(37812, 109, '2015-02-01 00:35:54.000000', 'temperatura', 249.0000, 'ºC'),
	(37813, 109, '2015-02-01 00:35:55.000000', 'temperatura', 154.0000, 'ºC'),
	(37814, 109, '2015-02-01 00:35:56.000000', 'temperatura', 22.0000, 'ºC'),
	(37815, 109, '2015-02-01 00:35:57.000000', 'temperatura', 848.0000, 'ºC'),
	(37816, 109, '2015-02-01 00:35:58.000000', 'temperatura', 576.0000, 'ºC'),
	(37817, 109, '2015-02-01 00:35:59.000000', 'temperatura', 337.0000, 'ºC'),
	(37818, 109, '2015-02-01 00:36:00.000000', 'temperatura', 1155.0000, 'ºC'),
	(37819, 109, '2015-02-01 00:36:01.000000', 'temperatura', 1167.0000, 'ºC'),
	(37820, 109, '2015-02-01 00:36:02.000000', 'temperatura', 1171.0000, 'ºC'),
	(37821, 109, '2015-02-01 00:36:03.000000', 'temperatura', 1155.0000, 'ºC'),
	(37822, 109, '2015-02-01 00:36:04.000000', 'temperatura', 1059.0000, 'ºC'),
	(37823, 109, '2015-02-01 00:36:05.000000', 'temperatura', 634.0000, 'ºC'),
	(37824, 109, '2015-02-01 00:36:06.000000', 'temperatura', 1192.0000, 'ºC'),
	(37825, 109, '2015-02-01 00:36:07.000000', 'temperatura', 458.0000, 'ºC'),
	(37826, 109, '2015-02-01 00:36:08.000000', 'temperatura', 1117.0000, 'ºC'),
	(37827, 109, '2015-02-01 00:36:09.000000', 'temperatura', 608.0000, 'ºC'),
	(37828, 109, '2015-02-01 00:36:10.000000', 'temperatura', 892.0000, 'ºC'),
	(37829, 109, '2015-02-01 00:36:11.000000', 'temperatura', 235.0000, 'ºC'),
	(37830, 109, '2015-02-01 00:36:12.000000', 'temperatura', 901.0000, 'ºC'),
	(37831, 109, '2015-02-01 00:36:13.000000', 'temperatura', 201.0000, 'ºC'),
	(37832, 109, '2015-02-01 00:36:14.000000', 'temperatura', 702.0000, 'ºC'),
	(37833, 109, '2015-02-01 00:36:15.000000', 'temperatura', 508.0000, 'ºC'),
	(37834, 109, '2015-02-01 00:36:16.000000', 'temperatura', 435.0000, 'ºC'),
	(37835, 109, '2015-02-01 00:36:17.000000', 'temperatura', 653.0000, 'ºC'),
	(37836, 109, '2015-02-01 00:36:18.000000', 'temperatura', 758.0000, 'ºC'),
	(37837, 109, '2015-02-01 00:36:19.000000', 'temperatura', 632.0000, 'ºC'),
	(37838, 109, '2015-02-01 00:36:20.000000', 'temperatura', 886.0000, 'ºC'),
	(37839, 109, '2015-02-01 00:36:21.000000', 'temperatura', 135.0000, 'ºC'),
	(37840, 109, '2015-02-01 00:36:22.000000', 'temperatura', 419.0000, 'ºC'),
	(37841, 109, '2015-02-01 00:36:23.000000', 'temperatura', 489.0000, 'ºC'),
	(37842, 109, '2015-02-01 00:36:24.000000', 'temperatura', 1188.0000, 'ºC'),
	(37843, 109, '2015-02-01 00:36:25.000000', 'temperatura', 872.0000, 'ºC'),
	(37844, 109, '2015-02-01 00:36:26.000000', 'temperatura', 799.0000, 'ºC'),
	(37845, 109, '2015-02-01 00:36:27.000000', 'temperatura', 178.0000, 'ºC'),
	(37846, 109, '2015-02-01 00:36:28.000000', 'temperatura', 896.0000, 'ºC'),
	(37847, 109, '2015-02-01 00:36:29.000000', 'temperatura', 346.0000, 'ºC'),
	(37848, 109, '2015-02-01 00:36:30.000000', 'temperatura', 241.0000, 'ºC'),
	(37849, 109, '2015-02-01 00:36:31.000000', 'temperatura', 168.0000, 'ºC'),
	(37850, 109, '2015-02-01 00:36:32.000000', 'temperatura', 120.0000, 'ºC'),
	(37851, 109, '2015-02-01 00:36:33.000000', 'temperatura', 93.0000, 'ºC'),
	(37852, 109, '2015-02-01 00:36:34.000000', 'temperatura', 108.0000, 'ºC'),
	(37853, 109, '2015-02-01 00:36:35.000000', 'temperatura', 259.0000, 'ºC'),
	(37854, 109, '2015-02-01 00:36:36.000000', 'temperatura', 975.0000, 'ºC'),
	(37855, 109, '2015-02-01 00:36:37.000000', 'temperatura', 496.0000, 'ºC'),
	(37856, 109, '2015-02-01 00:36:38.000000', 'temperatura', 754.0000, 'ºC'),
	(37857, 109, '2015-02-01 00:36:39.000000', 'temperatura', 1085.0000, 'ºC'),
	(37858, 109, '2015-02-01 00:36:40.000000', 'temperatura', 765.0000, 'ºC'),
	(37859, 109, '2015-02-01 00:36:41.000000', 'temperatura', 569.0000, 'ºC'),
	(37860, 109, '2015-02-01 00:36:42.000000', 'temperatura', 549.0000, 'ºC'),
	(37861, 109, '2015-02-01 00:36:43.000000', 'temperatura', 1039.0000, 'ºC'),
	(37862, 109, '2015-02-01 00:36:44.000000', 'temperatura', 1147.0000, 'ºC'),
	(37863, 109, '2015-02-01 00:36:45.000000', 'temperatura', 221.0000, 'ºC'),
	(37864, 109, '2015-02-01 00:36:46.000000', 'temperatura', 65.0000, 'ºC'),
	(37865, 109, '2015-02-01 00:36:47.000000', 'temperatura', 860.0000, 'ºC'),
	(37866, 109, '2015-02-01 00:36:48.000000', 'temperatura', 505.0000, 'ºC'),
	(37867, 109, '2015-02-01 00:36:49.000000', 'temperatura', 1146.0000, 'ºC'),
	(37868, 109, '2015-02-01 00:36:50.000000', 'temperatura', 617.0000, 'ºC'),
	(37869, 109, '2015-02-01 00:36:51.000000', 'temperatura', 849.0000, 'ºC'),
	(37870, 109, '2015-02-01 00:36:52.000000', 'temperatura', 1192.0000, 'ºC'),
	(37871, 109, '2015-02-01 00:36:53.000000', 'temperatura', 1015.0000, 'ºC'),
	(37872, 109, '2015-02-01 00:36:54.000000', 'temperatura', 300.0000, 'ºC'),
	(37873, 109, '2015-02-01 00:36:55.000000', 'temperatura', 855.0000, 'ºC'),
	(37874, 109, '2015-02-01 00:36:56.000000', 'temperatura', 976.0000, 'ºC'),
	(37875, 109, '2015-02-01 00:36:57.000000', 'temperatura', 1116.0000, 'ºC'),
	(37876, 109, '2015-02-01 00:36:58.000000', 'temperatura', 251.0000, 'ºC'),
	(37877, 109, '2015-02-01 00:36:59.000000', 'temperatura', 310.0000, 'ºC'),
	(37878, 109, '2015-02-01 00:37:00.000000', 'temperatura', 797.0000, 'ºC'),
	(37879, 109, '2015-02-01 00:37:01.000000', 'temperatura', 654.0000, 'ºC'),
	(37880, 109, '2015-02-01 00:37:02.000000', 'temperatura', 880.0000, 'ºC'),
	(37881, 109, '2015-02-01 00:37:03.000000', 'temperatura', 39.0000, 'ºC'),
	(37882, 109, '2015-02-01 00:37:04.000000', 'temperatura', 1153.0000, 'ºC'),
	(37883, 109, '2015-02-01 00:37:05.000000', 'temperatura', 851.0000, 'ºC'),
	(37884, 109, '2015-02-01 00:37:06.000000', 'temperatura', 794.0000, 'ºC'),
	(37885, 109, '2015-02-01 00:37:07.000000', 'temperatura', 218.0000, 'ºC'),
	(37886, 109, '2015-02-01 00:37:08.000000', 'temperatura', 1107.0000, 'ºC'),
	(37887, 109, '2015-02-01 00:37:09.000000', 'temperatura', 84.0000, 'ºC'),
	(37888, 109, '2015-02-01 00:37:10.000000', 'temperatura', 699.0000, 'ºC'),
	(37889, 109, '2015-02-01 00:37:11.000000', 'temperatura', 845.0000, 'ºC'),
	(37890, 109, '2015-02-01 00:37:12.000000', 'temperatura', 926.0000, 'ºC'),
	(37891, 109, '2015-02-01 00:37:13.000000', 'temperatura', 897.0000, 'ºC'),
	(37892, 109, '2015-02-01 00:37:14.000000', 'temperatura', 506.0000, 'ºC'),
	(37893, 109, '2015-02-01 00:37:15.000000', 'temperatura', 1040.0000, 'ºC'),
	(37894, 109, '2015-02-01 00:37:16.000000', 'temperatura', 83.0000, 'ºC'),
	(37895, 109, '2015-02-01 00:37:17.000000', 'temperatura', 897.0000, 'ºC'),
	(37896, 109, '2015-02-01 00:37:18.000000', 'temperatura', 635.0000, 'ºC'),
	(37897, 109, '2015-02-01 00:37:19.000000', 'temperatura', 484.0000, 'ºC'),
	(37898, 109, '2015-02-01 00:37:20.000000', 'temperatura', 515.0000, 'ºC'),
	(37899, 109, '2015-02-01 00:37:21.000000', 'temperatura', 1125.0000, 'ºC'),
	(37900, 109, '2015-02-01 00:37:22.000000', 'temperatura', 480.0000, 'ºC'),
	(37901, 109, '2015-02-01 00:37:23.000000', 'temperatura', 226.0000, 'ºC'),
	(37902, 109, '2015-02-01 00:37:24.000000', 'temperatura', 890.0000, 'ºC'),
	(37903, 109, '2015-02-01 00:37:25.000000', 'temperatura', 174.0000, 'ºC'),
	(37904, 109, '2015-02-01 00:37:26.000000', 'temperatura', 600.0000, 'ºC'),
	(37905, 109, '2015-02-01 00:37:27.000000', 'temperatura', 78.0000, 'ºC'),
	(37906, 109, '2015-02-01 00:37:28.000000', 'temperatura', 989.0000, 'ºC'),
	(37907, 109, '2015-02-01 00:37:29.000000', 'temperatura', 1113.0000, 'ºC'),
	(37908, 109, '2015-02-01 00:37:30.000000', 'temperatura', 197.0000, 'ºC'),
	(37909, 109, '2015-02-01 00:37:31.000000', 'temperatura', 48.0000, 'ºC'),
	(37910, 109, '2015-02-01 00:37:32.000000', 'temperatura', 851.0000, 'ºC'),
	(37911, 109, '2015-02-01 00:37:33.000000', 'temperatura', 508.0000, 'ºC'),
	(37912, 109, '2015-02-01 00:37:34.000000', 'temperatura', 1191.0000, 'ºC'),
	(37913, 109, '2015-02-01 00:37:35.000000', 'temperatura', 829.0000, 'ºC'),
	(37914, 109, '2015-02-01 00:37:36.000000', 'temperatura', 573.0000, 'ºC'),
	(37915, 109, '2015-02-01 00:37:37.000000', 'temperatura', 377.0000, 'ºC'),
	(37916, 109, '2015-02-01 00:37:38.000000', 'temperatura', 169.0000, 'ºC'),
	(37917, 109, '2015-02-01 00:37:39.000000', 'temperatura', 913.0000, 'ºC'),
	(37918, 109, '2015-02-01 00:37:40.000000', 'temperatura', 457.0000, 'ºC'),
	(37919, 109, '2015-02-01 00:37:41.000000', 'temperatura', 748.0000, 'ºC'),
	(37920, 109, '2015-02-01 00:37:42.000000', 'temperatura', 1169.0000, 'ºC'),
	(37921, 109, '2015-02-01 00:37:43.000000', 'temperatura', 1.0000, 'ºC'),
	(37922, 109, '2015-02-01 00:37:44.000000', 'temperatura', 99.0000, 'ºC'),
	(37923, 109, '2015-02-01 00:37:45.000000', 'temperatura', 493.0000, 'ºC'),
	(37924, 109, '2015-02-01 00:37:46.000000', 'temperatura', 967.0000, 'ºC'),
	(37925, 109, '2015-02-01 00:37:47.000000', 'temperatura', 956.0000, 'ºC'),
	(37926, 109, '2015-02-01 00:37:48.000000', 'temperatura', 680.0000, 'ºC'),
	(37927, 109, '2015-02-01 00:37:49.000000', 'temperatura', 533.0000, 'ºC'),
	(37928, 109, '2015-02-01 00:37:50.000000', 'temperatura', 625.0000, 'ºC'),
	(37929, 109, '2015-02-01 00:37:51.000000', 'temperatura', 328.0000, 'ºC'),
	(37930, 109, '2015-02-01 00:37:52.000000', 'temperatura', 964.0000, 'ºC'),
	(37931, 109, '2015-02-01 00:37:53.000000', 'temperatura', 239.0000, 'ºC'),
	(37932, 109, '2015-02-01 00:37:54.000000', 'temperatura', 702.0000, 'ºC'),
	(37933, 109, '2015-02-01 00:37:55.000000', 'temperatura', 394.0000, 'ºC'),
	(37934, 109, '2015-02-01 00:37:56.000000', 'temperatura', 1065.0000, 'ºC'),
	(37935, 109, '2015-02-01 00:37:57.000000', 'temperatura', 542.0000, 'ºC'),
	(37936, 109, '2015-02-01 00:37:58.000000', 'temperatura', 716.0000, 'ºC'),
	(37937, 109, '2015-02-01 00:37:59.000000', 'temperatura', 755.0000, 'ºC'),
	(37938, 109, '2015-02-01 00:38:00.000000', 'temperatura', 427.0000, 'ºC'),
	(37939, 109, '2015-02-01 00:38:01.000000', 'temperatura', 1072.0000, 'ºC'),
	(37940, 109, '2015-02-01 00:38:02.000000', 'temperatura', 478.0000, 'ºC'),
	(37941, 109, '2015-02-01 00:38:03.000000', 'temperatura', 374.0000, 'ºC'),
	(37942, 109, '2015-02-01 00:38:04.000000', 'temperatura', 439.0000, 'ºC'),
	(37943, 109, '2015-02-01 00:38:05.000000', 'temperatura', 1072.0000, 'ºC'),
	(37944, 109, '2015-02-01 00:38:06.000000', 'temperatura', 443.0000, 'ºC'),
	(37945, 109, '2015-02-01 00:38:07.000000', 'temperatura', 202.0000, 'ºC'),
	(37946, 109, '2015-02-01 00:38:08.000000', 'temperatura', 879.0000, 'ºC'),
	(37947, 109, '2015-02-01 00:38:09.000000', 'temperatura', 191.0000, 'ºC'),
	(37948, 109, '2015-02-01 00:38:10.000000', 'temperatura', 716.0000, 'ºC'),
	(37949, 109, '2015-02-01 00:38:11.000000', 'temperatura', 608.0000, 'ºC'),
	(37950, 109, '2015-02-01 00:38:12.000000', 'temperatura', 894.0000, 'ºC'),
	(37951, 109, '2015-02-01 00:38:13.000000', 'temperatura', 247.0000, 'ºC'),
	(37952, 109, '2015-02-01 00:38:14.000000', 'temperatura', 951.0000, 'ºC'),
	(37953, 109, '2015-02-01 00:38:15.000000', 'temperatura', 417.0000, 'ºC'),
	(37954, 109, '2015-02-01 00:38:16.000000', 'temperatura', 432.0000, 'ºC'),
	(37955, 109, '2015-02-01 00:38:17.000000', 'temperatura', 908.0000, 'ºC'),
	(37956, 109, '2015-02-01 00:38:18.000000', 'temperatura', 845.0000, 'ºC'),
	(37957, 109, '2015-02-01 00:38:19.000000', 'temperatura', 303.0000, 'ºC'),
	(37958, 109, '2015-02-01 00:38:20.000000', 'temperatura', 182.0000, 'ºC'),
	(37959, 109, '2015-02-01 00:38:21.000000', 'temperatura', 1198.0000, 'ºC'),
	(37960, 109, '2015-02-01 00:38:22.000000', 'temperatura', 648.0000, 'ºC'),
	(37961, 109, '2015-02-01 00:38:23.000000', 'temperatura', 845.0000, 'ºC'),
	(37962, 109, '2015-02-01 00:38:24.000000', 'temperatura', 1079.0000, 'ºC'),
	(37963, 109, '2015-02-01 00:38:25.000000', 'temperatura', 464.0000, 'ºC'),
	(37964, 109, '2015-02-01 00:38:26.000000', 'temperatura', 283.0000, 'ºC'),
	(37965, 109, '2015-02-01 00:38:27.000000', 'temperatura', 21.0000, 'ºC'),
	(37966, 109, '2015-02-01 00:38:28.000000', 'temperatura', 458.0000, 'ºC'),
	(37967, 109, '2015-02-01 00:38:29.000000', 'temperatura', 1027.0000, 'ºC'),
	(37968, 109, '2015-02-01 00:38:30.000000', 'temperatura', 162.0000, 'ºC'),
	(37969, 109, '2015-02-01 00:38:31.000000', 'temperatura', 128.0000, 'ºC'),
	(37970, 109, '2015-02-01 00:38:32.000000', 'temperatura', 155.0000, 'ºC'),
	(37971, 109, '2015-02-01 00:38:33.000000', 'temperatura', 391.0000, 'ºC'),
	(37972, 109, '2015-02-01 00:38:34.000000', 'temperatura', 291.0000, 'ºC'),
	(37973, 109, '2015-02-01 00:38:35.000000', 'temperatura', 281.0000, 'ºC'),
	(37974, 109, '2015-02-01 00:38:36.000000', 'temperatura', 534.0000, 'ºC'),
	(37975, 109, '2015-02-01 00:38:37.000000', 'temperatura', 627.0000, 'ºC'),
	(37976, 109, '2015-02-01 00:38:38.000000', 'temperatura', 332.0000, 'ºC'),
	(37977, 109, '2015-02-01 00:38:39.000000', 'temperatura', 980.0000, 'ºC'),
	(37978, 109, '2015-02-01 00:38:40.000000', 'temperatura', 304.0000, 'ºC'),
	(37979, 109, '2015-02-01 00:38:41.000000', 'temperatura', 981.0000, 'ºC'),
	(37980, 109, '2015-02-01 00:38:42.000000', 'temperatura', 394.0000, 'ºC'),
	(37981, 109, '2015-02-01 00:38:43.000000', 'temperatura', 227.0000, 'ºC'),
	(37982, 109, '2015-02-01 00:38:44.000000', 'temperatura', 1154.0000, 'ºC'),
	(37983, 109, '2015-02-01 00:38:45.000000', 'temperatura', 288.0000, 'ºC'),
	(37984, 109, '2015-02-01 00:38:46.000000', 'temperatura', 380.0000, 'ºC'),
	(37985, 109, '2015-02-01 00:38:47.000000', 'temperatura', 1035.0000, 'ºC'),
	(37986, 109, '2015-02-01 00:38:48.000000', 'temperatura', 438.0000, 'ºC'),
	(37987, 109, '2015-02-01 00:38:49.000000', 'temperatura', 283.0000, 'ºC'),
	(37988, 109, '2015-02-01 00:38:50.000000', 'temperatura', 103.0000, 'ºC'),
	(37989, 109, '2015-02-01 00:38:51.000000', 'temperatura', 867.0000, 'ºC'),
	(37990, 109, '2015-02-01 00:38:52.000000', 'temperatura', 426.0000, 'ºC'),
	(37991, 109, '2015-02-01 00:38:53.000000', 'temperatura', 731.0000, 'ºC'),
	(37992, 109, '2015-02-01 00:38:54.000000', 'temperatura', 1176.0000, 'ºC'),
	(37993, 109, '2015-02-01 00:38:55.000000', 'temperatura', 86.0000, 'ºC'),
	(37994, 109, '2015-02-01 00:38:56.000000', 'temperatura', 505.0000, 'ºC'),
	(37995, 109, '2015-02-01 00:38:57.000000', 'temperatura', 1065.0000, 'ºC'),
	(37996, 109, '2015-02-01 00:38:58.000000', 'temperatura', 213.0000, 'ºC'),
	(37997, 109, '2015-02-01 00:38:59.000000', 'temperatura', 270.0000, 'ºC'),
	(37998, 109, '2015-02-01 00:39:00.000000', 'temperatura', 712.0000, 'ºC'),
	(37999, 109, '2015-02-01 00:39:01.000000', 'temperatura', 350.0000, 'ºC'),
	(38000, 109, '2015-02-01 00:39:02.000000', 'temperatura', 813.0000, 'ºC'),
	(38001, 109, '2015-02-01 00:39:03.000000', 'temperatura', 618.0000, 'ºC'),
	(38002, 109, '2015-02-01 00:39:04.000000', 'temperatura', 650.0000, 'ºC'),
	(38003, 109, '2015-02-01 00:39:05.000000', 'temperatura', 196.0000, 'ºC'),
	(38004, 109, '2015-02-01 00:39:06.000000', 'temperatura', 233.0000, 'ºC'),
	(38005, 109, '2015-02-01 00:39:07.000000', 'temperatura', 576.0000, 'ºC'),
	(38006, 109, '2015-02-01 00:39:08.000000', 'temperatura', 980.0000, 'ºC'),
	(38007, 109, '2015-02-01 00:39:09.000000', 'temperatura', 774.0000, 'ºC'),
	(38008, 109, '2015-02-01 00:39:10.000000', 'temperatura', 931.0000, 'ºC'),
	(38009, 109, '2015-02-01 00:39:11.000000', 'temperatura', 1133.0000, 'ºC'),
	(38010, 109, '2015-02-01 00:39:12.000000', 'temperatura', 472.0000, 'ºC'),
	(38011, 109, '2015-02-01 00:39:13.000000', 'temperatura', 163.0000, 'ºC'),
	(38012, 109, '2015-02-01 00:39:14.000000', 'temperatura', 597.0000, 'ºC'),
	(38013, 109, '2015-02-01 00:39:15.000000', 'temperatura', 98.0000, 'ºC'),
	(38014, 109, '2015-02-01 00:39:16.000000', 'temperatura', 1100.0000, 'ºC'),
	(38015, 109, '2015-02-01 00:39:17.000000', 'temperatura', 405.0000, 'ºC'),
	(38016, 109, '2015-02-01 00:39:18.000000', 'temperatura', 1125.0000, 'ºC'),
	(38017, 109, '2015-02-01 00:39:19.000000', 'temperatura', 811.0000, 'ºC'),
	(38018, 109, '2015-02-01 00:39:20.000000', 'temperatura', 679.0000, 'ºC'),
	(38019, 109, '2015-02-01 00:39:21.000000', 'temperatura', 965.0000, 'ºC'),
	(38020, 109, '2015-02-01 00:39:22.000000', 'temperatura', 389.0000, 'ºC'),
	(38021, 109, '2015-02-01 00:39:23.000000', 'temperatura', 247.0000, 'ºC'),
	(38022, 109, '2015-02-01 00:39:24.000000', 'temperatura', 72.0000, 'ºC'),
	(38023, 109, '2015-02-01 00:39:25.000000', 'temperatura', 819.0000, 'ºC'),
	(38024, 109, '2015-02-01 00:39:26.000000', 'temperatura', 279.0000, 'ºC'),
	(38025, 109, '2015-02-01 00:39:27.000000', 'temperatura', 138.0000, 'ºC'),
	(38026, 109, '2015-02-01 00:39:28.000000', 'temperatura', 1054.0000, 'ºC'),
	(38027, 109, '2015-02-01 00:39:29.000000', 'temperatura', 58.0000, 'ºC'),
	(38028, 109, '2015-02-01 00:39:30.000000', 'temperatura', 726.0000, 'ºC'),
	(38029, 109, '2015-02-01 00:39:31.000000', 'temperatura', 1056.0000, 'ºC'),
	(38030, 109, '2015-02-01 00:39:32.000000', 'temperatura', 704.0000, 'ºC'),
	(38031, 109, '2015-02-01 00:39:33.000000', 'temperatura', 352.0000, 'ºC'),
	(38032, 109, '2015-02-01 00:39:34.000000', 'temperatura', 849.0000, 'ºC'),
	(38033, 109, '2015-02-01 00:39:35.000000', 'temperatura', 788.0000, 'ºC'),
	(38034, 109, '2015-02-01 00:39:36.000000', 'temperatura', 196.0000, 'ºC'),
	(38035, 109, '2015-02-01 00:39:37.000000', 'temperatura', 1017.0000, 'ºC'),
	(38036, 109, '2015-02-01 00:39:38.000000', 'temperatura', 896.0000, 'ºC'),
	(38037, 109, '2015-02-01 00:39:39.000000', 'temperatura', 228.0000, 'ºC'),
	(38038, 109, '2015-02-01 00:39:40.000000', 'temperatura', 854.0000, 'ºC'),
	(38039, 109, '2015-02-01 00:39:41.000000', 'temperatura', 1187.0000, 'ºC'),
	(38040, 109, '2015-02-01 00:39:42.000000', 'temperatura', 972.0000, 'ºC'),
	(38041, 109, '2015-02-01 00:39:43.000000', 'temperatura', 98.0000, 'ºC'),
	(38042, 109, '2015-02-01 00:39:44.000000', 'temperatura', 1178.0000, 'ºC'),
	(38043, 109, '2015-02-01 00:39:45.000000', 'temperatura', 794.0000, 'ºC'),
	(38044, 109, '2015-02-01 00:39:46.000000', 'temperatura', 435.0000, 'ºC'),
	(38045, 109, '2015-02-01 00:39:47.000000', 'temperatura', 997.0000, 'ºC'),
	(38046, 109, '2015-02-01 00:39:48.000000', 'temperatura', 78.0000, 'ºC'),
	(38047, 109, '2015-02-01 00:39:49.000000', 'temperatura', 1002.0000, 'ºC'),
	(38048, 109, '2015-02-01 00:39:50.000000', 'temperatura', 1175.0000, 'ºC'),
	(38049, 109, '2015-02-01 00:39:51.000000', 'temperatura', 471.0000, 'ºC'),
	(38050, 109, '2015-02-01 00:39:52.000000', 'temperatura', 30.0000, 'ºC'),
	(38051, 109, '2015-02-01 00:39:53.000000', 'temperatura', 1138.0000, 'ºC'),
	(38052, 109, '2015-02-01 00:39:54.000000', 'temperatura', 798.0000, 'ºC'),
	(38053, 109, '2015-02-01 00:39:55.000000', 'temperatura', 578.0000, 'ºC'),
	(38054, 109, '2015-02-01 00:39:56.000000', 'temperatura', 497.0000, 'ºC'),
	(38055, 109, '2015-02-01 00:39:57.000000', 'temperatura', 753.0000, 'ºC'),
	(38056, 109, '2015-02-01 00:39:58.000000', 'temperatura', 1072.0000, 'ºC'),
	(38057, 109, '2015-02-01 00:39:59.000000', 'temperatura', 702.0000, 'ºC'),
	(38058, 109, '2015-02-01 00:40:00.000000', 'temperatura', 295.0000, 'ºC'),
	(38059, 109, '2015-02-01 00:40:01.000000', 'temperatura', 571.0000, 'ºC'),
	(38060, 109, '2015-02-01 00:40:02.000000', 'temperatura', 768.0000, 'ºC'),
	(38061, 109, '2015-02-01 00:40:03.000000', 'temperatura', 928.0000, 'ºC'),
	(38062, 109, '2015-02-01 00:40:04.000000', 'temperatura', 1138.0000, 'ºC'),
	(38063, 109, '2015-02-01 00:40:05.000000', 'temperatura', 504.0000, 'ºC'),
	(38064, 109, '2015-02-01 00:40:06.000000', 'temperatura', 309.0000, 'ºC'),
	(38065, 109, '2015-02-01 00:40:07.000000', 'temperatura', 34.0000, 'ºC'),
	(38066, 109, '2015-02-01 00:40:08.000000', 'temperatura', 441.0000, 'ºC'),
	(38067, 109, '2015-02-01 00:40:09.000000', 'temperatura', 906.0000, 'ºC'),
	(38068, 109, '2015-02-01 00:40:10.000000', 'temperatura', 806.0000, 'ºC'),
	(38069, 109, '2015-02-01 00:40:11.000000', 'temperatura', 113.0000, 'ºC'),
	(38070, 109, '2015-02-01 00:40:12.000000', 'temperatura', 546.0000, 'ºC'),
	(38071, 109, '2015-02-01 00:40:13.000000', 'temperatura', 1194.0000, 'ºC'),
	(38072, 109, '2015-02-01 00:40:14.000000', 'temperatura', 732.0000, 'ºC'),
	(38073, 109, '2015-02-01 00:40:15.000000', 'temperatura', 76.0000, 'ºC'),
	(38074, 109, '2015-02-01 00:40:16.000000', 'temperatura', 588.0000, 'ºC'),
	(38075, 109, '2015-02-01 00:40:17.000000', 'temperatura', 311.0000, 'ºC'),
	(38076, 109, '2015-02-01 00:40:18.000000', 'temperatura', 990.0000, 'ºC'),
	(38077, 109, '2015-02-01 00:40:19.000000', 'temperatura', 418.0000, 'ºC'),
	(38078, 109, '2015-02-01 00:40:20.000000', 'temperatura', 319.0000, 'ºC'),
	(38079, 109, '2015-02-01 00:40:21.000000', 'temperatura', 342.0000, 'ºC'),
	(38080, 109, '2015-02-01 00:40:22.000000', 'temperatura', 756.0000, 'ºC'),
	(38081, 109, '2015-02-01 00:40:23.000000', 'temperatura', 352.0000, 'ºC'),
	(38082, 109, '2015-02-01 00:40:24.000000', 'temperatura', 693.0000, 'ºC'),
	(38083, 109, '2015-02-01 00:40:25.000000', 'temperatura', 11.0000, 'ºC'),
	(38084, 109, '2015-02-01 00:40:26.000000', 'temperatura', 377.0000, 'ºC'),
	(38085, 109, '2015-02-01 00:40:27.000000', 'temperatura', 652.0000, 'ºC'),
	(38086, 109, '2015-02-01 00:40:28.000000', 'temperatura', 928.0000, 'ºC'),
	(38087, 109, '2015-02-01 00:40:29.000000', 'temperatura', 284.0000, 'ºC'),
	(38088, 109, '2015-02-01 00:40:30.000000', 'temperatura', 1039.0000, 'ºC'),
	(38089, 109, '2015-02-01 00:40:31.000000', 'temperatura', 741.0000, 'ºC'),
	(38090, 109, '2015-02-01 00:40:32.000000', 'temperatura', 588.0000, 'ºC'),
	(38091, 109, '2015-02-01 00:40:33.000000', 'temperatura', 717.0000, 'ºC'),
	(38092, 109, '2015-02-01 00:40:34.000000', 'temperatura', 623.0000, 'ºC'),
	(38093, 109, '2015-02-01 00:40:35.000000', 'temperatura', 962.0000, 'ºC'),
	(38094, 109, '2015-02-01 00:40:36.000000', 'temperatura', 545.0000, 'ºC'),
	(38095, 109, '2015-02-01 00:40:37.000000', 'temperatura', 1036.0000, 'ºC'),
	(38096, 109, '2015-02-01 00:40:38.000000', 'temperatura', 1149.0000, 'ºC'),
	(38097, 109, '2015-02-01 00:40:39.000000', 'temperatura', 235.0000, 'ºC'),
	(38098, 109, '2015-02-01 00:40:40.000000', 'temperatura', 130.0000, 'ºC'),
	(38099, 109, '2015-02-01 00:40:41.000000', 'temperatura', 1146.0000, 'ºC'),
	(38100, 109, '2015-02-01 00:40:42.000000', 'temperatura', 540.0000, 'ºC'),
	(38101, 109, '2015-02-01 00:40:43.000000', 'temperatura', 463.0000, 'ºC'),
	(38102, 109, '2015-02-01 00:40:44.000000', 'temperatura', 693.0000, 'ºC'),
	(38103, 109, '2015-02-01 00:40:45.000000', 'temperatura', 879.0000, 'ºC'),
	(38104, 109, '2015-02-01 00:40:46.000000', 'temperatura', 1116.0000, 'ºC'),
	(38105, 109, '2015-02-01 00:40:47.000000', 'temperatura', 541.0000, 'ºC'),
	(38106, 109, '2015-02-01 00:40:48.000000', 'temperatura', 561.0000, 'ºC'),
	(38107, 109, '2015-02-01 00:40:49.000000', 'temperatura', 1181.0000, 'ºC'),
	(38108, 109, '2015-02-01 00:40:50.000000', 'temperatura', 624.0000, 'ºC'),
	(38109, 109, '2015-02-01 00:40:51.000000', 'temperatura', 777.0000, 'ºC'),
	(38110, 109, '2015-02-01 00:40:52.000000', 'temperatura', 813.0000, 'ºC'),
	(38111, 109, '2015-02-01 00:40:53.000000', 'temperatura', 536.0000, 'ºC'),
	(38112, 109, '2015-02-01 00:40:54.000000', 'temperatura', 241.0000, 'ºC'),
	(38113, 109, '2015-02-01 00:40:55.000000', 'temperatura', 797.0000, 'ºC'),
	(38114, 109, '2015-02-01 00:40:56.000000', 'temperatura', 863.0000, 'ºC'),
	(38115, 109, '2015-02-01 00:40:57.000000', 'temperatura', 726.0000, 'ºC'),
	(38116, 109, '2015-02-01 00:40:58.000000', 'temperatura', 1041.0000, 'ºC'),
	(38117, 109, '2015-02-01 00:40:59.000000', 'temperatura', 629.0000, 'ºC'),
	(38118, 109, '2015-02-01 00:41:00.000000', 'temperatura', 19.0000, 'ºC'),
	(38119, 109, '2015-02-01 00:41:01.000000', 'temperatura', 612.0000, 'ºC'),
	(38120, 109, '2015-02-01 00:41:02.000000', 'temperatura', 601.0000, 'ºC'),
	(38121, 109, '2015-02-01 00:41:03.000000', 'temperatura', 1172.0000, 'ºC'),
	(38122, 109, '2015-02-01 00:41:04.000000', 'temperatura', 457.0000, 'ºC'),
	(38123, 109, '2015-02-01 00:41:05.000000', 'temperatura', 1169.0000, 'ºC'),
	(38124, 109, '2015-02-01 00:41:06.000000', 'temperatura', 875.0000, 'ºC'),
	(38125, 109, '2015-02-01 00:41:07.000000', 'temperatura', 870.0000, 'ºC'),
	(38126, 109, '2015-02-01 00:41:08.000000', 'temperatura', 525.0000, 'ºC'),
	(38127, 109, '2015-02-01 00:41:09.000000', 'temperatura', 13.0000, 'ºC'),
	(38128, 109, '2015-02-01 00:41:10.000000', 'temperatura', 893.0000, 'ºC'),
	(38129, 109, '2015-02-01 00:41:11.000000', 'temperatura', 826.0000, 'ºC'),
	(38130, 109, '2015-02-01 00:41:12.000000', 'temperatura', 253.0000, 'ºC'),
	(38131, 109, '2015-02-01 00:41:13.000000', 'temperatura', 1184.0000, 'ºC'),
	(38132, 109, '2015-02-01 00:41:14.000000', 'temperatura', 364.0000, 'ºC'),
	(38133, 109, '2015-02-01 00:41:15.000000', 'temperatura', 669.0000, 'ºC'),
	(38134, 109, '2015-02-01 00:41:16.000000', 'temperatura', 1052.0000, 'ºC'),
	(38135, 109, '2015-02-01 00:41:17.000000', 'temperatura', 855.0000, 'ºC'),
	(38136, 109, '2015-02-01 00:41:18.000000', 'temperatura', 1119.0000, 'ºC'),
	(38137, 109, '2015-02-01 00:41:19.000000', 'temperatura', 631.0000, 'ºC'),
	(38138, 109, '2015-02-01 00:41:20.000000', 'temperatura', 997.0000, 'ºC'),
	(38139, 109, '2015-02-01 00:41:21.000000', 'temperatura', 694.0000, 'ºC'),
	(38140, 109, '2015-02-01 00:41:22.000000', 'temperatura', 480.0000, 'ºC'),
	(38141, 109, '2015-02-01 00:41:23.000000', 'temperatura', 319.0000, 'ºC'),
	(38142, 109, '2015-02-01 00:41:24.000000', 'temperatura', 156.0000, 'ºC'),
	(38143, 109, '2015-02-01 00:41:25.000000', 'temperatura', 1023.0000, 'ºC'),
	(38144, 109, '2015-02-01 00:41:26.000000', 'temperatura', 1045.0000, 'ºC'),
	(38145, 109, '2015-02-01 00:41:27.000000', 'temperatura', 960.0000, 'ºC'),
	(38146, 109, '2015-02-01 00:41:28.000000', 'temperatura', 464.0000, 'ºC'),
	(38147, 109, '2015-02-01 00:41:29.000000', 'temperatura', 641.0000, 'ºC'),
	(38148, 109, '2015-02-01 00:41:30.000000', 'temperatura', 612.0000, 'ºC'),
	(38149, 109, '2015-02-01 00:41:31.000000', 'temperatura', 1138.0000, 'ºC'),
	(38150, 109, '2015-02-01 00:41:32.000000', 'temperatura', 253.0000, 'ºC'),
	(38151, 109, '2015-02-01 00:41:33.000000', 'temperatura', 255.0000, 'ºC'),
	(38152, 109, '2015-02-01 00:41:34.000000', 'temperatura', 514.0000, 'ºC'),
	(38153, 109, '2015-02-01 00:41:35.000000', 'temperatura', 607.0000, 'ºC'),
	(38154, 109, '2015-02-01 00:41:36.000000', 'temperatura', 293.0000, 'ºC'),
	(38155, 109, '2015-02-01 00:41:37.000000', 'temperatura', 845.0000, 'ºC'),
	(38156, 109, '2015-02-01 00:41:38.000000', 'temperatura', 948.0000, 'ºC'),
	(38157, 109, '2015-02-01 00:41:39.000000', 'temperatura', 1005.0000, 'ºC'),
	(38158, 109, '2015-02-01 00:41:40.000000', 'temperatura', 982.0000, 'ºC'),
	(38159, 109, '2015-02-01 00:41:41.000000', 'temperatura', 694.0000, 'ºC'),
	(38160, 109, '2015-02-01 00:41:42.000000', 'temperatura', 527.0000, 'ºC'),
	(38161, 109, '2015-02-01 00:41:43.000000', 'temperatura', 552.0000, 'ºC'),
	(38162, 109, '2015-02-01 00:41:44.000000', 'temperatura', 1181.0000, 'ºC'),
	(38163, 109, '2015-02-01 00:41:45.000000', 'temperatura', 648.0000, 'ºC'),
	(38164, 109, '2015-02-01 00:41:46.000000', 'temperatura', 900.0000, 'ºC'),
	(38165, 109, '2015-02-01 00:41:47.000000', 'temperatura', 154.0000, 'ºC'),
	(38166, 109, '2015-02-01 00:41:48.000000', 'temperatura', 473.0000, 'ºC'),
	(38167, 109, '2015-02-01 00:41:49.000000', 'temperatura', 702.0000, 'ºC'),
	(38168, 109, '2015-02-01 00:41:50.000000', 'temperatura', 893.0000, 'ºC'),
	(38169, 109, '2015-02-01 00:41:51.000000', 'temperatura', 1158.0000, 'ºC'),
	(38170, 109, '2015-02-01 00:41:52.000000', 'temperatura', 711.0000, 'ºC'),
	(38171, 109, '2015-02-01 00:41:53.000000', 'temperatura', 80.0000, 'ºC'),
	(38172, 109, '2015-02-01 00:41:54.000000', 'temperatura', 670.0000, 'ºC'),
	(38173, 109, '2015-02-01 00:41:55.000000', 'temperatura', 712.0000, 'ºC'),
	(38174, 109, '2015-02-01 00:41:56.000000', 'temperatura', 348.0000, 'ºC'),
	(38175, 109, '2015-02-01 00:41:57.000000', 'temperatura', 805.0000, 'ºC'),
	(38176, 109, '2015-02-01 00:41:58.000000', 'temperatura', 580.0000, 'ºC'),
	(38177, 109, '2015-02-01 00:41:59.000000', 'temperatura', 485.0000, 'ºC'),
	(38178, 109, '2015-02-01 00:42:00.000000', 'temperatura', 687.0000, 'ºC'),
	(38179, 109, '2015-02-01 00:42:01.000000', 'temperatura', 781.0000, 'ºC'),
	(38180, 109, '2015-02-01 00:42:02.000000', 'temperatura', 642.0000, 'ºC'),
	(38181, 109, '2015-02-01 00:42:03.000000', 'temperatura', 869.0000, 'ºC'),
	(38182, 109, '2015-02-01 00:42:04.000000', 'temperatura', 19.0000, 'ºC'),
	(38183, 109, '2015-02-01 00:42:05.000000', 'temperatura', 1090.0000, 'ºC'),
	(38184, 109, '2015-02-01 00:42:06.000000', 'temperatura', 591.0000, 'ºC'),
	(38185, 109, '2015-02-01 00:42:07.000000', 'temperatura', 886.0000, 'ºC'),
	(38186, 109, '2015-02-01 00:42:08.000000', 'temperatura', 260.0000, 'ºC'),
	(38187, 109, '2015-02-01 00:42:09.000000', 'temperatura', 1041.0000, 'ºC'),
	(38188, 109, '2015-02-01 00:42:10.000000', 'temperatura', 825.0000, 'ºC'),
	(38189, 109, '2015-02-01 00:42:11.000000', 'temperatura', 1004.0000, 'ºC'),
	(38190, 109, '2015-02-01 00:42:12.000000', 'temperatura', 144.0000, 'ºC'),
	(38191, 109, '2015-02-01 00:42:13.000000', 'temperatura', 109.0000, 'ºC'),
	(38192, 109, '2015-02-01 00:42:14.000000', 'temperatura', 115.0000, 'ºC'),
	(38193, 109, '2015-02-01 00:42:15.000000', 'temperatura', 246.0000, 'ºC'),
	(38194, 109, '2015-02-01 00:42:16.000000', 'temperatura', 886.0000, 'ºC'),
	(38195, 109, '2015-02-01 00:42:17.000000', 'temperatura', 91.0000, 'ºC'),
	(38196, 109, '2015-02-01 00:42:18.000000', 'temperatura', 198.0000, 'ºC'),
	(38197, 109, '2015-02-01 00:42:19.000000', 'temperatura', 716.0000, 'ºC'),
	(38198, 109, '2015-02-01 00:42:20.000000', 'temperatura', 590.0000, 'ºC'),
	(38199, 109, '2015-02-01 00:42:21.000000', 'temperatura', 799.0000, 'ºC'),
	(38200, 109, '2015-02-01 00:42:22.000000', 'temperatura', 1027.0000, 'ºC'),
	(38201, 109, '2015-02-01 00:42:23.000000', 'temperatura', 338.0000, 'ºC'),
	(38202, 109, '2015-02-01 00:42:24.000000', 'temperatura', 1010.0000, 'ºC'),
	(38203, 109, '2015-02-01 00:42:25.000000', 'temperatura', 437.0000, 'ºC'),
	(38204, 109, '2015-02-01 00:42:26.000000', 'temperatura', 356.0000, 'ºC'),
	(38205, 109, '2015-02-01 00:42:27.000000', 'temperatura', 469.0000, 'ºC'),
	(38206, 109, '2015-02-01 00:42:28.000000', 'temperatura', 79.0000, 'ºC'),
	(38207, 109, '2015-02-01 00:42:29.000000', 'temperatura', 188.0000, 'ºC'),
	(38208, 109, '2015-02-01 00:42:30.000000', 'temperatura', 701.0000, 'ºC'),
	(38209, 109, '2015-02-01 00:42:31.000000', 'temperatura', 543.0000, 'ºC'),
	(38210, 109, '2015-02-01 00:42:32.000000', 'temperatura', 613.0000, 'ºC'),
	(38211, 109, '2015-02-01 00:42:33.000000', 'temperatura', 236.0000, 'ºC'),
	(38212, 109, '2015-02-01 00:42:34.000000', 'temperatura', 543.0000, 'ºC'),
	(38213, 109, '2015-02-01 00:42:35.000000', 'temperatura', 805.0000, 'ºC'),
	(38214, 109, '2015-02-01 00:42:36.000000', 'temperatura', 1196.0000, 'ºC'),
	(38215, 109, '2015-02-01 00:42:37.000000', 'temperatura', 1166.0000, 'ºC'),
	(38216, 109, '2015-02-01 00:42:38.000000', 'temperatura', 1043.0000, 'ºC'),
	(38217, 109, '2015-02-01 00:42:39.000000', 'temperatura', 518.0000, 'ºC'),
	(38218, 109, '2015-02-01 00:42:40.000000', 'temperatura', 659.0000, 'ºC'),
	(38219, 109, '2015-02-01 00:42:41.000000', 'temperatura', 544.0000, 'ºC'),
	(38220, 109, '2015-02-01 00:42:42.000000', 'temperatura', 743.0000, 'ºC'),
	(38221, 109, '2015-02-01 00:42:43.000000', 'temperatura', 885.0000, 'ºC'),
	(38222, 109, '2015-02-01 00:42:44.000000', 'temperatura', 996.0000, 'ºC'),
	(38223, 109, '2015-02-01 00:42:45.000000', 'temperatura', 1125.0000, 'ºC'),
	(38224, 109, '2015-02-01 00:42:46.000000', 'temperatura', 239.0000, 'ºC'),
	(38225, 109, '2015-02-01 00:42:47.000000', 'temperatura', 221.0000, 'ºC'),
	(38226, 109, '2015-02-01 00:42:48.000000', 'temperatura', 387.0000, 'ºC'),
	(38227, 109, '2015-02-01 00:42:49.000000', 'temperatura', 71.0000, 'ºC'),
	(38228, 109, '2015-02-01 00:42:50.000000', 'temperatura', 395.0000, 'ºC'),
	(38229, 109, '2015-02-01 00:42:51.000000', 'temperatura', 564.0000, 'ºC'),
	(38230, 109, '2015-02-01 00:42:52.000000', 'temperatura', 433.0000, 'ºC'),
	(38231, 109, '2015-02-01 00:42:53.000000', 'temperatura', 475.0000, 'ºC'),
	(38232, 109, '2015-02-01 00:42:54.000000', 'temperatura', 1075.0000, 'ºC'),
	(38233, 109, '2015-02-01 00:42:55.000000', 'temperatura', 353.0000, 'ºC'),
	(38234, 109, '2015-02-01 00:42:56.000000', 'temperatura', 941.0000, 'ºC'),
	(38235, 109, '2015-02-01 00:42:57.000000', 'temperatura', 45.0000, 'ºC'),
	(38236, 109, '2015-02-01 00:42:58.000000', 'temperatura', 1004.0000, 'ºC'),
	(38237, 109, '2015-02-01 00:42:59.000000', 'temperatura', 85.0000, 'ºC'),
	(38238, 109, '2015-02-01 00:43:00.000000', 'temperatura', 1013.0000, 'ºC'),
	(38239, 109, '2015-02-01 00:43:01.000000', 'temperatura', 11.0000, 'ºC'),
	(38240, 109, '2015-02-01 00:43:02.000000', 'temperatura', 616.0000, 'ºC'),
	(38241, 109, '2015-02-01 00:43:03.000000', 'temperatura', 646.0000, 'ºC'),
	(38242, 109, '2015-02-01 00:43:04.000000', 'temperatura', 184.0000, 'ºC'),
	(38243, 109, '2015-02-01 00:43:05.000000', 'temperatura', 184.0000, 'ºC'),
	(38244, 109, '2015-02-01 00:43:06.000000', 'temperatura', 366.0000, 'ºC'),
	(38245, 109, '2015-02-01 00:43:07.000000', 'temperatura', 78.0000, 'ºC'),
	(38246, 109, '2015-02-01 00:43:08.000000', 'temperatura', 493.0000, 'ºC'),
	(38247, 109, '2015-02-01 00:43:09.000000', 'temperatura', 1030.0000, 'ºC'),
	(38248, 109, '2015-02-01 00:43:10.000000', 'temperatura', 72.0000, 'ºC'),
	(38249, 109, '2015-02-01 00:43:11.000000', 'temperatura', 872.0000, 'ºC'),
	(38250, 109, '2015-02-01 00:43:12.000000', 'temperatura', 545.0000, 'ºC'),
	(38251, 109, '2015-02-01 00:43:13.000000', 'temperatura', 109.0000, 'ºC'),
	(38252, 109, '2015-02-01 00:43:14.000000', 'temperatura', 112.0000, 'ºC'),
	(38253, 109, '2015-02-01 00:43:15.000000', 'temperatura', 233.0000, 'ºC'),
	(38254, 109, '2015-02-01 00:43:16.000000', 'temperatura', 828.0000, 'ºC'),
	(38255, 109, '2015-02-01 00:43:17.000000', 'temperatura', 1040.0000, 'ºC'),
	(38256, 109, '2015-02-01 00:43:18.000000', 'temperatura', 318.0000, 'ºC'),
	(38257, 109, '2015-02-01 00:43:19.000000', 'temperatura', 872.0000, 'ºC'),
	(38258, 109, '2015-02-01 00:43:20.000000', 'temperatura', 1004.0000, 'ºC'),
	(38259, 109, '2015-02-01 00:43:21.000000', 'temperatura', 7.0000, 'ºC'),
	(38260, 109, '2015-02-01 00:43:22.000000', 'temperatura', 622.0000, 'ºC'),
	(38261, 109, '2015-02-01 00:43:23.000000', 'temperatura', 692.0000, 'ºC'),
	(38262, 109, '2015-02-01 00:43:24.000000', 'temperatura', 391.0000, 'ºC'),
	(38263, 109, '2015-02-01 00:43:25.000000', 'temperatura', 1082.0000, 'ºC'),
	(38264, 109, '2015-02-01 00:43:26.000000', 'temperatura', 637.0000, 'ºC'),
	(38265, 109, '2015-02-01 00:43:27.000000', 'temperatura', 1140.0000, 'ºC'),
	(38266, 109, '2015-02-01 00:43:28.000000', 'temperatura', 190.0000, 'ºC'),
	(38267, 109, '2015-02-01 00:43:29.000000', 'temperatura', 1129.0000, 'ºC'),
	(38268, 109, '2015-02-01 00:43:30.000000', 'temperatura', 278.0000, 'ºC'),
	(38269, 109, '2015-02-01 00:43:31.000000', 'temperatura', 402.0000, 'ºC'),
	(38270, 109, '2015-02-01 00:43:32.000000', 'temperatura', 1177.0000, 'ºC'),
	(38271, 109, '2015-02-01 00:43:33.000000', 'temperatura', 1079.0000, 'ºC'),
	(38272, 109, '2015-02-01 00:43:34.000000', 'temperatura', 665.0000, 'ºC'),
	(38273, 109, '2015-02-01 00:43:35.000000', 'temperatura', 86.0000, 'ºC'),
	(38274, 109, '2015-02-01 00:43:36.000000', 'temperatura', 838.0000, 'ºC'),
	(38275, 109, '2015-02-01 00:43:37.000000', 'temperatura', 330.0000, 'ºC'),
	(38276, 109, '2015-02-01 00:43:38.000000', 'temperatura', 339.0000, 'ºC'),
	(38277, 109, '2015-02-01 00:43:39.000000', 'temperatura', 703.0000, 'ºC'),
	(38278, 109, '2015-02-01 00:43:40.000000', 'temperatura', 100.0000, 'ºC'),
	(38279, 109, '2015-02-01 00:43:41.000000', 'temperatura', 793.0000, 'ºC'),
	(38280, 109, '2015-02-01 00:43:42.000000', 'temperatura', 64.0000, 'ºC'),
	(38281, 109, '2015-02-01 00:43:43.000000', 'temperatura', 341.0000, 'ºC'),
	(38282, 109, '2015-02-01 00:43:44.000000', 'temperatura', 313.0000, 'ºC'),
	(38283, 109, '2015-02-01 00:43:45.000000', 'temperatura', 545.0000, 'ºC'),
	(38284, 109, '2015-02-01 00:43:46.000000', 'temperatura', 584.0000, 'ºC'),
	(38285, 109, '2015-02-01 00:43:47.000000', 'temperatura', 88.0000, 'ºC'),
	(38286, 109, '2015-02-01 00:43:48.000000', 'temperatura', 1085.0000, 'ºC'),
	(38287, 109, '2015-02-01 00:43:49.000000', 'temperatura', 365.0000, 'ºC'),
	(38288, 109, '2015-02-01 00:43:50.000000', 'temperatura', 969.0000, 'ºC'),
	(38289, 109, '2015-02-01 00:43:51.000000', 'temperatura', 152.0000, 'ºC'),
	(38290, 109, '2015-02-01 00:43:52.000000', 'temperatura', 253.0000, 'ºC'),
	(38291, 109, '2015-02-01 00:43:53.000000', 'temperatura', 811.0000, 'ºC'),
	(38292, 109, '2015-02-01 00:43:54.000000', 'temperatura', 893.0000, 'ºC'),
	(38293, 109, '2015-02-01 00:43:55.000000', 'temperatura', 836.0000, 'ºC'),
	(38294, 109, '2015-02-01 00:43:56.000000', 'temperatura', 298.0000, 'ºC'),
	(38295, 109, '2015-02-01 00:43:57.000000', 'temperatura', 185.0000, 'ºC'),
	(38296, 109, '2015-02-01 00:43:58.000000', 'temperatura', 31.0000, 'ºC'),
	(38297, 109, '2015-02-01 00:43:59.000000', 'temperatura', 801.0000, 'ºC'),
	(38298, 109, '2015-02-01 00:44:00.000000', 'temperatura', 314.0000, 'ºC'),
	(38299, 109, '2015-02-01 00:44:01.000000', 'temperatura', 366.0000, 'ºC'),
	(38300, 109, '2015-02-01 00:44:02.000000', 'temperatura', 890.0000, 'ºC'),
	(38301, 109, '2015-02-01 00:44:03.000000', 'temperatura', 952.0000, 'ºC'),
	(38302, 109, '2015-02-01 00:44:04.000000', 'temperatura', 891.0000, 'ºC'),
	(38303, 109, '2015-02-01 00:44:05.000000', 'temperatura', 400.0000, 'ºC'),
	(38304, 109, '2015-02-01 00:44:06.000000', 'temperatura', 527.0000, 'ºC'),
	(38305, 109, '2015-02-01 00:44:07.000000', 'temperatura', 237.0000, 'ºC'),
	(38306, 109, '2015-02-01 00:44:08.000000', 'temperatura', 802.0000, 'ºC'),
	(38307, 109, '2015-02-01 00:44:09.000000', 'temperatura', 899.0000, 'ºC'),
	(38308, 109, '2015-02-01 00:44:10.000000', 'temperatura', 890.0000, 'ºC'),
	(38309, 109, '2015-02-01 00:44:11.000000', 'temperatura', 555.0000, 'ºC'),
	(38310, 109, '2015-02-01 00:44:12.000000', 'temperatura', 105.0000, 'ºC'),
	(38311, 109, '2015-02-01 00:44:13.000000', 'temperatura', 59.0000, 'ºC'),
	(38312, 109, '2015-02-01 00:44:14.000000', 'temperatura', 1180.0000, 'ºC'),
	(38313, 109, '2015-02-01 00:44:15.000000', 'temperatura', 923.0000, 'ºC'),
	(38314, 109, '2015-02-01 00:44:16.000000', 'temperatura', 1078.0000, 'ºC'),
	(38315, 109, '2015-02-01 00:44:17.000000', 'temperatura', 221.0000, 'ºC'),
	(38316, 109, '2015-02-01 00:44:18.000000', 'temperatura', 271.0000, 'ºC'),
	(38317, 109, '2015-02-01 00:44:19.000000', 'temperatura', 693.0000, 'ºC'),
	(38318, 109, '2015-02-01 00:44:20.000000', 'temperatura', 253.0000, 'ºC'),
	(38319, 109, '2015-02-01 00:44:21.000000', 'temperatura', 385.0000, 'ºC'),
	(38320, 109, '2015-02-01 00:44:22.000000', 'temperatura', 1168.0000, 'ºC'),
	(38321, 109, '2015-02-01 00:44:23.000000', 'temperatura', 1083.0000, 'ºC'),
	(38322, 109, '2015-02-01 00:44:24.000000', 'temperatura', 715.0000, 'ºC'),
	(38323, 109, '2015-02-01 00:44:25.000000', 'temperatura', 324.0000, 'ºC'),
	(38324, 109, '2015-02-01 00:44:26.000000', 'temperatura', 678.0000, 'ºC'),
	(38325, 109, '2015-02-01 00:44:27.000000', 'temperatura', 18.0000, 'ºC'),
	(38326, 109, '2015-02-01 00:44:28.000000', 'temperatura', 456.0000, 'ºC'),
	(38327, 109, '2015-02-01 00:44:29.000000', 'temperatura', 1028.0000, 'ºC'),
	(38328, 109, '2015-02-01 00:44:30.000000', 'temperatura', 171.0000, 'ºC'),
	(38329, 109, '2015-02-01 00:44:31.000000', 'temperatura', 173.0000, 'ºC'),
	(38330, 109, '2015-02-01 00:44:32.000000', 'temperatura', 351.0000, 'ºC'),
	(38331, 109, '2015-02-01 00:44:33.000000', 'temperatura', 38.0000, 'ºC'),
	(38332, 109, '2015-02-01 00:44:34.000000', 'temperatura', 339.0000, 'ºC'),
	(38333, 109, '2015-02-01 00:44:35.000000', 'temperatura', 378.0000, 'ºC'),
	(38334, 109, '2015-02-01 00:44:36.000000', 'temperatura', 875.0000, 'ºC'),
	(38335, 109, '2015-02-01 00:44:37.000000', 'temperatura', 840.0000, 'ºC'),
	(38336, 109, '2015-02-01 00:44:38.000000', 'temperatura', 376.0000, 'ºC'),
	(38337, 109, '2015-02-01 00:44:39.000000', 'temperatura', 562.0000, 'ºC'),
	(38338, 109, '2015-02-01 00:44:40.000000', 'temperatura', 480.0000, 'ºC'),
	(38339, 109, '2015-02-01 00:44:41.000000', 'temperatura', 717.0000, 'ºC'),
	(38340, 109, '2015-02-01 00:44:42.000000', 'temperatura', 943.0000, 'ºC'),
	(38341, 109, '2015-02-01 00:44:43.000000', 'temperatura', 166.0000, 'ºC'),
	(38342, 109, '2015-02-01 00:44:44.000000', 'temperatura', 402.0000, 'ºC'),
	(38343, 109, '2015-02-01 00:44:45.000000', 'temperatura', 311.0000, 'ºC'),
	(38344, 109, '2015-02-01 00:44:46.000000', 'temperatura', 349.0000, 'ºC'),
	(38345, 109, '2015-02-01 00:44:47.000000', 'temperatura', 815.0000, 'ºC'),
	(38346, 109, '2015-02-01 00:44:48.000000', 'temperatura', 627.0000, 'ºC'),
	(38347, 109, '2015-02-01 00:44:49.000000', 'temperatura', 691.0000, 'ºC'),
	(38348, 109, '2015-02-01 00:44:50.000000', 'temperatura', 374.0000, 'ºC'),
	(38349, 109, '2015-02-01 00:44:51.000000', 'temperatura', 1000.0000, 'ºC'),
	(38350, 109, '2015-02-01 00:44:52.000000', 'temperatura', 276.0000, 'ºC'),
	(38351, 109, '2015-02-01 00:44:53.000000', 'temperatura', 781.0000, 'ºC'),
	(38352, 109, '2015-02-01 00:44:54.000000', 'temperatura', 678.0000, 'ºC'),
	(38353, 109, '2015-02-01 00:44:55.000000', 'temperatura', 1045.0000, 'ºC'),
	(38354, 109, '2015-02-01 00:44:56.000000', 'temperatura', 794.0000, 'ºC'),
	(38355, 109, '2015-02-01 00:44:57.000000', 'temperatura', 834.0000, 'ºC'),
	(38356, 109, '2015-02-01 00:44:58.000000', 'temperatura', 591.0000, 'ºC'),
	(38357, 109, '2015-02-01 00:44:59.000000', 'temperatura', 452.0000, 'ºC'),
	(38358, 109, '2015-02-01 00:45:00.000000', 'temperatura', 488.0000, 'ºC'),
	(38359, 109, '2015-02-01 00:45:01.000000', 'temperatura', 1083.0000, 'ºC'),
	(38360, 109, '2015-02-01 00:45:02.000000', 'temperatura', 353.0000, 'ºC'),
	(38361, 109, '2015-02-01 00:45:03.000000', 'temperatura', 915.0000, 'ºC'),
	(38362, 109, '2015-02-01 00:45:04.000000', 'temperatura', 1116.0000, 'ºC'),
	(38363, 109, '2015-02-01 00:45:05.000000', 'temperatura', 436.0000, 'ºC'),
	(38364, 109, '2015-02-01 00:45:06.000000', 'temperatura', 31.0000, 'ºC'),
	(38365, 109, '2015-02-01 00:45:07.000000', 'temperatura', 47.0000, 'ºC'),
	(38366, 109, '2015-02-01 00:45:08.000000', 'temperatura', 144.0000, 'ºC'),
	(38367, 109, '2015-02-01 00:45:09.000000', 'temperatura', 579.0000, 'ºC'),
	(38368, 109, '2015-02-01 00:45:10.000000', 'temperatura', 63.0000, 'ºC'),
	(38369, 109, '2015-02-01 00:45:11.000000', 'temperatura', 978.0000, 'ºC'),
	(38370, 109, '2015-02-01 00:45:12.000000', 'temperatura', 1103.0000, 'ºC'),
	(38371, 109, '2015-02-01 00:45:13.000000', 'temperatura', 180.0000, 'ºC'),
	(38372, 109, '2015-02-01 00:45:14.000000', 'temperatura', 1192.0000, 'ºC'),
	(38373, 109, '2015-02-01 00:45:15.000000', 'temperatura', 619.0000, 'ºC'),
	(38374, 109, '2015-02-01 00:45:16.000000', 'temperatura', 721.0000, 'ºC'),
	(38375, 109, '2015-02-01 00:45:17.000000', 'temperatura', 546.0000, 'ºC'),
	(38376, 109, '2015-02-01 00:45:18.000000', 'temperatura', 571.0000, 'ºC'),
	(38377, 109, '2015-02-01 00:45:19.000000', 'temperatura', 16.0000, 'ºC'),
	(38378, 109, '2015-02-01 00:45:20.000000', 'temperatura', 768.0000, 'ºC'),
	(38379, 109, '2015-02-01 00:45:21.000000', 'temperatura', 192.0000, 'ºC'),
	(38380, 109, '2015-02-01 00:45:22.000000', 'temperatura', 1057.0000, 'ºC'),
	(38381, 109, '2015-02-01 00:45:23.000000', 'temperatura', 1110.0000, 'ºC'),
	(38382, 109, '2015-02-01 00:45:24.000000', 'temperatura', 1180.0000, 'ºC'),
	(38383, 109, '2015-02-01 00:45:25.000000', 'temperatura', 169.0000, 'ºC'),
	(38384, 109, '2015-02-01 00:45:26.000000', 'temperatura', 906.0000, 'ºC'),
	(38385, 109, '2015-02-01 00:45:27.000000', 'temperatura', 422.0000, 'ºC'),
	(38386, 109, '2015-02-01 00:45:28.000000', 'temperatura', 592.0000, 'ºC'),
	(38387, 109, '2015-02-01 00:45:29.000000', 'temperatura', 496.0000, 'ºC'),
	(38388, 109, '2015-02-01 00:45:30.000000', 'temperatura', 703.0000, 'ºC'),
	(38389, 109, '2015-02-01 00:45:31.000000', 'temperatura', 828.0000, 'ºC'),
	(38390, 109, '2015-02-01 00:45:32.000000', 'temperatura', 831.0000, 'ºC'),
	(38391, 109, '2015-02-01 00:45:33.000000', 'temperatura', 470.0000, 'ºC'),
	(38392, 109, '2015-02-01 00:45:34.000000', 'temperatura', 1060.0000, 'ºC'),
	(38393, 109, '2015-02-01 00:45:35.000000', 'temperatura', 289.0000, 'ºC'),
	(38394, 109, '2015-02-01 00:45:36.000000', 'temperatura', 668.0000, 'ºC'),
	(38395, 109, '2015-02-01 00:45:37.000000', 'temperatura', 71.0000, 'ºC'),
	(38396, 109, '2015-02-01 00:45:38.000000', 'temperatura', 750.0000, 'ºC'),
	(38397, 109, '2015-02-01 00:45:39.000000', 'temperatura', 1140.0000, 'ºC'),
	(38398, 109, '2015-02-01 00:45:40.000000', 'temperatura', 1051.0000, 'ºC'),
	(38399, 109, '2015-02-01 00:45:41.000000', 'temperatura', 634.0000, 'ºC'),
	(38400, 109, '2015-02-01 00:45:42.000000', 'temperatura', 18.0000, 'ºC'),
	(38401, 109, '2015-02-01 00:45:43.000000', 'temperatura', 590.0000, 'ºC'),
	(38402, 109, '2015-02-01 00:45:44.000000', 'temperatura', 496.0000, 'ºC'),
	(38403, 109, '2015-02-01 00:45:45.000000', 'temperatura', 708.0000, 'ºC'),
	(38404, 109, '2015-02-01 00:45:46.000000', 'temperatura', 855.0000, 'ºC'),
	(38405, 109, '2015-02-01 00:45:47.000000', 'temperatura', 953.0000, 'ºC'),
	(38406, 109, '2015-02-01 00:45:48.000000', 'temperatura', 997.0000, 'ºC'),
	(38407, 109, '2015-02-01 00:45:49.000000', 'temperatura', 930.0000, 'ºC'),
	(38408, 109, '2015-02-01 00:45:50.000000', 'temperatura', 457.0000, 'ºC'),
	(38409, 109, '2015-02-01 00:45:51.000000', 'temperatura', 697.0000, 'ºC'),
	(38410, 109, '2015-02-01 00:45:52.000000', 'temperatura', 915.0000, 'ºC'),
	(38411, 109, '2015-02-01 00:45:53.000000', 'temperatura', 83.0000, 'ºC'),
	(38412, 109, '2015-02-01 00:45:54.000000', 'temperatura', 70.0000, 'ºC'),
	(38413, 109, '2015-02-01 00:45:55.000000', 'temperatura', 101.0000, 'ºC'),
	(38414, 109, '2015-02-01 00:45:56.000000', 'temperatura', 296.0000, 'ºC'),
	(38415, 109, '2015-02-01 00:45:57.000000', 'temperatura', 1178.0000, 'ºC'),
	(38416, 109, '2015-02-01 00:45:58.000000', 'temperatura', 201.0000, 'ºC'),
	(38417, 109, '2015-02-01 00:45:59.000000', 'temperatura', 1071.0000, 'ºC'),
	(38418, 109, '2015-02-01 00:46:00.000000', 'temperatura', 1153.0000, 'ºC'),
	(38419, 109, '2015-02-01 00:46:01.000000', 'temperatura', 154.0000, 'ºC'),
	(38420, 109, '2015-02-01 00:46:02.000000', 'temperatura', 912.0000, 'ºC'),
	(38421, 109, '2015-02-01 00:46:03.000000', 'temperatura', 496.0000, 'ºC'),
	(38422, 109, '2015-02-01 00:46:04.000000', 'temperatura', 945.0000, 'ºC'),
	(38423, 109, '2015-02-01 00:46:05.000000', 'temperatura', 840.0000, 'ºC'),
	(38424, 109, '2015-02-01 00:46:06.000000', 'temperatura', 162.0000, 'ºC'),
	(38425, 109, '2015-02-01 00:46:07.000000', 'temperatura', 693.0000, 'ºC'),
	(38426, 109, '2015-02-01 00:46:08.000000', 'temperatura', 580.0000, 'ºC'),
	(38427, 109, '2015-02-01 00:46:09.000000', 'temperatura', 821.0000, 'ºC'),
	(38428, 109, '2015-02-01 00:46:10.000000', 'temperatura', 1165.0000, 'ºC'),
	(38429, 109, '2015-02-01 00:46:11.000000', 'temperatura', 963.0000, 'ºC'),
	(38430, 109, '2015-02-01 00:46:12.000000', 'temperatura', 121.0000, 'ºC'),
	(38431, 109, '2015-02-01 00:46:13.000000', 'temperatura', 118.0000, 'ºC'),
	(38432, 109, '2015-02-01 00:46:14.000000', 'temperatura', 226.0000, 'ºC'),
	(38433, 109, '2015-02-01 00:46:15.000000', 'temperatura', 775.0000, 'ºC'),
	(38434, 109, '2015-02-01 00:46:16.000000', 'temperatura', 797.0000, 'ºC'),
	(38435, 109, '2015-02-01 00:46:17.000000', 'temperatura', 460.0000, 'ºC'),
	(38436, 109, '2015-02-01 00:46:18.000000', 'temperatura', 1109.0000, 'ºC'),
	(38437, 109, '2015-02-01 00:46:19.000000', 'temperatura', 568.0000, 'ºC'),
	(38438, 109, '2015-02-01 00:46:20.000000', 'temperatura', 713.0000, 'ºC'),
	(38439, 109, '2015-02-01 00:46:21.000000', 'temperatura', 661.0000, 'ºC'),
	(38440, 109, '2015-02-01 00:46:22.000000', 'temperatura', 1166.0000, 'ºC'),
	(38441, 109, '2015-02-01 00:46:23.000000', 'temperatura', 249.0000, 'ºC'),
	(38442, 109, '2015-02-01 00:46:24.000000', 'temperatura', 147.0000, 'ºC'),
	(38443, 109, '2015-02-01 00:46:25.000000', 'temperatura', 1188.0000, 'ºC'),
	(38444, 109, '2015-02-01 00:46:26.000000', 'temperatura', 701.0000, 'ºC'),
	(38445, 109, '2015-02-01 00:46:27.000000', 'temperatura', 1140.0000, 'ºC'),
	(38446, 109, '2015-02-01 00:46:28.000000', 'temperatura', 1196.0000, 'ºC'),
	(38447, 109, '2015-02-01 00:46:29.000000', 'temperatura', 161.0000, 'ºC'),
	(38448, 109, '2015-02-01 00:46:30.000000', 'temperatura', 820.0000, 'ºC'),
	(38449, 109, '2015-02-01 00:46:31.000000', 'temperatura', 15.0000, 'ºC'),
	(38450, 109, '2015-02-01 00:46:32.000000', 'temperatura', 15.0000, 'ºC'),
	(38451, 109, '2015-02-01 00:46:33.000000', 'temperatura', 32.0000, 'ºC'),
	(38452, 109, '2015-02-01 00:46:34.000000', 'temperatura', 117.0000, 'ºC'),
	(38453, 109, '2015-02-01 00:46:35.000000', 'temperatura', 489.0000, 'ºC'),
	(38454, 109, '2015-02-01 00:46:36.000000', 'temperatura', 893.0000, 'ºC'),
	(38455, 109, '2015-02-01 00:46:37.000000', 'temperatura', 598.0000, 'ºC'),
	(38456, 109, '2015-02-01 00:46:38.000000', 'temperatura', 312.0000, 'ºC'),
	(38457, 109, '2015-02-01 00:46:39.000000', 'temperatura', 966.0000, 'ºC'),
	(38458, 109, '2015-02-01 00:46:40.000000', 'temperatura', 294.0000, 'ºC'),
	(38459, 109, '2015-02-01 00:46:41.000000', 'temperatura', 971.0000, 'ºC'),
	(38460, 109, '2015-02-01 00:46:42.000000', 'temperatura', 376.0000, 'ºC'),
	(38461, 109, '2015-02-01 00:46:43.000000', 'temperatura', 167.0000, 'ºC'),
	(38462, 109, '2015-02-01 00:46:44.000000', 'temperatura', 908.0000, 'ºC'),
	(38463, 109, '2015-02-01 00:46:45.000000', 'temperatura', 441.0000, 'ºC'),
	(38464, 109, '2015-02-01 00:46:46.000000', 'temperatura', 679.0000, 'ºC'),
	(38465, 109, '2015-02-01 00:46:47.000000', 'temperatura', 871.0000, 'ºC'),
	(38466, 109, '2015-02-01 00:46:48.000000', 'temperatura', 1121.0000, 'ºC'),
	(38467, 109, '2015-02-01 00:46:49.000000', 'temperatura', 592.0000, 'ºC'),
	(38468, 109, '2015-02-01 00:46:50.000000', 'temperatura', 798.0000, 'ºC'),
	(38469, 109, '2015-02-01 00:46:51.000000', 'temperatura', 1015.0000, 'ºC'),
	(38470, 109, '2015-02-01 00:46:52.000000', 'temperatura', 282.0000, 'ºC'),
	(38471, 109, '2015-02-01 00:46:53.000000', 'temperatura', 766.0000, 'ºC'),
	(38472, 109, '2015-02-01 00:46:54.000000', 'temperatura', 584.0000, 'ºC'),
	(38473, 109, '2015-02-01 00:46:55.000000', 'temperatura', 623.0000, 'ºC'),
	(38474, 109, '2015-02-01 00:46:56.000000', 'temperatura', 163.0000, 'ºC'),
	(38475, 109, '2015-02-01 00:46:57.000000', 'temperatura', 144.0000, 'ºC'),
	(38476, 109, '2015-02-01 00:46:58.000000', 'temperatura', 235.0000, 'ºC'),
	(38477, 109, '2015-02-01 00:46:59.000000', 'temperatura', 743.0000, 'ºC'),
	(38478, 109, '2015-02-01 00:47:00.000000', 'temperatura', 609.0000, 'ºC'),
	(38479, 109, '2015-02-01 00:47:01.000000', 'temperatura', 815.0000, 'ºC'),
	(38480, 109, '2015-02-01 00:47:02.000000', 'temperatura', 1051.0000, 'ºC'),
	(38481, 109, '2015-02-01 00:47:03.000000', 'temperatura', 409.0000, 'ºC'),
	(38482, 109, '2015-02-01 00:47:04.000000', 'temperatura', 91.0000, 'ºC'),
	(38483, 109, '2015-02-01 00:47:05.000000', 'temperatura', 430.0000, 'ºC'),
	(38484, 109, '2015-02-01 00:47:06.000000', 'temperatura', 679.0000, 'ºC'),
	(38485, 109, '2015-02-01 00:47:07.000000', 'temperatura', 905.0000, 'ºC'),
	(38486, 109, '2015-02-01 00:47:08.000000', 'temperatura', 90.0000, 'ºC'),
	(38487, 109, '2015-02-01 00:47:09.000000', 'temperatura', 135.0000, 'ºC'),
	(38488, 109, '2015-02-01 00:47:10.000000', 'temperatura', 403.0000, 'ºC'),
	(38489, 109, '2015-02-01 00:47:11.000000', 'temperatura', 413.0000, 'ºC'),
	(38490, 109, '2015-02-01 00:47:12.000000', 'temperatura', 855.0000, 'ºC'),
	(38491, 109, '2015-02-01 00:47:13.000000', 'temperatura', 636.0000, 'ºC'),
	(38492, 109, '2015-02-01 00:47:14.000000', 'temperatura', 617.0000, 'ºC'),
	(38493, 109, '2015-02-01 00:47:15.000000', 'temperatura', 1178.0000, 'ºC'),
	(38494, 109, '2015-02-01 00:47:16.000000', 'temperatura', 439.0000, 'ºC'),
	(38495, 109, '2015-02-01 00:47:17.000000', 'temperatura', 1061.0000, 'ºC'),
	(38496, 109, '2015-02-01 00:47:18.000000', 'temperatura', 391.0000, 'ºC'),
	(38497, 109, '2015-02-01 00:47:19.000000', 'temperatura', 1169.0000, 'ºC'),
	(38498, 109, '2015-02-01 00:47:20.000000', 'temperatura', 1075.0000, 'ºC'),
	(38499, 109, '2015-02-01 00:47:21.000000', 'temperatura', 667.0000, 'ºC'),
	(38500, 109, '2015-02-01 00:47:22.000000', 'temperatura', 111.0000, 'ºC'),
	(38501, 109, '2015-02-01 00:47:23.000000', 'temperatura', 956.0000, 'ºC'),
	(38502, 109, '2015-02-01 00:47:24.000000', 'temperatura', 847.0000, 'ºC'),
	(38503, 109, '2015-02-01 00:47:25.000000', 'temperatura', 167.0000, 'ºC'),
	(38504, 109, '2015-02-01 00:47:26.000000', 'temperatura', 695.0000, 'ºC'),
	(38505, 109, '2015-02-01 00:47:27.000000', 'temperatura', 576.0000, 'ºC'),
	(38506, 109, '2015-02-01 00:47:28.000000', 'temperatura', 795.0000, 'ºC'),
	(38507, 109, '2015-02-01 00:47:29.000000', 'temperatura', 1047.0000, 'ºC'),
	(38508, 109, '2015-02-01 00:47:30.000000', 'temperatura', 450.0000, 'ºC'),
	(38509, 109, '2015-02-01 00:47:31.000000', 'temperatura', 308.0000, 'ºC'),
	(38510, 109, '2015-02-01 00:47:32.000000', 'temperatura', 191.0000, 'ºC'),
	(38511, 109, '2015-02-01 00:47:33.000000', 'temperatura', 32.0000, 'ºC'),
	(38512, 109, '2015-02-01 00:47:34.000000', 'temperatura', 789.0000, 'ºC'),
	(38513, 109, '2015-02-01 00:47:35.000000', 'temperatura', 247.0000, 'ºC'),
	(38514, 109, '2015-02-01 00:47:36.000000', 'temperatura', 71.0000, 'ºC'),
	(38515, 109, '2015-02-01 00:47:37.000000', 'temperatura', 815.0000, 'ºC'),
	(38516, 109, '2015-02-01 00:47:38.000000', 'temperatura', 261.0000, 'ºC'),
	(38517, 109, '2015-02-01 00:47:39.000000', 'temperatura', 60.0000, 'ºC'),
	(38518, 109, '2015-02-01 00:47:40.000000', 'temperatura', 719.0000, 'ºC'),
	(38519, 109, '2015-02-01 00:47:41.000000', 'temperatura', 1014.0000, 'ºC'),
	(38520, 109, '2015-02-01 00:47:42.000000', 'temperatura', 512.0000, 'ºC'),
	(38521, 109, '2015-02-01 00:47:43.000000', 'temperatura', 722.0000, 'ºC'),
	(38522, 109, '2015-02-01 00:47:44.000000', 'temperatura', 872.0000, 'ºC'),
	(38523, 109, '2015-02-01 00:47:45.000000', 'temperatura', 994.0000, 'ºC'),
	(38524, 109, '2015-02-01 00:47:46.000000', 'temperatura', 1154.0000, 'ºC'),
	(38525, 109, '2015-02-01 00:47:47.000000', 'temperatura', 388.0000, 'ºC'),
	(38526, 109, '2015-02-01 00:47:48.000000', 'temperatura', 881.0000, 'ºC'),
	(38527, 109, '2015-02-01 00:47:49.000000', 'temperatura', 843.0000, 'ºC'),
	(38528, 109, '2015-02-01 00:47:50.000000', 'temperatura', 369.0000, 'ºC'),
	(38529, 109, '2015-02-01 00:47:51.000000', 'temperatura', 517.0000, 'ºC'),
	(38530, 109, '2015-02-01 00:47:52.000000', 'temperatura', 278.0000, 'ºC'),
	(38531, 109, '2015-02-01 00:47:53.000000', 'temperatura', 1038.0000, 'ºC'),
	(38532, 109, '2015-02-01 00:47:54.000000', 'temperatura', 760.0000, 'ºC'),
	(38533, 109, '2015-02-01 00:47:55.000000', 'temperatura', 685.0000, 'ºC'),
	(38534, 109, '2015-02-01 00:47:56.000000', 'temperatura', 1144.0000, 'ºC'),
	(38535, 109, '2015-02-01 00:47:57.000000', 'temperatura', 67.0000, 'ºC'),
	(38536, 109, '2015-02-01 00:47:58.000000', 'temperatura', 505.0000, 'ºC'),
	(38537, 109, '2015-02-01 00:47:59.000000', 'temperatura', 1125.0000, 'ºC'),
	(38538, 109, '2015-02-01 00:48:00.000000', 'temperatura', 507.0000, 'ºC'),
	(38539, 109, '2015-02-01 00:48:01.000000', 'temperatura', 363.0000, 'ºC'),
	(38540, 109, '2015-02-01 00:48:02.000000', 'temperatura', 293.0000, 'ºC'),
	(38541, 109, '2015-02-01 00:48:03.000000', 'temperatura', 379.0000, 'ºC'),
	(38542, 109, '2015-02-01 00:48:04.000000', 'temperatura', 1015.0000, 'ºC'),
	(38543, 109, '2015-02-01 00:48:05.000000', 'temperatura', 340.0000, 'ºC'),
	(38544, 109, '2015-02-01 00:48:06.000000', 'temperatura', 1053.0000, 'ºC'),
	(38545, 109, '2015-02-01 00:48:07.000000', 'temperatura', 646.0000, 'ºC'),
	(38546, 109, '2015-02-01 00:48:08.000000', 'temperatura', 71.0000, 'ºC'),
	(38547, 109, '2015-02-01 00:48:09.000000', 'temperatura', 816.0000, 'ºC'),
	(38548, 109, '2015-02-01 00:48:10.000000', 'temperatura', 271.0000, 'ºC'),
	(38549, 109, '2015-02-01 00:48:11.000000', 'temperatura', 105.0000, 'ºC'),
	(38550, 109, '2015-02-01 00:48:12.000000', 'temperatura', 913.0000, 'ºC'),
	(38551, 109, '2015-02-01 00:48:13.000000', 'temperatura', 649.0000, 'ºC'),
	(38552, 109, '2015-02-01 00:48:14.000000', 'temperatura', 508.0000, 'ºC'),
	(38553, 109, '2015-02-01 00:48:15.000000', 'temperatura', 591.0000, 'ºC'),
	(38554, 109, '2015-02-01 00:48:16.000000', 'temperatura', 234.0000, 'ºC'),
	(38555, 109, '2015-02-01 00:48:17.000000', 'temperatura', 596.0000, 'ºC'),
	(38556, 109, '2015-02-01 00:48:18.000000', 'temperatura', 1078.0000, 'ºC'),
	(38557, 109, '2015-02-01 00:48:19.000000', 'temperatura', 2.0000, 'ºC'),
	(38558, 109, '2015-02-01 00:48:20.000000', 'temperatura', 378.0000, 'ºC'),
	(38559, 109, '2015-02-01 00:48:21.000000', 'temperatura', 685.0000, 'ºC'),
	(38560, 109, '2015-02-01 00:48:22.000000', 'temperatura', 1089.0000, 'ºC'),
	(38561, 109, '2015-02-01 00:48:23.000000', 'temperatura', 991.0000, 'ºC'),
	(38562, 109, '2015-02-01 00:48:24.000000', 'temperatura', 491.0000, 'ºC'),
	(38563, 109, '2015-02-01 00:48:25.000000', 'temperatura', 680.0000, 'ºC'),
	(38564, 109, '2015-02-01 00:48:26.000000', 'temperatura', 730.0000, 'ºC'),
	(38565, 109, '2015-02-01 00:48:27.000000', 'temperatura', 411.0000, 'ºC'),
	(38566, 109, '2015-02-01 00:48:28.000000', 'temperatura', 1064.0000, 'ºC'),
	(38567, 109, '2015-02-01 00:48:29.000000', 'temperatura', 487.0000, 'ºC'),
	(38568, 109, '2015-02-01 00:48:30.000000', 'temperatura', 443.0000, 'ºC'),
	(38569, 109, '2015-02-01 00:48:31.000000', 'temperatura', 755.0000, 'ºC'),
	(38570, 109, '2015-02-01 00:48:32.000000', 'temperatura', 46.0000, 'ºC'),
	(38571, 109, '2015-02-01 00:48:33.000000', 'temperatura', 368.0000, 'ºC'),
	(38572, 109, '2015-02-01 00:48:34.000000', 'temperatura', 499.0000, 'ºC'),
	(38573, 109, '2015-02-01 00:48:35.000000', 'temperatura', 195.0000, 'ºC'),
	(38574, 109, '2015-02-01 00:48:36.000000', 'temperatura', 677.0000, 'ºC'),
	(38575, 109, '2015-02-01 00:48:37.000000', 'temperatura', 399.0000, 'ºC'),
	(38576, 109, '2015-02-01 00:48:38.000000', 'temperatura', 1165.0000, 'ºC'),
	(38577, 109, '2015-02-01 00:48:39.000000', 'temperatura', 1027.0000, 'ºC'),
	(38578, 109, '2015-02-01 00:48:40.000000', 'temperatura', 442.0000, 'ºC'),
	(38579, 109, '2015-02-01 00:48:41.000000', 'temperatura', 331.0000, 'ºC'),
	(38580, 109, '2015-02-01 00:48:42.000000', 'temperatura', 327.0000, 'ºC'),
	(38581, 109, '2015-02-01 00:48:43.000000', 'temperatura', 644.0000, 'ºC'),
	(38582, 109, '2015-02-01 00:48:44.000000', 'temperatura', 1039.0000, 'ºC'),
	(38583, 109, '2015-02-01 00:48:45.000000', 'temperatura', 864.0000, 'ºC'),
	(38584, 109, '2015-02-01 00:48:46.000000', 'temperatura', 3.0000, 'ºC'),
	(38585, 109, '2015-02-01 00:48:47.000000', 'temperatura', 1022.0000, 'ºC'),
	(38586, 109, '2015-02-01 00:48:48.000000', 'temperatura', 301.0000, 'ºC'),
	(38587, 109, '2015-02-01 00:48:49.000000', 'temperatura', 842.0000, 'ºC'),
	(38588, 109, '2015-02-01 00:48:50.000000', 'temperatura', 908.0000, 'ºC'),
	(38589, 109, '2015-02-01 00:48:51.000000', 'temperatura', 815.0000, 'ºC'),
	(38590, 109, '2015-02-01 00:48:52.000000', 'temperatura', 149.0000, 'ºC'),
	(38591, 109, '2015-02-01 00:48:53.000000', 'temperatura', 700.0000, 'ºC'),
	(38592, 109, '2015-02-01 00:48:54.000000', 'temperatura', 654.0000, 'ºC'),
	(38593, 109, '2015-02-01 00:48:55.000000', 'temperatura', 1170.0000, 'ºC'),
	(38594, 109, '2015-02-01 00:48:56.000000', 'temperatura', 288.0000, 'ºC'),
	(38595, 109, '2015-02-01 00:48:57.000000', 'temperatura', 331.0000, 'ºC'),
	(38596, 109, '2015-02-01 00:48:58.000000', 'temperatura', 793.0000, 'ºC'),
	(38597, 109, '2015-02-01 00:48:59.000000', 'temperatura', 572.0000, 'ºC'),
	(38598, 109, '2015-02-01 00:49:00.000000', 'temperatura', 479.0000, 'ºC'),
	(38599, 109, '2015-02-01 00:49:01.000000', 'temperatura', 682.0000, 'ºC'),
	(38600, 109, '2015-02-01 00:49:02.000000', 'temperatura', 773.0000, 'ºC'),
	(38601, 109, '2015-02-01 00:49:03.000000', 'temperatura', 617.0000, 'ºC'),
	(38602, 109, '2015-02-01 00:49:04.000000', 'temperatura', 770.0000, 'ºC'),
	(38603, 109, '2015-02-01 00:49:05.000000', 'temperatura', 797.0000, 'ºC'),
	(38604, 109, '2015-02-01 00:49:06.000000', 'temperatura', 476.0000, 'ºC'),
	(38605, 109, '2015-02-01 00:49:07.000000', 'temperatura', 1189.0000, 'ºC'),
	(38606, 109, '2015-02-01 00:49:08.000000', 'temperatura', 919.0000, 'ºC'),
	(38607, 109, '2015-02-01 00:49:09.000000', 'temperatura', 1030.0000, 'ºC'),
	(38608, 109, '2015-02-01 00:49:10.000000', 'temperatura', 1192.0000, 'ºC'),
	(38609, 109, '2015-02-01 00:49:11.000000', 'temperatura', 469.0000, 'ºC'),
	(38610, 109, '2015-02-01 00:49:12.000000', 'temperatura', 1169.0000, 'ºC'),
	(38611, 109, '2015-02-01 00:49:13.000000', 'temperatura', 840.0000, 'ºC'),
	(38612, 109, '2015-02-01 00:49:14.000000', 'temperatura', 693.0000, 'ºC'),
	(38613, 109, '2015-02-01 00:49:15.000000', 'temperatura', 946.0000, 'ºC'),
	(38614, 109, '2015-02-01 00:49:16.000000', 'temperatura', 249.0000, 'ºC'),
	(38615, 109, '2015-02-01 00:49:17.000000', 'temperatura', 810.0000, 'ºC'),
	(38616, 109, '2015-02-01 00:49:18.000000', 'temperatura', 901.0000, 'ºC'),
	(38617, 109, '2015-02-01 00:49:19.000000', 'temperatura', 878.0000, 'ºC'),
	(38618, 109, '2015-02-01 00:49:20.000000', 'temperatura', 486.0000, 'ºC'),
	(38619, 109, '2015-02-01 00:49:21.000000', 'temperatura', 996.0000, 'ºC'),
	(38620, 109, '2015-02-01 00:49:22.000000', 'temperatura', 1122.0000, 'ºC'),
	(38621, 109, '2015-02-01 00:49:23.000000', 'temperatura', 224.0000, 'ºC'),
	(38622, 109, '2015-02-01 00:49:24.000000', 'temperatura', 156.0000, 'ºC'),
	(38623, 109, '2015-02-01 00:49:25.000000', 'temperatura', 106.0000, 'ºC'),
	(38624, 109, '2015-02-01 00:49:26.000000', 'temperatura', 64.0000, 'ºC'),
	(38625, 109, '2015-02-01 00:49:27.000000', 'temperatura', 2.0000, 'ºC'),
	(38626, 109, '2015-02-01 00:49:28.000000', 'temperatura', 1017.0000, 'ºC'),
	(38627, 109, '2015-02-01 00:49:29.000000', 'temperatura', 279.0000, 'ºC'),
	(38628, 109, '2015-02-01 00:49:30.000000', 'temperatura', 748.0000, 'ºC'),
	(38629, 109, '2015-02-01 00:49:31.000000', 'temperatura', 500.0000, 'ºC'),
	(38630, 109, '2015-02-01 00:49:32.000000', 'temperatura', 256.0000, 'ºC'),
	(38631, 109, '2015-02-01 00:49:33.000000', 'temperatura', 983.0000, 'ºC'),
	(38632, 109, '2015-02-01 00:49:34.000000', 'temperatura', 549.0000, 'ºC'),
	(38633, 109, '2015-02-01 00:49:35.000000', 'temperatura', 993.0000, 'ºC'),
	(38634, 109, '2015-02-01 00:49:36.000000', 'temperatura', 919.0000, 'ºC'),
	(38635, 109, '2015-02-01 00:49:37.000000', 'temperatura', 419.0000, 'ºC'),
	(38636, 109, '2015-02-01 00:49:38.000000', 'temperatura', 537.0000, 'ºC'),
	(38637, 109, '2015-02-01 00:49:39.000000', 'temperatura', 228.0000, 'ºC'),
	(38638, 109, '2015-02-01 00:49:40.000000', 'temperatura', 730.0000, 'ºC'),
	(38639, 109, '2015-02-01 00:49:41.000000', 'temperatura', 565.0000, 'ºC'),
	(38640, 109, '2015-02-01 00:49:42.000000', 'temperatura', 636.0000, 'ºC'),
	(38641, 109, '2015-02-01 00:49:43.000000', 'temperatura', 285.0000, 'ºC'),
	(38642, 109, '2015-02-01 00:49:44.000000', 'temperatura', 717.0000, 'ºC'),
	(38643, 109, '2015-02-01 00:49:45.000000', 'temperatura', 331.0000, 'ºC'),
	(38644, 109, '2015-02-01 00:49:46.000000', 'temperatura', 704.0000, 'ºC'),
	(38645, 109, '2015-02-01 00:49:47.000000', 'temperatura', 129.0000, 'ºC'),
	(38646, 109, '2015-02-01 00:49:48.000000', 'temperatura', 933.0000, 'ºC'),
	(38647, 109, '2015-02-01 00:49:49.000000', 'temperatura', 678.0000, 'ºC'),
	(38648, 109, '2015-02-01 00:49:50.000000', 'temperatura', 591.0000, 'ºC'),
	(38649, 109, '2015-02-01 00:49:51.000000', 'temperatura', 920.0000, 'ºC'),
	(38650, 109, '2015-02-01 00:49:52.000000', 'temperatura', 430.0000, 'ºC'),
	(38651, 109, '2015-02-01 00:49:53.000000', 'temperatura', 590.0000, 'ºC'),
	(38652, 109, '2015-02-01 00:49:54.000000', 'temperatura', 462.0000, 'ºC'),
	(38653, 109, '2015-02-01 00:49:55.000000', 'temperatura', 537.0000, 'ºC'),
	(38654, 109, '2015-02-01 00:49:56.000000', 'temperatura', 103.0000, 'ºC'),
	(38655, 109, '2015-02-01 00:49:57.000000', 'temperatura', 104.0000, 'ºC'),
	(38656, 109, '2015-02-01 00:49:58.000000', 'temperatura', 209.0000, 'ºC'),
	(38657, 109, '2015-02-01 00:49:59.000000', 'temperatura', 736.0000, 'ºC'),
	(38658, 109, '2015-02-01 00:50:00.000000', 'temperatura', 652.0000, 'ºC'),
	(38659, 109, '2015-02-01 00:50:01.000000', 'temperatura', 1052.0000, 'ºC'),
	(38660, 109, '2015-02-01 00:50:02.000000', 'temperatura', 904.0000, 'ºC'),
	(38661, 109, '2015-02-01 00:50:03.000000', 'temperatura', 165.0000, 'ºC'),
	(38662, 109, '2015-02-01 00:50:04.000000', 'temperatura', 515.0000, 'ºC'),
	(38663, 109, '2015-02-01 00:50:05.000000', 'temperatura', 879.0000, 'ºC'),
	(38664, 109, '2015-02-01 00:50:06.000000', 'temperatura', 451.0000, 'ºC'),
	(38665, 109, '2015-02-01 00:50:07.000000', 'temperatura', 818.0000, 'ºC'),
	(38666, 109, '2015-02-01 00:50:08.000000', 'temperatura', 339.0000, 'ºC'),
	(38667, 109, '2015-02-01 00:50:09.000000', 'temperatura', 443.0000, 'ºC'),
	(38668, 109, '2015-02-01 00:50:10.000000', 'temperatura', 1196.0000, 'ºC'),
	(38669, 109, '2015-02-01 00:50:11.000000', 'temperatura', 1051.0000, 'ºC'),
	(38670, 109, '2015-02-01 00:50:12.000000', 'temperatura', 469.0000, 'ºC'),
	(38671, 109, '2015-02-01 00:50:13.000000', 'temperatura', 393.0000, 'ºC'),
	(38672, 109, '2015-02-01 00:50:14.000000', 'temperatura', 557.0000, 'ºC'),
	(38673, 109, '2015-02-01 00:50:15.000000', 'temperatura', 409.0000, 'ºC'),
	(38674, 109, '2015-02-01 00:50:16.000000', 'temperatura', 374.0000, 'ºC'),
	(38675, 109, '2015-02-01 00:50:17.000000', 'temperatura', 642.0000, 'ºC'),
	(38676, 109, '2015-02-01 00:50:18.000000', 'temperatura', 888.0000, 'ºC'),
	(38677, 109, '2015-02-01 00:50:19.000000', 'temperatura', 117.0000, 'ºC'),
	(38678, 109, '2015-02-01 00:50:20.000000', 'temperatura', 318.0000, 'ºC'),
	(38679, 109, '2015-02-01 00:50:21.000000', 'temperatura', 43.0000, 'ºC'),
	(38680, 109, '2015-02-01 00:50:22.000000', 'temperatura', 459.0000, 'ºC'),
	(38681, 109, '2015-02-01 00:50:23.000000', 'temperatura', 966.0000, 'ºC'),
	(38682, 109, '2015-02-01 00:50:24.000000', 'temperatura', 1053.0000, 'ºC'),
	(38683, 109, '2015-02-01 00:50:25.000000', 'temperatura', 1170.0000, 'ºC'),
	(38684, 109, '2015-02-01 00:50:26.000000', 'temperatura', 289.0000, 'ºC'),
	(38685, 109, '2015-02-01 00:50:27.000000', 'temperatura', 337.0000, 'ºC'),
	(38686, 109, '2015-02-01 00:50:28.000000', 'temperatura', 819.0000, 'ºC'),
	(38687, 109, '2015-02-01 00:50:29.000000', 'temperatura', 684.0000, 'ºC'),
	(38688, 109, '2015-02-01 00:50:30.000000', 'temperatura', 964.0000, 'ºC'),
	(38689, 109, '2015-02-01 00:50:31.000000', 'temperatura', 367.0000, 'ºC'),
	(38690, 109, '2015-02-01 00:50:32.000000', 'temperatura', 145.0000, 'ºC'),
	(38691, 109, '2015-02-01 00:50:33.000000', 'temperatura', 823.0000, 'ºC'),
	(38692, 109, '2015-02-01 00:50:34.000000', 'temperatura', 81.0000, 'ºC'),
	(38693, 109, '2015-02-01 00:50:35.000000', 'temperatura', 336.0000, 'ºC'),
	(38694, 109, '2015-02-01 00:50:36.000000', 'temperatura', 239.0000, 'ºC'),
	(38695, 109, '2015-02-01 00:50:37.000000', 'temperatura', 188.0000, 'ºC'),
	(38696, 109, '2015-02-01 00:50:38.000000', 'temperatura', 222.0000, 'ºC'),
	(38697, 109, '2015-02-01 00:50:39.000000', 'temperatura', 547.0000, 'ºC'),
	(38698, 109, '2015-02-01 00:50:40.000000', 'temperatura', 871.0000, 'ºC'),
	(38699, 109, '2015-02-01 00:50:41.000000', 'temperatura', 313.0000, 'ºC'),
	(38700, 109, '2015-02-01 00:50:42.000000', 'temperatura', 154.0000, 'ºC'),
	(38701, 109, '2015-02-01 00:50:43.000000', 'temperatura', 1032.0000, 'ºC'),
	(38702, 109, '2015-02-01 00:50:44.000000', 'temperatura', 1098.0000, 'ºC'),
	(38703, 109, '2015-02-01 00:50:45.000000', 'temperatura', 1195.0000, 'ºC'),
	(38704, 109, '2015-02-01 00:50:46.000000', 'temperatura', 283.0000, 'ºC'),
	(38705, 109, '2015-02-01 00:50:47.000000', 'temperatura', 227.0000, 'ºC'),
	(38706, 109, '2015-02-01 00:50:48.000000', 'temperatura', 289.0000, 'ºC'),
	(38707, 109, '2015-02-01 00:50:49.000000', 'temperatura', 764.0000, 'ºC'),
	(38708, 109, '2015-02-01 00:50:50.000000', 'temperatura', 555.0000, 'ºC'),
	(38709, 109, '2015-02-01 00:50:51.000000', 'temperatura', 481.0000, 'ºC'),
	(38710, 109, '2015-02-01 00:50:52.000000', 'temperatura', 741.0000, 'ºC'),
	(38711, 109, '2015-02-01 00:50:53.000000', 'temperatura', 1062.0000, 'ºC'),
	(38712, 109, '2015-02-01 00:50:54.000000', 'temperatura', 690.0000, 'ºC'),
	(38713, 109, '2015-02-01 00:50:55.000000', 'temperatura', 264.0000, 'ºC'),
	(38714, 109, '2015-02-01 00:50:56.000000', 'temperatura', 450.0000, 'ºC'),
	(38715, 109, '2015-02-01 00:50:57.000000', 'temperatura', 259.0000, 'ºC'),
	(38716, 109, '2015-02-01 00:50:58.000000', 'temperatura', 1145.0000, 'ºC'),
	(38717, 109, '2015-02-01 00:50:59.000000', 'temperatura', 147.0000, 'ºC'),
	(38718, 109, '2015-02-01 00:51:00.000000', 'temperatura', 901.0000, 'ºC'),
	(38719, 109, '2015-02-01 00:51:01.000000', 'temperatura', 466.0000, 'ºC'),
	(38720, 109, '2015-02-01 00:51:02.000000', 'temperatura', 827.0000, 'ºC'),
	(38721, 109, '2015-02-01 00:51:03.000000', 'temperatura', 337.0000, 'ºC'),
	(38722, 109, '2015-02-01 00:51:04.000000', 'temperatura', 404.0000, 'ºC'),
	(38723, 109, '2015-02-01 00:51:05.000000', 'temperatura', 1011.0000, 'ºC'),
	(38724, 109, '2015-02-01 00:51:06.000000', 'temperatura', 243.0000, 'ºC'),
	(38725, 109, '2015-02-01 00:51:07.000000', 'temperatura', 581.0000, 'ºC'),
	(38726, 109, '2015-02-01 00:51:08.000000', 'temperatura', 977.0000, 'ºC'),
	(38727, 109, '2015-02-01 00:51:09.000000', 'temperatura', 743.0000, 'ºC'),
	(38728, 109, '2015-02-01 00:51:10.000000', 'temperatura', 786.0000, 'ºC'),
	(38729, 109, '2015-02-01 00:51:11.000000', 'temperatura', 501.0000, 'ºC'),
	(38730, 109, '2015-02-01 00:51:12.000000', 'temperatura', 149.0000, 'ºC'),
	(38731, 109, '2015-02-01 00:51:13.000000', 'temperatura', 441.0000, 'ºC'),
	(38732, 109, '2015-02-01 00:51:14.000000', 'temperatura', 559.0000, 'ºC'),
	(38733, 109, '2015-02-01 00:51:15.000000', 'temperatura', 270.0000, 'ºC'),
	(38734, 109, '2015-02-01 00:51:16.000000', 'temperatura', 877.0000, 'ºC'),
	(38735, 109, '2015-02-01 00:51:17.000000', 'temperatura', 1173.0000, 'ºC'),
	(38736, 109, '2015-02-01 00:51:18.000000', 'temperatura', 834.0000, 'ºC'),
	(38737, 109, '2015-02-01 00:51:19.000000', 'temperatura', 651.0000, 'ºC'),
	(38738, 109, '2015-02-01 00:51:20.000000', 'temperatura', 753.0000, 'ºC'),
	(38739, 109, '2015-02-01 00:51:21.000000', 'temperatura', 615.0000, 'ºC'),
	(38740, 109, '2015-02-01 00:51:22.000000', 'temperatura', 813.0000, 'ºC'),
	(38741, 109, '2015-02-01 00:51:23.000000', 'temperatura', 1024.0000, 'ºC'),
	(38742, 109, '2015-02-01 00:51:24.000000', 'temperatura', 282.0000, 'ºC'),
	(38743, 109, '2015-02-01 00:51:25.000000', 'temperatura', 735.0000, 'ºC'),
	(38744, 109, '2015-02-01 00:51:26.000000', 'temperatura', 433.0000, 'ºC'),
	(38745, 109, '2015-02-01 00:51:27.000000', 'temperatura', 1159.0000, 'ºC'),
	(38746, 109, '2015-02-01 00:51:28.000000', 'temperatura', 895.0000, 'ºC'),
	(38747, 109, '2015-02-01 00:51:29.000000', 'temperatura', 998.0000, 'ºC'),
	(38748, 109, '2015-02-01 00:51:30.000000', 'temperatura', 1107.0000, 'ºC'),
	(38749, 109, '2015-02-01 00:51:31.000000', 'temperatura', 140.0000, 'ºC'),
	(38750, 109, '2015-02-01 00:51:32.000000', 'temperatura', 982.0000, 'ºC'),
	(38751, 109, '2015-02-01 00:51:33.000000', 'temperatura', 890.0000, 'ºC'),
	(38752, 109, '2015-02-01 00:51:34.000000', 'temperatura', 306.0000, 'ºC'),
	(38753, 109, '2015-02-01 00:51:35.000000', 'temperatura', 58.0000, 'ºC'),
	(38754, 109, '2015-02-01 00:51:36.000000', 'temperatura', 574.0000, 'ºC'),
	(38755, 109, '2015-02-01 00:51:37.000000', 'temperatura', 297.0000, 'ºC'),
	(38756, 109, '2015-02-01 00:51:38.000000', 'temperatura', 963.0000, 'ºC'),
	(38757, 109, '2015-02-01 00:51:39.000000', 'temperatura', 325.0000, 'ºC'),
	(38758, 109, '2015-02-01 00:51:40.000000', 'temperatura', 1138.0000, 'ºC'),
	(38759, 109, '2015-02-01 00:51:41.000000', 'temperatura', 1113.0000, 'ºC'),
	(38760, 109, '2015-02-01 00:51:42.000000', 'temperatura', 950.0000, 'ºC'),
	(38761, 109, '2015-02-01 00:51:43.000000', 'temperatura', 215.0000, 'ºC'),
	(38762, 109, '2015-02-01 00:51:44.000000', 'temperatura', 625.0000, 'ºC'),
	(38763, 109, '2015-02-01 00:51:45.000000', 'temperatura', 79.0000, 'ºC'),
	(38764, 109, '2015-02-01 00:51:46.000000', 'temperatura', 922.0000, 'ºC'),
	(38765, 109, '2015-02-01 00:51:47.000000', 'temperatura', 772.0000, 'ºC'),
	(38766, 109, '2015-02-01 00:51:48.000000', 'temperatura', 1095.0000, 'ºC'),
	(38767, 109, '2015-02-01 00:51:49.000000', 'temperatura', 759.0000, 'ºC'),
	(38768, 109, '2015-02-01 00:51:50.000000', 'temperatura', 510.0000, 'ºC'),
	(38769, 109, '2015-02-01 00:51:51.000000', 'temperatura', 273.0000, 'ºC'),
	(38770, 109, '2015-02-01 00:51:52.000000', 'temperatura', 1034.0000, 'ºC'),
	(38771, 109, '2015-02-01 00:51:53.000000', 'temperatura', 755.0000, 'ºC'),
	(38772, 109, '2015-02-01 00:51:54.000000', 'temperatura', 672.0000, 'ºC'),
	(38773, 109, '2015-02-01 00:51:55.000000', 'temperatura', 1095.0000, 'ºC'),
	(38774, 109, '2015-02-01 00:51:56.000000', 'temperatura', 1060.0000, 'ºC'),
	(38775, 109, '2015-02-01 00:51:57.000000', 'temperatura', 817.0000, 'ºC'),
	(38776, 109, '2015-02-01 00:51:58.000000', 'temperatura', 905.0000, 'ºC'),
	(38777, 109, '2015-02-01 00:51:59.000000', 'temperatura', 875.0000, 'ºC'),
	(38778, 109, '2015-02-01 00:52:00.000000', 'temperatura', 460.0000, 'ºC'),
	(38779, 109, '2015-02-01 00:52:01.000000', 'temperatura', 873.0000, 'ºC'),
	(38780, 109, '2015-02-01 00:52:02.000000', 'temperatura', 588.0000, 'ºC'),
	(38781, 109, '2015-02-01 00:52:03.000000', 'temperatura', 322.0000, 'ºC'),
	(38782, 109, '2015-02-01 00:52:04.000000', 'temperatura', 1047.0000, 'ºC'),
	(38783, 109, '2015-02-01 00:52:05.000000', 'temperatura', 668.0000, 'ºC'),
	(38784, 109, '2015-02-01 00:52:06.000000', 'temperatura', 201.0000, 'ºC'),
	(38785, 109, '2015-02-01 00:52:07.000000', 'temperatura', 199.0000, 'ºC'),
	(38786, 109, '2015-02-01 00:52:08.000000', 'temperatura', 392.0000, 'ºC'),
	(38787, 109, '2015-02-01 00:52:09.000000', 'temperatura', 166.0000, 'ºC'),
	(38788, 109, '2015-02-01 00:52:10.000000', 'temperatura', 855.0000, 'ºC'),
	(38789, 109, '2015-02-01 00:52:11.000000', 'temperatura', 177.0000, 'ºC'),
	(38790, 109, '2015-02-01 00:52:12.000000', 'temperatura', 718.0000, 'ºC'),
	(38791, 109, '2015-02-01 00:52:13.000000', 'temperatura', 662.0000, 'ºC'),
	(38792, 109, '2015-02-01 00:52:14.000000', 'temperatura', 1157.0000, 'ºC'),
	(38793, 109, '2015-02-01 00:52:15.000000', 'temperatura', 200.0000, 'ºC'),
	(38794, 109, '2015-02-01 00:52:16.000000', 'temperatura', 1126.0000, 'ºC'),
	(38795, 109, '2015-02-01 00:52:17.000000', 'temperatura', 234.0000, 'ºC'),
	(38796, 109, '2015-02-01 00:52:18.000000', 'temperatura', 193.0000, 'ºC'),
	(38797, 109, '2015-02-01 00:52:19.000000', 'temperatura', 260.0000, 'ºC'),
	(38798, 109, '2015-02-01 00:52:20.000000', 'temperatura', 724.0000, 'ºC'),
	(38799, 109, '2015-02-01 00:52:21.000000', 'temperatura', 441.0000, 'ºC'),
	(38800, 109, '2015-02-01 00:52:22.000000', 'temperatura', 31.0000, 'ºC'),
	(38801, 109, '2015-02-01 00:52:23.000000', 'temperatura', 32.0000, 'ºC'),
	(38802, 109, '2015-02-01 00:52:24.000000', 'temperatura', 70.0000, 'ºC'),
	(38803, 109, '2015-02-01 00:52:25.000000', 'temperatura', 254.0000, 'ºC'),
	(38804, 109, '2015-02-01 00:52:26.000000', 'temperatura', 1060.0000, 'ºC'),
	(38805, 109, '2015-02-01 00:52:27.000000', 'temperatura', 940.0000, 'ºC'),
	(38806, 109, '2015-02-01 00:52:28.000000', 'temperatura', 318.0000, 'ºC'),
	(38807, 109, '2015-02-01 00:52:29.000000', 'temperatura', 1170.0000, 'ºC'),
	(38808, 109, '2015-02-01 00:52:30.000000', 'temperatura', 96.0000, 'ºC'),
	(38809, 109, '2015-02-01 00:52:31.000000', 'temperatura', 573.0000, 'ºC'),
	(38810, 109, '2015-02-01 00:52:32.000000', 'temperatura', 177.0000, 'ºC'),
	(38811, 109, '2015-02-01 00:52:33.000000', 'temperatura', 367.0000, 'ºC'),
	(38812, 109, '2015-02-01 00:52:34.000000', 'temperatura', 104.0000, 'ºC'),
	(38813, 109, '2015-02-01 00:52:35.000000', 'temperatura', 618.0000, 'ºC'),
	(38814, 109, '2015-02-01 00:52:36.000000', 'temperatura', 381.0000, 'ºC'),
	(38815, 109, '2015-02-01 00:52:37.000000', 'temperatura', 49.0000, 'ºC'),
	(38816, 109, '2015-02-01 00:52:38.000000', 'temperatura', 302.0000, 'ºC'),
	(38817, 109, '2015-02-01 00:52:39.000000', 'temperatura', 164.0000, 'ºC'),
	(38818, 109, '2015-02-01 00:52:40.000000', 'temperatura', 1117.0000, 'ºC'),
	(38819, 109, '2015-02-01 00:52:41.000000', 'temperatura', 291.0000, 'ºC'),
	(38820, 109, '2015-02-01 00:52:42.000000', 'temperatura', 507.0000, 'ºC'),
	(38821, 109, '2015-02-01 00:52:43.000000', 'temperatura', 462.0000, 'ºC'),
	(38822, 109, '2015-02-01 00:52:44.000000', 'temperatura', 791.0000, 'ºC'),
	(38823, 109, '2015-02-01 00:52:45.000000', 'temperatura', 166.0000, 'ºC'),
	(38824, 109, '2015-02-01 00:52:46.000000', 'temperatura', 861.0000, 'ºC'),
	(38825, 109, '2015-02-01 00:52:47.000000', 'temperatura', 204.0000, 'ºC'),
	(38826, 109, '2015-02-01 00:52:48.000000', 'temperatura', 839.0000, 'ºC'),
	(38827, 109, '2015-02-01 00:52:49.000000', 'temperatura', 1185.0000, 'ºC'),
	(38828, 109, '2015-02-01 00:52:50.000000', 'temperatura', 1009.0000, 'ºC'),
	(38829, 109, '2015-02-01 00:52:51.000000', 'temperatura', 291.0000, 'ºC'),
	(38830, 109, '2015-02-01 00:52:52.000000', 'temperatura', 827.0000, 'ºC'),
	(38831, 109, '2015-02-01 00:52:53.000000', 'temperatura', 864.0000, 'ºC'),
	(38832, 109, '2015-02-01 00:52:54.000000', 'temperatura', 638.0000, 'ºC'),
	(38833, 109, '2015-02-01 00:52:55.000000', 'temperatura', 599.0000, 'ºC'),
	(38834, 109, '2015-02-01 00:52:56.000000', 'temperatura', 1081.0000, 'ºC'),
	(38835, 109, '2015-02-01 00:52:57.000000', 'temperatura', 11.0000, 'ºC'),
	(38836, 109, '2015-02-01 00:52:58.000000', 'temperatura', 411.0000, 'ºC'),
	(38837, 109, '2015-02-01 00:52:59.000000', 'temperatura', 821.0000, 'ºC'),
	(38838, 109, '2015-02-01 00:53:00.000000', 'temperatura', 474.0000, 'ºC'),
	(38839, 109, '2015-02-01 00:53:01.000000', 'temperatura', 1106.0000, 'ºC'),
	(38840, 109, '2015-02-01 00:53:02.000000', 'temperatura', 509.0000, 'ºC'),
	(38841, 109, '2015-02-01 00:53:03.000000', 'temperatura', 426.0000, 'ºC'),
	(38842, 109, '2015-02-01 00:53:04.000000', 'temperatura', 605.0000, 'ºC'),
	(38843, 109, '2015-02-01 00:53:05.000000', 'temperatura', 549.0000, 'ºC'),
	(38844, 109, '2015-02-01 00:53:06.000000', 'temperatura', 927.0000, 'ºC'),
	(38845, 109, '2015-02-01 00:53:07.000000', 'temperatura', 592.0000, 'ºC'),
	(38846, 109, '2015-02-01 00:53:08.000000', 'temperatura', 177.0000, 'ºC'),
	(38847, 109, '2015-02-01 00:53:09.000000', 'temperatura', 309.0000, 'ºC'),
	(38848, 109, '2015-02-01 00:53:10.000000', 'temperatura', 1015.0000, 'ºC'),
	(38849, 109, '2015-02-01 00:53:11.000000', 'temperatura', 550.0000, 'ºC'),
	(38850, 109, '2015-02-01 00:53:12.000000', 'temperatura', 906.0000, 'ºC'),
	(38851, 109, '2015-02-01 00:53:13.000000', 'temperatura', 478.0000, 'ºC'),
	(38852, 109, '2015-02-01 00:53:14.000000', 'temperatura', 872.0000, 'ºC'),
	(38853, 109, '2015-02-01 00:53:15.000000', 'temperatura', 529.0000, 'ºC'),
	(38854, 109, '2015-02-01 00:53:16.000000', 'temperatura', 29.0000, 'ºC'),
	(38855, 109, '2015-02-01 00:53:17.000000', 'temperatura', 957.0000, 'ºC'),
	(38856, 109, '2015-02-01 00:53:18.000000', 'temperatura', 1098.0000, 'ºC'),
	(38857, 109, '2015-02-01 00:53:19.000000', 'temperatura', 220.0000, 'ºC'),
	(38858, 109, '2015-02-01 00:53:20.000000', 'temperatura', 208.0000, 'ºC'),
	(38859, 109, '2015-02-01 00:53:21.000000', 'temperatura', 380.0000, 'ºC'),
	(38860, 109, '2015-02-01 00:53:22.000000', 'temperatura', 77.0000, 'ºC'),
	(38861, 109, '2015-02-01 00:53:23.000000', 'temperatura', 447.0000, 'ºC'),
	(38862, 109, '2015-02-01 00:53:24.000000', 'temperatura', 803.0000, 'ºC'),
	(38863, 109, '2015-02-01 00:53:25.000000', 'temperatura', 276.0000, 'ºC'),
	(38864, 109, '2015-02-01 00:53:26.000000', 'temperatura', 171.0000, 'ºC'),
	(38865, 109, '2015-02-01 00:53:27.000000', 'temperatura', 26.0000, 'ºC'),
	(38866, 109, '2015-02-01 00:53:28.000000', 'temperatura', 816.0000, 'ºC'),
	(38867, 109, '2015-02-01 00:53:29.000000', 'temperatura', 405.0000, 'ºC'),
	(38868, 109, '2015-02-01 00:53:30.000000', 'temperatura', 777.0000, 'ºC'),
	(38869, 109, '2015-02-01 00:53:31.000000', 'temperatura', 269.0000, 'ºC'),
	(38870, 109, '2015-02-01 00:53:32.000000', 'temperatura', 214.0000, 'ºC'),
	(38871, 109, '2015-02-01 00:53:33.000000', 'temperatura', 263.0000, 'ºC'),
	(38872, 109, '2015-02-01 00:53:34.000000', 'temperatura', 674.0000, 'ºC'),
	(38873, 109, '2015-02-01 00:53:35.000000', 'temperatura', 183.0000, 'ºC'),
	(38874, 109, '2015-02-01 00:53:36.000000', 'temperatura', 95.0000, 'ºC'),
	(38875, 109, '2015-02-01 00:53:37.000000', 'temperatura', 1124.0000, 'ºC'),
	(38876, 109, '2015-02-01 00:53:38.000000', 'temperatura', 538.0000, 'ºC'),
	(38877, 109, '2015-02-01 00:53:39.000000', 'temperatura', 515.0000, 'ºC'),
	(38878, 109, '2015-02-01 00:53:40.000000', 'temperatura', 964.0000, 'ºC'),
	(38879, 109, '2015-02-01 00:53:41.000000', 'temperatura', 873.0000, 'ºC'),
	(38880, 109, '2015-02-01 00:53:42.000000', 'temperatura', 276.0000, 'ºC'),
	(38881, 109, '2015-02-01 00:53:43.000000', 'temperatura', 1159.0000, 'ºC'),
	(38882, 109, '2015-02-01 00:53:44.000000', 'temperatura', 171.0000, 'ºC'),
	(38883, 109, '2015-02-01 00:53:45.000000', 'temperatura', 976.0000, 'ºC'),
	(38884, 109, '2015-02-01 00:53:46.000000', 'temperatura', 767.0000, 'ºC'),
	(38885, 109, '2015-02-01 00:53:47.000000', 'temperatura', 909.0000, 'ºC'),
	(38886, 109, '2015-02-01 00:53:48.000000', 'temperatura', 1042.0000, 'ºC'),
	(38887, 109, '2015-02-01 00:53:49.000000', 'temperatura', 87.0000, 'ºC'),
	(38888, 109, '2015-02-01 00:53:50.000000', 'temperatura', 907.0000, 'ºC'),
	(38889, 109, '2015-02-01 00:53:51.000000', 'temperatura', 675.0000, 'ºC'),
	(38890, 109, '2015-02-01 00:53:52.000000', 'temperatura', 657.0000, 'ºC'),
	(38891, 109, '2015-02-01 00:53:53.000000', 'temperatura', 57.0000, 'ºC'),
	(38892, 109, '2015-02-01 00:53:54.000000', 'temperatura', 716.0000, 'ºC'),
	(38893, 109, '2015-02-01 00:53:55.000000', 'temperatura', 1010.0000, 'ºC'),
	(38894, 109, '2015-02-01 00:53:56.000000', 'temperatura', 504.0000, 'ºC'),
	(38895, 109, '2015-02-01 00:53:57.000000', 'temperatura', 687.0000, 'ºC'),
	(38896, 109, '2015-02-01 00:53:58.000000', 'temperatura', 727.0000, 'ºC'),
	(38897, 109, '2015-02-01 00:53:59.000000', 'temperatura', 372.0000, 'ºC'),
	(38898, 109, '2015-02-01 00:54:00.000000', 'temperatura', 879.0000, 'ºC'),
	(38899, 109, '2015-02-01 00:54:01.000000', 'temperatura', 879.0000, 'ºC'),
	(38900, 109, '2015-02-01 00:54:02.000000', 'temperatura', 560.0000, 'ºC'),
	(38901, 109, '2015-02-01 00:54:03.000000', 'temperatura', 162.0000, 'ºC'),
	(38902, 109, '2015-02-01 00:54:04.000000', 'temperatura', 332.0000, 'ºC'),
	(38903, 109, '2015-02-01 00:54:05.000000', 'temperatura', 1175.0000, 'ºC'),
	(38904, 109, '2015-02-01 00:54:06.000000', 'temperatura', 78.0000, 'ºC'),
	(38905, 109, '2015-02-01 00:54:07.000000', 'temperatura', 465.0000, 'ºC'),
	(38906, 109, '2015-02-01 00:54:08.000000', 'temperatura', 892.0000, 'ºC'),
	(38907, 109, '2015-02-01 00:54:09.000000', 'temperatura', 668.0000, 'ºC'),
	(38908, 109, '2015-02-01 00:54:10.000000', 'temperatura', 661.0000, 'ºC'),
	(38909, 109, '2015-02-01 00:54:11.000000', 'temperatura', 104.0000, 'ºC'),
	(38910, 109, '2015-02-01 00:54:12.000000', 'temperatura', 938.0000, 'ºC'),
	(38911, 109, '2015-02-01 00:54:13.000000', 'temperatura', 776.0000, 'ºC'),
	(38912, 109, '2015-02-01 00:54:14.000000', 'temperatura', 1068.0000, 'ºC'),
	(38913, 109, '2015-02-01 00:54:15.000000', 'temperatura', 611.0000, 'ºC'),
	(38914, 109, '2015-02-01 00:54:16.000000', 'temperatura', 1052.0000, 'ºC'),
	(38915, 109, '2015-02-01 00:54:17.000000', 'temperatura', 1028.0000, 'ºC'),
	(38916, 109, '2015-02-01 00:54:18.000000', 'temperatura', 786.0000, 'ºC'),
	(38917, 109, '2015-02-01 00:54:19.000000', 'temperatura', 845.0000, 'ºC'),
	(38918, 109, '2015-02-01 00:54:20.000000', 'temperatura', 666.0000, 'ºC'),
	(38919, 109, '2015-02-01 00:54:21.000000', 'temperatura', 795.0000, 'ºC'),
	(38920, 109, '2015-02-01 00:54:22.000000', 'temperatura', 780.0000, 'ºC'),
	(38921, 109, '2015-02-01 00:54:23.000000', 'temperatura', 316.0000, 'ºC'),
	(38922, 109, '2015-02-01 00:54:24.000000', 'temperatura', 437.0000, 'ºC'),
	(38923, 109, '2015-02-01 00:54:25.000000', 'temperatura', 41.0000, 'ºC'),
	(38924, 109, '2015-02-01 00:54:26.000000', 'temperatura', 93.0000, 'ºC'),
	(38925, 109, '2015-02-01 00:54:27.000000', 'temperatura', 343.0000, 'ºC'),
	(38926, 109, '2015-02-01 00:54:28.000000', 'temperatura', 238.0000, 'ºC'),
	(38927, 109, '2015-02-01 00:54:29.000000', 'temperatura', 162.0000, 'ºC'),
	(38928, 109, '2015-02-01 00:54:30.000000', 'temperatura', 94.0000, 'ºC'),
	(38929, 109, '2015-02-01 00:54:31.000000', 'temperatura', 1184.0000, 'ºC'),
	(38930, 109, '2015-02-01 00:54:32.000000', 'temperatura', 841.0000, 'ºC'),
	(38931, 109, '2015-02-01 00:54:33.000000', 'temperatura', 651.0000, 'ºC'),
	(38932, 109, '2015-02-01 00:54:34.000000', 'temperatura', 732.0000, 'ºC'),
	(38933, 109, '2015-02-01 00:54:35.000000', 'temperatura', 507.0000, 'ºC'),
	(38934, 109, '2015-02-01 00:54:36.000000', 'temperatura', 340.0000, 'ºC'),
	(38935, 109, '2015-02-01 00:54:37.000000', 'temperatura', 182.0000, 'ºC'),
	(38936, 109, '2015-02-01 00:54:38.000000', 'temperatura', 1088.0000, 'ºC'),
	(38937, 109, '2015-02-01 00:54:39.000000', 'temperatura', 96.0000, 'ºC'),
	(38938, 109, '2015-02-01 00:54:40.000000', 'temperatura', 814.0000, 'ºC'),
	(38939, 109, '2015-02-01 00:54:41.000000', 'temperatura', 185.0000, 'ºC'),
	(38940, 109, '2015-02-01 00:54:42.000000', 'temperatura', 882.0000, 'ºC'),
	(38941, 109, '2015-02-01 00:54:43.000000', 'temperatura', 254.0000, 'ºC'),
	(38942, 109, '2015-02-01 00:54:44.000000', 'temperatura', 1025.0000, 'ºC'),
	(38943, 109, '2015-02-01 00:54:45.000000', 'temperatura', 765.0000, 'ºC'),
	(38944, 109, '2015-02-01 00:54:46.000000', 'temperatura', 751.0000, 'ºC'),
	(38945, 109, '2015-02-01 00:54:47.000000', 'temperatura', 261.0000, 'ºC'),
	(38946, 109, '2015-02-01 00:54:48.000000', 'temperatura', 252.0000, 'ºC'),
	(38947, 109, '2015-02-01 00:54:49.000000', 'temperatura', 478.0000, 'ºC'),
	(38948, 109, '2015-02-01 00:54:50.000000', 'temperatura', 434.0000, 'ºC'),
	(38949, 109, '2015-02-01 00:54:51.000000', 'temperatura', 735.0000, 'ºC'),
	(38950, 109, '2015-02-01 00:54:52.000000', 'temperatura', 1173.0000, 'ºC'),
	(38951, 109, '2015-02-01 00:54:53.000000', 'temperatura', 62.0000, 'ºC'),
	(38952, 109, '2015-02-01 00:54:54.000000', 'temperatura', 392.0000, 'ºC'),
	(38953, 109, '2015-02-01 00:54:55.000000', 'temperatura', 573.0000, 'ºC'),
	(38954, 109, '2015-02-01 00:54:56.000000', 'temperatura', 491.0000, 'ºC'),
	(38955, 109, '2015-02-01 00:54:57.000000', 'temperatura', 737.0000, 'ºC'),
	(38956, 109, '2015-02-01 00:54:58.000000', 'temperatura', 1011.0000, 'ºC'),
	(38957, 109, '2015-02-01 00:54:59.000000', 'temperatura', 447.0000, 'ºC'),
	(38958, 109, '2015-02-01 00:55:00.000000', 'temperatura', 401.0000, 'ºC'),
	(38959, 109, '2015-02-01 00:55:01.000000', 'temperatura', 664.0000, 'ºC'),
	(38960, 109, '2015-02-01 00:55:02.000000', 'temperatura', 919.0000, 'ºC'),
	(38961, 109, '2015-02-01 00:55:03.000000', 'temperatura', 204.0000, 'ºC'),
	(38962, 109, '2015-02-01 00:55:04.000000', 'temperatura', 663.0000, 'ºC'),
	(38963, 109, '2015-02-01 00:55:05.000000', 'temperatura', 303.0000, 'ºC'),
	(38964, 109, '2015-02-01 00:55:06.000000', 'temperatura', 728.0000, 'ºC'),
	(38965, 109, '2015-02-01 00:55:07.000000', 'temperatura', 332.0000, 'ºC'),
	(38966, 109, '2015-02-01 00:55:08.000000', 'temperatura', 677.0000, 'ºC'),
	(38967, 109, '2015-02-01 00:55:09.000000', 'temperatura', 1188.0000, 'ºC'),
	(38968, 109, '2015-02-01 00:55:10.000000', 'temperatura', 310.0000, 'ºC'),
	(38969, 109, '2015-02-01 00:55:11.000000', 'temperatura', 386.0000, 'ºC'),
	(38970, 109, '2015-02-01 00:55:12.000000', 'temperatura', 999.0000, 'ºC'),
	(38971, 109, '2015-02-01 00:55:13.000000', 'temperatura', 238.0000, 'ºC'),
	(38972, 109, '2015-02-01 00:55:14.000000', 'temperatura', 592.0000, 'ºC'),
	(38973, 109, '2015-02-01 00:55:15.000000', 'temperatura', 1048.0000, 'ºC'),
	(38974, 109, '2015-02-01 00:55:16.000000', 'temperatura', 1066.0000, 'ºC'),
	(38975, 109, '2015-02-01 00:55:17.000000', 'temperatura', 987.0000, 'ºC'),
	(38976, 109, '2015-02-01 00:55:18.000000', 'temperatura', 536.0000, 'ºC'),
	(38977, 109, '2015-02-01 00:55:19.000000', 'temperatura', 922.0000, 'ºC'),
	(38978, 109, '2015-02-01 00:55:20.000000', 'temperatura', 599.0000, 'ºC'),
	(38979, 109, '2015-02-01 00:55:21.000000', 'temperatura', 231.0000, 'ºC'),
	(38980, 109, '2015-02-01 00:55:22.000000', 'temperatura', 556.0000, 'ºC'),
	(38981, 109, '2015-02-01 00:55:23.000000', 'temperatura', 890.0000, 'ºC'),
	(38982, 109, '2015-02-01 00:55:24.000000', 'temperatura', 384.0000, 'ºC'),
	(38983, 109, '2015-02-01 00:55:25.000000', 'temperatura', 448.0000, 'ºC'),
	(38984, 109, '2015-02-01 00:55:26.000000', 'temperatura', 1090.0000, 'ºC'),
	(38985, 109, '2015-02-01 00:55:27.000000', 'temperatura', 504.0000, 'ºC'),
	(38986, 109, '2015-02-01 00:55:28.000000', 'temperatura', 453.0000, 'ºC'),
	(38987, 109, '2015-02-01 00:55:29.000000', 'temperatura', 752.0000, 'ºC'),
	(38988, 109, '2015-02-01 00:55:30.000000', 'temperatura', 3.0000, 'ºC'),
	(38989, 109, '2015-02-01 00:55:31.000000', 'temperatura', 160.0000, 'ºC'),
	(38990, 109, '2015-02-01 00:55:32.000000', 'temperatura', 790.0000, 'ºC'),
	(38991, 109, '2015-02-01 00:55:33.000000', 'temperatura', 1070.0000, 'ºC'),
	(38992, 109, '2015-02-01 00:55:34.000000', 'temperatura', 579.0000, 'ºC'),
	(38993, 109, '2015-02-01 00:55:35.000000', 'temperatura', 889.0000, 'ºC'),
	(38994, 109, '2015-02-01 00:55:36.000000', 'temperatura', 308.0000, 'ºC'),
	(38995, 109, '2015-02-01 00:55:37.000000', 'temperatura', 71.0000, 'ºC'),
	(38996, 109, '2015-02-01 00:55:38.000000', 'temperatura', 633.0000, 'ºC'),
	(38997, 109, '2015-02-01 00:55:39.000000', 'temperatura', 553.0000, 'ºC'),
	(38998, 109, '2015-02-01 00:55:40.000000', 'temperatura', 865.0000, 'ºC'),
	(38999, 109, '2015-02-01 00:55:41.000000', 'temperatura', 266.0000, 'ºC'),
	(39000, 109, '2015-02-01 00:55:42.000000', 'temperatura', 1137.0000, 'ºC'),
	(39001, 109, '2015-02-01 00:55:43.000000', 'temperatura', 85.0000, 'ºC'),
	(39002, 109, '2015-02-01 00:55:44.000000', 'temperatura', 616.0000, 'ºC'),
	(39003, 109, '2015-02-01 00:55:45.000000', 'temperatura', 425.0000, 'ºC'),
	(39004, 109, '2015-02-01 00:55:46.000000', 'temperatura', 276.0000, 'ºC'),
	(39005, 109, '2015-02-01 00:55:47.000000', 'temperatura', 109.0000, 'ºC'),
	(39006, 109, '2015-02-01 00:55:48.000000', 'temperatura', 915.0000, 'ºC'),
	(39007, 109, '2015-02-01 00:55:49.000000', 'temperatura', 648.0000, 'ºC'),
	(39008, 109, '2015-02-01 00:55:50.000000', 'temperatura', 498.0000, 'ºC'),
	(39009, 109, '2015-02-01 00:55:51.000000', 'temperatura', 547.0000, 'ºC'),
	(39010, 109, '2015-02-01 00:55:52.000000', 'temperatura', 41.0000, 'ºC'),
	(39011, 109, '2015-02-01 00:55:53.000000', 'temperatura', 962.0000, 'ºC'),
	(39012, 109, '2015-02-01 00:55:54.000000', 'temperatura', 1091.0000, 'ºC'),
	(39013, 109, '2015-02-01 00:55:55.000000', 'temperatura', 168.0000, 'ºC'),
	(39014, 109, '2015-02-01 00:55:56.000000', 'temperatura', 1168.0000, 'ºC'),
	(39015, 109, '2015-02-01 00:55:57.000000', 'temperatura', 536.0000, 'ºC'),
	(39016, 109, '2015-02-01 00:55:58.000000', 'temperatura', 379.0000, 'ºC'),
	(39017, 109, '2015-02-01 00:55:59.000000', 'temperatura', 285.0000, 'ºC'),
	(39018, 109, '2015-02-01 00:56:00.000000', 'temperatura', 288.0000, 'ºC'),
	(39019, 109, '2015-02-01 00:56:01.000000', 'temperatura', 586.0000, 'ºC'),
	(39020, 109, '2015-02-01 00:56:02.000000', 'temperatura', 867.0000, 'ºC'),
	(39021, 109, '2015-02-01 00:56:03.000000', 'temperatura', 179.0000, 'ºC'),
	(39022, 109, '2015-02-01 00:56:04.000000', 'temperatura', 691.0000, 'ºC'),
	(39023, 109, '2015-02-01 00:56:05.000000', 'temperatura', 522.0000, 'ºC'),
	(39024, 109, '2015-02-01 00:56:06.000000', 'temperatura', 537.0000, 'ºC'),
	(39025, 109, '2015-02-01 00:56:07.000000', 'temperatura', 1118.0000, 'ºC'),
	(39026, 109, '2015-02-01 00:56:08.000000', 'temperatura', 378.0000, 'ºC'),
	(39027, 109, '2015-02-01 00:56:09.000000', 'temperatura', 939.0000, 'ºC'),
	(39028, 109, '2015-02-01 00:56:10.000000', 'temperatura', 1162.0000, 'ºC'),
	(39029, 109, '2015-02-01 00:56:11.000000', 'temperatura', 592.0000, 'ºC'),
	(39030, 109, '2015-02-01 00:56:12.000000', 'temperatura', 674.0000, 'ºC'),
	(39031, 109, '2015-02-01 00:56:13.000000', 'temperatura', 395.0000, 'ºC'),
	(39032, 109, '2015-02-01 00:56:14.000000', 'temperatura', 1156.0000, 'ºC'),
	(39033, 109, '2015-02-01 00:56:15.000000', 'temperatura', 992.0000, 'ºC'),
	(39034, 109, '2015-02-01 00:56:16.000000', 'temperatura', 295.0000, 'ºC'),
	(39035, 109, '2015-02-01 00:56:17.000000', 'temperatura', 901.0000, 'ºC'),
	(39036, 109, '2015-02-01 00:56:18.000000', 'temperatura', 18.0000, 'ºC'),
	(39037, 109, '2015-02-01 00:56:19.000000', 'temperatura', 986.0000, 'ºC'),
	(39038, 109, '2015-02-01 00:56:20.000000', 'temperatura', 79.0000, 'ºC'),
	(39039, 109, '2015-02-01 00:56:21.000000', 'temperatura', 1038.0000, 'ºC'),
	(39040, 109, '2015-02-01 00:56:22.000000', 'temperatura', 151.0000, 'ºC'),
	(39041, 109, '2015-02-01 00:56:23.000000', 'temperatura', 42.0000, 'ºC'),
	(39042, 109, '2015-02-01 00:56:24.000000', 'temperatura', 959.0000, 'ºC'),
	(39043, 109, '2015-02-01 00:56:25.000000', 'temperatura', 1068.0000, 'ºC'),
	(39044, 109, '2015-02-01 00:56:26.000000', 'temperatura', 64.0000, 'ºC'),
	(39045, 109, '2015-02-01 00:56:27.000000', 'temperatura', 717.0000, 'ºC'),
	(39046, 109, '2015-02-01 00:56:28.000000', 'temperatura', 992.0000, 'ºC'),
	(39047, 109, '2015-02-01 00:56:29.000000', 'temperatura', 409.0000, 'ºC'),
	(39048, 109, '2015-02-01 00:56:30.000000', 'temperatura', 269.0000, 'ºC'),
	(39049, 109, '2015-02-01 00:56:31.000000', 'temperatura', 120.0000, 'ºC'),
	(39050, 109, '2015-02-01 00:56:32.000000', 'temperatura', 992.0000, 'ºC'),
	(39051, 109, '2015-02-01 00:56:33.000000', 'temperatura', 1002.0000, 'ºC'),
	(39052, 109, '2015-02-01 00:56:34.000000', 'temperatura', 832.0000, 'ºC'),
	(39053, 109, '2015-02-01 00:56:35.000000', 'temperatura', 1156.0000, 'ºC'),
	(39054, 109, '2015-02-01 00:56:36.000000', 'temperatura', 884.0000, 'ºC'),
	(39055, 109, '2015-02-01 00:56:37.000000', 'temperatura', 953.0000, 'ºC'),
	(39056, 109, '2015-02-01 00:56:38.000000', 'temperatura', 915.0000, 'ºC'),
	(39057, 109, '2015-02-01 00:56:39.000000', 'temperatura', 514.0000, 'ºC'),
	(39058, 109, '2015-02-01 00:56:40.000000', 'temperatura', 1026.0000, 'ºC'),
	(39059, 109, '2015-02-01 00:56:41.000000', 'temperatura', 1189.0000, 'ºC'),
	(39060, 109, '2015-02-01 00:56:42.000000', 'temperatura', 467.0000, 'ºC'),
	(39061, 109, '2015-02-01 00:56:43.000000', 'temperatura', 1169.0000, 'ºC'),
	(39062, 109, '2015-02-01 00:56:44.000000', 'temperatura', 845.0000, 'ºC'),
	(39063, 109, '2015-02-01 00:56:45.000000', 'temperatura', 720.0000, 'ºC'),
	(39064, 109, '2015-02-01 00:56:46.000000', 'temperatura', 1062.0000, 'ºC'),
	(39065, 109, '2015-02-01 00:56:47.000000', 'temperatura', 753.0000, 'ºC'),
	(39066, 109, '2015-02-01 00:56:48.000000', 'temperatura', 581.0000, 'ºC'),
	(39067, 109, '2015-02-01 00:56:49.000000', 'temperatura', 643.0000, 'ºC'),
	(39068, 109, '2015-02-01 00:56:50.000000', 'temperatura', 275.0000, 'ºC'),
	(39069, 109, '2015-02-01 00:56:51.000000', 'temperatura', 645.0000, 'ºC'),
	(39070, 109, '2015-02-01 00:56:52.000000', 'temperatura', 3.0000, 'ºC'),
	(39071, 109, '2015-02-01 00:56:53.000000', 'temperatura', 480.0000, 'ºC'),
	(39072, 109, '2015-02-01 00:56:54.000000', 'temperatura', 1189.0000, 'ºC'),
	(39073, 109, '2015-02-01 00:56:55.000000', 'temperatura', 907.0000, 'ºC'),
	(39074, 109, '2015-02-01 00:56:56.000000', 'temperatura', 968.0000, 'ºC'),
	(39075, 109, '2015-02-01 00:56:57.000000', 'temperatura', 918.0000, 'ºC'),
	(39076, 109, '2015-02-01 00:56:58.000000', 'temperatura', 488.0000, 'ºC'),
	(39077, 109, '2015-02-01 00:56:59.000000', 'temperatura', 885.0000, 'ºC'),
	(39078, 109, '2015-02-01 00:57:00.000000', 'temperatura', 564.0000, 'ºC'),
	(39079, 109, '2015-02-01 00:57:01.000000', 'temperatura', 166.0000, 'ºC'),
	(39080, 109, '2015-02-01 00:57:02.000000', 'temperatura', 336.0000, 'ºC'),
	(39081, 109, '2015-02-01 00:57:03.000000', 'temperatura', 1184.0000, 'ºC'),
	(39082, 109, '2015-02-01 00:57:04.000000', 'temperatura', 111.0000, 'ºC'),
	(39083, 109, '2015-02-01 00:57:05.000000', 'temperatura', 603.0000, 'ºC'),
	(39084, 109, '2015-02-01 00:57:06.000000', 'temperatura', 284.0000, 'ºC'),
	(39085, 109, '2015-02-01 00:57:07.000000', 'temperatura', 812.0000, 'ºC'),
	(39086, 109, '2015-02-01 00:57:08.000000', 'temperatura', 807.0000, 'ºC'),
	(39087, 109, '2015-02-01 00:57:09.000000', 'temperatura', 401.0000, 'ºC'),
	(39088, 109, '2015-02-01 00:57:10.000000', 'temperatura', 784.0000, 'ºC'),
	(39089, 109, '2015-02-01 00:57:11.000000', 'temperatura', 316.0000, 'ºC'),
	(39090, 109, '2015-02-01 00:57:12.000000', 'temperatura', 431.0000, 'ºC'),
	(39091, 109, '2015-02-01 00:57:13.000000', 'temperatura', 6.0000, 'ºC'),
	(39092, 109, '2015-02-01 00:57:14.000000', 'temperatura', 1138.0000, 'ºC'),
	(39093, 109, '2015-02-01 00:57:15.000000', 'temperatura', 873.0000, 'ºC'),
	(39094, 109, '2015-02-01 00:57:16.000000', 'temperatura', 950.0000, 'ºC'),
	(39095, 109, '2015-02-01 00:57:17.000000', 'temperatura', 931.0000, 'ºC'),
	(39096, 109, '2015-02-01 00:57:18.000000', 'temperatura', 606.0000, 'ºC'),
	(39097, 109, '2015-02-01 00:57:19.000000', 'temperatura', 237.0000, 'ºC'),
	(39098, 109, '2015-02-01 00:57:20.000000', 'temperatura', 567.0000, 'ºC'),
	(39099, 109, '2015-02-01 00:57:21.000000', 'temperatura', 927.0000, 'ºC'),
	(39100, 109, '2015-02-01 00:57:22.000000', 'temperatura', 532.0000, 'ºC'),
	(39101, 109, '2015-02-01 00:57:23.000000', 'temperatura', 1082.0000, 'ºC'),
	(39102, 109, '2015-02-01 00:57:24.000000', 'temperatura', 214.0000, 'ºC'),
	(39103, 109, '2015-02-01 00:57:25.000000', 'temperatura', 224.0000, 'ºC'),
	(39104, 109, '2015-02-01 00:57:26.000000', 'temperatura', 478.0000, 'ºC'),
	(39105, 109, '2015-02-01 00:57:27.000000', 'temperatura', 518.0000, 'ºC'),
	(39106, 109, '2015-02-01 00:57:28.000000', 'temperatura', 1156.0000, 'ºC'),
	(39107, 109, '2015-02-01 00:57:29.000000', 'temperatura', 627.0000, 'ºC'),
	(39108, 109, '2015-02-01 00:57:30.000000', 'temperatura', 868.0000, 'ºC'),
	(39109, 109, '2015-02-01 00:57:31.000000', 'temperatura', 58.0000, 'ºC'),
	(39110, 109, '2015-02-01 00:57:32.000000', 'temperatura', 89.0000, 'ºC'),
	(39111, 109, '2015-02-01 00:57:33.000000', 'temperatura', 271.0000, 'ºC'),
	(39112, 109, '2015-02-01 00:57:34.000000', 'temperatura', 1086.0000, 'ºC'),
	(39113, 109, '2015-02-01 00:57:35.000000', 'temperatura', 1019.0000, 'ºC'),
	(39114, 109, '2015-02-01 00:57:36.000000', 'temperatura', 637.0000, 'ºC'),
	(39115, 109, '2015-02-01 00:57:37.000000', 'temperatura', 130.0000, 'ºC'),
	(39116, 109, '2015-02-01 00:57:38.000000', 'temperatura', 1137.0000, 'ºC'),
	(39117, 109, '2015-02-01 00:57:39.000000', 'temperatura', 496.0000, 'ºC'),
	(39118, 109, '2015-02-01 00:57:40.000000', 'temperatura', 272.0000, 'ºC'),
	(39119, 109, '2015-02-01 00:57:41.000000', 'temperatura', 1069.0000, 'ºC'),
	(39120, 109, '2015-02-01 00:57:42.000000', 'temperatura', 933.0000, 'ºC'),
	(39121, 109, '2015-02-01 00:57:43.000000', 'temperatura', 257.0000, 'ºC'),
	(39122, 109, '2015-02-01 00:57:44.000000', 'temperatura', 886.0000, 'ºC'),
	(39123, 109, '2015-02-01 00:57:45.000000', 'temperatura', 61.0000, 'ºC'),
	(39124, 109, '2015-02-01 00:57:46.000000', 'temperatura', 47.0000, 'ºC'),
	(39125, 109, '2015-02-01 00:57:47.000000', 'temperatura', 54.0000, 'ºC'),
	(39126, 109, '2015-02-01 00:57:48.000000', 'temperatura', 130.0000, 'ºC'),
	(39127, 109, '2015-02-01 00:57:49.000000', 'temperatura', 488.0000, 'ºC'),
	(39128, 109, '2015-02-01 00:57:50.000000', 'temperatura', 850.0000, 'ºC'),
	(39129, 109, '2015-02-01 00:57:51.000000', 'temperatura', 385.0000, 'ºC'),
	(39130, 109, '2015-02-01 00:57:52.000000', 'temperatura', 574.0000, 'ºC'),
	(39131, 109, '2015-02-01 00:57:53.000000', 'temperatura', 519.0000, 'ºC'),
	(39132, 109, '2015-02-01 00:57:54.000000', 'temperatura', 873.0000, 'ºC'),
	(39133, 109, '2015-02-01 00:57:55.000000', 'temperatura', 407.0000, 'ºC'),
	(39134, 109, '2015-02-01 00:57:56.000000', 'temperatura', 619.0000, 'ºC'),
	(39135, 109, '2015-02-01 00:57:57.000000', 'temperatura', 674.0000, 'ºC'),
	(39136, 109, '2015-02-01 00:57:58.000000', 'temperatura', 314.0000, 'ºC'),
	(39137, 109, '2015-02-01 00:57:59.000000', 'temperatura', 750.0000, 'ºC'),
	(39138, 109, '2015-02-01 00:58:00.000000', 'temperatura', 406.0000, 'ºC'),
	(39139, 109, '2015-02-01 00:58:01.000000', 'temperatura', 979.0000, 'ºC'),
	(39140, 109, '2015-02-01 00:58:02.000000', 'temperatura', 81.0000, 'ºC'),
	(39141, 109, '2015-02-01 00:58:03.000000', 'temperatura', 1066.0000, 'ºC'),
	(39142, 109, '2015-02-01 00:58:04.000000', 'temperatura', 287.0000, 'ºC'),
	(39143, 109, '2015-02-01 00:58:05.000000', 'temperatura', 639.0000, 'ºC'),
	(39144, 109, '2015-02-01 00:58:06.000000', 'temperatura', 1135.0000, 'ºC'),
	(39145, 109, '2015-02-01 00:58:07.000000', 'temperatura', 159.0000, 'ºC'),
	(39146, 109, '2015-02-01 00:58:08.000000', 'temperatura', 989.0000, 'ºC'),
	(39147, 109, '2015-02-01 00:58:09.000000', 'temperatura', 868.0000, 'ºC'),
	(39148, 109, '2015-02-01 00:58:10.000000', 'temperatura', 175.0000, 'ºC'),
	(39149, 109, '2015-02-01 00:58:11.000000', 'temperatura', 673.0000, 'ºC'),
	(39150, 109, '2015-02-01 00:58:12.000000', 'temperatura', 437.0000, 'ºC'),
	(39151, 109, '2015-02-01 00:58:13.000000', 'temperatura', 168.0000, 'ºC'),
	(39152, 109, '2015-02-01 00:58:14.000000', 'temperatura', 729.0000, 'ºC'),
	(39153, 109, '2015-02-01 00:58:15.000000', 'temperatura', 742.0000, 'ºC'),
	(39154, 109, '2015-02-01 00:58:16.000000', 'temperatura', 324.0000, 'ºC'),
	(39155, 109, '2015-02-01 00:58:17.000000', 'temperatura', 594.0000, 'ºC'),
	(39156, 109, '2015-02-01 00:58:18.000000', 'temperatura', 798.0000, 'ºC'),
	(39157, 109, '2015-02-01 00:58:19.000000', 'temperatura', 1007.0000, 'ºC'),
	(39158, 109, '2015-02-01 00:58:20.000000', 'temperatura', 242.0000, 'ºC'),
	(39159, 109, '2015-02-01 00:58:21.000000', 'temperatura', 590.0000, 'ºC'),
	(39160, 109, '2015-02-01 00:58:22.000000', 'temperatura', 1026.0000, 'ºC'),
	(39161, 109, '2015-02-01 00:58:23.000000', 'temperatura', 961.0000, 'ºC'),
	(39162, 109, '2015-02-01 00:58:24.000000', 'temperatura', 527.0000, 'ºC'),
	(39163, 109, '2015-02-01 00:58:25.000000', 'temperatura', 953.0000, 'ºC'),
	(39164, 109, '2015-02-01 00:58:26.000000', 'temperatura', 782.0000, 'ºC'),
	(39165, 109, '2015-02-01 00:58:27.000000', 'temperatura', 1052.0000, 'ºC'),
	(39166, 109, '2015-02-01 00:58:28.000000', 'temperatura', 514.0000, 'ºC'),
	(39167, 109, '2015-02-01 00:58:29.000000', 'temperatura', 616.0000, 'ºC'),
	(39168, 109, '2015-02-01 00:58:30.000000', 'temperatura', 336.0000, 'ºC'),
	(39169, 109, '2015-02-01 00:58:31.000000', 'temperatura', 1035.0000, 'ºC'),
	(39170, 109, '2015-02-01 00:58:32.000000', 'temperatura', 566.0000, 'ºC'),
	(39171, 109, '2015-02-01 00:58:33.000000', 'temperatura', 924.0000, 'ºC'),
	(39172, 109, '2015-02-01 00:58:34.000000', 'temperatura', 525.0000, 'ºC'),
	(39173, 109, '2015-02-01 00:58:35.000000', 'temperatura', 1054.0000, 'ºC'),
	(39174, 109, '2015-02-01 00:58:36.000000', 'temperatura', 93.0000, 'ºC'),
	(39175, 109, '2015-02-01 00:58:37.000000', 'temperatura', 904.0000, 'ºC'),
	(39176, 109, '2015-02-01 00:58:38.000000', 'temperatura', 641.0000, 'ºC'),
	(39177, 109, '2015-02-01 00:58:39.000000', 'temperatura', 495.0000, 'ºC'),
	(39178, 109, '2015-02-01 00:58:40.000000', 'temperatura', 554.0000, 'ºC'),
	(39179, 109, '2015-02-01 00:58:41.000000', 'temperatura', 82.0000, 'ºC'),
	(39180, 109, '2015-02-01 00:58:42.000000', 'temperatura', 1151.0000, 'ºC'),
	(39181, 109, '2015-02-01 00:58:43.000000', 'temperatura', 709.0000, 'ºC'),
	(39182, 109, '2015-02-01 00:58:44.000000', 'temperatura', 92.0000, 'ºC'),
	(39183, 109, '2015-02-01 00:58:45.000000', 'temperatura', 735.0000, 'ºC'),
	(39184, 109, '2015-02-01 00:58:46.000000', 'temperatura', 997.0000, 'ºC'),
	(39185, 109, '2015-02-01 00:58:47.000000', 'temperatura', 380.0000, 'ºC'),
	(39186, 109, '2015-02-01 00:58:48.000000', 'temperatura', 111.0000, 'ºC'),
	(39187, 109, '2015-02-01 00:58:49.000000', 'temperatura', 616.0000, 'ºC'),
	(39188, 109, '2015-02-01 00:58:50.000000', 'temperatura', 346.0000, 'ºC'),
	(39189, 109, '2015-02-01 00:58:51.000000', 'temperatura', 1084.0000, 'ºC'),
	(39190, 109, '2015-02-01 00:58:52.000000', 'temperatura', 783.0000, 'ºC'),
	(39191, 109, '2015-02-01 00:58:53.000000', 'temperatura', 664.0000, 'ºC'),
	(39192, 109, '2015-02-01 00:58:54.000000', 'temperatura', 972.0000, 'ºC'),
	(39193, 109, '2015-02-01 00:58:55.000000', 'temperatura', 468.0000, 'ºC'),
	(39194, 109, '2015-02-01 00:58:56.000000', 'temperatura', 624.0000, 'ºC'),
	(39195, 109, '2015-02-01 00:58:57.000000', 'temperatura', 518.0000, 'ºC'),
	(39196, 109, '2015-02-01 00:58:58.000000', 'temperatura', 718.0000, 'ºC'),
	(39197, 109, '2015-02-01 00:58:59.000000', 'temperatura', 835.0000, 'ºC'),
	(39198, 109, '2015-02-01 00:59:00.000000', 'temperatura', 820.0000, 'ºC'),
	(39199, 109, '2015-02-01 00:59:01.000000', 'temperatura', 399.0000, 'ºC'),
	(39200, 109, '2015-02-01 00:59:02.000000', 'temperatura', 732.0000, 'ºC'),
	(39201, 109, '2015-02-01 00:59:03.000000', 'temperatura', 67.0000, 'ºC'),
	(39202, 109, '2015-02-01 00:59:04.000000', 'temperatura', 538.0000, 'ºC'),
	(39203, 109, '2015-02-01 00:59:05.000000', 'temperatura', 91.0000, 'ºC'),
	(39204, 109, '2015-02-01 00:59:06.000000', 'temperatura', 40.0000, 'ºC'),
	(39205, 109, '2015-02-01 00:59:07.000000', 'temperatura', 1130.0000, 'ºC'),
	(39206, 109, '2015-02-01 00:59:08.000000', 'temperatura', 728.0000, 'ºC'),
	(39207, 109, '2015-02-01 00:59:09.000000', 'temperatura', 251.0000, 'ºC'),
	(39208, 109, '2015-02-01 00:59:10.000000', 'temperatura', 273.0000, 'ºC'),
	(39209, 109, '2015-02-01 00:59:11.000000', 'temperatura', 610.0000, 'ºC'),
	(39210, 109, '2015-02-01 00:59:12.000000', 'temperatura', 1032.0000, 'ºC'),
	(39211, 109, '2015-02-01 00:59:13.000000', 'temperatura', 931.0000, 'ºC'),
	(39212, 109, '2015-02-01 00:59:14.000000', 'temperatura', 357.0000, 'ºC'),
	(39213, 109, '2015-02-01 00:59:15.000000', 'temperatura', 196.0000, 'ºC'),
	(39214, 109, '2015-02-01 00:59:16.000000', 'temperatura', 1106.0000, 'ºC'),
	(39215, 109, '2015-02-01 00:59:17.000000', 'temperatura', 145.0000, 'ºC'),
	(39216, 109, '2015-02-01 00:59:18.000000', 'temperatura', 1007.0000, 'ºC'),
	(39217, 109, '2015-02-01 00:59:19.000000', 'temperatura', 1000.0000, 'ºC'),
	(39218, 109, '2015-02-01 00:59:20.000000', 'temperatura', 780.0000, 'ºC'),
	(39219, 109, '2015-02-01 00:59:21.000000', 'temperatura', 901.0000, 'ºC'),
	(39220, 109, '2015-02-01 00:59:22.000000', 'temperatura', 967.0000, 'ºC'),
	(39221, 109, '2015-02-01 00:59:23.000000', 'temperatura', 931.0000, 'ºC'),
	(39222, 109, '2015-02-01 00:59:24.000000', 'temperatura', 556.0000, 'ºC'),
	(39223, 109, '2015-02-01 00:59:25.000000', 'temperatura', 1188.0000, 'ºC'),
	(39224, 109, '2015-02-01 00:59:26.000000', 'temperatura', 672.0000, 'ºC'),
	(39225, 109, '2015-02-01 00:59:27.000000', 'temperatura', 994.0000, 'ºC'),
	(39226, 109, '2015-02-01 00:59:28.000000', 'temperatura', 557.0000, 'ºC'),
	(39227, 109, '2015-02-01 00:59:29.000000', 'temperatura', 1001.0000, 'ºC'),
	(39228, 109, '2015-02-01 00:59:30.000000', 'temperatura', 937.0000, 'ºC'),
	(39229, 109, '2015-02-01 00:59:31.000000', 'temperatura', 484.0000, 'ºC'),
	(39230, 109, '2015-02-01 00:59:32.000000', 'temperatura', 807.0000, 'ºC'),
	(39231, 109, '2015-02-01 00:59:33.000000', 'temperatura', 183.0000, 'ºC'),
	(39232, 109, '2015-02-01 00:59:34.000000', 'temperatura', 894.0000, 'ºC'),
	(39233, 109, '2015-02-01 00:59:35.000000', 'temperatura', 324.0000, 'ºC'),
	(39234, 109, '2015-02-01 00:59:36.000000', 'temperatura', 136.0000, 'ºC'),
	(39235, 109, '2015-02-01 00:59:37.000000', 'temperatura', 909.0000, 'ºC'),
	(39236, 109, '2015-02-01 00:59:38.000000', 'temperatura', 537.0000, 'ºC'),
	(39237, 109, '2015-02-01 00:59:39.000000', 'temperatura', 1159.0000, 'ºC'),
	(39238, 109, '2015-02-01 00:59:40.000000', 'temperatura', 586.0000, 'ºC'),
	(39239, 109, '2015-02-01 00:59:41.000000', 'temperatura', 651.0000, 'ºC'),
	(39240, 109, '2015-02-01 00:59:42.000000', 'temperatura', 298.0000, 'ºC'),
	(39241, 109, '2015-02-01 00:59:43.000000', 'temperatura', 736.0000, 'ºC'),
	(39242, 109, '2015-02-01 00:59:44.000000', 'temperatura', 388.0000, 'ºC'),
	(39243, 109, '2015-02-01 00:59:45.000000', 'temperatura', 933.0000, 'ºC'),
	(39244, 109, '2015-02-01 00:59:46.000000', 'temperatura', 1100.0000, 'ºC'),
	(39245, 109, '2015-02-01 00:59:47.000000', 'temperatura', 304.0000, 'ºC'),
	(39246, 109, '2015-02-01 00:59:48.000000', 'temperatura', 618.0000, 'ºC'),
	(39247, 109, '2015-02-01 00:59:49.000000', 'temperatura', 980.0000, 'ºC'),
	(39248, 109, '2015-02-01 00:59:50.000000', 'temperatura', 648.0000, 'ºC'),
	(39249, 109, '2015-02-01 00:59:51.000000', 'temperatura', 297.0000, 'ºC'),
	(39250, 109, '2015-02-01 00:59:52.000000', 'temperatura', 744.0000, 'ºC'),
	(39251, 109, '2015-02-01 00:59:53.000000', 'temperatura', 428.0000, 'ºC'),
	(39252, 109, '2015-02-01 00:59:54.000000', 'temperatura', 1108.0000, 'ºC'),
	(39253, 109, '2015-02-01 00:59:55.000000', 'temperatura', 655.0000, 'ºC'),
	(39254, 109, '2015-02-01 00:59:56.000000', 'temperatura', 1154.0000, 'ºC'),
	(39255, 109, '2015-02-01 00:59:57.000000', 'temperatura', 203.0000, 'ºC'),
	(39256, 109, '2015-02-01 00:59:58.000000', 'temperatura', 1156.0000, 'ºC'),
	(39257, 109, '2015-02-01 00:59:59.000000', 'temperatura', 370.0000, 'ºC'),
	(39258, 109, '2015-02-01 01:00:00.000000', 'temperatura', 784.0000, 'ºC'),
	(39259, 109, '2015-02-01 01:00:01.000000', 'temperatura', 409.0000, 'ºC'),
	(39260, 109, '2015-02-01 01:00:02.000000', 'temperatura', 893.0000, 'ºC'),
	(39261, 109, '2015-02-01 01:00:03.000000', 'temperatura', 839.0000, 'ºC'),
	(39262, 109, '2015-02-01 01:00:04.000000', 'temperatura', 318.0000, 'ºC'),
	(39263, 109, '2015-02-01 01:00:05.000000', 'temperatura', 273.0000, 'ºC'),
	(39264, 109, '2015-02-01 01:00:06.000000', 'temperatura', 412.0000, 'ºC'),
	(39265, 109, '2015-02-01 01:00:07.000000', 'temperatura', 40.0000, 'ºC'),
	(39266, 109, '2015-02-01 01:00:08.000000', 'temperatura', 166.0000, 'ºC'),
	(39267, 109, '2015-02-01 01:00:09.000000', 'temperatura', 709.0000, 'ºC'),
	(39268, 109, '2015-02-01 01:00:10.000000', 'temperatura', 648.0000, 'ºC'),
	(39269, 109, '2015-02-01 01:00:11.000000', 'temperatura', 1113.0000, 'ºC'),
	(39270, 109, '2015-02-01 01:00:12.000000', 'temperatura', 22.0000, 'ºC'),
	(39271, 109, '2015-02-01 01:00:13.000000', 'temperatura', 372.0000, 'ºC'),
	(39272, 109, '2015-02-01 01:00:14.000000', 'temperatura', 592.0000, 'ºC'),
	(39273, 109, '2015-02-01 01:00:15.000000', 'temperatura', 646.0000, 'ºC'),
	(39274, 109, '2015-02-01 01:00:16.000000', 'temperatura', 256.0000, 'ºC'),
	(39275, 109, '2015-02-01 01:00:17.000000', 'temperatura', 540.0000, 'ºC'),
	(39276, 109, '2015-02-01 01:00:18.000000', 'temperatura', 734.0000, 'ºC'),
	(39277, 109, '2015-02-01 01:00:19.000000', 'temperatura', 850.0000, 'ºC'),
	(39278, 109, '2015-02-01 01:00:20.000000', 'temperatura', 848.0000, 'ºC'),
	(39279, 109, '2015-02-01 01:00:21.000000', 'temperatura', 492.0000, 'ºC'),
	(39280, 109, '2015-02-01 01:00:22.000000', 'temperatura', 1118.0000, 'ºC'),
	(39281, 109, '2015-02-01 01:00:23.000000', 'temperatura', 511.0000, 'ºC'),
	(39282, 109, '2015-02-01 01:00:24.000000', 'temperatura', 404.0000, 'ºC'),
	(39283, 109, '2015-02-01 01:00:25.000000', 'temperatura', 488.0000, 'ºC'),
	(39284, 109, '2015-02-01 01:00:26.000000', 'temperatura', 27.0000, 'ºC'),
	(39285, 109, '2015-02-01 01:00:27.000000', 'temperatura', 1074.0000, 'ºC'),
	(39286, 109, '2015-02-01 01:00:28.000000', 'temperatura', 487.0000, 'ºC'),
	(39287, 109, '2015-02-01 01:00:29.000000', 'temperatura', 416.0000, 'ºC'),
	(39288, 109, '2015-02-01 01:00:30.000000', 'temperatura', 619.0000, 'ºC'),
	(39289, 109, '2015-02-01 01:00:31.000000', 'temperatura', 648.0000, 'ºC'),
	(39290, 109, '2015-02-01 01:00:32.000000', 'temperatura', 181.0000, 'ºC'),
	(39291, 109, '2015-02-01 01:00:33.000000', 'temperatura', 164.0000, 'ºC'),
	(39292, 109, '2015-02-01 01:00:34.000000', 'temperatura', 275.0000, 'ºC'),
	(39293, 109, '2015-02-01 01:00:35.000000', 'temperatura', 885.0000, 'ºC'),
	(39294, 109, '2015-02-01 01:00:36.000000', 'temperatura', 0.0000, 'ºC'),
	(39295, 109, '2015-02-01 01:00:37.000000', 'temperatura', 946.0000, 'ºC'),
	(39296, 109, '2015-02-01 01:00:38.000000', 'temperatura', 1132.0000, 'ºC'),
	(39297, 109, '2015-02-01 01:00:39.000000', 'temperatura', 420.0000, 'ºC'),
	(39298, 109, '2015-02-01 01:00:40.000000', 'temperatura', 1104.0000, 'ºC'),
	(39299, 109, '2015-02-01 01:00:41.000000', 'temperatura', 663.0000, 'ºC'),
	(39300, 109, '2015-02-01 01:00:42.000000', 'temperatura', 1.0000, 'ºC'),
	(39301, 109, '2015-02-01 01:00:43.000000', 'temperatura', 419.0000, 'ºC'),
	(39302, 109, '2015-02-01 01:00:44.000000', 'temperatura', 893.0000, 'ºC'),
	(39303, 109, '2015-02-01 01:00:45.000000', 'temperatura', 806.0000, 'ºC'),
	(39304, 109, '2015-02-01 01:00:46.000000', 'temperatura', 152.0000, 'ºC'),
	(39305, 109, '2015-02-01 01:00:47.000000', 'temperatura', 741.0000, 'ºC'),
	(39306, 109, '2015-02-01 01:00:48.000000', 'temperatura', 853.0000, 'ºC'),
	(39307, 109, '2015-02-01 01:00:49.000000', 'temperatura', 841.0000, 'ºC'),
	(39308, 109, '2015-02-01 01:00:50.000000', 'temperatura', 445.0000, 'ºC'),
	(39309, 109, '2015-02-01 01:00:51.000000', 'temperatura', 903.0000, 'ºC'),
	(39310, 109, '2015-02-01 01:00:52.000000', 'temperatura', 782.0000, 'ºC'),
	(39311, 109, '2015-02-01 01:00:53.000000', 'temperatura', 1199.0000, 'ºC'),
	(39312, 109, '2015-02-01 01:00:54.000000', 'temperatura', 52.0000, 'ºC'),
	(39313, 109, '2015-02-01 01:00:55.000000', 'temperatura', 264.0000, 'ºC'),
	(39314, 109, '2015-02-01 01:00:56.000000', 'temperatura', 1165.0000, 'ºC'),
	(39315, 109, '2015-02-01 01:00:57.000000', 'temperatura', 230.0000, 'ºC'),
	(39316, 109, '2015-02-01 01:00:58.000000', 'temperatura', 59.0000, 'ºC'),
	(39317, 109, '2015-02-01 01:00:59.000000', 'temperatura', 803.0000, 'ºC'),
	(39318, 109, '2015-02-01 01:01:00.000000', 'temperatura', 241.0000, 'ºC'),
	(39319, 109, '2015-02-01 01:01:01.000000', 'temperatura', 1196.0000, 'ºC'),
	(39320, 109, '2015-02-01 01:01:02.000000', 'temperatura', 458.0000, 'ºC'),
	(39321, 109, '2015-02-01 01:01:03.000000', 'temperatura', 1102.0000, 'ºC'),
	(39322, 109, '2015-02-01 01:01:04.000000', 'temperatura', 539.0000, 'ºC'),
	(39323, 109, '2015-02-01 01:01:05.000000', 'temperatura', 586.0000, 'ºC'),
	(39324, 109, '2015-02-01 01:01:06.000000', 'temperatura', 113.0000, 'ºC'),
	(39325, 109, '2015-02-01 01:01:07.000000', 'temperatura', 7.0000, 'ºC'),
	(39326, 109, '2015-02-01 01:01:08.000000', 'temperatura', 899.0000, 'ºC'),
	(39327, 109, '2015-02-01 01:01:09.000000', 'temperatura', 873.0000, 'ºC'),
	(39328, 109, '2015-02-01 01:01:10.000000', 'temperatura', 467.0000, 'ºC'),
	(39329, 109, '2015-02-01 01:01:11.000000', 'temperatura', 919.0000, 'ºC'),
	(39330, 109, '2015-02-01 01:01:12.000000', 'temperatura', 793.0000, 'ºC'),
	(39331, 109, '2015-02-01 01:01:13.000000', 'temperatura', 9.0000, 'ºC'),
	(39332, 109, '2015-02-01 01:01:14.000000', 'temperatura', 65.0000, 'ºC'),
	(39333, 109, '2015-02-01 01:01:15.000000', 'temperatura', 301.0000, 'ºC'),
	(39334, 109, '2015-02-01 01:01:16.000000', 'temperatura', 108.0000, 'ºC'),
	(39335, 109, '2015-02-01 01:01:17.000000', 'temperatura', 838.0000, 'ºC'),
	(39336, 109, '2015-02-01 01:01:18.000000', 'temperatura', 269.0000, 'ºC'),
	(39337, 109, '2015-02-01 01:01:19.000000', 'temperatura', 30.0000, 'ºC'),
	(39338, 109, '2015-02-01 01:01:20.000000', 'temperatura', 544.0000, 'ºC'),
	(39339, 109, '2015-02-01 01:01:21.000000', 'temperatura', 228.0000, 'ºC'),
	(39340, 109, '2015-02-01 01:01:22.000000', 'temperatura', 711.0000, 'ºC'),
	(39341, 109, '2015-02-01 01:01:23.000000', 'temperatura', 472.0000, 'ºC'),
	(39342, 109, '2015-02-01 01:01:24.000000', 'temperatura', 226.0000, 'ºC'),
	(39343, 109, '2015-02-01 01:01:25.000000', 'temperatura', 915.0000, 'ºC'),
	(39344, 109, '2015-02-01 01:01:26.000000', 'temperatura', 298.0000, 'ºC'),
	(39345, 109, '2015-02-01 01:01:27.000000', 'temperatura', 1146.0000, 'ºC'),
	(39346, 109, '2015-02-01 01:01:28.000000', 'temperatura', 37.0000, 'ºC'),
	(39347, 109, '2015-02-01 01:01:29.000000', 'temperatura', 348.0000, 'ºC'),
	(39348, 109, '2015-02-01 01:01:30.000000', 'temperatura', 427.0000, 'ºC'),
	(39349, 109, '2015-02-01 01:01:31.000000', 'temperatura', 1093.0000, 'ºC'),
	(39350, 109, '2015-02-01 01:01:32.000000', 'temperatura', 586.0000, 'ºC'),
	(39351, 109, '2015-02-01 01:01:33.000000', 'temperatura', 850.0000, 'ºC'),
	(39352, 109, '2015-02-01 01:01:34.000000', 'temperatura', 94.0000, 'ºC'),
	(39353, 109, '2015-02-01 01:01:35.000000', 'temperatura', 321.0000, 'ºC'),
	(39354, 109, '2015-02-01 01:01:36.000000', 'temperatura', 124.0000, 'ºC'),
	(39355, 109, '2015-02-01 01:01:37.000000', 'temperatura', 855.0000, 'ºC'),
	(39356, 109, '2015-02-01 01:01:38.000000', 'temperatura', 304.0000, 'ºC'),
	(39357, 109, '2015-02-01 01:01:39.000000', 'temperatura', 156.0000, 'ºC'),
	(39358, 109, '2015-02-01 01:01:40.000000', 'temperatura', 1068.0000, 'ºC'),
	(39359, 109, '2015-02-01 01:01:41.000000', 'temperatura', 75.0000, 'ºC'),
	(39360, 109, '2015-02-01 01:01:42.000000', 'temperatura', 768.0000, 'ºC'),
	(39361, 109, '2015-02-01 01:01:43.000000', 'temperatura', 17.0000, 'ºC'),
	(39362, 109, '2015-02-01 01:01:44.000000', 'temperatura', 179.0000, 'ºC'),
	(39363, 109, '2015-02-01 01:01:45.000000', 'temperatura', 848.0000, 'ºC'),
	(39364, 109, '2015-02-01 01:01:46.000000', 'temperatura', 101.0000, 'ºC'),
	(39365, 109, '2015-02-01 01:01:47.000000', 'temperatura', 363.0000, 'ºC'),
	(39366, 109, '2015-02-01 01:01:48.000000', 'temperatura', 311.0000, 'ºC'),
	(39367, 109, '2015-02-01 01:01:49.000000', 'temperatura', 467.0000, 'ºC'),
	(39368, 109, '2015-02-01 01:01:50.000000', 'temperatura', 203.0000, 'ºC'),
	(39369, 109, '2015-02-01 01:01:51.000000', 'temperatura', 814.0000, 'ºC'),
	(39370, 109, '2015-02-01 01:01:52.000000', 'temperatura', 1062.0000, 'ºC'),
	(39371, 109, '2015-02-01 01:01:53.000000', 'temperatura', 468.0000, 'ºC'),
	(39372, 109, '2015-02-01 01:01:54.000000', 'temperatura', 353.0000, 'ºC'),
	(39373, 109, '2015-02-01 01:01:55.000000', 'temperatura', 364.0000, 'ºC'),
	(39374, 109, '2015-02-01 01:01:56.000000', 'temperatura', 759.0000, 'ºC'),
	(39375, 109, '2015-02-01 01:01:57.000000', 'temperatura', 303.0000, 'ºC'),
	(39376, 109, '2015-02-01 01:01:58.000000', 'temperatura', 438.0000, 'ºC'),
	(39377, 109, '2015-02-01 01:01:59.000000', 'temperatura', 82.0000, 'ºC'),
	(39378, 109, '2015-02-01 01:02:00.000000', 'temperatura', 296.0000, 'ºC'),
	(39379, 109, '2015-02-01 01:02:01.000000', 'temperatura', 35.0000, 'ºC'),
	(39380, 109, '2015-02-01 01:02:02.000000', 'temperatura', 487.0000, 'ºC'),
	(39381, 109, '2015-02-01 01:02:03.000000', 'temperatura', 1129.0000, 'ºC'),
	(39382, 109, '2015-02-01 01:02:04.000000', 'temperatura', 585.0000, 'ºC'),
	(39383, 109, '2015-02-01 01:02:05.000000', 'temperatura', 740.0000, 'ºC'),
	(39384, 109, '2015-02-01 01:02:06.000000', 'temperatura', 743.0000, 'ºC'),
	(39385, 109, '2015-02-01 01:02:07.000000', 'temperatura', 297.0000, 'ºC'),
	(39386, 109, '2015-02-01 01:02:08.000000', 'temperatura', 454.0000, 'ºC'),
	(39387, 109, '2015-02-01 01:02:09.000000', 'temperatura', 182.0000, 'ºC'),
	(39388, 109, '2015-02-01 01:02:10.000000', 'temperatura', 749.0000, 'ºC'),
	(39389, 109, '2015-02-01 01:02:11.000000', 'temperatura', 798.0000, 'ºC'),
	(39390, 109, '2015-02-01 01:02:12.000000', 'temperatura', 544.0000, 'ºC'),
	(39391, 109, '2015-02-01 01:02:13.000000', 'temperatura', 326.0000, 'ºC'),
	(39392, 109, '2015-02-01 01:02:14.000000', 'temperatura', 1199.0000, 'ºC'),
	(39393, 109, '2015-02-01 01:02:15.000000', 'temperatura', 216.0000, 'ºC'),
	(39394, 109, '2015-02-01 01:02:16.000000', 'temperatura', 1086.0000, 'ºC'),
	(39395, 109, '2015-02-01 01:02:17.000000', 'temperatura', 1182.0000, 'ºC'),
	(39396, 109, '2015-02-01 01:02:18.000000', 'temperatura', 250.0000, 'ºC'),
	(39397, 109, '2015-02-01 01:02:19.000000', 'temperatura', 107.0000, 'ºC'),
	(39398, 109, '2015-02-01 01:02:20.000000', 'temperatura', 986.0000, 'ºC'),
	(39399, 109, '2015-02-01 01:02:21.000000', 'temperatura', 1010.0000, 'ºC'),
	(39400, 109, '2015-02-01 01:02:22.000000', 'temperatura', 890.0000, 'ºC'),
	(39401, 109, '2015-02-01 01:02:23.000000', 'temperatura', 220.0000, 'ºC'),
	(39402, 109, '2015-02-01 01:02:24.000000', 'temperatura', 832.0000, 'ºC'),
	(39403, 109, '2015-02-01 01:02:25.000000', 'temperatura', 1098.0000, 'ºC'),
	(39404, 109, '2015-02-01 01:02:26.000000', 'temperatura', 596.0000, 'ºC'),
	(39405, 109, '2015-02-01 01:02:27.000000', 'temperatura', 888.0000, 'ºC'),
	(39406, 109, '2015-02-01 01:02:28.000000', 'temperatura', 253.0000, 'ºC'),
	(39407, 109, '2015-02-01 01:02:29.000000', 'temperatura', 999.0000, 'ºC'),
	(39408, 109, '2015-02-01 01:02:30.000000', 'temperatura', 637.0000, 'ºC'),
	(39409, 109, '2015-02-01 01:02:31.000000', 'temperatura', 189.0000, 'ºC'),
	(39410, 109, '2015-02-01 01:02:32.000000', 'temperatura', 235.0000, 'ºC'),
	(39411, 109, '2015-02-01 01:02:33.000000', 'temperatura', 609.0000, 'ºC'),
	(39412, 109, '2015-02-01 01:02:34.000000', 'temperatura', 1141.0000, 'ºC'),
	(39413, 109, '2015-02-01 01:02:35.000000', 'temperatura', 277.0000, 'ºC'),
	(39414, 109, '2015-02-01 01:02:36.000000', 'temperatura', 362.0000, 'ºC'),
	(39415, 109, '2015-02-01 01:02:37.000000', 'temperatura', 982.0000, 'ºC'),
	(39416, 109, '2015-02-01 01:02:38.000000', 'temperatura', 223.0000, 'ºC'),
	(39417, 109, '2015-02-01 01:02:39.000000', 'temperatura', 568.0000, 'ºC'),
	(39418, 109, '2015-02-01 01:02:40.000000', 'temperatura', 974.0000, 'ºC'),
	(39419, 109, '2015-02-01 01:02:41.000000', 'temperatura', 767.0000, 'ºC'),
	(39420, 109, '2015-02-01 01:02:42.000000', 'temperatura', 914.0000, 'ºC'),
	(39421, 109, '2015-02-01 01:02:43.000000', 'temperatura', 1069.0000, 'ºC'),
	(39422, 109, '2015-02-01 01:02:44.000000', 'temperatura', 204.0000, 'ºC'),
	(39423, 109, '2015-02-01 01:02:45.000000', 'temperatura', 212.0000, 'ºC'),
	(39424, 109, '2015-02-01 01:02:46.000000', 'temperatura', 449.0000, 'ºC'),
	(39425, 109, '2015-02-01 01:02:47.000000', 'temperatura', 410.0000, 'ºC'),
	(39426, 109, '2015-02-01 01:02:48.000000', 'temperatura', 702.0000, 'ºC'),
	(39427, 109, '2015-02-01 01:02:49.000000', 'temperatura', 1082.0000, 'ºC'),
	(39428, 109, '2015-02-01 01:02:50.000000', 'temperatura', 903.0000, 'ºC'),
	(39429, 109, '2015-02-01 01:02:51.000000', 'temperatura', 72.0000, 'ºC'),
	(39430, 109, '2015-02-01 01:02:52.000000', 'temperatura', 50.0000, 'ºC'),
	(39431, 109, '2015-02-01 01:02:53.000000', 'temperatura', 33.0000, 'ºC'),
	(39432, 109, '2015-02-01 01:02:54.000000', 'temperatura', 17.0000, 'ºC'),
	(39433, 109, '2015-02-01 01:02:55.000000', 'temperatura', 1187.0000, 'ºC'),
	(39434, 109, '2015-02-01 01:02:56.000000', 'temperatura', 1083.0000, 'ºC'),
	(39435, 109, '2015-02-01 01:02:57.000000', 'temperatura', 657.0000, 'ºC'),
	(39436, 109, '2015-02-01 01:02:58.000000', 'temperatura', 34.0000, 'ºC'),
	(39437, 109, '2015-02-01 01:02:59.000000', 'temperatura', 600.0000, 'ºC'),
	(39438, 109, '2015-02-01 01:03:00.000000', 'temperatura', 499.0000, 'ºC'),
	(39439, 109, '2015-02-01 01:03:01.000000', 'temperatura', 695.0000, 'ºC'),
	(39440, 109, '2015-02-01 01:03:02.000000', 'temperatura', 777.0000, 'ºC'),
	(39441, 109, '2015-02-01 01:03:03.000000', 'temperatura', 604.0000, 'ºC'),
	(39442, 109, '2015-02-01 01:03:04.000000', 'temperatura', 686.0000, 'ºC'),
	(39443, 109, '2015-02-01 01:03:05.000000', 'temperatura', 422.0000, 'ºC'),
	(39444, 109, '2015-02-01 01:03:06.000000', 'temperatura', 50.0000, 'ºC'),
	(39445, 109, '2015-02-01 01:03:07.000000', 'temperatura', 186.0000, 'ºC'),
	(39446, 109, '2015-02-01 01:03:08.000000', 'temperatura', 780.0000, 'ºC'),
	(39447, 109, '2015-02-01 01:03:09.000000', 'temperatura', 943.0000, 'ºC'),
	(39448, 109, '2015-02-01 01:03:10.000000', 'temperatura', 1176.0000, 'ºC'),
	(39449, 109, '2015-02-01 01:03:11.000000', 'temperatura', 650.0000, 'ºC'),
	(39450, 109, '2015-02-01 01:03:12.000000', 'temperatura', 925.0000, 'ºC'),
	(39451, 109, '2015-02-01 01:03:13.000000', 'temperatura', 275.0000, 'ºC'),
	(39452, 109, '2015-02-01 01:03:14.000000', 'temperatura', 1001.0000, 'ºC'),
	(39453, 109, '2015-02-01 01:03:15.000000', 'temperatura', 578.0000, 'ºC'),
	(39454, 109, '2015-02-01 01:03:16.000000', 'temperatura', 1089.0000, 'ºC'),
	(39455, 109, '2015-02-01 01:03:17.000000', 'temperatura', 110.0000, 'ºC'),
	(39456, 109, '2015-02-01 01:03:18.000000', 'temperatura', 885.0000, 'ºC'),
	(39457, 109, '2015-02-01 01:03:19.000000', 'temperatura', 496.0000, 'ºC'),
	(39458, 109, '2015-02-01 01:03:20.000000', 'temperatura', 1024.0000, 'ºC'),
	(39459, 109, '2015-02-01 01:03:21.000000', 'temperatura', 32.0000, 'ºC'),
	(39460, 109, '2015-02-01 01:03:22.000000', 'temperatura', 689.0000, 'ºC'),
	(39461, 109, '2015-02-01 01:03:23.000000', 'temperatura', 949.0000, 'ºC'),
	(39462, 109, '2015-02-01 01:03:24.000000', 'temperatura', 280.0000, 'ºC'),
	(39463, 109, '2015-02-01 01:03:25.000000', 'temperatura', 951.0000, 'ºC'),
	(39464, 109, '2015-02-01 01:03:26.000000', 'temperatura', 317.0000, 'ºC'),
	(39465, 109, '2015-02-01 01:03:27.000000', 'temperatura', 1134.0000, 'ºC'),
	(39466, 109, '2015-02-01 01:03:28.000000', 'temperatura', 1116.0000, 'ºC'),
	(39467, 109, '2015-02-01 01:03:29.000000', 'temperatura', 982.0000, 'ºC'),
	(39468, 109, '2015-02-01 01:03:30.000000', 'temperatura', 361.0000, 'ºC'),
	(39469, 109, '2015-02-01 01:03:31.000000', 'temperatura', 61.0000, 'ºC'),
	(39470, 109, '2015-02-01 01:03:32.000000', 'temperatura', 419.0000, 'ºC'),
	(39471, 109, '2015-02-01 01:03:33.000000', 'temperatura', 716.0000, 'ºC'),
	(39472, 109, '2015-02-01 01:03:34.000000', 'temperatura', 1123.0000, 'ºC'),
	(39473, 109, '2015-02-01 01:03:35.000000', 'temperatura', 1068.0000, 'ºC'),
	(39474, 109, '2015-02-01 01:03:36.000000', 'temperatura', 772.0000, 'ºC'),
	(39475, 109, '2015-02-01 01:03:37.000000', 'temperatura', 656.0000, 'ºC'),
	(39476, 109, '2015-02-01 01:03:38.000000', 'temperatura', 964.0000, 'ºC'),
	(39477, 109, '2015-02-01 01:03:39.000000', 'temperatura', 452.0000, 'ºC'),
	(39478, 109, '2015-02-01 01:03:40.000000', 'temperatura', 569.0000, 'ºC'),
	(39479, 109, '2015-02-01 01:03:41.000000', 'temperatura', 289.0000, 'ºC'),
	(39480, 109, '2015-02-01 01:03:42.000000', 'temperatura', 939.0000, 'ºC'),
	(39481, 109, '2015-02-01 01:03:43.000000', 'temperatura', 228.0000, 'ºC'),
	(39482, 109, '2015-02-01 01:03:44.000000', 'temperatura', 725.0000, 'ºC'),
	(39483, 109, '2015-02-01 01:03:45.000000', 'temperatura', 542.0000, 'ºC'),
	(39484, 109, '2015-02-01 01:03:46.000000', 'temperatura', 534.0000, 'ºC'),
	(39485, 109, '2015-02-01 01:03:47.000000', 'temperatura', 1043.0000, 'ºC'),
	(39486, 109, '2015-02-01 01:03:48.000000', 'temperatura', 15.0000, 'ºC'),
	(39487, 109, '2015-02-01 01:03:49.000000', 'temperatura', 548.0000, 'ºC'),
	(39488, 109, '2015-02-01 01:03:50.000000', 'temperatura', 293.0000, 'ºC'),
	(39489, 109, '2015-02-01 01:03:51.000000', 'temperatura', 1022.0000, 'ºC'),
	(39490, 109, '2015-02-01 01:03:52.000000', 'temperatura', 634.0000, 'ºC'),
	(39491, 109, '2015-02-01 01:03:53.000000', 'temperatura', 103.0000, 'ºC'),
	(39492, 109, '2015-02-01 01:03:54.000000', 'temperatura', 1013.0000, 'ºC'),
	(39493, 109, '2015-02-01 01:03:55.000000', 'temperatura', 1155.0000, 'ºC'),
	(39494, 109, '2015-02-01 01:03:56.000000', 'temperatura', 339.0000, 'ºC'),
	(39495, 109, '2015-02-01 01:03:57.000000', 'temperatura', 628.0000, 'ºC'),
	(39496, 109, '2015-02-01 01:03:58.000000', 'temperatura', 924.0000, 'ºC'),
	(39497, 109, '2015-02-01 01:03:59.000000', 'temperatura', 337.0000, 'ºC'),
	(39498, 109, '2015-02-01 01:04:00.000000', 'temperatura', 112.0000, 'ºC'),
	(39499, 109, '2015-02-01 01:04:01.000000', 'temperatura', 749.0000, 'ºC'),
	(39500, 109, '2015-02-01 01:04:02.000000', 'temperatura', 1011.0000, 'ºC'),
	(39501, 109, '2015-02-01 01:04:03.000000', 'temperatura', 407.0000, 'ºC'),
	(39502, 109, '2015-02-01 01:04:04.000000', 'temperatura', 205.0000, 'ºC'),
	(39503, 109, '2015-02-01 01:04:05.000000', 'temperatura', 1005.0000, 'ºC'),
	(39504, 109, '2015-02-01 01:04:06.000000', 'temperatura', 810.0000, 'ºC'),
	(39505, 109, '2015-02-01 01:04:07.000000', 'temperatura', 1035.0000, 'ºC'),
	(39506, 109, '2015-02-01 01:04:08.000000', 'temperatura', 346.0000, 'ºC'),
	(39507, 109, '2015-02-01 01:04:09.000000', 'temperatura', 1023.0000, 'ºC'),
	(39508, 109, '2015-02-01 01:04:10.000000', 'temperatura', 480.0000, 'ºC'),
	(39509, 109, '2015-02-01 01:04:11.000000', 'temperatura', 531.0000, 'ºC'),
	(39510, 109, '2015-02-01 01:04:12.000000', 'temperatura', 15.0000, 'ºC'),
	(39511, 109, '2015-02-01 01:04:13.000000', 'temperatura', 884.0000, 'ºC'),
	(39512, 109, '2015-02-01 01:04:14.000000', 'temperatura', 777.0000, 'ºC'),
	(39513, 109, '2015-02-01 01:04:15.000000', 'temperatura', 31.0000, 'ºC'),
	(39514, 109, '2015-02-01 01:04:16.000000', 'temperatura', 224.0000, 'ºC'),
	(39515, 109, '2015-02-01 01:04:17.000000', 'temperatura', 1028.0000, 'ºC'),
	(39516, 109, '2015-02-01 01:04:18.000000', 'temperatura', 870.0000, 'ºC'),
	(39517, 109, '2015-02-01 01:04:19.000000', 'temperatura', 67.0000, 'ºC'),
	(39518, 109, '2015-02-01 01:04:20.000000', 'temperatura', 124.0000, 'ºC'),
	(39519, 109, '2015-02-01 01:04:21.000000', 'temperatura', 420.0000, 'ºC'),
	(39520, 109, '2015-02-01 01:04:22.000000', 'temperatura', 529.0000, 'ºC'),
	(39521, 109, '2015-02-01 01:04:23.000000', 'temperatura', 185.0000, 'ºC'),
	(39522, 109, '2015-02-01 01:04:24.000000', 'temperatura', 541.0000, 'ºC'),
	(39523, 109, '2015-02-01 01:04:25.000000', 'temperatura', 947.0000, 'ºC'),
	(39524, 109, '2015-02-01 01:04:26.000000', 'temperatura', 714.0000, 'ºC'),
	(39525, 109, '2015-02-01 01:04:27.000000', 'temperatura', 731.0000, 'ºC'),
	(39526, 109, '2015-02-01 01:04:28.000000', 'temperatura', 312.0000, 'ºC'),
	(39527, 109, '2015-02-01 01:04:29.000000', 'temperatura', 570.0000, 'ºC'),
	(39528, 109, '2015-02-01 01:04:30.000000', 'temperatura', 712.0000, 'ºC'),
	(39529, 109, '2015-02-01 01:04:31.000000', 'temperatura', 651.0000, 'ºC'),
	(39530, 109, '2015-02-01 01:04:32.000000', 'temperatura', 1121.0000, 'ºC'),
	(39531, 109, '2015-02-01 01:04:33.000000', 'temperatura', 53.0000, 'ºC'),
	(39532, 109, '2015-02-01 01:04:34.000000', 'temperatura', 500.0000, 'ºC'),
	(39533, 109, '2015-02-01 01:04:35.000000', 'temperatura', 1144.0000, 'ºC'),
	(39534, 109, '2015-02-01 01:04:36.000000', 'temperatura', 618.0000, 'ºC'),
	(39535, 109, '2015-02-01 01:04:37.000000', 'temperatura', 860.0000, 'ºC'),
	(39536, 109, '2015-02-01 01:04:38.000000', 'temperatura', 46.0000, 'ºC'),
	(39537, 109, '2015-02-01 01:04:39.000000', 'temperatura', 51.0000, 'ºC'),
	(39538, 109, '2015-02-01 01:04:40.000000', 'temperatura', 116.0000, 'ºC'),
	(39539, 109, '2015-02-01 01:04:41.000000', 'temperatura', 427.0000, 'ºC'),
	(39540, 109, '2015-02-01 01:04:42.000000', 'temperatura', 586.0000, 'ºC'),
	(39541, 109, '2015-02-01 01:04:43.000000', 'temperatura', 453.0000, 'ºC'),
	(39542, 109, '2015-02-01 01:04:44.000000', 'temperatura', 505.0000, 'ºC'),
	(39543, 109, '2015-02-01 01:04:45.000000', 'temperatura', 1166.0000, 'ºC'),
	(39544, 109, '2015-02-01 01:04:46.000000', 'temperatura', 714.0000, 'ºC'),
	(39545, 109, '2015-02-01 01:04:47.000000', 'temperatura', 76.0000, 'ºC'),
	(39546, 109, '2015-02-01 01:04:48.000000', 'temperatura', 637.0000, 'ºC'),
	(39547, 109, '2015-02-01 01:04:49.000000', 'temperatura', 557.0000, 'ºC'),
	(39548, 109, '2015-02-01 01:04:50.000000', 'temperatura', 876.0000, 'ºC'),
	(39549, 109, '2015-02-01 01:04:51.000000', 'temperatura', 310.0000, 'ºC'),
	(39550, 109, '2015-02-01 01:04:52.000000', 'temperatura', 120.0000, 'ºC'),
	(39551, 109, '2015-02-01 01:04:53.000000', 'temperatura', 872.0000, 'ºC'),
	(39552, 109, '2015-02-01 01:04:54.000000', 'temperatura', 400.0000, 'ºC'),
	(39553, 109, '2015-02-01 01:04:55.000000', 'temperatura', 586.0000, 'ºC'),
	(39554, 109, '2015-02-01 01:04:56.000000', 'temperatura', 529.0000, 'ºC'),
	(39555, 109, '2015-02-01 01:04:57.000000', 'temperatura', 887.0000, 'ºC'),
	(39556, 109, '2015-02-01 01:04:58.000000', 'temperatura', 451.0000, 'ºC'),
	(39557, 109, '2015-02-01 01:04:59.000000', 'temperatura', 793.0000, 'ºC'),
	(39558, 109, '2015-02-01 01:05:00.000000', 'temperatura', 213.0000, 'ºC'),
	(39559, 109, '2015-02-01 01:05:01.000000', 'temperatura', 1085.0000, 'ºC'),
	(39560, 109, '2015-02-01 01:05:02.000000', 'temperatura', 1185.0000, 'ºC'),
	(39561, 109, '2015-02-01 01:05:03.000000', 'temperatura', 274.0000, 'ºC'),
	(39562, 109, '2015-02-01 01:05:04.000000', 'temperatura', 215.0000, 'ºC'),
	(39563, 109, '2015-02-01 01:05:05.000000', 'temperatura', 254.0000, 'ºC'),
	(39564, 109, '2015-02-01 01:05:06.000000', 'temperatura', 625.0000, 'ºC'),
	(39565, 109, '2015-02-01 01:05:07.000000', 'temperatura', 1163.0000, 'ºC'),
	(39566, 109, '2015-02-01 01:05:08.000000', 'temperatura', 340.0000, 'ºC'),
	(39567, 109, '2015-02-01 01:05:09.000000', 'temperatura', 612.0000, 'ºC'),
	(39568, 109, '2015-02-01 01:05:10.000000', 'temperatura', 841.0000, 'ºC'),
	(39569, 109, '2015-02-01 01:05:11.000000', 'temperatura', 1169.0000, 'ºC'),
	(39570, 109, '2015-02-01 01:05:12.000000', 'temperatura', 924.0000, 'ºC'),
	(39571, 109, '2015-02-01 01:05:13.000000', 'temperatura', 1113.0000, 'ºC'),
	(39572, 109, '2015-02-01 01:05:14.000000', 'temperatura', 393.0000, 'ºC'),
	(39573, 109, '2015-02-01 01:05:15.000000', 'temperatura', 1027.0000, 'ºC'),
	(39574, 109, '2015-02-01 01:05:16.000000', 'temperatura', 354.0000, 'ºC'),
	(39575, 109, '2015-02-01 01:05:17.000000', 'temperatura', 1092.0000, 'ºC'),
	(39576, 109, '2015-02-01 01:05:18.000000', 'temperatura', 796.0000, 'ºC'),
	(39577, 109, '2015-02-01 01:05:19.000000', 'temperatura', 708.0000, 'ºC'),
	(39578, 109, '2015-02-01 01:05:20.000000', 'temperatura', 1150.0000, 'ºC'),
	(39579, 109, '2015-02-01 01:05:21.000000', 'temperatura', 28.0000, 'ºC'),
	(39580, 109, '2015-02-01 01:05:22.000000', 'temperatura', 292.0000, 'ºC'),
	(39581, 109, '2015-02-01 01:05:23.000000', 'temperatura', 175.0000, 'ºC'),
	(39582, 109, '2015-02-01 01:05:24.000000', 'temperatura', 1198.0000, 'ºC'),
	(39583, 109, '2015-02-01 01:05:25.000000', 'temperatura', 666.0000, 'ºC'),
	(39584, 109, '2015-02-01 01:05:26.000000', 'temperatura', 937.0000, 'ºC'),
	(39585, 109, '2015-02-01 01:05:27.000000', 'temperatura', 287.0000, 'ºC'),
	(39586, 109, '2015-02-01 01:05:28.000000', 'temperatura', 1024.0000, 'ºC'),
	(39587, 109, '2015-02-01 01:05:29.000000', 'temperatura', 660.0000, 'ºC'),
	(39588, 109, '2015-02-01 01:05:30.000000', 'temperatura', 227.0000, 'ºC'),
	(39589, 109, '2015-02-01 01:05:31.000000', 'temperatura', 358.0000, 'ºC'),
	(39590, 109, '2015-02-01 01:05:32.000000', 'temperatura', 1109.0000, 'ºC'),
	(39591, 109, '2015-02-01 01:05:33.000000', 'temperatura', 872.0000, 'ºC'),
	(39592, 109, '2015-02-01 01:05:34.000000', 'temperatura', 1034.0000, 'ºC'),
	(39593, 109, '2015-02-01 01:05:35.000000', 'temperatura', 154.0000, 'ºC'),
	(39594, 109, '2015-02-01 01:05:36.000000', 'temperatura', 66.0000, 'ºC'),
	(39595, 109, '2015-02-01 01:05:37.000000', 'temperatura', 1071.0000, 'ºC'),
	(39596, 109, '2015-02-01 01:05:38.000000', 'temperatura', 357.0000, 'ºC'),
	(39597, 109, '2015-02-01 01:05:39.000000', 'temperatura', 974.0000, 'ºC'),
	(39598, 109, '2015-02-01 01:05:40.000000', 'temperatura', 197.0000, 'ºC'),
	(39599, 109, '2015-02-01 01:05:41.000000', 'temperatura', 464.0000, 'ºC'),
	(39600, 109, '2015-02-01 01:05:42.000000', 'temperatura', 528.0000, 'ºC'),
	(39601, 109, '2015-02-01 01:05:43.000000', 'temperatura', 52.0000, 'ºC'),
	(39602, 109, '2015-02-01 01:05:44.000000', 'temperatura', 1073.0000, 'ºC'),
	(39603, 109, '2015-02-01 01:05:45.000000', 'temperatura', 411.0000, 'ºC'),
	(39604, 109, '2015-02-01 01:05:46.000000', 'temperatura', 38.0000, 'ºC'),
	(39605, 109, '2015-02-01 01:05:47.000000', 'temperatura', 156.0000, 'ºC'),
	(39606, 109, '2015-02-01 01:05:48.000000', 'temperatura', 667.0000, 'ºC'),
	(39607, 109, '2015-02-01 01:05:49.000000', 'temperatura', 467.0000, 'ºC'),
	(39608, 109, '2015-02-01 01:05:50.000000', 'temperatura', 334.0000, 'ºC'),
	(39609, 109, '2015-02-01 01:05:51.000000', 'temperatura', 270.0000, 'ºC'),
	(39610, 109, '2015-02-01 01:05:52.000000', 'temperatura', 349.0000, 'ºC'),
	(39611, 109, '2015-02-01 01:05:53.000000', 'temperatura', 936.0000, 'ºC'),
	(39612, 109, '2015-02-01 01:05:54.000000', 'temperatura', 33.0000, 'ºC'),
	(39613, 109, '2015-02-01 01:05:55.000000', 'temperatura', 959.0000, 'ºC'),
	(39614, 109, '2015-02-01 01:05:56.000000', 'temperatura', 1095.0000, 'ºC'),
	(39615, 109, '2015-02-01 01:05:57.000000', 'temperatura', 197.0000, 'ºC'),
	(39616, 109, '2015-02-01 01:05:58.000000', 'temperatura', 101.0000, 'ºC'),
	(39617, 109, '2015-02-01 01:05:59.000000', 'temperatura', 1114.0000, 'ºC'),
	(39618, 109, '2015-02-01 01:06:00.000000', 'temperatura', 467.0000, 'ºC'),
	(39619, 109, '2015-02-01 01:06:01.000000', 'temperatura', 194.0000, 'ºC'),
	(39620, 109, '2015-02-01 01:06:02.000000', 'temperatura', 770.0000, 'ºC'),
	(39621, 109, '2015-02-01 01:06:03.000000', 'temperatura', 866.0000, 'ºC'),
	(39622, 109, '2015-02-01 01:06:04.000000', 'temperatura', 823.0000, 'ºC'),
	(39623, 109, '2015-02-01 01:06:05.000000', 'temperatura', 317.0000, 'ºC'),
	(39624, 109, '2015-02-01 01:06:06.000000', 'temperatura', 316.0000, 'ºC'),
	(39625, 109, '2015-02-01 01:06:07.000000', 'temperatura', 631.0000, 'ºC'),
	(39626, 109, '2015-02-01 01:06:08.000000', 'temperatura', 1006.0000, 'ºC'),
	(39627, 109, '2015-02-01 01:06:09.000000', 'temperatura', 738.0000, 'ºC'),
	(39628, 109, '2015-02-01 01:06:10.000000', 'temperatura', 673.0000, 'ºC'),
	(39629, 109, '2015-02-01 01:06:11.000000', 'temperatura', 1150.0000, 'ºC'),
	(39630, 109, '2015-02-01 01:06:12.000000', 'temperatura', 132.0000, 'ºC'),
	(39631, 109, '2015-02-01 01:06:13.000000', 'temperatura', 811.0000, 'ºC'),
	(39632, 109, '2015-02-01 01:06:14.000000', 'temperatura', 61.0000, 'ºC'),
	(39633, 109, '2015-02-01 01:06:15.000000', 'temperatura', 271.0000, 'ºC'),
	(39634, 109, '2015-02-01 01:06:16.000000', 'temperatura', 1171.0000, 'ºC'),
	(39635, 109, '2015-02-01 01:06:17.000000', 'temperatura', 243.0000, 'ºC'),
	(39636, 109, '2015-02-01 01:06:18.000000', 'temperatura', 104.0000, 'ºC'),
	(39637, 109, '2015-02-01 01:06:19.000000', 'temperatura', 993.0000, 'ºC'),
	(39638, 109, '2015-02-01 01:06:20.000000', 'temperatura', 1052.0000, 'ºC'),
	(39639, 109, '2015-02-01 01:06:21.000000', 'temperatura', 1080.0000, 'ºC'),
	(39640, 109, '2015-02-01 01:06:22.000000', 'temperatura', 1043.0000, 'ºC'),
	(39641, 109, '2015-02-01 01:06:23.000000', 'temperatura', 779.0000, 'ºC'),
	(39642, 109, '2015-02-01 01:06:24.000000', 'temperatura', 766.0000, 'ºC'),
	(39643, 109, '2015-02-01 01:06:25.000000', 'temperatura', 295.0000, 'ºC'),
	(39644, 109, '2015-02-01 01:06:26.000000', 'temperatura', 377.0000, 'ºC'),
	(39645, 109, '2015-02-01 01:06:27.000000', 'temperatura', 998.0000, 'ºC'),
	(39646, 109, '2015-02-01 01:06:28.000000', 'temperatura', 262.0000, 'ºC'),
	(39647, 109, '2015-02-01 01:06:29.000000', 'temperatura', 716.0000, 'ºC'),
	(39648, 109, '2015-02-01 01:06:30.000000', 'temperatura', 392.0000, 'ºC'),
	(39649, 109, '2015-02-01 01:06:31.000000', 'temperatura', 1016.0000, 'ºC'),
	(39650, 109, '2015-02-01 01:06:32.000000', 'temperatura', 303.0000, 'ºC'),
	(39651, 109, '2015-02-01 01:06:33.000000', 'temperatura', 868.0000, 'ºC'),
	(39652, 109, '2015-02-01 01:06:34.000000', 'temperatura', 1033.0000, 'ºC'),
	(39653, 109, '2015-02-01 01:06:35.000000', 'temperatura', 161.0000, 'ºC'),
	(39654, 109, '2015-02-01 01:06:36.000000', 'temperatura', 105.0000, 'ºC'),
	(39655, 109, '2015-02-01 01:06:37.000000', 'temperatura', 42.0000, 'ºC'),
	(39656, 109, '2015-02-01 01:06:38.000000', 'temperatura', 1096.0000, 'ºC'),
	(39657, 109, '2015-02-01 01:06:39.000000', 'temperatura', 555.0000, 'ºC'),
	(39658, 109, '2015-02-01 01:06:40.000000', 'temperatura', 688.0000, 'ºC'),
	(39659, 109, '2015-02-01 01:06:41.000000', 'temperatura', 575.0000, 'ºC'),
	(39660, 109, '2015-02-01 01:06:42.000000', 'temperatura', 811.0000, 'ºC'),
	(39661, 109, '2015-02-01 01:06:43.000000', 'temperatura', 1132.0000, 'ºC'),
	(39662, 109, '2015-02-01 01:06:44.000000', 'temperatura', 828.0000, 'ºC'),
	(39663, 109, '2015-02-01 01:06:45.000000', 'temperatura', 745.0000, 'ºC'),
	(39664, 109, '2015-02-01 01:06:46.000000', 'temperatura', 43.0000, 'ºC'),
	(39665, 109, '2015-02-01 01:06:47.000000', 'temperatura', 377.0000, 'ºC'),
	(39666, 109, '2015-02-01 01:06:48.000000', 'temperatura', 557.0000, 'ºC'),
	(39667, 109, '2015-02-01 01:06:49.000000', 'temperatura', 456.0000, 'ºC'),
	(39668, 109, '2015-02-01 01:06:50.000000', 'temperatura', 610.0000, 'ºC'),
	(39669, 109, '2015-02-01 01:06:51.000000', 'temperatura', 483.0000, 'ºC'),
	(39670, 109, '2015-02-01 01:06:52.000000', 'temperatura', 584.0000, 'ºC'),
	(39671, 109, '2015-02-01 01:06:53.000000', 'temperatura', 273.0000, 'ºC'),
	(39672, 109, '2015-02-01 01:06:54.000000', 'temperatura', 813.0000, 'ºC'),
	(39673, 109, '2015-02-01 01:06:55.000000', 'temperatura', 844.0000, 'ºC'),
	(39674, 109, '2015-02-01 01:06:56.000000', 'temperatura', 585.0000, 'ºC'),
	(39675, 109, '2015-02-01 01:06:57.000000', 'temperatura', 392.0000, 'ºC'),
	(39676, 109, '2015-02-01 01:06:58.000000', 'temperatura', 205.0000, 'ºC'),
	(39677, 109, '2015-02-01 01:06:59.000000', 'temperatura', 1049.0000, 'ºC'),
	(39678, 109, '2015-02-01 01:07:00.000000', 'temperatura', 1033.0000, 'ºC'),
	(39679, 109, '2015-02-01 01:07:01.000000', 'temperatura', 817.0000, 'ºC'),
	(39680, 109, '2015-02-01 01:07:02.000000', 'temperatura', 985.0000, 'ºC'),
	(39681, 109, '2015-02-01 01:07:03.000000', 'temperatura', 77.0000, 'ºC'),
	(39682, 109, '2015-02-01 01:07:04.000000', 'temperatura', 1029.0000, 'ºC'),
	(39683, 109, '2015-02-01 01:07:05.000000', 'temperatura', 117.0000, 'ºC'),
	(39684, 109, '2015-02-01 01:07:06.000000', 'temperatura', 1097.0000, 'ºC'),
	(39685, 109, '2015-02-01 01:07:07.000000', 'temperatura', 335.0000, 'ºC'),
	(39686, 109, '2015-02-01 01:07:08.000000', 'temperatura', 784.0000, 'ºC'),
	(39687, 109, '2015-02-01 01:07:09.000000', 'temperatura', 514.0000, 'ºC'),
	(39688, 110, '2015-02-01 00:00:00.000000', 'temperatura', 751.0000, 'ºC'),
	(39689, 110, '2015-02-01 00:00:01.000000', 'temperatura', 702.0000, 'ºC'),
	(39690, 110, '2015-02-01 00:00:02.000000', 'temperatura', 58.0000, 'ºC'),
	(39691, 110, '2015-02-01 00:00:03.000000', 'temperatura', 582.0000, 'ºC'),
	(39692, 110, '2015-02-01 00:00:04.000000', 'temperatura', 338.0000, 'ºC'),
	(39693, 110, '2015-02-01 00:00:05.000000', 'temperatura', 1144.0000, 'ºC'),
	(39694, 110, '2015-02-01 00:00:06.000000', 'temperatura', 1106.0000, 'ºC'),
	(39695, 110, '2015-02-01 00:00:07.000000', 'temperatura', 899.0000, 'ºC'),
	(39696, 110, '2015-02-01 00:00:08.000000', 'temperatura', 1178.0000, 'ºC'),
	(39697, 110, '2015-02-01 00:00:09.000000', 'temperatura', 792.0000, 'ºC'),
	(39698, 110, '2015-02-01 00:00:10.000000', 'temperatura', 426.0000, 'ºC'),
	(39699, 110, '2015-02-01 00:00:11.000000', 'temperatura', 957.0000, 'ºC'),
	(39700, 110, '2015-02-01 00:00:12.000000', 'temperatura', 1105.0000, 'ºC'),
	(39701, 110, '2015-02-01 00:00:13.000000', 'temperatura', 254.0000, 'ºC'),
	(39702, 110, '2015-02-01 00:00:14.000000', 'temperatura', 357.0000, 'ºC'),
	(39703, 110, '2015-02-01 00:00:15.000000', 'temperatura', 1021.0000, 'ºC'),
	(39704, 110, '2015-02-01 00:00:16.000000', 'temperatura', 436.0000, 'ºC'),
	(39705, 110, '2015-02-01 00:00:17.000000', 'temperatura', 319.0000, 'ºC'),
	(39706, 110, '2015-02-01 00:00:18.000000', 'temperatura', 288.0000, 'ºC'),
	(39707, 110, '2015-02-01 00:00:19.000000', 'temperatura', 483.0000, 'ºC'),
	(39708, 110, '2015-02-01 00:00:20.000000', 'temperatura', 352.0000, 'ºC'),
	(39709, 110, '2015-02-01 00:00:21.000000', 'temperatura', 309.0000, 'ºC'),
	(39710, 110, '2015-02-01 00:00:22.000000', 'temperatura', 492.0000, 'ºC'),
	(39711, 110, '2015-02-01 00:00:23.000000', 'temperatura', 334.0000, 'ºC'),
	(39712, 110, '2015-02-01 00:00:24.000000', 'temperatura', 193.0000, 'ºC'),
	(39713, 110, '2015-02-01 00:00:25.000000', 'temperatura', 1162.0000, 'ºC'),
	(39714, 110, '2015-02-01 00:00:26.000000', 'temperatura', 434.0000, 'ºC'),
	(39715, 110, '2015-02-01 00:00:27.000000', 'temperatura', 1084.0000, 'ºC'),
	(39716, 110, '2015-02-01 00:00:28.000000', 'temperatura', 518.0000, 'ºC'),
	(39717, 110, '2015-02-01 00:00:29.000000', 'temperatura', 538.0000, 'ºC'),
	(39718, 110, '2015-02-01 00:00:30.000000', 'temperatura', 1135.0000, 'ºC'),
	(39719, 110, '2015-02-01 00:00:31.000000', 'temperatura', 464.0000, 'ºC'),
	(39720, 110, '2015-02-01 00:00:32.000000', 'temperatura', 117.0000, 'ºC'),
	(39721, 110, '2015-02-01 00:00:33.000000', 'temperatura', 390.0000, 'ºC'),
	(39722, 110, '2015-02-01 00:00:34.000000', 'temperatura', 401.0000, 'ºC'),
	(39723, 110, '2015-02-01 00:00:35.000000', 'temperatura', 837.0000, 'ºC'),
	(39724, 110, '2015-02-01 00:00:36.000000', 'temperatura', 584.0000, 'ºC'),
	(39725, 110, '2015-02-01 00:00:37.000000', 'temperatura', 406.0000, 'ºC'),
	(39726, 110, '2015-02-01 00:00:38.000000', 'temperatura', 278.0000, 'ºC'),
	(39727, 110, '2015-02-01 00:00:39.000000', 'temperatura', 174.0000, 'ºC'),
	(39728, 110, '2015-02-01 00:00:40.000000', 'temperatura', 35.0000, 'ºC'),
	(39729, 110, '2015-02-01 00:00:41.000000', 'temperatura', 853.0000, 'ºC'),
	(39730, 110, '2015-02-01 00:00:42.000000', 'temperatura', 561.0000, 'ºC'),
	(39731, 110, '2015-02-01 00:00:43.000000', 'temperatura', 247.0000, 'ºC'),
	(39732, 110, '2015-02-01 00:00:44.000000', 'temperatura', 754.0000, 'ºC'),
	(39733, 110, '2015-02-01 00:00:45.000000', 'temperatura', 627.0000, 'ºC'),
	(39734, 110, '2015-02-01 00:00:46.000000', 'temperatura', 873.0000, 'ºC'),
	(39735, 110, '2015-02-01 00:00:47.000000', 'temperatura', 84.0000, 'ºC'),
	(39736, 110, '2015-02-01 00:00:48.000000', 'temperatura', 201.0000, 'ºC'),
	(39737, 110, '2015-02-01 00:00:49.000000', 'temperatura', 753.0000, 'ºC'),
	(39738, 110, '2015-02-01 00:00:50.000000', 'temperatura', 763.0000, 'ºC'),
	(39739, 110, '2015-02-01 00:00:51.000000', 'temperatura', 358.0000, 'ºC'),
	(39740, 110, '2015-02-01 00:00:52.000000', 'temperatura', 703.0000, 'ºC'),
	(39741, 110, '2015-02-01 00:00:53.000000', 'temperatura', 38.0000, 'ºC'),
	(39742, 110, '2015-02-01 00:00:54.000000', 'temperatura', 483.0000, 'ºC'),
	(39743, 110, '2015-02-01 00:00:55.000000', 'temperatura', 1102.0000, 'ºC'),
	(39744, 110, '2015-02-01 00:00:56.000000', 'temperatura', 461.0000, 'ºC'),
	(39745, 110, '2015-02-01 00:00:57.000000', 'temperatura', 200.0000, 'ºC'),
	(39746, 110, '2015-02-01 00:00:58.000000', 'temperatura', 818.0000, 'ºC'),
	(39747, 110, '2015-02-01 00:00:59.000000', 'temperatura', 1089.0000, 'ºC'),
	(39748, 110, '2015-02-01 00:01:00.000000', 'temperatura', 590.0000, 'ºC'),
	(39749, 110, '2015-02-01 00:01:01.000000', 'temperatura', 885.0000, 'ºC'),
	(39750, 110, '2015-02-01 00:01:02.000000', 'temperatura', 257.0000, 'ºC'),
	(39751, 110, '2015-02-01 00:01:03.000000', 'temperatura', 1031.0000, 'ºC'),
	(39752, 110, '2015-02-01 00:01:04.000000', 'temperatura', 783.0000, 'ºC'),
	(39753, 110, '2015-02-01 00:01:05.000000', 'temperatura', 825.0000, 'ºC'),
	(39754, 110, '2015-02-01 00:01:06.000000', 'temperatura', 574.0000, 'ºC'),
	(39755, 110, '2015-02-01 00:01:07.000000', 'temperatura', 394.0000, 'ºC'),
	(39756, 110, '2015-02-01 00:01:08.000000', 'temperatura', 251.0000, 'ºC'),
	(39757, 110, '2015-02-01 00:01:09.000000', 'temperatura', 71.0000, 'ºC'),
	(39758, 110, '2015-02-01 00:01:10.000000', 'temperatura', 805.0000, 'ºC'),
	(39759, 110, '2015-02-01 00:01:11.000000', 'temperatura', 211.0000, 'ºC'),
	(39760, 110, '2015-02-01 00:01:12.000000', 'temperatura', 1040.0000, 'ºC'),
	(39761, 110, '2015-02-01 00:01:13.000000', 'temperatura', 969.0000, 'ºC'),
	(39762, 110, '2015-02-01 00:01:14.000000', 'temperatura', 526.0000, 'ºC'),
	(39763, 110, '2015-02-01 00:01:15.000000', 'temperatura', 925.0000, 'ºC'),
	(39764, 110, '2015-02-01 00:01:16.000000', 'temperatura', 645.0000, 'ºC'),
	(39765, 110, '2015-02-01 00:01:17.000000', 'temperatura', 450.0000, 'ºC'),
	(39766, 110, '2015-02-01 00:01:18.000000', 'temperatura', 314.0000, 'ºC'),
	(39767, 110, '2015-02-01 00:01:19.000000', 'temperatura', 224.0000, 'ºC'),
	(39768, 110, '2015-02-01 00:01:20.000000', 'temperatura', 177.0000, 'ºC'),
	(39769, 110, '2015-02-01 00:01:21.000000', 'temperatura', 214.0000, 'ºC'),
	(39770, 110, '2015-02-01 00:01:22.000000', 'temperatura', 538.0000, 'ºC'),
	(39771, 110, '2015-02-01 00:01:23.000000', 'temperatura', 850.0000, 'ºC'),
	(39772, 110, '2015-02-01 00:01:24.000000', 'temperatura', 234.0000, 'ºC'),
	(39773, 110, '2015-02-01 00:01:25.000000', 'temperatura', 1022.0000, 'ºC'),
	(39774, 110, '2015-02-01 00:01:26.000000', 'temperatura', 810.0000, 'ºC'),
	(39775, 110, '2015-02-01 00:01:27.000000', 'temperatura', 982.0000, 'ºC'),
	(39776, 110, '2015-02-01 00:01:28.000000', 'temperatura', 80.0000, 'ºC'),
	(39777, 110, '2015-02-01 00:01:29.000000', 'temperatura', 1057.0000, 'ºC'),
	(39778, 110, '2015-02-01 00:01:30.000000', 'temperatura', 246.0000, 'ºC'),
	(39779, 110, '2015-02-01 00:01:31.000000', 'temperatura', 457.0000, 'ºC'),
	(39780, 110, '2015-02-01 00:01:32.000000', 'temperatura', 349.0000, 'ºC'),
	(39781, 110, '2015-02-01 00:01:33.000000', 'temperatura', 374.0000, 'ºC'),
	(39782, 110, '2015-02-01 00:01:34.000000', 'temperatura', 823.0000, 'ºC'),
	(39783, 110, '2015-02-01 00:01:35.000000', 'temperatura', 596.0000, 'ºC'),
	(39784, 110, '2015-02-01 00:01:36.000000', 'temperatura', 510.0000, 'ºC'),
	(39785, 110, '2015-02-01 00:01:37.000000', 'temperatura', 762.0000, 'ºC'),
	(39786, 110, '2015-02-01 00:01:38.000000', 'temperatura', 1081.0000, 'ºC'),
	(39787, 110, '2015-02-01 00:01:39.000000', 'temperatura', 721.0000, 'ºC'),
	(39788, 110, '2015-02-01 00:01:40.000000', 'temperatura', 361.0000, 'ºC'),
	(39789, 110, '2015-02-01 00:01:41.000000', 'temperatura', 841.0000, 'ºC'),
	(39790, 110, '2015-02-01 00:01:42.000000', 'temperatura', 723.0000, 'ºC'),
	(39791, 110, '2015-02-01 00:01:43.000000', 'temperatura', 1091.0000, 'ºC'),
	(39792, 110, '2015-02-01 00:01:44.000000', 'temperatura', 888.0000, 'ºC'),
	(39793, 110, '2015-02-01 00:01:45.000000', 'temperatura', 1167.0000, 'ºC'),
	(39794, 110, '2015-02-01 00:01:46.000000', 'temperatura', 773.0000, 'ºC'),
	(39795, 110, '2015-02-01 00:01:47.000000', 'temperatura', 365.0000, 'ºC'),
	(39796, 110, '2015-02-01 00:01:48.000000', 'temperatura', 705.0000, 'ºC'),
	(39797, 110, '2015-02-01 00:01:49.000000', 'temperatura', 32.0000, 'ºC'),
	(39798, 110, '2015-02-01 00:01:50.000000', 'temperatura', 443.0000, 'ºC'),
	(39799, 110, '2015-02-01 00:01:51.000000', 'temperatura', 919.0000, 'ºC'),
	(39800, 110, '2015-02-01 00:01:52.000000', 'temperatura', 868.0000, 'ºC'),
	(39801, 110, '2015-02-01 00:01:53.000000', 'temperatura', 385.0000, 'ºC'),
	(39802, 110, '2015-02-01 00:01:54.000000', 'temperatura', 518.0000, 'ºC'),
	(39803, 110, '2015-02-01 00:01:55.000000', 'temperatura', 238.0000, 'ºC'),
	(39804, 110, '2015-02-01 00:01:56.000000', 'temperatura', 837.0000, 'ºC'),
	(39805, 110, '2015-02-01 00:01:57.000000', 'temperatura', 1071.0000, 'ºC'),
	(39806, 110, '2015-02-01 00:01:58.000000', 'temperatura', 444.0000, 'ºC'),
	(39807, 110, '2015-02-01 00:01:59.000000', 'temperatura', 208.0000, 'ºC'),
	(39808, 110, '2015-02-01 00:02:00.000000', 'temperatura', 907.0000, 'ºC'),
	(39809, 110, '2015-02-01 00:02:01.000000', 'temperatura', 313.0000, 'ºC'),
	(39810, 110, '2015-02-01 00:02:02.000000', 'temperatura', 44.0000, 'ºC'),
	(39811, 110, '2015-02-01 00:02:03.000000', 'temperatura', 483.0000, 'ºC'),
	(39812, 110, '2015-02-01 00:02:04.000000', 'temperatura', 1084.0000, 'ºC'),
	(39813, 110, '2015-02-01 00:02:05.000000', 'temperatura', 368.0000, 'ºC'),
	(39814, 110, '2015-02-01 00:02:06.000000', 'temperatura', 992.0000, 'ºC'),
	(39815, 110, '2015-02-01 00:02:07.000000', 'temperatura', 255.0000, 'ºC'),
	(39816, 110, '2015-02-01 00:02:08.000000', 'temperatura', 698.0000, 'ºC'),
	(39817, 110, '2015-02-01 00:02:09.000000', 'temperatura', 327.0000, 'ºC'),
	(39818, 110, '2015-02-01 00:02:10.000000', 'temperatura', 743.0000, 'ºC'),
	(39819, 110, '2015-02-01 00:02:11.000000', 'temperatura', 335.0000, 'ºC'),
	(39820, 110, '2015-02-01 00:02:12.000000', 'temperatura', 645.0000, 'ºC'),
	(39821, 110, '2015-02-01 00:02:13.000000', 'temperatura', 1022.0000, 'ºC'),
	(39822, 110, '2015-02-01 00:02:14.000000', 'temperatura', 775.0000, 'ºC'),
	(39823, 110, '2015-02-01 00:02:15.000000', 'temperatura', 810.0000, 'ºC'),
	(39824, 110, '2015-02-01 00:02:16.000000', 'temperatura', 523.0000, 'ºC'),
	(39825, 110, '2015-02-01 00:02:17.000000', 'temperatura', 187.0000, 'ºC'),
	(39826, 110, '2015-02-01 00:02:18.000000', 'temperatura', 568.0000, 'ºC'),
	(39827, 110, '2015-02-01 00:02:19.000000', 'temperatura', 1079.0000, 'ºC'),
	(39828, 110, '2015-02-01 00:02:20.000000', 'temperatura', 90.0000, 'ºC'),
	(39829, 110, '2015-02-01 00:02:21.000000', 'temperatura', 815.0000, 'ºC'),
	(39830, 110, '2015-02-01 00:02:22.000000', 'temperatura', 206.0000, 'ºC'),
	(39831, 110, '2015-02-01 00:02:23.000000', 'temperatura', 983.0000, 'ºC'),
	(39832, 110, '2015-02-01 00:02:24.000000', 'temperatura', 698.0000, 'ºC'),
	(39833, 110, '2015-02-01 00:02:25.000000', 'temperatura', 542.0000, 'ºC'),
	(39834, 110, '2015-02-01 00:02:26.000000', 'temperatura', 618.0000, 'ºC'),
	(39835, 110, '2015-02-01 00:02:27.000000', 'temperatura', 262.0000, 'ºC'),
	(39836, 110, '2015-02-01 00:02:28.000000', 'temperatura', 658.0000, 'ºC'),
	(39837, 110, '2015-02-01 00:02:29.000000', 'temperatura', 104.0000, 'ºC'),
	(39838, 110, '2015-02-01 00:02:30.000000', 'temperatura', 945.0000, 'ºC'),
	(39839, 110, '2015-02-01 00:02:31.000000', 'temperatura', 816.0000, 'ºC'),
	(39840, 110, '2015-02-01 00:02:32.000000', 'temperatura', 46.0000, 'ºC'),
	(39841, 110, '2015-02-01 00:02:33.000000', 'temperatura', 181.0000, 'ºC'),
	(39842, 110, '2015-02-01 00:02:34.000000', 'temperatura', 768.0000, 'ºC'),
	(39843, 110, '2015-02-01 00:02:35.000000', 'temperatura', 899.0000, 'ºC'),
	(39844, 110, '2015-02-01 00:02:36.000000', 'temperatura', 992.0000, 'ºC'),
	(39845, 110, '2015-02-01 00:02:37.000000', 'temperatura', 1061.0000, 'ºC'),
	(39846, 110, '2015-02-01 00:02:38.000000', 'temperatura', 1131.0000, 'ºC'),
	(39847, 110, '2015-02-01 00:02:39.000000', 'temperatura', 70.0000, 'ºC'),
	(39848, 110, '2015-02-01 00:02:40.000000', 'temperatura', 560.0000, 'ºC'),
	(39849, 110, '2015-02-01 00:02:41.000000', 'temperatura', 189.0000, 'ºC'),
	(39850, 110, '2015-02-01 00:02:42.000000', 'temperatura', 464.0000, 'ºC'),
	(39851, 110, '2015-02-01 00:02:43.000000', 'temperatura', 555.0000, 'ºC'),
	(39852, 110, '2015-02-01 00:02:44.000000', 'temperatura', 182.0000, 'ºC'),
	(39853, 110, '2015-02-01 00:02:45.000000', 'temperatura', 446.0000, 'ºC'),
	(39854, 110, '2015-02-01 00:02:46.000000', 'temperatura', 486.0000, 'ºC'),
	(39855, 110, '2015-02-01 00:02:47.000000', 'temperatura', 1092.0000, 'ºC'),
	(39856, 110, '2015-02-01 00:02:48.000000', 'temperatura', 402.0000, 'ºC'),
	(39857, 110, '2015-02-01 00:02:49.000000', 'temperatura', 1136.0000, 'ºC'),
	(39858, 110, '2015-02-01 00:02:50.000000', 'temperatura', 874.0000, 'ºC'),
	(39859, 110, '2015-02-01 00:02:51.000000', 'temperatura', 962.0000, 'ºC'),
	(39860, 110, '2015-02-01 00:02:52.000000', 'temperatura', 988.0000, 'ºC'),
	(39861, 110, '2015-02-01 00:02:53.000000', 'temperatura', 855.0000, 'ºC'),
	(39862, 110, '2015-02-01 00:02:54.000000', 'temperatura', 111.0000, 'ºC'),
	(39863, 110, '2015-02-01 00:02:55.000000', 'temperatura', 390.0000, 'ºC'),
	(39864, 110, '2015-02-01 00:02:56.000000', 'temperatura', 419.0000, 'ºC'),
	(39865, 110, '2015-02-01 00:02:57.000000', 'temperatura', 924.0000, 'ºC'),
	(39866, 110, '2015-02-01 00:02:58.000000', 'temperatura', 962.0000, 'ºC'),
	(39867, 110, '2015-02-01 00:02:59.000000', 'temperatura', 842.0000, 'ºC'),
	(39868, 110, '2015-02-01 00:03:00.000000', 'temperatura', 123.0000, 'ºC'),
	(39869, 110, '2015-02-01 00:03:01.000000', 'temperatura', 490.0000, 'ºC'),
	(39870, 110, '2015-02-01 00:03:02.000000', 'temperatura', 881.0000, 'ºC'),
	(39871, 110, '2015-02-01 00:03:03.000000', 'temperatura', 534.0000, 'ºC'),
	(39872, 110, '2015-02-01 00:03:04.000000', 'temperatura', 29.0000, 'ºC'),
	(39873, 110, '2015-02-01 00:03:05.000000', 'temperatura', 943.0000, 'ºC'),
	(39874, 110, '2015-02-01 00:03:06.000000', 'temperatura', 1027.0000, 'ºC'),
	(39875, 110, '2015-02-01 00:03:07.000000', 'temperatura', 1109.0000, 'ºC'),
	(39876, 110, '2015-02-01 00:03:08.000000', 'temperatura', 65.0000, 'ºC'),
	(39877, 110, '2015-02-01 00:03:09.000000', 'temperatura', 599.0000, 'ºC'),
	(39878, 110, '2015-02-01 00:03:10.000000', 'temperatura', 401.0000, 'ºC'),
	(39879, 110, '2015-02-01 00:03:11.000000', 'temperatura', 207.0000, 'ºC'),
	(39880, 110, '2015-02-01 00:03:12.000000', 'temperatura', 1034.0000, 'ºC'),
	(39881, 110, '2015-02-01 00:03:13.000000', 'temperatura', 948.0000, 'ºC'),
	(39882, 110, '2015-02-01 00:03:14.000000', 'temperatura', 438.0000, 'ºC'),
	(39883, 110, '2015-02-01 00:03:15.000000', 'temperatura', 549.0000, 'ºC'),
	(39884, 110, '2015-02-01 00:03:16.000000', 'temperatura', 229.0000, 'ºC'),
	(39885, 110, '2015-02-01 00:03:17.000000', 'temperatura', 699.0000, 'ºC'),
	(39886, 110, '2015-02-01 00:03:18.000000', 'temperatura', 407.0000, 'ºC'),
	(39887, 110, '2015-02-01 00:03:19.000000', 'temperatura', 1142.0000, 'ºC'),
	(39888, 110, '2015-02-01 00:03:20.000000', 'temperatura', 887.0000, 'ºC'),
	(39889, 110, '2015-02-01 00:03:21.000000', 'temperatura', 1010.0000, 'ºC'),
	(39890, 110, '2015-02-01 00:03:22.000000', 'temperatura', 1191.0000, 'ºC'),
	(39891, 110, '2015-02-01 00:03:23.000000', 'temperatura', 524.0000, 'ºC'),
	(39892, 110, '2015-02-01 00:03:24.000000', 'temperatura', 248.0000, 'ºC'),
	(39893, 110, '2015-02-01 00:03:25.000000', 'temperatura', 870.0000, 'ºC'),
	(39894, 110, '2015-02-01 00:03:26.000000', 'temperatura', 7.0000, 'ºC'),
	(39895, 110, '2015-02-01 00:03:27.000000', 'temperatura', 1026.0000, 'ºC'),
	(39896, 110, '2015-02-01 00:03:28.000000', 'temperatura', 310.0000, 'ºC'),
	(39897, 110, '2015-02-01 00:03:29.000000', 'temperatura', 872.0000, 'ºC'),
	(39898, 110, '2015-02-01 00:03:30.000000', 'temperatura', 1029.0000, 'ºC'),
	(39899, 110, '2015-02-01 00:03:31.000000', 'temperatura', 132.0000, 'ºC'),
	(39900, 110, '2015-02-01 00:03:32.000000', 'temperatura', 1172.0000, 'ºC'),
	(39901, 110, '2015-02-01 00:03:33.000000', 'temperatura', 664.0000, 'ºC'),
	(39902, 110, '2015-02-01 00:03:34.000000', 'temperatura', 1004.0000, 'ºC'),
	(39903, 110, '2015-02-01 00:03:35.000000', 'temperatura', 630.0000, 'ºC'),
	(39904, 110, '2015-02-01 00:03:36.000000', 'temperatura', 139.0000, 'ºC'),
	(39905, 110, '2015-02-01 00:03:37.000000', 'temperatura', 3.0000, 'ºC'),
	(39906, 110, '2015-02-01 00:03:38.000000', 'temperatura', 800.0000, 'ºC'),
	(39907, 110, '2015-02-01 00:03:39.000000', 'temperatura', 390.0000, 'ºC'),
	(39908, 110, '2015-02-01 00:03:40.000000', 'temperatura', 749.0000, 'ºC'),
	(39909, 110, '2015-02-01 00:03:41.000000', 'temperatura', 179.0000, 'ºC'),
	(39910, 110, '2015-02-01 00:03:42.000000', 'temperatura', 1046.0000, 'ºC'),
	(39911, 110, '2015-02-01 00:03:43.000000', 'temperatura', 1095.0000, 'ºC'),
	(39912, 110, '2015-02-01 00:03:44.000000', 'temperatura', 1139.0000, 'ºC'),
	(39913, 110, '2015-02-01 00:03:45.000000', 'temperatura', 10.0000, 'ºC'),
	(39914, 110, '2015-02-01 00:03:46.000000', 'temperatura', 231.0000, 'ºC'),
	(39915, 110, '2015-02-01 00:03:47.000000', 'temperatura', 1127.0000, 'ºC'),
	(39916, 110, '2015-02-01 00:03:48.000000', 'temperatura', 142.0000, 'ºC'),
	(39917, 110, '2015-02-01 00:03:49.000000', 'temperatura', 931.0000, 'ºC'),
	(39918, 110, '2015-02-01 00:03:50.000000', 'temperatura', 629.0000, 'ºC'),
	(39919, 110, '2015-02-01 00:03:51.000000', 'temperatura', 352.0000, 'ºC'),
	(39920, 110, '2015-02-01 00:03:52.000000', 'temperatura', 1075.0000, 'ºC'),
	(39921, 110, '2015-02-01 00:03:53.000000', 'temperatura', 718.0000, 'ºC'),
	(39922, 110, '2015-02-01 00:03:54.000000', 'temperatura', 367.0000, 'ºC'),
	(39923, 110, '2015-02-01 00:03:55.000000', 'temperatura', 881.0000, 'ºC'),
	(39924, 110, '2015-02-01 00:03:56.000000', 'temperatura', 905.0000, 'ºC'),
	(39925, 110, '2015-02-01 00:03:57.000000', 'temperatura', 684.0000, 'ºC'),
	(39926, 110, '2015-02-01 00:03:58.000000', 'temperatura', 705.0000, 'ºC'),
	(39927, 110, '2015-02-01 00:03:59.000000', 'temperatura', 272.0000, 'ºC'),
	(39928, 110, '2015-02-01 00:04:00.000000', 'temperatura', 445.0000, 'ºC'),
	(39929, 110, '2015-02-01 00:04:01.000000', 'temperatura', 211.0000, 'ºC'),
	(39930, 110, '2015-02-01 00:04:02.000000', 'temperatura', 920.0000, 'ºC'),
	(39931, 110, '2015-02-01 00:04:03.000000', 'temperatura', 366.0000, 'ºC'),
	(39932, 110, '2015-02-01 00:04:04.000000', 'temperatura', 270.0000, 'ºC'),
	(39933, 110, '2015-02-01 00:04:05.000000', 'temperatura', 252.0000, 'ºC'),
	(39934, 110, '2015-02-01 00:04:06.000000', 'temperatura', 450.0000, 'ºC'),
	(39935, 110, '2015-02-01 00:04:07.000000', 'temperatura', 294.0000, 'ºC'),
	(39936, 110, '2015-02-01 00:04:08.000000', 'temperatura', 120.0000, 'ºC'),
	(39937, 110, '2015-02-01 00:04:09.000000', 'temperatura', 922.0000, 'ºC'),
	(39938, 110, '2015-02-01 00:04:10.000000', 'temperatura', 647.0000, 'ºC'),
	(39939, 110, '2015-02-01 00:04:11.000000', 'temperatura', 470.0000, 'ºC'),
	(39940, 110, '2015-02-01 00:04:12.000000', 'temperatura', 410.0000, 'ºC'),
	(39941, 110, '2015-02-01 00:04:13.000000', 'temperatura', 642.0000, 'ºC'),
	(39942, 110, '2015-02-01 00:04:14.000000', 'temperatura', 778.0000, 'ºC'),
	(39943, 110, '2015-02-01 00:04:15.000000', 'temperatura', 766.0000, 'ºC'),
	(39944, 110, '2015-02-01 00:04:16.000000', 'temperatura', 298.0000, 'ºC'),
	(39945, 110, '2015-02-01 00:04:17.000000', 'temperatura', 391.0000, 'ºC'),
	(39946, 110, '2015-02-01 00:04:18.000000', 'temperatura', 1064.0000, 'ºC'),
	(39947, 110, '2015-02-01 00:04:19.000000', 'temperatura', 544.0000, 'ºC'),
	(39948, 110, '2015-02-01 00:04:20.000000', 'temperatura', 729.0000, 'ºC'),
	(39949, 110, '2015-02-01 00:04:21.000000', 'temperatura', 815.0000, 'ºC'),
	(39950, 110, '2015-02-01 00:04:22.000000', 'temperatura', 690.0000, 'ºC'),
	(39951, 110, '2015-02-01 00:04:23.000000', 'temperatura', 1003.0000, 'ºC'),
	(39952, 110, '2015-02-01 00:04:24.000000', 'temperatura', 544.0000, 'ºC'),
	(39953, 110, '2015-02-01 00:04:25.000000', 'temperatura', 914.0000, 'ºC'),
	(39954, 110, '2015-02-01 00:04:26.000000', 'temperatura', 539.0000, 'ºC'),
	(39955, 110, '2015-02-01 00:04:27.000000', 'temperatura', 1151.0000, 'ºC'),
	(39956, 110, '2015-02-01 00:04:28.000000', 'temperatura', 538.0000, 'ºC'),
	(39957, 110, '2015-02-01 00:04:29.000000', 'temperatura', 441.0000, 'ºC'),
	(39958, 110, '2015-02-01 00:04:30.000000', 'temperatura', 588.0000, 'ºC'),
	(39959, 110, '2015-02-01 00:04:31.000000', 'temperatura', 418.0000, 'ºC'),
	(39960, 110, '2015-02-01 00:04:32.000000', 'temperatura', 326.0000, 'ºC'),
	(39961, 110, '2015-02-01 00:04:33.000000', 'temperatura', 375.0000, 'ºC'),
	(39962, 110, '2015-02-01 00:04:34.000000', 'temperatura', 901.0000, 'ºC'),
	(39963, 110, '2015-02-01 00:04:35.000000', 'temperatura', 980.0000, 'ºC'),
	(39964, 110, '2015-02-01 00:04:36.000000', 'temperatura', 996.0000, 'ºC'),
	(39965, 110, '2015-02-01 00:04:37.000000', 'temperatura', 843.0000, 'ºC'),
	(39966, 110, '2015-02-01 00:04:38.000000', 'temperatura', 25.0000, 'ºC'),
	(39967, 110, '2015-02-01 00:04:39.000000', 'temperatura', 1199.0000, 'ºC'),
	(39968, 110, '2015-02-01 00:04:40.000000', 'temperatura', 1118.0000, 'ºC'),
	(39969, 110, '2015-02-01 00:04:41.000000', 'temperatura', 794.0000, 'ºC'),
	(39970, 110, '2015-02-01 00:04:42.000000', 'temperatura', 616.0000, 'ºC'),
	(39971, 110, '2015-02-01 00:04:43.000000', 'temperatura', 700.0000, 'ºC'),
	(39972, 110, '2015-02-01 00:04:44.000000', 'temperatura', 451.0000, 'ºC'),
	(39973, 110, '2015-02-01 00:04:45.000000', 'temperatura', 157.0000, 'ºC'),
	(39974, 110, '2015-02-01 00:04:46.000000', 'temperatura', 631.0000, 'ºC'),
	(39975, 110, '2015-02-01 00:04:47.000000', 'temperatura', 284.0000, 'ºC'),
	(39976, 110, '2015-02-01 00:04:48.000000', 'temperatura', 726.0000, 'ºC'),
	(39977, 110, '2015-02-01 00:04:49.000000', 'temperatura', 381.0000, 'ºC'),
	(39978, 110, '2015-02-01 00:04:50.000000', 'temperatura', 927.0000, 'ºC'),
	(39979, 110, '2015-02-01 00:04:51.000000', 'temperatura', 1092.0000, 'ºC'),
	(39980, 110, '2015-02-01 00:04:52.000000', 'temperatura', 282.0000, 'ºC'),
	(39981, 110, '2015-02-01 00:04:53.000000', 'temperatura', 531.0000, 'ºC'),
	(39982, 110, '2015-02-01 00:04:54.000000', 'temperatura', 611.0000, 'ºC'),
	(39983, 110, '2015-02-01 00:04:55.000000', 'temperatura', 262.0000, 'ºC'),
	(39984, 110, '2015-02-01 00:04:56.000000', 'temperatura', 678.0000, 'ºC'),
	(39985, 110, '2015-02-01 00:04:57.000000', 'temperatura', 205.0000, 'ºC'),
	(39986, 110, '2015-02-01 00:04:58.000000', 'temperatura', 192.0000, 'ºC'),
	(39987, 110, '2015-02-01 00:04:59.000000', 'temperatura', 343.0000, 'ºC'),
	(39988, 110, '2015-02-01 00:05:00.000000', 'temperatura', 1140.0000, 'ºC'),
	(39989, 110, '2015-02-01 00:05:01.000000', 'temperatura', 1071.0000, 'ºC'),
	(39990, 110, '2015-02-01 00:05:02.000000', 'temperatura', 735.0000, 'ºC'),
	(39991, 110, '2015-02-01 00:05:03.000000', 'temperatura', 464.0000, 'ºC'),
	(39992, 110, '2015-02-01 00:05:04.000000', 'temperatura', 117.0000, 'ºC'),
	(39993, 110, '2015-02-01 00:05:05.000000', 'temperatura', 392.0000, 'ºC'),
	(39994, 110, '2015-02-01 00:05:06.000000', 'temperatura', 409.0000, 'ºC'),
	(39995, 110, '2015-02-01 00:05:07.000000', 'temperatura', 871.0000, 'ºC'),
	(39996, 110, '2015-02-01 00:05:08.000000', 'temperatura', 728.0000, 'ºC'),
	(39997, 110, '2015-02-01 00:05:09.000000', 'temperatura', 1027.0000, 'ºC'),
	(39998, 110, '2015-02-01 00:05:10.000000', 'temperatura', 551.0000, 'ºC'),
	(39999, 110, '2015-02-01 00:05:11.000000', 'temperatura', 874.0000, 'ºC'),
	(40000, 110, '2015-02-01 00:05:12.000000', 'temperatura', 319.0000, 'ºC'),
	(40001, 110, '2015-02-01 00:05:13.000000', 'temperatura', 171.0000, 'ºC'),
	(40002, 110, '2015-02-01 00:05:14.000000', 'temperatura', 1099.0000, 'ºC'),
	(40003, 110, '2015-02-01 00:05:15.000000', 'temperatura', 185.0000, 'ºC'),
	(40004, 110, '2015-02-01 00:05:16.000000', 'temperatura', 26.0000, 'ºC'),
	(40005, 110, '2015-02-01 00:05:17.000000', 'temperatura', 776.0000, 'ºC'),
	(40006, 110, '2015-02-01 00:05:18.000000', 'temperatura', 204.0000, 'ºC'),
	(40007, 110, '2015-02-01 00:05:19.000000', 'temperatura', 1090.0000, 'ºC'),
	(40008, 110, '2015-02-01 00:05:20.000000', 'temperatura', 38.0000, 'ºC'),
	(40009, 110, '2015-02-01 00:05:21.000000', 'temperatura', 521.0000, 'ºC'),
	(40010, 110, '2015-02-01 00:05:22.000000', 'temperatura', 91.0000, 'ºC'),
	(40011, 110, '2015-02-01 00:05:23.000000', 'temperatura', 91.0000, 'ºC'),
	(40012, 110, '2015-02-01 00:05:24.000000', 'temperatura', 186.0000, 'ºC'),
	(40013, 110, '2015-02-01 00:05:25.000000', 'temperatura', 654.0000, 'ºC'),
	(40014, 110, '2015-02-01 00:05:26.000000', 'temperatura', 314.0000, 'ºC'),
	(40015, 110, '2015-02-01 00:05:27.000000', 'temperatura', 808.0000, 'ºC'),
	(40016, 110, '2015-02-01 00:05:28.000000', 'temperatura', 698.0000, 'ºC'),
	(40017, 110, '2015-02-01 00:05:29.000000', 'temperatura', 1065.0000, 'ºC'),
	(40018, 110, '2015-02-01 00:05:30.000000', 'temperatura', 834.0000, 'ºC'),
	(40019, 110, '2015-02-01 00:05:31.000000', 'temperatura', 973.0000, 'ºC'),
	(40020, 110, '2015-02-01 00:05:32.000000', 'temperatura', 1164.0000, 'ºC'),
	(40021, 110, '2015-02-01 00:05:33.000000', 'temperatura', 503.0000, 'ºC'),
	(40022, 110, '2015-02-01 00:05:34.000000', 'temperatura', 221.0000, 'ºC'),
	(40023, 110, '2015-02-01 00:05:35.000000', 'temperatura', 799.0000, 'ºC'),
	(40024, 110, '2015-02-01 00:05:36.000000', 'temperatura', 932.0000, 'ºC'),
	(40025, 110, '2015-02-01 00:05:37.000000', 'temperatura', 1064.0000, 'ºC'),
	(40026, 110, '2015-02-01 00:05:38.000000', 'temperatura', 126.0000, 'ºC'),
	(40027, 110, '2015-02-01 00:05:39.000000', 'temperatura', 1036.0000, 'ºC'),
	(40028, 110, '2015-02-01 00:05:40.000000', 'temperatura', 1.0000, 'ºC'),
	(40029, 110, '2015-02-01 00:05:41.000000', 'temperatura', 500.0000, 'ºC'),
	(40030, 110, '2015-02-01 00:05:42.000000', 'temperatura', 98.0000, 'ºC'),
	(40031, 110, '2015-02-01 00:05:43.000000', 'temperatura', 188.0000, 'ºC'),
	(40032, 110, '2015-02-01 00:05:44.000000', 'temperatura', 647.0000, 'ºC'),
	(40033, 110, '2015-02-01 00:05:45.000000', 'temperatura', 273.0000, 'ºC'),
	(40034, 110, '2015-02-01 00:05:46.000000', 'temperatura', 624.0000, 'ºC'),
	(40035, 110, '2015-02-01 00:05:47.000000', 'temperatura', 1100.0000, 'ºC'),
	(40036, 110, '2015-02-01 00:05:48.000000', 'temperatura', 30.0000, 'ºC'),
	(40037, 110, '2015-02-01 00:05:49.000000', 'temperatura', 452.0000, 'ºC'),
	(40038, 110, '2015-02-01 00:05:50.000000', 'temperatura', 969.0000, 'ºC'),
	(40039, 110, '2015-02-01 00:05:51.000000', 'temperatura', 1088.0000, 'ºC'),
	(40040, 110, '2015-02-01 00:05:52.000000', 'temperatura', 133.0000, 'ºC'),
	(40041, 110, '2015-02-01 00:05:53.000000', 'temperatura', 1001.0000, 'ºC'),
	(40042, 110, '2015-02-01 00:05:54.000000', 'temperatura', 1006.0000, 'ºC'),
	(40043, 110, '2015-02-01 00:05:55.000000', 'temperatura', 829.0000, 'ºC'),
	(40044, 110, '2015-02-01 00:05:56.000000', 'temperatura', 1128.0000, 'ºC'),
	(40045, 110, '2015-02-01 00:05:57.000000', 'temperatura', 751.0000, 'ºC'),
	(40046, 110, '2015-02-01 00:05:58.000000', 'temperatura', 375.0000, 'ºC'),
	(40047, 110, '2015-02-01 00:05:59.000000', 'temperatura', 820.0000, 'ºC'),
	(40048, 110, '2015-02-01 00:06:00.000000', 'temperatura', 576.0000, 'ºC'),
	(40049, 110, '2015-02-01 00:06:01.000000', 'temperatura', 419.0000, 'ºC'),
	(40050, 110, '2015-02-01 00:06:02.000000', 'temperatura', 368.0000, 'ºC'),
	(40051, 110, '2015-02-01 00:06:03.000000', 'temperatura', 586.0000, 'ºC'),
	(40052, 110, '2015-02-01 00:06:04.000000', 'temperatura', 625.0000, 'ºC'),
	(40053, 110, '2015-02-01 00:06:05.000000', 'temperatura', 166.0000, 'ºC'),
	(40054, 110, '2015-02-01 00:06:06.000000', 'temperatura', 158.0000, 'ºC'),
	(40055, 110, '2015-02-01 00:06:07.000000', 'temperatura', 289.0000, 'ºC'),
	(40056, 110, '2015-02-01 00:06:08.000000', 'temperatura', 975.0000, 'ºC'),
	(40057, 110, '2015-02-01 00:06:09.000000', 'temperatura', 407.0000, 'ºC'),
	(40058, 110, '2015-02-01 00:06:10.000000', 'temperatura', 311.0000, 'ºC'),
	(40059, 110, '2015-02-01 00:06:11.000000', 'temperatura', 335.0000, 'ºC'),
	(40060, 110, '2015-02-01 00:06:12.000000', 'temperatura', 742.0000, 'ºC'),
	(40061, 110, '2015-02-01 00:06:13.000000', 'temperatura', 305.0000, 'ºC'),
	(40062, 110, '2015-02-01 00:06:14.000000', 'temperatura', 501.0000, 'ºC'),
	(40063, 110, '2015-02-01 00:06:15.000000', 'temperatura', 388.0000, 'ºC'),
	(40064, 110, '2015-02-01 00:06:16.000000', 'temperatura', 439.0000, 'ºC'),
	(40065, 110, '2015-02-01 00:06:17.000000', 'temperatura', 1031.0000, 'ºC'),
	(40066, 110, '2015-02-01 00:06:18.000000', 'temperatura', 237.0000, 'ºC'),
	(40067, 110, '2015-02-01 00:06:19.000000', 'temperatura', 493.0000, 'ºC'),
	(40068, 110, '2015-02-01 00:06:20.000000', 'temperatura', 555.0000, 'ºC'),
	(40069, 110, '2015-02-01 00:06:21.000000', 'temperatura', 95.0000, 'ºC'),
	(40070, 110, '2015-02-01 00:06:22.000000', 'temperatura', 12.0000, 'ºC'),
	(40071, 110, '2015-02-01 00:06:23.000000', 'temperatura', 976.0000, 'ºC'),
	(40072, 110, '2015-02-01 00:06:24.000000', 'temperatura', 46.0000, 'ºC'),
	(40073, 110, '2015-02-01 00:06:25.000000', 'temperatura', 901.0000, 'ºC'),
	(40074, 110, '2015-02-01 00:06:26.000000', 'temperatura', 767.0000, 'ºC'),
	(40075, 110, '2015-02-01 00:06:27.000000', 'temperatura', 1131.0000, 'ºC'),
	(40076, 110, '2015-02-01 00:06:28.000000', 'temperatura', 958.0000, 'ºC'),
	(40077, 110, '2015-02-01 00:06:29.000000', 'temperatura', 195.0000, 'ºC'),
	(40078, 110, '2015-02-01 00:06:30.000000', 'temperatura', 504.0000, 'ºC'),
	(40079, 110, '2015-02-01 00:06:31.000000', 'temperatura', 735.0000, 'ºC'),
	(40080, 110, '2015-02-01 00:06:32.000000', 'temperatura', 965.0000, 'ºC'),
	(40081, 110, '2015-02-01 00:06:33.000000', 'temperatura', 219.0000, 'ºC'),
	(40082, 110, '2015-02-01 00:06:34.000000', 'temperatura', 603.0000, 'ºC'),
	(40083, 110, '2015-02-01 00:06:35.000000', 'temperatura', 1155.0000, 'ºC'),
	(40084, 110, '2015-02-01 00:06:36.000000', 'temperatura', 368.0000, 'ºC'),
	(40085, 110, '2015-02-01 00:06:37.000000', 'temperatura', 774.0000, 'ºC'),
	(40086, 110, '2015-02-01 00:06:38.000000', 'temperatura', 369.0000, 'ºC'),
	(40087, 110, '2015-02-01 00:06:39.000000', 'temperatura', 723.0000, 'ºC'),
	(40088, 110, '2015-02-01 00:06:40.000000', 'temperatura', 109.0000, 'ºC'),
	(40089, 110, '2015-02-01 00:06:41.000000', 'temperatura', 777.0000, 'ºC'),
	(40090, 110, '2015-02-01 00:06:42.000000', 'temperatura', 1159.0000, 'ºC'),
	(40091, 110, '2015-02-01 00:06:43.000000', 'temperatura', 1064.0000, 'ºC'),
	(40092, 110, '2015-02-01 00:06:44.000000', 'temperatura', 642.0000, 'ºC'),
	(40093, 110, '2015-02-01 00:06:45.000000', 'temperatura', 19.0000, 'ºC'),
	(40094, 110, '2015-02-01 00:06:46.000000', 'temperatura', 570.0000, 'ºC'),
	(40095, 110, '2015-02-01 00:06:47.000000', 'temperatura', 393.0000, 'ºC'),
	(40096, 110, '2015-02-01 00:06:48.000000', 'temperatura', 254.0000, 'ºC'),
	(40097, 110, '2015-02-01 00:06:49.000000', 'temperatura', 94.0000, 'ºC'),
	(40098, 110, '2015-02-01 00:06:50.000000', 'temperatura', 909.0000, 'ºC'),
	(40099, 110, '2015-02-01 00:06:51.000000', 'temperatura', 662.0000, 'ºC'),
	(40100, 110, '2015-02-01 00:06:52.000000', 'temperatura', 585.0000, 'ºC'),
	(40101, 110, '2015-02-01 00:06:53.000000', 'temperatura', 937.0000, 'ºC'),
	(40102, 110, '2015-02-01 00:06:54.000000', 'temperatura', 533.0000, 'ºC'),
	(40103, 110, '2015-02-01 00:06:55.000000', 'temperatura', 1052.0000, 'ºC'),
	(40104, 110, '2015-02-01 00:06:56.000000', 'temperatura', 63.0000, 'ºC'),
	(40105, 110, '2015-02-01 00:06:57.000000', 'temperatura', 760.0000, 'ºC'),
	(40106, 110, '2015-02-01 00:06:58.000000', 'temperatura', 12.0000, 'ºC'),
	(40107, 110, '2015-02-01 00:06:59.000000', 'temperatura', 180.0000, 'ºC'),
	(40108, 110, '2015-02-01 00:07:00.000000', 'temperatura', 865.0000, 'ºC'),
	(40109, 110, '2015-02-01 00:07:01.000000', 'temperatura', 187.0000, 'ºC'),
	(40110, 110, '2015-02-01 00:07:02.000000', 'temperatura', 738.0000, 'ºC'),
	(40111, 110, '2015-02-01 00:07:03.000000', 'temperatura', 730.0000, 'ºC'),
	(40112, 110, '2015-02-01 00:07:04.000000', 'temperatura', 235.0000, 'ºC'),
	(40113, 110, '2015-02-01 00:07:05.000000', 'temperatura', 187.0000, 'ºC'),
	(40114, 110, '2015-02-01 00:07:06.000000', 'temperatura', 229.0000, 'ºC'),
	(40115, 110, '2015-02-01 00:07:07.000000', 'temperatura', 584.0000, 'ºC'),
	(40116, 110, '2015-02-01 00:07:08.000000', 'temperatura', 1034.0000, 'ºC'),
	(40117, 110, '2015-02-01 00:07:09.000000', 'temperatura', 1019.0000, 'ºC'),
	(40118, 110, '2015-02-01 00:07:10.000000', 'temperatura', 795.0000, 'ºC'),
	(40119, 110, '2015-02-01 00:07:11.000000', 'temperatura', 916.0000, 'ºC'),
	(40120, 110, '2015-02-01 00:07:12.000000', 'temperatura', 995.0000, 'ºC'),
	(40121, 110, '2015-02-01 00:07:13.000000', 'temperatura', 1028.0000, 'ºC'),
	(40122, 110, '2015-02-01 00:07:14.000000', 'temperatura', 958.0000, 'ºC'),
	(40123, 110, '2015-02-01 00:07:15.000000', 'temperatura', 504.0000, 'ºC'),
	(40124, 110, '2015-02-01 00:07:16.000000', 'temperatura', 846.0000, 'ºC'),
	(40125, 110, '2015-02-01 00:07:17.000000', 'temperatura', 319.0000, 'ºC'),
	(40126, 110, '2015-02-01 00:07:18.000000', 'temperatura', 256.0000, 'ºC'),
	(40127, 110, '2015-02-01 00:07:19.000000', 'temperatura', 326.0000, 'ºC'),
	(40128, 110, '2015-02-01 00:07:20.000000', 'temperatura', 862.0000, 'ºC'),
	(40129, 110, '2015-02-01 00:07:21.000000', 'temperatura', 932.0000, 'ºC'),
	(40130, 110, '2015-02-01 00:07:22.000000', 'temperatura', 874.0000, 'ºC'),
	(40131, 110, '2015-02-01 00:07:23.000000', 'temperatura', 374.0000, 'ºC'),
	(40132, 110, '2015-02-01 00:07:24.000000', 'temperatura', 449.0000, 'ºC'),
	(40133, 110, '2015-02-01 00:07:25.000000', 'temperatura', 1123.0000, 'ºC'),
	(40134, 110, '2015-02-01 00:07:26.000000', 'temperatura', 670.0000, 'ºC'),
	(40135, 110, '2015-02-01 00:07:27.000000', 'temperatura', 1181.0000, 'ºC'),
	(40136, 110, '2015-02-01 00:07:28.000000', 'temperatura', 294.0000, 'ºC'),
	(40137, 110, '2015-02-01 00:07:29.000000', 'temperatura', 328.0000, 'ºC'),
	(40138, 110, '2015-02-01 00:07:30.000000', 'temperatura', 758.0000, 'ºC'),
	(40139, 110, '2015-02-01 00:07:31.000000', 'temperatura', 405.0000, 'ºC'),
	(40140, 110, '2015-02-01 00:07:32.000000', 'temperatura', 953.0000, 'ºC'),
	(40141, 110, '2015-02-01 00:07:33.000000', 'temperatura', 1152.0000, 'ºC'),
	(40142, 110, '2015-02-01 00:07:34.000000', 'temperatura', 499.0000, 'ºC'),
	(40143, 110, '2015-02-01 00:07:35.000000', 'temperatura', 243.0000, 'ºC'),
	(40144, 110, '2015-02-01 00:07:36.000000', 'temperatura', 915.0000, 'ºC'),
	(40145, 110, '2015-02-01 00:07:37.000000', 'temperatura', 248.0000, 'ºC'),
	(40146, 110, '2015-02-01 00:07:38.000000', 'temperatura', 896.0000, 'ºC'),
	(40147, 110, '2015-02-01 00:07:39.000000', 'temperatura', 137.0000, 'ºC'),
	(40148, 110, '2015-02-01 00:07:40.000000', 'temperatura', 396.0000, 'ºC'),
	(40149, 110, '2015-02-01 00:07:41.000000', 'temperatura', 371.0000, 'ºC'),
	(40150, 110, '2015-02-01 00:07:42.000000', 'temperatura', 665.0000, 'ºC'),
	(40151, 110, '2015-02-01 00:07:43.000000', 'temperatura', 1014.0000, 'ºC'),
	(40152, 110, '2015-02-01 00:07:44.000000', 'temperatura', 673.0000, 'ºC'),
	(40153, 110, '2015-02-01 00:07:45.000000', 'temperatura', 327.0000, 'ºC'),
	(40154, 110, '2015-02-01 00:07:46.000000', 'temperatura', 815.0000, 'ºC'),
	(40155, 110, '2015-02-01 00:07:47.000000', 'temperatura', 695.0000, 'ºC'),
	(40156, 110, '2015-02-01 00:07:48.000000', 'temperatura', 1032.0000, 'ºC'),
	(40157, 110, '2015-02-01 00:07:49.000000', 'temperatura', 674.0000, 'ºC'),
	(40158, 110, '2015-02-01 00:07:50.000000', 'temperatura', 276.0000, 'ºC'),
	(40159, 110, '2015-02-01 00:07:51.000000', 'temperatura', 558.0000, 'ºC'),
	(40160, 110, '2015-02-01 00:07:52.000000', 'temperatura', 764.0000, 'ºC'),
	(40161, 110, '2015-02-01 00:07:53.000000', 'temperatura', 944.0000, 'ºC'),
	(40162, 110, '2015-02-01 00:07:54.000000', 'temperatura', 30.0000, 'ºC'),
	(40163, 110, '2015-02-01 00:07:55.000000', 'temperatura', 918.0000, 'ºC'),
	(40164, 110, '2015-02-01 00:07:56.000000', 'temperatura', 901.0000, 'ºC'),
	(40165, 110, '2015-02-01 00:07:57.000000', 'temperatura', 552.0000, 'ºC'),
	(40166, 110, '2015-02-01 00:07:58.000000', 'temperatura', 58.0000, 'ºC'),
	(40167, 110, '2015-02-01 00:07:59.000000', 'temperatura', 1036.0000, 'ºC'),
	(40168, 110, '2015-02-01 00:08:00.000000', 'temperatura', 204.0000, 'ºC'),
	(40169, 110, '2015-02-01 00:08:01.000000', 'temperatura', 312.0000, 'ºC'),
	(40170, 110, '2015-02-01 00:08:02.000000', 'temperatura', 948.0000, 'ºC'),
	(40171, 110, '2015-02-01 00:08:03.000000', 'temperatura', 207.0000, 'ºC'),
	(40172, 110, '2015-02-01 00:08:04.000000', 'temperatura', 590.0000, 'ºC'),
	(40173, 110, '2015-02-01 00:08:05.000000', 'temperatura', 1129.0000, 'ºC'),
	(40174, 110, '2015-02-01 00:08:06.000000', 'temperatura', 278.0000, 'ºC'),
	(40175, 110, '2015-02-01 00:08:07.000000', 'temperatura', 402.0000, 'ºC'),
	(40176, 110, '2015-02-01 00:08:08.000000', 'temperatura', 1178.0000, 'ºC'),
	(40177, 110, '2015-02-01 00:08:09.000000', 'temperatura', 1082.0000, 'ºC'),
	(40178, 110, '2015-02-01 00:08:10.000000', 'temperatura', 679.0000, 'ºC'),
	(40179, 110, '2015-02-01 00:08:11.000000', 'temperatura', 149.0000, 'ºC'),
	(40180, 110, '2015-02-01 00:08:12.000000', 'temperatura', 1109.0000, 'ºC'),
	(40181, 110, '2015-02-01 00:08:13.000000', 'temperatura', 296.0000, 'ºC'),
	(40182, 110, '2015-02-01 00:08:14.000000', 'temperatura', 557.0000, 'ºC'),
	(40183, 110, '2015-02-01 00:08:15.000000', 'temperatura', 695.0000, 'ºC'),
	(40184, 110, '2015-02-01 00:08:16.000000', 'temperatura', 607.0000, 'ºC'),
	(40185, 110, '2015-02-01 00:08:17.000000', 'temperatura', 949.0000, 'ºC'),
	(40186, 110, '2015-02-01 00:08:18.000000', 'temperatura', 525.0000, 'ºC'),
	(40187, 110, '2015-02-01 00:08:19.000000', 'temperatura', 977.0000, 'ºC'),
	(40188, 110, '2015-02-01 00:08:20.000000', 'temperatura', 910.0000, 'ºC'),
	(40189, 110, '2015-02-01 00:08:21.000000', 'temperatura', 419.0000, 'ºC'),
	(40190, 110, '2015-02-01 00:08:22.000000', 'temperatura', 565.0000, 'ºC'),
	(40191, 110, '2015-02-01 00:08:23.000000', 'temperatura', 368.0000, 'ºC'),
	(40192, 110, '2015-02-01 00:08:24.000000', 'temperatura', 147.0000, 'ºC'),
	(40193, 110, '2015-02-01 00:08:25.000000', 'temperatura', 830.0000, 'ºC'),
	(40194, 110, '2015-02-01 00:08:26.000000', 'temperatura', 109.0000, 'ºC'),
	(40195, 110, '2015-02-01 00:08:27.000000', 'temperatura', 457.0000, 'ºC'),
	(40196, 110, '2015-02-01 00:08:28.000000', 'temperatura', 758.0000, 'ºC'),
	(40197, 110, '2015-02-01 00:08:29.000000', 'temperatura', 19.0000, 'ºC'),
	(40198, 110, '2015-02-01 00:08:30.000000', 'temperatura', 224.0000, 'ºC'),
	(40199, 110, '2015-02-01 00:08:31.000000', 'temperatura', 1062.0000, 'ºC'),
	(40200, 110, '2015-02-01 00:08:32.000000', 'temperatura', 1039.0000, 'ºC'),
	(40201, 110, '2015-02-01 00:08:33.000000', 'temperatura', 809.0000, 'ºC'),
	(40202, 110, '2015-02-01 00:08:34.000000', 'temperatura', 929.0000, 'ºC'),
	(40203, 110, '2015-02-01 00:08:35.000000', 'temperatura', 1017.0000, 'ºC'),
	(40204, 110, '2015-02-01 00:08:36.000000', 'temperatura', 1101.0000, 'ºC'),
	(40205, 110, '2015-02-01 00:08:37.000000', 'temperatura', 52.0000, 'ºC'),
	(40206, 110, '2015-02-01 00:08:38.000000', 'temperatura', 556.0000, 'ºC'),
	(40207, 110, '2015-02-01 00:08:39.000000', 'temperatura', 228.0000, 'ºC'),
	(40208, 110, '2015-02-01 00:08:40.000000', 'temperatura', 670.0000, 'ºC'),
	(40209, 110, '2015-02-01 00:08:41.000000', 'temperatura', 267.0000, 'ºC'),
	(40210, 110, '2015-02-01 00:08:42.000000', 'temperatura', 524.0000, 'ºC'),
	(40211, 110, '2015-02-01 00:08:43.000000', 'temperatura', 620.0000, 'ºC'),
	(40212, 110, '2015-02-01 00:08:44.000000', 'temperatura', 331.0000, 'ºC'),
	(40213, 110, '2015-02-01 00:08:45.000000', 'temperatura', 992.0000, 'ºC'),
	(40214, 110, '2015-02-01 00:08:46.000000', 'temperatura', 370.0000, 'ºC'),
	(40215, 110, '2015-02-01 00:08:47.000000', 'temperatura', 75.0000, 'ºC'),
	(40216, 110, '2015-02-01 00:08:48.000000', 'temperatura', 463.0000, 'ºC'),
	(40217, 110, '2015-02-01 00:08:49.000000', 'temperatura', 893.0000, 'ºC'),
	(40218, 110, '2015-02-01 00:08:50.000000', 'temperatura', 677.0000, 'ºC'),
	(40219, 110, '2015-02-01 00:08:51.000000', 'temperatura', 707.0000, 'ºC'),
	(40220, 110, '2015-02-01 00:08:52.000000', 'temperatura', 305.0000, 'ºC'),
	(40221, 110, '2015-02-01 00:08:53.000000', 'temperatura', 605.0000, 'ºC'),
	(40222, 110, '2015-02-01 00:08:54.000000', 'temperatura', 909.0000, 'ºC'),
	(40223, 110, '2015-02-01 00:08:55.000000', 'temperatura', 330.0000, 'ºC'),
	(40224, 110, '2015-02-01 00:08:56.000000', 'temperatura', 123.0000, 'ºC'),
	(40225, 110, '2015-02-01 00:08:57.000000', 'temperatura', 826.0000, 'ºC'),
	(40226, 110, '2015-02-01 00:08:58.000000', 'temperatura', 162.0000, 'ºC'),
	(40227, 110, '2015-02-01 00:08:59.000000', 'temperatura', 733.0000, 'ºC'),
	(40228, 110, '2015-02-01 00:09:00.000000', 'temperatura', 779.0000, 'ºC'),
	(40229, 110, '2015-02-01 00:09:01.000000', 'temperatura', 497.0000, 'ºC'),
	(40230, 110, '2015-02-01 00:09:02.000000', 'temperatura', 148.0000, 'ºC'),
	(40231, 110, '2015-02-01 00:09:03.000000', 'temperatura', 449.0000, 'ºC'),
	(40232, 110, '2015-02-01 00:09:04.000000', 'temperatura', 603.0000, 'ºC'),
	(40233, 110, '2015-02-01 00:09:05.000000', 'temperatura', 467.0000, 'ºC'),
	(40234, 110, '2015-02-01 00:09:06.000000', 'temperatura', 526.0000, 'ºC'),
	(40235, 110, '2015-02-01 00:09:07.000000', 'temperatura', 29.0000, 'ºC'),
	(40236, 110, '2015-02-01 00:09:08.000000', 'temperatura', 967.0000, 'ºC'),
	(40237, 110, '2015-02-01 00:09:09.000000', 'temperatura', 1150.0000, 'ºC'),
	(40238, 110, '2015-02-01 00:09:10.000000', 'temperatura', 448.0000, 'ºC'),
	(40239, 110, '2015-02-01 00:09:11.000000', 'temperatura', 1192.0000, 'ºC'),
	(40240, 110, '2015-02-01 00:09:12.000000', 'temperatura', 1016.0000, 'ºC'),
	(40241, 110, '2015-02-01 00:09:13.000000', 'temperatura', 306.0000, 'ºC'),
	(40242, 110, '2015-02-01 00:09:14.000000', 'temperatura', 881.0000, 'ºC'),
	(40243, 110, '2015-02-01 00:09:15.000000', 'temperatura', 1089.0000, 'ºC'),
	(40244, 110, '2015-02-01 00:09:16.000000', 'temperatura', 403.0000, 'ºC'),
	(40245, 110, '2015-02-01 00:09:17.000000', 'temperatura', 1148.0000, 'ºC'),
	(40246, 110, '2015-02-01 00:09:18.000000', 'temperatura', 933.0000, 'ºC'),
	(40247, 110, '2015-02-01 00:09:19.000000', 'temperatura', 20.0000, 'ºC'),
	(40248, 110, '2015-02-01 00:09:20.000000', 'temperatura', 902.0000, 'ºC'),
	(40249, 110, '2015-02-01 00:09:21.000000', 'temperatura', 850.0000, 'ºC'),
	(40250, 110, '2015-02-01 00:09:22.000000', 'temperatura', 344.0000, 'ºC'),
	(40251, 110, '2015-02-01 00:09:23.000000', 'temperatura', 370.0000, 'ºC'),
	(40252, 110, '2015-02-01 00:09:24.000000', 'temperatura', 819.0000, 'ºC'),
	(40253, 110, '2015-02-01 00:09:25.000000', 'temperatura', 587.0000, 'ºC'),
	(40254, 110, '2015-02-01 00:09:26.000000', 'temperatura', 478.0000, 'ºC'),
	(40255, 110, '2015-02-01 00:09:27.000000', 'temperatura', 629.0000, 'ºC'),
	(40256, 110, '2015-02-01 00:09:28.000000', 'temperatura', 510.0000, 'ºC'),
	(40257, 110, '2015-02-01 00:09:29.000000', 'temperatura', 665.0000, 'ºC'),
	(40258, 110, '2015-02-01 00:09:30.000000', 'temperatura', 596.0000, 'ºC'),
	(40259, 110, '2015-02-01 00:09:31.000000', 'temperatura', 984.0000, 'ºC'),
	(40260, 110, '2015-02-01 00:09:32.000000', 'temperatura', 733.0000, 'ºC'),
	(40261, 110, '2015-02-01 00:09:33.000000', 'temperatura', 715.0000, 'ºC'),
	(40262, 110, '2015-02-01 00:09:34.000000', 'temperatura', 174.0000, 'ºC'),
	(40263, 110, '2015-02-01 00:09:35.000000', 'temperatura', 1125.0000, 'ºC'),
	(40264, 110, '2015-02-01 00:09:36.000000', 'temperatura', 304.0000, 'ºC'),
	(40265, 110, '2015-02-01 00:09:37.000000', 'temperatura', 546.0000, 'ºC'),
	(40266, 110, '2015-02-01 00:09:38.000000', 'temperatura', 619.0000, 'ºC'),
	(40267, 110, '2015-02-01 00:09:39.000000', 'temperatura', 257.0000, 'ºC'),
	(40268, 110, '2015-02-01 00:09:40.000000', 'temperatura', 630.0000, 'ºC'),
	(40269, 110, '2015-02-01 00:09:41.000000', 'temperatura', 1177.0000, 'ºC'),
	(40270, 110, '2015-02-01 00:09:42.000000', 'temperatura', 398.0000, 'ºC'),
	(40271, 110, '2015-02-01 00:09:43.000000', 'temperatura', 859.0000, 'ºC'),
	(40272, 110, '2015-02-01 00:09:44.000000', 'temperatura', 699.0000, 'ºC'),
	(40273, 110, '2015-02-01 00:09:45.000000', 'temperatura', 921.0000, 'ºC'),
	(40274, 110, '2015-02-01 00:09:46.000000', 'temperatura', 108.0000, 'ºC'),
	(40275, 110, '2015-02-01 00:09:47.000000', 'temperatura', 178.0000, 'ºC'),
	(40276, 110, '2015-02-01 00:09:48.000000', 'temperatura', 566.0000, 'ºC'),
	(40277, 110, '2015-02-01 00:09:49.000000', 'temperatura', 1098.0000, 'ºC'),
	(40278, 110, '2015-02-01 00:09:50.000000', 'temperatura', 191.0000, 'ºC'),
	(40279, 110, '2015-02-01 00:09:51.000000', 'temperatura', 62.0000, 'ºC'),
	(40280, 110, '2015-02-01 00:09:52.000000', 'temperatura', 936.0000, 'ºC'),
	(40281, 110, '2015-02-01 00:09:53.000000', 'temperatura', 894.0000, 'ºC'),
	(40282, 110, '2015-02-01 00:09:54.000000', 'temperatura', 463.0000, 'ºC'),
	(40283, 110, '2015-02-01 00:09:55.000000', 'temperatura', 834.0000, 'ºC'),
	(40284, 110, '2015-02-01 00:09:56.000000', 'temperatura', 379.0000, 'ºC'),
	(40285, 110, '2015-02-01 00:09:57.000000', 'temperatura', 597.0000, 'ºC'),
	(40286, 110, '2015-02-01 00:09:58.000000', 'temperatura', 646.0000, 'ºC'),
	(40287, 110, '2015-02-01 00:09:59.000000', 'temperatura', 240.0000, 'ºC'),
	(40288, 110, '2015-02-01 00:10:00.000000', 'temperatura', 463.0000, 'ºC'),
	(40289, 110, '2015-02-01 00:10:01.000000', 'temperatura', 394.0000, 'ºC'),
	(40290, 110, '2015-02-01 00:10:02.000000', 'temperatura', 584.0000, 'ºC'),
	(40291, 110, '2015-02-01 00:10:03.000000', 'temperatura', 539.0000, 'ºC'),
	(40292, 110, '2015-02-01 00:10:04.000000', 'temperatura', 943.0000, 'ºC'),
	(40293, 110, '2015-02-01 00:10:05.000000', 'temperatura', 698.0000, 'ºC'),
	(40294, 110, '2015-02-01 00:10:06.000000', 'temperatura', 663.0000, 'ºC'),
	(40295, 110, '2015-02-01 00:10:07.000000', 'temperatura', 19.0000, 'ºC'),
	(40296, 110, '2015-02-01 00:10:08.000000', 'temperatura', 508.0000, 'ºC'),
	(40297, 110, '2015-02-01 00:10:09.000000', 'temperatura', 81.0000, 'ºC'),
	(40298, 110, '2015-02-01 00:10:10.000000', 'temperatura', 83.0000, 'ºC'),
	(40299, 110, '2015-02-01 00:10:11.000000', 'temperatura', 174.0000, 'ºC'),
	(40300, 110, '2015-02-01 00:10:12.000000', 'temperatura', 619.0000, 'ºC'),
	(40301, 110, '2015-02-01 00:10:13.000000', 'temperatura', 173.0000, 'ºC'),
	(40302, 110, '2015-02-01 00:10:14.000000', 'temperatura', 210.0000, 'ºC'),
	(40303, 110, '2015-02-01 00:10:15.000000', 'temperatura', 531.0000, 'ºC'),
	(40304, 110, '2015-02-01 00:10:16.000000', 'temperatura', 827.0000, 'ºC'),
	(40305, 110, '2015-02-01 00:10:17.000000', 'temperatura', 142.0000, 'ºC'),
	(40306, 110, '2015-02-01 00:10:18.000000', 'temperatura', 630.0000, 'ºC'),
	(40307, 110, '2015-02-01 00:10:19.000000', 'temperatura', 324.0000, 'ºC'),
	(40308, 110, '2015-02-01 00:10:20.000000', 'temperatura', 932.0000, 'ºC'),
	(40309, 110, '2015-02-01 00:10:21.000000', 'temperatura', 86.0000, 'ºC'),
	(40310, 110, '2015-02-01 00:10:22.000000', 'temperatura', 37.0000, 'ºC'),
	(40311, 110, '2015-02-01 00:10:23.000000', 'temperatura', 1127.0000, 'ºC'),
	(40312, 110, '2015-02-01 00:10:24.000000', 'temperatura', 726.0000, 'ºC'),
	(40313, 110, '2015-02-01 00:10:25.000000', 'temperatura', 246.0000, 'ºC'),
	(40314, 110, '2015-02-01 00:10:26.000000', 'temperatura', 255.0000, 'ºC'),
	(40315, 110, '2015-02-01 00:10:27.000000', 'temperatura', 537.0000, 'ºC'),
	(40316, 110, '2015-02-01 00:10:28.000000', 'temperatura', 721.0000, 'ºC'),
	(40317, 110, '2015-02-01 00:10:29.000000', 'temperatura', 795.0000, 'ºC'),
	(40318, 110, '2015-02-01 00:10:30.000000', 'temperatura', 613.0000, 'ºC'),
	(40319, 110, '2015-02-01 00:10:31.000000', 'temperatura', 679.0000, 'ºC'),
	(40320, 110, '2015-02-01 00:10:32.000000', 'temperatura', 357.0000, 'ºC'),
	(40321, 110, '2015-02-01 00:10:33.000000', 'temperatura', 948.0000, 'ºC'),
	(40322, 110, '2015-02-01 00:10:34.000000', 'temperatura', 71.0000, 'ºC'),
	(40323, 110, '2015-02-01 00:10:35.000000', 'temperatura', 1111.0000, 'ºC'),
	(40324, 110, '2015-02-01 00:10:36.000000', 'temperatura', 542.0000, 'ºC'),
	(40325, 110, '2015-02-01 00:10:37.000000', 'temperatura', 576.0000, 'ºC'),
	(40326, 110, '2015-02-01 00:10:38.000000', 'temperatura', 58.0000, 'ºC'),
	(40327, 110, '2015-02-01 00:10:39.000000', 'temperatura', 959.0000, 'ºC'),
	(40328, 110, '2015-02-01 00:10:40.000000', 'temperatura', 1024.0000, 'ºC'),
	(40329, 110, '2015-02-01 00:10:41.000000', 'temperatura', 1044.0000, 'ºC'),
	(40330, 110, '2015-02-01 00:10:42.000000', 'temperatura', 946.0000, 'ºC'),
	(40331, 110, '2015-02-01 00:10:43.000000', 'temperatura', 401.0000, 'ºC'),
	(40332, 110, '2015-02-01 00:10:44.000000', 'temperatura', 366.0000, 'ºC'),
	(40333, 110, '2015-02-01 00:10:45.000000', 'temperatura', 628.0000, 'ºC'),
	(40334, 110, '2015-02-01 00:10:46.000000', 'temperatura', 842.0000, 'ºC'),
	(40335, 110, '2015-02-01 00:10:47.000000', 'temperatura', 1126.0000, 'ºC'),
	(40336, 110, '2015-02-01 00:10:48.000000', 'temperatura', 704.0000, 'ºC'),
	(40337, 110, '2015-02-01 00:10:49.000000', 'temperatura', 142.0000, 'ºC'),
	(40338, 110, '2015-02-01 00:10:50.000000', 'temperatura', 1001.0000, 'ºC'),
	(40339, 110, '2015-02-01 00:10:51.000000', 'temperatura', 977.0000, 'ºC'),
	(40340, 110, '2015-02-01 00:10:52.000000', 'temperatura', 684.0000, 'ºC'),
	(40341, 110, '2015-02-01 00:10:53.000000', 'temperatura', 490.0000, 'ºC'),
	(40342, 110, '2015-02-01 00:10:54.000000', 'temperatura', 399.0000, 'ºC'),
	(40343, 110, '2015-02-01 00:10:55.000000', 'temperatura', 524.0000, 'ºC'),
	(40344, 110, '2015-02-01 00:10:56.000000', 'temperatura', 222.0000, 'ºC'),
	(40345, 110, '2015-02-01 00:10:57.000000', 'temperatura', 741.0000, 'ºC'),
	(40346, 110, '2015-02-01 00:10:58.000000', 'temperatura', 640.0000, 'ºC'),
	(40347, 110, '2015-02-01 00:10:59.000000', 'temperatura', 976.0000, 'ºC'),
	(40348, 110, '2015-02-01 00:11:00.000000', 'temperatura', 562.0000, 'ºC'),
	(40349, 110, '2015-02-01 00:11:01.000000', 'temperatura', 1082.0000, 'ºC'),
	(40350, 110, '2015-02-01 00:11:02.000000', 'temperatura', 126.0000, 'ºC'),
	(40351, 110, '2015-02-01 00:11:03.000000', 'temperatura', 984.0000, 'ºC'),
	(40352, 110, '2015-02-01 00:11:04.000000', 'temperatura', 940.0000, 'ºC'),
	(40353, 110, '2015-02-01 00:11:05.000000', 'temperatura', 551.0000, 'ºC'),
	(40354, 110, '2015-02-01 00:11:06.000000', 'temperatura', 1133.0000, 'ºC'),
	(40355, 110, '2015-02-01 00:11:07.000000', 'temperatura', 414.0000, 'ºC'),
	(40356, 110, '2015-02-01 00:11:08.000000', 'temperatura', 1073.0000, 'ºC'),
	(40357, 110, '2015-02-01 00:11:09.000000', 'temperatura', 522.0000, 'ºC'),
	(40358, 110, '2015-02-01 00:11:10.000000', 'temperatura', 593.0000, 'ºC'),
	(40359, 110, '2015-02-01 00:11:11.000000', 'temperatura', 199.0000, 'ºC'),
	(40360, 110, '2015-02-01 00:11:12.000000', 'temperatura', 417.0000, 'ºC'),
	(40361, 110, '2015-02-01 00:11:13.000000', 'temperatura', 288.0000, 'ºC'),
	(40362, 110, '2015-02-01 00:11:14.000000', 'temperatura', 191.0000, 'ºC'),
	(40363, 110, '2015-02-01 00:11:15.000000', 'temperatura', 88.0000, 'ºC'),
	(40364, 110, '2015-02-01 00:11:16.000000', 'temperatura', 1071.0000, 'ºC'),
	(40365, 110, '2015-02-01 00:11:17.000000', 'temperatura', 291.0000, 'ºC'),
	(40366, 110, '2015-02-01 00:11:18.000000', 'temperatura', 641.0000, 'ºC'),
	(40367, 110, '2015-02-01 00:11:19.000000', 'temperatura', 1131.0000, 'ºC'),
	(40368, 110, '2015-02-01 00:11:20.000000', 'temperatura', 135.0000, 'ºC'),
	(40369, 110, '2015-02-01 00:11:21.000000', 'temperatura', 883.0000, 'ºC'),
	(40370, 110, '2015-02-01 00:11:22.000000', 'temperatura', 411.0000, 'ºC'),
	(40371, 110, '2015-02-01 00:11:23.000000', 'temperatura', 606.0000, 'ºC'),
	(40372, 110, '2015-02-01 00:11:24.000000', 'temperatura', 596.0000, 'ºC'),
	(40373, 110, '2015-02-01 00:11:25.000000', 'temperatura', 1165.0000, 'ºC'),
	(40374, 110, '2015-02-01 00:11:26.000000', 'temperatura', 434.0000, 'ºC'),
	(40375, 110, '2015-02-01 00:11:27.000000', 'temperatura', 1079.0000, 'ºC'),
	(40376, 110, '2015-02-01 00:11:28.000000', 'temperatura', 491.0000, 'ºC'),
	(40377, 110, '2015-02-01 00:11:29.000000', 'temperatura', 418.0000, 'ºC'),
	(40378, 110, '2015-02-01 00:11:30.000000', 'temperatura', 617.0000, 'ºC'),
	(40379, 110, '2015-02-01 00:11:31.000000', 'temperatura', 633.0000, 'ºC'),
	(40380, 110, '2015-02-01 00:11:32.000000', 'temperatura', 115.0000, 'ºC'),
	(40381, 110, '2015-02-01 00:11:33.000000', 'temperatura', 1074.0000, 'ºC'),
	(40382, 110, '2015-02-01 00:11:34.000000', 'temperatura', 226.0000, 'ºC'),
	(40383, 110, '2015-02-01 00:11:35.000000', 'temperatura', 310.0000, 'ºC'),
	(40384, 110, '2015-02-01 00:11:36.000000', 'temperatura', 874.0000, 'ºC'),
	(40385, 110, '2015-02-01 00:11:37.000000', 'temperatura', 1038.0000, 'ºC'),
	(40386, 110, '2015-02-01 00:11:38.000000', 'temperatura', 168.0000, 'ºC'),
	(40387, 110, '2015-02-01 00:11:39.000000', 'temperatura', 129.0000, 'ºC'),
	(40388, 110, '2015-02-01 00:11:40.000000', 'temperatura', 140.0000, 'ºC'),
	(40389, 110, '2015-02-01 00:11:41.000000', 'temperatura', 316.0000, 'ºC'),
	(40390, 110, '2015-02-01 00:11:42.000000', 'temperatura', 1158.0000, 'ºC'),
	(40391, 110, '2015-02-01 00:11:43.000000', 'temperatura', 45.0000, 'ºC'),
	(40392, 110, '2015-02-01 00:11:44.000000', 'temperatura', 349.0000, 'ºC'),
	(40393, 110, '2015-02-01 00:11:45.000000', 'temperatura', 411.0000, 'ºC'),
	(40394, 110, '2015-02-01 00:11:46.000000', 'temperatura', 1010.0000, 'ºC'),
	(40395, 110, '2015-02-01 00:11:47.000000', 'temperatura', 218.0000, 'ºC'),
	(40396, 110, '2015-02-01 00:11:48.000000', 'temperatura', 459.0000, 'ºC'),
	(40397, 110, '2015-02-01 00:11:49.000000', 'temperatura', 441.0000, 'ºC'),
	(40398, 110, '2015-02-01 00:11:50.000000', 'temperatura', 827.0000, 'ºC'),
	(40399, 110, '2015-02-01 00:11:51.000000', 'temperatura', 416.0000, 'ºC'),
	(40400, 110, '2015-02-01 00:11:52.000000', 'temperatura', 797.0000, 'ºC'),
	(40401, 110, '2015-02-01 00:11:53.000000', 'temperatura', 339.0000, 'ºC'),
	(40402, 110, '2015-02-01 00:11:54.000000', 'temperatura', 505.0000, 'ºC'),
	(40403, 110, '2015-02-01 00:11:55.000000', 'temperatura', 310.0000, 'ºC'),
	(40404, 110, '2015-02-01 00:11:56.000000', 'temperatura', 33.0000, 'ºC'),
	(40405, 110, '2015-02-01 00:11:57.000000', 'temperatura', 435.0000, 'ºC'),
	(40406, 110, '2015-02-01 00:11:58.000000', 'temperatura', 876.0000, 'ºC'),
	(40407, 110, '2015-02-01 00:11:59.000000', 'temperatura', 675.0000, 'ºC'),
	(40408, 110, '2015-02-01 00:12:00.000000', 'temperatura', 748.0000, 'ºC'),
	(40409, 110, '2015-02-01 00:12:01.000000', 'temperatura', 514.0000, 'ºC'),
	(40410, 110, '2015-02-01 00:12:02.000000', 'temperatura', 328.0000, 'ºC'),
	(40411, 110, '2015-02-01 00:12:03.000000', 'temperatura', 98.0000, 'ºC'),
	(40412, 110, '2015-02-01 00:12:04.000000', 'temperatura', 708.0000, 'ºC'),
	(40413, 110, '2015-02-01 00:12:05.000000', 'temperatura', 845.0000, 'ºC'),
	(40414, 110, '2015-02-01 00:12:06.000000', 'temperatura', 900.0000, 'ºC'),
	(40415, 110, '2015-02-01 00:12:07.000000', 'temperatura', 767.0000, 'ºC'),
	(40416, 110, '2015-02-01 00:12:08.000000', 'temperatura', 1134.0000, 'ºC'),
	(40417, 110, '2015-02-01 00:12:09.000000', 'temperatura', 970.0000, 'ºC'),
	(40418, 110, '2015-02-01 00:12:10.000000', 'temperatura', 248.0000, 'ºC'),
	(40419, 110, '2015-02-01 00:12:11.000000', 'temperatura', 731.0000, 'ºC'),
	(40420, 110, '2015-02-01 00:12:12.000000', 'temperatura', 513.0000, 'ºC'),
	(40421, 110, '2015-02-01 00:12:13.000000', 'temperatura', 372.0000, 'ºC'),
	(40422, 110, '2015-02-01 00:12:14.000000', 'temperatura', 320.0000, 'ºC'),
	(40423, 110, '2015-02-01 00:12:15.000000', 'temperatura', 484.0000, 'ºC'),
	(40424, 110, '2015-02-01 00:12:16.000000', 'temperatura', 263.0000, 'ºC'),
	(40425, 110, '2015-02-01 00:12:17.000000', 'temperatura', 1064.0000, 'ºC'),
	(40426, 110, '2015-02-01 00:12:18.000000', 'temperatura', 931.0000, 'ºC'),
	(40427, 110, '2015-02-01 00:12:19.000000', 'temperatura', 262.0000, 'ºC'),
	(40428, 110, '2015-02-01 00:12:20.000000', 'temperatura', 919.0000, 'ºC'),
	(40429, 110, '2015-02-01 00:12:21.000000', 'temperatura', 209.0000, 'ºC'),
	(40430, 110, '2015-02-01 00:12:22.000000', 'temperatura', 688.0000, 'ºC'),
	(40431, 110, '2015-02-01 00:12:23.000000', 'temperatura', 412.0000, 'ºC'),
	(40432, 110, '2015-02-01 00:12:24.000000', 'temperatura', 1199.0000, 'ºC'),
	(40433, 110, '2015-02-01 00:12:25.000000', 'temperatura', 1157.0000, 'ºC'),
	(40434, 110, '2015-02-01 00:12:26.000000', 'temperatura', 988.0000, 'ºC'),
	(40435, 110, '2015-02-01 00:12:27.000000', 'temperatura', 270.0000, 'ºC'),
	(40436, 110, '2015-02-01 00:12:28.000000', 'temperatura', 785.0000, 'ºC'),
	(40437, 110, '2015-02-01 00:12:29.000000', 'temperatura', 718.0000, 'ºC'),
	(40438, 110, '2015-02-01 00:12:30.000000', 'temperatura', 33.0000, 'ºC'),
	(40439, 110, '2015-02-01 00:12:31.000000', 'temperatura', 413.0000, 'ºC'),
	(40440, 110, '2015-02-01 00:12:32.000000', 'temperatura', 767.0000, 'ºC'),
	(40441, 110, '2015-02-01 00:12:33.000000', 'temperatura', 197.0000, 'ºC'),
	(40442, 110, '2015-02-01 00:12:34.000000', 'temperatura', 1083.0000, 'ºC'),
	(40443, 110, '2015-02-01 00:12:35.000000', 'temperatura', 27.0000, 'ºC'),
	(40444, 110, '2015-02-01 00:12:36.000000', 'temperatura', 483.0000, 'ºC'),
	(40445, 110, '2015-02-01 00:12:37.000000', 'temperatura', 1137.0000, 'ºC'),
	(40446, 110, '2015-02-01 00:12:38.000000', 'temperatura', 636.0000, 'ºC'),
	(40447, 110, '2015-02-01 00:12:39.000000', 'temperatura', 971.0000, 'ºC'),
	(40448, 110, '2015-02-01 00:12:40.000000', 'temperatura', 548.0000, 'ºC'),
	(40449, 110, '2015-02-01 00:12:41.000000', 'temperatura', 1026.0000, 'ºC'),
	(40450, 110, '2015-02-01 00:12:42.000000', 'temperatura', 1089.0000, 'ºC'),
	(40451, 110, '2015-02-01 00:12:43.000000', 'temperatura', 1165.0000, 'ºC'),
	(40452, 110, '2015-02-01 00:12:44.000000', 'temperatura', 160.0000, 'ºC'),
	(40453, 110, '2015-02-01 00:12:45.000000', 'temperatura', 905.0000, 'ºC'),
	(40454, 110, '2015-02-01 00:12:46.000000', 'temperatura', 445.0000, 'ºC'),
	(40455, 110, '2015-02-01 00:12:47.000000', 'temperatura', 710.0000, 'ºC'),
	(40456, 110, '2015-02-01 00:12:48.000000', 'temperatura', 1014.0000, 'ºC'),
	(40457, 110, '2015-02-01 00:12:49.000000', 'temperatura', 543.0000, 'ºC'),
	(40458, 110, '2015-02-01 00:12:50.000000', 'temperatura', 871.0000, 'ºC'),
	(40459, 110, '2015-02-01 00:12:51.000000', 'temperatura', 329.0000, 'ºC'),
	(40460, 110, '2015-02-01 00:12:52.000000', 'temperatura', 231.0000, 'ºC'),
	(40461, 110, '2015-02-01 00:12:53.000000', 'temperatura', 168.0000, 'ºC'),
	(40462, 110, '2015-02-01 00:12:54.000000', 'temperatura', 146.0000, 'ºC'),
	(40463, 110, '2015-02-01 00:12:55.000000', 'temperatura', 229.0000, 'ºC'),
	(40464, 110, '2015-02-01 00:12:56.000000', 'temperatura', 707.0000, 'ºC'),
	(40465, 110, '2015-02-01 00:12:57.000000', 'temperatura', 449.0000, 'ºC'),
	(40466, 110, '2015-02-01 00:12:58.000000', 'temperatura', 123.0000, 'ºC'),
	(40467, 110, '2015-02-01 00:12:59.000000', 'temperatura', 469.0000, 'ºC'),
	(40468, 110, '2015-02-01 00:13:00.000000', 'temperatura', 777.0000, 'ºC'),
	(40469, 110, '2015-02-01 00:13:01.000000', 'temperatura', 77.0000, 'ºC'),
	(40470, 110, '2015-02-01 00:13:02.000000', 'temperatura', 455.0000, 'ºC'),
	(40471, 110, '2015-02-01 00:13:03.000000', 'temperatura', 843.0000, 'ºC'),
	(40472, 110, '2015-02-01 00:13:04.000000', 'temperatura', 454.0000, 'ºC'),
	(40473, 110, '2015-02-01 00:13:05.000000', 'temperatura', 939.0000, 'ºC'),
	(40474, 110, '2015-02-01 00:13:06.000000', 'temperatura', 935.0000, 'ºC'),
	(40475, 110, '2015-02-01 00:13:07.000000', 'temperatura', 659.0000, 'ºC'),
	(40476, 110, '2015-02-01 00:13:08.000000', 'temperatura', 488.0000, 'ºC'),
	(40477, 110, '2015-02-01 00:13:09.000000', 'temperatura', 464.0000, 'ºC'),
	(40478, 110, '2015-02-01 00:13:10.000000', 'temperatura', 856.0000, 'ºC'),
	(40479, 110, '2015-02-01 00:13:11.000000', 'temperatura', 489.0000, 'ºC'),
	(40480, 110, '2015-02-01 00:13:12.000000', 'temperatura', 1077.0000, 'ºC'),
	(40481, 110, '2015-02-01 00:13:13.000000', 'temperatura', 319.0000, 'ºC'),
	(40482, 110, '2015-02-01 00:13:14.000000', 'temperatura', 766.0000, 'ºC'),
	(40483, 110, '2015-02-01 00:13:15.000000', 'temperatura', 473.0000, 'ºC'),
	(40484, 110, '2015-02-01 00:13:16.000000', 'temperatura', 68.0000, 'ºC'),
	(40485, 110, '2015-02-01 00:13:17.000000', 'temperatura', 120.0000, 'ºC'),
	(40486, 110, '2015-02-01 00:13:18.000000', 'temperatura', 396.0000, 'ºC'),
	(40487, 110, '2015-02-01 00:13:19.000000', 'temperatura', 423.0000, 'ºC'),
	(40488, 110, '2015-02-01 00:13:20.000000', 'temperatura', 926.0000, 'ºC'),
	(40489, 110, '2015-02-01 00:13:21.000000', 'temperatura', 961.0000, 'ºC'),
	(40490, 110, '2015-02-01 00:13:22.000000', 'temperatura', 830.0000, 'ºC'),
	(40491, 110, '2015-02-01 00:13:23.000000', 'temperatura', 65.0000, 'ºC'),
	(40492, 110, '2015-02-01 00:13:24.000000', 'temperatura', 238.0000, 'ºC'),
	(40493, 110, '2015-02-01 00:13:25.000000', 'temperatura', 993.0000, 'ºC'),
	(40494, 110, '2015-02-01 00:13:26.000000', 'temperatura', 653.0000, 'ºC'),
	(40495, 110, '2015-02-01 00:13:27.000000', 'temperatura', 287.0000, 'ºC'),
	(40496, 110, '2015-02-01 00:13:28.000000', 'temperatura', 676.0000, 'ºC'),
	(40497, 110, '2015-02-01 00:13:29.000000', 'temperatura', 121.0000, 'ºC'),
	(40498, 110, '2015-02-01 00:13:30.000000', 'temperatura', 977.0000, 'ºC'),
	(40499, 110, '2015-02-01 00:13:31.000000', 'temperatura', 921.0000, 'ºC'),
	(40500, 110, '2015-02-01 00:13:32.000000', 'temperatura', 474.0000, 'ºC'),
	(40501, 110, '2015-02-01 00:13:33.000000', 'temperatura', 808.0000, 'ºC'),
	(40502, 110, '2015-02-01 00:13:34.000000', 'temperatura', 218.0000, 'ºC'),
	(40503, 110, '2015-02-01 00:13:35.000000', 'temperatura', 1066.0000, 'ºC'),
	(40504, 110, '2015-02-01 00:13:36.000000', 'temperatura', 1076.0000, 'ºC'),
	(40505, 110, '2015-02-01 00:13:37.000000', 'temperatura', 985.0000, 'ºC'),
	(40506, 110, '2015-02-01 00:13:38.000000', 'temperatura', 495.0000, 'ºC'),
	(40507, 110, '2015-02-01 00:13:39.000000', 'temperatura', 723.0000, 'ºC'),
	(40508, 110, '2015-02-01 00:13:40.000000', 'temperatura', 930.0000, 'ºC'),
	(40509, 110, '2015-02-01 00:13:41.000000', 'temperatura', 81.0000, 'ºC'),
	(40510, 110, '2015-02-01 00:13:42.000000', 'temperatura', 14.0000, 'ºC'),
	(40511, 110, '2015-02-01 00:13:43.000000', 'temperatura', 1030.0000, 'ºC'),
	(40512, 110, '2015-02-01 00:13:44.000000', 'temperatura', 307.0000, 'ºC'),
	(40513, 110, '2015-02-01 00:13:45.000000', 'temperatura', 846.0000, 'ºC'),
	(40514, 110, '2015-02-01 00:13:46.000000', 'temperatura', 909.0000, 'ºC'),
	(40515, 110, '2015-02-01 00:13:47.000000', 'temperatura', 809.0000, 'ºC'),
	(40516, 110, '2015-02-01 00:13:48.000000', 'temperatura', 116.0000, 'ºC'),
	(40517, 110, '2015-02-01 00:13:49.000000', 'temperatura', 555.0000, 'ºC'),
	(40518, 110, '2015-02-01 00:13:50.000000', 'temperatura', 28.0000, 'ºC'),
	(40519, 110, '2015-02-01 00:13:51.000000', 'temperatura', 874.0000, 'ºC'),
	(40520, 110, '2015-02-01 00:13:52.000000', 'temperatura', 685.0000, 'ºC'),
	(40521, 110, '2015-02-01 00:13:53.000000', 'temperatura', 807.0000, 'ºC'),
	(40522, 110, '2015-02-01 00:13:54.000000', 'temperatura', 780.0000, 'ºC'),
	(40523, 110, '2015-02-01 00:13:55.000000', 'temperatura', 278.0000, 'ºC'),
	(40524, 110, '2015-02-01 00:13:56.000000', 'temperatura', 250.0000, 'ºC'),
	(40525, 110, '2015-02-01 00:13:57.000000', 'temperatura', 419.0000, 'ºC'),
	(40526, 110, '2015-02-01 00:13:58.000000', 'temperatura', 144.0000, 'ºC'),
	(40527, 110, '2015-02-01 00:13:59.000000', 'temperatura', 664.0000, 'ºC'),
	(40528, 110, '2015-02-01 00:14:00.000000', 'temperatura', 490.0000, 'ºC'),
	(40529, 110, '2015-02-01 00:14:01.000000', 'temperatura', 458.0000, 'ºC'),
	(40530, 110, '2015-02-01 00:14:02.000000', 'temperatura', 818.0000, 'ºC'),
	(40531, 110, '2015-02-01 00:14:03.000000', 'temperatura', 318.0000, 'ºC'),
	(40532, 110, '2015-02-01 00:14:04.000000', 'temperatura', 338.0000, 'ºC'),
	(40533, 110, '2015-02-01 00:14:05.000000', 'temperatura', 735.0000, 'ºC'),
	(40534, 110, '2015-02-01 00:14:06.000000', 'temperatura', 261.0000, 'ºC'),
	(40535, 110, '2015-02-01 00:14:07.000000', 'temperatura', 301.0000, 'ºC'),
	(40536, 110, '2015-02-01 00:14:08.000000', 'temperatura', 722.0000, 'ºC'),
	(40537, 110, '2015-02-01 00:14:09.000000', 'temperatura', 308.0000, 'ºC'),
	(40538, 110, '2015-02-01 00:14:10.000000', 'temperatura', 576.0000, 'ºC'),
	(40539, 110, '2015-02-01 00:14:11.000000', 'temperatura', 757.0000, 'ºC'),
	(40540, 110, '2015-02-01 00:14:12.000000', 'temperatura', 855.0000, 'ºC'),
	(40541, 110, '2015-02-01 00:14:13.000000', 'temperatura', 807.0000, 'ºC'),
	(40542, 110, '2015-02-01 00:14:14.000000', 'temperatura', 271.0000, 'ºC'),
	(40543, 110, '2015-02-01 00:14:15.000000', 'temperatura', 135.0000, 'ºC'),
	(40544, 110, '2015-02-01 00:14:16.000000', 'temperatura', 1061.0000, 'ºC'),
	(40545, 110, '2015-02-01 00:14:17.000000', 'temperatura', 103.0000, 'ºC'),
	(40546, 110, '2015-02-01 00:14:18.000000', 'temperatura', 930.0000, 'ºC'),
	(40547, 110, '2015-02-01 00:14:19.000000', 'temperatura', 743.0000, 'ºC'),
	(40548, 110, '2015-02-01 00:14:20.000000', 'temperatura', 924.0000, 'ºC'),
	(40549, 110, '2015-02-01 00:14:21.000000', 'temperatura', 1192.0000, 'ºC'),
	(40550, 110, '2015-02-01 00:14:22.000000', 'temperatura', 788.0000, 'ºC'),
	(40551, 110, '2015-02-01 00:14:23.000000', 'temperatura', 366.0000, 'ºC'),
	(40552, 110, '2015-02-01 00:14:24.000000', 'temperatura', 665.0000, 'ºC'),
	(40553, 110, '2015-02-01 00:14:25.000000', 'temperatura', 1030.0000, 'ºC'),
	(40554, 110, '2015-02-01 00:14:26.000000', 'temperatura', 753.0000, 'ºC'),
	(40555, 110, '2015-02-01 00:14:27.000000', 'temperatura', 675.0000, 'ºC'),
	(40556, 110, '2015-02-01 00:14:28.000000', 'temperatura', 1119.0000, 'ºC'),
	(40557, 110, '2015-02-01 00:14:29.000000', 'temperatura', 1169.0000, 'ºC'),
	(40558, 110, '2015-02-01 00:14:30.000000', 'temperatura', 87.0000, 'ºC'),
	(40559, 110, '2015-02-01 00:14:31.000000', 'temperatura', 530.0000, 'ºC'),
	(40560, 110, '2015-02-01 00:14:32.000000', 'temperatura', 1188.0000, 'ºC'),
	(40561, 110, '2015-02-01 00:14:33.000000', 'temperatura', 750.0000, 'ºC'),
	(40562, 110, '2015-02-01 00:14:34.000000', 'temperatura', 186.0000, 'ºC'),
	(40563, 110, '2015-02-01 00:14:35.000000', 'temperatura', 1079.0000, 'ºC'),
	(40564, 110, '2015-02-01 00:14:36.000000', 'temperatura', 41.0000, 'ºC'),
	(40565, 110, '2015-02-01 00:14:37.000000', 'temperatura', 569.0000, 'ºC'),
	(40566, 110, '2015-02-01 00:14:38.000000', 'temperatura', 320.0000, 'ºC'),
	(40567, 110, '2015-02-01 00:14:39.000000', 'temperatura', 1095.0000, 'ºC'),
	(40568, 110, '2015-02-01 00:14:40.000000', 'temperatura', 916.0000, 'ºC'),
	(40569, 110, '2015-02-01 00:14:41.000000', 'temperatura', 93.0000, 'ºC'),
	(40570, 110, '2015-02-01 00:14:42.000000', 'temperatura', 120.0000, 'ºC'),
	(40571, 110, '2015-02-01 00:14:43.000000', 'temperatura', 320.0000, 'ºC'),
	(40572, 110, '2015-02-01 00:14:44.000000', 'temperatura', 42.0000, 'ºC'),
	(40573, 110, '2015-02-01 00:14:45.000000', 'temperatura', 450.0000, 'ºC'),
	(40574, 110, '2015-02-01 00:14:46.000000', 'temperatura', 924.0000, 'ºC'),
	(40575, 110, '2015-02-01 00:14:47.000000', 'temperatura', 870.0000, 'ºC'),
	(40576, 110, '2015-02-01 00:14:48.000000', 'temperatura', 381.0000, 'ºC'),
	(40577, 110, '2015-02-01 00:14:49.000000', 'temperatura', 495.0000, 'ºC'),
	(40578, 110, '2015-02-01 00:14:50.000000', 'temperatura', 131.0000, 'ºC'),
	(40579, 110, '2015-02-01 00:14:51.000000', 'temperatura', 371.0000, 'ºC'),
	(40580, 110, '2015-02-01 00:14:52.000000', 'temperatura', 262.0000, 'ºC'),
	(40581, 110, '2015-02-01 00:14:53.000000', 'temperatura', 198.0000, 'ºC'),
	(40582, 110, '2015-02-01 00:14:54.000000', 'temperatura', 206.0000, 'ºC'),
	(40583, 110, '2015-02-01 00:14:55.000000', 'temperatura', 434.0000, 'ºC'),
	(40584, 110, '2015-02-01 00:14:56.000000', 'temperatura', 354.0000, 'ºC'),
	(40585, 110, '2015-02-01 00:14:57.000000', 'temperatura', 470.0000, 'ºC'),
	(40586, 110, '2015-02-01 00:14:58.000000', 'temperatura', 88.0000, 'ºC'),
	(40587, 110, '2015-02-01 00:14:59.000000', 'temperatura', 229.0000, 'ºC'),
	(40588, 110, '2015-02-01 00:15:00.000000', 'temperatura', 881.0000, 'ºC'),
	(40589, 110, '2015-02-01 00:15:01.000000', 'temperatura', 118.0000, 'ºC'),
	(40590, 110, '2015-02-01 00:15:02.000000', 'temperatura', 348.0000, 'ºC'),
	(40591, 110, '2015-02-01 00:15:03.000000', 'temperatura', 187.0000, 'ºC'),
	(40592, 110, '2015-02-01 00:15:04.000000', 'temperatura', 1093.0000, 'ºC'),
	(40593, 110, '2015-02-01 00:15:05.000000', 'temperatura', 104.0000, 'ºC'),
	(40594, 110, '2015-02-01 00:15:06.000000', 'temperatura', 842.0000, 'ºC'),
	(40595, 110, '2015-02-01 00:15:07.000000', 'temperatura', 298.0000, 'ºC'),
	(40596, 110, '2015-02-01 00:15:08.000000', 'temperatura', 165.0000, 'ºC'),
	(40597, 110, '2015-02-01 00:15:09.000000', 'temperatura', 1133.0000, 'ºC'),
	(40598, 110, '2015-02-01 00:15:10.000000', 'temperatura', 367.0000, 'ºC'),
	(40599, 110, '2015-02-01 00:15:11.000000', 'temperatura', 838.0000, 'ºC'),
	(40600, 110, '2015-02-01 00:15:12.000000', 'temperatura', 690.0000, 'ºC'),
	(40601, 110, '2015-02-01 00:15:13.000000', 'temperatura', 936.0000, 'ºC'),
	(40602, 110, '2015-02-01 00:15:14.000000', 'temperatura', 212.0000, 'ºC'),
	(40603, 110, '2015-02-01 00:15:15.000000', 'temperatura', 649.0000, 'ºC'),
	(40604, 110, '2015-02-01 00:15:16.000000', 'temperatura', 213.0000, 'ºC'),
	(40605, 110, '2015-02-01 00:15:17.000000', 'temperatura', 318.0000, 'ºC'),
	(40606, 110, '2015-02-01 00:15:18.000000', 'temperatura', 953.0000, 'ºC'),
	(40607, 110, '2015-02-01 00:15:19.000000', 'temperatura', 210.0000, 'ºC'),
	(40608, 110, '2015-02-01 00:15:20.000000', 'temperatura', 591.0000, 'ºC'),
	(40609, 110, '2015-02-01 00:15:21.000000', 'temperatura', 1125.0000, 'ºC'),
	(40610, 110, '2015-02-01 00:15:22.000000', 'temperatura', 253.0000, 'ºC'),
	(40611, 110, '2015-02-01 00:15:23.000000', 'temperatura', 288.0000, 'ºC'),
	(40612, 110, '2015-02-01 00:15:24.000000', 'temperatura', 685.0000, 'ºC'),
	(40613, 110, '2015-02-01 00:15:25.000000', 'temperatura', 162.0000, 'ºC'),
	(40614, 110, '2015-02-01 00:15:26.000000', 'temperatura', 1152.0000, 'ºC'),
	(40615, 110, '2015-02-01 00:15:27.000000', 'temperatura', 477.0000, 'ºC'),
	(40616, 110, '2015-02-01 00:15:28.000000', 'temperatura', 130.0000, 'ºC'),
	(40617, 110, '2015-02-01 00:15:29.000000', 'temperatura', 418.0000, 'ºC'),
	(40618, 110, '2015-02-01 00:15:30.000000', 'temperatura', 499.0000, 'ºC'),
	(40619, 110, '2015-02-01 00:15:31.000000', 'temperatura', 42.0000, 'ºC'),
	(40620, 110, '2015-02-01 00:15:32.000000', 'temperatura', 1115.0000, 'ºC'),
	(40621, 110, '2015-02-01 00:15:33.000000', 'temperatura', 650.0000, 'ºC'),
	(40622, 110, '2015-02-01 00:15:34.000000', 'temperatura', 1106.0000, 'ºC'),
	(40623, 110, '2015-02-01 00:15:35.000000', 'temperatura', 1178.0000, 'ºC'),
	(40624, 110, '2015-02-01 00:15:36.000000', 'temperatura', 174.0000, 'ºC'),
	(40625, 110, '2015-02-01 00:15:37.000000', 'temperatura', 937.0000, 'ºC'),
	(40626, 110, '2015-02-01 00:15:38.000000', 'temperatura', 565.0000, 'ºC'),
	(40627, 110, '2015-02-01 00:15:39.000000', 'temperatura', 11.0000, 'ºC'),
	(40628, 110, '2015-02-01 00:15:40.000000', 'temperatura', 763.0000, 'ºC'),
	(40629, 110, '2015-02-01 00:15:41.000000', 'temperatura', 182.0000, 'ºC'),
	(40630, 110, '2015-02-01 00:15:42.000000', 'temperatura', 1022.0000, 'ºC'),
	(40631, 110, '2015-02-01 00:15:43.000000', 'temperatura', 964.0000, 'ºC'),
	(40632, 110, '2015-02-01 00:15:44.000000', 'temperatura', 554.0000, 'ºC'),
	(40633, 110, '2015-02-01 00:15:45.000000', 'temperatura', 1078.0000, 'ºC'),
	(40634, 110, '2015-02-01 00:15:46.000000', 'temperatura', 128.0000, 'ºC'),
	(40635, 110, '2015-02-01 00:15:47.000000', 'temperatura', 1007.0000, 'ºC'),
	(40636, 110, '2015-02-01 00:15:48.000000', 'temperatura', 1054.0000, 'ºC'),
	(40637, 110, '2015-02-01 00:15:49.000000', 'temperatura', 1046.0000, 'ºC'),
	(40638, 110, '2015-02-01 00:15:50.000000', 'temperatura', 869.0000, 'ºC'),
	(40639, 110, '2015-02-01 00:15:51.000000', 'temperatura', 9.0000, 'ºC'),
	(40640, 110, '2015-02-01 00:15:52.000000', 'temperatura', 1038.0000, 'ºC'),
	(40641, 110, '2015-02-01 00:15:53.000000', 'temperatura', 365.0000, 'ºC'),
	(40642, 110, '2015-02-01 00:15:54.000000', 'temperatura', 1111.0000, 'ºC'),
	(40643, 110, '2015-02-01 00:15:55.000000', 'temperatura', 858.0000, 'ºC'),
	(40644, 110, '2015-02-01 00:15:56.000000', 'temperatura', 960.0000, 'ºC'),
	(40645, 110, '2015-02-01 00:15:57.000000', 'temperatura', 1024.0000, 'ºC'),
	(40646, 110, '2015-02-01 00:15:58.000000', 'temperatura', 1043.0000, 'ºC'),
	(40647, 110, '2015-02-01 00:15:59.000000', 'temperatura', 942.0000, 'ºC'),
	(40648, 110, '2015-02-01 00:16:00.000000', 'temperatura', 381.0000, 'ºC'),
	(40649, 110, '2015-02-01 00:16:01.000000', 'temperatura', 280.0000, 'ºC'),
	(40650, 110, '2015-02-01 00:16:02.000000', 'temperatura', 258.0000, 'ºC'),
	(40651, 110, '2015-02-01 00:16:03.000000', 'temperatura', 450.0000, 'ºC'),
	(40652, 110, '2015-02-01 00:16:04.000000', 'temperatura', 278.0000, 'ºC'),
	(40653, 110, '2015-02-01 00:16:05.000000', 'temperatura', 41.0000, 'ºC'),
	(40654, 110, '2015-02-01 00:16:06.000000', 'temperatura', 572.0000, 'ºC'),
	(40655, 110, '2015-02-01 00:16:07.000000', 'temperatura', 336.0000, 'ºC'),
	(40656, 110, '2015-02-01 00:16:08.000000', 'temperatura', 1166.0000, 'ºC'),
	(40657, 110, '2015-02-01 00:16:09.000000', 'temperatura', 23.0000, 'ºC'),
	(40658, 110, '2015-02-01 00:16:10.000000', 'temperatura', 215.0000, 'ºC'),
	(40659, 110, '2015-02-01 00:16:11.000000', 'temperatura', 1009.0000, 'ºC'),
	(40660, 110, '2015-02-01 00:16:12.000000', 'temperatura', 798.0000, 'ºC'),
	(40661, 110, '2015-02-01 00:16:13.000000', 'temperatura', 962.0000, 'ºC'),
	(40662, 110, '2015-02-01 00:16:14.000000', 'temperatura', 20.0000, 'ºC'),
	(40663, 110, '2015-02-01 00:16:15.000000', 'temperatura', 814.0000, 'ºC'),
	(40664, 110, '2015-02-01 00:16:16.000000', 'temperatura', 412.0000, 'ºC'),
	(40665, 110, '2015-02-01 00:16:17.000000', 'temperatura', 817.0000, 'ºC'),
	(40666, 110, '2015-02-01 00:16:18.000000', 'temperatura', 451.0000, 'ºC'),
	(40667, 110, '2015-02-01 00:16:19.000000', 'temperatura', 1005.0000, 'ºC'),
	(40668, 110, '2015-02-01 00:16:20.000000', 'temperatura', 72.0000, 'ºC'),
	(40669, 110, '2015-02-01 00:16:21.000000', 'temperatura', 945.0000, 'ºC'),
	(40670, 110, '2015-02-01 00:16:22.000000', 'temperatura', 911.0000, 'ºC'),
	(40671, 110, '2015-02-01 00:16:23.000000', 'temperatura', 518.0000, 'ºC'),
	(40672, 110, '2015-02-01 00:16:24.000000', 'temperatura', 1060.0000, 'ºC'),
	(40673, 110, '2015-02-01 00:16:25.000000', 'temperatura', 146.0000, 'ºC'),
	(40674, 110, '2015-02-01 00:16:26.000000', 'temperatura', 1152.0000, 'ºC'),
	(40675, 110, '2015-02-01 00:16:27.000000', 'temperatura', 521.0000, 'ºC'),
	(40676, 110, '2015-02-01 00:16:28.000000', 'temperatura', 351.0000, 'ºC'),
	(40677, 110, '2015-02-01 00:16:29.000000', 'temperatura', 191.0000, 'ºC'),
	(40678, 110, '2015-02-01 00:16:30.000000', 'temperatura', 1102.0000, 'ºC'),
	(40679, 110, '2015-02-01 00:16:31.000000', 'temperatura', 138.0000, 'ºC'),
	(40680, 110, '2015-02-01 00:16:32.000000', 'temperatura', 983.0000, 'ºC'),
	(40681, 110, '2015-02-01 00:16:33.000000', 'temperatura', 901.0000, 'ºC'),
	(40682, 110, '2015-02-01 00:16:34.000000', 'temperatura', 358.0000, 'ºC'),
	(40683, 110, '2015-02-01 00:16:35.000000', 'temperatura', 287.0000, 'ºC'),
	(40684, 110, '2015-02-01 00:16:36.000000', 'temperatura', 363.0000, 'ºC'),
	(40685, 110, '2015-02-01 00:16:37.000000', 'temperatura', 953.0000, 'ºC'),
	(40686, 110, '2015-02-01 00:16:38.000000', 'temperatura', 77.0000, 'ºC'),
	(40687, 110, '2015-02-01 00:16:39.000000', 'temperatura', 1127.0000, 'ºC'),
	(40688, 110, '2015-02-01 00:16:40.000000', 'temperatura', 603.0000, 'ºC'),
	(40689, 110, '2015-02-01 00:16:41.000000', 'temperatura', 836.0000, 'ºC'),
	(40690, 110, '2015-02-01 00:16:42.000000', 'temperatura', 1171.0000, 'ºC'),
	(40691, 110, '2015-02-01 00:16:43.000000', 'temperatura', 949.0000, 'ºC'),
	(40692, 110, '2015-02-01 00:16:44.000000', 'temperatura', 34.0000, 'ºC'),
	(40693, 110, '2015-02-01 00:16:45.000000', 'temperatura', 920.0000, 'ºC'),
	(40694, 110, '2015-02-01 00:16:46.000000', 'temperatura', 900.0000, 'ºC'),
	(40695, 110, '2015-02-01 00:16:47.000000', 'temperatura', 538.0000, 'ºC'),
	(40696, 110, '2015-02-01 00:16:48.000000', 'temperatura', 1194.0000, 'ºC'),
	(40697, 110, '2015-02-01 00:16:49.000000', 'temperatura', 756.0000, 'ºC'),
	(40698, 110, '2015-02-01 00:16:50.000000', 'temperatura', 197.0000, 'ºC'),
	(40699, 110, '2015-02-01 00:16:51.000000', 'temperatura', 1118.0000, 'ºC'),
	(40700, 110, '2015-02-01 00:16:52.000000', 'temperatura', 199.0000, 'ºC'),
	(40701, 110, '2015-02-01 00:16:53.000000', 'temperatura', 43.0000, 'ºC'),
	(40702, 110, '2015-02-01 00:16:54.000000', 'temperatura', 818.0000, 'ºC'),
	(40703, 110, '2015-02-01 00:16:55.000000', 'temperatura', 363.0000, 'ºC'),
	(40704, 110, '2015-02-01 00:16:56.000000', 'temperatura', 561.0000, 'ºC'),
	(40705, 110, '2015-02-01 00:16:57.000000', 'temperatura', 516.0000, 'ºC'),
	(40706, 110, '2015-02-01 00:16:58.000000', 'temperatura', 900.0000, 'ºC'),
	(40707, 110, '2015-02-01 00:16:59.000000', 'temperatura', 549.0000, 'ºC'),
	(40708, 110, '2015-02-01 00:17:00.000000', 'temperatura', 47.0000, 'ºC'),
	(40709, 110, '2015-02-01 00:17:01.000000', 'temperatura', 987.0000, 'ºC'),
	(40710, 110, '2015-02-01 00:17:02.000000', 'temperatura', 1197.0000, 'ºC'),
	(40711, 110, '2015-02-01 00:17:03.000000', 'temperatura', 625.0000, 'ºC'),
	(40712, 110, '2015-02-01 00:17:04.000000', 'temperatura', 733.0000, 'ºC'),
	(40713, 110, '2015-02-01 00:17:05.000000', 'temperatura', 590.0000, 'ºC'),
	(40714, 110, '2015-02-01 00:17:06.000000', 'temperatura', 752.0000, 'ºC'),
	(40715, 110, '2015-02-01 00:17:07.000000', 'temperatura', 789.0000, 'ºC'),
	(40716, 110, '2015-02-01 00:17:08.000000', 'temperatura', 490.0000, 'ºC'),
	(40717, 110, '2015-02-01 00:17:09.000000', 'temperatura', 85.0000, 'ºC'),
	(40718, 110, '2015-02-01 00:17:10.000000', 'temperatura', 155.0000, 'ºC'),
	(40719, 110, '2015-02-01 00:17:11.000000', 'temperatura', 518.0000, 'ºC'),
	(40720, 110, '2015-02-01 00:17:12.000000', 'temperatura', 928.0000, 'ºC'),
	(40721, 110, '2015-02-01 00:17:13.000000', 'temperatura', 687.0000, 'ºC'),
	(40722, 110, '2015-02-01 00:17:14.000000', 'temperatura', 652.0000, 'ºC'),
	(40723, 110, '2015-02-01 00:17:15.000000', 'temperatura', 1198.0000, 'ºC'),
	(40724, 110, '2015-02-01 00:17:16.000000', 'temperatura', 436.0000, 'ºC'),
	(40725, 110, '2015-02-01 00:17:17.000000', 'temperatura', 985.0000, 'ºC'),
	(40726, 110, '2015-02-01 00:17:18.000000', 'temperatura', 16.0000, 'ºC'),
	(40727, 110, '2015-02-01 00:17:19.000000', 'temperatura', 728.0000, 'ºC'),
	(40728, 110, '2015-02-01 00:17:20.000000', 'temperatura', 1191.0000, 'ºC'),
	(40729, 110, '2015-02-01 00:17:21.000000', 'temperatura', 174.0000, 'ºC'),
	(40730, 110, '2015-02-01 00:17:22.000000', 'temperatura', 896.0000, 'ºC'),
	(40731, 110, '2015-02-01 00:17:23.000000', 'temperatura', 361.0000, 'ºC'),
	(40732, 110, '2015-02-01 00:17:24.000000', 'temperatura', 314.0000, 'ºC'),
	(40733, 110, '2015-02-01 00:17:25.000000', 'temperatura', 490.0000, 'ºC'),
	(40734, 110, '2015-02-01 00:17:26.000000', 'temperatura', 306.0000, 'ºC'),
	(40735, 110, '2015-02-01 00:17:27.000000', 'temperatura', 60.0000, 'ºC'),
	(40736, 110, '2015-02-01 00:17:28.000000', 'temperatura', 582.0000, 'ºC'),
	(40737, 110, '2015-02-01 00:17:29.000000', 'temperatura', 331.0000, 'ºC'),
	(40738, 110, '2015-02-01 00:17:30.000000', 'temperatura', 1108.0000, 'ºC'),
	(40739, 110, '2015-02-01 00:17:31.000000', 'temperatura', 948.0000, 'ºC'),
	(40740, 110, '2015-02-01 00:17:32.000000', 'temperatura', 219.0000, 'ºC'),
	(40741, 110, '2015-02-01 00:17:33.000000', 'temperatura', 650.0000, 'ºC'),
	(40742, 110, '2015-02-01 00:17:34.000000', 'temperatura', 195.0000, 'ºC'),
	(40743, 110, '2015-02-01 00:17:35.000000', 'temperatura', 225.0000, 'ºC'),
	(40744, 110, '2015-02-01 00:17:36.000000', 'temperatura', 542.0000, 'ºC'),
	(40745, 110, '2015-02-01 00:17:37.000000', 'temperatura', 832.0000, 'ºC'),
	(40746, 110, '2015-02-01 00:17:38.000000', 'temperatura', 137.0000, 'ºC'),
	(40747, 110, '2015-02-01 00:17:39.000000', 'temperatura', 588.0000, 'ºC'),
	(40748, 110, '2015-02-01 00:17:40.000000', 'temperatura', 129.0000, 'ºC'),
	(40749, 110, '2015-02-01 00:17:41.000000', 'temperatura', 83.0000, 'ºC'),
	(40750, 110, '2015-02-01 00:17:42.000000', 'temperatura', 28.0000, 'ºC'),
	(40751, 110, '2015-02-01 00:17:43.000000', 'temperatura', 1091.0000, 'ºC'),
	(40752, 110, '2015-02-01 00:17:44.000000', 'temperatura', 573.0000, 'ºC'),
	(40753, 110, '2015-02-01 00:17:45.000000', 'temperatura', 792.0000, 'ºC'),
	(40754, 110, '2015-02-01 00:17:46.000000', 'temperatura', 1041.0000, 'ºC'),
	(40755, 110, '2015-02-01 00:17:47.000000', 'temperatura', 429.0000, 'ºC'),
	(40756, 110, '2015-02-01 00:17:48.000000', 'temperatura', 224.0000, 'ºC'),
	(40757, 110, '2015-02-01 00:17:49.000000', 'temperatura', 1035.0000, 'ºC'),
	(40758, 110, '2015-02-01 00:17:50.000000', 'temperatura', 901.0000, 'ºC'),
	(40759, 110, '2015-02-01 00:17:51.000000', 'temperatura', 201.0000, 'ºC'),
	(40760, 110, '2015-02-01 00:17:52.000000', 'temperatura', 702.0000, 'ºC'),
	(40761, 110, '2015-02-01 00:17:53.000000', 'temperatura', 508.0000, 'ºC'),
	(40762, 110, '2015-02-01 00:17:54.000000', 'temperatura', 432.0000, 'ºC'),
	(40763, 110, '2015-02-01 00:17:55.000000', 'temperatura', 640.0000, 'ºC'),
	(40764, 110, '2015-02-01 00:17:56.000000', 'temperatura', 703.0000, 'ºC'),
	(40765, 110, '2015-02-01 00:17:57.000000', 'temperatura', 397.0000, 'ºC'),
	(40766, 110, '2015-02-01 00:17:58.000000', 'temperatura', 1074.0000, 'ºC'),
	(40767, 110, '2015-02-01 00:17:59.000000', 'temperatura', 581.0000, 'ºC'),
	(40768, 110, '2015-02-01 00:18:00.000000', 'temperatura', 882.0000, 'ºC'),
	(40769, 110, '2015-02-01 00:18:01.000000', 'temperatura', 267.0000, 'ºC'),
	(40770, 110, '2015-02-01 00:18:02.000000', 'temperatura', 1089.0000, 'ºC'),
	(40771, 110, '2015-02-01 00:18:03.000000', 'temperatura', 1044.0000, 'ºC'),
	(40772, 110, '2015-02-01 00:18:04.000000', 'temperatura', 753.0000, 'ºC'),
	(40773, 110, '2015-02-01 00:18:05.000000', 'temperatura', 635.0000, 'ºC'),
	(40774, 110, '2015-02-01 00:18:06.000000', 'temperatura', 916.0000, 'ºC'),
	(40775, 110, '2015-02-01 00:18:07.000000', 'temperatura', 275.0000, 'ºC'),
	(40776, 110, '2015-02-01 00:18:08.000000', 'temperatura', 1029.0000, 'ºC'),
	(40777, 110, '2015-02-01 00:18:09.000000', 'temperatura', 721.0000, 'ºC'),
	(40778, 110, '2015-02-01 00:18:10.000000', 'temperatura', 517.0000, 'ºC'),
	(40779, 110, '2015-02-01 00:18:11.000000', 'temperatura', 423.0000, 'ºC'),
	(40780, 110, '2015-02-01 00:18:12.000000', 'temperatura', 565.0000, 'ºC'),
	(40781, 110, '2015-02-01 00:18:13.000000', 'temperatura', 356.0000, 'ºC'),
	(40782, 110, '2015-02-01 00:18:14.000000', 'temperatura', 85.0000, 'ºC'),
	(40783, 110, '2015-02-01 00:18:15.000000', 'temperatura', 560.0000, 'ºC'),
	(40784, 110, '2015-02-01 00:18:16.000000', 'temperatura', 144.0000, 'ºC'),
	(40785, 110, '2015-02-01 00:18:17.000000', 'temperatura', 241.0000, 'ºC'),
	(40786, 110, '2015-02-01 00:18:18.000000', 'temperatura', 774.0000, 'ºC'),
	(40787, 110, '2015-02-01 00:18:19.000000', 'temperatura', 746.0000, 'ºC'),
	(40788, 110, '2015-02-01 00:18:20.000000', 'temperatura', 208.0000, 'ºC'),
	(40789, 110, '2015-02-01 00:18:21.000000', 'temperatura', 2.0000, 'ºC'),
	(40790, 110, '2015-02-01 00:18:22.000000', 'temperatura', 588.0000, 'ºC'),
	(40791, 110, '2015-02-01 00:18:23.000000', 'temperatura', 534.0000, 'ºC'),
	(40792, 110, '2015-02-01 00:18:24.000000', 'temperatura', 907.0000, 'ºC'),
	(40793, 110, '2015-02-01 00:18:25.000000', 'temperatura', 532.0000, 'ºC'),
	(40794, 110, '2015-02-01 00:18:26.000000', 'temperatura', 1140.0000, 'ºC'),
	(40795, 110, '2015-02-01 00:18:27.000000', 'temperatura', 506.0000, 'ºC'),
	(40796, 110, '2015-02-01 00:18:28.000000', 'temperatura', 310.0000, 'ºC'),
	(40797, 110, '2015-02-01 00:18:29.000000', 'temperatura', 32.0000, 'ºC'),
	(40798, 110, '2015-02-01 00:18:30.000000', 'temperatura', 430.0000, 'ºC'),
	(40799, 110, '2015-02-01 00:18:31.000000', 'temperatura', 855.0000, 'ºC'),
	(40800, 110, '2015-02-01 00:18:32.000000', 'temperatura', 584.0000, 'ºC'),
	(40801, 110, '2015-02-01 00:18:33.000000', 'temperatura', 358.0000, 'ºC'),
	(40802, 110, '2015-02-01 00:18:34.000000', 'temperatura', 35.0000, 'ºC'),
	(40803, 110, '2015-02-01 00:18:35.000000', 'temperatura', 305.0000, 'ºC'),
	(40804, 110, '2015-02-01 00:18:36.000000', 'temperatura', 219.0000, 'ºC'),
	(40805, 110, '2015-02-01 00:18:37.000000', 'temperatura', 179.0000, 'ºC'),
	(40806, 110, '2015-02-01 00:18:38.000000', 'temperatura', 239.0000, 'ºC'),
	(40807, 110, '2015-02-01 00:18:39.000000', 'temperatura', 659.0000, 'ºC'),
	(40808, 110, '2015-02-01 00:18:40.000000', 'temperatura', 177.0000, 'ºC'),
	(40809, 110, '2015-02-01 00:18:41.000000', 'temperatura', 111.0000, 'ºC'),
	(40810, 110, '2015-02-01 00:18:42.000000', 'temperatura', 23.0000, 'ºC'),
	(40811, 110, '2015-02-01 00:18:43.000000', 'temperatura', 982.0000, 'ºC'),
	(40812, 110, '2015-02-01 00:18:44.000000', 'temperatura', 44.0000, 'ºC'),
	(40813, 110, '2015-02-01 00:18:45.000000', 'temperatura', 871.0000, 'ºC'),
	(40814, 110, '2015-02-01 00:18:46.000000', 'temperatura', 627.0000, 'ºC'),
	(40815, 110, '2015-02-01 00:18:47.000000', 'temperatura', 519.0000, 'ºC'),
	(40816, 110, '2015-02-01 00:18:48.000000', 'temperatura', 717.0000, 'ºC'),
	(40817, 110, '2015-02-01 00:18:49.000000', 'temperatura', 828.0000, 'ºC'),
	(40818, 110, '2015-02-01 00:18:50.000000', 'temperatura', 791.0000, 'ºC'),
	(40819, 110, '2015-02-01 00:18:51.000000', 'temperatura', 269.0000, 'ºC'),
	(40820, 110, '2015-02-01 00:18:52.000000', 'temperatura', 175.0000, 'ºC'),
	(40821, 110, '2015-02-01 00:18:53.000000', 'temperatura', 65.0000, 'ºC'),
	(40822, 110, '2015-02-01 00:18:54.000000', 'temperatura', 1004.0000, 'ºC'),
	(40823, 110, '2015-02-01 00:18:55.000000', 'temperatura', 23.0000, 'ºC'),
	(40824, 110, '2015-02-01 00:18:56.000000', 'temperatura', 705.0000, 'ºC'),
	(40825, 110, '2015-02-01 00:18:57.000000', 'temperatura', 1056.0000, 'ºC'),
	(40826, 110, '2015-02-01 00:18:58.000000', 'temperatura', 764.0000, 'ºC'),
	(40827, 110, '2015-02-01 00:18:59.000000', 'temperatura', 651.0000, 'ºC'),
	(40828, 110, '2015-02-01 00:19:00.000000', 'temperatura', 967.0000, 'ºC'),
	(40829, 110, '2015-02-01 00:19:01.000000', 'temperatura', 483.0000, 'ºC'),
	(40830, 110, '2015-02-01 00:19:02.000000', 'temperatura', 711.0000, 'ºC'),
	(40831, 110, '2015-02-01 00:19:03.000000', 'temperatura', 909.0000, 'ºC'),
	(40832, 110, '2015-02-01 00:19:04.000000', 'temperatura', 13.0000, 'ºC'),
	(40833, 110, '2015-02-01 00:19:05.000000', 'temperatura', 938.0000, 'ºC'),
	(40834, 110, '2015-02-01 00:19:06.000000', 'temperatura', 1053.0000, 'ºC'),
	(40835, 110, '2015-02-01 00:19:07.000000', 'temperatura', 50.0000, 'ºC'),
	(40836, 110, '2015-02-01 00:19:08.000000', 'temperatura', 691.0000, 'ºC'),
	(40837, 110, '2015-02-01 00:19:09.000000', 'temperatura', 904.0000, 'ºC'),
	(40838, 110, '2015-02-01 00:19:10.000000', 'temperatura', 48.0000, 'ºC'),
	(40839, 110, '2015-02-01 00:19:11.000000', 'temperatura', 1131.0000, 'ºC'),
	(40840, 110, '2015-02-01 00:19:12.000000', 'temperatura', 709.0000, 'ºC'),
	(40841, 110, '2015-02-01 00:19:13.000000', 'temperatura', 154.0000, 'ºC'),
	(40842, 110, '2015-02-01 00:19:14.000000', 'temperatura', 1044.0000, 'ºC'),
	(40843, 110, '2015-02-01 00:19:15.000000', 'temperatura', 1158.0000, 'ºC'),
	(40844, 110, '2015-02-01 00:19:16.000000', 'temperatura', 259.0000, 'ºC'),
	(40845, 110, '2015-02-01 00:19:17.000000', 'temperatura', 219.0000, 'ºC'),
	(40846, 110, '2015-02-01 00:19:18.000000', 'temperatura', 322.0000, 'ºC'),
	(40847, 110, '2015-02-01 00:19:19.000000', 'temperatura', 951.0000, 'ºC'),
	(40848, 110, '2015-02-01 00:19:20.000000', 'temperatura', 191.0000, 'ºC'),
	(40849, 110, '2015-02-01 00:19:21.000000', 'temperatura', 504.0000, 'ºC'),
	(40850, 110, '2015-02-01 00:19:22.000000', 'temperatura', 746.0000, 'ºC'),
	(40851, 110, '2015-02-01 00:19:23.000000', 'temperatura', 1019.0000, 'ºC'),
	(40852, 110, '2015-02-01 00:19:24.000000', 'temperatura', 457.0000, 'ºC'),
	(40853, 110, '2015-02-01 00:19:25.000000', 'temperatura', 429.0000, 'ºC'),
	(40854, 110, '2015-02-01 00:19:26.000000', 'temperatura', 774.0000, 'ºC'),
	(40855, 110, '2015-02-01 00:19:27.000000', 'temperatura', 184.0000, 'ºC'),
	(40856, 110, '2015-02-01 00:19:28.000000', 'temperatura', 998.0000, 'ºC'),
	(40857, 110, '2015-02-01 00:19:29.000000', 'temperatura', 838.0000, 'ºC'),
	(40858, 110, '2015-02-01 00:19:30.000000', 'temperatura', 1199.0000, 'ºC'),
	(40859, 110, '2015-02-01 00:19:31.000000', 'temperatura', 1080.0000, 'ºC'),
	(40860, 110, '2015-02-01 00:19:32.000000', 'temperatura', 604.0000, 'ºC'),
	(40861, 110, '2015-02-01 00:19:33.000000', 'temperatura', 981.0000, 'ºC'),
	(40862, 110, '2015-02-01 00:19:34.000000', 'temperatura', 692.0000, 'ºC'),
	(40863, 110, '2015-02-01 00:19:35.000000', 'temperatura', 517.0000, 'ºC'),
	(40864, 110, '2015-02-01 00:19:36.000000', 'temperatura', 512.0000, 'ºC'),
	(40865, 110, '2015-02-01 00:19:37.000000', 'temperatura', 1010.0000, 'ºC'),
	(40866, 110, '2015-02-01 00:19:38.000000', 'temperatura', 1113.0000, 'ºC'),
	(40867, 110, '2015-02-01 00:19:39.000000', 'temperatura', 135.0000, 'ºC'),
	(40868, 110, '2015-02-01 00:19:40.000000', 'temperatura', 935.0000, 'ºC'),
	(40869, 110, '2015-02-01 00:19:41.000000', 'temperatura', 673.0000, 'ºC'),
	(40870, 110, '2015-02-01 00:19:42.000000', 'temperatura', 560.0000, 'ºC'),
	(40871, 110, '2015-02-01 00:19:43.000000', 'temperatura', 782.0000, 'ºC'),
	(40872, 110, '2015-02-01 00:19:44.000000', 'temperatura', 1028.0000, 'ºC'),
	(40873, 110, '2015-02-01 00:19:45.000000', 'temperatura', 396.0000, 'ºC'),
	(40874, 110, '2015-02-01 00:19:46.000000', 'temperatura', 96.0000, 'ºC'),
	(40875, 110, '2015-02-01 00:19:47.000000', 'temperatura', 494.0000, 'ºC'),
	(40876, 110, '2015-02-01 00:19:48.000000', 'temperatura', 980.0000, 'ºC'),
	(40877, 110, '2015-02-01 00:19:49.000000', 'temperatura', 1021.0000, 'ºC'),
	(40878, 110, '2015-02-01 00:19:50.000000', 'temperatura', 963.0000, 'ºC'),
	(40879, 110, '2015-02-01 00:19:51.000000', 'temperatura', 555.0000, 'ºC'),
	(40880, 110, '2015-02-01 00:19:52.000000', 'temperatura', 1087.0000, 'ºC'),
	(40881, 110, '2015-02-01 00:19:53.000000', 'temperatura', 172.0000, 'ºC'),
	(40882, 110, '2015-02-01 00:19:54.000000', 'temperatura', 1196.0000, 'ºC'),
	(40883, 110, '2015-02-01 00:19:55.000000', 'temperatura', 665.0000, 'ºC'),
	(40884, 110, '2015-02-01 00:19:56.000000', 'temperatura', 939.0000, 'ºC'),
	(40885, 110, '2015-02-01 00:19:57.000000', 'temperatura', 300.0000, 'ºC'),
	(40886, 110, '2015-02-01 00:19:58.000000', 'temperatura', 1085.0000, 'ºC'),
	(40887, 110, '2015-02-01 00:19:59.000000', 'temperatura', 924.0000, 'ºC'),
	(40888, 110, '2015-02-01 00:20:00.000000', 'temperatura', 165.0000, 'ºC'),
	(40889, 110, '2015-02-01 00:20:01.000000', 'temperatura', 456.0000, 'ºC'),
	(40890, 110, '2015-02-01 00:20:02.000000', 'temperatura', 584.0000, 'ºC'),
	(40891, 110, '2015-02-01 00:20:03.000000', 'temperatura', 353.0000, 'ºC'),
	(40892, 110, '2015-02-01 00:20:04.000000', 'temperatura', 14.0000, 'ºC'),
	(40893, 110, '2015-02-01 00:20:05.000000', 'temperatura', 211.0000, 'ºC'),
	(40894, 110, '2015-02-01 00:20:06.000000', 'temperatura', 1012.0000, 'ºC'),
	(40895, 110, '2015-02-01 00:20:07.000000', 'temperatura', 828.0000, 'ºC'),
	(40896, 110, '2015-02-01 00:20:08.000000', 'temperatura', 1104.0000, 'ºC'),
	(40897, 110, '2015-02-01 00:20:09.000000', 'temperatura', 635.0000, 'ºC'),
	(40898, 110, '2015-02-01 00:20:10.000000', 'temperatura', 1065.0000, 'ºC'),
	(40899, 110, '2015-02-01 00:20:11.000000', 'temperatura', 1021.0000, 'ºC'),
	(40900, 110, '2015-02-01 00:20:12.000000', 'temperatura', 710.0000, 'ºC'),
	(40901, 110, '2015-02-01 00:20:13.000000', 'temperatura', 486.0000, 'ºC'),
	(40902, 110, '2015-02-01 00:20:14.000000', 'temperatura', 301.0000, 'ºC'),
	(40903, 110, '2015-02-01 00:20:15.000000', 'temperatura', 46.0000, 'ºC'),
	(40904, 110, '2015-02-01 00:20:16.000000', 'temperatura', 528.0000, 'ºC'),
	(40905, 110, '2015-02-01 00:20:17.000000', 'temperatura', 103.0000, 'ºC'),
	(40906, 110, '2015-02-01 00:20:18.000000', 'temperatura', 130.0000, 'ºC'),
	(40907, 110, '2015-02-01 00:20:19.000000', 'temperatura', 342.0000, 'ºC'),
	(40908, 110, '2015-02-01 00:20:20.000000', 'temperatura', 121.0000, 'ºC'),
	(40909, 110, '2015-02-01 00:20:21.000000', 'temperatura', 780.0000, 'ºC'),
	(40910, 110, '2015-02-01 00:20:22.000000', 'temperatura', 1136.0000, 'ºC'),
	(40911, 110, '2015-02-01 00:20:23.000000', 'temperatura', 943.0000, 'ºC'),
	(40912, 110, '2015-02-01 00:20:24.000000', 'temperatura', 107.0000, 'ºC'),
	(40913, 110, '2015-02-01 00:20:25.000000', 'temperatura', 105.0000, 'ºC'),
	(40914, 110, '2015-02-01 00:20:26.000000', 'temperatura', 205.0000, 'ºC'),
	(40915, 110, '2015-02-01 00:20:27.000000', 'temperatura', 710.0000, 'ºC'),
	(40916, 110, '2015-02-01 00:20:28.000000', 'temperatura', 536.0000, 'ºC'),
	(40917, 110, '2015-02-01 00:20:29.000000', 'temperatura', 549.0000, 'ºC'),
	(40918, 110, '2015-02-01 00:20:30.000000', 'temperatura', 1140.0000, 'ºC'),
	(40919, 110, '2015-02-01 00:20:31.000000', 'temperatura', 452.0000, 'ºC'),
	(40920, 110, '2015-02-01 00:20:32.000000', 'temperatura', 42.0000, 'ºC'),
	(40921, 110, '2015-02-01 00:20:33.000000', 'temperatura', 55.0000, 'ºC'),
	(40922, 110, '2015-02-01 00:20:34.000000', 'temperatura', 147.0000, 'ºC'),
	(40923, 110, '2015-02-01 00:20:35.000000', 'temperatura', 573.0000, 'ºC'),
	(40924, 110, '2015-02-01 00:20:36.000000', 'temperatura', 23.0000, 'ºC'),
	(40925, 110, '2015-02-01 00:20:37.000000', 'temperatura', 798.0000, 'ºC'),
	(40926, 110, '2015-02-01 00:20:38.000000', 'temperatura', 320.0000, 'ºC'),
	(40927, 110, '2015-02-01 00:20:39.000000', 'temperatura', 405.0000, 'ºC'),
	(40928, 110, '2015-02-01 00:20:40.000000', 'temperatura', 1067.0000, 'ºC'),
	(40929, 110, '2015-02-01 00:20:41.000000', 'temperatura', 520.0000, 'ºC'),
	(40930, 110, '2015-02-01 00:20:42.000000', 'temperatura', 601.0000, 'ºC'),
	(40931, 110, '2015-02-01 00:20:43.000000', 'temperatura', 243.0000, 'ºC'),
	(40932, 110, '2015-02-01 00:20:44.000000', 'temperatura', 612.0000, 'ºC'),
	(40933, 110, '2015-02-01 00:20:45.000000', 'temperatura', 1135.0000, 'ºC'),
	(40934, 110, '2015-02-01 00:20:46.000000', 'temperatura', 237.0000, 'ºC'),
	(40935, 110, '2015-02-01 00:20:47.000000', 'temperatura', 180.0000, 'ºC'),
	(40936, 110, '2015-02-01 00:20:48.000000', 'temperatura', 191.0000, 'ºC'),
	(40937, 110, '2015-02-01 00:20:49.000000', 'temperatura', 415.0000, 'ºC'),
	(40938, 110, '2015-02-01 00:20:50.000000', 'temperatura', 304.0000, 'ºC'),
	(40939, 110, '2015-02-01 00:20:51.000000', 'temperatura', 274.0000, 'ºC'),
	(40940, 110, '2015-02-01 00:20:52.000000', 'temperatura', 460.0000, 'ºC'),
	(40941, 110, '2015-02-01 00:20:53.000000', 'temperatura', 278.0000, 'ºC'),
	(40942, 110, '2015-02-01 00:20:54.000000', 'temperatura', 11.0000, 'ºC'),
	(40943, 110, '2015-02-01 00:20:55.000000', 'temperatura', 420.0000, 'ºC'),
	(40944, 110, '2015-02-01 00:20:56.000000', 'temperatura', 869.0000, 'ºC'),
	(40945, 110, '2015-02-01 00:20:57.000000', 'temperatura', 685.0000, 'ºC'),
	(40946, 110, '2015-02-01 00:20:58.000000', 'temperatura', 820.0000, 'ºC'),
	(40947, 110, '2015-02-01 00:20:59.000000', 'temperatura', 846.0000, 'ºC'),
	(40948, 110, '2015-02-01 00:21:00.000000', 'temperatura', 571.0000, 'ºC'),
	(40949, 110, '2015-02-01 00:21:01.000000', 'temperatura', 315.0000, 'ºC'),
	(40950, 110, '2015-02-01 00:21:02.000000', 'temperatura', 1063.0000, 'ºC'),
	(40951, 110, '2015-02-01 00:21:03.000000', 'temperatura', 772.0000, 'ºC'),
	(40952, 110, '2015-02-01 00:21:04.000000', 'temperatura', 670.0000, 'ºC'),
	(40953, 110, '2015-02-01 00:21:05.000000', 'temperatura', 1033.0000, 'ºC'),
	(40954, 110, '2015-02-01 00:21:06.000000', 'temperatura', 759.0000, 'ºC'),
	(40955, 110, '2015-02-01 00:21:07.000000', 'temperatura', 694.0000, 'ºC'),
	(40956, 110, '2015-02-01 00:21:08.000000', 'temperatura', 1193.0000, 'ºC'),
	(40957, 110, '2015-02-01 00:21:09.000000', 'temperatura', 284.0000, 'ºC'),
	(40958, 110, '2015-02-01 00:21:10.000000', 'temperatura', 240.0000, 'ºC'),
	(40959, 110, '2015-02-01 00:21:11.000000', 'temperatura', 349.0000, 'ºC'),
	(40960, 110, '2015-02-01 00:21:12.000000', 'temperatura', 1024.0000, 'ºC'),
	(40961, 110, '2015-02-01 00:21:13.000000', 'temperatura', 475.0000, 'ºC'),
	(40962, 110, '2015-02-01 00:21:14.000000', 'temperatura', 501.0000, 'ºC'),
	(40963, 110, '2015-02-01 00:21:15.000000', 'temperatura', 1084.0000, 'ºC'),
	(40964, 110, '2015-02-01 00:21:16.000000', 'temperatura', 314.0000, 'ºC'),
	(40965, 110, '2015-02-01 00:21:17.000000', 'temperatura', 721.0000, 'ºC'),
	(40966, 110, '2015-02-01 00:21:18.000000', 'temperatura', 262.0000, 'ºC'),
	(40967, 110, '2015-02-01 00:21:19.000000', 'temperatura', 350.0000, 'ºC'),
	(40968, 110, '2015-02-01 00:21:20.000000', 'temperatura', 964.0000, 'ºC'),
	(40969, 110, '2015-02-01 00:21:21.000000', 'temperatura', 170.0000, 'ºC'),
	(40970, 110, '2015-02-01 00:21:22.000000', 'temperatura', 360.0000, 'ºC'),
	(40971, 110, '2015-02-01 00:21:23.000000', 'temperatura', 87.0000, 'ºC'),
	(40972, 110, '2015-02-01 00:21:24.000000', 'temperatura', 558.0000, 'ºC'),
	(40973, 110, '2015-02-01 00:21:25.000000', 'temperatura', 131.0000, 'ºC'),
	(40974, 110, '2015-02-01 00:21:26.000000', 'temperatura', 179.0000, 'ºC'),
	(40975, 110, '2015-02-01 00:21:27.000000', 'temperatura', 504.0000, 'ºC'),
	(40976, 110, '2015-02-01 00:21:28.000000', 'temperatura', 784.0000, 'ºC'),
	(40977, 110, '2015-02-01 00:21:29.000000', 'temperatura', 7.0000, 'ºC'),
	(40978, 110, '2015-02-01 00:21:30.000000', 'temperatura', 84.0000, 'ºC'),
	(40979, 110, '2015-02-01 00:21:31.000000', 'temperatura', 401.0000, 'ºC'),
	(40980, 110, '2015-02-01 00:21:32.000000', 'temperatura', 554.0000, 'ºC'),
	(40981, 110, '2015-02-01 00:21:33.000000', 'temperatura', 365.0000, 'ºC'),
	(40982, 110, '2015-02-01 00:21:34.000000', 'temperatura', 163.0000, 'ºC'),
	(40983, 110, '2015-02-01 00:21:35.000000', 'temperatura', 921.0000, 'ºC'),
	(40984, 110, '2015-02-01 00:21:36.000000', 'temperatura', 515.0000, 'ºC'),
	(40985, 110, '2015-02-01 00:21:37.000000', 'temperatura', 1015.0000, 'ºC'),
	(40986, 110, '2015-02-01 00:21:38.000000', 'temperatura', 1130.0000, 'ºC'),
	(40987, 110, '2015-02-01 00:21:39.000000', 'temperatura', 206.0000, 'ºC'),
	(40988, 110, '2015-02-01 00:21:40.000000', 'temperatura', 38.0000, 'ºC'),
	(40989, 110, '2015-02-01 00:21:41.000000', 'temperatura', 776.0000, 'ºC'),
	(40990, 110, '2015-02-01 00:21:42.000000', 'temperatura', 164.0000, 'ºC'),
	(40991, 110, '2015-02-01 00:21:43.000000', 'temperatura', 892.0000, 'ºC'),
	(40992, 110, '2015-02-01 00:21:44.000000', 'temperatura', 369.0000, 'ºC'),
	(40993, 110, '2015-02-01 00:21:45.000000', 'temperatura', 372.0000, 'ºC'),
	(40994, 110, '2015-02-01 00:21:46.000000', 'temperatura', 751.0000, 'ºC'),
	(40995, 110, '2015-02-01 00:21:47.000000', 'temperatura', 242.0000, 'ºC'),
	(40996, 110, '2015-02-01 00:21:48.000000', 'temperatura', 156.0000, 'ºC'),
	(40997, 110, '2015-02-01 00:21:49.000000', 'temperatura', 55.0000, 'ºC'),
	(40998, 110, '2015-02-01 00:21:50.000000', 'temperatura', 1005.0000, 'ºC'),
	(40999, 110, '2015-02-01 00:21:51.000000', 'temperatura', 63.0000, 'ºC'),
	(41000, 110, '2015-02-01 00:21:52.000000', 'temperatura', 899.0000, 'ºC'),
	(41001, 110, '2015-02-01 00:21:53.000000', 'temperatura', 707.0000, 'ºC'),
	(41002, 110, '2015-02-01 00:21:54.000000', 'temperatura', 839.0000, 'ºC'),
	(41003, 110, '2015-02-01 00:21:55.000000', 'temperatura', 874.0000, 'ºC'),
	(41004, 110, '2015-02-01 00:21:56.000000', 'temperatura', 655.0000, 'ºC'),
	(41005, 110, '2015-02-01 00:21:57.000000', 'temperatura', 652.0000, 'ºC'),
	(41006, 110, '2015-02-01 00:21:58.000000', 'temperatura', 97.0000, 'ºC'),
	(41007, 110, '2015-02-01 00:21:59.000000', 'temperatura', 928.0000, 'ºC'),
	(41008, 110, '2015-02-01 00:22:00.000000', 'temperatura', 750.0000, 'ºC'),
	(41009, 110, '2015-02-01 00:22:01.000000', 'temperatura', 968.0000, 'ºC'),
	(41010, 110, '2015-02-01 00:22:02.000000', 'temperatura', 189.0000, 'ºC'),
	(41011, 110, '2015-02-01 00:22:03.000000', 'temperatura', 440.0000, 'ºC'),
	(41012, 110, '2015-02-01 00:22:04.000000', 'temperatura', 433.0000, 'ºC'),
	(41013, 110, '2015-02-01 00:22:05.000000', 'temperatura', 849.0000, 'ºC'),
	(41014, 110, '2015-02-01 00:22:06.000000', 'temperatura', 544.0000, 'ºC'),
	(41015, 110, '2015-02-01 00:22:07.000000', 'temperatura', 173.0000, 'ºC'),
	(41016, 110, '2015-02-01 00:22:08.000000', 'temperatura', 432.0000, 'ºC'),
	(41017, 110, '2015-02-01 00:22:09.000000', 'temperatura', 444.0000, 'ºC'),
	(41018, 110, '2015-02-01 00:22:10.000000', 'temperatura', 924.0000, 'ºC'),
	(41019, 110, '2015-02-01 00:22:11.000000', 'temperatura', 890.0000, 'ºC'),
	(41020, 110, '2015-02-01 00:22:12.000000', 'temperatura', 477.0000, 'ºC'),
	(41021, 110, '2015-02-01 00:22:13.000000', 'temperatura', 914.0000, 'ºC'),
	(41022, 110, '2015-02-01 00:22:14.000000', 'temperatura', 742.0000, 'ºC'),
	(41023, 110, '2015-02-01 00:22:15.000000', 'temperatura', 969.0000, 'ºC'),
	(41024, 110, '2015-02-01 00:22:16.000000', 'temperatura', 218.0000, 'ºC'),
	(41025, 110, '2015-02-01 00:22:17.000000', 'temperatura', 584.0000, 'ºC'),
	(41026, 110, '2015-02-01 00:22:18.000000', 'temperatura', 1065.0000, 'ºC'),
	(41027, 110, '2015-02-01 00:22:19.000000', 'temperatura', 1174.0000, 'ºC'),
	(41028, 110, '2015-02-01 00:22:20.000000', 'temperatura', 277.0000, 'ºC'),
	(41029, 110, '2015-02-01 00:22:21.000000', 'temperatura', 263.0000, 'ºC'),
	(41030, 110, '2015-02-01 00:22:22.000000', 'temperatura', 483.0000, 'ºC'),
	(41031, 110, '2015-02-01 00:22:23.000000', 'temperatura', 426.0000, 'ºC'),
	(41032, 110, '2015-02-01 00:22:24.000000', 'temperatura', 682.0000, 'ºC'),
	(41033, 110, '2015-02-01 00:22:25.000000', 'temperatura', 932.0000, 'ºC'),
	(41034, 110, '2015-02-01 00:22:26.000000', 'temperatura', 215.0000, 'ºC'),
	(41035, 110, '2015-02-01 00:22:27.000000', 'temperatura', 679.0000, 'ºC'),
	(41036, 110, '2015-02-01 00:22:28.000000', 'temperatura', 352.0000, 'ºC'),
	(41037, 110, '2015-02-01 00:22:29.000000', 'temperatura', 922.0000, 'ºC'),
	(41038, 110, '2015-02-01 00:22:30.000000', 'temperatura', 1155.0000, 'ºC'),
	(41039, 110, '2015-02-01 00:22:31.000000', 'temperatura', 611.0000, 'ºC'),
	(41040, 110, '2015-02-01 00:22:32.000000', 'temperatura', 789.0000, 'ºC'),
	(41041, 110, '2015-02-01 00:22:33.000000', 'temperatura', 915.0000, 'ºC'),
	(41042, 110, '2015-02-01 00:22:34.000000', 'temperatura', 1007.0000, 'ºC'),
	(41043, 110, '2015-02-01 00:22:35.000000', 'temperatura', 1089.0000, 'ºC'),
	(41044, 110, '2015-02-01 00:22:36.000000', 'temperatura', 25.0000, 'ºC'),
	(41045, 110, '2015-02-01 00:22:37.000000', 'temperatura', 460.0000, 'ºC'),
	(41046, 110, '2015-02-01 00:22:38.000000', 'temperatura', 1023.0000, 'ºC'),
	(41047, 110, '2015-02-01 00:22:39.000000', 'temperatura', 135.0000, 'ºC'),
	(41048, 110, '2015-02-01 00:22:40.000000', 'temperatura', 10.0000, 'ºC'),
	(41049, 110, '2015-02-01 00:22:41.000000', 'temperatura', 842.0000, 'ºC'),
	(41050, 110, '2015-02-01 00:22:42.000000', 'temperatura', 583.0000, 'ºC'),
	(41051, 110, '2015-02-01 00:22:43.000000', 'temperatura', 389.0000, 'ºC'),
	(41052, 110, '2015-02-01 00:22:44.000000', 'temperatura', 195.0000, 'ºC'),
	(41053, 110, '2015-02-01 00:22:45.000000', 'temperatura', 1009.0000, 'ºC'),
	(41054, 110, '2015-02-01 00:22:46.000000', 'temperatura', 859.0000, 'ºC'),
	(41055, 110, '2015-02-01 00:22:47.000000', 'temperatura', 69.0000, 'ºC'),
	(41056, 110, '2015-02-01 00:22:48.000000', 'temperatura', 168.0000, 'ºC'),
	(41057, 110, '2015-02-01 00:22:49.000000', 'temperatura', 634.0000, 'ºC'),
	(41058, 110, '2015-02-01 00:22:50.000000', 'temperatura', 269.0000, 'ºC'),
	(41059, 110, '2015-02-01 00:22:51.000000', 'temperatura', 640.0000, 'ºC'),
	(41060, 110, '2015-02-01 00:22:52.000000', 'temperatura', 1196.0000, 'ºC'),
	(41061, 110, '2015-02-01 00:22:53.000000', 'temperatura', 461.0000, 'ºC'),
	(41062, 110, '2015-02-01 00:22:54.000000', 'temperatura', 1115.0000, 'ºC'),
	(41063, 110, '2015-02-01 00:22:55.000000', 'temperatura', 595.0000, 'ºC'),
	(41064, 110, '2015-02-01 00:22:56.000000', 'temperatura', 828.0000, 'ºC'),
	(41065, 110, '2015-02-01 00:22:57.000000', 'temperatura', 1157.0000, 'ºC'),
	(41066, 110, '2015-02-01 00:22:58.000000', 'temperatura', 900.0000, 'ºC'),
	(41067, 110, '2015-02-01 00:22:59.000000', 'temperatura', 1030.0000, 'ºC'),
	(41068, 110, '2015-02-01 00:23:00.000000', 'temperatura', 49.0000, 'ºC'),
	(41069, 110, '2015-02-01 00:23:01.000000', 'temperatura', 756.0000, 'ºC'),
	(41070, 110, '2015-02-01 00:23:02.000000', 'temperatura', 34.0000, 'ºC'),
	(41071, 110, '2015-02-01 00:23:03.000000', 'temperatura', 304.0000, 'ºC'),
	(41072, 110, '2015-02-01 00:23:04.000000', 'temperatura', 219.0000, 'ºC'),
	(41073, 110, '2015-02-01 00:23:05.000000', 'temperatura', 181.0000, 'ºC'),
	(41074, 110, '2015-02-01 00:23:06.000000', 'temperatura', 251.0000, 'ºC'),
	(41075, 110, '2015-02-01 00:23:07.000000', 'temperatura', 712.0000, 'ºC'),
	(41076, 110, '2015-02-01 00:23:08.000000', 'temperatura', 406.0000, 'ºC'),
	(41077, 110, '2015-02-01 00:23:09.000000', 'temperatura', 1094.0000, 'ºC'),
	(41078, 110, '2015-02-01 00:23:10.000000', 'temperatura', 655.0000, 'ºC'),
	(41079, 110, '2015-02-01 00:23:11.000000', 'temperatura', 1192.0000, 'ºC'),
	(41080, 110, '2015-02-01 00:23:12.000000', 'temperatura', 396.0000, 'ºC'),
	(41081, 110, '2015-02-01 00:23:13.000000', 'temperatura', 806.0000, 'ºC'),
	(41082, 110, '2015-02-01 00:23:14.000000', 'temperatura', 440.0000, 'ºC'),
	(41083, 110, '2015-02-01 00:23:15.000000', 'temperatura', 981.0000, 'ºC'),
	(41084, 110, '2015-02-01 00:23:16.000000', 'temperatura', 1188.0000, 'ºC'),
	(41085, 110, '2015-02-01 00:23:17.000000', 'temperatura', 599.0000, 'ºC'),
	(41086, 110, '2015-02-01 00:23:18.000000', 'temperatura', 630.0000, 'ºC'),
	(41087, 110, '2015-02-01 00:23:19.000000', 'temperatura', 154.0000, 'ºC'),
	(41088, 110, '2015-02-01 00:23:20.000000', 'temperatura', 79.0000, 'ºC'),
	(41089, 110, '2015-02-01 00:23:21.000000', 'temperatura', 1136.0000, 'ºC'),
	(41090, 110, '2015-02-01 00:23:22.000000', 'temperatura', 643.0000, 'ºC'),
	(41091, 110, '2015-02-01 00:23:23.000000', 'temperatura', 1008.0000, 'ºC'),
	(41092, 110, '2015-02-01 00:23:24.000000', 'temperatura', 713.0000, 'ºC'),
	(41093, 110, '2015-02-01 00:23:25.000000', 'temperatura', 539.0000, 'ºC'),
	(41094, 110, '2015-02-01 00:23:26.000000', 'temperatura', 555.0000, 'ºC'),
	(41095, 110, '2015-02-01 00:23:27.000000', 'temperatura', 1162.0000, 'ºC'),
	(41096, 110, '2015-02-01 00:23:28.000000', 'temperatura', 544.0000, 'ºC'),
	(41097, 110, '2015-02-01 00:23:29.000000', 'temperatura', 435.0000, 'ºC'),
	(41098, 110, '2015-02-01 00:23:30.000000', 'temperatura', 542.0000, 'ºC'),
	(41099, 110, '2015-02-01 00:23:31.000000', 'temperatura', 205.0000, 'ºC'),
	(41100, 110, '2015-02-01 00:23:32.000000', 'temperatura', 598.0000, 'ºC'),
	(41101, 110, '2015-02-01 00:23:33.000000', 'temperatura', 1179.0000, 'ºC'),
	(41102, 110, '2015-02-01 00:23:34.000000', 'temperatura', 501.0000, 'ºC'),
	(41103, 110, '2015-02-01 00:23:35.000000', 'temperatura', 168.0000, 'ºC'),
	(41104, 110, '2015-02-01 00:23:36.000000', 'temperatura', 536.0000, 'ºC'),
	(41105, 110, '2015-02-01 00:23:37.000000', 'temperatura', 976.0000, 'ºC'),
	(41106, 110, '2015-02-01 00:23:38.000000', 'temperatura', 875.0000, 'ºC'),
	(41107, 110, '2015-02-01 00:23:39.000000', 'temperatura', 246.0000, 'ºC'),
	(41108, 110, '2015-02-01 00:23:40.000000', 'temperatura', 1008.0000, 'ºC'),
	(41109, 110, '2015-02-01 00:23:41.000000', 'temperatura', 700.0000, 'ºC'),
	(41110, 110, '2015-02-01 00:23:42.000000', 'temperatura', 479.0000, 'ºC'),
	(41111, 110, '2015-02-01 00:23:43.000000', 'temperatura', 292.0000, 'ºC'),
	(41112, 110, '2015-02-01 00:23:44.000000', 'temperatura', 27.0000, 'ºC'),
	(41113, 110, '2015-02-01 00:23:45.000000', 'temperatura', 458.0000, 'ºC'),
	(41114, 110, '2015-02-01 00:23:46.000000', 'temperatura', 1011.0000, 'ºC'),
	(41115, 110, '2015-02-01 00:23:47.000000', 'temperatura', 82.0000, 'ºC'),
	(41116, 110, '2015-02-01 00:23:48.000000', 'temperatura', 976.0000, 'ºC'),
	(41117, 110, '2015-02-01 00:23:49.000000', 'temperatura', 1034.0000, 'ºC'),
	(41118, 110, '2015-02-01 00:23:50.000000', 'temperatura', 1044.0000, 'ºC'),
	(41119, 110, '2015-02-01 00:23:51.000000', 'temperatura', 918.0000, 'ºC'),
	(41120, 110, '2015-02-01 00:23:52.000000', 'temperatura', 258.0000, 'ºC'),
	(41121, 110, '2015-02-01 00:23:53.000000', 'temperatura', 937.0000, 'ºC'),
	(41122, 110, '2015-02-01 00:23:54.000000', 'temperatura', 311.0000, 'ºC'),
	(41123, 110, '2015-02-01 00:23:55.000000', 'temperatura', 1145.0000, 'ºC'),
	(41124, 110, '2015-02-01 00:23:56.000000', 'temperatura', 1193.0000, 'ºC'),
	(41125, 110, '2015-02-01 00:23:57.000000', 'temperatura', 132.0000, 'ºC'),
	(41126, 110, '2015-02-01 00:23:58.000000', 'temperatura', 681.0000, 'ºC'),
	(41127, 110, '2015-02-01 00:23:59.000000', 'temperatura', 607.0000, 'ºC'),
	(41128, 110, '2015-02-01 00:24:00.000000', 'temperatura', 995.0000, 'ºC'),
	(41129, 110, '2015-02-01 00:24:01.000000', 'temperatura', 756.0000, 'ºC'),
	(41130, 110, '2015-02-01 00:24:02.000000', 'temperatura', 793.0000, 'ºC'),
	(41131, 110, '2015-02-01 00:24:03.000000', 'temperatura', 497.0000, 'ºC'),
	(41132, 110, '2015-02-01 00:24:04.000000', 'temperatura', 107.0000, 'ºC'),
	(41133, 110, '2015-02-01 00:24:05.000000', 'temperatura', 244.0000, 'ºC'),
	(41134, 110, '2015-02-01 00:24:06.000000', 'temperatura', 900.0000, 'ºC'),
	(41135, 110, '2015-02-01 00:24:07.000000', 'temperatura', 169.0000, 'ºC'),
	(41136, 110, '2015-02-01 00:24:08.000000', 'temperatura', 543.0000, 'ºC'),
	(41137, 110, '2015-02-01 00:24:09.000000', 'temperatura', 1011.0000, 'ºC'),
	(41138, 110, '2015-02-01 00:24:10.000000', 'temperatura', 1024.0000, 'ºC'),
	(41139, 110, '2015-02-01 00:24:11.000000', 'temperatura', 890.0000, 'ºC'),
	(41140, 110, '2015-02-01 00:24:12.000000', 'temperatura', 176.0000, 'ºC'),
	(41141, 110, '2015-02-01 00:24:13.000000', 'temperatura', 612.0000, 'ºC'),
	(41142, 110, '2015-02-01 00:24:14.000000', 'temperatura', 132.0000, 'ºC'),
	(41143, 110, '2015-02-01 00:24:15.000000', 'temperatura', 24.0000, 'ºC'),
	(41144, 110, '2015-02-01 00:24:16.000000', 'temperatura', 923.0000, 'ºC'),
	(41145, 110, '2015-02-01 00:24:17.000000', 'temperatura', 945.0000, 'ºC'),
	(41146, 110, '2015-02-01 00:24:18.000000', 'temperatura', 755.0000, 'ºC'),
	(41147, 110, '2015-02-01 00:24:19.000000', 'temperatura', 943.0000, 'ºC'),
	(41148, 110, '2015-02-01 00:24:20.000000', 'temperatura', 50.0000, 'ºC'),
	(41149, 110, '2015-02-01 00:24:21.000000', 'temperatura', 1021.0000, 'ºC'),
	(41150, 110, '2015-02-01 00:24:22.000000', 'temperatura', 156.0000, 'ºC'),
	(41151, 110, '2015-02-01 00:24:23.000000', 'temperatura', 118.0000, 'ºC'),
	(41152, 110, '2015-02-01 00:24:24.000000', 'temperatura', 122.0000, 'ºC'),
	(41153, 110, '2015-02-01 00:24:25.000000', 'temperatura', 257.0000, 'ºC'),
	(41154, 110, '2015-02-01 00:24:26.000000', 'temperatura', 920.0000, 'ºC'),
	(41155, 110, '2015-02-01 00:24:27.000000', 'temperatura', 230.0000, 'ºC'),
	(41156, 110, '2015-02-01 00:24:28.000000', 'temperatura', 790.0000, 'ºC'),
	(41157, 110, '2015-02-01 00:24:29.000000', 'temperatura', 860.0000, 'ºC'),
	(41158, 110, '2015-02-01 00:24:30.000000', 'temperatura', 732.0000, 'ºC'),
	(41159, 110, '2015-02-01 00:24:31.000000', 'temperatura', 1079.0000, 'ºC'),
	(41160, 110, '2015-02-01 00:24:32.000000', 'temperatura', 798.0000, 'ºC'),
	(41161, 110, '2015-02-01 00:24:33.000000', 'temperatura', 755.0000, 'ºC'),
	(41162, 110, '2015-02-01 00:24:34.000000', 'temperatura', 182.0000, 'ºC'),
	(41163, 110, '2015-02-01 00:24:35.000000', 'temperatura', 1046.0000, 'ºC'),
	(41164, 110, '2015-02-01 00:24:36.000000', 'temperatura', 1085.0000, 'ºC'),
	(41165, 110, '2015-02-01 00:24:37.000000', 'temperatura', 1087.0000, 'ºC'),
	(41166, 110, '2015-02-01 00:24:38.000000', 'temperatura', 982.0000, 'ºC'),
	(41167, 110, '2015-02-01 00:24:39.000000', 'temperatura', 450.0000, 'ºC'),
	(41168, 110, '2015-02-01 00:24:40.000000', 'temperatura', 503.0000, 'ºC'),
	(41169, 110, '2015-02-01 00:24:41.000000', 'temperatura', 1164.0000, 'ºC'),
	(41170, 110, '2015-02-01 00:24:42.000000', 'temperatura', 714.0000, 'ºC'),
	(41171, 110, '2015-02-01 00:24:43.000000', 'temperatura', 77.0000, 'ºC'),
	(41172, 110, '2015-02-01 00:24:44.000000', 'temperatura', 644.0000, 'ºC'),
	(41173, 110, '2015-02-01 00:24:45.000000', 'temperatura', 590.0000, 'ºC'),
	(41174, 110, '2015-02-01 00:24:46.000000', 'temperatura', 1019.0000, 'ºC'),
	(41175, 110, '2015-02-01 00:24:47.000000', 'temperatura', 925.0000, 'ºC'),
	(41176, 110, '2015-02-01 00:24:48.000000', 'temperatura', 370.0000, 'ºC'),
	(41177, 110, '2015-02-01 00:24:49.000000', 'temperatura', 274.0000, 'ºC'),
	(41178, 110, '2015-02-01 00:24:50.000000', 'temperatura', 262.0000, 'ºC'),
	(41179, 110, '2015-02-01 00:24:51.000000', 'temperatura', 486.0000, 'ºC'),
	(41180, 110, '2015-02-01 00:24:52.000000', 'temperatura', 444.0000, 'ºC'),
	(41181, 110, '2015-02-01 00:24:53.000000', 'temperatura', 763.0000, 'ºC'),
	(41182, 110, '2015-02-01 00:24:54.000000', 'temperatura', 83.0000, 'ºC'),
	(41183, 110, '2015-02-01 00:24:55.000000', 'temperatura', 527.0000, 'ºC'),
	(41184, 110, '2015-02-01 00:24:56.000000', 'temperatura', 1186.0000, 'ºC'),
	(41185, 110, '2015-02-01 00:24:57.000000', 'temperatura', 749.0000, 'ºC'),
	(41186, 110, '2015-02-01 00:24:58.000000', 'temperatura', 189.0000, 'ºC'),
	(41187, 110, '2015-02-01 00:24:59.000000', 'temperatura', 1098.0000, 'ºC'),
	(41188, 110, '2015-02-01 00:25:00.000000', 'temperatura', 125.0000, 'ºC'),
	(41189, 110, '2015-02-01 00:25:01.000000', 'temperatura', 929.0000, 'ºC'),
	(41190, 110, '2015-02-01 00:25:02.000000', 'temperatura', 673.0000, 'ºC'),
	(41191, 110, '2015-02-01 00:25:03.000000', 'temperatura', 576.0000, 'ºC'),
	(41192, 110, '2015-02-01 00:25:04.000000', 'temperatura', 863.0000, 'ºC'),
	(41193, 110, '2015-02-01 00:25:05.000000', 'temperatura', 186.0000, 'ºC'),
	(41194, 110, '2015-02-01 00:25:06.000000', 'temperatura', 741.0000, 'ºC'),
	(41195, 110, '2015-02-01 00:25:07.000000', 'temperatura', 748.0000, 'ºC'),
	(41196, 110, '2015-02-01 00:25:08.000000', 'temperatura', 316.0000, 'ºC'),
	(41197, 110, '2015-02-01 00:25:09.000000', 'temperatura', 539.0000, 'ºC'),
	(41198, 110, '2015-02-01 00:25:10.000000', 'temperatura', 545.0000, 'ºC'),
	(41199, 110, '2015-02-01 00:25:11.000000', 'temperatura', 1111.0000, 'ºC'),
	(41200, 110, '2015-02-01 00:25:12.000000', 'temperatura', 318.0000, 'ºC'),
	(41201, 110, '2015-02-01 00:25:13.000000', 'temperatura', 660.0000, 'ºC'),
	(41202, 110, '2015-02-01 00:25:14.000000', 'temperatura', 1147.0000, 'ºC'),
	(41203, 110, '2015-02-01 00:25:15.000000', 'temperatura', 155.0000, 'ºC'),
	(41204, 110, '2015-02-01 00:25:16.000000', 'temperatura', 936.0000, 'ºC'),
	(41205, 110, '2015-02-01 00:25:17.000000', 'temperatura', 615.0000, 'ºC'),
	(41206, 110, '2015-02-01 00:25:18.000000', 'temperatura', 266.0000, 'ºC'),
	(41207, 110, '2015-02-01 00:25:19.000000', 'temperatura', 687.0000, 'ºC'),
	(41208, 110, '2015-02-01 00:25:20.000000', 'temperatura', 237.0000, 'ºC'),
	(41209, 110, '2015-02-01 00:25:21.000000', 'temperatura', 324.0000, 'ºC'),
	(41210, 110, '2015-02-01 00:25:22.000000', 'temperatura', 910.0000, 'ºC'),
	(41211, 110, '2015-02-01 00:25:23.000000', 'temperatura', 1178.0000, 'ºC'),
	(41212, 110, '2015-02-01 00:25:24.000000', 'temperatura', 762.0000, 'ºC'),
	(41213, 110, '2015-02-01 00:25:25.000000', 'temperatura', 274.0000, 'ºC'),
	(41214, 110, '2015-02-01 00:25:26.000000', 'temperatura', 286.0000, 'ºC'),
	(41215, 110, '2015-02-01 00:25:27.000000', 'temperatura', 608.0000, 'ºC'),
	(41216, 110, '2015-02-01 00:25:28.000000', 'temperatura', 985.0000, 'ºC'),
	(41217, 110, '2015-02-01 00:25:29.000000', 'temperatura', 698.0000, 'ºC'),
	(41218, 110, '2015-02-01 00:25:30.000000', 'temperatura', 536.0000, 'ºC'),
	(41219, 110, '2015-02-01 00:25:31.000000', 'temperatura', 588.0000, 'ºC'),
	(41220, 110, '2015-02-01 00:25:32.000000', 'temperatura', 133.0000, 'ºC'),
	(41221, 110, '2015-02-01 00:25:33.000000', 'temperatura', 99.0000, 'ºC'),
	(41222, 110, '2015-02-01 00:25:34.000000', 'temperatura', 97.0000, 'ºC'),
	(41223, 110, '2015-02-01 00:25:35.000000', 'temperatura', 190.0000, 'ºC'),
	(41224, 110, '2015-02-01 00:25:36.000000', 'temperatura', 658.0000, 'ºC'),
	(41225, 110, '2015-02-01 00:25:37.000000', 'temperatura', 320.0000, 'ºC'),
	(41226, 110, '2015-02-01 00:25:38.000000', 'temperatura', 828.0000, 'ºC'),
	(41227, 110, '2015-02-01 00:25:39.000000', 'temperatura', 778.0000, 'ºC'),
	(41228, 110, '2015-02-01 00:25:40.000000', 'temperatura', 209.0000, 'ºC'),
	(41229, 110, '2015-02-01 00:25:41.000000', 'temperatura', 1113.0000, 'ºC'),
	(41230, 110, '2015-02-01 00:25:42.000000', 'temperatura', 135.0000, 'ºC'),
	(41231, 110, '2015-02-01 00:25:43.000000', 'temperatura', 938.0000, 'ºC'),
	(41232, 110, '2015-02-01 00:25:44.000000', 'temperatura', 683.0000, 'ºC'),
	(41233, 110, '2015-02-01 00:25:45.000000', 'temperatura', 604.0000, 'ºC'),
	(41234, 110, '2015-02-01 00:25:46.000000', 'temperatura', 972.0000, 'ºC'),
	(41235, 110, '2015-02-01 00:25:47.000000', 'temperatura', 647.0000, 'ºC'),
	(41236, 110, '2015-02-01 00:25:48.000000', 'temperatura', 318.0000, 'ºC'),
	(41237, 110, '2015-02-01 00:25:49.000000', 'temperatura', 851.0000, 'ºC'),
	(41238, 110, '2015-02-01 00:25:50.000000', 'temperatura', 903.0000, 'ºC'),
	(41239, 110, '2015-02-01 00:25:51.000000', 'temperatura', 759.0000, 'ºC'),
	(41240, 110, '2015-02-01 00:25:52.000000', 'temperatura', 1090.0000, 'ºC'),
	(41241, 110, '2015-02-01 00:25:53.000000', 'temperatura', 771.0000, 'ºC'),
	(41242, 110, '2015-02-01 00:25:54.000000', 'temperatura', 587.0000, 'ºC'),
	(41243, 110, '2015-02-01 00:25:55.000000', 'temperatura', 623.0000, 'ºC'),
	(41244, 110, '2015-02-01 00:25:56.000000', 'temperatura', 156.0000, 'ºC'),
	(41245, 110, '2015-02-01 00:25:57.000000', 'temperatura', 108.0000, 'ºC'),
	(41246, 110, '2015-02-01 00:25:58.000000', 'temperatura', 74.0000, 'ºC'),
	(41247, 110, '2015-02-01 00:25:59.000000', 'temperatura', 46.0000, 'ºC'),
	(41248, 110, '2015-02-01 00:26:00.000000', 'temperatura', 10.0000, 'ºC'),
	(41249, 110, '2015-02-01 00:26:01.000000', 'temperatura', 1110.0000, 'ºC'),
	(41250, 110, '2015-02-01 00:26:02.000000', 'temperatura', 723.0000, 'ºC'),
	(41251, 110, '2015-02-01 00:26:03.000000', 'temperatura', 286.0000, 'ºC'),
	(41252, 110, '2015-02-01 00:26:04.000000', 'temperatura', 459.0000, 'ºC'),
	(41253, 110, '2015-02-01 00:26:05.000000', 'temperatura', 237.0000, 'ºC'),
	(41254, 110, '2015-02-01 00:26:06.000000', 'temperatura', 1008.0000, 'ºC'),
	(41255, 110, '2015-02-01 00:26:07.000000', 'temperatura', 729.0000, 'ºC'),
	(41256, 110, '2015-02-01 00:26:08.000000', 'temperatura', 624.0000, 'ºC'),
	(41257, 110, '2015-02-01 00:26:09.000000', 'temperatura', 931.0000, 'ºC'),
	(41258, 110, '2015-02-01 00:26:10.000000', 'temperatura', 386.0000, 'ºC'),
	(41259, 110, '2015-02-01 00:26:11.000000', 'temperatura', 336.0000, 'ºC'),
	(41260, 110, '2015-02-01 00:26:12.000000', 'temperatura', 522.0000, 'ºC'),
	(41261, 110, '2015-02-01 00:26:13.000000', 'temperatura', 401.0000, 'ºC'),
	(41262, 110, '2015-02-01 00:26:14.000000', 'temperatura', 441.0000, 'ºC'),
	(41263, 110, '2015-02-01 00:26:15.000000', 'temperatura', 1004.0000, 'ºC'),
	(41264, 110, '2015-02-01 00:26:16.000000', 'temperatura', 95.0000, 'ºC'),
	(41265, 110, '2015-02-01 00:26:17.000000', 'temperatura', 1066.0000, 'ºC'),
	(41266, 110, '2015-02-01 00:26:18.000000', 'temperatura', 243.0000, 'ºC'),
	(41267, 110, '2015-02-01 00:26:19.000000', 'temperatura', 420.0000, 'ºC'),
	(41268, 110, '2015-02-01 00:26:20.000000', 'temperatura', 169.0000, 'ºC'),
	(41269, 110, '2015-02-01 00:26:21.000000', 'temperatura', 785.0000, 'ºC'),
	(41270, 110, '2015-02-01 00:26:22.000000', 'temperatura', 1021.0000, 'ºC'),
	(41271, 110, '2015-02-01 00:26:23.000000', 'temperatura', 350.0000, 'ºC'),
	(41272, 110, '2015-02-01 00:26:24.000000', 'temperatura', 1086.0000, 'ºC'),
	(41273, 110, '2015-02-01 00:26:25.000000', 'temperatura', 783.0000, 'ºC'),
	(41274, 110, '2015-02-01 00:26:26.000000', 'temperatura', 656.0000, 'ºC'),
	(41275, 110, '2015-02-01 00:26:27.000000', 'temperatura', 932.0000, 'ºC'),
	(41276, 110, '2015-02-01 00:26:28.000000', 'temperatura', 293.0000, 'ºC'),
	(41277, 110, '2015-02-01 00:26:29.000000', 'temperatura', 1068.0000, 'ºC'),
	(41278, 110, '2015-02-01 00:26:30.000000', 'temperatura', 863.0000, 'ºC'),
	(41279, 110, '2015-02-01 00:26:31.000000', 'temperatura', 1109.0000, 'ºC'),
	(41280, 110, '2015-02-01 00:26:32.000000', 'temperatura', 557.0000, 'ºC'),
	(41281, 110, '2015-02-01 00:26:33.000000', 'temperatura', 660.0000, 'ºC'),
	(41282, 110, '2015-02-01 00:26:34.000000', 'temperatura', 427.0000, 'ºC'),
	(41283, 110, '2015-02-01 00:26:35.000000', 'temperatura', 157.0000, 'ºC'),
	(41284, 110, '2015-02-01 00:26:36.000000', 'temperatura', 706.0000, 'ºC'),
	(41285, 110, '2015-02-01 00:26:37.000000', 'temperatura', 657.0000, 'ºC'),
	(41286, 110, '2015-02-01 00:26:38.000000', 'temperatura', 1170.0000, 'ºC'),
	(41287, 110, '2015-02-01 00:26:39.000000', 'temperatura', 276.0000, 'ºC'),
	(41288, 110, '2015-02-01 00:26:40.000000', 'temperatura', 273.0000, 'ºC'),
	(41289, 110, '2015-02-01 00:26:41.000000', 'temperatura', 538.0000, 'ºC'),
	(41290, 110, '2015-02-01 00:26:42.000000', 'temperatura', 673.0000, 'ºC'),
	(41291, 110, '2015-02-01 00:26:43.000000', 'temperatura', 549.0000, 'ºC'),
	(41292, 110, '2015-02-01 00:26:44.000000', 'temperatura', 726.0000, 'ºC'),
	(41293, 110, '2015-02-01 00:26:45.000000', 'temperatura', 784.0000, 'ºC'),
	(41294, 110, '2015-02-01 00:26:46.000000', 'temperatura', 542.0000, 'ºC'),
	(41295, 110, '2015-02-01 00:26:47.000000', 'temperatura', 357.0000, 'ºC'),
	(41296, 110, '2015-02-01 00:26:48.000000', 'temperatura', 162.0000, 'ºC'),
	(41297, 110, '2015-02-01 00:26:49.000000', 'temperatura', 938.0000, 'ºC'),
	(41298, 110, '2015-02-01 00:26:50.000000', 'temperatura', 605.0000, 'ºC'),
	(41299, 110, '2015-02-01 00:26:51.000000', 'temperatura', 213.0000, 'ºC'),
	(41300, 110, '2015-02-01 00:26:52.000000', 'temperatura', 451.0000, 'ºC'),
	(41301, 110, '2015-02-01 00:26:53.000000', 'temperatura', 416.0000, 'ºC'),
	(41302, 110, '2015-02-01 00:26:54.000000', 'temperatura', 729.0000, 'ºC'),
	(41303, 110, '2015-02-01 00:26:55.000000', 'temperatura', 1195.0000, 'ºC'),
	(41304, 110, '2015-02-01 00:26:56.000000', 'temperatura', 189.0000, 'ºC'),
	(41305, 110, '2015-02-01 00:26:57.000000', 'temperatura', 960.0000, 'ºC'),
	(41306, 110, '2015-02-01 00:26:58.000000', 'temperatura', 633.0000, 'ºC'),
	(41307, 110, '2015-02-01 00:26:59.000000', 'temperatura', 288.0000, 'ºC'),
	(41308, 110, '2015-02-01 00:27:00.000000', 'temperatura', 742.0000, 'ºC'),
	(41309, 110, '2015-02-01 00:27:01.000000', 'temperatura', 443.0000, 'ºC'),
	(41310, 110, '2015-02-01 00:27:02.000000', 'temperatura', 1192.0000, 'ºC'),
	(41311, 110, '2015-02-01 00:27:03.000000', 'temperatura', 1033.0000, 'ºC'),
	(41312, 110, '2015-02-01 00:27:04.000000', 'temperatura', 388.0000, 'ºC'),
	(41313, 110, '2015-02-01 00:27:05.000000', 'temperatura', 41.0000, 'ºC'),
	(41314, 110, '2015-02-01 00:27:06.000000', 'temperatura', 242.0000, 'ºC'),
	(41315, 110, '2015-02-01 00:27:07.000000', 'temperatura', 1089.0000, 'ºC'),
	(41316, 110, '2015-02-01 00:27:08.000000', 'temperatura', 1117.0000, 'ºC'),
	(41317, 110, '2015-02-01 00:27:09.000000', 'temperatura', 1121.0000, 'ºC'),
	(41318, 110, '2015-02-01 00:27:10.000000', 'temperatura', 1055.0000, 'ºC'),
	(41319, 110, '2015-02-01 00:27:11.000000', 'temperatura', 713.0000, 'ºC'),
	(41320, 110, '2015-02-01 00:27:12.000000', 'temperatura', 401.0000, 'ºC'),
	(41321, 110, '2015-02-01 00:27:13.000000', 'temperatura', 1067.0000, 'ºC'),
	(41322, 110, '2015-02-01 00:27:14.000000', 'temperatura', 532.0000, 'ºC'),
	(41323, 110, '2015-02-01 00:27:15.000000', 'temperatura', 659.0000, 'ºC'),
	(41324, 110, '2015-02-01 00:27:16.000000', 'temperatura', 500.0000, 'ºC'),
	(41325, 110, '2015-02-01 00:27:17.000000', 'temperatura', 524.0000, 'ºC'),
	(41326, 110, '2015-02-01 00:27:18.000000', 'temperatura', 1119.0000, 'ºC'),
	(41327, 110, '2015-02-01 00:27:19.000000', 'temperatura', 424.0000, 'ºC'),
	(41328, 110, '2015-02-01 00:27:20.000000', 'temperatura', 1164.0000, 'ºC'),
	(41329, 110, '2015-02-01 00:27:21.000000', 'temperatura', 947.0000, 'ºC'),
	(41330, 110, '2015-02-01 00:27:22.000000', 'temperatura', 44.0000, 'ºC'),
	(41331, 110, '2015-02-01 00:27:23.000000', 'temperatura', 981.0000, 'ºC'),
	(41332, 110, '2015-02-01 00:27:24.000000', 'temperatura', 1171.0000, 'ºC'),
	(41333, 110, '2015-02-01 00:27:25.000000', 'temperatura', 514.0000, 'ºC'),
	(41334, 110, '2015-02-01 00:27:26.000000', 'temperatura', 259.0000, 'ºC'),
	(41335, 110, '2015-02-01 00:27:27.000000', 'temperatura', 952.0000, 'ºC'),
	(41336, 110, '2015-02-01 00:27:28.000000', 'temperatura', 384.0000, 'ºC'),
	(41337, 110, '2015-02-01 00:27:29.000000', 'temperatura', 263.0000, 'ºC'),
	(41338, 110, '2015-02-01 00:27:30.000000', 'temperatura', 165.0000, 'ºC'),
	(41339, 110, '2015-02-01 00:27:31.000000', 'temperatura', 36.0000, 'ºC'),
	(41340, 110, '2015-02-01 00:27:32.000000', 'temperatura', 885.0000, 'ºC'),
	(41341, 110, '2015-02-01 00:27:33.000000', 'temperatura', 718.0000, 'ºC'),
	(41342, 110, '2015-02-01 00:27:34.000000', 'temperatura', 934.0000, 'ºC'),
	(41343, 110, '2015-02-01 00:27:35.000000', 'temperatura', 118.0000, 'ºC'),
	(41344, 110, '2015-02-01 00:27:36.000000', 'temperatura', 189.0000, 'ºC'),
	(41345, 110, '2015-02-01 00:27:37.000000', 'temperatura', 590.0000, 'ºC'),
	(41346, 110, '2015-02-01 00:27:38.000000', 'temperatura', 1184.0000, 'ºC'),
	(41347, 110, '2015-02-01 00:27:39.000000', 'temperatura', 549.0000, 'ºC'),
	(41348, 110, '2015-02-01 00:27:40.000000', 'temperatura', 396.0000, 'ºC'),
	(41349, 110, '2015-02-01 00:27:41.000000', 'temperatura', 332.0000, 'ºC'),
	(41350, 110, '2015-02-01 00:27:42.000000', 'temperatura', 471.0000, 'ºC'),
	(41351, 110, '2015-02-01 00:27:43.000000', 'temperatura', 160.0000, 'ºC'),
	(41352, 110, '2015-02-01 00:27:44.000000', 'temperatura', 586.0000, 'ºC'),
	(41353, 110, '2015-02-01 00:27:45.000000', 'temperatura', 53.0000, 'ºC'),
	(41354, 110, '2015-02-01 00:27:46.000000', 'temperatura', 909.0000, 'ºC'),
	(41355, 110, '2015-02-01 00:27:47.000000', 'temperatura', 784.0000, 'ºC'),
	(41356, 110, '2015-02-01 00:27:48.000000', 'temperatura', 1195.0000, 'ºC'),
	(41357, 110, '2015-02-01 00:27:49.000000', 'temperatura', 22.0000, 'ºC'),
	(41358, 110, '2015-02-01 00:27:50.000000', 'temperatura', 125.0000, 'ºC'),
	(41359, 110, '2015-02-01 00:27:51.000000', 'temperatura', 560.0000, 'ºC'),
	(41360, 110, '2015-02-01 00:27:52.000000', 'temperatura', 28.0000, 'ºC'),
	(41361, 110, '2015-02-01 00:27:53.000000', 'temperatura', 858.0000, 'ºC'),
	(41362, 110, '2015-02-01 00:27:54.000000', 'temperatura', 605.0000, 'ºC'),
	(41363, 110, '2015-02-01 00:27:55.000000', 'temperatura', 454.0000, 'ºC'),
	(41364, 110, '2015-02-01 00:27:56.000000', 'temperatura', 454.0000, 'ºC'),
	(41365, 110, '2015-02-01 00:27:57.000000', 'temperatura', 910.0000, 'ºC'),
	(41366, 110, '2015-02-01 00:27:58.000000', 'temperatura', 786.0000, 'ºC'),
	(41367, 110, '2015-02-01 00:27:59.000000', 'temperatura', 1.0000, 'ºC'),
	(41368, 110, '2015-02-01 00:28:00.000000', 'temperatura', 50.0000, 'ºC'),
	(41369, 110, '2015-02-01 00:28:01.000000', 'temperatura', 246.0000, 'ºC'),
	(41370, 110, '2015-02-01 00:28:02.000000', 'temperatura', 1081.0000, 'ºC'),
	(41371, 110, '2015-02-01 00:28:03.000000', 'temperatura', 1068.0000, 'ºC'),
	(41372, 110, '2015-02-01 00:28:04.000000', 'temperatura', 896.0000, 'ºC'),
	(41373, 110, '2015-02-01 00:28:05.000000', 'temperatura', 78.0000, 'ºC'),
	(41374, 110, '2015-02-01 00:28:06.000000', 'temperatura', 102.0000, 'ºC'),
	(41375, 110, '2015-02-01 00:28:07.000000', 'temperatura', 274.0000, 'ºC'),
	(41376, 110, '2015-02-01 00:28:08.000000', 'temperatura', 1068.0000, 'ºC'),
	(41377, 110, '2015-02-01 00:28:09.000000', 'temperatura', 915.0000, 'ºC'),
	(41378, 110, '2015-02-01 00:28:10.000000', 'temperatura', 174.0000, 'ºC'),
	(41379, 110, '2015-02-01 00:28:11.000000', 'temperatura', 525.0000, 'ºC'),
	(41380, 110, '2015-02-01 00:28:12.000000', 'temperatura', 905.0000, 'ºC'),
	(41381, 110, '2015-02-01 00:28:13.000000', 'temperatura', 551.0000, 'ºC'),
	(41382, 110, '2015-02-01 00:28:14.000000', 'temperatura', 38.0000, 'ºC'),
	(41383, 110, '2015-02-01 00:28:15.000000', 'temperatura', 939.0000, 'ºC'),
	(41384, 110, '2015-02-01 00:28:16.000000', 'temperatura', 980.0000, 'ºC'),
	(41385, 110, '2015-02-01 00:28:17.000000', 'temperatura', 886.0000, 'ºC'),
	(41386, 110, '2015-02-01 00:28:18.000000', 'temperatura', 288.0000, 'ºC'),
	(41387, 110, '2015-02-01 00:28:19.000000', 'temperatura', 1182.0000, 'ºC'),
	(41388, 110, '2015-02-01 00:28:20.000000', 'temperatura', 247.0000, 'ºC'),
	(41389, 110, '2015-02-01 00:28:21.000000', 'temperatura', 89.0000, 'ºC'),
	(41390, 110, '2015-02-01 00:28:22.000000', 'temperatura', 905.0000, 'ºC'),
	(41391, 110, '2015-02-01 00:28:23.000000', 'temperatura', 657.0000, 'ºC'),
	(41392, 110, '2015-02-01 00:28:24.000000', 'temperatura', 570.0000, 'ºC'),
	(41393, 110, '2015-02-01 00:28:25.000000', 'temperatura', 879.0000, 'ºC'),
	(41394, 110, '2015-02-01 00:28:26.000000', 'temperatura', 288.0000, 'ºC'),
	(41395, 110, '2015-02-01 00:28:27.000000', 'temperatura', 2.0000, 'ºC'),
	(41396, 110, '2015-02-01 00:28:28.000000', 'temperatura', 346.0000, 'ºC'),
	(41397, 110, '2015-02-01 00:28:29.000000', 'temperatura', 524.0000, 'ºC'),
	(41398, 110, '2015-02-01 00:28:30.000000', 'temperatura', 384.0000, 'ºC'),
	(41399, 110, '2015-02-01 00:28:31.000000', 'temperatura', 347.0000, 'ºC'),
	(41400, 110, '2015-02-01 00:28:32.000000', 'temperatura', 583.0000, 'ºC'),
	(41401, 110, '2015-02-01 00:28:33.000000', 'temperatura', 673.0000, 'ºC'),
	(41402, 110, '2015-02-01 00:28:34.000000', 'temperatura', 419.0000, 'ºC'),
	(41403, 110, '2015-02-01 00:28:35.000000', 'temperatura', 78.0000, 'ºC'),
	(41404, 110, '2015-02-01 00:28:36.000000', 'temperatura', 331.0000, 'ºC'),
	(41405, 110, '2015-02-01 00:28:37.000000', 'temperatura', 223.0000, 'ºC'),
	(41406, 110, '2015-02-01 00:28:38.000000', 'temperatura', 124.0000, 'ºC'),
	(41407, 110, '2015-02-01 00:28:39.000000', 'temperatura', 1148.0000, 'ºC'),
	(41408, 110, '2015-02-01 00:28:40.000000', 'temperatura', 570.0000, 'ºC'),
	(41409, 110, '2015-02-01 00:28:41.000000', 'temperatura', 608.0000, 'ºC'),
	(41410, 110, '2015-02-01 00:28:42.000000', 'temperatura', 129.0000, 'ºC'),
	(41411, 110, '2015-02-01 00:28:43.000000', 'temperatura', 24.0000, 'ºC'),
	(41412, 110, '2015-02-01 00:28:44.000000', 'temperatura', 931.0000, 'ºC'),
	(41413, 110, '2015-02-01 00:28:45.000000', 'temperatura', 983.0000, 'ºC'),
	(41414, 110, '2015-02-01 00:28:46.000000', 'temperatura', 925.0000, 'ºC'),
	(41415, 110, '2015-02-01 00:28:47.000000', 'temperatura', 474.0000, 'ºC'),
	(41416, 110, '2015-02-01 00:28:48.000000', 'temperatura', 794.0000, 'ºC'),
	(41417, 110, '2015-02-01 00:28:49.000000', 'temperatura', 152.0000, 'ºC'),
	(41418, 110, '2015-02-01 00:28:50.000000', 'temperatura', 777.0000, 'ºC'),
	(41419, 110, '2015-02-01 00:28:51.000000', 'temperatura', 1028.0000, 'ºC'),
	(41420, 110, '2015-02-01 00:28:52.000000', 'temperatura', 410.0000, 'ºC'),
	(41421, 110, '2015-02-01 00:28:53.000000', 'temperatura', 169.0000, 'ºC'),
	(41422, 110, '2015-02-01 00:28:54.000000', 'temperatura', 814.0000, 'ºC'),
	(41423, 110, '2015-02-01 00:28:55.000000', 'temperatura', 1163.0000, 'ºC'),
	(41424, 110, '2015-02-01 00:28:56.000000', 'temperatura', 974.0000, 'ºC'),
	(41425, 110, '2015-02-01 00:28:57.000000', 'temperatura', 181.0000, 'ºC'),
	(41426, 110, '2015-02-01 00:28:58.000000', 'temperatura', 383.0000, 'ºC'),
	(41427, 110, '2015-02-01 00:28:59.000000', 'temperatura', 175.0000, 'ºC'),
	(41428, 110, '2015-02-01 00:29:00.000000', 'temperatura', 923.0000, 'ºC'),
	(41429, 110, '2015-02-01 00:29:01.000000', 'temperatura', 493.0000, 'ºC'),
	(41430, 110, '2015-02-01 00:29:02.000000', 'temperatura', 896.0000, 'ºC'),
	(41431, 110, '2015-02-01 00:29:03.000000', 'temperatura', 599.0000, 'ºC'),
	(41432, 110, '2015-02-01 00:29:04.000000', 'temperatura', 311.0000, 'ºC'),
	(41433, 110, '2015-02-01 00:29:05.000000', 'temperatura', 958.0000, 'ºC'),
	(41434, 110, '2015-02-01 00:29:06.000000', 'temperatura', 256.0000, 'ºC'),
	(41435, 110, '2015-02-01 00:29:07.000000', 'temperatura', 807.0000, 'ºC'),
	(41436, 110, '2015-02-01 00:29:08.000000', 'temperatura', 867.0000, 'ºC'),
	(41437, 110, '2015-02-01 00:29:09.000000', 'temperatura', 717.0000, 'ºC'),
	(41438, 110, '2015-02-01 00:29:10.000000', 'temperatura', 983.0000, 'ºC'),
	(41439, 110, '2015-02-01 00:29:11.000000', 'temperatura', 365.0000, 'ºC'),
	(41440, 110, '2015-02-01 00:29:12.000000', 'temperatura', 75.0000, 'ºC'),
	(41441, 110, '2015-02-01 00:29:13.000000', 'temperatura', 482.0000, 'ºC'),
	(41442, 110, '2015-02-01 00:29:14.000000', 'temperatura', 986.0000, 'ºC'),
	(41443, 110, '2015-02-01 00:29:15.000000', 'temperatura', 1083.0000, 'ºC'),
	(41444, 110, '2015-02-01 00:29:16.000000', 'temperatura', 60.0000, 'ºC'),
	(41445, 110, '2015-02-01 00:29:17.000000', 'temperatura', 649.0000, 'ºC'),
	(41446, 110, '2015-02-01 00:29:18.000000', 'temperatura', 667.0000, 'ºC'),
	(41447, 110, '2015-02-01 00:29:19.000000', 'temperatura', 188.0000, 'ºC'),
	(41448, 110, '2015-02-01 00:29:20.000000', 'temperatura', 138.0000, 'ºC'),
	(41449, 110, '2015-02-01 00:29:21.000000', 'temperatura', 126.0000, 'ºC'),
	(41450, 110, '2015-02-01 00:29:22.000000', 'temperatura', 217.0000, 'ºC'),
	(41451, 110, '2015-02-01 00:29:23.000000', 'temperatura', 707.0000, 'ºC'),
	(41452, 110, '2015-02-01 00:29:24.000000', 'temperatura', 485.0000, 'ºC'),
	(41453, 110, '2015-02-01 00:29:25.000000', 'temperatura', 304.0000, 'ºC'),
	(41454, 110, '2015-02-01 00:29:26.000000', 'temperatura', 66.0000, 'ºC'),
	(41455, 110, '2015-02-01 00:29:27.000000', 'temperatura', 619.0000, 'ºC'),
	(41456, 110, '2015-02-01 00:29:28.000000', 'temperatura', 496.0000, 'ºC'),
	(41457, 110, '2015-02-01 00:29:29.000000', 'temperatura', 625.0000, 'ºC'),
	(41458, 110, '2015-02-01 00:29:30.000000', 'temperatura', 435.0000, 'ºC'),
	(41459, 110, '2015-02-01 00:29:31.000000', 'temperatura', 303.0000, 'ºC'),
	(41460, 110, '2015-02-01 00:29:32.000000', 'temperatura', 211.0000, 'ºC'),
	(41461, 110, '2015-02-01 00:29:33.000000', 'temperatura', 145.0000, 'ºC'),
	(41462, 110, '2015-02-01 00:29:34.000000', 'temperatura', 93.0000, 'ºC'),
	(41463, 110, '2015-02-01 00:29:35.000000', 'temperatura', 29.0000, 'ºC'),
	(41464, 110, '2015-02-01 00:29:36.000000', 'temperatura', 1065.0000, 'ºC'),
	(41465, 110, '2015-02-01 00:29:37.000000', 'temperatura', 442.0000, 'ºC'),
	(41466, 110, '2015-02-01 00:29:38.000000', 'temperatura', 216.0000, 'ºC'),
	(41467, 110, '2015-02-01 00:29:39.000000', 'temperatura', 952.0000, 'ºC'),
	(41468, 110, '2015-02-01 00:29:40.000000', 'temperatura', 512.0000, 'ºC'),
	(41469, 110, '2015-02-01 00:29:41.000000', 'temperatura', 907.0000, 'ºC'),
	(41470, 110, '2015-02-01 00:29:42.000000', 'temperatura', 596.0000, 'ºC'),
	(41471, 110, '2015-02-01 00:29:43.000000', 'temperatura', 263.0000, 'ºC'),
	(41472, 110, '2015-02-01 00:29:44.000000', 'temperatura', 728.0000, 'ºC'),
	(41473, 110, '2015-02-01 00:29:45.000000', 'temperatura', 449.0000, 'ºC'),
	(41474, 110, '2015-02-01 00:29:46.000000', 'temperatura', 63.0000, 'ºC'),
	(41475, 110, '2015-02-01 00:29:47.000000', 'temperatura', 168.0000, 'ºC'),
	(41476, 110, '2015-02-01 00:29:48.000000', 'temperatura', 651.0000, 'ºC'),
	(41477, 110, '2015-02-01 00:29:49.000000', 'temperatura', 352.0000, 'ºC'),
	(41478, 110, '2015-02-01 00:29:50.000000', 'temperatura', 1006.0000, 'ºC'),
	(41479, 110, '2015-02-01 00:29:51.000000', 'temperatura', 376.0000, 'ºC'),
	(41480, 110, '2015-02-01 00:29:52.000000', 'temperatura', 62.0000, 'ºC'),
	(41481, 110, '2015-02-01 00:29:53.000000', 'temperatura', 382.0000, 'ºC'),
	(41482, 110, '2015-02-01 00:29:54.000000', 'temperatura', 524.0000, 'ºC'),
	(41483, 110, '2015-02-01 00:29:55.000000', 'temperatura', 275.0000, 'ºC'),
	(41484, 110, '2015-02-01 00:29:56.000000', 'temperatura', 1003.0000, 'ºC'),
	(41485, 110, '2015-02-01 00:29:57.000000', 'temperatura', 593.0000, 'ºC'),
	(41486, 110, '2015-02-01 00:29:58.000000', 'temperatura', 1155.0000, 'ºC'),
	(41487, 110, '2015-02-01 00:29:59.000000', 'temperatura', 397.0000, 'ºC'),
	(41488, 110, '2015-02-01 00:30:00.000000', 'temperatura', 920.0000, 'ºC'),
	(41489, 110, '2015-02-01 00:30:01.000000', 'temperatura', 1009.0000, 'ºC'),
	(41490, 110, '2015-02-01 00:30:02.000000', 'temperatura', 1086.0000, 'ºC'),
	(41491, 110, '2015-02-01 00:30:03.000000', 'temperatura', 2.0000, 'ºC'),
	(41492, 110, '2015-02-01 00:30:04.000000', 'temperatura', 354.0000, 'ºC'),
	(41493, 110, '2015-02-01 00:30:05.000000', 'temperatura', 565.0000, 'ºC'),
	(41494, 110, '2015-02-01 00:30:06.000000', 'temperatura', 565.0000, 'ºC'),
	(41495, 110, '2015-02-01 00:30:07.000000', 'temperatura', 1127.0000, 'ºC'),
	(41496, 110, '2015-02-01 00:30:08.000000', 'temperatura', 342.0000, 'ºC'),
	(41497, 110, '2015-02-01 00:30:09.000000', 'temperatura', 730.0000, 'ºC'),
	(41498, 110, '2015-02-01 00:30:10.000000', 'temperatura', 225.0000, 'ºC'),
	(41499, 110, '2015-02-01 00:30:11.000000', 'temperatura', 136.0000, 'ºC'),
	(41500, 110, '2015-02-01 00:30:12.000000', 'temperatura', 4.0000, 'ºC'),
	(41501, 110, '2015-02-01 00:30:13.000000', 'temperatura', 814.0000, 'ºC'),
	(41502, 110, '2015-02-01 00:30:14.000000', 'temperatura', 460.0000, 'ºC'),
	(41503, 110, '2015-02-01 00:30:15.000000', 'temperatura', 1056.0000, 'ºC'),
	(41504, 110, '2015-02-01 00:30:16.000000', 'temperatura', 302.0000, 'ºC'),
	(41505, 110, '2015-02-01 00:30:17.000000', 'temperatura', 740.0000, 'ºC'),
	(41506, 110, '2015-02-01 00:30:18.000000', 'temperatura', 397.0000, 'ºC'),
	(41507, 110, '2015-02-01 00:30:19.000000', 'temperatura', 966.0000, 'ºC'),
	(41508, 110, '2015-02-01 00:30:20.000000', 'temperatura', 40.0000, 'ºC'),
	(41509, 110, '2015-02-01 00:30:21.000000', 'temperatura', 900.0000, 'ºC'),
	(41510, 110, '2015-02-01 00:30:22.000000', 'temperatura', 780.0000, 'ºC'),
	(41511, 110, '2015-02-01 00:30:23.000000', 'temperatura', 2.0000, 'ºC'),
	(41512, 110, '2015-02-01 00:30:24.000000', 'temperatura', 71.0000, 'ºC'),
	(41513, 110, '2015-02-01 00:30:25.000000', 'temperatura', 351.0000, 'ºC'),
	(41514, 110, '2015-02-01 00:30:26.000000', 'temperatura', 341.0000, 'ºC'),
	(41515, 110, '2015-02-01 00:30:27.000000', 'temperatura', 655.0000, 'ºC'),
	(41516, 110, '2015-02-01 00:30:28.000000', 'temperatura', 1049.0000, 'ºC'),
	(41517, 110, '2015-02-01 00:30:29.000000', 'temperatura', 882.0000, 'ºC'),
	(41518, 110, '2015-02-01 00:30:30.000000', 'temperatura', 64.0000, 'ºC'),
	(41519, 110, '2015-02-01 00:30:31.000000', 'temperatura', 76.0000, 'ºC'),
	(41520, 110, '2015-02-01 00:30:32.000000', 'temperatura', 186.0000, 'ºC'),
	(41521, 110, '2015-02-01 00:30:33.000000', 'temperatura', 703.0000, 'ºC'),
	(41522, 110, '2015-02-01 00:30:34.000000', 'temperatura', 560.0000, 'ºC'),
	(41523, 110, '2015-02-01 00:30:35.000000', 'temperatura', 689.0000, 'ºC'),
	(41524, 110, '2015-02-01 00:30:36.000000', 'temperatura', 567.0000, 'ºC'),
	(41525, 110, '2015-02-01 00:30:37.000000', 'temperatura', 767.0000, 'ºC'),
	(41526, 110, '2015-02-01 00:30:38.000000', 'temperatura', 934.0000, 'ºC'),
	(41527, 110, '2015-02-01 00:30:39.000000', 'temperatura', 1170.0000, 'ºC'),
	(41528, 110, '2015-02-01 00:30:40.000000', 'temperatura', 648.0000, 'ºC'),
	(41529, 110, '2015-02-01 00:30:41.000000', 'temperatura', 930.0000, 'ºC'),
	(41530, 110, '2015-02-01 00:30:42.000000', 'temperatura', 308.0000, 'ºC'),
	(41531, 110, '2015-02-01 00:30:43.000000', 'temperatura', 1149.0000, 'ºC'),
	(41532, 110, '2015-02-01 00:30:44.000000', 'temperatura', 22.0000, 'ºC'),
	(41533, 110, '2015-02-01 00:30:45.000000', 'temperatura', 265.0000, 'ºC'),
	(41534, 110, '2015-02-01 00:30:46.000000', 'temperatura', 61.0000, 'ºC'),
	(41535, 110, '2015-02-01 00:30:47.000000', 'temperatura', 707.0000, 'ºC'),
	(41536, 110, '2015-02-01 00:30:48.000000', 'temperatura', 955.0000, 'ºC'),
	(41537, 110, '2015-02-01 00:30:49.000000', 'temperatura', 253.0000, 'ºC'),
	(41538, 110, '2015-02-01 00:30:50.000000', 'temperatura', 801.0000, 'ºC'),
	(41539, 110, '2015-02-01 00:30:51.000000', 'temperatura', 846.0000, 'ºC'),
	(41540, 110, '2015-02-01 00:30:52.000000', 'temperatura', 627.0000, 'ºC'),
	(41541, 110, '2015-02-01 00:30:53.000000', 'temperatura', 600.0000, 'ºC'),
	(41542, 110, '2015-02-01 00:30:54.000000', 'temperatura', 1118.0000, 'ºC'),
	(41543, 110, '2015-02-01 00:30:55.000000', 'temperatura', 189.0000, 'ºC'),
	(41544, 110, '2015-02-01 00:30:56.000000', 'temperatura', 1191.0000, 'ºC'),
	(41545, 110, '2015-02-01 00:30:57.000000', 'temperatura', 588.0000, 'ºC'),
	(41546, 110, '2015-02-01 00:30:58.000000', 'temperatura', 569.0000, 'ºC'),
	(41547, 110, '2015-02-01 00:30:59.000000', 'temperatura', 1082.0000, 'ºC'),
	(41548, 110, '2015-02-01 00:31:00.000000', 'temperatura', 103.0000, 'ºC'),
	(41549, 110, '2015-02-01 00:31:01.000000', 'temperatura', 868.0000, 'ºC'),
	(41550, 110, '2015-02-01 00:31:02.000000', 'temperatura', 432.0000, 'ºC'),
	(41551, 110, '2015-02-01 00:31:03.000000', 'temperatura', 756.0000, 'ºC'),
	(41552, 110, '2015-02-01 00:31:04.000000', 'temperatura', 86.0000, 'ºC'),
	(41553, 110, '2015-02-01 00:31:05.000000', 'temperatura', 562.0000, 'ºC'),
	(41554, 110, '2015-02-01 00:31:06.000000', 'temperatura', 152.0000, 'ºC'),
	(41555, 110, '2015-02-01 00:31:07.000000', 'temperatura', 274.0000, 'ºC'),
	(41556, 110, '2015-02-01 00:31:08.000000', 'temperatura', 917.0000, 'ºC'),
	(41557, 110, '2015-02-01 00:31:09.000000', 'temperatura', 160.0000, 'ºC'),
	(41558, 110, '2015-02-01 00:31:10.000000', 'temperatura', 452.0000, 'ºC'),
	(41559, 110, '2015-02-01 00:31:11.000000', 'temperatura', 582.0000, 'ºC'),
	(41560, 110, '2015-02-01 00:31:12.000000', 'temperatura', 351.0000, 'ºC'),
	(41561, 110, '2015-02-01 00:31:13.000000', 'temperatura', 11.0000, 'ºC'),
	(41562, 110, '2015-02-01 00:31:14.000000', 'temperatura', 201.0000, 'ºC'),
	(41563, 110, '2015-02-01 00:31:15.000000', 'temperatura', 974.0000, 'ºC'),
	(41564, 110, '2015-02-01 00:31:16.000000', 'temperatura', 666.0000, 'ºC'),
	(41565, 110, '2015-02-01 00:31:17.000000', 'temperatura', 409.0000, 'ºC'),
	(41566, 110, '2015-02-01 00:31:18.000000', 'temperatura', 47.0000, 'ºC'),
	(41567, 110, '2015-02-01 00:31:19.000000', 'temperatura', 209.0000, 'ºC'),
	(41568, 110, '2015-02-01 00:31:20.000000', 'temperatura', 903.0000, 'ºC'),
	(41569, 110, '2015-02-01 00:31:21.000000', 'temperatura', 290.0000, 'ºC'),
	(41570, 110, '2015-02-01 00:31:22.000000', 'temperatura', 1140.0000, 'ºC'),
	(41571, 110, '2015-02-01 00:31:23.000000', 'temperatura', 29.0000, 'ºC'),
	(41572, 110, '2015-02-01 00:31:24.000000', 'temperatura', 329.0000, 'ºC'),
	(41573, 110, '2015-02-01 00:31:25.000000', 'temperatura', 358.0000, 'ºC'),
	(41574, 110, '2015-02-01 00:31:26.000000', 'temperatura', 802.0000, 'ºC'),
	(41575, 110, '2015-02-01 00:31:27.000000', 'temperatura', 538.0000, 'ºC'),
	(41576, 110, '2015-02-01 00:31:28.000000', 'temperatura', 285.0000, 'ºC'),
	(41577, 110, '2015-02-01 00:31:29.000000', 'temperatura', 1010.0000, 'ºC'),
	(41578, 110, '2015-02-01 00:31:30.000000', 'temperatura', 595.0000, 'ºC'),
	(41579, 110, '2015-02-01 00:31:31.000000', 'temperatura', 1146.0000, 'ºC'),
	(41580, 110, '2015-02-01 00:31:32.000000', 'temperatura', 344.0000, 'ºC'),
	(41581, 110, '2015-02-01 00:31:33.000000', 'temperatura', 684.0000, 'ºC'),
	(41582, 110, '2015-02-01 00:31:34.000000', 'temperatura', 1188.0000, 'ºC'),
	(41583, 110, '2015-02-01 00:31:35.000000', 'temperatura', 290.0000, 'ºC'),
	(41584, 110, '2015-02-01 00:31:36.000000', 'temperatura', 286.0000, 'ºC'),
	(41585, 110, '2015-02-01 00:31:37.000000', 'temperatura', 562.0000, 'ºC'),
	(41586, 110, '2015-02-01 00:31:38.000000', 'temperatura', 749.0000, 'ºC'),
	(41587, 110, '2015-02-01 00:31:39.000000', 'temperatura', 863.0000, 'ºC'),
	(41588, 110, '2015-02-01 00:31:40.000000', 'temperatura', 865.0000, 'ºC'),
	(41589, 110, '2015-02-01 00:31:41.000000', 'temperatura', 539.0000, 'ºC'),
	(41590, 110, '2015-02-01 00:31:42.000000', 'temperatura', 102.0000, 'ºC'),
	(41591, 110, '2015-02-01 00:31:43.000000', 'temperatura', 91.0000, 'ºC'),
	(41592, 110, '2015-02-01 00:31:44.000000', 'temperatura', 151.0000, 'ºC'),
	(41593, 110, '2015-02-01 00:31:45.000000', 'temperatura', 482.0000, 'ºC'),
	(41594, 110, '2015-02-01 00:31:46.000000', 'temperatura', 758.0000, 'ºC'),
	(41595, 110, '2015-02-01 00:31:47.000000', 'temperatura', 1145.0000, 'ºC'),
	(41596, 110, '2015-02-01 00:31:48.000000', 'temperatura', 1051.0000, 'ºC'),
	(41597, 110, '2015-02-01 00:31:49.000000', 'temperatura', 622.0000, 'ºC'),
	(41598, 110, '2015-02-01 00:31:50.000000', 'temperatura', 1155.0000, 'ºC'),
	(41599, 110, '2015-02-01 00:31:51.000000', 'temperatura', 311.0000, 'ºC'),
	(41600, 110, '2015-02-01 00:31:52.000000', 'temperatura', 490.0000, 'ºC'),
	(41601, 110, '2015-02-01 00:31:53.000000', 'temperatura', 316.0000, 'ºC'),
	(41602, 110, '2015-02-01 00:31:54.000000', 'temperatura', 112.0000, 'ºC'),
	(41603, 110, '2015-02-01 00:31:55.000000', 'temperatura', 814.0000, 'ºC'),
	(41604, 110, '2015-02-01 00:31:56.000000', 'temperatura', 135.0000, 'ºC'),
	(41605, 110, '2015-02-01 00:31:57.000000', 'temperatura', 632.0000, 'ºC'),
	(41606, 110, '2015-02-01 00:31:58.000000', 'temperatura', 354.0000, 'ºC'),
	(41607, 110, '2015-02-01 00:31:59.000000', 'temperatura', 1077.0000, 'ºC'),
	(41608, 110, '2015-02-01 00:32:00.000000', 'temperatura', 725.0000, 'ºC'),
	(41609, 110, '2015-02-01 00:32:01.000000', 'temperatura', 391.0000, 'ºC'),
	(41610, 110, '2015-02-01 00:32:02.000000', 'temperatura', 983.0000, 'ºC'),
	(41611, 110, '2015-02-01 00:32:03.000000', 'temperatura', 143.0000, 'ºC'),
	(41612, 110, '2015-02-01 00:32:04.000000', 'temperatura', 164.0000, 'ºC'),
	(41613, 110, '2015-02-01 00:32:05.000000', 'temperatura', 391.0000, 'ºC'),
	(41614, 110, '2015-02-01 00:32:06.000000', 'temperatura', 265.0000, 'ºC'),
	(41615, 110, '2015-02-01 00:32:07.000000', 'temperatura', 154.0000, 'ºC'),
	(41616, 110, '2015-02-01 00:32:08.000000', 'temperatura', 1174.0000, 'ºC'),
	(41617, 110, '2015-02-01 00:32:09.000000', 'temperatura', 607.0000, 'ºC'),
	(41618, 110, '2015-02-01 00:32:10.000000', 'temperatura', 714.0000, 'ºC'),
	(41619, 110, '2015-02-01 00:32:11.000000', 'temperatura', 549.0000, 'ºC'),
	(41620, 110, '2015-02-01 00:32:12.000000', 'temperatura', 603.0000, 'ºC'),
	(41621, 110, '2015-02-01 00:32:13.000000', 'temperatura', 170.0000, 'ºC'),
	(41622, 110, '2015-02-01 00:32:14.000000', 'temperatura', 241.0000, 'ºC'),
	(41623, 110, '2015-02-01 00:32:15.000000', 'temperatura', 694.0000, 'ºC'),
	(41624, 110, '2015-02-01 00:32:16.000000', 'temperatura', 347.0000, 'ºC'),
	(41625, 110, '2015-02-01 00:32:17.000000', 'temperatura', 856.0000, 'ºC'),
	(41626, 110, '2015-02-01 00:32:18.000000', 'temperatura', 838.0000, 'ºC'),
	(41627, 110, '2015-02-01 00:32:19.000000', 'temperatura', 424.0000, 'ºC'),
	(41628, 110, '2015-02-01 00:32:20.000000', 'temperatura', 806.0000, 'ºC'),
	(41629, 110, '2015-02-01 00:32:21.000000', 'temperatura', 360.0000, 'ºC'),
	(41630, 110, '2015-02-01 00:32:22.000000', 'temperatura', 583.0000, 'ºC'),
	(41631, 110, '2015-02-01 00:32:23.000000', 'temperatura', 635.0000, 'ºC'),
	(41632, 110, '2015-02-01 00:32:24.000000', 'temperatura', 226.0000, 'ºC'),
	(41633, 110, '2015-02-01 00:32:25.000000', 'temperatura', 426.0000, 'ºC'),
	(41634, 110, '2015-02-01 00:32:26.000000', 'temperatura', 250.0000, 'ºC'),
	(41635, 110, '2015-02-01 00:32:27.000000', 'temperatura', 1176.0000, 'ºC'),
	(41636, 110, '2015-02-01 00:32:28.000000', 'temperatura', 330.0000, 'ºC'),
	(41637, 110, '2015-02-01 00:32:29.000000', 'temperatura', 521.0000, 'ºC'),
	(41638, 110, '2015-02-01 00:32:30.000000', 'temperatura', 415.0000, 'ºC'),
	(41639, 110, '2015-02-01 00:32:31.000000', 'temperatura', 513.0000, 'ºC'),
	(41640, 110, '2015-02-01 00:32:32.000000', 'temperatura', 122.0000, 'ºC'),
	(41641, 110, '2015-02-01 00:32:33.000000', 'temperatura', 271.0000, 'ºC'),
	(41642, 110, '2015-02-01 00:32:34.000000', 'temperatura', 990.0000, 'ºC'),
	(41643, 110, '2015-02-01 00:32:35.000000', 'temperatura', 539.0000, 'ºC'),
	(41644, 110, '2015-02-01 00:32:36.000000', 'temperatura', 923.0000, 'ºC'),
	(41645, 110, '2015-02-01 00:32:37.000000', 'temperatura', 601.0000, 'ºC'),
	(41646, 110, '2015-02-01 00:32:38.000000', 'temperatura', 234.0000, 'ºC'),
	(41647, 110, '2015-02-01 00:32:39.000000', 'temperatura', 567.0000, 'ºC'),
	(41648, 110, '2015-02-01 00:32:40.000000', 'temperatura', 935.0000, 'ºC'),
	(41649, 110, '2015-02-01 00:32:41.000000', 'temperatura', 575.0000, 'ºC'),
	(41650, 110, '2015-02-01 00:32:42.000000', 'temperatura', 71.0000, 'ºC'),
	(41651, 110, '2015-02-01 00:32:43.000000', 'temperatura', 1030.0000, 'ºC'),
	(41652, 110, '2015-02-01 00:32:44.000000', 'temperatura', 138.0000, 'ºC'),
	(41653, 110, '2015-02-01 00:32:45.000000', 'temperatura', 1198.0000, 'ºC'),
	(41654, 110, '2015-02-01 00:32:46.000000', 'temperatura', 780.0000, 'ºC'),
	(41655, 110, '2015-02-01 00:32:47.000000', 'temperatura', 304.0000, 'ºC'),
	(41656, 110, '2015-02-01 00:32:48.000000', 'temperatura', 379.0000, 'ºC'),
	(41657, 110, '2015-02-01 00:32:49.000000', 'temperatura', 986.0000, 'ºC'),
	(41658, 110, '2015-02-01 00:32:50.000000', 'temperatura', 194.0000, 'ºC'),
	(41659, 110, '2015-02-01 00:32:51.000000', 'temperatura', 411.0000, 'ºC'),
	(41660, 110, '2015-02-01 00:32:52.000000', 'temperatura', 272.0000, 'ºC'),
	(41661, 110, '2015-02-01 00:32:53.000000', 'temperatura', 131.0000, 'ºC'),
	(41662, 110, '2015-02-01 00:32:54.000000', 'temperatura', 1037.0000, 'ºC'),
	(41663, 110, '2015-02-01 00:32:55.000000', 'temperatura', 1194.0000, 'ºC'),
	(41664, 110, '2015-02-01 00:32:56.000000', 'temperatura', 458.0000, 'ºC'),
	(41665, 110, '2015-02-01 00:32:57.000000', 'temperatura', 1109.0000, 'ºC'),
	(41666, 110, '2015-02-01 00:32:58.000000', 'temperatura', 572.0000, 'ºC'),
	(41667, 110, '2015-02-01 00:32:59.000000', 'temperatura', 733.0000, 'ºC'),
	(41668, 110, '2015-02-01 00:33:00.000000', 'temperatura', 751.0000, 'ºC'),
	(41669, 110, '2015-02-01 00:33:01.000000', 'temperatura', 357.0000, 'ºC'),
	(41670, 110, '2015-02-01 00:33:02.000000', 'temperatura', 731.0000, 'ºC'),
	(41671, 110, '2015-02-01 00:33:03.000000', 'temperatura', 184.0000, 'ºC'),
	(41672, 110, '2015-02-01 00:33:04.000000', 'temperatura', 1129.0000, 'ºC'),
	(41673, 110, '2015-02-01 00:33:05.000000', 'temperatura', 292.0000, 'ºC'),
	(41674, 110, '2015-02-01 00:33:06.000000', 'temperatura', 475.0000, 'ºC'),
	(41675, 110, '2015-02-01 00:33:07.000000', 'temperatura', 299.0000, 'ºC'),
	(41676, 110, '2015-02-01 00:33:08.000000', 'temperatura', 72.0000, 'ºC'),
	(41677, 110, '2015-02-01 00:33:09.000000', 'temperatura', 664.0000, 'ºC'),
	(41678, 110, '2015-02-01 00:33:10.000000', 'temperatura', 705.0000, 'ºC'),
	(41679, 110, '2015-02-01 00:33:11.000000', 'temperatura', 333.0000, 'ºC'),
	(41680, 110, '2015-02-01 00:33:12.000000', 'temperatura', 748.0000, 'ºC'),
	(41681, 110, '2015-02-01 00:33:13.000000', 'temperatura', 345.0000, 'ºC'),
	(41682, 110, '2015-02-01 00:33:14.000000', 'temperatura', 679.0000, 'ºC'),
	(41683, 110, '2015-02-01 00:33:15.000000', 'temperatura', 1161.0000, 'ºC'),
	(41684, 110, '2015-02-01 00:33:16.000000', 'temperatura', 170.0000, 'ºC'),
	(41685, 110, '2015-02-01 00:33:17.000000', 'temperatura', 968.0000, 'ºC'),
	(41686, 110, '2015-02-01 00:33:18.000000', 'temperatura', 729.0000, 'ºC'),
	(41687, 110, '2015-02-01 00:33:19.000000', 'temperatura', 742.0000, 'ºC'),
	(41688, 110, '2015-02-01 00:33:20.000000', 'temperatura', 324.0000, 'ºC'),
	(41689, 110, '2015-02-01 00:33:21.000000', 'temperatura', 594.0000, 'ºC'),
	(41690, 110, '2015-02-01 00:33:22.000000', 'temperatura', 800.0000, 'ºC'),
	(41691, 110, '2015-02-01 00:33:23.000000', 'temperatura', 1017.0000, 'ºC'),
	(41692, 110, '2015-02-01 00:33:24.000000', 'temperatura', 286.0000, 'ºC'),
	(41693, 110, '2015-02-01 00:33:25.000000', 'temperatura', 781.0000, 'ºC'),
	(41694, 110, '2015-02-01 00:33:26.000000', 'temperatura', 645.0000, 'ºC'),
	(41695, 110, '2015-02-01 00:33:27.000000', 'temperatura', 881.0000, 'ºC'),
	(41696, 110, '2015-02-01 00:33:28.000000', 'temperatura', 74.0000, 'ºC'),
	(41697, 110, '2015-02-01 00:33:29.000000', 'temperatura', 126.0000, 'ºC'),
	(41698, 110, '2015-02-01 00:33:30.000000', 'temperatura', 410.0000, 'ºC'),
	(41699, 110, '2015-02-01 00:33:31.000000', 'temperatura', 470.0000, 'ºC'),
	(41700, 110, '2015-02-01 00:33:32.000000', 'temperatura', 1122.0000, 'ºC'),
	(41701, 110, '2015-02-01 00:33:33.000000', 'temperatura', 602.0000, 'ºC'),
	(41702, 110, '2015-02-01 00:33:34.000000', 'temperatura', 841.0000, 'ºC'),
	(41703, 110, '2015-02-01 00:33:35.000000', 'temperatura', 3.0000, 'ºC'),
	(41704, 110, '2015-02-01 00:33:36.000000', 'temperatura', 1091.0000, 'ºC'),
	(41705, 110, '2015-02-01 00:33:37.000000', 'temperatura', 646.0000, 'ºC'),
	(41706, 110, '2015-02-01 00:33:38.000000', 'temperatura', 1159.0000, 'ºC'),
	(41707, 110, '2015-02-01 00:33:39.000000', 'temperatura', 255.0000, 'ºC'),
	(41708, 110, '2015-02-01 00:33:40.000000', 'temperatura', 200.0000, 'ºC'),
	(41709, 110, '2015-02-01 00:33:41.000000', 'temperatura', 237.0000, 'ºC'),
	(41710, 110, '2015-02-01 00:33:42.000000', 'temperatura', 585.0000, 'ºC'),
	(41711, 110, '2015-02-01 00:33:43.000000', 'temperatura', 1014.0000, 'ºC'),
	(41712, 110, '2015-02-01 00:33:44.000000', 'temperatura', 915.0000, 'ºC'),
	(41713, 110, '2015-02-01 00:33:45.000000', 'temperatura', 336.0000, 'ºC'),
	(41714, 110, '2015-02-01 00:33:46.000000', 'temperatura', 132.0000, 'ºC'),
	(41715, 110, '2015-02-01 00:33:47.000000', 'temperatura', 855.0000, 'ºC'),
	(41716, 110, '2015-02-01 00:33:48.000000', 'temperatura', 277.0000, 'ºC'),
	(41717, 110, '2015-02-01 00:33:49.000000', 'temperatura', 22.0000, 'ºC'),
	(41718, 110, '2015-02-01 00:33:50.000000', 'temperatura', 481.0000, 'ºC'),
	(41719, 110, '2015-02-01 00:33:51.000000', 'temperatura', 1140.0000, 'ºC'),
	(41720, 110, '2015-02-01 00:33:52.000000', 'temperatura', 656.0000, 'ºC'),
	(41721, 110, '2015-02-01 00:33:53.000000', 'temperatura', 1062.0000, 'ºC'),
	(41722, 110, '2015-02-01 00:33:54.000000', 'temperatura', 940.0000, 'ºC'),
	(41723, 110, '2015-02-01 00:33:55.000000', 'temperatura', 316.0000, 'ºC'),
	(41724, 110, '2015-02-01 00:33:56.000000', 'temperatura', 1161.0000, 'ºC'),
	(41725, 110, '2015-02-01 00:33:57.000000', 'temperatura', 58.0000, 'ºC'),
	(41726, 110, '2015-02-01 00:33:58.000000', 'temperatura', 405.0000, 'ºC'),
	(41727, 110, '2015-02-01 00:33:59.000000', 'temperatura', 651.0000, 'ºC'),
	(41728, 110, '2015-02-01 00:34:00.000000', 'temperatura', 843.0000, 'ºC'),
	(41729, 110, '2015-02-01 00:34:01.000000', 'temperatura', 1061.0000, 'ºC'),
	(41730, 110, '2015-02-01 00:34:02.000000', 'temperatura', 376.0000, 'ºC'),
	(41731, 110, '2015-02-01 00:34:03.000000', 'temperatura', 1098.0000, 'ºC'),
	(41732, 110, '2015-02-01 00:34:04.000000', 'temperatura', 763.0000, 'ºC'),
	(41733, 110, '2015-02-01 00:34:05.000000', 'temperatura', 522.0000, 'ºC'),
	(41734, 110, '2015-02-01 00:34:06.000000', 'temperatura', 323.0000, 'ºC'),
	(41735, 110, '2015-02-01 00:34:07.000000', 'temperatura', 48.0000, 'ºC'),
	(41736, 110, '2015-02-01 00:34:08.000000', 'temperatura', 470.0000, 'ºC'),
	(41737, 110, '2015-02-01 00:34:09.000000', 'temperatura', 1007.0000, 'ºC'),
	(41738, 110, '2015-02-01 00:34:10.000000', 'temperatura', 27.0000, 'ºC'),
	(41739, 110, '2015-02-01 00:34:11.000000', 'temperatura', 715.0000, 'ºC'),
	(41740, 110, '2015-02-01 00:34:12.000000', 'temperatura', 1093.0000, 'ºC'),
	(41741, 110, '2015-02-01 00:34:13.000000', 'temperatura', 920.0000, 'ºC'),
	(41742, 110, '2015-02-01 00:34:14.000000', 'temperatura', 124.0000, 'ºC'),
	(41743, 110, '2015-02-01 00:34:15.000000', 'temperatura', 259.0000, 'ºC'),
	(41744, 110, '2015-02-01 00:34:16.000000', 'temperatura', 923.0000, 'ºC'),
	(41745, 110, '2015-02-01 00:34:17.000000', 'temperatura', 238.0000, 'ºC'),
	(41746, 110, '2015-02-01 00:34:18.000000', 'temperatura', 823.0000, 'ºC'),
	(41747, 110, '2015-02-01 00:34:19.000000', 'temperatura', 999.0000, 'ºC'),
	(41748, 110, '2015-02-01 00:34:20.000000', 'temperatura', 129.0000, 'ºC'),
	(41749, 110, '2015-02-01 00:34:21.000000', 'temperatura', 46.0000, 'ºC'),
	(41750, 110, '2015-02-01 00:34:22.000000', 'temperatura', 1043.0000, 'ºC'),
	(41751, 110, '2015-02-01 00:34:23.000000', 'temperatura', 279.0000, 'ºC'),
	(41752, 110, '2015-02-01 00:34:24.000000', 'temperatura', 667.0000, 'ºC'),
	(41753, 110, '2015-02-01 00:34:25.000000', 'temperatura', 99.0000, 'ºC'),
	(41754, 110, '2015-02-01 00:34:26.000000', 'temperatura', 894.0000, 'ºC'),
	(41755, 110, '2015-02-01 00:34:27.000000', 'temperatura', 574.0000, 'ºC'),
	(41756, 110, '2015-02-01 00:34:28.000000', 'temperatura', 188.0000, 'ºC'),
	(41757, 110, '2015-02-01 00:34:29.000000', 'temperatura', 420.0000, 'ºC'),
	(41758, 110, '2015-02-01 00:34:30.000000', 'temperatura', 337.0000, 'ºC'),
	(41759, 110, '2015-02-01 00:34:31.000000', 'temperatura', 424.0000, 'ºC'),
	(41760, 110, '2015-02-01 00:34:32.000000', 'temperatura', 1111.0000, 'ºC'),
	(41761, 110, '2015-02-01 00:34:33.000000', 'temperatura', 684.0000, 'ºC'),
	(41762, 110, '2015-02-01 00:34:34.000000', 'temperatura', 86.0000, 'ºC'),
	(41763, 110, '2015-02-01 00:34:35.000000', 'temperatura', 781.0000, 'ºC'),
	(41764, 110, '2015-02-01 00:34:36.000000', 'temperatura', 45.0000, 'ºC'),
	(41765, 110, '2015-02-01 00:34:37.000000', 'temperatura', 282.0000, 'ºC'),
	(41766, 110, '2015-02-01 00:34:38.000000', 'temperatura', 77.0000, 'ºC'),
	(41767, 110, '2015-02-01 00:34:39.000000', 'temperatura', 738.0000, 'ºC'),
	(41768, 110, '2015-02-01 00:34:40.000000', 'temperatura', 1062.0000, 'ºC'),
	(41769, 110, '2015-02-01 00:34:41.000000', 'temperatura', 696.0000, 'ºC'),
	(41770, 110, '2015-02-01 00:34:42.000000', 'temperatura', 293.0000, 'ºC'),
	(41771, 110, '2015-02-01 00:34:43.000000', 'temperatura', 578.0000, 'ºC'),
	(41772, 110, '2015-02-01 00:34:44.000000', 'temperatura', 813.0000, 'ºC'),
	(41773, 110, '2015-02-01 00:34:45.000000', 'temperatura', 1129.0000, 'ºC'),
	(41774, 110, '2015-02-01 00:34:46.000000', 'temperatura', 809.0000, 'ºC'),
	(41775, 110, '2015-02-01 00:34:47.000000', 'temperatura', 657.0000, 'ºC'),
	(41776, 110, '2015-02-01 00:34:48.000000', 'temperatura', 860.0000, 'ºC'),
	(41777, 110, '2015-02-01 00:34:49.000000', 'temperatura', 1129.0000, 'ºC'),
	(41778, 110, '2015-02-01 00:34:50.000000', 'temperatura', 665.0000, 'ºC'),
	(41779, 110, '2015-02-01 00:34:51.000000', 'temperatura', 1137.0000, 'ºC'),
	(41780, 110, '2015-02-01 00:34:52.000000', 'temperatura', 90.0000, 'ºC'),
	(41781, 110, '2015-02-01 00:34:53.000000', 'temperatura', 642.0000, 'ºC'),
	(41782, 110, '2015-02-01 00:34:54.000000', 'temperatura', 539.0000, 'ºC'),
	(41783, 110, '2015-02-01 00:34:55.000000', 'temperatura', 772.0000, 'ºC'),
	(41784, 110, '2015-02-01 00:34:56.000000', 'temperatura', 1041.0000, 'ºC'),
	(41785, 110, '2015-02-01 00:34:57.000000', 'temperatura', 490.0000, 'ºC'),
	(41786, 110, '2015-02-01 00:34:58.000000', 'temperatura', 528.0000, 'ºC'),
	(41787, 110, '2015-02-01 00:34:59.000000', 'temperatura', 1170.0000, 'ºC'),
	(41788, 110, '2015-02-01 00:35:00.000000', 'temperatura', 665.0000, 'ºC'),
	(41789, 110, '2015-02-01 00:35:01.000000', 'temperatura', 1016.0000, 'ºC'),
	(41790, 110, '2015-02-01 00:35:02.000000', 'temperatura', 685.0000, 'ºC'),
	(41791, 110, '2015-02-01 00:35:03.000000', 'temperatura', 376.0000, 'ºC'),
	(41792, 110, '2015-02-01 00:35:04.000000', 'temperatura', 1028.0000, 'ºC'),
	(41793, 110, '2015-02-01 00:35:05.000000', 'temperatura', 412.0000, 'ºC'),
	(41794, 110, '2015-02-01 00:35:06.000000', 'temperatura', 177.0000, 'ºC'),
	(41795, 110, '2015-02-01 00:35:07.000000', 'temperatura', 848.0000, 'ºC'),
	(41796, 110, '2015-02-01 00:35:08.000000', 'temperatura', 110.0000, 'ºC'),
	(41797, 110, '2015-02-01 00:35:09.000000', 'temperatura', 405.0000, 'ºC'),
	(41798, 110, '2015-02-01 00:35:10.000000', 'temperatura', 497.0000, 'ºC'),
	(41799, 110, '2015-02-01 00:35:11.000000', 'temperatura', 68.0000, 'ºC'),
	(41800, 110, '2015-02-01 00:35:12.000000', 'temperatura', 52.0000, 'ºC'),
	(41801, 110, '2015-02-01 00:35:13.000000', 'temperatura', 57.0000, 'ºC'),
	(41802, 110, '2015-02-01 00:35:14.000000', 'temperatura', 128.0000, 'ºC'),
	(41803, 110, '2015-02-01 00:35:15.000000', 'temperatura', 472.0000, 'ºC'),
	(41804, 110, '2015-02-01 00:35:16.000000', 'temperatura', 774.0000, 'ºC'),
	(41805, 110, '2015-02-01 00:35:17.000000', 'temperatura', 54.0000, 'ºC'),
	(41806, 110, '2015-02-01 00:35:18.000000', 'temperatura', 350.0000, 'ºC'),
	(41807, 110, '2015-02-01 00:35:19.000000', 'temperatura', 388.0000, 'ºC'),
	(41808, 110, '2015-02-01 00:35:20.000000', 'temperatura', 890.0000, 'ºC'),
	(41809, 110, '2015-02-01 00:35:21.000000', 'temperatura', 887.0000, 'ºC'),
	(41810, 110, '2015-02-01 00:35:22.000000', 'temperatura', 566.0000, 'ºC'),
	(41811, 110, '2015-02-01 00:35:23.000000', 'temperatura', 170.0000, 'ºC'),
	(41812, 110, '2015-02-01 00:35:24.000000', 'temperatura', 350.0000, 'ºC'),
	(41813, 110, '2015-02-01 00:35:25.000000', 'temperatura', 43.0000, 'ºC'),
	(41814, 110, '2015-02-01 00:35:26.000000', 'temperatura', 364.0000, 'ºC'),
	(41815, 110, '2015-02-01 00:35:27.000000', 'temperatura', 493.0000, 'ºC'),
	(41816, 110, '2015-02-01 00:35:28.000000', 'temperatura', 174.0000, 'ºC'),
	(41817, 110, '2015-02-01 00:35:29.000000', 'temperatura', 590.0000, 'ºC'),
	(41818, 110, '2015-02-01 00:35:30.000000', 'temperatura', 28.0000, 'ºC'),
	(41819, 110, '2015-02-01 00:35:31.000000', 'temperatura', 770.0000, 'ºC'),
	(41820, 110, '2015-02-01 00:35:32.000000', 'temperatura', 169.0000, 'ºC'),
	(41821, 110, '2015-02-01 00:35:33.000000', 'temperatura', 934.0000, 'ºC'),
	(41822, 110, '2015-02-01 00:35:34.000000', 'temperatura', 565.0000, 'ºC'),
	(41823, 110, '2015-02-01 00:35:35.000000', 'temperatura', 22.0000, 'ºC'),
	(41824, 110, '2015-02-01 00:35:36.000000', 'temperatura', 816.0000, 'ºC'),
	(41825, 110, '2015-02-01 00:35:37.000000', 'temperatura', 414.0000, 'ºC'),
	(41826, 110, '2015-02-01 00:35:38.000000', 'temperatura', 823.0000, 'ºC'),
	(41827, 110, '2015-02-01 00:35:39.000000', 'temperatura', 475.0000, 'ºC'),
	(41828, 110, '2015-02-01 00:35:40.000000', 'temperatura', 1107.0000, 'ºC'),
	(41829, 110, '2015-02-01 00:35:41.000000', 'temperatura', 508.0000, 'ºC'),
	(41830, 110, '2015-02-01 00:35:42.000000', 'temperatura', 421.0000, 'ºC'),
	(41831, 110, '2015-02-01 00:35:43.000000', 'temperatura', 580.0000, 'ºC'),
	(41832, 110, '2015-02-01 00:35:44.000000', 'temperatura', 438.0000, 'ºC'),
	(41833, 110, '2015-02-01 00:35:45.000000', 'temperatura', 449.0000, 'ºC'),
	(41834, 110, '2015-02-01 00:35:46.000000', 'temperatura', 932.0000, 'ºC'),
	(41835, 110, '2015-02-01 00:35:47.000000', 'temperatura', 913.0000, 'ºC'),
	(41836, 110, '2015-02-01 00:35:48.000000', 'temperatura', 568.0000, 'ºC'),
	(41837, 110, '2015-02-01 00:35:49.000000', 'temperatura', 104.0000, 'ºC'),
	(41838, 110, '2015-02-01 00:35:50.000000', 'temperatura', 17.0000, 'ºC'),
	(41839, 110, '2015-02-01 00:35:51.000000', 'temperatura', 972.0000, 'ºC'),
	(41840, 110, '2015-02-01 00:35:52.000000', 'temperatura', 8.0000, 'ºC'),
	(41841, 110, '2015-02-01 00:35:53.000000', 'temperatura', 725.0000, 'ºC'),
	(41842, 110, '2015-02-01 00:35:54.000000', 'temperatura', 3.0000, 'ºC'),
	(41843, 110, '2015-02-01 00:35:55.000000', 'temperatura', 242.0000, 'ºC'),
	(41844, 110, '2015-02-01 00:35:56.000000', 'temperatura', 0.0000, 'ºC'),
	(41845, 110, '2015-02-01 00:35:57.000000', 'temperatura', 474.0000, 'ºC'),
	(41846, 110, '2015-02-01 00:35:58.000000', 'temperatura', 1170.0000, 'ºC'),
	(41847, 110, '2015-02-01 00:35:59.000000', 'temperatura', 830.0000, 'ºC'),
	(41848, 110, '2015-02-01 00:36:00.000000', 'temperatura', 640.0000, 'ºC'),
	(41849, 110, '2015-02-01 00:36:01.000000', 'temperatura', 710.0000, 'ºC'),
	(41850, 110, '2015-02-01 00:36:02.000000', 'temperatura', 429.0000, 'ºC'),
	(41851, 110, '2015-02-01 00:36:03.000000', 'temperatura', 17.0000, 'ºC'),
	(41852, 110, '2015-02-01 00:36:04.000000', 'temperatura', 1197.0000, 'ºC'),
	(41853, 110, '2015-02-01 00:36:05.000000', 'temperatura', 1137.0000, 'ºC'),
	(41854, 110, '2015-02-01 00:36:06.000000', 'temperatura', 895.0000, 'ºC'),
	(41855, 110, '2015-02-01 00:36:07.000000', 'temperatura', 1063.0000, 'ºC'),
	(41856, 110, '2015-02-01 00:36:08.000000', 'temperatura', 232.0000, 'ºC'),
	(41857, 110, '2015-02-01 00:36:09.000000', 'temperatura', 371.0000, 'ºC'),
	(41858, 110, '2015-02-01 00:36:10.000000', 'temperatura', 1158.0000, 'ºC'),
	(41859, 110, '2015-02-01 00:36:11.000000', 'temperatura', 1078.0000, 'ºC'),
	(41860, 110, '2015-02-01 00:36:12.000000', 'temperatura', 717.0000, 'ºC'),
	(41861, 110, '2015-02-01 00:36:13.000000', 'temperatura', 350.0000, 'ºC'),
	(41862, 110, '2015-02-01 00:36:14.000000', 'temperatura', 801.0000, 'ºC'),
	(41863, 110, '2015-02-01 00:36:15.000000', 'temperatura', 553.0000, 'ºC'),
	(41864, 110, '2015-02-01 00:36:16.000000', 'temperatura', 366.0000, 'ºC'),
	(41865, 110, '2015-02-01 00:36:17.000000', 'temperatura', 169.0000, 'ºC'),
	(41866, 110, '2015-02-01 00:36:18.000000', 'temperatura', 949.0000, 'ºC'),
	(41867, 110, '2015-02-01 00:36:19.000000', 'temperatura', 639.0000, 'ºC'),
	(41868, 110, '2015-02-01 00:36:20.000000', 'temperatura', 348.0000, 'ºC'),
	(41869, 110, '2015-02-01 00:36:21.000000', 'temperatura', 1024.0000, 'ºC'),
	(41870, 110, '2015-02-01 00:36:22.000000', 'temperatura', 476.0000, 'ºC'),
	(41871, 110, '2015-02-01 00:36:23.000000', 'temperatura', 509.0000, 'ºC'),
	(41872, 110, '2015-02-01 00:36:24.000000', 'temperatura', 1115.0000, 'ºC'),
	(41873, 110, '2015-02-01 00:36:25.000000', 'temperatura', 451.0000, 'ºC'),
	(41874, 110, '2015-02-01 00:36:26.000000', 'temperatura', 111.0000, 'ºC'),
	(41875, 110, '2015-02-01 00:36:27.000000', 'temperatura', 402.0000, 'ºC'),
	(41876, 110, '2015-02-01 00:36:28.000000', 'temperatura', 477.0000, 'ºC'),
	(41877, 110, '2015-02-01 00:36:29.000000', 'temperatura', 1181.0000, 'ºC'),
	(41878, 110, '2015-02-01 00:36:30.000000', 'temperatura', 876.0000, 'ºC'),
	(41879, 110, '2015-02-01 00:36:31.000000', 'temperatura', 835.0000, 'ºC'),
	(41880, 110, '2015-02-01 00:36:32.000000', 'temperatura', 346.0000, 'ºC'),
	(41881, 110, '2015-02-01 00:36:33.000000', 'temperatura', 429.0000, 'ºC'),
	(41882, 110, '2015-02-01 00:36:34.000000', 'temperatura', 1106.0000, 'ºC'),
	(41883, 110, '2015-02-01 00:36:35.000000', 'temperatura', 642.0000, 'ºC'),
	(41884, 110, '2015-02-01 00:36:36.000000', 'temperatura', 1094.0000, 'ºC'),
	(41885, 110, '2015-02-01 00:36:37.000000', 'temperatura', 1145.0000, 'ºC'),
	(41886, 110, '2015-02-01 00:36:38.000000', 'temperatura', 45.0000, 'ºC'),
	(41887, 110, '2015-02-01 00:36:39.000000', 'temperatura', 389.0000, 'ºC'),
	(41888, 110, '2015-02-01 00:36:40.000000', 'temperatura', 611.0000, 'ºC'),
	(41889, 110, '2015-02-01 00:36:41.000000', 'temperatura', 687.0000, 'ºC'),
	(41890, 110, '2015-02-01 00:36:42.000000', 'temperatura', 404.0000, 'ºC'),
	(41891, 110, '2015-02-01 00:36:43.000000', 'temperatura', 1158.0000, 'ºC'),
	(41892, 110, '2015-02-01 00:36:44.000000', 'temperatura', 978.0000, 'ºC'),
	(41893, 110, '2015-02-01 00:36:45.000000', 'temperatura', 218.0000, 'ºC'),
	(41894, 110, '2015-02-01 00:36:46.000000', 'temperatura', 555.0000, 'ºC'),
	(41895, 110, '2015-02-01 00:36:47.000000', 'temperatura', 922.0000, 'ºC'),
	(41896, 110, '2015-02-01 00:36:48.000000', 'temperatura', 548.0000, 'ºC'),
	(41897, 110, '2015-02-01 00:36:49.000000', 'temperatura', 1171.0000, 'ºC'),
	(41898, 110, '2015-02-01 00:36:50.000000', 'temperatura', 614.0000, 'ºC'),
	(41899, 110, '2015-02-01 00:36:51.000000', 'temperatura', 756.0000, 'ºC'),
	(41900, 110, '2015-02-01 00:36:52.000000', 'temperatura', 737.0000, 'ºC'),
	(41901, 110, '2015-02-01 00:36:53.000000', 'temperatura', 220.0000, 'ºC'),
	(41902, 110, '2015-02-01 00:36:54.000000', 'temperatura', 89.0000, 'ºC'),
	(41903, 110, '2015-02-01 00:36:55.000000', 'temperatura', 986.0000, 'ºC'),
	(41904, 110, '2015-02-01 00:36:56.000000', 'temperatura', 1064.0000, 'ºC'),
	(41905, 110, '2015-02-01 00:36:57.000000', 'temperatura', 1163.0000, 'ºC'),
	(41906, 110, '2015-02-01 00:36:58.000000', 'temperatura', 223.0000, 'ºC'),
	(41907, 110, '2015-02-01 00:36:59.000000', 'temperatura', 28.0000, 'ºC'),
	(41908, 110, '2015-02-01 00:37:00.000000', 'temperatura', 670.0000, 'ºC'),
	(41909, 110, '2015-02-01 00:37:01.000000', 'temperatura', 868.0000, 'ºC'),
	(41910, 110, '2015-02-01 00:37:02.000000', 'temperatura', 1129.0000, 'ºC'),
	(41911, 110, '2015-02-01 00:37:03.000000', 'temperatura', 641.0000, 'ºC'),
	(41912, 110, '2015-02-01 00:37:04.000000', 'temperatura', 1018.0000, 'ºC'),
	(41913, 110, '2015-02-01 00:37:05.000000', 'temperatura', 769.0000, 'ºC'),
	(41914, 110, '2015-02-01 00:37:06.000000', 'temperatura', 792.0000, 'ºC'),
	(41915, 110, '2015-02-01 00:37:07.000000', 'temperatura', 454.0000, 'ºC'),
	(41916, 110, '2015-02-01 00:37:08.000000', 'temperatura', 1092.0000, 'ºC'),
	(41917, 110, '2015-02-01 00:37:09.000000', 'temperatura', 499.0000, 'ºC'),
	(41918, 110, '2015-02-01 00:37:10.000000', 'temperatura', 421.0000, 'ºC'),
	(41919, 110, '2015-02-01 00:37:11.000000', 'temperatura', 606.0000, 'ºC'),
	(41920, 110, '2015-02-01 00:37:12.000000', 'temperatura', 568.0000, 'ºC'),
	(41921, 110, '2015-02-01 00:37:13.000000', 'temperatura', 1022.0000, 'ºC'),
	(41922, 110, '2015-02-01 00:37:14.000000', 'temperatura', 1007.0000, 'ºC'),
	(41923, 110, '2015-02-01 00:37:15.000000', 'temperatura', 770.0000, 'ºC'),
	(41924, 110, '2015-02-01 00:37:16.000000', 'temperatura', 831.0000, 'ºC'),
	(41925, 110, '2015-02-01 00:37:17.000000', 'temperatura', 643.0000, 'ºC'),
	(41926, 110, '2015-02-01 00:37:18.000000', 'temperatura', 723.0000, 'ºC'),
	(41927, 110, '2015-02-01 00:37:19.000000', 'temperatura', 485.0000, 'ºC'),
	(41928, 110, '2015-02-01 00:37:20.000000', 'temperatura', 258.0000, 'ºC'),
	(41929, 110, '2015-02-01 00:37:21.000000', 'temperatura', 1035.0000, 'ºC'),
	(41930, 110, '2015-02-01 00:37:22.000000', 'temperatura', 804.0000, 'ºC'),
	(41931, 110, '2015-02-01 00:37:23.000000', 'temperatura', 913.0000, 'ºC'),
	(41932, 110, '2015-02-01 00:37:24.000000', 'temperatura', 955.0000, 'ºC'),
	(41933, 110, '2015-02-01 00:37:25.000000', 'temperatura', 835.0000, 'ºC'),
	(41934, 110, '2015-02-01 00:37:26.000000', 'temperatura', 110.0000, 'ºC'),
	(41935, 110, '2015-02-01 00:37:27.000000', 'temperatura', 444.0000, 'ºC'),
	(41936, 110, '2015-02-01 00:37:28.000000', 'temperatura', 694.0000, 'ºC'),
	(41937, 110, '2015-02-01 00:37:29.000000', 'temperatura', 935.0000, 'ºC'),
	(41938, 110, '2015-02-01 00:37:30.000000', 'temperatura', 197.0000, 'ºC'),
	(41939, 110, '2015-02-01 00:37:31.000000', 'temperatura', 578.0000, 'ºC'),
	(41940, 110, '2015-02-01 00:37:32.000000', 'temperatura', 1100.0000, 'ºC'),
	(41941, 110, '2015-02-01 00:37:33.000000', 'temperatura', 166.0000, 'ºC'),
	(41942, 110, '2015-02-01 00:37:34.000000', 'temperatura', 1130.0000, 'ºC'),
	(41943, 110, '2015-02-01 00:37:35.000000', 'temperatura', 355.0000, 'ºC'),
	(41944, 110, '2015-02-01 00:37:36.000000', 'temperatura', 783.0000, 'ºC'),
	(41945, 110, '2015-02-01 00:37:37.000000', 'temperatura', 451.0000, 'ºC'),
	(41946, 110, '2015-02-01 00:37:38.000000', 'temperatura', 1108.0000, 'ºC'),
	(41947, 110, '2015-02-01 00:37:39.000000', 'temperatura', 588.0000, 'ºC'),
	(41948, 110, '2015-02-01 00:37:40.000000', 'temperatura', 815.0000, 'ºC'),
	(41949, 110, '2015-02-01 00:37:41.000000', 'temperatura', 1113.0000, 'ºC'),
	(41950, 110, '2015-02-01 00:37:42.000000', 'temperatura', 721.0000, 'ºC'),
	(41951, 110, '2015-02-01 00:37:43.000000', 'temperatura', 268.0000, 'ºC'),
	(41952, 110, '2015-02-01 00:37:44.000000', 'temperatura', 374.0000, 'ºC'),
	(41953, 110, '2015-02-01 00:37:45.000000', 'temperatura', 1070.0000, 'ºC'),
	(41954, 110, '2015-02-01 00:37:46.000000', 'temperatura', 626.0000, 'ºC'),
	(41955, 110, '2015-02-01 00:37:47.000000', 'temperatura', 1119.0000, 'ºC'),
	(41956, 110, '2015-02-01 00:37:48.000000', 'temperatura', 121.0000, 'ºC'),
	(41957, 110, '2015-02-01 00:37:49.000000', 'temperatura', 846.0000, 'ºC'),
	(41958, 110, '2015-02-01 00:37:50.000000', 'temperatura', 267.0000, 'ºC'),
	(41959, 110, '2015-02-01 00:37:51.000000', 'temperatura', 1197.0000, 'ºC'),
	(41960, 110, '2015-02-01 00:37:52.000000', 'temperatura', 385.0000, 'ºC'),
	(41961, 110, '2015-02-01 00:37:53.000000', 'temperatura', 733.0000, 'ºC'),
	(41962, 110, '2015-02-01 00:37:54.000000', 'temperatura', 111.0000, 'ºC'),
	(41963, 110, '2015-02-01 00:37:55.000000', 'temperatura', 755.0000, 'ºC'),
	(41964, 110, '2015-02-01 00:37:56.000000', 'temperatura', 1045.0000, 'ºC'),
	(41965, 110, '2015-02-01 00:37:57.000000', 'temperatura', 560.0000, 'ºC'),
	(41966, 110, '2015-02-01 00:37:58.000000', 'temperatura', 865.0000, 'ºC'),
	(41967, 110, '2015-02-01 00:37:59.000000', 'temperatura', 246.0000, 'ºC'),
	(41968, 110, '2015-02-01 00:38:00.000000', 'temperatura', 1037.0000, 'ºC'),
	(41969, 110, '2015-02-01 00:38:01.000000', 'temperatura', 845.0000, 'ºC'),
	(41970, 110, '2015-02-01 00:38:02.000000', 'temperatura', 1116.0000, 'ºC'),
	(41971, 110, '2015-02-01 00:38:03.000000', 'temperatura', 645.0000, 'ºC'),
	(41972, 110, '2015-02-01 00:38:04.000000', 'temperatura', 1078.0000, 'ºC'),
	(41973, 110, '2015-02-01 00:38:05.000000', 'temperatura', 1057.0000, 'ºC'),
	(41974, 110, '2015-02-01 00:38:06.000000', 'temperatura', 851.0000, 'ºC'),
	(41975, 110, '2015-02-01 00:38:07.000000', 'temperatura', 1086.0000, 'ºC'),
	(41976, 110, '2015-02-01 00:38:08.000000', 'temperatura', 476.0000, 'ºC'),
	(41977, 110, '2015-02-01 00:38:09.000000', 'temperatura', 325.0000, 'ºC'),
	(41978, 110, '2015-02-01 00:38:10.000000', 'temperatura', 194.0000, 'ºC'),
	(41979, 110, '2015-02-01 00:38:11.000000', 'temperatura', 1198.0000, 'ºC'),
	(41980, 110, '2015-02-01 00:38:12.000000', 'temperatura', 607.0000, 'ºC'),
	(41981, 110, '2015-02-01 00:38:13.000000', 'temperatura', 640.0000, 'ºC'),
	(41982, 110, '2015-02-01 00:38:14.000000', 'temperatura', 183.0000, 'ºC'),
	(41983, 110, '2015-02-01 00:38:15.000000', 'temperatura', 193.0000, 'ºC'),
	(41984, 110, '2015-02-01 00:38:16.000000', 'temperatura', 419.0000, 'ºC'),
	(41985, 110, '2015-02-01 00:38:17.000000', 'temperatura', 314.0000, 'ºC'),
	(41986, 110, '2015-02-01 00:38:18.000000', 'temperatura', 316.0000, 'ºC'),
	(41987, 110, '2015-02-01 00:38:19.000000', 'temperatura', 636.0000, 'ºC'),
	(41988, 110, '2015-02-01 00:38:20.000000', 'temperatura', 1035.0000, 'ºC'),
	(41989, 110, '2015-02-01 00:38:21.000000', 'temperatura', 867.0000, 'ºC'),
	(41990, 110, '2015-02-01 00:38:22.000000', 'temperatura', 28.0000, 'ºC'),
	(41991, 110, '2015-02-01 00:38:23.000000', 'temperatura', 1141.0000, 'ºC'),
	(41992, 110, '2015-02-01 00:38:24.000000', 'temperatura', 822.0000, 'ºC'),
	(41993, 110, '2015-02-01 00:38:25.000000', 'temperatura', 686.0000, 'ºC'),
	(41994, 110, '2015-02-01 00:38:26.000000', 'temperatura', 966.0000, 'ºC'),
	(41995, 110, '2015-02-01 00:38:27.000000', 'temperatura', 374.0000, 'ºC'),
	(41996, 110, '2015-02-01 00:38:28.000000', 'temperatura', 170.0000, 'ºC'),
	(41997, 110, '2015-02-01 00:38:29.000000', 'temperatura', 928.0000, 'ºC'),
	(41998, 110, '2015-02-01 00:38:30.000000', 'temperatura', 530.0000, 'ºC'),
	(41999, 110, '2015-02-01 00:38:31.000000', 'temperatura', 1069.0000, 'ºC'),
	(42000, 110, '2015-02-01 00:38:32.000000', 'temperatura', 153.0000, 'ºC'),
	(42001, 110, '2015-02-01 00:38:33.000000', 'temperatura', 1161.0000, 'ºC'),
	(42002, 110, '2015-02-01 00:38:34.000000', 'temperatura', 545.0000, 'ºC'),
	(42003, 110, '2015-02-01 00:38:35.000000', 'temperatura', 442.0000, 'ºC'),
	(42004, 110, '2015-02-01 00:38:36.000000', 'temperatura', 578.0000, 'ºC'),
	(42005, 110, '2015-02-01 00:38:37.000000', 'temperatura', 361.0000, 'ºC'),
	(42006, 110, '2015-02-01 00:38:38.000000', 'temperatura', 74.0000, 'ºC'),
	(42007, 110, '2015-02-01 00:38:39.000000', 'temperatura', 487.0000, 'ºC'),
	(42008, 110, '2015-02-01 00:38:40.000000', 'temperatura', 1013.0000, 'ºC'),
	(42009, 110, '2015-02-01 00:38:41.000000', 'temperatura', 6.0000, 'ºC'),
	(42010, 110, '2015-02-01 00:38:42.000000', 'temperatura', 590.0000, 'ºC'),
	(42011, 110, '2015-02-01 00:38:43.000000', 'temperatura', 531.0000, 'ºC'),
	(42012, 110, '2015-02-01 00:38:44.000000', 'temperatura', 887.0000, 'ºC'),
	(42013, 110, '2015-02-01 00:38:45.000000', 'temperatura', 442.0000, 'ºC'),
	(42014, 110, '2015-02-01 00:38:46.000000', 'temperatura', 749.0000, 'ºC'),
	(42015, 110, '2015-02-01 00:38:47.000000', 'temperatura', 22.0000, 'ºC'),
	(42016, 110, '2015-02-01 00:38:48.000000', 'temperatura', 262.0000, 'ºC'),
	(42017, 110, '2015-02-01 00:38:49.000000', 'temperatura', 44.0000, 'ºC'),
	(42018, 110, '2015-02-01 00:38:50.000000', 'temperatura', 635.0000, 'ºC'),
	(42019, 110, '2015-02-01 00:38:51.000000', 'temperatura', 643.0000, 'ºC'),
	(42020, 110, '2015-02-01 00:38:52.000000', 'temperatura', 112.0000, 'ºC'),
	(42021, 110, '2015-02-01 00:38:53.000000', 'temperatura', 1030.0000, 'ºC'),
	(42022, 110, '2015-02-01 00:38:54.000000', 'temperatura', 15.0000, 'ºC'),
	(42023, 110, '2015-02-01 00:38:55.000000', 'temperatura', 585.0000, 'ºC'),
	(42024, 110, '2015-02-01 00:38:56.000000', 'temperatura', 482.0000, 'ºC'),
	(42025, 110, '2015-02-01 00:38:57.000000', 'temperatura', 655.0000, 'ºC'),
	(42026, 110, '2015-02-01 00:38:58.000000', 'temperatura', 629.0000, 'ºC'),
	(42027, 110, '2015-02-01 00:38:59.000000', 'temperatura', 1183.0000, 'ºC'),
	(42028, 110, '2015-02-01 00:39:00.000000', 'temperatura', 425.0000, 'ºC'),
	(42029, 110, '2015-02-01 00:39:01.000000', 'temperatura', 978.0000, 'ºC'),
	(42030, 110, '2015-02-01 00:39:02.000000', 'temperatura', 14.0000, 'ºC'),
	(42031, 110, '2015-02-01 00:39:03.000000', 'temperatura', 737.0000, 'ºC'),
	(42032, 110, '2015-02-01 00:39:04.000000', 'temperatura', 44.0000, 'ºC'),
	(42033, 110, '2015-02-01 00:39:05.000000', 'temperatura', 409.0000, 'ºC'),
	(42034, 110, '2015-02-01 00:39:06.000000', 'temperatura', 712.0000, 'ºC'),
	(42035, 110, '2015-02-01 00:39:07.000000', 'temperatura', 1133.0000, 'ºC'),
	(42036, 110, '2015-02-01 00:39:08.000000', 'temperatura', 1132.0000, 'ºC'),
	(42037, 110, '2015-02-01 00:39:09.000000', 'temperatura', 1061.0000, 'ºC'),
	(42038, 110, '2015-02-01 00:39:10.000000', 'temperatura', 709.0000, 'ºC'),
	(42039, 110, '2015-02-01 00:39:11.000000', 'temperatura', 361.0000, 'ºC'),
	(42040, 110, '2015-02-01 00:39:12.000000', 'temperatura', 880.0000, 'ºC'),
	(42041, 110, '2015-02-01 00:39:13.000000', 'temperatura', 918.0000, 'ºC'),
	(42042, 110, '2015-02-01 00:39:14.000000', 'temperatura', 752.0000, 'ºC'),
	(42043, 110, '2015-02-01 00:39:15.000000', 'temperatura', 1004.0000, 'ºC'),
	(42044, 110, '2015-02-01 00:39:16.000000', 'temperatura', 364.0000, 'ºC'),
	(42045, 110, '2015-02-01 00:39:17.000000', 'temperatura', 9.0000, 'ºC'),
	(42046, 110, '2015-02-01 00:39:18.000000', 'temperatura', 153.0000, 'ºC'),
	(42047, 110, '2015-02-01 00:39:19.000000', 'temperatura', 738.0000, 'ºC'),
	(42048, 110, '2015-02-01 00:39:20.000000', 'temperatura', 834.0000, 'ºC'),
	(42049, 110, '2015-02-01 00:39:21.000000', 'temperatura', 754.0000, 'ºC'),
	(42050, 110, '2015-02-01 00:39:22.000000', 'temperatura', 68.0000, 'ºC'),
	(42051, 110, '2015-02-01 00:39:23.000000', 'temperatura', 480.0000, 'ºC'),
	(42052, 110, '2015-02-01 00:39:24.000000', 'temperatura', 997.0000, 'ºC'),
	(42053, 110, '2015-02-01 00:39:25.000000', 'temperatura', 1144.0000, 'ºC'),
	(42054, 110, '2015-02-01 00:39:26.000000', 'temperatura', 330.0000, 'ºC'),
	(42055, 110, '2015-02-01 00:39:27.000000', 'temperatura', 620.0000, 'ºC'),
	(42056, 110, '2015-02-01 00:39:28.000000', 'temperatura', 908.0000, 'ºC'),
	(42057, 110, '2015-02-01 00:39:29.000000', 'temperatura', 283.0000, 'ºC'),
	(42058, 110, '2015-02-01 00:39:30.000000', 'temperatura', 1092.0000, 'ºC'),
	(42059, 110, '2015-02-01 00:39:31.000000', 'temperatura', 1012.0000, 'ºC'),
	(42060, 110, '2015-02-01 00:39:32.000000', 'temperatura', 585.0000, 'ºC'),
	(42061, 110, '2015-02-01 00:39:33.000000', 'temperatura', 1090.0000, 'ºC'),
	(42062, 110, '2015-02-01 00:39:34.000000', 'temperatura', 96.0000, 'ºC'),
	(42063, 110, '2015-02-01 00:39:35.000000', 'temperatura', 808.0000, 'ºC'),
	(42064, 110, '2015-02-01 00:39:36.000000', 'temperatura', 153.0000, 'ºC'),
	(42065, 110, '2015-02-01 00:39:37.000000', 'temperatura', 742.0000, 'ºC'),
	(42066, 110, '2015-02-01 00:39:38.000000', 'temperatura', 852.0000, 'ºC'),
	(42067, 110, '2015-02-01 00:39:39.000000', 'temperatura', 835.0000, 'ºC'),
	(42068, 110, '2015-02-01 00:39:40.000000', 'temperatura', 419.0000, 'ºC'),
	(42069, 110, '2015-02-01 00:39:41.000000', 'temperatura', 789.0000, 'ºC'),
	(42070, 110, '2015-02-01 00:39:42.000000', 'temperatura', 289.0000, 'ºC'),
	(42071, 110, '2015-02-01 00:39:43.000000', 'temperatura', 278.0000, 'ºC'),
	(42072, 110, '2015-02-01 00:39:44.000000', 'temperatura', 522.0000, 'ºC'),
	(42073, 110, '2015-02-01 00:39:45.000000', 'temperatura', 578.0000, 'ºC'),
	(42074, 110, '2015-02-01 00:39:46.000000', 'temperatura', 125.0000, 'ºC'),
	(42075, 110, '2015-02-01 00:39:47.000000', 'temperatura', 92.0000, 'ºC'),
	(42076, 110, '2015-02-01 00:39:48.000000', 'temperatura', 85.0000, 'ºC'),
	(42077, 110, '2015-02-01 00:39:49.000000', 'temperatura', 151.0000, 'ºC'),
	(42078, 110, '2015-02-01 00:39:50.000000', 'temperatura', 499.0000, 'ºC'),
	(42079, 110, '2015-02-01 00:39:51.000000', 'temperatura', 844.0000, 'ºC'),
	(42080, 110, '2015-02-01 00:39:52.000000', 'temperatura', 322.0000, 'ºC'),
	(42081, 110, '2015-02-01 00:39:53.000000', 'temperatura', 281.0000, 'ºC'),
	(42082, 110, '2015-02-01 00:39:54.000000', 'temperatura', 437.0000, 'ºC'),
	(42083, 110, '2015-02-01 00:39:55.000000', 'temperatura', 142.0000, 'ºC'),
	(42084, 110, '2015-02-01 00:39:56.000000', 'temperatura', 602.0000, 'ºC'),
	(42085, 110, '2015-02-01 00:39:57.000000', 'temperatura', 184.0000, 'ºC'),
	(42086, 110, '2015-02-01 00:39:58.000000', 'temperatura', 316.0000, 'ºC'),
	(42087, 110, '2015-02-01 00:39:59.000000', 'temperatura', 1026.0000, 'ºC'),
	(42088, 110, '2015-02-01 00:40:00.000000', 'temperatura', 583.0000, 'ºC'),
	(42089, 110, '2015-02-01 00:40:01.000000', 'temperatura', 1039.0000, 'ºC'),
	(42090, 110, '2015-02-01 00:40:02.000000', 'temperatura', 1046.0000, 'ºC'),
	(42091, 110, '2015-02-01 00:40:03.000000', 'temperatura', 914.0000, 'ºC'),
	(42092, 110, '2015-02-01 00:40:04.000000', 'temperatura', 234.0000, 'ºC'),
	(42093, 110, '2015-02-01 00:40:05.000000', 'temperatura', 826.0000, 'ºC'),
	(42094, 110, '2015-02-01 00:40:06.000000', 'temperatura', 1029.0000, 'ºC'),
	(42095, 110, '2015-02-01 00:40:07.000000', 'temperatura', 269.0000, 'ºC'),
	(42096, 110, '2015-02-01 00:40:08.000000', 'temperatura', 657.0000, 'ºC'),
	(42097, 110, '2015-02-01 00:40:09.000000', 'temperatura', 81.0000, 'ºC'),
	(42098, 110, '2015-02-01 00:40:10.000000', 'temperatura', 832.0000, 'ºC'),
	(42099, 110, '2015-02-01 00:40:11.000000', 'temperatura', 318.0000, 'ºC'),
	(42100, 110, '2015-02-01 00:40:12.000000', 'temperatura', 295.0000, 'ºC'),
	(42101, 110, '2015-02-01 00:40:13.000000', 'temperatura', 523.0000, 'ºC'),
	(42102, 110, '2015-02-01 00:40:14.000000', 'temperatura', 529.0000, 'ºC'),
	(42103, 110, '2015-02-01 00:40:15.000000', 'temperatura', 1076.0000, 'ºC'),
	(42104, 110, '2015-02-01 00:40:16.000000', 'temperatura', 195.0000, 'ºC'),
	(42105, 110, '2015-02-01 00:40:17.000000', 'temperatura', 145.0000, 'ºC'),
	(42106, 110, '2015-02-01 00:40:18.000000', 'temperatura', 142.0000, 'ºC'),
	(42107, 110, '2015-02-01 00:40:19.000000', 'temperatura', 276.0000, 'ºC'),
	(42108, 110, '2015-02-01 00:40:20.000000', 'temperatura', 956.0000, 'ºC'),
	(42109, 110, '2015-02-01 00:40:21.000000', 'temperatura', 349.0000, 'ºC'),
	(42110, 110, '2015-02-01 00:40:22.000000', 'temperatura', 80.0000, 'ºC'),
	(42111, 110, '2015-02-01 00:40:23.000000', 'temperatura', 551.0000, 'ºC'),
	(42112, 110, '2015-02-01 00:40:24.000000', 'temperatura', 116.0000, 'ºC'),
	(42113, 110, '2015-02-01 00:40:25.000000', 'temperatura', 127.0000, 'ºC'),
	(42114, 110, '2015-02-01 00:40:26.000000', 'temperatura', 290.0000, 'ºC'),
	(42115, 110, '2015-02-01 00:40:27.000000', 'temperatura', 1069.0000, 'ºC'),
	(42116, 110, '2015-02-01 00:40:28.000000', 'temperatura', 876.0000, 'ºC'),
	(42117, 110, '2015-02-01 00:40:29.000000', 'temperatura', 1174.0000, 'ºC'),
	(42118, 110, '2015-02-01 00:40:30.000000', 'temperatura', 843.0000, 'ºC'),
	(42119, 110, '2015-02-01 00:40:31.000000', 'temperatura', 694.0000, 'ºC'),
	(42120, 110, '2015-02-01 00:40:32.000000', 'temperatura', 940.0000, 'ºC'),
	(42121, 110, '2015-02-01 00:40:33.000000', 'temperatura', 217.0000, 'ºC'),
	(42122, 110, '2015-02-01 00:40:34.000000', 'temperatura', 666.0000, 'ºC'),
	(42123, 110, '2015-02-01 00:40:35.000000', 'temperatura', 282.0000, 'ºC'),
	(42124, 110, '2015-02-01 00:40:36.000000', 'temperatura', 609.0000, 'ºC'),
	(42125, 110, '2015-02-01 00:40:37.000000', 'temperatura', 1003.0000, 'ºC'),
	(42126, 110, '2015-02-01 00:40:38.000000', 'temperatura', 786.0000, 'ºC'),
	(42127, 110, '2015-02-01 00:40:39.000000', 'temperatura', 921.0000, 'ºC'),
	(42128, 110, '2015-02-01 00:40:40.000000', 'temperatura', 1049.0000, 'ºC'),
	(42129, 110, '2015-02-01 00:40:41.000000', 'temperatura', 81.0000, 'ºC'),
	(42130, 110, '2015-02-01 00:40:42.000000', 'temperatura', 858.0000, 'ºC'),
	(42131, 110, '2015-02-01 00:40:43.000000', 'temperatura', 450.0000, 'ºC'),
	(42132, 110, '2015-02-01 00:40:44.000000', 'temperatura', 875.0000, 'ºC'),
	(42133, 110, '2015-02-01 00:40:45.000000', 'temperatura', 624.0000, 'ºC'),
	(42134, 110, '2015-02-01 00:40:46.000000', 'temperatura', 497.0000, 'ºC'),
	(42135, 110, '2015-02-01 00:40:47.000000', 'temperatura', 615.0000, 'ºC'),
	(42136, 110, '2015-02-01 00:40:48.000000', 'temperatura', 382.0000, 'ºC'),
	(42137, 110, '2015-02-01 00:40:49.000000', 'temperatura', 64.0000, 'ºC'),
	(42138, 110, '2015-02-01 00:40:50.000000', 'temperatura', 378.0000, 'ºC'),
	(42139, 110, '2015-02-01 00:40:51.000000', 'temperatura', 496.0000, 'ºC'),
	(42140, 110, '2015-02-01 00:40:52.000000', 'temperatura', 148.0000, 'ºC'),
	(42141, 110, '2015-02-01 00:40:53.000000', 'temperatura', 450.0000, 'ºC'),
	(42142, 110, '2015-02-01 00:40:54.000000', 'temperatura', 608.0000, 'ºC'),
	(42143, 110, '2015-02-01 00:40:55.000000', 'temperatura', 490.0000, 'ºC'),
	(42144, 110, '2015-02-01 00:40:56.000000', 'temperatura', 627.0000, 'ºC'),
	(42145, 110, '2015-02-01 00:40:57.000000', 'temperatura', 465.0000, 'ºC'),
	(42146, 110, '2015-02-01 00:40:58.000000', 'temperatura', 446.0000, 'ºC'),
	(42147, 110, '2015-02-01 00:40:59.000000', 'temperatura', 834.0000, 'ºC'),
	(42148, 110, '2015-02-01 00:41:00.000000', 'temperatura', 434.0000, 'ºC'),
	(42149, 110, '2015-02-01 00:41:01.000000', 'temperatura', 867.0000, 'ºC'),
	(42150, 110, '2015-02-01 00:41:02.000000', 'temperatura', 632.0000, 'ºC'),
	(42151, 110, '2015-02-01 00:41:03.000000', 'temperatura', 561.0000, 'ºC'),
	(42152, 110, '2015-02-01 00:41:04.000000', 'temperatura', 908.0000, 'ºC'),
	(42153, 110, '2015-02-01 00:41:05.000000', 'temperatura', 459.0000, 'ºC'),
	(42154, 110, '2015-02-01 00:41:06.000000', 'temperatura', 773.0000, 'ºC'),
	(42155, 110, '2015-02-01 00:41:07.000000', 'temperatura', 88.0000, 'ºC'),
	(42156, 110, '2015-02-01 00:41:08.000000', 'temperatura', 520.0000, 'ºC'),
	(42157, 110, '2015-02-01 00:41:09.000000', 'temperatura', 1136.0000, 'ºC'),
	(42158, 110, '2015-02-01 00:41:10.000000', 'temperatura', 520.0000, 'ºC'),
	(42159, 110, '2015-02-01 00:41:11.000000', 'temperatura', 392.0000, 'ºC'),
	(42160, 110, '2015-02-01 00:41:12.000000', 'temperatura', 404.0000, 'ºC'),
	(42161, 110, '2015-02-01 00:41:13.000000', 'temperatura', 841.0000, 'ºC'),
	(42162, 110, '2015-02-01 00:41:14.000000', 'temperatura', 594.0000, 'ºC'),
	(42163, 110, '2015-02-01 00:41:15.000000', 'temperatura', 448.0000, 'ºC'),
	(42164, 110, '2015-02-01 00:41:16.000000', 'temperatura', 460.0000, 'ºC'),
	(42165, 110, '2015-02-01 00:41:17.000000', 'temperatura', 956.0000, 'ºC'),
	(42166, 110, '2015-02-01 00:41:18.000000', 'temperatura', 1000.0000, 'ºC'),
	(42167, 110, '2015-02-01 00:41:19.000000', 'temperatura', 934.0000, 'ºC'),
	(42168, 110, '2015-02-01 00:41:20.000000', 'temperatura', 471.0000, 'ºC'),
	(42169, 110, '2015-02-01 00:41:21.000000', 'temperatura', 753.0000, 'ºC'),
	(42170, 110, '2015-02-01 00:41:22.000000', 'temperatura', 1153.0000, 'ºC'),
	(42171, 110, '2015-02-01 00:41:23.000000', 'temperatura', 1107.0000, 'ºC'),
	(42172, 110, '2015-02-01 00:41:24.000000', 'temperatura', 876.0000, 'ºC'),
	(42173, 110, '2015-02-01 00:41:25.000000', 'temperatura', 1061.0000, 'ºC'),
	(42174, 110, '2015-02-01 00:41:26.000000', 'temperatura', 277.0000, 'ºC'),
	(42175, 110, '2015-02-01 00:41:27.000000', 'temperatura', 602.0000, 'ºC'),
	(42176, 110, '2015-02-01 00:41:28.000000', 'temperatura', 980.0000, 'ºC'),
	(42177, 110, '2015-02-01 00:41:29.000000', 'temperatura', 694.0000, 'ºC'),
	(42178, 110, '2015-02-01 00:41:30.000000', 'temperatura', 530.0000, 'ºC'),
	(42179, 110, '2015-02-01 00:41:31.000000', 'temperatura', 569.0000, 'ºC'),
	(42180, 110, '2015-02-01 00:41:32.000000', 'temperatura', 54.0000, 'ºC'),
	(42181, 110, '2015-02-01 00:41:33.000000', 'temperatura', 963.0000, 'ºC'),
	(42182, 110, '2015-02-01 00:41:34.000000', 'temperatura', 1054.0000, 'ºC'),
	(42183, 110, '2015-02-01 00:41:35.000000', 'temperatura', 1183.0000, 'ºC'),
	(42184, 110, '2015-02-01 00:41:36.000000', 'temperatura', 354.0000, 'ºC'),
	(42185, 110, '2015-02-01 00:41:37.000000', 'temperatura', 621.0000, 'ºC'),
	(42186, 110, '2015-02-01 00:41:38.000000', 'temperatura', 843.0000, 'ºC'),
	(42187, 110, '2015-02-01 00:41:39.000000', 'temperatura', 1151.0000, 'ºC'),
	(42188, 110, '2015-02-01 00:41:40.000000', 'temperatura', 829.0000, 'ºC'),
	(42189, 110, '2015-02-01 00:41:41.000000', 'temperatura', 693.0000, 'ºC'),
	(42190, 110, '2015-02-01 00:41:42.000000', 'temperatura', 978.0000, 'ºC'),
	(42191, 110, '2015-02-01 00:41:43.000000', 'temperatura', 410.0000, 'ºC'),
	(42192, 110, '2015-02-01 00:41:44.000000', 'temperatura', 315.0000, 'ºC'),
	(42193, 110, '2015-02-01 00:41:45.000000', 'temperatura', 348.0000, 'ºC'),
	(42194, 110, '2015-02-01 00:41:46.000000', 'temperatura', 795.0000, 'ºC'),
	(42195, 110, '2015-02-01 00:41:47.000000', 'temperatura', 532.0000, 'ºC'),
	(42196, 110, '2015-02-01 00:41:48.000000', 'temperatura', 277.0000, 'ºC'),
	(42197, 110, '2015-02-01 00:41:49.000000', 'temperatura', 988.0000, 'ºC'),
	(42198, 110, '2015-02-01 00:41:50.000000', 'temperatura', 508.0000, 'ºC'),
	(42199, 110, '2015-02-01 00:41:51.000000', 'temperatura', 776.0000, 'ºC'),
	(42200, 110, '2015-02-01 00:41:52.000000', 'temperatura', 1159.0000, 'ºC'),
	(42201, 110, '2015-02-01 00:41:53.000000', 'temperatura', 1067.0000, 'ºC'),
	(42202, 110, '2015-02-01 00:41:54.000000', 'temperatura', 656.0000, 'ºC'),
	(42203, 110, '2015-02-01 00:41:55.000000', 'temperatura', 83.0000, 'ºC'),
	(42204, 110, '2015-02-01 00:41:56.000000', 'temperatura', 845.0000, 'ºC'),
	(42205, 110, '2015-02-01 00:41:57.000000', 'temperatura', 376.0000, 'ºC'),
	(42206, 110, '2015-02-01 00:41:58.000000', 'temperatura', 548.0000, 'ºC'),
	(42207, 110, '2015-02-01 00:41:59.000000', 'temperatura', 410.0000, 'ºC'),
	(42208, 110, '2015-02-01 00:42:00.000000', 'temperatura', 407.0000, 'ºC'),
	(42209, 110, '2015-02-01 00:42:01.000000', 'temperatura', 806.0000, 'ºC'),
	(42210, 110, '2015-02-01 00:42:02.000000', 'temperatura', 407.0000, 'ºC'),
	(42211, 110, '2015-02-01 00:42:03.000000', 'temperatura', 821.0000, 'ºC'),
	(42212, 110, '2015-02-01 00:42:04.000000', 'temperatura', 481.0000, 'ºC'),
	(42213, 110, '2015-02-01 00:42:05.000000', 'temperatura', 1145.0000, 'ºC'),
	(42214, 110, '2015-02-01 00:42:06.000000', 'temperatura', 680.0000, 'ºC'),
	(42215, 110, '2015-02-01 00:42:07.000000', 'temperatura', 1167.0000, 'ºC'),
	(42216, 110, '2015-02-01 00:42:08.000000', 'temperatura', 197.0000, 'ºC'),
	(42217, 110, '2015-02-01 00:42:09.000000', 'temperatura', 1084.0000, 'ºC'),
	(42218, 110, '2015-02-01 00:42:10.000000', 'temperatura', 31.0000, 'ºC'),
	(42219, 110, '2015-02-01 00:42:11.000000', 'temperatura', 502.0000, 'ºC'),
	(42220, 110, '2015-02-01 00:42:12.000000', 'temperatura', 19.0000, 'ºC'),
	(42221, 110, '2015-02-01 00:42:13.000000', 'temperatura', 989.0000, 'ºC'),
	(42222, 110, '2015-02-01 00:42:14.000000', 'temperatura', 89.0000, 'ºC'),
	(42223, 110, '2015-02-01 00:42:15.000000', 'temperatura', 1079.0000, 'ºC'),
	(42224, 110, '2015-02-01 00:42:16.000000', 'temperatura', 326.0000, 'ºC'),
	(42225, 110, '2015-02-01 00:42:17.000000', 'temperatura', 794.0000, 'ºC'),
	(42226, 110, '2015-02-01 00:42:18.000000', 'temperatura', 594.0000, 'ºC'),
	(42227, 110, '2015-02-01 00:42:19.000000', 'temperatura', 588.0000, 'ºC'),
	(42228, 110, '2015-02-01 00:42:20.000000', 'temperatura', 1159.0000, 'ºC'),
	(42229, 110, '2015-02-01 00:42:21.000000', 'temperatura', 430.0000, 'ºC'),
	(42230, 110, '2015-02-01 00:42:22.000000', 'temperatura', 1076.0000, 'ºC'),
	(42231, 110, '2015-02-01 00:42:23.000000', 'temperatura', 490.0000, 'ºC'),
	(42232, 110, '2015-02-01 00:42:24.000000', 'temperatura', 424.0000, 'ºC'),
	(42233, 110, '2015-02-01 00:42:25.000000', 'temperatura', 649.0000, 'ºC'),
	(42234, 110, '2015-02-01 00:42:26.000000', 'temperatura', 772.0000, 'ºC'),
	(42235, 110, '2015-02-01 00:42:27.000000', 'temperatura', 715.0000, 'ºC'),
	(42236, 110, '2015-02-01 00:42:28.000000', 'temperatura', 60.0000, 'ºC'),
	(42237, 110, '2015-02-01 00:42:29.000000', 'temperatura', 554.0000, 'ºC'),
	(42238, 110, '2015-02-01 00:42:30.000000', 'temperatura', 192.0000, 'ºC'),
	(42239, 110, '2015-02-01 00:42:31.000000', 'temperatura', 498.0000, 'ºC'),
	(42240, 110, '2015-02-01 00:42:32.000000', 'temperatura', 713.0000, 'ºC'),
	(42241, 110, '2015-02-01 00:42:33.000000', 'temperatura', 872.0000, 'ºC'),
	(42242, 110, '2015-02-01 00:42:34.000000', 'temperatura', 1021.0000, 'ºC'),
	(42243, 110, '2015-02-01 00:42:35.000000', 'temperatura', 90.0000, 'ºC'),
	(42244, 110, '2015-02-01 00:42:36.000000', 'temperatura', 989.0000, 'ºC'),
	(42245, 110, '2015-02-01 00:42:37.000000', 'temperatura', 1073.0000, 'ºC'),
	(42246, 110, '2015-02-01 00:42:38.000000', 'temperatura', 1198.0000, 'ºC'),
	(42247, 110, '2015-02-01 00:42:39.000000', 'temperatura', 375.0000, 'ºC'),
	(42248, 110, '2015-02-01 00:42:40.000000', 'temperatura', 678.0000, 'ºC'),
	(42249, 110, '2015-02-01 00:42:41.000000', 'temperatura', 1066.0000, 'ºC'),
	(42250, 110, '2015-02-01 00:42:42.000000', 'temperatura', 897.0000, 'ºC'),
	(42251, 110, '2015-02-01 00:42:43.000000', 'temperatura', 89.0000, 'ºC'),
	(42252, 110, '2015-02-01 00:42:44.000000', 'temperatura', 152.0000, 'ºC'),
	(42253, 110, '2015-02-01 00:42:45.000000', 'temperatura', 495.0000, 'ºC'),
	(42254, 110, '2015-02-01 00:42:46.000000', 'temperatura', 819.0000, 'ºC'),
	(42255, 110, '2015-02-01 00:42:47.000000', 'temperatura', 212.0000, 'ºC'),
	(42256, 110, '2015-02-01 00:42:48.000000', 'temperatura', 1004.0000, 'ºC'),
	(42257, 110, '2015-02-01 00:42:49.000000', 'temperatura', 783.0000, 'ºC'),
	(42258, 110, '2015-02-01 00:42:50.000000', 'temperatura', 905.0000, 'ºC'),
	(42259, 110, '2015-02-01 00:42:51.000000', 'temperatura', 976.0000, 'ºC'),
	(42260, 110, '2015-02-01 00:42:52.000000', 'temperatura', 964.0000, 'ºC'),
	(42261, 110, '2015-02-01 00:42:53.000000', 'temperatura', 692.0000, 'ºC'),
	(42262, 110, '2015-02-01 00:42:54.000000', 'temperatura', 568.0000, 'ºC'),
	(42263, 110, '2015-02-01 00:42:55.000000', 'temperatura', 764.0000, 'ºC'),
	(42264, 110, '2015-02-01 00:42:56.000000', 'temperatura', 917.0000, 'ºC'),
	(42265, 110, '2015-02-01 00:42:57.000000', 'temperatura', 1093.0000, 'ºC'),
	(42266, 110, '2015-02-01 00:42:58.000000', 'temperatura', 313.0000, 'ºC'),
	(42267, 110, '2015-02-01 00:42:59.000000', 'temperatura', 689.0000, 'ºC'),
	(42268, 110, '2015-02-01 00:43:00.000000', 'temperatura', 105.0000, 'ºC'),
	(42269, 110, '2015-02-01 00:43:01.000000', 'temperatura', 860.0000, 'ºC'),
	(42270, 110, '2015-02-01 00:43:02.000000', 'temperatura', 385.0000, 'ºC'),
	(42271, 110, '2015-02-01 00:43:03.000000', 'temperatura', 546.0000, 'ºC'),
	(42272, 110, '2015-02-01 00:43:04.000000', 'temperatura', 374.0000, 'ºC'),
	(42273, 110, '2015-02-01 00:43:05.000000', 'temperatura', 232.0000, 'ºC'),
	(42274, 110, '2015-02-01 00:43:06.000000', 'temperatura', 38.0000, 'ºC'),
	(42275, 110, '2015-02-01 00:43:07.000000', 'temperatura', 694.0000, 'ºC'),
	(42276, 110, '2015-02-01 00:43:08.000000', 'temperatura', 959.0000, 'ºC'),
	(42277, 110, '2015-02-01 00:43:09.000000', 'temperatura', 312.0000, 'ºC'),
	(42278, 110, '2015-02-01 00:43:10.000000', 'temperatura', 1086.0000, 'ºC'),
	(42279, 110, '2015-02-01 00:43:11.000000', 'temperatura', 891.0000, 'ºC'),
	(42280, 110, '2015-02-01 00:43:12.000000', 'temperatura', 1198.0000, 'ºC'),
	(42281, 110, '2015-02-01 00:43:13.000000', 'temperatura', 920.0000, 'ºC'),
	(42282, 110, '2015-02-01 00:43:14.000000', 'temperatura', 1005.0000, 'ºC'),
	(42283, 110, '2015-02-01 00:43:15.000000', 'temperatura', 1067.0000, 'ºC'),
	(42284, 110, '2015-02-01 00:43:16.000000', 'temperatura', 1119.0000, 'ºC'),
	(42285, 110, '2015-02-01 00:43:17.000000', 'temperatura', 1195.0000, 'ºC'),
	(42286, 110, '2015-02-01 00:43:18.000000', 'temperatura', 217.0000, 'ºC'),
	(42287, 110, '2015-02-01 00:43:19.000000', 'temperatura', 1101.0000, 'ºC'),
	(42288, 110, '2015-02-01 00:43:20.000000', 'temperatura', 56.0000, 'ºC'),
	(42289, 110, '2015-02-01 00:43:21.000000', 'temperatura', 579.0000, 'ºC'),
	(42290, 110, '2015-02-01 00:43:22.000000', 'temperatura', 324.0000, 'ºC'),
	(42291, 110, '2015-02-01 00:43:23.000000', 'temperatura', 1085.0000, 'ºC'),
	(42292, 110, '2015-02-01 00:43:24.000000', 'temperatura', 852.0000, 'ºC'),
	(42293, 110, '2015-02-01 00:43:25.000000', 'temperatura', 1004.0000, 'ºC'),
	(42294, 110, '2015-02-01 00:43:26.000000', 'temperatura', 68.0000, 'ºC'),
	(42295, 110, '2015-02-01 00:43:27.000000', 'temperatura', 929.0000, 'ºC'),
	(42296, 110, '2015-02-01 00:43:28.000000', 'temperatura', 839.0000, 'ºC'),
	(42297, 110, '2015-02-01 00:43:29.000000', 'temperatura', 209.0000, 'ºC'),
	(42298, 110, '2015-02-01 00:43:30.000000', 'temperatura', 928.0000, 'ºC'),
	(42299, 110, '2015-02-01 00:43:31.000000', 'temperatura', 414.0000, 'ºC'),
	(42300, 110, '2015-02-01 00:43:32.000000', 'temperatura', 489.0000, 'ºC'),
	(42301, 110, '2015-02-01 00:43:33.000000', 'temperatura', 0.0000, 'ºC'),
	(42302, 110, '2015-02-01 00:43:34.000000', 'temperatura', 935.0000, 'ºC'),
	(42303, 110, '2015-02-01 00:43:35.000000', 'temperatura', 1076.0000, 'ºC'),
	(42304, 110, '2015-02-01 00:43:36.000000', 'temperatura', 177.0000, 'ºC'),
	(42305, 110, '2015-02-01 00:43:37.000000', 'temperatura', 55.0000, 'ºC'),
	(42306, 110, '2015-02-01 00:43:38.000000', 'temperatura', 947.0000, 'ºC'),
	(42307, 110, '2015-02-01 00:43:39.000000', 'temperatura', 969.0000, 'ºC'),
	(42308, 110, '2015-02-01 00:43:40.000000', 'temperatura', 807.0000, 'ºC'),
	(42309, 110, '2015-02-01 00:43:41.000000', 'temperatura', 1125.0000, 'ºC'),
	(42310, 110, '2015-02-01 00:43:42.000000', 'temperatura', 808.0000, 'ºC'),
	(42311, 110, '2015-02-01 00:43:43.000000', 'temperatura', 662.0000, 'ºC'),
	(42312, 110, '2015-02-01 00:43:44.000000', 'temperatura', 889.0000, 'ºC'),
	(42313, 110, '2015-02-01 00:43:45.000000', 'temperatura', 58.0000, 'ºC'),
	(42314, 110, '2015-02-01 00:43:46.000000', 'temperatura', 25.0000, 'ºC'),
	(42315, 110, '2015-02-01 00:43:47.000000', 'temperatura', 1152.0000, 'ºC'),
	(42316, 110, '2015-02-01 00:43:48.000000', 'temperatura', 883.0000, 'ºC'),
	(42317, 110, '2015-02-01 00:43:49.000000', 'temperatura', 962.0000, 'ºC'),
	(42318, 110, '2015-02-01 00:43:50.000000', 'temperatura', 961.0000, 'ºC'),
	(42319, 110, '2015-02-01 00:43:51.000000', 'temperatura', 719.0000, 'ºC'),
	(42320, 110, '2015-02-01 00:43:52.000000', 'temperatura', 712.0000, 'ºC'),
	(42321, 110, '2015-02-01 00:43:53.000000', 'temperatura', 206.0000, 'ºC'),
	(42322, 110, '2015-02-01 00:43:54.000000', 'temperatura', 92.0000, 'ºC'),
	(42323, 110, '2015-02-01 00:43:55.000000', 'temperatura', 1042.0000, 'ºC'),
	(42324, 110, '2015-02-01 00:43:56.000000', 'temperatura', 135.0000, 'ºC'),
	(42325, 110, '2015-02-01 00:43:57.000000', 'temperatura', 1150.0000, 'ºC'),
	(42326, 110, '2015-02-01 00:43:58.000000', 'temperatura', 545.0000, 'ºC'),
	(42327, 110, '2015-02-01 00:43:59.000000', 'temperatura', 475.0000, 'ºC'),
	(42328, 110, '2015-02-01 00:44:00.000000', 'temperatura', 743.0000, 'ºC'),
	(42329, 110, '2015-02-01 00:44:01.000000', 'temperatura', 1090.0000, 'ºC'),
	(42330, 110, '2015-02-01 00:44:02.000000', 'temperatura', 819.0000, 'ºC'),
	(42331, 110, '2015-02-01 00:44:03.000000', 'temperatura', 828.0000, 'ºC'),
	(42332, 110, '2015-02-01 00:44:04.000000', 'temperatura', 482.0000, 'ºC'),
	(42333, 110, '2015-02-01 00:44:05.000000', 'temperatura', 1126.0000, 'ºC'),
	(42334, 110, '2015-02-01 00:44:06.000000', 'temperatura', 584.0000, 'ºC'),
	(42335, 110, '2015-02-01 00:44:07.000000', 'temperatura', 743.0000, 'ºC'),
	(42336, 110, '2015-02-01 00:44:08.000000', 'temperatura', 762.0000, 'ºC'),
	(42337, 110, '2015-02-01 00:44:09.000000', 'temperatura', 382.0000, 'ºC'),
	(42338, 110, '2015-02-01 00:44:10.000000', 'temperatura', 825.0000, 'ºC'),
	(42339, 110, '2015-02-01 00:44:11.000000', 'temperatura', 579.0000, 'ºC'),
	(42340, 110, '2015-02-01 00:44:12.000000', 'temperatura', 419.0000, 'ºC'),
	(42341, 110, '2015-02-01 00:44:13.000000', 'temperatura', 362.0000, 'ºC'),
	(42342, 110, '2015-02-01 00:44:14.000000', 'temperatura', 550.0000, 'ºC'),
	(42343, 110, '2015-02-01 00:44:15.000000', 'temperatura', 468.0000, 'ºC'),
	(42344, 110, '2015-02-01 00:44:16.000000', 'temperatura', 688.0000, 'ºC'),
	(42345, 110, '2015-02-01 00:44:17.000000', 'temperatura', 839.0000, 'ºC'),
	(42346, 110, '2015-02-01 00:44:18.000000', 'temperatura', 929.0000, 'ºC'),
	(42347, 110, '2015-02-01 00:44:19.000000', 'temperatura', 930.0000, 'ºC'),
	(42348, 110, '2015-02-01 00:44:20.000000', 'temperatura', 663.0000, 'ºC'),
	(42349, 110, '2015-02-01 00:44:21.000000', 'temperatura', 527.0000, 'ºC'),
	(42350, 110, '2015-02-01 00:44:22.000000', 'temperatura', 645.0000, 'ºC'),
	(42351, 110, '2015-02-01 00:44:23.000000', 'temperatura', 443.0000, 'ºC'),
	(42352, 110, '2015-02-01 00:44:24.000000', 'temperatura', 281.0000, 'ºC'),
	(42353, 110, '2015-02-01 00:44:25.000000', 'temperatura', 76.0000, 'ºC'),
	(42354, 110, '2015-02-01 00:44:26.000000', 'temperatura', 738.0000, 'ºC'),
	(42355, 110, '2015-02-01 00:44:27.000000', 'temperatura', 1062.0000, 'ºC'),
	(42356, 110, '2015-02-01 00:44:28.000000', 'temperatura', 699.0000, 'ºC'),
	(42357, 110, '2015-02-01 00:44:29.000000', 'temperatura', 307.0000, 'ºC'),
	(42358, 110, '2015-02-01 00:44:30.000000', 'temperatura', 637.0000, 'ºC'),
	(42359, 110, '2015-02-01 00:44:31.000000', 'temperatura', 1068.0000, 'ºC'),
	(42360, 110, '2015-02-01 00:44:32.000000', 'temperatura', 1027.0000, 'ºC'),
	(42361, 110, '2015-02-01 00:44:33.000000', 'temperatura', 734.0000, 'ºC'),
	(42362, 110, '2015-02-01 00:44:34.000000', 'temperatura', 588.0000, 'ºC'),
	(42363, 110, '2015-02-01 00:44:35.000000', 'temperatura', 740.0000, 'ºC'),
	(42364, 110, '2015-02-01 00:44:36.000000', 'temperatura', 736.0000, 'ºC'),
	(42365, 110, '2015-02-01 00:44:37.000000', 'temperatura', 261.0000, 'ºC'),
	(42366, 110, '2015-02-01 00:44:38.000000', 'temperatura', 297.0000, 'ºC'),
	(42367, 110, '2015-02-01 00:44:39.000000', 'temperatura', 704.0000, 'ºC'),
	(42368, 110, '2015-02-01 00:44:40.000000', 'temperatura', 230.0000, 'ºC'),
	(42369, 110, '2015-02-01 00:44:41.000000', 'temperatura', 237.0000, 'ºC'),
	(42370, 110, '2015-02-01 00:44:42.000000', 'temperatura', 497.0000, 'ºC'),
	(42371, 110, '2015-02-01 00:44:43.000000', 'temperatura', 574.0000, 'ºC'),
	(42372, 110, '2015-02-01 00:44:44.000000', 'temperatura', 181.0000, 'ºC'),
	(42373, 110, '2015-02-01 00:44:45.000000', 'temperatura', 384.0000, 'ºC'),
	(42374, 110, '2015-02-01 00:44:46.000000', 'temperatura', 176.0000, 'ºC'),
	(42375, 110, '2015-02-01 00:44:47.000000', 'temperatura', 930.0000, 'ºC'),
	(42376, 110, '2015-02-01 00:44:48.000000', 'temperatura', 522.0000, 'ºC'),
	(42377, 110, '2015-02-01 00:44:49.000000', 'temperatura', 1020.0000, 'ºC'),
	(42378, 110, '2015-02-01 00:44:50.000000', 'temperatura', 1133.0000, 'ºC'),
	(42379, 110, '2015-02-01 00:44:51.000000', 'temperatura', 207.0000, 'ºC'),
	(42380, 110, '2015-02-01 00:44:52.000000', 'temperatura', 35.0000, 'ºC'),
	(42381, 110, '2015-02-01 00:44:53.000000', 'temperatura', 754.0000, 'ºC'),
	(42382, 110, '2015-02-01 00:44:54.000000', 'temperatura', 66.0000, 'ºC'),
	(42383, 110, '2015-02-01 00:44:55.000000', 'temperatura', 468.0000, 'ºC'),
	(42384, 110, '2015-02-01 00:44:56.000000', 'temperatura', 944.0000, 'ºC'),
	(42385, 110, '2015-02-01 00:44:57.000000', 'temperatura', 916.0000, 'ºC'),
	(42386, 110, '2015-02-01 00:44:58.000000', 'temperatura', 550.0000, 'ºC'),
	(42387, 110, '2015-02-01 00:44:59.000000', 'temperatura', 2.0000, 'ºC'),
	(42388, 110, '2015-02-01 00:45:00.000000', 'temperatura', 761.0000, 'ºC'),
	(42389, 110, '2015-02-01 00:45:01.000000', 'temperatura', 198.0000, 'ºC'),
	(42390, 110, '2015-02-01 00:45:02.000000', 'temperatura', 1110.0000, 'ºC'),
	(42391, 110, '2015-02-01 00:45:03.000000', 'temperatura', 154.0000, 'ºC'),
	(42392, 110, '2015-02-01 00:45:04.000000', 'temperatura', 1043.0000, 'ºC'),
	(42393, 110, '2015-02-01 00:45:05.000000', 'temperatura', 1152.0000, 'ºC'),
	(42394, 110, '2015-02-01 00:45:06.000000', 'temperatura', 232.0000, 'ºC'),
	(42395, 110, '2015-02-01 00:45:07.000000', 'temperatura', 105.0000, 'ºC'),
	(42396, 110, '2015-02-01 00:45:08.000000', 'temperatura', 1031.0000, 'ºC'),
	(42397, 110, '2015-02-01 00:45:09.000000', 'temperatura', 38.0000, 'ºC'),
	(42398, 110, '2015-02-01 00:45:10.000000', 'temperatura', 700.0000, 'ºC'),
	(42399, 110, '2015-02-01 00:45:11.000000', 'temperatura', 986.0000, 'ºC'),
	(42400, 110, '2015-02-01 00:45:12.000000', 'temperatura', 429.0000, 'ºC'),
	(42401, 110, '2015-02-01 00:45:13.000000', 'temperatura', 390.0000, 'ºC'),
	(42402, 110, '2015-02-01 00:45:14.000000', 'temperatura', 663.0000, 'ºC'),
	(42403, 110, '2015-02-01 00:45:15.000000', 'temperatura', 943.0000, 'ºC'),
	(42404, 110, '2015-02-01 00:45:16.000000', 'temperatura', 329.0000, 'ºC'),
	(42405, 110, '2015-02-01 00:45:17.000000', 'temperatura', 15.0000, 'ºC'),
	(42406, 110, '2015-02-01 00:45:18.000000', 'temperatura', 289.0000, 'ºC'),
	(42407, 110, '2015-02-01 00:45:19.000000', 'temperatura', 202.0000, 'ºC'),
	(42408, 110, '2015-02-01 00:45:20.000000', 'temperatura', 144.0000, 'ºC'),
	(42409, 110, '2015-02-01 00:45:21.000000', 'temperatura', 114.0000, 'ºC'),
	(42410, 110, '2015-02-01 00:45:22.000000', 'temperatura', 140.0000, 'ºC'),
	(42411, 110, '2015-02-01 00:45:23.000000', 'temperatura', 358.0000, 'ºC'),
	(42412, 110, '2015-02-01 00:45:24.000000', 'temperatura', 169.0000, 'ºC'),
	(42413, 110, '2015-02-01 00:45:25.000000', 'temperatura', 974.0000, 'ºC'),
	(42414, 110, '2015-02-01 00:45:26.000000', 'temperatura', 761.0000, 'ºC'),
	(42415, 110, '2015-02-01 00:45:27.000000', 'temperatura', 884.0000, 'ºC'),
	(42416, 110, '2015-02-01 00:45:28.000000', 'temperatura', 940.0000, 'ºC'),
	(42417, 110, '2015-02-01 00:45:29.000000', 'temperatura', 845.0000, 'ºC'),
	(42418, 110, '2015-02-01 00:45:30.000000', 'temperatura', 207.0000, 'ºC'),
	(42419, 110, '2015-02-01 00:45:31.000000', 'temperatura', 900.0000, 'ºC'),
	(42420, 110, '2015-02-01 00:45:32.000000', 'temperatura', 278.0000, 'ºC'),
	(42421, 110, '2015-02-01 00:45:33.000000', 'temperatura', 1091.0000, 'ºC'),
	(42422, 110, '2015-02-01 00:45:34.000000', 'temperatura', 1020.0000, 'ºC'),
	(42423, 110, '2015-02-01 00:45:35.000000', 'temperatura', 629.0000, 'ºC'),
	(42424, 110, '2015-02-01 00:45:36.000000', 'temperatura', 87.0000, 'ºC'),
	(42425, 110, '2015-02-01 00:45:37.000000', 'temperatura', 949.0000, 'ºC'),
	(42426, 110, '2015-02-01 00:45:38.000000', 'temperatura', 882.0000, 'ºC'),
	(42427, 110, '2015-02-01 00:45:39.000000', 'temperatura', 363.0000, 'ºC'),
	(42428, 110, '2015-02-01 00:45:40.000000', 'temperatura', 370.0000, 'ºC'),
	(42429, 110, '2015-02-01 00:45:41.000000', 'temperatura', 763.0000, 'ºC'),
	(42430, 110, '2015-02-01 00:45:42.000000', 'temperatura', 306.0000, 'ºC'),
	(42431, 110, '2015-02-01 00:45:43.000000', 'temperatura', 440.0000, 'ºC'),
	(42432, 110, '2015-02-01 00:45:44.000000', 'temperatura', 84.0000, 'ºC'),
	(42433, 110, '2015-02-01 00:45:45.000000', 'temperatura', 301.0000, 'ºC'),
	(42434, 110, '2015-02-01 00:45:46.000000', 'temperatura', 54.0000, 'ºC'),
	(42435, 110, '2015-02-01 00:45:47.000000', 'temperatura', 568.0000, 'ºC'),
	(42436, 110, '2015-02-01 00:45:48.000000', 'temperatura', 278.0000, 'ºC'),
	(42437, 110, '2015-02-01 00:45:49.000000', 'temperatura', 885.0000, 'ºC'),
	(42438, 110, '2015-02-01 00:45:50.000000', 'temperatura', 1193.0000, 'ºC'),
	(42439, 110, '2015-02-01 00:45:51.000000', 'temperatura', 911.0000, 'ºC'),
	(42440, 110, '2015-02-01 00:45:52.000000', 'temperatura', 974.0000, 'ºC'),
	(42441, 110, '2015-02-01 00:45:53.000000', 'temperatura', 941.0000, 'ºC'),
	(42442, 110, '2015-02-01 00:45:54.000000', 'temperatura', 580.0000, 'ºC'),
	(42443, 110, '2015-02-01 00:45:55.000000', 'temperatura', 79.0000, 'ºC'),
	(42444, 110, '2015-02-01 00:45:56.000000', 'temperatura', 1056.0000, 'ºC'),
	(42445, 110, '2015-02-01 00:45:57.000000', 'temperatura', 243.0000, 'ºC'),
	(42446, 110, '2015-02-01 00:45:58.000000', 'temperatura', 449.0000, 'ºC'),
	(42447, 110, '2015-02-01 00:45:59.000000', 'temperatura', 316.0000, 'ºC'),
	(42448, 110, '2015-02-01 00:46:00.000000', 'temperatura', 233.0000, 'ºC'),
	(42449, 110, '2015-02-01 00:46:01.000000', 'temperatura', 219.0000, 'ºC'),
	(42450, 110, '2015-02-01 00:46:02.000000', 'temperatura', 395.0000, 'ºC'),
	(42451, 110, '2015-02-01 00:46:03.000000', 'temperatura', 119.0000, 'ºC'),
	(42452, 110, '2015-02-01 00:46:04.000000', 'temperatura', 612.0000, 'ºC'),
	(42453, 110, '2015-02-01 00:46:05.000000', 'temperatura', 301.0000, 'ºC'),
	(42454, 110, '2015-02-01 00:46:06.000000', 'temperatura', 872.0000, 'ºC'),
	(42455, 110, '2015-02-01 00:46:07.000000', 'temperatura', 1058.0000, 'ºC'),
	(42456, 110, '2015-02-01 00:46:08.000000', 'temperatura', 274.0000, 'ºC'),
	(42457, 110, '2015-02-01 00:46:09.000000', 'temperatura', 595.0000, 'ºC'),
	(42458, 110, '2015-02-01 00:46:10.000000', 'temperatura', 955.0000, 'ºC'),
	(42459, 110, '2015-02-01 00:46:11.000000', 'temperatura', 588.0000, 'ºC'),
	(42460, 110, '2015-02-01 00:46:12.000000', 'temperatura', 77.0000, 'ºC'),
	(42461, 110, '2015-02-01 00:46:13.000000', 'temperatura', 1021.0000, 'ºC'),
	(42462, 110, '2015-02-01 00:46:14.000000', 'temperatura', 75.0000, 'ºC'),
	(42463, 110, '2015-02-01 00:46:15.000000', 'temperatura', 911.0000, 'ºC'),
	(42464, 110, '2015-02-01 00:46:16.000000', 'temperatura', 731.0000, 'ºC'),
	(42465, 110, '2015-02-01 00:46:17.000000', 'temperatura', 922.0000, 'ºC'),
	(42466, 110, '2015-02-01 00:46:18.000000', 'temperatura', 16.0000, 'ºC'),
	(42467, 110, '2015-02-01 00:46:19.000000', 'temperatura', 916.0000, 'ºC'),
	(42468, 110, '2015-02-01 00:46:20.000000', 'temperatura', 933.0000, 'ºC'),
	(42469, 110, '2015-02-01 00:46:21.000000', 'temperatura', 715.0000, 'ºC'),
	(42470, 110, '2015-02-01 00:46:22.000000', 'temperatura', 779.0000, 'ºC'),
	(42471, 110, '2015-02-01 00:46:23.000000', 'temperatura', 550.0000, 'ºC'),
	(42472, 110, '2015-02-01 00:46:24.000000', 'temperatura', 414.0000, 'ºC'),
	(42473, 110, '2015-02-01 00:46:25.000000', 'temperatura', 422.0000, 'ºC'),
	(42474, 110, '2015-02-01 00:46:26.000000', 'temperatura', 867.0000, 'ºC'),
	(42475, 110, '2015-02-01 00:46:27.000000', 'temperatura', 671.0000, 'ºC'),
	(42476, 110, '2015-02-01 00:46:28.000000', 'temperatura', 755.0000, 'ºC'),
	(42477, 110, '2015-02-01 00:46:29.000000', 'temperatura', 563.0000, 'ºC'),
	(42478, 110, '2015-02-01 00:46:30.000000', 'temperatura', 549.0000, 'ºC'),
	(42479, 110, '2015-02-01 00:46:31.000000', 'temperatura', 1056.0000, 'ºC'),
	(42480, 110, '2015-02-01 00:46:32.000000', 'temperatura', 32.0000, 'ºC'),
	(42481, 110, '2015-02-01 00:46:33.000000', 'temperatura', 595.0000, 'ºC'),
	(42482, 110, '2015-02-01 00:46:34.000000', 'temperatura', 477.0000, 'ºC'),
	(42483, 110, '2015-02-01 00:46:35.000000', 'temperatura', 603.0000, 'ºC'),
	(42484, 110, '2015-02-01 00:46:36.000000', 'temperatura', 386.0000, 'ºC'),
	(42485, 110, '2015-02-01 00:46:37.000000', 'temperatura', 118.0000, 'ºC'),
	(42486, 110, '2015-02-01 00:46:38.000000', 'temperatura', 633.0000, 'ºC'),
	(42487, 110, '2015-02-01 00:46:39.000000', 'temperatura', 414.0000, 'ºC'),
	(42488, 110, '2015-02-01 00:46:40.000000', 'temperatura', 169.0000, 'ºC'),
	(42489, 110, '2015-02-01 00:46:41.000000', 'temperatura', 806.0000, 'ºC'),
	(42490, 110, '2015-02-01 00:46:42.000000', 'temperatura', 1121.0000, 'ºC'),
	(42491, 110, '2015-02-01 00:46:43.000000', 'temperatura', 790.0000, 'ºC'),
	(42492, 110, '2015-02-01 00:46:44.000000', 'temperatura', 588.0000, 'ºC'),
	(42493, 110, '2015-02-01 00:46:45.000000', 'temperatura', 568.0000, 'ºC'),
	(42494, 110, '2015-02-01 00:46:46.000000', 'temperatura', 1079.0000, 'ºC'),
	(42495, 110, '2015-02-01 00:46:47.000000', 'temperatura', 92.0000, 'ºC'),
	(42496, 110, '2015-02-01 00:46:48.000000', 'temperatura', 822.0000, 'ºC'),
	(42497, 110, '2015-02-01 00:46:49.000000', 'temperatura', 236.0000, 'ºC'),
	(42498, 110, '2015-02-01 00:46:50.000000', 'temperatura', 1112.0000, 'ºC'),
	(42499, 110, '2015-02-01 00:46:51.000000', 'temperatura', 54.0000, 'ºC'),
	(42500, 110, '2015-02-01 00:46:52.000000', 'temperatura', 536.0000, 'ºC'),
	(42501, 110, '2015-02-01 00:46:53.000000', 'temperatura', 115.0000, 'ºC'),
	(42502, 110, '2015-02-01 00:46:54.000000', 'temperatura', 171.0000, 'ºC'),
	(42503, 110, '2015-02-01 00:46:55.000000', 'temperatura', 508.0000, 'ºC'),
	(42504, 110, '2015-02-01 00:46:56.000000', 'temperatura', 828.0000, 'ºC'),
	(42505, 110, '2015-02-01 00:46:57.000000', 'temperatura', 216.0000, 'ºC'),
	(42506, 110, '2015-02-01 00:46:58.000000', 'temperatura', 995.0000, 'ºC'),
	(42507, 110, '2015-02-01 00:46:59.000000', 'temperatura', 729.0000, 'ºC'),
	(42508, 110, '2015-02-01 00:47:00.000000', 'temperatura', 661.0000, 'ºC'),
	(42509, 110, '2015-02-01 00:47:01.000000', 'temperatura', 1118.0000, 'ºC'),
	(42510, 110, '2015-02-01 00:47:02.000000', 'temperatura', 8.0000, 'ºC'),
	(42511, 110, '2015-02-01 00:47:03.000000', 'temperatura', 284.0000, 'ºC'),
	(42512, 110, '2015-02-01 00:47:04.000000', 'temperatura', 199.0000, 'ºC'),
	(42513, 110, '2015-02-01 00:47:05.000000', 'temperatura', 142.0000, 'ºC'),
	(42514, 110, '2015-02-01 00:47:06.000000', 'temperatura', 115.0000, 'ºC'),
	(42515, 110, '2015-02-01 00:47:07.000000', 'temperatura', 148.0000, 'ºC'),
	(42516, 110, '2015-02-01 00:47:08.000000', 'temperatura', 395.0000, 'ºC'),
	(42517, 110, '2015-02-01 00:47:09.000000', 'temperatura', 332.0000, 'ºC'),
	(42518, 110, '2015-02-01 00:47:10.000000', 'temperatura', 474.0000, 'ºC'),
	(42519, 110, '2015-02-01 00:47:11.000000', 'temperatura', 175.0000, 'ºC'),
	(42520, 110, '2015-02-01 00:47:12.000000', 'temperatura', 653.0000, 'ºC'),
	(42521, 110, '2015-02-01 00:47:13.000000', 'temperatura', 342.0000, 'ºC'),
	(42522, 110, '2015-02-01 00:47:14.000000', 'temperatura', 949.0000, 'ºC'),
	(42523, 110, '2015-02-01 00:47:15.000000', 'temperatura', 121.0000, 'ºC'),
	(42524, 110, '2015-02-01 00:47:16.000000', 'temperatura', 158.0000, 'ºC'),
	(42525, 110, '2015-02-01 00:47:17.000000', 'temperatura', 427.0000, 'ºC'),
	(42526, 110, '2015-02-01 00:47:18.000000', 'temperatura', 463.0000, 'ºC'),
	(42527, 110, '2015-02-01 00:47:19.000000', 'temperatura', 1034.0000, 'ºC'),
	(42528, 110, '2015-02-01 00:47:20.000000', 'temperatura', 183.0000, 'ºC'),
	(42529, 110, '2015-02-01 00:47:21.000000', 'temperatura', 214.0000, 'ºC'),
	(42530, 110, '2015-02-01 00:47:22.000000', 'temperatura', 519.0000, 'ºC'),
	(42531, 110, '2015-02-01 00:47:23.000000', 'temperatura', 756.0000, 'ºC'),
	(42532, 110, '2015-02-01 00:47:24.000000', 'temperatura', 1022.0000, 'ºC'),
	(42533, 110, '2015-02-01 00:47:25.000000', 'temperatura', 441.0000, 'ºC'),
	(42534, 110, '2015-02-01 00:47:26.000000', 'temperatura', 342.0000, 'ºC'),
	(42535, 110, '2015-02-01 00:47:27.000000', 'temperatura', 386.0000, 'ºC'),
	(42536, 110, '2015-02-01 00:47:28.000000', 'temperatura', 906.0000, 'ºC'),
	(42537, 110, '2015-02-01 00:47:29.000000', 'temperatura', 972.0000, 'ºC'),
	(42538, 110, '2015-02-01 00:47:30.000000', 'temperatura', 943.0000, 'ºC'),
	(42539, 110, '2015-02-01 00:47:31.000000', 'temperatura', 600.0000, 'ºC'),
	(42540, 110, '2015-02-01 00:47:32.000000', 'temperatura', 169.0000, 'ºC'),
	(42541, 110, '2015-02-01 00:47:33.000000', 'temperatura', 246.0000, 'ºC'),
	(42542, 110, '2015-02-01 00:47:34.000000', 'temperatura', 725.0000, 'ºC'),
	(42543, 110, '2015-02-01 00:47:35.000000', 'temperatura', 488.0000, 'ºC'),
	(42544, 110, '2015-02-01 00:47:36.000000', 'temperatura', 267.0000, 'ºC'),
	(42545, 110, '2015-02-01 00:47:37.000000', 'temperatura', 1068.0000, 'ºC'),
	(42546, 110, '2015-02-01 00:47:38.000000', 'temperatura', 943.0000, 'ºC'),
	(42547, 110, '2015-02-01 00:47:39.000000', 'temperatura', 310.0000, 'ºC'),
	(42548, 110, '2015-02-01 00:47:40.000000', 'temperatura', 1120.0000, 'ºC'),
	(42549, 110, '2015-02-01 00:47:41.000000', 'temperatura', 1071.0000, 'ºC'),
	(42550, 110, '2015-02-01 00:47:42.000000', 'temperatura', 794.0000, 'ºC'),
	(42551, 110, '2015-02-01 00:47:43.000000', 'temperatura', 758.0000, 'ºC'),
	(42552, 110, '2015-02-01 00:47:44.000000', 'temperatura', 210.0000, 'ºC'),
	(42553, 110, '2015-02-01 00:47:45.000000', 'temperatura', 1174.0000, 'ºC'),
	(42554, 110, '2015-02-01 00:47:46.000000', 'temperatura', 441.0000, 'ºC'),
	(42555, 110, '2015-02-01 00:47:47.000000', 'temperatura', 1084.0000, 'ºC'),
	(42556, 110, '2015-02-01 00:47:48.000000', 'temperatura', 495.0000, 'ºC'),
	(42557, 110, '2015-02-01 00:47:49.000000', 'temperatura', 427.0000, 'ºC'),
	(42558, 110, '2015-02-01 00:47:50.000000', 'temperatura', 650.0000, 'ºC'),
	(42559, 110, '2015-02-01 00:47:51.000000', 'temperatura', 769.0000, 'ºC'),
	(42560, 110, '2015-02-01 00:47:52.000000', 'temperatura', 695.0000, 'ºC'),
	(42561, 110, '2015-02-01 00:47:53.000000', 'temperatura', 1167.0000, 'ºC'),
	(42562, 110, '2015-02-01 00:47:54.000000', 'temperatura', 151.0000, 'ºC'),
	(42563, 110, '2015-02-01 00:47:55.000000', 'temperatura', 855.0000, 'ºC'),
	(42564, 110, '2015-02-01 00:47:56.000000', 'temperatura', 222.0000, 'ºC'),
	(42565, 110, '2015-02-01 00:47:57.000000', 'temperatura', 944.0000, 'ºC'),
	(42566, 110, '2015-02-01 00:47:58.000000', 'temperatura', 456.0000, 'ºC'),
	(42567, 110, '2015-02-01 00:47:59.000000', 'temperatura', 649.0000, 'ºC'),
	(42568, 110, '2015-02-01 00:48:00.000000', 'temperatura', 677.0000, 'ºC'),
	(42569, 110, '2015-02-01 00:48:01.000000', 'temperatura', 240.0000, 'ºC'),
	(42570, 110, '2015-02-01 00:48:02.000000', 'temperatura', 370.0000, 'ºC'),
	(42571, 110, '2015-02-01 00:48:03.000000', 'temperatura', 1130.0000, 'ºC'),
	(42572, 110, '2015-02-01 00:48:04.000000', 'temperatura', 941.0000, 'ºC'),
	(42573, 110, '2015-02-01 00:48:05.000000', 'temperatura', 114.0000, 'ºC'),
	(42574, 110, '2015-02-01 00:48:06.000000', 'temperatura', 148.0000, 'ºC'),
	(42575, 110, '2015-02-01 00:48:07.000000', 'temperatura', 398.0000, 'ºC'),
	(42576, 110, '2015-02-01 00:48:08.000000', 'temperatura', 345.0000, 'ºC'),
	(42577, 110, '2015-02-01 00:48:09.000000', 'temperatura', 534.0000, 'ºC'),
	(42578, 110, '2015-02-01 00:48:10.000000', 'temperatura', 435.0000, 'ºC'),
	(42579, 110, '2015-02-01 00:48:11.000000', 'temperatura', 573.0000, 'ºC'),
	(42580, 110, '2015-02-01 00:48:12.000000', 'temperatura', 362.0000, 'ºC'),
	(42581, 110, '2015-02-01 00:48:13.000000', 'temperatura', 92.0000, 'ºC'),
	(42582, 110, '2015-02-01 00:48:14.000000', 'temperatura', 573.0000, 'ºC'),
	(42583, 110, '2015-02-01 00:48:15.000000', 'temperatura', 188.0000, 'ºC'),
	(42584, 110, '2015-02-01 00:48:16.000000', 'temperatura', 422.0000, 'ºC'),
	(42585, 110, '2015-02-01 00:48:17.000000', 'temperatura', 348.0000, 'ºC'),
	(42586, 110, '2015-02-01 00:48:18.000000', 'temperatura', 472.0000, 'ºC'),
	(42587, 110, '2015-02-01 00:48:19.000000', 'temperatura', 117.0000, 'ºC'),
	(42588, 110, '2015-02-01 00:48:20.000000', 'temperatura', 369.0000, 'ºC'),
	(42589, 110, '2015-02-01 00:48:21.000000', 'temperatura', 293.0000, 'ºC'),
	(42590, 110, '2015-02-01 00:48:22.000000', 'temperatura', 361.0000, 'ºC'),
	(42591, 110, '2015-02-01 00:48:23.000000', 'temperatura', 927.0000, 'ºC'),
	(42592, 110, '2015-02-01 00:48:24.000000', 'temperatura', 1151.0000, 'ºC'),
	(42593, 110, '2015-02-01 00:48:25.000000', 'temperatura', 576.0000, 'ºC'),
	(42594, 110, '2015-02-01 00:48:26.000000', 'temperatura', 625.0000, 'ºC'),
	(42595, 110, '2015-02-01 00:48:27.000000', 'temperatura', 201.0000, 'ºC'),
	(42596, 110, '2015-02-01 00:48:28.000000', 'temperatura', 328.0000, 'ºC'),
	(42597, 110, '2015-02-01 00:48:29.000000', 'temperatura', 1038.0000, 'ºC'),
	(42598, 110, '2015-02-01 00:48:30.000000', 'temperatura', 606.0000, 'ºC'),
	(42599, 110, '2015-02-01 00:48:31.000000', 'temperatura', 1119.0000, 'ºC'),
	(42600, 110, '2015-02-01 00:48:32.000000', 'temperatura', 176.0000, 'ºC'),
	(42601, 110, '2015-02-01 00:48:33.000000', 'temperatura', 1124.0000, 'ºC'),
	(42602, 110, '2015-02-01 00:48:34.000000', 'temperatura', 293.0000, 'ºC'),
	(42603, 110, '2015-02-01 00:48:35.000000', 'temperatura', 491.0000, 'ºC'),
	(42604, 110, '2015-02-01 00:48:36.000000', 'temperatura', 380.0000, 'ºC'),
	(42605, 110, '2015-02-01 00:48:37.000000', 'temperatura', 425.0000, 'ºC'),
	(42606, 110, '2015-02-01 00:48:38.000000', 'temperatura', 987.0000, 'ºC'),
	(42607, 110, '2015-02-01 00:48:39.000000', 'temperatura', 59.0000, 'ºC'),
	(42608, 110, '2015-02-01 00:48:40.000000', 'temperatura', 937.0000, 'ºC'),
	(42609, 110, '2015-02-01 00:48:41.000000', 'temperatura', 906.0000, 'ºC'),
	(42610, 110, '2015-02-01 00:48:42.000000', 'temperatura', 519.0000, 'ºC'),
	(42611, 110, '2015-02-01 00:48:43.000000', 'temperatura', 1078.0000, 'ºC'),
	(42612, 110, '2015-02-01 00:48:44.000000', 'temperatura', 232.0000, 'ºC'),
	(42613, 110, '2015-02-01 00:48:45.000000', 'temperatura', 328.0000, 'ºC'),
	(42614, 110, '2015-02-01 00:48:46.000000', 'temperatura', 944.0000, 'ºC'),
	(42615, 110, '2015-02-01 00:48:47.000000', 'temperatura', 136.0000, 'ºC'),
	(42616, 110, '2015-02-01 00:48:48.000000', 'temperatura', 249.0000, 'ºC'),
	(42617, 110, '2015-02-01 00:48:49.000000', 'temperatura', 837.0000, 'ºC'),
	(42618, 110, '2015-02-01 00:48:50.000000', 'temperatura', 1040.0000, 'ºC'),
	(42619, 110, '2015-02-01 00:48:51.000000', 'temperatura', 289.0000, 'ºC'),
	(42620, 110, '2015-02-01 00:48:52.000000', 'temperatura', 725.0000, 'ºC'),
	(42621, 110, '2015-02-01 00:48:53.000000', 'temperatura', 361.0000, 'ºC'),
	(42622, 110, '2015-02-01 00:48:54.000000', 'temperatura', 827.0000, 'ºC'),
	(42623, 110, '2015-02-01 00:48:55.000000', 'temperatura', 655.0000, 'ºC'),
	(42624, 110, '2015-02-01 00:48:56.000000', 'temperatura', 794.0000, 'ºC'),
	(42625, 110, '2015-02-01 00:48:57.000000', 'temperatura', 807.0000, 'ºC'),
	(42626, 110, '2015-02-01 00:48:58.000000', 'temperatura', 453.0000, 'ºC'),
	(42627, 110, '2015-02-01 00:48:59.000000', 'temperatura', 1045.0000, 'ºC'),
	(42628, 110, '2015-02-01 00:49:00.000000', 'temperatura', 265.0000, 'ºC'),
	(42629, 110, '2015-02-01 00:49:01.000000', 'temperatura', 591.0000, 'ºC'),
	(42630, 110, '2015-02-01 00:49:02.000000', 'temperatura', 962.0000, 'ºC'),
	(42631, 110, '2015-02-01 00:49:03.000000', 'temperatura', 637.0000, 'ºC'),
	(42632, 110, '2015-02-01 00:49:04.000000', 'temperatura', 297.0000, 'ºC'),
	(42633, 110, '2015-02-01 00:49:05.000000', 'temperatura', 778.0000, 'ºC'),
	(42634, 110, '2015-02-01 00:49:06.000000', 'temperatura', 598.0000, 'ºC'),
	(42635, 110, '2015-02-01 00:49:07.000000', 'temperatura', 655.0000, 'ºC'),
	(42636, 110, '2015-02-01 00:49:08.000000', 'temperatura', 283.0000, 'ºC'),
	(42637, 110, '2015-02-01 00:49:09.000000', 'temperatura', 650.0000, 'ºC'),
	(42638, 110, '2015-02-01 00:49:10.000000', 'temperatura', 3.0000, 'ºC'),
	(42639, 110, '2015-02-01 00:49:11.000000', 'temperatura', 465.0000, 'ºC'),
	(42640, 110, '2015-02-01 00:49:12.000000', 'temperatura', 1115.0000, 'ºC'),
	(42641, 110, '2015-02-01 00:49:13.000000', 'temperatura', 581.0000, 'ºC'),
	(42642, 110, '2015-02-01 00:49:14.000000', 'temperatura', 760.0000, 'ºC'),
	(42643, 110, '2015-02-01 00:49:15.000000', 'temperatura', 857.0000, 'ºC'),
	(42644, 110, '2015-02-01 00:49:16.000000', 'temperatura', 808.0000, 'ºC'),
	(42645, 110, '2015-02-01 00:49:17.000000', 'temperatura', 267.0000, 'ºC'),
	(42646, 110, '2015-02-01 00:49:18.000000', 'temperatura', 113.0000, 'ºC'),
	(42647, 110, '2015-02-01 00:49:19.000000', 'temperatura', 963.0000, 'ºC'),
	(42648, 110, '2015-02-01 00:49:20.000000', 'temperatura', 876.0000, 'ºC'),
	(42649, 110, '2015-02-01 00:49:21.000000', 'temperatura', 292.0000, 'ºC'),
	(42650, 110, '2015-02-01 00:49:22.000000', 'temperatura', 33.0000, 'ºC'),
	(42651, 110, '2015-02-01 00:49:23.000000', 'temperatura', 491.0000, 'ºC'),
	(42652, 110, '2015-02-01 00:49:24.000000', 'temperatura', 1156.0000, 'ºC'),
	(42653, 110, '2015-02-01 00:49:25.000000', 'temperatura', 708.0000, 'ºC'),
	(42654, 110, '2015-02-01 00:49:26.000000', 'temperatura', 74.0000, 'ºC'),
	(42655, 110, '2015-02-01 00:49:27.000000', 'temperatura', 643.0000, 'ºC'),
	(42656, 110, '2015-02-01 00:49:28.000000', 'temperatura', 595.0000, 'ºC'),
	(42657, 110, '2015-02-01 00:49:29.000000', 'temperatura', 1046.0000, 'ºC'),
	(42658, 110, '2015-02-01 00:49:30.000000', 'temperatura', 1046.0000, 'ºC'),
	(42659, 110, '2015-02-01 00:49:31.000000', 'temperatura', 891.0000, 'ºC'),
	(42660, 110, '2015-02-01 00:49:32.000000', 'temperatura', 118.0000, 'ºC'),
	(42661, 110, '2015-02-01 00:49:33.000000', 'temperatura', 319.0000, 'ºC'),
	(42662, 110, '2015-02-01 00:49:34.000000', 'temperatura', 40.0000, 'ºC'),
	(42663, 110, '2015-02-01 00:49:35.000000', 'temperatura', 443.0000, 'ºC'),
	(42664, 110, '2015-02-01 00:49:36.000000', 'temperatura', 896.0000, 'ºC'),
	(42665, 110, '2015-02-01 00:49:37.000000', 'temperatura', 754.0000, 'ºC'),
	(42666, 110, '2015-02-01 00:49:38.000000', 'temperatura', 1080.0000, 'ºC'),
	(42667, 110, '2015-02-01 00:49:39.000000', 'temperatura', 738.0000, 'ºC'),
	(42668, 110, '2015-02-01 00:49:40.000000', 'temperatura', 452.0000, 'ºC'),
	(42669, 110, '2015-02-01 00:49:41.000000', 'temperatura', 44.0000, 'ºC'),
	(42670, 110, '2015-02-01 00:49:42.000000', 'temperatura', 65.0000, 'ºC'),
	(42671, 110, '2015-02-01 00:49:43.000000', 'temperatura', 196.0000, 'ºC'),
	(42672, 110, '2015-02-01 00:49:44.000000', 'temperatura', 785.0000, 'ºC'),
	(42673, 110, '2015-02-01 00:49:45.000000', 'temperatura', 937.0000, 'ºC'),
	(42674, 110, '2015-02-01 00:49:46.000000', 'temperatura', 1129.0000, 'ºC'),
	(42675, 110, '2015-02-01 00:49:47.000000', 'temperatura', 435.0000, 'ºC'),
	(42676, 110, '2015-02-01 00:49:48.000000', 'temperatura', 1189.0000, 'ºC'),
	(42677, 110, '2015-02-01 00:49:49.000000', 'temperatura', 1042.0000, 'ºC'),
	(42678, 110, '2015-02-01 00:49:50.000000', 'temperatura', 443.0000, 'ºC'),
	(42679, 110, '2015-02-01 00:49:51.000000', 'temperatura', 289.0000, 'ºC'),
	(42680, 110, '2015-02-01 00:49:52.000000', 'temperatura', 118.0000, 'ºC'),
	(42681, 110, '2015-02-01 00:49:53.000000', 'temperatura', 921.0000, 'ºC'),
	(42682, 110, '2015-02-01 00:49:54.000000', 'temperatura', 653.0000, 'ºC'),
	(42683, 110, '2015-02-01 00:49:55.000000', 'temperatura', 501.0000, 'ºC'),
	(42684, 110, '2015-02-01 00:49:56.000000', 'temperatura', 549.0000, 'ºC'),
	(42685, 110, '2015-02-01 00:49:57.000000', 'temperatura', 40.0000, 'ºC'),
	(42686, 110, '2015-02-01 00:49:58.000000', 'temperatura', 952.0000, 'ºC'),
	(42687, 110, '2015-02-01 00:49:59.000000', 'temperatura', 1044.0000, 'ºC'),
	(42688, 110, '2015-02-01 00:50:00.000000', 'temperatura', 1162.0000, 'ºC'),
	(42689, 110, '2015-02-01 00:50:01.000000', 'temperatura', 281.0000, 'ºC'),
	(42690, 110, '2015-02-01 00:50:02.000000', 'temperatura', 319.0000, 'ºC'),
	(42691, 110, '2015-02-01 00:50:03.000000', 'temperatura', 751.0000, 'ºC'),
	(42692, 110, '2015-02-01 00:50:04.000000', 'temperatura', 397.0000, 'ºC'),
	(42693, 110, '2015-02-01 00:50:05.000000', 'temperatura', 935.0000, 'ºC'),
	(42694, 110, '2015-02-01 00:50:06.000000', 'temperatura', 1084.0000, 'ºC'),
	(42695, 110, '2015-02-01 00:50:07.000000', 'temperatura', 215.0000, 'ºC'),
	(42696, 110, '2015-02-01 00:50:08.000000', 'temperatura', 222.0000, 'ºC'),
	(42697, 110, '2015-02-01 00:50:09.000000', 'temperatura', 469.0000, 'ºC'),
	(42698, 110, '2015-02-01 00:50:10.000000', 'temperatura', 477.0000, 'ºC'),
	(42699, 110, '2015-02-01 00:50:11.000000', 'temperatura', 981.0000, 'ºC'),
	(42700, 110, '2015-02-01 00:50:12.000000', 'temperatura', 1073.0000, 'ºC'),
	(42701, 110, '2015-02-01 00:50:13.000000', 'temperatura', 23.0000, 'ºC'),
	(42702, 110, '2015-02-01 00:50:14.000000', 'temperatura', 496.0000, 'ºC'),
	(42703, 110, '2015-02-01 00:50:15.000000', 'temperatura', 12.0000, 'ºC'),
	(42704, 110, '2015-02-01 00:50:16.000000', 'temperatura', 971.0000, 'ºC'),
	(42705, 110, '2015-02-01 00:50:17.000000', 'temperatura', 22.0000, 'ºC'),
	(42706, 110, '2015-02-01 00:50:18.000000', 'temperatura', 795.0000, 'ºC'),
	(42707, 110, '2015-02-01 00:50:19.000000', 'temperatura', 310.0000, 'ºC'),
	(42708, 110, '2015-02-01 00:50:20.000000', 'temperatura', 368.0000, 'ºC'),
	(42709, 110, '2015-02-01 00:50:21.000000', 'temperatura', 909.0000, 'ºC'),
	(42710, 110, '2015-02-01 00:50:22.000000', 'temperatura', 1039.0000, 'ºC'),
	(42711, 110, '2015-02-01 00:50:23.000000', 'temperatura', 72.0000, 'ºC'),
	(42712, 110, '2015-02-01 00:50:24.000000', 'temperatura', 843.0000, 'ºC'),
	(42713, 110, '2015-02-01 00:50:25.000000', 'temperatura', 400.0000, 'ºC'),
	(42714, 110, '2015-02-01 00:50:26.000000', 'temperatura', 669.0000, 'ºC'),
	(42715, 110, '2015-02-01 00:50:27.000000', 'temperatura', 945.0000, 'ºC'),
	(42716, 110, '2015-02-01 00:50:28.000000', 'temperatura', 322.0000, 'ºC'),
	(42717, 110, '2015-02-01 00:50:29.000000', 'temperatura', 1173.0000, 'ºC'),
	(42718, 110, '2015-02-01 00:50:30.000000', 'temperatura', 98.0000, 'ºC'),
	(42719, 110, '2015-02-01 00:50:31.000000', 'temperatura', 575.0000, 'ºC'),
	(42720, 110, '2015-02-01 00:50:32.000000', 'temperatura', 179.0000, 'ºC'),
	(42721, 110, '2015-02-01 00:50:33.000000', 'temperatura', 373.0000, 'ºC'),
	(42722, 110, '2015-02-01 00:50:34.000000', 'temperatura', 125.0000, 'ºC'),
	(42723, 110, '2015-02-01 00:50:35.000000', 'temperatura', 709.0000, 'ºC'),
	(42724, 110, '2015-02-01 00:50:36.000000', 'temperatura', 770.0000, 'ºC'),
	(42725, 110, '2015-02-01 00:50:37.000000', 'temperatura', 523.0000, 'ºC'),
	(42726, 110, '2015-02-01 00:50:38.000000', 'temperatura', 308.0000, 'ºC'),
	(42727, 110, '2015-02-01 00:50:39.000000', 'temperatura', 1169.0000, 'ºC'),
	(42728, 110, '2015-02-01 00:50:40.000000', 'temperatura', 122.0000, 'ºC'),
	(42729, 110, '2015-02-01 00:50:41.000000', 'temperatura', 702.0000, 'ºC'),
	(42730, 110, '2015-02-01 00:50:42.000000', 'temperatura', 748.0000, 'ºC'),
	(42731, 110, '2015-02-01 00:50:43.000000', 'temperatura', 431.0000, 'ºC'),
	(42732, 110, '2015-02-01 00:50:44.000000', 'temperatura', 1112.0000, 'ºC'),
	(42733, 110, '2015-02-01 00:50:45.000000', 'temperatura', 670.0000, 'ºC'),
	(42734, 110, '2015-02-01 00:50:46.000000', 'temperatura', 14.0000, 'ºC'),
	(42735, 110, '2015-02-01 00:50:47.000000', 'temperatura', 459.0000, 'ºC'),
	(42736, 110, '2015-02-01 00:50:48.000000', 'temperatura', 1055.0000, 'ºC'),
	(42737, 110, '2015-02-01 00:50:49.000000', 'temperatura', 300.0000, 'ºC'),
	(42738, 110, '2015-02-01 00:50:50.000000', 'temperatura', 732.0000, 'ºC'),
	(42739, 110, '2015-02-01 00:50:51.000000', 'temperatura', 363.0000, 'ºC'),
	(42740, 110, '2015-02-01 00:50:52.000000', 'temperatura', 818.0000, 'ºC'),
	(42741, 110, '2015-02-01 00:50:53.000000', 'temperatura', 600.0000, 'ºC'),
	(42742, 110, '2015-02-01 00:50:54.000000', 'temperatura', 548.0000, 'ºC'),
	(42743, 110, '2015-02-01 00:50:55.000000', 'temperatura', 940.0000, 'ºC'),
	(42744, 110, '2015-02-01 00:50:56.000000', 'temperatura', 659.0000, 'ºC'),
	(42745, 110, '2015-02-01 00:50:57.000000', 'temperatura', 473.0000, 'ºC'),
	(42746, 110, '2015-02-01 00:50:58.000000', 'temperatura', 388.0000, 'ºC'),
	(42747, 110, '2015-02-01 00:50:59.000000', 'temperatura', 520.0000, 'ºC'),
	(42748, 110, '2015-02-01 00:51:00.000000', 'temperatura', 239.0000, 'ºC'),
	(42749, 110, '2015-02-01 00:51:01.000000', 'temperatura', 834.0000, 'ºC'),
	(42750, 110, '2015-02-01 00:51:02.000000', 'temperatura', 1056.0000, 'ºC'),
	(42751, 110, '2015-02-01 00:51:03.000000', 'temperatura', 377.0000, 'ºC'),
	(42752, 110, '2015-02-01 00:51:04.000000', 'temperatura', 1117.0000, 'ºC'),
	(42753, 110, '2015-02-01 00:51:05.000000', 'temperatura', 857.0000, 'ºC'),
	(42754, 110, '2015-02-01 00:51:06.000000', 'temperatura', 933.0000, 'ºC'),
	(42755, 110, '2015-02-01 00:51:07.000000', 'temperatura', 894.0000, 'ºC'),
	(42756, 110, '2015-02-01 00:51:08.000000', 'temperatura', 473.0000, 'ºC'),
	(42757, 110, '2015-02-01 00:51:09.000000', 'temperatura', 883.0000, 'ºC'),
	(42758, 110, '2015-02-01 00:51:10.000000', 'temperatura', 595.0000, 'ºC'),
	(42759, 110, '2015-02-01 00:51:11.000000', 'temperatura', 328.0000, 'ºC'),
	(42760, 110, '2015-02-01 00:51:12.000000', 'temperatura', 1057.0000, 'ºC'),
	(42761, 110, '2015-02-01 00:51:13.000000', 'temperatura', 700.0000, 'ºC'),
	(42762, 110, '2015-02-01 00:51:14.000000', 'temperatura', 330.0000, 'ºC'),
	(42763, 110, '2015-02-01 00:51:15.000000', 'temperatura', 748.0000, 'ºC'),
	(42764, 110, '2015-02-01 00:51:16.000000', 'temperatura', 354.0000, 'ºC'),
	(42765, 110, '2015-02-01 00:51:17.000000', 'temperatura', 724.0000, 'ºC'),
	(42766, 110, '2015-02-01 00:51:18.000000', 'temperatura', 157.0000, 'ºC'),
	(42767, 110, '2015-02-01 00:51:19.000000', 'temperatura', 1016.0000, 'ºC'),
	(42768, 110, '2015-02-01 00:51:20.000000', 'temperatura', 1010.0000, 'ºC'),
	(42769, 110, '2015-02-01 00:51:21.000000', 'temperatura', 803.0000, 'ºC'),
	(42770, 110, '2015-02-01 00:51:22.000000', 'temperatura', 984.0000, 'ºC'),
	(42771, 110, '2015-02-01 00:51:23.000000', 'temperatura', 113.0000, 'ºC'),
	(42772, 110, '2015-02-01 00:51:24.000000', 'temperatura', 13.0000, 'ºC'),
	(42773, 110, '2015-02-01 00:51:25.000000', 'temperatura', 925.0000, 'ºC'),
	(42774, 110, '2015-02-01 00:51:26.000000', 'temperatura', 986.0000, 'ºC'),
	(42775, 110, '2015-02-01 00:51:27.000000', 'temperatura', 955.0000, 'ºC'),
	(42776, 110, '2015-02-01 00:51:28.000000', 'temperatura', 618.0000, 'ºC'),
	(42777, 110, '2015-02-01 00:51:29.000000', 'temperatura', 224.0000, 'ºC'),
	(42778, 110, '2015-02-01 00:51:30.000000', 'temperatura', 469.0000, 'ºC'),
	(42779, 110, '2015-02-01 00:51:31.000000', 'temperatura', 472.0000, 'ºC'),
	(42780, 110, '2015-02-01 00:51:32.000000', 'temperatura', 954.0000, 'ºC'),
	(42781, 110, '2015-02-01 00:51:33.000000', 'temperatura', 956.0000, 'ºC'),
	(42782, 110, '2015-02-01 00:51:34.000000', 'temperatura', 718.0000, 'ºC'),
	(42783, 110, '2015-02-01 00:51:35.000000', 'temperatura', 723.0000, 'ºC'),
	(42784, 110, '2015-02-01 00:51:36.000000', 'temperatura', 261.0000, 'ºC'),
	(42785, 110, '2015-02-01 00:51:37.000000', 'temperatura', 338.0000, 'ºC'),
	(42786, 110, '2015-02-01 00:51:38.000000', 'temperatura', 905.0000, 'ºC'),
	(42787, 110, '2015-02-01 00:51:39.000000', 'temperatura', 1111.0000, 'ºC'),
	(42788, 110, '2015-02-01 00:51:40.000000', 'temperatura', 440.0000, 'ºC'),
	(42789, 110, '2015-02-01 00:51:41.000000', 'temperatura', 71.0000, 'ºC'),
	(42790, 110, '2015-02-01 00:51:42.000000', 'temperatura', 232.0000, 'ºC'),
	(42791, 110, '2015-02-01 00:51:43.000000', 'temperatura', 951.0000, 'ºC'),
	(42792, 110, '2015-02-01 00:51:44.000000', 'temperatura', 457.0000, 'ºC'),
	(42793, 110, '2015-02-01 00:51:45.000000', 'temperatura', 631.0000, 'ºC'),
	(42794, 110, '2015-02-01 00:51:46.000000', 'temperatura', 587.0000, 'ºC'),
	(42795, 110, '2015-02-01 00:51:47.000000', 'temperatura', 1041.0000, 'ºC'),
	(42796, 110, '2015-02-01 00:51:48.000000', 'temperatura', 1045.0000, 'ºC'),
	(42797, 110, '2015-02-01 00:51:49.000000', 'temperatura', 902.0000, 'ºC'),
	(42798, 110, '2015-02-01 00:51:50.000000', 'temperatura', 176.0000, 'ºC'),
	(42799, 110, '2015-02-01 00:51:51.000000', 'temperatura', 575.0000, 'ºC'),
	(42800, 110, '2015-02-01 00:51:52.000000', 'temperatura', 1145.0000, 'ºC'),
	(42801, 110, '2015-02-01 00:51:53.000000', 'temperatura', 403.0000, 'ºC'),
	(42802, 110, '2015-02-01 00:51:54.000000', 'temperatura', 978.0000, 'ºC'),
	(42803, 110, '2015-02-01 00:51:55.000000', 'temperatura', 82.0000, 'ºC'),
	(42804, 110, '2015-02-01 00:51:56.000000', 'temperatura', 1076.0000, 'ºC'),
	(42805, 110, '2015-02-01 00:51:57.000000', 'temperatura', 337.0000, 'ºC'),
	(42806, 110, '2015-02-01 00:51:58.000000', 'temperatura', 857.0000, 'ºC'),
	(42807, 110, '2015-02-01 00:51:59.000000', 'temperatura', 872.0000, 'ºC'),
	(42808, 110, '2015-02-01 00:52:00.000000', 'temperatura', 593.0000, 'ºC'),
	(42809, 110, '2015-02-01 00:52:01.000000', 'temperatura', 347.0000, 'ºC'),
	(42810, 110, '2015-02-01 00:52:02.000000', 'temperatura', 1159.0000, 'ºC'),
	(42811, 110, '2015-02-01 00:52:03.000000', 'temperatura', 1152.0000, 'ºC'),
	(42812, 110, '2015-02-01 00:52:04.000000', 'temperatura', 1085.0000, 'ºC'),
	(42813, 110, '2015-02-01 00:52:05.000000', 'temperatura', 771.0000, 'ºC'),
	(42814, 110, '2015-02-01 00:52:06.000000', 'temperatura', 600.0000, 'ºC'),
	(42815, 110, '2015-02-01 00:52:07.000000', 'temperatura', 687.0000, 'ºC'),
	(42816, 110, '2015-02-01 00:52:08.000000', 'temperatura', 436.0000, 'ºC'),
	(42817, 110, '2015-02-01 00:52:09.000000', 'temperatura', 117.0000, 'ºC'),
	(42818, 110, '2015-02-01 00:52:10.000000', 'temperatura', 479.0000, 'ºC'),
	(42819, 110, '2015-02-01 00:52:11.000000', 'temperatura', 844.0000, 'ºC'),
	(42820, 110, '2015-02-01 00:52:12.000000', 'temperatura', 386.0000, 'ºC'),
	(42821, 110, '2015-02-01 00:52:13.000000', 'temperatura', 597.0000, 'ºC'),
	(42822, 110, '2015-02-01 00:52:14.000000', 'temperatura', 627.0000, 'ºC'),
	(42823, 110, '2015-02-01 00:52:15.000000', 'temperatura', 145.0000, 'ºC'),
	(42824, 110, '2015-02-01 00:52:16.000000', 'temperatura', 43.0000, 'ºC'),
	(42825, 110, '2015-02-01 00:52:17.000000', 'temperatura', 983.0000, 'ºC'),
	(42826, 110, '2015-02-01 00:52:18.000000', 'temperatura', 1184.0000, 'ºC'),
	(42827, 110, '2015-02-01 00:52:19.000000', 'temperatura', 573.0000, 'ºC'),
	(42828, 110, '2015-02-01 00:52:20.000000', 'temperatura', 514.0000, 'ºC'),
	(42829, 110, '2015-02-01 00:52:21.000000', 'temperatura', 853.0000, 'ºC'),
	(42830, 110, '2015-02-01 00:52:22.000000', 'temperatura', 321.0000, 'ºC'),
	(42831, 110, '2015-02-01 00:52:23.000000', 'temperatura', 248.0000, 'ºC'),
	(42832, 110, '2015-02-01 00:52:24.000000', 'temperatura', 275.0000, 'ºC'),
	(42833, 110, '2015-02-01 00:52:25.000000', 'temperatura', 635.0000, 'ºC'),
	(42834, 110, '2015-02-01 00:52:26.000000', 'temperatura', 1149.0000, 'ºC'),
	(42835, 110, '2015-02-01 00:52:27.000000', 'temperatura', 239.0000, 'ºC'),
	(42836, 110, '2015-02-01 00:52:28.000000', 'temperatura', 152.0000, 'ºC'),
	(42837, 110, '2015-02-01 00:52:29.000000', 'temperatura', 40.0000, 'ºC'),
	(42838, 110, '2015-02-01 00:52:30.000000', 'temperatura', 945.0000, 'ºC'),
	(42839, 110, '2015-02-01 00:52:31.000000', 'temperatura', 1008.0000, 'ºC'),
	(42840, 110, '2015-02-01 00:52:32.000000', 'temperatura', 1004.0000, 'ºC'),
	(42841, 110, '2015-02-01 00:52:33.000000', 'temperatura', 798.0000, 'ºC'),
	(42842, 110, '2015-02-01 00:52:34.000000', 'temperatura', 977.0000, 'ºC'),
	(42843, 110, '2015-02-01 00:52:35.000000', 'temperatura', 92.0000, 'ºC'),
	(42844, 110, '2015-02-01 00:52:36.000000', 'temperatura', 1131.0000, 'ºC'),
	(42845, 110, '2015-02-01 00:52:37.000000', 'temperatura', 578.0000, 'ºC'),
	(42846, 110, '2015-02-01 00:52:38.000000', 'temperatura', 696.0000, 'ºC'),
	(42847, 110, '2015-02-01 00:52:39.000000', 'temperatura', 549.0000, 'ºC'),
	(42848, 110, '2015-02-01 00:52:40.000000', 'temperatura', 659.0000, 'ºC'),
	(42849, 110, '2015-02-01 00:52:41.000000', 'temperatura', 446.0000, 'ºC'),
	(42850, 110, '2015-02-01 00:52:42.000000', 'temperatura', 253.0000, 'ºC'),
	(42851, 110, '2015-02-01 00:52:43.000000', 'temperatura', 1130.0000, 'ºC'),
	(42852, 110, '2015-02-01 00:52:44.000000', 'temperatura', 88.0000, 'ºC'),
	(42853, 110, '2015-02-01 00:52:45.000000', 'temperatura', 654.0000, 'ºC'),
	(42854, 110, '2015-02-01 00:52:46.000000', 'temperatura', 606.0000, 'ºC'),
	(42855, 110, '2015-02-01 00:52:47.000000', 'temperatura', 1066.0000, 'ºC'),
	(42856, 110, '2015-02-01 00:52:48.000000', 'temperatura', 1114.0000, 'ºC'),
	(42857, 110, '2015-02-01 00:52:49.000000', 'temperatura', 1171.0000, 'ºC'),
	(42858, 110, '2015-02-01 00:52:50.000000', 'temperatura', 114.0000, 'ºC'),
	(42859, 110, '2015-02-01 00:52:51.000000', 'temperatura', 658.0000, 'ºC'),
	(42860, 110, '2015-02-01 00:52:52.000000', 'temperatura', 549.0000, 'ºC'),
	(42861, 110, '2015-02-01 00:52:53.000000', 'temperatura', 771.0000, 'ºC'),
	(42862, 110, '2015-02-01 00:52:54.000000', 'temperatura', 1010.0000, 'ºC'),
	(42863, 110, '2015-02-01 00:52:55.000000', 'temperatura', 336.0000, 'ºC'),
	(42864, 110, '2015-02-01 00:52:56.000000', 'temperatura', 1052.0000, 'ºC'),
	(42865, 110, '2015-02-01 00:52:57.000000', 'temperatura', 651.0000, 'ºC'),
	(42866, 110, '2015-02-01 00:52:58.000000', 'temperatura', 98.0000, 'ºC'),
	(42867, 110, '2015-02-01 00:52:59.000000', 'temperatura', 939.0000, 'ºC'),
	(42868, 110, '2015-02-01 00:53:00.000000', 'temperatura', 802.0000, 'ºC'),
	(42869, 110, '2015-02-01 00:53:01.000000', 'temperatura', 1192.0000, 'ºC'),
	(42870, 110, '2015-02-01 00:53:02.000000', 'temperatura', 1156.0000, 'ºC'),
	(42871, 110, '2015-02-01 00:53:03.000000', 'temperatura', 1005.0000, 'ºC'),
	(42872, 110, '2015-02-01 00:53:04.000000', 'temperatura', 358.0000, 'ºC'),
	(42873, 110, '2015-02-01 00:53:05.000000', 'temperatura', 1173.0000, 'ºC'),
	(42874, 110, '2015-02-01 00:53:06.000000', 'temperatura', 1191.0000, 'ºC'),
	(42875, 110, '2015-02-01 00:53:07.000000', 'temperatura', 39.0000, 'ºC'),
	(42876, 110, '2015-02-01 00:53:08.000000', 'temperatura', 222.0000, 'ºC'),
	(42877, 110, '2015-02-01 00:53:09.000000', 'temperatura', 995.0000, 'ºC'),
	(42878, 110, '2015-02-01 00:53:10.000000', 'temperatura', 707.0000, 'ºC'),
	(42879, 110, '2015-02-01 00:53:11.000000', 'temperatura', 552.0000, 'ºC'),
	(42880, 110, '2015-02-01 00:53:12.000000', 'temperatura', 640.0000, 'ºC'),
	(42881, 110, '2015-02-01 00:53:13.000000', 'temperatura', 342.0000, 'ºC'),
	(42882, 110, '2015-02-01 00:53:14.000000', 'temperatura', 993.0000, 'ºC'),
	(42883, 110, '2015-02-01 00:53:15.000000', 'temperatura', 339.0000, 'ºC'),
	(42884, 110, '2015-02-01 00:53:16.000000', 'temperatura', 1117.0000, 'ºC'),
	(42885, 110, '2015-02-01 00:53:17.000000', 'temperatura', 969.0000, 'ºC'),
	(42886, 110, '2015-02-01 00:53:18.000000', 'temperatura', 295.0000, 'ºC'),
	(42887, 110, '2015-02-01 00:53:19.000000', 'temperatura', 968.0000, 'ºC'),
	(42888, 110, '2015-02-01 00:53:20.000000', 'temperatura', 355.0000, 'ºC'),
	(42889, 110, '2015-02-01 00:53:21.000000', 'temperatura', 70.0000, 'ºC'),
	(42890, 110, '2015-02-01 00:53:22.000000', 'temperatura', 488.0000, 'ºC'),
	(42891, 110, '2015-02-01 00:53:23.000000', 'temperatura', 1031.0000, 'ºC'),
	(42892, 110, '2015-02-01 00:53:24.000000', 'temperatura', 91.0000, 'ºC'),
	(42893, 110, '2015-02-01 00:53:25.000000', 'temperatura', 963.0000, 'ºC'),
	(42894, 110, '2015-02-01 00:53:26.000000', 'temperatura', 940.0000, 'ºC'),
	(42895, 110, '2015-02-01 00:53:27.000000', 'temperatura', 613.0000, 'ºC'),
	(42896, 110, '2015-02-01 00:53:28.000000', 'temperatura', 246.0000, 'ºC'),
	(42897, 110, '2015-02-01 00:53:29.000000', 'temperatura', 593.0000, 'ºC'),
	(42898, 110, '2015-02-01 00:53:30.000000', 'temperatura', 1026.0000, 'ºC'),
	(42899, 110, '2015-02-01 00:53:31.000000', 'temperatura', 954.0000, 'ºC'),
	(42900, 110, '2015-02-01 00:53:32.000000', 'temperatura', 489.0000, 'ºC'),
	(42901, 110, '2015-02-01 00:53:33.000000', 'temperatura', 786.0000, 'ºC'),
	(42902, 110, '2015-02-01 00:53:34.000000', 'temperatura', 62.0000, 'ºC'),
	(42903, 110, '2015-02-01 00:53:35.000000', 'temperatura', 353.0000, 'ºC'),
	(42904, 110, '2015-02-01 00:53:36.000000', 'temperatura', 381.0000, 'ºC'),
	(42905, 110, '2015-02-01 00:53:37.000000', 'temperatura', 843.0000, 'ºC'),
	(42906, 110, '2015-02-01 00:53:38.000000', 'temperatura', 676.0000, 'ºC'),
	(42907, 110, '2015-02-01 00:53:39.000000', 'temperatura', 850.0000, 'ºC'),
	(42908, 110, '2015-02-01 00:53:40.000000', 'temperatura', 1025.0000, 'ºC'),
	(42909, 110, '2015-02-01 00:53:41.000000', 'temperatura', 172.0000, 'ºC'),
	(42910, 110, '2015-02-01 00:53:42.000000', 'temperatura', 187.0000, 'ºC'),
	(42911, 110, '2015-02-01 00:53:43.000000', 'temperatura', 421.0000, 'ºC'),
	(42912, 110, '2015-02-01 00:53:44.000000', 'temperatura', 343.0000, 'ºC'),
	(42913, 110, '2015-02-01 00:53:45.000000', 'temperatura', 454.0000, 'ºC'),
	(42914, 110, '2015-02-01 00:53:46.000000', 'temperatura', 40.0000, 'ºC'),
	(42915, 110, '2015-02-01 00:53:47.000000', 'temperatura', 39.0000, 'ºC'),
	(42916, 110, '2015-02-01 00:53:48.000000', 'temperatura', 75.0000, 'ºC'),
	(42917, 110, '2015-02-01 00:53:49.000000', 'temperatura', 258.0000, 'ºC'),
	(42918, 110, '2015-02-01 00:53:50.000000', 'temperatura', 1066.0000, 'ºC'),
	(42919, 110, '2015-02-01 00:53:51.000000', 'temperatura', 958.0000, 'ºC'),
	(42920, 110, '2015-02-01 00:53:52.000000', 'temperatura', 390.0000, 'ºC'),
	(42921, 110, '2015-02-01 00:53:53.000000', 'temperatura', 277.0000, 'ºC'),
	(42922, 110, '2015-02-01 00:53:54.000000', 'temperatura', 216.0000, 'ºC'),
	(42923, 110, '2015-02-01 00:53:55.000000', 'temperatura', 248.0000, 'ºC'),
	(42924, 110, '2015-02-01 00:53:56.000000', 'temperatura', 594.0000, 'ºC'),
	(42925, 110, '2015-02-01 00:53:57.000000', 'temperatura', 1026.0000, 'ºC'),
	(42926, 110, '2015-02-01 00:53:58.000000', 'temperatura', 949.0000, 'ºC'),
	(42927, 110, '2015-02-01 00:53:59.000000', 'temperatura', 467.0000, 'ºC'),
	(42928, 110, '2015-02-01 00:54:00.000000', 'temperatura', 690.0000, 'ºC'),
	(42929, 110, '2015-02-01 00:54:01.000000', 'temperatura', 847.0000, 'ºC'),
	(42930, 110, '2015-02-01 00:54:02.000000', 'temperatura', 967.0000, 'ºC'),
	(42931, 110, '2015-02-01 00:54:03.000000', 'temperatura', 1095.0000, 'ºC'),
	(42932, 110, '2015-02-01 00:54:04.000000', 'temperatura', 176.0000, 'ºC'),
	(42933, 110, '2015-02-01 00:54:05.000000', 'temperatura', 1192.0000, 'ºC'),
	(42934, 110, '2015-02-01 00:54:06.000000', 'temperatura', 634.0000, 'ºC'),
	(42935, 110, '2015-02-01 00:54:07.000000', 'temperatura', 793.0000, 'ºC'),
	(42936, 110, '2015-02-01 00:54:08.000000', 'temperatura', 864.0000, 'ºC'),
	(42937, 110, '2015-02-01 00:54:09.000000', 'temperatura', 744.0000, 'ºC'),
	(42938, 110, '2015-02-01 00:54:10.000000', 'temperatura', 1127.0000, 'ºC'),
	(42939, 110, '2015-02-01 00:54:11.000000', 'temperatura', 1001.0000, 'ºC'),
	(42940, 110, '2015-02-01 00:54:12.000000', 'temperatura', 428.0000, 'ºC'),
	(42941, 110, '2015-02-01 00:54:13.000000', 'temperatura', 336.0000, 'ºC'),
	(42942, 110, '2015-02-01 00:54:14.000000', 'temperatura', 398.0000, 'ºC'),
	(42943, 110, '2015-02-01 00:54:15.000000', 'temperatura', 980.0000, 'ºC'),
	(42944, 110, '2015-02-01 00:54:16.000000', 'temperatura', 106.0000, 'ºC'),
	(42945, 110, '2015-02-01 00:54:17.000000', 'temperatura', 1191.0000, 'ºC'),
	(42946, 110, '2015-02-01 00:54:18.000000', 'temperatura', 840.0000, 'ºC'),
	(42947, 110, '2015-02-01 00:54:19.000000', 'temperatura', 626.0000, 'ºC'),
	(42948, 110, '2015-02-01 00:54:20.000000', 'temperatura', 612.0000, 'ºC'),
	(42949, 110, '2015-02-01 00:54:21.000000', 'temperatura', 1183.0000, 'ºC'),
	(42950, 110, '2015-02-01 00:54:22.000000', 'temperatura', 477.0000, 'ºC'),
	(42951, 110, '2015-02-01 00:54:23.000000', 'temperatura', 37.0000, 'ºC'),
	(42952, 110, '2015-02-01 00:54:24.000000', 'temperatura', 1156.0000, 'ºC'),
	(42953, 110, '2015-02-01 00:54:25.000000', 'temperatura', 867.0000, 'ºC'),
	(42954, 110, '2015-02-01 00:54:26.000000', 'temperatura', 869.0000, 'ºC'),
	(42955, 110, '2015-02-01 00:54:27.000000', 'temperatura', 546.0000, 'ºC'),
	(42956, 110, '2015-02-01 00:54:28.000000', 'temperatura', 122.0000, 'ºC'),
	(42957, 110, '2015-02-01 00:54:29.000000', 'temperatura', 173.0000, 'ºC'),
	(42958, 110, '2015-02-01 00:54:30.000000', 'temperatura', 500.0000, 'ºC'),
	(42959, 110, '2015-02-01 00:54:31.000000', 'temperatura', 779.0000, 'ºC'),
	(42960, 110, '2015-02-01 00:54:32.000000', 'temperatura', 1198.0000, 'ºC'),
	(42961, 110, '2015-02-01 00:54:33.000000', 'temperatura', 52.0000, 'ºC'),
	(42962, 110, '2015-02-01 00:54:34.000000', 'temperatura', 269.0000, 'ºC'),
	(42963, 110, '2015-02-01 00:54:35.000000', 'temperatura', 1188.0000, 'ºC'),
	(42964, 110, '2015-02-01 00:54:36.000000', 'temperatura', 332.0000, 'ºC'),
	(42965, 110, '2015-02-01 00:54:37.000000', 'temperatura', 499.0000, 'ºC'),
	(42966, 110, '2015-02-01 00:54:38.000000', 'temperatura', 299.0000, 'ºC'),
	(42967, 110, '2015-02-01 00:54:39.000000', 'temperatura', 1196.0000, 'ºC'),
	(42968, 110, '2015-02-01 00:54:40.000000', 'temperatura', 286.0000, 'ºC'),
	(42969, 110, '2015-02-01 00:54:41.000000', 'temperatura', 242.0000, 'ºC'),
	(42970, 110, '2015-02-01 00:54:42.000000', 'temperatura', 351.0000, 'ºC'),
	(42971, 110, '2015-02-01 00:54:43.000000', 'temperatura', 1031.0000, 'ºC'),
	(42972, 110, '2015-02-01 00:54:44.000000', 'temperatura', 500.0000, 'ºC'),
	(42973, 110, '2015-02-01 00:54:45.000000', 'temperatura', 610.0000, 'ºC'),
	(42974, 110, '2015-02-01 00:54:46.000000', 'temperatura', 348.0000, 'ºC'),
	(42975, 110, '2015-02-01 00:54:47.000000', 'temperatura', 1113.0000, 'ºC'),
	(42976, 110, '2015-02-01 00:54:48.000000', 'temperatura', 918.0000, 'ºC'),
	(42977, 110, '2015-02-01 00:54:49.000000', 'temperatura', 55.0000, 'ºC'),
	(42978, 110, '2015-02-01 00:54:50.000000', 'temperatura', 1122.0000, 'ºC'),
	(42979, 110, '2015-02-01 00:54:51.000000', 'temperatura', 645.0000, 'ºC'),
	(42980, 110, '2015-02-01 00:54:52.000000', 'temperatura', 1060.0000, 'ºC'),
	(42981, 110, '2015-02-01 00:54:53.000000', 'temperatura', 966.0000, 'ºC'),
	(42982, 110, '2015-02-01 00:54:54.000000', 'temperatura', 449.0000, 'ºC'),
	(42983, 110, '2015-02-01 00:54:55.000000', 'temperatura', 549.0000, 'ºC'),
	(42984, 110, '2015-02-01 00:54:56.000000', 'temperatura', 199.0000, 'ºC'),
	(42985, 110, '2015-02-01 00:54:57.000000', 'temperatura', 550.0000, 'ºC'),
	(42986, 110, '2015-02-01 00:54:58.000000', 'temperatura', 951.0000, 'ºC'),
	(42987, 110, '2015-02-01 00:54:59.000000', 'temperatura', 706.0000, 'ºC'),
	(42988, 110, '2015-02-01 00:55:00.000000', 'temperatura', 676.0000, 'ºC'),
	(42989, 110, '2015-02-01 00:55:01.000000', 'temperatura', 65.0000, 'ºC'),
	(42990, 110, '2015-02-01 00:55:02.000000', 'temperatura', 698.0000, 'ºC'),
	(42991, 110, '2015-02-01 00:55:03.000000', 'temperatura', 895.0000, 'ºC'),
	(42992, 110, '2015-02-01 00:55:04.000000', 'temperatura', 1180.0000, 'ºC'),
	(42993, 110, '2015-02-01 00:55:05.000000', 'temperatura', 816.0000, 'ºC'),
	(42994, 110, '2015-02-01 00:55:06.000000', 'temperatura', 540.0000, 'ºC'),
	(42995, 110, '2015-02-01 00:55:07.000000', 'temperatura', 252.0000, 'ºC'),
	(42996, 110, '2015-02-01 00:55:08.000000', 'temperatura', 843.0000, 'ºC'),
	(42997, 110, '2015-02-01 00:55:09.000000', 'temperatura', 1058.0000, 'ºC'),
	(42998, 110, '2015-02-01 00:55:10.000000', 'temperatura', 361.0000, 'ºC'),
	(42999, 110, '2015-02-01 00:55:11.000000', 'temperatura', 1031.0000, 'ºC'),
	(43000, 110, '2015-02-01 00:55:12.000000', 'temperatura', 473.0000, 'ºC'),
	(43001, 110, '2015-02-01 00:55:13.000000', 'temperatura', 474.0000, 'ºC'),
	(43002, 110, '2015-02-01 00:55:14.000000', 'temperatura', 949.0000, 'ºC'),
	(43003, 110, '2015-02-01 00:55:15.000000', 'temperatura', 926.0000, 'ºC'),
	(43004, 110, '2015-02-01 00:55:16.000000', 'temperatura', 584.0000, 'ºC'),
	(43005, 110, '2015-02-01 00:55:17.000000', 'temperatura', 143.0000, 'ºC'),
	(43006, 110, '2015-02-01 00:55:18.000000', 'temperatura', 163.0000, 'ºC'),
	(43007, 110, '2015-02-01 00:55:19.000000', 'temperatura', 386.0000, 'ºC'),
	(43008, 110, '2015-02-01 00:55:20.000000', 'temperatura', 241.0000, 'ºC'),
	(43009, 110, '2015-02-01 00:55:21.000000', 'temperatura', 46.0000, 'ºC'),
	(43010, 110, '2015-02-01 00:55:22.000000', 'temperatura', 708.0000, 'ºC'),
	(43011, 110, '2015-02-01 00:55:23.000000', 'temperatura', 1004.0000, 'ºC'),
	(43012, 110, '2015-02-01 00:55:24.000000', 'temperatura', 494.0000, 'ºC'),
	(43013, 110, '2015-02-01 00:55:25.000000', 'temperatura', 659.0000, 'ºC'),
	(43014, 110, '2015-02-01 00:55:26.000000', 'temperatura', 613.0000, 'ºC'),
	(43015, 110, '2015-02-01 00:55:27.000000', 'temperatura', 1088.0000, 'ºC'),
	(43016, 110, '2015-02-01 00:55:28.000000', 'temperatura', 1.0000, 'ºC'),
	(43017, 110, '2015-02-01 00:55:29.000000', 'temperatura', 341.0000, 'ºC'),
	(43018, 110, '2015-02-01 00:55:30.000000', 'temperatura', 503.0000, 'ºC'),
	(43019, 110, '2015-02-01 00:55:31.000000', 'temperatura', 291.0000, 'ºC'),
	(43020, 110, '2015-02-01 00:55:32.000000', 'temperatura', 1147.0000, 'ºC'),
	(43021, 110, '2015-02-01 00:55:33.000000', 'temperatura', 62.0000, 'ºC'),
	(43022, 110, '2015-02-01 00:55:34.000000', 'temperatura', 472.0000, 'ºC'),
	(43023, 110, '2015-02-01 00:55:35.000000', 'temperatura', 973.0000, 'ºC'),
	(43024, 110, '2015-02-01 00:55:36.000000', 'temperatura', 1050.0000, 'ºC'),
	(43025, 110, '2015-02-01 00:55:37.000000', 'temperatura', 1130.0000, 'ºC'),
	(43026, 110, '2015-02-01 00:55:38.000000', 'temperatura', 99.0000, 'ºC'),
	(43027, 110, '2015-02-01 00:55:39.000000', 'temperatura', 708.0000, 'ºC'),
	(43028, 110, '2015-02-01 00:55:40.000000', 'temperatura', 845.0000, 'ºC'),
	(43029, 110, '2015-02-01 00:55:41.000000', 'temperatura', 898.0000, 'ºC'),
	(43030, 110, '2015-02-01 00:55:42.000000', 'temperatura', 757.0000, 'ºC'),
	(43031, 110, '2015-02-01 00:55:43.000000', 'temperatura', 1092.0000, 'ºC'),
	(43032, 110, '2015-02-01 00:55:44.000000', 'temperatura', 788.0000, 'ºC'),
	(43033, 110, '2015-02-01 00:55:45.000000', 'temperatura', 667.0000, 'ºC'),
	(43034, 110, '2015-02-01 00:55:46.000000', 'temperatura', 971.0000, 'ºC'),
	(43035, 110, '2015-02-01 00:55:47.000000', 'temperatura', 456.0000, 'ºC'),
	(43036, 110, '2015-02-01 00:55:48.000000', 'temperatura', 565.0000, 'ºC'),
	(43037, 110, '2015-02-01 00:55:49.000000', 'temperatura', 257.0000, 'ºC'),
	(43038, 110, '2015-02-01 00:55:50.000000', 'temperatura', 790.0000, 'ºC'),
	(43039, 110, '2015-02-01 00:55:51.000000', 'temperatura', 781.0000, 'ºC'),
	(43040, 110, '2015-02-01 00:55:52.000000', 'temperatura', 333.0000, 'ºC'),
	(43041, 110, '2015-02-01 00:55:53.000000', 'temperatura', 525.0000, 'ºC'),
	(43042, 110, '2015-02-01 00:55:54.000000', 'temperatura', 426.0000, 'ºC'),
	(43043, 110, '2015-02-01 00:55:55.000000', 'temperatura', 554.0000, 'ºC'),
	(43044, 110, '2015-02-01 00:55:56.000000', 'temperatura', 295.0000, 'ºC'),
	(43045, 110, '2015-02-01 00:55:57.000000', 'temperatura', 1014.0000, 'ºC'),
	(43046, 110, '2015-02-01 00:55:58.000000', 'temperatura', 585.0000, 'ºC'),
	(43047, 110, '2015-02-01 00:55:59.000000', 'temperatura', 1083.0000, 'ºC'),
	(43048, 110, '2015-02-01 00:56:00.000000', 'temperatura', 61.0000, 'ºC'),
	(43049, 110, '2015-02-01 00:56:01.000000', 'temperatura', 658.0000, 'ºC'),
	(43050, 110, '2015-02-01 00:56:02.000000', 'temperatura', 704.0000, 'ºC'),
	(43051, 110, '2015-02-01 00:56:03.000000', 'temperatura', 349.0000, 'ºC'),
	(43052, 110, '2015-02-01 00:56:04.000000', 'temperatura', 831.0000, 'ºC'),
	(43053, 110, '2015-02-01 00:56:05.000000', 'temperatura', 710.0000, 'ºC'),
	(43054, 110, '2015-02-01 00:56:06.000000', 'temperatura', 1058.0000, 'ºC'),
	(43055, 110, '2015-02-01 00:56:07.000000', 'temperatura', 761.0000, 'ºC'),
	(43056, 110, '2015-02-01 00:56:08.000000', 'temperatura', 632.0000, 'ºC'),
	(43057, 110, '2015-02-01 00:56:09.000000', 'temperatura', 876.0000, 'ºC'),
	(43058, 110, '2015-02-01 00:56:10.000000', 'temperatura', 86.0000, 'ºC'),
	(43059, 110, '2015-02-01 00:56:11.000000', 'temperatura', 203.0000, 'ºC'),
	(43060, 110, '2015-02-01 00:56:12.000000', 'temperatura', 756.0000, 'ºC'),
	(43061, 110, '2015-02-01 00:56:13.000000', 'temperatura', 773.0000, 'ºC'),
	(43062, 110, '2015-02-01 00:56:14.000000', 'temperatura', 398.0000, 'ºC'),
	(43063, 110, '2015-02-01 00:56:15.000000', 'temperatura', 873.0000, 'ºC'),
	(43064, 110, '2015-02-01 00:56:16.000000', 'temperatura', 768.0000, 'ºC'),
	(43065, 110, '2015-02-01 00:56:17.000000', 'temperatura', 23.0000, 'ºC'),
	(43066, 110, '2015-02-01 00:56:18.000000', 'temperatura', 213.0000, 'ºC'),
	(43067, 110, '2015-02-01 00:56:19.000000', 'temperatura', 994.0000, 'ºC'),
	(43068, 110, '2015-02-01 00:56:20.000000', 'temperatura', 731.0000, 'ºC'),
	(43069, 110, '2015-02-01 00:56:21.000000', 'temperatura', 675.0000, 'ºC'),
	(43070, 110, '2015-02-01 00:56:22.000000', 'temperatura', 1181.0000, 'ºC'),
	(43071, 110, '2015-02-01 00:56:23.000000', 'temperatura', 279.0000, 'ºC'),
	(43072, 110, '2015-02-01 00:56:24.000000', 'temperatura', 255.0000, 'ºC'),
	(43073, 110, '2015-02-01 00:56:25.000000', 'temperatura', 439.0000, 'ºC'),
	(43074, 110, '2015-02-01 00:56:26.000000', 'temperatura', 229.0000, 'ºC'),
	(43075, 110, '2015-02-01 00:56:27.000000', 'temperatura', 1027.0000, 'ºC'),
	(43076, 110, '2015-02-01 00:56:28.000000', 'temperatura', 850.0000, 'ºC'),
	(43077, 110, '2015-02-01 00:56:29.000000', 'temperatura', 1170.0000, 'ºC'),
	(43078, 110, '2015-02-01 00:56:30.000000', 'temperatura', 899.0000, 'ºC'),
	(43079, 110, '2015-02-01 00:56:31.000000', 'temperatura', 987.0000, 'ºC'),
	(43080, 110, '2015-02-01 00:56:32.000000', 'temperatura', 1037.0000, 'ºC'),
	(43081, 110, '2015-02-01 00:56:33.000000', 'temperatura', 1024.0000, 'ºC'),
	(43082, 110, '2015-02-01 00:56:34.000000', 'temperatura', 811.0000, 'ºC'),
	(43083, 110, '2015-02-01 00:56:35.000000', 'temperatura', 983.0000, 'ºC'),
	(43084, 110, '2015-02-01 00:56:36.000000', 'temperatura', 83.0000, 'ºC'),
	(43085, 110, '2015-02-01 00:56:37.000000', 'temperatura', 1066.0000, 'ºC'),
	(43086, 110, '2015-02-01 00:56:38.000000', 'temperatura', 281.0000, 'ºC'),
	(43087, 110, '2015-02-01 00:56:39.000000', 'temperatura', 607.0000, 'ºC'),
	(43088, 110, '2015-02-01 00:56:40.000000', 'temperatura', 995.0000, 'ºC'),
	(43089, 110, '2015-02-01 00:56:41.000000', 'temperatura', 751.0000, 'ºC'),
	(43090, 110, '2015-02-01 00:56:42.000000', 'temperatura', 773.0000, 'ºC'),
	(43091, 110, '2015-02-01 00:56:43.000000', 'temperatura', 412.0000, 'ºC'),
	(43092, 110, '2015-02-01 00:56:44.000000', 'temperatura', 940.0000, 'ºC'),
	(43093, 110, '2015-02-01 00:56:45.000000', 'temperatura', 1067.0000, 'ºC'),
	(43094, 110, '2015-02-01 00:56:46.000000', 'temperatura', 115.0000, 'ºC'),
	(43095, 110, '2015-02-01 00:56:47.000000', 'temperatura', 976.0000, 'ºC'),
	(43096, 110, '2015-02-01 00:56:48.000000', 'temperatura', 933.0000, 'ºC'),
	(43097, 110, '2015-02-01 00:56:49.000000', 'temperatura', 539.0000, 'ºC'),
	(43098, 110, '2015-02-01 00:56:50.000000', 'temperatura', 1095.0000, 'ºC'),
	(43099, 110, '2015-02-01 00:56:51.000000', 'temperatura', 259.0000, 'ºC'),
	(43100, 110, '2015-02-01 00:56:52.000000', 'temperatura', 413.0000, 'ºC'),
	(43101, 110, '2015-02-01 00:56:53.000000', 'temperatura', 86.0000, 'ºC'),
	(43102, 110, '2015-02-01 00:56:54.000000', 'temperatura', 392.0000, 'ºC'),
	(43103, 110, '2015-02-01 00:56:55.000000', 'temperatura', 503.0000, 'ºC'),
	(43104, 110, '2015-02-01 00:56:56.000000', 'temperatura', 138.0000, 'ºC'),
	(43105, 110, '2015-02-01 00:56:57.000000', 'temperatura', 384.0000, 'ºC'),
	(43106, 110, '2015-02-01 00:56:58.000000', 'temperatura', 307.0000, 'ºC'),
	(43107, 110, '2015-02-01 00:56:59.000000', 'temperatura', 383.0000, 'ºC'),
	(43108, 110, '2015-02-01 00:57:00.000000', 'temperatura', 994.0000, 'ºC'),
	(43109, 110, '2015-02-01 00:57:01.000000', 'temperatura', 223.0000, 'ºC'),
	(43110, 110, '2015-02-01 00:57:02.000000', 'temperatura', 533.0000, 'ºC'),
	(43111, 110, '2015-02-01 00:57:03.000000', 'temperatura', 794.0000, 'ºC'),
	(43112, 110, '2015-02-01 00:57:04.000000', 'temperatura', 1174.0000, 'ºC'),
	(43113, 110, '2015-02-01 00:57:05.000000', 'temperatura', 1089.0000, 'ºC'),
	(43114, 110, '2015-02-01 00:57:06.000000', 'temperatura', 725.0000, 'ºC'),
	(43115, 110, '2015-02-01 00:57:07.000000', 'temperatura', 355.0000, 'ºC'),
	(43116, 110, '2015-02-01 00:57:08.000000', 'temperatura', 803.0000, 'ºC'),
	(43117, 110, '2015-02-01 00:57:09.000000', 'temperatura', 548.0000, 'ºC'),
	(43118, 110, '2015-02-01 00:57:10.000000', 'temperatura', 334.0000, 'ºC'),
	(43119, 110, '2015-02-01 00:57:11.000000', 'temperatura', 26.0000, 'ºC'),
	(43120, 110, '2015-02-01 00:57:12.000000', 'temperatura', 328.0000, 'ºC'),
	(43121, 110, '2015-02-01 00:57:13.000000', 'temperatura', 363.0000, 'ºC'),
	(43122, 110, '2015-02-01 00:57:14.000000', 'temperatura', 832.0000, 'ºC'),
	(43123, 110, '2015-02-01 00:57:15.000000', 'temperatura', 671.0000, 'ºC'),
	(43124, 110, '2015-02-01 00:57:16.000000', 'temperatura', 859.0000, 'ºC'),
	(43125, 110, '2015-02-01 00:57:17.000000', 'temperatura', 1082.0000, 'ºC'),
	(43126, 110, '2015-02-01 00:57:18.000000', 'temperatura', 435.0000, 'ºC'),
	(43127, 110, '2015-02-01 00:57:19.000000', 'temperatura', 128.0000, 'ºC'),
	(43128, 110, '2015-02-01 00:57:20.000000', 'temperatura', 534.0000, 'ºC'),
	(43129, 110, '2015-02-01 00:57:21.000000', 'temperatura', 1088.0000, 'ºC'),
	(43130, 110, '2015-02-01 00:57:22.000000', 'temperatura', 240.0000, 'ºC'),
	(43131, 110, '2015-02-01 00:57:23.000000', 'temperatura', 337.0000, 'ºC'),
	(43132, 110, '2015-02-01 00:57:24.000000', 'temperatura', 966.0000, 'ºC'),
	(43133, 110, '2015-02-01 00:57:25.000000', 'temperatura', 220.0000, 'ºC'),
	(43134, 110, '2015-02-01 00:57:26.000000', 'temperatura', 601.0000, 'ºC'),
	(43135, 110, '2015-02-01 00:57:27.000000', 'temperatura', 1147.0000, 'ºC'),
	(43136, 110, '2015-02-01 00:57:28.000000', 'temperatura', 332.0000, 'ºC'),
	(43137, 110, '2015-02-01 00:57:29.000000', 'temperatura', 617.0000, 'ºC'),
	(43138, 110, '2015-02-01 00:57:30.000000', 'temperatura', 893.0000, 'ºC'),
	(43139, 110, '2015-02-01 00:57:31.000000', 'temperatura', 211.0000, 'ºC'),
	(43140, 110, '2015-02-01 00:57:32.000000', 'temperatura', 779.0000, 'ºC'),
	(43141, 110, '2015-02-01 00:57:33.000000', 'temperatura', 862.0000, 'ºC'),
	(43142, 110, '2015-02-01 00:57:34.000000', 'temperatura', 772.0000, 'ºC'),
	(43143, 110, '2015-02-01 00:57:35.000000', 'temperatura', 76.0000, 'ºC'),
	(43144, 110, '2015-02-01 00:57:36.000000', 'temperatura', 463.0000, 'ºC'),
	(43145, 110, '2015-02-01 00:57:37.000000', 'temperatura', 889.0000, 'ºC'),
	(43146, 110, '2015-02-01 00:57:38.000000', 'temperatura', 657.0000, 'ºC'),
	(43147, 110, '2015-02-01 00:57:39.000000', 'temperatura', 619.0000, 'ºC'),
	(43148, 110, '2015-02-01 00:57:40.000000', 'temperatura', 1122.0000, 'ºC'),
	(43149, 110, '2015-02-01 00:57:41.000000', 'temperatura', 155.0000, 'ºC'),
	(43150, 110, '2015-02-01 00:57:42.000000', 'temperatura', 1007.0000, 'ºC'),
	(43151, 110, '2015-02-01 00:57:43.000000', 'temperatura', 973.0000, 'ºC'),
	(43152, 110, '2015-02-01 00:57:44.000000', 'temperatura', 642.0000, 'ºC'),
	(43153, 110, '2015-02-01 00:57:45.000000', 'temperatura', 294.0000, 'ºC'),
	(43154, 110, '2015-02-01 00:57:46.000000', 'temperatura', 743.0000, 'ºC'),
	(43155, 110, '2015-02-01 00:57:47.000000', 'temperatura', 435.0000, 'ºC'),
	(43156, 110, '2015-02-01 00:57:48.000000', 'temperatura', 1145.0000, 'ºC'),
	(43157, 110, '2015-02-01 00:57:49.000000', 'temperatura', 821.0000, 'ºC'),
	(43158, 110, '2015-02-01 00:57:50.000000', 'temperatura', 672.0000, 'ºC'),
	(43159, 110, '2015-02-01 00:57:51.000000', 'temperatura', 897.0000, 'ºC'),
	(43160, 110, '2015-02-01 00:57:52.000000', 'temperatura', 68.0000, 'ºC'),
	(43161, 110, '2015-02-01 00:57:53.000000', 'temperatura', 52.0000, 'ºC'),
	(43162, 110, '2015-02-01 00:57:54.000000', 'temperatura', 57.0000, 'ºC'),
	(43163, 110, '2015-02-01 00:57:55.000000', 'temperatura', 126.0000, 'ºC'),
	(43164, 110, '2015-02-01 00:57:56.000000', 'temperatura', 463.0000, 'ºC'),
	(43165, 110, '2015-02-01 00:57:57.000000', 'temperatura', 737.0000, 'ºC'),
	(43166, 110, '2015-02-01 00:57:58.000000', 'temperatura', 1094.0000, 'ºC'),
	(43167, 110, '2015-02-01 00:57:59.000000', 'temperatura', 860.0000, 'ºC'),
	(43168, 110, '2015-02-01 00:58:00.000000', 'temperatura', 1019.0000, 'ºC'),
	(43169, 110, '2015-02-01 00:58:01.000000', 'temperatura', 115.0000, 'ºC'),
	(43170, 110, '2015-02-01 00:58:02.000000', 'temperatura', 1117.0000, 'ºC'),
	(43171, 110, '2015-02-01 00:58:03.000000', 'temperatura', 443.0000, 'ºC'),
	(43172, 110, '2015-02-01 00:58:04.000000', 'temperatura', 63.0000, 'ºC'),
	(43173, 110, '2015-02-01 00:58:05.000000', 'temperatura', 185.0000, 'ºC'),
	(43174, 110, '2015-02-01 00:58:06.000000', 'temperatura', 739.0000, 'ºC'),
	(43175, 110, '2015-02-01 00:58:07.000000', 'temperatura', 742.0000, 'ºC'),
	(43176, 110, '2015-02-01 00:58:08.000000', 'temperatura', 291.0000, 'ºC'),
	(43177, 110, '2015-02-01 00:58:09.000000', 'temperatura', 430.0000, 'ºC'),
	(43178, 110, '2015-02-01 00:58:10.000000', 'temperatura', 78.0000, 'ºC'),
	(43179, 110, '2015-02-01 00:58:11.000000', 'temperatura', 300.0000, 'ºC'),
	(43180, 110, '2015-02-01 00:58:12.000000', 'temperatura', 68.0000, 'ºC'),
	(43181, 110, '2015-02-01 00:58:13.000000', 'temperatura', 639.0000, 'ºC'),
	(43182, 110, '2015-02-01 00:58:14.000000', 'temperatura', 592.0000, 'ºC'),
	(43183, 110, '2015-02-01 00:58:15.000000', 'temperatura', 1042.0000, 'ºC'),
	(43184, 110, '2015-02-01 00:58:16.000000', 'temperatura', 1034.0000, 'ºC'),
	(43185, 110, '2015-02-01 00:58:17.000000', 'temperatura', 848.0000, 'ºC'),
	(43186, 110, '2015-02-01 00:58:18.000000', 'temperatura', 1135.0000, 'ºC'),
	(43187, 110, '2015-02-01 00:58:19.000000', 'temperatura', 733.0000, 'ºC'),
	(43188, 110, '2015-02-01 00:58:20.000000', 'temperatura', 258.0000, 'ºC'),
	(43189, 110, '2015-02-01 00:58:21.000000', 'temperatura', 294.0000, 'ºC'),
	(43190, 110, '2015-02-01 00:58:22.000000', 'temperatura', 698.0000, 'ºC'),
	(43191, 110, '2015-02-01 00:58:23.000000', 'temperatura', 206.0000, 'ºC'),
	(43192, 110, '2015-02-01 00:58:24.000000', 'temperatura', 137.0000, 'ºC'),
	(43193, 110, '2015-02-01 00:58:25.000000', 'temperatura', 69.0000, 'ºC'),
	(43194, 110, '2015-02-01 00:58:26.000000', 'temperatura', 1134.0000, 'ºC'),
	(43195, 110, '2015-02-01 00:58:27.000000', 'temperatura', 664.0000, 'ºC'),
	(43196, 110, '2015-02-01 00:58:28.000000', 'temperatura', 1119.0000, 'ºC'),
	(43197, 110, '2015-02-01 00:58:29.000000', 'temperatura', 2.0000, 'ºC'),
	(43198, 110, '2015-02-01 00:58:30.000000', 'temperatura', 253.0000, 'ºC'),
	(43199, 110, '2015-02-01 00:58:31.000000', 'temperatura', 60.0000, 'ºC'),
	(43200, 110, '2015-02-01 00:58:32.000000', 'temperatura', 742.0000, 'ºC'),
	(43201, 110, '2015-02-01 00:58:33.000000', 'temperatura', 1130.0000, 'ºC'),
	(43202, 110, '2015-02-01 00:58:34.000000', 'temperatura', 1024.0000, 'ºC'),
	(43203, 110, '2015-02-01 00:58:35.000000', 'temperatura', 532.0000, 'ºC'),
	(43204, 110, '2015-02-01 00:58:36.000000', 'temperatura', 787.0000, 'ºC'),
	(43205, 110, '2015-02-01 00:58:37.000000', 'temperatura', 1139.0000, 'ºC'),
	(43206, 110, '2015-02-01 00:58:38.000000', 'temperatura', 934.0000, 'ºC'),
	(43207, 110, '2015-02-01 00:58:39.000000', 'temperatura', 53.0000, 'ºC'),
	(43208, 110, '2015-02-01 00:58:40.000000', 'temperatura', 1065.0000, 'ºC'),
	(43209, 110, '2015-02-01 00:58:41.000000', 'temperatura', 367.0000, 'ºC'),
	(43210, 110, '2015-02-01 00:58:42.000000', 'temperatura', 1042.0000, 'ºC'),
	(43211, 110, '2015-02-01 00:58:43.000000', 'temperatura', 508.0000, 'ºC'),
	(43212, 110, '2015-02-01 00:58:44.000000', 'temperatura', 614.0000, 'ºC'),
	(43213, 110, '2015-02-01 00:58:45.000000', 'temperatura', 347.0000, 'ºC'),
	(43214, 110, '2015-02-01 00:58:46.000000', 'temperatura', 1095.0000, 'ºC'),
	(43215, 110, '2015-02-01 00:58:47.000000', 'temperatura', 834.0000, 'ºC'),
	(43216, 110, '2015-02-01 00:58:48.000000', 'temperatura', 886.0000, 'ºC'),
	(43217, 110, '2015-02-01 00:58:49.000000', 'temperatura', 730.0000, 'ºC'),
	(43218, 110, '2015-02-01 00:58:50.000000', 'temperatura', 989.0000, 'ºC'),
	(43219, 110, '2015-02-01 00:58:51.000000', 'temperatura', 358.0000, 'ºC'),
	(43220, 110, '2015-02-01 00:58:52.000000', 'temperatura', 22.0000, 'ºC'),
	(43221, 110, '2015-02-01 00:58:53.000000', 'temperatura', 236.0000, 'ºC'),
	(43222, 110, '2015-02-01 00:58:54.000000', 'temperatura', 1115.0000, 'ºC'),
	(43223, 110, '2015-02-01 00:58:55.000000', 'temperatura', 69.0000, 'ºC'),
	(43224, 110, '2015-02-01 00:58:56.000000', 'temperatura', 599.0000, 'ºC'),
	(43225, 110, '2015-02-01 00:58:57.000000', 'temperatura', 388.0000, 'ºC'),
	(43226, 110, '2015-02-01 00:58:58.000000', 'temperatura', 143.0000, 'ºC'),
	(43227, 110, '2015-02-01 00:58:59.000000', 'temperatura', 751.0000, 'ºC'),
	(43228, 110, '2015-02-01 00:59:00.000000', 'temperatura', 925.0000, 'ºC'),
	(43229, 110, '2015-02-01 00:59:01.000000', 'temperatura', 1176.0000, 'ºC'),
	(43230, 110, '2015-02-01 00:59:02.000000', 'temperatura', 705.0000, 'ºC'),
	(43231, 110, '2015-02-01 00:59:03.000000', 'temperatura', 1196.0000, 'ºC'),
	(43232, 110, '2015-02-01 00:59:04.000000', 'temperatura', 266.0000, 'ºC'),
	(43233, 110, '2015-02-01 00:59:05.000000', 'temperatura', 145.0000, 'ºC'),
	(43234, 110, '2015-02-01 00:59:06.000000', 'temperatura', 1124.0000, 'ºC'),
	(43235, 111, '2015-02-01 00:00:00.000000', 'temperatura', 967.0000, 'ºC'),
	(43236, 111, '2015-02-01 00:00:01.000000', 'temperatura', 74.0000, 'ºC'),
	(43237, 111, '2015-02-01 00:00:02.000000', 'temperatura', 1068.0000, 'ºC'),
	(43238, 111, '2015-02-01 00:00:03.000000', 'temperatura', 319.0000, 'ºC'),
	(43239, 111, '2015-02-01 00:00:04.000000', 'temperatura', 793.0000, 'ºC'),
	(43240, 111, '2015-02-01 00:00:05.000000', 'temperatura', 607.0000, 'ºC'),
	(43241, 111, '2015-02-01 00:00:06.000000', 'temperatura', 659.0000, 'ºC'),
	(43242, 111, '2015-02-01 00:00:07.000000', 'temperatura', 271.0000, 'ºC'),
	(43243, 111, '2015-02-01 00:00:08.000000', 'temperatura', 580.0000, 'ºC'),
	(43244, 111, '2015-02-01 00:00:09.000000', 'temperatura', 889.0000, 'ºC'),
	(43245, 111, '2015-02-01 00:00:10.000000', 'temperatura', 304.0000, 'ºC'),
	(43246, 111, '2015-02-01 00:00:11.000000', 'temperatura', 53.0000, 'ºC'),
	(43247, 111, '2015-02-01 00:00:12.000000', 'temperatura', 555.0000, 'ºC'),
	(43248, 111, '2015-02-01 00:00:13.000000', 'temperatura', 214.0000, 'ºC'),
	(43249, 111, '2015-02-01 00:00:14.000000', 'temperatura', 609.0000, 'ºC'),
	(43250, 111, '2015-02-01 00:00:15.000000', 'temperatura', 2.0000, 'ºC'),
	(43251, 111, '2015-02-01 00:00:16.000000', 'temperatura', 582.0000, 'ºC'),
	(43252, 111, '2015-02-01 00:00:17.000000', 'temperatura', 503.0000, 'ºC'),
	(43253, 111, '2015-02-01 00:00:18.000000', 'temperatura', 773.0000, 'ºC'),
	(43254, 111, '2015-02-01 00:00:19.000000', 'temperatura', 1156.0000, 'ºC'),
	(43255, 111, '2015-02-01 00:00:20.000000', 'temperatura', 1059.0000, 'ºC'),
	(43256, 111, '2015-02-01 00:00:21.000000', 'temperatura', 630.0000, 'ºC'),
	(43257, 111, '2015-02-01 00:00:22.000000', 'temperatura', 1172.0000, 'ºC'),
	(43258, 111, '2015-02-01 00:00:23.000000', 'temperatura', 370.0000, 'ºC'),
	(43259, 111, '2015-02-01 00:00:24.000000', 'temperatura', 735.0000, 'ºC'),
	(43260, 111, '2015-02-01 00:00:25.000000', 'temperatura', 165.0000, 'ºC'),
	(43261, 111, '2015-02-01 00:00:26.000000', 'temperatura', 1021.0000, 'ºC'),
	(43262, 111, '2015-02-01 00:00:27.000000', 'temperatura', 1012.0000, 'ºC'),
	(43263, 111, '2015-02-01 00:00:28.000000', 'temperatura', 798.0000, 'ºC'),
	(43264, 111, '2015-02-01 00:00:29.000000', 'temperatura', 952.0000, 'ºC'),
	(43265, 111, '2015-02-01 00:00:30.000000', 'temperatura', 1168.0000, 'ºC'),
	(43266, 111, '2015-02-01 00:00:31.000000', 'temperatura', 583.0000, 'ºC'),
	(43267, 111, '2015-02-01 00:00:32.000000', 'temperatura', 612.0000, 'ºC'),
	(43268, 111, '2015-02-01 00:00:33.000000', 'temperatura', 110.0000, 'ºC'),
	(43269, 111, '2015-02-01 00:00:34.000000', 'temperatura', 1117.0000, 'ºC'),
	(43270, 111, '2015-02-01 00:00:35.000000', 'temperatura', 455.0000, 'ºC'),
	(43271, 111, '2015-02-01 00:00:36.000000', 'temperatura', 122.0000, 'ºC'),
	(43272, 111, '2015-02-01 00:00:37.000000', 'temperatura', 449.0000, 'ºC'),
	(43273, 111, '2015-02-01 00:00:38.000000', 'temperatura', 677.0000, 'ºC'),
	(43274, 111, '2015-02-01 00:00:39.000000', 'temperatura', 840.0000, 'ºC'),
	(43275, 111, '2015-02-01 00:00:40.000000', 'temperatura', 970.0000, 'ºC'),
	(43276, 111, '2015-02-01 00:00:41.000000', 'temperatura', 1130.0000, 'ºC'),
	(43277, 111, '2015-02-01 00:00:42.000000', 'temperatura', 340.0000, 'ºC'),
	(43278, 111, '2015-02-01 00:00:43.000000', 'temperatura', 713.0000, 'ºC'),
	(43279, 111, '2015-02-01 00:00:44.000000', 'temperatura', 143.0000, 'ºC'),
	(43280, 111, '2015-02-01 00:00:45.000000', 'temperatura', 979.0000, 'ºC'),
	(43281, 111, '2015-02-01 00:00:46.000000', 'temperatura', 866.0000, 'ºC'),
	(43282, 111, '2015-02-01 00:00:47.000000', 'temperatura', 194.0000, 'ºC'),
	(43283, 111, '2015-02-01 00:00:48.000000', 'temperatura', 771.0000, 'ºC'),
	(43284, 111, '2015-02-01 00:00:49.000000', 'temperatura', 874.0000, 'ºC'),
	(43285, 111, '2015-02-01 00:00:50.000000', 'temperatura', 858.0000, 'ºC'),
	(43286, 111, '2015-02-01 00:00:51.000000', 'temperatura', 468.0000, 'ºC'),
	(43287, 111, '2015-02-01 00:00:52.000000', 'temperatura', 966.0000, 'ºC'),
	(43288, 111, '2015-02-01 00:00:53.000000', 'temperatura', 1027.0000, 'ºC'),
	(43289, 111, '2015-02-01 00:00:54.000000', 'temperatura', 1037.0000, 'ºC'),
	(43290, 111, '2015-02-01 00:00:55.000000', 'temperatura', 905.0000, 'ºC'),
	(43291, 111, '2015-02-01 00:00:56.000000', 'temperatura', 214.0000, 'ºC'),
	(43292, 111, '2015-02-01 00:00:57.000000', 'temperatura', 757.0000, 'ºC'),
	(43293, 111, '2015-02-01 00:00:58.000000', 'temperatura', 741.0000, 'ºC'),
	(43294, 111, '2015-02-01 00:00:59.000000', 'temperatura', 237.0000, 'ºC'),
	(43295, 111, '2015-02-01 00:01:00.000000', 'temperatura', 161.0000, 'ºC'),
	(43296, 111, '2015-02-01 00:01:01.000000', 'temperatura', 96.0000, 'ºC'),
	(43297, 111, '2015-02-01 00:01:02.000000', 'temperatura', 1196.0000, 'ºC'),
	(43298, 111, '2015-02-01 00:01:03.000000', 'temperatura', 895.0000, 'ºC'),
	(43299, 111, '2015-02-01 00:01:04.000000', 'temperatura', 884.0000, 'ºC'),
	(43300, 111, '2015-02-01 00:01:05.000000', 'temperatura', 537.0000, 'ºC'),
	(43301, 111, '2015-02-01 00:01:06.000000', 'temperatura', 34.0000, 'ºC'),
	(43302, 111, '2015-02-01 00:01:07.000000', 'temperatura', 957.0000, 'ºC'),
	(43303, 111, '2015-02-01 00:01:08.000000', 'temperatura', 1086.0000, 'ºC'),
	(43304, 111, '2015-02-01 00:01:09.000000', 'temperatura', 158.0000, 'ºC'),
	(43305, 111, '2015-02-01 00:01:10.000000', 'temperatura', 1132.0000, 'ºC'),
	(43306, 111, '2015-02-01 00:01:11.000000', 'temperatura', 387.0000, 'ºC'),
	(43307, 111, '2015-02-01 00:01:12.000000', 'temperatura', 940.0000, 'ºC'),
	(43308, 111, '2015-02-01 00:01:13.000000', 'temperatura', 1141.0000, 'ºC'),
	(43309, 111, '2015-02-01 00:01:14.000000', 'temperatura', 485.0000, 'ºC'),
	(43310, 111, '2015-02-01 00:01:15.000000', 'temperatura', 203.0000, 'ºC'),
	(43311, 111, '2015-02-01 00:01:16.000000', 'temperatura', 758.0000, 'ºC'),
	(43312, 111, '2015-02-01 00:01:17.000000', 'temperatura', 782.0000, 'ºC'),
	(43313, 111, '2015-02-01 00:01:18.000000', 'temperatura', 436.0000, 'ºC'),
	(43314, 111, '2015-02-01 00:01:19.000000', 'temperatura', 1034.0000, 'ºC'),
	(43315, 111, '2015-02-01 00:01:20.000000', 'temperatura', 264.0000, 'ºC'),
	(43316, 111, '2015-02-01 00:01:21.000000', 'temperatura', 619.0000, 'ºC'),
	(43317, 111, '2015-02-01 00:01:22.000000', 'temperatura', 1101.0000, 'ºC'),
	(43318, 111, '2015-02-01 00:01:23.000000', 'temperatura', 51.0000, 'ºC'),
	(43319, 111, '2015-02-01 00:01:24.000000', 'temperatura', 550.0000, 'ºC'),
	(43320, 111, '2015-02-01 00:01:25.000000', 'temperatura', 198.0000, 'ºC'),
	(43321, 111, '2015-02-01 00:01:26.000000', 'temperatura', 543.0000, 'ºC'),
	(43322, 111, '2015-02-01 00:01:27.000000', 'temperatura', 919.0000, 'ºC'),
	(43323, 111, '2015-02-01 00:01:28.000000', 'temperatura', 568.0000, 'ºC'),
	(43324, 111, '2015-02-01 00:01:29.000000', 'temperatura', 84.0000, 'ºC'),
	(43325, 111, '2015-02-01 00:01:30.000000', 'temperatura', 1117.0000, 'ºC'),
	(43326, 111, '2015-02-01 00:01:31.000000', 'temperatura', 533.0000, 'ºC'),
	(43327, 111, '2015-02-01 00:01:32.000000', 'temperatura', 515.0000, 'ºC'),
	(43328, 111, '2015-02-01 00:01:33.000000', 'temperatura', 975.0000, 'ºC'),
	(43329, 111, '2015-02-01 00:01:34.000000', 'temperatura', 932.0000, 'ºC'),
	(43330, 111, '2015-02-01 00:01:35.000000', 'temperatura', 534.0000, 'ºC'),
	(43331, 111, '2015-02-01 00:01:36.000000', 'temperatura', 1074.0000, 'ºC'),
	(43332, 111, '2015-02-01 00:01:37.000000', 'temperatura', 171.0000, 'ºC'),
	(43333, 111, '2015-02-01 00:01:38.000000', 'temperatura', 31.0000, 'ºC'),
	(43334, 111, '2015-02-01 00:01:39.000000', 'temperatura', 841.0000, 'ºC'),
	(43335, 111, '2015-02-01 00:01:40.000000', 'temperatura', 516.0000, 'ºC'),
	(43336, 111, '2015-02-01 00:01:41.000000', 'temperatura', 56.0000, 'ºC'),
	(43337, 111, '2015-02-01 00:01:42.000000', 'temperatura', 1131.0000, 'ºC'),
	(43338, 111, '2015-02-01 00:01:43.000000', 'temperatura', 691.0000, 'ºC'),
	(43339, 111, '2015-02-01 00:01:44.000000', 'temperatura', 59.0000, 'ºC'),
	(43340, 111, '2015-02-01 00:01:45.000000', 'temperatura', 625.0000, 'ºC'),
	(43341, 111, '2015-02-01 00:01:46.000000', 'temperatura', 547.0000, 'ºC'),
	(43342, 111, '2015-02-01 00:01:47.000000', 'temperatura', 862.0000, 'ºC'),
	(43343, 111, '2015-02-01 00:01:48.000000', 'temperatura', 269.0000, 'ºC'),
	(43344, 111, '2015-02-01 00:01:49.000000', 'temperatura', 1161.0000, 'ºC'),
	(43345, 111, '2015-02-01 00:01:50.000000', 'temperatura', 197.0000, 'ºC'),
	(43346, 111, '2015-02-01 00:01:51.000000', 'temperatura', 1104.0000, 'ºC'),
	(43347, 111, '2015-02-01 00:01:52.000000', 'temperatura', 127.0000, 'ºC'),
	(43348, 111, '2015-02-01 00:01:53.000000', 'temperatura', 927.0000, 'ºC'),
	(43349, 111, '2015-02-01 00:01:54.000000', 'temperatura', 651.0000, 'ºC'),
	(43350, 111, '2015-02-01 00:01:55.000000', 'temperatura', 477.0000, 'ºC'),
	(43351, 111, '2015-02-01 00:01:56.000000', 'temperatura', 430.0000, 'ºC'),
	(43352, 111, '2015-02-01 00:01:57.000000', 'temperatura', 723.0000, 'ºC'),
	(43353, 111, '2015-02-01 00:01:58.000000', 'temperatura', 1123.0000, 'ºC'),
	(43354, 111, '2015-02-01 00:01:59.000000', 'temperatura', 1046.0000, 'ºC'),
	(43355, 111, '2015-02-01 00:02:00.000000', 'temperatura', 661.0000, 'ºC'),
	(43356, 111, '2015-02-01 00:02:01.000000', 'temperatura', 167.0000, 'ºC'),
	(43357, 111, '2015-02-01 00:02:02.000000', 'temperatura', 55.0000, 'ºC'),
	(43358, 111, '2015-02-01 00:02:03.000000', 'temperatura', 972.0000, 'ºC'),
	(43359, 111, '2015-02-01 00:02:04.000000', 'temperatura', 1095.0000, 'ºC'),
	(43360, 111, '2015-02-01 00:02:05.000000', 'temperatura', 161.0000, 'ºC'),
	(43361, 111, '2015-02-01 00:02:06.000000', 'temperatura', 1122.0000, 'ºC'),
	(43362, 111, '2015-02-01 00:02:07.000000', 'temperatura', 327.0000, 'ºC'),
	(43363, 111, '2015-02-01 00:02:08.000000', 'temperatura', 667.0000, 'ºC'),
	(43364, 111, '2015-02-01 00:02:09.000000', 'temperatura', 1156.0000, 'ºC'),
	(43365, 111, '2015-02-01 00:02:10.000000', 'temperatura', 182.0000, 'ºC'),
	(43366, 111, '2015-02-01 00:02:11.000000', 'temperatura', 1039.0000, 'ºC'),
	(43367, 111, '2015-02-01 00:02:12.000000', 'temperatura', 1050.0000, 'ºC'),
	(43368, 111, '2015-02-01 00:02:13.000000', 'temperatura', 932.0000, 'ºC'),
	(43369, 111, '2015-02-01 00:02:14.000000', 'temperatura', 313.0000, 'ºC'),
	(43370, 111, '2015-02-01 00:02:15.000000', 'temperatura', 1169.0000, 'ºC'),
	(43371, 111, '2015-02-01 00:02:16.000000', 'temperatura', 106.0000, 'ºC'),
	(43372, 111, '2015-02-01 00:02:17.000000', 'temperatura', 626.0000, 'ºC'),
	(43373, 111, '2015-02-01 00:02:18.000000', 'temperatura', 410.0000, 'ºC'),
	(43374, 111, '2015-02-01 00:02:19.000000', 'temperatura', 173.0000, 'ºC'),
	(43375, 111, '2015-02-01 00:02:20.000000', 'temperatura', 838.0000, 'ºC'),
	(43376, 111, '2015-02-01 00:02:21.000000', 'temperatura', 68.0000, 'ºC'),
	(43377, 111, '2015-02-01 00:02:22.000000', 'temperatura', 228.0000, 'ºC'),
	(43378, 111, '2015-02-01 00:02:23.000000', 'temperatura', 936.0000, 'ºC'),
	(43379, 111, '2015-02-01 00:02:24.000000', 'temperatura', 396.0000, 'ºC'),
	(43380, 111, '2015-02-01 00:02:25.000000', 'temperatura', 375.0000, 'ºC'),
	(43381, 111, '2015-02-01 00:02:26.000000', 'temperatura', 685.0000, 'ºC'),
	(43382, 111, '2015-02-01 00:02:27.000000', 'temperatura', 1101.0000, 'ºC'),
	(43383, 111, '2015-02-01 00:02:28.000000', 'temperatura', 1053.0000, 'ºC'),
	(43384, 111, '2015-02-01 00:02:29.000000', 'temperatura', 760.0000, 'ºC'),
	(43385, 111, '2015-02-01 00:02:30.000000', 'temperatura', 643.0000, 'ºC'),
	(43386, 111, '2015-02-01 00:02:31.000000', 'temperatura', 934.0000, 'ºC'),
	(43387, 111, '2015-02-01 00:02:32.000000', 'temperatura', 341.0000, 'ºC'),
	(43388, 111, '2015-02-01 00:02:33.000000', 'temperatura', 106.0000, 'ºC'),
	(43389, 111, '2015-02-01 00:02:34.000000', 'temperatura', 707.0000, 'ºC'),
	(43390, 111, '2015-02-01 00:02:35.000000', 'temperatura', 818.0000, 'ºC'),
	(43391, 111, '2015-02-01 00:02:36.000000', 'temperatura', 768.0000, 'ºC'),
	(43392, 111, '2015-02-01 00:02:37.000000', 'temperatura', 187.0000, 'ºC'),
	(43393, 111, '2015-02-01 00:02:38.000000', 'temperatura', 1030.0000, 'ºC'),
	(43394, 111, '2015-02-01 00:02:39.000000', 'temperatura', 991.0000, 'ºC'),
	(43395, 111, '2015-02-01 00:02:40.000000', 'temperatura', 663.0000, 'ºC'),
	(43396, 111, '2015-02-01 00:02:41.000000', 'temperatura', 345.0000, 'ºC'),
	(43397, 111, '2015-02-01 00:02:42.000000', 'temperatura', 935.0000, 'ºC'),
	(43398, 111, '2015-02-01 00:02:43.000000', 'temperatura', 43.0000, 'ºC'),
	(43399, 111, '2015-02-01 00:02:44.000000', 'temperatura', 1008.0000, 'ºC'),
	(43400, 111, '2015-02-01 00:02:45.000000', 'temperatura', 113.0000, 'ºC'),
	(43401, 111, '2015-02-01 00:02:46.000000', 'temperatura', 1141.0000, 'ºC'),
	(43402, 111, '2015-02-01 00:02:47.000000', 'temperatura', 568.0000, 'ºC'),
	(43403, 111, '2015-02-01 00:02:48.000000', 'temperatura', 616.0000, 'ºC'),
	(43404, 111, '2015-02-01 00:02:49.000000', 'temperatura', 176.0000, 'ºC'),
	(43405, 111, '2015-02-01 00:02:50.000000', 'temperatura', 232.0000, 'ºC'),
	(43406, 111, '2015-02-01 00:02:51.000000', 'temperatura', 634.0000, 'ºC'),
	(43407, 111, '2015-02-01 00:02:52.000000', 'temperatura', 75.0000, 'ºC'),
	(43408, 111, '2015-02-01 00:02:53.000000', 'temperatura', 873.0000, 'ºC'),
	(43409, 111, '2015-02-01 00:02:54.000000', 'temperatura', 539.0000, 'ºC'),
	(43410, 111, '2015-02-01 00:02:55.000000', 'temperatura', 76.0000, 'ºC'),
	(43411, 111, '2015-02-01 00:02:56.000000', 'temperatura', 1166.0000, 'ºC'),
	(43412, 111, '2015-02-01 00:02:57.000000', 'temperatura', 800.0000, 'ºC'),
	(43413, 111, '2015-02-01 00:02:58.000000', 'temperatura', 504.0000, 'ºC'),
	(43414, 111, '2015-02-01 00:02:59.000000', 'temperatura', 119.0000, 'ºC'),
	(43415, 111, '2015-02-01 00:03:00.000000', 'temperatura', 284.0000, 'ºC'),
	(43416, 111, '2015-02-01 00:03:01.000000', 'temperatura', 1063.0000, 'ºC'),
	(43417, 111, '2015-02-01 00:03:02.000000', 'temperatura', 862.0000, 'ºC'),
	(43418, 111, '2015-02-01 00:03:03.000000', 'temperatura', 1125.0000, 'ºC'),
	(43419, 111, '2015-02-01 00:03:04.000000', 'temperatura', 638.0000, 'ºC'),
	(43420, 111, '2015-02-01 00:03:05.000000', 'temperatura', 1014.0000, 'ºC'),
	(43421, 111, '2015-02-01 00:03:06.000000', 'temperatura', 756.0000, 'ºC'),
	(43422, 111, '2015-02-01 00:03:07.000000', 'temperatura', 741.0000, 'ºC'),
	(43423, 111, '2015-02-01 00:03:08.000000', 'temperatura', 237.0000, 'ºC'),
	(43424, 111, '2015-02-01 00:03:09.000000', 'temperatura', 161.0000, 'ºC'),
	(43425, 111, '2015-02-01 00:03:10.000000', 'temperatura', 94.0000, 'ºC'),
	(43426, 111, '2015-02-01 00:03:11.000000', 'temperatura', 1189.0000, 'ºC'),
	(43427, 111, '2015-02-01 00:03:12.000000', 'temperatura', 863.0000, 'ºC'),
	(43428, 111, '2015-02-01 00:03:13.000000', 'temperatura', 748.0000, 'ºC'),
	(43429, 111, '2015-02-01 00:03:14.000000', 'temperatura', 1151.0000, 'ºC'),
	(43430, 111, '2015-02-01 00:03:15.000000', 'temperatura', 1112.0000, 'ºC'),
	(43431, 111, '2015-02-01 00:03:16.000000', 'temperatura', 908.0000, 'ºC'),
	(43432, 111, '2015-02-01 00:03:17.000000', 'temperatura', 6.0000, 'ºC'),
	(43433, 111, '2015-02-01 00:03:18.000000', 'temperatura', 903.0000, 'ºC'),
	(43434, 111, '2015-02-01 00:03:19.000000', 'temperatura', 901.0000, 'ºC'),
	(43435, 111, '2015-02-01 00:03:20.000000', 'temperatura', 593.0000, 'ºC'),
	(43436, 111, '2015-02-01 00:03:21.000000', 'temperatura', 265.0000, 'ºC'),
	(43437, 111, '2015-02-01 00:03:22.000000', 'temperatura', 744.0000, 'ºC'),
	(43438, 111, '2015-02-01 00:03:23.000000', 'temperatura', 529.0000, 'ºC'),
	(43439, 111, '2015-02-01 00:03:24.000000', 'temperatura', 411.0000, 'ºC'),
	(43440, 111, '2015-02-01 00:03:25.000000', 'temperatura', 468.0000, 'ºC'),
	(43441, 111, '2015-02-01 00:03:26.000000', 'temperatura', 1109.0000, 'ºC'),
	(43442, 111, '2015-02-01 00:03:27.000000', 'temperatura', 541.0000, 'ºC'),
	(43443, 111, '2015-02-01 00:03:28.000000', 'temperatura', 580.0000, 'ºC'),
	(43444, 111, '2015-02-01 00:03:29.000000', 'temperatura', 77.0000, 'ºC'),
	(43445, 111, '2015-02-01 00:03:30.000000', 'temperatura', 1044.0000, 'ºC'),
	(43446, 111, '2015-02-01 00:03:31.000000', 'temperatura', 191.0000, 'ºC'),
	(43447, 111, '2015-02-01 00:03:32.000000', 'temperatura', 224.0000, 'ºC'),
	(43448, 111, '2015-02-01 00:03:33.000000', 'temperatura', 546.0000, 'ºC'),
	(43449, 111, '2015-02-01 00:03:34.000000', 'temperatura', 858.0000, 'ºC'),
	(43450, 111, '2015-02-01 00:03:35.000000', 'temperatura', 255.0000, 'ºC'),
	(43451, 111, '2015-02-01 00:03:36.000000', 'temperatura', 1101.0000, 'ºC'),
	(43452, 111, '2015-02-01 00:03:37.000000', 'temperatura', 1138.0000, 'ºC'),
	(43453, 111, '2015-02-01 00:03:38.000000', 'temperatura', 1189.0000, 'ºC'),
	(43454, 111, '2015-02-01 00:03:39.000000', 'temperatura', 132.0000, 'ºC'),
	(43455, 111, '2015-02-01 00:03:40.000000', 'temperatura', 691.0000, 'ºC'),
	(43456, 111, '2015-02-01 00:03:41.000000', 'temperatura', 662.0000, 'ºC'),
	(43457, 111, '2015-02-01 00:03:42.000000', 'temperatura', 35.0000, 'ºC'),
	(43458, 111, '2015-02-01 00:03:43.000000', 'temperatura', 590.0000, 'ºC'),
	(43459, 111, '2015-02-01 00:03:44.000000', 'temperatura', 446.0000, 'ºC'),
	(43460, 111, '2015-02-01 00:03:45.000000', 'temperatura', 461.0000, 'ºC'),
	(43461, 111, '2015-02-01 00:03:46.000000', 'temperatura', 969.0000, 'ºC'),
	(43462, 111, '2015-02-01 00:03:47.000000', 'temperatura', 1060.0000, 'ºC'),
	(43463, 111, '2015-02-01 00:03:48.000000', 'temperatura', 1193.0000, 'ºC'),
	(43464, 111, '2015-02-01 00:03:49.000000', 'temperatura', 386.0000, 'ºC'),
	(43465, 111, '2015-02-01 00:03:50.000000', 'temperatura', 752.0000, 'ºC'),
	(43466, 111, '2015-02-01 00:03:51.000000', 'temperatura', 202.0000, 'ºC'),
	(43467, 111, '2015-02-01 00:03:52.000000', 'temperatura', 1156.0000, 'ºC'),
	(43468, 111, '2015-02-01 00:03:53.000000', 'temperatura', 372.0000, 'ºC'),
	(43469, 111, '2015-02-01 00:03:54.000000', 'temperatura', 793.0000, 'ºC'),
	(43470, 111, '2015-02-01 00:03:55.000000', 'temperatura', 452.0000, 'ºC'),
	(43471, 111, '2015-02-01 00:03:56.000000', 'temperatura', 1079.0000, 'ºC'),
	(43472, 111, '2015-02-01 00:03:57.000000', 'temperatura', 442.0000, 'ºC'),
	(43473, 111, '2015-02-01 00:03:58.000000', 'temperatura', 174.0000, 'ºC'),
	(43474, 111, '2015-02-01 00:03:59.000000', 'temperatura', 743.0000, 'ºC'),
	(43475, 111, '2015-02-01 00:04:00.000000', 'temperatura', 794.0000, 'ºC'),
	(43476, 111, '2015-02-01 00:04:01.000000', 'temperatura', 541.0000, 'ºC'),
	(43477, 111, '2015-02-01 00:04:02.000000', 'temperatura', 323.0000, 'ºC'),
	(43478, 111, '2015-02-01 00:04:03.000000', 'temperatura', 1191.0000, 'ºC'),
	(43479, 111, '2015-02-01 00:04:04.000000', 'temperatura', 188.0000, 'ºC'),
	(43480, 111, '2015-02-01 00:04:05.000000', 'temperatura', 967.0000, 'ºC'),
	(43481, 111, '2015-02-01 00:04:06.000000', 'temperatura', 672.0000, 'ºC'),
	(43482, 111, '2015-02-01 00:04:07.000000', 'temperatura', 459.0000, 'ºC'),
	(43483, 111, '2015-02-01 00:04:08.000000', 'temperatura', 281.0000, 'ºC'),
	(43484, 111, '2015-02-01 00:04:09.000000', 'temperatura', 26.0000, 'ºC'),
	(43485, 111, '2015-02-01 00:04:10.000000', 'temperatura', 490.0000, 'ºC'),
	(43486, 111, '2015-02-01 00:04:11.000000', 'temperatura', 1171.0000, 'ºC'),
	(43487, 111, '2015-02-01 00:04:12.000000', 'temperatura', 785.0000, 'ºC'),
	(43488, 111, '2015-02-01 00:04:13.000000', 'temperatura', 415.0000, 'ºC'),
	(43489, 111, '2015-02-01 00:04:14.000000', 'temperatura', 917.0000, 'ºC'),
	(43490, 111, '2015-02-01 00:04:15.000000', 'temperatura', 943.0000, 'ºC'),
	(43491, 111, '2015-02-01 00:04:16.000000', 'temperatura', 762.0000, 'ºC'),
	(43492, 111, '2015-02-01 00:04:17.000000', 'temperatura', 983.0000, 'ºC'),
	(43493, 111, '2015-02-01 00:04:18.000000', 'temperatura', 227.0000, 'ºC'),
	(43494, 111, '2015-02-01 00:04:19.000000', 'temperatura', 589.0000, 'ºC'),
	(43495, 111, '2015-02-01 00:04:20.000000', 'temperatura', 1064.0000, 'ºC'),
	(43496, 111, '2015-02-01 00:04:21.000000', 'temperatura', 1155.0000, 'ºC'),
	(43497, 111, '2015-02-01 00:04:22.000000', 'temperatura', 182.0000, 'ºC'),
	(43498, 111, '2015-02-01 00:04:23.000000', 'temperatura', 1044.0000, 'ºC'),
	(43499, 111, '2015-02-01 00:04:24.000000', 'temperatura', 1075.0000, 'ºC'),
	(43500, 111, '2015-02-01 00:04:25.000000', 'temperatura', 1042.0000, 'ºC'),
	(43501, 111, '2015-02-01 00:04:26.000000', 'temperatura', 789.0000, 'ºC'),
	(43502, 111, '2015-02-01 00:04:27.000000', 'temperatura', 817.0000, 'ºC'),
	(43503, 111, '2015-02-01 00:04:28.000000', 'temperatura', 521.0000, 'ºC'),
	(43504, 111, '2015-02-01 00:04:29.000000', 'temperatura', 154.0000, 'ºC'),
	(43505, 111, '2015-02-01 00:04:30.000000', 'temperatura', 406.0000, 'ºC'),
	(43506, 111, '2015-02-01 00:04:31.000000', 'temperatura', 368.0000, 'ºC'),
	(43507, 111, '2015-02-01 00:04:32.000000', 'temperatura', 622.0000, 'ºC'),
	(43508, 111, '2015-02-01 00:04:33.000000', 'temperatura', 808.0000, 'ºC'),
	(43509, 111, '2015-02-01 00:04:34.000000', 'temperatura', 974.0000, 'ºC'),
	(43510, 111, '2015-02-01 00:04:35.000000', 'temperatura', 49.0000, 'ºC'),
	(43511, 111, '2015-02-01 00:04:36.000000', 'temperatura', 920.0000, 'ºC'),
	(43512, 111, '2015-02-01 00:04:37.000000', 'temperatura', 854.0000, 'ºC'),
	(43513, 111, '2015-02-01 00:04:38.000000', 'temperatura', 311.0000, 'ºC'),
	(43514, 111, '2015-02-01 00:04:39.000000', 'temperatura', 194.0000, 'ºC'),
	(43515, 111, '2015-02-01 00:04:40.000000', 'temperatura', 38.0000, 'ºC'),
	(43516, 111, '2015-02-01 00:04:41.000000', 'temperatura', 810.0000, 'ºC'),
	(43517, 111, '2015-02-01 00:04:42.000000', 'temperatura', 334.0000, 'ºC'),
	(43518, 111, '2015-02-01 00:04:43.000000', 'temperatura', 439.0000, 'ºC'),
	(43519, 111, '2015-02-01 00:04:44.000000', 'temperatura', 1195.0000, 'ºC'),
	(43520, 111, '2015-02-01 00:04:45.000000', 'temperatura', 1061.0000, 'ºC'),
	(43521, 111, '2015-02-01 00:04:46.000000', 'temperatura', 517.0000, 'ºC'),
	(43522, 111, '2015-02-01 00:04:47.000000', 'temperatura', 606.0000, 'ºC'),
	(43523, 111, '2015-02-01 00:04:48.000000', 'temperatura', 276.0000, 'ºC'),
	(43524, 111, '2015-02-01 00:04:49.000000', 'temperatura', 763.0000, 'ºC'),
	(43525, 111, '2015-02-01 00:04:50.000000', 'temperatura', 589.0000, 'ºC'),
	(43526, 111, '2015-02-01 00:04:51.000000', 'temperatura', 655.0000, 'ºC'),
	(43527, 111, '2015-02-01 00:04:52.000000', 'temperatura', 310.0000, 'ºC'),
	(43528, 111, '2015-02-01 00:04:53.000000', 'temperatura', 784.0000, 'ºC'),
	(43529, 111, '2015-02-01 00:04:54.000000', 'temperatura', 593.0000, 'ºC'),
	(43530, 111, '2015-02-01 00:04:55.000000', 'temperatura', 612.0000, 'ºC'),
	(43531, 111, '2015-02-01 00:04:56.000000', 'temperatura', 82.0000, 'ºC'),
	(43532, 111, '2015-02-01 00:04:57.000000', 'temperatura', 976.0000, 'ºC'),
	(43533, 111, '2015-02-01 00:04:58.000000', 'temperatura', 1031.0000, 'ºC'),
	(43534, 111, '2015-02-01 00:04:59.000000', 'temperatura', 1031.0000, 'ºC'),
	(43535, 111, '2015-02-01 00:05:00.000000', 'temperatura', 860.0000, 'ºC'),
	(43536, 111, '2015-02-01 00:05:01.000000', 'temperatura', 9.0000, 'ºC'),
	(43537, 111, '2015-02-01 00:05:02.000000', 'temperatura', 1063.0000, 'ºC'),
	(43538, 111, '2015-02-01 00:05:03.000000', 'temperatura', 491.0000, 'ºC'),
	(43539, 111, '2015-02-01 00:05:04.000000', 'temperatura', 468.0000, 'ºC'),
	(43540, 111, '2015-02-01 00:05:05.000000', 'temperatura', 865.0000, 'ºC'),
	(43541, 111, '2015-02-01 00:05:06.000000', 'temperatura', 522.0000, 'ºC'),
	(43542, 111, '2015-02-01 00:05:07.000000', 'temperatura', 15.0000, 'ºC'),
	(43543, 111, '2015-02-01 00:05:08.000000', 'temperatura', 910.0000, 'ºC'),
	(43544, 111, '2015-02-01 00:05:09.000000', 'temperatura', 906.0000, 'ºC'),
	(43545, 111, '2015-02-01 00:05:10.000000', 'temperatura', 600.0000, 'ºC'),
	(43546, 111, '2015-02-01 00:05:11.000000', 'temperatura', 282.0000, 'ºC'),
	(43547, 111, '2015-02-01 00:05:12.000000', 'temperatura', 811.0000, 'ºC'),
	(43548, 111, '2015-02-01 00:05:13.000000', 'temperatura', 808.0000, 'ºC'),
	(43549, 111, '2015-02-01 00:05:14.000000', 'temperatura', 407.0000, 'ºC'),
	(43550, 111, '2015-02-01 00:05:15.000000', 'temperatura', 814.0000, 'ºC'),
	(43551, 111, '2015-02-01 00:05:16.000000', 'temperatura', 448.0000, 'ºC'),
	(43552, 111, '2015-02-01 00:05:17.000000', 'temperatura', 997.0000, 'ºC'),
	(43553, 111, '2015-02-01 00:05:18.000000', 'temperatura', 43.0000, 'ºC'),
	(43554, 111, '2015-02-01 00:05:19.000000', 'temperatura', 826.0000, 'ºC'),
	(43555, 111, '2015-02-01 00:05:20.000000', 'temperatura', 399.0000, 'ºC'),
	(43556, 111, '2015-02-01 00:05:21.000000', 'temperatura', 719.0000, 'ºC'),
	(43557, 111, '2015-02-01 00:05:22.000000', 'temperatura', 1199.0000, 'ºC'),
	(43558, 111, '2015-02-01 00:05:23.000000', 'temperatura', 239.0000, 'ºC'),
	(43559, 111, '2015-02-01 00:05:24.000000', 'temperatura', 1198.0000, 'ºC'),
	(43560, 111, '2015-02-01 00:05:25.000000', 'temperatura', 475.0000, 'ºC'),
	(43561, 111, '2015-02-01 00:05:26.000000', 'temperatura', 1180.0000, 'ºC'),
	(43562, 111, '2015-02-01 00:05:27.000000', 'temperatura', 877.0000, 'ºC'),
	(43563, 111, '2015-02-01 00:05:28.000000', 'temperatura', 845.0000, 'ºC'),
	(43564, 111, '2015-02-01 00:05:29.000000', 'temperatura', 395.0000, 'ºC'),
	(43565, 111, '2015-02-01 00:05:30.000000', 'temperatura', 639.0000, 'ºC'),
	(43566, 111, '2015-02-01 00:05:31.000000', 'temperatura', 809.0000, 'ºC'),
	(43567, 111, '2015-02-01 00:05:32.000000', 'temperatura', 930.0000, 'ºC'),
	(43568, 111, '2015-02-01 00:05:33.000000', 'temperatura', 1025.0000, 'ºC'),
	(43569, 111, '2015-02-01 00:05:34.000000', 'temperatura', 1134.0000, 'ºC'),
	(43570, 111, '2015-02-01 00:05:35.000000', 'temperatura', 198.0000, 'ºC'),
	(43571, 111, '2015-02-01 00:05:36.000000', 'temperatura', 1185.0000, 'ºC'),
	(43572, 111, '2015-02-01 00:05:37.000000', 'temperatura', 535.0000, 'ºC'),
	(43573, 111, '2015-02-01 00:05:38.000000', 'temperatura', 317.0000, 'ºC'),
	(43574, 111, '2015-02-01 00:05:39.000000', 'temperatura', 1182.0000, 'ºC'),
	(43575, 111, '2015-02-01 00:05:40.000000', 'temperatura', 159.0000, 'ºC'),
	(43576, 111, '2015-02-01 00:05:41.000000', 'temperatura', 850.0000, 'ºC'),
	(43577, 111, '2015-02-01 00:05:42.000000', 'temperatura', 172.0000, 'ºC'),
	(43578, 111, '2015-02-01 00:05:43.000000', 'temperatura', 713.0000, 'ºC'),
	(43579, 111, '2015-02-01 00:05:44.000000', 'temperatura', 647.0000, 'ºC'),
	(43580, 111, '2015-02-01 00:05:45.000000', 'temperatura', 1096.0000, 'ºC'),
	(43581, 111, '2015-02-01 00:05:46.000000', 'temperatura', 1142.0000, 'ºC'),
	(43582, 111, '2015-02-01 00:05:47.000000', 'temperatura', 21.0000, 'ºC'),
	(43583, 111, '2015-02-01 00:05:48.000000', 'temperatura', 278.0000, 'ºC'),
	(43584, 111, '2015-02-01 00:05:49.000000', 'temperatura', 130.0000, 'ºC'),
	(43585, 111, '2015-02-01 00:05:50.000000', 'temperatura', 1018.0000, 'ºC'),
	(43586, 111, '2015-02-01 00:05:51.000000', 'temperatura', 1098.0000, 'ºC'),
	(43587, 111, '2015-02-01 00:05:52.000000', 'temperatura', 36.0000, 'ºC'),
	(43588, 111, '2015-02-01 00:05:53.000000', 'temperatura', 487.0000, 'ºC'),
	(43589, 111, '2015-02-01 00:05:54.000000', 'temperatura', 1129.0000, 'ºC'),
	(43590, 111, '2015-02-01 00:05:55.000000', 'temperatura', 582.0000, 'ºC'),
	(43591, 111, '2015-02-01 00:05:56.000000', 'temperatura', 726.0000, 'ºC'),
	(43592, 111, '2015-02-01 00:05:57.000000', 'temperatura', 685.0000, 'ºC'),
	(43593, 111, '2015-02-01 00:05:58.000000', 'temperatura', 46.0000, 'ºC'),
	(43594, 111, '2015-02-01 00:05:59.000000', 'temperatura', 574.0000, 'ºC'),
	(43595, 111, '2015-02-01 00:06:00.000000', 'temperatura', 334.0000, 'ºC'),
	(43596, 111, '2015-02-01 00:06:01.000000', 'temperatura', 1147.0000, 'ºC'),
	(43597, 111, '2015-02-01 00:06:02.000000', 'temperatura', 1134.0000, 'ºC'),
	(43598, 111, '2015-02-01 00:06:03.000000', 'temperatura', 1029.0000, 'ºC'),
	(43599, 111, '2015-02-01 00:06:04.000000', 'temperatura', 546.0000, 'ºC'),
	(43600, 111, '2015-02-01 00:06:05.000000', 'temperatura', 841.0000, 'ºC'),
	(43601, 111, '2015-02-01 00:06:06.000000', 'temperatura', 170.0000, 'ºC'),
	(43602, 111, '2015-02-01 00:06:07.000000', 'temperatura', 727.0000, 'ºC'),
	(43603, 111, '2015-02-01 00:06:08.000000', 'temperatura', 725.0000, 'ºC'),
	(43604, 111, '2015-02-01 00:06:09.000000', 'temperatura', 247.0000, 'ºC'),
	(43605, 111, '2015-02-01 00:06:10.000000', 'temperatura', 257.0000, 'ºC'),
	(43606, 111, '2015-02-01 00:06:11.000000', 'temperatura', 545.0000, 'ºC'),
	(43607, 111, '2015-02-01 00:06:12.000000', 'temperatura', 755.0000, 'ºC'),
	(43608, 111, '2015-02-01 00:06:13.000000', 'temperatura', 939.0000, 'ºC'),
	(43609, 111, '2015-02-01 00:06:14.000000', 'temperatura', 32.0000, 'ºC'),
	(43610, 111, '2015-02-01 00:06:15.000000', 'temperatura', 942.0000, 'ºC'),
	(43611, 111, '2015-02-01 00:06:16.000000', 'temperatura', 1015.0000, 'ºC'),
	(43612, 111, '2015-02-01 00:06:17.000000', 'temperatura', 1050.0000, 'ºC'),
	(43613, 111, '2015-02-01 00:06:18.000000', 'temperatura', 1006.0000, 'ºC'),
	(43614, 111, '2015-02-01 00:06:19.000000', 'temperatura', 681.0000, 'ºC'),
	(43615, 111, '2015-02-01 00:06:20.000000', 'temperatura', 389.0000, 'ºC'),
	(43616, 111, '2015-02-01 00:06:21.000000', 'temperatura', 1101.0000, 'ºC'),
	(43617, 111, '2015-02-01 00:06:22.000000', 'temperatura', 737.0000, 'ºC'),
	(43618, 111, '2015-02-01 00:06:23.000000', 'temperatura', 383.0000, 'ºC'),
	(43619, 111, '2015-02-01 00:06:24.000000', 'temperatura', 906.0000, 'ºC'),
	(43620, 111, '2015-02-01 00:06:25.000000', 'temperatura', 981.0000, 'ºC'),
	(43621, 111, '2015-02-01 00:06:26.000000', 'temperatura', 987.0000, 'ºC'),
	(43622, 111, '2015-02-01 00:06:27.000000', 'temperatura', 794.0000, 'ºC'),
	(43623, 111, '2015-02-01 00:06:28.000000', 'temperatura', 1008.0000, 'ºC'),
	(43624, 111, '2015-02-01 00:06:29.000000', 'temperatura', 259.0000, 'ºC'),
	(43625, 111, '2015-02-01 00:06:30.000000', 'temperatura', 670.0000, 'ºC'),
	(43626, 111, '2015-02-01 00:06:31.000000', 'temperatura', 175.0000, 'ºC'),
	(43627, 111, '2015-02-01 00:06:32.000000', 'temperatura', 64.0000, 'ºC'),
	(43628, 111, '2015-02-01 00:06:33.000000', 'temperatura', 998.0000, 'ºC'),
	(43629, 111, '2015-02-01 00:06:34.000000', 'temperatura', 1196.0000, 'ºC'),
	(43630, 111, '2015-02-01 00:06:35.000000', 'temperatura', 587.0000, 'ºC'),
	(43631, 111, '2015-02-01 00:06:36.000000', 'temperatura', 550.0000, 'ºC'),
	(43632, 111, '2015-02-01 00:06:37.000000', 'temperatura', 986.0000, 'ºC'),
	(43633, 111, '2015-02-01 00:06:38.000000', 'temperatura', 881.0000, 'ºC'),
	(43634, 111, '2015-02-01 00:06:39.000000', 'temperatura', 250.0000, 'ºC'),
	(43635, 111, '2015-02-01 00:06:40.000000', 'temperatura', 1007.0000, 'ºC'),
	(43636, 111, '2015-02-01 00:06:41.000000', 'temperatura', 684.0000, 'ºC'),
	(43637, 111, '2015-02-01 00:06:42.000000', 'temperatura', 400.0000, 'ºC'),
	(43638, 111, '2015-02-01 00:06:43.000000', 'temperatura', 1148.0000, 'ºC'),
	(43639, 111, '2015-02-01 00:06:44.000000', 'temperatura', 941.0000, 'ºC'),
	(43640, 111, '2015-02-01 00:06:45.000000', 'temperatura', 62.0000, 'ºC'),
	(43641, 111, '2015-02-01 00:06:46.000000', 'temperatura', 1089.0000, 'ºC'),
	(43642, 111, '2015-02-01 00:06:47.000000', 'temperatura', 456.0000, 'ºC'),
	(43643, 111, '2015-02-01 00:06:48.000000', 'temperatura', 215.0000, 'ºC'),
	(43644, 111, '2015-02-01 00:06:49.000000', 'temperatura', 909.0000, 'ºC'),
	(43645, 111, '2015-02-01 00:06:50.000000', 'temperatura', 300.0000, 'ºC'),
	(43646, 111, '2015-02-01 00:06:51.000000', 'temperatura', 1174.0000, 'ºC'),
	(43647, 111, '2015-02-01 00:06:52.000000', 'temperatura', 169.0000, 'ºC'),
	(43648, 111, '2015-02-01 00:06:53.000000', 'temperatura', 923.0000, 'ºC'),
	(43649, 111, '2015-02-01 00:06:54.000000', 'temperatura', 510.0000, 'ºC'),
	(43650, 111, '2015-02-01 00:06:55.000000', 'temperatura', 981.0000, 'ºC'),
	(43651, 111, '2015-02-01 00:06:56.000000', 'temperatura', 975.0000, 'ºC'),
	(43652, 111, '2015-02-01 00:06:57.000000', 'temperatura', 735.0000, 'ºC'),
	(43653, 111, '2015-02-01 00:06:58.000000', 'temperatura', 749.0000, 'ºC'),
	(43654, 111, '2015-02-01 00:06:59.000000', 'temperatura', 339.0000, 'ºC'),
	(43655, 111, '2015-02-01 00:07:00.000000', 'temperatura', 649.0000, 'ºC'),
	(43656, 111, '2015-02-01 00:07:01.000000', 'temperatura', 1027.0000, 'ºC'),
	(43657, 111, '2015-02-01 00:07:02.000000', 'temperatura', 791.0000, 'ºC'),
	(43658, 111, '2015-02-01 00:07:03.000000', 'temperatura', 873.0000, 'ºC'),
	(43659, 111, '2015-02-01 00:07:04.000000', 'temperatura', 791.0000, 'ºC'),
	(43660, 111, '2015-02-01 00:07:05.000000', 'temperatura', 138.0000, 'ºC'),
	(43661, 111, '2015-02-01 00:07:06.000000', 'temperatura', 719.0000, 'ºC'),
	(43662, 111, '2015-02-01 00:07:07.000000', 'temperatura', 780.0000, 'ºC'),
	(43663, 111, '2015-02-01 00:07:08.000000', 'temperatura', 543.0000, 'ºC'),
	(43664, 111, '2015-02-01 00:07:09.000000', 'temperatura', 375.0000, 'ºC'),
	(43665, 111, '2015-02-01 00:07:10.000000', 'temperatura', 246.0000, 'ºC'),
	(43666, 111, '2015-02-01 00:07:11.000000', 'temperatura', 108.0000, 'ºC'),
	(43667, 111, '2015-02-01 00:07:12.000000', 'temperatura', 1002.0000, 'ºC'),
	(43668, 111, '2015-02-01 00:07:13.000000', 'temperatura', 1084.0000, 'ºC'),
	(43669, 111, '2015-02-01 00:07:14.000000', 'temperatura', 18.0000, 'ºC'),
	(43670, 111, '2015-02-01 00:07:15.000000', 'temperatura', 435.0000, 'ºC'),
	(43671, 111, '2015-02-01 00:07:16.000000', 'temperatura', 925.0000, 'ºC'),
	(43672, 111, '2015-02-01 00:07:17.000000', 'temperatura', 919.0000, 'ºC'),
	(43673, 111, '2015-02-01 00:07:18.000000', 'temperatura', 619.0000, 'ºC'),
	(43674, 111, '2015-02-01 00:07:19.000000', 'temperatura', 339.0000, 'ºC'),
	(43675, 111, '2015-02-01 00:07:20.000000', 'temperatura', 1039.0000, 'ºC'),
	(43676, 111, '2015-02-01 00:07:21.000000', 'temperatura', 579.0000, 'ºC'),
	(43677, 111, '2015-02-01 00:07:22.000000', 'temperatura', 979.0000, 'ºC'),
	(43678, 111, '2015-02-01 00:07:23.000000', 'temperatura', 756.0000, 'ºC'),
	(43679, 111, '2015-02-01 00:07:24.000000', 'temperatura', 846.0000, 'ºC'),
	(43680, 111, '2015-02-01 00:07:25.000000', 'temperatura', 761.0000, 'ºC'),
	(43681, 111, '2015-02-01 00:07:26.000000', 'temperatura', 69.0000, 'ºC'),
	(43682, 111, '2015-02-01 00:07:27.000000', 'temperatura', 460.0000, 'ºC'),
	(43683, 111, '2015-02-01 00:07:28.000000', 'temperatura', 896.0000, 'ºC'),
	(43684, 111, '2015-02-01 00:07:29.000000', 'temperatura', 697.0000, 'ºC'),
	(43685, 111, '2015-02-01 00:07:30.000000', 'temperatura', 801.0000, 'ºC'),
	(43686, 111, '2015-02-01 00:07:31.000000', 'temperatura', 715.0000, 'ºC'),
	(43687, 111, '2015-02-01 00:07:32.000000', 'temperatura', 1173.0000, 'ºC'),
	(43688, 111, '2015-02-01 00:07:33.000000', 'temperatura', 119.0000, 'ºC'),
	(43689, 111, '2015-02-01 00:07:34.000000', 'temperatura', 679.0000, 'ºC'),
	(43690, 111, '2015-02-01 00:07:35.000000', 'temperatura', 635.0000, 'ºC'),
	(43691, 111, '2015-02-01 00:07:36.000000', 'temperatura', 1139.0000, 'ºC'),
	(43692, 111, '2015-02-01 00:07:37.000000', 'temperatura', 191.0000, 'ºC'),
	(43693, 111, '2015-02-01 00:07:38.000000', 'temperatura', 1138.0000, 'ºC'),
	(43694, 111, '2015-02-01 00:07:39.000000', 'temperatura', 318.0000, 'ºC'),
	(43695, 111, '2015-02-01 00:07:40.000000', 'temperatura', 576.0000, 'ºC'),
	(43696, 111, '2015-02-01 00:07:41.000000', 'temperatura', 728.0000, 'ºC'),
	(43697, 111, '2015-02-01 00:07:42.000000', 'temperatura', 710.0000, 'ºC'),
	(43698, 111, '2015-02-01 00:07:43.000000', 'temperatura', 170.0000, 'ºC'),
	(43699, 111, '2015-02-01 00:07:44.000000', 'temperatura', 1118.0000, 'ºC'),
	(43700, 111, '2015-02-01 00:07:45.000000', 'temperatura', 280.0000, 'ºC'),
	(43701, 111, '2015-02-01 00:07:46.000000', 'temperatura', 447.0000, 'ºC'),
	(43702, 111, '2015-02-01 00:07:47.000000', 'temperatura', 195.0000, 'ºC'),
	(43703, 111, '2015-02-01 00:07:48.000000', 'temperatura', 836.0000, 'ºC'),
	(43704, 111, '2015-02-01 00:07:49.000000', 'temperatura', 1193.0000, 'ºC'),
	(43705, 111, '2015-02-01 00:07:50.000000', 'temperatura', 1059.0000, 'ºC'),
	(43706, 111, '2015-02-01 00:07:51.000000', 'temperatura', 517.0000, 'ºC'),
	(43707, 111, '2015-02-01 00:07:52.000000', 'temperatura', 608.0000, 'ºC'),
	(43708, 111, '2015-02-01 00:07:53.000000', 'temperatura', 292.0000, 'ºC'),
	(43709, 111, '2015-02-01 00:07:54.000000', 'temperatura', 833.0000, 'ºC'),
	(43710, 111, '2015-02-01 00:07:55.000000', 'temperatura', 891.0000, 'ºC'),
	(43711, 111, '2015-02-01 00:07:56.000000', 'temperatura', 758.0000, 'ºC'),
	(43712, 111, '2015-02-01 00:07:57.000000', 'temperatura', 1117.0000, 'ºC'),
	(43713, 111, '2015-02-01 00:07:58.000000', 'temperatura', 913.0000, 'ºC'),
	(43714, 111, '2015-02-01 00:07:59.000000', 'temperatura', 14.0000, 'ºC'),
	(43715, 111, '2015-02-01 00:08:00.000000', 'temperatura', 930.0000, 'ºC'),
	(43716, 111, '2015-02-01 00:08:01.000000', 'temperatura', 1009.0000, 'ºC'),
	(43717, 111, '2015-02-01 00:08:02.000000', 'temperatura', 1055.0000, 'ºC'),
	(43718, 111, '2015-02-01 00:08:03.000000', 'temperatura', 1048.0000, 'ºC'),
	(43719, 111, '2015-02-01 00:08:04.000000', 'temperatura', 875.0000, 'ºC'),
	(43720, 111, '2015-02-01 00:08:05.000000', 'temperatura', 32.0000, 'ºC'),
	(43721, 111, '2015-02-01 00:08:06.000000', 'temperatura', 1136.0000, 'ºC'),
	(43722, 111, '2015-02-01 00:08:07.000000', 'temperatura', 784.0000, 'ºC'),
	(43723, 111, '2015-02-01 00:08:08.000000', 'temperatura', 513.0000, 'ºC'),
	(43724, 111, '2015-02-01 00:08:09.000000', 'temperatura', 212.0000, 'ºC'),
	(43725, 111, '2015-02-01 00:08:10.000000', 'temperatura', 724.0000, 'ºC'),
	(43726, 111, '2015-02-01 00:08:11.000000', 'temperatura', 583.0000, 'ºC'),
	(43727, 111, '2015-02-01 00:08:12.000000', 'temperatura', 744.0000, 'ºC'),
	(43728, 111, '2015-02-01 00:08:13.000000', 'temperatura', 771.0000, 'ºC'),
	(43729, 111, '2015-02-01 00:08:14.000000', 'temperatura', 426.0000, 'ºC'),
	(43730, 111, '2015-02-01 00:08:15.000000', 'temperatura', 1014.0000, 'ºC'),
	(43731, 111, '2015-02-01 00:08:16.000000', 'temperatura', 193.0000, 'ºC'),
	(43732, 111, '2015-02-01 00:08:17.000000', 'temperatura', 326.0000, 'ºC'),
	(43733, 111, '2015-02-01 00:08:18.000000', 'temperatura', 1048.0000, 'ºC'),
	(43734, 111, '2015-02-01 00:08:19.000000', 'temperatura', 665.0000, 'ºC'),
	(43735, 111, '2015-02-01 00:08:20.000000', 'temperatura', 179.0000, 'ºC'),
	(43736, 111, '2015-02-01 00:08:21.000000', 'temperatura', 101.0000, 'ºC'),
	(43737, 111, '2015-02-01 00:08:22.000000', 'temperatura', 1169.0000, 'ºC'),
	(43738, 111, '2015-02-01 00:08:23.000000', 'temperatura', 743.0000, 'ºC'),
	(43739, 111, '2015-02-01 00:08:24.000000', 'temperatura', 209.0000, 'ºC'),
	(43740, 111, '2015-02-01 00:08:25.000000', 'temperatura', 17.0000, 'ºC'),
	(43741, 111, '2015-02-01 00:08:26.000000', 'temperatura', 656.0000, 'ºC'),
	(43742, 111, '2015-02-01 00:08:27.000000', 'temperatura', 832.0000, 'ºC'),
	(43743, 111, '2015-02-01 00:08:28.000000', 'temperatura', 993.0000, 'ºC'),
	(43744, 111, '2015-02-01 00:08:29.000000', 'temperatura', 69.0000, 'ºC'),
	(43745, 111, '2015-02-01 00:08:30.000000', 'temperatura', 967.0000, 'ºC'),
	(43746, 111, '2015-02-01 00:08:31.000000', 'temperatura', 1027.0000, 'ºC'),
	(43747, 111, '2015-02-01 00:08:32.000000', 'temperatura', 1035.0000, 'ºC'),
	(43748, 111, '2015-02-01 00:08:33.000000', 'temperatura', 893.0000, 'ºC'),
	(43749, 111, '2015-02-01 00:08:34.000000', 'temperatura', 163.0000, 'ºC'),
	(43750, 111, '2015-02-01 00:08:35.000000', 'temperatura', 535.0000, 'ºC'),
	(43751, 111, '2015-02-01 00:08:36.000000', 'temperatura', 986.0000, 'ºC'),
	(43752, 111, '2015-02-01 00:08:37.000000', 'temperatura', 927.0000, 'ºC'),
	(43753, 111, '2015-02-01 00:08:38.000000', 'temperatura', 478.0000, 'ºC'),
	(43754, 111, '2015-02-01 00:08:39.000000', 'temperatura', 810.0000, 'ºC'),
	(43755, 111, '2015-02-01 00:08:40.000000', 'temperatura', 214.0000, 'ºC'),
	(43756, 111, '2015-02-01 00:08:41.000000', 'temperatura', 1043.0000, 'ºC'),
	(43757, 111, '2015-02-01 00:08:42.000000', 'temperatura', 975.0000, 'ºC'),
	(43758, 111, '2015-02-01 00:08:43.000000', 'temperatura', 543.0000, 'ºC'),
	(43759, 111, '2015-02-01 00:08:44.000000', 'temperatura', 992.0000, 'ºC'),
	(43760, 111, '2015-02-01 00:08:45.000000', 'temperatura', 929.0000, 'ºC'),
	(43761, 111, '2015-02-01 00:08:46.000000', 'temperatura', 472.0000, 'ºC'),
	(43762, 111, '2015-02-01 00:08:47.000000', 'temperatura', 774.0000, 'ºC'),
	(43763, 111, '2015-02-01 00:08:48.000000', 'temperatura', 55.0000, 'ºC'),
	(43764, 111, '2015-02-01 00:08:49.000000', 'temperatura', 351.0000, 'ºC'),
	(43765, 111, '2015-02-01 00:08:50.000000', 'temperatura', 392.0000, 'ºC'),
	(43766, 111, '2015-02-01 00:08:51.000000', 'temperatura', 908.0000, 'ºC'),
	(43767, 111, '2015-02-01 00:08:52.000000', 'temperatura', 965.0000, 'ºC'),
	(43768, 111, '2015-02-01 00:08:53.000000', 'temperatura', 899.0000, 'ºC'),
	(43769, 111, '2015-02-01 00:08:54.000000', 'temperatura', 403.0000, 'ºC'),
	(43770, 111, '2015-02-01 00:08:55.000000', 'temperatura', 517.0000, 'ºC'),
	(43771, 111, '2015-02-01 00:08:56.000000', 'temperatura', 179.0000, 'ºC'),
	(43772, 111, '2015-02-01 00:08:57.000000', 'temperatura', 543.0000, 'ºC'),
	(43773, 111, '2015-02-01 00:08:58.000000', 'temperatura', 977.0000, 'ºC'),
	(43774, 111, '2015-02-01 00:08:59.000000', 'temperatura', 858.0000, 'ºC'),
	(43775, 111, '2015-02-01 00:09:00.000000', 'temperatura', 161.0000, 'ºC'),
	(43776, 111, '2015-02-01 00:09:01.000000', 'temperatura', 629.0000, 'ºC'),
	(43777, 111, '2015-02-01 00:09:02.000000', 'temperatura', 265.0000, 'ºC'),
	(43778, 111, '2015-02-01 00:09:03.000000', 'temperatura', 638.0000, 'ºC'),
	(43779, 111, '2015-02-01 00:09:04.000000', 'temperatura', 1193.0000, 'ºC'),
	(43780, 111, '2015-02-01 00:09:05.000000', 'temperatura', 453.0000, 'ºC'),
	(43781, 111, '2015-02-01 00:09:06.000000', 'temperatura', 1086.0000, 'ºC'),
	(43782, 111, '2015-02-01 00:09:07.000000', 'temperatura', 470.0000, 'ºC'),
	(43783, 111, '2015-02-01 00:09:08.000000', 'temperatura', 294.0000, 'ºC'),
	(43784, 111, '2015-02-01 00:09:09.000000', 'temperatura', 61.0000, 'ºC'),
	(43785, 111, '2015-02-01 00:09:10.000000', 'temperatura', 623.0000, 'ºC'),
	(43786, 111, '2015-02-01 00:09:11.000000', 'temperatura', 533.0000, 'ºC'),
	(43787, 111, '2015-02-01 00:09:12.000000', 'temperatura', 797.0000, 'ºC'),
	(43788, 111, '2015-02-01 00:09:13.000000', 'temperatura', 1185.0000, 'ºC'),
	(43789, 111, '2015-02-01 00:09:14.000000', 'temperatura', 1134.0000, 'ºC'),
	(43790, 111, '2015-02-01 00:09:15.000000', 'temperatura', 917.0000, 'ºC'),
	(43791, 111, '2015-02-01 00:09:16.000000', 'temperatura', 1184.0000, 'ºC'),
	(43792, 111, '2015-02-01 00:09:17.000000', 'temperatura', 767.0000, 'ºC'),
	(43793, 111, '2015-02-01 00:09:18.000000', 'temperatura', 284.0000, 'ºC'),
	(43794, 111, '2015-02-01 00:09:19.000000', 'temperatura', 321.0000, 'ºC'),
	(43795, 111, '2015-02-01 00:09:20.000000', 'temperatura', 754.0000, 'ºC'),
	(43796, 111, '2015-02-01 00:09:21.000000', 'temperatura', 408.0000, 'ºC'),
	(43797, 111, '2015-02-01 00:09:22.000000', 'temperatura', 979.0000, 'ºC'),
	(43798, 111, '2015-02-01 00:09:23.000000', 'temperatura', 71.0000, 'ºC'),
	(43799, 111, '2015-02-01 00:09:24.000000', 'temperatura', 1018.0000, 'ºC'),
	(43800, 111, '2015-02-01 00:09:25.000000', 'temperatura', 78.0000, 'ºC'),
	(43801, 111, '2015-02-01 00:09:26.000000', 'temperatura', 935.0000, 'ºC'),
	(43802, 111, '2015-02-01 00:09:27.000000', 'temperatura', 842.0000, 'ºC'),
	(43803, 111, '2015-02-01 00:09:28.000000', 'temperatura', 205.0000, 'ºC'),
	(43804, 111, '2015-02-01 00:09:29.000000', 'temperatura', 898.0000, 'ºC'),
	(43805, 111, '2015-02-01 00:09:30.000000', 'temperatura', 278.0000, 'ºC'),
	(43806, 111, '2015-02-01 00:09:31.000000', 'temperatura', 1096.0000, 'ºC'),
	(43807, 111, '2015-02-01 00:09:32.000000', 'temperatura', 1045.0000, 'ºC'),
	(43808, 111, '2015-02-01 00:09:33.000000', 'temperatura', 740.0000, 'ºC'),
	(43809, 111, '2015-02-01 00:09:34.000000', 'temperatura', 562.0000, 'ºC'),
	(43810, 111, '2015-02-01 00:09:35.000000', 'temperatura', 594.0000, 'ºC'),
	(43811, 111, '2015-02-01 00:09:36.000000', 'temperatura', 84.0000, 'ºC'),
	(43812, 111, '2015-02-01 00:09:37.000000', 'temperatura', 1037.0000, 'ºC'),
	(43813, 111, '2015-02-01 00:09:38.000000', 'temperatura', 132.0000, 'ºC'),
	(43814, 111, '2015-02-01 00:09:39.000000', 'temperatura', 1151.0000, 'ºC'),
	(43815, 111, '2015-02-01 00:09:40.000000', 'temperatura', 560.0000, 'ºC'),
	(43816, 111, '2015-02-01 00:09:41.000000', 'temperatura', 548.0000, 'ºC'),
	(43817, 111, '2015-02-01 00:09:42.000000', 'temperatura', 1060.0000, 'ºC'),
	(43818, 111, '2015-02-01 00:09:43.000000', 'temperatura', 58.0000, 'ºC'),
	(43819, 111, '2015-02-01 00:09:44.000000', 'temperatura', 710.0000, 'ºC'),
	(43820, 111, '2015-02-01 00:09:45.000000', 'temperatura', 976.0000, 'ºC'),
	(43821, 111, '2015-02-01 00:09:46.000000', 'temperatura', 352.0000, 'ºC'),
	(43822, 111, '2015-02-01 00:09:47.000000', 'temperatura', 30.0000, 'ºC'),
	(43823, 111, '2015-02-01 00:09:48.000000', 'temperatura', 296.0000, 'ºC'),
	(43824, 111, '2015-02-01 00:09:49.000000', 'temperatura', 192.0000, 'ºC'),
	(43825, 111, '2015-02-01 00:09:50.000000', 'temperatura', 72.0000, 'ºC'),
	(43826, 111, '2015-02-01 00:09:51.000000', 'temperatura', 983.0000, 'ºC'),
	(43827, 111, '2015-02-01 00:09:52.000000', 'temperatura', 1102.0000, 'ºC'),
	(43828, 111, '2015-02-01 00:09:53.000000', 'temperatura', 159.0000, 'ºC'),
	(43829, 111, '2015-02-01 00:09:54.000000', 'temperatura', 1089.0000, 'ºC'),
	(43830, 111, '2015-02-01 00:09:55.000000', 'temperatura', 168.0000, 'ºC'),
	(43831, 111, '2015-02-01 00:09:56.000000', 'temperatura', 1175.0000, 'ºC'),
	(43832, 111, '2015-02-01 00:09:57.000000', 'temperatura', 573.0000, 'ºC'),
	(43833, 111, '2015-02-01 00:09:58.000000', 'temperatura', 539.0000, 'ºC'),
	(43834, 111, '2015-02-01 00:09:59.000000', 'temperatura', 978.0000, 'ºC'),
	(43835, 111, '2015-02-01 00:10:00.000000', 'temperatura', 874.0000, 'ºC'),
	(43836, 111, '2015-02-01 00:10:01.000000', 'temperatura', 237.0000, 'ºC'),
	(43837, 111, '2015-02-01 00:10:02.000000', 'temperatura', 963.0000, 'ºC'),
	(43838, 111, '2015-02-01 00:10:03.000000', 'temperatura', 504.0000, 'ºC'),
	(43839, 111, '2015-02-01 00:10:04.000000', 'temperatura', 832.0000, 'ºC'),
	(43840, 111, '2015-02-01 00:10:05.000000', 'temperatura', 246.0000, 'ºC'),
	(43841, 111, '2015-02-01 00:10:06.000000', 'temperatura', 1138.0000, 'ºC'),
	(43842, 111, '2015-02-01 00:10:07.000000', 'temperatura', 150.0000, 'ºC'),
	(43843, 111, '2015-02-01 00:10:08.000000', 'temperatura', 936.0000, 'ºC'),
	(43844, 111, '2015-02-01 00:10:09.000000', 'temperatura', 630.0000, 'ºC'),
	(43845, 111, '2015-02-01 00:10:10.000000', 'temperatura', 343.0000, 'ºC'),
	(43846, 111, '2015-02-01 00:10:11.000000', 'temperatura', 1026.0000, 'ºC'),
	(43847, 111, '2015-02-01 00:10:12.000000', 'temperatura', 501.0000, 'ºC'),
	(43848, 111, '2015-02-01 00:10:13.000000', 'temperatura', 630.0000, 'ºC'),
	(43849, 111, '2015-02-01 00:10:14.000000', 'temperatura', 445.0000, 'ºC'),
	(43850, 111, '2015-02-01 00:10:15.000000', 'temperatura', 336.0000, 'ºC'),
	(43851, 111, '2015-02-01 00:10:16.000000', 'temperatura', 346.0000, 'ºC'),
	(43852, 111, '2015-02-01 00:10:17.000000', 'temperatura', 724.0000, 'ºC'),
	(43853, 111, '2015-02-01 00:10:18.000000', 'temperatura', 180.0000, 'ºC'),
	(43854, 111, '2015-02-01 00:10:19.000000', 'temperatura', 1129.0000, 'ºC'),
	(43855, 111, '2015-02-01 00:10:20.000000', 'temperatura', 306.0000, 'ºC'),
	(43856, 111, '2015-02-01 00:10:21.000000', 'temperatura', 543.0000, 'ºC'),
	(43857, 111, '2015-02-01 00:10:22.000000', 'temperatura', 598.0000, 'ºC'),
	(43858, 111, '2015-02-01 00:10:23.000000', 'temperatura', 161.0000, 'ºC'),
	(43859, 111, '2015-02-01 00:10:24.000000', 'temperatura', 213.0000, 'ºC'),
	(43860, 111, '2015-02-01 00:10:25.000000', 'temperatura', 582.0000, 'ºC'),
	(43861, 111, '2015-02-01 00:10:26.000000', 'temperatura', 1072.0000, 'ºC'),
	(43862, 111, '2015-02-01 00:10:27.000000', 'temperatura', 15.0000, 'ºC'),
	(43863, 111, '2015-02-01 00:10:28.000000', 'temperatura', 459.0000, 'ºC'),
	(43864, 111, '2015-02-01 00:10:29.000000', 'temperatura', 1052.0000, 'ºC'),
	(43865, 111, '2015-02-01 00:10:30.000000', 'temperatura', 283.0000, 'ºC'),
	(43866, 111, '2015-02-01 00:10:31.000000', 'temperatura', 660.0000, 'ºC'),
	(43867, 111, '2015-02-01 00:10:32.000000', 'temperatura', 50.0000, 'ºC'),
	(43868, 111, '2015-02-01 00:10:33.000000', 'temperatura', 670.0000, 'ºC'),
	(43869, 111, '2015-02-01 00:10:34.000000', 'temperatura', 801.0000, 'ºC'),
	(43870, 111, '2015-02-01 00:10:35.000000', 'temperatura', 795.0000, 'ºC'),
	(43871, 111, '2015-02-01 00:10:36.000000', 'temperatura', 374.0000, 'ºC'),
	(43872, 111, '2015-02-01 00:10:37.000000', 'temperatura', 683.0000, 'ºC'),
	(43873, 111, '2015-02-01 00:10:38.000000', 'temperatura', 1096.0000, 'ºC'),
	(43874, 111, '2015-02-01 00:10:39.000000', 'temperatura', 1030.0000, 'ºC'),
	(43875, 111, '2015-02-01 00:10:40.000000', 'temperatura', 665.0000, 'ºC'),
	(43876, 111, '2015-02-01 00:10:41.000000', 'temperatura', 233.0000, 'ºC'),
	(43877, 111, '2015-02-01 00:10:42.000000', 'temperatura', 370.0000, 'ºC'),
	(43878, 111, '2015-02-01 00:10:43.000000', 'temperatura', 1151.0000, 'ºC'),
	(43879, 111, '2015-02-01 00:10:44.000000', 'temperatura', 1048.0000, 'ºC'),
	(43880, 111, '2015-02-01 00:10:45.000000', 'temperatura', 589.0000, 'ºC'),
	(43881, 111, '2015-02-01 00:10:46.000000', 'temperatura', 998.0000, 'ºC'),
	(43882, 111, '2015-02-01 00:10:47.000000', 'temperatura', 823.0000, 'ºC'),
	(43883, 111, '2015-02-01 00:10:48.000000', 'temperatura', 1122.0000, 'ºC'),
	(43884, 111, '2015-02-01 00:10:49.000000', 'temperatura', 741.0000, 'ºC'),
	(43885, 111, '2015-02-01 00:10:50.000000', 'temperatura', 339.0000, 'ºC'),
	(43886, 111, '2015-02-01 00:10:51.000000', 'temperatura', 673.0000, 'ºC'),
	(43887, 111, '2015-02-01 00:10:52.000000', 'temperatura', 1150.0000, 'ºC'),
	(43888, 111, '2015-02-01 00:10:53.000000', 'temperatura', 129.0000, 'ºC'),
	(43889, 111, '2015-02-01 00:10:54.000000', 'temperatura', 799.0000, 'ºC'),
	(43890, 111, '2015-02-01 00:10:55.000000', 'temperatura', 5.0000, 'ºC'),
	(43891, 111, '2015-02-01 00:10:56.000000', 'temperatura', 32.0000, 'ºC'),
	(43892, 111, '2015-02-01 00:10:57.000000', 'temperatura', 143.0000, 'ºC'),
	(43893, 111, '2015-02-01 00:10:58.000000', 'temperatura', 619.0000, 'ºC'),
	(43894, 111, '2015-02-01 00:10:59.000000', 'temperatura', 265.0000, 'ºC'),
	(43895, 111, '2015-02-01 00:11:00.000000', 'temperatura', 671.0000, 'ºC'),
	(43896, 111, '2015-02-01 00:11:01.000000', 'temperatura', 160.0000, 'ºC'),
	(43897, 111, '2015-02-01 00:11:02.000000', 'temperatura', 1186.0000, 'ºC'),
	(43898, 111, '2015-02-01 00:11:03.000000', 'temperatura', 652.0000, 'ºC'),
	(43899, 111, '2015-02-01 00:11:04.000000', 'temperatura', 902.0000, 'ºC'),
	(43900, 111, '2015-02-01 00:11:05.000000', 'temperatura', 154.0000, 'ºC'),
	(43901, 111, '2015-02-01 00:11:06.000000', 'temperatura', 464.0000, 'ºC'),
	(43902, 111, '2015-02-01 00:11:07.000000', 'temperatura', 660.0000, 'ºC'),
	(43903, 111, '2015-02-01 00:11:08.000000', 'temperatura', 709.0000, 'ºC'),
	(43904, 111, '2015-02-01 00:11:09.000000', 'temperatura', 365.0000, 'ºC'),
	(43905, 111, '2015-02-01 00:11:10.000000', 'temperatura', 899.0000, 'ºC'),
	(43906, 111, '2015-02-01 00:11:11.000000', 'temperatura', 999.0000, 'ºC'),
	(43907, 111, '2015-02-01 00:11:12.000000', 'temperatura', 1097.0000, 'ºC'),
	(43908, 111, '2015-02-01 00:11:13.000000', 'temperatura', 92.0000, 'ºC'),
	(43909, 111, '2015-02-01 00:11:14.000000', 'temperatura', 766.0000, 'ºC'),
	(43910, 111, '2015-02-01 00:11:15.000000', 'temperatura', 1157.0000, 'ºC'),
	(43911, 111, '2015-02-01 00:11:16.000000', 'temperatura', 1086.0000, 'ºC'),
	(43912, 111, '2015-02-01 00:11:17.000000', 'temperatura', 762.0000, 'ºC'),
	(43913, 111, '2015-02-01 00:11:18.000000', 'temperatura', 549.0000, 'ºC'),
	(43914, 111, '2015-02-01 00:11:19.000000', 'temperatura', 462.0000, 'ºC'),
	(43915, 111, '2015-02-01 00:11:20.000000', 'temperatura', 664.0000, 'ºC'),
	(43916, 111, '2015-02-01 00:11:21.000000', 'temperatura', 734.0000, 'ºC'),
	(43917, 111, '2015-02-01 00:11:22.000000', 'temperatura', 477.0000, 'ºC'),
	(43918, 111, '2015-02-01 00:11:23.000000', 'temperatura', 183.0000, 'ºC'),
	(43919, 111, '2015-02-01 00:11:24.000000', 'temperatura', 686.0000, 'ºC'),
	(43920, 111, '2015-02-01 00:11:25.000000', 'temperatura', 479.0000, 'ºC'),
	(43921, 111, '2015-02-01 00:11:26.000000', 'temperatura', 340.0000, 'ºC'),
	(43922, 111, '2015-02-01 00:11:27.000000', 'temperatura', 262.0000, 'ºC'),
	(43923, 111, '2015-02-01 00:11:28.000000', 'temperatura', 292.0000, 'ºC'),
	(43924, 111, '2015-02-01 00:11:29.000000', 'temperatura', 673.0000, 'ºC'),
	(43925, 111, '2015-02-01 00:11:30.000000', 'temperatura', 89.0000, 'ºC'),
	(43926, 111, '2015-02-01 00:11:31.000000', 'temperatura', 826.0000, 'ºC'),
	(43927, 111, '2015-02-01 00:11:32.000000', 'temperatura', 263.0000, 'ºC'),
	(43928, 111, '2015-02-01 00:11:33.000000', 'temperatura', 39.0000, 'ºC'),
	(43929, 111, '2015-02-01 00:11:34.000000', 'temperatura', 605.0000, 'ºC'),
	(43930, 111, '2015-02-01 00:11:35.000000', 'temperatura', 507.0000, 'ºC'),
	(43931, 111, '2015-02-01 00:11:36.000000', 'temperatura', 724.0000, 'ºC'),
	(43932, 111, '2015-02-01 00:11:37.000000', 'temperatura', 899.0000, 'ºC'),
	(43933, 111, '2015-02-01 00:11:38.000000', 'temperatura', 1122.0000, 'ºC'),
	(43934, 111, '2015-02-01 00:11:39.000000', 'temperatura', 515.0000, 'ºC'),
	(43935, 111, '2015-02-01 00:11:40.000000', 'temperatura', 409.0000, 'ºC'),
	(43936, 111, '2015-02-01 00:11:41.000000', 'temperatura', 502.0000, 'ºC'),
	(43937, 111, '2015-02-01 00:11:42.000000', 'temperatura', 84.0000, 'ºC'),
	(43938, 111, '2015-02-01 00:11:43.000000', 'temperatura', 115.0000, 'ºC'),
	(43939, 111, '2015-02-01 00:11:44.000000', 'temperatura', 323.0000, 'ºC'),
	(43940, 111, '2015-02-01 00:11:45.000000', 'temperatura', 69.0000, 'ºC'),
	(43941, 111, '2015-02-01 00:11:46.000000', 'temperatura', 579.0000, 'ºC'),
	(43942, 111, '2015-02-01 00:11:47.000000', 'temperatura', 288.0000, 'ºC'),
	(43943, 111, '2015-02-01 00:11:48.000000', 'temperatura', 904.0000, 'ºC'),
	(43944, 111, '2015-02-01 00:11:49.000000', 'temperatura', 57.0000, 'ºC'),
	(43945, 111, '2015-02-01 00:11:50.000000', 'temperatura', 1174.0000, 'ºC'),
	(43946, 111, '2015-02-01 00:11:51.000000', 'temperatura', 901.0000, 'ºC'),
	(43947, 111, '2015-02-01 00:11:52.000000', 'temperatura', 980.0000, 'ºC'),
	(43948, 111, '2015-02-01 00:11:53.000000', 'temperatura', 1000.0000, 'ºC'),
	(43949, 111, '2015-02-01 00:11:54.000000', 'temperatura', 861.0000, 'ºC'),
	(43950, 111, '2015-02-01 00:11:55.000000', 'temperatura', 103.0000, 'ºC'),
	(43951, 111, '2015-02-01 00:11:56.000000', 'temperatura', 333.0000, 'ºC'),
	(43952, 111, '2015-02-01 00:11:57.000000', 'temperatura', 156.0000, 'ºC'),
	(43953, 111, '2015-02-01 00:11:58.000000', 'temperatura', 982.0000, 'ºC'),
	(43954, 111, '2015-02-01 00:11:59.000000', 'temperatura', 844.0000, 'ºC'),
	(43955, 111, '2015-02-01 00:12:00.000000', 'temperatura', 73.0000, 'ºC'),
	(43956, 111, '2015-02-01 00:12:01.000000', 'temperatura', 232.0000, 'ºC'),
	(43957, 111, '2015-02-01 00:12:02.000000', 'temperatura', 944.0000, 'ºC'),
	(43958, 111, '2015-02-01 00:12:03.000000', 'temperatura', 422.0000, 'ºC'),
	(43959, 111, '2015-02-01 00:12:04.000000', 'temperatura', 480.0000, 'ºC'),
	(43960, 111, '2015-02-01 00:12:05.000000', 'temperatura', 1134.0000, 'ºC'),
	(43961, 111, '2015-02-01 00:12:06.000000', 'temperatura', 630.0000, 'ºC'),
	(43962, 111, '2015-02-01 00:12:07.000000', 'temperatura', 948.0000, 'ºC'),
	(43963, 111, '2015-02-01 00:12:08.000000', 'temperatura', 450.0000, 'ºC'),
	(43964, 111, '2015-02-01 00:12:09.000000', 'temperatura', 609.0000, 'ºC'),
	(43965, 111, '2015-02-01 00:12:10.000000', 'temperatura', 493.0000, 'ºC'),
	(43966, 111, '2015-02-01 00:12:11.000000', 'temperatura', 641.0000, 'ºC'),
	(43967, 111, '2015-02-01 00:12:12.000000', 'temperatura', 527.0000, 'ºC'),
	(43968, 111, '2015-02-01 00:12:13.000000', 'temperatura', 712.0000, 'ºC'),
	(43969, 111, '2015-02-01 00:12:14.000000', 'temperatura', 777.0000, 'ºC'),
	(43970, 111, '2015-02-01 00:12:15.000000', 'temperatura', 552.0000, 'ºC'),
	(43971, 111, '2015-02-01 00:12:16.000000', 'temperatura', 429.0000, 'ºC'),
	(43972, 111, '2015-02-01 00:12:17.000000', 'temperatura', 490.0000, 'ºC'),
	(43973, 111, '2015-02-01 00:12:18.000000', 'temperatura', 1165.0000, 'ºC'),
	(43974, 111, '2015-02-01 00:12:19.000000', 'temperatura', 753.0000, 'ºC'),
	(43975, 111, '2015-02-01 00:12:20.000000', 'temperatura', 273.0000, 'ºC'),
	(43976, 111, '2015-02-01 00:12:21.000000', 'temperatura', 303.0000, 'ºC'),
	(43977, 111, '2015-02-01 00:12:22.000000', 'temperatura', 699.0000, 'ºC'),
	(43978, 111, '2015-02-01 00:12:23.000000', 'temperatura', 188.0000, 'ºC'),
	(43979, 111, '2015-02-01 00:12:24.000000', 'temperatura', 41.0000, 'ºC'),
	(43980, 111, '2015-02-01 00:12:25.000000', 'temperatura', 844.0000, 'ºC'),
	(43981, 111, '2015-02-01 00:12:26.000000', 'temperatura', 498.0000, 'ºC'),
	(43982, 111, '2015-02-01 00:12:27.000000', 'temperatura', 1156.0000, 'ºC'),
	(43983, 111, '2015-02-01 00:12:28.000000', 'temperatura', 686.0000, 'ºC'),
	(43984, 111, '2015-02-01 00:12:29.000000', 'temperatura', 1165.0000, 'ºC'),
	(43985, 111, '2015-02-01 00:12:30.000000', 'temperatura', 166.0000, 'ºC'),
	(43986, 111, '2015-02-01 00:12:31.000000', 'temperatura', 938.0000, 'ºC'),
	(43987, 111, '2015-02-01 00:12:32.000000', 'temperatura', 589.0000, 'ºC'),
	(43988, 111, '2015-02-01 00:12:33.000000', 'temperatura', 133.0000, 'ºC'),
	(43989, 111, '2015-02-01 00:12:34.000000', 'temperatura', 100.0000, 'ºC'),
	(43990, 111, '2015-02-01 00:12:35.000000', 'temperatura', 99.0000, 'ºC'),
	(43991, 111, '2015-02-01 00:12:36.000000', 'temperatura', 197.0000, 'ºC'),
	(43992, 111, '2015-02-01 00:12:37.000000', 'temperatura', 688.0000, 'ºC'),
	(43993, 111, '2015-02-01 00:12:38.000000', 'temperatura', 448.0000, 'ºC'),
	(43994, 111, '2015-02-01 00:12:39.000000', 'temperatura', 177.0000, 'ºC'),
	(43995, 111, '2015-02-01 00:12:40.000000', 'temperatura', 741.0000, 'ºC'),
	(43996, 111, '2015-02-01 00:12:41.000000', 'temperatura', 776.0000, 'ºC'),
	(43997, 111, '2015-02-01 00:12:42.000000', 'temperatura', 455.0000, 'ºC'),
	(43998, 111, '2015-02-01 00:12:43.000000', 'temperatura', 1151.0000, 'ºC'),
	(43999, 111, '2015-02-01 00:12:44.000000', 'temperatura', 788.0000, 'ºC'),
	(44000, 111, '2015-02-01 00:12:45.000000', 'temperatura', 488.0000, 'ºC'),
	(44001, 111, '2015-02-01 00:12:46.000000', 'temperatura', 78.0000, 'ºC'),
	(44002, 111, '2015-02-01 00:12:47.000000', 'temperatura', 126.0000, 'ºC'),
	(44003, 111, '2015-02-01 00:12:48.000000', 'temperatura', 398.0000, 'ºC'),
	(44004, 111, '2015-02-01 00:12:49.000000', 'temperatura', 410.0000, 'ºC'),
	(44005, 111, '2015-02-01 00:12:50.000000', 'temperatura', 857.0000, 'ºC'),
	(44006, 111, '2015-02-01 00:12:51.000000', 'temperatura', 655.0000, 'ºC'),
	(44007, 111, '2015-02-01 00:12:52.000000', 'temperatura', 704.0000, 'ºC'),
	(44008, 111, '2015-02-01 00:12:53.000000', 'temperatura', 355.0000, 'ºC'),
	(44009, 111, '2015-02-01 00:12:54.000000', 'temperatura', 865.0000, 'ºC'),
	(44010, 111, '2015-02-01 00:12:55.000000', 'temperatura', 861.0000, 'ºC'),
	(44011, 111, '2015-02-01 00:12:56.000000', 'temperatura', 510.0000, 'ºC'),
	(44012, 111, '2015-02-01 00:12:57.000000', 'temperatura', 1169.0000, 'ºC'),
	(44013, 111, '2015-02-01 00:12:58.000000', 'temperatura', 714.0000, 'ºC'),
	(44014, 111, '2015-02-01 00:12:59.000000', 'temperatura', 62.0000, 'ºC'),
	(44015, 111, '2015-02-01 00:13:00.000000', 'temperatura', 571.0000, 'ºC'),
	(44016, 111, '2015-02-01 00:13:01.000000', 'temperatura', 270.0000, 'ºC'),
	(44017, 111, '2015-02-01 00:13:02.000000', 'temperatura', 836.0000, 'ºC'),
	(44018, 111, '2015-02-01 00:13:03.000000', 'temperatura', 972.0000, 'ºC'),
	(44019, 111, '2015-02-01 00:13:04.000000', 'temperatura', 1153.0000, 'ºC'),
	(44020, 111, '2015-02-01 00:13:05.000000', 'temperatura', 447.0000, 'ºC'),
	(44021, 111, '2015-02-01 00:13:06.000000', 'temperatura', 1177.0000, 'ºC'),
	(44022, 111, '2015-02-01 00:13:07.000000', 'temperatura', 944.0000, 'ºC'),
	(44023, 111, '2015-02-01 00:13:08.000000', 'temperatura', 1189.0000, 'ºC'),
	(44024, 111, '2015-02-01 00:13:09.000000', 'temperatura', 715.0000, 'ºC'),
	(44025, 111, '2015-02-01 00:13:10.000000', 'temperatura', 9.0000, 'ºC'),
	(44026, 111, '2015-02-01 00:13:11.000000', 'temperatura', 299.0000, 'ºC'),
	(44027, 111, '2015-02-01 00:13:12.000000', 'temperatura', 271.0000, 'ºC'),
	(44028, 111, '2015-02-01 00:13:13.000000', 'temperatura', 457.0000, 'ºC'),
	(44029, 111, '2015-02-01 00:13:14.000000', 'temperatura', 273.0000, 'ºC'),
	(44030, 111, '2015-02-01 00:13:15.000000', 'temperatura', 1194.0000, 'ºC'),
	(44031, 111, '2015-02-01 00:13:16.000000', 'temperatura', 353.0000, 'ºC'),
	(44032, 111, '2015-02-01 00:13:17.000000', 'temperatura', 583.0000, 'ºC'),
	(44033, 111, '2015-02-01 00:13:18.000000', 'temperatura', 656.0000, 'ºC'),
	(44034, 111, '2015-02-01 00:13:19.000000', 'temperatura', 333.0000, 'ºC'),
	(44035, 111, '2015-02-01 00:13:20.000000', 'temperatura', 896.0000, 'ºC'),
	(44036, 111, '2015-02-01 00:13:21.000000', 'temperatura', 1082.0000, 'ºC'),
	(44037, 111, '2015-02-01 00:13:22.000000', 'temperatura', 323.0000, 'ºC'),
	(44038, 111, '2015-02-01 00:13:23.000000', 'temperatura', 771.0000, 'ºC'),
	(44039, 111, '2015-02-01 00:13:24.000000', 'temperatura', 485.0000, 'ºC'),
	(44040, 111, '2015-02-01 00:13:25.000000', 'temperatura', 111.0000, 'ºC'),
	(44041, 111, '2015-02-01 00:13:26.000000', 'temperatura', 302.0000, 'ºC'),
	(44042, 111, '2015-02-01 00:13:27.000000', 'temperatura', 1176.0000, 'ºC'),
	(44043, 111, '2015-02-01 00:13:28.000000', 'temperatura', 174.0000, 'ºC'),
	(44044, 111, '2015-02-01 00:13:29.000000', 'temperatura', 941.0000, 'ºC'),
	(44045, 111, '2015-02-01 00:13:30.000000', 'temperatura', 587.0000, 'ºC'),
	(44046, 111, '2015-02-01 00:13:31.000000', 'temperatura', 112.0000, 'ºC'),
	(44047, 111, '2015-02-01 00:13:32.000000', 'temperatura', 1197.0000, 'ºC'),
	(44048, 111, '2015-02-01 00:13:33.000000', 'temperatura', 851.0000, 'ºC'),
	(44049, 111, '2015-02-01 00:13:34.000000', 'temperatura', 665.0000, 'ºC'),
	(44050, 111, '2015-02-01 00:13:35.000000', 'temperatura', 774.0000, 'ºC'),
	(44051, 111, '2015-02-01 00:13:36.000000', 'temperatura', 673.0000, 'ºC'),
	(44052, 111, '2015-02-01 00:13:37.000000', 'temperatura', 1042.0000, 'ºC'),
	(44053, 111, '2015-02-01 00:13:38.000000', 'temperatura', 794.0000, 'ºC'),
	(44054, 111, '2015-02-01 00:13:39.000000', 'temperatura', 844.0000, 'ºC'),
	(44055, 111, '2015-02-01 00:13:40.000000', 'temperatura', 640.0000, 'ºC'),
	(44056, 111, '2015-02-01 00:13:41.000000', 'temperatura', 666.0000, 'ºC'),
	(44057, 111, '2015-02-01 00:13:42.000000', 'temperatura', 212.0000, 'ºC'),
	(44058, 111, '2015-02-01 00:13:43.000000', 'temperatura', 263.0000, 'ºC'),
	(44059, 111, '2015-02-01 00:13:44.000000', 'temperatura', 679.0000, 'ºC'),
	(44060, 111, '2015-02-01 00:13:45.000000', 'temperatura', 206.0000, 'ºC'),
	(44061, 111, '2015-02-01 00:13:46.000000', 'temperatura', 194.0000, 'ºC'),
	(44062, 111, '2015-02-01 00:13:47.000000', 'temperatura', 353.0000, 'ºC'),
	(44063, 111, '2015-02-01 00:13:48.000000', 'temperatura', 1181.0000, 'ºC'),
	(44064, 111, '2015-02-01 00:13:49.000000', 'temperatura', 50.0000, 'ºC'),
	(44065, 111, '2015-02-01 00:13:50.000000', 'temperatura', 304.0000, 'ºC'),
	(44066, 111, '2015-02-01 00:13:51.000000', 'temperatura', 172.0000, 'ºC'),
	(44067, 111, '2015-02-01 00:13:52.000000', 'temperatura', 1148.0000, 'ºC'),
	(44068, 111, '2015-02-01 00:13:53.000000', 'temperatura', 426.0000, 'ºC'),
	(44069, 111, '2015-02-01 00:13:54.000000', 'temperatura', 1084.0000, 'ºC'),
	(44070, 111, '2015-02-01 00:13:55.000000', 'temperatura', 543.0000, 'ºC'),
	(44071, 111, '2015-02-01 00:13:56.000000', 'temperatura', 663.0000, 'ºC'),
	(44072, 111, '2015-02-01 00:13:57.000000', 'temperatura', 488.0000, 'ºC'),
	(44073, 111, '2015-02-01 00:13:58.000000', 'temperatura', 452.0000, 'ºC'),
	(44074, 111, '2015-02-01 00:13:59.000000', 'temperatura', 794.0000, 'ºC'),
	(44075, 111, '2015-02-01 00:14:00.000000', 'temperatura', 217.0000, 'ºC'),
	(44076, 111, '2015-02-01 00:14:01.000000', 'temperatura', 1102.0000, 'ºC'),
	(44077, 111, '2015-02-01 00:14:02.000000', 'temperatura', 60.0000, 'ºC'),
	(44078, 111, '2015-02-01 00:14:03.000000', 'temperatura', 593.0000, 'ºC'),
	(44079, 111, '2015-02-01 00:14:04.000000', 'temperatura', 386.0000, 'ºC'),
	(44080, 111, '2015-02-01 00:14:05.000000', 'temperatura', 153.0000, 'ºC'),
	(44081, 111, '2015-02-01 00:14:06.000000', 'temperatura', 806.0000, 'ºC'),
	(44082, 111, '2015-02-01 00:14:07.000000', 'temperatura', 1172.0000, 'ºC'),
	(44083, 111, '2015-02-01 00:14:08.000000', 'temperatura', 1041.0000, 'ºC'),
	(44084, 111, '2015-02-01 00:14:09.000000', 'temperatura', 492.0000, 'ºC'),
	(44085, 111, '2015-02-01 00:14:10.000000', 'temperatura', 538.0000, 'ºC'),
	(44086, 111, '2015-02-01 00:14:11.000000', 'temperatura', 14.0000, 'ºC'),
	(44087, 111, '2015-02-01 00:14:12.000000', 'temperatura', 856.0000, 'ºC'),
	(44088, 111, '2015-02-01 00:14:13.000000', 'temperatura', 639.0000, 'ºC'),
	(44089, 111, '2015-02-01 00:14:14.000000', 'temperatura', 626.0000, 'ºC'),
	(44090, 111, '2015-02-01 00:14:15.000000', 'temperatura', 12.0000, 'ºC'),
	(44091, 111, '2015-02-01 00:14:16.000000', 'temperatura', 585.0000, 'ºC'),
	(44092, 111, '2015-02-01 00:14:17.000000', 'temperatura', 489.0000, 'ºC'),
	(44093, 111, '2015-02-01 00:14:18.000000', 'temperatura', 690.0000, 'ºC'),
	(44094, 111, '2015-02-01 00:14:19.000000', 'temperatura', 784.0000, 'ºC'),
	(44095, 111, '2015-02-01 00:14:20.000000', 'temperatura', 652.0000, 'ºC'),
	(44096, 111, '2015-02-01 00:14:21.000000', 'temperatura', 906.0000, 'ºC'),
	(44097, 111, '2015-02-01 00:14:22.000000', 'temperatura', 175.0000, 'ºC'),
	(44098, 111, '2015-02-01 00:14:23.000000', 'temperatura', 557.0000, 'ºC'),
	(44099, 111, '2015-02-01 00:14:24.000000', 'temperatura', 1060.0000, 'ºC'),
	(44100, 111, '2015-02-01 00:14:25.000000', 'temperatura', 30.0000, 'ºC'),
	(44101, 111, '2015-02-01 00:14:26.000000', 'temperatura', 571.0000, 'ºC'),
	(44102, 111, '2015-02-01 00:14:27.000000', 'temperatura', 365.0000, 'ºC'),
	(44103, 111, '2015-02-01 00:14:28.000000', 'temperatura', 112.0000, 'ºC'),
	(44104, 111, '2015-02-01 00:14:29.000000', 'temperatura', 665.0000, 'ºC'),
	(44105, 111, '2015-02-01 00:14:30.000000', 'temperatura', 589.0000, 'ºC'),
	(44106, 111, '2015-02-01 00:14:31.000000', 'temperatura', 950.0000, 'ºC'),
	(44107, 111, '2015-02-01 00:14:32.000000', 'temperatura', 584.0000, 'ºC'),
	(44108, 111, '2015-02-01 00:14:33.000000', 'temperatura', 70.0000, 'ºC'),
	(44109, 111, '2015-02-01 00:14:34.000000', 'temperatura', 1001.0000, 'ºC'),
	(44110, 111, '2015-02-01 00:14:35.000000', 'temperatura', 1194.0000, 'ºC'),
	(44111, 111, '2015-02-01 00:14:36.000000', 'temperatura', 568.0000, 'ºC'),
	(44112, 111, '2015-02-01 00:14:37.000000', 'temperatura', 458.0000, 'ºC'),
	(44113, 111, '2015-02-01 00:14:38.000000', 'temperatura', 585.0000, 'ºC'),
	(44114, 111, '2015-02-01 00:14:39.000000', 'temperatura', 354.0000, 'ºC'),
	(44115, 111, '2015-02-01 00:14:40.000000', 'temperatura', 14.0000, 'ºC'),
	(44116, 111, '2015-02-01 00:14:41.000000', 'temperatura', 210.0000, 'ºC'),
	(44117, 111, '2015-02-01 00:14:42.000000', 'temperatura', 1007.0000, 'ºC'),
	(44118, 111, '2015-02-01 00:14:43.000000', 'temperatura', 808.0000, 'ºC'),
	(44119, 111, '2015-02-01 00:14:44.000000', 'temperatura', 1019.0000, 'ºC'),
	(44120, 111, '2015-02-01 00:14:45.000000', 'temperatura', 269.0000, 'ºC'),
	(44121, 111, '2015-02-01 00:14:46.000000', 'temperatura', 692.0000, 'ºC'),
	(44122, 111, '2015-02-01 00:14:47.000000', 'temperatura', 251.0000, 'ºC'),
	(44123, 111, '2015-02-01 00:14:48.000000', 'temperatura', 382.0000, 'ºC'),
	(44124, 111, '2015-02-01 00:14:49.000000', 'temperatura', 1156.0000, 'ºC'),
	(44125, 111, '2015-02-01 00:14:50.000000', 'temperatura', 1036.0000, 'ºC'),
	(44126, 111, '2015-02-01 00:14:51.000000', 'temperatura', 510.0000, 'ºC'),
	(44127, 111, '2015-02-01 00:14:52.000000', 'temperatura', 642.0000, 'ºC'),
	(44128, 111, '2015-02-01 00:14:53.000000', 'temperatura', 481.0000, 'ºC'),
	(44129, 111, '2015-02-01 00:14:54.000000', 'temperatura', 479.0000, 'ºC'),
	(44130, 111, '2015-02-01 00:14:55.000000', 'temperatura', 953.0000, 'ºC'),
	(44131, 111, '2015-02-01 00:14:56.000000', 'temperatura', 930.0000, 'ºC'),
	(44132, 111, '2015-02-01 00:14:57.000000', 'temperatura', 592.0000, 'ºC'),
	(44133, 111, '2015-02-01 00:14:58.000000', 'temperatura', 168.0000, 'ºC'),
	(44134, 111, '2015-02-01 00:14:59.000000', 'temperatura', 264.0000, 'ºC'),
	(44135, 111, '2015-02-01 00:15:00.000000', 'temperatura', 818.0000, 'ºC'),
	(44136, 111, '2015-02-01 00:15:01.000000', 'temperatura', 899.0000, 'ºC'),
	(44137, 111, '2015-02-01 00:15:02.000000', 'temperatura', 841.0000, 'ºC'),
	(44138, 111, '2015-02-01 00:15:03.000000', 'temperatura', 310.0000, 'ºC'),
	(44139, 111, '2015-02-01 00:15:04.000000', 'temperatura', 226.0000, 'ºC'),
	(44140, 111, '2015-02-01 00:15:05.000000', 'temperatura', 201.0000, 'ºC'),
	(44141, 111, '2015-02-01 00:15:06.000000', 'temperatura', 327.0000, 'ºC'),
	(44142, 111, '2015-02-01 00:15:07.000000', 'temperatura', 1033.0000, 'ºC'),
	(44143, 111, '2015-02-01 00:15:08.000000', 'temperatura', 583.0000, 'ºC'),
	(44144, 111, '2015-02-01 00:15:09.000000', 'temperatura', 1017.0000, 'ºC'),
	(44145, 111, '2015-02-01 00:15:10.000000', 'temperatura', 938.0000, 'ºC'),
	(44146, 111, '2015-02-01 00:15:11.000000', 'temperatura', 440.0000, 'ºC'),
	(44147, 111, '2015-02-01 00:15:12.000000', 'temperatura', 585.0000, 'ºC'),
	(44148, 111, '2015-02-01 00:15:13.000000', 'temperatura', 405.0000, 'ºC'),
	(44149, 111, '2015-02-01 00:15:14.000000', 'temperatura', 271.0000, 'ºC'),
	(44150, 111, '2015-02-01 00:15:15.000000', 'temperatura', 138.0000, 'ºC'),
	(44151, 111, '2015-02-01 00:15:16.000000', 'temperatura', 1081.0000, 'ºC'),
	(44152, 111, '2015-02-01 00:15:17.000000', 'temperatura', 191.0000, 'ºC'),
	(44153, 111, '2015-02-01 00:15:18.000000', 'temperatura', 113.0000, 'ºC'),
	(44154, 111, '2015-02-01 00:15:19.000000', 'temperatura', 1193.0000, 'ºC'),
	(44155, 111, '2015-02-01 00:15:20.000000', 'temperatura', 824.0000, 'ºC'),
	(44156, 111, '2015-02-01 00:15:21.000000', 'temperatura', 542.0000, 'ºC'),
	(44157, 111, '2015-02-01 00:15:22.000000', 'temperatura', 238.0000, 'ºC'),
	(44158, 111, '2015-02-01 00:15:23.000000', 'temperatura', 765.0000, 'ºC'),
	(44159, 111, '2015-02-01 00:15:24.000000', 'temperatura', 712.0000, 'ºC'),
	(44160, 111, '2015-02-01 00:15:25.000000', 'temperatura', 63.0000, 'ºC'),
	(44161, 111, '2015-02-01 00:15:26.000000', 'temperatura', 583.0000, 'ºC'),
	(44162, 111, '2015-02-01 00:15:27.000000', 'temperatura', 326.0000, 'ºC'),
	(44163, 111, '2015-02-01 00:15:28.000000', 'temperatura', 1079.0000, 'ºC'),
	(44164, 111, '2015-02-01 00:15:29.000000', 'temperatura', 818.0000, 'ºC'),
	(44165, 111, '2015-02-01 00:15:30.000000', 'temperatura', 853.0000, 'ºC'),
	(44166, 111, '2015-02-01 00:15:31.000000', 'temperatura', 614.0000, 'ºC'),
	(44167, 111, '2015-02-01 00:15:32.000000', 'temperatura', 510.0000, 'ºC'),
	(44168, 111, '2015-02-01 00:15:33.000000', 'temperatura', 709.0000, 'ºC'),
	(44169, 111, '2015-02-01 00:15:34.000000', 'temperatura', 816.0000, 'ºC'),
	(44170, 111, '2015-02-01 00:15:35.000000', 'temperatura', 753.0000, 'ºC'),
	(44171, 111, '2015-02-01 00:15:36.000000', 'temperatura', 117.0000, 'ºC'),
	(44172, 111, '2015-02-01 00:15:37.000000', 'temperatura', 727.0000, 'ºC'),
	(44173, 111, '2015-02-01 00:15:38.000000', 'temperatura', 885.0000, 'ºC'),
	(44174, 111, '2015-02-01 00:15:39.000000', 'temperatura', 1044.0000, 'ºC'),
	(44175, 111, '2015-02-01 00:15:40.000000', 'temperatura', 167.0000, 'ºC'),
	(44176, 111, '2015-02-01 00:15:41.000000', 'temperatura', 101.0000, 'ºC'),
	(44177, 111, '2015-02-01 00:15:42.000000', 'temperatura', 5.0000, 'ºC'),
	(44178, 111, '2015-02-01 00:15:43.000000', 'temperatura', 922.0000, 'ºC'),
	(44179, 111, '2015-02-01 00:15:44.000000', 'temperatura', 995.0000, 'ºC'),
	(44180, 111, '2015-02-01 00:15:45.000000', 'temperatura', 1008.0000, 'ºC'),
	(44181, 111, '2015-02-01 00:15:46.000000', 'temperatura', 858.0000, 'ºC'),
	(44182, 111, '2015-02-01 00:15:47.000000', 'temperatura', 66.0000, 'ºC'),
	(44183, 111, '2015-02-01 00:15:48.000000', 'temperatura', 156.0000, 'ºC'),
	(44184, 111, '2015-02-01 00:15:49.000000', 'temperatura', 585.0000, 'ºC'),
	(44185, 111, '2015-02-01 00:15:50.000000', 'temperatura', 55.0000, 'ºC'),
	(44186, 111, '2015-02-01 00:15:51.000000', 'temperatura', 923.0000, 'ºC'),
	(44187, 111, '2015-02-01 00:15:52.000000', 'temperatura', 850.0000, 'ºC'),
	(44188, 111, '2015-02-01 00:15:53.000000', 'temperatura', 279.0000, 'ºC'),
	(44189, 111, '2015-02-01 00:15:54.000000', 'temperatura', 47.0000, 'ºC'),
	(44190, 111, '2015-02-01 00:15:55.000000', 'temperatura', 599.0000, 'ºC'),
	(44191, 111, '2015-02-01 00:15:56.000000', 'temperatura', 455.0000, 'ºC'),
	(44192, 111, '2015-02-01 00:15:57.000000', 'temperatura', 479.0000, 'ºC'),
	(44193, 111, '2015-02-01 00:15:58.000000', 'temperatura', 1032.0000, 'ºC'),
	(44194, 111, '2015-02-01 00:15:59.000000', 'temperatura', 121.0000, 'ºC'),
	(44195, 111, '2015-02-01 00:16:00.000000', 'temperatura', 1109.0000, 'ºC'),
	(44196, 111, '2015-02-01 00:16:01.000000', 'temperatura', 382.0000, 'ºC'),
	(44197, 111, '2015-02-01 00:16:02.000000', 'temperatura', 986.0000, 'ºC'),
	(44198, 111, '2015-02-01 00:16:03.000000', 'temperatura', 184.0000, 'ºC'),
	(44199, 111, '2015-02-01 00:16:04.000000', 'temperatura', 364.0000, 'ºC'),
	(44200, 111, '2015-02-01 00:16:05.000000', 'temperatura', 66.0000, 'ºC'),
	(44201, 111, '2015-02-01 00:16:06.000000', 'temperatura', 441.0000, 'ºC'),
	(44202, 111, '2015-02-01 00:16:07.000000', 'temperatura', 806.0000, 'ºC'),
	(44203, 111, '2015-02-01 00:16:08.000000', 'temperatura', 306.0000, 'ºC'),
	(44204, 111, '2015-02-01 00:16:09.000000', 'temperatura', 314.0000, 'ºC'),
	(44205, 111, '2015-02-01 00:16:10.000000', 'temperatura', 651.0000, 'ºC'),
	(44206, 111, '2015-02-01 00:16:11.000000', 'temperatura', 1113.0000, 'ºC'),
	(44207, 111, '2015-02-01 00:16:12.000000', 'temperatura', 12.0000, 'ºC'),
	(44208, 111, '2015-02-01 00:16:13.000000', 'temperatura', 321.0000, 'ºC'),
	(44209, 111, '2015-02-01 00:16:14.000000', 'temperatura', 371.0000, 'ºC'),
	(44210, 111, '2015-02-01 00:16:15.000000', 'temperatura', 893.0000, 'ºC'),
	(44211, 111, '2015-02-01 00:16:16.000000', 'temperatura', 952.0000, 'ºC'),
	(44212, 111, '2015-02-01 00:16:17.000000', 'temperatura', 882.0000, 'ºC'),
	(44213, 111, '2015-02-01 00:16:18.000000', 'temperatura', 353.0000, 'ºC'),
	(44214, 111, '2015-02-01 00:16:19.000000', 'temperatura', 321.0000, 'ºC'),
	(44215, 111, '2015-02-01 00:16:20.000000', 'temperatura', 544.0000, 'ºC'),
	(44216, 111, '2015-02-01 00:16:21.000000', 'temperatura', 560.0000, 'ºC'),
	(44217, 111, '2015-02-01 00:16:22.000000', 'temperatura', 1169.0000, 'ºC'),
	(44218, 111, '2015-02-01 00:16:23.000000', 'temperatura', 567.0000, 'ºC'),
	(44219, 111, '2015-02-01 00:16:24.000000', 'temperatura', 526.0000, 'ºC'),
	(44220, 111, '2015-02-01 00:16:25.000000', 'temperatura', 929.0000, 'ºC'),
	(44221, 111, '2015-02-01 00:16:26.000000', 'temperatura', 667.0000, 'ºC'),
	(44222, 111, '2015-02-01 00:16:27.000000', 'temperatura', 548.0000, 'ºC'),
	(44223, 111, '2015-02-01 00:16:28.000000', 'temperatura', 740.0000, 'ºC'),
	(44224, 111, '2015-02-01 00:16:29.000000', 'temperatura', 856.0000, 'ºC'),
	(44225, 111, '2015-02-01 00:16:30.000000', 'temperatura', 860.0000, 'ºC'),
	(44226, 111, '2015-02-01 00:16:31.000000', 'temperatura', 533.0000, 'ºC'),
	(44227, 111, '2015-02-01 00:16:32.000000', 'temperatura', 87.0000, 'ºC'),
	(44228, 111, '2015-02-01 00:16:33.000000', 'temperatura', 35.0000, 'ºC'),
	(44229, 111, '2015-02-01 00:16:34.000000', 'temperatura', 1113.0000, 'ºC'),
	(44230, 111, '2015-02-01 00:16:35.000000', 'temperatura', 662.0000, 'ºC'),
	(44231, 111, '2015-02-01 00:16:36.000000', 'temperatura', 1170.0000, 'ºC'),
	(44232, 111, '2015-02-01 00:16:37.000000', 'temperatura', 267.0000, 'ºC'),
	(44233, 111, '2015-02-01 00:16:38.000000', 'temperatura', 226.0000, 'ºC'),
	(44234, 111, '2015-02-01 00:16:39.000000', 'temperatura', 327.0000, 'ºC'),
	(44235, 111, '2015-02-01 00:16:40.000000', 'temperatura', 960.0000, 'ºC'),
	(44236, 111, '2015-02-01 00:16:41.000000', 'temperatura', 216.0000, 'ºC'),
	(44237, 111, '2015-02-01 00:16:42.000000', 'temperatura', 604.0000, 'ºC'),
	(44238, 111, '2015-02-01 00:16:43.000000', 'temperatura', 1170.0000, 'ºC'),
	(44239, 111, '2015-02-01 00:16:44.000000', 'temperatura', 438.0000, 'ºC'),
	(44240, 111, '2015-02-01 00:16:45.000000', 'temperatura', 1083.0000, 'ºC'),
	(44241, 111, '2015-02-01 00:16:46.000000', 'temperatura', 502.0000, 'ºC'),
	(44242, 111, '2015-02-01 00:16:47.000000', 'temperatura', 462.0000, 'ºC'),
	(44243, 111, '2015-02-01 00:16:48.000000', 'temperatura', 802.0000, 'ºC'),
	(44244, 111, '2015-02-01 00:16:49.000000', 'temperatura', 224.0000, 'ºC'),
	(44245, 111, '2015-02-01 00:16:50.000000', 'temperatura', 1114.0000, 'ºC'),
	(44246, 111, '2015-02-01 00:16:51.000000', 'temperatura', 98.0000, 'ºC'),
	(44247, 111, '2015-02-01 00:16:52.000000', 'temperatura', 748.0000, 'ºC'),
	(44248, 111, '2015-02-01 00:16:53.000000', 'temperatura', 1048.0000, 'ºC'),
	(44249, 111, '2015-02-01 00:16:54.000000', 'temperatura', 595.0000, 'ºC'),
	(44250, 111, '2015-02-01 00:16:55.000000', 'temperatura', 1032.0000, 'ºC'),
	(44251, 111, '2015-02-01 00:16:56.000000', 'temperatura', 974.0000, 'ºC'),
	(44252, 111, '2015-02-01 00:16:57.000000', 'temperatura', 575.0000, 'ºC'),
	(44253, 111, '2015-02-01 00:16:58.000000', 'temperatura', 1153.0000, 'ºC'),
	(44254, 111, '2015-02-01 00:16:59.000000', 'temperatura', 440.0000, 'ºC'),
	(44255, 111, '2015-02-01 00:17:00.000000', 'temperatura', 1144.0000, 'ºC'),
	(44256, 111, '2015-02-01 00:17:01.000000', 'temperatura', 800.0000, 'ºC'),
	(44257, 111, '2015-02-01 00:17:02.000000', 'temperatura', 567.0000, 'ºC'),
	(44258, 111, '2015-02-01 00:17:03.000000', 'temperatura', 435.0000, 'ºC'),
	(44259, 111, '2015-02-01 00:17:04.000000', 'temperatura', 474.0000, 'ºC'),
	(44260, 111, '2015-02-01 00:17:05.000000', 'temperatura', 1064.0000, 'ºC'),
	(44261, 111, '2015-02-01 00:17:06.000000', 'temperatura', 302.0000, 'ºC'),
	(44262, 111, '2015-02-01 00:17:07.000000', 'temperatura', 715.0000, 'ºC'),
	(44263, 111, '2015-02-01 00:17:08.000000', 'temperatura', 272.0000, 'ºC'),
	(44264, 111, '2015-02-01 00:17:09.000000', 'temperatura', 413.0000, 'ºC'),
	(44265, 111, '2015-02-01 00:17:10.000000', 'temperatura', 53.0000, 'ºC'),
	(44266, 111, '2015-02-01 00:17:11.000000', 'temperatura', 224.0000, 'ºC'),
	(44267, 111, '2015-02-01 00:17:12.000000', 'temperatura', 963.0000, 'ºC'),
	(44268, 111, '2015-02-01 00:17:13.000000', 'temperatura', 543.0000, 'ºC'),
	(44269, 111, '2015-02-01 00:17:14.000000', 'temperatura', 1027.0000, 'ºC'),
	(44270, 111, '2015-02-01 00:17:15.000000', 'temperatura', 1107.0000, 'ºC'),
	(44271, 111, '2015-02-01 00:17:16.000000', 'temperatura', 56.0000, 'ºC'),
	(44272, 111, '2015-02-01 00:17:17.000000', 'temperatura', 556.0000, 'ºC'),
	(44273, 111, '2015-02-01 00:17:18.000000', 'temperatura', 214.0000, 'ºC'),
	(44274, 111, '2015-02-01 00:17:19.000000', 'temperatura', 601.0000, 'ºC'),
	(44275, 111, '2015-02-01 00:17:20.000000', 'temperatura', 1163.0000, 'ºC'),
	(44276, 111, '2015-02-01 00:17:21.000000', 'temperatura', 413.0000, 'ºC'),
	(44277, 111, '2015-02-01 00:17:22.000000', 'temperatura', 977.0000, 'ºC'),
	(44278, 111, '2015-02-01 00:17:23.000000', 'temperatura', 47.0000, 'ºC'),
	(44279, 111, '2015-02-01 00:17:24.000000', 'temperatura', 905.0000, 'ºC'),
	(44280, 111, '2015-02-01 00:17:25.000000', 'temperatura', 786.0000, 'ºC'),
	(44281, 111, '2015-02-01 00:17:26.000000', 'temperatura', 13.0000, 'ºC'),
	(44282, 111, '2015-02-01 00:17:27.000000', 'temperatura', 109.0000, 'ºC'),
	(44283, 111, '2015-02-01 00:17:28.000000', 'temperatura', 507.0000, 'ºC'),
	(44284, 111, '2015-02-01 00:17:29.000000', 'temperatura', 1006.0000, 'ºC'),
	(44285, 111, '2015-02-01 00:17:30.000000', 'temperatura', 1109.0000, 'ºC'),
	(44286, 111, '2015-02-01 00:17:31.000000', 'temperatura', 130.0000, 'ºC'),
	(44287, 111, '2015-02-01 00:17:32.000000', 'temperatura', 922.0000, 'ºC'),
	(44288, 111, '2015-02-01 00:17:33.000000', 'temperatura', 620.0000, 'ºC'),
	(44289, 111, '2015-02-01 00:17:34.000000', 'temperatura', 336.0000, 'ºC'),
	(44290, 111, '2015-02-01 00:17:35.000000', 'temperatura', 1019.0000, 'ºC'),
	(44291, 111, '2015-02-01 00:17:36.000000', 'temperatura', 490.0000, 'ºC'),
	(44292, 111, '2015-02-01 00:17:37.000000', 'temperatura', 593.0000, 'ºC'),
	(44293, 111, '2015-02-01 00:17:38.000000', 'temperatura', 295.0000, 'ºC'),
	(44294, 111, '2015-02-01 00:17:39.000000', 'temperatura', 898.0000, 'ºC'),
	(44295, 111, '2015-02-01 00:17:40.000000', 'temperatura', 2.0000, 'ºC'),
	(44296, 111, '2015-02-01 00:17:41.000000', 'temperatura', 920.0000, 'ºC'),
	(44297, 111, '2015-02-01 00:17:42.000000', 'temperatura', 995.0000, 'ºC'),
	(44298, 111, '2015-02-01 00:17:43.000000', 'temperatura', 1012.0000, 'ºC'),
	(44299, 111, '2015-02-01 00:17:44.000000', 'temperatura', 879.0000, 'ºC'),
	(44300, 111, '2015-02-01 00:17:45.000000', 'temperatura', 159.0000, 'ºC'),
	(44301, 111, '2015-02-01 00:17:46.000000', 'temperatura', 556.0000, 'ºC'),
	(44302, 111, '2015-02-01 00:17:47.000000', 'temperatura', 1105.0000, 'ºC'),
	(44303, 111, '2015-02-01 00:17:48.000000', 'temperatura', 259.0000, 'ºC'),
	(44304, 111, '2015-02-01 00:17:49.000000', 'temperatura', 378.0000, 'ºC'),
	(44305, 111, '2015-02-01 00:17:50.000000', 'temperatura', 1115.0000, 'ºC'),
	(44306, 111, '2015-02-01 00:17:51.000000', 'temperatura', 840.0000, 'ºC'),
	(44307, 111, '2015-02-01 00:17:52.000000', 'temperatura', 856.0000, 'ºC'),
	(44308, 111, '2015-02-01 00:17:53.000000', 'temperatura', 560.0000, 'ºC'),
	(44309, 111, '2015-02-01 00:17:54.000000', 'temperatura', 233.0000, 'ºC'),
	(44310, 111, '2015-02-01 00:17:55.000000', 'temperatura', 685.0000, 'ºC'),
	(44311, 111, '2015-02-01 00:17:56.000000', 'temperatura', 325.0000, 'ºC'),
	(44312, 111, '2015-02-01 00:17:57.000000', 'temperatura', 772.0000, 'ºC'),
	(44313, 111, '2015-02-01 00:17:58.000000', 'temperatura', 485.0000, 'ºC'),
	(44314, 111, '2015-02-01 00:17:59.000000', 'temperatura', 108.0000, 'ºC'),
	(44315, 111, '2015-02-01 00:18:00.000000', 'temperatura', 286.0000, 'ºC'),
	(44316, 111, '2015-02-01 00:18:01.000000', 'temperatura', 1108.0000, 'ºC'),
	(44317, 111, '2015-02-01 00:18:02.000000', 'temperatura', 1082.0000, 'ºC'),
	(44318, 111, '2015-02-01 00:18:03.000000', 'temperatura', 888.0000, 'ºC'),
	(44319, 111, '2015-02-01 00:18:04.000000', 'temperatura', 1195.0000, 'ºC'),
	(44320, 111, '2015-02-01 00:18:05.000000', 'temperatura', 911.0000, 'ºC'),
	(44321, 111, '2015-02-01 00:18:06.000000', 'temperatura', 970.0000, 'ºC'),
	(44322, 111, '2015-02-01 00:18:07.000000', 'temperatura', 917.0000, 'ºC'),
	(44323, 111, '2015-02-01 00:18:08.000000', 'temperatura', 474.0000, 'ºC'),
	(44324, 111, '2015-02-01 00:18:09.000000', 'temperatura', 820.0000, 'ºC'),
	(44325, 111, '2015-02-01 00:18:10.000000', 'temperatura', 280.0000, 'ºC'),
	(44326, 111, '2015-02-01 00:18:11.000000', 'temperatura', 139.0000, 'ºC'),
	(44327, 111, '2015-02-01 00:18:12.000000', 'temperatura', 1055.0000, 'ºC'),
	(44328, 111, '2015-02-01 00:18:13.000000', 'temperatura', 57.0000, 'ºC'),
	(44329, 111, '2015-02-01 00:18:14.000000', 'temperatura', 724.0000, 'ºC'),
	(44330, 111, '2015-02-01 00:18:15.000000', 'temperatura', 1048.0000, 'ºC'),
	(44331, 111, '2015-02-01 00:18:16.000000', 'temperatura', 668.0000, 'ºC'),
	(44332, 111, '2015-02-01 00:18:17.000000', 'temperatura', 198.0000, 'ºC'),
	(44333, 111, '2015-02-01 00:18:18.000000', 'temperatura', 186.0000, 'ºC'),
	(44334, 111, '2015-02-01 00:18:19.000000', 'temperatura', 336.0000, 'ºC'),
	(44335, 111, '2015-02-01 00:18:20.000000', 'temperatura', 1121.0000, 'ºC'),
	(44336, 111, '2015-02-01 00:18:21.000000', 'temperatura', 997.0000, 'ºC'),
	(44337, 111, '2015-02-01 00:18:22.000000', 'temperatura', 423.0000, 'ºC'),
	(44338, 111, '2015-02-01 00:18:23.000000', 'temperatura', 326.0000, 'ºC'),
	(44339, 111, '2015-02-01 00:18:24.000000', 'temperatura', 361.0000, 'ºC'),
	(44340, 111, '2015-02-01 00:18:25.000000', 'temperatura', 827.0000, 'ºC'),
	(44341, 111, '2015-02-01 00:18:26.000000', 'temperatura', 652.0000, 'ºC'),
	(44342, 111, '2015-02-01 00:18:27.000000', 'temperatura', 779.0000, 'ºC'),
	(44343, 111, '2015-02-01 00:18:28.000000', 'temperatura', 742.0000, 'ºC'),
	(44344, 111, '2015-02-01 00:18:29.000000', 'temperatura', 173.0000, 'ºC'),
	(44345, 111, '2015-02-01 00:18:30.000000', 'temperatura', 1039.0000, 'ºC'),
	(44346, 111, '2015-02-01 00:18:31.000000', 'temperatura', 1078.0000, 'ºC'),
	(44347, 111, '2015-02-01 00:18:32.000000', 'temperatura', 1074.0000, 'ºC'),
	(44348, 111, '2015-02-01 00:18:33.000000', 'temperatura', 934.0000, 'ºC'),
	(44349, 111, '2015-02-01 00:18:34.000000', 'temperatura', 247.0000, 'ºC'),
	(44350, 111, '2015-02-01 00:18:35.000000', 'temperatura', 837.0000, 'ºC'),
	(44351, 111, '2015-02-01 00:18:36.000000', 'temperatura', 1043.0000, 'ºC'),
	(44352, 111, '2015-02-01 00:18:37.000000', 'temperatura', 304.0000, 'ºC'),
	(44353, 111, '2015-02-01 00:18:38.000000', 'temperatura', 790.0000, 'ºC'),
	(44354, 111, '2015-02-01 00:18:39.000000', 'temperatura', 640.0000, 'ºC'),
	(44355, 111, '2015-02-01 00:18:40.000000', 'temperatura', 830.0000, 'ºC'),
	(44356, 111, '2015-02-01 00:18:41.000000', 'temperatura', 1030.0000, 'ºC'),
	(44357, 111, '2015-02-01 00:18:42.000000', 'temperatura', 261.0000, 'ºC'),
	(44358, 111, '2015-02-01 00:18:43.000000', 'temperatura', 614.0000, 'ºC'),
	(44359, 111, '2015-02-01 00:18:44.000000', 'temperatura', 1090.0000, 'ºC'),
	(44360, 111, '2015-02-01 00:18:45.000000', 'temperatura', 9.0000, 'ºC'),
	(44361, 111, '2015-02-01 00:18:46.000000', 'temperatura', 374.0000, 'ºC'),
	(44362, 111, '2015-02-01 00:18:47.000000', 'temperatura', 643.0000, 'ºC'),
	(44363, 111, '2015-02-01 00:18:48.000000', 'temperatura', 894.0000, 'ºC'),
	(44364, 111, '2015-02-01 00:18:49.000000', 'temperatura', 140.0000, 'ºC'),
	(44365, 111, '2015-02-01 00:18:50.000000', 'temperatura', 419.0000, 'ºC'),
	(44366, 111, '2015-02-01 00:18:51.000000', 'temperatura', 475.0000, 'ºC'),
	(44367, 111, '2015-02-01 00:18:52.000000', 'temperatura', 1119.0000, 'ºC'),
	(44368, 111, '2015-02-01 00:18:53.000000', 'temperatura', 570.0000, 'ºC'),
	(44369, 111, '2015-02-01 00:18:54.000000', 'temperatura', 695.0000, 'ºC'),
	(44370, 111, '2015-02-01 00:18:55.000000', 'temperatura', 565.0000, 'ºC'),
	(44371, 111, '2015-02-01 00:18:56.000000', 'temperatura', 741.0000, 'ºC'),
	(44372, 111, '2015-02-01 00:18:57.000000', 'temperatura', 810.0000, 'ºC'),
	(44373, 111, '2015-02-01 00:18:58.000000', 'temperatura', 628.0000, 'ºC'),
	(44374, 111, '2015-02-01 00:18:59.000000', 'temperatura', 712.0000, 'ºC'),
	(44375, 111, '2015-02-01 00:19:00.000000', 'temperatura', 476.0000, 'ºC'),
	(44376, 111, '2015-02-01 00:19:01.000000', 'temperatura', 244.0000, 'ºC'),
	(44377, 111, '2015-02-01 00:19:02.000000', 'temperatura', 994.0000, 'ºC'),
	(44378, 111, '2015-02-01 00:19:03.000000', 'temperatura', 639.0000, 'ºC'),
	(44379, 111, '2015-02-01 00:19:04.000000', 'temperatura', 212.0000, 'ºC'),
	(44380, 111, '2015-02-01 00:19:05.000000', 'temperatura', 344.0000, 'ºC'),
	(44381, 111, '2015-02-01 00:19:06.000000', 'temperatura', 1085.0000, 'ºC'),
	(44382, 111, '2015-02-01 00:19:07.000000', 'temperatura', 793.0000, 'ºC'),
	(44383, 111, '2015-02-01 00:19:08.000000', 'temperatura', 712.0000, 'ºC'),
	(44384, 111, '2015-02-01 00:19:09.000000', 'temperatura', 1182.0000, 'ºC'),
	(44385, 111, '2015-02-01 00:19:10.000000', 'temperatura', 175.0000, 'ºC'),
	(44386, 111, '2015-02-01 00:19:11.000000', 'temperatura', 930.0000, 'ºC'),
	(44387, 111, '2015-02-01 00:19:12.000000', 'temperatura', 523.0000, 'ºC'),
	(44388, 111, '2015-02-01 00:19:13.000000', 'temperatura', 1027.0000, 'ºC'),
	(44389, 111, '2015-02-01 00:19:14.000000', 'temperatura', 1165.0000, 'ºC'),
	(44390, 111, '2015-02-01 00:19:15.000000', 'temperatura', 344.0000, 'ºC'),
	(44391, 111, '2015-02-01 00:19:16.000000', 'temperatura', 626.0000, 'ºC'),
	(44392, 111, '2015-02-01 00:19:17.000000', 'temperatura', 898.0000, 'ºC'),
	(44393, 111, '2015-02-01 00:19:18.000000', 'temperatura', 214.0000, 'ºC'),
	(44394, 111, '2015-02-01 00:19:19.000000', 'temperatura', 776.0000, 'ºC'),
	(44395, 111, '2015-02-01 00:19:20.000000', 'temperatura', 837.0000, 'ºC'),
	(44396, 111, '2015-02-01 00:19:21.000000', 'temperatura', 659.0000, 'ºC'),
	(44397, 111, '2015-02-01 00:19:22.000000', 'temperatura', 783.0000, 'ºC'),
	(44398, 111, '2015-02-01 00:19:23.000000', 'temperatura', 738.0000, 'ºC'),
	(44399, 111, '2015-02-01 00:19:24.000000', 'temperatura', 141.0000, 'ºC'),
	(44400, 111, '2015-02-01 00:19:25.000000', 'temperatura', 893.0000, 'ºC'),
	(44401, 111, '2015-02-01 00:19:26.000000', 'temperatura', 442.0000, 'ºC'),
	(44402, 111, '2015-02-01 00:19:27.000000', 'temperatura', 733.0000, 'ºC'),
	(44403, 111, '2015-02-01 00:19:28.000000', 'temperatura', 1137.0000, 'ºC'),
	(44404, 111, '2015-02-01 00:19:29.000000', 'temperatura', 1086.0000, 'ºC'),
	(44405, 111, '2015-02-01 00:19:30.000000', 'temperatura', 821.0000, 'ºC'),
	(44406, 111, '2015-02-01 00:19:31.000000', 'temperatura', 849.0000, 'ºC'),
	(44407, 111, '2015-02-01 00:19:32.000000', 'temperatura', 580.0000, 'ºC'),
	(44408, 111, '2015-02-01 00:19:33.000000', 'temperatura', 355.0000, 'ºC'),
	(44409, 111, '2015-02-01 00:19:34.000000', 'temperatura', 35.0000, 'ºC'),
	(44410, 111, '2015-02-01 00:19:35.000000', 'temperatura', 311.0000, 'ºC'),
	(44411, 111, '2015-02-01 00:19:36.000000', 'temperatura', 250.0000, 'ºC'),
	(44412, 111, '2015-02-01 00:19:37.000000', 'temperatura', 316.0000, 'ºC'),
	(44413, 111, '2015-02-01 00:19:38.000000', 'temperatura', 833.0000, 'ºC'),
	(44414, 111, '2015-02-01 00:19:39.000000', 'temperatura', 816.0000, 'ºC'),
	(44415, 111, '2015-02-01 00:19:40.000000', 'temperatura', 381.0000, 'ºC'),
	(44416, 111, '2015-02-01 00:19:41.000000', 'temperatura', 657.0000, 'ºC'),
	(44417, 111, '2015-02-01 00:19:42.000000', 'temperatura', 941.0000, 'ºC'),
	(44418, 111, '2015-02-01 00:19:43.000000', 'temperatura', 337.0000, 'ºC'),
	(44419, 111, '2015-02-01 00:19:44.000000', 'temperatura', 61.0000, 'ºC'),
	(44420, 111, '2015-02-01 00:19:45.000000', 'temperatura', 495.0000, 'ºC'),
	(44421, 111, '2015-02-01 00:19:46.000000', 'temperatura', 1091.0000, 'ºC'),
	(44422, 111, '2015-02-01 00:19:47.000000', 'temperatura', 370.0000, 'ºC'),
	(44423, 111, '2015-02-01 00:19:48.000000', 'temperatura', 979.0000, 'ºC'),
	(44424, 111, '2015-02-01 00:19:49.000000', 'temperatura', 184.0000, 'ºC'),
	(44425, 111, '2015-02-01 00:19:50.000000', 'temperatura', 383.0000, 'ºC'),
	(44426, 111, '2015-02-01 00:19:51.000000', 'temperatura', 163.0000, 'ºC'),
	(44427, 111, '2015-02-01 00:19:52.000000', 'temperatura', 868.0000, 'ºC'),
	(44428, 111, '2015-02-01 00:19:53.000000', 'temperatura', 252.0000, 'ºC'),
	(44429, 111, '2015-02-01 00:19:54.000000', 'temperatura', 1056.0000, 'ºC'),
	(44430, 111, '2015-02-01 00:19:55.000000', 'temperatura', 924.0000, 'ºC'),
	(44431, 111, '2015-02-01 00:19:56.000000', 'temperatura', 254.0000, 'ºC'),
	(44432, 111, '2015-02-01 00:19:57.000000', 'temperatura', 896.0000, 'ºC'),
	(44433, 111, '2015-02-01 00:19:58.000000', 'temperatura', 119.0000, 'ºC'),
	(44434, 111, '2015-02-01 00:19:59.000000', 'temperatura', 307.0000, 'ºC'),
	(44435, 111, '2015-02-01 00:20:00.000000', 'temperatura', 1178.0000, 'ºC'),
	(44436, 111, '2015-02-01 00:20:01.000000', 'temperatura', 169.0000, 'ºC'),
	(44437, 111, '2015-02-01 00:20:02.000000', 'temperatura', 912.0000, 'ºC'),
	(44438, 111, '2015-02-01 00:20:03.000000', 'temperatura', 452.0000, 'ºC'),
	(44439, 111, '2015-02-01 00:20:04.000000', 'temperatura', 727.0000, 'ºC'),
	(44440, 111, '2015-02-01 00:20:05.000000', 'temperatura', 1080.0000, 'ºC'),
	(44441, 111, '2015-02-01 00:20:06.000000', 'temperatura', 820.0000, 'ºC'),
	(44442, 111, '2015-02-01 00:20:07.000000', 'temperatura', 861.0000, 'ºC'),
	(44443, 111, '2015-02-01 00:20:08.000000', 'temperatura', 646.0000, 'ºC'),
	(44444, 111, '2015-02-01 00:20:09.000000', 'temperatura', 645.0000, 'ºC'),
	(44445, 111, '2015-02-01 00:20:10.000000', 'temperatura', 88.0000, 'ºC'),
	(44446, 111, '2015-02-01 00:20:11.000000', 'temperatura', 904.0000, 'ºC'),
	(44447, 111, '2015-02-01 00:20:12.000000', 'temperatura', 659.0000, 'ºC'),
	(44448, 111, '2015-02-01 00:20:13.000000', 'temperatura', 583.0000, 'ºC'),
	(44449, 111, '2015-02-01 00:20:14.000000', 'temperatura', 938.0000, 'ºC'),
	(44450, 111, '2015-02-01 00:20:15.000000', 'temperatura', 541.0000, 'ºC'),
	(44451, 111, '2015-02-01 00:20:16.000000', 'temperatura', 1093.0000, 'ºC'),
	(44452, 111, '2015-02-01 00:20:17.000000', 'temperatura', 243.0000, 'ºC'),
	(44453, 111, '2015-02-01 00:20:18.000000', 'temperatura', 337.0000, 'ºC'),
	(44454, 111, '2015-02-01 00:20:19.000000', 'temperatura', 956.0000, 'ºC'),
	(44455, 111, '2015-02-01 00:20:20.000000', 'temperatura', 169.0000, 'ºC'),
	(44456, 111, '2015-02-01 00:20:21.000000', 'temperatura', 379.0000, 'ºC'),
	(44457, 111, '2015-02-01 00:20:22.000000', 'temperatura', 190.0000, 'ºC'),
	(44458, 111, '2015-02-01 00:20:23.000000', 'temperatura', 1010.0000, 'ºC'),
	(44459, 111, '2015-02-01 00:20:24.000000', 'temperatura', 881.0000, 'ºC'),
	(44460, 111, '2015-02-01 00:20:25.000000', 'temperatura', 178.0000, 'ºC'),
	(44461, 111, '2015-02-01 00:20:26.000000', 'temperatura', 647.0000, 'ºC'),
	(44462, 111, '2015-02-01 00:20:27.000000', 'temperatura', 299.0000, 'ºC'),
	(44463, 111, '2015-02-01 00:20:28.000000', 'temperatura', 756.0000, 'ºC'),
	(44464, 111, '2015-02-01 00:20:29.000000', 'temperatura', 482.0000, 'ºC'),
	(44465, 111, '2015-02-01 00:20:30.000000', 'temperatura', 145.0000, 'ºC'),
	(44466, 111, '2015-02-01 00:20:31.000000', 'temperatura', 477.0000, 'ºC'),
	(44467, 111, '2015-02-01 00:20:32.000000', 'temperatura', 749.0000, 'ºC'),
	(44468, 111, '2015-02-01 00:20:33.000000', 'temperatura', 1118.0000, 'ºC'),
	(44469, 111, '2015-02-01 00:20:34.000000', 'temperatura', 944.0000, 'ºC'),
	(44470, 111, '2015-02-01 00:20:35.000000', 'temperatura', 165.0000, 'ºC'),
	(44471, 111, '2015-02-01 00:20:36.000000', 'temperatura', 393.0000, 'ºC'),
	(44472, 111, '2015-02-01 00:20:37.000000', 'temperatura', 271.0000, 'ºC'),
	(44473, 111, '2015-02-01 00:20:38.000000', 'temperatura', 177.0000, 'ºC'),
	(44474, 111, '2015-02-01 00:20:39.000000', 'temperatura', 72.0000, 'ºC'),
	(44475, 111, '2015-02-01 00:20:40.000000', 'temperatura', 1028.0000, 'ºC'),
	(44476, 111, '2015-02-01 00:20:41.000000', 'temperatura', 127.0000, 'ºC'),
	(44477, 111, '2015-02-01 00:20:42.000000', 'temperatura', 1150.0000, 'ºC'),
	(44478, 111, '2015-02-01 00:20:43.000000', 'temperatura', 570.0000, 'ºC'),
	(44479, 111, '2015-02-01 00:20:44.000000', 'temperatura', 601.0000, 'ºC'),
	(44480, 111, '2015-02-01 00:20:45.000000', 'temperatura', 97.0000, 'ºC'),
	(44481, 111, '2015-02-01 00:20:46.000000', 'temperatura', 1079.0000, 'ºC'),
	(44482, 111, '2015-02-01 00:20:47.000000', 'temperatura', 307.0000, 'ºC'),
	(44483, 111, '2015-02-01 00:20:48.000000', 'temperatura', 700.0000, 'ºC'),
	(44484, 111, '2015-02-01 00:20:49.000000', 'temperatura', 176.0000, 'ºC'),
	(44485, 111, '2015-02-01 00:20:50.000000', 'temperatura', 1181.0000, 'ºC'),
	(44486, 111, '2015-02-01 00:20:51.000000', 'temperatura', 579.0000, 'ºC'),
	(44487, 111, '2015-02-01 00:20:52.000000', 'temperatura', 553.0000, 'ºC'),
	(44488, 111, '2015-02-01 00:20:53.000000', 'temperatura', 1030.0000, 'ºC'),
	(44489, 111, '2015-02-01 00:20:54.000000', 'temperatura', 1088.0000, 'ºC'),
	(44490, 111, '2015-02-01 00:20:55.000000', 'temperatura', 1153.0000, 'ºC'),
	(44491, 111, '2015-02-01 00:20:56.000000', 'temperatura', 103.0000, 'ºC'),
	(44492, 111, '2015-02-01 00:20:57.000000', 'temperatura', 653.0000, 'ºC'),
	(44493, 111, '2015-02-01 00:20:58.000000', 'temperatura', 558.0000, 'ºC'),
	(44494, 111, '2015-02-01 00:20:59.000000', 'temperatura', 833.0000, 'ºC'),
	(44495, 111, '2015-02-01 00:21:00.000000', 'temperatura', 91.0000, 'ºC'),
	(44496, 111, '2015-02-01 00:21:01.000000', 'temperatura', 357.0000, 'ºC'),
	(44497, 111, '2015-02-01 00:21:02.000000', 'temperatura', 314.0000, 'ºC'),
	(44498, 111, '2015-02-01 00:21:03.000000', 'temperatura', 497.0000, 'ºC'),
	(44499, 111, '2015-02-01 00:21:04.000000', 'temperatura', 344.0000, 'ºC'),
	(44500, 111, '2015-02-01 00:21:05.000000', 'temperatura', 229.0000, 'ºC'),
	(44501, 111, '2015-02-01 00:21:06.000000', 'temperatura', 114.0000, 'ºC'),
	(44502, 111, '2015-02-01 00:21:07.000000', 'temperatura', 1084.0000, 'ºC'),
	(44503, 111, '2015-02-01 00:21:08.000000', 'temperatura', 277.0000, 'ºC'),
	(44504, 111, '2015-02-01 00:21:09.000000', 'temperatura', 535.0000, 'ºC'),
	(44505, 111, '2015-02-01 00:21:10.000000', 'temperatura', 645.0000, 'ºC'),
	(44506, 111, '2015-02-01 00:21:11.000000', 'temperatura', 419.0000, 'ºC'),
	(44507, 111, '2015-02-01 00:21:12.000000', 'temperatura', 161.0000, 'ºC'),
	(44508, 111, '2015-02-01 00:21:13.000000', 'temperatura', 749.0000, 'ºC'),
	(44509, 111, '2015-02-01 00:21:14.000000', 'temperatura', 863.0000, 'ºC'),
	(44510, 111, '2015-02-01 00:21:15.000000', 'temperatura', 868.0000, 'ºC'),
	(44511, 111, '2015-02-01 00:21:16.000000', 'temperatura', 553.0000, 'ºC'),
	(44512, 111, '2015-02-01 00:21:17.000000', 'temperatura', 159.0000, 'ºC'),
	(44513, 111, '2015-02-01 00:21:18.000000', 'temperatura', 337.0000, 'ºC'),
	(44514, 111, '2015-02-01 00:21:19.000000', 'temperatura', 7.0000, 'ºC'),
	(44515, 111, '2015-02-01 00:21:20.000000', 'temperatura', 225.0000, 'ºC'),
	(44516, 111, '2015-02-01 00:21:21.000000', 'temperatura', 1104.0000, 'ºC'),
	(44517, 111, '2015-02-01 00:21:22.000000', 'temperatura', 48.0000, 'ºC'),
	(44518, 111, '2015-02-01 00:21:23.000000', 'temperatura', 526.0000, 'ºC'),
	(44519, 111, '2015-02-01 00:21:24.000000', 'temperatura', 89.0000, 'ºC'),
	(44520, 111, '2015-02-01 00:21:25.000000', 'temperatura', 65.0000, 'ºC'),
	(44521, 111, '2015-02-01 00:21:26.000000', 'temperatura', 58.0000, 'ºC'),
	(44522, 111, '2015-02-01 00:21:27.000000', 'temperatura', 96.0000, 'ºC'),
	(44523, 111, '2015-02-01 00:21:28.000000', 'temperatura', 307.0000, 'ºC'),
	(44524, 111, '2015-02-01 00:21:29.000000', 'temperatura', 48.0000, 'ºC'),
	(44525, 111, '2015-02-01 00:21:30.000000', 'temperatura', 520.0000, 'ºC'),
	(44526, 111, '2015-02-01 00:21:31.000000', 'temperatura', 55.0000, 'ºC'),
	(44527, 111, '2015-02-01 00:21:32.000000', 'temperatura', 1116.0000, 'ºC'),
	(44528, 111, '2015-02-01 00:21:33.000000', 'temperatura', 615.0000, 'ºC'),
	(44529, 111, '2015-02-01 00:21:34.000000', 'temperatura', 928.0000, 'ºC'),
	(44530, 111, '2015-02-01 00:21:35.000000', 'temperatura', 397.0000, 'ºC'),
	(44531, 111, '2015-02-01 00:21:36.000000', 'temperatura', 398.0000, 'ºC'),
	(44532, 111, '2015-02-01 00:21:37.000000', 'temperatura', 803.0000, 'ºC'),
	(44533, 111, '2015-02-01 00:21:38.000000', 'temperatura', 419.0000, 'ºC'),
	(44534, 111, '2015-02-01 00:21:39.000000', 'temperatura', 886.0000, 'ºC'),
	(44535, 111, '2015-02-01 00:21:40.000000', 'temperatura', 774.0000, 'ºC'),
	(44536, 111, '2015-02-01 00:21:41.000000', 'temperatura', 14.0000, 'ºC'),
	(44537, 111, '2015-02-01 00:21:42.000000', 'temperatura', 148.0000, 'ºC'),
	(44538, 111, '2015-02-01 00:21:43.000000', 'temperatura', 696.0000, 'ºC'),
	(44539, 111, '2015-02-01 00:21:44.000000', 'temperatura', 639.0000, 'ºC'),
	(44540, 111, '2015-02-01 00:21:45.000000', 'temperatura', 1106.0000, 'ºC'),
	(44541, 111, '2015-02-01 00:21:46.000000', 'temperatura', 15.0000, 'ºC'),
	(44542, 111, '2015-02-01 00:21:47.000000', 'temperatura', 359.0000, 'ºC'),
	(44543, 111, '2015-02-01 00:21:48.000000', 'temperatura', 548.0000, 'ºC'),
	(44544, 111, '2015-02-01 00:21:49.000000', 'temperatura', 463.0000, 'ºC'),
	(44545, 111, '2015-02-01 00:21:50.000000', 'temperatura', 672.0000, 'ºC'),
	(44546, 111, '2015-02-01 00:21:51.000000', 'temperatura', 770.0000, 'ºC'),
	(44547, 111, '2015-02-01 00:21:52.000000', 'temperatura', 637.0000, 'ºC'),
	(44548, 111, '2015-02-01 00:21:53.000000', 'temperatura', 875.0000, 'ºC'),
	(44549, 111, '2015-02-01 00:21:54.000000', 'temperatura', 65.0000, 'ºC'),
	(44550, 111, '2015-02-01 00:21:55.000000', 'temperatura', 100.0000, 'ºC'),
	(44551, 111, '2015-02-01 00:21:56.000000', 'temperatura', 305.0000, 'ºC'),
	(44552, 111, '2015-02-01 00:21:57.000000', 'temperatura', 27.0000, 'ºC'),
	(44553, 111, '2015-02-01 00:21:58.000000', 'temperatura', 420.0000, 'ºC'),
	(44554, 111, '2015-02-01 00:21:59.000000', 'temperatura', 818.0000, 'ºC'),
	(44555, 111, '2015-02-01 00:22:00.000000', 'temperatura', 430.0000, 'ºC'),
	(44556, 111, '2015-02-01 00:22:01.000000', 'temperatura', 898.0000, 'ºC'),
	(44557, 111, '2015-02-01 00:22:02.000000', 'temperatura', 799.0000, 'ºC'),
	(44558, 111, '2015-02-01 00:22:03.000000', 'temperatura', 102.0000, 'ºC'),
	(44559, 111, '2015-02-01 00:22:04.000000', 'temperatura', 513.0000, 'ºC'),
	(44560, 111, '2015-02-01 00:22:05.000000', 'temperatura', 1059.0000, 'ºC'),
	(44561, 111, '2015-02-01 00:22:06.000000', 'temperatura', 158.0000, 'ºC'),
	(44562, 111, '2015-02-01 00:22:07.000000', 'temperatura', 14.0000, 'ºC'),
	(44563, 111, '2015-02-01 00:22:08.000000', 'temperatura', 794.0000, 'ºC'),
	(44564, 111, '2015-02-01 00:22:09.000000', 'temperatura', 330.0000, 'ºC'),
	(44565, 111, '2015-02-01 00:22:10.000000', 'temperatura', 468.0000, 'ºC'),
	(44566, 111, '2015-02-01 00:22:11.000000', 'temperatura', 150.0000, 'ºC'),
	(44567, 111, '2015-02-01 00:22:12.000000', 'temperatura', 548.0000, 'ºC'),
	(44568, 111, '2015-02-01 00:22:13.000000', 'temperatura', 1091.0000, 'ºC'),
	(44569, 111, '2015-02-01 00:22:14.000000', 'temperatura', 209.0000, 'ºC'),
	(44570, 111, '2015-02-01 00:22:15.000000', 'temperatura', 175.0000, 'ºC'),
	(44571, 111, '2015-02-01 00:22:16.000000', 'temperatura', 247.0000, 'ºC'),
	(44572, 111, '2015-02-01 00:22:17.000000', 'temperatura', 711.0000, 'ºC'),
	(44573, 111, '2015-02-01 00:22:18.000000', 'temperatura', 415.0000, 'ºC'),
	(44574, 111, '2015-02-01 00:22:19.000000', 'temperatura', 1143.0000, 'ºC'),
	(44575, 111, '2015-02-01 00:22:20.000000', 'temperatura', 870.0000, 'ºC'),
	(44576, 111, '2015-02-01 00:22:21.000000', 'temperatura', 921.0000, 'ºC'),
	(44577, 111, '2015-02-01 00:22:22.000000', 'temperatura', 797.0000, 'ºC'),
	(44578, 111, '2015-02-01 00:22:23.000000', 'temperatura', 20.0000, 'ºC'),
	(44579, 111, '2015-02-01 00:22:24.000000', 'temperatura', 109.0000, 'ºC'),
	(44580, 111, '2015-02-01 00:22:25.000000', 'temperatura', 487.0000, 'ºC'),
	(44581, 111, '2015-02-01 00:22:26.000000', 'temperatura', 908.0000, 'ºC'),
	(44582, 111, '2015-02-01 00:22:27.000000', 'temperatura', 681.0000, 'ºC'),
	(44583, 111, '2015-02-01 00:22:28.000000', 'temperatura', 680.0000, 'ºC'),
	(44584, 111, '2015-02-01 00:22:29.000000', 'temperatura', 158.0000, 'ºC'),
	(44585, 111, '2015-02-01 00:22:30.000000', 'temperatura', 1150.0000, 'ºC'),
	(44586, 111, '2015-02-01 00:22:31.000000', 'temperatura', 475.0000, 'ºC'),
	(44587, 111, '2015-02-01 00:22:32.000000', 'temperatura', 128.0000, 'ºC'),
	(44588, 111, '2015-02-01 00:22:33.000000', 'temperatura', 415.0000, 'ºC'),
	(44589, 111, '2015-02-01 00:22:34.000000', 'temperatura', 491.0000, 'ºC'),
	(44590, 111, '2015-02-01 00:22:35.000000', 'temperatura', 10.0000, 'ºC'),
	(44591, 111, '2015-02-01 00:22:36.000000', 'temperatura', 979.0000, 'ºC'),
	(44592, 111, '2015-02-01 00:22:37.000000', 'temperatura', 64.0000, 'ºC'),
	(44593, 111, '2015-02-01 00:22:38.000000', 'temperatura', 986.0000, 'ºC'),
	(44594, 111, '2015-02-01 00:22:39.000000', 'temperatura', 1137.0000, 'ºC'),
	(44595, 111, '2015-02-01 00:22:40.000000', 'temperatura', 329.0000, 'ºC'),
	(44596, 111, '2015-02-01 00:22:41.000000', 'temperatura', 633.0000, 'ºC'),
	(44597, 111, '2015-02-01 00:22:42.000000', 'temperatura', 977.0000, 'ºC'),
	(44598, 111, '2015-02-01 00:22:43.000000', 'temperatura', 588.0000, 'ºC'),
	(44599, 111, '2015-02-01 00:22:44.000000', 'temperatura', 8.0000, 'ºC'),
	(44600, 111, '2015-02-01 00:22:45.000000', 'temperatura', 676.0000, 'ºC'),
	(44601, 111, '2015-02-01 00:22:46.000000', 'temperatura', 959.0000, 'ºC'),
	(44602, 111, '2015-02-01 00:22:47.000000', 'temperatura', 365.0000, 'ºC'),
	(44603, 111, '2015-02-01 00:22:48.000000', 'temperatura', 151.0000, 'ºC'),
	(44604, 111, '2015-02-01 00:22:49.000000', 'temperatura', 860.0000, 'ºC'),
	(44605, 111, '2015-02-01 00:22:50.000000', 'temperatura', 246.0000, 'ºC'),
	(44606, 111, '2015-02-01 00:22:51.000000', 'temperatura', 1049.0000, 'ºC'),
	(44607, 111, '2015-02-01 00:22:52.000000', 'temperatura', 910.0000, 'ºC'),
	(44608, 111, '2015-02-01 00:22:53.000000', 'temperatura', 203.0000, 'ºC'),
	(44609, 111, '2015-02-01 00:22:54.000000', 'temperatura', 686.0000, 'ºC'),
	(44610, 111, '2015-02-01 00:22:55.000000', 'temperatura', 423.0000, 'ºC'),
	(44611, 111, '2015-02-01 00:22:56.000000', 'temperatura', 55.0000, 'ºC'),
	(44612, 111, '2015-02-01 00:22:57.000000', 'temperatura', 208.0000, 'ºC'),
	(44613, 111, '2015-02-01 00:22:58.000000', 'temperatura', 876.0000, 'ºC'),
	(44614, 111, '2015-02-01 00:22:59.000000', 'temperatura', 157.0000, 'ºC'),
	(44615, 111, '2015-02-01 00:23:00.000000', 'temperatura', 559.0000, 'ºC'),
	(44616, 111, '2015-02-01 00:23:01.000000', 'temperatura', 1121.0000, 'ºC'),
	(44617, 111, '2015-02-01 00:23:02.000000', 'temperatura', 330.0000, 'ºC'),
	(44618, 111, '2015-02-01 00:23:03.000000', 'temperatura', 688.0000, 'ºC'),
	(44619, 111, '2015-02-01 00:23:04.000000', 'temperatura', 49.0000, 'ºC'),
	(44620, 111, '2015-02-01 00:23:05.000000', 'temperatura', 583.0000, 'ºC'),
	(44621, 111, '2015-02-01 00:23:06.000000', 'temperatura', 370.0000, 'ºC'),
	(44622, 111, '2015-02-01 00:23:07.000000', 'temperatura', 99.0000, 'ºC'),
	(44623, 111, '2015-02-01 00:23:08.000000', 'temperatura', 586.0000, 'ºC'),
	(44624, 111, '2015-02-01 00:23:09.000000', 'temperatura', 236.0000, 'ºC'),
	(44625, 111, '2015-02-01 00:23:10.000000', 'temperatura', 619.0000, 'ºC'),
	(44626, 111, '2015-02-01 00:23:11.000000', 'temperatura', 1190.0000, 'ºC'),
	(44627, 111, '2015-02-01 00:23:12.000000', 'temperatura', 495.0000, 'ºC'),
	(44628, 111, '2015-02-01 00:23:13.000000', 'temperatura', 102.0000, 'ºC'),
	(44629, 111, '2015-02-01 00:23:14.000000', 'temperatura', 227.0000, 'ºC'),
	(44630, 111, '2015-02-01 00:23:15.000000', 'temperatura', 829.0000, 'ºC'),
	(44631, 111, '2015-02-01 00:23:16.000000', 'temperatura', 1064.0000, 'ºC'),
	(44632, 111, '2015-02-01 00:23:17.000000', 'temperatura', 434.0000, 'ºC'),
	(44633, 111, '2015-02-01 00:23:18.000000', 'temperatura', 177.0000, 'ºC'),
	(44634, 111, '2015-02-01 00:23:19.000000', 'temperatura', 782.0000, 'ºC'),
	(44635, 111, '2015-02-01 00:23:20.000000', 'temperatura', 983.0000, 'ºC'),
	(44636, 111, '2015-02-01 00:23:21.000000', 'temperatura', 169.0000, 'ºC'),
	(44637, 111, '2015-02-01 00:23:22.000000', 'temperatura', 298.0000, 'ºC'),
	(44638, 111, '2015-02-01 00:23:23.000000', 'temperatura', 982.0000, 'ºC'),
	(44639, 111, '2015-02-01 00:23:24.000000', 'temperatura', 416.0000, 'ºC'),
	(44640, 111, '2015-02-01 00:23:25.000000', 'temperatura', 337.0000, 'ºC'),
	(44641, 111, '2015-02-01 00:23:26.000000', 'temperatura', 435.0000, 'ºC'),
	(44642, 111, '2015-02-01 00:23:27.000000', 'temperatura', 1163.0000, 'ºC'),
	(44643, 111, '2015-02-01 00:23:28.000000', 'temperatura', 913.0000, 'ºC'),
	(44644, 111, '2015-02-01 00:23:29.000000', 'temperatura', 1075.0000, 'ºC'),
	(44645, 111, '2015-02-01 00:23:30.000000', 'temperatura', 238.0000, 'ºC'),
	(44646, 111, '2015-02-01 00:23:31.000000', 'temperatura', 366.0000, 'ºC'),
	(44647, 111, '2015-02-01 00:23:32.000000', 'temperatura', 1115.0000, 'ºC'),
	(44648, 111, '2015-02-01 00:23:33.000000', 'temperatura', 876.0000, 'ºC'),
	(44649, 111, '2015-02-01 00:23:34.000000', 'temperatura', 1036.0000, 'ºC'),
	(44650, 111, '2015-02-01 00:23:35.000000', 'temperatura', 154.0000, 'ºC'),
	(44651, 111, '2015-02-01 00:23:36.000000', 'temperatura', 64.0000, 'ºC'),
	(44652, 111, '2015-02-01 00:23:37.000000', 'temperatura', 1057.0000, 'ºC'),
	(44653, 111, '2015-02-01 00:23:38.000000', 'temperatura', 292.0000, 'ºC'),
	(44654, 111, '2015-02-01 00:23:39.000000', 'temperatura', 689.0000, 'ºC'),
	(44655, 111, '2015-02-01 00:23:40.000000', 'temperatura', 171.0000, 'ºC'),
	(44656, 111, '2015-02-01 00:23:41.000000', 'temperatura', 1189.0000, 'ºC'),
	(44657, 111, '2015-02-01 00:23:42.000000', 'temperatura', 631.0000, 'ºC'),
	(44658, 111, '2015-02-01 00:23:43.000000', 'temperatura', 791.0000, 'ºC'),
	(44659, 111, '2015-02-01 00:23:44.000000', 'temperatura', 862.0000, 'ºC'),
	(44660, 111, '2015-02-01 00:23:45.000000', 'temperatura', 739.0000, 'ºC'),
	(44661, 111, '2015-02-01 00:23:46.000000', 'temperatura', 1107.0000, 'ºC'),
	(44662, 111, '2015-02-01 00:23:47.000000', 'temperatura', 921.0000, 'ºC'),
	(44663, 111, '2015-02-01 00:23:48.000000', 'temperatura', 81.0000, 'ºC'),
	(44664, 111, '2015-02-01 00:23:49.000000', 'temperatura', 45.0000, 'ºC'),
	(44665, 111, '2015-02-01 00:23:50.000000', 'temperatura', 1181.0000, 'ºC'),
	(44666, 111, '2015-02-01 00:23:51.000000', 'temperatura', 971.0000, 'ºC'),
	(44667, 111, '2015-02-01 00:23:52.000000', 'temperatura', 114.0000, 'ºC'),
	(44668, 111, '2015-02-01 00:23:53.000000', 'temperatura', 58.0000, 'ºC'),
	(44669, 111, '2015-02-01 00:23:54.000000', 'temperatura', 1149.0000, 'ºC'),
	(44670, 111, '2015-02-01 00:23:55.000000', 'temperatura', 770.0000, 'ºC'),
	(44671, 111, '2015-02-01 00:23:56.000000', 'temperatura', 405.0000, 'ºC'),
	(44672, 111, '2015-02-01 00:23:57.000000', 'temperatura', 916.0000, 'ºC'),
	(44673, 111, '2015-02-01 00:23:58.000000', 'temperatura', 965.0000, 'ºC'),
	(44674, 111, '2015-02-01 00:23:59.000000', 'temperatura', 875.0000, 'ºC'),
	(44675, 111, '2015-02-01 00:24:00.000000', 'temperatura', 284.0000, 'ºC'),
	(44676, 111, '2015-02-01 00:24:01.000000', 'temperatura', 1195.0000, 'ºC'),
	(44677, 111, '2015-02-01 00:24:02.000000', 'temperatura', 322.0000, 'ºC'),
	(44678, 111, '2015-02-01 00:24:03.000000', 'temperatura', 424.0000, 'ºC'),
	(44679, 111, '2015-02-01 00:24:04.000000', 'temperatura', 1156.0000, 'ºC'),
	(44680, 111, '2015-02-01 00:24:05.000000', 'temperatura', 909.0000, 'ºC'),
	(44681, 111, '2015-02-01 00:24:06.000000', 'temperatura', 1076.0000, 'ºC'),
	(44682, 111, '2015-02-01 00:24:07.000000', 'temperatura', 253.0000, 'ºC'),
	(44683, 111, '2015-02-01 00:24:08.000000', 'temperatura', 439.0000, 'ºC'),
	(44684, 111, '2015-02-01 00:24:09.000000', 'temperatura', 237.0000, 'ºC'),
	(44685, 111, '2015-02-01 00:24:10.000000', 'temperatura', 1069.0000, 'ºC'),
	(44686, 111, '2015-02-01 00:24:11.000000', 'temperatura', 1033.0000, 'ºC'),
	(44687, 111, '2015-02-01 00:24:12.000000', 'temperatura', 759.0000, 'ºC'),
	(44688, 111, '2015-02-01 00:24:13.000000', 'temperatura', 697.0000, 'ºC'),
	(44689, 111, '2015-02-01 00:24:14.000000', 'temperatura', 7.0000, 'ºC'),
	(44690, 111, '2015-02-01 00:24:15.000000', 'temperatura', 345.0000, 'ºC'),
	(44691, 111, '2015-02-01 00:24:16.000000', 'temperatura', 503.0000, 'ºC'),
	(44692, 111, '2015-02-01 00:24:17.000000', 'temperatura', 283.0000, 'ºC'),
	(44693, 111, '2015-02-01 00:24:18.000000', 'temperatura', 1106.0000, 'ºC'),
	(44694, 111, '2015-02-01 00:24:19.000000', 'temperatura', 1080.0000, 'ºC'),
	(44695, 111, '2015-02-01 00:24:20.000000', 'temperatura', 885.0000, 'ºC'),
	(44696, 111, '2015-02-01 00:24:21.000000', 'temperatura', 1185.0000, 'ºC'),
	(44697, 111, '2015-02-01 00:24:22.000000', 'temperatura', 871.0000, 'ºC'),
	(44698, 111, '2015-02-01 00:24:23.000000', 'temperatura', 798.0000, 'ºC'),
	(44699, 111, '2015-02-01 00:24:24.000000', 'temperatura', 178.0000, 'ºC'),
	(44700, 111, '2015-02-01 00:24:25.000000', 'temperatura', 898.0000, 'ºC'),
	(44701, 111, '2015-02-01 00:24:26.000000', 'temperatura', 355.0000, 'ºC'),
	(44702, 111, '2015-02-01 00:24:27.000000', 'temperatura', 281.0000, 'ºC'),
	(44703, 111, '2015-02-01 00:24:28.000000', 'temperatura', 339.0000, 'ºC'),
	(44704, 111, '2015-02-01 00:24:29.000000', 'temperatura', 855.0000, 'ºC'),
	(44705, 111, '2015-02-01 00:24:30.000000', 'temperatura', 856.0000, 'ºC'),
	(44706, 111, '2015-02-01 00:24:31.000000', 'temperatura', 518.0000, 'ºC'),
	(44707, 111, '2015-02-01 00:24:32.000000', 'temperatura', 22.0000, 'ºC'),
	(44708, 111, '2015-02-01 00:24:33.000000', 'temperatura', 958.0000, 'ºC'),
	(44709, 111, '2015-02-01 00:24:34.000000', 'temperatura', 1123.0000, 'ºC'),
	(44710, 111, '2015-02-01 00:24:35.000000', 'temperatura', 341.0000, 'ºC'),
	(44711, 111, '2015-02-01 00:24:36.000000', 'temperatura', 735.0000, 'ºC'),
	(44712, 111, '2015-02-01 00:24:37.000000', 'temperatura', 254.0000, 'ºC'),
	(44713, 111, '2015-02-01 00:24:38.000000', 'temperatura', 265.0000, 'ºC'),
	(44714, 111, '2015-02-01 00:24:39.000000', 'temperatura', 562.0000, 'ºC'),
	(44715, 111, '2015-02-01 00:24:40.000000', 'temperatura', 815.0000, 'ºC'),
	(44716, 111, '2015-02-01 00:24:41.000000', 'temperatura', 1192.0000, 'ºC'),
	(44717, 111, '2015-02-01 00:24:42.000000', 'temperatura', 1115.0000, 'ºC'),
	(44718, 111, '2015-02-01 00:24:43.000000', 'temperatura', 798.0000, 'ºC'),
	(44719, 111, '2015-02-01 00:24:44.000000', 'temperatura', 648.0000, 'ºC'),
	(44720, 111, '2015-02-01 00:24:45.000000', 'temperatura', 844.0000, 'ºC'),
	(44721, 111, '2015-02-01 00:24:46.000000', 'temperatura', 1078.0000, 'ºC'),
	(44722, 111, '2015-02-01 00:24:47.000000', 'temperatura', 456.0000, 'ºC'),
	(44723, 111, '2015-02-01 00:24:48.000000', 'temperatura', 248.0000, 'ºC'),
	(44724, 111, '2015-02-01 00:24:49.000000', 'temperatura', 1074.0000, 'ºC'),
	(44725, 111, '2015-02-01 00:24:50.000000', 'temperatura', 1026.0000, 'ºC'),
	(44726, 111, '2015-02-01 00:24:51.000000', 'temperatura', 708.0000, 'ºC'),
	(44727, 111, '2015-02-01 00:24:52.000000', 'temperatura', 465.0000, 'ºC'),
	(44728, 111, '2015-02-01 00:24:53.000000', 'temperatura', 198.0000, 'ºC'),
	(44729, 111, '2015-02-01 00:24:54.000000', 'temperatura', 796.0000, 'ºC'),
	(44730, 111, '2015-02-01 00:24:55.000000', 'temperatura', 985.0000, 'ºC'),
	(44731, 111, '2015-02-01 00:24:56.000000', 'temperatura', 141.0000, 'ºC'),
	(44732, 111, '2015-02-01 00:24:57.000000', 'temperatura', 148.0000, 'ºC'),
	(44733, 111, '2015-02-01 00:24:58.000000', 'temperatura', 320.0000, 'ºC'),
	(44734, 111, '2015-02-01 00:24:59.000000', 'temperatura', 1154.0000, 'ºC'),
	(44735, 111, '2015-02-01 00:25:00.000000', 'temperatura', 11.0000, 'ºC'),
	(44736, 111, '2015-02-01 00:25:01.000000', 'temperatura', 193.0000, 'ºC'),
	(44737, 111, '2015-02-01 00:25:02.000000', 'temperatura', 932.0000, 'ºC'),
	(44738, 111, '2015-02-01 00:25:03.000000', 'temperatura', 480.0000, 'ºC'),
	(44739, 111, '2015-02-01 00:25:04.000000', 'temperatura', 808.0000, 'ºC'),
	(44740, 111, '2015-02-01 00:25:05.000000', 'temperatura', 198.0000, 'ºC'),
	(44741, 111, '2015-02-01 00:25:06.000000', 'temperatura', 968.0000, 'ºC'),
	(44742, 111, '2015-02-01 00:25:07.000000', 'temperatura', 646.0000, 'ºC'),
	(44743, 111, '2015-02-01 00:25:08.000000', 'temperatura', 324.0000, 'ºC'),
	(44744, 111, '2015-02-01 00:25:09.000000', 'temperatura', 886.0000, 'ºC'),
	(44745, 111, '2015-02-01 00:25:10.000000', 'temperatura', 1056.0000, 'ºC'),
	(44746, 111, '2015-02-01 00:25:11.000000', 'temperatura', 225.0000, 'ºC'),
	(44747, 111, '2015-02-01 00:25:12.000000', 'temperatura', 358.0000, 'ºC'),
	(44748, 111, '2015-02-01 00:25:13.000000', 'temperatura', 1114.0000, 'ºC'),
	(44749, 111, '2015-02-01 00:25:14.000000', 'temperatura', 897.0000, 'ºC'),
	(44750, 111, '2015-02-01 00:25:15.000000', 'temperatura', 1143.0000, 'ºC'),
	(44751, 111, '2015-02-01 00:25:16.000000', 'temperatura', 624.0000, 'ºC'),
	(44752, 111, '2015-02-01 00:25:17.000000', 'temperatura', 890.0000, 'ºC'),
	(44753, 111, '2015-02-01 00:25:18.000000', 'temperatura', 181.0000, 'ºC'),
	(44754, 111, '2015-02-01 00:25:19.000000', 'temperatura', 636.0000, 'ºC'),
	(44755, 111, '2015-02-01 00:25:20.000000', 'temperatura', 239.0000, 'ºC'),
	(44756, 111, '2015-02-01 00:25:21.000000', 'temperatura', 485.0000, 'ºC'),
	(44757, 111, '2015-02-01 00:25:22.000000', 'temperatura', 507.0000, 'ºC'),
	(44758, 111, '2015-02-01 00:25:23.000000', 'temperatura', 1082.0000, 'ºC'),
	(44759, 111, '2015-02-01 00:25:24.000000', 'temperatura', 291.0000, 'ºC'),
	(44760, 111, '2015-02-01 00:25:25.000000', 'temperatura', 608.0000, 'ºC'),
	(44761, 111, '2015-02-01 00:25:26.000000', 'temperatura', 967.0000, 'ºC'),
	(44762, 111, '2015-02-01 00:25:27.000000', 'temperatura', 614.0000, 'ºC'),
	(44763, 111, '2015-02-01 00:25:28.000000', 'temperatura', 167.0000, 'ºC'),
	(44764, 111, '2015-02-01 00:25:29.000000', 'temperatura', 192.0000, 'ºC'),
	(44765, 111, '2015-02-01 00:25:30.000000', 'temperatura', 462.0000, 'ºC'),
	(44766, 111, '2015-02-01 00:25:31.000000', 'temperatura', 534.0000, 'ºC'),
	(44767, 111, '2015-02-01 00:25:32.000000', 'temperatura', 83.0000, 'ºC'),
	(44768, 111, '2015-02-01 00:25:33.000000', 'temperatura', 13.0000, 'ºC'),
	(44769, 111, '2015-02-01 00:25:34.000000', 'temperatura', 1019.0000, 'ºC'),
	(44770, 111, '2015-02-01 00:25:35.000000', 'temperatura', 254.0000, 'ºC'),
	(44771, 111, '2015-02-01 00:25:36.000000', 'temperatura', 613.0000, 'ºC'),
	(44772, 111, '2015-02-01 00:25:37.000000', 'temperatura', 1106.0000, 'ºC'),
	(44773, 111, '2015-02-01 00:25:38.000000', 'temperatura', 93.0000, 'ºC'),
	(44774, 111, '2015-02-01 00:25:39.000000', 'temperatura', 744.0000, 'ºC'),
	(44775, 111, '2015-02-01 00:25:40.000000', 'temperatura', 1043.0000, 'ºC'),
	(44776, 111, '2015-02-01 00:25:41.000000', 'temperatura', 584.0000, 'ºC'),
	(44777, 111, '2015-02-01 00:25:42.000000', 'temperatura', 990.0000, 'ºC'),
	(44778, 111, '2015-02-01 00:25:43.000000', 'temperatura', 800.0000, 'ºC'),
	(44779, 111, '2015-02-01 00:25:44.000000', 'temperatura', 1031.0000, 'ºC'),
	(44780, 111, '2015-02-01 00:25:45.000000', 'temperatura', 353.0000, 'ºC'),
	(44781, 111, '2015-02-01 00:25:46.000000', 'temperatura', 1074.0000, 'ºC'),
	(44782, 111, '2015-02-01 00:25:47.000000', 'temperatura', 710.0000, 'ºC'),
	(44783, 111, '2015-02-01 00:25:48.000000', 'temperatura', 329.0000, 'ºC'),
	(44784, 111, '2015-02-01 00:25:49.000000', 'temperatura', 716.0000, 'ºC'),
	(44785, 111, '2015-02-01 00:25:50.000000', 'temperatura', 195.0000, 'ºC'),
	(44786, 111, '2015-02-01 00:25:51.000000', 'temperatura', 26.0000, 'ºC'),
	(44787, 111, '2015-02-01 00:25:52.000000', 'temperatura', 745.0000, 'ºC'),
	(44788, 111, '2015-02-01 00:25:53.000000', 'temperatura', 50.0000, 'ºC'),
	(44789, 111, '2015-02-01 00:25:54.000000', 'temperatura', 414.0000, 'ºC'),
	(44790, 111, '2015-02-01 00:25:55.000000', 'temperatura', 718.0000, 'ºC'),
	(44791, 111, '2015-02-01 00:25:56.000000', 'temperatura', 1152.0000, 'ºC'),
	(44792, 111, '2015-02-01 00:25:57.000000', 'temperatura', 6.0000, 'ºC'),
	(44793, 111, '2015-02-01 00:25:58.000000', 'temperatura', 176.0000, 'ºC'),
	(44794, 111, '2015-02-01 00:25:59.000000', 'temperatura', 861.0000, 'ºC'),
	(44795, 111, '2015-02-01 00:26:00.000000', 'temperatura', 180.0000, 'ºC'),
	(44796, 111, '2015-02-01 00:26:01.000000', 'temperatura', 714.0000, 'ºC'),
	(44797, 111, '2015-02-01 00:26:02.000000', 'temperatura', 633.0000, 'ºC'),
	(44798, 111, '2015-02-01 00:26:03.000000', 'temperatura', 1021.0000, 'ºC'),
	(44799, 111, '2015-02-01 00:26:04.000000', 'temperatura', 808.0000, 'ºC'),
	(44800, 111, '2015-02-01 00:26:05.000000', 'temperatura', 979.0000, 'ºC'),
	(44801, 111, '2015-02-01 00:26:06.000000', 'temperatura', 68.0000, 'ºC'),
	(44802, 111, '2015-02-01 00:26:07.000000', 'temperatura', 1007.0000, 'ºC'),
	(44803, 111, '2015-02-01 00:26:08.000000', 'temperatura', 31.0000, 'ºC'),
	(44804, 111, '2015-02-01 00:26:09.000000', 'temperatura', 733.0000, 'ºC'),
	(44805, 111, '2015-02-01 00:26:10.000000', 'temperatura', 1172.0000, 'ºC'),
	(44806, 111, '2015-02-01 00:26:11.000000', 'temperatura', 62.0000, 'ºC'),
	(44807, 111, '2015-02-01 00:26:12.000000', 'temperatura', 396.0000, 'ºC'),
	(44808, 111, '2015-02-01 00:26:13.000000', 'temperatura', 592.0000, 'ºC'),
	(44809, 111, '2015-02-01 00:26:14.000000', 'temperatura', 574.0000, 'ºC'),
	(44810, 111, '2015-02-01 00:26:15.000000', 'temperatura', 1095.0000, 'ºC'),
	(44811, 111, '2015-02-01 00:26:16.000000', 'temperatura', 153.0000, 'ºC'),
	(44812, 111, '2015-02-01 00:26:17.000000', 'temperatura', 1082.0000, 'ºC'),
	(44813, 111, '2015-02-01 00:26:18.000000', 'temperatura', 149.0000, 'ºC'),
	(44814, 111, '2015-02-01 00:26:19.000000', 'temperatura', 1101.0000, 'ºC'),
	(44815, 111, '2015-02-01 00:26:20.000000', 'temperatura', 258.0000, 'ºC'),
	(44816, 111, '2015-02-01 00:26:21.000000', 'temperatura', 386.0000, 'ºC'),
	(44817, 111, '2015-02-01 00:26:22.000000', 'temperatura', 1159.0000, 'ºC'),
	(44818, 111, '2015-02-01 00:26:23.000000', 'temperatura', 1039.0000, 'ºC'),
	(44819, 111, '2015-02-01 00:26:24.000000', 'temperatura', 515.0000, 'ºC'),
	(44820, 111, '2015-02-01 00:26:25.000000', 'temperatura', 658.0000, 'ºC'),
	(44821, 111, '2015-02-01 00:26:26.000000', 'temperatura', 548.0000, 'ºC'),
	(44822, 111, '2015-02-01 00:26:27.000000', 'temperatura', 765.0000, 'ºC'),
	(44823, 111, '2015-02-01 00:26:28.000000', 'temperatura', 981.0000, 'ºC'),
	(44824, 111, '2015-02-01 00:26:29.000000', 'temperatura', 212.0000, 'ºC'),
	(44825, 111, '2015-02-01 00:26:30.000000', 'temperatura', 517.0000, 'ºC'),
	(44826, 111, '2015-02-01 00:26:31.000000', 'temperatura', 751.0000, 'ºC'),
	(44827, 111, '2015-02-01 00:26:32.000000', 'temperatura', 1002.0000, 'ºC'),
	(44828, 111, '2015-02-01 00:26:33.000000', 'temperatura', 357.0000, 'ºC'),
	(44829, 111, '2015-02-01 00:26:34.000000', 'temperatura', 1183.0000, 'ºC'),
	(44830, 111, '2015-02-01 00:26:35.000000', 'temperatura', 41.0000, 'ºC'),
	(44831, 111, '2015-02-01 00:26:36.000000', 'temperatura', 256.0000, 'ºC'),
	(44832, 111, '2015-02-01 00:26:37.000000', 'temperatura', 1160.0000, 'ºC'),
	(44833, 111, '2015-02-01 00:26:38.000000', 'temperatura', 230.0000, 'ºC'),
	(44834, 111, '2015-02-01 00:26:39.000000', 'temperatura', 72.0000, 'ºC'),
	(44835, 111, '2015-02-01 00:26:40.000000', 'temperatura', 872.0000, 'ºC'),
	(44836, 111, '2015-02-01 00:26:41.000000', 'temperatura', 543.0000, 'ºC'),
	(44837, 111, '2015-02-01 00:26:42.000000', 'temperatura', 99.0000, 'ºC'),
	(44838, 111, '2015-02-01 00:26:43.000000', 'temperatura', 69.0000, 'ºC'),
	(44839, 111, '2015-02-01 00:26:44.000000', 'temperatura', 46.0000, 'ºC'),
	(44840, 111, '2015-02-01 00:26:45.000000', 'temperatura', 24.0000, 'ºC'),
	(44841, 111, '2015-02-01 00:26:46.000000', 'temperatura', 1181.0000, 'ºC'),
	(44842, 111, '2015-02-01 00:26:47.000000', 'temperatura', 1034.0000, 'ºC'),
	(44843, 111, '2015-02-01 00:26:48.000000', 'temperatura', 427.0000, 'ºC'),
	(44844, 111, '2015-02-01 00:26:49.000000', 'temperatura', 236.0000, 'ºC'),
	(44845, 111, '2015-02-01 00:26:50.000000', 'temperatura', 1099.0000, 'ºC'),
	(44846, 111, '2015-02-01 00:26:51.000000', 'temperatura', 1189.0000, 'ºC'),
	(44847, 111, '2015-02-01 00:26:52.000000', 'temperatura', 245.0000, 'ºC'),
	(44848, 111, '2015-02-01 00:26:53.000000', 'temperatura', 61.0000, 'ºC'),
	(44849, 111, '2015-02-01 00:26:54.000000', 'temperatura', 769.0000, 'ºC'),
	(44850, 111, '2015-02-01 00:26:55.000000', 'temperatura', 64.0000, 'ºC'),
	(44851, 111, '2015-02-01 00:26:56.000000', 'temperatura', 414.0000, 'ºC'),
	(44852, 111, '2015-02-01 00:26:57.000000', 'temperatura', 676.0000, 'ºC'),
	(44853, 111, '2015-02-01 00:26:58.000000', 'temperatura', 939.0000, 'ºC'),
	(44854, 111, '2015-02-01 00:26:59.000000', 'temperatura', 266.0000, 'ºC'),
	(44855, 111, '2015-02-01 00:27:00.000000', 'temperatura', 917.0000, 'ºC'),
	(44856, 111, '2015-02-01 00:27:01.000000', 'temperatura', 185.0000, 'ºC'),
	(44857, 111, '2015-02-01 00:27:02.000000', 'temperatura', 576.0000, 'ºC'),
	(44858, 111, '2015-02-01 00:27:03.000000', 'temperatura', 1123.0000, 'ºC'),
	(44859, 111, '2015-02-01 00:27:04.000000', 'temperatura', 290.0000, 'ºC'),
	(44860, 111, '2015-02-01 00:27:05.000000', 'temperatura', 482.0000, 'ºC'),
	(44861, 111, '2015-02-01 00:27:06.000000', 'temperatura', 338.0000, 'ºC'),
	(44862, 111, '2015-02-01 00:27:07.000000', 'temperatura', 248.0000, 'ºC'),
	(44863, 111, '2015-02-01 00:27:08.000000', 'temperatura', 223.0000, 'ºC'),
	(44864, 111, '2015-02-01 00:27:09.000000', 'temperatura', 375.0000, 'ºC'),
	(44865, 111, '2015-02-01 00:27:10.000000', 'temperatura', 4.0000, 'ºC'),
	(44866, 111, '2015-02-01 00:27:11.000000', 'temperatura', 95.0000, 'ºC'),
	(44867, 111, '2015-02-01 00:27:12.000000', 'temperatura', 464.0000, 'ºC'),
	(44868, 111, '2015-02-01 00:27:13.000000', 'temperatura', 835.0000, 'ºC'),
	(44869, 111, '2015-02-01 00:27:14.000000', 'temperatura', 382.0000, 'ºC'),
	(44870, 111, '2015-02-01 00:27:15.000000', 'temperatura', 607.0000, 'ºC'),
	(44871, 111, '2015-02-01 00:27:16.000000', 'temperatura', 689.0000, 'ºC'),
	(44872, 111, '2015-02-01 00:27:17.000000', 'temperatura', 426.0000, 'ºC'),
	(44873, 111, '2015-02-01 00:27:18.000000', 'temperatura', 63.0000, 'ºC'),
	(44874, 111, '2015-02-01 00:27:19.000000', 'temperatura', 237.0000, 'ºC'),
	(44875, 111, '2015-02-01 00:27:20.000000', 'temperatura', 995.0000, 'ºC'),
	(44876, 111, '2015-02-01 00:27:21.000000', 'temperatura', 666.0000, 'ºC'),
	(44877, 111, '2015-02-01 00:27:22.000000', 'temperatura', 344.0000, 'ºC'),
	(44878, 111, '2015-02-01 00:27:23.000000', 'temperatura', 925.0000, 'ºC'),
	(44879, 111, '2015-02-01 00:27:24.000000', 'temperatura', 1194.0000, 'ºC'),
	(44880, 111, '2015-02-01 00:27:25.000000', 'temperatura', 793.0000, 'ºC'),
	(44881, 111, '2015-02-01 00:27:26.000000', 'temperatura', 383.0000, 'ºC'),
	(44882, 111, '2015-02-01 00:27:27.000000', 'temperatura', 738.0000, 'ºC'),
	(44883, 111, '2015-02-01 00:27:28.000000', 'temperatura', 141.0000, 'ºC'),
	(44884, 111, '2015-02-01 00:27:29.000000', 'temperatura', 893.0000, 'ºC'),
	(44885, 111, '2015-02-01 00:27:30.000000', 'temperatura', 440.0000, 'ºC'),
	(44886, 111, '2015-02-01 00:27:31.000000', 'temperatura', 722.0000, 'ºC'),
	(44887, 111, '2015-02-01 00:27:32.000000', 'temperatura', 1093.0000, 'ºC'),
	(44888, 111, '2015-02-01 00:27:33.000000', 'temperatura', 896.0000, 'ºC'),
	(44889, 111, '2015-02-01 00:27:34.000000', 'temperatura', 5.0000, 'ºC'),
	(44890, 111, '2015-02-01 00:27:35.000000', 'temperatura', 935.0000, 'ºC'),
	(44891, 111, '2015-02-01 00:27:36.000000', 'temperatura', 1062.0000, 'ºC'),
	(44892, 111, '2015-02-01 00:27:37.000000', 'temperatura', 106.0000, 'ºC'),
	(44893, 111, '2015-02-01 00:27:38.000000', 'temperatura', 943.0000, 'ºC'),
	(44894, 111, '2015-02-01 00:27:39.000000', 'temperatura', 798.0000, 'ºC'),
	(44895, 111, '2015-02-01 00:27:40.000000', 'temperatura', 1164.0000, 'ºC'),
	(44896, 111, '2015-02-01 00:27:41.000000', 'temperatura', 1023.0000, 'ºC'),
	(44897, 111, '2015-02-01 00:27:42.000000', 'temperatura', 424.0000, 'ºC'),
	(44898, 111, '2015-02-01 00:27:43.000000', 'temperatura', 250.0000, 'ºC'),
	(44899, 111, '2015-02-01 00:27:44.000000', 'temperatura', 1182.0000, 'ºC'),
	(44900, 111, '2015-02-01 00:27:45.000000', 'temperatura', 358.0000, 'ºC'),
	(44901, 111, '2015-02-01 00:27:46.000000', 'temperatura', 643.0000, 'ºC'),
	(44902, 111, '2015-02-01 00:27:47.000000', 'temperatura', 943.0000, 'ºC'),
	(44903, 111, '2015-02-01 00:27:48.000000', 'temperatura', 388.0000, 'ºC'),
	(44904, 111, '2015-02-01 00:27:49.000000', 'temperatura', 312.0000, 'ºC'),
	(44905, 111, '2015-02-01 00:27:50.000000', 'temperatura', 394.0000, 'ºC'),
	(44906, 111, '2015-02-01 00:27:51.000000', 'temperatura', 1038.0000, 'ºC'),
	(44907, 111, '2015-02-01 00:27:52.000000', 'temperatura', 405.0000, 'ºC'),
	(44908, 111, '2015-02-01 00:27:53.000000', 'temperatura', 112.0000, 'ºC'),
	(44909, 111, '2015-02-01 00:27:54.000000', 'temperatura', 547.0000, 'ºC'),
	(44910, 111, '2015-02-01 00:27:55.000000', 'temperatura', 1197.0000, 'ºC'),
	(44911, 111, '2015-02-01 00:27:56.000000', 'temperatura', 747.0000, 'ºC'),
	(44912, 111, '2015-02-01 00:27:57.000000', 'temperatura', 144.0000, 'ºC'),
	(44913, 111, '2015-02-01 00:27:58.000000', 'temperatura', 880.0000, 'ºC'),
	(44914, 111, '2015-02-01 00:27:59.000000', 'temperatura', 370.0000, 'ºC'),
	(44915, 111, '2015-02-01 00:28:00.000000', 'temperatura', 408.0000, 'ºC'),
	(44916, 111, '2015-02-01 00:28:01.000000', 'temperatura', 931.0000, 'ºC'),
	(44917, 111, '2015-02-01 00:28:02.000000', 'temperatura', 1031.0000, 'ºC'),
	(44918, 111, '2015-02-01 00:28:03.000000', 'temperatura', 1165.0000, 'ºC'),
	(44919, 111, '2015-02-01 00:28:04.000000', 'temperatura', 329.0000, 'ºC'),
	(44920, 111, '2015-02-01 00:28:05.000000', 'temperatura', 554.0000, 'ºC'),
	(44921, 111, '2015-02-01 00:28:06.000000', 'temperatura', 581.0000, 'ºC'),
	(44922, 111, '2015-02-01 00:28:07.000000', 'temperatura', 43.0000, 'ºC'),
	(44923, 111, '2015-02-01 00:28:08.000000', 'temperatura', 872.0000, 'ºC'),
	(44924, 111, '2015-02-01 00:28:09.000000', 'temperatura', 634.0000, 'ºC'),
	(44925, 111, '2015-02-01 00:28:10.000000', 'temperatura', 553.0000, 'ºC'),
	(44926, 111, '2015-02-01 00:28:11.000000', 'temperatura', 863.0000, 'ºC'),
	(44927, 111, '2015-02-01 00:28:12.000000', 'temperatura', 257.0000, 'ºC'),
	(44928, 111, '2015-02-01 00:28:13.000000', 'temperatura', 1098.0000, 'ºC'),
	(44929, 111, '2015-02-01 00:28:14.000000', 'temperatura', 1118.0000, 'ºC'),
	(44930, 111, '2015-02-01 00:28:15.000000', 'temperatura', 1096.0000, 'ºC'),
	(44931, 111, '2015-02-01 00:28:16.000000', 'temperatura', 927.0000, 'ºC'),
	(44932, 111, '2015-02-01 00:28:17.000000', 'temperatura', 147.0000, 'ºC'),
	(44933, 111, '2015-02-01 00:28:18.000000', 'temperatura', 354.0000, 'ºC'),
	(44934, 111, '2015-02-01 00:28:19.000000', 'temperatura', 131.0000, 'ºC'),
	(44935, 111, '2015-02-01 00:28:20.000000', 'temperatura', 795.0000, 'ºC'),
	(44936, 111, '2015-02-01 00:28:21.000000', 'temperatura', 1180.0000, 'ºC'),
	(44937, 111, '2015-02-01 00:28:22.000000', 'temperatura', 1116.0000, 'ºC'),
	(44938, 111, '2015-02-01 00:28:23.000000', 'temperatura', 840.0000, 'ºC'),
	(44939, 111, '2015-02-01 00:28:24.000000', 'temperatura', 851.0000, 'ºC'),
	(44940, 111, '2015-02-01 00:28:25.000000', 'temperatura', 536.0000, 'ºC'),
	(44941, 111, '2015-02-01 00:28:26.000000', 'temperatura', 129.0000, 'ºC'),
	(44942, 111, '2015-02-01 00:28:27.000000', 'temperatura', 236.0000, 'ºC'),
	(44943, 111, '2015-02-01 00:28:28.000000', 'temperatura', 794.0000, 'ºC'),
	(44944, 111, '2015-02-01 00:28:29.000000', 'temperatura', 865.0000, 'ºC'),
	(44945, 111, '2015-02-01 00:28:30.000000', 'temperatura', 740.0000, 'ºC'),
	(44946, 111, '2015-02-01 00:28:31.000000', 'temperatura', 1109.0000, 'ºC'),
	(44947, 111, '2015-02-01 00:28:32.000000', 'temperatura', 923.0000, 'ºC'),
	(44948, 111, '2015-02-01 00:28:33.000000', 'temperatura', 89.0000, 'ºC'),
	(44949, 111, '2015-02-01 00:28:34.000000', 'temperatura', 77.0000, 'ºC'),
	(44950, 111, '2015-02-01 00:28:35.000000', 'temperatura', 117.0000, 'ºC'),
	(44951, 111, '2015-02-01 00:28:36.000000', 'temperatura', 355.0000, 'ºC'),
	(44952, 111, '2015-02-01 00:28:37.000000', 'temperatura', 227.0000, 'ºC'),
	(44953, 111, '2015-02-01 00:28:38.000000', 'temperatura', 68.0000, 'ºC'),
	(44954, 111, '2015-02-01 00:28:39.000000', 'temperatura', 861.0000, 'ºC'),
	(44955, 111, '2015-02-01 00:28:40.000000', 'temperatura', 499.0000, 'ºC'),
	(44956, 111, '2015-02-01 00:28:41.000000', 'temperatura', 1113.0000, 'ºC'),
	(44957, 111, '2015-02-01 00:28:42.000000', 'temperatura', 470.0000, 'ºC'),
	(44958, 111, '2015-02-01 00:28:43.000000', 'temperatura', 210.0000, 'ºC'),
	(44959, 111, '2015-02-01 00:28:44.000000', 'temperatura', 840.0000, 'ºC'),
	(44960, 111, '2015-02-01 00:28:45.000000', 'temperatura', 1173.0000, 'ºC'),
	(44961, 111, '2015-02-01 00:28:46.000000', 'temperatura', 944.0000, 'ºC'),
	(44962, 111, '2015-02-01 00:28:47.000000', 'temperatura', 3.0000, 'ºC'),
	(44963, 111, '2015-02-01 00:28:48.000000', 'temperatura', 783.0000, 'ºC'),
	(44964, 111, '2015-02-01 00:28:49.000000', 'temperatura', 306.0000, 'ºC'),
	(44965, 111, '2015-02-01 00:28:50.000000', 'temperatura', 380.0000, 'ºC'),
	(44966, 111, '2015-02-01 00:28:51.000000', 'temperatura', 984.0000, 'ºC'),
	(44967, 111, '2015-02-01 00:28:52.000000', 'temperatura', 178.0000, 'ºC'),
	(44968, 111, '2015-02-01 00:28:53.000000', 'temperatura', 342.0000, 'ºC'),
	(44969, 111, '2015-02-01 00:28:54.000000', 'temperatura', 1176.0000, 'ºC'),
	(44970, 111, '2015-02-01 00:28:55.000000', 'temperatura', 52.0000, 'ºC'),
	(44971, 111, '2015-02-01 00:28:56.000000', 'temperatura', 334.0000, 'ºC'),
	(44972, 111, '2015-02-01 00:28:57.000000', 'temperatura', 317.0000, 'ºC'),
	(44973, 111, '2015-02-01 00:28:58.000000', 'temperatura', 580.0000, 'ºC'),
	(44974, 111, '2015-02-01 00:28:59.000000', 'temperatura', 749.0000, 'ºC'),
	(44975, 111, '2015-02-01 00:29:00.000000', 'temperatura', 806.0000, 'ºC'),
	(44976, 111, '2015-02-01 00:29:01.000000', 'temperatura', 585.0000, 'ºC'),
	(44977, 111, '2015-02-01 00:29:02.000000', 'temperatura', 505.0000, 'ºC'),
	(44978, 111, '2015-02-01 00:29:03.000000', 'temperatura', 774.0000, 'ºC'),
	(44979, 111, '2015-02-01 00:29:04.000000', 'temperatura', 1152.0000, 'ºC'),
	(44980, 111, '2015-02-01 00:29:05.000000', 'temperatura', 1039.0000, 'ºC'),
	(44981, 111, '2015-02-01 00:29:06.000000', 'temperatura', 542.0000, 'ºC'),
	(44982, 111, '2015-02-01 00:29:07.000000', 'temperatura', 790.0000, 'ºC'),
	(44983, 111, '2015-02-01 00:29:08.000000', 'temperatura', 1127.0000, 'ºC'),
	(44984, 111, '2015-02-01 00:29:09.000000', 'temperatura', 865.0000, 'ºC'),
	(44985, 111, '2015-02-01 00:29:10.000000', 'temperatura', 943.0000, 'ºC'),
	(44986, 111, '2015-02-01 00:29:11.000000', 'temperatura', 920.0000, 'ºC'),
	(44987, 111, '2015-02-01 00:29:12.000000', 'temperatura', 574.0000, 'ºC'),
	(44988, 111, '2015-02-01 00:29:13.000000', 'temperatura', 108.0000, 'ºC'),
	(44989, 111, '2015-02-01 00:29:14.000000', 'temperatura', 20.0000, 'ºC'),
	(44990, 111, '2015-02-01 00:29:15.000000', 'temperatura', 977.0000, 'ºC'),
	(44991, 111, '2015-02-01 00:29:16.000000', 'temperatura', 24.0000, 'ºC'),
	(44992, 111, '2015-02-01 00:29:17.000000', 'temperatura', 792.0000, 'ºC'),
	(44993, 111, '2015-02-01 00:29:18.000000', 'temperatura', 285.0000, 'ºC'),
	(44994, 111, '2015-02-01 00:29:19.000000', 'temperatura', 252.0000, 'ºC'),
	(44995, 111, '2015-02-01 00:29:20.000000', 'temperatura', 405.0000, 'ºC'),
	(44996, 111, '2015-02-01 00:29:21.000000', 'temperatura', 69.0000, 'ºC'),
	(44997, 111, '2015-02-01 00:29:22.000000', 'temperatura', 331.0000, 'ºC'),
	(44998, 111, '2015-02-01 00:29:23.000000', 'temperatura', 250.0000, 'ºC'),
	(44999, 111, '2015-02-01 00:29:24.000000', 'temperatura', 258.0000, 'ºC'),
	(45000, 111, '2015-02-01 00:29:25.000000', 'temperatura', 540.0000, 'ºC'),
	(45001, 111, '2015-02-01 00:29:26.000000', 'temperatura', 725.0000, 'ºC'),
	(45002, 111, '2015-02-01 00:29:27.000000', 'temperatura', 804.0000, 'ºC'),
	(45003, 111, '2015-02-01 00:29:28.000000', 'temperatura', 648.0000, 'ºC'),
	(45004, 111, '2015-02-01 00:29:29.000000', 'temperatura', 830.0000, 'ºC'),
	(45005, 111, '2015-02-01 00:29:30.000000', 'temperatura', 1004.0000, 'ºC'),
	(45006, 111, '2015-02-01 00:29:31.000000', 'temperatura', 130.0000, 'ºC'),
	(45007, 111, '2015-02-01 00:29:32.000000', 'temperatura', 38.0000, 'ºC'),
	(45008, 111, '2015-02-01 00:29:33.000000', 'temperatura', 1004.0000, 'ºC'),
	(45009, 111, '2015-02-01 00:29:34.000000', 'temperatura', 103.0000, 'ºC'),
	(45010, 111, '2015-02-01 00:29:35.000000', 'temperatura', 1104.0000, 'ºC'),
	(45011, 111, '2015-02-01 00:29:36.000000', 'temperatura', 411.0000, 'ºC'),
	(45012, 111, '2015-02-01 00:29:37.000000', 'temperatura', 1145.0000, 'ºC'),
	(45013, 111, '2015-02-01 00:29:38.000000', 'temperatura', 892.0000, 'ºC'),
	(45014, 111, '2015-02-01 00:29:39.000000', 'temperatura', 1024.0000, 'ºC'),
	(45015, 111, '2015-02-01 00:29:40.000000', 'temperatura', 46.0000, 'ºC'),
	(45016, 111, '2015-02-01 00:29:41.000000', 'temperatura', 757.0000, 'ºC'),
	(45017, 111, '2015-02-01 00:29:42.000000', 'temperatura', 47.0000, 'ºC'),
	(45018, 111, '2015-02-01 00:29:43.000000', 'temperatura', 365.0000, 'ºC'),
	(45019, 111, '2015-02-01 00:29:44.000000', 'temperatura', 486.0000, 'ºC'),
	(45020, 111, '2015-02-01 00:29:45.000000', 'temperatura', 133.0000, 'ºC'),
	(45021, 111, '2015-02-01 00:29:46.000000', 'temperatura', 408.0000, 'ºC'),
	(45022, 111, '2015-02-01 00:29:47.000000', 'temperatura', 443.0000, 'ºC'),
	(45023, 111, '2015-02-01 00:29:48.000000', 'temperatura', 991.0000, 'ºC'),
	(45024, 111, '2015-02-01 00:29:49.000000', 'temperatura', 25.0000, 'ºC'),
	(45025, 111, '2015-02-01 00:29:50.000000', 'temperatura', 755.0000, 'ºC'),
	(45026, 111, '2015-02-01 00:29:51.000000', 'temperatura', 100.0000, 'ºC'),
	(45027, 111, '2015-02-01 00:29:52.000000', 'temperatura', 637.0000, 'ºC'),
	(45028, 111, '2015-02-01 00:29:53.000000', 'temperatura', 483.0000, 'ºC'),
	(45029, 111, '2015-02-01 00:29:54.000000', 'temperatura', 506.0000, 'ºC'),
	(45030, 111, '2015-02-01 00:29:55.000000', 'temperatura', 1080.0000, 'ºC'),
	(45031, 111, '2015-02-01 00:29:56.000000', 'temperatura', 284.0000, 'ºC'),
	(45032, 111, '2015-02-01 00:29:57.000000', 'temperatura', 580.0000, 'ºC'),
	(45033, 111, '2015-02-01 00:29:58.000000', 'temperatura', 850.0000, 'ºC'),
	(45034, 111, '2015-02-01 00:29:59.000000', 'temperatura', 108.0000, 'ºC'),
	(45035, 111, '2015-02-01 00:30:00.000000', 'temperatura', 393.0000, 'ºC'),
	(45036, 111, '2015-02-01 00:30:01.000000', 'temperatura', 439.0000, 'ºC'),
	(45037, 111, '2015-02-01 00:30:02.000000', 'temperatura', 1016.0000, 'ºC'),
	(45038, 111, '2015-02-01 00:30:03.000000', 'temperatura', 163.0000, 'ºC'),
	(45039, 111, '2015-02-01 00:30:04.000000', 'temperatura', 170.0000, 'ºC'),
	(45040, 111, '2015-02-01 00:30:05.000000', 'temperatura', 362.0000, 'ºC'),
	(45041, 111, '2015-02-01 00:30:06.000000', 'temperatura', 101.0000, 'ºC'),
	(45042, 111, '2015-02-01 00:30:07.000000', 'temperatura', 621.0000, 'ºC'),
	(45043, 111, '2015-02-01 00:30:08.000000', 'temperatura', 399.0000, 'ºC'),
	(45044, 111, '2015-02-01 00:30:09.000000', 'temperatura', 133.0000, 'ºC'),
	(45045, 111, '2015-02-01 00:30:10.000000', 'temperatura', 668.0000, 'ºC'),
	(45046, 111, '2015-02-01 00:30:11.000000', 'temperatura', 541.0000, 'ºC'),
	(45047, 111, '2015-02-01 00:30:12.000000', 'temperatura', 704.0000, 'ºC'),
	(45048, 111, '2015-02-01 00:30:13.000000', 'temperatura', 695.0000, 'ºC'),
	(45049, 111, '2015-02-01 00:30:14.000000', 'temperatura', 164.0000, 'ºC'),
	(45050, 111, '2015-02-01 00:30:15.000000', 'temperatura', 1136.0000, 'ºC'),
	(45051, 111, '2015-02-01 00:30:16.000000', 'temperatura', 388.0000, 'ºC'),
	(45052, 111, '2015-02-01 00:30:17.000000', 'temperatura', 932.0000, 'ºC'),
	(45053, 111, '2015-02-01 00:30:18.000000', 'temperatura', 1099.0000, 'ºC'),
	(45054, 111, '2015-02-01 00:30:19.000000', 'temperatura', 299.0000, 'ºC'),
	(45055, 111, '2015-02-01 00:30:20.000000', 'temperatura', 597.0000, 'ºC'),
	(45056, 111, '2015-02-01 00:30:21.000000', 'temperatura', 889.0000, 'ºC'),
	(45057, 111, '2015-02-01 00:30:22.000000', 'temperatura', 256.0000, 'ºC'),
	(45058, 111, '2015-02-01 00:30:23.000000', 'temperatura', 1015.0000, 'ºC'),
	(45059, 111, '2015-02-01 00:30:24.000000', 'temperatura', 704.0000, 'ºC'),
	(45060, 111, '2015-02-01 00:30:25.000000', 'temperatura', 476.0000, 'ºC'),
	(45061, 111, '2015-02-01 00:30:26.000000', 'temperatura', 271.0000, 'ºC'),
	(45062, 111, '2015-02-01 00:30:27.000000', 'temperatura', 1125.0000, 'ºC'),
	(45063, 111, '2015-02-01 00:30:28.000000', 'temperatura', 13.0000, 'ºC'),
	(45064, 111, '2015-02-01 00:30:29.000000', 'temperatura', 292.0000, 'ºC'),
	(45065, 111, '2015-02-01 00:30:30.000000', 'temperatura', 221.0000, 'ºC'),
	(45066, 111, '2015-02-01 00:30:31.000000', 'temperatura', 231.0000, 'ºC'),
	(45067, 111, '2015-02-01 00:30:32.000000', 'temperatura', 491.0000, 'ºC'),
	(45068, 111, '2015-02-01 00:30:33.000000', 'temperatura', 564.0000, 'ºC'),
	(45069, 111, '2015-02-01 00:30:34.000000', 'temperatura', 148.0000, 'ºC'),
	(45070, 111, '2015-02-01 00:30:35.000000', 'temperatura', 246.0000, 'ºC'),
	(45071, 111, '2015-02-01 00:30:36.000000', 'temperatura', 787.0000, 'ºC'),
	(45072, 111, '2015-02-01 00:30:37.000000', 'temperatura', 798.0000, 'ºC'),
	(45073, 111, '2015-02-01 00:30:38.000000', 'temperatura', 431.0000, 'ºC'),
	(45074, 111, '2015-02-01 00:30:39.000000', 'temperatura', 960.0000, 'ºC'),
	(45075, 111, '2015-02-01 00:30:40.000000', 'temperatura', 1106.0000, 'ºC'),
	(45076, 111, '2015-02-01 00:30:41.000000', 'temperatura', 253.0000, 'ºC'),
	(45077, 111, '2015-02-01 00:30:42.000000', 'temperatura', 345.0000, 'ºC'),
	(45078, 111, '2015-02-01 00:30:43.000000', 'temperatura', 966.0000, 'ºC'),
	(45079, 111, '2015-02-01 00:30:44.000000', 'temperatura', 195.0000, 'ºC'),
	(45080, 111, '2015-02-01 00:30:45.000000', 'temperatura', 478.0000, 'ºC'),
	(45081, 111, '2015-02-01 00:30:46.000000', 'temperatura', 608.0000, 'ºC'),
	(45082, 111, '2015-02-01 00:30:47.000000', 'temperatura', 404.0000, 'ºC'),
	(45083, 111, '2015-02-01 00:30:48.000000', 'temperatura', 196.0000, 'ºC'),
	(45084, 111, '2015-02-01 00:30:49.000000', 'temperatura', 970.0000, 'ºC'),
	(45085, 111, '2015-02-01 00:30:50.000000', 'temperatura', 663.0000, 'ºC'),
	(45086, 111, '2015-02-01 00:30:51.000000', 'temperatura', 406.0000, 'ºC'),
	(45087, 111, '2015-02-01 00:30:52.000000', 'temperatura', 40.0000, 'ºC'),
	(45088, 111, '2015-02-01 00:30:53.000000', 'temperatura', 185.0000, 'ºC'),
	(45089, 111, '2015-02-01 00:30:54.000000', 'temperatura', 803.0000, 'ºC'),
	(45090, 111, '2015-02-01 00:30:55.000000', 'temperatura', 1063.0000, 'ºC'),
	(45091, 111, '2015-02-01 00:30:56.000000', 'temperatura', 505.0000, 'ºC'),
	(45092, 111, '2015-02-01 00:30:57.000000', 'temperatura', 537.0000, 'ºC'),
	(45093, 111, '2015-02-01 00:30:58.000000', 'temperatura', 1171.0000, 'ºC'),
	(45094, 111, '2015-02-01 00:30:59.000000', 'temperatura', 645.0000, 'ºC'),
	(45095, 111, '2015-02-01 00:31:00.000000', 'temperatura', 911.0000, 'ºC'),
	(45096, 111, '2015-02-01 00:31:01.000000', 'temperatura', 219.0000, 'ºC'),
	(45097, 111, '2015-02-01 00:31:02.000000', 'temperatura', 765.0000, 'ºC'),
	(45098, 111, '2015-02-01 00:31:03.000000', 'temperatura', 769.0000, 'ºC'),
	(45099, 111, '2015-02-01 00:31:04.000000', 'temperatura', 350.0000, 'ºC'),
	(45100, 111, '2015-02-01 00:31:05.000000', 'temperatura', 645.0000, 'ºC'),
	(45101, 111, '2015-02-01 00:31:06.000000', 'temperatura', 972.0000, 'ºC'),
	(45102, 111, '2015-02-01 00:31:07.000000', 'temperatura', 528.0000, 'ºC'),
	(45103, 111, '2015-02-01 00:31:08.000000', 'temperatura', 925.0000, 'ºC'),
	(45104, 111, '2015-02-01 00:31:09.000000', 'temperatura', 639.0000, 'ºC'),
	(45105, 111, '2015-02-01 00:31:10.000000', 'temperatura', 423.0000, 'ºC'),
	(45106, 111, '2015-02-01 00:31:11.000000', 'temperatura', 196.0000, 'ºC'),
	(45107, 111, '2015-02-01 00:31:12.000000', 'temperatura', 913.0000, 'ºC'),
	(45108, 111, '2015-02-01 00:31:13.000000', 'temperatura', 377.0000, 'ºC'),
	(45109, 111, '2015-02-01 00:31:14.000000', 'temperatura', 346.0000, 'ºC'),
	(45110, 111, '2015-02-01 00:31:15.000000', 'temperatura', 600.0000, 'ºC'),
	(45111, 111, '2015-02-01 00:31:16.000000', 'temperatura', 763.0000, 'ºC'),
	(45112, 111, '2015-02-01 00:31:17.000000', 'temperatura', 817.0000, 'ºC'),
	(45113, 111, '2015-02-01 00:31:18.000000', 'temperatura', 594.0000, 'ºC'),
	(45114, 111, '2015-02-01 00:31:19.000000', 'temperatura', 522.0000, 'ºC'),
	(45115, 111, '2015-02-01 00:31:20.000000', 'temperatura', 826.0000, 'ºC'),
	(45116, 111, '2015-02-01 00:31:21.000000', 'temperatura', 167.0000, 'ºC'),
	(45117, 111, '2015-02-01 00:31:22.000000', 'temperatura', 758.0000, 'ºC'),
	(45118, 111, '2015-02-01 00:31:23.000000', 'temperatura', 889.0000, 'ºC'),
	(45119, 111, '2015-02-01 00:31:24.000000', 'temperatura', 970.0000, 'ºC'),
	(45120, 111, '2015-02-01 00:31:25.000000', 'temperatura', 985.0000, 'ºC'),
	(45121, 111, '2015-02-01 00:31:26.000000', 'temperatura', 814.0000, 'ºC'),
	(45122, 111, '2015-02-01 00:31:27.000000', 'temperatura', 1118.0000, 'ºC'),
	(45123, 111, '2015-02-01 00:31:28.000000', 'temperatura', 747.0000, 'ºC'),
	(45124, 111, '2015-02-01 00:31:29.000000', 'temperatura', 382.0000, 'ºC'),
	(45125, 111, '2015-02-01 00:31:30.000000', 'temperatura', 868.0000, 'ºC'),
	(45126, 111, '2015-02-01 00:31:31.000000', 'temperatura', 796.0000, 'ºC'),
	(45127, 111, '2015-02-01 00:31:32.000000', 'temperatura', 174.0000, 'ºC'),
	(45128, 111, '2015-02-01 00:31:33.000000', 'temperatura', 885.0000, 'ºC'),
	(45129, 111, '2015-02-01 00:31:34.000000', 'temperatura', 302.0000, 'ºC'),
	(45130, 111, '2015-02-01 00:31:35.000000', 'temperatura', 55.0000, 'ºC'),
	(45131, 111, '2015-02-01 00:31:36.000000', 'temperatura', 572.0000, 'ºC'),
	(45132, 111, '2015-02-01 00:31:37.000000', 'temperatura', 293.0000, 'ºC'),
	(45133, 111, '2015-02-01 00:31:38.000000', 'temperatura', 952.0000, 'ºC'),
	(45134, 111, '2015-02-01 00:31:39.000000', 'temperatura', 279.0000, 'ºC'),
	(45135, 111, '2015-02-01 00:31:40.000000', 'temperatura', 941.0000, 'ºC'),
	(45136, 111, '2015-02-01 00:31:41.000000', 'temperatura', 266.0000, 'ºC'),
	(45137, 111, '2015-02-01 00:31:42.000000', 'temperatura', 910.0000, 'ºC'),
	(45138, 111, '2015-02-01 00:31:43.000000', 'temperatura', 152.0000, 'ºC'),
	(45139, 111, '2015-02-01 00:31:44.000000', 'temperatura', 431.0000, 'ºC'),
	(45140, 111, '2015-02-01 00:31:45.000000', 'temperatura', 498.0000, 'ºC'),
	(45141, 111, '2015-02-01 00:31:46.000000', 'temperatura', 1198.0000, 'ºC'),
	(45142, 111, '2015-02-01 00:31:47.000000', 'temperatura', 896.0000, 'ºC'),
	(45143, 111, '2015-02-01 00:31:48.000000', 'temperatura', 889.0000, 'ºC'),
	(45144, 111, '2015-02-01 00:31:49.000000', 'temperatura', 554.0000, 'ºC'),
	(45145, 111, '2015-02-01 00:31:50.000000', 'temperatura', 106.0000, 'ºC'),
	(45146, 111, '2015-02-01 00:31:51.000000', 'temperatura', 68.0000, 'ºC'),
	(45147, 111, '2015-02-01 00:31:52.000000', 'temperatura', 21.0000, 'ºC'),
	(45148, 111, '2015-02-01 00:31:53.000000', 'temperatura', 1105.0000, 'ºC'),
	(45149, 111, '2015-02-01 00:31:54.000000', 'temperatura', 659.0000, 'ºC'),
	(45150, 111, '2015-02-01 00:31:55.000000', 'temperatura', 1180.0000, 'ºC'),
	(45151, 111, '2015-02-01 00:31:56.000000', 'temperatura', 327.0000, 'ºC'),
	(45152, 111, '2015-02-01 00:31:57.000000', 'temperatura', 493.0000, 'ºC'),
	(45153, 111, '2015-02-01 00:31:58.000000', 'temperatura', 285.0000, 'ºC'),
	(45154, 111, '2015-02-01 00:31:59.000000', 'temperatura', 1146.0000, 'ºC'),
	(45155, 111, '2015-02-01 00:32:00.000000', 'temperatura', 75.0000, 'ºC'),
	(45156, 111, '2015-02-01 00:32:01.000000', 'temperatura', 540.0000, 'ºC'),
	(45157, 111, '2015-02-01 00:32:02.000000', 'temperatura', 75.0000, 'ºC'),
	(45158, 111, '2015-02-01 00:32:03.000000', 'temperatura', 1156.0000, 'ºC'),
	(45159, 111, '2015-02-01 00:32:04.000000', 'temperatura', 756.0000, 'ºC'),
	(45160, 111, '2015-02-01 00:32:05.000000', 'temperatura', 313.0000, 'ºC'),
	(45161, 111, '2015-02-01 00:32:06.000000', 'temperatura', 497.0000, 'ºC'),
	(45162, 111, '2015-02-01 00:32:07.000000', 'temperatura', 346.0000, 'ºC'),
	(45163, 111, '2015-02-01 00:32:08.000000', 'temperatura', 240.0000, 'ºC'),
	(45164, 111, '2015-02-01 00:32:09.000000', 'temperatura', 161.0000, 'ºC'),
	(45165, 111, '2015-02-01 00:32:10.000000', 'temperatura', 88.0000, 'ºC'),
	(45166, 111, '2015-02-01 00:32:11.000000', 'temperatura', 1155.0000, 'ºC'),
	(45167, 111, '2015-02-01 00:32:12.000000', 'temperatura', 713.0000, 'ºC'),
	(45168, 111, '2015-02-01 00:32:13.000000', 'temperatura', 100.0000, 'ºC'),
	(45169, 111, '2015-02-01 00:32:14.000000', 'temperatura', 760.0000, 'ºC'),
	(45170, 111, '2015-02-01 00:32:15.000000', 'temperatura', 1102.0000, 'ºC'),
	(45171, 111, '2015-02-01 00:32:16.000000', 'temperatura', 829.0000, 'ºC'),
	(45172, 111, '2015-02-01 00:32:17.000000', 'temperatura', 840.0000, 'ºC'),
	(45173, 111, '2015-02-01 00:32:18.000000', 'temperatura', 513.0000, 'ºC'),
	(45174, 111, '2015-02-01 00:32:19.000000', 'temperatura', 48.0000, 'ºC'),
	(45175, 111, '2015-02-01 00:32:20.000000', 'temperatura', 1100.0000, 'ºC'),
	(45176, 111, '2015-02-01 00:32:21.000000', 'temperatura', 557.0000, 'ºC'),
	(45177, 111, '2015-02-01 00:32:22.000000', 'temperatura', 685.0000, 'ºC'),
	(45178, 111, '2015-02-01 00:32:23.000000', 'temperatura', 555.0000, 'ºC'),
	(45179, 111, '2015-02-01 00:32:24.000000', 'temperatura', 721.0000, 'ºC'),
	(45180, 111, '2015-02-01 00:32:25.000000', 'temperatura', 739.0000, 'ºC'),
	(45181, 111, '2015-02-01 00:32:26.000000', 'temperatura', 332.0000, 'ºC'),
	(45182, 111, '2015-02-01 00:32:27.000000', 'temperatura', 645.0000, 'ºC'),
	(45183, 111, '2015-02-01 00:32:28.000000', 'temperatura', 1027.0000, 'ºC'),
	(45184, 111, '2015-02-01 00:32:29.000000', 'temperatura', 802.0000, 'ºC'),
	(45185, 111, '2015-02-01 00:32:30.000000', 'temperatura', 930.0000, 'ºC'),
	(45186, 111, '2015-02-01 00:32:31.000000', 'temperatura', 1046.0000, 'ºC'),
	(45187, 111, '2015-02-01 00:32:32.000000', 'temperatura', 37.0000, 'ºC'),
	(45188, 111, '2015-02-01 00:32:33.000000', 'temperatura', 651.0000, 'ºC'),
	(45189, 111, '2015-02-01 00:32:34.000000', 'temperatura', 744.0000, 'ºC'),
	(45190, 111, '2015-02-01 00:32:35.000000', 'temperatura', 566.0000, 'ºC'),
	(45191, 111, '2015-02-01 00:32:36.000000', 'temperatura', 599.0000, 'ºC'),
	(45192, 111, '2015-02-01 00:32:37.000000', 'temperatura', 99.0000, 'ºC'),
	(45193, 111, '2015-02-01 00:32:38.000000', 'temperatura', 1096.0000, 'ºC'),
	(45194, 111, '2015-02-01 00:32:39.000000', 'temperatura', 385.0000, 'ºC'),
	(45195, 111, '2015-02-01 00:32:40.000000', 'temperatura', 1036.0000, 'ºC'),
	(45196, 111, '2015-02-01 00:32:41.000000', 'temperatura', 428.0000, 'ºC'),
	(45197, 111, '2015-02-01 00:32:42.000000', 'temperatura', 231.0000, 'ºC'),
	(45198, 111, '2015-02-01 00:32:43.000000', 'temperatura', 1073.0000, 'ºC'),
	(45199, 111, '2015-02-01 00:32:44.000000', 'temperatura', 1073.0000, 'ºC'),
	(45200, 111, '2015-02-01 00:32:45.000000', 'temperatura', 944.0000, 'ºC'),
	(45201, 111, '2015-02-01 00:32:46.000000', 'temperatura', 303.0000, 'ºC'),
	(45202, 111, '2015-02-01 00:32:47.000000', 'temperatura', 1085.0000, 'ºC'),
	(45203, 111, '2015-02-01 00:32:48.000000', 'temperatura', 914.0000, 'ºC'),
	(45204, 111, '2015-02-01 00:32:49.000000', 'temperatura', 115.0000, 'ºC'),
	(45205, 111, '2015-02-01 00:32:50.000000', 'temperatura', 234.0000, 'ºC'),
	(45206, 111, '2015-02-01 00:32:51.000000', 'temperatura', 827.0000, 'ºC'),
	(45207, 111, '2015-02-01 00:32:52.000000', 'temperatura', 1034.0000, 'ºC'),
	(45208, 111, '2015-02-01 00:32:53.000000', 'temperatura', 288.0000, 'ºC'),
	(45209, 111, '2015-02-01 00:32:54.000000', 'temperatura', 738.0000, 'ºC'),
	(45210, 111, '2015-02-01 00:32:55.000000', 'temperatura', 429.0000, 'ºC'),
	(45211, 111, '2015-02-01 00:32:56.000000', 'temperatura', 1131.0000, 'ºC'),
	(45212, 111, '2015-02-01 00:32:57.000000', 'temperatura', 768.0000, 'ºC'),
	(45213, 111, '2015-02-01 00:32:58.000000', 'temperatura', 448.0000, 'ºC'),
	(45214, 111, '2015-02-01 00:32:59.000000', 'temperatura', 1137.0000, 'ºC'),
	(45215, 111, '2015-02-01 00:33:00.000000', 'temperatura', 740.0000, 'ºC'),
	(45216, 111, '2015-02-01 00:33:01.000000', 'temperatura', 291.0000, 'ºC'),
	(45217, 111, '2015-02-01 00:33:02.000000', 'temperatura', 436.0000, 'ºC'),
	(45218, 111, '2015-02-01 00:33:03.000000', 'temperatura', 109.0000, 'ºC'),
	(45219, 111, '2015-02-01 00:33:04.000000', 'temperatura', 435.0000, 'ºC'),
	(45220, 111, '2015-02-01 00:33:05.000000', 'temperatura', 650.0000, 'ºC'),
	(45221, 111, '2015-02-01 00:33:06.000000', 'temperatura', 743.0000, 'ºC'),
	(45222, 111, '2015-02-01 00:33:07.000000', 'temperatura', 568.0000, 'ºC'),
	(45223, 111, '2015-02-01 00:33:08.000000', 'temperatura', 610.0000, 'ºC'),
	(45224, 111, '2015-02-01 00:33:09.000000', 'temperatura', 148.0000, 'ºC'),
	(45225, 111, '2015-02-01 00:33:10.000000', 'temperatura', 111.0000, 'ºC'),
	(45226, 111, '2015-02-01 00:33:11.000000', 'temperatura', 113.0000, 'ºC'),
	(45227, 111, '2015-02-01 00:33:12.000000', 'temperatura', 229.0000, 'ºC'),
	(45228, 111, '2015-02-01 00:33:13.000000', 'temperatura', 809.0000, 'ºC'),
	(45229, 111, '2015-02-01 00:33:14.000000', 'temperatura', 956.0000, 'ºC'),
	(45230, 111, '2015-02-01 00:33:15.000000', 'temperatura', 1156.0000, 'ºC'),
	(45231, 111, '2015-02-01 00:33:16.000000', 'temperatura', 510.0000, 'ºC'),
	(45232, 111, '2015-02-01 00:33:17.000000', 'temperatura', 284.0000, 'ºC'),
	(45233, 111, '2015-02-01 00:33:18.000000', 'temperatura', 1089.0000, 'ºC'),
	(45234, 111, '2015-02-01 00:33:19.000000', 'temperatura', 992.0000, 'ºC'),
	(45235, 111, '2015-02-01 00:33:20.000000', 'temperatura', 497.0000, 'ºC'),
	(45236, 111, '2015-02-01 00:33:21.000000', 'temperatura', 707.0000, 'ºC'),
	(45237, 111, '2015-02-01 00:33:22.000000', 'temperatura', 846.0000, 'ºC'),
	(45238, 111, '2015-02-01 00:33:23.000000', 'temperatura', 911.0000, 'ºC'),
	(45239, 111, '2015-02-01 00:33:24.000000', 'temperatura', 816.0000, 'ºC'),
	(45240, 111, '2015-02-01 00:33:25.000000', 'temperatura', 148.0000, 'ºC'),
	(45241, 111, '2015-02-01 00:33:26.000000', 'temperatura', 693.0000, 'ºC'),
	(45242, 111, '2015-02-01 00:33:27.000000', 'temperatura', 619.0000, 'ºC'),
	(45243, 111, '2015-02-01 00:33:28.000000', 'temperatura', 1018.0000, 'ºC'),
	(45244, 111, '2015-02-01 00:33:29.000000', 'temperatura', 835.0000, 'ºC'),
	(45245, 111, '2015-02-01 00:33:30.000000', 'temperatura', 1122.0000, 'ºC'),
	(45246, 111, '2015-02-01 00:33:31.000000', 'temperatura', 702.0000, 'ºC'),
	(45247, 111, '2015-02-01 00:33:32.000000', 'temperatura', 148.0000, 'ºC'),
	(45248, 111, '2015-02-01 00:33:33.000000', 'temperatura', 1032.0000, 'ºC'),
	(45249, 111, '2015-02-01 00:33:34.000000', 'temperatura', 1116.0000, 'ºC'),
	(45250, 111, '2015-02-01 00:33:35.000000', 'temperatura', 84.0000, 'ºC'),
	(45251, 111, '2015-02-01 00:33:36.000000', 'temperatura', 674.0000, 'ºC'),
	(45252, 111, '2015-02-01 00:33:37.000000', 'temperatura', 720.0000, 'ºC'),
	(45253, 111, '2015-02-01 00:33:38.000000', 'temperatura', 378.0000, 'ºC'),
	(45254, 111, '2015-02-01 00:33:39.000000', 'temperatura', 932.0000, 'ºC'),
	(45255, 111, '2015-02-01 00:33:40.000000', 'temperatura', 1125.0000, 'ºC'),
	(45256, 111, '2015-02-01 00:33:41.000000', 'temperatura', 431.0000, 'ºC'),
	(45257, 111, '2015-02-01 00:33:42.000000', 'temperatura', 1181.0000, 'ºC'),
	(45258, 111, '2015-02-01 00:33:43.000000', 'temperatura', 1010.0000, 'ºC'),
	(45259, 111, '2015-02-01 00:33:44.000000', 'temperatura', 308.0000, 'ºC'),
	(45260, 111, '2015-02-01 00:33:45.000000', 'temperatura', 912.0000, 'ºC'),
	(45261, 111, '2015-02-01 00:33:46.000000', 'temperatura', 36.0000, 'ºC'),
	(45262, 111, '2015-02-01 00:33:47.000000', 'temperatura', 1044.0000, 'ºC'),
	(45263, 111, '2015-02-01 00:33:48.000000', 'temperatura', 313.0000, 'ºC'),
	(45264, 111, '2015-02-01 00:33:49.000000', 'temperatura', 834.0000, 'ºC'),
	(45265, 111, '2015-02-01 00:33:50.000000', 'temperatura', 829.0000, 'ºC'),
	(45266, 111, '2015-02-01 00:33:51.000000', 'temperatura', 445.0000, 'ºC'),
	(45267, 111, '2015-02-01 00:33:52.000000', 'temperatura', 936.0000, 'ºC'),
	(45268, 111, '2015-02-01 00:33:53.000000', 'temperatura', 949.0000, 'ºC'),
	(45269, 111, '2015-02-01 00:33:54.000000', 'temperatura', 735.0000, 'ºC'),
	(45270, 111, '2015-02-01 00:33:55.000000', 'temperatura', 828.0000, 'ºC'),
	(45271, 111, '2015-02-01 00:33:56.000000', 'temperatura', 735.0000, 'ºC'),
	(45272, 111, '2015-02-01 00:33:57.000000', 'temperatura', 1190.0000, 'ºC'),
	(45273, 111, '2015-02-01 00:33:58.000000', 'temperatura', 149.0000, 'ºC'),
	(45274, 111, '2015-02-01 00:33:59.000000', 'temperatura', 774.0000, 'ºC'),
	(45275, 111, '2015-02-01 00:34:00.000000', 'temperatura', 1024.0000, 'ºC'),
	(45276, 111, '2015-02-01 00:34:01.000000', 'temperatura', 398.0000, 'ºC'),
	(45277, 111, '2015-02-01 00:34:02.000000', 'temperatura', 119.0000, 'ºC'),
	(45278, 111, '2015-02-01 00:34:03.000000', 'temperatura', 599.0000, 'ºC'),
	(45279, 111, '2015-02-01 00:34:04.000000', 'temperatura', 242.0000, 'ºC'),
	(45280, 111, '2015-02-01 00:34:05.000000', 'temperatura', 611.0000, 'ºC'),
	(45281, 111, '2015-02-01 00:34:06.000000', 'temperatura', 1131.0000, 'ºC'),
	(45282, 111, '2015-02-01 00:34:07.000000', 'temperatura', 223.0000, 'ºC'),
	(45283, 111, '2015-02-01 00:34:08.000000', 'temperatura', 123.0000, 'ºC'),
	(45284, 111, '2015-02-01 00:34:09.000000', 'temperatura', 1146.0000, 'ºC'),
	(45285, 111, '2015-02-01 00:34:10.000000', 'temperatura', 563.0000, 'ºC'),
	(45286, 111, '2015-02-01 00:34:11.000000', 'temperatura', 577.0000, 'ºC'),
	(45287, 111, '2015-02-01 00:34:12.000000', 'temperatura', 1194.0000, 'ºC'),
	(45288, 111, '2015-02-01 00:34:13.000000', 'temperatura', 641.0000, 'ºC'),
	(45289, 111, '2015-02-01 00:34:14.000000', 'temperatura', 823.0000, 'ºC'),
	(45290, 111, '2015-02-01 00:34:15.000000', 'temperatura', 991.0000, 'ºC'),
	(45291, 111, '2015-02-01 00:34:16.000000', 'temperatura', 86.0000, 'ºC'),
	(45292, 111, '2015-02-01 00:34:17.000000', 'temperatura', 1060.0000, 'ºC'),
	(45293, 111, '2015-02-01 00:34:18.000000', 'temperatura', 241.0000, 'ºC'),
	(45294, 111, '2015-02-01 00:34:19.000000', 'temperatura', 427.0000, 'ºC'),
	(45295, 111, '2015-02-01 00:34:20.000000', 'temperatura', 210.0000, 'ºC'),
	(45296, 111, '2015-02-01 00:34:21.000000', 'temperatura', 970.0000, 'ºC'),
	(45297, 111, '2015-02-01 00:34:22.000000', 'temperatura', 622.0000, 'ºC'),
	(45298, 111, '2015-02-01 00:34:23.000000', 'temperatura', 200.0000, 'ºC'),
	(45299, 111, '2015-02-01 00:34:24.000000', 'temperatura', 335.0000, 'ºC'),
	(45300, 111, '2015-02-01 00:34:25.000000', 'temperatura', 1074.0000, 'ºC'),
	(45301, 111, '2015-02-01 00:34:26.000000', 'temperatura', 764.0000, 'ºC'),
	(45302, 111, '2015-02-01 00:34:27.000000', 'temperatura', 602.0000, 'ºC'),
	(45303, 111, '2015-02-01 00:34:28.000000', 'temperatura', 715.0000, 'ºC'),
	(45304, 111, '2015-02-01 00:34:29.000000', 'temperatura', 572.0000, 'ºC'),
	(45305, 111, '2015-02-01 00:34:30.000000', 'temperatura', 717.0000, 'ºC'),
	(45306, 111, '2015-02-01 00:34:31.000000', 'temperatura', 666.0000, 'ºC'),
	(45307, 111, '2015-02-01 00:34:32.000000', 'temperatura', 1182.0000, 'ºC'),
	(45308, 111, '2015-02-01 00:34:33.000000', 'temperatura', 312.0000, 'ºC'),
	(45309, 111, '2015-02-01 00:34:34.000000', 'temperatura', 415.0000, 'ºC'),
	(45310, 111, '2015-02-01 00:34:35.000000', 'temperatura', 1139.0000, 'ºC'),
	(45311, 111, '2015-02-01 00:34:36.000000', 'temperatura', 850.0000, 'ºC'),
	(45312, 111, '2015-02-01 00:34:37.000000', 'temperatura', 833.0000, 'ºC'),
	(45313, 111, '2015-02-01 00:34:38.000000', 'temperatura', 418.0000, 'ºC'),
	(45314, 111, '2015-02-01 00:34:39.000000', 'temperatura', 791.0000, 'ºC'),
	(45315, 111, '2015-02-01 00:34:40.000000', 'temperatura', 301.0000, 'ºC'),
	(45316, 111, '2015-02-01 00:34:41.000000', 'temperatura', 334.0000, 'ºC'),
	(45317, 111, '2015-02-01 00:34:42.000000', 'temperatura', 765.0000, 'ºC'),
	(45318, 111, '2015-02-01 00:34:43.000000', 'temperatura', 427.0000, 'ºC'),
	(45319, 111, '2015-02-01 00:34:44.000000', 'temperatura', 1037.0000, 'ºC'),
	(45320, 111, '2015-02-01 00:34:45.000000', 'temperatura', 305.0000, 'ºC'),
	(45321, 111, '2015-02-01 00:34:46.000000', 'temperatura', 815.0000, 'ºC'),
	(45322, 111, '2015-02-01 00:34:47.000000', 'temperatura', 761.0000, 'ºC'),
	(45323, 111, '2015-02-01 00:34:48.000000', 'temperatura', 162.0000, 'ºC'),
	(45324, 111, '2015-02-01 00:34:49.000000', 'temperatura', 924.0000, 'ºC'),
	(45325, 111, '2015-02-01 00:34:50.000000', 'temperatura', 537.0000, 'ºC'),
	(45326, 111, '2015-02-01 00:34:51.000000', 'temperatura', 1114.0000, 'ºC'),
	(45327, 111, '2015-02-01 00:34:52.000000', 'temperatura', 361.0000, 'ºC'),
	(45328, 111, '2015-02-01 00:34:53.000000', 'temperatura', 861.0000, 'ºC'),
	(45329, 111, '2015-02-01 00:34:54.000000', 'temperatura', 823.0000, 'ºC'),
	(45330, 111, '2015-02-01 00:34:55.000000', 'temperatura', 331.0000, 'ºC'),
	(45331, 111, '2015-02-01 00:34:56.000000', 'temperatura', 387.0000, 'ºC'),
	(45332, 111, '2015-02-01 00:34:57.000000', 'temperatura', 944.0000, 'ºC'),
	(45333, 111, '2015-02-01 00:34:58.000000', 'temperatura', 1158.0000, 'ºC'),
	(45334, 111, '2015-02-01 00:34:59.000000', 'temperatura', 560.0000, 'ºC'),
	(45335, 111, '2015-02-01 00:35:00.000000', 'temperatura', 526.0000, 'ºC'),
	(45336, 111, '2015-02-01 00:35:01.000000', 'temperatura', 950.0000, 'ºC'),
	(45337, 111, '2015-02-01 00:35:02.000000', 'temperatura', 774.0000, 'ºC'),
	(45338, 111, '2015-02-01 00:35:03.000000', 'temperatura', 1019.0000, 'ºC'),
	(45339, 111, '2015-02-01 00:35:04.000000', 'temperatura', 376.0000, 'ºC'),
	(45340, 111, '2015-02-01 00:35:05.000000', 'temperatura', 22.0000, 'ºC'),
	(45341, 111, '2015-02-01 00:35:06.000000', 'temperatura', 184.0000, 'ºC'),
	(45342, 111, '2015-02-01 00:35:07.000000', 'temperatura', 854.0000, 'ºC'),
	(45343, 111, '2015-02-01 00:35:08.000000', 'temperatura', 119.0000, 'ºC'),
	(45344, 111, '2015-02-01 00:35:09.000000', 'temperatura', 434.0000, 'ºC'),
	(45345, 111, '2015-02-01 00:35:10.000000', 'temperatura', 611.0000, 'ºC'),
	(45346, 111, '2015-02-01 00:35:11.000000', 'temperatura', 555.0000, 'ºC'),
	(45347, 111, '2015-02-01 00:35:12.000000', 'temperatura', 942.0000, 'ºC'),
	(45348, 111, '2015-02-01 00:35:13.000000', 'temperatura', 647.0000, 'ºC'),
	(45349, 111, '2015-02-01 00:35:14.000000', 'temperatura', 407.0000, 'ºC'),
	(45350, 111, '2015-02-01 00:35:15.000000', 'temperatura', 94.0000, 'ºC'),
	(45351, 111, '2015-02-01 00:35:16.000000', 'temperatura', 451.0000, 'ºC'),
	(45352, 111, '2015-02-01 00:35:17.000000', 'temperatura', 774.0000, 'ºC'),
	(45353, 111, '2015-02-01 00:35:18.000000', 'temperatura', 117.0000, 'ºC'),
	(45354, 111, '2015-02-01 00:35:19.000000', 'temperatura', 665.0000, 'ºC'),
	(45355, 111, '2015-02-01 00:35:20.000000', 'temperatura', 575.0000, 'ºC'),
	(45356, 111, '2015-02-01 00:35:21.000000', 'temperatura', 880.0000, 'ºC'),
	(45357, 111, '2015-02-01 00:35:22.000000', 'temperatura', 277.0000, 'ºC'),
	(45358, 111, '2015-02-01 00:35:23.000000', 'temperatura', 1143.0000, 'ºC'),
	(45359, 111, '2015-02-01 00:35:24.000000', 'temperatura', 85.0000, 'ºC'),
	(45360, 111, '2015-02-01 00:35:25.000000', 'temperatura', 597.0000, 'ºC'),
	(45361, 111, '2015-02-01 00:35:26.000000', 'temperatura', 329.0000, 'ºC'),
	(45362, 111, '2015-02-01 00:35:27.000000', 'temperatura', 1057.0000, 'ºC'),
	(45363, 111, '2015-02-01 00:35:28.000000', 'temperatura', 699.0000, 'ºC'),
	(45364, 111, '2015-02-01 00:35:29.000000', 'temperatura', 321.0000, 'ºC'),
	(45365, 111, '2015-02-01 00:35:30.000000', 'temperatura', 712.0000, 'ºC'),
	(45366, 111, '2015-02-01 00:35:31.000000', 'temperatura', 197.0000, 'ºC'),
	(45367, 111, '2015-02-01 00:35:32.000000', 'temperatura', 50.0000, 'ºC'),
	(45368, 111, '2015-02-01 00:35:33.000000', 'temperatura', 860.0000, 'ºC'),
	(45369, 111, '2015-02-01 00:35:34.000000', 'temperatura', 551.0000, 'ºC'),
	(45370, 111, '2015-02-01 00:35:35.000000', 'temperatura', 175.0000, 'ºC'),
	(45371, 111, '2015-02-01 00:35:36.000000', 'temperatura', 421.0000, 'ºC'),
	(45372, 111, '2015-02-01 00:35:37.000000', 'temperatura', 381.0000, 'ºC'),
	(45373, 111, '2015-02-01 00:35:38.000000', 'temperatura', 643.0000, 'ºC'),
	(45374, 111, '2015-02-01 00:35:39.000000', 'temperatura', 871.0000, 'ºC'),
	(45375, 111, '2015-02-01 00:35:40.000000', 'temperatura', 26.0000, 'ºC'),
	(45376, 111, '2015-02-01 00:35:41.000000', 'temperatura', 1119.0000, 'ºC'),
	(45377, 111, '2015-02-01 00:35:42.000000', 'temperatura', 718.0000, 'ºC'),
	(45378, 111, '2015-02-01 00:35:43.000000', 'temperatura', 234.0000, 'ºC'),
	(45379, 111, '2015-02-01 00:35:44.000000', 'temperatura', 216.0000, 'ºC'),
	(45380, 111, '2015-02-01 00:35:45.000000', 'temperatura', 377.0000, 'ºC'),
	(45381, 111, '2015-02-01 00:35:46.000000', 'temperatura', 40.0000, 'ºC'),
	(45382, 111, '2015-02-01 00:35:47.000000', 'temperatura', 268.0000, 'ºC'),
	(45383, 111, '2015-02-01 00:35:48.000000', 'temperatura', 22.0000, 'ºC'),
	(45384, 111, '2015-02-01 00:35:49.000000', 'temperatura', 505.0000, 'ºC'),
	(45385, 111, '2015-02-01 00:35:50.000000', 'temperatura', 60.0000, 'ºC'),
	(45386, 111, '2015-02-01 00:35:51.000000', 'temperatura', 1186.0000, 'ºC'),
	(45387, 111, '2015-02-01 00:35:52.000000', 'temperatura', 951.0000, 'ºC'),
	(45388, 111, '2015-02-01 00:35:53.000000', 'temperatura', 1196.0000, 'ºC'),
	(45389, 111, '2015-02-01 00:35:54.000000', 'temperatura', 729.0000, 'ºC'),
	(45390, 111, '2015-02-01 00:35:55.000000', 'temperatura', 57.0000, 'ºC'),
	(45391, 111, '2015-02-01 00:35:56.000000', 'temperatura', 497.0000, 'ºC'),
	(45392, 111, '2015-02-01 00:35:57.000000', 'temperatura', 1114.0000, 'ºC'),
	(45393, 111, '2015-02-01 00:35:58.000000', 'temperatura', 482.0000, 'ºC'),
	(45394, 111, '2015-02-01 00:35:59.000000', 'temperatura', 267.0000, 'ºC'),
	(45395, 111, '2015-02-01 00:36:00.000000', 'temperatura', 1089.0000, 'ºC'),
	(45396, 111, '2015-02-01 00:36:01.000000', 'temperatura', 1046.0000, 'ºC'),
	(45397, 111, '2015-02-01 00:36:02.000000', 'temperatura', 764.0000, 'ºC'),
	(45398, 111, '2015-02-01 00:36:03.000000', 'temperatura', 680.0000, 'ºC'),
	(45399, 111, '2015-02-01 00:36:04.000000', 'temperatura', 1109.0000, 'ºC'),
	(45400, 111, '2015-02-01 00:36:05.000000', 'temperatura', 1108.0000, 'ºC'),
	(45401, 111, '2015-02-01 00:36:06.000000', 'temperatura', 1010.0000, 'ºC'),
	(45402, 111, '2015-02-01 00:36:07.000000', 'temperatura', 528.0000, 'ºC'),
	(45403, 111, '2015-02-01 00:36:08.000000', 'temperatura', 811.0000, 'ºC'),
	(45404, 111, '2015-02-01 00:36:09.000000', 'temperatura', 69.0000, 'ºC'),
	(45405, 111, '2015-02-01 00:36:10.000000', 'temperatura', 316.0000, 'ºC'),
	(45406, 111, '2015-02-01 00:36:11.000000', 'temperatura', 170.0000, 'ºC'),
	(45407, 111, '2015-02-01 00:36:12.000000', 'temperatura', 1106.0000, 'ºC'),
	(45408, 111, '2015-02-01 00:36:13.000000', 'temperatura', 218.0000, 'ºC'),
	(45409, 111, '2015-02-01 00:36:14.000000', 'temperatura', 173.0000, 'ºC'),
	(45410, 111, '2015-02-01 00:36:15.000000', 'temperatura', 211.0000, 'ºC'),
	(45411, 111, '2015-02-01 00:36:16.000000', 'temperatura', 537.0000, 'ºC'),
	(45412, 111, '2015-02-01 00:36:17.000000', 'temperatura', 854.0000, 'ºC'),
	(45413, 111, '2015-02-01 00:36:18.000000', 'temperatura', 259.0000, 'ºC'),
	(45414, 111, '2015-02-01 00:36:19.000000', 'temperatura', 1135.0000, 'ºC'),
	(45415, 111, '2015-02-01 00:36:20.000000', 'temperatura', 97.0000, 'ºC'),
	(45416, 111, '2015-02-01 00:36:21.000000', 'temperatura', 680.0000, 'ºC'),
	(45417, 111, '2015-02-01 00:36:22.000000', 'temperatura', 710.0000, 'ºC'),
	(45418, 111, '2015-02-01 00:36:23.000000', 'temperatura', 310.0000, 'ºC'),
	(45419, 111, '2015-02-01 00:36:24.000000', 'temperatura', 619.0000, 'ºC'),
	(45420, 111, '2015-02-01 00:36:25.000000', 'temperatura', 967.0000, 'ºC'),
	(45421, 111, '2015-02-01 00:36:26.000000', 'temperatura', 579.0000, 'ºC'),
	(45422, 111, '2015-02-01 00:36:27.000000', 'temperatura', 1192.0000, 'ºC'),
	(45423, 111, '2015-02-01 00:36:28.000000', 'temperatura', 625.0000, 'ºC'),
	(45424, 111, '2015-02-01 00:36:29.000000', 'temperatura', 748.0000, 'ºC'),
	(45425, 111, '2015-02-01 00:36:30.000000', 'temperatura', 668.0000, 'ºC'),
	(45426, 111, '2015-02-01 00:36:31.000000', 'temperatura', 1094.0000, 'ºC'),
	(45427, 111, '2015-02-01 00:36:32.000000', 'temperatura', 1066.0000, 'ºC'),
	(45428, 111, '2015-02-01 00:36:33.000000', 'temperatura', 851.0000, 'ºC'),
	(45429, 111, '2015-02-01 00:36:34.000000', 'temperatura', 1058.0000, 'ºC'),
	(45430, 111, '2015-02-01 00:36:35.000000', 'temperatura', 335.0000, 'ºC'),
	(45431, 111, '2015-02-01 00:36:36.000000', 'temperatura', 901.0000, 'ºC'),
	(45432, 111, '2015-02-01 00:36:37.000000', 'temperatura', 1101.0000, 'ºC'),
	(45433, 111, '2015-02-01 00:36:38.000000', 'temperatura', 404.0000, 'ºC'),
	(45434, 111, '2015-02-01 00:36:39.000000', 'temperatura', 1117.0000, 'ºC'),
	(45435, 111, '2015-02-01 00:36:40.000000', 'temperatura', 774.0000, 'ºC'),
	(45436, 111, '2015-02-01 00:36:41.000000', 'temperatura', 518.0000, 'ºC'),
	(45437, 111, '2015-02-01 00:36:42.000000', 'temperatura', 271.0000, 'ºC'),
	(45438, 111, '2015-02-01 00:36:43.000000', 'temperatura', 999.0000, 'ºC'),
	(45439, 111, '2015-02-01 00:36:44.000000', 'temperatura', 584.0000, 'ºC'),
	(45440, 111, '2015-02-01 00:36:45.000000', 'temperatura', 1125.0000, 'ºC'),
	(45441, 111, '2015-02-01 00:36:46.000000', 'temperatura', 273.0000, 'ºC'),
	(45442, 111, '2015-02-01 00:36:47.000000', 'temperatura', 389.0000, 'ºC'),
	(45443, 111, '2015-02-01 00:36:48.000000', 'temperatura', 1129.0000, 'ºC'),
	(45444, 111, '2015-02-01 00:36:49.000000', 'temperatura', 876.0000, 'ºC'),
	(45445, 111, '2015-02-01 00:36:50.000000', 'temperatura', 996.0000, 'ºC'),
	(45446, 111, '2015-02-01 00:36:51.000000', 'temperatura', 1150.0000, 'ºC'),
	(45447, 111, '2015-02-01 00:36:52.000000', 'temperatura', 363.0000, 'ºC'),
	(45448, 111, '2015-02-01 00:36:53.000000', 'temperatura', 765.0000, 'ºC'),
	(45449, 111, '2015-02-01 00:36:54.000000', 'temperatura', 336.0000, 'ºC'),
	(45450, 111, '2015-02-01 00:36:55.000000', 'temperatura', 587.0000, 'ºC'),
	(45451, 111, '2015-02-01 00:36:56.000000', 'temperatura', 727.0000, 'ºC'),
	(45452, 111, '2015-02-01 00:36:57.000000', 'temperatura', 676.0000, 'ºC'),
	(45453, 111, '2015-02-01 00:36:58.000000', 'temperatura', 1197.0000, 'ºC'),
	(45454, 111, '2015-02-01 00:36:59.000000', 'temperatura', 358.0000, 'ºC'),
	(45455, 111, '2015-02-01 00:37:00.000000', 'temperatura', 598.0000, 'ºC'),
	(45456, 111, '2015-02-01 00:37:01.000000', 'temperatura', 718.0000, 'ºC'),
	(45457, 111, '2015-02-01 00:37:02.000000', 'temperatura', 596.0000, 'ºC'),
	(45458, 111, '2015-02-01 00:37:03.000000', 'temperatura', 827.0000, 'ºC'),
	(45459, 111, '2015-02-01 00:37:04.000000', 'temperatura', 1148.0000, 'ºC'),
	(45460, 111, '2015-02-01 00:37:05.000000', 'temperatura', 859.0000, 'ºC'),
	(45461, 111, '2015-02-01 00:37:06.000000', 'temperatura', 852.0000, 'ºC'),
	(45462, 111, '2015-02-01 00:37:07.000000', 'temperatura', 485.0000, 'ºC'),
	(45463, 111, '2015-02-01 00:37:08.000000', 'temperatura', 1069.0000, 'ºC'),
	(45464, 111, '2015-02-01 00:37:09.000000', 'temperatura', 291.0000, 'ºC'),
	(45465, 111, '2015-02-01 00:37:10.000000', 'temperatura', 646.0000, 'ºC'),
	(45466, 111, '2015-02-01 00:37:11.000000', 'temperatura', 1159.0000, 'ºC'),
	(45467, 111, '2015-02-01 00:37:12.000000', 'temperatura', 258.0000, 'ºC'),
	(45468, 111, '2015-02-01 00:37:13.000000', 'temperatura', 212.0000, 'ºC'),
	(45469, 111, '2015-02-01 00:37:14.000000', 'temperatura', 289.0000, 'ºC'),
	(45470, 111, '2015-02-01 00:37:15.000000', 'temperatura', 809.0000, 'ºC'),
	(45471, 111, '2015-02-01 00:37:16.000000', 'temperatura', 777.0000, 'ºC'),
	(45472, 111, '2015-02-01 00:37:17.000000', 'temperatura', 257.0000, 'ºC'),
	(45473, 111, '2015-02-01 00:37:18.000000', 'temperatura', 156.0000, 'ºC'),
	(45474, 111, '2015-02-01 00:37:19.000000', 'temperatura', 10.0000, 'ºC'),
	(45475, 111, '2015-02-01 00:37:20.000000', 'temperatura', 784.0000, 'ºC'),
	(45476, 111, '2015-02-01 00:37:21.000000', 'temperatura', 289.0000, 'ºC'),
	(45477, 111, '2015-02-01 00:37:22.000000', 'temperatura', 295.0000, 'ºC'),
	(45478, 111, '2015-02-01 00:37:23.000000', 'temperatura', 607.0000, 'ºC'),
	(45479, 111, '2015-02-01 00:37:24.000000', 'temperatura', 950.0000, 'ºC'),
	(45480, 111, '2015-02-01 00:37:25.000000', 'temperatura', 530.0000, 'ºC'),
	(45481, 111, '2015-02-01 00:37:26.000000', 'temperatura', 1002.0000, 'ºC'),
	(45482, 111, '2015-02-01 00:37:27.000000', 'temperatura', 1021.0000, 'ºC'),
	(45483, 111, '2015-02-01 00:37:28.000000', 'temperatura', 899.0000, 'ºC'),
	(45484, 111, '2015-02-01 00:37:29.000000', 'temperatura', 232.0000, 'ºC'),
	(45485, 111, '2015-02-01 00:37:30.000000', 'temperatura', 862.0000, 'ºC'),
	(45486, 111, '2015-02-01 00:37:31.000000', 'temperatura', 15.0000, 'ºC'),
	(45487, 111, '2015-02-01 00:37:32.000000', 'temperatura', 1091.0000, 'ºC'),
	(45488, 111, '2015-02-01 00:37:33.000000', 'temperatura', 612.0000, 'ºC'),
	(45489, 111, '2015-02-01 00:37:34.000000', 'temperatura', 985.0000, 'ºC'),
	(45490, 111, '2015-02-01 00:37:35.000000', 'temperatura', 690.0000, 'ºC'),
	(45491, 111, '2015-02-01 00:37:36.000000', 'temperatura', 495.0000, 'ºC'),
	(45492, 111, '2015-02-01 00:37:37.000000', 'temperatura', 406.0000, 'ºC'),
	(45493, 111, '2015-02-01 00:37:38.000000', 'temperatura', 547.0000, 'ºC'),
	(45494, 111, '2015-02-01 00:37:39.000000', 'temperatura', 318.0000, 'ºC'),
	(45495, 111, '2015-02-01 00:37:40.000000', 'temperatura', 1148.0000, 'ºC'),
	(45496, 111, '2015-02-01 00:37:41.000000', 'temperatura', 1186.0000, 'ºC'),
	(45497, 111, '2015-02-01 00:37:42.000000', 'temperatura', 88.0000, 'ºC'),
	(45498, 111, '2015-02-01 00:37:43.000000', 'temperatura', 482.0000, 'ºC'),
	(45499, 111, '2015-02-01 00:37:44.000000', 'temperatura', 946.0000, 'ºC'),
	(45500, 111, '2015-02-01 00:37:45.000000', 'temperatura', 887.0000, 'ºC'),
	(45501, 111, '2015-02-01 00:37:46.000000', 'temperatura', 395.0000, 'ºC'),
	(45502, 111, '2015-02-01 00:37:47.000000', 'temperatura', 516.0000, 'ºC'),
	(45503, 111, '2015-02-01 00:37:48.000000', 'temperatura', 194.0000, 'ºC'),
	(45504, 111, '2015-02-01 00:37:49.000000', 'temperatura', 623.0000, 'ºC'),
	(45505, 111, '2015-02-01 00:37:50.000000', 'temperatura', 136.0000, 'ºC'),
	(45506, 111, '2015-02-01 00:37:51.000000', 'temperatura', 8.0000, 'ºC'),
	(45507, 111, '2015-02-01 00:37:52.000000', 'temperatura', 834.0000, 'ºC'),
	(45508, 111, '2015-02-01 00:37:53.000000', 'temperatura', 547.0000, 'ºC'),
	(45509, 111, '2015-02-01 00:37:54.000000', 'temperatura', 233.0000, 'ºC'),
	(45510, 111, '2015-02-01 00:37:55.000000', 'temperatura', 725.0000, 'ºC'),
	(45511, 111, '2015-02-01 00:37:56.000000', 'temperatura', 525.0000, 'ºC'),
	(45512, 111, '2015-02-01 00:37:57.000000', 'temperatura', 451.0000, 'ºC'),
	(45513, 111, '2015-02-01 00:37:58.000000', 'temperatura', 679.0000, 'ºC'),
	(45514, 111, '2015-02-01 00:37:59.000000', 'temperatura', 846.0000, 'ºC'),
	(45515, 111, '2015-02-01 00:38:00.000000', 'temperatura', 990.0000, 'ºC'),
	(45516, 111, '2015-02-01 00:38:01.000000', 'temperatura', 14.0000, 'ºC'),
	(45517, 111, '2015-02-01 00:38:02.000000', 'temperatura', 700.0000, 'ºC'),
	(45518, 111, '2015-02-01 00:38:03.000000', 'temperatura', 1059.0000, 'ºC'),
	(45519, 111, '2015-02-01 00:38:04.000000', 'temperatura', 794.0000, 'ºC'),
	(45520, 111, '2015-02-01 00:38:05.000000', 'temperatura', 795.0000, 'ºC'),
	(45521, 111, '2015-02-01 00:38:06.000000', 'temperatura', 394.0000, 'ºC'),
	(45522, 111, '2015-02-01 00:38:07.000000', 'temperatura', 783.0000, 'ºC'),
	(45523, 111, '2015-02-01 00:38:08.000000', 'temperatura', 336.0000, 'ºC'),
	(45524, 111, '2015-02-01 00:38:09.000000', 'temperatura', 531.0000, 'ºC'),
	(45525, 111, '2015-02-01 00:38:10.000000', 'temperatura', 448.0000, 'ºC'),
	(45526, 111, '2015-02-01 00:38:11.000000', 'temperatura', 649.0000, 'ºC'),
	(45527, 111, '2015-02-01 00:38:12.000000', 'temperatura', 699.0000, 'ºC'),
	(45528, 111, '2015-02-01 00:38:13.000000', 'temperatura', 351.0000, 'ºC'),
	(45529, 111, '2015-02-01 00:38:14.000000', 'temperatura', 857.0000, 'ºC'),
	(45530, 111, '2015-02-01 00:38:15.000000', 'temperatura', 831.0000, 'ºC'),
	(45531, 111, '2015-02-01 00:38:16.000000', 'temperatura', 386.0000, 'ºC'),
	(45532, 111, '2015-02-01 00:38:17.000000', 'temperatura', 635.0000, 'ºC'),
	(45533, 111, '2015-02-01 00:38:18.000000', 'temperatura', 820.0000, 'ºC'),
	(45534, 111, '2015-02-01 00:38:19.000000', 'temperatura', 994.0000, 'ºC'),
	(45535, 111, '2015-02-01 00:38:20.000000', 'temperatura', 110.0000, 'ºC'),
	(45536, 111, '2015-02-01 00:38:21.000000', 'temperatura', 1168.0000, 'ºC'),
	(45537, 111, '2015-02-01 00:38:22.000000', 'temperatura', 710.0000, 'ºC'),
	(45538, 111, '2015-02-01 00:38:23.000000', 'temperatura', 47.0000, 'ºC'),
	(45539, 111, '2015-02-01 00:38:24.000000', 'temperatura', 506.0000, 'ºC'),
	(45540, 111, '2015-02-01 00:38:25.000000', 'temperatura', 1188.0000, 'ºC'),
	(45541, 111, '2015-02-01 00:38:26.000000', 'temperatura', 823.0000, 'ºC'),
	(45542, 111, '2015-02-01 00:38:27.000000', 'temperatura', 551.0000, 'ºC'),
	(45543, 111, '2015-02-01 00:38:28.000000', 'temperatura', 286.0000, 'ºC'),
	(45544, 111, '2015-02-01 00:38:29.000000', 'temperatura', 977.0000, 'ºC'),
	(45545, 111, '2015-02-01 00:38:30.000000', 'temperatura', 426.0000, 'ºC'),
	(45546, 111, '2015-02-01 00:38:31.000000', 'temperatura', 403.0000, 'ºC'),
	(45547, 111, '2015-02-01 00:38:32.000000', 'temperatura', 737.0000, 'ºC'),
	(45548, 111, '2015-02-01 00:38:33.000000', 'temperatura', 74.0000, 'ºC'),
	(45549, 111, '2015-02-01 00:38:34.000000', 'temperatura', 561.0000, 'ºC'),
	(45550, 111, '2015-02-01 00:38:35.000000', 'temperatura', 185.0000, 'ºC'),
	(45551, 111, '2015-02-01 00:38:36.000000', 'temperatura', 443.0000, 'ºC'),
	(45552, 111, '2015-02-01 00:38:37.000000', 'temperatura', 457.0000, 'ºC'),
	(45553, 111, '2015-02-01 00:38:38.000000', 'temperatura', 960.0000, 'ºC'),
	(45554, 111, '2015-02-01 00:38:39.000000', 'temperatura', 1029.0000, 'ºC'),
	(45555, 111, '2015-02-01 00:38:40.000000', 'temperatura', 1067.0000, 'ºC'),
	(45556, 111, '2015-02-01 00:38:41.000000', 'temperatura', 1045.0000, 'ºC'),
	(45557, 111, '2015-02-01 00:38:42.000000', 'temperatura', 827.0000, 'ºC'),
	(45558, 111, '2015-02-01 00:38:43.000000', 'temperatura', 1000.0000, 'ºC'),
	(45559, 111, '2015-02-01 00:38:44.000000', 'temperatura', 119.0000, 'ºC'),
	(45560, 111, '2015-02-01 00:38:45.000000', 'temperatura', 1195.0000, 'ºC'),
	(45561, 111, '2015-02-01 00:38:46.000000', 'temperatura', 817.0000, 'ºC'),
	(45562, 111, '2015-02-01 00:38:47.000000', 'temperatura', 502.0000, 'ºC'),
	(45563, 111, '2015-02-01 00:38:48.000000', 'temperatura', 60.0000, 'ºC'),
	(45564, 111, '2015-02-01 00:38:49.000000', 'temperatura', 1195.0000, 'ºC'),
	(45565, 111, '2015-02-01 00:38:50.000000', 'temperatura', 995.0000, 'ºC'),
	(45566, 111, '2015-02-01 00:38:51.000000', 'temperatura', 190.0000, 'ºC'),
	(45567, 111, '2015-02-01 00:38:52.000000', 'temperatura', 366.0000, 'ºC'),
	(45568, 111, '2015-02-01 00:38:53.000000', 'temperatura', 61.0000, 'ºC'),
	(45569, 111, '2015-02-01 00:38:54.000000', 'temperatura', 405.0000, 'ºC'),
	(45570, 111, '2015-02-01 00:38:55.000000', 'temperatura', 646.0000, 'ºC'),
	(45571, 111, '2015-02-01 00:38:56.000000', 'temperatura', 812.0000, 'ºC'),
	(45572, 111, '2015-02-01 00:38:57.000000', 'temperatura', 926.0000, 'ºC'),
	(45573, 111, '2015-02-01 00:38:58.000000', 'temperatura', 991.0000, 'ºC'),
	(45574, 111, '2015-02-01 00:38:59.000000', 'temperatura', 980.0000, 'ºC'),
	(45575, 111, '2015-02-01 00:39:00.000000', 'temperatura', 727.0000, 'ºC'),
	(45576, 111, '2015-02-01 00:39:01.000000', 'temperatura', 697.0000, 'ºC'),
	(45577, 111, '2015-02-01 00:39:02.000000', 'temperatura', 105.0000, 'ºC'),
	(45578, 111, '2015-02-01 00:39:03.000000', 'temperatura', 832.0000, 'ºC'),
	(45579, 111, '2015-02-01 00:39:04.000000', 'temperatura', 246.0000, 'ºC'),
	(45580, 111, '2015-02-01 00:39:05.000000', 'temperatura', 1134.0000, 'ºC'),
	(45581, 111, '2015-02-01 00:39:06.000000', 'temperatura', 134.0000, 'ºC'),
	(45582, 111, '2015-02-01 00:39:07.000000', 'temperatura', 869.0000, 'ºC'),
	(45583, 111, '2015-02-01 00:39:08.000000', 'temperatura', 345.0000, 'ºC'),
	(45584, 111, '2015-02-01 00:39:09.000000', 'temperatura', 315.0000, 'ºC'),
	(45585, 111, '2015-02-01 00:39:10.000000', 'temperatura', 543.0000, 'ºC'),
	(45586, 111, '2015-02-01 00:39:11.000000', 'temperatura', 571.0000, 'ºC'),
	(45587, 111, '2015-02-01 00:39:12.000000', 'temperatura', 25.0000, 'ºC'),
	(45588, 111, '2015-02-01 00:39:13.000000', 'temperatura', 812.0000, 'ºC'),
	(45589, 111, '2015-02-01 00:39:14.000000', 'temperatura', 388.0000, 'ºC'),
	(45590, 111, '2015-02-01 00:39:15.000000', 'temperatura', 702.0000, 'ºC'),
	(45591, 111, '2015-02-01 00:39:16.000000', 'temperatura', 1147.0000, 'ºC'),
	(45592, 111, '2015-02-01 00:39:17.000000', 'temperatura', 32.0000, 'ºC'),
	(45593, 111, '2015-02-01 00:39:18.000000', 'temperatura', 317.0000, 'ºC'),
	(45594, 111, '2015-02-01 00:39:19.000000', 'temperatura', 289.0000, 'ºC'),
	(45595, 111, '2015-02-01 00:39:20.000000', 'temperatura', 495.0000, 'ºC'),
	(45596, 111, '2015-02-01 00:39:21.000000', 'temperatura', 407.0000, 'ºC'),
	(45597, 111, '2015-02-01 00:39:22.000000', 'temperatura', 553.0000, 'ºC'),
	(45598, 111, '2015-02-01 00:39:23.000000', 'temperatura', 344.0000, 'ºC'),
	(45599, 111, '2015-02-01 00:39:24.000000', 'temperatura', 62.0000, 'ºC'),
	(45600, 111, '2015-02-01 00:39:25.000000', 'temperatura', 477.0000, 'ºC'),
	(45601, 111, '2015-02-01 00:39:26.000000', 'temperatura', 1002.0000, 'ºC'),
	(45602, 111, '2015-02-01 00:39:27.000000', 'temperatura', 1179.0000, 'ºC'),
	(45603, 111, '2015-02-01 00:39:28.000000', 'temperatura', 488.0000, 'ºC'),
	(45604, 111, '2015-02-01 00:39:29.000000', 'temperatura', 106.0000, 'ºC'),
	(45605, 111, '2015-02-01 00:39:30.000000', 'temperatura', 264.0000, 'ºC'),
	(45606, 111, '2015-02-01 00:39:31.000000', 'temperatura', 1005.0000, 'ºC'),
	(45607, 111, '2015-02-01 00:39:32.000000', 'temperatura', 633.0000, 'ºC'),
	(45608, 111, '2015-02-01 00:39:33.000000', 'temperatura', 152.0000, 'ºC'),
	(45609, 111, '2015-02-01 00:39:34.000000', 'temperatura', 60.0000, 'ºC'),
	(45610, 111, '2015-02-01 00:39:35.000000', 'temperatura', 1044.0000, 'ºC'),
	(45611, 111, '2015-02-01 00:39:36.000000', 'temperatura', 240.0000, 'ºC'),
	(45612, 111, '2015-02-01 00:39:37.000000', 'temperatura', 467.0000, 'ºC'),
	(45613, 111, '2015-02-01 00:39:38.000000', 'temperatura', 419.0000, 'ºC'),
	(45614, 111, '2015-02-01 00:39:39.000000', 'temperatura', 692.0000, 'ºC'),
	(45615, 111, '2015-02-01 00:39:40.000000', 'temperatura', 1003.0000, 'ºC'),
	(45616, 111, '2015-02-01 00:39:41.000000', 'temperatura', 539.0000, 'ºC'),
	(45617, 111, '2015-02-01 00:39:42.000000', 'temperatura', 885.0000, 'ºC'),
	(45618, 111, '2015-02-01 00:39:43.000000', 'temperatura', 412.0000, 'ºC'),
	(45619, 111, '2015-02-01 00:39:44.000000', 'temperatura', 605.0000, 'ºC'),
	(45620, 111, '2015-02-01 00:39:45.000000', 'temperatura', 590.0000, 'ºC'),
	(45621, 111, '2015-02-01 00:39:46.000000', 'temperatura', 1133.0000, 'ºC'),
	(45622, 111, '2015-02-01 00:39:47.000000', 'temperatura', 296.0000, 'ºC'),
	(45623, 111, '2015-02-01 00:39:48.000000', 'temperatura', 481.0000, 'ºC'),
	(45624, 111, '2015-02-01 00:39:49.000000', 'temperatura', 318.0000, 'ºC'),
	(45625, 111, '2015-02-01 00:39:50.000000', 'temperatura', 147.0000, 'ºC'),
	(45626, 111, '2015-02-01 00:39:51.000000', 'temperatura', 982.0000, 'ºC'),
	(45627, 111, '2015-02-01 00:39:52.000000', 'temperatura', 871.0000, 'ºC'),
	(45628, 111, '2015-02-01 00:39:53.000000', 'temperatura', 209.0000, 'ºC'),
	(45629, 111, '2015-02-01 00:39:54.000000', 'temperatura', 832.0000, 'ºC'),
	(45630, 111, '2015-02-01 00:39:55.000000', 'temperatura', 1132.0000, 'ºC'),
	(45631, 111, '2015-02-01 00:39:56.000000', 'temperatura', 764.0000, 'ºC'),
	(45632, 111, '2015-02-01 00:39:57.000000', 'temperatura', 425.0000, 'ºC'),
	(45633, 111, '2015-02-01 00:39:58.000000', 'temperatura', 1032.0000, 'ºC'),
	(45634, 111, '2015-02-01 00:39:59.000000', 'temperatura', 286.0000, 'ºC'),
	(45635, 111, '2015-02-01 00:40:00.000000', 'temperatura', 736.0000, 'ºC'),
	(45636, 111, '2015-02-01 00:40:01.000000', 'temperatura', 422.0000, 'ºC'),
	(45637, 111, '2015-02-01 00:40:02.000000', 'temperatura', 1101.0000, 'ºC'),
	(45638, 111, '2015-02-01 00:40:03.000000', 'temperatura', 642.0000, 'ºC'),
	(45639, 111, '2015-02-01 00:40:04.000000', 'temperatura', 1108.0000, 'ºC'),
	(45640, 111, '2015-02-01 00:40:05.000000', 'temperatura', 14.0000, 'ºC'),
	(45641, 111, '2015-02-01 00:40:06.000000', 'temperatura', 347.0000, 'ºC'),
	(45642, 111, '2015-02-01 00:40:07.000000', 'temperatura', 492.0000, 'ºC'),
	(45643, 111, '2015-02-01 00:40:08.000000', 'temperatura', 218.0000, 'ºC'),
	(45644, 111, '2015-02-01 00:40:09.000000', 'temperatura', 818.0000, 'ºC'),
	(45645, 111, '2015-02-01 00:40:10.000000', 'temperatura', 1034.0000, 'ºC'),
	(45646, 111, '2015-02-01 00:40:11.000000', 'temperatura', 319.0000, 'ºC'),
	(45647, 111, '2015-02-01 00:40:12.000000', 'temperatura', 890.0000, 'ºC'),
	(45648, 111, '2015-02-01 00:40:13.000000', 'temperatura', 1096.0000, 'ºC'),
	(45649, 111, '2015-02-01 00:40:14.000000', 'temperatura', 409.0000, 'ºC'),
	(45650, 111, '2015-02-01 00:40:15.000000', 'temperatura', 1156.0000, 'ºC'),
	(45651, 111, '2015-02-01 00:40:16.000000', 'temperatura', 955.0000, 'ºC'),
	(45652, 111, '2015-02-01 00:40:17.000000', 'temperatura', 107.0000, 'ºC'),
	(45653, 111, '2015-02-01 00:40:18.000000', 'temperatura', 70.0000, 'ºC'),
	(45654, 111, '2015-02-01 00:40:19.000000', 'temperatura', 29.0000, 'ºC'),
	(45655, 111, '2015-02-01 00:40:20.000000', 'temperatura', 1137.0000, 'ºC'),
	(45656, 111, '2015-02-01 00:40:21.000000', 'temperatura', 797.0000, 'ºC'),
	(45657, 111, '2015-02-01 00:40:22.000000', 'temperatura', 575.0000, 'ºC'),
	(45658, 111, '2015-02-01 00:40:23.000000', 'temperatura', 483.0000, 'ºC'),
	(45659, 111, '2015-02-01 00:40:24.000000', 'temperatura', 693.0000, 'ºC'),
	(45660, 111, '2015-02-01 00:40:25.000000', 'temperatura', 816.0000, 'ºC'),
	(45661, 111, '2015-02-01 00:40:26.000000', 'temperatura', 801.0000, 'ºC'),
	(45662, 111, '2015-02-01 00:40:27.000000', 'temperatura', 357.0000, 'ºC'),
	(45663, 111, '2015-02-01 00:40:28.000000', 'temperatura', 581.0000, 'ºC'),
	(45664, 111, '2015-02-01 00:40:29.000000', 'temperatura', 636.0000, 'ºC'),
	(45665, 111, '2015-02-01 00:40:30.000000', 'temperatura', 236.0000, 'ºC'),
	(45666, 111, '2015-02-01 00:40:31.000000', 'temperatura', 475.0000, 'ºC'),
	(45667, 111, '2015-02-01 00:40:32.000000', 'temperatura', 466.0000, 'ºC'),
	(45668, 111, '2015-02-01 00:40:33.000000', 'temperatura', 906.0000, 'ºC'),
	(45669, 111, '2015-02-01 00:40:34.000000', 'temperatura', 732.0000, 'ºC'),
	(45670, 111, '2015-02-01 00:40:35.000000', 'temperatura', 942.0000, 'ºC'),
	(45671, 111, '2015-02-01 00:40:36.000000', 'temperatura', 114.0000, 'ºC'),
	(45672, 111, '2015-02-01 00:40:37.000000', 'temperatura', 147.0000, 'ºC'),
	(45673, 111, '2015-02-01 00:40:38.000000', 'temperatura', 391.0000, 'ºC'),
	(45674, 111, '2015-02-01 00:40:39.000000', 'temperatura', 315.0000, 'ºC'),
	(45675, 111, '2015-02-01 00:40:40.000000', 'temperatura', 402.0000, 'ºC'),
	(45676, 111, '2015-02-01 00:40:41.000000', 'temperatura', 1067.0000, 'ºC'),
	(45677, 111, '2015-02-01 00:40:42.000000', 'temperatura', 531.0000, 'ºC'),
	(45678, 111, '2015-02-01 00:40:43.000000', 'temperatura', 652.0000, 'ºC'),
	(45679, 111, '2015-02-01 00:40:44.000000', 'temperatura', 467.0000, 'ºC'),
	(45680, 111, '2015-02-01 00:40:45.000000', 'temperatura', 379.0000, 'ºC'),
	(45681, 111, '2015-02-01 00:40:46.000000', 'temperatura', 496.0000, 'ºC'),
	(45682, 111, '2015-02-01 00:40:47.000000', 'temperatura', 144.0000, 'ºC'),
	(45683, 111, '2015-02-01 00:40:48.000000', 'temperatura', 432.0000, 'ºC'),
	(45684, 111, '2015-02-01 00:40:49.000000', 'temperatura', 527.0000, 'ºC'),
	(45685, 111, '2015-02-01 00:40:50.000000', 'temperatura', 141.0000, 'ºC'),
	(45686, 111, '2015-02-01 00:40:51.000000', 'temperatura', 322.0000, 'ºC'),
	(45687, 111, '2015-02-01 00:40:52.000000', 'temperatura', 1189.0000, 'ºC'),
	(45688, 111, '2015-02-01 00:40:53.000000', 'temperatura', 179.0000, 'ºC'),
	(45689, 111, '2015-02-01 00:40:54.000000', 'temperatura', 931.0000, 'ºC'),
	(45690, 111, '2015-02-01 00:40:55.000000', 'temperatura', 516.0000, 'ºC'),
	(45691, 111, '2015-02-01 00:40:56.000000', 'temperatura', 990.0000, 'ºC'),
	(45692, 111, '2015-02-01 00:40:57.000000', 'temperatura', 1000.0000, 'ºC'),
	(45693, 111, '2015-02-01 00:40:58.000000', 'temperatura', 832.0000, 'ºC'),
	(45694, 111, '2015-02-01 00:40:59.000000', 'temperatura', 1158.0000, 'ºC'),
	(45695, 111, '2015-02-01 00:41:00.000000', 'temperatura', 898.0000, 'ºC'),
	(45696, 111, '2015-02-01 00:41:01.000000', 'temperatura', 1014.0000, 'ºC'),
	(45697, 111, '2015-02-01 00:41:02.000000', 'temperatura', 1176.0000, 'ºC'),
	(45698, 111, '2015-02-01 00:41:03.000000', 'temperatura', 441.0000, 'ºC'),
	(45699, 111, '2015-02-01 00:41:04.000000', 'temperatura', 1078.0000, 'ºC'),
	(45700, 111, '2015-02-01 00:41:05.000000', 'temperatura', 466.0000, 'ºC'),
	(45701, 111, '2015-02-01 00:41:06.000000', 'temperatura', 299.0000, 'ºC'),
	(45702, 111, '2015-02-01 00:41:07.000000', 'temperatura', 94.0000, 'ºC'),
	(45703, 111, '2015-02-01 00:41:08.000000', 'temperatura', 774.0000, 'ºC'),
	(45704, 111, '2015-02-01 00:41:09.000000', 'temperatura', 1191.0000, 'ºC'),
	(45705, 111, '2015-02-01 00:41:10.000000', 'temperatura', 33.0000, 'ºC'),
	(45706, 111, '2015-02-01 00:41:11.000000', 'temperatura', 192.0000, 'ºC'),
	(45707, 111, '2015-02-01 00:41:12.000000', 'temperatura', 860.0000, 'ºC'),
	(45708, 111, '2015-02-01 00:41:13.000000', 'temperatura', 126.0000, 'ºC'),
	(45709, 111, '2015-02-01 00:41:14.000000', 'temperatura', 451.0000, 'ºC'),
	(45710, 111, '2015-02-01 00:41:15.000000', 'temperatura', 676.0000, 'ºC'),
	(45711, 111, '2015-02-01 00:41:16.000000', 'temperatura', 826.0000, 'ºC'),
	(45712, 111, '2015-02-01 00:41:17.000000', 'temperatura', 904.0000, 'ºC'),
	(45713, 111, '2015-02-01 00:41:18.000000', 'temperatura', 844.0000, 'ºC'),
	(45714, 111, '2015-02-01 00:41:19.000000', 'temperatura', 307.0000, 'ºC'),
	(45715, 111, '2015-02-01 00:41:20.000000', 'temperatura', 205.0000, 'ºC'),
	(45716, 111, '2015-02-01 00:41:21.000000', 'temperatura', 106.0000, 'ºC'),
	(45717, 111, '2015-02-01 00:41:22.000000', 'temperatura', 1113.0000, 'ºC'),
	(45718, 111, '2015-02-01 00:41:23.000000', 'temperatura', 448.0000, 'ºC'),
	(45719, 111, '2015-02-01 00:41:24.000000', 'temperatura', 102.0000, 'ºC'),
	(45720, 111, '2015-02-01 00:41:25.000000', 'temperatura', 365.0000, 'ºC'),
	(45721, 111, '2015-02-01 00:41:26.000000', 'temperatura', 320.0000, 'ºC'),
	(45722, 111, '2015-02-01 00:41:27.000000', 'temperatura', 506.0000, 'ºC'),
	(45723, 111, '2015-02-01 00:41:28.000000', 'temperatura', 372.0000, 'ºC'),
	(45724, 111, '2015-02-01 00:41:29.000000', 'temperatura', 339.0000, 'ºC'),
	(45725, 111, '2015-02-01 00:41:30.000000', 'temperatura', 582.0000, 'ºC'),
	(45726, 111, '2015-02-01 00:41:31.000000', 'temperatura', 692.0000, 'ºC'),
	(45727, 111, '2015-02-01 00:41:32.000000', 'temperatura', 517.0000, 'ºC'),
	(45728, 111, '2015-02-01 00:41:33.000000', 'temperatura', 508.0000, 'ºC'),
	(45729, 111, '2015-02-01 00:41:34.000000', 'temperatura', 988.0000, 'ºC'),
	(45730, 111, '2015-02-01 00:41:35.000000', 'temperatura', 1016.0000, 'ºC'),
	(45731, 111, '2015-02-01 00:41:36.000000', 'temperatura', 917.0000, 'ºC'),
	(45732, 111, '2015-02-01 00:41:37.000000', 'temperatura', 337.0000, 'ºC'),
	(45733, 111, '2015-02-01 00:41:38.000000', 'temperatura', 137.0000, 'ºC'),
	(45734, 111, '2015-02-01 00:41:39.000000', 'temperatura', 873.0000, 'ºC'),
	(45735, 111, '2015-02-01 00:41:40.000000', 'temperatura', 354.0000, 'ºC'),
	(45736, 111, '2015-02-01 00:41:41.000000', 'temperatura', 352.0000, 'ºC'),
	(45737, 111, '2015-02-01 00:41:42.000000', 'temperatura', 697.0000, 'ºC'),
	(45738, 111, '2015-02-01 00:41:43.000000', 'temperatura', 29.0000, 'ºC'),
	(45739, 111, '2015-02-01 00:41:44.000000', 'temperatura', 455.0000, 'ºC'),
	(45740, 111, '2015-02-01 00:41:45.000000', 'temperatura', 990.0000, 'ºC'),
	(45741, 111, '2015-02-01 00:41:46.000000', 'temperatura', 1186.0000, 'ºC'),
	(45742, 111, '2015-02-01 00:41:47.000000', 'temperatura', 562.0000, 'ºC'),
	(45743, 111, '2015-02-01 00:41:48.000000', 'temperatura', 449.0000, 'ºC'),
	(45744, 111, '2015-02-01 00:41:49.000000', 'temperatura', 562.0000, 'ºC'),
	(45745, 111, '2015-02-01 00:41:50.000000', 'temperatura', 264.0000, 'ºC'),
	(45746, 111, '2015-02-01 00:41:51.000000', 'temperatura', 833.0000, 'ºC'),
	(45747, 111, '2015-02-01 00:41:52.000000', 'temperatura', 973.0000, 'ºC'),
	(45748, 111, '2015-02-01 00:41:53.000000', 'temperatura', 1166.0000, 'ºC'),
	(45749, 111, '2015-02-01 00:41:54.000000', 'temperatura', 512.0000, 'ºC'),
	(45750, 111, '2015-02-01 00:41:55.000000', 'temperatura', 262.0000, 'ºC'),
	(45751, 111, '2015-02-01 00:41:56.000000', 'temperatura', 977.0000, 'ºC'),
	(45752, 111, '2015-02-01 00:41:57.000000', 'temperatura', 498.0000, 'ºC'),
	(45753, 111, '2015-02-01 00:41:58.000000', 'temperatura', 759.0000, 'ºC'),
	(45754, 111, '2015-02-01 00:41:59.000000', 'temperatura', 1101.0000, 'ºC'),
	(45755, 111, '2015-02-01 00:42:00.000000', 'temperatura', 828.0000, 'ºC'),
	(45756, 111, '2015-02-01 00:42:01.000000', 'temperatura', 837.0000, 'ºC'),
	(45757, 111, '2015-02-01 00:42:02.000000', 'temperatura', 501.0000, 'ºC'),
	(45758, 111, '2015-02-01 00:42:03.000000', 'temperatura', 1196.0000, 'ºC'),
	(45759, 111, '2015-02-01 00:42:04.000000', 'temperatura', 877.0000, 'ºC'),
	(45760, 111, '2015-02-01 00:42:05.000000', 'temperatura', 797.0000, 'ºC'),
	(45761, 111, '2015-02-01 00:42:06.000000', 'temperatura', 155.0000, 'ºC'),
	(45762, 111, '2015-02-01 00:42:07.000000', 'temperatura', 785.0000, 'ºC'),
	(45763, 111, '2015-02-01 00:42:08.000000', 'temperatura', 1062.0000, 'ºC'),
	(45764, 111, '2015-02-01 00:42:09.000000', 'temperatura', 553.0000, 'ºC'),
	(45765, 111, '2015-02-01 00:42:10.000000', 'temperatura', 781.0000, 'ºC'),
	(45766, 111, '2015-02-01 00:42:11.000000', 'temperatura', 1045.0000, 'ºC'),
	(45767, 111, '2015-02-01 00:42:12.000000', 'temperatura', 483.0000, 'ºC'),
	(45768, 111, '2015-02-01 00:42:13.000000', 'temperatura', 479.0000, 'ºC'),
	(45769, 111, '2015-02-01 00:42:14.000000', 'temperatura', 948.0000, 'ºC'),
	(45770, 111, '2015-02-01 00:42:15.000000', 'temperatura', 904.0000, 'ºC'),
	(45771, 111, '2015-02-01 00:42:16.000000', 'temperatura', 476.0000, 'ºC'),
	(45772, 111, '2015-02-01 00:42:17.000000', 'temperatura', 869.0000, 'ºC'),
	(45773, 111, '2015-02-01 00:42:18.000000', 'temperatura', 519.0000, 'ºC'),
	(45774, 111, '2015-02-01 00:42:19.000000', 'temperatura', 1188.0000, 'ºC'),
	(45775, 111, '2015-02-01 00:42:20.000000', 'temperatura', 783.0000, 'ºC'),
	(45776, 111, '2015-02-01 00:42:21.000000', 'temperatura', 350.0000, 'ºC'),
	(45777, 111, '2015-02-01 00:42:22.000000', 'temperatura', 603.0000, 'ºC'),
	(45778, 111, '2015-02-01 00:42:23.000000', 'temperatura', 763.0000, 'ºC'),
	(45779, 111, '2015-02-01 00:42:24.000000', 'temperatura', 809.0000, 'ºC'),
	(45780, 111, '2015-02-01 00:42:25.000000', 'temperatura', 555.0000, 'ºC'),
	(45781, 111, '2015-02-01 00:42:26.000000', 'temperatura', 350.0000, 'ºC'),
	(45782, 111, '2015-02-01 00:42:27.000000', 'temperatura', 83.0000, 'ºC'),
	(45783, 111, '2015-02-01 00:42:28.000000', 'temperatura', 566.0000, 'ºC'),
	(45784, 111, '2015-02-01 00:42:29.000000', 'temperatura', 184.0000, 'ºC'),
	(45785, 111, '2015-02-01 00:42:30.000000', 'temperatura', 422.0000, 'ºC'),
	(45786, 111, '2015-02-01 00:42:31.000000', 'temperatura', 357.0000, 'ºC'),
	(45787, 111, '2015-02-01 00:42:32.000000', 'temperatura', 519.0000, 'ºC'),
	(45788, 111, '2015-02-01 00:42:33.000000', 'temperatura', 326.0000, 'ºC'),
	(45789, 111, '2015-02-01 00:42:34.000000', 'temperatura', 75.0000, 'ºC'),
	(45790, 111, '2015-02-01 00:42:35.000000', 'temperatura', 594.0000, 'ºC'),
	(45791, 111, '2015-02-01 00:42:36.000000', 'temperatura', 348.0000, 'ºC'),
	(45792, 111, '2015-02-01 00:42:37.000000', 'temperatura', 1159.0000, 'ºC'),
	(45793, 111, '2015-02-01 00:42:38.000000', 'temperatura', 1150.0000, 'ºC'),
	(45794, 111, '2015-02-01 00:42:39.000000', 'temperatura', 1074.0000, 'ºC'),
	(45795, 111, '2015-02-01 00:42:40.000000', 'temperatura', 721.0000, 'ºC'),
	(45796, 111, '2015-02-01 00:42:41.000000', 'temperatura', 381.0000, 'ºC'),
	(45797, 111, '2015-02-01 00:42:42.000000', 'temperatura', 946.0000, 'ºC'),
	(45798, 111, '2015-02-01 00:42:43.000000', 'temperatura', 1184.0000, 'ºC'),
	(45799, 111, '2015-02-01 00:42:44.000000', 'temperatura', 686.0000, 'ºC'),
	(45800, 111, '2015-02-01 00:42:45.000000', 'temperatura', 1076.0000, 'ºC'),
	(45801, 111, '2015-02-01 00:42:46.000000', 'temperatura', 921.0000, 'ºC'),
	(45802, 111, '2015-02-01 00:42:47.000000', 'temperatura', 180.0000, 'ºC'),
	(45803, 111, '2015-02-01 00:42:48.000000', 'temperatura', 535.0000, 'ºC'),
	(45804, 111, '2015-02-01 00:42:49.000000', 'temperatura', 936.0000, 'ºC'),
	(45805, 111, '2015-02-01 00:42:50.000000', 'temperatura', 678.0000, 'ºC'),
	(45806, 111, '2015-02-01 00:42:51.000000', 'temperatura', 580.0000, 'ºC'),
	(45807, 111, '2015-02-01 00:42:52.000000', 'temperatura', 866.0000, 'ºC'),
	(45808, 111, '2015-02-01 00:42:53.000000', 'temperatura', 190.0000, 'ºC'),
	(45809, 111, '2015-02-01 00:42:54.000000', 'temperatura', 755.0000, 'ºC'),
	(45810, 111, '2015-02-01 00:42:55.000000', 'temperatura', 806.0000, 'ºC'),
	(45811, 111, '2015-02-01 00:42:56.000000', 'temperatura', 566.0000, 'ºC'),
	(45812, 111, '2015-02-01 00:42:57.000000', 'temperatura', 412.0000, 'ºC'),
	(45813, 111, '2015-02-01 00:42:58.000000', 'temperatura', 363.0000, 'ºC'),
	(45814, 111, '2015-02-01 00:42:59.000000', 'temperatura', 578.0000, 'ºC'),
	(45815, 111, '2015-02-01 00:43:00.000000', 'temperatura', 602.0000, 'ºC'),
	(45816, 111, '2015-02-01 00:43:01.000000', 'temperatura', 76.0000, 'ºC'),
	(45817, 111, '2015-02-01 00:43:02.000000', 'temperatura', 974.0000, 'ºC'),
	(45818, 111, '2015-02-01 00:43:03.000000', 'temperatura', 1044.0000, 'ºC'),
	(45819, 111, '2015-02-01 00:43:04.000000', 'temperatura', 1099.0000, 'ºC'),
	(45820, 111, '2015-02-01 00:43:05.000000', 'temperatura', 1163.0000, 'ºC'),
	(45821, 111, '2015-02-01 00:43:06.000000', 'temperatura', 119.0000, 'ºC'),
	(45822, 111, '2015-02-01 00:43:07.000000', 'temperatura', 707.0000, 'ºC'),
	(45823, 111, '2015-02-01 00:43:08.000000', 'temperatura', 776.0000, 'ºC'),
	(45824, 111, '2015-02-01 00:43:09.000000', 'temperatura', 561.0000, 'ºC'),
	(45825, 111, '2015-02-01 00:43:10.000000', 'temperatura', 477.0000, 'ºC'),
	(45826, 111, '2015-02-01 00:43:11.000000', 'temperatura', 703.0000, 'ºC'),
	(45827, 111, '2015-02-01 00:43:12.000000', 'temperatura', 885.0000, 'ºC'),
	(45828, 111, '2015-02-01 00:43:13.000000', 'temperatura', 1117.0000, 'ºC'),
	(45829, 111, '2015-02-01 00:43:14.000000', 'temperatura', 529.0000, 'ºC'),
	(45830, 111, '2015-02-01 00:43:15.000000', 'temperatura', 497.0000, 'ºC'),
	(45831, 111, '2015-02-01 00:43:16.000000', 'temperatura', 897.0000, 'ºC'),
	(45832, 111, '2015-02-01 00:43:17.000000', 'temperatura', 594.0000, 'ºC'),
	(45833, 111, '2015-02-01 00:43:18.000000', 'temperatura', 280.0000, 'ºC'),
	(45834, 111, '2015-02-01 00:43:19.000000', 'temperatura', 819.0000, 'ºC'),
	(45835, 111, '2015-02-01 00:43:20.000000', 'temperatura', 856.0000, 'ºC'),
	(45836, 111, '2015-02-01 00:43:21.000000', 'temperatura', 623.0000, 'ºC'),
	(45837, 111, '2015-02-01 00:43:22.000000', 'temperatura', 548.0000, 'ºC'),
	(45838, 111, '2015-02-01 00:43:23.000000', 'temperatura', 872.0000, 'ºC'),
	(45839, 111, '2015-02-01 00:43:24.000000', 'temperatura', 314.0000, 'ºC'),
	(45840, 111, '2015-02-01 00:43:25.000000', 'temperatura', 158.0000, 'ºC'),
	(45841, 111, '2015-02-01 00:43:26.000000', 'temperatura', 1046.0000, 'ºC'),
	(45842, 111, '2015-02-01 00:43:27.000000', 'temperatura', 1158.0000, 'ºC'),
	(45843, 111, '2015-02-01 00:43:28.000000', 'temperatura', 252.0000, 'ºC'),
	(45844, 111, '2015-02-01 00:43:29.000000', 'temperatura', 185.0000, 'ºC'),
	(45845, 111, '2015-02-01 00:43:30.000000', 'temperatura', 170.0000, 'ºC'),
	(45846, 111, '2015-02-01 00:43:31.000000', 'temperatura', 297.0000, 'ºC'),
	(45847, 111, '2015-02-01 00:43:32.000000', 'temperatura', 976.0000, 'ºC'),
	(45848, 111, '2015-02-01 00:43:33.000000', 'temperatura', 391.0000, 'ºC'),
	(45849, 111, '2015-02-01 00:43:34.000000', 'temperatura', 225.0000, 'ºC'),
	(45850, 111, '2015-02-01 00:43:35.000000', 'temperatura', 1152.0000, 'ºC'),
	(45851, 111, '2015-02-01 00:43:36.000000', 'temperatura', 285.0000, 'ºC'),
	(45852, 111, '2015-02-01 00:43:37.000000', 'temperatura', 370.0000, 'ºC'),
	(45853, 111, '2015-02-01 00:43:38.000000', 'temperatura', 998.0000, 'ºC'),
	(45854, 111, '2015-02-01 00:43:39.000000', 'temperatura', 278.0000, 'ºC'),
	(45855, 111, '2015-02-01 00:43:40.000000', 'temperatura', 799.0000, 'ºC'),
	(45856, 111, '2015-02-01 00:43:41.000000', 'temperatura', 761.0000, 'ºC'),
	(45857, 111, '2015-02-01 00:43:42.000000', 'temperatura', 206.0000, 'ºC'),
	(45858, 111, '2015-02-01 00:43:43.000000', 'temperatura', 1150.0000, 'ºC'),
	(45859, 111, '2015-02-01 00:43:44.000000', 'temperatura', 332.0000, 'ºC'),
	(45860, 111, '2015-02-01 00:43:45.000000', 'temperatura', 610.0000, 'ºC'),
	(45861, 111, '2015-02-01 00:43:46.000000', 'temperatura', 853.0000, 'ºC'),
	(45862, 111, '2015-02-01 00:43:47.000000', 'temperatura', 35.0000, 'ºC'),
	(45863, 111, '2015-02-01 00:43:48.000000', 'temperatura', 17.0000, 'ºC'),
	(45864, 111, '2015-02-01 00:43:49.000000', 'temperatura', 1180.0000, 'ºC'),
	(45865, 111, '2015-02-01 00:43:50.000000', 'temperatura', 1052.0000, 'ºC'),
	(45866, 111, '2015-02-01 00:43:51.000000', 'temperatura', 518.0000, 'ºC'),
	(45867, 111, '2015-02-01 00:43:52.000000', 'temperatura', 635.0000, 'ºC'),
	(45868, 111, '2015-02-01 00:43:53.000000', 'temperatura', 422.0000, 'ºC'),
	(45869, 111, '2015-02-01 00:43:54.000000', 'temperatura', 207.0000, 'ºC'),
	(45870, 111, '2015-02-01 00:43:55.000000', 'temperatura', 969.0000, 'ºC'),
	(45871, 111, '2015-02-01 00:43:56.000000', 'temperatura', 626.0000, 'ºC'),
	(45872, 111, '2015-02-01 00:43:57.000000', 'temperatura', 220.0000, 'ºC'),
	(45873, 111, '2015-02-01 00:43:58.000000', 'temperatura', 425.0000, 'ºC'),
	(45874, 111, '2015-02-01 00:43:59.000000', 'temperatura', 265.0000, 'ºC'),
	(45875, 111, '2015-02-01 00:44:00.000000', 'temperatura', 51.0000, 'ºC'),
	(45876, 111, '2015-02-01 00:44:01.000000', 'temperatura', 661.0000, 'ºC'),
	(45877, 111, '2015-02-01 00:44:02.000000', 'temperatura', 753.0000, 'ºC'),
	(45878, 111, '2015-02-01 00:44:03.000000', 'temperatura', 582.0000, 'ºC'),
	(45879, 111, '2015-02-01 00:44:04.000000', 'temperatura', 653.0000, 'ºC'),
	(45880, 111, '2015-02-01 00:44:05.000000', 'temperatura', 318.0000, 'ºC'),
	(45881, 111, '2015-02-01 00:44:06.000000', 'temperatura', 832.0000, 'ºC'),
	(45882, 111, '2015-02-01 00:44:07.000000', 'temperatura', 806.0000, 'ºC'),
	(45883, 111, '2015-02-01 00:44:08.000000', 'temperatura', 336.0000, 'ºC'),
	(45884, 111, '2015-02-01 00:44:09.000000', 'temperatura', 462.0000, 'ºC'),
	(45885, 111, '2015-02-01 00:44:10.000000', 'temperatura', 102.0000, 'ºC'),
	(45886, 111, '2015-02-01 00:44:11.000000', 'temperatura', 325.0000, 'ºC'),
	(45887, 111, '2015-02-01 00:44:12.000000', 'temperatura', 118.0000, 'ºC'),
	(45888, 111, '2015-02-01 00:44:13.000000', 'temperatura', 818.0000, 'ºC'),
	(45889, 111, '2015-02-01 00:44:14.000000', 'temperatura', 136.0000, 'ºC'),
	(45890, 111, '2015-02-01 00:44:15.000000', 'temperatura', 624.0000, 'ºC'),
	(45891, 111, '2015-02-01 00:44:16.000000', 'temperatura', 314.0000, 'ºC'),
	(45892, 111, '2015-02-01 00:44:17.000000', 'temperatura', 899.0000, 'ºC'),
	(45893, 111, '2015-02-01 00:44:18.000000', 'temperatura', 1153.0000, 'ºC'),
	(45894, 111, '2015-02-01 00:44:19.000000', 'temperatura', 669.0000, 'ºC'),
	(45895, 111, '2015-02-01 00:44:20.000000', 'temperatura', 1086.0000, 'ºC'),
	(45896, 111, '2015-02-01 00:44:21.000000', 'temperatura', 1026.0000, 'ºC'),
	(45897, 111, '2015-02-01 00:44:22.000000', 'temperatura', 670.0000, 'ºC'),
	(45898, 111, '2015-02-01 00:44:23.000000', 'temperatura', 273.0000, 'ºC'),
	(45899, 111, '2015-02-01 00:44:24.000000', 'temperatura', 554.0000, 'ºC'),
	(45900, 111, '2015-02-01 00:44:25.000000', 'temperatura', 752.0000, 'ºC'),
	(45901, 111, '2015-02-01 00:44:26.000000', 'temperatura', 899.0000, 'ºC'),
	(45902, 111, '2015-02-01 00:44:27.000000', 'temperatura', 1040.0000, 'ºC'),
	(45903, 111, '2015-02-01 00:44:28.000000', 'temperatura', 102.0000, 'ºC'),
	(45904, 111, '2015-02-01 00:44:29.000000', 'temperatura', 990.0000, 'ºC'),
	(45905, 111, '2015-02-01 00:44:30.000000', 'temperatura', 1045.0000, 'ºC'),
	(45906, 111, '2015-02-01 00:44:31.000000', 'temperatura', 1058.0000, 'ºC'),
	(45907, 111, '2015-02-01 00:44:32.000000', 'temperatura', 953.0000, 'ºC'),
	(45908, 111, '2015-02-01 00:44:33.000000', 'temperatura', 391.0000, 'ºC'),
	(45909, 111, '2015-02-01 00:44:34.000000', 'temperatura', 298.0000, 'ºC'),
	(45910, 111, '2015-02-01 00:44:35.000000', 'temperatura', 319.0000, 'ºC'),
	(45911, 111, '2015-02-01 00:44:36.000000', 'temperatura', 699.0000, 'ºC'),
	(45912, 111, '2015-02-01 00:44:37.000000', 'temperatura', 139.0000, 'ºC'),
	(45913, 111, '2015-02-01 00:44:38.000000', 'temperatura', 999.0000, 'ºC'),
	(45914, 111, '2015-02-01 00:44:39.000000', 'temperatura', 978.0000, 'ºC'),
	(45915, 111, '2015-02-01 00:44:40.000000', 'temperatura', 695.0000, 'ºC'),
	(45916, 111, '2015-02-01 00:44:41.000000', 'temperatura', 542.0000, 'ºC'),
	(45917, 111, '2015-02-01 00:44:42.000000', 'temperatura', 623.0000, 'ºC'),
	(45918, 111, '2015-02-01 00:44:43.000000', 'temperatura', 290.0000, 'ºC'),
	(45919, 111, '2015-02-01 00:44:44.000000', 'temperatura', 782.0000, 'ºC'),
	(45920, 111, '2015-02-01 00:44:45.000000', 'temperatura', 642.0000, 'ºC'),
	(45921, 111, '2015-02-01 00:44:46.000000', 'temperatura', 863.0000, 'ºC'),
	(45922, 111, '2015-02-01 00:44:47.000000', 'temperatura', 1188.0000, 'ºC'),
	(45923, 111, '2015-02-01 00:44:48.000000', 'temperatura', 954.0000, 'ºC'),
	(45924, 111, '2015-02-01 00:44:49.000000', 'temperatura', 6.0000, 'ºC'),
	(45925, 111, '2015-02-01 00:44:50.000000', 'temperatura', 769.0000, 'ºC'),
	(45926, 111, '2015-02-01 00:44:51.000000', 'temperatura', 226.0000, 'ºC'),
	(45927, 111, '2015-02-01 00:44:52.000000', 'temperatura', 24.0000, 'ºC'),
	(45928, 111, '2015-02-01 00:44:53.000000', 'temperatura', 643.0000, 'ºC'),
	(45929, 111, '2015-02-01 00:44:54.000000', 'temperatura', 741.0000, 'ºC'),
	(45930, 111, '2015-02-01 00:44:55.000000', 'temperatura', 578.0000, 'ºC'),
	(45931, 111, '2015-02-01 00:44:56.000000', 'temperatura', 670.0000, 'ºC'),
	(45932, 111, '2015-02-01 00:44:57.000000', 'temperatura', 413.0000, 'ºC'),
	(45933, 111, '2015-02-01 00:44:58.000000', 'temperatura', 57.0000, 'ºC'),
	(45934, 111, '2015-02-01 00:44:59.000000', 'temperatura', 248.0000, 'ºC'),
	(45935, 111, '2015-02-01 00:45:00.000000', 'temperatura', 1066.0000, 'ºC'),
	(45936, 111, '2015-02-01 00:45:01.000000', 'temperatura', 990.0000, 'ºC'),
	(45937, 111, '2015-02-01 00:45:02.000000', 'temperatura', 552.0000, 'ºC'),
	(45938, 111, '2015-02-01 00:45:03.000000', 'temperatura', 991.0000, 'ºC'),
	(45939, 111, '2015-02-01 00:45:04.000000', 'temperatura', 901.0000, 'ºC'),
	(45940, 111, '2015-02-01 00:45:05.000000', 'temperatura', 330.0000, 'ºC'),
	(45941, 111, '2015-02-01 00:45:06.000000', 'temperatura', 147.0000, 'ºC'),
	(45942, 111, '2015-02-01 00:45:07.000000', 'temperatura', 947.0000, 'ºC'),
	(45943, 111, '2015-02-01 00:45:08.000000', 'temperatura', 692.0000, 'ºC'),
	(45944, 111, '2015-02-01 00:45:09.000000', 'temperatura', 623.0000, 'ºC'),
	(45945, 111, '2015-02-01 00:45:10.000000', 'temperatura', 1038.0000, 'ºC'),
	(45946, 111, '2015-02-01 00:45:11.000000', 'temperatura', 920.0000, 'ºC'),
	(45947, 111, '2015-02-01 00:45:12.000000', 'temperatura', 286.0000, 'ºC'),
	(45948, 111, '2015-02-01 00:45:13.000000', 'temperatura', 1074.0000, 'ºC'),
	(45949, 111, '2015-02-01 00:45:14.000000', 'temperatura', 909.0000, 'ºC'),
	(45950, 111, '2015-02-01 00:45:15.000000', 'temperatura', 126.0000, 'ºC'),
	(45951, 111, '2015-02-01 00:45:16.000000', 'temperatura', 301.0000, 'ºC'),
	(45952, 111, '2015-02-01 00:45:17.000000', 'temperatura', 1130.0000, 'ºC'),
	(45953, 111, '2015-02-01 00:45:18.000000', 'temperatura', 1148.0000, 'ºC'),
	(45954, 111, '2015-02-01 00:45:19.000000', 'temperatura', 1151.0000, 'ºC'),
	(45955, 111, '2015-02-01 00:45:20.000000', 'temperatura', 1111.0000, 'ºC'),
	(45956, 111, '2015-02-01 00:45:21.000000', 'temperatura', 904.0000, 'ºC'),
	(45957, 111, '2015-02-01 00:45:22.000000', 'temperatura', 1187.0000, 'ºC'),
	(45958, 111, '2015-02-01 00:45:23.000000', 'temperatura', 824.0000, 'ºC'),
	(45959, 111, '2015-02-01 00:45:24.000000', 'temperatura', 557.0000, 'ºC'),
	(45960, 111, '2015-02-01 00:45:25.000000', 'temperatura', 316.0000, 'ºC'),
	(45961, 111, '2015-02-01 00:45:26.000000', 'temperatura', 1107.0000, 'ºC'),
	(45962, 111, '2015-02-01 00:45:27.000000', 'temperatura', 990.0000, 'ºC'),
	(45963, 111, '2015-02-01 00:45:28.000000', 'temperatura', 428.0000, 'ºC'),
	(45964, 111, '2015-02-01 00:45:29.000000', 'temperatura', 372.0000, 'ºC'),
	(45965, 111, '2015-02-01 00:45:30.000000', 'temperatura', 578.0000, 'ºC'),
	(45966, 111, '2015-02-01 00:45:31.000000', 'temperatura', 571.0000, 'ºC'),
	(45967, 111, '2015-02-01 00:45:32.000000', 'temperatura', 1124.0000, 'ºC'),
	(45968, 111, '2015-02-01 00:45:33.000000', 'temperatura', 306.0000, 'ºC'),
	(45969, 111, '2015-02-01 00:45:34.000000', 'temperatura', 559.0000, 'ºC'),
	(45970, 111, '2015-02-01 00:45:35.000000', 'temperatura', 678.0000, 'ºC'),
	(45971, 111, '2015-02-01 00:45:36.000000', 'temperatura', 514.0000, 'ºC'),
	(45972, 111, '2015-02-01 00:45:37.000000', 'temperatura', 536.0000, 'ºC'),
	(45973, 111, '2015-02-01 00:45:38.000000', 'temperatura', 1136.0000, 'ºC'),
	(45974, 111, '2015-02-01 00:45:39.000000', 'temperatura', 476.0000, 'ºC'),
	(45975, 111, '2015-02-01 00:45:40.000000', 'temperatura', 170.0000, 'ºC'),
	(45976, 111, '2015-02-01 00:45:41.000000', 'temperatura', 623.0000, 'ºC'),
	(45977, 111, '2015-02-01 00:45:42.000000', 'temperatura', 206.0000, 'ºC'),
	(45978, 111, '2015-02-01 00:45:43.000000', 'temperatura', 359.0000, 'ºC'),
	(45979, 111, '2015-02-01 00:45:44.000000', 'temperatura', 1181.0000, 'ºC'),
	(45980, 111, '2015-02-01 00:45:45.000000', 'temperatura', 27.0000, 'ºC'),
	(45981, 111, '2015-02-01 00:45:46.000000', 'temperatura', 191.0000, 'ºC'),
	(45982, 111, '2015-02-01 00:45:47.000000', 'temperatura', 874.0000, 'ºC'),
	(45983, 111, '2015-02-01 00:45:48.000000', 'temperatura', 200.0000, 'ºC'),
	(45984, 111, '2015-02-01 00:45:49.000000', 'temperatura', 776.0000, 'ºC'),
	(45985, 111, '2015-02-01 00:45:50.000000', 'temperatura', 882.0000, 'ºC'),
	(45986, 111, '2015-02-01 00:45:51.000000', 'temperatura', 880.0000, 'ºC'),
	(45987, 111, '2015-02-01 00:45:52.000000', 'temperatura', 557.0000, 'ºC'),
	(45988, 111, '2015-02-01 00:45:53.000000', 'temperatura', 145.0000, 'ºC'),
	(45989, 111, '2015-02-01 00:45:54.000000', 'temperatura', 254.0000, 'ºC'),
	(45990, 111, '2015-02-01 00:45:55.000000', 'temperatura', 836.0000, 'ºC'),
	(45991, 111, '2015-02-01 00:45:56.000000', 'temperatura', 1018.0000, 'ºC'),
	(45992, 111, '2015-02-01 00:45:57.000000', 'temperatura', 184.0000, 'ºC'),
	(45993, 111, '2015-02-01 00:45:58.000000', 'temperatura', 265.0000, 'ºC'),
	(45994, 111, '2015-02-01 00:45:59.000000', 'temperatura', 773.0000, 'ºC'),
	(45995, 111, '2015-02-01 00:46:00.000000', 'temperatura', 673.0000, 'ºC'),
	(45996, 111, '2015-02-01 00:46:01.000000', 'temperatura', 1045.0000, 'ºC'),
	(45997, 111, '2015-02-01 00:46:02.000000', 'temperatura', 809.0000, 'ºC'),
	(45998, 111, '2015-02-01 00:46:03.000000', 'temperatura', 908.0000, 'ºC'),
	(45999, 111, '2015-02-01 00:46:04.000000', 'temperatura', 913.0000, 'ºC'),
	(46000, 111, '2015-02-01 00:46:05.000000', 'temperatura', 644.0000, 'ºC'),
	(46001, 111, '2015-02-01 00:46:06.000000', 'temperatura', 478.0000, 'ºC'),
	(46002, 111, '2015-02-01 00:46:07.000000', 'temperatura', 462.0000, 'ºC'),
	(46003, 111, '2015-02-01 00:46:08.000000', 'temperatura', 873.0000, 'ºC'),
	(46004, 111, '2015-02-01 00:46:09.000000', 'temperatura', 582.0000, 'ºC'),
	(46005, 111, '2015-02-01 00:46:10.000000', 'temperatura', 292.0000, 'ºC'),
	(46006, 111, '2015-02-01 00:46:11.000000', 'temperatura', 914.0000, 'ºC'),
	(46007, 111, '2015-02-01 00:46:12.000000', 'temperatura', 93.0000, 'ºC'),
	(46008, 111, '2015-02-01 00:46:13.000000', 'temperatura', 122.0000, 'ºC'),
	(46009, 111, '2015-02-01 00:46:14.000000', 'temperatura', 335.0000, 'ºC'),
	(46010, 111, '2015-02-01 00:46:15.000000', 'temperatura', 108.0000, 'ºC'),
	(46011, 111, '2015-02-01 00:46:16.000000', 'temperatura', 735.0000, 'ºC'),
	(46012, 111, '2015-02-01 00:46:17.000000', 'temperatura', 953.0000, 'ºC'),
	(46013, 111, '2015-02-01 00:46:18.000000', 'temperatura', 158.0000, 'ºC'),
	(46014, 111, '2015-02-01 00:46:19.000000', 'temperatura', 332.0000, 'ºC'),
	(46015, 111, '2015-02-01 00:46:20.000000', 'temperatura', 1187.0000, 'ºC'),
	(46016, 111, '2015-02-01 00:46:21.000000', 'temperatura', 138.0000, 'ºC'),
	(46017, 111, '2015-02-01 00:46:22.000000', 'temperatura', 731.0000, 'ºC'),
	(46018, 111, '2015-02-01 00:46:23.000000', 'temperatura', 841.0000, 'ºC'),
	(46019, 111, '2015-02-01 00:46:24.000000', 'temperatura', 811.0000, 'ºC'),
	(46020, 111, '2015-02-01 00:46:25.000000', 'temperatura', 334.0000, 'ºC'),
	(46021, 111, '2015-02-01 00:46:26.000000', 'temperatura', 438.0000, 'ºC'),
	(46022, 111, '2015-02-01 00:46:27.000000', 'temperatura', 1188.0000, 'ºC'),
	(46023, 111, '2015-02-01 00:46:28.000000', 'temperatura', 1026.0000, 'ºC'),
	(46024, 111, '2015-02-01 00:46:29.000000', 'temperatura', 368.0000, 'ºC'),
	(46025, 111, '2015-02-01 00:46:30.000000', 'temperatura', 1161.0000, 'ºC'),
	(46026, 111, '2015-02-01 00:46:31.000000', 'temperatura', 1103.0000, 'ºC'),
	(46027, 111, '2015-02-01 00:46:32.000000', 'temperatura', 832.0000, 'ºC'),
	(46028, 111, '2015-02-01 00:46:33.000000', 'temperatura', 850.0000, 'ºC'),
	(46029, 111, '2015-02-01 00:46:34.000000', 'temperatura', 556.0000, 'ºC'),
	(46030, 111, '2015-02-01 00:46:35.000000', 'temperatura', 232.0000, 'ºC'),
	(46031, 111, '2015-02-01 00:46:36.000000', 'temperatura', 692.0000, 'ºC'),
	(46032, 111, '2015-02-01 00:46:37.000000', 'temperatura', 363.0000, 'ºC'),
	(46033, 111, '2015-02-01 00:46:38.000000', 'temperatura', 942.0000, 'ºC'),
	(46034, 111, '2015-02-01 00:46:39.000000', 'temperatura', 20.0000, 'ºC'),
	(46035, 111, '2015-02-01 00:46:40.000000', 'temperatura', 875.0000, 'ºC'),
	(46036, 111, '2015-02-01 00:46:41.000000', 'temperatura', 716.0000, 'ºC'),
	(46037, 111, '2015-02-01 00:46:42.000000', 'temperatura', 953.0000, 'ºC'),
	(46038, 111, '2015-02-01 00:46:43.000000', 'temperatura', 221.0000, 'ºC'),
	(46039, 111, '2015-02-01 00:46:44.000000', 'temperatura', 645.0000, 'ºC'),
	(46040, 111, '2015-02-01 00:46:45.000000', 'temperatura', 161.0000, 'ºC'),
	(46041, 111, '2015-02-01 00:46:46.000000', 'temperatura', 72.0000, 'ºC'),
	(46042, 111, '2015-02-01 00:46:47.000000', 'temperatura', 1076.0000, 'ºC'),
	(46043, 111, '2015-02-01 00:46:48.000000', 'temperatura', 367.0000, 'ºC'),
	(46044, 111, '2015-02-01 00:46:49.000000', 'temperatura', 1004.0000, 'ºC'),
	(46045, 111, '2015-02-01 00:46:50.000000', 'temperatura', 323.0000, 'ºC'),
	(46046, 111, '2015-02-01 00:46:51.000000', 'temperatura', 1000.0000, 'ºC'),
	(46047, 111, '2015-02-01 00:46:52.000000', 'temperatura', 434.0000, 'ºC'),
	(46048, 111, '2015-02-01 00:46:53.000000', 'temperatura', 368.0000, 'ºC'),
	(46049, 111, '2015-02-01 00:46:54.000000', 'temperatura', 539.0000, 'ºC'),
	(46050, 111, '2015-02-01 00:46:55.000000', 'temperatura', 392.0000, 'ºC'),
	(46051, 111, '2015-02-01 00:46:56.000000', 'temperatura', 343.0000, 'ºC'),
	(46052, 111, '2015-02-01 00:46:57.000000', 'temperatura', 539.0000, 'ºC'),
	(46053, 111, '2015-02-01 00:46:58.000000', 'temperatura', 469.0000, 'ºC'),
	(46054, 111, '2015-02-01 00:46:59.000000', 'temperatura', 728.0000, 'ºC'),
	(46055, 111, '2015-02-01 00:47:00.000000', 'temperatura', 1033.0000, 'ºC'),
	(46056, 111, '2015-02-01 00:47:01.000000', 'temperatura', 581.0000, 'ºC'),
	(46057, 111, '2015-02-01 00:47:02.000000', 'temperatura', 1006.0000, 'ºC'),
	(46058, 111, '2015-02-01 00:47:03.000000', 'temperatura', 888.0000, 'ºC'),
	(46059, 111, '2015-02-01 00:47:04.000000', 'temperatura', 222.0000, 'ºC'),
	(46060, 111, '2015-02-01 00:47:05.000000', 'temperatura', 848.0000, 'ºC'),
	(46061, 111, '2015-02-01 00:47:06.000000', 'temperatura', 1173.0000, 'ºC'),
	(46062, 111, '2015-02-01 00:47:07.000000', 'temperatura', 923.0000, 'ºC'),
	(46063, 111, '2015-02-01 00:47:08.000000', 'temperatura', 1096.0000, 'ºC'),
	(46064, 111, '2015-02-01 00:47:09.000000', 'temperatura', 311.0000, 'ºC'),
	(46065, 111, '2015-02-01 00:47:10.000000', 'temperatura', 667.0000, 'ºC'),
	(46066, 111, '2015-02-01 00:47:11.000000', 'temperatura', 2.0000, 'ºC'),
	(46067, 111, '2015-02-01 00:47:12.000000', 'temperatura', 411.0000, 'ºC'),
	(46068, 111, '2015-02-01 00:47:13.000000', 'temperatura', 848.0000, 'ºC'),
	(46069, 111, '2015-02-01 00:47:14.000000', 'temperatura', 610.0000, 'ºC'),
	(46070, 111, '2015-02-01 00:47:15.000000', 'temperatura', 504.0000, 'ºC'),
	(46071, 111, '2015-02-01 00:47:16.000000', 'temperatura', 691.0000, 'ºC'),
	(46072, 111, '2015-02-01 00:47:17.000000', 'temperatura', 742.0000, 'ºC'),
	(46073, 111, '2015-02-01 00:47:18.000000', 'temperatura', 440.0000, 'ºC'),
	(46074, 111, '2015-02-01 00:47:19.000000', 'temperatura', 1174.0000, 'ºC'),
	(46075, 111, '2015-02-01 00:47:20.000000', 'temperatura', 949.0000, 'ºC'),
	(46076, 111, '2015-02-01 00:47:21.000000', 'temperatura', 23.0000, 'ºC'),
	(46077, 111, '2015-02-01 00:47:22.000000', 'temperatura', 869.0000, 'ºC'),
	(46078, 111, '2015-02-01 00:47:23.000000', 'temperatura', 679.0000, 'ºC'),
	(46079, 111, '2015-02-01 00:47:24.000000', 'temperatura', 786.0000, 'ºC'),
	(46080, 111, '2015-02-01 00:47:25.000000', 'temperatura', 693.0000, 'ºC'),
	(46081, 111, '2015-02-01 00:47:26.000000', 'temperatura', 1110.0000, 'ºC'),
	(46082, 111, '2015-02-01 00:47:27.000000', 'temperatura', 1069.0000, 'ºC'),
	(46083, 111, '2015-02-01 00:47:28.000000', 'temperatura', 817.0000, 'ºC'),
	(46084, 111, '2015-02-01 00:47:29.000000', 'temperatura', 878.0000, 'ºC'),
	(46085, 111, '2015-02-01 00:47:30.000000', 'temperatura', 740.0000, 'ºC'),
	(46086, 111, '2015-02-01 00:47:31.000000', 'temperatura', 1068.0000, 'ºC'),
	(46087, 111, '2015-02-01 00:47:32.000000', 'temperatura', 720.0000, 'ºC'),
	(46088, 111, '2015-02-01 00:47:33.000000', 'temperatura', 394.0000, 'ºC'),
	(46089, 111, '2015-02-01 00:47:34.000000', 'temperatura', 1012.0000, 'ºC'),
	(46090, 111, '2015-02-01 00:47:35.000000', 'temperatura', 278.0000, 'ºC'),
	(46091, 111, '2015-02-01 00:47:36.000000', 'temperatura', 754.0000, 'ºC'),
	(46092, 111, '2015-02-01 00:47:37.000000', 'temperatura', 536.0000, 'ºC'),
	(46093, 111, '2015-02-01 00:47:38.000000', 'temperatura', 417.0000, 'ºC'),
	(46094, 111, '2015-02-01 00:47:39.000000', 'temperatura', 480.0000, 'ºC'),
	(46095, 111, '2015-02-01 00:47:40.000000', 'temperatura', 1149.0000, 'ºC'),
	(46096, 111, '2015-02-01 00:47:41.000000', 'temperatura', 705.0000, 'ºC'),
	(46097, 111, '2015-02-01 00:47:42.000000', 'temperatura', 78.0000, 'ºC'),
	(46098, 111, '2015-02-01 00:47:43.000000', 'temperatura', 676.0000, 'ºC'),
	(46099, 111, '2015-02-01 00:47:44.000000', 'temperatura', 747.0000, 'ºC'),
	(46100, 111, '2015-02-01 00:47:45.000000', 'temperatura', 509.0000, 'ºC'),
	(46101, 111, '2015-02-01 00:47:46.000000', 'temperatura', 301.0000, 'ºC'),
	(46102, 111, '2015-02-01 00:47:47.000000', 'temperatura', 1182.0000, 'ºC'),
	(46103, 111, '2015-02-01 00:47:48.000000', 'temperatura', 204.0000, 'ºC'),
	(46104, 111, '2015-02-01 00:47:49.000000', 'temperatura', 1078.0000, 'ºC'),
	(46105, 111, '2015-02-01 00:47:50.000000', 'temperatura', 1177.0000, 'ºC'),
	(46106, 111, '2015-02-01 00:47:51.000000', 'temperatura', 249.0000, 'ºC'),
	(46107, 111, '2015-02-01 00:47:52.000000', 'temperatura', 118.0000, 'ºC'),
	(46108, 111, '2015-02-01 00:47:53.000000', 'temperatura', 1043.0000, 'ºC'),
	(46109, 111, '2015-02-01 00:47:54.000000', 'temperatura', 61.0000, 'ºC'),
	(46110, 111, '2015-02-01 00:47:55.000000', 'temperatura', 776.0000, 'ºC'),
	(46111, 111, '2015-02-01 00:47:56.000000', 'temperatura', 97.0000, 'ºC'),
	(46112, 111, '2015-02-01 00:47:57.000000', 'temperatura', 557.0000, 'ºC'),
	(46113, 111, '2015-02-01 00:47:58.000000', 'temperatura', 95.0000, 'ºC'),
	(46114, 111, '2015-02-01 00:47:59.000000', 'temperatura', 6.0000, 'ºC'),
	(46115, 111, '2015-02-01 00:48:00.000000', 'temperatura', 945.0000, 'ºC'),
	(46116, 111, '2015-02-01 00:48:01.000000', 'temperatura', 1108.0000, 'ºC'),
	(46117, 111, '2015-02-01 00:48:02.000000', 'temperatura', 305.0000, 'ºC'),
	(46118, 111, '2015-02-01 00:48:03.000000', 'temperatura', 603.0000, 'ºC'),
	(46119, 111, '2015-02-01 00:48:04.000000', 'temperatura', 898.0000, 'ºC'),
	(46120, 111, '2015-02-01 00:48:05.000000', 'temperatura', 283.0000, 'ºC'),
	(46121, 111, '2015-02-01 00:48:06.000000', 'temperatura', 1123.0000, 'ºC'),
	(46122, 111, '2015-02-01 00:48:07.000000', 'temperatura', 1165.0000, 'ºC'),
	(46123, 111, '2015-02-01 00:48:08.000000', 'temperatura', 55.0000, 'ºC'),
	(46124, 111, '2015-02-01 00:48:09.000000', 'temperatura', 381.0000, 'ºC'),
	(46125, 111, '2015-02-01 00:48:10.000000', 'temperatura', 543.0000, 'ºC'),
	(46126, 111, '2015-02-01 00:48:11.000000', 'temperatura', 369.0000, 'ºC'),
	(46127, 111, '2015-02-01 00:48:12.000000', 'temperatura', 219.0000, 'ºC'),
	(46128, 111, '2015-02-01 00:48:13.000000', 'temperatura', 1188.0000, 'ºC'),
	(46129, 111, '2015-02-01 00:48:14.000000', 'temperatura', 485.0000, 'ºC'),
	(46130, 111, '2015-02-01 00:48:15.000000', 'temperatura', 62.0000, 'ºC'),
	(46131, 111, '2015-02-01 00:48:16.000000', 'temperatura', 54.0000, 'ºC'),
	(46132, 111, '2015-02-01 00:48:17.000000', 'temperatura', 86.0000, 'ºC'),
	(46133, 111, '2015-02-01 00:48:18.000000', 'temperatura', 267.0000, 'ºC'),
	(46134, 111, '2015-02-01 00:48:19.000000', 'temperatura', 1077.0000, 'ºC'),
	(46135, 111, '2015-02-01 00:48:20.000000', 'temperatura', 985.0000, 'ºC'),
	(46136, 111, '2015-02-01 00:48:21.000000', 'temperatura', 496.0000, 'ºC'),
	(46137, 111, '2015-02-01 00:48:22.000000', 'temperatura', 723.0000, 'ºC'),
	(46138, 111, '2015-02-01 00:48:23.000000', 'temperatura', 930.0000, 'ºC'),
	(46139, 111, '2015-02-01 00:48:24.000000', 'temperatura', 79.0000, 'ºC'),
	(46140, 111, '2015-02-01 00:48:25.000000', 'temperatura', 7.0000, 'ºC'),
	(46141, 111, '2015-02-01 00:48:26.000000', 'temperatura', 998.0000, 'ºC'),
	(46142, 111, '2015-02-01 00:48:27.000000', 'temperatura', 169.0000, 'ºC'),
	(46143, 111, '2015-02-01 00:48:28.000000', 'temperatura', 253.0000, 'ºC'),
	(46144, 111, '2015-02-01 00:48:29.000000', 'temperatura', 758.0000, 'ºC'),
	(46145, 111, '2015-02-01 00:48:30.000000', 'temperatura', 633.0000, 'ºC'),
	(46146, 111, '2015-02-01 00:48:31.000000', 'temperatura', 891.0000, 'ºC'),
	(46147, 111, '2015-02-01 00:48:32.000000', 'temperatura', 158.0000, 'ºC'),
	(46148, 111, '2015-02-01 00:48:33.000000', 'temperatura', 514.0000, 'ºC'),
	(46149, 111, '2015-02-01 00:48:34.000000', 'temperatura', 899.0000, 'ºC'),
	(46150, 111, '2015-02-01 00:48:35.000000', 'temperatura', 551.0000, 'ºC'),
	(46151, 111, '2015-02-01 00:48:36.000000', 'temperatura', 62.0000, 'ºC'),
	(46152, 111, '2015-02-01 00:48:37.000000', 'temperatura', 1054.0000, 'ºC'),
	(46153, 111, '2015-02-01 00:48:38.000000', 'temperatura', 287.0000, 'ºC'),
	(46154, 111, '2015-02-01 00:48:39.000000', 'temperatura', 673.0000, 'ºC'),
	(46155, 111, '2015-02-01 00:48:40.000000', 'temperatura', 103.0000, 'ºC'),
	(46156, 111, '2015-02-01 00:48:41.000000', 'temperatura', 899.0000, 'ºC'),
	(46157, 111, '2015-02-01 00:48:42.000000', 'temperatura', 587.0000, 'ºC'),
	(46158, 111, '2015-02-01 00:48:43.000000', 'temperatura', 236.0000, 'ºC'),
	(46159, 111, '2015-02-01 00:48:44.000000', 'temperatura', 621.0000, 'ºC'),
	(46160, 111, '2015-02-01 00:48:45.000000', 'temperatura', 1195.0000, 'ºC'),
	(46161, 111, '2015-02-01 00:48:46.000000', 'temperatura', 515.0000, 'ºC'),
	(46162, 111, '2015-02-01 00:48:47.000000', 'temperatura', 190.0000, 'ºC'),
	(46163, 111, '2015-02-01 00:48:48.000000', 'temperatura', 607.0000, 'ºC'),
	(46164, 111, '2015-02-01 00:48:49.000000', 'temperatura', 63.0000, 'ºC'),
	(46165, 111, '2015-02-01 00:48:50.000000', 'temperatura', 894.0000, 'ºC'),
	(46166, 111, '2015-02-01 00:48:51.000000', 'temperatura', 684.0000, 'ºC'),
	(46167, 111, '2015-02-01 00:48:52.000000', 'temperatura', 736.0000, 'ºC'),
	(46168, 111, '2015-02-01 00:48:53.000000', 'temperatura', 430.0000, 'ºC'),
	(46169, 111, '2015-02-01 00:48:54.000000', 'temperatura', 1143.0000, 'ºC'),
	(46170, 111, '2015-02-01 00:48:55.000000', 'temperatura', 825.0000, 'ºC'),
	(46171, 111, '2015-02-01 00:48:56.000000', 'temperatura', 695.0000, 'ºC'),
	(46172, 111, '2015-02-01 00:48:57.000000', 'temperatura', 1001.0000, 'ºC'),
	(46173, 111, '2015-02-01 00:48:58.000000', 'temperatura', 522.0000, 'ºC'),
	(46174, 111, '2015-02-01 00:48:59.000000', 'temperatura', 807.0000, 'ºC'),
	(46175, 111, '2015-02-01 00:49:00.000000', 'temperatura', 70.0000, 'ºC'),
	(46176, 111, '2015-02-01 00:49:01.000000', 'temperatura', 330.0000, 'ºC'),
	(46177, 111, '2015-02-01 00:49:02.000000', 'temperatura', 240.0000, 'ºC'),
	(46178, 111, '2015-02-01 00:49:03.000000', 'temperatura', 209.0000, 'ºC'),
	(46179, 111, '2015-02-01 00:49:04.000000', 'temperatura', 325.0000, 'ºC'),
	(46180, 111, '2015-02-01 00:49:05.000000', 'temperatura', 1000.0000, 'ºC'),
	(46181, 111, '2015-02-01 00:49:06.000000', 'temperatura', 425.0000, 'ºC'),
	(46182, 111, '2015-02-01 00:49:07.000000', 'temperatura', 327.0000, 'ºC'),
	(46183, 111, '2015-02-01 00:49:08.000000', 'temperatura', 361.0000, 'ºC'),
	(46184, 111, '2015-02-01 00:49:09.000000', 'temperatura', 823.0000, 'ºC'),
	(46185, 111, '2015-02-01 00:49:10.000000', 'temperatura', 633.0000, 'ºC'),
	(46186, 111, '2015-02-01 00:49:11.000000', 'temperatura', 698.0000, 'ºC'),
	(46187, 111, '2015-02-01 00:49:12.000000', 'temperatura', 392.0000, 'ºC'),
	(46188, 111, '2015-02-01 00:49:13.000000', 'temperatura', 1063.0000, 'ºC'),
	(46189, 111, '2015-02-01 00:49:14.000000', 'temperatura', 543.0000, 'ºC'),
	(46190, 111, '2015-02-01 00:49:15.000000', 'temperatura', 723.0000, 'ºC'),
	(46191, 111, '2015-02-01 00:49:16.000000', 'temperatura', 790.0000, 'ºC'),
	(46192, 111, '2015-02-01 00:49:17.000000', 'temperatura', 579.0000, 'ºC'),
	(46193, 111, '2015-02-01 00:49:18.000000', 'temperatura', 525.0000, 'ºC'),
	(46194, 111, '2015-02-01 00:49:19.000000', 'temperatura', 889.0000, 'ºC'),
	(46195, 111, '2015-02-01 00:49:20.000000', 'temperatura', 471.0000, 'ºC'),
	(46196, 111, '2015-02-01 00:49:21.000000', 'temperatura', 889.0000, 'ºC'),
	(46197, 111, '2015-02-01 00:49:22.000000', 'temperatura', 633.0000, 'ºC'),
	(46198, 111, '2015-02-01 00:49:23.000000', 'temperatura', 497.0000, 'ºC'),
	(46199, 111, '2015-02-01 00:49:24.000000', 'temperatura', 585.0000, 'ºC'),
	(46200, 111, '2015-02-01 00:49:25.000000', 'temperatura', 237.0000, 'ºC'),
	(46201, 111, '2015-02-01 00:49:26.000000', 'temperatura', 628.0000, 'ºC'),
	(46202, 111, '2015-02-01 00:49:27.000000', 'temperatura', 31.0000, 'ºC'),
	(46203, 111, '2015-02-01 00:49:28.000000', 'temperatura', 670.0000, 'ºC'),
	(46204, 111, '2015-02-01 00:49:29.000000', 'temperatura', 857.0000, 'ºC'),
	(46205, 111, '2015-02-01 00:49:30.000000', 'temperatura', 1075.0000, 'ºC'),
	(46206, 111, '2015-02-01 00:49:31.000000', 'temperatura', 405.0000, 'ºC'),
	(46207, 111, '2015-02-01 00:49:32.000000', 'temperatura', 0.0000, 'ºC'),
	(46208, 111, '2015-02-01 00:49:33.000000', 'temperatura', 1184.0000, 'ºC'),
	(46209, 111, '2015-02-01 00:49:34.000000', 'temperatura', 1123.0000, 'ºC'),
	(46210, 111, '2015-02-01 00:49:35.000000', 'temperatura', 865.0000, 'ºC'),
	(46211, 111, '2015-02-01 00:49:36.000000', 'temperatura', 954.0000, 'ºC'),
	(46212, 111, '2015-02-01 00:49:37.000000', 'temperatura', 975.0000, 'ºC'),
	(46213, 111, '2015-02-01 00:49:38.000000', 'temperatura', 815.0000, 'ºC'),
	(46214, 111, '2015-02-01 00:49:39.000000', 'temperatura', 1149.0000, 'ºC'),
	(46215, 111, '2015-02-01 00:49:40.000000', 'temperatura', 899.0000, 'ºC'),
	(46216, 111, '2015-02-01 00:49:41.000000', 'temperatura', 1052.0000, 'ºC'),
	(46217, 111, '2015-02-01 00:49:42.000000', 'temperatura', 162.0000, 'ºC'),
	(46218, 111, '2015-02-01 00:49:43.000000', 'temperatura', 55.0000, 'ºC'),
	(46219, 111, '2015-02-01 00:49:44.000000', 'temperatura', 988.0000, 'ºC'),
	(46220, 111, '2015-02-01 00:49:45.000000', 'temperatura', 1177.0000, 'ºC'),
	(46221, 111, '2015-02-01 00:49:46.000000', 'temperatura', 522.0000, 'ºC'),
	(46222, 111, '2015-02-01 00:49:47.000000', 'temperatura', 280.0000, 'ºC'),
	(46223, 111, '2015-02-01 00:49:48.000000', 'temperatura', 1034.0000, 'ºC'),
	(46224, 111, '2015-02-01 00:49:49.000000', 'temperatura', 730.0000, 'ºC'),
	(46225, 111, '2015-02-01 00:49:50.000000', 'temperatura', 547.0000, 'ºC'),
	(46226, 111, '2015-02-01 00:49:51.000000', 'temperatura', 547.0000, 'ºC'),
	(46227, 111, '2015-02-01 00:49:52.000000', 'temperatura', 1096.0000, 'ºC'),
	(46228, 111, '2015-02-01 00:49:53.000000', 'temperatura', 240.0000, 'ºC'),
	(46229, 111, '2015-02-01 00:49:54.000000', 'temperatura', 311.0000, 'ºC'),
	(46230, 111, '2015-02-01 00:49:55.000000', 'temperatura', 835.0000, 'ºC'),
	(46231, 111, '2015-02-01 00:49:56.000000', 'temperatura', 845.0000, 'ºC'),
	(46232, 111, '2015-02-01 00:49:57.000000', 'temperatura', 519.0000, 'ºC'),
	(46233, 111, '2015-02-01 00:49:58.000000', 'temperatura', 60.0000, 'ºC'),
	(46234, 111, '2015-02-01 00:49:59.000000', 'temperatura', 1142.0000, 'ºC'),
	(46235, 111, '2015-02-01 00:50:00.000000', 'temperatura', 734.0000, 'ºC'),
	(46236, 111, '2015-02-01 00:50:01.000000', 'temperatura', 241.0000, 'ºC'),
	(46237, 111, '2015-02-01 00:50:02.000000', 'temperatura', 207.0000, 'ºC'),
	(46238, 111, '2015-02-01 00:50:03.000000', 'temperatura', 311.0000, 'ºC'),
	(46239, 111, '2015-02-01 00:50:04.000000', 'temperatura', 935.0000, 'ºC'),
	(46240, 111, '2015-02-01 00:50:05.000000', 'temperatura', 143.0000, 'ºC'),
	(46241, 111, '2015-02-01 00:50:06.000000', 'temperatura', 310.0000, 'ºC'),
	(46242, 111, '2015-02-01 00:50:07.000000', 'temperatura', 1122.0000, 'ºC'),
	(46243, 111, '2015-02-01 00:50:08.000000', 'temperatura', 1082.0000, 'ºC'),
	(46244, 111, '2015-02-01 00:50:09.000000', 'temperatura', 843.0000, 'ºC'),
	(46245, 111, '2015-02-01 00:50:10.000000', 'temperatura', 972.0000, 'ºC'),
	(46246, 111, '2015-02-01 00:50:11.000000', 'temperatura', 1129.0000, 'ºC'),
	(46247, 111, '2015-02-01 00:50:12.000000', 'temperatura', 329.0000, 'ºC'),
	(46248, 111, '2015-02-01 00:50:13.000000', 'temperatura', 659.0000, 'ºC'),
	(46249, 111, '2015-02-01 00:50:14.000000', 'temperatura', 1107.0000, 'ºC'),
	(46250, 111, '2015-02-01 00:50:15.000000', 'temperatura', 1160.0000, 'ºC'),
	(46251, 111, '2015-02-01 00:50:16.000000', 'temperatura', 79.0000, 'ºC'),
	(46252, 111, '2015-02-01 00:50:17.000000', 'temperatura', 515.0000, 'ºC'),
	(46253, 111, '2015-02-01 00:50:18.000000', 'temperatura', 1141.0000, 'ºC'),
	(46254, 111, '2015-02-01 00:50:19.000000', 'temperatura', 557.0000, 'ºC'),
	(46255, 111, '2015-02-01 00:50:20.000000', 'temperatura', 565.0000, 'ºC'),
	(46256, 111, '2015-02-01 00:50:21.000000', 'temperatura', 1153.0000, 'ºC'),
	(46257, 111, '2015-02-01 00:50:22.000000', 'temperatura', 469.0000, 'ºC'),
	(46258, 111, '2015-02-01 00:50:23.000000', 'temperatura', 89.0000, 'ºC'),
	(46259, 111, '2015-02-01 00:50:24.000000', 'temperatura', 237.0000, 'ºC'),
	(46260, 111, '2015-02-01 00:50:25.000000', 'temperatura', 918.0000, 'ºC'),
	(46261, 111, '2015-02-01 00:50:26.000000', 'temperatura', 279.0000, 'ºC'),
	(46262, 111, '2015-02-01 00:50:27.000000', 'temperatura', 1044.0000, 'ºC'),
	(46263, 111, '2015-02-01 00:50:28.000000', 'temperatura', 783.0000, 'ºC'),
	(46264, 111, '2015-02-01 00:50:29.000000', 'temperatura', 783.0000, 'ºC'),
	(46265, 111, '2015-02-01 00:50:30.000000', 'temperatura', 366.0000, 'ºC'),
	(46266, 111, '2015-02-01 00:50:31.000000', 'temperatura', 680.0000, 'ºC'),
	(46267, 111, '2015-02-01 00:50:32.000000', 'temperatura', 1105.0000, 'ºC'),
	(46268, 111, '2015-02-01 00:50:33.000000', 'temperatura', 1084.0000, 'ºC'),
	(46269, 111, '2015-02-01 00:50:34.000000', 'temperatura', 905.0000, 'ºC'),
	(46270, 111, '2015-02-01 00:50:35.000000', 'temperatura', 76.0000, 'ºC'),
	(46271, 111, '2015-02-01 00:50:36.000000', 'temperatura', 65.0000, 'ºC'),
	(46272, 111, '2015-02-01 00:50:37.000000', 'temperatura', 95.0000, 'ºC'),
	(46273, 111, '2015-02-01 00:50:38.000000', 'temperatura', 284.0000, 'ºC'),
	(46274, 111, '2015-02-01 00:50:39.000000', 'temperatura', 1133.0000, 'ºC'),
	(46275, 111, '2015-02-01 00:50:40.000000', 'temperatura', 15.0000, 'ºC'),
	(46276, 111, '2015-02-01 00:50:41.000000', 'temperatura', 276.0000, 'ºC'),
	(46277, 111, '2015-02-01 00:50:42.000000', 'temperatura', 136.0000, 'ºC'),
	(46278, 111, '2015-02-01 00:50:43.000000', 'temperatura', 1053.0000, 'ºC'),
	(46279, 111, '2015-02-01 00:50:44.000000', 'temperatura', 56.0000, 'ºC'),
	(46280, 111, '2015-02-01 00:50:45.000000', 'temperatura', 722.0000, 'ºC'),
	(46281, 111, '2015-02-01 00:50:46.000000', 'temperatura', 1043.0000, 'ºC'),
	(46282, 111, '2015-02-01 00:50:47.000000', 'temperatura', 648.0000, 'ºC'),
	(46283, 111, '2015-02-01 00:50:48.000000', 'temperatura', 111.0000, 'ºC'),
	(46284, 111, '2015-02-01 00:50:49.000000', 'temperatura', 1011.0000, 'ºC'),
	(46285, 111, '2015-02-01 00:50:50.000000', 'temperatura', 1124.0000, 'ºC'),
	(46286, 111, '2015-02-01 00:50:51.000000', 'temperatura', 188.0000, 'ºC'),
	(46287, 111, '2015-02-01 00:50:52.000000', 'temperatura', 1169.0000, 'ºC'),
	(46288, 111, '2015-02-01 00:50:53.000000', 'temperatura', 481.0000, 'ºC'),
	(46289, 111, '2015-02-01 00:50:54.000000', 'temperatura', 100.0000, 'ºC'),
	(46290, 111, '2015-02-01 00:50:55.000000', 'temperatura', 255.0000, 'ºC'),
	(46291, 111, '2015-02-01 00:50:56.000000', 'temperatura', 975.0000, 'ºC'),
	(46292, 111, '2015-02-01 00:50:57.000000', 'temperatura', 510.0000, 'ºC'),
	(46293, 111, '2015-02-01 00:50:58.000000', 'temperatura', 828.0000, 'ºC'),
	(46294, 111, '2015-02-01 00:50:59.000000', 'temperatura', 211.0000, 'ºC'),
	(46295, 111, '2015-02-01 00:51:00.000000', 'temperatura', 970.0000, 'ºC'),
	(46296, 111, '2015-02-01 00:51:01.000000', 'temperatura', 620.0000, 'ºC'),
	(46297, 111, '2015-02-01 00:51:02.000000', 'temperatura', 187.0000, 'ºC'),
	(46298, 111, '2015-02-01 00:51:03.000000', 'temperatura', 278.0000, 'ºC'),
	(46299, 111, '2015-02-01 00:51:04.000000', 'temperatura', 827.0000, 'ºC'),
	(46300, 111, '2015-02-01 00:51:05.000000', 'temperatura', 902.0000, 'ºC'),
	(46301, 111, '2015-02-01 00:51:06.000000', 'temperatura', 830.0000, 'ºC'),
	(46302, 111, '2015-02-01 00:51:07.000000', 'temperatura', 245.0000, 'ºC'),
	(46303, 111, '2015-02-01 00:51:08.000000', 'temperatura', 1135.0000, 'ºC'),
	(46304, 111, '2015-02-01 00:51:09.000000', 'temperatura', 139.0000, 'ºC'),
	(46305, 111, '2015-02-01 00:51:10.000000', 'temperatura', 892.0000, 'ºC'),
	(46306, 111, '2015-02-01 00:51:11.000000', 'temperatura', 444.0000, 'ºC'),
	(46307, 111, '2015-02-01 00:51:12.000000', 'temperatura', 743.0000, 'ºC'),
	(46308, 111, '2015-02-01 00:51:13.000000', 'temperatura', 1183.0000, 'ºC'),
	(46309, 111, '2015-02-01 00:51:14.000000', 'temperatura', 88.0000, 'ºC'),
	(46310, 111, '2015-02-01 00:51:15.000000', 'temperatura', 490.0000, 'ºC'),
	(46311, 111, '2015-02-01 00:51:16.000000', 'temperatura', 987.0000, 'ºC'),
	(46312, 111, '2015-02-01 00:51:17.000000', 'temperatura', 1067.0000, 'ºC'),
	(46313, 111, '2015-02-01 00:51:18.000000', 'temperatura', 1173.0000, 'ºC'),
	(46314, 111, '2015-02-01 00:51:19.000000', 'temperatura', 266.0000, 'ºC'),
	(46315, 111, '2015-02-01 00:51:20.000000', 'temperatura', 212.0000, 'ºC'),
	(46316, 111, '2015-02-01 00:51:21.000000', 'temperatura', 263.0000, 'ºC'),
	(46317, 111, '2015-02-01 00:51:22.000000', 'temperatura', 679.0000, 'ºC'),
	(46318, 111, '2015-02-01 00:51:23.000000', 'temperatura', 208.0000, 'ºC'),
	(46319, 111, '2015-02-01 00:51:24.000000', 'temperatura', 203.0000, 'ºC'),
	(46320, 111, '2015-02-01 00:51:25.000000', 'temperatura', 393.0000, 'ºC'),
	(46321, 111, '2015-02-01 00:51:26.000000', 'temperatura', 154.0000, 'ºC'),
	(46322, 111, '2015-02-01 00:51:27.000000', 'temperatura', 793.0000, 'ºC'),
	(46323, 111, '2015-02-01 00:51:28.000000', 'temperatura', 1105.0000, 'ºC'),
	(46324, 111, '2015-02-01 00:51:29.000000', 'temperatura', 745.0000, 'ºC'),
	(46325, 111, '2015-02-01 00:51:30.000000', 'temperatura', 412.0000, 'ºC'),
	(46326, 111, '2015-02-01 00:51:31.000000', 'temperatura', 1025.0000, 'ºC'),
	(46327, 111, '2015-02-01 00:51:32.000000', 'temperatura', 288.0000, 'ºC'),
	(46328, 111, '2015-02-01 00:51:33.000000', 'temperatura', 766.0000, 'ºC'),
	(46329, 111, '2015-02-01 00:51:34.000000', 'temperatura', 566.0000, 'ºC'),
	(46330, 111, '2015-02-01 00:51:35.000000', 'temperatura', 532.0000, 'ºC'),
	(46331, 111, '2015-02-01 00:51:36.000000', 'temperatura', 965.0000, 'ºC'),
	(46332, 111, '2015-02-01 00:51:37.000000', 'temperatura', 827.0000, 'ºC'),
	(46333, 111, '2015-02-01 00:51:38.000000', 'temperatura', 41.0000, 'ºC'),
	(46334, 111, '2015-02-01 00:51:39.000000', 'temperatura', 124.0000, 'ºC'),
	(46335, 111, '2015-02-01 00:51:40.000000', 'temperatura', 496.0000, 'ºC'),
	(46336, 111, '2015-02-01 00:51:41.000000', 'temperatura', 910.0000, 'ºC'),
	(46337, 111, '2015-02-01 00:51:42.000000', 'temperatura', 664.0000, 'ºC'),
	(46338, 111, '2015-02-01 00:51:43.000000', 'temperatura', 588.0000, 'ºC'),
	(46339, 111, '2015-02-01 00:51:44.000000', 'temperatura', 949.0000, 'ºC'),
	(46340, 111, '2015-02-01 00:51:45.000000', 'temperatura', 583.0000, 'ºC'),
	(46341, 111, '2015-02-01 00:51:46.000000', 'temperatura', 68.0000, 'ºC'),
	(46342, 111, '2015-02-01 00:51:47.000000', 'temperatura', 991.0000, 'ºC'),
	(46343, 111, '2015-02-01 00:51:48.000000', 'temperatura', 1151.0000, 'ºC'),
	(46344, 111, '2015-02-01 00:51:49.000000', 'temperatura', 382.0000, 'ºC'),
	(46345, 111, '2015-02-01 00:51:50.000000', 'temperatura', 860.0000, 'ºC'),
	(46346, 111, '2015-02-01 00:51:51.000000', 'temperatura', 753.0000, 'ºC'),
	(46347, 111, '2015-02-01 00:51:52.000000', 'temperatura', 1186.0000, 'ºC'),
	(46348, 111, '2015-02-01 00:51:53.000000', 'temperatura', 71.0000, 'ºC'),
	(46349, 111, '2015-02-01 00:51:54.000000', 'temperatura', 396.0000, 'ºC'),
	(46350, 111, '2015-02-01 00:51:55.000000', 'temperatura', 568.0000, 'ºC'),
	(46351, 111, '2015-02-01 00:51:56.000000', 'temperatura', 453.0000, 'ºC'),
	(46352, 111, '2015-02-01 00:51:57.000000', 'temperatura', 560.0000, 'ºC'),
	(46353, 111, '2015-02-01 00:51:58.000000', 'temperatura', 245.0000, 'ºC'),
	(46354, 111, '2015-02-01 00:51:59.000000', 'temperatura', 742.0000, 'ºC'),
	(46355, 111, '2015-02-01 00:52:00.000000', 'temperatura', 576.0000, 'ºC'),
	(46356, 111, '2015-02-01 00:52:01.000000', 'temperatura', 653.0000, 'ºC'),
	(46357, 111, '2015-02-01 00:52:02.000000', 'temperatura', 341.0000, 'ºC'),
	(46358, 111, '2015-02-01 00:52:03.000000', 'temperatura', 943.0000, 'ºC'),
	(46359, 111, '2015-02-01 00:52:04.000000', 'temperatura', 96.0000, 'ºC'),
	(46360, 111, '2015-02-01 00:52:05.000000', 'temperatura', 50.0000, 'ºC'),
	(46361, 111, '2015-02-01 00:52:06.000000', 'temperatura', 1164.0000, 'ºC'),
	(46362, 111, '2015-02-01 00:52:07.000000', 'temperatura', 868.0000, 'ºC'),
	(46363, 111, '2015-02-01 00:52:08.000000', 'temperatura', 851.0000, 'ºC'),
	(46364, 111, '2015-02-01 00:52:09.000000', 'temperatura', 449.0000, 'ºC'),
	(46365, 111, '2015-02-01 00:52:10.000000', 'temperatura', 895.0000, 'ºC'),
	(46366, 111, '2015-02-01 00:52:11.000000', 'temperatura', 729.0000, 'ºC'),
	(46367, 111, '2015-02-01 00:52:12.000000', 'temperatura', 961.0000, 'ºC'),
	(46368, 111, '2015-02-01 00:52:13.000000', 'temperatura', 217.0000, 'ºC'),
	(46369, 111, '2015-02-01 00:52:14.000000', 'temperatura', 601.0000, 'ºC'),
	(46370, 111, '2015-02-01 00:52:15.000000', 'temperatura', 1156.0000, 'ºC'),
	(46371, 111, '2015-02-01 00:52:16.000000', 'temperatura', 377.0000, 'ºC'),
	(46372, 111, '2015-02-01 00:52:17.000000', 'temperatura', 816.0000, 'ºC'),
	(46373, 111, '2015-02-01 00:52:18.000000', 'temperatura', 551.0000, 'ºC'),
	(46374, 111, '2015-02-01 00:52:19.000000', 'temperatura', 307.0000, 'ºC'),
	(46375, 111, '2015-02-01 00:52:20.000000', 'temperatura', 1085.0000, 'ºC'),
	(46376, 111, '2015-02-01 00:52:21.000000', 'temperatura', 901.0000, 'ºC'),
	(46377, 111, '2015-02-01 00:52:22.000000', 'temperatura', 53.0000, 'ºC'),
	(46378, 111, '2015-02-01 00:52:23.000000', 'temperatura', 1162.0000, 'ºC'),
	(46379, 111, '2015-02-01 00:52:24.000000', 'temperatura', 853.0000, 'ºC'),
	(46380, 111, '2015-02-01 00:52:25.000000', 'temperatura', 777.0000, 'ºC'),
	(46381, 111, '2015-02-01 00:52:26.000000', 'temperatura', 127.0000, 'ºC'),
	(46382, 111, '2015-02-01 00:52:27.000000', 'temperatura', 704.0000, 'ºC'),
	(46383, 111, '2015-02-01 00:52:28.000000', 'temperatura', 742.0000, 'ºC'),
	(46384, 111, '2015-02-01 00:52:29.000000', 'temperatura', 397.0000, 'ºC'),
	(46385, 111, '2015-02-01 00:52:30.000000', 'temperatura', 962.0000, 'ºC'),
	(46386, 111, '2015-02-01 00:52:31.000000', 'temperatura', 16.0000, 'ºC'),
	(46387, 111, '2015-02-01 00:52:32.000000', 'temperatura', 797.0000, 'ºC'),
	(46388, 111, '2015-02-01 00:52:33.000000', 'temperatura', 338.0000, 'ºC'),
	(46389, 111, '2015-02-01 00:52:34.000000', 'temperatura', 500.0000, 'ºC'),
	(46390, 111, '2015-02-01 00:52:35.000000', 'temperatura', 286.0000, 'ºC'),
	(46391, 111, '2015-02-01 00:52:36.000000', 'temperatura', 1129.0000, 'ºC'),
	(46392, 111, '2015-02-01 00:52:37.000000', 'temperatura', 1187.0000, 'ºC'),
	(46393, 111, '2015-02-01 00:52:38.000000', 'temperatura', 149.0000, 'ºC'),
	(46394, 111, '2015-02-01 00:52:39.000000', 'temperatura', 784.0000, 'ºC'),
	(46395, 111, '2015-02-01 00:52:40.000000', 'temperatura', 1073.0000, 'ºC'),
	(46396, 111, '2015-02-01 00:52:41.000000', 'temperatura', 614.0000, 'ºC'),
	(46397, 111, '2015-02-01 00:52:42.000000', 'temperatura', 1051.0000, 'ºC'),
	(46398, 111, '2015-02-01 00:52:43.000000', 'temperatura', 1014.0000, 'ºC'),
	(46399, 111, '2015-02-01 00:52:44.000000', 'temperatura', 715.0000, 'ºC'),
	(46400, 111, '2015-02-01 00:52:45.000000', 'temperatura', 537.0000, 'ºC'),
	(46401, 111, '2015-02-01 00:52:46.000000', 'temperatura', 539.0000, 'ºC'),
	(46402, 111, '2015-02-01 00:52:47.000000', 'temperatura', 1086.0000, 'ºC'),
	(46403, 111, '2015-02-01 00:52:48.000000', 'temperatura', 211.0000, 'ºC'),
	(46404, 111, '2015-02-01 00:52:49.000000', 'temperatura', 200.0000, 'ºC'),
	(46405, 111, '2015-02-01 00:52:50.000000', 'temperatura', 366.0000, 'ºC'),
	(46406, 111, '2015-02-01 00:52:51.000000', 'temperatura', 30.0000, 'ºC'),
	(46407, 111, '2015-02-01 00:52:52.000000', 'temperatura', 253.0000, 'ºC'),
	(46408, 111, '2015-02-01 00:52:53.000000', 'temperatura', 1174.0000, 'ºC'),
	(46409, 111, '2015-02-01 00:52:54.000000', 'temperatura', 313.0000, 'ºC'),
	(46410, 111, '2015-02-01 00:52:55.000000', 'temperatura', 442.0000, 'ºC'),
	(46411, 111, '2015-02-01 00:52:56.000000', 'temperatura', 71.0000, 'ºC'),
	(46412, 111, '2015-02-01 00:52:57.000000', 'temperatura', 230.0000, 'ºC'),
	(46413, 111, '2015-02-01 00:52:58.000000', 'temperatura', 938.0000, 'ºC'),
	(46414, 111, '2015-02-01 00:52:59.000000', 'temperatura', 402.0000, 'ºC'),
	(46415, 111, '2015-02-01 00:53:00.000000', 'temperatura', 395.0000, 'ºC'),
	(46416, 111, '2015-02-01 00:53:01.000000', 'temperatura', 769.0000, 'ºC'),
	(46417, 111, '2015-02-01 00:53:02.000000', 'temperatura', 261.0000, 'ºC'),
	(46418, 111, '2015-02-01 00:53:03.000000', 'temperatura', 198.0000, 'ºC'),
	(46419, 111, '2015-02-01 00:53:04.000000', 'temperatura', 209.0000, 'ºC'),
	(46420, 111, '2015-02-01 00:53:05.000000', 'temperatura', 452.0000, 'ºC'),
	(46421, 111, '2015-02-01 00:53:06.000000', 'temperatura', 431.0000, 'ºC'),
	(46422, 111, '2015-02-01 00:53:07.000000', 'temperatura', 803.0000, 'ºC'),
	(46423, 111, '2015-02-01 00:53:08.000000', 'temperatura', 319.0000, 'ºC'),
	(46424, 111, '2015-02-01 00:53:09.000000', 'temperatura', 389.0000, 'ºC'),
	(46425, 111, '2015-02-01 00:53:10.000000', 'temperatura', 990.0000, 'ºC'),
	(46426, 111, '2015-02-01 00:53:11.000000', 'temperatura', 181.0000, 'ºC'),
	(46427, 111, '2015-02-01 00:53:12.000000', 'temperatura', 334.0000, 'ºC'),
	(46428, 111, '2015-02-01 00:53:13.000000', 'temperatura', 1131.0000, 'ºC'),
	(46429, 111, '2015-02-01 00:53:14.000000', 'temperatura', 1051.0000, 'ºC'),
	(46430, 111, '2015-02-01 00:53:15.000000', 'temperatura', 664.0000, 'ºC'),
	(46431, 111, '2015-02-01 00:53:16.000000', 'temperatura', 169.0000, 'ºC'),
	(46432, 111, '2015-02-01 00:53:17.000000', 'temperatura', 51.0000, 'ºC'),
	(46433, 111, '2015-02-01 00:53:18.000000', 'temperatura', 947.0000, 'ºC'),
	(46434, 111, '2015-02-01 00:53:19.000000', 'temperatura', 985.0000, 'ºC'),
	(46435, 111, '2015-02-01 00:53:20.000000', 'temperatura', 885.0000, 'ºC'),
	(46436, 111, '2015-02-01 00:53:21.000000', 'temperatura', 271.0000, 'ºC'),
	(46437, 111, '2015-02-01 00:53:22.000000', 'temperatura', 1098.0000, 'ºC'),
	(46438, 111, '2015-02-01 00:53:23.000000', 'temperatura', 1080.0000, 'ºC'),
	(46439, 111, '2015-02-01 00:53:24.000000', 'temperatura', 906.0000, 'ºC'),
	(46440, 111, '2015-02-01 00:53:25.000000', 'temperatura', 91.0000, 'ºC'),
	(46441, 111, '2015-02-01 00:53:26.000000', 'temperatura', 138.0000, 'ºC'),
	(46442, 111, '2015-02-01 00:53:27.000000', 'temperatura', 419.0000, 'ºC'),
	(46443, 111, '2015-02-01 00:53:28.000000', 'temperatura', 479.0000, 'ºC'),
	(46444, 111, '2015-02-01 00:53:29.000000', 'temperatura', 1139.0000, 'ºC'),
	(46445, 111, '2015-02-01 00:53:30.000000', 'temperatura', 659.0000, 'ºC'),
	(46446, 111, '2015-02-01 00:53:31.000000', 'temperatura', 1078.0000, 'ºC'),
	(46447, 111, '2015-02-01 00:53:32.000000', 'temperatura', 1014.0000, 'ºC'),
	(46448, 111, '2015-02-01 00:53:33.000000', 'temperatura', 638.0000, 'ºC'),
	(46449, 111, '2015-02-01 00:53:34.000000', 'temperatura', 149.0000, 'ºC'),
	(46450, 111, '2015-02-01 00:53:35.000000', 'temperatura', 30.0000, 'ºC'),
	(46451, 111, '2015-02-01 00:53:36.000000', 'temperatura', 905.0000, 'ºC'),
	(46452, 111, '2015-02-01 00:53:37.000000', 'temperatura', 834.0000, 'ºC'),
	(46453, 111, '2015-02-01 00:53:38.000000', 'temperatura', 255.0000, 'ºC'),
	(46454, 111, '2015-02-01 00:53:39.000000', 'temperatura', 1176.0000, 'ºC'),
	(46455, 111, '2015-02-01 00:53:40.000000', 'temperatura', 315.0000, 'ºC'),
	(46456, 111, '2015-02-01 00:53:41.000000', 'temperatura', 448.0000, 'ºC'),
	(46457, 111, '2015-02-01 00:53:42.000000', 'temperatura', 94.0000, 'ºC'),
	(46458, 111, '2015-02-01 00:53:43.000000', 'temperatura', 326.0000, 'ºC'),
	(46459, 111, '2015-02-01 00:53:44.000000', 'temperatura', 149.0000, 'ºC'),
	(46460, 111, '2015-02-01 00:53:45.000000', 'temperatura', 967.0000, 'ºC'),
	(46461, 111, '2015-02-01 00:53:46.000000', 'temperatura', 787.0000, 'ºC'),
	(46462, 111, '2015-02-01 00:53:47.000000', 'temperatura', 1036.0000, 'ºC'),
	(46463, 111, '2015-02-01 00:53:48.000000', 'temperatura', 421.0000, 'ºC'),
	(46464, 111, '2015-02-01 00:53:49.000000', 'temperatura', 197.0000, 'ºC'),
	(46465, 111, '2015-02-01 00:53:50.000000', 'temperatura', 921.0000, 'ºC'),
	(46466, 111, '2015-02-01 00:53:51.000000', 'temperatura', 417.0000, 'ºC'),
	(46467, 111, '2015-02-01 00:53:52.000000', 'temperatura', 521.0000, 'ºC'),
	(46468, 111, '2015-02-01 00:53:53.000000', 'temperatura', 157.0000, 'ºC'),
	(46469, 111, '2015-02-01 00:53:54.000000', 'temperatura', 419.0000, 'ºC'),
	(46470, 111, '2015-02-01 00:53:55.000000', 'temperatura', 426.0000, 'ºC'),
	(46471, 111, '2015-02-01 00:53:56.000000', 'temperatura', 873.0000, 'ºC'),
	(46472, 111, '2015-02-01 00:53:57.000000', 'temperatura', 687.0000, 'ºC'),
	(46473, 111, '2015-02-01 00:53:58.000000', 'temperatura', 817.0000, 'ºC'),
	(46474, 111, '2015-02-01 00:53:59.000000', 'temperatura', 826.0000, 'ºC'),
	(46475, 111, '2015-02-01 00:54:00.000000', 'temperatura', 480.0000, 'ºC'),
	(46476, 111, '2015-02-01 00:54:01.000000', 'temperatura', 1122.0000, 'ºC'),
	(46477, 111, '2015-02-01 00:54:02.000000', 'temperatura', 572.0000, 'ºC'),
	(46478, 111, '2015-02-01 00:54:03.000000', 'temperatura', 691.0000, 'ºC'),
	(46479, 111, '2015-02-01 00:54:04.000000', 'temperatura', 542.0000, 'ºC'),
	(46480, 111, '2015-02-01 00:54:05.000000', 'temperatura', 638.0000, 'ºC'),
	(46481, 111, '2015-02-01 00:54:06.000000', 'temperatura', 366.0000, 'ºC'),
	(46482, 111, '2015-02-01 00:54:07.000000', 'temperatura', 1113.0000, 'ºC'),
	(46483, 111, '2015-02-01 00:54:08.000000', 'temperatura', 869.0000, 'ºC'),
	(46484, 111, '2015-02-01 00:54:09.000000', 'temperatura', 1006.0000, 'ºC'),
	(46485, 111, '2015-02-01 00:54:10.000000', 'temperatura', 24.0000, 'ºC'),
	(46486, 111, '2015-02-01 00:54:11.000000', 'temperatura', 702.0000, 'ºC'),
	(46487, 111, '2015-02-01 00:54:12.000000', 'temperatura', 1040.0000, 'ºC'),
	(46488, 111, '2015-02-01 00:54:13.000000', 'temperatura', 692.0000, 'ºC'),
	(46489, 111, '2015-02-01 00:54:14.000000', 'temperatura', 341.0000, 'ºC'),
	(46490, 111, '2015-02-01 00:54:15.000000', 'temperatura', 831.0000, 'ºC'),
	(46491, 111, '2015-02-01 00:54:16.000000', 'temperatura', 730.0000, 'ºC'),
	(46492, 111, '2015-02-01 00:54:17.000000', 'temperatura', 1158.0000, 'ºC'),
	(46493, 111, '2015-02-01 00:54:18.000000', 'temperatura', 1.0000, 'ºC'),
	(46494, 111, '2015-02-01 00:54:19.000000', 'temperatura', 131.0000, 'ºC'),
	(46495, 111, '2015-02-01 00:54:20.000000', 'temperatura', 651.0000, 'ºC'),
	(46496, 111, '2015-02-01 00:54:21.000000', 'temperatura', 463.0000, 'ºC'),
	(46497, 111, '2015-02-01 00:54:22.000000', 'temperatura', 361.0000, 'ºC'),
	(46498, 111, '2015-02-01 00:54:23.000000', 'temperatura', 419.0000, 'ºC'),
	(46499, 111, '2015-02-01 00:54:24.000000', 'temperatura', 1011.0000, 'ºC'),
	(46500, 111, '2015-02-01 00:54:25.000000', 'temperatura', 200.0000, 'ºC'),
	(46501, 111, '2015-02-01 00:54:26.000000', 'temperatura', 367.0000, 'ºC'),
	(46502, 111, '2015-02-01 00:54:27.000000', 'temperatura', 36.0000, 'ºC'),
	(46503, 111, '2015-02-01 00:54:28.000000', 'temperatura', 281.0000, 'ºC'),
	(46504, 111, '2015-02-01 00:54:29.000000', 'temperatura', 94.0000, 'ºC'),
	(46505, 111, '2015-02-01 00:54:30.000000', 'temperatura', 831.0000, 'ºC'),
	(46506, 111, '2015-02-01 00:54:31.000000', 'temperatura', 272.0000, 'ºC'),
	(46507, 111, '2015-02-01 00:54:32.000000', 'temperatura', 69.0000, 'ºC'),
	(46508, 111, '2015-02-01 00:54:33.000000', 'temperatura', 730.0000, 'ºC'),
	(46509, 111, '2015-02-01 00:54:34.000000', 'temperatura', 1044.0000, 'ºC'),
	(46510, 111, '2015-02-01 00:54:35.000000', 'temperatura', 628.0000, 'ºC'),
	(46511, 111, '2015-02-01 00:54:36.000000', 'temperatura', 9.0000, 'ºC'),
	(46512, 111, '2015-02-01 00:54:37.000000', 'temperatura', 563.0000, 'ºC'),
	(46513, 111, '2015-02-01 00:54:38.000000', 'temperatura', 388.0000, 'ºC'),
	(46514, 111, '2015-02-01 00:54:39.000000', 'temperatura', 252.0000, 'ºC'),
	(46515, 111, '2015-02-01 00:54:40.000000', 'temperatura', 96.0000, 'ºC'),
	(46516, 111, '2015-02-01 00:54:41.000000', 'temperatura', 924.0000, 'ºC'),
	(46517, 111, '2015-02-01 00:54:42.000000', 'temperatura', 732.0000, 'ºC'),
	(46518, 111, '2015-02-01 00:54:43.000000', 'temperatura', 889.0000, 'ºC'),
	(46519, 111, '2015-02-01 00:54:44.000000', 'temperatura', 1051.0000, 'ºC'),
	(46520, 111, '2015-02-01 00:54:45.000000', 'temperatura', 186.0000, 'ºC'),
	(46521, 111, '2015-02-01 00:54:46.000000', 'temperatura', 180.0000, 'ºC'),
	(46522, 111, '2015-02-01 00:54:47.000000', 'temperatura', 342.0000, 'ºC'),
	(46523, 111, '2015-02-01 00:54:48.000000', 'temperatura', 1169.0000, 'ºC'),
	(46524, 111, '2015-02-01 00:54:49.000000', 'temperatura', 22.0000, 'ºC'),
	(46525, 111, '2015-02-01 00:54:50.000000', 'temperatura', 202.0000, 'ºC'),
	(46526, 111, '2015-02-01 00:54:51.000000', 'temperatura', 945.0000, 'ºC'),
	(46527, 111, '2015-02-01 00:54:52.000000', 'temperatura', 520.0000, 'ºC'),
	(46528, 111, '2015-02-01 00:54:53.000000', 'temperatura', 964.0000, 'ºC'),
	(46529, 111, '2015-02-01 00:54:54.000000', 'temperatura', 861.0000, 'ºC'),
	(46530, 111, '2015-02-01 00:54:55.000000', 'temperatura', 213.0000, 'ºC'),
	(46531, 111, '2015-02-01 00:54:56.000000', 'temperatura', 882.0000, 'ºC'),
	(46532, 111, '2015-02-01 00:54:57.000000', 'temperatura', 174.0000, 'ºC'),
	(46533, 111, '2015-02-01 00:54:58.000000', 'temperatura', 623.0000, 'ºC'),
	(46534, 111, '2015-02-01 00:54:59.000000', 'temperatura', 192.0000, 'ºC'),
	(46535, 111, '2015-02-01 00:55:00.000000', 'temperatura', 293.0000, 'ºC'),
	(46536, 111, '2015-02-01 00:55:01.000000', 'temperatura', 888.0000, 'ºC'),
	(46537, 111, '2015-02-01 00:55:02.000000', 'temperatura', 1164.0000, 'ºC'),
	(46538, 111, '2015-02-01 00:55:03.000000', 'temperatura', 757.0000, 'ºC'),
	(46539, 111, '2015-02-01 00:55:04.000000', 'temperatura', 294.0000, 'ºC'),
	(46540, 111, '2015-02-01 00:55:05.000000', 'temperatura', 400.0000, 'ºC'),
	(46541, 111, '2015-02-01 00:55:06.000000', 'temperatura', 1119.0000, 'ºC'),
	(46542, 111, '2015-02-01 00:55:07.000000', 'temperatura', 795.0000, 'ºC'),
	(46543, 111, '2015-02-01 00:55:08.000000', 'temperatura', 618.0000, 'ºC'),
	(46544, 111, '2015-02-01 00:55:09.000000', 'temperatura', 706.0000, 'ºC'),
	(46545, 111, '2015-02-01 00:55:10.000000', 'temperatura', 477.0000, 'ºC'),
	(46546, 111, '2015-02-01 00:55:11.000000', 'temperatura', 267.0000, 'ºC'),
	(46547, 111, '2015-02-01 00:55:12.000000', 'temperatura', 1103.0000, 'ºC'),
	(46548, 111, '2015-02-01 00:55:13.000000', 'temperatura', 1117.0000, 'ºC'),
	(46549, 111, '2015-02-01 00:55:14.000000', 'temperatura', 1075.0000, 'ºC'),
	(46550, 111, '2015-02-01 00:55:15.000000', 'temperatura', 825.0000, 'ºC'),
	(46551, 111, '2015-02-01 00:55:16.000000', 'temperatura', 899.0000, 'ºC'),
	(46552, 111, '2015-02-01 00:55:17.000000', 'temperatura', 819.0000, 'ºC'),
	(46553, 111, '2015-02-01 00:55:18.000000', 'temperatura', 202.0000, 'ºC'),
	(46554, 111, '2015-02-01 00:55:19.000000', 'temperatura', 953.0000, 'ºC'),
	(46555, 111, '2015-02-01 00:55:20.000000', 'temperatura', 559.0000, 'ºC'),
	(46556, 111, '2015-02-01 00:55:21.000000', 'temperatura', 1137.0000, 'ºC'),
	(46557, 111, '2015-02-01 00:55:22.000000', 'temperatura', 407.0000, 'ºC'),
	(46558, 111, '2015-02-01 00:55:23.000000', 'temperatura', 1027.0000, 'ºC'),
	(46559, 111, '2015-02-01 00:55:24.000000', 'temperatura', 312.0000, 'ºC'),
	(46560, 111, '2015-02-01 00:55:25.000000', 'temperatura', 879.0000, 'ºC'),
	(46561, 111, '2015-02-01 00:55:26.000000', 'temperatura', 1058.0000, 'ºC'),
	(46562, 111, '2015-02-01 00:55:27.000000', 'temperatura', 257.0000, 'ºC'),
	(46563, 111, '2015-02-01 00:55:28.000000', 'temperatura', 510.0000, 'ºC'),
	(46564, 111, '2015-02-01 00:55:29.000000', 'temperatura', 578.0000, 'ºC'),
	(46565, 111, '2015-02-01 00:55:30.000000', 'temperatura', 163.0000, 'ºC'),
	(46566, 111, '2015-02-01 00:55:31.000000', 'temperatura', 283.0000, 'ºC'),
	(46567, 111, '2015-02-01 00:55:32.000000', 'temperatura', 923.0000, 'ºC'),
	(46568, 111, '2015-02-01 00:55:33.000000', 'temperatura', 167.0000, 'ºC'),
	(46569, 111, '2015-02-01 00:55:34.000000', 'temperatura', 468.0000, 'ºC'),
	(46570, 111, '2015-02-01 00:55:35.000000', 'temperatura', 640.0000, 'ºC'),
	(46571, 111, '2015-02-01 00:55:36.000000', 'temperatura', 595.0000, 'ºC'),
	(46572, 111, '2015-02-01 00:55:37.000000', 'temperatura', 1058.0000, 'ºC'),
	(46573, 111, '2015-02-01 00:55:38.000000', 'temperatura', 1102.0000, 'ºC'),
	(46574, 111, '2015-02-01 00:55:39.000000', 'temperatura', 1140.0000, 'ºC'),
	(46575, 111, '2015-02-01 00:55:40.000000', 'temperatura', 1193.0000, 'ºC'),
	(46576, 111, '2015-02-01 00:55:41.000000', 'temperatura', 146.0000, 'ºC'),
	(46577, 111, '2015-02-01 00:55:42.000000', 'temperatura', 753.0000, 'ºC'),
	(46578, 111, '2015-02-01 00:55:43.000000', 'temperatura', 924.0000, 'ºC'),
	(46579, 111, '2015-02-01 00:55:44.000000', 'temperatura', 1165.0000, 'ºC'),
	(46580, 111, '2015-02-01 00:55:45.000000', 'temperatura', 651.0000, 'ºC'),
	(46581, 111, '2015-02-01 00:55:46.000000', 'temperatura', 961.0000, 'ºC'),
	(46582, 111, '2015-02-01 00:55:47.000000', 'temperatura', 454.0000, 'ºC'),
	(46583, 111, '2015-02-01 00:55:48.000000', 'temperatura', 586.0000, 'ºC'),
	(46584, 111, '2015-02-01 00:55:49.000000', 'temperatura', 369.0000, 'ºC'),
	(46585, 111, '2015-02-01 00:55:50.000000', 'temperatura', 88.0000, 'ºC'),
	(46586, 111, '2015-02-01 00:55:51.000000', 'temperatura', 532.0000, 'ºC'),
	(46587, 111, '2015-02-01 00:55:52.000000', 'temperatura', 1197.0000, 'ºC'),
	(46588, 111, '2015-02-01 00:55:53.000000', 'temperatura', 788.0000, 'ºC'),
	(46589, 111, '2015-02-01 00:55:54.000000', 'temperatura', 349.0000, 'ºC'),
	(46590, 111, '2015-02-01 00:55:55.000000', 'temperatura', 583.0000, 'ºC'),
	(46591, 111, '2015-02-01 00:55:56.000000', 'temperatura', 669.0000, 'ºC'),
	(46592, 111, '2015-02-01 00:55:57.000000', 'temperatura', 394.0000, 'ºC'),
	(46593, 111, '2015-02-01 00:55:58.000000', 'temperatura', 1166.0000, 'ºC'),
	(46594, 111, '2015-02-01 00:55:59.000000', 'temperatura', 1050.0000, 'ºC'),
	(46595, 111, '2015-02-01 00:56:00.000000', 'temperatura', 549.0000, 'ºC'),
	(46596, 111, '2015-02-01 00:56:01.000000', 'temperatura', 799.0000, 'ºC'),
	(46597, 111, '2015-02-01 00:56:02.000000', 'temperatura', 1145.0000, 'ºC'),
	(46598, 111, '2015-02-01 00:56:03.000000', 'temperatura', 931.0000, 'ºC'),
	(46599, 111, '2015-02-01 00:56:04.000000', 'temperatura', 18.0000, 'ºC'),
	(46600, 111, '2015-02-01 00:56:05.000000', 'temperatura', 899.0000, 'ºC'),
	(46601, 111, '2015-02-01 00:56:06.000000', 'temperatura', 841.0000, 'ºC'),
	(46602, 111, '2015-02-01 00:56:07.000000', 'temperatura', 307.0000, 'ºC'),
	(46603, 111, '2015-02-01 00:56:08.000000', 'temperatura', 215.0000, 'ºC'),
	(46604, 111, '2015-02-01 00:56:09.000000', 'temperatura', 153.0000, 'ºC'),
	(46605, 111, '2015-02-01 00:56:10.000000', 'temperatura', 122.0000, 'ºC'),
	(46606, 111, '2015-02-01 00:56:11.000000', 'temperatura', 153.0000, 'ºC'),
	(46607, 111, '2015-02-01 00:56:12.000000', 'temperatura', 397.0000, 'ºC'),
	(46608, 111, '2015-02-01 00:56:13.000000', 'temperatura', 327.0000, 'ºC'),
	(46609, 111, '2015-02-01 00:56:14.000000', 'temperatura', 444.0000, 'ºC'),
	(46610, 111, '2015-02-01 00:56:15.000000', 'temperatura', 39.0000, 'ºC'),
	(46611, 111, '2015-02-01 00:56:16.000000', 'temperatura', 63.0000, 'ºC'),
	(46612, 111, '2015-02-01 00:56:17.000000', 'temperatura', 197.0000, 'ºC'),
	(46613, 111, '2015-02-01 00:56:18.000000', 'temperatura', 800.0000, 'ºC'),
	(46614, 111, '2015-02-01 00:56:19.000000', 'temperatura', 1007.0000, 'ºC'),
	(46615, 111, '2015-02-01 00:56:20.000000', 'temperatura', 237.0000, 'ºC'),
	(46616, 111, '2015-02-01 00:56:21.000000', 'temperatura', 565.0000, 'ºC'),
	(46617, 111, '2015-02-01 00:56:22.000000', 'temperatura', 913.0000, 'ºC'),
	(46618, 111, '2015-02-01 00:56:23.000000', 'temperatura', 470.0000, 'ºC'),
	(46619, 111, '2015-02-01 00:56:24.000000', 'temperatura', 814.0000, 'ºC'),
	(46620, 111, '2015-02-01 00:56:25.000000', 'temperatura', 257.0000, 'ºC'),
	(46621, 111, '2015-02-01 00:56:26.000000', 'temperatura', 46.0000, 'ºC'),
	(46622, 111, '2015-02-01 00:56:27.000000', 'temperatura', 660.0000, 'ºC'),
	(46623, 111, '2015-02-01 00:56:28.000000', 'temperatura', 762.0000, 'ºC'),
	(46624, 111, '2015-02-01 00:56:29.000000', 'temperatura', 631.0000, 'ºC'),
	(46625, 111, '2015-02-01 00:56:30.000000', 'temperatura', 868.0000, 'ºC'),
	(46626, 111, '2015-02-01 00:56:31.000000', 'temperatura', 48.0000, 'ºC'),
	(46627, 111, '2015-02-01 00:56:32.000000', 'temperatura', 35.0000, 'ºC'),
	(46628, 111, '2015-02-01 00:56:33.000000', 'temperatura', 33.0000, 'ºC'),
	(46629, 111, '2015-02-01 00:56:34.000000', 'temperatura', 60.0000, 'ºC'),
	(46630, 111, '2015-02-01 00:56:35.000000', 'temperatura', 202.0000, 'ºC'),
	(46631, 111, '2015-02-01 00:56:36.000000', 'temperatura', 831.0000, 'ºC'),
	(46632, 111, '2015-02-01 00:56:37.000000', 'temperatura', 1149.0000, 'ºC'),
	(46633, 111, '2015-02-01 00:56:38.000000', 'temperatura', 850.0000, 'ºC'),
	(46634, 111, '2015-02-01 00:56:39.000000', 'temperatura', 807.0000, 'ºC'),
	(46635, 111, '2015-02-01 00:56:40.000000', 'temperatura', 286.0000, 'ºC'),
	(46636, 111, '2015-02-01 00:56:41.000000', 'temperatura', 208.0000, 'ºC'),
	(46637, 111, '2015-02-01 00:56:42.000000', 'temperatura', 182.0000, 'ºC'),
	(46638, 111, '2015-02-01 00:56:43.000000', 'temperatura', 286.0000, 'ºC'),
	(46639, 111, '2015-02-01 00:56:44.000000', 'temperatura', 886.0000, 'ºC'),
	(46640, 111, '2015-02-01 00:56:45.000000', 'temperatura', 1170.0000, 'ºC'),
	(46641, 111, '2015-02-01 00:56:46.000000', 'temperatura', 795.0000, 'ºC'),
	(46642, 111, '2015-02-01 00:56:47.000000', 'temperatura', 465.0000, 'ºC'),
	(46643, 111, '2015-02-01 00:56:48.000000', 'temperatura', 1142.0000, 'ºC'),
	(46644, 111, '2015-02-01 00:56:49.000000', 'temperatura', 714.0000, 'ºC'),
	(46645, 111, '2015-02-01 00:56:50.000000', 'temperatura', 145.0000, 'ºC'),
	(46646, 111, '2015-02-01 00:56:51.000000', 'temperatura', 985.0000, 'ºC'),
	(46647, 111, '2015-02-01 00:56:52.000000', 'temperatura', 887.0000, 'ºC'),
	(46648, 111, '2015-02-01 00:56:53.000000', 'temperatura', 283.0000, 'ºC'),
	(46649, 111, '2015-02-01 00:56:54.000000', 'temperatura', 1154.0000, 'ºC'),
	(46650, 111, '2015-02-01 00:56:55.000000', 'temperatura', 120.0000, 'ºC'),
	(46651, 111, '2015-02-01 00:56:56.000000', 'temperatura', 741.0000, 'ºC'),
	(46652, 111, '2015-02-01 00:56:57.000000', 'temperatura', 944.0000, 'ºC'),
	(46653, 111, '2015-02-01 00:56:58.000000', 'temperatura', 100.0000, 'ºC'),
	(46654, 111, '2015-02-01 00:56:59.000000', 'temperatura', 65.0000, 'ºC'),
	(46655, 111, '2015-02-01 00:57:00.000000', 'temperatura', 27.0000, 'ºC'),
	(46656, 111, '2015-02-01 00:57:01.000000', 'temperatura', 1141.0000, 'ºC'),
	(46657, 111, '2015-02-01 00:57:02.000000', 'temperatura', 824.0000, 'ºC'),
	(46658, 111, '2015-02-01 00:57:03.000000', 'temperatura', 698.0000, 'ºC'),
	(46659, 111, '2015-02-01 00:57:04.000000', 'temperatura', 1020.0000, 'ºC'),
	(46660, 111, '2015-02-01 00:57:05.000000', 'temperatura', 604.0000, 'ºC'),
	(46661, 111, '2015-02-01 00:57:06.000000', 'temperatura', 1162.0000, 'ºC'),
	(46662, 111, '2015-02-01 00:57:07.000000', 'temperatura', 396.0000, 'ºC'),
	(46663, 111, '2015-02-01 00:57:08.000000', 'temperatura', 896.0000, 'ºC'),
	(46664, 111, '2015-02-01 00:57:09.000000', 'temperatura', 892.0000, 'ºC'),
	(46665, 111, '2015-02-01 00:57:10.000000', 'temperatura', 572.0000, 'ºC'),
	(46666, 111, '2015-02-01 00:57:11.000000', 'temperatura', 183.0000, 'ºC'),
	(46667, 111, '2015-02-01 00:57:12.000000', 'temperatura', 402.0000, 'ºC'),
	(46668, 111, '2015-02-01 00:57:13.000000', 'temperatura', 262.0000, 'ºC'),
	(46669, 111, '2015-02-01 00:57:14.000000', 'temperatura', 104.0000, 'ºC'),
	(46670, 111, '2015-02-01 00:57:15.000000', 'temperatura', 935.0000, 'ºC'),
	(46671, 111, '2015-02-01 00:57:16.000000', 'temperatura', 762.0000, 'ºC'),
	(46672, 111, '2015-02-01 00:57:17.000000', 'temperatura', 1005.0000, 'ºC'),
	(46673, 111, '2015-02-01 00:57:18.000000', 'temperatura', 340.0000, 'ºC'),
	(46674, 111, '2015-02-01 00:57:19.000000', 'temperatura', 1084.0000, 'ºC'),
	(46675, 111, '2015-02-01 00:57:20.000000', 'temperatura', 803.0000, 'ºC'),
	(46676, 111, '2015-02-01 00:57:21.000000', 'temperatura', 763.0000, 'ºC'),
	(46677, 111, '2015-02-01 00:57:22.000000', 'temperatura', 206.0000, 'ºC'),
	(46678, 111, '2015-02-01 00:57:23.000000', 'temperatura', 1143.0000, 'ºC'),
	(46679, 111, '2015-02-01 00:57:24.000000', 'temperatura', 298.0000, 'ºC'),
	(46680, 111, '2015-02-01 00:57:25.000000', 'temperatura', 461.0000, 'ºC'),
	(46681, 111, '2015-02-01 00:57:26.000000', 'temperatura', 211.0000, 'ºC'),
	(46682, 111, '2015-02-01 00:57:27.000000', 'temperatura', 872.0000, 'ºC'),
	(46683, 111, '2015-02-01 00:57:28.000000', 'temperatura', 128.0000, 'ºC'),
	(46684, 111, '2015-02-01 00:57:29.000000', 'temperatura', 426.0000, 'ºC'),
	(46685, 111, '2015-02-01 00:57:30.000000', 'temperatura', 545.0000, 'ºC'),
	(46686, 111, '2015-02-01 00:57:31.000000', 'temperatura', 249.0000, 'ºC'),
	(46687, 111, '2015-02-01 00:57:32.000000', 'temperatura', 812.0000, 'ºC'),
	(46688, 111, '2015-02-01 00:57:33.000000', 'temperatura', 911.0000, 'ºC'),
	(46689, 111, '2015-02-01 00:57:34.000000', 'temperatura', 919.0000, 'ºC'),
	(46690, 111, '2015-02-01 00:57:35.000000', 'temperatura', 662.0000, 'ºC'),
	(46691, 111, '2015-02-01 00:57:36.000000', 'temperatura', 555.0000, 'ºC'),
	(46692, 111, '2015-02-01 00:57:37.000000', 'temperatura', 790.0000, 'ºC'),
	(46693, 111, '2015-02-01 00:57:38.000000', 'temperatura', 1083.0000, 'ºC'),
	(46694, 111, '2015-02-01 00:57:39.000000', 'temperatura', 646.0000, 'ºC'),
	(46695, 111, '2015-02-01 00:57:40.000000', 'temperatura', 1182.0000, 'ºC'),
	(46696, 111, '2015-02-01 00:57:41.000000', 'temperatura', 371.0000, 'ºC'),
	(46697, 111, '2015-02-01 00:57:42.000000', 'temperatura', 712.0000, 'ºC'),
	(46698, 111, '2015-02-01 00:57:43.000000', 'temperatura', 45.0000, 'ºC'),
	(46699, 111, '2015-02-01 00:57:44.000000', 'temperatura', 489.0000, 'ºC'),
	(46700, 111, '2015-02-01 00:57:45.000000', 'temperatura', 1114.0000, 'ºC'),
	(46701, 111, '2015-02-01 00:57:46.000000', 'temperatura', 500.0000, 'ºC'),
	(46702, 111, '2015-02-01 00:57:47.000000', 'temperatura', 360.0000, 'ºC'),
	(46703, 111, '2015-02-01 00:57:48.000000', 'temperatura', 301.0000, 'ºC'),
	(46704, 111, '2015-02-01 00:57:49.000000', 'temperatura', 424.0000, 'ºC'),
	(46705, 111, '2015-02-01 00:57:50.000000', 'temperatura', 18.0000, 'ºC'),
	(46706, 111, '2015-02-01 00:57:51.000000', 'temperatura', 19.0000, 'ºC'),
	(46707, 111, '2015-02-01 00:57:52.000000', 'temperatura', 42.0000, 'ºC'),
	(46708, 111, '2015-02-01 00:57:53.000000', 'temperatura', 153.0000, 'ºC'),
	(46709, 111, '2015-02-01 00:57:54.000000', 'temperatura', 640.0000, 'ºC'),
	(46710, 111, '2015-02-01 00:57:55.000000', 'temperatura', 341.0000, 'ºC'),
	(46711, 111, '2015-02-01 00:57:56.000000', 'temperatura', 986.0000, 'ºC'),
	(46712, 111, '2015-02-01 00:57:57.000000', 'temperatura', 309.0000, 'ºC'),
	(46713, 111, '2015-02-01 00:57:58.000000', 'temperatura', 985.0000, 'ºC'),
	(46714, 111, '2015-02-01 00:57:59.000000', 'temperatura', 401.0000, 'ºC'),
	(46715, 111, '2015-02-01 00:58:00.000000', 'temperatura', 250.0000, 'ºC'),
	(46716, 111, '2015-02-01 00:58:01.000000', 'temperatura', 47.0000, 'ºC'),
	(46717, 111, '2015-02-01 00:58:02.000000', 'temperatura', 684.0000, 'ºC'),
	(46718, 111, '2015-02-01 00:58:03.000000', 'temperatura', 880.0000, 'ºC'),
	(46719, 111, '2015-02-01 00:58:04.000000', 'temperatura', 1151.0000, 'ºC'),
	(46720, 111, '2015-02-01 00:58:05.000000', 'temperatura', 713.0000, 'ºC'),
	(46721, 111, '2015-02-01 00:58:06.000000', 'temperatura', 112.0000, 'ºC'),
	(46722, 111, '2015-02-01 00:58:07.000000', 'temperatura', 821.0000, 'ºC'),
	(46723, 111, '2015-02-01 00:58:08.000000', 'temperatura', 171.0000, 'ºC'),
	(46724, 111, '2015-02-01 00:58:09.000000', 'temperatura', 794.0000, 'ºC'),
	(46725, 111, '2015-02-01 00:58:10.000000', 'temperatura', 1056.0000, 'ºC'),
	(46726, 111, '2015-02-01 00:58:11.000000', 'temperatura', 498.0000, 'ºC'),
	(46727, 111, '2015-02-01 00:58:12.000000', 'temperatura', 522.0000, 'ºC'),
	(46728, 111, '2015-02-01 00:58:13.000000', 'temperatura', 1115.0000, 'ºC'),
	(46729, 111, '2015-02-01 00:58:14.000000', 'temperatura', 412.0000, 'ºC'),
	(46730, 111, '2015-02-01 00:58:15.000000', 'temperatura', 1114.0000, 'ºC'),
	(46731, 111, '2015-02-01 00:58:16.000000', 'temperatura', 734.0000, 'ºC'),
	(46732, 111, '2015-02-01 00:58:17.000000', 'temperatura', 329.0000, 'ºC'),
	(46733, 111, '2015-02-01 00:58:18.000000', 'temperatura', 643.0000, 'ºC'),
	(46734, 111, '2015-02-01 00:58:19.000000', 'temperatura', 1028.0000, 'ºC'),
	(46735, 111, '2015-02-01 00:58:20.000000', 'temperatura', 812.0000, 'ºC'),
	(46736, 111, '2015-02-01 00:58:21.000000', 'temperatura', 975.0000, 'ºC'),
	(46737, 111, '2015-02-01 00:58:22.000000', 'temperatura', 40.0000, 'ºC'),
	(46738, 111, '2015-02-01 00:58:23.000000', 'temperatura', 876.0000, 'ºC'),
	(46739, 111, '2015-02-01 00:58:24.000000', 'temperatura', 661.0000, 'ºC'),
	(46740, 111, '2015-02-01 00:58:25.000000', 'temperatura', 678.0000, 'ºC'),
	(46741, 111, '2015-02-01 00:58:26.000000', 'temperatura', 207.0000, 'ºC'),
	(46742, 111, '2015-02-01 00:58:27.000000', 'temperatura', 203.0000, 'ºC'),
	(46743, 111, '2015-02-01 00:58:28.000000', 'temperatura', 394.0000, 'ºC'),
	(46744, 111, '2015-02-01 00:58:29.000000', 'temperatura', 159.0000, 'ºC'),
	(46745, 111, '2015-02-01 00:58:30.000000', 'temperatura', 815.0000, 'ºC'),
	(46746, 111, '2015-02-01 00:58:31.000000', 'temperatura', 1197.0000, 'ºC'),
	(46747, 111, '2015-02-01 00:58:32.000000', 'temperatura', 1141.0000, 'ºC'),
	(46748, 111, '2015-02-01 00:58:33.000000', 'temperatura', 917.0000, 'ºC'),
	(46749, 111, '2015-02-01 00:58:34.000000', 'temperatura', 1159.0000, 'ºC'),
	(46750, 111, '2015-02-01 00:58:35.000000', 'temperatura', 647.0000, 'ºC'),
	(46751, 111, '2015-02-01 00:58:36.000000', 'temperatura', 957.0000, 'ºC'),
	(46752, 111, '2015-02-01 00:58:37.000000', 'temperatura', 445.0000, 'ºC'),
	(46753, 111, '2015-02-01 00:58:38.000000', 'temperatura', 555.0000, 'ºC'),
	(46754, 111, '2015-02-01 00:58:39.000000', 'temperatura', 238.0000, 'ºC'),
	(46755, 111, '2015-02-01 00:58:40.000000', 'temperatura', 728.0000, 'ºC'),
	(46756, 111, '2015-02-01 00:58:41.000000', 'temperatura', 527.0000, 'ºC'),
	(46757, 111, '2015-02-01 00:58:42.000000', 'temperatura', 451.0000, 'ºC'),
	(46758, 111, '2015-02-01 00:58:43.000000', 'temperatura', 673.0000, 'ºC'),
	(46759, 111, '2015-02-01 00:58:44.000000', 'temperatura', 812.0000, 'ºC'),
	(46760, 111, '2015-02-01 00:58:45.000000', 'temperatura', 843.0000, 'ºC'),
	(46761, 111, '2015-02-01 00:58:46.000000', 'temperatura', 577.0000, 'ºC'),
	(46762, 111, '2015-02-01 00:58:47.000000', 'temperatura', 359.0000, 'ºC'),
	(46763, 111, '2015-02-01 00:58:48.000000', 'temperatura', 62.0000, 'ºC'),
	(46764, 111, '2015-02-01 00:58:49.000000', 'temperatura', 436.0000, 'ºC'),
	(46765, 111, '2015-02-01 00:58:50.000000', 'temperatura', 794.0000, 'ºC'),
	(46766, 111, '2015-02-01 00:58:51.000000', 'temperatura', 262.0000, 'ºC'),
	(46767, 111, '2015-02-01 00:58:52.000000', 'temperatura', 128.0000, 'ºC'),
	(46768, 111, '2015-02-01 00:58:53.000000', 'temperatura', 1057.0000, 'ºC'),
	(46769, 111, '2015-02-01 00:58:54.000000', 'temperatura', 99.0000, 'ºC'),
	(46770, 111, '2015-02-01 00:58:55.000000', 'temperatura', 923.0000, 'ºC'),
	(46771, 111, '2015-02-01 00:58:56.000000', 'temperatura', 721.0000, 'ºC'),
	(46772, 111, '2015-02-01 00:58:57.000000', 'temperatura', 835.0000, 'ºC'),
	(46773, 111, '2015-02-01 00:58:58.000000', 'temperatura', 815.0000, 'ºC'),
	(46774, 111, '2015-02-01 00:58:59.000000', 'temperatura', 368.0000, 'ºC'),
	(46775, 111, '2015-02-01 00:59:00.000000', 'temperatura', 598.0000, 'ºC'),
	(46776, 111, '2015-02-01 00:59:01.000000', 'temperatura', 684.0000, 'ºC'),
	(46777, 111, '2015-02-01 00:59:02.000000', 'temperatura', 429.0000, 'ºC'),
	(46778, 111, '2015-02-01 00:59:03.000000', 'temperatura', 92.0000, 'ºC'),
	(46779, 111, '2015-02-01 00:59:04.000000', 'temperatura', 375.0000, 'ºC'),
	(46780, 111, '2015-02-01 00:59:05.000000', 'temperatura', 401.0000, 'ºC'),
	(46781, 111, '2015-02-01 00:59:06.000000', 'temperatura', 878.0000, 'ºC'),
	(46782, 111, '2015-02-01 00:59:07.000000', 'temperatura', 786.0000, 'ºC'),
	(46783, 111, '2015-02-01 00:59:08.000000', 'temperatura', 98.0000, 'ºC'),
	(46784, 111, '2015-02-01 00:59:09.000000', 'temperatura', 532.0000, 'ºC'),
	(46785, 111, '2015-02-01 00:59:10.000000', 'temperatura', 1167.0000, 'ºC'),
	(46786, 111, '2015-02-01 00:59:11.000000', 'temperatura', 640.0000, 'ºC'),
	(46787, 111, '2015-02-01 00:59:12.000000', 'temperatura', 898.0000, 'ºC'),
	(46788, 111, '2015-02-01 00:59:13.000000', 'temperatura', 173.0000, 'ºC'),
	(46789, 111, '2015-02-01 00:59:14.000000', 'temperatura', 570.0000, 'ºC'),
	(46790, 111, '2015-02-01 00:59:15.000000', 'temperatura', 1133.0000, 'ºC'),
	(46791, 111, '2015-02-01 00:59:16.000000', 'temperatura', 355.0000, 'ºC'),
	(46792, 111, '2015-02-01 00:59:17.000000', 'temperatura', 778.0000, 'ºC'),
	(46793, 111, '2015-02-01 00:59:18.000000', 'temperatura', 423.0000, 'ºC'),
	(46794, 111, '2015-02-01 00:59:19.000000', 'temperatura', 982.0000, 'ºC'),
	(46795, 111, '2015-02-01 00:59:20.000000', 'temperatura', 43.0000, 'ºC'),
	(46796, 111, '2015-02-01 00:59:21.000000', 'temperatura', 869.0000, 'ºC'),
	(46797, 111, '2015-02-01 00:59:22.000000', 'temperatura', 617.0000, 'ºC'),
	(46798, 111, '2015-02-01 00:59:23.000000', 'temperatura', 477.0000, 'ºC'),
	(46799, 111, '2015-02-01 00:59:24.000000', 'temperatura', 537.0000, 'ºC'),
	(46800, 111, '2015-02-01 00:59:25.000000', 'temperatura', 51.0000, 'ºC'),
	(46801, 111, '2015-02-01 00:59:26.000000', 'temperatura', 1048.0000, 'ºC'),
	(46802, 111, '2015-02-01 00:59:27.000000', 'temperatura', 285.0000, 'ºC'),
	(46803, 111, '2015-02-01 00:59:28.000000', 'temperatura', 684.0000, 'ºC'),
	(46804, 111, '2015-02-01 00:59:29.000000', 'temperatura', 163.0000, 'ºC'),
	(46805, 111, '2015-02-01 00:59:30.000000', 'temperatura', 1165.0000, 'ºC'),
	(46806, 111, '2015-02-01 00:59:31.000000', 'temperatura', 534.0000, 'ºC'),
	(46807, 111, '2015-02-01 00:59:32.000000', 'temperatura', 377.0000, 'ºC'),
	(46808, 111, '2015-02-01 00:59:33.000000', 'temperatura', 283.0000, 'ºC'),
	(46809, 111, '2015-02-01 00:59:34.000000', 'temperatura', 284.0000, 'ºC'),
	(46810, 111, '2015-02-01 00:59:35.000000', 'temperatura', 574.0000, 'ºC'),
	(46811, 111, '2015-02-01 00:59:36.000000', 'temperatura', 817.0000, 'ºC'),
	(46812, 111, '2015-02-01 00:59:37.000000', 'temperatura', 1164.0000, 'ºC'),
	(46813, 111, '2015-02-01 00:59:38.000000', 'temperatura', 969.0000, 'ºC'),
	(46814, 111, '2015-02-01 00:59:39.000000', 'temperatura', 155.0000, 'ºC'),
	(46815, 111, '2015-02-01 00:59:40.000000', 'temperatura', 268.0000, 'ºC'),
	(46816, 111, '2015-02-01 00:59:41.000000', 'temperatura', 874.0000, 'ºC'),
	(46817, 111, '2015-02-01 00:59:42.000000', 'temperatura', 1166.0000, 'ºC'),
	(46818, 111, '2015-02-01 00:59:43.000000', 'temperatura', 809.0000, 'ºC'),
	(46819, 111, '2015-02-01 00:59:44.000000', 'temperatura', 550.0000, 'ºC'),
	(46820, 111, '2015-02-01 00:59:45.000000', 'temperatura', 321.0000, 'ºC'),
	(46821, 111, '2015-02-01 00:59:46.000000', 'temperatura', 1158.0000, 'ºC'),
	(46822, 111, '2015-02-01 00:59:47.000000', 'temperatura', 26.0000, 'ºC'),
	(46823, 111, '2015-02-01 00:59:48.000000', 'temperatura', 255.0000, 'ºC'),
	(46824, 111, '2015-02-01 00:59:49.000000', 'temperatura', 1199.0000, 'ºC'),
	(46825, 111, '2015-02-01 00:59:50.000000', 'temperatura', 431.0000, 'ºC'),
	(46826, 111, '2015-02-01 00:59:51.000000', 'temperatura', 956.0000, 'ºC'),
	(46827, 111, '2015-02-01 00:59:52.000000', 'temperatura', 1090.0000, 'ºC'),
	(46828, 111, '2015-02-01 00:59:53.000000', 'temperatura', 183.0000, 'ºC'),
	(46829, 111, '2015-02-01 00:59:54.000000', 'temperatura', 43.0000, 'ºC'),
	(46830, 111, '2015-02-01 00:59:55.000000', 'temperatura', 869.0000, 'ºC'),
	(46831, 111, '2015-02-01 00:59:56.000000', 'temperatura', 617.0000, 'ºC'),
	(46832, 111, '2015-02-01 00:59:57.000000', 'temperatura', 476.0000, 'ºC'),
	(46833, 111, '2015-02-01 00:59:58.000000', 'temperatura', 529.0000, 'ºC'),
	(46834, 111, '2015-02-01 00:59:59.000000', 'temperatura', 18.0000, 'ºC'),
	(46835, 111, '2015-02-01 01:00:00.000000', 'temperatura', 903.0000, 'ºC'),
	(46836, 111, '2015-02-01 01:00:01.000000', 'temperatura', 860.0000, 'ºC'),
	(46837, 111, '2015-02-01 01:00:02.000000', 'temperatura', 394.0000, 'ºC'),
	(46838, 111, '2015-02-01 01:00:03.000000', 'temperatura', 588.0000, 'ºC'),
	(46839, 111, '2015-02-01 01:00:04.000000', 'temperatura', 559.0000, 'ºC'),
	(46840, 111, '2015-02-01 01:00:05.000000', 'temperatura', 1031.0000, 'ºC'),
	(46841, 111, '2015-02-01 01:00:06.000000', 'temperatura', 1079.0000, 'ºC'),
	(46842, 111, '2015-02-01 01:00:07.000000', 'temperatura', 1101.0000, 'ºC'),
	(46843, 111, '2015-02-01 01:00:08.000000', 'temperatura', 1071.0000, 'ºC'),
	(46844, 111, '2015-02-01 01:00:09.000000', 'temperatura', 850.0000, 'ºC'),
	(46845, 111, '2015-02-01 01:00:10.000000', 'temperatura', 1040.0000, 'ºC'),
	(46846, 111, '2015-02-01 01:00:11.000000', 'temperatura', 250.0000, 'ºC'),
	(46847, 111, '2015-02-01 01:00:12.000000', 'temperatura', 528.0000, 'ºC'),
	(46848, 111, '2015-02-01 01:00:13.000000', 'temperatura', 692.0000, 'ºC'),
	(46849, 111, '2015-02-01 01:00:14.000000', 'temperatura', 677.0000, 'ºC'),
	(46850, 111, '2015-02-01 01:00:15.000000', 'temperatura', 110.0000, 'ºC'),
	(46851, 111, '2015-02-01 01:00:16.000000', 'temperatura', 917.0000, 'ºC'),
	(46852, 111, '2015-02-01 01:00:17.000000', 'temperatura', 656.0000, 'ºC'),
	(46853, 111, '2015-02-01 01:00:18.000000', 'temperatura', 530.0000, 'ºC'),
	(46854, 111, '2015-02-01 01:00:19.000000', 'temperatura', 681.0000, 'ºC'),
	(46855, 111, '2015-02-01 01:00:20.000000', 'temperatura', 615.0000, 'ºC'),
	(46856, 111, '2015-02-01 01:00:21.000000', 'temperatura', 1035.0000, 'ºC'),
	(46857, 111, '2015-02-01 01:00:22.000000', 'temperatura', 930.0000, 'ºC'),
	(46858, 111, '2015-02-01 01:00:23.000000', 'temperatura', 344.0000, 'ºC'),
	(46859, 111, '2015-02-01 01:00:24.000000', 'temperatura', 133.0000, 'ºC'),
	(46860, 111, '2015-02-01 01:00:25.000000', 'temperatura', 831.0000, 'ºC'),
	(46861, 111, '2015-02-01 01:00:26.000000', 'temperatura', 159.0000, 'ºC'),
	(46862, 111, '2015-02-01 01:00:27.000000', 'temperatura', 703.0000, 'ºC'),
	(46863, 111, '2015-02-01 01:00:28.000000', 'temperatura', 638.0000, 'ºC'),
	(46864, 111, '2015-02-01 01:00:29.000000', 'temperatura', 1079.0000, 'ºC'),
	(46865, 111, '2015-02-01 01:00:30.000000', 'temperatura', 1084.0000, 'ºC'),
	(46866, 111, '2015-02-01 01:00:31.000000', 'temperatura', 982.0000, 'ºC'),
	(46867, 111, '2015-02-01 01:00:32.000000', 'temperatura', 459.0000, 'ºC'),
	(46868, 111, '2015-02-01 01:00:33.000000', 'temperatura', 552.0000, 'ºC'),
	(46869, 111, '2015-02-01 01:00:34.000000', 'temperatura', 180.0000, 'ºC'),
	(46870, 111, '2015-02-01 01:00:35.000000', 'temperatura', 445.0000, 'ºC'),
	(46871, 111, '2015-02-01 01:00:36.000000', 'temperatura', 487.0000, 'ºC'),
	(46872, 111, '2015-02-01 01:00:37.000000', 'temperatura', 1100.0000, 'ºC'),
	(46873, 111, '2015-02-01 01:00:38.000000', 'temperatura', 441.0000, 'ºC'),
	(46874, 111, '2015-02-01 01:00:39.000000', 'temperatura', 103.0000, 'ºC'),
	(46875, 111, '2015-02-01 01:00:40.000000', 'temperatura', 395.0000, 'ºC'),
	(46876, 111, '2015-02-01 01:00:41.000000', 'temperatura', 466.0000, 'ºC'),
	(46877, 111, '2015-02-01 01:00:42.000000', 'temperatura', 1147.0000, 'ºC'),
	(46878, 111, '2015-02-01 01:00:43.000000', 'temperatura', 737.0000, 'ºC'),
	(46879, 111, '2015-02-01 01:00:44.000000', 'temperatura', 243.0000, 'ºC'),
	(46880, 111, '2015-02-01 01:00:45.000000', 'temperatura', 204.0000, 'ºC'),
	(46881, 111, '2015-02-01 01:00:46.000000', 'temperatura', 294.0000, 'ºC'),
	(46882, 111, '2015-02-01 01:00:47.000000', 'temperatura', 857.0000, 'ºC'),
	(46883, 111, '2015-02-01 01:00:48.000000', 'temperatura', 1002.0000, 'ºC'),
	(46884, 111, '2015-02-01 01:00:49.000000', 'temperatura', 41.0000, 'ºC'),
	(46885, 111, '2015-02-01 01:00:50.000000', 'temperatura', 799.0000, 'ºC'),
	(46886, 111, '2015-02-01 01:00:51.000000', 'temperatura', 271.0000, 'ºC'),
	(46887, 111, '2015-02-01 01:00:52.000000', 'temperatura', 162.0000, 'ºC'),
	(46888, 111, '2015-02-01 01:00:53.000000', 'temperatura', 1194.0000, 'ºC'),
	(46889, 111, '2015-02-01 01:00:54.000000', 'temperatura', 685.0000, 'ºC'),
	(46890, 111, '2015-02-01 01:00:55.000000', 'temperatura', 1044.0000, 'ºC'),
	(46891, 111, '2015-02-01 01:00:56.000000', 'temperatura', 767.0000, 'ºC'),
	(46892, 111, '2015-02-01 01:00:57.000000', 'temperatura', 702.0000, 'ºC'),
	(46893, 111, '2015-02-01 01:00:58.000000', 'temperatura', 11.0000, 'ºC'),
	(46894, 111, '2015-02-01 01:00:59.000000', 'temperatura', 350.0000, 'ºC'),
	(46895, 111, '2015-02-01 01:01:00.000000', 'temperatura', 519.0000, 'ºC'),
	(46896, 111, '2015-02-01 01:01:01.000000', 'temperatura', 342.0000, 'ºC'),
	(46897, 111, '2015-02-01 01:01:02.000000', 'temperatura', 154.0000, 'ºC'),
	(46898, 111, '2015-02-01 01:01:03.000000', 'temperatura', 945.0000, 'ºC'),
	(46899, 111, '2015-02-01 01:01:04.000000', 'temperatura', 664.0000, 'ºC'),
	(46900, 111, '2015-02-01 01:01:05.000000', 'temperatura', 487.0000, 'ºC'),
	(46901, 111, '2015-02-01 01:01:06.000000', 'temperatura', 443.0000, 'ºC'),
	(46902, 111, '2015-02-01 01:01:07.000000', 'temperatura', 753.0000, 'ºC'),
	(46903, 111, '2015-02-01 01:01:08.000000', 'temperatura', 35.0000, 'ºC'),
	(46904, 111, '2015-02-01 01:01:09.000000', 'temperatura', 319.0000, 'ºC'),
	(46905, 111, '2015-02-01 01:01:10.000000', 'temperatura', 292.0000, 'ºC'),
	(46906, 111, '2015-02-01 01:01:11.000000', 'temperatura', 501.0000, 'ºC'),
	(46907, 111, '2015-02-01 01:01:12.000000', 'temperatura', 429.0000, 'ºC'),
	(46908, 111, '2015-02-01 01:01:13.000000', 'temperatura', 644.0000, 'ºC'),
	(46909, 111, '2015-02-01 01:01:14.000000', 'temperatura', 733.0000, 'ºC'),
	(46910, 111, '2015-02-01 01:01:15.000000', 'temperatura', 534.0000, 'ºC'),
	(46911, 111, '2015-02-01 01:01:16.000000', 'temperatura', 470.0000, 'ºC'),
	(46912, 111, '2015-02-01 01:01:17.000000', 'temperatura', 751.0000, 'ºC'),
	(46913, 111, '2015-02-01 01:01:18.000000', 'temperatura', 1143.0000, 'ºC'),
	(46914, 111, '2015-02-01 01:01:19.000000', 'temperatura', 1061.0000, 'ºC'),
	(46915, 111, '2015-02-01 01:01:20.000000', 'temperatura', 680.0000, 'ºC'),
	(46916, 111, '2015-02-01 01:01:21.000000', 'temperatura', 215.0000, 'ºC'),
	(46917, 111, '2015-02-01 01:01:22.000000', 'temperatura', 238.0000, 'ºC'),
	(46918, 111, '2015-02-01 01:01:23.000000', 'temperatura', 545.0000, 'ºC'),
	(46919, 111, '2015-02-01 01:01:24.000000', 'temperatura', 810.0000, 'ºC'),
	(46920, 111, '2015-02-01 01:01:25.000000', 'temperatura', 18.0000, 'ºC'),
	(46921, 111, '2015-02-01 01:01:26.000000', 'temperatura', 57.0000, 'ºC'),
	(46922, 111, '2015-02-01 01:01:27.000000', 'temperatura', 235.0000, 'ºC'),
	(46923, 111, '2015-02-01 01:01:28.000000', 'temperatura', 1001.0000, 'ºC'),
	(46924, 111, '2015-02-01 01:01:29.000000', 'temperatura', 703.0000, 'ºC'),
	(46925, 111, '2015-02-01 01:01:30.000000', 'temperatura', 513.0000, 'ºC'),
	(46926, 111, '2015-02-01 01:01:31.000000', 'temperatura', 454.0000, 'ºC'),
	(46927, 111, '2015-02-01 01:01:32.000000', 'temperatura', 731.0000, 'ºC'),
	(46928, 111, '2015-02-01 01:01:33.000000', 'temperatura', 1095.0000, 'ºC'),
	(46929, 111, '2015-02-01 01:01:34.000000', 'temperatura', 881.0000, 'ºC'),
	(46930, 111, '2015-02-01 01:01:35.000000', 'temperatura', 1122.0000, 'ºC'),
	(46931, 111, '2015-02-01 01:01:36.000000', 'temperatura', 565.0000, 'ºC'),
	(46932, 111, '2015-02-01 01:01:37.000000', 'temperatura', 663.0000, 'ºC'),
	(46933, 111, '2015-02-01 01:01:38.000000', 'temperatura', 417.0000, 'ºC'),
	(46934, 111, '2015-02-01 01:01:39.000000', 'temperatura', 98.0000, 'ºC'),
	(46935, 111, '2015-02-01 01:01:40.000000', 'temperatura', 438.0000, 'ºC'),
	(46936, 111, '2015-02-01 01:01:41.000000', 'temperatura', 696.0000, 'ºC'),
	(46937, 111, '2015-02-01 01:01:42.000000', 'temperatura', 967.0000, 'ºC'),
	(46938, 111, '2015-02-01 01:01:43.000000', 'temperatura', 347.0000, 'ºC'),
	(46939, 111, '2015-02-01 01:01:44.000000', 'temperatura', 35.0000, 'ºC'),
	(46940, 111, '2015-02-01 01:01:45.000000', 'temperatura', 334.0000, 'ºC'),
	(46941, 111, '2015-02-01 01:01:46.000000', 'temperatura', 368.0000, 'ºC'),
	(46942, 111, '2015-02-01 01:01:47.000000', 'temperatura', 836.0000, 'ºC'),
	(46943, 111, '2015-02-01 01:01:48.000000', 'temperatura', 678.0000, 'ºC'),
	(46944, 111, '2015-02-01 01:01:49.000000', 'temperatura', 881.0000, 'ºC'),
	(46945, 111, '2015-02-01 01:01:50.000000', 'temperatura', 1172.0000, 'ºC'),
	(46946, 111, '2015-02-01 01:01:51.000000', 'temperatura', 818.0000, 'ºC'),
	(46947, 111, '2015-02-01 01:01:52.000000', 'temperatura', 576.0000, 'ºC'),
	(46948, 111, '2015-02-01 01:01:53.000000', 'temperatura', 426.0000, 'ºC'),
	(46949, 111, '2015-02-01 01:01:54.000000', 'temperatura', 402.0000, 'ºC'),
	(46950, 111, '2015-02-01 01:01:55.000000', 'temperatura', 733.0000, 'ºC'),
	(46951, 111, '2015-02-01 01:01:56.000000', 'temperatura', 60.0000, 'ºC'),
	(46952, 111, '2015-02-01 01:01:57.000000', 'temperatura', 503.0000, 'ºC'),
	(46953, 111, '2015-02-01 01:01:58.000000', 'temperatura', 1133.0000, 'ºC'),
	(46954, 111, '2015-02-01 01:01:59.000000', 'temperatura', 556.0000, 'ºC'),
	(46955, 111, '2015-02-01 01:02:00.000000', 'temperatura', 581.0000, 'ºC'),
	(46956, 111, '2015-02-01 01:02:01.000000', 'temperatura', 37.0000, 'ºC'),
	(46957, 111, '2015-02-01 01:02:02.000000', 'temperatura', 844.0000, 'ºC'),
	(46958, 111, '2015-02-01 01:02:03.000000', 'temperatura', 508.0000, 'ºC'),
	(46959, 111, '2015-02-01 01:02:04.000000', 'temperatura', 10.0000, 'ºC'),
	(46960, 111, '2015-02-01 01:02:05.000000', 'temperatura', 926.0000, 'ºC'),
	(46961, 111, '2015-02-01 01:02:06.000000', 'temperatura', 998.0000, 'ºC'),
	(46962, 111, '2015-02-01 01:02:07.000000', 'temperatura', 1016.0000, 'ºC'),
	(46963, 111, '2015-02-01 01:02:08.000000', 'temperatura', 885.0000, 'ºC'),
	(46964, 111, '2015-02-01 01:02:09.000000', 'temperatura', 179.0000, 'ºC'),
	(46965, 111, '2015-02-01 01:02:10.000000', 'temperatura', 638.0000, 'ºC'),
	(46966, 111, '2015-02-01 01:02:11.000000', 'temperatura', 253.0000, 'ºC'),
	(46967, 111, '2015-02-01 01:02:12.000000', 'temperatura', 554.0000, 'ºC'),
	(46968, 111, '2015-02-01 01:02:13.000000', 'temperatura', 810.0000, 'ºC'),
	(46969, 111, '2015-02-01 01:02:14.000000', 'temperatura', 1188.0000, 'ºC'),
	(46970, 111, '2015-02-01 01:02:15.000000', 'temperatura', 1109.0000, 'ºC'),
	(46971, 111, '2015-02-01 01:02:16.000000', 'temperatura', 784.0000, 'ºC'),
	(46972, 111, '2015-02-01 01:02:17.000000', 'temperatura', 592.0000, 'ºC'),
	(46973, 111, '2015-02-01 01:02:18.000000', 'temperatura', 610.0000, 'ºC'),
	(46974, 111, '2015-02-01 01:02:19.000000', 'temperatura', 72.0000, 'ºC'),
	(46975, 111, '2015-02-01 01:02:20.000000', 'temperatura', 933.0000, 'ºC'),
	(46976, 111, '2015-02-01 01:02:21.000000', 'temperatura', 850.0000, 'ºC'),
	(46977, 111, '2015-02-01 01:02:22.000000', 'temperatura', 252.0000, 'ºC'),
	(46978, 111, '2015-02-01 01:02:23.000000', 'temperatura', 1112.0000, 'ºC'),
	(46979, 111, '2015-02-01 01:02:24.000000', 'temperatura', 1.0000, 'ºC'),
	(46980, 111, '2015-02-01 01:02:25.000000', 'temperatura', 271.0000, 'ºC'),
	(46981, 111, '2015-02-01 01:02:26.000000', 'temperatura', 153.0000, 'ºC'),
	(46982, 111, '2015-02-01 01:02:27.000000', 'temperatura', 1152.0000, 'ºC'),
	(46983, 111, '2015-02-01 01:02:28.000000', 'temperatura', 503.0000, 'ºC'),
	(46984, 111, '2015-02-01 01:02:29.000000', 'temperatura', 257.0000, 'ºC'),
	(46985, 111, '2015-02-01 01:02:30.000000', 'temperatura', 976.0000, 'ºC'),
	(46986, 111, '2015-02-01 01:02:31.000000', 'temperatura', 509.0000, 'ºC'),
	(46987, 111, '2015-02-01 01:02:32.000000', 'temperatura', 819.0000, 'ºC'),
	(46988, 111, '2015-02-01 01:02:33.000000', 'temperatura', 167.0000, 'ºC'),
	(46989, 111, '2015-02-01 01:02:34.000000', 'temperatura', 779.0000, 'ºC'),
	(46990, 111, '2015-02-01 01:02:35.000000', 'temperatura', 995.0000, 'ºC'),
	(46991, 111, '2015-02-01 01:02:36.000000', 'temperatura', 239.0000, 'ºC'),
	(46992, 111, '2015-02-01 01:02:37.000000', 'temperatura', 609.0000, 'ºC'),
	(46993, 111, '2015-02-01 01:02:38.000000', 'temperatura', 1131.0000, 'ºC'),
	(46994, 111, '2015-02-01 01:02:39.000000', 'temperatura', 227.0000, 'ºC'),
	(46995, 111, '2015-02-01 01:02:40.000000', 'temperatura', 142.0000, 'ºC'),
	(46996, 111, '2015-02-01 01:02:41.000000', 'temperatura', 32.0000, 'ºC'),
	(46997, 111, '2015-02-01 01:02:42.000000', 'temperatura', 932.0000, 'ºC'),
	(46998, 111, '2015-02-01 01:02:43.000000', 'temperatura', 967.0000, 'ºC'),
	(46999, 111, '2015-02-01 01:02:44.000000', 'temperatura', 837.0000, 'ºC'),
	(47000, 111, '2015-02-01 01:02:45.000000', 'temperatura', 84.0000, 'ºC'),
	(47001, 111, '2015-02-01 01:02:46.000000', 'temperatura', 312.0000, 'ºC'),
	(47002, 111, '2015-02-01 01:02:47.000000', 'temperatura', 105.0000, 'ºC'),
	(47003, 111, '2015-02-01 01:02:48.000000', 'temperatura', 793.0000, 'ºC'),
	(47004, 111, '2015-02-01 01:02:49.000000', 'temperatura', 50.0000, 'ºC'),
	(47005, 111, '2015-02-01 01:02:50.000000', 'temperatura', 272.0000, 'ºC'),
	(47006, 111, '2015-02-01 01:02:51.000000', 'temperatura', 9.0000, 'ºC'),
	(47007, 111, '2015-02-01 01:02:52.000000', 'temperatura', 430.0000, 'ºC'),
	(47008, 111, '2015-02-01 01:02:53.000000', 'temperatura', 925.0000, 'ºC'),
	(47009, 111, '2015-02-01 01:02:54.000000', 'temperatura', 934.0000, 'ºC'),
	(47010, 111, '2015-02-01 01:02:55.000000', 'temperatura', 698.0000, 'ºC'),
	(47011, 111, '2015-02-01 01:02:56.000000', 'temperatura', 686.0000, 'ºC'),
	(47012, 111, '2015-02-01 01:02:57.000000', 'temperatura', 136.0000, 'ºC'),
	(47013, 111, '2015-02-01 01:02:58.000000', 'temperatura', 1024.0000, 'ºC'),
	(47014, 111, '2015-02-01 01:02:59.000000', 'temperatura', 1110.0000, 'ºC'),
	(47015, 111, '2015-02-01 01:03:00.000000', 'temperatura', 81.0000, 'ºC'),
	(47016, 111, '2015-02-01 01:03:01.000000', 'temperatura', 674.0000, 'ºC'),
	(47017, 111, '2015-02-01 01:03:02.000000', 'temperatura', 730.0000, 'ºC'),
	(47018, 111, '2015-02-01 01:03:03.000000', 'temperatura', 425.0000, 'ºC'),
	(47019, 111, '2015-02-01 01:03:04.000000', 'temperatura', 1139.0000, 'ºC'),
	(47020, 111, '2015-02-01 01:03:05.000000', 'temperatura', 818.0000, 'ºC'),
	(47021, 111, '2015-02-01 01:03:06.000000', 'temperatura', 673.0000, 'ºC'),
	(47022, 111, '2015-02-01 01:03:07.000000', 'temperatura', 911.0000, 'ºC'),
	(47023, 111, '2015-02-01 01:03:08.000000', 'temperatura', 138.0000, 'ºC'),
	(47024, 111, '2015-02-01 01:03:09.000000', 'temperatura', 356.0000, 'ºC'),
	(47025, 111, '2015-02-01 01:03:10.000000', 'temperatura', 167.0000, 'ºC'),
	(47026, 111, '2015-02-01 01:03:11.000000', 'temperatura', 966.0000, 'ºC'),
	(47027, 111, '2015-02-01 01:03:12.000000', 'temperatura', 733.0000, 'ºC'),
	(47028, 111, '2015-02-01 01:03:13.000000', 'temperatura', 764.0000, 'ºC'),
	(47029, 111, '2015-02-01 01:03:14.000000', 'temperatura', 424.0000, 'ºC'),
	(47030, 111, '2015-02-01 01:03:15.000000', 'temperatura', 1028.0000, 'ºC'),
	(47031, 111, '2015-02-01 01:03:16.000000', 'temperatura', 269.0000, 'ºC'),
	(47032, 111, '2015-02-01 01:03:17.000000', 'temperatura', 659.0000, 'ºC'),
	(47033, 111, '2015-02-01 01:03:18.000000', 'temperatura', 89.0000, 'ºC'),
	(47034, 111, '2015-02-01 01:03:19.000000', 'temperatura', 871.0000, 'ºC'),
	(47035, 111, '2015-02-01 01:03:20.000000', 'temperatura', 487.0000, 'ºC'),
	(47036, 111, '2015-02-01 01:03:21.000000', 'temperatura', 1023.0000, 'ºC'),
	(47037, 111, '2015-02-01 01:03:22.000000', 'temperatura', 53.0000, 'ºC'),
	(47038, 111, '2015-02-01 01:03:23.000000', 'temperatura', 797.0000, 'ºC'),
	(47039, 111, '2015-02-01 01:03:24.000000', 'temperatura', 227.0000, 'ºC'),
	(47040, 111, '2015-02-01 01:03:25.000000', 'temperatura', 1144.0000, 'ºC'),
	(47041, 111, '2015-02-01 01:03:26.000000', 'temperatura', 238.0000, 'ºC'),
	(47042, 111, '2015-02-01 01:03:27.000000', 'temperatura', 161.0000, 'ºC'),
	(47043, 111, '2015-02-01 01:03:28.000000', 'temperatura', 90.0000, 'ºC'),
	(47044, 111, '2015-02-01 01:03:29.000000', 'temperatura', 1169.0000, 'ºC'),
	(47045, 111, '2015-02-01 01:03:30.000000', 'temperatura', 777.0000, 'ºC'),
	(47046, 111, '2015-02-01 01:03:31.000000', 'temperatura', 376.0000, 'ºC'),
	(47047, 111, '2015-02-01 01:03:32.000000', 'temperatura', 751.0000, 'ºC'),
	(47048, 111, '2015-02-01 01:03:33.000000', 'temperatura', 225.0000, 'ºC'),
	(47049, 111, '2015-02-01 01:03:34.000000', 'temperatura', 74.0000, 'ºC'),
	(47050, 111, '2015-02-01 01:03:35.000000', 'temperatura', 897.0000, 'ºC'),
	(47051, 111, '2015-02-01 01:03:36.000000', 'temperatura', 661.0000, 'ºC'),
	(47052, 111, '2015-02-01 01:03:37.000000', 'temperatura', 616.0000, 'ºC'),
	(47053, 111, '2015-02-01 01:03:38.000000', 'temperatura', 1097.0000, 'ºC'),
	(47054, 111, '2015-02-01 01:03:39.000000', 'temperatura', 39.0000, 'ºC'),
	(47055, 111, '2015-02-01 01:03:40.000000', 'temperatura', 504.0000, 'ºC'),
	(47056, 111, '2015-02-01 01:03:41.000000', 'temperatura', 5.0000, 'ºC'),
	(47057, 111, '2015-02-01 01:03:42.000000', 'temperatura', 911.0000, 'ºC'),
	(47058, 111, '2015-02-01 01:03:43.000000', 'temperatura', 942.0000, 'ºC'),
	(47059, 111, '2015-02-01 01:03:44.000000', 'temperatura', 777.0000, 'ºC'),
	(47060, 111, '2015-02-01 01:03:45.000000', 'temperatura', 1058.0000, 'ºC'),
	(47061, 111, '2015-02-01 01:03:46.000000', 'temperatura', 560.0000, 'ºC'),
	(47062, 111, '2015-02-01 01:03:47.000000', 'temperatura', 825.0000, 'ºC'),
	(47063, 111, '2015-02-01 01:03:48.000000', 'temperatura', 48.0000, 'ºC'),
	(47064, 111, '2015-02-01 01:03:49.000000', 'temperatura', 163.0000, 'ºC'),
	(47065, 111, '2015-02-01 01:03:50.000000', 'temperatura', 673.0000, 'ºC'),
	(47066, 111, '2015-02-01 01:03:51.000000', 'temperatura', 477.0000, 'ºC'),
	(47067, 111, '2015-02-01 01:03:52.000000', 'temperatura', 364.0000, 'ºC'),
	(47068, 111, '2015-02-01 01:03:53.000000', 'temperatura', 390.0000, 'ºC'),
	(47069, 111, '2015-02-01 01:03:54.000000', 'temperatura', 861.0000, 'ºC'),
	(47070, 111, '2015-02-01 01:03:55.000000', 'temperatura', 733.0000, 'ºC'),
	(47071, 111, '2015-02-01 01:03:56.000000', 'temperatura', 1084.0000, 'ºC'),
	(47072, 111, '2015-02-01 01:03:57.000000', 'temperatura', 823.0000, 'ºC'),
	(47073, 111, '2015-02-01 01:03:58.000000', 'temperatura', 861.0000, 'ºC'),
	(47074, 111, '2015-02-01 01:03:59.000000', 'temperatura', 637.0000, 'ºC'),
	(47075, 111, '2015-02-01 01:04:00.000000', 'temperatura', 601.0000, 'ºC'),
	(47076, 111, '2015-02-01 01:04:01.000000', 'temperatura', 1096.0000, 'ºC'),
	(47077, 111, '2015-02-01 01:04:02.000000', 'temperatura', 77.0000, 'ºC'),
	(47078, 111, '2015-02-01 01:04:03.000000', 'temperatura', 699.0000, 'ºC'),
	(47079, 111, '2015-02-01 01:04:04.000000', 'temperatura', 865.0000, 'ºC'),
	(47080, 111, '2015-02-01 01:04:05.000000', 'temperatura', 1029.0000, 'ºC'),
	(47081, 111, '2015-02-01 01:04:06.000000', 'temperatura', 149.0000, 'ºC'),
	(47082, 111, '2015-02-01 01:04:07.000000', 'temperatura', 59.0000, 'ºC'),
	(47083, 111, '2015-02-01 01:04:08.000000', 'temperatura', 1047.0000, 'ºC'),
	(47084, 111, '2015-02-01 01:04:09.000000', 'temperatura', 258.0000, 'ºC'),
	(47085, 111, '2015-02-01 01:04:10.000000', 'temperatura', 552.0000, 'ºC'),
	(47086, 111, '2015-02-01 01:04:11.000000', 'temperatura', 787.0000, 'ºC'),
	(47087, 111, '2015-02-01 01:04:12.000000', 'temperatura', 1077.0000, 'ºC'),
	(47088, 111, '2015-02-01 01:04:13.000000', 'temperatura', 624.0000, 'ºC'),
	(47089, 111, '2015-02-01 01:04:14.000000', 'temperatura', 1091.0000, 'ºC'),
	(47090, 111, '2015-02-01 01:04:15.000000', 'temperatura', 1181.0000, 'ºC'),
	(47091, 111, '2015-02-01 01:04:16.000000', 'temperatura', 235.0000, 'ºC'),
	(47092, 111, '2015-02-01 01:04:17.000000', 'temperatura', 31.0000, 'ºC'),
	(47093, 111, '2015-02-01 01:04:18.000000', 'temperatura', 649.0000, 'ºC'),
	(47094, 111, '2015-02-01 01:04:19.000000', 'temperatura', 756.0000, 'ºC'),
	(47095, 111, '2015-02-01 01:04:20.000000', 'temperatura', 632.0000, 'ºC'),
	(47096, 111, '2015-02-01 01:04:21.000000', 'temperatura', 894.0000, 'ºC'),
	(47097, 111, '2015-02-01 01:04:22.000000', 'temperatura', 174.0000, 'ºC'),
	(47098, 111, '2015-02-01 01:04:23.000000', 'temperatura', 588.0000, 'ºC'),
	(47099, 111, '2015-02-01 01:04:24.000000', 'temperatura', 21.0000, 'ºC'),
	(47100, 111, '2015-02-01 01:04:25.000000', 'temperatura', 738.0000, 'ºC'),
	(47101, 111, '2015-02-01 01:04:26.000000', 'temperatura', 28.0000, 'ºC'),
	(47102, 111, '2015-02-01 01:04:27.000000', 'temperatura', 329.0000, 'ºC'),
	(47103, 111, '2015-02-01 01:04:28.000000', 'temperatura', 360.0000, 'ºC'),
	(47104, 111, '2015-02-01 01:04:29.000000', 'temperatura', 812.0000, 'ºC'),
	(47105, 111, '2015-02-01 01:04:30.000000', 'temperatura', 583.0000, 'ºC'),
	(47106, 111, '2015-02-01 01:04:31.000000', 'temperatura', 477.0000, 'ºC'),
	(47107, 111, '2015-02-01 01:04:32.000000', 'temperatura', 638.0000, 'ºC'),
	(47108, 111, '2015-02-01 01:04:33.000000', 'temperatura', 560.0000, 'ºC'),
	(47109, 111, '2015-02-01 01:04:34.000000', 'temperatura', 884.0000, 'ºC'),
	(47110, 111, '2015-02-01 01:04:35.000000', 'temperatura', 342.0000, 'ºC'),
	(47111, 111, '2015-02-01 01:04:36.000000', 'temperatura', 259.0000, 'ºC'),
	(47112, 111, '2015-02-01 01:04:37.000000', 'temperatura', 269.0000, 'ºC'),
	(47113, 111, '2015-02-01 01:04:38.000000', 'temperatura', 567.0000, 'ºC'),
	(47114, 111, '2015-02-01 01:04:39.000000', 'temperatura', 832.0000, 'ºC'),
	(47115, 111, '2015-02-01 01:04:40.000000', 'temperatura', 56.0000, 'ºC'),
	(47116, 111, '2015-02-01 01:04:41.000000', 'temperatura', 185.0000, 'ºC'),
	(47117, 111, '2015-02-01 01:04:42.000000', 'temperatura', 757.0000, 'ºC'),
	(47118, 111, '2015-02-01 01:04:43.000000', 'temperatura', 833.0000, 'ºC'),
	(47119, 111, '2015-02-01 01:04:44.000000', 'temperatura', 692.0000, 'ºC'),
	(47120, 111, '2015-02-01 01:04:45.000000', 'temperatura', 962.0000, 'ºC'),
	(47121, 111, '2015-02-01 01:04:46.000000', 'temperatura', 336.0000, 'ºC'),
	(47122, 111, '2015-02-01 01:04:47.000000', 'temperatura', 1193.0000, 'ºC'),
	(47123, 111, '2015-02-01 01:04:48.000000', 'temperatura', 158.0000, 'ºC'),
	(47124, 111, '2015-02-01 01:04:49.000000', 'temperatura', 812.0000, 'ºC'),
	(47125, 111, '2015-02-01 01:04:50.000000', 'temperatura', 1188.0000, 'ºC'),
	(47126, 111, '2015-02-01 01:04:51.000000', 'temperatura', 1101.0000, 'ºC'),
	(47127, 111, '2015-02-01 01:04:52.000000', 'temperatura', 745.0000, 'ºC'),
	(47128, 111, '2015-02-01 01:04:53.000000', 'temperatura', 421.0000, 'ºC'),
	(47129, 111, '2015-02-01 01:04:54.000000', 'temperatura', 1071.0000, 'ºC'),
	(47130, 111, '2015-02-01 01:04:55.000000', 'temperatura', 492.0000, 'ºC'),
	(47131, 111, '2015-02-01 01:04:56.000000', 'temperatura', 447.0000, 'ºC'),
	(47132, 111, '2015-02-01 01:04:57.000000', 'temperatura', 762.0000, 'ºC'),
	(47133, 111, '2015-02-01 01:04:58.000000', 'temperatura', 66.0000, 'ºC'),
	(47134, 111, '2015-02-01 01:04:59.000000', 'temperatura', 446.0000, 'ºC'),
	(47135, 111, '2015-02-01 01:05:00.000000', 'temperatura', 834.0000, 'ºC'),
	(47136, 111, '2015-02-01 01:05:01.000000', 'temperatura', 431.0000, 'ºC'),
	(47137, 111, '2015-02-01 01:05:02.000000', 'temperatura', 854.0000, 'ºC'),
	(47138, 111, '2015-02-01 01:05:03.000000', 'temperatura', 577.0000, 'ºC'),
	(47139, 111, '2015-02-01 01:05:04.000000', 'temperatura', 322.0000, 'ºC'),
	(47140, 111, '2015-02-01 01:05:05.000000', 'temperatura', 1082.0000, 'ºC'),
	(47141, 111, '2015-02-01 01:05:06.000000', 'temperatura', 843.0000, 'ºC'),
	(47142, 111, '2015-02-01 01:05:07.000000', 'temperatura', 970.0000, 'ºC'),
	(47143, 111, '2015-02-01 01:05:08.000000', 'temperatura', 1123.0000, 'ºC'),
	(47144, 111, '2015-02-01 01:05:09.000000', 'temperatura', 303.0000, 'ºC'),
	(47145, 111, '2015-02-01 01:05:10.000000', 'temperatura', 548.0000, 'ºC'),
	(47146, 111, '2015-02-01 01:05:11.000000', 'temperatura', 630.0000, 'ºC'),
	(47147, 111, '2015-02-01 01:05:12.000000', 'temperatura', 307.0000, 'ºC'),
	(47148, 111, '2015-02-01 01:05:13.000000', 'temperatura', 846.0000, 'ºC'),
	(47149, 111, '2015-02-01 01:05:14.000000', 'temperatura', 911.0000, 'ºC'),
	(47150, 111, '2015-02-01 01:05:15.000000', 'temperatura', 814.0000, 'ºC'),
	(47151, 111, '2015-02-01 01:05:16.000000', 'temperatura', 141.0000, 'ºC'),
	(47152, 111, '2015-02-01 01:05:17.000000', 'temperatura', 660.0000, 'ºC'),
	(47153, 111, '2015-02-01 01:05:18.000000', 'temperatura', 479.0000, 'ºC'),
	(47154, 111, '2015-02-01 01:05:19.000000', 'temperatura', 417.0000, 'ºC'),
	(47155, 111, '2015-02-01 01:05:20.000000', 'temperatura', 646.0000, 'ºC'),
	(47156, 111, '2015-02-01 01:05:21.000000', 'temperatura', 778.0000, 'ºC'),
	(47157, 111, '2015-02-01 01:05:22.000000', 'temperatura', 756.0000, 'ºC'),
	(47158, 111, '2015-02-01 01:05:23.000000', 'temperatura', 246.0000, 'ºC'),
	(47159, 111, '2015-02-01 01:05:24.000000', 'temperatura', 162.0000, 'ºC'),
	(47160, 111, '2015-02-01 01:05:25.000000', 'temperatura', 74.0000, 'ºC'),
	(47161, 111, '2015-02-01 01:05:26.000000', 'temperatura', 1082.0000, 'ºC'),
	(47162, 111, '2015-02-01 01:05:27.000000', 'temperatura', 390.0000, 'ºC'),
	(47163, 111, '2015-02-01 01:05:28.000000', 'temperatura', 1103.0000, 'ºC'),
	(47164, 111, '2015-02-01 01:05:29.000000', 'temperatura', 748.0000, 'ºC'),
	(47165, 111, '2015-02-01 01:05:30.000000', 'temperatura', 432.0000, 'ºC'),
	(47166, 111, '2015-02-01 01:05:31.000000', 'temperatura', 1116.0000, 'ºC'),
	(47167, 111, '2015-02-01 01:05:32.000000', 'temperatura', 686.0000, 'ºC'),
	(47168, 111, '2015-02-01 01:05:33.000000', 'temperatura', 80.0000, 'ºC'),
	(47169, 111, '2015-02-01 01:05:34.000000', 'temperatura', 744.0000, 'ºC'),
	(47170, 111, '2015-02-01 01:05:35.000000', 'temperatura', 1080.0000, 'ºC'),
	(47171, 111, '2015-02-01 01:05:36.000000', 'temperatura', 766.0000, 'ºC'),
	(47172, 111, '2015-02-01 01:05:37.000000', 'temperatura', 594.0000, 'ºC'),
	(47173, 111, '2015-02-01 01:05:38.000000', 'temperatura', 673.0000, 'ºC'),
	(47174, 111, '2015-02-01 01:05:39.000000', 'temperatura', 380.0000, 'ºC'),
	(47175, 111, '2015-02-01 01:05:40.000000', 'temperatura', 1085.0000, 'ºC'),
	(47176, 111, '2015-02-01 01:05:41.000000', 'temperatura', 683.0000, 'ºC'),
	(47177, 111, '2015-02-01 01:05:42.000000', 'temperatura', 163.0000, 'ºC'),
	(47178, 111, '2015-02-01 01:05:43.000000', 'temperatura', 1164.0000, 'ºC'),
	(47179, 111, '2015-02-01 01:05:44.000000', 'temperatura', 532.0000, 'ºC'),
	(47180, 111, '2015-02-01 01:05:45.000000', 'temperatura', 370.0000, 'ºC'),
	(47181, 111, '2015-02-01 01:05:46.000000', 'temperatura', 256.0000, 'ºC'),
	(47182, 111, '2015-02-01 01:05:47.000000', 'temperatura', 167.0000, 'ºC'),
	(47183, 111, '2015-02-01 01:05:48.000000', 'temperatura', 68.0000, 'ºC'),
	(47184, 111, '2015-02-01 01:05:49.000000', 'temperatura', 1041.0000, 'ºC'),
	(47185, 111, '2015-02-01 01:05:50.000000', 'temperatura', 202.0000, 'ºC'),
	(47186, 111, '2015-02-01 01:05:51.000000', 'temperatura', 288.0000, 'ºC'),
	(47187, 111, '2015-02-01 01:05:52.000000', 'temperatura', 835.0000, 'ºC'),
	(47188, 111, '2015-02-01 01:05:53.000000', 'temperatura', 911.0000, 'ºC'),
	(47189, 111, '2015-02-01 01:05:54.000000', 'temperatura', 852.0000, 'ºC'),
	(47190, 111, '2015-02-01 01:05:55.000000', 'temperatura', 327.0000, 'ºC'),
	(47191, 111, '2015-02-01 01:05:56.000000', 'temperatura', 281.0000, 'ºC'),
	(47192, 111, '2015-02-01 01:05:57.000000', 'temperatura', 423.0000, 'ºC'),
	(47193, 111, '2015-02-01 01:05:58.000000', 'temperatura', 74.0000, 'ºC'),
	(47194, 111, '2015-02-01 01:05:59.000000', 'temperatura', 299.0000, 'ºC'),
	(47195, 111, '2015-02-01 01:06:00.000000', 'temperatura', 76.0000, 'ºC'),
	(47196, 111, '2015-02-01 01:06:01.000000', 'temperatura', 684.0000, 'ºC'),
	(47197, 111, '2015-02-01 01:06:02.000000', 'temperatura', 791.0000, 'ºC'),
	(47198, 111, '2015-02-01 01:06:03.000000', 'temperatura', 704.0000, 'ºC'),
	(47199, 111, '2015-02-01 01:06:04.000000', 'temperatura', 1148.0000, 'ºC'),
	(47200, 111, '2015-02-01 01:06:05.000000', 'temperatura', 28.0000, 'ºC'),
	(47201, 111, '2015-02-01 01:06:06.000000', 'temperatura', 296.0000, 'ºC'),
	(47202, 111, '2015-02-01 01:06:07.000000', 'temperatura', 199.0000, 'ºC'),
	(47203, 111, '2015-02-01 01:06:08.000000', 'temperatura', 105.0000, 'ºC'),
	(47204, 111, '2015-02-01 01:06:09.000000', 'temperatura', 1129.0000, 'ºC'),
	(47205, 111, '2015-02-01 01:06:10.000000', 'temperatura', 529.0000, 'ºC'),
	(47206, 112, '2015-02-01 00:00:00.000000', 'temperatura', 708.0000, 'ºC'),
	(47207, 112, '2015-02-01 00:00:01.000000', 'temperatura', 966.0000, 'ºC'),
	(47208, 112, '2015-02-01 00:00:02.000000', 'temperatura', 304.0000, 'ºC'),
	(47209, 112, '2015-02-01 00:00:03.000000', 'temperatura', 1022.0000, 'ºC'),
	(47210, 112, '2015-02-01 00:00:04.000000', 'temperatura', 598.0000, 'ºC'),
	(47211, 112, '2015-02-01 00:00:05.000000', 'temperatura', 1126.0000, 'ºC'),
	(47212, 112, '2015-02-01 00:00:06.000000', 'temperatura', 237.0000, 'ºC'),
	(47213, 112, '2015-02-01 00:00:07.000000', 'temperatura', 206.0000, 'ºC'),
	(47214, 112, '2015-02-01 00:00:08.000000', 'temperatura', 319.0000, 'ºC'),
	(47215, 112, '2015-02-01 00:00:09.000000', 'temperatura', 979.0000, 'ºC'),
	(47216, 112, '2015-02-01 00:00:10.000000', 'temperatura', 336.0000, 'ºC'),
	(47217, 112, '2015-02-01 00:00:11.000000', 'temperatura', 1147.0000, 'ºC'),
	(47218, 112, '2015-02-01 00:00:12.000000', 'temperatura', 1126.0000, 'ºC'),
	(47219, 112, '2015-02-01 00:00:13.000000', 'temperatura', 990.0000, 'ºC'),
	(47220, 112, '2015-02-01 00:00:14.000000', 'temperatura', 374.0000, 'ºC'),
	(47221, 112, '2015-02-01 00:00:15.000000', 'temperatura', 97.0000, 'ºC'),
	(47222, 112, '2015-02-01 00:00:16.000000', 'temperatura', 566.0000, 'ºC'),
	(47223, 112, '2015-02-01 00:00:17.000000', 'temperatura', 141.0000, 'ºC'),
	(47224, 112, '2015-02-01 00:00:18.000000', 'temperatura', 204.0000, 'ºC'),
	(47225, 112, '2015-02-01 00:00:19.000000', 'temperatura', 599.0000, 'ºC'),
	(47226, 112, '2015-02-01 00:00:20.000000', 'temperatura', 1185.0000, 'ºC'),
	(47227, 112, '2015-02-01 00:00:21.000000', 'temperatura', 529.0000, 'ºC'),
	(47228, 112, '2015-02-01 00:00:22.000000', 'temperatura', 291.0000, 'ºC'),
	(47229, 112, '2015-02-01 00:00:23.000000', 'temperatura', 1066.0000, 'ºC'),
	(47230, 112, '2015-02-01 00:00:24.000000', 'temperatura', 858.0000, 'ºC'),
	(47231, 112, '2015-02-01 00:00:25.000000', 'temperatura', 1092.0000, 'ºC'),
	(47232, 112, '2015-02-01 00:00:26.000000', 'temperatura', 487.0000, 'ºC'),
	(47233, 112, '2015-02-01 00:00:27.000000', 'temperatura', 360.0000, 'ºC'),
	(47234, 112, '2015-02-01 00:00:28.000000', 'temperatura', 340.0000, 'ºC'),
	(47235, 112, '2015-02-01 00:00:29.000000', 'temperatura', 621.0000, 'ºC'),
	(47236, 112, '2015-02-01 00:00:30.000000', 'temperatura', 887.0000, 'ºC'),
	(47237, 112, '2015-02-01 00:00:31.000000', 'temperatura', 169.0000, 'ºC'),
	(47238, 112, '2015-02-01 00:00:32.000000', 'temperatura', 587.0000, 'ºC'),
	(47239, 112, '2015-02-01 00:00:33.000000', 'temperatura', 29.0000, 'ºC'),
	(47240, 112, '2015-02-01 00:00:34.000000', 'temperatura', 784.0000, 'ºC'),
	(47241, 112, '2015-02-01 00:00:35.000000', 'temperatura', 235.0000, 'ºC'),
	(47242, 112, '2015-02-01 00:00:36.000000', 'temperatura', 21.0000, 'ºC'),
	(47243, 112, '2015-02-01 00:00:37.000000', 'temperatura', 603.0000, 'ºC'),
	(47244, 112, '2015-02-01 00:00:38.000000', 'temperatura', 550.0000, 'ºC'),
	(47245, 112, '2015-02-01 00:00:39.000000', 'temperatura', 944.0000, 'ºC'),
	(47246, 112, '2015-02-01 00:00:40.000000', 'temperatura', 669.0000, 'ºC'),
	(47247, 112, '2015-02-01 00:00:41.000000', 'temperatura', 513.0000, 'ºC'),
	(47248, 112, '2015-02-01 00:00:42.000000', 'temperatura', 558.0000, 'ºC'),
	(47249, 112, '2015-02-01 00:00:43.000000', 'temperatura', 54.0000, 'ºC'),
	(47250, 112, '2015-02-01 00:00:44.000000', 'temperatura', 995.0000, 'ºC'),
	(47251, 112, '2015-02-01 00:00:45.000000', 'temperatura', 13.0000, 'ºC'),
	(47252, 112, '2015-02-01 00:00:46.000000', 'temperatura', 682.0000, 'ºC'),
	(47253, 112, '2015-02-01 00:00:47.000000', 'temperatura', 973.0000, 'ºC'),
	(47254, 112, '2015-02-01 00:00:48.000000', 'temperatura', 416.0000, 'ºC'),
	(47255, 112, '2015-02-01 00:00:49.000000', 'temperatura', 364.0000, 'ºC'),
	(47256, 112, '2015-02-01 00:00:50.000000', 'temperatura', 572.0000, 'ºC'),
	(47257, 112, '2015-02-01 00:00:51.000000', 'temperatura', 568.0000, 'ºC'),
	(47258, 112, '2015-02-01 00:00:52.000000', 'temperatura', 1126.0000, 'ºC'),
	(47259, 112, '2015-02-01 00:00:53.000000', 'temperatura', 328.0000, 'ºC'),
	(47260, 112, '2015-02-01 00:00:54.000000', 'temperatura', 659.0000, 'ºC'),
	(47261, 112, '2015-02-01 00:00:55.000000', 'temperatura', 1114.0000, 'ºC'),
	(47262, 112, '2015-02-01 00:00:56.000000', 'temperatura', 1194.0000, 'ºC'),
	(47263, 112, '2015-02-01 00:00:57.000000', 'temperatura', 226.0000, 'ºC'),
	(47264, 112, '2015-02-01 00:00:58.000000', 'temperatura', 1150.0000, 'ºC'),
	(47265, 112, '2015-02-01 00:00:59.000000', 'temperatura', 271.0000, 'ºC'),
	(47266, 112, '2015-02-01 00:01:00.000000', 'temperatura', 306.0000, 'ºC'),
	(47267, 112, '2015-02-01 00:01:01.000000', 'temperatura', 718.0000, 'ºC'),
	(47268, 112, '2015-02-01 00:01:02.000000', 'temperatura', 273.0000, 'ºC'),
	(47269, 112, '2015-02-01 00:01:03.000000', 'temperatura', 413.0000, 'ºC'),
	(47270, 112, '2015-02-01 00:01:04.000000', 'temperatura', 45.0000, 'ºC'),
	(47271, 112, '2015-02-01 00:01:05.000000', 'temperatura', 187.0000, 'ºC'),
	(47272, 112, '2015-02-01 00:01:06.000000', 'temperatura', 799.0000, 'ºC'),
	(47273, 112, '2015-02-01 00:01:07.000000', 'temperatura', 1034.0000, 'ºC'),
	(47274, 112, '2015-02-01 00:01:08.000000', 'temperatura', 375.0000, 'ºC'),
	(47275, 112, '2015-02-01 00:01:09.000000', 'temperatura', 1174.0000, 'ºC'),
	(47276, 112, '2015-02-01 00:01:10.000000', 'temperatura', 1146.0000, 'ºC'),
	(47277, 112, '2015-02-01 00:01:11.000000', 'temperatura', 1008.0000, 'ºC'),
	(47278, 112, '2015-02-01 00:01:12.000000', 'temperatura', 404.0000, 'ºC'),
	(47279, 112, '2015-02-01 00:01:13.000000', 'temperatura', 195.0000, 'ºC'),
	(47280, 112, '2015-02-01 00:01:14.000000', 'temperatura', 964.0000, 'ºC'),
	(47281, 112, '2015-02-01 00:01:15.000000', 'temperatura', 636.0000, 'ºC'),
	(47282, 112, '2015-02-01 00:01:16.000000', 'temperatura', 290.0000, 'ºC'),
	(47283, 112, '2015-02-01 00:01:17.000000', 'temperatura', 740.0000, 'ºC'),
	(47284, 112, '2015-02-01 00:01:18.000000', 'temperatura', 432.0000, 'ºC'),
	(47285, 112, '2015-02-01 00:01:19.000000', 'temperatura', 1142.0000, 'ºC'),
	(47286, 112, '2015-02-01 00:01:20.000000', 'temperatura', 813.0000, 'ºC'),
	(47287, 112, '2015-02-01 00:01:21.000000', 'temperatura', 641.0000, 'ºC'),
	(47288, 112, '2015-02-01 00:01:22.000000', 'temperatura', 766.0000, 'ºC'),
	(47289, 112, '2015-02-01 00:01:23.000000', 'temperatura', 708.0000, 'ºC'),
	(47290, 112, '2015-02-01 00:01:24.000000', 'temperatura', 43.0000, 'ºC'),
	(47291, 112, '2015-02-01 00:01:25.000000', 'temperatura', 489.0000, 'ºC'),
	(47292, 112, '2015-02-01 00:01:26.000000', 'temperatura', 1116.0000, 'ºC'),
	(47293, 112, '2015-02-01 00:01:27.000000', 'temperatura', 515.0000, 'ºC'),
	(47294, 112, '2015-02-01 00:01:28.000000', 'temperatura', 429.0000, 'ºC'),
	(47295, 112, '2015-02-01 00:01:29.000000', 'temperatura', 597.0000, 'ºC'),
	(47296, 112, '2015-02-01 00:01:30.000000', 'temperatura', 501.0000, 'ºC'),
	(47297, 112, '2015-02-01 00:01:31.000000', 'temperatura', 713.0000, 'ºC'),
	(47298, 112, '2015-02-01 00:01:32.000000', 'temperatura', 863.0000, 'ºC'),
	(47299, 112, '2015-02-01 00:01:33.000000', 'temperatura', 976.0000, 'ºC'),
	(47300, 112, '2015-02-01 00:01:34.000000', 'temperatura', 1092.0000, 'ºC'),
	(47301, 112, '2015-02-01 00:01:35.000000', 'temperatura', 133.0000, 'ºC'),
	(47302, 112, '2015-02-01 00:01:36.000000', 'temperatura', 987.0000, 'ºC'),
	(47303, 112, '2015-02-01 00:01:37.000000', 'temperatura', 938.0000, 'ºC'),
	(47304, 112, '2015-02-01 00:01:38.000000', 'temperatura', 531.0000, 'ºC'),
	(47305, 112, '2015-02-01 00:01:39.000000', 'temperatura', 1039.0000, 'ºC'),
	(47306, 112, '2015-02-01 00:01:40.000000', 'temperatura', 5.0000, 'ºC'),
	(47307, 112, '2015-02-01 00:01:41.000000', 'temperatura', 507.0000, 'ºC'),
	(47308, 112, '2015-02-01 00:01:42.000000', 'temperatura', 121.0000, 'ºC'),
	(47309, 112, '2015-02-01 00:01:43.000000', 'temperatura', 284.0000, 'ºC'),
	(47310, 112, '2015-02-01 00:01:44.000000', 'temperatura', 1058.0000, 'ºC'),
	(47311, 112, '2015-02-01 00:01:45.000000', 'temperatura', 840.0000, 'ºC'),
	(47312, 112, '2015-02-01 00:01:46.000000', 'temperatura', 1027.0000, 'ºC'),
	(47313, 112, '2015-02-01 00:01:47.000000', 'temperatura', 213.0000, 'ºC'),
	(47314, 112, '2015-02-01 00:01:48.000000', 'temperatura', 387.0000, 'ºC'),
	(47315, 112, '2015-02-01 00:01:49.000000', 'temperatura', 97.0000, 'ºC'),
	(47316, 112, '2015-02-01 00:01:50.000000', 'temperatura', 523.0000, 'ºC'),
	(47317, 112, '2015-02-01 00:01:51.000000', 'temperatura', 1125.0000, 'ºC'),
	(47318, 112, '2015-02-01 00:01:52.000000', 'temperatura', 454.0000, 'ºC'),
	(47319, 112, '2015-02-01 00:01:53.000000', 'temperatura', 98.0000, 'ºC'),
	(47320, 112, '2015-02-01 00:01:54.000000', 'temperatura', 330.0000, 'ºC'),
	(47321, 112, '2015-02-01 00:01:55.000000', 'temperatura', 153.0000, 'ºC'),
	(47322, 112, '2015-02-01 00:01:56.000000', 'temperatura', 978.0000, 'ºC'),
	(47323, 112, '2015-02-01 00:01:57.000000', 'temperatura', 830.0000, 'ºC'),
	(47324, 112, '2015-02-01 00:01:58.000000', 'temperatura', 16.0000, 'ºC'),
	(47325, 112, '2015-02-01 00:01:59.000000', 'temperatura', 1191.0000, 'ºC'),
	(47326, 112, '2015-02-01 00:02:00.000000', 'temperatura', 1107.0000, 'ºC'),
	(47327, 112, '2015-02-01 00:02:01.000000', 'temperatura', 764.0000, 'ºC'),
	(47328, 112, '2015-02-01 00:02:02.000000', 'temperatura', 498.0000, 'ºC'),
	(47329, 112, '2015-02-01 00:02:03.000000', 'temperatura', 198.0000, 'ºC'),
	(47330, 112, '2015-02-01 00:02:04.000000', 'temperatura', 699.0000, 'ºC'),
	(47331, 112, '2015-02-01 00:02:05.000000', 'temperatura', 498.0000, 'ºC'),
	(47332, 112, '2015-02-01 00:02:06.000000', 'temperatura', 396.0000, 'ºC'),
	(47333, 112, '2015-02-01 00:02:07.000000', 'temperatura', 486.0000, 'ºC'),
	(47334, 112, '2015-02-01 00:02:08.000000', 'temperatura', 44.0000, 'ºC'),
	(47335, 112, '2015-02-01 00:02:09.000000', 'temperatura', 1162.0000, 'ºC'),
	(47336, 112, '2015-02-01 00:02:10.000000', 'temperatura', 879.0000, 'ºC'),
	(47337, 112, '2015-02-01 00:02:11.000000', 'temperatura', 907.0000, 'ºC'),
	(47338, 112, '2015-02-01 00:02:12.000000', 'temperatura', 700.0000, 'ºC'),
	(47339, 112, '2015-02-01 00:02:13.000000', 'temperatura', 780.0000, 'ºC'),
	(47340, 112, '2015-02-01 00:02:14.000000', 'temperatura', 598.0000, 'ºC'),
	(47341, 112, '2015-02-01 00:02:15.000000', 'temperatura', 652.0000, 'ºC'),
	(47342, 112, '2015-02-01 00:02:16.000000', 'temperatura', 269.0000, 'ºC'),
	(47343, 112, '2015-02-01 00:02:17.000000', 'temperatura', 586.0000, 'ºC'),
	(47344, 112, '2015-02-01 00:02:18.000000', 'temperatura', 924.0000, 'ºC'),
	(47345, 112, '2015-02-01 00:02:19.000000', 'temperatura', 464.0000, 'ºC'),
	(47346, 112, '2015-02-01 00:02:20.000000', 'temperatura', 747.0000, 'ºC'),
	(47347, 112, '2015-02-01 00:02:21.000000', 'temperatura', 1144.0000, 'ºC'),
	(47348, 112, '2015-02-01 00:02:22.000000', 'temperatura', 1078.0000, 'ºC'),
	(47349, 112, '2015-02-01 00:02:23.000000', 'temperatura', 758.0000, 'ºC'),
	(47350, 112, '2015-02-01 00:02:24.000000', 'temperatura', 556.0000, 'ºC'),
	(47351, 112, '2015-02-01 00:02:25.000000', 'temperatura', 508.0000, 'ºC'),
	(47352, 112, '2015-02-01 00:02:26.000000', 'temperatura', 872.0000, 'ºC'),
	(47353, 112, '2015-02-01 00:02:27.000000', 'temperatura', 438.0000, 'ºC'),
	(47354, 112, '2015-02-01 00:02:28.000000', 'temperatura', 773.0000, 'ºC'),
	(47355, 112, '2015-02-01 00:02:29.000000', 'temperatura', 153.0000, 'ºC'),
	(47356, 112, '2015-02-01 00:02:30.000000', 'temperatura', 846.0000, 'ºC'),
	(47357, 112, '2015-02-01 00:02:31.000000', 'temperatura', 171.0000, 'ºC'),
	(47358, 112, '2015-02-01 00:02:32.000000', 'temperatura', 719.0000, 'ºC'),
	(47359, 112, '2015-02-01 00:02:33.000000', 'temperatura', 682.0000, 'ºC'),
	(47360, 112, '2015-02-01 00:02:34.000000', 'temperatura', 54.0000, 'ºC'),
	(47361, 112, '2015-02-01 00:02:35.000000', 'temperatura', 624.0000, 'ºC'),
	(47362, 112, '2015-02-01 00:02:36.000000', 'temperatura', 558.0000, 'ºC'),
	(47363, 112, '2015-02-01 00:02:37.000000', 'temperatura', 919.0000, 'ºC'),
	(47364, 112, '2015-02-01 00:02:38.000000', 'temperatura', 522.0000, 'ºC'),
	(47365, 112, '2015-02-01 00:02:39.000000', 'temperatura', 1053.0000, 'ºC'),
	(47366, 112, '2015-02-01 00:02:40.000000', 'temperatura', 99.0000, 'ºC'),
	(47367, 112, '2015-02-01 00:02:41.000000', 'temperatura', 939.0000, 'ºC'),
	(47368, 112, '2015-02-01 00:02:42.000000', 'temperatura', 796.0000, 'ºC'),
	(47369, 112, '2015-02-01 00:02:43.000000', 'temperatura', 1162.0000, 'ºC'),
	(47370, 112, '2015-02-01 00:02:44.000000', 'temperatura', 1025.0000, 'ºC'),
	(47371, 112, '2015-02-01 00:02:45.000000', 'temperatura', 437.0000, 'ºC'),
	(47372, 112, '2015-02-01 00:02:46.000000', 'temperatura', 311.0000, 'ºC'),
	(47373, 112, '2015-02-01 00:02:47.000000', 'temperatura', 244.0000, 'ºC'),
	(47374, 112, '2015-02-01 00:02:48.000000', 'temperatura', 289.0000, 'ºC'),
	(47375, 112, '2015-02-01 00:02:49.000000', 'temperatura', 713.0000, 'ºC'),
	(47376, 112, '2015-02-01 00:02:50.000000', 'temperatura', 299.0000, 'ºC'),
	(47377, 112, '2015-02-01 00:02:51.000000', 'temperatura', 554.0000, 'ºC'),
	(47378, 112, '2015-02-01 00:02:52.000000', 'temperatura', 676.0000, 'ºC'),
	(47379, 112, '2015-02-01 00:02:53.000000', 'temperatura', 517.0000, 'ºC'),
	(47380, 112, '2015-02-01 00:02:54.000000', 'temperatura', 559.0000, 'ºC'),
	(47381, 112, '2015-02-01 00:02:55.000000', 'temperatura', 45.0000, 'ºC'),
	(47382, 112, '2015-02-01 00:02:56.000000', 'temperatura', 948.0000, 'ºC'),
	(47383, 112, '2015-02-01 00:02:57.000000', 'temperatura', 1005.0000, 'ºC'),
	(47384, 112, '2015-02-01 00:02:58.000000', 'temperatura', 980.0000, 'ºC'),
	(47385, 112, '2015-02-01 00:02:59.000000', 'temperatura', 686.0000, 'ºC'),
	(47386, 112, '2015-02-01 00:03:00.000000', 'temperatura', 491.0000, 'ºC'),
	(47387, 112, '2015-02-01 00:03:01.000000', 'temperatura', 397.0000, 'ºC'),
	(47388, 112, '2015-02-01 00:03:02.000000', 'temperatura', 515.0000, 'ºC'),
	(47389, 112, '2015-02-01 00:03:03.000000', 'temperatura', 182.0000, 'ºC'),
	(47390, 112, '2015-02-01 00:03:04.000000', 'temperatura', 566.0000, 'ºC'),
	(47391, 112, '2015-02-01 00:03:05.000000', 'temperatura', 1086.0000, 'ºC'),
	(47392, 112, '2015-02-01 00:03:06.000000', 'temperatura', 133.0000, 'ºC'),
	(47393, 112, '2015-02-01 00:03:07.000000', 'temperatura', 1005.0000, 'ºC'),
	(47394, 112, '2015-02-01 00:03:08.000000', 'temperatura', 1027.0000, 'ºC'),
	(47395, 112, '2015-02-01 00:03:09.000000', 'temperatura', 920.0000, 'ºC'),
	(47396, 112, '2015-02-01 00:03:10.000000', 'temperatura', 319.0000, 'ºC'),
	(47397, 112, '2015-02-01 00:03:11.000000', 'temperatura', 37.0000, 'ºC'),
	(47398, 112, '2015-02-01 00:03:12.000000', 'temperatura', 428.0000, 'ºC'),
	(47399, 112, '2015-02-01 00:03:13.000000', 'temperatura', 828.0000, 'ºC'),
	(47400, 112, '2015-02-01 00:03:14.000000', 'temperatura', 456.0000, 'ºC'),
	(47401, 112, '2015-02-01 00:03:15.000000', 'temperatura', 999.0000, 'ºC'),
	(47402, 112, '2015-02-01 00:03:16.000000', 'temperatura', 25.0000, 'ºC'),
	(47403, 112, '2015-02-01 00:03:17.000000', 'temperatura', 728.0000, 'ºC'),
	(47404, 112, '2015-02-01 00:03:18.000000', 'temperatura', 1167.0000, 'ºC'),
	(47405, 112, '2015-02-01 00:03:19.000000', 'temperatura', 53.0000, 'ºC'),
	(47406, 112, '2015-02-01 00:03:20.000000', 'temperatura', 364.0000, 'ºC'),
	(47407, 112, '2015-02-01 00:03:21.000000', 'temperatura', 459.0000, 'ºC'),
	(47408, 112, '2015-02-01 00:03:22.000000', 'temperatura', 6.0000, 'ºC'),
	(47409, 112, '2015-02-01 00:03:23.000000', 'temperatura', 1051.0000, 'ºC'),
	(47410, 112, '2015-02-01 00:03:24.000000', 'temperatura', 441.0000, 'ºC'),
	(47411, 112, '2015-02-01 00:03:25.000000', 'temperatura', 249.0000, 'ºC'),
	(47412, 112, '2015-02-01 00:03:26.000000', 'temperatura', 1124.0000, 'ºC'),
	(47413, 112, '2015-02-01 00:03:27.000000', 'temperatura', 76.0000, 'ºC'),
	(47414, 112, '2015-02-01 00:03:28.000000', 'temperatura', 605.0000, 'ºC'),
	(47415, 112, '2015-02-01 00:03:29.000000', 'temperatura', 397.0000, 'ºC'),
	(47416, 112, '2015-02-01 00:03:30.000000', 'temperatura', 170.0000, 'ºC'),
	(47417, 112, '2015-02-01 00:03:31.000000', 'temperatura', 863.0000, 'ºC'),
	(47418, 112, '2015-02-01 00:03:32.000000', 'temperatura', 202.0000, 'ºC'),
	(47419, 112, '2015-02-01 00:03:33.000000', 'temperatura', 823.0000, 'ºC'),
	(47420, 112, '2015-02-01 00:03:34.000000', 'temperatura', 1109.0000, 'ºC'),
	(47421, 112, '2015-02-01 00:03:35.000000', 'temperatura', 675.0000, 'ºC'),
	(47422, 112, '2015-02-01 00:03:36.000000', 'temperatura', 49.0000, 'ºC'),
	(47423, 112, '2015-02-01 00:03:37.000000', 'temperatura', 619.0000, 'ºC'),
	(47424, 112, '2015-02-01 00:03:38.000000', 'temperatura', 552.0000, 'ºC'),
	(47425, 112, '2015-02-01 00:03:39.000000', 'temperatura', 901.0000, 'ºC'),
	(47426, 112, '2015-02-01 00:03:40.000000', 'temperatura', 448.0000, 'ºC'),
	(47427, 112, '2015-02-01 00:03:41.000000', 'temperatura', 740.0000, 'ºC'),
	(47428, 112, '2015-02-01 00:03:42.000000', 'temperatura', 1156.0000, 'ºC'),
	(47429, 112, '2015-02-01 00:03:43.000000', 'temperatura', 1159.0000, 'ºC'),
	(47430, 112, '2015-02-01 00:03:44.000000', 'temperatura', 1126.0000, 'ºC'),
	(47431, 112, '2015-02-01 00:03:45.000000', 'temperatura', 957.0000, 'ºC'),
	(47432, 112, '2015-02-01 00:03:46.000000', 'temperatura', 206.0000, 'ºC'),
	(47433, 112, '2015-02-01 00:03:47.000000', 'temperatura', 558.0000, 'ºC'),
	(47434, 112, '2015-02-01 00:03:48.000000', 'temperatura', 975.0000, 'ºC'),
	(47435, 112, '2015-02-01 00:03:49.000000', 'temperatura', 799.0000, 'ºC'),
	(47436, 112, '2015-02-01 00:03:50.000000', 'temperatura', 1072.0000, 'ºC'),
	(47437, 112, '2015-02-01 00:03:51.000000', 'temperatura', 561.0000, 'ºC'),
	(47438, 112, '2015-02-01 00:03:52.000000', 'temperatura', 792.0000, 'ºC'),
	(47439, 112, '2015-02-01 00:03:53.000000', 'temperatura', 1077.0000, 'ºC'),
	(47440, 112, '2015-02-01 00:03:54.000000', 'temperatura', 608.0000, 'ºC'),
	(47441, 112, '2015-02-01 00:03:55.000000', 'temperatura', 1010.0000, 'ºC'),
	(47442, 112, '2015-02-01 00:03:56.000000', 'temperatura', 825.0000, 'ºC'),
	(47443, 112, '2015-02-01 00:03:57.000000', 'temperatura', 1097.0000, 'ºC'),
	(47444, 112, '2015-02-01 00:03:58.000000', 'temperatura', 611.0000, 'ºC'),
	(47445, 112, '2015-02-01 00:03:59.000000', 'temperatura', 964.0000, 'ºC'),
	(47446, 112, '2015-02-01 00:04:00.000000', 'temperatura', 587.0000, 'ºC'),
	(47447, 112, '2015-02-01 00:04:01.000000', 'temperatura', 43.0000, 'ºC'),
	(47448, 112, '2015-02-01 00:04:02.000000', 'temperatura', 853.0000, 'ºC'),
	(47449, 112, '2015-02-01 00:04:03.000000', 'temperatura', 538.0000, 'ºC'),
	(47450, 112, '2015-02-01 00:04:04.000000', 'temperatura', 133.0000, 'ºC'),
	(47451, 112, '2015-02-01 00:04:05.000000', 'temperatura', 252.0000, 'ºC'),
	(47452, 112, '2015-02-01 00:04:06.000000', 'temperatura', 862.0000, 'ºC'),
	(47453, 112, '2015-02-01 00:04:07.000000', 'temperatura', 1152.0000, 'ºC'),
	(47454, 112, '2015-02-01 00:04:08.000000', 'temperatura', 776.0000, 'ºC'),
	(47455, 112, '2015-02-01 00:04:09.000000', 'temperatura', 423.0000, 'ºC'),
	(47456, 112, '2015-02-01 00:04:10.000000', 'temperatura', 987.0000, 'ºC'),
	(47457, 112, '2015-02-01 00:04:11.000000', 'temperatura', 67.0000, 'ºC'),
	(47458, 112, '2015-02-01 00:04:12.000000', 'temperatura', 974.0000, 'ºC'),
	(47459, 112, '2015-02-01 00:04:13.000000', 'temperatura', 1071.0000, 'ºC'),
	(47460, 112, '2015-02-01 00:04:14.000000', 'temperatura', 32.0000, 'ºC'),
	(47461, 112, '2015-02-01 00:04:15.000000', 'temperatura', 548.0000, 'ºC'),
	(47462, 112, '2015-02-01 00:04:16.000000', 'temperatura', 245.0000, 'ºC'),
	(47463, 112, '2015-02-01 00:04:17.000000', 'temperatura', 782.0000, 'ºC'),
	(47464, 112, '2015-02-01 00:04:18.000000', 'temperatura', 774.0000, 'ºC'),
	(47465, 112, '2015-02-01 00:04:19.000000', 'temperatura', 326.0000, 'ºC'),
	(47466, 112, '2015-02-01 00:04:20.000000', 'temperatura', 509.0000, 'ºC'),
	(47467, 112, '2015-02-01 00:04:21.000000', 'temperatura', 366.0000, 'ºC'),
	(47468, 112, '2015-02-01 00:04:22.000000', 'temperatura', 304.0000, 'ºC'),
	(47469, 112, '2015-02-01 00:04:23.000000', 'temperatura', 421.0000, 'ºC'),
	(47470, 112, '2015-02-01 00:04:24.000000', 'temperatura', 1193.0000, 'ºC'),
	(47471, 112, '2015-02-01 00:04:25.000000', 'temperatura', 1103.0000, 'ºC'),
	(47472, 112, '2015-02-01 00:04:26.000000', 'temperatura', 735.0000, 'ºC'),
	(47473, 112, '2015-02-01 00:04:27.000000', 'temperatura', 369.0000, 'ºC'),
	(47474, 112, '2015-02-01 00:04:28.000000', 'temperatura', 839.0000, 'ºC'),
	(47475, 112, '2015-02-01 00:04:29.000000', 'temperatura', 691.0000, 'ºC'),
	(47476, 112, '2015-02-01 00:04:30.000000', 'temperatura', 936.0000, 'ºC'),
	(47477, 112, '2015-02-01 00:04:31.000000', 'temperatura', 208.0000, 'ºC'),
	(47478, 112, '2015-02-01 00:04:32.000000', 'temperatura', 631.0000, 'ºC'),
	(47479, 112, '2015-02-01 00:04:33.000000', 'temperatura', 131.0000, 'ºC'),
	(47480, 112, '2015-02-01 00:04:34.000000', 'temperatura', 1165.0000, 'ºC'),
	(47481, 112, '2015-02-01 00:04:35.000000', 'temperatura', 631.0000, 'ºC'),
	(47482, 112, '2015-02-01 00:04:36.000000', 'temperatura', 859.0000, 'ºC'),
	(47483, 112, '2015-02-01 00:04:37.000000', 'temperatura', 4.0000, 'ºC'),
	(47484, 112, '2015-02-01 00:04:38.000000', 'temperatura', 1043.0000, 'ºC'),
	(47485, 112, '2015-02-01 00:04:39.000000', 'temperatura', 402.0000, 'ºC'),
	(47486, 112, '2015-02-01 00:04:40.000000', 'temperatura', 81.0000, 'ºC'),
	(47487, 112, '2015-02-01 00:04:41.000000', 'temperatura', 401.0000, 'ºC'),
	(47488, 112, '2015-02-01 00:04:42.000000', 'temperatura', 564.0000, 'ºC'),
	(47489, 112, '2015-02-01 00:04:43.000000', 'temperatura', 415.0000, 'ºC'),
	(47490, 112, '2015-02-01 00:04:44.000000', 'temperatura', 385.0000, 'ºC'),
	(47491, 112, '2015-02-01 00:04:45.000000', 'temperatura', 679.0000, 'ºC'),
	(47492, 112, '2015-02-01 00:04:46.000000', 'temperatura', 1039.0000, 'ºC'),
	(47493, 112, '2015-02-01 00:04:47.000000', 'temperatura', 761.0000, 'ºC'),
	(47494, 112, '2015-02-01 00:04:48.000000', 'temperatura', 689.0000, 'ºC'),
	(47495, 112, '2015-02-01 00:04:49.000000', 'temperatura', 1160.0000, 'ºC'),
	(47496, 112, '2015-02-01 00:04:50.000000', 'temperatura', 135.0000, 'ºC'),
	(47497, 112, '2015-02-01 00:04:51.000000', 'temperatura', 795.0000, 'ºC'),
	(47498, 112, '2015-02-01 00:04:52.000000', 'temperatura', 1169.0000, 'ºC'),
	(47499, 112, '2015-02-01 00:04:53.000000', 'temperatura', 1061.0000, 'ºC'),
	(47500, 112, '2015-02-01 00:04:54.000000', 'temperatura', 600.0000, 'ºC'),
	(47501, 112, '2015-02-01 00:04:55.000000', 'temperatura', 1018.0000, 'ºC'),
	(47502, 112, '2015-02-01 00:04:56.000000', 'temperatura', 891.0000, 'ºC'),
	(47503, 112, '2015-02-01 00:04:57.000000', 'temperatura', 200.0000, 'ºC'),
	(47504, 112, '2015-02-01 00:04:58.000000', 'temperatura', 726.0000, 'ºC'),
	(47505, 112, '2015-02-01 00:04:59.000000', 'temperatura', 632.0000, 'ºC'),
	(47506, 112, '2015-02-01 00:05:00.000000', 'temperatura', 984.0000, 'ºC'),
	(47507, 112, '2015-02-01 00:05:01.000000', 'temperatura', 623.0000, 'ºC'),
	(47508, 112, '2015-02-01 00:05:02.000000', 'temperatura', 163.0000, 'ºC'),
	(47509, 112, '2015-02-01 00:05:03.000000', 'temperatura', 147.0000, 'ºC'),
	(47510, 112, '2015-02-01 00:05:04.000000', 'temperatura', 246.0000, 'ºC'),
	(47511, 112, '2015-02-01 00:05:05.000000', 'temperatura', 791.0000, 'ºC'),
	(47512, 112, '2015-02-01 00:05:06.000000', 'temperatura', 817.0000, 'ºC'),
	(47513, 112, '2015-02-01 00:05:07.000000', 'temperatura', 510.0000, 'ºC'),
	(47514, 112, '2015-02-01 00:05:08.000000', 'temperatura', 102.0000, 'ºC'),
	(47515, 112, '2015-02-01 00:05:09.000000', 'temperatura', 181.0000, 'ºC'),
	(47516, 112, '2015-02-01 00:05:10.000000', 'temperatura', 597.0000, 'ºC'),
	(47517, 112, '2015-02-01 00:05:11.000000', 'temperatura', 43.0000, 'ºC'),
	(47518, 112, '2015-02-01 00:05:12.000000', 'temperatura', 823.0000, 'ºC'),
	(47519, 112, '2015-02-01 00:05:13.000000', 'temperatura', 390.0000, 'ºC'),
	(47520, 112, '2015-02-01 00:05:14.000000', 'temperatura', 680.0000, 'ºC'),
	(47521, 112, '2015-02-01 00:05:15.000000', 'temperatura', 1030.0000, 'ºC'),
	(47522, 112, '2015-02-01 00:05:16.000000', 'temperatura', 709.0000, 'ºC'),
	(47523, 112, '2015-02-01 00:05:17.000000', 'temperatura', 459.0000, 'ºC'),
	(47524, 112, '2015-02-01 00:05:18.000000', 'temperatura', 166.0000, 'ºC'),
	(47525, 112, '2015-02-01 00:05:19.000000', 'temperatura', 654.0000, 'ºC'),
	(47526, 112, '2015-02-01 00:05:20.000000', 'temperatura', 373.0000, 'ºC'),
	(47527, 112, '2015-02-01 00:05:21.000000', 'temperatura', 1105.0000, 'ºC'),
	(47528, 112, '2015-02-01 00:05:22.000000', 'temperatura', 806.0000, 'ºC'),
	(47529, 112, '2015-02-01 00:05:23.000000', 'temperatura', 714.0000, 'ºC'),
	(47530, 112, '2015-02-01 00:05:24.000000', 'temperatura', 1154.0000, 'ºC'),
	(47531, 112, '2015-02-01 00:05:25.000000', 'temperatura', 29.0000, 'ºC'),
	(47532, 112, '2015-02-01 00:05:26.000000', 'temperatura', 282.0000, 'ºC'),
	(47533, 112, '2015-02-01 00:05:27.000000', 'temperatura', 125.0000, 'ºC'),
	(47534, 112, '2015-02-01 00:05:28.000000', 'temperatura', 979.0000, 'ºC'),
	(47535, 112, '2015-02-01 00:05:29.000000', 'temperatura', 922.0000, 'ºC'),
	(47536, 112, '2015-02-01 00:05:30.000000', 'temperatura', 473.0000, 'ºC'),
	(47537, 112, '2015-02-01 00:05:31.000000', 'temperatura', 798.0000, 'ºC'),
	(47538, 112, '2015-02-01 00:05:32.000000', 'temperatura', 173.0000, 'ºC'),
	(47539, 112, '2015-02-01 00:05:33.000000', 'temperatura', 873.0000, 'ºC'),
	(47540, 112, '2015-02-01 00:05:34.000000', 'temperatura', 244.0000, 'ºC'),
	(47541, 112, '2015-02-01 00:05:35.000000', 'temperatura', 1001.0000, 'ºC'),
	(47542, 112, '2015-02-01 00:05:36.000000', 'temperatura', 673.0000, 'ºC'),
	(47543, 112, '2015-02-01 00:05:37.000000', 'temperatura', 366.0000, 'ºC'),
	(47544, 112, '2015-02-01 00:05:38.000000', 'temperatura', 1008.0000, 'ºC'),
	(47545, 112, '2015-02-01 00:05:39.000000', 'temperatura', 344.0000, 'ºC'),
	(47546, 112, '2015-02-01 00:05:40.000000', 'temperatura', 1095.0000, 'ºC'),
	(47547, 112, '2015-02-01 00:05:41.000000', 'temperatura', 846.0000, 'ºC'),
	(47548, 112, '2015-02-01 00:05:42.000000', 'temperatura', 944.0000, 'ºC'),
	(47549, 112, '2015-02-01 00:05:43.000000', 'temperatura', 984.0000, 'ºC'),
	(47550, 112, '2015-02-01 00:05:44.000000', 'temperatura', 889.0000, 'ºC'),
	(47551, 112, '2015-02-01 00:05:45.000000', 'temperatura', 294.0000, 'ºC'),
	(47552, 112, '2015-02-01 00:05:46.000000', 'temperatura', 3.0000, 'ºC'),
	(47553, 112, '2015-02-01 00:05:47.000000', 'temperatura', 331.0000, 'ºC'),
	(47554, 112, '2015-02-01 00:05:48.000000', 'temperatura', 448.0000, 'ºC'),
	(47555, 112, '2015-02-01 00:05:49.000000', 'temperatura', 48.0000, 'ºC'),
	(47556, 112, '2015-02-01 00:05:50.000000', 'temperatura', 96.0000, 'ºC'),
	(47557, 112, '2015-02-01 00:05:51.000000', 'temperatura', 339.0000, 'ºC'),
	(47558, 112, '2015-02-01 00:05:52.000000', 'temperatura', 204.0000, 'ºC'),
	(47559, 112, '2015-02-01 00:05:53.000000', 'temperatura', 6.0000, 'ºC'),
	(47560, 112, '2015-02-01 00:05:54.000000', 'temperatura', 617.0000, 'ºC'),
	(47561, 112, '2015-02-01 00:05:55.000000', 'temperatura', 670.0000, 'ºC'),
	(47562, 112, '2015-02-01 00:05:56.000000', 'temperatura', 298.0000, 'ºC'),
	(47563, 112, '2015-02-01 00:05:57.000000', 'temperatura', 679.0000, 'ºC'),
	(47564, 112, '2015-02-01 00:05:58.000000', 'temperatura', 105.0000, 'ºC'),
	(47565, 112, '2015-02-01 00:05:59.000000', 'temperatura', 886.0000, 'ºC'),
	(47566, 112, '2015-02-01 00:06:00.000000', 'temperatura', 515.0000, 'ºC'),
	(47567, 112, '2015-02-01 00:06:01.000000', 'temperatura', 1116.0000, 'ºC'),
	(47568, 112, '2015-02-01 00:06:02.000000', 'temperatura', 438.0000, 'ºC'),
	(47569, 112, '2015-02-01 00:06:03.000000', 'temperatura', 43.0000, 'ºC'),
	(47570, 112, '2015-02-01 00:06:04.000000', 'temperatura', 99.0000, 'ºC'),
	(47571, 112, '2015-02-01 00:06:05.000000', 'temperatura', 368.0000, 'ºC'),
	(47572, 112, '2015-02-01 00:06:06.000000', 'temperatura', 343.0000, 'ºC'),
	(47573, 112, '2015-02-01 00:06:07.000000', 'temperatura', 611.0000, 'ºC'),
	(47574, 112, '2015-02-01 00:06:08.000000', 'temperatura', 827.0000, 'ºC'),
	(47575, 112, '2015-02-01 00:06:09.000000', 'temperatura', 1104.0000, 'ºC'),
	(47576, 112, '2015-02-01 00:06:10.000000', 'temperatura', 637.0000, 'ºC'),
	(47577, 112, '2015-02-01 00:06:11.000000', 'temperatura', 1076.0000, 'ºC'),
	(47578, 112, '2015-02-01 00:06:12.000000', 'temperatura', 1069.0000, 'ºC'),
	(47579, 112, '2015-02-01 00:06:13.000000', 'temperatura', 916.0000, 'ºC'),
	(47580, 112, '2015-02-01 00:06:14.000000', 'temperatura', 175.0000, 'ºC'),
	(47581, 112, '2015-02-01 00:06:15.000000', 'temperatura', 527.0000, 'ºC'),
	(47582, 112, '2015-02-01 00:06:16.000000', 'temperatura', 910.0000, 'ºC'),
	(47583, 112, '2015-02-01 00:06:17.000000', 'temperatura', 570.0000, 'ºC'),
	(47584, 112, '2015-02-01 00:06:18.000000', 'temperatura', 120.0000, 'ºC'),
	(47585, 112, '2015-02-01 00:06:19.000000', 'temperatura', 91.0000, 'ºC'),
	(47586, 112, '2015-02-01 00:06:20.000000', 'temperatura', 97.0000, 'ºC'),
	(47587, 112, '2015-02-01 00:06:21.000000', 'temperatura', 212.0000, 'ºC'),
	(47588, 112, '2015-02-01 00:06:22.000000', 'temperatura', 770.0000, 'ºC'),
	(47589, 112, '2015-02-01 00:06:23.000000', 'temperatura', 812.0000, 'ºC'),
	(47590, 112, '2015-02-01 00:06:24.000000', 'temperatura', 554.0000, 'ºC'),
	(47591, 112, '2015-02-01 00:06:25.000000', 'temperatura', 331.0000, 'ºC'),
	(47592, 112, '2015-02-01 00:06:26.000000', 'temperatura', 1197.0000, 'ºC'),
	(47593, 112, '2015-02-01 00:06:27.000000', 'temperatura', 189.0000, 'ºC'),
	(47594, 112, '2015-02-01 00:06:28.000000', 'temperatura', 956.0000, 'ºC'),
	(47595, 112, '2015-02-01 00:06:29.000000', 'temperatura', 612.0000, 'ºC'),
	(47596, 112, '2015-02-01 00:06:30.000000', 'temperatura', 192.0000, 'ºC'),
	(47597, 112, '2015-02-01 00:06:31.000000', 'temperatura', 324.0000, 'ºC'),
	(47598, 112, '2015-02-01 00:06:32.000000', 'temperatura', 1046.0000, 'ºC'),
	(47599, 112, '2015-02-01 00:06:33.000000', 'temperatura', 658.0000, 'ºC'),
	(47600, 112, '2015-02-01 00:06:34.000000', 'temperatura', 152.0000, 'ºC'),
	(47601, 112, '2015-02-01 00:06:35.000000', 'temperatura', 1188.0000, 'ºC'),
	(47602, 112, '2015-02-01 00:06:36.000000', 'temperatura', 683.0000, 'ºC'),
	(47603, 112, '2015-02-01 00:06:37.000000', 'temperatura', 1053.0000, 'ºC'),
	(47604, 112, '2015-02-01 00:06:38.000000', 'temperatura', 817.0000, 'ºC'),
	(47605, 112, '2015-02-01 00:06:39.000000', 'temperatura', 928.0000, 'ºC'),
	(47606, 112, '2015-02-01 00:06:40.000000', 'temperatura', 987.0000, 'ºC'),
	(47607, 112, '2015-02-01 00:06:41.000000', 'temperatura', 950.0000, 'ºC'),
	(47608, 112, '2015-02-01 00:06:42.000000', 'temperatura', 591.0000, 'ºC'),
	(47609, 112, '2015-02-01 00:06:43.000000', 'temperatura', 105.0000, 'ºC'),
	(47610, 112, '2015-02-01 00:06:44.000000', 'temperatura', 1152.0000, 'ºC'),
	(47611, 112, '2015-02-01 00:06:45.000000', 'temperatura', 645.0000, 'ºC'),
	(47612, 112, '2015-02-01 00:06:46.000000', 'temperatura', 972.0000, 'ºC'),
	(47613, 112, '2015-02-01 00:06:47.000000', 'temperatura', 524.0000, 'ºC'),
	(47614, 112, '2015-02-01 00:06:48.000000', 'temperatura', 903.0000, 'ºC'),
	(47615, 112, '2015-02-01 00:06:49.000000', 'temperatura', 546.0000, 'ºC'),
	(47616, 112, '2015-02-01 00:06:50.000000', 'temperatura', 19.0000, 'ºC'),
	(47617, 112, '2015-02-01 00:06:51.000000', 'temperatura', 860.0000, 'ºC'),
	(47618, 112, '2015-02-01 00:06:52.000000', 'temperatura', 641.0000, 'ºC'),
	(47619, 112, '2015-02-01 00:06:53.000000', 'temperatura', 627.0000, 'ºC'),
	(47620, 112, '2015-02-01 00:06:54.000000', 'temperatura', 14.0000, 'ºC'),
	(47621, 112, '2015-02-01 00:06:55.000000', 'temperatura', 590.0000, 'ºC'),
	(47622, 112, '2015-02-01 00:06:56.000000', 'temperatura', 505.0000, 'ºC'),
	(47623, 112, '2015-02-01 00:06:57.000000', 'temperatura', 759.0000, 'ºC'),
	(47624, 112, '2015-02-01 00:06:58.000000', 'temperatura', 1080.0000, 'ºC'),
	(47625, 112, '2015-02-01 00:06:59.000000', 'temperatura', 723.0000, 'ºC'),
	(47626, 112, '2015-02-01 00:07:00.000000', 'temperatura', 374.0000, 'ºC'),
	(47627, 112, '2015-02-01 00:07:01.000000', 'temperatura', 904.0000, 'ºC'),
	(47628, 112, '2015-02-01 00:07:02.000000', 'temperatura', 998.0000, 'ºC'),
	(47629, 112, '2015-02-01 00:07:03.000000', 'temperatura', 1079.0000, 'ºC'),
	(47630, 112, '2015-02-01 00:07:04.000000', 'temperatura', 2.0000, 'ºC'),
	(47631, 112, '2015-02-01 00:07:05.000000', 'temperatura', 372.0000, 'ºC'),
	(47632, 112, '2015-02-01 00:07:06.000000', 'temperatura', 654.0000, 'ºC'),
	(47633, 112, '2015-02-01 00:07:07.000000', 'temperatura', 957.0000, 'ºC'),
	(47634, 112, '2015-02-01 00:07:08.000000', 'temperatura', 423.0000, 'ºC'),
	(47635, 112, '2015-02-01 00:07:09.000000', 'temperatura', 444.0000, 'ºC'),
	(47636, 112, '2015-02-01 00:07:10.000000', 'temperatura', 951.0000, 'ºC'),
	(47637, 112, '2015-02-01 00:07:11.000000', 'temperatura', 1025.0000, 'ºC'),
	(47638, 112, '2015-02-01 00:07:12.000000', 'temperatura', 1071.0000, 'ºC'),
	(47639, 112, '2015-02-01 00:07:13.000000', 'temperatura', 1079.0000, 'ºC'),
	(47640, 112, '2015-02-01 00:07:14.000000', 'temperatura', 984.0000, 'ºC'),
	(47641, 112, '2015-02-01 00:07:15.000000', 'temperatura', 482.0000, 'ºC'),
	(47642, 112, '2015-02-01 00:07:16.000000', 'temperatura', 658.0000, 'ºC'),
	(47643, 112, '2015-02-01 00:07:17.000000', 'temperatura', 646.0000, 'ºC'),
	(47644, 112, '2015-02-01 00:07:18.000000', 'temperatura', 55.0000, 'ºC'),
	(47645, 112, '2015-02-01 00:07:19.000000', 'temperatura', 739.0000, 'ºC'),
	(47646, 112, '2015-02-01 00:07:20.000000', 'temperatura', 1129.0000, 'ºC'),
	(47647, 112, '2015-02-01 00:07:21.000000', 'temperatura', 1029.0000, 'ºC'),
	(47648, 112, '2015-02-01 00:07:22.000000', 'temperatura', 560.0000, 'ºC'),
	(47649, 112, '2015-02-01 00:07:23.000000', 'temperatura', 911.0000, 'ºC'),
	(47650, 112, '2015-02-01 00:07:24.000000', 'temperatura', 478.0000, 'ºC'),
	(47651, 112, '2015-02-01 00:07:25.000000', 'temperatura', 854.0000, 'ºC'),
	(47652, 112, '2015-02-01 00:07:26.000000', 'temperatura', 440.0000, 'ºC'),
	(47653, 112, '2015-02-01 00:07:27.000000', 'temperatura', 837.0000, 'ºC'),
	(47654, 112, '2015-02-01 00:07:28.000000', 'temperatura', 466.0000, 'ºC'),
	(47655, 112, '2015-02-01 00:07:29.000000', 'temperatura', 1019.0000, 'ºC'),
	(47656, 112, '2015-02-01 00:07:30.000000', 'temperatura', 100.0000, 'ºC'),
	(47657, 112, '2015-02-01 00:07:31.000000', 'temperatura', 1040.0000, 'ºC'),
	(47658, 112, '2015-02-01 00:07:32.000000', 'temperatura', 102.0000, 'ºC'),
	(47659, 112, '2015-02-01 00:07:33.000000', 'temperatura', 991.0000, 'ºC'),
	(47660, 112, '2015-02-01 00:07:34.000000', 'temperatura', 1049.0000, 'ºC'),
	(47661, 112, '2015-02-01 00:07:35.000000', 'temperatura', 1072.0000, 'ºC'),
	(47662, 112, '2015-02-01 00:07:36.000000', 'temperatura', 1012.0000, 'ºC'),
	(47663, 112, '2015-02-01 00:07:37.000000', 'temperatura', 647.0000, 'ºC'),
	(47664, 112, '2015-02-01 00:07:38.000000', 'temperatura', 197.0000, 'ºC'),
	(47665, 112, '2015-02-01 00:07:39.000000', 'temperatura', 246.0000, 'ºC'),
	(47666, 112, '2015-02-01 00:07:40.000000', 'temperatura', 640.0000, 'ºC'),
	(47667, 112, '2015-02-01 00:07:41.000000', 'temperatura', 61.0000, 'ºC'),
	(47668, 112, '2015-02-01 00:07:42.000000', 'temperatura', 788.0000, 'ºC'),
	(47669, 112, '2015-02-01 00:07:43.000000', 'temperatura', 156.0000, 'ºC'),
	(47670, 112, '2015-02-01 00:07:44.000000', 'temperatura', 815.0000, 'ºC'),
	(47671, 112, '2015-02-01 00:07:45.000000', 'temperatura', 7.0000, 'ºC'),
	(47672, 112, '2015-02-01 00:07:46.000000', 'temperatura', 1191.0000, 'ºC'),
	(47673, 112, '2015-02-01 00:07:47.000000', 'temperatura', 1135.0000, 'ºC'),
	(47674, 112, '2015-02-01 00:07:48.000000', 'temperatura', 904.0000, 'ºC'),
	(47675, 112, '2015-02-01 00:07:49.000000', 'temperatura', 1112.0000, 'ºC'),
	(47676, 112, '2015-02-01 00:07:50.000000', 'temperatura', 452.0000, 'ºC'),
	(47677, 112, '2015-02-01 00:07:51.000000', 'temperatura', 125.0000, 'ºC'),
	(47678, 112, '2015-02-01 00:07:52.000000', 'temperatura', 467.0000, 'ºC'),
	(47679, 112, '2015-02-01 00:07:53.000000', 'temperatura', 760.0000, 'ºC'),
	(47680, 112, '2015-02-01 00:07:54.000000', 'temperatura', 1.0000, 'ºC'),
	(47681, 112, '2015-02-01 00:07:55.000000', 'temperatura', 123.0000, 'ºC'),
	(47682, 112, '2015-02-01 00:07:56.000000', 'temperatura', 615.0000, 'ºC'),
	(47683, 112, '2015-02-01 00:07:57.000000', 'temperatura', 307.0000, 'ºC'),
	(47684, 112, '2015-02-01 00:07:58.000000', 'temperatura', 890.0000, 'ºC'),
	(47685, 112, '2015-02-01 00:07:59.000000', 'temperatura', 1129.0000, 'ºC'),
	(47686, 112, '2015-02-01 00:08:00.000000', 'temperatura', 576.0000, 'ºC'),
	(47687, 112, '2015-02-01 00:08:01.000000', 'temperatura', 694.0000, 'ºC'),
	(47688, 112, '2015-02-01 00:08:02.000000', 'temperatura', 544.0000, 'ºC'),
	(47689, 112, '2015-02-01 00:08:03.000000', 'temperatura', 637.0000, 'ºC'),
	(47690, 112, '2015-02-01 00:08:04.000000', 'temperatura', 356.0000, 'ºC'),
	(47691, 112, '2015-02-01 00:08:05.000000', 'temperatura', 1066.0000, 'ºC'),
	(47692, 112, '2015-02-01 00:08:06.000000', 'temperatura', 665.0000, 'ºC'),
	(47693, 112, '2015-02-01 00:08:07.000000', 'temperatura', 127.0000, 'ºC'),
	(47694, 112, '2015-02-01 00:08:08.000000', 'temperatura', 1041.0000, 'ºC'),
	(47695, 112, '2015-02-01 00:08:09.000000', 'temperatura', 26.0000, 'ºC'),
	(47696, 112, '2015-02-01 00:08:10.000000', 'temperatura', 604.0000, 'ºC'),
	(47697, 112, '2015-02-01 00:08:11.000000', 'temperatura', 544.0000, 'ºC'),
	(47698, 112, '2015-02-01 00:08:12.000000', 'temperatura', 909.0000, 'ºC'),
	(47699, 112, '2015-02-01 00:08:13.000000', 'temperatura', 512.0000, 'ºC'),
	(47700, 112, '2015-02-01 00:08:14.000000', 'temperatura', 1036.0000, 'ºC'),
	(47701, 112, '2015-02-01 00:08:15.000000', 'temperatura', 44.0000, 'ºC'),
	(47702, 112, '2015-02-01 00:08:16.000000', 'temperatura', 711.0000, 'ºC'),
	(47703, 112, '2015-02-01 00:08:17.000000', 'temperatura', 1025.0000, 'ºC'),
	(47704, 112, '2015-02-01 00:08:18.000000', 'temperatura', 593.0000, 'ºC'),
	(47705, 112, '2015-02-01 00:08:19.000000', 'temperatura', 1089.0000, 'ºC'),
	(47706, 112, '2015-02-01 00:08:20.000000', 'temperatura', 69.0000, 'ºC'),
	(47707, 112, '2015-02-01 00:08:21.000000', 'temperatura', 677.0000, 'ºC'),
	(47708, 112, '2015-02-01 00:08:22.000000', 'temperatura', 779.0000, 'ºC'),
	(47709, 112, '2015-02-01 00:08:23.000000', 'temperatura', 665.0000, 'ºC'),
	(47710, 112, '2015-02-01 00:08:24.000000', 'temperatura', 990.0000, 'ºC'),
	(47711, 112, '2015-02-01 00:08:25.000000', 'temperatura', 554.0000, 'ºC'),
	(47712, 112, '2015-02-01 00:08:26.000000', 'temperatura', 1002.0000, 'ºC'),
	(47713, 112, '2015-02-01 00:08:27.000000', 'temperatura', 946.0000, 'ºC'),
	(47714, 112, '2015-02-01 00:08:28.000000', 'temperatura', 524.0000, 'ºC'),
	(47715, 112, '2015-02-01 00:08:29.000000', 'temperatura', 982.0000, 'ºC'),
	(47716, 112, '2015-02-01 00:08:30.000000', 'temperatura', 938.0000, 'ºC'),
	(47717, 112, '2015-02-01 00:08:31.000000', 'temperatura', 544.0000, 'ºC'),
	(47718, 112, '2015-02-01 00:08:32.000000', 'temperatura', 1107.0000, 'ºC'),
	(47719, 112, '2015-02-01 00:08:33.000000', 'temperatura', 303.0000, 'ºC'),
	(47720, 112, '2015-02-01 00:08:34.000000', 'temperatura', 597.0000, 'ºC'),
	(47721, 112, '2015-02-01 00:08:35.000000', 'temperatura', 875.0000, 'ºC'),
	(47722, 112, '2015-02-01 00:08:36.000000', 'temperatura', 183.0000, 'ºC'),
	(47723, 112, '2015-02-01 00:08:37.000000', 'temperatura', 690.0000, 'ºC'),
	(47724, 112, '2015-02-01 00:08:38.000000', 'temperatura', 504.0000, 'ºC'),
	(47725, 112, '2015-02-01 00:08:39.000000', 'temperatura', 448.0000, 'ºC'),
	(47726, 112, '2015-02-01 00:08:40.000000', 'temperatura', 728.0000, 'ºC'),
	(47727, 112, '2015-02-01 00:08:41.000000', 'temperatura', 1097.0000, 'ºC'),
	(47728, 112, '2015-02-01 00:08:42.000000', 'temperatura', 900.0000, 'ºC'),
	(47729, 112, '2015-02-01 00:08:43.000000', 'temperatura', 11.0000, 'ºC'),
	(47730, 112, '2015-02-01 00:08:44.000000', 'temperatura', 954.0000, 'ºC'),
	(47731, 112, '2015-02-01 00:08:45.000000', 'temperatura', 1137.0000, 'ºC'),
	(47732, 112, '2015-02-01 00:08:46.000000', 'temperatura', 425.0000, 'ºC'),
	(47733, 112, '2015-02-01 00:08:47.000000', 'temperatura', 1114.0000, 'ºC'),
	(47734, 112, '2015-02-01 00:08:48.000000', 'temperatura', 697.0000, 'ºC'),
	(47735, 112, '2015-02-01 00:08:49.000000', 'temperatura', 143.0000, 'ºC'),
	(47736, 112, '2015-02-01 00:08:50.000000', 'temperatura', 1025.0000, 'ºC'),
	(47737, 112, '2015-02-01 00:08:51.000000', 'temperatura', 1094.0000, 'ºC'),
	(47738, 112, '2015-02-01 00:08:52.000000', 'temperatura', 1196.0000, 'ºC'),
	(47739, 112, '2015-02-01 00:08:53.000000', 'temperatura', 300.0000, 'ºC'),
	(47740, 112, '2015-02-01 00:08:54.000000', 'temperatura', 313.0000, 'ºC'),
	(47741, 112, '2015-02-01 00:08:55.000000', 'temperatura', 663.0000, 'ºC'),
	(47742, 112, '2015-02-01 00:08:56.000000', 'temperatura', 1177.0000, 'ºC'),
	(47743, 112, '2015-02-01 00:08:57.000000', 'temperatura', 296.0000, 'ºC'),
	(47744, 112, '2015-02-01 00:08:58.000000', 'temperatura', 349.0000, 'ºC'),
	(47745, 112, '2015-02-01 00:08:59.000000', 'temperatura', 858.0000, 'ºC'),
	(47746, 112, '2015-02-01 00:09:00.000000', 'temperatura', 845.0000, 'ºC'),
	(47747, 112, '2015-02-01 00:09:01.000000', 'temperatura', 449.0000, 'ºC'),
	(47748, 112, '2015-02-01 00:09:02.000000', 'temperatura', 912.0000, 'ºC'),
	(47749, 112, '2015-02-01 00:09:03.000000', 'temperatura', 812.0000, 'ºC'),
	(47750, 112, '2015-02-01 00:09:04.000000', 'temperatura', 126.0000, 'ºC'),
	(47751, 112, '2015-02-01 00:09:05.000000', 'temperatura', 593.0000, 'ºC'),
	(47752, 112, '2015-02-01 00:09:06.000000', 'temperatura', 187.0000, 'ºC'),
	(47753, 112, '2015-02-01 00:09:07.000000', 'temperatura', 358.0000, 'ºC'),
	(47754, 112, '2015-02-01 00:09:08.000000', 'temperatura', 30.0000, 'ºC'),
	(47755, 112, '2015-02-01 00:09:09.000000', 'temperatura', 277.0000, 'ºC'),
	(47756, 112, '2015-02-01 00:09:10.000000', 'temperatura', 96.0000, 'ºC'),
	(47757, 112, '2015-02-01 00:09:11.000000', 'temperatura', 847.0000, 'ºC'),
	(47758, 112, '2015-02-01 00:09:12.000000', 'temperatura', 349.0000, 'ºC'),
	(47759, 112, '2015-02-01 00:09:13.000000', 'temperatura', 403.0000, 'ºC'),
	(47760, 112, '2015-02-01 00:09:14.000000', 'temperatura', 969.0000, 'ºC'),
	(47761, 112, '2015-02-01 00:09:15.000000', 'temperatura', 36.0000, 'ºC'),
	(47762, 112, '2015-02-01 00:09:16.000000', 'temperatura', 872.0000, 'ºC'),
	(47763, 112, '2015-02-01 00:09:17.000000', 'temperatura', 654.0000, 'ºC'),
	(47764, 112, '2015-02-01 00:09:18.000000', 'temperatura', 656.0000, 'ºC'),
	(47765, 112, '2015-02-01 00:09:19.000000', 'temperatura', 119.0000, 'ºC'),
	(47766, 112, '2015-02-01 00:09:20.000000', 'temperatura', 1026.0000, 'ºC'),
	(47767, 112, '2015-02-01 00:09:21.000000', 'temperatura', 1172.0000, 'ºC'),
	(47768, 112, '2015-02-01 00:09:22.000000', 'temperatura', 386.0000, 'ºC'),
	(47769, 112, '2015-02-01 00:09:23.000000', 'temperatura', 811.0000, 'ºC'),
	(47770, 112, '2015-02-01 00:09:24.000000', 'temperatura', 501.0000, 'ºC'),
	(47771, 112, '2015-02-01 00:09:25.000000', 'temperatura', 71.0000, 'ºC'),
	(47772, 112, '2015-02-01 00:09:26.000000', 'temperatura', 51.0000, 'ºC'),
	(47773, 112, '2015-02-01 00:09:27.000000', 'temperatura', 43.0000, 'ºC'),
	(47774, 112, '2015-02-01 00:09:28.000000', 'temperatura', 65.0000, 'ºC'),
	(47775, 112, '2015-02-01 00:09:29.000000', 'temperatura', 193.0000, 'ºC'),
	(47776, 112, '2015-02-01 00:09:30.000000', 'temperatura', 773.0000, 'ºC'),
	(47777, 112, '2015-02-01 00:09:31.000000', 'temperatura', 887.0000, 'ºC'),
	(47778, 112, '2015-02-01 00:09:32.000000', 'temperatura', 916.0000, 'ºC'),
	(47779, 112, '2015-02-01 00:09:33.000000', 'temperatura', 718.0000, 'ºC'),
	(47780, 112, '2015-02-01 00:09:34.000000', 'temperatura', 842.0000, 'ºC'),
	(47781, 112, '2015-02-01 00:09:35.000000', 'temperatura', 858.0000, 'ºC'),
	(47782, 112, '2015-02-01 00:09:36.000000', 'temperatura', 564.0000, 'ºC'),
	(47783, 112, '2015-02-01 00:09:37.000000', 'temperatura', 246.0000, 'ºC'),
	(47784, 112, '2015-02-01 00:09:38.000000', 'temperatura', 741.0000, 'ºC'),
	(47785, 112, '2015-02-01 00:09:39.000000', 'temperatura', 564.0000, 'ºC'),
	(47786, 112, '2015-02-01 00:09:40.000000', 'temperatura', 599.0000, 'ºC'),
	(47787, 112, '2015-02-01 00:09:41.000000', 'temperatura', 103.0000, 'ºC'),
	(47788, 112, '2015-02-01 00:09:42.000000', 'temperatura', 1118.0000, 'ºC'),
	(47789, 112, '2015-02-01 00:09:43.000000', 'temperatura', 481.0000, 'ºC'),
	(47790, 112, '2015-02-01 00:09:44.000000', 'temperatura', 251.0000, 'ºC'),
	(47791, 112, '2015-02-01 00:09:45.000000', 'temperatura', 1014.0000, 'ºC'),
	(47792, 112, '2015-02-01 00:09:46.000000', 'temperatura', 715.0000, 'ºC'),
	(47793, 112, '2015-02-01 00:09:47.000000', 'temperatura', 536.0000, 'ºC'),
	(47794, 112, '2015-02-01 00:09:48.000000', 'temperatura', 534.0000, 'ºC'),
	(47795, 112, '2015-02-01 00:09:49.000000', 'temperatura', 1063.0000, 'ºC'),
	(47796, 112, '2015-02-01 00:09:50.000000', 'temperatura', 112.0000, 'ºC'),
	(47797, 112, '2015-02-01 00:09:51.000000', 'temperatura', 972.0000, 'ºC'),
	(47798, 112, '2015-02-01 00:09:52.000000', 'temperatura', 923.0000, 'ºC'),
	(47799, 112, '2015-02-01 00:09:53.000000', 'temperatura', 502.0000, 'ºC'),
	(47800, 112, '2015-02-01 00:09:54.000000', 'temperatura', 940.0000, 'ºC'),
	(47801, 112, '2015-02-01 00:09:55.000000', 'temperatura', 797.0000, 'ºC'),
	(47802, 112, '2015-02-01 00:09:56.000000', 'temperatura', 1164.0000, 'ºC'),
	(47803, 112, '2015-02-01 00:09:57.000000', 'temperatura', 1030.0000, 'ºC'),
	(47804, 112, '2015-02-01 00:09:58.000000', 'temperatura', 460.0000, 'ºC'),
	(47805, 112, '2015-02-01 00:09:59.000000', 'temperatura', 410.0000, 'ºC'),
	(47806, 112, '2015-02-01 00:10:00.000000', 'temperatura', 669.0000, 'ºC'),
	(47807, 112, '2015-02-01 00:10:01.000000', 'temperatura', 915.0000, 'ºC'),
	(47808, 112, '2015-02-01 00:10:02.000000', 'temperatura', 168.0000, 'ºC'),
	(47809, 112, '2015-02-01 00:10:03.000000', 'temperatura', 496.0000, 'ºC'),
	(47810, 112, '2015-02-01 00:10:04.000000', 'temperatura', 777.0000, 'ºC'),
	(47811, 112, '2015-02-01 00:10:05.000000', 'temperatura', 1198.0000, 'ºC'),
	(47812, 112, '2015-02-01 00:10:06.000000', 'temperatura', 58.0000, 'ºC'),
	(47813, 112, '2015-02-01 00:10:07.000000', 'temperatura', 299.0000, 'ºC'),
	(47814, 112, '2015-02-01 00:10:08.000000', 'temperatura', 121.0000, 'ºC'),
	(47815, 112, '2015-02-01 00:10:09.000000', 'temperatura', 909.0000, 'ºC'),
	(47816, 112, '2015-02-01 00:10:10.000000', 'temperatura', 582.0000, 'ºC'),
	(47817, 112, '2015-02-01 00:10:11.000000', 'temperatura', 184.0000, 'ºC'),
	(47818, 112, '2015-02-01 00:10:12.000000', 'temperatura', 375.0000, 'ºC'),
	(47819, 112, '2015-02-01 00:10:13.000000', 'temperatura', 121.0000, 'ºC'),
	(47820, 112, '2015-02-01 00:10:14.000000', 'temperatura', 683.0000, 'ºC'),
	(47821, 112, '2015-02-01 00:10:15.000000', 'temperatura', 650.0000, 'ºC'),
	(47822, 112, '2015-02-01 00:10:16.000000', 'temperatura', 3.0000, 'ºC'),
	(47823, 112, '2015-02-01 00:10:17.000000', 'temperatura', 463.0000, 'ºC'),
	(47824, 112, '2015-02-01 00:10:18.000000', 'temperatura', 1110.0000, 'ºC'),
	(47825, 112, '2015-02-01 00:10:19.000000', 'temperatura', 560.0000, 'ºC'),
	(47826, 112, '2015-02-01 00:10:20.000000', 'temperatura', 669.0000, 'ºC'),
	(47827, 112, '2015-02-01 00:10:21.000000', 'temperatura', 468.0000, 'ºC'),
	(47828, 112, '2015-02-01 00:10:22.000000', 'temperatura', 333.0000, 'ºC'),
	(47829, 112, '2015-02-01 00:10:23.000000', 'temperatura', 262.0000, 'ºC'),
	(47830, 112, '2015-02-01 00:10:24.000000', 'temperatura', 313.0000, 'ºC'),
	(47831, 112, '2015-02-01 00:10:25.000000', 'temperatura', 778.0000, 'ºC'),
	(47832, 112, '2015-02-01 00:10:26.000000', 'temperatura', 553.0000, 'ºC'),
	(47833, 112, '2015-02-01 00:10:27.000000', 'temperatura', 431.0000, 'ºC'),
	(47834, 112, '2015-02-01 00:10:28.000000', 'temperatura', 498.0000, 'ºC'),
	(47835, 112, '2015-02-01 00:10:29.000000', 'temperatura', 1196.0000, 'ºC'),
	(47836, 112, '2015-02-01 00:10:30.000000', 'temperatura', 885.0000, 'ºC'),
	(47837, 112, '2015-02-01 00:10:31.000000', 'temperatura', 840.0000, 'ºC'),
	(47838, 112, '2015-02-01 00:10:32.000000', 'temperatura', 345.0000, 'ºC'),
	(47839, 112, '2015-02-01 00:10:33.000000', 'temperatura', 407.0000, 'ºC'),
	(47840, 112, '2015-02-01 00:10:34.000000', 'temperatura', 999.0000, 'ºC'),
	(47841, 112, '2015-02-01 00:10:35.000000', 'temperatura', 175.0000, 'ºC'),
	(47842, 112, '2015-02-01 00:10:36.000000', 'temperatura', 277.0000, 'ºC'),
	(47843, 112, '2015-02-01 00:10:37.000000', 'temperatura', 861.0000, 'ºC'),
	(47844, 112, '2015-02-01 00:10:38.000000', 'temperatura', 1076.0000, 'ºC'),
	(47845, 112, '2015-02-01 00:10:39.000000', 'temperatura', 397.0000, 'ºC'),
	(47846, 112, '2015-02-01 00:10:40.000000', 'temperatura', 1159.0000, 'ºC'),
	(47847, 112, '2015-02-01 00:10:41.000000', 'temperatura', 1003.0000, 'ºC'),
	(47848, 112, '2015-02-01 00:10:42.000000', 'temperatura', 340.0000, 'ºC'),
	(47849, 112, '2015-02-01 00:10:43.000000', 'temperatura', 1089.0000, 'ºC'),
	(47850, 112, '2015-02-01 00:10:44.000000', 'temperatura', 825.0000, 'ºC'),
	(47851, 112, '2015-02-01 00:10:45.000000', 'temperatura', 858.0000, 'ºC'),
	(47852, 112, '2015-02-01 00:10:46.000000', 'temperatura', 616.0000, 'ºC'),
	(47853, 112, '2015-02-01 00:10:47.000000', 'temperatura', 507.0000, 'ºC'),
	(47854, 112, '2015-02-01 00:10:48.000000', 'temperatura', 689.0000, 'ºC'),
	(47855, 112, '2015-02-01 00:10:49.000000', 'temperatura', 722.0000, 'ºC'),
	(47856, 112, '2015-02-01 00:10:50.000000', 'temperatura', 344.0000, 'ºC'),
	(47857, 112, '2015-02-01 00:10:51.000000', 'temperatura', 757.0000, 'ºC'),
	(47858, 112, '2015-02-01 00:10:52.000000', 'temperatura', 351.0000, 'ºC'),
	(47859, 112, '2015-02-01 00:10:53.000000', 'temperatura', 686.0000, 'ºC'),
	(47860, 112, '2015-02-01 00:10:54.000000', 'temperatura', 1177.0000, 'ºC'),
	(47861, 112, '2015-02-01 00:10:55.000000', 'temperatura', 228.0000, 'ºC'),
	(47862, 112, '2015-02-01 00:10:56.000000', 'temperatura', 11.0000, 'ºC'),
	(47863, 112, '2015-02-01 00:10:57.000000', 'temperatura', 571.0000, 'ºC'),
	(47864, 112, '2015-02-01 00:10:58.000000', 'temperatura', 422.0000, 'ºC'),
	(47865, 112, '2015-02-01 00:10:59.000000', 'temperatura', 396.0000, 'ºC'),
	(47866, 112, '2015-02-01 00:11:00.000000', 'temperatura', 718.0000, 'ºC'),
	(47867, 112, '2015-02-01 00:11:01.000000', 'temperatura', 1199.0000, 'ºC'),
	(47868, 112, '2015-02-01 00:11:02.000000', 'temperatura', 243.0000, 'ºC'),
	(47869, 112, '2015-02-01 00:11:03.000000', 'temperatura', 20.0000, 'ºC'),
	(47870, 112, '2015-02-01 00:11:04.000000', 'temperatura', 572.0000, 'ºC'),
	(47871, 112, '2015-02-01 00:11:05.000000', 'temperatura', 398.0000, 'ºC'),
	(47872, 112, '2015-02-01 00:11:06.000000', 'temperatura', 277.0000, 'ºC'),
	(47873, 112, '2015-02-01 00:11:07.000000', 'temperatura', 191.0000, 'ºC'),
	(47874, 112, '2015-02-01 00:11:08.000000', 'temperatura', 124.0000, 'ºC'),
	(47875, 112, '2015-02-01 00:11:09.000000', 'temperatura', 46.0000, 'ºC'),
	(47876, 112, '2015-02-01 00:11:10.000000', 'temperatura', 1060.0000, 'ºC'),
	(47877, 112, '2015-02-01 00:11:11.000000', 'temperatura', 362.0000, 'ºC'),
	(47878, 112, '2015-02-01 00:11:12.000000', 'temperatura', 1031.0000, 'ºC'),
	(47879, 112, '2015-02-01 00:11:13.000000', 'temperatura', 471.0000, 'ºC'),
	(47880, 112, '2015-02-01 00:11:14.000000', 'temperatura', 460.0000, 'ºC'),
	(47881, 112, '2015-02-01 00:11:15.000000', 'temperatura', 890.0000, 'ºC'),
	(47882, 112, '2015-02-01 00:11:16.000000', 'temperatura', 670.0000, 'ºC'),
	(47883, 112, '2015-02-01 00:11:17.000000', 'temperatura', 680.0000, 'ºC'),
	(47884, 112, '2015-02-01 00:11:18.000000', 'temperatura', 192.0000, 'ºC'),
	(47885, 112, '2015-02-01 00:11:19.000000', 'temperatura', 118.0000, 'ºC'),
	(47886, 112, '2015-02-01 00:11:20.000000', 'temperatura', 14.0000, 'ºC'),
	(47887, 112, '2015-02-01 00:11:21.000000', 'temperatura', 917.0000, 'ºC'),
	(47888, 112, '2015-02-01 00:11:22.000000', 'temperatura', 946.0000, 'ºC'),
	(47889, 112, '2015-02-01 00:11:23.000000', 'temperatura', 776.0000, 'ºC'),
	(47890, 112, '2015-02-01 00:11:24.000000', 'temperatura', 1045.0000, 'ºC'),
	(47891, 112, '2015-02-01 00:11:25.000000', 'temperatura', 495.0000, 'ºC'),
	(47892, 112, '2015-02-01 00:11:26.000000', 'temperatura', 542.0000, 'ºC'),
	(47893, 112, '2015-02-01 00:11:27.000000', 'temperatura', 25.0000, 'ºC'),
	(47894, 112, '2015-02-01 00:11:28.000000', 'temperatura', 901.0000, 'ºC'),
	(47895, 112, '2015-02-01 00:11:29.000000', 'temperatura', 828.0000, 'ºC'),
	(47896, 112, '2015-02-01 00:11:30.000000', 'temperatura', 238.0000, 'ºC'),
	(47897, 112, '2015-02-01 00:11:31.000000', 'temperatura', 1107.0000, 'ºC'),
	(47898, 112, '2015-02-01 00:11:32.000000', 'temperatura', 22.0000, 'ºC'),
	(47899, 112, '2015-02-01 00:11:33.000000', 'temperatura', 390.0000, 'ºC'),
	(47900, 112, '2015-02-01 00:11:34.000000', 'temperatura', 685.0000, 'ºC'),
	(47901, 112, '2015-02-01 00:11:35.000000', 'temperatura', 1055.0000, 'ºC'),
	(47902, 112, '2015-02-01 00:11:36.000000', 'temperatura', 819.0000, 'ºC'),
	(47903, 112, '2015-02-01 00:11:37.000000', 'temperatura', 932.0000, 'ºC'),
	(47904, 112, '2015-02-01 00:11:38.000000', 'temperatura', 1001.0000, 'ºC'),
	(47905, 112, '2015-02-01 00:11:39.000000', 'temperatura', 1013.0000, 'ºC'),
	(47906, 112, '2015-02-01 00:11:40.000000', 'temperatura', 860.0000, 'ºC'),
	(47907, 112, '2015-02-01 00:11:41.000000', 'temperatura', 64.0000, 'ºC'),
	(47908, 112, '2015-02-01 00:11:42.000000', 'temperatura', 140.0000, 'ºC'),
	(47909, 112, '2015-02-01 00:11:43.000000', 'temperatura', 508.0000, 'ºC'),
	(47910, 112, '2015-02-01 00:11:44.000000', 'temperatura', 921.0000, 'ºC'),
	(47911, 112, '2015-02-01 00:11:45.000000', 'temperatura', 683.0000, 'ºC'),
	(47912, 112, '2015-02-01 00:11:46.000000', 'temperatura', 652.0000, 'ºC'),
	(47913, 112, '2015-02-01 00:11:47.000000', 'temperatura', 13.0000, 'ºC'),
	(47914, 112, '2015-02-01 00:11:48.000000', 'temperatura', 508.0000, 'ºC'),
	(47915, 112, '2015-02-01 00:11:49.000000', 'temperatura', 101.0000, 'ºC'),
	(47916, 112, '2015-02-01 00:11:50.000000', 'temperatura', 182.0000, 'ºC'),
	(47917, 112, '2015-02-01 00:11:51.000000', 'temperatura', 608.0000, 'ºC'),
	(47918, 112, '2015-02-01 00:11:52.000000', 'temperatura', 93.0000, 'ºC'),
	(47919, 112, '2015-02-01 00:11:53.000000', 'temperatura', 1042.0000, 'ºC'),
	(47920, 112, '2015-02-01 00:11:54.000000', 'temperatura', 131.0000, 'ºC'),
	(47921, 112, '2015-02-01 00:11:55.000000', 'temperatura', 1130.0000, 'ºC'),
	(47922, 112, '2015-02-01 00:11:56.000000', 'temperatura', 459.0000, 'ºC'),
	(47923, 112, '2015-02-01 00:11:57.000000', 'temperatura', 103.0000, 'ºC'),
	(47924, 112, '2015-02-01 00:11:58.000000', 'temperatura', 341.0000, 'ºC'),
	(47925, 112, '2015-02-01 00:11:59.000000', 'temperatura', 194.0000, 'ºC'),
	(47926, 112, '2015-02-01 00:12:00.000000', 'temperatura', 1148.0000, 'ºC'),
	(47927, 112, '2015-02-01 00:12:01.000000', 'temperatura', 360.0000, 'ºC'),
	(47928, 112, '2015-02-01 00:12:02.000000', 'temperatura', 756.0000, 'ºC'),
	(47929, 112, '2015-02-01 00:12:03.000000', 'temperatura', 301.0000, 'ºC'),
	(47930, 112, '2015-02-01 00:12:04.000000', 'temperatura', 438.0000, 'ºC'),
	(47931, 112, '2015-02-01 00:12:05.000000', 'temperatura', 88.0000, 'ºC'),
	(47932, 112, '2015-02-01 00:12:06.000000', 'temperatura', 326.0000, 'ºC'),
	(47933, 112, '2015-02-01 00:12:07.000000', 'temperatura', 166.0000, 'ºC'),
	(47934, 112, '2015-02-01 00:12:08.000000', 'temperatura', 1052.0000, 'ºC'),
	(47935, 112, '2015-02-01 00:12:09.000000', 'temperatura', 1161.0000, 'ºC'),
	(47936, 112, '2015-02-01 00:12:10.000000', 'temperatura', 251.0000, 'ºC'),
	(47937, 112, '2015-02-01 00:12:11.000000', 'temperatura', 170.0000, 'ºC'),
	(47938, 112, '2015-02-01 00:12:12.000000', 'temperatura', 100.0000, 'ºC'),
	(47939, 112, '2015-02-01 00:12:13.000000', 'temperatura', 1191.0000, 'ºC'),
	(47940, 112, '2015-02-01 00:12:14.000000', 'temperatura', 856.0000, 'ºC'),
	(47941, 112, '2015-02-01 00:12:15.000000', 'temperatura', 708.0000, 'ºC'),
	(47942, 112, '2015-02-01 00:12:16.000000', 'temperatura', 972.0000, 'ºC'),
	(47943, 112, '2015-02-01 00:12:17.000000', 'temperatura', 337.0000, 'ºC'),
	(47944, 112, '2015-02-01 00:12:18.000000', 'temperatura', 1169.0000, 'ºC'),
	(47945, 112, '2015-02-01 00:12:19.000000', 'temperatura', 33.0000, 'ºC'),
	(47946, 112, '2015-02-01 00:12:20.000000', 'temperatura', 260.0000, 'ºC'),
	(47947, 112, '2015-02-01 00:12:21.000000', 'temperatura', 2.0000, 'ºC'),
	(47948, 112, '2015-02-01 00:12:22.000000', 'temperatura', 431.0000, 'ºC'),
	(47949, 112, '2015-02-01 00:12:23.000000', 'temperatura', 947.0000, 'ºC'),
	(47950, 112, '2015-02-01 00:12:24.000000', 'temperatura', 1042.0000, 'ºC'),
	(47951, 112, '2015-02-01 00:12:25.000000', 'temperatura', 1172.0000, 'ºC'),
	(47952, 112, '2015-02-01 00:12:26.000000', 'temperatura', 336.0000, 'ºC'),
	(47953, 112, '2015-02-01 00:12:27.000000', 'temperatura', 561.0000, 'ºC'),
	(47954, 112, '2015-02-01 00:12:28.000000', 'temperatura', 601.0000, 'ºC'),
	(47955, 112, '2015-02-01 00:12:29.000000', 'temperatura', 119.0000, 'ºC'),
	(47956, 112, '2015-02-01 00:12:30.000000', 'temperatura', 1194.0000, 'ºC'),
	(47957, 112, '2015-02-01 00:12:31.000000', 'temperatura', 813.0000, 'ºC'),
	(47958, 112, '2015-02-01 00:12:32.000000', 'temperatura', 483.0000, 'ºC'),
	(47959, 112, '2015-02-01 00:12:33.000000', 'temperatura', 1176.0000, 'ºC'),
	(47960, 112, '2015-02-01 00:12:34.000000', 'temperatura', 832.0000, 'ºC'),
	(47961, 112, '2015-02-01 00:12:35.000000', 'temperatura', 634.0000, 'ºC'),
	(47962, 112, '2015-02-01 00:12:36.000000', 'temperatura', 675.0000, 'ºC'),
	(47963, 112, '2015-02-01 00:12:37.000000', 'temperatura', 273.0000, 'ºC'),
	(47964, 112, '2015-02-01 00:12:38.000000', 'temperatura', 541.0000, 'ºC'),
	(47965, 112, '2015-02-01 00:12:39.000000', 'temperatura', 685.0000, 'ºC'),
	(47966, 112, '2015-02-01 00:12:40.000000', 'temperatura', 601.0000, 'ºC'),
	(47967, 112, '2015-02-01 00:12:41.000000', 'temperatura', 953.0000, 'ºC'),
	(47968, 112, '2015-02-01 00:12:42.000000', 'temperatura', 562.0000, 'ºC'),
	(47969, 112, '2015-02-01 00:12:43.000000', 'temperatura', 1152.0000, 'ºC'),
	(47970, 112, '2015-02-01 00:12:44.000000', 'temperatura', 476.0000, 'ºC'),
	(47971, 112, '2015-02-01 00:12:45.000000', 'temperatura', 122.0000, 'ºC'),
	(47972, 112, '2015-02-01 00:12:46.000000', 'temperatura', 385.0000, 'ºC'),
	(47973, 112, '2015-02-01 00:12:47.000000', 'temperatura', 360.0000, 'ºC'),
	(47974, 112, '2015-02-01 00:12:48.000000', 'temperatura', 645.0000, 'ºC'),
	(47975, 112, '2015-02-01 00:12:49.000000', 'temperatura', 944.0000, 'ºC'),
	(47976, 112, '2015-02-01 00:12:50.000000', 'temperatura', 387.0000, 'ºC'),
	(47977, 112, '2015-02-01 00:12:51.000000', 'temperatura', 304.0000, 'ºC'),
	(47978, 112, '2015-02-01 00:12:52.000000', 'temperatura', 358.0000, 'ºC'),
	(47979, 112, '2015-02-01 00:12:53.000000', 'temperatura', 879.0000, 'ºC'),
	(47980, 112, '2015-02-01 00:12:54.000000', 'temperatura', 923.0000, 'ºC'),
	(47981, 112, '2015-02-01 00:12:55.000000', 'temperatura', 776.0000, 'ºC'),
	(47982, 112, '2015-02-01 00:12:56.000000', 'temperatura', 1113.0000, 'ºC'),
	(47983, 112, '2015-02-01 00:12:57.000000', 'temperatura', 837.0000, 'ºC'),
	(47984, 112, '2015-02-01 00:12:58.000000', 'temperatura', 845.0000, 'ºC'),
	(47985, 112, '2015-02-01 00:12:59.000000', 'temperatura', 515.0000, 'ºC'),
	(47986, 112, '2015-02-01 00:13:00.000000', 'temperatura', 40.0000, 'ºC'),
	(47987, 112, '2015-02-01 00:13:01.000000', 'temperatura', 1056.0000, 'ºC'),
	(47988, 112, '2015-02-01 00:13:02.000000', 'temperatura', 360.0000, 'ºC'),
	(47989, 112, '2015-02-01 00:13:03.000000', 'temperatura', 1034.0000, 'ºC'),
	(47990, 112, '2015-02-01 00:13:04.000000', 'temperatura', 489.0000, 'ºC'),
	(47991, 112, '2015-02-01 00:13:05.000000', 'temperatura', 545.0000, 'ºC'),
	(47992, 112, '2015-02-01 00:13:06.000000', 'temperatura', 59.0000, 'ºC'),
	(47993, 112, '2015-02-01 00:13:07.000000', 'temperatura', 1058.0000, 'ºC'),
	(47994, 112, '2015-02-01 00:13:08.000000', 'temperatura', 317.0000, 'ºC'),
	(47995, 112, '2015-02-01 00:13:09.000000', 'temperatura', 809.0000, 'ºC'),
	(47996, 112, '2015-02-01 00:13:10.000000', 'temperatura', 693.0000, 'ºC'),
	(47997, 112, '2015-02-01 00:13:11.000000', 'temperatura', 1041.0000, 'ºC'),
	(47998, 112, '2015-02-01 00:13:12.000000', 'temperatura', 725.0000, 'ºC'),
	(47999, 112, '2015-02-01 00:13:13.000000', 'temperatura', 503.0000, 'ºC'),
	(48000, 112, '2015-02-01 00:13:14.000000', 'temperatura', 340.0000, 'ºC'),
	(48001, 112, '2015-02-01 00:13:15.000000', 'temperatura', 192.0000, 'ºC'),
	(48002, 112, '2015-02-01 00:13:16.000000', 'temperatura', 1141.0000, 'ºC'),
	(48003, 112, '2015-02-01 00:13:17.000000', 'temperatura', 327.0000, 'ºC'),
	(48004, 112, '2015-02-01 00:13:18.000000', 'temperatura', 615.0000, 'ºC'),
	(48005, 112, '2015-02-01 00:13:19.000000', 'temperatura', 894.0000, 'ºC'),
	(48006, 112, '2015-02-01 00:13:20.000000', 'temperatura', 224.0000, 'ºC'),
	(48007, 112, '2015-02-01 00:13:21.000000', 'temperatura', 840.0000, 'ºC'),
	(48008, 112, '2015-02-01 00:13:22.000000', 'temperatura', 1128.0000, 'ºC'),
	(48009, 112, '2015-02-01 00:13:23.000000', 'temperatura', 719.0000, 'ºC'),
	(48010, 112, '2015-02-01 00:13:24.000000', 'temperatura', 214.0000, 'ºC'),
	(48011, 112, '2015-02-01 00:13:25.000000', 'temperatura', 114.0000, 'ºC'),
	(48012, 112, '2015-02-01 00:13:26.000000', 'temperatura', 1129.0000, 'ºC'),
	(48013, 112, '2015-02-01 00:13:27.000000', 'temperatura', 504.0000, 'ºC'),
	(48014, 112, '2015-02-01 00:13:28.000000', 'temperatura', 334.0000, 'ºC'),
	(48015, 112, '2015-02-01 00:13:29.000000', 'temperatura', 157.0000, 'ºC'),
	(48016, 112, '2015-02-01 00:13:30.000000', 'temperatura', 986.0000, 'ºC'),
	(48017, 112, '2015-02-01 00:13:31.000000', 'temperatura', 857.0000, 'ºC'),
	(48018, 112, '2015-02-01 00:13:32.000000', 'temperatura', 130.0000, 'ºC'),
	(48019, 112, '2015-02-01 00:13:33.000000', 'temperatura', 479.0000, 'ºC'),
	(48020, 112, '2015-02-01 00:13:34.000000', 'temperatura', 806.0000, 'ºC'),
	(48021, 112, '2015-02-01 00:13:35.000000', 'temperatura', 191.0000, 'ºC'),
	(48022, 112, '2015-02-01 00:13:36.000000', 'temperatura', 939.0000, 'ºC'),
	(48023, 112, '2015-02-01 00:13:37.000000', 'temperatura', 524.0000, 'ºC'),
	(48024, 112, '2015-02-01 00:13:38.000000', 'temperatura', 1003.0000, 'ºC'),
	(48025, 112, '2015-02-01 00:13:39.000000', 'temperatura', 1041.0000, 'ºC'),
	(48026, 112, '2015-02-01 00:13:40.000000', 'temperatura', 998.0000, 'ºC'),
	(48027, 112, '2015-02-01 00:13:41.000000', 'temperatura', 666.0000, 'ºC'),
	(48028, 112, '2015-02-01 00:13:42.000000', 'temperatura', 335.0000, 'ºC'),
	(48029, 112, '2015-02-01 00:13:43.000000', 'temperatura', 881.0000, 'ºC'),
	(48030, 112, '2015-02-01 00:13:44.000000', 'temperatura', 1001.0000, 'ºC'),
	(48031, 112, '2015-02-01 00:13:45.000000', 'temperatura', 1160.0000, 'ºC'),
	(48032, 112, '2015-02-01 00:13:46.000000', 'temperatura', 399.0000, 'ºC'),
	(48033, 112, '2015-02-01 00:13:47.000000', 'temperatura', 914.0000, 'ºC'),
	(48034, 112, '2015-02-01 00:13:48.000000', 'temperatura', 974.0000, 'ºC'),
	(48035, 112, '2015-02-01 00:13:49.000000', 'temperatura', 929.0000, 'ºC'),
	(48036, 112, '2015-02-01 00:13:50.000000', 'temperatura', 525.0000, 'ºC'),
	(48037, 112, '2015-02-01 00:13:51.000000', 'temperatura', 1036.0000, 'ºC'),
	(48038, 112, '2015-02-01 00:13:52.000000', 'temperatura', 8.0000, 'ºC'),
	(48039, 112, '2015-02-01 00:13:53.000000', 'temperatura', 533.0000, 'ºC'),
	(48040, 112, '2015-02-01 00:13:54.000000', 'temperatura', 241.0000, 'ºC'),
	(48041, 112, '2015-02-01 00:13:55.000000', 'temperatura', 806.0000, 'ºC'),
	(48042, 112, '2015-02-01 00:13:56.000000', 'temperatura', 907.0000, 'ºC'),
	(48043, 112, '2015-02-01 00:13:57.000000', 'temperatura', 920.0000, 'ºC'),
	(48044, 112, '2015-02-01 00:13:58.000000', 'temperatura', 677.0000, 'ºC'),
	(48045, 112, '2015-02-01 00:13:59.000000', 'temperatura', 628.0000, 'ºC'),
	(48046, 112, '2015-02-01 00:14:00.000000', 'temperatura', 1106.0000, 'ºC'),
	(48047, 112, '2015-02-01 00:14:01.000000', 'temperatura', 49.0000, 'ºC'),
	(48048, 112, '2015-02-01 00:14:02.000000', 'temperatura', 525.0000, 'ºC'),
	(48049, 112, '2015-02-01 00:14:03.000000', 'temperatura', 79.0000, 'ºC'),
	(48050, 112, '2015-02-01 00:14:04.000000', 'temperatura', 23.0000, 'ºC'),
	(48051, 112, '2015-02-01 00:14:05.000000', 'temperatura', 1075.0000, 'ºC'),
	(48052, 112, '2015-02-01 00:14:06.000000', 'temperatura', 510.0000, 'ºC'),
	(48053, 112, '2015-02-01 00:14:07.000000', 'temperatura', 524.0000, 'ºC'),
	(48054, 112, '2015-02-01 00:14:08.000000', 'temperatura', 1089.0000, 'ºC'),
	(48055, 112, '2015-02-01 00:14:09.000000', 'temperatura', 274.0000, 'ºC'),
	(48056, 112, '2015-02-01 00:14:10.000000', 'temperatura', 503.0000, 'ºC'),
	(48057, 112, '2015-02-01 00:14:11.000000', 'temperatura', 494.0000, 'ºC'),
	(48058, 112, '2015-02-01 00:14:12.000000', 'temperatura', 960.0000, 'ºC'),
	(48059, 112, '2015-02-01 00:14:13.000000', 'temperatura', 921.0000, 'ºC'),
	(48060, 112, '2015-02-01 00:14:14.000000', 'temperatura', 525.0000, 'ºC'),
	(48061, 112, '2015-02-01 00:14:15.000000', 'temperatura', 1064.0000, 'ºC'),
	(48062, 112, '2015-02-01 00:14:16.000000', 'temperatura', 144.0000, 'ºC'),
	(48063, 112, '2015-02-01 00:14:17.000000', 'temperatura', 1129.0000, 'ºC'),
	(48064, 112, '2015-02-01 00:14:18.000000', 'temperatura', 415.0000, 'ºC'),
	(48065, 112, '2015-02-01 00:14:19.000000', 'temperatura', 1086.0000, 'ºC'),
	(48066, 112, '2015-02-01 00:14:20.000000', 'temperatura', 586.0000, 'ºC'),
	(48067, 112, '2015-02-01 00:14:21.000000', 'temperatura', 875.0000, 'ºC'),
	(48068, 112, '2015-02-01 00:14:22.000000', 'temperatura', 215.0000, 'ºC'),
	(48069, 112, '2015-02-01 00:14:23.000000', 'temperatura', 851.0000, 'ºC'),
	(48070, 112, '2015-02-01 00:14:24.000000', 'temperatura', 11.0000, 'ºC'),
	(48071, 112, '2015-02-01 00:14:25.000000', 'temperatura', 1104.0000, 'ºC'),
	(48072, 112, '2015-02-01 00:14:26.000000', 'temperatura', 684.0000, 'ºC'),
	(48073, 112, '2015-02-01 00:14:27.000000', 'temperatura', 112.0000, 'ºC'),
	(48074, 112, '2015-02-01 00:14:28.000000', 'temperatura', 908.0000, 'ºC'),
	(48075, 112, '2015-02-01 00:14:29.000000', 'temperatura', 604.0000, 'ºC'),
	(48076, 112, '2015-02-01 00:14:30.000000', 'temperatura', 298.0000, 'ºC'),
	(48077, 112, '2015-02-01 00:14:31.000000', 'temperatura', 876.0000, 'ºC'),
	(48078, 112, '2015-02-01 00:14:32.000000', 'temperatura', 1087.0000, 'ºC'),
	(48079, 112, '2015-02-01 00:14:33.000000', 'temperatura', 408.0000, 'ºC'),
	(48080, 112, '2015-02-01 00:14:34.000000', 'temperatura', 1177.0000, 'ºC'),
	(48081, 112, '2015-02-01 00:14:35.000000', 'temperatura', 1064.0000, 'ºC'),
	(48082, 112, '2015-02-01 00:14:36.000000', 'temperatura', 590.0000, 'ºC'),
	(48083, 112, '2015-02-01 00:14:37.000000', 'temperatura', 957.0000, 'ºC'),
	(48084, 112, '2015-02-01 00:14:38.000000', 'temperatura', 615.0000, 'ºC'),
	(48085, 112, '2015-02-01 00:14:39.000000', 'temperatura', 207.0000, 'ºC'),
	(48086, 112, '2015-02-01 00:14:40.000000', 'temperatura', 389.0000, 'ºC'),
	(48087, 112, '2015-02-01 00:14:41.000000', 'temperatura', 123.0000, 'ºC'),
	(48088, 112, '2015-02-01 00:14:42.000000', 'temperatura', 652.0000, 'ºC'),
	(48089, 112, '2015-02-01 00:14:43.000000', 'temperatura', 488.0000, 'ºC'),
	(48090, 112, '2015-02-01 00:14:44.000000', 'temperatura', 488.0000, 'ºC'),
	(48091, 112, '2015-02-01 00:14:45.000000', 'temperatura', 973.0000, 'ºC'),
	(48092, 112, '2015-02-01 00:14:46.000000', 'temperatura', 1005.0000, 'ºC'),
	(48093, 112, '2015-02-01 00:14:47.000000', 'temperatura', 905.0000, 'ºC'),
	(48094, 112, '2015-02-01 00:14:48.000000', 'temperatura', 310.0000, 'ºC'),
	(48095, 112, '2015-02-01 00:14:49.000000', 'temperatura', 38.0000, 'ºC'),
	(48096, 112, '2015-02-01 00:14:50.000000', 'temperatura', 458.0000, 'ºC'),
	(48097, 112, '2015-02-01 00:14:51.000000', 'temperatura', 976.0000, 'ºC'),
	(48098, 112, '2015-02-01 00:14:52.000000', 'temperatura', 1108.0000, 'ºC'),
	(48099, 112, '2015-02-01 00:14:53.000000', 'temperatura', 214.0000, 'ºC'),
	(48100, 112, '2015-02-01 00:14:54.000000', 'temperatura', 145.0000, 'ºC'),
	(48101, 112, '2015-02-01 00:14:55.000000', 'temperatura', 85.0000, 'ºC'),
	(48102, 112, '2015-02-01 00:14:56.000000', 'temperatura', 1191.0000, 'ºC'),
	(48103, 112, '2015-02-01 00:14:57.000000', 'temperatura', 901.0000, 'ºC'),
	(48104, 112, '2015-02-01 00:14:58.000000', 'temperatura', 932.0000, 'ºC'),
	(48105, 112, '2015-02-01 00:14:59.000000', 'temperatura', 756.0000, 'ºC'),
	(48106, 112, '2015-02-01 00:15:00.000000', 'temperatura', 985.0000, 'ºC'),
	(48107, 112, '2015-02-01 00:15:01.000000', 'temperatura', 259.0000, 'ºC'),
	(48108, 112, '2015-02-01 00:15:02.000000', 'temperatura', 742.0000, 'ºC'),
	(48109, 112, '2015-02-01 00:15:03.000000', 'temperatura', 530.0000, 'ºC'),
	(48110, 112, '2015-02-01 00:15:04.000000', 'temperatura', 427.0000, 'ºC'),
	(48111, 112, '2015-02-01 00:15:05.000000', 'temperatura', 546.0000, 'ºC'),
	(48112, 112, '2015-02-01 00:15:06.000000', 'temperatura', 247.0000, 'ºC'),
	(48113, 112, '2015-02-01 00:15:07.000000', 'temperatura', 800.0000, 'ºC'),
	(48114, 112, '2015-02-01 00:15:08.000000', 'temperatura', 857.0000, 'ºC'),
	(48115, 112, '2015-02-01 00:15:09.000000', 'temperatura', 686.0000, 'ºC'),
	(48116, 112, '2015-02-01 00:15:10.000000', 'temperatura', 859.0000, 'ºC'),
	(48117, 112, '2015-02-01 00:15:11.000000', 'temperatura', 1040.0000, 'ºC'),
	(48118, 112, '2015-02-01 00:15:12.000000', 'temperatura', 222.0000, 'ºC'),
	(48119, 112, '2015-02-01 00:15:13.000000', 'temperatura', 390.0000, 'ºC'),
	(48120, 112, '2015-02-01 00:15:14.000000', 'temperatura', 85.0000, 'ºC'),
	(48121, 112, '2015-02-01 00:15:15.000000', 'temperatura', 456.0000, 'ºC'),
	(48122, 112, '2015-02-01 00:15:16.000000', 'temperatura', 825.0000, 'ºC'),
	(48123, 112, '2015-02-01 00:15:17.000000', 'temperatura', 360.0000, 'ºC'),
	(48124, 112, '2015-02-01 00:15:18.000000', 'temperatura', 523.0000, 'ºC'),
	(48125, 112, '2015-02-01 00:15:19.000000', 'temperatura', 334.0000, 'ºC'),
	(48126, 112, '2015-02-01 00:15:20.000000', 'temperatura', 104.0000, 'ºC'),
	(48127, 112, '2015-02-01 00:15:21.000000', 'temperatura', 719.0000, 'ºC'),
	(48128, 112, '2015-02-01 00:15:22.000000', 'temperatura', 884.0000, 'ºC'),
	(48129, 112, '2015-02-01 00:15:23.000000', 'temperatura', 1063.0000, 'ºC'),
	(48130, 112, '2015-02-01 00:15:24.000000', 'temperatura', 263.0000, 'ºC'),
	(48131, 112, '2015-02-01 00:15:25.000000', 'temperatura', 525.0000, 'ºC'),
	(48132, 112, '2015-02-01 00:15:26.000000', 'temperatura', 639.0000, 'ºC'),
	(48133, 112, '2015-02-01 00:15:27.000000', 'temperatura', 421.0000, 'ºC'),
	(48134, 112, '2015-02-01 00:15:28.000000', 'temperatura', 189.0000, 'ºC'),
	(48135, 112, '2015-02-01 00:15:29.000000', 'temperatura', 882.0000, 'ºC'),
	(48136, 112, '2015-02-01 00:15:30.000000', 'temperatura', 243.0000, 'ºC'),
	(48137, 112, '2015-02-01 00:15:31.000000', 'temperatura', 969.0000, 'ºC'),
	(48138, 112, '2015-02-01 00:15:32.000000', 'temperatura', 517.0000, 'ºC'),
	(48139, 112, '2015-02-01 00:15:33.000000', 'temperatura', 879.0000, 'ºC'),
	(48140, 112, '2015-02-01 00:15:34.000000', 'temperatura', 445.0000, 'ºC'),
	(48141, 112, '2015-02-01 00:15:35.000000', 'temperatura', 786.0000, 'ºC'),
	(48142, 112, '2015-02-01 00:15:36.000000', 'temperatura', 198.0000, 'ºC'),
	(48143, 112, '2015-02-01 00:15:37.000000', 'temperatura', 1030.0000, 'ºC'),
	(48144, 112, '2015-02-01 00:15:38.000000', 'temperatura', 959.0000, 'ºC'),
	(48145, 112, '2015-02-01 00:15:39.000000', 'temperatura', 503.0000, 'ºC'),
	(48146, 112, '2015-02-01 00:15:40.000000', 'temperatura', 839.0000, 'ºC'),
	(48147, 112, '2015-02-01 00:15:41.000000', 'temperatura', 287.0000, 'ºC'),
	(48148, 112, '2015-02-01 00:15:42.000000', 'temperatura', 119.0000, 'ºC'),
	(48149, 112, '2015-02-01 00:15:43.000000', 'temperatura', 936.0000, 'ºC'),
	(48150, 112, '2015-02-01 00:15:44.000000', 'temperatura', 720.0000, 'ºC'),
	(48151, 112, '2015-02-01 00:15:45.000000', 'temperatura', 796.0000, 'ºC'),
	(48152, 112, '2015-02-01 00:15:46.000000', 'temperatura', 618.0000, 'ºC'),
	(48153, 112, '2015-02-01 00:15:47.000000', 'temperatura', 704.0000, 'ºC'),
	(48154, 112, '2015-02-01 00:15:48.000000', 'temperatura', 468.0000, 'ºC'),
	(48155, 112, '2015-02-01 00:15:49.000000', 'temperatura', 227.0000, 'ºC'),
	(48156, 112, '2015-02-01 00:15:50.000000', 'temperatura', 933.0000, 'ºC'),
	(48157, 112, '2015-02-01 00:15:51.000000', 'temperatura', 383.0000, 'ºC'),
	(48158, 112, '2015-02-01 00:15:52.000000', 'temperatura', 315.0000, 'ºC'),
	(48159, 112, '2015-02-01 00:15:53.000000', 'temperatura', 429.0000, 'ºC'),
	(48160, 112, '2015-02-01 00:15:54.000000', 'temperatura', 2.0000, 'ºC'),
	(48161, 112, '2015-02-01 00:15:55.000000', 'temperatura', 1121.0000, 'ºC'),
	(48162, 112, '2015-02-01 00:15:56.000000', 'temperatura', 799.0000, 'ºC'),
	(48163, 112, '2015-02-01 00:15:57.000000', 'temperatura', 632.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(48164, 112, '2015-02-01 00:15:58.000000', 'temperatura', 763.0000, 'ºC'),
	(48165, 112, '2015-02-01 00:15:59.000000', 'temperatura', 720.0000, 'ºC'),
	(48166, 112, '2015-02-01 00:16:00.000000', 'temperatura', 110.0000, 'ºC'),
	(48167, 112, '2015-02-01 00:16:01.000000', 'temperatura', 793.0000, 'ºC'),
	(48168, 112, '2015-02-01 00:16:02.000000', 'temperatura', 35.0000, 'ºC'),
	(48169, 112, '2015-02-01 00:16:03.000000', 'temperatura', 196.0000, 'ºC'),
	(48170, 112, '2015-02-01 00:16:04.000000', 'temperatura', 874.0000, 'ºC'),
	(48171, 112, '2015-02-01 00:16:05.000000', 'temperatura', 184.0000, 'ºC'),
	(48172, 112, '2015-02-01 00:16:06.000000', 'temperatura', 699.0000, 'ºC'),
	(48173, 112, '2015-02-01 00:16:07.000000', 'temperatura', 544.0000, 'ºC'),
	(48174, 112, '2015-02-01 00:16:08.000000', 'temperatura', 623.0000, 'ºC'),
	(48175, 112, '2015-02-01 00:16:09.000000', 'temperatura', 285.0000, 'ºC'),
	(48176, 112, '2015-02-01 00:16:10.000000', 'temperatura', 756.0000, 'ºC'),
	(48177, 112, '2015-02-01 00:16:11.000000', 'temperatura', 524.0000, 'ºC'),
	(48178, 112, '2015-02-01 00:16:12.000000', 'temperatura', 352.0000, 'ºC'),
	(48179, 112, '2015-02-01 00:16:13.000000', 'temperatura', 188.0000, 'ºC'),
	(48180, 112, '2015-02-01 00:16:14.000000', 'temperatura', 1085.0000, 'ºC'),
	(48181, 112, '2015-02-01 00:16:15.000000', 'temperatura', 63.0000, 'ºC'),
	(48182, 112, '2015-02-01 00:16:16.000000', 'temperatura', 660.0000, 'ºC'),
	(48183, 112, '2015-02-01 00:16:17.000000', 'temperatura', 710.0000, 'ºC'),
	(48184, 112, '2015-02-01 00:16:18.000000', 'temperatura', 373.0000, 'ºC'),
	(48185, 112, '2015-02-01 00:16:19.000000', 'temperatura', 935.0000, 'ºC'),
	(48186, 112, '2015-02-01 00:16:20.000000', 'temperatura', 1155.0000, 'ºC'),
	(48187, 112, '2015-02-01 00:16:21.000000', 'temperatura', 573.0000, 'ºC'),
	(48188, 112, '2015-02-01 00:16:22.000000', 'temperatura', 600.0000, 'ºC'),
	(48189, 112, '2015-02-01 00:16:23.000000', 'temperatura', 79.0000, 'ºC'),
	(48190, 112, '2015-02-01 00:16:24.000000', 'temperatura', 999.0000, 'ºC'),
	(48191, 112, '2015-02-01 00:16:25.000000', 'temperatura', 1156.0000, 'ºC'),
	(48192, 112, '2015-02-01 00:16:26.000000', 'temperatura', 386.0000, 'ºC'),
	(48193, 112, '2015-02-01 00:16:27.000000', 'temperatura', 862.0000, 'ºC'),
	(48194, 112, '2015-02-01 00:16:28.000000', 'temperatura', 753.0000, 'ºC'),
	(48195, 112, '2015-02-01 00:16:29.000000', 'temperatura', 1177.0000, 'ºC'),
	(48196, 112, '2015-02-01 00:16:30.000000', 'temperatura', 29.0000, 'ºC'),
	(48197, 112, '2015-02-01 00:16:31.000000', 'temperatura', 214.0000, 'ºC'),
	(48198, 112, '2015-02-01 00:16:32.000000', 'temperatura', 984.0000, 'ºC'),
	(48199, 112, '2015-02-01 00:16:33.000000', 'temperatura', 677.0000, 'ºC'),
	(48200, 112, '2015-02-01 00:16:34.000000', 'temperatura', 436.0000, 'ºC'),
	(48201, 112, '2015-02-01 00:16:35.000000', 'temperatura', 149.0000, 'ºC'),
	(48202, 112, '2015-02-01 00:16:36.000000', 'temperatura', 636.0000, 'ºC'),
	(48203, 112, '2015-02-01 00:16:37.000000', 'temperatura', 333.0000, 'ºC'),
	(48204, 112, '2015-02-01 00:16:38.000000', 'temperatura', 958.0000, 'ºC'),
	(48205, 112, '2015-02-01 00:16:39.000000', 'temperatura', 192.0000, 'ºC'),
	(48206, 112, '2015-02-01 00:16:40.000000', 'temperatura', 486.0000, 'ºC'),
	(48207, 112, '2015-02-01 00:16:41.000000', 'temperatura', 657.0000, 'ºC'),
	(48208, 112, '2015-02-01 00:16:42.000000', 'temperatura', 624.0000, 'ºC'),
	(48209, 112, '2015-02-01 00:16:43.000000', 'temperatura', 1151.0000, 'ºC'),
	(48210, 112, '2015-02-01 00:16:44.000000', 'temperatura', 283.0000, 'ºC'),
	(48211, 112, '2015-02-01 00:16:45.000000', 'temperatura', 364.0000, 'ºC'),
	(48212, 112, '2015-02-01 00:16:46.000000', 'temperatura', 970.0000, 'ºC'),
	(48213, 112, '2015-02-01 00:16:47.000000', 'temperatura', 158.0000, 'ºC'),
	(48214, 112, '2015-02-01 00:16:48.000000', 'temperatura', 281.0000, 'ºC'),
	(48215, 112, '2015-02-01 00:16:49.000000', 'temperatura', 931.0000, 'ºC'),
	(48216, 112, '2015-02-01 00:16:50.000000', 'temperatura', 213.0000, 'ºC'),
	(48217, 112, '2015-02-01 00:16:51.000000', 'temperatura', 673.0000, 'ºC'),
	(48218, 112, '2015-02-01 00:16:52.000000', 'temperatura', 326.0000, 'ºC'),
	(48219, 112, '2015-02-01 00:16:53.000000', 'temperatura', 813.0000, 'ºC'),
	(48220, 112, '2015-02-01 00:16:54.000000', 'temperatura', 686.0000, 'ºC'),
	(48221, 112, '2015-02-01 00:16:55.000000', 'temperatura', 992.0000, 'ºC'),
	(48222, 112, '2015-02-01 00:16:56.000000', 'temperatura', 502.0000, 'ºC'),
	(48223, 112, '2015-02-01 00:16:57.000000', 'temperatura', 733.0000, 'ºC'),
	(48224, 112, '2015-02-01 00:16:58.000000', 'temperatura', 961.0000, 'ºC'),
	(48225, 112, '2015-02-01 00:16:59.000000', 'temperatura', 205.0000, 'ºC'),
	(48226, 112, '2015-02-01 00:17:00.000000', 'temperatura', 543.0000, 'ºC'),
	(48227, 112, '2015-02-01 00:17:01.000000', 'temperatura', 900.0000, 'ºC'),
	(48228, 112, '2015-02-01 00:17:02.000000', 'temperatura', 471.0000, 'ºC'),
	(48229, 112, '2015-02-01 00:17:03.000000', 'temperatura', 858.0000, 'ºC'),
	(48230, 112, '2015-02-01 00:17:04.000000', 'temperatura', 476.0000, 'ºC'),
	(48231, 112, '2015-02-01 00:17:05.000000', 'temperatura', 1006.0000, 'ºC'),
	(48232, 112, '2015-02-01 00:17:06.000000', 'temperatura', 2.0000, 'ºC'),
	(48233, 112, '2015-02-01 00:17:07.000000', 'temperatura', 593.0000, 'ºC'),
	(48234, 112, '2015-02-01 00:17:08.000000', 'temperatura', 561.0000, 'ºC'),
	(48235, 112, '2015-02-01 00:17:09.000000', 'temperatura', 1024.0000, 'ºC'),
	(48236, 112, '2015-02-01 00:17:10.000000', 'temperatura', 1039.0000, 'ºC'),
	(48237, 112, '2015-02-01 00:17:11.000000', 'temperatura', 924.0000, 'ºC'),
	(48238, 112, '2015-02-01 00:17:12.000000', 'temperatura', 303.0000, 'ºC'),
	(48239, 112, '2015-02-01 00:17:13.000000', 'temperatura', 1144.0000, 'ºC'),
	(48240, 112, '2015-02-01 00:17:14.000000', 'temperatura', 11.0000, 'ºC'),
	(48241, 112, '2015-02-01 00:17:15.000000', 'temperatura', 223.0000, 'ºC'),
	(48242, 112, '2015-02-01 00:17:16.000000', 'temperatura', 1085.0000, 'ºC'),
	(48243, 112, '2015-02-01 00:17:17.000000', 'temperatura', 1155.0000, 'ºC'),
	(48244, 112, '2015-02-01 00:17:18.000000', 'temperatura', 120.0000, 'ºC'),
	(48245, 112, '2015-02-01 00:17:19.000000', 'temperatura', 738.0000, 'ºC'),
	(48246, 112, '2015-02-01 00:17:20.000000', 'temperatura', 929.0000, 'ºC'),
	(48247, 112, '2015-02-01 00:17:21.000000', 'temperatura', 30.0000, 'ºC'),
	(48248, 112, '2015-02-01 00:17:22.000000', 'temperatura', 967.0000, 'ºC'),
	(48249, 112, '2015-02-01 00:17:23.000000', 'temperatura', 1142.0000, 'ºC'),
	(48250, 112, '2015-02-01 00:17:24.000000', 'temperatura', 411.0000, 'ºC'),
	(48251, 112, '2015-02-01 00:17:25.000000', 'temperatura', 1028.0000, 'ºC'),
	(48252, 112, '2015-02-01 00:17:26.000000', 'temperatura', 310.0000, 'ºC'),
	(48253, 112, '2015-02-01 00:17:27.000000', 'temperatura', 866.0000, 'ºC'),
	(48254, 112, '2015-02-01 00:17:28.000000', 'temperatura', 1001.0000, 'ºC'),
	(48255, 112, '2015-02-01 00:17:29.000000', 'temperatura', 6.0000, 'ºC'),
	(48256, 112, '2015-02-01 00:17:30.000000', 'temperatura', 627.0000, 'ºC'),
	(48257, 112, '2015-02-01 00:17:31.000000', 'temperatura', 718.0000, 'ºC'),
	(48258, 112, '2015-02-01 00:17:32.000000', 'temperatura', 509.0000, 'ºC'),
	(48259, 112, '2015-02-01 00:17:33.000000', 'temperatura', 390.0000, 'ºC'),
	(48260, 112, '2015-02-01 00:17:34.000000', 'temperatura', 426.0000, 'ºC'),
	(48261, 112, '2015-02-01 00:17:35.000000', 'temperatura', 959.0000, 'ºC'),
	(48262, 112, '2015-02-01 00:17:36.000000', 'temperatura', 1119.0000, 'ºC'),
	(48263, 112, '2015-02-01 00:17:37.000000', 'temperatura', 316.0000, 'ºC'),
	(48264, 112, '2015-02-01 00:17:38.000000', 'temperatura', 625.0000, 'ºC'),
	(48265, 112, '2015-02-01 00:17:39.000000', 'temperatura', 978.0000, 'ºC'),
	(48266, 112, '2015-02-01 00:17:40.000000', 'temperatura', 614.0000, 'ºC'),
	(48267, 112, '2015-02-01 00:17:41.000000', 'temperatura', 135.0000, 'ºC'),
	(48268, 112, '2015-02-01 00:17:42.000000', 'temperatura', 36.0000, 'ºC'),
	(48269, 112, '2015-02-01 00:17:43.000000', 'temperatura', 973.0000, 'ºC'),
	(48270, 112, '2015-02-01 00:17:44.000000', 'temperatura', 1157.0000, 'ºC'),
	(48271, 112, '2015-02-01 00:17:45.000000', 'temperatura', 470.0000, 'ºC'),
	(48272, 112, '2015-02-01 00:17:46.000000', 'temperatura', 77.0000, 'ºC'),
	(48273, 112, '2015-02-01 00:17:47.000000', 'temperatura', 177.0000, 'ºC'),
	(48274, 112, '2015-02-01 00:17:48.000000', 'temperatura', 652.0000, 'ºC'),
	(48275, 112, '2015-02-01 00:17:49.000000', 'temperatura', 330.0000, 'ºC'),
	(48276, 112, '2015-02-01 00:17:50.000000', 'temperatura', 895.0000, 'ºC'),
	(48277, 112, '2015-02-01 00:17:51.000000', 'temperatura', 1088.0000, 'ºC'),
	(48278, 112, '2015-02-01 00:17:52.000000', 'temperatura', 352.0000, 'ºC'),
	(48279, 112, '2015-02-01 00:17:53.000000', 'temperatura', 899.0000, 'ºC'),
	(48280, 112, '2015-02-01 00:17:54.000000', 'temperatura', 1040.0000, 'ºC'),
	(48281, 112, '2015-02-01 00:17:55.000000', 'temperatura', 103.0000, 'ºC'),
	(48282, 112, '2015-02-01 00:17:56.000000', 'temperatura', 996.0000, 'ºC'),
	(48283, 112, '2015-02-01 00:17:57.000000', 'temperatura', 1073.0000, 'ºC'),
	(48284, 112, '2015-02-01 00:17:58.000000', 'temperatura', 1175.0000, 'ºC'),
	(48285, 112, '2015-02-01 00:17:59.000000', 'temperatura', 255.0000, 'ºC'),
	(48286, 112, '2015-02-01 00:18:00.000000', 'temperatura', 153.0000, 'ºC'),
	(48287, 112, '2015-02-01 00:18:01.000000', 'temperatura', 0.0000, 'ºC'),
	(48288, 112, '2015-02-01 00:18:02.000000', 'temperatura', 742.0000, 'ºC'),
	(48289, 112, '2015-02-01 00:18:03.000000', 'temperatura', 110.0000, 'ºC'),
	(48290, 112, '2015-02-01 00:18:04.000000', 'temperatura', 725.0000, 'ºC'),
	(48291, 112, '2015-02-01 00:18:05.000000', 'temperatura', 897.0000, 'ºC'),
	(48292, 112, '2015-02-01 00:18:06.000000', 'temperatura', 1108.0000, 'ºC'),
	(48293, 112, '2015-02-01 00:18:07.000000', 'temperatura', 452.0000, 'ºC'),
	(48294, 112, '2015-02-01 00:18:08.000000', 'temperatura', 135.0000, 'ºC'),
	(48295, 112, '2015-02-01 00:18:09.000000', 'temperatura', 520.0000, 'ºC'),
	(48296, 112, '2015-02-01 00:18:10.000000', 'temperatura', 994.0000, 'ºC'),
	(48297, 112, '2015-02-01 00:18:11.000000', 'temperatura', 1010.0000, 'ºC'),
	(48298, 112, '2015-02-01 00:18:12.000000', 'temperatura', 871.0000, 'ºC'),
	(48299, 112, '2015-02-01 00:18:13.000000', 'temperatura', 125.0000, 'ºC'),
	(48300, 112, '2015-02-01 00:18:14.000000', 'temperatura', 411.0000, 'ºC'),
	(48301, 112, '2015-02-01 00:18:15.000000', 'temperatura', 483.0000, 'ºC'),
	(48302, 112, '2015-02-01 00:18:16.000000', 'temperatura', 1181.0000, 'ºC'),
	(48303, 112, '2015-02-01 00:18:17.000000', 'temperatura', 855.0000, 'ºC'),
	(48304, 112, '2015-02-01 00:18:18.000000', 'temperatura', 734.0000, 'ºC'),
	(48305, 112, '2015-02-01 00:18:19.000000', 'temperatura', 1106.0000, 'ºC'),
	(48306, 112, '2015-02-01 00:18:20.000000', 'temperatura', 929.0000, 'ºC'),
	(48307, 112, '2015-02-01 00:18:21.000000', 'temperatura', 125.0000, 'ºC'),
	(48308, 112, '2015-02-01 00:18:22.000000', 'temperatura', 241.0000, 'ºC'),
	(48309, 112, '2015-02-01 00:18:23.000000', 'temperatura', 830.0000, 'ºC'),
	(48310, 112, '2015-02-01 00:18:24.000000', 'temperatura', 1028.0000, 'ºC'),
	(48311, 112, '2015-02-01 00:18:25.000000', 'temperatura', 248.0000, 'ºC'),
	(48312, 112, '2015-02-01 00:18:26.000000', 'temperatura', 557.0000, 'ºC'),
	(48313, 112, '2015-02-01 00:18:27.000000', 'temperatura', 844.0000, 'ºC'),
	(48314, 112, '2015-02-01 00:18:28.000000', 'temperatura', 146.0000, 'ºC'),
	(48315, 112, '2015-02-01 00:18:29.000000', 'temperatura', 602.0000, 'ºC'),
	(48316, 112, '2015-02-01 00:18:30.000000', 'temperatura', 170.0000, 'ºC'),
	(48317, 112, '2015-02-01 00:18:31.000000', 'temperatura', 247.0000, 'ºC'),
	(48318, 112, '2015-02-01 00:18:32.000000', 'temperatura', 723.0000, 'ºC'),
	(48319, 112, '2015-02-01 00:18:33.000000', 'temperatura', 476.0000, 'ºC'),
	(48320, 112, '2015-02-01 00:18:34.000000', 'temperatura', 212.0000, 'ºC'),
	(48321, 112, '2015-02-01 00:18:35.000000', 'temperatura', 832.0000, 'ºC'),
	(48322, 112, '2015-02-01 00:18:36.000000', 'temperatura', 1125.0000, 'ºC'),
	(48323, 112, '2015-02-01 00:18:37.000000', 'temperatura', 729.0000, 'ºC'),
	(48324, 112, '2015-02-01 00:18:38.000000', 'temperatura', 271.0000, 'ºC'),
	(48325, 112, '2015-02-01 00:18:39.000000', 'temperatura', 368.0000, 'ºC'),
	(48326, 112, '2015-02-01 00:18:40.000000', 'temperatura', 1027.0000, 'ºC'),
	(48327, 112, '2015-02-01 00:18:41.000000', 'temperatura', 431.0000, 'ºC'),
	(48328, 112, '2015-02-01 00:18:42.000000', 'temperatura', 277.0000, 'ºC'),
	(48329, 112, '2015-02-01 00:18:43.000000', 'temperatura', 90.0000, 'ºC'),
	(48330, 112, '2015-02-01 00:18:44.000000', 'temperatura', 818.0000, 'ºC'),
	(48331, 112, '2015-02-01 00:18:45.000000', 'temperatura', 223.0000, 'ºC'),
	(48332, 112, '2015-02-01 00:18:46.000000', 'temperatura', 1061.0000, 'ºC'),
	(48333, 112, '2015-02-01 00:18:47.000000', 'temperatura', 1037.0000, 'ºC'),
	(48334, 112, '2015-02-01 00:18:48.000000', 'temperatura', 801.0000, 'ºC'),
	(48335, 112, '2015-02-01 00:18:49.000000', 'temperatura', 896.0000, 'ºC'),
	(48336, 112, '2015-02-01 00:18:50.000000', 'temperatura', 878.0000, 'ºC'),
	(48337, 112, '2015-02-01 00:18:51.000000', 'temperatura', 502.0000, 'ºC'),
	(48338, 112, '2015-02-01 00:18:52.000000', 'temperatura', 1075.0000, 'ºC'),
	(48339, 112, '2015-02-01 00:18:53.000000', 'temperatura', 272.0000, 'ºC'),
	(48340, 112, '2015-02-01 00:18:54.000000', 'temperatura', 533.0000, 'ºC'),
	(48341, 112, '2015-02-01 00:18:55.000000', 'temperatura', 650.0000, 'ºC'),
	(48342, 112, '2015-02-01 00:18:56.000000', 'temperatura', 450.0000, 'ºC'),
	(48343, 112, '2015-02-01 00:18:57.000000', 'temperatura', 302.0000, 'ºC'),
	(48344, 112, '2015-02-01 00:18:58.000000', 'temperatura', 162.0000, 'ºC'),
	(48345, 112, '2015-02-01 00:18:59.000000', 'temperatura', 1104.0000, 'ºC'),
	(48346, 112, '2015-02-01 00:19:00.000000', 'temperatura', 234.0000, 'ºC'),
	(48347, 112, '2015-02-01 00:19:01.000000', 'temperatura', 260.0000, 'ºC'),
	(48348, 112, '2015-02-01 00:19:02.000000', 'temperatura', 596.0000, 'ºC'),
	(48349, 112, '2015-02-01 00:19:03.000000', 'temperatura', 1002.0000, 'ºC'),
	(48350, 112, '2015-02-01 00:19:04.000000', 'temperatura', 821.0000, 'ºC'),
	(48351, 112, '2015-02-01 00:19:05.000000', 'temperatura', 1099.0000, 'ºC'),
	(48352, 112, '2015-02-01 00:19:06.000000', 'temperatura', 632.0000, 'ºC'),
	(48353, 112, '2015-02-01 00:19:07.000000', 'temperatura', 1066.0000, 'ºC'),
	(48354, 112, '2015-02-01 00:19:08.000000', 'temperatura', 1032.0000, 'ºC'),
	(48355, 112, '2015-02-01 00:19:09.000000', 'temperatura', 763.0000, 'ºC'),
	(48356, 112, '2015-02-01 00:19:10.000000', 'temperatura', 719.0000, 'ºC'),
	(48357, 112, '2015-02-01 00:19:11.000000', 'temperatura', 109.0000, 'ºC'),
	(48358, 112, '2015-02-01 00:19:12.000000', 'temperatura', 787.0000, 'ºC'),
	(48359, 112, '2015-02-01 00:19:13.000000', 'temperatura', 8.0000, 'ºC'),
	(48360, 112, '2015-02-01 00:19:14.000000', 'temperatura', 80.0000, 'ºC'),
	(48361, 112, '2015-02-01 00:19:15.000000', 'temperatura', 378.0000, 'ºC'),
	(48362, 112, '2015-02-01 00:19:16.000000', 'temperatura', 449.0000, 'ºC'),
	(48363, 112, '2015-02-01 00:19:17.000000', 'temperatura', 1113.0000, 'ºC'),
	(48364, 112, '2015-02-01 00:19:18.000000', 'temperatura', 616.0000, 'ºC'),
	(48365, 112, '2015-02-01 00:19:19.000000', 'temperatura', 941.0000, 'ºC'),
	(48366, 112, '2015-02-01 00:19:20.000000', 'temperatura', 458.0000, 'ºC'),
	(48367, 112, '2015-02-01 00:19:21.000000', 'temperatura', 666.0000, 'ºC'),
	(48368, 112, '2015-02-01 00:19:22.000000', 'temperatura', 760.0000, 'ºC'),
	(48369, 112, '2015-02-01 00:19:23.000000', 'temperatura', 600.0000, 'ºC'),
	(48370, 112, '2015-02-01 00:19:24.000000', 'temperatura', 723.0000, 'ºC'),
	(48371, 112, '2015-02-01 00:19:25.000000', 'temperatura', 614.0000, 'ºC'),
	(48372, 112, '2015-02-01 00:19:26.000000', 'temperatura', 900.0000, 'ºC'),
	(48373, 112, '2015-02-01 00:19:27.000000', 'temperatura', 259.0000, 'ºC'),
	(48374, 112, '2015-02-01 00:19:28.000000', 'temperatura', 997.0000, 'ºC'),
	(48375, 112, '2015-02-01 00:19:29.000000', 'temperatura', 609.0000, 'ºC'),
	(48376, 112, '2015-02-01 00:19:30.000000', 'temperatura', 53.0000, 'ºC'),
	(48377, 112, '2015-02-01 00:19:31.000000', 'temperatura', 838.0000, 'ºC'),
	(48378, 112, '2015-02-01 00:19:32.000000', 'temperatura', 433.0000, 'ºC'),
	(48379, 112, '2015-02-01 00:19:33.000000', 'temperatura', 853.0000, 'ºC'),
	(48380, 112, '2015-02-01 00:19:34.000000', 'temperatura', 564.0000, 'ºC'),
	(48381, 112, '2015-02-01 00:19:35.000000', 'temperatura', 262.0000, 'ºC'),
	(48382, 112, '2015-02-01 00:19:36.000000', 'temperatura', 819.0000, 'ºC'),
	(48383, 112, '2015-02-01 00:19:37.000000', 'temperatura', 909.0000, 'ºC'),
	(48384, 112, '2015-02-01 00:19:38.000000', 'temperatura', 888.0000, 'ºC'),
	(48385, 112, '2015-02-01 00:19:39.000000', 'temperatura', 513.0000, 'ºC'),
	(48386, 112, '2015-02-01 00:19:40.000000', 'temperatura', 1102.0000, 'ºC'),
	(48387, 112, '2015-02-01 00:19:41.000000', 'temperatura', 373.0000, 'ºC'),
	(48388, 112, '2015-02-01 00:19:42.000000', 'temperatura', 958.0000, 'ºC'),
	(48389, 112, '2015-02-01 00:19:43.000000', 'temperatura', 72.0000, 'ºC'),
	(48390, 112, '2015-02-01 00:19:44.000000', 'temperatura', 1085.0000, 'ºC'),
	(48391, 112, '2015-02-01 00:19:45.000000', 'temperatura', 410.0000, 'ºC'),
	(48392, 112, '2015-02-01 00:19:46.000000', 'temperatura', 1196.0000, 'ºC'),
	(48393, 112, '2015-02-01 00:19:47.000000', 'temperatura', 1150.0000, 'ºC'),
	(48394, 112, '2015-02-01 00:19:48.000000', 'temperatura', 964.0000, 'ºC'),
	(48395, 112, '2015-02-01 00:19:49.000000', 'temperatura', 169.0000, 'ºC'),
	(48396, 112, '2015-02-01 00:19:50.000000', 'temperatura', 353.0000, 'ºC'),
	(48397, 112, '2015-02-01 00:19:51.000000', 'temperatura', 59.0000, 'ºC'),
	(48398, 112, '2015-02-01 00:19:52.000000', 'temperatura', 438.0000, 'ºC'),
	(48399, 112, '2015-02-01 00:19:53.000000', 'temperatura', 814.0000, 'ºC'),
	(48400, 112, '2015-02-01 00:19:54.000000', 'temperatura', 357.0000, 'ºC'),
	(48401, 112, '2015-02-01 00:19:55.000000', 'temperatura', 542.0000, 'ºC'),
	(48402, 112, '2015-02-01 00:19:56.000000', 'temperatura', 440.0000, 'ºC'),
	(48403, 112, '2015-02-01 00:19:57.000000', 'temperatura', 574.0000, 'ºC'),
	(48404, 112, '2015-02-01 00:19:58.000000', 'temperatura', 350.0000, 'ºC'),
	(48405, 112, '2015-02-01 00:19:59.000000', 'temperatura', 30.0000, 'ºC'),
	(48406, 112, '2015-02-01 00:20:00.000000', 'temperatura', 299.0000, 'ºC'),
	(48407, 112, '2015-02-01 00:20:01.000000', 'temperatura', 204.0000, 'ºC'),
	(48408, 112, '2015-02-01 00:20:02.000000', 'temperatura', 126.0000, 'ºC'),
	(48409, 112, '2015-02-01 00:20:03.000000', 'temperatura', 16.0000, 'ºC'),
	(48410, 112, '2015-02-01 00:20:04.000000', 'temperatura', 905.0000, 'ºC'),
	(48411, 112, '2015-02-01 00:20:05.000000', 'temperatura', 877.0000, 'ºC'),
	(48412, 112, '2015-02-01 00:20:06.000000', 'temperatura', 469.0000, 'ºC'),
	(48413, 112, '2015-02-01 00:20:07.000000', 'temperatura', 916.0000, 'ºC'),
	(48414, 112, '2015-02-01 00:20:08.000000', 'temperatura', 775.0000, 'ºC'),
	(48415, 112, '2015-02-01 00:20:09.000000', 'temperatura', 1126.0000, 'ºC'),
	(48416, 112, '2015-02-01 00:20:10.000000', 'temperatura', 907.0000, 'ºC'),
	(48417, 112, '2015-02-01 00:20:11.000000', 'temperatura', 1158.0000, 'ºC'),
	(48418, 112, '2015-02-01 00:20:12.000000', 'temperatura', 668.0000, 'ºC'),
	(48419, 112, '2015-02-01 00:20:13.000000', 'temperatura', 1068.0000, 'ºC'),
	(48420, 112, '2015-02-01 00:20:14.000000', 'temperatura', 936.0000, 'ºC'),
	(48421, 112, '2015-02-01 00:20:15.000000', 'temperatura', 275.0000, 'ºC'),
	(48422, 112, '2015-02-01 00:20:16.000000', 'temperatura', 970.0000, 'ºC'),
	(48423, 112, '2015-02-01 00:20:17.000000', 'temperatura', 424.0000, 'ºC'),
	(48424, 112, '2015-02-01 00:20:18.000000', 'temperatura', 412.0000, 'ºC'),
	(48425, 112, '2015-02-01 00:20:19.000000', 'temperatura', 788.0000, 'ºC'),
	(48426, 112, '2015-02-01 00:20:20.000000', 'temperatura', 305.0000, 'ºC'),
	(48427, 112, '2015-02-01 00:20:21.000000', 'temperatura', 362.0000, 'ºC'),
	(48428, 112, '2015-02-01 00:20:22.000000', 'temperatura', 896.0000, 'ºC'),
	(48429, 112, '2015-02-01 00:20:23.000000', 'temperatura', 992.0000, 'ºC'),
	(48430, 112, '2015-02-01 00:20:24.000000', 'temperatura', 1072.0000, 'ºC'),
	(48431, 112, '2015-02-01 00:20:25.000000', 'temperatura', 1185.0000, 'ºC'),
	(48432, 112, '2015-02-01 00:20:26.000000', 'temperatura', 311.0000, 'ºC'),
	(48433, 112, '2015-02-01 00:20:27.000000', 'temperatura', 400.0000, 'ºC'),
	(48434, 112, '2015-02-01 00:20:28.000000', 'temperatura', 1069.0000, 'ºC'),
	(48435, 112, '2015-02-01 00:20:29.000000', 'temperatura', 546.0000, 'ºC'),
	(48436, 112, '2015-02-01 00:20:30.000000', 'temperatura', 721.0000, 'ºC'),
	(48437, 112, '2015-02-01 00:20:31.000000', 'temperatura', 769.0000, 'ºC'),
	(48438, 112, '2015-02-01 00:20:32.000000', 'temperatura', 480.0000, 'ºC'),
	(48439, 112, '2015-02-01 00:20:33.000000', 'temperatura', 95.0000, 'ºC'),
	(48440, 112, '2015-02-01 00:20:34.000000', 'temperatura', 237.0000, 'ºC'),
	(48441, 112, '2015-02-01 00:20:35.000000', 'temperatura', 899.0000, 'ºC'),
	(48442, 112, '2015-02-01 00:20:36.000000', 'temperatura', 185.0000, 'ºC'),
	(48443, 112, '2015-02-01 00:20:37.000000', 'temperatura', 630.0000, 'ºC'),
	(48444, 112, '2015-02-01 00:20:38.000000', 'temperatura', 196.0000, 'ºC'),
	(48445, 112, '2015-02-01 00:20:39.000000', 'temperatura', 287.0000, 'ºC'),
	(48446, 112, '2015-02-01 00:20:40.000000', 'temperatura', 850.0000, 'ºC'),
	(48447, 112, '2015-02-01 00:20:41.000000', 'temperatura', 990.0000, 'ºC'),
	(48448, 112, '2015-02-01 00:20:42.000000', 'temperatura', 1199.0000, 'ºC'),
	(48449, 112, '2015-02-01 00:20:43.000000', 'temperatura', 627.0000, 'ºC'),
	(48450, 112, '2015-02-01 00:20:44.000000', 'temperatura', 738.0000, 'ºC'),
	(48451, 112, '2015-02-01 00:20:45.000000', 'temperatura', 610.0000, 'ºC'),
	(48452, 112, '2015-02-01 00:20:46.000000', 'temperatura', 838.0000, 'ºC'),
	(48453, 112, '2015-02-01 00:20:47.000000', 'temperatura', 1159.0000, 'ºC'),
	(48454, 112, '2015-02-01 00:20:48.000000', 'temperatura', 880.0000, 'ºC'),
	(48455, 112, '2015-02-01 00:20:49.000000', 'temperatura', 924.0000, 'ºC'),
	(48456, 112, '2015-02-01 00:20:50.000000', 'temperatura', 779.0000, 'ºC'),
	(48457, 112, '2015-02-01 00:20:51.000000', 'temperatura', 1127.0000, 'ºC'),
	(48458, 112, '2015-02-01 00:20:52.000000', 'temperatura', 895.0000, 'ºC'),
	(48459, 112, '2015-02-01 00:20:53.000000', 'temperatura', 1095.0000, 'ºC'),
	(48460, 112, '2015-02-01 00:20:54.000000', 'temperatura', 393.0000, 'ºC'),
	(48461, 112, '2015-02-01 00:20:55.000000', 'temperatura', 1080.0000, 'ºC'),
	(48462, 112, '2015-02-01 00:20:56.000000', 'temperatura', 619.0000, 'ºC'),
	(48463, 112, '2015-02-01 00:20:57.000000', 'temperatura', 1058.0000, 'ºC'),
	(48464, 112, '2015-02-01 00:20:58.000000', 'temperatura', 1032.0000, 'ºC'),
	(48465, 112, '2015-02-01 00:20:59.000000', 'temperatura', 787.0000, 'ºC'),
	(48466, 112, '2015-02-01 00:21:00.000000', 'temperatura', 840.0000, 'ºC'),
	(48467, 112, '2015-02-01 00:21:01.000000', 'temperatura', 639.0000, 'ºC'),
	(48468, 112, '2015-02-01 00:21:02.000000', 'temperatura', 674.0000, 'ºC'),
	(48469, 112, '2015-02-01 00:21:03.000000', 'temperatura', 254.0000, 'ºC'),
	(48470, 112, '2015-02-01 00:21:04.000000', 'temperatura', 447.0000, 'ºC'),
	(48471, 112, '2015-02-01 00:21:05.000000', 'temperatura', 275.0000, 'ºC'),
	(48472, 112, '2015-02-01 00:21:06.000000', 'temperatura', 33.0000, 'ºC'),
	(48473, 112, '2015-02-01 00:21:07.000000', 'temperatura', 540.0000, 'ºC'),
	(48474, 112, '2015-02-01 00:21:08.000000', 'temperatura', 204.0000, 'ºC'),
	(48475, 112, '2015-02-01 00:21:09.000000', 'temperatura', 600.0000, 'ºC'),
	(48476, 112, '2015-02-01 00:21:10.000000', 'temperatura', 1189.0000, 'ºC'),
	(48477, 112, '2015-02-01 00:21:11.000000', 'temperatura', 543.0000, 'ºC'),
	(48478, 112, '2015-02-01 00:21:12.000000', 'temperatura', 350.0000, 'ºC'),
	(48479, 112, '2015-02-01 00:21:13.000000', 'temperatura', 122.0000, 'ºC'),
	(48480, 112, '2015-02-01 00:21:14.000000', 'temperatura', 762.0000, 'ºC'),
	(48481, 112, '2015-02-01 00:21:15.000000', 'temperatura', 1042.0000, 'ºC'),
	(48482, 112, '2015-02-01 00:21:16.000000', 'temperatura', 526.0000, 'ºC'),
	(48483, 112, '2015-02-01 00:21:17.000000', 'temperatura', 702.0000, 'ºC'),
	(48484, 112, '2015-02-01 00:21:18.000000', 'temperatura', 735.0000, 'ºC'),
	(48485, 112, '2015-02-01 00:21:19.000000', 'temperatura', 367.0000, 'ºC'),
	(48486, 112, '2015-02-01 00:21:20.000000', 'temperatura', 833.0000, 'ºC'),
	(48487, 112, '2015-02-01 00:21:21.000000', 'temperatura', 665.0000, 'ºC'),
	(48488, 112, '2015-02-01 00:21:22.000000', 'temperatura', 826.0000, 'ºC'),
	(48489, 112, '2015-02-01 00:21:23.000000', 'temperatura', 934.0000, 'ºC'),
	(48490, 112, '2015-02-01 00:21:24.000000', 'temperatura', 993.0000, 'ºC'),
	(48491, 112, '2015-02-01 00:21:25.000000', 'temperatura', 963.0000, 'ºC'),
	(48492, 112, '2015-02-01 00:21:26.000000', 'temperatura', 638.0000, 'ºC'),
	(48493, 112, '2015-02-01 00:21:27.000000', 'temperatura', 300.0000, 'ºC'),
	(48494, 112, '2015-02-01 00:21:28.000000', 'temperatura', 788.0000, 'ºC'),
	(48495, 112, '2015-02-01 00:21:29.000000', 'temperatura', 639.0000, 'ºC'),
	(48496, 112, '2015-02-01 00:21:30.000000', 'temperatura', 833.0000, 'ºC'),
	(48497, 112, '2015-02-01 00:21:31.000000', 'temperatura', 1048.0000, 'ºC'),
	(48498, 112, '2015-02-01 00:21:32.000000', 'temperatura', 342.0000, 'ºC'),
	(48499, 112, '2015-02-01 00:21:33.000000', 'temperatura', 967.0000, 'ºC'),
	(48500, 112, '2015-02-01 00:21:34.000000', 'temperatura', 208.0000, 'ºC'),
	(48501, 112, '2015-02-01 00:21:35.000000', 'temperatura', 541.0000, 'ºC'),
	(48502, 112, '2015-02-01 00:21:36.000000', 'temperatura', 882.0000, 'ºC'),
	(48503, 112, '2015-02-01 00:21:37.000000', 'temperatura', 385.0000, 'ºC'),
	(48504, 112, '2015-02-01 00:21:38.000000', 'temperatura', 480.0000, 'ºC'),
	(48505, 112, '2015-02-01 00:21:39.000000', 'temperatura', 48.0000, 'ºC'),
	(48506, 112, '2015-02-01 00:21:40.000000', 'temperatura', 1198.0000, 'ºC'),
	(48507, 112, '2015-02-01 00:21:41.000000', 'temperatura', 1046.0000, 'ºC'),
	(48508, 112, '2015-02-01 00:21:42.000000', 'temperatura', 438.0000, 'ºC'),
	(48509, 112, '2015-02-01 00:21:43.000000', 'temperatura', 251.0000, 'ºC'),
	(48510, 112, '2015-02-01 00:21:44.000000', 'temperatura', 1141.0000, 'ºC'),
	(48511, 112, '2015-02-01 00:21:45.000000', 'temperatura', 152.0000, 'ºC'),
	(48512, 112, '2015-02-01 00:21:46.000000', 'temperatura', 938.0000, 'ºC'),
	(48513, 112, '2015-02-01 00:21:47.000000', 'temperatura', 633.0000, 'ºC'),
	(48514, 112, '2015-02-01 00:21:48.000000', 'temperatura', 355.0000, 'ºC'),
	(48515, 112, '2015-02-01 00:21:49.000000', 'temperatura', 1074.0000, 'ºC'),
	(48516, 112, '2015-02-01 00:21:50.000000', 'temperatura', 707.0000, 'ºC'),
	(48517, 112, '2015-02-01 00:21:51.000000', 'temperatura', 312.0000, 'ºC'),
	(48518, 112, '2015-02-01 00:21:52.000000', 'temperatura', 639.0000, 'ºC'),
	(48519, 112, '2015-02-01 00:21:53.000000', 'temperatura', 1059.0000, 'ºC'),
	(48520, 112, '2015-02-01 00:21:54.000000', 'temperatura', 980.0000, 'ºC'),
	(48521, 112, '2015-02-01 00:21:55.000000', 'temperatura', 524.0000, 'ºC'),
	(48522, 112, '2015-02-01 00:21:56.000000', 'temperatura', 880.0000, 'ºC'),
	(48523, 112, '2015-02-01 00:21:57.000000', 'temperatura', 428.0000, 'ºC'),
	(48524, 112, '2015-02-01 00:21:58.000000', 'temperatura', 700.0000, 'ºC'),
	(48525, 112, '2015-02-01 00:21:59.000000', 'temperatura', 1016.0000, 'ºC'),
	(48526, 112, '2015-02-01 00:22:00.000000', 'temperatura', 583.0000, 'ºC'),
	(48527, 112, '2015-02-01 00:22:01.000000', 'temperatura', 1067.0000, 'ºC'),
	(48528, 112, '2015-02-01 00:22:02.000000', 'temperatura', 1188.0000, 'ºC'),
	(48529, 112, '2015-02-01 00:22:03.000000', 'temperatura', 336.0000, 'ºC'),
	(48530, 112, '2015-02-01 00:22:04.000000', 'temperatura', 518.0000, 'ºC'),
	(48531, 112, '2015-02-01 00:22:05.000000', 'temperatura', 382.0000, 'ºC'),
	(48532, 112, '2015-02-01 00:22:06.000000', 'temperatura', 355.0000, 'ºC'),
	(48533, 112, '2015-02-01 00:22:07.000000', 'temperatura', 631.0000, 'ºC'),
	(48534, 112, '2015-02-01 00:22:08.000000', 'temperatura', 890.0000, 'ºC'),
	(48535, 112, '2015-02-01 00:22:09.000000', 'temperatura', 159.0000, 'ºC'),
	(48536, 112, '2015-02-01 00:22:10.000000', 'temperatura', 526.0000, 'ºC'),
	(48537, 112, '2015-02-01 00:22:11.000000', 'temperatura', 950.0000, 'ºC'),
	(48538, 112, '2015-02-01 00:22:12.000000', 'temperatura', 776.0000, 'ºC'),
	(48539, 112, '2015-02-01 00:22:13.000000', 'temperatura', 1029.0000, 'ºC'),
	(48540, 112, '2015-02-01 00:22:14.000000', 'temperatura', 420.0000, 'ºC'),
	(48541, 112, '2015-02-01 00:22:15.000000', 'temperatura', 210.0000, 'ºC'),
	(48542, 112, '2015-02-01 00:22:16.000000', 'temperatura', 992.0000, 'ºC'),
	(48543, 112, '2015-02-01 00:22:17.000000', 'temperatura', 731.0000, 'ºC'),
	(48544, 112, '2015-02-01 00:22:18.000000', 'temperatura', 680.0000, 'ºC'),
	(48545, 112, '2015-02-01 00:22:19.000000', 'temperatura', 8.0000, 'ºC'),
	(48546, 112, '2015-02-01 00:22:20.000000', 'temperatura', 398.0000, 'ºC'),
	(48547, 112, '2015-02-01 00:22:21.000000', 'temperatura', 769.0000, 'ºC'),
	(48548, 112, '2015-02-01 00:22:22.000000', 'temperatura', 249.0000, 'ºC'),
	(48549, 112, '2015-02-01 00:22:23.000000', 'temperatura', 141.0000, 'ºC'),
	(48550, 112, '2015-02-01 00:22:24.000000', 'temperatura', 1157.0000, 'ºC'),
	(48551, 112, '2015-02-01 00:22:25.000000', 'temperatura', 563.0000, 'ºC'),
	(48552, 112, '2015-02-01 00:22:26.000000', 'temperatura', 545.0000, 'ºC'),
	(48553, 112, '2015-02-01 00:22:27.000000', 'temperatura', 1038.0000, 'ºC'),
	(48554, 112, '2015-02-01 00:22:28.000000', 'temperatura', 1152.0000, 'ºC'),
	(48555, 112, '2015-02-01 00:22:29.000000', 'temperatura', 249.0000, 'ºC'),
	(48556, 112, '2015-02-01 00:22:30.000000', 'temperatura', 189.0000, 'ºC'),
	(48557, 112, '2015-02-01 00:22:31.000000', 'temperatura', 197.0000, 'ºC'),
	(48558, 112, '2015-02-01 00:22:32.000000', 'temperatura', 421.0000, 'ºC'),
	(48559, 112, '2015-02-01 00:22:33.000000', 'temperatura', 313.0000, 'ºC'),
	(48560, 112, '2015-02-01 00:22:34.000000', 'temperatura', 301.0000, 'ºC'),
	(48561, 112, '2015-02-01 00:22:35.000000', 'temperatura', 568.0000, 'ºC'),
	(48562, 112, '2015-02-01 00:22:36.000000', 'temperatura', 736.0000, 'ºC'),
	(48563, 112, '2015-02-01 00:22:37.000000', 'temperatura', 777.0000, 'ºC'),
	(48564, 112, '2015-02-01 00:22:38.000000', 'temperatura', 478.0000, 'ºC'),
	(48565, 112, '2015-02-01 00:22:39.000000', 'temperatura', 58.0000, 'ºC'),
	(48566, 112, '2015-02-01 00:22:40.000000', 'temperatura', 57.0000, 'ºC'),
	(48567, 112, '2015-02-01 00:22:41.000000', 'temperatura', 110.0000, 'ºC'),
	(48568, 112, '2015-02-01 00:22:42.000000', 'temperatura', 381.0000, 'ºC'),
	(48569, 112, '2015-02-01 00:22:43.000000', 'temperatura', 376.0000, 'ºC'),
	(48570, 112, '2015-02-01 00:22:44.000000', 'temperatura', 738.0000, 'ºC'),
	(48571, 112, '2015-02-01 00:22:45.000000', 'temperatura', 162.0000, 'ºC'),
	(48572, 112, '2015-02-01 00:22:46.000000', 'temperatura', 997.0000, 'ºC'),
	(48573, 112, '2015-02-01 00:22:47.000000', 'temperatura', 898.0000, 'ºC'),
	(48574, 112, '2015-02-01 00:22:48.000000', 'temperatura', 301.0000, 'ºC'),
	(48575, 112, '2015-02-01 00:22:49.000000', 'temperatura', 10.0000, 'ºC'),
	(48576, 112, '2015-02-01 00:22:50.000000', 'temperatura', 347.0000, 'ºC'),
	(48577, 112, '2015-02-01 00:22:51.000000', 'temperatura', 506.0000, 'ºC'),
	(48578, 112, '2015-02-01 00:22:52.000000', 'temperatura', 288.0000, 'ºC'),
	(48579, 112, '2015-02-01 00:22:53.000000', 'temperatura', 1124.0000, 'ºC'),
	(48580, 112, '2015-02-01 00:22:54.000000', 'temperatura', 1156.0000, 'ºC'),
	(48581, 112, '2015-02-01 00:22:55.000000', 'temperatura', 8.0000, 'ºC'),
	(48582, 112, '2015-02-01 00:22:56.000000', 'temperatura', 172.0000, 'ºC'),
	(48583, 112, '2015-02-01 00:22:57.000000', 'temperatura', 837.0000, 'ºC'),
	(48584, 112, '2015-02-01 00:22:58.000000', 'temperatura', 69.0000, 'ºC'),
	(48585, 112, '2015-02-01 00:22:59.000000', 'temperatura', 234.0000, 'ºC'),
	(48586, 112, '2015-02-01 00:23:00.000000', 'temperatura', 963.0000, 'ºC'),
	(48587, 112, '2015-02-01 00:23:01.000000', 'temperatura', 513.0000, 'ºC'),
	(48588, 112, '2015-02-01 00:23:02.000000', 'temperatura', 876.0000, 'ºC'),
	(48589, 112, '2015-02-01 00:23:03.000000', 'temperatura', 442.0000, 'ºC'),
	(48590, 112, '2015-02-01 00:23:04.000000', 'temperatura', 783.0000, 'ºC'),
	(48591, 112, '2015-02-01 00:23:05.000000', 'temperatura', 188.0000, 'ºC'),
	(48592, 112, '2015-02-01 00:23:06.000000', 'temperatura', 992.0000, 'ºC'),
	(48593, 112, '2015-02-01 00:23:07.000000', 'temperatura', 799.0000, 'ºC'),
	(48594, 112, '2015-02-01 00:23:08.000000', 'temperatura', 1016.0000, 'ºC'),
	(48595, 112, '2015-02-01 00:23:09.000000', 'temperatura', 286.0000, 'ºC'),
	(48596, 112, '2015-02-01 00:23:10.000000', 'temperatura', 781.0000, 'ºC'),
	(48597, 112, '2015-02-01 00:23:11.000000', 'temperatura', 649.0000, 'ºC'),
	(48598, 112, '2015-02-01 00:23:12.000000', 'temperatura', 902.0000, 'ºC'),
	(48599, 112, '2015-02-01 00:23:13.000000', 'temperatura', 162.0000, 'ºC'),
	(48600, 112, '2015-02-01 00:23:14.000000', 'temperatura', 505.0000, 'ºC'),
	(48601, 112, '2015-02-01 00:23:15.000000', 'temperatura', 839.0000, 'ºC'),
	(48602, 112, '2015-02-01 00:23:16.000000', 'temperatura', 280.0000, 'ºC'),
	(48603, 112, '2015-02-01 00:23:17.000000', 'temperatura', 82.0000, 'ºC'),
	(48604, 112, '2015-02-01 00:23:18.000000', 'temperatura', 774.0000, 'ºC'),
	(48605, 112, '2015-02-01 00:23:19.000000', 'temperatura', 24.0000, 'ºC'),
	(48606, 112, '2015-02-01 00:23:20.000000', 'temperatura', 198.0000, 'ºC'),
	(48607, 112, '2015-02-01 00:23:21.000000', 'temperatura', 918.0000, 'ºC'),
	(48608, 112, '2015-02-01 00:23:22.000000', 'temperatura', 398.0000, 'ºC'),
	(48609, 112, '2015-02-01 00:23:23.000000', 'temperatura', 435.0000, 'ºC'),
	(48610, 112, '2015-02-01 00:23:24.000000', 'temperatura', 982.0000, 'ºC'),
	(48611, 112, '2015-02-01 00:23:25.000000', 'temperatura', 7.0000, 'ºC'),
	(48612, 112, '2015-02-01 00:23:26.000000', 'temperatura', 688.0000, 'ºC'),
	(48613, 112, '2015-02-01 00:23:27.000000', 'temperatura', 1021.0000, 'ºC'),
	(48614, 112, '2015-02-01 00:23:28.000000', 'temperatura', 641.0000, 'ºC'),
	(48615, 112, '2015-02-01 00:23:29.000000', 'temperatura', 143.0000, 'ºC'),
	(48616, 112, '2015-02-01 00:23:30.000000', 'temperatura', 1191.0000, 'ºC'),
	(48617, 112, '2015-02-01 00:23:31.000000', 'temperatura', 728.0000, 'ºC'),
	(48618, 112, '2015-02-01 00:23:32.000000', 'temperatura', 69.0000, 'ºC'),
	(48619, 112, '2015-02-01 00:23:33.000000', 'temperatura', 560.0000, 'ºC'),
	(48620, 112, '2015-02-01 00:23:34.000000', 'temperatura', 192.0000, 'ºC'),
	(48621, 112, '2015-02-01 00:23:35.000000', 'temperatura', 481.0000, 'ºC'),
	(48622, 112, '2015-02-01 00:23:36.000000', 'temperatura', 632.0000, 'ºC'),
	(48623, 112, '2015-02-01 00:23:37.000000', 'temperatura', 515.0000, 'ºC'),
	(48624, 112, '2015-02-01 00:23:38.000000', 'temperatura', 681.0000, 'ºC'),
	(48625, 112, '2015-02-01 00:23:39.000000', 'temperatura', 659.0000, 'ºC'),
	(48626, 112, '2015-02-01 00:23:40.000000', 'temperatura', 54.0000, 'ºC'),
	(48627, 112, '2015-02-01 00:23:41.000000', 'temperatura', 693.0000, 'ºC'),
	(48628, 112, '2015-02-01 00:23:42.000000', 'temperatura', 903.0000, 'ºC'),
	(48629, 112, '2015-02-01 00:23:43.000000', 'temperatura', 36.0000, 'ºC'),
	(48630, 112, '2015-02-01 00:23:44.000000', 'temperatura', 1073.0000, 'ºC'),
	(48631, 112, '2015-02-01 00:23:45.000000', 'temperatura', 459.0000, 'ºC'),
	(48632, 112, '2015-02-01 00:23:46.000000', 'temperatura', 273.0000, 'ºC'),
	(48633, 112, '2015-02-01 00:23:47.000000', 'temperatura', 1191.0000, 'ºC'),
	(48634, 112, '2015-02-01 00:23:48.000000', 'temperatura', 334.0000, 'ºC'),
	(48635, 112, '2015-02-01 00:23:49.000000', 'temperatura', 498.0000, 'ºC'),
	(48636, 112, '2015-02-01 00:23:50.000000', 'temperatura', 288.0000, 'ºC'),
	(48637, 112, '2015-02-01 00:23:51.000000', 'temperatura', 1146.0000, 'ºC'),
	(48638, 112, '2015-02-01 00:23:52.000000', 'temperatura', 66.0000, 'ºC'),
	(48639, 112, '2015-02-01 00:23:53.000000', 'temperatura', 495.0000, 'ºC'),
	(48640, 112, '2015-02-01 00:23:54.000000', 'temperatura', 1075.0000, 'ºC'),
	(48641, 112, '2015-02-01 00:23:55.000000', 'temperatura', 293.0000, 'ºC'),
	(48642, 112, '2015-02-01 00:23:56.000000', 'temperatura', 639.0000, 'ºC'),
	(48643, 112, '2015-02-01 00:23:57.000000', 'temperatura', 1116.0000, 'ºC'),
	(48644, 112, '2015-02-01 00:23:58.000000', 'temperatura', 64.0000, 'ºC'),
	(48645, 112, '2015-02-01 00:23:59.000000', 'temperatura', 574.0000, 'ºC'),
	(48646, 112, '2015-02-01 00:24:00.000000', 'temperatura', 277.0000, 'ºC'),
	(48647, 112, '2015-02-01 00:24:01.000000', 'temperatura', 865.0000, 'ºC'),
	(48648, 112, '2015-02-01 00:24:02.000000', 'temperatura', 1092.0000, 'ºC'),
	(48649, 112, '2015-02-01 00:24:03.000000', 'temperatura', 466.0000, 'ºC'),
	(48650, 112, '2015-02-01 00:24:04.000000', 'temperatura', 257.0000, 'ºC'),
	(48651, 112, '2015-02-01 00:24:05.000000', 'temperatura', 1084.0000, 'ºC'),
	(48652, 112, '2015-02-01 00:24:06.000000', 'temperatura', 1052.0000, 'ºC'),
	(48653, 112, '2015-02-01 00:24:07.000000', 'temperatura', 808.0000, 'ºC'),
	(48654, 112, '2015-02-01 00:24:08.000000', 'temperatura', 883.0000, 'ºC'),
	(48655, 112, '2015-02-01 00:24:09.000000', 'temperatura', 790.0000, 'ºC'),
	(48656, 112, '2015-02-01 00:24:10.000000', 'temperatura', 105.0000, 'ºC'),
	(48657, 112, '2015-02-01 00:24:11.000000', 'temperatura', 555.0000, 'ºC'),
	(48658, 112, '2015-02-01 00:24:12.000000', 'temperatura', 59.0000, 'ºC'),
	(48659, 112, '2015-02-01 00:24:13.000000', 'temperatura', 1033.0000, 'ºC'),
	(48660, 112, '2015-02-01 00:24:14.000000', 'temperatura', 187.0000, 'ºC'),
	(48661, 112, '2015-02-01 00:24:15.000000', 'temperatura', 235.0000, 'ºC'),
	(48662, 112, '2015-02-01 00:24:16.000000', 'temperatura', 617.0000, 'ºC'),
	(48663, 112, '2015-02-01 00:24:17.000000', 'temperatura', 1179.0000, 'ºC'),
	(48664, 112, '2015-02-01 00:24:18.000000', 'temperatura', 444.0000, 'ºC'),
	(48665, 112, '2015-02-01 00:24:19.000000', 'temperatura', 1083.0000, 'ºC'),
	(48666, 112, '2015-02-01 00:24:20.000000', 'temperatura', 485.0000, 'ºC'),
	(48667, 112, '2015-02-01 00:24:21.000000', 'temperatura', 376.0000, 'ºC'),
	(48668, 112, '2015-02-01 00:24:22.000000', 'temperatura', 428.0000, 'ºC'),
	(48669, 112, '2015-02-01 00:24:23.000000', 'temperatura', 1009.0000, 'ºC'),
	(48670, 112, '2015-02-01 00:24:24.000000', 'temperatura', 162.0000, 'ºC'),
	(48671, 112, '2015-02-01 00:24:25.000000', 'temperatura', 183.0000, 'ºC'),
	(48672, 112, '2015-02-01 00:24:26.000000', 'temperatura', 429.0000, 'ºC'),
	(48673, 112, '2015-02-01 00:24:27.000000', 'temperatura', 399.0000, 'ºC'),
	(48674, 112, '2015-02-01 00:24:28.000000', 'temperatura', 707.0000, 'ºC'),
	(48675, 112, '2015-02-01 00:24:29.000000', 'temperatura', 1140.0000, 'ºC'),
	(48676, 112, '2015-02-01 00:24:30.000000', 'temperatura', 1179.0000, 'ºC'),
	(48677, 112, '2015-02-01 00:24:31.000000', 'temperatura', 73.0000, 'ºC'),
	(48678, 112, '2015-02-01 00:24:32.000000', 'temperatura', 432.0000, 'ºC'),
	(48679, 112, '2015-02-01 00:24:33.000000', 'temperatura', 740.0000, 'ºC'),
	(48680, 112, '2015-02-01 00:24:34.000000', 'temperatura', 6.0000, 'ºC'),
	(48681, 112, '2015-02-01 00:24:35.000000', 'temperatura', 210.0000, 'ºC'),
	(48682, 112, '2015-02-01 00:24:36.000000', 'temperatura', 1033.0000, 'ºC'),
	(48683, 112, '2015-02-01 00:24:37.000000', 'temperatura', 934.0000, 'ºC'),
	(48684, 112, '2015-02-01 00:24:38.000000', 'temperatura', 373.0000, 'ºC'),
	(48685, 112, '2015-02-01 00:24:39.000000', 'temperatura', 264.0000, 'ºC'),
	(48686, 112, '2015-02-01 00:24:40.000000', 'temperatura', 203.0000, 'ºC'),
	(48687, 112, '2015-02-01 00:24:41.000000', 'temperatura', 221.0000, 'ºC'),
	(48688, 112, '2015-02-01 00:24:42.000000', 'temperatura', 495.0000, 'ºC'),
	(48689, 112, '2015-02-01 00:24:43.000000', 'temperatura', 616.0000, 'ºC'),
	(48690, 112, '2015-02-01 00:24:44.000000', 'temperatura', 394.0000, 'ºC'),
	(48691, 112, '2015-02-01 00:24:45.000000', 'temperatura', 125.0000, 'ºC'),
	(48692, 112, '2015-02-01 00:24:46.000000', 'temperatura', 640.0000, 'ºC'),
	(48693, 112, '2015-02-01 00:24:47.000000', 'temperatura', 429.0000, 'ºC'),
	(48694, 112, '2015-02-01 00:24:48.000000', 'temperatura', 222.0000, 'ºC'),
	(48695, 112, '2015-02-01 00:24:49.000000', 'temperatura', 1026.0000, 'ºC'),
	(48696, 112, '2015-02-01 00:24:50.000000', 'temperatura', 863.0000, 'ºC'),
	(48697, 112, '2015-02-01 00:24:51.000000', 'temperatura', 38.0000, 'ºC'),
	(48698, 112, '2015-02-01 00:24:52.000000', 'temperatura', 0.0000, 'ºC'),
	(48699, 112, '2015-02-01 00:24:53.000000', 'temperatura', 1089.0000, 'ºC'),
	(48700, 112, '2015-02-01 00:24:54.000000', 'temperatura', 644.0000, 'ºC'),
	(48701, 112, '2015-02-01 00:24:55.000000', 'temperatura', 1153.0000, 'ºC'),
	(48702, 112, '2015-02-01 00:24:56.000000', 'temperatura', 235.0000, 'ºC'),
	(48703, 112, '2015-02-01 00:24:57.000000', 'temperatura', 117.0000, 'ºC'),
	(48704, 112, '2015-02-01 00:24:58.000000', 'temperatura', 1082.0000, 'ºC'),
	(48705, 112, '2015-02-01 00:24:59.000000', 'temperatura', 257.0000, 'ºC'),
	(48706, 112, '2015-02-01 00:25:00.000000', 'temperatura', 441.0000, 'ºC'),
	(48707, 112, '2015-02-01 00:25:01.000000', 'temperatura', 235.0000, 'ºC'),
	(48708, 112, '2015-02-01 00:25:02.000000', 'temperatura', 1052.0000, 'ºC'),
	(48709, 112, '2015-02-01 00:25:03.000000', 'temperatura', 954.0000, 'ºC'),
	(48710, 112, '2015-02-01 00:25:04.000000', 'temperatura', 415.0000, 'ºC'),
	(48711, 112, '2015-02-01 00:25:05.000000', 'temperatura', 412.0000, 'ºC'),
	(48712, 112, '2015-02-01 00:25:06.000000', 'temperatura', 818.0000, 'ºC'),
	(48713, 112, '2015-02-01 00:25:07.000000', 'temperatura', 455.0000, 'ºC'),
	(48714, 112, '2015-02-01 00:25:08.000000', 'temperatura', 1022.0000, 'ºC'),
	(48715, 112, '2015-02-01 00:25:09.000000', 'temperatura', 144.0000, 'ºC'),
	(48716, 112, '2015-02-01 00:25:10.000000', 'temperatura', 55.0000, 'ºC'),
	(48717, 112, '2015-02-01 00:25:11.000000', 'temperatura', 1043.0000, 'ºC'),
	(48718, 112, '2015-02-01 00:25:12.000000', 'temperatura', 253.0000, 'ºC'),
	(48719, 112, '2015-02-01 00:25:13.000000', 'temperatura', 533.0000, 'ºC'),
	(48720, 112, '2015-02-01 00:25:14.000000', 'temperatura', 710.0000, 'ºC'),
	(48721, 112, '2015-02-01 00:25:15.000000', 'temperatura', 748.0000, 'ºC'),
	(48722, 112, '2015-02-01 00:25:16.000000', 'temperatura', 414.0000, 'ºC'),
	(48723, 112, '2015-02-01 00:25:17.000000', 'temperatura', 1025.0000, 'ºC'),
	(48724, 112, '2015-02-01 00:25:18.000000', 'temperatura', 282.0000, 'ºC'),
	(48725, 112, '2015-02-01 00:25:19.000000', 'temperatura', 735.0000, 'ºC'),
	(48726, 112, '2015-02-01 00:25:20.000000', 'temperatura', 429.0000, 'ºC'),
	(48727, 112, '2015-02-01 00:25:21.000000', 'temperatura', 1141.0000, 'ºC'),
	(48728, 112, '2015-02-01 00:25:22.000000', 'temperatura', 821.0000, 'ºC'),
	(48729, 112, '2015-02-01 00:25:23.000000', 'temperatura', 681.0000, 'ºC'),
	(48730, 112, '2015-02-01 00:25:24.000000', 'temperatura', 942.0000, 'ºC'),
	(48731, 112, '2015-02-01 00:25:25.000000', 'temperatura', 269.0000, 'ºC'),
	(48732, 112, '2015-02-01 00:25:26.000000', 'temperatura', 919.0000, 'ºC'),
	(48733, 112, '2015-02-01 00:25:27.000000', 'temperatura', 190.0000, 'ºC'),
	(48734, 112, '2015-02-01 00:25:28.000000', 'temperatura', 594.0000, 'ºC'),
	(48735, 112, '2015-02-01 00:25:29.000000', 'temperatura', 1198.0000, 'ºC'),
	(48736, 112, '2015-02-01 00:25:30.000000', 'temperatura', 611.0000, 'ºC'),
	(48737, 112, '2015-02-01 00:25:31.000000', 'temperatura', 660.0000, 'ºC'),
	(48738, 112, '2015-02-01 00:25:32.000000', 'temperatura', 266.0000, 'ºC'),
	(48739, 112, '2015-02-01 00:25:33.000000', 'temperatura', 551.0000, 'ºC'),
	(48740, 112, '2015-02-01 00:25:34.000000', 'temperatura', 758.0000, 'ºC'),
	(48741, 112, '2015-02-01 00:25:35.000000', 'temperatura', 937.0000, 'ºC'),
	(48742, 112, '2015-02-01 00:25:36.000000', 'temperatura', 10.0000, 'ºC'),
	(48743, 112, '2015-02-01 00:25:37.000000', 'temperatura', 840.0000, 'ºC'),
	(48744, 112, '2015-02-01 00:25:38.000000', 'temperatura', 573.0000, 'ºC'),
	(48745, 112, '2015-02-01 00:25:39.000000', 'temperatura', 342.0000, 'ºC'),
	(48746, 112, '2015-02-01 00:25:40.000000', 'temperatura', 1193.0000, 'ºC'),
	(48747, 112, '2015-02-01 00:25:41.000000', 'temperatura', 140.0000, 'ºC'),
	(48748, 112, '2015-02-01 00:25:42.000000', 'temperatura', 720.0000, 'ºC'),
	(48749, 112, '2015-02-01 00:25:43.000000', 'temperatura', 782.0000, 'ºC'),
	(48750, 112, '2015-02-01 00:25:44.000000', 'temperatura', 549.0000, 'ºC'),
	(48751, 112, '2015-02-01 00:25:45.000000', 'temperatura', 401.0000, 'ºC'),
	(48752, 112, '2015-02-01 00:25:46.000000', 'temperatura', 359.0000, 'ºC'),
	(48753, 112, '2015-02-01 00:25:47.000000', 'temperatura', 592.0000, 'ºC'),
	(48754, 112, '2015-02-01 00:25:48.000000', 'temperatura', 682.0000, 'ºC'),
	(48755, 112, '2015-02-01 00:25:49.000000', 'temperatura', 435.0000, 'ºC'),
	(48756, 112, '2015-02-01 00:25:50.000000', 'temperatura', 130.0000, 'ºC'),
	(48757, 112, '2015-02-01 00:25:51.000000', 'temperatura', 546.0000, 'ºC'),
	(48758, 112, '2015-02-01 00:25:52.000000', 'temperatura', 1139.0000, 'ºC'),
	(48759, 112, '2015-02-01 00:25:53.000000', 'temperatura', 459.0000, 'ºC'),
	(48760, 112, '2015-02-01 00:25:54.000000', 'temperatura', 78.0000, 'ºC'),
	(48761, 112, '2015-02-01 00:25:55.000000', 'temperatura', 213.0000, 'ºC'),
	(48762, 112, '2015-02-01 00:25:56.000000', 'temperatura', 833.0000, 'ºC'),
	(48763, 112, '2015-02-01 00:25:57.000000', 'temperatura', 1127.0000, 'ºC'),
	(48764, 112, '2015-02-01 00:25:58.000000', 'temperatura', 737.0000, 'ºC'),
	(48765, 112, '2015-02-01 00:25:59.000000', 'temperatura', 306.0000, 'ºC'),
	(48766, 112, '2015-02-01 00:26:00.000000', 'temperatura', 516.0000, 'ºC'),
	(48767, 112, '2015-02-01 00:26:01.000000', 'temperatura', 464.0000, 'ºC'),
	(48768, 112, '2015-02-01 00:26:02.000000', 'temperatura', 771.0000, 'ºC'),
	(48769, 112, '2015-02-01 00:26:03.000000', 'temperatura', 65.0000, 'ºC'),
	(48770, 112, '2015-02-01 00:26:04.000000', 'temperatura', 413.0000, 'ºC'),
	(48771, 112, '2015-02-01 00:26:05.000000', 'temperatura', 669.0000, 'ºC'),
	(48772, 112, '2015-02-01 00:26:06.000000', 'temperatura', 907.0000, 'ºC'),
	(48773, 112, '2015-02-01 00:26:07.000000', 'temperatura', 128.0000, 'ºC'),
	(48774, 112, '2015-02-01 00:26:08.000000', 'temperatura', 318.0000, 'ºC'),
	(48775, 112, '2015-02-01 00:26:09.000000', 'temperatura', 7.0000, 'ºC'),
	(48776, 112, '2015-02-01 00:26:10.000000', 'temperatura', 282.0000, 'ºC'),
	(48777, 112, '2015-02-01 00:26:11.000000', 'temperatura', 191.0000, 'ºC'),
	(48778, 112, '2015-02-01 00:26:12.000000', 'temperatura', 107.0000, 'ºC'),
	(48779, 112, '2015-02-01 00:26:13.000000', 'temperatura', 1164.0000, 'ºC'),
	(48780, 112, '2015-02-01 00:26:14.000000', 'temperatura', 698.0000, 'ºC'),
	(48781, 112, '2015-02-01 00:26:15.000000', 'temperatura', 1199.0000, 'ºC'),
	(48782, 112, '2015-02-01 00:26:16.000000', 'temperatura', 300.0000, 'ºC'),
	(48783, 112, '2015-02-01 00:26:17.000000', 'temperatura', 307.0000, 'ºC'),
	(48784, 112, '2015-02-01 00:26:18.000000', 'temperatura', 633.0000, 'ºC'),
	(48785, 112, '2015-02-01 00:26:19.000000', 'temperatura', 1045.0000, 'ºC'),
	(48786, 112, '2015-02-01 00:26:20.000000', 'temperatura', 925.0000, 'ºC'),
	(48787, 112, '2015-02-01 00:26:21.000000', 'temperatura', 291.0000, 'ºC'),
	(48788, 112, '2015-02-01 00:26:22.000000', 'temperatura', 1083.0000, 'ºC'),
	(48789, 112, '2015-02-01 00:26:23.000000', 'temperatura', 940.0000, 'ºC'),
	(48790, 112, '2015-02-01 00:26:24.000000', 'temperatura', 254.0000, 'ºC'),
	(48791, 112, '2015-02-01 00:26:25.000000', 'temperatura', 849.0000, 'ºC'),
	(48792, 112, '2015-02-01 00:26:26.000000', 'temperatura', 1084.0000, 'ºC'),
	(48793, 112, '2015-02-01 00:26:27.000000', 'temperatura', 472.0000, 'ºC'),
	(48794, 112, '2015-02-01 00:26:28.000000', 'temperatura', 311.0000, 'ºC'),
	(48795, 112, '2015-02-01 00:26:29.000000', 'temperatura', 139.0000, 'ºC'),
	(48796, 112, '2015-02-01 00:26:30.000000', 'temperatura', 961.0000, 'ºC'),
	(48797, 112, '2015-02-01 00:26:31.000000', 'temperatura', 788.0000, 'ºC'),
	(48798, 112, '2015-02-01 00:26:32.000000', 'temperatura', 1058.0000, 'ºC'),
	(48799, 112, '2015-02-01 00:26:33.000000', 'temperatura', 526.0000, 'ºC'),
	(48800, 112, '2015-02-01 00:26:34.000000', 'temperatura', 656.0000, 'ºC'),
	(48801, 112, '2015-02-01 00:26:35.000000', 'temperatura', 502.0000, 'ºC'),
	(48802, 112, '2015-02-01 00:26:36.000000', 'temperatura', 545.0000, 'ºC'),
	(48803, 112, '2015-02-01 00:26:37.000000', 'temperatura', 20.0000, 'ºC'),
	(48804, 112, '2015-02-01 00:26:38.000000', 'temperatura', 863.0000, 'ºC'),
	(48805, 112, '2015-02-01 00:26:39.000000', 'temperatura', 655.0000, 'ºC'),
	(48806, 112, '2015-02-01 00:26:40.000000', 'temperatura', 686.0000, 'ºC'),
	(48807, 112, '2015-02-01 00:26:41.000000', 'temperatura', 267.0000, 'ºC'),
	(48808, 112, '2015-02-01 00:26:42.000000', 'temperatura', 478.0000, 'ºC'),
	(48809, 112, '2015-02-01 00:26:43.000000', 'temperatura', 389.0000, 'ºC'),
	(48810, 112, '2015-02-01 00:26:44.000000', 'temperatura', 509.0000, 'ºC'),
	(48811, 112, '2015-02-01 00:26:45.000000', 'temperatura', 182.0000, 'ºC'),
	(48812, 112, '2015-02-01 00:26:46.000000', 'temperatura', 584.0000, 'ºC'),
	(48813, 112, '2015-02-01 00:26:47.000000', 'temperatura', 1172.0000, 'ºC'),
	(48814, 112, '2015-02-01 00:26:48.000000', 'temperatura', 511.0000, 'ºC'),
	(48815, 112, '2015-02-01 00:26:49.000000', 'temperatura', 236.0000, 'ºC'),
	(48816, 112, '2015-02-01 00:26:50.000000', 'temperatura', 850.0000, 'ºC'),
	(48817, 112, '2015-02-01 00:26:51.000000', 'temperatura', 1144.0000, 'ºC'),
	(48818, 112, '2015-02-01 00:26:52.000000', 'temperatura', 769.0000, 'ºC'),
	(48819, 112, '2015-02-01 00:26:53.000000', 'temperatura', 415.0000, 'ºC'),
	(48820, 112, '2015-02-01 00:26:54.000000', 'temperatura', 967.0000, 'ºC'),
	(48821, 112, '2015-02-01 00:26:55.000000', 'temperatura', 1189.0000, 'ºC'),
	(48822, 112, '2015-02-01 00:26:56.000000', 'temperatura', 648.0000, 'ºC'),
	(48823, 112, '2015-02-01 00:26:57.000000', 'temperatura', 871.0000, 'ºC'),
	(48824, 112, '2015-02-01 00:26:58.000000', 'temperatura', 10.0000, 'ºC'),
	(48825, 112, '2015-02-01 00:26:59.000000', 'temperatura', 1041.0000, 'ºC'),
	(48826, 112, '2015-02-01 00:27:00.000000', 'temperatura', 373.0000, 'ºC'),
	(48827, 112, '2015-02-01 00:27:01.000000', 'temperatura', 1145.0000, 'ºC'),
	(48828, 112, '2015-02-01 00:27:02.000000', 'temperatura', 1006.0000, 'ºC'),
	(48829, 112, '2015-02-01 00:27:03.000000', 'temperatura', 397.0000, 'ºC'),
	(48830, 112, '2015-02-01 00:27:04.000000', 'temperatura', 164.0000, 'ºC'),
	(48831, 112, '2015-02-01 00:27:05.000000', 'temperatura', 832.0000, 'ºC'),
	(48832, 112, '2015-02-01 00:27:06.000000', 'temperatura', 68.0000, 'ºC'),
	(48833, 112, '2015-02-01 00:27:07.000000', 'temperatura', 242.0000, 'ºC'),
	(48834, 112, '2015-02-01 00:27:08.000000', 'temperatura', 1010.0000, 'ºC'),
	(48835, 112, '2015-02-01 00:27:09.000000', 'temperatura', 724.0000, 'ºC'),
	(48836, 112, '2015-02-01 00:27:10.000000', 'temperatura', 590.0000, 'ºC'),
	(48837, 112, '2015-02-01 00:27:11.000000', 'temperatura', 777.0000, 'ºC'),
	(48838, 112, '2015-02-01 00:27:12.000000', 'temperatura', 917.0000, 'ºC'),
	(48839, 112, '2015-02-01 00:27:13.000000', 'temperatura', 1055.0000, 'ºC'),
	(48840, 112, '2015-02-01 00:27:14.000000', 'temperatura', 124.0000, 'ºC'),
	(48841, 112, '2015-02-01 00:27:15.000000', 'temperatura', 1057.0000, 'ºC'),
	(48842, 112, '2015-02-01 00:27:16.000000', 'temperatura', 113.0000, 'ºC'),
	(48843, 112, '2015-02-01 00:27:17.000000', 'temperatura', 993.0000, 'ºC'),
	(48844, 112, '2015-02-01 00:27:18.000000', 'temperatura', 1026.0000, 'ºC'),
	(48845, 112, '2015-02-01 00:27:19.000000', 'temperatura', 953.0000, 'ºC'),
	(48846, 112, '2015-02-01 00:27:20.000000', 'temperatura', 489.0000, 'ºC'),
	(48847, 112, '2015-02-01 00:27:21.000000', 'temperatura', 785.0000, 'ºC'),
	(48848, 112, '2015-02-01 00:27:22.000000', 'temperatura', 58.0000, 'ºC'),
	(48849, 112, '2015-02-01 00:27:23.000000', 'temperatura', 338.0000, 'ºC'),
	(48850, 112, '2015-02-01 00:27:24.000000', 'temperatura', 314.0000, 'ºC'),
	(48851, 112, '2015-02-01 00:27:25.000000', 'temperatura', 555.0000, 'ºC'),
	(48852, 112, '2015-02-01 00:27:26.000000', 'temperatura', 637.0000, 'ºC'),
	(48853, 112, '2015-02-01 00:27:27.000000', 'temperatura', 319.0000, 'ºC'),
	(48854, 112, '2015-02-01 00:27:28.000000', 'temperatura', 883.0000, 'ºC'),
	(48855, 112, '2015-02-01 00:27:29.000000', 'temperatura', 1058.0000, 'ºC'),
	(48856, 112, '2015-02-01 00:27:30.000000', 'temperatura', 243.0000, 'ºC'),
	(48857, 112, '2015-02-01 00:27:31.000000', 'temperatura', 443.0000, 'ºC'),
	(48858, 112, '2015-02-01 00:27:32.000000', 'temperatura', 284.0000, 'ºC'),
	(48859, 112, '2015-02-01 00:27:33.000000', 'temperatura', 93.0000, 'ºC'),
	(48860, 112, '2015-02-01 00:27:34.000000', 'temperatura', 811.0000, 'ºC'),
	(48861, 112, '2015-02-01 00:27:35.000000', 'temperatura', 178.0000, 'ºC'),
	(48862, 112, '2015-02-01 00:27:36.000000', 'temperatura', 859.0000, 'ºC'),
	(48863, 112, '2015-02-01 00:27:37.000000', 'temperatura', 162.0000, 'ºC'),
	(48864, 112, '2015-02-01 00:27:38.000000', 'temperatura', 633.0000, 'ºC'),
	(48865, 112, '2015-02-01 00:27:39.000000', 'temperatura', 278.0000, 'ºC'),
	(48866, 112, '2015-02-01 00:27:40.000000', 'temperatura', 692.0000, 'ºC'),
	(48867, 112, '2015-02-01 00:27:41.000000', 'temperatura', 227.0000, 'ºC'),
	(48868, 112, '2015-02-01 00:27:42.000000', 'temperatura', 257.0000, 'ºC'),
	(48869, 112, '2015-02-01 00:27:43.000000', 'temperatura', 608.0000, 'ºC'),
	(48870, 112, '2015-02-01 00:27:44.000000', 'temperatura', 1068.0000, 'ºC'),
	(48871, 112, '2015-02-01 00:27:45.000000', 'temperatura', 1118.0000, 'ºC'),
	(48872, 112, '2015-02-01 00:27:46.000000', 'temperatura', 1188.0000, 'ºC'),
	(48873, 112, '2015-02-01 00:27:47.000000', 'temperatura', 183.0000, 'ºC'),
	(48874, 112, '2015-02-01 00:27:48.000000', 'temperatura', 953.0000, 'ºC'),
	(48875, 112, '2015-02-01 00:27:49.000000', 'temperatura', 617.0000, 'ºC'),
	(48876, 112, '2015-02-01 00:27:50.000000', 'temperatura', 225.0000, 'ºC'),
	(48877, 112, '2015-02-01 00:27:51.000000', 'temperatura', 476.0000, 'ºC'),
	(48878, 112, '2015-02-01 00:27:52.000000', 'temperatura', 503.0000, 'ºC'),
	(48879, 112, '2015-02-01 00:27:53.000000', 'temperatura', 1090.0000, 'ºC'),
	(48880, 112, '2015-02-01 00:27:54.000000', 'temperatura', 342.0000, 'ºC'),
	(48881, 112, '2015-02-01 00:27:55.000000', 'temperatura', 840.0000, 'ºC'),
	(48882, 112, '2015-02-01 00:27:56.000000', 'temperatura', 775.0000, 'ºC'),
	(48883, 112, '2015-02-01 00:27:57.000000', 'temperatura', 155.0000, 'ºC'),
	(48884, 112, '2015-02-01 00:27:58.000000', 'temperatura', 851.0000, 'ºC'),
	(48885, 112, '2015-02-01 00:27:59.000000', 'temperatura', 189.0000, 'ºC'),
	(48886, 112, '2015-02-01 00:28:00.000000', 'temperatura', 793.0000, 'ºC'),
	(48887, 112, '2015-02-01 00:28:01.000000', 'temperatura', 997.0000, 'ºC'),
	(48888, 112, '2015-02-01 00:28:02.000000', 'temperatura', 207.0000, 'ºC'),
	(48889, 112, '2015-02-01 00:28:03.000000', 'temperatura', 445.0000, 'ºC'),
	(48890, 112, '2015-02-01 00:28:04.000000', 'temperatura', 407.0000, 'ºC'),
	(48891, 112, '2015-02-01 00:28:05.000000', 'temperatura', 697.0000, 'ºC'),
	(48892, 112, '2015-02-01 00:28:06.000000', 'temperatura', 1066.0000, 'ºC'),
	(48893, 112, '2015-02-01 00:28:07.000000', 'temperatura', 840.0000, 'ºC'),
	(48894, 112, '2015-02-01 00:28:08.000000', 'temperatura', 1003.0000, 'ºC'),
	(48895, 112, '2015-02-01 00:28:09.000000', 'temperatura', 93.0000, 'ºC'),
	(48896, 112, '2015-02-01 00:28:10.000000', 'temperatura', 1059.0000, 'ºC'),
	(48897, 112, '2015-02-01 00:28:11.000000', 'temperatura', 215.0000, 'ºC'),
	(48898, 112, '2015-02-01 00:28:12.000000', 'temperatura', 299.0000, 'ºC'),
	(48899, 112, '2015-02-01 00:28:13.000000', 'temperatura', 849.0000, 'ºC'),
	(48900, 112, '2015-02-01 00:28:14.000000', 'temperatura', 951.0000, 'ºC'),
	(48901, 112, '2015-02-01 00:28:15.000000', 'temperatura', 1006.0000, 'ºC'),
	(48902, 112, '2015-02-01 00:28:16.000000', 'temperatura', 979.0000, 'ºC'),
	(48903, 112, '2015-02-01 00:28:17.000000', 'temperatura', 675.0000, 'ºC'),
	(48904, 112, '2015-02-01 00:28:18.000000', 'temperatura', 441.0000, 'ºC'),
	(48905, 112, '2015-02-01 00:28:19.000000', 'temperatura', 179.0000, 'ºC'),
	(48906, 112, '2015-02-01 00:28:20.000000', 'temperatura', 773.0000, 'ºC'),
	(48907, 112, '2015-02-01 00:28:21.000000', 'temperatura', 929.0000, 'ºC'),
	(48908, 112, '2015-02-01 00:28:22.000000', 'temperatura', 1127.0000, 'ºC'),
	(48909, 112, '2015-02-01 00:28:23.000000', 'temperatura', 449.0000, 'ºC'),
	(48910, 112, '2015-02-01 00:28:24.000000', 'temperatura', 62.0000, 'ºC'),
	(48911, 112, '2015-02-01 00:28:25.000000', 'temperatura', 166.0000, 'ºC'),
	(48912, 112, '2015-02-01 00:28:26.000000', 'temperatura', 645.0000, 'ºC'),
	(48913, 112, '2015-02-01 00:28:27.000000', 'temperatura', 326.0000, 'ºC'),
	(48914, 112, '2015-02-01 00:28:28.000000', 'temperatura', 895.0000, 'ºC'),
	(48915, 112, '2015-02-01 00:28:29.000000', 'temperatura', 1099.0000, 'ºC'),
	(48916, 112, '2015-02-01 00:28:30.000000', 'temperatura', 409.0000, 'ºC'),
	(48917, 112, '2015-02-01 00:28:31.000000', 'temperatura', 1149.0000, 'ºC'),
	(48918, 112, '2015-02-01 00:28:32.000000', 'temperatura', 920.0000, 'ºC'),
	(48919, 112, '2015-02-01 00:28:33.000000', 'temperatura', 1154.0000, 'ºC'),
	(48920, 112, '2015-02-01 00:28:34.000000', 'temperatura', 608.0000, 'ºC'),
	(48921, 112, '2015-02-01 00:28:35.000000', 'temperatura', 781.0000, 'ºC'),
	(48922, 112, '2015-02-01 00:28:36.000000', 'temperatura', 880.0000, 'ºC'),
	(48923, 112, '2015-02-01 00:28:37.000000', 'temperatura', 858.0000, 'ºC'),
	(48924, 112, '2015-02-01 00:28:38.000000', 'temperatura', 450.0000, 'ºC'),
	(48925, 112, '2015-02-01 00:28:39.000000', 'temperatura', 876.0000, 'ºC'),
	(48926, 112, '2015-02-01 00:28:40.000000', 'temperatura', 633.0000, 'ºC'),
	(48927, 112, '2015-02-01 00:28:41.000000', 'temperatura', 535.0000, 'ºC'),
	(48928, 112, '2015-02-01 00:28:42.000000', 'temperatura', 775.0000, 'ºC'),
	(48929, 112, '2015-02-01 00:28:43.000000', 'temperatura', 1074.0000, 'ºC'),
	(48930, 112, '2015-02-01 00:28:44.000000', 'temperatura', 645.0000, 'ºC'),
	(48931, 112, '2015-02-01 00:28:45.000000', 'temperatura', 2.0000, 'ºC'),
	(48932, 112, '2015-02-01 00:28:46.000000', 'temperatura', 475.0000, 'ºC'),
	(48933, 112, '2015-02-01 00:28:47.000000', 'temperatura', 1169.0000, 'ºC'),
	(48934, 112, '2015-02-01 00:28:48.000000', 'temperatura', 821.0000, 'ºC'),
	(48935, 112, '2015-02-01 00:28:49.000000', 'temperatura', 598.0000, 'ºC'),
	(48936, 112, '2015-02-01 00:28:50.000000', 'temperatura', 526.0000, 'ºC'),
	(48937, 112, '2015-02-01 00:28:51.000000', 'temperatura', 838.0000, 'ºC'),
	(48938, 112, '2015-02-01 00:28:52.000000', 'temperatura', 211.0000, 'ºC'),
	(48939, 112, '2015-02-01 00:28:53.000000', 'temperatura', 944.0000, 'ºC'),
	(48940, 112, '2015-02-01 00:28:54.000000', 'temperatura', 485.0000, 'ºC'),
	(48941, 112, '2015-02-01 00:28:55.000000', 'temperatura', 794.0000, 'ºC'),
	(48942, 112, '2015-02-01 00:28:56.000000', 'temperatura', 116.0000, 'ºC'),
	(48943, 112, '2015-02-01 00:28:57.000000', 'temperatura', 599.0000, 'ºC'),
	(48944, 112, '2015-02-01 00:28:58.000000', 'temperatura', 247.0000, 'ºC'),
	(48945, 112, '2015-02-01 00:28:59.000000', 'temperatura', 638.0000, 'ºC'),
	(48946, 112, '2015-02-01 00:29:00.000000', 'temperatura', 49.0000, 'ºC'),
	(48947, 112, '2015-02-01 00:29:01.000000', 'temperatura', 731.0000, 'ºC'),
	(48948, 112, '2015-02-01 00:29:02.000000', 'temperatura', 1108.0000, 'ºC'),
	(48949, 112, '2015-02-01 00:29:03.000000', 'temperatura', 949.0000, 'ºC'),
	(48950, 112, '2015-02-01 00:29:04.000000', 'temperatura', 223.0000, 'ºC'),
	(48951, 112, '2015-02-01 00:29:05.000000', 'temperatura', 666.0000, 'ºC'),
	(48952, 112, '2015-02-01 00:29:06.000000', 'temperatura', 262.0000, 'ºC'),
	(48953, 112, '2015-02-01 00:29:07.000000', 'temperatura', 512.0000, 'ºC'),
	(48954, 112, '2015-02-01 00:29:08.000000', 'temperatura', 574.0000, 'ºC'),
	(48955, 112, '2015-02-01 00:29:09.000000', 'temperatura', 136.0000, 'ºC'),
	(48956, 112, '2015-02-01 00:29:10.000000', 'temperatura', 158.0000, 'ºC'),
	(48957, 112, '2015-02-01 00:29:11.000000', 'temperatura', 381.0000, 'ºC'),
	(48958, 112, '2015-02-01 00:29:12.000000', 'temperatura', 231.0000, 'ºC'),
	(48959, 112, '2015-02-01 00:29:13.000000', 'temperatura', 13.0000, 'ºC'),
	(48960, 112, '2015-02-01 00:29:14.000000', 'temperatura', 574.0000, 'ºC'),
	(48961, 112, '2015-02-01 00:29:15.000000', 'temperatura', 430.0000, 'ºC'),
	(48962, 112, '2015-02-01 00:29:16.000000', 'temperatura', 431.0000, 'ºC'),
	(48963, 112, '2015-02-01 00:29:17.000000', 'temperatura', 864.0000, 'ºC'),
	(48964, 112, '2015-02-01 00:29:18.000000', 'temperatura', 627.0000, 'ºC'),
	(48965, 112, '2015-02-01 00:29:19.000000', 'temperatura', 543.0000, 'ºC'),
	(48966, 112, '2015-02-01 00:29:20.000000', 'temperatura', 835.0000, 'ºC'),
	(48967, 112, '2015-02-01 00:29:21.000000', 'temperatura', 148.0000, 'ºC'),
	(48968, 112, '2015-02-01 00:29:22.000000', 'temperatura', 634.0000, 'ºC'),
	(48969, 112, '2015-02-01 00:29:23.000000', 'temperatura', 326.0000, 'ºC'),
	(48970, 112, '2015-02-01 00:29:24.000000', 'temperatura', 929.0000, 'ºC'),
	(48971, 112, '2015-02-01 00:29:25.000000', 'temperatura', 66.0000, 'ºC'),
	(48972, 112, '2015-02-01 00:29:26.000000', 'temperatura', 1143.0000, 'ºC'),
	(48973, 112, '2015-02-01 00:29:27.000000', 'temperatura', 719.0000, 'ºC'),
	(48974, 112, '2015-02-01 00:29:28.000000', 'temperatura', 166.0000, 'ºC'),
	(48975, 112, '2015-02-01 00:29:29.000000', 'temperatura', 1075.0000, 'ºC'),
	(48976, 112, '2015-02-01 00:29:30.000000', 'temperatura', 75.0000, 'ºC'),
	(48977, 112, '2015-02-01 00:29:31.000000', 'temperatura', 749.0000, 'ºC'),
	(48978, 112, '2015-02-01 00:29:32.000000', 'temperatura', 1124.0000, 'ºC'),
	(48979, 112, '2015-02-01 00:29:33.000000', 'temperatura', 974.0000, 'ºC'),
	(48980, 112, '2015-02-01 00:29:34.000000', 'temperatura', 296.0000, 'ºC'),
	(48981, 112, '2015-02-01 00:29:35.000000', 'temperatura', 957.0000, 'ºC'),
	(48982, 112, '2015-02-01 00:29:36.000000', 'temperatura', 300.0000, 'ºC'),
	(48983, 112, '2015-02-01 00:29:37.000000', 'temperatura', 1031.0000, 'ºC'),
	(48984, 112, '2015-02-01 00:29:38.000000', 'temperatura', 653.0000, 'ºC'),
	(48985, 112, '2015-02-01 00:29:39.000000', 'temperatura', 173.0000, 'ºC'),
	(48986, 112, '2015-02-01 00:29:40.000000', 'temperatura', 108.0000, 'ºC'),
	(48987, 112, '2015-02-01 00:29:41.000000', 'temperatura', 20.0000, 'ºC'),
	(48988, 112, '2015-02-01 00:29:42.000000', 'temperatura', 977.0000, 'ºC'),
	(48989, 112, '2015-02-01 00:29:43.000000', 'temperatura', 24.0000, 'ºC'),
	(48990, 112, '2015-02-01 00:29:44.000000', 'temperatura', 789.0000, 'ºC'),
	(48991, 112, '2015-02-01 00:29:45.000000', 'temperatura', 274.0000, 'ºC'),
	(48992, 112, '2015-02-01 00:29:46.000000', 'temperatura', 203.0000, 'ºC'),
	(48993, 112, '2015-02-01 00:29:47.000000', 'temperatura', 193.0000, 'ºC'),
	(48994, 112, '2015-02-01 00:29:48.000000', 'temperatura', 357.0000, 'ºC'),
	(48995, 112, '2015-02-01 00:29:49.000000', 'temperatura', 7.0000, 'ºC'),
	(48996, 112, '2015-02-01 00:29:50.000000', 'temperatura', 165.0000, 'ºC'),
	(48997, 112, '2015-02-01 00:29:51.000000', 'temperatura', 803.0000, 'ºC'),
	(48998, 112, '2015-02-01 00:29:52.000000', 'temperatura', 1122.0000, 'ºC'),
	(48999, 112, '2015-02-01 00:29:53.000000', 'temperatura', 799.0000, 'ºC'),
	(49000, 112, '2015-02-01 00:29:54.000000', 'temperatura', 632.0000, 'ºC'),
	(49001, 112, '2015-02-01 00:29:55.000000', 'temperatura', 763.0000, 'ºC'),
	(49002, 112, '2015-02-01 00:29:56.000000', 'temperatura', 719.0000, 'ºC'),
	(49003, 112, '2015-02-01 00:29:57.000000', 'temperatura', 108.0000, 'ºC'),
	(49004, 112, '2015-02-01 00:29:58.000000', 'temperatura', 781.0000, 'ºC'),
	(49005, 112, '2015-02-01 00:29:59.000000', 'temperatura', 1181.0000, 'ºC'),
	(49006, 112, '2015-02-01 00:30:00.000000', 'temperatura', 1165.0000, 'ºC'),
	(49007, 112, '2015-02-01 00:30:01.000000', 'temperatura', 1080.0000, 'ºC'),
	(49008, 112, '2015-02-01 00:30:02.000000', 'temperatura', 708.0000, 'ºC'),
	(49009, 112, '2015-02-01 00:30:03.000000', 'temperatura', 297.0000, 'ºC'),
	(49010, 112, '2015-02-01 00:30:04.000000', 'temperatura', 565.0000, 'ºC'),
	(49011, 112, '2015-02-01 00:30:05.000000', 'temperatura', 733.0000, 'ºC'),
	(49012, 112, '2015-02-01 00:30:06.000000', 'temperatura', 772.0000, 'ºC'),
	(49013, 112, '2015-02-01 00:30:07.000000', 'temperatura', 462.0000, 'ºC'),
	(49014, 112, '2015-02-01 00:30:08.000000', 'temperatura', 1192.0000, 'ºC'),
	(49015, 112, '2015-02-01 00:30:09.000000', 'temperatura', 974.0000, 'ºC'),
	(49016, 112, '2015-02-01 00:30:10.000000', 'temperatura', 96.0000, 'ºC'),
	(49017, 112, '2015-02-01 00:30:11.000000', 'temperatura', 1160.0000, 'ºC'),
	(49018, 112, '2015-02-01 00:30:12.000000', 'temperatura', 712.0000, 'ºC'),
	(49019, 112, '2015-02-01 00:30:13.000000', 'temperatura', 82.0000, 'ºC'),
	(49020, 112, '2015-02-01 00:30:14.000000', 'temperatura', 671.0000, 'ºC'),
	(49021, 112, '2015-02-01 00:30:15.000000', 'temperatura', 711.0000, 'ºC'),
	(49022, 112, '2015-02-01 00:30:16.000000', 'temperatura', 342.0000, 'ºC'),
	(49023, 112, '2015-02-01 00:30:17.000000', 'temperatura', 778.0000, 'ºC'),
	(49024, 112, '2015-02-01 00:30:18.000000', 'temperatura', 465.0000, 'ºC'),
	(49025, 112, '2015-02-01 00:30:19.000000', 'temperatura', 1190.0000, 'ºC'),
	(49026, 112, '2015-02-01 00:30:20.000000', 'temperatura', 958.0000, 'ºC'),
	(49027, 112, '2015-02-01 00:30:21.000000', 'temperatura', 18.0000, 'ºC'),
	(49028, 112, '2015-02-01 00:30:22.000000', 'temperatura', 819.0000, 'ºC'),
	(49029, 112, '2015-02-01 00:30:23.000000', 'temperatura', 440.0000, 'ºC'),
	(49030, 112, '2015-02-01 00:30:24.000000', 'temperatura', 945.0000, 'ºC'),
	(49031, 112, '2015-02-01 00:30:25.000000', 'temperatura', 1006.0000, 'ºC'),
	(49032, 112, '2015-02-01 00:30:26.000000', 'temperatura', 995.0000, 'ºC'),
	(49033, 112, '2015-02-01 00:30:27.000000', 'temperatura', 757.0000, 'ºC'),
	(49034, 112, '2015-02-01 00:30:28.000000', 'temperatura', 802.0000, 'ºC'),
	(49035, 112, '2015-02-01 00:30:29.000000', 'temperatura', 538.0000, 'ºC'),
	(49036, 112, '2015-02-01 00:30:30.000000', 'temperatura', 287.0000, 'ºC'),
	(49037, 112, '2015-02-01 00:30:31.000000', 'temperatura', 1020.0000, 'ºC'),
	(49038, 112, '2015-02-01 00:30:32.000000', 'temperatura', 640.0000, 'ºC'),
	(49039, 112, '2015-02-01 00:30:33.000000', 'temperatura', 139.0000, 'ºC'),
	(49040, 112, '2015-02-01 00:30:34.000000', 'temperatura', 1176.0000, 'ºC'),
	(49041, 112, '2015-02-01 00:30:35.000000', 'temperatura', 663.0000, 'ºC'),
	(49042, 112, '2015-02-01 00:30:36.000000', 'temperatura', 988.0000, 'ºC'),
	(49043, 112, '2015-02-01 00:30:37.000000', 'temperatura', 551.0000, 'ºC'),
	(49044, 112, '2015-02-01 00:30:38.000000', 'temperatura', 991.0000, 'ºC'),
	(49045, 112, '2015-02-01 00:30:39.000000', 'temperatura', 903.0000, 'ºC'),
	(49046, 112, '2015-02-01 00:30:40.000000', 'temperatura', 344.0000, 'ºC'),
	(49047, 112, '2015-02-01 00:30:41.000000', 'temperatura', 209.0000, 'ºC'),
	(49048, 112, '2015-02-01 00:30:42.000000', 'temperatura', 13.0000, 'ºC'),
	(49049, 112, '2015-02-01 00:30:43.000000', 'temperatura', 641.0000, 'ºC'),
	(49050, 112, '2015-02-01 00:30:44.000000', 'temperatura', 764.0000, 'ºC'),
	(49051, 112, '2015-02-01 00:30:45.000000', 'temperatura', 698.0000, 'ºC'),
	(49052, 112, '2015-02-01 00:30:46.000000', 'temperatura', 1197.0000, 'ºC'),
	(49053, 112, '2015-02-01 00:30:47.000000', 'temperatura', 294.0000, 'ºC'),
	(49054, 112, '2015-02-01 00:30:48.000000', 'temperatura', 279.0000, 'ºC'),
	(49055, 112, '2015-02-01 00:30:49.000000', 'temperatura', 512.0000, 'ºC'),
	(49056, 112, '2015-02-01 00:30:50.000000', 'temperatura', 525.0000, 'ºC'),
	(49057, 112, '2015-02-01 00:30:51.000000', 'temperatura', 1091.0000, 'ºC'),
	(49058, 112, '2015-02-01 00:30:52.000000', 'temperatura', 280.0000, 'ºC'),
	(49059, 112, '2015-02-01 00:30:53.000000', 'temperatura', 526.0000, 'ºC'),
	(49060, 112, '2015-02-01 00:30:54.000000', 'temperatura', 593.0000, 'ºC'),
	(49061, 112, '2015-02-01 00:30:55.000000', 'temperatura', 187.0000, 'ºC'),
	(49062, 112, '2015-02-01 00:30:56.000000', 'temperatura', 354.0000, 'ºC'),
	(49063, 112, '2015-02-01 00:30:57.000000', 'temperatura', 11.0000, 'ºC'),
	(49064, 112, '2015-02-01 00:30:58.000000', 'temperatura', 192.0000, 'ºC'),
	(49065, 112, '2015-02-01 00:30:59.000000', 'temperatura', 927.0000, 'ºC'),
	(49066, 112, '2015-02-01 00:31:00.000000', 'temperatura', 459.0000, 'ºC'),
	(49067, 112, '2015-02-01 00:31:01.000000', 'temperatura', 716.0000, 'ºC'),
	(49068, 112, '2015-02-01 00:31:02.000000', 'temperatura', 1001.0000, 'ºC'),
	(49069, 112, '2015-02-01 00:31:03.000000', 'temperatura', 460.0000, 'ºC'),
	(49070, 112, '2015-02-01 00:31:04.000000', 'temperatura', 496.0000, 'ºC'),
	(49071, 112, '2015-02-01 00:31:05.000000', 'temperatura', 1102.0000, 'ºC'),
	(49072, 112, '2015-02-01 00:31:06.000000', 'temperatura', 423.0000, 'ºC'),
	(49073, 112, '2015-02-01 00:31:07.000000', 'temperatura', 10.0000, 'ºC'),
	(49074, 112, '2015-02-01 00:31:08.000000', 'temperatura', 1181.0000, 'ºC'),
	(49075, 112, '2015-02-01 00:31:09.000000', 'temperatura', 1077.0000, 'ºC'),
	(49076, 112, '2015-02-01 00:31:10.000000', 'temperatura', 641.0000, 'ºC'),
	(49077, 112, '2015-02-01 00:31:11.000000', 'temperatura', 1177.0000, 'ºC'),
	(49078, 112, '2015-02-01 00:31:12.000000', 'temperatura', 360.0000, 'ºC'),
	(49079, 112, '2015-02-01 00:31:13.000000', 'temperatura', 668.0000, 'ºC'),
	(49080, 112, '2015-02-01 00:31:14.000000', 'temperatura', 1062.0000, 'ºC'),
	(49081, 112, '2015-02-01 00:31:15.000000', 'temperatura', 906.0000, 'ºC'),
	(49082, 112, '2015-02-01 00:31:16.000000', 'temperatura', 147.0000, 'ºC'),
	(49083, 112, '2015-02-01 00:31:17.000000', 'temperatura', 414.0000, 'ºC'),
	(49084, 112, '2015-02-01 00:31:18.000000', 'temperatura', 431.0000, 'ºC'),
	(49085, 112, '2015-02-01 00:31:19.000000', 'temperatura', 915.0000, 'ºC'),
	(49086, 112, '2015-02-01 00:31:20.000000', 'temperatura', 882.0000, 'ºC'),
	(49087, 112, '2015-02-01 00:31:21.000000', 'temperatura', 466.0000, 'ºC'),
	(49088, 112, '2015-02-01 00:31:22.000000', 'temperatura', 883.0000, 'ºC'),
	(49089, 112, '2015-02-01 00:31:23.000000', 'temperatura', 620.0000, 'ºC'),
	(49090, 112, '2015-02-01 00:31:24.000000', 'temperatura', 450.0000, 'ºC'),
	(49091, 112, '2015-02-01 00:31:25.000000', 'temperatura', 389.0000, 'ºC'),
	(49092, 112, '2015-02-01 00:31:26.000000', 'temperatura', 595.0000, 'ºC'),
	(49093, 112, '2015-02-01 00:31:27.000000', 'temperatura', 609.0000, 'ºC'),
	(49094, 112, '2015-02-01 00:31:28.000000', 'temperatura', 63.0000, 'ºC'),
	(49095, 112, '2015-02-01 00:31:29.000000', 'temperatura', 887.0000, 'ºC'),
	(49096, 112, '2015-02-01 00:31:30.000000', 'temperatura', 646.0000, 'ºC'),
	(49097, 112, '2015-02-01 00:31:31.000000', 'temperatura', 569.0000, 'ºC'),
	(49098, 112, '2015-02-01 00:31:32.000000', 'temperatura', 910.0000, 'ºC'),
	(49099, 112, '2015-02-01 00:31:33.000000', 'temperatura', 440.0000, 'ºC'),
	(49100, 112, '2015-02-01 00:31:34.000000', 'temperatura', 673.0000, 'ºC'),
	(49101, 112, '2015-02-01 00:31:35.000000', 'temperatura', 844.0000, 'ºC'),
	(49102, 112, '2015-02-01 00:31:36.000000', 'temperatura', 1004.0000, 'ºC'),
	(49103, 112, '2015-02-01 00:31:37.000000', 'temperatura', 87.0000, 'ºC'),
	(49104, 112, '2015-02-01 00:31:38.000000', 'temperatura', 1024.0000, 'ºC'),
	(49105, 112, '2015-02-01 00:31:39.000000', 'temperatura', 59.0000, 'ºC'),
	(49106, 112, '2015-02-01 00:31:40.000000', 'temperatura', 825.0000, 'ºC'),
	(49107, 112, '2015-02-01 00:31:41.000000', 'temperatura', 347.0000, 'ºC'),
	(49108, 112, '2015-02-01 00:31:42.000000', 'temperatura', 459.0000, 'ºC'),
	(49109, 112, '2015-02-01 00:31:43.000000', 'temperatura', 57.0000, 'ºC'),
	(49110, 112, '2015-02-01 00:31:44.000000', 'temperatura', 108.0000, 'ºC'),
	(49111, 112, '2015-02-01 00:31:45.000000', 'temperatura', 371.0000, 'ºC'),
	(49112, 112, '2015-02-01 00:31:46.000000', 'temperatura', 330.0000, 'ºC'),
	(49113, 112, '2015-02-01 00:31:47.000000', 'temperatura', 539.0000, 'ºC'),
	(49114, 112, '2015-02-01 00:31:48.000000', 'temperatura', 503.0000, 'ºC'),
	(49115, 112, '2015-02-01 00:31:49.000000', 'temperatura', 902.0000, 'ºC'),
	(49116, 112, '2015-02-01 00:31:50.000000', 'temperatura', 598.0000, 'ºC'),
	(49117, 112, '2015-02-01 00:31:51.000000', 'temperatura', 288.0000, 'ºC'),
	(49118, 112, '2015-02-01 00:31:52.000000', 'temperatura', 844.0000, 'ºC'),
	(49119, 112, '2015-02-01 00:31:53.000000', 'temperatura', 956.0000, 'ºC'),
	(49120, 112, '2015-02-01 00:31:54.000000', 'temperatura', 1050.0000, 'ºC'),
	(49121, 112, '2015-02-01 00:31:55.000000', 'temperatura', 1183.0000, 'ºC'),
	(49122, 112, '2015-02-01 00:31:56.000000', 'temperatura', 367.0000, 'ºC'),
	(49123, 112, '2015-02-01 00:31:57.000000', 'temperatura', 685.0000, 'ºC'),
	(49124, 112, '2015-02-01 00:31:58.000000', 'temperatura', 1123.0000, 'ºC'),
	(49125, 112, '2015-02-01 00:31:59.000000', 'temperatura', 1160.0000, 'ºC'),
	(49126, 112, '2015-02-01 00:32:00.000000', 'temperatura', 35.0000, 'ºC'),
	(49127, 112, '2015-02-01 00:32:01.000000', 'temperatura', 292.0000, 'ºC'),
	(49128, 112, '2015-02-01 00:32:02.000000', 'temperatura', 157.0000, 'ºC'),
	(49129, 112, '2015-02-01 00:32:03.000000', 'temperatura', 1111.0000, 'ºC'),
	(49130, 112, '2015-02-01 00:32:04.000000', 'temperatura', 285.0000, 'ºC'),
	(49131, 112, '2015-02-01 00:32:05.000000', 'temperatura', 493.0000, 'ºC'),
	(49132, 112, '2015-02-01 00:32:06.000000', 'temperatura', 409.0000, 'ºC'),
	(49133, 112, '2015-02-01 00:32:07.000000', 'temperatura', 566.0000, 'ºC'),
	(49134, 112, '2015-02-01 00:32:08.000000', 'temperatura', 403.0000, 'ºC'),
	(49135, 112, '2015-02-01 00:32:09.000000', 'temperatura', 319.0000, 'ºC'),
	(49136, 112, '2015-02-01 00:32:10.000000', 'temperatura', 385.0000, 'ºC'),
	(49137, 112, '2015-02-01 00:32:11.000000', 'temperatura', 970.0000, 'ºC'),
	(49138, 112, '2015-02-01 00:32:12.000000', 'temperatura', 93.0000, 'ºC'),
	(49139, 112, '2015-02-01 00:32:13.000000', 'temperatura', 1159.0000, 'ºC'),
	(49140, 112, '2015-02-01 00:32:14.000000', 'temperatura', 714.0000, 'ºC'),
	(49141, 112, '2015-02-01 00:32:15.000000', 'temperatura', 93.0000, 'ºC'),
	(49142, 112, '2015-02-01 00:32:16.000000', 'temperatura', 724.0000, 'ºC'),
	(49143, 112, '2015-02-01 00:32:17.000000', 'temperatura', 941.0000, 'ºC'),
	(49144, 112, '2015-02-01 00:32:18.000000', 'temperatura', 133.0000, 'ºC'),
	(49145, 112, '2015-02-01 00:32:19.000000', 'temperatura', 244.0000, 'ºC'),
	(49146, 112, '2015-02-01 00:32:20.000000', 'temperatura', 820.0000, 'ºC'),
	(49147, 112, '2015-02-01 00:32:21.000000', 'temperatura', 968.0000, 'ºC'),
	(49148, 112, '2015-02-01 00:32:22.000000', 'temperatura', 1180.0000, 'ºC'),
	(49149, 112, '2015-02-01 00:32:23.000000', 'temperatura', 597.0000, 'ºC'),
	(49150, 112, '2015-02-01 00:32:24.000000', 'temperatura', 648.0000, 'ºC'),
	(49151, 112, '2015-02-01 00:32:25.000000', 'temperatura', 247.0000, 'ºC'),
	(49152, 112, '2015-02-01 00:32:26.000000', 'temperatura', 494.0000, 'ºC'),
	(49153, 112, '2015-02-01 00:32:27.000000', 'temperatura', 527.0000, 'ºC'),
	(49154, 112, '2015-02-01 00:32:28.000000', 'temperatura', 1152.0000, 'ºC'),
	(49155, 112, '2015-02-01 00:32:29.000000', 'temperatura', 582.0000, 'ºC'),
	(49156, 112, '2015-02-01 00:32:30.000000', 'temperatura', 655.0000, 'ºC'),
	(49157, 112, '2015-02-01 00:32:31.000000', 'temperatura', 327.0000, 'ºC'),
	(49158, 112, '2015-02-01 00:32:32.000000', 'temperatura', 873.0000, 'ºC'),
	(49159, 112, '2015-02-01 00:32:33.000000', 'temperatura', 985.0000, 'ºC'),
	(49160, 112, '2015-02-01 00:32:34.000000', 'temperatura', 1104.0000, 'ºC'),
	(49161, 112, '2015-02-01 00:32:35.000000', 'temperatura', 165.0000, 'ºC'),
	(49162, 112, '2015-02-01 00:32:36.000000', 'temperatura', 1114.0000, 'ºC'),
	(49163, 112, '2015-02-01 00:32:37.000000', 'temperatura', 275.0000, 'ºC'),
	(49164, 112, '2015-02-01 00:32:38.000000', 'temperatura', 433.0000, 'ºC'),
	(49165, 112, '2015-02-01 00:32:39.000000', 'temperatura', 140.0000, 'ºC'),
	(49166, 112, '2015-02-01 00:32:40.000000', 'temperatura', 603.0000, 'ºC'),
	(49167, 112, '2015-02-01 00:32:41.000000', 'temperatura', 195.0000, 'ºC'),
	(49168, 112, '2015-02-01 00:32:42.000000', 'temperatura', 365.0000, 'ºC'),
	(49169, 112, '2015-02-01 00:32:43.000000', 'temperatura', 44.0000, 'ºC'),
	(49170, 112, '2015-02-01 00:32:44.000000', 'temperatura', 322.0000, 'ºC'),
	(49171, 112, '2015-02-01 00:32:45.000000', 'temperatura', 281.0000, 'ºC'),
	(49172, 112, '2015-02-01 00:32:46.000000', 'temperatura', 438.0000, 'ºC'),
	(49173, 112, '2015-02-01 00:32:47.000000', 'temperatura', 150.0000, 'ºC'),
	(49174, 112, '2015-02-01 00:32:48.000000', 'temperatura', 635.0000, 'ºC'),
	(49175, 112, '2015-02-01 00:32:49.000000', 'temperatura', 327.0000, 'ºC'),
	(49176, 112, '2015-02-01 00:32:50.000000', 'temperatura', 929.0000, 'ºC'),
	(49177, 112, '2015-02-01 00:32:51.000000', 'temperatura', 65.0000, 'ºC'),
	(49178, 112, '2015-02-01 00:32:52.000000', 'temperatura', 1139.0000, 'ºC'),
	(49179, 112, '2015-02-01 00:32:53.000000', 'temperatura', 702.0000, 'ºC'),
	(49180, 112, '2015-02-01 00:32:54.000000', 'temperatura', 91.0000, 'ºC'),
	(49181, 112, '2015-02-01 00:32:55.000000', 'temperatura', 749.0000, 'ºC'),
	(49182, 112, '2015-02-01 00:32:56.000000', 'temperatura', 1074.0000, 'ºC'),
	(49183, 112, '2015-02-01 00:32:57.000000', 'temperatura', 723.0000, 'ºC'),
	(49184, 112, '2015-02-01 00:32:58.000000', 'temperatura', 395.0000, 'ºC'),
	(49185, 112, '2015-02-01 00:32:59.000000', 'temperatura', 1005.0000, 'ºC'),
	(49186, 112, '2015-02-01 00:33:00.000000', 'temperatura', 243.0000, 'ºC'),
	(49187, 112, '2015-02-01 00:33:01.000000', 'temperatura', 597.0000, 'ºC'),
	(49188, 112, '2015-02-01 00:33:02.000000', 'temperatura', 1059.0000, 'ºC'),
	(49189, 112, '2015-02-01 00:33:03.000000', 'temperatura', 1106.0000, 'ºC'),
	(49190, 112, '2015-02-01 00:33:04.000000', 'temperatura', 1150.0000, 'ºC'),
	(49191, 112, '2015-02-01 00:33:05.000000', 'temperatura', 33.0000, 'ºC'),
	(49192, 112, '2015-02-01 00:33:06.000000', 'temperatura', 317.0000, 'ºC'),
	(49193, 112, '2015-02-01 00:33:07.000000', 'temperatura', 285.0000, 'ºC'),
	(49194, 112, '2015-02-01 00:33:08.000000', 'temperatura', 475.0000, 'ºC'),
	(49195, 112, '2015-02-01 00:33:09.000000', 'temperatura', 321.0000, 'ºC'),
	(49196, 112, '2015-02-01 00:33:10.000000', 'temperatura', 179.0000, 'ºC'),
	(49197, 112, '2015-02-01 00:33:11.000000', 'temperatura', 1135.0000, 'ºC'),
	(49198, 112, '2015-02-01 00:33:12.000000', 'temperatura', 338.0000, 'ºC'),
	(49199, 112, '2015-02-01 00:33:13.000000', 'temperatura', 685.0000, 'ºC'),
	(49200, 112, '2015-02-01 00:33:14.000000', 'temperatura', 14.0000, 'ºC'),
	(49201, 112, '2015-02-01 00:33:15.000000', 'temperatura', 412.0000, 'ºC'),
	(49202, 112, '2015-02-01 00:33:16.000000', 'temperatura', 819.0000, 'ºC'),
	(49203, 112, '2015-02-01 00:33:17.000000', 'temperatura', 458.0000, 'ºC'),
	(49204, 112, '2015-02-01 00:33:18.000000', 'temperatura', 1035.0000, 'ºC'),
	(49205, 112, '2015-02-01 00:33:19.000000', 'temperatura', 199.0000, 'ºC'),
	(49206, 112, '2015-02-01 00:33:20.000000', 'temperatura', 294.0000, 'ºC'),
	(49207, 112, '2015-02-01 00:33:21.000000', 'temperatura', 870.0000, 'ºC'),
	(49208, 112, '2015-02-01 00:33:22.000000', 'temperatura', 1072.0000, 'ºC'),
	(49209, 112, '2015-02-01 00:33:23.000000', 'temperatura', 348.0000, 'ºC'),
	(49210, 112, '2015-02-01 00:33:24.000000', 'temperatura', 927.0000, 'ºC'),
	(49211, 112, '2015-02-01 00:33:25.000000', 'temperatura', 1190.0000, 'ºC'),
	(49212, 112, '2015-02-01 00:33:26.000000', 'temperatura', 769.0000, 'ºC'),
	(49213, 112, '2015-02-01 00:33:27.000000', 'temperatura', 274.0000, 'ºC'),
	(49214, 112, '2015-02-01 00:33:28.000000', 'temperatura', 265.0000, 'ºC'),
	(49215, 112, '2015-02-01 00:33:29.000000', 'temperatura', 503.0000, 'ºC'),
	(49216, 112, '2015-02-01 00:33:30.000000', 'temperatura', 520.0000, 'ºC'),
	(49217, 112, '2015-02-01 00:33:31.000000', 'temperatura', 1092.0000, 'ºC'),
	(49218, 112, '2015-02-01 00:33:32.000000', 'temperatura', 300.0000, 'ºC'),
	(49219, 112, '2015-02-01 00:33:33.000000', 'temperatura', 624.0000, 'ºC'),
	(49220, 112, '2015-02-01 00:33:34.000000', 'temperatura', 1020.0000, 'ºC'),
	(49221, 112, '2015-02-01 00:33:35.000000', 'temperatura', 827.0000, 'ºC'),
	(49222, 112, '2015-02-01 00:33:36.000000', 'temperatura', 1079.0000, 'ºC'),
	(49223, 112, '2015-02-01 00:33:37.000000', 'temperatura', 514.0000, 'ºC'),
	(49224, 112, '2015-02-01 00:33:38.000000', 'temperatura', 533.0000, 'ºC'),
	(49225, 112, '2015-02-01 00:33:39.000000', 'temperatura', 1125.0000, 'ºC'),
	(49226, 112, '2015-02-01 00:33:40.000000', 'temperatura', 427.0000, 'ºC'),
	(49227, 112, '2015-02-01 00:33:41.000000', 'temperatura', 1160.0000, 'ºC'),
	(49228, 112, '2015-02-01 00:33:42.000000', 'temperatura', 919.0000, 'ºC'),
	(49229, 112, '2015-02-01 00:33:43.000000', 'temperatura', 1115.0000, 'ºC'),
	(49230, 112, '2015-02-01 00:33:44.000000', 'temperatura', 418.0000, 'ºC'),
	(49231, 112, '2015-02-01 00:33:45.000000', 'temperatura', 1144.0000, 'ºC'),
	(49232, 112, '2015-02-01 00:33:46.000000', 'temperatura', 869.0000, 'ºC'),
	(49233, 112, '2015-02-01 00:33:47.000000', 'temperatura', 911.0000, 'ºC'),
	(49234, 112, '2015-02-01 00:33:48.000000', 'temperatura', 750.0000, 'ºC'),
	(49235, 112, '2015-02-01 00:33:49.000000', 'temperatura', 1019.0000, 'ºC'),
	(49236, 112, '2015-02-01 00:33:50.000000', 'temperatura', 444.0000, 'ºC'),
	(49237, 112, '2015-02-01 00:33:51.000000', 'temperatura', 365.0000, 'ºC'),
	(49238, 112, '2015-02-01 00:33:52.000000', 'temperatura', 492.0000, 'ºC'),
	(49239, 112, '2015-02-01 00:33:53.000000', 'temperatura', 168.0000, 'ºC'),
	(49240, 112, '2015-02-01 00:33:54.000000', 'temperatura', 563.0000, 'ºC'),
	(49241, 112, '2015-02-01 00:33:55.000000', 'temperatura', 1113.0000, 'ºC'),
	(49242, 112, '2015-02-01 00:33:56.000000', 'temperatura', 273.0000, 'ºC'),
	(49243, 112, '2015-02-01 00:33:57.000000', 'temperatura', 430.0000, 'ºC'),
	(49244, 112, '2015-02-01 00:33:58.000000', 'temperatura', 131.0000, 'ºC'),
	(49245, 112, '2015-02-01 00:33:59.000000', 'temperatura', 566.0000, 'ºC'),
	(49246, 112, '2015-02-01 00:34:00.000000', 'temperatura', 36.0000, 'ºC'),
	(49247, 112, '2015-02-01 00:34:01.000000', 'temperatura', 881.0000, 'ºC'),
	(49248, 112, '2015-02-01 00:34:02.000000', 'temperatura', 700.0000, 'ºC'),
	(49249, 112, '2015-02-01 00:34:03.000000', 'temperatura', 858.0000, 'ºC'),
	(49250, 112, '2015-02-01 00:34:04.000000', 'temperatura', 989.0000, 'ºC'),
	(49251, 112, '2015-02-01 00:34:05.000000', 'temperatura', 1172.0000, 'ºC'),
	(49252, 112, '2015-02-01 00:34:06.000000', 'temperatura', 492.0000, 'ºC'),
	(49253, 112, '2015-02-01 00:34:07.000000', 'temperatura', 144.0000, 'ºC'),
	(49254, 112, '2015-02-01 00:34:08.000000', 'temperatura', 448.0000, 'ºC'),
	(49255, 112, '2015-02-01 00:34:09.000000', 'temperatura', 605.0000, 'ºC'),
	(49256, 112, '2015-02-01 00:34:10.000000', 'temperatura', 483.0000, 'ºC'),
	(49257, 112, '2015-02-01 00:34:11.000000', 'temperatura', 600.0000, 'ºC'),
	(49258, 112, '2015-02-01 00:34:12.000000', 'temperatura', 353.0000, 'ºC'),
	(49259, 112, '2015-02-01 00:34:13.000000', 'temperatura', 1166.0000, 'ºC'),
	(49260, 112, '2015-02-01 00:34:14.000000', 'temperatura', 1170.0000, 'ºC'),
	(49261, 112, '2015-02-01 00:34:15.000000', 'temperatura', 1154.0000, 'ºC'),
	(49262, 112, '2015-02-01 00:34:16.000000', 'temperatura', 1059.0000, 'ºC'),
	(49263, 112, '2015-02-01 00:34:17.000000', 'temperatura', 636.0000, 'ºC'),
	(49264, 112, '2015-02-01 00:34:18.000000', 'temperatura', 1.0000, 'ºC'),
	(49265, 112, '2015-02-01 00:34:19.000000', 'temperatura', 497.0000, 'ºC'),
	(49266, 112, '2015-02-01 00:34:20.000000', 'temperatura', 81.0000, 'ºC'),
	(49267, 112, '2015-02-01 00:34:21.000000', 'temperatura', 118.0000, 'ºC'),
	(49268, 112, '2015-02-01 00:34:22.000000', 'temperatura', 347.0000, 'ºC'),
	(49269, 112, '2015-02-01 00:34:23.000000', 'temperatura', 183.0000, 'ºC'),
	(49270, 112, '2015-02-01 00:34:24.000000', 'temperatura', 1072.0000, 'ºC'),
	(49271, 112, '2015-02-01 00:34:25.000000', 'temperatura', 12.0000, 'ºC'),
	(49272, 112, '2015-02-01 00:34:26.000000', 'temperatura', 444.0000, 'ºC'),
	(49273, 112, '2015-02-01 00:34:27.000000', 'temperatura', 985.0000, 'ºC'),
	(49274, 112, '2015-02-01 00:34:28.000000', 'temperatura', 1193.0000, 'ºC'),
	(49275, 112, '2015-02-01 00:34:29.000000', 'temperatura', 612.0000, 'ºC'),
	(49276, 112, '2015-02-01 00:34:30.000000', 'temperatura', 681.0000, 'ºC'),
	(49277, 112, '2015-02-01 00:34:31.000000', 'temperatura', 369.0000, 'ºC'),
	(49278, 112, '2015-02-01 00:34:32.000000', 'temperatura', 1004.0000, 'ºC'),
	(49279, 112, '2015-02-01 00:34:33.000000', 'temperatura', 311.0000, 'ºC'),
	(49280, 112, '2015-02-01 00:34:34.000000', 'temperatura', 946.0000, 'ºC'),
	(49281, 112, '2015-02-01 00:34:35.000000', 'temperatura', 197.0000, 'ºC'),
	(49282, 112, '2015-02-01 00:34:36.000000', 'temperatura', 548.0000, 'ºC'),
	(49283, 112, '2015-02-01 00:34:37.000000', 'temperatura', 948.0000, 'ºC'),
	(49284, 112, '2015-02-01 00:34:38.000000', 'temperatura', 697.0000, 'ºC'),
	(49285, 112, '2015-02-01 00:34:39.000000', 'temperatura', 643.0000, 'ºC'),
	(49286, 112, '2015-02-01 00:34:40.000000', 'temperatura', 1124.0000, 'ºC'),
	(49287, 112, '2015-02-01 00:34:41.000000', 'temperatura', 90.0000, 'ºC'),
	(49288, 112, '2015-02-01 00:34:42.000000', 'temperatura', 680.0000, 'ºC'),
	(49289, 112, '2015-02-01 00:34:43.000000', 'temperatura', 731.0000, 'ºC'),
	(49290, 112, '2015-02-01 00:34:44.000000', 'temperatura', 417.0000, 'ºC'),
	(49291, 112, '2015-02-01 00:34:45.000000', 'temperatura', 1091.0000, 'ºC'),
	(49292, 112, '2015-02-01 00:34:46.000000', 'temperatura', 603.0000, 'ºC'),
	(49293, 112, '2015-02-01 00:34:47.000000', 'temperatura', 941.0000, 'ºC'),
	(49294, 112, '2015-02-01 00:34:48.000000', 'temperatura', 500.0000, 'ºC'),
	(49295, 112, '2015-02-01 00:34:49.000000', 'temperatura', 877.0000, 'ºC'),
	(49296, 112, '2015-02-01 00:34:50.000000', 'temperatura', 484.0000, 'ºC'),
	(49297, 112, '2015-02-01 00:34:51.000000', 'temperatura', 991.0000, 'ºC'),
	(49298, 112, '2015-02-01 00:34:52.000000', 'temperatura', 1105.0000, 'ºC'),
	(49299, 112, '2015-02-01 00:34:53.000000', 'temperatura', 150.0000, 'ºC'),
	(49300, 112, '2015-02-01 00:34:54.000000', 'temperatura', 1038.0000, 'ºC'),
	(49301, 112, '2015-02-01 00:34:55.000000', 'temperatura', 1138.0000, 'ºC'),
	(49302, 112, '2015-02-01 00:34:56.000000', 'temperatura', 177.0000, 'ºC'),
	(49303, 112, '2015-02-01 00:34:57.000000', 'temperatura', 1070.0000, 'ºC'),
	(49304, 112, '2015-02-01 00:34:58.000000', 'temperatura', 20.0000, 'ºC'),
	(49305, 112, '2015-02-01 00:34:59.000000', 'temperatura', 492.0000, 'ºC'),
	(49306, 112, '2015-02-01 00:35:00.000000', 'temperatura', 1.0000, 'ºC'),
	(49307, 112, '2015-02-01 00:35:01.000000', 'temperatura', 929.0000, 'ºC'),
	(49308, 112, '2015-02-01 00:35:02.000000', 'temperatura', 1041.0000, 'ºC'),
	(49309, 112, '2015-02-01 00:35:03.000000', 'temperatura', 18.0000, 'ºC'),
	(49310, 112, '2015-02-01 00:35:04.000000', 'temperatura', 568.0000, 'ºC'),
	(49311, 112, '2015-02-01 00:35:05.000000', 'temperatura', 389.0000, 'ºC'),
	(49312, 112, '2015-02-01 00:35:06.000000', 'temperatura', 238.0000, 'ºC'),
	(49313, 112, '2015-02-01 00:35:07.000000', 'temperatura', 26.0000, 'ºC'),
	(49314, 112, '2015-02-01 00:35:08.000000', 'temperatura', 617.0000, 'ºC'),
	(49315, 112, '2015-02-01 00:35:09.000000', 'temperatura', 606.0000, 'ºC'),
	(49316, 112, '2015-02-01 00:35:10.000000', 'temperatura', 1181.0000, 'ºC'),
	(49317, 112, '2015-02-01 00:35:11.000000', 'temperatura', 486.0000, 'ºC'),
	(49318, 112, '2015-02-01 00:35:12.000000', 'temperatura', 89.0000, 'ºC'),
	(49319, 112, '2015-02-01 00:35:13.000000', 'temperatura', 185.0000, 'ºC'),
	(49320, 112, '2015-02-01 00:35:14.000000', 'temperatura', 661.0000, 'ºC'),
	(49321, 112, '2015-02-01 00:35:15.000000', 'temperatura', 348.0000, 'ºC'),
	(49322, 112, '2015-02-01 00:35:16.000000', 'temperatura', 958.0000, 'ºC'),
	(49323, 112, '2015-02-01 00:35:17.000000', 'temperatura', 146.0000, 'ºC'),
	(49324, 112, '2015-02-01 00:35:18.000000', 'temperatura', 258.0000, 'ºC'),
	(49325, 112, '2015-02-01 00:35:19.000000', 'temperatura', 852.0000, 'ºC'),
	(49326, 112, '2015-02-01 00:35:20.000000', 'temperatura', 1086.0000, 'ºC'),
	(49327, 112, '2015-02-01 00:35:21.000000', 'temperatura', 475.0000, 'ºC'),
	(49328, 112, '2015-02-01 00:35:22.000000', 'temperatura', 316.0000, 'ºC'),
	(49329, 112, '2015-02-01 00:35:23.000000', 'temperatura', 155.0000, 'ºC'),
	(49330, 112, '2015-02-01 00:35:24.000000', 'temperatura', 1027.0000, 'ºC'),
	(49331, 112, '2015-02-01 00:35:25.000000', 'temperatura', 1070.0000, 'ºC'),
	(49332, 112, '2015-02-01 00:35:26.000000', 'temperatura', 1072.0000, 'ºC'),
	(49333, 112, '2015-02-01 00:35:27.000000', 'temperatura', 949.0000, 'ºC'),
	(49334, 112, '2015-02-01 00:35:28.000000', 'temperatura', 329.0000, 'ºC'),
	(49335, 112, '2015-02-01 00:35:29.000000', 'temperatura', 0.0000, 'ºC'),
	(49336, 112, '2015-02-01 00:35:30.000000', 'temperatura', 212.0000, 'ºC'),
	(49337, 112, '2015-02-01 00:35:31.000000', 'temperatura', 1061.0000, 'ºC'),
	(49338, 112, '2015-02-01 00:35:32.000000', 'temperatura', 1070.0000, 'ºC'),
	(49339, 112, '2015-02-01 00:35:33.000000', 'temperatura', 968.0000, 'ºC'),
	(49340, 112, '2015-02-01 00:35:34.000000', 'temperatura', 428.0000, 'ºC'),
	(49341, 112, '2015-02-01 00:35:35.000000', 'temperatura', 439.0000, 'ºC'),
	(49342, 112, '2015-02-01 00:35:36.000000', 'temperatura', 912.0000, 'ºC'),
	(49343, 112, '2015-02-01 00:35:37.000000', 'temperatura', 844.0000, 'ºC'),
	(49344, 112, '2015-02-01 00:35:38.000000', 'temperatura', 284.0000, 'ºC'),
	(49345, 112, '2015-02-01 00:35:39.000000', 'temperatura', 89.0000, 'ºC'),
	(49346, 112, '2015-02-01 00:35:40.000000', 'temperatura', 791.0000, 'ºC'),
	(49347, 112, '2015-02-01 00:35:41.000000', 'temperatura', 90.0000, 'ºC'),
	(49348, 112, '2015-02-01 00:35:42.000000', 'temperatura', 478.0000, 'ºC'),
	(49349, 112, '2015-02-01 00:35:43.000000', 'temperatura', 919.0000, 'ºC'),
	(49350, 112, '2015-02-01 00:35:44.000000', 'temperatura', 762.0000, 'ºC'),
	(49351, 112, '2015-02-01 00:35:45.000000', 'temperatura', 1054.0000, 'ºC'),
	(49352, 112, '2015-02-01 00:35:46.000000', 'temperatura', 584.0000, 'ºC'),
	(49353, 112, '2015-02-01 00:35:47.000000', 'temperatura', 957.0000, 'ºC'),
	(49354, 112, '2015-02-01 00:35:48.000000', 'temperatura', 636.0000, 'ºC'),
	(49355, 112, '2015-02-01 00:35:49.000000', 'temperatura', 307.0000, 'ºC'),
	(49356, 112, '2015-02-01 00:35:50.000000', 'temperatura', 829.0000, 'ºC'),
	(49357, 112, '2015-02-01 00:35:51.000000', 'temperatura', 825.0000, 'ºC'),
	(49358, 112, '2015-02-01 00:35:52.000000', 'temperatura', 440.0000, 'ºC'),
	(49359, 112, '2015-02-01 00:35:53.000000', 'temperatura', 923.0000, 'ºC'),
	(49360, 112, '2015-02-01 00:35:54.000000', 'temperatura', 897.0000, 'ºC'),
	(49361, 112, '2015-02-01 00:35:55.000000', 'temperatura', 518.0000, 'ºC'),
	(49362, 112, '2015-02-01 00:35:56.000000', 'temperatura', 1096.0000, 'ºC'),
	(49363, 112, '2015-02-01 00:35:57.000000', 'temperatura', 329.0000, 'ºC'),
	(49364, 112, '2015-02-01 00:35:58.000000', 'temperatura', 757.0000, 'ºC'),
	(49365, 112, '2015-02-01 00:35:59.000000', 'temperatura', 399.0000, 'ºC'),
	(49366, 112, '2015-02-01 00:36:00.000000', 'temperatura', 926.0000, 'ºC'),
	(49367, 112, '2015-02-01 00:36:01.000000', 'temperatura', 1032.0000, 'ºC'),
	(49368, 112, '2015-02-01 00:36:02.000000', 'temperatura', 1182.0000, 'ºC'),
	(49369, 112, '2015-02-01 00:36:03.000000', 'temperatura', 417.0000, 'ºC'),
	(49370, 112, '2015-02-01 00:36:04.000000', 'temperatura', 938.0000, 'ºC'),
	(49371, 112, '2015-02-01 00:36:05.000000', 'temperatura', 1040.0000, 'ºC'),
	(49372, 112, '2015-02-01 00:36:06.000000', 'temperatura', 1188.0000, 'ºC'),
	(49373, 112, '2015-02-01 00:36:07.000000', 'temperatura', 420.0000, 'ºC'),
	(49374, 112, '2015-02-01 00:36:08.000000', 'temperatura', 936.0000, 'ºC'),
	(49375, 112, '2015-02-01 00:36:09.000000', 'temperatura', 1021.0000, 'ºC'),
	(49376, 112, '2015-02-01 00:36:10.000000', 'temperatura', 1097.0000, 'ºC'),
	(49377, 112, '2015-02-01 00:36:11.000000', 'temperatura', 21.0000, 'ºC'),
	(49378, 112, '2015-02-01 00:36:12.000000', 'temperatura', 414.0000, 'ºC'),
	(49379, 112, '2015-02-01 00:36:13.000000', 'temperatura', 807.0000, 'ºC'),
	(49380, 112, '2015-02-01 00:36:14.000000', 'temperatura', 395.0000, 'ºC'),
	(49381, 112, '2015-02-01 00:36:15.000000', 'temperatura', 756.0000, 'ºC'),
	(49382, 112, '2015-02-01 00:36:16.000000', 'temperatura', 193.0000, 'ºC'),
	(49383, 112, '2015-02-01 00:36:17.000000', 'temperatura', 1099.0000, 'ºC'),
	(49384, 112, '2015-02-01 00:36:18.000000', 'temperatura', 115.0000, 'ºC'),
	(49385, 112, '2015-02-01 00:36:19.000000', 'temperatura', 879.0000, 'ºC'),
	(49386, 112, '2015-02-01 00:36:20.000000', 'temperatura', 449.0000, 'ºC'),
	(49387, 112, '2015-02-01 00:36:21.000000', 'temperatura', 808.0000, 'ºC'),
	(49388, 112, '2015-02-01 00:36:22.000000', 'temperatura', 296.0000, 'ºC'),
	(49389, 112, '2015-02-01 00:36:23.000000', 'temperatura', 256.0000, 'ºC'),
	(49390, 112, '2015-02-01 00:36:24.000000', 'temperatura', 390.0000, 'ºC'),
	(49391, 112, '2015-02-01 00:36:25.000000', 'temperatura', 1185.0000, 'ºC'),
	(49392, 112, '2015-02-01 00:36:26.000000', 'temperatura', 1153.0000, 'ºC'),
	(49393, 112, '2015-02-01 00:36:27.000000', 'temperatura', 1014.0000, 'ºC'),
	(49394, 112, '2015-02-01 00:36:28.000000', 'temperatura', 409.0000, 'ºC'),
	(49395, 112, '2015-02-01 00:36:29.000000', 'temperatura', 203.0000, 'ºC'),
	(49396, 112, '2015-02-01 00:36:30.000000', 'temperatura', 988.0000, 'ºC'),
	(49397, 112, '2015-02-01 00:36:31.000000', 'temperatura', 732.0000, 'ºC'),
	(49398, 112, '2015-02-01 00:36:32.000000', 'temperatura', 697.0000, 'ºC'),
	(49399, 112, '2015-02-01 00:36:33.000000', 'temperatura', 89.0000, 'ºC'),
	(49400, 112, '2015-02-01 00:36:34.000000', 'temperatura', 753.0000, 'ºC'),
	(49401, 112, '2015-02-01 00:36:35.000000', 'temperatura', 1101.0000, 'ºC'),
	(49402, 112, '2015-02-01 00:36:36.000000', 'temperatura', 846.0000, 'ºC'),
	(49403, 112, '2015-02-01 00:36:37.000000', 'temperatura', 925.0000, 'ºC'),
	(49404, 112, '2015-02-01 00:36:38.000000', 'temperatura', 891.0000, 'ºC'),
	(49405, 112, '2015-02-01 00:36:39.000000', 'temperatura', 478.0000, 'ºC'),
	(49406, 112, '2015-02-01 00:36:40.000000', 'temperatura', 918.0000, 'ºC'),
	(49407, 112, '2015-02-01 00:36:41.000000', 'temperatura', 757.0000, 'ºC'),
	(49408, 112, '2015-02-01 00:36:42.000000', 'temperatura', 1030.0000, 'ºC'),
	(49409, 112, '2015-02-01 00:36:43.000000', 'temperatura', 481.0000, 'ºC'),
	(49410, 112, '2015-02-01 00:36:44.000000', 'temperatura', 515.0000, 'ºC'),
	(49411, 112, '2015-02-01 00:36:45.000000', 'temperatura', 1134.0000, 'ºC'),
	(49412, 112, '2015-02-01 00:36:46.000000', 'temperatura', 526.0000, 'ºC'),
	(49413, 112, '2015-02-01 00:36:47.000000', 'temperatura', 427.0000, 'ºC'),
	(49414, 112, '2015-02-01 00:36:48.000000', 'temperatura', 560.0000, 'ºC'),
	(49415, 112, '2015-02-01 00:36:49.000000', 'temperatura', 316.0000, 'ºC'),
	(49416, 112, '2015-02-01 00:36:50.000000', 'temperatura', 1102.0000, 'ºC'),
	(49417, 112, '2015-02-01 00:36:51.000000', 'temperatura', 962.0000, 'ºC'),
	(49418, 112, '2015-02-01 00:36:52.000000', 'temperatura', 304.0000, 'ºC'),
	(49419, 112, '2015-02-01 00:36:53.000000', 'temperatura', 1034.0000, 'ºC'),
	(49420, 112, '2015-02-01 00:36:54.000000', 'temperatura', 661.0000, 'ºC'),
	(49421, 112, '2015-02-01 00:36:55.000000', 'temperatura', 203.0000, 'ºC'),
	(49422, 112, '2015-02-01 00:36:56.000000', 'temperatura', 234.0000, 'ºC'),
	(49423, 112, '2015-02-01 00:36:57.000000', 'temperatura', 560.0000, 'ºC'),
	(49424, 112, '2015-02-01 00:36:58.000000', 'temperatura', 899.0000, 'ºC'),
	(49425, 112, '2015-02-01 00:36:59.000000', 'temperatura', 414.0000, 'ºC'),
	(49426, 112, '2015-02-01 00:37:00.000000', 'temperatura', 573.0000, 'ºC'),
	(49427, 112, '2015-02-01 00:37:01.000000', 'temperatura', 423.0000, 'ºC'),
	(49428, 112, '2015-02-01 00:37:02.000000', 'temperatura', 397.0000, 'ºC'),
	(49429, 112, '2015-02-01 00:37:03.000000', 'temperatura', 715.0000, 'ºC'),
	(49430, 112, '2015-02-01 00:37:04.000000', 'temperatura', 1187.0000, 'ºC'),
	(49431, 112, '2015-02-01 00:37:05.000000', 'temperatura', 190.0000, 'ºC'),
	(49432, 112, '2015-02-01 00:37:06.000000', 'temperatura', 988.0000, 'ºC'),
	(49433, 112, '2015-02-01 00:37:07.000000', 'temperatura', 771.0000, 'ºC'),
	(49434, 112, '2015-02-01 00:37:08.000000', 'temperatura', 891.0000, 'ºC'),
	(49435, 112, '2015-02-01 00:37:09.000000', 'temperatura', 942.0000, 'ºC'),
	(49436, 112, '2015-02-01 00:37:10.000000', 'temperatura', 836.0000, 'ºC'),
	(49437, 112, '2015-02-01 00:37:11.000000', 'temperatura', 158.0000, 'ºC'),
	(49438, 112, '2015-02-01 00:37:12.000000', 'temperatura', 681.0000, 'ºC'),
	(49439, 112, '2015-02-01 00:37:13.000000', 'temperatura', 531.0000, 'ºC'),
	(49440, 112, '2015-02-01 00:37:14.000000', 'temperatura', 613.0000, 'ºC'),
	(49441, 112, '2015-02-01 00:37:15.000000', 'temperatura', 274.0000, 'ºC'),
	(49442, 112, '2015-02-01 00:37:16.000000', 'temperatura', 732.0000, 'ºC'),
	(49443, 112, '2015-02-01 00:37:17.000000', 'temperatura', 437.0000, 'ºC'),
	(49444, 112, '2015-02-01 00:37:18.000000', 'temperatura', 1190.0000, 'ºC'),
	(49445, 112, '2015-02-01 00:37:19.000000', 'temperatura', 1038.0000, 'ºC'),
	(49446, 112, '2015-02-01 00:37:20.000000', 'temperatura', 423.0000, 'ºC'),
	(49447, 112, '2015-02-01 00:37:21.000000', 'temperatura', 201.0000, 'ºC'),
	(49448, 112, '2015-02-01 00:37:22.000000', 'temperatura', 935.0000, 'ºC'),
	(49449, 112, '2015-02-01 00:37:23.000000', 'temperatura', 474.0000, 'ºC'),
	(49450, 112, '2015-02-01 00:37:24.000000', 'temperatura', 766.0000, 'ºC'),
	(49451, 112, '2015-02-01 00:37:25.000000', 'temperatura', 8.0000, 'ºC'),
	(49452, 112, '2015-02-01 00:37:26.000000', 'temperatura', 144.0000, 'ºC'),
	(49453, 112, '2015-02-01 00:37:27.000000', 'temperatura', 695.0000, 'ºC'),
	(49454, 112, '2015-02-01 00:37:28.000000', 'temperatura', 645.0000, 'ºC'),
	(49455, 112, '2015-02-01 00:37:29.000000', 'temperatura', 1140.0000, 'ºC'),
	(49456, 112, '2015-02-01 00:37:30.000000', 'temperatura', 165.0000, 'ºC'),
	(49457, 112, '2015-02-01 00:37:31.000000', 'temperatura', 1004.0000, 'ºC'),
	(49458, 112, '2015-02-01 00:37:32.000000', 'temperatura', 926.0000, 'ºC'),
	(49459, 112, '2015-02-01 00:37:33.000000', 'temperatura', 418.0000, 'ºC'),
	(49460, 112, '2015-02-01 00:37:34.000000', 'temperatura', 513.0000, 'ºC'),
	(49461, 112, '2015-02-01 00:37:35.000000', 'temperatura', 110.0000, 'ºC'),
	(49462, 112, '2015-02-01 00:37:36.000000', 'temperatura', 212.0000, 'ºC'),
	(49463, 112, '2015-02-01 00:37:37.000000', 'temperatura', 731.0000, 'ºC'),
	(49464, 112, '2015-02-01 00:37:38.000000', 'temperatura', 618.0000, 'ºC'),
	(49465, 112, '2015-02-01 00:37:39.000000', 'temperatura', 899.0000, 'ºC'),
	(49466, 112, '2015-02-01 00:37:40.000000', 'temperatura', 243.0000, 'ºC'),
	(49467, 112, '2015-02-01 00:37:41.000000', 'temperatura', 917.0000, 'ºC'),
	(49468, 112, '2015-02-01 00:37:42.000000', 'temperatura', 256.0000, 'ºC'),
	(49469, 112, '2015-02-01 00:37:43.000000', 'temperatura', 929.0000, 'ºC'),
	(49470, 112, '2015-02-01 00:37:44.000000', 'temperatura', 278.0000, 'ºC'),
	(49471, 112, '2015-02-01 00:37:45.000000', 'temperatura', 1006.0000, 'ºC'),
	(49472, 112, '2015-02-01 00:37:46.000000', 'temperatura', 594.0000, 'ºC'),
	(49473, 112, '2015-02-01 00:37:47.000000', 'temperatura', 1152.0000, 'ºC'),
	(49474, 112, '2015-02-01 00:37:48.000000', 'temperatura', 380.0000, 'ºC'),
	(49475, 112, '2015-02-01 00:37:49.000000', 'temperatura', 843.0000, 'ºC'),
	(49476, 112, '2015-02-01 00:37:50.000000', 'temperatura', 678.0000, 'ºC'),
	(49477, 112, '2015-02-01 00:37:51.000000', 'temperatura', 861.0000, 'ºC'),
	(49478, 112, '2015-02-01 00:37:52.000000', 'temperatura', 1070.0000, 'ºC'),
	(49479, 112, '2015-02-01 00:37:53.000000', 'temperatura', 368.0000, 'ºC'),
	(49480, 112, '2015-02-01 00:37:54.000000', 'temperatura', 1029.0000, 'ºC'),
	(49481, 112, '2015-02-01 00:37:55.000000', 'temperatura', 441.0000, 'ºC'),
	(49482, 112, '2015-02-01 00:37:56.000000', 'temperatura', 320.0000, 'ºC'),
	(49483, 112, '2015-02-01 00:37:57.000000', 'temperatura', 275.0000, 'ºC'),
	(49484, 112, '2015-02-01 00:37:58.000000', 'temperatura', 418.0000, 'ºC'),
	(49485, 112, '2015-02-01 00:37:59.000000', 'temperatura', 65.0000, 'ºC'),
	(49486, 112, '2015-02-01 00:38:00.000000', 'temperatura', 272.0000, 'ºC'),
	(49487, 112, '2015-02-01 00:38:01.000000', 'temperatura', 1165.0000, 'ºC'),
	(49488, 112, '2015-02-01 00:38:02.000000', 'temperatura', 211.0000, 'ºC'),
	(49489, 112, '2015-02-01 00:38:03.000000', 'temperatura', 1160.0000, 'ºC'),
	(49490, 112, '2015-02-01 00:38:04.000000', 'temperatura', 369.0000, 'ºC'),
	(49491, 112, '2015-02-01 00:38:05.000000', 'temperatura', 762.0000, 'ºC'),
	(49492, 112, '2015-02-01 00:38:06.000000', 'temperatura', 307.0000, 'ºC'),
	(49493, 112, '2015-02-01 00:38:07.000000', 'temperatura', 449.0000, 'ºC'),
	(49494, 112, '2015-02-01 00:38:08.000000', 'temperatura', 123.0000, 'ºC'),
	(49495, 112, '2015-02-01 00:38:09.000000', 'temperatura', 469.0000, 'ºC'),
	(49496, 112, '2015-02-01 00:38:10.000000', 'temperatura', 777.0000, 'ºC'),
	(49497, 112, '2015-02-01 00:38:11.000000', 'temperatura', 79.0000, 'ºC'),
	(49498, 112, '2015-02-01 00:38:12.000000', 'temperatura', 466.0000, 'ºC'),
	(49499, 112, '2015-02-01 00:38:13.000000', 'temperatura', 892.0000, 'ºC'),
	(49500, 112, '2015-02-01 00:38:14.000000', 'temperatura', 661.0000, 'ºC'),
	(49501, 112, '2015-02-01 00:38:15.000000', 'temperatura', 631.0000, 'ºC'),
	(49502, 112, '2015-02-01 00:38:16.000000', 'temperatura', 1173.0000, 'ºC'),
	(49503, 112, '2015-02-01 00:38:17.000000', 'temperatura', 372.0000, 'ºC'),
	(49504, 112, '2015-02-01 00:38:18.000000', 'temperatura', 739.0000, 'ºC'),
	(49505, 112, '2015-02-01 00:38:19.000000', 'temperatura', 183.0000, 'ºC'),
	(49506, 112, '2015-02-01 00:38:20.000000', 'temperatura', 1096.0000, 'ºC'),
	(49507, 112, '2015-02-01 00:38:21.000000', 'temperatura', 132.0000, 'ºC'),
	(49508, 112, '2015-02-01 00:38:22.000000', 'temperatura', 975.0000, 'ºC'),
	(49509, 112, '2015-02-01 00:38:23.000000', 'temperatura', 876.0000, 'ºC'),
	(49510, 112, '2015-02-01 00:38:24.000000', 'temperatura', 259.0000, 'ºC'),
	(49511, 112, '2015-02-01 00:38:25.000000', 'temperatura', 1064.0000, 'ºC'),
	(49512, 112, '2015-02-01 00:38:26.000000', 'temperatura', 945.0000, 'ºC'),
	(49513, 112, '2015-02-01 00:38:27.000000', 'temperatura', 333.0000, 'ºC'),
	(49514, 112, '2015-02-01 00:38:28.000000', 'temperatura', 33.0000, 'ºC'),
	(49515, 112, '2015-02-01 00:38:29.000000', 'temperatura', 363.0000, 'ºC'),
	(49516, 112, '2015-02-01 00:38:30.000000', 'temperatura', 518.0000, 'ºC'),
	(49517, 112, '2015-02-01 00:38:31.000000', 'temperatura', 302.0000, 'ºC'),
	(49518, 112, '2015-02-01 00:38:32.000000', 'temperatura', 1157.0000, 'ºC'),
	(49519, 112, '2015-02-01 00:38:33.000000', 'temperatura', 81.0000, 'ºC'),
	(49520, 112, '2015-02-01 00:38:34.000000', 'temperatura', 531.0000, 'ºC'),
	(49521, 112, '2015-02-01 00:38:35.000000', 'temperatura', 15.0000, 'ºC'),
	(49522, 112, '2015-02-01 00:38:36.000000', 'temperatura', 883.0000, 'ºC'),
	(49523, 112, '2015-02-01 00:38:37.000000', 'temperatura', 768.0000, 'ºC'),
	(49524, 112, '2015-02-01 00:38:38.000000', 'temperatura', 1192.0000, 'ºC'),
	(49525, 112, '2015-02-01 00:38:39.000000', 'temperatura', 55.0000, 'ºC'),
	(49526, 112, '2015-02-01 00:38:40.000000', 'temperatura', 300.0000, 'ºC'),
	(49527, 112, '2015-02-01 00:38:41.000000', 'temperatura', 138.0000, 'ºC'),
	(49528, 112, '2015-02-01 00:38:42.000000', 'temperatura', 989.0000, 'ºC'),
	(49529, 112, '2015-02-01 00:38:43.000000', 'temperatura', 930.0000, 'ºC'),
	(49530, 112, '2015-02-01 00:38:44.000000', 'temperatura', 485.0000, 'ºC'),
	(49531, 112, '2015-02-01 00:38:45.000000', 'temperatura', 837.0000, 'ºC'),
	(49532, 112, '2015-02-01 00:38:46.000000', 'temperatura', 329.0000, 'ºC'),
	(49533, 112, '2015-02-01 00:38:47.000000', 'temperatura', 334.0000, 'ºC'),
	(49534, 112, '2015-02-01 00:38:48.000000', 'temperatura', 685.0000, 'ºC'),
	(49535, 112, '2015-02-01 00:38:49.000000', 'temperatura', 24.0000, 'ºC'),
	(49536, 112, '2015-02-01 00:38:50.000000', 'temperatura', 466.0000, 'ºC'),
	(49537, 112, '2015-02-01 00:38:51.000000', 'temperatura', 1059.0000, 'ºC'),
	(49538, 112, '2015-02-01 00:38:52.000000', 'temperatura', 298.0000, 'ºC'),
	(49539, 112, '2015-02-01 00:38:53.000000', 'temperatura', 711.0000, 'ºC'),
	(49540, 112, '2015-02-01 00:38:54.000000', 'temperatura', 264.0000, 'ºC'),
	(49541, 112, '2015-02-01 00:38:55.000000', 'temperatura', 384.0000, 'ºC'),
	(49542, 112, '2015-02-01 00:38:56.000000', 'temperatura', 1132.0000, 'ºC'),
	(49543, 112, '2015-02-01 00:38:57.000000', 'temperatura', 907.0000, 'ºC'),
	(49544, 112, '2015-02-01 00:38:58.000000', 'temperatura', 1142.0000, 'ºC'),
	(49545, 112, '2015-02-01 00:38:59.000000', 'temperatura', 587.0000, 'ºC'),
	(49546, 112, '2015-02-01 00:39:00.000000', 'temperatura', 710.0000, 'ºC'),
	(49547, 112, '2015-02-01 00:39:01.000000', 'temperatura', 589.0000, 'ºC'),
	(49548, 112, '2015-02-01 00:39:02.000000', 'temperatura', 817.0000, 'ºC'),
	(49549, 112, '2015-02-01 00:39:03.000000', 'temperatura', 1119.0000, 'ºC'),
	(49550, 112, '2015-02-01 00:39:04.000000', 'temperatura', 744.0000, 'ºC'),
	(49551, 112, '2015-02-01 00:39:05.000000', 'temperatura', 364.0000, 'ºC'),
	(49552, 112, '2015-02-01 00:39:06.000000', 'temperatura', 787.0000, 'ºC'),
	(49553, 112, '2015-02-01 00:39:07.000000', 'temperatura', 443.0000, 'ºC'),
	(49554, 112, '2015-02-01 00:39:08.000000', 'temperatura', 1057.0000, 'ºC'),
	(49555, 112, '2015-02-01 00:39:09.000000', 'temperatura', 356.0000, 'ºC'),
	(49556, 112, '2015-02-01 00:39:10.000000', 'temperatura', 1007.0000, 'ºC'),
	(49557, 112, '2015-02-01 00:39:11.000000', 'temperatura', 369.0000, 'ºC'),
	(49558, 112, '2015-02-01 00:39:12.000000', 'temperatura', 25.0000, 'ºC'),
	(49559, 112, '2015-02-01 00:39:13.000000', 'temperatura', 216.0000, 'ºC'),
	(49560, 112, '2015-02-01 00:39:14.000000', 'temperatura', 1009.0000, 'ºC'),
	(49561, 112, '2015-02-01 00:39:15.000000', 'temperatura', 796.0000, 'ºC'),
	(49562, 112, '2015-02-01 00:39:16.000000', 'temperatura', 952.0000, 'ºC'),
	(49563, 112, '2015-02-01 00:39:17.000000', 'temperatura', 1176.0000, 'ºC'),
	(49564, 112, '2015-02-01 00:39:18.000000', 'temperatura', 622.0000, 'ºC'),
	(49565, 112, '2015-02-01 00:39:19.000000', 'temperatura', 782.0000, 'ºC'),
	(49566, 112, '2015-02-01 00:39:20.000000', 'temperatura', 843.0000, 'ºC'),
	(49567, 112, '2015-02-01 00:39:21.000000', 'temperatura', 672.0000, 'ºC'),
	(49568, 112, '2015-02-01 00:39:22.000000', 'temperatura', 832.0000, 'ºC'),
	(49569, 112, '2015-02-01 00:39:23.000000', 'temperatura', 945.0000, 'ºC'),
	(49570, 112, '2015-02-01 00:39:24.000000', 'temperatura', 1029.0000, 'ºC'),
	(49571, 112, '2015-02-01 00:39:25.000000', 'temperatura', 1111.0000, 'ºC'),
	(49572, 112, '2015-02-01 00:39:26.000000', 'temperatura', 68.0000, 'ºC'),
	(49573, 112, '2015-02-01 00:39:27.000000', 'temperatura', 608.0000, 'ºC'),
	(49574, 112, '2015-02-01 00:39:28.000000', 'temperatura', 435.0000, 'ºC'),
	(49575, 112, '2015-02-01 00:39:29.000000', 'temperatura', 353.0000, 'ºC'),
	(49576, 112, '2015-02-01 00:39:30.000000', 'temperatura', 461.0000, 'ºC'),
	(49577, 112, '2015-02-01 00:39:31.000000', 'temperatura', 47.0000, 'ºC'),
	(49578, 112, '2015-02-01 00:39:32.000000', 'temperatura', 50.0000, 'ºC'),
	(49579, 112, '2015-02-01 00:39:33.000000', 'temperatura', 112.0000, 'ºC'),
	(49580, 112, '2015-02-01 00:39:34.000000', 'temperatura', 408.0000, 'ºC'),
	(49581, 112, '2015-02-01 00:39:35.000000', 'temperatura', 507.0000, 'ºC'),
	(49582, 112, '2015-02-01 00:39:36.000000', 'temperatura', 111.0000, 'ºC'),
	(49583, 112, '2015-02-01 00:39:37.000000', 'temperatura', 235.0000, 'ºC'),
	(49584, 112, '2015-02-01 00:39:38.000000', 'temperatura', 842.0000, 'ºC'),
	(49585, 112, '2015-02-01 00:39:39.000000', 'temperatura', 1104.0000, 'ºC'),
	(49586, 112, '2015-02-01 00:39:40.000000', 'temperatura', 595.0000, 'ºC'),
	(49587, 112, '2015-02-01 00:39:41.000000', 'temperatura', 862.0000, 'ºC'),
	(49588, 112, '2015-02-01 00:39:42.000000', 'temperatura', 126.0000, 'ºC'),
	(49589, 112, '2015-02-01 00:39:43.000000', 'temperatura', 443.0000, 'ºC'),
	(49590, 112, '2015-02-01 00:39:44.000000', 'temperatura', 641.0000, 'ºC'),
	(49591, 112, '2015-02-01 00:39:45.000000', 'temperatura', 673.0000, 'ºC'),
	(49592, 112, '2015-02-01 00:39:46.000000', 'temperatura', 245.0000, 'ºC'),
	(49593, 112, '2015-02-01 00:39:47.000000', 'temperatura', 406.0000, 'ºC'),
	(49594, 112, '2015-02-01 00:39:48.000000', 'temperatura', 97.0000, 'ºC'),
	(49595, 112, '2015-02-01 00:39:49.000000', 'temperatura', 467.0000, 'ºC'),
	(49596, 112, '2015-02-01 00:39:50.000000', 'temperatura', 844.0000, 'ºC'),
	(49597, 112, '2015-02-01 00:39:51.000000', 'temperatura', 422.0000, 'ºC'),
	(49598, 112, '2015-02-01 00:39:52.000000', 'temperatura', 775.0000, 'ºC'),
	(49599, 112, '2015-02-01 00:39:53.000000', 'temperatura', 211.0000, 'ºC'),
	(49600, 112, '2015-02-01 00:39:54.000000', 'temperatura', 1132.0000, 'ºC'),
	(49601, 112, '2015-02-01 00:39:55.000000', 'temperatura', 226.0000, 'ºC'),
	(49602, 112, '2015-02-01 00:39:56.000000', 'temperatura', 136.0000, 'ºC'),
	(49603, 112, '2015-02-01 00:39:57.000000', 'temperatura', 3.0000, 'ºC'),
	(49604, 112, '2015-02-01 00:39:58.000000', 'temperatura', 805.0000, 'ºC'),
	(49605, 112, '2015-02-01 00:39:59.000000', 'temperatura', 418.0000, 'ºC'),
	(49606, 112, '2015-02-01 00:40:00.000000', 'temperatura', 875.0000, 'ºC'),
	(49607, 112, '2015-02-01 00:40:01.000000', 'temperatura', 721.0000, 'ºC'),
	(49608, 112, '2015-02-01 00:40:02.000000', 'temperatura', 979.0000, 'ºC'),
	(49609, 112, '2015-02-01 00:40:03.000000', 'temperatura', 333.0000, 'ºC'),
	(49610, 112, '2015-02-01 00:40:04.000000', 'temperatura', 1130.0000, 'ºC'),
	(49611, 112, '2015-02-01 00:40:05.000000', 'temperatura', 1051.0000, 'ºC'),
	(49612, 112, '2015-02-01 00:40:06.000000', 'temperatura', 663.0000, 'ºC'),
	(49613, 112, '2015-02-01 00:40:07.000000', 'temperatura', 166.0000, 'ºC'),
	(49614, 112, '2015-02-01 00:40:08.000000', 'temperatura', 41.0000, 'ºC'),
	(49615, 112, '2015-02-01 00:40:09.000000', 'temperatura', 907.0000, 'ºC'),
	(49616, 112, '2015-02-01 00:40:10.000000', 'temperatura', 812.0000, 'ºC'),
	(49617, 112, '2015-02-01 00:40:11.000000', 'temperatura', 141.0000, 'ºC'),
	(49618, 112, '2015-02-01 00:40:12.000000', 'temperatura', 668.0000, 'ºC'),
	(49619, 112, '2015-02-01 00:40:13.000000', 'temperatura', 518.0000, 'ºC'),
	(49620, 112, '2015-02-01 00:40:14.000000', 'temperatura', 587.0000, 'ºC'),
	(49621, 112, '2015-02-01 00:40:15.000000', 'temperatura', 182.0000, 'ºC'),
	(49622, 112, '2015-02-01 00:40:16.000000', 'temperatura', 351.0000, 'ºC'),
	(49623, 112, '2015-02-01 00:40:17.000000', 'temperatura', 6.0000, 'ºC'),
	(49624, 112, '2015-02-01 00:40:18.000000', 'temperatura', 181.0000, 'ºC'),
	(49625, 112, '2015-02-01 00:40:19.000000', 'temperatura', 885.0000, 'ºC'),
	(49626, 112, '2015-02-01 00:40:20.000000', 'temperatura', 281.0000, 'ºC'),
	(49627, 112, '2015-02-01 00:40:21.000000', 'temperatura', 1153.0000, 'ºC'),
	(49628, 112, '2015-02-01 00:40:22.000000', 'temperatura', 121.0000, 'ºC'),
	(49629, 112, '2015-02-01 00:40:23.000000', 'temperatura', 745.0000, 'ºC'),
	(49630, 112, '2015-02-01 00:40:24.000000', 'temperatura', 966.0000, 'ºC'),
	(49631, 112, '2015-02-01 00:40:25.000000', 'temperatura', 192.0000, 'ºC'),
	(49632, 112, '2015-02-01 00:40:26.000000', 'temperatura', 466.0000, 'ºC'),
	(49633, 112, '2015-02-01 00:40:27.000000', 'temperatura', 552.0000, 'ºC'),
	(49634, 112, '2015-02-01 00:40:28.000000', 'temperatura', 165.0000, 'ºC'),
	(49635, 112, '2015-02-01 00:40:29.000000', 'temperatura', 367.0000, 'ºC'),
	(49636, 112, '2015-02-01 00:40:30.000000', 'temperatura', 141.0000, 'ºC'),
	(49637, 112, '2015-02-01 00:40:31.000000', 'temperatura', 805.0000, 'ºC'),
	(49638, 112, '2015-02-01 00:40:32.000000', 'temperatura', 2.0000, 'ºC'),
	(49639, 112, '2015-02-01 00:40:33.000000', 'temperatura', 1198.0000, 'ºC'),
	(49640, 112, '2015-02-01 00:40:34.000000', 'temperatura', 1181.0000, 'ºC'),
	(49641, 112, '2015-02-01 00:40:35.000000', 'temperatura', 1114.0000, 'ºC'),
	(49642, 112, '2015-02-01 00:40:36.000000', 'temperatura', 825.0000, 'ºC'),
	(49643, 112, '2015-02-01 00:40:37.000000', 'temperatura', 783.0000, 'ºC'),
	(49644, 112, '2015-02-01 00:40:38.000000', 'temperatura', 241.0000, 'ºC'),
	(49645, 112, '2015-02-01 00:40:39.000000', 'temperatura', 55.0000, 'ºC'),
	(49646, 112, '2015-02-01 00:40:40.000000', 'temperatura', 754.0000, 'ºC'),
	(49647, 112, '2015-02-01 00:40:41.000000', 'temperatura', 5.0000, 'ºC'),
	(49648, 112, '2015-02-01 00:40:42.000000', 'temperatura', 163.0000, 'ºC'),
	(49649, 112, '2015-02-01 00:40:43.000000', 'temperatura', 802.0000, 'ºC'),
	(49650, 112, '2015-02-01 00:40:44.000000', 'temperatura', 1121.0000, 'ºC'),
	(49651, 112, '2015-02-01 00:40:45.000000', 'temperatura', 799.0000, 'ºC'),
	(49652, 112, '2015-02-01 00:40:46.000000', 'temperatura', 633.0000, 'ºC'),
	(49653, 112, '2015-02-01 00:40:47.000000', 'temperatura', 767.0000, 'ºC'),
	(49654, 112, '2015-02-01 00:40:48.000000', 'temperatura', 739.0000, 'ºC'),
	(49655, 112, '2015-02-01 00:40:49.000000', 'temperatura', 193.0000, 'ºC'),
	(49656, 112, '2015-02-01 00:40:50.000000', 'temperatura', 1149.0000, 'ºC'),
	(49657, 112, '2015-02-01 00:40:51.000000', 'temperatura', 367.0000, 'ºC'),
	(49658, 112, '2015-02-01 00:40:52.000000', 'temperatura', 789.0000, 'ºC'),
	(49659, 112, '2015-02-01 00:40:53.000000', 'temperatura', 442.0000, 'ºC'),
	(49660, 112, '2015-02-01 00:40:54.000000', 'temperatura', 1043.0000, 'ºC'),
	(49661, 112, '2015-02-01 00:40:55.000000', 'temperatura', 293.0000, 'ºC'),
	(49662, 112, '2015-02-01 00:40:56.000000', 'temperatura', 734.0000, 'ºC'),
	(49663, 112, '2015-02-01 00:40:57.000000', 'temperatura', 391.0000, 'ºC'),
	(49664, 112, '2015-02-01 00:40:58.000000', 'temperatura', 954.0000, 'ºC'),
	(49665, 112, '2015-02-01 00:40:59.000000', 'temperatura', 1197.0000, 'ºC'),
	(49666, 112, '2015-02-01 00:41:00.000000', 'temperatura', 726.0000, 'ºC'),
	(49667, 112, '2015-02-01 00:41:01.000000', 'temperatura', 37.0000, 'ºC'),
	(49668, 112, '2015-02-01 00:41:02.000000', 'temperatura', 409.0000, 'ºC'),
	(49669, 112, '2015-02-01 00:41:03.000000', 'temperatura', 732.0000, 'ºC'),
	(49670, 112, '2015-02-01 00:41:04.000000', 'temperatura', 36.0000, 'ºC'),
	(49671, 112, '2015-02-01 00:41:05.000000', 'temperatura', 384.0000, 'ºC'),
	(49672, 112, '2015-02-01 00:41:06.000000', 'temperatura', 610.0000, 'ºC'),
	(49673, 112, '2015-02-01 00:41:07.000000', 'temperatura', 701.0000, 'ºC'),
	(49674, 112, '2015-02-01 00:41:08.000000', 'temperatura', 476.0000, 'ºC'),
	(49675, 112, '2015-02-01 00:41:09.000000', 'temperatura', 276.0000, 'ºC'),
	(49676, 112, '2015-02-01 00:41:10.000000', 'temperatura', 1153.0000, 'ºC'),
	(49677, 112, '2015-02-01 00:41:11.000000', 'temperatura', 136.0000, 'ºC'),
	(49678, 112, '2015-02-01 00:41:12.000000', 'temperatura', 821.0000, 'ºC'),
	(49679, 112, '2015-02-01 00:41:13.000000', 'temperatura', 98.0000, 'ºC'),
	(49680, 112, '2015-02-01 00:41:14.000000', 'temperatura', 429.0000, 'ºC'),
	(49681, 112, '2015-02-01 00:41:15.000000', 'temperatura', 652.0000, 'ºC'),
	(49682, 112, '2015-02-01 00:41:16.000000', 'temperatura', 772.0000, 'ºC'),
	(49683, 112, '2015-02-01 00:41:17.000000', 'temperatura', 707.0000, 'ºC'),
	(49684, 112, '2015-02-01 00:41:18.000000', 'temperatura', 18.0000, 'ºC'),
	(49685, 112, '2015-02-01 00:41:19.000000', 'temperatura', 370.0000, 'ºC'),
	(49686, 112, '2015-02-01 00:41:20.000000', 'temperatura', 597.0000, 'ºC'),
	(49687, 112, '2015-02-01 00:41:21.000000', 'temperatura', 674.0000, 'ºC'),
	(49688, 112, '2015-02-01 00:41:22.000000', 'temperatura', 382.0000, 'ºC'),
	(49689, 112, '2015-02-01 00:41:23.000000', 'temperatura', 1088.0000, 'ºC'),
	(49690, 112, '2015-02-01 00:41:24.000000', 'temperatura', 692.0000, 'ºC'),
	(49691, 112, '2015-02-01 00:41:25.000000', 'temperatura', 199.0000, 'ºC'),
	(49692, 112, '2015-02-01 00:41:26.000000', 'temperatura', 117.0000, 'ºC'),
	(49693, 112, '2015-02-01 00:41:27.000000', 'temperatura', 1190.0000, 'ºC'),
	(49694, 112, '2015-02-01 00:41:28.000000', 'temperatura', 799.0000, 'ºC'),
	(49695, 112, '2015-02-01 00:41:29.000000', 'temperatura', 424.0000, 'ºC'),
	(49696, 112, '2015-02-01 00:41:30.000000', 'temperatura', 926.0000, 'ºC'),
	(49697, 112, '2015-02-01 00:41:31.000000', 'temperatura', 958.0000, 'ºC'),
	(49698, 112, '2015-02-01 00:41:32.000000', 'temperatura', 813.0000, 'ºC'),
	(49699, 112, '2015-02-01 00:41:33.000000', 'temperatura', 1191.0000, 'ºC'),
	(49700, 112, '2015-02-01 00:41:34.000000', 'temperatura', 1115.0000, 'ºC'),
	(49701, 112, '2015-02-01 00:41:35.000000', 'temperatura', 804.0000, 'ºC'),
	(49702, 112, '2015-02-01 00:41:36.000000', 'temperatura', 674.0000, 'ºC'),
	(49703, 112, '2015-02-01 00:41:37.000000', 'temperatura', 958.0000, 'ºC'),
	(49704, 112, '2015-02-01 00:41:38.000000', 'temperatura', 369.0000, 'ºC'),
	(49705, 112, '2015-02-01 00:41:39.000000', 'temperatura', 172.0000, 'ºC'),
	(49706, 112, '2015-02-01 00:41:40.000000', 'temperatura', 953.0000, 'ºC'),
	(49707, 112, '2015-02-01 00:41:41.000000', 'temperatura', 650.0000, 'ºC'),
	(49708, 112, '2015-02-01 00:41:42.000000', 'temperatura', 390.0000, 'ºC'),
	(49709, 112, '2015-02-01 00:41:43.000000', 'temperatura', 0.0000, 'ºC'),
	(49710, 112, '2015-02-01 00:41:44.000000', 'temperatura', 32.0000, 'ºC'),
	(49711, 112, '2015-02-01 00:41:45.000000', 'temperatura', 159.0000, 'ºC'),
	(49712, 112, '2015-02-01 00:41:46.000000', 'temperatura', 701.0000, 'ºC'),
	(49713, 112, '2015-02-01 00:41:47.000000', 'temperatura', 626.0000, 'ºC'),
	(49714, 112, '2015-02-01 00:41:48.000000', 'temperatura', 1029.0000, 'ºC'),
	(49715, 112, '2015-02-01 00:41:49.000000', 'temperatura', 869.0000, 'ºC'),
	(49716, 112, '2015-02-01 00:41:50.000000', 'temperatura', 57.0000, 'ºC'),
	(49717, 112, '2015-02-01 00:41:51.000000', 'temperatura', 78.0000, 'ºC'),
	(49718, 112, '2015-02-01 00:41:52.000000', 'temperatura', 218.0000, 'ºC'),
	(49719, 112, '2015-02-01 00:41:53.000000', 'temperatura', 860.0000, 'ºC'),
	(49720, 112, '2015-02-01 00:41:54.000000', 'temperatura', 44.0000, 'ºC'),
	(49721, 112, '2015-02-01 00:41:55.000000', 'temperatura', 40.0000, 'ºC'),
	(49722, 112, '2015-02-01 00:41:56.000000', 'temperatura', 68.0000, 'ºC'),
	(49723, 112, '2015-02-01 00:41:57.000000', 'temperatura', 220.0000, 'ºC'),
	(49724, 112, '2015-02-01 00:41:58.000000', 'temperatura', 896.0000, 'ºC'),
	(49725, 112, '2015-02-01 00:41:59.000000', 'temperatura', 222.0000, 'ºC'),
	(49726, 112, '2015-02-01 00:42:00.000000', 'temperatura', 823.0000, 'ºC'),
	(49727, 112, '2015-02-01 00:42:01.000000', 'temperatura', 1048.0000, 'ºC'),
	(49728, 112, '2015-02-01 00:42:02.000000', 'temperatura', 372.0000, 'ºC'),
	(49729, 112, '2015-02-01 00:42:03.000000', 'temperatura', 1116.0000, 'ºC'),
	(49730, 112, '2015-02-01 00:42:04.000000', 'temperatura', 864.0000, 'ºC'),
	(49731, 112, '2015-02-01 00:42:05.000000', 'temperatura', 975.0000, 'ºC'),
	(49732, 112, '2015-02-01 00:42:06.000000', 'temperatura', 1081.0000, 'ºC'),
	(49733, 112, '2015-02-01 00:42:07.000000', 'temperatura', 81.0000, 'ºC'),
	(49734, 112, '2015-02-01 00:42:08.000000', 'temperatura', 764.0000, 'ºC'),
	(49735, 112, '2015-02-01 00:42:09.000000', 'temperatura', 1178.0000, 'ºC'),
	(49736, 112, '2015-02-01 00:42:10.000000', 'temperatura', 0.0000, 'ºC'),
	(49737, 112, '2015-02-01 00:42:11.000000', 'temperatura', 63.0000, 'ºC'),
	(49738, 112, '2015-02-01 00:42:12.000000', 'temperatura', 318.0000, 'ºC'),
	(49739, 112, '2015-02-01 00:42:13.000000', 'temperatura', 202.0000, 'ºC'),
	(49740, 112, '2015-02-01 00:42:14.000000', 'temperatura', 55.0000, 'ºC'),
	(49741, 112, '2015-02-01 00:42:15.000000', 'temperatura', 872.0000, 'ºC'),
	(49742, 112, '2015-02-01 00:42:16.000000', 'temperatura', 594.0000, 'ºC'),
	(49743, 112, '2015-02-01 00:42:17.000000', 'temperatura', 353.0000, 'ºC'),
	(49744, 112, '2015-02-01 00:42:18.000000', 'temperatura', 1183.0000, 'ºC'),
	(49745, 112, '2015-02-01 00:42:19.000000', 'temperatura', 59.0000, 'ºC'),
	(49746, 112, '2015-02-01 00:42:20.000000', 'temperatura', 346.0000, 'ºC'),
	(49747, 112, '2015-02-01 00:42:21.000000', 'temperatura', 352.0000, 'ºC'),
	(49748, 112, '2015-02-01 00:42:22.000000', 'temperatura', 723.0000, 'ºC'),
	(49749, 112, '2015-02-01 00:42:23.000000', 'temperatura', 160.0000, 'ºC'),
	(49750, 112, '2015-02-01 00:42:24.000000', 'temperatura', 1032.0000, 'ºC'),
	(49751, 112, '2015-02-01 00:42:25.000000', 'temperatura', 1079.0000, 'ºC'),
	(49752, 112, '2015-02-01 00:42:26.000000', 'temperatura', 1102.0000, 'ºC'),
	(49753, 112, '2015-02-01 00:42:27.000000', 'temperatura', 1070.0000, 'ºC'),
	(49754, 112, '2015-02-01 00:42:28.000000', 'temperatura', 848.0000, 'ºC'),
	(49755, 112, '2015-02-01 00:42:29.000000', 'temperatura', 1029.0000, 'ºC'),
	(49756, 112, '2015-02-01 00:42:30.000000', 'temperatura', 203.0000, 'ºC'),
	(49757, 112, '2015-02-01 00:42:31.000000', 'temperatura', 327.0000, 'ºC'),
	(49758, 112, '2015-02-01 00:42:32.000000', 'temperatura', 1027.0000, 'ºC'),
	(49759, 112, '2015-02-01 00:42:33.000000', 'temperatura', 554.0000, 'ºC'),
	(49760, 112, '2015-02-01 00:42:34.000000', 'temperatura', 889.0000, 'ºC'),
	(49761, 112, '2015-02-01 00:42:35.000000', 'temperatura', 386.0000, 'ºC'),
	(49762, 112, '2015-02-01 00:42:36.000000', 'temperatura', 461.0000, 'ºC'),
	(49763, 112, '2015-02-01 00:42:37.000000', 'temperatura', 1148.0000, 'ºC'),
	(49764, 112, '2015-02-01 00:42:38.000000', 'temperatura', 756.0000, 'ºC'),
	(49765, 112, '2015-02-01 00:42:39.000000', 'temperatura', 337.0000, 'ºC'),
	(49766, 112, '2015-02-01 00:42:40.000000', 'temperatura', 616.0000, 'ºC'),
	(49767, 112, '2015-02-01 00:42:41.000000', 'temperatura', 870.0000, 'ºC'),
	(49768, 112, '2015-02-01 00:42:42.000000', 'temperatura', 105.0000, 'ºC'),
	(49769, 112, '2015-02-01 00:42:43.000000', 'temperatura', 314.0000, 'ºC'),
	(49770, 112, '2015-02-01 00:42:44.000000', 'temperatura', 55.0000, 'ºC'),
	(49771, 112, '2015-02-01 00:42:45.000000', 'temperatura', 534.0000, 'ºC'),
	(49772, 112, '2015-02-01 00:42:46.000000', 'temperatura', 107.0000, 'ºC'),
	(49773, 112, '2015-02-01 00:42:47.000000', 'temperatura', 133.0000, 'ºC'),
	(49774, 112, '2015-02-01 00:42:48.000000', 'temperatura', 343.0000, 'ºC'),
	(49775, 112, '2015-02-01 00:42:49.000000', 'temperatura', 116.0000, 'ºC'),
	(49776, 112, '2015-02-01 00:42:50.000000', 'temperatura', 754.0000, 'ºC'),
	(49777, 112, '2015-02-01 00:42:51.000000', 'temperatura', 1019.0000, 'ºC'),
	(49778, 112, '2015-02-01 00:42:52.000000', 'temperatura', 437.0000, 'ºC'),
	(49779, 112, '2015-02-01 00:42:53.000000', 'temperatura', 325.0000, 'ºC'),
	(49780, 112, '2015-02-01 00:42:54.000000', 'temperatura', 318.0000, 'ºC'),
	(49781, 112, '2015-02-01 00:42:55.000000', 'temperatura', 613.0000, 'ºC'),
	(49782, 112, '2015-02-01 00:42:56.000000', 'temperatura', 913.0000, 'ºC'),
	(49783, 112, '2015-02-01 00:42:57.000000', 'temperatura', 327.0000, 'ºC'),
	(49784, 112, '2015-02-01 00:42:58.000000', 'temperatura', 94.0000, 'ºC'),
	(49785, 112, '2015-02-01 00:42:59.000000', 'temperatura', 692.0000, 'ºC'),
	(49786, 112, '2015-02-01 00:43:00.000000', 'temperatura', 779.0000, 'ºC'),
	(49787, 112, '2015-02-01 00:43:01.000000', 'temperatura', 621.0000, 'ºC'),
	(49788, 112, '2015-02-01 00:43:02.000000', 'temperatura', 765.0000, 'ºC'),
	(49789, 112, '2015-02-01 00:43:03.000000', 'temperatura', 764.0000, 'ºC'),
	(49790, 112, '2015-02-01 00:43:04.000000', 'temperatura', 326.0000, 'ºC'),
	(49791, 112, '2015-02-01 00:43:05.000000', 'temperatura', 536.0000, 'ºC'),
	(49792, 112, '2015-02-01 00:43:06.000000', 'temperatura', 504.0000, 'ºC'),
	(49793, 112, '2015-02-01 00:43:07.000000', 'temperatura', 911.0000, 'ºC'),
	(49794, 112, '2015-02-01 00:43:08.000000', 'temperatura', 646.0000, 'ºC'),
	(49795, 112, '2015-02-01 00:43:09.000000', 'temperatura', 498.0000, 'ºC'),
	(49796, 112, '2015-02-01 00:43:10.000000', 'temperatura', 550.0000, 'ºC'),
	(49797, 112, '2015-02-01 00:43:11.000000', 'temperatura', 58.0000, 'ºC'),
	(49798, 112, '2015-02-01 00:43:12.000000', 'temperatura', 1041.0000, 'ºC'),
	(49799, 112, '2015-02-01 00:43:13.000000', 'temperatura', 230.0000, 'ºC'),
	(49800, 112, '2015-02-01 00:43:14.000000', 'temperatura', 429.0000, 'ºC'),
	(49801, 112, '2015-02-01 00:43:15.000000', 'temperatura', 255.0000, 'ºC'),
	(49802, 112, '2015-02-01 00:43:16.000000', 'temperatura', 1190.0000, 'ºC'),
	(49803, 112, '2015-02-01 00:43:17.000000', 'temperatura', 384.0000, 'ºC'),
	(49804, 112, '2015-02-01 00:43:18.000000', 'temperatura', 749.0000, 'ºC'),
	(49805, 112, '2015-02-01 00:43:19.000000', 'temperatura', 197.0000, 'ºC'),
	(49806, 112, '2015-02-01 00:43:20.000000', 'temperatura', 1136.0000, 'ºC'),
	(49807, 112, '2015-02-01 00:43:21.000000', 'temperatura', 292.0000, 'ºC'),
	(49808, 112, '2015-02-01 00:43:22.000000', 'temperatura', 449.0000, 'ºC'),
	(49809, 112, '2015-02-01 00:43:23.000000', 'temperatura', 173.0000, 'ºC'),
	(49810, 112, '2015-02-01 00:43:24.000000', 'temperatura', 717.0000, 'ºC'),
	(49811, 112, '2015-02-01 00:43:25.000000', 'temperatura', 666.0000, 'ºC'),
	(49812, 112, '2015-02-01 00:43:26.000000', 'temperatura', 1179.0000, 'ºC'),
	(49813, 112, '2015-02-01 00:43:27.000000', 'temperatura', 300.0000, 'ºC'),
	(49814, 112, '2015-02-01 00:43:28.000000', 'temperatura', 362.0000, 'ºC'),
	(49815, 112, '2015-02-01 00:43:29.000000', 'temperatura', 910.0000, 'ºC'),
	(49816, 112, '2015-02-01 00:43:30.000000', 'temperatura', 1067.0000, 'ºC'),
	(49817, 112, '2015-02-01 00:43:31.000000', 'temperatura', 203.0000, 'ºC'),
	(49818, 112, '2015-02-01 00:43:32.000000', 'temperatura', 217.0000, 'ºC'),
	(49819, 112, '2015-02-01 00:43:33.000000', 'temperatura', 474.0000, 'ºC'),
	(49820, 112, '2015-02-01 00:43:34.000000', 'temperatura', 521.0000, 'ºC'),
	(49821, 112, '2015-02-01 00:43:35.000000', 'temperatura', 1181.0000, 'ºC'),
	(49822, 112, '2015-02-01 00:43:36.000000', 'temperatura', 746.0000, 'ºC'),
	(49823, 112, '2015-02-01 00:43:37.000000', 'temperatura', 184.0000, 'ºC'),
	(49824, 112, '2015-02-01 00:43:38.000000', 'temperatura', 1085.0000, 'ºC'),
	(49825, 112, '2015-02-01 00:43:39.000000', 'temperatura', 73.0000, 'ºC'),
	(49826, 112, '2015-02-01 00:43:40.000000', 'temperatura', 711.0000, 'ºC'),
	(49827, 112, '2015-02-01 00:43:41.000000', 'temperatura', 934.0000, 'ºC'),
	(49828, 112, '2015-02-01 00:43:42.000000', 'temperatura', 139.0000, 'ºC'),
	(49829, 112, '2015-02-01 00:43:43.000000', 'temperatura', 292.0000, 'ºC'),
	(49830, 112, '2015-02-01 00:43:44.000000', 'temperatura', 1044.0000, 'ºC'),
	(49831, 112, '2015-02-01 00:43:45.000000', 'temperatura', 745.0000, 'ºC'),
	(49832, 112, '2015-02-01 00:43:46.000000', 'temperatura', 593.0000, 'ºC'),
	(49833, 112, '2015-02-01 00:43:47.000000', 'temperatura', 731.0000, 'ºC'),
	(49834, 112, '2015-02-01 00:43:48.000000', 'temperatura', 677.0000, 'ºC'),
	(49835, 112, '2015-02-01 00:43:49.000000', 'temperatura', 1191.0000, 'ºC'),
	(49836, 112, '2015-02-01 00:43:50.000000', 'temperatura', 323.0000, 'ºC'),
	(49837, 112, '2015-02-01 00:43:51.000000', 'temperatura', 444.0000, 'ºC'),
	(49838, 112, '2015-02-01 00:43:52.000000', 'temperatura', 54.0000, 'ºC'),
	(49839, 112, '2015-02-01 00:43:53.000000', 'temperatura', 135.0000, 'ºC'),
	(49840, 112, '2015-02-01 00:43:54.000000', 'temperatura', 516.0000, 'ºC'),
	(49841, 112, '2015-02-01 00:43:55.000000', 'temperatura', 973.0000, 'ºC'),
	(49842, 112, '2015-02-01 00:43:56.000000', 'temperatura', 916.0000, 'ºC'),
	(49843, 112, '2015-02-01 00:43:57.000000', 'temperatura', 465.0000, 'ºC'),
	(49844, 112, '2015-02-01 00:43:58.000000', 'temperatura', 778.0000, 'ºC'),
	(49845, 112, '2015-02-01 00:43:59.000000', 'temperatura', 95.0000, 'ºC'),
	(49846, 112, '2015-02-01 00:44:00.000000', 'temperatura', 541.0000, 'ºC'),
	(49847, 112, '2015-02-01 00:44:01.000000', 'temperatura', 20.0000, 'ºC'),
	(49848, 112, '2015-02-01 00:44:02.000000', 'temperatura', 878.0000, 'ºC'),
	(49849, 112, '2015-02-01 00:44:03.000000', 'temperatura', 729.0000, 'ºC'),
	(49850, 112, '2015-02-01 00:44:04.000000', 'temperatura', 1011.0000, 'ºC'),
	(49851, 112, '2015-02-01 00:44:05.000000', 'temperatura', 470.0000, 'ºC'),
	(49852, 112, '2015-02-01 00:44:06.000000', 'temperatura', 517.0000, 'ºC'),
	(49853, 112, '2015-02-01 00:44:07.000000', 'temperatura', 1177.0000, 'ºC'),
	(49854, 112, '2015-02-01 00:44:08.000000', 'temperatura', 735.0000, 'ºC'),
	(49855, 112, '2015-02-01 00:44:09.000000', 'temperatura', 145.0000, 'ºC'),
	(49856, 112, '2015-02-01 00:44:10.000000', 'temperatura', 920.0000, 'ºC'),
	(49857, 112, '2015-02-01 00:44:11.000000', 'temperatura', 564.0000, 'ºC'),
	(49858, 112, '2015-02-01 00:44:12.000000', 'temperatura', 61.0000, 'ºC'),
	(49859, 112, '2015-02-01 00:44:13.000000', 'temperatura', 1012.0000, 'ºC'),
	(49860, 112, '2015-02-01 00:44:14.000000', 'temperatura', 79.0000, 'ºC'),
	(49861, 112, '2015-02-01 00:44:15.000000', 'temperatura', 959.0000, 'ºC'),
	(49862, 112, '2015-02-01 00:44:16.000000', 'temperatura', 960.0000, 'ºC'),
	(49863, 112, '2015-02-01 00:44:17.000000', 'temperatura', 721.0000, 'ºC'),
	(49864, 112, '2015-02-01 00:44:18.000000', 'temperatura', 726.0000, 'ºC'),
	(49865, 112, '2015-02-01 00:44:19.000000', 'temperatura', 268.0000, 'ºC'),
	(49866, 112, '2015-02-01 00:44:20.000000', 'temperatura', 362.0000, 'ºC'),
	(49867, 112, '2015-02-01 00:44:21.000000', 'temperatura', 1005.0000, 'ºC'),
	(49868, 112, '2015-02-01 00:44:22.000000', 'temperatura', 341.0000, 'ºC'),
	(49869, 112, '2015-02-01 00:44:23.000000', 'temperatura', 1092.0000, 'ºC'),
	(49870, 112, '2015-02-01 00:44:24.000000', 'temperatura', 838.0000, 'ºC'),
	(49871, 112, '2015-02-01 00:44:25.000000', 'temperatura', 915.0000, 'ºC'),
	(49872, 112, '2015-02-01 00:44:26.000000', 'temperatura', 861.0000, 'ºC'),
	(49873, 112, '2015-02-01 00:44:27.000000', 'temperatura', 359.0000, 'ºC'),
	(49874, 112, '2015-02-01 00:44:28.000000', 'temperatura', 414.0000, 'ºC'),
	(49875, 112, '2015-02-01 00:44:29.000000', 'temperatura', 993.0000, 'ºC'),
	(49876, 112, '2015-02-01 00:44:30.000000', 'temperatura', 124.0000, 'ºC'),
	(49877, 112, '2015-02-01 00:44:31.000000', 'temperatura', 40.0000, 'ºC'),
	(49878, 112, '2015-02-01 00:44:32.000000', 'temperatura', 1028.0000, 'ºC'),
	(49879, 112, '2015-02-01 00:44:33.000000', 'temperatura', 224.0000, 'ºC'),
	(49880, 112, '2015-02-01 00:44:34.000000', 'temperatura', 433.0000, 'ºC'),
	(49881, 112, '2015-02-01 00:44:35.000000', 'temperatura', 293.0000, 'ºC'),
	(49882, 112, '2015-02-01 00:44:36.000000', 'temperatura', 168.0000, 'ºC'),
	(49883, 112, '2015-02-01 00:44:37.000000', 'temperatura', 1163.0000, 'ºC'),
	(49884, 112, '2015-02-01 00:44:38.000000', 'temperatura', 509.0000, 'ºC'),
	(49885, 112, '2015-02-01 00:44:39.000000', 'temperatura', 256.0000, 'ºC'),
	(49886, 112, '2015-02-01 00:44:40.000000', 'temperatura', 954.0000, 'ºC'),
	(49887, 112, '2015-02-01 00:44:41.000000', 'temperatura', 402.0000, 'ºC'),
	(49888, 112, '2015-02-01 00:44:42.000000', 'temperatura', 348.0000, 'ºC'),
	(49889, 112, '2015-02-01 00:44:43.000000', 'temperatura', 536.0000, 'ºC'),
	(49890, 112, '2015-02-01 00:44:44.000000', 'temperatura', 437.0000, 'ºC'),
	(49891, 112, '2015-02-01 00:44:45.000000', 'temperatura', 579.0000, 'ºC'),
	(49892, 112, '2015-02-01 00:44:46.000000', 'temperatura', 382.0000, 'ºC'),
	(49893, 112, '2015-02-01 00:44:47.000000', 'temperatura', 174.0000, 'ºC'),
	(49894, 112, '2015-02-01 00:44:48.000000', 'temperatura', 924.0000, 'ºC'),
	(49895, 112, '2015-02-01 00:44:49.000000', 'temperatura', 500.0000, 'ºC'),
	(49896, 112, '2015-02-01 00:44:50.000000', 'temperatura', 927.0000, 'ºC'),
	(49897, 112, '2015-02-01 00:44:51.000000', 'temperatura', 734.0000, 'ºC'),
	(49898, 112, '2015-02-01 00:44:52.000000', 'temperatura', 892.0000, 'ºC'),
	(49899, 112, '2015-02-01 00:44:53.000000', 'temperatura', 1056.0000, 'ºC'),
	(49900, 112, '2015-02-01 00:44:54.000000', 'temperatura', 207.0000, 'ºC'),
	(49901, 112, '2015-02-01 00:44:55.000000', 'temperatura', 266.0000, 'ºC'),
	(49902, 112, '2015-02-01 00:44:56.000000', 'temperatura', 710.0000, 'ºC'),
	(49903, 112, '2015-02-01 00:44:57.000000', 'temperatura', 351.0000, 'ºC'),
	(49904, 112, '2015-02-01 00:44:58.000000', 'temperatura', 826.0000, 'ºC'),
	(49905, 112, '2015-02-01 00:44:59.000000', 'temperatura', 677.0000, 'ºC'),
	(49906, 112, '2015-02-01 00:45:00.000000', 'temperatura', 909.0000, 'ºC'),
	(49907, 112, '2015-02-01 00:45:01.000000', 'temperatura', 114.0000, 'ºC'),
	(49908, 112, '2015-02-01 00:45:02.000000', 'temperatura', 245.0000, 'ºC'),
	(49909, 112, '2015-02-01 00:45:03.000000', 'temperatura', 883.0000, 'ºC'),
	(49910, 112, '2015-02-01 00:45:04.000000', 'temperatura', 79.0000, 'ºC'),
	(49911, 112, '2015-02-01 00:45:05.000000', 'temperatura', 149.0000, 'ºC'),
	(49912, 112, '2015-02-01 00:45:06.000000', 'temperatura', 506.0000, 'ºC'),
	(49913, 112, '2015-02-01 00:45:07.000000', 'temperatura', 883.0000, 'ºC'),
	(49914, 112, '2015-02-01 00:45:08.000000', 'temperatura', 498.0000, 'ºC'),
	(49915, 112, '2015-02-01 00:45:09.000000', 'temperatura', 1044.0000, 'ºC'),
	(49916, 112, '2015-02-01 00:45:10.000000', 'temperatura', 123.0000, 'ºC'),
	(49917, 112, '2015-02-01 00:45:11.000000', 'temperatura', 1087.0000, 'ºC'),
	(49918, 112, '2015-02-01 00:45:12.000000', 'temperatura', 263.0000, 'ºC'),
	(49919, 112, '2015-02-01 00:45:13.000000', 'temperatura', 456.0000, 'ºC'),
	(49920, 112, '2015-02-01 00:45:14.000000', 'temperatura', 292.0000, 'ºC'),
	(49921, 112, '2015-02-01 00:45:15.000000', 'temperatura', 94.0000, 'ºC'),
	(49922, 112, '2015-02-01 00:45:16.000000', 'temperatura', 793.0000, 'ºC'),
	(49923, 112, '2015-02-01 00:45:17.000000', 'temperatura', 85.0000, 'ºC'),
	(49924, 112, '2015-02-01 00:45:18.000000', 'temperatura', 447.0000, 'ºC'),
	(49925, 112, '2015-02-01 00:45:19.000000', 'temperatura', 781.0000, 'ºC'),
	(49926, 112, '2015-02-01 00:45:20.000000', 'temperatura', 165.0000, 'ºC'),
	(49927, 112, '2015-02-01 00:45:21.000000', 'temperatura', 883.0000, 'ºC'),
	(49928, 112, '2015-02-01 00:45:22.000000', 'temperatura', 317.0000, 'ºC'),
	(49929, 112, '2015-02-01 00:45:23.000000', 'temperatura', 140.0000, 'ºC'),
	(49930, 112, '2015-02-01 00:45:24.000000', 'temperatura', 949.0000, 'ºC'),
	(49931, 112, '2015-02-01 00:45:25.000000', 'temperatura', 726.0000, 'ºC'),
	(49932, 112, '2015-02-01 00:45:26.000000', 'temperatura', 781.0000, 'ºC'),
	(49933, 112, '2015-02-01 00:45:27.000000', 'temperatura', 527.0000, 'ºC'),
	(49934, 112, '2015-02-01 00:45:28.000000', 'temperatura', 296.0000, 'ºC'),
	(49935, 112, '2015-02-01 00:45:29.000000', 'temperatura', 1096.0000, 'ºC'),
	(49936, 112, '2015-02-01 00:45:30.000000', 'temperatura', 993.0000, 'ºC'),
	(49937, 112, '2015-02-01 00:45:31.000000', 'temperatura', 480.0000, 'ºC'),
	(49938, 112, '2015-02-01 00:45:32.000000', 'temperatura', 620.0000, 'ºC'),
	(49939, 112, '2015-02-01 00:45:33.000000', 'temperatura', 462.0000, 'ºC'),
	(49940, 112, '2015-02-01 00:45:34.000000', 'temperatura', 449.0000, 'ºC'),
	(49941, 112, '2015-02-01 00:45:35.000000', 'temperatura', 860.0000, 'ºC'),
	(49942, 112, '2015-02-01 00:45:36.000000', 'temperatura', 552.0000, 'ºC'),
	(49943, 112, '2015-02-01 00:45:37.000000', 'temperatura', 183.0000, 'ºC'),
	(49944, 112, '2015-02-01 00:45:38.000000', 'temperatura', 457.0000, 'ºC'),
	(49945, 112, '2015-02-01 00:45:39.000000', 'temperatura', 538.0000, 'ºC'),
	(49946, 112, '2015-02-01 00:45:40.000000', 'temperatura', 118.0000, 'ºC'),
	(49947, 112, '2015-02-01 00:45:41.000000', 'temperatura', 179.0000, 'ºC'),
	(49948, 112, '2015-02-01 00:45:42.000000', 'temperatura', 539.0000, 'ºC'),
	(49949, 112, '2015-02-01 00:45:43.000000', 'temperatura', 959.0000, 'ºC'),
	(49950, 112, '2015-02-01 00:45:44.000000', 'temperatura', 779.0000, 'ºC'),
	(49951, 112, '2015-02-01 00:45:45.000000', 'temperatura', 1018.0000, 'ºC'),
	(49952, 112, '2015-02-01 00:45:46.000000', 'temperatura', 356.0000, 'ºC'),
	(49953, 112, '2015-02-01 00:45:47.000000', 'temperatura', 1123.0000, 'ºC'),
	(49954, 112, '2015-02-01 00:45:48.000000', 'temperatura', 949.0000, 'ºC'),
	(49955, 112, '2015-02-01 00:45:49.000000', 'temperatura', 178.0000, 'ºC'),
	(49956, 112, '2015-02-01 00:45:50.000000', 'temperatura', 440.0000, 'ºC'),
	(49957, 112, '2015-02-01 00:45:51.000000', 'temperatura', 469.0000, 'ºC'),
	(49958, 112, '2015-02-01 00:45:52.000000', 'temperatura', 1026.0000, 'ºC'),
	(49959, 112, '2015-02-01 00:45:53.000000', 'temperatura', 124.0000, 'ºC'),
	(49960, 112, '2015-02-01 00:45:54.000000', 'temperatura', 1142.0000, 'ºC'),
	(49961, 112, '2015-02-01 00:45:55.000000', 'temperatura', 537.0000, 'ºC'),
	(49962, 112, '2015-02-01 00:45:56.000000', 'temperatura', 461.0000, 'ºC'),
	(49963, 112, '2015-02-01 00:45:57.000000', 'temperatura', 693.0000, 'ºC'),
	(49964, 112, '2015-02-01 00:45:58.000000', 'temperatura', 882.0000, 'ºC'),
	(49965, 112, '2015-02-01 00:45:59.000000', 'temperatura', 1133.0000, 'ºC'),
	(49966, 112, '2015-02-01 00:46:00.000000', 'temperatura', 618.0000, 'ºC'),
	(49967, 112, '2015-02-01 00:46:01.000000', 'temperatura', 891.0000, 'ºC'),
	(49968, 112, '2015-02-01 00:46:02.000000', 'temperatura', 202.0000, 'ºC'),
	(49969, 112, '2015-02-01 00:46:03.000000', 'temperatura', 736.0000, 'ºC'),
	(49970, 112, '2015-02-01 00:46:04.000000', 'temperatura', 675.0000, 'ºC'),
	(49971, 112, '2015-02-01 00:46:05.000000', 'temperatura', 1167.0000, 'ºC'),
	(49972, 112, '2015-02-01 00:46:06.000000', 'temperatura', 212.0000, 'ºC'),
	(49973, 112, '2015-02-01 00:46:07.000000', 'temperatura', 1161.0000, 'ºC'),
	(49974, 112, '2015-02-01 00:46:08.000000', 'temperatura', 368.0000, 'ºC'),
	(49975, 112, '2015-02-01 00:46:09.000000', 'temperatura', 758.0000, 'ºC'),
	(49976, 112, '2015-02-01 00:46:10.000000', 'temperatura', 286.0000, 'ºC'),
	(49977, 112, '2015-02-01 00:46:11.000000', 'temperatura', 357.0000, 'ºC'),
	(49978, 112, '2015-02-01 00:46:12.000000', 'temperatura', 927.0000, 'ºC'),
	(49979, 112, '2015-02-01 00:46:13.000000', 'temperatura', 1167.0000, 'ºC'),
	(49980, 112, '2015-02-01 00:46:14.000000', 'temperatura', 652.0000, 'ºC'),
	(49981, 112, '2015-02-01 00:46:15.000000', 'temperatura', 959.0000, 'ºC'),
	(49982, 112, '2015-02-01 00:46:16.000000', 'temperatura', 439.0000, 'ºC'),
	(49983, 112, '2015-02-01 00:46:17.000000', 'temperatura', 520.0000, 'ºC'),
	(49984, 112, '2015-02-01 00:46:18.000000', 'temperatura', 84.0000, 'ºC'),
	(49985, 112, '2015-02-01 00:46:19.000000', 'temperatura', 61.0000, 'ºC'),
	(49986, 112, '2015-02-01 00:46:20.000000', 'temperatura', 52.0000, 'ºC'),
	(49987, 112, '2015-02-01 00:46:21.000000', 'temperatura', 79.0000, 'ºC'),
	(49988, 112, '2015-02-01 00:46:22.000000', 'temperatura', 239.0000, 'ºC'),
	(49989, 112, '2015-02-01 00:46:23.000000', 'temperatura', 960.0000, 'ºC'),
	(49990, 112, '2015-02-01 00:46:24.000000', 'temperatura', 481.0000, 'ºC'),
	(49991, 112, '2015-02-01 00:46:25.000000', 'temperatura', 726.0000, 'ºC'),
	(49992, 112, '2015-02-01 00:46:26.000000', 'temperatura', 986.0000, 'ºC'),
	(49993, 112, '2015-02-01 00:46:27.000000', 'temperatura', 353.0000, 'ºC'),
	(49994, 112, '2015-02-01 00:46:28.000000', 'temperatura', 8.0000, 'ºC'),
	(49995, 112, '2015-02-01 00:46:29.000000', 'temperatura', 183.0000, 'ºC'),
	(49996, 112, '2015-02-01 00:46:30.000000', 'temperatura', 889.0000, 'ºC'),
	(49997, 112, '2015-02-01 00:46:31.000000', 'temperatura', 296.0000, 'ºC'),
	(49998, 112, '2015-02-01 00:46:32.000000', 'temperatura', 15.0000, 'ºC'),
	(49999, 112, '2015-02-01 00:46:33.000000', 'temperatura', 388.0000, 'ºC'),
	(50000, 112, '2015-02-01 00:46:34.000000', 'temperatura', 693.0000, 'ºC'),
	(50001, 112, '2015-02-01 00:46:35.000000', 'temperatura', 1103.0000, 'ºC'),
	(50002, 112, '2015-02-01 00:46:36.000000', 'temperatura', 1036.0000, 'ºC'),
	(50003, 112, '2015-02-01 00:46:37.000000', 'temperatura', 671.0000, 'ºC'),
	(50004, 112, '2015-02-01 00:46:38.000000', 'temperatura', 247.0000, 'ºC'),
	(50005, 112, '2015-02-01 00:46:39.000000', 'temperatura', 425.0000, 'ºC'),
	(50006, 112, '2015-02-01 00:46:40.000000', 'temperatura', 183.0000, 'ºC'),
	(50007, 112, '2015-02-01 00:46:41.000000', 'temperatura', 843.0000, 'ºC'),
	(50008, 112, '2015-02-01 00:46:42.000000', 'temperatura', 64.0000, 'ºC'),
	(50009, 112, '2015-02-01 00:46:43.000000', 'temperatura', 190.0000, 'ºC'),
	(50010, 112, '2015-02-01 00:46:44.000000', 'temperatura', 760.0000, 'ºC'),
	(50011, 112, '2015-02-01 00:46:45.000000', 'temperatura', 831.0000, 'ºC'),
	(50012, 112, '2015-02-01 00:46:46.000000', 'temperatura', 674.0000, 'ºC'),
	(50013, 112, '2015-02-01 00:46:47.000000', 'temperatura', 879.0000, 'ºC'),
	(50014, 112, '2015-02-01 00:46:48.000000', 'temperatura', 1172.0000, 'ºC'),
	(50015, 112, '2015-02-01 00:46:49.000000', 'temperatura', 823.0000, 'ºC'),
	(50016, 112, '2015-02-01 00:46:50.000000', 'temperatura', 602.0000, 'ºC'),
	(50017, 112, '2015-02-01 00:46:51.000000', 'temperatura', 538.0000, 'ºC'),
	(50018, 112, '2015-02-01 00:46:52.000000', 'temperatura', 887.0000, 'ºC'),
	(50019, 112, '2015-02-01 00:46:53.000000', 'temperatura', 421.0000, 'ºC'),
	(50020, 112, '2015-02-01 00:46:54.000000', 'temperatura', 643.0000, 'ºC'),
	(50021, 112, '2015-02-01 00:46:55.000000', 'temperatura', 755.0000, 'ºC'),
	(50022, 112, '2015-02-01 00:46:56.000000', 'temperatura', 645.0000, 'ºC'),
	(50023, 112, '2015-02-01 00:46:57.000000', 'temperatura', 959.0000, 'ºC'),
	(50024, 112, '2015-02-01 00:46:58.000000', 'temperatura', 462.0000, 'ºC'),
	(50025, 112, '2015-02-01 00:46:59.000000', 'temperatura', 635.0000, 'ºC'),
	(50026, 112, '2015-02-01 00:47:00.000000', 'temperatura', 589.0000, 'ºC'),
	(50027, 112, '2015-02-01 00:47:01.000000', 'temperatura', 1040.0000, 'ºC'),
	(50028, 112, '2015-02-01 00:47:02.000000', 'temperatura', 1033.0000, 'ºC'),
	(50029, 112, '2015-02-01 00:47:03.000000', 'temperatura', 847.0000, 'ºC'),
	(50030, 112, '2015-02-01 00:47:04.000000', 'temperatura', 1136.0000, 'ºC'),
	(50031, 112, '2015-02-01 00:47:05.000000', 'temperatura', 741.0000, 'ºC'),
	(50032, 112, '2015-02-01 00:47:06.000000', 'temperatura', 295.0000, 'ºC'),
	(50033, 112, '2015-02-01 00:47:07.000000', 'temperatura', 454.0000, 'ºC'),
	(50034, 112, '2015-02-01 00:47:08.000000', 'temperatura', 185.0000, 'ºC'),
	(50035, 112, '2015-02-01 00:47:09.000000', 'temperatura', 762.0000, 'ºC'),
	(50036, 112, '2015-02-01 00:47:10.000000', 'temperatura', 858.0000, 'ºC'),
	(50037, 112, '2015-02-01 00:47:11.000000', 'temperatura', 801.0000, 'ºC'),
	(50038, 112, '2015-02-01 00:47:12.000000', 'temperatura', 235.0000, 'ºC'),
	(50039, 112, '2015-02-01 00:47:13.000000', 'temperatura', 1172.0000, 'ºC'),
	(50040, 112, '2015-02-01 00:47:14.000000', 'temperatura', 357.0000, 'ºC'),
	(50041, 112, '2015-02-01 00:47:15.000000', 'temperatura', 667.0000, 'ºC'),
	(50042, 112, '2015-02-01 00:47:16.000000', 'temperatura', 1066.0000, 'ºC'),
	(50043, 112, '2015-02-01 00:47:17.000000', 'temperatura', 927.0000, 'ºC'),
	(50044, 112, '2015-02-01 00:47:18.000000', 'temperatura', 240.0000, 'ºC'),
	(50045, 112, '2015-02-01 00:47:19.000000', 'temperatura', 820.0000, 'ºC'),
	(50046, 112, '2015-02-01 00:47:20.000000', 'temperatura', 979.0000, 'ºC'),
	(50047, 112, '2015-02-01 00:47:21.000000', 'temperatura', 35.0000, 'ºC'),
	(50048, 112, '2015-02-01 00:47:22.000000', 'temperatura', 838.0000, 'ºC'),
	(50049, 112, '2015-02-01 00:47:23.000000', 'temperatura', 487.0000, 'ºC'),
	(50050, 112, '2015-02-01 00:47:24.000000', 'temperatura', 1120.0000, 'ºC'),
	(50051, 112, '2015-02-01 00:47:25.000000', 'temperatura', 542.0000, 'ºC'),
	(50052, 112, '2015-02-01 00:47:26.000000', 'temperatura', 548.0000, 'ºC'),
	(50053, 112, '2015-02-01 00:47:27.000000', 'temperatura', 1113.0000, 'ºC'),
	(50054, 112, '2015-02-01 00:47:28.000000', 'temperatura', 324.0000, 'ºC'),
	(50055, 112, '2015-02-01 00:47:29.000000', 'temperatura', 683.0000, 'ºC'),
	(50056, 112, '2015-02-01 00:47:30.000000', 'temperatura', 41.0000, 'ºC'),
	(50057, 112, '2015-02-01 00:47:31.000000', 'temperatura', 557.0000, 'ºC'),
	(50058, 112, '2015-02-01 00:47:32.000000', 'temperatura', 264.0000, 'ºC'),
	(50059, 112, '2015-02-01 00:47:33.000000', 'temperatura', 850.0000, 'ºC'),
	(50060, 112, '2015-02-01 00:47:34.000000', 'temperatura', 1056.0000, 'ºC'),
	(50061, 112, '2015-02-01 00:47:35.000000', 'temperatura', 333.0000, 'ºC'),
	(50062, 112, '2015-02-01 00:47:36.000000', 'temperatura', 896.0000, 'ºC'),
	(50063, 112, '2015-02-01 00:47:37.000000', 'temperatura', 1084.0000, 'ºC'),
	(50064, 112, '2015-02-01 00:47:38.000000', 'temperatura', 331.0000, 'ºC'),
	(50065, 112, '2015-02-01 00:47:39.000000', 'temperatura', 803.0000, 'ºC'),
	(50066, 112, '2015-02-01 00:47:40.000000', 'temperatura', 623.0000, 'ºC'),
	(50067, 112, '2015-02-01 00:47:41.000000', 'temperatura', 706.0000, 'ºC'),
	(50068, 112, '2015-02-01 00:47:42.000000', 'temperatura', 462.0000, 'ºC'),
	(50069, 112, '2015-02-01 00:47:43.000000', 'temperatura', 192.0000, 'ºC'),
	(50070, 112, '2015-02-01 00:47:44.000000', 'temperatura', 774.0000, 'ºC'),
	(50071, 112, '2015-02-01 00:47:45.000000', 'temperatura', 895.0000, 'ºC'),
	(50072, 112, '2015-02-01 00:47:46.000000', 'temperatura', 954.0000, 'ºC'),
	(50073, 112, '2015-02-01 00:47:47.000000', 'temperatura', 885.0000, 'ºC'),
	(50074, 112, '2015-02-01 00:47:48.000000', 'temperatura', 366.0000, 'ºC'),
	(50075, 112, '2015-02-01 00:47:49.000000', 'temperatura', 372.0000, 'ºC'),
	(50076, 112, '2015-02-01 00:47:50.000000', 'temperatura', 764.0000, 'ºC'),
	(50077, 112, '2015-02-01 00:47:51.000000', 'temperatura', 303.0000, 'ºC'),
	(50078, 112, '2015-02-01 00:47:52.000000', 'temperatura', 425.0000, 'ºC'),
	(50079, 112, '2015-02-01 00:47:53.000000', 'temperatura', 17.0000, 'ºC'),
	(50080, 112, '2015-02-01 00:47:54.000000', 'temperatura', 11.0000, 'ºC'),
	(50081, 112, '2015-02-01 00:47:55.000000', 'temperatura', 3.0000, 'ºC'),
	(50082, 112, '2015-02-01 00:47:56.000000', 'temperatura', 1183.0000, 'ºC'),
	(50083, 112, '2015-02-01 00:47:57.000000', 'temperatura', 1105.0000, 'ºC'),
	(50084, 112, '2015-02-01 00:47:58.000000', 'temperatura', 779.0000, 'ºC'),
	(50085, 112, '2015-02-01 00:47:59.000000', 'temperatura', 579.0000, 'ºC'),
	(50086, 112, '2015-02-01 00:48:00.000000', 'temperatura', 557.0000, 'ºC'),
	(50087, 112, '2015-02-01 00:48:01.000000', 'temperatura', 1049.0000, 'ºC'),
	(50088, 112, '2015-02-01 00:48:02.000000', 'temperatura', 1174.0000, 'ºC'),
	(50089, 112, '2015-02-01 00:48:03.000000', 'temperatura', 325.0000, 'ºC'),
	(50090, 112, '2015-02-01 00:48:04.000000', 'temperatura', 503.0000, 'ºC'),
	(50091, 112, '2015-02-01 00:48:05.000000', 'temperatura', 339.0000, 'ºC'),
	(50092, 112, '2015-02-01 00:48:06.000000', 'temperatura', 188.0000, 'ºC'),
	(50093, 112, '2015-02-01 00:48:07.000000', 'temperatura', 1121.0000, 'ºC'),
	(50094, 112, '2015-02-01 00:48:08.000000', 'temperatura', 245.0000, 'ºC'),
	(50095, 112, '2015-02-01 00:48:09.000000', 'temperatura', 262.0000, 'ºC'),
	(50096, 112, '2015-02-01 00:48:10.000000', 'temperatura', 573.0000, 'ºC'),
	(50097, 112, '2015-02-01 00:48:11.000000', 'temperatura', 881.0000, 'ºC'),
	(50098, 112, '2015-02-01 00:48:12.000000', 'temperatura', 288.0000, 'ºC'),
	(50099, 112, '2015-02-01 00:48:13.000000', 'temperatura', 1196.0000, 'ºC'),
	(50100, 112, '2015-02-01 00:48:14.000000', 'temperatura', 318.0000, 'ºC'),
	(50101, 112, '2015-02-01 00:48:15.000000', 'temperatura', 401.0000, 'ºC'),
	(50102, 112, '2015-02-01 00:48:16.000000', 'temperatura', 1053.0000, 'ºC'),
	(50103, 112, '2015-02-01 00:48:17.000000', 'temperatura', 463.0000, 'ºC'),
	(50104, 112, '2015-02-01 00:48:18.000000', 'temperatura', 356.0000, 'ºC'),
	(50105, 112, '2015-02-01 00:48:19.000000', 'temperatura', 391.0000, 'ºC'),
	(50106, 112, '2015-02-01 00:48:20.000000', 'temperatura', 889.0000, 'ºC'),
	(50107, 112, '2015-02-01 00:48:21.000000', 'temperatura', 870.0000, 'ºC'),
	(50108, 112, '2015-02-01 00:48:22.000000', 'temperatura', 484.0000, 'ºC'),
	(50109, 112, '2015-02-01 00:48:23.000000', 'temperatura', 1010.0000, 'ºC'),
	(50110, 112, '2015-02-01 00:48:24.000000', 'temperatura', 1199.0000, 'ºC'),
	(50111, 112, '2015-02-01 00:48:25.000000', 'temperatura', 567.0000, 'ºC'),
	(50112, 112, '2015-02-01 00:48:26.000000', 'temperatura', 438.0000, 'ºC'),
	(50113, 112, '2015-02-01 00:48:27.000000', 'temperatura', 490.0000, 'ºC'),
	(50114, 112, '2015-02-01 00:48:28.000000', 'temperatura', 1138.0000, 'ºC'),
	(50115, 112, '2015-02-01 00:48:29.000000', 'temperatura', 619.0000, 'ºC'),
	(50116, 112, '2015-02-01 00:48:30.000000', 'temperatura', 883.0000, 'ºC'),
	(50117, 112, '2015-02-01 00:48:31.000000', 'temperatura', 156.0000, 'ºC'),
	(50118, 112, '2015-02-01 00:48:32.000000', 'temperatura', 534.0000, 'ºC'),
	(50119, 112, '2015-02-01 00:48:33.000000', 'temperatura', 1000.0000, 'ºC'),
	(50120, 112, '2015-02-01 00:48:34.000000', 'temperatura', 1000.0000, 'ºC'),
	(50121, 112, '2015-02-01 00:48:35.000000', 'temperatura', 798.0000, 'ºC'),
	(50122, 112, '2015-02-01 00:48:36.000000', 'temperatura', 994.0000, 'ºC'),
	(50123, 112, '2015-02-01 00:48:37.000000', 'temperatura', 173.0000, 'ºC'),
	(50124, 112, '2015-02-01 00:48:38.000000', 'temperatura', 287.0000, 'ºC'),
	(50125, 112, '2015-02-01 00:48:39.000000', 'temperatura', 915.0000, 'ºC'),
	(50126, 112, '2015-02-01 00:48:40.000000', 'temperatura', 115.0000, 'ºC'),
	(50127, 112, '2015-02-01 00:48:41.000000', 'temperatura', 231.0000, 'ºC'),
	(50128, 112, '2015-02-01 00:48:42.000000', 'temperatura', 811.0000, 'ºC'),
	(50129, 112, '2015-02-01 00:48:43.000000', 'temperatura', 962.0000, 'ºC'),
	(50130, 112, '2015-02-01 00:48:44.000000', 'temperatura', 1178.0000, 'ºC'),
	(50131, 112, '2015-02-01 00:48:45.000000', 'temperatura', 604.0000, 'ºC'),
	(50132, 112, '2015-02-01 00:48:46.000000', 'temperatura', 685.0000, 'ºC'),
	(50133, 112, '2015-02-01 00:48:47.000000', 'temperatura', 415.0000, 'ºC'),
	(50134, 112, '2015-02-01 00:48:48.000000', 'temperatura', 20.0000, 'ºC'),
	(50135, 112, '2015-02-01 00:48:49.000000', 'temperatura', 57.0000, 'ºC'),
	(50136, 112, '2015-02-01 00:48:50.000000', 'temperatura', 226.0000, 'ºC'),
	(50137, 112, '2015-02-01 00:48:51.000000', 'temperatura', 958.0000, 'ºC'),
	(50138, 112, '2015-02-01 00:48:52.000000', 'temperatura', 515.0000, 'ºC'),
	(50139, 112, '2015-02-01 00:48:53.000000', 'temperatura', 898.0000, 'ºC'),
	(50140, 112, '2015-02-01 00:48:54.000000', 'temperatura', 549.0000, 'ºC'),
	(50141, 112, '2015-02-01 00:48:55.000000', 'temperatura', 48.0000, 'ºC'),
	(50142, 112, '2015-02-01 00:48:56.000000', 'temperatura', 996.0000, 'ºC'),
	(50143, 112, '2015-02-01 00:48:57.000000', 'temperatura', 38.0000, 'ºC'),
	(50144, 112, '2015-02-01 00:48:58.000000', 'temperatura', 799.0000, 'ºC'),
	(50145, 112, '2015-02-01 00:48:59.000000', 'temperatura', 282.0000, 'ºC'),
	(50146, 112, '2015-02-01 00:49:00.000000', 'temperatura', 214.0000, 'ºC'),
	(50147, 112, '2015-02-01 00:49:01.000000', 'temperatura', 226.0000, 'ºC'),
	(50148, 112, '2015-02-01 00:49:02.000000', 'temperatura', 486.0000, 'ºC'),
	(50149, 112, '2015-02-01 00:49:03.000000', 'temperatura', 554.0000, 'ºC'),
	(50150, 112, '2015-02-01 00:49:04.000000', 'temperatura', 113.0000, 'ºC'),
	(50151, 112, '2015-02-01 00:49:05.000000', 'temperatura', 105.0000, 'ºC'),
	(50152, 112, '2015-02-01 00:49:06.000000', 'temperatura', 184.0000, 'ºC'),
	(50153, 112, '2015-02-01 00:49:07.000000', 'temperatura', 608.0000, 'ºC'),
	(50154, 112, '2015-02-01 00:49:08.000000', 'temperatura', 86.0000, 'ºC'),
	(50155, 112, '2015-02-01 00:49:09.000000', 'temperatura', 1007.0000, 'ºC'),
	(50156, 112, '2015-02-01 00:49:10.000000', 'temperatura', 1179.0000, 'ºC'),
	(50157, 112, '2015-02-01 00:49:11.000000', 'temperatura', 473.0000, 'ºC'),
	(50158, 112, '2015-02-01 00:49:12.000000', 'temperatura', 28.0000, 'ºC'),
	(50159, 112, '2015-02-01 00:49:13.000000', 'temperatura', 1123.0000, 'ºC'),
	(50160, 112, '2015-02-01 00:49:14.000000', 'temperatura', 730.0000, 'ºC'),
	(50161, 112, '2015-02-01 00:49:15.000000', 'temperatura', 282.0000, 'ºC'),
	(50162, 112, '2015-02-01 00:49:16.000000', 'temperatura', 419.0000, 'ºC'),
	(50163, 112, '2015-02-01 00:49:17.000000', 'temperatura', 52.0000, 'ºC'),
	(50164, 112, '2015-02-01 00:49:18.000000', 'temperatura', 205.0000, 'ºC'),
	(50165, 112, '2015-02-01 00:49:19.000000', 'temperatura', 866.0000, 'ºC'),
	(50166, 112, '2015-02-01 00:49:20.000000', 'temperatura', 116.0000, 'ºC'),
	(50167, 112, '2015-02-01 00:49:21.000000', 'temperatura', 382.0000, 'ºC'),
	(50168, 112, '2015-02-01 00:49:22.000000', 'temperatura', 365.0000, 'ºC'),
	(50169, 112, '2015-02-01 00:49:23.000000', 'temperatura', 676.0000, 'ºC'),
	(50170, 112, '2015-02-01 00:49:24.000000', 'temperatura', 1088.0000, 'ºC'),
	(50171, 112, '2015-02-01 00:49:25.000000', 'temperatura', 1010.0000, 'ºC'),
	(50172, 112, '2015-02-01 00:49:26.000000', 'temperatura', 589.0000, 'ºC'),
	(50173, 112, '2015-02-01 00:49:27.000000', 'temperatura', 1116.0000, 'ºC'),
	(50174, 112, '2015-02-01 00:49:28.000000', 'temperatura', 212.0000, 'ºC'),
	(50175, 112, '2015-02-01 00:49:29.000000', 'temperatura', 115.0000, 'ºC'),
	(50176, 112, '2015-02-01 00:49:30.000000', 'temperatura', 1137.0000, 'ºC'),
	(50177, 112, '2015-02-01 00:49:31.000000', 'temperatura', 540.0000, 'ºC'),
	(50178, 112, '2015-02-01 00:49:32.000000', 'temperatura', 490.0000, 'ºC'),
	(50179, 112, '2015-02-01 00:49:33.000000', 'temperatura', 832.0000, 'ºC'),
	(50180, 112, '2015-02-01 00:49:34.000000', 'temperatura', 289.0000, 'ºC'),
	(50181, 112, '2015-02-01 00:49:35.000000', 'temperatura', 151.0000, 'ºC'),
	(50182, 112, '2015-02-01 00:49:36.000000', 'temperatura', 1089.0000, 'ºC'),
	(50183, 112, '2015-02-01 00:49:37.000000', 'temperatura', 191.0000, 'ºC'),
	(50184, 112, '2015-02-01 00:49:38.000000', 'temperatura', 87.0000, 'ºC'),
	(50185, 112, '2015-02-01 00:49:39.000000', 'temperatura', 1064.0000, 'ºC'),
	(50186, 112, '2015-02-01 00:49:40.000000', 'temperatura', 261.0000, 'ºC'),
	(50187, 112, '2015-02-01 00:49:41.000000', 'temperatura', 513.0000, 'ºC'),
	(50188, 112, '2015-02-01 00:49:42.000000', 'temperatura', 581.0000, 'ºC'),
	(50189, 112, '2015-02-01 00:49:43.000000', 'temperatura', 167.0000, 'ºC'),
	(50190, 112, '2015-02-01 00:49:44.000000', 'temperatura', 291.0000, 'ºC'),
	(50191, 112, '2015-02-01 00:49:45.000000', 'temperatura', 957.0000, 'ºC'),
	(50192, 112, '2015-02-01 00:49:46.000000', 'temperatura', 312.0000, 'ºC'),
	(50193, 112, '2015-02-01 00:49:47.000000', 'temperatura', 1089.0000, 'ºC'),
	(50194, 112, '2015-02-01 00:49:48.000000', 'temperatura', 908.0000, 'ºC'),
	(50195, 112, '2015-02-01 00:49:49.000000', 'temperatura', 75.0000, 'ºC'),
	(50196, 112, '2015-02-01 00:49:50.000000', 'temperatura', 52.0000, 'ºC'),
	(50197, 112, '2015-02-01 00:49:51.000000', 'temperatura', 35.0000, 'ºC'),
	(50198, 112, '2015-02-01 00:49:52.000000', 'temperatura', 21.0000, 'ºC'),
	(50199, 112, '2015-02-01 00:49:53.000000', 'temperatura', 1199.0000, 'ºC'),
	(50200, 112, '2015-02-01 00:49:54.000000', 'temperatura', 1131.0000, 'ºC'),
	(50201, 112, '2015-02-01 00:49:55.000000', 'temperatura', 859.0000, 'ºC'),
	(50202, 112, '2015-02-01 00:49:56.000000', 'temperatura', 901.0000, 'ºC'),
	(50203, 112, '2015-02-01 00:49:57.000000', 'temperatura', 730.0000, 'ºC'),
	(50204, 112, '2015-02-01 00:49:58.000000', 'temperatura', 946.0000, 'ºC'),
	(50205, 112, '2015-02-01 00:49:59.000000', 'temperatura', 141.0000, 'ºC'),
	(50206, 112, '2015-02-01 00:50:00.000000', 'temperatura', 269.0000, 'ºC'),
	(50207, 112, '2015-02-01 00:50:01.000000', 'temperatura', 922.0000, 'ºC'),
	(50208, 112, '2015-02-01 00:50:02.000000', 'temperatura', 202.0000, 'ºC'),
	(50209, 112, '2015-02-01 00:50:03.000000', 'temperatura', 644.0000, 'ºC'),
	(50210, 112, '2015-02-01 00:50:04.000000', 'temperatura', 217.0000, 'ºC'),
	(50211, 112, '2015-02-01 00:50:05.000000', 'temperatura', 352.0000, 'ºC'),
	(50212, 112, '2015-02-01 00:50:06.000000', 'temperatura', 1109.0000, 'ºC'),
	(50213, 112, '2015-02-01 00:50:07.000000', 'temperatura', 891.0000, 'ºC'),
	(50214, 112, '2015-02-01 00:50:08.000000', 'temperatura', 1126.0000, 'ºC'),
	(50215, 112, '2015-02-01 00:50:09.000000', 'temperatura', 558.0000, 'ºC'),
	(50216, 112, '2015-02-01 00:50:10.000000', 'temperatura', 612.0000, 'ºC'),
	(50217, 112, '2015-02-01 00:50:11.000000', 'temperatura', 185.0000, 'ºC'),
	(50218, 112, '2015-02-01 00:50:12.000000', 'temperatura', 292.0000, 'ºC'),
	(50219, 112, '2015-02-01 00:50:13.000000', 'temperatura', 903.0000, 'ºC'),
	(50220, 112, '2015-02-01 00:50:14.000000', 'temperatura', 40.0000, 'ºC'),
	(50221, 112, '2015-02-01 00:50:15.000000', 'temperatura', 1090.0000, 'ºC'),
	(50222, 112, '2015-02-01 00:50:16.000000', 'temperatura', 533.0000, 'ºC'),
	(50223, 112, '2015-02-01 00:50:17.000000', 'temperatura', 595.0000, 'ºC'),
	(50224, 112, '2015-02-01 00:50:18.000000', 'temperatura', 175.0000, 'ºC'),
	(50225, 112, '2015-02-01 00:50:19.000000', 'temperatura', 293.0000, 'ºC'),
	(50226, 112, '2015-02-01 00:50:20.000000', 'temperatura', 940.0000, 'ºC'),
	(50227, 112, '2015-02-01 00:50:21.000000', 'temperatura', 222.0000, 'ºC'),
	(50228, 112, '2015-02-01 00:50:22.000000', 'temperatura', 691.0000, 'ºC'),
	(50229, 112, '2015-02-01 00:50:23.000000', 'temperatura', 389.0000, 'ºC'),
	(50230, 112, '2015-02-01 00:50:24.000000', 'temperatura', 1071.0000, 'ºC'),
	(50231, 112, '2015-02-01 00:50:25.000000', 'temperatura', 588.0000, 'ºC'),
	(50232, 112, '2015-02-01 00:50:26.000000', 'temperatura', 929.0000, 'ºC'),
	(50233, 112, '2015-02-01 00:50:27.000000', 'temperatura', 481.0000, 'ºC'),
	(50234, 112, '2015-02-01 00:50:28.000000', 'temperatura', 820.0000, 'ºC'),
	(50235, 112, '2015-02-01 00:50:29.000000', 'temperatura', 257.0000, 'ºC'),
	(50236, 112, '2015-02-01 00:50:30.000000', 'temperatura', 26.0000, 'ºC'),
	(50237, 112, '2015-02-01 00:50:31.000000', 'temperatura', 559.0000, 'ºC'),
	(50238, 112, '2015-02-01 00:50:32.000000', 'temperatura', 319.0000, 'ºC'),
	(50239, 112, '2015-02-01 00:50:33.000000', 'temperatura', 1117.0000, 'ºC'),
	(50240, 112, '2015-02-01 00:50:34.000000', 'temperatura', 1027.0000, 'ºC'),
	(50241, 112, '2015-02-01 00:50:35.000000', 'temperatura', 586.0000, 'ºC'),
	(50242, 112, '2015-02-01 00:50:36.000000', 'temperatura', 1047.0000, 'ºC'),
	(50243, 112, '2015-02-01 00:50:37.000000', 'temperatura', 1081.0000, 'ºC'),
	(50244, 112, '2015-02-01 00:50:38.000000', 'temperatura', 1063.0000, 'ºC'),
	(50245, 112, '2015-02-01 00:50:39.000000', 'temperatura', 874.0000, 'ºC'),
	(50246, 112, '2015-02-01 00:50:40.000000', 'temperatura', 1183.0000, 'ºC'),
	(50247, 112, '2015-02-01 00:50:41.000000', 'temperatura', 890.0000, 'ºC'),
	(50248, 112, '2015-02-01 00:50:42.000000', 'temperatura', 904.0000, 'ºC'),
	(50249, 112, '2015-02-01 00:50:43.000000', 'temperatura', 648.0000, 'ºC'),
	(50250, 112, '2015-02-01 00:50:44.000000', 'temperatura', 529.0000, 'ºC'),
	(50251, 112, '2015-02-01 00:50:45.000000', 'temperatura', 703.0000, 'ºC'),
	(50252, 112, '2015-02-01 00:50:46.000000', 'temperatura', 728.0000, 'ºC'),
	(50253, 112, '2015-02-01 00:50:47.000000', 'temperatura', 330.0000, 'ºC'),
	(50254, 112, '2015-02-01 00:50:48.000000', 'temperatura', 666.0000, 'ºC'),
	(50255, 112, '2015-02-01 00:50:49.000000', 'temperatura', 1140.0000, 'ºC'),
	(50256, 112, '2015-02-01 00:50:50.000000', 'temperatura', 105.0000, 'ºC'),
	(50257, 112, '2015-02-01 00:50:51.000000', 'temperatura', 705.0000, 'ºC'),
	(50258, 112, '2015-02-01 00:50:52.000000', 'temperatura', 811.0000, 'ºC'),
	(50259, 112, '2015-02-01 00:50:53.000000', 'temperatura', 741.0000, 'ºC'),
	(50260, 112, '2015-02-01 00:50:54.000000', 'temperatura', 73.0000, 'ºC'),
	(50261, 112, '2015-02-01 00:50:55.000000', 'temperatura', 541.0000, 'ºC'),
	(50262, 112, '2015-02-01 00:50:56.000000', 'temperatura', 87.0000, 'ºC'),
	(50263, 112, '2015-02-01 00:50:57.000000', 'temperatura', 14.0000, 'ºC'),
	(50264, 112, '2015-02-01 00:50:58.000000', 'temperatura', 1007.0000, 'ºC'),
	(50265, 112, '2015-02-01 00:50:59.000000', 'temperatura', 196.0000, 'ºC'),
	(50266, 112, '2015-02-01 00:51:00.000000', 'temperatura', 357.0000, 'ºC'),
	(50267, 112, '2015-02-01 00:51:01.000000', 'temperatura', 1199.0000, 'ºC'),
	(50268, 112, '2015-02-01 00:51:02.000000', 'temperatura', 126.0000, 'ºC'),
	(50269, 112, '2015-02-01 00:51:03.000000', 'temperatura', 632.0000, 'ºC'),
	(50270, 112, '2015-02-01 00:51:04.000000', 'temperatura', 384.0000, 'ºC'),
	(50271, 112, '2015-02-01 00:51:05.000000', 'temperatura', 22.0000, 'ºC'),
	(50272, 112, '2015-02-01 00:51:06.000000', 'temperatura', 158.0000, 'ºC'),
	(50273, 112, '2015-02-01 00:51:07.000000', 'temperatura', 727.0000, 'ºC'),
	(50274, 112, '2015-02-01 00:51:08.000000', 'temperatura', 761.0000, 'ºC'),
	(50275, 112, '2015-02-01 00:51:09.000000', 'temperatura', 422.0000, 'ºC'),
	(50276, 112, '2015-02-01 00:51:10.000000', 'temperatura', 1030.0000, 'ºC'),
	(50277, 112, '2015-02-01 00:51:11.000000', 'temperatura', 284.0000, 'ºC'),
	(50278, 112, '2015-02-01 00:51:12.000000', 'temperatura', 732.0000, 'ºC'),
	(50279, 112, '2015-02-01 00:51:13.000000', 'temperatura', 407.0000, 'ºC'),
	(50280, 112, '2015-02-01 00:51:14.000000', 'temperatura', 1040.0000, 'ºC'),
	(50281, 112, '2015-02-01 00:51:15.000000', 'temperatura', 381.0000, 'ºC'),
	(50282, 112, '2015-02-01 00:51:16.000000', 'temperatura', 1183.0000, 'ºC'),
	(50283, 112, '2015-02-01 00:51:17.000000', 'temperatura', 1172.0000, 'ºC'),
	(50284, 112, '2015-02-01 00:51:18.000000', 'temperatura', 1114.0000, 'ºC'),
	(50285, 112, '2015-02-01 00:51:19.000000', 'temperatura', 853.0000, 'ºC'),
	(50286, 112, '2015-02-01 00:51:20.000000', 'temperatura', 923.0000, 'ºC'),
	(50287, 112, '2015-02-01 00:51:21.000000', 'temperatura', 859.0000, 'ºC'),
	(50288, 112, '2015-02-01 00:51:22.000000', 'temperatura', 323.0000, 'ºC'),
	(50289, 112, '2015-02-01 00:51:23.000000', 'temperatura', 242.0000, 'ºC'),
	(50290, 112, '2015-02-01 00:51:24.000000', 'temperatura', 240.0000, 'ºC'),
	(50291, 112, '2015-02-01 00:51:25.000000', 'temperatura', 475.0000, 'ºC'),
	(50292, 112, '2015-02-01 00:51:26.000000', 'temperatura', 455.0000, 'ºC'),
	(50293, 112, '2015-02-01 00:51:27.000000', 'temperatura', 851.0000, 'ºC'),
	(50294, 112, '2015-02-01 00:51:28.000000', 'temperatura', 491.0000, 'ºC'),
	(50295, 112, '2015-02-01 00:51:29.000000', 'temperatura', 1104.0000, 'ºC'),
	(50296, 112, '2015-02-01 00:51:30.000000', 'temperatura', 445.0000, 'ºC'),
	(50297, 112, '2015-02-01 00:51:31.000000', 'temperatura', 113.0000, 'ºC'),
	(50298, 112, '2015-02-01 00:51:32.000000', 'temperatura', 430.0000, 'ºC'),
	(50299, 112, '2015-02-01 00:51:33.000000', 'temperatura', 614.0000, 'ºC'),
	(50300, 112, '2015-02-01 00:51:34.000000', 'temperatura', 579.0000, 'ºC'),
	(50301, 112, '2015-02-01 00:51:35.000000', 'temperatura', 1055.0000, 'ºC'),
	(50302, 112, '2015-02-01 00:51:36.000000', 'temperatura', 1138.0000, 'ºC'),
	(50303, 112, '2015-02-01 00:51:37.000000', 'temperatura', 127.0000, 'ºC'),
	(50304, 112, '2015-02-01 00:51:38.000000', 'temperatura', 822.0000, 'ºC'),
	(50305, 112, '2015-02-01 00:51:39.000000', 'temperatura', 129.0000, 'ºC'),
	(50306, 112, '2015-02-01 00:51:40.000000', 'temperatura', 577.0000, 'ºC'),
	(50307, 112, '2015-02-01 00:51:41.000000', 'temperatura', 101.0000, 'ºC'),
	(50308, 112, '2015-02-01 00:51:42.000000', 'temperatura', 1174.0000, 'ºC'),
	(50309, 112, '2015-02-01 00:51:43.000000', 'temperatura', 766.0000, 'ºC'),
	(50310, 112, '2015-02-01 00:51:44.000000', 'temperatura', 311.0000, 'ºC'),
	(50311, 112, '2015-02-01 00:51:45.000000', 'temperatura', 455.0000, 'ºC'),
	(50312, 112, '2015-02-01 00:51:46.000000', 'temperatura', 144.0000, 'ºC'),
	(50313, 112, '2015-02-01 00:51:47.000000', 'temperatura', 556.0000, 'ºC'),
	(50314, 112, '2015-02-01 00:51:48.000000', 'temperatura', 1150.0000, 'ºC'),
	(50315, 112, '2015-02-01 00:51:49.000000', 'temperatura', 479.0000, 'ºC'),
	(50316, 112, '2015-02-01 00:51:50.000000', 'temperatura', 148.0000, 'ºC'),
	(50317, 112, '2015-02-01 00:51:51.000000', 'temperatura', 505.0000, 'ºC'),
	(50318, 112, '2015-02-01 00:51:52.000000', 'temperatura', 878.0000, 'ºC'),
	(50319, 112, '2015-02-01 00:51:53.000000', 'temperatura', 478.0000, 'ºC'),
	(50320, 112, '2015-02-01 00:51:54.000000', 'temperatura', 954.0000, 'ºC'),
	(50321, 112, '2015-02-01 00:51:55.000000', 'temperatura', 939.0000, 'ºC'),
	(50322, 112, '2015-02-01 00:51:56.000000', 'temperatura', 632.0000, 'ºC'),
	(50323, 112, '2015-02-01 00:51:57.000000', 'temperatura', 346.0000, 'ºC'),
	(50324, 112, '2015-02-01 00:51:58.000000', 'temperatura', 1032.0000, 'ºC'),
	(50325, 112, '2015-02-01 00:51:59.000000', 'temperatura', 522.0000, 'ºC'),
	(50326, 112, '2015-02-01 00:52:00.000000', 'temperatura', 714.0000, 'ºC'),
	(50327, 112, '2015-02-01 00:52:01.000000', 'temperatura', 807.0000, 'ºC'),
	(50328, 112, '2015-02-01 00:52:02.000000', 'temperatura', 691.0000, 'ºC'),
	(50329, 112, '2015-02-01 00:52:03.000000', 'temperatura', 1035.0000, 'ºC'),
	(50330, 112, '2015-02-01 00:52:04.000000', 'temperatura', 701.0000, 'ºC'),
	(50331, 112, '2015-02-01 00:52:05.000000', 'temperatura', 404.0000, 'ºC'),
	(50332, 112, '2015-02-01 00:52:06.000000', 'temperatura', 1115.0000, 'ºC'),
	(50333, 112, '2015-02-01 00:52:07.000000', 'temperatura', 762.0000, 'ºC'),
	(50334, 112, '2015-02-01 00:52:08.000000', 'temperatura', 468.0000, 'ºC'),
	(50335, 112, '2015-02-01 00:52:09.000000', 'temperatura', 54.0000, 'ºC'),
	(50336, 112, '2015-02-01 00:52:10.000000', 'temperatura', 66.0000, 'ºC'),
	(50337, 112, '2015-02-01 00:52:11.000000', 'temperatura', 167.0000, 'ºC'),
	(50338, 112, '2015-02-01 00:52:12.000000', 'temperatura', 641.0000, 'ºC'),
	(50339, 112, '2015-02-01 00:52:13.000000', 'temperatura', 301.0000, 'ºC'),
	(50340, 112, '2015-02-01 00:52:14.000000', 'temperatura', 785.0000, 'ºC'),
	(50341, 112, '2015-02-01 00:52:15.000000', 'temperatura', 620.0000, 'ºC'),
	(50342, 112, '2015-02-01 00:52:16.000000', 'temperatura', 746.0000, 'ºC'),
	(50343, 112, '2015-02-01 00:52:17.000000', 'temperatura', 672.0000, 'ºC'),
	(50344, 112, '2015-02-01 00:52:18.000000', 'temperatura', 1120.0000, 'ºC'),
	(50345, 112, '2015-02-01 00:52:19.000000', 'temperatura', 1186.0000, 'ºC'),
	(50346, 112, '2015-02-01 00:52:20.000000', 'temperatura', 171.0000, 'ºC'),
	(50347, 112, '2015-02-01 00:52:21.000000', 'temperatura', 899.0000, 'ºC'),
	(50348, 112, '2015-02-01 00:52:22.000000', 'temperatura', 381.0000, 'ºC'),
	(50349, 112, '2015-02-01 00:52:23.000000', 'temperatura', 409.0000, 'ºC'),
	(50350, 112, '2015-02-01 00:52:24.000000', 'temperatura', 900.0000, 'ºC'),
	(50351, 112, '2015-02-01 00:52:25.000000', 'temperatura', 875.0000, 'ºC'),
	(50352, 112, '2015-02-01 00:52:26.000000', 'temperatura', 478.0000, 'ºC'),
	(50353, 112, '2015-02-01 00:52:27.000000', 'temperatura', 962.0000, 'ºC'),
	(50354, 112, '2015-02-01 00:52:28.000000', 'temperatura', 979.0000, 'ºC'),
	(50355, 112, '2015-02-01 00:52:29.000000', 'temperatura', 807.0000, 'ºC'),
	(50356, 112, '2015-02-01 00:52:30.000000', 'temperatura', 1101.0000, 'ºC'),
	(50357, 112, '2015-02-01 00:52:31.000000', 'temperatura', 684.0000, 'ºC'),
	(50358, 112, '2015-02-01 00:52:32.000000', 'temperatura', 117.0000, 'ºC'),
	(50359, 112, '2015-02-01 00:52:33.000000', 'temperatura', 935.0000, 'ºC'),
	(50360, 112, '2015-02-01 00:52:34.000000', 'temperatura', 722.0000, 'ºC'),
	(50361, 112, '2015-02-01 00:52:35.000000', 'temperatura', 808.0000, 'ºC'),
	(50362, 112, '2015-02-01 00:52:36.000000', 'temperatura', 676.0000, 'ºC'),
	(50363, 112, '2015-02-01 00:52:37.000000', 'temperatura', 953.0000, 'ºC'),
	(50364, 112, '2015-02-01 00:52:38.000000', 'temperatura', 339.0000, 'ºC'),
	(50365, 112, '2015-02-01 00:52:39.000000', 'temperatura', 37.0000, 'ºC'),
	(50366, 112, '2015-02-01 00:52:40.000000', 'temperatura', 368.0000, 'ºC'),
	(50367, 112, '2015-02-01 00:52:41.000000', 'temperatura', 527.0000, 'ºC'),
	(50368, 112, '2015-02-01 00:52:42.000000', 'temperatura', 335.0000, 'ºC'),
	(50369, 112, '2015-02-01 00:52:43.000000', 'temperatura', 95.0000, 'ºC'),
	(50370, 112, '2015-02-01 00:52:44.000000', 'temperatura', 667.0000, 'ºC'),
	(50371, 112, '2015-02-01 00:52:45.000000', 'temperatura', 653.0000, 'ºC'),
	(50372, 112, '2015-02-01 00:52:46.000000', 'temperatura', 63.0000, 'ºC'),
	(50373, 112, '2015-02-01 00:52:47.000000', 'temperatura', 758.0000, 'ºC'),
	(50374, 112, '2015-02-01 00:52:48.000000', 'temperatura', 3.0000, 'ºC'),
	(50375, 112, '2015-02-01 00:52:49.000000', 'temperatura', 139.0000, 'ºC'),
	(50376, 112, '2015-02-01 00:52:50.000000', 'temperatura', 687.0000, 'ºC'),
	(50377, 112, '2015-02-01 00:52:51.000000', 'temperatura', 620.0000, 'ºC'),
	(50378, 112, '2015-02-01 00:52:52.000000', 'temperatura', 1039.0000, 'ºC'),
	(50379, 112, '2015-02-01 00:52:53.000000', 'temperatura', 933.0000, 'ºC'),
	(50380, 112, '2015-02-01 00:52:54.000000', 'temperatura', 351.0000, 'ºC'),
	(50381, 112, '2015-02-01 00:52:55.000000', 'temperatura', 154.0000, 'ºC'),
	(50382, 112, '2015-02-01 00:52:56.000000', 'temperatura', 919.0000, 'ºC'),
	(50383, 112, '2015-02-01 00:52:57.000000', 'temperatura', 534.0000, 'ºC'),
	(50384, 112, '2015-02-01 00:52:58.000000', 'temperatura', 1114.0000, 'ºC'),
	(50385, 112, '2015-02-01 00:52:59.000000', 'temperatura', 367.0000, 'ºC'),
	(50386, 112, '2015-02-01 00:53:00.000000', 'temperatura', 896.0000, 'ºC'),
	(50387, 112, '2015-02-01 00:53:01.000000', 'temperatura', 979.0000, 'ºC'),
	(50388, 112, '2015-02-01 00:53:02.000000', 'temperatura', 1006.0000, 'ºC'),
	(50389, 112, '2015-02-01 00:53:03.000000', 'temperatura', 894.0000, 'ºC'),
	(50390, 112, '2015-02-01 00:53:04.000000', 'temperatura', 253.0000, 'ºC'),
	(50391, 112, '2015-02-01 00:53:05.000000', 'temperatura', 981.0000, 'ºC'),
	(50392, 112, '2015-02-01 00:53:06.000000', 'temperatura', 549.0000, 'ºC'),
	(50393, 112, '2015-02-01 00:53:07.000000', 'temperatura', 1001.0000, 'ºC'),
	(50394, 112, '2015-02-01 00:53:08.000000', 'temperatura', 958.0000, 'ºC'),
	(50395, 112, '2015-02-01 00:53:09.000000', 'temperatura', 587.0000, 'ºC'),
	(50396, 112, '2015-02-01 00:53:10.000000', 'temperatura', 60.0000, 'ºC'),
	(50397, 112, '2015-02-01 00:53:11.000000', 'temperatura', 943.0000, 'ºC'),
	(50398, 112, '2015-02-01 00:53:12.000000', 'temperatura', 934.0000, 'ºC'),
	(50399, 112, '2015-02-01 00:53:13.000000', 'temperatura', 640.0000, 'ºC'),
	(50400, 112, '2015-02-01 00:53:14.000000', 'temperatura', 399.0000, 'ºC'),
	(50401, 112, '2015-02-01 00:53:15.000000', 'temperatura', 74.0000, 'ºC'),
	(50402, 112, '2015-02-01 00:53:16.000000', 'temperatura', 376.0000, 'ºC'),
	(50403, 112, '2015-02-01 00:53:17.000000', 'temperatura', 460.0000, 'ºC'),
	(50404, 112, '2015-02-01 00:53:18.000000', 'temperatura', 1170.0000, 'ºC'),
	(50405, 112, '2015-02-01 00:53:19.000000', 'temperatura', 871.0000, 'ºC'),
	(50406, 112, '2015-02-01 00:53:20.000000', 'temperatura', 844.0000, 'ºC'),
	(50407, 112, '2015-02-01 00:53:21.000000', 'temperatura', 408.0000, 'ºC'),
	(50408, 112, '2015-02-01 00:53:22.000000', 'temperatura', 708.0000, 'ºC'),
	(50409, 112, '2015-02-01 00:53:23.000000', 'temperatura', 1117.0000, 'ºC'),
	(50410, 112, '2015-02-01 00:53:24.000000', 'temperatura', 1060.0000, 'ºC'),
	(50411, 112, '2015-02-01 00:53:25.000000', 'temperatura', 752.0000, 'ºC'),
	(50412, 112, '2015-02-01 00:53:26.000000', 'temperatura', 578.0000, 'ºC'),
	(50413, 112, '2015-02-01 00:53:27.000000', 'temperatura', 634.0000, 'ºC'),
	(50414, 112, '2015-02-01 00:53:28.000000', 'temperatura', 239.0000, 'ºC'),
	(50415, 112, '2015-02-01 00:53:29.000000', 'temperatura', 495.0000, 'ºC'),
	(50416, 112, '2015-02-01 00:53:30.000000', 'temperatura', 555.0000, 'ºC'),
	(50417, 112, '2015-02-01 00:53:31.000000', 'temperatura', 92.0000, 'ºC'),
	(50418, 112, '2015-02-01 00:53:32.000000', 'temperatura', 1197.0000, 'ºC'),
	(50419, 112, '2015-02-01 00:53:33.000000', 'temperatura', 908.0000, 'ºC'),
	(50420, 112, '2015-02-01 00:53:34.000000', 'temperatura', 948.0000, 'ºC'),
	(50421, 112, '2015-02-01 00:53:35.000000', 'temperatura', 818.0000, 'ºC'),
	(50422, 112, '2015-02-01 00:53:36.000000', 'temperatura', 45.0000, 'ºC'),
	(50423, 112, '2015-02-01 00:53:37.000000', 'temperatura', 174.0000, 'ºC'),
	(50424, 112, '2015-02-01 00:53:38.000000', 'temperatura', 733.0000, 'ºC'),
	(50425, 112, '2015-02-01 00:53:39.000000', 'temperatura', 747.0000, 'ºC'),
	(50426, 112, '2015-02-01 00:53:40.000000', 'temperatura', 333.0000, 'ºC'),
	(50427, 112, '2015-02-01 00:53:41.000000', 'temperatura', 626.0000, 'ºC'),
	(50428, 112, '2015-02-01 00:53:42.000000', 'temperatura', 931.0000, 'ºC'),
	(50429, 112, '2015-02-01 00:53:43.000000', 'temperatura', 378.0000, 'ºC'),
	(50430, 112, '2015-02-01 00:53:44.000000', 'temperatura', 298.0000, 'ºC'),
	(50431, 112, '2015-02-01 00:53:45.000000', 'temperatura', 356.0000, 'ºC'),
	(50432, 112, '2015-02-01 00:53:46.000000', 'temperatura', 885.0000, 'ºC'),
	(50433, 112, '2015-02-01 00:53:47.000000', 'temperatura', 957.0000, 'ºC'),
	(50434, 112, '2015-02-01 00:53:48.000000', 'temperatura', 931.0000, 'ºC'),
	(50435, 112, '2015-02-01 00:53:49.000000', 'temperatura', 586.0000, 'ºC'),
	(50436, 112, '2015-02-01 00:53:50.000000', 'temperatura', 139.0000, 'ºC'),
	(50437, 112, '2015-02-01 00:53:51.000000', 'temperatura', 135.0000, 'ºC'),
	(50438, 112, '2015-02-01 00:53:52.000000', 'temperatura', 259.0000, 'ºC'),
	(50439, 112, '2015-02-01 00:53:53.000000', 'temperatura', 892.0000, 'ºC'),
	(50440, 112, '2015-02-01 00:53:54.000000', 'temperatura', 84.0000, 'ºC'),
	(50441, 112, '2015-02-01 00:53:55.000000', 'temperatura', 145.0000, 'ºC'),
	(50442, 112, '2015-02-01 00:53:56.000000', 'temperatura', 472.0000, 'ºC'),
	(50443, 112, '2015-02-01 00:53:57.000000', 'temperatura', 726.0000, 'ºC'),
	(50444, 112, '2015-02-01 00:53:58.000000', 'temperatura', 1015.0000, 'ºC'),
	(50445, 112, '2015-02-01 00:53:59.000000', 'temperatura', 498.0000, 'ºC'),
	(50446, 112, '2015-02-01 00:54:00.000000', 'temperatura', 643.0000, 'ºC'),
	(50447, 112, '2015-02-01 00:54:01.000000', 'temperatura', 522.0000, 'ºC'),
	(50448, 112, '2015-02-01 00:54:02.000000', 'temperatura', 681.0000, 'ºC'),
	(50449, 112, '2015-02-01 00:54:03.000000', 'temperatura', 639.0000, 'ºC'),
	(50450, 112, '2015-02-01 00:54:04.000000', 'temperatura', 1154.0000, 'ºC'),
	(50451, 112, '2015-02-01 00:54:05.000000', 'temperatura', 253.0000, 'ºC'),
	(50452, 112, '2015-02-01 00:54:06.000000', 'temperatura', 202.0000, 'ºC'),
	(50453, 112, '2015-02-01 00:54:07.000000', 'temperatura', 252.0000, 'ºC'),
	(50454, 112, '2015-02-01 00:54:08.000000', 'temperatura', 653.0000, 'ºC'),
	(50455, 112, '2015-02-01 00:54:09.000000', 'temperatura', 110.0000, 'ºC'),
	(50456, 112, '2015-02-01 00:54:10.000000', 'temperatura', 992.0000, 'ºC'),
	(50457, 112, '2015-02-01 00:54:11.000000', 'temperatura', 1030.0000, 'ºC'),
	(50458, 112, '2015-02-01 00:54:12.000000', 'temperatura', 974.0000, 'ºC'),
	(50459, 112, '2015-02-01 00:54:13.000000', 'temperatura', 580.0000, 'ºC'),
	(50460, 112, '2015-02-01 00:54:14.000000', 'temperatura', 1179.0000, 'ºC'),
	(50461, 112, '2015-02-01 00:54:15.000000', 'temperatura', 558.0000, 'ºC'),
	(50462, 112, '2015-02-01 00:54:16.000000', 'temperatura', 450.0000, 'ºC'),
	(50463, 112, '2015-02-01 00:54:17.000000', 'temperatura', 577.0000, 'ºC'),
	(50464, 112, '2015-02-01 00:54:18.000000', 'temperatura', 335.0000, 'ºC'),
	(50465, 112, '2015-02-01 00:54:19.000000', 'temperatura', 1145.0000, 'ºC'),
	(50466, 112, '2015-02-01 00:54:20.000000', 'temperatura', 1119.0000, 'ºC'),
	(50467, 112, '2015-02-01 00:54:21.000000', 'temperatura', 961.0000, 'ºC'),
	(50468, 112, '2015-02-01 00:54:22.000000', 'temperatura', 248.0000, 'ºC'),
	(50469, 112, '2015-02-01 00:54:23.000000', 'temperatura', 759.0000, 'ºC'),
	(50470, 112, '2015-02-01 00:54:24.000000', 'temperatura', 649.0000, 'ºC'),
	(50471, 112, '2015-02-01 00:54:25.000000', 'temperatura', 971.0000, 'ºC'),
	(50472, 112, '2015-02-01 00:54:26.000000', 'temperatura', 507.0000, 'ºC'),
	(50473, 112, '2015-02-01 00:54:27.000000', 'temperatura', 822.0000, 'ºC'),
	(50474, 112, '2015-02-01 00:54:28.000000', 'temperatura', 189.0000, 'ºC'),
	(50475, 112, '2015-02-01 00:54:29.000000', 'temperatura', 880.0000, 'ºC'),
	(50476, 112, '2015-02-01 00:54:30.000000', 'temperatura', 236.0000, 'ºC'),
	(50477, 112, '2015-02-01 00:54:31.000000', 'temperatura', 937.0000, 'ºC'),
	(50478, 112, '2015-02-01 00:54:32.000000', 'temperatura', 381.0000, 'ºC'),
	(50479, 112, '2015-02-01 00:54:33.000000', 'temperatura', 293.0000, 'ºC'),
	(50480, 112, '2015-02-01 00:54:34.000000', 'temperatura', 322.0000, 'ºC'),
	(50481, 112, '2015-02-01 00:54:35.000000', 'temperatura', 730.0000, 'ºC'),
	(50482, 112, '2015-02-01 00:54:36.000000', 'temperatura', 285.0000, 'ºC'),
	(50483, 112, '2015-02-01 00:54:37.000000', 'temperatura', 434.0000, 'ºC'),
	(50484, 112, '2015-02-01 00:54:38.000000', 'temperatura', 119.0000, 'ºC'),
	(50485, 112, '2015-02-01 00:54:39.000000', 'temperatura', 491.0000, 'ºC'),
	(50486, 112, '2015-02-01 00:54:40.000000', 'temperatura', 897.0000, 'ºC'),
	(50487, 112, '2015-02-01 00:54:41.000000', 'temperatura', 616.0000, 'ºC'),
	(50488, 112, '2015-02-01 00:54:42.000000', 'temperatura', 387.0000, 'ºC'),
	(50489, 112, '2015-02-01 00:54:43.000000', 'temperatura', 87.0000, 'ºC'),
	(50490, 112, '2015-02-01 00:54:44.000000', 'temperatura', 477.0000, 'ºC'),
	(50491, 112, '2015-02-01 00:54:45.000000', 'temperatura', 925.0000, 'ºC'),
	(50492, 112, '2015-02-01 00:54:46.000000', 'temperatura', 793.0000, 'ºC'),
	(50493, 112, '2015-02-01 00:54:47.000000', 'temperatura', 1192.0000, 'ºC'),
	(50494, 112, '2015-02-01 00:54:48.000000', 'temperatura', 1181.0000, 'ºC'),
	(50495, 112, '2015-02-01 00:54:49.000000', 'temperatura', 1129.0000, 'ºC'),
	(50496, 112, '2015-02-01 00:54:50.000000', 'temperatura', 901.0000, 'ºC'),
	(50497, 112, '2015-02-01 00:54:51.000000', 'temperatura', 1120.0000, 'ºC'),
	(50498, 112, '2015-02-01 00:54:52.000000', 'temperatura', 496.0000, 'ºC'),
	(50499, 112, '2015-02-01 00:54:53.000000', 'temperatura', 320.0000, 'ºC'),
	(50500, 112, '2015-02-01 00:54:54.000000', 'temperatura', 112.0000, 'ºC'),
	(50501, 112, '2015-02-01 00:54:55.000000', 'temperatura', 804.0000, 'ºC'),
	(50502, 112, '2015-02-01 00:54:56.000000', 'temperatura', 81.0000, 'ºC'),
	(50503, 112, '2015-02-01 00:54:57.000000', 'temperatura', 393.0000, 'ºC'),
	(50504, 112, '2015-02-01 00:54:58.000000', 'temperatura', 525.0000, 'ºC'),
	(50505, 112, '2015-02-01 00:54:59.000000', 'temperatura', 244.0000, 'ºC'),
	(50506, 112, '2015-02-01 00:55:00.000000', 'temperatura', 847.0000, 'ºC'),
	(50507, 112, '2015-02-01 00:55:01.000000', 'temperatura', 1102.0000, 'ºC'),
	(50508, 112, '2015-02-01 00:55:02.000000', 'temperatura', 570.0000, 'ºC'),
	(50509, 112, '2015-02-01 00:55:03.000000', 'temperatura', 743.0000, 'ºC'),
	(50510, 112, '2015-02-01 00:55:04.000000', 'temperatura', 807.0000, 'ºC'),
	(50511, 112, '2015-02-01 00:55:05.000000', 'temperatura', 607.0000, 'ºC'),
	(50512, 112, '2015-02-01 00:55:06.000000', 'temperatura', 615.0000, 'ºC'),
	(50513, 112, '2015-02-01 00:55:07.000000', 'temperatura', 52.0000, 'ºC'),
	(50514, 112, '2015-02-01 00:55:08.000000', 'temperatura', 815.0000, 'ºC'),
	(50515, 112, '2015-02-01 00:55:09.000000', 'temperatura', 323.0000, 'ºC'),
	(50516, 112, '2015-02-01 00:55:10.000000', 'temperatura', 367.0000, 'ºC'),
	(50517, 112, '2015-02-01 00:55:11.000000', 'temperatura', 869.0000, 'ºC'),
	(50518, 112, '2015-02-01 00:55:12.000000', 'temperatura', 846.0000, 'ºC'),
	(50519, 112, '2015-02-01 00:55:13.000000', 'temperatura', 421.0000, 'ºC'),
	(50520, 112, '2015-02-01 00:55:14.000000', 'temperatura', 766.0000, 'ºC'),
	(50521, 112, '2015-02-01 00:55:15.000000', 'temperatura', 169.0000, 'ºC'),
	(50522, 112, '2015-02-01 00:55:16.000000', 'temperatura', 947.0000, 'ºC'),
	(50523, 112, '2015-02-01 00:55:17.000000', 'temperatura', 630.0000, 'ºC'),
	(50524, 112, '2015-02-01 00:55:18.000000', 'temperatura', 310.0000, 'ºC'),
	(50525, 112, '2015-02-01 00:55:19.000000', 'temperatura', 861.0000, 'ºC'),
	(50526, 112, '2015-02-01 00:55:20.000000', 'temperatura', 975.0000, 'ºC'),
	(50527, 112, '2015-02-01 00:55:21.000000', 'temperatura', 1091.0000, 'ºC'),
	(50528, 112, '2015-02-01 00:55:22.000000', 'temperatura', 133.0000, 'ºC'),
	(50529, 112, '2015-02-01 00:55:23.000000', 'temperatura', 989.0000, 'ºC'),
	(50530, 112, '2015-02-01 00:55:24.000000', 'temperatura', 949.0000, 'ºC'),
	(50531, 112, '2015-02-01 00:55:25.000000', 'temperatura', 579.0000, 'ºC'),
	(50532, 112, '2015-02-01 00:55:26.000000', 'temperatura', 46.0000, 'ºC'),
	(50533, 112, '2015-02-01 00:55:27.000000', 'temperatura', 895.0000, 'ºC'),
	(50534, 112, '2015-02-01 00:55:28.000000', 'temperatura', 736.0000, 'ºC'),
	(50535, 112, '2015-02-01 00:55:29.000000', 'temperatura', 997.0000, 'ºC'),
	(50536, 112, '2015-02-01 00:55:30.000000', 'temperatura', 378.0000, 'ºC'),
	(50537, 112, '2015-02-01 00:55:31.000000', 'temperatura', 100.0000, 'ºC'),
	(50538, 112, '2015-02-01 00:55:32.000000', 'temperatura', 568.0000, 'ºC'),
	(50539, 112, '2015-02-01 00:55:33.000000', 'temperatura', 137.0000, 'ºC'),
	(50540, 112, '2015-02-01 00:55:34.000000', 'temperatura', 184.0000, 'ºC'),
	(50541, 112, '2015-02-01 00:55:35.000000', 'temperatura', 510.0000, 'ºC'),
	(50542, 112, '2015-02-01 00:55:36.000000', 'temperatura', 799.0000, 'ºC'),
	(50543, 112, '2015-02-01 00:55:37.000000', 'temperatura', 64.0000, 'ºC'),
	(50544, 112, '2015-02-01 00:55:38.000000', 'temperatura', 325.0000, 'ºC'),
	(50545, 112, '2015-02-01 00:55:39.000000', 'temperatura', 235.0000, 'ºC'),
	(50546, 112, '2015-02-01 00:55:40.000000', 'temperatura', 197.0000, 'ºC'),
	(50547, 112, '2015-02-01 00:55:41.000000', 'temperatura', 282.0000, 'ºC'),
	(50548, 112, '2015-02-01 00:55:42.000000', 'temperatura', 821.0000, 'ºC'),
	(50549, 112, '2015-02-01 00:55:43.000000', 'temperatura', 859.0000, 'ºC'),
	(50550, 112, '2015-02-01 00:55:44.000000', 'temperatura', 630.0000, 'ºC'),
	(50551, 112, '2015-02-01 00:55:45.000000', 'temperatura', 575.0000, 'ºC'),
	(50552, 112, '2015-02-01 00:55:46.000000', 'temperatura', 986.0000, 'ºC'),
	(50553, 112, '2015-02-01 00:55:47.000000', 'temperatura', 803.0000, 'ºC'),
	(50554, 112, '2015-02-01 00:55:48.000000', 'temperatura', 1061.0000, 'ºC'),
	(50555, 112, '2015-02-01 00:55:49.000000', 'temperatura', 496.0000, 'ºC'),
	(50556, 112, '2015-02-01 00:55:50.000000', 'temperatura', 495.0000, 'ºC'),
	(50557, 112, '2015-02-01 00:55:51.000000', 'temperatura', 988.0000, 'ºC'),
	(50558, 112, '2015-02-01 00:55:52.000000', 'temperatura', 1055.0000, 'ºC'),
	(50559, 112, '2015-02-01 00:55:53.000000', 'temperatura', 1111.0000, 'ºC'),
	(50560, 112, '2015-02-01 00:55:54.000000', 'temperatura', 1193.0000, 'ºC'),
	(50561, 112, '2015-02-01 00:55:55.000000', 'temperatura', 232.0000, 'ºC'),
	(50562, 112, '2015-02-01 00:55:56.000000', 'temperatura', 1182.0000, 'ºC'),
	(50563, 112, '2015-02-01 00:55:57.000000', 'temperatura', 412.0000, 'ºC'),
	(50564, 112, '2015-02-01 00:55:58.000000', 'temperatura', 917.0000, 'ºC'),
	(50565, 112, '2015-02-01 00:55:59.000000', 'temperatura', 950.0000, 'ºC'),
	(50566, 112, '2015-02-01 00:56:00.000000', 'temperatura', 796.0000, 'ºC'),
	(50567, 112, '2015-02-01 00:56:01.000000', 'temperatura', 1134.0000, 'ºC'),
	(50568, 112, '2015-02-01 00:56:02.000000', 'temperatura', 882.0000, 'ºC'),
	(50569, 112, '2015-02-01 00:56:03.000000', 'temperatura', 1007.0000, 'ºC'),
	(50570, 112, '2015-02-01 00:56:04.000000', 'temperatura', 1189.0000, 'ºC'),
	(50571, 112, '2015-02-01 00:56:05.000000', 'temperatura', 526.0000, 'ºC'),
	(50572, 112, '2015-02-01 00:56:06.000000', 'temperatura', 262.0000, 'ºC'),
	(50573, 112, '2015-02-01 00:56:07.000000', 'temperatura', 934.0000, 'ºC'),
	(50574, 112, '2015-02-01 00:56:08.000000', 'temperatura', 284.0000, 'ºC'),
	(50575, 112, '2015-02-01 00:56:09.000000', 'temperatura', 1020.0000, 'ºC'),
	(50576, 112, '2015-02-01 00:56:10.000000', 'temperatura', 647.0000, 'ºC'),
	(50577, 112, '2015-02-01 00:56:11.000000', 'temperatura', 176.0000, 'ºC'),
	(50578, 112, '2015-02-01 00:56:12.000000', 'temperatura', 137.0000, 'ºC'),
	(50579, 112, '2015-02-01 00:56:13.000000', 'temperatura', 160.0000, 'ºC'),
	(50580, 112, '2015-02-01 00:56:14.000000', 'temperatura', 391.0000, 'ºC'),
	(50581, 112, '2015-02-01 00:56:15.000000', 'temperatura', 273.0000, 'ºC'),
	(50582, 112, '2015-02-01 00:56:16.000000', 'temperatura', 195.0000, 'ºC'),
	(50583, 112, '2015-02-01 00:56:17.000000', 'temperatura', 155.0000, 'ºC'),
	(50584, 112, '2015-02-01 00:56:18.000000', 'temperatura', 190.0000, 'ºC'),
	(50585, 112, '2015-02-01 00:56:19.000000', 'temperatura', 487.0000, 'ºC'),
	(50586, 112, '2015-02-01 00:56:20.000000', 'temperatura', 667.0000, 'ºC'),
	(50587, 112, '2015-02-01 00:56:21.000000', 'temperatura', 672.0000, 'ºC'),
	(50588, 112, '2015-02-01 00:56:22.000000', 'temperatura', 159.0000, 'ºC'),
	(50589, 112, '2015-02-01 00:56:23.000000', 'temperatura', 1182.0000, 'ºC'),
	(50590, 112, '2015-02-01 00:56:24.000000', 'temperatura', 633.0000, 'ºC'),
	(50591, 112, '2015-02-01 00:56:25.000000', 'temperatura', 821.0000, 'ºC'),
	(50592, 112, '2015-02-01 00:56:26.000000', 'temperatura', 1005.0000, 'ºC'),
	(50593, 112, '2015-02-01 00:56:27.000000', 'temperatura', 161.0000, 'ºC'),
	(50594, 112, '2015-02-01 00:56:28.000000', 'temperatura', 191.0000, 'ºC'),
	(50595, 112, '2015-02-01 00:56:29.000000', 'temperatura', 473.0000, 'ºC'),
	(50596, 112, '2015-02-01 00:56:30.000000', 'temperatura', 591.0000, 'ºC'),
	(50597, 112, '2015-02-01 00:56:31.000000', 'temperatura', 337.0000, 'ºC'),
	(50598, 112, '2015-02-01 00:56:32.000000', 'temperatura', 1111.0000, 'ºC'),
	(50599, 112, '2015-02-01 00:56:33.000000', 'temperatura', 945.0000, 'ºC'),
	(50600, 112, '2015-02-01 00:56:34.000000', 'temperatura', 193.0000, 'ºC'),
	(50601, 112, '2015-02-01 00:56:35.000000', 'temperatura', 532.0000, 'ºC'),
	(50602, 112, '2015-02-01 00:56:36.000000', 'temperatura', 882.0000, 'ºC'),
	(50603, 112, '2015-02-01 00:56:37.000000', 'temperatura', 413.0000, 'ºC'),
	(50604, 112, '2015-02-01 00:56:38.000000', 'temperatura', 620.0000, 'ºC'),
	(50605, 112, '2015-02-01 00:56:39.000000', 'temperatura', 663.0000, 'ºC'),
	(50606, 112, '2015-02-01 00:56:40.000000', 'temperatura', 255.0000, 'ºC'),
	(50607, 112, '2015-02-01 00:56:41.000000', 'temperatura', 486.0000, 'ºC'),
	(50608, 112, '2015-02-01 00:56:42.000000', 'temperatura', 466.0000, 'ºC'),
	(50609, 112, '2015-02-01 00:56:43.000000', 'temperatura', 872.0000, 'ºC'),
	(50610, 112, '2015-02-01 00:56:44.000000', 'temperatura', 563.0000, 'ºC'),
	(50611, 112, '2015-02-01 00:56:45.000000', 'temperatura', 201.0000, 'ºC'),
	(50612, 112, '2015-02-01 00:56:46.000000', 'temperatura', 516.0000, 'ºC'),
	(50613, 112, '2015-02-01 00:56:47.000000', 'temperatura', 778.0000, 'ºC'),
	(50614, 112, '2015-02-01 00:56:48.000000', 'temperatura', 1143.0000, 'ºC'),
	(50615, 112, '2015-02-01 00:56:49.000000', 'temperatura', 983.0000, 'ºC'),
	(50616, 112, '2015-02-01 00:56:50.000000', 'temperatura', 284.0000, 'ºC'),
	(50617, 112, '2015-02-01 00:56:51.000000', 'temperatura', 871.0000, 'ºC'),
	(50618, 112, '2015-02-01 00:56:52.000000', 'temperatura', 1103.0000, 'ºC'),
	(50619, 112, '2015-02-01 00:56:53.000000', 'temperatura', 505.0000, 'ºC'),
	(50620, 112, '2015-02-01 00:56:54.000000', 'temperatura', 416.0000, 'ºC'),
	(50621, 112, '2015-02-01 00:56:55.000000', 'temperatura', 563.0000, 'ºC'),
	(50622, 112, '2015-02-01 00:56:56.000000', 'temperatura', 369.0000, 'ºC'),
	(50623, 112, '2015-02-01 00:56:57.000000', 'temperatura', 155.0000, 'ºC'),
	(50624, 112, '2015-02-01 00:56:58.000000', 'temperatura', 868.0000, 'ºC'),
	(50625, 112, '2015-02-01 00:56:59.000000', 'temperatura', 277.0000, 'ºC'),
	(50626, 112, '2015-02-01 00:57:00.000000', 'temperatura', 1181.0000, 'ºC'),
	(50627, 112, '2015-02-01 00:57:01.000000', 'temperatura', 273.0000, 'ºC'),
	(50628, 112, '2015-02-01 00:57:02.000000', 'temperatura', 224.0000, 'ºC'),
	(50629, 112, '2015-02-01 00:57:03.000000', 'temperatura', 303.0000, 'ºC'),
	(50630, 112, '2015-02-01 00:57:04.000000', 'temperatura', 843.0000, 'ºC'),
	(50631, 112, '2015-02-01 00:57:05.000000', 'temperatura', 904.0000, 'ºC'),
	(50632, 112, '2015-02-01 00:57:06.000000', 'temperatura', 793.0000, 'ºC'),
	(50633, 112, '2015-02-01 00:57:07.000000', 'temperatura', 53.0000, 'ºC'),
	(50634, 112, '2015-02-01 00:57:08.000000', 'temperatura', 288.0000, 'ºC'),
	(50635, 112, '2015-02-01 00:57:09.000000', 'temperatura', 81.0000, 'ºC'),
	(50636, 112, '2015-02-01 00:57:10.000000', 'temperatura', 740.0000, 'ºC'),
	(50637, 112, '2015-02-01 00:57:11.000000', 'temperatura', 1058.0000, 'ºC'),
	(50638, 112, '2015-02-01 00:57:12.000000', 'temperatura', 672.0000, 'ºC'),
	(50639, 112, '2015-02-01 00:57:13.000000', 'temperatura', 187.0000, 'ºC'),
	(50640, 112, '2015-02-01 00:57:14.000000', 'temperatura', 117.0000, 'ºC'),
	(50641, 112, '2015-02-01 00:57:15.000000', 'temperatura', 27.0000, 'ºC'),
	(50642, 112, '2015-02-01 00:57:16.000000', 'temperatura', 984.0000, 'ºC'),
	(50643, 112, '2015-02-01 00:57:17.000000', 'temperatura', 39.0000, 'ºC'),
	(50644, 112, '2015-02-01 00:57:18.000000', 'temperatura', 846.0000, 'ºC'),
	(50645, 112, '2015-02-01 00:57:19.000000', 'temperatura', 511.0000, 'ºC'),
	(50646, 112, '2015-02-01 00:57:20.000000', 'temperatura', 17.0000, 'ºC'),
	(50647, 112, '2015-02-01 00:57:21.000000', 'temperatura', 953.0000, 'ºC'),
	(50648, 112, '2015-02-01 00:57:22.000000', 'temperatura', 1113.0000, 'ºC'),
	(50649, 112, '2015-02-01 00:57:23.000000', 'temperatura', 308.0000, 'ºC'),
	(50650, 112, '2015-02-01 00:57:24.000000', 'temperatura', 601.0000, 'ºC'),
	(50651, 112, '2015-02-01 00:57:25.000000', 'temperatura', 880.0000, 'ºC'),
	(50652, 112, '2015-02-01 00:57:26.000000', 'temperatura', 200.0000, 'ºC'),
	(50653, 112, '2015-02-01 00:57:27.000000', 'temperatura', 761.0000, 'ºC'),
	(50654, 112, '2015-02-01 00:57:28.000000', 'temperatura', 806.0000, 'ºC'),
	(50655, 112, '2015-02-01 00:57:29.000000', 'temperatura', 546.0000, 'ºC'),
	(50656, 112, '2015-02-01 00:57:30.000000', 'temperatura', 311.0000, 'ºC'),
	(50657, 112, '2015-02-01 00:57:31.000000', 'temperatura', 1118.0000, 'ºC'),
	(50658, 112, '2015-02-01 00:57:32.000000', 'temperatura', 1060.0000, 'ºC'),
	(50659, 112, '2015-02-01 00:57:33.000000', 'temperatura', 745.0000, 'ºC'),
	(50660, 112, '2015-02-01 00:57:34.000000', 'temperatura', 546.0000, 'ºC'),
	(50661, 112, '2015-02-01 00:57:35.000000', 'temperatura', 495.0000, 'ºC'),
	(50662, 112, '2015-02-01 00:57:36.000000', 'temperatura', 838.0000, 'ºC'),
	(50663, 112, '2015-02-01 00:57:37.000000', 'temperatura', 303.0000, 'ºC'),
	(50664, 112, '2015-02-01 00:57:38.000000', 'temperatura', 204.0000, 'ºC'),
	(50665, 112, '2015-02-01 00:57:39.000000', 'temperatura', 110.0000, 'ºC'),
	(50666, 112, '2015-02-01 00:57:40.000000', 'temperatura', 1138.0000, 'ºC'),
	(50667, 112, '2015-02-01 00:57:41.000000', 'temperatura', 562.0000, 'ºC'),
	(50668, 112, '2015-02-01 00:57:42.000000', 'temperatura', 595.0000, 'ºC'),
	(50669, 112, '2015-02-01 00:57:43.000000', 'temperatura', 91.0000, 'ºC'),
	(50670, 112, '2015-02-01 00:57:44.000000', 'temperatura', 1070.0000, 'ºC'),
	(50671, 112, '2015-02-01 00:57:45.000000', 'temperatura', 278.0000, 'ºC'),
	(50672, 112, '2015-02-01 00:57:46.000000', 'temperatura', 581.0000, 'ºC'),
	(50673, 112, '2015-02-01 00:57:47.000000', 'temperatura', 870.0000, 'ºC'),
	(50674, 112, '2015-02-01 00:57:48.000000', 'temperatura', 209.0000, 'ºC'),
	(50675, 112, '2015-02-01 00:57:49.000000', 'temperatura', 835.0000, 'ºC'),
	(50676, 112, '2015-02-01 00:57:50.000000', 'temperatura', 1149.0000, 'ºC'),
	(50677, 112, '2015-02-01 00:57:51.000000', 'temperatura', 842.0000, 'ºC'),
	(50678, 112, '2015-02-01 00:57:52.000000', 'temperatura', 762.0000, 'ºC'),
	(50679, 112, '2015-02-01 00:57:53.000000', 'temperatura', 83.0000, 'ºC'),
	(50680, 112, '2015-02-01 00:57:54.000000', 'temperatura', 529.0000, 'ºC'),
	(50681, 112, '2015-02-01 00:57:55.000000', 'temperatura', 1198.0000, 'ºC'),
	(50682, 112, '2015-02-01 00:57:56.000000', 'temperatura', 803.0000, 'ºC'),
	(50683, 112, '2015-02-01 00:57:57.000000', 'temperatura', 421.0000, 'ºC'),
	(50684, 112, '2015-02-01 00:57:58.000000', 'temperatura', 895.0000, 'ºC'),
	(50685, 112, '2015-02-01 00:57:59.000000', 'temperatura', 815.0000, 'ºC'),
	(50686, 112, '2015-02-01 00:58:00.000000', 'temperatura', 189.0000, 'ºC'),
	(50687, 112, '2015-02-01 00:58:01.000000', 'temperatura', 899.0000, 'ºC'),
	(50688, 112, '2015-02-01 00:58:02.000000', 'temperatura', 330.0000, 'ºC'),
	(50689, 112, '2015-02-01 00:58:03.000000', 'temperatura', 153.0000, 'ºC'),
	(50690, 112, '2015-02-01 00:58:04.000000', 'temperatura', 977.0000, 'ºC'),
	(50691, 112, '2015-02-01 00:58:05.000000', 'temperatura', 827.0000, 'ºC'),
	(50692, 112, '2015-02-01 00:58:06.000000', 'temperatura', 3.0000, 'ºC'),
	(50693, 112, '2015-02-01 00:58:07.000000', 'temperatura', 1135.0000, 'ºC'),
	(50694, 112, '2015-02-01 00:58:08.000000', 'temperatura', 866.0000, 'ºC'),
	(50695, 112, '2015-02-01 00:58:09.000000', 'temperatura', 928.0000, 'ºC'),
	(50696, 112, '2015-02-01 00:58:10.000000', 'temperatura', 840.0000, 'ºC'),
	(50697, 112, '2015-02-01 00:58:11.000000', 'temperatura', 218.0000, 'ºC'),
	(50698, 112, '2015-02-01 00:58:12.000000', 'temperatura', 972.0000, 'ºC'),
	(50699, 112, '2015-02-01 00:58:13.000000', 'temperatura', 603.0000, 'ºC'),
	(50700, 112, '2015-02-01 00:58:14.000000', 'temperatura', 101.0000, 'ºC'),
	(50701, 112, '2015-02-01 00:58:15.000000', 'temperatura', 1095.0000, 'ºC'),
	(50702, 112, '2015-02-01 00:58:16.000000', 'temperatura', 373.0000, 'ºC'),
	(50703, 112, '2015-02-01 00:58:17.000000', 'temperatura', 982.0000, 'ºC'),
	(50704, 112, '2015-02-01 00:58:18.000000', 'temperatura', 193.0000, 'ºC'),
	(50705, 112, '2015-02-01 00:58:19.000000', 'temperatura', 416.0000, 'ºC'),
	(50706, 112, '2015-02-01 00:58:20.000000', 'temperatura', 305.0000, 'ºC'),
	(50707, 112, '2015-02-01 00:58:21.000000', 'temperatura', 274.0000, 'ºC'),
	(50708, 112, '2015-02-01 00:58:22.000000', 'temperatura', 457.0000, 'ºC'),
	(50709, 112, '2015-02-01 00:58:23.000000', 'temperatura', 263.0000, 'ºC'),
	(50710, 112, '2015-02-01 00:58:24.000000', 'temperatura', 1146.0000, 'ºC'),
	(50711, 112, '2015-02-01 00:58:25.000000', 'temperatura', 140.0000, 'ºC'),
	(50712, 112, '2015-02-01 00:58:26.000000', 'temperatura', 861.0000, 'ºC'),
	(50713, 112, '2015-02-01 00:58:27.000000', 'temperatura', 287.0000, 'ºC'),
	(50714, 112, '2015-02-01 00:58:28.000000', 'temperatura', 51.0000, 'ºC'),
	(50715, 112, '2015-02-01 00:58:29.000000', 'temperatura', 594.0000, 'ºC'),
	(50716, 112, '2015-02-01 00:58:30.000000', 'temperatura', 420.0000, 'ºC'),
	(50717, 112, '2015-02-01 00:58:31.000000', 'temperatura', 316.0000, 'ºC'),
	(50718, 112, '2015-02-01 00:58:32.000000', 'temperatura', 321.0000, 'ºC'),
	(50719, 112, '2015-02-01 00:58:33.000000', 'temperatura', 656.0000, 'ºC'),
	(50720, 112, '2015-02-01 00:58:34.000000', 'temperatura', 1120.0000, 'ºC'),
	(50721, 112, '2015-02-01 00:58:35.000000', 'temperatura', 32.0000, 'ºC'),
	(50722, 112, '2015-02-01 00:58:36.000000', 'temperatura', 399.0000, 'ºC'),
	(50723, 112, '2015-02-01 00:58:37.000000', 'temperatura', 701.0000, 'ºC'),
	(50724, 112, '2015-02-01 00:58:38.000000', 'temperatura', 1107.0000, 'ºC'),
	(50725, 112, '2015-02-01 00:58:39.000000', 'temperatura', 1034.0000, 'ºC'),
	(50726, 112, '2015-02-01 00:58:40.000000', 'temperatura', 650.0000, 'ºC'),
	(50727, 112, '2015-02-01 00:58:41.000000', 'temperatura', 147.0000, 'ºC'),
	(50728, 112, '2015-02-01 00:58:42.000000', 'temperatura', 1186.0000, 'ºC'),
	(50729, 112, '2015-02-01 00:58:43.000000', 'temperatura', 690.0000, 'ºC'),
	(50730, 112, '2015-02-01 00:58:44.000000', 'temperatura', 1091.0000, 'ºC'),
	(50731, 112, '2015-02-01 00:58:45.000000', 'temperatura', 987.0000, 'ºC'),
	(50732, 112, '2015-02-01 00:58:46.000000', 'temperatura', 464.0000, 'ºC'),
	(50733, 112, '2015-02-01 00:58:47.000000', 'temperatura', 558.0000, 'ºC'),
	(50734, 112, '2015-02-01 00:58:48.000000', 'temperatura', 198.0000, 'ºC'),
	(50735, 112, '2015-02-01 00:58:49.000000', 'temperatura', 518.0000, 'ºC'),
	(50736, 112, '2015-02-01 00:58:50.000000', 'temperatura', 797.0000, 'ºC'),
	(50737, 112, '2015-02-01 00:58:51.000000', 'temperatura', 31.0000, 'ºC'),
	(50738, 112, '2015-02-01 00:58:52.000000', 'temperatura', 165.0000, 'ºC'),
	(50739, 112, '2015-02-01 00:58:53.000000', 'temperatura', 732.0000, 'ºC'),
	(50740, 112, '2015-02-01 00:58:54.000000', 'temperatura', 764.0000, 'ºC'),
	(50741, 112, '2015-02-01 00:58:55.000000', 'temperatura', 427.0000, 'ºC'),
	(50742, 112, '2015-02-01 00:58:56.000000', 'temperatura', 1040.0000, 'ºC'),
	(50743, 112, '2015-02-01 00:58:57.000000', 'temperatura', 323.0000, 'ºC'),
	(50744, 112, '2015-02-01 00:58:58.000000', 'temperatura', 895.0000, 'ºC'),
	(50745, 112, '2015-02-01 00:58:59.000000', 'temperatura', 1106.0000, 'ºC'),
	(50746, 112, '2015-02-01 00:59:00.000000', 'temperatura', 445.0000, 'ºC'),
	(50747, 112, '2015-02-01 00:59:01.000000', 'temperatura', 107.0000, 'ºC'),
	(50748, 112, '2015-02-01 00:59:02.000000', 'temperatura', 403.0000, 'ºC'),
	(50749, 112, '2015-02-01 00:59:03.000000', 'temperatura', 493.0000, 'ºC'),
	(50750, 112, '2015-02-01 00:59:04.000000', 'temperatura', 58.0000, 'ºC'),
	(50751, 112, '2015-02-01 00:59:05.000000', 'temperatura', 10.0000, 'ºC'),
	(50752, 112, '2015-02-01 00:59:06.000000', 'temperatura', 1079.0000, 'ºC'),
	(50753, 112, '2015-02-01 00:59:07.000000', 'temperatura', 564.0000, 'ºC'),
	(50754, 112, '2015-02-01 00:59:08.000000', 'temperatura', 782.0000, 'ºC'),
	(50755, 112, '2015-02-01 00:59:09.000000', 'temperatura', 1020.0000, 'ºC'),
	(50756, 112, '2015-02-01 00:59:10.000000', 'temperatura', 356.0000, 'ºC'),
	(50757, 112, '2015-02-01 00:59:11.000000', 'temperatura', 1118.0000, 'ºC'),
	(50758, 112, '2015-02-01 00:59:12.000000', 'temperatura', 922.0000, 'ºC'),
	(50759, 112, '2015-02-01 00:59:13.000000', 'temperatura', 57.0000, 'ºC'),
	(50760, 112, '2015-02-01 00:59:14.000000', 'temperatura', 1120.0000, 'ºC'),
	(50761, 112, '2015-02-01 00:59:15.000000', 'temperatura', 629.0000, 'ºC'),
	(50762, 112, '2015-02-01 00:59:16.000000', 'temperatura', 986.0000, 'ºC'),
	(50763, 112, '2015-02-01 00:59:17.000000', 'temperatura', 642.0000, 'ºC'),
	(50764, 112, '2015-02-01 00:59:18.000000', 'temperatura', 255.0000, 'ºC'),
	(50765, 112, '2015-02-01 00:59:19.000000', 'temperatura', 549.0000, 'ºC'),
	(50766, 112, '2015-02-01 00:59:20.000000', 'temperatura', 780.0000, 'ºC'),
	(50767, 112, '2015-02-01 00:59:21.000000', 'temperatura', 1054.0000, 'ºC'),
	(50768, 112, '2015-02-01 00:59:22.000000', 'temperatura', 532.0000, 'ºC'),
	(50769, 112, '2015-02-01 00:59:23.000000', 'temperatura', 698.0000, 'ºC'),
	(50770, 112, '2015-02-01 00:59:24.000000', 'temperatura', 693.0000, 'ºC'),
	(50771, 112, '2015-02-01 00:59:25.000000', 'temperatura', 174.0000, 'ºC'),
	(50772, 112, '2015-02-01 00:59:26.000000', 'temperatura', 1192.0000, 'ºC'),
	(50773, 112, '2015-02-01 00:59:27.000000', 'temperatura', 636.0000, 'ºC'),
	(50774, 112, '2015-02-01 00:59:28.000000', 'temperatura', 804.0000, 'ºC'),
	(50775, 112, '2015-02-01 00:59:29.000000', 'temperatura', 912.0000, 'ºC'),
	(50776, 112, '2015-02-01 00:59:30.000000', 'temperatura', 951.0000, 'ºC'),
	(50777, 112, '2015-02-01 00:59:31.000000', 'temperatura', 817.0000, 'ºC'),
	(50778, 112, '2015-02-01 00:59:32.000000', 'temperatura', 33.0000, 'ºC'),
	(50779, 112, '2015-02-01 00:59:33.000000', 'temperatura', 117.0000, 'ºC'),
	(50780, 112, '2015-02-01 00:59:34.000000', 'temperatura', 483.0000, 'ºC'),
	(50781, 112, '2015-02-01 00:59:35.000000', 'temperatura', 865.0000, 'ºC'),
	(50782, 112, '2015-02-01 00:59:36.000000', 'temperatura', 479.0000, 'ºC'),
	(50783, 112, '2015-02-01 00:59:37.000000', 'temperatura', 999.0000, 'ºC'),
	(50784, 112, '2015-02-01 00:59:38.000000', 'temperatura', 1158.0000, 'ºC'),
	(50785, 112, '2015-02-01 00:59:39.000000', 'temperatura', 395.0000, 'ºC'),
	(50786, 112, '2015-02-01 00:59:40.000000', 'temperatura', 901.0000, 'ºC'),
	(50787, 112, '2015-02-01 00:59:41.000000', 'temperatura', 921.0000, 'ºC'),
	(50788, 112, '2015-02-01 00:59:42.000000', 'temperatura', 703.0000, 'ºC'),
	(50789, 112, '2015-02-01 00:59:43.000000', 'temperatura', 751.0000, 'ºC'),
	(50790, 112, '2015-02-01 00:59:44.000000', 'temperatura', 446.0000, 'ºC'),
	(50791, 112, '2015-02-01 00:59:45.000000', 'temperatura', 1177.0000, 'ºC'),
	(50792, 112, '2015-02-01 00:59:46.000000', 'temperatura', 948.0000, 'ºC'),
	(50793, 112, '2015-02-01 00:59:47.000000', 'temperatura', 9.0000, 'ºC'),
	(50794, 112, '2015-02-01 00:59:48.000000', 'temperatura', 804.0000, 'ºC'),
	(50795, 112, '2015-02-01 00:59:49.000000', 'temperatura', 392.0000, 'ºC'),
	(50796, 112, '2015-02-01 00:59:50.000000', 'temperatura', 747.0000, 'ºC'),
	(50797, 112, '2015-02-01 00:59:51.000000', 'temperatura', 159.0000, 'ºC'),
	(50798, 112, '2015-02-01 00:59:52.000000', 'temperatura', 956.0000, 'ºC'),
	(50799, 112, '2015-02-01 00:59:53.000000', 'temperatura', 705.0000, 'ºC'),
	(50800, 112, '2015-02-01 00:59:54.000000', 'temperatura', 656.0000, 'ºC'),
	(50801, 112, '2015-02-01 00:59:55.000000', 'temperatura', 1167.0000, 'ºC'),
	(50802, 112, '2015-02-01 00:59:56.000000', 'temperatura', 269.0000, 'ºC'),
	(50803, 112, '2015-02-01 00:59:57.000000', 'temperatura', 241.0000, 'ºC'),
	(50804, 112, '2015-02-01 00:59:58.000000', 'temperatura', 401.0000, 'ºC'),
	(50805, 112, '2015-02-01 00:59:59.000000', 'temperatura', 82.0000, 'ºC'),
	(50806, 112, '2015-02-01 01:00:00.000000', 'temperatura', 406.0000, 'ºC'),
	(50807, 112, '2015-02-01 01:00:01.000000', 'temperatura', 587.0000, 'ºC'),
	(50808, 112, '2015-02-01 01:00:02.000000', 'temperatura', 515.0000, 'ºC'),
	(50809, 112, '2015-02-01 01:00:03.000000', 'temperatura', 814.0000, 'ºC'),
	(50810, 112, '2015-02-01 01:00:04.000000', 'temperatura', 128.0000, 'ºC'),
	(50811, 112, '2015-02-01 01:00:05.000000', 'temperatura', 598.0000, 'ºC'),
	(50812, 112, '2015-02-01 01:00:06.000000', 'temperatura', 206.0000, 'ºC'),
	(50813, 112, '2015-02-01 01:00:07.000000', 'temperatura', 436.0000, 'ºC'),
	(50814, 112, '2015-02-01 01:00:08.000000', 'temperatura', 364.0000, 'ºC'),
	(50815, 112, '2015-02-01 01:00:09.000000', 'temperatura', 512.0000, 'ºC'),
	(50816, 112, '2015-02-01 01:00:10.000000', 'temperatura', 268.0000, 'ºC'),
	(50817, 112, '2015-02-01 01:00:11.000000', 'temperatura', 1005.0000, 'ºC'),
	(50818, 112, '2015-02-01 01:00:12.000000', 'temperatura', 620.0000, 'ºC'),
	(50819, 112, '2015-02-01 01:00:13.000000', 'temperatura', 85.0000, 'ºC'),
	(50820, 112, '2015-02-01 01:00:14.000000', 'temperatura', 967.0000, 'ºC'),
	(50821, 112, '2015-02-01 01:00:15.000000', 'temperatura', 982.0000, 'ºC'),
	(50822, 112, '2015-02-01 01:00:16.000000', 'temperatura', 808.0000, 'ºC'),
	(50823, 112, '2015-02-01 01:00:17.000000', 'temperatura', 1096.0000, 'ºC'),
	(50824, 112, '2015-02-01 01:00:18.000000', 'temperatura', 657.0000, 'ºC'),
	(50825, 112, '2015-02-01 01:00:19.000000', 'temperatura', 1196.0000, 'ºC'),
	(50826, 112, '2015-02-01 01:00:20.000000', 'temperatura', 410.0000, 'ºC'),
	(50827, 112, '2015-02-01 01:00:21.000000', 'temperatura', 861.0000, 'ºC'),
	(50828, 112, '2015-02-01 01:00:22.000000', 'temperatura', 676.0000, 'ºC'),
	(50829, 112, '2015-02-01 01:00:23.000000', 'temperatura', 797.0000, 'ºC'),
	(50830, 112, '2015-02-01 01:00:24.000000', 'temperatura', 757.0000, 'ºC'),
	(50831, 112, '2015-02-01 01:00:25.000000', 'temperatura', 194.0000, 'ºC'),
	(50832, 112, '2015-02-01 01:00:26.000000', 'temperatura', 1099.0000, 'ºC'),
	(50833, 112, '2015-02-01 01:00:27.000000', 'temperatura', 114.0000, 'ºC'),
	(50834, 112, '2015-02-01 01:00:28.000000', 'temperatura', 876.0000, 'ºC'),
	(50835, 112, '2015-02-01 01:00:29.000000', 'temperatura', 436.0000, 'ºC'),
	(50836, 112, '2015-02-01 01:00:30.000000', 'temperatura', 752.0000, 'ºC'),
	(50837, 112, '2015-02-01 01:00:31.000000', 'temperatura', 52.0000, 'ºC'),
	(50838, 112, '2015-02-01 01:00:32.000000', 'temperatura', 406.0000, 'ºC'),
	(50839, 112, '2015-02-01 01:00:33.000000', 'temperatura', 672.0000, 'ºC'),
	(50840, 112, '2015-02-01 01:00:34.000000', 'temperatura', 945.0000, 'ºC'),
	(50841, 112, '2015-02-01 01:00:35.000000', 'temperatura', 309.0000, 'ºC'),
	(50842, 112, '2015-02-01 01:00:36.000000', 'temperatura', 1112.0000, 'ºC'),
	(50843, 112, '2015-02-01 01:00:37.000000', 'temperatura', 1034.0000, 'ºC'),
	(50844, 112, '2015-02-01 01:00:38.000000', 'temperatura', 635.0000, 'ºC'),
	(50845, 112, '2015-02-01 01:00:39.000000', 'temperatura', 74.0000, 'ºC'),
	(50846, 112, '2015-02-01 01:00:40.000000', 'temperatura', 865.0000, 'ºC'),
	(50847, 112, '2015-02-01 01:00:41.000000', 'temperatura', 502.0000, 'ºC'),
	(50848, 112, '2015-02-01 01:00:42.000000', 'temperatura', 1115.0000, 'ºC'),
	(50849, 112, '2015-02-01 01:00:43.000000', 'temperatura', 472.0000, 'ºC'),
	(50850, 112, '2015-02-01 01:00:44.000000', 'temperatura', 215.0000, 'ºC'),
	(50851, 112, '2015-02-01 01:00:45.000000', 'temperatura', 857.0000, 'ºC'),
	(50852, 112, '2015-02-01 01:00:46.000000', 'temperatura', 43.0000, 'ºC'),
	(50853, 112, '2015-02-01 01:00:47.000000', 'temperatura', 42.0000, 'ºC'),
	(50854, 112, '2015-02-01 01:00:48.000000', 'temperatura', 82.0000, 'ºC'),
	(50855, 112, '2015-02-01 01:00:49.000000', 'temperatura', 286.0000, 'ºC'),
	(50856, 112, '2015-02-01 01:00:50.000000', 'temperatura', 1185.0000, 'ºC'),
	(50857, 112, '2015-02-01 01:00:51.000000', 'temperatura', 265.0000, 'ºC'),
	(50858, 112, '2015-02-01 01:00:52.000000', 'temperatura', 174.0000, 'ºC'),
	(50859, 112, '2015-02-01 01:00:53.000000', 'temperatura', 72.0000, 'ºC'),
	(50860, 112, '2015-02-01 01:00:54.000000', 'temperatura', 1040.0000, 'ºC'),
	(50861, 112, '2015-02-01 01:00:55.000000', 'temperatura', 184.0000, 'ºC'),
	(50862, 112, '2015-02-01 01:00:56.000000', 'temperatura', 199.0000, 'ºC'),
	(50863, 112, '2015-02-01 01:00:57.000000', 'temperatura', 446.0000, 'ºC'),
	(50864, 112, '2015-02-01 01:00:58.000000', 'temperatura', 434.0000, 'ºC'),
	(50865, 112, '2015-02-01 01:00:59.000000', 'temperatura', 831.0000, 'ºC'),
	(50866, 112, '2015-02-01 01:01:00.000000', 'temperatura', 453.0000, 'ºC'),
	(50867, 112, '2015-02-01 01:01:01.000000', 'temperatura', 974.0000, 'ºC'),
	(50868, 112, '2015-02-01 01:01:02.000000', 'temperatura', 1109.0000, 'ºC'),
	(50869, 112, '2015-02-01 01:01:03.000000', 'temperatura', 226.0000, 'ºC'),
	(50870, 112, '2015-02-01 01:01:04.000000', 'temperatura', 201.0000, 'ºC'),
	(50871, 112, '2015-02-01 01:01:05.000000', 'temperatura', 329.0000, 'ºC'),
	(50872, 112, '2015-02-01 01:01:06.000000', 'temperatura', 1042.0000, 'ºC'),
	(50873, 112, '2015-02-01 01:01:07.000000', 'temperatura', 622.0000, 'ºC'),
	(50874, 112, '2015-02-01 01:01:08.000000', 'temperatura', 1187.0000, 'ºC'),
	(50875, 112, '2015-02-01 01:01:09.000000', 'temperatura', 468.0000, 'ºC'),
	(50876, 112, '2015-02-01 01:01:10.000000', 'temperatura', 1181.0000, 'ºC'),
	(50877, 112, '2015-02-01 01:01:11.000000', 'temperatura', 903.0000, 'ºC'),
	(50878, 112, '2015-02-01 01:01:12.000000', 'temperatura', 970.0000, 'ºC'),
	(50879, 112, '2015-02-01 01:01:13.000000', 'temperatura', 943.0000, 'ºC'),
	(50880, 112, '2015-02-01 01:01:14.000000', 'temperatura', 607.0000, 'ºC'),
	(50881, 112, '2015-02-01 01:01:15.000000', 'temperatura', 203.0000, 'ºC'),
	(50882, 112, '2015-02-01 01:01:16.000000', 'temperatura', 396.0000, 'ºC'),
	(50883, 112, '2015-02-01 01:01:17.000000', 'temperatura', 172.0000, 'ºC'),
	(50884, 112, '2015-02-01 01:01:18.000000', 'temperatura', 873.0000, 'ºC'),
	(50885, 112, '2015-02-01 01:01:19.000000', 'temperatura', 248.0000, 'ºC'),
	(50886, 112, '2015-02-01 01:01:20.000000', 'temperatura', 1023.0000, 'ºC'),
	(50887, 112, '2015-02-01 01:01:21.000000', 'temperatura', 769.0000, 'ºC'),
	(50888, 112, '2015-02-01 01:01:22.000000', 'temperatura', 778.0000, 'ºC'),
	(50889, 112, '2015-02-01 01:01:23.000000', 'temperatura', 384.0000, 'ºC'),
	(50890, 112, '2015-02-01 01:01:24.000000', 'temperatura', 787.0000, 'ºC'),
	(50891, 112, '2015-02-01 01:01:25.000000', 'temperatura', 382.0000, 'ºC'),
	(50892, 112, '2015-02-01 01:01:26.000000', 'temperatura', 750.0000, 'ºC'),
	(50893, 112, '2015-02-01 01:01:27.000000', 'temperatura', 203.0000, 'ºC'),
	(50894, 112, '2015-02-01 01:01:28.000000', 'temperatura', 1167.0000, 'ºC'),
	(50895, 112, '2015-02-01 01:01:29.000000', 'temperatura', 426.0000, 'ºC'),
	(50896, 112, '2015-02-01 01:01:30.000000', 'temperatura', 1028.0000, 'ºC'),
	(50897, 112, '2015-02-01 01:01:31.000000', 'temperatura', 263.0000, 'ºC'),
	(50898, 112, '2015-02-01 01:01:32.000000', 'temperatura', 632.0000, 'ºC'),
	(50899, 112, '2015-02-01 01:01:33.000000', 'temperatura', 1170.0000, 'ºC'),
	(50900, 112, '2015-02-01 01:01:34.000000', 'temperatura', 356.0000, 'ºC'),
	(50901, 112, '2015-02-01 01:01:35.000000', 'temperatura', 671.0000, 'ºC'),
	(50902, 112, '2015-02-01 01:01:36.000000', 'temperatura', 1087.0000, 'ºC'),
	(50903, 112, '2015-02-01 01:01:37.000000', 'temperatura', 1024.0000, 'ºC'),
	(50904, 112, '2015-02-01 01:01:38.000000', 'temperatura', 660.0000, 'ºC'),
	(50905, 112, '2015-02-01 01:01:39.000000', 'temperatura', 227.0000, 'ºC'),
	(50906, 112, '2015-02-01 01:01:40.000000', 'temperatura', 356.0000, 'ºC'),
	(50907, 112, '2015-02-01 01:01:41.000000', 'temperatura', 1098.0000, 'ºC'),
	(50908, 112, '2015-02-01 01:01:42.000000', 'temperatura', 822.0000, 'ºC'),
	(50909, 112, '2015-02-01 01:01:43.000000', 'temperatura', 817.0000, 'ºC'),
	(50910, 112, '2015-02-01 01:01:44.000000', 'temperatura', 419.0000, 'ºC'),
	(50911, 112, '2015-02-01 01:01:45.000000', 'temperatura', 843.0000, 'ºC'),
	(50912, 112, '2015-02-01 01:01:46.000000', 'temperatura', 561.0000, 'ºC'),
	(50913, 112, '2015-02-01 01:01:47.000000', 'temperatura', 276.0000, 'ºC'),
	(50914, 112, '2015-02-01 01:01:48.000000', 'temperatura', 895.0000, 'ºC'),
	(50915, 112, '2015-02-01 01:01:49.000000', 'temperatura', 51.0000, 'ºC'),
	(50916, 112, '2015-02-01 01:01:50.000000', 'temperatura', 1169.0000, 'ºC'),
	(50917, 112, '2015-02-01 01:01:51.000000', 'temperatura', 891.0000, 'ºC'),
	(50918, 112, '2015-02-01 01:01:52.000000', 'temperatura', 951.0000, 'ºC'),
	(50919, 112, '2015-02-01 01:01:53.000000', 'temperatura', 883.0000, 'ºC'),
	(50920, 112, '2015-02-01 01:01:54.000000', 'temperatura', 360.0000, 'ºC'),
	(50921, 112, '2015-02-01 01:01:55.000000', 'temperatura', 354.0000, 'ºC'),
	(50922, 112, '2015-02-01 01:01:56.000000', 'temperatura', 688.0000, 'ºC'),
	(50923, 112, '2015-02-01 01:01:57.000000', 'temperatura', 1179.0000, 'ºC'),
	(50924, 112, '2015-02-01 01:01:58.000000', 'temperatura', 233.0000, 'ºC'),
	(50925, 112, '2015-02-01 01:01:59.000000', 'temperatura', 30.0000, 'ºC'),
	(50926, 112, '2015-02-01 01:02:00.000000', 'temperatura', 649.0000, 'ºC'),
	(50927, 112, '2015-02-01 01:02:01.000000', 'temperatura', 755.0000, 'ºC'),
	(50928, 112, '2015-02-01 01:02:02.000000', 'temperatura', 629.0000, 'ºC'),
	(50929, 112, '2015-02-01 01:02:03.000000', 'temperatura', 880.0000, 'ºC'),
	(50930, 112, '2015-02-01 01:02:04.000000', 'temperatura', 114.0000, 'ºC'),
	(50931, 112, '2015-02-01 01:02:05.000000', 'temperatura', 330.0000, 'ºC'),
	(50932, 112, '2015-02-01 01:02:06.000000', 'temperatura', 110.0000, 'ºC'),
	(50933, 112, '2015-02-01 01:02:07.000000', 'temperatura', 761.0000, 'ºC'),
	(50934, 112, '2015-02-01 01:02:08.000000', 'temperatura', 1073.0000, 'ºC'),
	(50935, 112, '2015-02-01 01:02:09.000000', 'temperatura', 682.0000, 'ºC'),
	(50936, 112, '2015-02-01 01:02:10.000000', 'temperatura', 194.0000, 'ºC'),
	(50937, 112, '2015-02-01 01:02:11.000000', 'temperatura', 123.0000, 'ºC'),
	(50938, 112, '2015-02-01 01:02:12.000000', 'temperatura', 35.0000, 'ºC'),
	(50939, 112, '2015-02-01 01:02:13.000000', 'temperatura', 1005.0000, 'ºC'),
	(50940, 112, '2015-02-01 01:02:14.000000', 'temperatura', 122.0000, 'ºC'),
	(50941, 112, '2015-02-01 01:02:15.000000', 'temperatura', 1193.0000, 'ºC'),
	(50942, 112, '2015-02-01 01:02:16.000000', 'temperatura', 801.0000, 'ºC'),
	(50943, 112, '2015-02-01 01:02:17.000000', 'temperatura', 428.0000, 'ºC'),
	(50944, 112, '2015-02-01 01:02:18.000000', 'temperatura', 935.0000, 'ºC'),
	(50945, 112, '2015-02-01 01:02:19.000000', 'temperatura', 992.0000, 'ºC'),
	(50946, 112, '2015-02-01 01:02:20.000000', 'temperatura', 956.0000, 'ºC'),
	(50947, 112, '2015-02-01 01:02:21.000000', 'temperatura', 604.0000, 'ºC'),
	(50948, 112, '2015-02-01 01:02:22.000000', 'temperatura', 154.0000, 'ºC'),
	(50949, 112, '2015-02-01 01:02:23.000000', 'temperatura', 158.0000, 'ºC'),
	(50950, 112, '2015-02-01 01:02:24.000000', 'temperatura', 329.0000, 'ºC'),
	(50951, 112, '2015-02-01 01:02:25.000000', 'temperatura', 1170.0000, 'ºC'),
	(50952, 112, '2015-02-01 01:02:26.000000', 'temperatura', 64.0000, 'ºC'),
	(50953, 112, '2015-02-01 01:02:27.000000', 'temperatura', 409.0000, 'ºC'),
	(50954, 112, '2015-02-01 01:02:28.000000', 'temperatura', 653.0000, 'ºC'),
	(50955, 112, '2015-02-01 01:02:29.000000', 'temperatura', 841.0000, 'ºC'),
	(50956, 112, '2015-02-01 01:02:30.000000', 'temperatura', 1044.0000, 'ºC'),
	(50957, 112, '2015-02-01 01:02:31.000000', 'temperatura', 300.0000, 'ºC'),
	(50958, 112, '2015-02-01 01:02:32.000000', 'temperatura', 768.0000, 'ºC'),
	(50959, 112, '2015-02-01 01:02:33.000000', 'temperatura', 540.0000, 'ºC'),
	(50960, 112, '2015-02-01 01:02:34.000000', 'temperatura', 395.0000, 'ºC'),
	(50961, 112, '2015-02-01 01:02:35.000000', 'temperatura', 356.0000, 'ºC'),
	(50962, 112, '2015-02-01 01:02:36.000000', 'temperatura', 595.0000, 'ºC'),
	(50963, 112, '2015-02-01 01:02:37.000000', 'temperatura', 707.0000, 'ºC'),
	(50964, 112, '2015-02-01 01:02:38.000000', 'temperatura', 549.0000, 'ºC'),
	(50965, 112, '2015-02-01 01:02:39.000000', 'temperatura', 627.0000, 'ºC'),
	(50966, 112, '2015-02-01 01:02:40.000000', 'temperatura', 288.0000, 'ºC'),
	(50967, 112, '2015-02-01 01:02:41.000000', 'temperatura', 758.0000, 'ºC'),
	(50968, 112, '2015-02-01 01:02:42.000000', 'temperatura', 526.0000, 'ºC'),
	(50969, 112, '2015-02-01 01:02:43.000000', 'temperatura', 360.0000, 'ºC'),
	(50970, 112, '2015-02-01 01:02:44.000000', 'temperatura', 219.0000, 'ºC'),
	(50971, 112, '2015-02-01 01:02:45.000000', 'temperatura', 15.0000, 'ºC'),
	(50972, 112, '2015-02-01 01:02:46.000000', 'temperatura', 620.0000, 'ºC'),
	(50973, 112, '2015-02-01 01:02:47.000000', 'temperatura', 657.0000, 'ºC'),
	(50974, 112, '2015-02-01 01:02:48.000000', 'temperatura', 225.0000, 'ºC'),
	(50975, 112, '2015-02-01 01:02:49.000000', 'temperatura', 354.0000, 'ºC'),
	(50976, 112, '2015-02-01 01:02:50.000000', 'temperatura', 1098.0000, 'ºC'),
	(50977, 112, '2015-02-01 01:02:51.000000', 'temperatura', 825.0000, 'ºC'),
	(50978, 112, '2015-02-01 01:02:52.000000', 'temperatura', 832.0000, 'ºC'),
	(50979, 112, '2015-02-01 01:02:53.000000', 'temperatura', 484.0000, 'ºC'),
	(50980, 112, '2015-02-01 01:02:54.000000', 'temperatura', 1128.0000, 'ºC'),
	(50981, 112, '2015-02-01 01:02:55.000000', 'temperatura', 585.0000, 'ºC'),
	(50982, 112, '2015-02-01 01:02:56.000000', 'temperatura', 744.0000, 'ºC'),
	(50983, 112, '2015-02-01 01:02:57.000000', 'temperatura', 763.0000, 'ºC'),
	(50984, 112, '2015-02-01 01:02:58.000000', 'temperatura', 387.0000, 'ºC'),
	(50985, 112, '2015-02-01 01:02:59.000000', 'temperatura', 843.0000, 'ºC'),
	(50986, 112, '2015-02-01 01:03:00.000000', 'temperatura', 658.0000, 'ºC'),
	(50987, 112, '2015-02-01 01:03:01.000000', 'temperatura', 760.0000, 'ºC'),
	(50988, 112, '2015-02-01 01:03:02.000000', 'temperatura', 626.0000, 'ºC'),
	(50989, 112, '2015-02-01 01:03:03.000000', 'temperatura', 851.0000, 'ºC'),
	(50990, 112, '2015-02-01 01:03:04.000000', 'temperatura', 1178.0000, 'ºC'),
	(50991, 112, '2015-02-01 01:03:05.000000', 'temperatura', 938.0000, 'ºC'),
	(50992, 112, '2015-02-01 01:03:06.000000', 'temperatura', 1155.0000, 'ºC'),
	(50993, 112, '2015-02-01 01:03:07.000000', 'temperatura', 561.0000, 'ºC'),
	(50994, 112, '2015-02-01 01:03:08.000000', 'temperatura', 541.0000, 'ºC'),
	(50995, 112, '2015-02-01 01:03:09.000000', 'temperatura', 1023.0000, 'ºC'),
	(50996, 112, '2015-02-01 01:03:10.000000', 'temperatura', 1093.0000, 'ºC'),
	(50997, 112, '2015-02-01 01:03:11.000000', 'temperatura', 1195.0000, 'ºC'),
	(50998, 112, '2015-02-01 01:03:12.000000', 'temperatura', 298.0000, 'ºC'),
	(50999, 112, '2015-02-01 01:03:13.000000', 'temperatura', 305.0000, 'ºC'),
	(51000, 112, '2015-02-01 01:03:14.000000', 'temperatura', 632.0000, 'ºC'),
	(51001, 112, '2015-02-01 01:03:15.000000', 'temperatura', 1043.0000, 'ºC'),
	(51002, 112, '2015-02-01 01:03:16.000000', 'temperatura', 923.0000, 'ºC'),
	(51003, 112, '2015-02-01 01:03:17.000000', 'temperatura', 283.0000, 'ºC'),
	(51004, 112, '2015-02-01 01:03:18.000000', 'temperatura', 1049.0000, 'ºC'),
	(51005, 112, '2015-02-01 01:03:19.000000', 'temperatura', 797.0000, 'ºC'),
	(51006, 112, '2015-02-01 01:03:20.000000', 'temperatura', 839.0000, 'ºC'),
	(51007, 112, '2015-02-01 01:03:21.000000', 'temperatura', 601.0000, 'ºC'),
	(51008, 112, '2015-02-01 01:03:22.000000', 'temperatura', 492.0000, 'ºC'),
	(51009, 112, '2015-02-01 01:03:23.000000', 'temperatura', 658.0000, 'ºC'),
	(51010, 112, '2015-02-01 01:03:24.000000', 'temperatura', 612.0000, 'ºC'),
	(51011, 112, '2015-02-01 01:03:25.000000', 'temperatura', 1087.0000, 'ºC'),
	(51012, 112, '2015-02-01 01:03:26.000000', 'temperatura', 1.0000, 'ºC'),
	(51013, 112, '2015-02-01 01:03:27.000000', 'temperatura', 344.0000, 'ºC'),
	(51014, 112, '2015-02-01 01:03:28.000000', 'temperatura', 519.0000, 'ºC'),
	(51015, 112, '2015-02-01 01:03:29.000000', 'temperatura', 364.0000, 'ºC'),
	(51016, 112, '2015-02-01 01:03:30.000000', 'temperatura', 261.0000, 'ºC'),
	(51017, 112, '2015-02-01 01:03:31.000000', 'temperatura', 213.0000, 'ºC'),
	(51018, 112, '2015-02-01 01:03:32.000000', 'temperatura', 285.0000, 'ºC'),
	(51019, 112, '2015-02-01 01:03:33.000000', 'temperatura', 784.0000, 'ºC'),
	(51020, 112, '2015-02-01 01:03:34.000000', 'temperatura', 669.0000, 'ºC'),
	(51021, 112, '2015-02-01 01:03:35.000000', 'temperatura', 990.0000, 'ºC'),
	(51022, 112, '2015-02-01 01:03:36.000000', 'temperatura', 544.0000, 'ºC'),
	(51023, 112, '2015-02-01 01:03:37.000000', 'temperatura', 950.0000, 'ºC'),
	(51024, 112, '2015-02-01 01:03:38.000000', 'temperatura', 721.0000, 'ºC'),
	(51025, 112, '2015-02-01 01:03:39.000000', 'temperatura', 753.0000, 'ºC'),
	(51026, 112, '2015-02-01 01:03:40.000000', 'temperatura', 405.0000, 'ºC'),
	(51027, 112, '2015-02-01 01:03:41.000000', 'temperatura', 963.0000, 'ºC'),
	(51028, 112, '2015-02-01 01:03:42.000000', 'temperatura', 4.0000, 'ºC'),
	(51029, 112, '2015-02-01 01:03:43.000000', 'temperatura', 728.0000, 'ºC'),
	(51030, 112, '2015-02-01 01:03:44.000000', 'temperatura', 32.0000, 'ºC'),
	(51031, 112, '2015-02-01 01:03:45.000000', 'temperatura', 373.0000, 'ºC'),
	(51032, 112, '2015-02-01 01:03:46.000000', 'temperatura', 573.0000, 'ºC'),
	(51033, 112, '2015-02-01 01:03:47.000000', 'temperatura', 545.0000, 'ºC'),
	(51034, 112, '2015-02-01 01:03:48.000000', 'temperatura', 1008.0000, 'ºC'),
	(51035, 112, '2015-02-01 01:03:49.000000', 'temperatura', 1006.0000, 'ºC'),
	(51036, 112, '2015-02-01 01:03:50.000000', 'temperatura', 804.0000, 'ºC'),
	(51037, 112, '2015-02-01 01:03:51.000000', 'temperatura', 1002.0000, 'ºC'),
	(51038, 112, '2015-02-01 01:03:52.000000', 'temperatura', 198.0000, 'ºC'),
	(51039, 112, '2015-02-01 01:03:53.000000', 'temperatura', 387.0000, 'ºC'),
	(51040, 112, '2015-02-01 01:03:54.000000', 'temperatura', 142.0000, 'ºC'),
	(51041, 112, '2015-02-01 01:03:55.000000', 'temperatura', 749.0000, 'ºC'),
	(51042, 112, '2015-02-01 01:03:56.000000', 'temperatura', 920.0000, 'ºC'),
	(51043, 112, '2015-02-01 01:03:57.000000', 'temperatura', 1155.0000, 'ºC'),
	(51044, 112, '2015-02-01 01:03:58.000000', 'temperatura', 613.0000, 'ºC'),
	(51045, 112, '2015-02-01 01:03:59.000000', 'temperatura', 802.0000, 'ºC'),
	(51046, 112, '2015-02-01 01:04:00.000000', 'temperatura', 970.0000, 'ºC'),
	(51047, 112, '2015-02-01 01:04:01.000000', 'temperatura', 46.0000, 'ºC'),
	(51048, 112, '2015-02-01 01:04:02.000000', 'temperatura', 918.0000, 'ºC'),
	(51049, 112, '2015-02-01 01:04:03.000000', 'temperatura', 856.0000, 'ºC'),
	(51050, 112, '2015-02-01 01:04:04.000000', 'temperatura', 323.0000, 'ºC'),
	(51051, 112, '2015-02-01 01:04:05.000000', 'temperatura', 249.0000, 'ºC'),
	(51052, 112, '2015-02-01 01:04:06.000000', 'temperatura', 276.0000, 'ºC'),
	(51053, 112, '2015-02-01 01:04:07.000000', 'temperatura', 632.0000, 'ºC'),
	(51054, 112, '2015-02-01 01:04:08.000000', 'temperatura', 1133.0000, 'ºC'),
	(51055, 112, '2015-02-01 01:04:09.000000', 'temperatura', 169.0000, 'ºC'),
	(51056, 112, '2015-02-01 01:04:10.000000', 'temperatura', 1047.0000, 'ºC'),
	(51057, 112, '2015-02-01 01:04:11.000000', 'temperatura', 1131.0000, 'ºC'),
	(51058, 112, '2015-02-01 01:04:12.000000', 'temperatura', 112.0000, 'ºC'),
	(51059, 112, '2015-02-01 01:04:13.000000', 'temperatura', 766.0000, 'ºC'),
	(51060, 112, '2015-02-01 01:04:14.000000', 'temperatura', 1098.0000, 'ºC'),
	(51061, 112, '2015-02-01 01:04:15.000000', 'temperatura', 790.0000, 'ºC'),
	(51062, 112, '2015-02-01 01:04:16.000000', 'temperatura', 657.0000, 'ºC'),
	(51063, 112, '2015-02-01 01:04:17.000000', 'temperatura', 916.0000, 'ºC'),
	(51064, 112, '2015-02-01 01:04:18.000000', 'temperatura', 211.0000, 'ºC'),
	(51065, 112, '2015-02-01 01:04:19.000000', 'temperatura', 705.0000, 'ºC'),
	(51066, 112, '2015-02-01 01:04:20.000000', 'temperatura', 495.0000, 'ºC'),
	(51067, 112, '2015-02-01 01:04:21.000000', 'temperatura', 359.0000, 'ºC'),
	(51068, 112, '2015-02-01 01:04:22.000000', 'temperatura', 313.0000, 'ºC'),
	(51069, 112, '2015-02-01 01:04:23.000000', 'temperatura', 485.0000, 'ºC'),
	(51070, 112, '2015-02-01 01:04:24.000000', 'temperatura', 289.0000, 'ºC'),
	(51071, 112, '2015-02-01 01:04:25.000000', 'temperatura', 1190.0000, 'ºC'),
	(51072, 112, '2015-02-01 01:04:26.000000', 'temperatura', 284.0000, 'ºC'),
	(51073, 112, '2015-02-01 01:04:27.000000', 'temperatura', 248.0000, 'ºC'),
	(51074, 112, '2015-02-01 01:04:28.000000', 'temperatura', 391.0000, 'ºC'),
	(51075, 112, '2015-02-01 01:04:29.000000', 'temperatura', 13.0000, 'ºC'),
	(51076, 112, '2015-02-01 01:04:30.000000', 'temperatura', 90.0000, 'ºC'),
	(51077, 112, '2015-02-01 01:04:31.000000', 'temperatura', 411.0000, 'ºC'),
	(51078, 112, '2015-02-01 01:04:32.000000', 'temperatura', 587.0000, 'ºC'),
	(51079, 112, '2015-02-01 01:04:33.000000', 'temperatura', 502.0000, 'ºC'),
	(51080, 112, '2015-02-01 01:04:34.000000', 'temperatura', 748.0000, 'ºC'),
	(51081, 112, '2015-02-01 01:04:35.000000', 'temperatura', 1035.0000, 'ºC'),
	(51082, 112, '2015-02-01 01:04:36.000000', 'temperatura', 533.0000, 'ºC'),
	(51083, 112, '2015-02-01 01:04:37.000000', 'temperatura', 759.0000, 'ºC'),
	(51084, 112, '2015-02-01 01:04:38.000000', 'temperatura', 995.0000, 'ºC'),
	(51085, 112, '2015-02-01 01:04:39.000000', 'temperatura', 301.0000, 'ºC'),
	(51086, 112, '2015-02-01 01:04:40.000000', 'temperatura', 920.0000, 'ºC'),
	(51087, 112, '2015-02-01 01:04:41.000000', 'temperatura', 98.0000, 'ºC'),
	(51088, 112, '2015-02-01 01:04:42.000000', 'temperatura', 132.0000, 'ºC'),
	(51089, 112, '2015-02-01 01:04:43.000000', 'temperatura', 366.0000, 'ºC'),
	(51090, 112, '2015-02-01 01:04:44.000000', 'temperatura', 233.0000, 'ºC'),
	(51091, 112, '2015-02-01 01:04:45.000000', 'temperatura', 68.0000, 'ºC'),
	(51092, 112, '2015-02-01 01:04:46.000000', 'temperatura', 842.0000, 'ºC'),
	(51093, 112, '2015-02-01 01:04:47.000000', 'temperatura', 408.0000, 'ºC'),
	(51094, 112, '2015-02-01 01:04:48.000000', 'temperatura', 712.0000, 'ºC'),
	(51095, 112, '2015-02-01 01:04:49.000000', 'temperatura', 1135.0000, 'ºC'),
	(51096, 112, '2015-02-01 01:04:50.000000', 'temperatura', 1143.0000, 'ºC'),
	(51097, 112, '2015-02-01 01:04:51.000000', 'temperatura', 1109.0000, 'ºC'),
	(51098, 112, '2015-02-01 01:04:52.000000', 'temperatura', 916.0000, 'ºC'),
	(51099, 112, '2015-02-01 01:04:53.000000', 'temperatura', 56.0000, 'ºC'),
	(51100, 112, '2015-02-01 01:04:54.000000', 'temperatura', 1131.0000, 'ºC'),
	(51101, 112, '2015-02-01 01:04:55.000000', 'temperatura', 685.0000, 'ºC'),
	(51102, 112, '2015-02-01 01:04:56.000000', 'temperatura', 36.0000, 'ºC'),
	(51103, 112, '2015-02-01 01:04:57.000000', 'temperatura', 526.0000, 'ºC'),
	(51104, 112, '2015-02-01 01:04:58.000000', 'temperatura', 120.0000, 'ºC'),
	(51105, 112, '2015-02-01 01:04:59.000000', 'temperatura', 224.0000, 'ºC'),
	(51106, 112, '2015-02-01 01:05:00.000000', 'temperatura', 761.0000, 'ºC'),
	(51107, 112, '2015-02-01 01:05:01.000000', 'temperatura', 732.0000, 'ºC'),
	(51108, 112, '2015-02-01 01:05:02.000000', 'temperatura', 177.0000, 'ºC'),
	(51109, 112, '2015-02-01 01:05:03.000000', 'temperatura', 1092.0000, 'ºC'),
	(51110, 112, '2015-02-01 01:05:04.000000', 'temperatura', 128.0000, 'ºC'),
	(51111, 112, '2015-02-01 01:05:05.000000', 'temperatura', 963.0000, 'ºC'),
	(51112, 112, '2015-02-01 01:05:06.000000', 'temperatura', 834.0000, 'ºC'),
	(51113, 112, '2015-02-01 01:05:07.000000', 'temperatura', 81.0000, 'ºC'),
	(51114, 112, '2015-02-01 01:05:08.000000', 'temperatura', 303.0000, 'ºC'),
	(51115, 112, '2015-02-01 01:05:09.000000', 'temperatura', 74.0000, 'ºC'),
	(51116, 112, '2015-02-01 01:05:10.000000', 'temperatura', 659.0000, 'ºC'),
	(51117, 112, '2015-02-01 01:05:11.000000', 'temperatura', 676.0000, 'ºC'),
	(51118, 112, '2015-02-01 01:05:12.000000', 'temperatura', 203.0000, 'ºC'),
	(51119, 112, '2015-02-01 01:05:13.000000', 'temperatura', 186.0000, 'ºC'),
	(51120, 112, '2015-02-01 01:05:14.000000', 'temperatura', 324.0000, 'ºC'),
	(51121, 112, '2015-02-01 01:05:15.000000', 'temperatura', 1062.0000, 'ºC'),
	(51122, 112, '2015-02-01 01:05:16.000000', 'temperatura', 738.0000, 'ºC'),
	(51123, 112, '2015-02-01 01:05:17.000000', 'temperatura', 506.0000, 'ºC'),
	(51124, 112, '2015-02-01 01:05:18.000000', 'temperatura', 315.0000, 'ºC'),
	(51125, 112, '2015-02-01 01:05:19.000000', 'temperatura', 60.0000, 'ºC'),
	(51126, 112, '2015-02-01 01:05:20.000000', 'temperatura', 553.0000, 'ºC'),
	(51127, 112, '2015-02-01 01:05:21.000000', 'temperatura', 187.0000, 'ºC'),
	(51128, 112, '2015-02-01 01:05:22.000000', 'temperatura', 475.0000, 'ºC'),
	(51129, 112, '2015-02-01 01:05:23.000000', 'temperatura', 615.0000, 'ºC'),
	(51130, 112, '2015-02-01 01:05:24.000000', 'temperatura', 450.0000, 'ºC'),
	(51131, 112, '2015-02-01 01:05:25.000000', 'temperatura', 407.0000, 'ºC'),
	(51132, 112, '2015-02-01 01:05:26.000000', 'temperatura', 686.0000, 'ºC'),
	(51133, 112, '2015-02-01 01:05:27.000000', 'temperatura', 1010.0000, 'ºC'),
	(51134, 112, '2015-02-01 01:05:28.000000', 'temperatura', 589.0000, 'ºC'),
	(51135, 112, '2015-02-01 01:05:29.000000', 'temperatura', 1119.0000, 'ºC'),
	(51136, 112, '2015-02-01 01:05:30.000000', 'temperatura', 228.0000, 'ºC'),
	(51137, 112, '2015-02-01 01:05:31.000000', 'temperatura', 183.0000, 'ºC'),
	(51138, 112, '2015-02-01 01:05:32.000000', 'temperatura', 230.0000, 'ºC'),
	(51139, 112, '2015-02-01 01:05:33.000000', 'temperatura', 601.0000, 'ºC'),
	(51140, 112, '2015-02-01 01:05:34.000000', 'temperatura', 1116.0000, 'ºC'),
	(51141, 112, '2015-02-01 01:05:35.000000', 'temperatura', 178.0000, 'ºC'),
	(51142, 112, '2015-02-01 01:05:36.000000', 'temperatura', 1142.0000, 'ºC'),
	(51143, 112, '2015-02-01 01:05:37.000000', 'temperatura', 376.0000, 'ºC'),
	(51144, 112, '2015-02-01 01:05:38.000000', 'temperatura', 853.0000, 'ºC'),
	(51145, 112, '2015-02-01 01:05:39.000000', 'temperatura', 740.0000, 'ºC'),
	(51146, 112, '2015-02-01 01:05:40.000000', 'temperatura', 1142.0000, 'ºC'),
	(51147, 112, '2015-02-01 01:05:41.000000', 'temperatura', 1089.0000, 'ºC'),
	(51148, 112, '2015-02-01 01:05:42.000000', 'temperatura', 819.0000, 'ºC'),
	(51149, 112, '2015-02-01 01:05:43.000000', 'temperatura', 829.0000, 'ºC'),
	(51150, 112, '2015-02-01 01:05:44.000000', 'temperatura', 490.0000, 'ºC'),
	(51151, 112, '2015-02-01 01:05:45.000000', 'temperatura', 1165.0000, 'ºC'),
	(51152, 112, '2015-02-01 01:05:46.000000', 'temperatura', 752.0000, 'ºC'),
	(51153, 112, '2015-02-01 01:05:47.000000', 'temperatura', 267.0000, 'ºC'),
	(51154, 112, '2015-02-01 01:05:48.000000', 'temperatura', 280.0000, 'ºC'),
	(51155, 112, '2015-02-01 01:05:49.000000', 'temperatura', 598.0000, 'ºC'),
	(51156, 112, '2015-02-01 01:05:50.000000', 'temperatura', 949.0000, 'ºC'),
	(51157, 112, '2015-02-01 01:05:51.000000', 'temperatura', 555.0000, 'ºC'),
	(51158, 112, '2015-02-01 01:05:52.000000', 'temperatura', 1126.0000, 'ºC'),
	(51159, 112, '2015-02-01 01:05:53.000000', 'temperatura', 368.0000, 'ºC'),
	(51160, 112, '2015-02-01 01:05:54.000000', 'temperatura', 862.0000, 'ºC'),
	(51161, 112, '2015-02-01 01:05:55.000000', 'temperatura', 806.0000, 'ºC'),
	(51162, 112, '2015-02-01 01:05:56.000000', 'temperatura', 242.0000, 'ºC'),
	(51163, 112, '2015-02-01 01:05:57.000000', 'temperatura', 1196.0000, 'ºC'),
	(51164, 112, '2015-02-01 01:05:58.000000', 'temperatura', 453.0000, 'ºC'),
	(51165, 112, '2015-02-01 01:05:59.000000', 'temperatura', 1076.0000, 'ºC'),
	(51166, 112, '2015-02-01 01:06:00.000000', 'temperatura', 422.0000, 'ºC'),
	(51167, 112, '2015-02-01 01:06:01.000000', 'temperatura', 84.0000, 'ºC'),
	(51168, 112, '2015-02-01 01:06:02.000000', 'temperatura', 353.0000, 'ºC'),
	(51169, 112, '2015-02-01 01:06:03.000000', 'temperatura', 315.0000, 'ºC'),
	(51170, 112, '2015-02-01 01:06:04.000000', 'temperatura', 518.0000, 'ºC'),
	(51171, 112, '2015-02-01 01:06:05.000000', 'temperatura', 442.0000, 'ºC'),
	(51172, 112, '2015-02-01 01:06:06.000000', 'temperatura', 660.0000, 'ºC'),
	(51173, 112, '2015-02-01 01:06:07.000000', 'temperatura', 773.0000, 'ºC'),
	(51174, 112, '2015-02-01 01:06:08.000000', 'temperatura', 684.0000, 'ºC'),
	(51175, 112, '2015-02-01 01:06:09.000000', 'temperatura', 1103.0000, 'ºC'),
	(51176, 112, '2015-02-01 01:06:10.000000', 'temperatura', 1063.0000, 'ºC'),
	(51177, 112, '2015-02-01 01:06:11.000000', 'temperatura', 808.0000, 'ºC'),
	(51178, 112, '2015-02-01 01:06:12.000000', 'temperatura', 851.0000, 'ºC'),
	(51179, 112, '2015-02-01 01:06:13.000000', 'temperatura', 631.0000, 'ºC'),
	(51180, 112, '2015-02-01 01:06:14.000000', 'temperatura', 601.0000, 'ºC'),
	(51181, 112, '2015-02-01 01:06:15.000000', 'temperatura', 1112.0000, 'ºC'),
	(51182, 112, '2015-02-01 01:06:16.000000', 'temperatura', 158.0000, 'ºC'),
	(51183, 112, '2015-02-01 01:06:17.000000', 'temperatura', 1056.0000, 'ºC'),
	(51184, 112, '2015-02-01 01:06:18.000000', 'temperatura', 8.0000, 'ºC'),
	(51185, 112, '2015-02-01 01:06:19.000000', 'temperatura', 469.0000, 'ºC'),
	(51186, 112, '2015-02-01 01:06:20.000000', 'temperatura', 1124.0000, 'ºC'),
	(51187, 112, '2015-02-01 01:06:21.000000', 'temperatura', 615.0000, 'ºC'),
	(51188, 112, '2015-02-01 01:06:22.000000', 'temperatura', 901.0000, 'ºC'),
	(51189, 112, '2015-02-01 01:06:23.000000', 'temperatura', 262.0000, 'ºC'),
	(51190, 112, '2015-02-01 01:06:24.000000', 'temperatura', 1007.0000, 'ºC'),
	(51191, 112, '2015-02-01 01:06:25.000000', 'temperatura', 647.0000, 'ºC'),
	(51192, 112, '2015-02-01 01:06:26.000000', 'temperatura', 217.0000, 'ºC'),
	(51193, 112, '2015-02-01 01:06:27.000000', 'temperatura', 346.0000, 'ºC'),
	(51194, 112, '2015-02-01 01:06:28.000000', 'temperatura', 1077.0000, 'ºC'),
	(51195, 112, '2015-02-01 01:06:29.000000', 'temperatura', 750.0000, 'ºC'),
	(51196, 112, '2015-02-01 01:06:30.000000', 'temperatura', 519.0000, 'ºC'),
	(51197, 112, '2015-02-01 01:06:31.000000', 'temperatura', 345.0000, 'ºC'),
	(51198, 112, '2015-02-01 01:06:32.000000', 'temperatura', 167.0000, 'ºC'),
	(51199, 112, '2015-02-01 01:06:33.000000', 'temperatura', 1000.0000, 'ºC'),
	(51200, 112, '2015-02-01 01:06:34.000000', 'temperatura', 901.0000, 'ºC'),
	(51201, 112, '2015-02-01 01:06:35.000000', 'temperatura', 307.0000, 'ºC'),
	(51202, 112, '2015-02-01 01:06:36.000000', 'temperatura', 30.0000, 'ºC'),
	(51203, 112, '2015-02-01 01:06:37.000000', 'temperatura', 430.0000, 'ºC'),
	(51204, 112, '2015-02-01 01:06:38.000000', 'temperatura', 860.0000, 'ºC'),
	(51205, 112, '2015-02-01 01:06:39.000000', 'temperatura', 609.0000, 'ºC'),
	(51206, 112, '2015-02-01 01:06:40.000000', 'temperatura', 467.0000, 'ºC'),
	(51207, 112, '2015-02-01 01:06:41.000000', 'temperatura', 507.0000, 'ºC'),
	(51208, 112, '2015-02-01 01:06:42.000000', 'temperatura', 1138.0000, 'ºC'),
	(51209, 112, '2015-02-01 01:06:43.000000', 'temperatura', 566.0000, 'ºC'),
	(51210, 112, '2015-02-01 01:06:44.000000', 'temperatura', 616.0000, 'ºC'),
	(51211, 112, '2015-02-01 01:06:45.000000', 'temperatura', 186.0000, 'ºC'),
	(51212, 112, '2015-02-01 01:06:46.000000', 'temperatura', 279.0000, 'ºC'),
	(51213, 112, '2015-02-01 01:06:47.000000', 'temperatura', 839.0000, 'ºC'),
	(51214, 112, '2015-02-01 01:06:48.000000', 'temperatura', 960.0000, 'ºC'),
	(51215, 112, '2015-02-01 01:06:49.000000', 'temperatura', 1083.0000, 'ºC'),
	(51216, 112, '2015-02-01 01:06:50.000000', 'temperatura', 134.0000, 'ºC'),
	(51217, 112, '2015-02-01 01:06:51.000000', 'temperatura', 1021.0000, 'ºC'),
	(51218, 112, '2015-02-01 01:06:52.000000', 'temperatura', 1102.0000, 'ºC'),
	(51219, 112, '2015-02-01 01:06:53.000000', 'temperatura', 51.0000, 'ºC'),
	(51220, 112, '2015-02-01 01:06:54.000000', 'temperatura', 549.0000, 'ºC'),
	(51221, 112, '2015-02-01 01:06:55.000000', 'temperatura', 192.0000, 'ºC'),
	(51222, 112, '2015-02-01 01:06:56.000000', 'temperatura', 514.0000, 'ºC'),
	(51223, 112, '2015-02-01 01:06:57.000000', 'temperatura', 795.0000, 'ºC'),
	(51224, 112, '2015-02-01 01:06:58.000000', 'temperatura', 32.0000, 'ºC'),
	(51225, 112, '2015-02-01 01:06:59.000000', 'temperatura', 176.0000, 'ºC'),
	(51226, 112, '2015-02-01 01:07:00.000000', 'temperatura', 786.0000, 'ºC'),
	(51227, 112, '2015-02-01 01:07:01.000000', 'temperatura', 1000.0000, 'ºC'),
	(51228, 112, '2015-02-01 01:07:02.000000', 'temperatura', 245.0000, 'ºC'),
	(51229, 112, '2015-02-01 01:07:03.000000', 'temperatura', 625.0000, 'ºC'),
	(51230, 112, '2015-02-01 01:07:04.000000', 'temperatura', 1189.0000, 'ºC'),
	(51231, 112, '2015-02-01 01:07:05.000000', 'temperatura', 470.0000, 'ºC'),
	(51232, 112, '2015-02-01 01:07:06.000000', 'temperatura', 1183.0000, 'ºC'),
	(51233, 112, '2015-02-01 01:07:07.000000', 'temperatura', 908.0000, 'ºC'),
	(51234, 112, '2015-02-01 01:07:08.000000', 'temperatura', 991.0000, 'ºC'),
	(51235, 112, '2015-02-01 01:07:09.000000', 'temperatura', 1032.0000, 'ºC'),
	(51236, 112, '2015-02-01 01:07:10.000000', 'temperatura', 987.0000, 'ºC'),
	(51237, 112, '2015-02-01 01:07:11.000000', 'temperatura', 639.0000, 'ºC'),
	(51238, 112, '2015-02-01 01:07:12.000000', 'temperatura', 236.0000, 'ºC'),
	(51239, 112, '2015-02-01 01:07:13.000000', 'temperatura', 462.0000, 'ºC'),
	(51240, 112, '2015-02-01 01:07:14.000000', 'temperatura', 403.0000, 'ºC'),
	(51241, 112, '2015-02-01 01:07:15.000000', 'temperatura', 629.0000, 'ºC'),
	(51242, 112, '2015-02-01 01:07:16.000000', 'temperatura', 737.0000, 'ºC'),
	(51243, 112, '2015-02-01 01:07:17.000000', 'temperatura', 599.0000, 'ºC'),
	(51244, 112, '2015-02-01 01:07:18.000000', 'temperatura', 784.0000, 'ºC'),
	(51245, 112, '2015-02-01 01:07:19.000000', 'temperatura', 925.0000, 'ºC'),
	(51246, 112, '2015-02-01 01:07:20.000000', 'temperatura', 1072.0000, 'ºC'),
	(51247, 112, '2015-02-01 01:07:21.000000', 'temperatura', 185.0000, 'ºC'),
	(51248, 112, '2015-02-01 01:07:22.000000', 'temperatura', 109.0000, 'ºC'),
	(51249, 112, '2015-02-01 01:07:23.000000', 'temperatura', 1190.0000, 'ºC'),
	(51250, 112, '2015-02-01 01:07:24.000000', 'temperatura', 826.0000, 'ºC'),
	(51251, 112, '2015-02-01 01:07:25.000000', 'temperatura', 558.0000, 'ºC'),
	(51252, 112, '2015-02-01 01:07:26.000000', 'temperatura', 312.0000, 'ºC'),
	(51253, 112, '2015-02-01 01:07:27.000000', 'temperatura', 1088.0000, 'ºC'),
	(51254, 112, '2015-02-01 01:07:28.000000', 'temperatura', 903.0000, 'ºC'),
	(51255, 112, '2015-02-01 01:07:29.000000', 'temperatura', 52.0000, 'ºC'),
	(51256, 112, '2015-02-01 01:07:30.000000', 'temperatura', 1153.0000, 'ºC'),
	(51257, 112, '2015-02-01 01:07:31.000000', 'temperatura', 809.0000, 'ºC'),
	(51258, 112, '2015-02-01 01:07:32.000000', 'temperatura', 587.0000, 'ºC'),
	(51259, 112, '2015-02-01 01:07:33.000000', 'temperatura', 508.0000, 'ºC'),
	(51260, 112, '2015-02-01 01:07:34.000000', 'temperatura', 780.0000, 'ºC'),
	(51261, 112, '2015-02-01 01:07:35.000000', 'temperatura', 1178.0000, 'ºC'),
	(51262, 112, '2015-02-01 01:07:36.000000', 'temperatura', 1149.0000, 'ºC'),
	(51263, 112, '2015-02-01 01:07:37.000000', 'temperatura', 1010.0000, 'ºC'),
	(51264, 112, '2015-02-01 01:07:38.000000', 'temperatura', 404.0000, 'ºC'),
	(51265, 112, '2015-02-01 01:07:39.000000', 'temperatura', 191.0000, 'ºC'),
	(51266, 112, '2015-02-01 01:07:40.000000', 'temperatura', 943.0000, 'ºC'),
	(51267, 112, '2015-02-01 01:07:41.000000', 'temperatura', 542.0000, 'ºC'),
	(51268, 112, '2015-02-01 01:07:42.000000', 'temperatura', 1080.0000, 'ºC'),
	(51269, 112, '2015-02-01 01:07:43.000000', 'temperatura', 176.0000, 'ºC'),
	(51270, 112, '2015-02-01 01:07:44.000000', 'temperatura', 41.0000, 'ºC'),
	(51271, 112, '2015-02-01 01:07:45.000000', 'temperatura', 876.0000, 'ºC'),
	(51272, 112, '2015-02-01 01:07:46.000000', 'temperatura', 660.0000, 'ºC'),
	(51273, 112, '2015-02-01 01:07:47.000000', 'temperatura', 671.0000, 'ºC'),
	(51274, 112, '2015-02-01 01:07:48.000000', 'temperatura', 178.0000, 'ºC'),
	(51275, 112, '2015-02-01 01:07:49.000000', 'temperatura', 74.0000, 'ºC'),
	(51276, 112, '2015-02-01 01:07:50.000000', 'temperatura', 1040.0000, 'ºC'),
	(51277, 112, '2015-02-01 01:07:51.000000', 'temperatura', 175.0000, 'ºC'),
	(51278, 112, '2015-02-01 01:07:52.000000', 'temperatura', 156.0000, 'ºC'),
	(51279, 112, '2015-02-01 01:07:53.000000', 'temperatura', 257.0000, 'ºC'),
	(51280, 112, '2015-02-01 01:07:54.000000', 'temperatura', 818.0000, 'ºC'),
	(51281, 112, '2015-02-01 01:07:55.000000', 'temperatura', 919.0000, 'ºC'),
	(51282, 112, '2015-02-01 01:07:56.000000', 'temperatura', 939.0000, 'ºC'),
	(51283, 112, '2015-02-01 01:07:57.000000', 'temperatura', 741.0000, 'ºC'),
	(51284, 112, '2015-02-01 01:07:58.000000', 'temperatura', 887.0000, 'ºC'),
	(51285, 112, '2015-02-01 01:07:59.000000', 'temperatura', 1014.0000, 'ºC'),
	(51286, 112, '2015-02-01 01:08:00.000000', 'temperatura', 11.0000, 'ºC'),
	(51287, 112, '2015-02-01 01:08:01.000000', 'temperatura', 612.0000, 'ºC'),
	(51288, 112, '2015-02-01 01:08:02.000000', 'temperatura', 625.0000, 'ºC'),
	(51289, 112, '2015-02-01 01:08:03.000000', 'temperatura', 93.0000, 'ºC'),
	(51290, 112, '2015-02-01 01:08:04.000000', 'temperatura', 989.0000, 'ºC'),
	(51291, 112, '2015-02-01 01:08:05.000000', 'temperatura', 1066.0000, 'ºC'),
	(51292, 112, '2015-02-01 01:08:06.000000', 'temperatura', 1166.0000, 'ºC'),
	(51293, 112, '2015-02-01 01:08:07.000000', 'temperatura', 229.0000, 'ºC'),
	(51294, 112, '2015-02-01 01:08:08.000000', 'temperatura', 50.0000, 'ºC'),
	(51295, 112, '2015-02-01 01:08:09.000000', 'temperatura', 765.0000, 'ºC'),
	(51296, 112, '2015-02-01 01:08:10.000000', 'temperatura', 73.0000, 'ºC'),
	(51297, 112, '2015-02-01 01:08:11.000000', 'temperatura', 471.0000, 'ºC'),
	(51298, 112, '2015-02-01 01:08:12.000000', 'temperatura', 937.0000, 'ºC'),
	(51299, 112, '2015-02-01 01:08:13.000000', 'temperatura', 873.0000, 'ºC'),
	(51300, 112, '2015-02-01 01:08:14.000000', 'temperatura', 354.0000, 'ºC'),
	(51301, 112, '2015-02-01 01:08:15.000000', 'temperatura', 350.0000, 'ºC'),
	(51302, 112, '2015-02-01 01:08:16.000000', 'temperatura', 687.0000, 'ºC'),
	(51303, 112, '2015-02-01 01:08:17.000000', 'temperatura', 1189.0000, 'ºC'),
	(51304, 112, '2015-02-01 01:08:18.000000', 'temperatura', 284.0000, 'ºC'),
	(51305, 112, '2015-02-01 01:08:19.000000', 'temperatura', 251.0000, 'ºC'),
	(51306, 112, '2015-02-01 01:08:20.000000', 'temperatura', 407.0000, 'ºC'),
	(51307, 112, '2015-02-01 01:08:21.000000', 'temperatura', 81.0000, 'ºC'),
	(51308, 112, '2015-02-01 01:08:22.000000', 'temperatura', 383.0000, 'ºC'),
	(51309, 112, '2015-02-01 01:08:23.000000', 'temperatura', 473.0000, 'ºC'),
	(51310, 112, '2015-02-01 01:08:24.000000', 'temperatura', 19.0000, 'ºC'),
	(51311, 112, '2015-02-01 01:08:25.000000', 'temperatura', 1074.0000, 'ºC'),
	(51312, 112, '2015-02-01 01:08:26.000000', 'temperatura', 516.0000, 'ºC'),
	(51313, 112, '2015-02-01 01:08:27.000000', 'temperatura', 557.0000, 'ºC'),
	(51314, 112, '2015-02-01 01:08:28.000000', 'temperatura', 36.0000, 'ºC'),
	(51315, 112, '2015-02-01 01:08:29.000000', 'temperatura', 912.0000, 'ºC'),
	(51316, 112, '2015-02-01 01:08:30.000000', 'temperatura', 850.0000, 'ºC'),
	(51317, 112, '2015-02-01 01:08:31.000000', 'temperatura', 316.0000, 'ºC'),
	(51318, 112, '2015-02-01 01:08:32.000000', 'temperatura', 229.0000, 'ºC'),
	(51319, 112, '2015-02-01 01:08:33.000000', 'temperatura', 198.0000, 'ºC'),
	(51320, 112, '2015-02-01 01:08:34.000000', 'temperatura', 303.0000, 'ºC'),
	(51321, 112, '2015-02-01 01:08:35.000000', 'temperatura', 924.0000, 'ºC'),
	(51322, 112, '2015-02-01 01:08:36.000000', 'temperatura', 110.0000, 'ºC'),
	(51323, 112, '2015-02-01 01:08:37.000000', 'temperatura', 177.0000, 'ºC'),
	(51324, 112, '2015-02-01 01:08:38.000000', 'temperatura', 558.0000, 'ºC'),
	(51325, 112, '2015-02-01 01:08:39.000000', 'temperatura', 1057.0000, 'ºC'),
	(51326, 112, '2015-02-01 01:08:40.000000', 'temperatura', 14.0000, 'ºC'),
	(51327, 112, '2015-02-01 01:08:41.000000', 'temperatura', 500.0000, 'ºC'),
	(51328, 112, '2015-02-01 01:08:42.000000', 'temperatura', 56.0000, 'ºC'),
	(51329, 112, '2015-02-01 01:08:43.000000', 'temperatura', 1180.0000, 'ºC'),
	(51330, 112, '2015-02-01 01:08:44.000000', 'temperatura', 935.0000, 'ºC'),
	(51331, 112, '2015-02-01 01:08:45.000000', 'temperatura', 1134.0000, 'ºC'),
	(51332, 112, '2015-02-01 01:08:46.000000', 'temperatura', 467.0000, 'ºC'),
	(51333, 112, '2015-02-01 01:08:47.000000', 'temperatura', 131.0000, 'ºC'),
	(51334, 112, '2015-02-01 01:08:48.000000', 'temperatura', 456.0000, 'ºC'),
	(51335, 112, '2015-02-01 01:08:49.000000', 'temperatura', 687.0000, 'ºC'),
	(51336, 112, '2015-02-01 01:08:50.000000', 'temperatura', 866.0000, 'ºC'),
	(51337, 112, '2015-02-01 01:08:51.000000', 'temperatura', 1069.0000, 'ºC'),
	(51338, 112, '2015-02-01 01:08:52.000000', 'temperatura', 348.0000, 'ºC'),
	(51339, 112, '2015-02-01 01:08:53.000000', 'temperatura', 933.0000, 'ºC'),
	(51340, 112, '2015-02-01 01:08:54.000000', 'temperatura', 20.0000, 'ºC'),
	(51341, 112, '2015-02-01 01:08:55.000000', 'temperatura', 905.0000, 'ºC'),
	(51342, 112, '2015-02-01 01:08:56.000000', 'temperatura', 864.0000, 'ºC'),
	(51343, 112, '2015-02-01 01:08:57.000000', 'temperatura', 407.0000, 'ºC'),
	(51344, 112, '2015-02-01 01:08:58.000000', 'temperatura', 643.0000, 'ºC'),
	(51345, 112, '2015-02-01 01:08:59.000000', 'temperatura', 795.0000, 'ºC'),
	(51346, 112, '2015-02-01 01:09:00.000000', 'temperatura', 845.0000, 'ºC'),
	(51347, 112, '2015-02-01 01:09:01.000000', 'temperatura', 641.0000, 'ºC'),
	(51348, 112, '2015-02-01 01:09:02.000000', 'temperatura', 672.0000, 'ºC'),
	(51349, 112, '2015-02-01 01:09:03.000000', 'temperatura', 235.0000, 'ºC'),
	(51350, 112, '2015-02-01 01:09:04.000000', 'temperatura', 362.0000, 'ºC'),
	(51351, 112, '2015-02-01 01:09:05.000000', 'temperatura', 1103.0000, 'ºC'),
	(51352, 112, '2015-02-01 01:09:06.000000', 'temperatura', 832.0000, 'ºC'),
	(51353, 112, '2015-02-01 01:09:07.000000', 'temperatura', 849.0000, 'ºC'),
	(51354, 108, '2015-02-15 00:00:00.000000', 'temperatura', 210.0000, 'ºC'),
	(51355, 108, '2015-02-15 00:00:01.000000', 'temperatura', 594.0000, 'ºC'),
	(51356, 108, '2015-02-15 00:00:02.000000', 'temperatura', 1143.0000, 'ºC'),
	(51357, 108, '2015-02-15 00:00:03.000000', 'temperatura', 334.0000, 'ºC'),
	(51358, 108, '2015-02-15 00:00:04.000000', 'temperatura', 641.0000, 'ºC'),
	(51359, 108, '2015-02-15 00:00:05.000000', 'temperatura', 1003.0000, 'ºC'),
	(51360, 108, '2015-02-15 00:00:06.000000', 'temperatura', 691.0000, 'ºC'),
	(51361, 108, '2015-02-15 00:00:07.000000', 'temperatura', 446.0000, 'ºC'),
	(51362, 108, '2015-02-15 00:00:08.000000', 'temperatura', 158.0000, 'ºC'),
	(51363, 108, '2015-02-15 00:00:09.000000', 'temperatura', 655.0000, 'ºC'),
	(51364, 108, '2015-02-15 00:00:10.000000', 'temperatura', 399.0000, 'ºC'),
	(51365, 108, '2015-02-15 00:00:11.000000', 'temperatura', 30.0000, 'ºC'),
	(51366, 108, '2015-02-15 00:00:12.000000', 'temperatura', 155.0000, 'ºC'),
	(51367, 108, '2015-02-15 00:00:13.000000', 'temperatura', 684.0000, 'ºC'),
	(51368, 108, '2015-02-15 00:00:14.000000', 'temperatura', 558.0000, 'ºC'),
	(51369, 108, '2015-02-15 00:00:15.000000', 'temperatura', 737.0000, 'ºC'),
	(51370, 108, '2015-02-15 00:00:16.000000', 'temperatura', 813.0000, 'ºC'),
	(51371, 108, '2015-02-15 00:00:17.000000', 'temperatura', 654.0000, 'ºC'),
	(51372, 108, '2015-02-15 00:00:18.000000', 'temperatura', 831.0000, 'ºC'),
	(51373, 108, '2015-02-15 00:00:19.000000', 'temperatura', 994.0000, 'ºC'),
	(51374, 108, '2015-02-15 00:00:20.000000', 'temperatura', 79.0000, 'ºC'),
	(51375, 108, '2015-02-15 00:00:21.000000', 'temperatura', 1012.0000, 'ºC'),
	(51376, 108, '2015-02-15 00:00:22.000000', 'temperatura', 23.0000, 'ºC'),
	(51377, 108, '2015-02-15 00:00:23.000000', 'temperatura', 681.0000, 'ºC'),
	(51378, 108, '2015-02-15 00:00:24.000000', 'temperatura', 934.0000, 'ºC'),
	(51379, 108, '2015-02-15 00:00:25.000000', 'temperatura', 228.0000, 'ºC'),
	(51380, 108, '2015-02-15 00:00:26.000000', 'temperatura', 741.0000, 'ºC'),
	(51381, 108, '2015-02-15 00:00:27.000000', 'temperatura', 619.0000, 'ºC'),
	(51382, 108, '2015-02-15 00:00:28.000000', 'temperatura', 873.0000, 'ºC'),
	(51383, 108, '2015-02-15 00:00:29.000000', 'temperatura', 107.0000, 'ºC'),
	(51384, 108, '2015-02-15 00:00:30.000000', 'temperatura', 319.0000, 'ºC'),
	(51385, 108, '2015-02-15 00:00:31.000000', 'temperatura', 72.0000, 'ºC'),
	(51386, 108, '2015-02-15 00:00:32.000000', 'temperatura', 603.0000, 'ºC'),
	(51387, 108, '2015-02-15 00:00:33.000000', 'temperatura', 399.0000, 'ºC'),
	(51388, 108, '2015-02-15 00:00:34.000000', 'temperatura', 188.0000, 'ºC'),
	(51389, 108, '2015-02-15 00:00:35.000000', 'temperatura', 945.0000, 'ºC'),
	(51390, 108, '2015-02-15 00:00:36.000000', 'temperatura', 560.0000, 'ºC'),
	(51391, 108, '2015-02-15 00:00:37.000000', 'temperatura', 1166.0000, 'ºC'),
	(51392, 108, '2015-02-15 00:00:38.000000', 'temperatura', 549.0000, 'ºC'),
	(51393, 108, '2015-02-15 00:00:39.000000', 'temperatura', 450.0000, 'ºC'),
	(51394, 108, '2015-02-15 00:00:40.000000', 'temperatura', 603.0000, 'ºC'),
	(51395, 108, '2015-02-15 00:00:41.000000', 'temperatura', 466.0000, 'ºC'),
	(51396, 108, '2015-02-15 00:00:42.000000', 'temperatura', 521.0000, 'ºC'),
	(51397, 108, '2015-02-15 00:00:43.000000', 'temperatura', 8.0000, 'ºC'),
	(51398, 108, '2015-02-15 00:00:44.000000', 'temperatura', 879.0000, 'ºC'),
	(51399, 108, '2015-02-15 00:00:45.000000', 'temperatura', 771.0000, 'ºC'),
	(51400, 108, '2015-02-15 00:00:46.000000', 'temperatura', 17.0000, 'ºC'),
	(51401, 108, '2015-02-15 00:00:47.000000', 'temperatura', 173.0000, 'ºC'),
	(51402, 108, '2015-02-15 00:00:48.000000', 'temperatura', 815.0000, 'ºC'),
	(51403, 108, '2015-02-15 00:00:49.000000', 'temperatura', 1155.0000, 'ºC'),
	(51404, 108, '2015-02-15 00:00:50.000000', 'temperatura', 931.0000, 'ºC'),
	(51405, 108, '2015-02-15 00:00:51.000000', 'temperatura', 1192.0000, 'ºC'),
	(51406, 108, '2015-02-15 00:00:52.000000', 'temperatura', 768.0000, 'ºC'),
	(51407, 108, '2015-02-15 00:00:53.000000', 'temperatura', 265.0000, 'ºC'),
	(51408, 108, '2015-02-15 00:00:54.000000', 'temperatura', 220.0000, 'ºC'),
	(51409, 108, '2015-02-15 00:00:55.000000', 'temperatura', 304.0000, 'ºC'),
	(51410, 108, '2015-02-15 00:00:56.000000', 'temperatura', 863.0000, 'ºC'),
	(51411, 108, '2015-02-15 00:00:57.000000', 'temperatura', 1004.0000, 'ºC'),
	(51412, 108, '2015-02-15 00:00:58.000000', 'temperatura', 32.0000, 'ºC'),
	(51413, 108, '2015-02-15 00:00:59.000000', 'temperatura', 748.0000, 'ºC'),
	(51414, 108, '2015-02-15 00:01:00.000000', 'temperatura', 45.0000, 'ºC'),
	(51415, 108, '2015-02-15 00:01:01.000000', 'temperatura', 383.0000, 'ºC'),
	(51416, 108, '2015-02-15 00:01:02.000000', 'temperatura', 578.0000, 'ºC'),
	(51417, 108, '2015-02-15 00:01:03.000000', 'temperatura', 544.0000, 'ºC'),
	(51418, 108, '2015-02-15 00:01:04.000000', 'temperatura', 984.0000, 'ºC'),
	(51419, 108, '2015-02-15 00:01:05.000000', 'temperatura', 891.0000, 'ºC'),
	(51420, 108, '2015-02-15 00:01:06.000000', 'temperatura', 302.0000, 'ºC'),
	(51421, 108, '2015-02-15 00:01:07.000000', 'temperatura', 39.0000, 'ºC'),
	(51422, 108, '2015-02-15 00:01:08.000000', 'temperatura', 488.0000, 'ºC'),
	(51423, 108, '2015-02-15 00:01:09.000000', 'temperatura', 1124.0000, 'ºC'),
	(51424, 108, '2015-02-15 00:01:10.000000', 'temperatura', 558.0000, 'ºC'),
	(51425, 108, '2015-02-15 00:01:11.000000', 'temperatura', 617.0000, 'ºC'),
	(51426, 108, '2015-02-15 00:01:12.000000', 'temperatura', 214.0000, 'ºC'),
	(51427, 108, '2015-02-15 00:01:13.000000', 'temperatura', 416.0000, 'ºC'),
	(51428, 108, '2015-02-15 00:01:14.000000', 'temperatura', 241.0000, 'ºC'),
	(51429, 108, '2015-02-15 00:01:15.000000', 'temperatura', 1155.0000, 'ºC'),
	(51430, 108, '2015-02-15 00:01:16.000000', 'temperatura', 255.0000, 'ºC'),
	(51431, 108, '2015-02-15 00:01:17.000000', 'temperatura', 210.0000, 'ºC'),
	(51432, 108, '2015-02-15 00:01:18.000000', 'temperatura', 285.0000, 'ºC'),
	(51433, 108, '2015-02-15 00:01:19.000000', 'temperatura', 798.0000, 'ºC'),
	(51434, 108, '2015-02-15 00:01:20.000000', 'temperatura', 732.0000, 'ºC'),
	(51435, 108, '2015-02-15 00:01:21.000000', 'temperatura', 67.0000, 'ºC'),
	(51436, 108, '2015-02-15 00:01:22.000000', 'temperatura', 541.0000, 'ºC'),
	(51437, 108, '2015-02-15 00:01:23.000000', 'temperatura', 105.0000, 'ºC'),
	(51438, 108, '2015-02-15 00:01:24.000000', 'temperatura', 103.0000, 'ºC'),
	(51439, 108, '2015-02-15 00:01:25.000000', 'temperatura', 198.0000, 'ºC'),
	(51440, 108, '2015-02-15 00:01:26.000000', 'temperatura', 681.0000, 'ºC'),
	(51441, 108, '2015-02-15 00:01:27.000000', 'temperatura', 415.0000, 'ºC'),
	(51442, 108, '2015-02-15 00:01:28.000000', 'temperatura', 30.0000, 'ºC'),
	(51443, 108, '2015-02-15 00:01:29.000000', 'temperatura', 105.0000, 'ºC'),
	(51444, 108, '2015-02-15 00:01:30.000000', 'temperatura', 436.0000, 'ºC'),
	(51445, 108, '2015-02-15 00:01:31.000000', 'temperatura', 667.0000, 'ºC'),
	(51446, 108, '2015-02-15 00:01:32.000000', 'temperatura', 827.0000, 'ºC'),
	(51447, 108, '2015-02-15 00:01:33.000000', 'temperatura', 934.0000, 'ºC'),
	(51448, 108, '2015-02-15 00:01:34.000000', 'temperatura', 991.0000, 'ºC'),
	(51449, 108, '2015-02-15 00:01:35.000000', 'temperatura', 954.0000, 'ºC'),
	(51450, 108, '2015-02-15 00:01:36.000000', 'temperatura', 595.0000, 'ºC'),
	(51451, 108, '2015-02-15 00:01:37.000000', 'temperatura', 117.0000, 'ºC'),
	(51452, 108, '2015-02-15 00:01:38.000000', 'temperatura', 1197.0000, 'ºC'),
	(51453, 108, '2015-02-15 00:01:39.000000', 'temperatura', 834.0000, 'ºC'),
	(51454, 108, '2015-02-15 00:01:40.000000', 'temperatura', 582.0000, 'ºC'),
	(51455, 108, '2015-02-15 00:01:41.000000', 'temperatura', 407.0000, 'ºC'),
	(51456, 108, '2015-02-15 00:01:42.000000', 'temperatura', 291.0000, 'ºC'),
	(51457, 108, '2015-02-15 00:01:43.000000', 'temperatura', 234.0000, 'ºC'),
	(51458, 108, '2015-02-15 00:01:44.000000', 'temperatura', 297.0000, 'ºC'),
	(51459, 108, '2015-02-15 00:01:45.000000', 'temperatura', 786.0000, 'ºC'),
	(51460, 108, '2015-02-15 00:01:46.000000', 'temperatura', 636.0000, 'ºC'),
	(51461, 108, '2015-02-15 00:01:47.000000', 'temperatura', 823.0000, 'ºC'),
	(51462, 108, '2015-02-15 00:01:48.000000', 'temperatura', 1008.0000, 'ºC'),
	(51463, 108, '2015-02-15 00:01:49.000000', 'temperatura', 172.0000, 'ºC'),
	(51464, 108, '2015-02-15 00:01:50.000000', 'temperatura', 235.0000, 'ºC'),
	(51465, 108, '2015-02-15 00:01:51.000000', 'temperatura', 659.0000, 'ºC'),
	(51466, 108, '2015-02-15 00:01:52.000000', 'temperatura', 189.0000, 'ºC'),
	(51467, 108, '2015-02-15 00:01:53.000000', 'temperatura', 172.0000, 'ºC'),
	(51468, 108, '2015-02-15 00:01:54.000000', 'temperatura', 291.0000, 'ºC'),
	(51469, 108, '2015-02-15 00:01:55.000000', 'temperatura', 939.0000, 'ºC'),
	(51470, 108, '2015-02-15 00:01:56.000000', 'temperatura', 224.0000, 'ºC'),
	(51471, 108, '2015-02-15 00:01:57.000000', 'temperatura', 703.0000, 'ºC'),
	(51472, 108, '2015-02-15 00:01:58.000000', 'temperatura', 441.0000, 'ºC'),
	(51473, 108, '2015-02-15 00:01:59.000000', 'temperatura', 100.0000, 'ºC'),
	(51474, 108, '2015-02-15 00:02:00.000000', 'temperatura', 377.0000, 'ºC'),
	(51475, 108, '2015-02-15 00:02:01.000000', 'temperatura', 385.0000, 'ºC'),
	(51476, 108, '2015-02-15 00:02:02.000000', 'temperatura', 795.0000, 'ºC'),
	(51477, 108, '2015-02-15 00:02:03.000000', 'temperatura', 420.0000, 'ºC'),
	(51478, 108, '2015-02-15 00:02:04.000000', 'temperatura', 917.0000, 'ºC'),
	(51479, 108, '2015-02-15 00:02:05.000000', 'temperatura', 924.0000, 'ºC'),
	(51480, 108, '2015-02-15 00:02:06.000000', 'temperatura', 671.0000, 'ºC'),
	(51481, 108, '2015-02-15 00:02:07.000000', 'temperatura', 583.0000, 'ºC'),
	(51482, 108, '2015-02-15 00:02:08.000000', 'temperatura', 903.0000, 'ºC'),
	(51483, 108, '2015-02-15 00:02:09.000000', 'temperatura', 367.0000, 'ºC'),
	(51484, 108, '2015-02-15 00:02:10.000000', 'temperatura', 327.0000, 'ºC'),
	(51485, 108, '2015-02-15 00:02:11.000000', 'temperatura', 536.0000, 'ºC'),
	(51486, 108, '2015-02-15 00:02:12.000000', 'temperatura', 497.0000, 'ºC'),
	(51487, 108, '2015-02-15 00:02:13.000000', 'temperatura', 878.0000, 'ºC'),
	(51488, 108, '2015-02-15 00:02:14.000000', 'temperatura', 498.0000, 'ºC'),
	(51489, 108, '2015-02-15 00:02:15.000000', 'temperatura', 1056.0000, 'ºC'),
	(51490, 108, '2015-02-15 00:02:16.000000', 'temperatura', 185.0000, 'ºC'),
	(51491, 108, '2015-02-15 00:02:17.000000', 'temperatura', 161.0000, 'ºC'),
	(51492, 108, '2015-02-15 00:02:18.000000', 'temperatura', 251.0000, 'ºC'),
	(51493, 108, '2015-02-15 00:02:19.000000', 'temperatura', 771.0000, 'ºC'),
	(51494, 108, '2015-02-15 00:02:20.000000', 'temperatura', 703.0000, 'ºC'),
	(51495, 108, '2015-02-15 00:02:21.000000', 'temperatura', 3.0000, 'ºC'),
	(51496, 108, '2015-02-15 00:02:22.000000', 'temperatura', 306.0000, 'ºC'),
	(51497, 108, '2015-02-15 00:02:23.000000', 'temperatura', 320.0000, 'ºC'),
	(51498, 108, '2015-02-15 00:02:24.000000', 'temperatura', 684.0000, 'ºC'),
	(51499, 108, '2015-02-15 00:02:25.000000', 'temperatura', 59.0000, 'ºC'),
	(51500, 108, '2015-02-15 00:02:26.000000', 'temperatura', 644.0000, 'ºC'),
	(51501, 108, '2015-02-15 00:02:27.000000', 'temperatura', 644.0000, 'ºC'),
	(51502, 108, '2015-02-15 00:02:28.000000', 'temperatura', 90.0000, 'ºC'),
	(51503, 108, '2015-02-15 00:02:29.000000', 'temperatura', 917.0000, 'ºC'),
	(51504, 108, '2015-02-15 00:02:30.000000', 'temperatura', 716.0000, 'ºC'),
	(51505, 108, '2015-02-15 00:02:31.000000', 'temperatura', 827.0000, 'ºC'),
	(51506, 108, '2015-02-15 00:02:32.000000', 'temperatura', 790.0000, 'ºC'),
	(51507, 108, '2015-02-15 00:02:33.000000', 'temperatura', 269.0000, 'ºC'),
	(51508, 108, '2015-02-15 00:02:34.000000', 'temperatura', 176.0000, 'ºC'),
	(51509, 108, '2015-02-15 00:02:35.000000', 'temperatura', 75.0000, 'ºC'),
	(51510, 108, '2015-02-15 00:02:36.000000', 'temperatura', 1046.0000, 'ºC'),
	(51511, 108, '2015-02-15 00:02:37.000000', 'temperatura', 205.0000, 'ºC'),
	(51512, 108, '2015-02-15 00:02:38.000000', 'temperatura', 288.0000, 'ºC'),
	(51513, 108, '2015-02-15 00:02:39.000000', 'temperatura', 827.0000, 'ºC'),
	(51514, 108, '2015-02-15 00:02:40.000000', 'temperatura', 871.0000, 'ºC'),
	(51515, 108, '2015-02-15 00:02:41.000000', 'temperatura', 675.0000, 'ºC'),
	(51516, 108, '2015-02-15 00:02:42.000000', 'temperatura', 761.0000, 'ºC'),
	(51517, 108, '2015-02-15 00:02:43.000000', 'temperatura', 582.0000, 'ºC'),
	(51518, 108, '2015-02-15 00:02:44.000000', 'temperatura', 628.0000, 'ºC'),
	(51519, 108, '2015-02-15 00:02:45.000000', 'temperatura', 195.0000, 'ºC'),
	(51520, 108, '2015-02-15 00:02:46.000000', 'temperatura', 289.0000, 'ºC'),
	(51521, 108, '2015-02-15 00:02:47.000000', 'temperatura', 862.0000, 'ºC'),
	(51522, 108, '2015-02-15 00:02:48.000000', 'temperatura', 1043.0000, 'ºC'),
	(51523, 108, '2015-02-15 00:02:49.000000', 'temperatura', 229.0000, 'ºC'),
	(51524, 108, '2015-02-15 00:02:50.000000', 'temperatura', 416.0000, 'ºC'),
	(51525, 108, '2015-02-15 00:02:51.000000', 'temperatura', 193.0000, 'ºC'),
	(51526, 108, '2015-02-15 00:02:52.000000', 'temperatura', 920.0000, 'ºC'),
	(51527, 108, '2015-02-15 00:02:53.000000', 'temperatura', 421.0000, 'ºC'),
	(51528, 108, '2015-02-15 00:02:54.000000', 'temperatura', 545.0000, 'ºC'),
	(51529, 108, '2015-02-15 00:02:55.000000', 'temperatura', 264.0000, 'ºC'),
	(51530, 108, '2015-02-15 00:02:56.000000', 'temperatura', 884.0000, 'ºC'),
	(51531, 108, '2015-02-15 00:02:57.000000', 'temperatura', 28.0000, 'ºC'),
	(51532, 108, '2015-02-15 00:02:58.000000', 'temperatura', 1091.0000, 'ºC'),
	(51533, 108, '2015-02-15 00:02:59.000000', 'temperatura', 569.0000, 'ºC'),
	(51534, 108, '2015-02-15 00:03:00.000000', 'temperatura', 774.0000, 'ºC'),
	(51535, 108, '2015-02-15 00:03:01.000000', 'temperatura', 965.0000, 'ºC'),
	(51536, 108, '2015-02-15 00:03:02.000000', 'temperatura', 102.0000, 'ºC'),
	(51537, 108, '2015-02-15 00:03:03.000000', 'temperatura', 16.0000, 'ºC'),
	(51538, 108, '2015-02-15 00:03:04.000000', 'temperatura', 975.0000, 'ºC'),
	(51539, 108, '2015-02-15 00:03:05.000000', 'temperatura', 28.0000, 'ºC'),
	(51540, 108, '2015-02-15 00:03:06.000000', 'temperatura', 814.0000, 'ºC'),
	(51541, 108, '2015-02-15 00:03:07.000000', 'temperatura', 385.0000, 'ºC'),
	(51542, 108, '2015-02-15 00:03:08.000000', 'temperatura', 685.0000, 'ºC'),
	(51543, 108, '2015-02-15 00:03:09.000000', 'temperatura', 1070.0000, 'ºC'),
	(51544, 108, '2015-02-15 00:03:10.000000', 'temperatura', 896.0000, 'ºC'),
	(51545, 108, '2015-02-15 00:03:11.000000', 'temperatura', 72.0000, 'ºC'),
	(51546, 108, '2015-02-15 00:03:12.000000', 'temperatura', 70.0000, 'ºC'),
	(51547, 108, '2015-02-15 00:03:13.000000', 'temperatura', 133.0000, 'ºC'),
	(51548, 108, '2015-02-15 00:03:14.000000', 'temperatura', 459.0000, 'ºC'),
	(51549, 108, '2015-02-15 00:03:15.000000', 'temperatura', 696.0000, 'ºC'),
	(51550, 108, '2015-02-15 00:03:16.000000', 'temperatura', 904.0000, 'ºC'),
	(51551, 108, '2015-02-15 00:03:17.000000', 'temperatura', 33.0000, 'ºC'),
	(51552, 108, '2015-02-15 00:03:18.000000', 'temperatura', 1053.0000, 'ºC'),
	(51553, 108, '2015-02-15 00:03:19.000000', 'temperatura', 367.0000, 'ºC'),
	(51554, 108, '2015-02-15 00:03:20.000000', 'temperatura', 1075.0000, 'ºC'),
	(51555, 108, '2015-02-15 00:03:21.000000', 'temperatura', 677.0000, 'ºC'),
	(51556, 108, '2015-02-15 00:03:22.000000', 'temperatura', 159.0000, 'ºC'),
	(51557, 108, '2015-02-15 00:03:23.000000', 'temperatura', 1165.0000, 'ºC'),
	(51558, 108, '2015-02-15 00:03:24.000000', 'temperatura', 547.0000, 'ºC'),
	(51559, 108, '2015-02-15 00:03:25.000000', 'temperatura', 439.0000, 'ºC'),
	(51560, 108, '2015-02-15 00:03:26.000000', 'temperatura', 557.0000, 'ºC'),
	(51561, 108, '2015-02-15 00:03:27.000000', 'temperatura', 269.0000, 'ºC'),
	(51562, 108, '2015-02-15 00:03:28.000000', 'temperatura', 875.0000, 'ºC'),
	(51563, 108, '2015-02-15 00:03:29.000000', 'temperatura', 1168.0000, 'ºC'),
	(51564, 108, '2015-02-15 00:03:30.000000', 'temperatura', 817.0000, 'ºC'),
	(51565, 108, '2015-02-15 00:03:31.000000', 'temperatura', 581.0000, 'ºC'),
	(51566, 108, '2015-02-15 00:03:32.000000', 'temperatura', 456.0000, 'ºC'),
	(51567, 108, '2015-02-15 00:03:33.000000', 'temperatura', 535.0000, 'ºC'),
	(51568, 108, '2015-02-15 00:03:34.000000', 'temperatura', 109.0000, 'ºC'),
	(51569, 108, '2015-02-15 00:03:35.000000', 'temperatura', 140.0000, 'ºC'),
	(51570, 108, '2015-02-15 00:03:36.000000', 'temperatura', 374.0000, 'ºC'),
	(51571, 108, '2015-02-15 00:03:37.000000', 'temperatura', 249.0000, 'ºC'),
	(51572, 108, '2015-02-15 00:03:38.000000', 'temperatura', 125.0000, 'ºC'),
	(51573, 108, '2015-02-15 00:03:39.000000', 'temperatura', 1078.0000, 'ºC'),
	(51574, 108, '2015-02-15 00:03:40.000000', 'temperatura', 217.0000, 'ºC'),
	(51575, 108, '2015-02-15 00:03:41.000000', 'temperatura', 249.0000, 'ºC'),
	(51576, 108, '2015-02-15 00:03:42.000000', 'temperatura', 594.0000, 'ºC'),
	(51577, 108, '2015-02-15 00:03:43.000000', 'temperatura', 1024.0000, 'ºC'),
	(51578, 108, '2015-02-15 00:03:44.000000', 'temperatura', 939.0000, 'ºC'),
	(51579, 108, '2015-02-15 00:03:45.000000', 'temperatura', 423.0000, 'ºC'),
	(51580, 108, '2015-02-15 00:03:46.000000', 'temperatura', 499.0000, 'ºC'),
	(51581, 108, '2015-02-15 00:03:47.000000', 'temperatura', 27.0000, 'ºC'),
	(51582, 108, '2015-02-15 00:03:48.000000', 'temperatura', 1038.0000, 'ºC'),
	(51583, 108, '2015-02-15 00:03:49.000000', 'temperatura', 312.0000, 'ºC'),
	(51584, 108, '2015-02-15 00:03:50.000000', 'temperatura', 843.0000, 'ºC'),
	(51585, 108, '2015-02-15 00:03:51.000000', 'temperatura', 882.0000, 'ºC'),
	(51586, 108, '2015-02-15 00:03:52.000000', 'temperatura', 679.0000, 'ºC'),
	(51587, 108, '2015-02-15 00:03:53.000000', 'temperatura', 753.0000, 'ºC'),
	(51588, 108, '2015-02-15 00:03:54.000000', 'temperatura', 525.0000, 'ºC'),
	(51589, 108, '2015-02-15 00:03:55.000000', 'temperatura', 367.0000, 'ºC'),
	(51590, 108, '2015-02-15 00:03:56.000000', 'temperatura', 261.0000, 'ºC'),
	(51591, 108, '2015-02-15 00:03:57.000000', 'temperatura', 204.0000, 'ºC'),
	(51592, 108, '2015-02-15 00:03:58.000000', 'temperatura', 238.0000, 'ºC'),
	(51593, 108, '2015-02-15 00:03:59.000000', 'temperatura', 581.0000, 'ºC'),
	(51594, 108, '2015-02-15 00:04:00.000000', 'temperatura', 988.0000, 'ºC'),
	(51595, 108, '2015-02-15 00:04:01.000000', 'temperatura', 797.0000, 'ºC'),
	(51596, 108, '2015-02-15 00:04:02.000000', 'temperatura', 1023.0000, 'ºC'),
	(51597, 108, '2015-02-15 00:04:03.000000', 'temperatura', 322.0000, 'ºC'),
	(51598, 108, '2015-02-15 00:04:04.000000', 'temperatura', 944.0000, 'ºC'),
	(51599, 108, '2015-02-15 00:04:05.000000', 'temperatura', 154.0000, 'ºC'),
	(51600, 108, '2015-02-15 00:04:06.000000', 'temperatura', 339.0000, 'ºC'),
	(51601, 108, '2015-02-15 00:04:07.000000', 'temperatura', 31.0000, 'ºC'),
	(51602, 108, '2015-02-15 00:04:08.000000', 'temperatura', 342.0000, 'ºC'),
	(51603, 108, '2015-02-15 00:04:09.000000', 'temperatura', 414.0000, 'ºC'),
	(51604, 108, '2015-02-15 00:04:10.000000', 'temperatura', 1047.0000, 'ºC'),
	(51605, 108, '2015-02-15 00:04:11.000000', 'temperatura', 391.0000, 'ºC'),
	(51606, 108, '2015-02-15 00:04:12.000000', 'temperatura', 16.0000, 'ºC'),
	(51607, 108, '2015-02-15 00:04:13.000000', 'temperatura', 107.0000, 'ºC'),
	(51608, 108, '2015-02-15 00:04:14.000000', 'temperatura', 487.0000, 'ºC'),
	(51609, 108, '2015-02-15 00:04:15.000000', 'temperatura', 914.0000, 'ºC'),
	(51610, 108, '2015-02-15 00:04:16.000000', 'temperatura', 712.0000, 'ºC'),
	(51611, 108, '2015-02-15 00:04:17.000000', 'temperatura', 817.0000, 'ºC'),
	(51612, 108, '2015-02-15 00:04:18.000000', 'temperatura', 748.0000, 'ºC'),
	(51613, 108, '2015-02-15 00:04:19.000000', 'temperatura', 89.0000, 'ºC'),
	(51614, 108, '2015-02-15 00:04:20.000000', 'temperatura', 603.0000, 'ºC'),
	(51615, 108, '2015-02-15 00:04:21.000000', 'temperatura', 347.0000, 'ºC'),
	(51616, 108, '2015-02-15 00:04:22.000000', 'temperatura', 1126.0000, 'ºC'),
	(51617, 108, '2015-02-15 00:04:23.000000', 'temperatura', 992.0000, 'ºC'),
	(51618, 108, '2015-02-15 00:04:24.000000', 'temperatura', 382.0000, 'ºC'),
	(51619, 108, '2015-02-15 00:04:25.000000', 'temperatura', 135.0000, 'ºC'),
	(51620, 108, '2015-02-15 00:04:26.000000', 'temperatura', 729.0000, 'ºC'),
	(51621, 108, '2015-02-15 00:04:27.000000', 'temperatura', 842.0000, 'ºC'),
	(51622, 108, '2015-02-15 00:04:28.000000', 'temperatura', 821.0000, 'ºC'),
	(51623, 108, '2015-02-15 00:04:29.000000', 'temperatura', 381.0000, 'ºC'),
	(51624, 108, '2015-02-15 00:04:30.000000', 'temperatura', 641.0000, 'ºC'),
	(51625, 108, '2015-02-15 00:04:31.000000', 'temperatura', 863.0000, 'ºC'),
	(51626, 108, '2015-02-15 00:04:32.000000', 'temperatura', 1193.0000, 'ºC'),
	(51627, 108, '2015-02-15 00:04:33.000000', 'temperatura', 975.0000, 'ºC'),
	(51628, 108, '2015-02-15 00:04:34.000000', 'temperatura', 96.0000, 'ºC'),
	(51629, 108, '2015-02-15 00:04:35.000000', 'temperatura', 1157.0000, 'ºC'),
	(51630, 108, '2015-02-15 00:04:36.000000', 'temperatura', 698.0000, 'ºC'),
	(51631, 108, '2015-02-15 00:04:37.000000', 'temperatura', 19.0000, 'ºC'),
	(51632, 108, '2015-02-15 00:04:38.000000', 'temperatura', 401.0000, 'ºC'),
	(51633, 108, '2015-02-15 00:04:39.000000', 'temperatura', 748.0000, 'ºC'),
	(51634, 108, '2015-02-15 00:04:40.000000', 'temperatura', 139.0000, 'ºC'),
	(51635, 108, '2015-02-15 00:04:41.000000', 'temperatura', 849.0000, 'ºC'),
	(51636, 108, '2015-02-15 00:04:42.000000', 'temperatura', 231.0000, 'ºC'),
	(51637, 108, '2015-02-15 00:04:43.000000', 'temperatura', 1007.0000, 'ºC'),
	(51638, 108, '2015-02-15 00:04:44.000000', 'temperatura', 743.0000, 'ºC'),
	(51639, 108, '2015-02-15 00:04:45.000000', 'temperatura', 694.0000, 'ºC'),
	(51640, 108, '2015-02-15 00:04:46.000000', 'temperatura', 42.0000, 'ºC'),
	(51641, 108, '2015-02-15 00:04:47.000000', 'temperatura', 527.0000, 'ºC'),
	(51642, 108, '2015-02-15 00:04:48.000000', 'temperatura', 111.0000, 'ºC'),
	(51643, 108, '2015-02-15 00:04:49.000000', 'temperatura', 175.0000, 'ºC'),
	(51644, 108, '2015-02-15 00:04:50.000000', 'temperatura', 544.0000, 'ºC'),
	(51645, 108, '2015-02-15 00:04:51.000000', 'temperatura', 993.0000, 'ºC'),
	(51646, 108, '2015-02-15 00:04:52.000000', 'temperatura', 934.0000, 'ºC'),
	(51647, 108, '2015-02-15 00:04:53.000000', 'temperatura', 491.0000, 'ºC'),
	(51648, 108, '2015-02-15 00:04:54.000000', 'temperatura', 852.0000, 'ºC'),
	(51649, 108, '2015-02-15 00:04:55.000000', 'temperatura', 390.0000, 'ºC'),
	(51650, 108, '2015-02-15 00:04:56.000000', 'temperatura', 595.0000, 'ºC'),
	(51651, 108, '2015-02-15 00:04:57.000000', 'temperatura', 606.0000, 'ºC'),
	(51652, 108, '2015-02-15 00:04:58.000000', 'temperatura', 43.0000, 'ºC'),
	(51653, 108, '2015-02-15 00:04:59.000000', 'temperatura', 798.0000, 'ºC'),
	(51654, 108, '2015-02-15 00:05:00.000000', 'temperatura', 261.0000, 'ºC'),
	(51655, 108, '2015-02-15 00:05:01.000000', 'temperatura', 113.0000, 'ºC'),
	(51656, 108, '2015-02-15 00:05:02.000000', 'temperatura', 983.0000, 'ºC'),
	(51657, 108, '2015-02-15 00:05:03.000000', 'temperatura', 977.0000, 'ºC'),
	(51658, 108, '2015-02-15 00:05:04.000000', 'temperatura', 734.0000, 'ºC'),
	(51659, 108, '2015-02-15 00:05:05.000000', 'temperatura', 740.0000, 'ºC'),
	(51660, 108, '2015-02-15 00:05:06.000000', 'temperatura', 299.0000, 'ºC'),
	(51661, 108, '2015-02-15 00:05:07.000000', 'temperatura', 477.0000, 'ºC'),
	(51662, 108, '2015-02-15 00:05:08.000000', 'temperatura', 289.0000, 'ºC'),
	(51663, 108, '2015-02-15 00:05:09.000000', 'temperatura', 12.0000, 'ºC'),
	(51664, 108, '2015-02-15 00:05:10.000000', 'temperatura', 394.0000, 'ºC'),
	(51665, 108, '2015-02-15 00:05:11.000000', 'temperatura', 734.0000, 'ºC'),
	(51666, 108, '2015-02-15 00:05:12.000000', 'temperatura', 89.0000, 'ºC'),
	(51667, 108, '2015-02-15 00:05:13.000000', 'temperatura', 642.0000, 'ºC'),
	(51668, 108, '2015-02-15 00:05:14.000000', 'temperatura', 545.0000, 'ºC'),
	(51669, 108, '2015-02-15 00:05:15.000000', 'temperatura', 798.0000, 'ºC'),
	(51670, 108, '2015-02-15 00:05:16.000000', 'temperatura', 1155.0000, 'ºC'),
	(51671, 108, '2015-02-15 00:05:17.000000', 'temperatura', 983.0000, 'ºC'),
	(51672, 108, '2015-02-15 00:05:18.000000', 'temperatura', 251.0000, 'ºC'),
	(51673, 108, '2015-02-15 00:05:19.000000', 'temperatura', 705.0000, 'ºC'),
	(51674, 108, '2015-02-15 00:05:20.000000', 'temperatura', 372.0000, 'ºC'),
	(51675, 108, '2015-02-15 00:05:21.000000', 'temperatura', 946.0000, 'ºC'),
	(51676, 108, '2015-02-15 00:05:22.000000', 'temperatura', 16.0000, 'ºC'),
	(51677, 108, '2015-02-15 00:05:23.000000', 'temperatura', 843.0000, 'ºC'),
	(51678, 108, '2015-02-15 00:05:24.000000', 'temperatura', 566.0000, 'ºC'),
	(51679, 108, '2015-02-15 00:05:25.000000', 'temperatura', 300.0000, 'ºC'),
	(51680, 108, '2015-02-15 00:05:26.000000', 'temperatura', 1004.0000, 'ºC'),
	(51681, 108, '2015-02-15 00:05:27.000000', 'temperatura', 520.0000, 'ºC'),
	(51682, 108, '2015-02-15 00:05:28.000000', 'temperatura', 789.0000, 'ºC'),
	(51683, 108, '2015-02-15 00:05:29.000000', 'temperatura', 1185.0000, 'ºC'),
	(51684, 108, '2015-02-15 00:05:30.000000', 'temperatura', 1160.0000, 'ºC'),
	(51685, 108, '2015-02-15 00:05:31.000000', 'temperatura', 1044.0000, 'ºC'),
	(51686, 108, '2015-02-15 00:05:32.000000', 'temperatura', 542.0000, 'ºC'),
	(51687, 108, '2015-02-15 00:05:33.000000', 'temperatura', 777.0000, 'ºC'),
	(51688, 108, '2015-02-15 00:05:34.000000', 'temperatura', 1061.0000, 'ºC'),
	(51689, 108, '2015-02-15 00:05:35.000000', 'temperatura', 572.0000, 'ºC'),
	(51690, 108, '2015-02-15 00:05:36.000000', 'temperatura', 879.0000, 'ºC'),
	(51691, 108, '2015-02-15 00:05:37.000000', 'temperatura', 281.0000, 'ºC'),
	(51692, 108, '2015-02-15 00:05:38.000000', 'temperatura', 1167.0000, 'ºC'),
	(51693, 108, '2015-02-15 00:05:39.000000', 'temperatura', 192.0000, 'ºC'),
	(51694, 108, '2015-02-15 00:05:40.000000', 'temperatura', 1061.0000, 'ºC'),
	(51695, 108, '2015-02-15 00:05:41.000000', 'temperatura', 1127.0000, 'ºC'),
	(51696, 108, '2015-02-15 00:05:42.000000', 'temperatura', 54.0000, 'ºC'),
	(51697, 108, '2015-02-15 00:05:43.000000', 'temperatura', 489.0000, 'ºC'),
	(51698, 108, '2015-02-15 00:05:44.000000', 'temperatura', 1086.0000, 'ºC'),
	(51699, 108, '2015-02-15 00:05:45.000000', 'temperatura', 360.0000, 'ºC'),
	(51700, 108, '2015-02-15 00:05:46.000000', 'temperatura', 944.0000, 'ºC'),
	(51701, 108, '2015-02-15 00:05:47.000000', 'temperatura', 40.0000, 'ºC'),
	(51702, 108, '2015-02-15 00:05:48.000000', 'temperatura', 969.0000, 'ºC'),
	(51703, 108, '2015-02-15 00:05:49.000000', 'temperatura', 1124.0000, 'ºC'),
	(51704, 108, '2015-02-15 00:05:50.000000', 'temperatura', 313.0000, 'ºC'),
	(51705, 108, '2015-02-15 00:05:51.000000', 'temperatura', 596.0000, 'ºC'),
	(51706, 108, '2015-02-15 00:05:52.000000', 'temperatura', 839.0000, 'ºC'),
	(51707, 108, '2015-02-15 00:05:53.000000', 'temperatura', 9.0000, 'ºC'),
	(51708, 108, '2015-02-15 00:05:54.000000', 'temperatura', 1128.0000, 'ºC'),
	(51709, 108, '2015-02-15 00:05:55.000000', 'temperatura', 814.0000, 'ºC'),
	(51710, 108, '2015-02-15 00:05:56.000000', 'temperatura', 685.0000, 'ºC'),
	(51711, 108, '2015-02-15 00:05:57.000000', 'temperatura', 986.0000, 'ºC'),
	(51712, 108, '2015-02-15 00:05:58.000000', 'temperatura', 476.0000, 'ºC'),
	(51713, 108, '2015-02-15 00:05:59.000000', 'temperatura', 619.0000, 'ºC'),
	(51714, 108, '2015-02-15 00:06:00.000000', 'temperatura', 471.0000, 'ºC'),
	(51715, 108, '2015-02-15 00:06:01.000000', 'temperatura', 495.0000, 'ºC'),
	(51716, 108, '2015-02-15 00:06:02.000000', 'temperatura', 1065.0000, 'ºC'),
	(51717, 108, '2015-02-15 00:06:03.000000', 'temperatura', 241.0000, 'ºC'),
	(51718, 108, '2015-02-15 00:06:04.000000', 'temperatura', 408.0000, 'ºC'),
	(51719, 108, '2015-02-15 00:06:05.000000', 'temperatura', 120.0000, 'ºC'),
	(51720, 108, '2015-02-15 00:06:06.000000', 'temperatura', 576.0000, 'ºC'),
	(51721, 108, '2015-02-15 00:06:07.000000', 'temperatura', 122.0000, 'ºC'),
	(51722, 108, '2015-02-15 00:06:08.000000', 'temperatura', 80.0000, 'ºC'),
	(51723, 108, '2015-02-15 00:06:09.000000', 'temperatura', 34.0000, 'ºC'),
	(51724, 108, '2015-02-15 00:06:10.000000', 'temperatura', 1130.0000, 'ºC'),
	(51725, 108, '2015-02-15 00:06:11.000000', 'temperatura', 751.0000, 'ºC'),
	(51726, 108, '2015-02-15 00:06:12.000000', 'temperatura', 366.0000, 'ºC'),
	(51727, 108, '2015-02-15 00:06:13.000000', 'temperatura', 775.0000, 'ºC'),
	(51728, 108, '2015-02-15 00:06:14.000000', 'temperatura', 378.0000, 'ºC'),
	(51729, 108, '2015-02-15 00:06:15.000000', 'temperatura', 767.0000, 'ºC'),
	(51730, 108, '2015-02-15 00:06:16.000000', 'temperatura', 301.0000, 'ºC'),
	(51731, 108, '2015-02-15 00:06:17.000000', 'temperatura', 406.0000, 'ºC'),
	(51732, 108, '2015-02-15 00:06:18.000000', 'temperatura', 1126.0000, 'ºC'),
	(51733, 108, '2015-02-15 00:06:19.000000', 'temperatura', 813.0000, 'ºC'),
	(51734, 108, '2015-02-15 00:06:20.000000', 'temperatura', 685.0000, 'ºC'),
	(51735, 108, '2015-02-15 00:06:21.000000', 'temperatura', 989.0000, 'ºC'),
	(51736, 108, '2015-02-15 00:06:22.000000', 'temperatura', 489.0000, 'ºC'),
	(51737, 108, '2015-02-15 00:06:23.000000', 'temperatura', 681.0000, 'ºC'),
	(51738, 108, '2015-02-15 00:06:24.000000', 'temperatura', 737.0000, 'ºC'),
	(51739, 108, '2015-02-15 00:06:25.000000', 'temperatura', 443.0000, 'ºC'),
	(51740, 108, '2015-02-15 00:06:26.000000', 'temperatura', 4.0000, 'ºC'),
	(51741, 108, '2015-02-15 00:06:27.000000', 'temperatura', 1093.0000, 'ºC'),
	(51742, 108, '2015-02-15 00:06:28.000000', 'temperatura', 654.0000, 'ºC'),
	(51743, 108, '2015-02-15 00:06:29.000000', 'temperatura', 1190.0000, 'ºC'),
	(51744, 108, '2015-02-15 00:06:30.000000', 'temperatura', 389.0000, 'ºC'),
	(51745, 108, '2015-02-15 00:06:31.000000', 'temperatura', 774.0000, 'ºC'),
	(51746, 108, '2015-02-15 00:06:32.000000', 'temperatura', 307.0000, 'ºC'),
	(51747, 108, '2015-02-15 00:06:33.000000', 'temperatura', 410.0000, 'ºC'),
	(51748, 108, '2015-02-15 00:06:34.000000', 'temperatura', 1129.0000, 'ºC'),
	(51749, 108, '2015-02-15 00:06:35.000000', 'temperatura', 817.0000, 'ºC'),
	(51750, 108, '2015-02-15 00:06:36.000000', 'temperatura', 697.0000, 'ºC'),
	(51751, 108, '2015-02-15 00:06:37.000000', 'temperatura', 1036.0000, 'ºC'),
	(51752, 108, '2015-02-15 00:06:38.000000', 'temperatura', 690.0000, 'ºC'),
	(51753, 108, '2015-02-15 00:06:39.000000', 'temperatura', 342.0000, 'ºC'),
	(51754, 108, '2015-02-15 00:06:40.000000', 'temperatura', 841.0000, 'ºC'),
	(51755, 108, '2015-02-15 00:06:41.000000', 'temperatura', 779.0000, 'ºC'),
	(51756, 108, '2015-02-15 00:06:42.000000', 'temperatura', 172.0000, 'ºC'),
	(51757, 108, '2015-02-15 00:06:43.000000', 'temperatura', 922.0000, 'ºC'),
	(51758, 108, '2015-02-15 00:06:44.000000', 'temperatura', 498.0000, 'ºC'),
	(51759, 108, '2015-02-15 00:06:45.000000', 'temperatura', 922.0000, 'ºC'),
	(51760, 108, '2015-02-15 00:06:46.000000', 'temperatura', 718.0000, 'ºC'),
	(51761, 108, '2015-02-15 00:06:47.000000', 'temperatura', 825.0000, 'ºC'),
	(51762, 108, '2015-02-15 00:06:48.000000', 'temperatura', 772.0000, 'ºC'),
	(51763, 108, '2015-02-15 00:06:49.000000', 'temperatura', 187.0000, 'ºC'),
	(51764, 108, '2015-02-15 00:06:50.000000', 'temperatura', 1016.0000, 'ºC'),
	(51765, 108, '2015-02-15 00:06:51.000000', 'temperatura', 921.0000, 'ºC'),
	(51766, 108, '2015-02-15 00:06:52.000000', 'temperatura', 355.0000, 'ºC'),
	(51767, 108, '2015-02-15 00:06:53.000000', 'temperatura', 216.0000, 'ºC'),
	(51768, 108, '2015-02-15 00:06:54.000000', 'temperatura', 15.0000, 'ºC'),
	(51769, 108, '2015-02-15 00:06:55.000000', 'temperatura', 628.0000, 'ºC'),
	(51770, 108, '2015-02-15 00:06:56.000000', 'temperatura', 695.0000, 'ºC'),
	(51771, 108, '2015-02-15 00:06:57.000000', 'temperatura', 391.0000, 'ºC'),
	(51772, 108, '2015-02-15 00:06:58.000000', 'temperatura', 1070.0000, 'ºC'),
	(51773, 108, '2015-02-15 00:06:59.000000', 'temperatura', 580.0000, 'ºC'),
	(51774, 108, '2015-02-15 00:07:00.000000', 'temperatura', 887.0000, 'ºC'),
	(51775, 108, '2015-02-15 00:07:01.000000', 'temperatura', 299.0000, 'ºC'),
	(51776, 108, '2015-02-15 00:07:02.000000', 'temperatura', 31.0000, 'ºC'),
	(51777, 108, '2015-02-15 00:07:03.000000', 'temperatura', 461.0000, 'ºC'),
	(51778, 108, '2015-02-15 00:07:04.000000', 'temperatura', 1013.0000, 'ºC'),
	(51779, 108, '2015-02-15 00:07:05.000000', 'temperatura', 83.0000, 'ºC'),
	(51780, 108, '2015-02-15 00:07:06.000000', 'temperatura', 976.0000, 'ºC'),
	(51781, 108, '2015-02-15 00:07:07.000000', 'temperatura', 1030.0000, 'ºC'),
	(51782, 108, '2015-02-15 00:07:08.000000', 'temperatura', 1022.0000, 'ºC'),
	(51783, 108, '2015-02-15 00:07:09.000000', 'temperatura', 820.0000, 'ºC'),
	(51784, 108, '2015-02-15 00:07:10.000000', 'temperatura', 1035.0000, 'ºC'),
	(51785, 108, '2015-02-15 00:07:11.000000', 'temperatura', 316.0000, 'ºC'),
	(51786, 108, '2015-02-15 00:07:12.000000', 'temperatura', 874.0000, 'ºC'),
	(51787, 108, '2015-02-15 00:07:13.000000', 'temperatura', 1022.0000, 'ºC'),
	(51788, 108, '2015-02-15 00:07:14.000000', 'temperatura', 91.0000, 'ºC'),
	(51789, 108, '2015-02-15 00:07:15.000000', 'temperatura', 989.0000, 'ºC'),
	(51790, 108, '2015-02-15 00:07:16.000000', 'temperatura', 1072.0000, 'ºC'),
	(51791, 108, '2015-02-15 00:07:17.000000', 'temperatura', 1195.0000, 'ºC'),
	(51792, 108, '2015-02-15 00:07:18.000000', 'temperatura', 358.0000, 'ºC'),
	(51793, 108, '2015-02-15 00:07:19.000000', 'temperatura', 607.0000, 'ºC'),
	(51794, 108, '2015-02-15 00:07:20.000000', 'temperatura', 762.0000, 'ºC'),
	(51795, 108, '2015-02-15 00:07:21.000000', 'temperatura', 789.0000, 'ºC'),
	(51796, 108, '2015-02-15 00:07:22.000000', 'temperatura', 461.0000, 'ºC'),
	(51797, 108, '2015-02-15 00:07:23.000000', 'temperatura', 1136.0000, 'ºC'),
	(51798, 108, '2015-02-15 00:07:24.000000', 'temperatura', 700.0000, 'ºC'),
	(51799, 108, '2015-02-15 00:07:25.000000', 'temperatura', 93.0000, 'ºC'),
	(51800, 108, '2015-02-15 00:07:26.000000', 'temperatura', 764.0000, 'ºC'),
	(51801, 108, '2015-02-15 00:07:27.000000', 'temperatura', 1143.0000, 'ºC'),
	(51802, 108, '2015-02-15 00:07:28.000000', 'temperatura', 1021.0000, 'ºC'),
	(51803, 108, '2015-02-15 00:07:29.000000', 'temperatura', 478.0000, 'ºC'),
	(51804, 108, '2015-02-15 00:07:30.000000', 'temperatura', 528.0000, 'ºC'),
	(51805, 108, '2015-02-15 00:07:31.000000', 'temperatura', 6.0000, 'ºC'),
	(51806, 108, '2015-02-15 00:07:32.000000', 'temperatura', 848.0000, 'ºC'),
	(51807, 108, '2015-02-15 00:07:33.000000', 'temperatura', 620.0000, 'ºC'),
	(51808, 108, '2015-02-15 00:07:34.000000', 'temperatura', 559.0000, 'ºC'),
	(51809, 108, '2015-02-15 00:07:35.000000', 'temperatura', 933.0000, 'ºC'),
	(51810, 108, '2015-02-15 00:07:36.000000', 'temperatura', 590.0000, 'ºC'),
	(51811, 108, '2015-02-15 00:07:37.000000', 'temperatura', 152.0000, 'ºC'),
	(51812, 108, '2015-02-15 00:07:38.000000', 'temperatura', 189.0000, 'ºC'),
	(51813, 108, '2015-02-15 00:07:39.000000', 'temperatura', 492.0000, 'ºC'),
	(51814, 108, '2015-02-15 00:07:40.000000', 'temperatura', 692.0000, 'ºC'),
	(51815, 108, '2015-02-15 00:07:41.000000', 'temperatura', 784.0000, 'ºC'),
	(51816, 108, '2015-02-15 00:07:42.000000', 'temperatura', 644.0000, 'ºC'),
	(51817, 108, '2015-02-15 00:07:43.000000', 'temperatura', 867.0000, 'ºC'),
	(51818, 108, '2015-02-15 00:07:44.000000', 'temperatura', 5.0000, 'ºC'),
	(51819, 108, '2015-02-15 00:07:45.000000', 'temperatura', 1026.0000, 'ºC'),
	(51820, 108, '2015-02-15 00:07:46.000000', 'temperatura', 314.0000, 'ºC'),
	(51821, 108, '2015-02-15 00:07:47.000000', 'temperatura', 892.0000, 'ºC'),
	(51822, 108, '2015-02-15 00:07:48.000000', 'temperatura', 1119.0000, 'ºC'),
	(51823, 108, '2015-02-15 00:07:49.000000', 'temperatura', 518.0000, 'ºC'),
	(51824, 108, '2015-02-15 00:07:50.000000', 'temperatura', 433.0000, 'ºC'),
	(51825, 108, '2015-02-15 00:07:51.000000', 'temperatura', 613.0000, 'ºC'),
	(51826, 108, '2015-02-15 00:07:52.000000', 'temperatura', 568.0000, 'ºC'),
	(51827, 108, '2015-02-15 00:07:53.000000', 'temperatura', 1000.0000, 'ºC'),
	(51828, 108, '2015-02-15 00:07:54.000000', 'temperatura', 897.0000, 'ºC'),
	(51829, 108, '2015-02-15 00:07:55.000000', 'temperatura', 285.0000, 'ºC'),
	(51830, 108, '2015-02-15 00:07:56.000000', 'temperatura', 1133.0000, 'ºC'),
	(51831, 108, '2015-02-15 00:07:57.000000', 'temperatura', 14.0000, 'ºC'),
	(51832, 108, '2015-02-15 00:07:58.000000', 'temperatura', 269.0000, 'ºC'),
	(51833, 108, '2015-02-15 00:07:59.000000', 'temperatura', 103.0000, 'ºC'),
	(51834, 108, '2015-02-15 00:08:00.000000', 'temperatura', 911.0000, 'ºC'),
	(51835, 108, '2015-02-15 00:08:01.000000', 'temperatura', 643.0000, 'ºC'),
	(51836, 108, '2015-02-15 00:08:02.000000', 'temperatura', 486.0000, 'ºC'),
	(51837, 108, '2015-02-15 00:08:03.000000', 'temperatura', 500.0000, 'ºC'),
	(51838, 108, '2015-02-15 00:08:04.000000', 'temperatura', 1044.0000, 'ºC'),
	(51839, 108, '2015-02-15 00:08:05.000000', 'temperatura', 119.0000, 'ºC'),
	(51840, 108, '2015-02-15 00:08:06.000000', 'temperatura', 1065.0000, 'ºC'),
	(51841, 108, '2015-02-15 00:08:07.000000', 'temperatura', 169.0000, 'ºC'),
	(51842, 108, '2015-02-15 00:08:08.000000', 'temperatura', 51.0000, 'ºC'),
	(51843, 108, '2015-02-15 00:08:09.000000', 'temperatura', 947.0000, 'ºC'),
	(51844, 108, '2015-02-15 00:08:10.000000', 'temperatura', 984.0000, 'ºC'),
	(51845, 108, '2015-02-15 00:08:11.000000', 'temperatura', 877.0000, 'ºC'),
	(51846, 108, '2015-02-15 00:08:12.000000', 'temperatura', 235.0000, 'ºC'),
	(51847, 108, '2015-02-15 00:08:13.000000', 'temperatura', 945.0000, 'ºC'),
	(51848, 108, '2015-02-15 00:08:14.000000', 'temperatura', 420.0000, 'ºC'),
	(51849, 108, '2015-02-15 00:08:15.000000', 'temperatura', 466.0000, 'ºC'),
	(51850, 108, '2015-02-15 00:08:16.000000', 'temperatura', 1070.0000, 'ºC'),
	(51851, 108, '2015-02-15 00:08:17.000000', 'temperatura', 353.0000, 'ºC'),
	(51852, 108, '2015-02-15 00:08:18.000000', 'temperatura', 954.0000, 'ºC'),
	(51853, 108, '2015-02-15 00:08:19.000000', 'temperatura', 112.0000, 'ºC'),
	(51854, 108, '2015-02-15 00:08:20.000000', 'temperatura', 100.0000, 'ºC'),
	(51855, 108, '2015-02-15 00:08:21.000000', 'temperatura', 162.0000, 'ºC'),
	(51856, 108, '2015-02-15 00:08:22.000000', 'temperatura', 514.0000, 'ºC'),
	(51857, 108, '2015-02-15 00:08:23.000000', 'temperatura', 881.0000, 'ºC'),
	(51858, 108, '2015-02-15 00:08:24.000000', 'temperatura', 465.0000, 'ºC'),
	(51859, 108, '2015-02-15 00:08:25.000000', 'temperatura', 882.0000, 'ºC'),
	(51860, 108, '2015-02-15 00:08:26.000000', 'temperatura', 614.0000, 'ºC'),
	(51861, 108, '2015-02-15 00:08:27.000000', 'temperatura', 426.0000, 'ºC'),
	(51862, 108, '2015-02-15 00:08:28.000000', 'temperatura', 287.0000, 'ºC'),
	(51863, 108, '2015-02-15 00:08:29.000000', 'temperatura', 157.0000, 'ºC'),
	(51864, 108, '2015-02-15 00:08:30.000000', 'temperatura', 1126.0000, 'ºC'),
	(51865, 108, '2015-02-15 00:08:31.000000', 'temperatura', 360.0000, 'ºC'),
	(51866, 108, '2015-02-15 00:08:32.000000', 'temperatura', 822.0000, 'ºC'),
	(51867, 108, '2015-02-15 00:08:33.000000', 'temperatura', 632.0000, 'ºC'),
	(51868, 108, '2015-02-15 00:08:34.000000', 'temperatura', 692.0000, 'ºC'),
	(51869, 108, '2015-02-15 00:08:35.000000', 'temperatura', 365.0000, 'ºC'),
	(51870, 108, '2015-02-15 00:08:36.000000', 'temperatura', 951.0000, 'ºC'),
	(51871, 108, '2015-02-15 00:08:37.000000', 'temperatura', 60.0000, 'ºC'),
	(51872, 108, '2015-02-15 00:08:38.000000', 'temperatura', 1046.0000, 'ºC'),
	(51873, 108, '2015-02-15 00:08:39.000000', 'temperatura', 250.0000, 'ºC'),
	(51874, 108, '2015-02-15 00:08:40.000000', 'temperatura', 512.0000, 'ºC'),
	(51875, 108, '2015-02-15 00:08:41.000000', 'temperatura', 613.0000, 'ºC'),
	(51876, 108, '2015-02-15 00:08:42.000000', 'temperatura', 330.0000, 'ºC'),
	(51877, 108, '2015-02-15 00:08:43.000000', 'temperatura', 1009.0000, 'ºC'),
	(51878, 108, '2015-02-15 00:08:44.000000', 'temperatura', 459.0000, 'ºC'),
	(51879, 108, '2015-02-15 00:08:45.000000', 'temperatura', 465.0000, 'ºC'),
	(51880, 108, '2015-02-15 00:08:46.000000', 'temperatura', 950.0000, 'ºC'),
	(51881, 108, '2015-02-15 00:08:47.000000', 'temperatura', 956.0000, 'ºC'),
	(51882, 108, '2015-02-15 00:08:48.000000', 'temperatura', 730.0000, 'ºC'),
	(51883, 108, '2015-02-15 00:08:49.000000', 'temperatura', 784.0000, 'ºC'),
	(51884, 108, '2015-02-15 00:08:50.000000', 'temperatura', 529.0000, 'ºC'),
	(51885, 108, '2015-02-15 00:08:51.000000', 'temperatura', 294.0000, 'ºC'),
	(51886, 108, '2015-02-15 00:08:52.000000', 'temperatura', 1085.0000, 'ºC'),
	(51887, 108, '2015-02-15 00:08:53.000000', 'temperatura', 943.0000, 'ºC'),
	(51888, 108, '2015-02-15 00:08:54.000000', 'temperatura', 260.0000, 'ºC'),
	(51889, 108, '2015-02-15 00:08:55.000000', 'temperatura', 871.0000, 'ºC'),
	(51890, 108, '2015-02-15 00:08:56.000000', 'temperatura', 1177.0000, 'ºC'),
	(51891, 108, '2015-02-15 00:08:57.000000', 'temperatura', 872.0000, 'ºC'),
	(51892, 108, '2015-02-15 00:08:58.000000', 'temperatura', 828.0000, 'ºC'),
	(51893, 108, '2015-02-15 00:08:59.000000', 'temperatura', 324.0000, 'ºC'),
	(51894, 108, '2015-02-15 00:09:00.000000', 'temperatura', 336.0000, 'ºC'),
	(51895, 108, '2015-02-15 00:09:01.000000', 'temperatura', 710.0000, 'ºC'),
	(51896, 108, '2015-02-15 00:09:02.000000', 'temperatura', 141.0000, 'ºC'),
	(51897, 108, '2015-02-15 00:09:03.000000', 'temperatura', 974.0000, 'ºC'),
	(51898, 108, '2015-02-15 00:09:04.000000', 'temperatura', 851.0000, 'ºC'),
	(51899, 108, '2015-02-15 00:09:05.000000', 'temperatura', 130.0000, 'ºC'),
	(51900, 108, '2015-02-15 00:09:06.000000', 'temperatura', 501.0000, 'ºC'),
	(51901, 108, '2015-02-15 00:09:07.000000', 'temperatura', 914.0000, 'ºC'),
	(51902, 108, '2015-02-15 00:09:08.000000', 'temperatura', 667.0000, 'ºC'),
	(51903, 108, '2015-02-15 00:09:09.000000', 'temperatura', 594.0000, 'ºC'),
	(51904, 108, '2015-02-15 00:09:10.000000', 'temperatura', 971.0000, 'ºC'),
	(51905, 108, '2015-02-15 00:09:11.000000', 'temperatura', 673.0000, 'ºC'),
	(51906, 108, '2015-02-15 00:09:12.000000', 'temperatura', 452.0000, 'ºC'),
	(51907, 108, '2015-02-15 00:09:13.000000', 'temperatura', 240.0000, 'ºC'),
	(51908, 108, '2015-02-15 00:09:14.000000', 'temperatura', 1044.0000, 'ºC'),
	(51909, 108, '2015-02-15 00:09:15.000000', 'temperatura', 901.0000, 'ºC'),
	(51910, 108, '2015-02-15 00:09:16.000000', 'temperatura', 175.0000, 'ºC'),
	(51911, 108, '2015-02-15 00:09:17.000000', 'temperatura', 571.0000, 'ºC'),
	(51912, 108, '2015-02-15 00:09:18.000000', 'temperatura', 1131.0000, 'ºC'),
	(51913, 108, '2015-02-15 00:09:19.000000', 'temperatura', 344.0000, 'ºC'),
	(51914, 108, '2015-02-15 00:09:20.000000', 'temperatura', 727.0000, 'ºC'),
	(51915, 108, '2015-02-15 00:09:21.000000', 'temperatura', 202.0000, 'ºC'),
	(51916, 108, '2015-02-15 00:09:22.000000', 'temperatura', 28.0000, 'ºC'),
	(51917, 108, '2015-02-15 00:09:23.000000', 'temperatura', 737.0000, 'ºC'),
	(51918, 108, '2015-02-15 00:09:24.000000', 'temperatura', 2.0000, 'ºC'),
	(51919, 108, '2015-02-15 00:09:25.000000', 'temperatura', 199.0000, 'ºC'),
	(51920, 108, '2015-02-15 00:09:26.000000', 'temperatura', 989.0000, 'ºC'),
	(51921, 108, '2015-02-15 00:09:27.000000', 'temperatura', 749.0000, 'ºC'),
	(51922, 108, '2015-02-15 00:09:28.000000', 'temperatura', 780.0000, 'ºC'),
	(51923, 108, '2015-02-15 00:09:29.000000', 'temperatura', 452.0000, 'ºC'),
	(51924, 108, '2015-02-15 00:09:30.000000', 'temperatura', 1119.0000, 'ºC'),
	(51925, 108, '2015-02-15 00:09:31.000000', 'temperatura', 641.0000, 'ºC'),
	(51926, 108, '2015-02-15 00:09:32.000000', 'temperatura', 1047.0000, 'ºC'),
	(51927, 108, '2015-02-15 00:09:33.000000', 'temperatura', 912.0000, 'ºC'),
	(51928, 108, '2015-02-15 00:09:34.000000', 'temperatura', 220.0000, 'ºC'),
	(51929, 108, '2015-02-15 00:09:35.000000', 'temperatura', 766.0000, 'ºC'),
	(51930, 108, '2015-02-15 00:09:36.000000', 'temperatura', 769.0000, 'ºC'),
	(51931, 108, '2015-02-15 00:09:37.000000', 'temperatura', 349.0000, 'ºC'),
	(51932, 108, '2015-02-15 00:09:38.000000', 'temperatura', 638.0000, 'ºC'),
	(51933, 108, '2015-02-15 00:09:39.000000', 'temperatura', 943.0000, 'ºC'),
	(51934, 108, '2015-02-15 00:09:40.000000', 'temperatura', 402.0000, 'ºC'),
	(51935, 108, '2015-02-15 00:09:41.000000', 'temperatura', 383.0000, 'ºC'),
	(51936, 108, '2015-02-15 00:09:42.000000', 'temperatura', 708.0000, 'ºC'),
	(51937, 108, '2015-02-15 00:09:43.000000', 'temperatura', 1191.0000, 'ºC'),
	(51938, 108, '2015-02-15 00:09:44.000000', 'temperatura', 233.0000, 'ºC'),
	(51939, 108, '2015-02-15 00:09:45.000000', 'temperatura', 1192.0000, 'ºC'),
	(51940, 108, '2015-02-15 00:09:46.000000', 'temperatura', 463.0000, 'ºC'),
	(51941, 108, '2015-02-15 00:09:47.000000', 'temperatura', 1136.0000, 'ºC'),
	(51942, 108, '2015-02-15 00:09:48.000000', 'temperatura', 695.0000, 'ºC'),
	(51943, 108, '2015-02-15 00:09:49.000000', 'temperatura', 66.0000, 'ºC'),
	(51944, 108, '2015-02-15 00:09:50.000000', 'temperatura', 644.0000, 'ºC'),
	(51945, 108, '2015-02-15 00:09:51.000000', 'temperatura', 622.0000, 'ºC'),
	(51946, 108, '2015-02-15 00:09:52.000000', 'temperatura', 1178.0000, 'ºC'),
	(51947, 108, '2015-02-15 00:09:53.000000', 'temperatura', 424.0000, 'ºC'),
	(51948, 108, '2015-02-15 00:09:54.000000', 'temperatura', 986.0000, 'ºC'),
	(51949, 108, '2015-02-15 00:09:55.000000', 'temperatura', 61.0000, 'ºC'),
	(51950, 108, '2015-02-15 00:09:56.000000', 'temperatura', 946.0000, 'ºC'),
	(51951, 108, '2015-02-15 00:09:57.000000', 'temperatura', 947.0000, 'ºC'),
	(51952, 108, '2015-02-15 00:09:58.000000', 'temperatura', 700.0000, 'ºC'),
	(51953, 108, '2015-02-15 00:09:59.000000', 'temperatura', 657.0000, 'ºC'),
	(51954, 108, '2015-02-15 00:10:00.000000', 'temperatura', 1186.0000, 'ºC'),
	(51955, 108, '2015-02-15 00:10:01.000000', 'temperatura', 360.0000, 'ºC'),
	(51956, 108, '2015-02-15 00:10:02.000000', 'temperatura', 643.0000, 'ºC'),
	(51957, 108, '2015-02-15 00:10:03.000000', 'temperatura', 935.0000, 'ºC'),
	(51958, 108, '2015-02-15 00:10:04.000000', 'temperatura', 346.0000, 'ºC'),
	(51959, 108, '2015-02-15 00:10:05.000000', 'temperatura', 125.0000, 'ºC'),
	(51960, 108, '2015-02-15 00:10:06.000000', 'temperatura', 789.0000, 'ºC'),
	(51961, 108, '2015-02-15 00:10:07.000000', 'temperatura', 1168.0000, 'ºC'),
	(51962, 108, '2015-02-15 00:10:08.000000', 'temperatura', 1074.0000, 'ºC'),
	(51963, 108, '2015-02-15 00:10:09.000000', 'temperatura', 667.0000, 'ºC'),
	(51964, 108, '2015-02-15 00:10:10.000000', 'temperatura', 112.0000, 'ºC'),
	(51965, 108, '2015-02-15 00:10:11.000000', 'temperatura', 962.0000, 'ºC'),
	(51966, 108, '2015-02-15 00:10:12.000000', 'temperatura', 872.0000, 'ºC'),
	(51967, 108, '2015-02-15 00:10:13.000000', 'temperatura', 275.0000, 'ºC'),
	(51968, 108, '2015-02-15 00:10:14.000000', 'temperatura', 1161.0000, 'ºC'),
	(51969, 108, '2015-02-15 00:10:15.000000', 'temperatura', 180.0000, 'ºC'),
	(51970, 108, '2015-02-15 00:10:16.000000', 'temperatura', 1018.0000, 'ºC'),
	(51971, 108, '2015-02-15 00:10:17.000000', 'temperatura', 949.0000, 'ºC'),
	(51972, 108, '2015-02-15 00:10:18.000000', 'temperatura', 492.0000, 'ºC'),
	(51973, 108, '2015-02-15 00:10:19.000000', 'temperatura', 813.0000, 'ºC'),
	(51974, 108, '2015-02-15 00:10:20.000000', 'temperatura', 191.0000, 'ºC'),
	(51975, 108, '2015-02-15 00:10:21.000000', 'temperatura', 915.0000, 'ºC'),
	(51976, 108, '2015-02-15 00:10:22.000000', 'temperatura', 402.0000, 'ºC'),
	(51977, 108, '2015-02-15 00:10:23.000000', 'temperatura', 465.0000, 'ºC'),
	(51978, 108, '2015-02-15 00:10:24.000000', 'temperatura', 1119.0000, 'ºC'),
	(51979, 108, '2015-02-15 00:10:25.000000', 'temperatura', 602.0000, 'ºC'),
	(51980, 108, '2015-02-15 00:10:26.000000', 'temperatura', 854.0000, 'ºC'),
	(51981, 108, '2015-02-15 00:10:27.000000', 'temperatura', 63.0000, 'ºC'),
	(51982, 108, '2015-02-15 00:10:28.000000', 'temperatura', 152.0000, 'ºC'),
	(51983, 108, '2015-02-15 00:10:29.000000', 'temperatura', 574.0000, 'ºC'),
	(51984, 108, '2015-02-15 00:10:30.000000', 'temperatura', 12.0000, 'ºC'),
	(51985, 108, '2015-02-15 00:10:31.000000', 'temperatura', 739.0000, 'ºC'),
	(51986, 108, '2015-02-15 00:10:32.000000', 'temperatura', 60.0000, 'ºC'),
	(51987, 108, '2015-02-15 00:10:33.000000', 'temperatura', 485.0000, 'ºC'),
	(51988, 108, '2015-02-15 00:10:34.000000', 'temperatura', 1044.0000, 'ºC'),
	(51989, 108, '2015-02-15 00:10:35.000000', 'temperatura', 166.0000, 'ºC'),
	(51990, 108, '2015-02-15 00:10:36.000000', 'temperatura', 99.0000, 'ºC'),
	(51991, 108, '2015-02-15 00:10:37.000000', 'temperatura', 1196.0000, 'ºC'),
	(51992, 108, '2015-02-15 00:10:38.000000', 'temperatura', 885.0000, 'ºC'),
	(51993, 108, '2015-02-15 00:10:39.000000', 'temperatura', 835.0000, 'ºC'),
	(51994, 108, '2015-02-15 00:10:40.000000', 'temperatura', 323.0000, 'ºC'),
	(51995, 108, '2015-02-15 00:10:41.000000', 'temperatura', 309.0000, 'ºC'),
	(51996, 108, '2015-02-15 00:10:42.000000', 'temperatura', 576.0000, 'ºC'),
	(51997, 108, '2015-02-15 00:10:43.000000', 'temperatura', 755.0000, 'ºC'),
	(51998, 108, '2015-02-15 00:10:44.000000', 'temperatura', 848.0000, 'ºC'),
	(51999, 108, '2015-02-15 00:10:45.000000', 'temperatura', 777.0000, 'ºC'),
	(52000, 108, '2015-02-15 00:10:46.000000', 'temperatura', 139.0000, 'ºC'),
	(52001, 108, '2015-02-15 00:10:47.000000', 'temperatura', 766.0000, 'ºC'),
	(52002, 108, '2015-02-15 00:10:48.000000', 'temperatura', 1015.0000, 'ºC'),
	(52003, 108, '2015-02-15 00:10:49.000000', 'temperatura', 376.0000, 'ºC'),
	(52004, 108, '2015-02-15 00:10:50.000000', 'temperatura', 35.0000, 'ºC'),
	(52005, 108, '2015-02-15 00:10:51.000000', 'temperatura', 246.0000, 'ºC'),
	(52006, 108, '2015-02-15 00:10:52.000000', 'temperatura', 1127.0000, 'ºC'),
	(52007, 108, '2015-02-15 00:10:53.000000', 'temperatura', 99.0000, 'ºC'),
	(52008, 108, '2015-02-15 00:10:54.000000', 'temperatura', 712.0000, 'ºC'),
	(52009, 108, '2015-02-15 00:10:55.000000', 'temperatura', 864.0000, 'ºC'),
	(52010, 108, '2015-02-15 00:10:56.000000', 'temperatura', 986.0000, 'ºC'),
	(52011, 108, '2015-02-15 00:10:57.000000', 'temperatura', 1137.0000, 'ºC'),
	(52012, 108, '2015-02-15 00:10:58.000000', 'temperatura', 330.0000, 'ºC'),
	(52013, 108, '2015-02-15 00:10:59.000000', 'temperatura', 637.0000, 'ºC'),
	(52014, 108, '2015-02-15 00:11:00.000000', 'temperatura', 998.0000, 'ºC'),
	(52015, 108, '2015-02-15 00:11:01.000000', 'temperatura', 678.0000, 'ºC'),
	(52016, 108, '2015-02-15 00:11:02.000000', 'temperatura', 395.0000, 'ºC'),
	(52017, 108, '2015-02-15 00:11:03.000000', 'temperatura', 1144.0000, 'ºC'),
	(52018, 108, '2015-02-15 00:11:04.000000', 'temperatura', 934.0000, 'ºC'),
	(52019, 108, '2015-02-15 00:11:05.000000', 'temperatura', 38.0000, 'ºC'),
	(52020, 108, '2015-02-15 00:11:06.000000', 'temperatura', 989.0000, 'ºC'),
	(52021, 108, '2015-02-15 00:11:07.000000', 'temperatura', 30.0000, 'ºC'),
	(52022, 108, '2015-02-15 00:11:08.000000', 'temperatura', 783.0000, 'ºC'),
	(52023, 108, '2015-02-15 00:11:09.000000', 'temperatura', 226.0000, 'ºC'),
	(52024, 108, '2015-02-15 00:11:10.000000', 'temperatura', 1181.0000, 'ºC'),
	(52025, 108, '2015-02-15 00:11:11.000000', 'temperatura', 429.0000, 'ºC'),
	(52026, 108, '2015-02-15 00:11:12.000000', 'temperatura', 1001.0000, 'ºC'),
	(52027, 108, '2015-02-15 00:11:13.000000', 'temperatura', 118.0000, 'ºC'),
	(52028, 108, '2015-02-15 00:11:14.000000', 'temperatura', 1190.0000, 'ºC'),
	(52029, 108, '2015-02-15 00:11:15.000000', 'temperatura', 794.0000, 'ºC'),
	(52030, 108, '2015-02-15 00:11:16.000000', 'temperatura', 400.0000, 'ºC'),
	(52031, 108, '2015-02-15 00:11:17.000000', 'temperatura', 819.0000, 'ºC'),
	(52032, 108, '2015-02-15 00:11:18.000000', 'temperatura', 497.0000, 'ºC'),
	(52033, 108, '2015-02-15 00:11:19.000000', 'temperatura', 28.0000, 'ºC'),
	(52034, 108, '2015-02-15 00:11:20.000000', 'temperatura', 1051.0000, 'ºC'),
	(52035, 108, '2015-02-15 00:11:21.000000', 'temperatura', 371.0000, 'ºC'),
	(52036, 108, '2015-02-15 00:11:22.000000', 'temperatura', 1101.0000, 'ºC'),
	(52037, 108, '2015-02-15 00:11:23.000000', 'temperatura', 793.0000, 'ºC'),
	(52038, 108, '2015-02-15 00:11:24.000000', 'temperatura', 662.0000, 'ºC'),
	(52039, 108, '2015-02-15 00:11:25.000000', 'temperatura', 933.0000, 'ºC'),
	(52040, 108, '2015-02-15 00:11:26.000000', 'temperatura', 277.0000, 'ºC'),
	(52041, 108, '2015-02-15 00:11:27.000000', 'temperatura', 988.0000, 'ºC'),
	(52042, 108, '2015-02-15 00:11:28.000000', 'temperatura', 511.0000, 'ºC'),
	(52043, 108, '2015-02-15 00:11:29.000000', 'temperatura', 789.0000, 'ºC'),
	(52044, 108, '2015-02-15 00:11:30.000000', 'temperatura', 13.0000, 'ºC'),
	(52045, 108, '2015-02-15 00:11:31.000000', 'temperatura', 98.0000, 'ºC'),
	(52046, 108, '2015-02-15 00:11:32.000000', 'temperatura', 452.0000, 'ºC'),
	(52047, 108, '2015-02-15 00:11:33.000000', 'temperatura', 766.0000, 'ºC'),
	(52048, 108, '2015-02-15 00:11:34.000000', 'temperatura', 73.0000, 'ºC'),
	(52049, 108, '2015-02-15 00:11:35.000000', 'temperatura', 470.0000, 'ºC'),
	(52050, 108, '2015-02-15 00:11:36.000000', 'temperatura', 931.0000, 'ºC'),
	(52051, 108, '2015-02-15 00:11:37.000000', 'temperatura', 847.0000, 'ºC'),
	(52052, 108, '2015-02-15 00:11:38.000000', 'temperatura', 242.0000, 'ºC'),
	(52053, 108, '2015-02-15 00:11:39.000000', 'temperatura', 1067.0000, 'ºC'),
	(52054, 108, '2015-02-15 00:11:40.000000', 'temperatura', 1013.0000, 'ºC'),
	(52055, 108, '2015-02-15 00:11:41.000000', 'temperatura', 662.0000, 'ºC'),
	(52056, 108, '2015-02-15 00:11:42.000000', 'temperatura', 270.0000, 'ºC'),
	(52057, 108, '2015-02-15 00:11:43.000000', 'temperatura', 567.0000, 'ºC'),
	(52058, 108, '2015-02-15 00:11:44.000000', 'temperatura', 827.0000, 'ºC'),
	(52059, 108, '2015-02-15 00:11:45.000000', 'temperatura', 31.0000, 'ºC'),
	(52060, 108, '2015-02-15 00:11:46.000000', 'temperatura', 76.0000, 'ºC'),
	(52061, 108, '2015-02-15 00:11:47.000000', 'temperatura', 289.0000, 'ºC'),
	(52062, 108, '2015-02-15 00:11:48.000000', 'temperatura', 17.0000, 'ºC'),
	(52063, 108, '2015-02-15 00:11:49.000000', 'temperatura', 417.0000, 'ºC'),
	(52064, 108, '2015-02-15 00:11:50.000000', 'temperatura', 837.0000, 'ºC'),
	(52065, 108, '2015-02-15 00:11:51.000000', 'temperatura', 533.0000, 'ºC'),
	(52066, 108, '2015-02-15 00:11:52.000000', 'temperatura', 154.0000, 'ºC'),
	(52067, 108, '2015-02-15 00:11:53.000000', 'temperatura', 372.0000, 'ºC'),
	(52068, 108, '2015-02-15 00:11:54.000000', 'temperatura', 197.0000, 'ºC'),
	(52069, 108, '2015-02-15 00:11:55.000000', 'temperatura', 1069.0000, 'ºC'),
	(52070, 108, '2015-02-15 00:11:56.000000', 'temperatura', 1156.0000, 'ºC'),
	(52071, 108, '2015-02-15 00:11:57.000000', 'temperatura', 174.0000, 'ºC'),
	(52072, 108, '2015-02-15 00:11:58.000000', 'temperatura', 1003.0000, 'ºC'),
	(52073, 108, '2015-02-15 00:11:59.000000', 'temperatura', 891.0000, 'ºC'),
	(52074, 108, '2015-02-15 00:12:00.000000', 'temperatura', 247.0000, 'ºC'),
	(52075, 108, '2015-02-15 00:12:01.000000', 'temperatura', 961.0000, 'ºC'),
	(52076, 108, '2015-02-15 00:12:02.000000', 'temperatura', 466.0000, 'ºC'),
	(52077, 108, '2015-02-15 00:12:03.000000', 'temperatura', 649.0000, 'ºC'),
	(52078, 108, '2015-02-15 00:12:04.000000', 'temperatura', 647.0000, 'ºC'),
	(52079, 108, '2015-02-15 00:12:05.000000', 'temperatura', 89.0000, 'ºC'),
	(52080, 108, '2015-02-15 00:12:06.000000', 'temperatura', 902.0000, 'ºC'),
	(52081, 108, '2015-02-15 00:12:07.000000', 'temperatura', 644.0000, 'ºC'),
	(52082, 108, '2015-02-15 00:12:08.000000', 'temperatura', 513.0000, 'ºC'),
	(52083, 108, '2015-02-15 00:12:09.000000', 'temperatura', 636.0000, 'ºC'),
	(52084, 108, '2015-02-15 00:12:10.000000', 'temperatura', 441.0000, 'ºC'),
	(52085, 108, '2015-02-15 00:12:11.000000', 'temperatura', 296.0000, 'ºC'),
	(52086, 108, '2015-02-15 00:12:12.000000', 'temperatura', 160.0000, 'ºC'),
	(52087, 108, '2015-02-15 00:12:13.000000', 'temperatura', 1112.0000, 'ºC'),
	(52088, 108, '2015-02-15 00:12:14.000000', 'temperatura', 279.0000, 'ºC'),
	(52089, 108, '2015-02-15 00:12:15.000000', 'temperatura', 460.0000, 'ºC'),
	(52090, 108, '2015-02-15 00:12:16.000000', 'temperatura', 263.0000, 'ºC'),
	(52091, 108, '2015-02-15 00:12:17.000000', 'temperatura', 1134.0000, 'ºC'),
	(52092, 108, '2015-02-15 00:12:18.000000', 'temperatura', 83.0000, 'ºC'),
	(52093, 108, '2015-02-15 00:12:19.000000', 'temperatura', 615.0000, 'ºC'),
	(52094, 108, '2015-02-15 00:12:20.000000', 'temperatura', 424.0000, 'ºC'),
	(52095, 108, '2015-02-15 00:12:21.000000', 'temperatura', 276.0000, 'ºC'),
	(52096, 108, '2015-02-15 00:12:22.000000', 'temperatura', 108.0000, 'ºC'),
	(52097, 108, '2015-02-15 00:12:23.000000', 'temperatura', 914.0000, 'ºC'),
	(52098, 108, '2015-02-15 00:12:24.000000', 'temperatura', 647.0000, 'ºC'),
	(52099, 108, '2015-02-15 00:12:25.000000', 'temperatura', 491.0000, 'ºC'),
	(52100, 108, '2015-02-15 00:12:26.000000', 'temperatura', 514.0000, 'ºC'),
	(52101, 108, '2015-02-15 00:12:27.000000', 'temperatura', 1100.0000, 'ºC'),
	(52102, 108, '2015-02-15 00:12:28.000000', 'temperatura', 357.0000, 'ºC'),
	(52103, 108, '2015-02-15 00:12:29.000000', 'temperatura', 884.0000, 'ºC'),
	(52104, 108, '2015-02-15 00:12:30.000000', 'temperatura', 950.0000, 'ºC'),
	(52105, 108, '2015-02-15 00:12:31.000000', 'temperatura', 898.0000, 'ºC'),
	(52106, 108, '2015-02-15 00:12:32.000000', 'temperatura', 443.0000, 'ºC'),
	(52107, 108, '2015-02-15 00:12:33.000000', 'temperatura', 720.0000, 'ºC'),
	(52108, 108, '2015-02-15 00:12:34.000000', 'temperatura', 1072.0000, 'ºC'),
	(52109, 108, '2015-02-15 00:12:35.000000', 'temperatura', 802.0000, 'ºC'),
	(52110, 108, '2015-02-15 00:12:36.000000', 'temperatura', 794.0000, 'ºC'),
	(52111, 108, '2015-02-15 00:12:37.000000', 'temperatura', 364.0000, 'ºC'),
	(52112, 108, '2015-02-15 00:12:38.000000', 'temperatura', 637.0000, 'ºC'),
	(52113, 108, '2015-02-15 00:12:39.000000', 'temperatura', 896.0000, 'ºC'),
	(52114, 108, '2015-02-15 00:12:40.000000', 'temperatura', 167.0000, 'ºC'),
	(52115, 108, '2015-02-15 00:12:41.000000', 'temperatura', 548.0000, 'ºC'),
	(52116, 108, '2015-02-15 00:12:42.000000', 'temperatura', 1041.0000, 'ºC'),
	(52117, 108, '2015-02-15 00:12:43.000000', 'temperatura', 1162.0000, 'ºC'),
	(52118, 108, '2015-02-15 00:12:44.000000', 'temperatura', 288.0000, 'ºC'),
	(52119, 108, '2015-02-15 00:12:45.000000', 'temperatura', 352.0000, 'ºC'),
	(52120, 108, '2015-02-15 00:12:46.000000', 'temperatura', 898.0000, 'ºC'),
	(52121, 108, '2015-02-15 00:12:47.000000', 'temperatura', 1035.0000, 'ºC'),
	(52122, 108, '2015-02-15 00:12:48.000000', 'temperatura', 81.0000, 'ºC'),
	(52123, 108, '2015-02-15 00:12:49.000000', 'temperatura', 899.0000, 'ºC'),
	(52124, 108, '2015-02-15 00:12:50.000000', 'temperatura', 655.0000, 'ºC'),
	(52125, 108, '2015-02-15 00:12:51.000000', 'temperatura', 579.0000, 'ºC'),
	(52126, 108, '2015-02-15 00:12:52.000000', 'temperatura', 928.0000, 'ºC'),
	(52127, 108, '2015-02-15 00:12:53.000000', 'temperatura', 506.0000, 'ºC'),
	(52128, 108, '2015-02-15 00:12:54.000000', 'temperatura', 946.0000, 'ºC'),
	(52129, 108, '2015-02-15 00:12:55.000000', 'temperatura', 811.0000, 'ºC'),
	(52130, 108, '2015-02-15 00:12:56.000000', 'temperatura', 18.0000, 'ºC'),
	(52131, 108, '2015-02-15 00:12:57.000000', 'temperatura', 58.0000, 'ºC'),
	(52132, 108, '2015-02-15 00:12:58.000000', 'temperatura', 237.0000, 'ºC'),
	(52133, 108, '2015-02-15 00:12:59.000000', 'temperatura', 1013.0000, 'ºC'),
	(52134, 108, '2015-02-15 00:13:00.000000', 'temperatura', 753.0000, 'ºC'),
	(52135, 108, '2015-02-15 00:13:01.000000', 'temperatura', 727.0000, 'ºC'),
	(52136, 108, '2015-02-15 00:13:02.000000', 'temperatura', 175.0000, 'ºC'),
	(52137, 108, '2015-02-15 00:13:03.000000', 'temperatura', 1097.0000, 'ºC'),
	(52138, 108, '2015-02-15 00:13:04.000000', 'temperatura', 158.0000, 'ºC'),
	(52139, 108, '2015-02-15 00:13:05.000000', 'temperatura', 1102.0000, 'ºC'),
	(52140, 108, '2015-02-15 00:13:06.000000', 'temperatura', 235.0000, 'ºC'),
	(52141, 108, '2015-02-15 00:13:07.000000', 'temperatura', 272.0000, 'ºC'),
	(52142, 108, '2015-02-15 00:13:08.000000', 'temperatura', 653.0000, 'ºC'),
	(52143, 108, '2015-02-15 00:13:09.000000', 'temperatura', 49.0000, 'ºC'),
	(52144, 108, '2015-02-15 00:13:10.000000', 'temperatura', 689.0000, 'ºC'),
	(52145, 108, '2015-02-15 00:13:11.000000', 'temperatura', 899.0000, 'ºC'),
	(52146, 108, '2015-02-15 00:13:12.000000', 'temperatura', 28.0000, 'ºC'),
	(52147, 108, '2015-02-15 00:13:13.000000', 'temperatura', 1041.0000, 'ºC'),
	(52148, 108, '2015-02-15 00:13:14.000000', 'temperatura', 323.0000, 'ºC'),
	(52149, 108, '2015-02-15 00:13:15.000000', 'temperatura', 894.0000, 'ºC'),
	(52150, 108, '2015-02-15 00:13:16.000000', 'temperatura', 1099.0000, 'ºC'),
	(52151, 108, '2015-02-15 00:13:17.000000', 'temperatura', 414.0000, 'ºC'),
	(52152, 108, '2015-02-15 00:13:18.000000', 'temperatura', 1173.0000, 'ºC'),
	(52153, 108, '2015-02-15 00:13:19.000000', 'temperatura', 1025.0000, 'ºC'),
	(52154, 108, '2015-02-15 00:13:20.000000', 'temperatura', 407.0000, 'ºC'),
	(52155, 108, '2015-02-15 00:13:21.000000', 'temperatura', 159.0000, 'ºC'),
	(52156, 108, '2015-02-15 00:13:22.000000', 'temperatura', 773.0000, 'ºC'),
	(52157, 108, '2015-02-15 00:13:23.000000', 'temperatura', 989.0000, 'ºC'),
	(52158, 108, '2015-02-15 00:13:24.000000', 'temperatura', 228.0000, 'ºC'),
	(52159, 108, '2015-02-15 00:13:25.000000', 'temperatura', 574.0000, 'ºC'),
	(52160, 108, '2015-02-15 00:13:26.000000', 'temperatura', 985.0000, 'ºC'),
	(52161, 108, '2015-02-15 00:13:27.000000', 'temperatura', 805.0000, 'ºC'),
	(52162, 108, '2015-02-15 00:13:28.000000', 'temperatura', 1071.0000, 'ºC'),
	(52163, 108, '2015-02-15 00:13:29.000000', 'temperatura', 541.0000, 'ºC'),
	(52164, 108, '2015-02-15 00:13:30.000000', 'temperatura', 693.0000, 'ºC'),
	(52165, 108, '2015-02-15 00:13:31.000000', 'temperatura', 641.0000, 'ºC'),
	(52166, 108, '2015-02-15 00:13:32.000000', 'temperatura', 1127.0000, 'ºC'),
	(52167, 108, '2015-02-15 00:13:33.000000', 'temperatura', 111.0000, 'ºC'),
	(52168, 108, '2015-02-15 00:13:34.000000', 'temperatura', 777.0000, 'ºC'),
	(52169, 108, '2015-02-15 00:13:35.000000', 'temperatura', 1154.0000, 'ºC'),
	(52170, 108, '2015-02-15 00:13:36.000000', 'temperatura', 1036.0000, 'ºC'),
	(52171, 108, '2015-02-15 00:13:37.000000', 'temperatura', 518.0000, 'ºC'),
	(52172, 108, '2015-02-15 00:13:38.000000', 'temperatura', 685.0000, 'ºC'),
	(52173, 108, '2015-02-15 00:13:39.000000', 'temperatura', 669.0000, 'ºC'),
	(52174, 108, '2015-02-15 00:13:40.000000', 'temperatura', 91.0000, 'ºC'),
	(52175, 108, '2015-02-15 00:13:41.000000', 'temperatura', 849.0000, 'ºC'),
	(52176, 108, '2015-02-15 00:13:42.000000', 'temperatura', 374.0000, 'ºC'),
	(52177, 108, '2015-02-15 00:13:43.000000', 'temperatura', 523.0000, 'ºC'),
	(52178, 108, '2015-02-15 00:13:44.000000', 'temperatura', 293.0000, 'ºC'),
	(52179, 108, '2015-02-15 00:13:45.000000', 'temperatura', 1097.0000, 'ºC'),
	(52180, 108, '2015-02-15 00:13:46.000000', 'temperatura', 1007.0000, 'ºC'),
	(52181, 108, '2015-02-15 00:13:47.000000', 'temperatura', 545.0000, 'ºC'),
	(52182, 108, '2015-02-15 00:13:48.000000', 'temperatura', 904.0000, 'ºC'),
	(52183, 108, '2015-02-15 00:13:49.000000', 'temperatura', 486.0000, 'ºC'),
	(52184, 108, '2015-02-15 00:13:50.000000', 'temperatura', 919.0000, 'ºC'),
	(52185, 108, '2015-02-15 00:13:51.000000', 'temperatura', 737.0000, 'ºC'),
	(52186, 108, '2015-02-15 00:13:52.000000', 'temperatura', 929.0000, 'ºC'),
	(52187, 108, '2015-02-15 00:13:53.000000', 'temperatura', 33.0000, 'ºC'),
	(52188, 108, '2015-02-15 00:13:54.000000', 'temperatura', 979.0000, 'ºC'),
	(52189, 108, '2015-02-15 00:13:55.000000', 'temperatura', 1198.0000, 'ºC'),
	(52190, 108, '2015-02-15 00:13:56.000000', 'temperatura', 650.0000, 'ºC'),
	(52191, 108, '2015-02-15 00:13:57.000000', 'temperatura', 860.0000, 'ºC'),
	(52192, 108, '2015-02-15 00:13:58.000000', 'temperatura', 1150.0000, 'ºC'),
	(52193, 108, '2015-02-15 00:13:59.000000', 'temperatura', 770.0000, 'ºC'),
	(52194, 108, '2015-02-15 00:14:00.000000', 'temperatura', 401.0000, 'ºC'),
	(52195, 108, '2015-02-15 00:14:01.000000', 'temperatura', 893.0000, 'ºC'),
	(52196, 108, '2015-02-15 00:14:02.000000', 'temperatura', 866.0000, 'ºC'),
	(52197, 108, '2015-02-15 00:14:03.000000', 'temperatura', 448.0000, 'ºC'),
	(52198, 108, '2015-02-15 00:14:04.000000', 'temperatura', 844.0000, 'ºC'),
	(52199, 108, '2015-02-15 00:14:05.000000', 'temperatura', 476.0000, 'ºC'),
	(52200, 108, '2015-02-15 00:14:06.000000', 'temperatura', 1050.0000, 'ºC'),
	(52201, 108, '2015-02-15 00:14:07.000000', 'temperatura', 220.0000, 'ºC'),
	(52202, 108, '2015-02-15 00:14:08.000000', 'temperatura', 350.0000, 'ºC'),
	(52203, 108, '2015-02-15 00:14:09.000000', 'temperatura', 1092.0000, 'ºC'),
	(52204, 108, '2015-02-15 00:14:10.000000', 'temperatura', 811.0000, 'ºC'),
	(52205, 108, '2015-02-15 00:14:11.000000', 'temperatura', 780.0000, 'ºC'),
	(52206, 108, '2015-02-15 00:14:12.000000', 'temperatura', 266.0000, 'ºC'),
	(52207, 108, '2015-02-15 00:14:13.000000', 'temperatura', 191.0000, 'ºC'),
	(52208, 108, '2015-02-15 00:14:14.000000', 'temperatura', 157.0000, 'ºC'),
	(52209, 108, '2015-02-15 00:14:15.000000', 'temperatura', 214.0000, 'ºC'),
	(52210, 108, '2015-02-15 00:14:16.000000', 'temperatura', 597.0000, 'ºC'),
	(52211, 108, '2015-02-15 00:14:17.000000', 'temperatura', 1143.0000, 'ºC'),
	(52212, 108, '2015-02-15 00:14:18.000000', 'temperatura', 326.0000, 'ºC'),
	(52213, 108, '2015-02-15 00:14:19.000000', 'temperatura', 603.0000, 'ºC'),
	(52214, 108, '2015-02-15 00:14:20.000000', 'temperatura', 835.0000, 'ºC'),
	(52215, 108, '2015-02-15 00:14:21.000000', 'temperatura', 1167.0000, 'ºC'),
	(52216, 108, '2015-02-15 00:14:22.000000', 'temperatura', 933.0000, 'ºC'),
	(52217, 108, '2015-02-15 00:14:23.000000', 'temperatura', 1161.0000, 'ºC'),
	(52218, 108, '2015-02-15 00:14:24.000000', 'temperatura', 609.0000, 'ºC'),
	(52219, 108, '2015-02-15 00:14:25.000000', 'temperatura', 761.0000, 'ºC'),
	(52220, 108, '2015-02-15 00:14:26.000000', 'temperatura', 780.0000, 'ºC'),
	(52221, 108, '2015-02-15 00:14:27.000000', 'temperatura', 416.0000, 'ºC'),
	(52222, 108, '2015-02-15 00:14:28.000000', 'temperatura', 943.0000, 'ºC'),
	(52223, 108, '2015-02-15 00:14:29.000000', 'temperatura', 1067.0000, 'ºC'),
	(52224, 108, '2015-02-15 00:14:30.000000', 'temperatura', 106.0000, 'ºC'),
	(52225, 108, '2015-02-15 00:14:31.000000', 'temperatura', 929.0000, 'ºC'),
	(52226, 108, '2015-02-15 00:14:32.000000', 'temperatura', 727.0000, 'ºC'),
	(52227, 108, '2015-02-15 00:14:33.000000', 'temperatura', 847.0000, 'ºC'),
	(52228, 108, '2015-02-15 00:14:34.000000', 'temperatura', 856.0000, 'ºC'),
	(52229, 108, '2015-02-15 00:14:35.000000', 'temperatura', 539.0000, 'ºC'),
	(52230, 108, '2015-02-15 00:14:36.000000', 'temperatura', 127.0000, 'ºC'),
	(52231, 108, '2015-02-15 00:14:37.000000', 'temperatura', 218.0000, 'ºC'),
	(52232, 108, '2015-02-15 00:14:38.000000', 'temperatura', 709.0000, 'ºC'),
	(52233, 108, '2015-02-15 00:14:39.000000', 'temperatura', 492.0000, 'ºC'),
	(52234, 108, '2015-02-15 00:14:40.000000', 'temperatura', 332.0000, 'ºC'),
	(52235, 108, '2015-02-15 00:14:41.000000', 'temperatura', 185.0000, 'ºC'),
	(52236, 108, '2015-02-15 00:14:42.000000', 'temperatura', 1129.0000, 'ºC'),
	(52237, 108, '2015-02-15 00:14:43.000000', 'temperatura', 292.0000, 'ºC'),
	(52238, 108, '2015-02-15 00:14:44.000000', 'temperatura', 474.0000, 'ºC'),
	(52239, 108, '2015-02-15 00:14:45.000000', 'temperatura', 296.0000, 'ºC'),
	(52240, 108, '2015-02-15 00:14:46.000000', 'temperatura', 55.0000, 'ºC'),
	(52241, 108, '2015-02-15 00:14:47.000000', 'temperatura', 590.0000, 'ºC'),
	(52242, 108, '2015-02-15 00:14:48.000000', 'temperatura', 386.0000, 'ºC'),
	(52243, 108, '2015-02-15 00:14:49.000000', 'temperatura', 161.0000, 'ºC'),
	(52244, 108, '2015-02-15 00:14:50.000000', 'temperatura', 846.0000, 'ºC'),
	(52245, 108, '2015-02-15 00:14:51.000000', 'temperatura', 148.0000, 'ºC'),
	(52246, 108, '2015-02-15 00:14:52.000000', 'temperatura', 603.0000, 'ºC'),
	(52247, 108, '2015-02-15 00:14:53.000000', 'temperatura', 171.0000, 'ºC'),
	(52248, 108, '2015-02-15 00:14:54.000000', 'temperatura', 247.0000, 'ºC'),
	(52249, 108, '2015-02-15 00:14:55.000000', 'temperatura', 722.0000, 'ºC'),
	(52250, 108, '2015-02-15 00:14:56.000000', 'temperatura', 471.0000, 'ºC'),
	(52251, 108, '2015-02-15 00:14:57.000000', 'temperatura', 189.0000, 'ºC'),
	(52252, 108, '2015-02-15 00:14:58.000000', 'temperatura', 731.0000, 'ºC'),
	(52253, 108, '2015-02-15 00:14:59.000000', 'temperatura', 690.0000, 'ºC'),
	(52254, 108, '2015-02-15 00:15:00.000000', 'temperatura', 55.0000, 'ºC'),
	(52255, 108, '2015-02-15 00:15:01.000000', 'temperatura', 607.0000, 'ºC'),
	(52256, 108, '2015-02-15 00:15:02.000000', 'temperatura', 469.0000, 'ºC'),
	(52257, 108, '2015-02-15 00:15:03.000000', 'temperatura', 526.0000, 'ºC'),
	(52258, 108, '2015-02-15 00:15:04.000000', 'temperatura', 23.0000, 'ºC'),
	(52259, 108, '2015-02-15 00:15:05.000000', 'temperatura', 938.0000, 'ºC'),
	(52260, 108, '2015-02-15 00:15:06.000000', 'temperatura', 1020.0000, 'ºC'),
	(52261, 108, '2015-02-15 00:15:07.000000', 'temperatura', 1089.0000, 'ºC'),
	(52262, 108, '2015-02-15 00:15:08.000000', 'temperatura', 1186.0000, 'ºC'),
	(52263, 108, '2015-02-15 00:15:09.000000', 'temperatura', 264.0000, 'ºC'),
	(52264, 108, '2015-02-15 00:15:10.000000', 'temperatura', 162.0000, 'ºC'),
	(52265, 108, '2015-02-15 00:15:11.000000', 'temperatura', 18.0000, 'ºC'),
	(52266, 108, '2015-02-15 00:15:12.000000', 'temperatura', 804.0000, 'ºC'),
	(52267, 108, '2015-02-15 00:15:13.000000', 'temperatura', 369.0000, 'ºC'),
	(52268, 108, '2015-02-15 00:15:14.000000', 'temperatura', 632.0000, 'ºC'),
	(52269, 108, '2015-02-15 00:15:15.000000', 'temperatura', 851.0000, 'ºC'),
	(52270, 108, '2015-02-15 00:15:16.000000', 'temperatura', 1163.0000, 'ºC'),
	(52271, 108, '2015-02-15 00:15:17.000000', 'temperatura', 861.0000, 'ºC'),
	(52272, 108, '2015-02-15 00:15:18.000000', 'temperatura', 817.0000, 'ºC'),
	(52273, 108, '2015-02-15 00:15:19.000000', 'temperatura', 300.0000, 'ºC'),
	(52274, 108, '2015-02-15 00:15:20.000000', 'temperatura', 253.0000, 'ºC'),
	(52275, 108, '2015-02-15 00:15:21.000000', 'temperatura', 363.0000, 'ºC'),
	(52276, 108, '2015-02-15 00:15:22.000000', 'temperatura', 1059.0000, 'ºC'),
	(52277, 108, '2015-02-15 00:15:23.000000', 'temperatura', 604.0000, 'ºC'),
	(52278, 108, '2015-02-15 00:15:24.000000', 'temperatura', 1046.0000, 'ºC'),
	(52279, 108, '2015-02-15 00:15:25.000000', 'temperatura', 1015.0000, 'ºC'),
	(52280, 108, '2015-02-15 00:15:26.000000', 'temperatura', 741.0000, 'ºC'),
	(52281, 108, '2015-02-15 00:15:27.000000', 'temperatura', 660.0000, 'ºC'),
	(52282, 108, '2015-02-15 00:15:28.000000', 'temperatura', 1076.0000, 'ºC'),
	(52283, 108, '2015-02-15 00:15:29.000000', 'temperatura', 1001.0000, 'ºC'),
	(52284, 108, '2015-02-15 00:15:30.000000', 'temperatura', 576.0000, 'ºC'),
	(52285, 108, '2015-02-15 00:15:31.000000', 'temperatura', 1077.0000, 'ºC'),
	(52286, 108, '2015-02-15 00:15:32.000000', 'temperatura', 59.0000, 'ºC'),
	(52287, 108, '2015-02-15 00:15:33.000000', 'temperatura', 663.0000, 'ºC'),
	(52288, 108, '2015-02-15 00:15:34.000000', 'temperatura', 740.0000, 'ºC'),
	(52289, 108, '2015-02-15 00:15:35.000000', 'temperatura', 509.0000, 'ºC'),
	(52290, 108, '2015-02-15 00:15:36.000000', 'temperatura', 327.0000, 'ºC'),
	(52291, 108, '2015-02-15 00:15:37.000000', 'temperatura', 107.0000, 'ºC'),
	(52292, 108, '2015-02-15 00:15:38.000000', 'temperatura', 757.0000, 'ºC'),
	(52293, 108, '2015-02-15 00:15:39.000000', 'temperatura', 1064.0000, 'ºC'),
	(52294, 108, '2015-02-15 00:15:40.000000', 'temperatura', 650.0000, 'ºC'),
	(52295, 108, '2015-02-15 00:15:41.000000', 'temperatura', 59.0000, 'ºC'),
	(52296, 108, '2015-02-15 00:15:42.000000', 'temperatura', 746.0000, 'ºC'),
	(52297, 108, '2015-02-15 00:15:43.000000', 'temperatura', 1154.0000, 'ºC'),
	(52298, 108, '2015-02-15 00:15:44.000000', 'temperatura', 1132.0000, 'ºC'),
	(52299, 108, '2015-02-15 00:15:45.000000', 'temperatura', 998.0000, 'ºC'),
	(52300, 108, '2015-02-15 00:15:46.000000', 'temperatura', 397.0000, 'ºC'),
	(52301, 108, '2015-02-15 00:15:47.000000', 'temperatura', 189.0000, 'ºC'),
	(52302, 108, '2015-02-15 00:15:48.000000', 'temperatura', 953.0000, 'ºC'),
	(52303, 108, '2015-02-15 00:15:49.000000', 'temperatura', 602.0000, 'ºC'),
	(52304, 108, '2015-02-15 00:15:50.000000', 'temperatura', 148.0000, 'ºC'),
	(52305, 108, '2015-02-15 00:15:51.000000', 'temperatura', 137.0000, 'ºC'),
	(52306, 108, '2015-02-15 00:15:52.000000', 'temperatura', 242.0000, 'ºC'),
	(52307, 108, '2015-02-15 00:15:53.000000', 'temperatura', 798.0000, 'ºC'),
	(52308, 108, '2015-02-15 00:15:54.000000', 'temperatura', 864.0000, 'ºC'),
	(52309, 108, '2015-02-15 00:15:55.000000', 'temperatura', 727.0000, 'ºC'),
	(52310, 108, '2015-02-15 00:15:56.000000', 'temperatura', 1042.0000, 'ºC'),
	(52311, 108, '2015-02-15 00:15:57.000000', 'temperatura', 632.0000, 'ºC'),
	(52312, 108, '2015-02-15 00:15:58.000000', 'temperatura', 36.0000, 'ºC'),
	(52313, 108, '2015-02-15 00:15:59.000000', 'temperatura', 681.0000, 'ºC'),
	(52314, 108, '2015-02-15 00:16:00.000000', 'temperatura', 898.0000, 'ºC'),
	(52315, 108, '2015-02-15 00:16:01.000000', 'temperatura', 49.0000, 'ºC'),
	(52316, 108, '2015-02-15 00:16:02.000000', 'temperatura', 1152.0000, 'ºC'),
	(52317, 108, '2015-02-15 00:16:03.000000', 'temperatura', 813.0000, 'ºC'),
	(52318, 108, '2015-02-15 00:16:04.000000', 'temperatura', 610.0000, 'ºC'),
	(52319, 108, '2015-02-15 00:16:05.000000', 'temperatura', 611.0000, 'ºC'),
	(52320, 108, '2015-02-15 00:16:06.000000', 'temperatura', 24.0000, 'ºC'),
	(52321, 108, '2015-02-15 00:16:07.000000', 'temperatura', 690.0000, 'ºC'),
	(52322, 108, '2015-02-15 00:16:08.000000', 'temperatura', 979.0000, 'ºC'),
	(52323, 108, '2015-02-15 00:16:09.000000', 'temperatura', 426.0000, 'ºC'),
	(52324, 108, '2015-02-15 00:16:10.000000', 'temperatura', 391.0000, 'ºC'),
	(52325, 108, '2015-02-15 00:16:11.000000', 'temperatura', 679.0000, 'ºC'),
	(52326, 108, '2015-02-15 00:16:12.000000', 'temperatura', 1023.0000, 'ºC'),
	(52327, 108, '2015-02-15 00:16:13.000000', 'temperatura', 678.0000, 'ºC'),
	(52328, 108, '2015-02-15 00:16:14.000000', 'temperatura', 323.0000, 'ºC'),
	(52329, 108, '2015-02-15 00:16:15.000000', 'temperatura', 779.0000, 'ºC'),
	(52330, 108, '2015-02-15 00:16:16.000000', 'temperatura', 528.0000, 'ºC'),
	(52331, 108, '2015-02-15 00:16:17.000000', 'temperatura', 301.0000, 'ºC'),
	(52332, 108, '2015-02-15 00:16:18.000000', 'temperatura', 1123.0000, 'ºC'),
	(52333, 108, '2015-02-15 00:16:19.000000', 'temperatura', 1113.0000, 'ºC'),
	(52334, 108, '2015-02-15 00:16:20.000000', 'temperatura', 994.0000, 'ºC'),
	(52335, 108, '2015-02-15 00:16:21.000000', 'temperatura', 435.0000, 'ºC'),
	(52336, 108, '2015-02-15 00:16:22.000000', 'temperatura', 392.0000, 'ºC'),
	(52337, 108, '2015-02-15 00:16:23.000000', 'temperatura', 654.0000, 'ºC'),
	(52338, 108, '2015-02-15 00:16:24.000000', 'temperatura', 897.0000, 'ºC'),
	(52339, 108, '2015-02-15 00:16:25.000000', 'temperatura', 122.0000, 'ºC'),
	(52340, 108, '2015-02-15 00:16:26.000000', 'temperatura', 318.0000, 'ºC'),
	(52341, 108, '2015-02-15 00:16:27.000000', 'temperatura', 25.0000, 'ºC'),
	(52342, 108, '2015-02-15 00:16:28.000000', 'temperatura', 374.0000, 'ºC'),
	(52343, 108, '2015-02-15 00:16:29.000000', 'temperatura', 595.0000, 'ºC'),
	(52344, 108, '2015-02-15 00:16:30.000000', 'temperatura', 652.0000, 'ºC'),
	(52345, 108, '2015-02-15 00:16:31.000000', 'temperatura', 278.0000, 'ºC'),
	(52346, 108, '2015-02-15 00:16:32.000000', 'temperatura', 633.0000, 'ºC'),
	(52347, 108, '2015-02-15 00:16:33.000000', 'temperatura', 1133.0000, 'ºC'),
	(52348, 108, '2015-02-15 00:16:34.000000', 'temperatura', 167.0000, 'ºC'),
	(52349, 108, '2015-02-15 00:16:35.000000', 'temperatura', 1038.0000, 'ºC'),
	(52350, 108, '2015-02-15 00:16:36.000000', 'temperatura', 1086.0000, 'ºC'),
	(52351, 108, '2015-02-15 00:16:37.000000', 'temperatura', 1117.0000, 'ºC'),
	(52352, 108, '2015-02-15 00:16:38.000000', 'temperatura', 1129.0000, 'ºC'),
	(52353, 108, '2015-02-15 00:16:39.000000', 'temperatura', 1095.0000, 'ºC'),
	(52354, 108, '2015-02-15 00:16:40.000000', 'temperatura', 886.0000, 'ºC'),
	(52355, 108, '2015-02-15 00:16:41.000000', 'temperatura', 1147.0000, 'ºC'),
	(52356, 108, '2015-02-15 00:16:42.000000', 'temperatura', 677.0000, 'ºC'),
	(52357, 108, '2015-02-15 00:16:43.000000', 'temperatura', 1145.0000, 'ºC'),
	(52358, 108, '2015-02-15 00:16:44.000000', 'temperatura', 93.0000, 'ºC'),
	(52359, 108, '2015-02-15 00:16:45.000000', 'temperatura', 633.0000, 'ºC'),
	(52360, 108, '2015-02-15 00:16:46.000000', 'temperatura', 485.0000, 'ºC'),
	(52361, 108, '2015-02-15 00:16:47.000000', 'temperatura', 526.0000, 'ºC'),
	(52362, 108, '2015-02-15 00:16:48.000000', 'temperatura', 1178.0000, 'ºC'),
	(52363, 108, '2015-02-15 00:16:49.000000', 'temperatura', 712.0000, 'ºC'),
	(52364, 108, '2015-02-15 00:16:50.000000', 'temperatura', 25.0000, 'ºC'),
	(52365, 108, '2015-02-15 00:16:51.000000', 'temperatura', 389.0000, 'ºC'),
	(52366, 108, '2015-02-15 00:16:52.000000', 'temperatura', 673.0000, 'ºC'),
	(52367, 108, '2015-02-15 00:16:53.000000', 'temperatura', 996.0000, 'ºC'),
	(52368, 108, '2015-02-15 00:16:54.000000', 'temperatura', 565.0000, 'ºC'),
	(52369, 108, '2015-02-15 00:16:55.000000', 'temperatura', 1034.0000, 'ºC'),
	(52370, 108, '2015-02-15 00:16:56.000000', 'temperatura', 1075.0000, 'ºC'),
	(52371, 108, '2015-02-15 00:16:57.000000', 'temperatura', 1074.0000, 'ºC'),
	(52372, 108, '2015-02-15 00:16:58.000000', 'temperatura', 945.0000, 'ºC'),
	(52373, 108, '2015-02-15 00:16:59.000000', 'temperatura', 303.0000, 'ºC'),
	(52374, 108, '2015-02-15 00:17:00.000000', 'temperatura', 1082.0000, 'ºC'),
	(52375, 108, '2015-02-15 00:17:01.000000', 'temperatura', 900.0000, 'ºC'),
	(52376, 108, '2015-02-15 00:17:02.000000', 'temperatura', 55.0000, 'ºC'),
	(52377, 108, '2015-02-15 00:17:03.000000', 'temperatura', 1176.0000, 'ºC'),
	(52378, 108, '2015-02-15 00:17:04.000000', 'temperatura', 916.0000, 'ºC'),
	(52379, 108, '2015-02-15 00:17:05.000000', 'temperatura', 1051.0000, 'ºC'),
	(52380, 108, '2015-02-15 00:17:06.000000', 'temperatura', 108.0000, 'ºC'),
	(52381, 108, '2015-02-15 00:17:07.000000', 'temperatura', 989.0000, 'ºC'),
	(52382, 108, '2015-02-15 00:17:08.000000', 'temperatura', 1020.0000, 'ºC'),
	(52383, 108, '2015-02-15 00:17:09.000000', 'temperatura', 932.0000, 'ºC'),
	(52384, 108, '2015-02-15 00:17:10.000000', 'temperatura', 402.0000, 'ºC'),
	(52385, 108, '2015-02-15 00:17:11.000000', 'temperatura', 413.0000, 'ºC'),
	(52386, 108, '2015-02-15 00:17:12.000000', 'temperatura', 863.0000, 'ºC'),
	(52387, 108, '2015-02-15 00:17:13.000000', 'temperatura', 673.0000, 'ºC'),
	(52388, 108, '2015-02-15 00:17:14.000000', 'temperatura', 776.0000, 'ºC'),
	(52389, 108, '2015-02-15 00:17:15.000000', 'temperatura', 664.0000, 'ºC'),
	(52390, 108, '2015-02-15 00:17:16.000000', 'temperatura', 994.0000, 'ºC'),
	(52391, 108, '2015-02-15 00:17:17.000000', 'temperatura', 575.0000, 'ºC'),
	(52392, 108, '2015-02-15 00:17:18.000000', 'temperatura', 1097.0000, 'ºC'),
	(52393, 108, '2015-02-15 00:17:19.000000', 'temperatura', 157.0000, 'ºC'),
	(52394, 108, '2015-02-15 00:17:20.000000', 'temperatura', 1097.0000, 'ºC'),
	(52395, 108, '2015-02-15 00:17:21.000000', 'temperatura', 212.0000, 'ºC'),
	(52396, 108, '2015-02-15 00:17:22.000000', 'temperatura', 170.0000, 'ºC'),
	(52397, 108, '2015-02-15 00:17:23.000000', 'temperatura', 216.0000, 'ºC'),
	(52398, 108, '2015-02-15 00:17:24.000000', 'temperatura', 570.0000, 'ºC'),
	(52399, 108, '2015-02-15 00:17:25.000000', 'temperatura', 1003.0000, 'ºC'),
	(52400, 108, '2015-02-15 00:17:26.000000', 'temperatura', 905.0000, 'ºC'),
	(52401, 108, '2015-02-15 00:17:27.000000', 'temperatura', 315.0000, 'ºC'),
	(52402, 108, '2015-02-15 00:17:28.000000', 'temperatura', 60.0000, 'ºC'),
	(52403, 108, '2015-02-15 00:17:29.000000', 'temperatura', 557.0000, 'ºC'),
	(52404, 108, '2015-02-15 00:17:30.000000', 'temperatura', 205.0000, 'ºC'),
	(52405, 108, '2015-02-15 00:17:31.000000', 'temperatura', 554.0000, 'ºC'),
	(52406, 108, '2015-02-15 00:17:32.000000', 'temperatura', 956.0000, 'ºC'),
	(52407, 108, '2015-02-15 00:17:33.000000', 'temperatura', 719.0000, 'ºC'),
	(52408, 108, '2015-02-15 00:17:34.000000', 'temperatura', 728.0000, 'ºC'),
	(52409, 108, '2015-02-15 00:17:35.000000', 'temperatura', 282.0000, 'ºC'),
	(52410, 108, '2015-02-15 00:17:36.000000', 'temperatura', 428.0000, 'ºC'),
	(52411, 108, '2015-02-15 00:17:37.000000', 'temperatura', 93.0000, 'ºC'),
	(52412, 108, '2015-02-15 00:17:38.000000', 'temperatura', 382.0000, 'ºC'),
	(52413, 108, '2015-02-15 00:17:39.000000', 'temperatura', 431.0000, 'ºC'),
	(52414, 108, '2015-02-15 00:17:40.000000', 'temperatura', 1009.0000, 'ºC'),
	(52415, 108, '2015-02-15 00:17:41.000000', 'temperatura', 153.0000, 'ºC'),
	(52416, 108, '2015-02-15 00:17:42.000000', 'temperatura', 139.0000, 'ºC'),
	(52417, 108, '2015-02-15 00:17:43.000000', 'temperatura', 235.0000, 'ºC'),
	(52418, 108, '2015-02-15 00:17:44.000000', 'temperatura', 758.0000, 'ºC'),
	(52419, 108, '2015-02-15 00:17:45.000000', 'temperatura', 685.0000, 'ºC'),
	(52420, 108, '2015-02-15 00:17:46.000000', 'temperatura', 1153.0000, 'ºC'),
	(52421, 108, '2015-02-15 00:17:47.000000', 'temperatura', 112.0000, 'ºC'),
	(52422, 108, '2015-02-15 00:17:48.000000', 'temperatura', 701.0000, 'ºC'),
	(52423, 108, '2015-02-15 00:17:49.000000', 'temperatura', 768.0000, 'ºC'),
	(52424, 108, '2015-02-15 00:17:50.000000', 'temperatura', 539.0000, 'ºC'),
	(52425, 108, '2015-02-15 00:17:51.000000', 'temperatura', 392.0000, 'ºC'),
	(52426, 108, '2015-02-15 00:17:52.000000', 'temperatura', 345.0000, 'ºC'),
	(52427, 108, '2015-02-15 00:17:53.000000', 'temperatura', 546.0000, 'ºC'),
	(52428, 108, '2015-02-15 00:17:54.000000', 'temperatura', 497.0000, 'ºC'),
	(52429, 108, '2015-02-15 00:17:55.000000', 'temperatura', 847.0000, 'ºC'),
	(52430, 108, '2015-02-15 00:17:56.000000', 'temperatura', 345.0000, 'ºC'),
	(52431, 108, '2015-02-15 00:17:57.000000', 'temperatura', 384.0000, 'ºC'),
	(52432, 108, '2015-02-15 00:17:58.000000', 'temperatura', 886.0000, 'ºC'),
	(52433, 108, '2015-02-15 00:17:59.000000', 'temperatura', 880.0000, 'ºC'),
	(52434, 108, '2015-02-15 00:18:00.000000', 'temperatura', 542.0000, 'ºC'),
	(52435, 108, '2015-02-15 00:18:01.000000', 'temperatura', 71.0000, 'ºC'),
	(52436, 108, '2015-02-15 00:18:02.000000', 'temperatura', 1130.0000, 'ºC'),
	(52437, 108, '2015-02-15 00:18:03.000000', 'temperatura', 636.0000, 'ºC'),
	(52438, 108, '2015-02-15 00:18:04.000000', 'temperatura', 990.0000, 'ºC'),
	(52439, 108, '2015-02-15 00:18:05.000000', 'temperatura', 644.0000, 'ºC'),
	(52440, 108, '2015-02-15 00:18:06.000000', 'temperatura', 248.0000, 'ºC'),
	(52441, 108, '2015-02-15 00:18:07.000000', 'temperatura', 509.0000, 'ºC'),
	(52442, 108, '2015-02-15 00:18:08.000000', 'temperatura', 602.0000, 'ºC'),
	(52443, 108, '2015-02-15 00:18:09.000000', 'temperatura', 283.0000, 'ºC'),
	(52444, 108, '2015-02-15 00:18:10.000000', 'temperatura', 810.0000, 'ºC'),
	(52445, 108, '2015-02-15 00:18:11.000000', 'temperatura', 802.0000, 'ºC'),
	(52446, 108, '2015-02-15 00:18:12.000000', 'temperatura', 381.0000, 'ºC'),
	(52447, 108, '2015-02-15 00:18:13.000000', 'temperatura', 699.0000, 'ºC'),
	(52448, 108, '2015-02-15 00:18:14.000000', 'temperatura', 1154.0000, 'ºC'),
	(52449, 108, '2015-02-15 00:18:15.000000', 'temperatura', 74.0000, 'ºC'),
	(52450, 108, '2015-02-15 00:18:16.000000', 'temperatura', 508.0000, 'ºC'),
	(52451, 108, '2015-02-15 00:18:17.000000', 'temperatura', 1120.0000, 'ºC'),
	(52452, 108, '2015-02-15 00:18:18.000000', 'temperatura', 473.0000, 'ºC'),
	(52453, 108, '2015-02-15 00:18:19.000000', 'temperatura', 208.0000, 'ºC'),
	(52454, 108, '2015-02-15 00:18:20.000000', 'temperatura', 823.0000, 'ºC'),
	(52455, 108, '2015-02-15 00:18:21.000000', 'temperatura', 1089.0000, 'ºC'),
	(52456, 108, '2015-02-15 00:18:22.000000', 'temperatura', 578.0000, 'ºC'),
	(52457, 108, '2015-02-15 00:18:23.000000', 'temperatura', 821.0000, 'ºC'),
	(52458, 108, '2015-02-15 00:18:24.000000', 'temperatura', 1175.0000, 'ºC'),
	(52459, 108, '2015-02-15 00:18:25.000000', 'temperatura', 1010.0000, 'ºC'),
	(52460, 108, '2015-02-15 00:18:26.000000', 'temperatura', 326.0000, 'ºC'),
	(52461, 108, '2015-02-15 00:18:27.000000', 'temperatura', 1000.0000, 'ºC'),
	(52462, 108, '2015-02-15 00:18:28.000000', 'temperatura', 422.0000, 'ºC'),
	(52463, 108, '2015-02-15 00:18:29.000000', 'temperatura', 312.0000, 'ºC'),
	(52464, 108, '2015-02-15 00:18:30.000000', 'temperatura', 294.0000, 'ºC'),
	(52465, 108, '2015-02-15 00:18:31.000000', 'temperatura', 534.0000, 'ºC'),
	(52466, 108, '2015-02-15 00:18:32.000000', 'temperatura', 590.0000, 'ºC'),
	(52467, 108, '2015-02-15 00:18:33.000000', 'temperatura', 150.0000, 'ºC'),
	(52468, 108, '2015-02-15 00:18:34.000000', 'temperatura', 178.0000, 'ºC'),
	(52469, 108, '2015-02-15 00:18:35.000000', 'temperatura', 439.0000, 'ºC'),
	(52470, 108, '2015-02-15 00:18:36.000000', 'temperatura', 464.0000, 'ºC'),
	(52471, 108, '2015-02-15 00:18:37.000000', 'temperatura', 1002.0000, 'ºC'),
	(52472, 108, '2015-02-15 00:18:38.000000', 'temperatura', 19.0000, 'ºC'),
	(52473, 108, '2015-02-15 00:18:39.000000', 'temperatura', 691.0000, 'ºC'),
	(52474, 108, '2015-02-15 00:18:40.000000', 'temperatura', 995.0000, 'ºC'),
	(52475, 108, '2015-02-15 00:18:41.000000', 'temperatura', 506.0000, 'ºC'),
	(52476, 108, '2015-02-15 00:18:42.000000', 'temperatura', 746.0000, 'ºC'),
	(52477, 108, '2015-02-15 00:18:43.000000', 'temperatura', 1011.0000, 'ºC'),
	(52478, 108, '2015-02-15 00:18:44.000000', 'temperatura', 416.0000, 'ºC'),
	(52479, 108, '2015-02-15 00:18:45.000000', 'temperatura', 249.0000, 'ºC'),
	(52480, 108, '2015-02-15 00:18:46.000000', 'temperatura', 1196.0000, 'ºC'),
	(52481, 108, '2015-02-15 00:18:47.000000', 'temperatura', 436.0000, 'ºC'),
	(52482, 108, '2015-02-15 00:18:48.000000', 'temperatura', 991.0000, 'ºC'),
	(52483, 108, '2015-02-15 00:18:49.000000', 'temperatura', 47.0000, 'ºC'),
	(52484, 108, '2015-02-15 00:18:50.000000', 'temperatura', 864.0000, 'ºC'),
	(52485, 108, '2015-02-15 00:18:51.000000', 'temperatura', 577.0000, 'ºC'),
	(52486, 108, '2015-02-15 00:18:52.000000', 'temperatura', 295.0000, 'ºC'),
	(52487, 108, '2015-02-15 00:18:53.000000', 'temperatura', 945.0000, 'ºC'),
	(52488, 108, '2015-02-15 00:18:54.000000', 'temperatura', 241.0000, 'ºC'),
	(52489, 108, '2015-02-15 00:18:55.000000', 'temperatura', 769.0000, 'ºC'),
	(52490, 108, '2015-02-15 00:18:56.000000', 'temperatura', 722.0000, 'ºC'),
	(52491, 108, '2015-02-15 00:18:57.000000', 'temperatura', 103.0000, 'ºC'),
	(52492, 108, '2015-02-15 00:18:58.000000', 'temperatura', 751.0000, 'ºC'),
	(52493, 108, '2015-02-15 00:18:59.000000', 'temperatura', 1044.0000, 'ºC'),
	(52494, 108, '2015-02-15 00:19:00.000000', 'temperatura', 570.0000, 'ºC'),
	(52495, 108, '2015-02-15 00:19:01.000000', 'temperatura', 916.0000, 'ºC'),
	(52496, 108, '2015-02-15 00:19:02.000000', 'temperatura', 473.0000, 'ºC'),
	(52497, 108, '2015-02-15 00:19:03.000000', 'temperatura', 817.0000, 'ºC'),
	(52498, 108, '2015-02-15 00:19:04.000000', 'temperatura', 266.0000, 'ºC'),
	(52499, 108, '2015-02-15 00:19:05.000000', 'temperatura', 81.0000, 'ºC'),
	(52500, 108, '2015-02-15 00:19:06.000000', 'temperatura', 805.0000, 'ºC'),
	(52501, 108, '2015-02-15 00:19:07.000000', 'temperatura', 184.0000, 'ºC'),
	(52502, 108, '2015-02-15 00:19:08.000000', 'temperatura', 907.0000, 'ºC'),
	(52503, 108, '2015-02-15 00:19:09.000000', 'temperatura', 381.0000, 'ºC'),
	(52504, 108, '2015-02-15 00:19:10.000000', 'temperatura', 384.0000, 'ºC'),
	(52505, 108, '2015-02-15 00:19:11.000000', 'temperatura', 779.0000, 'ºC'),
	(52506, 108, '2015-02-15 00:19:12.000000', 'temperatura', 345.0000, 'ºC'),
	(52507, 108, '2015-02-15 00:19:13.000000', 'temperatura', 588.0000, 'ºC'),
	(52508, 108, '2015-02-15 00:19:14.000000', 'temperatura', 705.0000, 'ºC'),
	(52509, 108, '2015-02-15 00:19:15.000000', 'temperatura', 563.0000, 'ºC'),
	(52510, 108, '2015-02-15 00:19:16.000000', 'temperatura', 700.0000, 'ºC'),
	(52511, 108, '2015-02-15 00:19:17.000000', 'temperatura', 613.0000, 'ºC'),
	(52512, 108, '2015-02-15 00:19:18.000000', 'temperatura', 963.0000, 'ºC'),
	(52513, 108, '2015-02-15 00:19:19.000000', 'temperatura', 579.0000, 'ºC'),
	(52514, 108, '2015-02-15 00:19:20.000000', 'temperatura', 5.0000, 'ºC'),
	(52515, 108, '2015-02-15 00:19:21.000000', 'temperatura', 689.0000, 'ºC'),
	(52516, 108, '2015-02-15 00:19:22.000000', 'temperatura', 1028.0000, 'ºC'),
	(52517, 108, '2015-02-15 00:19:23.000000', 'temperatura', 677.0000, 'ºC'),
	(52518, 108, '2015-02-15 00:19:24.000000', 'temperatura', 300.0000, 'ºC'),
	(52519, 108, '2015-02-15 00:19:25.000000', 'temperatura', 669.0000, 'ºC'),
	(52520, 108, '2015-02-15 00:19:26.000000', 'temperatura', 47.0000, 'ºC'),
	(52521, 108, '2015-02-15 00:19:27.000000', 'temperatura', 630.0000, 'ºC'),
	(52522, 108, '2015-02-15 00:19:28.000000', 'temperatura', 607.0000, 'ºC'),
	(52523, 108, '2015-02-15 00:19:29.000000', 'temperatura', 1144.0000, 'ºC'),
	(52524, 108, '2015-02-15 00:19:30.000000', 'temperatura', 303.0000, 'ºC'),
	(52525, 108, '2015-02-15 00:19:31.000000', 'temperatura', 482.0000, 'ºC'),
	(52526, 108, '2015-02-15 00:19:32.000000', 'temperatura', 302.0000, 'ºC'),
	(52527, 108, '2015-02-15 00:19:33.000000', 'temperatura', 64.0000, 'ºC'),
	(52528, 108, '2015-02-15 00:19:34.000000', 'temperatura', 613.0000, 'ºC'),
	(52529, 108, '2015-02-15 00:19:35.000000', 'temperatura', 475.0000, 'ºC'),
	(52530, 108, '2015-02-15 00:19:36.000000', 'temperatura', 534.0000, 'ºC'),
	(52531, 108, '2015-02-15 00:19:37.000000', 'temperatura', 48.0000, 'ºC'),
	(52532, 108, '2015-02-15 00:19:38.000000', 'temperatura', 1037.0000, 'ºC'),
	(52533, 108, '2015-02-15 00:19:39.000000', 'temperatura', 241.0000, 'ºC'),
	(52534, 108, '2015-02-15 00:19:40.000000', 'temperatura', 495.0000, 'ºC'),
	(52535, 108, '2015-02-15 00:19:41.000000', 'temperatura', 553.0000, 'ºC'),
	(52536, 108, '2015-02-15 00:19:42.000000', 'temperatura', 78.0000, 'ºC'),
	(52537, 108, '2015-02-15 00:19:43.000000', 'temperatura', 1134.0000, 'ºC'),
	(52538, 108, '2015-02-15 00:19:44.000000', 'temperatura', 634.0000, 'ºC'),
	(52539, 108, '2015-02-15 00:19:45.000000', 'temperatura', 971.0000, 'ºC'),
	(52540, 108, '2015-02-15 00:19:46.000000', 'temperatura', 555.0000, 'ºC'),
	(52541, 108, '2015-02-15 00:19:47.000000', 'temperatura', 1060.0000, 'ºC'),
	(52542, 108, '2015-02-15 00:19:48.000000', 'temperatura', 35.0000, 'ºC'),
	(52543, 108, '2015-02-15 00:19:49.000000', 'temperatura', 596.0000, 'ºC'),
	(52544, 108, '2015-02-15 00:19:50.000000', 'temperatura', 474.0000, 'ºC'),
	(52545, 108, '2015-02-15 00:19:51.000000', 'temperatura', 585.0000, 'ºC'),
	(52546, 108, '2015-02-15 00:19:52.000000', 'temperatura', 302.0000, 'ºC'),
	(52547, 108, '2015-02-15 00:19:53.000000', 'temperatura', 954.0000, 'ºC'),
	(52548, 108, '2015-02-15 00:19:54.000000', 'temperatura', 267.0000, 'ºC'),
	(52549, 108, '2015-02-15 00:19:55.000000', 'temperatura', 874.0000, 'ºC'),
	(52550, 108, '2015-02-15 00:19:56.000000', 'temperatura', 1167.0000, 'ºC'),
	(52551, 108, '2015-02-15 00:19:57.000000', 'temperatura', 814.0000, 'ºC'),
	(52552, 108, '2015-02-15 00:19:58.000000', 'temperatura', 571.0000, 'ºC'),
	(52553, 108, '2015-02-15 00:19:59.000000', 'temperatura', 411.0000, 'ºC'),
	(52554, 108, '2015-02-15 00:20:00.000000', 'temperatura', 343.0000, 'ºC'),
	(52555, 108, '2015-02-15 00:20:01.000000', 'temperatura', 481.0000, 'ºC'),
	(52556, 108, '2015-02-15 00:20:02.000000', 'temperatura', 179.0000, 'ºC'),
	(52557, 108, '2015-02-15 00:20:03.000000', 'temperatura', 654.0000, 'ºC'),
	(52558, 108, '2015-02-15 00:20:04.000000', 'temperatura', 331.0000, 'ºC'),
	(52559, 108, '2015-02-15 00:20:05.000000', 'temperatura', 893.0000, 'ºC'),
	(52560, 108, '2015-02-15 00:20:06.000000', 'temperatura', 1075.0000, 'ºC'),
	(52561, 108, '2015-02-15 00:20:07.000000', 'temperatura', 293.0000, 'ºC'),
	(52562, 108, '2015-02-15 00:20:08.000000', 'temperatura', 643.0000, 'ºC'),
	(52563, 108, '2015-02-15 00:20:09.000000', 'temperatura', 1137.0000, 'ºC'),
	(52564, 108, '2015-02-15 00:20:10.000000', 'temperatura', 157.0000, 'ºC'),
	(52565, 108, '2015-02-15 00:20:11.000000', 'temperatura', 975.0000, 'ºC'),
	(52566, 108, '2015-02-15 00:20:12.000000', 'temperatura', 804.0000, 'ºC'),
	(52567, 108, '2015-02-15 00:20:13.000000', 'temperatura', 1095.0000, 'ºC'),
	(52568, 108, '2015-02-15 00:20:14.000000', 'temperatura', 664.0000, 'ºC'),
	(52569, 108, '2015-02-15 00:20:15.000000', 'temperatura', 35.0000, 'ºC'),
	(52570, 108, '2015-02-15 00:20:16.000000', 'temperatura', 585.0000, 'ºC'),
	(52571, 108, '2015-02-15 00:20:17.000000', 'temperatura', 418.0000, 'ºC'),
	(52572, 108, '2015-02-15 00:20:18.000000', 'temperatura', 336.0000, 'ºC'),
	(52573, 108, '2015-02-15 00:20:19.000000', 'temperatura', 425.0000, 'ºC'),
	(52574, 108, '2015-02-15 00:20:20.000000', 'temperatura', 1120.0000, 'ºC'),
	(52575, 108, '2015-02-15 00:20:21.000000', 'temperatura', 726.0000, 'ºC'),
	(52576, 108, '2015-02-15 00:20:22.000000', 'temperatura', 272.0000, 'ºC'),
	(52577, 108, '2015-02-15 00:20:23.000000', 'temperatura', 379.0000, 'ºC'),
	(52578, 108, '2015-02-15 00:20:24.000000', 'temperatura', 1080.0000, 'ºC'),
	(52579, 108, '2015-02-15 00:20:25.000000', 'temperatura', 664.0000, 'ºC'),
	(52580, 108, '2015-02-15 00:20:26.000000', 'temperatura', 79.0000, 'ºC'),
	(52581, 108, '2015-02-15 00:20:27.000000', 'temperatura', 805.0000, 'ºC'),
	(52582, 108, '2015-02-15 00:20:28.000000', 'temperatura', 187.0000, 'ºC'),
	(52583, 108, '2015-02-15 00:20:29.000000', 'temperatura', 923.0000, 'ºC'),
	(52584, 108, '2015-02-15 00:20:30.000000', 'temperatura', 453.0000, 'ºC'),
	(52585, 108, '2015-02-15 00:20:31.000000', 'temperatura', 698.0000, 'ºC'),
	(52586, 108, '2015-02-15 00:20:32.000000', 'temperatura', 931.0000, 'ºC'),
	(52587, 108, '2015-02-15 00:20:33.000000', 'temperatura', 160.0000, 'ºC'),
	(52588, 108, '2015-02-15 00:20:34.000000', 'temperatura', 408.0000, 'ºC'),
	(52589, 108, '2015-02-15 00:20:35.000000', 'temperatura', 361.0000, 'ºC'),
	(52590, 108, '2015-02-15 00:20:36.000000', 'temperatura', 580.0000, 'ºC'),
	(52591, 108, '2015-02-15 00:20:37.000000', 'temperatura', 619.0000, 'ºC'),
	(52592, 108, '2015-02-15 00:20:38.000000', 'temperatura', 157.0000, 'ºC'),
	(52593, 108, '2015-02-15 00:20:39.000000', 'temperatura', 126.0000, 'ºC'),
	(52594, 108, '2015-02-15 00:20:40.000000', 'temperatura', 162.0000, 'ºC'),
	(52595, 108, '2015-02-15 00:20:41.000000', 'temperatura', 433.0000, 'ºC'),
	(52596, 108, '2015-02-15 00:20:42.000000', 'temperatura', 479.0000, 'ºC'),
	(52597, 108, '2015-02-15 00:20:43.000000', 'temperatura', 1096.0000, 'ºC'),
	(52598, 108, '2015-02-15 00:20:44.000000', 'temperatura', 443.0000, 'ºC'),
	(52599, 108, '2015-02-15 00:20:45.000000', 'temperatura', 127.0000, 'ºC'),
	(52600, 108, '2015-02-15 00:20:46.000000', 'temperatura', 508.0000, 'ºC'),
	(52601, 108, '2015-02-15 00:20:47.000000', 'temperatura', 959.0000, 'ºC'),
	(52602, 108, '2015-02-15 00:20:48.000000', 'temperatura', 870.0000, 'ºC'),
	(52603, 108, '2015-02-15 00:20:49.000000', 'temperatura', 273.0000, 'ºC'),
	(52604, 108, '2015-02-15 00:20:50.000000', 'temperatura', 1157.0000, 'ºC'),
	(52605, 108, '2015-02-15 00:20:51.000000', 'temperatura', 164.0000, 'ºC'),
	(52606, 108, '2015-02-15 00:20:52.000000', 'temperatura', 952.0000, 'ºC'),
	(52607, 108, '2015-02-15 00:20:53.000000', 'temperatura', 668.0000, 'ºC'),
	(52608, 108, '2015-02-15 00:20:54.000000', 'temperatura', 483.0000, 'ºC'),
	(52609, 108, '2015-02-15 00:20:55.000000', 'temperatura', 412.0000, 'ºC'),
	(52610, 108, '2015-02-15 00:20:56.000000', 'temperatura', 611.0000, 'ºC'),
	(52611, 108, '2015-02-15 00:20:57.000000', 'temperatura', 620.0000, 'ºC'),
	(52612, 108, '2015-02-15 00:20:58.000000', 'temperatura', 67.0000, 'ºC'),
	(52613, 108, '2015-02-15 00:20:59.000000', 'temperatura', 874.0000, 'ºC'),
	(52614, 108, '2015-02-15 00:21:00.000000', 'temperatura', 573.0000, 'ºC'),
	(52615, 108, '2015-02-15 00:21:01.000000', 'temperatura', 242.0000, 'ºC'),
	(52616, 108, '2015-02-15 00:21:02.000000', 'temperatura', 690.0000, 'ºC'),
	(52617, 108, '2015-02-15 00:21:03.000000', 'temperatura', 326.0000, 'ºC'),
	(52618, 108, '2015-02-15 00:21:04.000000', 'temperatura', 762.0000, 'ºC'),
	(52619, 108, '2015-02-15 00:21:05.000000', 'temperatura', 432.0000, 'ºC'),
	(52620, 108, '2015-02-15 00:21:06.000000', 'temperatura', 1075.0000, 'ºC'),
	(52621, 108, '2015-02-15 00:21:07.000000', 'temperatura', 479.0000, 'ºC'),
	(52622, 108, '2015-02-15 00:21:08.000000', 'temperatura', 370.0000, 'ºC'),
	(52623, 108, '2015-02-15 00:21:09.000000', 'temperatura', 412.0000, 'ºC'),
	(52624, 108, '2015-02-15 00:21:10.000000', 'temperatura', 953.0000, 'ºC'),
	(52625, 108, '2015-02-15 00:21:11.000000', 'temperatura', 1129.0000, 'ºC'),
	(52626, 108, '2015-02-15 00:21:12.000000', 'temperatura', 385.0000, 'ºC'),
	(52627, 108, '2015-02-15 00:21:13.000000', 'temperatura', 941.0000, 'ºC'),
	(52628, 108, '2015-02-15 00:21:14.000000', 'temperatura', 1151.0000, 'ºC'),
	(52629, 108, '2015-02-15 00:21:15.000000', 'temperatura', 531.0000, 'ºC'),
	(52630, 108, '2015-02-15 00:21:16.000000', 'temperatura', 403.0000, 'ºC'),
	(52631, 108, '2015-02-15 00:21:17.000000', 'temperatura', 420.0000, 'ºC'),
	(52632, 108, '2015-02-15 00:21:18.000000', 'temperatura', 895.0000, 'ºC'),
	(52633, 108, '2015-02-15 00:21:19.000000', 'temperatura', 815.0000, 'ºC'),
	(52634, 108, '2015-02-15 00:21:20.000000', 'temperatura', 191.0000, 'ºC'),
	(52635, 108, '2015-02-15 00:21:21.000000', 'temperatura', 909.0000, 'ºC'),
	(52636, 108, '2015-02-15 00:21:22.000000', 'temperatura', 373.0000, 'ºC'),
	(52637, 108, '2015-02-15 00:21:23.000000', 'temperatura', 341.0000, 'ºC'),
	(52638, 108, '2015-02-15 00:21:24.000000', 'temperatura', 583.0000, 'ºC'),
	(52639, 108, '2015-02-15 00:21:25.000000', 'temperatura', 694.0000, 'ºC'),
	(52640, 108, '2015-02-15 00:21:26.000000', 'temperatura', 522.0000, 'ºC'),
	(52641, 108, '2015-02-15 00:21:27.000000', 'temperatura', 526.0000, 'ºC'),
	(52642, 108, '2015-02-15 00:21:28.000000', 'temperatura', 1067.0000, 'ºC'),
	(52643, 108, '2015-02-15 00:21:29.000000', 'temperatura', 158.0000, 'ºC'),
	(52644, 108, '2015-02-15 00:21:30.000000', 'temperatura', 1191.0000, 'ºC'),
	(52645, 108, '2015-02-15 00:21:31.000000', 'temperatura', 678.0000, 'ºC'),
	(52646, 108, '2015-02-15 00:21:32.000000', 'temperatura', 1019.0000, 'ºC'),
	(52647, 108, '2015-02-15 00:21:33.000000', 'temperatura', 660.0000, 'ºC'),
	(52648, 108, '2015-02-15 00:21:34.000000', 'temperatura', 245.0000, 'ºC'),
	(52649, 108, '2015-02-15 00:21:35.000000', 'temperatura', 444.0000, 'ºC'),
	(52650, 108, '2015-02-15 00:21:36.000000', 'temperatura', 286.0000, 'ºC'),
	(52651, 108, '2015-02-15 00:21:37.000000', 'temperatura', 99.0000, 'ºC'),
	(52652, 108, '2015-02-15 00:21:38.000000', 'temperatura', 837.0000, 'ºC'),
	(52653, 108, '2015-02-15 00:21:39.000000', 'temperatura', 290.0000, 'ºC'),
	(52654, 108, '2015-02-15 00:21:40.000000', 'temperatura', 138.0000, 'ºC'),
	(52655, 108, '2015-02-15 00:21:41.000000', 'temperatura', 1020.0000, 'ºC'),
	(52656, 108, '2015-02-15 00:21:42.000000', 'temperatura', 1088.0000, 'ºC'),
	(52657, 108, '2015-02-15 00:21:43.000000', 'temperatura', 1181.0000, 'ºC'),
	(52658, 108, '2015-02-15 00:21:44.000000', 'temperatura', 241.0000, 'ºC'),
	(52659, 108, '2015-02-15 00:21:45.000000', 'temperatura', 64.0000, 'ºC'),
	(52660, 108, '2015-02-15 00:21:46.000000', 'temperatura', 794.0000, 'ºC'),
	(52661, 108, '2015-02-15 00:21:47.000000', 'temperatura', 181.0000, 'ºC'),
	(52662, 108, '2015-02-15 00:21:48.000000', 'temperatura', 922.0000, 'ºC'),
	(52663, 108, '2015-02-15 00:21:49.000000', 'temperatura', 470.0000, 'ºC'),
	(52664, 108, '2015-02-15 00:21:50.000000', 'temperatura', 784.0000, 'ºC'),
	(52665, 108, '2015-02-15 00:21:51.000000', 'temperatura', 108.0000, 'ºC'),
	(52666, 108, '2015-02-15 00:21:52.000000', 'temperatura', 590.0000, 'ºC'),
	(52667, 108, '2015-02-15 00:21:53.000000', 'temperatura', 225.0000, 'ºC'),
	(52668, 108, '2015-02-15 00:21:54.000000', 'temperatura', 557.0000, 'ºC'),
	(52669, 108, '2015-02-15 00:21:55.000000', 'temperatura', 910.0000, 'ºC'),
	(52670, 108, '2015-02-15 00:21:56.000000', 'temperatura', 479.0000, 'ºC'),
	(52671, 108, '2015-02-15 00:21:57.000000', 'temperatura', 864.0000, 'ºC'),
	(52672, 108, '2015-02-15 00:21:58.000000', 'temperatura', 487.0000, 'ºC'),
	(52673, 108, '2015-02-15 00:21:59.000000', 'temperatura', 1041.0000, 'ºC'),
	(52674, 108, '2015-02-15 00:22:00.000000', 'temperatura', 143.0000, 'ºC'),
	(52675, 108, '2015-02-15 00:22:01.000000', 'temperatura', 1195.0000, 'ºC'),
	(52676, 108, '2015-02-15 00:22:02.000000', 'temperatura', 748.0000, 'ºC'),
	(52677, 108, '2015-02-15 00:22:03.000000', 'temperatura', 153.0000, 'ºC'),
	(52678, 108, '2015-02-15 00:22:04.000000', 'temperatura', 922.0000, 'ºC'),
	(52679, 108, '2015-02-15 00:22:05.000000', 'temperatura', 551.0000, 'ºC'),
	(52680, 108, '2015-02-15 00:22:06.000000', 'temperatura', 1189.0000, 'ºC'),
	(52681, 108, '2015-02-15 00:22:07.000000', 'temperatura', 694.0000, 'ºC'),
	(52682, 108, '2015-02-15 00:22:08.000000', 'temperatura', 1101.0000, 'ºC'),
	(52683, 108, '2015-02-15 00:22:09.000000', 'temperatura', 1025.0000, 'ºC'),
	(52684, 108, '2015-02-15 00:22:10.000000', 'temperatura', 621.0000, 'ºC'),
	(52685, 108, '2015-02-15 00:22:11.000000', 'temperatura', 30.0000, 'ºC'),
	(52686, 108, '2015-02-15 00:22:12.000000', 'temperatura', 690.0000, 'ºC'),
	(52687, 108, '2015-02-15 00:22:13.000000', 'temperatura', 958.0000, 'ºC'),
	(52688, 108, '2015-02-15 00:22:14.000000', 'temperatura', 321.0000, 'ºC'),
	(52689, 108, '2015-02-15 00:22:15.000000', 'temperatura', 1132.0000, 'ºC'),
	(52690, 108, '2015-02-15 00:22:16.000000', 'temperatura', 1099.0000, 'ºC'),
	(52691, 108, '2015-02-15 00:22:17.000000', 'temperatura', 898.0000, 'ºC'),
	(52692, 108, '2015-02-15 00:22:18.000000', 'temperatura', 1195.0000, 'ºC'),
	(52693, 108, '2015-02-15 00:22:19.000000', 'temperatura', 880.0000, 'ºC'),
	(52694, 108, '2015-02-15 00:22:20.000000', 'temperatura', 814.0000, 'ºC'),
	(52695, 108, '2015-02-15 00:22:21.000000', 'temperatura', 231.0000, 'ºC'),
	(52696, 108, '2015-02-15 00:22:22.000000', 'temperatura', 1115.0000, 'ºC'),
	(52697, 108, '2015-02-15 00:22:23.000000', 'temperatura', 84.0000, 'ºC'),
	(52698, 108, '2015-02-15 00:22:24.000000', 'temperatura', 673.0000, 'ºC'),
	(52699, 108, '2015-02-15 00:22:25.000000', 'temperatura', 715.0000, 'ºC'),
	(52700, 108, '2015-02-15 00:22:26.000000', 'temperatura', 355.0000, 'ºC'),
	(52701, 108, '2015-02-15 00:22:27.000000', 'temperatura', 833.0000, 'ºC'),
	(52702, 108, '2015-02-15 00:22:28.000000', 'temperatura', 700.0000, 'ºC'),
	(52703, 108, '2015-02-15 00:22:29.000000', 'temperatura', 1001.0000, 'ºC'),
	(52704, 108, '2015-02-15 00:22:30.000000', 'temperatura', 504.0000, 'ºC'),
	(52705, 108, '2015-02-15 00:22:31.000000', 'temperatura', 718.0000, 'ºC'),
	(52706, 108, '2015-02-15 00:22:32.000000', 'temperatura', 880.0000, 'ºC'),
	(52707, 108, '2015-02-15 00:22:33.000000', 'temperatura', 1047.0000, 'ºC'),
	(52708, 108, '2015-02-15 00:22:34.000000', 'temperatura', 195.0000, 'ºC'),
	(52709, 108, '2015-02-15 00:22:35.000000', 'temperatura', 234.0000, 'ºC'),
	(52710, 108, '2015-02-15 00:22:36.000000', 'temperatura', 587.0000, 'ºC'),
	(52711, 108, '2015-02-15 00:22:37.000000', 'temperatura', 1032.0000, 'ºC'),
	(52712, 108, '2015-02-15 00:22:38.000000', 'temperatura', 998.0000, 'ºC'),
	(52713, 108, '2015-02-15 00:22:39.000000', 'temperatura', 696.0000, 'ºC'),
	(52714, 108, '2015-02-15 00:22:40.000000', 'temperatura', 488.0000, 'ºC'),
	(52715, 108, '2015-02-15 00:22:41.000000', 'temperatura', 353.0000, 'ºC'),
	(52716, 108, '2015-02-15 00:22:42.000000', 'temperatura', 299.0000, 'ºC'),
	(52717, 108, '2015-02-15 00:22:43.000000', 'temperatura', 438.0000, 'ºC'),
	(52718, 108, '2015-02-15 00:22:44.000000', 'temperatura', 92.0000, 'ºC'),
	(52719, 108, '2015-02-15 00:22:45.000000', 'temperatura', 349.0000, 'ºC'),
	(52720, 108, '2015-02-15 00:22:46.000000', 'temperatura', 267.0000, 'ºC'),
	(52721, 108, '2015-02-15 00:22:47.000000', 'temperatura', 291.0000, 'ºC'),
	(52722, 108, '2015-02-15 00:22:48.000000', 'temperatura', 652.0000, 'ºC'),
	(52723, 108, '2015-02-15 00:22:49.000000', 'temperatura', 1187.0000, 'ºC'),
	(52724, 108, '2015-02-15 00:22:50.000000', 'temperatura', 382.0000, 'ºC'),
	(52725, 108, '2015-02-15 00:22:51.000000', 'temperatura', 748.0000, 'ºC'),
	(52726, 108, '2015-02-15 00:22:52.000000', 'temperatura', 194.0000, 'ºC'),
	(52727, 108, '2015-02-15 00:22:53.000000', 'temperatura', 1127.0000, 'ºC'),
	(52728, 108, '2015-02-15 00:22:54.000000', 'temperatura', 253.0000, 'ºC'),
	(52729, 108, '2015-02-15 00:22:55.000000', 'temperatura', 285.0000, 'ºC'),
	(52730, 108, '2015-02-15 00:22:56.000000', 'temperatura', 667.0000, 'ºC'),
	(52731, 108, '2015-02-15 00:22:57.000000', 'temperatura', 81.0000, 'ºC'),
	(52732, 108, '2015-02-15 00:22:58.000000', 'temperatura', 802.0000, 'ºC'),
	(52733, 108, '2015-02-15 00:22:59.000000', 'temperatura', 168.0000, 'ºC'),
	(52734, 108, '2015-02-15 00:23:00.000000', 'temperatura', 835.0000, 'ºC'),
	(52735, 108, '2015-02-15 00:23:01.000000', 'temperatura', 73.0000, 'ºC'),
	(52736, 108, '2015-02-15 00:23:02.000000', 'temperatura', 259.0000, 'ºC'),
	(52737, 108, '2015-02-15 00:23:03.000000', 'temperatura', 1076.0000, 'ºC'),
	(52738, 108, '2015-02-15 00:23:04.000000', 'temperatura', 1003.0000, 'ºC'),
	(52739, 108, '2015-02-15 00:23:05.000000', 'temperatura', 590.0000, 'ºC'),
	(52740, 108, '2015-02-15 00:23:06.000000', 'temperatura', 1139.0000, 'ºC'),
	(52741, 108, '2015-02-15 00:23:07.000000', 'temperatura', 326.0000, 'ºC'),
	(52742, 108, '2015-02-15 00:23:08.000000', 'temperatura', 614.0000, 'ºC'),
	(52743, 108, '2015-02-15 00:23:09.000000', 'temperatura', 892.0000, 'ºC'),
	(52744, 108, '2015-02-15 00:23:10.000000', 'temperatura', 220.0000, 'ºC'),
	(52745, 108, '2015-02-15 00:23:11.000000', 'temperatura', 822.0000, 'ºC'),
	(52746, 108, '2015-02-15 00:23:12.000000', 'temperatura', 1050.0000, 'ºC'),
	(52747, 108, '2015-02-15 00:23:13.000000', 'temperatura', 387.0000, 'ºC'),
	(52748, 108, '2015-02-15 00:23:14.000000', 'temperatura', 1183.0000, 'ºC'),
	(52749, 108, '2015-02-15 00:23:15.000000', 'temperatura', 1158.0000, 'ºC'),
	(52750, 108, '2015-02-15 00:23:16.000000', 'temperatura', 1039.0000, 'ºC'),
	(52751, 108, '2015-02-15 00:23:17.000000', 'temperatura', 521.0000, 'ºC'),
	(52752, 108, '2015-02-15 00:23:18.000000', 'temperatura', 687.0000, 'ºC'),
	(52753, 108, '2015-02-15 00:23:19.000000', 'temperatura', 676.0000, 'ºC'),
	(52754, 108, '2015-02-15 00:23:20.000000', 'temperatura', 119.0000, 'ºC'),
	(52755, 108, '2015-02-15 00:23:21.000000', 'temperatura', 966.0000, 'ºC'),
	(52756, 108, '2015-02-15 00:23:22.000000', 'temperatura', 874.0000, 'ºC'),
	(52757, 108, '2015-02-15 00:23:23.000000', 'temperatura', 275.0000, 'ºC'),
	(52758, 108, '2015-02-15 00:23:24.000000', 'temperatura', 1150.0000, 'ºC'),
	(52759, 108, '2015-02-15 00:23:25.000000', 'temperatura', 127.0000, 'ºC'),
	(52760, 108, '2015-02-15 00:23:26.000000', 'temperatura', 787.0000, 'ºC'),
	(52761, 108, '2015-02-15 00:23:27.000000', 'temperatura', 1153.0000, 'ºC'),
	(52762, 108, '2015-02-15 00:23:28.000000', 'temperatura', 1003.0000, 'ºC'),
	(52763, 108, '2015-02-15 00:23:29.000000', 'temperatura', 358.0000, 'ºC'),
	(52764, 108, '2015-02-15 00:23:30.000000', 'temperatura', 1180.0000, 'ºC'),
	(52765, 108, '2015-02-15 00:23:31.000000', 'temperatura', 26.0000, 'ºC'),
	(52766, 108, '2015-02-15 00:23:32.000000', 'temperatura', 191.0000, 'ºC'),
	(52767, 108, '2015-02-15 00:23:33.000000', 'temperatura', 879.0000, 'ºC'),
	(52768, 108, '2015-02-15 00:23:34.000000', 'temperatura', 220.0000, 'ºC'),
	(52769, 108, '2015-02-15 00:23:35.000000', 'temperatura', 864.0000, 'ºC'),
	(52770, 108, '2015-02-15 00:23:36.000000', 'temperatura', 63.0000, 'ºC'),
	(52771, 108, '2015-02-15 00:23:37.000000', 'temperatura', 120.0000, 'ºC'),
	(52772, 108, '2015-02-15 00:23:38.000000', 'temperatura', 413.0000, 'ºC'),
	(52773, 108, '2015-02-15 00:23:39.000000', 'temperatura', 507.0000, 'ºC'),
	(52774, 108, '2015-02-15 00:23:40.000000', 'temperatura', 97.0000, 'ºC'),
	(52775, 108, '2015-02-15 00:23:41.000000', 'temperatura', 165.0000, 'ºC'),
	(52776, 108, '2015-02-15 00:23:42.000000', 'temperatura', 534.0000, 'ºC'),
	(52777, 108, '2015-02-15 00:23:43.000000', 'temperatura', 975.0000, 'ºC'),
	(52778, 108, '2015-02-15 00:23:44.000000', 'temperatura', 874.0000, 'ºC'),
	(52779, 108, '2015-02-15 00:23:45.000000', 'temperatura', 245.0000, 'ºC'),
	(52780, 108, '2015-02-15 00:23:46.000000', 'temperatura', 1005.0000, 'ºC'),
	(52781, 108, '2015-02-15 00:23:47.000000', 'temperatura', 690.0000, 'ºC'),
	(52782, 108, '2015-02-15 00:23:48.000000', 'temperatura', 434.0000, 'ºC'),
	(52783, 108, '2015-02-15 00:23:49.000000', 'temperatura', 102.0000, 'ºC'),
	(52784, 108, '2015-02-15 00:23:50.000000', 'temperatura', 409.0000, 'ºC'),
	(52785, 108, '2015-02-15 00:23:51.000000', 'temperatura', 539.0000, 'ºC'),
	(52786, 108, '2015-02-15 00:23:52.000000', 'temperatura', 267.0000, 'ºC'),
	(52787, 108, '2015-02-15 00:23:53.000000', 'temperatura', 921.0000, 'ºC'),
	(52788, 108, '2015-02-15 00:23:54.000000', 'temperatura', 203.0000, 'ºC'),
	(52789, 108, '2015-02-15 00:23:55.000000', 'temperatura', 653.0000, 'ºC'),
	(52790, 108, '2015-02-15 00:23:56.000000', 'temperatura', 254.0000, 'ºC'),
	(52791, 108, '2015-02-15 00:23:57.000000', 'temperatura', 514.0000, 'ºC'),
	(52792, 108, '2015-02-15 00:23:58.000000', 'temperatura', 609.0000, 'ºC'),
	(52793, 108, '2015-02-15 00:23:59.000000', 'temperatura', 303.0000, 'ºC'),
	(52794, 108, '2015-02-15 00:24:00.000000', 'temperatura', 890.0000, 'ºC'),
	(52795, 108, '2015-02-15 00:24:01.000000', 'temperatura', 1141.0000, 'ºC'),
	(52796, 108, '2015-02-15 00:24:02.000000', 'temperatura', 636.0000, 'ºC'),
	(52797, 108, '2015-02-15 00:24:03.000000', 'temperatura', 957.0000, 'ºC'),
	(52798, 108, '2015-02-15 00:24:04.000000', 'temperatura', 477.0000, 'ºC'),
	(52799, 108, '2015-02-15 00:24:05.000000', 'temperatura', 714.0000, 'ºC'),
	(52800, 108, '2015-02-15 00:24:06.000000', 'temperatura', 942.0000, 'ºC'),
	(52801, 108, '2015-02-15 00:24:07.000000', 'temperatura', 165.0000, 'ºC'),
	(52802, 108, '2015-02-15 00:24:08.000000', 'temperatura', 403.0000, 'ºC'),
	(52803, 108, '2015-02-15 00:24:09.000000', 'temperatura', 318.0000, 'ºC'),
	(52804, 108, '2015-02-15 00:24:10.000000', 'temperatura', 383.0000, 'ºC'),
	(52805, 108, '2015-02-15 00:24:11.000000', 'temperatura', 960.0000, 'ºC'),
	(52806, 108, '2015-02-15 00:24:12.000000', 'temperatura', 52.0000, 'ºC'),
	(52807, 108, '2015-02-15 00:24:13.000000', 'temperatura', 980.0000, 'ºC'),
	(52808, 108, '2015-02-15 00:24:14.000000', 'temperatura', 1145.0000, 'ºC'),
	(52809, 108, '2015-02-15 00:24:15.000000', 'temperatura', 384.0000, 'ºC'),
	(52810, 108, '2015-02-15 00:24:16.000000', 'temperatura', 886.0000, 'ºC'),
	(52811, 108, '2015-02-15 00:24:17.000000', 'temperatura', 881.0000, 'ºC'),
	(52812, 108, '2015-02-15 00:24:18.000000', 'temperatura', 545.0000, 'ºC'),
	(52813, 108, '2015-02-15 00:24:19.000000', 'temperatura', 82.0000, 'ºC'),
	(52814, 108, '2015-02-15 00:24:20.000000', 'temperatura', 1176.0000, 'ºC'),
	(52815, 108, '2015-02-15 00:24:21.000000', 'temperatura', 834.0000, 'ºC'),
	(52816, 108, '2015-02-15 00:24:22.000000', 'temperatura', 641.0000, 'ºC'),
	(52817, 108, '2015-02-15 00:24:23.000000', 'temperatura', 705.0000, 'ºC'),
	(52818, 108, '2015-02-15 00:24:24.000000', 'temperatura', 402.0000, 'ºC'),
	(52819, 108, '2015-02-15 00:24:25.000000', 'temperatura', 1095.0000, 'ºC'),
	(52820, 108, '2015-02-15 00:24:26.000000', 'temperatura', 670.0000, 'ºC'),
	(52821, 108, '2015-02-15 00:24:27.000000', 'temperatura', 65.0000, 'ºC'),
	(52822, 108, '2015-02-15 00:24:28.000000', 'temperatura', 714.0000, 'ºC'),
	(52823, 108, '2015-02-15 00:24:29.000000', 'temperatura', 977.0000, 'ºC'),
	(52824, 108, '2015-02-15 00:24:30.000000', 'temperatura', 344.0000, 'ºC'),
	(52825, 108, '2015-02-15 00:24:31.000000', 'temperatura', 1189.0000, 'ºC'),
	(52826, 108, '2015-02-15 00:24:32.000000', 'temperatura', 113.0000, 'ºC'),
	(52827, 108, '2015-02-15 00:24:33.000000', 'temperatura', 597.0000, 'ºC'),
	(52828, 108, '2015-02-15 00:24:34.000000', 'temperatura', 247.0000, 'ºC'),
	(52829, 108, '2015-02-15 00:24:35.000000', 'temperatura', 646.0000, 'ºC'),
	(52830, 108, '2015-02-15 00:24:36.000000', 'temperatura', 88.0000, 'ºC'),
	(52831, 108, '2015-02-15 00:24:37.000000', 'temperatura', 902.0000, 'ºC'),
	(52832, 108, '2015-02-15 00:24:38.000000', 'temperatura', 647.0000, 'ºC'),
	(52833, 108, '2015-02-15 00:24:39.000000', 'temperatura', 530.0000, 'ºC'),
	(52834, 108, '2015-02-15 00:24:40.000000', 'temperatura', 709.0000, 'ºC'),
	(52835, 108, '2015-02-15 00:24:41.000000', 'temperatura', 754.0000, 'ºC'),
	(52836, 108, '2015-02-15 00:24:42.000000', 'temperatura', 447.0000, 'ºC'),
	(52837, 108, '2015-02-15 00:24:43.000000', 'temperatura', 1170.0000, 'ºC'),
	(52838, 108, '2015-02-15 00:24:44.000000', 'temperatura', 912.0000, 'ºC'),
	(52839, 108, '2015-02-15 00:24:45.000000', 'temperatura', 1050.0000, 'ºC'),
	(52840, 108, '2015-02-15 00:24:46.000000', 'temperatura', 115.0000, 'ºC'),
	(52841, 108, '2015-02-15 00:24:47.000000', 'temperatura', 1026.0000, 'ºC'),
	(52842, 108, '2015-02-15 00:24:48.000000', 'temperatura', 1184.0000, 'ºC'),
	(52843, 108, '2015-02-15 00:24:49.000000', 'temperatura', 441.0000, 'ºC'),
	(52844, 108, '2015-02-15 00:24:50.000000', 'temperatura', 1055.0000, 'ºC'),
	(52845, 108, '2015-02-15 00:24:51.000000', 'temperatura', 350.0000, 'ºC'),
	(52846, 108, '2015-02-15 00:24:52.000000', 'temperatura', 989.0000, 'ºC'),
	(52847, 108, '2015-02-15 00:24:53.000000', 'temperatura', 294.0000, 'ºC'),
	(52848, 108, '2015-02-15 00:24:54.000000', 'temperatura', 905.0000, 'ºC'),
	(52849, 108, '2015-02-15 00:24:55.000000', 'temperatura', 44.0000, 'ºC'),
	(52850, 108, '2015-02-15 00:24:56.000000', 'temperatura', 1105.0000, 'ºC'),
	(52851, 108, '2015-02-15 00:24:57.000000', 'temperatura', 592.0000, 'ºC'),
	(52852, 108, '2015-02-15 00:24:58.000000', 'temperatura', 848.0000, 'ºC'),
	(52853, 108, '2015-02-15 00:24:59.000000', 'temperatura', 62.0000, 'ºC'),
	(52854, 108, '2015-02-15 00:25:00.000000', 'temperatura', 166.0000, 'ºC'),
	(52855, 108, '2015-02-15 00:25:01.000000', 'temperatura', 646.0000, 'ºC'),
	(52856, 108, '2015-02-15 00:25:02.000000', 'temperatura', 330.0000, 'ºC'),
	(52857, 108, '2015-02-15 00:25:03.000000', 'temperatura', 915.0000, 'ºC'),
	(52858, 108, '2015-02-15 00:25:04.000000', 'temperatura', 1184.0000, 'ºC'),
	(52859, 108, '2015-02-15 00:25:05.000000', 'temperatura', 774.0000, 'ºC'),
	(52860, 108, '2015-02-15 00:25:06.000000', 'temperatura', 320.0000, 'ºC'),
	(52861, 108, '2015-02-15 00:25:07.000000', 'temperatura', 479.0000, 'ºC'),
	(52862, 108, '2015-02-15 00:25:08.000000', 'temperatura', 234.0000, 'ºC'),
	(52863, 108, '2015-02-15 00:25:09.000000', 'temperatura', 936.0000, 'ºC'),
	(52864, 108, '2015-02-15 00:25:10.000000', 'temperatura', 376.0000, 'ºC'),
	(52865, 108, '2015-02-15 00:25:11.000000', 'temperatura', 275.0000, 'ºC'),
	(52866, 108, '2015-02-15 00:25:12.000000', 'temperatura', 246.0000, 'ºC'),
	(52867, 108, '2015-02-15 00:25:13.000000', 'temperatura', 404.0000, 'ºC'),
	(52868, 108, '2015-02-15 00:25:14.000000', 'temperatura', 85.0000, 'ºC'),
	(52869, 108, '2015-02-15 00:25:15.000000', 'temperatura', 412.0000, 'ºC'),
	(52870, 108, '2015-02-15 00:25:16.000000', 'temperatura', 604.0000, 'ºC'),
	(52871, 108, '2015-02-15 00:25:17.000000', 'temperatura', 587.0000, 'ºC'),
	(52872, 108, '2015-02-15 00:25:18.000000', 'temperatura', 1123.0000, 'ºC'),
	(52873, 108, '2015-02-15 00:25:19.000000', 'temperatura', 255.0000, 'ºC'),
	(52874, 108, '2015-02-15 00:25:20.000000', 'temperatura', 306.0000, 'ºC'),
	(52875, 108, '2015-02-15 00:25:21.000000', 'temperatura', 768.0000, 'ºC'),
	(52876, 108, '2015-02-15 00:25:22.000000', 'temperatura', 519.0000, 'ºC'),
	(52877, 108, '2015-02-15 00:25:23.000000', 'temperatura', 291.0000, 'ºC'),
	(52878, 108, '2015-02-15 00:25:24.000000', 'temperatura', 1102.0000, 'ºC'),
	(52879, 108, '2015-02-15 00:25:25.000000', 'temperatura', 1035.0000, 'ºC'),
	(52880, 108, '2015-02-15 00:25:26.000000', 'temperatura', 669.0000, 'ºC'),
	(52881, 108, '2015-02-15 00:25:27.000000', 'temperatura', 243.0000, 'ºC'),
	(52882, 108, '2015-02-15 00:25:28.000000', 'temperatura', 406.0000, 'ºC'),
	(52883, 108, '2015-02-15 00:25:29.000000', 'temperatura', 104.0000, 'ºC'),
	(52884, 108, '2015-02-15 00:25:30.000000', 'temperatura', 502.0000, 'ºC'),
	(52885, 108, '2015-02-15 00:25:31.000000', 'temperatura', 998.0000, 'ºC'),
	(52886, 108, '2015-02-15 00:25:32.000000', 'temperatura', 1083.0000, 'ºC'),
	(52887, 108, '2015-02-15 00:25:33.000000', 'temperatura', 21.0000, 'ºC'),
	(52888, 108, '2015-02-15 00:25:34.000000', 'temperatura', 457.0000, 'ºC'),
	(52889, 108, '2015-02-15 00:25:35.000000', 'temperatura', 1021.0000, 'ºC'),
	(52890, 108, '2015-02-15 00:25:36.000000', 'temperatura', 137.0000, 'ºC'),
	(52891, 108, '2015-02-15 00:25:37.000000', 'temperatura', 24.0000, 'ºC'),
	(52892, 108, '2015-02-15 00:25:38.000000', 'temperatura', 907.0000, 'ºC'),
	(52893, 108, '2015-02-15 00:25:39.000000', 'temperatura', 863.0000, 'ºC'),
	(52894, 108, '2015-02-15 00:25:40.000000', 'temperatura', 394.0000, 'ºC'),
	(52895, 108, '2015-02-15 00:25:41.000000', 'temperatura', 582.0000, 'ºC'),
	(52896, 108, '2015-02-15 00:25:42.000000', 'temperatura', 528.0000, 'ºC'),
	(52897, 108, '2015-02-15 00:25:43.000000', 'temperatura', 893.0000, 'ºC'),
	(52898, 108, '2015-02-15 00:25:44.000000', 'temperatura', 483.0000, 'ºC'),
	(52899, 108, '2015-02-15 00:25:45.000000', 'temperatura', 939.0000, 'ºC'),
	(52900, 108, '2015-02-15 00:25:46.000000', 'temperatura', 843.0000, 'ºC'),
	(52901, 108, '2015-02-15 00:25:47.000000', 'temperatura', 200.0000, 'ºC'),
	(52902, 108, '2015-02-15 00:25:48.000000', 'temperatura', 869.0000, 'ºC'),
	(52903, 108, '2015-02-15 00:25:49.000000', 'temperatura', 149.0000, 'ºC'),
	(52904, 108, '2015-02-15 00:25:50.000000', 'temperatura', 536.0000, 'ºC'),
	(52905, 108, '2015-02-15 00:25:51.000000', 'temperatura', 1035.0000, 'ºC'),
	(52906, 108, '2015-02-15 00:25:52.000000', 'temperatura', 1165.0000, 'ºC'),
	(52907, 108, '2015-02-15 00:25:53.000000', 'temperatura', 323.0000, 'ºC'),
	(52908, 108, '2015-02-15 00:25:54.000000', 'temperatura', 520.0000, 'ºC'),
	(52909, 108, '2015-02-15 00:25:55.000000', 'temperatura', 430.0000, 'ºC'),
	(52910, 108, '2015-02-15 00:25:56.000000', 'temperatura', 591.0000, 'ºC'),
	(52911, 108, '2015-02-15 00:25:57.000000', 'temperatura', 467.0000, 'ºC'),
	(52912, 108, '2015-02-15 00:25:58.000000', 'temperatura', 561.0000, 'ºC'),
	(52913, 108, '2015-02-15 00:25:59.000000', 'temperatura', 205.0000, 'ºC'),
	(52914, 108, '2015-02-15 00:26:00.000000', 'temperatura', 541.0000, 'ºC'),
	(52915, 108, '2015-02-15 00:26:01.000000', 'temperatura', 890.0000, 'ºC'),
	(52916, 108, '2015-02-15 00:26:02.000000', 'temperatura', 430.0000, 'ºC'),
	(52917, 108, '2015-02-15 00:26:03.000000', 'temperatura', 678.0000, 'ºC'),
	(52918, 108, '2015-02-15 00:26:04.000000', 'temperatura', 903.0000, 'ºC'),
	(52919, 108, '2015-02-15 00:26:05.000000', 'temperatura', 81.0000, 'ºC'),
	(52920, 108, '2015-02-15 00:26:06.000000', 'temperatura', 95.0000, 'ºC'),
	(52921, 108, '2015-02-15 00:26:07.000000', 'temperatura', 233.0000, 'ºC'),
	(52922, 108, '2015-02-15 00:26:08.000000', 'temperatura', 880.0000, 'ºC'),
	(52923, 108, '2015-02-15 00:26:09.000000', 'temperatura', 100.0000, 'ºC'),
	(52924, 108, '2015-02-15 00:26:10.000000', 'temperatura', 262.0000, 'ºC'),
	(52925, 108, '2015-02-15 00:26:11.000000', 'temperatura', 1012.0000, 'ºC'),
	(52926, 108, '2015-02-15 00:26:12.000000', 'temperatura', 673.0000, 'ºC'),
	(52927, 108, '2015-02-15 00:26:13.000000', 'temperatura', 330.0000, 'ºC'),
	(52928, 108, '2015-02-15 00:26:14.000000', 'temperatura', 833.0000, 'ºC'),
	(52929, 108, '2015-02-15 00:26:15.000000', 'temperatura', 773.0000, 'ºC'),
	(52930, 108, '2015-02-15 00:26:16.000000', 'temperatura', 165.0000, 'ºC'),
	(52931, 108, '2015-02-15 00:26:17.000000', 'temperatura', 910.0000, 'ºC'),
	(52932, 108, '2015-02-15 00:26:18.000000', 'temperatura', 452.0000, 'ºC'),
	(52933, 108, '2015-02-15 00:26:19.000000', 'temperatura', 733.0000, 'ºC'),
	(52934, 108, '2015-02-15 00:26:20.000000', 'temperatura', 1107.0000, 'ºC'),
	(52935, 108, '2015-02-15 00:26:21.000000', 'temperatura', 937.0000, 'ºC'),
	(52936, 108, '2015-02-15 00:26:22.000000', 'temperatura', 166.0000, 'ºC'),
	(52937, 108, '2015-02-15 00:26:23.000000', 'temperatura', 418.0000, 'ºC'),
	(52938, 108, '2015-02-15 00:26:24.000000', 'temperatura', 395.0000, 'ºC'),
	(52939, 108, '2015-02-15 00:26:25.000000', 'temperatura', 720.0000, 'ºC'),
	(52940, 108, '2015-02-15 00:26:26.000000', 'temperatura', 15.0000, 'ºC'),
	(52941, 108, '2015-02-15 00:26:27.000000', 'temperatura', 318.0000, 'ºC'),
	(52942, 108, '2015-02-15 00:26:28.000000', 'temperatura', 342.0000, 'ºC'),
	(52943, 108, '2015-02-15 00:26:29.000000', 'temperatura', 759.0000, 'ºC'),
	(52944, 108, '2015-02-15 00:26:30.000000', 'temperatura', 369.0000, 'ºC'),
	(52945, 108, '2015-02-15 00:26:31.000000', 'temperatura', 770.0000, 'ºC'),
	(52946, 108, '2015-02-15 00:26:32.000000', 'temperatura', 344.0000, 'ºC'),
	(52947, 108, '2015-02-15 00:26:33.000000', 'temperatura', 608.0000, 'ºC'),
	(52948, 108, '2015-02-15 00:26:34.000000', 'temperatura', 809.0000, 'ºC'),
	(52949, 108, '2015-02-15 00:26:35.000000', 'temperatura', 1021.0000, 'ºC'),
	(52950, 108, '2015-02-15 00:26:36.000000', 'temperatura', 279.0000, 'ºC'),
	(52951, 108, '2015-02-15 00:26:37.000000', 'temperatura', 733.0000, 'ºC'),
	(52952, 108, '2015-02-15 00:26:38.000000', 'temperatura', 430.0000, 'ºC'),
	(52953, 108, '2015-02-15 00:26:39.000000', 'temperatura', 1150.0000, 'ºC'),
	(52954, 108, '2015-02-15 00:26:40.000000', 'temperatura', 860.0000, 'ºC'),
	(52955, 108, '2015-02-15 00:26:41.000000', 'temperatura', 851.0000, 'ºC'),
	(52956, 108, '2015-02-15 00:26:42.000000', 'temperatura', 474.0000, 'ºC'),
	(52957, 108, '2015-02-15 00:26:43.000000', 'temperatura', 1018.0000, 'ºC'),
	(52958, 108, '2015-02-15 00:26:44.000000', 'temperatura', 70.0000, 'ºC'),
	(52959, 108, '2015-02-15 00:26:45.000000', 'temperatura', 896.0000, 'ºC'),
	(52960, 108, '2015-02-15 00:26:46.000000', 'temperatura', 671.0000, 'ºC'),
	(52961, 108, '2015-02-15 00:26:47.000000', 'temperatura', 666.0000, 'ºC'),
	(52962, 108, '2015-02-15 00:26:48.000000', 'temperatura', 116.0000, 'ºC'),
	(52963, 108, '2015-02-15 00:26:49.000000', 'temperatura', 985.0000, 'ºC'),
	(52964, 108, '2015-02-15 00:26:50.000000', 'temperatura', 975.0000, 'ºC'),
	(52965, 108, '2015-02-15 00:26:51.000000', 'temperatura', 721.0000, 'ºC'),
	(52966, 108, '2015-02-15 00:26:52.000000', 'temperatura', 679.0000, 'ºC'),
	(52967, 108, '2015-02-15 00:26:53.000000', 'temperatura', 35.0000, 'ºC'),
	(52968, 108, '2015-02-15 00:26:54.000000', 'temperatura', 536.0000, 'ºC'),
	(52969, 108, '2015-02-15 00:26:55.000000', 'temperatura', 176.0000, 'ºC'),
	(52970, 108, '2015-02-15 00:26:56.000000', 'temperatura', 474.0000, 'ºC'),
	(52971, 108, '2015-02-15 00:26:57.000000', 'temperatura', 643.0000, 'ºC'),
	(52972, 108, '2015-02-15 00:26:58.000000', 'temperatura', 591.0000, 'ºC'),
	(52973, 108, '2015-02-15 00:26:59.000000', 'temperatura', 1030.0000, 'ºC'),
	(52974, 108, '2015-02-15 00:27:00.000000', 'temperatura', 975.0000, 'ºC'),
	(52975, 108, '2015-02-15 00:27:01.000000', 'temperatura', 585.0000, 'ºC'),
	(52976, 108, '2015-02-15 00:27:02.000000', 'temperatura', 2.0000, 'ºC'),
	(52977, 108, '2015-02-15 00:27:03.000000', 'temperatura', 657.0000, 'ºC'),
	(52978, 108, '2015-02-15 00:27:04.000000', 'temperatura', 878.0000, 'ºC'),
	(52979, 108, '2015-02-15 00:27:05.000000', 'temperatura', 20.0000, 'ºC'),
	(52980, 108, '2015-02-15 00:27:06.000000', 'temperatura', 1068.0000, 'ºC'),
	(52981, 108, '2015-02-15 00:27:07.000000', 'temperatura', 479.0000, 'ºC'),
	(52982, 108, '2015-02-15 00:27:08.000000', 'temperatura', 394.0000, 'ºC'),
	(52983, 108, '2015-02-15 00:27:09.000000', 'temperatura', 530.0000, 'ºC'),
	(52984, 108, '2015-02-15 00:27:10.000000', 'temperatura', 272.0000, 'ºC'),
	(52985, 108, '2015-02-15 00:27:11.000000', 'temperatura', 968.0000, 'ºC'),
	(52986, 108, '2015-02-15 00:27:12.000000', 'temperatura', 426.0000, 'ºC'),
	(52987, 108, '2015-02-15 00:27:13.000000', 'temperatura', 426.0000, 'ºC'),
	(52988, 108, '2015-02-15 00:27:14.000000', 'temperatura', 851.0000, 'ºC'),
	(52989, 108, '2015-02-15 00:27:15.000000', 'temperatura', 580.0000, 'ºC'),
	(52990, 108, '2015-02-15 00:27:16.000000', 'temperatura', 347.0000, 'ºC'),
	(52991, 108, '2015-02-15 00:27:17.000000', 'temperatura', 1193.0000, 'ºC'),
	(52992, 108, '2015-02-15 00:27:18.000000', 'temperatura', 127.0000, 'ºC'),
	(52993, 108, '2015-02-15 00:27:19.000000', 'temperatura', 658.0000, 'ºC'),
	(52994, 108, '2015-02-15 00:27:20.000000', 'temperatura', 507.0000, 'ºC'),
	(52995, 108, '2015-02-15 00:27:21.000000', 'temperatura', 563.0000, 'ºC'),
	(52996, 108, '2015-02-15 00:27:22.000000', 'temperatura', 96.0000, 'ºC'),
	(52997, 108, '2015-02-15 00:27:23.000000', 'temperatura', 1189.0000, 'ºC'),
	(52998, 108, '2015-02-15 00:27:24.000000', 'temperatura', 860.0000, 'ºC'),
	(52999, 108, '2015-02-15 00:27:25.000000', 'temperatura', 731.0000, 'ºC'),
	(53000, 108, '2015-02-15 00:27:26.000000', 'temperatura', 1075.0000, 'ºC'),
	(53001, 108, '2015-02-15 00:27:27.000000', 'temperatura', 783.0000, 'ºC'),
	(53002, 108, '2015-02-15 00:27:28.000000', 'temperatura', 693.0000, 'ºC'),
	(53003, 108, '2015-02-15 00:27:29.000000', 'temperatura', 1115.0000, 'ºC'),
	(53004, 108, '2015-02-15 00:27:30.000000', 'temperatura', 1095.0000, 'ºC'),
	(53005, 108, '2015-02-15 00:27:31.000000', 'temperatura', 933.0000, 'ºC'),
	(53006, 108, '2015-02-15 00:27:32.000000', 'temperatura', 177.0000, 'ºC'),
	(53007, 108, '2015-02-15 00:27:33.000000', 'temperatura', 490.0000, 'ºC'),
	(53008, 108, '2015-02-15 00:27:34.000000', 'temperatura', 718.0000, 'ºC'),
	(53009, 108, '2015-02-15 00:27:35.000000', 'temperatura', 922.0000, 'ºC'),
	(53010, 108, '2015-02-15 00:27:36.000000', 'temperatura', 56.0000, 'ºC'),
	(53011, 108, '2015-02-15 00:27:37.000000', 'temperatura', 1114.0000, 'ºC'),
	(53012, 108, '2015-02-15 00:27:38.000000', 'temperatura', 602.0000, 'ºC'),
	(53013, 108, '2015-02-15 00:27:39.000000', 'temperatura', 868.0000, 'ºC'),
	(53014, 108, '2015-02-15 00:27:40.000000', 'temperatura', 135.0000, 'ºC'),
	(53015, 108, '2015-02-15 00:27:41.000000', 'temperatura', 471.0000, 'ºC'),
	(53016, 108, '2015-02-15 00:27:42.000000', 'temperatura', 752.0000, 'ºC'),
	(53017, 108, '2015-02-15 00:27:43.000000', 'temperatura', 1146.0000, 'ºC'),
	(53018, 108, '2015-02-15 00:27:44.000000', 'temperatura', 1075.0000, 'ºC'),
	(53019, 108, '2015-02-15 00:27:45.000000', 'temperatura', 739.0000, 'ºC'),
	(53020, 108, '2015-02-15 00:27:46.000000', 'temperatura', 469.0000, 'ºC'),
	(53021, 108, '2015-02-15 00:27:47.000000', 'temperatura', 129.0000, 'ºC'),
	(53022, 108, '2015-02-15 00:27:48.000000', 'temperatura', 439.0000, 'ºC'),
	(53023, 108, '2015-02-15 00:27:49.000000', 'temperatura', 607.0000, 'ºC'),
	(53024, 108, '2015-02-15 00:27:50.000000', 'temperatura', 519.0000, 'ºC'),
	(53025, 108, '2015-02-15 00:27:51.000000', 'temperatura', 774.0000, 'ºC'),
	(53026, 108, '2015-02-15 00:27:52.000000', 'temperatura', 1112.0000, 'ºC'),
	(53027, 108, '2015-02-15 00:27:53.000000', 'temperatura', 841.0000, 'ºC'),
	(53028, 108, '2015-02-15 00:27:54.000000', 'temperatura', 867.0000, 'ºC'),
	(53029, 108, '2015-02-15 00:27:55.000000', 'temperatura', 613.0000, 'ºC'),
	(53030, 108, '2015-02-15 00:27:56.000000', 'temperatura', 464.0000, 'ºC'),
	(53031, 108, '2015-02-15 00:27:57.000000', 'temperatura', 481.0000, 'ºC'),
	(53032, 108, '2015-02-15 00:27:58.000000', 'temperatura', 1015.0000, 'ºC'),
	(53033, 108, '2015-02-15 00:27:59.000000', 'temperatura', 31.0000, 'ºC'),
	(53034, 108, '2015-02-15 00:28:00.000000', 'temperatura', 711.0000, 'ºC'),
	(53035, 108, '2015-02-15 00:28:01.000000', 'temperatura', 1061.0000, 'ºC'),
	(53036, 108, '2015-02-15 00:28:02.000000', 'temperatura', 772.0000, 'ºC'),
	(53037, 108, '2015-02-15 00:28:03.000000', 'temperatura', 679.0000, 'ºC'),
	(53038, 108, '2015-02-15 00:28:04.000000', 'temperatura', 1081.0000, 'ºC'),
	(53039, 108, '2015-02-15 00:28:05.000000', 'temperatura', 968.0000, 'ºC'),
	(53040, 108, '2015-02-15 00:28:06.000000', 'temperatura', 396.0000, 'ºC'),
	(53041, 108, '2015-02-15 00:28:07.000000', 'temperatura', 279.0000, 'ºC'),
	(53042, 108, '2015-02-15 00:28:08.000000', 'temperatura', 206.0000, 'ºC'),
	(53043, 108, '2015-02-15 00:28:09.000000', 'temperatura', 193.0000, 'ºC'),
	(53044, 108, '2015-02-15 00:28:10.000000', 'temperatura', 348.0000, 'ºC'),
	(53045, 108, '2015-02-15 00:28:11.000000', 'temperatura', 1161.0000, 'ºC'),
	(53046, 108, '2015-02-15 00:28:12.000000', 'temperatura', 1160.0000, 'ºC'),
	(53047, 108, '2015-02-15 00:28:13.000000', 'temperatura', 1121.0000, 'ºC'),
	(53048, 108, '2015-02-15 00:28:14.000000', 'temperatura', 923.0000, 'ºC'),
	(53049, 108, '2015-02-15 00:28:15.000000', 'temperatura', 55.0000, 'ºC'),
	(53050, 108, '2015-02-15 00:28:16.000000', 'temperatura', 1104.0000, 'ºC'),
	(53051, 108, '2015-02-15 00:28:17.000000', 'temperatura', 558.0000, 'ºC'),
	(53052, 108, '2015-02-15 00:28:18.000000', 'temperatura', 677.0000, 'ºC'),
	(53053, 108, '2015-02-15 00:28:19.000000', 'temperatura', 512.0000, 'ºC'),
	(53054, 108, '2015-02-15 00:28:20.000000', 'temperatura', 531.0000, 'ºC'),
	(53055, 108, '2015-02-15 00:28:21.000000', 'temperatura', 1117.0000, 'ºC'),
	(53056, 108, '2015-02-15 00:28:22.000000', 'temperatura', 391.0000, 'ºC'),
	(53057, 108, '2015-02-15 00:28:23.000000', 'temperatura', 1008.0000, 'ºC'),
	(53058, 108, '2015-02-15 00:28:24.000000', 'temperatura', 265.0000, 'ºC'),
	(53059, 108, '2015-02-15 00:28:25.000000', 'temperatura', 703.0000, 'ºC'),
	(53060, 108, '2015-02-15 00:28:26.000000', 'temperatura', 322.0000, 'ºC'),
	(53061, 108, '2015-02-15 00:28:27.000000', 'temperatura', 699.0000, 'ºC'),
	(53062, 108, '2015-02-15 00:28:28.000000', 'temperatura', 130.0000, 'ºC'),
	(53063, 108, '2015-02-15 00:28:29.000000', 'temperatura', 954.0000, 'ºC'),
	(53064, 108, '2015-02-15 00:28:30.000000', 'temperatura', 780.0000, 'ºC'),
	(53065, 108, '2015-02-15 00:28:31.000000', 'temperatura', 1039.0000, 'ºC'),
	(53066, 108, '2015-02-15 00:28:32.000000', 'temperatura', 454.0000, 'ºC'),
	(53067, 108, '2015-02-15 00:28:33.000000', 'temperatura', 353.0000, 'ºC'),
	(53068, 108, '2015-02-15 00:28:34.000000', 'temperatura', 404.0000, 'ºC'),
	(53069, 108, '2015-02-15 00:28:35.000000', 'temperatura', 961.0000, 'ºC'),
	(53070, 108, '2015-02-15 00:28:36.000000', 'temperatura', 1193.0000, 'ºC'),
	(53071, 108, '2015-02-15 00:28:37.000000', 'temperatura', 684.0000, 'ºC'),
	(53072, 108, '2015-02-15 00:28:38.000000', 'temperatura', 1040.0000, 'ºC'),
	(53073, 108, '2015-02-15 00:28:39.000000', 'temperatura', 748.0000, 'ºC'),
	(53074, 108, '2015-02-15 00:28:40.000000', 'temperatura', 621.0000, 'ºC'),
	(53075, 108, '2015-02-15 00:28:41.000000', 'temperatura', 861.0000, 'ºC'),
	(53076, 108, '2015-02-15 00:28:42.000000', 'temperatura', 42.0000, 'ºC'),
	(53077, 108, '2015-02-15 00:28:43.000000', 'temperatura', 26.0000, 'ºC'),
	(53078, 108, '2015-02-15 00:28:44.000000', 'temperatura', 7.0000, 'ºC'),
	(53079, 108, '2015-02-15 00:28:45.000000', 'temperatura', 1155.0000, 'ºC'),
	(53080, 108, '2015-02-15 00:28:46.000000', 'temperatura', 957.0000, 'ºC'),
	(53081, 108, '2015-02-15 00:28:47.000000', 'temperatura', 119.0000, 'ºC'),
	(53082, 108, '2015-02-15 00:28:48.000000', 'temperatura', 123.0000, 'ºC'),
	(53083, 108, '2015-02-15 00:28:49.000000', 'temperatura', 259.0000, 'ºC'),
	(53084, 108, '2015-02-15 00:28:50.000000', 'temperatura', 927.0000, 'ºC'),
	(53085, 108, '2015-02-15 00:28:51.000000', 'temperatura', 261.0000, 'ºC'),
	(53086, 108, '2015-02-15 00:28:52.000000', 'temperatura', 921.0000, 'ºC'),
	(53087, 108, '2015-02-15 00:28:53.000000', 'temperatura', 226.0000, 'ºC'),
	(53088, 108, '2015-02-15 00:28:54.000000', 'temperatura', 764.0000, 'ºC'),
	(53089, 108, '2015-02-15 00:28:55.000000', 'temperatura', 745.0000, 'ºC'),
	(53090, 108, '2015-02-15 00:28:56.000000', 'temperatura', 231.0000, 'ºC'),
	(53091, 108, '2015-02-15 00:28:57.000000', 'temperatura', 122.0000, 'ºC'),
	(53092, 108, '2015-02-15 00:28:58.000000', 'temperatura', 1116.0000, 'ºC'),
	(53093, 108, '2015-02-15 00:28:59.000000', 'temperatura', 415.0000, 'ºC'),
	(53094, 108, '2015-02-15 00:29:00.000000', 'temperatura', 1128.0000, 'ºC'),
	(53095, 108, '2015-02-15 00:29:01.000000', 'temperatura', 794.0000, 'ºC'),
	(53096, 108, '2015-02-15 00:29:02.000000', 'temperatura', 588.0000, 'ºC'),
	(53097, 108, '2015-02-15 00:29:03.000000', 'temperatura', 560.0000, 'ºC'),
	(53098, 108, '2015-02-15 00:29:04.000000', 'temperatura', 1034.0000, 'ºC'),
	(53099, 108, '2015-02-15 00:29:05.000000', 'temperatura', 1090.0000, 'ºC'),
	(53100, 108, '2015-02-15 00:29:06.000000', 'temperatura', 1150.0000, 'ºC'),
	(53101, 108, '2015-02-15 00:29:07.000000', 'temperatura', 81.0000, 'ºC'),
	(53102, 108, '2015-02-15 00:29:08.000000', 'temperatura', 556.0000, 'ºC'),
	(53103, 108, '2015-02-15 00:29:09.000000', 'temperatura', 137.0000, 'ºC'),
	(53104, 108, '2015-02-15 00:29:10.000000', 'temperatura', 217.0000, 'ºC'),
	(53105, 108, '2015-02-15 00:29:11.000000', 'temperatura', 676.0000, 'ºC'),
	(53106, 108, '2015-02-15 00:29:12.000000', 'temperatura', 327.0000, 'ºC'),
	(53107, 108, '2015-02-15 00:29:13.000000', 'temperatura', 807.0000, 'ºC'),
	(53108, 108, '2015-02-15 00:29:14.000000', 'temperatura', 654.0000, 'ºC'),
	(53109, 108, '2015-02-15 00:29:15.000000', 'temperatura', 852.0000, 'ºC'),
	(53110, 108, '2015-02-15 00:29:16.000000', 'temperatura', 1098.0000, 'ºC'),
	(53111, 108, '2015-02-15 00:29:17.000000', 'temperatura', 536.0000, 'ºC'),
	(53112, 108, '2015-02-15 00:29:18.000000', 'temperatura', 585.0000, 'ºC'),
	(53113, 108, '2015-02-15 00:29:19.000000', 'temperatura', 117.0000, 'ºC'),
	(53114, 108, '2015-02-15 00:29:20.000000', 'temperatura', 30.0000, 'ºC'),
	(53115, 108, '2015-02-15 00:29:21.000000', 'temperatura', 1002.0000, 'ºC'),
	(53116, 108, '2015-02-15 00:29:22.000000', 'temperatura', 120.0000, 'ºC'),
	(53117, 108, '2015-02-15 00:29:23.000000', 'temperatura', 1194.0000, 'ºC'),
	(53118, 108, '2015-02-15 00:29:24.000000', 'temperatura', 812.0000, 'ºC'),
	(53119, 108, '2015-02-15 00:29:25.000000', 'temperatura', 479.0000, 'ºC'),
	(53120, 108, '2015-02-15 00:29:26.000000', 'temperatura', 1160.0000, 'ºC'),
	(53121, 108, '2015-02-15 00:29:27.000000', 'temperatura', 764.0000, 'ºC'),
	(53122, 108, '2015-02-15 00:29:28.000000', 'temperatura', 341.0000, 'ºC'),
	(53123, 108, '2015-02-15 00:29:29.000000', 'temperatura', 612.0000, 'ºC'),
	(53124, 108, '2015-02-15 00:29:30.000000', 'temperatura', 840.0000, 'ºC'),
	(53125, 108, '2015-02-15 00:29:31.000000', 'temperatura', 1162.0000, 'ºC'),
	(53126, 108, '2015-02-15 00:29:32.000000', 'temperatura', 891.0000, 'ºC'),
	(53127, 108, '2015-02-15 00:29:33.000000', 'temperatura', 969.0000, 'ºC'),
	(53128, 108, '2015-02-15 00:29:34.000000', 'temperatura', 973.0000, 'ºC'),
	(53129, 108, '2015-02-15 00:29:35.000000', 'temperatura', 759.0000, 'ºC'),
	(53130, 108, '2015-02-15 00:29:36.000000', 'temperatura', 876.0000, 'ºC'),
	(53131, 108, '2015-02-15 00:29:37.000000', 'temperatura', 905.0000, 'ºC'),
	(53132, 108, '2015-02-15 00:29:38.000000', 'temperatura', 695.0000, 'ºC'),
	(53133, 108, '2015-02-15 00:29:39.000000', 'temperatura', 761.0000, 'ºC'),
	(53134, 108, '2015-02-15 00:29:40.000000', 'temperatura', 519.0000, 'ºC'),
	(53135, 108, '2015-02-15 00:29:41.000000', 'temperatura', 313.0000, 'ºC'),
	(53136, 108, '2015-02-15 00:29:42.000000', 'temperatura', 10.0000, 'ºC'),
	(53137, 108, '2015-02-15 00:29:43.000000', 'temperatura', 311.0000, 'ºC'),
	(53138, 108, '2015-02-15 00:29:44.000000', 'temperatura', 323.0000, 'ºC'),
	(53139, 108, '2015-02-15 00:29:45.000000', 'temperatura', 685.0000, 'ºC'),
	(53140, 108, '2015-02-15 00:29:46.000000', 'temperatura', 58.0000, 'ºC'),
	(53141, 108, '2015-02-15 00:29:47.000000', 'temperatura', 633.0000, 'ºC'),
	(53142, 108, '2015-02-15 00:29:48.000000', 'temperatura', 592.0000, 'ºC'),
	(53143, 108, '2015-02-15 00:29:49.000000', 'temperatura', 1061.0000, 'ºC'),
	(53144, 108, '2015-02-15 00:29:50.000000', 'temperatura', 1130.0000, 'ºC'),
	(53145, 108, '2015-02-15 00:29:51.000000', 'temperatura', 66.0000, 'ºC'),
	(53146, 108, '2015-02-15 00:29:52.000000', 'temperatura', 541.0000, 'ºC'),
	(53147, 108, '2015-02-15 00:29:53.000000', 'temperatura', 107.0000, 'ºC'),
	(53148, 108, '2015-02-15 00:29:54.000000', 'temperatura', 114.0000, 'ºC'),
	(53149, 108, '2015-02-15 00:29:55.000000', 'temperatura', 248.0000, 'ºC'),
	(53150, 108, '2015-02-15 00:29:56.000000', 'temperatura', 898.0000, 'ºC'),
	(53151, 108, '2015-02-15 00:29:57.000000', 'temperatura', 149.0000, 'ºC'),
	(53152, 108, '2015-02-15 00:29:58.000000', 'temperatura', 451.0000, 'ºC'),
	(53153, 108, '2015-02-15 00:29:59.000000', 'temperatura', 609.0000, 'ºC'),
	(53154, 108, '2015-02-15 00:30:00.000000', 'temperatura', 491.0000, 'ºC'),
	(53155, 108, '2015-02-15 00:30:01.000000', 'temperatura', 627.0000, 'ºC'),
	(53156, 108, '2015-02-15 00:30:02.000000', 'temperatura', 466.0000, 'ºC'),
	(53157, 108, '2015-02-15 00:30:03.000000', 'temperatura', 447.0000, 'ºC'),
	(53158, 108, '2015-02-15 00:30:04.000000', 'temperatura', 837.0000, 'ºC'),
	(53159, 108, '2015-02-15 00:30:05.000000', 'temperatura', 443.0000, 'ºC'),
	(53160, 108, '2015-02-15 00:30:06.000000', 'temperatura', 907.0000, 'ºC'),
	(53161, 108, '2015-02-15 00:30:07.000000', 'temperatura', 807.0000, 'ºC'),
	(53162, 108, '2015-02-15 00:30:08.000000', 'temperatura', 113.0000, 'ºC'),
	(53163, 108, '2015-02-15 00:30:09.000000', 'temperatura', 544.0000, 'ºC'),
	(53164, 108, '2015-02-15 00:30:10.000000', 'temperatura', 1181.0000, 'ºC'),
	(53165, 108, '2015-02-15 00:30:11.000000', 'temperatura', 674.0000, 'ºC'),
	(53166, 108, '2015-02-15 00:30:12.000000', 'temperatura', 1030.0000, 'ºC'),
	(53167, 108, '2015-02-15 00:30:13.000000', 'temperatura', 726.0000, 'ºC'),
	(53168, 108, '2015-02-15 00:30:14.000000', 'temperatura', 539.0000, 'ºC'),
	(53169, 108, '2015-02-15 00:30:15.000000', 'temperatura', 521.0000, 'ºC'),
	(53170, 108, '2015-02-15 00:30:16.000000', 'temperatura', 988.0000, 'ºC'),
	(53171, 108, '2015-02-15 00:30:17.000000', 'temperatura', 975.0000, 'ºC'),
	(53172, 108, '2015-02-15 00:30:18.000000', 'temperatura', 714.0000, 'ºC'),
	(53173, 108, '2015-02-15 00:30:19.000000', 'temperatura', 645.0000, 'ºC'),
	(53174, 108, '2015-02-15 00:30:20.000000', 'temperatura', 1082.0000, 'ºC'),
	(53175, 108, '2015-02-15 00:30:21.000000', 'temperatura', 1076.0000, 'ºC'),
	(53176, 108, '2015-02-15 00:30:22.000000', 'temperatura', 935.0000, 'ºC'),
	(53177, 108, '2015-02-15 00:30:23.000000', 'temperatura', 248.0000, 'ºC'),
	(53178, 108, '2015-02-15 00:30:24.000000', 'temperatura', 837.0000, 'ºC'),
	(53179, 108, '2015-02-15 00:30:25.000000', 'temperatura', 1041.0000, 'ºC'),
	(53180, 108, '2015-02-15 00:30:26.000000', 'temperatura', 292.0000, 'ºC'),
	(53181, 108, '2015-02-15 00:30:27.000000', 'temperatura', 740.0000, 'ºC'),
	(53182, 108, '2015-02-15 00:30:28.000000', 'temperatura', 425.0000, 'ºC'),
	(53183, 108, '2015-02-15 00:30:29.000000', 'temperatura', 1103.0000, 'ºC'),
	(53184, 108, '2015-02-15 00:30:30.000000', 'temperatura', 643.0000, 'ºC'),
	(53185, 108, '2015-02-15 00:30:31.000000', 'temperatura', 1104.0000, 'ºC'),
	(53186, 108, '2015-02-15 00:30:32.000000', 'temperatura', 1194.0000, 'ºC'),
	(53187, 108, '2015-02-15 00:30:33.000000', 'temperatura', 257.0000, 'ºC'),
	(53188, 108, '2015-02-15 00:30:34.000000', 'temperatura', 105.0000, 'ºC'),
	(53189, 108, '2015-02-15 00:30:35.000000', 'temperatura', 956.0000, 'ºC'),
	(53190, 108, '2015-02-15 00:30:36.000000', 'temperatura', 863.0000, 'ºC'),
	(53191, 108, '2015-02-15 00:30:37.000000', 'temperatura', 249.0000, 'ºC'),
	(53192, 108, '2015-02-15 00:30:38.000000', 'temperatura', 1056.0000, 'ºC'),
	(53193, 108, '2015-02-15 00:30:39.000000', 'temperatura', 935.0000, 'ºC'),
	(53194, 108, '2015-02-15 00:30:40.000000', 'temperatura', 305.0000, 'ºC'),
	(53195, 108, '2015-02-15 00:30:41.000000', 'temperatura', 1122.0000, 'ºC'),
	(53196, 108, '2015-02-15 00:30:42.000000', 'temperatura', 1093.0000, 'ºC'),
	(53197, 108, '2015-02-15 00:30:43.000000', 'temperatura', 902.0000, 'ºC'),
	(53198, 108, '2015-02-15 00:30:44.000000', 'temperatura', 32.0000, 'ºC'),
	(53199, 108, '2015-02-15 00:30:45.000000', 'temperatura', 1052.0000, 'ºC'),
	(53200, 108, '2015-02-15 00:30:46.000000', 'temperatura', 365.0000, 'ºC'),
	(53201, 108, '2015-02-15 00:30:47.000000', 'temperatura', 1069.0000, 'ºC'),
	(53202, 108, '2015-02-15 00:30:48.000000', 'temperatura', 649.0000, 'ºC'),
	(53203, 108, '2015-02-15 00:30:49.000000', 'temperatura', 42.0000, 'ºC'),
	(53204, 108, '2015-02-15 00:30:50.000000', 'temperatura', 663.0000, 'ºC'),
	(53205, 108, '2015-02-15 00:30:51.000000', 'temperatura', 787.0000, 'ºC'),
	(53206, 108, '2015-02-15 00:30:52.000000', 'temperatura', 749.0000, 'ºC'),
	(53207, 108, '2015-02-15 00:30:53.000000', 'temperatura', 184.0000, 'ºC'),
	(53208, 108, '2015-02-15 00:30:54.000000', 'temperatura', 1075.0000, 'ºC'),
	(53209, 108, '2015-02-15 00:30:55.000000', 'temperatura', 21.0000, 'ºC'),
	(53210, 108, '2015-02-15 00:30:56.000000', 'temperatura', 480.0000, 'ºC'),
	(53211, 108, '2015-02-15 00:30:57.000000', 'temperatura', 1139.0000, 'ºC'),
	(53212, 108, '2015-02-15 00:30:58.000000', 'temperatura', 654.0000, 'ºC'),
	(53213, 108, '2015-02-15 00:30:59.000000', 'temperatura', 1053.0000, 'ºC'),
	(53214, 108, '2015-02-15 00:31:00.000000', 'temperatura', 905.0000, 'ºC'),
	(53215, 108, '2015-02-15 00:31:01.000000', 'temperatura', 168.0000, 'ºC'),
	(53216, 108, '2015-02-15 00:31:02.000000', 'temperatura', 525.0000, 'ºC'),
	(53217, 108, '2015-02-15 00:31:03.000000', 'temperatura', 921.0000, 'ºC'),
	(53218, 108, '2015-02-15 00:31:04.000000', 'temperatura', 631.0000, 'ºC'),
	(53219, 108, '2015-02-15 00:31:05.000000', 'temperatura', 394.0000, 'ºC'),
	(53220, 108, '2015-02-15 00:31:06.000000', 'temperatura', 77.0000, 'ºC'),
	(53221, 108, '2015-02-15 00:31:07.000000', 'temperatura', 402.0000, 'ºC'),
	(53222, 108, '2015-02-15 00:31:08.000000', 'temperatura', 579.0000, 'ºC'),
	(53223, 108, '2015-02-15 00:31:09.000000', 'temperatura', 488.0000, 'ºC'),
	(53224, 108, '2015-02-15 00:31:10.000000', 'temperatura', 706.0000, 'ºC'),
	(53225, 108, '2015-02-15 00:31:11.000000', 'temperatura', 865.0000, 'ºC'),
	(53226, 108, '2015-02-15 00:31:12.000000', 'temperatura', 1009.0000, 'ºC'),
	(53227, 108, '2015-02-15 00:31:13.000000', 'temperatura', 51.0000, 'ºC'),
	(53228, 108, '2015-02-15 00:31:14.000000', 'temperatura', 830.0000, 'ºC'),
	(53229, 108, '2015-02-15 00:31:15.000000', 'temperatura', 394.0000, 'ºC'),
	(53230, 108, '2015-02-15 00:31:16.000000', 'temperatura', 682.0000, 'ºC'),
	(53231, 108, '2015-02-15 00:31:17.000000', 'temperatura', 1030.0000, 'ºC'),
	(53232, 108, '2015-02-15 00:31:18.000000', 'temperatura', 702.0000, 'ºC'),
	(53233, 108, '2015-02-15 00:31:19.000000', 'temperatura', 422.0000, 'ºC'),
	(53234, 108, '2015-02-15 00:31:20.000000', 'temperatura', 6.0000, 'ºC'),
	(53235, 108, '2015-02-15 00:31:21.000000', 'temperatura', 1161.0000, 'ºC'),
	(53236, 108, '2015-02-15 00:31:22.000000', 'temperatura', 991.0000, 'ºC'),
	(53237, 108, '2015-02-15 00:31:23.000000', 'temperatura', 270.0000, 'ºC'),
	(53238, 108, '2015-02-15 00:31:24.000000', 'temperatura', 778.0000, 'ºC'),
	(53239, 108, '2015-02-15 00:31:25.000000', 'temperatura', 682.0000, 'ºC'),
	(53240, 108, '2015-02-15 00:31:26.000000', 'temperatura', 1074.0000, 'ºC'),
	(53241, 108, '2015-02-15 00:31:27.000000', 'temperatura', 925.0000, 'ºC'),
	(53242, 108, '2015-02-15 00:31:28.000000', 'temperatura', 203.0000, 'ºC'),
	(53243, 108, '2015-02-15 00:31:29.000000', 'temperatura', 640.0000, 'ºC'),
	(53244, 108, '2015-02-15 00:31:30.000000', 'temperatura', 191.0000, 'ºC'),
	(53245, 108, '2015-02-15 00:31:31.000000', 'temperatura', 237.0000, 'ºC'),
	(53246, 108, '2015-02-15 00:31:32.000000', 'temperatura', 610.0000, 'ºC'),
	(53247, 108, '2015-02-15 00:31:33.000000', 'temperatura', 1141.0000, 'ºC'),
	(53248, 108, '2015-02-15 00:31:34.000000', 'temperatura', 275.0000, 'ºC'),
	(53249, 108, '2015-02-15 00:31:35.000000', 'temperatura', 351.0000, 'ºC'),
	(53250, 108, '2015-02-15 00:31:36.000000', 'temperatura', 934.0000, 'ºC'),
	(53251, 108, '2015-02-15 00:31:37.000000', 'temperatura', 14.0000, 'ºC'),
	(53252, 108, '2015-02-15 00:31:38.000000', 'temperatura', 870.0000, 'ºC'),
	(53253, 108, '2015-02-15 00:31:39.000000', 'temperatura', 707.0000, 'ºC'),
	(53254, 108, '2015-02-15 00:31:40.000000', 'temperatura', 926.0000, 'ºC'),
	(53255, 108, '2015-02-15 00:31:41.000000', 'temperatura', 108.0000, 'ºC'),
	(53256, 108, '2015-02-15 00:31:42.000000', 'temperatura', 164.0000, 'ºC'),
	(53257, 108, '2015-02-15 00:31:43.000000', 'temperatura', 494.0000, 'ºC'),
	(53258, 108, '2015-02-15 00:31:44.000000', 'temperatura', 782.0000, 'ºC'),
	(53259, 108, '2015-02-15 00:31:45.000000', 'temperatura', 27.0000, 'ºC'),
	(53260, 108, '2015-02-15 00:31:46.000000', 'temperatura', 190.0000, 'ºC'),
	(53261, 108, '2015-02-15 00:31:47.000000', 'temperatura', 869.0000, 'ºC'),
	(53262, 108, '2015-02-15 00:31:48.000000', 'temperatura', 176.0000, 'ºC'),
	(53263, 108, '2015-02-15 00:31:49.000000', 'temperatura', 674.0000, 'ºC'),
	(53264, 108, '2015-02-15 00:31:50.000000', 'temperatura', 442.0000, 'ºC'),
	(53265, 108, '2015-02-15 00:31:51.000000', 'temperatura', 189.0000, 'ºC'),
	(53266, 108, '2015-02-15 00:31:52.000000', 'temperatura', 821.0000, 'ºC'),
	(53267, 108, '2015-02-15 00:31:53.000000', 'temperatura', 1136.0000, 'ºC'),
	(53268, 108, '2015-02-15 00:31:54.000000', 'temperatura', 816.0000, 'ºC'),
	(53269, 108, '2015-02-15 00:31:55.000000', 'temperatura', 675.0000, 'ºC'),
	(53270, 108, '2015-02-15 00:31:56.000000', 'temperatura', 928.0000, 'ºC'),
	(53271, 108, '2015-02-15 00:31:57.000000', 'temperatura', 215.0000, 'ºC'),
	(53272, 108, '2015-02-15 00:31:58.000000', 'temperatura', 692.0000, 'ºC'),
	(53273, 108, '2015-02-15 00:31:59.000000', 'temperatura', 413.0000, 'ºC'),
	(53274, 108, '2015-02-15 00:32:00.000000', 'temperatura', 1191.0000, 'ºC'),
	(53275, 108, '2015-02-15 00:32:01.000000', 'temperatura', 1115.0000, 'ºC'),
	(53276, 108, '2015-02-15 00:32:02.000000', 'temperatura', 802.0000, 'ºC'),
	(53277, 108, '2015-02-15 00:32:03.000000', 'temperatura', 668.0000, 'ºC'),
	(53278, 108, '2015-02-15 00:32:04.000000', 'temperatura', 935.0000, 'ºC'),
	(53279, 108, '2015-02-15 00:32:05.000000', 'temperatura', 272.0000, 'ºC'),
	(53280, 108, '2015-02-15 00:32:06.000000', 'temperatura', 956.0000, 'ºC'),
	(53281, 108, '2015-02-15 00:32:07.000000', 'temperatura', 363.0000, 'ºC'),
	(53282, 108, '2015-02-15 00:32:08.000000', 'temperatura', 146.0000, 'ºC'),
	(53283, 108, '2015-02-15 00:32:09.000000', 'temperatura', 842.0000, 'ºC'),
	(53284, 108, '2015-02-15 00:32:10.000000', 'temperatura', 171.0000, 'ºC'),
	(53285, 108, '2015-02-15 00:32:11.000000', 'temperatura', 733.0000, 'ºC'),
	(53286, 108, '2015-02-15 00:32:12.000000', 'temperatura', 751.0000, 'ºC'),
	(53287, 108, '2015-02-15 00:32:13.000000', 'temperatura', 357.0000, 'ºC'),
	(53288, 108, '2015-02-15 00:32:14.000000', 'temperatura', 731.0000, 'ºC'),
	(53289, 108, '2015-02-15 00:32:15.000000', 'temperatura', 185.0000, 'ºC'),
	(53290, 108, '2015-02-15 00:32:16.000000', 'temperatura', 1133.0000, 'ºC'),
	(53291, 108, '2015-02-15 00:32:17.000000', 'temperatura', 309.0000, 'ºC'),
	(53292, 108, '2015-02-15 00:32:18.000000', 'temperatura', 548.0000, 'ºC'),
	(53293, 108, '2015-02-15 00:32:19.000000', 'temperatura', 611.0000, 'ºC'),
	(53294, 108, '2015-02-15 00:32:20.000000', 'temperatura', 213.0000, 'ºC'),
	(53295, 108, '2015-02-15 00:32:21.000000', 'temperatura', 433.0000, 'ºC'),
	(53296, 108, '2015-02-15 00:32:22.000000', 'temperatura', 327.0000, 'ºC'),
	(53297, 108, '2015-02-15 00:32:23.000000', 'temperatura', 337.0000, 'ºC'),
	(53298, 108, '2015-02-15 00:32:24.000000', 'temperatura', 705.0000, 'ºC'),
	(53299, 108, '2015-02-15 00:32:25.000000', 'temperatura', 112.0000, 'ºC'),
	(53300, 108, '2015-02-15 00:32:26.000000', 'temperatura', 847.0000, 'ºC'),
	(53301, 108, '2015-02-15 00:32:27.000000', 'temperatura', 298.0000, 'ºC'),
	(53302, 108, '2015-02-15 00:32:28.000000', 'temperatura', 150.0000, 'ºC'),
	(53303, 108, '2015-02-15 00:32:29.000000', 'temperatura', 1058.0000, 'ºC'),
	(53304, 108, '2015-02-15 00:32:30.000000', 'temperatura', 39.0000, 'ºC'),
	(53305, 108, '2015-02-15 00:32:31.000000', 'temperatura', 621.0000, 'ºC'),
	(53306, 108, '2015-02-15 00:32:32.000000', 'temperatura', 588.0000, 'ºC'),
	(53307, 108, '2015-02-15 00:32:33.000000', 'temperatura', 1079.0000, 'ºC'),
	(53308, 108, '2015-02-15 00:32:34.000000', 'temperatura', 30.0000, 'ºC'),
	(53309, 108, '2015-02-15 00:32:35.000000', 'temperatura', 515.0000, 'ºC'),
	(53310, 108, '2015-02-15 00:32:36.000000', 'temperatura', 85.0000, 'ºC'),
	(53311, 108, '2015-02-15 00:32:37.000000', 'temperatura', 80.0000, 'ºC'),
	(53312, 108, '2015-02-15 00:32:38.000000', 'temperatura', 144.0000, 'ºC'),
	(53313, 108, '2015-02-15 00:32:39.000000', 'temperatura', 481.0000, 'ºC'),
	(53314, 108, '2015-02-15 00:32:40.000000', 'temperatura', 776.0000, 'ºC'),
	(53315, 108, '2015-02-15 00:32:41.000000', 'temperatura', 34.0000, 'ºC'),
	(53316, 108, '2015-02-15 00:32:42.000000', 'temperatura', 246.0000, 'ºC'),
	(53317, 108, '2015-02-15 00:32:43.000000', 'temperatura', 1126.0000, 'ºC'),
	(53318, 108, '2015-02-15 00:32:44.000000', 'temperatura', 93.0000, 'ºC'),
	(53319, 108, '2015-02-15 00:32:45.000000', 'temperatura', 689.0000, 'ºC'),
	(53320, 108, '2015-02-15 00:32:46.000000', 'temperatura', 766.0000, 'ºC'),
	(53321, 108, '2015-02-15 00:32:47.000000', 'temperatura', 561.0000, 'ºC'),
	(53322, 108, '2015-02-15 00:32:48.000000', 'temperatura', 509.0000, 'ºC'),
	(53323, 108, '2015-02-15 00:32:49.000000', 'temperatura', 864.0000, 'ºC'),
	(53324, 108, '2015-02-15 00:32:50.000000', 'temperatura', 394.0000, 'ºC'),
	(53325, 108, '2015-02-15 00:32:51.000000', 'temperatura', 577.0000, 'ºC'),
	(53326, 108, '2015-02-15 00:32:52.000000', 'temperatura', 504.0000, 'ºC'),
	(53327, 108, '2015-02-15 00:32:53.000000', 'temperatura', 788.0000, 'ºC'),
	(53328, 108, '2015-02-15 00:32:54.000000', 'temperatura', 29.0000, 'ºC'),
	(53329, 108, '2015-02-15 00:32:55.000000', 'temperatura', 180.0000, 'ºC'),
	(53330, 108, '2015-02-15 00:32:56.000000', 'temperatura', 817.0000, 'ºC'),
	(53331, 108, '2015-02-15 00:32:57.000000', 'temperatura', 1143.0000, 'ºC'),
	(53332, 108, '2015-02-15 00:32:58.000000', 'temperatura', 867.0000, 'ºC'),
	(53333, 108, '2015-02-15 00:32:59.000000', 'temperatura', 905.0000, 'ºC'),
	(53334, 108, '2015-02-15 00:33:00.000000', 'temperatura', 723.0000, 'ºC'),
	(53335, 108, '2015-02-15 00:33:01.000000', 'temperatura', 900.0000, 'ºC'),
	(53336, 108, '2015-02-15 00:33:02.000000', 'temperatura', 1133.0000, 'ºC'),
	(53337, 108, '2015-02-15 00:33:03.000000', 'temperatura', 565.0000, 'ºC'),
	(53338, 108, '2015-02-15 00:33:04.000000', 'temperatura', 625.0000, 'ºC'),
	(53339, 108, '2015-02-15 00:33:05.000000', 'temperatura', 232.0000, 'ºC'),
	(53340, 108, '2015-02-15 00:33:06.000000', 'temperatura', 486.0000, 'ºC'),
	(53341, 108, '2015-02-15 00:33:07.000000', 'temperatura', 533.0000, 'ºC'),
	(53342, 108, '2015-02-15 00:33:08.000000', 'temperatura', 6.0000, 'ºC'),
	(53343, 108, '2015-02-15 00:33:09.000000', 'temperatura', 834.0000, 'ºC'),
	(53344, 108, '2015-02-15 00:33:10.000000', 'temperatura', 552.0000, 'ºC'),
	(53345, 108, '2015-02-15 00:33:11.000000', 'temperatura', 260.0000, 'ºC'),
	(53346, 108, '2015-02-15 00:33:12.000000', 'temperatura', 844.0000, 'ºC'),
	(53347, 108, '2015-02-15 00:33:13.000000', 'temperatura', 1039.0000, 'ºC'),
	(53348, 108, '2015-02-15 00:33:14.000000', 'temperatura', 266.0000, 'ºC'),
	(53349, 108, '2015-02-15 00:33:15.000000', 'temperatura', 612.0000, 'ºC'),
	(53350, 108, '2015-02-15 00:33:16.000000', 'temperatura', 1064.0000, 'ºC'),
	(53351, 108, '2015-02-15 00:33:17.000000', 'temperatura', 1086.0000, 'ºC'),
	(53352, 108, '2015-02-15 00:33:18.000000', 'temperatura', 1035.0000, 'ºC'),
	(53353, 108, '2015-02-15 00:33:19.000000', 'temperatura', 718.0000, 'ºC'),
	(53354, 108, '2015-02-15 00:33:20.000000', 'temperatura', 487.0000, 'ºC'),
	(53355, 108, '2015-02-15 00:33:21.000000', 'temperatura', 280.0000, 'ºC'),
	(53356, 108, '2015-02-15 00:33:22.000000', 'temperatura', 1139.0000, 'ºC'),
	(53357, 108, '2015-02-15 00:33:23.000000', 'temperatura', 56.0000, 'ºC'),
	(53358, 108, '2015-02-15 00:33:24.000000', 'temperatura', 465.0000, 'ºC'),
	(53359, 108, '2015-02-15 00:33:25.000000', 'temperatura', 955.0000, 'ºC'),
	(53360, 108, '2015-02-15 00:33:26.000000', 'temperatura', 984.0000, 'ºC'),
	(53361, 108, '2015-02-15 00:33:27.000000', 'temperatura', 853.0000, 'ºC'),
	(53362, 108, '2015-02-15 00:33:28.000000', 'temperatura', 112.0000, 'ºC'),
	(53363, 108, '2015-02-15 00:33:29.000000', 'temperatura', 405.0000, 'ºC'),
	(53364, 108, '2015-02-15 00:33:30.000000', 'temperatura', 488.0000, 'ºC'),
	(53365, 108, '2015-02-15 00:33:31.000000', 'temperatura', 25.0000, 'ºC'),
	(53366, 108, '2015-02-15 00:33:32.000000', 'temperatura', 1061.0000, 'ºC'),
	(53367, 108, '2015-02-15 00:33:33.000000', 'temperatura', 430.0000, 'ºC'),
	(53368, 108, '2015-02-15 00:33:34.000000', 'temperatura', 167.0000, 'ºC'),
	(53369, 108, '2015-02-15 00:33:35.000000', 'temperatura', 746.0000, 'ºC'),
	(53370, 108, '2015-02-15 00:33:36.000000', 'temperatura', 832.0000, 'ºC'),
	(53371, 108, '2015-02-15 00:33:37.000000', 'temperatura', 720.0000, 'ºC'),
	(53372, 108, '2015-02-15 00:33:38.000000', 'temperatura', 1107.0000, 'ºC'),
	(53373, 108, '2015-02-15 00:33:39.000000', 'temperatura', 974.0000, 'ºC'),
	(53374, 108, '2015-02-15 00:33:40.000000', 'temperatura', 349.0000, 'ºC'),
	(53375, 108, '2015-02-15 00:33:41.000000', 'temperatura', 24.0000, 'ºC'),
	(53376, 108, '2015-02-15 00:33:42.000000', 'temperatura', 273.0000, 'ºC'),
	(53377, 108, '2015-02-15 00:33:43.000000', 'temperatura', 94.0000, 'ºC'),
	(53378, 108, '2015-02-15 00:33:44.000000', 'temperatura', 850.0000, 'ºC'),
	(53379, 108, '2015-02-15 00:33:45.000000', 'temperatura', 371.0000, 'ºC'),
	(53380, 108, '2015-02-15 00:33:46.000000', 'temperatura', 504.0000, 'ºC'),
	(53381, 108, '2015-02-15 00:33:47.000000', 'temperatura', 209.0000, 'ºC'),
	(53382, 108, '2015-02-15 00:33:48.000000', 'temperatura', 731.0000, 'ºC'),
	(53383, 108, '2015-02-15 00:33:49.000000', 'temperatura', 629.0000, 'ºC'),
	(53384, 108, '2015-02-15 00:33:50.000000', 'temperatura', 954.0000, 'ºC'),
	(53385, 108, '2015-02-15 00:33:51.000000', 'temperatura', 483.0000, 'ºC'),
	(53386, 108, '2015-02-15 00:33:52.000000', 'temperatura', 752.0000, 'ºC'),
	(53387, 108, '2015-02-15 00:33:53.000000', 'temperatura', 1113.0000, 'ºC'),
	(53388, 108, '2015-02-15 00:33:54.000000', 'temperatura', 909.0000, 'ºC'),
	(53389, 108, '2015-02-15 00:33:55.000000', 'temperatura', 7.0000, 'ºC'),
	(53390, 108, '2015-02-15 00:33:56.000000', 'temperatura', 910.0000, 'ºC'),
	(53391, 108, '2015-02-15 00:33:57.000000', 'temperatura', 927.0000, 'ºC'),
	(53392, 108, '2015-02-15 00:33:58.000000', 'temperatura', 706.0000, 'ºC'),
	(53393, 108, '2015-02-15 00:33:59.000000', 'temperatura', 751.0000, 'ºC'),
	(53394, 108, '2015-02-15 00:34:00.000000', 'temperatura', 435.0000, 'ºC'),
	(53395, 108, '2015-02-15 00:34:01.000000', 'temperatura', 1124.0000, 'ºC'),
	(53396, 108, '2015-02-15 00:34:02.000000', 'temperatura', 716.0000, 'ºC'),
	(53397, 108, '2015-02-15 00:34:03.000000', 'temperatura', 206.0000, 'ºC'),
	(53398, 108, '2015-02-15 00:34:04.000000', 'temperatura', 84.0000, 'ºC'),
	(53399, 108, '2015-02-15 00:34:05.000000', 'temperatura', 1004.0000, 'ºC'),
	(53400, 108, '2015-02-15 00:34:06.000000', 'temperatura', 1166.0000, 'ºC'),
	(53401, 108, '2015-02-15 00:34:07.000000', 'temperatura', 421.0000, 'ºC'),
	(53402, 108, '2015-02-15 00:34:08.000000', 'temperatura', 1005.0000, 'ºC'),
	(53403, 108, '2015-02-15 00:34:09.000000', 'temperatura', 162.0000, 'ºC'),
	(53404, 108, '2015-02-15 00:34:10.000000', 'temperatura', 198.0000, 'ºC'),
	(53405, 108, '2015-02-15 00:34:11.000000', 'temperatura', 502.0000, 'ºC'),
	(53406, 108, '2015-02-15 00:34:12.000000', 'temperatura', 717.0000, 'ºC'),
	(53407, 108, '2015-02-15 00:34:13.000000', 'temperatura', 881.0000, 'ºC'),
	(53408, 108, '2015-02-15 00:34:14.000000', 'temperatura', 1056.0000, 'ºC'),
	(53409, 108, '2015-02-15 00:34:15.000000', 'temperatura', 234.0000, 'ºC'),
	(53410, 108, '2015-02-15 00:34:16.000000', 'temperatura', 404.0000, 'ºC'),
	(53411, 108, '2015-02-15 00:34:17.000000', 'temperatura', 120.0000, 'ºC'),
	(53412, 108, '2015-02-15 00:34:18.000000', 'temperatura', 585.0000, 'ºC'),
	(53413, 108, '2015-02-15 00:34:19.000000', 'temperatura', 169.0000, 'ºC'),
	(53414, 108, '2015-02-15 00:34:20.000000', 'temperatura', 289.0000, 'ºC'),
	(53415, 108, '2015-02-15 00:34:21.000000', 'temperatura', 940.0000, 'ºC'),
	(53416, 108, '2015-02-15 00:34:22.000000', 'temperatura', 234.0000, 'ºC'),
	(53417, 108, '2015-02-15 00:34:23.000000', 'temperatura', 749.0000, 'ºC'),
	(53418, 108, '2015-02-15 00:34:24.000000', 'temperatura', 645.0000, 'ºC'),
	(53419, 108, '2015-02-15 00:34:25.000000', 'temperatura', 979.0000, 'ºC'),
	(53420, 108, '2015-02-15 00:34:26.000000', 'temperatura', 560.0000, 'ºC'),
	(53421, 108, '2015-02-15 00:34:27.000000', 'temperatura', 1063.0000, 'ºC'),
	(53422, 108, '2015-02-15 00:34:28.000000', 'temperatura', 36.0000, 'ºC'),
	(53423, 108, '2015-02-15 00:34:29.000000', 'temperatura', 590.0000, 'ºC'),
	(53424, 108, '2015-02-15 00:34:30.000000', 'temperatura', 442.0000, 'ºC'),
	(53425, 108, '2015-02-15 00:34:31.000000', 'temperatura', 441.0000, 'ºC'),
	(53426, 108, '2015-02-15 00:34:32.000000', 'temperatura', 880.0000, 'ºC'),
	(53427, 108, '2015-02-15 00:34:33.000000', 'temperatura', 678.0000, 'ºC'),
	(53428, 108, '2015-02-15 00:34:34.000000', 'temperatura', 749.0000, 'ºC'),
	(53429, 108, '2015-02-15 00:34:35.000000', 'temperatura', 513.0000, 'ºC'),
	(53430, 108, '2015-02-15 00:34:36.000000', 'temperatura', 316.0000, 'ºC'),
	(53431, 108, '2015-02-15 00:34:37.000000', 'temperatura', 45.0000, 'ºC'),
	(53432, 108, '2015-02-15 00:34:38.000000', 'temperatura', 475.0000, 'ºC'),
	(53433, 108, '2015-02-15 00:34:39.000000', 'temperatura', 1041.0000, 'ºC'),
	(53434, 108, '2015-02-15 00:34:40.000000', 'temperatura', 181.0000, 'ºC'),
	(53435, 108, '2015-02-15 00:34:41.000000', 'temperatura', 181.0000, 'ºC'),
	(53436, 108, '2015-02-15 00:34:42.000000', 'temperatura', 362.0000, 'ºC'),
	(53437, 108, '2015-02-15 00:34:43.000000', 'temperatura', 70.0000, 'ºC'),
	(53438, 108, '2015-02-15 00:34:44.000000', 'temperatura', 463.0000, 'ºC'),
	(53439, 108, '2015-02-15 00:34:45.000000', 'temperatura', 905.0000, 'ºC'),
	(53440, 108, '2015-02-15 00:34:46.000000', 'temperatura', 735.0000, 'ºC'),
	(53441, 108, '2015-02-15 00:34:47.000000', 'temperatura', 963.0000, 'ºC'),
	(53442, 108, '2015-02-15 00:34:48.000000', 'temperatura', 211.0000, 'ºC'),
	(53443, 108, '2015-02-15 00:34:49.000000', 'temperatura', 564.0000, 'ºC'),
	(53444, 108, '2015-02-15 00:34:50.000000', 'temperatura', 990.0000, 'ºC'),
	(53445, 108, '2015-02-15 00:34:51.000000', 'temperatura', 856.0000, 'ºC'),
	(53446, 108, '2015-02-15 00:34:52.000000', 'temperatura', 112.0000, 'ºC'),
	(53447, 108, '2015-02-15 00:34:53.000000', 'temperatura', 393.0000, 'ºC'),
	(53448, 108, '2015-02-15 00:34:54.000000', 'temperatura', 428.0000, 'ºC'),
	(53449, 108, '2015-02-15 00:34:55.000000', 'temperatura', 963.0000, 'ºC'),
	(53450, 108, '2015-02-15 00:34:56.000000', 'temperatura', 1131.0000, 'ºC'),
	(53451, 108, '2015-02-15 00:34:57.000000', 'temperatura', 368.0000, 'ºC'),
	(53452, 108, '2015-02-15 00:34:58.000000', 'temperatura', 847.0000, 'ºC'),
	(53453, 108, '2015-02-15 00:34:59.000000', 'temperatura', 730.0000, 'ºC'),
	(53454, 108, '2015-02-15 00:35:00.000000', 'temperatura', 1112.0000, 'ºC'),
	(53455, 108, '2015-02-15 00:35:01.000000', 'temperatura', 971.0000, 'ºC'),
	(53456, 108, '2015-02-15 00:35:02.000000', 'temperatura', 318.0000, 'ºC'),
	(53457, 108, '2015-02-15 00:35:03.000000', 'temperatura', 1077.0000, 'ºC'),
	(53458, 108, '2015-02-15 00:35:04.000000', 'temperatura', 830.0000, 'ºC'),
	(53459, 108, '2015-02-15 00:35:05.000000', 'temperatura', 921.0000, 'ºC'),
	(53460, 108, '2015-02-15 00:35:06.000000', 'temperatura', 915.0000, 'ºC'),
	(53461, 108, '2015-02-15 00:35:07.000000', 'temperatura', 614.0000, 'ºC'),
	(53462, 108, '2015-02-15 00:35:08.000000', 'temperatura', 325.0000, 'ºC'),
	(53463, 108, '2015-02-15 00:35:09.000000', 'temperatura', 984.0000, 'ºC'),
	(53464, 108, '2015-02-15 00:35:10.000000', 'temperatura', 343.0000, 'ºC'),
	(53465, 108, '2015-02-15 00:35:11.000000', 'temperatura', 1166.0000, 'ºC'),
	(53466, 108, '2015-02-15 00:35:12.000000', 'temperatura', 1199.0000, 'ºC'),
	(53467, 108, '2015-02-15 00:35:13.000000', 'temperatura', 100.0000, 'ºC'),
	(53468, 108, '2015-02-15 00:35:14.000000', 'temperatura', 503.0000, 'ºC'),
	(53469, 108, '2015-02-15 00:35:15.000000', 'temperatura', 1014.0000, 'ºC'),
	(53470, 108, '2015-02-15 00:35:16.000000', 'temperatura', 1164.0000, 'ºC'),
	(53471, 108, '2015-02-15 00:35:17.000000', 'temperatura', 379.0000, 'ºC'),
	(53472, 108, '2015-02-15 00:35:18.000000', 'temperatura', 801.0000, 'ºC'),
	(53473, 108, '2015-02-15 00:35:19.000000', 'temperatura', 469.0000, 'ºC'),
	(53474, 108, '2015-02-15 00:35:20.000000', 'temperatura', 1142.0000, 'ºC'),
	(53475, 108, '2015-02-15 00:35:21.000000', 'temperatura', 704.0000, 'ºC'),
	(53476, 108, '2015-02-15 00:35:22.000000', 'temperatura', 95.0000, 'ºC'),
	(53477, 108, '2015-02-15 00:35:23.000000', 'temperatura', 761.0000, 'ºC'),
	(53478, 108, '2015-02-15 00:35:24.000000', 'temperatura', 1123.0000, 'ºC'),
	(53479, 108, '2015-02-15 00:35:25.000000', 'temperatura', 932.0000, 'ºC'),
	(53480, 108, '2015-02-15 00:35:26.000000', 'temperatura', 90.0000, 'ºC'),
	(53481, 108, '2015-02-15 00:35:27.000000', 'temperatura', 54.0000, 'ºC'),
	(53482, 108, '2015-02-15 00:35:28.000000', 'temperatura', 0.0000, 'ºC'),
	(53483, 108, '2015-02-15 00:35:29.000000', 'temperatura', 1038.0000, 'ºC'),
	(53484, 108, '2015-02-15 00:35:30.000000', 'temperatura', 392.0000, 'ºC'),
	(53485, 108, '2015-02-15 00:35:31.000000', 'temperatura', 46.0000, 'ºC'),
	(53486, 108, '2015-02-15 00:35:32.000000', 'temperatura', 254.0000, 'ºC'),
	(53487, 108, '2015-02-15 00:35:33.000000', 'temperatura', 1133.0000, 'ºC'),
	(53488, 108, '2015-02-15 00:35:34.000000', 'temperatura', 105.0000, 'ºC'),
	(53489, 108, '2015-02-15 00:35:35.000000', 'temperatura', 725.0000, 'ºC'),
	(53490, 108, '2015-02-15 00:35:36.000000', 'temperatura', 909.0000, 'ºC'),
	(53491, 108, '2015-02-15 00:35:37.000000', 'temperatura', 1173.0000, 'ºC'),
	(53492, 108, '2015-02-15 00:35:38.000000', 'temperatura', 737.0000, 'ºC'),
	(53493, 108, '2015-02-15 00:35:39.000000', 'temperatura', 167.0000, 'ºC'),
	(53494, 108, '2015-02-15 00:35:40.000000', 'temperatura', 1022.0000, 'ºC'),
	(53495, 108, '2015-02-15 00:35:41.000000', 'temperatura', 1013.0000, 'ºC'),
	(53496, 108, '2015-02-15 00:35:42.000000', 'temperatura', 798.0000, 'ºC'),
	(53497, 108, '2015-02-15 00:35:43.000000', 'temperatura', 953.0000, 'ºC'),
	(53498, 108, '2015-02-15 00:35:44.000000', 'temperatura', 1169.0000, 'ºC'),
	(53499, 108, '2015-02-15 00:35:45.000000', 'temperatura', 589.0000, 'ºC'),
	(53500, 108, '2015-02-15 00:35:46.000000', 'temperatura', 637.0000, 'ºC'),
	(53501, 108, '2015-02-15 00:35:47.000000', 'temperatura', 218.0000, 'ºC'),
	(53502, 108, '2015-02-15 00:35:48.000000', 'temperatura', 381.0000, 'ºC'),
	(53503, 108, '2015-02-15 00:35:49.000000', 'temperatura', 52.0000, 'ºC'),
	(53504, 108, '2015-02-15 00:35:50.000000', 'temperatura', 318.0000, 'ºC'),
	(53505, 108, '2015-02-15 00:35:51.000000', 'temperatura', 234.0000, 'ºC'),
	(53506, 108, '2015-02-15 00:35:52.000000', 'temperatura', 216.0000, 'ºC'),
	(53507, 108, '2015-02-15 00:35:53.000000', 'temperatura', 378.0000, 'ºC'),
	(53508, 108, '2015-02-15 00:35:54.000000', 'temperatura', 45.0000, 'ºC'),
	(53509, 108, '2015-02-15 00:35:55.000000', 'temperatura', 289.0000, 'ºC'),
	(53510, 108, '2015-02-15 00:35:56.000000', 'temperatura', 111.0000, 'ºC'),
	(53511, 108, '2015-02-15 00:35:57.000000', 'temperatura', 889.0000, 'ºC'),
	(53512, 108, '2015-02-15 00:35:58.000000', 'temperatura', 514.0000, 'ºC'),
	(53513, 108, '2015-02-15 00:35:59.000000', 'temperatura', 1104.0000, 'ºC'),
	(53514, 108, '2015-02-15 00:36:00.000000', 'temperatura', 377.0000, 'ºC'),
	(53515, 108, '2015-02-15 00:36:01.000000', 'temperatura', 972.0000, 'ºC'),
	(53516, 108, '2015-02-15 00:36:02.000000', 'temperatura', 129.0000, 'ºC'),
	(53517, 108, '2015-02-15 00:36:03.000000', 'temperatura', 132.0000, 'ºC'),
	(53518, 108, '2015-02-15 00:36:04.000000', 'temperatura', 271.0000, 'ºC'),
	(53519, 108, '2015-02-15 00:36:05.000000', 'temperatura', 960.0000, 'ºC'),
	(53520, 108, '2015-02-15 00:36:06.000000', 'temperatura', 389.0000, 'ºC'),
	(53521, 108, '2015-02-15 00:36:07.000000', 'temperatura', 265.0000, 'ºC'),
	(53522, 108, '2015-02-15 00:36:08.000000', 'temperatura', 159.0000, 'ºC'),
	(53523, 108, '2015-02-15 00:36:09.000000', 'temperatura', 0.0000, 'ºC'),
	(53524, 108, '2015-02-15 00:36:10.000000', 'temperatura', 723.0000, 'ºC'),
	(53525, 108, '2015-02-15 00:36:11.000000', 'temperatura', 16.0000, 'ºC'),
	(53526, 108, '2015-02-15 00:36:12.000000', 'temperatura', 310.0000, 'ºC'),
	(53527, 108, '2015-02-15 00:36:13.000000', 'temperatura', 305.0000, 'ºC'),
	(53528, 108, '2015-02-15 00:36:14.000000', 'temperatura', 596.0000, 'ºC'),
	(53529, 108, '2015-02-15 00:36:15.000000', 'temperatura', 863.0000, 'ºC'),
	(53530, 108, '2015-02-15 00:36:16.000000', 'temperatura', 130.0000, 'ºC'),
	(53531, 108, '2015-02-15 00:36:17.000000', 'temperatura', 461.0000, 'ºC'),
	(53532, 108, '2015-02-15 00:36:18.000000', 'temperatura', 715.0000, 'ºC'),
	(53533, 108, '2015-02-15 00:36:19.000000', 'temperatura', 994.0000, 'ºC'),
	(53534, 108, '2015-02-15 00:36:20.000000', 'temperatura', 424.0000, 'ºC'),
	(53535, 108, '2015-02-15 00:36:21.000000', 'temperatura', 338.0000, 'ºC'),
	(53536, 108, '2015-02-15 00:36:22.000000', 'temperatura', 421.0000, 'ºC'),
	(53537, 108, '2015-02-15 00:36:23.000000', 'temperatura', 1088.0000, 'ºC'),
	(53538, 108, '2015-02-15 00:36:24.000000', 'temperatura', 581.0000, 'ºC'),
	(53539, 108, '2015-02-15 00:36:25.000000', 'temperatura', 838.0000, 'ºC'),
	(53540, 108, '2015-02-15 00:36:26.000000', 'temperatura', 51.0000, 'ºC'),
	(53541, 108, '2015-02-15 00:36:27.000000', 'temperatura', 138.0000, 'ºC'),
	(53542, 108, '2015-02-15 00:36:28.000000', 'temperatura', 540.0000, 'ºC'),
	(53543, 108, '2015-02-15 00:36:29.000000', 'temperatura', 1087.0000, 'ºC'),
	(53544, 108, '2015-02-15 00:36:30.000000', 'temperatura', 213.0000, 'ºC'),
	(53545, 108, '2015-02-15 00:36:31.000000', 'temperatura', 208.0000, 'ºC'),
	(53546, 108, '2015-02-15 00:36:32.000000', 'temperatura', 399.0000, 'ºC'),
	(53547, 108, '2015-02-15 00:36:33.000000', 'temperatura', 172.0000, 'ºC'),
	(53548, 108, '2015-02-15 00:36:34.000000', 'temperatura', 862.0000, 'ºC'),
	(53549, 108, '2015-02-15 00:36:35.000000', 'temperatura', 196.0000, 'ºC'),
	(53550, 108, '2015-02-15 00:36:36.000000', 'temperatura', 792.0000, 'ºC'),
	(53551, 108, '2015-02-15 00:36:37.000000', 'temperatura', 975.0000, 'ºC'),
	(53552, 108, '2015-02-15 00:36:38.000000', 'temperatura', 99.0000, 'ºC'),
	(53553, 108, '2015-02-15 00:36:39.000000', 'temperatura', 1170.0000, 'ºC'),
	(53554, 108, '2015-02-15 00:36:40.000000', 'temperatura', 755.0000, 'ºC'),
	(53555, 108, '2015-02-15 00:36:41.000000', 'temperatura', 263.0000, 'ºC'),
	(53556, 108, '2015-02-15 00:36:42.000000', 'temperatura', 251.0000, 'ºC'),
	(53557, 108, '2015-02-15 00:36:43.000000', 'temperatura', 467.0000, 'ºC'),
	(53558, 108, '2015-02-15 00:36:44.000000', 'temperatura', 382.0000, 'ºC'),
	(53559, 108, '2015-02-15 00:36:45.000000', 'temperatura', 510.0000, 'ºC'),
	(53560, 108, '2015-02-15 00:36:46.000000', 'temperatura', 204.0000, 'ºC'),
	(53561, 108, '2015-02-15 00:36:47.000000', 'temperatura', 691.0000, 'ºC'),
	(53562, 108, '2015-02-15 00:36:48.000000', 'temperatura', 445.0000, 'ºC'),
	(53563, 108, '2015-02-15 00:36:49.000000', 'temperatura', 151.0000, 'ºC'),
	(53564, 108, '2015-02-15 00:36:50.000000', 'temperatura', 623.0000, 'ºC'),
	(53565, 108, '2015-02-15 00:36:51.000000', 'temperatura', 260.0000, 'ºC'),
	(53566, 108, '2015-02-15 00:36:52.000000', 'temperatura', 631.0000, 'ºC'),
	(53567, 108, '2015-02-15 00:36:53.000000', 'temperatura', 1178.0000, 'ºC'),
	(53568, 108, '2015-02-15 00:36:54.000000', 'temperatura', 398.0000, 'ºC'),
	(53569, 108, '2015-02-15 00:36:55.000000', 'temperatura', 855.0000, 'ºC'),
	(53570, 108, '2015-02-15 00:36:56.000000', 'temperatura', 683.0000, 'ºC'),
	(53571, 108, '2015-02-15 00:36:57.000000', 'temperatura', 850.0000, 'ºC'),
	(53572, 108, '2015-02-15 00:36:58.000000', 'temperatura', 1001.0000, 'ºC'),
	(53573, 108, '2015-02-15 00:36:59.000000', 'temperatura', 56.0000, 'ºC'),
	(53574, 108, '2015-02-15 00:37:00.000000', 'temperatura', 878.0000, 'ºC'),
	(53575, 108, '2015-02-15 00:37:01.000000', 'temperatura', 621.0000, 'ºC'),
	(53576, 108, '2015-02-15 00:37:02.000000', 'temperatura', 474.0000, 'ºC'),
	(53577, 108, '2015-02-15 00:37:03.000000', 'temperatura', 507.0000, 'ºC'),
	(53578, 108, '2015-02-15 00:37:04.000000', 'temperatura', 1113.0000, 'ºC'),
	(53579, 108, '2015-02-15 00:37:05.000000', 'temperatura', 443.0000, 'ºC'),
	(53580, 108, '2015-02-15 00:37:06.000000', 'temperatura', 78.0000, 'ºC'),
	(53581, 108, '2015-02-15 00:37:07.000000', 'temperatura', 261.0000, 'ºC'),
	(53582, 108, '2015-02-15 00:37:08.000000', 'temperatura', 1069.0000, 'ºC'),
	(53583, 108, '2015-02-15 00:37:09.000000', 'temperatura', 966.0000, 'ºC'),
	(53584, 108, '2015-02-15 00:37:10.000000', 'temperatura', 424.0000, 'ºC'),
	(53585, 108, '2015-02-15 00:37:11.000000', 'temperatura', 422.0000, 'ºC'),
	(53586, 108, '2015-02-15 00:37:12.000000', 'temperatura', 838.0000, 'ºC'),
	(53587, 108, '2015-02-15 00:37:13.000000', 'temperatura', 523.0000, 'ºC'),
	(53588, 108, '2015-02-15 00:37:14.000000', 'temperatura', 102.0000, 'ºC'),
	(53589, 108, '2015-02-15 00:37:15.000000', 'temperatura', 141.0000, 'ºC'),
	(53590, 108, '2015-02-15 00:37:16.000000', 'temperatura', 401.0000, 'ºC'),
	(53591, 108, '2015-02-15 00:37:17.000000', 'temperatura', 383.0000, 'ºC'),
	(53592, 108, '2015-02-15 00:37:18.000000', 'temperatura', 712.0000, 'ºC'),
	(53593, 108, '2015-02-15 00:37:19.000000', 'temperatura', 12.0000, 'ºC'),
	(53594, 108, '2015-02-15 00:37:20.000000', 'temperatura', 323.0000, 'ºC'),
	(53595, 108, '2015-02-15 00:37:21.000000', 'temperatura', 379.0000, 'ºC'),
	(53596, 108, '2015-02-15 00:37:22.000000', 'temperatura', 929.0000, 'ºC'),
	(53597, 108, '2015-02-15 00:37:23.000000', 'temperatura', 1109.0000, 'ºC'),
	(53598, 108, '2015-02-15 00:37:24.000000', 'temperatura', 357.0000, 'ºC'),
	(53599, 108, '2015-02-15 00:37:25.000000', 'temperatura', 857.0000, 'ºC'),
	(53600, 108, '2015-02-15 00:37:26.000000', 'temperatura', 816.0000, 'ºC'),
	(53601, 108, '2015-02-15 00:37:27.000000', 'temperatura', 308.0000, 'ºC'),
	(53602, 108, '2015-02-15 00:37:28.000000', 'temperatura', 295.0000, 'ºC'),
	(53603, 108, '2015-02-15 00:37:29.000000', 'temperatura', 551.0000, 'ºC'),
	(53604, 108, '2015-02-15 00:37:30.000000', 'temperatura', 671.0000, 'ºC'),
	(53605, 108, '2015-02-15 00:37:31.000000', 'temperatura', 502.0000, 'ºC'),
	(53606, 108, '2015-02-15 00:37:32.000000', 'temperatura', 497.0000, 'ºC'),
	(53607, 108, '2015-02-15 00:37:33.000000', 'temperatura', 980.0000, 'ºC'),
	(53608, 108, '2015-02-15 00:37:34.000000', 'temperatura', 1008.0000, 'ºC'),
	(53609, 108, '2015-02-15 00:37:35.000000', 'temperatura', 900.0000, 'ºC'),
	(53610, 108, '2015-02-15 00:37:36.000000', 'temperatura', 277.0000, 'ºC'),
	(53611, 108, '2015-02-15 00:37:37.000000', 'temperatura', 1086.0000, 'ºC'),
	(53612, 108, '2015-02-15 00:37:38.000000', 'temperatura', 1001.0000, 'ºC'),
	(53613, 108, '2015-02-15 00:37:39.000000', 'temperatura', 546.0000, 'ºC'),
	(53614, 108, '2015-02-15 00:37:40.000000', 'temperatura', 927.0000, 'ºC'),
	(53615, 108, '2015-02-15 00:37:41.000000', 'temperatura', 599.0000, 'ºC'),
	(53616, 108, '2015-02-15 00:37:42.000000', 'temperatura', 215.0000, 'ºC'),
	(53617, 108, '2015-02-15 00:37:43.000000', 'temperatura', 476.0000, 'ºC'),
	(53618, 108, '2015-02-15 00:37:44.000000', 'temperatura', 538.0000, 'ºC'),
	(53619, 108, '2015-02-15 00:37:45.000000', 'temperatura', 60.0000, 'ºC'),
	(53620, 108, '2015-02-15 00:37:46.000000', 'temperatura', 1089.0000, 'ºC'),
	(53621, 108, '2015-02-15 00:37:47.000000', 'temperatura', 465.0000, 'ºC'),
	(53622, 108, '2015-02-15 00:37:48.000000', 'temperatura', 259.0000, 'ºC'),
	(53623, 108, '2015-02-15 00:37:49.000000', 'temperatura', 1098.0000, 'ºC'),
	(53624, 108, '2015-02-15 00:37:50.000000', 'temperatura', 1115.0000, 'ºC'),
	(53625, 108, '2015-02-15 00:37:51.000000', 'temperatura', 1083.0000, 'ºC'),
	(53626, 108, '2015-02-15 00:37:52.000000', 'temperatura', 868.0000, 'ºC'),
	(53627, 108, '2015-02-15 00:37:53.000000', 'temperatura', 1094.0000, 'ºC'),
	(53628, 108, '2015-02-15 00:37:54.000000', 'temperatura', 467.0000, 'ºC'),
	(53629, 108, '2015-02-15 00:37:55.000000', 'temperatura', 253.0000, 'ºC'),
	(53630, 108, '2015-02-15 00:37:56.000000', 'temperatura', 1062.0000, 'ºC'),
	(53631, 108, '2015-02-15 00:37:57.000000', 'temperatura', 955.0000, 'ºC'),
	(53632, 108, '2015-02-15 00:37:58.000000', 'temperatura', 388.0000, 'ºC'),
	(53633, 108, '2015-02-15 00:37:59.000000', 'temperatura', 277.0000, 'ºC'),
	(53634, 108, '2015-02-15 00:38:00.000000', 'temperatura', 219.0000, 'ºC'),
	(53635, 108, '2015-02-15 00:38:01.000000', 'temperatura', 264.0000, 'ºC'),
	(53636, 108, '2015-02-15 00:38:02.000000', 'temperatura', 663.0000, 'ºC'),
	(53637, 108, '2015-02-15 00:38:03.000000', 'temperatura', 124.0000, 'ºC'),
	(53638, 108, '2015-02-15 00:38:04.000000', 'temperatura', 1032.0000, 'ºC'),
	(53639, 108, '2015-02-15 00:38:05.000000', 'temperatura', 1190.0000, 'ºC'),
	(53640, 108, '2015-02-15 00:38:06.000000', 'temperatura', 451.0000, 'ºC'),
	(53641, 108, '2015-02-15 00:38:07.000000', 'temperatura', 1089.0000, 'ºC'),
	(53642, 108, '2015-02-15 00:38:08.000000', 'temperatura', 490.0000, 'ºC'),
	(53643, 108, '2015-02-15 00:38:09.000000', 'temperatura', 383.0000, 'ºC'),
	(53644, 108, '2015-02-15 00:38:10.000000', 'temperatura', 446.0000, 'ºC'),
	(53645, 108, '2015-02-15 00:38:11.000000', 'temperatura', 1083.0000, 'ºC'),
	(53646, 108, '2015-02-15 00:38:12.000000', 'temperatura', 477.0000, 'ºC'),
	(53647, 108, '2015-02-15 00:38:13.000000', 'temperatura', 338.0000, 'ºC'),
	(53648, 108, '2015-02-15 00:38:14.000000', 'temperatura', 259.0000, 'ºC'),
	(53649, 108, '2015-02-15 00:38:15.000000', 'temperatura', 281.0000, 'ºC'),
	(53650, 108, '2015-02-15 00:38:16.000000', 'temperatura', 630.0000, 'ºC'),
	(53651, 108, '2015-02-15 00:38:17.000000', 'temperatura', 1106.0000, 'ºC'),
	(53652, 108, '2015-02-15 00:38:18.000000', 'temperatura', 42.0000, 'ºC'),
	(53653, 108, '2015-02-15 00:38:19.000000', 'temperatura', 491.0000, 'ºC'),
	(53654, 108, '2015-02-15 00:38:20.000000', 'temperatura', 1128.0000, 'ºC'),
	(53655, 108, '2015-02-15 00:38:21.000000', 'temperatura', 570.0000, 'ºC'),
	(53656, 108, '2015-02-15 00:38:22.000000', 'temperatura', 665.0000, 'ºC'),
	(53657, 108, '2015-02-15 00:38:23.000000', 'temperatura', 416.0000, 'ºC'),
	(53658, 108, '2015-02-15 00:38:24.000000', 'temperatura', 86.0000, 'ºC'),
	(53659, 108, '2015-02-15 00:38:25.000000', 'temperatura', 383.0000, 'ºC'),
	(53660, 108, '2015-02-15 00:38:26.000000', 'temperatura', 457.0000, 'ºC'),
	(53661, 108, '2015-02-15 00:38:27.000000', 'temperatura', 1135.0000, 'ºC'),
	(53662, 108, '2015-02-15 00:38:28.000000', 'temperatura', 705.0000, 'ºC'),
	(53663, 108, '2015-02-15 00:38:29.000000', 'temperatura', 121.0000, 'ºC'),
	(53664, 108, '2015-02-15 00:38:30.000000', 'temperatura', 890.0000, 'ºC'),
	(53665, 108, '2015-02-15 00:38:31.000000', 'temperatura', 488.0000, 'ºC'),
	(53666, 108, '2015-02-15 00:38:32.000000', 'temperatura', 971.0000, 'ºC'),
	(53667, 108, '2015-02-15 00:38:33.000000', 'temperatura', 992.0000, 'ºC'),
	(53668, 108, '2015-02-15 00:38:34.000000', 'temperatura', 845.0000, 'ºC'),
	(53669, 108, '2015-02-15 00:38:35.000000', 'temperatura', 53.0000, 'ºC'),
	(53670, 108, '2015-02-15 00:38:36.000000', 'temperatura', 128.0000, 'ºC'),
	(53671, 108, '2015-02-15 00:38:37.000000', 'temperatura', 482.0000, 'ºC'),
	(53672, 108, '2015-02-15 00:38:38.000000', 'temperatura', 827.0000, 'ºC'),
	(53673, 108, '2015-02-15 00:38:39.000000', 'temperatura', 289.0000, 'ºC'),
	(53674, 108, '2015-02-15 00:38:40.000000', 'temperatura', 166.0000, 'ºC'),
	(53675, 108, '2015-02-15 00:38:41.000000', 'temperatura', 1164.0000, 'ºC'),
	(53676, 108, '2015-02-15 00:38:42.000000', 'temperatura', 520.0000, 'ºC'),
	(53677, 108, '2015-02-15 00:38:43.000000', 'temperatura', 311.0000, 'ºC'),
	(53678, 108, '2015-02-15 00:38:44.000000', 'temperatura', 1197.0000, 'ºC'),
	(53679, 108, '2015-02-15 00:38:45.000000', 'temperatura', 249.0000, 'ºC'),
	(53680, 108, '2015-02-15 00:38:46.000000', 'temperatura', 55.0000, 'ºC'),
	(53681, 108, '2015-02-15 00:38:47.000000', 'temperatura', 730.0000, 'ºC'),
	(53682, 108, '2015-02-15 00:38:48.000000', 'temperatura', 1087.0000, 'ºC'),
	(53683, 108, '2015-02-15 00:38:49.000000', 'temperatura', 842.0000, 'ºC'),
	(53684, 108, '2015-02-15 00:38:50.000000', 'temperatura', 952.0000, 'ºC'),
	(53685, 108, '2015-02-15 00:38:51.000000', 'temperatura', 1032.0000, 'ºC'),
	(53686, 108, '2015-02-15 00:38:52.000000', 'temperatura', 1106.0000, 'ºC'),
	(53687, 108, '2015-02-15 00:38:53.000000', 'temperatura', 35.0000, 'ºC'),
	(53688, 108, '2015-02-15 00:38:54.000000', 'temperatura', 457.0000, 'ºC'),
	(53689, 108, '2015-02-15 00:38:55.000000', 'temperatura', 982.0000, 'ºC'),
	(53690, 108, '2015-02-15 00:38:56.000000', 'temperatura', 1138.0000, 'ºC'),
	(53691, 108, '2015-02-15 00:38:57.000000', 'temperatura', 344.0000, 'ºC'),
	(53692, 108, '2015-02-15 00:38:58.000000', 'temperatura', 706.0000, 'ºC'),
	(53693, 108, '2015-02-15 00:38:59.000000', 'temperatura', 97.0000, 'ºC'),
	(53694, 108, '2015-02-15 00:39:00.000000', 'temperatura', 770.0000, 'ºC'),
	(53695, 108, '2015-02-15 00:39:01.000000', 'temperatura', 1159.0000, 'ºC'),
	(53696, 108, '2015-02-15 00:39:02.000000', 'temperatura', 1084.0000, 'ºC'),
	(53697, 108, '2015-02-15 00:39:03.000000', 'temperatura', 743.0000, 'ºC'),
	(53698, 108, '2015-02-15 00:39:04.000000', 'temperatura', 467.0000, 'ºC'),
	(53699, 108, '2015-02-15 00:39:05.000000', 'temperatura', 103.0000, 'ºC'),
	(53700, 108, '2015-02-15 00:39:06.000000', 'temperatura', 315.0000, 'ºC'),
	(53701, 108, '2015-02-15 00:39:07.000000', 'temperatura', 66.0000, 'ºC'),
	(53702, 108, '2015-02-15 00:39:08.000000', 'temperatura', 587.0000, 'ºC'),
	(53703, 108, '2015-02-15 00:39:09.000000', 'temperatura', 335.0000, 'ºC'),
	(53704, 108, '2015-02-15 00:39:10.000000', 'temperatura', 1115.0000, 'ºC'),
	(53705, 108, '2015-02-15 00:39:11.000000', 'temperatura', 973.0000, 'ºC'),
	(53706, 108, '2015-02-15 00:39:12.000000', 'temperatura', 318.0000, 'ºC'),
	(53707, 108, '2015-02-15 00:39:13.000000', 'temperatura', 1072.0000, 'ºC'),
	(53708, 108, '2015-02-15 00:39:14.000000', 'temperatura', 808.0000, 'ºC'),
	(53709, 108, '2015-02-15 00:39:15.000000', 'temperatura', 823.0000, 'ºC'),
	(53710, 108, '2015-02-15 00:39:16.000000', 'temperatura', 490.0000, 'ºC'),
	(53711, 108, '2015-02-15 00:39:17.000000', 'temperatura', 1183.0000, 'ºC'),
	(53712, 108, '2015-02-15 00:39:18.000000', 'temperatura', 846.0000, 'ºC'),
	(53713, 108, '2015-02-15 00:39:19.000000', 'temperatura', 679.0000, 'ºC'),
	(53714, 108, '2015-02-15 00:39:20.000000', 'temperatura', 861.0000, 'ºC'),
	(53715, 108, '2015-02-15 00:39:21.000000', 'temperatura', 1066.0000, 'ºC'),
	(53716, 108, '2015-02-15 00:39:22.000000', 'temperatura', 346.0000, 'ºC'),
	(53717, 108, '2015-02-15 00:39:23.000000', 'temperatura', 935.0000, 'ºC'),
	(53718, 108, '2015-02-15 00:39:24.000000', 'temperatura', 36.0000, 'ºC'),
	(53719, 108, '2015-02-15 00:39:25.000000', 'temperatura', 978.0000, 'ºC'),
	(53720, 108, '2015-02-15 00:39:26.000000', 'temperatura', 1181.0000, 'ºC'),
	(53721, 108, '2015-02-15 00:39:27.000000', 'temperatura', 573.0000, 'ºC'),
	(53722, 108, '2015-02-15 00:39:28.000000', 'temperatura', 520.0000, 'ºC'),
	(53723, 108, '2015-02-15 00:39:29.000000', 'temperatura', 881.0000, 'ºC'),
	(53724, 108, '2015-02-15 00:39:30.000000', 'temperatura', 448.0000, 'ºC'),
	(53725, 108, '2015-02-15 00:39:31.000000', 'temperatura', 797.0000, 'ºC'),
	(53726, 108, '2015-02-15 00:39:32.000000', 'temperatura', 243.0000, 'ºC'),
	(53727, 108, '2015-02-15 00:39:33.000000', 'temperatura', 24.0000, 'ºC'),
	(53728, 108, '2015-02-15 00:39:34.000000', 'temperatura', 590.0000, 'ºC'),
	(53729, 108, '2015-02-15 00:39:35.000000', 'temperatura', 481.0000, 'ºC'),
	(53730, 108, '2015-02-15 00:39:36.000000', 'temperatura', 635.0000, 'ºC'),
	(53731, 108, '2015-02-15 00:39:37.000000', 'temperatura', 533.0000, 'ºC'),
	(53732, 108, '2015-02-15 00:39:38.000000', 'temperatura', 761.0000, 'ºC'),
	(53733, 108, '2015-02-15 00:39:39.000000', 'temperatura', 1005.0000, 'ºC'),
	(53734, 108, '2015-02-15 00:39:40.000000', 'temperatura', 344.0000, 'ºC'),
	(53735, 108, '2015-02-15 00:39:41.000000', 'temperatura', 1106.0000, 'ºC'),
	(53736, 108, '2015-02-15 00:39:42.000000', 'temperatura', 898.0000, 'ºC'),
	(53737, 108, '2015-02-15 00:39:43.000000', 'temperatura', 1171.0000, 'ºC'),
	(53738, 108, '2015-02-15 00:39:44.000000', 'temperatura', 762.0000, 'ºC'),
	(53739, 108, '2015-02-15 00:39:45.000000', 'temperatura', 299.0000, 'ºC'),
	(53740, 108, '2015-02-15 00:39:46.000000', 'temperatura', 407.0000, 'ºC'),
	(53741, 108, '2015-02-15 00:39:47.000000', 'temperatura', 1138.0000, 'ºC'),
	(53742, 108, '2015-02-15 00:39:48.000000', 'temperatura', 869.0000, 'ºC'),
	(53743, 108, '2015-02-15 00:39:49.000000', 'temperatura', 933.0000, 'ºC'),
	(53744, 108, '2015-02-15 00:39:50.000000', 'temperatura', 857.0000, 'ºC'),
	(53745, 108, '2015-02-15 00:39:51.000000', 'temperatura', 285.0000, 'ºC'),
	(53746, 108, '2015-02-15 00:39:52.000000', 'temperatura', 58.0000, 'ºC'),
	(53747, 108, '2015-02-15 00:39:53.000000', 'temperatura', 633.0000, 'ºC'),
	(53748, 108, '2015-02-15 00:39:54.000000', 'temperatura', 594.0000, 'ºC'),
	(53749, 108, '2015-02-15 00:39:55.000000', 'temperatura', 1072.0000, 'ºC'),
	(53750, 108, '2015-02-15 00:39:56.000000', 'temperatura', 1177.0000, 'ºC'),
	(53751, 108, '2015-02-15 00:39:57.000000', 'temperatura', 271.0000, 'ºC'),
	(53752, 108, '2015-02-15 00:39:58.000000', 'temperatura', 223.0000, 'ºC'),
	(53753, 108, '2015-02-15 00:39:59.000000', 'temperatura', 302.0000, 'ºC'),
	(53754, 108, '2015-02-15 00:40:00.000000', 'temperatura', 843.0000, 'ºC'),
	(53755, 108, '2015-02-15 00:40:01.000000', 'temperatura', 909.0000, 'ºC'),
	(53756, 108, '2015-02-15 00:40:02.000000', 'temperatura', 818.0000, 'ºC'),
	(53757, 108, '2015-02-15 00:40:03.000000', 'temperatura', 160.0000, 'ºC'),
	(53758, 108, '2015-02-15 00:40:04.000000', 'temperatura', 750.0000, 'ºC'),
	(53759, 108, '2015-02-15 00:40:05.000000', 'temperatura', 868.0000, 'ºC'),
	(53760, 108, '2015-02-15 00:40:06.000000', 'temperatura', 892.0000, 'ºC'),
	(53761, 108, '2015-02-15 00:40:07.000000', 'temperatura', 656.0000, 'ºC'),
	(53762, 108, '2015-02-15 00:40:08.000000', 'temperatura', 604.0000, 'ºC'),
	(53763, 108, '2015-02-15 00:40:09.000000', 'temperatura', 1054.0000, 'ºC'),
	(53764, 108, '2015-02-15 00:40:10.000000', 'temperatura', 1059.0000, 'ºC'),
	(53765, 108, '2015-02-15 00:40:11.000000', 'temperatura', 931.0000, 'ºC'),
	(53766, 108, '2015-02-15 00:40:12.000000', 'temperatura', 277.0000, 'ºC'),
	(53767, 108, '2015-02-15 00:40:13.000000', 'temperatura', 996.0000, 'ºC'),
	(53768, 108, '2015-02-15 00:40:14.000000', 'temperatura', 550.0000, 'ºC'),
	(53769, 108, '2015-02-15 00:40:15.000000', 'temperatura', 963.0000, 'ºC'),
	(53770, 108, '2015-02-15 00:40:16.000000', 'temperatura', 764.0000, 'ºC'),
	(53771, 108, '2015-02-15 00:40:17.000000', 'temperatura', 933.0000, 'ºC'),
	(53772, 108, '2015-02-15 00:40:18.000000', 'temperatura', 1172.0000, 'ºC'),
	(53773, 108, '2015-02-15 00:40:19.000000', 'temperatura', 663.0000, 'ºC'),
	(53774, 108, '2015-02-15 00:40:20.000000', 'temperatura', 997.0000, 'ºC'),
	(53775, 108, '2015-02-15 00:40:21.000000', 'temperatura', 597.0000, 'ºC'),
	(53776, 108, '2015-02-15 00:40:22.000000', 'temperatura', 1194.0000, 'ºC'),
	(53777, 108, '2015-02-15 00:40:23.000000', 'temperatura', 580.0000, 'ºC'),
	(53778, 108, '2015-02-15 00:40:24.000000', 'temperatura', 520.0000, 'ºC'),
	(53779, 108, '2015-02-15 00:40:25.000000', 'temperatura', 860.0000, 'ºC'),
	(53780, 108, '2015-02-15 00:40:26.000000', 'temperatura', 342.0000, 'ºC'),
	(53781, 108, '2015-02-15 00:40:27.000000', 'temperatura', 330.0000, 'ºC'),
	(53782, 108, '2015-02-15 00:40:28.000000', 'temperatura', 624.0000, 'ºC'),
	(53783, 108, '2015-02-15 00:40:29.000000', 'temperatura', 930.0000, 'ºC'),
	(53784, 108, '2015-02-15 00:40:30.000000', 'temperatura', 379.0000, 'ºC'),
	(53785, 108, '2015-02-15 00:40:31.000000', 'temperatura', 303.0000, 'ºC'),
	(53786, 108, '2015-02-15 00:40:32.000000', 'temperatura', 382.0000, 'ºC'),
	(53787, 108, '2015-02-15 00:40:33.000000', 'temperatura', 999.0000, 'ºC'),
	(53788, 108, '2015-02-15 00:40:34.000000', 'temperatura', 250.0000, 'ºC'),
	(53789, 108, '2015-02-15 00:40:35.000000', 'temperatura', 653.0000, 'ºC'),
	(53790, 108, '2015-02-15 00:40:36.000000', 'temperatura', 118.0000, 'ºC'),
	(53791, 108, '2015-02-15 00:40:37.000000', 'temperatura', 1031.0000, 'ºC'),
	(53792, 108, '2015-02-15 00:40:38.000000', 'temperatura', 0.0000, 'ºC'),
	(53793, 108, '2015-02-15 00:40:39.000000', 'temperatura', 508.0000, 'ºC'),
	(53794, 108, '2015-02-15 00:40:40.000000', 'temperatura', 140.0000, 'ºC'),
	(53795, 108, '2015-02-15 00:40:41.000000', 'temperatura', 378.0000, 'ºC'),
	(53796, 108, '2015-02-15 00:40:42.000000', 'temperatura', 268.0000, 'ºC'),
	(53797, 108, '2015-02-15 00:40:43.000000', 'temperatura', 207.0000, 'ºC'),
	(53798, 108, '2015-02-15 00:40:44.000000', 'temperatura', 232.0000, 'ºC'),
	(53799, 108, '2015-02-15 00:40:45.000000', 'temperatura', 540.0000, 'ºC'),
	(53800, 108, '2015-02-15 00:40:46.000000', 'temperatura', 803.0000, 'ºC'),
	(53801, 108, '2015-02-15 00:40:47.000000', 'temperatura', 1195.0000, 'ºC'),
	(53802, 108, '2015-02-15 00:40:48.000000', 'temperatura', 1169.0000, 'ºC'),
	(53803, 108, '2015-02-15 00:40:49.000000', 'temperatura', 1058.0000, 'ºC'),
	(53804, 108, '2015-02-15 00:40:50.000000', 'temperatura', 583.0000, 'ºC'),
	(53805, 108, '2015-02-15 00:40:51.000000', 'temperatura', 942.0000, 'ºC'),
	(53806, 108, '2015-02-15 00:40:52.000000', 'temperatura', 562.0000, 'ºC'),
	(53807, 108, '2015-02-15 00:40:53.000000', 'temperatura', 1183.0000, 'ºC'),
	(53808, 108, '2015-02-15 00:40:54.000000', 'temperatura', 631.0000, 'ºC'),
	(53809, 108, '2015-02-15 00:40:55.000000', 'temperatura', 805.0000, 'ºC'),
	(53810, 108, '2015-02-15 00:40:56.000000', 'temperatura', 935.0000, 'ºC'),
	(53811, 108, '2015-02-15 00:40:57.000000', 'temperatura', 1061.0000, 'ºC'),
	(53812, 108, '2015-02-15 00:40:58.000000', 'temperatura', 100.0000, 'ºC'),
	(53813, 108, '2015-02-15 00:40:59.000000', 'temperatura', 916.0000, 'ºC'),
	(53814, 108, '2015-02-15 00:41:00.000000', 'temperatura', 682.0000, 'ºC'),
	(53815, 108, '2015-02-15 00:41:01.000000', 'temperatura', 660.0000, 'ºC'),
	(53816, 108, '2015-02-15 00:41:02.000000', 'temperatura', 57.0000, 'ºC'),
	(53817, 108, '2015-02-15 00:41:03.000000', 'temperatura', 703.0000, 'ºC'),
	(53818, 108, '2015-02-15 00:41:04.000000', 'temperatura', 945.0000, 'ºC'),
	(53819, 108, '2015-02-15 00:41:05.000000', 'temperatura', 216.0000, 'ºC'),
	(53820, 108, '2015-02-15 00:41:06.000000', 'temperatura', 647.0000, 'ºC'),
	(53821, 108, '2015-02-15 00:41:07.000000', 'temperatura', 188.0000, 'ºC'),
	(53822, 108, '2015-02-15 00:41:08.000000', 'temperatura', 199.0000, 'ºC'),
	(53823, 108, '2015-02-15 00:41:09.000000', 'temperatura', 433.0000, 'ºC'),
	(53824, 108, '2015-02-15 00:41:10.000000', 'temperatura', 367.0000, 'ºC'),
	(53825, 108, '2015-02-15 00:41:11.000000', 'temperatura', 536.0000, 'ºC'),
	(53826, 108, '2015-02-15 00:41:12.000000', 'temperatura', 382.0000, 'ºC'),
	(53827, 108, '2015-02-15 00:41:13.000000', 'temperatura', 300.0000, 'ºC'),
	(53828, 108, '2015-02-15 00:41:14.000000', 'temperatura', 354.0000, 'ºC'),
	(53829, 108, '2015-02-15 00:41:15.000000', 'temperatura', 870.0000, 'ºC'),
	(53830, 108, '2015-02-15 00:41:16.000000', 'temperatura', 890.0000, 'ºC'),
	(53831, 108, '2015-02-15 00:41:17.000000', 'temperatura', 639.0000, 'ºC'),
	(53832, 108, '2015-02-15 00:41:18.000000', 'temperatura', 527.0000, 'ºC'),
	(53833, 108, '2015-02-15 00:41:19.000000', 'temperatura', 719.0000, 'ºC'),
	(53834, 108, '2015-02-15 00:41:20.000000', 'temperatura', 813.0000, 'ºC'),
	(53835, 108, '2015-02-15 00:41:21.000000', 'temperatura', 711.0000, 'ºC'),
	(53836, 108, '2015-02-15 00:41:22.000000', 'temperatura', 1115.0000, 'ºC'),
	(53837, 108, '2015-02-15 00:41:23.000000', 'temperatura', 1043.0000, 'ºC'),
	(53838, 108, '2015-02-15 00:41:24.000000', 'temperatura', 670.0000, 'ºC'),
	(53839, 108, '2015-02-15 00:41:25.000000', 'temperatura', 221.0000, 'ºC'),
	(53840, 108, '2015-02-15 00:41:26.000000', 'temperatura', 296.0000, 'ºC'),
	(53841, 108, '2015-02-15 00:41:27.000000', 'temperatura', 817.0000, 'ºC'),
	(53842, 108, '2015-02-15 00:41:28.000000', 'temperatura', 800.0000, 'ºC'),
	(53843, 108, '2015-02-15 00:41:29.000000', 'temperatura', 346.0000, 'ºC'),
	(53844, 108, '2015-02-15 00:41:30.000000', 'temperatura', 532.0000, 'ºC'),
	(53845, 108, '2015-02-15 00:41:31.000000', 'temperatura', 422.0000, 'ºC'),
	(53846, 108, '2015-02-15 00:41:32.000000', 'temperatura', 517.0000, 'ºC'),
	(53847, 108, '2015-02-15 00:41:33.000000', 'temperatura', 117.0000, 'ºC'),
	(53848, 108, '2015-02-15 00:41:34.000000', 'temperatura', 234.0000, 'ºC'),
	(53849, 108, '2015-02-15 00:41:35.000000', 'temperatura', 822.0000, 'ºC'),
	(53850, 108, '2015-02-15 00:41:36.000000', 'temperatura', 1007.0000, 'ºC'),
	(53851, 108, '2015-02-15 00:41:37.000000', 'temperatura', 169.0000, 'ºC'),
	(53852, 108, '2015-02-15 00:41:38.000000', 'temperatura', 225.0000, 'ºC'),
	(53853, 108, '2015-02-15 00:41:39.000000', 'temperatura', 619.0000, 'ºC'),
	(53854, 108, '2015-02-15 00:41:40.000000', 'temperatura', 21.0000, 'ºC'),
	(53855, 108, '2015-02-15 00:41:41.000000', 'temperatura', 650.0000, 'ºC'),
	(53856, 108, '2015-02-15 00:41:42.000000', 'temperatura', 786.0000, 'ºC'),
	(53857, 108, '2015-02-15 00:41:43.000000', 'temperatura', 781.0000, 'ºC'),
	(53858, 108, '2015-02-15 00:41:44.000000', 'temperatura', 346.0000, 'ºC'),
	(53859, 108, '2015-02-15 00:41:45.000000', 'temperatura', 588.0000, 'ºC'),
	(53860, 108, '2015-02-15 00:41:46.000000', 'temperatura', 702.0000, 'ºC'),
	(53861, 108, '2015-02-15 00:41:47.000000', 'temperatura', 546.0000, 'ºC'),
	(53862, 108, '2015-02-15 00:41:48.000000', 'temperatura', 627.0000, 'ºC'),
	(53863, 108, '2015-02-15 00:41:49.000000', 'temperatura', 294.0000, 'ºC'),
	(53864, 108, '2015-02-15 00:41:50.000000', 'temperatura', 793.0000, 'ºC'),
	(53865, 108, '2015-02-15 00:41:51.000000', 'temperatura', 682.0000, 'ºC'),
	(53866, 108, '2015-02-15 00:41:52.000000', 'temperatura', 1031.0000, 'ºC'),
	(53867, 108, '2015-02-15 00:41:53.000000', 'temperatura', 708.0000, 'ºC'),
	(53868, 108, '2015-02-15 00:41:54.000000', 'temperatura', 450.0000, 'ºC'),
	(53869, 108, '2015-02-15 00:41:55.000000', 'temperatura', 127.0000, 'ºC'),
	(53870, 108, '2015-02-15 00:41:56.000000', 'temperatura', 484.0000, 'ºC'),
	(53871, 108, '2015-02-15 00:41:57.000000', 'temperatura', 840.0000, 'ºC'),
	(53872, 108, '2015-02-15 00:41:58.000000', 'temperatura', 348.0000, 'ºC'),
	(53873, 108, '2015-02-15 00:41:59.000000', 'temperatura', 422.0000, 'ºC'),
	(53874, 108, '2015-02-15 00:42:00.000000', 'temperatura', 1067.0000, 'ºC'),
	(53875, 108, '2015-02-15 00:42:01.000000', 'temperatura', 468.0000, 'ºC'),
	(53876, 108, '2015-02-15 00:42:02.000000', 'temperatura', 338.0000, 'ºC'),
	(53877, 108, '2015-02-15 00:42:03.000000', 'temperatura', 288.0000, 'ºC'),
	(53878, 108, '2015-02-15 00:42:04.000000', 'temperatura', 428.0000, 'ºC'),
	(53879, 108, '2015-02-15 00:42:05.000000', 'temperatura', 76.0000, 'ºC'),
	(53880, 108, '2015-02-15 00:42:06.000000', 'temperatura', 297.0000, 'ºC'),
	(53881, 108, '2015-02-15 00:42:07.000000', 'temperatura', 55.0000, 'ºC'),
	(53882, 108, '2015-02-15 00:42:08.000000', 'temperatura', 586.0000, 'ºC'),
	(53883, 108, '2015-02-15 00:42:09.000000', 'temperatura', 364.0000, 'ºC'),
	(53884, 108, '2015-02-15 00:42:10.000000', 'temperatura', 65.0000, 'ºC'),
	(53885, 108, '2015-02-15 00:42:11.000000', 'temperatura', 432.0000, 'ºC'),
	(53886, 108, '2015-02-15 00:42:12.000000', 'temperatura', 765.0000, 'ºC'),
	(53887, 108, '2015-02-15 00:42:13.000000', 'temperatura', 129.0000, 'ºC'),
	(53888, 108, '2015-02-15 00:42:14.000000', 'temperatura', 753.0000, 'ºC'),
	(53889, 108, '2015-02-15 00:42:15.000000', 'temperatura', 976.0000, 'ºC'),
	(53890, 108, '2015-02-15 00:42:16.000000', 'temperatura', 221.0000, 'ºC'),
	(53891, 108, '2015-02-15 00:42:17.000000', 'temperatura', 580.0000, 'ºC'),
	(53892, 108, '2015-02-15 00:42:18.000000', 'temperatura', 1035.0000, 'ºC'),
	(53893, 108, '2015-02-15 00:42:19.000000', 'temperatura', 1036.0000, 'ºC'),
	(53894, 108, '2015-02-15 00:42:20.000000', 'temperatura', 874.0000, 'ºC'),
	(53895, 108, '2015-02-15 00:42:21.000000', 'temperatura', 64.0000, 'ºC'),
	(53896, 108, '2015-02-15 00:42:22.000000', 'temperatura', 98.0000, 'ºC'),
	(53897, 108, '2015-02-15 00:42:23.000000', 'temperatura', 300.0000, 'ºC'),
	(53898, 108, '2015-02-15 00:42:24.000000', 'temperatura', 6.0000, 'ºC'),
	(53899, 108, '2015-02-15 00:42:25.000000', 'temperatura', 329.0000, 'ºC'),
	(53900, 108, '2015-02-15 00:42:26.000000', 'temperatura', 428.0000, 'ºC'),
	(53901, 108, '2015-02-15 00:42:27.000000', 'temperatura', 1155.0000, 'ºC'),
	(53902, 108, '2015-02-15 00:42:28.000000', 'temperatura', 893.0000, 'ºC'),
	(53903, 108, '2015-02-15 00:42:29.000000', 'temperatura', 997.0000, 'ºC'),
	(53904, 108, '2015-02-15 00:42:30.000000', 'temperatura', 1107.0000, 'ºC'),
	(53905, 108, '2015-02-15 00:42:31.000000', 'temperatura', 143.0000, 'ºC'),
	(53906, 108, '2015-02-15 00:42:32.000000', 'temperatura', 996.0000, 'ºC'),
	(53907, 108, '2015-02-15 00:42:33.000000', 'temperatura', 952.0000, 'ºC'),
	(53908, 108, '2015-02-15 00:42:34.000000', 'temperatura', 574.0000, 'ºC'),
	(53909, 108, '2015-02-15 00:42:35.000000', 'temperatura', 13.0000, 'ºC'),
	(53910, 108, '2015-02-15 00:42:36.000000', 'temperatura', 742.0000, 'ºC'),
	(53911, 108, '2015-02-15 00:42:37.000000', 'temperatura', 74.0000, 'ºC'),
	(53912, 108, '2015-02-15 00:42:38.000000', 'temperatura', 546.0000, 'ºC'),
	(53913, 108, '2015-02-15 00:42:39.000000', 'temperatura', 105.0000, 'ºC'),
	(53914, 108, '2015-02-15 00:42:40.000000', 'temperatura', 91.0000, 'ºC'),
	(53915, 108, '2015-02-15 00:42:41.000000', 'temperatura', 137.0000, 'ºC'),
	(53916, 108, '2015-02-15 00:42:42.000000', 'temperatura', 413.0000, 'ºC'),
	(53917, 108, '2015-02-15 00:42:43.000000', 'temperatura', 455.0000, 'ºC'),
	(53918, 108, '2015-02-15 00:42:44.000000', 'temperatura', 1037.0000, 'ºC'),
	(53919, 108, '2015-02-15 00:42:45.000000', 'temperatura', 221.0000, 'ºC'),
	(53920, 108, '2015-02-15 00:42:46.000000', 'temperatura', 392.0000, 'ºC'),
	(53921, 108, '2015-02-15 00:42:47.000000', 'temperatura', 100.0000, 'ºC'),
	(53922, 108, '2015-02-15 00:42:48.000000', 'temperatura', 525.0000, 'ºC'),
	(53923, 108, '2015-02-15 00:42:49.000000', 'temperatura', 1127.0000, 'ºC'),
	(53924, 108, '2015-02-15 00:42:50.000000', 'temperatura', 457.0000, 'ºC'),
	(53925, 108, '2015-02-15 00:42:51.000000', 'temperatura', 106.0000, 'ºC'),
	(53926, 108, '2015-02-15 00:42:52.000000', 'temperatura', 360.0000, 'ºC'),
	(53927, 108, '2015-02-15 00:42:53.000000', 'temperatura', 281.0000, 'ºC'),
	(53928, 108, '2015-02-15 00:42:54.000000', 'temperatura', 328.0000, 'ºC'),
	(53929, 108, '2015-02-15 00:42:55.000000', 'temperatura', 796.0000, 'ºC'),
	(53930, 108, '2015-02-15 00:42:56.000000', 'temperatura', 597.0000, 'ºC'),
	(53931, 108, '2015-02-15 00:42:57.000000', 'temperatura', 599.0000, 'ºC'),
	(53932, 108, '2015-02-15 00:42:58.000000', 'temperatura', 4.0000, 'ºC'),
	(53933, 108, '2015-02-15 00:42:59.000000', 'temperatura', 622.0000, 'ºC'),
	(53934, 108, '2015-02-15 00:43:00.000000', 'temperatura', 701.0000, 'ºC'),
	(53935, 108, '2015-02-15 00:43:01.000000', 'temperatura', 436.0000, 'ºC'),
	(53936, 108, '2015-02-15 00:43:02.000000', 'temperatura', 81.0000, 'ºC'),
	(53937, 108, '2015-02-15 00:43:03.000000', 'temperatura', 296.0000, 'ºC'),
	(53938, 108, '2015-02-15 00:43:04.000000', 'temperatura', 36.0000, 'ºC'),
	(53939, 108, '2015-02-15 00:43:05.000000', 'temperatura', 494.0000, 'ºC'),
	(53940, 108, '2015-02-15 00:43:06.000000', 'temperatura', 1163.0000, 'ºC'),
	(53941, 108, '2015-02-15 00:43:07.000000', 'temperatura', 735.0000, 'ºC'),
	(53942, 108, '2015-02-15 00:43:08.000000', 'temperatura', 184.0000, 'ºC'),
	(53943, 108, '2015-02-15 00:43:09.000000', 'temperatura', 1116.0000, 'ºC'),
	(53944, 108, '2015-02-15 00:43:10.000000', 'temperatura', 230.0000, 'ºC'),
	(53945, 108, '2015-02-15 00:43:11.000000', 'temperatura', 203.0000, 'ºC'),
	(53946, 108, '2015-02-15 00:43:12.000000', 'temperatura', 323.0000, 'ºC'),
	(53947, 108, '2015-02-15 00:43:13.000000', 'temperatura', 1006.0000, 'ºC'),
	(53948, 108, '2015-02-15 00:43:14.000000', 'temperatura', 464.0000, 'ºC'),
	(53949, 108, '2015-02-15 00:43:15.000000', 'temperatura', 500.0000, 'ºC'),
	(53950, 108, '2015-02-15 00:43:16.000000', 'temperatura', 1109.0000, 'ºC'),
	(53951, 108, '2015-02-15 00:43:17.000000', 'temperatura', 445.0000, 'ºC'),
	(53952, 108, '2015-02-15 00:43:18.000000', 'temperatura', 98.0000, 'ºC'),
	(53953, 108, '2015-02-15 00:43:19.000000', 'temperatura', 358.0000, 'ºC'),
	(53954, 108, '2015-02-15 00:43:20.000000', 'temperatura', 296.0000, 'ºC'),
	(53955, 108, '2015-02-15 00:43:21.000000', 'temperatura', 405.0000, 'ºC'),
	(53956, 108, '2015-02-15 00:43:22.000000', 'temperatura', 1139.0000, 'ºC'),
	(53957, 108, '2015-02-15 00:43:23.000000', 'temperatura', 879.0000, 'ºC'),
	(53958, 108, '2015-02-15 00:43:24.000000', 'temperatura', 981.0000, 'ºC'),
	(53959, 108, '2015-02-15 00:43:25.000000', 'temperatura', 1066.0000, 'ºC'),
	(53960, 108, '2015-02-15 00:43:26.000000', 'temperatura', 1187.0000, 'ºC'),
	(53961, 108, '2015-02-15 00:43:27.000000', 'temperatura', 338.0000, 'ºC'),
	(53962, 108, '2015-02-15 00:43:28.000000', 'temperatura', 529.0000, 'ºC'),
	(53963, 108, '2015-02-15 00:43:29.000000', 'temperatura', 433.0000, 'ºC'),
	(53964, 108, '2015-02-15 00:43:30.000000', 'temperatura', 577.0000, 'ºC'),
	(53965, 108, '2015-02-15 00:43:31.000000', 'temperatura', 389.0000, 'ºC'),
	(53966, 108, '2015-02-15 00:43:32.000000', 'temperatura', 212.0000, 'ºC'),
	(53967, 108, '2015-02-15 00:43:33.000000', 'temperatura', 1096.0000, 'ºC'),
	(53968, 108, '2015-02-15 00:43:34.000000', 'temperatura', 43.0000, 'ºC'),
	(53969, 108, '2015-02-15 00:43:35.000000', 'temperatura', 526.0000, 'ºC'),
	(53970, 108, '2015-02-15 00:43:36.000000', 'temperatura', 101.0000, 'ºC'),
	(53971, 108, '2015-02-15 00:43:37.000000', 'temperatura', 129.0000, 'ºC'),
	(53972, 108, '2015-02-15 00:43:38.000000', 'temperatura', 343.0000, 'ºC'),
	(53973, 108, '2015-02-15 00:43:39.000000', 'temperatura', 130.0000, 'ºC'),
	(53974, 108, '2015-02-15 00:43:40.000000', 'temperatura', 820.0000, 'ºC'),
	(53975, 108, '2015-02-15 00:43:41.000000', 'temperatura', 112.0000, 'ºC'),
	(53976, 108, '2015-02-15 00:43:42.000000', 'temperatura', 499.0000, 'ºC'),
	(53977, 108, '2015-02-15 00:43:43.000000', 'temperatura', 959.0000, 'ºC'),
	(53978, 108, '2015-02-15 00:43:44.000000', 'temperatura', 900.0000, 'ºC'),
	(53979, 108, '2015-02-15 00:43:45.000000', 'temperatura', 421.0000, 'ºC'),
	(53980, 108, '2015-02-15 00:43:46.000000', 'temperatura', 609.0000, 'ºC'),
	(53981, 108, '2015-02-15 00:43:47.000000', 'temperatura', 580.0000, 'ºC'),
	(53982, 108, '2015-02-15 00:43:48.000000', 'temperatura', 1074.0000, 'ºC'),
	(53983, 108, '2015-02-15 00:43:49.000000', 'temperatura', 31.0000, 'ºC'),
	(53984, 108, '2015-02-15 00:43:50.000000', 'temperatura', 533.0000, 'ºC'),
	(53985, 108, '2015-02-15 00:43:51.000000', 'temperatura', 171.0000, 'ºC'),
	(53986, 108, '2015-02-15 00:43:52.000000', 'temperatura', 458.0000, 'ºC'),
	(53987, 108, '2015-02-15 00:43:53.000000', 'temperatura', 577.0000, 'ºC'),
	(53988, 108, '2015-02-15 00:43:54.000000', 'temperatura', 310.0000, 'ºC'),
	(53989, 108, '2015-02-15 00:43:55.000000', 'temperatura', 1022.0000, 'ºC'),
	(53990, 108, '2015-02-15 00:43:56.000000', 'temperatura', 578.0000, 'ºC'),
	(53991, 108, '2015-02-15 00:43:57.000000', 'temperatura', 1027.0000, 'ºC'),
	(53992, 108, '2015-02-15 00:43:58.000000', 'temperatura', 1000.0000, 'ºC'),
	(53993, 108, '2015-02-15 00:43:59.000000', 'temperatura', 721.0000, 'ºC'),
	(53994, 108, '2015-02-15 00:44:00.000000', 'temperatura', 607.0000, 'ºC'),
	(53995, 108, '2015-02-15 00:44:01.000000', 'temperatura', 869.0000, 'ºC'),
	(53996, 108, '2015-02-15 00:44:02.000000', 'temperatura', 127.0000, 'ºC'),
	(53997, 108, '2015-02-15 00:44:03.000000', 'temperatura', 426.0000, 'ºC'),
	(53998, 108, '2015-02-15 00:44:04.000000', 'temperatura', 551.0000, 'ºC'),
	(53999, 108, '2015-02-15 00:44:05.000000', 'temperatura', 277.0000, 'ºC'),
	(54000, 108, '2015-02-15 00:44:06.000000', 'temperatura', 933.0000, 'ºC'),
	(54001, 108, '2015-02-15 00:44:07.000000', 'temperatura', 235.0000, 'ºC'),
	(54002, 108, '2015-02-15 00:44:08.000000', 'temperatura', 776.0000, 'ºC'),
	(54003, 108, '2015-02-15 00:44:09.000000', 'temperatura', 778.0000, 'ºC'),
	(54004, 108, '2015-02-15 00:44:10.000000', 'temperatura', 359.0000, 'ºC'),
	(54005, 108, '2015-02-15 00:44:11.000000', 'temperatura', 663.0000, 'ºC'),
	(54006, 108, '2015-02-15 00:44:12.000000', 'temperatura', 1037.0000, 'ºC'),
	(54007, 108, '2015-02-15 00:44:13.000000', 'temperatura', 796.0000, 'ºC'),
	(54008, 108, '2015-02-15 00:44:14.000000', 'temperatura', 872.0000, 'ºC'),
	(54009, 108, '2015-02-15 00:44:15.000000', 'temperatura', 772.0000, 'ºC'),
	(54010, 108, '2015-02-15 00:44:16.000000', 'temperatura', 46.0000, 'ºC'),
	(54011, 108, '2015-02-15 00:44:17.000000', 'temperatura', 314.0000, 'ºC'),
	(54012, 108, '2015-02-15 00:44:18.000000', 'temperatura', 232.0000, 'ºC'),
	(54013, 108, '2015-02-15 00:44:19.000000', 'temperatura', 218.0000, 'ºC'),
	(54014, 108, '2015-02-15 00:44:20.000000', 'temperatura', 397.0000, 'ºC'),
	(54015, 108, '2015-02-15 00:44:21.000000', 'temperatura', 129.0000, 'ºC'),
	(54016, 108, '2015-02-15 00:44:22.000000', 'temperatura', 654.0000, 'ºC'),
	(54017, 108, '2015-02-15 00:44:23.000000', 'temperatura', 486.0000, 'ºC'),
	(54018, 108, '2015-02-15 00:44:24.000000', 'temperatura', 467.0000, 'ºC'),
	(54019, 108, '2015-02-15 00:44:25.000000', 'temperatura', 877.0000, 'ºC'),
	(54020, 108, '2015-02-15 00:44:26.000000', 'temperatura', 585.0000, 'ºC'),
	(54021, 108, '2015-02-15 00:44:27.000000', 'temperatura', 294.0000, 'ºC'),
	(54022, 108, '2015-02-15 00:44:28.000000', 'temperatura', 914.0000, 'ºC'),
	(54023, 108, '2015-02-15 00:44:29.000000', 'temperatura', 90.0000, 'ºC'),
	(54024, 108, '2015-02-15 00:44:30.000000', 'temperatura', 110.0000, 'ºC'),
	(54025, 108, '2015-02-15 00:44:31.000000', 'temperatura', 278.0000, 'ºC'),
	(54026, 108, '2015-02-15 00:44:32.000000', 'temperatura', 1060.0000, 'ºC'),
	(54027, 108, '2015-02-15 00:44:33.000000', 'temperatura', 868.0000, 'ºC'),
	(54028, 108, '2015-02-15 00:44:34.000000', 'temperatura', 1162.0000, 'ºC'),
	(54029, 108, '2015-02-15 00:44:35.000000', 'temperatura', 806.0000, 'ºC'),
	(54030, 108, '2015-02-15 00:44:36.000000', 'temperatura', 544.0000, 'ºC'),
	(54031, 108, '2015-02-15 00:44:37.000000', 'temperatura', 304.0000, 'ºC'),
	(54032, 108, '2015-02-15 00:44:38.000000', 'temperatura', 1086.0000, 'ºC'),
	(54033, 108, '2015-02-15 00:44:39.000000', 'temperatura', 922.0000, 'ºC'),
	(54034, 108, '2015-02-15 00:44:40.000000', 'temperatura', 149.0000, 'ºC'),
	(54035, 108, '2015-02-15 00:44:41.000000', 'temperatura', 381.0000, 'ºC'),
	(54036, 108, '2015-02-15 00:44:42.000000', 'temperatura', 257.0000, 'ºC'),
	(54037, 108, '2015-02-15 00:44:43.000000', 'temperatura', 145.0000, 'ºC'),
	(54038, 108, '2015-02-15 00:44:44.000000', 'temperatura', 1155.0000, 'ºC'),
	(54039, 108, '2015-02-15 00:44:45.000000', 'temperatura', 541.0000, 'ºC'),
	(54040, 108, '2015-02-15 00:44:46.000000', 'temperatura', 441.0000, 'ºC'),
	(54041, 108, '2015-02-15 00:44:47.000000', 'temperatura', 583.0000, 'ºC'),
	(54042, 108, '2015-02-15 00:44:48.000000', 'temperatura', 392.0000, 'ºC'),
	(54043, 108, '2015-02-15 00:44:49.000000', 'temperatura', 212.0000, 'ºC'),
	(54044, 108, '2015-02-15 00:44:50.000000', 'temperatura', 1084.0000, 'ºC'),
	(54045, 108, '2015-02-15 00:44:51.000000', 'temperatura', 1184.0000, 'ºC'),
	(54046, 108, '2015-02-15 00:44:52.000000', 'temperatura', 270.0000, 'ºC'),
	(54047, 108, '2015-02-15 00:44:53.000000', 'temperatura', 198.0000, 'ºC'),
	(54048, 108, '2015-02-15 00:44:54.000000', 'temperatura', 181.0000, 'ºC'),
	(54049, 108, '2015-02-15 00:44:55.000000', 'temperatura', 310.0000, 'ºC'),
	(54050, 108, '2015-02-15 00:44:56.000000', 'temperatura', 1006.0000, 'ºC'),
	(54051, 108, '2015-02-15 00:44:57.000000', 'temperatura', 504.0000, 'ºC'),
	(54052, 108, '2015-02-15 00:44:58.000000', 'temperatura', 702.0000, 'ºC'),
	(54053, 108, '2015-02-15 00:44:59.000000', 'temperatura', 797.0000, 'ºC'),
	(54054, 108, '2015-02-15 00:45:00.000000', 'temperatura', 679.0000, 'ºC'),
	(54055, 108, '2015-02-15 00:45:01.000000', 'temperatura', 1007.0000, 'ºC'),
	(54056, 108, '2015-02-15 00:45:02.000000', 'temperatura', 595.0000, 'ºC'),
	(54057, 108, '2015-02-15 00:45:03.000000', 'temperatura', 1158.0000, 'ºC'),
	(54058, 108, '2015-02-15 00:45:04.000000', 'temperatura', 403.0000, 'ºC'),
	(54059, 108, '2015-02-15 00:45:05.000000', 'temperatura', 942.0000, 'ºC'),
	(54060, 108, '2015-02-15 00:45:06.000000', 'temperatura', 1102.0000, 'ºC'),
	(54061, 108, '2015-02-15 00:45:07.000000', 'temperatura', 283.0000, 'ºC'),
	(54062, 108, '2015-02-15 00:45:08.000000', 'temperatura', 510.0000, 'ºC'),
	(54063, 108, '2015-02-15 00:45:09.000000', 'temperatura', 502.0000, 'ºC'),
	(54064, 108, '2015-02-15 00:45:10.000000', 'temperatura', 981.0000, 'ºC'),
	(54065, 108, '2015-02-15 00:45:11.000000', 'temperatura', 1001.0000, 'ºC'),
	(54066, 108, '2015-02-15 00:45:12.000000', 'temperatura', 861.0000, 'ºC'),
	(54067, 108, '2015-02-15 00:45:13.000000', 'temperatura', 101.0000, 'ºC'),
	(54068, 108, '2015-02-15 00:45:14.000000', 'temperatura', 323.0000, 'ºC'),
	(54069, 108, '2015-02-15 00:45:15.000000', 'temperatura', 113.0000, 'ºC'),
	(54070, 108, '2015-02-15 00:45:16.000000', 'temperatura', 795.0000, 'ºC'),
	(54071, 108, '2015-02-15 00:45:17.000000', 'temperatura', 36.0000, 'ºC'),
	(54072, 108, '2015-02-15 00:45:18.000000', 'temperatura', 196.0000, 'ºC'),
	(54073, 108, '2015-02-15 00:45:19.000000', 'temperatura', 872.0000, 'ºC'),
	(54074, 108, '2015-02-15 00:45:20.000000', 'temperatura', 175.0000, 'ºC'),
	(54075, 108, '2015-02-15 00:45:21.000000', 'temperatura', 656.0000, 'ºC'),
	(54076, 108, '2015-02-15 00:45:22.000000', 'temperatura', 358.0000, 'ºC'),
	(54077, 108, '2015-02-15 00:45:23.000000', 'temperatura', 1022.0000, 'ºC'),
	(54078, 108, '2015-02-15 00:45:24.000000', 'temperatura', 438.0000, 'ºC'),
	(54079, 108, '2015-02-15 00:45:25.000000', 'temperatura', 325.0000, 'ºC'),
	(54080, 108, '2015-02-15 00:45:26.000000', 'temperatura', 308.0000, 'ºC'),
	(54081, 108, '2015-02-15 00:45:27.000000', 'temperatura', 568.0000, 'ºC'),
	(54082, 108, '2015-02-15 00:45:28.000000', 'temperatura', 718.0000, 'ºC'),
	(54083, 108, '2015-02-15 00:45:29.000000', 'temperatura', 685.0000, 'ºC'),
	(54084, 108, '2015-02-15 00:45:30.000000', 'temperatura', 70.0000, 'ºC'),
	(54085, 108, '2015-02-15 00:45:31.000000', 'temperatura', 697.0000, 'ºC'),
	(54086, 108, '2015-02-15 00:45:32.000000', 'temperatura', 877.0000, 'ºC'),
	(54087, 108, '2015-02-15 00:45:33.000000', 'temperatura', 1092.0000, 'ºC'),
	(54088, 108, '2015-02-15 00:45:34.000000', 'temperatura', 429.0000, 'ºC'),
	(54089, 108, '2015-02-15 00:45:35.000000', 'temperatura', 70.0000, 'ºC'),
	(54090, 108, '2015-02-15 00:45:36.000000', 'temperatura', 264.0000, 'ºC'),
	(54091, 108, '2015-02-15 00:45:37.000000', 'temperatura', 1112.0000, 'ºC'),
	(54092, 108, '2015-02-15 00:45:38.000000', 'temperatura', 1166.0000, 'ºC'),
	(54093, 108, '2015-02-15 00:45:39.000000', 'temperatura', 94.0000, 'ºC'),
	(54094, 108, '2015-02-15 00:45:40.000000', 'temperatura', 575.0000, 'ºC'),
	(54095, 108, '2015-02-15 00:45:41.000000', 'temperatura', 193.0000, 'ºC'),
	(54096, 108, '2015-02-15 00:45:42.000000', 'temperatura', 440.0000, 'ºC'),
	(54097, 108, '2015-02-15 00:45:43.000000', 'temperatura', 421.0000, 'ºC'),
	(54098, 108, '2015-02-15 00:45:44.000000', 'temperatura', 786.0000, 'ºC'),
	(54099, 108, '2015-02-15 00:45:45.000000', 'temperatura', 266.0000, 'ºC'),
	(54100, 108, '2015-02-15 00:45:46.000000', 'temperatura', 174.0000, 'ºC'),
	(54101, 108, '2015-02-15 00:45:47.000000', 'temperatura', 73.0000, 'ºC'),
	(54102, 108, '2015-02-15 00:45:48.000000', 'temperatura', 1044.0000, 'ºC'),
	(54103, 108, '2015-02-15 00:45:49.000000', 'temperatura', 200.0000, 'ºC'),
	(54104, 108, '2015-02-15 00:45:50.000000', 'temperatura', 270.0000, 'ºC'),
	(54105, 108, '2015-02-15 00:45:51.000000', 'temperatura', 751.0000, 'ºC'),
	(54106, 108, '2015-02-15 00:45:52.000000', 'temperatura', 544.0000, 'ºC'),
	(54107, 108, '2015-02-15 00:45:53.000000', 'temperatura', 470.0000, 'ºC'),
	(54108, 108, '2015-02-15 00:45:54.000000', 'temperatura', 716.0000, 'ºC'),
	(54109, 108, '2015-02-15 00:45:55.000000', 'temperatura', 971.0000, 'ºC'),
	(54110, 108, '2015-02-15 00:45:56.000000', 'temperatura', 308.0000, 'ºC'),
	(54111, 108, '2015-02-15 00:45:57.000000', 'temperatura', 1027.0000, 'ºC'),
	(54112, 108, '2015-02-15 00:45:58.000000', 'temperatura', 613.0000, 'ºC'),
	(54113, 108, '2015-02-15 00:45:59.000000', 'temperatura', 1182.0000, 'ºC'),
	(54114, 108, '2015-02-15 00:46:00.000000', 'temperatura', 474.0000, 'ºC'),
	(54115, 108, '2015-02-15 00:46:01.000000', 'temperatura', 25.0000, 'ºC'),
	(54116, 108, '2015-02-15 00:46:02.000000', 'temperatura', 1102.0000, 'ºC'),
	(54117, 108, '2015-02-15 00:46:03.000000', 'temperatura', 635.0000, 'ºC'),
	(54118, 108, '2015-02-15 00:46:04.000000', 'temperatura', 1072.0000, 'ºC'),
	(54119, 108, '2015-02-15 00:46:05.000000', 'temperatura', 1053.0000, 'ºC'),
	(54120, 108, '2015-02-15 00:46:06.000000', 'temperatura', 852.0000, 'ºC'),
	(54121, 108, '2015-02-15 00:46:07.000000', 'temperatura', 1100.0000, 'ºC'),
	(54122, 108, '2015-02-15 00:46:08.000000', 'temperatura', 546.0000, 'ºC'),
	(54123, 108, '2015-02-15 00:46:09.000000', 'temperatura', 628.0000, 'ºC'),
	(54124, 108, '2015-02-15 00:46:10.000000', 'temperatura', 305.0000, 'ºC'),
	(54125, 108, '2015-02-15 00:46:11.000000', 'temperatura', 839.0000, 'ºC'),
	(54126, 108, '2015-02-15 00:46:12.000000', 'temperatura', 882.0000, 'ºC'),
	(54127, 108, '2015-02-15 00:46:13.000000', 'temperatura', 692.0000, 'ºC'),
	(54128, 108, '2015-02-15 00:46:14.000000', 'temperatura', 814.0000, 'ºC'),
	(54129, 108, '2015-02-15 00:46:15.000000', 'temperatura', 794.0000, 'ºC'),
	(54130, 108, '2015-02-15 00:46:16.000000', 'temperatura', 330.0000, 'ºC'),
	(54131, 108, '2015-02-15 00:46:17.000000', 'temperatura', 469.0000, 'ºC'),
	(54132, 108, '2015-02-15 00:46:18.000000', 'temperatura', 154.0000, 'ºC'),
	(54133, 108, '2015-02-15 00:46:19.000000', 'temperatura', 565.0000, 'ºC'),
	(54134, 108, '2015-02-15 00:46:20.000000', 'temperatura', 1164.0000, 'ºC'),
	(54135, 108, '2015-02-15 00:46:21.000000', 'temperatura', 526.0000, 'ºC'),
	(54136, 108, '2015-02-15 00:46:22.000000', 'temperatura', 339.0000, 'ºC'),
	(54137, 108, '2015-02-15 00:46:23.000000', 'temperatura', 116.0000, 'ºC'),
	(54138, 108, '2015-02-15 00:46:24.000000', 'temperatura', 763.0000, 'ºC'),
	(54139, 108, '2015-02-15 00:46:25.000000', 'temperatura', 1068.0000, 'ºC'),
	(54140, 108, '2015-02-15 00:46:26.000000', 'temperatura', 653.0000, 'ºC'),
	(54141, 108, '2015-02-15 00:46:27.000000', 'temperatura', 60.0000, 'ºC'),
	(54142, 108, '2015-02-15 00:46:28.000000', 'temperatura', 743.0000, 'ºC'),
	(54143, 108, '2015-02-15 00:46:29.000000', 'temperatura', 1135.0000, 'ºC'),
	(54144, 108, '2015-02-15 00:46:30.000000', 'temperatura', 1046.0000, 'ºC'),
	(54145, 108, '2015-02-15 00:46:31.000000', 'temperatura', 624.0000, 'ºC'),
	(54146, 108, '2015-02-15 00:46:32.000000', 'temperatura', 1183.0000, 'ºC'),
	(54147, 108, '2015-02-15 00:46:33.000000', 'temperatura', 444.0000, 'ºC'),
	(54148, 108, '2015-02-15 00:46:34.000000', 'temperatura', 1073.0000, 'ºC'),
	(54149, 108, '2015-02-15 00:46:35.000000', 'temperatura', 431.0000, 'ºC'),
	(54150, 108, '2015-02-15 00:46:36.000000', 'temperatura', 139.0000, 'ºC'),
	(54151, 108, '2015-02-15 00:46:37.000000', 'temperatura', 602.0000, 'ºC'),
	(54152, 108, '2015-02-15 00:46:38.000000', 'temperatura', 194.0000, 'ºC'),
	(54153, 108, '2015-02-15 00:46:39.000000', 'temperatura', 365.0000, 'ºC'),
	(54154, 108, '2015-02-15 00:46:40.000000', 'temperatura', 41.0000, 'ºC'),
	(54155, 108, '2015-02-15 00:46:41.000000', 'temperatura', 312.0000, 'ºC'),
	(54156, 108, '2015-02-15 00:46:42.000000', 'temperatura', 239.0000, 'ºC'),
	(54157, 108, '2015-02-15 00:46:43.000000', 'temperatura', 256.0000, 'ºC'),
	(54158, 108, '2015-02-15 00:46:44.000000', 'temperatura', 567.0000, 'ºC'),
	(54159, 108, '2015-02-15 00:46:45.000000', 'temperatura', 865.0000, 'ºC'),
	(54160, 108, '2015-02-15 00:46:46.000000', 'temperatura', 226.0000, 'ºC'),
	(54161, 108, '2015-02-15 00:46:47.000000', 'temperatura', 934.0000, 'ºC'),
	(54162, 108, '2015-02-15 00:46:48.000000', 'temperatura', 393.0000, 'ºC'),
	(54163, 108, '2015-02-15 00:46:49.000000', 'temperatura', 365.0000, 'ºC'),
	(54164, 108, '2015-02-15 00:46:50.000000', 'temperatura', 647.0000, 'ºC'),
	(54165, 108, '2015-02-15 00:46:51.000000', 'temperatura', 939.0000, 'ºC'),
	(54166, 108, '2015-02-15 00:46:52.000000', 'temperatura', 355.0000, 'ºC'),
	(54167, 108, '2015-02-15 00:46:53.000000', 'temperatura', 158.0000, 'ºC'),
	(54168, 108, '2015-02-15 00:46:54.000000', 'temperatura', 925.0000, 'ºC'),
	(54169, 108, '2015-02-15 00:46:55.000000', 'temperatura', 550.0000, 'ºC'),
	(54170, 108, '2015-02-15 00:46:56.000000', 'temperatura', 1179.0000, 'ºC'),
	(54171, 108, '2015-02-15 00:46:57.000000', 'temperatura', 644.0000, 'ºC'),
	(54172, 108, '2015-02-15 00:46:58.000000', 'temperatura', 885.0000, 'ºC'),
	(54173, 108, '2015-02-15 00:46:59.000000', 'temperatura', 91.0000, 'ºC'),
	(54174, 108, '2015-02-15 00:47:00.000000', 'temperatura', 201.0000, 'ºC'),
	(54175, 108, '2015-02-15 00:47:01.000000', 'temperatura', 735.0000, 'ºC'),
	(54176, 108, '2015-02-15 00:47:02.000000', 'temperatura', 671.0000, 'ºC'),
	(54177, 108, '2015-02-15 00:47:03.000000', 'temperatura', 1151.0000, 'ºC'),
	(54178, 108, '2015-02-15 00:47:04.000000', 'temperatura', 142.0000, 'ºC'),
	(54179, 108, '2015-02-15 00:47:05.000000', 'temperatura', 857.0000, 'ºC'),
	(54180, 108, '2015-02-15 00:47:06.000000', 'temperatura', 260.0000, 'ºC'),
	(54181, 108, '2015-02-15 00:47:07.000000', 'temperatura', 1130.0000, 'ºC'),
	(54182, 108, '2015-02-15 00:47:08.000000', 'temperatura', 71.0000, 'ºC'),
	(54183, 108, '2015-02-15 00:47:09.000000', 'temperatura', 567.0000, 'ºC'),
	(54184, 108, '2015-02-15 00:47:10.000000', 'temperatura', 219.0000, 'ºC'),
	(54185, 108, '2015-02-15 00:47:11.000000', 'temperatura', 596.0000, 'ºC'),
	(54186, 108, '2015-02-15 00:47:12.000000', 'temperatura', 1124.0000, 'ºC'),
	(54187, 108, '2015-02-15 00:47:13.000000', 'temperatura', 232.0000, 'ºC'),
	(54188, 108, '2015-02-15 00:47:14.000000', 'temperatura', 190.0000, 'ºC'),
	(54189, 108, '2015-02-15 00:47:15.000000', 'temperatura', 255.0000, 'ºC'),
	(54190, 108, '2015-02-15 00:47:16.000000', 'temperatura', 707.0000, 'ºC'),
	(54191, 108, '2015-02-15 00:47:17.000000', 'temperatura', 367.0000, 'ºC'),
	(54192, 108, '2015-02-15 00:47:18.000000', 'temperatura', 915.0000, 'ºC'),
	(54193, 108, '2015-02-15 00:47:19.000000', 'temperatura', 1073.0000, 'ºC'),
	(54194, 108, '2015-02-15 00:47:20.000000', 'temperatura', 223.0000, 'ºC'),
	(54195, 108, '2015-02-15 00:47:21.000000', 'temperatura', 295.0000, 'ºC'),
	(54196, 108, '2015-02-15 00:47:22.000000', 'temperatura', 808.0000, 'ºC'),
	(54197, 108, '2015-02-15 00:47:23.000000', 'temperatura', 753.0000, 'ºC'),
	(54198, 108, '2015-02-15 00:47:24.000000', 'temperatura', 144.0000, 'ºC'),
	(54199, 108, '2015-02-15 00:47:25.000000', 'temperatura', 860.0000, 'ºC'),
	(54200, 108, '2015-02-15 00:47:26.000000', 'temperatura', 270.0000, 'ºC'),
	(54201, 108, '2015-02-15 00:47:27.000000', 'temperatura', 1168.0000, 'ºC'),
	(54202, 108, '2015-02-15 00:47:28.000000', 'temperatura', 231.0000, 'ºC'),
	(54203, 108, '2015-02-15 00:47:29.000000', 'temperatura', 51.0000, 'ºC'),
	(54204, 108, '2015-02-15 00:47:30.000000', 'temperatura', 761.0000, 'ºC'),
	(54205, 108, '2015-02-15 00:47:31.000000', 'temperatura', 55.0000, 'ºC'),
	(54206, 108, '2015-02-15 00:47:32.000000', 'temperatura', 392.0000, 'ºC'),
	(54207, 108, '2015-02-15 00:47:33.000000', 'temperatura', 596.0000, 'ºC'),
	(54208, 108, '2015-02-15 00:47:34.000000', 'temperatura', 604.0000, 'ºC'),
	(54209, 108, '2015-02-15 00:47:35.000000', 'temperatura', 32.0000, 'ºC'),
	(54210, 108, '2015-02-15 00:47:36.000000', 'temperatura', 749.0000, 'ºC'),
	(54211, 108, '2015-02-15 00:47:37.000000', 'temperatura', 48.0000, 'ºC'),
	(54212, 108, '2015-02-15 00:47:38.000000', 'temperatura', 394.0000, 'ºC'),
	(54213, 108, '2015-02-15 00:47:39.000000', 'temperatura', 627.0000, 'ºC'),
	(54214, 108, '2015-02-15 00:47:40.000000', 'temperatura', 751.0000, 'ºC'),
	(54215, 108, '2015-02-15 00:47:41.000000', 'temperatura', 678.0000, 'ºC'),
	(54216, 108, '2015-02-15 00:47:42.000000', 'temperatura', 1137.0000, 'ºC'),
	(54217, 108, '2015-02-15 00:47:43.000000', 'temperatura', 49.0000, 'ºC'),
	(54218, 108, '2015-02-15 00:47:44.000000', 'temperatura', 437.0000, 'ºC'),
	(54219, 108, '2015-02-15 00:47:45.000000', 'temperatura', 839.0000, 'ºC'),
	(54220, 108, '2015-02-15 00:47:46.000000', 'temperatura', 483.0000, 'ºC'),
	(54221, 108, '2015-02-15 00:47:47.000000', 'temperatura', 1097.0000, 'ºC'),
	(54222, 108, '2015-02-15 00:47:48.000000', 'temperatura', 439.0000, 'ºC'),
	(54223, 108, '2015-02-15 00:47:49.000000', 'temperatura', 106.0000, 'ºC'),
	(54224, 108, '2015-02-15 00:47:50.000000', 'temperatura', 410.0000, 'ºC'),
	(54225, 108, '2015-02-15 00:47:51.000000', 'temperatura', 534.0000, 'ºC'),
	(54226, 108, '2015-02-15 00:47:52.000000', 'temperatura', 241.0000, 'ºC'),
	(54227, 108, '2015-02-15 00:47:53.000000', 'temperatura', 805.0000, 'ºC'),
	(54228, 108, '2015-02-15 00:47:54.000000', 'temperatura', 900.0000, 'ºC'),
	(54229, 108, '2015-02-15 00:47:55.000000', 'temperatura', 884.0000, 'ºC'),
	(54230, 108, '2015-02-15 00:47:56.000000', 'temperatura', 523.0000, 'ºC'),
	(54231, 108, '2015-02-15 00:47:57.000000', 'temperatura', 1164.0000, 'ºC'),
	(54232, 108, '2015-02-15 00:47:58.000000', 'temperatura', 651.0000, 'ºC'),
	(54233, 108, '2015-02-15 00:47:59.000000', 'temperatura', 964.0000, 'ºC'),
	(54234, 108, '2015-02-15 00:48:00.000000', 'temperatura', 465.0000, 'ºC'),
	(54235, 108, '2015-02-15 00:48:01.000000', 'temperatura', 635.0000, 'ºC'),
	(54236, 108, '2015-02-15 00:48:02.000000', 'temperatura', 582.0000, 'ºC'),
	(54237, 108, '2015-02-15 00:48:03.000000', 'temperatura', 1004.0000, 'ºC'),
	(54238, 108, '2015-02-15 00:48:04.000000', 'temperatura', 875.0000, 'ºC'),
	(54239, 108, '2015-02-15 00:48:05.000000', 'temperatura', 162.0000, 'ºC'),
	(54240, 108, '2015-02-15 00:48:06.000000', 'temperatura', 585.0000, 'ºC'),
	(54241, 108, '2015-02-15 00:48:07.000000', 'temperatura', 40.0000, 'ºC'),
	(54242, 108, '2015-02-15 00:48:08.000000', 'temperatura', 844.0000, 'ºC'),
	(54243, 108, '2015-02-15 00:48:09.000000', 'temperatura', 502.0000, 'ºC'),
	(54244, 108, '2015-02-15 00:48:10.000000', 'temperatura', 1178.0000, 'ºC'),
	(54245, 108, '2015-02-15 00:48:11.000000', 'temperatura', 786.0000, 'ºC'),
	(54246, 108, '2015-02-15 00:48:12.000000', 'temperatura', 398.0000, 'ºC'),
	(54247, 108, '2015-02-15 00:48:13.000000', 'temperatura', 830.0000, 'ºC'),
	(54248, 108, '2015-02-15 00:48:14.000000', 'temperatura', 556.0000, 'ºC'),
	(54249, 108, '2015-02-15 00:48:15.000000', 'temperatura', 292.0000, 'ºC'),
	(54250, 108, '2015-02-15 00:48:16.000000', 'temperatura', 990.0000, 'ºC'),
	(54251, 108, '2015-02-15 00:48:17.000000', 'temperatura', 476.0000, 'ºC'),
	(54252, 108, '2015-02-15 00:48:18.000000', 'temperatura', 611.0000, 'ºC'),
	(54253, 108, '2015-02-15 00:48:19.000000', 'temperatura', 426.0000, 'ºC'),
	(54254, 108, '2015-02-15 00:48:20.000000', 'temperatura', 297.0000, 'ºC'),
	(54255, 108, '2015-02-15 00:48:21.000000', 'temperatura', 208.0000, 'ºC'),
	(54256, 108, '2015-02-15 00:48:22.000000', 'temperatura', 149.0000, 'ºC'),
	(54257, 108, '2015-02-15 00:48:23.000000', 'temperatura', 123.0000, 'ºC'),
	(54258, 108, '2015-02-15 00:48:24.000000', 'temperatura', 168.0000, 'ºC'),
	(54259, 108, '2015-02-15 00:48:25.000000', 'temperatura', 471.0000, 'ºC'),
	(54260, 108, '2015-02-15 00:48:26.000000', 'temperatura', 652.0000, 'ºC'),
	(54261, 108, '2015-02-15 00:48:27.000000', 'temperatura', 648.0000, 'ºC'),
	(54262, 108, '2015-02-15 00:48:28.000000', 'temperatura', 83.0000, 'ºC'),
	(54263, 108, '2015-02-15 00:48:29.000000', 'temperatura', 871.0000, 'ºC'),
	(54264, 108, '2015-02-15 00:48:30.000000', 'temperatura', 509.0000, 'ºC'),
	(54265, 108, '2015-02-15 00:48:31.000000', 'temperatura', 1131.0000, 'ºC'),
	(54266, 108, '2015-02-15 00:48:32.000000', 'temperatura', 528.0000, 'ºC'),
	(54267, 108, '2015-02-15 00:48:33.000000', 'temperatura', 449.0000, 'ºC'),
	(54268, 108, '2015-02-15 00:48:34.000000', 'temperatura', 663.0000, 'ºC'),
	(54269, 108, '2015-02-15 00:48:35.000000', 'temperatura', 766.0000, 'ºC'),
	(54270, 108, '2015-02-15 00:48:36.000000', 'temperatura', 642.0000, 'ºC'),
	(54271, 108, '2015-02-15 00:48:37.000000', 'temperatura', 913.0000, 'ºC'),
	(54272, 108, '2015-02-15 00:48:38.000000', 'temperatura', 239.0000, 'ºC'),
	(54273, 108, '2015-02-15 00:48:39.000000', 'temperatura', 858.0000, 'ºC'),
	(54274, 108, '2015-02-15 00:48:40.000000', 'temperatura', 1172.0000, 'ºC'),
	(54275, 108, '2015-02-15 00:48:41.000000', 'temperatura', 886.0000, 'ºC'),
	(54276, 108, '2015-02-15 00:48:42.000000', 'temperatura', 916.0000, 'ºC'),
	(54277, 108, '2015-02-15 00:48:43.000000', 'temperatura', 721.0000, 'ºC'),
	(54278, 108, '2015-02-15 00:48:44.000000', 'temperatura', 856.0000, 'ºC'),
	(54279, 108, '2015-02-15 00:48:45.000000', 'temperatura', 921.0000, 'ºC'),
	(54280, 108, '2015-02-15 00:48:46.000000', 'temperatura', 834.0000, 'ºC'),
	(54281, 108, '2015-02-15 00:48:47.000000', 'temperatura', 209.0000, 'ºC'),
	(54282, 108, '2015-02-15 00:48:48.000000', 'temperatura', 944.0000, 'ºC'),
	(54283, 108, '2015-02-15 00:48:49.000000', 'temperatura', 494.0000, 'ºC'),
	(54284, 108, '2015-02-15 00:48:50.000000', 'temperatura', 839.0000, 'ºC'),
	(54285, 108, '2015-02-15 00:48:51.000000', 'temperatura', 314.0000, 'ºC'),
	(54286, 108, '2015-02-15 00:48:52.000000', 'temperatura', 251.0000, 'ºC'),
	(54287, 108, '2015-02-15 00:48:53.000000', 'temperatura', 313.0000, 'ºC'),
	(54288, 108, '2015-02-15 00:48:54.000000', 'temperatura', 813.0000, 'ºC'),
	(54289, 108, '2015-02-15 00:48:55.000000', 'temperatura', 729.0000, 'ºC'),
	(54290, 108, '2015-02-15 00:48:56.000000', 'temperatura', 4.0000, 'ºC'),
	(54291, 108, '2015-02-15 00:48:57.000000', 'temperatura', 233.0000, 'ºC'),
	(54292, 108, '2015-02-15 00:48:58.000000', 'temperatura', 1155.0000, 'ºC'),
	(54293, 108, '2015-02-15 00:48:59.000000', 'temperatura', 275.0000, 'ºC'),
	(54294, 108, '2015-02-15 00:49:00.000000', 'temperatura', 311.0000, 'ºC'),
	(54295, 108, '2015-02-15 00:49:01.000000', 'temperatura', 730.0000, 'ºC'),
	(54296, 108, '2015-02-15 00:49:02.000000', 'temperatura', 318.0000, 'ºC'),
	(54297, 108, '2015-02-15 00:49:03.000000', 'temperatura', 602.0000, 'ºC'),
	(54298, 108, '2015-02-15 00:49:04.000000', 'temperatura', 857.0000, 'ºC'),
	(54299, 108, '2015-02-15 00:49:05.000000', 'temperatura', 79.0000, 'ºC'),
	(54300, 108, '2015-02-15 00:49:06.000000', 'temperatura', 222.0000, 'ºC'),
	(54301, 108, '2015-02-15 00:49:07.000000', 'temperatura', 877.0000, 'ºC'),
	(54302, 108, '2015-02-15 00:49:08.000000', 'temperatura', 118.0000, 'ºC'),
	(54303, 108, '2015-02-15 00:49:09.000000', 'temperatura', 360.0000, 'ºC'),
	(54304, 108, '2015-02-15 00:49:10.000000', 'temperatura', 246.0000, 'ºC'),
	(54305, 108, '2015-02-15 00:49:11.000000', 'temperatura', 152.0000, 'ºC'),
	(54306, 108, '2015-02-15 00:49:12.000000', 'temperatura', 23.0000, 'ºC'),
	(54307, 108, '2015-02-15 00:49:13.000000', 'temperatura', 859.0000, 'ºC'),
	(54308, 108, '2015-02-15 00:49:14.000000', 'temperatura', 628.0000, 'ºC'),
	(54309, 108, '2015-02-15 00:49:15.000000', 'temperatura', 560.0000, 'ºC'),
	(54310, 108, '2015-02-15 00:49:16.000000', 'temperatura', 919.0000, 'ºC'),
	(54311, 108, '2015-02-15 00:49:17.000000', 'temperatura', 515.0000, 'ºC'),
	(54312, 108, '2015-02-15 00:49:18.000000', 'temperatura', 1017.0000, 'ºC'),
	(54313, 108, '2015-02-15 00:49:19.000000', 'temperatura', 1141.0000, 'ºC'),
	(54314, 108, '2015-02-15 00:49:20.000000', 'temperatura', 255.0000, 'ºC'),
	(54315, 108, '2015-02-15 00:49:21.000000', 'temperatura', 252.0000, 'ºC'),
	(54316, 108, '2015-02-15 00:49:22.000000', 'temperatura', 497.0000, 'ºC'),
	(54317, 108, '2015-02-15 00:49:23.000000', 'temperatura', 529.0000, 'ºC'),
	(54318, 108, '2015-02-15 00:49:24.000000', 'temperatura', 1156.0000, 'ºC'),
	(54319, 108, '2015-02-15 00:49:25.000000', 'temperatura', 593.0000, 'ºC'),
	(54320, 108, '2015-02-15 00:49:26.000000', 'temperatura', 697.0000, 'ºC'),
	(54321, 108, '2015-02-15 00:49:27.000000', 'temperatura', 506.0000, 'ºC'),
	(54322, 108, '2015-02-15 00:49:28.000000', 'temperatura', 440.0000, 'ºC'),
	(54323, 108, '2015-02-15 00:49:29.000000', 'temperatura', 684.0000, 'ºC'),
	(54324, 108, '2015-02-15 00:49:30.000000', 'temperatura', 898.0000, 'ºC'),
	(54325, 108, '2015-02-15 00:49:31.000000', 'temperatura', 38.0000, 'ºC'),
	(54326, 108, '2015-02-15 00:49:32.000000', 'temperatura', 1099.0000, 'ºC'),
	(54327, 108, '2015-02-15 00:49:33.000000', 'temperatura', 578.0000, 'ºC'),
	(54328, 108, '2015-02-15 00:49:34.000000', 'temperatura', 797.0000, 'ºC'),
	(54329, 108, '2015-02-15 00:49:35.000000', 'temperatura', 1051.0000, 'ºC'),
	(54330, 108, '2015-02-15 00:49:36.000000', 'temperatura', 465.0000, 'ºC'),
	(54331, 108, '2015-02-15 00:49:37.000000', 'temperatura', 373.0000, 'ºC'),
	(54332, 108, '2015-02-15 00:49:38.000000', 'temperatura', 468.0000, 'ºC'),
	(54333, 108, '2015-02-15 00:49:39.000000', 'temperatura', 24.0000, 'ºC'),
	(54334, 108, '2015-02-15 00:49:40.000000', 'temperatura', 1115.0000, 'ºC'),
	(54335, 108, '2015-02-15 00:49:41.000000', 'temperatura', 705.0000, 'ºC'),
	(54336, 108, '2015-02-15 00:49:42.000000', 'temperatura', 179.0000, 'ºC'),
	(54337, 108, '2015-02-15 00:49:43.000000', 'temperatura', 1182.0000, 'ºC'),
	(54338, 108, '2015-02-15 00:49:44.000000', 'temperatura', 575.0000, 'ºC'),
	(54339, 108, '2015-02-15 00:49:45.000000', 'temperatura', 526.0000, 'ºC'),
	(54340, 108, '2015-02-15 00:49:46.000000', 'temperatura', 907.0000, 'ºC'),
	(54341, 108, '2015-02-15 00:49:47.000000', 'temperatura', 558.0000, 'ºC'),
	(54342, 108, '2015-02-15 00:49:48.000000', 'temperatura', 68.0000, 'ºC'),
	(54343, 108, '2015-02-15 00:49:49.000000', 'temperatura', 1066.0000, 'ºC'),
	(54344, 108, '2015-02-15 00:49:50.000000', 'temperatura', 326.0000, 'ºC'),
	(54345, 108, '2015-02-15 00:49:51.000000', 'temperatura', 833.0000, 'ºC'),
	(54346, 108, '2015-02-15 00:49:52.000000', 'temperatura', 788.0000, 'ºC'),
	(54347, 108, '2015-02-15 00:49:53.000000', 'temperatura', 240.0000, 'ºC'),
	(54348, 108, '2015-02-15 00:49:54.000000', 'temperatura', 37.0000, 'ºC'),
	(54349, 108, '2015-02-15 00:49:55.000000', 'temperatura', 667.0000, 'ºC'),
	(54350, 108, '2015-02-15 00:49:56.000000', 'temperatura', 823.0000, 'ºC'),
	(54351, 108, '2015-02-15 00:49:57.000000', 'temperatura', 915.0000, 'ºC'),
	(54352, 108, '2015-02-15 00:49:58.000000', 'temperatura', 907.0000, 'ºC'),
	(54353, 108, '2015-02-15 00:49:59.000000', 'temperatura', 592.0000, 'ºC'),
	(54354, 108, '2015-02-15 00:50:00.000000', 'temperatura', 236.0000, 'ºC'),
	(54355, 108, '2015-02-15 00:50:01.000000', 'temperatura', 607.0000, 'ºC'),
	(54356, 108, '2015-02-15 00:50:02.000000', 'temperatura', 1128.0000, 'ºC'),
	(54357, 108, '2015-02-15 00:50:03.000000', 'temperatura', 220.0000, 'ºC'),
	(54358, 108, '2015-02-15 00:50:04.000000', 'temperatura', 116.0000, 'ºC'),
	(54359, 108, '2015-02-15 00:50:05.000000', 'temperatura', 1120.0000, 'ºC'),
	(54360, 108, '2015-02-15 00:50:06.000000', 'temperatura', 454.0000, 'ºC'),
	(54361, 108, '2015-02-15 00:50:07.000000', 'temperatura', 108.0000, 'ºC'),
	(54362, 108, '2015-02-15 00:50:08.000000', 'temperatura', 378.0000, 'ºC'),
	(54363, 108, '2015-02-15 00:50:09.000000', 'temperatura', 366.0000, 'ºC'),
	(54364, 108, '2015-02-15 00:50:10.000000', 'temperatura', 696.0000, 'ºC'),
	(54365, 108, '2015-02-15 00:50:11.000000', 'temperatura', 1182.0000, 'ºC'),
	(54366, 108, '2015-02-15 00:50:12.000000', 'temperatura', 224.0000, 'ºC'),
	(54367, 108, '2015-02-15 00:50:13.000000', 'temperatura', 1174.0000, 'ºC'),
	(54368, 108, '2015-02-15 00:50:14.000000', 'temperatura', 400.0000, 'ºC'),
	(54369, 108, '2015-02-15 00:50:15.000000', 'temperatura', 878.0000, 'ºC'),
	(54370, 108, '2015-02-15 00:50:16.000000', 'temperatura', 791.0000, 'ºC'),
	(54371, 108, '2015-02-15 00:50:17.000000', 'temperatura', 122.0000, 'ºC'),
	(54372, 108, '2015-02-15 00:50:18.000000', 'temperatura', 637.0000, 'ºC'),
	(54373, 108, '2015-02-15 00:50:19.000000', 'temperatura', 419.0000, 'ºC'),
	(54374, 108, '2015-02-15 00:50:20.000000', 'temperatura', 184.0000, 'ºC'),
	(54375, 108, '2015-02-15 00:50:21.000000', 'temperatura', 863.0000, 'ºC'),
	(54376, 108, '2015-02-15 00:50:22.000000', 'temperatura', 163.0000, 'ºC'),
	(54377, 108, '2015-02-15 00:50:23.000000', 'temperatura', 628.0000, 'ºC'),
	(54378, 108, '2015-02-15 00:50:24.000000', 'temperatura', 249.0000, 'ºC'),
	(54379, 108, '2015-02-15 00:50:25.000000', 'temperatura', 563.0000, 'ºC'),
	(54380, 108, '2015-02-15 00:50:26.000000', 'temperatura', 868.0000, 'ºC'),
	(54381, 108, '2015-02-15 00:50:27.000000', 'temperatura', 251.0000, 'ºC'),
	(54382, 108, '2015-02-15 00:50:28.000000', 'temperatura', 1051.0000, 'ºC'),
	(54383, 108, '2015-02-15 00:50:29.000000', 'temperatura', 903.0000, 'ºC'),
	(54384, 108, '2015-02-15 00:50:30.000000', 'temperatura', 161.0000, 'ºC'),
	(54385, 108, '2015-02-15 00:50:31.000000', 'temperatura', 498.0000, 'ºC'),
	(54386, 108, '2015-02-15 00:50:32.000000', 'temperatura', 806.0000, 'ºC'),
	(54387, 108, '2015-02-15 00:50:33.000000', 'temperatura', 139.0000, 'ºC'),
	(54388, 108, '2015-02-15 00:50:34.000000', 'temperatura', 675.0000, 'ºC'),
	(54389, 108, '2015-02-15 00:50:35.000000', 'temperatura', 558.0000, 'ºC'),
	(54390, 108, '2015-02-15 00:50:36.000000', 'temperatura', 768.0000, 'ºC'),
	(54391, 108, '2015-02-15 00:50:37.000000', 'temperatura', 967.0000, 'ºC'),
	(54392, 108, '2015-02-15 00:50:38.000000', 'temperatura', 130.0000, 'ºC'),
	(54393, 108, '2015-02-15 00:50:39.000000', 'temperatura', 152.0000, 'ºC'),
	(54394, 108, '2015-02-15 00:50:40.000000', 'temperatura', 369.0000, 'ºC'),
	(54395, 108, '2015-02-15 00:50:41.000000', 'temperatura', 188.0000, 'ºC'),
	(54396, 108, '2015-02-15 00:50:42.000000', 'temperatura', 1034.0000, 'ºC'),
	(54397, 108, '2015-02-15 00:50:43.000000', 'temperatura', 1006.0000, 'ºC'),
	(54398, 108, '2015-02-15 00:50:44.000000', 'temperatura', 730.0000, 'ºC'),
	(54399, 108, '2015-02-15 00:50:45.000000', 'temperatura', 631.0000, 'ºC'),
	(54400, 108, '2015-02-15 00:50:46.000000', 'temperatura', 965.0000, 'ºC'),
	(54401, 108, '2015-02-15 00:50:47.000000', 'temperatura', 532.0000, 'ºC'),
	(54402, 108, '2015-02-15 00:50:48.000000', 'temperatura', 968.0000, 'ºC'),
	(54403, 108, '2015-02-15 00:50:49.000000', 'temperatura', 844.0000, 'ºC'),
	(54404, 108, '2015-02-15 00:50:50.000000', 'temperatura', 117.0000, 'ºC'),
	(54405, 108, '2015-02-15 00:50:51.000000', 'temperatura', 452.0000, 'ºC'),
	(54406, 108, '2015-02-15 00:50:52.000000', 'temperatura', 711.0000, 'ºC'),
	(54407, 108, '2015-02-15 00:50:53.000000', 'temperatura', 1000.0000, 'ºC'),
	(54408, 108, '2015-02-15 00:50:54.000000', 'temperatura', 467.0000, 'ºC'),
	(54409, 108, '2015-02-15 00:50:55.000000', 'temperatura', 534.0000, 'ºC'),
	(54410, 108, '2015-02-15 00:50:56.000000', 'temperatura', 72.0000, 'ºC'),
	(54411, 108, '2015-02-15 00:50:57.000000', 'temperatura', 1159.0000, 'ºC'),
	(54412, 108, '2015-02-15 00:50:58.000000', 'temperatura', 778.0000, 'ºC'),
	(54413, 108, '2015-02-15 00:50:59.000000', 'temperatura', 413.0000, 'ºC'),
	(54414, 108, '2015-02-15 00:51:00.000000', 'temperatura', 932.0000, 'ºC'),
	(54415, 108, '2015-02-15 00:51:01.000000', 'temperatura', 1021.0000, 'ºC'),
	(54416, 108, '2015-02-15 00:51:02.000000', 'temperatura', 1108.0000, 'ºC'),
	(54417, 108, '2015-02-15 00:51:03.000000', 'temperatura', 80.0000, 'ºC'),
	(54418, 108, '2015-02-15 00:51:04.000000', 'temperatura', 676.0000, 'ºC'),
	(54419, 108, '2015-02-15 00:51:05.000000', 'temperatura', 740.0000, 'ºC'),
	(54420, 108, '2015-02-15 00:51:06.000000', 'temperatura', 475.0000, 'ºC'),
	(54421, 108, '2015-02-15 00:51:07.000000', 'temperatura', 153.0000, 'ºC'),
	(54422, 108, '2015-02-15 00:51:08.000000', 'temperatura', 540.0000, 'ºC'),
	(54423, 108, '2015-02-15 00:51:09.000000', 'temperatura', 1040.0000, 'ºC'),
	(54424, 108, '2015-02-15 00:51:10.000000', 'temperatura', 1184.0000, 'ºC'),
	(54425, 108, '2015-02-15 00:51:11.000000', 'temperatura', 399.0000, 'ºC'),
	(54426, 108, '2015-02-15 00:51:12.000000', 'temperatura', 844.0000, 'ºC'),
	(54427, 108, '2015-02-15 00:51:13.000000', 'temperatura', 621.0000, 'ºC'),
	(54428, 108, '2015-02-15 00:51:14.000000', 'temperatura', 577.0000, 'ºC'),
	(54429, 108, '2015-02-15 00:51:15.000000', 'temperatura', 1020.0000, 'ºC'),
	(54430, 108, '2015-02-15 00:51:16.000000', 'temperatura', 970.0000, 'ºC'),
	(54431, 108, '2015-02-15 00:51:17.000000', 'temperatura', 591.0000, 'ºC'),
	(54432, 108, '2015-02-15 00:51:18.000000', 'temperatura', 46.0000, 'ºC'),
	(54433, 108, '2015-02-15 00:51:19.000000', 'temperatura', 856.0000, 'ºC'),
	(54434, 108, '2015-02-15 00:51:20.000000', 'temperatura', 543.0000, 'ºC'),
	(54435, 108, '2015-02-15 00:51:21.000000', 'temperatura', 149.0000, 'ºC'),
	(54436, 108, '2015-02-15 00:51:22.000000', 'temperatura', 314.0000, 'ºC'),
	(54437, 108, '2015-02-15 00:51:23.000000', 'temperatura', 1124.0000, 'ºC'),
	(54438, 108, '2015-02-15 00:51:24.000000', 'temperatura', 1078.0000, 'ºC'),
	(54439, 108, '2015-02-15 00:51:25.000000', 'temperatura', 819.0000, 'ºC'),
	(54440, 108, '2015-02-15 00:51:26.000000', 'temperatura', 863.0000, 'ºC'),
	(54441, 108, '2015-02-15 00:51:27.000000', 'temperatura', 658.0000, 'ºC'),
	(54442, 108, '2015-02-15 00:51:28.000000', 'temperatura', 700.0000, 'ºC'),
	(54443, 108, '2015-02-15 00:51:29.000000', 'temperatura', 326.0000, 'ºC'),
	(54444, 108, '2015-02-15 00:51:30.000000', 'temperatura', 734.0000, 'ºC'),
	(54445, 108, '2015-02-15 00:51:31.000000', 'temperatura', 289.0000, 'ºC'),
	(54446, 108, '2015-02-15 00:51:32.000000', 'temperatura', 444.0000, 'ºC'),
	(54447, 108, '2015-02-15 00:51:33.000000', 'temperatura', 152.0000, 'ºC'),
	(54448, 108, '2015-02-15 00:51:34.000000', 'temperatura', 631.0000, 'ºC'),
	(54449, 108, '2015-02-15 00:51:35.000000', 'temperatura', 298.0000, 'ºC'),
	(54450, 108, '2015-02-15 00:51:36.000000', 'temperatura', 797.0000, 'ºC'),
	(54451, 108, '2015-02-15 00:51:37.000000', 'temperatura', 691.0000, 'ºC'),
	(54452, 108, '2015-02-15 00:51:38.000000', 'temperatura', 1064.0000, 'ºC'),
	(54453, 108, '2015-02-15 00:51:39.000000', 'temperatura', 848.0000, 'ºC'),
	(54454, 108, '2015-02-15 00:51:40.000000', 'temperatura', 1050.0000, 'ºC'),
	(54455, 108, '2015-02-15 00:51:41.000000', 'temperatura', 305.0000, 'ºC'),
	(54456, 108, '2015-02-15 00:51:42.000000', 'temperatura', 776.0000, 'ºC'),
	(54457, 108, '2015-02-15 00:51:43.000000', 'temperatura', 564.0000, 'ºC'),
	(54458, 108, '2015-02-15 00:51:44.000000', 'temperatura', 495.0000, 'ºC'),
	(54459, 108, '2015-02-15 00:51:45.000000', 'temperatura', 781.0000, 'ºC'),
	(54460, 108, '2015-02-15 00:51:46.000000', 'temperatura', 21.0000, 'ºC'),
	(54461, 108, '2015-02-15 00:51:47.000000', 'temperatura', 163.0000, 'ºC'),
	(54462, 108, '2015-02-15 00:51:48.000000', 'temperatura', 753.0000, 'ºC'),
	(54463, 108, '2015-02-15 00:51:49.000000', 'temperatura', 877.0000, 'ºC'),
	(54464, 108, '2015-02-15 00:51:50.000000', 'temperatura', 928.0000, 'ºC'),
	(54465, 108, '2015-02-15 00:51:51.000000', 'temperatura', 806.0000, 'ºC'),
	(54466, 108, '2015-02-15 00:51:52.000000', 'temperatura', 50.0000, 'ºC'),
	(54467, 108, '2015-02-15 00:51:53.000000', 'temperatura', 231.0000, 'ºC'),
	(54468, 108, '2015-02-15 00:51:54.000000', 'temperatura', 1005.0000, 'ºC'),
	(54469, 108, '2015-02-15 00:51:55.000000', 'temperatura', 733.0000, 'ºC'),
	(54470, 108, '2015-02-15 00:51:56.000000', 'temperatura', 652.0000, 'ºC'),
	(54471, 108, '2015-02-15 00:51:57.000000', 'temperatura', 1060.0000, 'ºC'),
	(54472, 108, '2015-02-15 00:51:58.000000', 'temperatura', 945.0000, 'ºC'),
	(54473, 108, '2015-02-15 00:51:59.000000', 'temperatura', 343.0000, 'ºC'),
	(54474, 108, '2015-02-15 00:52:00.000000', 'temperatura', 84.0000, 'ºC'),
	(54475, 108, '2015-02-15 00:52:01.000000', 'temperatura', 590.0000, 'ºC'),
	(54476, 108, '2015-02-15 00:52:02.000000', 'temperatura', 297.0000, 'ºC'),
	(54477, 108, '2015-02-15 00:52:03.000000', 'temperatura', 915.0000, 'ºC'),
	(54478, 108, '2015-02-15 00:52:04.000000', 'temperatura', 87.0000, 'ºC'),
	(54479, 108, '2015-02-15 00:52:05.000000', 'temperatura', 91.0000, 'ºC'),
	(54480, 108, '2015-02-15 00:52:06.000000', 'temperatura', 192.0000, 'ºC'),
	(54481, 108, '2015-02-15 00:52:07.000000', 'temperatura', 686.0000, 'ºC'),
	(54482, 108, '2015-02-15 00:52:08.000000', 'temperatura', 458.0000, 'ºC'),
	(54483, 108, '2015-02-15 00:52:09.000000', 'temperatura', 233.0000, 'ºC'),
	(54484, 108, '2015-02-15 00:52:10.000000', 'temperatura', 990.0000, 'ºC'),
	(54485, 108, '2015-02-15 00:52:11.000000', 'temperatura', 650.0000, 'ºC'),
	(54486, 108, '2015-02-15 00:52:12.000000', 'temperatura', 282.0000, 'ºC'),
	(54487, 108, '2015-02-15 00:52:13.000000', 'temperatura', 659.0000, 'ºC'),
	(54488, 108, '2015-02-15 00:52:14.000000', 'temperatura', 50.0000, 'ºC'),
	(54489, 108, '2015-02-15 00:52:15.000000', 'temperatura', 674.0000, 'ºC'),
	(54490, 108, '2015-02-15 00:52:16.000000', 'temperatura', 822.0000, 'ºC'),
	(54491, 108, '2015-02-15 00:52:17.000000', 'temperatura', 886.0000, 'ºC'),
	(54492, 108, '2015-02-15 00:52:18.000000', 'temperatura', 767.0000, 'ºC'),
	(54493, 108, '2015-02-15 00:52:19.000000', 'temperatura', 1178.0000, 'ºC'),
	(54494, 108, '2015-02-15 00:52:20.000000', 'temperatura', 1189.0000, 'ºC'),
	(54495, 108, '2015-02-15 00:52:21.000000', 'temperatura', 13.0000, 'ºC'),
	(54496, 108, '2015-02-15 00:52:22.000000', 'temperatura', 95.0000, 'ºC'),
	(54497, 108, '2015-02-15 00:52:23.000000', 'temperatura', 439.0000, 'ºC'),
	(54498, 108, '2015-02-15 00:52:24.000000', 'temperatura', 709.0000, 'ºC'),
	(54499, 108, '2015-02-15 00:52:25.000000', 'temperatura', 1029.0000, 'ºC'),
	(54500, 108, '2015-02-15 00:52:26.000000', 'temperatura', 618.0000, 'ºC'),
	(54501, 108, '2015-02-15 00:52:27.000000', 'temperatura', 3.0000, 'ºC'),
	(54502, 108, '2015-02-15 00:52:28.000000', 'temperatura', 563.0000, 'ºC'),
	(54503, 108, '2015-02-15 00:52:29.000000', 'temperatura', 406.0000, 'ºC'),
	(54504, 108, '2015-02-15 00:52:30.000000', 'temperatura', 342.0000, 'ºC'),
	(54505, 108, '2015-02-15 00:52:31.000000', 'temperatura', 492.0000, 'ºC'),
	(54506, 108, '2015-02-15 00:52:32.000000', 'temperatura', 234.0000, 'ºC'),
	(54507, 108, '2015-02-15 00:52:33.000000', 'temperatura', 895.0000, 'ºC'),
	(54508, 108, '2015-02-15 00:52:34.000000', 'temperatura', 172.0000, 'ºC'),
	(54509, 108, '2015-02-15 00:52:35.000000', 'temperatura', 575.0000, 'ºC'),
	(54510, 108, '2015-02-15 00:52:36.000000', 'temperatura', 1159.0000, 'ºC'),
	(54511, 108, '2015-02-15 00:52:37.000000', 'temperatura', 472.0000, 'ºC'),
	(54512, 108, '2015-02-15 00:52:38.000000', 'temperatura', 85.0000, 'ºC'),
	(54513, 108, '2015-02-15 00:52:39.000000', 'temperatura', 209.0000, 'ºC'),
	(54514, 108, '2015-02-15 00:52:40.000000', 'temperatura', 791.0000, 'ºC'),
	(54515, 108, '2015-02-15 00:52:41.000000', 'temperatura', 927.0000, 'ºC'),
	(54516, 108, '2015-02-15 00:52:42.000000', 'temperatura', 1063.0000, 'ºC'),
	(54517, 108, '2015-02-15 00:52:43.000000', 'temperatura', 136.0000, 'ºC'),
	(54518, 108, '2015-02-15 00:52:44.000000', 'temperatura', 1092.0000, 'ºC'),
	(54519, 108, '2015-02-15 00:52:45.000000', 'temperatura', 250.0000, 'ºC'),
	(54520, 108, '2015-02-15 00:52:46.000000', 'temperatura', 377.0000, 'ºC'),
	(54521, 108, '2015-02-15 00:52:47.000000', 'temperatura', 1134.0000, 'ºC'),
	(54522, 108, '2015-02-15 00:52:48.000000', 'temperatura', 939.0000, 'ºC'),
	(54523, 108, '2015-02-15 00:52:49.000000', 'temperatura', 94.0000, 'ºC'),
	(54524, 108, '2015-02-15 00:52:50.000000', 'temperatura', 52.0000, 'ºC'),
	(54525, 108, '2015-02-15 00:52:51.000000', 'temperatura', 1179.0000, 'ºC'),
	(54526, 108, '2015-02-15 00:52:52.000000', 'temperatura', 942.0000, 'ºC'),
	(54527, 108, '2015-02-15 00:52:53.000000', 'temperatura', 1170.0000, 'ºC'),
	(54528, 108, '2015-02-15 00:52:54.000000', 'temperatura', 628.0000, 'ºC'),
	(54529, 108, '2015-02-15 00:52:55.000000', 'temperatura', 827.0000, 'ºC'),
	(54530, 108, '2015-02-15 00:52:56.000000', 'temperatura', 1053.0000, 'ºC'),
	(54531, 108, '2015-02-15 00:52:57.000000', 'temperatura', 384.0000, 'ºC'),
	(54532, 108, '2015-02-15 00:52:58.000000', 'temperatura', 1163.0000, 'ºC'),
	(54533, 108, '2015-02-15 00:52:59.000000', 'temperatura', 1063.0000, 'ºC'),
	(54534, 108, '2015-02-15 00:53:00.000000', 'temperatura', 628.0000, 'ºC'),
	(54535, 108, '2015-02-15 00:53:01.000000', 'temperatura', 1151.0000, 'ºC'),
	(54536, 108, '2015-02-15 00:53:02.000000', 'temperatura', 270.0000, 'ºC'),
	(54537, 108, '2015-02-15 00:53:03.000000', 'temperatura', 296.0000, 'ºC'),
	(54538, 108, '2015-02-15 00:53:04.000000', 'temperatura', 674.0000, 'ºC'),
	(54539, 108, '2015-02-15 00:53:05.000000', 'temperatura', 80.0000, 'ºC'),
	(54540, 108, '2015-02-15 00:53:06.000000', 'temperatura', 779.0000, 'ºC'),
	(54541, 108, '2015-02-15 00:53:07.000000', 'temperatura', 57.0000, 'ºC'),
	(54542, 108, '2015-02-15 00:53:08.000000', 'temperatura', 348.0000, 'ºC'),
	(54543, 108, '2015-02-15 00:53:09.000000', 'temperatura', 369.0000, 'ºC'),
	(54544, 108, '2015-02-15 00:53:10.000000', 'temperatura', 801.0000, 'ºC'),
	(54545, 108, '2015-02-15 00:53:11.000000', 'temperatura', 499.0000, 'ºC'),
	(54546, 108, '2015-02-15 00:53:12.000000', 'temperatura', 93.0000, 'ºC'),
	(54547, 108, '2015-02-15 00:53:13.000000', 'temperatura', 167.0000, 'ºC'),
	(54548, 108, '2015-02-15 00:53:14.000000', 'temperatura', 557.0000, 'ºC'),
	(54549, 108, '2015-02-15 00:53:15.000000', 'temperatura', 1087.0000, 'ºC'),
	(54550, 108, '2015-02-15 00:53:16.000000', 'temperatura', 162.0000, 'ºC'),
	(54551, 108, '2015-02-15 00:53:17.000000', 'temperatura', 1149.0000, 'ºC'),
	(54552, 108, '2015-02-15 00:53:18.000000', 'temperatura', 462.0000, 'ºC'),
	(54553, 108, '2015-02-15 00:53:19.000000', 'temperatura', 61.0000, 'ºC'),
	(54554, 108, '2015-02-15 00:53:20.000000', 'temperatura', 119.0000, 'ºC'),
	(54555, 108, '2015-02-15 00:53:21.000000', 'temperatura', 414.0000, 'ºC'),
	(54556, 108, '2015-02-15 00:53:22.000000', 'temperatura', 515.0000, 'ºC'),
	(54557, 108, '2015-02-15 00:53:23.000000', 'temperatura', 133.0000, 'ºC'),
	(54558, 108, '2015-02-15 00:53:24.000000', 'temperatura', 320.0000, 'ºC'),
	(54559, 108, '2015-02-15 00:53:25.000000', 'temperatura', 1199.0000, 'ºC'),
	(54560, 108, '2015-02-15 00:53:26.000000', 'temperatura', 239.0000, 'ºC'),
	(54561, 108, '2015-02-15 00:53:27.000000', 'temperatura', 1198.0000, 'ºC'),
	(54562, 108, '2015-02-15 00:53:28.000000', 'temperatura', 472.0000, 'ºC'),
	(54563, 108, '2015-02-15 00:53:29.000000', 'temperatura', 1165.0000, 'ºC'),
	(54564, 108, '2015-02-15 00:53:30.000000', 'temperatura', 812.0000, 'ºC'),
	(54565, 108, '2015-02-15 00:53:31.000000', 'temperatura', 564.0000, 'ºC'),
	(54566, 108, '2015-02-15 00:53:32.000000', 'temperatura', 387.0000, 'ºC'),
	(54567, 108, '2015-02-15 00:53:33.000000', 'temperatura', 241.0000, 'ºC'),
	(54568, 108, '2015-02-15 00:53:34.000000', 'temperatura', 44.0000, 'ºC'),
	(54569, 108, '2015-02-15 00:53:35.000000', 'temperatura', 698.0000, 'ºC'),
	(54570, 108, '2015-02-15 00:53:36.000000', 'temperatura', 961.0000, 'ºC'),
	(54571, 108, '2015-02-15 00:53:37.000000', 'temperatura', 309.0000, 'ºC'),
	(54572, 108, '2015-02-15 00:53:38.000000', 'temperatura', 1064.0000, 'ºC'),
	(54573, 108, '2015-02-15 00:53:39.000000', 'temperatura', 793.0000, 'ºC'),
	(54574, 108, '2015-02-15 00:53:40.000000', 'temperatura', 773.0000, 'ºC'),
	(54575, 108, '2015-02-15 00:53:41.000000', 'temperatura', 288.0000, 'ºC'),
	(54576, 108, '2015-02-15 00:53:42.000000', 'temperatura', 319.0000, 'ºC'),
	(54577, 108, '2015-02-15 00:53:43.000000', 'temperatura', 732.0000, 'ºC'),
	(54578, 108, '2015-02-15 00:53:44.000000', 'temperatura', 304.0000, 'ºC'),
	(54579, 108, '2015-02-15 00:53:45.000000', 'temperatura', 526.0000, 'ºC'),
	(54580, 108, '2015-02-15 00:53:46.000000', 'temperatura', 517.0000, 'ºC'),
	(54581, 108, '2015-02-15 00:53:47.000000', 'temperatura', 1007.0000, 'ºC'),
	(54582, 108, '2015-02-15 00:53:48.000000', 'temperatura', 1086.0000, 'ºC'),
	(54583, 108, '2015-02-15 00:53:49.000000', 'temperatura', 10.0000, 'ºC'),
	(54584, 108, '2015-02-15 00:53:50.000000', 'temperatura', 391.0000, 'ºC'),
	(54585, 108, '2015-02-15 00:53:51.000000', 'temperatura', 725.0000, 'ºC'),
	(54586, 108, '2015-02-15 00:53:52.000000', 'temperatura', 55.0000, 'ºC'),
	(54587, 108, '2015-02-15 00:53:53.000000', 'temperatura', 498.0000, 'ºC'),
	(54588, 108, '2015-02-15 00:53:54.000000', 'temperatura', 1125.0000, 'ºC'),
	(54589, 108, '2015-02-15 00:53:55.000000', 'temperatura', 532.0000, 'ºC'),
	(54590, 108, '2015-02-15 00:53:56.000000', 'temperatura', 485.0000, 'ºC'),
	(54591, 108, '2015-02-15 00:53:57.000000', 'temperatura', 832.0000, 'ºC'),
	(54592, 108, '2015-02-15 00:53:58.000000', 'temperatura', 305.0000, 'ºC'),
	(54593, 108, '2015-02-15 00:53:59.000000', 'temperatura', 229.0000, 'ºC'),
	(54594, 108, '2015-02-15 00:54:00.000000', 'temperatura', 231.0000, 'ºC'),
	(54595, 108, '2015-02-15 00:54:01.000000', 'temperatura', 467.0000, 'ºC'),
	(54596, 108, '2015-02-15 00:54:02.000000', 'temperatura', 444.0000, 'ºC'),
	(54597, 108, '2015-02-15 00:54:03.000000', 'temperatura', 820.0000, 'ºC'),
	(54598, 108, '2015-02-15 00:54:04.000000', 'temperatura', 368.0000, 'ºC'),
	(54599, 108, '2015-02-15 00:54:05.000000', 'temperatura', 581.0000, 'ºC'),
	(54600, 108, '2015-02-15 00:54:06.000000', 'temperatura', 601.0000, 'ºC'),
	(54601, 108, '2015-02-15 00:54:07.000000', 'temperatura', 62.0000, 'ºC'),
	(54602, 108, '2015-02-15 00:54:08.000000', 'temperatura', 906.0000, 'ºC'),
	(54603, 108, '2015-02-15 00:54:09.000000', 'temperatura', 746.0000, 'ºC'),
	(54604, 108, '2015-02-15 00:54:10.000000', 'temperatura', 1011.0000, 'ºC'),
	(54605, 108, '2015-02-15 00:54:11.000000', 'temperatura', 417.0000, 'ºC'),
	(54606, 108, '2015-02-15 00:54:12.000000', 'temperatura', 252.0000, 'ºC'),
	(54607, 108, '2015-02-15 00:54:13.000000', 'temperatura', 9.0000, 'ºC'),
	(54608, 108, '2015-02-15 00:54:14.000000', 'temperatura', 489.0000, 'ºC'),
	(54609, 108, '2015-02-15 00:54:15.000000', 'temperatura', 19.0000, 'ºC'),
	(54610, 108, '2015-02-15 00:54:16.000000', 'temperatura', 1028.0000, 'ºC'),
	(54611, 108, '2015-02-15 00:54:17.000000', 'temperatura', 283.0000, 'ºC'),
	(54612, 108, '2015-02-15 00:54:18.000000', 'temperatura', 732.0000, 'ºC'),
	(54613, 108, '2015-02-15 00:54:19.000000', 'temperatura', 412.0000, 'ºC'),
	(54614, 108, '2015-02-15 00:54:20.000000', 'temperatura', 1066.0000, 'ºC'),
	(54615, 108, '2015-02-15 00:54:21.000000', 'temperatura', 493.0000, 'ºC'),
	(54616, 108, '2015-02-15 00:54:22.000000', 'temperatura', 467.0000, 'ºC'),
	(54617, 108, '2015-02-15 00:54:23.000000', 'temperatura', 858.0000, 'ºC'),
	(54618, 108, '2015-02-15 00:54:24.000000', 'temperatura', 487.0000, 'ºC'),
	(54619, 108, '2015-02-15 00:54:25.000000', 'temperatura', 1064.0000, 'ºC'),
	(54620, 108, '2015-02-15 00:54:26.000000', 'temperatura', 260.0000, 'ºC'),
	(54621, 108, '2015-02-15 00:54:27.000000', 'temperatura', 507.0000, 'ºC'),
	(54622, 108, '2015-02-15 00:54:28.000000', 'temperatura', 554.0000, 'ºC'),
	(54623, 108, '2015-02-15 00:54:29.000000', 'temperatura', 52.0000, 'ºC'),
	(54624, 108, '2015-02-15 00:54:30.000000', 'temperatura', 999.0000, 'ºC'),
	(54625, 108, '2015-02-15 00:54:31.000000', 'temperatura', 38.0000, 'ºC'),
	(54626, 108, '2015-02-15 00:54:32.000000', 'temperatura', 793.0000, 'ºC'),
	(54627, 108, '2015-02-15 00:54:33.000000', 'temperatura', 251.0000, 'ºC'),
	(54628, 108, '2015-02-15 00:54:34.000000', 'temperatura', 79.0000, 'ºC'),
	(54629, 108, '2015-02-15 00:54:35.000000', 'temperatura', 841.0000, 'ºC'),
	(54630, 108, '2015-02-15 00:54:36.000000', 'temperatura', 371.0000, 'ºC'),
	(54631, 108, '2015-02-15 00:54:37.000000', 'temperatura', 530.0000, 'ºC'),
	(54632, 108, '2015-02-15 00:54:38.000000', 'temperatura', 339.0000, 'ºC'),
	(54633, 108, '2015-02-15 00:54:39.000000', 'temperatura', 107.0000, 'ºC'),
	(54634, 108, '2015-02-15 00:54:40.000000', 'temperatura', 716.0000, 'ºC'),
	(54635, 108, '2015-02-15 00:54:41.000000', 'temperatura', 862.0000, 'ºC'),
	(54636, 108, '2015-02-15 00:54:42.000000', 'temperatura', 961.0000, 'ºC'),
	(54637, 108, '2015-02-15 00:54:43.000000', 'temperatura', 1021.0000, 'ºC'),
	(54638, 108, '2015-02-15 00:54:44.000000', 'temperatura', 1023.0000, 'ºC'),
	(54639, 108, '2015-02-15 00:54:45.000000', 'temperatura', 853.0000, 'ºC'),
	(54640, 108, '2015-02-15 00:54:46.000000', 'temperatura', 1195.0000, 'ºC'),
	(54641, 108, '2015-02-15 00:54:47.000000', 'temperatura', 1019.0000, 'ºC'),
	(54642, 108, '2015-02-15 00:54:48.000000', 'temperatura', 308.0000, 'ºC'),
	(54643, 108, '2015-02-15 00:54:49.000000', 'temperatura', 886.0000, 'ºC'),
	(54644, 108, '2015-02-15 00:54:50.000000', 'temperatura', 1104.0000, 'ºC'),
	(54645, 108, '2015-02-15 00:54:51.000000', 'temperatura', 465.0000, 'ºC'),
	(54646, 108, '2015-02-15 00:54:52.000000', 'temperatura', 212.0000, 'ºC'),
	(54647, 108, '2015-02-15 00:54:53.000000', 'temperatura', 867.0000, 'ºC'),
	(54648, 108, '2015-02-15 00:54:54.000000', 'temperatura', 97.0000, 'ºC'),
	(54649, 108, '2015-02-15 00:54:55.000000', 'temperatura', 288.0000, 'ºC'),
	(54650, 108, '2015-02-15 00:54:56.000000', 'temperatura', 1146.0000, 'ºC'),
	(54651, 108, '2015-02-15 00:54:57.000000', 'temperatura', 67.0000, 'ºC'),
	(54652, 108, '2015-02-15 00:54:58.000000', 'temperatura', 497.0000, 'ºC'),
	(54653, 108, '2015-02-15 00:54:59.000000', 'temperatura', 1084.0000, 'ºC'),
	(54654, 108, '2015-02-15 00:55:00.000000', 'temperatura', 331.0000, 'ºC'),
	(54655, 108, '2015-02-15 00:55:01.000000', 'temperatura', 803.0000, 'ºC'),
	(54656, 108, '2015-02-15 00:55:02.000000', 'temperatura', 621.0000, 'ºC'),
	(54657, 108, '2015-02-15 00:55:03.000000', 'temperatura', 697.0000, 'ºC'),
	(54658, 108, '2015-02-15 00:55:04.000000', 'temperatura', 421.0000, 'ºC'),
	(54659, 108, '2015-02-15 00:55:05.000000', 'temperatura', 17.0000, 'ºC'),
	(54660, 108, '2015-02-15 00:55:06.000000', 'temperatura', 20.0000, 'ºC'),
	(54661, 108, '2015-02-15 00:55:07.000000', 'temperatura', 51.0000, 'ºC'),
	(54662, 108, '2015-02-15 00:55:08.000000', 'temperatura', 194.0000, 'ºC'),
	(54663, 108, '2015-02-15 00:55:09.000000', 'temperatura', 818.0000, 'ºC'),
	(54664, 108, '2015-02-15 00:55:10.000000', 'temperatura', 1107.0000, 'ºC'),
	(54665, 108, '2015-02-15 00:55:11.000000', 'temperatura', 682.0000, 'ºC'),
	(54666, 108, '2015-02-15 00:55:12.000000', 'temperatura', 90.0000, 'ºC'),
	(54667, 108, '2015-02-15 00:55:13.000000', 'temperatura', 803.0000, 'ºC'),
	(54668, 108, '2015-02-15 00:55:14.000000', 'temperatura', 145.0000, 'ºC'),
	(54669, 108, '2015-02-15 00:55:15.000000', 'temperatura', 719.0000, 'ºC'),
	(54670, 108, '2015-02-15 00:55:16.000000', 'temperatura', 759.0000, 'ºC'),
	(54671, 108, '2015-02-15 00:55:17.000000', 'temperatura', 440.0000, 'ºC'),
	(54672, 108, '2015-02-15 00:55:18.000000', 'temperatura', 1124.0000, 'ºC'),
	(54673, 108, '2015-02-15 00:55:19.000000', 'temperatura', 701.0000, 'ºC'),
	(54674, 108, '2015-02-15 00:55:20.000000', 'temperatura', 134.0000, 'ºC'),
	(54675, 108, '2015-02-15 00:55:21.000000', 'temperatura', 968.0000, 'ºC'),
	(54676, 108, '2015-02-15 00:55:22.000000', 'temperatura', 838.0000, 'ºC'),
	(54677, 108, '2015-02-15 00:55:23.000000', 'temperatura', 86.0000, 'ºC'),
	(54678, 108, '2015-02-15 00:55:24.000000', 'temperatura', 318.0000, 'ºC'),
	(54679, 108, '2015-02-15 00:55:25.000000', 'temperatura', 131.0000, 'ºC'),
	(54680, 108, '2015-02-15 00:55:26.000000', 'temperatura', 902.0000, 'ºC'),
	(54681, 108, '2015-02-15 00:55:27.000000', 'temperatura', 517.0000, 'ºC'),
	(54682, 108, '2015-02-15 00:55:28.000000', 'temperatura', 1078.0000, 'ºC'),
	(54683, 108, '2015-02-15 00:55:29.000000', 'temperatura', 242.0000, 'ºC'),
	(54684, 108, '2015-02-15 00:55:30.000000', 'temperatura', 376.0000, 'ºC'),
	(54685, 108, '2015-02-15 00:55:31.000000', 'temperatura', 1155.0000, 'ºC'),
	(54686, 108, '2015-02-15 00:55:32.000000', 'temperatura', 1045.0000, 'ºC'),
	(54687, 108, '2015-02-15 00:55:33.000000', 'temperatura', 564.0000, 'ºC'),
	(54688, 108, '2015-02-15 00:55:34.000000', 'temperatura', 883.0000, 'ºC'),
	(54689, 108, '2015-02-15 00:55:35.000000', 'temperatura', 325.0000, 'ºC'),
	(54690, 108, '2015-02-15 00:55:36.000000', 'temperatura', 174.0000, 'ºC'),
	(54691, 108, '2015-02-15 00:55:37.000000', 'temperatura', 1097.0000, 'ºC'),
	(54692, 108, '2015-02-15 00:55:38.000000', 'temperatura', 164.0000, 'ºC'),
	(54693, 108, '2015-02-15 00:55:39.000000', 'temperatura', 1131.0000, 'ºC'),
	(54694, 108, '2015-02-15 00:55:40.000000', 'temperatura', 362.0000, 'ºC'),
	(54695, 108, '2015-02-15 00:55:41.000000', 'temperatura', 818.0000, 'ºC'),
	(54696, 108, '2015-02-15 00:55:42.000000', 'temperatura', 604.0000, 'ºC'),
	(54697, 108, '2015-02-15 00:55:43.000000', 'temperatura', 565.0000, 'ºC'),
	(54698, 108, '2015-02-15 00:55:44.000000', 'temperatura', 1015.0000, 'ºC'),
	(54699, 108, '2015-02-15 00:55:45.000000', 'temperatura', 979.0000, 'ºC'),
	(54700, 108, '2015-02-15 00:55:46.000000', 'temperatura', 650.0000, 'ºC'),
	(54701, 108, '2015-02-15 00:55:47.000000', 'temperatura', 312.0000, 'ºC'),
	(54702, 108, '2015-02-15 00:55:48.000000', 'temperatura', 814.0000, 'ºC'),
	(54703, 108, '2015-02-15 00:55:49.000000', 'temperatura', 733.0000, 'ºC'),
	(54704, 108, '2015-02-15 00:55:50.000000', 'temperatura', 25.0000, 'ºC'),
	(54705, 108, '2015-02-15 00:55:51.000000', 'temperatura', 327.0000, 'ºC'),
	(54706, 108, '2015-02-15 00:55:52.000000', 'temperatura', 361.0000, 'ºC'),
	(54707, 108, '2015-02-15 00:55:53.000000', 'temperatura', 822.0000, 'ºC'),
	(54708, 108, '2015-02-15 00:55:54.000000', 'temperatura', 628.0000, 'ºC'),
	(54709, 108, '2015-02-15 00:55:55.000000', 'temperatura', 675.0000, 'ºC'),
	(54710, 108, '2015-02-15 00:55:56.000000', 'temperatura', 290.0000, 'ºC'),
	(54711, 108, '2015-02-15 00:55:57.000000', 'temperatura', 627.0000, 'ºC'),
	(54712, 108, '2015-02-15 00:55:58.000000', 'temperatura', 1067.0000, 'ºC'),
	(54713, 108, '2015-02-15 00:55:59.000000', 'temperatura', 1052.0000, 'ºC'),
	(54714, 108, '2015-02-15 00:56:00.000000', 'temperatura', 861.0000, 'ºC'),
	(54715, 108, '2015-02-15 00:56:01.000000', 'temperatura', 1149.0000, 'ºC'),
	(54716, 108, '2015-02-15 00:56:02.000000', 'temperatura', 762.0000, 'ºC'),
	(54717, 108, '2015-02-15 00:56:03.000000', 'temperatura', 362.0000, 'ºC'),
	(54718, 108, '2015-02-15 00:56:04.000000', 'temperatura', 727.0000, 'ºC'),
	(54719, 108, '2015-02-15 00:56:05.000000', 'temperatura', 149.0000, 'ºC'),
	(54720, 108, '2015-02-15 00:56:06.000000', 'temperatura', 963.0000, 'ºC'),
	(54721, 108, '2015-02-15 00:56:07.000000', 'temperatura', 769.0000, 'ºC'),
	(54722, 108, '2015-02-15 00:56:08.000000', 'temperatura', 959.0000, 'ºC'),
	(54723, 108, '2015-02-15 00:56:09.000000', 'temperatura', 86.0000, 'ºC'),
	(54724, 108, '2015-02-15 00:56:10.000000', 'temperatura', 1154.0000, 'ºC'),
	(54725, 108, '2015-02-15 00:56:11.000000', 'temperatura', 711.0000, 'ºC'),
	(54726, 108, '2015-02-15 00:56:12.000000', 'temperatura', 94.0000, 'ºC'),
	(54727, 108, '2015-02-15 00:56:13.000000', 'temperatura', 740.0000, 'ºC'),
	(54728, 108, '2015-02-15 00:56:14.000000', 'temperatura', 1015.0000, 'ºC'),
	(54729, 108, '2015-02-15 00:56:15.000000', 'temperatura', 458.0000, 'ºC'),
	(54730, 108, '2015-02-15 00:56:16.000000', 'temperatura', 445.0000, 'ºC'),
	(54731, 108, '2015-02-15 00:56:17.000000', 'temperatura', 850.0000, 'ºC'),
	(54732, 108, '2015-02-15 00:56:18.000000', 'temperatura', 518.0000, 'ºC'),
	(54733, 108, '2015-02-15 00:56:19.000000', 'temperatura', 38.0000, 'ºC'),
	(54734, 108, '2015-02-15 00:56:20.000000', 'temperatura', 1036.0000, 'ºC'),
	(54735, 108, '2015-02-15 00:56:21.000000', 'temperatura', 268.0000, 'ºC'),
	(54736, 108, '2015-02-15 00:56:22.000000', 'temperatura', 634.0000, 'ºC'),
	(54737, 108, '2015-02-15 00:56:23.000000', 'temperatura', 1165.0000, 'ºC'),
	(54738, 108, '2015-02-15 00:56:24.000000', 'temperatura', 323.0000, 'ºC'),
	(54739, 108, '2015-02-15 00:56:25.000000', 'temperatura', 520.0000, 'ºC'),
	(54740, 108, '2015-02-15 00:56:26.000000', 'temperatura', 434.0000, 'ºC'),
	(54741, 108, '2015-02-15 00:56:27.000000', 'temperatura', 610.0000, 'ºC'),
	(54742, 108, '2015-02-15 00:56:28.000000', 'temperatura', 546.0000, 'ºC'),
	(54743, 108, '2015-02-15 00:56:29.000000', 'temperatura', 902.0000, 'ºC'),
	(54744, 108, '2015-02-15 00:56:30.000000', 'temperatura', 473.0000, 'ºC'),
	(54745, 108, '2015-02-15 00:56:31.000000', 'temperatura', 861.0000, 'ºC'),
	(54746, 108, '2015-02-15 00:56:32.000000', 'temperatura', 484.0000, 'ºC'),
	(54747, 108, '2015-02-15 00:56:33.000000', 'temperatura', 1037.0000, 'ºC'),
	(54748, 108, '2015-02-15 00:56:34.000000', 'temperatura', 134.0000, 'ºC'),
	(54749, 108, '2015-02-15 00:56:35.000000', 'temperatura', 1161.0000, 'ºC'),
	(54750, 108, '2015-02-15 00:56:36.000000', 'temperatura', 602.0000, 'ºC'),
	(54751, 108, '2015-02-15 00:56:37.000000', 'temperatura', 728.0000, 'ºC'),
	(54752, 108, '2015-02-15 00:56:38.000000', 'temperatura', 633.0000, 'ºC'),
	(54753, 108, '2015-02-15 00:56:39.000000', 'temperatura', 983.0000, 'ºC'),
	(54754, 108, '2015-02-15 00:56:40.000000', 'temperatura', 617.0000, 'ºC'),
	(54755, 108, '2015-02-15 00:56:41.000000', 'temperatura', 135.0000, 'ºC'),
	(54756, 108, '2015-02-15 00:56:42.000000', 'temperatura', 25.0000, 'ºC'),
	(54757, 108, '2015-02-15 00:56:43.000000', 'temperatura', 919.0000, 'ºC'),
	(54758, 108, '2015-02-15 00:56:44.000000', 'temperatura', 921.0000, 'ºC'),
	(54759, 108, '2015-02-15 00:56:45.000000', 'temperatura', 649.0000, 'ºC'),
	(54760, 108, '2015-02-15 00:56:46.000000', 'temperatura', 484.0000, 'ºC'),
	(54761, 108, '2015-02-15 00:56:47.000000', 'temperatura', 473.0000, 'ºC'),
	(54762, 108, '2015-02-15 00:56:48.000000', 'temperatura', 912.0000, 'ºC'),
	(54763, 108, '2015-02-15 00:56:49.000000', 'temperatura', 741.0000, 'ºC'),
	(54764, 108, '2015-02-15 00:56:50.000000', 'temperatura', 972.0000, 'ºC'),
	(54765, 108, '2015-02-15 00:56:51.000000', 'temperatura', 236.0000, 'ºC'),
	(54766, 108, '2015-02-15 00:56:52.000000', 'temperatura', 665.0000, 'ºC'),
	(54767, 108, '2015-02-15 00:56:53.000000', 'temperatura', 216.0000, 'ºC'),
	(54768, 108, '2015-02-15 00:56:54.000000', 'temperatura', 287.0000, 'ºC'),
	(54769, 108, '2015-02-15 00:56:55.000000', 'temperatura', 789.0000, 'ºC'),
	(54770, 108, '2015-02-15 00:56:56.000000', 'temperatura', 682.0000, 'ºC'),
	(54771, 108, '2015-02-15 00:56:57.000000', 'temperatura', 1042.0000, 'ºC'),
	(54772, 108, '2015-02-15 00:56:58.000000', 'temperatura', 767.0000, 'ºC'),
	(54773, 108, '2015-02-15 00:56:59.000000', 'temperatura', 710.0000, 'ºC'),
	(54774, 108, '2015-02-15 00:57:00.000000', 'temperatura', 48.0000, 'ºC'),
	(54775, 108, '2015-02-15 00:57:01.000000', 'temperatura', 512.0000, 'ºC'),
	(54776, 108, '2015-02-15 00:57:02.000000', 'temperatura', 17.0000, 'ºC'),
	(54777, 108, '2015-02-15 00:57:03.000000', 'temperatura', 947.0000, 'ºC'),
	(54778, 108, '2015-02-15 00:57:04.000000', 'temperatura', 1084.0000, 'ºC'),
	(54779, 108, '2015-02-15 00:57:05.000000', 'temperatura', 182.0000, 'ºC'),
	(54780, 108, '2015-02-15 00:57:06.000000', 'temperatura', 56.0000, 'ºC'),
	(54781, 108, '2015-02-15 00:57:07.000000', 'temperatura', 934.0000, 'ºC'),
	(54782, 108, '2015-02-15 00:57:08.000000', 'temperatura', 903.0000, 'ºC'),
	(54783, 108, '2015-02-15 00:57:09.000000', 'temperatura', 512.0000, 'ºC'),
	(54784, 108, '2015-02-15 00:57:10.000000', 'temperatura', 1054.0000, 'ºC'),
	(54785, 108, '2015-02-15 00:57:11.000000', 'temperatura', 134.0000, 'ºC'),
	(54786, 108, '2015-02-15 00:57:12.000000', 'temperatura', 1108.0000, 'ºC'),
	(54787, 108, '2015-02-15 00:57:13.000000', 'temperatura', 337.0000, 'ºC'),
	(54788, 108, '2015-02-15 00:57:14.000000', 'temperatura', 763.0000, 'ºC'),
	(54789, 108, '2015-02-15 00:57:15.000000', 'temperatura', 404.0000, 'ºC'),
	(54790, 108, '2015-02-15 00:57:16.000000', 'temperatura', 932.0000, 'ºC'),
	(54791, 108, '2015-02-15 00:57:17.000000', 'temperatura', 1048.0000, 'ºC'),
	(54792, 108, '2015-02-15 00:57:18.000000', 'temperatura', 47.0000, 'ºC'),
	(54793, 108, '2015-02-15 00:57:19.000000', 'temperatura', 689.0000, 'ºC'),
	(54794, 108, '2015-02-15 00:57:20.000000', 'temperatura', 904.0000, 'ºC'),
	(54795, 108, '2015-02-15 00:57:21.000000', 'temperatura', 55.0000, 'ºC'),
	(54796, 108, '2015-02-15 00:57:22.000000', 'temperatura', 1164.0000, 'ºC'),
	(54797, 108, '2015-02-15 00:57:23.000000', 'temperatura', 853.0000, 'ºC'),
	(54798, 108, '2015-02-15 00:57:24.000000', 'temperatura', 776.0000, 'ºC'),
	(54799, 108, '2015-02-15 00:57:25.000000', 'temperatura', 120.0000, 'ºC'),
	(54800, 108, '2015-02-15 00:57:26.000000', 'temperatura', 674.0000, 'ºC'),
	(54801, 108, '2015-02-15 00:57:27.000000', 'temperatura', 609.0000, 'ºC'),
	(54802, 108, '2015-02-15 00:57:28.000000', 'temperatura', 1023.0000, 'ºC'),
	(54803, 108, '2015-02-15 00:57:29.000000', 'temperatura', 889.0000, 'ºC'),
	(54804, 108, '2015-02-15 00:57:30.000000', 'temperatura', 178.0000, 'ºC'),
	(54805, 108, '2015-02-15 00:57:31.000000', 'temperatura', 621.0000, 'ºC'),
	(54806, 108, '2015-02-15 00:57:32.000000', 'temperatura', 171.0000, 'ºC'),
	(54807, 108, '2015-02-15 00:57:33.000000', 'temperatura', 194.0000, 'ºC'),
	(54808, 108, '2015-02-15 00:57:34.000000', 'temperatura', 459.0000, 'ºC'),
	(54809, 108, '2015-02-15 00:57:35.000000', 'temperatura', 511.0000, 'ºC'),
	(54810, 108, '2015-02-15 00:57:36.000000', 'temperatura', 1179.0000, 'ºC'),
	(54811, 108, '2015-02-15 00:57:37.000000', 'temperatura', 762.0000, 'ºC'),
	(54812, 108, '2015-02-15 00:57:38.000000', 'temperatura', 276.0000, 'ºC'),
	(54813, 108, '2015-02-15 00:57:39.000000', 'temperatura', 294.0000, 'ºC'),
	(54814, 108, '2015-02-15 00:57:40.000000', 'temperatura', 642.0000, 'ºC'),
	(54815, 108, '2015-02-15 00:57:41.000000', 'temperatura', 1126.0000, 'ºC'),
	(54816, 108, '2015-02-15 00:57:42.000000', 'temperatura', 108.0000, 'ºC'),
	(54817, 108, '2015-02-15 00:57:43.000000', 'temperatura', 760.0000, 'ºC'),
	(54818, 108, '2015-02-15 00:57:44.000000', 'temperatura', 1078.0000, 'ºC'),
	(54819, 108, '2015-02-15 00:57:45.000000', 'temperatura', 711.0000, 'ºC'),
	(54820, 108, '2015-02-15 00:57:46.000000', 'temperatura', 321.0000, 'ºC'),
	(54821, 108, '2015-02-15 00:57:47.000000', 'temperatura', 671.0000, 'ºC'),
	(54822, 108, '2015-02-15 00:57:48.000000', 'temperatura', 1192.0000, 'ºC'),
	(54823, 108, '2015-02-15 00:57:49.000000', 'temperatura', 347.0000, 'ºC'),
	(54824, 108, '2015-02-15 00:57:50.000000', 'temperatura', 560.0000, 'ºC'),
	(54825, 108, '2015-02-15 00:57:51.000000', 'temperatura', 559.0000, 'ºC'),
	(54826, 108, '2015-02-15 00:57:52.000000', 'temperatura', 1118.0000, 'ºC'),
	(54827, 108, '2015-02-15 00:57:53.000000', 'temperatura', 311.0000, 'ºC'),
	(54828, 108, '2015-02-15 00:57:54.000000', 'temperatura', 603.0000, 'ºC'),
	(54829, 108, '2015-02-15 00:57:55.000000', 'temperatura', 880.0000, 'ºC'),
	(54830, 108, '2015-02-15 00:57:56.000000', 'temperatura', 194.0000, 'ºC'),
	(54831, 108, '2015-02-15 00:57:57.000000', 'temperatura', 728.0000, 'ºC'),
	(54832, 108, '2015-02-15 00:57:58.000000', 'temperatura', 659.0000, 'ºC'),
	(54833, 108, '2015-02-15 00:57:59.000000', 'temperatura', 1114.0000, 'ºC'),
	(54834, 108, '2015-02-15 00:58:00.000000', 'temperatura', 1191.0000, 'ºC'),
	(54835, 108, '2015-02-15 00:58:01.000000', 'temperatura', 214.0000, 'ºC'),
	(54836, 108, '2015-02-15 00:58:02.000000', 'temperatura', 1097.0000, 'ºC'),
	(54837, 108, '2015-02-15 00:58:03.000000', 'temperatura', 44.0000, 'ºC'),
	(54838, 108, '2015-02-15 00:58:04.000000', 'temperatura', 529.0000, 'ºC'),
	(54839, 108, '2015-02-15 00:58:05.000000', 'temperatura', 115.0000, 'ºC'),
	(54840, 108, '2015-02-15 00:58:06.000000', 'temperatura', 188.0000, 'ºC'),
	(54841, 108, '2015-02-15 00:58:07.000000', 'temperatura', 596.0000, 'ºC'),
	(54842, 108, '2015-02-15 00:58:08.000000', 'temperatura', 18.0000, 'ºC'),
	(54843, 108, '2015-02-15 00:58:09.000000', 'temperatura', 700.0000, 'ºC'),
	(54844, 108, '2015-02-15 00:58:10.000000', 'temperatura', 1049.0000, 'ºC'),
	(54845, 108, '2015-02-15 00:58:11.000000', 'temperatura', 744.0000, 'ºC'),
	(54846, 108, '2015-02-15 00:58:12.000000', 'temperatura', 572.0000, 'ºC'),
	(54847, 108, '2015-02-15 00:58:13.000000', 'temperatura', 628.0000, 'ºC'),
	(54848, 108, '2015-02-15 00:58:14.000000', 'temperatura', 226.0000, 'ºC'),
	(54849, 108, '2015-02-15 00:58:15.000000', 'temperatura', 445.0000, 'ºC'),
	(54850, 108, '2015-02-15 00:58:16.000000', 'temperatura', 348.0000, 'ºC'),
	(54851, 108, '2015-02-15 00:58:17.000000', 'temperatura', 405.0000, 'ºC'),
	(54852, 108, '2015-02-15 00:58:18.000000', 'temperatura', 981.0000, 'ºC'),
	(54853, 108, '2015-02-15 00:58:19.000000', 'temperatura', 90.0000, 'ºC'),
	(54854, 108, '2015-02-15 00:58:20.000000', 'temperatura', 1108.0000, 'ºC'),
	(54855, 108, '2015-02-15 00:58:21.000000', 'temperatura', 471.0000, 'ºC'),
	(54856, 108, '2015-02-15 00:58:22.000000', 'temperatura', 230.0000, 'ºC'),
	(54857, 108, '2015-02-15 00:58:23.000000', 'temperatura', 937.0000, 'ºC'),
	(54858, 108, '2015-02-15 00:58:24.000000', 'temperatura', 396.0000, 'ºC'),
	(54859, 108, '2015-02-15 00:58:25.000000', 'temperatura', 369.0000, 'ºC'),
	(54860, 108, '2015-02-15 00:58:26.000000', 'temperatura', 656.0000, 'ºC'),
	(54861, 108, '2015-02-15 00:58:27.000000', 'temperatura', 975.0000, 'ºC'),
	(54862, 108, '2015-02-15 00:58:28.000000', 'temperatura', 508.0000, 'ºC'),
	(54863, 108, '2015-02-15 00:58:29.000000', 'temperatura', 816.0000, 'ºC'),
	(54864, 108, '2015-02-15 00:58:30.000000', 'temperatura', 154.0000, 'ºC'),
	(54865, 108, '2015-02-15 00:58:31.000000', 'temperatura', 725.0000, 'ºC'),
	(54866, 108, '2015-02-15 00:58:32.000000', 'temperatura', 763.0000, 'ºC'),
	(54867, 108, '2015-02-15 00:58:33.000000', 'temperatura', 442.0000, 'ºC'),
	(54868, 108, '2015-02-15 00:58:34.000000', 'temperatura', 1120.0000, 'ºC'),
	(54869, 108, '2015-02-15 00:58:35.000000', 'temperatura', 676.0000, 'ºC'),
	(54870, 108, '2015-02-15 00:58:36.000000', 'temperatura', 22.0000, 'ºC'),
	(54871, 108, '2015-02-15 00:58:37.000000', 'temperatura', 479.0000, 'ºC'),
	(54872, 108, '2015-02-15 00:58:38.000000', 'temperatura', 1132.0000, 'ºC'),
	(54873, 108, '2015-02-15 00:58:39.000000', 'temperatura', 624.0000, 'ºC'),
	(54874, 108, '2015-02-15 00:58:40.000000', 'temperatura', 922.0000, 'ºC'),
	(54875, 108, '2015-02-15 00:58:41.000000', 'temperatura', 339.0000, 'ºC'),
	(54876, 108, '2015-02-15 00:58:42.000000', 'temperatura', 129.0000, 'ºC'),
	(54877, 108, '2015-02-15 00:58:43.000000', 'temperatura', 830.0000, 'ºC'),
	(54878, 108, '2015-02-15 00:58:44.000000', 'temperatura', 161.0000, 'ºC'),
	(54879, 108, '2015-02-15 00:58:45.000000', 'temperatura', 719.0000, 'ºC'),
	(54880, 108, '2015-02-15 00:58:46.000000', 'temperatura', 710.0000, 'ºC'),
	(54881, 108, '2015-02-15 00:58:47.000000', 'temperatura', 195.0000, 'ºC'),
	(54882, 108, '2015-02-15 00:58:48.000000', 'temperatura', 45.0000, 'ºC'),
	(54883, 108, '2015-02-15 00:58:49.000000', 'temperatura', 842.0000, 'ºC'),
	(54884, 108, '2015-02-15 00:58:50.000000', 'temperatura', 477.0000, 'ºC'),
	(54885, 108, '2015-02-15 00:58:51.000000', 'temperatura', 1056.0000, 'ºC'),
	(54886, 108, '2015-02-15 00:58:52.000000', 'temperatura', 250.0000, 'ºC'),
	(54887, 108, '2015-02-15 00:58:53.000000', 'temperatura', 482.0000, 'ºC'),
	(54888, 108, '2015-02-15 00:58:54.000000', 'temperatura', 460.0000, 'ºC'),
	(54889, 108, '2015-02-15 00:58:55.000000', 'temperatura', 856.0000, 'ºC'),
	(54890, 108, '2015-02-15 00:58:56.000000', 'temperatura', 502.0000, 'ºC'),
	(54891, 108, '2015-02-15 00:58:57.000000', 'temperatura', 1142.0000, 'ºC'),
	(54892, 108, '2015-02-15 00:58:58.000000', 'temperatura', 602.0000, 'ºC'),
	(54893, 108, '2015-02-15 00:58:59.000000', 'temperatura', 787.0000, 'ºC'),
	(54894, 108, '2015-02-15 00:59:00.000000', 'temperatura', 928.0000, 'ºC'),
	(54895, 108, '2015-02-15 00:59:01.000000', 'temperatura', 1078.0000, 'ºC'),
	(54896, 108, '2015-02-15 00:59:02.000000', 'temperatura', 210.0000, 'ºC'),
	(54897, 108, '2015-02-15 00:59:03.000000', 'temperatura', 213.0000, 'ºC'),
	(54898, 108, '2015-02-15 00:59:04.000000', 'temperatura', 436.0000, 'ºC'),
	(54899, 108, '2015-02-15 00:59:05.000000', 'temperatura', 344.0000, 'ºC'),
	(54900, 108, '2015-02-15 00:59:06.000000', 'temperatura', 410.0000, 'ºC'),
	(54901, 108, '2015-02-15 00:59:07.000000', 'temperatura', 1021.0000, 'ºC'),
	(54902, 108, '2015-02-15 00:59:08.000000', 'temperatura', 272.0000, 'ºC'),
	(54903, 108, '2015-02-15 00:59:09.000000', 'temperatura', 700.0000, 'ºC'),
	(54904, 108, '2015-02-15 00:59:10.000000', 'temperatura', 284.0000, 'ºC'),
	(54905, 108, '2015-02-15 00:59:11.000000', 'temperatura', 523.0000, 'ºC'),
	(54906, 108, '2015-02-15 00:59:12.000000', 'temperatura', 560.0000, 'ºC'),
	(54907, 108, '2015-02-15 00:59:13.000000', 'temperatura', 32.0000, 'ºC'),
	(54908, 108, '2015-02-15 00:59:14.000000', 'temperatura', 880.0000, 'ºC'),
	(54909, 108, '2015-02-15 00:59:15.000000', 'temperatura', 703.0000, 'ºC'),
	(54910, 108, '2015-02-15 00:59:16.000000', 'temperatura', 877.0000, 'ºC'),
	(54911, 108, '2015-02-15 00:59:17.000000', 'temperatura', 1078.0000, 'ºC'),
	(54912, 108, '2015-02-15 00:59:18.000000', 'temperatura', 360.0000, 'ºC'),
	(54913, 108, '2015-02-15 00:59:19.000000', 'temperatura', 967.0000, 'ºC'),
	(54914, 108, '2015-02-15 00:59:20.000000', 'temperatura', 156.0000, 'ºC'),
	(54915, 108, '2015-02-15 00:59:21.000000', 'temperatura', 279.0000, 'ºC'),
	(54916, 108, '2015-02-15 00:59:22.000000', 'temperatura', 928.0000, 'ºC'),
	(54917, 108, '2015-02-15 00:59:23.000000', 'temperatura', 204.0000, 'ºC'),
	(54918, 108, '2015-02-15 00:59:24.000000', 'temperatura', 637.0000, 'ºC'),
	(54919, 108, '2015-02-15 00:59:25.000000', 'temperatura', 174.0000, 'ºC'),
	(54920, 108, '2015-02-15 00:59:26.000000', 'temperatura', 156.0000, 'ºC'),
	(54921, 108, '2015-02-15 00:59:27.000000', 'temperatura', 262.0000, 'ºC'),
	(54922, 108, '2015-02-15 00:59:28.000000', 'temperatura', 841.0000, 'ºC'),
	(54923, 108, '2015-02-15 00:59:29.000000', 'temperatura', 1018.0000, 'ºC'),
	(54924, 108, '2015-02-15 00:59:30.000000', 'temperatura', 169.0000, 'ºC'),
	(54925, 108, '2015-02-15 00:59:31.000000', 'temperatura', 191.0000, 'ºC'),
	(54926, 108, '2015-02-15 00:59:32.000000', 'temperatura', 448.0000, 'ºC'),
	(54927, 108, '2015-02-15 00:59:33.000000', 'temperatura', 467.0000, 'ºC'),
	(54928, 108, '2015-02-15 00:59:34.000000', 'temperatura', 992.0000, 'ºC'),
	(54929, 108, '2015-02-15 00:59:35.000000', 'temperatura', 1159.0000, 'ºC'),
	(54930, 108, '2015-02-15 00:59:36.000000', 'temperatura', 421.0000, 'ºC'),
	(54931, 108, '2015-02-15 00:59:37.000000', 'temperatura', 1029.0000, 'ºC'),
	(54932, 108, '2015-02-15 00:59:38.000000', 'temperatura', 283.0000, 'ºC'),
	(54933, 108, '2015-02-15 00:59:39.000000', 'temperatura', 728.0000, 'ºC'),
	(54934, 108, '2015-02-15 00:59:40.000000', 'temperatura', 392.0000, 'ºC'),
	(54935, 108, '2015-02-15 00:59:41.000000', 'temperatura', 977.0000, 'ºC'),
	(54936, 108, '2015-02-15 00:59:42.000000', 'temperatura', 109.0000, 'ºC'),
	(54937, 108, '2015-02-15 00:59:43.000000', 'temperatura', 16.0000, 'ºC'),
	(54938, 108, '2015-02-15 00:59:44.000000', 'temperatura', 953.0000, 'ºC'),
	(54939, 108, '2015-02-15 00:59:45.000000', 'temperatura', 1117.0000, 'ºC'),
	(54940, 108, '2015-02-15 00:59:46.000000', 'temperatura', 328.0000, 'ºC'),
	(54941, 108, '2015-02-15 00:59:47.000000', 'temperatura', 690.0000, 'ºC'),
	(54942, 108, '2015-02-15 00:59:48.000000', 'temperatura', 66.0000, 'ºC'),
	(54943, 108, '2015-02-15 00:59:49.000000', 'temperatura', 660.0000, 'ºC'),
	(54944, 108, '2015-02-15 00:59:50.000000', 'temperatura', 705.0000, 'ºC'),
	(54945, 108, '2015-02-15 00:59:51.000000', 'temperatura', 342.0000, 'ºC'),
	(54946, 108, '2015-02-15 00:59:52.000000', 'temperatura', 795.0000, 'ºC'),
	(54947, 108, '2015-02-15 00:59:53.000000', 'temperatura', 552.0000, 'ºC'),
	(54948, 108, '2015-02-15 00:59:54.000000', 'temperatura', 376.0000, 'ºC'),
	(54949, 108, '2015-02-15 00:59:55.000000', 'temperatura', 224.0000, 'ºC'),
	(54950, 108, '2015-02-15 00:59:56.000000', 'temperatura', 1194.0000, 'ºC'),
	(54951, 108, '2015-02-15 00:59:57.000000', 'temperatura', 496.0000, 'ºC'),
	(54952, 108, '2015-02-15 00:59:58.000000', 'temperatura', 100.0000, 'ºC'),
	(54953, 108, '2015-02-15 00:59:59.000000', 'temperatura', 212.0000, 'ºC'),
	(54954, 108, '2015-02-15 01:00:00.000000', 'temperatura', 759.0000, 'ºC'),
	(54955, 108, '2015-02-15 01:00:01.000000', 'temperatura', 759.0000, 'ºC'),
	(54956, 108, '2015-02-15 01:00:02.000000', 'temperatura', 318.0000, 'ºC'),
	(54957, 108, '2015-02-15 01:00:03.000000', 'temperatura', 513.0000, 'ºC'),
	(54958, 108, '2015-02-15 01:00:04.000000', 'temperatura', 413.0000, 'ºC'),
	(54959, 108, '2015-02-15 01:00:05.000000', 'temperatura', 528.0000, 'ºC'),
	(54960, 108, '2015-02-15 01:00:06.000000', 'temperatura', 199.0000, 'ºC'),
	(54961, 108, '2015-02-15 01:00:07.000000', 'temperatura', 615.0000, 'ºC'),
	(54962, 108, '2015-02-15 01:00:08.000000', 'temperatura', 75.0000, 'ºC'),
	(54963, 108, '2015-02-15 01:00:09.000000', 'temperatura', 930.0000, 'ºC'),
	(54964, 108, '2015-02-15 01:00:10.000000', 'temperatura', 827.0000, 'ºC'),
	(54965, 108, '2015-02-15 01:00:11.000000', 'temperatura', 147.0000, 'ºC'),
	(54966, 108, '2015-02-15 01:00:12.000000', 'temperatura', 653.0000, 'ºC'),
	(54967, 108, '2015-02-15 01:00:13.000000', 'temperatura', 424.0000, 'ºC'),
	(54968, 108, '2015-02-15 01:00:14.000000', 'temperatura', 161.0000, 'ºC'),
	(54969, 108, '2015-02-15 01:00:15.000000', 'temperatura', 733.0000, 'ºC'),
	(54970, 108, '2015-02-15 01:00:16.000000', 'temperatura', 782.0000, 'ºC'),
	(54971, 108, '2015-02-15 01:00:17.000000', 'temperatura', 513.0000, 'ºC'),
	(54972, 108, '2015-02-15 01:00:18.000000', 'temperatura', 219.0000, 'ºC'),
	(54973, 108, '2015-02-15 01:00:19.000000', 'temperatura', 758.0000, 'ºC'),
	(54974, 108, '2015-02-15 01:00:20.000000', 'temperatura', 732.0000, 'ºC'),
	(54975, 108, '2015-02-15 01:00:21.000000', 'temperatura', 188.0000, 'ºC'),
	(54976, 108, '2015-02-15 01:00:22.000000', 'temperatura', 1144.0000, 'ºC'),
	(54977, 108, '2015-02-15 01:00:23.000000', 'temperatura', 358.0000, 'ºC'),
	(54978, 108, '2015-02-15 01:00:24.000000', 'temperatura', 757.0000, 'ºC'),
	(54979, 108, '2015-02-15 01:00:25.000000', 'temperatura', 312.0000, 'ºC'),
	(54980, 108, '2015-02-15 01:00:26.000000', 'temperatura', 491.0000, 'ºC'),
	(54981, 108, '2015-02-15 01:00:27.000000', 'temperatura', 317.0000, 'ºC'),
	(54982, 108, '2015-02-15 01:00:28.000000', 'temperatura', 112.0000, 'ºC'),
	(54983, 108, '2015-02-15 01:00:29.000000', 'temperatura', 809.0000, 'ºC'),
	(54984, 108, '2015-02-15 01:00:30.000000', 'temperatura', 111.0000, 'ºC'),
	(54985, 108, '2015-02-15 01:00:31.000000', 'temperatura', 529.0000, 'ºC'),
	(54986, 108, '2015-02-15 01:00:32.000000', 'temperatura', 1110.0000, 'ºC'),
	(54987, 108, '2015-02-15 01:00:33.000000', 'temperatura', 365.0000, 'ºC'),
	(54988, 108, '2015-02-15 01:00:34.000000', 'temperatura', 894.0000, 'ºC'),
	(54989, 108, '2015-02-15 01:00:35.000000', 'temperatura', 975.0000, 'ºC'),
	(54990, 108, '2015-02-15 01:00:36.000000', 'temperatura', 996.0000, 'ºC'),
	(54991, 108, '2015-02-15 01:00:37.000000', 'temperatura', 856.0000, 'ºC'),
	(54992, 108, '2015-02-15 01:00:38.000000', 'temperatura', 91.0000, 'ºC'),
	(54993, 108, '2015-02-15 01:00:39.000000', 'temperatura', 287.0000, 'ºC'),
	(54994, 108, '2015-02-15 01:00:40.000000', 'temperatura', 1164.0000, 'ºC'),
	(54995, 108, '2015-02-15 01:00:41.000000', 'temperatura', 160.0000, 'ºC'),
	(54996, 108, '2015-02-15 01:00:42.000000', 'temperatura', 907.0000, 'ºC'),
	(54997, 108, '2015-02-15 01:00:43.000000', 'temperatura', 457.0000, 'ºC'),
	(54998, 108, '2015-02-15 01:00:44.000000', 'temperatura', 764.0000, 'ºC'),
	(54999, 108, '2015-02-15 01:00:45.000000', 'temperatura', 51.0000, 'ºC'),
	(55000, 108, '2015-02-15 01:00:46.000000', 'temperatura', 361.0000, 'ºC'),
	(55001, 108, '2015-02-15 01:00:47.000000', 'temperatura', 455.0000, 'ºC'),
	(55002, 108, '2015-02-15 01:00:48.000000', 'temperatura', 1192.0000, 'ºC'),
	(55003, 108, '2015-02-15 01:00:49.000000', 'temperatura', 996.0000, 'ºC'),
	(55004, 108, '2015-02-15 01:00:50.000000', 'temperatura', 204.0000, 'ºC'),
	(55005, 108, '2015-02-15 01:00:51.000000', 'temperatura', 432.0000, 'ºC'),
	(55006, 108, '2015-02-15 01:00:52.000000', 'temperatura', 348.0000, 'ºC'),
	(55007, 108, '2015-02-15 01:00:53.000000', 'temperatura', 446.0000, 'ºC'),
	(55008, 108, '2015-02-15 01:00:54.000000', 'temperatura', 1187.0000, 'ºC'),
	(55009, 108, '2015-02-15 01:00:55.000000', 'temperatura', 998.0000, 'ºC'),
	(55010, 108, '2015-02-15 01:00:56.000000', 'temperatura', 230.0000, 'ºC'),
	(55011, 108, '2015-02-15 01:00:57.000000', 'temperatura', 554.0000, 'ºC'),
	(55012, 108, '2015-02-15 01:00:58.000000', 'temperatura', 881.0000, 'ºC'),
	(55013, 108, '2015-02-15 01:00:59.000000', 'temperatura', 343.0000, 'ºC'),
	(55014, 108, '2015-02-15 01:01:00.000000', 'temperatura', 273.0000, 'ºC'),
	(55015, 108, '2015-02-15 01:01:01.000000', 'temperatura', 336.0000, 'ºC'),
	(55016, 108, '2015-02-15 01:01:02.000000', 'temperatura', 864.0000, 'ºC'),
	(55017, 108, '2015-02-15 01:01:03.000000', 'temperatura', 910.0000, 'ºC'),
	(55018, 108, '2015-02-15 01:01:04.000000', 'temperatura', 759.0000, 'ºC'),
	(55019, 108, '2015-02-15 01:01:05.000000', 'temperatura', 1068.0000, 'ºC'),
	(55020, 108, '2015-02-15 01:01:06.000000', 'temperatura', 660.0000, 'ºC'),
	(55021, 108, '2015-02-15 01:01:07.000000', 'temperatura', 99.0000, 'ºC'),
	(55022, 108, '2015-02-15 01:01:08.000000', 'temperatura', 915.0000, 'ºC'),
	(55023, 108, '2015-02-15 01:01:09.000000', 'temperatura', 676.0000, 'ºC'),
	(55024, 108, '2015-02-15 01:01:10.000000', 'temperatura', 638.0000, 'ºC'),
	(55025, 108, '2015-02-15 01:01:11.000000', 'temperatura', 1163.0000, 'ºC'),
	(55026, 108, '2015-02-15 01:01:12.000000', 'temperatura', 302.0000, 'ºC'),
	(55027, 108, '2015-02-15 01:01:13.000000', 'temperatura', 420.0000, 'ºC'),
	(55028, 108, '2015-02-15 01:01:14.000000', 'temperatura', 1197.0000, 'ºC'),
	(55029, 108, '2015-02-15 01:01:15.000000', 'temperatura', 1124.0000, 'ºC'),
	(55030, 108, '2015-02-15 01:01:16.000000', 'temperatura', 829.0000, 'ºC'),
	(55031, 108, '2015-02-15 01:01:17.000000', 'temperatura', 773.0000, 'ºC'),
	(55032, 108, '2015-02-15 01:01:18.000000', 'temperatura', 178.0000, 'ºC'),
	(55033, 108, '2015-02-15 01:01:19.000000', 'temperatura', 972.0000, 'ºC'),
	(55034, 108, '2015-02-15 01:01:20.000000', 'temperatura', 725.0000, 'ºC'),
	(55035, 108, '2015-02-15 01:01:21.000000', 'temperatura', 710.0000, 'ºC'),
	(55036, 108, '2015-02-15 01:01:22.000000', 'temperatura', 177.0000, 'ºC'),
	(55037, 108, '2015-02-15 01:01:23.000000', 'temperatura', 1156.0000, 'ºC'),
	(55038, 108, '2015-02-15 01:01:24.000000', 'temperatura', 449.0000, 'ºC'),
	(55039, 108, '2015-02-15 01:01:25.000000', 'temperatura', 1176.0000, 'ºC'),
	(55040, 108, '2015-02-15 01:01:26.000000', 'temperatura', 934.0000, 'ºC'),
	(55041, 108, '2015-02-15 01:01:27.000000', 'temperatura', 1141.0000, 'ºC'),
	(55042, 108, '2015-02-15 01:01:28.000000', 'temperatura', 504.0000, 'ºC'),
	(55043, 108, '2015-02-15 01:01:29.000000', 'temperatura', 300.0000, 'ºC'),
	(55044, 108, '2015-02-15 01:01:30.000000', 'temperatura', 1187.0000, 'ºC'),
	(55045, 108, '2015-02-15 01:01:31.000000', 'temperatura', 237.0000, 'ºC'),
	(55046, 108, '2015-02-15 01:01:32.000000', 'temperatura', 24.0000, 'ºC'),
	(55047, 108, '2015-02-15 01:01:33.000000', 'temperatura', 610.0000, 'ºC'),
	(55048, 108, '2015-02-15 01:01:34.000000', 'temperatura', 579.0000, 'ºC'),
	(55049, 108, '2015-02-15 01:01:35.000000', 'temperatura', 1065.0000, 'ºC'),
	(55050, 108, '2015-02-15 01:01:36.000000', 'temperatura', 1189.0000, 'ºC'),
	(55051, 108, '2015-02-15 01:01:37.000000', 'temperatura', 352.0000, 'ºC'),
	(55052, 108, '2015-02-15 01:01:38.000000', 'temperatura', 592.0000, 'ºC'),
	(55053, 108, '2015-02-15 01:01:39.000000', 'temperatura', 705.0000, 'ºC'),
	(55054, 108, '2015-02-15 01:01:40.000000', 'temperatura', 550.0000, 'ºC'),
	(55055, 108, '2015-02-15 01:01:41.000000', 'temperatura', 634.0000, 'ºC'),
	(55056, 108, '2015-02-15 01:01:42.000000', 'temperatura', 320.0000, 'ºC'),
	(55057, 108, '2015-02-15 01:01:43.000000', 'temperatura', 899.0000, 'ºC'),
	(55058, 108, '2015-02-15 01:01:44.000000', 'temperatura', 1134.0000, 'ºC'),
	(55059, 108, '2015-02-15 01:01:45.000000', 'temperatura', 576.0000, 'ºC'),
	(55060, 108, '2015-02-15 01:01:46.000000', 'temperatura', 679.0000, 'ºC'),
	(55061, 108, '2015-02-15 01:01:47.000000', 'temperatura', 466.0000, 'ºC'),
	(55062, 108, '2015-02-15 01:01:48.000000', 'temperatura', 292.0000, 'ºC'),
	(55063, 108, '2015-02-15 01:01:49.000000', 'temperatura', 64.0000, 'ºC'),
	(55064, 108, '2015-02-15 01:01:50.000000', 'temperatura', 643.0000, 'ºC'),
	(55065, 108, '2015-02-15 01:01:51.000000', 'temperatura', 625.0000, 'ºC'),
	(55066, 108, '2015-02-15 01:01:52.000000', 'temperatura', 1195.0000, 'ºC'),
	(55067, 108, '2015-02-15 01:01:53.000000', 'temperatura', 502.0000, 'ºC'),
	(55068, 108, '2015-02-15 01:01:54.000000', 'temperatura', 124.0000, 'ºC'),
	(55069, 108, '2015-02-15 01:01:55.000000', 'temperatura', 316.0000, 'ºC'),
	(55070, 108, '2015-02-15 01:01:56.000000', 'temperatura', 10.0000, 'ºC'),
	(55071, 108, '2015-02-15 01:01:57.000000', 'temperatura', 301.0000, 'ºC'),
	(55072, 108, '2015-02-15 01:01:58.000000', 'temperatura', 277.0000, 'ºC'),
	(55073, 108, '2015-02-15 01:01:59.000000', 'temperatura', 479.0000, 'ºC'),
	(55074, 108, '2015-02-15 01:02:00.000000', 'temperatura', 368.0000, 'ºC'),
	(55075, 108, '2015-02-15 01:02:01.000000', 'temperatura', 403.0000, 'ºC'),
	(55076, 108, '2015-02-15 01:02:02.000000', 'temperatura', 910.0000, 'ºC'),
	(55077, 108, '2015-02-15 01:02:03.000000', 'temperatura', 940.0000, 'ºC'),
	(55078, 108, '2015-02-15 01:02:04.000000', 'temperatura', 774.0000, 'ºC'),
	(55079, 108, '2015-02-15 01:02:05.000000', 'temperatura', 1048.0000, 'ºC'),
	(55080, 108, '2015-02-15 01:02:06.000000', 'temperatura', 521.0000, 'ºC'),
	(55081, 108, '2015-02-15 01:02:07.000000', 'temperatura', 659.0000, 'ºC'),
	(55082, 108, '2015-02-15 01:02:08.000000', 'temperatura', 535.0000, 'ºC'),
	(55083, 108, '2015-02-15 01:02:09.000000', 'temperatura', 696.0000, 'ºC'),
	(55084, 108, '2015-02-15 01:02:10.000000', 'temperatura', 678.0000, 'ºC'),
	(55085, 108, '2015-02-15 01:02:11.000000', 'temperatura', 103.0000, 'ºC'),
	(55086, 108, '2015-02-15 01:02:12.000000', 'temperatura', 881.0000, 'ºC'),
	(55087, 108, '2015-02-15 01:02:13.000000', 'temperatura', 496.0000, 'ºC'),
	(55088, 108, '2015-02-15 01:02:14.000000', 'temperatura', 1038.0000, 'ºC'),
	(55089, 108, '2015-02-15 01:02:15.000000', 'temperatura', 101.0000, 'ºC'),
	(55090, 108, '2015-02-15 01:02:16.000000', 'temperatura', 991.0000, 'ºC'),
	(55091, 108, '2015-02-15 01:02:17.000000', 'temperatura', 1052.0000, 'ºC'),
	(55092, 108, '2015-02-15 01:02:18.000000', 'temperatura', 1090.0000, 'ºC'),
	(55093, 108, '2015-02-15 01:02:19.000000', 'temperatura', 1092.0000, 'ºC'),
	(55094, 108, '2015-02-15 01:02:20.000000', 'temperatura', 990.0000, 'ºC'),
	(55095, 108, '2015-02-15 01:02:21.000000', 'temperatura', 475.0000, 'ºC'),
	(55096, 108, '2015-02-15 01:02:22.000000', 'temperatura', 608.0000, 'ºC'),
	(55097, 108, '2015-02-15 01:02:23.000000', 'temperatura', 414.0000, 'ºC'),
	(55098, 108, '2015-02-15 01:02:24.000000', 'temperatura', 246.0000, 'ºC'),
	(55099, 108, '2015-02-15 01:02:25.000000', 'temperatura', 1188.0000, 'ºC'),
	(55100, 108, '2015-02-15 01:02:26.000000', 'temperatura', 401.0000, 'ºC'),
	(55101, 108, '2015-02-15 01:02:27.000000', 'temperatura', 844.0000, 'ºC'),
	(55102, 108, '2015-02-15 01:02:28.000000', 'temperatura', 617.0000, 'ºC'),
	(55103, 108, '2015-02-15 01:02:29.000000', 'temperatura', 554.0000, 'ºC'),
	(55104, 108, '2015-02-15 01:02:30.000000', 'temperatura', 918.0000, 'ºC'),
	(55105, 108, '2015-02-15 01:02:31.000000', 'temperatura', 530.0000, 'ºC'),
	(55106, 108, '2015-02-15 01:02:32.000000', 'temperatura', 1095.0000, 'ºC'),
	(55107, 108, '2015-02-15 01:02:33.000000', 'temperatura', 286.0000, 'ºC'),
	(55108, 108, '2015-02-15 01:02:34.000000', 'temperatura', 547.0000, 'ºC'),
	(55109, 108, '2015-02-15 01:02:35.000000', 'temperatura', 678.0000, 'ºC'),
	(55110, 108, '2015-02-15 01:02:36.000000', 'temperatura', 549.0000, 'ºC'),
	(55111, 108, '2015-02-15 01:02:37.000000', 'temperatura', 713.0000, 'ºC'),
	(55112, 108, '2015-02-15 01:02:38.000000', 'temperatura', 716.0000, 'ºC'),
	(55113, 108, '2015-02-15 01:02:39.000000', 'temperatura', 241.0000, 'ºC'),
	(55114, 108, '2015-02-15 01:02:40.000000', 'temperatura', 260.0000, 'ºC'),
	(55115, 108, '2015-02-15 01:02:41.000000', 'temperatura', 574.0000, 'ºC'),
	(55116, 108, '2015-02-15 01:02:42.000000', 'temperatura', 893.0000, 'ºC'),
	(55117, 108, '2015-02-15 01:02:43.000000', 'temperatura', 344.0000, 'ºC'),
	(55118, 108, '2015-02-15 01:02:44.000000', 'temperatura', 241.0000, 'ºC'),
	(55119, 108, '2015-02-15 01:02:45.000000', 'temperatura', 175.0000, 'ºC'),
	(55120, 108, '2015-02-15 01:02:46.000000', 'temperatura', 150.0000, 'ºC'),
	(55121, 108, '2015-02-15 01:02:47.000000', 'temperatura', 227.0000, 'ºC'),
	(55122, 108, '2015-02-15 01:02:48.000000', 'temperatura', 687.0000, 'ºC'),
	(55123, 108, '2015-02-15 01:02:49.000000', 'temperatura', 353.0000, 'ºC'),
	(55124, 108, '2015-02-15 01:02:50.000000', 'temperatura', 906.0000, 'ºC'),
	(55125, 108, '2015-02-15 01:02:51.000000', 'temperatura', 1071.0000, 'ºC'),
	(55126, 108, '2015-02-15 01:02:52.000000', 'temperatura', 238.0000, 'ºC'),
	(55127, 108, '2015-02-15 01:02:53.000000', 'temperatura', 376.0000, 'ºC'),
	(55128, 108, '2015-02-15 01:02:54.000000', 'temperatura', 1166.0000, 'ºC'),
	(55129, 108, '2015-02-15 01:02:55.000000', 'temperatura', 1102.0000, 'ºC'),
	(55130, 108, '2015-02-15 01:02:56.000000', 'temperatura', 814.0000, 'ºC'),
	(55131, 108, '2015-02-15 01:02:57.000000', 'temperatura', 763.0000, 'ºC'),
	(55132, 108, '2015-02-15 01:02:58.000000', 'temperatura', 174.0000, 'ºC'),
	(55133, 108, '2015-02-15 01:02:59.000000', 'temperatura', 983.0000, 'ºC'),
	(55134, 108, '2015-02-15 01:03:00.000000', 'temperatura', 792.0000, 'ºC'),
	(55135, 108, '2015-02-15 01:03:01.000000', 'temperatura', 1014.0000, 'ºC'),
	(55136, 108, '2015-02-15 01:03:02.000000', 'temperatura', 291.0000, 'ºC'),
	(55137, 108, '2015-02-15 01:03:03.000000', 'temperatura', 816.0000, 'ºC'),
	(55138, 108, '2015-02-15 01:03:04.000000', 'temperatura', 806.0000, 'ºC'),
	(55139, 108, '2015-02-15 01:03:05.000000', 'temperatura', 382.0000, 'ºC'),
	(55140, 108, '2015-02-15 01:03:06.000000', 'temperatura', 695.0000, 'ºC'),
	(55141, 108, '2015-02-15 01:03:07.000000', 'temperatura', 1127.0000, 'ºC'),
	(55142, 108, '2015-02-15 01:03:08.000000', 'temperatura', 1152.0000, 'ºC'),
	(55143, 108, '2015-02-15 01:03:09.000000', 'temperatura', 1179.0000, 'ºC'),
	(55144, 108, '2015-02-15 01:03:10.000000', 'temperatura', 38.0000, 'ºC'),
	(55145, 108, '2015-02-15 01:03:11.000000', 'temperatura', 256.0000, 'ºC'),
	(55146, 108, '2015-02-15 01:03:12.000000', 'temperatura', 1164.0000, 'ºC'),
	(55147, 108, '2015-02-15 01:03:13.000000', 'temperatura', 255.0000, 'ºC'),
	(55148, 108, '2015-02-15 01:03:14.000000', 'temperatura', 182.0000, 'ºC'),
	(55149, 108, '2015-02-15 01:03:15.000000', 'temperatura', 146.0000, 'ºC'),
	(55150, 108, '2015-02-15 01:03:16.000000', 'temperatura', 186.0000, 'ºC'),
	(55151, 108, '2015-02-15 01:03:17.000000', 'temperatura', 490.0000, 'ºC'),
	(55152, 108, '2015-02-15 01:03:18.000000', 'temperatura', 693.0000, 'ºC'),
	(55153, 108, '2015-02-15 01:03:19.000000', 'temperatura', 794.0000, 'ºC'),
	(55154, 108, '2015-02-15 01:03:20.000000', 'temperatura', 694.0000, 'ºC'),
	(55155, 108, '2015-02-15 01:03:21.000000', 'temperatura', 1088.0000, 'ºC'),
	(55156, 108, '2015-02-15 01:03:22.000000', 'temperatura', 959.0000, 'ºC'),
	(55157, 108, '2015-02-15 01:03:23.000000', 'temperatura', 330.0000, 'ºC'),
	(55158, 108, '2015-02-15 01:03:24.000000', 'temperatura', 1176.0000, 'ºC'),
	(55159, 108, '2015-02-15 01:03:25.000000', 'temperatura', 89.0000, 'ºC'),
	(55160, 108, '2015-02-15 01:03:26.000000', 'temperatura', 520.0000, 'ºC'),
	(55161, 108, '2015-02-15 01:03:27.000000', 'temperatura', 1131.0000, 'ºC'),
	(55162, 108, '2015-02-15 01:03:28.000000', 'temperatura', 496.0000, 'ºC'),
	(55163, 108, '2015-02-15 01:03:29.000000', 'temperatura', 287.0000, 'ºC'),
	(55164, 108, '2015-02-15 01:03:30.000000', 'temperatura', 1146.0000, 'ºC'),
	(55165, 108, '2015-02-15 01:03:31.000000', 'temperatura', 71.0000, 'ºC'),
	(55166, 108, '2015-02-15 01:03:32.000000', 'temperatura', 518.0000, 'ºC'),
	(55167, 108, '2015-02-15 01:03:33.000000', 'temperatura', 1178.0000, 'ºC'),
	(55168, 108, '2015-02-15 01:03:34.000000', 'temperatura', 735.0000, 'ºC'),
	(55169, 108, '2015-02-15 01:03:35.000000', 'temperatura', 141.0000, 'ºC'),
	(55170, 108, '2015-02-15 01:03:36.000000', 'temperatura', 901.0000, 'ºC'),
	(55171, 108, '2015-02-15 01:03:37.000000', 'temperatura', 483.0000, 'ºC'),
	(55172, 108, '2015-02-15 01:03:38.000000', 'temperatura', 911.0000, 'ºC'),
	(55173, 108, '2015-02-15 01:03:39.000000', 'temperatura', 709.0000, 'ºC'),
	(55174, 108, '2015-02-15 01:03:40.000000', 'temperatura', 812.0000, 'ºC'),
	(55175, 108, '2015-02-15 01:03:41.000000', 'temperatura', 733.0000, 'ºC'),
	(55176, 108, '2015-02-15 01:03:42.000000', 'temperatura', 28.0000, 'ºC'),
	(55177, 108, '2015-02-15 01:03:43.000000', 'temperatura', 341.0000, 'ºC'),
	(55178, 108, '2015-02-15 01:03:44.000000', 'temperatura', 422.0000, 'ºC'),
	(55179, 108, '2015-02-15 01:03:45.000000', 'temperatura', 1087.0000, 'ºC'),
	(55180, 108, '2015-02-15 01:03:46.000000', 'temperatura', 571.0000, 'ºC'),
	(55181, 108, '2015-02-15 01:03:47.000000', 'temperatura', 792.0000, 'ºC'),
	(55182, 108, '2015-02-15 01:03:48.000000', 'temperatura', 1049.0000, 'ºC'),
	(55183, 108, '2015-02-15 01:03:49.000000', 'temperatura', 471.0000, 'ºC'),
	(55184, 108, '2015-02-15 01:03:50.000000', 'temperatura', 407.0000, 'ºC'),
	(55185, 108, '2015-02-15 01:03:51.000000', 'temperatura', 622.0000, 'ºC'),
	(55186, 108, '2015-02-15 01:03:52.000000', 'temperatura', 689.0000, 'ºC'),
	(55187, 108, '2015-02-15 01:03:53.000000', 'temperatura', 379.0000, 'ºC'),
	(55188, 108, '2015-02-15 01:03:54.000000', 'temperatura', 1031.0000, 'ºC'),
	(55189, 108, '2015-02-15 01:03:55.000000', 'temperatura', 418.0000, 'ºC'),
	(55190, 108, '2015-02-15 01:03:56.000000', 'temperatura', 199.0000, 'ºC'),
	(55191, 108, '2015-02-15 01:03:57.000000', 'temperatura', 941.0000, 'ºC'),
	(55192, 108, '2015-02-15 01:03:58.000000', 'temperatura', 508.0000, 'ºC'),
	(55193, 108, '2015-02-15 01:03:59.000000', 'temperatura', 915.0000, 'ºC'),
	(55194, 108, '2015-02-15 01:04:00.000000', 'temperatura', 655.0000, 'ºC'),
	(55195, 108, '2015-02-15 01:04:01.000000', 'temperatura', 529.0000, 'ºC'),
	(55196, 108, '2015-02-15 01:04:02.000000', 'temperatura', 682.0000, 'ºC'),
	(55197, 108, '2015-02-15 01:04:03.000000', 'temperatura', 620.0000, 'ºC'),
	(55198, 108, '2015-02-15 01:04:04.000000', 'temperatura', 1058.0000, 'ºC'),
	(55199, 108, '2015-02-15 01:04:05.000000', 'temperatura', 1030.0000, 'ºC'),
	(55200, 108, '2015-02-15 01:04:06.000000', 'temperatura', 778.0000, 'ºC'),
	(55201, 108, '2015-02-15 01:04:07.000000', 'temperatura', 799.0000, 'ºC'),
	(55202, 108, '2015-02-15 01:04:08.000000', 'temperatura', 462.0000, 'ºC'),
	(55203, 108, '2015-02-15 01:04:09.000000', 'temperatura', 1113.0000, 'ºC'),
	(55204, 108, '2015-02-15 01:04:10.000000', 'temperatura', 578.0000, 'ºC'),
	(55205, 108, '2015-02-15 01:04:11.000000', 'temperatura', 752.0000, 'ºC'),
	(55206, 108, '2015-02-15 01:04:12.000000', 'temperatura', 825.0000, 'ºC'),
	(55207, 108, '2015-02-15 01:04:13.000000', 'temperatura', 673.0000, 'ºC'),
	(55208, 108, '2015-02-15 01:04:14.000000', 'temperatura', 889.0000, 'ºC'),
	(55209, 108, '2015-02-15 01:04:15.000000', 'temperatura', 24.0000, 'ºC'),
	(55210, 108, '2015-02-15 01:04:16.000000', 'temperatura', 1057.0000, 'ºC'),
	(55211, 108, '2015-02-15 01:04:17.000000', 'temperatura', 413.0000, 'ºC'),
	(55212, 108, '2015-02-15 01:04:18.000000', 'temperatura', 94.0000, 'ºC'),
	(55213, 108, '2015-02-15 01:04:19.000000', 'temperatura', 432.0000, 'ºC'),
	(55214, 108, '2015-02-15 01:04:20.000000', 'temperatura', 677.0000, 'ºC'),
	(55215, 108, '2015-02-15 01:04:21.000000', 'temperatura', 889.0000, 'ºC'),
	(55216, 108, '2015-02-15 01:04:22.000000', 'temperatura', 17.0000, 'ºC'),
	(55217, 108, '2015-02-15 01:04:23.000000', 'temperatura', 1017.0000, 'ºC'),
	(55218, 108, '2015-02-15 01:04:24.000000', 'temperatura', 235.0000, 'ºC'),
	(55219, 108, '2015-02-15 01:04:25.000000', 'temperatura', 524.0000, 'ºC'),
	(55220, 108, '2015-02-15 01:04:26.000000', 'temperatura', 715.0000, 'ºC'),
	(55221, 108, '2015-02-15 01:04:27.000000', 'temperatura', 805.0000, 'ºC'),
	(55222, 108, '2015-02-15 01:04:28.000000', 'temperatura', 679.0000, 'ºC'),
	(55223, 108, '2015-02-15 01:04:29.000000', 'temperatura', 981.0000, 'ºC'),
	(55224, 108, '2015-02-15 01:04:30.000000', 'temperatura', 468.0000, 'ºC'),
	(55225, 108, '2015-02-15 01:04:31.000000', 'temperatura', 599.0000, 'ºC'),
	(55226, 108, '2015-02-15 01:04:32.000000', 'temperatura', 391.0000, 'ºC'),
	(55227, 108, '2015-02-15 01:04:33.000000', 'temperatura', 158.0000, 'ºC'),
	(55228, 108, '2015-02-15 01:04:34.000000', 'temperatura', 818.0000, 'ºC'),
	(55229, 108, '2015-02-15 01:04:35.000000', 'temperatura', 17.0000, 'ºC'),
	(55230, 108, '2015-02-15 01:04:36.000000', 'temperatura', 31.0000, 'ºC'),
	(55231, 108, '2015-02-15 01:04:37.000000', 'temperatura', 104.0000, 'ºC'),
	(55232, 108, '2015-02-15 01:04:38.000000', 'temperatura', 428.0000, 'ºC'),
	(55233, 108, '2015-02-15 01:04:39.000000', 'temperatura', 626.0000, 'ºC'),
	(55234, 108, '2015-02-15 01:04:40.000000', 'temperatura', 650.0000, 'ºC'),
	(55235, 108, '2015-02-15 01:04:41.000000', 'temperatura', 170.0000, 'ºC'),
	(55236, 108, '2015-02-15 01:04:42.000000', 'temperatura', 101.0000, 'ºC'),
	(55237, 108, '2015-02-15 01:04:43.000000', 'temperatura', 1196.0000, 'ºC'),
	(55238, 108, '2015-02-15 01:04:44.000000', 'temperatura', 876.0000, 'ºC'),
	(55239, 108, '2015-02-15 01:04:45.000000', 'temperatura', 794.0000, 'ºC'),
	(55240, 108, '2015-02-15 01:04:46.000000', 'temperatura', 143.0000, 'ºC'),
	(55241, 108, '2015-02-15 01:04:47.000000', 'temperatura', 732.0000, 'ºC'),
	(55242, 108, '2015-02-15 01:04:48.000000', 'temperatura', 830.0000, 'ºC'),
	(55243, 108, '2015-02-15 01:04:49.000000', 'temperatura', 758.0000, 'ºC'),
	(55244, 108, '2015-02-15 01:04:50.000000', 'temperatura', 99.0000, 'ºC'),
	(55245, 108, '2015-02-15 01:04:51.000000', 'temperatura', 624.0000, 'ºC'),
	(55246, 108, '2015-02-15 01:04:52.000000', 'temperatura', 420.0000, 'ºC'),
	(55247, 108, '2015-02-15 01:04:53.000000', 'temperatura', 229.0000, 'ºC'),
	(55248, 108, '2015-02-15 01:04:54.000000', 'temperatura', 1088.0000, 'ºC'),
	(55249, 108, '2015-02-15 01:04:55.000000', 'temperatura', 1151.0000, 'ºC'),
	(55250, 108, '2015-02-15 01:04:56.000000', 'temperatura', 94.0000, 'ºC'),
	(55251, 108, '2015-02-15 01:04:57.000000', 'temperatura', 616.0000, 'ºC'),
	(55252, 108, '2015-02-15 01:04:58.000000', 'temperatura', 400.0000, 'ºC'),
	(55253, 108, '2015-02-15 01:04:59.000000', 'temperatura', 150.0000, 'ºC'),
	(55254, 108, '2015-02-15 01:05:00.000000', 'temperatura', 752.0000, 'ºC'),
	(55255, 108, '2015-02-15 01:05:01.000000', 'temperatura', 912.0000, 'ºC'),
	(55256, 108, '2015-02-15 01:05:02.000000', 'temperatura', 1103.0000, 'ºC'),
	(55257, 108, '2015-02-15 01:05:03.000000', 'temperatura', 382.0000, 'ºC'),
	(55258, 108, '2015-02-15 01:05:04.000000', 'temperatura', 999.0000, 'ºC'),
	(55259, 108, '2015-02-15 01:05:05.000000', 'temperatura', 250.0000, 'ºC'),
	(55260, 108, '2015-02-15 01:05:06.000000', 'temperatura', 655.0000, 'ºC'),
	(55261, 108, '2015-02-15 01:05:07.000000', 'temperatura', 124.0000, 'ºC'),
	(55262, 108, '2015-02-15 01:05:08.000000', 'temperatura', 1055.0000, 'ºC'),
	(55263, 108, '2015-02-15 01:05:09.000000', 'temperatura', 104.0000, 'ºC'),
	(55264, 108, '2015-02-15 01:05:10.000000', 'temperatura', 956.0000, 'ºC'),
	(55265, 108, '2015-02-15 01:05:11.000000', 'temperatura', 866.0000, 'ºC'),
	(55266, 108, '2015-02-15 01:05:12.000000', 'temperatura', 265.0000, 'ºC'),
	(55267, 108, '2015-02-15 01:05:13.000000', 'temperatura', 1127.0000, 'ºC'),
	(55268, 108, '2015-02-15 01:05:14.000000', 'temperatura', 39.0000, 'ºC'),
	(55269, 108, '2015-02-15 01:05:15.000000', 'temperatura', 417.0000, 'ºC'),
	(55270, 108, '2015-02-15 01:05:16.000000', 'temperatura', 769.0000, 'ºC'),
	(55271, 108, '2015-02-15 01:05:17.000000', 'temperatura', 195.0000, 'ºC'),
	(55272, 108, '2015-02-15 01:05:18.000000', 'temperatura', 1066.0000, 'ºC'),
	(55273, 108, '2015-02-15 01:05:19.000000', 'temperatura', 1146.0000, 'ºC'),
	(55274, 108, '2015-02-15 01:05:20.000000', 'temperatura', 132.0000, 'ºC'),
	(55275, 108, '2015-02-15 01:05:21.000000', 'temperatura', 822.0000, 'ºC'),
	(55276, 108, '2015-02-15 01:05:22.000000', 'temperatura', 115.0000, 'ºC'),
	(55277, 108, '2015-02-15 01:05:23.000000', 'temperatura', 509.0000, 'ºC'),
	(55278, 108, '2015-02-15 01:05:24.000000', 'temperatura', 1001.0000, 'ºC'),
	(55279, 108, '2015-02-15 01:05:25.000000', 'temperatura', 1076.0000, 'ºC'),
	(55280, 108, '2015-02-15 01:05:26.000000', 'temperatura', 1181.0000, 'ºC'),
	(55281, 108, '2015-02-15 01:05:27.000000', 'temperatura', 276.0000, 'ºC'),
	(55282, 108, '2015-02-15 01:05:28.000000', 'temperatura', 236.0000, 'ºC'),
	(55283, 108, '2015-02-15 01:05:29.000000', 'temperatura', 355.0000, 'ºC'),
	(55284, 108, '2015-02-15 01:05:30.000000', 'temperatura', 1065.0000, 'ºC'),
	(55285, 108, '2015-02-15 01:05:31.000000', 'temperatura', 662.0000, 'ºC'),
	(55286, 108, '2015-02-15 01:05:32.000000', 'temperatura', 116.0000, 'ºC'),
	(55287, 108, '2015-02-15 01:05:33.000000', 'temperatura', 994.0000, 'ºC'),
	(55288, 108, '2015-02-15 01:05:34.000000', 'temperatura', 1021.0000, 'ºC'),
	(55289, 108, '2015-02-15 01:05:35.000000', 'temperatura', 923.0000, 'ºC'),
	(55290, 108, '2015-02-15 01:05:36.000000', 'temperatura', 354.0000, 'ºC'),
	(55291, 108, '2015-02-15 01:05:37.000000', 'temperatura', 203.0000, 'ºC'),
	(55292, 108, '2015-02-15 01:05:38.000000', 'temperatura', 1152.0000, 'ºC'),
	(55293, 108, '2015-02-15 01:05:39.000000', 'temperatura', 352.0000, 'ºC'),
	(55294, 108, '2015-02-15 01:05:40.000000', 'temperatura', 702.0000, 'ºC'),
	(55295, 108, '2015-02-15 01:05:41.000000', 'temperatura', 58.0000, 'ºC'),
	(55296, 108, '2015-02-15 01:05:42.000000', 'temperatura', 583.0000, 'ºC'),
	(55297, 108, '2015-02-15 01:05:43.000000', 'temperatura', 342.0000, 'ºC'),
	(55298, 108, '2015-02-15 01:05:44.000000', 'temperatura', 1163.0000, 'ºC'),
	(55299, 108, '2015-02-15 01:05:45.000000', 'temperatura', 1188.0000, 'ºC'),
	(55300, 108, '2015-02-15 01:05:46.000000', 'temperatura', 52.0000, 'ºC'),
	(55301, 108, '2015-02-15 01:05:47.000000', 'temperatura', 295.0000, 'ºC'),
	(55302, 108, '2015-02-15 01:05:48.000000', 'temperatura', 122.0000, 'ºC'),
	(55303, 108, '2015-02-15 01:05:49.000000', 'temperatura', 924.0000, 'ºC'),
	(55304, 108, '2015-02-15 01:05:50.000000', 'temperatura', 653.0000, 'ºC'),
	(55305, 108, '2015-02-15 01:05:51.000000', 'temperatura', 497.0000, 'ºC'),
	(55306, 108, '2015-02-15 01:05:52.000000', 'temperatura', 523.0000, 'ºC'),
	(55307, 108, '2015-02-15 01:05:53.000000', 'temperatura', 1125.0000, 'ºC'),
	(55308, 108, '2015-02-15 01:05:54.000000', 'temperatura', 458.0000, 'ºC'),
	(55309, 108, '2015-02-15 01:05:55.000000', 'temperatura', 116.0000, 'ºC'),
	(55310, 108, '2015-02-15 01:05:56.000000', 'temperatura', 407.0000, 'ºC'),
	(55311, 108, '2015-02-15 01:05:57.000000', 'temperatura', 485.0000, 'ºC'),
	(55312, 108, '2015-02-15 01:05:58.000000', 'temperatura', 5.0000, 'ºC'),
	(55313, 108, '2015-02-15 01:05:59.000000', 'temperatura', 970.0000, 'ºC'),
	(55314, 108, '2015-02-15 01:06:00.000000', 'temperatura', 38.0000, 'ºC'),
	(55315, 108, '2015-02-15 01:06:01.000000', 'temperatura', 880.0000, 'ºC'),
	(55316, 108, '2015-02-15 01:06:02.000000', 'temperatura', 688.0000, 'ºC'),
	(55317, 108, '2015-02-15 01:06:03.000000', 'temperatura', 798.0000, 'ºC'),
	(55318, 108, '2015-02-15 01:06:04.000000', 'temperatura', 726.0000, 'ºC'),
	(55319, 108, '2015-02-15 01:06:05.000000', 'temperatura', 38.0000, 'ºC'),
	(55320, 108, '2015-02-15 01:06:06.000000', 'temperatura', 411.0000, 'ºC'),
	(55321, 108, '2015-02-15 01:06:07.000000', 'temperatura', 743.0000, 'ºC'),
	(55322, 108, '2015-02-15 01:06:08.000000', 'temperatura', 81.0000, 'ºC'),
	(55323, 108, '2015-02-15 01:06:09.000000', 'temperatura', 575.0000, 'ºC'),
	(55324, 108, '2015-02-15 01:06:10.000000', 'temperatura', 236.0000, 'ºC'),
	(55325, 108, '2015-02-15 01:06:11.000000', 'temperatura', 654.0000, 'ºC'),
	(55326, 108, '2015-02-15 01:06:12.000000', 'temperatura', 162.0000, 'ºC'),
	(55327, 108, '2015-02-15 01:06:13.000000', 'temperatura', 51.0000, 'ºC'),
	(55328, 108, '2015-02-15 01:06:14.000000', 'temperatura', 967.0000, 'ºC'),
	(55329, 108, '2015-02-15 01:06:15.000000', 'temperatura', 1082.0000, 'ºC'),
	(55330, 108, '2015-02-15 01:06:16.000000', 'temperatura', 110.0000, 'ºC'),
	(55331, 108, '2015-02-15 01:06:17.000000', 'temperatura', 907.0000, 'ºC'),
	(55332, 108, '2015-02-15 01:06:18.000000', 'temperatura', 603.0000, 'ºC'),
	(55333, 108, '2015-02-15 01:06:19.000000', 'temperatura', 297.0000, 'ºC'),
	(55334, 108, '2015-02-15 01:06:20.000000', 'temperatura', 875.0000, 'ºC'),
	(55335, 108, '2015-02-15 01:06:21.000000', 'temperatura', 1085.0000, 'ºC'),
	(55336, 108, '2015-02-15 01:06:22.000000', 'temperatura', 400.0000, 'ºC'),
	(55337, 108, '2015-02-15 01:06:23.000000', 'temperatura', 1144.0000, 'ºC'),
	(55338, 108, '2015-02-15 01:06:24.000000', 'temperatura', 921.0000, 'ºC'),
	(55339, 108, '2015-02-15 01:06:25.000000', 'temperatura', 1173.0000, 'ºC'),
	(55340, 108, '2015-02-15 01:06:26.000000', 'temperatura', 701.0000, 'ºC'),
	(55341, 108, '2015-02-15 01:06:27.000000', 'temperatura', 1188.0000, 'ºC'),
	(55342, 108, '2015-02-15 01:06:28.000000', 'temperatura', 238.0000, 'ºC'),
	(55343, 108, '2015-02-15 01:06:29.000000', 'temperatura', 26.0000, 'ºC'),
	(55344, 108, '2015-02-15 01:06:30.000000', 'temperatura', 619.0000, 'ºC'),
	(55345, 108, '2015-02-15 01:06:31.000000', 'temperatura', 614.0000, 'ºC'),
	(55346, 108, '2015-02-15 01:06:32.000000', 'temperatura', 16.0000, 'ºC'),
	(55347, 108, '2015-02-15 01:06:33.000000', 'temperatura', 640.0000, 'ºC'),
	(55348, 108, '2015-02-15 01:06:34.000000', 'temperatura', 749.0000, 'ºC'),
	(55349, 108, '2015-02-15 01:06:35.000000', 'temperatura', 626.0000, 'ºC'),
	(55350, 108, '2015-02-15 01:06:36.000000', 'temperatura', 884.0000, 'ºC'),
	(55351, 108, '2015-02-15 01:06:37.000000', 'temperatura', 144.0000, 'ºC'),
	(55352, 108, '2015-02-15 01:06:38.000000', 'temperatura', 467.0000, 'ºC'),
	(55353, 108, '2015-02-15 01:06:39.000000', 'temperatura', 705.0000, 'ºC'),
	(55354, 108, '2015-02-15 01:06:40.000000', 'temperatura', 922.0000, 'ºC'),
	(55355, 108, '2015-02-15 01:06:41.000000', 'temperatura', 98.0000, 'ºC'),
	(55356, 108, '2015-02-15 01:06:42.000000', 'temperatura', 124.0000, 'ºC'),
	(55357, 108, '2015-02-15 01:06:43.000000', 'temperatura', 325.0000, 'ºC'),
	(55358, 108, '2015-02-15 01:06:44.000000', 'temperatura', 55.0000, 'ºC'),
	(55359, 108, '2015-02-15 01:06:45.000000', 'temperatura', 501.0000, 'ºC'),
	(55360, 108, '2015-02-15 01:06:46.000000', 'temperatura', 1139.0000, 'ºC'),
	(55361, 108, '2015-02-15 01:06:47.000000', 'temperatura', 594.0000, 'ºC'),
	(55362, 108, '2015-02-15 01:06:48.000000', 'temperatura', 753.0000, 'ºC'),
	(55363, 108, '2015-02-15 01:06:49.000000', 'temperatura', 782.0000, 'ºC'),
	(55364, 108, '2015-02-15 01:06:50.000000', 'temperatura', 452.0000, 'ºC'),
	(55365, 108, '2015-02-15 01:06:51.000000', 'temperatura', 1116.0000, 'ºC'),
	(55366, 108, '2015-02-15 01:06:52.000000', 'temperatura', 622.0000, 'ºC'),
	(55367, 108, '2015-02-15 01:06:53.000000', 'temperatura', 963.0000, 'ºC'),
	(55368, 108, '2015-02-15 01:06:54.000000', 'temperatura', 552.0000, 'ºC'),
	(55369, 108, '2015-02-15 01:06:55.000000', 'temperatura', 1070.0000, 'ºC'),
	(55370, 108, '2015-02-15 01:06:56.000000', 'temperatura', 96.0000, 'ºC'),
	(55371, 108, '2015-02-15 01:06:57.000000', 'temperatura', 868.0000, 'ºC'),
	(55372, 108, '2015-02-15 01:06:58.000000', 'temperatura', 452.0000, 'ºC'),
	(55373, 108, '2015-02-15 01:06:59.000000', 'temperatura', 859.0000, 'ºC'),
	(55374, 108, '2015-02-15 01:07:00.000000', 'temperatura', 538.0000, 'ºC'),
	(55375, 108, '2015-02-15 01:07:01.000000', 'temperatura', 113.0000, 'ºC'),
	(55376, 108, '2015-02-15 01:07:02.000000', 'temperatura', 153.0000, 'ºC'),
	(55377, 108, '2015-02-15 01:07:03.000000', 'temperatura', 424.0000, 'ºC'),
	(55378, 108, '2015-02-15 01:07:04.000000', 'temperatura', 463.0000, 'ºC'),
	(55379, 108, '2015-02-15 01:07:05.000000', 'temperatura', 1045.0000, 'ºC'),
	(55380, 108, '2015-02-15 01:07:06.000000', 'temperatura', 234.0000, 'ºC'),
	(55381, 108, '2015-02-15 01:07:07.000000', 'temperatura', 436.0000, 'ºC'),
	(55382, 108, '2015-02-15 01:07:08.000000', 'temperatura', 279.0000, 'ºC'),
	(55383, 108, '2015-02-15 01:07:09.000000', 'temperatura', 89.0000, 'ºC'),
	(55384, 108, '2015-02-15 01:07:10.000000', 'temperatura', 806.0000, 'ºC'),
	(55385, 108, '2015-02-15 01:07:11.000000', 'temperatura', 165.0000, 'ºC'),
	(55386, 108, '2015-02-15 01:07:12.000000', 'temperatura', 807.0000, 'ºC'),
	(55387, 108, '2015-02-15 01:07:13.000000', 'temperatura', 1141.0000, 'ºC'),
	(55388, 108, '2015-02-15 01:07:14.000000', 'temperatura', 884.0000, 'ºC'),
	(55389, 108, '2015-02-15 01:07:15.000000', 'temperatura', 999.0000, 'ºC'),
	(55390, 108, '2015-02-15 01:07:16.000000', 'temperatura', 1142.0000, 'ºC'),
	(55391, 108, '2015-02-15 01:07:17.000000', 'temperatura', 313.0000, 'ºC'),
	(55392, 108, '2015-02-15 01:07:18.000000', 'temperatura', 542.0000, 'ºC'),
	(55393, 108, '2015-02-15 01:07:19.000000', 'temperatura', 571.0000, 'ºC'),
	(55394, 108, '2015-02-15 01:07:20.000000', 'temperatura', 28.0000, 'ºC'),
	(55395, 108, '2015-02-15 01:07:21.000000', 'temperatura', 828.0000, 'ºC'),
	(55396, 108, '2015-02-15 01:07:22.000000', 'temperatura', 455.0000, 'ºC'),
	(55397, 108, '2015-02-15 01:07:23.000000', 'temperatura', 992.0000, 'ºC'),
	(55398, 108, '2015-02-15 01:07:24.000000', 'temperatura', 1194.0000, 'ºC'),
	(55399, 108, '2015-02-15 01:07:25.000000', 'temperatura', 598.0000, 'ºC'),
	(55400, 108, '2015-02-15 01:07:26.000000', 'temperatura', 606.0000, 'ºC'),
	(55401, 108, '2015-02-15 01:07:27.000000', 'temperatura', 37.0000, 'ºC'),
	(55402, 108, '2015-02-15 01:07:28.000000', 'temperatura', 768.0000, 'ºC'),
	(55403, 108, '2015-02-15 01:07:29.000000', 'temperatura', 127.0000, 'ºC'),
	(55404, 108, '2015-02-15 01:07:30.000000', 'temperatura', 734.0000, 'ºC'),
	(55405, 108, '2015-02-15 01:07:31.000000', 'temperatura', 890.0000, 'ºC'),
	(55406, 108, '2015-02-15 01:07:32.000000', 'temperatura', 1047.0000, 'ºC'),
	(55407, 108, '2015-02-15 01:07:33.000000', 'temperatura', 165.0000, 'ºC'),
	(55408, 108, '2015-02-15 01:07:34.000000', 'temperatura', 86.0000, 'ºC'),
	(55409, 108, '2015-02-15 01:07:35.000000', 'temperatura', 1133.0000, 'ºC'),
	(55410, 108, '2015-02-15 01:07:36.000000', 'temperatura', 610.0000, 'ºC'),
	(55411, 108, '2015-02-15 01:07:37.000000', 'temperatura', 850.0000, 'ºC'),
	(55412, 108, '2015-02-15 01:07:38.000000', 'temperatura', 23.0000, 'ºC'),
	(55413, 108, '2015-02-15 01:07:39.000000', 'temperatura', 1163.0000, 'ºC'),
	(55414, 108, '2015-02-15 01:07:40.000000', 'temperatura', 946.0000, 'ºC'),
	(55415, 108, '2015-02-15 01:07:41.000000', 'temperatura', 41.0000, 'ºC'),
	(55416, 108, '2015-02-15 01:07:42.000000', 'temperatura', 967.0000, 'ºC'),
	(55417, 108, '2015-02-15 01:07:43.000000', 'temperatura', 1114.0000, 'ºC'),
	(55418, 108, '2015-02-15 01:07:44.000000', 'temperatura', 270.0000, 'ºC'),
	(55419, 108, '2015-02-15 01:07:45.000000', 'temperatura', 409.0000, 'ºC'),
	(55420, 108, '2015-02-15 01:07:46.000000', 'temperatura', 33.0000, 'ºC'),
	(55421, 108, '2015-02-15 01:07:47.000000', 'temperatura', 141.0000, 'ºC'),
	(55422, 108, '2015-02-15 01:07:48.000000', 'temperatura', 605.0000, 'ºC'),
	(55423, 108, '2015-02-15 01:07:49.000000', 'temperatura', 204.0000, 'ºC'),
	(55424, 108, '2015-02-15 01:07:50.000000', 'temperatura', 404.0000, 'ºC'),
	(55425, 108, '2015-02-15 01:07:51.000000', 'temperatura', 208.0000, 'ºC'),
	(55426, 108, '2015-02-15 01:07:52.000000', 'temperatura', 1029.0000, 'ºC'),
	(55427, 108, '2015-02-15 01:07:53.000000', 'temperatura', 921.0000, 'ºC'),
	(55428, 108, '2015-02-15 01:07:54.000000', 'temperatura', 318.0000, 'ºC'),
	(55429, 108, '2015-02-15 01:07:55.000000', 'temperatura', 30.0000, 'ºC'),
	(55430, 108, '2015-02-15 01:07:56.000000', 'temperatura', 395.0000, 'ºC'),
	(55431, 108, '2015-02-15 01:07:57.000000', 'temperatura', 687.0000, 'ºC'),
	(55432, 108, '2015-02-15 01:07:58.000000', 'temperatura', 1048.0000, 'ºC'),
	(55433, 108, '2015-02-15 01:07:59.000000', 'temperatura', 780.0000, 'ºC'),
	(55434, 108, '2015-02-15 01:08:00.000000', 'temperatura', 755.0000, 'ºC'),
	(55435, 108, '2015-02-15 01:08:01.000000', 'temperatura', 237.0000, 'ºC'),
	(55436, 108, '2015-02-15 01:08:02.000000', 'temperatura', 121.0000, 'ºC'),
	(55437, 108, '2015-02-15 01:08:03.000000', 'temperatura', 1094.0000, 'ºC'),
	(55438, 108, '2015-02-15 01:08:04.000000', 'temperatura', 308.0000, 'ºC'),
	(55439, 108, '2015-02-15 01:08:05.000000', 'temperatura', 658.0000, 'ºC'),
	(55440, 108, '2015-02-15 01:08:06.000000', 'temperatura', 1166.0000, 'ºC'),
	(55441, 108, '2015-02-15 01:08:07.000000', 'temperatura', 259.0000, 'ºC'),
	(55442, 108, '2015-02-15 01:08:08.000000', 'temperatura', 195.0000, 'ºC'),
	(55443, 108, '2015-02-15 01:08:09.000000', 'temperatura', 199.0000, 'ºC'),
	(55444, 108, '2015-02-15 01:08:10.000000', 'temperatura', 409.0000, 'ºC'),
	(55445, 108, '2015-02-15 01:08:11.000000', 'temperatura', 248.0000, 'ºC'),
	(55446, 108, '2015-02-15 01:08:12.000000', 'temperatura', 15.0000, 'ºC'),
	(55447, 108, '2015-02-15 01:08:13.000000', 'temperatura', 531.0000, 'ºC'),
	(55448, 108, '2015-02-15 01:08:14.000000', 'temperatura', 210.0000, 'ºC'),
	(55449, 108, '2015-02-15 01:08:15.000000', 'temperatura', 659.0000, 'ºC'),
	(55450, 108, '2015-02-15 01:08:16.000000', 'temperatura', 267.0000, 'ºC'),
	(55451, 108, '2015-02-15 01:08:17.000000', 'temperatura', 556.0000, 'ºC'),
	(55452, 108, '2015-02-15 01:08:18.000000', 'temperatura', 779.0000, 'ºC'),
	(55453, 108, '2015-02-15 01:08:19.000000', 'temperatura', 1029.0000, 'ºC'),
	(55454, 108, '2015-02-15 01:08:20.000000', 'temperatura', 409.0000, 'ºC'),
	(55455, 108, '2015-02-15 01:08:21.000000', 'temperatura', 159.0000, 'ºC'),
	(55456, 108, '2015-02-15 01:08:22.000000', 'temperatura', 770.0000, 'ºC'),
	(55457, 108, '2015-02-15 01:08:23.000000', 'temperatura', 970.0000, 'ºC'),
	(55458, 108, '2015-02-15 01:08:24.000000', 'temperatura', 143.0000, 'ºC'),
	(55459, 108, '2015-02-15 01:08:25.000000', 'temperatura', 204.0000, 'ºC'),
	(55460, 108, '2015-02-15 01:08:26.000000', 'temperatura', 594.0000, 'ºC'),
	(55461, 108, '2015-02-15 01:08:27.000000', 'temperatura', 1157.0000, 'ºC'),
	(55462, 108, '2015-02-15 01:08:28.000000', 'temperatura', 405.0000, 'ºC'),
	(55463, 108, '2015-02-15 01:08:29.000000', 'temperatura', 953.0000, 'ºC'),
	(55464, 108, '2015-02-15 01:08:30.000000', 'temperatura', 1151.0000, 'ºC'),
	(55465, 108, '2015-02-15 01:08:31.000000', 'temperatura', 498.0000, 'ºC'),
	(55466, 108, '2015-02-15 01:08:32.000000', 'temperatura', 234.0000, 'ºC'),
	(55467, 108, '2015-02-15 01:08:33.000000', 'temperatura', 880.0000, 'ºC'),
	(55468, 108, '2015-02-15 01:08:34.000000', 'temperatura', 97.0000, 'ºC'),
	(55469, 108, '2015-02-15 01:08:35.000000', 'temperatura', 245.0000, 'ºC'),
	(55470, 108, '2015-02-15 01:08:36.000000', 'temperatura', 934.0000, 'ºC'),
	(55471, 108, '2015-02-15 01:08:37.000000', 'temperatura', 336.0000, 'ºC'),
	(55472, 108, '2015-02-15 01:08:38.000000', 'temperatura', 78.0000, 'ºC'),
	(55473, 108, '2015-02-15 01:08:39.000000', 'temperatura', 581.0000, 'ºC'),
	(55474, 108, '2015-02-15 01:08:40.000000', 'temperatura', 273.0000, 'ºC'),
	(55475, 108, '2015-02-15 01:08:41.000000', 'temperatura', 824.0000, 'ºC'),
	(55476, 108, '2015-02-15 01:08:42.000000', 'temperatura', 902.0000, 'ºC'),
	(55477, 108, '2015-02-15 01:08:43.000000', 'temperatura', 840.0000, 'ºC'),
	(55478, 108, '2015-02-15 01:08:44.000000', 'temperatura', 291.0000, 'ºC'),
	(55479, 108, '2015-02-15 01:08:45.000000', 'temperatura', 135.0000, 'ºC'),
	(55480, 108, '2015-02-15 01:08:46.000000', 'temperatura', 1003.0000, 'ºC'),
	(55481, 108, '2015-02-15 01:08:47.000000', 'temperatura', 1013.0000, 'ºC'),
	(55482, 108, '2015-02-15 01:08:48.000000', 'temperatura', 854.0000, 'ºC'),
	(55483, 108, '2015-02-15 01:08:49.000000', 'temperatura', 34.0000, 'ºC'),
	(55484, 108, '2015-02-15 01:08:50.000000', 'temperatura', 6.0000, 'ºC'),
	(55485, 108, '2015-02-15 01:08:51.000000', 'temperatura', 1129.0000, 'ºC'),
	(55486, 108, '2015-02-15 01:08:52.000000', 'temperatura', 830.0000, 'ºC'),
	(55487, 108, '2015-02-15 01:08:53.000000', 'temperatura', 760.0000, 'ºC'),
	(55488, 108, '2015-02-15 01:08:54.000000', 'temperatura', 112.0000, 'ºC'),
	(55489, 108, '2015-02-15 01:08:55.000000', 'temperatura', 679.0000, 'ºC'),
	(55490, 108, '2015-02-15 01:08:56.000000', 'temperatura', 661.0000, 'ºC'),
	(55491, 108, '2015-02-15 01:08:57.000000', 'temperatura', 67.0000, 'ºC'),
	(55492, 108, '2015-02-15 01:08:58.000000', 'temperatura', 754.0000, 'ºC'),
	(55493, 108, '2015-02-15 01:08:59.000000', 'temperatura', 1168.0000, 'ºC'),
	(55494, 108, '2015-02-15 01:09:00.000000', 'temperatura', 1177.0000, 'ºC'),
	(55495, 108, '2015-02-15 01:09:01.000000', 'temperatura', 1183.0000, 'ºC'),
	(55496, 108, '2015-02-15 01:09:02.000000', 'temperatura', 1186.0000, 'ºC'),
	(55497, 108, '2015-02-15 01:09:03.000000', 'temperatura', 1179.0000, 'ºC'),
	(55498, 108, '2015-02-15 01:09:04.000000', 'temperatura', 1139.0000, 'ºC'),
	(55499, 108, '2015-02-15 01:09:05.000000', 'temperatura', 959.0000, 'ºC'),
	(55500, 108, '2015-02-15 01:09:06.000000', 'temperatura', 179.0000, 'ºC'),
	(55501, 108, '2015-02-15 01:09:07.000000', 'temperatura', 416.0000, 'ºC'),
	(55502, 108, '2015-02-15 01:09:08.000000', 'temperatura', 344.0000, 'ºC'),
	(55503, 108, '2015-02-15 01:09:09.000000', 'temperatura', 474.0000, 'ºC'),
	(55504, 108, '2015-02-15 01:09:10.000000', 'temperatura', 136.0000, 'ºC'),
	(55505, 108, '2015-02-15 01:09:11.000000', 'temperatura', 461.0000, 'ºC'),
	(55506, 108, '2015-02-15 01:09:12.000000', 'temperatura', 695.0000, 'ºC'),
	(55507, 108, '2015-02-15 01:09:13.000000', 'temperatura', 895.0000, 'ºC'),
	(55508, 108, '2015-02-15 01:09:14.000000', 'temperatura', 1188.0000, 'ºC'),
	(55509, 108, '2015-02-15 01:09:15.000000', 'temperatura', 857.0000, 'ºC'),
	(55510, 108, '2015-02-15 01:09:16.000000', 'temperatura', 719.0000, 'ºC'),
	(55511, 108, '2015-02-15 01:09:17.000000', 'temperatura', 1028.0000, 'ºC'),
	(55512, 108, '2015-02-15 01:09:18.000000', 'temperatura', 582.0000, 'ºC'),
	(55513, 108, '2015-02-15 01:09:19.000000', 'temperatura', 1028.0000, 'ºC'),
	(55514, 108, '2015-02-15 01:09:20.000000', 'temperatura', 995.0000, 'ºC'),
	(55515, 108, '2015-02-15 01:09:21.000000', 'temperatura', 692.0000, 'ºC'),
	(55516, 108, '2015-02-15 01:09:22.000000', 'temperatura', 473.0000, 'ºC'),
	(55517, 108, '2015-02-15 01:09:23.000000', 'temperatura', 292.0000, 'ºC'),
	(55518, 108, '2015-02-15 01:09:24.000000', 'temperatura', 41.0000, 'ºC'),
	(55519, 108, '2015-02-15 01:09:25.000000', 'temperatura', 528.0000, 'ºC'),
	(55520, 108, '2015-02-15 01:09:26.000000', 'temperatura', 118.0000, 'ºC'),
	(55521, 108, '2015-02-15 01:09:27.000000', 'temperatura', 206.0000, 'ºC'),
	(55522, 108, '2015-02-15 01:09:28.000000', 'temperatura', 675.0000, 'ºC'),
	(55523, 108, '2015-02-15 01:09:29.000000', 'temperatura', 361.0000, 'ºC'),
	(55524, 108, '2015-02-15 01:09:30.000000', 'temperatura', 977.0000, 'ºC'),
	(55525, 108, '2015-02-15 01:09:31.000000', 'temperatura', 205.0000, 'ºC'),
	(55526, 108, '2015-02-15 01:09:32.000000', 'temperatura', 495.0000, 'ºC'),
	(55527, 108, '2015-02-15 01:09:33.000000', 'temperatura', 661.0000, 'ºC'),
	(55528, 108, '2015-02-15 01:09:34.000000', 'temperatura', 621.0000, 'ºC'),
	(55529, 108, '2015-02-15 01:09:35.000000', 'temperatura', 1121.0000, 'ºC'),
	(55530, 108, '2015-02-15 01:09:36.000000', 'temperatura', 145.0000, 'ºC'),
	(55531, 108, '2015-02-15 01:09:37.000000', 'temperatura', 961.0000, 'ºC'),
	(55532, 108, '2015-02-15 01:09:38.000000', 'temperatura', 769.0000, 'ºC'),
	(55533, 108, '2015-02-15 01:09:39.000000', 'temperatura', 965.0000, 'ºC'),
	(55534, 108, '2015-02-15 01:09:40.000000', 'temperatura', 119.0000, 'ºC'),
	(55535, 108, '2015-02-15 01:09:41.000000', 'temperatura', 101.0000, 'ºC'),
	(55536, 108, '2015-02-15 01:09:42.000000', 'temperatura', 146.0000, 'ºC'),
	(55537, 108, '2015-02-15 01:09:43.000000', 'temperatura', 429.0000, 'ºC'),
	(55538, 108, '2015-02-15 01:09:44.000000', 'temperatura', 507.0000, 'ºC'),
	(55539, 108, '2015-02-15 01:09:45.000000', 'temperatura', 47.0000, 'ºC'),
	(55540, 108, '2015-02-15 01:09:46.000000', 'temperatura', 1117.0000, 'ºC'),
	(55541, 108, '2015-02-15 01:09:47.000000', 'temperatura', 643.0000, 'ºC'),
	(55542, 108, '2015-02-15 01:09:48.000000', 'temperatura', 1065.0000, 'ºC'),
	(55543, 108, '2015-02-15 01:09:49.000000', 'temperatura', 997.0000, 'ºC'),
	(55544, 108, '2015-02-15 01:09:50.000000', 'temperatura', 589.0000, 'ºC'),
	(55545, 108, '2015-02-15 01:09:51.000000', 'temperatura', 1157.0000, 'ºC'),
	(55546, 108, '2015-02-15 01:09:52.000000', 'temperatura', 416.0000, 'ºC'),
	(55547, 108, '2015-02-15 01:09:53.000000', 'temperatura', 1008.0000, 'ºC'),
	(55548, 108, '2015-02-15 01:09:54.000000', 'temperatura', 195.0000, 'ºC'),
	(55549, 108, '2015-02-15 01:09:55.000000', 'temperatura', 353.0000, 'ºC'),
	(55550, 108, '2015-02-15 01:09:56.000000', 'temperatura', 1179.0000, 'ºC'),
	(55551, 108, '2015-02-15 01:09:57.000000', 'temperatura', 37.0000, 'ºC'),
	(55552, 108, '2015-02-15 01:09:58.000000', 'temperatura', 248.0000, 'ºC'),
	(55553, 108, '2015-02-15 01:09:59.000000', 'temperatura', 1129.0000, 'ºC'),
	(55554, 108, '2015-02-15 01:10:00.000000', 'temperatura', 104.0000, 'ºC'),
	(55555, 108, '2015-02-15 01:10:01.000000', 'temperatura', 732.0000, 'ºC'),
	(55556, 108, '2015-02-15 01:10:02.000000', 'temperatura', 950.0000, 'ºC'),
	(55557, 108, '2015-02-15 01:10:03.000000', 'temperatura', 154.0000, 'ºC'),
	(55558, 108, '2015-02-15 01:10:04.000000', 'temperatura', 322.0000, 'ºC'),
	(55559, 108, '2015-02-15 01:10:05.000000', 'temperatura', 1145.0000, 'ºC'),
	(55560, 108, '2015-02-15 01:10:06.000000', 'temperatura', 1162.0000, 'ºC'),
	(55561, 108, '2015-02-15 01:10:07.000000', 'temperatura', 1176.0000, 'ºC'),
	(55562, 108, '2015-02-15 01:10:08.000000', 'temperatura', 1194.0000, 'ºC'),
	(55563, 108, '2015-02-15 01:10:09.000000', 'temperatura', 43.0000, 'ºC'),
	(55564, 108, '2015-02-15 01:10:10.000000', 'temperatura', 232.0000, 'ºC'),
	(55565, 108, '2015-02-15 01:10:11.000000', 'temperatura', 1033.0000, 'ºC'),
	(55566, 108, '2015-02-15 01:10:12.000000', 'temperatura', 871.0000, 'ºC'),
	(55567, 108, '2015-02-15 01:10:13.000000', 'temperatura', 53.0000, 'ºC'),
	(55568, 108, '2015-02-15 01:10:14.000000', 'temperatura', 55.0000, 'ºC'),
	(55569, 108, '2015-02-15 01:10:15.000000', 'temperatura', 117.0000, 'ºC'),
	(55570, 108, '2015-02-15 01:10:16.000000', 'temperatura', 420.0000, 'ºC'),
	(55571, 108, '2015-02-15 01:10:17.000000', 'temperatura', 548.0000, 'ºC'),
	(55572, 108, '2015-02-15 01:10:18.000000', 'temperatura', 279.0000, 'ºC'),
	(55573, 108, '2015-02-15 01:10:19.000000', 'temperatura', 955.0000, 'ºC'),
	(55574, 108, '2015-02-15 01:10:20.000000', 'temperatura', 335.0000, 'ºC'),
	(55575, 108, '2015-02-15 01:10:21.000000', 'temperatura', 13.0000, 'ºC'),
	(55576, 108, '2015-02-15 01:10:22.000000', 'temperatura', 259.0000, 'ºC'),
	(55577, 108, '2015-02-15 01:10:23.000000', 'temperatura', 55.0000, 'ºC'),
	(55578, 108, '2015-02-15 01:10:24.000000', 'temperatura', 701.0000, 'ºC'),
	(55579, 108, '2015-02-15 01:10:25.000000', 'temperatura', 941.0000, 'ºC'),
	(55580, 108, '2015-02-15 01:10:26.000000', 'temperatura', 201.0000, 'ºC'),
	(55581, 108, '2015-02-15 01:10:27.000000', 'temperatura', 583.0000, 'ºC'),
	(55582, 108, '2015-02-15 01:10:28.000000', 'temperatura', 1111.0000, 'ºC'),
	(55583, 108, '2015-02-15 01:10:29.000000', 'temperatura', 208.0000, 'ºC'),
	(55584, 108, '2015-02-15 01:10:30.000000', 'temperatura', 108.0000, 'ºC'),
	(55585, 108, '2015-02-15 01:10:31.000000', 'temperatura', 1118.0000, 'ºC'),
	(55586, 108, '2015-02-15 01:10:32.000000', 'temperatura', 465.0000, 'ºC'),
	(55587, 108, '2015-02-15 01:10:33.000000', 'temperatura', 169.0000, 'ºC'),
	(55588, 108, '2015-02-15 01:10:34.000000', 'temperatura', 654.0000, 'ºC'),
	(55589, 108, '2015-02-15 01:10:35.000000', 'temperatura', 363.0000, 'ºC'),
	(55590, 108, '2015-02-15 01:10:36.000000', 'temperatura', 1051.0000, 'ºC'),
	(55591, 108, '2015-02-15 01:10:37.000000', 'temperatura', 568.0000, 'ºC'),
	(55592, 108, '2015-02-15 01:10:38.000000', 'temperatura', 890.0000, 'ºC'),
	(55593, 108, '2015-02-15 01:10:39.000000', 'temperatura', 343.0000, 'ºC'),
	(55594, 108, '2015-02-15 01:10:40.000000', 'temperatura', 245.0000, 'ºC'),
	(55595, 108, '2015-02-15 01:10:41.000000', 'temperatura', 197.0000, 'ºC'),
	(55596, 108, '2015-02-15 01:10:42.000000', 'temperatura', 252.0000, 'ºC'),
	(55597, 108, '2015-02-15 01:10:43.000000', 'temperatura', 668.0000, 'ºC'),
	(55598, 108, '2015-02-15 01:10:44.000000', 'temperatura', 183.0000, 'ºC'),
	(55599, 108, '2015-02-15 01:10:45.000000', 'temperatura', 114.0000, 'ºC'),
	(55600, 108, '2015-02-15 01:10:46.000000', 'temperatura', 19.0000, 'ºC'),
	(55601, 108, '2015-02-15 01:10:47.000000', 'temperatura', 956.0000, 'ºC'),
	(55602, 108, '2015-02-15 01:10:48.000000', 'temperatura', 1123.0000, 'ºC'),
	(55603, 108, '2015-02-15 01:10:49.000000', 'temperatura', 347.0000, 'ºC'),
	(55604, 108, '2015-02-15 01:10:50.000000', 'temperatura', 766.0000, 'ºC'),
	(55605, 108, '2015-02-15 01:10:51.000000', 'temperatura', 392.0000, 'ºC'),
	(55606, 108, '2015-02-15 01:10:52.000000', 'temperatura', 860.0000, 'ºC'),
	(55607, 108, '2015-02-15 01:10:53.000000', 'temperatura', 724.0000, 'ºC'),
	(55608, 108, '2015-02-15 01:10:54.000000', 'temperatura', 1040.0000, 'ºC'),
	(55609, 108, '2015-02-15 01:10:55.000000', 'temperatura', 631.0000, 'ºC'),
	(55610, 108, '2015-02-15 01:10:56.000000', 'temperatura', 35.0000, 'ºC'),
	(55611, 108, '2015-02-15 01:10:57.000000', 'temperatura', 682.0000, 'ºC'),
	(55612, 108, '2015-02-15 01:10:58.000000', 'temperatura', 908.0000, 'ºC'),
	(55613, 108, '2015-02-15 01:10:59.000000', 'temperatura', 91.0000, 'ºC'),
	(55614, 108, '2015-02-15 01:11:00.000000', 'temperatura', 132.0000, 'ºC'),
	(55615, 108, '2015-02-15 01:11:01.000000', 'temperatura', 388.0000, 'ºC'),
	(55616, 108, '2015-02-15 01:11:02.000000', 'temperatura', 344.0000, 'ºC'),
	(55617, 108, '2015-02-15 01:11:03.000000', 'temperatura', 558.0000, 'ºC'),
	(55618, 108, '2015-02-15 01:11:04.000000', 'temperatura', 557.0000, 'ºC'),
	(55619, 108, '2015-02-15 01:11:05.000000', 'temperatura', 1111.0000, 'ºC'),
	(55620, 108, '2015-02-15 01:11:06.000000', 'temperatura', 285.0000, 'ºC'),
	(55621, 108, '2015-02-15 01:11:07.000000', 'temperatura', 493.0000, 'ºC'),
	(55622, 108, '2015-02-15 01:11:08.000000', 'temperatura', 410.0000, 'ºC'),
	(55623, 108, '2015-02-15 01:11:09.000000', 'temperatura', 571.0000, 'ºC'),
	(55624, 108, '2015-02-15 01:11:10.000000', 'temperatura', 424.0000, 'ºC'),
	(55625, 108, '2015-02-15 01:11:11.000000', 'temperatura', 409.0000, 'ºC'),
	(55626, 108, '2015-02-15 01:11:12.000000', 'temperatura', 774.0000, 'ºC'),
	(55627, 108, '2015-02-15 01:11:13.000000', 'temperatura', 245.0000, 'ºC'),
	(55628, 108, '2015-02-15 01:11:14.000000', 'temperatura', 101.0000, 'ºC'),
	(55629, 108, '2015-02-15 01:11:15.000000', 'temperatura', 972.0000, 'ºC'),
	(55630, 108, '2015-02-15 01:11:16.000000', 'temperatura', 959.0000, 'ºC'),
	(55631, 108, '2015-02-15 01:11:17.000000', 'temperatura', 678.0000, 'ºC'),
	(55632, 108, '2015-02-15 01:11:18.000000', 'temperatura', 514.0000, 'ºC'),
	(55633, 108, '2015-02-15 01:11:19.000000', 'temperatura', 534.0000, 'ºC'),
	(55634, 108, '2015-02-15 01:11:20.000000', 'temperatura', 1131.0000, 'ºC'),
	(55635, 108, '2015-02-15 01:11:21.000000', 'temperatura', 455.0000, 'ºC'),
	(55636, 108, '2015-02-15 01:11:22.000000', 'temperatura', 80.0000, 'ºC'),
	(55637, 108, '2015-02-15 01:11:23.000000', 'temperatura', 237.0000, 'ºC'),
	(55638, 108, '2015-02-15 01:11:24.000000', 'temperatura', 946.0000, 'ºC'),
	(55639, 108, '2015-02-15 01:11:25.000000', 'temperatura', 419.0000, 'ºC'),
	(55640, 108, '2015-02-15 01:11:26.000000', 'temperatura', 456.0000, 'ºC'),
	(55641, 108, '2015-02-15 01:11:27.000000', 'temperatura', 1026.0000, 'ºC'),
	(55642, 108, '2015-02-15 01:11:28.000000', 'temperatura', 163.0000, 'ºC'),
	(55643, 108, '2015-02-15 01:11:29.000000', 'temperatura', 135.0000, 'ºC'),
	(55644, 108, '2015-02-15 01:11:30.000000', 'temperatura', 188.0000, 'ºC'),
	(55645, 108, '2015-02-15 01:11:31.000000', 'temperatura', 535.0000, 'ºC'),
	(55646, 108, '2015-02-15 01:11:32.000000', 'temperatura', 912.0000, 'ºC'),
	(55647, 108, '2015-02-15 01:11:33.000000', 'temperatura', 556.0000, 'ºC'),
	(55648, 108, '2015-02-15 01:11:34.000000', 'temperatura', 46.0000, 'ºC'),
	(55649, 108, '2015-02-15 01:11:35.000000', 'temperatura', 961.0000, 'ºC'),
	(55650, 108, '2015-02-15 01:11:36.000000', 'temperatura', 1067.0000, 'ºC'),
	(55651, 108, '2015-02-15 01:11:37.000000', 'temperatura', 51.0000, 'ºC'),
	(55652, 108, '2015-02-15 01:11:38.000000', 'temperatura', 657.0000, 'ºC'),
	(55653, 108, '2015-02-15 01:11:39.000000', 'temperatura', 732.0000, 'ºC'),
	(55654, 108, '2015-02-15 01:11:40.000000', 'temperatura', 489.0000, 'ºC'),
	(55655, 108, '2015-02-15 01:11:41.000000', 'temperatura', 248.0000, 'ºC'),
	(55656, 108, '2015-02-15 01:11:42.000000', 'temperatura', 973.0000, 'ºC'),
	(55657, 108, '2015-02-15 01:11:43.000000', 'temperatura', 522.0000, 'ºC'),
	(55658, 108, '2015-02-15 01:11:44.000000', 'temperatura', 893.0000, 'ºC'),
	(55659, 108, '2015-02-15 01:11:45.000000', 'temperatura', 500.0000, 'ºC'),
	(55660, 108, '2015-02-15 01:11:46.000000', 'temperatura', 1022.0000, 'ºC'),
	(55661, 108, '2015-02-15 01:11:47.000000', 'temperatura', 10.0000, 'ºC'),
	(55662, 108, '2015-02-15 01:11:48.000000', 'temperatura', 584.0000, 'ºC'),
	(55663, 108, '2015-02-15 01:11:49.000000', 'temperatura', 489.0000, 'ºC'),
	(55664, 108, '2015-02-15 01:11:50.000000', 'temperatura', 696.0000, 'ºC'),
	(55665, 108, '2015-02-15 01:11:51.000000', 'temperatura', 812.0000, 'ºC'),
	(55666, 108, '2015-02-15 01:11:52.000000', 'temperatura', 774.0000, 'ºC'),
	(55667, 108, '2015-02-15 01:11:53.000000', 'temperatura', 233.0000, 'ºC'),
	(55668, 108, '2015-02-15 01:11:54.000000', 'temperatura', 42.0000, 'ºC'),
	(55669, 108, '2015-02-15 01:11:55.000000', 'temperatura', 714.0000, 'ºC'),
	(55670, 108, '2015-02-15 01:11:56.000000', 'temperatura', 1042.0000, 'ºC'),
	(55671, 108, '2015-02-15 01:11:57.000000', 'temperatura', 668.0000, 'ºC'),
	(55672, 108, '2015-02-15 01:11:58.000000', 'temperatura', 217.0000, 'ºC'),
	(55673, 108, '2015-02-15 01:11:59.000000', 'temperatura', 280.0000, 'ºC'),
	(55674, 108, '2015-02-15 01:12:00.000000', 'temperatura', 751.0000, 'ºC'),
	(55675, 108, '2015-02-15 01:12:01.000000', 'temperatura', 515.0000, 'ºC'),
	(55676, 108, '2015-02-15 01:12:02.000000', 'temperatura', 323.0000, 'ºC'),
	(55677, 108, '2015-02-15 01:12:03.000000', 'temperatura', 68.0000, 'ºC'),
	(55678, 108, '2015-02-15 01:12:04.000000', 'temperatura', 575.0000, 'ºC'),
	(55679, 108, '2015-02-15 01:12:05.000000', 'temperatura', 269.0000, 'ºC'),
	(55680, 108, '2015-02-15 01:12:06.000000', 'temperatura', 820.0000, 'ºC'),
	(55681, 108, '2015-02-15 01:12:07.000000', 'temperatura', 893.0000, 'ºC'),
	(55682, 108, '2015-02-15 01:12:08.000000', 'temperatura', 806.0000, 'ºC'),
	(55683, 108, '2015-02-15 01:12:09.000000', 'temperatura', 152.0000, 'ºC'),
	(55684, 108, '2015-02-15 01:12:10.000000', 'temperatura', 741.0000, 'ºC'),
	(55685, 108, '2015-02-15 01:12:11.000000', 'temperatura', 851.0000, 'ºC'),
	(55686, 108, '2015-02-15 01:12:12.000000', 'temperatura', 834.0000, 'ºC'),
	(55687, 108, '2015-02-15 01:12:13.000000', 'temperatura', 415.0000, 'ºC'),
	(55688, 108, '2015-02-15 01:12:14.000000', 'temperatura', 772.0000, 'ºC'),
	(55689, 108, '2015-02-15 01:12:15.000000', 'temperatura', 219.0000, 'ºC'),
	(55690, 108, '2015-02-15 01:12:16.000000', 'temperatura', 1179.0000, 'ºC'),
	(55691, 108, '2015-02-15 01:12:17.000000', 'temperatura', 437.0000, 'ºC'),
	(55692, 108, '2015-02-15 01:12:18.000000', 'temperatura', 1049.0000, 'ºC'),
	(55693, 108, '2015-02-15 01:12:19.000000', 'temperatura', 334.0000, 'ºC'),
	(55694, 108, '2015-02-15 01:12:20.000000', 'temperatura', 922.0000, 'ºC'),
	(55695, 108, '2015-02-15 01:12:21.000000', 'temperatura', 10.0000, 'ºC'),
	(55696, 108, '2015-02-15 01:12:22.000000', 'temperatura', 885.0000, 'ºC'),
	(55697, 108, '2015-02-15 01:12:23.000000', 'temperatura', 795.0000, 'ºC'),
	(55698, 108, '2015-02-15 01:12:24.000000', 'temperatura', 119.0000, 'ºC'),
	(55699, 108, '2015-02-15 01:12:25.000000', 'temperatura', 609.0000, 'ºC'),
	(55700, 108, '2015-02-15 01:12:26.000000', 'temperatura', 292.0000, 'ºC'),
	(55701, 108, '2015-02-15 01:12:27.000000', 'temperatura', 834.0000, 'ºC'),
	(55702, 108, '2015-02-15 01:12:28.000000', 'temperatura', 894.0000, 'ºC'),
	(55703, 108, '2015-02-15 01:12:29.000000', 'temperatura', 768.0000, 'ºC'),
	(55704, 108, '2015-02-15 01:12:30.000000', 'temperatura', 1158.0000, 'ºC'),
	(55705, 108, '2015-02-15 01:12:31.000000', 'temperatura', 1086.0000, 'ºC'),
	(55706, 108, '2015-02-15 01:12:32.000000', 'temperatura', 756.0000, 'ºC'),
	(55707, 108, '2015-02-15 01:12:33.000000', 'temperatura', 524.0000, 'ºC'),
	(55708, 108, '2015-02-15 01:12:34.000000', 'temperatura', 351.0000, 'ºC'),
	(55709, 108, '2015-02-15 01:12:35.000000', 'temperatura', 182.0000, 'ºC'),
	(55710, 108, '2015-02-15 01:12:36.000000', 'temperatura', 1060.0000, 'ºC'),
	(55711, 108, '2015-02-15 01:12:37.000000', 'temperatura', 1156.0000, 'ºC'),
	(55712, 108, '2015-02-15 01:12:38.000000', 'temperatura', 197.0000, 'ºC'),
	(55713, 108, '2015-02-15 01:12:39.000000', 'temperatura', 1118.0000, 'ºC'),
	(55714, 108, '2015-02-15 01:12:40.000000', 'temperatura', 202.0000, 'ºC'),
	(55715, 108, '2015-02-15 01:12:41.000000', 'temperatura', 53.0000, 'ºC'),
	(55716, 108, '2015-02-15 01:12:42.000000', 'temperatura', 862.0000, 'ºC'),
	(55717, 108, '2015-02-15 01:12:43.000000', 'temperatura', 551.0000, 'ºC'),
	(55718, 108, '2015-02-15 01:12:44.000000', 'temperatura', 168.0000, 'ºC'),
	(55719, 108, '2015-02-15 01:12:45.000000', 'temperatura', 388.0000, 'ºC'),
	(55720, 108, '2015-02-15 01:12:46.000000', 'temperatura', 239.0000, 'ºC'),
	(55721, 108, '2015-02-15 01:12:47.000000', 'temperatura', 28.0000, 'ºC'),
	(55722, 108, '2015-02-15 01:12:48.000000', 'temperatura', 625.0000, 'ºC'),
	(55723, 108, '2015-02-15 01:12:49.000000', 'temperatura', 640.0000, 'ºC'),
	(55724, 108, '2015-02-15 01:12:50.000000', 'temperatura', 125.0000, 'ºC'),
	(55725, 108, '2015-02-15 01:12:51.000000', 'temperatura', 1105.0000, 'ºC'),
	(55726, 108, '2015-02-15 01:12:52.000000', 'temperatura', 350.0000, 'ºC'),
	(55727, 108, '2015-02-15 01:12:53.000000', 'temperatura', 839.0000, 'ºC'),
	(55728, 108, '2015-02-15 01:12:54.000000', 'temperatura', 742.0000, 'ºC'),
	(55729, 108, '2015-02-15 01:12:55.000000', 'temperatura', 1195.0000, 'ºC'),
	(55730, 108, '2015-02-15 01:12:56.000000', 'temperatura', 149.0000, 'ºC'),
	(55731, 108, '2015-02-15 01:12:57.000000', 'temperatura', 759.0000, 'ºC'),
	(55732, 108, '2015-02-15 01:12:58.000000', 'temperatura', 950.0000, 'ºC'),
	(55733, 109, '2015-02-15 00:00:00.000000', 'temperatura', 1110.0000, 'ºC'),
	(55734, 109, '2015-02-15 00:00:01.000000', 'temperatura', 534.0000, 'ºC'),
	(55735, 109, '2015-02-15 00:00:02.000000', 'temperatura', 543.0000, 'ºC'),
	(55736, 109, '2015-02-15 00:00:03.000000', 'temperatura', 1113.0000, 'ºC'),
	(55737, 109, '2015-02-15 00:00:04.000000', 'temperatura', 335.0000, 'ºC'),
	(55738, 109, '2015-02-15 00:00:05.000000', 'temperatura', 737.0000, 'ºC'),
	(55739, 109, '2015-02-15 00:00:06.000000', 'temperatura', 280.0000, 'ºC'),
	(55740, 109, '2015-02-15 00:00:07.000000', 'temperatura', 389.0000, 'ºC'),
	(55741, 109, '2015-02-15 00:00:08.000000', 'temperatura', 1105.0000, 'ºC'),
	(55742, 109, '2015-02-15 00:00:09.000000', 'temperatura', 761.0000, 'ºC'),
	(55743, 109, '2015-02-15 00:00:10.000000', 'temperatura', 489.0000, 'ºC'),
	(55744, 109, '2015-02-15 00:00:11.000000', 'temperatura', 163.0000, 'ºC'),
	(55745, 109, '2015-02-15 00:00:12.000000', 'temperatura', 549.0000, 'ºC'),
	(55746, 109, '2015-02-15 00:00:13.000000', 'temperatura', 1054.0000, 'ºC'),
	(55747, 109, '2015-02-15 00:00:14.000000', 'temperatura', 26.0000, 'ºC'),
	(55748, 109, '2015-02-15 00:00:15.000000', 'temperatura', 568.0000, 'ºC'),
	(55749, 109, '2015-02-15 00:00:16.000000', 'temperatura', 362.0000, 'ºC'),
	(55750, 109, '2015-02-15 00:00:17.000000', 'temperatura', 107.0000, 'ºC'),
	(55751, 109, '2015-02-15 00:00:18.000000', 'temperatura', 648.0000, 'ºC'),
	(55752, 109, '2015-02-15 00:00:19.000000', 'temperatura', 519.0000, 'ºC'),
	(55753, 109, '2015-02-15 00:00:20.000000', 'temperatura', 651.0000, 'ºC'),
	(55754, 109, '2015-02-15 00:00:21.000000', 'temperatura', 498.0000, 'ºC'),
	(55755, 109, '2015-02-15 00:00:22.000000', 'temperatura', 538.0000, 'ºC'),
	(55756, 109, '2015-02-15 00:00:23.000000', 'temperatura', 1195.0000, 'ºC'),
	(55757, 109, '2015-02-15 00:00:24.000000', 'temperatura', 764.0000, 'ºC'),
	(55758, 109, '2015-02-15 00:00:25.000000', 'temperatura', 235.0000, 'ºC'),
	(55759, 109, '2015-02-15 00:00:26.000000', 'temperatura', 84.0000, 'ºC'),
	(55760, 109, '2015-02-15 00:00:27.000000', 'temperatura', 915.0000, 'ºC'),
	(55761, 109, '2015-02-15 00:00:28.000000', 'temperatura', 722.0000, 'ºC'),
	(55762, 109, '2015-02-15 00:00:29.000000', 'temperatura', 866.0000, 'ºC'),
	(55763, 109, '2015-02-15 00:00:30.000000', 'temperatura', 964.0000, 'ºC'),
	(55764, 109, '2015-02-15 00:00:31.000000', 'temperatura', 1023.0000, 'ºC'),
	(55765, 109, '2015-02-15 00:00:32.000000', 'temperatura', 1025.0000, 'ºC'),
	(55766, 109, '2015-02-15 00:00:33.000000', 'temperatura', 854.0000, 'ºC'),
	(55767, 109, '2015-02-15 00:00:34.000000', 'temperatura', 1195.0000, 'ºC'),
	(55768, 109, '2015-02-15 00:00:35.000000', 'temperatura', 1015.0000, 'ºC'),
	(55769, 109, '2015-02-15 00:00:36.000000', 'temperatura', 291.0000, 'ºC'),
	(55770, 109, '2015-02-15 00:00:37.000000', 'temperatura', 812.0000, 'ºC'),
	(55771, 109, '2015-02-15 00:00:38.000000', 'temperatura', 785.0000, 'ºC'),
	(55772, 109, '2015-02-15 00:00:39.000000', 'temperatura', 290.0000, 'ºC'),
	(55773, 109, '2015-02-15 00:00:40.000000', 'temperatura', 296.0000, 'ºC'),
	(55774, 109, '2015-02-15 00:00:41.000000', 'temperatura', 610.0000, 'ºC'),
	(55775, 109, '2015-02-15 00:00:42.000000', 'temperatura', 964.0000, 'ºC'),
	(55776, 109, '2015-02-15 00:00:43.000000', 'temperatura', 587.0000, 'ºC'),
	(55777, 109, '2015-02-15 00:00:44.000000', 'temperatura', 47.0000, 'ºC'),
	(55778, 109, '2015-02-15 00:00:45.000000', 'temperatura', 875.0000, 'ºC'),
	(55779, 109, '2015-02-15 00:00:46.000000', 'temperatura', 634.0000, 'ºC'),
	(55780, 109, '2015-02-15 00:00:47.000000', 'temperatura', 546.0000, 'ºC'),
	(55781, 109, '2015-02-15 00:00:48.000000', 'temperatura', 830.0000, 'ºC'),
	(55782, 109, '2015-02-15 00:00:49.000000', 'temperatura', 110.0000, 'ºC'),
	(55783, 109, '2015-02-15 00:00:50.000000', 'temperatura', 460.0000, 'ºC'),
	(55784, 109, '2015-02-15 00:00:51.000000', 'temperatura', 772.0000, 'ºC'),
	(55785, 109, '2015-02-15 00:00:52.000000', 'temperatura', 81.0000, 'ºC'),
	(55786, 109, '2015-02-15 00:00:53.000000', 'temperatura', 490.0000, 'ºC'),
	(55787, 109, '2015-02-15 00:00:54.000000', 'temperatura', 1005.0000, 'ºC'),
	(55788, 109, '2015-02-15 00:00:55.000000', 'temperatura', 1155.0000, 'ºC'),
	(55789, 109, '2015-02-15 00:00:56.000000', 'temperatura', 363.0000, 'ºC'),
	(55790, 109, '2015-02-15 00:00:57.000000', 'temperatura', 750.0000, 'ºC'),
	(55791, 109, '2015-02-15 00:00:58.000000', 'temperatura', 262.0000, 'ºC'),
	(55792, 109, '2015-02-15 00:00:59.000000', 'temperatura', 261.0000, 'ºC'),
	(55793, 109, '2015-02-15 00:01:00.000000', 'temperatura', 518.0000, 'ºC'),
	(55794, 109, '2015-02-15 00:01:01.000000', 'temperatura', 607.0000, 'ºC'),
	(55795, 109, '2015-02-15 00:01:02.000000', 'temperatura', 283.0000, 'ºC'),
	(55796, 109, '2015-02-15 00:01:03.000000', 'temperatura', 792.0000, 'ºC'),
	(55797, 109, '2015-02-15 00:01:04.000000', 'temperatura', 714.0000, 'ºC'),
	(55798, 109, '2015-02-15 00:01:05.000000', 'temperatura', 1192.0000, 'ºC'),
	(55799, 109, '2015-02-15 00:01:06.000000', 'temperatura', 218.0000, 'ºC'),
	(55800, 109, '2015-02-15 00:01:07.000000', 'temperatura', 1117.0000, 'ºC'),
	(55801, 109, '2015-02-15 00:01:08.000000', 'temperatura', 129.0000, 'ºC'),
	(55802, 109, '2015-02-15 00:01:09.000000', 'temperatura', 894.0000, 'ºC'),
	(55803, 109, '2015-02-15 00:01:10.000000', 'temperatura', 486.0000, 'ºC'),
	(55804, 109, '2015-02-15 00:01:11.000000', 'temperatura', 945.0000, 'ºC'),
	(55805, 109, '2015-02-15 00:01:12.000000', 'temperatura', 871.0000, 'ºC'),
	(55806, 109, '2015-02-15 00:01:13.000000', 'temperatura', 320.0000, 'ºC'),
	(55807, 109, '2015-02-15 00:01:14.000000', 'temperatura', 188.0000, 'ºC'),
	(55808, 109, '2015-02-15 00:01:15.000000', 'temperatura', 1180.0000, 'ºC'),
	(55809, 109, '2015-02-15 00:01:16.000000', 'temperatura', 535.0000, 'ºC'),
	(55810, 109, '2015-02-15 00:01:17.000000', 'temperatura', 337.0000, 'ºC'),
	(55811, 109, '2015-02-15 00:01:18.000000', 'temperatura', 79.0000, 'ºC'),
	(55812, 109, '2015-02-15 00:01:19.000000', 'temperatura', 585.0000, 'ºC'),
	(55813, 109, '2015-02-15 00:01:20.000000', 'temperatura', 290.0000, 'ºC'),
	(55814, 109, '2015-02-15 00:01:21.000000', 'temperatura', 895.0000, 'ºC'),
	(55815, 109, '2015-02-15 00:01:22.000000', 'temperatura', 4.0000, 'ºC'),
	(55816, 109, '2015-02-15 00:01:23.000000', 'temperatura', 938.0000, 'ºC'),
	(55817, 109, '2015-02-15 00:01:24.000000', 'temperatura', 1077.0000, 'ºC'),
	(55818, 109, '2015-02-15 00:01:25.000000', 'temperatura', 170.0000, 'ºC'),
	(55819, 109, '2015-02-15 00:01:26.000000', 'temperatura', 22.0000, 'ºC'),
	(55820, 109, '2015-02-15 00:01:27.000000', 'temperatura', 802.0000, 'ºC'),
	(55821, 109, '2015-02-15 00:01:28.000000', 'temperatura', 341.0000, 'ºC'),
	(55822, 109, '2015-02-15 00:01:29.000000', 'temperatura', 500.0000, 'ºC'),
	(55823, 109, '2015-02-15 00:01:30.000000', 'temperatura', 277.0000, 'ºC'),
	(55824, 109, '2015-02-15 00:01:31.000000', 'temperatura', 1085.0000, 'ºC'),
	(55825, 109, '2015-02-15 00:01:32.000000', 'temperatura', 996.0000, 'ºC'),
	(55826, 109, '2015-02-15 00:01:33.000000', 'temperatura', 524.0000, 'ºC'),
	(55827, 109, '2015-02-15 00:01:34.000000', 'temperatura', 833.0000, 'ºC'),
	(55828, 109, '2015-02-15 00:01:35.000000', 'temperatura', 194.0000, 'ºC'),
	(55829, 109, '2015-02-15 00:01:36.000000', 'temperatura', 870.0000, 'ºC'),
	(55830, 109, '2015-02-15 00:01:37.000000', 'temperatura', 168.0000, 'ºC'),
	(55831, 109, '2015-02-15 00:01:38.000000', 'temperatura', 633.0000, 'ºC'),
	(55832, 109, '2015-02-15 00:01:39.000000', 'temperatura', 262.0000, 'ºC'),
	(55833, 109, '2015-02-15 00:01:40.000000', 'temperatura', 609.0000, 'ºC'),
	(55834, 109, '2015-02-15 00:01:41.000000', 'temperatura', 1058.0000, 'ºC'),
	(55835, 109, '2015-02-15 00:01:42.000000', 'temperatura', 1067.0000, 'ºC'),
	(55836, 109, '2015-02-15 00:01:43.000000', 'temperatura', 961.0000, 'ºC'),
	(55837, 109, '2015-02-15 00:01:44.000000', 'temperatura', 403.0000, 'ºC'),
	(55838, 109, '2015-02-15 00:01:45.000000', 'temperatura', 335.0000, 'ºC'),
	(55839, 109, '2015-02-15 00:01:46.000000', 'temperatura', 464.0000, 'ºC'),
	(55840, 109, '2015-02-15 00:01:47.000000', 'temperatura', 117.0000, 'ºC'),
	(55841, 109, '2015-02-15 00:01:48.000000', 'temperatura', 391.0000, 'ºC'),
	(55842, 109, '2015-02-15 00:01:49.000000', 'temperatura', 407.0000, 'ºC'),
	(55843, 109, '2015-02-15 00:01:50.000000', 'temperatura', 863.0000, 'ºC'),
	(55844, 109, '2015-02-15 00:01:51.000000', 'temperatura', 693.0000, 'ºC'),
	(55845, 109, '2015-02-15 00:01:52.000000', 'temperatura', 875.0000, 'ºC'),
	(55846, 109, '2015-02-15 00:01:53.000000', 'temperatura', 1099.0000, 'ºC'),
	(55847, 109, '2015-02-15 00:01:54.000000', 'temperatura', 470.0000, 'ºC'),
	(55848, 109, '2015-02-15 00:01:55.000000', 'temperatura', 253.0000, 'ºC'),
	(55849, 109, '2015-02-15 00:01:56.000000', 'temperatura', 1056.0000, 'ºC'),
	(55850, 109, '2015-02-15 00:01:57.000000', 'temperatura', 923.0000, 'ºC'),
	(55851, 109, '2015-02-15 00:01:58.000000', 'temperatura', 246.0000, 'ºC'),
	(55852, 109, '2015-02-15 00:01:59.000000', 'temperatura', 862.0000, 'ºC'),
	(55853, 109, '2015-02-15 00:02:00.000000', 'temperatura', 1174.0000, 'ºC'),
	(55854, 109, '2015-02-15 00:02:01.000000', 'temperatura', 882.0000, 'ºC'),
	(55855, 109, '2015-02-15 00:02:02.000000', 'temperatura', 889.0000, 'ºC'),
	(55856, 109, '2015-02-15 00:02:03.000000', 'temperatura', 598.0000, 'ºC'),
	(55857, 109, '2015-02-15 00:02:04.000000', 'temperatura', 326.0000, 'ºC'),
	(55858, 109, '2015-02-15 00:02:05.000000', 'temperatura', 1034.0000, 'ºC'),
	(55859, 109, '2015-02-15 00:02:06.000000', 'temperatura', 592.0000, 'ºC'),
	(55860, 109, '2015-02-15 00:02:07.000000', 'temperatura', 1058.0000, 'ºC'),
	(55861, 109, '2015-02-15 00:02:08.000000', 'temperatura', 1115.0000, 'ºC'),
	(55862, 109, '2015-02-15 00:02:09.000000', 'temperatura', 1.0000, 'ºC'),
	(55863, 109, '2015-02-15 00:02:10.000000', 'temperatura', 259.0000, 'ºC'),
	(55864, 109, '2015-02-15 00:02:11.000000', 'temperatura', 94.0000, 'ºC'),
	(55865, 109, '2015-02-15 00:02:12.000000', 'temperatura', 895.0000, 'ºC'),
	(55866, 109, '2015-02-15 00:02:13.000000', 'temperatura', 592.0000, 'ºC'),
	(55867, 109, '2015-02-15 00:02:14.000000', 'temperatura', 274.0000, 'ºC'),
	(55868, 109, '2015-02-15 00:02:15.000000', 'temperatura', 795.0000, 'ºC'),
	(55869, 109, '2015-02-15 00:02:16.000000', 'temperatura', 753.0000, 'ºC'),
	(55870, 109, '2015-02-15 00:02:17.000000', 'temperatura', 183.0000, 'ºC'),
	(55871, 109, '2015-02-15 00:02:18.000000', 'temperatura', 1056.0000, 'ºC'),
	(55872, 109, '2015-02-15 00:02:19.000000', 'temperatura', 1130.0000, 'ºC'),
	(55873, 109, '2015-02-15 00:02:20.000000', 'temperatura', 85.0000, 'ºC'),
	(55874, 109, '2015-02-15 00:02:21.000000', 'temperatura', 634.0000, 'ºC'),
	(55875, 109, '2015-02-15 00:02:22.000000', 'temperatura', 514.0000, 'ºC'),
	(55876, 109, '2015-02-15 00:02:23.000000', 'temperatura', 672.0000, 'ºC'),
	(55877, 109, '2015-02-15 00:02:24.000000', 'temperatura', 615.0000, 'ºC'),
	(55878, 109, '2015-02-15 00:02:25.000000', 'temperatura', 1062.0000, 'ºC'),
	(55879, 109, '2015-02-15 00:02:26.000000', 'temperatura', 1064.0000, 'ºC'),
	(55880, 109, '2015-02-15 00:02:27.000000', 'temperatura', 933.0000, 'ºC'),
	(55881, 109, '2015-02-15 00:02:28.000000', 'temperatura', 275.0000, 'ºC'),
	(55882, 109, '2015-02-15 00:02:29.000000', 'temperatura', 977.0000, 'ºC'),
	(55883, 109, '2015-02-15 00:02:30.000000', 'temperatura', 459.0000, 'ºC'),
	(55884, 109, '2015-02-15 00:02:31.000000', 'temperatura', 564.0000, 'ºC'),
	(55885, 109, '2015-02-15 00:02:32.000000', 'temperatura', 242.0000, 'ºC'),
	(55886, 109, '2015-02-15 00:02:33.000000', 'temperatura', 722.0000, 'ºC'),
	(55887, 109, '2015-02-15 00:02:34.000000', 'temperatura', 483.0000, 'ºC'),
	(55888, 109, '2015-02-15 00:02:35.000000', 'temperatura', 251.0000, 'ºC'),
	(55889, 109, '2015-02-15 00:02:36.000000', 'temperatura', 1005.0000, 'ºC'),
	(55890, 109, '2015-02-15 00:02:37.000000', 'temperatura', 672.0000, 'ºC'),
	(55891, 109, '2015-02-15 00:02:38.000000', 'temperatura', 347.0000, 'ºC'),
	(55892, 109, '2015-02-15 00:02:39.000000', 'temperatura', 917.0000, 'ºC'),
	(55893, 109, '2015-02-15 00:02:40.000000', 'temperatura', 1146.0000, 'ºC'),
	(55894, 109, '2015-02-15 00:02:41.000000', 'temperatura', 578.0000, 'ºC'),
	(55895, 109, '2015-02-15 00:02:42.000000', 'temperatura', 651.0000, 'ºC'),
	(55896, 109, '2015-02-15 00:02:43.000000', 'temperatura', 325.0000, 'ºC'),
	(55897, 109, '2015-02-15 00:02:44.000000', 'temperatura', 871.0000, 'ºC'),
	(55898, 109, '2015-02-15 00:02:45.000000', 'temperatura', 981.0000, 'ºC'),
	(55899, 109, '2015-02-15 00:02:46.000000', 'temperatura', 1094.0000, 'ºC'),
	(55900, 109, '2015-02-15 00:02:47.000000', 'temperatura', 127.0000, 'ºC'),
	(55901, 109, '2015-02-15 00:02:48.000000', 'temperatura', 952.0000, 'ºC'),
	(55902, 109, '2015-02-15 00:02:49.000000', 'temperatura', 779.0000, 'ºC'),
	(55903, 109, '2015-02-15 00:02:50.000000', 'temperatura', 1039.0000, 'ºC'),
	(55904, 109, '2015-02-15 00:02:51.000000', 'temperatura', 458.0000, 'ºC'),
	(55905, 109, '2015-02-15 00:02:52.000000', 'temperatura', 375.0000, 'ºC'),
	(55906, 109, '2015-02-15 00:02:53.000000', 'temperatura', 503.0000, 'ºC'),
	(55907, 109, '2015-02-15 00:02:54.000000', 'temperatura', 188.0000, 'ºC'),
	(55908, 109, '2015-02-15 00:02:55.000000', 'temperatura', 631.0000, 'ºC'),
	(55909, 109, '2015-02-15 00:02:56.000000', 'temperatura', 190.0000, 'ºC'),
	(55910, 109, '2015-02-15 00:02:57.000000', 'temperatura', 261.0000, 'ºC'),
	(55911, 109, '2015-02-15 00:02:58.000000', 'temperatura', 734.0000, 'ºC'),
	(55912, 109, '2015-02-15 00:02:59.000000', 'temperatura', 487.0000, 'ºC'),
	(55913, 109, '2015-02-15 00:03:00.000000', 'temperatura', 236.0000, 'ºC'),
	(55914, 109, '2015-02-15 00:03:01.000000', 'temperatura', 917.0000, 'ºC'),
	(55915, 109, '2015-02-15 00:03:02.000000', 'temperatura', 277.0000, 'ºC'),
	(55916, 109, '2015-02-15 00:03:03.000000', 'temperatura', 1036.0000, 'ºC'),
	(55917, 109, '2015-02-15 00:03:04.000000', 'temperatura', 748.0000, 'ºC'),
	(55918, 109, '2015-02-15 00:03:05.000000', 'temperatura', 632.0000, 'ºC'),
	(55919, 109, '2015-02-15 00:03:06.000000', 'temperatura', 915.0000, 'ºC'),
	(55920, 109, '2015-02-15 00:03:07.000000', 'temperatura', 282.0000, 'ºC'),
	(55921, 109, '2015-02-15 00:03:08.000000', 'temperatura', 1066.0000, 'ºC'),
	(55922, 109, '2015-02-15 00:03:09.000000', 'temperatura', 886.0000, 'ºC'),
	(55923, 109, '2015-02-15 00:03:10.000000', 'temperatura', 30.0000, 'ºC'),
	(55924, 109, '2015-02-15 00:03:11.000000', 'temperatura', 1092.0000, 'ºC'),
	(55925, 109, '2015-02-15 00:03:12.000000', 'temperatura', 573.0000, 'ºC'),
	(55926, 109, '2015-02-15 00:03:13.000000', 'temperatura', 789.0000, 'ºC'),
	(55927, 109, '2015-02-15 00:03:14.000000', 'temperatura', 1028.0000, 'ºC'),
	(55928, 109, '2015-02-15 00:03:15.000000', 'temperatura', 371.0000, 'ºC'),
	(55929, 109, '2015-02-15 00:03:16.000000', 'temperatura', 1170.0000, 'ºC'),
	(55930, 109, '2015-02-15 00:03:17.000000', 'temperatura', 1140.0000, 'ºC'),
	(55931, 109, '2015-02-15 00:03:18.000000', 'temperatura', 990.0000, 'ºC'),
	(55932, 109, '2015-02-15 00:03:19.000000', 'temperatura', 331.0000, 'ºC'),
	(55933, 109, '2015-02-15 00:03:20.000000', 'temperatura', 1086.0000, 'ºC'),
	(55934, 109, '2015-02-15 00:03:21.000000', 'temperatura', 836.0000, 'ºC'),
	(55935, 109, '2015-02-15 00:03:22.000000', 'temperatura', 925.0000, 'ºC'),
	(55936, 109, '2015-02-15 00:03:23.000000', 'temperatura', 917.0000, 'ºC'),
	(55937, 109, '2015-02-15 00:03:24.000000', 'temperatura', 609.0000, 'ºC'),
	(55938, 109, '2015-02-15 00:03:25.000000', 'temperatura', 297.0000, 'ºC'),
	(55939, 109, '2015-02-15 00:03:26.000000', 'temperatura', 856.0000, 'ºC'),
	(55940, 109, '2015-02-15 00:03:27.000000', 'temperatura', 990.0000, 'ºC'),
	(55941, 109, '2015-02-15 00:03:28.000000', 'temperatura', 1182.0000, 'ºC'),
	(55942, 109, '2015-02-15 00:03:29.000000', 'temperatura', 543.0000, 'ºC'),
	(55943, 109, '2015-02-15 00:03:30.000000', 'temperatura', 366.0000, 'ºC'),
	(55944, 109, '2015-02-15 00:03:31.000000', 'temperatura', 203.0000, 'ºC'),
	(55945, 109, '2015-02-15 00:03:32.000000', 'temperatura', 1117.0000, 'ºC'),
	(55946, 109, '2015-02-15 00:03:33.000000', 'temperatura', 178.0000, 'ºC'),
	(55947, 109, '2015-02-15 00:03:34.000000', 'temperatura', 1137.0000, 'ºC'),
	(55948, 109, '2015-02-15 00:03:35.000000', 'temperatura', 352.0000, 'ºC'),
	(55949, 109, '2015-02-15 00:03:36.000000', 'temperatura', 751.0000, 'ºC'),
	(55950, 109, '2015-02-15 00:03:37.000000', 'temperatura', 301.0000, 'ºC'),
	(55951, 109, '2015-02-15 00:03:38.000000', 'temperatura', 449.0000, 'ºC'),
	(55952, 109, '2015-02-15 00:03:39.000000', 'temperatura', 144.0000, 'ºC'),
	(55953, 109, '2015-02-15 00:03:40.000000', 'temperatura', 572.0000, 'ºC'),
	(55954, 109, '2015-02-15 00:03:41.000000', 'temperatura', 31.0000, 'ºC'),
	(55955, 109, '2015-02-15 00:03:42.000000', 'temperatura', 838.0000, 'ºC'),
	(55956, 109, '2015-02-15 00:03:43.000000', 'temperatura', 497.0000, 'ºC'),
	(55957, 109, '2015-02-15 00:03:44.000000', 'temperatura', 1174.0000, 'ºC'),
	(55958, 109, '2015-02-15 00:03:45.000000', 'temperatura', 777.0000, 'ºC'),
	(55959, 109, '2015-02-15 00:03:46.000000', 'temperatura', 364.0000, 'ºC'),
	(55960, 109, '2015-02-15 00:03:47.000000', 'temperatura', 691.0000, 'ºC'),
	(55961, 109, '2015-02-15 00:03:48.000000', 'temperatura', 1163.0000, 'ºC'),
	(55962, 109, '2015-02-15 00:03:49.000000', 'temperatura', 143.0000, 'ºC'),
	(55963, 109, '2015-02-15 00:03:50.000000', 'temperatura', 827.0000, 'ºC'),
	(55964, 109, '2015-02-15 00:03:51.000000', 'temperatura', 105.0000, 'ºC'),
	(55965, 109, '2015-02-15 00:03:52.000000', 'temperatura', 447.0000, 'ºC'),
	(55966, 109, '2015-02-15 00:03:53.000000', 'temperatura', 718.0000, 'ºC'),
	(55967, 109, '2015-02-15 00:03:54.000000', 'temperatura', 1052.0000, 'ºC'),
	(55968, 109, '2015-02-15 00:03:55.000000', 'temperatura', 704.0000, 'ºC'),
	(55969, 109, '2015-02-15 00:03:56.000000', 'temperatura', 366.0000, 'ºC'),
	(55970, 109, '2015-02-15 00:03:57.000000', 'temperatura', 917.0000, 'ºC'),
	(55971, 109, '2015-02-15 00:03:58.000000', 'temperatura', 1086.0000, 'ºC'),
	(55972, 109, '2015-02-15 00:03:59.000000', 'temperatura', 282.0000, 'ºC'),
	(55973, 109, '2015-02-15 00:04:00.000000', 'temperatura', 554.0000, 'ºC'),
	(55974, 109, '2015-02-15 00:04:01.000000', 'temperatura', 723.0000, 'ºC'),
	(55975, 109, '2015-02-15 00:04:02.000000', 'temperatura', 752.0000, 'ºC'),
	(55976, 109, '2015-02-15 00:04:03.000000', 'temperatura', 395.0000, 'ºC'),
	(55977, 109, '2015-02-15 00:04:04.000000', 'temperatura', 916.0000, 'ºC'),
	(55978, 109, '2015-02-15 00:04:05.000000', 'temperatura', 998.0000, 'ºC'),
	(55979, 109, '2015-02-15 00:04:06.000000', 'temperatura', 1042.0000, 'ºC'),
	(55980, 109, '2015-02-15 00:04:07.000000', 'temperatura', 1014.0000, 'ºC'),
	(55981, 109, '2015-02-15 00:04:08.000000', 'temperatura', 747.0000, 'ºC'),
	(55982, 109, '2015-02-15 00:04:09.000000', 'temperatura', 693.0000, 'ºC'),
	(55983, 109, '2015-02-15 00:04:10.000000', 'temperatura', 26.0000, 'ºC'),
	(55984, 109, '2015-02-15 00:04:11.000000', 'temperatura', 451.0000, 'ºC'),
	(55985, 109, '2015-02-15 00:04:12.000000', 'temperatura', 975.0000, 'ºC'),
	(55986, 109, '2015-02-15 00:04:13.000000', 'temperatura', 1126.0000, 'ºC'),
	(55987, 109, '2015-02-15 00:04:14.000000', 'temperatura', 302.0000, 'ºC'),
	(55988, 109, '2015-02-15 00:04:15.000000', 'temperatura', 535.0000, 'ºC'),
	(55989, 109, '2015-02-15 00:04:16.000000', 'temperatura', 568.0000, 'ºC'),
	(55990, 109, '2015-02-15 00:04:17.000000', 'temperatura', 37.0000, 'ºC'),
	(55991, 109, '2015-02-15 00:04:18.000000', 'temperatura', 882.0000, 'ºC'),
	(55992, 109, '2015-02-15 00:04:19.000000', 'temperatura', 700.0000, 'ºC'),
	(55993, 109, '2015-02-15 00:04:20.000000', 'temperatura', 852.0000, 'ºC'),
	(55994, 109, '2015-02-15 00:04:21.000000', 'temperatura', 963.0000, 'ºC'),
	(55995, 109, '2015-02-15 00:04:22.000000', 'temperatura', 1060.0000, 'ºC'),
	(55996, 109, '2015-02-15 00:04:23.000000', 'temperatura', 12.0000, 'ºC'),
	(55997, 109, '2015-02-15 00:04:24.000000', 'temperatura', 480.0000, 'ºC'),
	(55998, 109, '2015-02-15 00:04:25.000000', 'temperatura', 1164.0000, 'ºC'),
	(55999, 109, '2015-02-15 00:04:26.000000', 'temperatura', 781.0000, 'ºC'),
	(56000, 109, '2015-02-15 00:04:27.000000', 'temperatura', 415.0000, 'ºC'),
	(56001, 109, '2015-02-15 00:04:28.000000', 'temperatura', 931.0000, 'ºC'),
	(56002, 109, '2015-02-15 00:04:29.000000', 'temperatura', 1011.0000, 'ºC'),
	(56003, 109, '2015-02-15 00:04:30.000000', 'temperatura', 1062.0000, 'ºC'),
	(56004, 109, '2015-02-15 00:04:31.000000', 'temperatura', 1077.0000, 'ºC'),
	(56005, 109, '2015-02-15 00:04:32.000000', 'temperatura', 998.0000, 'ºC'),
	(56006, 109, '2015-02-15 00:04:33.000000', 'temperatura', 561.0000, 'ºC'),
	(56007, 109, '2015-02-15 00:04:34.000000', 'temperatura', 1010.0000, 'ºC'),
	(56008, 109, '2015-02-15 00:04:35.000000', 'temperatura', 970.0000, 'ºC'),
	(56009, 109, '2015-02-15 00:04:36.000000', 'temperatura', 621.0000, 'ºC'),
	(56010, 109, '2015-02-15 00:04:37.000000', 'temperatura', 195.0000, 'ºC'),
	(56011, 109, '2015-02-15 00:04:38.000000', 'temperatura', 313.0000, 'ºC'),
	(56012, 109, '2015-02-15 00:04:39.000000', 'temperatura', 980.0000, 'ºC'),
	(56013, 109, '2015-02-15 00:04:40.000000', 'temperatura', 362.0000, 'ºC'),
	(56014, 109, '2015-02-15 00:04:41.000000', 'temperatura', 68.0000, 'ºC'),
	(56015, 109, '2015-02-15 00:04:42.000000', 'temperatura', 457.0000, 'ºC'),
	(56016, 109, '2015-02-15 00:04:43.000000', 'temperatura', 883.0000, 'ºC'),
	(56017, 109, '2015-02-15 00:04:44.000000', 'temperatura', 642.0000, 'ºC'),
	(56018, 109, '2015-02-15 00:04:45.000000', 'temperatura', 563.0000, 'ºC'),
	(56019, 109, '2015-02-15 00:04:46.000000', 'temperatura', 888.0000, 'ºC'),
	(56020, 109, '2015-02-15 00:04:47.000000', 'temperatura', 353.0000, 'ºC'),
	(56021, 109, '2015-02-15 00:04:48.000000', 'temperatura', 301.0000, 'ºC'),
	(56022, 109, '2015-02-15 00:04:49.000000', 'temperatura', 445.0000, 'ºC'),
	(56023, 109, '2015-02-15 00:04:50.000000', 'temperatura', 123.0000, 'ºC'),
	(56024, 109, '2015-02-15 00:04:51.000000', 'temperatura', 479.0000, 'ºC'),
	(56025, 109, '2015-02-15 00:04:52.000000', 'temperatura', 829.0000, 'ºC'),
	(56026, 109, '2015-02-15 00:04:53.000000', 'temperatura', 307.0000, 'ºC'),
	(56027, 109, '2015-02-15 00:04:54.000000', 'temperatura', 249.0000, 'ºC'),
	(56028, 109, '2015-02-15 00:04:55.000000', 'temperatura', 326.0000, 'ºC'),
	(56029, 109, '2015-02-15 00:04:56.000000', 'temperatura', 883.0000, 'ºC'),
	(56030, 109, '2015-02-15 00:04:57.000000', 'temperatura', 1037.0000, 'ºC'),
	(56031, 109, '2015-02-15 00:04:58.000000', 'temperatura', 138.0000, 'ºC'),
	(56032, 109, '2015-02-15 00:04:59.000000', 'temperatura', 1177.0000, 'ºC'),
	(56033, 109, '2015-02-15 00:05:00.000000', 'temperatura', 673.0000, 'ºC'),
	(56034, 109, '2015-02-15 00:05:01.000000', 'temperatura', 1033.0000, 'ºC'),
	(56035, 109, '2015-02-15 00:05:02.000000', 'temperatura', 746.0000, 'ºC'),
	(56036, 109, '2015-02-15 00:05:03.000000', 'temperatura', 630.0000, 'ºC'),
	(56037, 109, '2015-02-15 00:05:04.000000', 'temperatura', 916.0000, 'ºC'),
	(56038, 109, '2015-02-15 00:05:05.000000', 'temperatura', 287.0000, 'ºC'),
	(56039, 109, '2015-02-15 00:05:06.000000', 'temperatura', 1090.0000, 'ºC'),
	(56040, 109, '2015-02-15 00:05:07.000000', 'temperatura', 990.0000, 'ºC'),
	(56041, 109, '2015-02-15 00:05:08.000000', 'temperatura', 480.0000, 'ºC'),
	(56042, 109, '2015-02-15 00:05:09.000000', 'temperatura', 629.0000, 'ºC'),
	(56043, 109, '2015-02-15 00:05:10.000000', 'temperatura', 506.0000, 'ºC'),
	(56044, 109, '2015-02-15 00:05:11.000000', 'temperatura', 644.0000, 'ºC'),
	(56045, 109, '2015-02-15 00:05:12.000000', 'temperatura', 502.0000, 'ºC'),
	(56046, 109, '2015-02-15 00:05:13.000000', 'temperatura', 577.0000, 'ºC'),
	(56047, 109, '2015-02-15 00:05:14.000000', 'temperatura', 180.0000, 'ºC'),
	(56048, 109, '2015-02-15 00:05:15.000000', 'temperatura', 371.0000, 'ºC'),
	(56049, 109, '2015-02-15 00:05:16.000000', 'temperatura', 114.0000, 'ºC'),
	(56050, 109, '2015-02-15 00:05:17.000000', 'temperatura', 659.0000, 'ºC'),
	(56051, 109, '2015-02-15 00:05:18.000000', 'temperatura', 552.0000, 'ºC'),
	(56052, 109, '2015-02-15 00:05:19.000000', 'temperatura', 783.0000, 'ºC'),
	(56053, 109, '2015-02-15 00:05:20.000000', 'temperatura', 1058.0000, 'ºC'),
	(56054, 109, '2015-02-15 00:05:21.000000', 'temperatura', 544.0000, 'ºC'),
	(56055, 109, '2015-02-15 00:05:22.000000', 'temperatura', 744.0000, 'ºC'),
	(56056, 109, '2015-02-15 00:05:23.000000', 'temperatura', 890.0000, 'ºC'),
	(56057, 109, '2015-02-15 00:05:24.000000', 'temperatura', 1019.0000, 'ºC'),
	(56058, 109, '2015-02-15 00:05:25.000000', 'temperatura', 27.0000, 'ºC'),
	(56059, 109, '2015-02-15 00:05:26.000000', 'temperatura', 676.0000, 'ºC'),
	(56060, 109, '2015-02-15 00:05:27.000000', 'temperatura', 902.0000, 'ºC'),
	(56061, 109, '2015-02-15 00:05:28.000000', 'temperatura', 83.0000, 'ºC'),
	(56062, 109, '2015-02-15 00:05:29.000000', 'temperatura', 109.0000, 'ºC'),
	(56063, 109, '2015-02-15 00:05:30.000000', 'temperatura', 297.0000, 'ºC'),
	(56064, 109, '2015-02-15 00:05:31.000000', 'temperatura', 1158.0000, 'ºC'),
	(56065, 109, '2015-02-15 00:05:32.000000', 'temperatura', 99.0000, 'ºC'),
	(56066, 109, '2015-02-15 00:05:33.000000', 'temperatura', 623.0000, 'ºC'),
	(56067, 109, '2015-02-15 00:05:34.000000', 'temperatura', 418.0000, 'ºC'),
	(56068, 109, '2015-02-15 00:05:35.000000', 'temperatura', 223.0000, 'ºC'),
	(56069, 109, '2015-02-15 00:05:36.000000', 'temperatura', 1059.0000, 'ºC'),
	(56070, 109, '2015-02-15 00:05:37.000000', 'temperatura', 1027.0000, 'ºC'),
	(56071, 109, '2015-02-15 00:05:38.000000', 'temperatura', 760.0000, 'ºC'),
	(56072, 109, '2015-02-15 00:05:39.000000', 'temperatura', 720.0000, 'ºC'),
	(56073, 109, '2015-02-15 00:05:40.000000', 'temperatura', 121.0000, 'ºC'),
	(56074, 109, '2015-02-15 00:05:41.000000', 'temperatura', 843.0000, 'ºC'),
	(56075, 109, '2015-02-15 00:05:42.000000', 'temperatura', 255.0000, 'ºC'),
	(56076, 109, '2015-02-15 00:05:43.000000', 'temperatura', 1147.0000, 'ºC'),
	(56077, 109, '2015-02-15 00:05:44.000000', 'temperatura', 170.0000, 'ºC'),
	(56078, 109, '2015-02-15 00:05:45.000000', 'temperatura', 1007.0000, 'ºC'),
	(56079, 109, '2015-02-15 00:05:46.000000', 'temperatura', 928.0000, 'ºC'),
	(56080, 109, '2015-02-15 00:05:47.000000', 'temperatura', 417.0000, 'ºC'),
	(56081, 109, '2015-02-15 00:05:48.000000', 'temperatura', 503.0000, 'ºC'),
	(56082, 109, '2015-02-15 00:05:49.000000', 'temperatura', 63.0000, 'ºC'),
	(56083, 109, '2015-02-15 00:05:50.000000', 'temperatura', 7.0000, 'ºC'),
	(56084, 109, '2015-02-15 00:05:51.000000', 'temperatura', 1045.0000, 'ºC'),
	(56085, 109, '2015-02-15 00:05:52.000000', 'temperatura', 407.0000, 'ºC'),
	(56086, 109, '2015-02-15 00:05:53.000000', 'temperatura', 98.0000, 'ºC'),
	(56087, 109, '2015-02-15 00:05:54.000000', 'temperatura', 472.0000, 'ºC'),
	(56088, 109, '2015-02-15 00:05:55.000000', 'temperatura', 865.0000, 'ºC'),
	(56089, 109, '2015-02-15 00:05:56.000000', 'temperatura', 508.0000, 'ºC'),
	(56090, 109, '2015-02-15 00:05:57.000000', 'temperatura', 1148.0000, 'ºC'),
	(56091, 109, '2015-02-15 00:05:58.000000', 'temperatura', 614.0000, 'ºC'),
	(56092, 109, '2015-02-15 00:05:59.000000', 'temperatura', 828.0000, 'ºC'),
	(56093, 109, '2015-02-15 00:06:00.000000', 'temperatura', 1097.0000, 'ºC'),
	(56094, 109, '2015-02-15 00:06:01.000000', 'temperatura', 602.0000, 'ºC'),
	(56095, 109, '2015-02-15 00:06:02.000000', 'temperatura', 918.0000, 'ºC'),
	(56096, 109, '2015-02-15 00:06:03.000000', 'temperatura', 386.0000, 'ºC'),
	(56097, 109, '2015-02-15 00:06:04.000000', 'temperatura', 378.0000, 'ºC'),
	(56098, 109, '2015-02-15 00:06:05.000000', 'temperatura', 731.0000, 'ºC'),
	(56099, 109, '2015-02-15 00:06:06.000000', 'temperatura', 123.0000, 'ºC'),
	(56100, 109, '2015-02-15 00:06:07.000000', 'temperatura', 820.0000, 'ºC'),
	(56101, 109, '2015-02-15 00:06:08.000000', 'temperatura', 134.0000, 'ºC'),
	(56102, 109, '2015-02-15 00:06:09.000000', 'temperatura', 611.0000, 'ºC'),
	(56103, 109, '2015-02-15 00:06:10.000000', 'temperatura', 253.0000, 'ºC'),
	(56104, 109, '2015-02-15 00:06:11.000000', 'temperatura', 634.0000, 'ºC'),
	(56105, 109, '2015-02-15 00:06:12.000000', 'temperatura', 8.0000, 'ºC'),
	(56106, 109, '2015-02-15 00:06:13.000000', 'temperatura', 542.0000, 'ºC'),
	(56107, 109, '2015-02-15 00:06:14.000000', 'temperatura', 286.0000, 'ºC'),
	(56108, 109, '2015-02-15 00:06:15.000000', 'temperatura', 1003.0000, 'ºC'),
	(56109, 109, '2015-02-15 00:06:16.000000', 'temperatura', 558.0000, 'ºC'),
	(56110, 109, '2015-02-15 00:06:17.000000', 'temperatura', 983.0000, 'ºC'),
	(56111, 109, '2015-02-15 00:06:18.000000', 'temperatura', 839.0000, 'ºC'),
	(56112, 109, '2015-02-15 00:06:19.000000', 'temperatura', 48.0000, 'ºC'),
	(56113, 109, '2015-02-15 00:06:20.000000', 'temperatura', 125.0000, 'ºC'),
	(56114, 109, '2015-02-15 00:06:21.000000', 'temperatura', 480.0000, 'ºC'),
	(56115, 109, '2015-02-15 00:06:22.000000', 'temperatura', 827.0000, 'ºC'),
	(56116, 109, '2015-02-15 00:06:23.000000', 'temperatura', 294.0000, 'ºC'),
	(56117, 109, '2015-02-15 00:06:24.000000', 'temperatura', 188.0000, 'ºC'),
	(56118, 109, '2015-02-15 00:06:25.000000', 'temperatura', 61.0000, 'ºC'),
	(56119, 109, '2015-02-15 00:06:26.000000', 'temperatura', 939.0000, 'ºC'),
	(56120, 109, '2015-02-15 00:06:27.000000', 'temperatura', 915.0000, 'ºC'),
	(56121, 109, '2015-02-15 00:06:28.000000', 'temperatura', 559.0000, 'ºC'),
	(56122, 109, '2015-02-15 00:06:29.000000', 'temperatura', 52.0000, 'ºC'),
	(56123, 109, '2015-02-15 00:06:30.000000', 'temperatura', 980.0000, 'ºC'),
	(56124, 109, '2015-02-15 00:06:31.000000', 'temperatura', 1144.0000, 'ºC'),
	(56125, 109, '2015-02-15 00:06:32.000000', 'temperatura', 382.0000, 'ºC'),
	(56126, 109, '2015-02-15 00:06:33.000000', 'temperatura', 879.0000, 'ºC'),
	(56127, 109, '2015-02-15 00:06:34.000000', 'temperatura', 850.0000, 'ºC'),
	(56128, 109, '2015-02-15 00:06:35.000000', 'temperatura', 415.0000, 'ºC'),
	(56129, 109, '2015-02-15 00:06:36.000000', 'temperatura', 723.0000, 'ºC'),
	(56130, 109, '2015-02-15 00:06:37.000000', 'temperatura', 1169.0000, 'ºC'),
	(56131, 109, '2015-02-15 00:06:38.000000', 'temperatura', 79.0000, 'ºC'),
	(56132, 109, '2015-02-15 00:06:39.000000', 'temperatura', 489.0000, 'ºC'),
	(56133, 109, '2015-02-15 00:06:40.000000', 'temperatura', 1009.0000, 'ºC'),
	(56134, 109, '2015-02-15 00:06:41.000000', 'temperatura', 1179.0000, 'ºC'),
	(56135, 109, '2015-02-15 00:06:42.000000', 'temperatura', 467.0000, 'ºC'),
	(56136, 109, '2015-02-15 00:06:43.000000', 'temperatura', 1.0000, 'ºC'),
	(56137, 109, '2015-02-15 00:06:44.000000', 'temperatura', 1003.0000, 'ºC'),
	(56138, 109, '2015-02-15 00:06:45.000000', 'temperatura', 211.0000, 'ºC'),
	(56139, 109, '2015-02-15 00:06:46.000000', 'temperatura', 450.0000, 'ºC'),
	(56140, 109, '2015-02-15 00:06:47.000000', 'temperatura', 414.0000, 'ºC'),
	(56141, 109, '2015-02-15 00:06:48.000000', 'temperatura', 721.0000, 'ºC'),
	(56142, 109, '2015-02-15 00:06:49.000000', 'temperatura', 1165.0000, 'ºC'),
	(56143, 109, '2015-02-15 00:06:50.000000', 'temperatura', 62.0000, 'ºC'),
	(56144, 109, '2015-02-15 00:06:51.000000', 'temperatura', 415.0000, 'ºC'),
	(56145, 109, '2015-02-15 00:06:52.000000', 'temperatura', 691.0000, 'ºC'),
	(56146, 109, '2015-02-15 00:06:53.000000', 'temperatura', 1008.0000, 'ºC'),
	(56147, 109, '2015-02-15 00:06:54.000000', 'temperatura', 570.0000, 'ºC'),
	(56148, 109, '2015-02-15 00:06:55.000000', 'temperatura', 1026.0000, 'ºC'),
	(56149, 109, '2015-02-15 00:06:56.000000', 'temperatura', 1018.0000, 'ºC'),
	(56150, 109, '2015-02-15 00:06:57.000000', 'temperatura', 815.0000, 'ºC'),
	(56151, 109, '2015-02-15 00:06:58.000000', 'temperatura', 1023.0000, 'ºC'),
	(56152, 109, '2015-02-15 00:06:59.000000', 'temperatura', 267.0000, 'ºC'),
	(56153, 109, '2015-02-15 00:07:00.000000', 'temperatura', 669.0000, 'ºC'),
	(56154, 109, '2015-02-15 00:07:01.000000', 'temperatura', 146.0000, 'ºC'),
	(56155, 109, '2015-02-15 00:07:02.000000', 'temperatura', 1120.0000, 'ºC'),
	(56156, 109, '2015-02-15 00:07:03.000000', 'temperatura', 365.0000, 'ºC'),
	(56157, 109, '2015-02-15 00:07:04.000000', 'temperatura', 865.0000, 'ºC'),
	(56158, 109, '2015-02-15 00:07:05.000000', 'temperatura', 831.0000, 'ºC'),
	(56159, 109, '2015-02-15 00:07:06.000000', 'temperatura', 361.0000, 'ºC'),
	(56160, 109, '2015-02-15 00:07:07.000000', 'temperatura', 511.0000, 'ºC'),
	(56161, 109, '2015-02-15 00:07:08.000000', 'temperatura', 272.0000, 'ºC'),
	(56162, 109, '2015-02-15 00:07:09.000000', 'temperatura', 1030.0000, 'ºC'),
	(56163, 109, '2015-02-15 00:07:10.000000', 'temperatura', 734.0000, 'ºC'),
	(56164, 109, '2015-02-15 00:07:11.000000', 'temperatura', 579.0000, 'ºC'),
	(56165, 109, '2015-02-15 00:07:12.000000', 'temperatura', 696.0000, 'ºC'),
	(56166, 109, '2015-02-15 00:07:13.000000', 'temperatura', 543.0000, 'ºC'),
	(56167, 109, '2015-02-15 00:07:14.000000', 'temperatura', 627.0000, 'ºC'),
	(56168, 109, '2015-02-15 00:07:15.000000', 'temperatura', 307.0000, 'ºC'),
	(56169, 109, '2015-02-15 00:07:16.000000', 'temperatura', 853.0000, 'ºC'),
	(56170, 109, '2015-02-15 00:07:17.000000', 'temperatura', 945.0000, 'ºC'),
	(56171, 109, '2015-02-15 00:07:18.000000', 'temperatura', 969.0000, 'ºC'),
	(56172, 109, '2015-02-15 00:07:19.000000', 'temperatura', 808.0000, 'ºC'),
	(56173, 109, '2015-02-15 00:07:20.000000', 'temperatura', 1134.0000, 'ºC'),
	(56174, 109, '2015-02-15 00:07:21.000000', 'temperatura', 847.0000, 'ºC'),
	(56175, 109, '2015-02-15 00:07:22.000000', 'temperatura', 834.0000, 'ºC'),
	(56176, 109, '2015-02-15 00:07:23.000000', 'temperatura', 428.0000, 'ºC'),
	(56177, 109, '2015-02-15 00:07:24.000000', 'temperatura', 840.0000, 'ºC'),
	(56178, 109, '2015-02-15 00:07:25.000000', 'temperatura', 516.0000, 'ºC'),
	(56179, 109, '2015-02-15 00:07:26.000000', 'temperatura', 61.0000, 'ºC'),
	(56180, 109, '2015-02-15 00:07:27.000000', 'temperatura', 1156.0000, 'ºC'),
	(56181, 109, '2015-02-15 00:07:28.000000', 'temperatura', 800.0000, 'ºC'),
	(56182, 109, '2015-02-15 00:07:29.000000', 'temperatura', 532.0000, 'ºC'),
	(56183, 109, '2015-02-15 00:07:30.000000', 'temperatura', 258.0000, 'ºC'),
	(56184, 109, '2015-02-15 00:07:31.000000', 'temperatura', 897.0000, 'ºC'),
	(56185, 109, '2015-02-15 00:07:32.000000', 'temperatura', 112.0000, 'ºC'),
	(56186, 109, '2015-02-15 00:07:33.000000', 'temperatura', 268.0000, 'ºC'),
	(56187, 109, '2015-02-15 00:07:34.000000', 'temperatura', 1004.0000, 'ºC'),
	(56188, 109, '2015-02-15 00:07:35.000000', 'temperatura', 617.0000, 'ºC'),
	(56189, 109, '2015-02-15 00:07:36.000000', 'temperatura', 72.0000, 'ºC'),
	(56190, 109, '2015-02-15 00:07:37.000000', 'temperatura', 910.0000, 'ºC'),
	(56191, 109, '2015-02-15 00:07:38.000000', 'temperatura', 733.0000, 'ºC'),
	(56192, 109, '2015-02-15 00:07:39.000000', 'temperatura', 937.0000, 'ºC'),
	(56193, 109, '2015-02-15 00:07:40.000000', 'temperatura', 86.0000, 'ºC'),
	(56194, 109, '2015-02-15 00:07:41.000000', 'temperatura', 18.0000, 'ºC'),
	(56195, 109, '2015-02-15 00:07:42.000000', 'temperatura', 1034.0000, 'ºC'),
	(56196, 109, '2015-02-15 00:07:43.000000', 'temperatura', 316.0000, 'ºC'),
	(56197, 109, '2015-02-15 00:07:44.000000', 'temperatura', 880.0000, 'ºC'),
	(56198, 109, '2015-02-15 00:07:45.000000', 'temperatura', 1051.0000, 'ºC'),
	(56199, 109, '2015-02-15 00:07:46.000000', 'temperatura', 217.0000, 'ºC'),
	(56200, 109, '2015-02-15 00:07:47.000000', 'temperatura', 331.0000, 'ºC'),
	(56201, 109, '2015-02-15 00:07:48.000000', 'temperatura', 1007.0000, 'ºC'),
	(56202, 109, '2015-02-15 00:07:49.000000', 'temperatura', 440.0000, 'ºC'),
	(56203, 109, '2015-02-15 00:07:50.000000', 'temperatura', 382.0000, 'ºC'),
	(56204, 109, '2015-02-15 00:07:51.000000', 'temperatura', 588.0000, 'ºC'),
	(56205, 109, '2015-02-15 00:07:52.000000', 'temperatura', 595.0000, 'ºC'),
	(56206, 109, '2015-02-15 00:07:53.000000', 'temperatura', 13.0000, 'ºC'),
	(56207, 109, '2015-02-15 00:07:54.000000', 'temperatura', 681.0000, 'ºC'),
	(56208, 109, '2015-02-15 00:07:55.000000', 'temperatura', 964.0000, 'ºC'),
	(56209, 109, '2015-02-15 00:07:56.000000', 'temperatura', 378.0000, 'ºC'),
	(56210, 109, '2015-02-15 00:07:57.000000', 'temperatura', 198.0000, 'ºC'),
	(56211, 109, '2015-02-15 00:07:58.000000', 'temperatura', 1055.0000, 'ºC'),
	(56212, 109, '2015-02-15 00:07:59.000000', 'temperatura', 1083.0000, 'ºC'),
	(56213, 109, '2015-02-15 00:08:00.000000', 'temperatura', 1050.0000, 'ºC'),
	(56214, 109, '2015-02-15 00:08:01.000000', 'temperatura', 804.0000, 'ºC'),
	(56215, 109, '2015-02-15 00:08:02.000000', 'temperatura', 868.0000, 'ºC'),
	(56216, 109, '2015-02-15 00:08:03.000000', 'temperatura', 729.0000, 'ºC'),
	(56217, 109, '2015-02-15 00:08:04.000000', 'temperatura', 1043.0000, 'ºC'),
	(56218, 109, '2015-02-15 00:08:05.000000', 'temperatura', 626.0000, 'ºC'),
	(56219, 109, '2015-02-15 00:08:06.000000', 'temperatura', 3.0000, 'ºC'),
	(56220, 109, '2015-02-15 00:08:07.000000', 'temperatura', 537.0000, 'ºC'),
	(56221, 109, '2015-02-15 00:08:08.000000', 'temperatura', 278.0000, 'ºC'),
	(56222, 109, '2015-02-15 00:08:09.000000', 'temperatura', 979.0000, 'ºC'),
	(56223, 109, '2015-02-15 00:08:10.000000', 'temperatura', 462.0000, 'ºC'),
	(56224, 109, '2015-02-15 00:08:11.000000', 'temperatura', 574.0000, 'ºC'),
	(56225, 109, '2015-02-15 00:08:12.000000', 'temperatura', 284.0000, 'ºC'),
	(56226, 109, '2015-02-15 00:08:13.000000', 'temperatura', 897.0000, 'ºC'),
	(56227, 109, '2015-02-15 00:08:14.000000', 'temperatura', 36.0000, 'ºC'),
	(56228, 109, '2015-02-15 00:08:15.000000', 'temperatura', 1090.0000, 'ºC'),
	(56229, 109, '2015-02-15 00:08:16.000000', 'temperatura', 539.0000, 'ºC'),
	(56230, 109, '2015-02-15 00:08:17.000000', 'temperatura', 629.0000, 'ºC'),
	(56231, 109, '2015-02-15 00:08:18.000000', 'temperatura', 327.0000, 'ºC'),
	(56232, 109, '2015-02-15 00:08:19.000000', 'temperatura', 949.0000, 'ºC'),
	(56233, 109, '2015-02-15 00:08:20.000000', 'temperatura', 166.0000, 'ºC'),
	(56234, 109, '2015-02-15 00:08:21.000000', 'temperatura', 382.0000, 'ºC'),
	(56235, 109, '2015-02-15 00:08:22.000000', 'temperatura', 211.0000, 'ºC'),
	(56236, 109, '2015-02-15 00:08:23.000000', 'temperatura', 1113.0000, 'ºC'),
	(56237, 109, '2015-02-15 00:08:24.000000', 'temperatura', 130.0000, 'ºC'),
	(56238, 109, '2015-02-15 00:08:25.000000', 'temperatura', 911.0000, 'ºC'),
	(56239, 109, '2015-02-15 00:08:26.000000', 'temperatura', 567.0000, 'ºC'),
	(56240, 109, '2015-02-15 00:08:27.000000', 'temperatura', 103.0000, 'ºC'),
	(56241, 109, '2015-02-15 00:08:28.000000', 'temperatura', 16.0000, 'ºC'),
	(56242, 109, '2015-02-15 00:08:29.000000', 'temperatura', 968.0000, 'ºC'),
	(56243, 109, '2015-02-15 00:08:30.000000', 'temperatura', 1195.0000, 'ºC'),
	(56244, 109, '2015-02-15 00:08:31.000000', 'temperatura', 671.0000, 'ºC'),
	(56245, 109, '2015-02-15 00:08:32.000000', 'temperatura', 971.0000, 'ºC'),
	(56246, 109, '2015-02-15 00:08:33.000000', 'temperatura', 443.0000, 'ºC'),
	(56247, 109, '2015-02-15 00:08:34.000000', 'temperatura', 502.0000, 'ºC'),
	(56248, 109, '2015-02-15 00:08:35.000000', 'temperatura', 1179.0000, 'ºC'),
	(56249, 109, '2015-02-15 00:08:36.000000', 'temperatura', 793.0000, 'ºC'),
	(56250, 109, '2015-02-15 00:08:37.000000', 'temperatura', 427.0000, 'ºC'),
	(56251, 109, '2015-02-15 00:08:38.000000', 'temperatura', 955.0000, 'ºC'),
	(56252, 109, '2015-02-15 00:08:39.000000', 'temperatura', 1095.0000, 'ºC'),
	(56253, 109, '2015-02-15 00:08:40.000000', 'temperatura', 213.0000, 'ºC'),
	(56254, 109, '2015-02-15 00:08:41.000000', 'temperatura', 179.0000, 'ºC'),
	(56255, 109, '2015-02-15 00:08:42.000000', 'temperatura', 257.0000, 'ºC'),
	(56256, 109, '2015-02-15 00:08:43.000000', 'temperatura', 747.0000, 'ºC'),
	(56257, 109, '2015-02-15 00:08:44.000000', 'temperatura', 567.0000, 'ºC'),
	(56258, 109, '2015-02-15 00:08:45.000000', 'temperatura', 592.0000, 'ºC'),
	(56259, 109, '2015-02-15 00:08:46.000000', 'temperatura', 62.0000, 'ºC'),
	(56260, 109, '2015-02-15 00:08:47.000000', 'temperatura', 933.0000, 'ºC'),
	(56261, 109, '2015-02-15 00:08:48.000000', 'temperatura', 881.0000, 'ºC'),
	(56262, 109, '2015-02-15 00:08:49.000000', 'temperatura', 405.0000, 'ºC'),
	(56263, 109, '2015-02-15 00:08:50.000000', 'temperatura', 582.0000, 'ºC'),
	(56264, 109, '2015-02-15 00:08:51.000000', 'temperatura', 496.0000, 'ºC'),
	(56265, 109, '2015-02-15 00:08:52.000000', 'temperatura', 733.0000, 'ºC'),
	(56266, 109, '2015-02-15 00:08:53.000000', 'temperatura', 980.0000, 'ºC'),
	(56267, 109, '2015-02-15 00:08:54.000000', 'temperatura', 301.0000, 'ºC'),
	(56268, 109, '2015-02-15 00:08:55.000000', 'temperatura', 966.0000, 'ºC'),
	(56269, 109, '2015-02-15 00:08:56.000000', 'temperatura', 329.0000, 'ºC'),
	(56270, 109, '2015-02-15 00:08:57.000000', 'temperatura', 1145.0000, 'ºC'),
	(56271, 109, '2015-02-15 00:08:58.000000', 'temperatura', 1141.0000, 'ºC'),
	(56272, 109, '2015-02-15 00:08:59.000000', 'temperatura', 1067.0000, 'ºC'),
	(56273, 109, '2015-02-15 00:09:00.000000', 'temperatura', 715.0000, 'ºC'),
	(56274, 109, '2015-02-15 00:09:01.000000', 'temperatura', 375.0000, 'ºC'),
	(56275, 109, '2015-02-15 00:09:02.000000', 'temperatura', 928.0000, 'ºC'),
	(56276, 109, '2015-02-15 00:09:03.000000', 'temperatura', 1116.0000, 'ºC'),
	(56277, 109, '2015-02-15 00:09:04.000000', 'temperatura', 398.0000, 'ºC'),
	(56278, 109, '2015-02-15 00:09:05.000000', 'temperatura', 1042.0000, 'ºC'),
	(56279, 109, '2015-02-15 00:09:06.000000', 'temperatura', 417.0000, 'ºC'),
	(56280, 109, '2015-02-15 00:09:07.000000', 'temperatura', 161.0000, 'ºC'),
	(56281, 109, '2015-02-15 00:09:08.000000', 'temperatura', 752.0000, 'ºC'),
	(56282, 109, '2015-02-15 00:09:09.000000', 'temperatura', 880.0000, 'ºC'),
	(56283, 109, '2015-02-15 00:09:10.000000', 'temperatura', 945.0000, 'ºC'),
	(56284, 109, '2015-02-15 00:09:11.000000', 'temperatura', 883.0000, 'ºC'),
	(56285, 109, '2015-02-15 00:09:12.000000', 'temperatura', 381.0000, 'ºC'),
	(56286, 109, '2015-02-15 00:09:13.000000', 'temperatura', 458.0000, 'ºC'),
	(56287, 109, '2015-02-15 00:09:14.000000', 'temperatura', 1148.0000, 'ºC'),
	(56288, 109, '2015-02-15 00:09:15.000000', 'temperatura', 766.0000, 'ºC'),
	(56289, 109, '2015-02-15 00:09:16.000000', 'temperatura', 385.0000, 'ºC'),
	(56290, 109, '2015-02-15 00:09:17.000000', 'temperatura', 829.0000, 'ºC'),
	(56291, 109, '2015-02-15 00:09:18.000000', 'temperatura', 588.0000, 'ºC'),
	(56292, 109, '2015-02-15 00:09:19.000000', 'temperatura', 457.0000, 'ºC'),
	(56293, 109, '2015-02-15 00:09:20.000000', 'temperatura', 518.0000, 'ºC'),
	(56294, 109, '2015-02-15 00:09:21.000000', 'temperatura', 21.0000, 'ºC'),
	(56295, 109, '2015-02-15 00:09:22.000000', 'temperatura', 949.0000, 'ºC'),
	(56296, 109, '2015-02-15 00:09:23.000000', 'temperatura', 1086.0000, 'ºC'),
	(56297, 109, '2015-02-15 00:09:24.000000', 'temperatura', 183.0000, 'ºC'),
	(56298, 109, '2015-02-15 00:09:25.000000', 'temperatura', 57.0000, 'ºC'),
	(56299, 109, '2015-02-15 00:09:26.000000', 'temperatura', 938.0000, 'ºC'),
	(56300, 109, '2015-02-15 00:09:27.000000', 'temperatura', 917.0000, 'ºC'),
	(56301, 109, '2015-02-15 00:09:28.000000', 'temperatura', 575.0000, 'ºC'),
	(56302, 109, '2015-02-15 00:09:29.000000', 'temperatura', 121.0000, 'ºC'),
	(56303, 109, '2015-02-15 00:09:30.000000', 'temperatura', 83.0000, 'ºC'),
	(56304, 109, '2015-02-15 00:09:31.000000', 'temperatura', 51.0000, 'ºC'),
	(56305, 109, '2015-02-15 00:09:32.000000', 'temperatura', 9.0000, 'ºC'),
	(56306, 109, '2015-02-15 00:09:33.000000', 'temperatura', 1091.0000, 'ºC'),
	(56307, 109, '2015-02-15 00:09:34.000000', 'temperatura', 630.0000, 'ºC'),
	(56308, 109, '2015-02-15 00:09:35.000000', 'temperatura', 1075.0000, 'ºC'),
	(56309, 109, '2015-02-15 00:09:36.000000', 'temperatura', 1085.0000, 'ºC'),
	(56310, 109, '2015-02-15 00:09:37.000000', 'temperatura', 1000.0000, 'ºC'),
	(56311, 109, '2015-02-15 00:09:38.000000', 'temperatura', 546.0000, 'ºC'),
	(56312, 109, '2015-02-15 00:09:39.000000', 'temperatura', 931.0000, 'ºC'),
	(56313, 109, '2015-02-15 00:09:40.000000', 'temperatura', 619.0000, 'ºC'),
	(56314, 109, '2015-02-15 00:09:41.000000', 'temperatura', 300.0000, 'ºC'),
	(56315, 109, '2015-02-15 00:09:42.000000', 'temperatura', 846.0000, 'ºC'),
	(56316, 109, '2015-02-15 00:09:43.000000', 'temperatura', 929.0000, 'ºC'),
	(56317, 109, '2015-02-15 00:09:44.000000', 'temperatura', 907.0000, 'ºC'),
	(56318, 109, '2015-02-15 00:09:45.000000', 'temperatura', 550.0000, 'ºC'),
	(56319, 109, '2015-02-15 00:09:46.000000', 'temperatura', 29.0000, 'ºC'),
	(56320, 109, '2015-02-15 00:09:47.000000', 'temperatura', 893.0000, 'ºC'),
	(56321, 109, '2015-02-15 00:09:48.000000', 'temperatura', 782.0000, 'ºC'),
	(56322, 109, '2015-02-15 00:09:49.000000', 'temperatura', 30.0000, 'ºC'),
	(56323, 109, '2015-02-15 00:09:50.000000', 'temperatura', 205.0000, 'ºC'),
	(56324, 109, '2015-02-15 00:09:51.000000', 'temperatura', 936.0000, 'ºC'),
	(56325, 109, '2015-02-15 00:09:52.000000', 'temperatura', 464.0000, 'ºC'),
	(56326, 109, '2015-02-15 00:09:53.000000', 'temperatura', 714.0000, 'ºC'),
	(56327, 109, '2015-02-15 00:09:54.000000', 'temperatura', 976.0000, 'ºC'),
	(56328, 109, '2015-02-15 00:09:55.000000', 'temperatura', 341.0000, 'ºC'),
	(56329, 109, '2015-02-15 00:09:56.000000', 'temperatura', 1175.0000, 'ºC'),
	(56330, 109, '2015-02-15 00:09:57.000000', 'temperatura', 54.0000, 'ºC'),
	(56331, 109, '2015-02-15 00:09:58.000000', 'temperatura', 345.0000, 'ºC'),
	(56332, 109, '2015-02-15 00:09:59.000000', 'temperatura', 366.0000, 'ºC'),
	(56333, 109, '2015-02-15 00:10:00.000000', 'temperatura', 792.0000, 'ºC'),
	(56334, 109, '2015-02-15 00:10:01.000000', 'temperatura', 465.0000, 'ºC'),
	(56335, 109, '2015-02-15 00:10:02.000000', 'temperatura', 1151.0000, 'ºC'),
	(56336, 109, '2015-02-15 00:10:03.000000', 'temperatura', 757.0000, 'ºC'),
	(56337, 109, '2015-02-15 00:10:04.000000', 'temperatura', 333.0000, 'ºC'),
	(56338, 109, '2015-02-15 00:10:05.000000', 'temperatura', 594.0000, 'ºC'),
	(56339, 109, '2015-02-15 00:10:06.000000', 'temperatura', 773.0000, 'ºC'),
	(56340, 109, '2015-02-15 00:10:07.000000', 'temperatura', 883.0000, 'ºC'),
	(56341, 109, '2015-02-15 00:10:08.000000', 'temperatura', 895.0000, 'ºC'),
	(56342, 109, '2015-02-15 00:10:09.000000', 'temperatura', 628.0000, 'ºC'),
	(56343, 109, '2015-02-15 00:10:10.000000', 'temperatura', 454.0000, 'ºC'),
	(56344, 109, '2015-02-15 00:10:11.000000', 'temperatura', 386.0000, 'ºC'),
	(56345, 109, '2015-02-15 00:10:12.000000', 'temperatura', 569.0000, 'ºC'),
	(56346, 109, '2015-02-15 00:10:13.000000', 'temperatura', 486.0000, 'ºC'),
	(56347, 109, '2015-02-15 00:10:14.000000', 'temperatura', 725.0000, 'ºC'),
	(56348, 109, '2015-02-15 00:10:15.000000', 'temperatura', 967.0000, 'ºC'),
	(56349, 109, '2015-02-15 00:10:16.000000', 'temperatura', 261.0000, 'ºC'),
	(56350, 109, '2015-02-15 00:10:17.000000', 'temperatura', 806.0000, 'ºC'),
	(56351, 109, '2015-02-15 00:10:18.000000', 'temperatura', 845.0000, 'ºC'),
	(56352, 109, '2015-02-15 00:10:19.000000', 'temperatura', 606.0000, 'ºC'),
	(56353, 109, '2015-02-15 00:10:20.000000', 'temperatura', 499.0000, 'ºC'),
	(56354, 109, '2015-02-15 00:10:21.000000', 'temperatura', 676.0000, 'ºC'),
	(56355, 109, '2015-02-15 00:10:22.000000', 'temperatura', 682.0000, 'ºC'),
	(56356, 109, '2015-02-15 00:10:23.000000', 'temperatura', 182.0000, 'ºC'),
	(56357, 109, '2015-02-15 00:10:24.000000', 'temperatura', 64.0000, 'ºC'),
	(56358, 109, '2015-02-15 00:10:25.000000', 'temperatura', 975.0000, 'ºC'),
	(56359, 109, '2015-02-15 00:10:26.000000', 'temperatura', 1085.0000, 'ºC'),
	(56360, 109, '2015-02-15 00:10:27.000000', 'temperatura', 98.0000, 'ºC'),
	(56361, 109, '2015-02-15 00:10:28.000000', 'temperatura', 836.0000, 'ºC'),
	(56362, 109, '2015-02-15 00:10:29.000000', 'temperatura', 285.0000, 'ºC'),
	(56363, 109, '2015-02-15 00:10:30.000000', 'temperatura', 119.0000, 'ºC'),
	(56364, 109, '2015-02-15 00:10:31.000000', 'temperatura', 940.0000, 'ºC'),
	(56365, 109, '2015-02-15 00:10:32.000000', 'temperatura', 744.0000, 'ºC'),
	(56366, 109, '2015-02-15 00:10:33.000000', 'temperatura', 902.0000, 'ºC'),
	(56367, 109, '2015-02-15 00:10:34.000000', 'temperatura', 1079.0000, 'ºC'),
	(56368, 109, '2015-02-15 00:10:35.000000', 'temperatura', 290.0000, 'ºC'),
	(56369, 109, '2015-02-15 00:10:36.000000', 'temperatura', 614.0000, 'ºC'),
	(56370, 109, '2015-02-15 00:10:37.000000', 'temperatura', 999.0000, 'ºC'),
	(56371, 109, '2015-02-15 00:10:38.000000', 'temperatura', 754.0000, 'ºC'),
	(56372, 109, '2015-02-15 00:10:39.000000', 'temperatura', 772.0000, 'ºC'),
	(56373, 109, '2015-02-15 00:10:40.000000', 'temperatura', 399.0000, 'ºC'),
	(56374, 109, '2015-02-15 00:10:41.000000', 'temperatura', 879.0000, 'ºC'),
	(56375, 109, '2015-02-15 00:10:42.000000', 'temperatura', 800.0000, 'ºC'),
	(56376, 109, '2015-02-15 00:10:43.000000', 'temperatura', 161.0000, 'ºC'),
	(56377, 109, '2015-02-15 00:10:44.000000', 'temperatura', 809.0000, 'ºC'),
	(56378, 109, '2015-02-15 00:10:45.000000', 'temperatura', 1160.0000, 'ºC'),
	(56379, 109, '2015-02-15 00:10:46.000000', 'temperatura', 974.0000, 'ºC'),
	(56380, 109, '2015-02-15 00:10:47.000000', 'temperatura', 189.0000, 'ºC'),
	(56381, 109, '2015-02-15 00:10:48.000000', 'temperatura', 423.0000, 'ºC'),
	(56382, 109, '2015-02-15 00:10:49.000000', 'temperatura', 350.0000, 'ºC'),
	(56383, 109, '2015-02-15 00:10:50.000000', 'temperatura', 483.0000, 'ºC'),
	(56384, 109, '2015-02-15 00:10:51.000000', 'temperatura', 163.0000, 'ºC'),
	(56385, 109, '2015-02-15 00:10:52.000000', 'temperatura', 566.0000, 'ºC'),
	(56386, 109, '2015-02-15 00:10:53.000000', 'temperatura', 1141.0000, 'ºC'),
	(56387, 109, '2015-02-15 00:10:54.000000', 'temperatura', 409.0000, 'ºC'),
	(56388, 109, '2015-02-15 00:10:55.000000', 'temperatura', 1022.0000, 'ºC'),
	(56389, 109, '2015-02-15 00:10:56.000000', 'temperatura', 285.0000, 'ºC'),
	(56390, 109, '2015-02-15 00:10:57.000000', 'temperatura', 757.0000, 'ºC'),
	(56391, 109, '2015-02-15 00:10:58.000000', 'temperatura', 530.0000, 'ºC'),
	(56392, 109, '2015-02-15 00:10:59.000000', 'temperatura', 382.0000, 'ºC'),
	(56393, 109, '2015-02-15 00:11:00.000000', 'temperatura', 322.0000, 'ºC'),
	(56394, 109, '2015-02-15 00:11:01.000000', 'temperatura', 461.0000, 'ºC'),
	(56395, 109, '2015-02-15 00:11:02.000000', 'temperatura', 141.0000, 'ºC'),
	(56396, 109, '2015-02-15 00:11:03.000000', 'temperatura', 523.0000, 'ºC'),
	(56397, 109, '2015-02-15 00:11:04.000000', 'temperatura', 992.0000, 'ºC'),
	(56398, 109, '2015-02-15 00:11:05.000000', 'temperatura', 993.0000, 'ºC'),
	(56399, 109, '2015-02-15 00:11:06.000000', 'temperatura', 787.0000, 'ºC'),
	(56400, 109, '2015-02-15 00:11:07.000000', 'temperatura', 958.0000, 'ºC'),
	(56401, 109, '2015-02-15 00:11:08.000000', 'temperatura', 31.0000, 'ºC'),
	(56402, 109, '2015-02-15 00:11:09.000000', 'temperatura', 880.0000, 'ºC'),
	(56403, 109, '2015-02-15 00:11:10.000000', 'temperatura', 709.0000, 'ºC'),
	(56404, 109, '2015-02-15 00:11:11.000000', 'temperatura', 906.0000, 'ºC'),
	(56405, 109, '2015-02-15 00:11:12.000000', 'temperatura', 4.0000, 'ºC'),
	(56406, 109, '2015-02-15 00:11:13.000000', 'temperatura', 901.0000, 'ºC'),
	(56407, 109, '2015-02-15 00:11:14.000000', 'temperatura', 895.0000, 'ºC'),
	(56408, 109, '2015-02-15 00:11:15.000000', 'temperatura', 573.0000, 'ºC'),
	(56409, 109, '2015-02-15 00:11:16.000000', 'temperatura', 179.0000, 'ºC'),
	(56410, 109, '2015-02-15 00:11:17.000000', 'temperatura', 375.0000, 'ºC'),
	(56411, 109, '2015-02-15 00:11:18.000000', 'temperatura', 139.0000, 'ºC'),
	(56412, 109, '2015-02-15 00:11:19.000000', 'temperatura', 771.0000, 'ºC'),
	(56413, 109, '2015-02-15 00:11:20.000000', 'temperatura', 1040.0000, 'ºC'),
	(56414, 109, '2015-02-15 00:11:21.000000', 'temperatura', 488.0000, 'ºC'),
	(56415, 109, '2015-02-15 00:11:22.000000', 'temperatura', 519.0000, 'ºC'),
	(56416, 109, '2015-02-15 00:11:23.000000', 'temperatura', 1131.0000, 'ºC'),
	(56417, 109, '2015-02-15 00:11:24.000000', 'temperatura', 499.0000, 'ºC'),
	(56418, 109, '2015-02-15 00:11:25.000000', 'temperatura', 302.0000, 'ºC'),
	(56419, 109, '2015-02-15 00:11:26.000000', 'temperatura', 14.0000, 'ºC'),
	(56420, 109, '2015-02-15 00:11:27.000000', 'temperatura', 365.0000, 'ºC'),
	(56421, 109, '2015-02-15 00:11:28.000000', 'temperatura', 585.0000, 'ºC'),
	(56422, 109, '2015-02-15 00:11:29.000000', 'temperatura', 629.0000, 'ºC'),
	(56423, 109, '2015-02-15 00:11:30.000000', 'temperatura', 190.0000, 'ºC'),
	(56424, 109, '2015-02-15 00:11:31.000000', 'temperatura', 262.0000, 'ºC'),
	(56425, 109, '2015-02-15 00:11:32.000000', 'temperatura', 742.0000, 'ºC'),
	(56426, 109, '2015-02-15 00:11:33.000000', 'temperatura', 526.0000, 'ºC'),
	(56427, 109, '2015-02-15 00:11:34.000000', 'temperatura', 404.0000, 'ºC'),
	(56428, 109, '2015-02-15 00:11:35.000000', 'temperatura', 443.0000, 'ºC'),
	(56429, 109, '2015-02-15 00:11:36.000000', 'temperatura', 1001.0000, 'ºC'),
	(56430, 109, '2015-02-15 00:11:37.000000', 'temperatura', 79.0000, 'ºC'),
	(56431, 109, '2015-02-15 00:11:38.000000', 'temperatura', 992.0000, 'ºC'),
	(56432, 109, '2015-02-15 00:11:39.000000', 'temperatura', 1123.0000, 'ºC'),
	(56433, 109, '2015-02-15 00:11:40.000000', 'temperatura', 241.0000, 'ºC'),
	(56434, 109, '2015-02-15 00:11:41.000000', 'temperatura', 235.0000, 'ºC'),
	(56435, 109, '2015-02-15 00:11:42.000000', 'temperatura', 451.0000, 'ºC'),
	(56436, 109, '2015-02-15 00:11:43.000000', 'temperatura', 352.0000, 'ºC'),
	(56437, 109, '2015-02-15 00:11:44.000000', 'temperatura', 407.0000, 'ºC'),
	(56438, 109, '2015-02-15 00:11:45.000000', 'temperatura', 981.0000, 'ºC'),
	(56439, 109, '2015-02-15 00:11:46.000000', 'temperatura', 83.0000, 'ºC'),
	(56440, 109, '2015-02-15 00:11:47.000000', 'temperatura', 1072.0000, 'ºC'),
	(56441, 109, '2015-02-15 00:11:48.000000', 'temperatura', 311.0000, 'ºC'),
	(56442, 109, '2015-02-15 00:11:49.000000', 'temperatura', 741.0000, 'ºC'),
	(56443, 109, '2015-02-15 00:11:50.000000', 'temperatura', 374.0000, 'ºC'),
	(56444, 109, '2015-02-15 00:11:51.000000', 'temperatura', 847.0000, 'ºC'),
	(56445, 109, '2015-02-15 00:11:52.000000', 'temperatura', 712.0000, 'ºC'),
	(56446, 109, '2015-02-15 00:11:53.000000', 'temperatura', 1018.0000, 'ºC'),
	(56447, 109, '2015-02-15 00:11:54.000000', 'temperatura', 558.0000, 'ºC'),
	(56448, 109, '2015-02-15 00:11:55.000000', 'temperatura', 934.0000, 'ºC'),
	(56449, 109, '2015-02-15 00:11:56.000000', 'temperatura', 598.0000, 'ºC'),
	(56450, 109, '2015-02-15 00:11:57.000000', 'temperatura', 187.0000, 'ºC'),
	(56451, 109, '2015-02-15 00:11:58.000000', 'temperatura', 344.0000, 'ºC'),
	(56452, 109, '2015-02-15 00:11:59.000000', 'temperatura', 1157.0000, 'ºC'),
	(56453, 109, '2015-02-15 00:12:00.000000', 'temperatura', 1154.0000, 'ºC'),
	(56454, 109, '2015-02-15 00:12:01.000000', 'temperatura', 1098.0000, 'ºC'),
	(56455, 109, '2015-02-15 00:12:02.000000', 'temperatura', 829.0000, 'ºC'),
	(56456, 109, '2015-02-15 00:12:03.000000', 'temperatura', 854.0000, 'ºC'),
	(56457, 109, '2015-02-15 00:12:04.000000', 'temperatura', 580.0000, 'ºC'),
	(56458, 109, '2015-02-15 00:12:05.000000', 'temperatura', 342.0000, 'ºC'),
	(56459, 109, '2015-02-15 00:12:06.000000', 'temperatura', 1169.0000, 'ºC'),
	(56460, 109, '2015-02-15 00:12:07.000000', 'temperatura', 21.0000, 'ºC'),
	(56461, 109, '2015-02-15 00:12:08.000000', 'temperatura', 198.0000, 'ºC'),
	(56462, 109, '2015-02-15 00:12:09.000000', 'temperatura', 928.0000, 'ºC'),
	(56463, 109, '2015-02-15 00:12:10.000000', 'temperatura', 445.0000, 'ºC'),
	(56464, 109, '2015-02-15 00:12:11.000000', 'temperatura', 644.0000, 'ºC'),
	(56465, 109, '2015-02-15 00:12:12.000000', 'temperatura', 684.0000, 'ºC'),
	(56466, 109, '2015-02-15 00:12:13.000000', 'temperatura', 287.0000, 'ºC'),
	(56467, 109, '2015-02-15 00:12:14.000000', 'temperatura', 585.0000, 'ºC'),
	(56468, 109, '2015-02-15 00:12:15.000000', 'temperatura', 862.0000, 'ºC'),
	(56469, 109, '2015-02-15 00:12:16.000000', 'temperatura', 158.0000, 'ºC'),
	(56470, 109, '2015-02-15 00:12:17.000000', 'temperatura', 602.0000, 'ºC'),
	(56471, 109, '2015-02-15 00:12:18.000000', 'temperatura', 140.0000, 'ºC'),
	(56472, 109, '2015-02-15 00:12:19.000000', 'temperatura', 92.0000, 'ºC'),
	(56473, 109, '2015-02-15 00:12:20.000000', 'temperatura', 43.0000, 'ºC'),
	(56474, 109, '2015-02-15 00:12:21.000000', 'temperatura', 1137.0000, 'ºC'),
	(56475, 109, '2015-02-15 00:12:22.000000', 'temperatura', 758.0000, 'ºC'),
	(56476, 109, '2015-02-15 00:12:23.000000', 'temperatura', 380.0000, 'ºC'),
	(56477, 109, '2015-02-15 00:12:24.000000', 'temperatura', 825.0000, 'ºC'),
	(56478, 109, '2015-02-15 00:12:25.000000', 'temperatura', 587.0000, 'ºC'),
	(56479, 109, '2015-02-15 00:12:26.000000', 'temperatura', 458.0000, 'ºC'),
	(56480, 109, '2015-02-15 00:12:27.000000', 'temperatura', 533.0000, 'ºC'),
	(56481, 109, '2015-02-15 00:12:28.000000', 'temperatura', 89.0000, 'ºC'),
	(56482, 109, '2015-02-15 00:12:29.000000', 'temperatura', 48.0000, 'ºC'),
	(56483, 109, '2015-02-15 00:12:30.000000', 'temperatura', 1172.0000, 'ºC'),
	(56484, 109, '2015-02-15 00:12:31.000000', 'temperatura', 916.0000, 'ºC'),
	(56485, 109, '2015-02-15 00:12:32.000000', 'temperatura', 1063.0000, 'ºC'),
	(56486, 109, '2015-02-15 00:12:33.000000', 'temperatura', 170.0000, 'ºC'),
	(56487, 109, '2015-02-15 00:12:34.000000', 'temperatura', 62.0000, 'ºC'),
	(56488, 109, '2015-02-15 00:12:35.000000', 'temperatura', 999.0000, 'ºC'),
	(56489, 109, '2015-02-15 00:12:36.000000', 'temperatura', 11.0000, 'ºC'),
	(56490, 109, '2015-02-15 00:12:37.000000', 'temperatura', 657.0000, 'ºC'),
	(56491, 109, '2015-02-15 00:12:38.000000', 'temperatura', 853.0000, 'ºC'),
	(56492, 109, '2015-02-15 00:12:39.000000', 'temperatura', 1094.0000, 'ºC'),
	(56493, 109, '2015-02-15 00:12:40.000000', 'temperatura', 513.0000, 'ºC'),
	(56494, 109, '2015-02-15 00:12:41.000000', 'temperatura', 481.0000, 'ºC'),
	(56495, 109, '2015-02-15 00:12:42.000000', 'temperatura', 869.0000, 'ºC'),
	(56496, 109, '2015-02-15 00:12:43.000000', 'temperatura', 500.0000, 'ºC'),
	(56497, 109, '2015-02-15 00:12:44.000000', 'temperatura', 1096.0000, 'ºC'),
	(56498, 109, '2015-02-15 00:12:45.000000', 'temperatura', 381.0000, 'ºC'),
	(56499, 109, '2015-02-15 00:12:46.000000', 'temperatura', 1016.0000, 'ºC'),
	(56500, 109, '2015-02-15 00:12:47.000000', 'temperatura', 338.0000, 'ºC'),
	(56501, 109, '2015-02-15 00:12:48.000000', 'temperatura', 1041.0000, 'ºC'),
	(56502, 109, '2015-02-15 00:12:49.000000', 'temperatura', 592.0000, 'ºC'),
	(56503, 109, '2015-02-15 00:12:50.000000', 'temperatura', 1036.0000, 'ºC'),
	(56504, 109, '2015-02-15 00:12:51.000000', 'temperatura', 1006.0000, 'ºC'),
	(56505, 109, '2015-02-15 00:12:52.000000', 'temperatura', 723.0000, 'ºC'),
	(56506, 109, '2015-02-15 00:12:53.000000', 'temperatura', 596.0000, 'ºC'),
	(56507, 109, '2015-02-15 00:12:54.000000', 'temperatura', 810.0000, 'ºC'),
	(56508, 109, '2015-02-15 00:12:55.000000', 'temperatura', 1066.0000, 'ºC'),
	(56509, 109, '2015-02-15 00:12:56.000000', 'temperatura', 499.0000, 'ºC'),
	(56510, 109, '2015-02-15 00:12:57.000000', 'temperatura', 498.0000, 'ºC'),
	(56511, 109, '2015-02-15 00:12:58.000000', 'temperatura', 995.0000, 'ºC'),
	(56512, 109, '2015-02-15 00:12:59.000000', 'temperatura', 1080.0000, 'ºC'),
	(56513, 109, '2015-02-15 00:13:00.000000', 'temperatura', 14.0000, 'ºC'),
	(56514, 109, '2015-02-15 00:13:01.000000', 'temperatura', 433.0000, 'ºC'),
	(56515, 109, '2015-02-15 00:13:02.000000', 'temperatura', 924.0000, 'ºC'),
	(56516, 109, '2015-02-15 00:13:03.000000', 'temperatura', 922.0000, 'ºC'),
	(56517, 109, '2015-02-15 00:13:04.000000', 'temperatura', 636.0000, 'ºC'),
	(56518, 109, '2015-02-15 00:13:05.000000', 'temperatura', 417.0000, 'ºC'),
	(56519, 109, '2015-02-15 00:13:06.000000', 'temperatura', 178.0000, 'ºC'),
	(56520, 109, '2015-02-15 00:13:07.000000', 'temperatura', 837.0000, 'ºC'),
	(56521, 109, '2015-02-15 00:13:08.000000', 'temperatura', 53.0000, 'ºC'),
	(56522, 109, '2015-02-15 00:13:09.000000', 'temperatura', 155.0000, 'ºC'),
	(56523, 109, '2015-02-15 00:13:10.000000', 'temperatura', 616.0000, 'ºC'),
	(56524, 109, '2015-02-15 00:13:11.000000', 'temperatura', 216.0000, 'ºC'),
	(56525, 109, '2015-02-15 00:13:12.000000', 'temperatura', 434.0000, 'ºC'),
	(56526, 109, '2015-02-15 00:13:13.000000', 'temperatura', 321.0000, 'ºC'),
	(56527, 109, '2015-02-15 00:13:14.000000', 'temperatura', 303.0000, 'ºC'),
	(56528, 109, '2015-02-15 00:13:15.000000', 'temperatura', 554.0000, 'ºC'),
	(56529, 109, '2015-02-15 00:13:16.000000', 'temperatura', 661.0000, 'ºC'),
	(56530, 109, '2015-02-15 00:13:17.000000', 'temperatura', 445.0000, 'ºC'),
	(56531, 109, '2015-02-15 00:13:18.000000', 'temperatura', 240.0000, 'ºC'),
	(56532, 109, '2015-02-15 00:13:19.000000', 'temperatura', 1065.0000, 'ºC'),
	(56533, 109, '2015-02-15 00:13:20.000000', 'temperatura', 1007.0000, 'ºC'),
	(56534, 109, '2015-02-15 00:13:21.000000', 'temperatura', 641.0000, 'ºC'),
	(56535, 109, '2015-02-15 00:13:22.000000', 'temperatura', 183.0000, 'ºC'),
	(56536, 109, '2015-02-15 00:13:23.000000', 'temperatura', 195.0000, 'ºC'),
	(56537, 109, '2015-02-15 00:13:24.000000', 'temperatura', 425.0000, 'ºC'),
	(56538, 109, '2015-02-15 00:13:25.000000', 'temperatura', 340.0000, 'ºC'),
	(56539, 109, '2015-02-15 00:13:26.000000', 'temperatura', 426.0000, 'ºC'),
	(56540, 109, '2015-02-15 00:13:27.000000', 'temperatura', 1109.0000, 'ºC'),
	(56541, 109, '2015-02-15 00:13:28.000000', 'temperatura', 667.0000, 'ºC'),
	(56542, 109, '2015-02-15 00:13:29.000000', 'temperatura', 9.0000, 'ºC'),
	(56543, 109, '2015-02-15 00:13:30.000000', 'temperatura', 445.0000, 'ºC'),
	(56544, 109, '2015-02-15 00:13:31.000000', 'temperatura', 1000.0000, 'ºC'),
	(56545, 109, '2015-02-15 00:13:32.000000', 'temperatura', 63.0000, 'ºC'),
	(56546, 109, '2015-02-15 00:13:33.000000', 'temperatura', 917.0000, 'ºC'),
	(56547, 109, '2015-02-15 00:13:34.000000', 'temperatura', 798.0000, 'ºC'),
	(56548, 109, '2015-02-15 00:13:35.000000', 'temperatura', 38.0000, 'ºC'),
	(56549, 109, '2015-02-15 00:13:36.000000', 'temperatura', 197.0000, 'ºC'),
	(56550, 109, '2015-02-15 00:13:37.000000', 'temperatura', 869.0000, 'ºC'),
	(56551, 109, '2015-02-15 00:13:38.000000', 'temperatura', 158.0000, 'ºC'),
	(56552, 109, '2015-02-15 00:13:39.000000', 'temperatura', 582.0000, 'ºC'),
	(56553, 109, '2015-02-15 00:13:40.000000', 'temperatura', 36.0000, 'ºC'),
	(56554, 109, '2015-02-15 00:13:41.000000', 'temperatura', 836.0000, 'ºC'),
	(56555, 109, '2015-02-15 00:13:42.000000', 'temperatura', 473.0000, 'ºC'),
	(56556, 109, '2015-02-15 00:13:43.000000', 'temperatura', 1054.0000, 'ºC'),
	(56557, 109, '2015-02-15 00:13:44.000000', 'temperatura', 255.0000, 'ºC'),
	(56558, 109, '2015-02-15 00:13:45.000000', 'temperatura', 514.0000, 'ºC'),
	(56559, 109, '2015-02-15 00:13:46.000000', 'temperatura', 606.0000, 'ºC'),
	(56560, 109, '2015-02-15 00:13:47.000000', 'temperatura', 286.0000, 'ºC'),
	(56561, 109, '2015-02-15 00:13:48.000000', 'temperatura', 815.0000, 'ºC'),
	(56562, 109, '2015-02-15 00:13:49.000000', 'temperatura', 816.0000, 'ºC'),
	(56563, 109, '2015-02-15 00:13:50.000000', 'temperatura', 434.0000, 'ºC'),
	(56564, 109, '2015-02-15 00:13:51.000000', 'temperatura', 923.0000, 'ºC'),
	(56565, 109, '2015-02-15 00:13:52.000000', 'temperatura', 914.0000, 'ºC'),
	(56566, 109, '2015-02-15 00:13:53.000000', 'temperatura', 603.0000, 'ºC'),
	(56567, 109, '2015-02-15 00:13:54.000000', 'temperatura', 273.0000, 'ºC'),
	(56568, 109, '2015-02-15 00:13:55.000000', 'temperatura', 758.0000, 'ºC'),
	(56569, 109, '2015-02-15 00:13:56.000000', 'temperatura', 570.0000, 'ºC'),
	(56570, 109, '2015-02-15 00:13:57.000000', 'temperatura', 576.0000, 'ºC'),
	(56571, 109, '2015-02-15 00:13:58.000000', 'temperatura', 1173.0000, 'ºC'),
	(56572, 109, '2015-02-15 00:13:59.000000', 'temperatura', 536.0000, 'ºC'),
	(56573, 109, '2015-02-15 00:14:00.000000', 'temperatura', 360.0000, 'ºC'),
	(56574, 109, '2015-02-15 00:14:01.000000', 'temperatura', 194.0000, 'ºC'),
	(56575, 109, '2015-02-15 00:14:02.000000', 'temperatura', 1092.0000, 'ºC'),
	(56576, 109, '2015-02-15 00:14:03.000000', 'temperatura', 76.0000, 'ºC'),
	(56577, 109, '2015-02-15 00:14:04.000000', 'temperatura', 707.0000, 'ºC'),
	(56578, 109, '2015-02-15 00:14:05.000000', 'temperatura', 905.0000, 'ºC'),
	(56579, 109, '2015-02-15 00:14:06.000000', 'temperatura', 7.0000, 'ºC'),
	(56580, 109, '2015-02-15 00:14:07.000000', 'temperatura', 920.0000, 'ºC'),
	(56581, 109, '2015-02-15 00:14:08.000000', 'temperatura', 978.0000, 'ºC'),
	(56582, 109, '2015-02-15 00:14:09.000000', 'temperatura', 932.0000, 'ºC'),
	(56583, 109, '2015-02-15 00:14:10.000000', 'temperatura', 524.0000, 'ºC'),
	(56584, 109, '2015-02-15 00:14:11.000000', 'temperatura', 1028.0000, 'ºC'),
	(56585, 109, '2015-02-15 00:14:12.000000', 'temperatura', 1166.0000, 'ºC'),
	(56586, 109, '2015-02-15 00:14:13.000000', 'temperatura', 346.0000, 'ºC'),
	(56587, 109, '2015-02-15 00:14:14.000000', 'temperatura', 632.0000, 'ºC'),
	(56588, 109, '2015-02-15 00:14:15.000000', 'temperatura', 924.0000, 'ºC'),
	(56589, 109, '2015-02-15 00:14:16.000000', 'temperatura', 323.0000, 'ºC'),
	(56590, 109, '2015-02-15 00:14:17.000000', 'temperatura', 43.0000, 'ºC'),
	(56591, 109, '2015-02-15 00:14:18.000000', 'temperatura', 449.0000, 'ºC'),
	(56592, 109, '2015-02-15 00:14:19.000000', 'temperatura', 914.0000, 'ºC'),
	(56593, 109, '2015-02-15 00:14:20.000000', 'temperatura', 826.0000, 'ºC'),
	(56594, 109, '2015-02-15 00:14:21.000000', 'temperatura', 185.0000, 'ºC'),
	(56595, 109, '2015-02-15 00:14:22.000000', 'temperatura', 851.0000, 'ºC'),
	(56596, 109, '2015-02-15 00:14:23.000000', 'temperatura', 100.0000, 'ºC'),
	(56597, 109, '2015-02-15 00:14:24.000000', 'temperatura', 346.0000, 'ºC'),
	(56598, 109, '2015-02-15 00:14:25.000000', 'temperatura', 230.0000, 'ºC'),
	(56599, 109, '2015-02-15 00:14:26.000000', 'temperatura', 113.0000, 'ºC'),
	(56600, 109, '2015-02-15 00:14:27.000000', 'temperatura', 1074.0000, 'ºC'),
	(56601, 109, '2015-02-15 00:14:28.000000', 'temperatura', 231.0000, 'ºC'),
	(56602, 109, '2015-02-15 00:14:29.000000', 'temperatura', 336.0000, 'ºC'),
	(56603, 109, '2015-02-15 00:14:30.000000', 'temperatura', 988.0000, 'ºC'),
	(56604, 109, '2015-02-15 00:14:31.000000', 'temperatura', 333.0000, 'ºC'),
	(56605, 109, '2015-02-15 00:14:32.000000', 'temperatura', 1099.0000, 'ºC'),
	(56606, 109, '2015-02-15 00:14:33.000000', 'temperatura', 899.0000, 'ºC'),
	(56607, 109, '2015-02-15 00:14:34.000000', 'temperatura', 1196.0000, 'ºC'),
	(56608, 109, '2015-02-15 00:14:35.000000', 'temperatura', 883.0000, 'ºC'),
	(56609, 109, '2015-02-15 00:14:36.000000', 'temperatura', 830.0000, 'ºC'),
	(56610, 109, '2015-02-15 00:14:37.000000', 'temperatura', 299.0000, 'ºC'),
	(56611, 109, '2015-02-15 00:14:38.000000', 'temperatura', 207.0000, 'ºC'),
	(56612, 109, '2015-02-15 00:14:39.000000', 'temperatura', 139.0000, 'ºC'),
	(56613, 109, '2015-02-15 00:14:40.000000', 'temperatura', 72.0000, 'ºC'),
	(56614, 109, '2015-02-15 00:14:41.000000', 'temperatura', 1146.0000, 'ºC'),
	(56615, 109, '2015-02-15 00:14:42.000000', 'temperatura', 715.0000, 'ºC'),
	(56616, 109, '2015-02-15 00:14:43.000000', 'temperatura', 137.0000, 'ºC'),
	(56617, 109, '2015-02-15 00:14:44.000000', 'temperatura', 938.0000, 'ºC'),
	(56618, 109, '2015-02-15 00:14:45.000000', 'temperatura', 682.0000, 'ºC'),
	(56619, 109, '2015-02-15 00:14:46.000000', 'temperatura', 596.0000, 'ºC'),
	(56620, 109, '2015-02-15 00:14:47.000000', 'temperatura', 936.0000, 'ºC'),
	(56621, 109, '2015-02-15 00:14:48.000000', 'temperatura', 493.0000, 'ºC'),
	(56622, 109, '2015-02-15 00:14:49.000000', 'temperatura', 858.0000, 'ºC'),
	(56623, 109, '2015-02-15 00:14:50.000000', 'temperatura', 412.0000, 'ºC'),
	(56624, 109, '2015-02-15 00:14:51.000000', 'temperatura', 687.0000, 'ºC'),
	(56625, 109, '2015-02-15 00:14:52.000000', 'temperatura', 998.0000, 'ºC'),
	(56626, 109, '2015-02-15 00:14:53.000000', 'temperatura', 528.0000, 'ºC'),
	(56627, 109, '2015-02-15 00:14:54.000000', 'temperatura', 849.0000, 'ºC'),
	(56628, 109, '2015-02-15 00:14:55.000000', 'temperatura', 263.0000, 'ºC'),
	(56629, 109, '2015-02-15 00:14:56.000000', 'temperatura', 1165.0000, 'ºC'),
	(56630, 109, '2015-02-15 00:14:57.000000', 'temperatura', 239.0000, 'ºC'),
	(56631, 109, '2015-02-15 00:14:58.000000', 'temperatura', 101.0000, 'ºC'),
	(56632, 109, '2015-02-15 00:14:59.000000', 'temperatura', 986.0000, 'ºC'),
	(56633, 109, '2015-02-15 00:15:00.000000', 'temperatura', 1030.0000, 'ºC'),
	(56634, 109, '2015-02-15 00:15:01.000000', 'temperatura', 990.0000, 'ºC'),
	(56635, 109, '2015-02-15 00:15:02.000000', 'temperatura', 663.0000, 'ºC'),
	(56636, 109, '2015-02-15 00:15:03.000000', 'temperatura', 343.0000, 'ºC'),
	(56637, 109, '2015-02-15 00:15:04.000000', 'temperatura', 926.0000, 'ºC'),
	(56638, 109, '2015-02-15 00:15:05.000000', 'temperatura', 3.0000, 'ºC'),
	(56639, 109, '2015-02-15 00:15:06.000000', 'temperatura', 835.0000, 'ºC'),
	(56640, 109, '2015-02-15 00:15:07.000000', 'temperatura', 569.0000, 'ºC'),
	(56641, 109, '2015-02-15 00:15:08.000000', 'temperatura', 342.0000, 'ºC'),
	(56642, 109, '2015-02-15 00:15:09.000000', 'temperatura', 2.0000, 'ºC'),
	(56643, 109, '2015-02-15 00:15:10.000000', 'temperatura', 183.0000, 'ºC'),
	(56644, 109, '2015-02-15 00:15:11.000000', 'temperatura', 911.0000, 'ºC'),
	(56645, 109, '2015-02-15 00:15:12.000000', 'temperatura', 408.0000, 'ºC'),
	(56646, 109, '2015-02-15 00:15:13.000000', 'temperatura', 505.0000, 'ºC'),
	(56647, 109, '2015-02-15 00:15:14.000000', 'temperatura', 102.0000, 'ºC'),
	(56648, 109, '2015-02-15 00:15:15.000000', 'temperatura', 194.0000, 'ºC'),
	(56649, 109, '2015-02-15 00:15:16.000000', 'temperatura', 667.0000, 'ºC'),
	(56650, 109, '2015-02-15 00:15:17.000000', 'temperatura', 354.0000, 'ºC'),
	(56651, 109, '2015-02-15 00:15:18.000000', 'temperatura', 967.0000, 'ºC'),
	(56652, 109, '2015-02-15 00:15:19.000000', 'temperatura', 175.0000, 'ºC'),
	(56653, 109, '2015-02-15 00:15:20.000000', 'temperatura', 374.0000, 'ºC'),
	(56654, 109, '2015-02-15 00:15:21.000000', 'temperatura', 147.0000, 'ºC'),
	(56655, 109, '2015-02-15 00:15:22.000000', 'temperatura', 811.0000, 'ºC'),
	(56656, 109, '2015-02-15 00:15:23.000000', 'temperatura', 17.0000, 'ºC'),
	(56657, 109, '2015-02-15 00:15:24.000000', 'temperatura', 50.0000, 'ºC'),
	(56658, 109, '2015-02-15 00:15:25.000000', 'temperatura', 202.0000, 'ºC'),
	(56659, 109, '2015-02-15 00:15:26.000000', 'temperatura', 858.0000, 'ºC'),
	(56660, 109, '2015-02-15 00:15:27.000000', 'temperatura', 84.0000, 'ºC'),
	(56661, 109, '2015-02-15 00:15:28.000000', 'temperatura', 246.0000, 'ºC'),
	(56662, 109, '2015-02-15 00:15:29.000000', 'temperatura', 981.0000, 'ºC'),
	(56663, 109, '2015-02-15 00:15:30.000000', 'temperatura', 567.0000, 'ºC'),
	(56664, 109, '2015-02-15 00:15:31.000000', 'temperatura', 1092.0000, 'ºC'),
	(56665, 109, '2015-02-15 00:15:32.000000', 'temperatura', 161.0000, 'ºC'),
	(56666, 109, '2015-02-15 00:15:33.000000', 'temperatura', 1128.0000, 'ºC'),
	(56667, 109, '2015-02-15 00:15:34.000000', 'temperatura', 356.0000, 'ºC'),
	(56668, 109, '2015-02-15 00:15:35.000000', 'temperatura', 799.0000, 'ºC'),
	(56669, 109, '2015-02-15 00:15:36.000000', 'temperatura', 526.0000, 'ºC'),
	(56670, 109, '2015-02-15 00:15:37.000000', 'temperatura', 233.0000, 'ºC'),
	(56671, 109, '2015-02-15 00:15:38.000000', 'temperatura', 789.0000, 'ºC'),
	(56672, 109, '2015-02-15 00:15:39.000000', 'temperatura', 845.0000, 'ºC'),
	(56673, 109, '2015-02-15 00:15:40.000000', 'temperatura', 658.0000, 'ºC'),
	(56674, 109, '2015-02-15 00:15:41.000000', 'temperatura', 756.0000, 'ºC'),
	(56675, 109, '2015-02-15 00:15:42.000000', 'temperatura', 607.0000, 'ºC'),
	(56676, 109, '2015-02-15 00:15:43.000000', 'temperatura', 768.0000, 'ºC'),
	(56677, 109, '2015-02-15 00:15:44.000000', 'temperatura', 819.0000, 'ºC'),
	(56678, 109, '2015-02-15 00:15:45.000000', 'temperatura', 593.0000, 'ºC'),
	(56679, 109, '2015-02-15 00:15:46.000000', 'temperatura', 508.0000, 'ºC'),
	(56680, 109, '2015-02-15 00:15:47.000000', 'temperatura', 759.0000, 'ºC'),
	(56681, 109, '2015-02-15 00:15:48.000000', 'temperatura', 1074.0000, 'ºC'),
	(56682, 109, '2015-02-15 00:15:49.000000', 'temperatura', 693.0000, 'ºC'),
	(56683, 109, '2015-02-15 00:15:50.000000', 'temperatura', 245.0000, 'ºC'),
	(56684, 109, '2015-02-15 00:15:51.000000', 'temperatura', 345.0000, 'ºC'),
	(56685, 109, '2015-02-15 00:15:52.000000', 'temperatura', 992.0000, 'ºC'),
	(56686, 109, '2015-02-15 00:15:53.000000', 'temperatura', 327.0000, 'ºC'),
	(56687, 109, '2015-02-15 00:15:54.000000', 'temperatura', 1057.0000, 'ºC'),
	(56688, 109, '2015-02-15 00:15:55.000000', 'temperatura', 704.0000, 'ºC'),
	(56689, 109, '2015-02-15 00:15:56.000000', 'temperatura', 349.0000, 'ºC'),
	(56690, 109, '2015-02-15 00:15:57.000000', 'temperatura', 834.0000, 'ºC'),
	(56691, 109, '2015-02-15 00:15:58.000000', 'temperatura', 724.0000, 'ºC'),
	(56692, 109, '2015-02-15 00:15:59.000000', 'temperatura', 1120.0000, 'ºC'),
	(56693, 109, '2015-02-15 00:16:00.000000', 'temperatura', 1028.0000, 'ºC'),
	(56694, 109, '2015-02-15 00:16:01.000000', 'temperatura', 578.0000, 'ºC'),
	(56695, 109, '2015-02-15 00:16:02.000000', 'temperatura', 1010.0000, 'ºC'),
	(56696, 109, '2015-02-15 00:16:03.000000', 'temperatura', 914.0000, 'ºC'),
	(56697, 109, '2015-02-15 00:16:04.000000', 'temperatura', 342.0000, 'ºC'),
	(56698, 109, '2015-02-15 00:16:05.000000', 'temperatura', 167.0000, 'ºC'),
	(56699, 109, '2015-02-15 00:16:06.000000', 'temperatura', 1012.0000, 'ºC'),
	(56700, 109, '2015-02-15 00:16:07.000000', 'temperatura', 959.0000, 'ºC'),
	(56701, 109, '2015-02-15 00:16:08.000000', 'temperatura', 561.0000, 'ºC'),
	(56702, 109, '2015-02-15 00:16:09.000000', 'temperatura', 1127.0000, 'ºC'),
	(56703, 109, '2015-02-15 00:16:10.000000', 'temperatura', 354.0000, 'ºC'),
	(56704, 109, '2015-02-15 00:16:11.000000', 'temperatura', 787.0000, 'ºC'),
	(56705, 109, '2015-02-15 00:16:12.000000', 'temperatura', 474.0000, 'ºC'),
	(56706, 109, '2015-02-15 00:16:13.000000', 'temperatura', 9.0000, 'ºC'),
	(56707, 109, '2015-02-15 00:16:14.000000', 'temperatura', 1026.0000, 'ºC'),
	(56708, 109, '2015-02-15 00:16:15.000000', 'temperatura', 300.0000, 'ºC'),
	(56709, 109, '2015-02-15 00:16:16.000000', 'temperatura', 825.0000, 'ºC'),
	(56710, 109, '2015-02-15 00:16:17.000000', 'temperatura', 826.0000, 'ºC'),
	(56711, 109, '2015-02-15 00:16:18.000000', 'temperatura', 456.0000, 'ºC'),
	(56712, 109, '2015-02-15 00:16:19.000000', 'temperatura', 1004.0000, 'ºC'),
	(56713, 109, '2015-02-15 00:16:20.000000', 'temperatura', 49.0000, 'ºC'),
	(56714, 109, '2015-02-15 00:16:21.000000', 'temperatura', 834.0000, 'ºC'),
	(56715, 109, '2015-02-15 00:16:22.000000', 'temperatura', 425.0000, 'ºC'),
	(56716, 109, '2015-02-15 00:16:23.000000', 'temperatura', 821.0000, 'ºC'),
	(56717, 109, '2015-02-15 00:16:24.000000', 'temperatura', 432.0000, 'ºC'),
	(56718, 109, '2015-02-15 00:16:25.000000', 'temperatura', 896.0000, 'ºC'),
	(56719, 109, '2015-02-15 00:16:26.000000', 'temperatura', 785.0000, 'ºC'),
	(56720, 109, '2015-02-15 00:16:27.000000', 'temperatura', 37.0000, 'ºC'),
	(56721, 109, '2015-02-15 00:16:28.000000', 'temperatura', 231.0000, 'ºC'),
	(56722, 109, '2015-02-15 00:16:29.000000', 'temperatura', 1044.0000, 'ºC'),
	(56723, 109, '2015-02-15 00:16:30.000000', 'temperatura', 930.0000, 'ºC'),
	(56724, 109, '2015-02-15 00:16:31.000000', 'temperatura', 317.0000, 'ºC'),
	(56725, 109, '2015-02-15 00:16:32.000000', 'temperatura', 1194.0000, 'ºC'),
	(56726, 109, '2015-02-15 00:16:33.000000', 'temperatura', 222.0000, 'ºC'),
	(56727, 109, '2015-02-15 00:16:34.000000', 'temperatura', 1129.0000, 'ºC'),
	(56728, 109, '2015-02-15 00:16:35.000000', 'temperatura', 176.0000, 'ºC'),
	(56729, 109, '2015-02-15 00:16:36.000000', 'temperatura', 1097.0000, 'ºC'),
	(56730, 109, '2015-02-15 00:16:37.000000', 'temperatura', 155.0000, 'ºC'),
	(56731, 109, '2015-02-15 00:16:38.000000', 'temperatura', 1086.0000, 'ºC'),
	(56732, 109, '2015-02-15 00:16:39.000000', 'temperatura', 164.0000, 'ºC'),
	(56733, 109, '2015-02-15 00:16:40.000000', 'temperatura', 1164.0000, 'ºC'),
	(56734, 109, '2015-02-15 00:16:41.000000', 'temperatura', 526.0000, 'ºC'),
	(56735, 109, '2015-02-15 00:16:42.000000', 'temperatura', 340.0000, 'ºC'),
	(56736, 109, '2015-02-15 00:16:43.000000', 'temperatura', 123.0000, 'ºC'),
	(56737, 109, '2015-02-15 00:16:44.000000', 'temperatura', 793.0000, 'ºC'),
	(56738, 109, '2015-02-15 00:16:45.000000', 'temperatura', 0.0000, 'ºC'),
	(56739, 109, '2015-02-15 00:16:46.000000', 'temperatura', 19.0000, 'ºC'),
	(56740, 109, '2015-02-15 00:16:47.000000', 'temperatura', 96.0000, 'ºC'),
	(56741, 109, '2015-02-15 00:16:48.000000', 'temperatura', 422.0000, 'ºC'),
	(56742, 109, '2015-02-15 00:16:49.000000', 'temperatura', 624.0000, 'ºC'),
	(56743, 109, '2015-02-15 00:16:50.000000', 'temperatura', 654.0000, 'ºC'),
	(56744, 109, '2015-02-15 00:16:51.000000', 'temperatura', 197.0000, 'ºC'),
	(56745, 109, '2015-02-15 00:16:52.000000', 'temperatura', 226.0000, 'ºC'),
	(56746, 109, '2015-02-15 00:16:53.000000', 'temperatura', 537.0000, 'ºC'),
	(56747, 109, '2015-02-15 00:16:54.000000', 'temperatura', 809.0000, 'ºC'),
	(56748, 109, '2015-02-15 00:16:55.000000', 'temperatura', 32.0000, 'ºC'),
	(56749, 109, '2015-02-15 00:16:56.000000', 'temperatura', 136.0000, 'ºC'),
	(56750, 109, '2015-02-15 00:16:57.000000', 'temperatura', 582.0000, 'ºC'),
	(56751, 109, '2015-02-15 00:16:58.000000', 'temperatura', 104.0000, 'ºC'),
	(56752, 109, '2015-02-15 00:16:59.000000', 'temperatura', 1175.0000, 'ºC'),
	(56753, 109, '2015-02-15 00:17:00.000000', 'temperatura', 764.0000, 'ºC'),
	(56754, 109, '2015-02-15 00:17:01.000000', 'temperatura', 294.0000, 'ºC'),
	(56755, 109, '2015-02-15 00:17:02.000000', 'temperatura', 378.0000, 'ºC'),
	(56756, 109, '2015-02-15 00:17:03.000000', 'temperatura', 1008.0000, 'ºC'),
	(56757, 109, '2015-02-15 00:17:04.000000', 'temperatura', 306.0000, 'ºC'),
	(56758, 109, '2015-02-15 00:17:05.000000', 'temperatura', 909.0000, 'ºC'),
	(56759, 109, '2015-02-15 00:17:06.000000', 'temperatura', 28.0000, 'ºC'),
	(56760, 109, '2015-02-15 00:17:07.000000', 'temperatura', 1011.0000, 'ºC'),
	(56761, 109, '2015-02-15 00:17:08.000000', 'temperatura', 172.0000, 'ºC'),
	(56762, 109, '2015-02-15 00:17:09.000000', 'temperatura', 227.0000, 'ºC'),
	(56763, 109, '2015-02-15 00:17:10.000000', 'temperatura', 622.0000, 'ºC'),
	(56764, 109, '2015-02-15 00:17:11.000000', 'temperatura', 29.0000, 'ºC'),
	(56765, 109, '2015-02-15 00:17:12.000000', 'temperatura', 678.0000, 'ºC'),
	(56766, 109, '2015-02-15 00:17:13.000000', 'temperatura', 903.0000, 'ºC'),
	(56767, 109, '2015-02-15 00:17:14.000000', 'temperatura', 81.0000, 'ºC'),
	(56768, 109, '2015-02-15 00:17:15.000000', 'temperatura', 98.0000, 'ºC'),
	(56769, 109, '2015-02-15 00:17:16.000000', 'temperatura', 249.0000, 'ºC'),
	(56770, 109, '2015-02-15 00:17:17.000000', 'temperatura', 951.0000, 'ºC'),
	(56771, 109, '2015-02-15 00:17:18.000000', 'temperatura', 408.0000, 'ºC'),
	(56772, 109, '2015-02-15 00:17:19.000000', 'temperatura', 389.0000, 'ºC'),
	(56773, 109, '2015-02-15 00:17:20.000000', 'temperatura', 719.0000, 'ºC'),
	(56774, 109, '2015-02-15 00:17:21.000000', 'temperatura', 30.0000, 'ºC'),
	(56775, 109, '2015-02-15 00:17:22.000000', 'temperatura', 394.0000, 'ºC'),
	(56776, 109, '2015-02-15 00:17:23.000000', 'temperatura', 678.0000, 'ºC'),
	(56777, 109, '2015-02-15 00:17:24.000000', 'temperatura', 1009.0000, 'ºC'),
	(56778, 109, '2015-02-15 00:17:25.000000', 'temperatura', 612.0000, 'ºC'),
	(56779, 109, '2015-02-15 00:17:26.000000', 'temperatura', 34.0000, 'ºC'),
	(56780, 109, '2015-02-15 00:17:27.000000', 'temperatura', 732.0000, 'ºC'),
	(56781, 109, '2015-02-15 00:17:28.000000', 'temperatura', 1161.0000, 'ºC'),
	(56782, 109, '2015-02-15 00:17:29.000000', 'temperatura', 10.0000, 'ºC'),
	(56783, 109, '2015-02-15 00:17:30.000000', 'temperatura', 167.0000, 'ºC'),
	(56784, 109, '2015-02-15 00:17:31.000000', 'temperatura', 807.0000, 'ºC'),
	(56785, 109, '2015-02-15 00:17:32.000000', 'temperatura', 1132.0000, 'ºC'),
	(56786, 109, '2015-02-15 00:17:33.000000', 'temperatura', 840.0000, 'ºC'),
	(56787, 109, '2015-02-15 00:17:34.000000', 'temperatura', 805.0000, 'ºC'),
	(56788, 109, '2015-02-15 00:17:35.000000', 'temperatura', 306.0000, 'ºC'),
	(56789, 109, '2015-02-15 00:17:36.000000', 'temperatura', 314.0000, 'ºC'),
	(56790, 109, '2015-02-15 00:17:37.000000', 'temperatura', 654.0000, 'ºC'),
	(56791, 109, '2015-02-15 00:17:38.000000', 'temperatura', 1126.0000, 'ºC'),
	(56792, 109, '2015-02-15 00:17:39.000000', 'temperatura', 71.0000, 'ºC'),
	(56793, 109, '2015-02-15 00:17:40.000000', 'temperatura', 576.0000, 'ºC'),
	(56794, 109, '2015-02-15 00:17:41.000000', 'temperatura', 268.0000, 'ºC'),
	(56795, 109, '2015-02-15 00:17:42.000000', 'temperatura', 811.0000, 'ºC'),
	(56796, 109, '2015-02-15 00:17:43.000000', 'temperatura', 851.0000, 'ºC'),
	(56797, 109, '2015-02-15 00:17:44.000000', 'temperatura', 623.0000, 'ºC'),
	(56798, 109, '2015-02-15 00:17:45.000000', 'temperatura', 562.0000, 'ºC'),
	(56799, 109, '2015-02-15 00:17:46.000000', 'temperatura', 942.0000, 'ºC'),
	(56800, 109, '2015-02-15 00:17:47.000000', 'temperatura', 626.0000, 'ºC'),
	(56801, 109, '2015-02-15 00:17:48.000000', 'temperatura', 303.0000, 'ºC'),
	(56802, 109, '2015-02-15 00:17:49.000000', 'temperatura', 839.0000, 'ºC'),
	(56803, 109, '2015-02-15 00:17:50.000000', 'temperatura', 886.0000, 'ºC'),
	(56804, 109, '2015-02-15 00:17:51.000000', 'temperatura', 714.0000, 'ºC'),
	(56805, 109, '2015-02-15 00:17:52.000000', 'temperatura', 910.0000, 'ºC'),
	(56806, 109, '2015-02-15 00:17:53.000000', 'temperatura', 12.0000, 'ºC'),
	(56807, 109, '2015-02-15 00:17:54.000000', 'temperatura', 927.0000, 'ºC'),
	(56808, 109, '2015-02-15 00:17:55.000000', 'temperatura', 1001.0000, 'ºC'),
	(56809, 109, '2015-02-15 00:17:56.000000', 'temperatura', 1026.0000, 'ºC'),
	(56810, 109, '2015-02-15 00:17:57.000000', 'temperatura', 925.0000, 'ºC'),
	(56811, 109, '2015-02-15 00:17:58.000000', 'temperatura', 346.0000, 'ºC'),
	(56812, 109, '2015-02-15 00:17:59.000000', 'temperatura', 159.0000, 'ºC'),
	(56813, 109, '2015-02-15 00:18:00.000000', 'temperatura', 957.0000, 'ºC'),
	(56814, 109, '2015-02-15 00:18:01.000000', 'temperatura', 706.0000, 'ºC'),
	(56815, 109, '2015-02-15 00:18:02.000000', 'temperatura', 661.0000, 'ºC'),
	(56816, 109, '2015-02-15 00:18:03.000000', 'temperatura', 1187.0000, 'ºC'),
	(56817, 109, '2015-02-15 00:18:04.000000', 'temperatura', 352.0000, 'ºC'),
	(56818, 109, '2015-02-15 00:18:05.000000', 'temperatura', 601.0000, 'ºC'),
	(56819, 109, '2015-02-15 00:18:06.000000', 'temperatura', 750.0000, 'ºC'),
	(56820, 109, '2015-02-15 00:18:07.000000', 'temperatura', 746.0000, 'ºC'),
	(56821, 109, '2015-02-15 00:18:08.000000', 'temperatura', 283.0000, 'ºC'),
	(56822, 109, '2015-02-15 00:18:09.000000', 'temperatura', 377.0000, 'ºC'),
	(56823, 109, '2015-02-15 00:18:10.000000', 'temperatura', 1034.0000, 'ºC'),
	(56824, 109, '2015-02-15 00:18:11.000000', 'temperatura', 441.0000, 'ºC'),
	(56825, 109, '2015-02-15 00:18:12.000000', 'temperatura', 303.0000, 'ºC'),
	(56826, 109, '2015-02-15 00:18:13.000000', 'temperatura', 191.0000, 'ºC'),
	(56827, 109, '2015-02-15 00:18:14.000000', 'temperatura', 50.0000, 'ºC'),
	(56828, 109, '2015-02-15 00:18:15.000000', 'temperatura', 874.0000, 'ºC'),
	(56829, 109, '2015-02-15 00:18:16.000000', 'temperatura', 623.0000, 'ºC'),
	(56830, 109, '2015-02-15 00:18:17.000000', 'temperatura', 492.0000, 'ºC'),
	(56831, 109, '2015-02-15 00:18:18.000000', 'temperatura', 594.0000, 'ºC'),
	(56832, 109, '2015-02-15 00:18:19.000000', 'temperatura', 294.0000, 'ºC'),
	(56833, 109, '2015-02-15 00:18:20.000000', 'temperatura', 886.0000, 'ºC'),
	(56834, 109, '2015-02-15 00:18:21.000000', 'temperatura', 1150.0000, 'ºC'),
	(56835, 109, '2015-02-15 00:18:22.000000', 'temperatura', 694.0000, 'ºC'),
	(56836, 109, '2015-02-15 00:18:23.000000', 'temperatura', 21.0000, 'ºC'),
	(56837, 109, '2015-02-15 00:18:24.000000', 'temperatura', 424.0000, 'ºC'),
	(56838, 109, '2015-02-15 00:18:25.000000', 'temperatura', 857.0000, 'ºC'),
	(56839, 109, '2015-02-15 00:18:26.000000', 'temperatura', 612.0000, 'ºC'),
	(56840, 109, '2015-02-15 00:18:27.000000', 'temperatura', 489.0000, 'ºC'),
	(56841, 109, '2015-02-15 00:18:28.000000', 'temperatura', 611.0000, 'ºC'),
	(56842, 109, '2015-02-15 00:18:29.000000', 'temperatura', 390.0000, 'ºC'),
	(56843, 109, '2015-02-15 00:18:30.000000', 'temperatura', 117.0000, 'ºC'),
	(56844, 109, '2015-02-15 00:18:31.000000', 'temperatura', 613.0000, 'ºC'),
	(56845, 109, '2015-02-15 00:18:32.000000', 'temperatura', 315.0000, 'ºC'),
	(56846, 109, '2015-02-15 00:18:33.000000', 'temperatura', 938.0000, 'ºC'),
	(56847, 109, '2015-02-15 00:18:34.000000', 'temperatura', 143.0000, 'ºC'),
	(56848, 109, '2015-02-15 00:18:35.000000', 'temperatura', 304.0000, 'ºC'),
	(56849, 109, '2015-02-15 00:18:36.000000', 'temperatura', 1091.0000, 'ºC'),
	(56850, 109, '2015-02-15 00:18:37.000000', 'temperatura', 944.0000, 'ºC'),
	(56851, 109, '2015-02-15 00:18:38.000000', 'temperatura', 246.0000, 'ºC'),
	(56852, 109, '2015-02-15 00:18:39.000000', 'temperatura', 798.0000, 'ºC'),
	(56853, 109, '2015-02-15 00:18:40.000000', 'temperatura', 854.0000, 'ºC'),
	(56854, 109, '2015-02-15 00:18:41.000000', 'temperatura', 676.0000, 'ºC'),
	(56855, 109, '2015-02-15 00:18:42.000000', 'temperatura', 818.0000, 'ºC'),
	(56856, 109, '2015-02-15 00:18:43.000000', 'temperatura', 862.0000, 'ºC'),
	(56857, 109, '2015-02-15 00:18:44.000000', 'temperatura', 658.0000, 'ºC'),
	(56858, 109, '2015-02-15 00:18:45.000000', 'temperatura', 703.0000, 'ºC'),
	(56859, 109, '2015-02-15 00:18:46.000000', 'temperatura', 344.0000, 'ºC'),
	(56860, 109, '2015-02-15 00:18:47.000000', 'temperatura', 810.0000, 'ºC'),
	(56861, 109, '2015-02-15 00:18:48.000000', 'temperatura', 620.0000, 'ºC'),
	(56862, 109, '2015-02-15 00:18:49.000000', 'temperatura', 669.0000, 'ºC'),
	(56863, 109, '2015-02-15 00:18:50.000000', 'temperatura', 284.0000, 'ºC'),
	(56864, 109, '2015-02-15 00:18:51.000000', 'temperatura', 615.0000, 'ºC'),
	(56865, 109, '2015-02-15 00:18:52.000000', 'temperatura', 1025.0000, 'ºC'),
	(56866, 109, '2015-02-15 00:18:53.000000', 'temperatura', 877.0000, 'ºC'),
	(56867, 109, '2015-02-15 00:18:54.000000', 'temperatura', 113.0000, 'ºC'),
	(56868, 109, '2015-02-15 00:18:55.000000', 'temperatura', 334.0000, 'ºC'),
	(56869, 109, '2015-02-15 00:18:56.000000', 'temperatura', 132.0000, 'ºC'),
	(56870, 109, '2015-02-15 00:18:57.000000', 'temperatura', 858.0000, 'ºC'),
	(56871, 109, '2015-02-15 00:18:58.000000', 'temperatura', 295.0000, 'ºC'),
	(56872, 109, '2015-02-15 00:18:59.000000', 'temperatura', 102.0000, 'ºC'),
	(56873, 109, '2015-02-15 00:19:00.000000', 'temperatura', 826.0000, 'ºC'),
	(56874, 109, '2015-02-15 00:19:01.000000', 'temperatura', 224.0000, 'ºC'),
	(56875, 109, '2015-02-15 00:19:02.000000', 'temperatura', 1041.0000, 'ºC'),
	(56876, 109, '2015-02-15 00:19:03.000000', 'temperatura', 936.0000, 'ºC'),
	(56877, 109, '2015-02-15 00:19:04.000000', 'temperatura', 354.0000, 'ºC'),
	(56878, 109, '2015-02-15 00:19:05.000000', 'temperatura', 166.0000, 'ºC'),
	(56879, 109, '2015-02-15 00:19:06.000000', 'temperatura', 965.0000, 'ºC'),
	(56880, 109, '2015-02-15 00:19:07.000000', 'temperatura', 731.0000, 'ºC'),
	(56881, 109, '2015-02-15 00:19:08.000000', 'temperatura', 760.0000, 'ºC'),
	(56882, 109, '2015-02-15 00:19:09.000000', 'temperatura', 406.0000, 'ºC'),
	(56883, 109, '2015-02-15 00:19:10.000000', 'temperatura', 950.0000, 'ºC'),
	(56884, 109, '2015-02-15 00:19:11.000000', 'temperatura', 1135.0000, 'ºC'),
	(56885, 109, '2015-02-15 00:19:12.000000', 'temperatura', 424.0000, 'ºC'),
	(56886, 109, '2015-02-15 00:19:13.000000', 'temperatura', 1117.0000, 'ºC'),
	(56887, 109, '2015-02-15 00:19:14.000000', 'temperatura', 713.0000, 'ºC'),
	(56888, 109, '2015-02-15 00:19:15.000000', 'temperatura', 212.0000, 'ºC'),
	(56889, 109, '2015-02-15 00:19:16.000000', 'temperatura', 124.0000, 'ºC'),
	(56890, 109, '2015-02-15 00:19:17.000000', 'temperatura', 1182.0000, 'ºC'),
	(56891, 109, '2015-02-15 00:19:18.000000', 'temperatura', 739.0000, 'ºC'),
	(56892, 109, '2015-02-15 00:19:19.000000', 'temperatura', 150.0000, 'ºC'),
	(56893, 109, '2015-02-15 00:19:20.000000', 'temperatura', 932.0000, 'ºC'),
	(56894, 109, '2015-02-15 00:19:21.000000', 'temperatura', 613.0000, 'ºC'),
	(56895, 109, '2015-02-15 00:19:22.000000', 'temperatura', 269.0000, 'ºC'),
	(56896, 109, '2015-02-15 00:19:23.000000', 'temperatura', 707.0000, 'ºC'),
	(56897, 109, '2015-02-15 00:19:24.000000', 'temperatura', 329.0000, 'ºC'),
	(56898, 109, '2015-02-15 00:19:25.000000', 'temperatura', 722.0000, 'ºC'),
	(56899, 109, '2015-02-15 00:19:26.000000', 'temperatura', 224.0000, 'ºC'),
	(56900, 109, '2015-02-15 00:19:27.000000', 'temperatura', 154.0000, 'ºC'),
	(56901, 109, '2015-02-15 00:19:28.000000', 'temperatura', 101.0000, 'ºC'),
	(56902, 109, '2015-02-15 00:19:29.000000', 'temperatura', 42.0000, 'ºC'),
	(56903, 109, '2015-02-15 00:19:30.000000', 'temperatura', 1106.0000, 'ºC'),
	(56904, 109, '2015-02-15 00:19:31.000000', 'temperatura', 608.0000, 'ºC'),
	(56905, 109, '2015-02-15 00:19:32.000000', 'temperatura', 920.0000, 'ºC'),
	(56906, 109, '2015-02-15 00:19:33.000000', 'temperatura', 376.0000, 'ºC'),
	(56907, 109, '2015-02-15 00:19:34.000000', 'temperatura', 320.0000, 'ºC'),
	(56908, 109, '2015-02-15 00:19:35.000000', 'temperatura', 474.0000, 'ºC'),
	(56909, 109, '2015-02-15 00:19:36.000000', 'temperatura', 208.0000, 'ºC'),
	(56910, 109, '2015-02-15 00:19:37.000000', 'temperatura', 820.0000, 'ºC'),
	(56911, 109, '2015-02-15 00:19:38.000000', 'temperatura', 1077.0000, 'ºC'),
	(56912, 109, '2015-02-15 00:19:39.000000', 'temperatura', 526.0000, 'ºC'),
	(56913, 109, '2015-02-15 00:19:40.000000', 'temperatura', 601.0000, 'ºC'),
	(56914, 109, '2015-02-15 00:19:41.000000', 'temperatura', 224.0000, 'ºC'),
	(56915, 109, '2015-02-15 00:19:42.000000', 'temperatura', 519.0000, 'ºC'),
	(56916, 109, '2015-02-15 00:19:43.000000', 'temperatura', 724.0000, 'ºC'),
	(56917, 109, '2015-02-15 00:19:44.000000', 'temperatura', 861.0000, 'ºC'),
	(56918, 109, '2015-02-15 00:19:45.000000', 'temperatura', 937.0000, 'ºC'),
	(56919, 109, '2015-02-15 00:19:46.000000', 'temperatura', 900.0000, 'ºC'),
	(56920, 109, '2015-02-15 00:19:47.000000', 'temperatura', 489.0000, 'ºC'),
	(56921, 109, '2015-02-15 00:19:48.000000', 'temperatura', 947.0000, 'ºC'),
	(56922, 109, '2015-02-15 00:19:49.000000', 'temperatura', 870.0000, 'ºC'),
	(56923, 109, '2015-02-15 00:19:50.000000', 'temperatura', 307.0000, 'ºC'),
	(56924, 109, '2015-02-15 00:19:51.000000', 'temperatura', 125.0000, 'ºC'),
	(56925, 109, '2015-02-15 00:19:52.000000', 'temperatura', 904.0000, 'ºC'),
	(56926, 109, '2015-02-15 00:19:53.000000', 'temperatura', 546.0000, 'ºC'),
	(56927, 109, '2015-02-15 00:19:54.000000', 'temperatura', 19.0000, 'ºC'),
	(56928, 109, '2015-02-15 00:19:55.000000', 'temperatura', 856.0000, 'ºC'),
	(56929, 109, '2015-02-15 00:19:56.000000', 'temperatura', 623.0000, 'ºC'),
	(56930, 109, '2015-02-15 00:19:57.000000', 'temperatura', 548.0000, 'ºC'),
	(56931, 109, '2015-02-15 00:19:58.000000', 'temperatura', 873.0000, 'ºC'),
	(56932, 109, '2015-02-15 00:19:59.000000', 'temperatura', 321.0000, 'ºC'),
	(56933, 109, '2015-02-15 00:20:00.000000', 'temperatura', 188.0000, 'ºC'),
	(56934, 109, '2015-02-15 00:20:01.000000', 'temperatura', 1176.0000, 'ºC'),
	(56935, 109, '2015-02-15 00:20:02.000000', 'temperatura', 515.0000, 'ºC'),
	(56936, 109, '2015-02-15 00:20:03.000000', 'temperatura', 248.0000, 'ºC'),
	(56937, 109, '2015-02-15 00:20:04.000000', 'temperatura', 897.0000, 'ºC'),
	(56938, 109, '2015-02-15 00:20:05.000000', 'temperatura', 141.0000, 'ºC'),
	(56939, 109, '2015-02-15 00:20:06.000000', 'temperatura', 414.0000, 'ºC'),
	(56940, 109, '2015-02-15 00:20:07.000000', 'temperatura', 448.0000, 'ºC'),
	(56941, 109, '2015-02-15 00:20:08.000000', 'temperatura', 998.0000, 'ºC'),
	(56942, 109, '2015-02-15 00:20:09.000000', 'temperatura', 46.0000, 'ºC'),
	(56943, 109, '2015-02-15 00:20:10.000000', 'temperatura', 838.0000, 'ºC'),
	(56944, 109, '2015-02-15 00:20:11.000000', 'temperatura', 451.0000, 'ºC'),
	(56945, 109, '2015-02-15 00:20:12.000000', 'temperatura', 943.0000, 'ºC'),
	(56946, 109, '2015-02-15 00:20:13.000000', 'temperatura', 961.0000, 'ºC'),
	(56947, 109, '2015-02-15 00:20:14.000000', 'temperatura', 776.0000, 'ºC'),
	(56948, 109, '2015-02-15 00:20:15.000000', 'temperatura', 999.0000, 'ºC'),
	(56949, 109, '2015-02-15 00:20:16.000000', 'temperatura', 266.0000, 'ºC'),
	(56950, 109, '2015-02-15 00:20:17.000000', 'temperatura', 734.0000, 'ºC'),
	(56951, 109, '2015-02-15 00:20:18.000000', 'temperatura', 472.0000, 'ºC'),
	(56952, 109, '2015-02-15 00:20:19.000000', 'temperatura', 158.0000, 'ºC'),
	(56953, 109, '2015-02-15 00:20:20.000000', 'temperatura', 574.0000, 'ºC'),
	(56954, 109, '2015-02-15 00:20:21.000000', 'temperatura', 1197.0000, 'ºC'),
	(56955, 109, '2015-02-15 00:20:22.000000', 'temperatura', 663.0000, 'ºC'),
	(56956, 109, '2015-02-15 00:20:23.000000', 'temperatura', 923.0000, 'ºC'),
	(56957, 109, '2015-02-15 00:20:24.000000', 'temperatura', 230.0000, 'ºC'),
	(56958, 109, '2015-02-15 00:20:25.000000', 'temperatura', 780.0000, 'ºC'),
	(56959, 109, '2015-02-15 00:20:26.000000', 'temperatura', 811.0000, 'ºC'),
	(56960, 109, '2015-02-15 00:20:27.000000', 'temperatura', 517.0000, 'ºC'),
	(56961, 109, '2015-02-15 00:20:28.000000', 'temperatura', 150.0000, 'ºC'),
	(56962, 109, '2015-02-15 00:20:29.000000', 'temperatura', 399.0000, 'ºC'),
	(56963, 109, '2015-02-15 00:20:30.000000', 'temperatura', 347.0000, 'ºC'),
	(56964, 109, '2015-02-15 00:20:31.000000', 'temperatura', 540.0000, 'ºC'),
	(56965, 109, '2015-02-15 00:20:32.000000', 'temperatura', 459.0000, 'ºC'),
	(56966, 109, '2015-02-15 00:20:33.000000', 'temperatura', 675.0000, 'ºC'),
	(56967, 109, '2015-02-15 00:20:34.000000', 'temperatura', 798.0000, 'ºC'),
	(56968, 109, '2015-02-15 00:20:35.000000', 'temperatura', 768.0000, 'ºC'),
	(56969, 109, '2015-02-15 00:20:36.000000', 'temperatura', 245.0000, 'ºC'),
	(56970, 109, '2015-02-15 00:20:37.000000', 'temperatura', 120.0000, 'ºC'),
	(56971, 109, '2015-02-15 00:20:38.000000', 'temperatura', 1067.0000, 'ºC'),
	(56972, 109, '2015-02-15 00:20:39.000000', 'temperatura', 177.0000, 'ºC'),
	(56973, 109, '2015-02-15 00:20:40.000000', 'temperatura', 82.0000, 'ºC'),
	(56974, 109, '2015-02-15 00:20:41.000000', 'temperatura', 1081.0000, 'ºC'),
	(56975, 109, '2015-02-15 00:20:42.000000', 'temperatura', 357.0000, 'ºC'),
	(56976, 109, '2015-02-15 00:20:43.000000', 'temperatura', 944.0000, 'ºC'),
	(56977, 109, '2015-02-15 00:20:44.000000', 'temperatura', 48.0000, 'ºC'),
	(56978, 109, '2015-02-15 00:20:45.000000', 'temperatura', 1008.0000, 'ºC'),
	(56979, 109, '2015-02-15 00:20:46.000000', 'temperatura', 100.0000, 'ºC'),
	(56980, 109, '2015-02-15 00:20:47.000000', 'temperatura', 1073.0000, 'ºC'),
	(56981, 109, '2015-02-15 00:20:48.000000', 'temperatura', 268.0000, 'ºC'),
	(56982, 109, '2015-02-15 00:20:49.000000', 'temperatura', 521.0000, 'ºC'),
	(56983, 109, '2015-02-15 00:20:50.000000', 'temperatura', 601.0000, 'ºC'),
	(56984, 109, '2015-02-15 00:20:51.000000', 'temperatura', 242.0000, 'ºC'),
	(56985, 109, '2015-02-15 00:20:52.000000', 'temperatura', 608.0000, 'ºC'),
	(56986, 109, '2015-02-15 00:20:53.000000', 'temperatura', 1114.0000, 'ºC'),
	(56987, 109, '2015-02-15 00:20:54.000000', 'temperatura', 148.0000, 'ºC'),
	(56988, 109, '2015-02-15 00:20:55.000000', 'temperatura', 997.0000, 'ºC'),
	(56989, 109, '2015-02-15 00:20:56.000000', 'temperatura', 940.0000, 'ºC'),
	(56990, 109, '2015-02-15 00:20:57.000000', 'temperatura', 513.0000, 'ºC'),
	(56991, 109, '2015-02-15 00:20:58.000000', 'temperatura', 943.0000, 'ºC'),
	(56992, 109, '2015-02-15 00:20:59.000000', 'temperatura', 777.0000, 'ºC'),
	(56993, 109, '2015-02-15 00:21:00.000000', 'temperatura', 1058.0000, 'ºC'),
	(56994, 109, '2015-02-15 00:21:01.000000', 'temperatura', 560.0000, 'ºC'),
	(56995, 109, '2015-02-15 00:21:02.000000', 'temperatura', 825.0000, 'ºC'),
	(56996, 109, '2015-02-15 00:21:03.000000', 'temperatura', 46.0000, 'ºC'),
	(56997, 109, '2015-02-15 00:21:04.000000', 'temperatura', 155.0000, 'ºC'),
	(56998, 109, '2015-02-15 00:21:05.000000', 'temperatura', 637.0000, 'ºC'),
	(56999, 109, '2015-02-15 00:21:06.000000', 'temperatura', 321.0000, 'ºC'),
	(57000, 109, '2015-02-15 00:21:07.000000', 'temperatura', 892.0000, 'ºC'),
	(57001, 109, '2015-02-15 00:21:08.000000', 'temperatura', 1101.0000, 'ºC'),
	(57002, 109, '2015-02-15 00:21:09.000000', 'temperatura', 429.0000, 'ºC'),
	(57003, 109, '2015-02-15 00:21:10.000000', 'temperatura', 40.0000, 'ºC'),
	(57004, 109, '2015-02-15 00:21:11.000000', 'temperatura', 117.0000, 'ºC'),
	(57005, 109, '2015-02-15 00:21:12.000000', 'temperatura', 464.0000, 'ºC'),
	(57006, 109, '2015-02-15 00:21:13.000000', 'temperatura', 770.0000, 'ºC'),
	(57007, 109, '2015-02-15 00:21:14.000000', 'temperatura', 60.0000, 'ºC'),
	(57008, 109, '2015-02-15 00:21:15.000000', 'temperatura', 387.0000, 'ºC'),
	(57009, 109, '2015-02-15 00:21:16.000000', 'temperatura', 558.0000, 'ºC'),
	(57010, 109, '2015-02-15 00:21:17.000000', 'temperatura', 430.0000, 'ºC'),
	(57011, 109, '2015-02-15 00:21:18.000000', 'temperatura', 477.0000, 'ºC'),
	(57012, 109, '2015-02-15 00:21:19.000000', 'temperatura', 1093.0000, 'ºC'),
	(57013, 109, '2015-02-15 00:21:20.000000', 'temperatura', 436.0000, 'ºC'),
	(57014, 109, '2015-02-15 00:21:21.000000', 'temperatura', 101.0000, 'ºC'),
	(57015, 109, '2015-02-15 00:21:22.000000', 'temperatura', 398.0000, 'ºC'),
	(57016, 109, '2015-02-15 00:21:23.000000', 'temperatura', 488.0000, 'ºC'),
	(57017, 109, '2015-02-15 00:21:24.000000', 'temperatura', 45.0000, 'ºC'),
	(57018, 109, '2015-02-15 00:21:25.000000', 'temperatura', 1161.0000, 'ºC'),
	(57019, 109, '2015-02-15 00:21:26.000000', 'temperatura', 873.0000, 'ºC'),
	(57020, 109, '2015-02-15 00:21:27.000000', 'temperatura', 883.0000, 'ºC'),
	(57021, 109, '2015-02-15 00:21:28.000000', 'temperatura', 597.0000, 'ºC'),
	(57022, 109, '2015-02-15 00:21:29.000000', 'temperatura', 335.0000, 'ºC'),
	(57023, 109, '2015-02-15 00:21:30.000000', 'temperatura', 1084.0000, 'ºC'),
	(57024, 109, '2015-02-15 00:21:31.000000', 'temperatura', 815.0000, 'ºC'),
	(57025, 109, '2015-02-15 00:21:32.000000', 'temperatura', 823.0000, 'ºC'),
	(57026, 109, '2015-02-15 00:21:33.000000', 'temperatura', 469.0000, 'ºC'),
	(57027, 109, '2015-02-15 00:21:34.000000', 'temperatura', 1079.0000, 'ºC'),
	(57028, 109, '2015-02-15 00:21:35.000000', 'temperatura', 390.0000, 'ºC'),
	(57029, 109, '2015-02-15 00:21:36.000000', 'temperatura', 1112.0000, 'ºC'),
	(57030, 109, '2015-02-15 00:21:37.000000', 'temperatura', 790.0000, 'ºC'),
	(57031, 109, '2015-02-15 00:21:38.000000', 'temperatura', 614.0000, 'ºC'),
	(57032, 109, '2015-02-15 00:21:39.000000', 'temperatura', 700.0000, 'ºC'),
	(57033, 109, '2015-02-15 00:21:40.000000', 'temperatura', 459.0000, 'ºC'),
	(57034, 109, '2015-02-15 00:21:41.000000', 'temperatura', 194.0000, 'ºC'),
	(57035, 109, '2015-02-15 00:21:42.000000', 'temperatura', 795.0000, 'ºC'),
	(57036, 109, '2015-02-15 00:21:43.000000', 'temperatura', 992.0000, 'ºC'),
	(57037, 109, '2015-02-15 00:21:44.000000', 'temperatura', 176.0000, 'ºC'),
	(57038, 109, '2015-02-15 00:21:45.000000', 'temperatura', 304.0000, 'ºC'),
	(57039, 109, '2015-02-15 00:21:46.000000', 'temperatura', 994.0000, 'ºC'),
	(57040, 109, '2015-02-15 00:21:47.000000', 'temperatura', 457.0000, 'ºC'),
	(57041, 109, '2015-02-15 00:21:48.000000', 'temperatura', 502.0000, 'ºC'),
	(57042, 109, '2015-02-15 00:21:49.000000', 'temperatura', 1141.0000, 'ºC'),
	(57043, 109, '2015-02-15 00:21:50.000000', 'temperatura', 602.0000, 'ºC'),
	(57044, 109, '2015-02-15 00:21:51.000000', 'temperatura', 784.0000, 'ºC'),
	(57045, 109, '2015-02-15 00:21:52.000000', 'temperatura', 914.0000, 'ºC'),
	(57046, 109, '2015-02-15 00:21:53.000000', 'temperatura', 1020.0000, 'ºC'),
	(57047, 109, '2015-02-15 00:21:54.000000', 'temperatura', 1158.0000, 'ºC'),
	(57048, 109, '2015-02-15 00:21:55.000000', 'temperatura', 330.0000, 'ºC'),
	(57049, 109, '2015-02-15 00:21:56.000000', 'temperatura', 576.0000, 'ºC'),
	(57050, 109, '2015-02-15 00:21:57.000000', 'temperatura', 690.0000, 'ºC'),
	(57051, 109, '2015-02-15 00:21:58.000000', 'temperatura', 523.0000, 'ºC'),
	(57052, 109, '2015-02-15 00:21:59.000000', 'temperatura', 547.0000, 'ºC'),
	(57053, 109, '2015-02-15 00:22:00.000000', 'temperatura', 1166.0000, 'ºC'),
	(57054, 109, '2015-02-15 00:22:01.000000', 'temperatura', 589.0000, 'ºC'),
	(57055, 109, '2015-02-15 00:22:02.000000', 'temperatura', 649.0000, 'ºC'),
	(57056, 109, '2015-02-15 00:22:03.000000', 'temperatura', 278.0000, 'ºC'),
	(57057, 109, '2015-02-15 00:22:04.000000', 'temperatura', 641.0000, 'ºC'),
	(57058, 109, '2015-02-15 00:22:05.000000', 'temperatura', 1173.0000, 'ºC'),
	(57059, 109, '2015-02-15 00:22:06.000000', 'temperatura', 344.0000, 'ºC'),
	(57060, 109, '2015-02-15 00:22:07.000000', 'temperatura', 600.0000, 'ºC'),
	(57061, 109, '2015-02-15 00:22:08.000000', 'temperatura', 770.0000, 'ºC'),
	(57062, 109, '2015-02-15 00:22:09.000000', 'temperatura', 851.0000, 'ºC'),
	(57063, 109, '2015-02-15 00:22:10.000000', 'temperatura', 743.0000, 'ºC'),
	(57064, 109, '2015-02-15 00:22:11.000000', 'temperatura', 1162.0000, 'ºC'),
	(57065, 109, '2015-02-15 00:22:12.000000', 'temperatura', 1181.0000, 'ºC'),
	(57066, 109, '2015-02-15 00:22:13.000000', 'temperatura', 20.0000, 'ºC'),
	(57067, 109, '2015-02-15 00:22:14.000000', 'temperatura', 156.0000, 'ºC'),
	(57068, 109, '2015-02-15 00:22:15.000000', 'temperatura', 721.0000, 'ºC'),
	(57069, 109, '2015-02-15 00:22:16.000000', 'temperatura', 738.0000, 'ºC'),
	(57070, 109, '2015-02-15 00:22:17.000000', 'temperatura', 327.0000, 'ºC'),
	(57071, 109, '2015-02-15 00:22:18.000000', 'temperatura', 622.0000, 'ºC'),
	(57072, 109, '2015-02-15 00:22:19.000000', 'temperatura', 929.0000, 'ºC'),
	(57073, 109, '2015-02-15 00:22:20.000000', 'temperatura', 380.0000, 'ºC'),
	(57074, 109, '2015-02-15 00:22:21.000000', 'temperatura', 314.0000, 'ºC'),
	(57075, 109, '2015-02-15 00:22:22.000000', 'temperatura', 430.0000, 'ºC'),
	(57076, 109, '2015-02-15 00:22:23.000000', 'temperatura', 7.0000, 'ºC'),
	(57077, 109, '2015-02-15 00:22:24.000000', 'temperatura', 1146.0000, 'ºC'),
	(57078, 109, '2015-02-15 00:22:25.000000', 'temperatura', 910.0000, 'ºC'),
	(57079, 109, '2015-02-15 00:22:26.000000', 'temperatura', 1114.0000, 'ºC'),
	(57080, 109, '2015-02-15 00:22:27.000000', 'temperatura', 438.0000, 'ºC'),
	(57081, 109, '2015-02-15 00:22:28.000000', 'temperatura', 52.0000, 'ºC'),
	(57082, 109, '2015-02-15 00:22:29.000000', 'temperatura', 143.0000, 'ºC'),
	(57083, 109, '2015-02-15 00:22:30.000000', 'temperatura', 561.0000, 'ºC'),
	(57084, 109, '2015-02-15 00:22:31.000000', 'temperatura', 1177.0000, 'ºC'),
	(57085, 109, '2015-02-15 00:22:32.000000', 'temperatura', 604.0000, 'ºC'),
	(57086, 109, '2015-02-15 00:22:33.000000', 'temperatura', 686.0000, 'ºC'),
	(57087, 109, '2015-02-15 00:22:34.000000', 'temperatura', 420.0000, 'ºC'),
	(57088, 109, '2015-02-15 00:22:35.000000', 'temperatura', 44.0000, 'ºC'),
	(57089, 109, '2015-02-15 00:22:36.000000', 'temperatura', 161.0000, 'ºC'),
	(57090, 109, '2015-02-15 00:22:37.000000', 'temperatura', 672.0000, 'ºC'),
	(57091, 109, '2015-02-15 00:22:38.000000', 'temperatura', 477.0000, 'ºC'),
	(57092, 109, '2015-02-15 00:22:39.000000', 'temperatura', 371.0000, 'ºC'),
	(57093, 109, '2015-02-15 00:22:40.000000', 'temperatura', 424.0000, 'ºC'),
	(57094, 109, '2015-02-15 00:22:41.000000', 'temperatura', 1007.0000, 'ºC'),
	(57095, 109, '2015-02-15 00:22:42.000000', 'temperatura', 162.0000, 'ºC'),
	(57096, 109, '2015-02-15 00:22:43.000000', 'temperatura', 191.0000, 'ºC'),
	(57097, 109, '2015-02-15 00:22:44.000000', 'temperatura', 470.0000, 'ºC'),
	(57098, 109, '2015-02-15 00:22:45.000000', 'temperatura', 576.0000, 'ºC'),
	(57099, 109, '2015-02-15 00:22:46.000000', 'temperatura', 272.0000, 'ºC'),
	(57100, 109, '2015-02-15 00:22:47.000000', 'temperatura', 834.0000, 'ºC'),
	(57101, 109, '2015-02-15 00:22:48.000000', 'temperatura', 952.0000, 'ºC'),
	(57102, 109, '2015-02-15 00:22:49.000000', 'temperatura', 1061.0000, 'ºC'),
	(57103, 109, '2015-02-15 00:22:50.000000', 'temperatura', 48.0000, 'ºC'),
	(57104, 109, '2015-02-15 00:22:51.000000', 'temperatura', 660.0000, 'ºC'),
	(57105, 109, '2015-02-15 00:22:52.000000', 'temperatura', 754.0000, 'ºC'),
	(57106, 109, '2015-02-15 00:22:53.000000', 'temperatura', 592.0000, 'ºC'),
	(57107, 109, '2015-02-15 00:22:54.000000', 'temperatura', 696.0000, 'ºC'),
	(57108, 109, '2015-02-15 00:22:55.000000', 'temperatura', 508.0000, 'ºC'),
	(57109, 109, '2015-02-15 00:22:56.000000', 'temperatura', 450.0000, 'ºC'),
	(57110, 109, '2015-02-15 00:22:57.000000', 'temperatura', 726.0000, 'ºC'),
	(57111, 109, '2015-02-15 00:22:58.000000', 'temperatura', 1080.0000, 'ºC'),
	(57112, 109, '2015-02-15 00:22:59.000000', 'temperatura', 823.0000, 'ºC'),
	(57113, 109, '2015-02-15 00:23:00.000000', 'temperatura', 874.0000, 'ºC'),
	(57114, 109, '2015-02-15 00:23:01.000000', 'temperatura', 703.0000, 'ºC'),
	(57115, 109, '2015-02-15 00:23:02.000000', 'temperatura', 895.0000, 'ºC'),
	(57116, 109, '2015-02-15 00:23:03.000000', 'temperatura', 1167.0000, 'ºC'),
	(57117, 109, '2015-02-15 00:23:04.000000', 'temperatura', 749.0000, 'ºC'),
	(57118, 109, '2015-02-15 00:23:05.000000', 'temperatura', 246.0000, 'ºC'),
	(57119, 109, '2015-02-15 00:23:06.000000', 'temperatura', 182.0000, 'ºC'),
	(57120, 109, '2015-02-15 00:23:07.000000', 'temperatura', 172.0000, 'ºC'),
	(57121, 109, '2015-02-15 00:23:08.000000', 'temperatura', 314.0000, 'ºC'),
	(57122, 109, '2015-02-15 00:23:09.000000', 'temperatura', 1055.0000, 'ºC'),
	(57123, 109, '2015-02-15 00:23:10.000000', 'temperatura', 735.0000, 'ºC'),
	(57124, 109, '2015-02-15 00:23:11.000000', 'temperatura', 508.0000, 'ºC'),
	(57125, 109, '2015-02-15 00:23:12.000000', 'temperatura', 336.0000, 'ºC'),
	(57126, 109, '2015-02-15 00:23:13.000000', 'temperatura', 157.0000, 'ºC'),
	(57127, 109, '2015-02-15 00:23:14.000000', 'temperatura', 978.0000, 'ºC'),
	(57128, 109, '2015-02-15 00:23:15.000000', 'temperatura', 819.0000, 'ºC'),
	(57129, 109, '2015-02-15 00:23:16.000000', 'temperatura', 1162.0000, 'ºC'),
	(57130, 109, '2015-02-15 00:23:17.000000', 'temperatura', 952.0000, 'ºC'),
	(57131, 109, '2015-02-15 00:23:18.000000', 'temperatura', 75.0000, 'ºC'),
	(57132, 109, '2015-02-15 00:23:19.000000', 'temperatura', 1120.0000, 'ºC'),
	(57133, 109, '2015-02-15 00:23:20.000000', 'temperatura', 576.0000, 'ºC'),
	(57134, 109, '2015-02-15 00:23:21.000000', 'temperatura', 720.0000, 'ºC'),
	(57135, 109, '2015-02-15 00:23:22.000000', 'temperatura', 673.0000, 'ºC'),
	(57136, 109, '2015-02-15 00:23:23.000000', 'temperatura', 6.0000, 'ºC'),
	(57137, 109, '2015-02-15 00:23:24.000000', 'temperatura', 413.0000, 'ºC'),
	(57138, 109, '2015-02-15 00:23:25.000000', 'temperatura', 846.0000, 'ºC'),
	(57139, 109, '2015-02-15 00:23:26.000000', 'temperatura', 590.0000, 'ºC'),
	(57140, 109, '2015-02-15 00:23:27.000000', 'temperatura', 413.0000, 'ºC'),
	(57141, 109, '2015-02-15 00:23:28.000000', 'temperatura', 294.0000, 'ºC'),
	(57142, 109, '2015-02-15 00:23:29.000000', 'temperatura', 234.0000, 'ºC'),
	(57143, 109, '2015-02-15 00:23:30.000000', 'temperatura', 289.0000, 'ºC'),
	(57144, 109, '2015-02-15 00:23:31.000000', 'temperatura', 742.0000, 'ºC'),
	(57145, 109, '2015-02-15 00:23:32.000000', 'temperatura', 446.0000, 'ºC'),
	(57146, 109, '2015-02-15 00:23:33.000000', 'temperatura', 3.0000, 'ºC'),
	(57147, 109, '2015-02-15 00:23:34.000000', 'temperatura', 1076.0000, 'ºC'),
	(57148, 109, '2015-02-15 00:23:35.000000', 'temperatura', 571.0000, 'ºC'),
	(57149, 109, '2015-02-15 00:23:36.000000', 'temperatura', 828.0000, 'ºC'),
	(57150, 109, '2015-02-15 00:23:37.000000', 'temperatura', 26.0000, 'ºC'),
	(57151, 109, '2015-02-15 00:23:38.000000', 'temperatura', 48.0000, 'ºC'),
	(57152, 109, '2015-02-15 00:23:39.000000', 'temperatura', 162.0000, 'ºC'),
	(57153, 109, '2015-02-15 00:23:40.000000', 'temperatura', 666.0000, 'ºC'),
	(57154, 109, '2015-02-15 00:23:41.000000', 'temperatura', 447.0000, 'ºC'),
	(57155, 109, '2015-02-15 00:23:42.000000', 'temperatura', 236.0000, 'ºC'),
	(57156, 109, '2015-02-15 00:23:43.000000', 'temperatura', 1038.0000, 'ºC'),
	(57157, 109, '2015-02-15 00:23:44.000000', 'temperatura', 884.0000, 'ºC'),
	(57158, 109, '2015-02-15 00:23:45.000000', 'temperatura', 105.0000, 'ºC'),
	(57159, 109, '2015-02-15 00:23:46.000000', 'temperatura', 276.0000, 'ºC'),
	(57160, 109, '2015-02-15 00:23:47.000000', 'temperatura', 1062.0000, 'ºC'),
	(57161, 109, '2015-02-15 00:23:48.000000', 'temperatura', 886.0000, 'ºC'),
	(57162, 109, '2015-02-15 00:23:49.000000', 'temperatura', 41.0000, 'ºC'),
	(57163, 109, '2015-02-15 00:23:50.000000', 'temperatura', 1150.0000, 'ºC'),
	(57164, 109, '2015-02-15 00:23:51.000000', 'temperatura', 827.0000, 'ºC'),
	(57165, 109, '2015-02-15 00:23:52.000000', 'temperatura', 687.0000, 'ºC'),
	(57166, 109, '2015-02-15 00:23:53.000000', 'temperatura', 952.0000, 'ºC'),
	(57167, 109, '2015-02-15 00:23:54.000000', 'temperatura', 299.0000, 'ºC'),
	(57168, 109, '2015-02-15 00:23:55.000000', 'temperatura', 1040.0000, 'ºC'),
	(57169, 109, '2015-02-15 00:23:56.000000', 'temperatura', 702.0000, 'ºC'),
	(57170, 109, '2015-02-15 00:23:57.000000', 'temperatura', 393.0000, 'ºC'),
	(57171, 109, '2015-02-15 00:23:58.000000', 'temperatura', 1059.0000, 'ºC'),
	(57172, 109, '2015-02-15 00:23:59.000000', 'temperatura', 515.0000, 'ºC'),
	(57173, 109, '2015-02-15 00:24:00.000000', 'temperatura', 597.0000, 'ºC'),
	(57174, 109, '2015-02-15 00:24:01.000000', 'temperatura', 244.0000, 'ºC'),
	(57175, 109, '2015-02-15 00:24:02.000000', 'temperatura', 629.0000, 'ºC'),
	(57176, 109, '2015-02-15 00:24:03.000000', 'temperatura', 11.0000, 'ºC'),
	(57177, 109, '2015-02-15 00:24:04.000000', 'temperatura', 569.0000, 'ºC'),
	(57178, 109, '2015-02-15 00:24:05.000000', 'temperatura', 415.0000, 'ºC'),
	(57179, 109, '2015-02-15 00:24:06.000000', 'temperatura', 366.0000, 'ºC'),
	(57180, 109, '2015-02-15 00:24:07.000000', 'temperatura', 586.0000, 'ºC'),
	(57181, 109, '2015-02-15 00:24:08.000000', 'temperatura', 632.0000, 'ºC'),
	(57182, 109, '2015-02-15 00:24:09.000000', 'temperatura', 205.0000, 'ºC'),
	(57183, 109, '2015-02-15 00:24:10.000000', 'temperatura', 327.0000, 'ºC'),
	(57184, 109, '2015-02-15 00:24:11.000000', 'temperatura', 1020.0000, 'ºC'),
	(57185, 109, '2015-02-15 00:24:12.000000', 'temperatura', 522.0000, 'ºC'),
	(57186, 109, '2015-02-15 00:24:13.000000', 'temperatura', 747.0000, 'ºC'),
	(57187, 109, '2015-02-15 00:24:14.000000', 'temperatura', 973.0000, 'ºC'),
	(57188, 109, '2015-02-15 00:24:15.000000', 'temperatura', 222.0000, 'ºC'),
	(57189, 109, '2015-02-15 00:24:16.000000', 'temperatura', 591.0000, 'ºC'),
	(57190, 109, '2015-02-15 00:24:17.000000', 'temperatura', 1090.0000, 'ºC'),
	(57191, 109, '2015-02-15 00:24:18.000000', 'temperatura', 80.0000, 'ºC'),
	(57192, 109, '2015-02-15 00:24:19.000000', 'temperatura', 727.0000, 'ºC'),
	(57193, 109, '2015-02-15 00:24:20.000000', 'temperatura', 998.0000, 'ºC'),
	(57194, 109, '2015-02-15 00:24:21.000000', 'temperatura', 409.0000, 'ºC'),
	(57195, 109, '2015-02-15 00:24:22.000000', 'temperatura', 252.0000, 'ºC'),
	(57196, 109, '2015-02-15 00:24:23.000000', 'temperatura', 34.0000, 'ºC'),
	(57197, 109, '2015-02-15 00:24:24.000000', 'temperatura', 615.0000, 'ºC'),
	(57198, 109, '2015-02-15 00:24:25.000000', 'temperatura', 573.0000, 'ºC'),
	(57199, 109, '2015-02-15 00:24:26.000000', 'temperatura', 1019.0000, 'ºC'),
	(57200, 109, '2015-02-15 00:24:27.000000', 'temperatura', 978.0000, 'ºC'),
	(57201, 109, '2015-02-15 00:24:28.000000', 'temperatura', 635.0000, 'ºC'),
	(57202, 109, '2015-02-15 00:24:29.000000', 'temperatura', 241.0000, 'ºC'),
	(57203, 109, '2015-02-15 00:24:30.000000', 'temperatura', 499.0000, 'ºC'),
	(57204, 109, '2015-02-15 00:24:31.000000', 'temperatura', 573.0000, 'ºC'),
	(57205, 109, '2015-02-15 00:24:32.000000', 'temperatura', 167.0000, 'ºC'),
	(57206, 109, '2015-02-15 00:24:33.000000', 'temperatura', 319.0000, 'ºC'),
	(57207, 109, '2015-02-15 00:24:34.000000', 'temperatura', 1093.0000, 'ºC'),
	(57208, 109, '2015-02-15 00:24:35.000000', 'temperatura', 911.0000, 'ºC'),
	(57209, 109, '2015-02-15 00:24:36.000000', 'temperatura', 74.0000, 'ºC'),
	(57210, 109, '2015-02-15 00:24:37.000000', 'temperatura', 38.0000, 'ºC'),
	(57211, 109, '2015-02-15 00:24:38.000000', 'temperatura', 1169.0000, 'ºC'),
	(57212, 109, '2015-02-15 00:24:39.000000', 'temperatura', 932.0000, 'ºC'),
	(57213, 109, '2015-02-15 00:24:40.000000', 'temperatura', 1152.0000, 'ºC'),
	(57214, 109, '2015-02-15 00:24:41.000000', 'temperatura', 567.0000, 'ºC'),
	(57215, 109, '2015-02-15 00:24:42.000000', 'temperatura', 579.0000, 'ºC'),
	(57216, 109, '2015-02-15 00:24:43.000000', 'temperatura', 1193.0000, 'ºC'),
	(57217, 109, '2015-02-15 00:24:44.000000', 'temperatura', 629.0000, 'ºC'),
	(57218, 109, '2015-02-15 00:24:45.000000', 'temperatura', 765.0000, 'ºC'),
	(57219, 109, '2015-02-15 00:24:46.000000', 'temperatura', 738.0000, 'ºC'),
	(57220, 109, '2015-02-15 00:24:47.000000', 'temperatura', 196.0000, 'ºC'),
	(57221, 109, '2015-02-15 00:24:48.000000', 'temperatura', 1166.0000, 'ºC'),
	(57222, 109, '2015-02-15 00:24:49.000000', 'temperatura', 443.0000, 'ºC'),
	(57223, 109, '2015-02-15 00:24:50.000000', 'temperatura', 1116.0000, 'ºC'),
	(57224, 109, '2015-02-15 00:24:51.000000', 'temperatura', 651.0000, 'ºC'),
	(57225, 109, '2015-02-15 00:24:52.000000', 'temperatura', 1107.0000, 'ºC'),
	(57226, 109, '2015-02-15 00:24:53.000000', 'temperatura', 1184.0000, 'ºC'),
	(57227, 109, '2015-02-15 00:24:54.000000', 'temperatura', 201.0000, 'ºC'),
	(57228, 109, '2015-02-15 00:24:55.000000', 'temperatura', 1053.0000, 'ºC'),
	(57229, 109, '2015-02-15 00:24:56.000000', 'temperatura', 1060.0000, 'ºC'),
	(57230, 109, '2015-02-15 00:24:57.000000', 'temperatura', 942.0000, 'ºC'),
	(57231, 109, '2015-02-15 00:24:58.000000', 'temperatura', 333.0000, 'ºC'),
	(57232, 109, '2015-02-15 00:24:59.000000', 'temperatura', 39.0000, 'ºC'),
	(57233, 109, '2015-02-15 00:25:00.000000', 'temperatura', 395.0000, 'ºC'),
	(57234, 109, '2015-02-15 00:25:01.000000', 'temperatura', 660.0000, 'ºC'),
	(57235, 109, '2015-02-15 00:25:02.000000', 'temperatura', 916.0000, 'ºC'),
	(57236, 109, '2015-02-15 00:25:03.000000', 'temperatura', 201.0000, 'ºC'),
	(57237, 109, '2015-02-15 00:25:04.000000', 'temperatura', 656.0000, 'ºC'),
	(57238, 109, '2015-02-15 00:25:05.000000', 'temperatura', 278.0000, 'ºC'),
	(57239, 109, '2015-02-15 00:25:06.000000', 'temperatura', 621.0000, 'ºC'),
	(57240, 109, '2015-02-15 00:25:07.000000', 'temperatura', 1073.0000, 'ºC'),
	(57241, 109, '2015-02-15 00:25:08.000000', 'temperatura', 1101.0000, 'ºC'),
	(57242, 109, '2015-02-15 00:25:09.000000', 'temperatura', 1088.0000, 'ºC'),
	(57243, 109, '2015-02-15 00:25:10.000000', 'temperatura', 938.0000, 'ºC'),
	(57244, 109, '2015-02-15 00:25:11.000000', 'temperatura', 227.0000, 'ºC'),
	(57245, 109, '2015-02-15 00:25:12.000000', 'temperatura', 720.0000, 'ºC'),
	(57246, 109, '2015-02-15 00:25:13.000000', 'temperatura', 521.0000, 'ºC'),
	(57247, 109, '2015-02-15 00:25:14.000000', 'temperatura', 446.0000, 'ºC'),
	(57248, 109, '2015-02-15 00:25:15.000000', 'temperatura', 666.0000, 'ºC'),
	(57249, 109, '2015-02-15 00:25:16.000000', 'temperatura', 791.0000, 'ºC'),
	(57250, 109, '2015-02-15 00:25:17.000000', 'temperatura', 759.0000, 'ºC'),
	(57251, 109, '2015-02-15 00:25:18.000000', 'temperatura', 224.0000, 'ºC'),
	(57252, 109, '2015-02-15 00:25:19.000000', 'temperatura', 41.0000, 'ºC'),
	(57253, 109, '2015-02-15 00:25:20.000000', 'temperatura', 737.0000, 'ºC'),
	(57254, 109, '2015-02-15 00:25:21.000000', 'temperatura', 1159.0000, 'ºC'),
	(57255, 109, '2015-02-15 00:25:22.000000', 'temperatura', 1185.0000, 'ºC'),
	(57256, 109, '2015-02-15 00:25:23.000000', 'temperatura', 47.0000, 'ºC'),
	(57257, 109, '2015-02-15 00:25:24.000000', 'temperatura', 283.0000, 'ºC'),
	(57258, 109, '2015-02-15 00:25:25.000000', 'temperatura', 73.0000, 'ºC'),
	(57259, 109, '2015-02-15 00:25:26.000000', 'temperatura', 715.0000, 'ºC'),
	(57260, 109, '2015-02-15 00:25:27.000000', 'temperatura', 959.0000, 'ºC'),
	(57261, 109, '2015-02-15 00:25:28.000000', 'temperatura', 250.0000, 'ºC'),
	(57262, 109, '2015-02-15 00:25:29.000000', 'temperatura', 773.0000, 'ºC'),
	(57263, 109, '2015-02-15 00:25:30.000000', 'temperatura', 715.0000, 'ºC'),
	(57264, 109, '2015-02-15 00:25:31.000000', 'temperatura', 57.0000, 'ºC'),
	(57265, 109, '2015-02-15 00:25:32.000000', 'temperatura', 540.0000, 'ºC'),
	(57266, 109, '2015-02-15 00:25:33.000000', 'temperatura', 129.0000, 'ºC'),
	(57267, 109, '2015-02-15 00:25:34.000000', 'temperatura', 227.0000, 'ºC'),
	(57268, 109, '2015-02-15 00:25:35.000000', 'temperatura', 747.0000, 'ºC'),
	(57269, 109, '2015-02-15 00:25:36.000000', 'temperatura', 653.0000, 'ºC'),
	(57270, 109, '2015-02-15 00:25:37.000000', 'temperatura', 1027.0000, 'ºC'),
	(57271, 109, '2015-02-15 00:25:38.000000', 'temperatura', 777.0000, 'ºC'),
	(57272, 109, '2015-02-15 00:25:39.000000', 'temperatura', 806.0000, 'ºC'),
	(57273, 109, '2015-02-15 00:25:40.000000', 'temperatura', 497.0000, 'ºC'),
	(57274, 109, '2015-02-15 00:25:41.000000', 'temperatura', 67.0000, 'ºC'),
	(57275, 109, '2015-02-15 00:25:42.000000', 'temperatura', 47.0000, 'ºC'),
	(57276, 109, '2015-02-15 00:25:43.000000', 'temperatura', 33.0000, 'ºC'),
	(57277, 109, '2015-02-15 00:25:44.000000', 'temperatura', 23.0000, 'ºC'),
	(57278, 109, '2015-02-15 00:25:45.000000', 'temperatura', 16.0000, 'ºC'),
	(57279, 109, '2015-02-15 00:25:46.000000', 'temperatura', 12.0000, 'ºC'),
	(57280, 109, '2015-02-15 00:25:47.000000', 'temperatura', 12.0000, 'ºC'),
	(57281, 109, '2015-02-15 00:25:48.000000', 'temperatura', 26.0000, 'ºC'),
	(57282, 109, '2015-02-15 00:25:49.000000', 'temperatura', 93.0000, 'ºC'),
	(57283, 109, '2015-02-15 00:25:50.000000', 'temperatura', 388.0000, 'ºC'),
	(57284, 109, '2015-02-15 00:25:51.000000', 'temperatura', 462.0000, 'ºC'),
	(57285, 109, '2015-02-15 00:25:52.000000', 'temperatura', 1146.0000, 'ºC'),
	(57286, 109, '2015-02-15 00:25:53.000000', 'temperatura', 746.0000, 'ºC'),
	(57287, 109, '2015-02-15 00:25:54.000000', 'temperatura', 292.0000, 'ºC'),
	(57288, 109, '2015-02-15 00:25:55.000000', 'temperatura', 420.0000, 'ºC'),
	(57289, 109, '2015-02-15 00:25:56.000000', 'temperatura', 28.0000, 'ºC'),
	(57290, 109, '2015-02-15 00:25:57.000000', 'temperatura', 78.0000, 'ºC'),
	(57291, 109, '2015-02-15 00:25:58.000000', 'temperatura', 308.0000, 'ºC'),
	(57292, 109, '2015-02-15 00:25:59.000000', 'temperatura', 107.0000, 'ºC'),
	(57293, 109, '2015-02-15 00:26:00.000000', 'temperatura', 809.0000, 'ºC'),
	(57294, 109, '2015-02-15 00:26:01.000000', 'temperatura', 125.0000, 'ºC'),
	(57295, 109, '2015-02-15 00:26:02.000000', 'temperatura', 597.0000, 'ºC'),
	(57296, 109, '2015-02-15 00:26:03.000000', 'temperatura', 213.0000, 'ºC'),
	(57297, 109, '2015-02-15 00:26:04.000000', 'temperatura', 472.0000, 'ºC'),
	(57298, 109, '2015-02-15 00:26:05.000000', 'temperatura', 524.0000, 'ºC'),
	(57299, 109, '2015-02-15 00:26:06.000000', 'temperatura', 2.0000, 'ºC'),
	(57300, 109, '2015-02-15 00:26:07.000000', 'temperatura', 839.0000, 'ºC'),
	(57301, 109, '2015-02-15 00:26:08.000000', 'temperatura', 592.0000, 'ºC'),
	(57302, 109, '2015-02-15 00:26:09.000000', 'temperatura', 442.0000, 'ºC'),
	(57303, 109, '2015-02-15 00:26:10.000000', 'temperatura', 436.0000, 'ºC'),
	(57304, 109, '2015-02-15 00:26:11.000000', 'temperatura', 853.0000, 'ºC'),
	(57305, 109, '2015-02-15 00:26:12.000000', 'temperatura', 556.0000, 'ºC'),
	(57306, 109, '2015-02-15 00:26:13.000000', 'temperatura', 224.0000, 'ºC'),
	(57307, 109, '2015-02-15 00:26:14.000000', 'temperatura', 654.0000, 'ºC'),
	(57308, 109, '2015-02-15 00:26:15.000000', 'temperatura', 196.0000, 'ºC'),
	(57309, 109, '2015-02-15 00:26:16.000000', 'temperatura', 219.0000, 'ºC'),
	(57310, 109, '2015-02-15 00:26:17.000000', 'temperatura', 505.0000, 'ºC'),
	(57311, 109, '2015-02-15 00:26:18.000000', 'temperatura', 672.0000, 'ºC'),
	(57312, 109, '2015-02-15 00:26:19.000000', 'temperatura', 646.0000, 'ºC'),
	(57313, 109, '2015-02-15 00:26:20.000000', 'temperatura', 12.0000, 'ºC'),
	(57314, 109, '2015-02-15 00:26:21.000000', 'temperatura', 522.0000, 'ºC'),
	(57315, 109, '2015-02-15 00:26:22.000000', 'temperatura', 177.0000, 'ºC'),
	(57316, 109, '2015-02-15 00:26:23.000000', 'temperatura', 519.0000, 'ºC'),
	(57317, 109, '2015-02-15 00:26:24.000000', 'temperatura', 863.0000, 'ºC'),
	(57318, 109, '2015-02-15 00:26:25.000000', 'temperatura', 361.0000, 'ºC'),
	(57319, 109, '2015-02-15 00:26:26.000000', 'temperatura', 414.0000, 'ºC'),
	(57320, 109, '2015-02-15 00:26:27.000000', 'temperatura', 989.0000, 'ºC'),
	(57321, 109, '2015-02-15 00:26:28.000000', 'temperatura', 102.0000, 'ºC'),
	(57322, 109, '2015-02-15 00:26:29.000000', 'temperatura', 1143.0000, 'ºC'),
	(57323, 109, '2015-02-15 00:26:30.000000', 'temperatura', 612.0000, 'ºC'),
	(57324, 109, '2015-02-15 00:26:31.000000', 'temperatura', 830.0000, 'ºC'),
	(57325, 109, '2015-02-15 00:26:32.000000', 'temperatura', 1115.0000, 'ºC'),
	(57326, 109, '2015-02-15 00:26:33.000000', 'temperatura', 684.0000, 'ºC'),
	(57327, 109, '2015-02-15 00:26:34.000000', 'temperatura', 78.0000, 'ºC'),
	(57328, 109, '2015-02-15 00:26:35.000000', 'temperatura', 738.0000, 'ºC'),
	(57329, 109, '2015-02-15 00:26:36.000000', 'temperatura', 1057.0000, 'ºC'),
	(57330, 109, '2015-02-15 00:26:37.000000', 'temperatura', 673.0000, 'ºC'),
	(57331, 109, '2015-02-15 00:26:38.000000', 'temperatura', 193.0000, 'ºC'),
	(57332, 109, '2015-02-15 00:26:39.000000', 'temperatura', 145.0000, 'ºC'),
	(57333, 109, '2015-02-15 00:26:40.000000', 'temperatura', 149.0000, 'ºC'),
	(57334, 109, '2015-02-15 00:26:41.000000', 'temperatura', 310.0000, 'ºC'),
	(57335, 109, '2015-02-15 00:26:42.000000', 'temperatura', 1104.0000, 'ºC'),
	(57336, 109, '2015-02-15 00:26:43.000000', 'temperatura', 989.0000, 'ºC'),
	(57337, 109, '2015-02-15 00:26:44.000000', 'temperatura', 434.0000, 'ºC'),
	(57338, 109, '2015-02-15 00:26:45.000000', 'temperatura', 405.0000, 'ºC'),
	(57339, 109, '2015-02-15 00:26:46.000000', 'temperatura', 723.0000, 'ºC'),
	(57340, 109, '2015-02-15 00:26:47.000000', 'temperatura', 0.0000, 'ºC'),
	(57341, 109, '2015-02-15 00:26:48.000000', 'temperatura', 230.0000, 'ºC'),
	(57342, 109, '2015-02-15 00:26:49.000000', 'temperatura', 1151.0000, 'ºC'),
	(57343, 109, '2015-02-15 00:26:50.000000', 'temperatura', 266.0000, 'ºC'),
	(57344, 109, '2015-02-15 00:26:51.000000', 'temperatura', 276.0000, 'ºC'),
	(57345, 109, '2015-02-15 00:26:52.000000', 'temperatura', 583.0000, 'ºC'),
	(57346, 109, '2015-02-15 00:26:53.000000', 'temperatura', 886.0000, 'ºC'),
	(57347, 109, '2015-02-15 00:26:54.000000', 'temperatura', 285.0000, 'ºC'),
	(57348, 109, '2015-02-15 00:26:55.000000', 'temperatura', 1166.0000, 'ºC'),
	(57349, 109, '2015-02-15 00:26:56.000000', 'temperatura', 174.0000, 'ºC'),
	(57350, 109, '2015-02-15 00:26:57.000000', 'temperatura', 974.0000, 'ºC'),
	(57351, 109, '2015-02-15 00:26:58.000000', 'temperatura', 748.0000, 'ºC'),
	(57352, 109, '2015-02-15 00:26:59.000000', 'temperatura', 818.0000, 'ºC'),
	(57353, 109, '2015-02-15 00:27:00.000000', 'temperatura', 647.0000, 'ºC'),
	(57354, 109, '2015-02-15 00:27:01.000000', 'temperatura', 780.0000, 'ºC'),
	(57355, 109, '2015-02-15 00:27:02.000000', 'temperatura', 761.0000, 'ºC'),
	(57356, 109, '2015-02-15 00:27:03.000000', 'temperatura', 264.0000, 'ºC'),
	(57357, 109, '2015-02-15 00:27:04.000000', 'temperatura', 237.0000, 'ºC'),
	(57358, 109, '2015-02-15 00:27:05.000000', 'temperatura', 396.0000, 'ºC'),
	(57359, 109, '2015-02-15 00:27:06.000000', 'temperatura', 69.0000, 'ºC'),
	(57360, 109, '2015-02-15 00:27:07.000000', 'temperatura', 356.0000, 'ºC'),
	(57361, 109, '2015-02-15 00:27:08.000000', 'temperatura', 372.0000, 'ºC'),
	(57362, 109, '2015-02-15 00:27:09.000000', 'temperatura', 795.0000, 'ºC'),
	(57363, 109, '2015-02-15 00:27:10.000000', 'temperatura', 460.0000, 'ºC'),
	(57364, 109, '2015-02-15 00:27:11.000000', 'temperatura', 1115.0000, 'ºC'),
	(57365, 109, '2015-02-15 00:27:12.000000', 'temperatura', 596.0000, 'ºC'),
	(57366, 109, '2015-02-15 00:27:13.000000', 'temperatura', 837.0000, 'ºC'),
	(57367, 109, '2015-02-15 00:27:14.000000', 'temperatura', 1194.0000, 'ºC'),
	(57368, 109, '2015-02-15 00:27:15.000000', 'temperatura', 1061.0000, 'ºC'),
	(57369, 109, '2015-02-15 00:27:16.000000', 'temperatura', 523.0000, 'ºC'),
	(57370, 109, '2015-02-15 00:27:17.000000', 'temperatura', 634.0000, 'ºC'),
	(57371, 109, '2015-02-15 00:27:18.000000', 'temperatura', 401.0000, 'ºC'),
	(57372, 109, '2015-02-15 00:27:19.000000', 'temperatura', 103.0000, 'ºC'),
	(57373, 109, '2015-02-15 00:27:20.000000', 'temperatura', 514.0000, 'ºC'),
	(57374, 109, '2015-02-15 00:27:21.000000', 'temperatura', 1062.0000, 'ºC'),
	(57375, 109, '2015-02-15 00:27:22.000000', 'temperatura', 166.0000, 'ºC'),
	(57376, 109, '2015-02-15 00:27:23.000000', 'temperatura', 44.0000, 'ºC'),
	(57377, 109, '2015-02-15 00:27:24.000000', 'temperatura', 924.0000, 'ºC'),
	(57378, 109, '2015-02-15 00:27:25.000000', 'temperatura', 889.0000, 'ºC'),
	(57379, 109, '2015-02-15 00:27:26.000000', 'temperatura', 475.0000, 'ºC'),
	(57380, 109, '2015-02-15 00:27:27.000000', 'temperatura', 906.0000, 'ºC'),
	(57381, 109, '2015-02-15 00:27:28.000000', 'temperatura', 708.0000, 'ºC'),
	(57382, 109, '2015-02-15 00:27:29.000000', 'temperatura', 821.0000, 'ºC'),
	(57383, 109, '2015-02-15 00:27:30.000000', 'temperatura', 784.0000, 'ºC'),
	(57384, 109, '2015-02-15 00:27:31.000000', 'temperatura', 255.0000, 'ºC'),
	(57385, 109, '2015-02-15 00:27:32.000000', 'temperatura', 124.0000, 'ºC'),
	(57386, 109, '2015-02-15 00:27:33.000000', 'temperatura', 1053.0000, 'ºC'),
	(57387, 109, '2015-02-15 00:27:34.000000', 'temperatura', 97.0000, 'ºC'),
	(57388, 109, '2015-02-15 00:27:35.000000', 'temperatura', 927.0000, 'ºC'),
	(57389, 109, '2015-02-15 00:27:36.000000', 'temperatura', 742.0000, 'ºC'),
	(57390, 109, '2015-02-15 00:27:37.000000', 'temperatura', 929.0000, 'ºC'),
	(57391, 109, '2015-02-15 00:27:38.000000', 'temperatura', 19.0000, 'ºC'),
	(57392, 109, '2015-02-15 00:27:39.000000', 'temperatura', 908.0000, 'ºC'),
	(57393, 109, '2015-02-15 00:27:40.000000', 'temperatura', 885.0000, 'ºC'),
	(57394, 109, '2015-02-15 00:27:41.000000', 'temperatura', 500.0000, 'ºC'),
	(57395, 109, '2015-02-15 00:27:42.000000', 'temperatura', 1044.0000, 'ºC'),
	(57396, 109, '2015-02-15 00:27:43.000000', 'temperatura', 124.0000, 'ºC'),
	(57397, 109, '2015-02-15 00:27:44.000000', 'temperatura', 1087.0000, 'ºC'),
	(57398, 109, '2015-02-15 00:27:45.000000', 'temperatura', 263.0000, 'ºC'),
	(57399, 109, '2015-02-15 00:27:46.000000', 'temperatura', 456.0000, 'ºC'),
	(57400, 109, '2015-02-15 00:27:47.000000', 'temperatura', 289.0000, 'ºC'),
	(57401, 109, '2015-02-15 00:27:48.000000', 'temperatura', 79.0000, 'ºC'),
	(57402, 109, '2015-02-15 00:27:49.000000', 'temperatura', 729.0000, 'ºC'),
	(57403, 109, '2015-02-15 00:27:50.000000', 'temperatura', 1010.0000, 'ºC'),
	(57404, 109, '2015-02-15 00:27:51.000000', 'temperatura', 461.0000, 'ºC'),
	(57405, 109, '2015-02-15 00:27:52.000000', 'temperatura', 476.0000, 'ºC'),
	(57406, 109, '2015-02-15 00:27:53.000000', 'temperatura', 996.0000, 'ºC'),
	(57407, 109, '2015-02-15 00:27:54.000000', 'temperatura', 1154.0000, 'ºC'),
	(57408, 109, '2015-02-15 00:27:55.000000', 'temperatura', 384.0000, 'ºC'),
	(57409, 109, '2015-02-15 00:27:56.000000', 'temperatura', 857.0000, 'ºC'),
	(57410, 109, '2015-02-15 00:27:57.000000', 'temperatura', 734.0000, 'ºC'),
	(57411, 109, '2015-02-15 00:27:58.000000', 'temperatura', 1097.0000, 'ºC'),
	(57412, 109, '2015-02-15 00:27:59.000000', 'temperatura', 886.0000, 'ºC'),
	(57413, 109, '2015-02-15 00:28:00.000000', 'temperatura', 1140.0000, 'ºC'),
	(57414, 109, '2015-02-15 00:28:01.000000', 'temperatura', 642.0000, 'ºC'),
	(57415, 109, '2015-02-15 00:28:02.000000', 'temperatura', 989.0000, 'ºC'),
	(57416, 109, '2015-02-15 00:28:03.000000', 'temperatura', 620.0000, 'ºC'),
	(57417, 109, '2015-02-15 00:28:04.000000', 'temperatura', 132.0000, 'ºC'),
	(57418, 109, '2015-02-15 00:28:05.000000', 'temperatura', 1.0000, 'ºC'),
	(57419, 109, '2015-02-15 00:28:06.000000', 'temperatura', 809.0000, 'ºC'),
	(57420, 109, '2015-02-15 00:28:07.000000', 'temperatura', 444.0000, 'ºC'),
	(57421, 109, '2015-02-15 00:28:08.000000', 'temperatura', 993.0000, 'ºC'),
	(57422, 109, '2015-02-15 00:28:09.000000', 'temperatura', 32.0000, 'ºC'),
	(57423, 109, '2015-02-15 00:28:10.000000', 'temperatura', 781.0000, 'ºC'),
	(57424, 109, '2015-02-15 00:28:11.000000', 'temperatura', 209.0000, 'ºC'),
	(57425, 109, '2015-02-15 00:28:12.000000', 'temperatura', 1105.0000, 'ºC'),
	(57426, 109, '2015-02-15 00:28:13.000000', 'temperatura', 96.0000, 'ºC'),
	(57427, 109, '2015-02-15 00:28:14.000000', 'temperatura', 765.0000, 'ºC'),
	(57428, 109, '2015-02-15 00:28:15.000000', 'temperatura', 1139.0000, 'ºC'),
	(57429, 109, '2015-02-15 00:28:16.000000', 'temperatura', 999.0000, 'ºC'),
	(57430, 109, '2015-02-15 00:28:17.000000', 'temperatura', 378.0000, 'ºC'),
	(57431, 109, '2015-02-15 00:28:18.000000', 'temperatura', 93.0000, 'ºC'),
	(57432, 109, '2015-02-15 00:28:19.000000', 'temperatura', 534.0000, 'ºC'),
	(57433, 109, '2015-02-15 00:28:20.000000', 'temperatura', 1189.0000, 'ºC'),
	(57434, 109, '2015-02-15 00:28:21.000000', 'temperatura', 746.0000, 'ºC'),
	(57435, 109, '2015-02-15 00:28:22.000000', 'temperatura', 161.0000, 'ºC'),
	(57436, 109, '2015-02-15 00:28:23.000000', 'temperatura', 971.0000, 'ºC'),
	(57437, 109, '2015-02-15 00:28:24.000000', 'temperatura', 769.0000, 'ºC'),
	(57438, 109, '2015-02-15 00:28:25.000000', 'temperatura', 934.0000, 'ºC'),
	(57439, 109, '2015-02-15 00:28:26.000000', 'temperatura', 1164.0000, 'ºC'),
	(57440, 109, '2015-02-15 00:28:27.000000', 'temperatura', 616.0000, 'ºC'),
	(57441, 109, '2015-02-15 00:28:28.000000', 'temperatura', 791.0000, 'ºC'),
	(57442, 109, '2015-02-15 00:28:29.000000', 'temperatura', 907.0000, 'ºC'),
	(57443, 109, '2015-02-15 00:28:30.000000', 'temperatura', 962.0000, 'ºC'),
	(57444, 109, '2015-02-15 00:28:31.000000', 'temperatura', 889.0000, 'ºC'),
	(57445, 109, '2015-02-15 00:28:32.000000', 'temperatura', 358.0000, 'ºC'),
	(57446, 109, '2015-02-15 00:28:33.000000', 'temperatura', 326.0000, 'ºC'),
	(57447, 109, '2015-02-15 00:28:34.000000', 'temperatura', 555.0000, 'ºC'),
	(57448, 109, '2015-02-15 00:28:35.000000', 'temperatura', 599.0000, 'ºC'),
	(57449, 109, '2015-02-15 00:28:36.000000', 'temperatura', 132.0000, 'ºC'),
	(57450, 109, '2015-02-15 00:28:37.000000', 'temperatura', 61.0000, 'ºC'),
	(57451, 109, '2015-02-15 00:28:38.000000', 'temperatura', 1110.0000, 'ºC'),
	(57452, 109, '2015-02-15 00:28:39.000000', 'temperatura', 570.0000, 'ºC'),
	(57453, 109, '2015-02-15 00:28:40.000000', 'temperatura', 717.0000, 'ºC'),
	(57454, 109, '2015-02-15 00:28:41.000000', 'temperatura', 676.0000, 'ºC'),
	(57455, 109, '2015-02-15 00:28:42.000000', 'temperatura', 28.0000, 'ºC'),
	(57456, 109, '2015-02-15 00:28:43.000000', 'temperatura', 516.0000, 'ºC'),
	(57457, 109, '2015-02-15 00:28:44.000000', 'temperatura', 95.0000, 'ºC'),
	(57458, 109, '2015-02-15 00:28:45.000000', 'temperatura', 129.0000, 'ºC'),
	(57459, 109, '2015-02-15 00:28:46.000000', 'temperatura', 360.0000, 'ºC'),
	(57460, 109, '2015-02-15 00:28:47.000000', 'temperatura', 214.0000, 'ºC'),
	(57461, 109, '2015-02-15 00:28:48.000000', 'temperatura', 1188.0000, 'ºC'),
	(57462, 109, '2015-02-15 00:28:49.000000', 'temperatura', 500.0000, 'ºC'),
	(57463, 109, '2015-02-15 00:28:50.000000', 'temperatura', 135.0000, 'ºC'),
	(57464, 109, '2015-02-15 00:28:51.000000', 'temperatura', 377.0000, 'ºC'),
	(57465, 109, '2015-02-15 00:28:52.000000', 'temperatura', 280.0000, 'ºC'),
	(57466, 109, '2015-02-15 00:28:53.000000', 'temperatura', 270.0000, 'ºC'),
	(57467, 109, '2015-02-15 00:28:54.000000', 'temperatura', 512.0000, 'ºC'),
	(57468, 109, '2015-02-15 00:28:55.000000', 'temperatura', 548.0000, 'ºC'),
	(57469, 109, '2015-02-15 00:28:56.000000', 'temperatura', 4.0000, 'ºC'),
	(57470, 109, '2015-02-15 00:28:57.000000', 'temperatura', 780.0000, 'ºC'),
	(57471, 109, '2015-02-15 00:28:58.000000', 'temperatura', 285.0000, 'ºC'),
	(57472, 109, '2015-02-15 00:28:59.000000', 'temperatura', 287.0000, 'ºC'),
	(57473, 109, '2015-02-15 00:29:00.000000', 'temperatura', 579.0000, 'ºC'),
	(57474, 109, '2015-02-15 00:29:01.000000', 'temperatura', 837.0000, 'ºC'),
	(57475, 109, '2015-02-15 00:29:02.000000', 'temperatura', 47.0000, 'ºC'),
	(57476, 109, '2015-02-15 00:29:03.000000', 'temperatura', 124.0000, 'ºC'),
	(57477, 109, '2015-02-15 00:29:04.000000', 'temperatura', 478.0000, 'ºC'),
	(57478, 109, '2015-02-15 00:29:05.000000', 'temperatura', 822.0000, 'ºC'),
	(57479, 109, '2015-02-15 00:29:06.000000', 'temperatura', 274.0000, 'ºC'),
	(57480, 109, '2015-02-15 00:29:07.000000', 'temperatura', 104.0000, 'ºC'),
	(57481, 109, '2015-02-15 00:29:08.000000', 'temperatura', 898.0000, 'ºC'),
	(57482, 109, '2015-02-15 00:29:09.000000', 'temperatura', 580.0000, 'ºC'),
	(57483, 109, '2015-02-15 00:29:10.000000', 'temperatura', 206.0000, 'ºC'),
	(57484, 109, '2015-02-15 00:29:11.000000', 'temperatura', 490.0000, 'ºC'),
	(57485, 109, '2015-02-15 00:29:12.000000', 'temperatura', 635.0000, 'ºC'),
	(57486, 109, '2015-02-15 00:29:13.000000', 'temperatura', 503.0000, 'ºC'),
	(57487, 109, '2015-02-15 00:29:14.000000', 'temperatura', 610.0000, 'ºC'),
	(57488, 109, '2015-02-15 00:29:15.000000', 'temperatura', 343.0000, 'ºC'),
	(57489, 109, '2015-02-15 00:29:16.000000', 'temperatura', 1086.0000, 'ºC'),
	(57490, 109, '2015-02-15 00:29:17.000000', 'temperatura', 801.0000, 'ºC'),
	(57491, 109, '2015-02-15 00:29:18.000000', 'temperatura', 749.0000, 'ºC'),
	(57492, 109, '2015-02-15 00:29:19.000000', 'temperatura', 143.0000, 'ºC'),
	(57493, 109, '2015-02-15 00:29:20.000000', 'temperatura', 866.0000, 'ºC'),
	(57494, 109, '2015-02-15 00:29:21.000000', 'temperatura', 302.0000, 'ºC'),
	(57495, 109, '2015-02-15 00:29:22.000000', 'temperatura', 112.0000, 'ºC'),
	(57496, 109, '2015-02-15 00:29:23.000000', 'temperatura', 857.0000, 'ºC'),
	(57497, 109, '2015-02-15 00:29:24.000000', 'temperatura', 349.0000, 'ºC'),
	(57498, 109, '2015-02-15 00:29:25.000000', 'temperatura', 374.0000, 'ºC'),
	(57499, 109, '2015-02-15 00:29:26.000000', 'temperatura', 822.0000, 'ºC'),
	(57500, 109, '2015-02-15 00:29:27.000000', 'temperatura', 589.0000, 'ºC'),
	(57501, 109, '2015-02-15 00:29:28.000000', 'temperatura', 480.0000, 'ºC'),
	(57502, 109, '2015-02-15 00:29:29.000000', 'temperatura', 635.0000, 'ºC'),
	(57503, 109, '2015-02-15 00:29:30.000000', 'temperatura', 536.0000, 'ºC'),
	(57504, 109, '2015-02-15 00:29:31.000000', 'temperatura', 773.0000, 'ºC'),
	(57505, 109, '2015-02-15 00:29:32.000000', 'temperatura', 1057.0000, 'ºC'),
	(57506, 109, '2015-02-15 00:29:33.000000', 'temperatura', 565.0000, 'ºC'),
	(57507, 109, '2015-02-15 00:29:34.000000', 'temperatura', 858.0000, 'ºC'),
	(57508, 109, '2015-02-15 00:29:35.000000', 'temperatura', 196.0000, 'ºC'),
	(57509, 109, '2015-02-15 00:29:36.000000', 'temperatura', 803.0000, 'ºC'),
	(57510, 109, '2015-02-15 00:29:37.000000', 'temperatura', 1030.0000, 'ºC'),
	(57511, 109, '2015-02-15 00:29:38.000000', 'temperatura', 341.0000, 'ºC'),
	(57512, 109, '2015-02-15 00:29:39.000000', 'temperatura', 1014.0000, 'ºC'),
	(57513, 109, '2015-02-15 00:29:40.000000', 'temperatura', 447.0000, 'ºC'),
	(57514, 109, '2015-02-15 00:29:41.000000', 'temperatura', 396.0000, 'ºC'),
	(57515, 109, '2015-02-15 00:29:42.000000', 'temperatura', 638.0000, 'ºC'),
	(57516, 109, '2015-02-15 00:29:43.000000', 'temperatura', 804.0000, 'ºC'),
	(57517, 109, '2015-02-15 00:29:44.000000', 'temperatura', 905.0000, 'ºC'),
	(57518, 109, '2015-02-15 00:29:45.000000', 'temperatura', 914.0000, 'ºC'),
	(57519, 109, '2015-02-15 00:29:46.000000', 'temperatura', 657.0000, 'ºC'),
	(57520, 109, '2015-02-15 00:29:47.000000', 'temperatura', 544.0000, 'ºC'),
	(57521, 109, '2015-02-15 00:29:48.000000', 'temperatura', 747.0000, 'ºC'),
	(57522, 109, '2015-02-15 00:29:49.000000', 'temperatura', 904.0000, 'ºC'),
	(57523, 109, '2015-02-15 00:29:50.000000', 'temperatura', 1082.0000, 'ºC'),
	(57524, 109, '2015-02-15 00:29:51.000000', 'temperatura', 297.0000, 'ºC'),
	(57525, 109, '2015-02-15 00:29:52.000000', 'temperatura', 638.0000, 'ºC'),
	(57526, 109, '2015-02-15 00:29:53.000000', 'temperatura', 1099.0000, 'ºC'),
	(57527, 109, '2015-02-15 00:29:54.000000', 'temperatura', 1183.0000, 'ºC'),
	(57528, 109, '2015-02-15 00:29:55.000000', 'temperatura', 217.0000, 'ºC'),
	(57529, 109, '2015-02-15 00:29:56.000000', 'temperatura', 1136.0000, 'ºC'),
	(57530, 109, '2015-02-15 00:29:57.000000', 'temperatura', 229.0000, 'ºC'),
	(57531, 109, '2015-02-15 00:29:58.000000', 'temperatura', 137.0000, 'ºC'),
	(57532, 109, '2015-02-15 00:29:59.000000', 'temperatura', 1198.0000, 'ºC'),
	(57533, 109, '2015-02-15 00:30:00.000000', 'temperatura', 780.0000, 'ºC'),
	(57534, 109, '2015-02-15 00:30:01.000000', 'temperatura', 308.0000, 'ºC'),
	(57535, 109, '2015-02-15 00:30:02.000000', 'temperatura', 402.0000, 'ºC'),
	(57536, 109, '2015-02-15 00:30:03.000000', 'temperatura', 1084.0000, 'ºC'),
	(57537, 109, '2015-02-15 00:30:04.000000', 'temperatura', 616.0000, 'ºC'),
	(57538, 109, '2015-02-15 00:30:05.000000', 'temperatura', 1026.0000, 'ºC'),
	(57539, 109, '2015-02-15 00:30:06.000000', 'temperatura', 885.0000, 'ºC'),
	(57540, 109, '2015-02-15 00:30:07.000000', 'temperatura', 146.0000, 'ºC'),
	(57541, 109, '2015-02-15 00:30:08.000000', 'temperatura', 474.0000, 'ºC'),
	(57542, 109, '2015-02-15 00:30:09.000000', 'temperatura', 736.0000, 'ºC'),
	(57543, 109, '2015-02-15 00:30:10.000000', 'temperatura', 1056.0000, 'ºC'),
	(57544, 109, '2015-02-15 00:30:11.000000', 'temperatura', 672.0000, 'ºC'),
	(57545, 109, '2015-02-15 00:30:12.000000', 'temperatura', 193.0000, 'ºC'),
	(57546, 109, '2015-02-15 00:30:13.000000', 'temperatura', 151.0000, 'ºC'),
	(57547, 109, '2015-02-15 00:30:14.000000', 'temperatura', 175.0000, 'ºC'),
	(57548, 109, '2015-02-15 00:30:15.000000', 'temperatura', 424.0000, 'ºC'),
	(57549, 109, '2015-02-15 00:30:16.000000', 'temperatura', 397.0000, 'ºC'),
	(57550, 109, '2015-02-15 00:30:17.000000', 'temperatura', 711.0000, 'ºC'),
	(57551, 109, '2015-02-15 00:30:18.000000', 'temperatura', 1165.0000, 'ºC'),
	(57552, 109, '2015-02-15 00:30:19.000000', 'temperatura', 93.0000, 'ºC'),
	(57553, 109, '2015-02-15 00:30:20.000000', 'temperatura', 568.0000, 'ºC'),
	(57554, 109, '2015-02-15 00:30:21.000000', 'temperatura', 164.0000, 'ºC'),
	(57555, 109, '2015-02-15 00:30:22.000000', 'temperatura', 314.0000, 'ºC'),
	(57556, 109, '2015-02-15 00:30:23.000000', 'temperatura', 1081.0000, 'ºC'),
	(57557, 109, '2015-02-15 00:30:24.000000', 'temperatura', 863.0000, 'ºC'),
	(57558, 109, '2015-02-15 00:30:25.000000', 'temperatura', 1073.0000, 'ºC'),
	(57559, 109, '2015-02-15 00:30:26.000000', 'temperatura', 376.0000, 'ºC'),
	(57560, 109, '2015-02-15 00:30:27.000000', 'temperatura', 1062.0000, 'ºC'),
	(57561, 109, '2015-02-15 00:30:28.000000', 'temperatura', 581.0000, 'ºC'),
	(57562, 109, '2015-02-15 00:30:29.000000', 'temperatura', 920.0000, 'ºC'),
	(57563, 109, '2015-02-15 00:30:30.000000', 'temperatura', 458.0000, 'ºC'),
	(57564, 109, '2015-02-15 00:30:31.000000', 'temperatura', 728.0000, 'ºC'),
	(57565, 109, '2015-02-15 00:30:32.000000', 'temperatura', 1069.0000, 'ºC'),
	(57566, 109, '2015-02-15 00:30:33.000000', 'temperatura', 762.0000, 'ºC'),
	(57567, 109, '2015-02-15 00:30:34.000000', 'temperatura', 604.0000, 'ºC'),
	(57568, 109, '2015-02-15 00:30:35.000000', 'temperatura', 736.0000, 'ºC'),
	(57569, 109, '2015-02-15 00:30:36.000000', 'temperatura', 665.0000, 'ºC'),
	(57570, 109, '2015-02-15 00:30:37.000000', 'temperatura', 1121.0000, 'ºC'),
	(57571, 109, '2015-02-15 00:30:38.000000', 'temperatura', 7.0000, 'ºC'),
	(57572, 109, '2015-02-15 00:30:39.000000', 'temperatura', 276.0000, 'ºC'),
	(57573, 109, '2015-02-15 00:30:40.000000', 'temperatura', 157.0000, 'ºC'),
	(57574, 109, '2015-02-15 00:30:41.000000', 'temperatura', 1158.0000, 'ºC'),
	(57575, 109, '2015-02-15 00:30:42.000000', 'temperatura', 521.0000, 'ºC'),
	(57576, 109, '2015-02-15 00:30:43.000000', 'temperatura', 330.0000, 'ºC'),
	(57577, 109, '2015-02-15 00:30:44.000000', 'temperatura', 88.0000, 'ºC'),
	(57578, 109, '2015-02-15 00:30:45.000000', 'temperatura', 648.0000, 'ºC'),
	(57579, 109, '2015-02-15 00:30:46.000000', 'temperatura', 580.0000, 'ºC'),
	(57580, 109, '2015-02-15 00:30:47.000000', 'temperatura', 954.0000, 'ºC'),
	(57581, 109, '2015-02-15 00:30:48.000000', 'temperatura', 631.0000, 'ºC'),
	(57582, 109, '2015-02-15 00:30:49.000000', 'temperatura', 293.0000, 'ºC'),
	(57583, 109, '2015-02-15 00:30:50.000000', 'temperatura', 773.0000, 'ºC'),
	(57584, 109, '2015-02-15 00:30:51.000000', 'temperatura', 586.0000, 'ºC'),
	(57585, 109, '2015-02-15 00:30:52.000000', 'temperatura', 613.0000, 'ºC'),
	(57586, 109, '2015-02-15 00:30:53.000000', 'temperatura', 105.0000, 'ºC'),
	(57587, 109, '2015-02-15 00:30:54.000000', 'temperatura', 1086.0000, 'ºC'),
	(57588, 109, '2015-02-15 00:30:55.000000', 'temperatura', 317.0000, 'ºC'),
	(57589, 109, '2015-02-15 00:30:56.000000', 'temperatura', 725.0000, 'ºC'),
	(57590, 109, '2015-02-15 00:30:57.000000', 'temperatura', 277.0000, 'ºC'),
	(57591, 109, '2015-02-15 00:30:58.000000', 'temperatura', 411.0000, 'ºC'),
	(57592, 109, '2015-02-15 00:30:59.000000', 'temperatura', 22.0000, 'ºC'),
	(57593, 109, '2015-02-15 00:31:00.000000', 'temperatura', 79.0000, 'ºC'),
	(57594, 109, '2015-02-15 00:31:01.000000', 'temperatura', 330.0000, 'ºC'),
	(57595, 109, '2015-02-15 00:31:02.000000', 'temperatura', 214.0000, 'ºC'),
	(57596, 109, '2015-02-15 00:31:03.000000', 'temperatura', 81.0000, 'ºC'),
	(57597, 109, '2015-02-15 00:31:04.000000', 'temperatura', 961.0000, 'ºC'),
	(57598, 109, '2015-02-15 00:31:05.000000', 'temperatura', 963.0000, 'ºC'),
	(57599, 109, '2015-02-15 00:31:06.000000', 'temperatura', 731.0000, 'ºC'),
	(57600, 109, '2015-02-15 00:31:07.000000', 'temperatura', 770.0000, 'ºC'),
	(57601, 109, '2015-02-15 00:31:08.000000', 'temperatura', 455.0000, 'ºC'),
	(57602, 109, '2015-02-15 00:31:09.000000', 'temperatura', 1165.0000, 'ºC'),
	(57603, 109, '2015-02-15 00:31:10.000000', 'temperatura', 861.0000, 'ºC'),
	(57604, 109, '2015-02-15 00:31:11.000000', 'temperatura', 813.0000, 'ºC'),
	(57605, 109, '2015-02-15 00:31:12.000000', 'temperatura', 280.0000, 'ºC'),
	(57606, 109, '2015-02-15 00:31:13.000000', 'temperatura', 164.0000, 'ºC'),
	(57607, 109, '2015-02-15 00:31:14.000000', 'temperatura', 1177.0000, 'ºC'),
	(57608, 109, '2015-02-15 00:31:15.000000', 'temperatura', 597.0000, 'ºC'),
	(57609, 109, '2015-02-15 00:31:16.000000', 'temperatura', 652.0000, 'ºC'),
	(57610, 109, '2015-02-15 00:31:17.000000', 'temperatura', 269.0000, 'ºC'),
	(57611, 109, '2015-02-15 00:31:18.000000', 'temperatura', 591.0000, 'ºC'),
	(57612, 109, '2015-02-15 00:31:19.000000', 'temperatura', 948.0000, 'ºC'),
	(57613, 109, '2015-02-15 00:31:20.000000', 'temperatura', 569.0000, 'ºC'),
	(57614, 109, '2015-02-15 00:31:21.000000', 'temperatura', 2.0000, 'ºC'),
	(57615, 109, '2015-02-15 00:31:22.000000', 'temperatura', 701.0000, 'ºC'),
	(57616, 109, '2015-02-15 00:31:23.000000', 'temperatura', 1099.0000, 'ºC'),
	(57617, 109, '2015-02-15 00:31:24.000000', 'temperatura', 992.0000, 'ºC'),
	(57618, 109, '2015-02-15 00:31:25.000000', 'temperatura', 466.0000, 'ºC'),
	(57619, 109, '2015-02-15 00:31:26.000000', 'temperatura', 552.0000, 'ºC'),
	(57620, 109, '2015-02-15 00:31:27.000000', 'temperatura', 164.0000, 'ºC'),
	(57621, 109, '2015-02-15 00:31:28.000000', 'temperatura', 365.0000, 'ºC'),
	(57622, 109, '2015-02-15 00:31:29.000000', 'temperatura', 132.0000, 'ºC'),
	(57623, 109, '2015-02-15 00:31:30.000000', 'temperatura', 765.0000, 'ºC'),
	(57624, 109, '2015-02-15 00:31:31.000000', 'temperatura', 1030.0000, 'ºC'),
	(57625, 109, '2015-02-15 00:31:32.000000', 'temperatura', 456.0000, 'ºC'),
	(57626, 109, '2015-02-15 00:31:33.000000', 'temperatura', 391.0000, 'ºC'),
	(57627, 109, '2015-02-15 00:31:34.000000', 'temperatura', 588.0000, 'ºC'),
	(57628, 109, '2015-02-15 00:31:35.000000', 'temperatura', 565.0000, 'ºC'),
	(57629, 109, '2015-02-15 00:31:36.000000', 'temperatura', 1063.0000, 'ºC'),
	(57630, 109, '2015-02-15 00:31:37.000000', 'temperatura', 22.0000, 'ºC'),
	(57631, 109, '2015-02-15 00:31:38.000000', 'temperatura', 518.0000, 'ºC'),
	(57632, 109, '2015-02-15 00:31:39.000000', 'temperatura', 127.0000, 'ºC'),
	(57633, 109, '2015-02-15 00:31:40.000000', 'temperatura', 281.0000, 'ºC'),
	(57634, 109, '2015-02-15 00:31:41.000000', 'temperatura', 1027.0000, 'ºC'),
	(57635, 109, '2015-02-15 00:31:42.000000', 'temperatura', 689.0000, 'ºC'),
	(57636, 109, '2015-02-15 00:31:43.000000', 'temperatura', 365.0000, 'ºC'),
	(57637, 109, '2015-02-15 00:31:44.000000', 'temperatura', 958.0000, 'ºC'),
	(57638, 109, '2015-02-15 00:31:45.000000', 'temperatura', 94.0000, 'ºC'),
	(57639, 109, '2015-02-15 00:31:46.000000', 'temperatura', 0.0000, 'ºC'),
	(57640, 109, '2015-02-15 00:31:47.000000', 'temperatura', 917.0000, 'ºC'),
	(57641, 109, '2015-02-15 00:31:48.000000', 'temperatura', 986.0000, 'ºC'),
	(57642, 109, '2015-02-15 00:31:49.000000', 'temperatura', 977.0000, 'ºC'),
	(57643, 109, '2015-02-15 00:31:50.000000', 'temperatura', 730.0000, 'ºC'),
	(57644, 109, '2015-02-15 00:31:51.000000', 'temperatura', 717.0000, 'ºC'),
	(57645, 109, '2015-02-15 00:31:52.000000', 'temperatura', 199.0000, 'ºC'),
	(57646, 109, '2015-02-15 00:31:53.000000', 'temperatura', 42.0000, 'ºC'),
	(57647, 109, '2015-02-15 00:31:54.000000', 'temperatura', 815.0000, 'ºC'),
	(57648, 109, '2015-02-15 00:31:55.000000', 'temperatura', 349.0000, 'ºC'),
	(57649, 109, '2015-02-15 00:31:56.000000', 'temperatura', 498.0000, 'ºC'),
	(57650, 109, '2015-02-15 00:31:57.000000', 'temperatura', 247.0000, 'ºC'),
	(57651, 109, '2015-02-15 00:31:58.000000', 'temperatura', 938.0000, 'ºC'),
	(57652, 109, '2015-02-15 00:31:59.000000', 'temperatura', 352.0000, 'ºC'),
	(57653, 109, '2015-02-15 00:32:00.000000', 'temperatura', 146.0000, 'ºC'),
	(57654, 109, '2015-02-15 00:32:01.000000', 'temperatura', 873.0000, 'ºC'),
	(57655, 109, '2015-02-15 00:32:02.000000', 'temperatura', 327.0000, 'ºC'),
	(57656, 109, '2015-02-15 00:32:03.000000', 'temperatura', 218.0000, 'ºC'),
	(57657, 109, '2015-02-15 00:32:04.000000', 'temperatura', 110.0000, 'ºC'),
	(57658, 109, '2015-02-15 00:32:05.000000', 'temperatura', 1095.0000, 'ºC'),
	(57659, 109, '2015-02-15 00:32:06.000000', 'temperatura', 345.0000, 'ºC'),
	(57660, 109, '2015-02-15 00:32:07.000000', 'temperatura', 841.0000, 'ºC'),
	(57661, 109, '2015-02-15 00:32:08.000000', 'temperatura', 771.0000, 'ºC'),
	(57662, 109, '2015-02-15 00:32:09.000000', 'temperatura', 133.0000, 'ºC'),
	(57663, 109, '2015-02-15 00:32:10.000000', 'temperatura', 753.0000, 'ºC'),
	(57664, 109, '2015-02-15 00:32:11.000000', 'temperatura', 966.0000, 'ºC'),
	(57665, 109, '2015-02-15 00:32:12.000000', 'temperatura', 170.0000, 'ºC'),
	(57666, 109, '2015-02-15 00:32:13.000000', 'temperatura', 353.0000, 'ºC'),
	(57667, 109, '2015-02-15 00:32:14.000000', 'temperatura', 54.0000, 'ºC'),
	(57668, 109, '2015-02-15 00:32:15.000000', 'temperatura', 415.0000, 'ºC'),
	(57669, 109, '2015-02-15 00:32:16.000000', 'temperatura', 711.0000, 'ºC'),
	(57670, 109, '2015-02-15 00:32:17.000000', 'temperatura', 1113.0000, 'ºC'),
	(57671, 109, '2015-02-15 00:32:18.000000', 'temperatura', 1032.0000, 'ºC'),
	(57672, 109, '2015-02-15 00:32:19.000000', 'temperatura', 619.0000, 'ºC'),
	(57673, 109, '2015-02-15 00:32:20.000000', 'temperatura', 1.0000, 'ºC'),
	(57674, 109, '2015-02-15 00:32:21.000000', 'temperatura', 550.0000, 'ºC'),
	(57675, 109, '2015-02-15 00:32:22.000000', 'temperatura', 346.0000, 'ºC'),
	(57676, 109, '2015-02-15 00:32:23.000000', 'temperatura', 80.0000, 'ºC'),
	(57677, 109, '2015-02-15 00:32:24.000000', 'temperatura', 562.0000, 'ºC'),
	(57678, 109, '2015-02-15 00:32:25.000000', 'temperatura', 172.0000, 'ºC'),
	(57679, 109, '2015-02-15 00:32:26.000000', 'temperatura', 373.0000, 'ºC'),
	(57680, 109, '2015-02-15 00:32:27.000000', 'temperatura', 149.0000, 'ºC'),
	(57681, 109, '2015-02-15 00:32:28.000000', 'temperatura', 829.0000, 'ºC'),
	(57682, 109, '2015-02-15 00:32:29.000000', 'temperatura', 99.0000, 'ºC'),
	(57683, 109, '2015-02-15 00:32:30.000000', 'temperatura', 406.0000, 'ºC'),
	(57684, 109, '2015-02-15 00:32:31.000000', 'temperatura', 534.0000, 'ºC'),
	(57685, 109, '2015-02-15 00:32:32.000000', 'temperatura', 254.0000, 'ºC'),
	(57686, 109, '2015-02-15 00:32:33.000000', 'temperatura', 869.0000, 'ºC'),
	(57687, 109, '2015-02-15 00:32:34.000000', 'temperatura', 1183.0000, 'ºC'),
	(57688, 109, '2015-02-15 00:32:35.000000', 'temperatura', 908.0000, 'ºC'),
	(57689, 109, '2015-02-15 00:32:36.000000', 'temperatura', 994.0000, 'ºC'),
	(57690, 109, '2015-02-15 00:32:37.000000', 'temperatura', 1043.0000, 'ºC'),
	(57691, 109, '2015-02-15 00:32:38.000000', 'temperatura', 1036.0000, 'ºC'),
	(57692, 109, '2015-02-15 00:32:39.000000', 'temperatura', 851.0000, 'ºC'),
	(57693, 109, '2015-02-15 00:32:40.000000', 'temperatura', 1146.0000, 'ºC'),
	(57694, 109, '2015-02-15 00:32:41.000000', 'temperatura', 779.0000, 'ºC'),
	(57695, 109, '2015-02-15 00:32:42.000000', 'temperatura', 458.0000, 'ºC'),
	(57696, 109, '2015-02-15 00:32:43.000000', 'temperatura', 1155.0000, 'ºC'),
	(57697, 109, '2015-02-15 00:32:44.000000', 'temperatura', 798.0000, 'ºC'),
	(57698, 109, '2015-02-15 00:32:45.000000', 'temperatura', 528.0000, 'ºC'),
	(57699, 109, '2015-02-15 00:32:46.000000', 'temperatura', 248.0000, 'ºC'),
	(57700, 109, '2015-02-15 00:32:47.000000', 'temperatura', 853.0000, 'ºC'),
	(57701, 109, '2015-02-15 00:32:48.000000', 'temperatura', 1123.0000, 'ºC'),
	(57702, 109, '2015-02-15 00:32:49.000000', 'temperatura', 655.0000, 'ºC'),
	(57703, 109, '2015-02-15 00:32:50.000000', 'temperatura', 1106.0000, 'ºC'),
	(57704, 109, '2015-02-15 00:32:51.000000', 'temperatura', 1165.0000, 'ºC'),
	(57705, 109, '2015-02-15 00:32:52.000000', 'temperatura', 110.0000, 'ºC'),
	(57706, 109, '2015-02-15 00:32:53.000000', 'temperatura', 653.0000, 'ºC'),
	(57707, 109, '2015-02-15 00:32:54.000000', 'temperatura', 536.0000, 'ºC'),
	(57708, 109, '2015-02-15 00:32:55.000000', 'temperatura', 721.0000, 'ºC'),
	(57709, 109, '2015-02-15 00:32:56.000000', 'temperatura', 800.0000, 'ºC'),
	(57710, 109, '2015-02-15 00:32:57.000000', 'temperatura', 636.0000, 'ºC'),
	(57711, 109, '2015-02-15 00:32:58.000000', 'temperatura', 779.0000, 'ºC'),
	(57712, 109, '2015-02-15 00:32:59.000000', 'temperatura', 788.0000, 'ºC'),
	(57713, 109, '2015-02-15 00:33:00.000000', 'temperatura', 402.0000, 'ºC'),
	(57714, 109, '2015-02-15 00:33:01.000000', 'temperatura', 848.0000, 'ºC'),
	(57715, 109, '2015-02-15 00:33:02.000000', 'temperatura', 634.0000, 'ºC'),
	(57716, 109, '2015-02-15 00:33:03.000000', 'temperatura', 628.0000, 'ºC'),
	(57717, 109, '2015-02-15 00:33:04.000000', 'temperatura', 39.0000, 'ºC'),
	(57718, 109, '2015-02-15 00:33:05.000000', 'temperatura', 711.0000, 'ºC'),
	(57719, 109, '2015-02-15 00:33:06.000000', 'temperatura', 1038.0000, 'ºC'),
	(57720, 109, '2015-02-15 00:33:07.000000', 'temperatura', 659.0000, 'ºC'),
	(57721, 109, '2015-02-15 00:33:08.000000', 'temperatura', 179.0000, 'ºC'),
	(57722, 109, '2015-02-15 00:33:09.000000', 'temperatura', 122.0000, 'ºC'),
	(57723, 109, '2015-02-15 00:33:10.000000', 'temperatura', 70.0000, 'ºC'),
	(57724, 109, '2015-02-15 00:33:11.000000', 'temperatura', 1187.0000, 'ºC'),
	(57725, 109, '2015-02-15 00:33:12.000000', 'temperatura', 924.0000, 'ºC'),
	(57726, 109, '2015-02-15 00:33:13.000000', 'temperatura', 1062.0000, 'ºC'),
	(57727, 109, '2015-02-15 00:33:14.000000', 'temperatura', 137.0000, 'ºC'),
	(57728, 109, '2015-02-15 00:33:15.000000', 'temperatura', 1099.0000, 'ºC'),
	(57729, 109, '2015-02-15 00:33:16.000000', 'temperatura', 286.0000, 'ºC'),
	(57730, 109, '2015-02-15 00:33:17.000000', 'temperatura', 531.0000, 'ºC'),
	(57731, 109, '2015-02-15 00:33:18.000000', 'temperatura', 597.0000, 'ºC'),
	(57732, 109, '2015-02-15 00:33:19.000000', 'temperatura', 194.0000, 'ºC'),
	(57733, 109, '2015-02-15 00:33:20.000000', 'temperatura', 381.0000, 'ºC'),
	(57734, 109, '2015-02-15 00:33:21.000000', 'temperatura', 121.0000, 'ºC'),
	(57735, 109, '2015-02-15 00:33:22.000000', 'temperatura', 663.0000, 'ºC'),
	(57736, 109, '2015-02-15 00:33:23.000000', 'temperatura', 553.0000, 'ºC'),
	(57737, 109, '2015-02-15 00:33:24.000000', 'temperatura', 778.0000, 'ºC'),
	(57738, 109, '2015-02-15 00:33:25.000000', 'temperatura', 1030.0000, 'ºC'),
	(57739, 109, '2015-02-15 00:33:26.000000', 'temperatura', 417.0000, 'ºC'),
	(57740, 109, '2015-02-15 00:33:27.000000', 'temperatura', 194.0000, 'ºC'),
	(57741, 109, '2015-02-15 00:33:28.000000', 'temperatura', 921.0000, 'ºC'),
	(57742, 109, '2015-02-15 00:33:29.000000', 'temperatura', 425.0000, 'ºC'),
	(57743, 109, '2015-02-15 00:33:30.000000', 'temperatura', 561.0000, 'ºC'),
	(57744, 109, '2015-02-15 00:33:31.000000', 'temperatura', 329.0000, 'ºC'),
	(57745, 109, '2015-02-15 00:33:32.000000', 'temperatura', 1163.0000, 'ºC'),
	(57746, 109, '2015-02-15 00:33:33.000000', 'temperatura', 28.0000, 'ºC'),
	(57747, 109, '2015-02-15 00:33:34.000000', 'temperatura', 250.0000, 'ºC'),
	(57748, 109, '2015-02-15 00:33:35.000000', 'temperatura', 1169.0000, 'ºC'),
	(57749, 109, '2015-02-15 00:33:36.000000', 'temperatura', 295.0000, 'ºC'),
	(57750, 109, '2015-02-15 00:33:37.000000', 'temperatura', 369.0000, 'ºC'),
	(57751, 109, '2015-02-15 00:33:38.000000', 'temperatura', 959.0000, 'ºC'),
	(57752, 109, '2015-02-15 00:33:39.000000', 'temperatura', 91.0000, 'ºC'),
	(57753, 109, '2015-02-15 00:33:40.000000', 'temperatura', 1179.0000, 'ºC'),
	(57754, 109, '2015-02-15 00:33:41.000000', 'temperatura', 821.0000, 'ºC'),
	(57755, 109, '2015-02-15 00:33:42.000000', 'temperatura', 569.0000, 'ºC'),
	(57756, 109, '2015-02-15 00:33:43.000000', 'temperatura', 381.0000, 'ºC'),
	(57757, 109, '2015-02-15 00:33:44.000000', 'temperatura', 201.0000, 'ºC'),
	(57758, 109, '2015-02-15 00:33:45.000000', 'temperatura', 1061.0000, 'ºC'),
	(57759, 109, '2015-02-15 00:33:46.000000', 'temperatura', 1102.0000, 'ºC'),
	(57760, 109, '2015-02-15 00:33:47.000000', 'temperatura', 1130.0000, 'ºC'),
	(57761, 109, '2015-02-15 00:33:48.000000', 'temperatura', 1141.0000, 'ºC'),
	(57762, 109, '2015-02-15 00:33:49.000000', 'temperatura', 1118.0000, 'ºC'),
	(57763, 109, '2015-02-15 00:33:50.000000', 'temperatura', 969.0000, 'ºC'),
	(57764, 109, '2015-02-15 00:33:51.000000', 'temperatura', 289.0000, 'ºC'),
	(57765, 109, '2015-02-15 00:33:52.000000', 'temperatura', 941.0000, 'ºC'),
	(57766, 109, '2015-02-15 00:33:53.000000', 'temperatura', 236.0000, 'ºC'),
	(57767, 109, '2015-02-15 00:33:54.000000', 'temperatura', 758.0000, 'ºC'),
	(57768, 109, '2015-02-15 00:33:55.000000', 'temperatura', 683.0000, 'ºC'),
	(57769, 109, '2015-02-15 00:33:56.000000', 'temperatura', 1143.0000, 'ºC'),
	(57770, 109, '2015-02-15 00:33:57.000000', 'temperatura', 67.0000, 'ºC'),
	(57771, 109, '2015-02-15 00:33:58.000000', 'temperatura', 507.0000, 'ºC'),
	(57772, 109, '2015-02-15 00:33:59.000000', 'temperatura', 1133.0000, 'ºC'),
	(57773, 109, '2015-02-15 00:34:00.000000', 'temperatura', 543.0000, 'ºC'),
	(57774, 109, '2015-02-15 00:34:01.000000', 'temperatura', 518.0000, 'ºC'),
	(57775, 109, '2015-02-15 00:34:02.000000', 'temperatura', 961.0000, 'ºC'),
	(57776, 109, '2015-02-15 00:34:03.000000', 'temperatura', 852.0000, 'ºC'),
	(57777, 109, '2015-02-15 00:34:04.000000', 'temperatura', 176.0000, 'ºC'),
	(57778, 109, '2015-02-15 00:34:05.000000', 'temperatura', 727.0000, 'ºC'),
	(57779, 109, '2015-02-15 00:34:06.000000', 'temperatura', 705.0000, 'ºC'),
	(57780, 109, '2015-02-15 00:34:07.000000', 'temperatura', 143.0000, 'ºC'),
	(57781, 109, '2015-02-15 00:34:08.000000', 'temperatura', 1004.0000, 'ºC'),
	(57782, 109, '2015-02-15 00:34:09.000000', 'temperatura', 989.0000, 'ºC'),
	(57783, 109, '2015-02-15 00:34:10.000000', 'temperatura', 734.0000, 'ºC'),
	(57784, 109, '2015-02-15 00:34:11.000000', 'temperatura', 703.0000, 'ºC'),
	(57785, 109, '2015-02-15 00:34:12.000000', 'temperatura', 112.0000, 'ºC'),
	(57786, 109, '2015-02-15 00:34:13.000000', 'temperatura', 854.0000, 'ºC'),
	(57787, 109, '2015-02-15 00:34:14.000000', 'temperatura', 334.0000, 'ºC'),
	(57788, 109, '2015-02-15 00:34:15.000000', 'temperatura', 309.0000, 'ºC'),
	(57789, 109, '2015-02-15 00:34:16.000000', 'temperatura', 545.0000, 'ºC'),
	(57790, 109, '2015-02-15 00:34:17.000000', 'temperatura', 596.0000, 'ºC'),
	(57791, 109, '2015-02-15 00:34:18.000000', 'temperatura', 144.0000, 'ºC'),
	(57792, 109, '2015-02-15 00:34:19.000000', 'temperatura', 136.0000, 'ºC'),
	(57793, 109, '2015-02-15 00:34:20.000000', 'temperatura', 247.0000, 'ºC'),
	(57794, 109, '2015-02-15 00:34:21.000000', 'temperatura', 827.0000, 'ºC'),
	(57795, 109, '2015-02-15 00:34:22.000000', 'temperatura', 996.0000, 'ºC'),
	(57796, 109, '2015-02-15 00:34:23.000000', 'temperatura', 97.0000, 'ºC'),
	(57797, 109, '2015-02-15 00:34:24.000000', 'temperatura', 1099.0000, 'ºC'),
	(57798, 109, '2015-02-15 00:34:25.000000', 'temperatura', 405.0000, 'ºC'),
	(57799, 109, '2015-02-15 00:34:26.000000', 'temperatura', 1130.0000, 'ºC'),
	(57800, 109, '2015-02-15 00:34:27.000000', 'temperatura', 834.0000, 'ºC'),
	(57801, 109, '2015-02-15 00:34:28.000000', 'temperatura', 780.0000, 'ºC'),
	(57802, 109, '2015-02-15 00:34:29.000000', 'temperatura', 201.0000, 'ºC'),
	(57803, 109, '2015-02-15 00:34:30.000000', 'temperatura', 1062.0000, 'ºC'),
	(57804, 109, '2015-02-15 00:34:31.000000', 'temperatura', 1111.0000, 'ºC'),
	(57805, 109, '2015-02-15 00:34:32.000000', 'temperatura', 1168.0000, 'ºC'),
	(57806, 109, '2015-02-15 00:34:33.000000', 'temperatura', 106.0000, 'ºC'),
	(57807, 109, '2015-02-15 00:34:34.000000', 'temperatura', 626.0000, 'ºC'),
	(57808, 109, '2015-02-15 00:34:35.000000', 'temperatura', 413.0000, 'ºC'),
	(57809, 109, '2015-02-15 00:34:36.000000', 'temperatura', 188.0000, 'ºC'),
	(57810, 109, '2015-02-15 00:34:37.000000', 'temperatura', 901.0000, 'ºC'),
	(57811, 109, '2015-02-15 00:34:38.000000', 'temperatura', 343.0000, 'ºC'),
	(57812, 109, '2015-02-15 00:34:39.000000', 'temperatura', 211.0000, 'ºC'),
	(57813, 109, '2015-02-15 00:34:40.000000', 'temperatura', 27.0000, 'ºC'),
	(57814, 109, '2015-02-15 00:34:41.000000', 'temperatura', 703.0000, 'ºC'),
	(57815, 109, '2015-02-15 00:34:42.000000', 'temperatura', 1033.0000, 'ºC'),
	(57816, 109, '2015-02-15 00:34:43.000000', 'temperatura', 659.0000, 'ºC'),
	(57817, 109, '2015-02-15 00:34:44.000000', 'temperatura', 195.0000, 'ºC'),
	(57818, 109, '2015-02-15 00:34:45.000000', 'temperatura', 200.0000, 'ºC'),
	(57819, 109, '2015-02-15 00:34:46.000000', 'temperatura', 414.0000, 'ºC'),
	(57820, 109, '2015-02-15 00:34:47.000000', 'temperatura', 273.0000, 'ºC'),
	(57821, 109, '2015-02-15 00:34:48.000000', 'temperatura', 122.0000, 'ºC'),
	(57822, 109, '2015-02-15 00:34:49.000000', 'temperatura', 992.0000, 'ºC'),
	(57823, 109, '2015-02-15 00:34:50.000000', 'temperatura', 994.0000, 'ºC'),
	(57824, 109, '2015-02-15 00:34:51.000000', 'temperatura', 796.0000, 'ºC'),
	(57825, 109, '2015-02-15 00:34:52.000000', 'temperatura', 998.0000, 'ºC'),
	(57826, 109, '2015-02-15 00:34:53.000000', 'temperatura', 202.0000, 'ºC'),
	(57827, 109, '2015-02-15 00:34:54.000000', 'temperatura', 417.0000, 'ºC'),
	(57828, 109, '2015-02-15 00:34:55.000000', 'temperatura', 279.0000, 'ºC'),
	(57829, 109, '2015-02-15 00:34:56.000000', 'temperatura', 143.0000, 'ºC'),
	(57830, 109, '2015-02-15 00:34:57.000000', 'temperatura', 1079.0000, 'ºC'),
	(57831, 109, '2015-02-15 00:34:58.000000', 'temperatura', 165.0000, 'ºC'),
	(57832, 109, '2015-02-15 00:34:59.000000', 'temperatura', 1190.0000, 'ºC'),
	(57833, 109, '2015-02-15 00:35:00.000000', 'temperatura', 656.0000, 'ºC'),
	(57834, 109, '2015-02-15 00:35:01.000000', 'temperatura', 910.0000, 'ºC'),
	(57835, 109, '2015-02-15 00:35:02.000000', 'temperatura', 184.0000, 'ºC'),
	(57836, 109, '2015-02-15 00:35:03.000000', 'temperatura', 588.0000, 'ºC'),
	(57837, 109, '2015-02-15 00:35:04.000000', 'temperatura', 1189.0000, 'ºC'),
	(57838, 109, '2015-02-15 00:35:05.000000', 'temperatura', 580.0000, 'ºC'),
	(57839, 109, '2015-02-15 00:35:06.000000', 'temperatura', 535.0000, 'ºC'),
	(57840, 109, '2015-02-15 00:35:07.000000', 'temperatura', 934.0000, 'ºC'),
	(57841, 109, '2015-02-15 00:35:08.000000', 'temperatura', 664.0000, 'ºC'),
	(57842, 109, '2015-02-15 00:35:09.000000', 'temperatura', 522.0000, 'ºC'),
	(57843, 109, '2015-02-15 00:35:10.000000', 'temperatura', 616.0000, 'ºC'),
	(57844, 109, '2015-02-15 00:35:11.000000', 'temperatura', 317.0000, 'ºC'),
	(57845, 109, '2015-02-15 00:35:12.000000', 'temperatura', 934.0000, 'ºC'),
	(57846, 109, '2015-02-15 00:35:13.000000', 'temperatura', 122.0000, 'ºC'),
	(57847, 109, '2015-02-15 00:35:14.000000', 'temperatura', 208.0000, 'ºC'),
	(57848, 109, '2015-02-15 00:35:15.000000', 'temperatura', 676.0000, 'ºC'),
	(57849, 109, '2015-02-15 00:35:16.000000', 'temperatura', 356.0000, 'ºC'),
	(57850, 109, '2015-02-15 00:35:17.000000', 'temperatura', 952.0000, 'ºC'),
	(57851, 109, '2015-02-15 00:35:18.000000', 'temperatura', 91.0000, 'ºC'),
	(57852, 109, '2015-02-15 00:35:19.000000', 'temperatura', 0.0000, 'ºC'),
	(57853, 109, '2015-02-15 00:35:20.000000', 'temperatura', 928.0000, 'ºC'),
	(57854, 109, '2015-02-15 00:35:21.000000', 'temperatura', 1039.0000, 'ºC'),
	(57855, 109, '2015-02-15 00:35:22.000000', 'temperatura', 12.0000, 'ºC'),
	(57856, 109, '2015-02-15 00:35:23.000000', 'temperatura', 544.0000, 'ºC'),
	(57857, 109, '2015-02-15 00:35:24.000000', 'temperatura', 285.0000, 'ºC'),
	(57858, 109, '2015-02-15 00:35:25.000000', 'temperatura', 993.0000, 'ºC'),
	(57859, 109, '2015-02-15 00:35:26.000000', 'temperatura', 512.0000, 'ºC'),
	(57860, 109, '2015-02-15 00:35:27.000000', 'temperatura', 779.0000, 'ºC'),
	(57861, 109, '2015-02-15 00:35:28.000000', 'temperatura', 1162.0000, 'ºC'),
	(57862, 109, '2015-02-15 00:35:29.000000', 'temperatura', 1072.0000, 'ºC'),
	(57863, 109, '2015-02-15 00:35:30.000000', 'temperatura', 676.0000, 'ºC'),
	(57864, 109, '2015-02-15 00:35:31.000000', 'temperatura', 163.0000, 'ºC'),
	(57865, 109, '2015-02-15 00:35:32.000000', 'temperatura', 1187.0000, 'ºC'),
	(57866, 109, '2015-02-15 00:35:33.000000', 'temperatura', 647.0000, 'ºC'),
	(57867, 109, '2015-02-15 00:35:34.000000', 'temperatura', 873.0000, 'ºC'),
	(57868, 109, '2015-02-15 00:35:35.000000', 'temperatura', 24.0000, 'ºC'),
	(57869, 109, '2015-02-15 00:35:36.000000', 'temperatura', 1103.0000, 'ºC'),
	(57870, 109, '2015-02-15 00:35:37.000000', 'temperatura', 642.0000, 'ºC'),
	(57871, 109, '2015-02-15 00:35:38.000000', 'temperatura', 1104.0000, 'ºC'),
	(57872, 109, '2015-02-15 00:35:39.000000', 'temperatura', 1192.0000, 'ºC'),
	(57873, 109, '2015-02-15 00:35:40.000000', 'temperatura', 250.0000, 'ºC'),
	(57874, 109, '2015-02-15 00:35:41.000000', 'temperatura', 73.0000, 'ºC'),
	(57875, 109, '2015-02-15 00:35:42.000000', 'temperatura', 818.0000, 'ºC'),
	(57876, 109, '2015-02-15 00:35:43.000000', 'temperatura', 268.0000, 'ºC'),
	(57877, 109, '2015-02-15 00:35:44.000000', 'temperatura', 90.0000, 'ºC'),
	(57878, 109, '2015-02-15 00:35:45.000000', 'temperatura', 845.0000, 'ºC'),
	(57879, 109, '2015-02-15 00:35:46.000000', 'temperatura', 356.0000, 'ºC'),
	(57880, 109, '2015-02-15 00:35:47.000000', 'temperatura', 446.0000, 'ºC'),
	(57881, 109, '2015-02-15 00:35:48.000000', 'temperatura', 1161.0000, 'ºC'),
	(57882, 109, '2015-02-15 00:35:49.000000', 'temperatura', 870.0000, 'ºC'),
	(57883, 109, '2015-02-15 00:35:50.000000', 'temperatura', 866.0000, 'ºC'),
	(57884, 109, '2015-02-15 00:35:51.000000', 'temperatura', 520.0000, 'ºC'),
	(57885, 109, '2015-02-15 00:35:52.000000', 'temperatura', 5.0000, 'ºC'),
	(57886, 109, '2015-02-15 00:35:53.000000', 'temperatura', 862.0000, 'ºC'),
	(57887, 109, '2015-02-15 00:35:54.000000', 'temperatura', 697.0000, 'ºC'),
	(57888, 109, '2015-02-15 00:35:55.000000', 'temperatura', 899.0000, 'ºC'),
	(57889, 109, '2015-02-15 00:35:56.000000', 'temperatura', 6.0000, 'ºC'),
	(57890, 109, '2015-02-15 00:35:57.000000', 'temperatura', 932.0000, 'ºC'),
	(57891, 109, '2015-02-15 00:35:58.000000', 'temperatura', 1044.0000, 'ºC'),
	(57892, 109, '2015-02-15 00:35:59.000000', 'temperatura', 23.0000, 'ºC'),
	(57893, 109, '2015-02-15 00:36:00.000000', 'temperatura', 585.0000, 'ºC'),
	(57894, 109, '2015-02-15 00:36:01.000000', 'temperatura', 455.0000, 'ºC'),
	(57895, 109, '2015-02-15 00:36:02.000000', 'temperatura', 520.0000, 'ºC'),
	(57896, 109, '2015-02-15 00:36:03.000000', 'temperatura', 36.0000, 'ºC'),
	(57897, 109, '2015-02-15 00:36:04.000000', 'temperatura', 1022.0000, 'ºC'),
	(57898, 109, '2015-02-15 00:36:05.000000', 'temperatura', 201.0000, 'ºC'),
	(57899, 109, '2015-02-15 00:36:06.000000', 'temperatura', 341.0000, 'ºC'),
	(57900, 109, '2015-02-15 00:36:07.000000', 'temperatura', 1102.0000, 'ºC'),
	(57901, 109, '2015-02-15 00:36:08.000000', 'temperatura', 887.0000, 'ºC'),
	(57902, 109, '2015-02-15 00:36:09.000000', 'temperatura', 1128.0000, 'ºC'),
	(57903, 109, '2015-02-15 00:36:10.000000', 'temperatura', 581.0000, 'ºC'),
	(57904, 109, '2015-02-15 00:36:11.000000', 'temperatura', 720.0000, 'ºC'),
	(57905, 109, '2015-02-15 00:36:12.000000', 'temperatura', 656.0000, 'ºC'),
	(57906, 109, '2015-02-15 00:36:13.000000', 'temperatura', 1124.0000, 'ºC'),
	(57907, 109, '2015-02-15 00:36:14.000000', 'temperatura', 51.0000, 'ºC'),
	(57908, 109, '2015-02-15 00:36:15.000000', 'temperatura', 482.0000, 'ºC'),
	(57909, 109, '2015-02-15 00:36:16.000000', 'temperatura', 1059.0000, 'ºC'),
	(57910, 109, '2015-02-15 00:36:17.000000', 'temperatura', 251.0000, 'ºC'),
	(57911, 109, '2015-02-15 00:36:18.000000', 'temperatura', 477.0000, 'ºC'),
	(57912, 109, '2015-02-15 00:36:19.000000', 'temperatura', 432.0000, 'ºC'),
	(57913, 109, '2015-02-15 00:36:20.000000', 'temperatura', 732.0000, 'ºC'),
	(57914, 109, '2015-02-15 00:36:21.000000', 'temperatura', 1161.0000, 'ºC'),
	(57915, 109, '2015-02-15 00:36:22.000000', 'temperatura', 12.0000, 'ºC'),
	(57916, 109, '2015-02-15 00:36:23.000000', 'temperatura', 176.0000, 'ºC'),
	(57917, 109, '2015-02-15 00:36:24.000000', 'temperatura', 847.0000, 'ºC'),
	(57918, 109, '2015-02-15 00:36:25.000000', 'temperatura', 105.0000, 'ºC'),
	(57919, 109, '2015-02-15 00:36:26.000000', 'temperatura', 384.0000, 'ºC'),
	(57920, 109, '2015-02-15 00:36:27.000000', 'temperatura', 408.0000, 'ºC'),
	(57921, 109, '2015-02-15 00:36:28.000000', 'temperatura', 888.0000, 'ºC'),
	(57922, 109, '2015-02-15 00:36:29.000000', 'temperatura', 815.0000, 'ºC'),
	(57923, 109, '2015-02-15 00:36:30.000000', 'temperatura', 212.0000, 'ºC'),
	(57924, 109, '2015-02-15 00:36:31.000000', 'temperatura', 1017.0000, 'ºC'),
	(57925, 109, '2015-02-15 00:36:32.000000', 'temperatura', 850.0000, 'ºC'),
	(57926, 109, '2015-02-15 00:36:33.000000', 'temperatura', 1198.0000, 'ºC'),
	(57927, 109, '2015-02-15 00:36:34.000000', 'temperatura', 1043.0000, 'ºC'),
	(57928, 109, '2015-02-15 00:36:35.000000', 'temperatura', 419.0000, 'ºC'),
	(57929, 109, '2015-02-15 00:36:36.000000', 'temperatura', 166.0000, 'ºC'),
	(57930, 109, '2015-02-15 00:36:37.000000', 'temperatura', 775.0000, 'ºC'),
	(57931, 109, '2015-02-15 00:36:38.000000', 'temperatura', 978.0000, 'ºC'),
	(57932, 109, '2015-02-15 00:36:39.000000', 'temperatura', 165.0000, 'ºC'),
	(57933, 109, '2015-02-15 00:36:40.000000', 'temperatura', 293.0000, 'ºC'),
	(57934, 109, '2015-02-15 00:36:41.000000', 'temperatura', 971.0000, 'ºC'),
	(57935, 109, '2015-02-15 00:36:42.000000', 'temperatura', 373.0000, 'ºC'),
	(57936, 109, '2015-02-15 00:36:43.000000', 'temperatura', 155.0000, 'ºC'),
	(57937, 109, '2015-02-15 00:36:44.000000', 'temperatura', 858.0000, 'ºC'),
	(57938, 109, '2015-02-15 00:36:45.000000', 'temperatura', 223.0000, 'ºC'),
	(57939, 109, '2015-02-15 00:36:46.000000', 'temperatura', 943.0000, 'ºC'),
	(57940, 109, '2015-02-15 00:36:47.000000', 'temperatura', 445.0000, 'ºC'),
	(57941, 109, '2015-02-15 00:36:48.000000', 'temperatura', 595.0000, 'ºC'),
	(57942, 109, '2015-02-15 00:36:49.000000', 'temperatura', 442.0000, 'ºC'),
	(57943, 109, '2015-02-15 00:36:50.000000', 'temperatura', 426.0000, 'ºC'),
	(57944, 109, '2015-02-15 00:36:51.000000', 'temperatura', 806.0000, 'ºC'),
	(57945, 109, '2015-02-15 00:36:52.000000', 'temperatura', 351.0000, 'ºC'),
	(57946, 109, '2015-02-15 00:36:53.000000', 'temperatura', 536.0000, 'ºC'),
	(57947, 109, '2015-02-15 00:36:54.000000', 'temperatura', 428.0000, 'ºC'),
	(57948, 109, '2015-02-15 00:36:55.000000', 'temperatura', 531.0000, 'ºC'),
	(57949, 109, '2015-02-15 00:36:56.000000', 'temperatura', 174.0000, 'ºC'),
	(57950, 109, '2015-02-15 00:36:57.000000', 'temperatura', 479.0000, 'ºC'),
	(57951, 109, '2015-02-15 00:36:58.000000', 'temperatura', 670.0000, 'ºC'),
	(57952, 109, '2015-02-15 00:36:59.000000', 'temperatura', 717.0000, 'ºC'),
	(57953, 109, '2015-02-15 00:37:00.000000', 'temperatura', 372.0000, 'ºC'),
	(57954, 109, '2015-02-15 00:37:01.000000', 'temperatura', 912.0000, 'ºC'),
	(57955, 109, '2015-02-15 00:37:02.000000', 'temperatura', 1045.0000, 'ºC'),
	(57956, 109, '2015-02-15 00:37:03.000000', 'temperatura', 90.0000, 'ºC'),
	(57957, 109, '2015-02-15 00:37:04.000000', 'temperatura', 914.0000, 'ºC'),
	(57958, 109, '2015-02-15 00:37:05.000000', 'temperatura', 700.0000, 'ºC'),
	(57959, 109, '2015-02-15 00:37:06.000000', 'temperatura', 760.0000, 'ºC'),
	(57960, 109, '2015-02-15 00:37:07.000000', 'temperatura', 501.0000, 'ºC'),
	(57961, 109, '2015-02-15 00:37:08.000000', 'temperatura', 226.0000, 'ºC'),
	(57962, 109, '2015-02-15 00:37:09.000000', 'temperatura', 827.0000, 'ºC'),
	(57963, 109, '2015-02-15 00:37:10.000000', 'temperatura', 1057.0000, 'ºC'),
	(57964, 109, '2015-02-15 00:37:11.000000', 'temperatura', 404.0000, 'ºC'),
	(57965, 109, '2015-02-15 00:37:12.000000', 'temperatura', 50.0000, 'ºC'),
	(57966, 109, '2015-02-15 00:37:13.000000', 'temperatura', 239.0000, 'ºC'),
	(57967, 109, '2015-02-15 00:37:14.000000', 'temperatura', 1043.0000, 'ºC'),
	(57968, 109, '2015-02-15 00:37:15.000000', 'temperatura', 902.0000, 'ºC'),
	(57969, 109, '2015-02-15 00:37:16.000000', 'temperatura', 178.0000, 'ºC'),
	(57970, 109, '2015-02-15 00:37:17.000000', 'temperatura', 587.0000, 'ºC'),
	(57971, 109, '2015-02-15 00:37:18.000000', 'temperatura', 3.0000, 'ºC'),
	(57972, 109, '2015-02-15 00:37:19.000000', 'temperatura', 652.0000, 'ºC'),
	(57973, 109, '2015-02-15 00:37:20.000000', 'temperatura', 854.0000, 'ºC'),
	(57974, 109, '2015-02-15 00:37:21.000000', 'temperatura', 1111.0000, 'ºC'),
	(57975, 109, '2015-02-15 00:37:22.000000', 'temperatura', 596.0000, 'ºC'),
	(57976, 109, '2015-02-15 00:37:23.000000', 'temperatura', 849.0000, 'ºC'),
	(57977, 109, '2015-02-15 00:37:24.000000', 'temperatura', 56.0000, 'ºC'),
	(57978, 109, '2015-02-15 00:37:25.000000', 'temperatura', 133.0000, 'ºC'),
	(57979, 109, '2015-02-15 00:37:26.000000', 'temperatura', 498.0000, 'ºC'),
	(57980, 109, '2015-02-15 00:37:27.000000', 'temperatura', 891.0000, 'ºC'),
	(57981, 109, '2015-02-15 00:37:28.000000', 'temperatura', 560.0000, 'ºC'),
	(57982, 109, '2015-02-15 00:37:29.000000', 'temperatura', 129.0000, 'ºC'),
	(57983, 109, '2015-02-15 00:37:30.000000', 'temperatura', 167.0000, 'ºC'),
	(57984, 109, '2015-02-15 00:37:31.000000', 'temperatura', 449.0000, 'ºC'),
	(57985, 109, '2015-02-15 00:37:32.000000', 'temperatura', 545.0000, 'ºC'),
	(57986, 109, '2015-02-15 00:37:33.000000', 'temperatura', 176.0000, 'ºC'),
	(57987, 109, '2015-02-15 00:37:34.000000', 'temperatura', 446.0000, 'ºC'),
	(57988, 109, '2015-02-15 00:37:35.000000', 'temperatura', 503.0000, 'ºC'),
	(57989, 109, '2015-02-15 00:37:36.000000', 'temperatura', 1178.0000, 'ºC'),
	(57990, 109, '2015-02-15 00:37:37.000000', 'temperatura', 782.0000, 'ºC'),
	(57991, 109, '2015-02-15 00:37:38.000000', 'temperatura', 376.0000, 'ºC'),
	(57992, 109, '2015-02-15 00:37:39.000000', 'temperatura', 734.0000, 'ºC'),
	(57993, 109, '2015-02-15 00:37:40.000000', 'temperatura', 143.0000, 'ºC'),
	(57994, 109, '2015-02-15 00:37:41.000000', 'temperatura', 915.0000, 'ºC'),
	(57995, 109, '2015-02-15 00:37:42.000000', 'temperatura', 546.0000, 'ºC'),
	(57996, 109, '2015-02-15 00:37:43.000000', 'temperatura', 1187.0000, 'ºC'),
	(57997, 109, '2015-02-15 00:37:44.000000', 'temperatura', 694.0000, 'ºC'),
	(57998, 109, '2015-02-15 00:37:45.000000', 'temperatura', 1112.0000, 'ºC'),
	(57999, 109, '2015-02-15 00:37:46.000000', 'temperatura', 1077.0000, 'ºC'),
	(58000, 109, '2015-02-15 00:37:47.000000', 'temperatura', 848.0000, 'ºC'),
	(58001, 109, '2015-02-15 00:37:48.000000', 'temperatura', 1011.0000, 'ºC'),
	(58002, 109, '2015-02-15 00:37:49.000000', 'temperatura', 110.0000, 'ºC'),
	(58003, 109, '2015-02-15 00:37:50.000000', 'temperatura', 1119.0000, 'ºC'),
	(58004, 109, '2015-02-15 00:37:51.000000', 'temperatura', 465.0000, 'ºC'),
	(58005, 109, '2015-02-15 00:37:52.000000', 'temperatura', 168.0000, 'ºC'),
	(58006, 109, '2015-02-15 00:37:53.000000', 'temperatura', 644.0000, 'ºC'),
	(58007, 109, '2015-02-15 00:37:54.000000', 'temperatura', 317.0000, 'ºC'),
	(58008, 109, '2015-02-15 00:37:55.000000', 'temperatura', 856.0000, 'ºC'),
	(58009, 109, '2015-02-15 00:37:56.000000', 'temperatura', 927.0000, 'ºC'),
	(58010, 109, '2015-02-15 00:37:57.000000', 'temperatura', 870.0000, 'ºC'),
	(58011, 109, '2015-02-15 00:37:58.000000', 'temperatura', 368.0000, 'ºC'),
	(58012, 109, '2015-02-15 00:37:59.000000', 'temperatura', 432.0000, 'ºC'),
	(58013, 109, '2015-02-15 00:38:00.000000', 'temperatura', 1054.0000, 'ºC'),
	(58014, 109, '2015-02-15 00:38:01.000000', 'temperatura', 374.0000, 'ºC'),
	(58015, 109, '2015-02-15 00:38:02.000000', 'temperatura', 1112.0000, 'ºC'),
	(58016, 109, '2015-02-15 00:38:03.000000', 'temperatura', 835.0000, 'ºC'),
	(58017, 109, '2015-02-15 00:38:04.000000', 'temperatura', 841.0000, 'ºC'),
	(58018, 109, '2015-02-15 00:38:05.000000', 'temperatura', 499.0000, 'ºC'),
	(58019, 109, '2015-02-15 00:38:06.000000', 'temperatura', 1175.0000, 'ºC'),
	(58020, 109, '2015-02-15 00:38:07.000000', 'temperatura', 778.0000, 'ºC'),
	(58021, 109, '2015-02-15 00:38:08.000000', 'temperatura', 366.0000, 'ºC'),
	(58022, 109, '2015-02-15 00:38:09.000000', 'temperatura', 694.0000, 'ºC'),
	(58023, 109, '2015-02-15 00:38:10.000000', 'temperatura', 1173.0000, 'ºC'),
	(58024, 109, '2015-02-15 00:38:11.000000', 'temperatura', 186.0000, 'ºC'),
	(58025, 109, '2015-02-15 00:38:12.000000', 'temperatura', 1010.0000, 'ºC'),
	(58026, 109, '2015-02-15 00:38:13.000000', 'temperatura', 891.0000, 'ºC'),
	(58027, 109, '2015-02-15 00:38:14.000000', 'temperatura', 225.0000, 'ºC'),
	(58028, 109, '2015-02-15 00:38:15.000000', 'temperatura', 853.0000, 'ºC'),
	(58029, 109, '2015-02-15 00:38:16.000000', 'temperatura', 1190.0000, 'ºC'),
	(58030, 109, '2015-02-15 00:38:17.000000', 'temperatura', 991.0000, 'ºC'),
	(58031, 109, '2015-02-15 00:38:18.000000', 'temperatura', 187.0000, 'ºC'),
	(58032, 109, '2015-02-15 00:38:19.000000', 'temperatura', 364.0000, 'ºC'),
	(58033, 109, '2015-02-15 00:38:20.000000', 'temperatura', 58.0000, 'ºC'),
	(58034, 109, '2015-02-15 00:38:21.000000', 'temperatura', 398.0000, 'ºC'),
	(58035, 109, '2015-02-15 00:38:22.000000', 'temperatura', 618.0000, 'ºC'),
	(58036, 109, '2015-02-15 00:38:23.000000', 'temperatura', 694.0000, 'ºC'),
	(58037, 109, '2015-02-15 00:38:24.000000', 'temperatura', 417.0000, 'ºC'),
	(58038, 109, '2015-02-15 00:38:25.000000', 'temperatura', 2.0000, 'ºC'),
	(58039, 109, '2015-02-15 00:38:26.000000', 'temperatura', 1162.0000, 'ºC'),
	(58040, 109, '2015-02-15 00:38:27.000000', 'temperatura', 1004.0000, 'ºC'),
	(58041, 109, '2015-02-15 00:38:28.000000', 'temperatura', 336.0000, 'ºC'),
	(58042, 109, '2015-02-15 00:38:29.000000', 'temperatura', 1066.0000, 'ºC'),
	(58043, 109, '2015-02-15 00:38:30.000000', 'temperatura', 725.0000, 'ºC'),
	(58044, 109, '2015-02-15 00:38:31.000000', 'temperatura', 428.0000, 'ºC'),
	(58045, 109, '2015-02-15 00:38:32.000000', 'temperatura', 1163.0000, 'ºC'),
	(58046, 109, '2015-02-15 00:38:33.000000', 'temperatura', 935.0000, 'ºC'),
	(58047, 109, '2015-02-15 00:38:34.000000', 'temperatura', 1183.0000, 'ºC'),
	(58048, 109, '2015-02-15 00:38:35.000000', 'temperatura', 710.0000, 'ºC'),
	(58049, 109, '2015-02-15 00:38:36.000000', 'temperatura', 3.0000, 'ºC'),
	(58050, 109, '2015-02-15 00:38:37.000000', 'temperatura', 284.0000, 'ºC'),
	(58051, 109, '2015-02-15 00:38:38.000000', 'temperatura', 211.0000, 'ºC'),
	(58052, 109, '2015-02-15 00:38:39.000000', 'temperatura', 205.0000, 'ºC'),
	(58053, 109, '2015-02-15 00:38:40.000000', 'temperatura', 391.0000, 'ºC'),
	(58054, 109, '2015-02-15 00:38:41.000000', 'temperatura', 141.0000, 'ºC'),
	(58055, 109, '2015-02-15 00:38:42.000000', 'temperatura', 732.0000, 'ºC'),
	(58056, 109, '2015-02-15 00:38:43.000000', 'temperatura', 837.0000, 'ºC'),
	(58057, 109, '2015-02-15 00:38:44.000000', 'temperatura', 789.0000, 'ºC'),
	(58058, 109, '2015-02-15 00:38:45.000000', 'temperatura', 235.0000, 'ºC'),
	(58059, 109, '2015-02-15 00:38:46.000000', 'temperatura', 10.0000, 'ºC'),
	(58060, 109, '2015-02-15 00:38:47.000000', 'temperatura', 546.0000, 'ºC'),
	(58061, 109, '2015-02-15 00:38:48.000000', 'temperatura', 298.0000, 'ºC'),
	(58062, 109, '2015-02-15 00:38:49.000000', 'temperatura', 1055.0000, 'ºC'),
	(58063, 109, '2015-02-15 00:38:50.000000', 'temperatura', 782.0000, 'ºC'),
	(58064, 109, '2015-02-15 00:38:51.000000', 'temperatura', 744.0000, 'ºC'),
	(58065, 109, '2015-02-15 00:38:52.000000', 'temperatura', 176.0000, 'ºC'),
	(58066, 109, '2015-02-15 00:38:53.000000', 'temperatura', 1047.0000, 'ºC'),
	(58067, 109, '2015-02-15 00:38:54.000000', 'temperatura', 1108.0000, 'ºC'),
	(58068, 109, '2015-02-15 00:38:55.000000', 'temperatura', 1199.0000, 'ºC'),
	(58069, 109, '2015-02-15 00:38:56.000000', 'temperatura', 273.0000, 'ºC'),
	(58070, 109, '2015-02-15 00:38:57.000000', 'temperatura', 168.0000, 'ºC'),
	(58071, 109, '2015-02-15 00:38:58.000000', 'temperatura', 20.0000, 'ºC'),
	(58072, 109, '2015-02-15 00:38:59.000000', 'temperatura', 798.0000, 'ºC'),
	(58073, 109, '2015-02-15 00:39:00.000000', 'temperatura', 329.0000, 'ºC'),
	(58074, 109, '2015-02-15 00:39:01.000000', 'temperatura', 454.0000, 'ºC'),
	(58075, 109, '2015-02-15 00:39:02.000000', 'temperatura', 80.0000, 'ºC'),
	(58076, 109, '2015-02-15 00:39:03.000000', 'temperatura', 242.0000, 'ºC'),
	(58077, 109, '2015-02-15 00:39:04.000000', 'temperatura', 969.0000, 'ºC'),
	(58078, 109, '2015-02-15 00:39:05.000000', 'temperatura', 518.0000, 'ºC'),
	(58079, 109, '2015-02-15 00:39:06.000000', 'temperatura', 885.0000, 'ºC'),
	(58080, 109, '2015-02-15 00:39:07.000000', 'temperatura', 473.0000, 'ºC'),
	(58081, 109, '2015-02-15 00:39:08.000000', 'temperatura', 909.0000, 'ºC'),
	(58082, 109, '2015-02-15 00:39:09.000000', 'temperatura', 726.0000, 'ºC'),
	(58083, 109, '2015-02-15 00:39:10.000000', 'temperatura', 902.0000, 'ºC'),
	(58084, 109, '2015-02-15 00:39:11.000000', 'temperatura', 1134.0000, 'ºC'),
	(58085, 109, '2015-02-15 00:39:12.000000', 'temperatura', 564.0000, 'ºC'),
	(58086, 109, '2015-02-15 00:39:13.000000', 'temperatura', 617.0000, 'ºC'),
	(58087, 109, '2015-02-15 00:39:14.000000', 'temperatura', 197.0000, 'ºC'),
	(58088, 109, '2015-02-15 00:39:15.000000', 'temperatura', 332.0000, 'ºC'),
	(58089, 109, '2015-02-15 00:39:16.000000', 'temperatura', 1072.0000, 'ºC'),
	(58090, 109, '2015-02-15 00:39:17.000000', 'temperatura', 764.0000, 'ºC'),
	(58091, 109, '2015-02-15 00:39:18.000000', 'temperatura', 603.0000, 'ºC'),
	(58092, 109, '2015-02-15 00:39:19.000000', 'temperatura', 724.0000, 'ºC'),
	(58093, 109, '2015-02-15 00:39:20.000000', 'temperatura', 611.0000, 'ºC'),
	(58094, 109, '2015-02-15 00:39:21.000000', 'temperatura', 883.0000, 'ºC'),
	(58095, 109, '2015-02-15 00:39:22.000000', 'temperatura', 183.0000, 'ºC'),
	(58096, 109, '2015-02-15 00:39:23.000000', 'temperatura', 665.0000, 'ºC'),
	(58097, 109, '2015-02-15 00:39:24.000000', 'temperatura', 377.0000, 'ºC'),
	(58098, 109, '2015-02-15 00:39:25.000000', 'temperatura', 1090.0000, 'ºC'),
	(58099, 109, '2015-02-15 00:39:26.000000', 'temperatura', 719.0000, 'ºC'),
	(58100, 109, '2015-02-15 00:39:27.000000', 'temperatura', 326.0000, 'ºC'),
	(58101, 109, '2015-02-15 00:39:28.000000', 'temperatura', 672.0000, 'ºC'),
	(58102, 109, '2015-02-15 00:39:29.000000', 'temperatura', 1183.0000, 'ºC'),
	(58103, 109, '2015-02-15 00:39:30.000000', 'temperatura', 301.0000, 'ºC'),
	(58104, 109, '2015-02-15 00:39:31.000000', 'temperatura', 357.0000, 'ºC'),
	(58105, 109, '2015-02-15 00:39:32.000000', 'temperatura', 882.0000, 'ºC'),
	(58106, 109, '2015-02-15 00:39:33.000000', 'temperatura', 940.0000, 'ºC'),
	(58107, 109, '2015-02-15 00:39:34.000000', 'temperatura', 855.0000, 'ºC'),
	(58108, 109, '2015-02-15 00:39:35.000000', 'temperatura', 257.0000, 'ºC'),
	(58109, 109, '2015-02-15 00:39:36.000000', 'temperatura', 1118.0000, 'ºC'),
	(58110, 109, '2015-02-15 00:39:37.000000', 'temperatura', 20.0000, 'ºC'),
	(58111, 109, '2015-02-15 00:39:38.000000', 'temperatura', 349.0000, 'ºC'),
	(58112, 109, '2015-02-15 00:39:39.000000', 'temperatura', 482.0000, 'ºC'),
	(58113, 109, '2015-02-15 00:39:40.000000', 'temperatura', 166.0000, 'ºC'),
	(58114, 109, '2015-02-15 00:39:41.000000', 'temperatura', 583.0000, 'ºC'),
	(58115, 109, '2015-02-15 00:39:42.000000', 'temperatura', 18.0000, 'ºC'),
	(58116, 109, '2015-02-15 00:39:43.000000', 'temperatura', 742.0000, 'ºC'),
	(58117, 109, '2015-02-15 00:39:44.000000', 'temperatura', 58.0000, 'ºC'),
	(58118, 109, '2015-02-15 00:39:45.000000', 'temperatura', 464.0000, 'ºC'),
	(58119, 109, '2015-02-15 00:39:46.000000', 'temperatura', 947.0000, 'ºC'),
	(58120, 109, '2015-02-15 00:39:47.000000', 'temperatura', 941.0000, 'ºC'),
	(58121, 109, '2015-02-15 00:39:48.000000', 'temperatura', 666.0000, 'ºC'),
	(58122, 109, '2015-02-15 00:39:49.000000', 'temperatura', 509.0000, 'ºC'),
	(58123, 109, '2015-02-15 00:39:50.000000', 'temperatura', 548.0000, 'ºC'),
	(58124, 109, '2015-02-15 00:39:51.000000', 'temperatura', 13.0000, 'ºC'),
	(58125, 109, '2015-02-15 00:39:52.000000', 'temperatura', 819.0000, 'ºC'),
	(58126, 109, '2015-02-15 00:39:53.000000', 'temperatura', 458.0000, 'ºC'),
	(58127, 109, '2015-02-15 00:39:54.000000', 'temperatura', 1035.0000, 'ºC'),
	(58128, 109, '2015-02-15 00:39:55.000000', 'temperatura', 202.0000, 'ºC'),
	(58129, 109, '2015-02-15 00:39:56.000000', 'temperatura', 304.0000, 'ºC'),
	(58130, 109, '2015-02-15 00:39:57.000000', 'temperatura', 915.0000, 'ºC'),
	(58131, 109, '2015-02-15 00:39:58.000000', 'temperatura', 62.0000, 'ºC'),
	(58132, 109, '2015-02-15 00:39:59.000000', 'temperatura', 1167.0000, 'ºC'),
	(58133, 109, '2015-02-15 00:40:00.000000', 'temperatura', 850.0000, 'ºC'),
	(58134, 109, '2015-02-15 00:40:01.000000', 'temperatura', 749.0000, 'ºC'),
	(58135, 109, '2015-02-15 00:40:02.000000', 'temperatura', 1193.0000, 'ºC'),
	(58136, 109, '2015-02-15 00:40:03.000000', 'temperatura', 122.0000, 'ºC'),
	(58137, 109, '2015-02-15 00:40:04.000000', 'temperatura', 631.0000, 'ºC'),
	(58138, 109, '2015-02-15 00:40:05.000000', 'temperatura', 390.0000, 'ºC'),
	(58139, 109, '2015-02-15 00:40:06.000000', 'temperatura', 57.0000, 'ºC'),
	(58140, 109, '2015-02-15 00:40:07.000000', 'temperatura', 317.0000, 'ºC'),
	(58141, 109, '2015-02-15 00:40:08.000000', 'temperatura', 212.0000, 'ºC'),
	(58142, 109, '2015-02-15 00:40:09.000000', 'temperatura', 109.0000, 'ºC'),
	(58143, 109, '2015-02-15 00:40:10.000000', 'temperatura', 1111.0000, 'ºC'),
	(58144, 109, '2015-02-15 00:40:11.000000', 'temperatura', 427.0000, 'ºC'),
	(58145, 109, '2015-02-15 00:40:12.000000', 'temperatura', 4.0000, 'ºC'),
	(58146, 109, '2015-02-15 00:40:13.000000', 'temperatura', 1138.0000, 'ºC'),
	(58147, 109, '2015-02-15 00:40:14.000000', 'temperatura', 880.0000, 'ºC'),
	(58148, 109, '2015-02-15 00:40:15.000000', 'temperatura', 987.0000, 'ºC'),
	(58149, 109, '2015-02-15 00:40:16.000000', 'temperatura', 1095.0000, 'ºC'),
	(58150, 109, '2015-02-15 00:40:17.000000', 'temperatura', 112.0000, 'ºC'),
	(58151, 109, '2015-02-15 00:40:18.000000', 'temperatura', 879.0000, 'ºC'),
	(58152, 109, '2015-02-15 00:40:19.000000', 'temperatura', 459.0000, 'ºC'),
	(58153, 109, '2015-02-15 00:40:20.000000', 'temperatura', 856.0000, 'ºC'),
	(58154, 109, '2015-02-15 00:40:21.000000', 'temperatura', 505.0000, 'ºC'),
	(58155, 109, '2015-02-15 00:40:22.000000', 'temperatura', 1159.0000, 'ºC'),
	(58156, 109, '2015-02-15 00:40:23.000000', 'temperatura', 680.0000, 'ºC'),
	(58157, 109, '2015-02-15 00:40:24.000000', 'temperatura', 1124.0000, 'ºC'),
	(58158, 109, '2015-02-15 00:40:25.000000', 'temperatura', 1178.0000, 'ºC'),
	(58159, 109, '2015-02-15 00:40:26.000000', 'temperatura', 119.0000, 'ºC'),
	(58160, 109, '2015-02-15 00:40:27.000000', 'temperatura', 661.0000, 'ºC'),
	(58161, 109, '2015-02-15 00:40:28.000000', 'temperatura', 548.0000, 'ºC'),
	(58162, 109, '2015-02-15 00:40:29.000000', 'temperatura', 759.0000, 'ºC'),
	(58163, 109, '2015-02-15 00:40:30.000000', 'temperatura', 951.0000, 'ºC'),
	(58164, 109, '2015-02-15 00:40:31.000000', 'temperatura', 77.0000, 'ºC'),
	(58165, 109, '2015-02-15 00:40:32.000000', 'temperatura', 1136.0000, 'ºC'),
	(58166, 109, '2015-02-15 00:40:33.000000', 'temperatura', 646.0000, 'ºC'),
	(58167, 109, '2015-02-15 00:40:34.000000', 'temperatura', 1024.0000, 'ºC'),
	(58168, 109, '2015-02-15 00:40:35.000000', 'temperatura', 781.0000, 'ºC'),
	(58169, 109, '2015-02-15 00:40:36.000000', 'temperatura', 836.0000, 'ºC'),
	(58170, 109, '2015-02-15 00:40:37.000000', 'temperatura', 637.0000, 'ºC'),
	(58171, 109, '2015-02-15 00:40:38.000000', 'temperatura', 679.0000, 'ºC'),
	(58172, 109, '2015-02-15 00:40:39.000000', 'temperatura', 283.0000, 'ºC'),
	(58173, 109, '2015-02-15 00:40:40.000000', 'temperatura', 580.0000, 'ºC'),
	(58174, 109, '2015-02-15 00:40:41.000000', 'temperatura', 851.0000, 'ºC'),
	(58175, 109, '2015-02-15 00:40:42.000000', 'temperatura', 117.0000, 'ºC'),
	(58176, 109, '2015-02-15 00:40:43.000000', 'temperatura', 430.0000, 'ºC'),
	(58177, 109, '2015-02-15 00:40:44.000000', 'temperatura', 601.0000, 'ºC'),
	(58178, 109, '2015-02-15 00:40:45.000000', 'temperatura', 514.0000, 'ºC'),
	(58179, 109, '2015-02-15 00:40:46.000000', 'temperatura', 767.0000, 'ºC'),
	(58180, 109, '2015-02-15 00:40:47.000000', 'temperatura', 1095.0000, 'ºC'),
	(58181, 109, '2015-02-15 00:40:48.000000', 'temperatura', 774.0000, 'ºC'),
	(58182, 109, '2015-02-15 00:40:49.000000', 'temperatura', 586.0000, 'ºC'),
	(58183, 109, '2015-02-15 00:40:50.000000', 'temperatura', 610.0000, 'ºC'),
	(58184, 109, '2015-02-15 00:40:51.000000', 'temperatura', 90.0000, 'ºC'),
	(58185, 109, '2015-02-15 00:40:52.000000', 'temperatura', 1021.0000, 'ºC'),
	(58186, 109, '2015-02-15 00:40:53.000000', 'temperatura', 38.0000, 'ºC'),
	(58187, 109, '2015-02-15 00:40:54.000000', 'temperatura', 725.0000, 'ºC'),
	(58188, 109, '2015-02-15 00:40:55.000000', 'temperatura', 1112.0000, 'ºC'),
	(58189, 109, '2015-02-15 00:40:56.000000', 'temperatura', 985.0000, 'ºC'),
	(58190, 109, '2015-02-15 00:40:57.000000', 'temperatura', 390.0000, 'ºC'),
	(58191, 109, '2015-02-15 00:40:58.000000', 'temperatura', 195.0000, 'ºC'),
	(58192, 109, '2015-02-15 00:40:59.000000', 'temperatura', 1008.0000, 'ºC'),
	(58193, 109, '2015-02-15 00:41:00.000000', 'temperatura', 853.0000, 'ºC'),
	(58194, 109, '2015-02-15 00:41:01.000000', 'temperatura', 41.0000, 'ºC'),
	(58195, 109, '2015-02-15 00:41:02.000000', 'temperatura', 45.0000, 'ºC'),
	(58196, 109, '2015-02-15 00:41:03.000000', 'temperatura', 106.0000, 'ºC'),
	(58197, 109, '2015-02-15 00:41:04.000000', 'temperatura', 393.0000, 'ºC'),
	(58198, 109, '2015-02-15 00:41:05.000000', 'temperatura', 446.0000, 'ºC'),
	(58199, 109, '2015-02-15 00:41:06.000000', 'temperatura', 1055.0000, 'ºC'),
	(58200, 109, '2015-02-15 00:41:07.000000', 'temperatura', 336.0000, 'ºC'),
	(58201, 109, '2015-02-15 00:41:08.000000', 'temperatura', 917.0000, 'ºC'),
	(58202, 109, '2015-02-15 00:41:09.000000', 'temperatura', 1175.0000, 'ºC'),
	(58203, 109, '2015-02-15 00:41:10.000000', 'temperatura', 723.0000, 'ºC'),
	(58204, 109, '2015-02-15 00:41:11.000000', 'temperatura', 94.0000, 'ºC'),
	(58205, 109, '2015-02-15 00:41:12.000000', 'temperatura', 701.0000, 'ºC'),
	(58206, 109, '2015-02-15 00:41:13.000000', 'temperatura', 824.0000, 'ºC'),
	(58207, 109, '2015-02-15 00:41:14.000000', 'temperatura', 817.0000, 'ºC'),
	(58208, 109, '2015-02-15 00:41:15.000000', 'temperatura', 413.0000, 'ºC'),
	(58209, 109, '2015-02-15 00:41:16.000000', 'temperatura', 813.0000, 'ºC'),
	(58210, 109, '2015-02-15 00:41:17.000000', 'temperatura', 429.0000, 'ºC'),
	(58211, 109, '2015-02-15 00:41:18.000000', 'temperatura', 906.0000, 'ºC'),
	(58212, 109, '2015-02-15 00:41:19.000000', 'temperatura', 841.0000, 'ºC'),
	(58213, 109, '2015-02-15 00:41:20.000000', 'temperatura', 290.0000, 'ºC'),
	(58214, 109, '2015-02-15 00:41:21.000000', 'temperatura', 126.0000, 'ºC'),
	(58215, 109, '2015-02-15 00:41:22.000000', 'temperatura', 963.0000, 'ºC'),
	(58216, 109, '2015-02-15 00:41:23.000000', 'temperatura', 837.0000, 'ºC'),
	(58217, 109, '2015-02-15 00:41:24.000000', 'temperatura', 96.0000, 'ºC'),
	(58218, 109, '2015-02-15 00:41:25.000000', 'temperatura', 369.0000, 'ºC'),
	(58219, 109, '2015-02-15 00:41:26.000000', 'temperatura', 358.0000, 'ºC'),
	(58220, 109, '2015-02-15 00:41:27.000000', 'temperatura', 685.0000, 'ºC'),
	(58221, 109, '2015-02-15 00:41:28.000000', 'temperatura', 1148.0000, 'ºC'),
	(58222, 109, '2015-02-15 00:41:29.000000', 'temperatura', 89.0000, 'ºC'),
	(58223, 109, '2015-02-15 00:41:30.000000', 'temperatura', 599.0000, 'ºC'),
	(58224, 109, '2015-02-15 00:41:31.000000', 'temperatura', 330.0000, 'ºC'),
	(58225, 109, '2015-02-15 00:41:32.000000', 'temperatura', 1055.0000, 'ºC'),
	(58226, 109, '2015-02-15 00:41:33.000000', 'temperatura', 685.0000, 'ºC'),
	(58227, 109, '2015-02-15 00:41:34.000000', 'temperatura', 258.0000, 'ºC'),
	(58228, 109, '2015-02-15 00:41:35.000000', 'temperatura', 437.0000, 'ºC'),
	(58229, 109, '2015-02-15 00:41:36.000000', 'temperatura', 209.0000, 'ºC'),
	(58230, 109, '2015-02-15 00:41:37.000000', 'temperatura', 938.0000, 'ºC'),
	(58231, 109, '2015-02-15 00:41:38.000000', 'temperatura', 463.0000, 'ºC'),
	(58232, 109, '2015-02-15 00:41:39.000000', 'temperatura', 701.0000, 'ºC'),
	(58233, 109, '2015-02-15 00:41:40.000000', 'temperatura', 918.0000, 'ºC'),
	(58234, 109, '2015-02-15 00:41:41.000000', 'temperatura', 86.0000, 'ºC'),
	(58235, 109, '2015-02-15 00:41:42.000000', 'temperatura', 78.0000, 'ºC'),
	(58236, 109, '2015-02-15 00:41:43.000000', 'temperatura', 130.0000, 'ºC'),
	(58237, 109, '2015-02-15 00:41:44.000000', 'temperatura', 419.0000, 'ºC'),
	(58238, 109, '2015-02-15 00:41:45.000000', 'temperatura', 505.0000, 'ºC'),
	(58239, 109, '2015-02-15 00:41:46.000000', 'temperatura', 69.0000, 'ºC'),
	(58240, 109, '2015-02-15 00:41:47.000000', 'temperatura', 28.0000, 'ºC'),
	(58241, 109, '2015-02-15 00:41:48.000000', 'temperatura', 1135.0000, 'ºC'),
	(58242, 109, '2015-02-15 00:41:49.000000', 'temperatura', 790.0000, 'ºC'),
	(58243, 109, '2015-02-15 00:41:50.000000', 'temperatura', 547.0000, 'ºC'),
	(58244, 109, '2015-02-15 00:41:51.000000', 'temperatura', 364.0000, 'ºC'),
	(58245, 109, '2015-02-15 00:41:52.000000', 'temperatura', 181.0000, 'ºC'),
	(58246, 109, '2015-02-15 00:41:53.000000', 'temperatura', 1013.0000, 'ºC'),
	(58247, 109, '2015-02-15 00:41:54.000000', 'temperatura', 922.0000, 'ºC'),
	(58248, 109, '2015-02-15 00:41:55.000000', 'temperatura', 372.0000, 'ºC'),
	(58249, 109, '2015-02-15 00:41:56.000000', 'temperatura', 296.0000, 'ºC'),
	(58250, 109, '2015-02-15 00:41:57.000000', 'temperatura', 365.0000, 'ºC'),
	(58251, 109, '2015-02-15 00:41:58.000000', 'temperatura', 935.0000, 'ºC'),
	(58252, 109, '2015-02-15 00:41:59.000000', 'temperatura', 1179.0000, 'ºC'),
	(58253, 109, '2015-02-15 00:42:00.000000', 'temperatura', 694.0000, 'ºC'),
	(58254, 109, '2015-02-15 00:42:01.000000', 'temperatura', 1134.0000, 'ºC'),
	(58255, 109, '2015-02-15 00:42:02.000000', 'temperatura', 1185.0000, 'ºC'),
	(58256, 109, '2015-02-15 00:42:03.000000', 'temperatura', 126.0000, 'ºC'),
	(58257, 109, '2015-02-15 00:42:04.000000', 'temperatura', 676.0000, 'ºC'),
	(58258, 109, '2015-02-15 00:42:05.000000', 'temperatura', 600.0000, 'ºC'),
	(58259, 109, '2015-02-15 00:42:06.000000', 'temperatura', 973.0000, 'ºC'),
	(58260, 109, '2015-02-15 00:42:07.000000', 'temperatura', 666.0000, 'ºC'),
	(58261, 109, '2015-02-15 00:42:08.000000', 'temperatura', 412.0000, 'ºC'),
	(58262, 109, '2015-02-15 00:42:09.000000', 'temperatura', 63.0000, 'ºC'),
	(58263, 109, '2015-02-15 00:42:10.000000', 'temperatura', 279.0000, 'ºC'),
	(58264, 109, '2015-02-15 00:42:11.000000', 'temperatura', 8.0000, 'ºC'),
	(58265, 109, '2015-02-15 00:42:12.000000', 'temperatura', 403.0000, 'ºC'),
	(58266, 109, '2015-02-15 00:42:13.000000', 'temperatura', 793.0000, 'ºC'),
	(58267, 109, '2015-02-15 00:42:14.000000', 'temperatura', 353.0000, 'ºC'),
	(58268, 109, '2015-02-15 00:42:15.000000', 'temperatura', 589.0000, 'ºC'),
	(58269, 109, '2015-02-15 00:42:16.000000', 'temperatura', 686.0000, 'ºC'),
	(58270, 109, '2015-02-15 00:42:17.000000', 'temperatura', 462.0000, 'ºC'),
	(58271, 109, '2015-02-15 00:42:18.000000', 'temperatura', 253.0000, 'ºC'),
	(58272, 109, '2015-02-15 00:42:19.000000', 'temperatura', 1080.0000, 'ºC'),
	(58273, 109, '2015-02-15 00:42:20.000000', 'temperatura', 1040.0000, 'ºC'),
	(58274, 109, '2015-02-15 00:42:21.000000', 'temperatura', 763.0000, 'ºC'),
	(58275, 109, '2015-02-15 00:42:22.000000', 'temperatura', 695.0000, 'ºC'),
	(58276, 109, '2015-02-15 00:42:23.000000', 'temperatura', 1185.0000, 'ºC'),
	(58277, 109, '2015-02-15 00:42:24.000000', 'temperatura', 242.0000, 'ºC'),
	(58278, 109, '2015-02-15 00:42:25.000000', 'temperatura', 56.0000, 'ºC'),
	(58279, 109, '2015-02-15 00:42:26.000000', 'temperatura', 753.0000, 'ºC'),
	(58280, 109, '2015-02-15 00:42:27.000000', 'temperatura', 1198.0000, 'ºC'),
	(58281, 109, '2015-02-15 00:42:28.000000', 'temperatura', 132.0000, 'ºC'),
	(58282, 109, '2015-02-15 00:42:29.000000', 'temperatura', 667.0000, 'ºC'),
	(58283, 109, '2015-02-15 00:42:30.000000', 'temperatura', 541.0000, 'ºC'),
	(58284, 109, '2015-02-15 00:42:31.000000', 'temperatura', 703.0000, 'ºC'),
	(58285, 109, '2015-02-15 00:42:32.000000', 'temperatura', 694.0000, 'ºC'),
	(58286, 109, '2015-02-15 00:42:33.000000', 'temperatura', 160.0000, 'ºC'),
	(58287, 109, '2015-02-15 00:42:34.000000', 'temperatura', 1121.0000, 'ºC'),
	(58288, 109, '2015-02-15 00:42:35.000000', 'temperatura', 322.0000, 'ºC'),
	(58289, 109, '2015-02-15 00:42:36.000000', 'temperatura', 649.0000, 'ºC'),
	(58290, 109, '2015-02-15 00:42:37.000000', 'temperatura', 1078.0000, 'ºC'),
	(58291, 109, '2015-02-15 00:42:38.000000', 'temperatura', 1043.0000, 'ºC'),
	(58292, 109, '2015-02-15 00:42:39.000000', 'temperatura', 784.0000, 'ºC'),
	(58293, 109, '2015-02-15 00:42:40.000000', 'temperatura', 790.0000, 'ºC'),
	(58294, 109, '2015-02-15 00:42:41.000000', 'temperatura', 400.0000, 'ºC'),
	(58295, 109, '2015-02-15 00:42:42.000000', 'temperatura', 831.0000, 'ºC'),
	(58296, 109, '2015-02-15 00:42:43.000000', 'temperatura', 555.0000, 'ºC'),
	(58297, 109, '2015-02-15 00:42:44.000000', 'temperatura', 281.0000, 'ºC'),
	(58298, 109, '2015-02-15 00:42:45.000000', 'temperatura', 940.0000, 'ºC'),
	(58299, 109, '2015-02-15 00:42:46.000000', 'temperatura', 257.0000, 'ºC'),
	(58300, 109, '2015-02-15 00:42:47.000000', 'temperatura', 867.0000, 'ºC'),
	(58301, 109, '2015-02-15 00:42:48.000000', 'temperatura', 1164.0000, 'ºC'),
	(58302, 109, '2015-02-15 00:42:49.000000', 'temperatura', 820.0000, 'ºC'),
	(58303, 109, '2015-02-15 00:42:50.000000', 'temperatura', 608.0000, 'ºC'),
	(58304, 109, '2015-02-15 00:42:51.000000', 'temperatura', 583.0000, 'ºC'),
	(58305, 109, '2015-02-15 00:42:52.000000', 'temperatura', 1088.0000, 'ºC'),
	(58306, 109, '2015-02-15 00:42:53.000000', 'temperatura', 95.0000, 'ºC'),
	(58307, 109, '2015-02-15 00:42:54.000000', 'temperatura', 809.0000, 'ºC'),
	(58308, 109, '2015-02-15 00:42:55.000000', 'temperatura', 159.0000, 'ºC'),
	(58309, 109, '2015-02-15 00:42:56.000000', 'temperatura', 771.0000, 'ºC'),
	(58310, 109, '2015-02-15 00:42:57.000000', 'temperatura', 980.0000, 'ºC'),
	(58311, 109, '2015-02-15 00:42:58.000000', 'temperatura', 185.0000, 'ºC'),
	(58312, 109, '2015-02-15 00:42:59.000000', 'temperatura', 387.0000, 'ºC'),
	(58313, 109, '2015-02-15 00:43:00.000000', 'temperatura', 179.0000, 'ºC'),
	(58314, 109, '2015-02-15 00:43:01.000000', 'temperatura', 935.0000, 'ºC'),
	(58315, 109, '2015-02-15 00:43:02.000000', 'temperatura', 539.0000, 'ºC'),
	(58316, 109, '2015-02-15 00:43:03.000000', 'temperatura', 1091.0000, 'ºC'),
	(58317, 109, '2015-02-15 00:43:04.000000', 'temperatura', 238.0000, 'ºC'),
	(58318, 109, '2015-02-15 00:43:05.000000', 'temperatura', 319.0000, 'ºC'),
	(58319, 109, '2015-02-15 00:43:06.000000', 'temperatura', 878.0000, 'ºC'),
	(58320, 109, '2015-02-15 00:43:07.000000', 'temperatura', 1037.0000, 'ºC'),
	(58321, 109, '2015-02-15 00:43:08.000000', 'temperatura', 150.0000, 'ºC'),
	(58322, 109, '2015-02-15 00:43:09.000000', 'temperatura', 41.0000, 'ºC'),
	(58323, 109, '2015-02-15 00:43:10.000000', 'temperatura', 955.0000, 'ºC'),
	(58324, 109, '2015-02-15 00:43:11.000000', 'temperatura', 1051.0000, 'ºC'),
	(58325, 109, '2015-02-15 00:43:12.000000', 'temperatura', 1193.0000, 'ºC'),
	(58326, 109, '2015-02-15 00:43:13.000000', 'temperatura', 409.0000, 'ºC'),
	(58327, 109, '2015-02-15 00:43:14.000000', 'temperatura', 870.0000, 'ºC'),
	(58328, 109, '2015-02-15 00:43:15.000000', 'temperatura', 723.0000, 'ºC'),
	(58329, 109, '2015-02-15 00:43:16.000000', 'temperatura', 1005.0000, 'ºC'),
	(58330, 109, '2015-02-15 00:43:17.000000', 'temperatura', 458.0000, 'ºC'),
	(58331, 109, '2015-02-15 00:43:18.000000', 'temperatura', 475.0000, 'ºC'),
	(58332, 109, '2015-02-15 00:43:19.000000', 'temperatura', 999.0000, 'ºC'),
	(58333, 109, '2015-02-15 00:43:20.000000', 'temperatura', 1174.0000, 'ºC'),
	(58334, 109, '2015-02-15 00:43:21.000000', 'temperatura', 471.0000, 'ºC'),
	(58335, 109, '2015-02-15 00:43:22.000000', 'temperatura', 33.0000, 'ºC'),
	(58336, 109, '2015-02-15 00:43:23.000000', 'temperatura', 1154.0000, 'ºC'),
	(58337, 109, '2015-02-15 00:43:24.000000', 'temperatura', 870.0000, 'ºC'),
	(58338, 109, '2015-02-15 00:43:25.000000', 'temperatura', 890.0000, 'ºC'),
	(58339, 109, '2015-02-15 00:43:26.000000', 'temperatura', 640.0000, 'ºC'),
	(58340, 109, '2015-02-15 00:43:27.000000', 'temperatura', 530.0000, 'ºC'),
	(58341, 109, '2015-02-15 00:43:28.000000', 'temperatura', 730.0000, 'ºC'),
	(58342, 109, '2015-02-15 00:43:29.000000', 'temperatura', 861.0000, 'ºC'),
	(58343, 109, '2015-02-15 00:43:30.000000', 'temperatura', 914.0000, 'ºC'),
	(58344, 109, '2015-02-15 00:43:31.000000', 'temperatura', 790.0000, 'ºC'),
	(58345, 109, '2015-02-15 00:43:32.000000', 'temperatura', 9.0000, 'ºC'),
	(58346, 109, '2015-02-15 00:43:33.000000', 'temperatura', 75.0000, 'ºC'),
	(58347, 109, '2015-02-15 00:43:34.000000', 'temperatura', 349.0000, 'ºC'),
	(58348, 109, '2015-02-15 00:43:35.000000', 'temperatura', 318.0000, 'ºC'),
	(58349, 109, '2015-02-15 00:43:36.000000', 'temperatura', 546.0000, 'ºC'),
	(58350, 109, '2015-02-15 00:43:37.000000', 'temperatura', 576.0000, 'ºC'),
	(58351, 109, '2015-02-15 00:43:38.000000', 'temperatura', 41.0000, 'ºC'),
	(58352, 109, '2015-02-15 00:43:39.000000', 'temperatura', 877.0000, 'ºC'),
	(58353, 109, '2015-02-15 00:43:40.000000', 'temperatura', 664.0000, 'ºC'),
	(58354, 109, '2015-02-15 00:43:41.000000', 'temperatura', 689.0000, 'ºC'),
	(58355, 109, '2015-02-15 00:43:42.000000', 'temperatura', 255.0000, 'ºC'),
	(58356, 109, '2015-02-15 00:43:43.000000', 'temperatura', 407.0000, 'ºC'),
	(58357, 109, '2015-02-15 00:43:44.000000', 'temperatura', 73.0000, 'ºC'),
	(58358, 109, '2015-02-15 00:43:45.000000', 'temperatura', 341.0000, 'ºC'),
	(58359, 109, '2015-02-15 00:43:46.000000', 'temperatura', 289.0000, 'ºC'),
	(58360, 109, '2015-02-15 00:43:47.000000', 'temperatura', 422.0000, 'ºC'),
	(58361, 109, '2015-02-15 00:43:48.000000', 'temperatura', 44.0000, 'ºC'),
	(58362, 109, '2015-02-15 00:43:49.000000', 'temperatura', 155.0000, 'ºC'),
	(58363, 109, '2015-02-15 00:43:50.000000', 'temperatura', 644.0000, 'ºC'),
	(58364, 109, '2015-02-15 00:43:51.000000', 'temperatura', 355.0000, 'ºC'),
	(58365, 109, '2015-02-15 00:43:52.000000', 'temperatura', 1043.0000, 'ºC'),
	(58366, 109, '2015-02-15 00:43:53.000000', 'temperatura', 550.0000, 'ºC'),
	(58367, 109, '2015-02-15 00:43:54.000000', 'temperatura', 820.0000, 'ºC'),
	(58368, 109, '2015-02-15 00:43:55.000000', 'temperatura', 52.0000, 'ºC'),
	(58369, 109, '2015-02-15 00:43:56.000000', 'temperatura', 202.0000, 'ºC'),
	(58370, 109, '2015-02-15 00:43:57.000000', 'temperatura', 854.0000, 'ºC'),
	(58371, 109, '2015-02-15 00:43:58.000000', 'temperatura', 66.0000, 'ºC'),
	(58372, 109, '2015-02-15 00:43:59.000000', 'temperatura', 168.0000, 'ºC'),
	(58373, 109, '2015-02-15 00:44:00.000000', 'temperatura', 642.0000, 'ºC'),
	(58374, 109, '2015-02-15 00:44:01.000000', 'temperatura', 304.0000, 'ºC'),
	(58375, 109, '2015-02-15 00:44:02.000000', 'temperatura', 798.0000, 'ºC'),
	(58376, 109, '2015-02-15 00:44:03.000000', 'temperatura', 675.0000, 'ºC'),
	(58377, 109, '2015-02-15 00:44:04.000000', 'temperatura', 985.0000, 'ºC'),
	(58378, 109, '2015-02-15 00:44:05.000000', 'temperatura', 500.0000, 'ºC'),
	(58379, 109, '2015-02-15 00:44:06.000000', 'temperatura', 743.0000, 'ºC'),
	(58380, 109, '2015-02-15 00:44:07.000000', 'temperatura', 1018.0000, 'ºC'),
	(58381, 109, '2015-02-15 00:44:08.000000', 'temperatura', 462.0000, 'ºC'),
	(58382, 109, '2015-02-15 00:44:09.000000', 'temperatura', 456.0000, 'ºC'),
	(58383, 109, '2015-02-15 00:44:10.000000', 'temperatura', 896.0000, 'ºC'),
	(58384, 109, '2015-02-15 00:44:11.000000', 'temperatura', 712.0000, 'ºC'),
	(58385, 109, '2015-02-15 00:44:12.000000', 'temperatura', 871.0000, 'ºC'),
	(58386, 109, '2015-02-15 00:44:13.000000', 'temperatura', 1019.0000, 'ºC'),
	(58387, 109, '2015-02-15 00:44:14.000000', 'temperatura', 82.0000, 'ºC'),
	(58388, 109, '2015-02-15 00:44:15.000000', 'temperatura', 954.0000, 'ºC'),
	(58389, 109, '2015-02-15 00:44:16.000000', 'temperatura', 923.0000, 'ºC'),
	(58390, 109, '2015-02-15 00:44:17.000000', 'temperatura', 555.0000, 'ºC'),
	(58391, 109, '2015-02-15 00:44:18.000000', 'temperatura', 6.0000, 'ºC'),
	(58392, 109, '2015-02-15 00:44:19.000000', 'temperatura', 766.0000, 'ºC'),
	(58393, 109, '2015-02-15 00:44:20.000000', 'temperatura', 213.0000, 'ºC'),
	(58394, 109, '2015-02-15 00:44:21.000000', 'temperatura', 1166.0000, 'ºC'),
	(58395, 109, '2015-02-15 00:44:22.000000', 'temperatura', 391.0000, 'ºC'),
	(58396, 109, '2015-02-15 00:44:23.000000', 'temperatura', 858.0000, 'ºC'),
	(58397, 109, '2015-02-15 00:44:24.000000', 'temperatura', 719.0000, 'ºC'),
	(58398, 109, '2015-02-15 00:44:25.000000', 'temperatura', 1021.0000, 'ºC'),
	(58399, 109, '2015-02-15 00:44:26.000000', 'temperatura', 546.0000, 'ºC'),
	(58400, 109, '2015-02-15 00:44:27.000000', 'temperatura', 871.0000, 'ºC'),
	(58401, 109, '2015-02-15 00:44:28.000000', 'temperatura', 317.0000, 'ºC'),
	(58402, 109, '2015-02-15 00:44:29.000000', 'temperatura', 171.0000, 'ºC'),
	(58403, 109, '2015-02-15 00:44:30.000000', 'temperatura', 1104.0000, 'ºC'),
	(58404, 109, '2015-02-15 00:44:31.000000', 'temperatura', 210.0000, 'ºC'),
	(58405, 109, '2015-02-15 00:44:32.000000', 'temperatura', 138.0000, 'ºC'),
	(58406, 109, '2015-02-15 00:44:33.000000', 'temperatura', 61.0000, 'ºC'),
	(58407, 109, '2015-02-15 00:44:34.000000', 'temperatura', 1091.0000, 'ºC'),
	(58408, 109, '2015-02-15 00:44:35.000000', 'temperatura', 471.0000, 'ºC'),
	(58409, 109, '2015-02-15 00:44:36.000000', 'temperatura', 281.0000, 'ºC'),
	(58410, 109, '2015-02-15 00:44:37.000000', 'temperatura', 1196.0000, 'ºC'),
	(58411, 109, '2015-02-15 00:44:38.000000', 'temperatura', 337.0000, 'ºC'),
	(58412, 109, '2015-02-15 00:44:39.000000', 'temperatura', 495.0000, 'ºC'),
	(58413, 109, '2015-02-15 00:44:40.000000', 'temperatura', 268.0000, 'ºC'),
	(58414, 109, '2015-02-15 00:44:41.000000', 'temperatura', 1054.0000, 'ºC'),
	(58415, 109, '2015-02-15 00:44:42.000000', 'temperatura', 864.0000, 'ºC'),
	(58416, 109, '2015-02-15 00:44:43.000000', 'temperatura', 1162.0000, 'ºC'),
	(58417, 109, '2015-02-15 00:44:44.000000', 'temperatura', 818.0000, 'ºC'),
	(58418, 109, '2015-02-15 00:44:45.000000', 'temperatura', 604.0000, 'ºC'),
	(58419, 109, '2015-02-15 00:44:46.000000', 'temperatura', 568.0000, 'ºC'),
	(58420, 109, '2015-02-15 00:44:47.000000', 'temperatura', 1027.0000, 'ºC'),
	(58421, 109, '2015-02-15 00:44:48.000000', 'temperatura', 1030.0000, 'ºC'),
	(58422, 109, '2015-02-15 00:44:49.000000', 'temperatura', 873.0000, 'ºC'),
	(58423, 109, '2015-02-15 00:44:50.000000', 'temperatura', 74.0000, 'ºC'),
	(58424, 109, '2015-02-15 00:44:51.000000', 'temperatura', 150.0000, 'ºC'),
	(58425, 109, '2015-02-15 00:44:52.000000', 'temperatura', 527.0000, 'ºC'),
	(58426, 109, '2015-02-15 00:44:53.000000', 'temperatura', 989.0000, 'ºC'),
	(58427, 109, '2015-02-15 00:44:54.000000', 'temperatura', 963.0000, 'ºC'),
	(58428, 109, '2015-02-15 00:44:55.000000', 'temperatura', 647.0000, 'ºC'),
	(58429, 109, '2015-02-15 00:44:56.000000', 'temperatura', 349.0000, 'ºC'),
	(58430, 109, '2015-02-15 00:44:57.000000', 'temperatura', 1003.0000, 'ºC'),
	(58431, 109, '2015-02-15 00:44:58.000000', 'temperatura', 370.0000, 'ºC'),
	(58432, 109, '2015-02-15 00:44:59.000000', 'temperatura', 42.0000, 'ºC'),
	(58433, 109, '2015-02-15 00:45:00.000000', 'temperatura', 297.0000, 'ºC'),
	(58434, 109, '2015-02-15 00:45:01.000000', 'temperatura', 163.0000, 'ºC'),
	(58435, 109, '2015-02-15 00:45:02.000000', 'temperatura', 1125.0000, 'ºC'),
	(58436, 109, '2015-02-15 00:45:03.000000', 'temperatura', 335.0000, 'ºC'),
	(58437, 109, '2015-02-15 00:45:04.000000', 'temperatura', 699.0000, 'ºC'),
	(58438, 109, '2015-02-15 00:45:05.000000', 'temperatura', 91.0000, 'ºC'),
	(58439, 109, '2015-02-15 00:45:06.000000', 'temperatura', 758.0000, 'ºC'),
	(58440, 109, '2015-02-15 00:45:07.000000', 'temperatura', 1117.0000, 'ºC'),
	(58441, 109, '2015-02-15 00:45:08.000000', 'temperatura', 911.0000, 'ºC'),
	(58442, 109, '2015-02-15 00:45:09.000000', 'temperatura', 7.0000, 'ºC'),
	(58443, 109, '2015-02-15 00:45:10.000000', 'temperatura', 902.0000, 'ºC'),
	(58444, 109, '2015-02-15 00:45:11.000000', 'temperatura', 887.0000, 'ºC'),
	(58445, 109, '2015-02-15 00:45:12.000000', 'temperatura', 532.0000, 'ºC'),
	(58446, 109, '2015-02-15 00:45:13.000000', 'temperatura', 1197.0000, 'ºC'),
	(58447, 109, '2015-02-15 00:45:14.000000', 'temperatura', 792.0000, 'ºC'),
	(58448, 109, '2015-02-15 00:45:15.000000', 'temperatura', 371.0000, 'ºC'),
	(58449, 109, '2015-02-15 00:45:16.000000', 'temperatura', 676.0000, 'ºC'),
	(58450, 109, '2015-02-15 00:45:17.000000', 'temperatura', 1068.0000, 'ºC'),
	(58451, 109, '2015-02-15 00:45:18.000000', 'temperatura', 911.0000, 'ºC'),
	(58452, 109, '2015-02-15 00:45:19.000000', 'temperatura', 153.0000, 'ºC'),
	(58453, 109, '2015-02-15 00:45:20.000000', 'temperatura', 431.0000, 'ºC'),
	(58454, 109, '2015-02-15 00:45:21.000000', 'temperatura', 498.0000, 'ºC'),
	(58455, 109, '2015-02-15 00:45:22.000000', 'temperatura', 1199.0000, 'ºC'),
	(58456, 109, '2015-02-15 00:45:23.000000', 'temperatura', 900.0000, 'ºC'),
	(58457, 109, '2015-02-15 00:45:24.000000', 'temperatura', 905.0000, 'ºC'),
	(58458, 109, '2015-02-15 00:45:25.000000', 'temperatura', 627.0000, 'ºC'),
	(58459, 109, '2015-02-15 00:45:26.000000', 'temperatura', 417.0000, 'ºC'),
	(58460, 109, '2015-02-15 00:45:27.000000', 'temperatura', 206.0000, 'ºC'),
	(58461, 109, '2015-02-15 00:45:28.000000', 'temperatura', 978.0000, 'ºC'),
	(58462, 109, '2015-02-15 00:45:29.000000', 'temperatura', 675.0000, 'ºC'),
	(58463, 109, '2015-02-15 00:45:30.000000', 'temperatura', 439.0000, 'ºC'),
	(58464, 109, '2015-02-15 00:45:31.000000', 'temperatura', 172.0000, 'ºC'),
	(58465, 109, '2015-02-15 00:45:32.000000', 'temperatura', 741.0000, 'ºC'),
	(58466, 109, '2015-02-15 00:45:33.000000', 'temperatura', 791.0000, 'ºC'),
	(58467, 109, '2015-02-15 00:45:34.000000', 'temperatura', 535.0000, 'ºC'),
	(58468, 109, '2015-02-15 00:45:35.000000', 'temperatura', 299.0000, 'ºC'),
	(58469, 109, '2015-02-15 00:45:36.000000', 'temperatura', 1092.0000, 'ºC'),
	(58470, 109, '2015-02-15 00:45:37.000000', 'temperatura', 964.0000, 'ºC'),
	(58471, 109, '2015-02-15 00:45:38.000000', 'temperatura', 345.0000, 'ºC'),
	(58472, 109, '2015-02-15 00:45:39.000000', 'temperatura', 31.0000, 'ºC'),
	(58473, 109, '2015-02-15 00:45:40.000000', 'temperatura', 322.0000, 'ºC'),
	(58474, 109, '2015-02-15 00:45:41.000000', 'temperatura', 316.0000, 'ºC'),
	(58475, 109, '2015-02-15 00:45:42.000000', 'temperatura', 614.0000, 'ºC'),
	(58476, 109, '2015-02-15 00:45:43.000000', 'temperatura', 924.0000, 'ºC'),
	(58477, 109, '2015-02-15 00:45:44.000000', 'temperatura', 377.0000, 'ºC'),
	(58478, 109, '2015-02-15 00:45:45.000000', 'temperatura', 315.0000, 'ºC'),
	(58479, 109, '2015-02-15 00:45:46.000000', 'temperatura', 444.0000, 'ºC'),
	(58480, 109, '2015-02-15 00:45:47.000000', 'temperatura', 74.0000, 'ºC'),
	(58481, 109, '2015-02-15 00:45:48.000000', 'temperatura', 239.0000, 'ºC'),
	(58482, 109, '2015-02-15 00:45:49.000000', 'temperatura', 975.0000, 'ºC'),
	(58483, 109, '2015-02-15 00:45:50.000000', 'temperatura', 556.0000, 'ºC'),
	(58484, 109, '2015-02-15 00:45:51.000000', 'temperatura', 1056.0000, 'ºC'),
	(58485, 109, '2015-02-15 00:45:52.000000', 'temperatura', 13.0000, 'ºC'),
	(58486, 109, '2015-02-15 00:45:53.000000', 'temperatura', 497.0000, 'ºC'),
	(58487, 109, '2015-02-15 00:45:54.000000', 'temperatura', 49.0000, 'ºC'),
	(58488, 109, '2015-02-15 00:45:55.000000', 'temperatura', 1153.0000, 'ºC'),
	(58489, 109, '2015-02-15 00:45:56.000000', 'temperatura', 817.0000, 'ºC'),
	(58490, 109, '2015-02-15 00:45:57.000000', 'temperatura', 629.0000, 'ºC'),
	(58491, 109, '2015-02-15 00:45:58.000000', 'temperatura', 693.0000, 'ºC'),
	(58492, 109, '2015-02-15 00:45:59.000000', 'temperatura', 380.0000, 'ºC'),
	(58493, 109, '2015-02-15 00:46:00.000000', 'temperatura', 1020.0000, 'ºC'),
	(58494, 109, '2015-02-15 00:46:01.000000', 'temperatura', 361.0000, 'ºC'),
	(58495, 109, '2015-02-15 00:46:02.000000', 'temperatura', 1145.0000, 'ºC'),
	(58496, 109, '2015-02-15 00:46:03.000000', 'temperatura', 1045.0000, 'ºC'),
	(58497, 109, '2015-02-15 00:46:04.000000', 'temperatura', 588.0000, 'ºC'),
	(58498, 109, '2015-02-15 00:46:05.000000', 'temperatura', 1006.0000, 'ºC'),
	(58499, 109, '2015-02-15 00:46:06.000000', 'temperatura', 867.0000, 'ºC'),
	(58500, 109, '2015-02-15 00:46:07.000000', 'temperatura', 115.0000, 'ºC'),
	(58501, 109, '2015-02-15 00:46:08.000000', 'temperatura', 377.0000, 'ºC'),
	(58502, 109, '2015-02-15 00:46:09.000000', 'temperatura', 340.0000, 'ºC'),
	(58503, 109, '2015-02-15 00:46:10.000000', 'temperatura', 571.0000, 'ºC'),
	(58504, 109, '2015-02-15 00:46:11.000000', 'temperatura', 634.0000, 'ºC'),
	(58505, 109, '2015-02-15 00:46:12.000000', 'temperatura', 257.0000, 'ºC'),
	(58506, 109, '2015-02-15 00:46:13.000000', 'temperatura', 582.0000, 'ºC'),
	(58507, 109, '2015-02-15 00:46:14.000000', 'temperatura', 943.0000, 'ºC'),
	(58508, 109, '2015-02-15 00:46:15.000000', 'temperatura', 568.0000, 'ºC'),
	(58509, 109, '2015-02-15 00:46:16.000000', 'temperatura', 11.0000, 'ºC'),
	(58510, 109, '2015-02-15 00:46:17.000000', 'temperatura', 753.0000, 'ºC'),
	(58511, 109, '2015-02-15 00:46:18.000000', 'temperatura', 133.0000, 'ºC'),
	(58512, 109, '2015-02-15 00:46:19.000000', 'temperatura', 804.0000, 'ºC'),
	(58513, 109, '2015-02-15 00:46:20.000000', 'temperatura', 21.0000, 'ºC'),
	(58514, 109, '2015-02-15 00:46:21.000000', 'temperatura', 94.0000, 'ºC'),
	(58515, 109, '2015-02-15 00:46:22.000000', 'temperatura', 410.0000, 'ºC'),
	(58516, 109, '2015-02-15 00:46:23.000000', 'temperatura', 567.0000, 'ºC'),
	(58517, 109, '2015-02-15 00:46:24.000000', 'temperatura', 407.0000, 'ºC'),
	(58518, 109, '2015-02-15 00:46:25.000000', 'temperatura', 335.0000, 'ºC'),
	(58519, 109, '2015-02-15 00:46:26.000000', 'temperatura', 454.0000, 'ºC'),
	(58520, 109, '2015-02-15 00:46:27.000000', 'temperatura', 64.0000, 'ºC'),
	(58521, 109, '2015-02-15 00:46:28.000000', 'temperatura', 158.0000, 'ºC'),
	(58522, 109, '2015-02-15 00:46:29.000000', 'temperatura', 598.0000, 'ºC'),
	(58523, 109, '2015-02-15 00:46:30.000000', 'temperatura', 116.0000, 'ºC'),
	(58524, 109, '2015-02-15 00:46:31.000000', 'temperatura', 1187.0000, 'ºC'),
	(58525, 109, '2015-02-15 00:46:32.000000', 'temperatura', 788.0000, 'ºC'),
	(58526, 109, '2015-02-15 00:46:33.000000', 'temperatura', 381.0000, 'ºC'),
	(58527, 109, '2015-02-15 00:46:34.000000', 'temperatura', 741.0000, 'ºC'),
	(58528, 109, '2015-02-15 00:46:35.000000', 'temperatura', 164.0000, 'ºC'),
	(58529, 109, '2015-02-15 00:46:36.000000', 'temperatura', 996.0000, 'ºC'),
	(58530, 109, '2015-02-15 00:46:37.000000', 'temperatura', 888.0000, 'ºC'),
	(58531, 109, '2015-02-15 00:46:38.000000', 'temperatura', 252.0000, 'ºC'),
	(58532, 109, '2015-02-15 00:46:39.000000', 'temperatura', 998.0000, 'ºC'),
	(58533, 109, '2015-02-15 00:46:40.000000', 'temperatura', 636.0000, 'ºC'),
	(58534, 109, '2015-02-15 00:46:41.000000', 'temperatura', 185.0000, 'ºC'),
	(58535, 109, '2015-02-15 00:46:42.000000', 'temperatura', 218.0000, 'ºC'),
	(58536, 109, '2015-02-15 00:46:43.000000', 'temperatura', 536.0000, 'ºC'),
	(58537, 109, '2015-02-15 00:46:44.000000', 'temperatura', 825.0000, 'ºC'),
	(58538, 109, '2015-02-15 00:46:45.000000', 'temperatura', 118.0000, 'ºC'),
	(58539, 109, '2015-02-15 00:46:46.000000', 'temperatura', 517.0000, 'ºC'),
	(58540, 109, '2015-02-15 00:46:47.000000', 'temperatura', 1030.0000, 'ºC'),
	(58541, 109, '2015-02-15 00:46:48.000000', 'temperatura', 1198.0000, 'ºC'),
	(58542, 109, '2015-02-15 00:46:49.000000', 'temperatura', 502.0000, 'ºC'),
	(58543, 109, '2015-02-15 00:46:50.000000', 'temperatura', 116.0000, 'ºC'),
	(58544, 109, '2015-02-15 00:46:51.000000', 'temperatura', 275.0000, 'ºC'),
	(58545, 109, '2015-02-15 00:46:52.000000', 'temperatura', 1029.0000, 'ºC'),
	(58546, 109, '2015-02-15 00:46:53.000000', 'temperatura', 719.0000, 'ºC'),
	(58547, 109, '2015-02-15 00:46:54.000000', 'temperatura', 509.0000, 'ºC'),
	(58548, 109, '2015-02-15 00:46:55.000000', 'temperatura', 389.0000, 'ºC'),
	(58549, 109, '2015-02-15 00:46:56.000000', 'temperatura', 419.0000, 'ºC'),
	(58550, 109, '2015-02-15 00:46:57.000000', 'temperatura', 928.0000, 'ºC'),
	(58551, 109, '2015-02-15 00:46:58.000000', 'temperatura', 985.0000, 'ºC'),
	(58552, 109, '2015-02-15 00:46:59.000000', 'temperatura', 939.0000, 'ºC'),
	(58553, 109, '2015-02-15 00:47:00.000000', 'temperatura', 542.0000, 'ºC'),
	(58554, 109, '2015-02-15 00:47:01.000000', 'temperatura', 1091.0000, 'ºC'),
	(58555, 109, '2015-02-15 00:47:02.000000', 'temperatura', 233.0000, 'ºC'),
	(58556, 109, '2015-02-15 00:47:03.000000', 'temperatura', 290.0000, 'ºC'),
	(58557, 109, '2015-02-15 00:47:04.000000', 'temperatura', 750.0000, 'ºC'),
	(58558, 109, '2015-02-15 00:47:05.000000', 'temperatura', 483.0000, 'ºC'),
	(58559, 109, '2015-02-15 00:47:06.000000', 'temperatura', 166.0000, 'ºC'),
	(58560, 109, '2015-02-15 00:47:07.000000', 'temperatura', 579.0000, 'ºC'),
	(58561, 109, '2015-02-15 00:47:08.000000', 'temperatura', 1197.0000, 'ºC'),
	(58562, 109, '2015-02-15 00:47:09.000000', 'temperatura', 651.0000, 'ºC'),
	(58563, 109, '2015-02-15 00:47:10.000000', 'temperatura', 864.0000, 'ºC'),
	(58564, 109, '2015-02-15 00:47:11.000000', 'temperatura', 1167.0000, 'ºC'),
	(58565, 109, '2015-02-15 00:47:12.000000', 'temperatura', 844.0000, 'ºC'),
	(58566, 109, '2015-02-15 00:47:13.000000', 'temperatura', 721.0000, 'ºC'),
	(58567, 109, '2015-02-15 00:47:14.000000', 'temperatura', 1071.0000, 'ºC'),
	(58568, 109, '2015-02-15 00:47:15.000000', 'temperatura', 795.0000, 'ºC'),
	(58569, 109, '2015-02-15 00:47:16.000000', 'temperatura', 761.0000, 'ºC'),
	(58570, 109, '2015-02-15 00:47:17.000000', 'temperatura', 219.0000, 'ºC'),
	(58571, 109, '2015-02-15 00:47:18.000000', 'temperatura', 14.0000, 'ºC'),
	(58572, 109, '2015-02-15 00:47:19.000000', 'temperatura', 614.0000, 'ºC'),
	(58573, 109, '2015-02-15 00:47:20.000000', 'temperatura', 630.0000, 'ºC'),
	(58574, 109, '2015-02-15 00:47:21.000000', 'temperatura', 106.0000, 'ºC'),
	(58575, 109, '2015-02-15 00:47:22.000000', 'temperatura', 1042.0000, 'ºC'),
	(58576, 109, '2015-02-15 00:47:23.000000', 'temperatura', 90.0000, 'ºC'),
	(58577, 109, '2015-02-15 00:47:24.000000', 'temperatura', 925.0000, 'ºC'),
	(58578, 109, '2015-02-15 00:47:25.000000', 'temperatura', 758.0000, 'ºC'),
	(58579, 109, '2015-02-15 00:47:26.000000', 'temperatura', 1013.0000, 'ºC'),
	(58580, 109, '2015-02-15 00:47:27.000000', 'temperatura', 394.0000, 'ºC'),
	(58581, 109, '2015-02-15 00:47:28.000000', 'temperatura', 129.0000, 'ºC'),
	(58582, 109, '2015-02-15 00:47:29.000000', 'temperatura', 665.0000, 'ºC'),
	(58583, 109, '2015-02-15 00:47:30.000000', 'temperatura', 538.0000, 'ºC'),
	(58584, 109, '2015-02-15 00:47:31.000000', 'temperatura', 697.0000, 'ºC'),
	(58585, 109, '2015-02-15 00:47:32.000000', 'temperatura', 669.0000, 'ºC'),
	(58586, 109, '2015-02-15 00:47:33.000000', 'temperatura', 56.0000, 'ºC'),
	(58587, 109, '2015-02-15 00:47:34.000000', 'temperatura', 675.0000, 'ºC'),
	(58588, 109, '2015-02-15 00:47:35.000000', 'temperatura', 806.0000, 'ºC'),
	(58589, 109, '2015-02-15 00:47:36.000000', 'temperatura', 807.0000, 'ºC'),
	(58590, 109, '2015-02-15 00:47:37.000000', 'temperatura', 417.0000, 'ºC'),
	(58591, 109, '2015-02-15 00:47:38.000000', 'temperatura', 865.0000, 'ºC'),
	(58592, 109, '2015-02-15 00:47:39.000000', 'temperatura', 672.0000, 'ºC'),
	(58593, 109, '2015-02-15 00:47:40.000000', 'temperatura', 767.0000, 'ºC'),
	(58594, 109, '2015-02-15 00:47:41.000000', 'temperatura', 620.0000, 'ºC'),
	(58595, 109, '2015-02-15 00:47:42.000000', 'temperatura', 800.0000, 'ºC'),
	(58596, 109, '2015-02-15 00:47:43.000000', 'temperatura', 939.0000, 'ºC'),
	(58597, 109, '2015-02-15 00:47:44.000000', 'temperatura', 1094.0000, 'ºC'),
	(58598, 109, '2015-02-15 00:47:45.000000', 'temperatura', 257.0000, 'ºC'),
	(58599, 109, '2015-02-15 00:47:46.000000', 'temperatura', 402.0000, 'ºC'),
	(58600, 109, '2015-02-15 00:47:47.000000', 'temperatura', 38.0000, 'ºC'),
	(58601, 109, '2015-02-15 00:47:48.000000', 'temperatura', 186.0000, 'ºC'),
	(58602, 109, '2015-02-15 00:47:49.000000', 'temperatura', 815.0000, 'ºC'),
	(58603, 109, '2015-02-15 00:47:50.000000', 'temperatura', 1117.0000, 'ºC'),
	(58604, 109, '2015-02-15 00:47:51.000000', 'temperatura', 740.0000, 'ºC'),
	(58605, 109, '2015-02-15 00:47:52.000000', 'temperatura', 352.0000, 'ºC'),
	(58606, 109, '2015-02-15 00:47:53.000000', 'temperatura', 740.0000, 'ºC'),
	(58607, 109, '2015-02-15 00:47:54.000000', 'temperatura', 246.0000, 'ºC'),
	(58608, 109, '2015-02-15 00:47:55.000000', 'temperatura', 210.0000, 'ºC'),
	(58609, 109, '2015-02-15 00:47:56.000000', 'temperatura', 312.0000, 'ºC'),
	(58610, 109, '2015-02-15 00:47:57.000000', 'temperatura', 929.0000, 'ºC'),
	(58611, 109, '2015-02-15 00:47:58.000000', 'temperatura', 111.0000, 'ºC'),
	(58612, 109, '2015-02-15 00:47:59.000000', 'temperatura', 170.0000, 'ºC'),
	(58613, 109, '2015-02-15 00:48:00.000000', 'temperatura', 515.0000, 'ºC'),
	(58614, 109, '2015-02-15 00:48:01.000000', 'temperatura', 868.0000, 'ºC'),
	(58615, 109, '2015-02-15 00:48:02.000000', 'temperatura', 393.0000, 'ºC'),
	(58616, 109, '2015-02-15 00:48:03.000000', 'temperatura', 561.0000, 'ºC'),
	(58617, 109, '2015-02-15 00:48:04.000000', 'temperatura', 429.0000, 'ºC'),
	(58618, 109, '2015-02-15 00:48:05.000000', 'temperatura', 460.0000, 'ºC'),
	(58619, 109, '2015-02-15 00:48:06.000000', 'temperatura', 1016.0000, 'ºC'),
	(58620, 109, '2015-02-15 00:48:07.000000', 'temperatura', 101.0000, 'ºC'),
	(58621, 109, '2015-02-15 00:48:08.000000', 'temperatura', 1055.0000, 'ºC'),
	(58622, 109, '2015-02-15 00:48:09.000000', 'temperatura', 171.0000, 'ºC'),
	(58623, 109, '2015-02-15 00:48:10.000000', 'temperatura', 94.0000, 'ºC'),
	(58624, 109, '2015-02-15 00:48:11.000000', 'temperatura', 1157.0000, 'ºC'),
	(58625, 109, '2015-02-15 00:48:12.000000', 'temperatura', 703.0000, 'ºC'),
	(58626, 109, '2015-02-15 00:48:13.000000', 'temperatura', 43.0000, 'ºC'),
	(58627, 109, '2015-02-15 00:48:14.000000', 'temperatura', 508.0000, 'ºC'),
	(58628, 109, '2015-02-15 00:48:15.000000', 'temperatura', 10.0000, 'ºC'),
	(58629, 109, '2015-02-15 00:48:16.000000', 'temperatura', 926.0000, 'ºC'),
	(58630, 109, '2015-02-15 00:48:17.000000', 'temperatura', 1000.0000, 'ºC'),
	(58631, 109, '2015-02-15 00:48:18.000000', 'temperatura', 1025.0000, 'ºC'),
	(58632, 109, '2015-02-15 00:48:19.000000', 'temperatura', 925.0000, 'ºC'),
	(58633, 109, '2015-02-15 00:48:20.000000', 'temperatura', 349.0000, 'ºC'),
	(58634, 109, '2015-02-15 00:48:21.000000', 'temperatura', 169.0000, 'ºC'),
	(58635, 109, '2015-02-15 00:48:22.000000', 'temperatura', 1001.0000, 'ºC'),
	(58636, 109, '2015-02-15 00:48:23.000000', 'temperatura', 897.0000, 'ºC'),
	(58637, 109, '2015-02-15 00:48:24.000000', 'temperatura', 283.0000, 'ºC'),
	(58638, 109, '2015-02-15 00:48:25.000000', 'temperatura', 1126.0000, 'ºC'),
	(58639, 109, '2015-02-15 00:48:26.000000', 'temperatura', 1181.0000, 'ºC'),
	(58640, 109, '2015-02-15 00:48:27.000000', 'temperatura', 126.0000, 'ºC'),
	(58641, 109, '2015-02-15 00:48:28.000000', 'temperatura', 690.0000, 'ºC'),
	(58642, 109, '2015-02-15 00:48:29.000000', 'temperatura', 673.0000, 'ºC'),
	(58643, 109, '2015-02-15 00:48:30.000000', 'temperatura', 93.0000, 'ºC'),
	(58644, 109, '2015-02-15 00:48:31.000000', 'temperatura', 846.0000, 'ºC'),
	(58645, 109, '2015-02-15 00:48:32.000000', 'temperatura', 353.0000, 'ºC'),
	(58646, 109, '2015-02-15 00:48:33.000000', 'temperatura', 428.0000, 'ºC'),
	(58647, 109, '2015-02-15 00:48:34.000000', 'temperatura', 1083.0000, 'ºC'),
	(58648, 109, '2015-02-15 00:48:35.000000', 'temperatura', 529.0000, 'ºC'),
	(58649, 109, '2015-02-15 00:48:36.000000', 'temperatura', 599.0000, 'ºC'),
	(58650, 109, '2015-02-15 00:48:37.000000', 'temperatura', 207.0000, 'ºC'),
	(58651, 109, '2015-02-15 00:48:38.000000', 'temperatura', 438.0000, 'ºC'),
	(58652, 109, '2015-02-15 00:48:39.000000', 'temperatura', 368.0000, 'ºC'),
	(58653, 109, '2015-02-15 00:48:40.000000', 'temperatura', 528.0000, 'ºC'),
	(58654, 109, '2015-02-15 00:48:41.000000', 'temperatura', 336.0000, 'ºC'),
	(58655, 109, '2015-02-15 00:48:42.000000', 'temperatura', 99.0000, 'ºC'),
	(58656, 109, '2015-02-15 00:48:43.000000', 'temperatura', 685.0000, 'ºC'),
	(58657, 109, '2015-02-15 00:48:44.000000', 'temperatura', 727.0000, 'ºC'),
	(58658, 109, '2015-02-15 00:48:45.000000', 'temperatura', 384.0000, 'ºC'),
	(58659, 109, '2015-02-15 00:48:46.000000', 'temperatura', 937.0000, 'ºC'),
	(58660, 109, '2015-02-15 00:48:47.000000', 'temperatura', 1135.0000, 'ºC'),
	(58661, 109, '2015-02-15 00:48:48.000000', 'temperatura', 463.0000, 'ºC'),
	(58662, 109, '2015-02-15 00:48:49.000000', 'temperatura', 111.0000, 'ºC'),
	(58663, 109, '2015-02-15 00:48:50.000000', 'temperatura', 365.0000, 'ºC'),
	(58664, 109, '2015-02-15 00:48:51.000000', 'temperatura', 293.0000, 'ºC'),
	(58665, 109, '2015-02-15 00:48:52.000000', 'temperatura', 371.0000, 'ºC'),
	(58666, 109, '2015-02-15 00:48:53.000000', 'temperatura', 978.0000, 'ºC'),
	(58667, 109, '2015-02-15 00:48:54.000000', 'temperatura', 178.0000, 'ºC'),
	(58668, 109, '2015-02-15 00:48:55.000000', 'temperatura', 355.0000, 'ºC'),
	(58669, 109, '2015-02-15 00:48:56.000000', 'temperatura', 41.0000, 'ºC'),
	(58670, 109, '2015-02-15 00:48:57.000000', 'temperatura', 343.0000, 'ºC'),
	(58671, 109, '2015-02-15 00:48:58.000000', 'temperatura', 392.0000, 'ºC'),
	(58672, 109, '2015-02-15 00:48:59.000000', 'temperatura', 929.0000, 'ºC'),
	(58673, 109, '2015-02-15 00:49:00.000000', 'temperatura', 1072.0000, 'ºC'),
	(58674, 109, '2015-02-15 00:49:01.000000', 'temperatura', 171.0000, 'ºC'),
	(58675, 109, '2015-02-15 00:49:02.000000', 'temperatura', 41.0000, 'ºC'),
	(58676, 109, '2015-02-15 00:49:03.000000', 'temperatura', 892.0000, 'ºC'),
	(58677, 109, '2015-02-15 00:49:04.000000', 'temperatura', 737.0000, 'ºC'),
	(58678, 109, '2015-02-15 00:49:05.000000', 'temperatura', 1010.0000, 'ºC'),
	(58679, 109, '2015-02-15 00:49:06.000000', 'temperatura', 441.0000, 'ºC'),
	(58680, 109, '2015-02-15 00:49:07.000000', 'temperatura', 376.0000, 'ºC'),
	(58681, 109, '2015-02-15 00:49:08.000000', 'temperatura', 554.0000, 'ºC'),
	(58682, 109, '2015-02-15 00:49:09.000000', 'temperatura', 446.0000, 'ºC'),
	(58683, 109, '2015-02-15 00:49:10.000000', 'temperatura', 566.0000, 'ºC'),
	(58684, 109, '2015-02-15 00:49:11.000000', 'temperatura', 292.0000, 'ºC'),
	(58685, 109, '2015-02-15 00:49:12.000000', 'temperatura', 962.0000, 'ºC'),
	(58686, 109, '2015-02-15 00:49:13.000000', 'temperatura', 336.0000, 'ºC'),
	(58687, 109, '2015-02-15 00:49:14.000000', 'temperatura', 1194.0000, 'ºC'),
	(58688, 109, '2015-02-15 00:49:15.000000', 'temperatura', 161.0000, 'ºC'),
	(58689, 109, '2015-02-15 00:49:16.000000', 'temperatura', 827.0000, 'ºC'),
	(58690, 109, '2015-02-15 00:49:17.000000', 'temperatura', 50.0000, 'ºC'),
	(58691, 109, '2015-02-15 00:49:18.000000', 'temperatura', 169.0000, 'ºC'),
	(58692, 109, '2015-02-15 00:49:19.000000', 'temperatura', 697.0000, 'ºC'),
	(58693, 109, '2015-02-15 00:49:20.000000', 'temperatura', 578.0000, 'ºC'),
	(58694, 109, '2015-02-15 00:49:21.000000', 'temperatura', 799.0000, 'ºC'),
	(58695, 109, '2015-02-15 00:49:22.000000', 'temperatura', 1060.0000, 'ºC'),
	(58696, 109, '2015-02-15 00:49:23.000000', 'temperatura', 506.0000, 'ºC'),
	(58697, 109, '2015-02-15 00:49:24.000000', 'temperatura', 548.0000, 'ºC'),
	(58698, 109, '2015-02-15 00:49:25.000000', 'temperatura', 24.0000, 'ºC'),
	(58699, 109, '2015-02-15 00:49:26.000000', 'temperatura', 876.0000, 'ºC'),
	(58700, 109, '2015-02-15 00:49:27.000000', 'temperatura', 710.0000, 'ºC'),
	(58701, 109, '2015-02-15 00:49:28.000000', 'temperatura', 920.0000, 'ºC'),
	(58702, 109, '2015-02-15 00:49:29.000000', 'temperatura', 73.0000, 'ºC'),
	(58703, 109, '2015-02-15 00:49:30.000000', 'temperatura', 2.0000, 'ºC'),
	(58704, 109, '2015-02-15 00:49:31.000000', 'temperatura', 995.0000, 'ºC'),
	(58705, 109, '2015-02-15 00:49:32.000000', 'temperatura', 168.0000, 'ºC'),
	(58706, 109, '2015-02-15 00:49:33.000000', 'temperatura', 255.0000, 'ºC'),
	(58707, 109, '2015-02-15 00:49:34.000000', 'temperatura', 773.0000, 'ºC'),
	(58708, 109, '2015-02-15 00:49:35.000000', 'temperatura', 701.0000, 'ºC'),
	(58709, 109, '2015-02-15 00:49:36.000000', 'temperatura', 1186.0000, 'ºC'),
	(58710, 109, '2015-02-15 00:49:37.000000', 'temperatura', 228.0000, 'ºC'),
	(58711, 109, '2015-02-15 00:49:38.000000', 'temperatura', 1183.0000, 'ºC'),
	(58712, 109, '2015-02-15 00:49:39.000000', 'temperatura', 432.0000, 'ºC'),
	(58713, 109, '2015-02-15 00:49:40.000000', 'temperatura', 1010.0000, 'ºC'),
	(58714, 109, '2015-02-15 00:49:41.000000', 'temperatura', 157.0000, 'ºC'),
	(58715, 109, '2015-02-15 00:49:42.000000', 'temperatura', 152.0000, 'ºC'),
	(58716, 109, '2015-02-15 00:49:43.000000', 'temperatura', 291.0000, 'ºC'),
	(58717, 109, '2015-02-15 00:49:44.000000', 'temperatura', 1001.0000, 'ºC'),
	(58718, 109, '2015-02-15 00:49:45.000000', 'temperatura', 532.0000, 'ºC'),
	(58719, 109, '2015-02-15 00:49:46.000000', 'temperatura', 857.0000, 'ºC'),
	(58720, 109, '2015-02-15 00:49:47.000000', 'temperatura', 288.0000, 'ºC'),
	(58721, 109, '2015-02-15 00:49:48.000000', 'temperatura', 72.0000, 'ºC'),
	(58722, 109, '2015-02-15 00:49:49.000000', 'temperatura', 696.0000, 'ºC'),
	(58723, 109, '2015-02-15 00:49:50.000000', 'temperatura', 866.0000, 'ºC'),
	(58724, 109, '2015-02-15 00:49:51.000000', 'temperatura', 1042.0000, 'ºC'),
	(58725, 109, '2015-02-15 00:49:52.000000', 'temperatura', 212.0000, 'ºC'),
	(58726, 109, '2015-02-15 00:49:53.000000', 'temperatura', 336.0000, 'ºC'),
	(58727, 109, '2015-02-15 00:49:54.000000', 'temperatura', 1041.0000, 'ºC'),
	(58728, 109, '2015-02-15 00:49:55.000000', 'temperatura', 601.0000, 'ºC'),
	(58729, 109, '2015-02-15 00:49:56.000000', 'temperatura', 1081.0000, 'ºC'),
	(58730, 109, '2015-02-15 00:49:57.000000', 'temperatura', 1.0000, 'ºC'),
	(58731, 109, '2015-02-15 00:49:58.000000', 'temperatura', 364.0000, 'ºC'),
	(58732, 109, '2015-02-15 00:49:59.000000', 'temperatura', 618.0000, 'ºC'),
	(58733, 109, '2015-02-15 00:50:00.000000', 'temperatura', 797.0000, 'ºC'),
	(58734, 109, '2015-02-15 00:50:01.000000', 'temperatura', 932.0000, 'ºC'),
	(58735, 109, '2015-02-15 00:50:02.000000', 'temperatura', 1071.0000, 'ºC'),
	(58736, 109, '2015-02-15 00:50:03.000000', 'temperatura', 160.0000, 'ºC'),
	(58737, 109, '2015-02-15 00:50:04.000000', 'temperatura', 1185.0000, 'ºC'),
	(58738, 109, '2015-02-15 00:50:05.000000', 'temperatura', 647.0000, 'ºC'),
	(58739, 109, '2015-02-15 00:50:06.000000', 'temperatura', 880.0000, 'ºC'),
	(58740, 109, '2015-02-15 00:50:07.000000', 'temperatura', 59.0000, 'ºC'),
	(58741, 109, '2015-02-15 00:50:08.000000', 'temperatura', 54.0000, 'ºC'),
	(58742, 109, '2015-02-15 00:50:09.000000', 'temperatura', 95.0000, 'ºC'),
	(58743, 109, '2015-02-15 00:50:10.000000', 'temperatura', 312.0000, 'ºC'),
	(58744, 109, '2015-02-15 00:50:11.000000', 'temperatura', 75.0000, 'ºC'),
	(58745, 109, '2015-02-15 00:50:12.000000', 'temperatura', 641.0000, 'ºC'),
	(58746, 109, '2015-02-15 00:50:13.000000', 'temperatura', 581.0000, 'ºC'),
	(58747, 109, '2015-02-15 00:50:14.000000', 'temperatura', 982.0000, 'ºC'),
	(58748, 109, '2015-02-15 00:50:15.000000', 'temperatura', 770.0000, 'ºC'),
	(58749, 109, '2015-02-15 00:50:16.000000', 'temperatura', 901.0000, 'ºC'),
	(58750, 109, '2015-02-15 00:50:17.000000', 'temperatura', 996.0000, 'ºC'),
	(58751, 109, '2015-02-15 00:50:18.000000', 'temperatura', 1078.0000, 'ºC'),
	(58752, 109, '2015-02-15 00:50:19.000000', 'temperatura', 1.0000, 'ºC'),
	(58753, 109, '2015-02-15 00:50:20.000000', 'temperatura', 370.0000, 'ºC'),
	(58754, 109, '2015-02-15 00:50:21.000000', 'temperatura', 651.0000, 'ºC'),
	(58755, 109, '2015-02-15 00:50:22.000000', 'temperatura', 946.0000, 'ºC'),
	(58756, 109, '2015-02-15 00:50:23.000000', 'temperatura', 376.0000, 'ºC'),
	(58757, 109, '2015-02-15 00:50:24.000000', 'temperatura', 244.0000, 'ºC'),
	(58758, 109, '2015-02-15 00:50:25.000000', 'temperatura', 89.0000, 'ºC'),
	(58759, 109, '2015-02-15 00:50:26.000000', 'temperatura', 917.0000, 'ºC'),
	(58760, 109, '2015-02-15 00:50:27.000000', 'temperatura', 719.0000, 'ºC'),
	(58761, 109, '2015-02-15 00:50:28.000000', 'temperatura', 844.0000, 'ºC'),
	(58762, 109, '2015-02-15 00:50:29.000000', 'temperatura', 864.0000, 'ºC'),
	(58763, 109, '2015-02-15 00:50:30.000000', 'temperatura', 587.0000, 'ºC'),
	(58764, 109, '2015-02-15 00:50:31.000000', 'temperatura', 343.0000, 'ºC'),
	(58765, 109, '2015-02-15 00:50:32.000000', 'temperatura', 1156.0000, 'ºC'),
	(58766, 109, '2015-02-15 00:50:33.000000', 'temperatura', 1153.0000, 'ºC'),
	(58767, 109, '2015-02-15 00:50:34.000000', 'temperatura', 1095.0000, 'ºC'),
	(58768, 109, '2015-02-15 00:50:35.000000', 'temperatura', 815.0000, 'ºC'),
	(58769, 109, '2015-02-15 00:50:36.000000', 'temperatura', 793.0000, 'ºC'),
	(58770, 109, '2015-02-15 00:50:37.000000', 'temperatura', 322.0000, 'ºC'),
	(58771, 109, '2015-02-15 00:50:38.000000', 'temperatura', 428.0000, 'ºC'),
	(58772, 109, '2015-02-15 00:50:39.000000', 'temperatura', 1176.0000, 'ºC'),
	(58773, 109, '2015-02-15 00:50:40.000000', 'temperatura', 997.0000, 'ºC'),
	(58774, 109, '2015-02-15 00:50:41.000000', 'temperatura', 256.0000, 'ºC'),
	(58775, 109, '2015-02-15 00:50:42.000000', 'temperatura', 688.0000, 'ºC'),
	(58776, 109, '2015-02-15 00:50:43.000000', 'temperatura', 276.0000, 'ºC'),
	(58777, 109, '2015-02-15 00:50:44.000000', 'temperatura', 514.0000, 'ºC'),
	(58778, 109, '2015-02-15 00:50:45.000000', 'temperatura', 543.0000, 'ºC'),
	(58779, 109, '2015-02-15 00:50:46.000000', 'temperatura', 1176.0000, 'ºC'),
	(58780, 109, '2015-02-15 00:50:47.000000', 'temperatura', 649.0000, 'ºC'),
	(58781, 109, '2015-02-15 00:50:48.000000', 'temperatura', 917.0000, 'ºC'),
	(58782, 109, '2015-02-15 00:50:49.000000', 'temperatura', 241.0000, 'ºC'),
	(58783, 109, '2015-02-15 00:50:50.000000', 'temperatura', 851.0000, 'ºC'),
	(58784, 109, '2015-02-15 00:50:51.000000', 'temperatura', 1136.0000, 'ºC'),
	(58785, 109, '2015-02-15 00:50:52.000000', 'temperatura', 727.0000, 'ºC'),
	(58786, 109, '2015-02-15 00:50:53.000000', 'temperatura', 227.0000, 'ºC'),
	(58787, 109, '2015-02-15 00:50:54.000000', 'temperatura', 156.0000, 'ºC'),
	(58788, 109, '2015-02-15 00:50:55.000000', 'temperatura', 98.0000, 'ºC'),
	(58789, 109, '2015-02-15 00:50:56.000000', 'temperatura', 24.0000, 'ºC'),
	(58790, 109, '2015-02-15 00:50:57.000000', 'temperatura', 1027.0000, 'ºC'),
	(58791, 109, '2015-02-15 00:50:58.000000', 'temperatura', 262.0000, 'ºC'),
	(58792, 109, '2015-02-15 00:50:59.000000', 'temperatura', 628.0000, 'ºC'),
	(58793, 109, '2015-02-15 00:51:00.000000', 'temperatura', 1156.0000, 'ºC'),
	(58794, 109, '2015-02-15 00:51:01.000000', 'temperatura', 297.0000, 'ºC'),
	(58795, 109, '2015-02-15 00:51:02.000000', 'temperatura', 418.0000, 'ºC'),
	(58796, 109, '2015-02-15 00:51:03.000000', 'temperatura', 1.0000, 'ºC'),
	(58797, 109, '2015-02-15 00:51:04.000000', 'temperatura', 1148.0000, 'ºC'),
	(58798, 109, '2015-02-15 00:51:05.000000', 'temperatura', 940.0000, 'ºC'),
	(58799, 109, '2015-02-15 00:51:06.000000', 'temperatura', 56.0000, 'ºC'),
	(58800, 109, '2015-02-15 00:51:07.000000', 'temperatura', 1062.0000, 'ºC'),
	(58801, 109, '2015-02-15 00:51:08.000000', 'temperatura', 339.0000, 'ºC'),
	(58802, 109, '2015-02-15 00:51:09.000000', 'temperatura', 912.0000, 'ºC'),
	(58803, 109, '2015-02-15 00:51:10.000000', 'temperatura', 1145.0000, 'ºC'),
	(58804, 109, '2015-02-15 00:51:11.000000', 'temperatura', 587.0000, 'ºC'),
	(58805, 109, '2015-02-15 00:51:12.000000', 'temperatura', 700.0000, 'ºC'),
	(58806, 109, '2015-02-15 00:51:13.000000', 'temperatura', 541.0000, 'ºC'),
	(58807, 109, '2015-02-15 00:51:14.000000', 'temperatura', 605.0000, 'ºC'),
	(58808, 109, '2015-02-15 00:51:15.000000', 'temperatura', 201.0000, 'ºC'),
	(58809, 109, '2015-02-15 00:51:16.000000', 'temperatura', 393.0000, 'ºC'),
	(58810, 109, '2015-02-15 00:51:17.000000', 'temperatura', 162.0000, 'ºC'),
	(58811, 109, '2015-02-15 00:51:18.000000', 'temperatura', 833.0000, 'ºC'),
	(58812, 109, '2015-02-15 00:51:19.000000', 'temperatura', 77.0000, 'ºC'),
	(58813, 109, '2015-02-15 00:51:20.000000', 'temperatura', 286.0000, 'ºC'),
	(58814, 109, '2015-02-15 00:51:21.000000', 'temperatura', 1.0000, 'ºC'),
	(58815, 109, '2015-02-15 00:51:22.000000', 'temperatura', 349.0000, 'ºC'),
	(58816, 109, '2015-02-15 00:51:23.000000', 'temperatura', 542.0000, 'ºC'),
	(58817, 109, '2015-02-15 00:51:24.000000', 'temperatura', 461.0000, 'ºC'),
	(58818, 109, '2015-02-15 00:51:25.000000', 'temperatura', 683.0000, 'ºC'),
	(58819, 109, '2015-02-15 00:51:26.000000', 'temperatura', 830.0000, 'ºC'),
	(58820, 109, '2015-02-15 00:51:27.000000', 'temperatura', 902.0000, 'ºC'),
	(58821, 109, '2015-02-15 00:51:28.000000', 'temperatura', 819.0000, 'ºC'),
	(58822, 109, '2015-02-15 00:51:29.000000', 'temperatura', 191.0000, 'ºC'),
	(58823, 109, '2015-02-15 00:51:30.000000', 'temperatura', 899.0000, 'ºC'),
	(58824, 109, '2015-02-15 00:51:31.000000', 'temperatura', 323.0000, 'ºC'),
	(58825, 109, '2015-02-15 00:51:32.000000', 'temperatura', 118.0000, 'ºC'),
	(58826, 109, '2015-02-15 00:51:33.000000', 'temperatura', 820.0000, 'ºC'),
	(58827, 109, '2015-02-15 00:51:34.000000', 'temperatura', 147.0000, 'ºC'),
	(58828, 109, '2015-02-15 00:51:35.000000', 'temperatura', 677.0000, 'ºC'),
	(58829, 109, '2015-02-15 00:51:36.000000', 'temperatura', 543.0000, 'ºC'),
	(58830, 109, '2015-02-15 00:51:37.000000', 'temperatura', 685.0000, 'ºC'),
	(58831, 109, '2015-02-15 00:51:38.000000', 'temperatura', 596.0000, 'ºC'),
	(58832, 109, '2015-02-15 00:51:39.000000', 'temperatura', 926.0000, 'ºC'),
	(58833, 109, '2015-02-15 00:51:40.000000', 'temperatura', 443.0000, 'ºC'),
	(58834, 109, '2015-02-15 00:51:41.000000', 'temperatura', 636.0000, 'ºC'),
	(58835, 109, '2015-02-15 00:51:42.000000', 'temperatura', 650.0000, 'ºC'),
	(58836, 109, '2015-02-15 00:51:43.000000', 'temperatura', 146.0000, 'ºC'),
	(58837, 109, '2015-02-15 00:51:44.000000', 'temperatura', 1178.0000, 'ºC'),
	(58838, 109, '2015-02-15 00:51:45.000000', 'temperatura', 654.0000, 'ºC'),
	(58839, 109, '2015-02-15 00:51:46.000000', 'temperatura', 935.0000, 'ºC'),
	(58840, 109, '2015-02-15 00:51:47.000000', 'temperatura', 312.0000, 'ºC'),
	(58841, 109, '2015-02-15 00:51:48.000000', 'temperatura', 1157.0000, 'ºC'),
	(58842, 109, '2015-02-15 00:51:49.000000', 'temperatura', 51.0000, 'ºC'),
	(58843, 109, '2015-02-15 00:51:50.000000', 'temperatura', 383.0000, 'ºC'),
	(58844, 109, '2015-02-15 00:51:51.000000', 'temperatura', 564.0000, 'ºC'),
	(58845, 109, '2015-02-15 00:51:52.000000', 'temperatura', 469.0000, 'ºC'),
	(58846, 109, '2015-02-15 00:51:53.000000', 'temperatura', 655.0000, 'ºC'),
	(58847, 109, '2015-02-15 00:51:54.000000', 'temperatura', 666.0000, 'ºC'),
	(58848, 109, '2015-02-15 00:51:55.000000', 'temperatura', 169.0000, 'ºC'),
	(58849, 109, '2015-02-15 00:51:56.000000', 'temperatura', 45.0000, 'ºC'),
	(58850, 109, '2015-02-15 00:51:57.000000', 'temperatura', 920.0000, 'ºC'),
	(58851, 109, '2015-02-15 00:51:58.000000', 'temperatura', 863.0000, 'ºC'),
	(58852, 109, '2015-02-15 00:51:59.000000', 'temperatura', 359.0000, 'ºC'),
	(58853, 109, '2015-02-15 00:52:00.000000', 'temperatura', 404.0000, 'ºC'),
	(58854, 109, '2015-02-15 00:52:01.000000', 'temperatura', 942.0000, 'ºC'),
	(58855, 109, '2015-02-15 00:52:02.000000', 'temperatura', 1100.0000, 'ºC'),
	(58856, 109, '2015-02-15 00:52:03.000000', 'temperatura', 276.0000, 'ºC'),
	(58857, 109, '2015-02-15 00:52:04.000000', 'temperatura', 481.0000, 'ºC'),
	(58858, 109, '2015-02-15 00:52:05.000000', 'temperatura', 377.0000, 'ºC'),
	(58859, 109, '2015-02-15 00:52:06.000000', 'temperatura', 442.0000, 'ºC'),
	(58860, 109, '2015-02-15 00:52:07.000000', 'temperatura', 1079.0000, 'ºC'),
	(58861, 109, '2015-02-15 00:52:08.000000', 'temperatura', 471.0000, 'ºC'),
	(58862, 109, '2015-02-15 00:52:09.000000', 'temperatura', 318.0000, 'ºC'),
	(58863, 109, '2015-02-15 00:52:10.000000', 'temperatura', 179.0000, 'ºC'),
	(58864, 109, '2015-02-15 00:52:11.000000', 'temperatura', 1139.0000, 'ºC'),
	(58865, 109, '2015-02-15 00:52:12.000000', 'temperatura', 361.0000, 'ºC'),
	(58866, 109, '2015-02-15 00:52:13.000000', 'temperatura', 787.0000, 'ºC'),
	(58867, 109, '2015-02-15 00:52:14.000000', 'temperatura', 454.0000, 'ºC'),
	(58868, 109, '2015-02-15 00:52:15.000000', 'temperatura', 1108.0000, 'ºC'),
	(58869, 109, '2015-02-15 00:52:16.000000', 'temperatura', 578.0000, 'ºC'),
	(58870, 109, '2015-02-15 00:52:17.000000', 'temperatura', 767.0000, 'ºC'),
	(58871, 109, '2015-02-15 00:52:18.000000', 'temperatura', 900.0000, 'ºC'),
	(58872, 109, '2015-02-15 00:52:19.000000', 'temperatura', 1001.0000, 'ºC'),
	(58873, 109, '2015-02-15 00:52:20.000000', 'temperatura', 1106.0000, 'ºC'),
	(58874, 109, '2015-02-15 00:52:21.000000', 'temperatura', 127.0000, 'ºC'),
	(58875, 109, '2015-02-15 00:52:22.000000', 'temperatura', 918.0000, 'ºC'),
	(58876, 109, '2015-02-15 00:52:23.000000', 'temperatura', 611.0000, 'ºC'),
	(58877, 109, '2015-02-15 00:52:24.000000', 'temperatura', 300.0000, 'ºC'),
	(58878, 109, '2015-02-15 00:52:25.000000', 'temperatura', 868.0000, 'ºC'),
	(58879, 109, '2015-02-15 00:52:26.000000', 'temperatura', 1038.0000, 'ºC'),
	(58880, 109, '2015-02-15 00:52:27.000000', 'temperatura', 189.0000, 'ºC'),
	(58881, 109, '2015-02-15 00:52:28.000000', 'temperatura', 232.0000, 'ºC'),
	(58882, 109, '2015-02-15 00:52:29.000000', 'temperatura', 591.0000, 'ºC'),
	(58883, 109, '2015-02-15 00:52:30.000000', 'temperatura', 1060.0000, 'ºC'),
	(58884, 109, '2015-02-15 00:52:31.000000', 'temperatura', 1130.0000, 'ºC'),
	(58885, 109, '2015-02-15 00:52:32.000000', 'temperatura', 68.0000, 'ºC'),
	(58886, 109, '2015-02-15 00:52:33.000000', 'temperatura', 549.0000, 'ºC'),
	(58887, 109, '2015-02-15 00:52:34.000000', 'temperatura', 144.0000, 'ºC'),
	(58888, 109, '2015-02-15 00:52:35.000000', 'temperatura', 275.0000, 'ºC'),
	(58889, 109, '2015-02-15 00:52:36.000000', 'temperatura', 941.0000, 'ºC'),
	(58890, 109, '2015-02-15 00:52:37.000000', 'temperatura', 282.0000, 'ºC'),
	(58891, 109, '2015-02-15 00:52:38.000000', 'temperatura', 989.0000, 'ºC'),
	(58892, 109, '2015-02-15 00:52:39.000000', 'temperatura', 498.0000, 'ºC'),
	(58893, 109, '2015-02-15 00:52:40.000000', 'temperatura', 725.0000, 'ºC'),
	(58894, 109, '2015-02-15 00:52:41.000000', 'temperatura', 931.0000, 'ºC'),
	(58895, 109, '2015-02-15 00:52:42.000000', 'temperatura', 79.0000, 'ºC'),
	(58896, 109, '2015-02-15 00:52:43.000000', 'temperatura', 2.0000, 'ºC'),
	(58897, 109, '2015-02-15 00:52:44.000000', 'temperatura', 976.0000, 'ºC'),
	(58898, 109, '2015-02-15 00:52:45.000000', 'temperatura', 75.0000, 'ºC'),
	(58899, 109, '2015-02-15 00:52:46.000000', 'temperatura', 1046.0000, 'ºC'),
	(58900, 109, '2015-02-15 00:52:47.000000', 'temperatura', 205.0000, 'ºC'),
	(58901, 109, '2015-02-15 00:52:48.000000', 'temperatura', 286.0000, 'ºC'),
	(58902, 109, '2015-02-15 00:52:49.000000', 'temperatura', 817.0000, 'ºC'),
	(58903, 109, '2015-02-15 00:52:50.000000', 'temperatura', 826.0000, 'ºC'),
	(58904, 109, '2015-02-15 00:52:51.000000', 'temperatura', 479.0000, 'ºC'),
	(58905, 109, '2015-02-15 00:52:52.000000', 'temperatura', 1120.0000, 'ºC'),
	(58906, 109, '2015-02-15 00:52:53.000000', 'temperatura', 563.0000, 'ºC'),
	(58907, 109, '2015-02-15 00:52:54.000000', 'temperatura', 656.0000, 'ºC'),
	(58908, 109, '2015-02-15 00:52:55.000000', 'temperatura', 390.0000, 'ºC'),
	(58909, 109, '2015-02-15 00:52:56.000000', 'temperatura', 1182.0000, 'ºC'),
	(58910, 109, '2015-02-15 00:52:57.000000', 'temperatura', 1140.0000, 'ºC'),
	(58911, 109, '2015-02-15 00:52:58.000000', 'temperatura', 957.0000, 'ºC'),
	(58912, 109, '2015-02-15 00:52:59.000000', 'temperatura', 166.0000, 'ºC'),
	(58913, 110, '2015-02-15 00:00:00.000000', 'temperatura', 88.0000, 'ºC'),
	(58914, 110, '2015-02-15 00:00:01.000000', 'temperatura', 572.0000, 'ºC'),
	(58915, 110, '2015-02-15 00:00:02.000000', 'temperatura', 194.0000, 'ºC'),
	(58916, 110, '2015-02-15 00:00:03.000000', 'temperatura', 456.0000, 'ºC'),
	(58917, 110, '2015-02-15 00:00:04.000000', 'temperatura', 499.0000, 'ºC'),
	(58918, 110, '2015-02-15 00:00:05.000000', 'temperatura', 1126.0000, 'ºC'),
	(58919, 110, '2015-02-15 00:00:06.000000', 'temperatura', 534.0000, 'ºC'),
	(58920, 110, '2015-02-15 00:00:07.000000', 'temperatura', 491.0000, 'ºC'),
	(58921, 110, '2015-02-15 00:00:08.000000', 'temperatura', 853.0000, 'ºC'),
	(58922, 110, '2015-02-15 00:00:09.000000', 'temperatura', 395.0000, 'ºC'),
	(58923, 110, '2015-02-15 00:00:10.000000', 'temperatura', 616.0000, 'ºC'),
	(58924, 110, '2015-02-15 00:00:11.000000', 'temperatura', 696.0000, 'ºC'),
	(58925, 110, '2015-02-15 00:00:12.000000', 'temperatura', 434.0000, 'ºC'),
	(58926, 110, '2015-02-15 00:00:13.000000', 'temperatura', 81.0000, 'ºC'),
	(58927, 110, '2015-02-15 00:00:14.000000', 'temperatura', 303.0000, 'ºC'),
	(58928, 110, '2015-02-15 00:00:15.000000', 'temperatura', 72.0000, 'ºC'),
	(58929, 110, '2015-02-15 00:00:16.000000', 'temperatura', 654.0000, 'ºC'),
	(58930, 110, '2015-02-15 00:00:17.000000', 'temperatura', 652.0000, 'ºC'),
	(58931, 110, '2015-02-15 00:00:18.000000', 'temperatura', 98.0000, 'ºC'),
	(58932, 110, '2015-02-15 00:00:19.000000', 'temperatura', 933.0000, 'ºC'),
	(58933, 110, '2015-02-15 00:00:20.000000', 'temperatura', 775.0000, 'ºC'),
	(58934, 110, '2015-02-15 00:00:21.000000', 'temperatura', 1074.0000, 'ºC'),
	(58935, 110, '2015-02-15 00:00:22.000000', 'temperatura', 648.0000, 'ºC'),
	(58936, 110, '2015-02-15 00:00:23.000000', 'temperatura', 15.0000, 'ºC'),
	(58937, 110, '2015-02-15 00:00:24.000000', 'temperatura', 535.0000, 'ºC'),
	(58938, 110, '2015-02-15 00:00:25.000000', 'temperatura', 230.0000, 'ºC'),
	(58939, 110, '2015-02-15 00:00:26.000000', 'temperatura', 745.0000, 'ºC'),
	(58940, 110, '2015-02-15 00:00:27.000000', 'temperatura', 636.0000, 'ºC'),
	(58941, 110, '2015-02-15 00:00:28.000000', 'temperatura', 946.0000, 'ºC'),
	(58942, 110, '2015-02-15 00:00:29.000000', 'temperatura', 421.0000, 'ºC'),
	(58943, 110, '2015-02-15 00:00:30.000000', 'temperatura', 467.0000, 'ºC'),
	(58944, 110, '2015-02-15 00:00:31.000000', 'temperatura', 1074.0000, 'ºC'),
	(58945, 110, '2015-02-15 00:00:32.000000', 'temperatura', 367.0000, 'ºC'),
	(58946, 110, '2015-02-15 00:00:33.000000', 'temperatura', 1016.0000, 'ºC'),
	(58947, 110, '2015-02-15 00:00:34.000000', 'temperatura', 380.0000, 'ºC'),
	(58948, 110, '2015-02-15 00:00:35.000000', 'temperatura', 53.0000, 'ºC'),
	(58949, 110, '2015-02-15 00:00:36.000000', 'temperatura', 325.0000, 'ºC'),
	(58950, 110, '2015-02-15 00:00:37.000000', 'temperatura', 268.0000, 'ºC'),
	(58951, 110, '2015-02-15 00:00:38.000000', 'temperatura', 364.0000, 'ºC'),
	(58952, 110, '2015-02-15 00:00:39.000000', 'temperatura', 1017.0000, 'ºC'),
	(58953, 110, '2015-02-15 00:00:40.000000', 'temperatura', 394.0000, 'ºC'),
	(58954, 110, '2015-02-15 00:00:41.000000', 'temperatura', 120.0000, 'ºC'),
	(58955, 110, '2015-02-15 00:00:42.000000', 'temperatura', 616.0000, 'ºC'),
	(58956, 110, '2015-02-15 00:00:43.000000', 'temperatura', 322.0000, 'ºC'),
	(58957, 110, '2015-02-15 00:00:44.000000', 'temperatura', 962.0000, 'ºC'),
	(58958, 110, '2015-02-15 00:00:45.000000', 'temperatura', 243.0000, 'ºC'),
	(58959, 110, '2015-02-15 00:00:46.000000', 'temperatura', 729.0000, 'ºC'),
	(58960, 110, '2015-02-15 00:00:47.000000', 'temperatura', 517.0000, 'ºC'),
	(58961, 110, '2015-02-15 00:00:48.000000', 'temperatura', 400.0000, 'ºC'),
	(58962, 110, '2015-02-15 00:00:49.000000', 'temperatura', 448.0000, 'ºC'),
	(58963, 110, '2015-02-15 00:00:50.000000', 'temperatura', 1040.0000, 'ºC'),
	(58964, 110, '2015-02-15 00:00:51.000000', 'temperatura', 255.0000, 'ºC'),
	(58965, 110, '2015-02-15 00:00:52.000000', 'temperatura', 559.0000, 'ºC'),
	(58966, 110, '2015-02-15 00:00:53.000000', 'temperatura', 828.0000, 'ºC'),
	(58967, 110, '2015-02-15 00:00:54.000000', 'temperatura', 65.0000, 'ºC'),
	(58968, 110, '2015-02-15 00:00:55.000000', 'temperatura', 242.0000, 'ºC'),
	(58969, 110, '2015-02-15 00:00:56.000000', 'temperatura', 1015.0000, 'ºC'),
	(58970, 110, '2015-02-15 00:00:57.000000', 'temperatura', 750.0000, 'ºC'),
	(58971, 110, '2015-02-15 00:00:58.000000', 'temperatura', 704.0000, 'ºC'),
	(58972, 110, '2015-02-15 00:00:59.000000', 'temperatura', 72.0000, 'ºC'),
	(58973, 110, '2015-02-15 00:01:00.000000', 'temperatura', 650.0000, 'ºC'),
	(58974, 110, '2015-02-15 00:01:01.000000', 'temperatura', 633.0000, 'ºC'),
	(58975, 110, '2015-02-15 00:01:02.000000', 'temperatura', 14.0000, 'ºC'),
	(58976, 110, '2015-02-15 00:01:03.000000', 'temperatura', 573.0000, 'ºC'),
	(58977, 110, '2015-02-15 00:01:04.000000', 'temperatura', 425.0000, 'ºC'),
	(58978, 110, '2015-02-15 00:01:05.000000', 'temperatura', 406.0000, 'ºC'),
	(58979, 110, '2015-02-15 00:01:06.000000', 'temperatura', 753.0000, 'ºC'),
	(58980, 110, '2015-02-15 00:01:07.000000', 'temperatura', 151.0000, 'ºC'),
	(58981, 110, '2015-02-15 00:01:08.000000', 'temperatura', 894.0000, 'ºC'),
	(58982, 110, '2015-02-15 00:01:09.000000', 'temperatura', 419.0000, 'ºC'),
	(58983, 110, '2015-02-15 00:01:10.000000', 'temperatura', 613.0000, 'ºC'),
	(58984, 110, '2015-02-15 00:01:11.000000', 'temperatura', 609.0000, 'ºC'),
	(58985, 110, '2015-02-15 00:01:12.000000', 'temperatura', 7.0000, 'ºC'),
	(58986, 110, '2015-02-15 00:01:13.000000', 'temperatura', 608.0000, 'ºC'),
	(58987, 110, '2015-02-15 00:01:14.000000', 'temperatura', 619.0000, 'ºC'),
	(58988, 110, '2015-02-15 00:01:15.000000', 'temperatura', 71.0000, 'ºC'),
	(58989, 110, '2015-02-15 00:01:16.000000', 'temperatura', 899.0000, 'ºC'),
	(58990, 110, '2015-02-15 00:01:17.000000', 'temperatura', 683.0000, 'ºC'),
	(58991, 110, '2015-02-15 00:01:18.000000', 'temperatura', 717.0000, 'ºC'),
	(58992, 110, '2015-02-15 00:01:19.000000', 'temperatura', 336.0000, 'ºC'),
	(58993, 110, '2015-02-15 00:01:20.000000', 'temperatura', 729.0000, 'ºC'),
	(58994, 110, '2015-02-15 00:01:21.000000', 'temperatura', 239.0000, 'ºC'),
	(58995, 110, '2015-02-15 00:01:22.000000', 'temperatura', 207.0000, 'ºC'),
	(58996, 110, '2015-02-15 00:01:23.000000', 'temperatura', 320.0000, 'ºC'),
	(58997, 110, '2015-02-15 00:01:24.000000', 'temperatura', 979.0000, 'ºC'),
	(58998, 110, '2015-02-15 00:01:25.000000', 'temperatura', 335.0000, 'ºC'),
	(58999, 110, '2015-02-15 00:01:26.000000', 'temperatura', 1137.0000, 'ºC'),
	(59000, 110, '2015-02-15 00:01:27.000000', 'temperatura', 1081.0000, 'ºC'),
	(59001, 110, '2015-02-15 00:01:28.000000', 'temperatura', 793.0000, 'ºC'),
	(59002, 110, '2015-02-15 00:01:29.000000', 'temperatura', 724.0000, 'ºC'),
	(59003, 110, '2015-02-15 00:01:30.000000', 'temperatura', 42.0000, 'ºC'),
	(59004, 110, '2015-02-15 00:01:31.000000', 'temperatura', 438.0000, 'ºC'),
	(59005, 110, '2015-02-15 00:01:32.000000', 'temperatura', 867.0000, 'ºC'),
	(59006, 110, '2015-02-15 00:01:33.000000', 'temperatura', 618.0000, 'ºC'),
	(59007, 110, '2015-02-15 00:01:34.000000', 'temperatura', 491.0000, 'ºC'),
	(59008, 110, '2015-02-15 00:01:35.000000', 'temperatura', 603.0000, 'ºC'),
	(59009, 110, '2015-02-15 00:01:36.000000', 'temperatura', 339.0000, 'ºC'),
	(59010, 110, '2015-02-15 00:01:37.000000', 'temperatura', 1090.0000, 'ºC'),
	(59011, 110, '2015-02-15 00:01:38.000000', 'temperatura', 833.0000, 'ºC'),
	(59012, 110, '2015-02-15 00:01:39.000000', 'temperatura', 896.0000, 'ºC'),
	(59013, 110, '2015-02-15 00:01:40.000000', 'temperatura', 779.0000, 'ºC'),
	(59014, 110, '2015-02-15 00:01:41.000000', 'temperatura', 8.0000, 'ºC'),
	(59015, 110, '2015-02-15 00:01:42.000000', 'temperatura', 106.0000, 'ºC'),
	(59016, 110, '2015-02-15 00:01:43.000000', 'temperatura', 505.0000, 'ºC'),
	(59017, 110, '2015-02-15 00:01:44.000000', 'temperatura', 1006.0000, 'ºC'),
	(59018, 110, '2015-02-15 00:01:45.000000', 'temperatura', 1115.0000, 'ºC'),
	(59019, 110, '2015-02-15 00:01:46.000000', 'temperatura', 157.0000, 'ºC'),
	(59020, 110, '2015-02-15 00:01:47.000000', 'temperatura', 1040.0000, 'ºC'),
	(59021, 110, '2015-02-15 00:01:48.000000', 'temperatura', 1131.0000, 'ºC'),
	(59022, 110, '2015-02-15 00:01:49.000000', 'temperatura', 134.0000, 'ºC'),
	(59023, 110, '2015-02-15 00:01:50.000000', 'temperatura', 877.0000, 'ºC'),
	(59024, 110, '2015-02-15 00:01:51.000000', 'temperatura', 386.0000, 'ºC'),
	(59025, 110, '2015-02-15 00:01:52.000000', 'temperatura', 497.0000, 'ºC'),
	(59026, 110, '2015-02-15 00:01:53.000000', 'temperatura', 130.0000, 'ºC'),
	(59027, 110, '2015-02-15 00:01:54.000000', 'temperatura', 357.0000, 'ºC'),
	(59028, 110, '2015-02-15 00:01:55.000000', 'temperatura', 195.0000, 'ºC'),
	(59029, 110, '2015-02-15 00:01:56.000000', 'temperatura', 1107.0000, 'ºC'),
	(59030, 110, '2015-02-15 00:01:57.000000', 'temperatura', 151.0000, 'ºC'),
	(59031, 110, '2015-02-15 00:01:58.000000', 'temperatura', 1033.0000, 'ºC'),
	(59032, 110, '2015-02-15 00:01:59.000000', 'temperatura', 1112.0000, 'ºC'),
	(59033, 110, '2015-02-15 00:02:00.000000', 'temperatura', 64.0000, 'ºC'),
	(59034, 110, '2015-02-15 00:02:01.000000', 'temperatura', 583.0000, 'ºC'),
	(59035, 110, '2015-02-15 00:02:02.000000', 'temperatura', 325.0000, 'ºC'),
	(59036, 110, '2015-02-15 00:02:03.000000', 'temperatura', 1076.0000, 'ºC'),
	(59037, 110, '2015-02-15 00:02:04.000000', 'temperatura', 804.0000, 'ºC'),
	(59038, 110, '2015-02-15 00:02:05.000000', 'temperatura', 794.0000, 'ºC'),
	(59039, 110, '2015-02-15 00:02:06.000000', 'temperatura', 356.0000, 'ºC'),
	(59040, 110, '2015-02-15 00:02:07.000000', 'temperatura', 602.0000, 'ºC'),
	(59041, 110, '2015-02-15 00:02:08.000000', 'temperatura', 741.0000, 'ºC'),
	(59042, 110, '2015-02-15 00:02:09.000000', 'temperatura', 699.0000, 'ºC'),
	(59043, 110, '2015-02-15 00:02:10.000000', 'temperatura', 73.0000, 'ºC'),
	(59044, 110, '2015-02-15 00:02:11.000000', 'temperatura', 670.0000, 'ºC'),
	(59045, 110, '2015-02-15 00:02:12.000000', 'temperatura', 730.0000, 'ºC'),
	(59046, 110, '2015-02-15 00:02:13.000000', 'temperatura', 441.0000, 'ºC'),
	(59047, 110, '2015-02-15 00:02:14.000000', 'temperatura', 15.0000, 'ºC'),
	(59048, 110, '2015-02-15 00:02:15.000000', 'temperatura', 1152.0000, 'ºC'),
	(59049, 110, '2015-02-15 00:02:16.000000', 'temperatura', 917.0000, 'ºC'),
	(59050, 110, '2015-02-15 00:02:17.000000', 'temperatura', 1130.0000, 'ºC'),
	(59051, 110, '2015-02-15 00:02:18.000000', 'temperatura', 497.0000, 'ºC'),
	(59052, 110, '2015-02-15 00:02:19.000000', 'temperatura', 296.0000, 'ºC'),
	(59053, 110, '2015-02-15 00:02:20.000000', 'temperatura', 1190.0000, 'ºC'),
	(59054, 110, '2015-02-15 00:02:21.000000', 'temperatura', 264.0000, 'ºC'),
	(59055, 110, '2015-02-15 00:02:22.000000', 'temperatura', 149.0000, 'ºC'),
	(59056, 110, '2015-02-15 00:02:23.000000', 'temperatura', 1156.0000, 'ºC'),
	(59057, 110, '2015-02-15 00:02:24.000000', 'temperatura', 530.0000, 'ºC'),
	(59058, 110, '2015-02-15 00:02:25.000000', 'temperatura', 384.0000, 'ºC'),
	(59059, 110, '2015-02-15 00:02:26.000000', 'temperatura', 332.0000, 'ºC'),
	(59060, 110, '2015-02-15 00:02:27.000000', 'temperatura', 507.0000, 'ºC'),
	(59061, 110, '2015-02-15 00:02:28.000000', 'temperatura', 341.0000, 'ºC'),
	(59062, 110, '2015-02-15 00:02:29.000000', 'temperatura', 183.0000, 'ºC'),
	(59063, 110, '2015-02-15 00:02:30.000000', 'temperatura', 1093.0000, 'ºC'),
	(59064, 110, '2015-02-15 00:02:31.000000', 'temperatura', 118.0000, 'ºC'),
	(59065, 110, '2015-02-15 00:02:32.000000', 'temperatura', 912.0000, 'ºC'),
	(59066, 110, '2015-02-15 00:02:33.000000', 'temperatura', 606.0000, 'ºC'),
	(59067, 110, '2015-02-15 00:02:34.000000', 'temperatura', 294.0000, 'ºC'),
	(59068, 110, '2015-02-15 00:02:35.000000', 'temperatura', 854.0000, 'ºC'),
	(59069, 110, '2015-02-15 00:02:36.000000', 'temperatura', 989.0000, 'ºC'),
	(59070, 110, '2015-02-15 00:02:37.000000', 'temperatura', 1184.0000, 'ºC'),
	(59071, 110, '2015-02-15 00:02:38.000000', 'temperatura', 554.0000, 'ºC'),
	(59072, 110, '2015-02-15 00:02:39.000000', 'temperatura', 416.0000, 'ºC'),
	(59073, 110, '2015-02-15 00:02:40.000000', 'temperatura', 420.0000, 'ºC'),
	(59074, 110, '2015-02-15 00:02:41.000000', 'temperatura', 850.0000, 'ºC'),
	(59075, 110, '2015-02-15 00:02:42.000000', 'temperatura', 593.0000, 'ºC'),
	(59076, 110, '2015-02-15 00:02:43.000000', 'temperatura', 413.0000, 'ºC'),
	(59077, 110, '2015-02-15 00:02:44.000000', 'temperatura', 289.0000, 'ºC'),
	(59078, 110, '2015-02-15 00:02:45.000000', 'temperatura', 205.0000, 'ºC'),
	(59079, 110, '2015-02-15 00:02:46.000000', 'temperatura', 160.0000, 'ºC'),
	(59080, 110, '2015-02-15 00:02:47.000000', 'temperatura', 185.0000, 'ºC'),
	(59081, 110, '2015-02-15 00:02:48.000000', 'temperatura', 447.0000, 'ºC'),
	(59082, 110, '2015-02-15 00:02:49.000000', 'temperatura', 479.0000, 'ºC'),
	(59083, 110, '2015-02-15 00:02:50.000000', 'temperatura', 1053.0000, 'ºC'),
	(59084, 110, '2015-02-15 00:02:51.000000', 'temperatura', 228.0000, 'ºC'),
	(59085, 110, '2015-02-15 00:02:52.000000', 'temperatura', 384.0000, 'ºC'),
	(59086, 110, '2015-02-15 00:02:53.000000', 'temperatura', 36.0000, 'ºC'),
	(59087, 110, '2015-02-15 00:02:54.000000', 'temperatura', 228.0000, 'ºC'),
	(59088, 110, '2015-02-15 00:02:55.000000', 'temperatura', 1035.0000, 'ºC'),
	(59089, 110, '2015-02-15 00:02:56.000000', 'temperatura', 889.0000, 'ºC'),
	(59090, 110, '2015-02-15 00:02:57.000000', 'temperatura', 140.0000, 'ºC'),
	(59091, 110, '2015-02-15 00:02:58.000000', 'temperatura', 433.0000, 'ºC'),
	(59092, 110, '2015-02-15 00:02:59.000000', 'temperatura', 549.0000, 'ºC'),
	(59093, 110, '2015-02-15 00:03:00.000000', 'temperatura', 243.0000, 'ºC'),
	(59094, 110, '2015-02-15 00:03:01.000000', 'temperatura', 768.0000, 'ºC'),
	(59095, 110, '2015-02-15 00:03:02.000000', 'temperatura', 712.0000, 'ºC'),
	(59096, 110, '2015-02-15 00:03:03.000000', 'temperatura', 57.0000, 'ºC'),
	(59097, 110, '2015-02-15 00:03:04.000000', 'temperatura', 551.0000, 'ºC'),
	(59098, 110, '2015-02-15 00:03:05.000000', 'temperatura', 184.0000, 'ºC'),
	(59099, 110, '2015-02-15 00:03:06.000000', 'temperatura', 467.0000, 'ºC'),
	(59100, 110, '2015-02-15 00:03:07.000000', 'temperatura', 582.0000, 'ºC'),
	(59101, 110, '2015-02-15 00:03:08.000000', 'temperatura', 309.0000, 'ºC'),
	(59102, 110, '2015-02-15 00:03:09.000000', 'temperatura', 1001.0000, 'ºC'),
	(59103, 110, '2015-02-15 00:03:10.000000', 'temperatura', 477.0000, 'ºC'),
	(59104, 110, '2015-02-15 00:03:11.000000', 'temperatura', 584.0000, 'ºC'),
	(59105, 110, '2015-02-15 00:03:12.000000', 'temperatura', 289.0000, 'ºC'),
	(59106, 110, '2015-02-15 00:03:13.000000', 'temperatura', 894.0000, 'ºC'),
	(59107, 110, '2015-02-15 00:03:14.000000', 'temperatura', 4.0000, 'ºC'),
	(59108, 110, '2015-02-15 00:03:15.000000', 'temperatura', 938.0000, 'ºC'),
	(59109, 110, '2015-02-15 00:03:16.000000', 'temperatura', 1079.0000, 'ºC'),
	(59110, 110, '2015-02-15 00:03:17.000000', 'temperatura', 183.0000, 'ºC'),
	(59111, 110, '2015-02-15 00:03:18.000000', 'temperatura', 76.0000, 'ºC'),
	(59112, 110, '2015-02-15 00:03:19.000000', 'temperatura', 1032.0000, 'ºC'),
	(59113, 110, '2015-02-15 00:03:20.000000', 'temperatura', 134.0000, 'ºC'),
	(59114, 110, '2015-02-15 00:03:21.000000', 'temperatura', 1176.0000, 'ºC'),
	(59115, 110, '2015-02-15 00:03:22.000000', 'temperatura', 675.0000, 'ºC'),
	(59116, 110, '2015-02-15 00:03:23.000000', 'temperatura', 1050.0000, 'ºC'),
	(59117, 110, '2015-02-15 00:03:24.000000', 'temperatura', 825.0000, 'ºC'),
	(59118, 110, '2015-02-15 00:03:25.000000', 'temperatura', 973.0000, 'ºC'),
	(59119, 110, '2015-02-15 00:03:26.000000', 'temperatura', 1193.0000, 'ºC'),
	(59120, 110, '2015-02-15 00:03:27.000000', 'temperatura', 646.0000, 'ºC'),
	(59121, 110, '2015-02-15 00:03:28.000000', 'temperatura', 850.0000, 'ºC'),
	(59122, 110, '2015-02-15 00:03:29.000000', 'temperatura', 1113.0000, 'ºC'),
	(59123, 110, '2015-02-15 00:03:30.000000', 'temperatura', 616.0000, 'ºC'),
	(59124, 110, '2015-02-15 00:03:31.000000', 'temperatura', 943.0000, 'ºC'),
	(59125, 110, '2015-02-15 00:03:32.000000', 'temperatura', 468.0000, 'ºC'),
	(59126, 110, '2015-02-15 00:03:33.000000', 'temperatura', 711.0000, 'ºC'),
	(59127, 110, '2015-02-15 00:03:34.000000', 'temperatura', 951.0000, 'ºC'),
	(59128, 110, '2015-02-15 00:03:35.000000', 'temperatura', 223.0000, 'ºC'),
	(59129, 110, '2015-02-15 00:03:36.000000', 'temperatura', 661.0000, 'ºC'),
	(59130, 110, '2015-02-15 00:03:37.000000', 'temperatura', 238.0000, 'ºC'),
	(59131, 110, '2015-02-15 00:03:38.000000', 'temperatura', 405.0000, 'ºC'),
	(59132, 110, '2015-02-15 00:03:39.000000', 'temperatura', 114.0000, 'ºC'),
	(59133, 110, '2015-02-15 00:03:40.000000', 'temperatura', 553.0000, 'ºC'),
	(59134, 110, '2015-02-15 00:03:41.000000', 'temperatura', 25.0000, 'ºC'),
	(59135, 110, '2015-02-15 00:03:42.000000', 'temperatura', 867.0000, 'ºC'),
	(59136, 110, '2015-02-15 00:03:43.000000', 'temperatura', 661.0000, 'ºC'),
	(59137, 110, '2015-02-15 00:03:44.000000', 'temperatura', 705.0000, 'ºC'),
	(59138, 110, '2015-02-15 00:03:45.000000', 'temperatura', 343.0000, 'ºC'),
	(59139, 110, '2015-02-15 00:03:46.000000', 'temperatura', 799.0000, 'ºC'),
	(59140, 110, '2015-02-15 00:03:47.000000', 'temperatura', 568.0000, 'ºC'),
	(59141, 110, '2015-02-15 00:03:48.000000', 'temperatura', 444.0000, 'ºC'),
	(59142, 110, '2015-02-15 00:03:49.000000', 'temperatura', 515.0000, 'ºC'),
	(59143, 110, '2015-02-15 00:03:50.000000', 'temperatura', 42.0000, 'ºC'),
	(59144, 110, '2015-02-15 00:03:51.000000', 'temperatura', 1068.0000, 'ºC'),
	(59145, 110, '2015-02-15 00:03:52.000000', 'temperatura', 414.0000, 'ºC'),
	(59146, 110, '2015-02-15 00:03:53.000000', 'temperatura', 67.0000, 'ºC'),
	(59147, 110, '2015-02-15 00:03:54.000000', 'temperatura', 294.0000, 'ºC'),
	(59148, 110, '2015-02-15 00:03:55.000000', 'temperatura', 68.0000, 'ºC'),
	(59149, 110, '2015-02-15 00:03:56.000000', 'temperatura', 658.0000, 'ºC'),
	(59150, 110, '2015-02-15 00:03:57.000000', 'temperatura', 689.0000, 'ºC'),
	(59151, 110, '2015-02-15 00:03:58.000000', 'temperatura', 270.0000, 'ºC'),
	(59152, 110, '2015-02-15 00:03:59.000000', 'temperatura', 484.0000, 'ºC'),
	(59153, 110, '2015-02-15 00:04:00.000000', 'temperatura', 409.0000, 'ºC'),
	(59154, 110, '2015-02-15 00:04:01.000000', 'temperatura', 597.0000, 'ºC'),
	(59155, 110, '2015-02-15 00:04:02.000000', 'temperatura', 555.0000, 'ºC'),
	(59156, 110, '2015-02-15 00:04:03.000000', 'temperatura', 984.0000, 'ºC'),
	(59157, 110, '2015-02-15 00:04:04.000000', 'temperatura', 855.0000, 'ºC'),
	(59158, 110, '2015-02-15 00:04:05.000000', 'temperatura', 127.0000, 'ºC'),
	(59159, 110, '2015-02-15 00:04:06.000000', 'temperatura', 467.0000, 'ºC'),
	(59160, 110, '2015-02-15 00:04:07.000000', 'temperatura', 755.0000, 'ºC'),
	(59161, 110, '2015-02-15 00:04:08.000000', 'temperatura', 1175.0000, 'ºC'),
	(59162, 110, '2015-02-15 00:04:09.000000', 'temperatura', 11.0000, 'ºC'),
	(59163, 110, '2015-02-15 00:04:10.000000', 'temperatura', 131.0000, 'ºC'),
	(59164, 110, '2015-02-15 00:04:11.000000', 'temperatura', 620.0000, 'ºC'),
	(59165, 110, '2015-02-15 00:04:12.000000', 'temperatura', 309.0000, 'ºC'),
	(59166, 110, '2015-02-15 00:04:13.000000', 'temperatura', 887.0000, 'ºC'),
	(59167, 110, '2015-02-15 00:04:14.000000', 'temperatura', 1109.0000, 'ºC'),
	(59168, 110, '2015-02-15 00:04:15.000000', 'temperatura', 486.0000, 'ºC'),
	(59169, 110, '2015-02-15 00:04:16.000000', 'temperatura', 300.0000, 'ºC'),
	(59170, 110, '2015-02-15 00:04:17.000000', 'temperatura', 42.0000, 'ºC'),
	(59171, 110, '2015-02-15 00:04:18.000000', 'temperatura', 511.0000, 'ºC'),
	(59172, 110, '2015-02-15 00:04:19.000000', 'temperatura', 31.0000, 'ºC'),
	(59173, 110, '2015-02-15 00:04:20.000000', 'temperatura', 1023.0000, 'ºC'),
	(59174, 110, '2015-02-15 00:04:21.000000', 'temperatura', 222.0000, 'ºC'),
	(59175, 110, '2015-02-15 00:04:22.000000', 'temperatura', 442.0000, 'ºC'),
	(59176, 110, '2015-02-15 00:04:23.000000', 'temperatura', 345.0000, 'ºC'),
	(59177, 110, '2015-02-15 00:04:24.000000', 'temperatura', 398.0000, 'ºC'),
	(59178, 110, '2015-02-15 00:04:25.000000', 'temperatura', 958.0000, 'ºC'),
	(59179, 110, '2015-02-15 00:04:26.000000', 'temperatura', 1195.0000, 'ºC'),
	(59180, 110, '2015-02-15 00:04:27.000000', 'temperatura', 702.0000, 'ºC'),
	(59181, 110, '2015-02-15 00:04:28.000000', 'temperatura', 1124.0000, 'ºC'),
	(59182, 110, '2015-02-15 00:04:29.000000', 'temperatura', 1115.0000, 'ºC'),
	(59183, 110, '2015-02-15 00:04:30.000000', 'temperatura', 1003.0000, 'ºC'),
	(59184, 110, '2015-02-15 00:04:31.000000', 'temperatura', 472.0000, 'ºC'),
	(59185, 110, '2015-02-15 00:04:32.000000', 'temperatura', 549.0000, 'ºC'),
	(59186, 110, '2015-02-15 00:04:33.000000', 'temperatura', 132.0000, 'ºC'),
	(59187, 110, '2015-02-15 00:04:34.000000', 'temperatura', 211.0000, 'ºC'),
	(59188, 110, '2015-02-15 00:04:35.000000', 'temperatura', 661.0000, 'ºC'),
	(59189, 110, '2015-02-15 00:04:36.000000', 'temperatura', 273.0000, 'ºC'),
	(59190, 110, '2015-02-15 00:04:37.000000', 'temperatura', 583.0000, 'ºC'),
	(59191, 110, '2015-02-15 00:04:38.000000', 'temperatura', 896.0000, 'ºC'),
	(59192, 110, '2015-02-15 00:04:39.000000', 'temperatura', 331.0000, 'ºC'),
	(59193, 110, '2015-02-15 00:04:40.000000', 'temperatura', 169.0000, 'ºC'),
	(59194, 110, '2015-02-15 00:04:41.000000', 'temperatura', 1050.0000, 'ºC'),
	(59195, 110, '2015-02-15 00:04:42.000000', 'temperatura', 1143.0000, 'ºC'),
	(59196, 110, '2015-02-15 00:04:43.000000', 'temperatura', 169.0000, 'ºC'),
	(59197, 110, '2015-02-15 00:04:44.000000', 'temperatura', 1013.0000, 'ºC'),
	(59198, 110, '2015-02-15 00:04:45.000000', 'temperatura', 960.0000, 'ºC'),
	(59199, 110, '2015-02-15 00:04:46.000000', 'temperatura', 562.0000, 'ºC'),
	(59200, 110, '2015-02-15 00:04:47.000000', 'temperatura', 1129.0000, 'ºC'),
	(59201, 110, '2015-02-15 00:04:48.000000', 'temperatura', 358.0000, 'ºC'),
	(59202, 110, '2015-02-15 00:04:49.000000', 'temperatura', 807.0000, 'ºC'),
	(59203, 110, '2015-02-15 00:04:50.000000', 'temperatura', 561.0000, 'ºC'),
	(59204, 110, '2015-02-15 00:04:51.000000', 'temperatura', 383.0000, 'ºC'),
	(59205, 110, '2015-02-15 00:04:52.000000', 'temperatura', 231.0000, 'ºC'),
	(59206, 110, '2015-02-15 00:04:53.000000', 'temperatura', 10.0000, 'ºC'),
	(59207, 110, '2015-02-15 00:04:54.000000', 'temperatura', 556.0000, 'ºC'),
	(59208, 110, '2015-02-15 00:04:55.000000', 'temperatura', 349.0000, 'ºC'),
	(59209, 110, '2015-02-15 00:04:56.000000', 'temperatura', 78.0000, 'ºC'),
	(59210, 110, '2015-02-15 00:04:57.000000', 'temperatura', 544.0000, 'ºC'),
	(59211, 110, '2015-02-15 00:04:58.000000', 'temperatura', 86.0000, 'ºC'),
	(59212, 110, '2015-02-15 00:04:59.000000', 'temperatura', 1197.0000, 'ºC'),
	(59213, 110, '2015-02-15 00:05:00.000000', 'temperatura', 930.0000, 'ºC'),
	(59214, 110, '2015-02-15 00:05:01.000000', 'temperatura', 1059.0000, 'ºC'),
	(59215, 110, '2015-02-15 00:05:02.000000', 'temperatura', 105.0000, 'ºC'),
	(59216, 110, '2015-02-15 00:05:03.000000', 'temperatura', 951.0000, 'ºC'),
	(59217, 110, '2015-02-15 00:05:04.000000', 'temperatura', 838.0000, 'ºC'),
	(59218, 110, '2015-02-15 00:05:05.000000', 'temperatura', 138.0000, 'ºC'),
	(59219, 110, '2015-02-15 00:05:06.000000', 'temperatura', 576.0000, 'ºC'),
	(59220, 110, '2015-02-15 00:05:07.000000', 'temperatura', 67.0000, 'ºC'),
	(59221, 110, '2015-02-15 00:05:08.000000', 'temperatura', 1009.0000, 'ºC'),
	(59222, 110, '2015-02-15 00:05:09.000000', 'temperatura', 42.0000, 'ºC'),
	(59223, 110, '2015-02-15 00:05:10.000000', 'temperatura', 784.0000, 'ºC'),
	(59224, 110, '2015-02-15 00:05:11.000000', 'temperatura', 197.0000, 'ºC'),
	(59225, 110, '2015-02-15 00:05:12.000000', 'temperatura', 1031.0000, 'ºC'),
	(59226, 110, '2015-02-15 00:05:13.000000', 'temperatura', 964.0000, 'ºC'),
	(59227, 110, '2015-02-15 00:05:14.000000', 'temperatura', 527.0000, 'ºC'),
	(59228, 110, '2015-02-15 00:05:15.000000', 'temperatura', 946.0000, 'ºC'),
	(59229, 110, '2015-02-15 00:05:16.000000', 'temperatura', 748.0000, 'ºC'),
	(59230, 110, '2015-02-15 00:05:17.000000', 'temperatura', 904.0000, 'ºC'),
	(59231, 110, '2015-02-15 00:05:18.000000', 'temperatura', 1075.0000, 'ºC'),
	(59232, 110, '2015-02-15 00:05:19.000000', 'temperatura', 264.0000, 'ºC'),
	(59233, 110, '2015-02-15 00:05:20.000000', 'temperatura', 496.0000, 'ºC'),
	(59234, 110, '2015-02-15 00:05:21.000000', 'temperatura', 486.0000, 'ºC'),
	(59235, 110, '2015-02-15 00:05:22.000000', 'temperatura', 945.0000, 'ºC'),
	(59236, 110, '2015-02-15 00:05:23.000000', 'temperatura', 866.0000, 'ºC'),
	(59237, 110, '2015-02-15 00:05:24.000000', 'temperatura', 297.0000, 'ºC'),
	(59238, 110, '2015-02-15 00:05:25.000000', 'temperatura', 86.0000, 'ºC'),
	(59239, 110, '2015-02-15 00:05:26.000000', 'temperatura', 741.0000, 'ºC'),
	(59240, 110, '2015-02-15 00:05:27.000000', 'temperatura', 1048.0000, 'ºC'),
	(59241, 110, '2015-02-15 00:05:28.000000', 'temperatura', 618.0000, 'ºC'),
	(59242, 110, '2015-02-15 00:05:29.000000', 'temperatura', 1147.0000, 'ºC'),
	(59243, 110, '2015-02-15 00:05:30.000000', 'temperatura', 282.0000, 'ºC'),
	(59244, 110, '2015-02-15 00:05:31.000000', 'temperatura', 370.0000, 'ºC'),
	(59245, 110, '2015-02-15 00:05:32.000000', 'temperatura', 1003.0000, 'ºC'),
	(59246, 110, '2015-02-15 00:05:33.000000', 'temperatura', 304.0000, 'ºC'),
	(59247, 110, '2015-02-15 00:05:34.000000', 'temperatura', 913.0000, 'ºC'),
	(59248, 110, '2015-02-15 00:05:35.000000', 'temperatura', 54.0000, 'ºC'),
	(59249, 110, '2015-02-15 00:05:36.000000', 'temperatura', 1133.0000, 'ºC'),
	(59250, 110, '2015-02-15 00:05:37.000000', 'temperatura', 702.0000, 'ºC'),
	(59251, 110, '2015-02-15 00:05:38.000000', 'temperatura', 110.0000, 'ºC'),
	(59252, 110, '2015-02-15 00:05:39.000000', 'temperatura', 845.0000, 'ºC'),
	(59253, 110, '2015-02-15 00:05:40.000000', 'temperatura', 297.0000, 'ºC'),
	(59254, 110, '2015-02-15 00:05:41.000000', 'temperatura', 149.0000, 'ºC'),
	(59255, 110, '2015-02-15 00:05:42.000000', 'temperatura', 1056.0000, 'ºC'),
	(59256, 110, '2015-02-15 00:05:43.000000', 'temperatura', 35.0000, 'ºC'),
	(59257, 110, '2015-02-15 00:05:44.000000', 'temperatura', 604.0000, 'ºC'),
	(59258, 110, '2015-02-15 00:05:45.000000', 'temperatura', 517.0000, 'ºC'),
	(59259, 110, '2015-02-15 00:05:46.000000', 'temperatura', 772.0000, 'ºC'),
	(59260, 110, '2015-02-15 00:05:47.000000', 'temperatura', 1108.0000, 'ºC'),
	(59261, 110, '2015-02-15 00:05:48.000000', 'temperatura', 828.0000, 'ºC'),
	(59262, 110, '2015-02-15 00:05:49.000000', 'temperatura', 814.0000, 'ºC'),
	(59263, 110, '2015-02-15 00:05:50.000000', 'temperatura', 388.0000, 'ºC'),
	(59264, 110, '2015-02-15 00:05:51.000000', 'temperatura', 700.0000, 'ºC'),
	(59265, 110, '2015-02-15 00:05:52.000000', 'temperatura', 1135.0000, 'ºC'),
	(59266, 110, '2015-02-15 00:05:53.000000', 'temperatura', 1177.0000, 'ºC'),
	(59267, 110, '2015-02-15 00:05:54.000000', 'temperatura', 80.0000, 'ºC'),
	(59268, 110, '2015-02-15 00:05:55.000000', 'temperatura', 467.0000, 'ºC'),
	(59269, 110, '2015-02-15 00:05:56.000000', 'temperatura', 899.0000, 'ºC'),
	(59270, 110, '2015-02-15 00:05:57.000000', 'temperatura', 693.0000, 'ºC'),
	(59271, 110, '2015-02-15 00:05:58.000000', 'temperatura', 769.0000, 'ºC'),
	(59272, 110, '2015-02-15 00:05:59.000000', 'temperatura', 566.0000, 'ºC'),
	(59273, 110, '2015-02-15 00:06:00.000000', 'temperatura', 523.0000, 'ºC'),
	(59274, 110, '2015-02-15 00:06:01.000000', 'temperatura', 918.0000, 'ºC'),
	(59275, 110, '2015-02-15 00:06:02.000000', 'temperatura', 620.0000, 'ºC'),
	(59276, 110, '2015-02-15 00:06:03.000000', 'temperatura', 347.0000, 'ºC'),
	(59277, 110, '2015-02-15 00:06:04.000000', 'temperatura', 1076.0000, 'ºC'),
	(59278, 110, '2015-02-15 00:06:05.000000', 'temperatura', 738.0000, 'ºC'),
	(59279, 110, '2015-02-15 00:06:06.000000', 'temperatura', 462.0000, 'ºC'),
	(59280, 110, '2015-02-15 00:06:07.000000', 'temperatura', 97.0000, 'ºC'),
	(59281, 110, '2015-02-15 00:06:08.000000', 'temperatura', 300.0000, 'ºC'),
	(59282, 110, '2015-02-15 00:06:09.000000', 'temperatura', 11.0000, 'ºC'),
	(59283, 110, '2015-02-15 00:06:10.000000', 'temperatura', 354.0000, 'ºC'),
	(59284, 110, '2015-02-15 00:06:11.000000', 'temperatura', 540.0000, 'ºC'),
	(59285, 110, '2015-02-15 00:06:12.000000', 'temperatura', 436.0000, 'ºC'),
	(59286, 110, '2015-02-15 00:06:13.000000', 'temperatura', 559.0000, 'ºC'),
	(59287, 110, '2015-02-15 00:06:14.000000', 'temperatura', 291.0000, 'ºC'),
	(59288, 110, '2015-02-15 00:06:15.000000', 'temperatura', 977.0000, 'ºC'),
	(59289, 110, '2015-02-15 00:06:16.000000', 'temperatura', 413.0000, 'ºC'),
	(59290, 110, '2015-02-15 00:06:17.000000', 'temperatura', 333.0000, 'ºC'),
	(59291, 110, '2015-02-15 00:06:18.000000', 'temperatura', 428.0000, 'ºC'),
	(59292, 110, '2015-02-15 00:06:19.000000', 'temperatura', 1140.0000, 'ºC'),
	(59293, 110, '2015-02-15 00:06:20.000000', 'temperatura', 815.0000, 'ºC'),
	(59294, 110, '2015-02-15 00:06:21.000000', 'temperatura', 658.0000, 'ºC'),
	(59295, 110, '2015-02-15 00:06:22.000000', 'temperatura', 844.0000, 'ºC'),
	(59296, 110, '2015-02-15 00:06:23.000000', 'temperatura', 1046.0000, 'ºC'),
	(59297, 110, '2015-02-15 00:06:24.000000', 'temperatura', 301.0000, 'ºC'),
	(59298, 110, '2015-02-15 00:06:25.000000', 'temperatura', 766.0000, 'ºC'),
	(59299, 110, '2015-02-15 00:06:26.000000', 'temperatura', 526.0000, 'ºC'),
	(59300, 110, '2015-02-15 00:06:27.000000', 'temperatura', 335.0000, 'ºC'),
	(59301, 110, '2015-02-15 00:06:28.000000', 'temperatura', 96.0000, 'ºC'),
	(59302, 110, '2015-02-15 00:06:29.000000', 'temperatura', 677.0000, 'ºC'),
	(59303, 110, '2015-02-15 00:06:30.000000', 'temperatura', 695.0000, 'ºC'),
	(59304, 110, '2015-02-15 00:06:31.000000', 'temperatura', 244.0000, 'ºC'),
	(59305, 110, '2015-02-15 00:06:32.000000', 'temperatura', 337.0000, 'ºC'),
	(59306, 110, '2015-02-15 00:06:33.000000', 'temperatura', 954.0000, 'ºC'),
	(59307, 110, '2015-02-15 00:06:34.000000', 'temperatura', 161.0000, 'ºC'),
	(59308, 110, '2015-02-15 00:06:35.000000', 'temperatura', 340.0000, 'ºC'),
	(59309, 110, '2015-02-15 00:06:36.000000', 'temperatura', 19.0000, 'ºC'),
	(59310, 110, '2015-02-15 00:06:37.000000', 'temperatura', 275.0000, 'ºC'),
	(59311, 110, '2015-02-15 00:06:38.000000', 'temperatura', 120.0000, 'ºC'),
	(59312, 110, '2015-02-15 00:06:39.000000', 'temperatura', 973.0000, 'ºC'),
	(59313, 110, '2015-02-15 00:06:40.000000', 'temperatura', 909.0000, 'ºC'),
	(59314, 110, '2015-02-15 00:06:41.000000', 'temperatura', 424.0000, 'ºC'),
	(59315, 110, '2015-02-15 00:06:42.000000', 'temperatura', 593.0000, 'ºC'),
	(59316, 110, '2015-02-15 00:06:43.000000', 'temperatura', 493.0000, 'ºC'),
	(59317, 110, '2015-02-15 00:06:44.000000', 'temperatura', 687.0000, 'ºC'),
	(59318, 110, '2015-02-15 00:06:45.000000', 'temperatura', 755.0000, 'ºC'),
	(59319, 110, '2015-02-15 00:06:46.000000', 'temperatura', 515.0000, 'ºC'),
	(59320, 110, '2015-02-15 00:06:47.000000', 'temperatura', 312.0000, 'ºC'),
	(59321, 110, '2015-02-15 00:06:48.000000', 'temperatura', 14.0000, 'ºC'),
	(59322, 110, '2015-02-15 00:06:49.000000', 'temperatura', 334.0000, 'ºC'),
	(59323, 110, '2015-02-15 00:06:50.000000', 'temperatura', 427.0000, 'ºC'),
	(59324, 110, '2015-02-15 00:06:51.000000', 'temperatura', 1137.0000, 'ºC'),
	(59325, 110, '2015-02-15 00:06:52.000000', 'temperatura', 803.0000, 'ºC'),
	(59326, 110, '2015-02-15 00:06:53.000000', 'temperatura', 606.0000, 'ºC'),
	(59327, 110, '2015-02-15 00:06:54.000000', 'temperatura', 619.0000, 'ºC'),
	(59328, 110, '2015-02-15 00:06:55.000000', 'temperatura', 79.0000, 'ºC'),
	(59329, 110, '2015-02-15 00:06:56.000000', 'temperatura', 939.0000, 'ºC'),
	(59330, 110, '2015-02-15 00:06:57.000000', 'temperatura', 857.0000, 'ºC'),
	(59331, 110, '2015-02-15 00:06:58.000000', 'temperatura', 271.0000, 'ºC'),
	(59332, 110, '2015-02-15 00:06:59.000000', 'temperatura', 1183.0000, 'ºC'),
	(59333, 110, '2015-02-15 00:07:00.000000', 'temperatura', 303.0000, 'ºC'),
	(59334, 110, '2015-02-15 00:07:01.000000', 'temperatura', 365.0000, 'ºC'),
	(59335, 110, '2015-02-15 00:07:02.000000', 'temperatura', 917.0000, 'ºC'),
	(59336, 110, '2015-02-15 00:07:03.000000', 'temperatura', 1091.0000, 'ºC'),
	(59337, 110, '2015-02-15 00:07:04.000000', 'temperatura', 304.0000, 'ºC'),
	(59338, 110, '2015-02-15 00:07:05.000000', 'temperatura', 647.0000, 'ºC'),
	(59339, 110, '2015-02-15 00:07:06.000000', 'temperatura', 1125.0000, 'ºC'),
	(59340, 110, '2015-02-15 00:07:07.000000', 'temperatura', 85.0000, 'ºC'),
	(59341, 110, '2015-02-15 00:07:08.000000', 'temperatura', 648.0000, 'ºC'),
	(59342, 110, '2015-02-15 00:07:09.000000', 'temperatura', 585.0000, 'ºC'),
	(59343, 110, '2015-02-15 00:07:10.000000', 'temperatura', 984.0000, 'ºC'),
	(59344, 110, '2015-02-15 00:07:11.000000', 'temperatura', 764.0000, 'ºC'),
	(59345, 110, '2015-02-15 00:07:12.000000', 'temperatura', 867.0000, 'ºC'),
	(59346, 110, '2015-02-15 00:07:13.000000', 'temperatura', 844.0000, 'ºC'),
	(59347, 110, '2015-02-15 00:07:14.000000', 'temperatura', 422.0000, 'ºC'),
	(59348, 110, '2015-02-15 00:07:15.000000', 'temperatura', 777.0000, 'ºC'),
	(59349, 110, '2015-02-15 00:07:16.000000', 'temperatura', 219.0000, 'ºC'),
	(59350, 110, '2015-02-15 00:07:17.000000', 'temperatura', 1165.0000, 'ºC'),
	(59351, 110, '2015-02-15 00:07:18.000000', 'temperatura', 370.0000, 'ºC'),
	(59352, 110, '2015-02-15 00:07:19.000000', 'temperatura', 753.0000, 'ºC'),
	(59353, 110, '2015-02-15 00:07:20.000000', 'temperatura', 255.0000, 'ºC'),
	(59354, 110, '2015-02-15 00:07:21.000000', 'temperatura', 219.0000, 'ºC'),
	(59355, 110, '2015-02-15 00:07:22.000000', 'temperatura', 328.0000, 'ºC'),
	(59356, 110, '2015-02-15 00:07:23.000000', 'temperatura', 983.0000, 'ºC'),
	(59357, 110, '2015-02-15 00:07:24.000000', 'temperatura', 333.0000, 'ºC'),
	(59358, 110, '2015-02-15 00:07:25.000000', 'temperatura', 1116.0000, 'ºC'),
	(59359, 110, '2015-02-15 00:07:26.000000', 'temperatura', 982.0000, 'ºC'),
	(59360, 110, '2015-02-15 00:07:27.000000', 'temperatura', 362.0000, 'ºC'),
	(59361, 110, '2015-02-15 00:07:28.000000', 'temperatura', 65.0000, 'ºC'),
	(59362, 110, '2015-02-15 00:07:29.000000', 'temperatura', 440.0000, 'ºC'),
	(59363, 110, '2015-02-15 00:07:30.000000', 'temperatura', 804.0000, 'ºC'),
	(59364, 110, '2015-02-15 00:07:31.000000', 'temperatura', 302.0000, 'ºC'),
	(59365, 110, '2015-02-15 00:07:32.000000', 'temperatura', 299.0000, 'ºC'),
	(59366, 110, '2015-02-15 00:07:33.000000', 'temperatura', 589.0000, 'ºC'),
	(59367, 110, '2015-02-15 00:07:34.000000', 'temperatura', 847.0000, 'ºC'),
	(59368, 110, '2015-02-15 00:07:35.000000', 'temperatura', 70.0000, 'ºC'),
	(59369, 110, '2015-02-15 00:07:36.000000', 'temperatura', 210.0000, 'ºC'),
	(59370, 110, '2015-02-15 00:07:37.000000', 'temperatura', 840.0000, 'ºC'),
	(59371, 110, '2015-02-15 00:07:38.000000', 'temperatura', 1171.0000, 'ºC'),
	(59372, 110, '2015-02-15 00:07:39.000000', 'temperatura', 937.0000, 'ºC'),
	(59373, 110, '2015-02-15 00:07:40.000000', 'temperatura', 1171.0000, 'ºC'),
	(59374, 110, '2015-02-15 00:07:41.000000', 'temperatura', 645.0000, 'ºC'),
	(59375, 110, '2015-02-15 00:07:42.000000', 'temperatura', 913.0000, 'ºC'),
	(59376, 110, '2015-02-15 00:07:43.000000', 'temperatura', 231.0000, 'ºC'),
	(59377, 110, '2015-02-15 00:07:44.000000', 'temperatura', 815.0000, 'ºC'),
	(59378, 110, '2015-02-15 00:07:45.000000', 'temperatura', 982.0000, 'ºC'),
	(59379, 110, '2015-02-15 00:07:46.000000', 'temperatura', 66.0000, 'ºC'),
	(59380, 110, '2015-02-15 00:07:47.000000', 'temperatura', 985.0000, 'ºC'),
	(59381, 110, '2015-02-15 00:07:48.000000', 'temperatura', 1127.0000, 'ºC'),
	(59382, 110, '2015-02-15 00:07:49.000000', 'temperatura', 279.0000, 'ºC'),
	(59383, 110, '2015-02-15 00:07:50.000000', 'temperatura', 414.0000, 'ºC'),
	(59384, 110, '2015-02-15 00:07:51.000000', 'temperatura', 36.0000, 'ºC'),
	(59385, 110, '2015-02-15 00:07:52.000000', 'temperatura', 139.0000, 'ºC'),
	(59386, 110, '2015-02-15 00:07:53.000000', 'temperatura', 587.0000, 'ºC'),
	(59387, 110, '2015-02-15 00:07:54.000000', 'temperatura', 118.0000, 'ºC'),
	(59388, 110, '2015-02-15 00:07:55.000000', 'temperatura', 31.0000, 'ºC'),
	(59389, 110, '2015-02-15 00:07:56.000000', 'temperatura', 1001.0000, 'ºC'),
	(59390, 110, '2015-02-15 00:07:57.000000', 'temperatura', 114.0000, 'ºC'),
	(59391, 110, '2015-02-15 00:07:58.000000', 'temperatura', 1165.0000, 'ºC'),
	(59392, 110, '2015-02-15 00:07:59.000000', 'temperatura', 686.0000, 'ºC'),
	(59393, 110, '2015-02-15 00:08:00.000000', 'temperatura', 1133.0000, 'ºC'),
	(59394, 110, '2015-02-15 00:08:01.000000', 'temperatura', 7.0000, 'ºC'),
	(59395, 110, '2015-02-15 00:08:02.000000', 'temperatura', 239.0000, 'ºC'),
	(59396, 110, '2015-02-15 00:08:03.000000', 'temperatura', 1173.0000, 'ºC'),
	(59397, 110, '2015-02-15 00:08:04.000000', 'temperatura', 348.0000, 'ºC'),
	(59398, 110, '2015-02-15 00:08:05.000000', 'temperatura', 621.0000, 'ºC'),
	(59399, 110, '2015-02-15 00:08:06.000000', 'temperatura', 864.0000, 'ºC'),
	(59400, 110, '2015-02-15 00:08:07.000000', 'temperatura', 57.0000, 'ºC'),
	(59401, 110, '2015-02-15 00:08:08.000000', 'temperatura', 93.0000, 'ºC'),
	(59402, 110, '2015-02-15 00:08:09.000000', 'temperatura', 293.0000, 'ºC'),
	(59403, 110, '2015-02-15 00:08:10.000000', 'temperatura', 1189.0000, 'ºC'),
	(59404, 110, '2015-02-15 00:08:11.000000', 'temperatura', 265.0000, 'ºC'),
	(59405, 110, '2015-02-15 00:08:12.000000', 'temperatura', 158.0000, 'ºC'),
	(59406, 110, '2015-02-15 00:08:13.000000', 'temperatura', 1198.0000, 'ºC'),
	(59407, 110, '2015-02-15 00:08:14.000000', 'temperatura', 716.0000, 'ºC'),
	(59408, 110, '2015-02-15 00:08:15.000000', 'temperatura', 1185.0000, 'ºC'),
	(59409, 110, '2015-02-15 00:08:16.000000', 'temperatura', 176.0000, 'ºC'),
	(59410, 110, '2015-02-15 00:08:17.000000', 'temperatura', 928.0000, 'ºC'),
	(59411, 110, '2015-02-15 00:08:18.000000', 'temperatura', 512.0000, 'ºC'),
	(59412, 110, '2015-02-15 00:08:19.000000', 'temperatura', 975.0000, 'ºC'),
	(59413, 110, '2015-02-15 00:08:20.000000', 'temperatura', 938.0000, 'ºC'),
	(59414, 110, '2015-02-15 00:08:21.000000', 'temperatura', 569.0000, 'ºC'),
	(59415, 110, '2015-02-15 00:08:22.000000', 'temperatura', 31.0000, 'ºC'),
	(59416, 110, '2015-02-15 00:08:23.000000', 'temperatura', 850.0000, 'ºC'),
	(59417, 110, '2015-02-15 00:08:24.000000', 'temperatura', 555.0000, 'ºC'),
	(59418, 110, '2015-02-15 00:08:25.000000', 'temperatura', 224.0000, 'ºC'),
	(59419, 110, '2015-02-15 00:08:26.000000', 'temperatura', 659.0000, 'ºC'),
	(59420, 110, '2015-02-15 00:08:27.000000', 'temperatura', 222.0000, 'ºC'),
	(59421, 110, '2015-02-15 00:08:28.000000', 'temperatura', 334.0000, 'ºC'),
	(59422, 110, '2015-02-15 00:08:29.000000', 'temperatura', 1006.0000, 'ºC'),
	(59423, 110, '2015-02-15 00:08:30.000000', 'temperatura', 426.0000, 'ºC'),
	(59424, 110, '2015-02-15 00:08:31.000000', 'temperatura', 314.0000, 'ºC'),
	(59425, 110, '2015-02-15 00:08:32.000000', 'temperatura', 291.0000, 'ºC'),
	(59426, 110, '2015-02-15 00:08:33.000000', 'temperatura', 513.0000, 'ºC'),
	(59427, 110, '2015-02-15 00:08:34.000000', 'temperatura', 495.0000, 'ºC'),
	(59428, 110, '2015-02-15 00:08:35.000000', 'temperatura', 936.0000, 'ºC'),
	(59429, 110, '2015-02-15 00:08:36.000000', 'temperatura', 795.0000, 'ºC'),
	(59430, 110, '2015-02-15 00:08:37.000000', 'temperatura', 1169.0000, 'ºC'),
	(59431, 110, '2015-02-15 00:08:38.000000', 'temperatura', 1061.0000, 'ºC'),
	(59432, 110, '2015-02-15 00:08:39.000000', 'temperatura', 597.0000, 'ºC'),
	(59433, 110, '2015-02-15 00:08:40.000000', 'temperatura', 1003.0000, 'ºC'),
	(59434, 110, '2015-02-15 00:08:41.000000', 'temperatura', 824.0000, 'ºC'),
	(59435, 110, '2015-02-15 00:08:42.000000', 'temperatura', 1114.0000, 'ºC'),
	(59436, 110, '2015-02-15 00:08:43.000000', 'temperatura', 695.0000, 'ºC'),
	(59437, 110, '2015-02-15 00:08:44.000000', 'temperatura', 136.0000, 'ºC'),
	(59438, 110, '2015-02-15 00:08:45.000000', 'temperatura', 994.0000, 'ºC'),
	(59439, 110, '2015-02-15 00:08:46.000000', 'temperatura', 964.0000, 'ºC'),
	(59440, 110, '2015-02-15 00:08:47.000000', 'temperatura', 636.0000, 'ºC'),
	(59441, 110, '2015-02-15 00:08:48.000000', 'temperatura', 291.0000, 'ºC'),
	(59442, 110, '2015-02-15 00:08:49.000000', 'temperatura', 748.0000, 'ºC'),
	(59443, 110, '2015-02-15 00:08:50.000000', 'temperatura', 465.0000, 'ºC'),
	(59444, 110, '2015-02-15 00:08:51.000000', 'temperatura', 81.0000, 'ºC'),
	(59445, 110, '2015-02-15 00:08:52.000000', 'temperatura', 211.0000, 'ºC'),
	(59446, 110, '2015-02-15 00:08:53.000000', 'temperatura', 814.0000, 'ºC'),
	(59447, 110, '2015-02-15 00:08:54.000000', 'temperatura', 1035.0000, 'ºC'),
	(59448, 110, '2015-02-15 00:08:55.000000', 'temperatura', 334.0000, 'ºC'),
	(59449, 110, '2015-02-15 00:08:56.000000', 'temperatura', 968.0000, 'ºC'),
	(59450, 110, '2015-02-15 00:08:57.000000', 'temperatura', 237.0000, 'ºC'),
	(59451, 110, '2015-02-15 00:08:58.000000', 'temperatura', 681.0000, 'ºC'),
	(59452, 110, '2015-02-15 00:08:59.000000', 'temperatura', 295.0000, 'ºC'),
	(59453, 110, '2015-02-15 00:09:00.000000', 'temperatura', 634.0000, 'ºC'),
	(59454, 110, '2015-02-15 00:09:01.000000', 'temperatura', 1084.0000, 'ºC'),
	(59455, 110, '2015-02-15 00:09:02.000000', 'temperatura', 1120.0000, 'ºC'),
	(59456, 110, '2015-02-15 00:09:03.000000', 'temperatura', 1148.0000, 'ºC'),
	(59457, 110, '2015-02-15 00:09:04.000000', 'temperatura', 1180.0000, 'ºC'),
	(59458, 110, '2015-02-15 00:09:05.000000', 'temperatura', 55.0000, 'ºC'),
	(59459, 110, '2015-02-15 00:09:06.000000', 'temperatura', 338.0000, 'ºC'),
	(59460, 110, '2015-02-15 00:09:07.000000', 'temperatura', 325.0000, 'ºC'),
	(59461, 110, '2015-02-15 00:09:08.000000', 'temperatura', 610.0000, 'ºC'),
	(59462, 110, '2015-02-15 00:09:09.000000', 'temperatura', 876.0000, 'ºC'),
	(59463, 110, '2015-02-15 00:09:10.000000', 'temperatura', 149.0000, 'ºC'),
	(59464, 110, '2015-02-15 00:09:11.000000', 'temperatura', 518.0000, 'ºC'),
	(59465, 110, '2015-02-15 00:09:12.000000', 'temperatura', 943.0000, 'ºC'),
	(59466, 110, '2015-02-15 00:09:13.000000', 'temperatura', 764.0000, 'ºC'),
	(59467, 110, '2015-02-15 00:09:14.000000', 'temperatura', 990.0000, 'ºC'),
	(59468, 110, '2015-02-15 00:09:15.000000', 'temperatura', 257.0000, 'ºC'),
	(59469, 110, '2015-02-15 00:09:16.000000', 'temperatura', 716.0000, 'ºC'),
	(59470, 110, '2015-02-15 00:09:17.000000', 'temperatura', 410.0000, 'ºC'),
	(59471, 110, '2015-02-15 00:09:18.000000', 'temperatura', 1101.0000, 'ºC'),
	(59472, 110, '2015-02-15 00:09:19.000000', 'temperatura', 675.0000, 'ºC'),
	(59473, 110, '2015-02-15 00:09:20.000000', 'temperatura', 72.0000, 'ºC'),
	(59474, 110, '2015-02-15 00:09:21.000000', 'temperatura', 737.0000, 'ºC'),
	(59475, 110, '2015-02-15 00:09:22.000000', 'temperatura', 1068.0000, 'ºC'),
	(59476, 110, '2015-02-15 00:09:23.000000', 'temperatura', 730.0000, 'ºC'),
	(59477, 110, '2015-02-15 00:09:24.000000', 'temperatura', 447.0000, 'ºC'),
	(59478, 110, '2015-02-15 00:09:25.000000', 'temperatura', 46.0000, 'ºC'),
	(59479, 110, '2015-02-15 00:09:26.000000', 'temperatura', 89.0000, 'ºC'),
	(59480, 110, '2015-02-15 00:09:27.000000', 'temperatura', 307.0000, 'ºC'),
	(59481, 110, '2015-02-15 00:09:28.000000', 'temperatura', 68.0000, 'ºC'),
	(59482, 110, '2015-02-15 00:09:29.000000', 'temperatura', 619.0000, 'ºC'),
	(59483, 110, '2015-02-15 00:09:30.000000', 'temperatura', 492.0000, 'ºC'),
	(59484, 110, '2015-02-15 00:09:31.000000', 'temperatura', 604.0000, 'ºC'),
	(59485, 110, '2015-02-15 00:09:32.000000', 'temperatura', 344.0000, 'ºC'),
	(59486, 110, '2015-02-15 00:09:33.000000', 'temperatura', 1107.0000, 'ºC'),
	(59487, 110, '2015-02-15 00:09:34.000000', 'temperatura', 907.0000, 'ºC'),
	(59488, 110, '2015-02-15 00:09:35.000000', 'temperatura', 12.0000, 'ºC'),
	(59489, 110, '2015-02-15 00:09:36.000000', 'temperatura', 939.0000, 'ºC'),
	(59490, 110, '2015-02-15 00:09:37.000000', 'temperatura', 1059.0000, 'ºC'),
	(59491, 110, '2015-02-15 00:09:38.000000', 'temperatura', 79.0000, 'ºC'),
	(59492, 110, '2015-02-15 00:09:39.000000', 'temperatura', 819.0000, 'ºC'),
	(59493, 110, '2015-02-15 00:09:40.000000', 'temperatura', 259.0000, 'ºC'),
	(59494, 110, '2015-02-15 00:09:41.000000', 'temperatura', 36.0000, 'ºC'),
	(59495, 110, '2015-02-15 00:09:42.000000', 'temperatura', 605.0000, 'ºC'),
	(59496, 110, '2015-02-15 00:09:43.000000', 'temperatura', 518.0000, 'ºC'),
	(59497, 110, '2015-02-15 00:09:44.000000', 'temperatura', 776.0000, 'ºC'),
	(59498, 110, '2015-02-15 00:09:45.000000', 'temperatura', 1126.0000, 'ºC'),
	(59499, 110, '2015-02-15 00:09:46.000000', 'temperatura', 903.0000, 'ºC'),
	(59500, 110, '2015-02-15 00:09:47.000000', 'temperatura', 1137.0000, 'ºC'),
	(59501, 110, '2015-02-15 00:09:48.000000', 'temperatura', 575.0000, 'ºC'),
	(59502, 110, '2015-02-15 00:09:49.000000', 'temperatura', 664.0000, 'ºC'),
	(59503, 110, '2015-02-15 00:09:50.000000', 'temperatura', 398.0000, 'ºC'),
	(59504, 110, '2015-02-15 00:09:51.000000', 'temperatura', 1199.0000, 'ºC'),
	(59505, 110, '2015-02-15 00:09:52.000000', 'temperatura', 0.0000, 'ºC'),
	(59506, 110, '2015-02-15 00:09:53.000000', 'temperatura', 3.0000, 'ºC'),
	(59507, 110, '2015-02-15 00:09:54.000000', 'temperatura', 16.0000, 'ºC'),
	(59508, 110, '2015-02-15 00:09:55.000000', 'temperatura', 69.0000, 'ºC'),
	(59509, 110, '2015-02-15 00:09:56.000000', 'temperatura', 301.0000, 'ºC'),
	(59510, 110, '2015-02-15 00:09:57.000000', 'temperatura', 98.0000, 'ºC'),
	(59511, 110, '2015-02-15 00:09:58.000000', 'temperatura', 786.0000, 'ºC'),
	(59512, 110, '2015-02-15 00:09:59.000000', 'temperatura', 36.0000, 'ºC'),
	(59513, 110, '2015-02-15 00:10:00.000000', 'temperatura', 223.0000, 'ºC'),
	(59514, 110, '2015-02-15 00:10:01.000000', 'temperatura', 1009.0000, 'ºC'),
	(59515, 110, '2015-02-15 00:10:02.000000', 'temperatura', 774.0000, 'ºC'),
	(59516, 110, '2015-02-15 00:10:03.000000', 'temperatura', 844.0000, 'ºC'),
	(59517, 110, '2015-02-15 00:10:04.000000', 'temperatura', 697.0000, 'ºC'),
	(59518, 110, '2015-02-15 00:10:05.000000', 'temperatura', 955.0000, 'ºC'),
	(59519, 110, '2015-02-15 00:10:06.000000', 'temperatura', 284.0000, 'ºC'),
	(59520, 110, '2015-02-15 00:10:07.000000', 'temperatura', 955.0000, 'ºC'),
	(59521, 110, '2015-02-15 00:10:08.000000', 'temperatura', 325.0000, 'ºC'),
	(59522, 110, '2015-02-15 00:10:09.000000', 'temperatura', 1160.0000, 'ºC'),
	(59523, 110, '2015-02-15 00:10:10.000000', 'temperatura', 27.0000, 'ºC'),
	(59524, 110, '2015-02-15 00:10:11.000000', 'temperatura', 252.0000, 'ºC'),
	(59525, 110, '2015-02-15 00:10:12.000000', 'temperatura', 1182.0000, 'ºC'),
	(59526, 110, '2015-02-15 00:10:13.000000', 'temperatura', 356.0000, 'ºC'),
	(59527, 110, '2015-02-15 00:10:14.000000', 'temperatura', 632.0000, 'ºC'),
	(59528, 110, '2015-02-15 00:10:15.000000', 'temperatura', 891.0000, 'ºC'),
	(59529, 110, '2015-02-15 00:10:16.000000', 'temperatura', 162.0000, 'ºC'),
	(59530, 110, '2015-02-15 00:10:17.000000', 'temperatura', 535.0000, 'ºC'),
	(59531, 110, '2015-02-15 00:10:18.000000', 'temperatura', 992.0000, 'ºC'),
	(59532, 110, '2015-02-15 00:10:19.000000', 'temperatura', 953.0000, 'ºC'),
	(59533, 110, '2015-02-15 00:10:20.000000', 'temperatura', 591.0000, 'ºC'),
	(59534, 110, '2015-02-15 00:10:21.000000', 'temperatura', 98.0000, 'ºC'),
	(59535, 110, '2015-02-15 00:10:22.000000', 'temperatura', 1117.0000, 'ºC'),
	(59536, 110, '2015-02-15 00:10:23.000000', 'temperatura', 489.0000, 'ºC'),
	(59537, 110, '2015-02-15 00:10:24.000000', 'temperatura', 297.0000, 'ºC'),
	(59538, 110, '2015-02-15 00:10:25.000000', 'temperatura', 17.0000, 'ºC'),
	(59539, 110, '2015-02-15 00:10:26.000000', 'temperatura', 395.0000, 'ºC'),
	(59540, 110, '2015-02-15 00:10:27.000000', 'temperatura', 724.0000, 'ºC'),
	(59541, 110, '2015-02-15 00:10:28.000000', 'temperatura', 36.0000, 'ºC'),
	(59542, 110, '2015-02-15 00:10:29.000000', 'temperatura', 407.0000, 'ºC'),
	(59543, 110, '2015-02-15 00:10:30.000000', 'temperatura', 729.0000, 'ºC'),
	(59544, 110, '2015-02-15 00:10:31.000000', 'temperatura', 25.0000, 'ºC'),
	(59545, 110, '2015-02-15 00:10:32.000000', 'temperatura', 336.0000, 'ºC'),
	(59546, 110, '2015-02-15 00:10:33.000000', 'temperatura', 408.0000, 'ºC'),
	(59547, 110, '2015-02-15 00:10:34.000000', 'temperatura', 1030.0000, 'ºC'),
	(59548, 110, '2015-02-15 00:10:35.000000', 'temperatura', 329.0000, 'ºC'),
	(59549, 110, '2015-02-15 00:10:36.000000', 'temperatura', 957.0000, 'ºC'),
	(59550, 110, '2015-02-15 00:10:37.000000', 'temperatura', 195.0000, 'ºC'),
	(59551, 110, '2015-02-15 00:10:38.000000', 'temperatura', 505.0000, 'ºC'),
	(59552, 110, '2015-02-15 00:10:39.000000', 'temperatura', 742.0000, 'ºC'),
	(59553, 110, '2015-02-15 00:10:40.000000', 'temperatura', 993.0000, 'ºC'),
	(59554, 110, '2015-02-15 00:10:41.000000', 'temperatura', 342.0000, 'ºC'),
	(59555, 110, '2015-02-15 00:10:42.000000', 'temperatura', 1130.0000, 'ºC'),
	(59556, 110, '2015-02-15 00:10:43.000000', 'temperatura', 1023.0000, 'ºC'),
	(59557, 110, '2015-02-15 00:10:44.000000', 'temperatura', 526.0000, 'ºC'),
	(59558, 110, '2015-02-15 00:10:45.000000', 'temperatura', 763.0000, 'ºC'),
	(59559, 110, '2015-02-15 00:10:46.000000', 'temperatura', 1037.0000, 'ºC'),
	(59560, 110, '2015-02-15 00:10:47.000000', 'temperatura', 498.0000, 'ºC'),
	(59561, 110, '2015-02-15 00:10:48.000000', 'temperatura', 577.0000, 'ºC'),
	(59562, 110, '2015-02-15 00:10:49.000000', 'temperatura', 193.0000, 'ºC'),
	(59563, 110, '2015-02-15 00:10:50.000000', 'temperatura', 432.0000, 'ºC'),
	(59564, 110, '2015-02-15 00:10:51.000000', 'temperatura', 383.0000, 'ºC'),
	(59565, 110, '2015-02-15 00:10:52.000000', 'temperatura', 621.0000, 'ºC'),
	(59566, 110, '2015-02-15 00:10:53.000000', 'temperatura', 757.0000, 'ºC'),
	(59567, 110, '2015-02-15 00:10:54.000000', 'temperatura', 721.0000, 'ºC'),
	(59568, 110, '2015-02-15 00:10:55.000000', 'temperatura', 133.0000, 'ºC'),
	(59569, 110, '2015-02-15 00:10:56.000000', 'temperatura', 905.0000, 'ºC'),
	(59570, 110, '2015-02-15 00:10:57.000000', 'temperatura', 527.0000, 'ºC'),
	(59571, 110, '2015-02-15 00:10:58.000000', 'temperatura', 1120.0000, 'ºC'),
	(59572, 110, '2015-02-15 00:10:59.000000', 'temperatura', 419.0000, 'ºC'),
	(59573, 110, '2015-02-15 00:11:00.000000', 'temperatura', 1134.0000, 'ºC'),
	(59574, 110, '2015-02-15 00:11:01.000000', 'temperatura', 813.0000, 'ºC'),
	(59575, 110, '2015-02-15 00:11:02.000000', 'temperatura', 665.0000, 'ºC'),
	(59576, 110, '2015-02-15 00:11:03.000000', 'temperatura', 887.0000, 'ºC'),
	(59577, 110, '2015-02-15 00:11:04.000000', 'temperatura', 39.0000, 'ºC'),
	(59578, 110, '2015-02-15 00:11:05.000000', 'temperatura', 1134.0000, 'ºC'),
	(59579, 110, '2015-02-15 00:11:06.000000', 'temperatura', 754.0000, 'ºC'),
	(59580, 110, '2015-02-15 00:11:07.000000', 'temperatura', 369.0000, 'ºC'),
	(59581, 110, '2015-02-15 00:11:08.000000', 'temperatura', 782.0000, 'ºC'),
	(59582, 110, '2015-02-15 00:11:09.000000', 'temperatura', 404.0000, 'ºC'),
	(59583, 110, '2015-02-15 00:11:10.000000', 'temperatura', 875.0000, 'ºC'),
	(59584, 110, '2015-02-15 00:11:11.000000', 'temperatura', 764.0000, 'ºC'),
	(59585, 110, '2015-02-15 00:11:12.000000', 'temperatura', 1195.0000, 'ºC'),
	(59586, 110, '2015-02-15 00:11:13.000000', 'temperatura', 84.0000, 'ºC'),
	(59587, 110, '2015-02-15 00:11:14.000000', 'temperatura', 434.0000, 'ºC'),
	(59588, 110, '2015-02-15 00:11:15.000000', 'temperatura', 720.0000, 'ºC'),
	(59589, 110, '2015-02-15 00:11:16.000000', 'temperatura', 1098.0000, 'ºC'),
	(59590, 110, '2015-02-15 00:11:17.000000', 'temperatura', 929.0000, 'ºC'),
	(59591, 110, '2015-02-15 00:11:18.000000', 'temperatura', 153.0000, 'ºC'),
	(59592, 110, '2015-02-15 00:11:19.000000', 'temperatura', 380.0000, 'ºC'),
	(59593, 110, '2015-02-15 00:11:20.000000', 'temperatura', 240.0000, 'ºC'),
	(59594, 110, '2015-02-15 00:11:21.000000', 'temperatura', 61.0000, 'ºC'),
	(59595, 110, '2015-02-15 00:11:22.000000', 'temperatura', 783.0000, 'ºC'),
	(59596, 110, '2015-02-15 00:11:23.000000', 'temperatura', 135.0000, 'ºC'),
	(59597, 110, '2015-02-15 00:11:24.000000', 'temperatura', 728.0000, 'ºC'),
	(59598, 110, '2015-02-15 00:11:25.000000', 'temperatura', 832.0000, 'ºC'),
	(59599, 110, '2015-02-15 00:11:26.000000', 'temperatura', 777.0000, 'ºC'),
	(59600, 110, '2015-02-15 00:11:27.000000', 'temperatura', 192.0000, 'ºC'),
	(59601, 110, '2015-02-15 00:11:28.000000', 'temperatura', 1026.0000, 'ºC'),
	(59602, 110, '2015-02-15 00:11:29.000000', 'temperatura', 957.0000, 'ºC'),
	(59603, 110, '2015-02-15 00:11:30.000000', 'temperatura', 506.0000, 'ºC'),
	(59604, 110, '2015-02-15 00:11:31.000000', 'temperatura', 862.0000, 'ºC'),
	(59605, 110, '2015-02-15 00:11:32.000000', 'temperatura', 392.0000, 'ºC'),
	(59606, 110, '2015-02-15 00:11:33.000000', 'temperatura', 573.0000, 'ºC'),
	(59607, 110, '2015-02-15 00:11:34.000000', 'temperatura', 491.0000, 'ºC'),
	(59608, 110, '2015-02-15 00:11:35.000000', 'temperatura', 734.0000, 'ºC'),
	(59609, 110, '2015-02-15 00:11:36.000000', 'temperatura', 1000.0000, 'ºC'),
	(59610, 110, '2015-02-15 00:11:37.000000', 'temperatura', 397.0000, 'ºC'),
	(59611, 110, '2015-02-15 00:11:38.000000', 'temperatura', 184.0000, 'ºC'),
	(59612, 110, '2015-02-15 00:11:39.000000', 'temperatura', 933.0000, 'ºC'),
	(59613, 110, '2015-02-15 00:11:40.000000', 'temperatura', 510.0000, 'ºC'),
	(59614, 110, '2015-02-15 00:11:41.000000', 'temperatura', 955.0000, 'ºC'),
	(59615, 110, '2015-02-15 00:11:42.000000', 'temperatura', 843.0000, 'ºC'),
	(59616, 110, '2015-02-15 00:11:43.000000', 'temperatura', 152.0000, 'ºC'),
	(59617, 110, '2015-02-15 00:11:44.000000', 'temperatura', 629.0000, 'ºC'),
	(59618, 110, '2015-02-15 00:11:45.000000', 'temperatura', 291.0000, 'ºC'),
	(59619, 110, '2015-02-15 00:11:46.000000', 'temperatura', 768.0000, 'ºC'),
	(59620, 110, '2015-02-15 00:11:47.000000', 'temperatura', 569.0000, 'ºC'),
	(59621, 110, '2015-02-15 00:11:48.000000', 'temperatura', 539.0000, 'ºC'),
	(59622, 110, '2015-02-15 00:11:49.000000', 'temperatura', 989.0000, 'ºC'),
	(59623, 110, '2015-02-15 00:11:50.000000', 'temperatura', 930.0000, 'ºC'),
	(59624, 110, '2015-02-15 00:11:51.000000', 'temperatura', 484.0000, 'ºC'),
	(59625, 110, '2015-02-15 00:11:52.000000', 'temperatura', 828.0000, 'ºC'),
	(59626, 110, '2015-02-15 00:11:53.000000', 'temperatura', 288.0000, 'ºC'),
	(59627, 110, '2015-02-15 00:11:54.000000', 'temperatura', 156.0000, 'ºC'),
	(59628, 110, '2015-02-15 00:11:55.000000', 'temperatura', 1118.0000, 'ºC'),
	(59629, 110, '2015-02-15 00:11:56.000000', 'temperatura', 324.0000, 'ºC'),
	(59630, 110, '2015-02-15 00:11:57.000000', 'temperatura', 666.0000, 'ºC'),
	(59631, 110, '2015-02-15 00:11:58.000000', 'temperatura', 1157.0000, 'ºC'),
	(59632, 110, '2015-02-15 00:11:59.000000', 'temperatura', 189.0000, 'ºC'),
	(59633, 110, '2015-02-15 00:12:00.000000', 'temperatura', 1072.0000, 'ºC'),
	(59634, 110, '2015-02-15 00:12:01.000000', 'temperatura', 1195.0000, 'ºC'),
	(59635, 110, '2015-02-15 00:12:02.000000', 'temperatura', 358.0000, 'ºC'),
	(59636, 110, '2015-02-15 00:12:03.000000', 'temperatura', 608.0000, 'ºC'),
	(59637, 110, '2015-02-15 00:12:04.000000', 'temperatura', 764.0000, 'ºC'),
	(59638, 110, '2015-02-15 00:12:05.000000', 'temperatura', 796.0000, 'ºC'),
	(59639, 110, '2015-02-15 00:12:06.000000', 'temperatura', 490.0000, 'ºC'),
	(59640, 110, '2015-02-15 00:12:07.000000', 'temperatura', 63.0000, 'ºC'),
	(59641, 110, '2015-02-15 00:12:08.000000', 'temperatura', 47.0000, 'ºC'),
	(59642, 110, '2015-02-15 00:12:09.000000', 'temperatura', 45.0000, 'ºC'),
	(59643, 110, '2015-02-15 00:12:10.000000', 'temperatura', 86.0000, 'ºC'),
	(59644, 110, '2015-02-15 00:12:11.000000', 'temperatura', 293.0000, 'ºC'),
	(59645, 110, '2015-02-15 00:12:12.000000', 'temperatura', 9.0000, 'ºC'),
	(59646, 110, '2015-02-15 00:12:13.000000', 'temperatura', 365.0000, 'ºC'),
	(59647, 110, '2015-02-15 00:12:14.000000', 'temperatura', 598.0000, 'ºC'),
	(59648, 110, '2015-02-15 00:12:15.000000', 'temperatura', 697.0000, 'ºC'),
	(59649, 110, '2015-02-15 00:12:16.000000', 'temperatura', 490.0000, 'ºC'),
	(59650, 110, '2015-02-15 00:12:17.000000', 'temperatura', 358.0000, 'ºC'),
	(59651, 110, '2015-02-15 00:12:18.000000', 'temperatura', 324.0000, 'ºC'),
	(59652, 110, '2015-02-15 00:12:19.000000', 'temperatura', 546.0000, 'ºC'),
	(59653, 110, '2015-02-15 00:12:20.000000', 'temperatura', 557.0000, 'ºC'),
	(59654, 110, '2015-02-15 00:12:21.000000', 'temperatura', 1146.0000, 'ºC'),
	(59655, 110, '2015-02-15 00:12:22.000000', 'temperatura', 461.0000, 'ºC'),
	(59656, 110, '2015-02-15 00:12:23.000000', 'temperatura', 68.0000, 'ºC'),
	(59657, 110, '2015-02-15 00:12:24.000000', 'temperatura', 157.0000, 'ºC'),
	(59658, 110, '2015-02-15 00:12:25.000000', 'temperatura', 583.0000, 'ºC'),
	(59659, 110, '2015-02-15 00:12:26.000000', 'temperatura', 42.0000, 'ºC'),
	(59660, 110, '2015-02-15 00:12:27.000000', 'temperatura', 861.0000, 'ºC'),
	(59661, 110, '2015-02-15 00:12:28.000000', 'temperatura', 580.0000, 'ºC'),
	(59662, 110, '2015-02-15 00:12:29.000000', 'temperatura', 318.0000, 'ºC'),
	(59663, 110, '2015-02-15 00:12:30.000000', 'temperatura', 1050.0000, 'ºC'),
	(59664, 110, '2015-02-15 00:12:31.000000', 'temperatura', 696.0000, 'ºC'),
	(59665, 110, '2015-02-15 00:12:32.000000', 'temperatura', 330.0000, 'ºC'),
	(59666, 110, '2015-02-15 00:12:33.000000', 'temperatura', 763.0000, 'ºC'),
	(59667, 110, '2015-02-15 00:12:34.000000', 'temperatura', 424.0000, 'ºC'),
	(59668, 110, '2015-02-15 00:12:35.000000', 'temperatura', 1035.0000, 'ºC'),
	(59669, 110, '2015-02-15 00:12:36.000000', 'temperatura', 301.0000, 'ºC'),
	(59670, 110, '2015-02-15 00:12:37.000000', 'temperatura', 800.0000, 'ºC'),
	(59671, 110, '2015-02-15 00:12:38.000000', 'temperatura', 697.0000, 'ºC'),
	(59672, 110, '2015-02-15 00:12:39.000000', 'temperatura', 1085.0000, 'ºC'),
	(59673, 110, '2015-02-15 00:12:40.000000', 'temperatura', 937.0000, 'ºC'),
	(59674, 110, '2015-02-15 00:12:41.000000', 'temperatura', 229.0000, 'ºC'),
	(59675, 110, '2015-02-15 00:12:42.000000', 'temperatura', 734.0000, 'ºC'),
	(59676, 110, '2015-02-15 00:12:43.000000', 'temperatura', 584.0000, 'ºC'),
	(59677, 110, '2015-02-15 00:12:44.000000', 'temperatura', 720.0000, 'ºC'),
	(59678, 110, '2015-02-15 00:12:45.000000', 'temperatura', 649.0000, 'ºC'),
	(59679, 110, '2015-02-15 00:12:46.000000', 'temperatura', 1085.0000, 'ºC'),
	(59680, 110, '2015-02-15 00:12:47.000000', 'temperatura', 1080.0000, 'ºC'),
	(59681, 110, '2015-02-15 00:12:48.000000', 'temperatura', 945.0000, 'ºC'),
	(59682, 110, '2015-02-15 00:12:49.000000', 'temperatura', 283.0000, 'ºC'),
	(59683, 110, '2015-02-15 00:12:50.000000', 'temperatura', 981.0000, 'ºC'),
	(59684, 110, '2015-02-15 00:12:51.000000', 'temperatura', 457.0000, 'ºC'),
	(59685, 110, '2015-02-15 00:12:52.000000', 'temperatura', 544.0000, 'ºC'),
	(59686, 110, '2015-02-15 00:12:53.000000', 'temperatura', 151.0000, 'ºC'),
	(59687, 110, '2015-02-15 00:12:54.000000', 'temperatura', 320.0000, 'ºC'),
	(59688, 110, '2015-02-15 00:12:55.000000', 'temperatura', 1150.0000, 'ºC'),
	(59689, 110, '2015-02-15 00:12:56.000000', 'temperatura', 1189.0000, 'ºC'),
	(59690, 110, '2015-02-15 00:12:57.000000', 'temperatura', 94.0000, 'ºC'),
	(59691, 110, '2015-02-15 00:12:58.000000', 'temperatura', 505.0000, 'ºC'),
	(59692, 110, '2015-02-15 00:12:59.000000', 'temperatura', 1044.0000, 'ºC'),
	(59693, 110, '2015-02-15 00:13:00.000000', 'temperatura', 107.0000, 'ºC'),
	(59694, 110, '2015-02-15 00:13:01.000000', 'temperatura', 1001.0000, 'ºC'),
	(59695, 110, '2015-02-15 00:13:02.000000', 'temperatura', 1083.0000, 'ºC'),
	(59696, 110, '2015-02-15 00:13:03.000000', 'temperatura', 16.0000, 'ºC'),
	(59697, 110, '2015-02-15 00:13:04.000000', 'temperatura', 431.0000, 'ºC'),
	(59698, 110, '2015-02-15 00:13:05.000000', 'temperatura', 908.0000, 'ºC'),
	(59699, 110, '2015-02-15 00:13:06.000000', 'temperatura', 847.0000, 'ºC'),
	(59700, 110, '2015-02-15 00:13:07.000000', 'temperatura', 310.0000, 'ºC'),
	(59701, 110, '2015-02-15 00:13:08.000000', 'temperatura', 212.0000, 'ºC'),
	(59702, 110, '2015-02-15 00:13:09.000000', 'temperatura', 130.0000, 'ºC'),
	(59703, 110, '2015-02-15 00:13:10.000000', 'temperatura', 13.0000, 'ºC'),
	(59704, 110, '2015-02-15 00:13:11.000000', 'temperatura', 876.0000, 'ºC'),
	(59705, 110, '2015-02-15 00:13:12.000000', 'temperatura', 743.0000, 'ºC'),
	(59706, 110, '2015-02-15 00:13:13.000000', 'temperatura', 1088.0000, 'ºC'),
	(59707, 110, '2015-02-15 00:13:14.000000', 'temperatura', 809.0000, 'ºC'),
	(59708, 110, '2015-02-15 00:13:15.000000', 'temperatura', 784.0000, 'ºC'),
	(59709, 110, '2015-02-15 00:13:16.000000', 'temperatura', 292.0000, 'ºC'),
	(59710, 110, '2015-02-15 00:13:17.000000', 'temperatura', 309.0000, 'ºC'),
	(59711, 110, '2015-02-15 00:13:18.000000', 'temperatura', 671.0000, 'ºC'),
	(59712, 110, '2015-02-15 00:13:19.000000', 'temperatura', 27.0000, 'ºC'),
	(59713, 110, '2015-02-15 00:13:20.000000', 'temperatura', 522.0000, 'ºC'),
	(59714, 110, '2015-02-15 00:13:21.000000', 'temperatura', 131.0000, 'ºC'),
	(59715, 110, '2015-02-15 00:13:22.000000', 'temperatura', 289.0000, 'ºC'),
	(59716, 110, '2015-02-15 00:13:23.000000', 'temperatura', 1051.0000, 'ºC'),
	(59717, 110, '2015-02-15 00:13:24.000000', 'temperatura', 791.0000, 'ºC'),
	(59718, 110, '2015-02-15 00:13:25.000000', 'temperatura', 800.0000, 'ºC'),
	(59719, 110, '2015-02-15 00:13:26.000000', 'temperatura', 428.0000, 'ºC'),
	(59720, 110, '2015-02-15 00:13:27.000000', 'temperatura', 940.0000, 'ºC'),
	(59721, 110, '2015-02-15 00:13:28.000000', 'temperatura', 1017.0000, 'ºC'),
	(59722, 110, '2015-02-15 00:13:29.000000', 'temperatura', 1065.0000, 'ºC'),
	(59723, 110, '2015-02-15 00:13:30.000000', 'temperatura', 1076.0000, 'ºC'),
	(59724, 110, '2015-02-15 00:13:31.000000', 'temperatura', 986.0000, 'ºC'),
	(59725, 110, '2015-02-15 00:13:32.000000', 'temperatura', 501.0000, 'ºC'),
	(59726, 110, '2015-02-15 00:13:33.000000', 'temperatura', 746.0000, 'ºC'),
	(59727, 110, '2015-02-15 00:13:34.000000', 'temperatura', 1029.0000, 'ºC'),
	(59728, 110, '2015-02-15 00:13:35.000000', 'temperatura', 507.0000, 'ºC'),
	(59729, 110, '2015-02-15 00:13:36.000000', 'temperatura', 648.0000, 'ºC'),
	(59730, 110, '2015-02-15 00:13:37.000000', 'temperatura', 520.0000, 'ºC'),
	(59731, 110, '2015-02-15 00:13:38.000000', 'temperatura', 657.0000, 'ºC'),
	(59732, 110, '2015-02-15 00:13:39.000000', 'temperatura', 523.0000, 'ºC'),
	(59733, 110, '2015-02-15 00:13:40.000000', 'temperatura', 648.0000, 'ºC'),
	(59734, 110, '2015-02-15 00:13:41.000000', 'temperatura', 469.0000, 'ºC'),
	(59735, 110, '2015-02-15 00:13:42.000000', 'temperatura', 402.0000, 'ºC'),
	(59736, 110, '2015-02-15 00:13:43.000000', 'temperatura', 604.0000, 'ºC'),
	(59737, 110, '2015-02-15 00:13:44.000000', 'temperatura', 613.0000, 'ºC'),
	(59738, 110, '2015-02-15 00:13:45.000000', 'temperatura', 56.0000, 'ºC'),
	(59739, 110, '2015-02-15 00:13:46.000000', 'temperatura', 842.0000, 'ºC'),
	(59740, 110, '2015-02-15 00:13:47.000000', 'temperatura', 441.0000, 'ºC'),
	(59741, 110, '2015-02-15 00:13:48.000000', 'temperatura', 881.0000, 'ºC'),
	(59742, 110, '2015-02-15 00:13:49.000000', 'temperatura', 680.0000, 'ºC'),
	(59743, 110, '2015-02-15 00:13:50.000000', 'temperatura', 759.0000, 'ºC'),
	(59744, 110, '2015-02-15 00:13:51.000000', 'temperatura', 553.0000, 'ºC'),
	(59745, 110, '2015-02-15 00:13:52.000000', 'temperatura', 491.0000, 'ºC'),
	(59746, 110, '2015-02-15 00:13:53.000000', 'temperatura', 794.0000, 'ºC'),
	(59747, 110, '2015-02-15 00:13:54.000000', 'temperatura', 98.0000, 'ºC'),
	(59748, 110, '2015-02-15 00:13:55.000000', 'temperatura', 508.0000, 'ºC'),
	(59749, 110, '2015-02-15 00:13:56.000000', 'temperatura', 1049.0000, 'ºC'),
	(59750, 110, '2015-02-15 00:13:57.000000', 'temperatura', 121.0000, 'ºC'),
	(59751, 110, '2015-02-15 00:13:58.000000', 'temperatura', 1058.0000, 'ºC'),
	(59752, 110, '2015-02-15 00:13:59.000000', 'temperatura', 128.0000, 'ºC'),
	(59753, 110, '2015-02-15 00:14:00.000000', 'temperatura', 1064.0000, 'ºC'),
	(59754, 110, '2015-02-15 00:14:01.000000', 'temperatura', 140.0000, 'ºC'),
	(59755, 110, '2015-02-15 00:14:02.000000', 'temperatura', 1106.0000, 'ºC'),
	(59756, 110, '2015-02-15 00:14:03.000000', 'temperatura', 311.0000, 'ºC'),
	(59757, 110, '2015-02-15 00:14:04.000000', 'temperatura', 638.0000, 'ºC'),
	(59758, 110, '2015-02-15 00:14:05.000000', 'temperatura', 1058.0000, 'ºC'),
	(59759, 110, '2015-02-15 00:14:06.000000', 'temperatura', 974.0000, 'ºC'),
	(59760, 110, '2015-02-15 00:14:07.000000', 'temperatura', 499.0000, 'ºC'),
	(59761, 110, '2015-02-15 00:14:08.000000', 'temperatura', 772.0000, 'ºC'),
	(59762, 110, '2015-02-15 00:14:09.000000', 'temperatura', 1163.0000, 'ºC'),
	(59763, 110, '2015-02-15 00:14:10.000000', 'temperatura', 1102.0000, 'ºC'),
	(59764, 110, '2015-02-15 00:14:11.000000', 'temperatura', 819.0000, 'ºC'),
	(59765, 110, '2015-02-15 00:14:12.000000', 'temperatura', 791.0000, 'ºC'),
	(59766, 110, '2015-02-15 00:14:13.000000', 'temperatura', 298.0000, 'ºC'),
	(59767, 110, '2015-02-15 00:14:14.000000', 'temperatura', 318.0000, 'ºC'),
	(59768, 110, '2015-02-15 00:14:15.000000', 'temperatura', 696.0000, 'ºC'),
	(59769, 110, '2015-02-15 00:14:16.000000', 'temperatura', 126.0000, 'ºC'),
	(59770, 110, '2015-02-15 00:14:17.000000', 'temperatura', 943.0000, 'ºC'),
	(59771, 110, '2015-02-15 00:14:18.000000', 'temperatura', 735.0000, 'ºC'),
	(59772, 110, '2015-02-15 00:14:19.000000', 'temperatura', 850.0000, 'ºC'),
	(59773, 110, '2015-02-15 00:14:20.000000', 'temperatura', 844.0000, 'ºC'),
	(59774, 110, '2015-02-15 00:14:21.000000', 'temperatura', 471.0000, 'ºC'),
	(59775, 110, '2015-02-15 00:14:22.000000', 'temperatura', 1024.0000, 'ºC'),
	(59776, 110, '2015-02-15 00:14:23.000000', 'temperatura', 109.0000, 'ºC'),
	(59777, 110, '2015-02-15 00:14:24.000000', 'temperatura', 1071.0000, 'ºC'),
	(59778, 110, '2015-02-15 00:14:25.000000', 'temperatura', 231.0000, 'ºC'),
	(59779, 110, '2015-02-15 00:14:26.000000', 'temperatura', 342.0000, 'ºC'),
	(59780, 110, '2015-02-15 00:14:27.000000', 'temperatura', 1016.0000, 'ºC'),
	(59781, 110, '2015-02-15 00:14:28.000000', 'temperatura', 453.0000, 'ºC'),
	(59782, 110, '2015-02-15 00:14:29.000000', 'temperatura', 420.0000, 'ºC'),
	(59783, 110, '2015-02-15 00:14:30.000000', 'temperatura', 742.0000, 'ºC'),
	(59784, 110, '2015-02-15 00:14:31.000000', 'temperatura', 50.0000, 'ºC'),
	(59785, 110, '2015-02-15 00:14:32.000000', 'temperatura', 423.0000, 'ºC'),
	(59786, 110, '2015-02-15 00:14:33.000000', 'temperatura', 766.0000, 'ºC'),
	(59787, 110, '2015-02-15 00:14:34.000000', 'temperatura', 164.0000, 'ºC'),
	(59788, 110, '2015-02-15 00:14:35.000000', 'temperatura', 919.0000, 'ºC'),
	(59789, 110, '2015-02-15 00:14:36.000000', 'temperatura', 507.0000, 'ºC'),
	(59790, 110, '2015-02-15 00:14:37.000000', 'temperatura', 976.0000, 'ºC'),
	(59791, 110, '2015-02-15 00:14:38.000000', 'temperatura', 959.0000, 'ºC'),
	(59792, 110, '2015-02-15 00:14:39.000000', 'temperatura', 667.0000, 'ºC'),
	(59793, 110, '2015-02-15 00:14:40.000000', 'temperatura', 459.0000, 'ºC'),
	(59794, 110, '2015-02-15 00:14:41.000000', 'temperatura', 293.0000, 'ºC'),
	(59795, 110, '2015-02-15 00:14:42.000000', 'temperatura', 90.0000, 'ºC'),
	(59796, 110, '2015-02-15 00:14:43.000000', 'temperatura', 770.0000, 'ºC'),
	(59797, 110, '2015-02-15 00:14:44.000000', 'temperatura', 1180.0000, 'ºC'),
	(59798, 110, '2015-02-15 00:14:45.000000', 'temperatura', 1192.0000, 'ºC'),
	(59799, 110, '2015-02-15 00:14:46.000000', 'temperatura', 19.0000, 'ºC'),
	(59800, 110, '2015-02-15 00:14:47.000000', 'temperatura', 122.0000, 'ºC'),
	(59801, 110, '2015-02-15 00:14:48.000000', 'temperatura', 551.0000, 'ºC'),
	(59802, 110, '2015-02-15 00:14:49.000000', 'temperatura', 1190.0000, 'ºC'),
	(59803, 110, '2015-02-15 00:14:50.000000', 'temperatura', 699.0000, 'ºC'),
	(59804, 110, '2015-02-15 00:14:51.000000', 'temperatura', 1127.0000, 'ºC'),
	(59805, 110, '2015-02-15 00:14:52.000000', 'temperatura', 1135.0000, 'ºC'),
	(59806, 110, '2015-02-15 00:14:53.000000', 'temperatura', 1098.0000, 'ºC'),
	(59807, 110, '2015-02-15 00:14:54.000000', 'temperatura', 884.0000, 'ºC'),
	(59808, 110, '2015-02-15 00:14:55.000000', 'temperatura', 1125.0000, 'ºC'),
	(59809, 110, '2015-02-15 00:14:56.000000', 'temperatura', 572.0000, 'ºC'),
	(59810, 110, '2015-02-15 00:14:57.000000', 'temperatura', 689.0000, 'ºC'),
	(59811, 110, '2015-02-15 00:14:58.000000', 'temperatura', 530.0000, 'ºC'),
	(59812, 110, '2015-02-15 00:14:59.000000', 'temperatura', 581.0000, 'ºC'),
	(59813, 110, '2015-02-15 00:15:00.000000', 'temperatura', 115.0000, 'ºC'),
	(59814, 110, '2015-02-15 00:15:01.000000', 'temperatura', 35.0000, 'ºC'),
	(59815, 110, '2015-02-15 00:15:02.000000', 'temperatura', 1028.0000, 'ºC'),
	(59816, 110, '2015-02-15 00:15:03.000000', 'temperatura', 237.0000, 'ºC'),
	(59817, 110, '2015-02-15 00:15:04.000000', 'temperatura', 503.0000, 'ºC'),
	(59818, 110, '2015-02-15 00:15:05.000000', 'temperatura', 602.0000, 'ºC'),
	(59819, 110, '2015-02-15 00:15:06.000000', 'temperatura', 304.0000, 'ºC'),
	(59820, 110, '2015-02-15 00:15:07.000000', 'temperatura', 912.0000, 'ºC'),
	(59821, 110, '2015-02-15 00:15:08.000000', 'temperatura', 50.0000, 'ºC'),
	(59822, 110, '2015-02-15 00:15:09.000000', 'temperatura', 1113.0000, 'ºC'),
	(59823, 110, '2015-02-15 00:15:10.000000', 'temperatura', 614.0000, 'ºC'),
	(59824, 110, '2015-02-15 00:15:11.000000', 'temperatura', 934.0000, 'ºC'),
	(59825, 110, '2015-02-15 00:15:12.000000', 'temperatura', 427.0000, 'ºC'),
	(59826, 110, '2015-02-15 00:15:13.000000', 'temperatura', 535.0000, 'ºC'),
	(59827, 110, '2015-02-15 00:15:14.000000', 'temperatura', 195.0000, 'ºC'),
	(59828, 110, '2015-02-15 00:15:15.000000', 'temperatura', 571.0000, 'ºC'),
	(59829, 110, '2015-02-15 00:15:16.000000', 'temperatura', 1071.0000, 'ºC'),
	(59830, 110, '2015-02-15 00:15:17.000000', 'temperatura', 42.0000, 'ºC'),
	(59831, 110, '2015-02-15 00:15:18.000000', 'temperatura', 597.0000, 'ºC'),
	(59832, 110, '2015-02-15 00:15:19.000000', 'temperatura', 461.0000, 'ºC'),
	(59833, 110, '2015-02-15 00:15:20.000000', 'temperatura', 512.0000, 'ºC'),
	(59834, 110, '2015-02-15 00:15:21.000000', 'temperatura', 1180.0000, 'ºC'),
	(59835, 110, '2015-02-15 00:15:22.000000', 'temperatura', 765.0000, 'ºC'),
	(59836, 110, '2015-02-15 00:15:23.000000', 'temperatura', 285.0000, 'ºC'),
	(59837, 110, '2015-02-15 00:15:24.000000', 'temperatura', 331.0000, 'ºC'),
	(59838, 110, '2015-02-15 00:15:25.000000', 'temperatura', 799.0000, 'ºC'),
	(59839, 110, '2015-02-15 00:15:26.000000', 'temperatura', 602.0000, 'ºC'),
	(59840, 110, '2015-02-15 00:15:27.000000', 'temperatura', 613.0000, 'ºC'),
	(59841, 110, '2015-02-15 00:15:28.000000', 'temperatura', 60.0000, 'ºC'),
	(59842, 110, '2015-02-15 00:15:29.000000', 'temperatura', 863.0000, 'ºC'),
	(59843, 110, '2015-02-15 00:15:30.000000', 'temperatura', 535.0000, 'ºC'),
	(59844, 110, '2015-02-15 00:15:31.000000', 'temperatura', 84.0000, 'ºC'),
	(59845, 110, '2015-02-15 00:15:32.000000', 'temperatura', 19.0000, 'ºC'),
	(59846, 110, '2015-02-15 00:15:33.000000', 'temperatura', 1042.0000, 'ºC'),
	(59847, 110, '2015-02-15 00:15:34.000000', 'temperatura', 353.0000, 'ºC'),
	(59848, 110, '2015-02-15 00:15:35.000000', 'temperatura', 1038.0000, 'ºC'),
	(59849, 110, '2015-02-15 00:15:36.000000', 'temperatura', 535.0000, 'ºC'),
	(59850, 110, '2015-02-15 00:15:37.000000', 'temperatura', 758.0000, 'ºC'),
	(59851, 110, '2015-02-15 00:15:38.000000', 'temperatura', 989.0000, 'ºC'),
	(59852, 110, '2015-02-15 00:15:39.000000', 'temperatura', 269.0000, 'ºC'),
	(59853, 110, '2015-02-15 00:15:40.000000', 'temperatura', 779.0000, 'ºC'),
	(59854, 110, '2015-02-15 00:15:41.000000', 'temperatura', 689.0000, 'ºC'),
	(59855, 110, '2015-02-15 00:15:42.000000', 'temperatura', 1110.0000, 'ºC'),
	(59856, 110, '2015-02-15 00:15:43.000000', 'temperatura', 1084.0000, 'ºC'),
	(59857, 110, '2015-02-15 00:15:44.000000', 'temperatura', 888.0000, 'ºC'),
	(59858, 110, '2015-02-15 00:15:45.000000', 'temperatura', 1187.0000, 'ºC'),
	(59859, 110, '2015-02-15 00:15:46.000000', 'temperatura', 875.0000, 'ºC'),
	(59860, 110, '2015-02-15 00:15:47.000000', 'temperatura', 813.0000, 'ºC'),
	(59861, 110, '2015-02-15 00:15:48.000000', 'temperatura', 239.0000, 'ºC'),
	(59862, 110, '2015-02-15 00:15:49.000000', 'temperatura', 1157.0000, 'ºC'),
	(59863, 110, '2015-02-15 00:15:50.000000', 'temperatura', 268.0000, 'ºC'),
	(59864, 110, '2015-02-15 00:15:51.000000', 'temperatura', 271.0000, 'ºC'),
	(59865, 110, '2015-02-15 00:15:52.000000', 'temperatura', 549.0000, 'ºC'),
	(59866, 110, '2015-02-15 00:15:53.000000', 'temperatura', 734.0000, 'ºC'),
	(59867, 110, '2015-02-15 00:15:54.000000', 'temperatura', 823.0000, 'ºC'),
	(59868, 110, '2015-02-15 00:15:55.000000', 'temperatura', 716.0000, 'ºC'),
	(59869, 110, '2015-02-15 00:15:56.000000', 'temperatura', 1109.0000, 'ºC'),
	(59870, 110, '2015-02-15 00:15:57.000000', 'temperatura', 996.0000, 'ºC'),
	(59871, 110, '2015-02-15 00:15:58.000000', 'temperatura', 455.0000, 'ºC'),
	(59872, 110, '2015-02-15 00:15:59.000000', 'temperatura', 489.0000, 'ºC'),
	(59873, 110, '2015-02-15 00:16:00.000000', 'temperatura', 1077.0000, 'ºC'),
	(59874, 110, '2015-02-15 00:16:01.000000', 'temperatura', 322.0000, 'ºC'),
	(59875, 110, '2015-02-15 00:16:02.000000', 'temperatura', 776.0000, 'ºC'),
	(59876, 110, '2015-02-15 00:16:03.000000', 'temperatura', 517.0000, 'ºC'),
	(59877, 110, '2015-02-15 00:16:04.000000', 'temperatura', 257.0000, 'ºC'),
	(59878, 110, '2015-02-15 00:16:05.000000', 'temperatura', 936.0000, 'ºC'),
	(59879, 110, '2015-02-15 00:16:06.000000', 'temperatura', 308.0000, 'ºC'),
	(59880, 110, '2015-02-15 00:16:07.000000', 'temperatura', 1132.0000, 'ºC'),
	(59881, 110, '2015-02-15 00:16:08.000000', 'temperatura', 1137.0000, 'ºC'),
	(59882, 110, '2015-02-15 00:16:09.000000', 'temperatura', 1088.0000, 'ºC'),
	(59883, 110, '2015-02-15 00:16:10.000000', 'temperatura', 831.0000, 'ºC'),
	(59884, 110, '2015-02-15 00:16:11.000000', 'temperatura', 890.0000, 'ºC'),
	(59885, 110, '2015-02-15 00:16:12.000000', 'temperatura', 758.0000, 'ºC'),
	(59886, 110, '2015-02-15 00:16:13.000000', 'temperatura', 1123.0000, 'ºC'),
	(59887, 110, '2015-02-15 00:16:14.000000', 'temperatura', 939.0000, 'ºC'),
	(59888, 110, '2015-02-15 00:16:15.000000', 'temperatura', 128.0000, 'ºC'),
	(59889, 110, '2015-02-15 00:16:16.000000', 'temperatura', 222.0000, 'ºC'),
	(59890, 110, '2015-02-15 00:16:17.000000', 'temperatura', 727.0000, 'ºC'),
	(59891, 110, '2015-02-15 00:16:18.000000', 'temperatura', 568.0000, 'ºC'),
	(59892, 110, '2015-02-15 00:16:19.000000', 'temperatura', 662.0000, 'ºC'),
	(59893, 110, '2015-02-15 00:16:20.000000', 'temperatura', 404.0000, 'ºC'),
	(59894, 110, '2015-02-15 00:16:21.000000', 'temperatura', 34.0000, 'ºC'),
	(59895, 110, '2015-02-15 00:16:22.000000', 'temperatura', 160.0000, 'ºC'),
	(59896, 110, '2015-02-15 00:16:23.000000', 'temperatura', 697.0000, 'ºC'),
	(59897, 110, '2015-02-15 00:16:24.000000', 'temperatura', 607.0000, 'ºC'),
	(59898, 110, '2015-02-15 00:16:25.000000', 'temperatura', 943.0000, 'ºC'),
	(59899, 110, '2015-02-15 00:16:26.000000', 'temperatura', 497.0000, 'ºC'),
	(59900, 110, '2015-02-15 00:16:27.000000', 'temperatura', 856.0000, 'ºC'),
	(59901, 110, '2015-02-15 00:16:28.000000', 'temperatura', 389.0000, 'ºC'),
	(59902, 110, '2015-02-15 00:16:29.000000', 'temperatura', 579.0000, 'ºC'),
	(59903, 110, '2015-02-15 00:16:30.000000', 'temperatura', 528.0000, 'ºC'),
	(59904, 110, '2015-02-15 00:16:31.000000', 'temperatura', 903.0000, 'ºC'),
	(59905, 110, '2015-02-15 00:16:32.000000', 'temperatura', 530.0000, 'ºC'),
	(59906, 110, '2015-02-15 00:16:33.000000', 'temperatura', 1141.0000, 'ºC'),
	(59907, 110, '2015-02-15 00:16:34.000000', 'temperatura', 517.0000, 'ºC'),
	(59908, 110, '2015-02-15 00:16:35.000000', 'temperatura', 362.0000, 'ºC'),
	(59909, 110, '2015-02-15 00:16:36.000000', 'temperatura', 260.0000, 'ºC'),
	(59910, 110, '2015-02-15 00:16:37.000000', 'temperatura', 216.0000, 'ºC'),
	(59911, 110, '2015-02-15 00:16:38.000000', 'temperatura', 298.0000, 'ºC'),
	(59912, 110, '2015-02-15 00:16:39.000000', 'temperatura', 843.0000, 'ºC'),
	(59913, 110, '2015-02-15 00:16:40.000000', 'temperatura', 922.0000, 'ºC'),
	(59914, 110, '2015-02-15 00:16:41.000000', 'temperatura', 883.0000, 'ºC'),
	(59915, 110, '2015-02-15 00:16:42.000000', 'temperatura', 446.0000, 'ºC'),
	(59916, 110, '2015-02-15 00:16:43.000000', 'temperatura', 784.0000, 'ºC'),
	(59917, 110, '2015-02-15 00:16:44.000000', 'temperatura', 182.0000, 'ºC'),
	(59918, 110, '2015-02-15 00:16:45.000000', 'temperatura', 958.0000, 'ºC'),
	(59919, 110, '2015-02-15 00:16:46.000000', 'temperatura', 643.0000, 'ºC'),
	(59920, 110, '2015-02-15 00:16:47.000000', 'temperatura', 345.0000, 'ºC'),
	(59921, 110, '2015-02-15 00:16:48.000000', 'temperatura', 994.0000, 'ºC'),
	(59922, 110, '2015-02-15 00:16:49.000000', 'temperatura', 335.0000, 'ºC'),
	(59923, 110, '2015-02-15 00:16:50.000000', 'temperatura', 1094.0000, 'ºC'),
	(59924, 110, '2015-02-15 00:16:51.000000', 'temperatura', 866.0000, 'ºC'),
	(59925, 110, '2015-02-15 00:16:52.000000', 'temperatura', 1049.0000, 'ºC'),
	(59926, 110, '2015-02-15 00:16:53.000000', 'temperatura', 248.0000, 'ºC'),
	(59927, 110, '2015-02-15 00:16:54.000000', 'temperatura', 495.0000, 'ºC'),
	(59928, 110, '2015-02-15 00:16:55.000000', 'temperatura', 529.0000, 'ºC'),
	(59929, 110, '2015-02-15 00:16:56.000000', 'temperatura', 1162.0000, 'ºC'),
	(59930, 110, '2015-02-15 00:16:57.000000', 'temperatura', 625.0000, 'ºC'),
	(59931, 110, '2015-02-15 00:16:58.000000', 'temperatura', 837.0000, 'ºC'),
	(59932, 110, '2015-02-15 00:16:59.000000', 'temperatura', 1111.0000, 'ºC'),
	(59933, 110, '2015-02-15 00:17:00.000000', 'temperatura', 646.0000, 'ºC'),
	(59934, 110, '2015-02-15 00:17:01.000000', 'temperatura', 1096.0000, 'ºC'),
	(59935, 110, '2015-02-15 00:17:02.000000', 'temperatura', 1141.0000, 'ºC'),
	(59936, 110, '2015-02-15 00:17:03.000000', 'temperatura', 18.0000, 'ºC'),
	(59937, 110, '2015-02-15 00:17:04.000000', 'temperatura', 267.0000, 'ºC'),
	(59938, 110, '2015-02-15 00:17:05.000000', 'temperatura', 84.0000, 'ºC'),
	(59939, 110, '2015-02-15 00:17:06.000000', 'temperatura', 820.0000, 'ºC'),
	(59940, 110, '2015-02-15 00:17:07.000000', 'temperatura', 247.0000, 'ºC'),
	(59941, 110, '2015-02-15 00:17:08.000000', 'temperatura', 1175.0000, 'ºC'),
	(59942, 110, '2015-02-15 00:17:09.000000', 'temperatura', 336.0000, 'ºC'),
	(59943, 110, '2015-02-15 00:17:10.000000', 'temperatura', 555.0000, 'ºC'),
	(59944, 110, '2015-02-15 00:17:11.000000', 'temperatura', 567.0000, 'ºC'),
	(59945, 110, '2015-02-15 00:17:12.000000', 'temperatura', 1173.0000, 'ºC'),
	(59946, 110, '2015-02-15 00:17:13.000000', 'temperatura', 562.0000, 'ºC'),
	(59947, 110, '2015-02-15 00:17:14.000000', 'temperatura', 490.0000, 'ºC'),
	(59948, 110, '2015-02-15 00:17:15.000000', 'temperatura', 767.0000, 'ºC'),
	(59949, 110, '2015-02-15 00:17:16.000000', 'temperatura', 1166.0000, 'ºC'),
	(59950, 110, '2015-02-15 00:17:17.000000', 'temperatura', 1128.0000, 'ºC'),
	(59951, 110, '2015-02-15 00:17:18.000000', 'temperatura', 944.0000, 'ºC'),
	(59952, 110, '2015-02-15 00:17:19.000000', 'temperatura', 136.0000, 'ºC'),
	(59953, 110, '2015-02-15 00:17:20.000000', 'temperatura', 250.0000, 'ºC'),
	(59954, 110, '2015-02-15 00:17:21.000000', 'temperatura', 840.0000, 'ºC'),
	(59955, 110, '2015-02-15 00:17:22.000000', 'temperatura', 1053.0000, 'ºC'),
	(59956, 110, '2015-02-15 00:17:23.000000', 'temperatura', 346.0000, 'ºC'),
	(59957, 110, '2015-02-15 00:17:24.000000', 'temperatura', 971.0000, 'ºC'),
	(59958, 110, '2015-02-15 00:17:25.000000', 'temperatura', 219.0000, 'ºC'),
	(59959, 110, '2015-02-15 00:17:26.000000', 'temperatura', 580.0000, 'ºC'),
	(59960, 110, '2015-02-15 00:17:27.000000', 'temperatura', 1045.0000, 'ºC'),
	(59961, 110, '2015-02-15 00:17:28.000000', 'temperatura', 1086.0000, 'ºC'),
	(59962, 110, '2015-02-15 00:17:29.000000', 'temperatura', 1094.0000, 'ºC'),
	(59963, 110, '2015-02-15 00:17:30.000000', 'temperatura', 1012.0000, 'ºC'),
	(59964, 110, '2015-02-15 00:17:31.000000', 'temperatura', 579.0000, 'ºC'),
	(59965, 110, '2015-02-15 00:17:32.000000', 'temperatura', 1058.0000, 'ºC'),
	(59966, 110, '2015-02-15 00:17:33.000000', 'temperatura', 1155.0000, 'ºC'),
	(59967, 110, '2015-02-15 00:17:34.000000', 'temperatura', 202.0000, 'ºC'),
	(59968, 110, '2015-02-15 00:17:35.000000', 'temperatura', 1144.0000, 'ºC'),
	(59969, 110, '2015-02-15 00:17:36.000000', 'temperatura', 315.0000, 'ºC'),
	(59970, 110, '2015-02-15 00:17:37.000000', 'temperatura', 542.0000, 'ºC'),
	(59971, 110, '2015-02-15 00:17:38.000000', 'temperatura', 566.0000, 'ºC'),
	(59972, 110, '2015-02-15 00:17:39.000000', 'temperatura', 3.0000, 'ºC'),
	(59973, 110, '2015-02-15 00:17:40.000000', 'temperatura', 720.0000, 'ºC'),
	(59974, 110, '2015-02-15 00:17:41.000000', 'temperatura', 1189.0000, 'ºC'),
	(59975, 110, '2015-02-15 00:17:42.000000', 'temperatura', 187.0000, 'ºC'),
	(59976, 110, '2015-02-15 00:17:43.000000', 'temperatura', 969.0000, 'ºC'),
	(59977, 110, '2015-02-15 00:17:44.000000', 'temperatura', 683.0000, 'ºC'),
	(59978, 110, '2015-02-15 00:17:45.000000', 'temperatura', 511.0000, 'ºC'),
	(59979, 110, '2015-02-15 00:17:46.000000', 'temperatura', 505.0000, 'ºC'),
	(59980, 110, '2015-02-15 00:17:47.000000', 'temperatura', 991.0000, 'ºC'),
	(59981, 110, '2015-02-15 00:17:48.000000', 'temperatura', 1043.0000, 'ºC'),
	(59982, 110, '2015-02-15 00:17:49.000000', 'temperatura', 1043.0000, 'ºC'),
	(59983, 110, '2015-02-15 00:17:50.000000', 'temperatura', 887.0000, 'ºC'),
	(59984, 110, '2015-02-15 00:17:51.000000', 'temperatura', 107.0000, 'ºC'),
	(59985, 110, '2015-02-15 00:17:52.000000', 'temperatura', 272.0000, 'ºC'),
	(59986, 110, '2015-02-15 00:17:53.000000', 'temperatura', 1039.0000, 'ºC'),
	(59987, 110, '2015-02-15 00:17:54.000000', 'temperatura', 779.0000, 'ºC'),
	(59988, 110, '2015-02-15 00:17:55.000000', 'temperatura', 782.0000, 'ºC'),
	(59989, 110, '2015-02-15 00:17:56.000000', 'temperatura', 371.0000, 'ºC'),
	(59990, 110, '2015-02-15 00:17:57.000000', 'temperatura', 708.0000, 'ºC'),
	(59991, 110, '2015-02-15 00:17:58.000000', 'temperatura', 30.0000, 'ºC'),
	(59992, 110, '2015-02-15 00:17:59.000000', 'temperatura', 426.0000, 'ºC'),
	(59993, 110, '2015-02-15 00:18:00.000000', 'temperatura', 839.0000, 'ºC'),
	(59994, 110, '2015-02-15 00:18:01.000000', 'temperatura', 520.0000, 'ºC'),
	(59995, 110, '2015-02-15 00:18:02.000000', 'temperatura', 84.0000, 'ºC'),
	(59996, 110, '2015-02-15 00:18:03.000000', 'temperatura', 61.0000, 'ºC'),
	(59997, 110, '2015-02-15 00:18:04.000000', 'temperatura', 50.0000, 'ºC'),
	(59998, 110, '2015-02-15 00:18:05.000000', 'temperatura', 70.0000, 'ºC'),
	(59999, 110, '2015-02-15 00:18:06.000000', 'temperatura', 202.0000, 'ºC'),
	(60000, 110, '2015-02-15 00:18:07.000000', 'temperatura', 799.0000, 'ºC'),
	(60001, 110, '2015-02-15 00:18:08.000000', 'temperatura', 990.0000, 'ºC'),
	(60002, 110, '2015-02-15 00:18:09.000000', 'temperatura', 152.0000, 'ºC'),
	(60003, 110, '2015-02-15 00:18:10.000000', 'temperatura', 192.0000, 'ºC'),
	(60004, 110, '2015-02-15 00:18:11.000000', 'temperatura', 505.0000, 'ºC'),
	(60005, 110, '2015-02-15 00:18:12.000000', 'temperatura', 750.0000, 'ºC'),
	(60006, 110, '2015-02-15 00:18:13.000000', 'temperatura', 1037.0000, 'ºC'),
	(60007, 110, '2015-02-15 00:18:14.000000', 'temperatura', 532.0000, 'ºC'),
	(60008, 110, '2015-02-15 00:18:15.000000', 'temperatura', 753.0000, 'ºC'),
	(60009, 110, '2015-02-15 00:18:16.000000', 'temperatura', 966.0000, 'ºC'),
	(60010, 110, '2015-02-15 00:18:17.000000', 'temperatura', 173.0000, 'ºC'),
	(60011, 110, '2015-02-15 00:18:18.000000', 'temperatura', 369.0000, 'ºC'),
	(60012, 110, '2015-02-15 00:18:19.000000', 'temperatura', 125.0000, 'ºC'),
	(60013, 110, '2015-02-15 00:18:20.000000', 'temperatura', 719.0000, 'ºC'),
	(60014, 110, '2015-02-15 00:18:21.000000', 'temperatura', 819.0000, 'ºC'),
	(60015, 110, '2015-02-15 00:18:22.000000', 'temperatura', 737.0000, 'ºC'),
	(60016, 110, '2015-02-15 00:18:23.000000', 'temperatura', 32.0000, 'ºC'),
	(60017, 110, '2015-02-15 00:18:24.000000', 'temperatura', 346.0000, 'ºC'),
	(60018, 110, '2015-02-15 00:18:25.000000', 'temperatura', 438.0000, 'ºC'),
	(60019, 110, '2015-02-15 00:18:26.000000', 'temperatura', 1151.0000, 'ºC'),
	(60020, 110, '2015-02-15 00:18:27.000000', 'temperatura', 842.0000, 'ºC'),
	(60021, 110, '2015-02-15 00:18:28.000000', 'temperatura', 756.0000, 'ºC'),
	(60022, 110, '2015-02-15 00:18:29.000000', 'temperatura', 56.0000, 'ºC'),
	(60023, 110, '2015-02-15 00:18:30.000000', 'temperatura', 414.0000, 'ºC'),
	(60024, 110, '2015-02-15 00:18:31.000000', 'temperatura', 701.0000, 'ºC'),
	(60025, 110, '2015-02-15 00:18:32.000000', 'temperatura', 1065.0000, 'ºC'),
	(60026, 110, '2015-02-15 00:18:33.000000', 'temperatura', 823.0000, 'ºC'),
	(60027, 110, '2015-02-15 00:18:34.000000', 'temperatura', 920.0000, 'ºC'),
	(60028, 110, '2015-02-15 00:18:35.000000', 'temperatura', 932.0000, 'ºC'),
	(60029, 110, '2015-02-15 00:18:36.000000', 'temperatura', 700.0000, 'ºC'),
	(60030, 110, '2015-02-15 00:18:37.000000', 'temperatura', 705.0000, 'ºC'),
	(60031, 110, '2015-02-15 00:18:38.000000', 'temperatura', 224.0000, 'ºC'),
	(60032, 110, '2015-02-15 00:18:39.000000', 'temperatura', 208.0000, 'ºC'),
	(60033, 110, '2015-02-15 00:18:40.000000', 'temperatura', 367.0000, 'ºC'),
	(60034, 110, '2015-02-15 00:18:41.000000', 'temperatura', 10.0000, 'ºC'),
	(60035, 110, '2015-02-15 00:18:42.000000', 'temperatura', 152.0000, 'ºC'),
	(60036, 110, '2015-02-15 00:18:43.000000', 'temperatura', 729.0000, 'ºC'),
	(60037, 110, '2015-02-15 00:18:44.000000', 'temperatura', 791.0000, 'ºC'),
	(60038, 110, '2015-02-15 00:18:45.000000', 'temperatura', 569.0000, 'ºC'),
	(60039, 110, '2015-02-15 00:18:46.000000', 'temperatura', 470.0000, 'ºC'),
	(60040, 110, '2015-02-15 00:18:47.000000', 'temperatura', 645.0000, 'ºC'),
	(60041, 110, '2015-02-15 00:18:48.000000', 'temperatura', 616.0000, 'ºC'),
	(60042, 110, '2015-02-15 00:18:49.000000', 'temperatura', 1146.0000, 'ºC'),
	(60043, 110, '2015-02-15 00:18:50.000000', 'temperatura', 282.0000, 'ºC'),
	(60044, 110, '2015-02-15 00:18:51.000000', 'temperatura', 374.0000, 'ºC'),
	(60045, 110, '2015-02-15 00:18:52.000000', 'temperatura', 1022.0000, 'ºC'),
	(60046, 110, '2015-02-15 00:18:53.000000', 'temperatura', 388.0000, 'ºC'),
	(60047, 110, '2015-02-15 00:18:54.000000', 'temperatura', 77.0000, 'ºC'),
	(60048, 110, '2015-02-15 00:18:55.000000', 'temperatura', 422.0000, 'ºC'),
	(60049, 110, '2015-02-15 00:18:56.000000', 'temperatura', 680.0000, 'ºC'),
	(60050, 110, '2015-02-15 00:18:57.000000', 'temperatura', 931.0000, 'ºC'),
	(60051, 110, '2015-02-15 00:18:58.000000', 'temperatura', 219.0000, 'ºC'),
	(60052, 110, '2015-02-15 00:18:59.000000', 'temperatura', 701.0000, 'ºC'),
	(60053, 110, '2015-02-15 00:19:00.000000', 'temperatura', 448.0000, 'ºC'),
	(60054, 110, '2015-02-15 00:19:01.000000', 'temperatura', 137.0000, 'ºC'),
	(60055, 110, '2015-02-15 00:19:02.000000', 'temperatura', 543.0000, 'ºC'),
	(60056, 110, '2015-02-15 00:19:03.000000', 'temperatura', 1103.0000, 'ºC'),
	(60057, 110, '2015-02-15 00:19:04.000000', 'temperatura', 288.0000, 'ºC'),
	(60058, 110, '2015-02-15 00:19:05.000000', 'temperatura', 529.0000, 'ºC'),
	(60059, 110, '2015-02-15 00:19:06.000000', 'temperatura', 583.0000, 'ºC'),
	(60060, 110, '2015-02-15 00:19:07.000000', 'temperatura', 127.0000, 'ºC'),
	(60061, 110, '2015-02-15 00:19:08.000000', 'temperatura', 88.0000, 'ºC'),
	(60062, 110, '2015-02-15 00:19:09.000000', 'temperatura', 61.0000, 'ºC'),
	(60063, 110, '2015-02-15 00:19:10.000000', 'temperatura', 39.0000, 'ºC'),
	(60064, 110, '2015-02-15 00:19:11.000000', 'temperatura', 15.0000, 'ºC'),
	(60065, 110, '2015-02-15 00:19:12.000000', 'temperatura', 1156.0000, 'ºC'),
	(60066, 110, '2015-02-15 00:19:13.000000', 'temperatura', 935.0000, 'ºC'),
	(60067, 110, '2015-02-15 00:19:14.000000', 'temperatura', 9.0000, 'ºC'),
	(60068, 110, '2015-02-15 00:19:15.000000', 'temperatura', 842.0000, 'ºC'),
	(60069, 110, '2015-02-15 00:19:16.000000', 'temperatura', 582.0000, 'ºC'),
	(60070, 110, '2015-02-15 00:19:17.000000', 'temperatura', 385.0000, 'ºC'),
	(60071, 110, '2015-02-15 00:19:18.000000', 'temperatura', 179.0000, 'ºC'),
	(60072, 110, '2015-02-15 00:19:19.000000', 'temperatura', 939.0000, 'ºC'),
	(60073, 110, '2015-02-15 00:19:20.000000', 'temperatura', 561.0000, 'ºC'),
	(60074, 110, '2015-02-15 00:19:21.000000', 'temperatura', 1186.0000, 'ºC'),
	(60075, 110, '2015-02-15 00:19:22.000000', 'temperatura', 647.0000, 'ºC'),
	(60076, 110, '2015-02-15 00:19:23.000000', 'temperatura', 878.0000, 'ºC'),
	(60077, 110, '2015-02-15 00:19:24.000000', 'temperatura', 48.0000, 'ºC'),
	(60078, 110, '2015-02-15 00:19:25.000000', 'temperatura', 10.0000, 'ºC'),
	(60079, 110, '2015-02-15 00:19:26.000000', 'temperatura', 1104.0000, 'ºC'),
	(60080, 110, '2015-02-15 00:19:27.000000', 'temperatura', 692.0000, 'ºC'),
	(60081, 110, '2015-02-15 00:19:28.000000', 'temperatura', 146.0000, 'ºC'),
	(60082, 110, '2015-02-15 00:19:29.000000', 'temperatura', 1057.0000, 'ºC'),
	(60083, 110, '2015-02-15 00:19:30.000000', 'temperatura', 47.0000, 'ºC'),
	(60084, 110, '2015-02-15 00:19:31.000000', 'temperatura', 663.0000, 'ºC'),
	(60085, 110, '2015-02-15 00:19:32.000000', 'temperatura', 775.0000, 'ºC'),
	(60086, 110, '2015-02-15 00:19:33.000000', 'temperatura', 686.0000, 'ºC'),
	(60087, 110, '2015-02-15 00:19:34.000000', 'temperatura', 1104.0000, 'ºC'),
	(60088, 110, '2015-02-15 00:19:35.000000', 'temperatura', 1065.0000, 'ºC'),
	(60089, 110, '2015-02-15 00:19:36.000000', 'temperatura', 812.0000, 'ºC'),
	(60090, 110, '2015-02-15 00:19:37.000000', 'temperatura', 865.0000, 'ºC'),
	(60091, 110, '2015-02-15 00:19:38.000000', 'temperatura', 692.0000, 'ºC'),
	(60092, 110, '2015-02-15 00:19:39.000000', 'temperatura', 862.0000, 'ºC'),
	(60093, 110, '2015-02-15 00:19:40.000000', 'temperatura', 1037.0000, 'ºC'),
	(60094, 110, '2015-02-15 00:19:41.000000', 'temperatura', 200.0000, 'ºC'),
	(60095, 110, '2015-02-15 00:19:42.000000', 'temperatura', 290.0000, 'ºC'),
	(60096, 110, '2015-02-15 00:19:43.000000', 'temperatura', 851.0000, 'ºC'),
	(60097, 110, '2015-02-15 00:19:44.000000', 'temperatura', 987.0000, 'ºC'),
	(60098, 110, '2015-02-15 00:19:45.000000', 'temperatura', 1179.0000, 'ºC'),
	(60099, 110, '2015-02-15 00:19:46.000000', 'temperatura', 537.0000, 'ºC'),
	(60100, 110, '2015-02-15 00:19:47.000000', 'temperatura', 348.0000, 'ºC'),
	(60101, 110, '2015-02-15 00:19:48.000000', 'temperatura', 128.0000, 'ºC'),
	(60102, 110, '2015-02-15 00:19:49.000000', 'temperatura', 797.0000, 'ºC'),
	(60103, 110, '2015-02-15 00:19:50.000000', 'temperatura', 0.0000, 'ºC'),
	(60104, 110, '2015-02-15 00:19:51.000000', 'temperatura', 10.0000, 'ºC'),
	(60105, 110, '2015-02-15 00:19:52.000000', 'temperatura', 50.0000, 'ºC'),
	(60106, 110, '2015-02-15 00:19:53.000000', 'temperatura', 219.0000, 'ºC'),
	(60107, 110, '2015-02-15 00:19:54.000000', 'temperatura', 947.0000, 'ºC'),
	(60108, 110, '2015-02-15 00:19:55.000000', 'temperatura', 480.0000, 'ºC'),
	(60109, 110, '2015-02-15 00:19:56.000000', 'temperatura', 760.0000, 'ºC'),
	(60110, 110, '2015-02-15 00:19:57.000000', 'temperatura', 1157.0000, 'ºC'),
	(60111, 110, '2015-02-15 00:19:58.000000', 'temperatura', 1109.0000, 'ºC'),
	(60112, 110, '2015-02-15 00:19:59.000000', 'temperatura', 874.0000, 'ºC'),
	(60113, 110, '2015-02-15 00:20:00.000000', 'temperatura', 1045.0000, 'ºC'),
	(60114, 110, '2015-02-15 00:20:01.000000', 'temperatura', 201.0000, 'ºC'),
	(60115, 110, '2015-02-15 00:20:02.000000', 'temperatura', 270.0000, 'ºC'),
	(60116, 110, '2015-02-15 00:20:03.000000', 'temperatura', 748.0000, 'ºC'),
	(60117, 110, '2015-02-15 00:20:04.000000', 'temperatura', 531.0000, 'ºC'),
	(60118, 110, '2015-02-15 00:20:05.000000', 'temperatura', 411.0000, 'ºC'),
	(60119, 110, '2015-02-15 00:20:06.000000', 'temperatura', 461.0000, 'ºC'),
	(60120, 110, '2015-02-15 00:20:07.000000', 'temperatura', 1074.0000, 'ºC'),
	(60121, 110, '2015-02-15 00:20:08.000000', 'temperatura', 386.0000, 'ºC'),
	(60122, 110, '2015-02-15 00:20:09.000000', 'temperatura', 1110.0000, 'ºC'),
	(60123, 110, '2015-02-15 00:20:10.000000', 'temperatura', 793.0000, 'ºC'),
	(60124, 110, '2015-02-15 00:20:11.000000', 'temperatura', 633.0000, 'ºC'),
	(60125, 110, '2015-02-15 00:20:12.000000', 'temperatura', 788.0000, 'ºC'),
	(60126, 110, '2015-02-15 00:20:13.000000', 'temperatura', 840.0000, 'ºC'),
	(60127, 110, '2015-02-15 00:20:14.000000', 'temperatura', 639.0000, 'ºC'),
	(60128, 110, '2015-02-15 00:20:15.000000', 'temperatura', 675.0000, 'ºC'),
	(60129, 110, '2015-02-15 00:20:16.000000', 'temperatura', 258.0000, 'ºC'),
	(60130, 110, '2015-02-15 00:20:17.000000', 'temperatura', 464.0000, 'ºC'),
	(60131, 110, '2015-02-15 00:20:18.000000', 'temperatura', 348.0000, 'ºC'),
	(60132, 110, '2015-02-15 00:20:19.000000', 'temperatura', 350.0000, 'ºC'),
	(60133, 110, '2015-02-15 00:20:20.000000', 'temperatura', 703.0000, 'ºC'),
	(60134, 110, '2015-02-15 00:20:21.000000', 'temperatura', 69.0000, 'ºC'),
	(60135, 110, '2015-02-15 00:20:22.000000', 'temperatura', 635.0000, 'ºC'),
	(60136, 110, '2015-02-15 00:20:23.000000', 'temperatura', 570.0000, 'ºC'),
	(60137, 110, '2015-02-15 00:20:24.000000', 'temperatura', 943.0000, 'ºC'),
	(60138, 110, '2015-02-15 00:20:25.000000', 'temperatura', 607.0000, 'ºC'),
	(60139, 110, '2015-02-15 00:20:26.000000', 'temperatura', 208.0000, 'ºC'),
	(60140, 110, '2015-02-15 00:20:27.000000', 'temperatura', 420.0000, 'ºC'),
	(60141, 110, '2015-02-15 00:20:28.000000', 'temperatura', 273.0000, 'ºC'),
	(60142, 110, '2015-02-15 00:20:29.000000', 'temperatura', 108.0000, 'ºC'),
	(60143, 110, '2015-02-15 00:20:30.000000', 'temperatura', 920.0000, 'ºC'),
	(60144, 110, '2015-02-15 00:20:31.000000', 'temperatura', 678.0000, 'ºC'),
	(60145, 110, '2015-02-15 00:20:32.000000', 'temperatura', 628.0000, 'ºC'),
	(60146, 110, '2015-02-15 00:20:33.000000', 'temperatura', 1107.0000, 'ºC'),
	(60147, 110, '2015-02-15 00:20:34.000000', 'temperatura', 51.0000, 'ºC'),
	(60148, 110, '2015-02-15 00:20:35.000000', 'temperatura', 534.0000, 'ºC'),
	(60149, 110, '2015-02-15 00:20:36.000000', 'temperatura', 118.0000, 'ºC'),
	(60150, 110, '2015-02-15 00:20:37.000000', 'temperatura', 190.0000, 'ºC'),
	(60151, 110, '2015-02-15 00:20:38.000000', 'temperatura', 596.0000, 'ºC'),
	(60152, 110, '2015-02-15 00:20:39.000000', 'temperatura', 9.0000, 'ºC'),
	(60153, 110, '2015-02-15 00:20:40.000000', 'temperatura', 658.0000, 'ºC'),
	(60154, 110, '2015-02-15 00:20:41.000000', 'temperatura', 863.0000, 'ºC'),
	(60155, 110, '2015-02-15 00:20:42.000000', 'temperatura', 1141.0000, 'ºC'),
	(60156, 110, '2015-02-15 00:20:43.000000', 'temperatura', 719.0000, 'ºC'),
	(60157, 110, '2015-02-15 00:20:44.000000', 'temperatura', 172.0000, 'ºC'),
	(60158, 110, '2015-02-15 00:20:45.000000', 'temperatura', 1101.0000, 'ºC'),
	(60159, 110, '2015-02-15 00:20:46.000000', 'temperatura', 193.0000, 'ºC'),
	(60160, 110, '2015-02-15 00:20:47.000000', 'temperatura', 60.0000, 'ºC'),
	(60161, 110, '2015-02-15 00:20:48.000000', 'temperatura', 922.0000, 'ºC'),
	(60162, 110, '2015-02-15 00:20:49.000000', 'temperatura', 831.0000, 'ºC'),
	(60163, 110, '2015-02-15 00:20:50.000000', 'temperatura', 191.0000, 'ºC'),
	(60164, 110, '2015-02-15 00:20:51.000000', 'temperatura', 863.0000, 'ºC'),
	(60165, 110, '2015-02-15 00:20:52.000000', 'temperatura', 139.0000, 'ºC'),
	(60166, 110, '2015-02-15 00:20:53.000000', 'temperatura', 510.0000, 'ºC'),
	(60167, 110, '2015-02-15 00:20:54.000000', 'temperatura', 931.0000, 'ºC'),
	(60168, 110, '2015-02-15 00:20:55.000000', 'temperatura', 726.0000, 'ºC'),
	(60169, 110, '2015-02-15 00:20:56.000000', 'temperatura', 836.0000, 'ºC'),
	(60170, 110, '2015-02-15 00:20:57.000000', 'temperatura', 803.0000, 'ºC'),
	(60171, 110, '2015-02-15 00:20:58.000000', 'temperatura', 306.0000, 'ºC'),
	(60172, 110, '2015-02-15 00:20:59.000000', 'temperatura', 323.0000, 'ºC'),
	(60173, 110, '2015-02-15 00:21:00.000000', 'temperatura', 697.0000, 'ºC'),
	(60174, 110, '2015-02-15 00:21:01.000000', 'temperatura', 117.0000, 'ºC'),
	(60175, 110, '2015-02-15 00:21:02.000000', 'temperatura', 895.0000, 'ºC'),
	(60176, 110, '2015-02-15 00:21:03.000000', 'temperatura', 525.0000, 'ºC'),
	(60177, 110, '2015-02-15 00:21:04.000000', 'temperatura', 1138.0000, 'ºC'),
	(60178, 110, '2015-02-15 00:21:05.000000', 'temperatura', 517.0000, 'ºC'),
	(60179, 110, '2015-02-15 00:21:06.000000', 'temperatura', 372.0000, 'ºC'),
	(60180, 110, '2015-02-15 00:21:07.000000', 'temperatura', 311.0000, 'ºC'),
	(60181, 110, '2015-02-15 00:21:08.000000', 'temperatura', 438.0000, 'ºC'),
	(60182, 110, '2015-02-15 00:21:09.000000', 'temperatura', 57.0000, 'ºC'),
	(60183, 110, '2015-02-15 00:21:10.000000', 'temperatura', 174.0000, 'ºC'),
	(60184, 110, '2015-02-15 00:21:11.000000', 'temperatura', 696.0000, 'ºC'),
	(60185, 110, '2015-02-15 00:21:12.000000', 'temperatura', 560.0000, 'ºC'),
	(60186, 110, '2015-02-15 00:21:13.000000', 'temperatura', 714.0000, 'ºC'),
	(60187, 110, '2015-02-15 00:21:14.000000', 'temperatura', 688.0000, 'ºC'),
	(60188, 110, '2015-02-15 00:21:15.000000', 'temperatura', 99.0000, 'ºC'),
	(60189, 110, '2015-02-15 00:21:16.000000', 'temperatura', 834.0000, 'ºC'),
	(60190, 110, '2015-02-15 00:21:17.000000', 'temperatura', 272.0000, 'ºC'),
	(60191, 110, '2015-02-15 00:21:18.000000', 'temperatura', 58.0000, 'ºC'),
	(60192, 110, '2015-02-15 00:21:19.000000', 'temperatura', 676.0000, 'ºC'),
	(60193, 110, '2015-02-15 00:21:20.000000', 'temperatura', 805.0000, 'ºC'),
	(60194, 110, '2015-02-15 00:21:21.000000', 'temperatura', 796.0000, 'ºC'),
	(60195, 110, '2015-02-15 00:21:22.000000', 'temperatura', 367.0000, 'ºC'),
	(60196, 110, '2015-02-15 00:21:23.000000', 'temperatura', 646.0000, 'ºC'),
	(60197, 110, '2015-02-15 00:21:24.000000', 'temperatura', 930.0000, 'ºC'),
	(60198, 110, '2015-02-15 00:21:25.000000', 'temperatura', 313.0000, 'ºC'),
	(60199, 110, '2015-02-15 00:21:26.000000', 'temperatura', 1176.0000, 'ºC'),
	(60200, 110, '2015-02-15 00:21:27.000000', 'temperatura', 143.0000, 'ºC'),
	(60201, 110, '2015-02-15 00:21:28.000000', 'temperatura', 785.0000, 'ºC'),
	(60202, 110, '2015-02-15 00:21:29.000000', 'temperatura', 1097.0000, 'ºC'),
	(60203, 110, '2015-02-15 00:21:30.000000', 'temperatura', 730.0000, 'ºC'),
	(60204, 110, '2015-02-15 00:21:31.000000', 'temperatura', 359.0000, 'ºC'),
	(60205, 110, '2015-02-15 00:21:32.000000', 'temperatura', 806.0000, 'ºC'),
	(60206, 110, '2015-02-15 00:21:33.000000', 'temperatura', 555.0000, 'ºC'),
	(60207, 110, '2015-02-15 00:21:34.000000', 'temperatura', 355.0000, 'ºC'),
	(60208, 110, '2015-02-15 00:21:35.000000', 'temperatura', 110.0000, 'ºC'),
	(60209, 110, '2015-02-15 00:21:36.000000', 'temperatura', 687.0000, 'ºC'),
	(60210, 110, '2015-02-15 00:21:37.000000', 'temperatura', 704.0000, 'ºC'),
	(60211, 110, '2015-02-15 00:21:38.000000', 'temperatura', 259.0000, 'ºC'),
	(60212, 110, '2015-02-15 00:21:39.000000', 'temperatura', 385.0000, 'ºC'),
	(60213, 110, '2015-02-15 00:21:40.000000', 'temperatura', 1147.0000, 'ºC'),
	(60214, 110, '2015-02-15 00:21:41.000000', 'temperatura', 980.0000, 'ºC'),
	(60215, 110, '2015-02-15 00:21:42.000000', 'temperatura', 261.0000, 'ºC'),
	(60216, 110, '2015-02-15 00:21:43.000000', 'temperatura', 766.0000, 'ºC'),
	(60217, 110, '2015-02-15 00:21:44.000000', 'temperatura', 648.0000, 'ºC'),
	(60218, 110, '2015-02-15 00:21:45.000000', 'temperatura', 940.0000, 'ºC'),
	(60219, 110, '2015-02-15 00:21:46.000000', 'temperatura', 360.0000, 'ºC'),
	(60220, 110, '2015-02-15 00:21:47.000000', 'temperatura', 178.0000, 'ºC'),
	(60221, 110, '2015-02-15 00:21:48.000000', 'temperatura', 1011.0000, 'ºC'),
	(60222, 110, '2015-02-15 00:21:49.000000', 'temperatura', 920.0000, 'ºC'),
	(60223, 110, '2015-02-15 00:21:50.000000', 'temperatura', 370.0000, 'ºC'),
	(60224, 110, '2015-02-15 00:21:51.000000', 'temperatura', 290.0000, 'ºC'),
	(60225, 110, '2015-02-15 00:21:52.000000', 'temperatura', 340.0000, 'ºC'),
	(60226, 110, '2015-02-15 00:21:53.000000', 'temperatura', 830.0000, 'ºC'),
	(60227, 110, '2015-02-15 00:21:54.000000', 'temperatura', 730.0000, 'ºC'),
	(60228, 110, '2015-02-15 00:21:55.000000', 'temperatura', 1161.0000, 'ºC'),
	(60229, 110, '2015-02-15 00:21:56.000000', 'temperatura', 17.0000, 'ºC'),
	(60230, 110, '2015-02-15 00:21:57.000000', 'temperatura', 203.0000, 'ºC'),
	(60231, 110, '2015-02-15 00:21:58.000000', 'temperatura', 963.0000, 'ºC'),
	(60232, 110, '2015-02-15 00:21:59.000000', 'temperatura', 606.0000, 'ºC'),
	(60233, 110, '2015-02-15 00:22:00.000000', 'temperatura', 141.0000, 'ºC'),
	(60234, 110, '2015-02-15 00:22:01.000000', 'temperatura', 89.0000, 'ºC'),
	(60235, 110, '2015-02-15 00:22:02.000000', 'temperatura', 23.0000, 'ºC'),
	(60236, 110, '2015-02-15 00:22:03.000000', 'temperatura', 1050.0000, 'ºC'),
	(60237, 110, '2015-02-15 00:22:04.000000', 'temperatura', 378.0000, 'ºC'),
	(60238, 110, '2015-02-15 00:22:05.000000', 'temperatura', 1144.0000, 'ºC'),
	(60239, 110, '2015-02-15 00:22:06.000000', 'temperatura', 983.0000, 'ºC'),
	(60240, 110, '2015-02-15 00:22:07.000000', 'temperatura', 285.0000, 'ºC'),
	(60241, 110, '2015-02-15 00:22:08.000000', 'temperatura', 876.0000, 'ºC'),
	(60242, 110, '2015-02-15 00:22:09.000000', 'temperatura', 1126.0000, 'ºC'),
	(60243, 110, '2015-02-15 00:22:10.000000', 'temperatura', 601.0000, 'ºC'),
	(60244, 110, '2015-02-15 00:22:11.000000', 'temperatura', 828.0000, 'ºC'),
	(60245, 110, '2015-02-15 00:22:12.000000', 'temperatura', 1138.0000, 'ºC'),
	(60246, 110, '2015-02-15 00:22:13.000000', 'temperatura', 806.0000, 'ºC'),
	(60247, 110, '2015-02-15 00:22:14.000000', 'temperatura', 616.0000, 'ºC'),
	(60248, 110, '2015-02-15 00:22:15.000000', 'temperatura', 663.0000, 'ºC'),
	(60249, 110, '2015-02-15 00:22:16.000000', 'temperatura', 267.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(60250, 110, '2015-02-15 00:22:17.000000', 'temperatura', 547.0000, 'ºC'),
	(60251, 110, '2015-02-15 00:22:18.000000', 'temperatura', 736.0000, 'ºC'),
	(60252, 110, '2015-02-15 00:22:19.000000', 'temperatura', 837.0000, 'ºC'),
	(60253, 110, '2015-02-15 00:22:20.000000', 'temperatura', 777.0000, 'ºC'),
	(60254, 110, '2015-02-15 00:22:21.000000', 'temperatura', 177.0000, 'ºC'),
	(60255, 110, '2015-02-15 00:22:22.000000', 'temperatura', 952.0000, 'ºC'),
	(60256, 110, '2015-02-15 00:22:23.000000', 'temperatura', 630.0000, 'ºC'),
	(60257, 110, '2015-02-15 00:22:24.000000', 'temperatura', 294.0000, 'ºC'),
	(60258, 110, '2015-02-15 00:22:25.000000', 'temperatura', 783.0000, 'ºC'),
	(60259, 110, '2015-02-15 00:22:26.000000', 'temperatura', 631.0000, 'ºC'),
	(60260, 110, '2015-02-15 00:22:27.000000', 'temperatura', 807.0000, 'ºC'),
	(60261, 110, '2015-02-15 00:22:28.000000', 'temperatura', 943.0000, 'ºC'),
	(60262, 110, '2015-02-15 00:22:29.000000', 'temperatura', 1096.0000, 'ºC'),
	(60263, 110, '2015-02-15 00:22:30.000000', 'temperatura', 250.0000, 'ºC'),
	(60264, 110, '2015-02-15 00:22:31.000000', 'temperatura', 365.0000, 'ºC'),
	(60265, 110, '2015-02-15 00:22:32.000000', 'temperatura', 1072.0000, 'ºC'),
	(60266, 110, '2015-02-15 00:22:33.000000', 'temperatura', 666.0000, 'ºC'),
	(60267, 110, '2015-02-15 00:22:34.000000', 'temperatura', 115.0000, 'ºC'),
	(60268, 110, '2015-02-15 00:22:35.000000', 'temperatura', 978.0000, 'ºC'),
	(60269, 110, '2015-02-15 00:22:36.000000', 'temperatura', 945.0000, 'ºC'),
	(60270, 110, '2015-02-15 00:22:37.000000', 'temperatura', 591.0000, 'ºC'),
	(60271, 110, '2015-02-15 00:22:38.000000', 'temperatura', 120.0000, 'ºC'),
	(60272, 110, '2015-02-15 00:22:39.000000', 'temperatura', 30.0000, 'ºC'),
	(60273, 110, '2015-02-15 00:22:40.000000', 'temperatura', 989.0000, 'ºC'),
	(60274, 110, '2015-02-15 00:22:41.000000', 'temperatura', 55.0000, 'ºC'),
	(60275, 110, '2015-02-15 00:22:42.000000', 'temperatura', 911.0000, 'ºC'),
	(60276, 110, '2015-02-15 00:22:43.000000', 'temperatura', 789.0000, 'ºC'),
	(60277, 110, '2015-02-15 00:22:44.000000', 'temperatura', 11.0000, 'ºC'),
	(60278, 110, '2015-02-15 00:22:45.000000', 'temperatura', 91.0000, 'ºC'),
	(60279, 110, '2015-02-15 00:22:46.000000', 'temperatura', 424.0000, 'ºC'),
	(60280, 110, '2015-02-15 00:22:47.000000', 'temperatura', 644.0000, 'ºC'),
	(60281, 110, '2015-02-15 00:22:48.000000', 'temperatura', 751.0000, 'ºC'),
	(60282, 110, '2015-02-15 00:22:49.000000', 'temperatura', 621.0000, 'ºC'),
	(60283, 110, '2015-02-15 00:22:50.000000', 'temperatura', 856.0000, 'ºC'),
	(60284, 110, '2015-02-15 00:22:51.000000', 'temperatura', 14.0000, 'ºC'),
	(60285, 110, '2015-02-15 00:22:52.000000', 'temperatura', 1106.0000, 'ºC'),
	(60286, 110, '2015-02-15 00:22:53.000000', 'temperatura', 686.0000, 'ºC'),
	(60287, 110, '2015-02-15 00:22:54.000000', 'temperatura', 114.0000, 'ºC'),
	(60288, 110, '2015-02-15 00:22:55.000000', 'temperatura', 913.0000, 'ºC'),
	(60289, 110, '2015-02-15 00:22:56.000000', 'temperatura', 623.0000, 'ºC'),
	(60290, 110, '2015-02-15 00:22:57.000000', 'temperatura', 375.0000, 'ºC'),
	(60291, 110, '2015-02-15 00:22:58.000000', 'temperatura', 8.0000, 'ºC'),
	(60292, 110, '2015-02-15 00:22:59.000000', 'temperatura', 115.0000, 'ºC'),
	(60293, 110, '2015-02-15 00:23:00.000000', 'temperatura', 553.0000, 'ºC'),
	(60294, 110, '2015-02-15 00:23:01.000000', 'temperatura', 19.0000, 'ºC'),
	(60295, 110, '2015-02-15 00:23:02.000000', 'temperatura', 838.0000, 'ºC'),
	(60296, 110, '2015-02-15 00:23:03.000000', 'temperatura', 534.0000, 'ºC'),
	(60297, 110, '2015-02-15 00:23:04.000000', 'temperatura', 155.0000, 'ºC'),
	(60298, 110, '2015-02-15 00:23:05.000000', 'temperatura', 375.0000, 'ºC'),
	(60299, 110, '2015-02-15 00:23:06.000000', 'temperatura', 209.0000, 'ºC'),
	(60300, 110, '2015-02-15 00:23:07.000000', 'temperatura', 1120.0000, 'ºC'),
	(60301, 110, '2015-02-15 00:23:08.000000', 'temperatura', 176.0000, 'ºC'),
	(60302, 110, '2015-02-15 00:23:09.000000', 'temperatura', 1117.0000, 'ºC'),
	(60303, 110, '2015-02-15 00:23:10.000000', 'temperatura', 261.0000, 'ºC'),
	(60304, 110, '2015-02-15 00:23:11.000000', 'temperatura', 351.0000, 'ºC'),
	(60305, 110, '2015-02-15 00:23:12.000000', 'temperatura', 975.0000, 'ºC'),
	(60306, 110, '2015-02-15 00:23:13.000000', 'temperatura', 222.0000, 'ºC'),
	(60307, 110, '2015-02-15 00:23:14.000000', 'temperatura', 586.0000, 'ºC'),
	(60308, 110, '2015-02-15 00:23:15.000000', 'temperatura', 1065.0000, 'ºC'),
	(60309, 110, '2015-02-15 00:23:16.000000', 'temperatura', 1168.0000, 'ºC'),
	(60310, 110, '2015-02-15 00:23:17.000000', 'temperatura', 244.0000, 'ºC'),
	(60311, 110, '2015-02-15 00:23:18.000000', 'temperatura', 118.0000, 'ºC'),
	(60312, 110, '2015-02-15 00:23:19.000000', 'temperatura', 1060.0000, 'ºC'),
	(60313, 110, '2015-02-15 00:23:20.000000', 'temperatura', 145.0000, 'ºC'),
	(60314, 110, '2015-02-15 00:23:21.000000', 'temperatura', 1144.0000, 'ºC'),
	(60315, 110, '2015-02-15 00:23:22.000000', 'temperatura', 485.0000, 'ºC'),
	(60316, 110, '2015-02-15 00:23:23.000000', 'temperatura', 193.0000, 'ºC'),
	(60317, 110, '2015-02-15 00:23:24.000000', 'temperatura', 713.0000, 'ºC'),
	(60318, 110, '2015-02-15 00:23:25.000000', 'temperatura', 585.0000, 'ºC'),
	(60319, 110, '2015-02-15 00:23:26.000000', 'temperatura', 788.0000, 'ºC'),
	(60320, 110, '2015-02-15 00:23:27.000000', 'temperatura', 985.0000, 'ºC'),
	(60321, 110, '2015-02-15 00:23:28.000000', 'temperatura', 160.0000, 'ºC'),
	(60322, 110, '2015-02-15 00:23:29.000000', 'temperatura', 244.0000, 'ºC'),
	(60323, 110, '2015-02-15 00:23:30.000000', 'temperatura', 744.0000, 'ºC'),
	(60324, 110, '2015-02-15 00:23:31.000000', 'temperatura', 587.0000, 'ºC'),
	(60325, 110, '2015-02-15 00:23:32.000000', 'temperatura', 702.0000, 'ºC'),
	(60326, 110, '2015-02-15 00:23:33.000000', 'temperatura', 551.0000, 'ºC'),
	(60327, 110, '2015-02-15 00:23:34.000000', 'temperatura', 649.0000, 'ºC'),
	(60328, 110, '2015-02-15 00:23:35.000000', 'temperatura', 394.0000, 'ºC'),
	(60329, 110, '2015-02-15 00:23:36.000000', 'temperatura', 23.0000, 'ºC'),
	(60330, 110, '2015-02-15 00:23:37.000000', 'temperatura', 133.0000, 'ºC'),
	(60331, 110, '2015-02-15 00:23:38.000000', 'temperatura', 597.0000, 'ºC'),
	(60332, 110, '2015-02-15 00:23:39.000000', 'temperatura', 185.0000, 'ºC'),
	(60333, 110, '2015-02-15 00:23:40.000000', 'temperatura', 336.0000, 'ºC'),
	(60334, 110, '2015-02-15 00:23:41.000000', 'temperatura', 1126.0000, 'ºC'),
	(60335, 110, '2015-02-15 00:23:42.000000', 'temperatura', 1024.0000, 'ºC'),
	(60336, 110, '2015-02-15 00:23:43.000000', 'temperatura', 540.0000, 'ºC'),
	(60337, 110, '2015-02-15 00:23:44.000000', 'temperatura', 828.0000, 'ºC'),
	(60338, 110, '2015-02-15 00:23:45.000000', 'temperatura', 123.0000, 'ºC'),
	(60339, 110, '2015-02-15 00:23:46.000000', 'temperatura', 530.0000, 'ºC'),
	(60340, 110, '2015-02-15 00:23:47.000000', 'temperatura', 1081.0000, 'ºC'),
	(60341, 110, '2015-02-15 00:23:48.000000', 'temperatura', 216.0000, 'ºC'),
	(60342, 110, '2015-02-15 00:23:49.000000', 'temperatura', 239.0000, 'ºC'),
	(60343, 110, '2015-02-15 00:23:50.000000', 'temperatura', 547.0000, 'ºC'),
	(60344, 110, '2015-02-15 00:23:51.000000', 'temperatura', 818.0000, 'ºC'),
	(60345, 110, '2015-02-15 00:23:52.000000', 'temperatura', 51.0000, 'ºC'),
	(60346, 110, '2015-02-15 00:23:53.000000', 'temperatura', 200.0000, 'ºC'),
	(60347, 110, '2015-02-15 00:23:54.000000', 'temperatura', 849.0000, 'ºC'),
	(60348, 110, '2015-02-15 00:23:55.000000', 'temperatura', 45.0000, 'ºC'),
	(60349, 110, '2015-02-15 00:23:56.000000', 'temperatura', 77.0000, 'ºC'),
	(60350, 110, '2015-02-15 00:23:57.000000', 'temperatura', 251.0000, 'ºC'),
	(60351, 110, '2015-02-15 00:23:58.000000', 'temperatura', 1024.0000, 'ºC'),
	(60352, 110, '2015-02-15 00:23:59.000000', 'temperatura', 767.0000, 'ºC'),
	(60353, 110, '2015-02-15 00:24:00.000000', 'temperatura', 766.0000, 'ºC'),
	(60354, 110, '2015-02-15 00:24:01.000000', 'temperatura', 327.0000, 'ºC'),
	(60355, 110, '2015-02-15 00:24:02.000000', 'temperatura', 537.0000, 'ºC'),
	(60356, 110, '2015-02-15 00:24:03.000000', 'temperatura', 506.0000, 'ºC'),
	(60357, 110, '2015-02-15 00:24:04.000000', 'temperatura', 919.0000, 'ºC'),
	(60358, 110, '2015-02-15 00:24:05.000000', 'temperatura', 677.0000, 'ºC'),
	(60359, 110, '2015-02-15 00:24:06.000000', 'temperatura', 628.0000, 'ºC'),
	(60360, 110, '2015-02-15 00:24:07.000000', 'temperatura', 1108.0000, 'ºC'),
	(60361, 110, '2015-02-15 00:24:08.000000', 'temperatura', 59.0000, 'ºC'),
	(60362, 110, '2015-02-15 00:24:09.000000', 'temperatura', 571.0000, 'ºC'),
	(60363, 110, '2015-02-15 00:24:10.000000', 'temperatura', 280.0000, 'ºC'),
	(60364, 110, '2015-02-15 00:24:11.000000', 'temperatura', 888.0000, 'ºC'),
	(60365, 110, '2015-02-15 00:24:12.000000', 'temperatura', 0.0000, 'ºC'),
	(60366, 110, '2015-02-15 00:24:13.000000', 'temperatura', 935.0000, 'ºC'),
	(60367, 110, '2015-02-15 00:24:14.000000', 'temperatura', 1078.0000, 'ºC'),
	(60368, 110, '2015-02-15 00:24:15.000000', 'temperatura', 186.0000, 'ºC'),
	(60369, 110, '2015-02-15 00:24:16.000000', 'temperatura', 94.0000, 'ºC'),
	(60370, 110, '2015-02-15 00:24:17.000000', 'temperatura', 1112.0000, 'ºC'),
	(60371, 110, '2015-02-15 00:24:18.000000', 'temperatura', 480.0000, 'ºC'),
	(60372, 110, '2015-02-15 00:24:19.000000', 'temperatura', 264.0000, 'ºC'),
	(60373, 110, '2015-02-15 00:24:20.000000', 'temperatura', 1081.0000, 'ºC'),
	(60374, 110, '2015-02-15 00:24:21.000000', 'temperatura', 1014.0000, 'ºC'),
	(60375, 110, '2015-02-15 00:24:22.000000', 'temperatura', 629.0000, 'ºC'),
	(60376, 110, '2015-02-15 00:24:23.000000', 'temperatura', 101.0000, 'ºC'),
	(60377, 110, '2015-02-15 00:24:24.000000', 'temperatura', 1021.0000, 'ºC'),
	(60378, 110, '2015-02-15 00:24:25.000000', 'temperatura', 2.0000, 'ºC'),
	(60379, 110, '2015-02-15 00:24:26.000000', 'temperatura', 548.0000, 'ºC'),
	(60380, 110, '2015-02-15 00:24:27.000000', 'temperatura', 332.0000, 'ºC'),
	(60381, 110, '2015-02-15 00:24:28.000000', 'temperatura', 17.0000, 'ºC'),
	(60382, 110, '2015-02-15 00:24:29.000000', 'temperatura', 289.0000, 'ºC'),
	(60383, 110, '2015-02-15 00:24:30.000000', 'temperatura', 196.0000, 'ºC'),
	(60384, 110, '2015-02-15 00:24:31.000000', 'temperatura', 111.0000, 'ºC'),
	(60385, 110, '2015-02-15 00:24:32.000000', 'temperatura', 1169.0000, 'ºC'),
	(60386, 110, '2015-02-15 00:24:33.000000', 'temperatura', 711.0000, 'ºC'),
	(60387, 110, '2015-02-15 00:24:34.000000', 'temperatura', 51.0000, 'ºC'),
	(60388, 110, '2015-02-15 00:24:35.000000', 'temperatura', 521.0000, 'ºC'),
	(60389, 110, '2015-02-15 00:24:36.000000', 'temperatura', 52.0000, 'ºC'),
	(60390, 110, '2015-02-15 00:24:37.000000', 'temperatura', 1100.0000, 'ºC'),
	(60391, 110, '2015-02-15 00:24:38.000000', 'temperatura', 543.0000, 'ºC'),
	(60392, 110, '2015-02-15 00:24:39.000000', 'temperatura', 617.0000, 'ºC'),
	(60393, 110, '2015-02-15 00:24:40.000000', 'temperatura', 254.0000, 'ºC'),
	(60394, 110, '2015-02-15 00:24:41.000000', 'temperatura', 619.0000, 'ºC'),
	(60395, 110, '2015-02-15 00:24:42.000000', 'temperatura', 1135.0000, 'ºC'),
	(60396, 110, '2015-02-15 00:24:43.000000', 'temperatura', 219.0000, 'ºC'),
	(60397, 110, '2015-02-15 00:24:44.000000', 'temperatura', 89.0000, 'ºC'),
	(60398, 110, '2015-02-15 00:24:45.000000', 'temperatura', 990.0000, 'ºC'),
	(60399, 110, '2015-02-15 00:24:46.000000', 'temperatura', 1083.0000, 'ºC'),
	(60400, 110, '2015-02-15 00:24:47.000000', 'temperatura', 46.0000, 'ºC'),
	(60401, 110, '2015-02-15 00:24:48.000000', 'temperatura', 579.0000, 'ºC'),
	(60402, 110, '2015-02-15 00:24:49.000000', 'temperatura', 361.0000, 'ºC'),
	(60403, 110, '2015-02-15 00:24:50.000000', 'temperatura', 65.0000, 'ºC'),
	(60404, 110, '2015-02-15 00:24:51.000000', 'temperatura', 445.0000, 'ºC'),
	(60405, 110, '2015-02-15 00:24:52.000000', 'temperatura', 830.0000, 'ºC'),
	(60406, 110, '2015-02-15 00:24:53.000000', 'temperatura', 414.0000, 'ºC'),
	(60407, 110, '2015-02-15 00:24:54.000000', 'temperatura', 783.0000, 'ºC'),
	(60408, 110, '2015-02-15 00:24:55.000000', 'temperatura', 270.0000, 'ºC'),
	(60409, 110, '2015-02-15 00:24:56.000000', 'temperatura', 205.0000, 'ºC'),
	(60410, 110, '2015-02-15 00:24:57.000000', 'temperatura', 216.0000, 'ºC'),
	(60411, 110, '2015-02-15 00:24:58.000000', 'temperatura', 462.0000, 'ºC'),
	(60412, 110, '2015-02-15 00:24:59.000000', 'temperatura', 465.0000, 'ºC'),
	(60413, 110, '2015-02-15 00:25:00.000000', 'temperatura', 939.0000, 'ºC'),
	(60414, 110, '2015-02-15 00:25:01.000000', 'temperatura', 900.0000, 'ºC'),
	(60415, 110, '2015-02-15 00:25:02.000000', 'temperatura', 483.0000, 'ºC'),
	(60416, 110, '2015-02-15 00:25:03.000000', 'temperatura', 918.0000, 'ºC'),
	(60417, 110, '2015-02-15 00:25:04.000000', 'temperatura', 740.0000, 'ºC'),
	(60418, 110, '2015-02-15 00:25:05.000000', 'temperatura', 949.0000, 'ºC'),
	(60419, 110, '2015-02-15 00:25:06.000000', 'temperatura', 122.0000, 'ºC'),
	(60420, 110, '2015-02-15 00:25:07.000000', 'temperatura', 165.0000, 'ºC'),
	(60421, 110, '2015-02-15 00:25:08.000000', 'temperatura', 458.0000, 'ºC'),
	(60422, 110, '2015-02-15 00:25:09.000000', 'temperatura', 597.0000, 'ºC'),
	(60423, 110, '2015-02-15 00:25:10.000000', 'temperatura', 412.0000, 'ºC'),
	(60424, 110, '2015-02-15 00:25:11.000000', 'temperatura', 269.0000, 'ºC'),
	(60425, 110, '2015-02-15 00:25:12.000000', 'temperatura', 107.0000, 'ºC'),
	(60426, 110, '2015-02-15 00:25:13.000000', 'temperatura', 932.0000, 'ºC'),
	(60427, 110, '2015-02-15 00:25:14.000000', 'temperatura', 737.0000, 'ºC'),
	(60428, 110, '2015-02-15 00:25:15.000000', 'temperatura', 891.0000, 'ºC'),
	(60429, 110, '2015-02-15 00:25:16.000000', 'temperatura', 1043.0000, 'ºC'),
	(60430, 110, '2015-02-15 00:25:17.000000', 'temperatura', 145.0000, 'ºC'),
	(60431, 110, '2015-02-15 00:25:18.000000', 'temperatura', 1196.0000, 'ºC'),
	(60432, 110, '2015-02-15 00:25:19.000000', 'temperatura', 744.0000, 'ºC'),
	(60433, 110, '2015-02-15 00:25:20.000000', 'temperatura', 133.0000, 'ºC'),
	(60434, 110, '2015-02-15 00:25:21.000000', 'temperatura', 835.0000, 'ºC'),
	(60435, 110, '2015-02-15 00:25:22.000000', 'temperatura', 177.0000, 'ºC'),
	(60436, 110, '2015-02-15 00:25:23.000000', 'temperatura', 781.0000, 'ºC'),
	(60437, 110, '2015-02-15 00:25:24.000000', 'temperatura', 974.0000, 'ºC'),
	(60438, 110, '2015-02-15 00:25:25.000000', 'temperatura', 128.0000, 'ºC'),
	(60439, 110, '2015-02-15 00:25:26.000000', 'temperatura', 119.0000, 'ºC'),
	(60440, 110, '2015-02-15 00:25:27.000000', 'temperatura', 209.0000, 'ºC'),
	(60441, 110, '2015-02-15 00:25:28.000000', 'temperatura', 689.0000, 'ºC'),
	(60442, 110, '2015-02-15 00:25:29.000000', 'temperatura', 419.0000, 'ºC'),
	(60443, 110, '2015-02-15 00:25:30.000000', 'temperatura', 30.0000, 'ºC'),
	(60444, 110, '2015-02-15 00:25:31.000000', 'temperatura', 91.0000, 'ºC'),
	(60445, 110, '2015-02-15 00:25:32.000000', 'temperatura', 366.0000, 'ºC'),
	(60446, 110, '2015-02-15 00:25:33.000000', 'temperatura', 357.0000, 'ºC'),
	(60447, 110, '2015-02-15 00:25:34.000000', 'temperatura', 689.0000, 'ºC'),
	(60448, 110, '2015-02-15 00:25:35.000000', 'temperatura', 1172.0000, 'ºC'),
	(60449, 110, '2015-02-15 00:25:36.000000', 'temperatura', 195.0000, 'ºC'),
	(60450, 110, '2015-02-15 00:25:37.000000', 'temperatura', 1061.0000, 'ºC'),
	(60451, 110, '2015-02-15 00:25:38.000000', 'temperatura', 1119.0000, 'ºC'),
	(60452, 110, '2015-02-15 00:25:39.000000', 'temperatura', 11.0000, 'ºC'),
	(60453, 110, '2015-02-15 00:25:40.000000', 'temperatura', 300.0000, 'ºC'),
	(60454, 110, '2015-02-15 00:25:41.000000', 'temperatura', 266.0000, 'ºC'),
	(60455, 110, '2015-02-15 00:25:42.000000', 'temperatura', 430.0000, 'ºC'),
	(60456, 110, '2015-02-15 00:25:43.000000', 'temperatura', 151.0000, 'ºC'),
	(60457, 110, '2015-02-15 00:25:44.000000', 'temperatura', 669.0000, 'ºC'),
	(60458, 110, '2015-02-15 00:25:45.000000', 'temperatura', 492.0000, 'ºC'),
	(60459, 110, '2015-02-15 00:25:46.000000', 'temperatura', 453.0000, 'ºC'),
	(60460, 110, '2015-02-15 00:25:47.000000', 'temperatura', 791.0000, 'ºC'),
	(60461, 110, '2015-02-15 00:25:48.000000', 'temperatura', 195.0000, 'ºC'),
	(60462, 110, '2015-02-15 00:25:49.000000', 'temperatura', 1001.0000, 'ºC'),
	(60463, 110, '2015-02-15 00:25:50.000000', 'temperatura', 823.0000, 'ºC'),
	(60464, 110, '2015-02-15 00:25:51.000000', 'temperatura', 1113.0000, 'ºC'),
	(60465, 110, '2015-02-15 00:25:52.000000', 'temperatura', 694.0000, 'ºC'),
	(60466, 110, '2015-02-15 00:25:53.000000', 'temperatura', 131.0000, 'ºC'),
	(60467, 110, '2015-02-15 00:25:54.000000', 'temperatura', 976.0000, 'ºC'),
	(60468, 110, '2015-02-15 00:25:55.000000', 'temperatura', 887.0000, 'ºC'),
	(60469, 110, '2015-02-15 00:25:56.000000', 'temperatura', 306.0000, 'ºC'),
	(60470, 110, '2015-02-15 00:25:57.000000', 'temperatura', 71.0000, 'ºC'),
	(60471, 110, '2015-02-15 00:25:58.000000', 'temperatura', 639.0000, 'ºC'),
	(60472, 110, '2015-02-15 00:25:59.000000', 'temperatura', 580.0000, 'ºC'),
	(60473, 110, '2015-02-15 00:26:00.000000', 'temperatura', 985.0000, 'ºC'),
	(60474, 110, '2015-02-15 00:26:01.000000', 'temperatura', 785.0000, 'ºC'),
	(60475, 110, '2015-02-15 00:26:02.000000', 'temperatura', 970.0000, 'ºC'),
	(60476, 110, '2015-02-15 00:26:03.000000', 'temperatura', 94.0000, 'ºC'),
	(60477, 110, '2015-02-15 00:26:04.000000', 'temperatura', 1163.0000, 'ºC'),
	(60478, 110, '2015-02-15 00:26:05.000000', 'temperatura', 733.0000, 'ºC'),
	(60479, 110, '2015-02-15 00:26:06.000000', 'temperatura', 176.0000, 'ºC'),
	(60480, 110, '2015-02-15 00:26:07.000000', 'temperatura', 1082.0000, 'ºC'),
	(60481, 110, '2015-02-15 00:26:08.000000', 'temperatura', 83.0000, 'ºC'),
	(60482, 110, '2015-02-15 00:26:09.000000', 'temperatura', 768.0000, 'ºC'),
	(60483, 110, '2015-02-15 00:26:10.000000', 'temperatura', 1192.0000, 'ºC'),
	(60484, 110, '2015-02-15 00:26:11.000000', 'temperatura', 56.0000, 'ºC'),
	(60485, 110, '2015-02-15 00:26:12.000000', 'temperatura', 306.0000, 'ºC'),
	(60486, 110, '2015-02-15 00:26:13.000000', 'temperatura', 161.0000, 'ºC'),
	(60487, 110, '2015-02-15 00:26:14.000000', 'temperatura', 1086.0000, 'ºC'),
	(60488, 110, '2015-02-15 00:26:15.000000', 'temperatura', 151.0000, 'ºC'),
	(60489, 110, '2015-02-15 00:26:16.000000', 'temperatura', 1094.0000, 'ºC'),
	(60490, 110, '2015-02-15 00:26:17.000000', 'temperatura', 220.0000, 'ºC'),
	(60491, 110, '2015-02-15 00:26:18.000000', 'temperatura', 219.0000, 'ºC'),
	(60492, 110, '2015-02-15 00:26:19.000000', 'temperatura', 433.0000, 'ºC'),
	(60493, 110, '2015-02-15 00:26:20.000000', 'temperatura', 312.0000, 'ºC'),
	(60494, 110, '2015-02-15 00:26:21.000000', 'temperatura', 259.0000, 'ºC'),
	(60495, 110, '2015-02-15 00:26:22.000000', 'temperatura', 358.0000, 'ºC'),
	(60496, 110, '2015-02-15 00:26:23.000000', 'temperatura', 1015.0000, 'ºC'),
	(60497, 110, '2015-02-15 00:26:24.000000', 'temperatura', 402.0000, 'ºC'),
	(60498, 110, '2015-02-15 00:26:25.000000', 'temperatura', 165.0000, 'ºC'),
	(60499, 110, '2015-02-15 00:26:26.000000', 'temperatura', 821.0000, 'ºC'),
	(60500, 110, '2015-02-15 00:26:27.000000', 'temperatura', 10.0000, 'ºC'),
	(60501, 110, '2015-02-15 00:26:28.000000', 'temperatura', 1188.0000, 'ºC'),
	(60502, 110, '2015-02-15 00:26:29.000000', 'temperatura', 1112.0000, 'ºC'),
	(60503, 110, '2015-02-15 00:26:30.000000', 'temperatura', 794.0000, 'ºC'),
	(60504, 110, '2015-02-15 00:26:31.000000', 'temperatura', 636.0000, 'ºC'),
	(60505, 110, '2015-02-15 00:26:32.000000', 'temperatura', 797.0000, 'ºC'),
	(60506, 110, '2015-02-15 00:26:33.000000', 'temperatura', 880.0000, 'ºC'),
	(60507, 110, '2015-02-15 00:26:34.000000', 'temperatura', 809.0000, 'ºC'),
	(60508, 110, '2015-02-15 00:26:35.000000', 'temperatura', 203.0000, 'ºC'),
	(60509, 110, '2015-02-15 00:26:36.000000', 'temperatura', 991.0000, 'ºC'),
	(60510, 110, '2015-02-15 00:26:37.000000', 'temperatura', 745.0000, 'ºC'),
	(60511, 110, '2015-02-15 00:26:38.000000', 'temperatura', 752.0000, 'ºC'),
	(60512, 110, '2015-02-15 00:26:39.000000', 'temperatura', 328.0000, 'ºC'),
	(60513, 110, '2015-02-15 00:26:40.000000', 'temperatura', 584.0000, 'ºC'),
	(60514, 110, '2015-02-15 00:26:41.000000', 'temperatura', 738.0000, 'ºC'),
	(60515, 110, '2015-02-15 00:26:42.000000', 'temperatura', 735.0000, 'ºC'),
	(60516, 110, '2015-02-15 00:26:43.000000', 'temperatura', 264.0000, 'ºC'),
	(60517, 110, '2015-02-15 00:26:44.000000', 'temperatura', 315.0000, 'ºC'),
	(60518, 110, '2015-02-15 00:26:45.000000', 'temperatura', 784.0000, 'ºC'),
	(60519, 110, '2015-02-15 00:26:46.000000', 'temperatura', 574.0000, 'ºC'),
	(60520, 110, '2015-02-15 00:26:47.000000', 'temperatura', 517.0000, 'ºC'),
	(60521, 110, '2015-02-15 00:26:48.000000', 'temperatura', 866.0000, 'ºC'),
	(60522, 110, '2015-02-15 00:26:49.000000', 'temperatura', 379.0000, 'ºC'),
	(60523, 110, '2015-02-15 00:26:50.000000', 'temperatura', 497.0000, 'ºC'),
	(60524, 110, '2015-02-15 00:26:51.000000', 'temperatura', 148.0000, 'ºC'),
	(60525, 110, '2015-02-15 00:26:52.000000', 'temperatura', 452.0000, 'ºC'),
	(60526, 110, '2015-02-15 00:26:53.000000', 'temperatura', 613.0000, 'ºC'),
	(60527, 110, '2015-02-15 00:26:54.000000', 'temperatura', 512.0000, 'ºC'),
	(60528, 110, '2015-02-15 00:26:55.000000', 'temperatura', 720.0000, 'ºC'),
	(60529, 110, '2015-02-15 00:26:56.000000', 'temperatura', 866.0000, 'ºC'),
	(60530, 110, '2015-02-15 00:26:57.000000', 'temperatura', 969.0000, 'ºC'),
	(60531, 110, '2015-02-15 00:26:58.000000', 'temperatura', 1050.0000, 'ºC'),
	(60532, 110, '2015-02-15 00:26:59.000000', 'temperatura', 1143.0000, 'ºC'),
	(60533, 110, '2015-02-15 00:27:00.000000', 'temperatura', 163.0000, 'ºC'),
	(60534, 110, '2015-02-15 00:27:01.000000', 'temperatura', 987.0000, 'ºC'),
	(60535, 110, '2015-02-15 00:27:02.000000', 'temperatura', 847.0000, 'ºC'),
	(60536, 110, '2015-02-15 00:27:03.000000', 'temperatura', 75.0000, 'ºC'),
	(60537, 110, '2015-02-15 00:27:04.000000', 'temperatura', 236.0000, 'ºC'),
	(60538, 110, '2015-02-15 00:27:05.000000', 'temperatura', 955.0000, 'ºC'),
	(60539, 110, '2015-02-15 00:27:06.000000', 'temperatura', 469.0000, 'ºC'),
	(60540, 110, '2015-02-15 00:27:07.000000', 'temperatura', 678.0000, 'ºC'),
	(60541, 110, '2015-02-15 00:27:08.000000', 'temperatura', 786.0000, 'ºC'),
	(60542, 110, '2015-02-15 00:27:09.000000', 'temperatura', 696.0000, 'ºC'),
	(60543, 110, '2015-02-15 00:27:10.000000', 'temperatura', 1124.0000, 'ºC'),
	(60544, 110, '2015-02-15 00:27:11.000000', 'temperatura', 1131.0000, 'ºC'),
	(60545, 110, '2015-02-15 00:27:12.000000', 'temperatura', 1082.0000, 'ºC'),
	(60546, 110, '2015-02-15 00:27:13.000000', 'temperatura', 820.0000, 'ºC'),
	(60547, 110, '2015-02-15 00:27:14.000000', 'temperatura', 854.0000, 'ºC'),
	(60548, 110, '2015-02-15 00:27:15.000000', 'temperatura', 610.0000, 'ºC'),
	(60549, 110, '2015-02-15 00:27:16.000000', 'temperatura', 490.0000, 'ºC'),
	(60550, 110, '2015-02-15 00:27:17.000000', 'temperatura', 620.0000, 'ºC'),
	(60551, 110, '2015-02-15 00:27:18.000000', 'temperatura', 428.0000, 'ºC'),
	(60552, 110, '2015-02-15 00:27:19.000000', 'temperatura', 283.0000, 'ºC'),
	(60553, 110, '2015-02-15 00:27:20.000000', 'temperatura', 129.0000, 'ºC'),
	(60554, 110, '2015-02-15 00:27:21.000000', 'temperatura', 999.0000, 'ºC'),
	(60555, 110, '2015-02-15 00:27:22.000000', 'temperatura', 1006.0000, 'ºC'),
	(60556, 110, '2015-02-15 00:27:23.000000', 'temperatura', 836.0000, 'ºC'),
	(60557, 110, '2015-02-15 00:27:24.000000', 'temperatura', 1162.0000, 'ºC'),
	(60558, 110, '2015-02-15 00:27:25.000000', 'temperatura', 903.0000, 'ºC'),
	(60559, 110, '2015-02-15 00:27:26.000000', 'temperatura', 1028.0000, 'ºC'),
	(60560, 110, '2015-02-15 00:27:27.000000', 'temperatura', 32.0000, 'ºC'),
	(60561, 110, '2015-02-15 00:27:28.000000', 'temperatura', 678.0000, 'ºC'),
	(60562, 110, '2015-02-15 00:27:29.000000', 'temperatura', 893.0000, 'ºC'),
	(60563, 110, '2015-02-15 00:27:30.000000', 'temperatura', 31.0000, 'ºC'),
	(60564, 110, '2015-02-15 00:27:31.000000', 'temperatura', 1077.0000, 'ºC'),
	(60565, 110, '2015-02-15 00:27:32.000000', 'temperatura', 494.0000, 'ºC'),
	(60566, 110, '2015-02-15 00:27:33.000000', 'temperatura', 441.0000, 'ºC'),
	(60567, 110, '2015-02-15 00:27:34.000000', 'temperatura', 720.0000, 'ºC'),
	(60568, 110, '2015-02-15 00:27:35.000000', 'temperatura', 1078.0000, 'ºC'),
	(60569, 110, '2015-02-15 00:27:36.000000', 'temperatura', 831.0000, 'ºC'),
	(60570, 110, '2015-02-15 00:27:37.000000', 'temperatura', 923.0000, 'ºC'),
	(60571, 110, '2015-02-15 00:27:38.000000', 'temperatura', 921.0000, 'ºC'),
	(60572, 110, '2015-02-15 00:27:39.000000', 'temperatura', 638.0000, 'ºC'),
	(60573, 110, '2015-02-15 00:27:40.000000', 'temperatura', 425.0000, 'ºC'),
	(60574, 110, '2015-02-15 00:27:41.000000', 'temperatura', 214.0000, 'ºC'),
	(60575, 110, '2015-02-15 00:27:42.000000', 'temperatura', 994.0000, 'ºC'),
	(60576, 110, '2015-02-15 00:27:43.000000', 'temperatura', 730.0000, 'ºC'),
	(60577, 110, '2015-02-15 00:27:44.000000', 'temperatura', 670.0000, 'ºC'),
	(60578, 110, '2015-02-15 00:27:45.000000', 'temperatura', 1157.0000, 'ºC'),
	(60579, 110, '2015-02-15 00:27:46.000000', 'temperatura', 178.0000, 'ºC'),
	(60580, 110, '2015-02-15 00:27:47.000000', 'temperatura', 1017.0000, 'ºC'),
	(60581, 110, '2015-02-15 00:27:48.000000', 'temperatura', 952.0000, 'ºC'),
	(60582, 110, '2015-02-15 00:27:49.000000', 'temperatura', 511.0000, 'ºC'),
	(60583, 110, '2015-02-15 00:27:50.000000', 'temperatura', 900.0000, 'ºC'),
	(60584, 110, '2015-02-15 00:27:51.000000', 'temperatura', 568.0000, 'ºC'),
	(60585, 110, '2015-02-15 00:27:52.000000', 'temperatura', 142.0000, 'ºC'),
	(60586, 110, '2015-02-15 00:27:53.000000', 'temperatura', 203.0000, 'ºC'),
	(60587, 110, '2015-02-15 00:27:54.000000', 'temperatura', 591.0000, 'ºC'),
	(60588, 110, '2015-02-15 00:27:55.000000', 'temperatura', 1148.0000, 'ºC'),
	(60589, 110, '2015-02-15 00:27:56.000000', 'temperatura', 368.0000, 'ºC'),
	(60590, 110, '2015-02-15 00:27:57.000000', 'temperatura', 796.0000, 'ºC'),
	(60591, 110, '2015-02-15 00:27:58.000000', 'temperatura', 478.0000, 'ºC'),
	(60592, 110, '2015-02-15 00:27:59.000000', 'temperatura', 0.0000, 'ºC'),
	(60593, 110, '2015-02-15 00:28:00.000000', 'temperatura', 967.0000, 'ºC'),
	(60594, 110, '2015-02-15 00:28:01.000000', 'temperatura', 37.0000, 'ºC'),
	(60595, 110, '2015-02-15 00:28:02.000000', 'temperatura', 885.0000, 'ºC'),
	(60596, 110, '2015-02-15 00:28:03.000000', 'temperatura', 714.0000, 'ºC'),
	(60597, 110, '2015-02-15 00:28:04.000000', 'temperatura', 917.0000, 'ºC'),
	(60598, 110, '2015-02-15 00:28:05.000000', 'temperatura', 42.0000, 'ºC'),
	(60599, 110, '2015-02-15 00:28:06.000000', 'temperatura', 1061.0000, 'ºC'),
	(60600, 110, '2015-02-15 00:28:07.000000', 'temperatura', 380.0000, 'ºC'),
	(60601, 110, '2015-02-15 00:28:08.000000', 'temperatura', 1116.0000, 'ºC'),
	(60602, 110, '2015-02-15 00:28:09.000000', 'temperatura', 841.0000, 'ºC'),
	(60603, 110, '2015-02-15 00:28:10.000000', 'temperatura', 859.0000, 'ºC'),
	(60604, 110, '2015-02-15 00:28:11.000000', 'temperatura', 570.0000, 'ºC'),
	(60605, 110, '2015-02-15 00:28:12.000000', 'temperatura', 273.0000, 'ºC'),
	(60606, 110, '2015-02-15 00:28:13.000000', 'temperatura', 857.0000, 'ºC'),
	(60607, 110, '2015-02-15 00:28:14.000000', 'temperatura', 1068.0000, 'ºC'),
	(60608, 110, '2015-02-15 00:28:15.000000', 'temperatura', 369.0000, 'ºC'),
	(60609, 110, '2015-02-15 00:28:16.000000', 'temperatura', 1039.0000, 'ºC'),
	(60610, 110, '2015-02-15 00:28:17.000000', 'temperatura', 490.0000, 'ºC'),
	(60611, 110, '2015-02-15 00:28:18.000000', 'temperatura', 534.0000, 'ºC'),
	(60612, 110, '2015-02-15 00:28:19.000000', 'temperatura', 1.0000, 'ºC'),
	(60613, 110, '2015-02-15 00:28:20.000000', 'temperatura', 805.0000, 'ºC'),
	(60614, 110, '2015-02-15 00:28:21.000000', 'temperatura', 420.0000, 'ºC'),
	(60615, 110, '2015-02-15 00:28:22.000000', 'temperatura', 888.0000, 'ºC'),
	(60616, 110, '2015-02-15 00:28:23.000000', 'temperatura', 777.0000, 'ºC'),
	(60617, 110, '2015-02-15 00:28:24.000000', 'temperatura', 24.0000, 'ºC'),
	(60618, 110, '2015-02-15 00:28:25.000000', 'temperatura', 189.0000, 'ºC'),
	(60619, 110, '2015-02-15 00:28:26.000000', 'temperatura', 871.0000, 'ºC'),
	(60620, 110, '2015-02-15 00:28:27.000000', 'temperatura', 192.0000, 'ºC'),
	(60621, 110, '2015-02-15 00:28:28.000000', 'temperatura', 744.0000, 'ºC'),
	(60622, 110, '2015-02-15 00:28:29.000000', 'temperatura', 747.0000, 'ºC'),
	(60623, 110, '2015-02-15 00:28:30.000000', 'temperatura', 301.0000, 'ºC'),
	(60624, 110, '2015-02-15 00:28:31.000000', 'temperatura', 465.0000, 'ºC'),
	(60625, 110, '2015-02-15 00:28:32.000000', 'temperatura', 222.0000, 'ºC'),
	(60626, 110, '2015-02-15 00:28:33.000000', 'temperatura', 918.0000, 'ºC'),
	(60627, 110, '2015-02-15 00:28:34.000000', 'temperatura', 323.0000, 'ºC'),
	(60628, 110, '2015-02-15 00:28:35.000000', 'temperatura', 63.0000, 'ºC'),
	(60629, 110, '2015-02-15 00:28:36.000000', 'temperatura', 546.0000, 'ºC'),
	(60630, 110, '2015-02-15 00:28:37.000000', 'temperatura', 141.0000, 'ºC'),
	(60631, 110, '2015-02-15 00:28:38.000000', 'temperatura', 268.0000, 'ºC'),
	(60632, 110, '2015-02-15 00:28:39.000000', 'temperatura', 918.0000, 'ºC'),
	(60633, 110, '2015-02-15 00:28:40.000000', 'temperatura', 188.0000, 'ºC'),
	(60634, 110, '2015-02-15 00:28:41.000000', 'temperatura', 585.0000, 'ºC'),
	(60635, 110, '2015-02-15 00:28:42.000000', 'temperatura', 1163.0000, 'ºC'),
	(60636, 110, '2015-02-15 00:28:43.000000', 'temperatura', 460.0000, 'ºC'),
	(60637, 110, '2015-02-15 00:28:44.000000', 'temperatura', 12.0000, 'ºC'),
	(60638, 110, '2015-02-15 00:28:45.000000', 'temperatura', 1079.0000, 'ºC'),
	(60639, 110, '2015-02-15 00:28:46.000000', 'temperatura', 561.0000, 'ºC'),
	(60640, 110, '2015-02-15 00:28:47.000000', 'temperatura', 769.0000, 'ºC'),
	(60641, 110, '2015-02-15 00:28:48.000000', 'temperatura', 962.0000, 'ºC'),
	(60642, 110, '2015-02-15 00:28:49.000000', 'temperatura', 103.0000, 'ºC'),
	(60643, 110, '2015-02-15 00:28:50.000000', 'temperatura', 29.0000, 'ºC'),
	(60644, 110, '2015-02-15 00:28:51.000000', 'temperatura', 1037.0000, 'ºC'),
	(60645, 110, '2015-02-15 00:28:52.000000', 'temperatura', 300.0000, 'ºC'),
	(60646, 110, '2015-02-15 00:28:53.000000', 'temperatura', 788.0000, 'ºC'),
	(60647, 110, '2015-02-15 00:28:54.000000', 'temperatura', 640.0000, 'ºC'),
	(60648, 110, '2015-02-15 00:28:55.000000', 'temperatura', 839.0000, 'ºC'),
	(60649, 110, '2015-02-15 00:28:56.000000', 'temperatura', 1073.0000, 'ºC'),
	(60650, 110, '2015-02-15 00:28:57.000000', 'temperatura', 449.0000, 'ºC'),
	(60651, 110, '2015-02-15 00:28:58.000000', 'temperatura', 225.0000, 'ºC'),
	(60652, 110, '2015-02-15 00:28:59.000000', 'temperatura', 981.0000, 'ºC'),
	(60653, 110, '2015-02-15 00:29:00.000000', 'temperatura', 628.0000, 'ºC'),
	(60654, 110, '2015-02-15 00:29:01.000000', 'temperatura', 200.0000, 'ºC'),
	(60655, 110, '2015-02-15 00:29:02.000000', 'temperatura', 314.0000, 'ºC'),
	(60656, 110, '2015-02-15 00:29:03.000000', 'temperatura', 973.0000, 'ºC'),
	(60657, 110, '2015-02-15 00:29:04.000000', 'temperatura', 321.0000, 'ºC'),
	(60658, 110, '2015-02-15 00:29:05.000000', 'temperatura', 1089.0000, 'ºC'),
	(60659, 110, '2015-02-15 00:29:06.000000', 'temperatura', 881.0000, 'ºC'),
	(60660, 110, '2015-02-15 00:29:07.000000', 'temperatura', 1139.0000, 'ºC'),
	(60661, 110, '2015-02-15 00:29:08.000000', 'temperatura', 652.0000, 'ºC'),
	(60662, 110, '2015-02-15 00:29:09.000000', 'temperatura', 1044.0000, 'ºC'),
	(60663, 110, '2015-02-15 00:29:10.000000', 'temperatura', 864.0000, 'ºC'),
	(60664, 110, '2015-02-15 00:29:11.000000', 'temperatura', 1188.0000, 'ºC'),
	(60665, 110, '2015-02-15 00:29:12.000000', 'temperatura', 949.0000, 'ºC'),
	(60666, 110, '2015-02-15 00:29:13.000000', 'temperatura', 1180.0000, 'ºC'),
	(60667, 110, '2015-02-15 00:29:14.000000', 'temperatura', 656.0000, 'ºC'),
	(60668, 110, '2015-02-15 00:29:15.000000', 'temperatura', 940.0000, 'ºC'),
	(60669, 110, '2015-02-15 00:29:16.000000', 'temperatura', 333.0000, 'ºC'),
	(60670, 110, '2015-02-15 00:29:17.000000', 'temperatura', 45.0000, 'ºC'),
	(60671, 110, '2015-02-15 00:29:18.000000', 'temperatura', 425.0000, 'ºC'),
	(60672, 110, '2015-02-15 00:29:19.000000', 'temperatura', 792.0000, 'ºC'),
	(60673, 110, '2015-02-15 00:29:20.000000', 'temperatura', 287.0000, 'ºC'),
	(60674, 110, '2015-02-15 00:29:21.000000', 'temperatura', 259.0000, 'ºC'),
	(60675, 110, '2015-02-15 00:29:22.000000', 'temperatura', 432.0000, 'ºC'),
	(60676, 110, '2015-02-15 00:29:23.000000', 'temperatura', 187.0000, 'ºC'),
	(60677, 110, '2015-02-15 00:29:24.000000', 'temperatura', 836.0000, 'ºC'),
	(60678, 110, '2015-02-15 00:29:25.000000', 'temperatura', 21.0000, 'ºC'),
	(60679, 110, '2015-02-15 00:29:26.000000', 'temperatura', 1197.0000, 'ºC'),
	(60680, 110, '2015-02-15 00:29:27.000000', 'temperatura', 1123.0000, 'ºC'),
	(60681, 110, '2015-02-15 00:29:28.000000', 'temperatura', 826.0000, 'ºC'),
	(60682, 110, '2015-02-15 00:29:29.000000', 'temperatura', 761.0000, 'ºC'),
	(60683, 110, '2015-02-15 00:29:30.000000', 'temperatura', 127.0000, 'ºC'),
	(60684, 110, '2015-02-15 00:29:31.000000', 'temperatura', 754.0000, 'ºC'),
	(60685, 110, '2015-02-15 00:29:32.000000', 'temperatura', 989.0000, 'ºC'),
	(60686, 110, '2015-02-15 00:29:33.000000', 'temperatura', 282.0000, 'ºC'),
	(60687, 110, '2015-02-15 00:29:34.000000', 'temperatura', 843.0000, 'ºC'),
	(60688, 110, '2015-02-15 00:29:35.000000', 'temperatura', 970.0000, 'ºC'),
	(60689, 110, '2015-02-15 00:29:36.000000', 'temperatura', 1121.0000, 'ºC'),
	(60690, 110, '2015-02-15 00:29:37.000000', 'temperatura', 296.0000, 'ºC'),
	(60691, 110, '2015-02-15 00:29:38.000000', 'temperatura', 519.0000, 'ºC'),
	(60692, 110, '2015-02-15 00:29:39.000000', 'temperatura', 507.0000, 'ºC'),
	(60693, 110, '2015-02-15 00:29:40.000000', 'temperatura', 976.0000, 'ºC'),
	(60694, 110, '2015-02-15 00:29:41.000000', 'temperatura', 962.0000, 'ºC'),
	(60695, 110, '2015-02-15 00:29:42.000000', 'temperatura', 681.0000, 'ºC'),
	(60696, 110, '2015-02-15 00:29:43.000000', 'temperatura', 518.0000, 'ºC'),
	(60697, 110, '2015-02-15 00:29:44.000000', 'temperatura', 551.0000, 'ºC'),
	(60698, 110, '2015-02-15 00:29:45.000000', 'temperatura', 0.0000, 'ºC'),
	(60699, 110, '2015-02-15 00:29:46.000000', 'temperatura', 746.0000, 'ºC'),
	(60700, 110, '2015-02-15 00:29:47.000000', 'temperatura', 131.0000, 'ºC'),
	(60701, 110, '2015-02-15 00:29:48.000000', 'temperatura', 816.0000, 'ºC'),
	(60702, 110, '2015-02-15 00:29:49.000000', 'temperatura', 88.0000, 'ºC'),
	(60703, 110, '2015-02-15 00:29:50.000000', 'temperatura', 394.0000, 'ºC'),
	(60704, 110, '2015-02-15 00:29:51.000000', 'temperatura', 504.0000, 'ºC'),
	(60705, 110, '2015-02-15 00:29:52.000000', 'temperatura', 140.0000, 'ºC'),
	(60706, 110, '2015-02-15 00:29:53.000000', 'temperatura', 389.0000, 'ºC'),
	(60707, 110, '2015-02-15 00:29:54.000000', 'temperatura', 325.0000, 'ºC'),
	(60708, 110, '2015-02-15 00:29:55.000000', 'temperatura', 457.0000, 'ºC'),
	(60709, 110, '2015-02-15 00:29:56.000000', 'temperatura', 113.0000, 'ºC'),
	(60710, 110, '2015-02-15 00:29:57.000000', 'temperatura', 392.0000, 'ºC'),
	(60711, 110, '2015-02-15 00:29:58.000000', 'temperatura', 422.0000, 'ºC'),
	(60712, 110, '2015-02-15 00:29:59.000000', 'temperatura', 933.0000, 'ºC'),
	(60713, 110, '2015-02-15 00:30:00.000000', 'temperatura', 1002.0000, 'ºC'),
	(60714, 110, '2015-02-15 00:30:01.000000', 'temperatura', 1010.0000, 'ºC'),
	(60715, 110, '2015-02-15 00:30:02.000000', 'temperatura', 843.0000, 'ºC'),
	(60716, 110, '2015-02-15 00:30:03.000000', 'temperatura', 1189.0000, 'ºC'),
	(60717, 110, '2015-02-15 00:30:04.000000', 'temperatura', 1015.0000, 'ºC'),
	(60718, 110, '2015-02-15 00:30:05.000000', 'temperatura', 308.0000, 'ºC'),
	(60719, 110, '2015-02-15 00:30:06.000000', 'temperatura', 897.0000, 'ºC'),
	(60720, 110, '2015-02-15 00:30:07.000000', 'temperatura', 1161.0000, 'ºC'),
	(60721, 110, '2015-02-15 00:30:08.000000', 'temperatura', 712.0000, 'ºC'),
	(60722, 110, '2015-02-15 00:30:09.000000', 'temperatura', 81.0000, 'ºC'),
	(60723, 110, '2015-02-15 00:30:10.000000', 'temperatura', 669.0000, 'ºC'),
	(60724, 110, '2015-02-15 00:30:11.000000', 'temperatura', 703.0000, 'ºC'),
	(60725, 110, '2015-02-15 00:30:12.000000', 'temperatura', 307.0000, 'ºC'),
	(60726, 110, '2015-02-15 00:30:13.000000', 'temperatura', 628.0000, 'ºC'),
	(60727, 110, '2015-02-15 00:30:14.000000', 'temperatura', 1018.0000, 'ºC'),
	(60728, 110, '2015-02-15 00:30:15.000000', 'temperatura', 808.0000, 'ºC'),
	(60729, 110, '2015-02-15 00:30:16.000000', 'temperatura', 987.0000, 'ºC'),
	(60730, 110, '2015-02-15 00:30:17.000000', 'temperatura', 112.0000, 'ºC'),
	(60731, 110, '2015-02-15 00:30:18.000000', 'temperatura', 1197.0000, 'ºC'),
	(60732, 110, '2015-02-15 00:30:19.000000', 'temperatura', 850.0000, 'ºC'),
	(60733, 110, '2015-02-15 00:30:20.000000', 'temperatura', 660.0000, 'ºC'),
	(60734, 110, '2015-02-15 00:30:21.000000', 'temperatura', 749.0000, 'ºC'),
	(60735, 110, '2015-02-15 00:30:22.000000', 'temperatura', 565.0000, 'ºC'),
	(60736, 110, '2015-02-15 00:30:23.000000', 'temperatura', 581.0000, 'ºC'),
	(60737, 110, '2015-02-15 00:30:24.000000', 'temperatura', 11.0000, 'ºC'),
	(60738, 110, '2015-02-15 00:30:25.000000', 'temperatura', 710.0000, 'ºC'),
	(60739, 110, '2015-02-15 00:30:26.000000', 'temperatura', 1118.0000, 'ºC'),
	(60740, 110, '2015-02-15 00:30:27.000000', 'temperatura', 1062.0000, 'ºC'),
	(60741, 110, '2015-02-15 00:30:28.000000', 'temperatura', 756.0000, 'ºC'),
	(60742, 110, '2015-02-15 00:30:29.000000', 'temperatura', 595.0000, 'ºC'),
	(60743, 110, '2015-02-15 00:30:30.000000', 'temperatura', 705.0000, 'ºC'),
	(60744, 110, '2015-02-15 00:30:31.000000', 'temperatura', 543.0000, 'ºC'),
	(60745, 110, '2015-02-15 00:30:32.000000', 'temperatura', 599.0000, 'ºC'),
	(60746, 110, '2015-02-15 00:30:33.000000', 'temperatura', 166.0000, 'ºC'),
	(60747, 110, '2015-02-15 00:30:34.000000', 'temperatura', 233.0000, 'ºC'),
	(60748, 110, '2015-02-15 00:30:35.000000', 'temperatura', 667.0000, 'ºC'),
	(60749, 110, '2015-02-15 00:30:36.000000', 'temperatura', 238.0000, 'ºC'),
	(60750, 110, '2015-02-15 00:30:37.000000', 'temperatura', 389.0000, 'ºC'),
	(60751, 110, '2015-02-15 00:30:38.000000', 'temperatura', 32.0000, 'ºC'),
	(60752, 110, '2015-02-15 00:30:39.000000', 'temperatura', 195.0000, 'ºC'),
	(60753, 110, '2015-02-15 00:30:40.000000', 'temperatura', 878.0000, 'ºC'),
	(60754, 110, '2015-02-15 00:30:41.000000', 'temperatura', 205.0000, 'ºC'),
	(60755, 110, '2015-02-15 00:30:42.000000', 'temperatura', 792.0000, 'ºC'),
	(60756, 110, '2015-02-15 00:30:43.000000', 'temperatura', 944.0000, 'ºC'),
	(60757, 110, '2015-02-15 00:30:44.000000', 'temperatura', 1144.0000, 'ºC'),
	(60758, 110, '2015-02-15 00:30:45.000000', 'temperatura', 488.0000, 'ºC'),
	(60759, 110, '2015-02-15 00:30:46.000000', 'temperatura', 208.0000, 'ºC'),
	(60760, 110, '2015-02-15 00:30:47.000000', 'temperatura', 776.0000, 'ºC'),
	(60761, 110, '2015-02-15 00:30:48.000000', 'temperatura', 858.0000, 'ºC'),
	(60762, 110, '2015-02-15 00:30:49.000000', 'temperatura', 763.0000, 'ºC'),
	(60763, 110, '2015-02-15 00:30:50.000000', 'temperatura', 39.0000, 'ºC'),
	(60764, 110, '2015-02-15 00:30:51.000000', 'temperatura', 310.0000, 'ºC'),
	(60765, 110, '2015-02-15 00:30:52.000000', 'temperatura', 231.0000, 'ºC'),
	(60766, 110, '2015-02-15 00:30:53.000000', 'temperatura', 226.0000, 'ºC'),
	(60767, 110, '2015-02-15 00:30:54.000000', 'temperatura', 437.0000, 'ºC'),
	(60768, 110, '2015-02-15 00:30:55.000000', 'temperatura', 308.0000, 'ºC'),
	(60769, 110, '2015-02-15 00:30:56.000000', 'temperatura', 231.0000, 'ºC'),
	(60770, 110, '2015-02-15 00:30:57.000000', 'temperatura', 229.0000, 'ºC'),
	(60771, 110, '2015-02-15 00:30:58.000000', 'temperatura', 452.0000, 'ºC'),
	(60772, 110, '2015-02-15 00:30:59.000000', 'temperatura', 374.0000, 'ºC'),
	(60773, 110, '2015-02-15 00:31:00.000000', 'temperatura', 517.0000, 'ºC'),
	(60774, 110, '2015-02-15 00:31:01.000000', 'temperatura', 262.0000, 'ºC'),
	(60775, 110, '2015-02-15 00:31:02.000000', 'temperatura', 960.0000, 'ºC'),
	(60776, 110, '2015-02-15 00:31:03.000000', 'temperatura', 415.0000, 'ºC'),
	(60777, 110, '2015-02-15 00:31:04.000000', 'temperatura', 394.0000, 'ºC'),
	(60778, 110, '2015-02-15 00:31:05.000000', 'temperatura', 727.0000, 'ºC'),
	(60779, 110, '2015-02-15 00:31:06.000000', 'temperatura', 55.0000, 'ºC'),
	(60780, 110, '2015-02-15 00:31:07.000000', 'temperatura', 491.0000, 'ºC'),
	(60781, 110, '2015-02-15 00:31:08.000000', 'temperatura', 1094.0000, 'ºC'),
	(60782, 110, '2015-02-15 00:31:09.000000', 'temperatura', 395.0000, 'ºC'),
	(60783, 110, '2015-02-15 00:31:10.000000', 'temperatura', 1094.0000, 'ºC'),
	(60784, 110, '2015-02-15 00:31:11.000000', 'temperatura', 687.0000, 'ºC'),
	(60785, 110, '2015-02-15 00:31:12.000000', 'temperatura', 153.0000, 'ºC'),
	(60786, 110, '2015-02-15 00:31:13.000000', 'temperatura', 1105.0000, 'ºC'),
	(60787, 110, '2015-02-15 00:31:14.000000', 'temperatura', 264.0000, 'ºC'),
	(60788, 110, '2015-02-15 00:31:15.000000', 'temperatura', 409.0000, 'ºC'),
	(60789, 110, '2015-02-15 00:31:16.000000', 'temperatura', 51.0000, 'ºC'),
	(60790, 110, '2015-02-15 00:31:17.000000', 'temperatura', 230.0000, 'ºC'),
	(60791, 110, '2015-02-15 00:31:18.000000', 'temperatura', 997.0000, 'ºC'),
	(60792, 110, '2015-02-15 00:31:19.000000', 'temperatura', 695.0000, 'ºC'),
	(60793, 110, '2015-02-15 00:31:20.000000', 'temperatura', 485.0000, 'ºC'),
	(60794, 110, '2015-02-15 00:31:21.000000', 'temperatura', 340.0000, 'ºC'),
	(60795, 110, '2015-02-15 00:31:22.000000', 'temperatura', 244.0000, 'ºC'),
	(60796, 110, '2015-02-15 00:31:23.000000', 'temperatura', 201.0000, 'ºC'),
	(60797, 110, '2015-02-15 00:31:24.000000', 'temperatura', 275.0000, 'ºC'),
	(60798, 110, '2015-02-15 00:31:25.000000', 'temperatura', 771.0000, 'ºC'),
	(60799, 110, '2015-02-15 00:31:26.000000', 'temperatura', 630.0000, 'ºC'),
	(60800, 110, '2015-02-15 00:31:27.000000', 'temperatura', 840.0000, 'ºC'),
	(60801, 110, '2015-02-15 00:31:28.000000', 'temperatura', 1109.0000, 'ºC'),
	(60802, 110, '2015-02-15 00:31:29.000000', 'temperatura', 625.0000, 'ºC'),
	(60803, 110, '2015-02-15 00:31:30.000000', 'temperatura', 1000.0000, 'ºC'),
	(60804, 110, '2015-02-15 00:31:31.000000', 'temperatura', 724.0000, 'ºC'),
	(60805, 110, '2015-02-15 00:31:32.000000', 'temperatura', 619.0000, 'ºC'),
	(60806, 110, '2015-02-15 00:31:33.000000', 'temperatura', 927.0000, 'ºC'),
	(60807, 110, '2015-02-15 00:31:34.000000', 'temperatura', 376.0000, 'ºC'),
	(60808, 110, '2015-02-15 00:31:35.000000', 'temperatura', 301.0000, 'ºC'),
	(60809, 110, '2015-02-15 00:31:36.000000', 'temperatura', 375.0000, 'ºC'),
	(60810, 110, '2015-02-15 00:31:37.000000', 'temperatura', 975.0000, 'ºC'),
	(60811, 110, '2015-02-15 00:31:38.000000', 'temperatura', 149.0000, 'ºC'),
	(60812, 110, '2015-02-15 00:31:39.000000', 'temperatura', 220.0000, 'ºC'),
	(60813, 110, '2015-02-15 00:31:40.000000', 'temperatura', 656.0000, 'ºC'),
	(60814, 110, '2015-02-15 00:31:41.000000', 'temperatura', 220.0000, 'ºC'),
	(60815, 110, '2015-02-15 00:31:42.000000', 'temperatura', 331.0000, 'ºC'),
	(60816, 110, '2015-02-15 00:31:43.000000', 'temperatura', 996.0000, 'ºC'),
	(60817, 110, '2015-02-15 00:31:44.000000', 'temperatura', 387.0000, 'ºC'),
	(60818, 110, '2015-02-15 00:31:45.000000', 'temperatura', 149.0000, 'ºC'),
	(60819, 110, '2015-02-15 00:31:46.000000', 'temperatura', 785.0000, 'ºC'),
	(60820, 110, '2015-02-15 00:31:47.000000', 'temperatura', 1078.0000, 'ºC'),
	(60821, 110, '2015-02-15 00:31:48.000000', 'temperatura', 637.0000, 'ºC'),
	(60822, 110, '2015-02-15 00:31:49.000000', 'temperatura', 1150.0000, 'ºC'),
	(60823, 110, '2015-02-15 00:31:50.000000', 'temperatura', 238.0000, 'ºC'),
	(60824, 110, '2015-02-15 00:31:51.000000', 'temperatura', 142.0000, 'ºC'),
	(60825, 110, '2015-02-15 00:31:52.000000', 'temperatura', 1196.0000, 'ºC'),
	(60826, 110, '2015-02-15 00:31:53.000000', 'temperatura', 754.0000, 'ºC'),
	(60827, 110, '2015-02-15 00:31:54.000000', 'temperatura', 185.0000, 'ºC'),
	(60828, 110, '2015-02-15 00:31:55.000000', 'temperatura', 1062.0000, 'ºC'),
	(60829, 110, '2015-02-15 00:31:56.000000', 'temperatura', 1154.0000, 'ºC'),
	(60830, 110, '2015-02-15 00:31:57.000000', 'temperatura', 186.0000, 'ºC'),
	(60831, 110, '2015-02-15 00:31:58.000000', 'temperatura', 1067.0000, 'ºC'),
	(60832, 110, '2015-02-15 00:31:59.000000', 'temperatura', 1177.0000, 'ºC'),
	(60833, 110, '2015-02-15 00:32:00.000000', 'temperatura', 284.0000, 'ºC'),
	(60834, 110, '2015-02-15 00:32:01.000000', 'temperatura', 290.0000, 'ºC'),
	(60835, 110, '2015-02-15 00:32:02.000000', 'temperatura', 598.0000, 'ºC'),
	(60836, 110, '2015-02-15 00:32:03.000000', 'temperatura', 920.0000, 'ºC'),
	(60837, 110, '2015-02-15 00:32:04.000000', 'temperatura', 409.0000, 'ºC'),
	(60838, 110, '2015-02-15 00:32:05.000000', 'temperatura', 485.0000, 'ºC'),
	(60839, 110, '2015-02-15 00:32:06.000000', 'temperatura', 0.0000, 'ºC'),
	(60840, 110, '2015-02-15 00:32:07.000000', 'temperatura', 944.0000, 'ºC'),
	(60841, 110, '2015-02-15 00:32:08.000000', 'temperatura', 1120.0000, 'ºC'),
	(60842, 110, '2015-02-15 00:32:09.000000', 'temperatura', 370.0000, 'ºC'),
	(60843, 110, '2015-02-15 00:32:10.000000', 'temperatura', 889.0000, 'ºC'),
	(60844, 110, '2015-02-15 00:32:11.000000', 'temperatura', 937.0000, 'ºC'),
	(60845, 110, '2015-02-15 00:32:12.000000', 'temperatura', 819.0000, 'ºC'),
	(60846, 110, '2015-02-15 00:32:13.000000', 'temperatura', 85.0000, 'ºC'),
	(60847, 110, '2015-02-15 00:32:14.000000', 'temperatura', 368.0000, 'ºC'),
	(60848, 110, '2015-02-15 00:32:15.000000', 'temperatura', 387.0000, 'ºC'),
	(60849, 110, '2015-02-15 00:32:16.000000', 'temperatura', 828.0000, 'ºC'),
	(60850, 110, '2015-02-15 00:32:17.000000', 'temperatura', 582.0000, 'ºC'),
	(60851, 110, '2015-02-15 00:32:18.000000', 'temperatura', 425.0000, 'ºC'),
	(60852, 110, '2015-02-15 00:32:19.000000', 'temperatura', 378.0000, 'ºC'),
	(60853, 110, '2015-02-15 00:32:20.000000', 'temperatura', 619.0000, 'ºC'),
	(60854, 110, '2015-02-15 00:32:21.000000', 'temperatura', 760.0000, 'ºC'),
	(60855, 110, '2015-02-15 00:32:22.000000', 'temperatura', 744.0000, 'ºC'),
	(60856, 110, '2015-02-15 00:32:23.000000', 'temperatura', 238.0000, 'ºC'),
	(60857, 110, '2015-02-15 00:32:24.000000', 'temperatura', 161.0000, 'ºC'),
	(60858, 110, '2015-02-15 00:32:25.000000', 'temperatura', 91.0000, 'ºC'),
	(60859, 110, '2015-02-15 00:32:26.000000', 'temperatura', 1174.0000, 'ºC'),
	(60860, 110, '2015-02-15 00:32:27.000000', 'temperatura', 797.0000, 'ºC'),
	(60861, 110, '2015-02-15 00:32:28.000000', 'temperatura', 462.0000, 'ºC'),
	(60862, 110, '2015-02-15 00:32:29.000000', 'temperatura', 1120.0000, 'ºC'),
	(60863, 110, '2015-02-15 00:32:30.000000', 'temperatura', 613.0000, 'ºC'),
	(60864, 110, '2015-02-15 00:32:31.000000', 'temperatura', 905.0000, 'ºC'),
	(60865, 110, '2015-02-15 00:32:32.000000', 'temperatura', 287.0000, 'ºC'),
	(60866, 110, '2015-02-15 00:32:33.000000', 'temperatura', 1122.0000, 'ºC'),
	(60867, 110, '2015-02-15 00:32:34.000000', 'temperatura', 1151.0000, 'ºC'),
	(60868, 110, '2015-02-15 00:32:35.000000', 'temperatura', 1187.0000, 'ºC'),
	(60869, 110, '2015-02-15 00:32:36.000000', 'temperatura', 82.0000, 'ºC'),
	(60870, 110, '2015-02-15 00:32:37.000000', 'temperatura', 451.0000, 'ºC'),
	(60871, 110, '2015-02-15 00:32:38.000000', 'temperatura', 809.0000, 'ºC'),
	(60872, 110, '2015-02-15 00:32:39.000000', 'temperatura', 294.0000, 'ºC'),
	(60873, 110, '2015-02-15 00:32:40.000000', 'temperatura', 244.0000, 'ºC'),
	(60874, 110, '2015-02-15 00:32:41.000000', 'temperatura', 337.0000, 'ºC'),
	(60875, 110, '2015-02-15 00:32:42.000000', 'temperatura', 954.0000, 'ºC'),
	(60876, 110, '2015-02-15 00:32:43.000000', 'temperatura', 160.0000, 'ºC'),
	(60877, 110, '2015-02-15 00:32:44.000000', 'temperatura', 336.0000, 'ºC'),
	(60878, 110, '2015-02-15 00:32:45.000000', 'temperatura', 4.0000, 'ºC'),
	(60879, 110, '2015-02-15 00:32:46.000000', 'temperatura', 210.0000, 'ºC'),
	(60880, 110, '2015-02-15 00:32:47.000000', 'temperatura', 1041.0000, 'ºC'),
	(60881, 110, '2015-02-15 00:32:48.000000', 'temperatura', 975.0000, 'ºC'),
	(60882, 110, '2015-02-15 00:32:49.000000', 'temperatura', 550.0000, 'ºC'),
	(60883, 110, '2015-02-15 00:32:50.000000', 'temperatura', 1028.0000, 'ºC'),
	(60884, 110, '2015-02-15 00:32:51.000000', 'temperatura', 1091.0000, 'ºC'),
	(60885, 110, '2015-02-15 00:32:52.000000', 'temperatura', 1170.0000, 'ºC'),
	(60886, 110, '2015-02-15 00:32:53.000000', 'temperatura', 178.0000, 'ºC'),
	(60887, 110, '2015-02-15 00:32:54.000000', 'temperatura', 981.0000, 'ºC'),
	(60888, 110, '2015-02-15 00:32:55.000000', 'temperatura', 772.0000, 'ºC'),
	(60889, 110, '2015-02-15 00:32:56.000000', 'temperatura', 917.0000, 'ºC'),
	(60890, 110, '2015-02-15 00:32:57.000000', 'temperatura', 1068.0000, 'ºC'),
	(60891, 110, '2015-02-15 00:32:58.000000', 'temperatura', 190.0000, 'ºC'),
	(60892, 110, '2015-02-15 00:32:59.000000', 'temperatura', 149.0000, 'ºC'),
	(60893, 110, '2015-02-15 00:33:00.000000', 'temperatura', 173.0000, 'ºC'),
	(60894, 110, '2015-02-15 00:33:01.000000', 'temperatura', 418.0000, 'ºC'),
	(60895, 110, '2015-02-15 00:33:02.000000', 'temperatura', 374.0000, 'ºC'),
	(60896, 110, '2015-02-15 00:33:03.000000', 'temperatura', 616.0000, 'ºC'),
	(60897, 110, '2015-02-15 00:33:04.000000', 'temperatura', 758.0000, 'ºC'),
	(60898, 110, '2015-02-15 00:33:05.000000', 'temperatura', 744.0000, 'ºC'),
	(60899, 110, '2015-02-15 00:33:06.000000', 'temperatura', 244.0000, 'ºC'),
	(60900, 110, '2015-02-15 00:33:07.000000', 'temperatura', 190.0000, 'ºC'),
	(60901, 110, '2015-02-15 00:33:08.000000', 'temperatura', 217.0000, 'ºC'),
	(60902, 110, '2015-02-15 00:33:09.000000', 'temperatura', 516.0000, 'ºC'),
	(60903, 110, '2015-02-15 00:33:10.000000', 'temperatura', 731.0000, 'ºC'),
	(60904, 110, '2015-02-15 00:33:11.000000', 'temperatura', 906.0000, 'ºC'),
	(60905, 110, '2015-02-15 00:33:12.000000', 'temperatura', 1140.0000, 'ºC'),
	(60906, 110, '2015-02-15 00:33:13.000000', 'temperatura', 580.0000, 'ºC'),
	(60907, 110, '2015-02-15 00:33:14.000000', 'temperatura', 682.0000, 'ºC'),
	(60908, 110, '2015-02-15 00:33:15.000000', 'temperatura', 469.0000, 'ºC'),
	(60909, 110, '2015-02-15 00:33:16.000000', 'temperatura', 302.0000, 'ºC'),
	(60910, 110, '2015-02-15 00:33:17.000000', 'temperatura', 103.0000, 'ºC'),
	(60911, 110, '2015-02-15 00:33:18.000000', 'temperatura', 809.0000, 'ºC'),
	(60912, 110, '2015-02-15 00:33:19.000000', 'temperatura', 138.0000, 'ºC'),
	(60913, 110, '2015-02-15 00:33:20.000000', 'temperatura', 664.0000, 'ºC'),
	(60914, 110, '2015-02-15 00:33:21.000000', 'temperatura', 503.0000, 'ºC'),
	(60915, 110, '2015-02-15 00:33:22.000000', 'temperatura', 527.0000, 'ºC'),
	(60916, 110, '2015-02-15 00:33:23.000000', 'temperatura', 1126.0000, 'ºC'),
	(60917, 110, '2015-02-15 00:33:24.000000', 'temperatura', 447.0000, 'ºC'),
	(60918, 110, '2015-02-15 00:33:25.000000', 'temperatura', 61.0000, 'ºC'),
	(60919, 110, '2015-02-15 00:33:26.000000', 'temperatura', 162.0000, 'ºC'),
	(60920, 110, '2015-02-15 00:33:27.000000', 'temperatura', 627.0000, 'ºC'),
	(60921, 110, '2015-02-15 00:33:28.000000', 'temperatura', 249.0000, 'ºC'),
	(60922, 110, '2015-02-15 00:33:29.000000', 'temperatura', 564.0000, 'ºC'),
	(60923, 110, '2015-02-15 00:33:30.000000', 'temperatura', 873.0000, 'ºC'),
	(60924, 110, '2015-02-15 00:33:31.000000', 'temperatura', 275.0000, 'ºC'),
	(60925, 110, '2015-02-15 00:33:32.000000', 'temperatura', 1158.0000, 'ºC'),
	(60926, 110, '2015-02-15 00:33:33.000000', 'temperatura', 163.0000, 'ºC'),
	(60927, 110, '2015-02-15 00:33:34.000000', 'temperatura', 940.0000, 'ºC'),
	(60928, 110, '2015-02-15 00:33:35.000000', 'temperatura', 614.0000, 'ºC'),
	(60929, 110, '2015-02-15 00:33:36.000000', 'temperatura', 250.0000, 'ºC'),
	(60930, 110, '2015-02-15 00:33:37.000000', 'temperatura', 609.0000, 'ºC'),
	(60931, 110, '2015-02-15 00:33:38.000000', 'temperatura', 1095.0000, 'ºC'),
	(60932, 110, '2015-02-15 00:33:39.000000', 'temperatura', 46.0000, 'ºC'),
	(60933, 110, '2015-02-15 00:33:40.000000', 'temperatura', 549.0000, 'ºC'),
	(60934, 110, '2015-02-15 00:33:41.000000', 'temperatura', 208.0000, 'ºC'),
	(60935, 110, '2015-02-15 00:33:42.000000', 'temperatura', 591.0000, 'ºC'),
	(60936, 110, '2015-02-15 00:33:43.000000', 'temperatura', 1131.0000, 'ºC'),
	(60937, 110, '2015-02-15 00:33:44.000000', 'temperatura', 285.0000, 'ºC'),
	(60938, 110, '2015-02-15 00:33:45.000000', 'temperatura', 431.0000, 'ºC'),
	(60939, 110, '2015-02-15 00:33:46.000000', 'temperatura', 103.0000, 'ºC'),
	(60940, 110, '2015-02-15 00:33:47.000000', 'temperatura', 420.0000, 'ºC'),
	(60941, 110, '2015-02-15 00:33:48.000000', 'temperatura', 594.0000, 'ºC'),
	(60942, 110, '2015-02-15 00:33:49.000000', 'temperatura', 509.0000, 'ºC'),
	(60943, 110, '2015-02-15 00:33:50.000000', 'temperatura', 763.0000, 'ºC'),
	(60944, 110, '2015-02-15 00:33:51.000000', 'temperatura', 1089.0000, 'ºC'),
	(60945, 110, '2015-02-15 00:33:52.000000', 'temperatura', 754.0000, 'ºC'),
	(60946, 110, '2015-02-15 00:33:53.000000', 'temperatura', 507.0000, 'ºC'),
	(60947, 110, '2015-02-15 00:33:54.000000', 'temperatura', 271.0000, 'ºC'),
	(60948, 110, '2015-02-15 00:33:55.000000', 'temperatura', 1034.0000, 'ºC'),
	(60949, 110, '2015-02-15 00:33:56.000000', 'temperatura', 757.0000, 'ºC'),
	(60950, 110, '2015-02-15 00:33:57.000000', 'temperatura', 686.0000, 'ºC'),
	(60951, 110, '2015-02-15 00:33:58.000000', 'temperatura', 1160.0000, 'ºC'),
	(60952, 110, '2015-02-15 00:33:59.000000', 'temperatura', 142.0000, 'ºC'),
	(60953, 110, '2015-02-15 00:34:00.000000', 'temperatura', 831.0000, 'ºC'),
	(60954, 110, '2015-02-15 00:34:01.000000', 'temperatura', 130.0000, 'ºC'),
	(60955, 110, '2015-02-15 00:34:02.000000', 'temperatura', 555.0000, 'ºC'),
	(60956, 110, '2015-02-15 00:34:03.000000', 'temperatura', 1188.0000, 'ºC'),
	(60957, 110, '2015-02-15 00:34:04.000000', 'temperatura', 674.0000, 'ºC'),
	(60958, 110, '2015-02-15 00:34:05.000000', 'temperatura', 1005.0000, 'ºC'),
	(60959, 110, '2015-02-15 00:34:06.000000', 'temperatura', 606.0000, 'ºC'),
	(60960, 110, '2015-02-15 00:34:07.000000', 'temperatura', 14.0000, 'ºC'),
	(60961, 110, '2015-02-15 00:34:08.000000', 'temperatura', 653.0000, 'ºC'),
	(60962, 110, '2015-02-15 00:34:09.000000', 'temperatura', 823.0000, 'ºC'),
	(60963, 110, '2015-02-15 00:34:10.000000', 'temperatura', 957.0000, 'ºC'),
	(60964, 110, '2015-02-15 00:34:11.000000', 'temperatura', 1117.0000, 'ºC'),
	(60965, 110, '2015-02-15 00:34:12.000000', 'temperatura', 316.0000, 'ºC'),
	(60966, 110, '2015-02-15 00:34:13.000000', 'temperatura', 628.0000, 'ºC'),
	(60967, 110, '2015-02-15 00:34:14.000000', 'temperatura', 993.0000, 'ºC'),
	(60968, 110, '2015-02-15 00:34:15.000000', 'temperatura', 682.0000, 'ºC'),
	(60969, 110, '2015-02-15 00:34:16.000000', 'temperatura', 430.0000, 'ºC'),
	(60970, 110, '2015-02-15 00:34:17.000000', 'temperatura', 104.0000, 'ºC'),
	(60971, 110, '2015-02-15 00:34:18.000000', 'temperatura', 433.0000, 'ºC'),
	(60972, 110, '2015-02-15 00:34:19.000000', 'temperatura', 654.0000, 'ºC'),
	(60973, 110, '2015-02-15 00:34:20.000000', 'temperatura', 771.0000, 'ºC'),
	(60974, 110, '2015-02-15 00:34:21.000000', 'temperatura', 692.0000, 'ºC'),
	(60975, 110, '2015-02-15 00:34:22.000000', 'temperatura', 1148.0000, 'ºC'),
	(60976, 110, '2015-02-15 00:34:23.000000', 'temperatura', 63.0000, 'ºC'),
	(60977, 110, '2015-02-15 00:34:24.000000', 'temperatura', 471.0000, 'ºC'),
	(60978, 110, '2015-02-15 00:34:25.000000', 'temperatura', 967.0000, 'ºC'),
	(60979, 110, '2015-02-15 00:34:26.000000', 'temperatura', 1023.0000, 'ºC'),
	(60980, 110, '2015-02-15 00:34:27.000000', 'temperatura', 1013.0000, 'ºC'),
	(60981, 110, '2015-02-15 00:34:28.000000', 'temperatura', 798.0000, 'ºC'),
	(60982, 110, '2015-02-15 00:34:29.000000', 'temperatura', 953.0000, 'ºC'),
	(60983, 110, '2015-02-15 00:34:30.000000', 'temperatura', 1171.0000, 'ºC'),
	(60984, 110, '2015-02-15 00:34:31.000000', 'temperatura', 598.0000, 'ºC'),
	(60985, 110, '2015-02-15 00:34:32.000000', 'temperatura', 675.0000, 'ºC'),
	(60986, 110, '2015-02-15 00:34:33.000000', 'temperatura', 383.0000, 'ºC'),
	(60987, 110, '2015-02-15 00:34:34.000000', 'temperatura', 1092.0000, 'ºC'),
	(60988, 110, '2015-02-15 00:34:35.000000', 'temperatura', 710.0000, 'ºC'),
	(60989, 110, '2015-02-15 00:34:36.000000', 'temperatura', 275.0000, 'ºC'),
	(60990, 110, '2015-02-15 00:34:37.000000', 'temperatura', 445.0000, 'ºC'),
	(60991, 110, '2015-02-15 00:34:38.000000', 'temperatura', 200.0000, 'ºC'),
	(60992, 110, '2015-02-15 00:34:39.000000', 'temperatura', 866.0000, 'ºC'),
	(60993, 110, '2015-02-15 00:34:40.000000', 'temperatura', 129.0000, 'ºC'),
	(60994, 110, '2015-02-15 00:34:41.000000', 'temperatura', 448.0000, 'ºC'),
	(60995, 110, '2015-02-15 00:34:42.000000', 'temperatura', 654.0000, 'ºC'),
	(60996, 110, '2015-02-15 00:34:43.000000', 'temperatura', 726.0000, 'ºC'),
	(60997, 110, '2015-02-15 00:34:44.000000', 'temperatura', 470.0000, 'ºC'),
	(60998, 110, '2015-02-15 00:34:45.000000', 'temperatura', 171.0000, 'ºC'),
	(60999, 110, '2015-02-15 00:34:46.000000', 'temperatura', 646.0000, 'ºC'),
	(61000, 110, '2015-02-15 00:34:47.000000', 'temperatura', 319.0000, 'ºC'),
	(61001, 110, '2015-02-15 00:34:48.000000', 'temperatura', 858.0000, 'ºC'),
	(61002, 110, '2015-02-15 00:34:49.000000', 'temperatura', 932.0000, 'ºC'),
	(61003, 110, '2015-02-15 00:34:50.000000', 'temperatura', 888.0000, 'ºC'),
	(61004, 110, '2015-02-15 00:34:51.000000', 'temperatura', 445.0000, 'ºC'),
	(61005, 110, '2015-02-15 00:34:52.000000', 'temperatura', 761.0000, 'ºC'),
	(61006, 110, '2015-02-15 00:34:53.000000', 'temperatura', 72.0000, 'ºC'),
	(61007, 110, '2015-02-15 00:34:54.000000', 'temperatura', 477.0000, 'ºC'),
	(61008, 110, '2015-02-15 00:34:55.000000', 'temperatura', 967.0000, 'ºC'),
	(61009, 110, '2015-02-15 00:34:56.000000', 'temperatura', 1006.0000, 'ºC'),
	(61010, 110, '2015-02-15 00:34:57.000000', 'temperatura', 931.0000, 'ºC'),
	(61011, 110, '2015-02-15 00:34:58.000000', 'temperatura', 437.0000, 'ºC'),
	(61012, 110, '2015-02-15 00:34:59.000000', 'temperatura', 592.0000, 'ºC'),
	(61013, 110, '2015-02-15 00:35:00.000000', 'temperatura', 448.0000, 'ºC'),
	(61014, 110, '2015-02-15 00:35:01.000000', 'temperatura', 464.0000, 'ºC'),
	(61015, 110, '2015-02-15 00:35:02.000000', 'temperatura', 978.0000, 'ºC'),
	(61016, 110, '2015-02-15 00:35:03.000000', 'temperatura', 1099.0000, 'ºC'),
	(61017, 110, '2015-02-15 00:35:04.000000', 'temperatura', 162.0000, 'ºC'),
	(61018, 110, '2015-02-15 00:35:05.000000', 'temperatura', 1115.0000, 'ºC'),
	(61019, 110, '2015-02-15 00:35:06.000000', 'temperatura', 287.0000, 'ºC'),
	(61020, 110, '2015-02-15 00:35:07.000000', 'temperatura', 491.0000, 'ºC'),
	(61021, 110, '2015-02-15 00:35:08.000000', 'temperatura', 395.0000, 'ºC'),
	(61022, 110, '2015-02-15 00:35:09.000000', 'temperatura', 502.0000, 'ºC'),
	(61023, 110, '2015-02-15 00:35:10.000000', 'temperatura', 127.0000, 'ºC'),
	(61024, 110, '2015-02-15 00:35:11.000000', 'temperatura', 330.0000, 'ºC'),
	(61025, 110, '2015-02-15 00:35:12.000000', 'temperatura', 67.0000, 'ºC'),
	(61026, 110, '2015-02-15 00:35:13.000000', 'temperatura', 546.0000, 'ºC'),
	(61027, 110, '2015-02-15 00:35:14.000000', 'temperatura', 130.0000, 'ºC'),
	(61028, 110, '2015-02-15 00:35:15.000000', 'temperatura', 212.0000, 'ºC'),
	(61029, 110, '2015-02-15 00:35:16.000000', 'temperatura', 672.0000, 'ºC'),
	(61030, 110, '2015-02-15 00:35:17.000000', 'temperatura', 326.0000, 'ºC'),
	(61031, 110, '2015-02-15 00:35:18.000000', 'temperatura', 812.0000, 'ºC'),
	(61032, 110, '2015-02-15 00:35:19.000000', 'temperatura', 683.0000, 'ºC'),
	(61033, 110, '2015-02-15 00:35:20.000000', 'temperatura', 978.0000, 'ºC'),
	(61034, 110, '2015-02-15 00:35:21.000000', 'temperatura', 443.0000, 'ºC'),
	(61035, 110, '2015-02-15 00:35:22.000000', 'temperatura', 482.0000, 'ºC'),
	(61036, 110, '2015-02-15 00:35:23.000000', 'temperatura', 1080.0000, 'ºC'),
	(61037, 110, '2015-02-15 00:35:24.000000', 'temperatura', 356.0000, 'ºC'),
	(61038, 110, '2015-02-15 00:35:25.000000', 'temperatura', 941.0000, 'ºC'),
	(61039, 110, '2015-02-15 00:35:26.000000', 'temperatura', 36.0000, 'ºC'),
	(61040, 110, '2015-02-15 00:35:27.000000', 'temperatura', 959.0000, 'ºC'),
	(61041, 110, '2015-02-15 00:35:28.000000', 'temperatura', 1088.0000, 'ºC'),
	(61042, 110, '2015-02-15 00:35:29.000000', 'temperatura', 161.0000, 'ºC'),
	(61043, 110, '2015-02-15 00:35:30.000000', 'temperatura', 1141.0000, 'ºC'),
	(61044, 110, '2015-02-15 00:35:31.000000', 'temperatura', 425.0000, 'ºC'),
	(61045, 110, '2015-02-15 00:35:32.000000', 'temperatura', 1103.0000, 'ºC'),
	(61046, 110, '2015-02-15 00:35:33.000000', 'temperatura', 641.0000, 'ºC'),
	(61047, 110, '2015-02-15 00:35:34.000000', 'temperatura', 1096.0000, 'ºC'),
	(61048, 110, '2015-02-15 00:35:35.000000', 'temperatura', 1155.0000, 'ºC'),
	(61049, 110, '2015-02-15 00:35:36.000000', 'temperatura', 91.0000, 'ºC'),
	(61050, 110, '2015-02-15 00:35:37.000000', 'temperatura', 588.0000, 'ºC'),
	(61051, 110, '2015-02-15 00:35:38.000000', 'temperatura', 269.0000, 'ºC'),
	(61052, 110, '2015-02-15 00:35:39.000000', 'temperatura', 781.0000, 'ºC'),
	(61053, 110, '2015-02-15 00:35:40.000000', 'temperatura', 700.0000, 'ºC'),
	(61054, 110, '2015-02-15 00:35:41.000000', 'temperatura', 1158.0000, 'ºC'),
	(61055, 110, '2015-02-15 00:35:42.000000', 'temperatura', 90.0000, 'ºC'),
	(61056, 110, '2015-02-15 00:35:43.000000', 'temperatura', 574.0000, 'ºC'),
	(61057, 110, '2015-02-15 00:35:44.000000', 'temperatura', 203.0000, 'ºC'),
	(61058, 110, '2015-02-15 00:35:45.000000', 'temperatura', 492.0000, 'ºC'),
	(61059, 110, '2015-02-15 00:35:46.000000', 'temperatura', 651.0000, 'ºC'),
	(61060, 110, '2015-02-15 00:35:47.000000', 'temperatura', 582.0000, 'ºC'),
	(61061, 110, '2015-02-15 00:35:48.000000', 'temperatura', 955.0000, 'ºC'),
	(61062, 110, '2015-02-15 00:35:49.000000', 'temperatura', 632.0000, 'ºC'),
	(61063, 110, '2015-02-15 00:35:50.000000', 'temperatura', 295.0000, 'ºC'),
	(61064, 110, '2015-02-15 00:35:51.000000', 'temperatura', 780.0000, 'ºC'),
	(61065, 110, '2015-02-15 00:35:52.000000', 'temperatura', 616.0000, 'ºC'),
	(61066, 110, '2015-02-15 00:35:53.000000', 'temperatura', 742.0000, 'ºC'),
	(61067, 110, '2015-02-15 00:35:54.000000', 'temperatura', 659.0000, 'ºC'),
	(61068, 110, '2015-02-15 00:35:55.000000', 'temperatura', 1071.0000, 'ºC'),
	(61069, 110, '2015-02-15 00:35:56.000000', 'temperatura', 979.0000, 'ºC'),
	(61070, 110, '2015-02-15 00:35:57.000000', 'temperatura', 480.0000, 'ºC'),
	(61071, 110, '2015-02-15 00:35:58.000000', 'temperatura', 666.0000, 'ºC'),
	(61072, 110, '2015-02-15 00:35:59.000000', 'temperatura', 688.0000, 'ºC'),
	(61073, 110, '2015-02-15 00:36:00.000000', 'temperatura', 244.0000, 'ºC'),
	(61074, 110, '2015-02-15 00:36:01.000000', 'temperatura', 358.0000, 'ºC'),
	(61075, 110, '2015-02-15 00:36:02.000000', 'temperatura', 1058.0000, 'ºC'),
	(61076, 110, '2015-02-15 00:36:03.000000', 'temperatura', 614.0000, 'ºC'),
	(61077, 110, '2015-02-15 00:36:04.000000', 'temperatura', 1098.0000, 'ºC'),
	(61078, 110, '2015-02-15 00:36:05.000000', 'temperatura', 47.0000, 'ºC'),
	(61079, 110, '2015-02-15 00:36:06.000000', 'temperatura', 541.0000, 'ºC'),
	(61080, 110, '2015-02-15 00:36:07.000000', 'temperatura', 166.0000, 'ºC'),
	(61081, 110, '2015-02-15 00:36:08.000000', 'temperatura', 407.0000, 'ºC'),
	(61082, 110, '2015-02-15 00:36:09.000000', 'temperatura', 336.0000, 'ºC'),
	(61083, 110, '2015-02-15 00:36:10.000000', 'temperatura', 462.0000, 'ºC'),
	(61084, 110, '2015-02-15 00:36:11.000000', 'temperatura', 99.0000, 'ºC'),
	(61085, 110, '2015-02-15 00:36:12.000000', 'temperatura', 313.0000, 'ºC'),
	(61086, 110, '2015-02-15 00:36:13.000000', 'temperatura', 68.0000, 'ºC'),
	(61087, 110, '2015-02-15 00:36:14.000000', 'temperatura', 599.0000, 'ºC'),
	(61088, 110, '2015-02-15 00:36:15.000000', 'temperatura', 394.0000, 'ºC'),
	(61089, 110, '2015-02-15 00:36:16.000000', 'temperatura', 172.0000, 'ºC'),
	(61090, 110, '2015-02-15 00:36:17.000000', 'temperatura', 879.0000, 'ºC'),
	(61091, 110, '2015-02-15 00:36:18.000000', 'temperatura', 278.0000, 'ºC'),
	(61092, 110, '2015-02-15 00:36:19.000000', 'temperatura', 1153.0000, 'ºC'),
	(61093, 110, '2015-02-15 00:36:20.000000', 'temperatura', 131.0000, 'ºC'),
	(61094, 110, '2015-02-15 00:36:21.000000', 'temperatura', 796.0000, 'ºC'),
	(61095, 110, '2015-02-15 00:36:22.000000', 'temperatura', 1190.0000, 'ºC'),
	(61096, 110, '2015-02-15 00:36:23.000000', 'temperatura', 1163.0000, 'ºC'),
	(61097, 110, '2015-02-15 00:36:24.000000', 'temperatura', 1043.0000, 'ºC'),
	(61098, 110, '2015-02-15 00:36:25.000000', 'temperatura', 526.0000, 'ºC'),
	(61099, 110, '2015-02-15 00:36:26.000000', 'temperatura', 705.0000, 'ºC'),
	(61100, 110, '2015-02-15 00:36:27.000000', 'temperatura', 744.0000, 'ºC'),
	(61101, 110, '2015-02-15 00:36:28.000000', 'temperatura', 408.0000, 'ºC'),
	(61102, 110, '2015-02-15 00:36:29.000000', 'temperatura', 1007.0000, 'ºC'),
	(61103, 110, '2015-02-15 00:36:30.000000', 'temperatura', 210.0000, 'ºC'),
	(61104, 110, '2015-02-15 00:36:31.000000', 'temperatura', 432.0000, 'ºC'),
	(61105, 110, '2015-02-15 00:36:32.000000', 'temperatura', 331.0000, 'ºC'),
	(61106, 110, '2015-02-15 00:36:33.000000', 'temperatura', 359.0000, 'ºC'),
	(61107, 110, '2015-02-15 00:36:34.000000', 'temperatura', 800.0000, 'ºC'),
	(61108, 110, '2015-02-15 00:36:35.000000', 'temperatura', 526.0000, 'ºC'),
	(61109, 110, '2015-02-15 00:36:36.000000', 'temperatura', 230.0000, 'ºC'),
	(61110, 110, '2015-02-15 00:36:37.000000', 'temperatura', 772.0000, 'ºC'),
	(61111, 110, '2015-02-15 00:36:38.000000', 'temperatura', 770.0000, 'ºC'),
	(61112, 110, '2015-02-15 00:36:39.000000', 'temperatura', 336.0000, 'ºC'),
	(61113, 110, '2015-02-15 00:36:40.000000', 'temperatura', 572.0000, 'ºC'),
	(61114, 110, '2015-02-15 00:36:41.000000', 'temperatura', 649.0000, 'ºC'),
	(61115, 110, '2015-02-15 00:36:42.000000', 'temperatura', 333.0000, 'ºC'),
	(61116, 110, '2015-02-15 00:36:43.000000', 'temperatura', 917.0000, 'ºC'),
	(61117, 110, '2015-02-15 00:36:44.000000', 'temperatura', 1185.0000, 'ºC'),
	(61118, 110, '2015-02-15 00:36:45.000000', 'temperatura', 775.0000, 'ºC'),
	(61119, 110, '2015-02-15 00:36:46.000000', 'temperatura', 321.0000, 'ºC'),
	(61120, 110, '2015-02-15 00:36:47.000000', 'temperatura', 478.0000, 'ºC'),
	(61121, 110, '2015-02-15 00:36:48.000000', 'temperatura', 231.0000, 'ºC'),
	(61122, 110, '2015-02-15 00:36:49.000000', 'temperatura', 919.0000, 'ºC'),
	(61123, 110, '2015-02-15 00:36:50.000000', 'temperatura', 301.0000, 'ºC'),
	(61124, 110, '2015-02-15 00:36:51.000000', 'temperatura', 1152.0000, 'ºC'),
	(61125, 110, '2015-02-15 00:36:52.000000', 'temperatura', 57.0000, 'ºC'),
	(61126, 110, '2015-02-15 00:36:53.000000', 'temperatura', 427.0000, 'ºC'),
	(61127, 110, '2015-02-15 00:36:54.000000', 'temperatura', 766.0000, 'ºC'),
	(61128, 110, '2015-02-15 00:36:55.000000', 'temperatura', 148.0000, 'ºC'),
	(61129, 110, '2015-02-15 00:36:56.000000', 'temperatura', 843.0000, 'ºC'),
	(61130, 110, '2015-02-15 00:36:57.000000', 'temperatura', 171.0000, 'ºC'),
	(61131, 110, '2015-02-15 00:36:58.000000', 'temperatura', 726.0000, 'ºC'),
	(61132, 110, '2015-02-15 00:36:59.000000', 'temperatura', 718.0000, 'ºC'),
	(61133, 110, '2015-02-15 00:37:00.000000', 'temperatura', 211.0000, 'ºC'),
	(61134, 110, '2015-02-15 00:37:01.000000', 'temperatura', 103.0000, 'ºC'),
	(61135, 110, '2015-02-15 00:37:02.000000', 'temperatura', 1083.0000, 'ºC'),
	(61136, 110, '2015-02-15 00:37:03.000000', 'temperatura', 304.0000, 'ºC'),
	(61137, 110, '2015-02-15 00:37:04.000000', 'temperatura', 675.0000, 'ºC'),
	(61138, 110, '2015-02-15 00:37:05.000000', 'temperatura', 61.0000, 'ºC'),
	(61139, 110, '2015-02-15 00:37:06.000000', 'temperatura', 681.0000, 'ºC'),
	(61140, 110, '2015-02-15 00:37:07.000000', 'temperatura', 823.0000, 'ºC'),
	(61141, 110, '2015-02-15 00:37:08.000000', 'temperatura', 874.0000, 'ºC'),
	(61142, 110, '2015-02-15 00:37:09.000000', 'temperatura', 699.0000, 'ºC'),
	(61143, 110, '2015-02-15 00:37:10.000000', 'temperatura', 872.0000, 'ºC'),
	(61144, 110, '2015-02-15 00:37:11.000000', 'temperatura', 1067.0000, 'ºC'),
	(61145, 110, '2015-02-15 00:37:12.000000', 'temperatura', 318.0000, 'ºC'),
	(61146, 110, '2015-02-15 00:37:13.000000', 'temperatura', 791.0000, 'ºC'),
	(61147, 110, '2015-02-15 00:37:14.000000', 'temperatura', 599.0000, 'ºC'),
	(61148, 110, '2015-02-15 00:37:15.000000', 'temperatura', 623.0000, 'ºC'),
	(61149, 110, '2015-02-15 00:37:16.000000', 'temperatura', 120.0000, 'ºC'),
	(61150, 110, '2015-02-15 00:37:17.000000', 'temperatura', 1131.0000, 'ºC'),
	(61151, 110, '2015-02-15 00:37:18.000000', 'temperatura', 496.0000, 'ºC'),
	(61152, 110, '2015-02-15 00:37:19.000000', 'temperatura', 289.0000, 'ºC'),
	(61153, 110, '2015-02-15 00:37:20.000000', 'temperatura', 1156.0000, 'ºC'),
	(61154, 110, '2015-02-15 00:37:21.000000', 'temperatura', 115.0000, 'ºC'),
	(61155, 110, '2015-02-15 00:37:22.000000', 'temperatura', 706.0000, 'ºC'),
	(61156, 110, '2015-02-15 00:37:23.000000', 'temperatura', 784.0000, 'ºC'),
	(61157, 110, '2015-02-15 00:37:24.000000', 'temperatura', 606.0000, 'ºC'),
	(61158, 110, '2015-02-15 00:37:25.000000', 'temperatura', 677.0000, 'ºC'),
	(61159, 110, '2015-02-15 00:37:26.000000', 'temperatura', 365.0000, 'ºC'),
	(61160, 110, '2015-02-15 00:37:27.000000', 'temperatura', 998.0000, 'ºC'),
	(61161, 110, '2015-02-15 00:37:28.000000', 'temperatura', 294.0000, 'ºC'),
	(61162, 110, '2015-02-15 00:37:29.000000', 'temperatura', 875.0000, 'ºC'),
	(61163, 110, '2015-02-15 00:37:30.000000', 'temperatura', 1094.0000, 'ºC'),
	(61164, 110, '2015-02-15 00:37:31.000000', 'temperatura', 445.0000, 'ºC'),
	(61165, 110, '2015-02-15 00:37:32.000000', 'temperatura', 142.0000, 'ºC'),
	(61166, 110, '2015-02-15 00:37:33.000000', 'temperatura', 578.0000, 'ºC'),
	(61167, 110, '2015-02-15 00:37:34.000000', 'temperatura', 66.0000, 'ºC'),
	(61168, 110, '2015-02-15 00:37:35.000000', 'temperatura', 994.0000, 'ºC'),
	(61169, 110, '2015-02-15 00:37:36.000000', 'temperatura', 1174.0000, 'ºC'),
	(61170, 110, '2015-02-15 00:37:37.000000', 'temperatura', 489.0000, 'ºC'),
	(61171, 110, '2015-02-15 00:37:38.000000', 'temperatura', 122.0000, 'ºC'),
	(61172, 110, '2015-02-15 00:37:39.000000', 'temperatura', 345.0000, 'ºC'),
	(61173, 110, '2015-02-15 00:37:40.000000', 'temperatura', 160.0000, 'ºC'),
	(61174, 110, '2015-02-15 00:37:41.000000', 'temperatura', 964.0000, 'ºC'),
	(61175, 110, '2015-02-15 00:37:42.000000', 'temperatura', 739.0000, 'ºC'),
	(61176, 110, '2015-02-15 00:37:43.000000', 'temperatura', 805.0000, 'ºC'),
	(61177, 110, '2015-02-15 00:37:44.000000', 'temperatura', 608.0000, 'ºC'),
	(61178, 110, '2015-02-15 00:37:45.000000', 'temperatura', 625.0000, 'ºC'),
	(61179, 110, '2015-02-15 00:37:46.000000', 'temperatura', 102.0000, 'ºC'),
	(61180, 110, '2015-02-15 00:37:47.000000', 'temperatura', 1034.0000, 'ºC'),
	(61181, 110, '2015-02-15 00:37:48.000000', 'temperatura', 64.0000, 'ºC'),
	(61182, 110, '2015-02-15 00:37:49.000000', 'temperatura', 819.0000, 'ºC'),
	(61183, 110, '2015-02-15 00:37:50.000000', 'temperatura', 305.0000, 'ºC'),
	(61184, 110, '2015-02-15 00:37:51.000000', 'temperatura', 267.0000, 'ºC'),
	(61185, 110, '2015-02-15 00:37:52.000000', 'temperatura', 422.0000, 'ºC'),
	(61186, 110, '2015-02-15 00:37:53.000000', 'temperatura', 107.0000, 'ºC'),
	(61187, 110, '2015-02-15 00:37:54.000000', 'temperatura', 471.0000, 'ºC'),
	(61188, 110, '2015-02-15 00:37:55.000000', 'temperatura', 834.0000, 'ºC'),
	(61189, 110, '2015-02-15 00:37:56.000000', 'temperatura', 357.0000, 'ºC'),
	(61190, 110, '2015-02-15 00:37:57.000000', 'temperatura', 484.0000, 'ºC'),
	(61191, 110, '2015-02-15 00:37:58.000000', 'temperatura', 148.0000, 'ºC'),
	(61192, 110, '2015-02-15 00:37:59.000000', 'temperatura', 491.0000, 'ºC'),
	(61193, 110, '2015-02-15 00:38:00.000000', 'temperatura', 812.0000, 'ºC'),
	(61194, 110, '2015-02-15 00:38:01.000000', 'temperatura', 185.0000, 'ºC'),
	(61195, 110, '2015-02-15 00:38:02.000000', 'temperatura', 890.0000, 'ºC'),
	(61196, 110, '2015-02-15 00:38:03.000000', 'temperatura', 294.0000, 'ºC'),
	(61197, 110, '2015-02-15 00:38:04.000000', 'temperatura', 1.0000, 'ºC'),
	(61198, 110, '2015-02-15 00:38:05.000000', 'temperatura', 325.0000, 'ºC'),
	(61199, 110, '2015-02-15 00:38:06.000000', 'temperatura', 421.0000, 'ºC'),
	(61200, 110, '2015-02-15 00:38:07.000000', 'temperatura', 1130.0000, 'ºC'),
	(61201, 110, '2015-02-15 00:38:08.000000', 'temperatura', 787.0000, 'ºC'),
	(61202, 110, '2015-02-15 00:38:09.000000', 'temperatura', 544.0000, 'ºC'),
	(61203, 110, '2015-02-15 00:38:10.000000', 'temperatura', 363.0000, 'ºC'),
	(61204, 110, '2015-02-15 00:38:11.000000', 'temperatura', 183.0000, 'ºC'),
	(61205, 110, '2015-02-15 00:38:12.000000', 'temperatura', 1026.0000, 'ºC'),
	(61206, 110, '2015-02-15 00:38:13.000000', 'temperatura', 981.0000, 'ºC'),
	(61207, 110, '2015-02-15 00:38:14.000000', 'temperatura', 630.0000, 'ºC'),
	(61208, 110, '2015-02-15 00:38:15.000000', 'temperatura', 204.0000, 'ºC'),
	(61209, 110, '2015-02-15 00:38:16.000000', 'temperatura', 334.0000, 'ºC'),
	(61210, 110, '2015-02-15 00:38:17.000000', 'temperatura', 1055.0000, 'ºC'),
	(61211, 110, '2015-02-15 00:38:18.000000', 'temperatura', 676.0000, 'ºC'),
	(61212, 110, '2015-02-15 00:38:19.000000', 'temperatura', 216.0000, 'ºC'),
	(61213, 110, '2015-02-15 00:38:20.000000', 'temperatura', 251.0000, 'ºC'),
	(61214, 110, '2015-02-15 00:38:21.000000', 'temperatura', 608.0000, 'ºC'),
	(61215, 110, '2015-02-15 00:38:22.000000', 'temperatura', 1088.0000, 'ºC'),
	(61216, 110, '2015-02-15 00:38:23.000000', 'temperatura', 16.0000, 'ºC'),
	(61217, 110, '2015-02-15 00:38:24.000000', 'temperatura', 418.0000, 'ºC'),
	(61218, 110, '2015-02-15 00:38:25.000000', 'temperatura', 842.0000, 'ºC'),
	(61219, 110, '2015-02-15 00:38:26.000000', 'temperatura', 556.0000, 'ºC'),
	(61220, 110, '2015-02-15 00:38:27.000000', 'temperatura', 256.0000, 'ºC'),
	(61221, 110, '2015-02-15 00:38:28.000000', 'temperatura', 810.0000, 'ºC'),
	(61222, 110, '2015-02-15 00:38:29.000000', 'temperatura', 884.0000, 'ºC'),
	(61223, 110, '2015-02-15 00:38:30.000000', 'temperatura', 790.0000, 'ºC'),
	(61224, 110, '2015-02-15 00:38:31.000000', 'temperatura', 99.0000, 'ºC'),
	(61225, 110, '2015-02-15 00:38:32.000000', 'temperatura', 527.0000, 'ºC'),
	(61226, 110, '2015-02-15 00:38:33.000000', 'temperatura', 1138.0000, 'ºC'),
	(61227, 110, '2015-02-15 00:38:34.000000', 'temperatura', 509.0000, 'ºC'),
	(61228, 110, '2015-02-15 00:38:35.000000', 'temperatura', 333.0000, 'ºC'),
	(61229, 110, '2015-02-15 00:38:36.000000', 'temperatura', 136.0000, 'ºC'),
	(61230, 110, '2015-02-15 00:38:37.000000', 'temperatura', 884.0000, 'ºC'),
	(61231, 110, '2015-02-15 00:38:38.000000', 'temperatura', 411.0000, 'ºC'),
	(61232, 110, '2015-02-15 00:38:39.000000', 'temperatura', 605.0000, 'ºC'),
	(61233, 110, '2015-02-15 00:38:40.000000', 'temperatura', 594.0000, 'ºC'),
	(61234, 110, '2015-02-15 00:38:41.000000', 'temperatura', 1152.0000, 'ºC'),
	(61235, 110, '2015-02-15 00:38:42.000000', 'temperatura', 382.0000, 'ºC'),
	(61236, 110, '2015-02-15 00:38:43.000000', 'temperatura', 852.0000, 'ºC'),
	(61237, 110, '2015-02-15 00:38:44.000000', 'temperatura', 715.0000, 'ºC'),
	(61238, 110, '2015-02-15 00:38:45.000000', 'temperatura', 1021.0000, 'ºC'),
	(61239, 110, '2015-02-15 00:38:46.000000', 'temperatura', 561.0000, 'ºC'),
	(61240, 110, '2015-02-15 00:38:47.000000', 'temperatura', 943.0000, 'ºC'),
	(61241, 110, '2015-02-15 00:38:48.000000', 'temperatura', 631.0000, 'ºC'),
	(61242, 110, '2015-02-15 00:38:49.000000', 'temperatura', 327.0000, 'ºC'),
	(61243, 110, '2015-02-15 00:38:50.000000', 'temperatura', 944.0000, 'ºC'),
	(61244, 110, '2015-02-15 00:38:51.000000', 'temperatura', 139.0000, 'ºC'),
	(61245, 110, '2015-02-15 00:38:52.000000', 'temperatura', 265.0000, 'ºC'),
	(61246, 110, '2015-02-15 00:38:53.000000', 'temperatura', 907.0000, 'ºC'),
	(61247, 110, '2015-02-15 00:38:54.000000', 'temperatura', 141.0000, 'ºC'),
	(61248, 110, '2015-02-15 00:38:55.000000', 'temperatura', 382.0000, 'ºC'),
	(61249, 110, '2015-02-15 00:38:56.000000', 'temperatura', 291.0000, 'ºC'),
	(61250, 110, '2015-02-15 00:38:57.000000', 'temperatura', 306.0000, 'ºC'),
	(61251, 110, '2015-02-15 00:38:58.000000', 'temperatura', 660.0000, 'ºC'),
	(61252, 110, '2015-02-15 00:38:59.000000', 'temperatura', 1180.0000, 'ºC'),
	(61253, 110, '2015-02-15 00:39:00.000000', 'temperatura', 322.0000, 'ºC'),
	(61254, 110, '2015-02-15 00:39:01.000000', 'temperatura', 472.0000, 'ºC'),
	(61255, 110, '2015-02-15 00:39:02.000000', 'temperatura', 192.0000, 'ºC'),
	(61256, 110, '2015-02-15 00:39:03.000000', 'temperatura', 745.0000, 'ºC'),
	(61257, 110, '2015-02-15 00:39:04.000000', 'temperatura', 748.0000, 'ºC'),
	(61258, 110, '2015-02-15 00:39:05.000000', 'temperatura', 306.0000, 'ºC'),
	(61259, 110, '2015-02-15 00:39:06.000000', 'temperatura', 485.0000, 'ºC'),
	(61260, 110, '2015-02-15 00:39:07.000000', 'temperatura', 310.0000, 'ºC'),
	(61261, 110, '2015-02-15 00:39:08.000000', 'temperatura', 93.0000, 'ºC'),
	(61262, 110, '2015-02-15 00:39:09.000000', 'temperatura', 739.0000, 'ºC'),
	(61263, 110, '2015-02-15 00:39:10.000000', 'temperatura', 1013.0000, 'ºC'),
	(61264, 110, '2015-02-15 00:39:11.000000', 'temperatura', 449.0000, 'ºC'),
	(61265, 110, '2015-02-15 00:39:12.000000', 'temperatura', 409.0000, 'ºC'),
	(61266, 110, '2015-02-15 00:39:13.000000', 'temperatura', 695.0000, 'ºC'),
	(61267, 110, '2015-02-15 00:39:14.000000', 'temperatura', 1050.0000, 'ºC'),
	(61268, 110, '2015-02-15 00:39:15.000000', 'temperatura', 766.0000, 'ºC'),
	(61269, 110, '2015-02-15 00:39:16.000000', 'temperatura', 680.0000, 'ºC'),
	(61270, 110, '2015-02-15 00:39:17.000000', 'temperatura', 1103.0000, 'ºC'),
	(61271, 110, '2015-02-15 00:39:18.000000', 'temperatura', 1075.0000, 'ºC'),
	(61272, 110, '2015-02-15 00:39:19.000000', 'temperatura', 865.0000, 'ºC'),
	(61273, 110, '2015-02-15 00:39:20.000000', 'temperatura', 1101.0000, 'ºC'),
	(61274, 110, '2015-02-15 00:39:21.000000', 'temperatura', 509.0000, 'ºC'),
	(61275, 110, '2015-02-15 00:39:22.000000', 'temperatura', 445.0000, 'ºC'),
	(61276, 110, '2015-02-15 00:39:23.000000', 'temperatura', 699.0000, 'ºC'),
	(61277, 110, '2015-02-15 00:39:24.000000', 'temperatura', 961.0000, 'ºC'),
	(61278, 110, '2015-02-15 00:39:25.000000', 'temperatura', 308.0000, 'ºC'),
	(61279, 110, '2015-02-15 00:39:26.000000', 'temperatura', 1057.0000, 'ºC'),
	(61280, 110, '2015-02-15 00:39:27.000000', 'temperatura', 763.0000, 'ºC'),
	(61281, 110, '2015-02-15 00:39:28.000000', 'temperatura', 645.0000, 'ºC'),
	(61282, 110, '2015-02-15 00:39:29.000000', 'temperatura', 934.0000, 'ºC'),
	(61283, 110, '2015-02-15 00:39:30.000000', 'temperatura', 336.0000, 'ºC'),
	(61284, 110, '2015-02-15 00:39:31.000000', 'temperatura', 78.0000, 'ºC'),
	(61285, 110, '2015-02-15 00:39:32.000000', 'temperatura', 582.0000, 'ºC'),
	(61286, 110, '2015-02-15 00:39:33.000000', 'temperatura', 277.0000, 'ºC'),
	(61287, 110, '2015-02-15 00:39:34.000000', 'temperatura', 838.0000, 'ºC'),
	(61288, 110, '2015-02-15 00:39:35.000000', 'temperatura', 963.0000, 'ºC'),
	(61289, 110, '2015-02-15 00:39:36.000000', 'temperatura', 1098.0000, 'ºC'),
	(61290, 110, '2015-02-15 00:39:37.000000', 'temperatura', 203.0000, 'ºC'),
	(61291, 110, '2015-02-15 00:39:38.000000', 'temperatura', 123.0000, 'ºC'),
	(61292, 110, '2015-02-15 00:39:39.000000', 'temperatura', 7.0000, 'ºC'),
	(61293, 110, '2015-02-15 00:39:40.000000', 'temperatura', 867.0000, 'ºC'),
	(61294, 110, '2015-02-15 00:39:41.000000', 'temperatura', 715.0000, 'ºC'),
	(61295, 110, '2015-02-15 00:39:42.000000', 'temperatura', 974.0000, 'ºC'),
	(61296, 110, '2015-02-15 00:39:43.000000', 'temperatura', 326.0000, 'ºC'),
	(61297, 110, '2015-02-15 00:39:44.000000', 'temperatura', 1106.0000, 'ºC'),
	(61298, 110, '2015-02-15 00:39:45.000000', 'temperatura', 956.0000, 'ºC'),
	(61299, 110, '2015-02-15 00:39:46.000000', 'temperatura', 259.0000, 'ºC'),
	(61300, 110, '2015-02-15 00:39:47.000000', 'temperatura', 829.0000, 'ºC'),
	(61301, 110, '2015-02-15 00:39:48.000000', 'temperatura', 968.0000, 'ºC'),
	(61302, 110, '2015-02-15 00:39:49.000000', 'temperatura', 1153.0000, 'ºC'),
	(61303, 110, '2015-02-15 00:39:50.000000', 'temperatura', 462.0000, 'ºC'),
	(61304, 110, '2015-02-15 00:39:51.000000', 'temperatura', 53.0000, 'ºC'),
	(61305, 110, '2015-02-15 00:39:52.000000', 'temperatura', 80.0000, 'ºC'),
	(61306, 110, '2015-02-15 00:39:53.000000', 'temperatura', 241.0000, 'ºC'),
	(61307, 110, '2015-02-15 00:39:54.000000', 'temperatura', 967.0000, 'ºC'),
	(61308, 110, '2015-02-15 00:39:55.000000', 'temperatura', 511.0000, 'ºC'),
	(61309, 110, '2015-02-15 00:39:56.000000', 'temperatura', 855.0000, 'ºC'),
	(61310, 110, '2015-02-15 00:39:57.000000', 'temperatura', 344.0000, 'ºC'),
	(61311, 110, '2015-02-15 00:39:58.000000', 'temperatura', 353.0000, 'ºC'),
	(61312, 110, '2015-02-15 00:39:59.000000', 'temperatura', 733.0000, 'ºC'),
	(61313, 110, '2015-02-15 00:40:00.000000', 'temperatura', 209.0000, 'ºC'),
	(61314, 110, '2015-02-15 00:40:01.000000', 'temperatura', 45.0000, 'ºC'),
	(61315, 110, '2015-02-15 00:40:02.000000', 'temperatura', 799.0000, 'ºC'),
	(61316, 110, '2015-02-15 00:40:03.000000', 'temperatura', 259.0000, 'ºC'),
	(61317, 110, '2015-02-15 00:40:04.000000', 'temperatura', 98.0000, 'ºC'),
	(61318, 110, '2015-02-15 00:40:05.000000', 'temperatura', 915.0000, 'ºC'),
	(61319, 110, '2015-02-15 00:40:06.000000', 'temperatura', 682.0000, 'ºC'),
	(61320, 110, '2015-02-15 00:40:07.000000', 'temperatura', 665.0000, 'ºC'),
	(61321, 110, '2015-02-15 00:40:08.000000', 'temperatura', 79.0000, 'ºC'),
	(61322, 110, '2015-02-15 00:40:09.000000', 'temperatura', 801.0000, 'ºC'),
	(61323, 110, '2015-02-15 00:40:10.000000', 'temperatura', 167.0000, 'ºC'),
	(61324, 110, '2015-02-15 00:40:11.000000', 'temperatura', 835.0000, 'ºC'),
	(61325, 110, '2015-02-15 00:40:12.000000', 'temperatura', 73.0000, 'ºC'),
	(61326, 110, '2015-02-15 00:40:13.000000', 'temperatura', 262.0000, 'ºC'),
	(61327, 110, '2015-02-15 00:40:14.000000', 'temperatura', 1090.0000, 'ºC'),
	(61328, 110, '2015-02-15 00:40:15.000000', 'temperatura', 1067.0000, 'ºC'),
	(61329, 110, '2015-02-15 00:40:16.000000', 'temperatura', 862.0000, 'ºC'),
	(61330, 110, '2015-02-15 00:40:17.000000', 'temperatura', 1112.0000, 'ºC'),
	(61331, 110, '2015-02-15 00:40:18.000000', 'temperatura', 572.0000, 'ºC'),
	(61332, 110, '2015-02-15 00:40:19.000000', 'temperatura', 725.0000, 'ºC'),
	(61333, 110, '2015-02-15 00:40:20.000000', 'temperatura', 710.0000, 'ºC'),
	(61334, 110, '2015-02-15 00:40:21.000000', 'temperatura', 175.0000, 'ºC'),
	(61335, 110, '2015-02-15 00:40:22.000000', 'temperatura', 1144.0000, 'ºC'),
	(61336, 110, '2015-02-15 00:40:23.000000', 'temperatura', 396.0000, 'ºC'),
	(61337, 110, '2015-02-15 00:40:24.000000', 'temperatura', 947.0000, 'ºC'),
	(61338, 110, '2015-02-15 00:40:25.000000', 'temperatura', 1151.0000, 'ºC'),
	(61339, 110, '2015-02-15 00:40:26.000000', 'temperatura', 513.0000, 'ºC'),
	(61340, 110, '2015-02-15 00:40:27.000000', 'temperatura', 313.0000, 'ºC'),
	(61341, 110, '2015-02-15 00:40:28.000000', 'temperatura', 28.0000, 'ºC'),
	(61342, 110, '2015-02-15 00:40:29.000000', 'temperatura', 399.0000, 'ºC'),
	(61343, 110, '2015-02-15 00:40:30.000000', 'temperatura', 714.0000, 'ºC'),
	(61344, 110, '2015-02-15 00:40:31.000000', 'temperatura', 1174.0000, 'ºC'),
	(61345, 110, '2015-02-15 00:40:32.000000', 'temperatura', 127.0000, 'ºC'),
	(61346, 110, '2015-02-15 00:40:33.000000', 'temperatura', 715.0000, 'ºC'),
	(61347, 110, '2015-02-15 00:40:34.000000', 'temperatura', 793.0000, 'ºC'),
	(61348, 110, '2015-02-15 00:40:35.000000', 'temperatura', 621.0000, 'ºC'),
	(61349, 110, '2015-02-15 00:40:36.000000', 'temperatura', 726.0000, 'ºC'),
	(61350, 110, '2015-02-15 00:40:37.000000', 'temperatura', 569.0000, 'ºC'),
	(61351, 110, '2015-02-15 00:40:38.000000', 'temperatura', 665.0000, 'ºC'),
	(61352, 110, '2015-02-15 00:40:39.000000', 'temperatura', 421.0000, 'ºC'),
	(61353, 110, '2015-02-15 00:40:40.000000', 'temperatura', 109.0000, 'ºC'),
	(61354, 110, '2015-02-15 00:40:41.000000', 'temperatura', 482.0000, 'ºC'),
	(61355, 110, '2015-02-15 00:40:42.000000', 'temperatura', 882.0000, 'ºC'),
	(61356, 110, '2015-02-15 00:40:43.000000', 'temperatura', 568.0000, 'ºC'),
	(61357, 110, '2015-02-15 00:40:44.000000', 'temperatura', 192.0000, 'ºC'),
	(61358, 110, '2015-02-15 00:40:45.000000', 'temperatura', 458.0000, 'ºC'),
	(61359, 110, '2015-02-15 00:40:46.000000', 'temperatura', 515.0000, 'ºC'),
	(61360, 110, '2015-02-15 00:40:47.000000', 'temperatura', 1.0000, 'ºC'),
	(61361, 110, '2015-02-15 00:40:48.000000', 'temperatura', 859.0000, 'ºC'),
	(61362, 110, '2015-02-15 00:40:49.000000', 'temperatura', 692.0000, 'ºC'),
	(61363, 110, '2015-02-15 00:40:50.000000', 'temperatura', 884.0000, 'ºC'),
	(61364, 110, '2015-02-15 00:40:51.000000', 'temperatura', 1146.0000, 'ºC'),
	(61365, 110, '2015-02-15 00:40:52.000000', 'temperatura', 676.0000, 'ºC'),
	(61366, 110, '2015-02-15 00:40:53.000000', 'temperatura', 1143.0000, 'ºC'),
	(61367, 110, '2015-02-15 00:40:54.000000', 'temperatura', 89.0000, 'ºC'),
	(61368, 110, '2015-02-15 00:40:55.000000', 'temperatura', 616.0000, 'ºC'),
	(61369, 110, '2015-02-15 00:40:56.000000', 'temperatura', 413.0000, 'ºC'),
	(61370, 110, '2015-02-15 00:40:57.000000', 'temperatura', 219.0000, 'ºC'),
	(61371, 110, '2015-02-15 00:40:58.000000', 'temperatura', 1057.0000, 'ºC'),
	(61372, 110, '2015-02-15 00:40:59.000000', 'temperatura', 1029.0000, 'ºC'),
	(61373, 110, '2015-02-15 00:41:00.000000', 'temperatura', 775.0000, 'ºC'),
	(61374, 110, '2015-02-15 00:41:01.000000', 'temperatura', 786.0000, 'ºC'),
	(61375, 110, '2015-02-15 00:41:02.000000', 'temperatura', 406.0000, 'ºC'),
	(61376, 110, '2015-02-15 00:41:03.000000', 'temperatura', 873.0000, 'ºC'),
	(61377, 110, '2015-02-15 00:41:04.000000', 'temperatura', 749.0000, 'ºC'),
	(61378, 110, '2015-02-15 00:41:05.000000', 'temperatura', 1125.0000, 'ºC'),
	(61379, 110, '2015-02-15 00:41:06.000000', 'temperatura', 978.0000, 'ºC'),
	(61380, 110, '2015-02-15 00:41:07.000000', 'temperatura', 317.0000, 'ºC'),
	(61381, 110, '2015-02-15 00:41:08.000000', 'temperatura', 1053.0000, 'ºC'),
	(61382, 110, '2015-02-15 00:41:09.000000', 'temperatura', 712.0000, 'ºC'),
	(61383, 110, '2015-02-15 00:41:10.000000', 'temperatura', 400.0000, 'ºC'),
	(61384, 110, '2015-02-15 00:41:11.000000', 'temperatura', 1067.0000, 'ºC'),
	(61385, 110, '2015-02-15 00:41:12.000000', 'temperatura', 535.0000, 'ºC'),
	(61386, 110, '2015-02-15 00:41:13.000000', 'temperatura', 673.0000, 'ºC'),
	(61387, 110, '2015-02-15 00:41:14.000000', 'temperatura', 564.0000, 'ºC'),
	(61388, 110, '2015-02-15 00:41:15.000000', 'temperatura', 798.0000, 'ºC'),
	(61389, 110, '2015-02-15 00:41:16.000000', 'temperatura', 1100.0000, 'ºC'),
	(61390, 110, '2015-02-15 00:41:17.000000', 'temperatura', 705.0000, 'ºC'),
	(61391, 110, '2015-02-15 00:41:18.000000', 'temperatura', 228.0000, 'ºC'),
	(61392, 110, '2015-02-15 00:41:19.000000', 'temperatura', 223.0000, 'ºC'),
	(61393, 110, '2015-02-15 00:41:20.000000', 'temperatura', 431.0000, 'ºC'),
	(61394, 110, '2015-02-15 00:41:21.000000', 'temperatura', 287.0000, 'ºC'),
	(61395, 110, '2015-02-15 00:41:22.000000', 'temperatura', 142.0000, 'ºC'),
	(61396, 110, '2015-02-15 00:41:23.000000', 'temperatura', 1051.0000, 'ºC'),
	(61397, 110, '2015-02-15 00:41:24.000000', 'temperatura', 29.0000, 'ºC'),
	(61398, 110, '2015-02-15 00:41:25.000000', 'temperatura', 591.0000, 'ºC'),
	(61399, 110, '2015-02-15 00:41:26.000000', 'temperatura', 469.0000, 'ºC'),
	(61400, 110, '2015-02-15 00:41:27.000000', 'temperatura', 575.0000, 'ºC'),
	(61401, 110, '2015-02-15 00:41:28.000000', 'temperatura', 265.0000, 'ºC'),
	(61402, 110, '2015-02-15 00:41:29.000000', 'temperatura', 803.0000, 'ºC'),
	(61403, 110, '2015-02-15 00:41:30.000000', 'temperatura', 821.0000, 'ºC'),
	(61404, 110, '2015-02-15 00:41:31.000000', 'temperatura', 494.0000, 'ºC'),
	(61405, 110, '2015-02-15 00:41:32.000000', 'temperatura', 7.0000, 'ºC'),
	(61406, 110, '2015-02-15 00:41:33.000000', 'temperatura', 956.0000, 'ºC'),
	(61407, 110, '2015-02-15 00:41:34.000000', 'temperatura', 1160.0000, 'ºC'),
	(61408, 110, '2015-02-15 00:41:35.000000', 'temperatura', 531.0000, 'ºC'),
	(61409, 110, '2015-02-15 00:41:36.000000', 'temperatura', 378.0000, 'ºC'),
	(61410, 110, '2015-02-15 00:41:37.000000', 'temperatura', 295.0000, 'ºC'),
	(61411, 110, '2015-02-15 00:41:38.000000', 'temperatura', 342.0000, 'ºC'),
	(61412, 110, '2015-02-15 00:41:39.000000', 'temperatura', 824.0000, 'ºC'),
	(61413, 110, '2015-02-15 00:41:40.000000', 'temperatura', 695.0000, 'ºC'),
	(61414, 110, '2015-02-15 00:41:41.000000', 'temperatura', 1003.0000, 'ºC'),
	(61415, 110, '2015-02-15 00:41:42.000000', 'temperatura', 533.0000, 'ºC'),
	(61416, 110, '2015-02-15 00:41:43.000000', 'temperatura', 855.0000, 'ºC'),
	(61417, 110, '2015-02-15 00:41:44.000000', 'temperatura', 278.0000, 'ºC'),
	(61418, 110, '2015-02-15 00:41:45.000000', 'temperatura', 25.0000, 'ºC'),
	(61419, 110, '2015-02-15 00:41:46.000000', 'temperatura', 493.0000, 'ºC'),
	(61420, 110, '2015-02-15 00:41:47.000000', 'temperatura', 1187.0000, 'ºC'),
	(61421, 110, '2015-02-15 00:41:48.000000', 'temperatura', 859.0000, 'ºC'),
	(61422, 110, '2015-02-15 00:41:49.000000', 'temperatura', 735.0000, 'ºC'),
	(61423, 110, '2015-02-15 00:41:50.000000', 'temperatura', 1096.0000, 'ºC'),
	(61424, 110, '2015-02-15 00:41:51.000000', 'temperatura', 875.0000, 'ºC'),
	(61425, 110, '2015-02-15 00:41:52.000000', 'temperatura', 1089.0000, 'ºC'),
	(61426, 110, '2015-02-15 00:41:53.000000', 'temperatura', 422.0000, 'ºC'),
	(61427, 110, '2015-02-15 00:41:54.000000', 'temperatura', 42.0000, 'ºC'),
	(61428, 110, '2015-02-15 00:41:55.000000', 'temperatura', 146.0000, 'ºC'),
	(61429, 110, '2015-02-15 00:41:56.000000', 'temperatura', 605.0000, 'ºC'),
	(61430, 110, '2015-02-15 00:41:57.000000', 'temperatura', 186.0000, 'ºC'),
	(61431, 110, '2015-02-15 00:41:58.000000', 'temperatura', 316.0000, 'ºC'),
	(61432, 110, '2015-02-15 00:41:59.000000', 'temperatura', 1022.0000, 'ºC'),
	(61433, 110, '2015-02-15 00:42:00.000000', 'temperatura', 562.0000, 'ºC'),
	(61434, 110, '2015-02-15 00:42:01.000000', 'temperatura', 946.0000, 'ºC'),
	(61435, 110, '2015-02-15 00:42:02.000000', 'temperatura', 644.0000, 'ºC'),
	(61436, 110, '2015-02-15 00:42:03.000000', 'temperatura', 384.0000, 'ºC'),
	(61437, 110, '2015-02-15 00:42:04.000000', 'temperatura', 1187.0000, 'ºC'),
	(61438, 110, '2015-02-15 00:42:05.000000', 'temperatura', 1183.0000, 'ºC'),
	(61439, 110, '2015-02-15 00:42:06.000000', 'temperatura', 1153.0000, 'ºC'),
	(61440, 110, '2015-02-15 00:42:07.000000', 'temperatura', 1018.0000, 'ºC'),
	(61441, 110, '2015-02-15 00:42:08.000000', 'temperatura', 433.0000, 'ºC'),
	(61442, 110, '2015-02-15 00:42:09.000000', 'temperatura', 312.0000, 'ºC'),
	(61443, 110, '2015-02-15 00:42:10.000000', 'temperatura', 262.0000, 'ºC'),
	(61444, 110, '2015-02-15 00:42:11.000000', 'temperatura', 371.0000, 'ºC'),
	(61445, 110, '2015-02-15 00:42:12.000000', 'temperatura', 1072.0000, 'ºC'),
	(61446, 110, '2015-02-15 00:42:13.000000', 'temperatura', 649.0000, 'ºC'),
	(61447, 110, '2015-02-15 00:42:14.000000', 'temperatura', 28.0000, 'ºC'),
	(61448, 110, '2015-02-15 00:42:15.000000', 'temperatura', 592.0000, 'ºC'),
	(61449, 110, '2015-02-15 00:42:16.000000', 'temperatura', 478.0000, 'ºC'),
	(61450, 110, '2015-02-15 00:42:17.000000', 'temperatura', 615.0000, 'ºC'),
	(61451, 110, '2015-02-15 00:42:18.000000', 'temperatura', 443.0000, 'ºC'),
	(61452, 110, '2015-02-15 00:42:19.000000', 'temperatura', 369.0000, 'ºC'),
	(61453, 110, '2015-02-15 00:42:20.000000', 'temperatura', 518.0000, 'ºC'),
	(61454, 110, '2015-02-15 00:42:21.000000', 'temperatura', 281.0000, 'ºC'),
	(61455, 110, '2015-02-15 00:42:22.000000', 'temperatura', 1054.0000, 'ºC'),
	(61456, 110, '2015-02-15 00:42:23.000000', 'temperatura', 827.0000, 'ºC'),
	(61457, 110, '2015-02-15 00:42:24.000000', 'temperatura', 972.0000, 'ºC'),
	(61458, 110, '2015-02-15 00:42:25.000000', 'temperatura', 1181.0000, 'ºC'),
	(61459, 110, '2015-02-15 00:42:26.000000', 'temperatura', 588.0000, 'ºC'),
	(61460, 110, '2015-02-15 00:42:27.000000', 'temperatura', 598.0000, 'ºC'),
	(61461, 110, '2015-02-15 00:42:28.000000', 'temperatura', 25.0000, 'ºC'),
	(61462, 110, '2015-02-15 00:42:29.000000', 'temperatura', 734.0000, 'ºC'),
	(61463, 110, '2015-02-15 00:42:30.000000', 'temperatura', 1195.0000, 'ºC'),
	(61464, 110, '2015-02-15 00:42:31.000000', 'temperatura', 175.0000, 'ºC'),
	(61465, 110, '2015-02-15 00:42:32.000000', 'temperatura', 889.0000, 'ºC'),
	(61466, 110, '2015-02-15 00:42:33.000000', 'temperatura', 321.0000, 'ºC'),
	(61467, 110, '2015-02-15 00:42:34.000000', 'temperatura', 139.0000, 'ºC'),
	(61468, 110, '2015-02-15 00:42:35.000000', 'temperatura', 933.0000, 'ºC'),
	(61469, 110, '2015-02-15 00:42:36.000000', 'temperatura', 650.0000, 'ºC'),
	(61470, 110, '2015-02-15 00:42:37.000000', 'temperatura', 449.0000, 'ºC'),
	(61471, 110, '2015-02-15 00:42:38.000000', 'temperatura', 296.0000, 'ºC'),
	(61472, 110, '2015-02-15 00:42:39.000000', 'temperatura', 133.0000, 'ºC'),
	(61473, 110, '2015-02-15 00:42:40.000000', 'temperatura', 977.0000, 'ºC'),
	(61474, 110, '2015-02-15 00:42:41.000000', 'temperatura', 889.0000, 'ºC'),
	(61475, 110, '2015-02-15 00:42:42.000000', 'temperatura', 313.0000, 'ºC'),
	(61476, 110, '2015-02-15 00:42:43.000000', 'temperatura', 97.0000, 'ºC'),
	(61477, 110, '2015-02-15 00:42:44.000000', 'temperatura', 749.0000, 'ºC'),
	(61478, 110, '2015-02-15 00:42:45.000000', 'temperatura', 1054.0000, 'ºC'),
	(61479, 110, '2015-02-15 00:42:46.000000', 'temperatura', 624.0000, 'ºC'),
	(61480, 110, '2015-02-15 00:42:47.000000', 'temperatura', 1159.0000, 'ºC'),
	(61481, 110, '2015-02-15 00:42:48.000000', 'temperatura', 322.0000, 'ºC'),
	(61482, 110, '2015-02-15 00:42:49.000000', 'temperatura', 533.0000, 'ºC'),
	(61483, 110, '2015-02-15 00:42:50.000000', 'temperatura', 500.0000, 'ºC'),
	(61484, 110, '2015-02-15 00:42:51.000000', 'temperatura', 904.0000, 'ºC'),
	(61485, 110, '2015-02-15 00:42:52.000000', 'temperatura', 617.0000, 'ºC'),
	(61486, 110, '2015-02-15 00:42:53.000000', 'temperatura', 374.0000, 'ºC'),
	(61487, 110, '2015-02-15 00:42:54.000000', 'temperatura', 19.0000, 'ºC'),
	(61488, 110, '2015-02-15 00:42:55.000000', 'temperatura', 174.0000, 'ºC'),
	(61489, 110, '2015-02-15 00:42:56.000000', 'temperatura', 815.0000, 'ºC'),
	(61490, 110, '2015-02-15 00:42:57.000000', 'temperatura', 1153.0000, 'ºC'),
	(61491, 110, '2015-02-15 00:42:58.000000', 'temperatura', 922.0000, 'ºC'),
	(61492, 110, '2015-02-15 00:42:59.000000', 'temperatura', 1149.0000, 'ºC'),
	(61493, 110, '2015-02-15 00:43:00.000000', 'temperatura', 580.0000, 'ºC'),
	(61494, 110, '2015-02-15 00:43:01.000000', 'temperatura', 655.0000, 'ºC'),
	(61495, 110, '2015-02-15 00:43:02.000000', 'temperatura', 334.0000, 'ºC'),
	(61496, 110, '2015-02-15 00:43:03.000000', 'temperatura', 904.0000, 'ºC'),
	(61497, 110, '2015-02-15 00:43:04.000000', 'temperatura', 1121.0000, 'ºC'),
	(61498, 110, '2015-02-15 00:43:05.000000', 'temperatura', 495.0000, 'ºC'),
	(61499, 110, '2015-02-15 00:43:06.000000', 'temperatura', 310.0000, 'ºC'),
	(61500, 110, '2015-02-15 00:43:07.000000', 'temperatura', 65.0000, 'ºC'),
	(61501, 110, '2015-02-15 00:43:08.000000', 'temperatura', 596.0000, 'ºC'),
	(61502, 110, '2015-02-15 00:43:09.000000', 'temperatura', 386.0000, 'ºC'),
	(61503, 110, '2015-02-15 00:43:10.000000', 'temperatura', 141.0000, 'ºC'),
	(61504, 110, '2015-02-15 00:43:11.000000', 'temperatura', 750.0000, 'ºC'),
	(61505, 110, '2015-02-15 00:43:12.000000', 'temperatura', 927.0000, 'ºC'),
	(61506, 110, '2015-02-15 00:43:13.000000', 'temperatura', 1183.0000, 'ºC'),
	(61507, 110, '2015-02-15 00:43:14.000000', 'temperatura', 738.0000, 'ºC'),
	(61508, 110, '2015-02-15 00:43:15.000000', 'temperatura', 138.0000, 'ºC'),
	(61509, 110, '2015-02-15 00:43:16.000000', 'temperatura', 879.0000, 'ºC'),
	(61510, 110, '2015-02-15 00:43:17.000000', 'temperatura', 380.0000, 'ºC'),
	(61511, 110, '2015-02-15 00:43:18.000000', 'temperatura', 464.0000, 'ºC'),
	(61512, 110, '2015-02-15 00:43:19.000000', 'temperatura', 1181.0000, 'ºC'),
	(61513, 110, '2015-02-15 00:43:20.000000', 'temperatura', 913.0000, 'ºC'),
	(61514, 110, '2015-02-15 00:43:21.000000', 'temperatura', 1021.0000, 'ºC'),
	(61515, 110, '2015-02-15 00:43:22.000000', 'temperatura', 1168.0000, 'ºC'),
	(61516, 110, '2015-02-15 00:43:23.000000', 'temperatura', 378.0000, 'ºC'),
	(61517, 110, '2015-02-15 00:43:24.000000', 'temperatura', 788.0000, 'ºC'),
	(61518, 110, '2015-02-15 00:43:25.000000', 'temperatura', 403.0000, 'ºC'),
	(61519, 110, '2015-02-15 00:43:26.000000', 'temperatura', 854.0000, 'ºC'),
	(61520, 110, '2015-02-15 00:43:27.000000', 'temperatura', 663.0000, 'ºC'),
	(61521, 110, '2015-02-15 00:43:28.000000', 'temperatura', 751.0000, 'ºC'),
	(61522, 110, '2015-02-15 00:43:29.000000', 'temperatura', 567.0000, 'ºC'),
	(61523, 110, '2015-02-15 00:43:30.000000', 'temperatura', 584.0000, 'ºC'),
	(61524, 110, '2015-02-15 00:43:31.000000', 'temperatura', 19.0000, 'ºC'),
	(61525, 110, '2015-02-15 00:43:32.000000', 'temperatura', 741.0000, 'ºC'),
	(61526, 110, '2015-02-15 00:43:33.000000', 'temperatura', 51.0000, 'ºC'),
	(61527, 110, '2015-02-15 00:43:34.000000', 'temperatura', 433.0000, 'ºC'),
	(61528, 110, '2015-02-15 00:43:35.000000', 'temperatura', 813.0000, 'ºC'),
	(61529, 110, '2015-02-15 00:43:36.000000', 'temperatura', 367.0000, 'ºC'),
	(61530, 110, '2015-02-15 00:43:37.000000', 'temperatura', 596.0000, 'ºC'),
	(61531, 110, '2015-02-15 00:43:38.000000', 'temperatura', 681.0000, 'ºC'),
	(61532, 110, '2015-02-15 00:43:39.000000', 'temperatura', 414.0000, 'ºC'),
	(61533, 110, '2015-02-15 00:43:40.000000', 'temperatura', 30.0000, 'ºC'),
	(61534, 110, '2015-02-15 00:43:41.000000', 'temperatura', 107.0000, 'ºC'),
	(61535, 110, '2015-02-15 00:43:42.000000', 'temperatura', 448.0000, 'ºC'),
	(61536, 110, '2015-02-15 00:43:43.000000', 'temperatura', 719.0000, 'ºC'),
	(61537, 110, '2015-02-15 00:43:44.000000', 'temperatura', 1049.0000, 'ºC'),
	(61538, 110, '2015-02-15 00:43:45.000000', 'temperatura', 691.0000, 'ºC'),
	(61539, 110, '2015-02-15 00:43:46.000000', 'temperatura', 306.0000, 'ºC'),
	(61540, 110, '2015-02-15 00:43:47.000000', 'temperatura', 659.0000, 'ºC'),
	(61541, 110, '2015-02-15 00:43:48.000000', 'temperatura', 1176.0000, 'ºC'),
	(61542, 110, '2015-02-15 00:43:49.000000', 'temperatura', 303.0000, 'ºC'),
	(61543, 110, '2015-02-15 00:43:50.000000', 'temperatura', 389.0000, 'ºC'),
	(61544, 110, '2015-02-15 00:43:51.000000', 'temperatura', 1034.0000, 'ºC'),
	(61545, 110, '2015-02-15 00:43:52.000000', 'temperatura', 407.0000, 'ºC'),
	(61546, 110, '2015-02-15 00:43:53.000000', 'temperatura', 131.0000, 'ºC'),
	(61547, 110, '2015-02-15 00:43:54.000000', 'temperatura', 635.0000, 'ºC'),
	(61548, 110, '2015-02-15 00:43:55.000000', 'temperatura', 381.0000, 'ºC'),
	(61549, 110, '2015-02-15 00:43:56.000000', 'temperatura', 0.0000, 'ºC'),
	(61550, 110, '2015-02-15 00:43:57.000000', 'temperatura', 60.0000, 'ºC'),
	(61551, 110, '2015-02-15 00:43:58.000000', 'temperatura', 301.0000, 'ºC'),
	(61552, 110, '2015-02-15 00:43:59.000000', 'temperatura', 126.0000, 'ºC'),
	(61553, 110, '2015-02-15 00:44:00.000000', 'temperatura', 925.0000, 'ºC'),
	(61554, 110, '2015-02-15 00:44:01.000000', 'temperatura', 649.0000, 'ºC'),
	(61555, 110, '2015-02-15 00:44:02.000000', 'temperatura', 470.0000, 'ºC'),
	(61556, 110, '2015-02-15 00:44:03.000000', 'temperatura', 404.0000, 'ºC'),
	(61557, 110, '2015-02-15 00:44:04.000000', 'temperatura', 610.0000, 'ºC'),
	(61558, 110, '2015-02-15 00:44:05.000000', 'temperatura', 640.0000, 'ºC'),
	(61559, 110, '2015-02-15 00:44:06.000000', 'temperatura', 170.0000, 'ºC'),
	(61560, 110, '2015-02-15 00:44:07.000000', 'temperatura', 129.0000, 'ºC'),
	(61561, 110, '2015-02-15 00:44:08.000000', 'temperatura', 137.0000, 'ºC'),
	(61562, 110, '2015-02-15 00:44:09.000000', 'temperatura', 298.0000, 'ºC'),
	(61563, 110, '2015-02-15 00:44:10.000000', 'temperatura', 1080.0000, 'ºC'),
	(61564, 110, '2015-02-15 00:44:11.000000', 'temperatura', 906.0000, 'ºC'),
	(61565, 110, '2015-02-15 00:44:12.000000', 'temperatura', 89.0000, 'ºC'),
	(61566, 110, '2015-02-15 00:44:13.000000', 'temperatura', 127.0000, 'ºC'),
	(61567, 110, '2015-02-15 00:44:14.000000', 'temperatura', 371.0000, 'ºC'),
	(61568, 110, '2015-02-15 00:44:15.000000', 'temperatura', 272.0000, 'ºC'),
	(61569, 110, '2015-02-15 00:44:16.000000', 'temperatura', 250.0000, 'ºC'),
	(61570, 110, '2015-02-15 00:44:17.000000', 'temperatura', 435.0000, 'ºC'),
	(61571, 110, '2015-02-15 00:44:18.000000', 'temperatura', 224.0000, 'ºC'),
	(61572, 110, '2015-02-15 00:44:19.000000', 'temperatura', 1017.0000, 'ºC'),
	(61573, 110, '2015-02-15 00:44:20.000000', 'temperatura', 812.0000, 'ºC'),
	(61574, 110, '2015-02-15 00:44:21.000000', 'temperatura', 1008.0000, 'ºC'),
	(61575, 110, '2015-02-15 00:44:22.000000', 'temperatura', 208.0000, 'ºC'),
	(61576, 110, '2015-02-15 00:44:23.000000', 'temperatura', 413.0000, 'ºC'),
	(61577, 110, '2015-02-15 00:44:24.000000', 'temperatura', 243.0000, 'ºC'),
	(61578, 110, '2015-02-15 00:44:25.000000', 'temperatura', 1177.0000, 'ºC'),
	(61579, 110, '2015-02-15 00:44:26.000000', 'temperatura', 354.0000, 'ºC'),
	(61580, 110, '2015-02-15 00:44:27.000000', 'temperatura', 642.0000, 'ºC'),
	(61581, 110, '2015-02-15 00:44:28.000000', 'temperatura', 948.0000, 'ºC'),
	(61582, 110, '2015-02-15 00:44:29.000000', 'temperatura', 412.0000, 'ºC'),
	(61583, 110, '2015-02-15 00:44:30.000000', 'temperatura', 420.0000, 'ºC'),
	(61584, 110, '2015-02-15 00:44:31.000000', 'temperatura', 862.0000, 'ºC'),
	(61585, 110, '2015-02-15 00:44:32.000000', 'temperatura', 651.0000, 'ºC'),
	(61586, 110, '2015-02-15 00:44:33.000000', 'temperatura', 670.0000, 'ºC'),
	(61587, 110, '2015-02-15 00:44:34.000000', 'temperatura', 196.0000, 'ºC'),
	(61588, 110, '2015-02-15 00:44:35.000000', 'temperatura', 170.0000, 'ºC'),
	(61589, 110, '2015-02-15 00:44:36.000000', 'temperatura', 265.0000, 'ºC'),
	(61590, 110, '2015-02-15 00:44:37.000000', 'temperatura', 816.0000, 'ºC'),
	(61591, 110, '2015-02-15 00:44:38.000000', 'temperatura', 883.0000, 'ºC'),
	(61592, 110, '2015-02-15 00:44:39.000000', 'temperatura', 767.0000, 'ºC'),
	(61593, 110, '2015-02-15 00:44:40.000000', 'temperatura', 1189.0000, 'ºC'),
	(61594, 110, '2015-02-15 00:44:41.000000', 'temperatura', 45.0000, 'ºC'),
	(61595, 110, '2015-02-15 00:44:42.000000', 'temperatura', 257.0000, 'ºC'),
	(61596, 110, '2015-02-15 00:44:43.000000', 'temperatura', 1152.0000, 'ºC'),
	(61597, 110, '2015-02-15 00:44:44.000000', 'temperatura', 188.0000, 'ºC'),
	(61598, 110, '2015-02-15 00:44:45.000000', 'temperatura', 1083.0000, 'ºC'),
	(61599, 110, '2015-02-15 00:44:46.000000', 'temperatura', 53.0000, 'ºC'),
	(61600, 110, '2015-02-15 00:44:47.000000', 'temperatura', 618.0000, 'ºC'),
	(61601, 110, '2015-02-15 00:44:48.000000', 'temperatura', 531.0000, 'ºC'),
	(61602, 110, '2015-02-15 00:44:49.000000', 'temperatura', 803.0000, 'ºC'),
	(61603, 110, '2015-02-15 00:44:50.000000', 'temperatura', 20.0000, 'ºC'),
	(61604, 110, '2015-02-15 00:44:51.000000', 'temperatura', 94.0000, 'ºC'),
	(61605, 110, '2015-02-15 00:44:52.000000', 'temperatura', 410.0000, 'ºC'),
	(61606, 110, '2015-02-15 00:44:53.000000', 'temperatura', 570.0000, 'ºC'),
	(61607, 110, '2015-02-15 00:44:54.000000', 'temperatura', 419.0000, 'ºC'),
	(61608, 110, '2015-02-15 00:44:55.000000', 'temperatura', 386.0000, 'ºC'),
	(61609, 110, '2015-02-15 00:44:56.000000', 'temperatura', 673.0000, 'ºC'),
	(61610, 110, '2015-02-15 00:44:57.000000', 'temperatura', 1008.0000, 'ºC'),
	(61611, 110, '2015-02-15 00:44:58.000000', 'temperatura', 620.0000, 'ºC'),
	(61612, 110, '2015-02-15 00:44:59.000000', 'temperatura', 78.0000, 'ºC'),
	(61613, 110, '2015-02-15 00:45:00.000000', 'temperatura', 931.0000, 'ºC'),
	(61614, 110, '2015-02-15 00:45:01.000000', 'temperatura', 822.0000, 'ºC'),
	(61615, 110, '2015-02-15 00:45:02.000000', 'temperatura', 115.0000, 'ºC'),
	(61616, 110, '2015-02-15 00:45:03.000000', 'temperatura', 511.0000, 'ºC'),
	(61617, 110, '2015-02-15 00:45:04.000000', 'temperatura', 1010.0000, 'ºC'),
	(61618, 110, '2015-02-15 00:45:05.000000', 'temperatura', 1116.0000, 'ºC'),
	(61619, 110, '2015-02-15 00:45:06.000000', 'temperatura', 153.0000, 'ºC'),
	(61620, 110, '2015-02-15 00:45:07.000000', 'temperatura', 1017.0000, 'ºC'),
	(61621, 110, '2015-02-15 00:45:08.000000', 'temperatura', 1025.0000, 'ºC'),
	(61622, 110, '2015-02-15 00:45:09.000000', 'temperatura', 874.0000, 'ºC'),
	(61623, 110, '2015-02-15 00:45:10.000000', 'temperatura', 96.0000, 'ºC'),
	(61624, 110, '2015-02-15 00:45:11.000000', 'temperatura', 257.0000, 'ºC'),
	(61625, 110, '2015-02-15 00:45:12.000000', 'temperatura', 1000.0000, 'ºC'),
	(61626, 110, '2015-02-15 00:45:13.000000', 'temperatura', 630.0000, 'ºC'),
	(61627, 110, '2015-02-15 00:45:14.000000', 'temperatura', 150.0000, 'ºC'),
	(61628, 110, '2015-02-15 00:45:15.000000', 'temperatura', 59.0000, 'ºC'),
	(61629, 110, '2015-02-15 00:45:16.000000', 'temperatura', 1048.0000, 'ºC'),
	(61630, 110, '2015-02-15 00:45:17.000000', 'temperatura', 262.0000, 'ºC'),
	(61631, 110, '2015-02-15 00:45:18.000000', 'temperatura', 566.0000, 'ºC'),
	(61632, 110, '2015-02-15 00:45:19.000000', 'temperatura', 846.0000, 'ºC'),
	(61633, 110, '2015-02-15 00:45:20.000000', 'temperatura', 134.0000, 'ºC'),
	(61634, 110, '2015-02-15 00:45:21.000000', 'temperatura', 529.0000, 'ºC'),
	(61635, 110, '2015-02-15 00:45:22.000000', 'temperatura', 1045.0000, 'ºC'),
	(61636, 110, '2015-02-15 00:45:23.000000', 'temperatura', 38.0000, 'ºC'),
	(61637, 110, '2015-02-15 00:45:24.000000', 'temperatura', 654.0000, 'ºC'),
	(61638, 110, '2015-02-15 00:45:25.000000', 'temperatura', 756.0000, 'ºC'),
	(61639, 110, '2015-02-15 00:45:26.000000', 'temperatura', 621.0000, 'ºC'),
	(61640, 110, '2015-02-15 00:45:27.000000', 'temperatura', 838.0000, 'ºC'),
	(61641, 110, '2015-02-15 00:45:28.000000', 'temperatura', 1127.0000, 'ºC'),
	(61642, 110, '2015-02-15 00:45:29.000000', 'temperatura', 722.0000, 'ºC'),
	(61643, 110, '2015-02-15 00:45:30.000000', 'temperatura', 228.0000, 'ºC'),
	(61644, 110, '2015-02-15 00:45:31.000000', 'temperatura', 175.0000, 'ºC'),
	(61645, 110, '2015-02-15 00:45:32.000000', 'temperatura', 193.0000, 'ºC'),
	(61646, 110, '2015-02-15 00:45:33.000000', 'temperatura', 438.0000, 'ºC'),
	(61647, 110, '2015-02-15 00:45:34.000000', 'temperatura', 411.0000, 'ºC'),
	(61648, 110, '2015-02-15 00:45:35.000000', 'temperatura', 745.0000, 'ºC'),
	(61649, 110, '2015-02-15 00:45:36.000000', 'temperatura', 90.0000, 'ºC'),
	(61650, 110, '2015-02-15 00:45:37.000000', 'temperatura', 615.0000, 'ºC'),
	(61651, 110, '2015-02-15 00:45:38.000000', 'temperatura', 404.0000, 'ºC'),
	(61652, 110, '2015-02-15 00:45:39.000000', 'temperatura', 178.0000, 'ºC'),
	(61653, 110, '2015-02-15 00:45:40.000000', 'temperatura', 877.0000, 'ºC'),
	(61654, 110, '2015-02-15 00:45:41.000000', 'temperatura', 251.0000, 'ºC'),
	(61655, 110, '2015-02-15 00:45:42.000000', 'temperatura', 1025.0000, 'ºC'),
	(61656, 110, '2015-02-15 00:45:43.000000', 'temperatura', 772.0000, 'ºC'),
	(61657, 110, '2015-02-15 00:45:44.000000', 'temperatura', 787.0000, 'ºC'),
	(61658, 110, '2015-02-15 00:45:45.000000', 'temperatura', 419.0000, 'ºC'),
	(61659, 110, '2015-02-15 00:45:46.000000', 'temperatura', 933.0000, 'ºC'),
	(61660, 110, '2015-02-15 00:45:47.000000', 'temperatura', 1009.0000, 'ºC'),
	(61661, 110, '2015-02-15 00:45:48.000000', 'temperatura', 1047.0000, 'ºC'),
	(61662, 110, '2015-02-15 00:45:49.000000', 'temperatura', 1008.0000, 'ºC'),
	(61663, 110, '2015-02-15 00:45:50.000000', 'temperatura', 701.0000, 'ºC'),
	(61664, 110, '2015-02-15 00:45:51.000000', 'temperatura', 480.0000, 'ºC'),
	(61665, 110, '2015-02-15 00:45:52.000000', 'temperatura', 297.0000, 'ºC'),
	(61666, 110, '2015-02-15 00:45:53.000000', 'temperatura', 47.0000, 'ºC'),
	(61667, 110, '2015-02-15 00:45:54.000000', 'temperatura', 542.0000, 'ºC'),
	(61668, 110, '2015-02-15 00:45:55.000000', 'temperatura', 172.0000, 'ºC'),
	(61669, 110, '2015-02-15 00:45:56.000000', 'temperatura', 432.0000, 'ºC'),
	(61670, 110, '2015-02-15 00:45:57.000000', 'temperatura', 445.0000, 'ºC'),
	(61671, 110, '2015-02-15 00:45:58.000000', 'temperatura', 931.0000, 'ºC'),
	(61672, 110, '2015-02-15 00:45:59.000000', 'temperatura', 918.0000, 'ºC'),
	(61673, 110, '2015-02-15 00:46:00.000000', 'temperatura', 598.0000, 'ºC'),
	(61674, 110, '2015-02-15 00:46:01.000000', 'temperatura', 236.0000, 'ºC'),
	(61675, 110, '2015-02-15 00:46:02.000000', 'temperatura', 588.0000, 'ºC'),
	(61676, 110, '2015-02-15 00:46:03.000000', 'temperatura', 1032.0000, 'ºC'),
	(61677, 110, '2015-02-15 00:46:04.000000', 'temperatura', 998.0000, 'ºC'),
	(61678, 110, '2015-02-15 00:46:05.000000', 'temperatura', 692.0000, 'ºC'),
	(61679, 110, '2015-02-15 00:46:06.000000', 'temperatura', 469.0000, 'ºC'),
	(61680, 110, '2015-02-15 00:46:07.000000', 'temperatura', 269.0000, 'ºC'),
	(61681, 110, '2015-02-15 00:46:08.000000', 'temperatura', 1136.0000, 'ºC'),
	(61682, 110, '2015-02-15 00:46:09.000000', 'temperatura', 77.0000, 'ºC'),
	(61683, 110, '2015-02-15 00:46:10.000000', 'temperatura', 574.0000, 'ºC'),
	(61684, 110, '2015-02-15 00:46:11.000000', 'temperatura', 243.0000, 'ºC'),
	(61685, 110, '2015-02-15 00:46:12.000000', 'temperatura', 691.0000, 'ºC'),
	(61686, 110, '2015-02-15 00:46:13.000000', 'temperatura', 327.0000, 'ºC'),
	(61687, 110, '2015-02-15 00:46:14.000000', 'temperatura', 761.0000, 'ºC'),
	(61688, 110, '2015-02-15 00:46:15.000000', 'temperatura', 425.0000, 'ºC'),
	(61689, 110, '2015-02-15 00:46:16.000000', 'temperatura', 1042.0000, 'ºC'),
	(61690, 110, '2015-02-15 00:46:17.000000', 'temperatura', 336.0000, 'ºC'),
	(61691, 110, '2015-02-15 00:46:18.000000', 'temperatura', 955.0000, 'ºC'),
	(61692, 110, '2015-02-15 00:46:19.000000', 'temperatura', 167.0000, 'ºC'),
	(61693, 110, '2015-02-15 00:46:20.000000', 'temperatura', 369.0000, 'ºC'),
	(61694, 110, '2015-02-15 00:46:21.000000', 'temperatura', 145.0000, 'ºC'),
	(61695, 110, '2015-02-15 00:46:22.000000', 'temperatura', 821.0000, 'ºC'),
	(61696, 110, '2015-02-15 00:46:23.000000', 'temperatura', 68.0000, 'ºC'),
	(61697, 110, '2015-02-15 00:46:24.000000', 'temperatura', 280.0000, 'ºC'),
	(61698, 110, '2015-02-15 00:46:25.000000', 'temperatura', 1196.0000, 'ºC'),
	(61699, 110, '2015-02-15 00:46:26.000000', 'temperatura', 341.0000, 'ºC'),
	(61700, 110, '2015-02-15 00:46:27.000000', 'temperatura', 517.0000, 'ºC'),
	(61701, 110, '2015-02-15 00:46:28.000000', 'temperatura', 363.0000, 'ºC'),
	(61702, 110, '2015-02-15 00:46:29.000000', 'temperatura', 265.0000, 'ºC'),
	(61703, 110, '2015-02-15 00:46:30.000000', 'temperatura', 234.0000, 'ºC'),
	(61704, 110, '2015-02-15 00:46:31.000000', 'temperatura', 376.0000, 'ºC'),
	(61705, 110, '2015-02-15 00:46:32.000000', 'temperatura', 1179.0000, 'ºC'),
	(61706, 110, '2015-02-15 00:46:33.000000', 'temperatura', 1167.0000, 'ºC'),
	(61707, 110, '2015-02-15 00:46:34.000000', 'temperatura', 1097.0000, 'ºC'),
	(61708, 110, '2015-02-15 00:46:35.000000', 'temperatura', 787.0000, 'ºC'),
	(61709, 110, '2015-02-15 00:46:36.000000', 'temperatura', 645.0000, 'ºC'),
	(61710, 110, '2015-02-15 00:46:37.000000', 'temperatura', 863.0000, 'ºC'),
	(61711, 110, '2015-02-15 00:46:38.000000', 'temperatura', 1179.0000, 'ºC'),
	(61712, 110, '2015-02-15 00:46:39.000000', 'temperatura', 907.0000, 'ºC'),
	(61713, 110, '2015-02-15 00:46:40.000000', 'temperatura', 1000.0000, 'ºC'),
	(61714, 110, '2015-02-15 00:46:41.000000', 'temperatura', 1080.0000, 'ºC'),
	(61715, 110, '2015-02-15 00:46:42.000000', 'temperatura', 2.0000, 'ºC'),
	(61716, 110, '2015-02-15 00:46:43.000000', 'temperatura', 367.0000, 'ºC'),
	(61717, 110, '2015-02-15 00:46:44.000000', 'temperatura', 630.0000, 'ºC'),
	(61718, 110, '2015-02-15 00:46:45.000000', 'temperatura', 849.0000, 'ºC'),
	(61719, 110, '2015-02-15 00:46:46.000000', 'temperatura', 1157.0000, 'ºC'),
	(61720, 110, '2015-02-15 00:46:47.000000', 'temperatura', 839.0000, 'ºC'),
	(61721, 110, '2015-02-15 00:46:48.000000', 'temperatura', 725.0000, 'ºC'),
	(61722, 110, '2015-02-15 00:46:49.000000', 'temperatura', 1108.0000, 'ºC'),
	(61723, 110, '2015-02-15 00:46:50.000000', 'temperatura', 965.0000, 'ºC'),
	(61724, 110, '2015-02-15 00:46:51.000000', 'temperatura', 303.0000, 'ºC'),
	(61725, 110, '2015-02-15 00:46:52.000000', 'temperatura', 1020.0000, 'ºC'),
	(61726, 110, '2015-02-15 00:46:53.000000', 'temperatura', 591.0000, 'ºC'),
	(61727, 110, '2015-02-15 00:46:54.000000', 'temperatura', 1094.0000, 'ºC'),
	(61728, 110, '2015-02-15 00:46:55.000000', 'temperatura', 100.0000, 'ºC'),
	(61729, 110, '2015-02-15 00:46:56.000000', 'temperatura', 819.0000, 'ºC'),
	(61730, 110, '2015-02-15 00:46:57.000000', 'temperatura', 195.0000, 'ºC'),
	(61731, 110, '2015-02-15 00:46:58.000000', 'temperatura', 916.0000, 'ºC'),
	(61732, 110, '2015-02-15 00:46:59.000000', 'temperatura', 399.0000, 'ºC'),
	(61733, 110, '2015-02-15 00:47:00.000000', 'temperatura', 446.0000, 'ºC'),
	(61734, 110, '2015-02-15 00:47:01.000000', 'temperatura', 1032.0000, 'ºC'),
	(61735, 110, '2015-02-15 00:47:02.000000', 'temperatura', 226.0000, 'ºC'),
	(61736, 110, '2015-02-15 00:47:03.000000', 'temperatura', 431.0000, 'ºC'),
	(61737, 110, '2015-02-15 00:47:04.000000', 'temperatura', 281.0000, 'ºC'),
	(61738, 110, '2015-02-15 00:47:05.000000', 'temperatura', 109.0000, 'ºC'),
	(61739, 110, '2015-02-15 00:47:06.000000', 'temperatura', 905.0000, 'ºC'),
	(61740, 110, '2015-02-15 00:47:07.000000', 'temperatura', 596.0000, 'ºC'),
	(61741, 110, '2015-02-15 00:47:08.000000', 'temperatura', 266.0000, 'ºC'),
	(61742, 110, '2015-02-15 00:47:09.000000', 'temperatura', 743.0000, 'ºC'),
	(61743, 110, '2015-02-15 00:47:10.000000', 'temperatura', 520.0000, 'ºC'),
	(61744, 110, '2015-02-15 00:47:11.000000', 'temperatura', 368.0000, 'ºC'),
	(61745, 110, '2015-02-15 00:47:12.000000', 'temperatura', 282.0000, 'ºC'),
	(61746, 110, '2015-02-15 00:47:13.000000', 'temperatura', 306.0000, 'ºC'),
	(61747, 110, '2015-02-15 00:47:14.000000', 'temperatura', 686.0000, 'ºC'),
	(61748, 110, '2015-02-15 00:47:15.000000', 'temperatura', 113.0000, 'ºC'),
	(61749, 110, '2015-02-15 00:47:16.000000', 'temperatura', 905.0000, 'ºC'),
	(61750, 110, '2015-02-15 00:47:17.000000', 'temperatura', 586.0000, 'ºC'),
	(61751, 110, '2015-02-15 00:47:18.000000', 'temperatura', 217.0000, 'ºC'),
	(61752, 110, '2015-02-15 00:47:19.000000', 'temperatura', 525.0000, 'ºC'),
	(61753, 110, '2015-02-15 00:47:20.000000', 'temperatura', 778.0000, 'ºC'),
	(61754, 110, '2015-02-15 00:47:21.000000', 'temperatura', 1113.0000, 'ºC'),
	(61755, 110, '2015-02-15 00:47:22.000000', 'temperatura', 831.0000, 'ºC'),
	(61756, 110, '2015-02-15 00:47:23.000000', 'temperatura', 816.0000, 'ºC'),
	(61757, 110, '2015-02-15 00:47:24.000000', 'temperatura', 389.0000, 'ºC'),
	(61758, 110, '2015-02-15 00:47:25.000000', 'temperatura', 697.0000, 'ºC'),
	(61759, 110, '2015-02-15 00:47:26.000000', 'temperatura', 1119.0000, 'ºC'),
	(61760, 110, '2015-02-15 00:47:27.000000', 'temperatura', 1106.0000, 'ºC'),
	(61761, 110, '2015-02-15 00:47:28.000000', 'temperatura', 972.0000, 'ºC'),
	(61762, 110, '2015-02-15 00:47:29.000000', 'temperatura', 341.0000, 'ºC'),
	(61763, 110, '2015-02-15 00:47:30.000000', 'temperatura', 1191.0000, 'ºC'),
	(61764, 110, '2015-02-15 00:47:31.000000', 'temperatura', 134.0000, 'ºC'),
	(61765, 110, '2015-02-15 00:47:32.000000', 'temperatura', 694.0000, 'ºC'),
	(61766, 110, '2015-02-15 00:47:33.000000', 'temperatura', 672.0000, 'ºC'),
	(61767, 110, '2015-02-15 00:47:34.000000', 'temperatura', 76.0000, 'ºC'),
	(61768, 110, '2015-02-15 00:47:35.000000', 'temperatura', 764.0000, 'ºC'),
	(61769, 110, '2015-02-15 00:47:36.000000', 'temperatura', 1193.0000, 'ºC'),
	(61770, 110, '2015-02-15 00:47:37.000000', 'temperatura', 75.0000, 'ºC'),
	(61771, 110, '2015-02-15 00:47:38.000000', 'temperatura', 394.0000, 'ºC'),
	(61772, 110, '2015-02-15 00:47:39.000000', 'temperatura', 546.0000, 'ºC'),
	(61773, 110, '2015-02-15 00:47:40.000000', 'temperatura', 349.0000, 'ºC'),
	(61774, 110, '2015-02-15 00:47:41.000000', 'temperatura', 108.0000, 'ºC'),
	(61775, 110, '2015-02-15 00:47:42.000000', 'temperatura', 695.0000, 'ºC'),
	(61776, 110, '2015-02-15 00:47:43.000000', 'temperatura', 749.0000, 'ºC'),
	(61777, 110, '2015-02-15 00:47:44.000000', 'temperatura', 462.0000, 'ºC'),
	(61778, 110, '2015-02-15 00:47:45.000000', 'temperatura', 65.0000, 'ºC'),
	(61779, 110, '2015-02-15 00:47:46.000000', 'temperatura', 136.0000, 'ºC'),
	(61780, 110, '2015-02-15 00:47:47.000000', 'temperatura', 488.0000, 'ºC'),
	(61781, 110, '2015-02-15 00:47:48.000000', 'temperatura', 831.0000, 'ºC'),
	(61782, 110, '2015-02-15 00:47:49.000000', 'temperatura', 293.0000, 'ºC'),
	(61783, 110, '2015-02-15 00:47:50.000000', 'temperatura', 172.0000, 'ºC'),
	(61784, 110, '2015-02-15 00:47:51.000000', 'temperatura', 1181.0000, 'ºC'),
	(61785, 110, '2015-02-15 00:47:52.000000', 'temperatura', 590.0000, 'ºC'),
	(61786, 110, '2015-02-15 00:47:53.000000', 'temperatura', 608.0000, 'ºC'),
	(61787, 110, '2015-02-15 00:47:54.000000', 'temperatura', 72.0000, 'ºC'),
	(61788, 110, '2015-02-15 00:47:55.000000', 'temperatura', 934.0000, 'ºC'),
	(61789, 110, '2015-02-15 00:47:56.000000', 'temperatura', 854.0000, 'ºC'),
	(61790, 110, '2015-02-15 00:47:57.000000', 'temperatura', 267.0000, 'ºC'),
	(61791, 110, '2015-02-15 00:47:58.000000', 'temperatura', 1177.0000, 'ºC'),
	(61792, 110, '2015-02-15 00:47:59.000000', 'temperatura', 285.0000, 'ºC'),
	(61793, 110, '2015-02-15 00:48:00.000000', 'temperatura', 291.0000, 'ºC'),
	(61794, 110, '2015-02-15 00:48:01.000000', 'temperatura', 603.0000, 'ºC'),
	(61795, 110, '2015-02-15 00:48:02.000000', 'temperatura', 943.0000, 'ºC'),
	(61796, 110, '2015-02-15 00:48:03.000000', 'temperatura', 507.0000, 'ºC'),
	(61797, 110, '2015-02-15 00:48:04.000000', 'temperatura', 907.0000, 'ºC'),
	(61798, 110, '2015-02-15 00:48:05.000000', 'temperatura', 613.0000, 'ºC'),
	(61799, 110, '2015-02-15 00:48:06.000000', 'temperatura', 345.0000, 'ºC'),
	(61800, 110, '2015-02-15 00:48:07.000000', 'temperatura', 1084.0000, 'ºC'),
	(61801, 110, '2015-02-15 00:48:08.000000', 'temperatura', 788.0000, 'ºC'),
	(61802, 110, '2015-02-15 00:48:09.000000', 'temperatura', 690.0000, 'ºC'),
	(61803, 110, '2015-02-15 00:48:10.000000', 'temperatura', 1085.0000, 'ºC'),
	(61804, 110, '2015-02-15 00:48:11.000000', 'temperatura', 955.0000, 'ºC'),
	(61805, 110, '2015-02-15 00:48:12.000000', 'temperatura', 322.0000, 'ºC'),
	(61806, 110, '2015-02-15 00:48:13.000000', 'temperatura', 1143.0000, 'ºC'),
	(61807, 110, '2015-02-15 00:48:14.000000', 'temperatura', 1151.0000, 'ºC'),
	(61808, 110, '2015-02-15 00:48:15.000000', 'temperatura', 1126.0000, 'ºC'),
	(61809, 110, '2015-02-15 00:48:16.000000', 'temperatura', 978.0000, 'ºC'),
	(61810, 110, '2015-02-15 00:48:17.000000', 'temperatura', 313.0000, 'ºC'),
	(61811, 110, '2015-02-15 00:48:18.000000', 'temperatura', 1030.0000, 'ºC'),
	(61812, 110, '2015-02-15 00:48:19.000000', 'temperatura', 610.0000, 'ºC'),
	(61813, 110, '2015-02-15 00:48:20.000000', 'temperatura', 1164.0000, 'ºC'),
	(61814, 110, '2015-02-15 00:48:21.000000', 'temperatura', 388.0000, 'ºC'),
	(61815, 110, '2015-02-15 00:48:22.000000', 'temperatura', 850.0000, 'ºC'),
	(61816, 110, '2015-02-15 00:48:23.000000', 'temperatura', 684.0000, 'ºC'),
	(61817, 110, '2015-02-15 00:48:24.000000', 'temperatura', 871.0000, 'ºC'),
	(61818, 110, '2015-02-15 00:48:25.000000', 'temperatura', 1106.0000, 'ºC'),
	(61819, 110, '2015-02-15 00:48:26.000000', 'temperatura', 514.0000, 'ºC'),
	(61820, 110, '2015-02-15 00:48:27.000000', 'temperatura', 455.0000, 'ºC'),
	(61821, 110, '2015-02-15 00:48:28.000000', 'temperatura', 731.0000, 'ºC'),
	(61822, 110, '2015-02-15 00:48:29.000000', 'temperatura', 1091.0000, 'ºC'),
	(61823, 110, '2015-02-15 00:48:30.000000', 'temperatura', 863.0000, 'ºC'),
	(61824, 110, '2015-02-15 00:48:31.000000', 'temperatura', 1044.0000, 'ºC'),
	(61825, 110, '2015-02-15 00:48:32.000000', 'temperatura', 228.0000, 'ºC'),
	(61826, 110, '2015-02-15 00:48:33.000000', 'temperatura', 412.0000, 'ºC'),
	(61827, 110, '2015-02-15 00:48:34.000000', 'temperatura', 174.0000, 'ºC'),
	(61828, 110, '2015-02-15 00:48:35.000000', 'temperatura', 836.0000, 'ºC'),
	(61829, 110, '2015-02-15 00:48:36.000000', 'temperatura', 60.0000, 'ºC'),
	(61830, 110, '2015-02-15 00:48:37.000000', 'temperatura', 189.0000, 'ºC'),
	(61831, 110, '2015-02-15 00:48:38.000000', 'temperatura', 769.0000, 'ºC'),
	(61832, 110, '2015-02-15 00:48:39.000000', 'temperatura', 878.0000, 'ºC'),
	(61833, 110, '2015-02-15 00:48:40.000000', 'temperatura', 881.0000, 'ºC'),
	(61834, 110, '2015-02-15 00:48:41.000000', 'temperatura', 573.0000, 'ºC'),
	(61835, 110, '2015-02-15 00:48:42.000000', 'temperatura', 224.0000, 'ºC'),
	(61836, 110, '2015-02-15 00:48:43.000000', 'temperatura', 599.0000, 'ºC'),
	(61837, 110, '2015-02-15 00:48:44.000000', 'temperatura', 1125.0000, 'ºC'),
	(61838, 110, '2015-02-15 00:48:45.000000', 'temperatura', 227.0000, 'ºC'),
	(61839, 110, '2015-02-15 00:48:46.000000', 'temperatura', 163.0000, 'ºC'),
	(61840, 110, '2015-02-15 00:48:47.000000', 'temperatura', 133.0000, 'ºC'),
	(61841, 110, '2015-02-15 00:48:48.000000', 'temperatura', 178.0000, 'ºC'),
	(61842, 110, '2015-02-15 00:48:49.000000', 'temperatura', 491.0000, 'ºC'),
	(61843, 110, '2015-02-15 00:48:50.000000', 'temperatura', 723.0000, 'ºC'),
	(61844, 110, '2015-02-15 00:48:51.000000', 'temperatura', 941.0000, 'ºC'),
	(61845, 110, '2015-02-15 00:48:52.000000', 'temperatura', 135.0000, 'ºC'),
	(61846, 110, '2015-02-15 00:48:53.000000', 'temperatura', 253.0000, 'ºC'),
	(61847, 110, '2015-02-15 00:48:54.000000', 'temperatura', 863.0000, 'ºC'),
	(61848, 110, '2015-02-15 00:48:55.000000', 'temperatura', 1155.0000, 'ºC'),
	(61849, 110, '2015-02-15 00:48:56.000000', 'temperatura', 786.0000, 'ºC'),
	(61850, 110, '2015-02-15 00:48:57.000000', 'temperatura', 468.0000, 'ºC'),
	(61851, 110, '2015-02-15 00:48:58.000000', 'temperatura', 1180.0000, 'ºC'),
	(61852, 110, '2015-02-15 00:48:59.000000', 'temperatura', 896.0000, 'ºC'),
	(61853, 110, '2015-02-15 00:49:00.000000', 'temperatura', 941.0000, 'ºC'),
	(61854, 110, '2015-02-15 00:49:01.000000', 'temperatura', 817.0000, 'ºC'),
	(61855, 110, '2015-02-15 00:49:02.000000', 'temperatura', 62.0000, 'ºC'),
	(61856, 110, '2015-02-15 00:49:03.000000', 'temperatura', 261.0000, 'ºC'),
	(61857, 110, '2015-02-15 00:49:04.000000', 'temperatura', 1117.0000, 'ºC'),
	(61858, 110, '2015-02-15 00:49:05.000000', 'temperatura', 5.0000, 'ºC'),
	(61859, 110, '2015-02-15 00:49:06.000000', 'temperatura', 275.0000, 'ºC'),
	(61860, 110, '2015-02-15 00:49:07.000000', 'temperatura', 159.0000, 'ºC'),
	(61861, 110, '2015-02-15 00:49:08.000000', 'temperatura', 1169.0000, 'ºC'),
	(61862, 110, '2015-02-15 00:49:09.000000', 'temperatura', 570.0000, 'ºC'),
	(61863, 110, '2015-02-15 00:49:10.000000', 'temperatura', 541.0000, 'ºC'),
	(61864, 110, '2015-02-15 00:49:11.000000', 'temperatura', 999.0000, 'ºC'),
	(61865, 110, '2015-02-15 00:49:12.000000', 'temperatura', 971.0000, 'ºC'),
	(61866, 110, '2015-02-15 00:49:13.000000', 'temperatura', 658.0000, 'ºC'),
	(61867, 110, '2015-02-15 00:49:14.000000', 'temperatura', 378.0000, 'ºC'),
	(61868, 110, '2015-02-15 00:49:15.000000', 'temperatura', 1117.0000, 'ºC'),
	(61869, 110, '2015-02-15 00:49:16.000000', 'temperatura', 853.0000, 'ºC'),
	(61870, 110, '2015-02-15 00:49:17.000000', 'temperatura', 913.0000, 'ºC'),
	(61871, 110, '2015-02-15 00:49:18.000000', 'temperatura', 805.0000, 'ºC'),
	(61872, 110, '2015-02-15 00:49:19.000000', 'temperatura', 89.0000, 'ºC'),
	(61873, 110, '2015-02-15 00:49:20.000000', 'temperatura', 428.0000, 'ºC'),
	(61874, 110, '2015-02-15 00:49:21.000000', 'temperatura', 673.0000, 'ºC'),
	(61875, 110, '2015-02-15 00:49:22.000000', 'temperatura', 883.0000, 'ºC'),
	(61876, 110, '2015-02-15 00:49:23.000000', 'temperatura', 1196.0000, 'ºC'),
	(61877, 110, '2015-02-15 00:49:24.000000', 'temperatura', 933.0000, 'ºC'),
	(61878, 110, '2015-02-15 00:49:25.000000', 'temperatura', 1075.0000, 'ºC'),
	(61879, 110, '2015-02-15 00:49:26.000000', 'temperatura', 180.0000, 'ºC'),
	(61880, 110, '2015-02-15 00:49:27.000000', 'temperatura', 72.0000, 'ºC'),
	(61881, 110, '2015-02-15 00:49:28.000000', 'temperatura', 1021.0000, 'ºC'),
	(61882, 110, '2015-02-15 00:49:29.000000', 'temperatura', 88.0000, 'ºC'),
	(61883, 110, '2015-02-15 00:49:30.000000', 'temperatura', 980.0000, 'ºC'),
	(61884, 110, '2015-02-15 00:49:31.000000', 'temperatura', 1034.0000, 'ºC'),
	(61885, 110, '2015-02-15 00:49:32.000000', 'temperatura', 1031.0000, 'ºC'),
	(61886, 110, '2015-02-15 00:49:33.000000', 'temperatura', 853.0000, 'ºC'),
	(61887, 110, '2015-02-15 00:49:34.000000', 'temperatura', 1173.0000, 'ºC'),
	(61888, 110, '2015-02-15 00:49:35.000000', 'temperatura', 907.0000, 'ºC'),
	(61889, 110, '2015-02-15 00:49:36.000000', 'temperatura', 1015.0000, 'ºC'),
	(61890, 110, '2015-02-15 00:49:37.000000', 'temperatura', 1154.0000, 'ºC'),
	(61891, 110, '2015-02-15 00:49:38.000000', 'temperatura', 327.0000, 'ºC'),
	(61892, 110, '2015-02-15 00:49:39.000000', 'temperatura', 574.0000, 'ºC'),
	(61893, 110, '2015-02-15 00:49:40.000000', 'temperatura', 688.0000, 'ºC'),
	(61894, 110, '2015-02-15 00:49:41.000000', 'temperatura', 517.0000, 'ºC'),
	(61895, 110, '2015-02-15 00:49:42.000000', 'temperatura', 523.0000, 'ºC'),
	(61896, 110, '2015-02-15 00:49:43.000000', 'temperatura', 1066.0000, 'ºC'),
	(61897, 110, '2015-02-15 00:49:44.000000', 'temperatura', 161.0000, 'ºC'),
	(61898, 110, '2015-02-15 00:49:45.000000', 'temperatura', 5.0000, 'ºC'),
	(61899, 110, '2015-02-15 00:49:46.000000', 'temperatura', 745.0000, 'ºC'),
	(61900, 110, '2015-02-15 00:49:47.000000', 'temperatura', 108.0000, 'ºC'),
	(61901, 110, '2015-02-15 00:49:48.000000', 'temperatura', 707.0000, 'ºC'),
	(61902, 110, '2015-02-15 00:49:49.000000', 'temperatura', 812.0000, 'ºC'),
	(61903, 110, '2015-02-15 00:49:50.000000', 'temperatura', 739.0000, 'ºC'),
	(61904, 110, '2015-02-15 00:49:51.000000', 'temperatura', 58.0000, 'ºC'),
	(61905, 110, '2015-02-15 00:49:52.000000', 'temperatura', 473.0000, 'ºC'),
	(61906, 110, '2015-02-15 00:49:53.000000', 'temperatura', 991.0000, 'ºC'),
	(61907, 110, '2015-02-15 00:49:54.000000', 'temperatura', 1139.0000, 'ºC'),
	(61908, 110, '2015-02-15 00:49:55.000000', 'temperatura', 323.0000, 'ºC'),
	(61909, 110, '2015-02-15 00:49:56.000000', 'temperatura', 596.0000, 'ºC'),
	(61910, 110, '2015-02-15 00:49:57.000000', 'temperatura', 813.0000, 'ºC'),
	(61911, 110, '2015-02-15 00:49:58.000000', 'temperatura', 1079.0000, 'ºC'),
	(61912, 110, '2015-02-15 00:49:59.000000', 'temperatura', 556.0000, 'ºC'),
	(61913, 110, '2015-02-15 00:50:00.000000', 'temperatura', 742.0000, 'ºC'),
	(61914, 110, '2015-02-15 00:50:01.000000', 'temperatura', 844.0000, 'ºC'),
	(61915, 110, '2015-02-15 00:50:02.000000', 'temperatura', 793.0000, 'ºC'),
	(61916, 110, '2015-02-15 00:50:03.000000', 'temperatura', 233.0000, 'ºC'),
	(61917, 110, '2015-02-15 00:50:04.000000', 'temperatura', 1188.0000, 'ºC'),
	(61918, 110, '2015-02-15 00:50:05.000000', 'temperatura', 443.0000, 'ºC'),
	(61919, 110, '2015-02-15 00:50:06.000000', 'temperatura', 1050.0000, 'ºC'),
	(61920, 110, '2015-02-15 00:50:07.000000', 'temperatura', 320.0000, 'ºC'),
	(61921, 110, '2015-02-15 00:50:08.000000', 'temperatura', 852.0000, 'ºC'),
	(61922, 110, '2015-02-15 00:50:09.000000', 'temperatura', 899.0000, 'ºC'),
	(61923, 110, '2015-02-15 00:50:10.000000', 'temperatura', 742.0000, 'ºC'),
	(61924, 110, '2015-02-15 00:50:11.000000', 'temperatura', 1014.0000, 'ºC'),
	(61925, 110, '2015-02-15 00:50:12.000000', 'temperatura', 443.0000, 'ºC'),
	(61926, 110, '2015-02-15 00:50:13.000000', 'temperatura', 374.0000, 'ºC'),
	(61927, 110, '2015-02-15 00:50:14.000000', 'temperatura', 540.0000, 'ºC'),
	(61928, 110, '2015-02-15 00:50:15.000000', 'temperatura', 380.0000, 'ºC'),
	(61929, 110, '2015-02-15 00:50:16.000000', 'temperatura', 282.0000, 'ºC'),
	(61930, 110, '2015-02-15 00:50:17.000000', 'temperatura', 267.0000, 'ºC'),
	(61931, 110, '2015-02-15 00:50:18.000000', 'temperatura', 491.0000, 'ºC'),
	(61932, 110, '2015-02-15 00:50:19.000000', 'temperatura', 456.0000, 'ºC'),
	(61933, 110, '2015-02-15 00:50:20.000000', 'temperatura', 806.0000, 'ºC'),
	(61934, 110, '2015-02-15 00:50:21.000000', 'temperatura', 265.0000, 'ºC'),
	(61935, 110, '2015-02-15 00:50:22.000000', 'temperatura', 104.0000, 'ºC'),
	(61936, 110, '2015-02-15 00:50:23.000000', 'temperatura', 929.0000, 'ºC'),
	(61937, 110, '2015-02-15 00:50:24.000000', 'temperatura', 731.0000, 'ºC'),
	(61938, 110, '2015-02-15 00:50:25.000000', 'temperatura', 870.0000, 'ºC'),
	(61939, 110, '2015-02-15 00:50:26.000000', 'temperatura', 955.0000, 'ºC'),
	(61940, 110, '2015-02-15 00:50:27.000000', 'temperatura', 966.0000, 'ºC'),
	(61941, 110, '2015-02-15 00:50:28.000000', 'temperatura', 767.0000, 'ºC'),
	(61942, 110, '2015-02-15 00:50:29.000000', 'temperatura', 938.0000, 'ºC'),
	(61943, 110, '2015-02-15 00:50:30.000000', 'temperatura', 1188.0000, 'ºC'),
	(61944, 110, '2015-02-15 00:50:31.000000', 'temperatura', 728.0000, 'ºC'),
	(61945, 110, '2015-02-15 00:50:32.000000', 'temperatura', 74.0000, 'ºC'),
	(61946, 110, '2015-02-15 00:50:33.000000', 'temperatura', 588.0000, 'ºC'),
	(61947, 110, '2015-02-15 00:50:34.000000', 'temperatura', 319.0000, 'ºC'),
	(61948, 110, '2015-02-15 00:50:35.000000', 'temperatura', 1033.0000, 'ºC'),
	(61949, 110, '2015-02-15 00:50:36.000000', 'temperatura', 608.0000, 'ºC'),
	(61950, 110, '2015-02-15 00:50:37.000000', 'temperatura', 1139.0000, 'ºC'),
	(61951, 110, '2015-02-15 00:50:38.000000', 'temperatura', 273.0000, 'ºC'),
	(61952, 110, '2015-02-15 00:50:39.000000', 'temperatura', 348.0000, 'ºC'),
	(61953, 110, '2015-02-15 00:50:40.000000', 'temperatura', 921.0000, 'ºC'),
	(61954, 110, '2015-02-15 00:50:41.000000', 'temperatura', 1162.0000, 'ºC'),
	(61955, 110, '2015-02-15 00:50:42.000000', 'temperatura', 646.0000, 'ºC'),
	(61956, 110, '2015-02-15 00:50:43.000000', 'temperatura', 946.0000, 'ºC'),
	(61957, 110, '2015-02-15 00:50:44.000000', 'temperatura', 394.0000, 'ºC'),
	(61958, 110, '2015-02-15 00:50:45.000000', 'temperatura', 332.0000, 'ºC'),
	(61959, 110, '2015-02-15 00:50:46.000000', 'temperatura', 478.0000, 'ºC'),
	(61960, 110, '2015-02-15 00:50:47.000000', 'temperatura', 196.0000, 'ºC'),
	(61961, 110, '2015-02-15 00:50:48.000000', 'temperatura', 746.0000, 'ºC'),
	(61962, 110, '2015-02-15 00:50:49.000000', 'temperatura', 742.0000, 'ºC'),
	(61963, 110, '2015-02-15 00:50:50.000000', 'temperatura', 271.0000, 'ºC'),
	(61964, 110, '2015-02-15 00:50:51.000000', 'temperatura', 329.0000, 'ºC'),
	(61965, 110, '2015-02-15 00:50:52.000000', 'temperatura', 833.0000, 'ºC'),
	(61966, 110, '2015-02-15 00:50:53.000000', 'temperatura', 780.0000, 'ºC'),
	(61967, 110, '2015-02-15 00:50:54.000000', 'temperatura', 200.0000, 'ºC'),
	(61968, 110, '2015-02-15 00:50:55.000000', 'temperatura', 1060.0000, 'ºC'),
	(61969, 110, '2015-02-15 00:50:56.000000', 'temperatura', 1103.0000, 'ºC'),
	(61970, 110, '2015-02-15 00:50:57.000000', 'temperatura', 1135.0000, 'ºC'),
	(61971, 110, '2015-02-15 00:50:58.000000', 'temperatura', 1165.0000, 'ºC'),
	(61972, 110, '2015-02-15 00:50:59.000000', 'temperatura', 22.0000, 'ºC'),
	(61973, 110, '2015-02-15 00:51:00.000000', 'temperatura', 214.0000, 'ºC'),
	(61974, 110, '2015-02-15 00:51:01.000000', 'temperatura', 1006.0000, 'ºC'),
	(61975, 110, '2015-02-15 00:51:02.000000', 'temperatura', 788.0000, 'ºC'),
	(61976, 110, '2015-02-15 00:51:03.000000', 'temperatura', 921.0000, 'ºC'),
	(61977, 110, '2015-02-15 00:51:04.000000', 'temperatura', 1040.0000, 'ºC'),
	(61978, 110, '2015-02-15 00:51:05.000000', 'temperatura', 41.0000, 'ºC'),
	(61979, 110, '2015-02-15 00:51:06.000000', 'temperatura', 686.0000, 'ºC'),
	(61980, 110, '2015-02-15 00:51:07.000000', 'temperatura', 905.0000, 'ºC'),
	(61981, 110, '2015-02-15 00:51:08.000000', 'temperatura', 66.0000, 'ºC'),
	(61982, 110, '2015-02-15 00:51:09.000000', 'temperatura', 18.0000, 'ºC'),
	(61983, 110, '2015-02-15 00:51:10.000000', 'temperatura', 1094.0000, 'ºC'),
	(61984, 110, '2015-02-15 00:51:11.000000', 'temperatura', 615.0000, 'ºC'),
	(61985, 110, '2015-02-15 00:51:12.000000', 'temperatura', 992.0000, 'ºC'),
	(61986, 110, '2015-02-15 00:51:13.000000', 'temperatura', 718.0000, 'ºC'),
	(61987, 110, '2015-02-15 00:51:14.000000', 'temperatura', 614.0000, 'ºC'),
	(61988, 110, '2015-02-15 00:51:15.000000', 'temperatura', 918.0000, 'ºC'),
	(61989, 110, '2015-02-15 00:51:16.000000', 'temperatura', 348.0000, 'ºC'),
	(61990, 110, '2015-02-15 00:51:17.000000', 'temperatura', 184.0000, 'ºC'),
	(61991, 110, '2015-02-15 00:51:18.000000', 'temperatura', 1079.0000, 'ºC'),
	(61992, 110, '2015-02-15 00:51:19.000000', 'temperatura', 44.0000, 'ºC'),
	(61993, 110, '2015-02-15 00:51:20.000000', 'temperatura', 583.0000, 'ºC'),
	(61994, 110, '2015-02-15 00:51:21.000000', 'temperatura', 382.0000, 'ºC'),
	(61995, 110, '2015-02-15 00:51:22.000000', 'temperatura', 164.0000, 'ºC'),
	(61996, 110, '2015-02-15 00:51:23.000000', 'temperatura', 872.0000, 'ºC'),
	(61997, 110, '2015-02-15 00:51:24.000000', 'temperatura', 271.0000, 'ºC'),
	(61998, 110, '2015-02-15 00:51:25.000000', 'temperatura', 1138.0000, 'ºC'),
	(61999, 110, '2015-02-15 00:51:26.000000', 'temperatura', 77.0000, 'ºC'),
	(62000, 110, '2015-02-15 00:51:27.000000', 'temperatura', 571.0000, 'ºC'),
	(62001, 110, '2015-02-15 00:51:28.000000', 'temperatura', 225.0000, 'ºC'),
	(62002, 110, '2015-02-15 00:51:29.000000', 'temperatura', 615.0000, 'ºC'),
	(62003, 110, '2015-02-15 00:51:30.000000', 'temperatura', 1198.0000, 'ºC'),
	(62004, 110, '2015-02-15 00:51:31.000000', 'temperatura', 546.0000, 'ºC'),
	(62005, 110, '2015-02-15 00:51:32.000000', 'temperatura', 337.0000, 'ºC'),
	(62006, 110, '2015-02-15 00:51:33.000000', 'temperatura', 45.0000, 'ºC'),
	(62007, 110, '2015-02-15 00:51:34.000000', 'temperatura', 417.0000, 'ºC'),
	(62008, 110, '2015-02-15 00:51:35.000000', 'temperatura', 749.0000, 'ºC'),
	(62009, 110, '2015-02-15 00:51:36.000000', 'temperatura', 95.0000, 'ºC'),
	(62010, 110, '2015-02-15 00:51:37.000000', 'temperatura', 628.0000, 'ºC'),
	(62011, 110, '2015-02-15 00:51:38.000000', 'temperatura', 455.0000, 'ºC'),
	(62012, 110, '2015-02-15 00:51:39.000000', 'temperatura', 394.0000, 'ºC'),
	(62013, 110, '2015-02-15 00:51:40.000000', 'temperatura', 605.0000, 'ºC'),
	(62014, 110, '2015-02-15 00:51:41.000000', 'temperatura', 643.0000, 'ºC'),
	(62015, 110, '2015-02-15 00:51:42.000000', 'temperatura', 202.0000, 'ºC'),
	(62016, 110, '2015-02-15 00:51:43.000000', 'temperatura', 282.0000, 'ºC'),
	(62017, 110, '2015-02-15 00:51:44.000000', 'temperatura', 805.0000, 'ºC'),
	(62018, 110, '2015-02-15 00:51:45.000000', 'temperatura', 780.0000, 'ºC'),
	(62019, 110, '2015-02-15 00:51:46.000000', 'temperatura', 284.0000, 'ºC'),
	(62020, 110, '2015-02-15 00:51:47.000000', 'temperatura', 281.0000, 'ºC'),
	(62021, 110, '2015-02-15 00:51:48.000000', 'temperatura', 555.0000, 'ºC'),
	(62022, 110, '2015-02-15 00:51:49.000000', 'temperatura', 733.0000, 'ºC'),
	(62023, 110, '2015-02-15 00:51:50.000000', 'temperatura', 801.0000, 'ºC'),
	(62024, 110, '2015-02-15 00:51:51.000000', 'temperatura', 606.0000, 'ºC'),
	(62025, 110, '2015-02-15 00:51:52.000000', 'temperatura', 627.0000, 'ºC'),
	(62026, 110, '2015-02-15 00:51:53.000000', 'temperatura', 116.0000, 'ºC'),
	(62027, 110, '2015-02-15 00:51:54.000000', 'temperatura', 1100.0000, 'ºC'),
	(62028, 110, '2015-02-15 00:51:55.000000', 'temperatura', 351.0000, 'ºC'),
	(62029, 110, '2015-02-15 00:51:56.000000', 'temperatura', 857.0000, 'ºC'),
	(62030, 110, '2015-02-15 00:51:57.000000', 'temperatura', 834.0000, 'ºC'),
	(62031, 110, '2015-02-15 00:51:58.000000', 'temperatura', 400.0000, 'ºC'),
	(62032, 110, '2015-02-15 00:51:59.000000', 'temperatura', 698.0000, 'ºC'),
	(62033, 110, '2015-02-15 00:52:00.000000', 'temperatura', 1092.0000, 'ºC'),
	(62034, 110, '2015-02-15 00:52:01.000000', 'temperatura', 965.0000, 'ºC'),
	(62035, 110, '2015-02-15 00:52:02.000000', 'temperatura', 351.0000, 'ºC'),
	(62036, 110, '2015-02-15 00:52:03.000000', 'temperatura', 58.0000, 'ºC'),
	(62037, 110, '2015-02-15 00:52:04.000000', 'temperatura', 438.0000, 'ºC'),
	(62038, 110, '2015-02-15 00:52:05.000000', 'temperatura', 817.0000, 'ºC'),
	(62039, 110, '2015-02-15 00:52:06.000000', 'temperatura', 369.0000, 'ºC'),
	(62040, 110, '2015-02-15 00:52:07.000000', 'temperatura', 598.0000, 'ºC'),
	(62041, 110, '2015-02-15 00:52:08.000000', 'temperatura', 681.0000, 'ºC'),
	(62042, 110, '2015-02-15 00:52:09.000000', 'temperatura', 413.0000, 'ºC'),
	(62043, 110, '2015-02-15 00:52:10.000000', 'temperatura', 23.0000, 'ºC'),
	(62044, 110, '2015-02-15 00:52:11.000000', 'temperatura', 75.0000, 'ºC'),
	(62045, 110, '2015-02-15 00:52:12.000000', 'temperatura', 307.0000, 'ºC'),
	(62046, 110, '2015-02-15 00:52:13.000000', 'temperatura', 111.0000, 'ºC'),
	(62047, 110, '2015-02-15 00:52:14.000000', 'temperatura', 836.0000, 'ºC'),
	(62048, 110, '2015-02-15 00:52:15.000000', 'temperatura', 245.0000, 'ºC'),
	(62049, 110, '2015-02-15 00:52:16.000000', 'temperatura', 1118.0000, 'ºC'),
	(62050, 110, '2015-02-15 00:52:17.000000', 'temperatura', 56.0000, 'ºC'),
	(62051, 110, '2015-02-15 00:52:18.000000', 'temperatura', 528.0000, 'ºC'),
	(62052, 110, '2015-02-15 00:52:19.000000', 'temperatura', 71.0000, 'ºC'),
	(62053, 110, '2015-02-15 00:52:20.000000', 'temperatura', 1170.0000, 'ºC'),
	(62054, 110, '2015-02-15 00:52:21.000000', 'temperatura', 839.0000, 'ºC'),
	(62055, 110, '2015-02-15 00:52:22.000000', 'temperatura', 686.0000, 'ºC'),
	(62056, 110, '2015-02-15 00:52:23.000000', 'temperatura', 912.0000, 'ºC'),
	(62057, 110, '2015-02-15 00:52:24.000000', 'temperatura', 104.0000, 'ºC'),
	(62058, 110, '2015-02-15 00:52:25.000000', 'temperatura', 183.0000, 'ºC'),
	(62059, 110, '2015-02-15 00:52:26.000000', 'temperatura', 602.0000, 'ºC'),
	(62060, 110, '2015-02-15 00:52:27.000000', 'temperatura', 65.0000, 'ºC'),
	(62061, 110, '2015-02-15 00:52:28.000000', 'temperatura', 917.0000, 'ºC'),
	(62062, 110, '2015-02-15 00:52:29.000000', 'temperatura', 793.0000, 'ºC'),
	(62063, 110, '2015-02-15 00:52:30.000000', 'temperatura', 14.0000, 'ºC'),
	(62064, 110, '2015-02-15 00:52:31.000000', 'temperatura', 92.0000, 'ºC'),
	(62065, 110, '2015-02-15 00:52:32.000000', 'temperatura', 419.0000, 'ºC'),
	(62066, 110, '2015-02-15 00:52:33.000000', 'temperatura', 619.0000, 'ºC'),
	(62067, 110, '2015-02-15 00:52:34.000000', 'temperatura', 639.0000, 'ºC'),
	(62068, 110, '2015-02-15 00:52:35.000000', 'temperatura', 139.0000, 'ºC'),
	(62069, 110, '2015-02-15 00:52:36.000000', 'temperatura', 1176.0000, 'ºC'),
	(62070, 110, '2015-02-15 00:52:37.000000', 'temperatura', 666.0000, 'ºC'),
	(62071, 110, '2015-02-15 00:52:38.000000', 'temperatura', 1000.0000, 'ºC'),
	(62072, 110, '2015-02-15 00:52:39.000000', 'temperatura', 602.0000, 'ºC'),
	(62073, 110, '2015-02-15 00:52:40.000000', 'temperatura', 12.0000, 'ºC'),
	(62074, 110, '2015-02-15 00:52:41.000000', 'temperatura', 654.0000, 'ºC'),
	(62075, 110, '2015-02-15 00:52:42.000000', 'temperatura', 834.0000, 'ºC'),
	(62076, 110, '2015-02-15 00:52:43.000000', 'temperatura', 1008.0000, 'ºC'),
	(62077, 110, '2015-02-15 00:52:44.000000', 'temperatura', 141.0000, 'ºC'),
	(62078, 110, '2015-02-15 00:52:45.000000', 'temperatura', 81.0000, 'ºC'),
	(62079, 110, '2015-02-15 00:52:46.000000', 'temperatura', 1181.0000, 'ºC'),
	(62080, 110, '2015-02-15 00:52:47.000000', 'temperatura', 861.0000, 'ºC'),
	(62081, 110, '2015-02-15 00:52:48.000000', 'temperatura', 764.0000, 'ºC'),
	(62082, 110, '2015-02-15 00:52:49.000000', 'temperatura', 40.0000, 'ºC'),
	(62083, 110, '2015-02-15 00:52:50.000000', 'temperatura', 305.0000, 'ºC'),
	(62084, 110, '2015-02-15 00:52:51.000000', 'temperatura', 206.0000, 'ºC'),
	(62085, 110, '2015-02-15 00:52:52.000000', 'temperatura', 117.0000, 'ºC'),
	(62086, 110, '2015-02-15 00:52:53.000000', 'temperatura', 1165.0000, 'ºC'),
	(62087, 110, '2015-02-15 00:52:54.000000', 'temperatura', 674.0000, 'ºC'),
	(62088, 110, '2015-02-15 00:52:55.000000', 'temperatura', 1079.0000, 'ºC'),
	(62089, 110, '2015-02-15 00:52:56.000000', 'temperatura', 971.0000, 'ºC'),
	(62090, 110, '2015-02-15 00:52:57.000000', 'temperatura', 419.0000, 'ºC'),
	(62091, 110, '2015-02-15 00:52:58.000000', 'temperatura', 381.0000, 'ºC'),
	(62092, 110, '2015-02-15 00:52:59.000000', 'temperatura', 649.0000, 'ºC'),
	(62093, 110, '2015-02-15 00:53:00.000000', 'temperatura', 904.0000, 'ºC'),
	(62094, 110, '2015-02-15 00:53:01.000000', 'temperatura', 173.0000, 'ºC'),
	(62095, 110, '2015-02-15 00:53:02.000000', 'temperatura', 553.0000, 'ºC'),
	(62096, 110, '2015-02-15 00:53:03.000000', 'temperatura', 1045.0000, 'ºC'),
	(62097, 110, '2015-02-15 00:53:04.000000', 'temperatura', 1170.0000, 'ºC'),
	(62098, 110, '2015-02-15 00:53:05.000000', 'temperatura', 313.0000, 'ºC'),
	(62099, 110, '2015-02-15 00:53:06.000000', 'temperatura', 455.0000, 'ºC'),
	(62100, 110, '2015-02-15 00:53:07.000000', 'temperatura', 139.0000, 'ºC'),
	(62101, 110, '2015-02-15 00:53:08.000000', 'temperatura', 530.0000, 'ºC'),
	(62102, 110, '2015-02-15 00:53:09.000000', 'temperatura', 1034.0000, 'ºC'),
	(62103, 110, '2015-02-15 00:53:10.000000', 'temperatura', 1178.0000, 'ºC'),
	(62104, 110, '2015-02-15 00:53:11.000000', 'temperatura', 391.0000, 'ºC'),
	(62105, 110, '2015-02-15 00:53:12.000000', 'temperatura', 820.0000, 'ºC'),
	(62106, 110, '2015-02-15 00:53:13.000000', 'temperatura', 528.0000, 'ºC'),
	(62107, 110, '2015-02-15 00:53:14.000000', 'temperatura', 180.0000, 'ºC'),
	(62108, 110, '2015-02-15 00:53:15.000000', 'temperatura', 519.0000, 'ºC'),
	(62109, 110, '2015-02-15 00:53:16.000000', 'temperatura', 854.0000, 'ºC'),
	(62110, 110, '2015-02-15 00:53:17.000000', 'temperatura', 313.0000, 'ºC'),
	(62111, 110, '2015-02-15 00:53:18.000000', 'temperatura', 203.0000, 'ºC'),
	(62112, 110, '2015-02-15 00:53:19.000000', 'temperatura', 75.0000, 'ºC'),
	(62113, 110, '2015-02-15 00:53:20.000000', 'temperatura', 969.0000, 'ºC'),
	(62114, 110, '2015-02-15 00:53:21.000000', 'temperatura', 1018.0000, 'ºC'),
	(62115, 110, '2015-02-15 00:53:22.000000', 'temperatura', 984.0000, 'ºC'),
	(62116, 110, '2015-02-15 00:53:23.000000', 'temperatura', 668.0000, 'ºC'),
	(62117, 110, '2015-02-15 00:53:24.000000', 'temperatura', 386.0000, 'ºC'),
	(62118, 110, '2015-02-15 00:53:25.000000', 'temperatura', 1128.0000, 'ºC'),
	(62119, 110, '2015-02-15 00:53:26.000000', 'temperatura', 884.0000, 'ºC'),
	(62120, 110, '2015-02-15 00:53:27.000000', 'temperatura', 1035.0000, 'ºC'),
	(62121, 110, '2015-02-15 00:53:28.000000', 'temperatura', 123.0000, 'ºC'),
	(62122, 110, '2015-02-15 00:53:29.000000', 'temperatura', 1112.0000, 'ºC'),
	(62123, 110, '2015-02-15 00:53:30.000000', 'temperatura', 393.0000, 'ºC'),
	(62124, 110, '2015-02-15 00:53:31.000000', 'temperatura', 1027.0000, 'ºC'),
	(62125, 110, '2015-02-15 00:53:32.000000', 'temperatura', 355.0000, 'ºC'),
	(62126, 110, '2015-02-15 00:53:33.000000', 'temperatura', 1098.0000, 'ºC'),
	(62127, 110, '2015-02-15 00:53:34.000000', 'temperatura', 824.0000, 'ºC'),
	(62128, 110, '2015-02-15 00:53:35.000000', 'temperatura', 828.0000, 'ºC'),
	(62129, 110, '2015-02-15 00:53:36.000000', 'temperatura', 466.0000, 'ºC'),
	(62130, 110, '2015-02-15 00:53:37.000000', 'temperatura', 1046.0000, 'ºC'),
	(62131, 110, '2015-02-15 00:53:38.000000', 'temperatura', 234.0000, 'ºC'),
	(62132, 110, '2015-02-15 00:53:39.000000', 'temperatura', 433.0000, 'ºC'),
	(62133, 110, '2015-02-15 00:53:40.000000', 'temperatura', 261.0000, 'ºC'),
	(62134, 110, '2015-02-15 00:53:41.000000', 'temperatura', 9.0000, 'ºC'),
	(62135, 110, '2015-02-15 00:53:42.000000', 'temperatura', 460.0000, 'ºC'),
	(62136, 110, '2015-02-15 00:53:43.000000', 'temperatura', 1073.0000, 'ºC'),
	(62137, 110, '2015-02-15 00:53:44.000000', 'temperatura', 386.0000, 'ºC'),
	(62138, 110, '2015-02-15 00:53:45.000000', 'temperatura', 1112.0000, 'ºC'),
	(62139, 110, '2015-02-15 00:53:46.000000', 'temperatura', 804.0000, 'ºC'),
	(62140, 110, '2015-02-15 00:53:47.000000', 'temperatura', 685.0000, 'ºC'),
	(62141, 110, '2015-02-15 00:53:48.000000', 'temperatura', 1014.0000, 'ºC'),
	(62142, 110, '2015-02-15 00:53:49.000000', 'temperatura', 616.0000, 'ºC'),
	(62143, 110, '2015-02-15 00:53:50.000000', 'temperatura', 38.0000, 'ºC'),
	(62144, 110, '2015-02-15 00:53:51.000000', 'temperatura', 740.0000, 'ºC'),
	(62145, 110, '2015-02-15 00:53:52.000000', 'temperatura', 1190.0000, 'ºC'),
	(62146, 110, '2015-02-15 00:53:53.000000', 'temperatura', 128.0000, 'ºC'),
	(62147, 110, '2015-02-15 00:53:54.000000', 'temperatura', 670.0000, 'ºC'),
	(62148, 110, '2015-02-15 00:53:55.000000', 'temperatura', 565.0000, 'ºC'),
	(62149, 110, '2015-02-15 00:53:56.000000', 'temperatura', 819.0000, 'ºC'),
	(62150, 110, '2015-02-15 00:53:57.000000', 'temperatura', 1198.0000, 'ºC'),
	(62151, 110, '2015-02-15 00:53:58.000000', 'temperatura', 1133.0000, 'ºC'),
	(62152, 110, '2015-02-15 00:53:59.000000', 'temperatura', 871.0000, 'ºC'),
	(62153, 110, '2015-02-15 00:54:00.000000', 'temperatura', 959.0000, 'ºC'),
	(62154, 110, '2015-02-15 00:54:01.000000', 'temperatura', 981.0000, 'ºC'),
	(62155, 110, '2015-02-15 00:54:02.000000', 'temperatura', 831.0000, 'ºC'),
	(62156, 110, '2015-02-15 00:54:03.000000', 'temperatura', 10.0000, 'ºC'),
	(62157, 110, '2015-02-15 00:54:04.000000', 'temperatura', 1159.0000, 'ºC'),
	(62158, 110, '2015-02-15 00:54:05.000000', 'temperatura', 966.0000, 'ºC'),
	(62159, 110, '2015-02-15 00:54:06.000000', 'temperatura', 153.0000, 'ºC'),
	(62160, 110, '2015-02-15 00:54:07.000000', 'temperatura', 269.0000, 'ºC'),
	(62161, 110, '2015-02-15 00:54:08.000000', 'temperatura', 886.0000, 'ºC'),
	(62162, 110, '2015-02-15 00:54:09.000000', 'temperatura', 22.0000, 'ºC'),
	(62163, 110, '2015-02-15 00:54:10.000000', 'temperatura', 1053.0000, 'ºC'),
	(62164, 110, '2015-02-15 00:54:11.000000', 'temperatura', 399.0000, 'ºC'),
	(62165, 110, '2015-02-15 00:54:12.000000', 'temperatura', 37.0000, 'ºC'),
	(62166, 110, '2015-02-15 00:54:13.000000', 'temperatura', 188.0000, 'ºC'),
	(62167, 110, '2015-02-15 00:54:14.000000', 'temperatura', 831.0000, 'ºC'),
	(62168, 110, '2015-02-15 00:54:15.000000', 'temperatura', 1189.0000, 'ºC'),
	(62169, 110, '2015-02-15 00:54:16.000000', 'temperatura', 1054.0000, 'ºC'),
	(62170, 110, '2015-02-15 00:54:17.000000', 'temperatura', 502.0000, 'ºC'),
	(62171, 110, '2015-02-15 00:54:18.000000', 'temperatura', 550.0000, 'ºC'),
	(62172, 110, '2015-02-15 00:54:19.000000', 'temperatura', 44.0000, 'ºC'),
	(62173, 110, '2015-02-15 00:54:20.000000', 'temperatura', 969.0000, 'ºC'),
	(62174, 110, '2015-02-15 00:54:21.000000', 'temperatura', 1115.0000, 'ºC'),
	(62175, 110, '2015-02-15 00:54:22.000000', 'temperatura', 267.0000, 'ºC'),
	(62176, 110, '2015-02-15 00:54:23.000000', 'temperatura', 392.0000, 'ºC'),
	(62177, 110, '2015-02-15 00:54:24.000000', 'temperatura', 1159.0000, 'ºC'),
	(62178, 110, '2015-02-15 00:54:25.000000', 'temperatura', 1020.0000, 'ºC'),
	(62179, 110, '2015-02-15 00:54:26.000000', 'temperatura', 424.0000, 'ºC'),
	(62180, 110, '2015-02-15 00:54:27.000000', 'temperatura', 260.0000, 'ºC'),
	(62181, 110, '2015-02-15 00:54:28.000000', 'temperatura', 30.0000, 'ºC'),
	(62182, 110, '2015-02-15 00:54:29.000000', 'temperatura', 569.0000, 'ºC'),
	(62183, 110, '2015-02-15 00:54:30.000000', 'temperatura', 357.0000, 'ºC'),
	(62184, 110, '2015-02-15 00:54:31.000000', 'temperatura', 76.0000, 'ºC'),
	(62185, 110, '2015-02-15 00:54:32.000000', 'temperatura', 511.0000, 'ºC'),
	(62186, 110, '2015-02-15 00:54:33.000000', 'temperatura', 1125.0000, 'ºC'),
	(62187, 110, '2015-02-15 00:54:34.000000', 'temperatura', 495.0000, 'ºC'),
	(62188, 110, '2015-02-15 00:54:35.000000', 'temperatura', 300.0000, 'ºC'),
	(62189, 110, '2015-02-15 00:54:36.000000', 'temperatura', 14.0000, 'ºC'),
	(62190, 110, '2015-02-15 00:54:37.000000', 'temperatura', 369.0000, 'ºC'),
	(62191, 110, '2015-02-15 00:54:38.000000', 'temperatura', 607.0000, 'ºC'),
	(62192, 110, '2015-02-15 00:54:39.000000', 'temperatura', 726.0000, 'ºC'),
	(62193, 110, '2015-02-15 00:54:40.000000', 'temperatura', 612.0000, 'ºC'),
	(62194, 110, '2015-02-15 00:54:41.000000', 'temperatura', 883.0000, 'ºC'),
	(62195, 110, '2015-02-15 00:54:42.000000', 'temperatura', 179.0000, 'ºC'),
	(62196, 110, '2015-02-15 00:54:43.000000', 'temperatura', 645.0000, 'ºC'),
	(62197, 110, '2015-02-15 00:54:44.000000', 'temperatura', 288.0000, 'ºC'),
	(62198, 110, '2015-02-15 00:54:45.000000', 'temperatura', 707.0000, 'ºC'),
	(62199, 110, '2015-02-15 00:54:46.000000', 'temperatura', 270.0000, 'ºC'),
	(62200, 110, '2015-02-15 00:54:47.000000', 'temperatura', 431.0000, 'ºC'),
	(62201, 110, '2015-02-15 00:54:48.000000', 'temperatura', 145.0000, 'ºC'),
	(62202, 110, '2015-02-15 00:54:49.000000', 'temperatura', 634.0000, 'ºC'),
	(62203, 110, '2015-02-15 00:54:50.000000', 'temperatura', 336.0000, 'ºC'),
	(62204, 110, '2015-02-15 00:54:51.000000', 'temperatura', 976.0000, 'ºC'),
	(62205, 110, '2015-02-15 00:54:52.000000', 'temperatura', 273.0000, 'ºC'),
	(62206, 110, '2015-02-15 00:54:53.000000', 'temperatura', 836.0000, 'ºC'),
	(62207, 110, '2015-02-15 00:54:54.000000', 'temperatura', 962.0000, 'ºC'),
	(62208, 110, '2015-02-15 00:54:55.000000', 'temperatura', 1103.0000, 'ºC'),
	(62209, 110, '2015-02-15 00:54:56.000000', 'temperatura', 229.0000, 'ºC'),
	(62210, 110, '2015-02-15 00:54:57.000000', 'temperatura', 235.0000, 'ºC'),
	(62211, 110, '2015-02-15 00:54:58.000000', 'temperatura', 491.0000, 'ºC'),
	(62212, 110, '2015-02-15 00:54:59.000000', 'temperatura', 549.0000, 'ºC'),
	(62213, 110, '2015-02-15 00:55:00.000000', 'temperatura', 71.0000, 'ºC'),
	(62214, 110, '2015-02-15 00:55:01.000000', 'temperatura', 1111.0000, 'ºC'),
	(62215, 110, '2015-02-15 00:55:02.000000', 'temperatura', 543.0000, 'ºC'),
	(62216, 110, '2015-02-15 00:55:03.000000', 'temperatura', 580.0000, 'ºC'),
	(62217, 110, '2015-02-15 00:55:04.000000', 'temperatura', 73.0000, 'ºC'),
	(62218, 110, '2015-02-15 00:55:05.000000', 'temperatura', 1026.0000, 'ºC'),
	(62219, 110, '2015-02-15 00:55:06.000000', 'temperatura', 111.0000, 'ºC'),
	(62220, 110, '2015-02-15 00:55:07.000000', 'temperatura', 1076.0000, 'ºC'),
	(62221, 110, '2015-02-15 00:55:08.000000', 'temperatura', 250.0000, 'ºC'),
	(62222, 110, '2015-02-15 00:55:09.000000', 'temperatura', 419.0000, 'ºC'),
	(62223, 110, '2015-02-15 00:55:10.000000', 'temperatura', 149.0000, 'ºC'),
	(62224, 110, '2015-02-15 00:55:11.000000', 'temperatura', 688.0000, 'ºC'),
	(62225, 110, '2015-02-15 00:55:12.000000', 'temperatura', 593.0000, 'ºC'),
	(62226, 110, '2015-02-15 00:55:13.000000', 'temperatura', 900.0000, 'ºC'),
	(62227, 110, '2015-02-15 00:55:14.000000', 'temperatura', 323.0000, 'ºC'),
	(62228, 110, '2015-02-15 00:55:15.000000', 'temperatura', 117.0000, 'ºC'),
	(62229, 110, '2015-02-15 00:55:16.000000', 'temperatura', 815.0000, 'ºC'),
	(62230, 110, '2015-02-15 00:55:17.000000', 'temperatura', 126.0000, 'ºC'),
	(62231, 110, '2015-02-15 00:55:18.000000', 'temperatura', 584.0000, 'ºC'),
	(62232, 110, '2015-02-15 00:55:19.000000', 'temperatura', 142.0000, 'ºC'),
	(62233, 110, '2015-02-15 00:55:20.000000', 'temperatura', 161.0000, 'ºC'),
	(62234, 110, '2015-02-15 00:55:21.000000', 'temperatura', 377.0000, 'ºC'),
	(62235, 110, '2015-02-15 00:55:22.000000', 'temperatura', 205.0000, 'ºC'),
	(62236, 110, '2015-02-15 00:55:23.000000', 'temperatura', 1095.0000, 'ºC'),
	(62237, 110, '2015-02-15 00:55:24.000000', 'temperatura', 61.0000, 'ºC'),
	(62238, 110, '2015-02-15 00:55:25.000000', 'temperatura', 618.0000, 'ºC'),
	(62239, 110, '2015-02-15 00:55:26.000000', 'temperatura', 508.0000, 'ºC'),
	(62240, 110, '2015-02-15 00:55:27.000000', 'temperatura', 688.0000, 'ºC'),
	(62241, 110, '2015-02-15 00:55:28.000000', 'temperatura', 717.0000, 'ºC'),
	(62242, 110, '2015-02-15 00:55:29.000000', 'temperatura', 322.0000, 'ºC'),
	(62243, 110, '2015-02-15 00:55:30.000000', 'temperatura', 657.0000, 'ºC'),
	(62244, 110, '2015-02-15 00:55:31.000000', 'temperatura', 1120.0000, 'ºC'),
	(62245, 110, '2015-02-15 00:55:32.000000', 'temperatura', 29.0000, 'ºC'),
	(62246, 110, '2015-02-15 00:55:33.000000', 'temperatura', 385.0000, 'ºC'),
	(62247, 110, '2015-02-15 00:55:34.000000', 'temperatura', 637.0000, 'ºC'),
	(62248, 110, '2015-02-15 00:55:35.000000', 'temperatura', 833.0000, 'ºC'),
	(62249, 110, '2015-02-15 00:55:36.000000', 'temperatura', 1053.0000, 'ºC'),
	(62250, 110, '2015-02-15 00:55:37.000000', 'temperatura', 368.0000, 'ºC'),
	(62251, 110, '2015-02-15 00:55:38.000000', 'temperatura', 1081.0000, 'ºC'),
	(62252, 110, '2015-02-15 00:55:39.000000', 'temperatura', 703.0000, 'ºC'),
	(62253, 110, '2015-02-15 00:55:40.000000', 'temperatura', 272.0000, 'ºC'),
	(62254, 110, '2015-02-15 00:55:41.000000', 'temperatura', 452.0000, 'ºC'),
	(62255, 110, '2015-02-15 00:55:42.000000', 'temperatura', 242.0000, 'ºC'),
	(62256, 110, '2015-02-15 00:55:43.000000', 'temperatura', 1056.0000, 'ºC'),
	(62257, 110, '2015-02-15 00:55:44.000000', 'temperatura', 955.0000, 'ºC'),
	(62258, 110, '2015-02-15 00:55:45.000000', 'temperatura', 407.0000, 'ºC'),
	(62259, 110, '2015-02-15 00:55:46.000000', 'temperatura', 370.0000, 'ºC'),
	(62260, 110, '2015-02-15 00:55:47.000000', 'temperatura', 632.0000, 'ºC'),
	(62261, 110, '2015-02-15 00:55:48.000000', 'temperatura', 849.0000, 'ºC'),
	(62262, 110, '2015-02-15 00:55:49.000000', 'temperatura', 1148.0000, 'ºC'),
	(62263, 110, '2015-02-15 00:55:50.000000', 'temperatura', 795.0000, 'ºC'),
	(62264, 110, '2015-02-15 00:55:51.000000', 'temperatura', 532.0000, 'ºC'),
	(62265, 110, '2015-02-15 00:55:52.000000', 'temperatura', 275.0000, 'ºC'),
	(62266, 110, '2015-02-15 00:55:53.000000', 'temperatura', 978.0000, 'ºC'),
	(62267, 110, '2015-02-15 00:55:54.000000', 'temperatura', 468.0000, 'ºC'),
	(62268, 110, '2015-02-15 00:55:55.000000', 'temperatura', 606.0000, 'ºC'),
	(62269, 110, '2015-02-15 00:55:56.000000', 'temperatura', 428.0000, 'ºC'),
	(62270, 110, '2015-02-15 00:55:57.000000', 'temperatura', 322.0000, 'ºC'),
	(62271, 110, '2015-02-15 00:55:58.000000', 'temperatura', 324.0000, 'ºC'),
	(62272, 110, '2015-02-15 00:55:59.000000', 'temperatura', 656.0000, 'ºC'),
	(62273, 110, '2015-02-15 00:56:00.000000', 'temperatura', 1108.0000, 'ºC'),
	(62274, 110, '2015-02-15 00:56:01.000000', 'temperatura', 1175.0000, 'ºC'),
	(62275, 110, '2015-02-15 00:56:02.000000', 'temperatura', 149.0000, 'ºC'),
	(62276, 110, '2015-02-15 00:56:03.000000', 'temperatura', 823.0000, 'ºC'),
	(62277, 110, '2015-02-15 00:56:04.000000', 'temperatura', 67.0000, 'ºC'),
	(62278, 110, '2015-02-15 00:56:05.000000', 'temperatura', 266.0000, 'ºC'),
	(62279, 110, '2015-02-15 00:56:06.000000', 'temperatura', 1130.0000, 'ºC'),
	(62280, 110, '2015-02-15 00:56:07.000000', 'temperatura', 52.0000, 'ºC'),
	(62281, 110, '2015-02-15 00:56:08.000000', 'temperatura', 473.0000, 'ºC'),
	(62282, 110, '2015-02-15 00:56:09.000000', 'temperatura', 1008.0000, 'ºC'),
	(62283, 110, '2015-02-15 00:56:10.000000', 'temperatura', 21.0000, 'ºC'),
	(62284, 110, '2015-02-15 00:56:11.000000', 'temperatura', 680.0000, 'ºC'),
	(62285, 110, '2015-02-15 00:56:12.000000', 'temperatura', 939.0000, 'ºC'),
	(62286, 110, '2015-02-15 00:56:13.000000', 'temperatura', 257.0000, 'ºC'),
	(62287, 110, '2015-02-15 00:56:14.000000', 'temperatura', 868.0000, 'ºC'),
	(62288, 110, '2015-02-15 00:56:15.000000', 'temperatura', 1171.0000, 'ºC'),
	(62289, 110, '2015-02-15 00:56:16.000000', 'temperatura', 850.0000, 'ºC'),
	(62290, 110, '2015-02-15 00:56:17.000000', 'temperatura', 736.0000, 'ºC'),
	(62291, 110, '2015-02-15 00:56:18.000000', 'temperatura', 1133.0000, 'ºC'),
	(62292, 110, '2015-02-15 00:56:19.000000', 'temperatura', 1054.0000, 'ºC'),
	(62293, 110, '2015-02-15 00:56:20.000000', 'temperatura', 675.0000, 'ºC'),
	(62294, 110, '2015-02-15 00:56:21.000000', 'temperatura', 214.0000, 'ºC'),
	(62295, 110, '2015-02-15 00:56:22.000000', 'temperatura', 244.0000, 'ºC'),
	(62296, 110, '2015-02-15 00:56:23.000000', 'temperatura', 579.0000, 'ºC'),
	(62297, 110, '2015-02-15 00:56:24.000000', 'temperatura', 964.0000, 'ºC'),
	(62298, 110, '2015-02-15 00:56:25.000000', 'temperatura', 683.0000, 'ºC'),
	(62299, 110, '2015-02-15 00:56:26.000000', 'temperatura', 525.0000, 'ºC'),
	(62300, 110, '2015-02-15 00:56:27.000000', 'temperatura', 577.0000, 'ºC'),
	(62301, 110, '2015-02-15 00:56:28.000000', 'temperatura', 111.0000, 'ºC'),
	(62302, 110, '2015-02-15 00:56:29.000000', 'temperatura', 25.0000, 'ºC'),
	(62303, 110, '2015-02-15 00:56:30.000000', 'temperatura', 992.0000, 'ºC'),
	(62304, 110, '2015-02-15 00:56:31.000000', 'temperatura', 85.0000, 'ºC'),
	(62305, 110, '2015-02-15 00:56:32.000000', 'temperatura', 1048.0000, 'ºC'),
	(62306, 110, '2015-02-15 00:56:33.000000', 'temperatura', 187.0000, 'ºC'),
	(62307, 110, '2015-02-15 00:56:34.000000', 'temperatura', 189.0000, 'ºC'),
	(62308, 110, '2015-02-15 00:56:35.000000', 'temperatura', 386.0000, 'ºC'),
	(62309, 110, '2015-02-15 00:56:36.000000', 'temperatura', 166.0000, 'ºC'),
	(62310, 110, '2015-02-15 00:56:37.000000', 'temperatura', 869.0000, 'ºC'),
	(62311, 110, '2015-02-15 00:56:38.000000', 'temperatura', 248.0000, 'ºC'),
	(62312, 110, '2015-02-15 00:56:39.000000', 'temperatura', 1033.0000, 'ºC'),
	(62313, 110, '2015-02-15 00:56:40.000000', 'temperatura', 823.0000, 'ºC'),
	(62314, 110, '2015-02-15 00:56:41.000000', 'temperatura', 1017.0000, 'ºC'),
	(62315, 110, '2015-02-15 00:56:42.000000', 'temperatura', 214.0000, 'ºC'),
	(62316, 110, '2015-02-15 00:56:43.000000', 'temperatura', 422.0000, 'ºC'),
	(62317, 110, '2015-02-15 00:56:44.000000', 'temperatura', 267.0000, 'ºC'),
	(62318, 110, '2015-02-15 00:56:45.000000', 'temperatura', 69.0000, 'ºC'),
	(62319, 110, '2015-02-15 00:56:46.000000', 'temperatura', 744.0000, 'ºC'),
	(62320, 110, '2015-02-15 00:56:47.000000', 'temperatura', 1116.0000, 'ºC'),
	(62321, 110, '2015-02-15 00:56:48.000000', 'temperatura', 949.0000, 'ºC'),
	(62322, 110, '2015-02-15 00:56:49.000000', 'temperatura', 196.0000, 'ºC'),
	(62323, 110, '2015-02-15 00:56:50.000000', 'temperatura', 534.0000, 'ºC'),
	(62324, 110, '2015-02-15 00:56:51.000000', 'temperatura', 883.0000, 'ºC'),
	(62325, 110, '2015-02-15 00:56:52.000000', 'temperatura', 412.0000, 'ºC'),
	(62326, 110, '2015-02-15 00:56:53.000000', 'temperatura', 611.0000, 'ºC'),
	(62327, 110, '2015-02-15 00:56:54.000000', 'temperatura', 621.0000, 'ºC'),
	(62328, 110, '2015-02-15 00:56:55.000000', 'temperatura', 72.0000, 'ºC'),
	(62329, 110, '2015-02-15 00:56:56.000000', 'temperatura', 896.0000, 'ºC'),
	(62330, 110, '2015-02-15 00:56:57.000000', 'temperatura', 667.0000, 'ºC'),
	(62331, 110, '2015-02-15 00:56:58.000000', 'temperatura', 646.0000, 'ºC'),
	(62332, 110, '2015-02-15 00:56:59.000000', 'temperatura', 32.0000, 'ºC'),
	(62333, 110, '2015-02-15 00:57:00.000000', 'temperatura', 620.0000, 'ºC'),
	(62334, 110, '2015-02-15 00:57:01.000000', 'temperatura', 606.0000, 'ºC'),
	(62335, 110, '2015-02-15 00:57:02.000000', 'temperatura', 1172.0000, 'ºC'),
	(62336, 110, '2015-02-15 00:57:03.000000', 'temperatura', 440.0000, 'ºC'),
	(62337, 110, '2015-02-15 00:57:04.000000', 'temperatura', 1087.0000, 'ºC'),
	(62338, 110, '2015-02-15 00:57:05.000000', 'temperatura', 513.0000, 'ºC'),
	(62339, 110, '2015-02-15 00:57:06.000000', 'temperatura', 507.0000, 'ºC'),
	(62340, 110, '2015-02-15 00:57:07.000000', 'temperatura', 997.0000, 'ºC'),
	(62341, 110, '2015-02-15 00:57:08.000000', 'temperatura', 1065.0000, 'ºC'),
	(62342, 110, '2015-02-15 00:57:09.000000', 'temperatura', 1133.0000, 'ºC'),
	(62343, 110, '2015-02-15 00:57:10.000000', 'temperatura', 69.0000, 'ºC'),
	(62344, 110, '2015-02-15 00:57:11.000000', 'temperatura', 549.0000, 'ºC'),
	(62345, 110, '2015-02-15 00:57:12.000000', 'temperatura', 138.0000, 'ºC'),
	(62346, 110, '2015-02-15 00:57:13.000000', 'temperatura', 242.0000, 'ºC'),
	(62347, 110, '2015-02-15 00:57:14.000000', 'temperatura', 799.0000, 'ºC'),
	(62348, 110, '2015-02-15 00:57:15.000000', 'temperatura', 869.0000, 'ºC'),
	(62349, 110, '2015-02-15 00:57:16.000000', 'temperatura', 746.0000, 'ºC'),
	(62350, 110, '2015-02-15 00:57:17.000000', 'temperatura', 1125.0000, 'ºC'),
	(62351, 110, '2015-02-15 00:57:18.000000', 'temperatura', 986.0000, 'ºC'),
	(62352, 110, '2015-02-15 00:57:19.000000', 'temperatura', 355.0000, 'ºC'),
	(62353, 110, '2015-02-15 00:57:20.000000', 'temperatura', 18.0000, 'ºC'),
	(62354, 110, '2015-02-15 00:57:21.000000', 'temperatura', 225.0000, 'ºC'),
	(62355, 110, '2015-02-15 00:57:22.000000', 'temperatura', 1072.0000, 'ºC'),
	(62356, 110, '2015-02-15 00:57:23.000000', 'temperatura', 1084.0000, 'ºC'),
	(62357, 110, '2015-02-15 00:57:24.000000', 'temperatura', 1005.0000, 'ºC'),
	(62358, 110, '2015-02-15 00:57:25.000000', 'temperatura', 573.0000, 'ºC'),
	(62359, 110, '2015-02-15 00:57:26.000000', 'temperatura', 1052.0000, 'ºC'),
	(62360, 110, '2015-02-15 00:57:27.000000', 'temperatura', 1141.0000, 'ºC'),
	(62361, 110, '2015-02-15 00:57:28.000000', 'temperatura', 148.0000, 'ºC'),
	(62362, 110, '2015-02-15 00:57:29.000000', 'temperatura', 920.0000, 'ºC'),
	(62363, 110, '2015-02-15 00:57:30.000000', 'temperatura', 557.0000, 'ºC'),
	(62364, 110, '2015-02-15 00:57:31.000000', 'temperatura', 24.0000, 'ºC'),
	(62365, 110, '2015-02-15 00:57:32.000000', 'temperatura', 850.0000, 'ºC'),
	(62366, 110, '2015-02-15 00:57:33.000000', 'temperatura', 577.0000, 'ºC'),
	(62367, 110, '2015-02-15 00:57:34.000000', 'temperatura', 335.0000, 'ºC'),
	(62368, 110, '2015-02-15 00:57:35.000000', 'temperatura', 1144.0000, 'ºC'),
	(62369, 110, '2015-02-15 00:57:36.000000', 'temperatura', 1117.0000, 'ºC'),
	(62370, 110, '2015-02-15 00:57:37.000000', 'temperatura', 951.0000, 'ºC'),
	(62371, 110, '2015-02-15 00:57:38.000000', 'temperatura', 208.0000, 'ºC'),
	(62372, 110, '2015-02-15 00:57:39.000000', 'temperatura', 586.0000, 'ºC'),
	(62373, 110, '2015-02-15 00:57:40.000000', 'temperatura', 1105.0000, 'ºC'),
	(62374, 110, '2015-02-15 00:57:41.000000', 'temperatura', 169.0000, 'ºC'),
	(62375, 110, '2015-02-15 00:57:42.000000', 'temperatura', 1132.0000, 'ºC'),
	(62376, 110, '2015-02-15 00:57:43.000000', 'temperatura', 353.0000, 'ºC'),
	(62377, 110, '2015-02-15 00:57:44.000000', 'temperatura', 769.0000, 'ºC'),
	(62378, 110, '2015-02-15 00:57:45.000000', 'temperatura', 387.0000, 'ºC'),
	(62379, 110, '2015-02-15 00:57:46.000000', 'temperatura', 828.0000, 'ºC'),
	(62380, 110, '2015-02-15 00:57:47.000000', 'temperatura', 582.0000, 'ºC'),
	(62381, 110, '2015-02-15 00:57:48.000000', 'temperatura', 424.0000, 'ºC'),
	(62382, 110, '2015-02-15 00:57:49.000000', 'temperatura', 374.0000, 'ºC'),
	(62383, 110, '2015-02-15 00:57:50.000000', 'temperatura', 599.0000, 'ºC'),
	(62384, 110, '2015-02-15 00:57:51.000000', 'temperatura', 673.0000, 'ºC'),
	(62385, 110, '2015-02-15 00:57:52.000000', 'temperatura', 369.0000, 'ºC'),
	(62386, 110, '2015-02-15 00:57:53.000000', 'temperatura', 1027.0000, 'ºC'),
	(62387, 110, '2015-02-15 00:57:54.000000', 'temperatura', 428.0000, 'ºC'),
	(62388, 110, '2015-02-15 00:57:55.000000', 'temperatura', 261.0000, 'ºC'),
	(62389, 110, '2015-02-15 00:57:56.000000', 'temperatura', 21.0000, 'ºC'),
	(62390, 110, '2015-02-15 00:57:57.000000', 'temperatura', 521.0000, 'ºC'),
	(62391, 110, '2015-02-15 00:57:58.000000', 'temperatura', 144.0000, 'ºC'),
	(62392, 110, '2015-02-15 00:57:59.000000', 'temperatura', 359.0000, 'ºC'),
	(62393, 110, '2015-02-15 00:58:00.000000', 'temperatura', 160.0000, 'ºC'),
	(62394, 110, '2015-02-15 00:58:01.000000', 'temperatura', 926.0000, 'ºC'),
	(62395, 110, '2015-02-15 00:58:02.000000', 'temperatura', 549.0000, 'ºC'),
	(62396, 110, '2015-02-15 00:58:03.000000', 'temperatura', 1168.0000, 'ºC'),
	(62397, 110, '2015-02-15 00:58:04.000000', 'temperatura', 593.0000, 'ºC'),
	(62398, 110, '2015-02-15 00:58:05.000000', 'temperatura', 661.0000, 'ºC'),
	(62399, 110, '2015-02-15 00:58:06.000000', 'temperatura', 328.0000, 'ºC'),
	(62400, 110, '2015-02-15 00:58:07.000000', 'temperatura', 858.0000, 'ºC'),
	(62401, 110, '2015-02-15 00:58:08.000000', 'temperatura', 904.0000, 'ºC'),
	(62402, 110, '2015-02-15 00:58:09.000000', 'temperatura', 748.0000, 'ºC'),
	(62403, 110, '2015-02-15 00:58:10.000000', 'temperatura', 1029.0000, 'ºC'),
	(62404, 110, '2015-02-15 00:58:11.000000', 'temperatura', 501.0000, 'ºC'),
	(62405, 110, '2015-02-15 00:58:12.000000', 'temperatura', 617.0000, 'ºC'),
	(62406, 110, '2015-02-15 00:58:13.000000', 'temperatura', 384.0000, 'ºC'),
	(62407, 110, '2015-02-15 00:58:14.000000', 'temperatura', 68.0000, 'ºC'),
	(62408, 110, '2015-02-15 00:58:15.000000', 'temperatura', 391.0000, 'ºC'),
	(62409, 110, '2015-02-15 00:58:16.000000', 'temperatura', 550.0000, 'ºC'),
	(62410, 110, '2015-02-15 00:58:17.000000', 'temperatura', 376.0000, 'ºC'),
	(62411, 110, '2015-02-15 00:58:18.000000', 'temperatura', 234.0000, 'ºC'),
	(62412, 110, '2015-02-15 00:58:19.000000', 'temperatura', 39.0000, 'ºC'),
	(62413, 110, '2015-02-15 00:58:20.000000', 'temperatura', 697.0000, 'ºC'),
	(62414, 110, '2015-02-15 00:58:21.000000', 'temperatura', 966.0000, 'ºC'),
	(62415, 110, '2015-02-15 00:58:22.000000', 'temperatura', 341.0000, 'ºC'),
	(62416, 110, '2015-02-15 00:58:23.000000', 'temperatura', 7.0000, 'ºC'),
	(62417, 110, '2015-02-15 00:58:24.000000', 'temperatura', 214.0000, 'ºC'),
	(62418, 110, '2015-02-15 00:58:25.000000', 'temperatura', 1050.0000, 'ºC'),
	(62419, 110, '2015-02-15 00:58:26.000000', 'temperatura', 1006.0000, 'ºC'),
	(62420, 110, '2015-02-15 00:58:27.000000', 'temperatura', 681.0000, 'ºC'),
	(62421, 110, '2015-02-15 00:58:28.000000', 'temperatura', 386.0000, 'ºC'),
	(62422, 110, '2015-02-15 00:58:29.000000', 'temperatura', 1088.0000, 'ºC'),
	(62423, 110, '2015-02-15 00:58:30.000000', 'temperatura', 685.0000, 'ºC'),
	(62424, 110, '2015-02-15 00:58:31.000000', 'temperatura', 161.0000, 'ºC'),
	(62425, 110, '2015-02-15 00:58:32.000000', 'temperatura', 1148.0000, 'ºC'),
	(62426, 110, '2015-02-15 00:58:33.000000', 'temperatura', 459.0000, 'ºC'),
	(62427, 110, '2015-02-15 00:58:34.000000', 'temperatura', 52.0000, 'ºC'),
	(62428, 110, '2015-02-15 00:58:35.000000', 'temperatura', 81.0000, 'ºC'),
	(62429, 110, '2015-02-15 00:58:36.000000', 'temperatura', 251.0000, 'ºC'),
	(62430, 110, '2015-02-15 00:58:37.000000', 'temperatura', 1014.0000, 'ºC'),
	(62431, 110, '2015-02-15 00:58:38.000000', 'temperatura', 715.0000, 'ºC'),
	(62432, 110, '2015-02-15 00:58:39.000000', 'temperatura', 536.0000, 'ºC'),
	(62433, 110, '2015-02-15 00:58:40.000000', 'temperatura', 535.0000, 'ºC'),
	(62434, 110, '2015-02-15 00:58:41.000000', 'temperatura', 1068.0000, 'ºC'),
	(62435, 110, '2015-02-15 00:58:42.000000', 'temperatura', 133.0000, 'ºC'),
	(62436, 110, '2015-02-15 00:58:43.000000', 'temperatura', 1065.0000, 'ºC'),
	(62437, 110, '2015-02-15 00:58:44.000000', 'temperatura', 125.0000, 'ºC'),
	(62438, 110, '2015-02-15 00:58:45.000000', 'temperatura', 1029.0000, 'ºC'),
	(62439, 110, '2015-02-15 00:58:46.000000', 'temperatura', 1173.0000, 'ºC'),
	(62440, 110, '2015-02-15 00:58:47.000000', 'temperatura', 377.0000, 'ºC'),
	(62441, 110, '2015-02-15 00:58:48.000000', 'temperatura', 767.0000, 'ºC'),
	(62442, 110, '2015-02-15 00:58:49.000000', 'temperatura', 303.0000, 'ºC'),
	(62443, 110, '2015-02-15 00:58:50.000000', 'temperatura', 413.0000, 'ºC'),
	(62444, 110, '2015-02-15 00:58:51.000000', 'temperatura', 1160.0000, 'ºC'),
	(62445, 110, '2015-02-15 00:58:52.000000', 'temperatura', 960.0000, 'ºC'),
	(62446, 110, '2015-02-15 00:58:53.000000', 'temperatura', 119.0000, 'ºC'),
	(62447, 110, '2015-02-15 00:58:54.000000', 'temperatura', 115.0000, 'ºC'),
	(62448, 110, '2015-02-15 00:58:55.000000', 'temperatura', 221.0000, 'ºC'),
	(62449, 110, '2015-02-15 00:58:56.000000', 'temperatura', 760.0000, 'ºC'),
	(62450, 110, '2015-02-15 00:58:57.000000', 'temperatura', 737.0000, 'ºC'),
	(62451, 110, '2015-02-15 00:58:58.000000', 'temperatura', 204.0000, 'ºC'),
	(62452, 110, '2015-02-15 00:58:59.000000', 'temperatura', 12.0000, 'ºC'),
	(62453, 110, '2015-02-15 00:59:00.000000', 'temperatura', 650.0000, 'ºC'),
	(62454, 110, '2015-02-15 00:59:01.000000', 'temperatura', 811.0000, 'ºC'),
	(62455, 110, '2015-02-15 00:59:02.000000', 'temperatura', 909.0000, 'ºC'),
	(62456, 110, '2015-02-15 00:59:03.000000', 'temperatura', 910.0000, 'ºC'),
	(62457, 110, '2015-02-15 00:59:04.000000', 'temperatura', 624.0000, 'ºC'),
	(62458, 110, '2015-02-15 00:59:05.000000', 'temperatura', 392.0000, 'ºC'),
	(62459, 110, '2015-02-15 00:59:06.000000', 'temperatura', 90.0000, 'ºC'),
	(62460, 110, '2015-02-15 00:59:07.000000', 'temperatura', 471.0000, 'ºC'),
	(62461, 110, '2015-02-15 00:59:08.000000', 'temperatura', 886.0000, 'ºC'),
	(62462, 110, '2015-02-15 00:59:09.000000', 'temperatura', 619.0000, 'ºC'),
	(62463, 110, '2015-02-15 00:59:10.000000', 'temperatura', 437.0000, 'ºC'),
	(62464, 110, '2015-02-15 00:59:11.000000', 'temperatura', 329.0000, 'ºC'),
	(62465, 110, '2015-02-15 00:59:12.000000', 'temperatura', 333.0000, 'ºC'),
	(62466, 110, '2015-02-15 00:59:13.000000', 'temperatura', 679.0000, 'ºC'),
	(62467, 110, '2015-02-15 00:59:14.000000', 'temperatura', 1195.0000, 'ºC'),
	(62468, 110, '2015-02-15 00:59:15.000000', 'temperatura', 338.0000, 'ºC'),
	(62469, 110, '2015-02-15 00:59:16.000000', 'temperatura', 508.0000, 'ºC'),
	(62470, 110, '2015-02-15 00:59:17.000000', 'temperatura', 325.0000, 'ºC'),
	(62471, 110, '2015-02-15 00:59:18.000000', 'temperatura', 101.0000, 'ºC'),
	(62472, 110, '2015-02-15 00:59:19.000000', 'temperatura', 732.0000, 'ºC'),
	(62473, 110, '2015-02-15 00:59:20.000000', 'temperatura', 959.0000, 'ºC'),
	(62474, 110, '2015-02-15 00:59:21.000000', 'temperatura', 197.0000, 'ºC'),
	(62475, 110, '2015-02-15 00:59:22.000000', 'temperatura', 510.0000, 'ºC'),
	(62476, 110, '2015-02-15 00:59:23.000000', 'temperatura', 757.0000, 'ºC'),
	(62477, 110, '2015-02-15 00:59:24.000000', 'temperatura', 1057.0000, 'ºC'),
	(62478, 110, '2015-02-15 00:59:25.000000', 'temperatura', 616.0000, 'ºC'),
	(62479, 110, '2015-02-15 00:59:26.000000', 'temperatura', 1109.0000, 'ºC'),
	(62480, 110, '2015-02-15 00:59:27.000000', 'temperatura', 96.0000, 'ºC'),
	(62481, 110, '2015-02-15 00:59:28.000000', 'temperatura', 753.0000, 'ºC'),
	(62482, 110, '2015-02-15 00:59:29.000000', 'temperatura', 1080.0000, 'ºC'),
	(62483, 110, '2015-02-15 00:59:30.000000', 'temperatura', 740.0000, 'ºC'),
	(62484, 110, '2015-02-15 00:59:31.000000', 'temperatura', 459.0000, 'ºC'),
	(62485, 110, '2015-02-15 00:59:32.000000', 'temperatura', 79.0000, 'ºC'),
	(62486, 110, '2015-02-15 00:59:33.000000', 'temperatura', 216.0000, 'ºC'),
	(62487, 110, '2015-02-15 00:59:34.000000', 'temperatura', 845.0000, 'ºC'),
	(62488, 110, '2015-02-15 00:59:35.000000', 'temperatura', 1178.0000, 'ºC'),
	(62489, 110, '2015-02-15 00:59:36.000000', 'temperatura', 957.0000, 'ºC'),
	(62490, 110, '2015-02-15 00:59:37.000000', 'temperatura', 49.0000, 'ºC'),
	(62491, 110, '2015-02-15 00:59:38.000000', 'temperatura', 975.0000, 'ºC'),
	(62492, 110, '2015-02-15 00:59:39.000000', 'temperatura', 1131.0000, 'ºC'),
	(62493, 110, '2015-02-15 00:59:40.000000', 'temperatura', 327.0000, 'ºC'),
	(62494, 110, '2015-02-15 00:59:41.000000', 'temperatura', 646.0000, 'ºC'),
	(62495, 110, '2015-02-15 00:59:42.000000', 'temperatura', 1047.0000, 'ºC'),
	(62496, 110, '2015-02-15 00:59:43.000000', 'temperatura', 898.0000, 'ºC'),
	(62497, 110, '2015-02-15 00:59:44.000000', 'temperatura', 148.0000, 'ºC'),
	(62498, 110, '2015-02-15 00:59:45.000000', 'temperatura', 449.0000, 'ºC'),
	(62499, 110, '2015-02-15 00:59:46.000000', 'temperatura', 599.0000, 'ºC'),
	(62500, 110, '2015-02-15 00:59:47.000000', 'temperatura', 450.0000, 'ºC'),
	(62501, 110, '2015-02-15 00:59:48.000000', 'temperatura', 451.0000, 'ºC'),
	(62502, 110, '2015-02-15 00:59:49.000000', 'temperatura', 908.0000, 'ºC'),
	(62503, 110, '2015-02-15 00:59:50.000000', 'temperatura', 788.0000, 'ºC'),
	(62504, 110, '2015-02-15 00:59:51.000000', 'temperatura', 17.0000, 'ºC'),
	(62505, 110, '2015-02-15 00:59:52.000000', 'temperatura', 121.0000, 'ºC'),
	(62506, 110, '2015-02-15 00:59:53.000000', 'temperatura', 554.0000, 'ºC'),
	(62507, 110, '2015-02-15 00:59:54.000000', 'temperatura', 8.0000, 'ºC'),
	(62508, 110, '2015-02-15 00:59:55.000000', 'temperatura', 777.0000, 'ºC'),
	(62509, 110, '2015-02-15 00:59:56.000000', 'temperatura', 261.0000, 'ºC'),
	(62510, 110, '2015-02-15 00:59:57.000000', 'temperatura', 174.0000, 'ºC'),
	(62511, 110, '2015-02-15 00:59:58.000000', 'temperatura', 88.0000, 'ºC'),
	(62512, 110, '2015-02-15 00:59:59.000000', 'temperatura', 1117.0000, 'ºC'),
	(62513, 110, '2015-02-15 01:00:00.000000', 'temperatura', 524.0000, 'ºC'),
	(62514, 110, '2015-02-15 01:00:01.000000', 'temperatura', 467.0000, 'ºC'),
	(62515, 110, '2015-02-15 01:00:02.000000', 'temperatura', 767.0000, 'ºC'),
	(62516, 110, '2015-02-15 01:00:03.000000', 'temperatura', 32.0000, 'ºC'),
	(62517, 110, '2015-02-15 01:00:04.000000', 'temperatura', 258.0000, 'ºC'),
	(62518, 110, '2015-02-15 01:00:05.000000', 'temperatura', 1197.0000, 'ºC'),
	(62519, 110, '2015-02-15 01:00:06.000000', 'temperatura', 413.0000, 'ºC'),
	(62520, 110, '2015-02-15 01:00:07.000000', 'temperatura', 872.0000, 'ºC'),
	(62521, 110, '2015-02-15 01:00:08.000000', 'temperatura', 722.0000, 'ºC'),
	(62522, 110, '2015-02-15 01:00:09.000000', 'temperatura', 995.0000, 'ºC'),
	(62523, 110, '2015-02-15 01:00:10.000000', 'temperatura', 411.0000, 'ºC'),
	(62524, 110, '2015-02-15 01:00:11.000000', 'temperatura', 267.0000, 'ºC'),
	(62525, 110, '2015-02-15 01:00:12.000000', 'temperatura', 105.0000, 'ºC'),
	(62526, 110, '2015-02-15 01:00:13.000000', 'temperatura', 924.0000, 'ºC'),
	(62527, 110, '2015-02-15 01:00:14.000000', 'temperatura', 707.0000, 'ºC'),
	(62528, 110, '2015-02-15 01:00:15.000000', 'temperatura', 763.0000, 'ºC'),
	(62529, 110, '2015-02-15 01:00:16.000000', 'temperatura', 494.0000, 'ºC'),
	(62530, 110, '2015-02-15 01:00:17.000000', 'temperatura', 182.0000, 'ºC'),
	(62531, 110, '2015-02-15 01:00:18.000000', 'temperatura', 630.0000, 'ºC'),
	(62532, 110, '2015-02-15 01:00:19.000000', 'temperatura', 204.0000, 'ºC'),
	(62533, 110, '2015-02-15 01:00:20.000000', 'temperatura', 332.0000, 'ºC'),
	(62534, 110, '2015-02-15 01:00:21.000000', 'temperatura', 1047.0000, 'ºC'),
	(62535, 110, '2015-02-15 01:00:22.000000', 'temperatura', 639.0000, 'ºC'),
	(62536, 110, '2015-02-15 01:00:23.000000', 'temperatura', 53.0000, 'ºC'),
	(62537, 110, '2015-02-15 01:00:24.000000', 'temperatura', 750.0000, 'ºC'),
	(62538, 110, '2015-02-15 01:00:25.000000', 'temperatura', 1193.0000, 'ºC'),
	(62539, 110, '2015-02-15 01:00:26.000000', 'temperatura', 116.0000, 'ºC'),
	(62540, 110, '2015-02-15 01:00:27.000000', 'temperatura', 602.0000, 'ºC'),
	(62541, 110, '2015-02-15 01:00:28.000000', 'temperatura', 261.0000, 'ºC'),
	(62542, 110, '2015-02-15 01:00:29.000000', 'temperatura', 700.0000, 'ºC'),
	(62543, 110, '2015-02-15 01:00:30.000000', 'temperatura', 318.0000, 'ºC'),
	(62544, 110, '2015-02-15 01:00:31.000000', 'temperatura', 692.0000, 'ºC'),
	(62545, 110, '2015-02-15 01:00:32.000000', 'temperatura', 105.0000, 'ºC'),
	(62546, 110, '2015-02-15 01:00:33.000000', 'temperatura', 848.0000, 'ºC'),
	(62547, 110, '2015-02-15 01:00:34.000000', 'temperatura', 327.0000, 'ºC'),
	(62548, 110, '2015-02-15 01:00:35.000000', 'temperatura', 289.0000, 'ºC'),
	(62549, 110, '2015-02-15 01:00:36.000000', 'temperatura', 467.0000, 'ºC'),
	(62550, 110, '2015-02-15 01:00:37.000000', 'temperatura', 267.0000, 'ºC'),
	(62551, 110, '2015-02-15 01:00:38.000000', 'temperatura', 1134.0000, 'ºC'),
	(62552, 110, '2015-02-15 01:00:39.000000', 'temperatura', 71.0000, 'ºC'),
	(62553, 110, '2015-02-15 01:00:40.000000', 'temperatura', 553.0000, 'ºC'),
	(62554, 110, '2015-02-15 01:00:41.000000', 'temperatura', 153.0000, 'ºC'),
	(62555, 110, '2015-02-15 01:00:42.000000', 'temperatura', 304.0000, 'ºC'),
	(62556, 110, '2015-02-15 01:00:43.000000', 'temperatura', 1065.0000, 'ºC'),
	(62557, 110, '2015-02-15 01:00:44.000000', 'temperatura', 812.0000, 'ºC'),
	(62558, 110, '2015-02-15 01:00:45.000000', 'temperatura', 864.0000, 'ºC'),
	(62559, 110, '2015-02-15 01:00:46.000000', 'temperatura', 687.0000, 'ºC'),
	(62560, 110, '2015-02-15 01:00:47.000000', 'temperatura', 841.0000, 'ºC'),
	(62561, 110, '2015-02-15 01:00:48.000000', 'temperatura', 945.0000, 'ºC'),
	(62562, 110, '2015-02-15 01:00:49.000000', 'temperatura', 1003.0000, 'ºC'),
	(62563, 110, '2015-02-15 01:00:50.000000', 'temperatura', 980.0000, 'ºC'),
	(62564, 110, '2015-02-15 01:00:51.000000', 'temperatura', 693.0000, 'ºC'),
	(62565, 110, '2015-02-15 01:00:52.000000', 'temperatura', 524.0000, 'ºC'),
	(62566, 110, '2015-02-15 01:00:53.000000', 'temperatura', 540.0000, 'ºC'),
	(62567, 110, '2015-02-15 01:00:54.000000', 'temperatura', 1130.0000, 'ºC'),
	(62568, 110, '2015-02-15 01:00:55.000000', 'temperatura', 429.0000, 'ºC'),
	(62569, 110, '2015-02-15 01:00:56.000000', 'temperatura', 1158.0000, 'ºC'),
	(62570, 110, '2015-02-15 01:00:57.000000', 'temperatura', 904.0000, 'ºC'),
	(62571, 110, '2015-02-15 01:00:58.000000', 'temperatura', 1047.0000, 'ºC'),
	(62572, 110, '2015-02-15 01:00:59.000000', 'temperatura', 124.0000, 'ºC'),
	(62573, 110, '2015-02-15 01:01:00.000000', 'temperatura', 1078.0000, 'ºC'),
	(62574, 110, '2015-02-15 01:01:01.000000', 'temperatura', 217.0000, 'ºC'),
	(62575, 110, '2015-02-15 01:01:02.000000', 'temperatura', 252.0000, 'ºC'),
	(62576, 110, '2015-02-15 01:01:03.000000', 'temperatura', 609.0000, 'ºC'),
	(62577, 110, '2015-02-15 01:01:04.000000', 'temperatura', 1090.0000, 'ºC'),
	(62578, 110, '2015-02-15 01:01:05.000000', 'temperatura', 25.0000, 'ºC'),
	(62579, 110, '2015-02-15 01:01:06.000000', 'temperatura', 455.0000, 'ºC'),
	(62580, 110, '2015-02-15 01:01:07.000000', 'temperatura', 1001.0000, 'ºC'),
	(62581, 110, '2015-02-15 01:01:08.000000', 'temperatura', 40.0000, 'ºC'),
	(62582, 110, '2015-02-15 01:01:09.000000', 'temperatura', 796.0000, 'ºC'),
	(62583, 110, '2015-02-15 01:01:10.000000', 'temperatura', 259.0000, 'ºC'),
	(62584, 110, '2015-02-15 01:01:11.000000', 'temperatura', 111.0000, 'ºC'),
	(62585, 110, '2015-02-15 01:01:12.000000', 'temperatura', 979.0000, 'ºC'),
	(62586, 110, '2015-02-15 01:01:13.000000', 'temperatura', 960.0000, 'ºC'),
	(62587, 110, '2015-02-15 01:01:14.000000', 'temperatura', 664.0000, 'ºC'),
	(62588, 110, '2015-02-15 01:01:15.000000', 'temperatura', 439.0000, 'ºC'),
	(62589, 110, '2015-02-15 01:01:16.000000', 'temperatura', 204.0000, 'ºC'),
	(62590, 110, '2015-02-15 01:01:17.000000', 'temperatura', 905.0000, 'ºC'),
	(62591, 110, '2015-02-15 01:01:18.000000', 'temperatura', 313.0000, 'ºC'),
	(62592, 110, '2015-02-15 01:01:19.000000', 'temperatura', 49.0000, 'ºC'),
	(62593, 110, '2015-02-15 01:01:20.000000', 'temperatura', 507.0000, 'ºC'),
	(62594, 110, '2015-02-15 01:01:21.000000', 'temperatura', 1190.0000, 'ºC'),
	(62595, 110, '2015-02-15 01:01:22.000000', 'temperatura', 827.0000, 'ºC'),
	(62596, 110, '2015-02-15 01:01:23.000000', 'temperatura', 567.0000, 'ºC'),
	(62597, 110, '2015-02-15 01:01:24.000000', 'temperatura', 355.0000, 'ºC'),
	(62598, 110, '2015-02-15 01:01:25.000000', 'temperatura', 75.0000, 'ºC'),
	(62599, 110, '2015-02-15 01:01:26.000000', 'temperatura', 508.0000, 'ºC'),
	(62600, 110, '2015-02-15 01:01:27.000000', 'temperatura', 1116.0000, 'ºC'),
	(62601, 110, '2015-02-15 01:01:28.000000', 'temperatura', 457.0000, 'ºC'),
	(62602, 110, '2015-02-15 01:01:29.000000', 'temperatura', 139.0000, 'ºC'),
	(62603, 110, '2015-02-15 01:01:30.000000', 'temperatura', 523.0000, 'ºC'),
	(62604, 110, '2015-02-15 01:01:31.000000', 'temperatura', 1000.0000, 'ºC'),
	(62605, 110, '2015-02-15 01:01:32.000000', 'temperatura', 1032.0000, 'ºC'),
	(62606, 110, '2015-02-15 01:01:33.000000', 'temperatura', 959.0000, 'ºC'),
	(62607, 110, '2015-02-15 01:01:34.000000', 'temperatura', 498.0000, 'ºC'),
	(62608, 110, '2015-02-15 01:01:35.000000', 'temperatura', 816.0000, 'ºC'),
	(62609, 110, '2015-02-15 01:01:36.000000', 'temperatura', 186.0000, 'ºC'),
	(62610, 110, '2015-02-15 01:01:37.000000', 'temperatura', 884.0000, 'ºC'),
	(62611, 110, '2015-02-15 01:01:38.000000', 'temperatura', 262.0000, 'ºC'),
	(62612, 110, '2015-02-15 01:01:39.000000', 'temperatura', 1058.0000, 'ºC'),
	(62613, 110, '2015-02-15 01:01:40.000000', 'temperatura', 906.0000, 'ºC'),
	(62614, 110, '2015-02-15 01:01:41.000000', 'temperatura', 157.0000, 'ºC'),
	(62615, 110, '2015-02-15 01:01:42.000000', 'temperatura', 465.0000, 'ºC'),
	(62616, 110, '2015-02-15 01:01:43.000000', 'temperatura', 657.0000, 'ºC'),
	(62617, 110, '2015-02-15 01:01:44.000000', 'temperatura', 691.0000, 'ºC'),
	(62618, 110, '2015-02-15 01:01:45.000000', 'temperatura', 285.0000, 'ºC'),
	(62619, 110, '2015-02-15 01:01:46.000000', 'temperatura', 553.0000, 'ºC'),
	(62620, 110, '2015-02-15 01:01:47.000000', 'temperatura', 710.0000, 'ºC'),
	(62621, 110, '2015-02-15 01:01:48.000000', 'temperatura', 692.0000, 'ºC'),
	(62622, 110, '2015-02-15 01:01:49.000000', 'temperatura', 129.0000, 'ºC'),
	(62623, 110, '2015-02-15 01:01:50.000000', 'temperatura', 968.0000, 'ºC'),
	(62624, 110, '2015-02-15 01:01:51.000000', 'temperatura', 857.0000, 'ºC'),
	(62625, 110, '2015-02-15 01:01:52.000000', 'temperatura', 178.0000, 'ºC'),
	(62626, 110, '2015-02-15 01:01:53.000000', 'temperatura', 721.0000, 'ºC'),
	(62627, 110, '2015-02-15 01:01:54.000000', 'temperatura', 672.0000, 'ºC'),
	(62628, 110, '2015-02-15 01:01:55.000000', 'temperatura', 1199.0000, 'ºC'),
	(62629, 110, '2015-02-15 01:01:56.000000', 'temperatura', 378.0000, 'ºC'),
	(62630, 110, '2015-02-15 01:01:57.000000', 'temperatura', 695.0000, 'ºC'),
	(62631, 110, '2015-02-15 01:01:58.000000', 'temperatura', 1142.0000, 'ºC'),
	(62632, 110, '2015-02-15 01:01:59.000000', 'temperatura', 25.0000, 'ºC'),
	(62633, 110, '2015-02-15 01:02:00.000000', 'temperatura', 300.0000, 'ºC'),
	(62634, 110, '2015-02-15 01:02:01.000000', 'temperatura', 226.0000, 'ºC'),
	(62635, 110, '2015-02-15 01:02:02.000000', 'temperatura', 229.0000, 'ºC'),
	(62636, 110, '2015-02-15 01:02:03.000000', 'temperatura', 466.0000, 'ºC'),
	(62637, 110, '2015-02-15 01:02:04.000000', 'temperatura', 446.0000, 'ºC'),
	(62638, 110, '2015-02-15 01:02:05.000000', 'temperatura', 832.0000, 'ºC'),
	(62639, 110, '2015-02-15 01:02:06.000000', 'temperatura', 422.0000, 'ºC'),
	(62640, 110, '2015-02-15 01:02:07.000000', 'temperatura', 813.0000, 'ºC'),
	(62641, 110, '2015-02-15 01:02:08.000000', 'temperatura', 400.0000, 'ºC'),
	(62642, 110, '2015-02-15 01:02:09.000000', 'temperatura', 762.0000, 'ºC'),
	(62643, 110, '2015-02-15 01:02:10.000000', 'temperatura', 212.0000, 'ºC'),
	(62644, 110, '2015-02-15 01:02:11.000000', 'temperatura', 1174.0000, 'ºC'),
	(62645, 110, '2015-02-15 01:02:12.000000', 'temperatura', 434.0000, 'ºC'),
	(62646, 110, '2015-02-15 01:02:13.000000', 'temperatura', 1050.0000, 'ºC'),
	(62647, 110, '2015-02-15 01:02:14.000000', 'temperatura', 346.0000, 'ºC'),
	(62648, 110, '2015-02-15 01:02:15.000000', 'temperatura', 980.0000, 'ºC'),
	(62649, 110, '2015-02-15 01:02:16.000000', 'temperatura', 264.0000, 'ºC'),
	(62650, 110, '2015-02-15 01:02:17.000000', 'temperatura', 781.0000, 'ºC'),
	(62651, 110, '2015-02-15 01:02:18.000000', 'temperatura', 714.0000, 'ºC'),
	(62652, 110, '2015-02-15 01:02:19.000000', 'temperatura', 25.0000, 'ºC'),
	(62653, 110, '2015-02-15 01:02:20.000000', 'temperatura', 386.0000, 'ºC'),
	(62654, 110, '2015-02-15 01:02:21.000000', 'temperatura', 653.0000, 'ºC'),
	(62655, 110, '2015-02-15 01:02:22.000000', 'temperatura', 907.0000, 'ºC'),
	(62656, 110, '2015-02-15 01:02:23.000000', 'temperatura', 178.0000, 'ºC'),
	(62657, 110, '2015-02-15 01:02:24.000000', 'temperatura', 569.0000, 'ºC'),
	(62658, 110, '2015-02-15 01:02:25.000000', 'temperatura', 1110.0000, 'ºC'),
	(62659, 110, '2015-02-15 01:02:26.000000', 'temperatura', 244.0000, 'ºC'),
	(62660, 110, '2015-02-15 01:02:27.000000', 'temperatura', 291.0000, 'ºC'),
	(62661, 110, '2015-02-15 01:02:28.000000', 'temperatura', 723.0000, 'ºC'),
	(62662, 110, '2015-02-15 01:02:29.000000', 'temperatura', 344.0000, 'ºC'),
	(62663, 110, '2015-02-15 01:02:30.000000', 'temperatura', 749.0000, 'ºC'),
	(62664, 110, '2015-02-15 01:02:31.000000', 'temperatura', 316.0000, 'ºC'),
	(62665, 110, '2015-02-15 01:02:32.000000', 'temperatura', 533.0000, 'ºC'),
	(62666, 110, '2015-02-15 01:02:33.000000', 'temperatura', 517.0000, 'ºC'),
	(62667, 110, '2015-02-15 01:02:34.000000', 'temperatura', 987.0000, 'ºC'),
	(62668, 110, '2015-02-15 01:02:35.000000', 'temperatura', 982.0000, 'ºC'),
	(62669, 110, '2015-02-15 01:02:36.000000', 'temperatura', 753.0000, 'ºC'),
	(62670, 110, '2015-02-15 01:02:37.000000', 'temperatura', 816.0000, 'ºC'),
	(62671, 110, '2015-02-15 01:02:38.000000', 'temperatura', 625.0000, 'ºC'),
	(62672, 110, '2015-02-15 01:02:39.000000', 'temperatura', 674.0000, 'ºC'),
	(62673, 110, '2015-02-15 01:02:40.000000', 'temperatura', 298.0000, 'ºC'),
	(62674, 110, '2015-02-15 01:02:41.000000', 'temperatura', 667.0000, 'ºC'),
	(62675, 110, '2015-02-15 01:02:42.000000', 'temperatura', 42.0000, 'ºC'),
	(62676, 110, '2015-02-15 01:02:43.000000', 'temperatura', 609.0000, 'ºC'),
	(62677, 110, '2015-02-15 01:02:44.000000', 'temperatura', 520.0000, 'ºC'),
	(62678, 110, '2015-02-15 01:02:45.000000', 'temperatura', 772.0000, 'ºC'),
	(62679, 110, '2015-02-15 01:02:46.000000', 'temperatura', 1101.0000, 'ºC'),
	(62680, 110, '2015-02-15 01:02:47.000000', 'temperatura', 789.0000, 'ºC'),
	(62681, 110, '2015-02-15 01:02:48.000000', 'temperatura', 641.0000, 'ºC'),
	(62682, 110, '2015-02-15 01:02:49.000000', 'temperatura', 840.0000, 'ºC'),
	(62683, 110, '2015-02-15 01:02:50.000000', 'temperatura', 1078.0000, 'ºC'),
	(62684, 110, '2015-02-15 01:02:51.000000', 'temperatura', 469.0000, 'ºC'),
	(62685, 110, '2015-02-15 01:02:52.000000', 'temperatura', 313.0000, 'ºC'),
	(62686, 110, '2015-02-15 01:02:53.000000', 'temperatura', 158.0000, 'ºC'),
	(62687, 110, '2015-02-15 01:02:54.000000', 'temperatura', 1053.0000, 'ºC'),
	(62688, 110, '2015-02-15 01:02:55.000000', 'temperatura', 1192.0000, 'ºC'),
	(62689, 110, '2015-02-15 01:02:56.000000', 'temperatura', 402.0000, 'ºC'),
	(62690, 110, '2015-02-15 01:02:57.000000', 'temperatura', 833.0000, 'ºC'),
	(62691, 110, '2015-02-15 01:02:58.000000', 'temperatura', 558.0000, 'ºC'),
	(62692, 110, '2015-02-15 01:02:59.000000', 'temperatura', 293.0000, 'ºC'),
	(62693, 110, '2015-02-15 01:03:00.000000', 'temperatura', 993.0000, 'ºC'),
	(62694, 110, '2015-02-15 01:03:01.000000', 'temperatura', 486.0000, 'ºC'),
	(62695, 110, '2015-02-15 01:03:02.000000', 'temperatura', 651.0000, 'ºC'),
	(62696, 110, '2015-02-15 01:03:03.000000', 'temperatura', 596.0000, 'ºC'),
	(62697, 110, '2015-02-15 01:03:04.000000', 'temperatura', 1027.0000, 'ºC'),
	(62698, 110, '2015-02-15 01:03:05.000000', 'temperatura', 949.0000, 'ºC'),
	(62699, 110, '2015-02-15 01:03:06.000000', 'temperatura', 463.0000, 'ºC'),
	(62700, 110, '2015-02-15 01:03:07.000000', 'temperatura', 669.0000, 'ºC'),
	(62701, 110, '2015-02-15 01:03:08.000000', 'temperatura', 758.0000, 'ºC'),
	(62702, 110, '2015-02-15 01:03:09.000000', 'temperatura', 583.0000, 'ºC'),
	(62703, 110, '2015-02-15 01:03:10.000000', 'temperatura', 643.0000, 'ºC'),
	(62704, 110, '2015-02-15 01:03:11.000000', 'temperatura', 266.0000, 'ºC'),
	(62705, 110, '2015-02-15 01:03:12.000000', 'temperatura', 599.0000, 'ºC'),
	(62706, 110, '2015-02-15 01:03:13.000000', 'temperatura', 999.0000, 'ºC'),
	(62707, 110, '2015-02-15 01:03:14.000000', 'temperatura', 799.0000, 'ºC'),
	(62708, 110, '2015-02-15 01:03:15.000000', 'temperatura', 998.0000, 'ºC'),
	(62709, 110, '2015-02-15 01:03:16.000000', 'temperatura', 192.0000, 'ºC'),
	(62710, 110, '2015-02-15 01:03:17.000000', 'temperatura', 368.0000, 'ºC'),
	(62711, 110, '2015-02-15 01:03:18.000000', 'temperatura', 64.0000, 'ºC'),
	(62712, 110, '2015-02-15 01:03:19.000000', 'temperatura', 417.0000, 'ºC'),
	(62713, 110, '2015-02-15 01:03:20.000000', 'temperatura', 695.0000, 'ºC'),
	(62714, 110, '2015-02-15 01:03:21.000000', 'temperatura', 1024.0000, 'ºC'),
	(62715, 110, '2015-02-15 01:03:22.000000', 'temperatura', 636.0000, 'ºC'),
	(62716, 110, '2015-02-15 01:03:23.000000', 'temperatura', 106.0000, 'ºC'),
	(62717, 110, '2015-02-15 01:03:24.000000', 'temperatura', 1026.0000, 'ºC'),
	(62718, 110, '2015-02-15 01:03:25.000000', 'temperatura', 9.0000, 'ºC'),
	(62719, 110, '2015-02-15 01:03:26.000000', 'temperatura', 569.0000, 'ºC'),
	(62720, 110, '2015-02-15 01:03:27.000000', 'temperatura', 417.0000, 'ºC'),
	(62721, 110, '2015-02-15 01:03:28.000000', 'temperatura', 380.0000, 'ºC'),
	(62722, 110, '2015-02-15 01:03:29.000000', 'temperatura', 648.0000, 'ºC'),
	(62723, 110, '2015-02-15 01:03:30.000000', 'temperatura', 899.0000, 'ºC'),
	(62724, 110, '2015-02-15 01:03:31.000000', 'temperatura', 154.0000, 'ºC'),
	(62725, 110, '2015-02-15 01:03:32.000000', 'temperatura', 474.0000, 'ºC'),
	(62726, 110, '2015-02-15 01:03:33.000000', 'temperatura', 706.0000, 'ºC'),
	(62727, 110, '2015-02-15 01:03:34.000000', 'temperatura', 910.0000, 'ºC'),
	(62728, 110, '2015-02-15 01:03:35.000000', 'temperatura', 32.0000, 'ºC'),
	(62729, 110, '2015-02-15 01:03:36.000000', 'temperatura', 1033.0000, 'ºC'),
	(62730, 110, '2015-02-15 01:03:37.000000', 'temperatura', 267.0000, 'ºC'),
	(62731, 110, '2015-02-15 01:03:38.000000', 'temperatura', 637.0000, 'ºC'),
	(62732, 110, '2015-02-15 01:03:39.000000', 'temperatura', 1184.0000, 'ºC'),
	(62733, 110, '2015-02-15 01:03:40.000000', 'temperatura', 410.0000, 'ºC'),
	(62734, 110, '2015-02-15 01:03:41.000000', 'temperatura', 899.0000, 'ºC'),
	(62735, 110, '2015-02-15 01:03:42.000000', 'temperatura', 867.0000, 'ºC'),
	(62736, 110, '2015-02-15 01:03:43.000000', 'temperatura', 438.0000, 'ºC'),
	(62737, 110, '2015-02-15 01:03:44.000000', 'temperatura', 789.0000, 'ºC'),
	(62738, 110, '2015-02-15 01:03:45.000000', 'temperatura', 231.0000, 'ºC'),
	(62739, 110, '2015-02-15 01:03:46.000000', 'temperatura', 1188.0000, 'ºC'),
	(62740, 110, '2015-02-15 01:03:47.000000', 'temperatura', 448.0000, 'ºC'),
	(62741, 110, '2015-02-15 01:03:48.000000', 'temperatura', 1077.0000, 'ºC'),
	(62742, 110, '2015-02-15 01:03:49.000000', 'temperatura', 442.0000, 'ºC'),
	(62743, 110, '2015-02-15 01:03:50.000000', 'temperatura', 180.0000, 'ºC'),
	(62744, 110, '2015-02-15 01:03:51.000000', 'temperatura', 772.0000, 'ºC'),
	(62745, 110, '2015-02-15 01:03:52.000000', 'temperatura', 921.0000, 'ºC'),
	(62746, 110, '2015-02-15 01:03:53.000000', 'temperatura', 1089.0000, 'ºC'),
	(62747, 110, '2015-02-15 01:03:54.000000', 'temperatura', 285.0000, 'ºC'),
	(62748, 110, '2015-02-15 01:03:55.000000', 'temperatura', 558.0000, 'ºC'),
	(62749, 110, '2015-02-15 01:03:56.000000', 'temperatura', 734.0000, 'ºC'),
	(62750, 110, '2015-02-15 01:03:57.000000', 'temperatura', 796.0000, 'ºC'),
	(62751, 110, '2015-02-15 01:03:58.000000', 'temperatura', 579.0000, 'ºC'),
	(62752, 110, '2015-02-15 01:03:59.000000', 'temperatura', 509.0000, 'ºC'),
	(62753, 110, '2015-02-15 01:04:00.000000', 'temperatura', 809.0000, 'ºC'),
	(62754, 110, '2015-02-15 01:04:01.000000', 'temperatura', 117.0000, 'ºC'),
	(62755, 110, '2015-02-15 01:04:02.000000', 'temperatura', 557.0000, 'ºC'),
	(62756, 110, '2015-02-15 01:04:03.000000', 'temperatura', 35.0000, 'ºC'),
	(62757, 110, '2015-02-15 01:04:04.000000', 'temperatura', 905.0000, 'ºC'),
	(62758, 110, '2015-02-15 01:04:05.000000', 'temperatura', 820.0000, 'ºC'),
	(62759, 110, '2015-02-15 01:04:06.000000', 'temperatura', 184.0000, 'ºC'),
	(62760, 110, '2015-02-15 01:04:07.000000', 'temperatura', 864.0000, 'ºC'),
	(62761, 110, '2015-02-15 01:04:08.000000', 'temperatura', 165.0000, 'ºC'),
	(62762, 110, '2015-02-15 01:04:09.000000', 'temperatura', 636.0000, 'ºC'),
	(62763, 110, '2015-02-15 01:04:10.000000', 'temperatura', 285.0000, 'ºC'),
	(62764, 110, '2015-02-15 01:04:11.000000', 'temperatura', 719.0000, 'ºC'),
	(62765, 110, '2015-02-15 01:04:12.000000', 'temperatura', 338.0000, 'ºC'),
	(62766, 110, '2015-02-15 01:04:13.000000', 'temperatura', 734.0000, 'ºC'),
	(62767, 110, '2015-02-15 01:04:14.000000', 'temperatura', 256.0000, 'ºC'),
	(62768, 110, '2015-02-15 01:04:15.000000', 'temperatura', 278.0000, 'ºC'),
	(62769, 110, '2015-02-15 01:04:16.000000', 'temperatura', 623.0000, 'ºC'),
	(62770, 110, '2015-02-15 01:04:17.000000', 'temperatura', 1080.0000, 'ºC'),
	(62771, 110, '2015-02-15 01:04:18.000000', 'temperatura', 1134.0000, 'ºC'),
	(62772, 110, '2015-02-15 01:04:19.000000', 'temperatura', 29.0000, 'ºC'),
	(62773, 110, '2015-02-15 01:04:20.000000', 'temperatura', 344.0000, 'ºC'),
	(62774, 110, '2015-02-15 01:04:21.000000', 'temperatura', 436.0000, 'ºC'),
	(62775, 110, '2015-02-15 01:04:22.000000', 'temperatura', 1145.0000, 'ºC'),
	(62776, 110, '2015-02-15 01:04:23.000000', 'temperatura', 817.0000, 'ºC'),
	(62777, 110, '2015-02-15 01:04:24.000000', 'temperatura', 652.0000, 'ºC'),
	(62778, 110, '2015-02-15 01:04:25.000000', 'temperatura', 809.0000, 'ºC'),
	(62779, 110, '2015-02-15 01:04:26.000000', 'temperatura', 890.0000, 'ºC'),
	(62780, 110, '2015-02-15 01:04:27.000000', 'temperatura', 825.0000, 'ºC'),
	(62781, 110, '2015-02-15 01:04:28.000000', 'temperatura', 255.0000, 'ºC'),
	(62782, 110, '2015-02-15 01:04:29.000000', 'temperatura', 0.0000, 'ºC'),
	(62783, 110, '2015-02-15 01:04:30.000000', 'temperatura', 436.0000, 'ºC'),
	(62784, 110, '2015-02-15 01:04:31.000000', 'temperatura', 980.0000, 'ºC'),
	(62785, 110, '2015-02-15 01:04:32.000000', 'temperatura', 1192.0000, 'ºC'),
	(62786, 110, '2015-02-15 01:04:33.000000', 'temperatura', 620.0000, 'ºC'),
	(62787, 110, '2015-02-15 01:04:34.000000', 'temperatura', 724.0000, 'ºC'),
	(62788, 110, '2015-02-15 01:04:35.000000', 'temperatura', 559.0000, 'ºC'),
	(62789, 110, '2015-02-15 01:04:36.000000', 'temperatura', 627.0000, 'ºC'),
	(62790, 110, '2015-02-15 01:04:37.000000', 'temperatura', 256.0000, 'ºC'),
	(62791, 110, '2015-02-15 01:04:38.000000', 'temperatura', 601.0000, 'ºC'),
	(62792, 110, '2015-02-15 01:04:39.000000', 'temperatura', 1038.0000, 'ºC'),
	(62793, 110, '2015-02-15 01:04:40.000000', 'temperatura', 989.0000, 'ºC'),
	(62794, 110, '2015-02-15 01:04:41.000000', 'temperatura', 629.0000, 'ºC'),
	(62795, 110, '2015-02-15 01:04:42.000000', 'temperatura', 181.0000, 'ºC'),
	(62796, 110, '2015-02-15 01:04:43.000000', 'temperatura', 217.0000, 'ºC'),
	(62797, 110, '2015-02-15 01:04:44.000000', 'temperatura', 544.0000, 'ºC'),
	(62798, 110, '2015-02-15 01:04:45.000000', 'temperatura', 867.0000, 'ºC'),
	(62799, 110, '2015-02-15 01:04:46.000000', 'temperatura', 303.0000, 'ºC'),
	(62800, 110, '2015-02-15 01:04:47.000000', 'temperatura', 114.0000, 'ºC'),
	(62801, 110, '2015-02-15 01:04:48.000000', 'temperatura', 861.0000, 'ºC'),
	(62802, 110, '2015-02-15 01:04:49.000000', 'temperatura', 366.0000, 'ºC'),
	(62803, 110, '2015-02-15 01:04:50.000000', 'temperatura', 445.0000, 'ºC'),
	(62804, 110, '2015-02-15 01:04:51.000000', 'temperatura', 1129.0000, 'ºC'),
	(62805, 110, '2015-02-15 01:04:52.000000', 'temperatura', 710.0000, 'ºC'),
	(62806, 111, '2015-02-15 00:00:00.000000', 'temperatura', 1096.0000, 'ºC'),
	(62807, 111, '2015-02-15 00:00:01.000000', 'temperatura', 185.0000, 'ºC'),
	(62808, 111, '2015-02-15 00:00:02.000000', 'temperatura', 38.0000, 'ºC'),
	(62809, 111, '2015-02-15 00:00:03.000000', 'temperatura', 836.0000, 'ºC'),
	(62810, 111, '2015-02-15 00:00:04.000000', 'temperatura', 464.0000, 'ºC'),
	(62811, 111, '2015-02-15 00:00:05.000000', 'temperatura', 1015.0000, 'ºC'),
	(62812, 111, '2015-02-15 00:00:06.000000', 'temperatura', 81.0000, 'ºC'),
	(62813, 111, '2015-02-15 00:00:07.000000', 'temperatura', 964.0000, 'ºC'),
	(62814, 111, '2015-02-15 00:00:08.000000', 'temperatura', 974.0000, 'ºC'),
	(62815, 111, '2015-02-15 00:00:09.000000', 'temperatura', 781.0000, 'ºC'),
	(62816, 111, '2015-02-15 00:00:10.000000', 'temperatura', 982.0000, 'ºC'),
	(62817, 111, '2015-02-15 00:00:11.000000', 'temperatura', 166.0000, 'ºC'),
	(62818, 111, '2015-02-15 00:00:12.000000', 'temperatura', 287.0000, 'ºC'),
	(62819, 111, '2015-02-15 00:00:13.000000', 'temperatura', 936.0000, 'ºC'),
	(62820, 111, '2015-02-15 00:00:14.000000', 'temperatura', 220.0000, 'ºC'),
	(62821, 111, '2015-02-15 00:00:15.000000', 'temperatura', 692.0000, 'ºC'),
	(62822, 111, '2015-02-15 00:00:16.000000', 'temperatura', 401.0000, 'ºC'),
	(62823, 111, '2015-02-15 00:00:17.000000', 'temperatura', 1130.0000, 'ºC'),
	(62824, 111, '2015-02-15 00:00:18.000000', 'temperatura', 846.0000, 'ºC'),
	(62825, 111, '2015-02-15 00:00:19.000000', 'temperatura', 842.0000, 'ºC'),
	(62826, 111, '2015-02-15 00:00:20.000000', 'temperatura', 474.0000, 'ºC'),
	(62827, 111, '2015-02-15 00:00:21.000000', 'temperatura', 1043.0000, 'ºC'),
	(62828, 111, '2015-02-15 00:00:22.000000', 'temperatura', 192.0000, 'ºC'),
	(62829, 111, '2015-02-15 00:00:23.000000', 'temperatura', 234.0000, 'ºC'),
	(62830, 111, '2015-02-15 00:00:24.000000', 'temperatura', 595.0000, 'ºC'),
	(62831, 111, '2015-02-15 00:00:25.000000', 'temperatura', 1075.0000, 'ºC'),
	(62832, 111, '2015-02-15 00:00:26.000000', 'temperatura', 1187.0000, 'ºC'),
	(62833, 111, '2015-02-15 00:00:27.000000', 'temperatura', 312.0000, 'ºC'),
	(62834, 111, '2015-02-15 00:00:28.000000', 'temperatura', 397.0000, 'ºC'),
	(62835, 111, '2015-02-15 00:00:29.000000', 'temperatura', 1053.0000, 'ºC'),
	(62836, 111, '2015-02-15 00:00:30.000000', 'temperatura', 473.0000, 'ºC'),
	(62837, 111, '2015-02-15 00:00:31.000000', 'temperatura', 406.0000, 'ºC'),
	(62838, 111, '2015-02-15 00:00:32.000000', 'temperatura', 611.0000, 'ºC'),
	(62839, 111, '2015-02-15 00:00:33.000000', 'temperatura', 640.0000, 'ºC'),
	(62840, 111, '2015-02-15 00:00:34.000000', 'temperatura', 164.0000, 'ºC'),
	(62841, 111, '2015-02-15 00:00:35.000000', 'temperatura', 103.0000, 'ºC'),
	(62842, 111, '2015-02-15 00:00:36.000000', 'temperatura', 21.0000, 'ºC'),
	(62843, 111, '2015-02-15 00:00:37.000000', 'temperatura', 996.0000, 'ºC'),
	(62844, 111, '2015-02-15 00:00:38.000000', 'temperatura', 121.0000, 'ºC'),
	(62845, 111, '2015-02-15 00:00:39.000000', 'temperatura', 14.0000, 'ºC'),
	(62846, 111, '2015-02-15 00:00:40.000000', 'temperatura', 911.0000, 'ºC'),
	(62847, 111, '2015-02-15 00:00:41.000000', 'temperatura', 910.0000, 'ºC'),
	(62848, 111, '2015-02-15 00:00:42.000000', 'temperatura', 618.0000, 'ºC'),
	(62849, 111, '2015-02-15 00:00:43.000000', 'temperatura', 363.0000, 'ºC'),
	(62850, 111, '2015-02-15 00:00:44.000000', 'temperatura', 1160.0000, 'ºC'),
	(62851, 111, '2015-02-15 00:00:45.000000', 'temperatura', 1109.0000, 'ºC'),
	(62852, 111, '2015-02-15 00:00:46.000000', 'temperatura', 869.0000, 'ºC'),
	(62853, 111, '2015-02-15 00:00:47.000000', 'temperatura', 1019.0000, 'ºC'),
	(62854, 111, '2015-02-15 00:00:48.000000', 'temperatura', 89.0000, 'ºC'),
	(62855, 111, '2015-02-15 00:00:49.000000', 'temperatura', 987.0000, 'ºC'),
	(62856, 111, '2015-02-15 00:00:50.000000', 'temperatura', 1068.0000, 'ºC'),
	(62857, 111, '2015-02-15 00:00:51.000000', 'temperatura', 1181.0000, 'ºC'),
	(62858, 111, '2015-02-15 00:00:52.000000', 'temperatura', 300.0000, 'ºC'),
	(62859, 111, '2015-02-15 00:00:53.000000', 'temperatura', 356.0000, 'ºC'),
	(62860, 111, '2015-02-15 00:00:54.000000', 'temperatura', 882.0000, 'ºC'),
	(62861, 111, '2015-02-15 00:00:55.000000', 'temperatura', 945.0000, 'ºC'),
	(62862, 111, '2015-02-15 00:00:56.000000', 'temperatura', 876.0000, 'ºC'),
	(62863, 111, '2015-02-15 00:00:57.000000', 'temperatura', 346.0000, 'ºC'),
	(62864, 111, '2015-02-15 00:00:58.000000', 'temperatura', 305.0000, 'ºC'),
	(62865, 111, '2015-02-15 00:00:59.000000', 'temperatura', 487.0000, 'ºC'),
	(62866, 111, '2015-02-15 00:01:00.000000', 'temperatura', 319.0000, 'ºC'),
	(62867, 111, '2015-02-15 00:01:01.000000', 'temperatura', 133.0000, 'ºC'),
	(62868, 111, '2015-02-15 00:01:02.000000', 'temperatura', 911.0000, 'ºC'),
	(62869, 111, '2015-02-15 00:01:03.000000', 'temperatura', 554.0000, 'ºC'),
	(62870, 111, '2015-02-15 00:01:04.000000', 'temperatura', 40.0000, 'ºC'),
	(62871, 111, '2015-02-15 00:01:05.000000', 'temperatura', 936.0000, 'ºC'),
	(62872, 111, '2015-02-15 00:01:06.000000', 'temperatura', 964.0000, 'ºC'),
	(62873, 111, '2015-02-15 00:01:07.000000', 'temperatura', 809.0000, 'ºC'),
	(62874, 111, '2015-02-15 00:01:08.000000', 'temperatura', 1157.0000, 'ºC'),
	(62875, 111, '2015-02-15 00:01:09.000000', 'temperatura', 955.0000, 'ºC'),
	(62876, 111, '2015-02-15 00:01:10.000000', 'temperatura', 106.0000, 'ºC'),
	(62877, 111, '2015-02-15 00:01:11.000000', 'temperatura', 64.0000, 'ºC'),
	(62878, 111, '2015-02-15 00:01:12.000000', 'temperatura', 3.0000, 'ºC'),
	(62879, 111, '2015-02-15 00:01:13.000000', 'temperatura', 1026.0000, 'ºC'),
	(62880, 111, '2015-02-15 00:01:14.000000', 'temperatura', 320.0000, 'ºC'),
	(62881, 111, '2015-02-15 00:01:15.000000', 'temperatura', 922.0000, 'ºC'),
	(62882, 111, '2015-02-15 00:01:16.000000', 'temperatura', 50.0000, 'ºC'),
	(62883, 111, '2015-02-15 00:01:17.000000', 'temperatura', 1086.0000, 'ºC'),
	(62884, 111, '2015-02-15 00:01:18.000000', 'temperatura', 481.0000, 'ºC'),
	(62885, 111, '2015-02-15 00:01:19.000000', 'temperatura', 347.0000, 'ºC'),
	(62886, 111, '2015-02-15 00:01:20.000000', 'temperatura', 292.0000, 'ºC'),
	(62887, 111, '2015-02-15 00:01:21.000000', 'temperatura', 422.0000, 'ºC'),
	(62888, 111, '2015-02-15 00:01:22.000000', 'temperatura', 32.0000, 'ºC'),
	(62889, 111, '2015-02-15 00:01:23.000000', 'temperatura', 95.0000, 'ºC'),
	(62890, 111, '2015-02-15 00:01:24.000000', 'temperatura', 380.0000, 'ºC'),
	(62891, 111, '2015-02-15 00:01:25.000000', 'temperatura', 417.0000, 'ºC'),
	(62892, 111, '2015-02-15 00:01:26.000000', 'temperatura', 943.0000, 'ºC'),
	(62893, 111, '2015-02-15 00:01:27.000000', 'temperatura', 1064.0000, 'ºC'),
	(62894, 111, '2015-02-15 00:01:28.000000', 'temperatura', 91.0000, 'ºC'),
	(62895, 111, '2015-02-15 00:01:29.000000', 'temperatura', 865.0000, 'ºC'),
	(62896, 111, '2015-02-15 00:01:30.000000', 'temperatura', 450.0000, 'ºC'),
	(62897, 111, '2015-02-15 00:01:31.000000', 'temperatura', 859.0000, 'ºC'),
	(62898, 111, '2015-02-15 00:01:32.000000', 'temperatura', 544.0000, 'ºC'),
	(62899, 111, '2015-02-15 00:01:33.000000', 'temperatura', 143.0000, 'ºC'),
	(62900, 111, '2015-02-15 00:01:34.000000', 'temperatura', 284.0000, 'ºC'),
	(62901, 111, '2015-02-15 00:01:35.000000', 'temperatura', 993.0000, 'ºC'),
	(62902, 111, '2015-02-15 00:01:36.000000', 'temperatura', 515.0000, 'ºC'),
	(62903, 111, '2015-02-15 00:01:37.000000', 'temperatura', 793.0000, 'ºC'),
	(62904, 111, '2015-02-15 00:01:38.000000', 'temperatura', 20.0000, 'ºC'),
	(62905, 111, '2015-02-15 00:01:39.000000', 'temperatura', 125.0000, 'ºC'),
	(62906, 111, '2015-02-15 00:01:40.000000', 'temperatura', 563.0000, 'ºC'),
	(62907, 111, '2015-02-15 00:01:41.000000', 'temperatura', 40.0000, 'ºC'),
	(62908, 111, '2015-02-15 00:01:42.000000', 'temperatura', 913.0000, 'ºC'),
	(62909, 111, '2015-02-15 00:01:43.000000', 'temperatura', 846.0000, 'ºC'),
	(62910, 111, '2015-02-15 00:01:44.000000', 'temperatura', 289.0000, 'ºC'),
	(62911, 111, '2015-02-15 00:01:45.000000', 'temperatura', 110.0000, 'ºC'),
	(62912, 111, '2015-02-15 00:01:46.000000', 'temperatura', 882.0000, 'ºC'),
	(62913, 111, '2015-02-15 00:01:47.000000', 'temperatura', 482.0000, 'ºC'),
	(62914, 111, '2015-02-15 00:01:48.000000', 'temperatura', 963.0000, 'ºC'),
	(62915, 111, '2015-02-15 00:01:49.000000', 'temperatura', 969.0000, 'ºC'),
	(62916, 111, '2015-02-15 00:01:50.000000', 'temperatura', 758.0000, 'ºC'),
	(62917, 111, '2015-02-15 00:01:51.000000', 'temperatura', 884.0000, 'ºC'),
	(62918, 111, '2015-02-15 00:01:52.000000', 'temperatura', 947.0000, 'ºC'),
	(62919, 111, '2015-02-15 00:01:53.000000', 'temperatura', 882.0000, 'ºC'),
	(62920, 111, '2015-02-15 00:01:54.000000', 'temperatura', 368.0000, 'ºC'),
	(62921, 111, '2015-02-15 00:01:55.000000', 'temperatura', 398.0000, 'ºC'),
	(62922, 111, '2015-02-15 00:01:56.000000', 'temperatura', 884.0000, 'ºC'),
	(62923, 111, '2015-02-15 00:01:57.000000', 'temperatura', 829.0000, 'ºC'),
	(62924, 111, '2015-02-15 00:01:58.000000', 'temperatura', 293.0000, 'ºC'),
	(62925, 111, '2015-02-15 00:01:59.000000', 'temperatura', 179.0000, 'ºC'),
	(62926, 111, '2015-02-15 00:02:00.000000', 'temperatura', 16.0000, 'ºC'),
	(62927, 111, '2015-02-15 00:02:01.000000', 'temperatura', 742.0000, 'ºC'),
	(62928, 111, '2015-02-15 00:02:02.000000', 'temperatura', 64.0000, 'ºC'),
	(62929, 111, '2015-02-15 00:02:03.000000', 'temperatura', 496.0000, 'ºC'),
	(62930, 111, '2015-02-15 00:02:04.000000', 'temperatura', 1087.0000, 'ºC'),
	(62931, 111, '2015-02-15 00:02:05.000000', 'temperatura', 347.0000, 'ºC'),
	(62932, 111, '2015-02-15 00:02:06.000000', 'temperatura', 875.0000, 'ºC'),
	(62933, 111, '2015-02-15 00:02:07.000000', 'temperatura', 934.0000, 'ºC'),
	(62934, 111, '2015-02-15 00:02:08.000000', 'temperatura', 847.0000, 'ºC'),
	(62935, 111, '2015-02-15 00:02:09.000000', 'temperatura', 233.0000, 'ºC'),
	(62936, 111, '2015-02-15 00:02:10.000000', 'temperatura', 1023.0000, 'ºC'),
	(62937, 111, '2015-02-15 00:02:11.000000', 'temperatura', 817.0000, 'ºC'),
	(62938, 111, '2015-02-15 00:02:12.000000', 'temperatura', 1018.0000, 'ºC'),
	(62939, 111, '2015-02-15 00:02:13.000000', 'temperatura', 237.0000, 'ºC'),
	(62940, 111, '2015-02-15 00:02:14.000000', 'temperatura', 532.0000, 'ºC'),
	(62941, 111, '2015-02-15 00:02:15.000000', 'temperatura', 748.0000, 'ºC'),
	(62942, 111, '2015-02-15 00:02:16.000000', 'temperatura', 946.0000, 'ºC'),
	(62943, 111, '2015-02-15 00:02:17.000000', 'temperatura', 86.0000, 'ºC'),
	(62944, 111, '2015-02-15 00:02:18.000000', 'temperatura', 1192.0000, 'ºC'),
	(62945, 111, '2015-02-15 00:02:19.000000', 'temperatura', 905.0000, 'ºC'),
	(62946, 111, '2015-02-15 00:02:20.000000', 'temperatura', 947.0000, 'ºC'),
	(62947, 111, '2015-02-15 00:02:21.000000', 'temperatura', 820.0000, 'ºC'),
	(62948, 111, '2015-02-15 00:02:22.000000', 'temperatura', 61.0000, 'ºC'),
	(62949, 111, '2015-02-15 00:02:23.000000', 'temperatura', 246.0000, 'ºC'),
	(62950, 111, '2015-02-15 00:02:24.000000', 'temperatura', 1045.0000, 'ºC'),
	(62951, 111, '2015-02-15 00:02:25.000000', 'temperatura', 888.0000, 'ºC'),
	(62952, 111, '2015-02-15 00:02:26.000000', 'temperatura', 105.0000, 'ºC'),
	(62953, 111, '2015-02-15 00:02:27.000000', 'temperatura', 263.0000, 'ºC'),
	(62954, 111, '2015-02-15 00:02:28.000000', 'temperatura', 998.0000, 'ºC'),
	(62955, 111, '2015-02-15 00:02:29.000000', 'temperatura', 604.0000, 'ºC'),
	(62956, 111, '2015-02-15 00:02:30.000000', 'temperatura', 25.0000, 'ºC'),
	(62957, 111, '2015-02-15 00:02:31.000000', 'temperatura', 714.0000, 'ºC'),
	(62958, 111, '2015-02-15 00:02:32.000000', 'temperatura', 1095.0000, 'ºC'),
	(62959, 111, '2015-02-15 00:02:33.000000', 'temperatura', 936.0000, 'ºC'),
	(62960, 111, '2015-02-15 00:02:34.000000', 'temperatura', 192.0000, 'ºC'),
	(62961, 111, '2015-02-15 00:02:35.000000', 'temperatura', 555.0000, 'ºC'),
	(62962, 111, '2015-02-15 00:02:36.000000', 'temperatura', 998.0000, 'ºC'),
	(62963, 111, '2015-02-15 00:02:37.000000', 'temperatura', 928.0000, 'ºC'),
	(62964, 111, '2015-02-15 00:02:38.000000', 'temperatura', 445.0000, 'ºC'),
	(62965, 111, '2015-02-15 00:02:39.000000', 'temperatura', 642.0000, 'ºC'),
	(62966, 111, '2015-02-15 00:02:40.000000', 'temperatura', 673.0000, 'ºC'),
	(62967, 111, '2015-02-15 00:02:41.000000', 'temperatura', 243.0000, 'ºC'),
	(62968, 111, '2015-02-15 00:02:42.000000', 'temperatura', 395.0000, 'ºC'),
	(62969, 111, '2015-02-15 00:02:43.000000', 'temperatura', 45.0000, 'ºC'),
	(62970, 111, '2015-02-15 00:02:44.000000', 'temperatura', 242.0000, 'ºC'),
	(62971, 111, '2015-02-15 00:02:45.000000', 'temperatura', 1073.0000, 'ºC'),
	(62972, 111, '2015-02-15 00:02:46.000000', 'temperatura', 1043.0000, 'ºC'),
	(62973, 111, '2015-02-15 00:02:47.000000', 'temperatura', 794.0000, 'ºC'),
	(62974, 111, '2015-02-15 00:02:48.000000', 'temperatura', 840.0000, 'ºC'),
	(62975, 111, '2015-02-15 00:02:49.000000', 'temperatura', 621.0000, 'ºC'),
	(62976, 111, '2015-02-15 00:02:50.000000', 'temperatura', 584.0000, 'ºC'),
	(62977, 111, '2015-02-15 00:02:51.000000', 'temperatura', 1058.0000, 'ºC'),
	(62978, 111, '2015-02-15 00:02:52.000000', 'temperatura', 1137.0000, 'ºC'),
	(62979, 111, '2015-02-15 00:02:53.000000', 'temperatura', 112.0000, 'ºC'),
	(62980, 111, '2015-02-15 00:02:54.000000', 'temperatura', 749.0000, 'ºC'),
	(62981, 111, '2015-02-15 00:02:55.000000', 'temperatura', 1012.0000, 'ºC'),
	(62982, 111, '2015-02-15 00:02:56.000000', 'temperatura', 411.0000, 'ºC'),
	(62983, 111, '2015-02-15 00:02:57.000000', 'temperatura', 221.0000, 'ºC'),
	(62984, 111, '2015-02-15 00:02:58.000000', 'temperatura', 1074.0000, 'ºC'),
	(62985, 111, '2015-02-15 00:02:59.000000', 'temperatura', 1105.0000, 'ºC'),
	(62986, 111, '2015-02-15 00:03:00.000000', 'temperatura', 1104.0000, 'ºC'),
	(62987, 111, '2015-02-15 00:03:01.000000', 'temperatura', 1005.0000, 'ºC'),
	(62988, 111, '2015-02-15 00:03:02.000000', 'temperatura', 515.0000, 'ºC'),
	(62989, 111, '2015-02-15 00:03:03.000000', 'temperatura', 758.0000, 'ºC'),
	(62990, 111, '2015-02-15 00:03:04.000000', 'temperatura', 1047.0000, 'ºC'),
	(62991, 111, '2015-02-15 00:03:05.000000', 'temperatura', 560.0000, 'ºC'),
	(62992, 111, '2015-02-15 00:03:06.000000', 'temperatura', 861.0000, 'ºC'),
	(62993, 111, '2015-02-15 00:03:07.000000', 'temperatura', 225.0000, 'ºC'),
	(62994, 111, '2015-02-15 00:03:08.000000', 'temperatura', 944.0000, 'ºC'),
	(62995, 111, '2015-02-15 00:03:09.000000', 'temperatura', 443.0000, 'ºC'),
	(62996, 111, '2015-02-15 00:03:10.000000', 'temperatura', 582.0000, 'ºC'),
	(62997, 111, '2015-02-15 00:03:11.000000', 'temperatura', 385.0000, 'ºC'),
	(62998, 111, '2015-02-15 00:03:12.000000', 'temperatura', 180.0000, 'ºC'),
	(62999, 111, '2015-02-15 00:03:13.000000', 'temperatura', 945.0000, 'ºC'),
	(63000, 111, '2015-02-15 00:03:14.000000', 'temperatura', 583.0000, 'ºC'),
	(63001, 111, '2015-02-15 00:03:15.000000', 'temperatura', 84.0000, 'ºC'),
	(63002, 111, '2015-02-15 00:03:16.000000', 'temperatura', 1070.0000, 'ºC'),
	(63003, 111, '2015-02-15 00:03:17.000000', 'temperatura', 298.0000, 'ºC'),
	(63004, 111, '2015-02-15 00:03:18.000000', 'temperatura', 679.0000, 'ºC'),
	(63005, 111, '2015-02-15 00:03:19.000000', 'temperatura', 103.0000, 'ºC'),
	(63006, 111, '2015-02-15 00:03:20.000000', 'temperatura', 877.0000, 'ºC'),
	(63007, 111, '2015-02-15 00:03:21.000000', 'temperatura', 479.0000, 'ºC'),
	(63008, 111, '2015-02-15 00:03:22.000000', 'temperatura', 962.0000, 'ºC'),
	(63009, 111, '2015-02-15 00:03:23.000000', 'temperatura', 976.0000, 'ºC'),
	(63010, 111, '2015-02-15 00:03:24.000000', 'temperatura', 795.0000, 'ºC'),
	(63011, 111, '2015-02-15 00:03:25.000000', 'temperatura', 1047.0000, 'ºC'),
	(63012, 111, '2015-02-15 00:03:26.000000', 'temperatura', 449.0000, 'ºC'),
	(63013, 111, '2015-02-15 00:03:27.000000', 'temperatura', 305.0000, 'ºC'),
	(63014, 111, '2015-02-15 00:03:28.000000', 'temperatura', 181.0000, 'ºC'),
	(63015, 111, '2015-02-15 00:03:29.000000', 'temperatura', 1188.0000, 'ºC'),
	(63016, 111, '2015-02-15 00:03:30.000000', 'temperatura', 598.0000, 'ºC'),
	(63017, 111, '2015-02-15 00:03:31.000000', 'temperatura', 626.0000, 'ºC'),
	(63018, 111, '2015-02-15 00:03:32.000000', 'temperatura', 138.0000, 'ºC'),
	(63019, 111, '2015-02-15 00:03:33.000000', 'temperatura', 11.0000, 'ºC'),
	(63020, 111, '2015-02-15 00:03:34.000000', 'temperatura', 842.0000, 'ºC'),
	(63021, 111, '2015-02-15 00:03:35.000000', 'temperatura', 577.0000, 'ºC'),
	(63022, 111, '2015-02-15 00:03:36.000000', 'temperatura', 362.0000, 'ºC'),
	(63023, 111, '2015-02-15 00:03:37.000000', 'temperatura', 78.0000, 'ºC'),
	(63024, 111, '2015-02-15 00:03:38.000000', 'temperatura', 504.0000, 'ºC'),
	(63025, 111, '2015-02-15 00:03:39.000000', 'temperatura', 1085.0000, 'ºC'),
	(63026, 111, '2015-02-15 00:03:40.000000', 'temperatura', 316.0000, 'ºC'),
	(63027, 111, '2015-02-15 00:03:41.000000', 'temperatura', 727.0000, 'ºC'),
	(63028, 111, '2015-02-15 00:03:42.000000', 'temperatura', 284.0000, 'ºC'),
	(63029, 111, '2015-02-15 00:03:43.000000', 'temperatura', 442.0000, 'ºC'),
	(63030, 111, '2015-02-15 00:03:44.000000', 'temperatura', 160.0000, 'ºC'),
	(63031, 111, '2015-02-15 00:03:45.000000', 'temperatura', 671.0000, 'ºC'),
	(63032, 111, '2015-02-15 00:03:46.000000', 'temperatura', 479.0000, 'ºC'),
	(63033, 111, '2015-02-15 00:03:47.000000', 'temperatura', 380.0000, 'ºC'),
	(63034, 111, '2015-02-15 00:03:48.000000', 'temperatura', 465.0000, 'ºC'),
	(63035, 111, '2015-02-15 00:03:49.000000', 'temperatura', 1186.0000, 'ºC'),
	(63036, 111, '2015-02-15 00:03:50.000000', 'temperatura', 933.0000, 'ºC'),
	(63037, 111, '2015-02-15 00:03:51.000000', 'temperatura', 1110.0000, 'ºC'),
	(63038, 111, '2015-02-15 00:03:52.000000', 'temperatura', 350.0000, 'ºC'),
	(63039, 111, '2015-02-15 00:03:53.000000', 'temperatura', 822.0000, 'ºC'),
	(63040, 111, '2015-02-15 00:03:54.000000', 'temperatura', 661.0000, 'ºC'),
	(63041, 111, '2015-02-15 00:03:55.000000', 'temperatura', 840.0000, 'ºC'),
	(63042, 111, '2015-02-15 00:03:56.000000', 'temperatura', 1016.0000, 'ºC'),
	(63043, 111, '2015-02-15 00:03:57.000000', 'temperatura', 160.0000, 'ºC'),
	(63044, 111, '2015-02-15 00:03:58.000000', 'temperatura', 155.0000, 'ºC'),
	(63045, 111, '2015-02-15 00:03:59.000000', 'temperatura', 295.0000, 'ºC'),
	(63046, 111, '2015-02-15 00:04:00.000000', 'temperatura', 1011.0000, 'ºC'),
	(63047, 111, '2015-02-15 00:04:01.000000', 'temperatura', 571.0000, 'ºC'),
	(63048, 111, '2015-02-15 00:04:02.000000', 'temperatura', 1021.0000, 'ºC'),
	(63049, 111, '2015-02-15 00:04:03.000000', 'temperatura', 992.0000, 'ºC'),
	(63050, 111, '2015-02-15 00:04:04.000000', 'temperatura', 700.0000, 'ºC'),
	(63051, 111, '2015-02-15 00:04:05.000000', 'temperatura', 522.0000, 'ºC'),
	(63052, 111, '2015-02-15 00:04:06.000000', 'temperatura', 511.0000, 'ºC'),
	(63053, 111, '2015-02-15 00:04:07.000000', 'temperatura', 989.0000, 'ºC'),
	(63054, 111, '2015-02-15 00:04:08.000000', 'temperatura', 1012.0000, 'ºC'),
	(63055, 111, '2015-02-15 00:04:09.000000', 'temperatura', 893.0000, 'ºC'),
	(63056, 111, '2015-02-15 00:04:10.000000', 'temperatura', 229.0000, 'ºC'),
	(63057, 111, '2015-02-15 00:04:11.000000', 'temperatura', 869.0000, 'ºC'),
	(63058, 111, '2015-02-15 00:04:12.000000', 'temperatura', 58.0000, 'ºC'),
	(63059, 111, '2015-02-15 00:04:13.000000', 'temperatura', 83.0000, 'ºC'),
	(63060, 111, '2015-02-15 00:04:14.000000', 'temperatura', 240.0000, 'ºC'),
	(63061, 111, '2015-02-15 00:04:15.000000', 'temperatura', 951.0000, 'ºC'),
	(63062, 111, '2015-02-15 00:04:16.000000', 'temperatura', 437.0000, 'ºC'),
	(63063, 111, '2015-02-15 00:04:17.000000', 'temperatura', 533.0000, 'ºC'),
	(63064, 111, '2015-02-15 00:04:18.000000', 'temperatura', 153.0000, 'ºC'),
	(63065, 111, '2015-02-15 00:04:19.000000', 'temperatura', 366.0000, 'ºC'),
	(63066, 111, '2015-02-15 00:04:20.000000', 'temperatura', 173.0000, 'ºC'),
	(63067, 111, '2015-02-15 00:04:21.000000', 'temperatura', 968.0000, 'ºC'),
	(63068, 111, '2015-02-15 00:04:22.000000', 'temperatura', 721.0000, 'ºC'),
	(63069, 111, '2015-02-15 00:04:23.000000', 'temperatura', 700.0000, 'ºC'),
	(63070, 111, '2015-02-15 00:04:24.000000', 'temperatura', 139.0000, 'ºC'),
	(63071, 111, '2015-02-15 00:04:25.000000', 'temperatura', 997.0000, 'ºC'),
	(63072, 111, '2015-02-15 00:04:26.000000', 'temperatura', 967.0000, 'ºC'),
	(63073, 111, '2015-02-15 00:04:27.000000', 'temperatura', 647.0000, 'ºC'),
	(63074, 111, '2015-02-15 00:04:28.000000', 'temperatura', 331.0000, 'ºC'),
	(63075, 111, '2015-02-15 00:04:29.000000', 'temperatura', 918.0000, 'ºC'),
	(63076, 111, '2015-02-15 00:04:30.000000', 'temperatura', 1195.0000, 'ºC'),
	(63077, 111, '2015-02-15 00:04:31.000000', 'temperatura', 823.0000, 'ºC'),
	(63078, 111, '2015-02-15 00:04:32.000000', 'temperatura', 531.0000, 'ºC'),
	(63079, 111, '2015-02-15 00:04:33.000000', 'temperatura', 185.0000, 'ºC'),
	(63080, 111, '2015-02-15 00:04:34.000000', 'temperatura', 535.0000, 'ºC'),
	(63081, 111, '2015-02-15 00:04:35.000000', 'temperatura', 918.0000, 'ºC'),
	(63082, 111, '2015-02-15 00:04:36.000000', 'temperatura', 586.0000, 'ºC'),
	(63083, 111, '2015-02-15 00:04:37.000000', 'temperatura', 175.0000, 'ºC'),
	(63084, 111, '2015-02-15 00:04:38.000000', 'temperatura', 318.0000, 'ºC'),
	(63085, 111, '2015-02-15 00:04:39.000000', 'temperatura', 1068.0000, 'ºC'),
	(63086, 111, '2015-02-15 00:04:40.000000', 'temperatura', 785.0000, 'ºC'),
	(63087, 111, '2015-02-15 00:04:41.000000', 'temperatura', 722.0000, 'ºC'),
	(63088, 111, '2015-02-15 00:04:42.000000', 'temperatura', 54.0000, 'ºC'),
	(63089, 111, '2015-02-15 00:04:43.000000', 'temperatura', 506.0000, 'ºC'),
	(63090, 111, '2015-02-15 00:04:44.000000', 'temperatura', 1168.0000, 'ºC'),
	(63091, 111, '2015-02-15 00:04:45.000000', 'temperatura', 724.0000, 'ºC'),
	(63092, 111, '2015-02-15 00:04:46.000000', 'temperatura', 116.0000, 'ºC'),
	(63093, 111, '2015-02-15 00:04:47.000000', 'temperatura', 809.0000, 'ºC'),
	(63094, 111, '2015-02-15 00:04:48.000000', 'temperatura', 95.0000, 'ºC'),
	(63095, 111, '2015-02-15 00:04:49.000000', 'temperatura', 451.0000, 'ºC'),
	(63096, 111, '2015-02-15 00:04:50.000000', 'temperatura', 769.0000, 'ºC'),
	(63097, 111, '2015-02-15 00:04:51.000000', 'temperatura', 91.0000, 'ºC'),
	(63098, 111, '2015-02-15 00:04:52.000000', 'temperatura', 551.0000, 'ºC'),
	(63099, 111, '2015-02-15 00:04:53.000000', 'temperatura', 80.0000, 'ºC'),
	(63100, 111, '2015-02-15 00:04:54.000000', 'temperatura', 1148.0000, 'ºC'),
	(63101, 111, '2015-02-15 00:04:55.000000', 'temperatura', 702.0000, 'ºC'),
	(63102, 111, '2015-02-15 00:04:56.000000', 'temperatura', 64.0000, 'ºC'),
	(63103, 111, '2015-02-15 00:04:57.000000', 'temperatura', 618.0000, 'ºC'),
	(63104, 111, '2015-02-15 00:04:58.000000', 'temperatura', 496.0000, 'ºC'),
	(63105, 111, '2015-02-15 00:04:59.000000', 'temperatura', 628.0000, 'ºC'),
	(63106, 111, '2015-02-15 00:05:00.000000', 'temperatura', 450.0000, 'ºC'),
	(63107, 111, '2015-02-15 00:05:01.000000', 'temperatura', 369.0000, 'ºC'),
	(63108, 111, '2015-02-15 00:05:02.000000', 'temperatura', 494.0000, 'ºC'),
	(63109, 111, '2015-02-15 00:05:03.000000', 'temperatura', 166.0000, 'ºC'),
	(63110, 111, '2015-02-15 00:05:04.000000', 'temperatura', 545.0000, 'ºC'),
	(63111, 111, '2015-02-15 00:05:05.000000', 'temperatura', 1030.0000, 'ºC'),
	(63112, 111, '2015-02-15 00:05:06.000000', 'temperatura', 1113.0000, 'ºC'),
	(63113, 111, '2015-02-15 00:05:07.000000', 'temperatura', 77.0000, 'ºC'),
	(63114, 111, '2015-02-15 00:05:08.000000', 'temperatura', 646.0000, 'ºC'),
	(63115, 111, '2015-02-15 00:05:09.000000', 'temperatura', 598.0000, 'ºC'),
	(63116, 111, '2015-02-15 00:05:10.000000', 'temperatura', 1053.0000, 'ºC'),
	(63117, 111, '2015-02-15 00:05:11.000000', 'temperatura', 1073.0000, 'ºC'),
	(63118, 111, '2015-02-15 00:05:12.000000', 'temperatura', 1007.0000, 'ºC'),
	(63119, 111, '2015-02-15 00:05:13.000000', 'temperatura', 614.0000, 'ºC'),
	(63120, 111, '2015-02-15 00:05:14.000000', 'temperatura', 52.0000, 'ºC'),
	(63121, 111, '2015-02-15 00:05:15.000000', 'temperatura', 818.0000, 'ºC'),
	(63122, 111, '2015-02-15 00:05:16.000000', 'temperatura', 335.0000, 'ºC'),
	(63123, 111, '2015-02-15 00:05:17.000000', 'temperatura', 421.0000, 'ºC'),
	(63124, 111, '2015-02-15 00:05:18.000000', 'temperatura', 1099.0000, 'ºC'),
	(63125, 111, '2015-02-15 00:05:19.000000', 'temperatura', 635.0000, 'ºC'),
	(63126, 111, '2015-02-15 00:05:20.000000', 'temperatura', 1076.0000, 'ºC'),
	(63127, 111, '2015-02-15 00:05:21.000000', 'temperatura', 1076.0000, 'ºC'),
	(63128, 111, '2015-02-15 00:05:22.000000', 'temperatura', 955.0000, 'ºC'),
	(63129, 111, '2015-02-15 00:05:23.000000', 'temperatura', 345.0000, 'ºC'),
	(63130, 111, '2015-02-15 00:05:24.000000', 'temperatura', 63.0000, 'ºC'),
	(63131, 111, '2015-02-15 00:05:25.000000', 'temperatura', 477.0000, 'ºC'),
	(63132, 111, '2015-02-15 00:05:26.000000', 'temperatura', 1000.0000, 'ºC'),
	(63133, 111, '2015-02-15 00:05:27.000000', 'temperatura', 1167.0000, 'ºC'),
	(63134, 111, '2015-02-15 00:05:28.000000', 'temperatura', 435.0000, 'ºC'),
	(63135, 111, '2015-02-15 00:05:29.000000', 'temperatura', 1077.0000, 'ºC'),
	(63136, 111, '2015-02-15 00:05:30.000000', 'temperatura', 478.0000, 'ºC'),
	(63137, 111, '2015-02-15 00:05:31.000000', 'temperatura', 359.0000, 'ºC'),
	(63138, 111, '2015-02-15 00:05:32.000000', 'temperatura', 361.0000, 'ºC'),
	(63139, 111, '2015-02-15 00:05:33.000000', 'temperatura', 729.0000, 'ºC'),
	(63140, 111, '2015-02-15 00:05:34.000000', 'temperatura', 161.0000, 'ºC'),
	(63141, 111, '2015-02-15 00:05:35.000000', 'temperatura', 1021.0000, 'ºC'),
	(63142, 111, '2015-02-15 00:05:36.000000', 'temperatura', 1024.0000, 'ºC'),
	(63143, 111, '2015-02-15 00:05:37.000000', 'temperatura', 854.0000, 'ºC'),
	(63144, 111, '2015-02-15 00:05:38.000000', 'temperatura', 1199.0000, 'ºC'),
	(63145, 111, '2015-02-15 00:05:39.000000', 'temperatura', 1033.0000, 'ºC'),
	(63146, 111, '2015-02-15 00:05:40.000000', 'temperatura', 370.0000, 'ºC'),
	(63147, 111, '2015-02-15 00:05:41.000000', 'temperatura', 1153.0000, 'ºC'),
	(63148, 111, '2015-02-15 00:05:42.000000', 'temperatura', 1053.0000, 'ºC'),
	(63149, 111, '2015-02-15 00:05:43.000000', 'temperatura', 606.0000, 'ºC'),
	(63150, 111, '2015-02-15 00:05:44.000000', 'temperatura', 1072.0000, 'ºC'),
	(63151, 111, '2015-02-15 00:05:45.000000', 'temperatura', 1144.0000, 'ºC'),
	(63152, 111, '2015-02-15 00:05:46.000000', 'temperatura', 102.0000, 'ºC'),
	(63153, 111, '2015-02-15 00:05:47.000000', 'temperatura', 678.0000, 'ºC'),
	(63154, 111, '2015-02-15 00:05:48.000000', 'temperatura', 688.0000, 'ºC'),
	(63155, 111, '2015-02-15 00:05:49.000000', 'temperatura', 203.0000, 'ºC'),
	(63156, 111, '2015-02-15 00:05:50.000000', 'temperatura', 153.0000, 'ºC'),
	(63157, 111, '2015-02-15 00:05:51.000000', 'temperatura', 155.0000, 'ºC'),
	(63158, 111, '2015-02-15 00:05:52.000000', 'temperatura', 319.0000, 'ºC'),
	(63159, 111, '2015-02-15 00:05:53.000000', 'temperatura', 1129.0000, 'ºC'),
	(63160, 111, '2015-02-15 00:05:54.000000', 'temperatura', 1089.0000, 'ºC'),
	(63161, 111, '2015-02-15 00:05:55.000000', 'temperatura', 857.0000, 'ºC'),
	(63162, 111, '2015-02-15 00:05:56.000000', 'temperatura', 1018.0000, 'ºC'),
	(63163, 111, '2015-02-15 00:05:57.000000', 'temperatura', 119.0000, 'ºC'),
	(63164, 111, '2015-02-15 00:05:58.000000', 'temperatura', 1144.0000, 'ºC'),
	(63165, 111, '2015-02-15 00:05:59.000000', 'temperatura', 562.0000, 'ºC'),
	(63166, 111, '2015-02-15 00:06:00.000000', 'temperatura', 578.0000, 'ºC'),
	(63167, 111, '2015-02-15 00:06:01.000000', 'temperatura', 5.0000, 'ºC'),
	(63168, 111, '2015-02-15 00:06:02.000000', 'temperatura', 693.0000, 'ºC'),
	(63169, 111, '2015-02-15 00:06:03.000000', 'temperatura', 1048.0000, 'ºC'),
	(63170, 111, '2015-02-15 00:06:04.000000', 'temperatura', 761.0000, 'ºC'),
	(63171, 111, '2015-02-15 00:06:05.000000', 'temperatura', 663.0000, 'ºC'),
	(63172, 111, '2015-02-15 00:06:06.000000', 'temperatura', 1030.0000, 'ºC'),
	(63173, 111, '2015-02-15 00:06:07.000000', 'temperatura', 765.0000, 'ºC'),
	(63174, 111, '2015-02-15 00:06:08.000000', 'temperatura', 734.0000, 'ºC'),
	(63175, 111, '2015-02-15 00:06:09.000000', 'temperatura', 174.0000, 'ºC'),
	(63176, 111, '2015-02-15 00:06:10.000000', 'temperatura', 1070.0000, 'ºC'),
	(63177, 111, '2015-02-15 00:06:11.000000', 'temperatura', 28.0000, 'ºC'),
	(63178, 111, '2015-02-15 00:06:12.000000', 'temperatura', 531.0000, 'ºC'),
	(63179, 111, '2015-02-15 00:06:13.000000', 'temperatura', 172.0000, 'ºC'),
	(63180, 111, '2015-02-15 00:06:14.000000', 'temperatura', 467.0000, 'ºC'),
	(63181, 111, '2015-02-15 00:06:15.000000', 'temperatura', 620.0000, 'ºC'),
	(63182, 111, '2015-02-15 00:06:16.000000', 'temperatura', 501.0000, 'ºC'),
	(63183, 111, '2015-02-15 00:06:17.000000', 'temperatura', 642.0000, 'ºC'),
	(63184, 111, '2015-02-15 00:06:18.000000', 'temperatura', 511.0000, 'ºC'),
	(63185, 111, '2015-02-15 00:06:19.000000', 'temperatura', 627.0000, 'ºC'),
	(63186, 111, '2015-02-15 00:06:20.000000', 'temperatura', 403.0000, 'ºC'),
	(63187, 111, '2015-02-15 00:06:21.000000', 'temperatura', 134.0000, 'ºC'),
	(63188, 111, '2015-02-15 00:06:22.000000', 'temperatura', 661.0000, 'ºC'),
	(63189, 111, '2015-02-15 00:06:23.000000', 'temperatura', 505.0000, 'ºC'),
	(63190, 111, '2015-02-15 00:06:24.000000', 'temperatura', 544.0000, 'ºC'),
	(63191, 111, '2015-02-15 00:06:25.000000', 'temperatura', 4.0000, 'ºC'),
	(63192, 111, '2015-02-15 00:06:26.000000', 'temperatura', 790.0000, 'ºC'),
	(63193, 111, '2015-02-15 00:06:27.000000', 'temperatura', 339.0000, 'ºC'),
	(63194, 111, '2015-02-15 00:06:28.000000', 'temperatura', 522.0000, 'ºC'),
	(63195, 111, '2015-02-15 00:06:29.000000', 'temperatura', 397.0000, 'ºC'),
	(63196, 111, '2015-02-15 00:06:30.000000', 'temperatura', 416.0000, 'ºC'),
	(63197, 111, '2015-02-15 00:06:31.000000', 'temperatura', 892.0000, 'ºC'),
	(63198, 111, '2015-02-15 00:06:32.000000', 'temperatura', 812.0000, 'ºC'),
	(63199, 111, '2015-02-15 00:06:33.000000', 'temperatura', 183.0000, 'ºC'),
	(63200, 111, '2015-02-15 00:06:34.000000', 'temperatura', 882.0000, 'ºC'),
	(63201, 111, '2015-02-15 00:06:35.000000', 'temperatura', 259.0000, 'ºC'),
	(63202, 111, '2015-02-15 00:06:36.000000', 'temperatura', 1051.0000, 'ºC'),
	(63203, 111, '2015-02-15 00:06:37.000000', 'temperatura', 879.0000, 'ºC'),
	(63204, 111, '2015-02-15 00:06:38.000000', 'temperatura', 42.0000, 'ºC'),
	(63205, 111, '2015-02-15 00:06:39.000000', 'temperatura', 1172.0000, 'ºC'),
	(63206, 111, '2015-02-15 00:06:40.000000', 'temperatura', 934.0000, 'ºC'),
	(63207, 111, '2015-02-15 00:06:41.000000', 'temperatura', 1154.0000, 'ºC'),
	(63208, 111, '2015-02-15 00:06:42.000000', 'temperatura', 571.0000, 'ºC'),
	(63209, 111, '2015-02-15 00:06:43.000000', 'temperatura', 590.0000, 'ºC'),
	(63210, 111, '2015-02-15 00:06:44.000000', 'temperatura', 41.0000, 'ºC'),
	(63211, 111, '2015-02-15 00:06:45.000000', 'temperatura', 834.0000, 'ºC'),
	(63212, 111, '2015-02-15 00:06:46.000000', 'temperatura', 448.0000, 'ºC'),
	(63213, 111, '2015-02-15 00:06:47.000000', 'temperatura', 940.0000, 'ºC'),
	(63214, 111, '2015-02-15 00:06:48.000000', 'temperatura', 955.0000, 'ºC'),
	(63215, 111, '2015-02-15 00:06:49.000000', 'temperatura', 757.0000, 'ºC'),
	(63216, 111, '2015-02-15 00:06:50.000000', 'temperatura', 918.0000, 'ºC'),
	(63217, 111, '2015-02-15 00:06:51.000000', 'temperatura', 1122.0000, 'ºC'),
	(63218, 111, '2015-02-15 00:06:52.000000', 'temperatura', 454.0000, 'ºC'),
	(63219, 111, '2015-02-15 00:06:53.000000', 'temperatura', 105.0000, 'ºC'),
	(63220, 111, '2015-02-15 00:06:54.000000', 'temperatura', 362.0000, 'ºC'),
	(63221, 111, '2015-02-15 00:06:55.000000', 'temperatura', 299.0000, 'ºC'),
	(63222, 111, '2015-02-15 00:06:56.000000', 'temperatura', 406.0000, 'ºC'),
	(63223, 111, '2015-02-15 00:06:57.000000', 'temperatura', 1137.0000, 'ºC'),
	(63224, 111, '2015-02-15 00:06:58.000000', 'temperatura', 866.0000, 'ºC'),
	(63225, 111, '2015-02-15 00:06:59.000000', 'temperatura', 920.0000, 'ºC'),
	(63226, 111, '2015-02-15 00:07:00.000000', 'temperatura', 801.0000, 'ºC'),
	(63227, 111, '2015-02-15 00:07:01.000000', 'temperatura', 48.0000, 'ºC'),
	(63228, 111, '2015-02-15 00:07:02.000000', 'temperatura', 238.0000, 'ºC'),
	(63229, 111, '2015-02-15 00:07:03.000000', 'temperatura', 1045.0000, 'ºC'),
	(63230, 111, '2015-02-15 00:07:04.000000', 'temperatura', 911.0000, 'ºC'),
	(63231, 111, '2015-02-15 00:07:05.000000', 'temperatura', 221.0000, 'ºC'),
	(63232, 111, '2015-02-15 00:07:06.000000', 'temperatura', 773.0000, 'ºC'),
	(63233, 111, '2015-02-15 00:07:07.000000', 'temperatura', 801.0000, 'ºC'),
	(63234, 111, '2015-02-15 00:07:08.000000', 'temperatura', 489.0000, 'ºC'),
	(63235, 111, '2015-02-15 00:07:09.000000', 'temperatura', 41.0000, 'ºC'),
	(63236, 111, '2015-02-15 00:07:10.000000', 'temperatura', 1138.0000, 'ºC'),
	(63237, 111, '2015-02-15 00:07:11.000000', 'temperatura', 767.0000, 'ºC'),
	(63238, 111, '2015-02-15 00:07:12.000000', 'temperatura', 422.0000, 'ºC'),
	(63239, 111, '2015-02-15 00:07:13.000000', 'temperatura', 1008.0000, 'ºC'),
	(63240, 111, '2015-02-15 00:07:14.000000', 'temperatura', 174.0000, 'ºC'),
	(63241, 111, '2015-02-15 00:07:15.000000', 'temperatura', 247.0000, 'ºC'),
	(63242, 111, '2015-02-15 00:07:16.000000', 'temperatura', 714.0000, 'ºC'),
	(63243, 111, '2015-02-15 00:07:17.000000', 'temperatura', 427.0000, 'ºC'),
	(63244, 111, '2015-02-15 00:07:18.000000', 'temperatura', 1197.0000, 'ºC'),
	(63245, 111, '2015-02-15 00:07:19.000000', 'temperatura', 1102.0000, 'ºC'),
	(63246, 111, '2015-02-15 00:07:20.000000', 'temperatura', 722.0000, 'ºC'),
	(63247, 111, '2015-02-15 00:07:21.000000', 'temperatura', 301.0000, 'ºC'),
	(63248, 111, '2015-02-15 00:07:22.000000', 'temperatura', 543.0000, 'ºC'),
	(63249, 111, '2015-02-15 00:07:23.000000', 'temperatura', 612.0000, 'ºC'),
	(63250, 111, '2015-02-15 00:07:24.000000', 'temperatura', 233.0000, 'ºC'),
	(63251, 111, '2015-02-15 00:07:25.000000', 'temperatura', 528.0000, 'ºC'),
	(63252, 111, '2015-02-15 00:07:26.000000', 'temperatura', 743.0000, 'ºC'),
	(63253, 111, '2015-02-15 00:07:27.000000', 'temperatura', 931.0000, 'ºC'),
	(63254, 111, '2015-02-15 00:07:28.000000', 'temperatura', 27.0000, 'ºC'),
	(63255, 111, '2015-02-15 00:07:29.000000', 'temperatura', 944.0000, 'ºC'),
	(63256, 111, '2015-02-15 00:07:30.000000', 'temperatura', 1037.0000, 'ºC'),
	(63257, 111, '2015-02-15 00:07:31.000000', 'temperatura', 1154.0000, 'ºC'),
	(63258, 111, '2015-02-15 00:07:32.000000', 'temperatura', 259.0000, 'ºC'),
	(63259, 111, '2015-02-15 00:07:33.000000', 'temperatura', 235.0000, 'ºC'),
	(63260, 111, '2015-02-15 00:07:34.000000', 'temperatura', 397.0000, 'ºC'),
	(63261, 111, '2015-02-15 00:07:35.000000', 'temperatura', 79.0000, 'ºC'),
	(63262, 111, '2015-02-15 00:07:36.000000', 'temperatura', 407.0000, 'ºC'),
	(63263, 111, '2015-02-15 00:07:37.000000', 'temperatura', 599.0000, 'ºC'),
	(63264, 111, '2015-02-15 00:07:38.000000', 'temperatura', 575.0000, 'ºC'),
	(63265, 111, '2015-02-15 00:07:39.000000', 'temperatura', 1076.0000, 'ºC'),
	(63266, 111, '2015-02-15 00:07:40.000000', 'temperatura', 58.0000, 'ºC'),
	(63267, 111, '2015-02-15 00:07:41.000000', 'temperatura', 659.0000, 'ºC'),
	(63268, 111, '2015-02-15 00:07:42.000000', 'temperatura', 725.0000, 'ºC'),
	(63269, 111, '2015-02-15 00:07:43.000000', 'temperatura', 447.0000, 'ºC'),
	(63270, 111, '2015-02-15 00:07:44.000000', 'temperatura', 60.0000, 'ºC'),
	(63271, 111, '2015-02-15 00:07:45.000000', 'temperatura', 158.0000, 'ºC'),
	(63272, 111, '2015-02-15 00:07:46.000000', 'temperatura', 614.0000, 'ºC'),
	(63273, 111, '2015-02-15 00:07:47.000000', 'temperatura', 193.0000, 'ºC'),
	(63274, 111, '2015-02-15 00:07:48.000000', 'temperatura', 326.0000, 'ºC'),
	(63275, 111, '2015-02-15 00:07:49.000000', 'temperatura', 1053.0000, 'ºC'),
	(63276, 111, '2015-02-15 00:07:50.000000', 'temperatura', 684.0000, 'ºC'),
	(63277, 111, '2015-02-15 00:07:51.000000', 'temperatura', 263.0000, 'ºC'),
	(63278, 111, '2015-02-15 00:07:52.000000', 'temperatura', 462.0000, 'ºC'),
	(63279, 111, '2015-02-15 00:07:53.000000', 'temperatura', 322.0000, 'ºC'),
	(63280, 111, '2015-02-15 00:07:54.000000', 'temperatura', 224.0000, 'ºC'),
	(63281, 111, '2015-02-15 00:07:55.000000', 'temperatura', 157.0000, 'ºC'),
	(63282, 111, '2015-02-15 00:07:56.000000', 'temperatura', 113.0000, 'ºC'),
	(63283, 111, '2015-02-15 00:07:57.000000', 'temperatura', 92.0000, 'ºC'),
	(63284, 111, '2015-02-15 00:07:58.000000', 'temperatura', 123.0000, 'ºC'),
	(63285, 111, '2015-02-15 00:07:59.000000', 'temperatura', 339.0000, 'ºC'),
	(63286, 111, '2015-02-15 00:08:00.000000', 'temperatura', 128.0000, 'ºC'),
	(63287, 111, '2015-02-15 00:08:01.000000', 'temperatura', 824.0000, 'ºC'),
	(63288, 111, '2015-02-15 00:08:02.000000', 'temperatura', 135.0000, 'ºC'),
	(63289, 111, '2015-02-15 00:08:03.000000', 'temperatura', 604.0000, 'ºC'),
	(63290, 111, '2015-02-15 00:08:04.000000', 'temperatura', 214.0000, 'ºC'),
	(63291, 111, '2015-02-15 00:08:05.000000', 'temperatura', 458.0000, 'ºC'),
	(63292, 111, '2015-02-15 00:08:06.000000', 'temperatura', 449.0000, 'ºC'),
	(63293, 111, '2015-02-15 00:08:07.000000', 'temperatura', 872.0000, 'ºC'),
	(63294, 111, '2015-02-15 00:08:08.000000', 'temperatura', 613.0000, 'ºC'),
	(63295, 111, '2015-02-15 00:08:09.000000', 'temperatura', 450.0000, 'ºC'),
	(63296, 111, '2015-02-15 00:08:10.000000', 'temperatura', 411.0000, 'ºC'),
	(63297, 111, '2015-02-15 00:08:11.000000', 'temperatura', 705.0000, 'ºC'),
	(63298, 111, '2015-02-15 00:08:12.000000', 'temperatura', 1095.0000, 'ºC'),
	(63299, 111, '2015-02-15 00:08:13.000000', 'temperatura', 957.0000, 'ºC'),
	(63300, 111, '2015-02-15 00:08:14.000000', 'temperatura', 303.0000, 'ºC'),
	(63301, 111, '2015-02-15 00:08:15.000000', 'temperatura', 1045.0000, 'ºC'),
	(63302, 111, '2015-02-15 00:08:16.000000', 'temperatura', 715.0000, 'ºC'),
	(63303, 111, '2015-02-15 00:08:17.000000', 'temperatura', 441.0000, 'ºC'),
	(63304, 111, '2015-02-15 00:08:18.000000', 'temperatura', 60.0000, 'ºC'),
	(63305, 111, '2015-02-15 00:08:19.000000', 'temperatura', 176.0000, 'ºC'),
	(63306, 111, '2015-02-15 00:08:20.000000', 'temperatura', 701.0000, 'ºC'),
	(63307, 111, '2015-02-15 00:08:21.000000', 'temperatura', 580.0000, 'ºC'),
	(63308, 111, '2015-02-15 00:08:22.000000', 'temperatura', 797.0000, 'ºC'),
	(63309, 111, '2015-02-15 00:08:23.000000', 'temperatura', 1044.0000, 'ºC'),
	(63310, 111, '2015-02-15 00:08:24.000000', 'temperatura', 428.0000, 'ºC'),
	(63311, 111, '2015-02-15 00:08:25.000000', 'temperatura', 212.0000, 'ºC'),
	(63312, 111, '2015-02-15 00:08:26.000000', 'temperatura', 973.0000, 'ºC'),
	(63313, 111, '2015-02-15 00:08:27.000000', 'temperatura', 631.0000, 'ºC'),
	(63314, 111, '2015-02-15 00:08:28.000000', 'temperatura', 236.0000, 'ºC'),
	(63315, 111, '2015-02-15 00:08:29.000000', 'temperatura', 487.0000, 'ºC'),
	(63316, 111, '2015-02-15 00:08:30.000000', 'temperatura', 526.0000, 'ºC'),
	(63317, 111, '2015-02-15 00:08:31.000000', 'temperatura', 1172.0000, 'ºC'),
	(63318, 111, '2015-02-15 00:08:32.000000', 'temperatura', 683.0000, 'ºC'),
	(63319, 111, '2015-02-15 00:08:33.000000', 'temperatura', 1100.0000, 'ºC'),
	(63320, 111, '2015-02-15 00:08:34.000000', 'temperatura', 1051.0000, 'ºC'),
	(63321, 111, '2015-02-15 00:08:35.000000', 'temperatura', 755.0000, 'ºC'),
	(63322, 111, '2015-02-15 00:08:36.000000', 'temperatura', 621.0000, 'ºC'),
	(63323, 111, '2015-02-15 00:08:37.000000', 'temperatura', 841.0000, 'ºC'),
	(63324, 111, '2015-02-15 00:08:38.000000', 'temperatura', 1142.0000, 'ºC'),
	(63325, 111, '2015-02-15 00:08:39.000000', 'temperatura', 788.0000, 'ºC'),
	(63326, 111, '2015-02-15 00:08:40.000000', 'temperatura', 516.0000, 'ºC'),
	(63327, 111, '2015-02-15 00:08:41.000000', 'temperatura', 216.0000, 'ºC'),
	(63328, 111, '2015-02-15 00:08:42.000000', 'temperatura', 732.0000, 'ºC'),
	(63329, 111, '2015-02-15 00:08:43.000000', 'temperatura', 612.0000, 'ºC'),
	(63330, 111, '2015-02-15 00:08:44.000000', 'temperatura', 864.0000, 'ºC'),
	(63331, 111, '2015-02-15 00:08:45.000000', 'temperatura', 85.0000, 'ºC'),
	(63332, 111, '2015-02-15 00:08:46.000000', 'temperatura', 232.0000, 'ºC'),
	(63333, 111, '2015-02-15 00:08:47.000000', 'temperatura', 906.0000, 'ºC'),
	(63334, 111, '2015-02-15 00:08:48.000000', 'temperatura', 236.0000, 'ºC'),
	(63335, 111, '2015-02-15 00:08:49.000000', 'temperatura', 862.0000, 'ºC'),
	(63336, 111, '2015-02-15 00:08:50.000000', 'temperatura', 1.0000, 'ºC'),
	(63337, 111, '2015-02-15 00:08:51.000000', 'temperatura', 1021.0000, 'ºC'),
	(63338, 111, '2015-02-15 00:08:52.000000', 'temperatura', 302.0000, 'ºC'),
	(63339, 111, '2015-02-15 00:08:53.000000', 'temperatura', 846.0000, 'ºC'),
	(63340, 111, '2015-02-15 00:08:54.000000', 'temperatura', 926.0000, 'ºC'),
	(63341, 111, '2015-02-15 00:08:55.000000', 'temperatura', 893.0000, 'ºC'),
	(63342, 111, '2015-02-15 00:08:56.000000', 'temperatura', 487.0000, 'ºC'),
	(63343, 111, '2015-02-15 00:08:57.000000', 'temperatura', 955.0000, 'ºC'),
	(63344, 111, '2015-02-15 00:08:58.000000', 'temperatura', 916.0000, 'ºC'),
	(63345, 111, '2015-02-15 00:08:59.000000', 'temperatura', 515.0000, 'ºC'),
	(63346, 111, '2015-02-15 00:09:00.000000', 'temperatura', 1027.0000, 'ºC'),
	(63347, 111, '2015-02-15 00:09:01.000000', 'temperatura', 1192.0000, 'ºC'),
	(63348, 111, '2015-02-15 00:09:02.000000', 'temperatura', 478.0000, 'ºC'),
	(63349, 111, '2015-02-15 00:09:03.000000', 'temperatura', 16.0000, 'ºC'),
	(63350, 111, '2015-02-15 00:09:04.000000', 'temperatura', 1047.0000, 'ºC'),
	(63351, 111, '2015-02-15 00:09:05.000000', 'temperatura', 388.0000, 'ºC'),
	(63352, 111, '2015-02-15 00:09:06.000000', 'temperatura', 1197.0000, 'ºC'),
	(63353, 111, '2015-02-15 00:09:07.000000', 'temperatura', 24.0000, 'ºC'),
	(63354, 111, '2015-02-15 00:09:08.000000', 'temperatura', 130.0000, 'ºC'),
	(63355, 111, '2015-02-15 00:09:09.000000', 'temperatura', 576.0000, 'ºC'),
	(63356, 111, '2015-02-15 00:09:10.000000', 'temperatura', 91.0000, 'ºC'),
	(63357, 111, '2015-02-15 00:09:11.000000', 'temperatura', 1130.0000, 'ºC'),
	(63358, 111, '2015-02-15 00:09:12.000000', 'temperatura', 576.0000, 'ºC'),
	(63359, 111, '2015-02-15 00:09:13.000000', 'temperatura', 691.0000, 'ºC'),
	(63360, 111, '2015-02-15 00:09:14.000000', 'temperatura', 525.0000, 'ºC'),
	(63361, 111, '2015-02-15 00:09:15.000000', 'temperatura', 556.0000, 'ºC'),
	(63362, 111, '2015-02-15 00:09:16.000000', 'temperatura', 3.0000, 'ºC'),
	(63363, 111, '2015-02-15 00:09:17.000000', 'temperatura', 749.0000, 'ºC'),
	(63364, 111, '2015-02-15 00:09:18.000000', 'temperatura', 134.0000, 'ºC'),
	(63365, 111, '2015-02-15 00:09:19.000000', 'temperatura', 827.0000, 'ºC'),
	(63366, 111, '2015-02-15 00:09:20.000000', 'temperatura', 130.0000, 'ºC'),
	(63367, 111, '2015-02-15 00:09:21.000000', 'temperatura', 573.0000, 'ºC'),
	(63368, 111, '2015-02-15 00:09:22.000000', 'temperatura', 73.0000, 'ºC'),
	(63369, 111, '2015-02-15 00:09:23.000000', 'temperatura', 1048.0000, 'ºC'),
	(63370, 111, '2015-02-15 00:09:24.000000', 'temperatura', 223.0000, 'ºC'),
	(63371, 111, '2015-02-15 00:09:25.000000', 'temperatura', 368.0000, 'ºC'),
	(63372, 111, '2015-02-15 00:09:26.000000', 'temperatura', 1174.0000, 'ºC'),
	(63373, 111, '2015-02-15 00:09:27.000000', 'temperatura', 1166.0000, 'ºC'),
	(63374, 111, '2015-02-15 00:09:28.000000', 'temperatura', 1107.0000, 'ºC'),
	(63375, 111, '2015-02-15 00:09:29.000000', 'temperatura', 840.0000, 'ºC'),
	(63376, 111, '2015-02-15 00:09:30.000000', 'temperatura', 879.0000, 'ºC'),
	(63377, 111, '2015-02-15 00:09:31.000000', 'temperatura', 675.0000, 'ºC'),
	(63378, 111, '2015-02-15 00:09:32.000000', 'temperatura', 737.0000, 'ºC'),
	(63379, 111, '2015-02-15 00:09:33.000000', 'temperatura', 460.0000, 'ºC'),
	(63380, 111, '2015-02-15 00:09:34.000000', 'temperatura', 91.0000, 'ºC'),
	(63381, 111, '2015-02-15 00:09:35.000000', 'temperatura', 275.0000, 'ºC'),
	(63382, 111, '2015-02-15 00:09:36.000000', 'temperatura', 1101.0000, 'ºC'),
	(63383, 111, '2015-02-15 00:09:37.000000', 'temperatura', 1082.0000, 'ºC'),
	(63384, 111, '2015-02-15 00:09:38.000000', 'temperatura', 906.0000, 'ºC'),
	(63385, 111, '2015-02-15 00:09:39.000000', 'temperatura', 85.0000, 'ºC'),
	(63386, 111, '2015-02-15 00:09:40.000000', 'temperatura', 109.0000, 'ºC'),
	(63387, 111, '2015-02-15 00:09:41.000000', 'temperatura', 291.0000, 'ºC'),
	(63388, 111, '2015-02-15 00:09:42.000000', 'temperatura', 1126.0000, 'ºC'),
	(63389, 111, '2015-02-15 00:09:43.000000', 'temperatura', 1157.0000, 'ºC'),
	(63390, 111, '2015-02-15 00:09:44.000000', 'temperatura', 7.0000, 'ºC'),
	(63391, 111, '2015-02-15 00:09:45.000000', 'temperatura', 168.0000, 'ºC'),
	(63392, 111, '2015-02-15 00:09:46.000000', 'temperatura', 816.0000, 'ºC'),
	(63393, 111, '2015-02-15 00:09:47.000000', 'temperatura', 1178.0000, 'ºC'),
	(63394, 111, '2015-02-15 00:09:48.000000', 'temperatura', 1041.0000, 'ºC'),
	(63395, 111, '2015-02-15 00:09:49.000000', 'temperatura', 473.0000, 'ºC'),
	(63396, 111, '2015-02-15 00:09:50.000000', 'temperatura', 444.0000, 'ºC'),
	(63397, 111, '2015-02-15 00:09:51.000000', 'temperatura', 798.0000, 'ºC'),
	(63398, 111, '2015-02-15 00:09:52.000000', 'temperatura', 261.0000, 'ºC'),
	(63399, 111, '2015-02-15 00:09:53.000000', 'temperatura', 111.0000, 'ºC'),
	(63400, 111, '2015-02-15 00:09:54.000000', 'temperatura', 971.0000, 'ºC'),
	(63401, 111, '2015-02-15 00:09:55.000000', 'temperatura', 925.0000, 'ºC'),
	(63402, 111, '2015-02-15 00:09:56.000000', 'temperatura', 510.0000, 'ºC'),
	(63403, 111, '2015-02-15 00:09:57.000000', 'temperatura', 977.0000, 'ºC'),
	(63404, 111, '2015-02-15 00:09:58.000000', 'temperatura', 956.0000, 'ºC'),
	(63405, 111, '2015-02-15 00:09:59.000000', 'temperatura', 650.0000, 'ºC'),
	(63406, 111, '2015-02-15 00:10:00.000000', 'temperatura', 383.0000, 'ºC'),
	(63407, 111, '2015-02-15 00:10:01.000000', 'temperatura', 1162.0000, 'ºC'),
	(63408, 111, '2015-02-15 00:10:02.000000', 'temperatura', 1065.0000, 'ºC'),
	(63409, 111, '2015-02-15 00:10:03.000000', 'temperatura', 640.0000, 'ºC'),
	(63410, 111, '2015-02-15 00:10:04.000000', 'temperatura', 4.0000, 'ºC'),
	(63411, 111, '2015-02-15 00:10:05.000000', 'temperatura', 500.0000, 'ºC'),
	(63412, 111, '2015-02-15 00:10:06.000000', 'temperatura', 88.0000, 'ºC'),
	(63413, 111, '2015-02-15 00:10:07.000000', 'temperatura', 140.0000, 'ºC'),
	(63414, 111, '2015-02-15 00:10:08.000000', 'temperatura', 439.0000, 'ºC'),
	(63415, 111, '2015-02-15 00:10:09.000000', 'temperatura', 572.0000, 'ºC'),
	(63416, 111, '2015-02-15 00:10:10.000000', 'temperatura', 347.0000, 'ºC'),
	(63417, 111, '2015-02-15 00:10:11.000000', 'temperatura', 16.0000, 'ºC'),
	(63418, 111, '2015-02-15 00:10:12.000000', 'temperatura', 242.0000, 'ºC'),
	(63419, 111, '2015-02-15 00:10:13.000000', 'temperatura', 1163.0000, 'ºC'),
	(63420, 111, '2015-02-15 00:10:14.000000', 'temperatura', 288.0000, 'ºC'),
	(63421, 111, '2015-02-15 00:10:15.000000', 'temperatura', 350.0000, 'ºC'),
	(63422, 111, '2015-02-15 00:10:16.000000', 'temperatura', 888.0000, 'ºC'),
	(63423, 111, '2015-02-15 00:10:17.000000', 'temperatura', 989.0000, 'ºC'),
	(63424, 111, '2015-02-15 00:10:18.000000', 'temperatura', 1082.0000, 'ºC'),
	(63425, 111, '2015-02-15 00:10:19.000000', 'temperatura', 43.0000, 'ºC'),
	(63426, 111, '2015-02-15 00:10:20.000000', 'temperatura', 570.0000, 'ºC'),
	(63427, 111, '2015-02-15 00:10:21.000000', 'temperatura', 324.0000, 'ºC'),
	(63428, 111, '2015-02-15 00:10:22.000000', 'temperatura', 1107.0000, 'ºC'),
	(63429, 111, '2015-02-15 00:10:23.000000', 'temperatura', 964.0000, 'ºC'),
	(63430, 111, '2015-02-15 00:10:24.000000', 'temperatura', 301.0000, 'ºC'),
	(63431, 111, '2015-02-15 00:10:25.000000', 'temperatura', 1014.0000, 'ºC'),
	(63432, 111, '2015-02-15 00:10:26.000000', 'temperatura', 565.0000, 'ºC'),
	(63433, 111, '2015-02-15 00:10:27.000000', 'temperatura', 986.0000, 'ºC'),
	(63434, 111, '2015-02-15 00:10:28.000000', 'temperatura', 837.0000, 'ºC'),
	(63435, 111, '2015-02-15 00:10:29.000000', 'temperatura', 24.0000, 'ºC'),
	(63436, 111, '2015-02-15 00:10:30.000000', 'temperatura', 10.0000, 'ºC'),
	(63437, 111, '2015-02-15 00:10:31.000000', 'temperatura', 1178.0000, 'ºC'),
	(63438, 111, '2015-02-15 00:10:32.000000', 'temperatura', 1063.0000, 'ºC'),
	(63439, 111, '2015-02-15 00:10:33.000000', 'temperatura', 579.0000, 'ºC'),
	(63440, 111, '2015-02-15 00:10:34.000000', 'temperatura', 909.0000, 'ºC'),
	(63441, 111, '2015-02-15 00:10:35.000000', 'temperatura', 407.0000, 'ºC'),
	(63442, 111, '2015-02-15 00:10:36.000000', 'temperatura', 511.0000, 'ºC'),
	(63443, 111, '2015-02-15 00:10:37.000000', 'temperatura', 132.0000, 'ºC'),
	(63444, 111, '2015-02-15 00:10:38.000000', 'temperatura', 326.0000, 'ºC'),
	(63445, 111, '2015-02-15 00:10:39.000000', 'temperatura', 37.0000, 'ºC'),
	(63446, 111, '2015-02-15 00:10:40.000000', 'temperatura', 409.0000, 'ºC'),
	(63447, 111, '2015-02-15 00:10:41.000000', 'temperatura', 732.0000, 'ºC'),
	(63448, 111, '2015-02-15 00:10:42.000000', 'temperatura', 35.0000, 'ºC'),
	(63449, 111, '2015-02-15 00:10:43.000000', 'temperatura', 378.0000, 'ºC'),
	(63450, 111, '2015-02-15 00:10:44.000000', 'temperatura', 587.0000, 'ºC'),
	(63451, 111, '2015-02-15 00:10:45.000000', 'temperatura', 601.0000, 'ºC'),
	(63452, 111, '2015-02-15 00:10:46.000000', 'temperatura', 44.0000, 'ºC'),
	(63453, 111, '2015-02-15 00:10:47.000000', 'temperatura', 817.0000, 'ºC'),
	(63454, 111, '2015-02-15 00:10:48.000000', 'temperatura', 355.0000, 'ºC'),
	(63455, 111, '2015-02-15 00:10:49.000000', 'temperatura', 526.0000, 'ºC'),
	(63456, 111, '2015-02-15 00:10:50.000000', 'temperatura', 363.0000, 'ºC'),
	(63457, 111, '2015-02-15 00:10:51.000000', 'temperatura', 238.0000, 'ºC'),
	(63458, 111, '2015-02-15 00:10:52.000000', 'temperatura', 103.0000, 'ºC'),
	(63459, 111, '2015-02-15 00:10:53.000000', 'temperatura', 1002.0000, 'ºC'),
	(63460, 111, '2015-02-15 00:10:54.000000', 'temperatura', 1100.0000, 'ºC'),
	(63461, 111, '2015-02-15 00:10:55.000000', 'temperatura', 96.0000, 'ºC'),
	(63462, 111, '2015-02-15 00:10:56.000000', 'temperatura', 781.0000, 'ºC'),
	(63463, 111, '2015-02-15 00:10:57.000000', 'temperatura', 15.0000, 'ºC'),
	(63464, 111, '2015-02-15 00:10:58.000000', 'temperatura', 133.0000, 'ºC'),
	(63465, 111, '2015-02-15 00:10:59.000000', 'temperatura', 623.0000, 'ºC'),
	(63466, 111, '2015-02-15 00:11:00.000000', 'temperatura', 313.0000, 'ºC'),
	(63467, 111, '2015-02-15 00:11:01.000000', 'temperatura', 899.0000, 'ºC'),
	(63468, 111, '2015-02-15 00:11:02.000000', 'temperatura', 1156.0000, 'ºC'),
	(63469, 111, '2015-02-15 00:11:03.000000', 'temperatura', 684.0000, 'ºC'),
	(63470, 111, '2015-02-15 00:11:04.000000', 'temperatura', 1153.0000, 'ºC'),
	(63471, 111, '2015-02-15 00:11:05.000000', 'temperatura', 114.0000, 'ºC'),
	(63472, 111, '2015-02-15 00:11:06.000000', 'temperatura', 711.0000, 'ºC'),
	(63473, 111, '2015-02-15 00:11:07.000000', 'temperatura', 815.0000, 'ºC'),
	(63474, 111, '2015-02-15 00:11:08.000000', 'temperatura', 741.0000, 'ºC'),
	(63475, 111, '2015-02-15 00:11:09.000000', 'temperatura', 60.0000, 'ºC'),
	(63476, 111, '2015-02-15 00:11:10.000000', 'temperatura', 480.0000, 'ºC'),
	(63477, 111, '2015-02-15 00:11:11.000000', 'temperatura', 1017.0000, 'ºC'),
	(63478, 111, '2015-02-15 00:11:12.000000', 'temperatura', 47.0000, 'ºC'),
	(63479, 111, '2015-02-15 00:11:13.000000', 'temperatura', 785.0000, 'ºC'),
	(63480, 111, '2015-02-15 00:11:14.000000', 'temperatura', 184.0000, 'ºC'),
	(63481, 111, '2015-02-15 00:11:15.000000', 'temperatura', 966.0000, 'ºC'),
	(63482, 111, '2015-02-15 00:11:16.000000', 'temperatura', 678.0000, 'ºC'),
	(63483, 111, '2015-02-15 00:11:17.000000', 'temperatura', 493.0000, 'ºC'),
	(63484, 111, '2015-02-15 00:11:18.000000', 'temperatura', 433.0000, 'ºC'),
	(63485, 111, '2015-02-15 00:11:19.000000', 'temperatura', 684.0000, 'ºC'),
	(63486, 111, '2015-02-15 00:11:20.000000', 'temperatura', 923.0000, 'ºC'),
	(63487, 111, '2015-02-15 00:11:21.000000', 'temperatura', 161.0000, 'ºC'),
	(63488, 111, '2015-02-15 00:11:22.000000', 'temperatura', 438.0000, 'ºC'),
	(63489, 111, '2015-02-15 00:11:23.000000', 'temperatura', 507.0000, 'ºC'),
	(63490, 111, '2015-02-15 00:11:24.000000', 'temperatura', 21.0000, 'ºC'),
	(63491, 111, '2015-02-15 00:11:25.000000', 'temperatura', 987.0000, 'ºC'),
	(63492, 111, '2015-02-15 00:11:26.000000', 'temperatura', 70.0000, 'ºC'),
	(63493, 111, '2015-02-15 00:11:27.000000', 'temperatura', 991.0000, 'ºC'),
	(63494, 111, '2015-02-15 00:11:28.000000', 'temperatura', 1143.0000, 'ºC'),
	(63495, 111, '2015-02-15 00:11:29.000000', 'temperatura', 345.0000, 'ºC'),
	(63496, 111, '2015-02-15 00:11:30.000000', 'temperatura', 694.0000, 'ºC'),
	(63497, 111, '2015-02-15 00:11:31.000000', 'temperatura', 38.0000, 'ºC'),
	(63498, 111, '2015-02-15 00:11:32.000000', 'temperatura', 506.0000, 'ºC'),
	(63499, 111, '2015-02-15 00:11:33.000000', 'temperatura', 19.0000, 'ºC'),
	(63500, 111, '2015-02-15 00:11:34.000000', 'temperatura', 977.0000, 'ºC'),
	(63501, 111, '2015-02-15 00:11:35.000000', 'temperatura', 30.0000, 'ºC'),
	(63502, 111, '2015-02-15 00:11:36.000000', 'temperatura', 819.0000, 'ºC'),
	(63503, 111, '2015-02-15 00:11:37.000000', 'temperatura', 406.0000, 'ºC'),
	(63504, 111, '2015-02-15 00:11:38.000000', 'temperatura', 773.0000, 'ºC'),
	(63505, 111, '2015-02-15 00:11:39.000000', 'temperatura', 246.0000, 'ºC'),
	(63506, 111, '2015-02-15 00:11:40.000000', 'temperatura', 113.0000, 'ºC'),
	(63507, 111, '2015-02-15 00:11:41.000000', 'temperatura', 1026.0000, 'ºC'),
	(63508, 111, '2015-02-15 00:11:42.000000', 'temperatura', 1192.0000, 'ºC'),
	(63509, 111, '2015-02-15 00:11:43.000000', 'temperatura', 484.0000, 'ºC'),
	(63510, 111, '2015-02-15 00:11:44.000000', 'temperatura', 43.0000, 'ºC'),
	(63511, 111, '2015-02-15 00:11:45.000000', 'temperatura', 1165.0000, 'ºC'),
	(63512, 111, '2015-02-15 00:11:46.000000', 'temperatura', 896.0000, 'ºC'),
	(63513, 111, '2015-02-15 00:11:47.000000', 'temperatura', 986.0000, 'ºC'),
	(63514, 111, '2015-02-15 00:11:48.000000', 'temperatura', 1041.0000, 'ºC'),
	(63515, 111, '2015-02-15 00:11:49.000000', 'temperatura', 1047.0000, 'ºC'),
	(63516, 111, '2015-02-15 00:11:50.000000', 'temperatura', 915.0000, 'ºC'),
	(63517, 111, '2015-02-15 00:11:51.000000', 'temperatura', 235.0000, 'ºC'),
	(63518, 111, '2015-02-15 00:11:52.000000', 'temperatura', 829.0000, 'ºC'),
	(63519, 111, '2015-02-15 00:11:53.000000', 'temperatura', 1042.0000, 'ºC'),
	(63520, 111, '2015-02-15 00:11:54.000000', 'temperatura', 324.0000, 'ºC'),
	(63521, 111, '2015-02-15 00:11:55.000000', 'temperatura', 894.0000, 'ºC'),
	(63522, 111, '2015-02-15 00:11:56.000000', 'temperatura', 1099.0000, 'ºC'),
	(63523, 111, '2015-02-15 00:11:57.000000', 'temperatura', 414.0000, 'ºC'),
	(63524, 111, '2015-02-15 00:11:58.000000', 'temperatura', 1172.0000, 'ºC'),
	(63525, 111, '2015-02-15 00:11:59.000000', 'temperatura', 1019.0000, 'ºC'),
	(63526, 111, '2015-02-15 00:12:00.000000', 'temperatura', 380.0000, 'ºC'),
	(63527, 111, '2015-02-15 00:12:01.000000', 'temperatura', 42.0000, 'ºC'),
	(63528, 111, '2015-02-15 00:12:02.000000', 'temperatura', 270.0000, 'ºC'),
	(63529, 111, '2015-02-15 00:12:03.000000', 'temperatura', 26.0000, 'ºC'),
	(63530, 111, '2015-02-15 00:12:04.000000', 'temperatura', 519.0000, 'ºC'),
	(63531, 111, '2015-02-15 00:12:05.000000', 'temperatura', 118.0000, 'ºC'),
	(63532, 111, '2015-02-15 00:12:06.000000', 'temperatura', 236.0000, 'ºC'),
	(63533, 111, '2015-02-15 00:12:07.000000', 'temperatura', 824.0000, 'ºC'),
	(63534, 111, '2015-02-15 00:12:08.000000', 'temperatura', 1014.0000, 'ºC'),
	(63535, 111, '2015-02-15 00:12:09.000000', 'temperatura', 197.0000, 'ºC'),
	(63536, 111, '2015-02-15 00:12:10.000000', 'temperatura', 342.0000, 'ºC'),
	(63537, 111, '2015-02-15 00:12:11.000000', 'temperatura', 1123.0000, 'ºC'),
	(63538, 111, '2015-02-15 00:12:12.000000', 'temperatura', 987.0000, 'ºC'),
	(63539, 111, '2015-02-15 00:12:13.000000', 'temperatura', 368.0000, 'ºC'),
	(63540, 111, '2015-02-15 00:12:14.000000', 'temperatura', 77.0000, 'ºC'),
	(63541, 111, '2015-02-15 00:12:15.000000', 'temperatura', 485.0000, 'ºC'),
	(63542, 111, '2015-02-15 00:12:16.000000', 'temperatura', 992.0000, 'ºC'),
	(63543, 111, '2015-02-15 00:12:17.000000', 'temperatura', 1108.0000, 'ºC'),
	(63544, 111, '2015-02-15 00:12:18.000000', 'temperatura', 164.0000, 'ºC'),
	(63545, 111, '2015-02-15 00:12:19.000000', 'temperatura', 1098.0000, 'ºC'),
	(63546, 111, '2015-02-15 00:12:20.000000', 'temperatura', 196.0000, 'ºC'),
	(63547, 111, '2015-02-15 00:12:21.000000', 'temperatura', 89.0000, 'ºC'),
	(63548, 111, '2015-02-15 00:12:22.000000', 'temperatura', 1056.0000, 'ºC'),
	(63549, 111, '2015-02-15 00:12:23.000000', 'temperatura', 212.0000, 'ºC'),
	(63550, 111, '2015-02-15 00:12:24.000000', 'temperatura', 292.0000, 'ºC'),
	(63551, 111, '2015-02-15 00:12:25.000000', 'temperatura', 827.0000, 'ºC'),
	(63552, 111, '2015-02-15 00:12:26.000000', 'temperatura', 860.0000, 'ºC'),
	(63553, 111, '2015-02-15 00:12:27.000000', 'temperatura', 620.0000, 'ºC'),
	(63554, 111, '2015-02-15 00:12:28.000000', 'temperatura', 519.0000, 'ºC'),
	(63555, 111, '2015-02-15 00:12:29.000000', 'temperatura', 737.0000, 'ºC'),
	(63556, 111, '2015-02-15 00:12:30.000000', 'temperatura', 929.0000, 'ºC'),
	(63557, 111, '2015-02-15 00:12:31.000000', 'temperatura', 34.0000, 'ºC'),
	(63558, 111, '2015-02-15 00:12:32.000000', 'temperatura', 983.0000, 'ºC'),
	(63559, 111, '2015-02-15 00:12:33.000000', 'temperatura', 14.0000, 'ºC'),
	(63560, 111, '2015-02-15 00:12:34.000000', 'temperatura', 721.0000, 'ºC'),
	(63561, 111, '2015-02-15 00:12:35.000000', 'temperatura', 1164.0000, 'ºC'),
	(63562, 111, '2015-02-15 00:12:36.000000', 'temperatura', 59.0000, 'ºC'),
	(63563, 111, '2015-02-15 00:12:37.000000', 'temperatura', 403.0000, 'ºC'),
	(63564, 111, '2015-02-15 00:12:38.000000', 'temperatura', 637.0000, 'ºC'),
	(63565, 111, '2015-02-15 00:12:39.000000', 'temperatura', 776.0000, 'ºC'),
	(63566, 111, '2015-02-15 00:12:40.000000', 'temperatura', 770.0000, 'ºC'),
	(63567, 111, '2015-02-15 00:12:41.000000', 'temperatura', 321.0000, 'ºC'),
	(63568, 111, '2015-02-15 00:12:42.000000', 'temperatura', 498.0000, 'ºC'),
	(63569, 111, '2015-02-15 00:12:43.000000', 'temperatura', 328.0000, 'ºC'),
	(63570, 111, '2015-02-15 00:12:44.000000', 'temperatura', 147.0000, 'ºC'),
	(63571, 111, '2015-02-15 00:12:45.000000', 'temperatura', 951.0000, 'ºC'),
	(63572, 111, '2015-02-15 00:12:46.000000', 'temperatura', 716.0000, 'ºC'),
	(63573, 111, '2015-02-15 00:12:47.000000', 'temperatura', 727.0000, 'ºC'),
	(63574, 111, '2015-02-15 00:12:48.000000', 'temperatura', 287.0000, 'ºC'),
	(63575, 111, '2015-02-15 00:12:49.000000', 'temperatura', 455.0000, 'ºC'),
	(63576, 111, '2015-02-15 00:12:50.000000', 'temperatura', 216.0000, 'ºC'),
	(63577, 111, '2015-02-15 00:12:51.000000', 'temperatura', 913.0000, 'ºC'),
	(63578, 111, '2015-02-15 00:12:52.000000', 'temperatura', 319.0000, 'ºC'),
	(63579, 111, '2015-02-15 00:12:53.000000', 'temperatura', 57.0000, 'ºC'),
	(63580, 111, '2015-02-15 00:12:54.000000', 'temperatura', 528.0000, 'ºC'),
	(63581, 111, '2015-02-15 00:12:55.000000', 'temperatura', 67.0000, 'ºC'),
	(63582, 111, '2015-02-15 00:12:56.000000', 'temperatura', 1155.0000, 'ºC'),
	(63583, 111, '2015-02-15 00:12:57.000000', 'temperatura', 772.0000, 'ºC'),
	(63584, 111, '2015-02-15 00:12:58.000000', 'temperatura', 397.0000, 'ºC'),
	(63585, 111, '2015-02-15 00:12:59.000000', 'temperatura', 871.0000, 'ºC'),
	(63586, 111, '2015-02-15 00:13:00.000000', 'temperatura', 761.0000, 'ºC'),
	(63587, 111, '2015-02-15 00:13:01.000000', 'temperatura', 1196.0000, 'ºC'),
	(63588, 111, '2015-02-15 00:13:02.000000', 'temperatura', 96.0000, 'ºC'),
	(63589, 111, '2015-02-15 00:13:03.000000', 'temperatura', 493.0000, 'ºC'),
	(63590, 111, '2015-02-15 00:13:04.000000', 'temperatura', 979.0000, 'ºC'),
	(63591, 111, '2015-02-15 00:13:05.000000', 'temperatura', 1016.0000, 'ºC'),
	(63592, 111, '2015-02-15 00:13:06.000000', 'temperatura', 941.0000, 'ºC'),
	(63593, 111, '2015-02-15 00:13:07.000000', 'temperatura', 460.0000, 'ºC'),
	(63594, 111, '2015-02-15 00:13:08.000000', 'temperatura', 676.0000, 'ºC'),
	(63595, 111, '2015-02-15 00:13:09.000000', 'temperatura', 802.0000, 'ºC'),
	(63596, 111, '2015-02-15 00:13:10.000000', 'temperatura', 782.0000, 'ºC'),
	(63597, 111, '2015-02-15 00:13:11.000000', 'temperatura', 306.0000, 'ºC'),
	(63598, 111, '2015-02-15 00:13:12.000000', 'temperatura', 384.0000, 'ºC'),
	(63599, 111, '2015-02-15 00:13:13.000000', 'temperatura', 1004.0000, 'ºC'),
	(63600, 111, '2015-02-15 00:13:14.000000', 'temperatura', 266.0000, 'ºC'),
	(63601, 111, '2015-02-15 00:13:15.000000', 'temperatura', 720.0000, 'ºC'),
	(63602, 111, '2015-02-15 00:13:16.000000', 'temperatura', 403.0000, 'ºC'),
	(63603, 111, '2015-02-15 00:13:17.000000', 'temperatura', 1053.0000, 'ºC'),
	(63604, 111, '2015-02-15 00:13:18.000000', 'temperatura', 457.0000, 'ºC'),
	(63605, 111, '2015-02-15 00:13:19.000000', 'temperatura', 328.0000, 'ºC'),
	(63606, 111, '2015-02-15 00:13:20.000000', 'temperatura', 269.0000, 'ºC'),
	(63607, 111, '2015-02-15 00:13:21.000000', 'temperatura', 361.0000, 'ºC'),
	(63608, 111, '2015-02-15 00:13:22.000000', 'temperatura', 999.0000, 'ºC'),
	(63609, 111, '2015-02-15 00:13:23.000000', 'temperatura', 314.0000, 'ºC'),
	(63610, 111, '2015-02-15 00:13:24.000000', 'temperatura', 970.0000, 'ºC'),
	(63611, 111, '2015-02-15 00:13:25.000000', 'temperatura', 312.0000, 'ºC'),
	(63612, 111, '2015-02-15 00:13:26.000000', 'temperatura', 1049.0000, 'ºC'),
	(63613, 111, '2015-02-15 00:13:27.000000', 'temperatura', 710.0000, 'ºC'),
	(63614, 111, '2015-02-15 00:13:28.000000', 'temperatura', 405.0000, 'ºC'),
	(63615, 111, '2015-02-15 00:13:29.000000', 'temperatura', 1096.0000, 'ºC'),
	(63616, 111, '2015-02-15 00:13:30.000000', 'temperatura', 664.0000, 'ºC'),
	(63617, 111, '2015-02-15 00:13:31.000000', 'temperatura', 32.0000, 'ºC'),
	(63618, 111, '2015-02-15 00:13:32.000000', 'temperatura', 570.0000, 'ºC'),
	(63619, 111, '2015-02-15 00:13:33.000000', 'temperatura', 354.0000, 'ºC'),
	(63620, 111, '2015-02-15 00:13:34.000000', 'temperatura', 60.0000, 'ºC'),
	(63621, 111, '2015-02-15 00:13:35.000000', 'temperatura', 440.0000, 'ºC'),
	(63622, 111, '2015-02-15 00:13:36.000000', 'temperatura', 818.0000, 'ºC'),
	(63623, 111, '2015-02-15 00:13:37.000000', 'temperatura', 370.0000, 'ºC'),
	(63624, 111, '2015-02-15 00:13:38.000000', 'temperatura', 599.0000, 'ºC'),
	(63625, 111, '2015-02-15 00:13:39.000000', 'temperatura', 686.0000, 'ºC'),
	(63626, 111, '2015-02-15 00:13:40.000000', 'temperatura', 431.0000, 'ºC'),
	(63627, 111, '2015-02-15 00:13:41.000000', 'temperatura', 97.0000, 'ºC'),
	(63628, 111, '2015-02-15 00:13:42.000000', 'temperatura', 394.0000, 'ºC'),
	(63629, 111, '2015-02-15 00:13:43.000000', 'temperatura', 478.0000, 'ºC'),
	(63630, 111, '2015-02-15 00:13:44.000000', 'temperatura', 10.0000, 'ºC'),
	(63631, 111, '2015-02-15 00:13:45.000000', 'temperatura', 1015.0000, 'ºC'),
	(63632, 111, '2015-02-15 00:13:46.000000', 'temperatura', 246.0000, 'ºC'),
	(63633, 111, '2015-02-15 00:13:47.000000', 'temperatura', 586.0000, 'ºC'),
	(63634, 111, '2015-02-15 00:13:48.000000', 'temperatura', 993.0000, 'ºC'),
	(63635, 111, '2015-02-15 00:13:49.000000', 'temperatura', 809.0000, 'ºC'),
	(63636, 111, '2015-02-15 00:13:50.000000', 'temperatura', 1064.0000, 'ºC'),
	(63637, 111, '2015-02-15 00:13:51.000000', 'temperatura', 493.0000, 'ºC'),
	(63638, 111, '2015-02-15 00:13:52.000000', 'temperatura', 474.0000, 'ºC'),
	(63639, 111, '2015-02-15 00:13:53.000000', 'temperatura', 893.0000, 'ºC'),
	(63640, 111, '2015-02-15 00:13:54.000000', 'temperatura', 642.0000, 'ºC'),
	(63641, 111, '2015-02-15 00:13:55.000000', 'temperatura', 534.0000, 'ºC'),
	(63642, 111, '2015-02-15 00:13:56.000000', 'temperatura', 741.0000, 'ºC'),
	(63643, 111, '2015-02-15 00:13:57.000000', 'temperatura', 905.0000, 'ºC'),
	(63644, 111, '2015-02-15 00:13:58.000000', 'temperatura', 1105.0000, 'ºC'),
	(63645, 111, '2015-02-15 00:13:59.000000', 'temperatura', 407.0000, 'ºC'),
	(63646, 111, '2015-02-15 00:14:00.000000', 'temperatura', 1121.0000, 'ºC'),
	(63647, 111, '2015-02-15 00:14:01.000000', 'temperatura', 783.0000, 'ºC'),
	(63648, 111, '2015-02-15 00:14:02.000000', 'temperatura', 556.0000, 'ºC'),
	(63649, 111, '2015-02-15 00:14:03.000000', 'temperatura', 429.0000, 'ºC'),
	(63650, 111, '2015-02-15 00:14:04.000000', 'temperatura', 477.0000, 'ºC'),
	(63651, 111, '2015-02-15 00:14:05.000000', 'temperatura', 1101.0000, 'ºC'),
	(63652, 111, '2015-02-15 00:14:06.000000', 'temperatura', 474.0000, 'ºC'),
	(63653, 111, '2015-02-15 00:14:07.000000', 'temperatura', 267.0000, 'ºC'),
	(63654, 111, '2015-02-15 00:14:08.000000', 'temperatura', 1112.0000, 'ºC'),
	(63655, 111, '2015-02-15 00:14:09.000000', 'temperatura', 1163.0000, 'ºC'),
	(63656, 111, '2015-02-15 00:14:10.000000', 'temperatura', 77.0000, 'ºC'),
	(63657, 111, '2015-02-15 00:14:11.000000', 'temperatura', 495.0000, 'ºC'),
	(63658, 111, '2015-02-15 00:14:12.000000', 'temperatura', 1047.0000, 'ºC'),
	(63659, 111, '2015-02-15 00:14:13.000000', 'temperatura', 150.0000, 'ºC'),
	(63660, 111, '2015-02-15 00:14:14.000000', 'temperatura', 9.0000, 'ºC'),
	(63661, 111, '2015-02-15 00:14:15.000000', 'temperatura', 796.0000, 'ºC'),
	(63662, 111, '2015-02-15 00:14:16.000000', 'temperatura', 354.0000, 'ºC'),
	(63663, 111, '2015-02-15 00:14:17.000000', 'temperatura', 582.0000, 'ºC'),
	(63664, 111, '2015-02-15 00:14:18.000000', 'temperatura', 649.0000, 'ºC'),
	(63665, 111, '2015-02-15 00:14:19.000000', 'temperatura', 301.0000, 'ºC'),
	(63666, 111, '2015-02-15 00:14:20.000000', 'temperatura', 757.0000, 'ºC'),
	(63667, 111, '2015-02-15 00:14:21.000000', 'temperatura', 481.0000, 'ºC'),
	(63668, 111, '2015-02-15 00:14:22.000000', 'temperatura', 137.0000, 'ºC'),
	(63669, 111, '2015-02-15 00:14:23.000000', 'temperatura', 442.0000, 'ºC'),
	(63670, 111, '2015-02-15 00:14:24.000000', 'temperatura', 598.0000, 'ºC'),
	(63671, 111, '2015-02-15 00:14:25.000000', 'temperatura', 464.0000, 'ºC'),
	(63672, 111, '2015-02-15 00:14:26.000000', 'temperatura', 526.0000, 'ºC'),
	(63673, 111, '2015-02-15 00:14:27.000000', 'temperatura', 38.0000, 'ºC'),
	(63674, 111, '2015-02-15 00:14:28.000000', 'temperatura', 1014.0000, 'ºC'),
	(63675, 111, '2015-02-15 00:14:29.000000', 'temperatura', 158.0000, 'ºC'),
	(63676, 111, '2015-02-15 00:14:30.000000', 'temperatura', 147.0000, 'ºC'),
	(63677, 111, '2015-02-15 00:14:31.000000', 'temperatura', 261.0000, 'ºC'),
	(63678, 111, '2015-02-15 00:14:32.000000', 'temperatura', 863.0000, 'ºC'),
	(63679, 111, '2015-02-15 00:14:33.000000', 'temperatura', 1135.0000, 'ºC'),
	(63680, 111, '2015-02-15 00:14:34.000000', 'temperatura', 687.0000, 'ºC'),
	(63681, 111, '2015-02-15 00:14:35.000000', 'temperatura', 31.0000, 'ºC'),
	(63682, 111, '2015-02-15 00:14:36.000000', 'temperatura', 493.0000, 'ºC'),
	(63683, 111, '2015-02-15 00:14:37.000000', 'temperatura', 1171.0000, 'ºC'),
	(63684, 111, '2015-02-15 00:14:38.000000', 'temperatura', 780.0000, 'ºC'),
	(63685, 111, '2015-02-15 00:14:39.000000', 'temperatura', 386.0000, 'ºC'),
	(63686, 111, '2015-02-15 00:14:40.000000', 'temperatura', 789.0000, 'ºC'),
	(63687, 111, '2015-02-15 00:14:41.000000', 'temperatura', 387.0000, 'ºC'),
	(63688, 111, '2015-02-15 00:14:42.000000', 'temperatura', 768.0000, 'ºC'),
	(63689, 111, '2015-02-15 00:14:43.000000', 'temperatura', 282.0000, 'ºC'),
	(63690, 111, '2015-02-15 00:14:44.000000', 'temperatura', 308.0000, 'ºC'),
	(63691, 111, '2015-02-15 00:14:45.000000', 'temperatura', 691.0000, 'ºC'),
	(63692, 111, '2015-02-15 00:14:46.000000', 'temperatura', 132.0000, 'ºC'),
	(63693, 111, '2015-02-15 00:14:47.000000', 'temperatura', 990.0000, 'ºC'),
	(63694, 111, '2015-02-15 00:14:48.000000', 'temperatura', 953.0000, 'ºC'),
	(63695, 111, '2015-02-15 00:14:49.000000', 'temperatura', 594.0000, 'ºC'),
	(63696, 111, '2015-02-15 00:14:50.000000', 'temperatura', 112.0000, 'ºC'),
	(63697, 111, '2015-02-15 00:14:51.000000', 'temperatura', 1178.0000, 'ºC'),
	(63698, 111, '2015-02-15 00:14:52.000000', 'temperatura', 754.0000, 'ºC'),
	(63699, 111, '2015-02-15 00:14:53.000000', 'temperatura', 239.0000, 'ºC'),
	(63700, 111, '2015-02-15 00:14:54.000000', 'temperatura', 133.0000, 'ºC'),
	(63701, 111, '2015-02-15 00:14:55.000000', 'temperatura', 1147.0000, 'ºC'),
	(63702, 111, '2015-02-15 00:14:56.000000', 'temperatura', 536.0000, 'ºC'),
	(63703, 111, '2015-02-15 00:14:57.000000', 'temperatura', 439.0000, 'ºC'),
	(63704, 111, '2015-02-15 00:14:58.000000', 'temperatura', 588.0000, 'ºC'),
	(63705, 111, '2015-02-15 00:14:59.000000', 'temperatura', 425.0000, 'ºC'),
	(63706, 111, '2015-02-15 00:15:00.000000', 'temperatura', 359.0000, 'ºC'),
	(63707, 111, '2015-02-15 00:15:01.000000', 'temperatura', 521.0000, 'ºC'),
	(63708, 111, '2015-02-15 00:15:02.000000', 'temperatura', 328.0000, 'ºC'),
	(63709, 111, '2015-02-15 00:15:03.000000', 'temperatura', 76.0000, 'ºC'),
	(63710, 111, '2015-02-15 00:15:04.000000', 'temperatura', 598.0000, 'ºC'),
	(63711, 111, '2015-02-15 00:15:05.000000', 'temperatura', 364.0000, 'ºC'),
	(63712, 111, '2015-02-15 00:15:06.000000', 'temperatura', 27.0000, 'ºC'),
	(63713, 111, '2015-02-15 00:15:07.000000', 'temperatura', 242.0000, 'ºC'),
	(63714, 111, '2015-02-15 00:15:08.000000', 'temperatura', 1129.0000, 'ºC'),
	(63715, 111, '2015-02-15 00:15:09.000000', 'temperatura', 120.0000, 'ºC'),
	(63716, 111, '2015-02-15 00:15:10.000000', 'temperatura', 814.0000, 'ºC'),
	(63717, 111, '2015-02-15 00:15:11.000000', 'temperatura', 112.0000, 'ºC'),
	(63718, 111, '2015-02-15 00:15:12.000000', 'temperatura', 516.0000, 'ºC'),
	(63719, 111, '2015-02-15 00:15:13.000000', 'temperatura', 1047.0000, 'ºC'),
	(63720, 111, '2015-02-15 00:15:14.000000', 'temperatura', 86.0000, 'ºC'),
	(63721, 111, '2015-02-15 00:15:15.000000', 'temperatura', 890.0000, 'ºC'),
	(63722, 111, '2015-02-15 00:15:16.000000', 'temperatura', 593.0000, 'ºC'),
	(63723, 111, '2015-02-15 00:15:17.000000', 'temperatura', 296.0000, 'ºC'),
	(63724, 111, '2015-02-15 00:15:18.000000', 'temperatura', 902.0000, 'ºC'),
	(63725, 111, '2015-02-15 00:15:19.000000', 'temperatura', 23.0000, 'ºC'),
	(63726, 111, '2015-02-15 00:15:20.000000', 'temperatura', 1008.0000, 'ºC'),
	(63727, 111, '2015-02-15 00:15:21.000000', 'temperatura', 172.0000, 'ºC'),
	(63728, 111, '2015-02-15 00:15:22.000000', 'temperatura', 236.0000, 'ºC'),
	(63729, 111, '2015-02-15 00:15:23.000000', 'temperatura', 665.0000, 'ºC'),
	(63730, 111, '2015-02-15 00:15:24.000000', 'temperatura', 218.0000, 'ºC'),
	(63731, 111, '2015-02-15 00:15:25.000000', 'temperatura', 295.0000, 'ºC'),
	(63732, 111, '2015-02-15 00:15:26.000000', 'temperatura', 824.0000, 'ºC'),
	(63733, 111, '2015-02-15 00:15:27.000000', 'temperatura', 832.0000, 'ºC'),
	(63734, 111, '2015-02-15 00:15:28.000000', 'temperatura', 489.0000, 'ºC'),
	(63735, 111, '2015-02-15 00:15:29.000000', 'temperatura', 1151.0000, 'ºC'),
	(63736, 111, '2015-02-15 00:15:30.000000', 'temperatura', 690.0000, 'ºC'),
	(63737, 111, '2015-02-15 00:15:31.000000', 'temperatura', 1196.0000, 'ºC'),
	(63738, 111, '2015-02-15 00:15:32.000000', 'temperatura', 309.0000, 'ºC'),
	(63739, 111, '2015-02-15 00:15:33.000000', 'temperatura', 359.0000, 'ºC'),
	(63740, 111, '2015-02-15 00:15:34.000000', 'temperatura', 869.0000, 'ºC'),
	(63741, 111, '2015-02-15 00:15:35.000000', 'temperatura', 870.0000, 'ºC'),
	(63742, 111, '2015-02-15 00:15:36.000000', 'temperatura', 541.0000, 'ºC'),
	(63743, 111, '2015-02-15 00:15:37.000000', 'temperatura', 97.0000, 'ºC'),
	(63744, 111, '2015-02-15 00:15:38.000000', 'temperatura', 62.0000, 'ºC'),
	(63745, 111, '2015-02-15 00:15:39.000000', 'temperatura', 21.0000, 'ºC'),
	(63746, 111, '2015-02-15 00:15:40.000000', 'temperatura', 1117.0000, 'ºC'),
	(63747, 111, '2015-02-15 00:15:41.000000', 'temperatura', 722.0000, 'ºC'),
	(63748, 111, '2015-02-15 00:15:42.000000', 'temperatura', 262.0000, 'ºC'),
	(63749, 111, '2015-02-15 00:15:43.000000', 'temperatura', 344.0000, 'ºC'),
	(63750, 111, '2015-02-15 00:15:44.000000', 'temperatura', 932.0000, 'ºC'),
	(63751, 111, '2015-02-15 00:15:45.000000', 'temperatura', 31.0000, 'ºC'),
	(63752, 111, '2015-02-15 00:15:46.000000', 'temperatura', 957.0000, 'ºC'),
	(63753, 111, '2015-02-15 00:15:47.000000', 'temperatura', 1094.0000, 'ºC'),
	(63754, 111, '2015-02-15 00:15:48.000000', 'temperatura', 198.0000, 'ºC'),
	(63755, 111, '2015-02-15 00:15:49.000000', 'temperatura', 108.0000, 'ºC'),
	(63756, 111, '2015-02-15 00:15:50.000000', 'temperatura', 1145.0000, 'ºC'),
	(63757, 111, '2015-02-15 00:15:51.000000', 'temperatura', 605.0000, 'ºC'),
	(63758, 111, '2015-02-15 00:15:52.000000', 'temperatura', 790.0000, 'ºC'),
	(63759, 111, '2015-02-15 00:15:53.000000', 'temperatura', 936.0000, 'ºC'),
	(63760, 111, '2015-02-15 00:15:54.000000', 'temperatura', 1109.0000, 'ºC'),
	(63761, 111, '2015-02-15 00:15:55.000000', 'temperatura', 337.0000, 'ºC'),
	(63762, 111, '2015-02-15 00:15:56.000000', 'temperatura', 759.0000, 'ºC'),
	(63763, 111, '2015-02-15 00:15:57.000000', 'temperatura', 383.0000, 'ºC'),
	(63764, 111, '2015-02-15 00:15:58.000000', 'temperatura', 842.0000, 'ºC'),
	(63765, 111, '2015-02-15 00:15:59.000000', 'temperatura', 658.0000, 'ºC'),
	(63766, 111, '2015-02-15 00:16:00.000000', 'temperatura', 766.0000, 'ºC'),
	(63767, 111, '2015-02-15 00:16:01.000000', 'temperatura', 655.0000, 'ºC'),
	(63768, 111, '2015-02-15 00:16:02.000000', 'temperatura', 980.0000, 'ºC'),
	(63769, 111, '2015-02-15 00:16:03.000000', 'temperatura', 536.0000, 'ºC'),
	(63770, 111, '2015-02-15 00:16:04.000000', 'temperatura', 938.0000, 'ºC'),
	(63771, 111, '2015-02-15 00:16:05.000000', 'temperatura', 685.0000, 'ºC'),
	(63772, 111, '2015-02-15 00:16:06.000000', 'temperatura', 612.0000, 'ºC'),
	(63773, 111, '2015-02-15 00:16:07.000000', 'temperatura', 1005.0000, 'ºC'),
	(63774, 111, '2015-02-15 00:16:08.000000', 'temperatura', 788.0000, 'ºC'),
	(63775, 111, '2015-02-15 00:16:09.000000', 'temperatura', 925.0000, 'ºC'),
	(63776, 111, '2015-02-15 00:16:10.000000', 'temperatura', 1064.0000, 'ºC'),
	(63777, 111, '2015-02-15 00:16:11.000000', 'temperatura', 146.0000, 'ºC'),
	(63778, 111, '2015-02-15 00:16:12.000000', 'temperatura', 1139.0000, 'ºC'),
	(63779, 111, '2015-02-15 00:16:13.000000', 'temperatura', 455.0000, 'ºC'),
	(63780, 111, '2015-02-15 00:16:14.000000', 'temperatura', 61.0000, 'ºC'),
	(63781, 111, '2015-02-15 00:16:15.000000', 'temperatura', 138.0000, 'ºC'),
	(63782, 111, '2015-02-15 00:16:16.000000', 'temperatura', 507.0000, 'ºC'),
	(63783, 111, '2015-02-15 00:16:17.000000', 'temperatura', 923.0000, 'ºC'),
	(63784, 111, '2015-02-15 00:16:18.000000', 'temperatura', 695.0000, 'ºC'),
	(63785, 111, '2015-02-15 00:16:19.000000', 'temperatura', 706.0000, 'ºC'),
	(63786, 111, '2015-02-15 00:16:20.000000', 'temperatura', 243.0000, 'ºC'),
	(63787, 111, '2015-02-15 00:16:21.000000', 'temperatura', 301.0000, 'ºC'),
	(63788, 111, '2015-02-15 00:16:22.000000', 'temperatura', 773.0000, 'ºC'),
	(63789, 111, '2015-02-15 00:16:23.000000', 'temperatura', 565.0000, 'ºC'),
	(63790, 111, '2015-02-15 00:16:24.000000', 'temperatura', 507.0000, 'ºC'),
	(63791, 111, '2015-02-15 00:16:25.000000', 'temperatura', 840.0000, 'ºC'),
	(63792, 111, '2015-02-15 00:16:26.000000', 'temperatura', 281.0000, 'ºC'),
	(63793, 111, '2015-02-15 00:16:27.000000', 'temperatura', 84.0000, 'ºC'),
	(63794, 111, '2015-02-15 00:16:28.000000', 'temperatura', 780.0000, 'ºC'),
	(63795, 111, '2015-02-15 00:16:29.000000', 'temperatura', 45.0000, 'ºC'),
	(63796, 111, '2015-02-15 00:16:30.000000', 'temperatura', 288.0000, 'ºC'),
	(63797, 111, '2015-02-15 00:16:31.000000', 'temperatura', 103.0000, 'ºC'),
	(63798, 111, '2015-02-15 00:16:32.000000', 'temperatura', 853.0000, 'ºC'),
	(63799, 111, '2015-02-15 00:16:33.000000', 'temperatura', 355.0000, 'ºC'),
	(63800, 111, '2015-02-15 00:16:34.000000', 'temperatura', 419.0000, 'ºC'),
	(63801, 111, '2015-02-15 00:16:35.000000', 'temperatura', 1030.0000, 'ºC'),
	(63802, 111, '2015-02-15 00:16:36.000000', 'temperatura', 293.0000, 'ºC'),
	(63803, 111, '2015-02-15 00:16:37.000000', 'temperatura', 777.0000, 'ºC'),
	(63804, 111, '2015-02-15 00:16:38.000000', 'temperatura', 604.0000, 'ºC'),
	(63805, 111, '2015-02-15 00:16:39.000000', 'temperatura', 691.0000, 'ºC'),
	(63806, 111, '2015-02-15 00:16:40.000000', 'temperatura', 444.0000, 'ºC'),
	(63807, 111, '2015-02-15 00:16:41.000000', 'temperatura', 146.0000, 'ºC'),
	(63808, 111, '2015-02-15 00:16:42.000000', 'temperatura', 598.0000, 'ºC'),
	(63809, 111, '2015-02-15 00:16:43.000000', 'temperatura', 155.0000, 'ºC'),
	(63810, 111, '2015-02-15 00:16:44.000000', 'temperatura', 182.0000, 'ºC'),
	(63811, 111, '2015-02-15 00:16:45.000000', 'temperatura', 443.0000, 'ºC'),
	(63812, 111, '2015-02-15 00:16:46.000000', 'temperatura', 471.0000, 'ºC'),
	(63813, 111, '2015-02-15 00:16:47.000000', 'temperatura', 1027.0000, 'ºC'),
	(63814, 111, '2015-02-15 00:16:48.000000', 'temperatura', 121.0000, 'ºC'),
	(63815, 111, '2015-02-15 00:16:49.000000', 'temperatura', 1125.0000, 'ºC'),
	(63816, 111, '2015-02-15 00:16:50.000000', 'temperatura', 461.0000, 'ºC'),
	(63817, 111, '2015-02-15 00:16:51.000000', 'temperatura', 134.0000, 'ºC'),
	(63818, 111, '2015-02-15 00:16:52.000000', 'temperatura', 485.0000, 'ºC'),
	(63819, 111, '2015-02-15 00:16:53.000000', 'temperatura', 823.0000, 'ºC'),
	(63820, 111, '2015-02-15 00:16:54.000000', 'temperatura', 260.0000, 'ºC'),
	(63821, 111, '2015-02-15 00:16:55.000000', 'temperatura', 34.0000, 'ºC'),
	(63822, 111, '2015-02-15 00:16:56.000000', 'temperatura', 591.0000, 'ºC'),
	(63823, 111, '2015-02-15 00:16:57.000000', 'temperatura', 452.0000, 'ºC'),
	(63824, 111, '2015-02-15 00:16:58.000000', 'temperatura', 489.0000, 'ºC'),
	(63825, 111, '2015-02-15 00:16:59.000000', 'temperatura', 1089.0000, 'ºC'),
	(63826, 111, '2015-02-15 00:17:00.000000', 'temperatura', 378.0000, 'ºC'),
	(63827, 111, '2015-02-15 00:17:01.000000', 'temperatura', 1024.0000, 'ºC'),
	(63828, 111, '2015-02-15 00:17:02.000000', 'temperatura', 384.0000, 'ºC'),
	(63829, 111, '2015-02-15 00:17:03.000000', 'temperatura', 51.0000, 'ºC'),
	(63830, 111, '2015-02-15 00:17:04.000000', 'temperatura', 304.0000, 'ºC'),
	(63831, 111, '2015-02-15 00:17:05.000000', 'temperatura', 166.0000, 'ºC'),
	(63832, 111, '2015-02-15 00:17:06.000000', 'temperatura', 1118.0000, 'ºC'),
	(63833, 111, '2015-02-15 00:17:07.000000', 'temperatura', 293.0000, 'ºC'),
	(63834, 111, '2015-02-15 00:17:08.000000', 'temperatura', 513.0000, 'ºC'),
	(63835, 111, '2015-02-15 00:17:09.000000', 'temperatura', 487.0000, 'ºC'),
	(63836, 111, '2015-02-15 00:17:10.000000', 'temperatura', 894.0000, 'ºC'),
	(63837, 111, '2015-02-15 00:17:11.000000', 'temperatura', 611.0000, 'ºC'),
	(63838, 111, '2015-02-15 00:17:12.000000', 'temperatura', 371.0000, 'ºC'),
	(63839, 111, '2015-02-15 00:17:13.000000', 'temperatura', 26.0000, 'ºC'),
	(63840, 111, '2015-02-15 00:17:14.000000', 'temperatura', 216.0000, 'ºC'),
	(63841, 111, '2015-02-15 00:17:15.000000', 'temperatura', 1001.0000, 'ºC'),
	(63842, 111, '2015-02-15 00:17:16.000000', 'temperatura', 759.0000, 'ºC'),
	(63843, 111, '2015-02-15 00:17:17.000000', 'temperatura', 792.0000, 'ºC'),
	(63844, 111, '2015-02-15 00:17:18.000000', 'temperatura', 485.0000, 'ºC'),
	(63845, 111, '2015-02-15 00:17:19.000000', 'temperatura', 49.0000, 'ºC'),
	(63846, 111, '2015-02-15 00:17:20.000000', 'temperatura', 1190.0000, 'ºC'),
	(63847, 111, '2015-02-15 00:17:21.000000', 'temperatura', 1005.0000, 'ºC'),
	(63848, 111, '2015-02-15 00:17:22.000000', 'temperatura', 256.0000, 'ºC'),
	(63849, 111, '2015-02-15 00:17:23.000000', 'temperatura', 663.0000, 'ºC'),
	(63850, 111, '2015-02-15 00:17:24.000000', 'temperatura', 149.0000, 'ºC'),
	(63851, 111, '2015-02-15 00:17:25.000000', 'temperatura', 1156.0000, 'ºC'),
	(63852, 111, '2015-02-15 00:17:26.000000', 'temperatura', 534.0000, 'ºC'),
	(63853, 111, '2015-02-15 00:17:27.000000', 'temperatura', 404.0000, 'ºC'),
	(63854, 111, '2015-02-15 00:17:28.000000', 'temperatura', 416.0000, 'ºC'),
	(63855, 111, '2015-02-15 00:17:29.000000', 'temperatura', 870.0000, 'ºC'),
	(63856, 111, '2015-02-15 00:17:30.000000', 'temperatura', 703.0000, 'ºC'),
	(63857, 111, '2015-02-15 00:17:31.000000', 'temperatura', 905.0000, 'ºC'),
	(63858, 111, '2015-02-15 00:17:32.000000', 'temperatura', 18.0000, 'ºC'),
	(63859, 111, '2015-02-15 00:17:33.000000', 'temperatura', 975.0000, 'ºC'),
	(63860, 111, '2015-02-15 00:17:34.000000', 'temperatura', 19.0000, 'ºC'),
	(63861, 111, '2015-02-15 00:17:35.000000', 'temperatura', 773.0000, 'ºC'),
	(63862, 111, '2015-02-15 00:17:36.000000', 'temperatura', 209.0000, 'ºC'),
	(63863, 111, '2015-02-15 00:17:37.000000', 'temperatura', 1126.0000, 'ºC'),
	(63864, 111, '2015-02-15 00:17:38.000000', 'temperatura', 205.0000, 'ºC'),
	(63865, 111, '2015-02-15 00:17:39.000000', 'temperatura', 47.0000, 'ºC'),
	(63866, 111, '2015-02-15 00:17:40.000000', 'temperatura', 822.0000, 'ºC'),
	(63867, 111, '2015-02-15 00:17:41.000000', 'temperatura', 368.0000, 'ºC'),
	(63868, 111, '2015-02-15 00:17:42.000000', 'temperatura', 577.0000, 'ºC'),
	(63869, 111, '2015-02-15 00:17:43.000000', 'temperatura', 578.0000, 'ºC'),
	(63870, 111, '2015-02-15 00:17:44.000000', 'temperatura', 1162.0000, 'ºC'),
	(63871, 111, '2015-02-15 00:17:45.000000', 'temperatura', 475.0000, 'ºC'),
	(63872, 111, '2015-02-15 00:17:46.000000', 'temperatura', 90.0000, 'ºC'),
	(63873, 111, '2015-02-15 00:17:47.000000', 'temperatura', 225.0000, 'ºC'),
	(63874, 111, '2015-02-15 00:17:48.000000', 'temperatura', 857.0000, 'ºC'),
	(63875, 111, '2015-02-15 00:17:49.000000', 'temperatura', 10.0000, 'ºC'),
	(63876, 111, '2015-02-15 00:17:50.000000', 'temperatura', 1081.0000, 'ºC'),
	(63877, 111, '2015-02-15 00:17:51.000000', 'temperatura', 575.0000, 'ºC'),
	(63878, 111, '2015-02-15 00:17:52.000000', 'temperatura', 833.0000, 'ºC'),
	(63879, 111, '2015-02-15 00:17:53.000000', 'temperatura', 38.0000, 'ºC'),
	(63880, 111, '2015-02-15 00:17:54.000000', 'temperatura', 93.0000, 'ºC'),
	(63881, 111, '2015-02-15 00:17:55.000000', 'temperatura', 353.0000, 'ºC'),
	(63882, 111, '2015-02-15 00:17:56.000000', 'temperatura', 283.0000, 'ºC'),
	(63883, 111, '2015-02-15 00:17:57.000000', 'temperatura', 359.0000, 'ºC'),
	(63884, 111, '2015-02-15 00:17:58.000000', 'temperatura', 947.0000, 'ºC'),
	(63885, 111, '2015-02-15 00:17:59.000000', 'temperatura', 59.0000, 'ºC'),
	(63886, 111, '2015-02-15 00:18:00.000000', 'temperatura', 1055.0000, 'ºC'),
	(63887, 111, '2015-02-15 00:18:01.000000', 'temperatura', 299.0000, 'ºC'),
	(63888, 111, '2015-02-15 00:18:02.000000', 'temperatura', 729.0000, 'ºC'),
	(63889, 111, '2015-02-15 00:18:03.000000', 'temperatura', 350.0000, 'ºC'),
	(63890, 111, '2015-02-15 00:18:04.000000', 'temperatura', 764.0000, 'ºC'),
	(63891, 111, '2015-02-15 00:18:05.000000', 'temperatura', 371.0000, 'ºC'),
	(63892, 111, '2015-02-15 00:18:06.000000', 'temperatura', 761.0000, 'ºC'),
	(63893, 111, '2015-02-15 00:18:07.000000', 'temperatura', 291.0000, 'ºC'),
	(63894, 111, '2015-02-15 00:18:08.000000', 'temperatura', 376.0000, 'ºC'),
	(63895, 111, '2015-02-15 00:18:09.000000', 'temperatura', 1007.0000, 'ºC'),
	(63896, 111, '2015-02-15 00:18:10.000000', 'temperatura', 307.0000, 'ºC'),
	(63897, 111, '2015-02-15 00:18:11.000000', 'temperatura', 913.0000, 'ºC'),
	(63898, 111, '2015-02-15 00:18:12.000000', 'temperatura', 44.0000, 'ºC'),
	(63899, 111, '2015-02-15 00:18:13.000000', 'temperatura', 1081.0000, 'ºC'),
	(63900, 111, '2015-02-15 00:18:14.000000', 'temperatura', 474.0000, 'ºC'),
	(63901, 111, '2015-02-15 00:18:15.000000', 'temperatura', 328.0000, 'ºC'),
	(63902, 111, '2015-02-15 00:18:16.000000', 'temperatura', 220.0000, 'ºC'),
	(63903, 111, '2015-02-15 00:18:17.000000', 'temperatura', 115.0000, 'ºC'),
	(63904, 111, '2015-02-15 00:18:18.000000', 'temperatura', 1115.0000, 'ºC'),
	(63905, 111, '2015-02-15 00:18:19.000000', 'temperatura', 430.0000, 'ºC'),
	(63906, 111, '2015-02-15 00:18:20.000000', 'temperatura', 7.0000, 'ºC'),
	(63907, 111, '2015-02-15 00:18:21.000000', 'temperatura', 1144.0000, 'ºC'),
	(63908, 111, '2015-02-15 00:18:22.000000', 'temperatura', 899.0000, 'ºC'),
	(63909, 111, '2015-02-15 00:18:23.000000', 'temperatura', 1064.0000, 'ºC'),
	(63910, 111, '2015-02-15 00:18:24.000000', 'temperatura', 224.0000, 'ºC'),
	(63911, 111, '2015-02-15 00:18:25.000000', 'temperatura', 327.0000, 'ºC'),
	(63912, 111, '2015-02-15 00:18:26.000000', 'temperatura', 964.0000, 'ºC'),
	(63913, 111, '2015-02-15 00:18:27.000000', 'temperatura', 238.0000, 'ºC'),
	(63914, 111, '2015-02-15 00:18:28.000000', 'temperatura', 699.0000, 'ºC'),
	(63915, 111, '2015-02-15 00:18:29.000000', 'temperatura', 383.0000, 'ºC'),
	(63916, 111, '2015-02-15 00:18:30.000000', 'temperatura', 1017.0000, 'ºC'),
	(63917, 111, '2015-02-15 00:18:31.000000', 'temperatura', 336.0000, 'ºC'),
	(63918, 111, '2015-02-15 00:18:32.000000', 'temperatura', 1029.0000, 'ºC'),
	(63919, 111, '2015-02-15 00:18:33.000000', 'temperatura', 537.0000, 'ºC'),
	(63920, 111, '2015-02-15 00:18:34.000000', 'temperatura', 800.0000, 'ºC'),
	(63921, 111, '2015-02-15 00:18:35.000000', 'temperatura', 1189.0000, 'ºC'),
	(63922, 111, '2015-02-15 00:18:36.000000', 'temperatura', 1145.0000, 'ºC'),
	(63923, 111, '2015-02-15 00:18:37.000000', 'temperatura', 959.0000, 'ºC'),
	(63924, 111, '2015-02-15 00:18:38.000000', 'temperatura', 159.0000, 'ºC'),
	(63925, 111, '2015-02-15 00:18:39.000000', 'temperatura', 319.0000, 'ºC'),
	(63926, 111, '2015-02-15 00:18:40.000000', 'temperatura', 1118.0000, 'ºC'),
	(63927, 111, '2015-02-15 00:18:41.000000', 'temperatura', 1036.0000, 'ºC'),
	(63928, 111, '2015-02-15 00:18:42.000000', 'temperatura', 625.0000, 'ºC'),
	(63929, 111, '2015-02-15 00:18:43.000000', 'temperatura', 18.0000, 'ºC'),
	(63930, 111, '2015-02-15 00:18:44.000000', 'temperatura', 615.0000, 'ºC'),
	(63931, 111, '2015-02-15 00:18:45.000000', 'temperatura', 621.0000, 'ºC'),
	(63932, 111, '2015-02-15 00:18:46.000000', 'temperatura', 61.0000, 'ºC'),
	(63933, 111, '2015-02-15 00:18:47.000000', 'temperatura', 842.0000, 'ºC'),
	(63934, 111, '2015-02-15 00:18:48.000000', 'temperatura', 426.0000, 'ºC'),
	(63935, 111, '2015-02-15 00:18:49.000000', 'temperatura', 806.0000, 'ºC'),
	(63936, 111, '2015-02-15 00:18:50.000000', 'temperatura', 351.0000, 'ºC'),
	(63937, 111, '2015-02-15 00:18:51.000000', 'temperatura', 538.0000, 'ºC'),
	(63938, 111, '2015-02-15 00:18:52.000000', 'temperatura', 438.0000, 'ºC'),
	(63939, 111, '2015-02-15 00:18:53.000000', 'temperatura', 575.0000, 'ºC'),
	(63940, 111, '2015-02-15 00:18:54.000000', 'temperatura', 364.0000, 'ºC'),
	(63941, 111, '2015-02-15 00:18:55.000000', 'temperatura', 94.0000, 'ºC'),
	(63942, 111, '2015-02-15 00:18:56.000000', 'temperatura', 578.0000, 'ºC'),
	(63943, 111, '2015-02-15 00:18:57.000000', 'temperatura', 208.0000, 'ºC'),
	(63944, 111, '2015-02-15 00:18:58.000000', 'temperatura', 506.0000, 'ºC'),
	(63945, 111, '2015-02-15 00:18:59.000000', 'temperatura', 706.0000, 'ºC'),
	(63946, 111, '2015-02-15 00:19:00.000000', 'temperatura', 815.0000, 'ºC'),
	(63947, 111, '2015-02-15 00:19:01.000000', 'temperatura', 755.0000, 'ºC'),
	(63948, 111, '2015-02-15 00:19:02.000000', 'temperatura', 133.0000, 'ºC'),
	(63949, 111, '2015-02-15 00:19:03.000000', 'temperatura', 799.0000, 'ºC'),
	(63950, 111, '2015-02-15 00:19:04.000000', 'temperatura', 1198.0000, 'ºC'),
	(63951, 111, '2015-02-15 00:19:05.000000', 'temperatura', 1194.0000, 'ºC'),
	(63952, 111, '2015-02-15 00:19:06.000000', 'temperatura', 1177.0000, 'ºC'),
	(63953, 111, '2015-02-15 00:19:07.000000', 'temperatura', 1101.0000, 'ºC'),
	(63954, 111, '2015-02-15 00:19:08.000000', 'temperatura', 775.0000, 'ºC'),
	(63955, 111, '2015-02-15 00:19:09.000000', 'temperatura', 574.0000, 'ºC'),
	(63956, 111, '2015-02-15 00:19:10.000000', 'temperatura', 543.0000, 'ºC'),
	(63957, 111, '2015-02-15 00:19:11.000000', 'temperatura', 995.0000, 'ºC'),
	(63958, 111, '2015-02-15 00:19:12.000000', 'temperatura', 944.0000, 'ºC'),
	(63959, 111, '2015-02-15 00:19:13.000000', 'temperatura', 538.0000, 'ºC'),
	(63960, 111, '2015-02-15 00:19:14.000000', 'temperatura', 1057.0000, 'ºC'),
	(63961, 111, '2015-02-15 00:19:15.000000', 'temperatura', 70.0000, 'ºC'),
	(63962, 111, '2015-02-15 00:19:16.000000', 'temperatura', 783.0000, 'ºC'),
	(63963, 111, '2015-02-15 00:19:17.000000', 'temperatura', 104.0000, 'ºC'),
	(63964, 111, '2015-02-15 00:19:18.000000', 'temperatura', 572.0000, 'ºC'),
	(63965, 111, '2015-02-15 00:19:19.000000', 'temperatura', 147.0000, 'ºC'),
	(63966, 111, '2015-02-15 00:19:20.000000', 'temperatura', 219.0000, 'ºC'),
	(63967, 111, '2015-02-15 00:19:21.000000', 'temperatura', 657.0000, 'ºC'),
	(63968, 111, '2015-02-15 00:19:22.000000', 'temperatura', 226.0000, 'ºC'),
	(63969, 111, '2015-02-15 00:19:23.000000', 'temperatura', 362.0000, 'ºC'),
	(63970, 111, '2015-02-15 00:19:24.000000', 'temperatura', 1133.0000, 'ºC'),
	(63971, 111, '2015-02-15 00:19:25.000000', 'temperatura', 979.0000, 'ºC'),
	(63972, 111, '2015-02-15 00:19:26.000000', 'temperatura', 294.0000, 'ºC'),
	(63973, 111, '2015-02-15 00:19:27.000000', 'temperatura', 936.0000, 'ºC'),
	(63974, 111, '2015-02-15 00:19:28.000000', 'temperatura', 196.0000, 'ºC'),
	(63975, 111, '2015-02-15 00:19:29.000000', 'temperatura', 574.0000, 'ºC'),
	(63976, 111, '2015-02-15 00:19:30.000000', 'temperatura', 1081.0000, 'ºC'),
	(63977, 111, '2015-02-15 00:19:31.000000', 'temperatura', 84.0000, 'ºC'),
	(63978, 111, '2015-02-15 00:19:32.000000', 'temperatura', 777.0000, 'ºC'),
	(63979, 111, '2015-02-15 00:19:33.000000', 'temperatura', 32.0000, 'ºC'),
	(63980, 111, '2015-02-15 00:19:34.000000', 'temperatura', 231.0000, 'ºC'),
	(63981, 111, '2015-02-15 00:19:35.000000', 'temperatura', 1059.0000, 'ºC'),
	(63982, 111, '2015-02-15 00:19:36.000000', 'temperatura', 1002.0000, 'ºC'),
	(63983, 111, '2015-02-15 00:19:37.000000', 'temperatura', 633.0000, 'ºC'),
	(63984, 111, '2015-02-15 00:19:38.000000', 'temperatura', 162.0000, 'ºC'),
	(63985, 111, '2015-02-15 00:19:39.000000', 'temperatura', 110.0000, 'ºC'),
	(63986, 111, '2015-02-15 00:19:40.000000', 'temperatura', 65.0000, 'ºC'),
	(63987, 111, '2015-02-15 00:19:41.000000', 'temperatura', 1196.0000, 'ºC'),
	(63988, 111, '2015-02-15 00:19:42.000000', 'temperatura', 985.0000, 'ºC'),
	(63989, 111, '2015-02-15 00:19:43.000000', 'temperatura', 139.0000, 'ºC'),
	(63990, 111, '2015-02-15 00:19:44.000000', 'temperatura', 140.0000, 'ºC'),
	(63991, 111, '2015-02-15 00:19:45.000000', 'temperatura', 282.0000, 'ºC'),
	(63992, 111, '2015-02-15 00:19:46.000000', 'temperatura', 989.0000, 'ºC'),
	(63993, 111, '2015-02-15 00:19:47.000000', 'temperatura', 502.0000, 'ºC'),
	(63994, 111, '2015-02-15 00:19:48.000000', 'temperatura', 742.0000, 'ºC'),
	(63995, 111, '2015-02-15 00:19:49.000000', 'temperatura', 1007.0000, 'ºC'),
	(63996, 111, '2015-02-15 00:19:50.000000', 'temperatura', 409.0000, 'ºC'),
	(63997, 111, '2015-02-15 00:19:51.000000', 'temperatura', 223.0000, 'ºC'),
	(63998, 111, '2015-02-15 00:19:52.000000', 'temperatura', 1090.0000, 'ºC'),
	(63999, 111, '2015-02-15 00:19:53.000000', 'temperatura', 1181.0000, 'ºC'),
	(64000, 111, '2015-02-15 00:19:54.000000', 'temperatura', 234.0000, 'ºC'),
	(64001, 111, '2015-02-15 00:19:55.000000', 'temperatura', 28.0000, 'ºC'),
	(64002, 111, '2015-02-15 00:19:56.000000', 'temperatura', 637.0000, 'ºC'),
	(64003, 111, '2015-02-15 00:19:57.000000', 'temperatura', 704.0000, 'ºC'),
	(64004, 111, '2015-02-15 00:19:58.000000', 'temperatura', 410.0000, 'ºC'),
	(64005, 111, '2015-02-15 00:19:59.000000', 'temperatura', 1136.0000, 'ºC'),
	(64006, 111, '2015-02-15 00:20:00.000000', 'temperatura', 852.0000, 'ºC'),
	(64007, 111, '2015-02-15 00:20:01.000000', 'temperatura', 852.0000, 'ºC'),
	(64008, 111, '2015-02-15 00:20:02.000000', 'temperatura', 506.0000, 'ºC'),
	(64009, 111, '2015-02-15 00:20:03.000000', 'temperatura', 1175.0000, 'ºC'),
	(64010, 111, '2015-02-15 00:20:04.000000', 'temperatura', 757.0000, 'ºC'),
	(64011, 111, '2015-02-15 00:20:05.000000', 'temperatura', 261.0000, 'ºC'),
	(64012, 111, '2015-02-15 00:20:06.000000', 'temperatura', 234.0000, 'ºC'),
	(64013, 111, '2015-02-15 00:20:07.000000', 'temperatura', 386.0000, 'ºC'),
	(64014, 111, '2015-02-15 00:20:08.000000', 'temperatura', 30.0000, 'ºC'),
	(64015, 111, '2015-02-15 00:20:09.000000', 'temperatura', 194.0000, 'ºC'),
	(64016, 111, '2015-02-15 00:20:10.000000', 'temperatura', 878.0000, 'ºC'),
	(64017, 111, '2015-02-15 00:20:11.000000', 'temperatura', 210.0000, 'ºC'),
	(64018, 111, '2015-02-15 00:20:12.000000', 'temperatura', 814.0000, 'ºC'),
	(64019, 111, '2015-02-15 00:20:13.000000', 'temperatura', 1042.0000, 'ºC'),
	(64020, 111, '2015-02-15 00:20:14.000000', 'temperatura', 368.0000, 'ºC'),
	(64021, 111, '2015-02-15 00:20:15.000000', 'temperatura', 1117.0000, 'ºC'),
	(64022, 111, '2015-02-15 00:20:16.000000', 'temperatura', 880.0000, 'ºC'),
	(64023, 111, '2015-02-15 00:20:17.000000', 'temperatura', 1048.0000, 'ºC'),
	(64024, 111, '2015-02-15 00:20:18.000000', 'temperatura', 201.0000, 'ºC'),
	(64025, 111, '2015-02-15 00:20:19.000000', 'temperatura', 264.0000, 'ºC'),
	(64026, 111, '2015-02-15 00:20:20.000000', 'temperatura', 716.0000, 'ºC'),
	(64027, 111, '2015-02-15 00:20:21.000000', 'temperatura', 386.0000, 'ºC'),
	(64028, 111, '2015-02-15 00:20:22.000000', 'temperatura', 986.0000, 'ºC'),
	(64029, 111, '2015-02-15 00:20:23.000000', 'temperatura', 172.0000, 'ºC'),
	(64030, 111, '2015-02-15 00:20:24.000000', 'temperatura', 301.0000, 'ºC'),
	(64031, 111, '2015-02-15 00:20:25.000000', 'temperatura', 990.0000, 'ºC'),
	(64032, 111, '2015-02-15 00:20:26.000000', 'temperatura', 446.0000, 'ºC'),
	(64033, 111, '2015-02-15 00:20:27.000000', 'temperatura', 463.0000, 'ºC'),
	(64034, 111, '2015-02-15 00:20:28.000000', 'temperatura', 979.0000, 'ºC'),
	(64035, 111, '2015-02-15 00:20:29.000000', 'temperatura', 1103.0000, 'ºC'),
	(64036, 111, '2015-02-15 00:20:30.000000', 'temperatura', 181.0000, 'ºC'),
	(64037, 111, '2015-02-15 00:20:31.000000', 'temperatura', 1197.0000, 'ºC'),
	(64038, 111, '2015-02-15 00:20:32.000000', 'temperatura', 641.0000, 'ºC'),
	(64039, 111, '2015-02-15 00:20:33.000000', 'temperatura', 813.0000, 'ºC'),
	(64040, 111, '2015-02-15 00:20:34.000000', 'temperatura', 945.0000, 'ºC'),
	(64041, 111, '2015-02-15 00:20:35.000000', 'temperatura', 1087.0000, 'ºC'),
	(64042, 111, '2015-02-15 00:20:36.000000', 'temperatura', 198.0000, 'ºC'),
	(64043, 111, '2015-02-15 00:20:37.000000', 'temperatura', 130.0000, 'ºC'),
	(64044, 111, '2015-02-15 00:20:38.000000', 'temperatura', 55.0000, 'ºC'),
	(64045, 111, '2015-02-15 00:20:39.000000', 'temperatura', 1086.0000, 'ºC'),
	(64046, 111, '2015-02-15 00:20:40.000000', 'temperatura', 467.0000, 'ºC'),
	(64047, 111, '2015-02-15 00:20:41.000000', 'temperatura', 278.0000, 'ºC'),
	(64048, 111, '2015-02-15 00:20:42.000000', 'temperatura', 1190.0000, 'ºC'),
	(64049, 111, '2015-02-15 00:20:43.000000', 'temperatura', 314.0000, 'ºC'),
	(64050, 111, '2015-02-15 00:20:44.000000', 'temperatura', 400.0000, 'ºC'),
	(64051, 111, '2015-02-15 00:20:45.000000', 'temperatura', 1060.0000, 'ºC'),
	(64052, 111, '2015-02-15 00:20:46.000000', 'temperatura', 498.0000, 'ºC'),
	(64053, 111, '2015-02-15 00:20:47.000000', 'temperatura', 514.0000, 'ºC'),
	(64054, 111, '2015-02-15 00:20:48.000000', 'temperatura', 1075.0000, 'ºC'),
	(64055, 111, '2015-02-15 00:20:49.000000', 'temperatura', 233.0000, 'ºC'),
	(64056, 111, '2015-02-15 00:20:50.000000', 'temperatura', 340.0000, 'ºC'),
	(64057, 111, '2015-02-15 00:20:51.000000', 'temperatura', 1002.0000, 'ºC'),
	(64058, 111, '2015-02-15 00:20:52.000000', 'temperatura', 392.0000, 'ºC'),
	(64059, 111, '2015-02-15 00:20:53.000000', 'temperatura', 151.0000, 'ºC'),
	(64060, 111, '2015-02-15 00:20:54.000000', 'temperatura', 783.0000, 'ºC'),
	(64061, 111, '2015-02-15 00:20:55.000000', 'temperatura', 1062.0000, 'ºC'),
	(64062, 111, '2015-02-15 00:20:56.000000', 'temperatura', 559.0000, 'ºC'),
	(64063, 111, '2015-02-15 00:20:57.000000', 'temperatura', 813.0000, 'ºC'),
	(64064, 111, '2015-02-15 00:20:58.000000', 'temperatura', 1186.0000, 'ºC'),
	(64065, 111, '2015-02-15 00:20:59.000000', 'temperatura', 1094.0000, 'ºC'),
	(64066, 111, '2015-02-15 00:21:00.000000', 'temperatura', 710.0000, 'ºC'),
	(64067, 111, '2015-02-15 00:21:01.000000', 'temperatura', 268.0000, 'ºC'),
	(64068, 111, '2015-02-15 00:21:02.000000', 'temperatura', 410.0000, 'ºC'),
	(64069, 111, '2015-02-15 00:21:03.000000', 'temperatura', 46.0000, 'ºC'),
	(64070, 111, '2015-02-15 00:21:04.000000', 'temperatura', 200.0000, 'ºC'),
	(64071, 111, '2015-02-15 00:21:05.000000', 'temperatura', 864.0000, 'ºC'),
	(64072, 111, '2015-02-15 00:21:06.000000', 'temperatura', 119.0000, 'ºC'),
	(64073, 111, '2015-02-15 00:21:07.000000', 'temperatura', 405.0000, 'ºC'),
	(64074, 111, '2015-02-15 00:21:08.000000', 'temperatura', 469.0000, 'ºC'),
	(64075, 111, '2015-02-15 00:21:09.000000', 'temperatura', 1129.0000, 'ºC'),
	(64076, 111, '2015-02-15 00:21:10.000000', 'temperatura', 637.0000, 'ºC'),
	(64077, 111, '2015-02-15 00:21:11.000000', 'temperatura', 1001.0000, 'ºC'),
	(64078, 111, '2015-02-15 00:21:12.000000', 'temperatura', 692.0000, 'ºC'),
	(64079, 111, '2015-02-15 00:21:13.000000', 'temperatura', 459.0000, 'ºC'),
	(64080, 111, '2015-02-15 00:21:14.000000', 'temperatura', 221.0000, 'ºC'),
	(64081, 111, '2015-02-15 00:21:15.000000', 'temperatura', 929.0000, 'ºC'),
	(64082, 111, '2015-02-15 00:21:16.000000', 'temperatura', 382.0000, 'ºC'),
	(64083, 111, '2015-02-15 00:21:17.000000', 'temperatura', 322.0000, 'ºC'),
	(64084, 111, '2015-02-15 00:21:18.000000', 'temperatura', 463.0000, 'ºC'),
	(64085, 111, '2015-02-15 00:21:19.000000', 'temperatura', 152.0000, 'ºC'),
	(64086, 111, '2015-02-15 00:21:20.000000', 'temperatura', 569.0000, 'ºC'),
	(64087, 111, '2015-02-15 00:21:21.000000', 'temperatura', 1192.0000, 'ºC'),
	(64088, 111, '2015-02-15 00:21:22.000000', 'temperatura', 655.0000, 'ºC'),
	(64089, 111, '2015-02-15 00:21:23.000000', 'temperatura', 896.0000, 'ºC'),
	(64090, 111, '2015-02-15 00:21:24.000000', 'temperatura', 119.0000, 'ºC'),
	(64091, 111, '2015-02-15 00:21:25.000000', 'temperatura', 305.0000, 'ºC'),
	(64092, 111, '2015-02-15 00:21:26.000000', 'temperatura', 1170.0000, 'ºC'),
	(64093, 111, '2015-02-15 00:21:27.000000', 'temperatura', 135.0000, 'ºC'),
	(64094, 111, '2015-02-15 00:21:28.000000', 'temperatura', 764.0000, 'ºC'),
	(64095, 111, '2015-02-15 00:21:29.000000', 'temperatura', 1017.0000, 'ºC'),
	(64096, 111, '2015-02-15 00:21:30.000000', 'temperatura', 394.0000, 'ºC'),
	(64097, 111, '2015-02-15 00:21:31.000000', 'temperatura', 120.0000, 'ºC'),
	(64098, 111, '2015-02-15 00:21:32.000000', 'temperatura', 617.0000, 'ºC'),
	(64099, 111, '2015-02-15 00:21:33.000000', 'temperatura', 327.0000, 'ºC'),
	(64100, 111, '2015-02-15 00:21:34.000000', 'temperatura', 985.0000, 'ºC'),
	(64101, 111, '2015-02-15 00:21:35.000000', 'temperatura', 344.0000, 'ºC'),
	(64102, 111, '2015-02-15 00:21:36.000000', 'temperatura', 1167.0000, 'ºC'),
	(64103, 111, '2015-02-15 00:21:37.000000', 'temperatura', 1.0000, 'ºC'),
	(64104, 111, '2015-02-15 00:21:38.000000', 'temperatura', 105.0000, 'ºC'),
	(64105, 111, '2015-02-15 00:21:39.000000', 'temperatura', 521.0000, 'ºC'),
	(64106, 111, '2015-02-15 00:21:40.000000', 'temperatura', 1091.0000, 'ºC'),
	(64107, 111, '2015-02-15 00:21:41.000000', 'temperatura', 291.0000, 'ºC'),
	(64108, 111, '2015-02-15 00:21:42.000000', 'temperatura', 586.0000, 'ºC'),
	(64109, 111, '2015-02-15 00:21:43.000000', 'temperatura', 856.0000, 'ºC'),
	(64110, 111, '2015-02-15 00:21:44.000000', 'temperatura', 123.0000, 'ºC'),
	(64111, 111, '2015-02-15 00:21:45.000000', 'temperatura', 448.0000, 'ºC'),
	(64112, 111, '2015-02-15 00:21:46.000000', 'temperatura', 673.0000, 'ºC'),
	(64113, 111, '2015-02-15 00:21:47.000000', 'temperatura', 819.0000, 'ºC'),
	(64114, 111, '2015-02-15 00:21:48.000000', 'temperatura', 879.0000, 'ºC'),
	(64115, 111, '2015-02-15 00:21:49.000000', 'temperatura', 735.0000, 'ºC'),
	(64116, 111, '2015-02-15 00:21:50.000000', 'temperatura', 1042.0000, 'ºC'),
	(64117, 111, '2015-02-15 00:21:51.000000', 'temperatura', 603.0000, 'ºC'),
	(64118, 111, '2015-02-15 00:21:52.000000', 'temperatura', 1089.0000, 'ºC'),
	(64119, 111, '2015-02-15 00:21:53.000000', 'temperatura', 39.0000, 'ºC'),
	(64120, 111, '2015-02-15 00:21:54.000000', 'temperatura', 527.0000, 'ºC'),
	(64121, 111, '2015-02-15 00:21:55.000000', 'temperatura', 117.0000, 'ºC'),
	(64122, 111, '2015-02-15 00:21:56.000000', 'temperatura', 204.0000, 'ºC'),
	(64123, 111, '2015-02-15 00:21:57.000000', 'temperatura', 672.0000, 'ºC'),
	(64124, 111, '2015-02-15 00:21:58.000000', 'temperatura', 349.0000, 'ºC'),
	(64125, 111, '2015-02-15 00:21:59.000000', 'temperatura', 929.0000, 'ºC'),
	(64126, 111, '2015-02-15 00:22:00.000000', 'temperatura', 0.0000, 'ºC'),
	(64127, 111, '2015-02-15 00:22:01.000000', 'temperatura', 812.0000, 'ºC'),
	(64128, 111, '2015-02-15 00:22:02.000000', 'temperatura', 463.0000, 'ºC'),
	(64129, 111, '2015-02-15 00:22:03.000000', 'temperatura', 1077.0000, 'ºC'),
	(64130, 111, '2015-02-15 00:22:04.000000', 'temperatura', 397.0000, 'ºC'),
	(64131, 111, '2015-02-15 00:22:05.000000', 'temperatura', 1153.0000, 'ºC'),
	(64132, 111, '2015-02-15 00:22:06.000000', 'temperatura', 977.0000, 'ºC'),
	(64133, 111, '2015-02-15 00:22:07.000000', 'temperatura', 226.0000, 'ºC'),
	(64134, 111, '2015-02-15 00:22:08.000000', 'temperatura', 598.0000, 'ºC'),
	(64135, 111, '2015-02-15 00:22:09.000000', 'temperatura', 1112.0000, 'ºC'),
	(64136, 111, '2015-02-15 00:22:10.000000', 'temperatura', 168.0000, 'ºC'),
	(64137, 111, '2015-02-15 00:22:11.000000', 'temperatura', 1105.0000, 'ºC'),
	(64138, 111, '2015-02-15 00:22:12.000000', 'temperatura', 220.0000, 'ºC'),
	(64139, 111, '2015-02-15 00:22:13.000000', 'temperatura', 185.0000, 'ºC'),
	(64140, 111, '2015-02-15 00:22:14.000000', 'temperatura', 264.0000, 'ºC'),
	(64141, 111, '2015-02-15 00:22:15.000000', 'temperatura', 769.0000, 'ºC'),
	(64142, 111, '2015-02-15 00:22:16.000000', 'temperatura', 651.0000, 'ºC'),
	(64143, 111, '2015-02-15 00:22:17.000000', 'temperatura', 948.0000, 'ºC'),
	(64144, 111, '2015-02-15 00:22:18.000000', 'temperatura', 389.0000, 'ºC'),
	(64145, 111, '2015-02-15 00:22:19.000000', 'temperatura', 299.0000, 'ºC'),
	(64146, 111, '2015-02-15 00:22:20.000000', 'temperatura', 332.0000, 'ºC'),
	(64147, 111, '2015-02-15 00:22:21.000000', 'temperatura', 762.0000, 'ºC'),
	(64148, 111, '2015-02-15 00:22:22.000000', 'temperatura', 415.0000, 'ºC'),
	(64149, 111, '2015-02-15 00:22:23.000000', 'temperatura', 988.0000, 'ºC'),
	(64150, 111, '2015-02-15 00:22:24.000000', 'temperatura', 98.0000, 'ºC'),
	(64151, 111, '2015-02-15 00:22:25.000000', 'temperatura', 1126.0000, 'ºC'),
	(64152, 111, '2015-02-15 00:22:26.000000', 'temperatura', 537.0000, 'ºC'),
	(64153, 111, '2015-02-15 00:22:27.000000', 'temperatura', 509.0000, 'ºC'),
	(64154, 111, '2015-02-15 00:22:28.000000', 'temperatura', 931.0000, 'ºC'),
	(64155, 111, '2015-02-15 00:22:29.000000', 'temperatura', 730.0000, 'ºC'),
	(64156, 111, '2015-02-15 00:22:30.000000', 'temperatura', 857.0000, 'ºC'),
	(64157, 111, '2015-02-15 00:22:31.000000', 'temperatura', 895.0000, 'ºC'),
	(64158, 111, '2015-02-15 00:22:32.000000', 'temperatura', 704.0000, 'ºC'),
	(64159, 111, '2015-02-15 00:22:33.000000', 'temperatura', 836.0000, 'ºC'),
	(64160, 111, '2015-02-15 00:22:34.000000', 'temperatura', 868.0000, 'ºC'),
	(64161, 111, '2015-02-15 00:22:35.000000', 'temperatura', 634.0000, 'ºC'),
	(64162, 111, '2015-02-15 00:22:36.000000', 'temperatura', 564.0000, 'ºC'),
	(64163, 111, '2015-02-15 00:22:37.000000', 'temperatura', 919.0000, 'ºC'),
	(64164, 111, '2015-02-15 00:22:38.000000', 'temperatura', 505.0000, 'ºC'),
	(64165, 111, '2015-02-15 00:22:39.000000', 'temperatura', 967.0000, 'ºC'),
	(64166, 111, '2015-02-15 00:22:40.000000', 'temperatura', 919.0000, 'ºC'),
	(64167, 111, '2015-02-15 00:22:41.000000', 'temperatura', 496.0000, 'ºC'),
	(64168, 111, '2015-02-15 00:22:42.000000', 'temperatura', 925.0000, 'ºC'),
	(64169, 111, '2015-02-15 00:22:43.000000', 'temperatura', 736.0000, 'ºC'),
	(64170, 111, '2015-02-15 00:22:44.000000', 'temperatura', 906.0000, 'ºC'),
	(64171, 111, '2015-02-15 00:22:45.000000', 'temperatura', 1124.0000, 'ºC'),
	(64172, 111, '2015-02-15 00:22:46.000000', 'temperatura', 501.0000, 'ºC'),
	(64173, 111, '2015-02-15 00:22:47.000000', 'temperatura', 335.0000, 'ºC'),
	(64174, 111, '2015-02-15 00:22:48.000000', 'temperatura', 173.0000, 'ºC'),
	(64175, 111, '2015-02-15 00:22:49.000000', 'temperatura', 1059.0000, 'ºC'),
	(64176, 111, '2015-02-15 00:22:50.000000', 'temperatura', 1177.0000, 'ºC'),
	(64177, 111, '2015-02-15 00:22:51.000000', 'temperatura', 307.0000, 'ºC'),
	(64178, 111, '2015-02-15 00:22:52.000000', 'temperatura', 406.0000, 'ºC'),
	(64179, 111, '2015-02-15 00:22:53.000000', 'temperatura', 1108.0000, 'ºC'),
	(64180, 111, '2015-02-15 00:22:54.000000', 'temperatura', 723.0000, 'ºC'),
	(64181, 111, '2015-02-15 00:22:55.000000', 'temperatura', 294.0000, 'ºC'),
	(64182, 111, '2015-02-15 00:22:56.000000', 'temperatura', 499.0000, 'ºC'),
	(64183, 111, '2015-02-15 00:22:57.000000', 'temperatura', 415.0000, 'ºC'),
	(64184, 111, '2015-02-15 00:22:58.000000', 'temperatura', 579.0000, 'ºC'),
	(64185, 111, '2015-02-15 00:22:59.000000', 'temperatura', 450.0000, 'ºC'),
	(64186, 111, '2015-02-15 00:23:00.000000', 'temperatura', 513.0000, 'ºC'),
	(64187, 111, '2015-02-15 00:23:01.000000', 'temperatura', 18.0000, 'ºC'),
	(64188, 111, '2015-02-15 00:23:02.000000', 'temperatura', 948.0000, 'ºC'),
	(64189, 111, '2015-02-15 00:23:03.000000', 'temperatura', 1089.0000, 'ºC'),
	(64190, 111, '2015-02-15 00:23:04.000000', 'temperatura', 200.0000, 'ºC'),
	(64191, 111, '2015-02-15 00:23:05.000000', 'temperatura', 133.0000, 'ºC'),
	(64192, 111, '2015-02-15 00:23:06.000000', 'temperatura', 65.0000, 'ºC'),
	(64193, 111, '2015-02-15 00:23:07.000000', 'temperatura', 1126.0000, 'ºC'),
	(64194, 111, '2015-02-15 00:23:08.000000', 'temperatura', 638.0000, 'ºC'),
	(64195, 111, '2015-02-15 00:23:09.000000', 'temperatura', 1010.0000, 'ºC'),
	(64196, 111, '2015-02-15 00:23:10.000000', 'temperatura', 738.0000, 'ºC'),
	(64197, 111, '2015-02-15 00:23:11.000000', 'temperatura', 662.0000, 'ºC'),
	(64198, 111, '2015-02-15 00:23:12.000000', 'temperatura', 1096.0000, 'ºC'),
	(64199, 111, '2015-02-15 00:23:13.000000', 'temperatura', 1094.0000, 'ºC'),
	(64200, 111, '2015-02-15 00:23:14.000000', 'temperatura', 984.0000, 'ºC'),
	(64201, 111, '2015-02-15 00:23:15.000000', 'temperatura', 438.0000, 'ºC'),
	(64202, 111, '2015-02-15 00:23:16.000000', 'temperatura', 439.0000, 'ºC'),
	(64203, 111, '2015-02-15 00:23:17.000000', 'temperatura', 879.0000, 'ºC'),
	(64204, 111, '2015-02-15 00:23:18.000000', 'temperatura', 680.0000, 'ºC'),
	(64205, 111, '2015-02-15 00:23:19.000000', 'temperatura', 762.0000, 'ºC'),
	(64206, 111, '2015-02-15 00:23:20.000000', 'temperatura', 572.0000, 'ºC'),
	(64207, 111, '2015-02-15 00:23:21.000000', 'temperatura', 572.0000, 'ºC'),
	(64208, 111, '2015-02-15 00:23:22.000000', 'temperatura', 1146.0000, 'ºC'),
	(64209, 111, '2015-02-15 00:23:23.000000', 'temperatura', 416.0000, 'ºC'),
	(64210, 111, '2015-02-15 00:23:24.000000', 'temperatura', 1043.0000, 'ºC'),
	(64211, 111, '2015-02-15 00:23:25.000000', 'temperatura', 366.0000, 'ºC'),
	(64212, 111, '2015-02-15 00:23:26.000000', 'temperatura', 1102.0000, 'ºC'),
	(64213, 111, '2015-02-15 00:23:27.000000', 'temperatura', 811.0000, 'ºC'),
	(64214, 111, '2015-02-15 00:23:28.000000', 'temperatura', 751.0000, 'ºC'),
	(64215, 111, '2015-02-15 00:23:29.000000', 'temperatura', 122.0000, 'ºC'),
	(64216, 111, '2015-02-15 00:23:30.000000', 'temperatura', 758.0000, 'ºC'),
	(64217, 111, '2015-02-15 00:23:31.000000', 'temperatura', 1026.0000, 'ºC'),
	(64218, 111, '2015-02-15 00:23:32.000000', 'temperatura', 453.0000, 'ºC'),
	(64219, 111, '2015-02-15 00:23:33.000000', 'temperatura', 391.0000, 'ºC'),
	(64220, 111, '2015-02-15 00:23:34.000000', 'temperatura', 595.0000, 'ºC'),
	(64221, 111, '2015-02-15 00:23:35.000000', 'temperatura', 604.0000, 'ºC'),
	(64222, 111, '2015-02-15 00:23:36.000000', 'temperatura', 35.0000, 'ºC'),
	(64223, 111, '2015-02-15 00:23:37.000000', 'temperatura', 765.0000, 'ºC'),
	(64224, 111, '2015-02-15 00:23:38.000000', 'temperatura', 120.0000, 'ºC'),
	(64225, 111, '2015-02-15 00:23:39.000000', 'temperatura', 705.0000, 'ºC'),
	(64226, 111, '2015-02-15 00:23:40.000000', 'temperatura', 767.0000, 'ºC'),
	(64227, 111, '2015-02-15 00:23:41.000000', 'temperatura', 518.0000, 'ºC'),
	(64228, 111, '2015-02-15 00:23:42.000000', 'temperatura', 292.0000, 'ºC'),
	(64229, 111, '2015-02-15 00:23:43.000000', 'temperatura', 1106.0000, 'ºC'),
	(64230, 111, '2015-02-15 00:23:44.000000', 'temperatura', 1056.0000, 'ºC'),
	(64231, 111, '2015-02-15 00:23:45.000000', 'temperatura', 760.0000, 'ºC'),
	(64232, 111, '2015-02-15 00:23:46.000000', 'temperatura', 632.0000, 'ºC'),
	(64233, 111, '2015-02-15 00:23:47.000000', 'temperatura', 881.0000, 'ºC'),
	(64234, 111, '2015-02-15 00:23:48.000000', 'temperatura', 111.0000, 'ºC'),
	(64235, 111, '2015-02-15 00:23:49.000000', 'temperatura', 313.0000, 'ºC'),
	(64236, 111, '2015-02-15 00:23:50.000000', 'temperatura', 30.0000, 'ºC'),
	(64237, 111, '2015-02-15 00:23:51.000000', 'temperatura', 412.0000, 'ºC'),
	(64238, 111, '2015-02-15 00:23:52.000000', 'temperatura', 773.0000, 'ºC'),
	(64239, 111, '2015-02-15 00:23:53.000000', 'temperatura', 228.0000, 'ºC'),
	(64240, 111, '2015-02-15 00:23:54.000000', 'temperatura', 20.0000, 'ºC'),
	(64241, 111, '2015-02-15 00:23:55.000000', 'temperatura', 618.0000, 'ºC'),
	(64242, 111, '2015-02-15 00:23:56.000000', 'temperatura', 629.0000, 'ºC'),
	(64243, 111, '2015-02-15 00:23:57.000000', 'temperatura', 94.0000, 'ºC'),
	(64244, 111, '2015-02-15 00:23:58.000000', 'temperatura', 982.0000, 'ºC'),
	(64245, 111, '2015-02-15 00:23:59.000000', 'temperatura', 1028.0000, 'ºC'),
	(64246, 111, '2015-02-15 00:24:00.000000', 'temperatura', 995.0000, 'ºC'),
	(64247, 111, '2015-02-15 00:24:01.000000', 'temperatura', 693.0000, 'ºC'),
	(64248, 111, '2015-02-15 00:24:02.000000', 'temperatura', 479.0000, 'ºC'),
	(64249, 111, '2015-02-15 00:24:03.000000', 'temperatura', 319.0000, 'ºC'),
	(64250, 111, '2015-02-15 00:24:04.000000', 'temperatura', 157.0000, 'ºC'),
	(64251, 111, '2015-02-15 00:24:05.000000', 'temperatura', 1027.0000, 'ºC'),
	(64252, 111, '2015-02-15 00:24:06.000000', 'temperatura', 1064.0000, 'ºC'),
	(64253, 111, '2015-02-15 00:24:07.000000', 'temperatura', 1041.0000, 'ºC'),
	(64254, 111, '2015-02-15 00:24:08.000000', 'temperatura', 814.0000, 'ºC'),
	(64255, 111, '2015-02-15 00:24:09.000000', 'temperatura', 947.0000, 'ºC'),
	(64256, 111, '2015-02-15 00:24:10.000000', 'temperatura', 1094.0000, 'ºC'),
	(64257, 111, '2015-02-15 00:24:11.000000', 'temperatura', 230.0000, 'ºC'),
	(64258, 111, '2015-02-15 00:24:12.000000', 'temperatura', 268.0000, 'ºC'),
	(64259, 111, '2015-02-15 00:24:13.000000', 'temperatura', 650.0000, 'ºC'),
	(64260, 111, '2015-02-15 00:24:14.000000', 'temperatura', 49.0000, 'ºC'),
	(64261, 111, '2015-02-15 00:24:15.000000', 'temperatura', 693.0000, 'ºC'),
	(64262, 111, '2015-02-15 00:24:16.000000', 'temperatura', 921.0000, 'ºC'),
	(64263, 111, '2015-02-15 00:24:17.000000', 'temperatura', 125.0000, 'ºC'),
	(64264, 111, '2015-02-15 00:24:18.000000', 'temperatura', 261.0000, 'ºC'),
	(64265, 111, '2015-02-15 00:24:19.000000', 'temperatura', 932.0000, 'ºC'),
	(64266, 111, '2015-02-15 00:24:20.000000', 'temperatura', 277.0000, 'ºC'),
	(64267, 111, '2015-02-15 00:24:21.000000', 'temperatura', 992.0000, 'ºC'),
	(64268, 111, '2015-02-15 00:24:22.000000', 'temperatura', 527.0000, 'ºC'),
	(64269, 111, '2015-02-15 00:24:23.000000', 'temperatura', 860.0000, 'ºC'),
	(64270, 111, '2015-02-15 00:24:24.000000', 'temperatura', 318.0000, 'ºC'),
	(64271, 111, '2015-02-15 00:24:25.000000', 'temperatura', 211.0000, 'ºC'),
	(64272, 111, '2015-02-15 00:24:26.000000', 'temperatura', 102.0000, 'ºC'),
	(64273, 111, '2015-02-15 00:24:27.000000', 'temperatura', 1079.0000, 'ºC'),
	(64274, 111, '2015-02-15 00:24:28.000000', 'temperatura', 290.0000, 'ºC'),
	(64275, 111, '2015-02-15 00:24:29.000000', 'temperatura', 612.0000, 'ºC'),
	(64276, 111, '2015-02-15 00:24:30.000000', 'temperatura', 992.0000, 'ºC'),
	(64277, 111, '2015-02-15 00:24:31.000000', 'temperatura', 724.0000, 'ºC'),
	(64278, 111, '2015-02-15 00:24:32.000000', 'temperatura', 642.0000, 'ºC'),
	(64279, 111, '2015-02-15 00:24:33.000000', 'temperatura', 1042.0000, 'ºC'),
	(64280, 111, '2015-02-15 00:24:34.000000', 'temperatura', 884.0000, 'ºC'),
	(64281, 111, '2015-02-15 00:24:35.000000', 'temperatura', 92.0000, 'ºC'),
	(64282, 111, '2015-02-15 00:24:36.000000', 'temperatura', 210.0000, 'ºC'),
	(64283, 111, '2015-02-15 00:24:37.000000', 'temperatura', 772.0000, 'ºC'),
	(64284, 111, '2015-02-15 00:24:38.000000', 'temperatura', 833.0000, 'ºC'),
	(64285, 111, '2015-02-15 00:24:39.000000', 'temperatura', 650.0000, 'ºC'),
	(64286, 111, '2015-02-15 00:24:40.000000', 'temperatura', 750.0000, 'ºC'),
	(64287, 111, '2015-02-15 00:24:41.000000', 'temperatura', 601.0000, 'ºC'),
	(64288, 111, '2015-02-15 00:24:42.000000', 'temperatura', 756.0000, 'ºC'),
	(64289, 111, '2015-02-15 00:24:43.000000', 'temperatura', 778.0000, 'ºC'),
	(64290, 111, '2015-02-15 00:24:44.000000', 'temperatura', 422.0000, 'ºC'),
	(64291, 111, '2015-02-15 00:24:45.000000', 'temperatura', 978.0000, 'ºC'),
	(64292, 111, '2015-02-15 00:24:46.000000', 'temperatura', 22.0000, 'ºC'),
	(64293, 111, '2015-02-15 00:24:47.000000', 'temperatura', 778.0000, 'ºC'),
	(64294, 111, '2015-02-15 00:24:48.000000', 'temperatura', 226.0000, 'ºC'),
	(64295, 111, '2015-02-15 00:24:49.000000', 'temperatura', 1195.0000, 'ºC'),
	(64296, 111, '2015-02-15 00:24:50.000000', 'temperatura', 498.0000, 'ºC'),
	(64297, 111, '2015-02-15 00:24:51.000000', 'temperatura', 104.0000, 'ºC'),
	(64298, 111, '2015-02-15 00:24:52.000000', 'temperatura', 227.0000, 'ºC'),
	(64299, 111, '2015-02-15 00:24:53.000000', 'temperatura', 824.0000, 'ºC'),
	(64300, 111, '2015-02-15 00:24:54.000000', 'temperatura', 1039.0000, 'ºC'),
	(64301, 111, '2015-02-15 00:24:55.000000', 'temperatura', 322.0000, 'ºC'),
	(64302, 111, '2015-02-15 00:24:56.000000', 'temperatura', 897.0000, 'ºC'),
	(64303, 111, '2015-02-15 00:24:57.000000', 'temperatura', 1116.0000, 'ºC'),
	(64304, 111, '2015-02-15 00:24:58.000000', 'temperatura', 491.0000, 'ºC'),
	(64305, 111, '2015-02-15 00:24:59.000000', 'temperatura', 307.0000, 'ºC'),
	(64306, 111, '2015-02-15 00:25:00.000000', 'temperatura', 64.0000, 'ºC'),
	(64307, 111, '2015-02-15 00:25:01.000000', 'temperatura', 597.0000, 'ºC'),
	(64308, 111, '2015-02-15 00:25:02.000000', 'temperatura', 393.0000, 'ºC'),
	(64309, 111, '2015-02-15 00:25:03.000000', 'temperatura', 177.0000, 'ºC'),
	(64310, 111, '2015-02-15 00:25:04.000000', 'temperatura', 905.0000, 'ºC'),
	(64311, 111, '2015-02-15 00:25:05.000000', 'temperatura', 395.0000, 'ºC'),
	(64312, 111, '2015-02-15 00:25:06.000000', 'temperatura', 461.0000, 'ºC'),
	(64313, 111, '2015-02-15 00:25:07.000000', 'temperatura', 1118.0000, 'ºC'),
	(64314, 111, '2015-02-15 00:25:08.000000', 'temperatura', 611.0000, 'ºC'),
	(64315, 111, '2015-02-15 00:25:09.000000', 'temperatura', 900.0000, 'ºC'),
	(64316, 111, '2015-02-15 00:25:10.000000', 'temperatura', 266.0000, 'ºC'),
	(64317, 111, '2015-02-15 00:25:11.000000', 'temperatura', 1033.0000, 'ºC'),
	(64318, 111, '2015-02-15 00:25:12.000000', 'temperatura', 768.0000, 'ºC'),
	(64319, 111, '2015-02-15 00:25:13.000000', 'temperatura', 740.0000, 'ºC'),
	(64320, 111, '2015-02-15 00:25:14.000000', 'temperatura', 197.0000, 'ºC'),
	(64321, 111, '2015-02-15 00:25:15.000000', 'temperatura', 1163.0000, 'ºC'),
	(64322, 111, '2015-02-15 00:25:16.000000', 'temperatura', 428.0000, 'ºC'),
	(64323, 111, '2015-02-15 00:25:17.000000', 'temperatura', 1049.0000, 'ºC'),
	(64324, 111, '2015-02-15 00:25:18.000000', 'temperatura', 362.0000, 'ºC'),
	(64325, 111, '2015-02-15 00:25:19.000000', 'temperatura', 1065.0000, 'ºC'),
	(64326, 111, '2015-02-15 00:25:20.000000', 'temperatura', 637.0000, 'ºC'),
	(64327, 111, '2015-02-15 00:25:21.000000', 'temperatura', 1190.0000, 'ºC'),
	(64328, 111, '2015-02-15 00:25:22.000000', 'temperatura', 439.0000, 'ºC'),
	(64329, 111, '2015-02-15 00:25:23.000000', 'temperatura', 1027.0000, 'ºC'),
	(64330, 111, '2015-02-15 00:25:24.000000', 'temperatura', 216.0000, 'ºC'),
	(64331, 111, '2015-02-15 00:25:25.000000', 'temperatura', 402.0000, 'ºC'),
	(64332, 111, '2015-02-15 00:25:26.000000', 'temperatura', 162.0000, 'ºC'),
	(64333, 111, '2015-02-15 00:25:27.000000', 'temperatura', 803.0000, 'ºC'),
	(64334, 111, '2015-02-15 00:25:28.000000', 'temperatura', 1132.0000, 'ºC'),
	(64335, 111, '2015-02-15 00:25:29.000000', 'temperatura', 850.0000, 'ºC'),
	(64336, 111, '2015-02-15 00:25:30.000000', 'temperatura', 855.0000, 'ºC'),
	(64337, 111, '2015-02-15 00:25:31.000000', 'temperatura', 527.0000, 'ºC'),
	(64338, 111, '2015-02-15 00:25:32.000000', 'temperatura', 68.0000, 'ºC'),
	(64339, 111, '2015-02-15 00:25:33.000000', 'temperatura', 1162.0000, 'ºC'),
	(64340, 111, '2015-02-15 00:25:34.000000', 'temperatura', 804.0000, 'ºC'),
	(64341, 111, '2015-02-15 00:25:35.000000', 'temperatura', 537.0000, 'ºC'),
	(64342, 111, '2015-02-15 00:25:36.000000', 'temperatura', 272.0000, 'ºC'),
	(64343, 111, '2015-02-15 00:25:37.000000', 'temperatura', 951.0000, 'ºC'),
	(64344, 111, '2015-02-15 00:25:38.000000', 'temperatura', 337.0000, 'ºC'),
	(64345, 111, '2015-02-15 00:25:39.000000', 'temperatura', 34.0000, 'ºC'),
	(64346, 111, '2015-02-15 00:25:40.000000', 'temperatura', 360.0000, 'ºC'),
	(64347, 111, '2015-02-15 00:25:41.000000', 'temperatura', 498.0000, 'ºC'),
	(64348, 111, '2015-02-15 00:25:42.000000', 'temperatura', 211.0000, 'ºC'),
	(64349, 111, '2015-02-15 00:25:43.000000', 'temperatura', 759.0000, 'ºC'),
	(64350, 111, '2015-02-15 00:25:44.000000', 'temperatura', 766.0000, 'ºC'),
	(64351, 111, '2015-02-15 00:25:45.000000', 'temperatura', 352.0000, 'ºC'),
	(64352, 111, '2015-02-15 00:25:46.000000', 'temperatura', 662.0000, 'ºC'),
	(64353, 111, '2015-02-15 00:25:47.000000', 'temperatura', 1055.0000, 'ºC'),
	(64354, 111, '2015-02-15 00:25:48.000000', 'temperatura', 891.0000, 'ºC'),
	(64355, 111, '2015-02-15 00:25:49.000000', 'temperatura', 88.0000, 'ºC'),
	(64356, 111, '2015-02-15 00:25:50.000000', 'temperatura', 168.0000, 'ºC'),
	(64357, 111, '2015-02-15 00:25:51.000000', 'temperatura', 579.0000, 'ºC'),
	(64358, 111, '2015-02-15 00:25:52.000000', 'temperatura', 1189.0000, 'ºC'),
	(64359, 111, '2015-02-15 00:25:53.000000', 'temperatura', 607.0000, 'ºC'),
	(64360, 111, '2015-02-15 00:25:54.000000', 'temperatura', 671.0000, 'ºC'),
	(64361, 111, '2015-02-15 00:25:55.000000', 'temperatura', 333.0000, 'ºC'),
	(64362, 111, '2015-02-15 00:25:56.000000', 'temperatura', 851.0000, 'ºC'),
	(64363, 111, '2015-02-15 00:25:57.000000', 'temperatura', 860.0000, 'ºC'),
	(64364, 111, '2015-02-15 00:25:58.000000', 'temperatura', 545.0000, 'ºC'),
	(64365, 111, '2015-02-15 00:25:59.000000', 'temperatura', 148.0000, 'ºC'),
	(64366, 111, '2015-02-15 00:26:00.000000', 'temperatura', 306.0000, 'ºC'),
	(64367, 111, '2015-02-15 00:26:01.000000', 'temperatura', 1083.0000, 'ºC'),
	(64368, 111, '2015-02-15 00:26:02.000000', 'temperatura', 900.0000, 'ºC'),
	(64369, 111, '2015-02-15 00:26:03.000000', 'temperatura', 52.0000, 'ºC'),
	(64370, 111, '2015-02-15 00:26:04.000000', 'temperatura', 1159.0000, 'ºC'),
	(64371, 111, '2015-02-15 00:26:05.000000', 'temperatura', 842.0000, 'ºC'),
	(64372, 111, '2015-02-15 00:26:06.000000', 'temperatura', 731.0000, 'ºC'),
	(64373, 111, '2015-02-15 00:26:07.000000', 'temperatura', 1131.0000, 'ºC'),
	(64374, 111, '2015-02-15 00:26:08.000000', 'temperatura', 1063.0000, 'ºC'),
	(64375, 111, '2015-02-15 00:26:09.000000', 'temperatura', 722.0000, 'ºC'),
	(64376, 111, '2015-02-15 00:26:10.000000', 'temperatura', 422.0000, 'ºC'),
	(64377, 111, '2015-02-15 00:26:11.000000', 'temperatura', 1144.0000, 'ºC'),
	(64378, 111, '2015-02-15 00:26:12.000000', 'temperatura', 855.0000, 'ºC'),
	(64379, 111, '2015-02-15 00:26:13.000000', 'temperatura', 841.0000, 'ºC'),
	(64380, 111, '2015-02-15 00:26:14.000000', 'temperatura', 443.0000, 'ºC'),
	(64381, 111, '2015-02-15 00:26:15.000000', 'temperatura', 893.0000, 'ºC'),
	(64382, 111, '2015-02-15 00:26:16.000000', 'temperatura', 736.0000, 'ºC'),
	(64383, 111, '2015-02-15 00:26:17.000000', 'temperatura', 1002.0000, 'ºC'),
	(64384, 111, '2015-02-15 00:26:18.000000', 'temperatura', 401.0000, 'ºC'),
	(64385, 111, '2015-02-15 00:26:19.000000', 'temperatura', 200.0000, 'ºC'),
	(64386, 111, '2015-02-15 00:26:20.000000', 'temperatura', 998.0000, 'ºC'),
	(64387, 111, '2015-02-15 00:26:21.000000', 'temperatura', 790.0000, 'ºC'),
	(64388, 111, '2015-02-15 00:26:22.000000', 'temperatura', 958.0000, 'ºC'),
	(64389, 111, '2015-02-15 00:26:23.000000', 'temperatura', 18.0000, 'ºC'),
	(64390, 111, '2015-02-15 00:26:24.000000', 'temperatura', 817.0000, 'ºC'),
	(64391, 111, '2015-02-15 00:26:25.000000', 'temperatura', 434.0000, 'ºC'),
	(64392, 111, '2015-02-15 00:26:26.000000', 'temperatura', 917.0000, 'ºC'),
	(64393, 111, '2015-02-15 00:26:27.000000', 'temperatura', 882.0000, 'ºC'),
	(64394, 111, '2015-02-15 00:26:28.000000', 'temperatura', 462.0000, 'ºC'),
	(64395, 111, '2015-02-15 00:26:29.000000', 'temperatura', 863.0000, 'ºC'),
	(64396, 111, '2015-02-15 00:26:30.000000', 'temperatura', 531.0000, 'ºC'),
	(64397, 111, '2015-02-15 00:26:31.000000', 'temperatura', 65.0000, 'ºC'),
	(64398, 111, '2015-02-15 00:26:32.000000', 'temperatura', 1133.0000, 'ºC'),
	(64399, 111, '2015-02-15 00:26:33.000000', 'temperatura', 673.0000, 'ºC'),
	(64400, 111, '2015-02-15 00:26:34.000000', 'temperatura', 1163.0000, 'ºC'),
	(64401, 111, '2015-02-15 00:26:35.000000', 'temperatura', 199.0000, 'ºC'),
	(64402, 111, '2015-02-15 00:26:36.000000', 'temperatura', 1105.0000, 'ºC'),
	(64403, 111, '2015-02-15 00:26:37.000000', 'temperatura', 127.0000, 'ºC'),
	(64404, 111, '2015-02-15 00:26:38.000000', 'temperatura', 921.0000, 'ºC'),
	(64405, 111, '2015-02-15 00:26:39.000000', 'temperatura', 625.0000, 'ºC'),
	(64406, 111, '2015-02-15 00:26:40.000000', 'temperatura', 363.0000, 'ºC'),
	(64407, 111, '2015-02-15 00:26:41.000000', 'temperatura', 1140.0000, 'ºC'),
	(64408, 111, '2015-02-15 00:26:42.000000', 'temperatura', 1012.0000, 'ºC'),
	(64409, 111, '2015-02-15 00:26:43.000000', 'temperatura', 439.0000, 'ºC'),
	(64410, 111, '2015-02-15 00:26:44.000000', 'temperatura', 359.0000, 'ºC'),
	(64411, 111, '2015-02-15 00:26:45.000000', 'temperatura', 478.0000, 'ºC'),
	(64412, 111, '2015-02-15 00:26:46.000000', 'temperatura', 115.0000, 'ºC'),
	(64413, 111, '2015-02-15 00:26:47.000000', 'temperatura', 339.0000, 'ºC'),
	(64414, 111, '2015-02-15 00:26:48.000000', 'temperatura', 154.0000, 'ºC'),
	(64415, 111, '2015-02-15 00:26:49.000000', 'temperatura', 951.0000, 'ºC'),
	(64416, 111, '2015-02-15 00:26:50.000000', 'temperatura', 696.0000, 'ºC'),
	(64417, 111, '2015-02-15 00:26:51.000000', 'temperatura', 625.0000, 'ºC'),
	(64418, 111, '2015-02-15 00:26:52.000000', 'temperatura', 1039.0000, 'ºC'),
	(64419, 111, '2015-02-15 00:26:53.000000', 'temperatura', 921.0000, 'ºC'),
	(64420, 111, '2015-02-15 00:26:54.000000', 'temperatura', 287.0000, 'ºC'),
	(64421, 111, '2015-02-15 00:26:55.000000', 'temperatura', 1074.0000, 'ºC'),
	(64422, 111, '2015-02-15 00:26:56.000000', 'temperatura', 910.0000, 'ºC'),
	(64423, 111, '2015-02-15 00:26:57.000000', 'temperatura', 126.0000, 'ºC'),
	(64424, 111, '2015-02-15 00:26:58.000000', 'temperatura', 302.0000, 'ºC'),
	(64425, 111, '2015-02-15 00:26:59.000000', 'temperatura', 1134.0000, 'ºC'),
	(64426, 111, '2015-02-15 00:27:00.000000', 'temperatura', 1165.0000, 'ºC'),
	(64427, 111, '2015-02-15 00:27:01.000000', 'temperatura', 22.0000, 'ºC'),
	(64428, 111, '2015-02-15 00:27:02.000000', 'temperatura', 215.0000, 'ºC'),
	(64429, 111, '2015-02-15 00:27:03.000000', 'temperatura', 1009.0000, 'ºC'),
	(64430, 111, '2015-02-15 00:27:04.000000', 'temperatura', 802.0000, 'ºC'),
	(64431, 111, '2015-02-15 00:27:05.000000', 'temperatura', 984.0000, 'ºC'),
	(64432, 111, '2015-02-15 00:27:06.000000', 'temperatura', 115.0000, 'ºC'),
	(64433, 111, '2015-02-15 00:27:07.000000', 'temperatura', 23.0000, 'ºC'),
	(64434, 111, '2015-02-15 00:27:08.000000', 'temperatura', 972.0000, 'ºC'),
	(64435, 111, '2015-02-15 00:27:09.000000', 'temperatura', 1189.0000, 'ºC'),
	(64436, 111, '2015-02-15 00:27:10.000000', 'temperatura', 630.0000, 'ºC'),
	(64437, 111, '2015-02-15 00:27:11.000000', 'temperatura', 783.0000, 'ºC'),
	(64438, 111, '2015-02-15 00:27:12.000000', 'temperatura', 825.0000, 'ºC'),
	(64439, 111, '2015-02-15 00:27:13.000000', 'temperatura', 578.0000, 'ºC'),
	(64440, 111, '2015-02-15 00:27:14.000000', 'temperatura', 413.0000, 'ºC'),
	(64441, 111, '2015-02-15 00:27:15.000000', 'temperatura', 334.0000, 'ºC'),
	(64442, 111, '2015-02-15 00:27:16.000000', 'temperatura', 430.0000, 'ºC'),
	(64443, 111, '2015-02-15 00:27:17.000000', 'temperatura', 1150.0000, 'ºC'),
	(64444, 111, '2015-02-15 00:27:18.000000', 'temperatura', 859.0000, 'ºC'),
	(64445, 111, '2015-02-15 00:27:19.000000', 'temperatura', 844.0000, 'ºC'),
	(64446, 111, '2015-02-15 00:27:20.000000', 'temperatura', 446.0000, 'ºC'),
	(64447, 111, '2015-02-15 00:27:21.000000', 'temperatura', 900.0000, 'ºC'),
	(64448, 111, '2015-02-15 00:27:22.000000', 'temperatura', 760.0000, 'ºC'),
	(64449, 111, '2015-02-15 00:27:23.000000', 'temperatura', 1102.0000, 'ºC'),
	(64450, 111, '2015-02-15 00:27:24.000000', 'temperatura', 831.0000, 'ºC'),
	(64451, 111, '2015-02-15 00:27:25.000000', 'temperatura', 847.0000, 'ºC'),
	(64452, 111, '2015-02-15 00:27:26.000000', 'temperatura', 545.0000, 'ºC'),
	(64453, 111, '2015-02-15 00:27:27.000000', 'temperatura', 185.0000, 'ºC'),
	(64454, 111, '2015-02-15 00:27:28.000000', 'temperatura', 491.0000, 'ºC'),
	(64455, 111, '2015-02-15 00:27:29.000000', 'temperatura', 701.0000, 'ºC'),
	(64456, 111, '2015-02-15 00:27:30.000000', 'temperatura', 830.0000, 'ºC'),
	(64457, 111, '2015-02-15 00:27:31.000000', 'temperatura', 847.0000, 'ºC'),
	(64458, 111, '2015-02-15 00:27:32.000000', 'temperatura', 545.0000, 'ºC'),
	(64459, 111, '2015-02-15 00:27:33.000000', 'temperatura', 184.0000, 'ºC'),
	(64460, 111, '2015-02-15 00:27:34.000000', 'temperatura', 487.0000, 'ºC'),
	(64461, 111, '2015-02-15 00:27:35.000000', 'temperatura', 682.0000, 'ºC'),
	(64462, 111, '2015-02-15 00:27:36.000000', 'temperatura', 752.0000, 'ºC'),
	(64463, 111, '2015-02-15 00:27:37.000000', 'temperatura', 511.0000, 'ºC'),
	(64464, 111, '2015-02-15 00:27:38.000000', 'temperatura', 303.0000, 'ºC'),
	(64465, 111, '2015-02-15 00:27:39.000000', 'temperatura', 1179.0000, 'ºC'),
	(64466, 111, '2015-02-15 00:27:40.000000', 'temperatura', 190.0000, 'ºC'),
	(64467, 111, '2015-02-15 00:27:41.000000', 'temperatura', 1011.0000, 'ºC'),
	(64468, 111, '2015-02-15 00:27:42.000000', 'temperatura', 887.0000, 'ºC'),
	(64469, 111, '2015-02-15 00:27:43.000000', 'temperatura', 201.0000, 'ºC'),
	(64470, 111, '2015-02-15 00:27:44.000000', 'temperatura', 746.0000, 'ºC'),
	(64471, 111, '2015-02-15 00:27:45.000000', 'temperatura', 726.0000, 'ºC'),
	(64472, 111, '2015-02-15 00:27:46.000000', 'temperatura', 192.0000, 'ºC'),
	(64473, 111, '2015-02-15 00:27:47.000000', 'temperatura', 1184.0000, 'ºC'),
	(64474, 111, '2015-02-15 00:27:48.000000', 'temperatura', 546.0000, 'ºC'),
	(64475, 111, '2015-02-15 00:27:49.000000', 'temperatura', 375.0000, 'ºC'),
	(64476, 111, '2015-02-15 00:27:50.000000', 'temperatura', 239.0000, 'ºC'),
	(64477, 111, '2015-02-15 00:27:51.000000', 'temperatura', 71.0000, 'ºC'),
	(64478, 111, '2015-02-15 00:27:52.000000', 'temperatura', 839.0000, 'ºC'),
	(64479, 111, '2015-02-15 00:27:53.000000', 'temperatura', 384.0000, 'ºC'),
	(64480, 111, '2015-02-15 00:27:54.000000', 'temperatura', 602.0000, 'ºC'),
	(64481, 111, '2015-02-15 00:27:55.000000', 'temperatura', 658.0000, 'ºC'),
	(64482, 111, '2015-02-15 00:27:56.000000', 'temperatura', 286.0000, 'ºC'),
	(64483, 111, '2015-02-15 00:27:57.000000', 'temperatura', 656.0000, 'ºC'),
	(64484, 111, '2015-02-15 00:27:58.000000', 'temperatura', 24.0000, 'ºC'),
	(64485, 111, '2015-02-15 00:27:59.000000', 'temperatura', 552.0000, 'ºC'),
	(64486, 111, '2015-02-15 00:28:00.000000', 'temperatura', 287.0000, 'ºC'),
	(64487, 111, '2015-02-15 00:28:01.000000', 'temperatura', 978.0000, 'ºC'),
	(64488, 111, '2015-02-15 00:28:02.000000', 'temperatura', 431.0000, 'ºC'),
	(64489, 111, '2015-02-15 00:28:03.000000', 'temperatura', 423.0000, 'ºC'),
	(64490, 111, '2015-02-15 00:28:04.000000', 'temperatura', 823.0000, 'ºC'),
	(64491, 111, '2015-02-15 00:28:05.000000', 'temperatura', 447.0000, 'ºC'),
	(64492, 111, '2015-02-15 00:28:06.000000', 'temperatura', 966.0000, 'ºC'),
	(64493, 111, '2015-02-15 00:28:07.000000', 'temperatura', 1089.0000, 'ºC'),
	(64494, 111, '2015-02-15 00:28:08.000000', 'temperatura', 148.0000, 'ºC'),
	(64495, 111, '2015-02-15 00:28:09.000000', 'temperatura', 1072.0000, 'ºC'),
	(64496, 111, '2015-02-15 00:28:10.000000', 'temperatura', 119.0000, 'ºC'),
	(64497, 111, '2015-02-15 00:28:11.000000', 'temperatura', 977.0000, 'ºC'),
	(64498, 111, '2015-02-15 00:28:12.000000', 'temperatura', 927.0000, 'ºC'),
	(64499, 111, '2015-02-15 00:28:13.000000', 'temperatura', 508.0000, 'ºC'),
	(64500, 111, '2015-02-15 00:28:14.000000', 'temperatura', 958.0000, 'ºC'),
	(64501, 111, '2015-02-15 00:28:15.000000', 'temperatura', 866.0000, 'ºC'),
	(64502, 111, '2015-02-15 00:28:16.000000', 'temperatura', 259.0000, 'ºC'),
	(64503, 111, '2015-02-15 00:28:17.000000', 'temperatura', 1096.0000, 'ºC'),
	(64504, 111, '2015-02-15 00:28:18.000000', 'temperatura', 1102.0000, 'ºC'),
	(64505, 111, '2015-02-15 00:28:19.000000', 'temperatura', 1024.0000, 'ºC'),
	(64506, 111, '2015-02-15 00:28:20.000000', 'temperatura', 615.0000, 'ºC'),
	(64507, 111, '2015-02-15 00:28:21.000000', 'temperatura', 2.0000, 'ºC'),
	(64508, 111, '2015-02-15 00:28:22.000000', 'temperatura', 567.0000, 'ºC'),
	(64509, 111, '2015-02-15 00:28:23.000000', 'temperatura', 430.0000, 'ºC'),
	(64510, 111, '2015-02-15 00:28:24.000000', 'temperatura', 450.0000, 'ºC'),
	(64511, 111, '2015-02-15 00:28:25.000000', 'temperatura', 961.0000, 'ºC'),
	(64512, 111, '2015-02-15 00:28:26.000000', 'temperatura', 1053.0000, 'ºC'),
	(64513, 111, '2015-02-15 00:28:27.000000', 'temperatura', 1186.0000, 'ºC'),
	(64514, 111, '2015-02-15 00:28:28.000000', 'temperatura', 369.0000, 'ºC'),
	(64515, 111, '2015-02-15 00:28:29.000000', 'temperatura', 686.0000, 'ºC'),
	(64516, 111, '2015-02-15 00:28:30.000000', 'temperatura', 1125.0000, 'ºC'),
	(64517, 111, '2015-02-15 00:28:31.000000', 'temperatura', 1168.0000, 'ºC'),
	(64518, 111, '2015-02-15 00:28:32.000000', 'temperatura', 63.0000, 'ºC'),
	(64519, 111, '2015-02-15 00:28:33.000000', 'temperatura', 414.0000, 'ºC'),
	(64520, 111, '2015-02-15 00:28:34.000000', 'temperatura', 683.0000, 'ºC'),
	(64521, 111, '2015-02-15 00:28:35.000000', 'temperatura', 970.0000, 'ºC'),
	(64522, 111, '2015-02-15 00:28:36.000000', 'temperatura', 405.0000, 'ºC'),
	(64523, 111, '2015-02-15 00:28:37.000000', 'temperatura', 312.0000, 'ºC'),
	(64524, 111, '2015-02-15 00:28:38.000000', 'temperatura', 348.0000, 'ºC'),
	(64525, 111, '2015-02-15 00:28:39.000000', 'temperatura', 805.0000, 'ºC'),
	(64526, 111, '2015-02-15 00:28:40.000000', 'temperatura', 580.0000, 'ºC'),
	(64527, 111, '2015-02-15 00:28:41.000000', 'temperatura', 488.0000, 'ºC'),
	(64528, 111, '2015-02-15 00:28:42.000000', 'temperatura', 699.0000, 'ºC'),
	(64529, 111, '2015-02-15 00:28:43.000000', 'temperatura', 833.0000, 'ºC'),
	(64530, 111, '2015-02-15 00:28:44.000000', 'temperatura', 868.0000, 'ºC'),
	(64531, 111, '2015-02-15 00:28:45.000000', 'temperatura', 640.0000, 'ºC'),
	(64532, 111, '2015-02-15 00:28:46.000000', 'temperatura', 596.0000, 'ºC'),
	(64533, 111, '2015-02-15 00:28:47.000000', 'temperatura', 1062.0000, 'ºC'),
	(64534, 111, '2015-02-15 00:28:48.000000', 'temperatura', 1123.0000, 'ºC'),
	(64535, 111, '2015-02-15 00:28:49.000000', 'temperatura', 30.0000, 'ºC'),
	(64536, 111, '2015-02-15 00:28:50.000000', 'temperatura', 381.0000, 'ºC'),
	(64537, 111, '2015-02-15 00:28:51.000000', 'temperatura', 616.0000, 'ºC'),
	(64538, 111, '2015-02-15 00:28:52.000000', 'temperatura', 735.0000, 'ºC'),
	(64539, 111, '2015-02-15 00:28:53.000000', 'temperatura', 630.0000, 'ºC'),
	(64540, 111, '2015-02-15 00:28:54.000000', 'temperatura', 946.0000, 'ºC'),
	(64541, 111, '2015-02-15 00:28:55.000000', 'temperatura', 441.0000, 'ºC'),
	(64542, 111, '2015-02-15 00:28:56.000000', 'temperatura', 564.0000, 'ºC'),
	(64543, 111, '2015-02-15 00:28:57.000000', 'temperatura', 301.0000, 'ºC'),
	(64544, 111, '2015-02-15 00:28:58.000000', 'temperatura', 1012.0000, 'ºC'),
	(64545, 111, '2015-02-15 00:28:59.000000', 'temperatura', 558.0000, 'ºC'),
	(64546, 111, '2015-02-15 00:29:00.000000', 'temperatura', 953.0000, 'ºC'),
	(64547, 111, '2015-02-15 00:29:01.000000', 'temperatura', 694.0000, 'ºC'),
	(64548, 111, '2015-02-15 00:29:02.000000', 'temperatura', 611.0000, 'ºC'),
	(64549, 111, '2015-02-15 00:29:03.000000', 'temperatura', 975.0000, 'ºC'),
	(64550, 111, '2015-02-15 00:29:04.000000', 'temperatura', 640.0000, 'ºC'),
	(64551, 111, '2015-02-15 00:29:05.000000', 'temperatura', 277.0000, 'ºC'),
	(64552, 111, '2015-02-15 00:29:06.000000', 'temperatura', 663.0000, 'ºC'),
	(64553, 111, '2015-02-15 00:29:07.000000', 'temperatura', 88.0000, 'ºC'),
	(64554, 111, '2015-02-15 00:29:08.000000', 'temperatura', 848.0000, 'ºC'),
	(64555, 111, '2015-02-15 00:29:09.000000', 'temperatura', 378.0000, 'ºC'),
	(64556, 111, '2015-02-15 00:29:10.000000', 'temperatura', 547.0000, 'ºC'),
	(64557, 111, '2015-02-15 00:29:11.000000', 'temperatura', 401.0000, 'ºC'),
	(64558, 111, '2015-02-15 00:29:12.000000', 'temperatura', 366.0000, 'ºC'),
	(64559, 111, '2015-02-15 00:29:13.000000', 'temperatura', 629.0000, 'ºC'),
	(64560, 111, '2015-02-15 00:29:14.000000', 'temperatura', 844.0000, 'ºC'),
	(64561, 111, '2015-02-15 00:29:15.000000', 'temperatura', 1133.0000, 'ºC'),
	(64562, 111, '2015-02-15 00:29:16.000000', 'temperatura', 736.0000, 'ºC'),
	(64563, 111, '2015-02-15 00:29:17.000000', 'temperatura', 282.0000, 'ºC'),
	(64564, 111, '2015-02-15 00:29:18.000000', 'temperatura', 401.0000, 'ºC'),
	(64565, 111, '2015-02-15 00:29:19.000000', 'temperatura', 1160.0000, 'ºC'),
	(64566, 111, '2015-02-15 00:29:20.000000', 'temperatura', 998.0000, 'ºC'),
	(64567, 111, '2015-02-15 00:29:21.000000', 'temperatura', 311.0000, 'ºC'),
	(64568, 111, '2015-02-15 00:29:22.000000', 'temperatura', 961.0000, 'ºC'),
	(64569, 111, '2015-02-15 00:29:23.000000', 'temperatura', 270.0000, 'ºC'),
	(64570, 111, '2015-02-15 00:29:24.000000', 'temperatura', 870.0000, 'ºC'),
	(64571, 111, '2015-02-15 00:29:25.000000', 'temperatura', 1142.0000, 'ºC'),
	(64572, 111, '2015-02-15 00:29:26.000000', 'temperatura', 698.0000, 'ºC'),
	(64573, 111, '2015-02-15 00:29:27.000000', 'temperatura', 66.0000, 'ºC'),
	(64574, 111, '2015-02-15 00:29:28.000000', 'temperatura', 637.0000, 'ºC'),
	(64575, 111, '2015-02-15 00:29:29.000000', 'temperatura', 585.0000, 'ºC'),
	(64576, 111, '2015-02-15 00:29:30.000000', 'temperatura', 1015.0000, 'ºC'),
	(64577, 111, '2015-02-15 00:29:31.000000', 'temperatura', 922.0000, 'ºC'),
	(64578, 111, '2015-02-15 00:29:32.000000', 'temperatura', 366.0000, 'ºC'),
	(64579, 111, '2015-02-15 00:29:33.000000', 'temperatura', 263.0000, 'ºC'),
	(64580, 111, '2015-02-15 00:29:34.000000', 'temperatura', 220.0000, 'ºC'),
	(64581, 111, '2015-02-15 00:29:35.000000', 'temperatura', 309.0000, 'ºC'),
	(64582, 111, '2015-02-15 00:29:36.000000', 'temperatura', 885.0000, 'ºC'),
	(64583, 111, '2015-02-15 00:29:37.000000', 'temperatura', 1099.0000, 'ºC'),
	(64584, 111, '2015-02-15 00:29:38.000000', 'temperatura', 442.0000, 'ºC'),
	(64585, 111, '2015-02-15 00:29:39.000000', 'temperatura', 113.0000, 'ºC'),
	(64586, 111, '2015-02-15 00:29:40.000000', 'temperatura', 438.0000, 'ºC'),
	(64587, 111, '2015-02-15 00:29:41.000000', 'temperatura', 651.0000, 'ºC'),
	(64588, 111, '2015-02-15 00:29:42.000000', 'temperatura', 743.0000, 'ºC'),
	(64589, 111, '2015-02-15 00:29:43.000000', 'temperatura', 562.0000, 'ºC'),
	(64590, 111, '2015-02-15 00:29:44.000000', 'temperatura', 582.0000, 'ºC'),
	(64591, 111, '2015-02-15 00:29:45.000000', 'temperatura', 23.0000, 'ºC'),
	(64592, 111, '2015-02-15 00:29:46.000000', 'temperatura', 770.0000, 'ºC'),
	(64593, 111, '2015-02-15 00:29:47.000000', 'temperatura', 184.0000, 'ºC'),
	(64594, 111, '2015-02-15 00:29:48.000000', 'temperatura', 1007.0000, 'ºC'),
	(64595, 111, '2015-02-15 00:29:49.000000', 'temperatura', 885.0000, 'ºC'),
	(64596, 111, '2015-02-15 00:29:50.000000', 'temperatura', 206.0000, 'ºC'),
	(64597, 111, '2015-02-15 00:29:51.000000', 'temperatura', 775.0000, 'ºC'),
	(64598, 111, '2015-02-15 00:29:52.000000', 'temperatura', 855.0000, 'ºC'),
	(64599, 111, '2015-02-15 00:29:53.000000', 'temperatura', 753.0000, 'ºC'),
	(64600, 111, '2015-02-15 00:29:54.000000', 'temperatura', 0.0000, 'ºC'),
	(64601, 111, '2015-02-15 00:29:55.000000', 'temperatura', 141.0000, 'ºC'),
	(64602, 111, '2015-02-15 00:29:56.000000', 'temperatura', 704.0000, 'ºC'),
	(64603, 111, '2015-02-15 00:29:57.000000', 'temperatura', 698.0000, 'ºC'),
	(64604, 111, '2015-02-15 00:29:58.000000', 'temperatura', 178.0000, 'ºC'),
	(64605, 111, '2015-02-15 00:29:59.000000', 'temperatura', 1196.0000, 'ºC'),
	(64606, 111, '2015-02-15 00:30:00.000000', 'temperatura', 648.0000, 'ºC'),
	(64607, 111, '2015-02-15 00:30:01.000000', 'temperatura', 851.0000, 'ºC'),
	(64608, 111, '2015-02-15 00:30:02.000000', 'temperatura', 1110.0000, 'ºC'),
	(64609, 111, '2015-02-15 00:30:03.000000', 'temperatura', 600.0000, 'ºC'),
	(64610, 111, '2015-02-15 00:30:04.000000', 'temperatura', 871.0000, 'ºC'),
	(64611, 111, '2015-02-15 00:30:05.000000', 'temperatura', 156.0000, 'ºC'),
	(64612, 111, '2015-02-15 00:30:06.000000', 'temperatura', 568.0000, 'ºC'),
	(64613, 111, '2015-02-15 00:30:07.000000', 'temperatura', 1172.0000, 'ºC'),
	(64614, 111, '2015-02-15 00:30:08.000000', 'temperatura', 554.0000, 'ºC'),
	(64615, 111, '2015-02-15 00:30:09.000000', 'temperatura', 456.0000, 'ºC'),
	(64616, 111, '2015-02-15 00:30:10.000000', 'temperatura', 620.0000, 'ºC'),
	(64617, 111, '2015-02-15 00:30:11.000000', 'temperatura', 533.0000, 'ºC'),
	(64618, 111, '2015-02-15 00:30:12.000000', 'temperatura', 803.0000, 'ºC'),
	(64619, 111, '2015-02-15 00:30:13.000000', 'temperatura', 18.0000, 'ºC'),
	(64620, 111, '2015-02-15 00:30:14.000000', 'temperatura', 82.0000, 'ºC'),
	(64621, 111, '2015-02-15 00:30:15.000000', 'temperatura', 357.0000, 'ºC'),
	(64622, 111, '2015-02-15 00:30:16.000000', 'temperatura', 341.0000, 'ºC'),
	(64623, 111, '2015-02-15 00:30:17.000000', 'temperatura', 631.0000, 'ºC'),
	(64624, 111, '2015-02-15 00:30:18.000000', 'temperatura', 934.0000, 'ºC'),
	(64625, 111, '2015-02-15 00:30:19.000000', 'temperatura', 378.0000, 'ºC'),
	(64626, 111, '2015-02-15 00:30:20.000000', 'temperatura', 289.0000, 'ºC'),
	(64627, 111, '2015-02-15 00:30:21.000000', 'temperatura', 313.0000, 'ºC'),
	(64628, 111, '2015-02-15 00:30:22.000000', 'temperatura', 697.0000, 'ºC'),
	(64629, 111, '2015-02-15 00:30:23.000000', 'temperatura', 146.0000, 'ºC'),
	(64630, 111, '2015-02-15 00:30:24.000000', 'temperatura', 1041.0000, 'ºC'),
	(64631, 111, '2015-02-15 00:30:25.000000', 'temperatura', 1168.0000, 'ºC'),
	(64632, 111, '2015-02-15 00:30:26.000000', 'temperatura', 315.0000, 'ºC'),
	(64633, 111, '2015-02-15 00:30:27.000000', 'temperatura', 472.0000, 'ºC'),
	(64634, 111, '2015-02-15 00:30:28.000000', 'temperatura', 218.0000, 'ºC'),
	(64635, 111, '2015-02-15 00:30:29.000000', 'temperatura', 871.0000, 'ºC'),
	(64636, 111, '2015-02-15 00:30:30.000000', 'temperatura', 104.0000, 'ºC'),
	(64637, 111, '2015-02-15 00:30:31.000000', 'temperatura', 305.0000, 'ºC'),
	(64638, 111, '2015-02-15 00:30:32.000000', 'temperatura', 15.0000, 'ºC'),
	(64639, 111, '2015-02-15 00:30:33.000000', 'temperatura', 359.0000, 'ºC'),
	(64640, 111, '2015-02-15 00:30:34.000000', 'temperatura', 551.0000, 'ºC'),
	(64641, 111, '2015-02-15 00:30:35.000000', 'temperatura', 481.0000, 'ºC'),
	(64642, 111, '2015-02-15 00:30:36.000000', 'temperatura', 750.0000, 'ºC'),
	(64643, 111, '2015-02-15 00:30:37.000000', 'temperatura', 1106.0000, 'ºC'),
	(64644, 111, '2015-02-15 00:30:38.000000', 'temperatura', 882.0000, 'ºC'),
	(64645, 111, '2015-02-15 00:30:39.000000', 'temperatura', 1093.0000, 'ºC'),
	(64646, 111, '2015-02-15 00:30:40.000000', 'temperatura', 420.0000, 'ºC'),
	(64647, 111, '2015-02-15 00:30:41.000000', 'temperatura', 23.0000, 'ºC'),
	(64648, 111, '2015-02-15 00:30:42.000000', 'temperatura', 53.0000, 'ºC'),
	(64649, 111, '2015-02-15 00:30:43.000000', 'temperatura', 199.0000, 'ºC'),
	(64650, 111, '2015-02-15 00:30:44.000000', 'temperatura', 835.0000, 'ºC'),
	(64651, 111, '2015-02-15 00:30:45.000000', 'temperatura', 1181.0000, 'ºC'),
	(64652, 111, '2015-02-15 00:30:46.000000', 'temperatura', 997.0000, 'ºC'),
	(64653, 111, '2015-02-15 00:30:47.000000', 'temperatura', 246.0000, 'ºC'),
	(64654, 111, '2015-02-15 00:30:48.000000', 'temperatura', 637.0000, 'ºC'),
	(64655, 111, '2015-02-15 00:30:49.000000', 'temperatura', 48.0000, 'ºC'),
	(64656, 111, '2015-02-15 00:30:50.000000', 'temperatura', 731.0000, 'ºC'),
	(64657, 111, '2015-02-15 00:30:51.000000', 'temperatura', 1113.0000, 'ºC'),
	(64658, 111, '2015-02-15 00:30:52.000000', 'temperatura', 969.0000, 'ºC'),
	(64659, 111, '2015-02-15 00:30:53.000000', 'temperatura', 309.0000, 'ºC'),
	(64660, 111, '2015-02-15 00:30:54.000000', 'temperatura', 1039.0000, 'ºC'),
	(64661, 111, '2015-02-15 00:30:55.000000', 'temperatura', 668.0000, 'ºC'),
	(64662, 111, '2015-02-15 00:30:56.000000', 'temperatura', 223.0000, 'ºC'),
	(64663, 111, '2015-02-15 00:30:57.000000', 'temperatura', 310.0000, 'ºC'),
	(64664, 111, '2015-02-15 00:30:58.000000', 'temperatura', 881.0000, 'ºC'),
	(64665, 111, '2015-02-15 00:30:59.000000', 'temperatura', 1078.0000, 'ºC'),
	(64666, 111, '2015-02-15 00:31:00.000000', 'temperatura', 345.0000, 'ºC'),
	(64667, 111, '2015-02-15 00:31:01.000000', 'temperatura', 892.0000, 'ºC'),
	(64668, 111, '2015-02-15 00:31:02.000000', 'temperatura', 1028.0000, 'ºC'),
	(64669, 111, '2015-02-15 00:31:03.000000', 'temperatura', 62.0000, 'ºC'),
	(64670, 111, '2015-02-15 00:31:04.000000', 'temperatura', 827.0000, 'ºC'),
	(64671, 111, '2015-02-15 00:31:05.000000', 'temperatura', 348.0000, 'ºC'),
	(64672, 111, '2015-02-15 00:31:06.000000', 'temperatura', 459.0000, 'ºC'),
	(64673, 111, '2015-02-15 00:31:07.000000', 'temperatura', 51.0000, 'ºC'),
	(64674, 111, '2015-02-15 00:31:08.000000', 'temperatura', 81.0000, 'ºC'),
	(64675, 111, '2015-02-15 00:31:09.000000', 'temperatura', 252.0000, 'ºC'),
	(64676, 111, '2015-02-15 00:31:10.000000', 'temperatura', 1015.0000, 'ºC'),
	(64677, 111, '2015-02-15 00:31:11.000000', 'temperatura', 721.0000, 'ºC'),
	(64678, 111, '2015-02-15 00:31:12.000000', 'temperatura', 561.0000, 'ºC'),
	(64679, 111, '2015-02-15 00:31:13.000000', 'temperatura', 644.0000, 'ºC'),
	(64680, 111, '2015-02-15 00:31:14.000000', 'temperatura', 337.0000, 'ºC'),
	(64681, 111, '2015-02-15 00:31:15.000000', 'temperatura', 954.0000, 'ºC'),
	(64682, 111, '2015-02-15 00:31:16.000000', 'temperatura', 159.0000, 'ºC'),
	(64683, 111, '2015-02-15 00:31:17.000000', 'temperatura', 333.0000, 'ºC'),
	(64684, 111, '2015-02-15 00:31:18.000000', 'temperatura', 1188.0000, 'ºC'),
	(64685, 111, '2015-02-15 00:31:19.000000', 'temperatura', 140.0000, 'ºC'),
	(64686, 111, '2015-02-15 00:31:20.000000', 'temperatura', 739.0000, 'ºC'),
	(64687, 111, '2015-02-15 00:31:21.000000', 'temperatura', 875.0000, 'ºC'),
	(64688, 111, '2015-02-15 00:31:22.000000', 'temperatura', 960.0000, 'ºC'),
	(64689, 111, '2015-02-15 00:31:23.000000', 'temperatura', 976.0000, 'ºC'),
	(64690, 111, '2015-02-15 00:31:24.000000', 'temperatura', 799.0000, 'ºC'),
	(64691, 111, '2015-02-15 00:31:25.000000', 'temperatura', 1069.0000, 'ºC'),
	(64692, 111, '2015-02-15 00:31:26.000000', 'temperatura', 550.0000, 'ºC'),
	(64693, 111, '2015-02-15 00:31:27.000000', 'temperatura', 740.0000, 'ºC'),
	(64694, 111, '2015-02-15 00:31:28.000000', 'temperatura', 854.0000, 'ºC'),
	(64695, 111, '2015-02-15 00:31:29.000000', 'temperatura', 847.0000, 'ºC'),
	(64696, 111, '2015-02-15 00:31:30.000000', 'temperatura', 475.0000, 'ºC'),
	(64697, 111, '2015-02-15 00:31:31.000000', 'temperatura', 1033.0000, 'ºC'),
	(64698, 111, '2015-02-15 00:31:32.000000', 'temperatura', 142.0000, 'ºC'),
	(64699, 111, '2015-02-15 00:31:33.000000', 'temperatura', 10.0000, 'ºC'),
	(64700, 111, '2015-02-15 00:31:34.000000', 'temperatura', 827.0000, 'ºC'),
	(64701, 111, '2015-02-15 00:31:35.000000', 'temperatura', 505.0000, 'ºC'),
	(64702, 111, '2015-02-15 00:31:36.000000', 'temperatura', 43.0000, 'ºC'),
	(64703, 111, '2015-02-15 00:31:37.000000', 'temperatura', 1099.0000, 'ºC'),
	(64704, 111, '2015-02-15 00:31:38.000000', 'temperatura', 570.0000, 'ºC'),
	(64705, 111, '2015-02-15 00:31:39.000000', 'temperatura', 752.0000, 'ºC'),
	(64706, 111, '2015-02-15 00:31:40.000000', 'temperatura', 853.0000, 'ºC'),
	(64707, 111, '2015-02-15 00:31:41.000000', 'temperatura', 806.0000, 'ºC'),
	(64708, 111, '2015-02-15 00:31:42.000000', 'temperatura', 274.0000, 'ºC'),
	(64709, 111, '2015-02-15 00:31:43.000000', 'temperatura', 151.0000, 'ºC'),
	(64710, 111, '2015-02-15 00:31:44.000000', 'temperatura', 1132.0000, 'ºC'),
	(64711, 111, '2015-02-15 00:31:45.000000', 'temperatura', 409.0000, 'ºC'),
	(64712, 111, '2015-02-15 00:31:46.000000', 'temperatura', 1051.0000, 'ºC'),
	(64713, 111, '2015-02-15 00:31:47.000000', 'temperatura', 426.0000, 'ºC'),
	(64714, 111, '2015-02-15 00:31:48.000000', 'temperatura', 180.0000, 'ºC'),
	(64715, 111, '2015-02-15 00:31:49.000000', 'temperatura', 822.0000, 'ºC'),
	(64716, 111, '2015-02-15 00:31:50.000000', 'temperatura', 1169.0000, 'ºC'),
	(64717, 111, '2015-02-15 00:31:51.000000', 'temperatura', 981.0000, 'ºC'),
	(64718, 111, '2015-02-15 00:31:52.000000', 'temperatura', 197.0000, 'ºC'),
	(64719, 111, '2015-02-15 00:31:53.000000', 'temperatura', 444.0000, 'ºC'),
	(64720, 111, '2015-02-15 00:31:54.000000', 'temperatura', 430.0000, 'ºC'),
	(64721, 111, '2015-02-15 00:31:55.000000', 'temperatura', 820.0000, 'ºC'),
	(64722, 111, '2015-02-15 00:31:56.000000', 'temperatura', 408.0000, 'ºC'),
	(64723, 111, '2015-02-15 00:31:57.000000', 'temperatura', 781.0000, 'ºC'),
	(64724, 111, '2015-02-15 00:31:58.000000', 'temperatura', 282.0000, 'ºC'),
	(64725, 111, '2015-02-15 00:31:59.000000', 'temperatura', 266.0000, 'ºC'),
	(64726, 111, '2015-02-15 00:32:00.000000', 'temperatura', 484.0000, 'ºC'),
	(64727, 111, '2015-02-15 00:32:01.000000', 'temperatura', 424.0000, 'ºC'),
	(64728, 111, '2015-02-15 00:32:02.000000', 'temperatura', 668.0000, 'ºC'),
	(64729, 111, '2015-02-15 00:32:03.000000', 'temperatura', 867.0000, 'ºC'),
	(64730, 111, '2015-02-15 00:32:04.000000', 'temperatura', 1135.0000, 'ºC'),
	(64731, 111, '2015-02-15 00:32:05.000000', 'temperatura', 671.0000, 'ºC'),
	(64732, 111, '2015-02-15 00:32:06.000000', 'temperatura', 1152.0000, 'ºC'),
	(64733, 111, '2015-02-15 00:32:07.000000', 'temperatura', 148.0000, 'ºC'),
	(64734, 111, '2015-02-15 00:32:08.000000', 'temperatura', 885.0000, 'ºC'),
	(64735, 111, '2015-02-15 00:32:09.000000', 'temperatura', 379.0000, 'ºC'),
	(64736, 111, '2015-02-15 00:32:10.000000', 'temperatura', 440.0000, 'ºC'),
	(64737, 111, '2015-02-15 00:32:11.000000', 'temperatura', 1067.0000, 'ºC'),
	(64738, 111, '2015-02-15 00:32:12.000000', 'temperatura', 413.0000, 'ºC'),
	(64739, 111, '2015-02-15 00:32:13.000000', 'temperatura', 66.0000, 'ºC'),
	(64740, 111, '2015-02-15 00:32:14.000000', 'temperatura', 289.0000, 'ºC'),
	(64741, 111, '2015-02-15 00:32:15.000000', 'temperatura', 49.0000, 'ºC'),
	(64742, 111, '2015-02-15 00:32:16.000000', 'temperatura', 577.0000, 'ºC'),
	(64743, 111, '2015-02-15 00:32:17.000000', 'temperatura', 340.0000, 'ºC'),
	(64744, 111, '2015-02-15 00:32:18.000000', 'temperatura', 1169.0000, 'ºC'),
	(64745, 111, '2015-02-15 00:32:19.000000', 'temperatura', 27.0000, 'ºC'),
	(64746, 111, '2015-02-15 00:32:20.000000', 'temperatura', 227.0000, 'ºC'),
	(64747, 111, '2015-02-15 00:32:21.000000', 'temperatura', 1053.0000, 'ºC'),
	(64748, 111, '2015-02-15 00:32:22.000000', 'temperatura', 985.0000, 'ºC'),
	(64749, 111, '2015-02-15 00:32:23.000000', 'temperatura', 565.0000, 'ºC'),
	(64750, 111, '2015-02-15 00:32:24.000000', 'temperatura', 1074.0000, 'ºC'),
	(64751, 111, '2015-02-15 00:32:25.000000', 'temperatura', 73.0000, 'ºC'),
	(64752, 111, '2015-02-15 00:32:26.000000', 'temperatura', 742.0000, 'ºC'),
	(64753, 111, '2015-02-15 00:32:27.000000', 'temperatura', 1095.0000, 'ºC'),
	(64754, 111, '2015-02-15 00:32:28.000000', 'temperatura', 849.0000, 'ºC'),
	(64755, 111, '2015-02-15 00:32:29.000000', 'temperatura', 959.0000, 'ºC'),
	(64756, 111, '2015-02-15 00:32:30.000000', 'temperatura', 1049.0000, 'ºC'),
	(64757, 111, '2015-02-15 00:32:31.000000', 'temperatura', 1169.0000, 'ºC'),
	(64758, 111, '2015-02-15 00:32:32.000000', 'temperatura', 300.0000, 'ºC'),
	(64759, 111, '2015-02-15 00:32:33.000000', 'temperatura', 394.0000, 'ºC'),
	(64760, 111, '2015-02-15 00:32:34.000000', 'temperatura', 1068.0000, 'ºC'),
	(64761, 111, '2015-02-15 00:32:35.000000', 'temperatura', 559.0000, 'ºC'),
	(64762, 111, '2015-02-15 00:32:36.000000', 'temperatura', 790.0000, 'ºC'),
	(64763, 111, '2015-02-15 00:32:37.000000', 'temperatura', 1075.0000, 'ºC'),
	(64764, 111, '2015-02-15 00:32:38.000000', 'temperatura', 604.0000, 'ºC'),
	(64765, 111, '2015-02-15 00:32:39.000000', 'temperatura', 995.0000, 'ºC'),
	(64766, 111, '2015-02-15 00:32:40.000000', 'temperatura', 762.0000, 'ºC'),
	(64767, 111, '2015-02-15 00:32:41.000000', 'temperatura', 829.0000, 'ºC'),
	(64768, 111, '2015-02-15 00:32:42.000000', 'temperatura', 660.0000, 'ºC'),
	(64769, 111, '2015-02-15 00:32:43.000000', 'temperatura', 811.0000, 'ºC'),
	(64770, 111, '2015-02-15 00:32:44.000000', 'temperatura', 879.0000, 'ºC'),
	(64771, 111, '2015-02-15 00:32:45.000000', 'temperatura', 759.0000, 'ºC'),
	(64772, 111, '2015-02-15 00:32:46.000000', 'temperatura', 1159.0000, 'ºC'),
	(64773, 111, '2015-02-15 00:32:47.000000', 'temperatura', 1117.0000, 'ºC'),
	(64774, 111, '2015-02-15 00:32:48.000000', 'temperatura', 911.0000, 'ºC'),
	(64775, 111, '2015-02-15 00:32:49.000000', 'temperatura', 3.0000, 'ºC'),
	(64776, 111, '2015-02-15 00:32:50.000000', 'temperatura', 881.0000, 'ºC'),
	(64777, 111, '2015-02-15 00:32:51.000000', 'temperatura', 798.0000, 'ºC'),
	(64778, 111, '2015-02-15 00:32:52.000000', 'temperatura', 145.0000, 'ºC'),
	(64779, 111, '2015-02-15 00:32:53.000000', 'temperatura', 735.0000, 'ºC'),
	(64780, 111, '2015-02-15 00:32:54.000000', 'temperatura', 838.0000, 'ºC'),
	(64781, 111, '2015-02-15 00:32:55.000000', 'temperatura', 787.0000, 'ºC'),
	(64782, 111, '2015-02-15 00:32:56.000000', 'temperatura', 222.0000, 'ºC'),
	(64783, 111, '2015-02-15 00:32:57.000000', 'temperatura', 1147.0000, 'ºC'),
	(64784, 111, '2015-02-15 00:32:58.000000', 'temperatura', 270.0000, 'ºC'),
	(64785, 111, '2015-02-15 00:32:59.000000', 'temperatura', 311.0000, 'ºC'),
	(64786, 111, '2015-02-15 00:33:00.000000', 'temperatura', 743.0000, 'ºC'),
	(64787, 111, '2015-02-15 00:33:01.000000', 'temperatura', 383.0000, 'ºC'),
	(64788, 111, '2015-02-15 00:33:02.000000', 'temperatura', 886.0000, 'ºC'),
	(64789, 111, '2015-02-15 00:33:03.000000', 'temperatura', 880.0000, 'ºC'),
	(64790, 111, '2015-02-15 00:33:04.000000', 'temperatura', 546.0000, 'ºC'),
	(64791, 111, '2015-02-15 00:33:05.000000', 'temperatura', 88.0000, 'ºC'),
	(64792, 111, '2015-02-15 00:33:06.000000', 'temperatura', 4.0000, 'ºC'),
	(64793, 111, '2015-02-15 00:33:07.000000', 'temperatura', 954.0000, 'ºC'),
	(64794, 111, '2015-02-15 00:33:08.000000', 'temperatura', 1160.0000, 'ºC'),
	(64795, 111, '2015-02-15 00:33:09.000000', 'temperatura', 540.0000, 'ºC'),
	(64796, 111, '2015-02-15 00:33:10.000000', 'temperatura', 421.0000, 'ºC'),
	(64797, 111, '2015-02-15 00:33:11.000000', 'temperatura', 486.0000, 'ºC'),
	(64798, 111, '2015-02-15 00:33:12.000000', 'temperatura', 1167.0000, 'ºC'),
	(64799, 111, '2015-02-15 00:33:13.000000', 'temperatura', 776.0000, 'ºC'),
	(64800, 111, '2015-02-15 00:33:14.000000', 'temperatura', 380.0000, 'ºC'),
	(64801, 111, '2015-02-15 00:33:15.000000', 'temperatura', 773.0000, 'ºC'),
	(64802, 111, '2015-02-15 00:33:16.000000', 'temperatura', 323.0000, 'ºC'),
	(64803, 111, '2015-02-15 00:33:17.000000', 'temperatura', 500.0000, 'ºC'),
	(64804, 111, '2015-02-15 00:33:18.000000', 'temperatura', 329.0000, 'ºC'),
	(64805, 111, '2015-02-15 00:33:19.000000', 'temperatura', 144.0000, 'ºC'),
	(64806, 111, '2015-02-15 00:33:20.000000', 'temperatura', 936.0000, 'ºC'),
	(64807, 111, '2015-02-15 00:33:21.000000', 'temperatura', 649.0000, 'ºC'),
	(64808, 111, '2015-02-15 00:33:22.000000', 'temperatura', 436.0000, 'ºC'),
	(64809, 111, '2015-02-15 00:33:23.000000', 'temperatura', 236.0000, 'ºC'),
	(64810, 111, '2015-02-15 00:33:24.000000', 'temperatura', 1069.0000, 'ºC'),
	(64811, 111, '2015-02-15 00:33:25.000000', 'temperatura', 1041.0000, 'ºC'),
	(64812, 111, '2015-02-15 00:33:26.000000', 'temperatura', 796.0000, 'ºC'),
	(64813, 111, '2015-02-15 00:33:27.000000', 'temperatura', 856.0000, 'ºC'),
	(64814, 111, '2015-02-15 00:33:28.000000', 'temperatura', 695.0000, 'ºC'),
	(64815, 111, '2015-02-15 00:33:29.000000', 'temperatura', 907.0000, 'ºC'),
	(64816, 111, '2015-02-15 00:33:30.000000', 'temperatura', 49.0000, 'ºC'),
	(64817, 111, '2015-02-15 00:33:31.000000', 'temperatura', 1124.0000, 'ºC'),
	(64818, 111, '2015-02-15 00:33:32.000000', 'temperatura', 676.0000, 'ºC'),
	(64819, 111, '2015-02-15 00:33:33.000000', 'temperatura', 9.0000, 'ºC'),
	(64820, 111, '2015-02-15 00:33:34.000000', 'temperatura', 416.0000, 'ºC'),
	(64821, 111, '2015-02-15 00:33:35.000000', 'temperatura', 854.0000, 'ºC'),
	(64822, 111, '2015-02-15 00:33:36.000000', 'temperatura', 622.0000, 'ºC'),
	(64823, 111, '2015-02-15 00:33:37.000000', 'temperatura', 547.0000, 'ºC'),
	(64824, 111, '2015-02-15 00:33:38.000000', 'temperatura', 870.0000, 'ºC'),
	(64825, 111, '2015-02-15 00:33:39.000000', 'temperatura', 310.0000, 'ºC'),
	(64826, 111, '2015-02-15 00:33:40.000000', 'temperatura', 140.0000, 'ºC'),
	(64827, 111, '2015-02-15 00:33:41.000000', 'temperatura', 969.0000, 'ºC'),
	(64828, 111, '2015-02-15 00:33:42.000000', 'temperatura', 827.0000, 'ºC'),
	(64829, 111, '2015-02-15 00:33:43.000000', 'temperatura', 28.0000, 'ºC'),
	(64830, 111, '2015-02-15 00:33:44.000000', 'temperatura', 61.0000, 'ºC'),
	(64831, 111, '2015-02-15 00:33:45.000000', 'temperatura', 220.0000, 'ºC'),
	(64832, 111, '2015-02-15 00:33:46.000000', 'temperatura', 920.0000, 'ºC'),
	(64833, 111, '2015-02-15 00:33:47.000000', 'temperatura', 337.0000, 'ºC'),
	(64834, 111, '2015-02-15 00:33:48.000000', 'temperatura', 127.0000, 'ºC'),
	(64835, 111, '2015-02-15 00:33:49.000000', 'temperatura', 823.0000, 'ºC'),
	(64836, 111, '2015-02-15 00:33:50.000000', 'temperatura', 135.0000, 'ºC'),
	(64837, 111, '2015-02-15 00:33:51.000000', 'temperatura', 608.0000, 'ºC'),
	(64838, 111, '2015-02-15 00:33:52.000000', 'temperatura', 236.0000, 'ºC'),
	(64839, 111, '2015-02-15 00:33:53.000000', 'temperatura', 557.0000, 'ºC'),
	(64840, 111, '2015-02-15 00:33:54.000000', 'temperatura', 878.0000, 'ºC'),
	(64841, 111, '2015-02-15 00:33:55.000000', 'temperatura', 317.0000, 'ºC'),
	(64842, 111, '2015-02-15 00:33:56.000000', 'temperatura', 153.0000, 'ºC'),
	(64843, 111, '2015-02-15 00:33:57.000000', 'temperatura', 1014.0000, 'ºC'),
	(64844, 111, '2015-02-15 00:33:58.000000', 'temperatura', 1010.0000, 'ºC'),
	(64845, 111, '2015-02-15 00:33:59.000000', 'temperatura', 811.0000, 'ºC'),
	(64846, 111, '2015-02-15 00:34:00.000000', 'temperatura', 1024.0000, 'ºC'),
	(64847, 111, '2015-02-15 00:34:01.000000', 'temperatura', 288.0000, 'ºC'),
	(64848, 111, '2015-02-15 00:34:02.000000', 'temperatura', 769.0000, 'ºC'),
	(64849, 111, '2015-02-15 00:34:03.000000', 'temperatura', 580.0000, 'ºC'),
	(64850, 111, '2015-02-15 00:34:04.000000', 'temperatura', 596.0000, 'ºC'),
	(64851, 111, '2015-02-15 00:34:05.000000', 'temperatura', 38.0000, 'ºC'),
	(64852, 111, '2015-02-15 00:34:06.000000', 'temperatura', 804.0000, 'ºC'),
	(64853, 111, '2015-02-15 00:34:07.000000', 'temperatura', 305.0000, 'ºC'),
	(64854, 111, '2015-02-15 00:34:08.000000', 'temperatura', 316.0000, 'ºC'),
	(64855, 111, '2015-02-15 00:34:09.000000', 'temperatura', 664.0000, 'ºC'),
	(64856, 111, '2015-02-15 00:34:10.000000', 'temperatura', 1174.0000, 'ºC'),
	(64857, 111, '2015-02-15 00:34:11.000000', 'temperatura', 277.0000, 'ºC'),
	(64858, 111, '2015-02-15 00:34:12.000000', 'temperatura', 263.0000, 'ºC'),
	(64859, 111, '2015-02-15 00:34:13.000000', 'temperatura', 484.0000, 'ºC'),
	(64860, 111, '2015-02-15 00:34:14.000000', 'temperatura', 433.0000, 'ºC'),
	(64861, 111, '2015-02-15 00:34:15.000000', 'temperatura', 714.0000, 'ºC'),
	(64862, 111, '2015-02-15 00:34:16.000000', 'temperatura', 1070.0000, 'ºC'),
	(64863, 111, '2015-02-15 00:34:17.000000', 'temperatura', 809.0000, 'ºC'),
	(64864, 111, '2015-02-15 00:34:18.000000', 'temperatura', 834.0000, 'ºC'),
	(64865, 111, '2015-02-15 00:34:19.000000', 'temperatura', 546.0000, 'ºC'),
	(64866, 111, '2015-02-15 00:34:20.000000', 'temperatura', 226.0000, 'ºC'),
	(64867, 111, '2015-02-15 00:34:21.000000', 'temperatura', 694.0000, 'ºC'),
	(64868, 111, '2015-02-15 00:34:22.000000', 'temperatura', 394.0000, 'ºC'),
	(64869, 111, '2015-02-15 00:34:23.000000', 'temperatura', 1085.0000, 'ºC'),
	(64870, 111, '2015-02-15 00:34:24.000000', 'temperatura', 646.0000, 'ºC'),
	(64871, 111, '2015-02-15 00:34:25.000000', 'temperatura', 1173.0000, 'ºC'),
	(64872, 111, '2015-02-15 00:34:26.000000', 'temperatura', 328.0000, 'ºC'),
	(64873, 111, '2015-02-15 00:34:27.000000', 'temperatura', 523.0000, 'ºC'),
	(64874, 111, '2015-02-15 00:34:28.000000', 'temperatura', 430.0000, 'ºC'),
	(64875, 111, '2015-02-15 00:34:29.000000', 'temperatura', 582.0000, 'ºC'),
	(64876, 111, '2015-02-15 00:34:30.000000', 'temperatura', 421.0000, 'ºC'),
	(64877, 111, '2015-02-15 00:34:31.000000', 'temperatura', 359.0000, 'ºC'),
	(64878, 111, '2015-02-15 00:34:32.000000', 'temperatura', 532.0000, 'ºC'),
	(64879, 111, '2015-02-15 00:34:33.000000', 'temperatura', 383.0000, 'ºC'),
	(64880, 111, '2015-02-15 00:34:34.000000', 'temperatura', 319.0000, 'ºC'),
	(64881, 111, '2015-02-15 00:34:35.000000', 'temperatura', 447.0000, 'ºC'),
	(64882, 111, '2015-02-15 00:34:36.000000', 'temperatura', 80.0000, 'ºC'),
	(64883, 111, '2015-02-15 00:34:37.000000', 'temperatura', 260.0000, 'ºC'),
	(64884, 111, '2015-02-15 00:34:38.000000', 'temperatura', 1058.0000, 'ºC'),
	(64885, 111, '2015-02-15 00:34:39.000000', 'temperatura', 910.0000, 'ºC'),
	(64886, 111, '2015-02-15 00:34:40.000000', 'temperatura', 179.0000, 'ºC'),
	(64887, 111, '2015-02-15 00:34:41.000000', 'temperatura', 567.0000, 'ºC'),
	(64888, 111, '2015-02-15 00:34:42.000000', 'temperatura', 1095.0000, 'ºC'),
	(64889, 111, '2015-02-15 00:34:43.000000', 'temperatura', 176.0000, 'ºC'),
	(64890, 111, '2015-02-15 00:34:44.000000', 'temperatura', 1197.0000, 'ºC'),
	(64891, 111, '2015-02-15 00:34:45.000000', 'temperatura', 655.0000, 'ºC'),
	(64892, 111, '2015-02-15 00:34:46.000000', 'temperatura', 887.0000, 'ºC'),
	(64893, 111, '2015-02-15 00:34:47.000000', 'temperatura', 71.0000, 'ºC'),
	(64894, 111, '2015-02-15 00:34:48.000000', 'temperatura', 92.0000, 'ºC'),
	(64895, 111, '2015-02-15 00:34:49.000000', 'temperatura', 249.0000, 'ºC'),
	(64896, 111, '2015-02-15 00:34:50.000000', 'temperatura', 969.0000, 'ºC'),
	(64897, 111, '2015-02-15 00:34:51.000000', 'temperatura', 499.0000, 'ºC'),
	(64898, 111, '2015-02-15 00:34:52.000000', 'temperatura', 790.0000, 'ºC'),
	(64899, 111, '2015-02-15 00:34:53.000000', 'temperatura', 51.0000, 'ºC'),
	(64900, 111, '2015-02-15 00:34:54.000000', 'temperatura', 287.0000, 'ºC'),
	(64901, 111, '2015-02-15 00:34:55.000000', 'temperatura', 83.0000, 'ºC'),
	(64902, 111, '2015-02-15 00:34:56.000000', 'temperatura', 755.0000, 'ºC'),
	(64903, 111, '2015-02-15 00:34:57.000000', 'temperatura', 1124.0000, 'ºC'),
	(64904, 111, '2015-02-15 00:34:58.000000', 'temperatura', 955.0000, 'ºC'),
	(64905, 111, '2015-02-15 00:34:59.000000', 'temperatura', 204.0000, 'ºC'),
	(64906, 111, '2015-02-15 00:35:00.000000', 'temperatura', 555.0000, 'ºC'),
	(64907, 111, '2015-02-15 00:35:01.000000', 'temperatura', 963.0000, 'ºC'),
	(64908, 111, '2015-02-15 00:35:02.000000', 'temperatura', 750.0000, 'ºC'),
	(64909, 111, '2015-02-15 00:35:03.000000', 'temperatura', 863.0000, 'ºC'),
	(64910, 111, '2015-02-15 00:35:04.000000', 'temperatura', 864.0000, 'ºC'),
	(64911, 111, '2015-02-15 00:35:05.000000', 'temperatura', 533.0000, 'ºC'),
	(64912, 111, '2015-02-15 00:35:06.000000', 'temperatura', 74.0000, 'ºC'),
	(64913, 111, '2015-02-15 00:35:07.000000', 'temperatura', 1169.0000, 'ºC'),
	(64914, 111, '2015-02-15 00:35:08.000000', 'temperatura', 826.0000, 'ºC'),
	(64915, 111, '2015-02-15 00:35:09.000000', 'temperatura', 623.0000, 'ºC'),
	(64916, 111, '2015-02-15 00:35:10.000000', 'temperatura', 635.0000, 'ºC'),
	(64917, 111, '2015-02-15 00:35:11.000000', 'temperatura', 110.0000, 'ºC'),
	(64918, 111, '2015-02-15 00:35:12.000000', 'temperatura', 1045.0000, 'ºC'),
	(64919, 111, '2015-02-15 00:35:13.000000', 'temperatura', 94.0000, 'ºC'),
	(64920, 111, '2015-02-15 00:35:14.000000', 'temperatura', 936.0000, 'ºC'),
	(64921, 111, '2015-02-15 00:35:15.000000', 'temperatura', 799.0000, 'ºC'),
	(64922, 111, '2015-02-15 00:35:16.000000', 'temperatura', 1188.0000, 'ºC'),
	(64923, 111, '2015-02-15 00:35:17.000000', 'temperatura', 1141.0000, 'ºC'),
	(64924, 111, '2015-02-15 00:35:18.000000', 'temperatura', 945.0000, 'ºC'),
	(64925, 111, '2015-02-15 00:35:19.000000', 'temperatura', 99.0000, 'ºC'),
	(64926, 111, '2015-02-15 00:35:20.000000', 'temperatura', 62.0000, 'ºC'),
	(64927, 111, '2015-02-15 00:35:21.000000', 'temperatura', 13.0000, 'ºC'),
	(64928, 111, '2015-02-15 00:35:22.000000', 'temperatura', 1079.0000, 'ºC'),
	(64929, 111, '2015-02-15 00:35:23.000000', 'temperatura', 556.0000, 'ºC'),
	(64930, 111, '2015-02-15 00:35:24.000000', 'temperatura', 742.0000, 'ºC'),
	(64931, 111, '2015-02-15 00:35:25.000000', 'temperatura', 845.0000, 'ºC'),
	(64932, 111, '2015-02-15 00:35:26.000000', 'temperatura', 798.0000, 'ºC'),
	(64933, 111, '2015-02-15 00:35:27.000000', 'temperatura', 257.0000, 'ºC'),
	(64934, 111, '2015-02-15 00:35:28.000000', 'temperatura', 92.0000, 'ºC'),
	(64935, 111, '2015-02-15 00:35:29.000000', 'temperatura', 888.0000, 'ºC'),
	(64936, 111, '2015-02-15 00:35:30.000000', 'temperatura', 565.0000, 'ºC'),
	(64937, 111, '2015-02-15 00:35:31.000000', 'temperatura', 163.0000, 'ºC'),
	(64938, 111, '2015-02-15 00:35:32.000000', 'temperatura', 319.0000, 'ºC'),
	(64939, 111, '2015-02-15 00:35:33.000000', 'temperatura', 1108.0000, 'ºC'),
	(64940, 111, '2015-02-15 00:35:34.000000', 'temperatura', 981.0000, 'ºC'),
	(64941, 111, '2015-02-15 00:35:35.000000', 'temperatura', 381.0000, 'ºC'),
	(64942, 111, '2015-02-15 00:35:36.000000', 'temperatura', 165.0000, 'ºC'),
	(64943, 111, '2015-02-15 00:35:37.000000', 'temperatura', 882.0000, 'ºC'),
	(64944, 111, '2015-02-15 00:35:38.000000', 'temperatura', 317.0000, 'ºC'),
	(64945, 111, '2015-02-15 00:35:39.000000', 'temperatura', 138.0000, 'ºC'),
	(64946, 111, '2015-02-15 00:35:40.000000', 'temperatura', 941.0000, 'ºC'),
	(64947, 111, '2015-02-15 00:35:41.000000', 'temperatura', 690.0000, 'ºC'),
	(64948, 111, '2015-02-15 00:35:42.000000', 'temperatura', 630.0000, 'ºC'),
	(64949, 111, '2015-02-15 00:35:43.000000', 'temperatura', 1078.0000, 'ºC'),
	(64950, 111, '2015-02-15 00:35:44.000000', 'temperatura', 1101.0000, 'ºC'),
	(64951, 111, '2015-02-15 00:35:45.000000', 'temperatura', 1071.0000, 'ºC'),
	(64952, 111, '2015-02-15 00:35:46.000000', 'temperatura', 851.0000, 'ºC'),
	(64953, 111, '2015-02-15 00:35:47.000000', 'temperatura', 1045.0000, 'ºC'),
	(64954, 111, '2015-02-15 00:35:48.000000', 'temperatura', 273.0000, 'ºC'),
	(64955, 111, '2015-02-15 00:35:49.000000', 'temperatura', 629.0000, 'ºC'),
	(64956, 111, '2015-02-15 00:35:50.000000', 'temperatura', 1128.0000, 'ºC'),
	(64957, 111, '2015-02-15 00:35:51.000000', 'temperatura', 154.0000, 'ºC'),
	(64958, 111, '2015-02-15 00:35:52.000000', 'temperatura', 984.0000, 'ºC'),
	(64959, 111, '2015-02-15 00:35:53.000000', 'temperatura', 858.0000, 'ºC'),
	(64960, 111, '2015-02-15 00:35:54.000000', 'temperatura', 141.0000, 'ºC'),
	(64961, 111, '2015-02-15 00:35:55.000000', 'temperatura', 532.0000, 'ºC'),
	(64962, 111, '2015-02-15 00:35:56.000000', 'temperatura', 1038.0000, 'ºC'),
	(64963, 111, '2015-02-15 00:35:57.000000', 'temperatura', 1195.0000, 'ºC'),
	(64964, 111, '2015-02-15 00:35:58.000000', 'temperatura', 461.0000, 'ºC'),
	(64965, 111, '2015-02-15 00:35:59.000000', 'temperatura', 1119.0000, 'ºC'),
	(64966, 111, '2015-02-15 00:36:00.000000', 'temperatura', 615.0000, 'ºC'),
	(64967, 111, '2015-02-15 00:36:01.000000', 'temperatura', 918.0000, 'ºC'),
	(64968, 111, '2015-02-15 00:36:02.000000', 'temperatura', 345.0000, 'ºC'),
	(64969, 111, '2015-02-15 00:36:03.000000', 'temperatura', 172.0000, 'ºC'),
	(64970, 111, '2015-02-15 00:36:04.000000', 'temperatura', 1024.0000, 'ºC'),
	(64971, 111, '2015-02-15 00:36:05.000000', 'temperatura', 1007.0000, 'ºC'),
	(64972, 111, '2015-02-15 00:36:06.000000', 'temperatura', 764.0000, 'ºC'),
	(64973, 111, '2015-02-15 00:36:07.000000', 'temperatura', 798.0000, 'ºC'),
	(64974, 111, '2015-02-15 00:36:08.000000', 'temperatura', 499.0000, 'ºC'),
	(64975, 111, '2015-02-15 00:36:09.000000', 'temperatura', 101.0000, 'ºC'),
	(64976, 111, '2015-02-15 00:36:10.000000', 'temperatura', 207.0000, 'ºC'),
	(64977, 111, '2015-02-15 00:36:11.000000', 'temperatura', 735.0000, 'ºC'),
	(64978, 111, '2015-02-15 00:36:12.000000', 'temperatura', 655.0000, 'ºC'),
	(64979, 111, '2015-02-15 00:36:13.000000', 'temperatura', 1071.0000, 'ºC'),
	(64980, 111, '2015-02-15 00:36:14.000000', 'temperatura', 989.0000, 'ºC'),
	(64981, 111, '2015-02-15 00:36:15.000000', 'temperatura', 533.0000, 'ºC'),
	(64982, 111, '2015-02-15 00:36:16.000000', 'temperatura', 898.0000, 'ºC'),
	(64983, 111, '2015-02-15 00:36:17.000000', 'temperatura', 491.0000, 'ºC'),
	(64984, 111, '2015-02-15 00:36:18.000000', 'temperatura', 961.0000, 'ºC'),
	(64985, 111, '2015-02-15 00:36:19.000000', 'temperatura', 932.0000, 'ºC'),
	(64986, 111, '2015-02-15 00:36:20.000000', 'temperatura', 580.0000, 'ºC'),
	(64987, 111, '2015-02-15 00:36:21.000000', 'temperatura', 101.0000, 'ºC'),
	(64988, 111, '2015-02-15 00:36:22.000000', 'temperatura', 1169.0000, 'ºC'),
	(64989, 111, '2015-02-15 00:36:23.000000', 'temperatura', 739.0000, 'ºC'),
	(64990, 111, '2015-02-15 00:36:24.000000', 'temperatura', 191.0000, 'ºC'),
	(64991, 111, '2015-02-15 00:36:25.000000', 'temperatura', 1137.0000, 'ºC'),
	(64992, 111, '2015-02-15 00:36:26.000000', 'temperatura', 313.0000, 'ºC'),
	(64993, 111, '2015-02-15 00:36:27.000000', 'temperatura', 553.0000, 'ºC'),
	(64994, 111, '2015-02-15 00:36:28.000000', 'temperatura', 627.0000, 'ºC'),
	(64995, 111, '2015-02-15 00:36:29.000000', 'temperatura', 278.0000, 'ºC'),
	(64996, 111, '2015-02-15 00:36:30.000000', 'temperatura', 711.0000, 'ºC'),
	(64997, 111, '2015-02-15 00:36:31.000000', 'temperatura', 319.0000, 'ºC'),
	(64998, 111, '2015-02-15 00:36:32.000000', 'temperatura', 663.0000, 'ºC'),
	(64999, 111, '2015-02-15 00:36:33.000000', 'temperatura', 1158.0000, 'ºC'),
	(65000, 111, '2015-02-15 00:36:34.000000', 'temperatura', 201.0000, 'ºC'),
	(65001, 111, '2015-02-15 00:36:35.000000', 'temperatura', 1131.0000, 'ºC'),
	(65002, 111, '2015-02-15 00:36:36.000000', 'temperatura', 254.0000, 'ºC'),
	(65003, 111, '2015-02-15 00:36:37.000000', 'temperatura', 278.0000, 'ºC'),
	(65004, 111, '2015-02-15 00:36:38.000000', 'temperatura', 627.0000, 'ºC'),
	(65005, 111, '2015-02-15 00:36:39.000000', 'temperatura', 1103.0000, 'ºC'),
	(65006, 111, '2015-02-15 00:36:40.000000', 'temperatura', 33.0000, 'ºC'),
	(65007, 111, '2015-02-15 00:36:41.000000', 'temperatura', 458.0000, 'ºC'),
	(65008, 111, '2015-02-15 00:36:42.000000', 'temperatura', 989.0000, 'ºC'),
	(65009, 111, '2015-02-15 00:36:43.000000', 'temperatura', 1172.0000, 'ºC'),
	(65010, 111, '2015-02-15 00:36:44.000000', 'temperatura', 496.0000, 'ºC'),
	(65011, 111, '2015-02-15 00:36:45.000000', 'temperatura', 161.0000, 'ºC'),
	(65012, 111, '2015-02-15 00:36:46.000000', 'temperatura', 521.0000, 'ºC'),
	(65013, 111, '2015-02-15 00:36:47.000000', 'temperatura', 920.0000, 'ºC'),
	(65014, 111, '2015-02-15 00:36:48.000000', 'temperatura', 638.0000, 'ºC'),
	(65015, 111, '2015-02-15 00:36:49.000000', 'temperatura', 429.0000, 'ºC'),
	(65016, 111, '2015-02-15 00:36:50.000000', 'temperatura', 234.0000, 'ºC'),
	(65017, 111, '2015-02-15 00:36:51.000000', 'temperatura', 1084.0000, 'ºC'),
	(65018, 111, '2015-02-15 00:36:52.000000', 'temperatura', 1119.0000, 'ºC'),
	(65019, 111, '2015-02-15 00:36:53.000000', 'temperatura', 1142.0000, 'ºC'),
	(65020, 111, '2015-02-15 00:36:54.000000', 'temperatura', 1152.0000, 'ºC'),
	(65021, 111, '2015-02-15 00:36:55.000000', 'temperatura', 1136.0000, 'ºC'),
	(65022, 111, '2015-02-15 00:36:56.000000', 'temperatura', 1024.0000, 'ºC'),
	(65023, 111, '2015-02-15 00:36:57.000000', 'temperatura', 512.0000, 'ºC'),
	(65024, 111, '2015-02-15 00:36:58.000000', 'temperatura', 690.0000, 'ºC'),
	(65025, 111, '2015-02-15 00:36:59.000000', 'temperatura', 716.0000, 'ºC'),
	(65026, 111, '2015-02-15 00:37:00.000000', 'temperatura', 308.0000, 'ºC'),
	(65027, 111, '2015-02-15 00:37:01.000000', 'temperatura', 594.0000, 'ºC'),
	(65028, 111, '2015-02-15 00:37:02.000000', 'temperatura', 845.0000, 'ºC'),
	(65029, 111, '2015-02-15 00:37:03.000000', 'temperatura', 43.0000, 'ºC'),
	(65030, 111, '2015-02-15 00:37:04.000000', 'temperatura', 79.0000, 'ºC'),
	(65031, 111, '2015-02-15 00:37:05.000000', 'temperatura', 270.0000, 'ºC'),
	(65032, 111, '2015-02-15 00:37:06.000000', 'temperatura', 1113.0000, 'ºC'),
	(65033, 111, '2015-02-15 00:37:07.000000', 'temperatura', 1153.0000, 'ºC'),
	(65034, 111, '2015-02-15 00:37:08.000000', 'temperatura', 30.0000, 'ºC'),
	(65035, 111, '2015-02-15 00:37:09.000000', 'temperatura', 289.0000, 'ºC'),
	(65036, 111, '2015-02-15 00:37:10.000000', 'temperatura', 158.0000, 'ºC'),
	(65037, 111, '2015-02-15 00:37:11.000000', 'temperatura', 1122.0000, 'ºC'),
	(65038, 111, '2015-02-15 00:37:12.000000', 'temperatura', 337.0000, 'ºC'),
	(65039, 111, '2015-02-15 00:37:13.000000', 'temperatura', 719.0000, 'ºC'),
	(65040, 111, '2015-02-15 00:37:14.000000', 'temperatura', 185.0000, 'ºC'),
	(65041, 111, '2015-02-15 00:37:15.000000', 'temperatura', 1169.0000, 'ºC'),
	(65042, 111, '2015-02-15 00:37:16.000000', 'temperatura', 489.0000, 'ºC'),
	(65043, 111, '2015-02-15 00:37:17.000000', 'temperatura', 139.0000, 'ºC'),
	(65044, 111, '2015-02-15 00:37:18.000000', 'temperatura', 427.0000, 'ºC'),
	(65045, 111, '2015-02-15 00:37:19.000000', 'temperatura', 518.0000, 'ºC'),
	(65046, 111, '2015-02-15 00:37:20.000000', 'temperatura', 112.0000, 'ºC'),
	(65047, 111, '2015-02-15 00:37:21.000000', 'temperatura', 204.0000, 'ºC'),
	(65048, 111, '2015-02-15 00:37:22.000000', 'temperatura', 686.0000, 'ºC'),
	(65049, 111, '2015-02-15 00:37:23.000000', 'temperatura', 418.0000, 'ºC'),
	(65050, 111, '2015-02-15 00:37:24.000000', 'temperatura', 33.0000, 'ºC'),
	(65051, 111, '2015-02-15 00:37:25.000000', 'temperatura', 110.0000, 'ºC'),
	(65052, 111, '2015-02-15 00:37:26.000000', 'temperatura', 454.0000, 'ºC'),
	(65053, 111, '2015-02-15 00:37:27.000000', 'temperatura', 741.0000, 'ºC'),
	(65054, 111, '2015-02-15 00:37:28.000000', 'temperatura', 1142.0000, 'ºC'),
	(65055, 111, '2015-02-15 00:37:29.000000', 'temperatura', 1089.0000, 'ºC'),
	(65056, 111, '2015-02-15 00:37:30.000000', 'temperatura', 820.0000, 'ºC'),
	(65057, 111, '2015-02-15 00:37:31.000000', 'temperatura', 834.0000, 'ºC'),
	(65058, 111, '2015-02-15 00:37:32.000000', 'temperatura', 511.0000, 'ºC'),
	(65059, 111, '2015-02-15 00:37:33.000000', 'temperatura', 54.0000, 'ºC'),
	(65060, 111, '2015-02-15 00:37:34.000000', 'temperatura', 1136.0000, 'ºC'),
	(65061, 111, '2015-02-15 00:37:35.000000', 'temperatura', 720.0000, 'ºC'),
	(65062, 111, '2015-02-15 00:37:36.000000', 'temperatura', 190.0000, 'ºC'),
	(65063, 111, '2015-02-15 00:37:37.000000', 'temperatura', 1190.0000, 'ºC'),
	(65064, 111, '2015-02-15 00:37:38.000000', 'temperatura', 580.0000, 'ºC'),
	(65065, 111, '2015-02-15 00:37:39.000000', 'temperatura', 534.0000, 'ºC'),
	(65066, 111, '2015-02-15 00:37:40.000000', 'temperatura', 928.0000, 'ºC'),
	(65067, 111, '2015-02-15 00:37:41.000000', 'temperatura', 638.0000, 'ºC'),
	(65068, 111, '2015-02-15 00:37:42.000000', 'temperatura', 407.0000, 'ºC'),
	(65069, 111, '2015-02-15 00:37:43.000000', 'temperatura', 121.0000, 'ºC'),
	(65070, 111, '2015-02-15 00:37:44.000000', 'temperatura', 585.0000, 'ºC'),
	(65071, 111, '2015-02-15 00:37:45.000000', 'temperatura', 161.0000, 'ºC'),
	(65072, 111, '2015-02-15 00:37:46.000000', 'temperatura', 253.0000, 'ºC'),
	(65073, 111, '2015-02-15 00:37:47.000000', 'temperatura', 783.0000, 'ºC'),
	(65074, 111, '2015-02-15 00:37:48.000000', 'temperatura', 755.0000, 'ºC'),
	(65075, 111, '2015-02-15 00:37:49.000000', 'temperatura', 226.0000, 'ºC'),
	(65076, 111, '2015-02-15 00:37:50.000000', 'temperatura', 65.0000, 'ºC'),
	(65077, 111, '2015-02-15 00:37:51.000000', 'temperatura', 847.0000, 'ºC'),
	(65078, 111, '2015-02-15 00:37:52.000000', 'temperatura', 443.0000, 'ºC'),
	(65079, 111, '2015-02-15 00:37:53.000000', 'temperatura', 873.0000, 'ºC'),
	(65080, 111, '2015-02-15 00:37:54.000000', 'temperatura', 636.0000, 'ºC'),
	(65081, 111, '2015-02-15 00:37:55.000000', 'temperatura', 562.0000, 'ºC'),
	(65082, 111, '2015-02-15 00:37:56.000000', 'temperatura', 903.0000, 'ºC'),
	(65083, 111, '2015-02-15 00:37:57.000000', 'temperatura', 427.0000, 'ºC'),
	(65084, 111, '2015-02-15 00:37:58.000000', 'temperatura', 629.0000, 'ºC'),
	(65085, 111, '2015-02-15 00:37:59.000000', 'temperatura', 664.0000, 'ºC'),
	(65086, 111, '2015-02-15 00:38:00.000000', 'temperatura', 231.0000, 'ºC'),
	(65087, 111, '2015-02-15 00:38:01.000000', 'temperatura', 367.0000, 'ºC'),
	(65088, 111, '2015-02-15 00:38:02.000000', 'temperatura', 1142.0000, 'ºC'),
	(65089, 111, '2015-02-15 00:38:03.000000', 'temperatura', 1010.0000, 'ºC'),
	(65090, 111, '2015-02-15 00:38:04.000000', 'temperatura', 424.0000, 'ºC'),
	(65091, 111, '2015-02-15 00:38:05.000000', 'temperatura', 291.0000, 'ºC'),
	(65092, 111, '2015-02-15 00:38:06.000000', 'temperatura', 181.0000, 'ºC'),
	(65093, 111, '2015-02-15 00:38:07.000000', 'temperatura', 35.0000, 'ºC'),
	(65094, 111, '2015-02-15 00:38:08.000000', 'temperatura', 832.0000, 'ºC'),
	(65095, 111, '2015-02-15 00:38:09.000000', 'temperatura', 456.0000, 'ºC'),
	(65096, 111, '2015-02-15 00:38:10.000000', 'temperatura', 985.0000, 'ºC'),
	(65097, 111, '2015-02-15 00:38:11.000000', 'temperatura', 1157.0000, 'ºC'),
	(65098, 111, '2015-02-15 00:38:12.000000', 'temperatura', 429.0000, 'ºC'),
	(65099, 111, '2015-02-15 00:38:13.000000', 'temperatura', 1075.0000, 'ºC'),
	(65100, 111, '2015-02-15 00:38:14.000000', 'temperatura', 488.0000, 'ºC'),
	(65101, 111, '2015-02-15 00:38:15.000000', 'temperatura', 417.0000, 'ºC'),
	(65102, 111, '2015-02-15 00:38:16.000000', 'temperatura', 619.0000, 'ºC'),
	(65103, 111, '2015-02-15 00:38:17.000000', 'temperatura', 647.0000, 'ºC'),
	(65104, 111, '2015-02-15 00:38:18.000000', 'temperatura', 178.0000, 'ºC'),
	(65105, 111, '2015-02-15 00:38:19.000000', 'temperatura', 150.0000, 'ºC'),
	(65106, 111, '2015-02-15 00:38:20.000000', 'temperatura', 214.0000, 'ºC'),
	(65107, 111, '2015-02-15 00:38:21.000000', 'temperatura', 622.0000, 'ºC'),
	(65108, 111, '2015-02-15 00:38:22.000000', 'temperatura', 68.0000, 'ºC'),
	(65109, 111, '2015-02-15 00:38:23.000000', 'temperatura', 874.0000, 'ºC'),
	(65110, 111, '2015-02-15 00:38:24.000000', 'temperatura', 566.0000, 'ºC'),
	(65111, 111, '2015-02-15 00:38:25.000000', 'temperatura', 210.0000, 'ºC'),
	(65112, 111, '2015-02-15 00:38:26.000000', 'temperatura', 554.0000, 'ºC'),
	(65113, 111, '2015-02-15 00:38:27.000000', 'temperatura', 939.0000, 'ºC'),
	(65114, 111, '2015-02-15 00:38:28.000000', 'temperatura', 633.0000, 'ºC'),
	(65115, 111, '2015-02-15 00:38:29.000000', 'temperatura', 350.0000, 'ºC'),
	(65116, 111, '2015-02-15 00:38:30.000000', 'temperatura', 1050.0000, 'ºC'),
	(65117, 111, '2015-02-15 00:38:31.000000', 'temperatura', 602.0000, 'ºC'),
	(65118, 111, '2015-02-15 00:38:32.000000', 'temperatura', 1059.0000, 'ºC'),
	(65119, 111, '2015-02-15 00:38:33.000000', 'temperatura', 1091.0000, 'ºC'),
	(65120, 111, '2015-02-15 00:38:34.000000', 'temperatura', 1077.0000, 'ºC'),
	(65121, 111, '2015-02-15 00:38:35.000000', 'temperatura', 912.0000, 'ºC'),
	(65122, 111, '2015-02-15 00:38:36.000000', 'temperatura', 129.0000, 'ºC'),
	(65123, 111, '2015-02-15 00:38:37.000000', 'temperatura', 312.0000, 'ºC'),
	(65124, 111, '2015-02-15 00:38:38.000000', 'temperatura', 1175.0000, 'ºC'),
	(65125, 111, '2015-02-15 00:38:39.000000', 'temperatura', 136.0000, 'ºC'),
	(65126, 111, '2015-02-15 00:38:40.000000', 'temperatura', 755.0000, 'ºC'),
	(65127, 111, '2015-02-15 00:38:41.000000', 'temperatura', 968.0000, 'ºC'),
	(65128, 111, '2015-02-15 00:38:42.000000', 'temperatura', 175.0000, 'ºC'),
	(65129, 111, '2015-02-15 00:38:43.000000', 'temperatura', 371.0000, 'ºC'),
	(65130, 111, '2015-02-15 00:38:44.000000', 'temperatura', 129.0000, 'ºC'),
	(65131, 111, '2015-02-15 00:38:45.000000', 'temperatura', 736.0000, 'ºC'),
	(65132, 111, '2015-02-15 00:38:46.000000', 'temperatura', 891.0000, 'ºC'),
	(65133, 111, '2015-02-15 00:38:47.000000', 'temperatura', 1048.0000, 'ºC'),
	(65134, 111, '2015-02-15 00:38:48.000000', 'temperatura', 169.0000, 'ºC'),
	(65135, 111, '2015-02-15 00:38:49.000000', 'temperatura', 101.0000, 'ºC'),
	(65136, 111, '2015-02-15 00:38:50.000000', 'temperatura', 0.0000, 'ºC'),
	(65137, 111, '2015-02-15 00:38:51.000000', 'temperatura', 895.0000, 'ºC'),
	(65138, 111, '2015-02-15 00:38:52.000000', 'temperatura', 875.0000, 'ºC'),
	(65139, 111, '2015-02-15 00:38:53.000000', 'temperatura', 492.0000, 'ºC'),
	(65140, 111, '2015-02-15 00:38:54.000000', 'temperatura', 1035.0000, 'ºC'),
	(65141, 111, '2015-02-15 00:38:55.000000', 'temperatura', 100.0000, 'ºC'),
	(65142, 111, '2015-02-15 00:38:56.000000', 'temperatura', 996.0000, 'ºC'),
	(65143, 111, '2015-02-15 00:38:57.000000', 'temperatura', 1078.0000, 'ºC'),
	(65144, 111, '2015-02-15 00:38:58.000000', 'temperatura', 4.0000, 'ºC'),
	(65145, 111, '2015-02-15 00:38:59.000000', 'temperatura', 385.0000, 'ºC'),
	(65146, 111, '2015-02-15 00:39:00.000000', 'temperatura', 714.0000, 'ºC'),
	(65147, 111, '2015-02-15 00:39:01.000000', 'temperatura', 15.0000, 'ºC'),
	(65148, 111, '2015-02-15 00:39:02.000000', 'temperatura', 336.0000, 'ºC'),
	(65149, 111, '2015-02-15 00:39:03.000000', 'temperatura', 435.0000, 'ºC'),
	(65150, 111, '2015-02-15 00:39:04.000000', 'temperatura', 1165.0000, 'ºC'),
	(65151, 111, '2015-02-15 00:39:05.000000', 'temperatura', 923.0000, 'ºC'),
	(65152, 111, '2015-02-15 00:39:06.000000', 'temperatura', 1120.0000, 'ºC'),
	(65153, 111, '2015-02-15 00:39:07.000000', 'temperatura', 430.0000, 'ºC'),
	(65154, 111, '2015-02-15 00:39:08.000000', 'temperatura', 1191.0000, 'ºC'),
	(65155, 111, '2015-02-15 00:39:09.000000', 'temperatura', 1067.0000, 'ºC'),
	(65156, 111, '2015-02-15 00:39:10.000000', 'temperatura', 563.0000, 'ºC'),
	(65157, 111, '2015-02-15 00:39:11.000000', 'temperatura', 813.0000, 'ºC'),
	(65158, 111, '2015-02-15 00:39:12.000000', 'temperatura', 1178.0000, 'ºC'),
	(65159, 111, '2015-02-15 00:39:13.000000', 'temperatura', 1052.0000, 'ºC'),
	(65160, 111, '2015-02-15 00:39:14.000000', 'temperatura', 527.0000, 'ºC'),
	(65161, 111, '2015-02-15 00:39:15.000000', 'temperatura', 680.0000, 'ºC'),
	(65162, 111, '2015-02-15 00:39:16.000000', 'temperatura', 617.0000, 'ºC'),
	(65163, 111, '2015-02-15 00:39:17.000000', 'temperatura', 1045.0000, 'ºC'),
	(65164, 111, '2015-02-15 00:39:18.000000', 'temperatura', 975.0000, 'ºC'),
	(65165, 111, '2015-02-15 00:39:19.000000', 'temperatura', 541.0000, 'ºC'),
	(65166, 111, '2015-02-15 00:39:20.000000', 'temperatura', 979.0000, 'ºC'),
	(65167, 111, '2015-02-15 00:39:21.000000', 'temperatura', 872.0000, 'ºC'),
	(65168, 111, '2015-02-15 00:39:22.000000', 'temperatura', 224.0000, 'ºC'),
	(65169, 111, '2015-02-15 00:39:23.000000', 'temperatura', 906.0000, 'ºC'),
	(65170, 111, '2015-02-15 00:39:24.000000', 'temperatura', 256.0000, 'ºC'),
	(65171, 111, '2015-02-15 00:39:25.000000', 'temperatura', 962.0000, 'ºC'),
	(65172, 111, '2015-02-15 00:39:26.000000', 'temperatura', 443.0000, 'ºC'),
	(65173, 111, '2015-02-15 00:39:27.000000', 'temperatura', 530.0000, 'ºC'),
	(65174, 111, '2015-02-15 00:39:28.000000', 'temperatura', 121.0000, 'ºC'),
	(65175, 111, '2015-02-15 00:39:29.000000', 'temperatura', 218.0000, 'ºC'),
	(65176, 111, '2015-02-15 00:39:30.000000', 'temperatura', 725.0000, 'ºC'),
	(65177, 111, '2015-02-15 00:39:31.000000', 'temperatura', 570.0000, 'ºC'),
	(65178, 111, '2015-02-15 00:39:32.000000', 'temperatura', 677.0000, 'ºC'),
	(65179, 111, '2015-02-15 00:39:33.000000', 'temperatura', 478.0000, 'ºC'),
	(65180, 111, '2015-02-15 00:39:34.000000', 'temperatura', 356.0000, 'ºC'),
	(65181, 111, '2015-02-15 00:39:35.000000', 'temperatura', 348.0000, 'ºC'),
	(65182, 111, '2015-02-15 00:39:36.000000', 'temperatura', 674.0000, 'ºC'),
	(65183, 111, '2015-02-15 00:39:37.000000', 'temperatura', 1127.0000, 'ºC'),
	(65184, 111, '2015-02-15 00:39:38.000000', 'temperatura', 12.0000, 'ºC'),
	(65185, 111, '2015-02-15 00:39:39.000000', 'temperatura', 278.0000, 'ºC'),
	(65186, 111, '2015-02-15 00:39:40.000000', 'temperatura', 157.0000, 'ºC'),
	(65187, 111, '2015-02-15 00:39:41.000000', 'temperatura', 1151.0000, 'ºC'),
	(65188, 111, '2015-02-15 00:39:42.000000', 'temperatura', 486.0000, 'ºC'),
	(65189, 111, '2015-02-15 00:39:43.000000', 'temperatura', 176.0000, 'ºC'),
	(65190, 111, '2015-02-15 00:39:44.000000', 'temperatura', 624.0000, 'ºC'),
	(65191, 111, '2015-02-15 00:39:45.000000', 'temperatura', 194.0000, 'ºC'),
	(65192, 111, '2015-02-15 00:39:46.000000', 'temperatura', 295.0000, 'ºC'),
	(65193, 111, '2015-02-15 00:39:47.000000', 'temperatura', 893.0000, 'ºC'),
	(65194, 111, '2015-02-15 00:39:48.000000', 'temperatura', 1183.0000, 'ºC'),
	(65195, 111, '2015-02-15 00:39:49.000000', 'temperatura', 837.0000, 'ºC'),
	(65196, 111, '2015-02-15 00:39:50.000000', 'temperatura', 635.0000, 'ºC'),
	(65197, 111, '2015-02-15 00:39:51.000000', 'temperatura', 664.0000, 'ºC'),
	(65198, 111, '2015-02-15 00:39:52.000000', 'temperatura', 215.0000, 'ºC'),
	(65199, 111, '2015-02-15 00:39:53.000000', 'temperatura', 286.0000, 'ºC'),
	(65200, 111, '2015-02-15 00:39:54.000000', 'temperatura', 785.0000, 'ºC'),
	(65201, 111, '2015-02-15 00:39:55.000000', 'temperatura', 665.0000, 'ºC'),
	(65202, 111, '2015-02-15 00:39:56.000000', 'temperatura', 973.0000, 'ºC'),
	(65203, 111, '2015-02-15 00:39:57.000000', 'temperatura', 470.0000, 'ºC'),
	(65204, 111, '2015-02-15 00:39:58.000000', 'temperatura', 633.0000, 'ºC'),
	(65205, 111, '2015-02-15 00:39:59.000000', 'temperatura', 556.0000, 'ºC'),
	(65206, 111, '2015-02-15 00:40:00.000000', 'temperatura', 879.0000, 'ºC'),
	(65207, 111, '2015-02-15 00:40:01.000000', 'temperatura', 329.0000, 'ºC'),
	(65208, 111, '2015-02-15 00:40:02.000000', 'temperatura', 210.0000, 'ºC'),
	(65209, 111, '2015-02-15 00:40:03.000000', 'temperatura', 63.0000, 'ºC'),
	(65210, 111, '2015-02-15 00:40:04.000000', 'temperatura', 883.0000, 'ºC'),
	(65211, 111, '2015-02-15 00:40:05.000000', 'temperatura', 627.0000, 'ºC'),
	(65212, 111, '2015-02-15 00:40:06.000000', 'temperatura', 488.0000, 'ºC'),
	(65213, 111, '2015-02-15 00:40:07.000000', 'temperatura', 557.0000, 'ºC'),
	(65214, 111, '2015-02-15 00:40:08.000000', 'temperatura', 123.0000, 'ºC'),
	(65215, 111, '2015-02-15 00:40:09.000000', 'temperatura', 145.0000, 'ºC'),
	(65216, 111, '2015-02-15 00:40:10.000000', 'temperatura', 358.0000, 'ºC'),
	(65217, 111, '2015-02-15 00:40:11.000000', 'temperatura', 153.0000, 'ºC'),
	(65218, 111, '2015-02-15 00:40:12.000000', 'temperatura', 892.0000, 'ºC'),
	(65219, 111, '2015-02-15 00:40:13.000000', 'temperatura', 403.0000, 'ºC'),
	(65220, 111, '2015-02-15 00:40:14.000000', 'temperatura', 537.0000, 'ºC'),
	(65221, 111, '2015-02-15 00:40:15.000000', 'temperatura', 279.0000, 'ºC'),
	(65222, 111, '2015-02-15 00:40:16.000000', 'temperatura', 982.0000, 'ºC'),
	(65223, 111, '2015-02-15 00:40:17.000000', 'temperatura', 474.0000, 'ºC'),
	(65224, 111, '2015-02-15 00:40:18.000000', 'temperatura', 627.0000, 'ºC'),
	(65225, 111, '2015-02-15 00:40:19.000000', 'temperatura', 511.0000, 'ºC'),
	(65226, 111, '2015-02-15 00:40:20.000000', 'temperatura', 675.0000, 'ºC'),
	(65227, 111, '2015-02-15 00:40:21.000000', 'temperatura', 641.0000, 'ºC'),
	(65228, 111, '2015-02-15 00:40:22.000000', 'temperatura', 1182.0000, 'ºC'),
	(65229, 111, '2015-02-15 00:40:23.000000', 'temperatura', 386.0000, 'ºC'),
	(65230, 111, '2015-02-15 00:40:24.000000', 'temperatura', 786.0000, 'ºC'),
	(65231, 111, '2015-02-15 00:40:25.000000', 'temperatura', 371.0000, 'ºC'),
	(65232, 111, '2015-02-15 00:40:26.000000', 'temperatura', 699.0000, 'ºC'),
	(65233, 111, '2015-02-15 00:40:27.000000', 'temperatura', 1183.0000, 'ºC'),
	(65234, 111, '2015-02-15 00:40:28.000000', 'temperatura', 216.0000, 'ºC'),
	(65235, 111, '2015-02-15 00:40:29.000000', 'temperatura', 1135.0000, 'ºC'),
	(65236, 111, '2015-02-15 00:40:30.000000', 'temperatura', 225.0000, 'ºC'),
	(65237, 111, '2015-02-15 00:40:31.000000', 'temperatura', 122.0000, 'ºC'),
	(65238, 111, '2015-02-15 00:40:32.000000', 'temperatura', 1134.0000, 'ºC'),
	(65239, 111, '2015-02-15 00:40:33.000000', 'temperatura', 504.0000, 'ºC'),
	(65240, 111, '2015-02-15 00:40:34.000000', 'temperatura', 319.0000, 'ºC'),
	(65241, 111, '2015-02-15 00:40:35.000000', 'temperatura', 84.0000, 'ºC'),
	(65242, 111, '2015-02-15 00:40:36.000000', 'temperatura', 661.0000, 'ºC'),
	(65243, 111, '2015-02-15 00:40:37.000000', 'temperatura', 657.0000, 'ºC'),
	(65244, 111, '2015-02-15 00:40:38.000000', 'temperatura', 99.0000, 'ºC'),
	(65245, 111, '2015-02-15 00:40:39.000000', 'temperatura', 926.0000, 'ºC'),
	(65246, 111, '2015-02-15 00:40:40.000000', 'temperatura', 736.0000, 'ºC'),
	(65247, 111, '2015-02-15 00:40:41.000000', 'temperatura', 899.0000, 'ºC'),
	(65248, 111, '2015-02-15 00:40:42.000000', 'temperatura', 1089.0000, 'ºC'),
	(65249, 111, '2015-02-15 00:40:43.000000', 'temperatura', 350.0000, 'ºC'),
	(65250, 111, '2015-02-15 00:40:44.000000', 'temperatura', 883.0000, 'ºC'),
	(65251, 111, '2015-02-15 00:40:45.000000', 'temperatura', 966.0000, 'ºC'),
	(65252, 111, '2015-02-15 00:40:46.000000', 'temperatura', 980.0000, 'ºC'),
	(65253, 111, '2015-02-15 00:40:47.000000', 'temperatura', 803.0000, 'ºC'),
	(65254, 111, '2015-02-15 00:40:48.000000', 'temperatura', 1074.0000, 'ºC'),
	(65255, 111, '2015-02-15 00:40:49.000000', 'temperatura', 564.0000, 'ºC'),
	(65256, 111, '2015-02-15 00:40:50.000000', 'temperatura', 798.0000, 'ºC'),
	(65257, 111, '2015-02-15 00:40:51.000000', 'temperatura', 1097.0000, 'ºC'),
	(65258, 111, '2015-02-15 00:40:52.000000', 'temperatura', 692.0000, 'ºC'),
	(65259, 111, '2015-02-15 00:40:53.000000', 'temperatura', 171.0000, 'ºC'),
	(65260, 111, '2015-02-15 00:40:54.000000', 'temperatura', 1179.0000, 'ºC'),
	(65261, 111, '2015-02-15 00:40:55.000000', 'temperatura', 584.0000, 'ºC'),
	(65262, 111, '2015-02-15 00:40:56.000000', 'temperatura', 582.0000, 'ºC'),
	(65263, 111, '2015-02-15 00:40:57.000000', 'temperatura', 1160.0000, 'ºC'),
	(65264, 111, '2015-02-15 00:40:58.000000', 'temperatura', 454.0000, 'ºC'),
	(65265, 111, '2015-02-15 00:40:59.000000', 'temperatura', 1189.0000, 'ºC'),
	(65266, 111, '2015-02-15 00:41:00.000000', 'temperatura', 983.0000, 'ºC'),
	(65267, 111, '2015-02-15 00:41:01.000000', 'temperatura', 149.0000, 'ºC'),
	(65268, 111, '2015-02-15 00:41:02.000000', 'temperatura', 198.0000, 'ºC'),
	(65269, 111, '2015-02-15 00:41:03.000000', 'temperatura', 542.0000, 'ºC'),
	(65270, 111, '2015-02-15 00:41:04.000000', 'temperatura', 916.0000, 'ºC'),
	(65271, 111, '2015-02-15 00:41:05.000000', 'temperatura', 554.0000, 'ºC'),
	(65272, 111, '2015-02-15 00:41:06.000000', 'temperatura', 24.0000, 'ºC'),
	(65273, 111, '2015-02-15 00:41:07.000000', 'temperatura', 858.0000, 'ºC'),
	(65274, 111, '2015-02-15 00:41:08.000000', 'temperatura', 620.0000, 'ºC'),
	(65275, 111, '2015-02-15 00:41:09.000000', 'temperatura', 526.0000, 'ºC'),
	(65276, 111, '2015-02-15 00:41:10.000000', 'temperatura', 771.0000, 'ºC'),
	(65277, 111, '2015-02-15 00:41:11.000000', 'temperatura', 1078.0000, 'ºC'),
	(65278, 111, '2015-02-15 00:41:12.000000', 'temperatura', 677.0000, 'ºC'),
	(65279, 111, '2015-02-15 00:41:13.000000', 'temperatura', 153.0000, 'ºC'),
	(65280, 111, '2015-02-15 00:41:14.000000', 'temperatura', 1132.0000, 'ºC'),
	(65281, 111, '2015-02-15 00:41:15.000000', 'temperatura', 404.0000, 'ºC'),
	(65282, 111, '2015-02-15 00:41:16.000000', 'temperatura', 1022.0000, 'ºC'),
	(65283, 111, '2015-02-15 00:41:17.000000', 'temperatura', 301.0000, 'ºC'),
	(65284, 111, '2015-02-15 00:41:18.000000', 'temperatura', 839.0000, 'ºC'),
	(65285, 111, '2015-02-15 00:41:19.000000', 'temperatura', 891.0000, 'ºC'),
	(65286, 111, '2015-02-15 00:41:20.000000', 'temperatura', 738.0000, 'ºC'),
	(65287, 111, '2015-02-15 00:41:21.000000', 'temperatura', 1018.0000, 'ºC'),
	(65288, 111, '2015-02-15 00:41:22.000000', 'temperatura', 475.0000, 'ºC'),
	(65289, 111, '2015-02-15 00:41:23.000000', 'temperatura', 524.0000, 'ºC'),
	(65290, 111, '2015-02-15 00:41:24.000000', 'temperatura', 1193.0000, 'ºC'),
	(65291, 111, '2015-02-15 00:41:25.000000', 'temperatura', 794.0000, 'ºC'),
	(65292, 111, '2015-02-15 00:41:26.000000', 'temperatura', 393.0000, 'ºC'),
	(65293, 111, '2015-02-15 00:41:27.000000', 'temperatura', 784.0000, 'ºC'),
	(65294, 111, '2015-02-15 00:41:28.000000', 'temperatura', 340.0000, 'ºC'),
	(65295, 111, '2015-02-15 00:41:29.000000', 'temperatura', 551.0000, 'ºC'),
	(65296, 111, '2015-02-15 00:41:30.000000', 'temperatura', 532.0000, 'ºC'),
	(65297, 111, '2015-02-15 00:41:31.000000', 'temperatura', 1009.0000, 'ºC'),
	(65298, 111, '2015-02-15 00:41:32.000000', 'temperatura', 1050.0000, 'ºC'),
	(65299, 111, '2015-02-15 00:41:33.000000', 'temperatura', 1025.0000, 'ºC'),
	(65300, 111, '2015-02-15 00:41:34.000000', 'temperatura', 773.0000, 'ºC'),
	(65301, 111, '2015-02-15 00:41:35.000000', 'temperatura', 793.0000, 'ºC'),
	(65302, 111, '2015-02-15 00:41:36.000000', 'temperatura', 446.0000, 'ºC'),
	(65303, 111, '2015-02-15 00:41:37.000000', 'temperatura', 1052.0000, 'ºC'),
	(65304, 111, '2015-02-15 00:41:38.000000', 'temperatura', 322.0000, 'ºC'),
	(65305, 111, '2015-02-15 00:41:39.000000', 'temperatura', 856.0000, 'ºC'),
	(65306, 111, '2015-02-15 00:41:40.000000', 'temperatura', 915.0000, 'ºC'),
	(65307, 111, '2015-02-15 00:41:41.000000', 'temperatura', 807.0000, 'ºC'),
	(65308, 111, '2015-02-15 00:41:42.000000', 'temperatura', 90.0000, 'ºC'),
	(65309, 111, '2015-02-15 00:41:43.000000', 'temperatura', 430.0000, 'ºC'),
	(65310, 111, '2015-02-15 00:41:44.000000', 'temperatura', 679.0000, 'ºC'),
	(65311, 111, '2015-02-15 00:41:45.000000', 'temperatura', 907.0000, 'ºC'),
	(65312, 111, '2015-02-15 00:41:46.000000', 'temperatura', 100.0000, 'ºC'),
	(65313, 111, '2015-02-15 00:41:47.000000', 'temperatura', 177.0000, 'ºC'),
	(65314, 111, '2015-02-15 00:41:48.000000', 'temperatura', 587.0000, 'ºC'),
	(65315, 111, '2015-02-15 00:41:49.000000', 'temperatura', 6.0000, 'ºC'),
	(65316, 111, '2015-02-15 00:41:50.000000', 'temperatura', 666.0000, 'ºC'),
	(65317, 111, '2015-02-15 00:41:51.000000', 'temperatura', 915.0000, 'ºC'),
	(65318, 111, '2015-02-15 00:41:52.000000', 'temperatura', 177.0000, 'ºC'),
	(65319, 111, '2015-02-15 00:41:53.000000', 'temperatura', 539.0000, 'ºC'),
	(65320, 111, '2015-02-15 00:41:54.000000', 'temperatura', 964.0000, 'ºC'),
	(65321, 111, '2015-02-15 00:41:55.000000', 'temperatura', 803.0000, 'ºC'),
	(65322, 111, '2015-02-15 00:41:56.000000', 'temperatura', 1125.0000, 'ºC'),
	(65323, 111, '2015-02-15 00:41:57.000000', 'temperatura', 817.0000, 'ºC'),
	(65324, 111, '2015-02-15 00:41:58.000000', 'temperatura', 708.0000, 'ºC'),
	(65325, 111, '2015-02-15 00:41:59.000000', 'temperatura', 1092.0000, 'ºC'),
	(65326, 111, '2015-02-15 00:42:00.000000', 'temperatura', 936.0000, 'ºC'),
	(65327, 111, '2015-02-15 00:42:01.000000', 'temperatura', 206.0000, 'ºC'),
	(65328, 111, '2015-02-15 00:42:02.000000', 'temperatura', 621.0000, 'ºC'),
	(65329, 111, '2015-02-15 00:42:03.000000', 'temperatura', 89.0000, 'ºC'),
	(65330, 111, '2015-02-15 00:42:04.000000', 'temperatura', 980.0000, 'ºC'),
	(65331, 111, '2015-02-15 00:42:05.000000', 'temperatura', 1033.0000, 'ºC'),
	(65332, 111, '2015-02-15 00:42:06.000000', 'temperatura', 1025.0000, 'ºC'),
	(65333, 111, '2015-02-15 00:42:07.000000', 'temperatura', 828.0000, 'ºC'),
	(65334, 111, '2015-02-15 00:42:08.000000', 'temperatura', 1066.0000, 'ºC'),
	(65335, 111, '2015-02-15 00:42:09.000000', 'temperatura', 444.0000, 'ºC'),
	(65336, 111, '2015-02-15 00:42:10.000000', 'temperatura', 224.0000, 'ºC'),
	(65337, 111, '2015-02-15 00:42:11.000000', 'temperatura', 987.0000, 'ºC'),
	(65338, 111, '2015-02-15 00:42:12.000000', 'temperatura', 665.0000, 'ºC'),
	(65339, 111, '2015-02-15 00:42:13.000000', 'temperatura', 362.0000, 'ºC'),
	(65340, 111, '2015-02-15 00:42:14.000000', 'temperatura', 1018.0000, 'ºC'),
	(65341, 111, '2015-02-15 00:42:15.000000', 'temperatura', 402.0000, 'ºC'),
	(65342, 111, '2015-02-15 00:42:16.000000', 'temperatura', 157.0000, 'ºC'),
	(65343, 111, '2015-02-15 00:42:17.000000', 'temperatura', 779.0000, 'ºC'),
	(65344, 111, '2015-02-15 00:42:18.000000', 'temperatura', 1024.0000, 'ºC'),
	(65345, 111, '2015-02-15 00:42:19.000000', 'temperatura', 385.0000, 'ºC'),
	(65346, 111, '2015-02-15 00:42:20.000000', 'temperatura', 52.0000, 'ºC'),
	(65347, 111, '2015-02-15 00:42:21.000000', 'temperatura', 307.0000, 'ºC'),
	(65348, 111, '2015-02-15 00:42:22.000000', 'temperatura', 180.0000, 'ºC'),
	(65349, 111, '2015-02-15 00:42:23.000000', 'temperatura', 1178.0000, 'ºC'),
	(65350, 111, '2015-02-15 00:42:24.000000', 'temperatura', 552.0000, 'ºC'),
	(65351, 111, '2015-02-15 00:42:25.000000', 'temperatura', 424.0000, 'ºC'),
	(65352, 111, '2015-02-15 00:42:26.000000', 'temperatura', 466.0000, 'ºC'),
	(65353, 111, '2015-02-15 00:42:27.000000', 'temperatura', 1057.0000, 'ºC'),
	(65354, 111, '2015-02-15 00:42:28.000000', 'temperatura', 290.0000, 'ºC'),
	(65355, 111, '2015-02-15 00:42:29.000000', 'temperatura', 677.0000, 'ºC'),
	(65356, 111, '2015-02-15 00:42:30.000000', 'temperatura', 116.0000, 'ºC'),
	(65357, 111, '2015-02-15 00:42:31.000000', 'temperatura', 950.0000, 'ºC'),
	(65358, 111, '2015-02-15 00:42:32.000000', 'temperatura', 803.0000, 'ºC'),
	(65359, 111, '2015-02-15 00:42:33.000000', 'temperatura', 1166.0000, 'ºC'),
	(65360, 111, '2015-02-15 00:42:34.000000', 'temperatura', 1022.0000, 'ºC'),
	(65361, 111, '2015-02-15 00:42:35.000000', 'temperatura', 412.0000, 'ºC'),
	(65362, 111, '2015-02-15 00:42:36.000000', 'temperatura', 194.0000, 'ºC'),
	(65363, 111, '2015-02-15 00:42:37.000000', 'temperatura', 937.0000, 'ºC'),
	(65364, 111, '2015-02-15 00:42:38.000000', 'temperatura', 500.0000, 'ºC'),
	(65365, 111, '2015-02-15 00:42:39.000000', 'temperatura', 891.0000, 'ºC'),
	(65366, 111, '2015-02-15 00:42:40.000000', 'temperatura', 556.0000, 'ºC'),
	(65367, 111, '2015-02-15 00:42:41.000000', 'temperatura', 109.0000, 'ºC'),
	(65368, 111, '2015-02-15 00:42:42.000000', 'temperatura', 75.0000, 'ºC'),
	(65369, 111, '2015-02-15 00:42:43.000000', 'temperatura', 48.0000, 'ºC'),
	(65370, 111, '2015-02-15 00:42:44.000000', 'temperatura', 16.0000, 'ºC'),
	(65371, 111, '2015-02-15 00:42:45.000000', 'temperatura', 1138.0000, 'ºC'),
	(65372, 111, '2015-02-15 00:42:46.000000', 'temperatura', 840.0000, 'ºC'),
	(65373, 111, '2015-02-15 00:42:47.000000', 'temperatura', 788.0000, 'ºC'),
	(65374, 111, '2015-02-15 00:42:48.000000', 'temperatura', 221.0000, 'ºC'),
	(65375, 111, '2015-02-15 00:42:49.000000', 'temperatura', 1141.0000, 'ºC'),
	(65376, 111, '2015-02-15 00:42:50.000000', 'temperatura', 245.0000, 'ºC'),
	(65377, 111, '2015-02-15 00:42:51.000000', 'temperatura', 199.0000, 'ºC'),
	(65378, 111, '2015-02-15 00:42:52.000000', 'temperatura', 262.0000, 'ºC'),
	(65379, 111, '2015-02-15 00:42:53.000000', 'temperatura', 713.0000, 'ºC'),
	(65380, 111, '2015-02-15 00:42:54.000000', 'temperatura', 381.0000, 'ºC'),
	(65381, 111, '2015-02-15 00:42:55.000000', 'temperatura', 966.0000, 'ºC'),
	(65382, 111, '2015-02-15 00:42:56.000000', 'temperatura', 87.0000, 'ºC'),
	(65383, 111, '2015-02-15 00:42:57.000000', 'temperatura', 1139.0000, 'ºC'),
	(65384, 111, '2015-02-15 00:42:58.000000', 'temperatura', 635.0000, 'ºC'),
	(65385, 111, '2015-02-15 00:42:59.000000', 'temperatura', 959.0000, 'ºC'),
	(65386, 111, '2015-02-15 00:43:00.000000', 'temperatura', 488.0000, 'ºC'),
	(65387, 111, '2015-02-15 00:43:01.000000', 'temperatura', 763.0000, 'ºC'),
	(65388, 111, '2015-02-15 00:43:02.000000', 'temperatura', 1152.0000, 'ºC'),
	(65389, 111, '2015-02-15 00:43:03.000000', 'temperatura', 1071.0000, 'ºC'),
	(65390, 111, '2015-02-15 00:43:04.000000', 'temperatura', 699.0000, 'ºC'),
	(65391, 111, '2015-02-15 00:43:05.000000', 'temperatura', 283.0000, 'ºC'),
	(65392, 111, '2015-02-15 00:43:06.000000', 'temperatura', 521.0000, 'ºC'),
	(65393, 111, '2015-02-15 00:43:07.000000', 'temperatura', 553.0000, 'ºC'),
	(65394, 111, '2015-02-15 00:43:08.000000', 'temperatura', 3.0000, 'ºC'),
	(65395, 111, '2015-02-15 00:43:09.000000', 'temperatura', 758.0000, 'ºC'),
	(65396, 111, '2015-02-15 00:43:10.000000', 'temperatura', 182.0000, 'ºC'),
	(65397, 111, '2015-02-15 00:43:11.000000', 'temperatura', 1036.0000, 'ºC'),
	(65398, 111, '2015-02-15 00:43:12.000000', 'temperatura', 1036.0000, 'ºC'),
	(65399, 111, '2015-02-15 00:43:13.000000', 'temperatura', 870.0000, 'ºC'),
	(65400, 111, '2015-02-15 00:43:14.000000', 'temperatura', 43.0000, 'ºC'),
	(65401, 111, '2015-02-15 00:43:15.000000', 'temperatura', 4.0000, 'ºC'),
	(65402, 111, '2015-02-15 00:43:16.000000', 'temperatura', 1091.0000, 'ºC'),
	(65403, 111, '2015-02-15 00:43:17.000000', 'temperatura', 646.0000, 'ºC'),
	(65404, 111, '2015-02-15 00:43:18.000000', 'temperatura', 1158.0000, 'ºC'),
	(65405, 111, '2015-02-15 00:43:19.000000', 'temperatura', 250.0000, 'ºC'),
	(65406, 111, '2015-02-15 00:43:20.000000', 'temperatura', 178.0000, 'ºC'),
	(65407, 111, '2015-02-15 00:43:21.000000', 'temperatura', 142.0000, 'ºC'),
	(65408, 111, '2015-02-15 00:43:22.000000', 'temperatura', 174.0000, 'ºC'),
	(65409, 111, '2015-02-15 00:43:23.000000', 'temperatura', 445.0000, 'ºC'),
	(65410, 111, '2015-02-15 00:43:24.000000', 'temperatura', 505.0000, 'ºC'),
	(65411, 111, '2015-02-15 00:43:25.000000', 'temperatura', 1188.0000, 'ºC'),
	(65412, 111, '2015-02-15 00:43:26.000000', 'temperatura', 826.0000, 'ºC'),
	(65413, 111, '2015-02-15 00:43:27.000000', 'temperatura', 568.0000, 'ºC'),
	(65414, 111, '2015-02-15 00:43:28.000000', 'temperatura', 361.0000, 'ºC'),
	(65415, 111, '2015-02-15 00:43:29.000000', 'temperatura', 100.0000, 'ºC'),
	(65416, 111, '2015-02-15 00:43:30.000000', 'temperatura', 620.0000, 'ºC'),
	(65417, 111, '2015-02-15 00:43:31.000000', 'temperatura', 399.0000, 'ºC'),
	(65418, 111, '2015-02-15 00:43:32.000000', 'temperatura', 134.0000, 'ºC'),
	(65419, 111, '2015-02-15 00:43:33.000000', 'temperatura', 676.0000, 'ºC'),
	(65420, 111, '2015-02-15 00:43:34.000000', 'temperatura', 578.0000, 'ºC'),
	(65421, 111, '2015-02-15 00:43:35.000000', 'temperatura', 863.0000, 'ºC'),
	(65422, 111, '2015-02-15 00:43:36.000000', 'temperatura', 182.0000, 'ºC'),
	(65423, 111, '2015-02-15 00:43:37.000000', 'temperatura', 720.0000, 'ºC'),
	(65424, 111, '2015-02-15 00:43:38.000000', 'temperatura', 657.0000, 'ºC'),
	(65425, 111, '2015-02-15 00:43:39.000000', 'temperatura', 1124.0000, 'ºC'),
	(65426, 111, '2015-02-15 00:43:40.000000', 'temperatura', 51.0000, 'ºC'),
	(65427, 111, '2015-02-15 00:43:41.000000', 'temperatura', 482.0000, 'ºC'),
	(65428, 111, '2015-02-15 00:43:42.000000', 'temperatura', 1056.0000, 'ºC'),
	(65429, 111, '2015-02-15 00:43:43.000000', 'temperatura', 238.0000, 'ºC'),
	(65430, 111, '2015-02-15 00:43:44.000000', 'temperatura', 420.0000, 'ºC'),
	(65431, 111, '2015-02-15 00:43:45.000000', 'temperatura', 186.0000, 'ºC'),
	(65432, 111, '2015-02-15 00:43:46.000000', 'temperatura', 871.0000, 'ºC'),
	(65433, 111, '2015-02-15 00:43:47.000000', 'temperatura', 200.0000, 'ºC'),
	(65434, 111, '2015-02-15 00:43:48.000000', 'temperatura', 785.0000, 'ºC'),
	(65435, 111, '2015-02-15 00:43:49.000000', 'temperatura', 926.0000, 'ºC'),
	(65436, 111, '2015-02-15 00:43:50.000000', 'temperatura', 1078.0000, 'ºC'),
	(65437, 111, '2015-02-15 00:43:51.000000', 'temperatura', 210.0000, 'ºC'),
	(65438, 111, '2015-02-15 00:43:52.000000', 'temperatura', 215.0000, 'ºC'),
	(65439, 111, '2015-02-15 00:43:53.000000', 'temperatura', 448.0000, 'ºC'),
	(65440, 111, '2015-02-15 00:43:54.000000', 'temperatura', 395.0000, 'ºC'),
	(65441, 111, '2015-02-15 00:43:55.000000', 'temperatura', 632.0000, 'ºC'),
	(65442, 111, '2015-02-15 00:43:56.000000', 'temperatura', 776.0000, 'ºC'),
	(65443, 111, '2015-02-15 00:43:57.000000', 'temperatura', 786.0000, 'ºC'),
	(65444, 111, '2015-02-15 00:43:58.000000', 'temperatura', 400.0000, 'ºC'),
	(65445, 111, '2015-02-15 00:43:59.000000', 'temperatura', 841.0000, 'ºC'),
	(65446, 111, '2015-02-15 00:44:00.000000', 'temperatura', 609.0000, 'ºC'),
	(65447, 111, '2015-02-15 00:44:01.000000', 'temperatura', 522.0000, 'ºC'),
	(65448, 111, '2015-02-15 00:44:02.000000', 'temperatura', 781.0000, 'ºC'),
	(65449, 111, '2015-02-15 00:44:03.000000', 'temperatura', 1142.0000, 'ºC'),
	(65450, 111, '2015-02-15 00:44:04.000000', 'temperatura', 967.0000, 'ºC'),
	(65451, 111, '2015-02-15 00:44:05.000000', 'temperatura', 210.0000, 'ºC'),
	(65452, 111, '2015-02-15 00:44:06.000000', 'temperatura', 551.0000, 'ºC'),
	(65453, 111, '2015-02-15 00:44:07.000000', 'temperatura', 923.0000, 'ºC'),
	(65454, 111, '2015-02-15 00:44:08.000000', 'temperatura', 561.0000, 'ºC'),
	(65455, 111, '2015-02-15 00:44:09.000000', 'temperatura', 39.0000, 'ºC'),
	(65456, 111, '2015-02-15 00:44:10.000000', 'temperatura', 912.0000, 'ºC'),
	(65457, 111, '2015-02-15 00:44:11.000000', 'temperatura', 844.0000, 'ºC'),
	(65458, 111, '2015-02-15 00:44:12.000000', 'temperatura', 283.0000, 'ºC'),
	(65459, 111, '2015-02-15 00:44:13.000000', 'temperatura', 86.0000, 'ºC'),
	(65460, 111, '2015-02-15 00:44:14.000000', 'temperatura', 781.0000, 'ºC'),
	(65461, 111, '2015-02-15 00:44:15.000000', 'temperatura', 48.0000, 'ºC'),
	(65462, 111, '2015-02-15 00:44:16.000000', 'temperatura', 296.0000, 'ºC'),
	(65463, 111, '2015-02-15 00:44:17.000000', 'temperatura', 137.0000, 'ºC'),
	(65464, 111, '2015-02-15 00:44:18.000000', 'temperatura', 1000.0000, 'ºC'),
	(65465, 111, '2015-02-15 00:44:19.000000', 'temperatura', 986.0000, 'ºC'),
	(65466, 111, '2015-02-15 00:44:20.000000', 'temperatura', 731.0000, 'ºC'),
	(65467, 111, '2015-02-15 00:44:21.000000', 'temperatura', 698.0000, 'ºC'),
	(65468, 111, '2015-02-15 00:44:22.000000', 'temperatura', 96.0000, 'ºC'),
	(65469, 111, '2015-02-15 00:44:23.000000', 'temperatura', 787.0000, 'ºC'),
	(65470, 111, '2015-02-15 00:44:24.000000', 'temperatura', 46.0000, 'ºC'),
	(65471, 111, '2015-02-15 00:44:25.000000', 'temperatura', 273.0000, 'ºC'),
	(65472, 111, '2015-02-15 00:44:26.000000', 'temperatura', 25.0000, 'ºC'),
	(65473, 111, '2015-02-15 00:44:27.000000', 'temperatura', 509.0000, 'ºC'),
	(65474, 111, '2015-02-15 00:44:28.000000', 'temperatura', 69.0000, 'ºC'),
	(65475, 111, '2015-02-15 00:44:29.000000', 'temperatura', 20.0000, 'ºC'),
	(65476, 111, '2015-02-15 00:44:30.000000', 'temperatura', 1091.0000, 'ºC'),
	(65477, 111, '2015-02-15 00:44:31.000000', 'temperatura', 599.0000, 'ºC'),
	(65478, 111, '2015-02-15 00:44:32.000000', 'temperatura', 919.0000, 'ºC'),
	(65479, 111, '2015-02-15 00:44:33.000000', 'temperatura', 400.0000, 'ºC'),
	(65480, 111, '2015-02-15 00:44:34.000000', 'temperatura', 444.0000, 'ºC'),
	(65481, 111, '2015-02-15 00:44:35.000000', 'temperatura', 1019.0000, 'ºC'),
	(65482, 111, '2015-02-15 00:44:36.000000', 'temperatura', 162.0000, 'ºC'),
	(65483, 111, '2015-02-15 00:44:37.000000', 'temperatura', 156.0000, 'ºC'),
	(65484, 111, '2015-02-15 00:44:38.000000', 'temperatura', 295.0000, 'ºC'),
	(65485, 111, '2015-02-15 00:44:39.000000', 'temperatura', 1005.0000, 'ºC'),
	(65486, 111, '2015-02-15 00:44:40.000000', 'temperatura', 541.0000, 'ºC'),
	(65487, 111, '2015-02-15 00:44:41.000000', 'temperatura', 890.0000, 'ºC'),
	(65488, 111, '2015-02-15 00:44:42.000000', 'temperatura', 427.0000, 'ºC'),
	(65489, 111, '2015-02-15 00:44:43.000000', 'temperatura', 667.0000, 'ºC'),
	(65490, 111, '2015-02-15 00:44:44.000000', 'temperatura', 852.0000, 'ºC'),
	(65491, 111, '2015-02-15 00:44:45.000000', 'temperatura', 1062.0000, 'ºC'),
	(65492, 111, '2015-02-15 00:44:46.000000', 'temperatura', 354.0000, 'ºC'),
	(65493, 111, '2015-02-15 00:44:47.000000', 'temperatura', 984.0000, 'ºC'),
	(65494, 111, '2015-02-15 00:44:48.000000', 'temperatura', 259.0000, 'ºC'),
	(65495, 111, '2015-02-15 00:44:49.000000', 'temperatura', 742.0000, 'ºC'),
	(65496, 111, '2015-02-15 00:44:50.000000', 'temperatura', 536.0000, 'ºC'),
	(65497, 111, '2015-02-15 00:44:51.000000', 'temperatura', 452.0000, 'ºC'),
	(65498, 111, '2015-02-15 00:44:52.000000', 'temperatura', 653.0000, 'ºC'),
	(65499, 111, '2015-02-15 00:44:53.000000', 'temperatura', 711.0000, 'ºC'),
	(65500, 111, '2015-02-15 00:44:54.000000', 'temperatura', 397.0000, 'ºC'),
	(65501, 111, '2015-02-15 00:44:55.000000', 'temperatura', 1050.0000, 'ºC'),
	(65502, 111, '2015-02-15 00:44:56.000000', 'temperatura', 459.0000, 'ºC'),
	(65503, 111, '2015-02-15 00:44:57.000000', 'temperatura', 348.0000, 'ºC'),
	(65504, 111, '2015-02-15 00:44:58.000000', 'temperatura', 363.0000, 'ºC'),
	(65505, 111, '2015-02-15 00:44:59.000000', 'temperatura', 771.0000, 'ºC'),
	(65506, 111, '2015-02-15 00:45:00.000000', 'temperatura', 368.0000, 'ºC'),
	(65507, 111, '2015-02-15 00:45:01.000000', 'temperatura', 726.0000, 'ºC'),
	(65508, 111, '2015-02-15 00:45:02.000000', 'temperatura', 129.0000, 'ºC'),
	(65509, 111, '2015-02-15 00:45:03.000000', 'temperatura', 864.0000, 'ºC'),
	(65510, 111, '2015-02-15 00:45:04.000000', 'temperatura', 335.0000, 'ºC'),
	(65511, 111, '2015-02-15 00:45:05.000000', 'temperatura', 282.0000, 'ºC'),
	(65512, 111, '2015-02-15 00:45:06.000000', 'temperatura', 407.0000, 'ºC'),
	(65513, 111, '2015-02-15 00:45:07.000000', 'temperatura', 1188.0000, 'ºC'),
	(65514, 111, '2015-02-15 00:45:08.000000', 'temperatura', 1120.0000, 'ºC'),
	(65515, 111, '2015-02-15 00:45:09.000000', 'temperatura', 835.0000, 'ºC'),
	(65516, 111, '2015-02-15 00:45:10.000000', 'temperatura', 818.0000, 'ºC'),
	(65517, 111, '2015-02-15 00:45:11.000000', 'temperatura', 384.0000, 'ºC'),
	(65518, 111, '2015-02-15 00:45:12.000000', 'temperatura', 668.0000, 'ºC'),
	(65519, 111, '2015-02-15 00:45:13.000000', 'temperatura', 986.0000, 'ºC'),
	(65520, 111, '2015-02-15 00:45:14.000000', 'temperatura', 527.0000, 'ºC'),
	(65521, 111, '2015-02-15 00:45:15.000000', 'temperatura', 879.0000, 'ºC'),
	(65522, 111, '2015-02-15 00:45:16.000000', 'temperatura', 412.0000, 'ºC'),
	(65523, 111, '2015-02-15 00:45:17.000000', 'temperatura', 626.0000, 'ºC'),
	(65524, 111, '2015-02-15 00:45:18.000000', 'temperatura', 692.0000, 'ºC'),
	(65525, 111, '2015-02-15 00:45:19.000000', 'temperatura', 386.0000, 'ºC'),
	(65526, 111, '2015-02-15 00:45:20.000000', 'temperatura', 1051.0000, 'ºC'),
	(65527, 111, '2015-02-15 00:45:21.000000', 'temperatura', 501.0000, 'ºC'),
	(65528, 111, '2015-02-15 00:45:22.000000', 'temperatura', 550.0000, 'ºC'),
	(65529, 111, '2015-02-15 00:45:23.000000', 'temperatura', 47.0000, 'ºC'),
	(65530, 111, '2015-02-15 00:45:24.000000', 'temperatura', 986.0000, 'ºC'),
	(65531, 111, '2015-02-15 00:45:25.000000', 'temperatura', 1190.0000, 'ºC'),
	(65532, 111, '2015-02-15 00:45:26.000000', 'temperatura', 592.0000, 'ºC'),
	(65533, 111, '2015-02-15 00:45:27.000000', 'temperatura', 590.0000, 'ºC'),
	(65534, 111, '2015-02-15 00:45:28.000000', 'temperatura', 1175.0000, 'ºC'),
	(65535, 111, '2015-02-15 00:45:29.000000', 'temperatura', 507.0000, 'ºC'),
	(65536, 111, '2015-02-15 00:45:30.000000', 'temperatura', 208.0000, 'ºC'),
	(65537, 111, '2015-02-15 00:45:31.000000', 'temperatura', 721.0000, 'ºC'),
	(65538, 111, '2015-02-15 00:45:32.000000', 'temperatura', 582.0000, 'ºC'),
	(65539, 111, '2015-02-15 00:45:33.000000', 'temperatura', 746.0000, 'ºC'),
	(65540, 111, '2015-02-15 00:45:34.000000', 'temperatura', 786.0000, 'ºC'),
	(65541, 111, '2015-02-15 00:45:35.000000', 'temperatura', 493.0000, 'ºC'),
	(65542, 111, '2015-02-15 00:45:36.000000', 'temperatura', 107.0000, 'ºC'),
	(65543, 111, '2015-02-15 00:45:37.000000', 'temperatura', 258.0000, 'ºC'),
	(65544, 111, '2015-02-15 00:45:38.000000', 'temperatura', 969.0000, 'ºC'),
	(65545, 111, '2015-02-15 00:45:39.000000', 'temperatura', 472.0000, 'ºC'),
	(65546, 111, '2015-02-15 00:45:40.000000', 'temperatura', 654.0000, 'ºC'),
	(65547, 111, '2015-02-15 00:45:41.000000', 'temperatura', 654.0000, 'ºC'),
	(65548, 111, '2015-02-15 00:45:42.000000', 'temperatura', 107.0000, 'ºC'),
	(65549, 111, '2015-02-15 00:45:43.000000', 'temperatura', 975.0000, 'ºC'),
	(65550, 111, '2015-02-15 00:45:44.000000', 'temperatura', 952.0000, 'ºC'),
	(65551, 111, '2015-02-15 00:45:45.000000', 'temperatura', 639.0000, 'ºC'),
	(65552, 111, '2015-02-15 00:45:46.000000', 'temperatura', 336.0000, 'ºC'),
	(65553, 111, '2015-02-15 00:45:47.000000', 'temperatura', 966.0000, 'ºC'),
	(65554, 111, '2015-02-15 00:45:48.000000', 'temperatura', 221.0000, 'ºC'),
	(65555, 111, '2015-02-15 00:45:49.000000', 'temperatura', 608.0000, 'ºC'),
	(65556, 111, '2015-02-15 00:45:50.000000', 'temperatura', 1176.0000, 'ºC'),
	(65557, 111, '2015-02-15 00:45:51.000000', 'temperatura', 457.0000, 'ºC'),
	(65558, 111, '2015-02-15 00:45:52.000000', 'temperatura', 1157.0000, 'ºC'),
	(65559, 111, '2015-02-15 00:45:53.000000', 'temperatura', 813.0000, 'ºC'),
	(65560, 111, '2015-02-15 00:45:54.000000', 'temperatura', 597.0000, 'ºC'),
	(65561, 111, '2015-02-15 00:45:55.000000', 'temperatura', 548.0000, 'ºC'),
	(65562, 111, '2015-02-15 00:45:56.000000', 'temperatura', 947.0000, 'ºC'),
	(65563, 111, '2015-02-15 00:45:57.000000', 'temperatura', 693.0000, 'ºC'),
	(65564, 111, '2015-02-15 00:45:58.000000', 'temperatura', 625.0000, 'ºC'),
	(65565, 111, '2015-02-15 00:45:59.000000', 'temperatura', 1045.0000, 'ºC'),
	(65566, 111, '2015-02-15 00:46:00.000000', 'temperatura', 952.0000, 'ºC'),
	(65567, 111, '2015-02-15 00:46:01.000000', 'temperatura', 423.0000, 'ºC'),
	(65568, 111, '2015-02-15 00:46:02.000000', 'temperatura', 463.0000, 'ºC'),
	(65569, 111, '2015-02-15 00:46:03.000000', 'temperatura', 1044.0000, 'ºC'),
	(65570, 111, '2015-02-15 00:46:04.000000', 'temperatura', 231.0000, 'ºC'),
	(65571, 111, '2015-02-15 00:46:05.000000', 'temperatura', 425.0000, 'ºC'),
	(65572, 111, '2015-02-15 00:46:06.000000', 'temperatura', 233.0000, 'ºC'),
	(65573, 111, '2015-02-15 00:46:07.000000', 'temperatura', 1091.0000, 'ºC'),
	(65574, 111, '2015-02-15 00:46:08.000000', 'temperatura', 1155.0000, 'ºC'),
	(65575, 111, '2015-02-15 00:46:09.000000', 'temperatura', 101.0000, 'ºC'),
	(65576, 111, '2015-02-15 00:46:10.000000', 'temperatura', 643.0000, 'ºC'),
	(65577, 111, '2015-02-15 00:46:11.000000', 'temperatura', 512.0000, 'ºC'),
	(65578, 111, '2015-02-15 00:46:12.000000', 'temperatura', 633.0000, 'ºC'),
	(65579, 111, '2015-02-15 00:46:13.000000', 'temperatura', 428.0000, 'ºC'),
	(65580, 111, '2015-02-15 00:46:14.000000', 'temperatura', 240.0000, 'ºC'),
	(65581, 111, '2015-02-15 00:46:15.000000', 'temperatura', 1116.0000, 'ºC'),
	(65582, 111, '2015-02-15 00:46:16.000000', 'temperatura', 62.0000, 'ºC'),
	(65583, 111, '2015-02-15 00:46:17.000000', 'temperatura', 564.0000, 'ºC'),
	(65584, 111, '2015-02-15 00:46:18.000000', 'temperatura', 231.0000, 'ºC'),
	(65585, 111, '2015-02-15 00:46:19.000000', 'temperatura', 666.0000, 'ºC'),
	(65586, 111, '2015-02-15 00:46:20.000000', 'temperatura', 236.0000, 'ºC'),
	(65587, 111, '2015-02-15 00:46:21.000000', 'temperatura', 383.0000, 'ºC'),
	(65588, 111, '2015-02-15 00:46:22.000000', 'temperatura', 8.0000, 'ºC'),
	(65589, 111, '2015-02-15 00:46:23.000000', 'temperatura', 90.0000, 'ºC'),
	(65590, 111, '2015-02-15 00:46:24.000000', 'temperatura', 427.0000, 'ºC'),
	(65591, 111, '2015-02-15 00:46:25.000000', 'temperatura', 664.0000, 'ºC'),
	(65592, 111, '2015-02-15 00:46:26.000000', 'temperatura', 840.0000, 'ºC'),
	(65593, 111, '2015-02-15 00:46:27.000000', 'temperatura', 1011.0000, 'ºC'),
	(65594, 111, '2015-02-15 00:46:28.000000', 'temperatura', 133.0000, 'ºC'),
	(65595, 111, '2015-02-15 00:46:29.000000', 'temperatura', 34.0000, 'ºC'),
	(65596, 111, '2015-02-15 00:46:30.000000', 'temperatura', 969.0000, 'ºC'),
	(65597, 111, '2015-02-15 00:46:31.000000', 'temperatura', 1146.0000, 'ºC'),
	(65598, 111, '2015-02-15 00:46:32.000000', 'temperatura', 421.0000, 'ºC'),
	(65599, 111, '2015-02-15 00:46:33.000000', 'temperatura', 1067.0000, 'ºC'),
	(65600, 111, '2015-02-15 00:46:34.000000', 'temperatura', 474.0000, 'ºC'),
	(65601, 111, '2015-02-15 00:46:35.000000', 'temperatura', 367.0000, 'ºC'),
	(65602, 111, '2015-02-15 00:46:36.000000', 'temperatura', 416.0000, 'ºC'),
	(65603, 111, '2015-02-15 00:46:37.000000', 'temperatura', 979.0000, 'ºC'),
	(65604, 111, '2015-02-15 00:46:38.000000', 'temperatura', 49.0000, 'ºC'),
	(65605, 111, '2015-02-15 00:46:39.000000', 'temperatura', 909.0000, 'ºC'),
	(65606, 111, '2015-02-15 00:46:40.000000', 'temperatura', 798.0000, 'ºC'),
	(65607, 111, '2015-02-15 00:46:41.000000', 'temperatura', 63.0000, 'ºC'),
	(65608, 111, '2015-02-15 00:46:42.000000', 'temperatura', 320.0000, 'ºC'),
	(65609, 111, '2015-02-15 00:46:43.000000', 'temperatura', 214.0000, 'ºC'),
	(65610, 111, '2015-02-15 00:46:44.000000', 'temperatura', 111.0000, 'ºC'),
	(65611, 111, '2015-02-15 00:46:45.000000', 'temperatura', 1112.0000, 'ºC'),
	(65612, 111, '2015-02-15 00:46:46.000000', 'temperatura', 427.0000, 'ºC'),
	(65613, 111, '2015-02-15 00:46:47.000000', 'temperatura', 1.0000, 'ºC'),
	(65614, 111, '2015-02-15 00:46:48.000000', 'temperatura', 1126.0000, 'ºC'),
	(65615, 111, '2015-02-15 00:46:49.000000', 'temperatura', 825.0000, 'ºC'),
	(65616, 111, '2015-02-15 00:46:50.000000', 'temperatura', 746.0000, 'ºC'),
	(65617, 111, '2015-02-15 00:46:51.000000', 'temperatura', 59.0000, 'ºC'),
	(65618, 111, '2015-02-15 00:46:52.000000', 'temperatura', 455.0000, 'ºC'),
	(65619, 111, '2015-02-15 00:46:53.000000', 'temperatura', 898.0000, 'ºC'),
	(65620, 111, '2015-02-15 00:46:54.000000', 'temperatura', 727.0000, 'ºC'),
	(65621, 111, '2015-02-15 00:46:55.000000', 'temperatura', 939.0000, 'ºC'),
	(65622, 111, '2015-02-15 00:46:56.000000', 'temperatura', 117.0000, 'ºC'),
	(65623, 111, '2015-02-15 00:46:57.000000', 'temperatura', 167.0000, 'ºC'),
	(65624, 111, '2015-02-15 00:46:58.000000', 'temperatura', 487.0000, 'ºC'),
	(65625, 111, '2015-02-15 00:46:59.000000', 'temperatura', 733.0000, 'ºC'),
	(65626, 111, '2015-02-15 00:47:00.000000', 'temperatura', 1006.0000, 'ºC'),
	(65627, 111, '2015-02-15 00:47:01.000000', 'temperatura', 431.0000, 'ºC'),
	(65628, 111, '2015-02-15 00:47:02.000000', 'temperatura', 336.0000, 'ºC'),
	(65629, 111, '2015-02-15 00:47:03.000000', 'temperatura', 389.0000, 'ºC'),
	(65630, 111, '2015-02-15 00:47:04.000000', 'temperatura', 936.0000, 'ºC'),
	(65631, 111, '2015-02-15 00:47:05.000000', 'temperatura', 1113.0000, 'ºC'),
	(65632, 111, '2015-02-15 00:47:06.000000', 'temperatura', 358.0000, 'ºC'),
	(65633, 111, '2015-02-15 00:47:07.000000', 'temperatura', 852.0000, 'ºC'),
	(65634, 111, '2015-02-15 00:47:08.000000', 'temperatura', 786.0000, 'ºC'),
	(65635, 111, '2015-02-15 00:47:09.000000', 'temperatura', 175.0000, 'ºC'),
	(65636, 111, '2015-02-15 00:47:10.000000', 'temperatura', 915.0000, 'ºC'),
	(65637, 111, '2015-02-15 00:47:11.000000', 'temperatura', 454.0000, 'ºC'),
	(65638, 111, '2015-02-15 00:47:12.000000', 'temperatura', 725.0000, 'ºC'),
	(65639, 111, '2015-02-15 00:47:13.000000', 'temperatura', 1063.0000, 'ºC'),
	(65640, 111, '2015-02-15 00:47:14.000000', 'temperatura', 739.0000, 'ºC'),
	(65641, 111, '2015-02-15 00:47:15.000000', 'temperatura', 505.0000, 'ºC'),
	(65642, 111, '2015-02-15 00:47:16.000000', 'temperatura', 312.0000, 'ºC'),
	(65643, 111, '2015-02-15 00:47:17.000000', 'temperatura', 44.0000, 'ºC'),
	(65644, 111, '2015-02-15 00:47:18.000000', 'temperatura', 486.0000, 'ºC'),
	(65645, 111, '2015-02-15 00:47:19.000000', 'temperatura', 1098.0000, 'ºC'),
	(65646, 111, '2015-02-15 00:47:20.000000', 'temperatura', 433.0000, 'ºC'),
	(65647, 111, '2015-02-15 00:47:21.000000', 'temperatura', 72.0000, 'ºC'),
	(65648, 111, '2015-02-15 00:47:22.000000', 'temperatura', 260.0000, 'ºC'),
	(65649, 111, '2015-02-15 00:47:23.000000', 'temperatura', 1087.0000, 'ºC'),
	(65650, 111, '2015-02-15 00:47:24.000000', 'temperatura', 1054.0000, 'ºC'),
	(65651, 111, '2015-02-15 00:47:25.000000', 'temperatura', 808.0000, 'ºC'),
	(65652, 111, '2015-02-15 00:47:26.000000', 'temperatura', 880.0000, 'ºC'),
	(65653, 111, '2015-02-15 00:47:27.000000', 'temperatura', 777.0000, 'ºC'),
	(65654, 111, '2015-02-15 00:47:28.000000', 'temperatura', 45.0000, 'ºC'),
	(65655, 111, '2015-02-15 00:47:29.000000', 'temperatura', 296.0000, 'ºC'),
	(65656, 111, '2015-02-15 00:47:30.000000', 'temperatura', 145.0000, 'ºC'),
	(65657, 111, '2015-02-15 00:47:31.000000', 'temperatura', 1036.0000, 'ºC'),
	(65658, 111, '2015-02-15 00:47:32.000000', 'temperatura', 1144.0000, 'ºC'),
	(65659, 111, '2015-02-15 00:47:33.000000', 'temperatura', 216.0000, 'ºC'),
	(65660, 111, '2015-02-15 00:47:34.000000', 'temperatura', 46.0000, 'ºC'),
	(65661, 111, '2015-02-15 00:47:35.000000', 'temperatura', 781.0000, 'ºC'),
	(65662, 111, '2015-02-15 00:47:36.000000', 'temperatura', 171.0000, 'ºC'),
	(65663, 111, '2015-02-15 00:47:37.000000', 'temperatura', 909.0000, 'ºC'),
	(65664, 111, '2015-02-15 00:47:38.000000', 'temperatura', 434.0000, 'ºC'),
	(65665, 111, '2015-02-15 00:47:39.000000', 'temperatura', 646.0000, 'ºC'),
	(65666, 111, '2015-02-15 00:47:40.000000', 'temperatura', 725.0000, 'ºC'),
	(65667, 111, '2015-02-15 00:47:41.000000', 'temperatura', 488.0000, 'ºC'),
	(65668, 111, '2015-02-15 00:47:42.000000', 'temperatura', 267.0000, 'ºC'),
	(65669, 111, '2015-02-15 00:47:43.000000', 'temperatura', 1070.0000, 'ºC'),
	(65670, 111, '2015-02-15 00:47:44.000000', 'temperatura', 951.0000, 'ºC'),
	(65671, 111, '2015-02-15 00:47:45.000000', 'temperatura', 347.0000, 'ºC'),
	(65672, 111, '2015-02-15 00:47:46.000000', 'temperatura', 79.0000, 'ºC'),
	(65673, 111, '2015-02-15 00:47:47.000000', 'temperatura', 558.0000, 'ºC'),
	(65674, 111, '2015-02-15 00:47:48.000000', 'temperatura', 150.0000, 'ºC'),
	(65675, 111, '2015-02-15 00:47:49.000000', 'temperatura', 280.0000, 'ºC'),
	(65676, 111, '2015-02-15 00:47:50.000000', 'temperatura', 948.0000, 'ºC'),
	(65677, 111, '2015-02-15 00:47:51.000000', 'temperatura', 303.0000, 'ºC'),
	(65678, 111, '2015-02-15 00:47:52.000000', 'temperatura', 1071.0000, 'ºC'),
	(65679, 111, '2015-02-15 00:47:53.000000', 'temperatura', 847.0000, 'ºC'),
	(65680, 111, '2015-02-15 00:47:54.000000', 'temperatura', 1022.0000, 'ºC'),
	(65681, 111, '2015-02-15 00:47:55.000000', 'temperatura', 168.0000, 'ºC'),
	(65682, 111, '2015-02-15 00:47:56.000000', 'temperatura', 175.0000, 'ºC'),
	(65683, 111, '2015-02-15 00:47:57.000000', 'temperatura', 371.0000, 'ºC'),
	(65684, 111, '2015-02-15 00:47:58.000000', 'temperatura', 129.0000, 'ºC'),
	(65685, 111, '2015-02-15 00:47:59.000000', 'temperatura', 735.0000, 'ºC'),
	(65686, 111, '2015-02-15 00:48:00.000000', 'temperatura', 889.0000, 'ºC'),
	(65687, 111, '2015-02-15 00:48:01.000000', 'temperatura', 1041.0000, 'ºC'),
	(65688, 111, '2015-02-15 00:48:02.000000', 'temperatura', 139.0000, 'ºC'),
	(65689, 111, '2015-02-15 00:48:03.000000', 'temperatura', 1171.0000, 'ºC'),
	(65690, 111, '2015-02-15 00:48:04.000000', 'temperatura', 637.0000, 'ºC'),
	(65691, 111, '2015-02-15 00:48:05.000000', 'temperatura', 873.0000, 'ºC'),
	(65692, 111, '2015-02-15 00:48:06.000000', 'temperatura', 53.0000, 'ºC'),
	(65693, 111, '2015-02-15 00:48:07.000000', 'temperatura', 49.0000, 'ºC'),
	(65694, 111, '2015-02-15 00:48:08.000000', 'temperatura', 85.0000, 'ºC'),
	(65695, 111, '2015-02-15 00:48:09.000000', 'temperatura', 281.0000, 'ºC'),
	(65696, 111, '2015-02-15 00:48:10.000000', 'temperatura', 1149.0000, 'ºC'),
	(65697, 111, '2015-02-15 00:48:11.000000', 'temperatura', 101.0000, 'ºC'),
	(65698, 111, '2015-02-15 00:48:12.000000', 'temperatura', 660.0000, 'ºC'),
	(65699, 111, '2015-02-15 00:48:13.000000', 'temperatura', 595.0000, 'ºC'),
	(65700, 111, '2015-02-15 00:48:14.000000', 'temperatura', 999.0000, 'ºC'),
	(65701, 111, '2015-02-15 00:48:15.000000', 'temperatura', 808.0000, 'ºC'),
	(65702, 111, '2015-02-15 00:48:16.000000', 'temperatura', 1044.0000, 'ºC'),
	(65703, 111, '2015-02-15 00:48:17.000000', 'temperatura', 396.0000, 'ºC'),
	(65704, 111, '2015-02-15 00:48:18.000000', 'temperatura', 48.0000, 'ºC'),
	(65705, 111, '2015-02-15 00:48:19.000000', 'temperatura', 253.0000, 'ºC'),
	(65706, 111, '2015-02-15 00:48:20.000000', 'temperatura', 1120.0000, 'ºC'),
	(65707, 111, '2015-02-15 00:48:21.000000', 'temperatura', 42.0000, 'ºC'),
	(65708, 111, '2015-02-15 00:48:22.000000', 'temperatura', 450.0000, 'ºC'),
	(65709, 111, '2015-02-15 00:48:23.000000', 'temperatura', 924.0000, 'ºC'),
	(65710, 111, '2015-02-15 00:48:24.000000', 'temperatura', 872.0000, 'ºC'),
	(65711, 111, '2015-02-15 00:48:25.000000', 'temperatura', 388.0000, 'ºC'),
	(65712, 111, '2015-02-15 00:48:26.000000', 'temperatura', 523.0000, 'ºC'),
	(65713, 111, '2015-02-15 00:48:27.000000', 'temperatura', 254.0000, 'ºC'),
	(65714, 111, '2015-02-15 00:48:28.000000', 'temperatura', 901.0000, 'ºC'),
	(65715, 111, '2015-02-15 00:48:29.000000', 'temperatura', 144.0000, 'ºC'),
	(65716, 111, '2015-02-15 00:48:30.000000', 'temperatura', 418.0000, 'ºC'),
	(65717, 111, '2015-02-15 00:48:31.000000', 'temperatura', 459.0000, 'ºC'),
	(65718, 111, '2015-02-15 00:48:32.000000', 'temperatura', 1042.0000, 'ºC'),
	(65719, 111, '2015-02-15 00:48:33.000000', 'temperatura', 233.0000, 'ºC'),
	(65720, 111, '2015-02-15 00:48:34.000000', 'temperatura', 437.0000, 'ºC'),
	(65721, 111, '2015-02-15 00:48:35.000000', 'temperatura', 290.0000, 'ºC'),
	(65722, 111, '2015-02-15 00:48:36.000000', 'temperatura', 138.0000, 'ºC'),
	(65723, 111, '2015-02-15 00:48:37.000000', 'temperatura', 1022.0000, 'ºC'),
	(65724, 111, '2015-02-15 00:48:38.000000', 'temperatura', 1096.0000, 'ºC'),
	(65725, 111, '2015-02-15 00:48:39.000000', 'temperatura', 16.0000, 'ºC'),
	(65726, 111, '2015-02-15 00:48:40.000000', 'temperatura', 392.0000, 'ºC'),
	(65727, 111, '2015-02-15 00:48:41.000000', 'temperatura', 714.0000, 'ºC'),
	(65728, 111, '2015-02-15 00:48:42.000000', 'temperatura', 1192.0000, 'ºC'),
	(65729, 111, '2015-02-15 00:48:43.000000', 'temperatura', 221.0000, 'ºC'),
	(65730, 111, '2015-02-15 00:48:44.000000', 'temperatura', 1129.0000, 'ºC'),
	(65731, 111, '2015-02-15 00:48:45.000000', 'temperatura', 181.0000, 'ºC'),
	(65732, 111, '2015-02-15 00:48:46.000000', 'temperatura', 1119.0000, 'ºC'),
	(65733, 111, '2015-02-15 00:48:47.000000', 'temperatura', 254.0000, 'ºC'),
	(65734, 111, '2015-02-15 00:48:48.000000', 'temperatura', 312.0000, 'ºC'),
	(65735, 111, '2015-02-15 00:48:49.000000', 'temperatura', 797.0000, 'ºC'),
	(65736, 111, '2015-02-15 00:48:50.000000', 'temperatura', 650.0000, 'ºC'),
	(65737, 111, '2015-02-15 00:48:51.000000', 'temperatura', 859.0000, 'ºC'),
	(65738, 111, '2015-02-15 00:48:52.000000', 'temperatura', 1145.0000, 'ºC'),
	(65739, 111, '2015-02-15 00:48:53.000000', 'temperatura', 749.0000, 'ºC'),
	(65740, 111, '2015-02-15 00:48:54.000000', 'temperatura', 311.0000, 'ºC'),
	(65741, 111, '2015-02-15 00:48:55.000000', 'temperatura', 509.0000, 'ºC'),
	(65742, 111, '2015-02-15 00:48:56.000000', 'temperatura', 411.0000, 'ºC'),
	(65743, 111, '2015-02-15 00:48:57.000000', 'temperatura', 531.0000, 'ºC'),
	(65744, 111, '2015-02-15 00:48:58.000000', 'temperatura', 222.0000, 'ºC'),
	(65745, 111, '2015-02-15 00:48:59.000000', 'temperatura', 718.0000, 'ºC'),
	(65746, 111, '2015-02-15 00:49:00.000000', 'temperatura', 526.0000, 'ºC'),
	(65747, 111, '2015-02-15 00:49:01.000000', 'temperatura', 473.0000, 'ºC'),
	(65748, 111, '2015-02-15 00:49:02.000000', 'temperatura', 789.0000, 'ºC'),
	(65749, 111, '2015-02-15 00:49:03.000000', 'temperatura', 125.0000, 'ºC'),
	(65750, 111, '2015-02-15 00:49:04.000000', 'temperatura', 658.0000, 'ºC'),
	(65751, 111, '2015-02-15 00:49:05.000000', 'temperatura', 515.0000, 'ºC'),
	(65752, 111, '2015-02-15 00:49:06.000000', 'temperatura', 604.0000, 'ºC'),
	(65753, 111, '2015-02-15 00:49:07.000000', 'temperatura', 273.0000, 'ºC'),
	(65754, 111, '2015-02-15 00:49:08.000000', 'temperatura', 755.0000, 'ºC'),
	(65755, 111, '2015-02-15 00:49:09.000000', 'temperatura', 556.0000, 'ºC'),
	(65756, 111, '2015-02-15 00:49:10.000000', 'temperatura', 515.0000, 'ºC'),
	(65757, 111, '2015-02-15 00:49:11.000000', 'temperatura', 909.0000, 'ºC'),
	(65758, 111, '2015-02-15 00:49:12.000000', 'temperatura', 599.0000, 'ºC'),
	(65759, 111, '2015-02-15 00:49:13.000000', 'temperatura', 268.0000, 'ºC'),
	(65760, 111, '2015-02-15 00:49:14.000000', 'temperatura', 746.0000, 'ºC'),
	(65761, 111, '2015-02-15 00:49:15.000000', 'temperatura', 525.0000, 'ºC'),
	(65762, 111, '2015-02-15 00:49:16.000000', 'temperatura', 386.0000, 'ºC'),
	(65763, 111, '2015-02-15 00:49:17.000000', 'temperatura', 359.0000, 'ºC'),
	(65764, 111, '2015-02-15 00:49:18.000000', 'temperatura', 634.0000, 'ºC'),
	(65765, 111, '2015-02-15 00:49:19.000000', 'temperatura', 894.0000, 'ºC'),
	(65766, 111, '2015-02-15 00:49:20.000000', 'temperatura', 169.0000, 'ºC'),
	(65767, 111, '2015-02-15 00:49:21.000000', 'temperatura', 563.0000, 'ºC'),
	(65768, 111, '2015-02-15 00:49:22.000000', 'temperatura', 1108.0000, 'ºC'),
	(65769, 111, '2015-02-15 00:49:23.000000', 'temperatura', 253.0000, 'ºC'),
	(65770, 111, '2015-02-15 00:49:24.000000', 'temperatura', 341.0000, 'ºC'),
	(65771, 111, '2015-02-15 00:49:25.000000', 'temperatura', 947.0000, 'ºC'),
	(65772, 111, '2015-02-15 00:49:26.000000', 'temperatura', 112.0000, 'ºC'),
	(65773, 111, '2015-02-15 00:49:27.000000', 'temperatura', 119.0000, 'ºC'),
	(65774, 111, '2015-02-15 00:49:28.000000', 'temperatura', 258.0000, 'ºC'),
	(65775, 111, '2015-02-15 00:49:29.000000', 'temperatura', 937.0000, 'ºC'),
	(65776, 111, '2015-02-15 00:49:30.000000', 'temperatura', 309.0000, 'ºC'),
	(65777, 111, '2015-02-15 00:49:31.000000', 'temperatura', 1136.0000, 'ºC'),
	(65778, 111, '2015-02-15 00:49:32.000000', 'temperatura', 1151.0000, 'ºC'),
	(65779, 111, '2015-02-15 00:49:33.000000', 'temperatura', 1151.0000, 'ºC'),
	(65780, 111, '2015-02-15 00:49:34.000000', 'temperatura', 1100.0000, 'ºC'),
	(65781, 111, '2015-02-15 00:49:35.000000', 'temperatura', 848.0000, 'ºC'),
	(65782, 111, '2015-02-15 00:49:36.000000', 'temperatura', 942.0000, 'ºC'),
	(65783, 111, '2015-02-15 00:49:37.000000', 'temperatura', 965.0000, 'ºC'),
	(65784, 111, '2015-02-15 00:49:38.000000', 'temperatura', 800.0000, 'ºC'),
	(65785, 111, '2015-02-15 00:49:39.000000', 'temperatura', 1106.0000, 'ºC'),
	(65786, 111, '2015-02-15 00:49:40.000000', 'temperatura', 728.0000, 'ºC'),
	(65787, 111, '2015-02-15 00:49:41.000000', 'temperatura', 325.0000, 'ºC'),
	(65788, 111, '2015-02-15 00:49:42.000000', 'temperatura', 641.0000, 'ºC'),
	(65789, 111, '2015-02-15 00:49:43.000000', 'temperatura', 1029.0000, 'ºC'),
	(65790, 111, '2015-02-15 00:49:44.000000', 'temperatura', 823.0000, 'ºC'),
	(65791, 111, '2015-02-15 00:49:45.000000', 'temperatura', 1029.0000, 'ºC'),
	(65792, 111, '2015-02-15 00:49:46.000000', 'temperatura', 278.0000, 'ºC'),
	(65793, 111, '2015-02-15 00:49:47.000000', 'temperatura', 702.0000, 'ºC'),
	(65794, 111, '2015-02-15 00:49:48.000000', 'temperatura', 278.0000, 'ºC'),
	(65795, 111, '2015-02-15 00:49:49.000000', 'temperatura', 483.0000, 'ºC'),
	(65796, 111, '2015-02-15 00:49:50.000000', 'temperatura', 384.0000, 'ºC'),
	(65797, 111, '2015-02-15 00:49:51.000000', 'temperatura', 470.0000, 'ºC'),
	(65798, 111, '2015-02-15 00:49:52.000000', 'temperatura', 1196.0000, 'ºC'),
	(65799, 111, '2015-02-15 00:49:53.000000', 'temperatura', 974.0000, 'ºC'),
	(65800, 111, '2015-02-15 00:49:54.000000', 'temperatura', 83.0000, 'ºC'),
	(65801, 111, '2015-02-15 00:49:55.000000', 'temperatura', 1092.0000, 'ºC'),
	(65802, 111, '2015-02-15 00:49:56.000000', 'temperatura', 412.0000, 'ºC'),
	(65803, 111, '2015-02-15 00:49:57.000000', 'temperatura', 1183.0000, 'ºC'),
	(65804, 111, '2015-02-15 00:49:58.000000', 'temperatura', 1081.0000, 'ºC'),
	(65805, 111, '2015-02-15 00:49:59.000000', 'temperatura', 656.0000, 'ºC'),
	(65806, 111, '2015-02-15 00:50:00.000000', 'temperatura', 39.0000, 'ºC'),
	(65807, 111, '2015-02-15 00:50:01.000000', 'temperatura', 626.0000, 'ºC'),
	(65808, 111, '2015-02-15 00:50:02.000000', 'temperatura', 613.0000, 'ºC'),
	(65809, 111, '2015-02-15 00:50:03.000000', 'temperatura', 1186.0000, 'ºC'),
	(65810, 111, '2015-02-15 00:50:04.000000', 'temperatura', 493.0000, 'ºC'),
	(65811, 111, '2015-02-15 00:50:05.000000', 'temperatura', 106.0000, 'ºC'),
	(65812, 111, '2015-02-15 00:50:06.000000', 'temperatura', 254.0000, 'ºC'),
	(65813, 111, '2015-02-15 00:50:07.000000', 'temperatura', 950.0000, 'ºC'),
	(65814, 111, '2015-02-15 00:50:08.000000', 'temperatura', 392.0000, 'ºC'),
	(65815, 111, '2015-02-15 00:50:09.000000', 'temperatura', 307.0000, 'ºC'),
	(65816, 111, '2015-02-15 00:50:10.000000', 'temperatura', 361.0000, 'ºC'),
	(65817, 111, '2015-02-15 00:50:11.000000', 'temperatura', 884.0000, 'ºC'),
	(65818, 111, '2015-02-15 00:50:12.000000', 'temperatura', 938.0000, 'ºC'),
	(65819, 111, '2015-02-15 00:50:13.000000', 'temperatura', 839.0000, 'ºC'),
	(65820, 111, '2015-02-15 00:50:14.000000', 'temperatura', 181.0000, 'ºC'),
	(65821, 111, '2015-02-15 00:50:15.000000', 'temperatura', 787.0000, 'ºC'),
	(65822, 111, '2015-02-15 00:50:16.000000', 'temperatura', 992.0000, 'ºC'),
	(65823, 111, '2015-02-15 00:50:17.000000', 'temperatura', 200.0000, 'ºC'),
	(65824, 111, '2015-02-15 00:50:18.000000', 'temperatura', 425.0000, 'ºC'),
	(65825, 111, '2015-02-15 00:50:19.000000', 'temperatura', 327.0000, 'ºC'),
	(65826, 111, '2015-02-15 00:50:20.000000', 'temperatura', 358.0000, 'ºC'),
	(65827, 111, '2015-02-15 00:50:21.000000', 'temperatura', 812.0000, 'ºC'),
	(65828, 111, '2015-02-15 00:50:22.000000', 'temperatura', 587.0000, 'ºC'),
	(65829, 111, '2015-02-15 00:50:23.000000', 'temperatura', 499.0000, 'ºC'),
	(65830, 111, '2015-02-15 00:50:24.000000', 'temperatura', 733.0000, 'ºC'),
	(65831, 111, '2015-02-15 00:50:25.000000', 'temperatura', 970.0000, 'ºC'),
	(65832, 111, '2015-02-15 00:50:26.000000', 'temperatura', 253.0000, 'ºC'),
	(65833, 111, '2015-02-15 00:50:27.000000', 'temperatura', 753.0000, 'ºC'),
	(65834, 111, '2015-02-15 00:50:28.000000', 'temperatura', 608.0000, 'ºC'),
	(65835, 111, '2015-02-15 00:50:29.000000', 'temperatura', 779.0000, 'ºC'),
	(65836, 111, '2015-02-15 00:50:30.000000', 'temperatura', 874.0000, 'ºC'),
	(65837, 111, '2015-02-15 00:50:31.000000', 'temperatura', 832.0000, 'ºC'),
	(65838, 111, '2015-02-15 00:50:32.000000', 'temperatura', 341.0000, 'ºC'),
	(65839, 111, '2015-02-15 00:50:33.000000', 'temperatura', 408.0000, 'ºC'),
	(65840, 111, '2015-02-15 00:50:34.000000', 'temperatura', 1016.0000, 'ºC'),
	(65841, 111, '2015-02-15 00:50:35.000000', 'temperatura', 258.0000, 'ºC'),
	(65842, 111, '2015-02-15 00:50:36.000000', 'temperatura', 642.0000, 'ºC'),
	(65843, 111, '2015-02-15 00:50:37.000000', 'temperatura', 37.0000, 'ºC'),
	(65844, 111, '2015-02-15 00:50:38.000000', 'temperatura', 661.0000, 'ºC'),
	(65845, 111, '2015-02-15 00:50:39.000000', 'temperatura', 794.0000, 'ºC'),
	(65846, 111, '2015-02-15 00:50:40.000000', 'temperatura', 788.0000, 'ºC'),
	(65847, 111, '2015-02-15 00:50:41.000000', 'temperatura', 357.0000, 'ºC'),
	(65848, 111, '2015-02-15 00:50:42.000000', 'temperatura', 620.0000, 'ºC'),
	(65849, 111, '2015-02-15 00:50:43.000000', 'temperatura', 832.0000, 'ºC'),
	(65850, 111, '2015-02-15 00:50:44.000000', 'temperatura', 1099.0000, 'ºC'),
	(65851, 111, '2015-02-15 00:50:45.000000', 'temperatura', 599.0000, 'ºC'),
	(65852, 111, '2015-02-15 00:50:46.000000', 'temperatura', 899.0000, 'ºC'),
	(65853, 111, '2015-02-15 00:50:47.000000', 'temperatura', 300.0000, 'ºC'),
	(65854, 111, '2015-02-15 00:50:48.000000', 'temperatura', 2.0000, 'ºC'),
	(65855, 111, '2015-02-15 00:50:49.000000', 'temperatura', 311.0000, 'ºC'),
	(65856, 111, '2015-02-15 00:50:50.000000', 'temperatura', 349.0000, 'ºC'),
	(65857, 111, '2015-02-15 00:50:51.000000', 'temperatura', 814.0000, 'ºC'),
	(65858, 111, '2015-02-15 00:50:52.000000', 'temperatura', 624.0000, 'ºC'),
	(65859, 111, '2015-02-15 00:50:53.000000', 'temperatura', 676.0000, 'ºC'),
	(65860, 111, '2015-02-15 00:50:54.000000', 'temperatura', 310.0000, 'ºC'),
	(65861, 111, '2015-02-15 00:50:55.000000', 'temperatura', 724.0000, 'ºC'),
	(65862, 111, '2015-02-15 00:50:56.000000', 'temperatura', 291.0000, 'ºC'),
	(65863, 111, '2015-02-15 00:50:57.000000', 'temperatura', 481.0000, 'ºC'),
	(65864, 111, '2015-02-15 00:50:58.000000', 'temperatura', 334.0000, 'ºC'),
	(65865, 111, '2015-02-15 00:50:59.000000', 'temperatura', 226.0000, 'ºC'),
	(65866, 111, '2015-02-15 00:51:00.000000', 'temperatura', 128.0000, 'ºC'),
	(65867, 111, '2015-02-15 00:51:01.000000', 'temperatura', 1165.0000, 'ºC'),
	(65868, 111, '2015-02-15 00:51:02.000000', 'temperatura', 641.0000, 'ºC'),
	(65869, 111, '2015-02-15 00:51:03.000000', 'temperatura', 911.0000, 'ºC'),
	(65870, 111, '2015-02-15 00:51:04.000000', 'temperatura', 232.0000, 'ºC'),
	(65871, 111, '2015-02-15 00:51:05.000000', 'temperatura', 829.0000, 'ºC'),
	(65872, 111, '2015-02-15 00:51:06.000000', 'temperatura', 1050.0000, 'ºC'),
	(65873, 111, '2015-02-15 00:51:07.000000', 'temperatura', 364.0000, 'ºC'),
	(65874, 111, '2015-02-15 00:51:08.000000', 'temperatura', 1068.0000, 'ºC'),
	(65875, 111, '2015-02-15 00:51:09.000000', 'temperatura', 650.0000, 'ºC'),
	(65876, 111, '2015-02-15 00:51:10.000000', 'temperatura', 48.0000, 'ºC'),
	(65877, 111, '2015-02-15 00:51:11.000000', 'temperatura', 688.0000, 'ºC'),
	(65878, 111, '2015-02-15 00:51:12.000000', 'temperatura', 899.0000, 'ºC'),
	(65879, 111, '2015-02-15 00:51:13.000000', 'temperatura', 30.0000, 'ºC'),
	(65880, 111, '2015-02-15 00:51:14.000000', 'temperatura', 1055.0000, 'ºC'),
	(65881, 111, '2015-02-15 00:51:15.000000', 'temperatura', 384.0000, 'ºC'),
	(65882, 111, '2015-02-15 00:51:16.000000', 'temperatura', 1155.0000, 'ºC'),
	(65883, 111, '2015-02-15 00:51:17.000000', 'temperatura', 1025.0000, 'ºC'),
	(65884, 111, '2015-02-15 00:51:18.000000', 'temperatura', 460.0000, 'ºC'),
	(65885, 111, '2015-02-15 00:51:19.000000', 'temperatura', 427.0000, 'ºC'),
	(65886, 111, '2015-02-15 00:51:20.000000', 'temperatura', 755.0000, 'ºC'),
	(65887, 111, '2015-02-15 00:51:21.000000', 'temperatura', 93.0000, 'ºC'),
	(65888, 111, '2015-02-15 00:51:22.000000', 'temperatura', 602.0000, 'ºC'),
	(65889, 111, '2015-02-15 00:51:23.000000', 'temperatura', 333.0000, 'ºC'),
	(65890, 111, '2015-02-15 00:51:24.000000', 'temperatura', 1058.0000, 'ºC'),
	(65891, 111, '2015-02-15 00:51:25.000000', 'temperatura', 692.0000, 'ºC'),
	(65892, 111, '2015-02-15 00:51:26.000000', 'temperatura', 287.0000, 'ºC'),
	(65893, 111, '2015-02-15 00:51:27.000000', 'temperatura', 557.0000, 'ºC'),
	(65894, 111, '2015-02-15 00:51:28.000000', 'temperatura', 727.0000, 'ºC'),
	(65895, 111, '2015-02-15 00:51:29.000000', 'temperatura', 763.0000, 'ºC'),
	(65896, 111, '2015-02-15 00:51:30.000000', 'temperatura', 437.0000, 'ºC'),
	(65897, 111, '2015-02-15 00:51:31.000000', 'temperatura', 1093.0000, 'ºC'),
	(65898, 111, '2015-02-15 00:51:32.000000', 'temperatura', 556.0000, 'ºC'),
	(65899, 111, '2015-02-15 00:51:33.000000', 'temperatura', 700.0000, 'ºC'),
	(65900, 111, '2015-02-15 00:51:34.000000', 'temperatura', 635.0000, 'ºC'),
	(65901, 111, '2015-02-15 00:51:35.000000', 'temperatura', 1076.0000, 'ºC'),
	(65902, 111, '2015-02-15 00:51:36.000000', 'temperatura', 1074.0000, 'ºC'),
	(65903, 111, '2015-02-15 00:51:37.000000', 'temperatura', 942.0000, 'ºC'),
	(65904, 111, '2015-02-15 00:51:38.000000', 'temperatura', 290.0000, 'ºC'),
	(65905, 111, '2015-02-15 00:51:39.000000', 'temperatura', 1024.0000, 'ºC'),
	(65906, 111, '2015-02-15 00:51:40.000000', 'temperatura', 652.0000, 'ºC'),
	(65907, 111, '2015-02-15 00:51:41.000000', 'temperatura', 189.0000, 'ºC'),
	(65908, 111, '2015-02-15 00:51:42.000000', 'temperatura', 190.0000, 'ºC'),
	(65909, 111, '2015-02-15 00:51:43.000000', 'temperatura', 381.0000, 'ºC'),
	(65910, 111, '2015-02-15 00:51:44.000000', 'temperatura', 137.0000, 'ºC'),
	(65911, 111, '2015-02-15 00:51:45.000000', 'temperatura', 741.0000, 'ºC'),
	(65912, 111, '2015-02-15 00:51:46.000000', 'temperatura', 894.0000, 'ºC'),
	(65913, 111, '2015-02-15 00:51:47.000000', 'temperatura', 1049.0000, 'ºC'),
	(65914, 111, '2015-02-15 00:51:48.000000', 'temperatura', 161.0000, 'ºC'),
	(65915, 111, '2015-02-15 00:51:49.000000', 'temperatura', 61.0000, 'ºC'),
	(65916, 111, '2015-02-15 00:51:50.000000', 'temperatura', 1022.0000, 'ºC'),
	(65917, 111, '2015-02-15 00:51:51.000000', 'temperatura', 126.0000, 'ºC'),
	(65918, 111, '2015-02-15 00:51:52.000000', 'temperatura', 1165.0000, 'ºC'),
	(65919, 111, '2015-02-15 00:51:53.000000', 'temperatura', 647.0000, 'ºC'),
	(65920, 111, '2015-02-15 00:51:54.000000', 'temperatura', 942.0000, 'ºC'),
	(65921, 111, '2015-02-15 00:51:55.000000', 'temperatura', 371.0000, 'ºC'),
	(65922, 111, '2015-02-15 00:51:56.000000', 'temperatura', 228.0000, 'ºC'),
	(65923, 111, '2015-02-15 00:51:57.000000', 'temperatura', 26.0000, 'ºC'),
	(65924, 111, '2015-02-15 00:51:58.000000', 'temperatura', 647.0000, 'ºC'),
	(65925, 111, '2015-02-15 00:51:59.000000', 'temperatura', 756.0000, 'ºC'),
	(65926, 111, '2015-02-15 00:52:00.000000', 'temperatura', 640.0000, 'ºC'),
	(65927, 111, '2015-02-15 00:52:01.000000', 'temperatura', 932.0000, 'ºC'),
	(65928, 111, '2015-02-15 00:52:02.000000', 'temperatura', 343.0000, 'ºC'),
	(65929, 111, '2015-02-15 00:52:03.000000', 'temperatura', 119.0000, 'ºC'),
	(65930, 111, '2015-02-15 00:52:04.000000', 'temperatura', 764.0000, 'ºC'),
	(65931, 111, '2015-02-15 00:52:05.000000', 'temperatura', 1065.0000, 'ºC'),
	(65932, 111, '2015-02-15 00:52:06.000000', 'temperatura', 634.0000, 'ºC'),
	(65933, 111, '2015-02-15 00:52:07.000000', 'temperatura', 1173.0000, 'ºC'),
	(65934, 111, '2015-02-15 00:52:08.000000', 'temperatura', 365.0000, 'ºC'),
	(65935, 111, '2015-02-15 00:52:09.000000', 'temperatura', 706.0000, 'ºC'),
	(65936, 111, '2015-02-15 00:52:10.000000', 'temperatura', 38.0000, 'ºC'),
	(65937, 111, '2015-02-15 00:52:11.000000', 'temperatura', 469.0000, 'ºC'),
	(65938, 111, '2015-02-15 00:52:12.000000', 'temperatura', 1033.0000, 'ºC'),
	(65939, 111, '2015-02-15 00:52:13.000000', 'temperatura', 157.0000, 'ºC'),
	(65940, 111, '2015-02-15 00:52:14.000000', 'temperatura', 89.0000, 'ºC'),
	(65941, 111, '2015-02-15 00:52:15.000000', 'temperatura', 1175.0000, 'ºC'),
	(65942, 111, '2015-02-15 00:52:16.000000', 'temperatura', 806.0000, 'ºC'),
	(65943, 111, '2015-02-15 00:52:17.000000', 'temperatura', 507.0000, 'ºC'),
	(65944, 111, '2015-02-15 00:52:18.000000', 'temperatura', 117.0000, 'ºC'),
	(65945, 111, '2015-02-15 00:52:19.000000', 'temperatura', 263.0000, 'ºC'),
	(65946, 111, '2015-02-15 00:52:20.000000', 'temperatura', 965.0000, 'ºC'),
	(65947, 111, '2015-02-15 00:52:21.000000', 'temperatura', 435.0000, 'ºC'),
	(65948, 111, '2015-02-15 00:52:22.000000', 'temperatura', 482.0000, 'ºC'),
	(65949, 111, '2015-02-15 00:52:23.000000', 'temperatura', 1106.0000, 'ºC'),
	(65950, 111, '2015-02-15 00:52:24.000000', 'temperatura', 483.0000, 'ºC'),
	(65951, 111, '2015-02-15 00:52:25.000000', 'temperatura', 296.0000, 'ºC'),
	(65952, 111, '2015-02-15 00:52:26.000000', 'temperatura', 35.0000, 'ºC'),
	(65953, 111, '2015-02-15 00:52:27.000000', 'temperatura', 485.0000, 'ºC'),
	(65954, 111, '2015-02-15 00:52:28.000000', 'temperatura', 1121.0000, 'ºC'),
	(65955, 111, '2015-02-15 00:52:29.000000', 'temperatura', 551.0000, 'ºC'),
	(65956, 111, '2015-02-15 00:52:30.000000', 'temperatura', 593.0000, 'ºC'),
	(65957, 111, '2015-02-15 00:52:31.000000', 'temperatura', 113.0000, 'ºC'),
	(65958, 111, '2015-02-15 00:52:32.000000', 'temperatura', 1184.0000, 'ºC'),
	(65959, 111, '2015-02-15 00:52:33.000000', 'temperatura', 782.0000, 'ºC'),
	(65960, 111, '2015-02-15 00:52:34.000000', 'temperatura', 359.0000, 'ºC'),
	(65961, 111, '2015-02-15 00:52:35.000000', 'temperatura', 650.0000, 'ºC'),
	(65962, 111, '2015-02-15 00:52:36.000000', 'temperatura', 971.0000, 'ºC'),
	(65963, 111, '2015-02-15 00:52:37.000000', 'temperatura', 508.0000, 'ºC'),
	(65964, 111, '2015-02-15 00:52:38.000000', 'temperatura', 826.0000, 'ºC'),
	(65965, 111, '2015-02-15 00:52:39.000000', 'temperatura', 207.0000, 'ºC'),
	(65966, 111, '2015-02-15 00:52:40.000000', 'temperatura', 956.0000, 'ºC'),
	(65967, 111, '2015-02-15 00:52:41.000000', 'temperatura', 561.0000, 'ºC'),
	(65968, 111, '2015-02-15 00:52:42.000000', 'temperatura', 1135.0000, 'ºC'),
	(65969, 111, '2015-02-15 00:52:43.000000', 'temperatura', 395.0000, 'ºC'),
	(65970, 111, '2015-02-15 00:52:44.000000', 'temperatura', 970.0000, 'ºC'),
	(65971, 111, '2015-02-15 00:52:45.000000', 'temperatura', 65.0000, 'ºC'),
	(65972, 111, '2015-02-15 00:52:46.000000', 'temperatura', 1017.0000, 'ºC'),
	(65973, 111, '2015-02-15 00:52:47.000000', 'temperatura', 91.0000, 'ºC'),
	(65974, 111, '2015-02-15 00:52:48.000000', 'temperatura', 1002.0000, 'ºC'),
	(65975, 111, '2015-02-15 00:52:49.000000', 'temperatura', 1138.0000, 'ºC'),
	(65976, 111, '2015-02-15 00:52:50.000000', 'temperatura', 284.0000, 'ºC'),
	(65977, 111, '2015-02-15 00:52:51.000000', 'temperatura', 406.0000, 'ºC'),
	(65978, 111, '2015-02-15 00:52:52.000000', 'temperatura', 1178.0000, 'ºC'),
	(65979, 111, '2015-02-15 00:52:53.000000', 'temperatura', 1075.0000, 'ºC'),
	(65980, 111, '2015-02-15 00:52:54.000000', 'temperatura', 642.0000, 'ºC'),
	(65981, 111, '2015-02-15 00:52:55.000000', 'temperatura', 1182.0000, 'ºC'),
	(65982, 111, '2015-02-15 00:52:56.000000', 'temperatura', 388.0000, 'ºC'),
	(65983, 111, '2015-02-15 00:52:57.000000', 'temperatura', 793.0000, 'ºC'),
	(65984, 111, '2015-02-15 00:52:58.000000', 'temperatura', 403.0000, 'ºC'),
	(65985, 111, '2015-02-15 00:52:59.000000', 'temperatura', 834.0000, 'ºC'),
	(65986, 111, '2015-02-15 00:53:00.000000', 'temperatura', 562.0000, 'ºC'),
	(65987, 111, '2015-02-15 00:53:01.000000', 'temperatura', 308.0000, 'ºC'),
	(65988, 111, '2015-02-15 00:53:02.000000', 'temperatura', 1054.0000, 'ºC'),
	(65989, 111, '2015-02-15 00:53:03.000000', 'temperatura', 749.0000, 'ºC'),
	(65990, 111, '2015-02-15 00:53:04.000000', 'temperatura', 584.0000, 'ºC'),
	(65991, 111, '2015-02-15 00:53:05.000000', 'temperatura', 671.0000, 'ºC'),
	(65992, 111, '2015-02-15 00:53:06.000000', 'temperatura', 405.0000, 'ºC'),
	(65993, 111, '2015-02-15 00:53:07.000000', 'temperatura', 13.0000, 'ºC'),
	(65994, 111, '2015-02-15 00:53:08.000000', 'temperatura', 48.0000, 'ºC'),
	(65995, 111, '2015-02-15 00:53:09.000000', 'temperatura', 203.0000, 'ºC'),
	(65996, 111, '2015-02-15 00:53:10.000000', 'temperatura', 872.0000, 'ºC'),
	(65997, 111, '2015-02-15 00:53:11.000000', 'temperatura', 150.0000, 'ºC'),
	(65998, 111, '2015-02-15 00:53:12.000000', 'temperatura', 534.0000, 'ºC'),
	(65999, 111, '2015-02-15 00:53:13.000000', 'temperatura', 1021.0000, 'ºC'),
	(66000, 111, '2015-02-15 00:53:14.000000', 'temperatura', 1102.0000, 'ºC'),
	(66001, 111, '2015-02-15 00:53:15.000000', 'temperatura', 50.0000, 'ºC'),
	(66002, 111, '2015-02-15 00:53:16.000000', 'temperatura', 543.0000, 'ºC'),
	(66003, 111, '2015-02-15 00:53:17.000000', 'temperatura', 165.0000, 'ºC'),
	(66004, 111, '2015-02-15 00:53:18.000000', 'temperatura', 397.0000, 'ºC'),
	(66005, 111, '2015-02-15 00:53:19.000000', 'temperatura', 292.0000, 'ºC'),
	(66006, 111, '2015-02-15 00:53:20.000000', 'temperatura', 269.0000, 'ºC'),
	(66007, 111, '2015-02-15 00:53:21.000000', 'temperatura', 470.0000, 'ºC'),
	(66008, 111, '2015-02-15 00:53:22.000000', 'temperatura', 342.0000, 'ºC'),
	(66009, 111, '2015-02-15 00:53:23.000000', 'temperatura', 300.0000, 'ºC'),
	(66010, 111, '2015-02-15 00:53:24.000000', 'temperatura', 477.0000, 'ºC'),
	(66011, 111, '2015-02-15 00:53:25.000000', 'temperatura', 285.0000, 'ºC'),
	(66012, 111, '2015-02-15 00:53:26.000000', 'temperatura', 1195.0000, 'ºC'),
	(66013, 111, '2015-02-15 00:53:27.000000', 'temperatura', 319.0000, 'ºC'),
	(66014, 111, '2015-02-15 00:53:28.000000', 'temperatura', 411.0000, 'ºC'),
	(66015, 111, '2015-02-15 00:53:29.000000', 'temperatura', 1098.0000, 'ºC'),
	(66016, 111, '2015-02-15 00:53:30.000000', 'temperatura', 658.0000, 'ºC'),
	(66017, 111, '2015-02-15 00:53:31.000000', 'temperatura', 1194.0000, 'ºC'),
	(66018, 111, '2015-02-15 00:53:32.000000', 'temperatura', 400.0000, 'ºC'),
	(66019, 111, '2015-02-15 00:53:33.000000', 'temperatura', 817.0000, 'ºC'),
	(66020, 111, '2015-02-15 00:53:34.000000', 'temperatura', 487.0000, 'ºC'),
	(66021, 111, '2015-02-15 00:53:35.000000', 'temperatura', 1184.0000, 'ºC'),
	(66022, 111, '2015-02-15 00:53:36.000000', 'temperatura', 858.0000, 'ºC'),
	(66023, 111, '2015-02-15 00:53:37.000000', 'temperatura', 737.0000, 'ºC'),
	(66024, 111, '2015-02-15 00:53:38.000000', 'temperatura', 1114.0000, 'ºC'),
	(66025, 111, '2015-02-15 00:53:39.000000', 'temperatura', 959.0000, 'ºC'),
	(66026, 111, '2015-02-15 00:53:40.000000', 'temperatura', 255.0000, 'ºC'),
	(66027, 111, '2015-02-15 00:53:41.000000', 'temperatura', 797.0000, 'ºC'),
	(66028, 111, '2015-02-15 00:53:42.000000', 'temperatura', 823.0000, 'ºC'),
	(66029, 111, '2015-02-15 00:53:43.000000', 'temperatura', 522.0000, 'ºC'),
	(66030, 111, '2015-02-15 00:53:44.000000', 'temperatura', 140.0000, 'ºC'),
	(66031, 111, '2015-02-15 00:53:45.000000', 'temperatura', 336.0000, 'ºC'),
	(66032, 111, '2015-02-15 00:53:46.000000', 'temperatura', 62.0000, 'ºC'),
	(66033, 111, '2015-02-15 00:53:47.000000', 'temperatura', 501.0000, 'ºC'),
	(66034, 111, '2015-02-15 00:53:48.000000', 'temperatura', 1122.0000, 'ºC'),
	(66035, 111, '2015-02-15 00:53:49.000000', 'temperatura', 504.0000, 'ºC'),
	(66036, 111, '2015-02-15 00:53:50.000000', 'temperatura', 356.0000, 'ºC'),
	(66037, 111, '2015-02-15 00:53:51.000000', 'temperatura', 269.0000, 'ºC'),
	(66038, 111, '2015-02-15 00:53:52.000000', 'temperatura', 278.0000, 'ºC'),
	(66039, 111, '2015-02-15 00:53:53.000000', 'temperatura', 582.0000, 'ºC'),
	(66040, 111, '2015-02-15 00:53:54.000000', 'temperatura', 875.0000, 'ºC'),
	(66041, 111, '2015-02-15 00:53:55.000000', 'temperatura', 232.0000, 'ºC'),
	(66042, 111, '2015-02-15 00:53:56.000000', 'temperatura', 933.0000, 'ºC'),
	(66043, 111, '2015-02-15 00:53:57.000000', 'temperatura', 371.0000, 'ºC'),
	(66044, 111, '2015-02-15 00:53:58.000000', 'temperatura', 258.0000, 'ºC'),
	(66045, 111, '2015-02-15 00:53:59.000000', 'temperatura', 175.0000, 'ºC'),
	(66046, 111, '2015-02-15 00:54:00.000000', 'temperatura', 103.0000, 'ºC'),
	(66047, 111, '2015-02-15 00:54:01.000000', 'temperatura', 1189.0000, 'ºC'),
	(66048, 111, '2015-02-15 00:54:02.000000', 'temperatura', 839.0000, 'ºC'),
	(66049, 111, '2015-02-15 00:54:03.000000', 'temperatura', 628.0000, 'ºC'),
	(66050, 111, '2015-02-15 00:54:04.000000', 'temperatura', 623.0000, 'ºC'),
	(66051, 111, '2015-02-15 00:54:05.000000', 'temperatura', 30.0000, 'ºC'),
	(66052, 111, '2015-02-15 00:54:06.000000', 'temperatura', 682.0000, 'ºC'),
	(66053, 111, '2015-02-15 00:54:07.000000', 'temperatura', 922.0000, 'ºC'),
	(66054, 111, '2015-02-15 00:54:08.000000', 'temperatura', 165.0000, 'ºC'),
	(66055, 111, '2015-02-15 00:54:09.000000', 'temperatura', 458.0000, 'ºC'),
	(66056, 111, '2015-02-15 00:54:10.000000', 'temperatura', 596.0000, 'ºC'),
	(66057, 111, '2015-02-15 00:54:11.000000', 'temperatura', 407.0000, 'ºC'),
	(66058, 111, '2015-02-15 00:54:12.000000', 'temperatura', 248.0000, 'ºC'),
	(66059, 111, '2015-02-15 00:54:13.000000', 'temperatura', 21.0000, 'ºC'),
	(66060, 111, '2015-02-15 00:54:14.000000', 'temperatura', 560.0000, 'ºC'),
	(66061, 111, '2015-02-15 00:54:15.000000', 'temperatura', 338.0000, 'ºC'),
	(66062, 111, '2015-02-15 00:54:16.000000', 'temperatura', 11.0000, 'ºC'),
	(66063, 111, '2015-02-15 00:54:17.000000', 'temperatura', 241.0000, 'ºC'),
	(66064, 111, '2015-02-15 00:54:18.000000', 'temperatura', 1173.0000, 'ºC'),
	(66065, 111, '2015-02-15 00:54:19.000000', 'temperatura', 341.0000, 'ºC'),
	(66066, 111, '2015-02-15 00:54:20.000000', 'temperatura', 586.0000, 'ºC'),
	(66067, 111, '2015-02-15 00:54:21.000000', 'temperatura', 708.0000, 'ºC'),
	(66068, 111, '2015-02-15 00:54:22.000000', 'temperatura', 582.0000, 'ºC'),
	(66069, 111, '2015-02-15 00:54:23.000000', 'temperatura', 787.0000, 'ºC'),
	(66070, 111, '2015-02-15 00:54:24.000000', 'temperatura', 990.0000, 'ºC'),
	(66071, 111, '2015-02-15 00:54:25.000000', 'temperatura', 190.0000, 'ºC'),
	(66072, 111, '2015-02-15 00:54:26.000000', 'temperatura', 379.0000, 'ºC'),
	(66073, 111, '2015-02-15 00:54:27.000000', 'temperatura', 128.0000, 'ºC'),
	(66074, 111, '2015-02-15 00:54:28.000000', 'temperatura', 702.0000, 'ºC'),
	(66075, 111, '2015-02-15 00:54:29.000000', 'temperatura', 728.0000, 'ºC'),
	(66076, 111, '2015-02-15 00:54:30.000000', 'temperatura', 335.0000, 'ºC'),
	(66077, 111, '2015-02-15 00:54:31.000000', 'temperatura', 689.0000, 'ºC'),
	(66078, 111, '2015-02-15 00:54:32.000000', 'temperatura', 42.0000, 'ºC'),
	(66079, 111, '2015-02-15 00:54:33.000000', 'temperatura', 543.0000, 'ºC'),
	(66080, 111, '2015-02-15 00:54:34.000000', 'temperatura', 190.0000, 'ºC'),
	(66081, 111, '2015-02-15 00:54:35.000000', 'temperatura', 520.0000, 'ºC'),
	(66082, 111, '2015-02-15 00:54:36.000000', 'temperatura', 831.0000, 'ºC'),
	(66083, 111, '2015-02-15 00:54:37.000000', 'temperatura', 195.0000, 'ºC'),
	(66084, 111, '2015-02-15 00:54:38.000000', 'temperatura', 885.0000, 'ºC'),
	(66085, 111, '2015-02-15 00:54:39.000000', 'temperatura', 238.0000, 'ºC'),
	(66086, 111, '2015-02-15 00:54:40.000000', 'temperatura', 937.0000, 'ºC'),
	(66087, 111, '2015-02-15 00:54:41.000000', 'temperatura', 370.0000, 'ºC'),
	(66088, 111, '2015-02-15 00:54:42.000000', 'temperatura', 241.0000, 'ºC'),
	(66089, 111, '2015-02-15 00:54:43.000000', 'temperatura', 97.0000, 'ºC'),
	(66090, 111, '2015-02-15 00:54:44.000000', 'temperatura', 961.0000, 'ºC'),
	(66091, 111, '2015-02-15 00:54:45.000000', 'temperatura', 914.0000, 'ºC'),
	(66092, 111, '2015-02-15 00:54:46.000000', 'temperatura', 487.0000, 'ºC'),
	(66093, 111, '2015-02-15 00:54:47.000000', 'temperatura', 893.0000, 'ºC'),
	(66094, 111, '2015-02-15 00:54:48.000000', 'temperatura', 605.0000, 'ºC'),
	(66095, 111, '2015-02-15 00:54:49.000000', 'temperatura', 346.0000, 'ºC'),
	(66096, 111, '2015-02-15 00:54:50.000000', 'temperatura', 1114.0000, 'ºC'),
	(66097, 111, '2015-02-15 00:54:51.000000', 'temperatura', 934.0000, 'ºC'),
	(66098, 111, '2015-02-15 00:54:52.000000', 'temperatura', 131.0000, 'ºC'),
	(66099, 111, '2015-02-15 00:54:53.000000', 'temperatura', 250.0000, 'ºC'),
	(66100, 111, '2015-02-15 00:54:54.000000', 'temperatura', 857.0000, 'ºC'),
	(66101, 111, '2015-02-15 00:54:55.000000', 'temperatura', 1138.0000, 'ºC'),
	(66102, 111, '2015-02-15 00:54:56.000000', 'temperatura', 718.0000, 'ºC'),
	(66103, 111, '2015-02-15 00:54:57.000000', 'temperatura', 177.0000, 'ºC'),
	(66104, 111, '2015-02-15 00:54:58.000000', 'temperatura', 1131.0000, 'ºC'),
	(66105, 111, '2015-02-15 00:54:59.000000', 'temperatura', 326.0000, 'ºC'),
	(66106, 111, '2015-02-15 00:55:00.000000', 'temperatura', 636.0000, 'ºC'),
	(66107, 111, '2015-02-15 00:55:01.000000', 'temperatura', 1004.0000, 'ºC'),
	(66108, 111, '2015-02-15 00:55:02.000000', 'temperatura', 712.0000, 'ºC'),
	(66109, 111, '2015-02-15 00:55:03.000000', 'temperatura', 548.0000, 'ºC'),
	(66110, 111, '2015-02-15 00:55:04.000000', 'temperatura', 604.0000, 'ºC'),
	(66111, 111, '2015-02-15 00:55:05.000000', 'temperatura', 176.0000, 'ºC'),
	(66112, 111, '2015-02-15 00:55:06.000000', 'temperatura', 271.0000, 'ºC'),
	(66113, 111, '2015-02-15 00:55:07.000000', 'temperatura', 827.0000, 'ºC'),
	(66114, 111, '2015-02-15 00:55:08.000000', 'temperatura', 921.0000, 'ºC'),
	(66115, 111, '2015-02-15 00:55:09.000000', 'temperatura', 923.0000, 'ºC'),
	(66116, 111, '2015-02-15 00:55:10.000000', 'temperatura', 655.0000, 'ºC'),
	(66117, 111, '2015-02-15 00:55:11.000000', 'temperatura', 507.0000, 'ºC'),
	(66118, 111, '2015-02-15 00:55:12.000000', 'temperatura', 568.0000, 'ºC'),
	(66119, 111, '2015-02-15 00:55:13.000000', 'temperatura', 121.0000, 'ºC'),
	(66120, 111, '2015-02-15 00:55:14.000000', 'temperatura', 103.0000, 'ºC'),
	(66121, 111, '2015-02-15 00:55:15.000000', 'temperatura', 153.0000, 'ºC'),
	(66122, 111, '2015-02-15 00:55:16.000000', 'temperatura', 456.0000, 'ºC'),
	(66123, 111, '2015-02-15 00:55:17.000000', 'temperatura', 619.0000, 'ºC'),
	(66124, 111, '2015-02-15 00:55:18.000000', 'temperatura', 529.0000, 'ºC'),
	(66125, 111, '2015-02-15 00:55:19.000000', 'temperatura', 786.0000, 'ºC'),
	(66126, 111, '2015-02-15 00:55:20.000000', 'temperatura', 1146.0000, 'ºC'),
	(66127, 111, '2015-02-15 00:55:21.000000', 'temperatura', 974.0000, 'ºC'),
	(66128, 111, '2015-02-15 00:55:22.000000', 'temperatura', 231.0000, 'ºC'),
	(66129, 111, '2015-02-15 00:55:23.000000', 'temperatura', 632.0000, 'ºC'),
	(66130, 111, '2015-02-15 00:55:24.000000', 'temperatura', 68.0000, 'ºC'),
	(66131, 111, '2015-02-15 00:55:25.000000', 'temperatura', 846.0000, 'ºC'),
	(66132, 111, '2015-02-15 00:55:26.000000', 'temperatura', 427.0000, 'ºC'),
	(66133, 111, '2015-02-15 00:55:27.000000', 'temperatura', 796.0000, 'ºC'),
	(66134, 111, '2015-02-15 00:55:28.000000', 'temperatura', 302.0000, 'ºC'),
	(66135, 111, '2015-02-15 00:55:29.000000', 'temperatura', 321.0000, 'ºC'),
	(66136, 111, '2015-02-15 00:55:30.000000', 'temperatura', 698.0000, 'ºC'),
	(66137, 111, '2015-02-15 00:55:31.000000', 'temperatura', 130.0000, 'ºC'),
	(66138, 111, '2015-02-15 00:55:32.000000', 'temperatura', 956.0000, 'ºC'),
	(66139, 111, '2015-02-15 00:55:33.000000', 'temperatura', 791.0000, 'ºC'),
	(66140, 111, '2015-02-15 00:55:34.000000', 'temperatura', 1087.0000, 'ºC'),
	(66141, 111, '2015-02-15 00:55:35.000000', 'temperatura', 663.0000, 'ºC'),
	(66142, 111, '2015-02-15 00:55:36.000000', 'temperatura', 55.0000, 'ºC'),
	(66143, 111, '2015-02-15 00:55:37.000000', 'temperatura', 688.0000, 'ºC'),
	(66144, 111, '2015-02-15 00:55:38.000000', 'temperatura', 873.0000, 'ºC'),
	(66145, 111, '2015-02-15 00:55:39.000000', 'temperatura', 1101.0000, 'ºC'),
	(66146, 111, '2015-02-15 00:55:40.000000', 'temperatura', 487.0000, 'ºC'),
	(66147, 111, '2015-02-15 00:55:41.000000', 'temperatura', 334.0000, 'ºC'),
	(66148, 111, '2015-02-15 00:55:42.000000', 'temperatura', 209.0000, 'ºC'),
	(66149, 111, '2015-02-15 00:55:43.000000', 'temperatura', 44.0000, 'ºC'),
	(66150, 111, '2015-02-15 00:55:44.000000', 'temperatura', 791.0000, 'ºC'),
	(66151, 111, '2015-02-15 00:55:45.000000', 'temperatura', 224.0000, 'ºC'),
	(66152, 111, '2015-02-15 00:55:46.000000', 'temperatura', 1150.0000, 'ºC'),
	(66153, 111, '2015-02-15 00:55:47.000000', 'temperatura', 277.0000, 'ºC'),
	(66154, 111, '2015-02-15 00:55:48.000000', 'temperatura', 337.0000, 'ºC'),
	(66155, 111, '2015-02-15 00:55:49.000000', 'temperatura', 855.0000, 'ºC'),
	(66156, 111, '2015-02-15 00:55:50.000000', 'temperatura', 862.0000, 'ºC'),
	(66157, 111, '2015-02-15 00:55:51.000000', 'temperatura', 547.0000, 'ºC'),
	(66158, 111, '2015-02-15 00:55:52.000000', 'temperatura', 151.0000, 'ºC'),
	(66159, 111, '2015-02-15 00:55:53.000000', 'temperatura', 314.0000, 'ºC'),
	(66160, 111, '2015-02-15 00:55:54.000000', 'temperatura', 1119.0000, 'ºC'),
	(66161, 111, '2015-02-15 00:55:55.000000', 'temperatura', 1052.0000, 'ºC'),
	(66162, 111, '2015-02-15 00:55:56.000000', 'temperatura', 704.0000, 'ºC'),
	(66163, 111, '2015-02-15 00:55:57.000000', 'temperatura', 364.0000, 'ºC'),
	(66164, 111, '2015-02-15 00:55:58.000000', 'temperatura', 908.0000, 'ºC'),
	(66165, 111, '2015-02-15 00:55:59.000000', 'temperatura', 1048.0000, 'ºC'),
	(66166, 111, '2015-02-15 00:56:00.000000', 'temperatura', 117.0000, 'ºC'),
	(66167, 111, '2015-02-15 00:56:01.000000', 'temperatura', 1040.0000, 'ºC'),
	(66168, 111, '2015-02-15 00:56:02.000000', 'temperatura', 51.0000, 'ºC'),
	(66169, 111, '2015-02-15 00:56:03.000000', 'temperatura', 736.0000, 'ºC'),
	(66170, 111, '2015-02-15 00:56:04.000000', 'temperatura', 1129.0000, 'ºC'),
	(66171, 111, '2015-02-15 00:56:05.000000', 'temperatura', 1036.0000, 'ºC'),
	(66172, 111, '2015-02-15 00:56:06.000000', 'temperatura', 592.0000, 'ºC'),
	(66173, 111, '2015-02-15 00:56:07.000000', 'temperatura', 1054.0000, 'ºC'),
	(66174, 111, '2015-02-15 00:56:08.000000', 'temperatura', 1094.0000, 'ºC'),
	(66175, 111, '2015-02-15 00:56:09.000000', 'temperatura', 1108.0000, 'ºC'),
	(66176, 111, '2015-02-15 00:56:10.000000', 'temperatura', 1060.0000, 'ºC'),
	(66177, 111, '2015-02-15 00:56:11.000000', 'temperatura', 774.0000, 'ºC'),
	(66178, 111, '2015-02-15 00:56:12.000000', 'temperatura', 690.0000, 'ºC'),
	(66179, 111, '2015-02-15 00:56:13.000000', 'temperatura', 1131.0000, 'ºC'),
	(66180, 111, '2015-02-15 00:56:14.000000', 'temperatura', 1187.0000, 'ºC'),
	(66181, 111, '2015-02-15 00:56:15.000000', 'temperatura', 139.0000, 'ºC'),
	(66182, 111, '2015-02-15 00:56:16.000000', 'temperatura', 736.0000, 'ºC'),
	(66183, 111, '2015-02-15 00:56:17.000000', 'temperatura', 861.0000, 'ºC'),
	(66184, 111, '2015-02-15 00:56:18.000000', 'temperatura', 901.0000, 'ºC'),
	(66185, 111, '2015-02-15 00:56:19.000000', 'temperatura', 722.0000, 'ºC'),
	(66186, 111, '2015-02-15 00:56:20.000000', 'temperatura', 905.0000, 'ºC'),
	(66187, 111, '2015-02-15 00:56:21.000000', 'temperatura', 1161.0000, 'ºC'),
	(66188, 111, '2015-02-15 00:56:22.000000', 'temperatura', 689.0000, 'ºC'),
	(66189, 111, '2015-02-15 00:56:23.000000', 'temperatura', 1164.0000, 'ºC'),
	(66190, 111, '2015-02-15 00:56:24.000000', 'temperatura', 152.0000, 'ºC'),
	(66191, 111, '2015-02-15 00:56:25.000000', 'temperatura', 871.0000, 'ºC'),
	(66192, 111, '2015-02-15 00:56:26.000000', 'temperatura', 300.0000, 'ºC'),
	(66193, 111, '2015-02-15 00:56:27.000000', 'temperatura', 86.0000, 'ºC'),
	(66194, 111, '2015-02-15 00:56:28.000000', 'temperatura', 732.0000, 'ºC'),
	(66195, 111, '2015-02-15 00:56:29.000000', 'temperatura', 1003.0000, 'ºC'),
	(66196, 111, '2015-02-15 00:56:30.000000', 'temperatura', 420.0000, 'ºC'),
	(66197, 111, '2015-02-15 00:56:31.000000', 'temperatura', 291.0000, 'ºC'),
	(66198, 111, '2015-02-15 00:56:32.000000', 'temperatura', 197.0000, 'ºC'),
	(66199, 111, '2015-02-15 00:56:33.000000', 'temperatura', 110.0000, 'ºC'),
	(66200, 111, '2015-02-15 00:56:34.000000', 'temperatura', 1161.0000, 'ºC'),
	(66201, 111, '2015-02-15 00:56:35.000000', 'temperatura', 674.0000, 'ºC'),
	(66202, 111, '2015-02-15 00:56:36.000000', 'temperatura', 1087.0000, 'ºC'),
	(66203, 111, '2015-02-15 00:56:37.000000', 'temperatura', 1013.0000, 'ºC'),
	(66204, 111, '2015-02-15 00:56:38.000000', 'temperatura', 605.0000, 'ºC'),
	(66205, 111, '2015-02-15 00:56:39.000000', 'temperatura', 1188.0000, 'ºC'),
	(66206, 111, '2015-02-15 00:56:40.000000', 'temperatura', 525.0000, 'ºC'),
	(66207, 111, '2015-02-15 00:56:41.000000', 'temperatura', 259.0000, 'ºC'),
	(66208, 111, '2015-02-15 00:56:42.000000', 'temperatura', 924.0000, 'ºC'),
	(66209, 111, '2015-02-15 00:56:43.000000', 'temperatura', 241.0000, 'ºC'),
	(66210, 111, '2015-02-15 00:56:44.000000', 'temperatura', 835.0000, 'ºC'),
	(66211, 111, '2015-02-15 00:56:45.000000', 'temperatura', 1053.0000, 'ºC'),
	(66212, 111, '2015-02-15 00:56:46.000000', 'temperatura', 359.0000, 'ºC'),
	(66213, 111, '2015-02-15 00:56:47.000000', 'temperatura', 1035.0000, 'ºC'),
	(66214, 111, '2015-02-15 00:56:48.000000', 'temperatura', 500.0000, 'ºC'),
	(66215, 111, '2015-02-15 00:56:49.000000', 'temperatura', 597.0000, 'ºC'),
	(66216, 111, '2015-02-15 00:56:50.000000', 'temperatura', 283.0000, 'ºC'),
	(66217, 111, '2015-02-15 00:56:51.000000', 'temperatura', 826.0000, 'ºC'),
	(66218, 111, '2015-02-15 00:56:52.000000', 'temperatura', 880.0000, 'ºC'),
	(66219, 111, '2015-02-15 00:56:53.000000', 'temperatura', 723.0000, 'ºC'),
	(66220, 112, '2015-02-15 00:00:00.000000', 'temperatura', 306.0000, 'ºC'),
	(66221, 112, '2015-02-15 00:00:01.000000', 'temperatura', 1006.0000, 'ºC'),
	(66222, 112, '2015-02-15 00:00:02.000000', 'temperatura', 511.0000, 'ºC'),
	(66223, 112, '2015-02-15 00:00:03.000000', 'temperatura', 739.0000, 'ºC'),
	(66224, 112, '2015-02-15 00:00:04.000000', 'temperatura', 960.0000, 'ºC'),
	(66225, 112, '2015-02-15 00:00:05.000000', 'temperatura', 186.0000, 'ºC'),
	(66226, 112, '2015-02-15 00:00:06.000000', 'temperatura', 451.0000, 'ºC'),
	(66227, 112, '2015-02-15 00:00:07.000000', 'temperatura', 495.0000, 'ºC'),
	(66228, 112, '2015-02-15 00:00:08.000000', 'temperatura', 1123.0000, 'ºC'),
	(66229, 112, '2015-02-15 00:00:09.000000', 'temperatura', 529.0000, 'ºC'),
	(66230, 112, '2015-02-15 00:00:10.000000', 'temperatura', 477.0000, 'ºC'),
	(66231, 112, '2015-02-15 00:00:11.000000', 'temperatura', 800.0000, 'ºC'),
	(66232, 112, '2015-02-15 00:00:12.000000', 'temperatura', 168.0000, 'ºC'),
	(66233, 112, '2015-02-15 00:00:13.000000', 'temperatura', 843.0000, 'ºC'),
	(66234, 112, '2015-02-15 00:00:14.000000', 'temperatura', 110.0000, 'ºC'),
	(66235, 112, '2015-02-15 00:00:15.000000', 'temperatura', 420.0000, 'ºC'),
	(66236, 112, '2015-02-15 00:00:16.000000', 'temperatura', 574.0000, 'ºC'),
	(66237, 112, '2015-02-15 00:00:17.000000', 'temperatura', 408.0000, 'ºC'),
	(66238, 112, '2015-02-15 00:00:18.000000', 'temperatura', 318.0000, 'ºC'),
	(66239, 112, '2015-02-15 00:00:19.000000', 'temperatura', 368.0000, 'ºC'),
	(66240, 112, '2015-02-15 00:00:20.000000', 'temperatura', 888.0000, 'ºC'),
	(66241, 112, '2015-02-15 00:00:21.000000', 'temperatura', 935.0000, 'ºC'),
	(66242, 112, '2015-02-15 00:00:22.000000', 'temperatura', 813.0000, 'ºC'),
	(66243, 112, '2015-02-15 00:00:23.000000', 'temperatura', 61.0000, 'ºC'),
	(66244, 112, '2015-02-15 00:00:24.000000', 'temperatura', 265.0000, 'ºC'),
	(66245, 112, '2015-02-15 00:00:25.000000', 'temperatura', 1142.0000, 'ºC'),
	(66246, 112, '2015-02-15 00:00:26.000000', 'temperatura', 115.0000, 'ºC'),
	(66247, 112, '2015-02-15 00:00:27.000000', 'temperatura', 752.0000, 'ºC'),
	(66248, 112, '2015-02-15 00:00:28.000000', 'temperatura', 1013.0000, 'ºC'),
	(66249, 112, '2015-02-15 00:00:29.000000', 'temperatura', 409.0000, 'ºC'),
	(66250, 112, '2015-02-15 00:00:30.000000', 'temperatura', 209.0000, 'ºC'),
	(66251, 112, '2015-02-15 00:00:31.000000', 'temperatura', 1016.0000, 'ºC'),
	(66252, 112, '2015-02-15 00:00:32.000000', 'temperatura', 856.0000, 'ºC'),
	(66253, 112, '2015-02-15 00:00:33.000000', 'temperatura', 30.0000, 'ºC'),
	(66254, 112, '2015-02-15 00:00:34.000000', 'temperatura', 1183.0000, 'ºC'),
	(66255, 112, '2015-02-15 00:00:35.000000', 'temperatura', 1025.0000, 'ºC'),
	(66256, 112, '2015-02-15 00:00:36.000000', 'temperatura', 379.0000, 'ºC'),
	(66257, 112, '2015-02-15 00:00:37.000000', 'temperatura', 20.0000, 'ºC'),
	(66258, 112, '2015-02-15 00:00:38.000000', 'temperatura', 162.0000, 'ºC'),
	(66259, 112, '2015-02-15 00:00:39.000000', 'temperatura', 751.0000, 'ºC'),
	(66260, 112, '2015-02-15 00:00:40.000000', 'temperatura', 872.0000, 'ºC'),
	(66261, 112, '2015-02-15 00:00:41.000000', 'temperatura', 905.0000, 'ºC'),
	(66262, 112, '2015-02-15 00:00:42.000000', 'temperatura', 709.0000, 'ºC'),
	(66263, 112, '2015-02-15 00:00:43.000000', 'temperatura', 829.0000, 'ºC'),
	(66264, 112, '2015-02-15 00:00:44.000000', 'temperatura', 821.0000, 'ºC'),
	(66265, 112, '2015-02-15 00:00:45.000000', 'temperatura', 418.0000, 'ºC'),
	(66266, 112, '2015-02-15 00:00:46.000000', 'temperatura', 828.0000, 'ºC'),
	(66267, 112, '2015-02-15 00:00:47.000000', 'temperatura', 486.0000, 'ºC'),
	(66268, 112, '2015-02-15 00:00:48.000000', 'temperatura', 1148.0000, 'ºC'),
	(66269, 112, '2015-02-15 00:00:49.000000', 'temperatura', 683.0000, 'ºC'),
	(66270, 112, '2015-02-15 00:00:50.000000', 'temperatura', 1171.0000, 'ºC'),
	(66271, 112, '2015-02-15 00:00:51.000000', 'temperatura', 206.0000, 'ºC'),
	(66272, 112, '2015-02-15 00:00:52.000000', 'temperatura', 1117.0000, 'ºC'),
	(66273, 112, '2015-02-15 00:00:53.000000', 'temperatura', 169.0000, 'ºC'),
	(66274, 112, '2015-02-15 00:00:54.000000', 'temperatura', 1095.0000, 'ºC'),
	(66275, 112, '2015-02-15 00:00:55.000000', 'temperatura', 168.0000, 'ºC'),
	(66276, 112, '2015-02-15 00:00:56.000000', 'temperatura', 1155.0000, 'ºC'),
	(66277, 112, '2015-02-15 00:00:57.000000', 'temperatura', 473.0000, 'ºC'),
	(66278, 112, '2015-02-15 00:00:58.000000', 'temperatura', 101.0000, 'ºC'),
	(66279, 112, '2015-02-15 00:00:59.000000', 'temperatura', 287.0000, 'ºC'),
	(66280, 112, '2015-02-15 00:01:00.000000', 'temperatura', 1132.0000, 'ºC'),
	(66281, 112, '2015-02-15 00:01:01.000000', 'temperatura', 1198.0000, 'ºC'),
	(66282, 112, '2015-02-15 00:01:02.000000', 'temperatura', 194.0000, 'ºC'),
	(66283, 112, '2015-02-15 00:01:03.000000', 'temperatura', 979.0000, 'ºC'),
	(66284, 112, '2015-02-15 00:01:04.000000', 'temperatura', 713.0000, 'ºC'),
	(66285, 112, '2015-02-15 00:01:05.000000', 'temperatura', 630.0000, 'ºC'),
	(66286, 112, '2015-02-15 00:01:06.000000', 'temperatura', 1008.0000, 'ºC'),
	(66287, 112, '2015-02-15 00:01:07.000000', 'temperatura', 753.0000, 'ºC'),
	(66288, 112, '2015-02-15 00:01:08.000000', 'temperatura', 741.0000, 'ºC'),
	(66289, 112, '2015-02-15 00:01:09.000000', 'temperatura', 246.0000, 'ºC'),
	(66290, 112, '2015-02-15 00:01:10.000000', 'temperatura', 207.0000, 'ºC'),
	(66291, 112, '2015-02-15 00:01:11.000000', 'temperatura', 300.0000, 'ºC'),
	(66292, 112, '2015-02-15 00:01:12.000000', 'temperatura', 877.0000, 'ºC'),
	(66293, 112, '2015-02-15 00:01:13.000000', 'temperatura', 1087.0000, 'ºC'),
	(66294, 112, '2015-02-15 00:01:14.000000', 'temperatura', 403.0000, 'ºC'),
	(66295, 112, '2015-02-15 00:01:15.000000', 'temperatura', 1154.0000, 'ºC'),
	(66296, 112, '2015-02-15 00:01:16.000000', 'temperatura', 961.0000, 'ºC'),
	(66297, 112, '2015-02-15 00:01:17.000000', 'temperatura', 143.0000, 'ºC'),
	(66298, 112, '2015-02-15 00:01:18.000000', 'temperatura', 234.0000, 'ºC'),
	(66299, 112, '2015-02-15 00:01:19.000000', 'temperatura', 741.0000, 'ºC'),
	(66300, 112, '2015-02-15 00:01:20.000000', 'temperatura', 605.0000, 'ºC'),
	(66301, 112, '2015-02-15 00:01:21.000000', 'temperatura', 801.0000, 'ºC'),
	(66302, 112, '2015-02-15 00:01:22.000000', 'temperatura', 991.0000, 'ºC'),
	(66303, 112, '2015-02-15 00:01:23.000000', 'temperatura', 153.0000, 'ºC'),
	(66304, 112, '2015-02-15 00:01:24.000000', 'temperatura', 194.0000, 'ºC'),
	(66305, 112, '2015-02-15 00:01:25.000000', 'temperatura', 509.0000, 'ºC'),
	(66306, 112, '2015-02-15 00:01:26.000000', 'temperatura', 763.0000, 'ºC'),
	(66307, 112, '2015-02-15 00:01:27.000000', 'temperatura', 1091.0000, 'ºC'),
	(66308, 112, '2015-02-15 00:01:28.000000', 'temperatura', 764.0000, 'ºC'),
	(66309, 112, '2015-02-15 00:01:29.000000', 'temperatura', 548.0000, 'ºC'),
	(66310, 112, '2015-02-15 00:01:30.000000', 'temperatura', 448.0000, 'ºC'),
	(66311, 112, '2015-02-15 00:01:31.000000', 'temperatura', 595.0000, 'ºC'),
	(66312, 112, '2015-02-15 00:01:32.000000', 'temperatura', 434.0000, 'ºC'),
	(66313, 112, '2015-02-15 00:01:33.000000', 'temperatura', 385.0000, 'ºC'),
	(66314, 112, '2015-02-15 00:01:34.000000', 'temperatura', 622.0000, 'ºC'),
	(66315, 112, '2015-02-15 00:01:35.000000', 'temperatura', 754.0000, 'ºC'),
	(66316, 112, '2015-02-15 00:01:36.000000', 'temperatura', 708.0000, 'ºC'),
	(66317, 112, '2015-02-15 00:01:37.000000', 'temperatura', 78.0000, 'ºC'),
	(66318, 112, '2015-02-15 00:01:38.000000', 'temperatura', 666.0000, 'ºC'),
	(66319, 112, '2015-02-15 00:01:39.000000', 'temperatura', 698.0000, 'ºC'),
	(66320, 112, '2015-02-15 00:01:40.000000', 'temperatura', 291.0000, 'ºC'),
	(66321, 112, '2015-02-15 00:01:41.000000', 'temperatura', 563.0000, 'ºC'),
	(66322, 112, '2015-02-15 00:01:42.000000', 'temperatura', 741.0000, 'ºC'),
	(66323, 112, '2015-02-15 00:01:43.000000', 'temperatura', 817.0000, 'ºC'),
	(66324, 112, '2015-02-15 00:01:44.000000', 'temperatura', 663.0000, 'ºC'),
	(66325, 112, '2015-02-15 00:01:45.000000', 'temperatura', 865.0000, 'ºC'),
	(66326, 112, '2015-02-15 00:01:46.000000', 'temperatura', 1137.0000, 'ºC'),
	(66327, 112, '2015-02-15 00:01:47.000000', 'temperatura', 690.0000, 'ºC'),
	(66328, 112, '2015-02-15 00:01:48.000000', 'temperatura', 39.0000, 'ºC'),
	(66329, 112, '2015-02-15 00:01:49.000000', 'temperatura', 527.0000, 'ºC'),
	(66330, 112, '2015-02-15 00:01:50.000000', 'temperatura', 119.0000, 'ºC'),
	(66331, 112, '2015-02-15 00:01:51.000000', 'temperatura', 214.0000, 'ºC'),
	(66332, 112, '2015-02-15 00:01:52.000000', 'temperatura', 714.0000, 'ºC'),
	(66333, 112, '2015-02-15 00:01:53.000000', 'temperatura', 526.0000, 'ºC'),
	(66334, 112, '2015-02-15 00:01:54.000000', 'temperatura', 490.0000, 'ºC'),
	(66335, 112, '2015-02-15 00:01:55.000000', 'temperatura', 872.0000, 'ºC'),
	(66336, 112, '2015-02-15 00:01:56.000000', 'temperatura', 490.0000, 'ºC'),
	(66337, 112, '2015-02-15 00:01:57.000000', 'temperatura', 1036.0000, 'ºC'),
	(66338, 112, '2015-02-15 00:01:58.000000', 'temperatura', 112.0000, 'ºC'),
	(66339, 112, '2015-02-15 00:01:59.000000', 'temperatura', 1049.0000, 'ºC'),
	(66340, 112, '2015-02-15 00:02:00.000000', 'temperatura', 113.0000, 'ºC'),
	(66341, 112, '2015-02-15 00:02:01.000000', 'temperatura', 1015.0000, 'ºC'),
	(66342, 112, '2015-02-15 00:02:02.000000', 'temperatura', 1139.0000, 'ºC'),
	(66343, 112, '2015-02-15 00:02:03.000000', 'temperatura', 250.0000, 'ºC'),
	(66344, 112, '2015-02-15 00:02:04.000000', 'temperatura', 233.0000, 'ºC'),
	(66345, 112, '2015-02-15 00:02:05.000000', 'temperatura', 415.0000, 'ºC'),
	(66346, 112, '2015-02-15 00:02:06.000000', 'temperatura', 176.0000, 'ºC'),
	(66347, 112, '2015-02-15 00:02:07.000000', 'temperatura', 838.0000, 'ºC'),
	(66348, 112, '2015-02-15 00:02:08.000000', 'temperatura', 61.0000, 'ºC'),
	(66349, 112, '2015-02-15 00:02:09.000000', 'temperatura', 190.0000, 'ºC'),
	(66350, 112, '2015-02-15 00:02:10.000000', 'temperatura', 770.0000, 'ºC'),
	(66351, 112, '2015-02-15 00:02:11.000000', 'temperatura', 878.0000, 'ºC'),
	(66352, 112, '2015-02-15 00:02:12.000000', 'temperatura', 880.0000, 'ºC'),
	(66353, 112, '2015-02-15 00:02:13.000000', 'temperatura', 569.0000, 'ºC'),
	(66354, 112, '2015-02-15 00:02:14.000000', 'temperatura', 203.0000, 'ºC'),
	(66355, 112, '2015-02-15 00:02:15.000000', 'temperatura', 512.0000, 'ºC'),
	(66356, 112, '2015-02-15 00:02:16.000000', 'temperatura', 748.0000, 'ºC'),
	(66357, 112, '2015-02-15 00:02:17.000000', 'temperatura', 1004.0000, 'ºC'),
	(66358, 112, '2015-02-15 00:02:18.000000', 'temperatura', 379.0000, 'ºC'),
	(66359, 112, '2015-02-15 00:02:19.000000', 'temperatura', 82.0000, 'ºC'),
	(66360, 112, '2015-02-15 00:02:20.000000', 'temperatura', 474.0000, 'ºC'),
	(66361, 112, '2015-02-15 00:02:21.000000', 'temperatura', 926.0000, 'ºC'),
	(66362, 112, '2015-02-15 00:02:22.000000', 'temperatura', 805.0000, 'ºC'),
	(66363, 112, '2015-02-15 00:02:23.000000', 'temperatura', 51.0000, 'ºC'),
	(66364, 112, '2015-02-15 00:02:24.000000', 'temperatura', 240.0000, 'ºC'),
	(66365, 112, '2015-02-15 00:02:25.000000', 'temperatura', 1048.0000, 'ºC'),
	(66366, 112, '2015-02-15 00:02:26.000000', 'temperatura', 921.0000, 'ºC'),
	(66367, 112, '2015-02-15 00:02:27.000000', 'temperatura', 261.0000, 'ºC'),
	(66368, 112, '2015-02-15 00:02:28.000000', 'temperatura', 944.0000, 'ºC'),
	(66369, 112, '2015-02-15 00:02:29.000000', 'temperatura', 335.0000, 'ºC'),
	(66370, 112, '2015-02-15 00:02:30.000000', 'temperatura', 44.0000, 'ºC'),
	(66371, 112, '2015-02-15 00:02:31.000000', 'temperatura', 415.0000, 'ºC'),
	(66372, 112, '2015-02-15 00:02:32.000000', 'temperatura', 745.0000, 'ºC'),
	(66373, 112, '2015-02-15 00:02:33.000000', 'temperatura', 79.0000, 'ºC'),
	(66374, 112, '2015-02-15 00:02:34.000000', 'temperatura', 560.0000, 'ºC'),
	(66375, 112, '2015-02-15 00:02:35.000000', 'temperatura', 166.0000, 'ºC'),
	(66376, 112, '2015-02-15 00:02:36.000000', 'temperatura', 348.0000, 'ºC'),
	(66377, 112, '2015-02-15 00:02:37.000000', 'temperatura', 42.0000, 'ºC'),
	(66378, 112, '2015-02-15 00:02:38.000000', 'temperatura', 369.0000, 'ºC'),
	(66379, 112, '2015-02-15 00:02:39.000000', 'temperatura', 519.0000, 'ºC'),
	(66380, 112, '2015-02-15 00:02:40.000000', 'temperatura', 289.0000, 'ºC'),
	(66381, 112, '2015-02-15 00:02:41.000000', 'temperatura', 1088.0000, 'ºC'),
	(66382, 112, '2015-02-15 00:02:42.000000', 'temperatura', 972.0000, 'ºC'),
	(66383, 112, '2015-02-15 00:02:43.000000', 'temperatura', 396.0000, 'ºC'),
	(66384, 112, '2015-02-15 00:02:44.000000', 'temperatura', 265.0000, 'ºC'),
	(66385, 112, '2015-02-15 00:02:45.000000', 'temperatura', 139.0000, 'ºC'),
	(66386, 112, '2015-02-15 00:02:46.000000', 'temperatura', 1099.0000, 'ºC'),
	(66387, 112, '2015-02-15 00:02:47.000000', 'temperatura', 280.0000, 'ºC'),
	(66388, 112, '2015-02-15 00:02:48.000000', 'temperatura', 501.0000, 'ºC'),
	(66389, 112, '2015-02-15 00:02:49.000000', 'temperatura', 467.0000, 'ºC'),
	(66390, 112, '2015-02-15 00:02:50.000000', 'temperatura', 831.0000, 'ºC'),
	(66391, 112, '2015-02-15 00:02:51.000000', 'temperatura', 356.0000, 'ºC'),
	(66392, 112, '2015-02-15 00:02:52.000000', 'temperatura', 489.0000, 'ºC'),
	(66393, 112, '2015-02-15 00:02:53.000000', 'temperatura', 176.0000, 'ºC'),
	(66394, 112, '2015-02-15 00:02:54.000000', 'temperatura', 614.0000, 'ºC'),
	(66395, 112, '2015-02-15 00:02:55.000000', 'temperatura', 144.0000, 'ºC'),
	(66396, 112, '2015-02-15 00:02:56.000000', 'temperatura', 76.0000, 'ºC'),
	(66397, 112, '2015-02-15 00:02:57.000000', 'temperatura', 1148.0000, 'ºC'),
	(66398, 112, '2015-02-15 00:02:58.000000', 'temperatura', 714.0000, 'ºC'),
	(66399, 112, '2015-02-15 00:02:59.000000', 'temperatura', 126.0000, 'ºC'),
	(66400, 112, '2015-02-15 00:03:00.000000', 'temperatura', 889.0000, 'ºC'),
	(66401, 112, '2015-02-15 00:03:01.000000', 'temperatura', 467.0000, 'ºC'),
	(66402, 112, '2015-02-15 00:03:02.000000', 'temperatura', 867.0000, 'ºC'),
	(66403, 112, '2015-02-15 00:03:03.000000', 'temperatura', 536.0000, 'ºC'),
	(66404, 112, '2015-02-15 00:03:04.000000', 'temperatura', 78.0000, 'ºC'),
	(66405, 112, '2015-02-15 00:03:05.000000', 'temperatura', 1182.0000, 'ºC'),
	(66406, 112, '2015-02-15 00:03:06.000000', 'temperatura', 878.0000, 'ºC'),
	(66407, 112, '2015-02-15 00:03:07.000000', 'temperatura', 844.0000, 'ºC'),
	(66408, 112, '2015-02-15 00:03:08.000000', 'temperatura', 387.0000, 'ºC'),
	(66409, 112, '2015-02-15 00:03:09.000000', 'temperatura', 602.0000, 'ºC'),
	(66410, 112, '2015-02-15 00:03:10.000000', 'temperatura', 649.0000, 'ºC'),
	(66411, 112, '2015-02-15 00:03:11.000000', 'temperatura', 242.0000, 'ºC'),
	(66412, 112, '2015-02-15 00:03:12.000000', 'temperatura', 462.0000, 'ºC'),
	(66413, 112, '2015-02-15 00:03:13.000000', 'temperatura', 385.0000, 'ºC'),
	(66414, 112, '2015-02-15 00:03:14.000000', 'temperatura', 538.0000, 'ºC'),
	(66415, 112, '2015-02-15 00:03:15.000000', 'temperatura', 337.0000, 'ºC'),
	(66416, 112, '2015-02-15 00:03:16.000000', 'temperatura', 71.0000, 'ºC'),
	(66417, 112, '2015-02-15 00:03:17.000000', 'temperatura', 544.0000, 'ºC'),
	(66418, 112, '2015-02-15 00:03:18.000000', 'temperatura', 106.0000, 'ºC'),
	(66419, 112, '2015-02-15 00:03:19.000000', 'temperatura', 100.0000, 'ºC'),
	(66420, 112, '2015-02-15 00:03:20.000000', 'temperatura', 181.0000, 'ºC'),
	(66421, 112, '2015-02-15 00:03:21.000000', 'temperatura', 605.0000, 'ºC'),
	(66422, 112, '2015-02-15 00:03:22.000000', 'temperatura', 83.0000, 'ºC'),
	(66423, 112, '2015-02-15 00:03:23.000000', 'temperatura', 1003.0000, 'ºC'),
	(66424, 112, '2015-02-15 00:03:24.000000', 'temperatura', 1163.0000, 'ºC'),
	(66425, 112, '2015-02-15 00:03:25.000000', 'temperatura', 408.0000, 'ºC'),
	(66426, 112, '2015-02-15 00:03:26.000000', 'temperatura', 954.0000, 'ºC'),
	(66427, 112, '2015-02-15 00:03:27.000000', 'temperatura', 1143.0000, 'ºC'),
	(66428, 112, '2015-02-15 00:03:28.000000', 'temperatura', 453.0000, 'ºC'),
	(66429, 112, '2015-02-15 00:03:29.000000', 'temperatura', 38.0000, 'ºC'),
	(66430, 112, '2015-02-15 00:03:30.000000', 'temperatura', 31.0000, 'ºC'),
	(66431, 112, '2015-02-15 00:03:31.000000', 'temperatura', 40.0000, 'ºC'),
	(66432, 112, '2015-02-15 00:03:32.000000', 'temperatura', 110.0000, 'ºC'),
	(66433, 112, '2015-02-15 00:03:33.000000', 'temperatura', 429.0000, 'ºC'),
	(66434, 112, '2015-02-15 00:03:34.000000', 'temperatura', 615.0000, 'ºC'),
	(66435, 112, '2015-02-15 00:03:35.000000', 'temperatura', 588.0000, 'ºC'),
	(66436, 112, '2015-02-15 00:03:36.000000', 'temperatura', 1097.0000, 'ºC'),
	(66437, 112, '2015-02-15 00:03:37.000000', 'temperatura', 122.0000, 'ºC'),
	(66438, 112, '2015-02-15 00:03:38.000000', 'temperatura', 918.0000, 'ºC'),
	(66439, 112, '2015-02-15 00:03:39.000000', 'temperatura', 625.0000, 'ºC'),
	(66440, 112, '2015-02-15 00:03:40.000000', 'temperatura', 373.0000, 'ºC'),
	(66441, 112, '2015-02-15 00:03:41.000000', 'temperatura', 1188.0000, 'ºC'),
	(66442, 112, '2015-02-15 00:03:42.000000', 'temperatura', 22.0000, 'ºC'),
	(66443, 112, '2015-02-15 00:03:43.000000', 'temperatura', 149.0000, 'ºC'),
	(66444, 112, '2015-02-15 00:03:44.000000', 'temperatura', 677.0000, 'ºC'),
	(66445, 112, '2015-02-15 00:03:45.000000', 'temperatura', 539.0000, 'ºC'),
	(66446, 112, '2015-02-15 00:03:46.000000', 'temperatura', 664.0000, 'ºC'),
	(66447, 112, '2015-02-15 00:03:47.000000', 'temperatura', 505.0000, 'ºC'),
	(66448, 112, '2015-02-15 00:03:48.000000', 'temperatura', 533.0000, 'ºC'),
	(66449, 112, '2015-02-15 00:03:49.000000', 'temperatura', 1151.0000, 'ºC'),
	(66450, 112, '2015-02-15 00:03:50.000000', 'temperatura', 558.0000, 'ºC'),
	(66451, 112, '2015-02-15 00:03:51.000000', 'temperatura', 537.0000, 'ºC'),
	(66452, 112, '2015-02-15 00:03:52.000000', 'temperatura', 1010.0000, 'ºC'),
	(66453, 112, '2015-02-15 00:03:53.000000', 'temperatura', 1039.0000, 'ºC'),
	(66454, 112, '2015-02-15 00:03:54.000000', 'temperatura', 966.0000, 'ºC'),
	(66455, 112, '2015-02-15 00:03:55.000000', 'temperatura', 516.0000, 'ºC'),
	(66456, 112, '2015-02-15 00:03:56.000000', 'temperatura', 879.0000, 'ºC'),
	(66457, 112, '2015-02-15 00:03:57.000000', 'temperatura', 450.0000, 'ºC'),
	(66458, 112, '2015-02-15 00:03:58.000000', 'temperatura', 811.0000, 'ºC'),
	(66459, 112, '2015-02-15 00:03:59.000000', 'temperatura', 305.0000, 'ºC'),
	(66460, 112, '2015-02-15 00:04:00.000000', 'temperatura', 293.0000, 'ºC'),
	(66461, 112, '2015-02-15 00:04:01.000000', 'temperatura', 549.0000, 'ºC'),
	(66462, 112, '2015-02-15 00:04:02.000000', 'temperatura', 669.0000, 'ºC'),
	(66463, 112, '2015-02-15 00:04:03.000000', 'temperatura', 498.0000, 'ºC'),
	(66464, 112, '2015-02-15 00:04:04.000000', 'temperatura', 482.0000, 'ºC'),
	(66465, 112, '2015-02-15 00:04:05.000000', 'temperatura', 917.0000, 'ºC'),
	(66466, 112, '2015-02-15 00:04:06.000000', 'temperatura', 742.0000, 'ºC'),
	(66467, 112, '2015-02-15 00:04:07.000000', 'temperatura', 956.0000, 'ºC'),
	(66468, 112, '2015-02-15 00:04:08.000000', 'temperatura', 156.0000, 'ºC'),
	(66469, 112, '2015-02-15 00:04:09.000000', 'temperatura', 313.0000, 'ºC'),
	(66470, 112, '2015-02-15 00:04:10.000000', 'temperatura', 1095.0000, 'ºC'),
	(66471, 112, '2015-02-15 00:04:11.000000', 'temperatura', 939.0000, 'ºC'),
	(66472, 112, '2015-02-15 00:04:12.000000', 'temperatura', 209.0000, 'ºC'),
	(66473, 112, '2015-02-15 00:04:13.000000', 'temperatura', 630.0000, 'ºC'),
	(66474, 112, '2015-02-15 00:04:14.000000', 'temperatura', 122.0000, 'ºC'),
	(66475, 112, '2015-02-15 00:04:15.000000', 'temperatura', 1120.0000, 'ºC'),
	(66476, 112, '2015-02-15 00:04:16.000000', 'temperatura', 436.0000, 'ºC'),
	(66477, 112, '2015-02-15 00:04:17.000000', 'temperatura', 21.0000, 'ºC'),
	(66478, 112, '2015-02-15 00:04:18.000000', 'temperatura', 1196.0000, 'ºC'),
	(66479, 112, '2015-02-15 00:04:19.000000', 'temperatura', 1119.0000, 'ºC'),
	(66480, 112, '2015-02-15 00:04:20.000000', 'temperatura', 806.0000, 'ºC'),
	(66481, 112, '2015-02-15 00:04:21.000000', 'temperatura', 673.0000, 'ºC'),
	(66482, 112, '2015-02-15 00:04:22.000000', 'temperatura', 949.0000, 'ºC'),
	(66483, 112, '2015-02-15 00:04:23.000000', 'temperatura', 326.0000, 'ºC'),
	(66484, 112, '2015-02-15 00:04:24.000000', 'temperatura', 1184.0000, 'ºC'),
	(66485, 112, '2015-02-15 00:04:25.000000', 'temperatura', 143.0000, 'ºC'),
	(66486, 112, '2015-02-15 00:04:26.000000', 'temperatura', 761.0000, 'ºC'),
	(66487, 112, '2015-02-15 00:04:27.000000', 'temperatura', 978.0000, 'ºC'),
	(66488, 112, '2015-02-15 00:04:28.000000', 'temperatura', 207.0000, 'ºC'),
	(66489, 112, '2015-02-15 00:04:29.000000', 'temperatura', 500.0000, 'ºC'),
	(66490, 112, '2015-02-15 00:04:30.000000', 'temperatura', 679.0000, 'ºC'),
	(66491, 112, '2015-02-15 00:04:31.000000', 'temperatura', 697.0000, 'ºC'),
	(66492, 112, '2015-02-15 00:04:32.000000', 'temperatura', 248.0000, 'ºC'),
	(66493, 112, '2015-02-15 00:04:33.000000', 'temperatura', 352.0000, 'ºC'),
	(66494, 112, '2015-02-15 00:04:34.000000', 'temperatura', 1013.0000, 'ºC'),
	(66495, 112, '2015-02-15 00:04:35.000000', 'temperatura', 412.0000, 'ºC'),
	(66496, 112, '2015-02-15 00:04:36.000000', 'temperatura', 219.0000, 'ºC'),
	(66497, 112, '2015-02-15 00:04:37.000000', 'temperatura', 1060.0000, 'ºC'),
	(66498, 112, '2015-02-15 00:04:38.000000', 'temperatura', 1043.0000, 'ºC'),
	(66499, 112, '2015-02-15 00:04:39.000000', 'temperatura', 834.0000, 'ºC'),
	(66500, 112, '2015-02-15 00:04:40.000000', 'temperatura', 1045.0000, 'ºC'),
	(66501, 112, '2015-02-15 00:04:41.000000', 'temperatura', 321.0000, 'ºC'),
	(66502, 112, '2015-02-15 00:04:42.000000', 'temperatura', 872.0000, 'ºC'),
	(66503, 112, '2015-02-15 00:04:43.000000', 'temperatura', 997.0000, 'ºC'),
	(66504, 112, '2015-02-15 00:04:44.000000', 'temperatura', 1168.0000, 'ºC'),
	(66505, 112, '2015-02-15 00:04:45.000000', 'temperatura', 451.0000, 'ºC'),
	(66506, 112, '2015-02-15 00:04:46.000000', 'temperatura', 1150.0000, 'ºC'),
	(66507, 112, '2015-02-15 00:04:47.000000', 'temperatura', 798.0000, 'ºC'),
	(66508, 112, '2015-02-15 00:04:48.000000', 'temperatura', 540.0000, 'ºC'),
	(66509, 112, '2015-02-15 00:04:49.000000', 'temperatura', 307.0000, 'ºC'),
	(66510, 112, '2015-02-15 00:04:50.000000', 'temperatura', 1116.0000, 'ºC'),
	(66511, 112, '2015-02-15 00:04:51.000000', 'temperatura', 1060.0000, 'ºC'),
	(66512, 112, '2015-02-15 00:04:52.000000', 'temperatura', 753.0000, 'ºC'),
	(66513, 112, '2015-02-15 00:04:53.000000', 'temperatura', 586.0000, 'ºC'),
	(66514, 112, '2015-02-15 00:04:54.000000', 'temperatura', 672.0000, 'ºC'),
	(66515, 112, '2015-02-15 00:04:55.000000', 'temperatura', 402.0000, 'ºC'),
	(66516, 112, '2015-02-15 00:04:56.000000', 'temperatura', 1192.0000, 'ºC'),
	(66517, 112, '2015-02-15 00:04:57.000000', 'temperatura', 1156.0000, 'ºC'),
	(66518, 112, '2015-02-15 00:04:58.000000', 'temperatura', 1005.0000, 'ºC'),
	(66519, 112, '2015-02-15 00:04:59.000000', 'temperatura', 359.0000, 'ºC'),
	(66520, 112, '2015-02-15 00:05:00.000000', 'temperatura', 1180.0000, 'ºC'),
	(66521, 112, '2015-02-15 00:05:01.000000', 'temperatura', 25.0000, 'ºC'),
	(66522, 112, '2015-02-15 00:05:02.000000', 'temperatura', 183.0000, 'ºC'),
	(66523, 112, '2015-02-15 00:05:03.000000', 'temperatura', 842.0000, 'ºC'),
	(66524, 112, '2015-02-15 00:05:04.000000', 'temperatura', 61.0000, 'ºC'),
	(66525, 112, '2015-02-15 00:05:05.000000', 'temperatura', 179.0000, 'ºC'),
	(66526, 112, '2015-02-15 00:05:06.000000', 'temperatura', 713.0000, 'ºC'),
	(66527, 112, '2015-02-15 00:05:07.000000', 'temperatura', 627.0000, 'ºC'),
	(66528, 112, '2015-02-15 00:05:08.000000', 'temperatura', 996.0000, 'ºC'),
	(66529, 112, '2015-02-15 00:05:09.000000', 'temperatura', 702.0000, 'ºC'),
	(66530, 112, '2015-02-15 00:05:10.000000', 'temperatura', 523.0000, 'ºC'),
	(66531, 112, '2015-02-15 00:05:11.000000', 'temperatura', 509.0000, 'ºC'),
	(66532, 112, '2015-02-15 00:05:12.000000', 'temperatura', 978.0000, 'ºC'),
	(66533, 112, '2015-02-15 00:05:13.000000', 'temperatura', 960.0000, 'ºC'),
	(66534, 112, '2015-02-15 00:05:14.000000', 'temperatura', 670.0000, 'ºC'),
	(66535, 112, '2015-02-15 00:05:15.000000', 'temperatura', 469.0000, 'ºC'),
	(66536, 112, '2015-02-15 00:05:16.000000', 'temperatura', 335.0000, 'ºC'),
	(66537, 112, '2015-02-15 00:05:17.000000', 'temperatura', 270.0000, 'ºC'),
	(66538, 112, '2015-02-15 00:05:18.000000', 'temperatura', 344.0000, 'ºC'),
	(66539, 112, '2015-02-15 00:05:19.000000', 'temperatura', 911.0000, 'ºC'),
	(66540, 112, '2015-02-15 00:05:20.000000', 'temperatura', 1123.0000, 'ºC'),
	(66541, 112, '2015-02-15 00:05:21.000000', 'temperatura', 482.0000, 'ºC'),
	(66542, 112, '2015-02-15 00:05:22.000000', 'temperatura', 244.0000, 'ºC'),
	(66543, 112, '2015-02-15 00:05:23.000000', 'temperatura', 974.0000, 'ºC'),
	(66544, 112, '2015-02-15 00:05:24.000000', 'temperatura', 536.0000, 'ºC'),
	(66545, 112, '2015-02-15 00:05:25.000000', 'temperatura', 961.0000, 'ºC'),
	(66546, 112, '2015-02-15 00:05:26.000000', 'temperatura', 799.0000, 'ºC'),
	(66547, 112, '2015-02-15 00:05:27.000000', 'temperatura', 1110.0000, 'ºC'),
	(66548, 112, '2015-02-15 00:05:28.000000', 'temperatura', 754.0000, 'ºC'),
	(66549, 112, '2015-02-15 00:05:29.000000', 'temperatura', 441.0000, 'ºC'),
	(66550, 112, '2015-02-15 00:05:30.000000', 'temperatura', 1143.0000, 'ºC'),
	(66551, 112, '2015-02-15 00:05:31.000000', 'temperatura', 791.0000, 'ºC'),
	(66552, 112, '2015-02-15 00:05:32.000000', 'temperatura', 526.0000, 'ºC'),
	(66553, 112, '2015-02-15 00:05:33.000000', 'temperatura', 259.0000, 'ºC'),
	(66554, 112, '2015-02-15 00:05:34.000000', 'temperatura', 916.0000, 'ºC'),
	(66555, 112, '2015-02-15 00:05:35.000000', 'temperatura', 203.0000, 'ºC'),
	(66556, 112, '2015-02-15 00:05:36.000000', 'temperatura', 667.0000, 'ºC'),
	(66557, 112, '2015-02-15 00:05:37.000000', 'temperatura', 327.0000, 'ºC'),
	(66558, 112, '2015-02-15 00:05:38.000000', 'temperatura', 834.0000, 'ºC'),
	(66559, 112, '2015-02-15 00:05:39.000000', 'temperatura', 792.0000, 'ºC'),
	(66560, 112, '2015-02-15 00:05:40.000000', 'temperatura', 258.0000, 'ºC'),
	(66561, 112, '2015-02-15 00:05:41.000000', 'temperatura', 114.0000, 'ºC'),
	(66562, 112, '2015-02-15 00:05:42.000000', 'temperatura', 995.0000, 'ºC'),
	(66563, 112, '2015-02-15 00:05:43.000000', 'temperatura', 1034.0000, 'ºC'),
	(66564, 112, '2015-02-15 00:05:44.000000', 'temperatura', 985.0000, 'ºC'),
	(66565, 112, '2015-02-15 00:05:45.000000', 'temperatura', 624.0000, 'ºC'),
	(66566, 112, '2015-02-15 00:05:46.000000', 'temperatura', 164.0000, 'ºC'),
	(66567, 112, '2015-02-15 00:05:47.000000', 'temperatura', 150.0000, 'ºC'),
	(66568, 112, '2015-02-15 00:05:48.000000', 'temperatura', 259.0000, 'ºC'),
	(66569, 112, '2015-02-15 00:05:49.000000', 'temperatura', 844.0000, 'ºC'),
	(66570, 112, '2015-02-15 00:05:50.000000', 'temperatura', 1044.0000, 'ºC'),
	(66571, 112, '2015-02-15 00:05:51.000000', 'temperatura', 289.0000, 'ºC'),
	(66572, 112, '2015-02-15 00:05:52.000000', 'temperatura', 715.0000, 'ºC'),
	(66573, 112, '2015-02-15 00:05:53.000000', 'temperatura', 308.0000, 'ºC'),
	(66574, 112, '2015-02-15 00:05:54.000000', 'temperatura', 597.0000, 'ºC'),
	(66575, 112, '2015-02-15 00:05:55.000000', 'temperatura', 861.0000, 'ºC'),
	(66576, 112, '2015-02-15 00:05:56.000000', 'temperatura', 112.0000, 'ºC'),
	(66577, 112, '2015-02-15 00:05:57.000000', 'temperatura', 379.0000, 'ºC'),
	(66578, 112, '2015-02-15 00:05:58.000000', 'temperatura', 361.0000, 'ºC'),
	(66579, 112, '2015-02-15 00:05:59.000000', 'temperatura', 666.0000, 'ºC'),
	(66580, 112, '2015-02-15 00:06:00.000000', 'temperatura', 1048.0000, 'ºC'),
	(66581, 112, '2015-02-15 00:06:01.000000', 'temperatura', 842.0000, 'ºC'),
	(66582, 112, '2015-02-15 00:06:02.000000', 'temperatura', 1065.0000, 'ºC'),
	(66583, 112, '2015-02-15 00:06:03.000000', 'temperatura', 401.0000, 'ºC'),
	(66584, 112, '2015-02-15 00:06:04.000000', 'temperatura', 11.0000, 'ºC'),
	(66585, 112, '2015-02-15 00:06:05.000000', 'temperatura', 51.0000, 'ºC'),
	(66586, 112, '2015-02-15 00:06:06.000000', 'temperatura', 222.0000, 'ºC'),
	(66587, 112, '2015-02-15 00:06:07.000000', 'temperatura', 958.0000, 'ºC'),
	(66588, 112, '2015-02-15 00:06:08.000000', 'temperatura', 525.0000, 'ºC'),
	(66589, 112, '2015-02-15 00:06:09.000000', 'temperatura', 951.0000, 'ºC'),
	(66590, 112, '2015-02-15 00:06:10.000000', 'temperatura', 782.0000, 'ºC'),
	(66591, 112, '2015-02-15 00:06:11.000000', 'temperatura', 1055.0000, 'ºC'),
	(66592, 112, '2015-02-15 00:06:12.000000', 'temperatura', 531.0000, 'ºC'),
	(66593, 112, '2015-02-15 00:06:13.000000', 'temperatura', 691.0000, 'ºC'),
	(66594, 112, '2015-02-15 00:06:14.000000', 'temperatura', 662.0000, 'ºC'),
	(66595, 112, '2015-02-15 00:06:15.000000', 'temperatura', 36.0000, 'ºC'),
	(66596, 112, '2015-02-15 00:06:16.000000', 'temperatura', 595.0000, 'ºC'),
	(66597, 112, '2015-02-15 00:06:17.000000', 'temperatura', 466.0000, 'ºC'),
	(66598, 112, '2015-02-15 00:06:18.000000', 'temperatura', 546.0000, 'ºC'),
	(66599, 112, '2015-02-15 00:06:19.000000', 'temperatura', 132.0000, 'ºC'),
	(66600, 112, '2015-02-15 00:06:20.000000', 'temperatura', 221.0000, 'ºC'),
	(66601, 112, '2015-02-15 00:06:21.000000', 'temperatura', 713.0000, 'ºC'),
	(66602, 112, '2015-02-15 00:06:22.000000', 'temperatura', 501.0000, 'ºC'),
	(66603, 112, '2015-02-15 00:06:23.000000', 'temperatura', 367.0000, 'ºC'),
	(66604, 112, '2015-02-15 00:06:24.000000', 'temperatura', 334.0000, 'ºC'),
	(66605, 112, '2015-02-15 00:06:25.000000', 'temperatura', 570.0000, 'ºC'),
	(66606, 112, '2015-02-15 00:06:26.000000', 'temperatura', 646.0000, 'ºC'),
	(66607, 112, '2015-02-15 00:06:27.000000', 'temperatura', 323.0000, 'ºC'),
	(66608, 112, '2015-02-15 00:06:28.000000', 'temperatura', 878.0000, 'ºC'),
	(66609, 112, '2015-02-15 00:06:29.000000', 'temperatura', 1022.0000, 'ºC'),
	(66610, 112, '2015-02-15 00:06:30.000000', 'temperatura', 77.0000, 'ºC'),
	(66611, 112, '2015-02-15 00:06:31.000000', 'temperatura', 917.0000, 'ºC'),
	(66612, 112, '2015-02-15 00:06:32.000000', 'temperatura', 754.0000, 'ºC'),
	(66613, 112, '2015-02-15 00:06:33.000000', 'temperatura', 1018.0000, 'ºC'),
	(66614, 112, '2015-02-15 00:06:34.000000', 'temperatura', 432.0000, 'ºC'),
	(66615, 112, '2015-02-15 00:06:35.000000', 'temperatura', 306.0000, 'ºC'),
	(66616, 112, '2015-02-15 00:06:36.000000', 'temperatura', 233.0000, 'ºC'),
	(66617, 112, '2015-02-15 00:06:37.000000', 'temperatura', 248.0000, 'ºC'),
	(66618, 112, '2015-02-15 00:06:38.000000', 'temperatura', 540.0000, 'ºC'),
	(66619, 112, '2015-02-15 00:06:39.000000', 'temperatura', 759.0000, 'ºC'),
	(66620, 112, '2015-02-15 00:06:40.000000', 'temperatura', 974.0000, 'ºC'),
	(66621, 112, '2015-02-15 00:06:41.000000', 'temperatura', 195.0000, 'ºC'),
	(66622, 112, '2015-02-15 00:06:42.000000', 'temperatura', 452.0000, 'ºC'),
	(66623, 112, '2015-02-15 00:06:43.000000', 'temperatura', 476.0000, 'ºC'),
	(66624, 112, '2015-02-15 00:06:44.000000', 'temperatura', 1023.0000, 'ºC'),
	(66625, 112, '2015-02-15 00:06:45.000000', 'temperatura', 89.0000, 'ºC'),
	(66626, 112, '2015-02-15 00:06:46.000000', 'temperatura', 976.0000, 'ºC'),
	(66627, 112, '2015-02-15 00:06:47.000000', 'temperatura', 1014.0000, 'ºC'),
	(66628, 112, '2015-02-15 00:06:48.000000', 'temperatura', 944.0000, 'ºC'),
	(66629, 112, '2015-02-15 00:06:49.000000', 'temperatura', 476.0000, 'ºC'),
	(66630, 112, '2015-02-15 00:06:50.000000', 'temperatura', 749.0000, 'ºC'),
	(66631, 112, '2015-02-15 00:06:51.000000', 'temperatura', 1118.0000, 'ºC'),
	(66632, 112, '2015-02-15 00:06:52.000000', 'temperatura', 945.0000, 'ºC'),
	(66633, 112, '2015-02-15 00:06:53.000000', 'temperatura', 168.0000, 'ºC'),
	(66634, 112, '2015-02-15 00:06:54.000000', 'temperatura', 409.0000, 'ºC'),
	(66635, 112, '2015-02-15 00:06:55.000000', 'temperatura', 339.0000, 'ºC'),
	(66636, 112, '2015-02-15 00:06:56.000000', 'temperatura', 469.0000, 'ºC'),
	(66637, 112, '2015-02-15 00:06:57.000000', 'temperatura', 128.0000, 'ºC'),
	(66638, 112, '2015-02-15 00:06:58.000000', 'temperatura', 435.0000, 'ºC'),
	(66639, 112, '2015-02-15 00:06:59.000000', 'temperatura', 591.0000, 'ºC'),
	(66640, 112, '2015-02-15 00:07:00.000000', 'temperatura', 451.0000, 'ºC'),
	(66641, 112, '2015-02-15 00:07:01.000000', 'temperatura', 481.0000, 'ºC'),
	(66642, 112, '2015-02-15 00:07:02.000000', 'temperatura', 1053.0000, 'ºC'),
	(66643, 112, '2015-02-15 00:07:03.000000', 'temperatura', 224.0000, 'ºC'),
	(66644, 112, '2015-02-15 00:07:04.000000', 'temperatura', 359.0000, 'ºC'),
	(66645, 112, '2015-02-15 00:07:05.000000', 'temperatura', 1126.0000, 'ºC'),
	(66646, 112, '2015-02-15 00:07:06.000000', 'temperatura', 955.0000, 'ºC'),
	(66647, 112, '2015-02-15 00:07:07.000000', 'temperatura', 194.0000, 'ºC'),
	(66648, 112, '2015-02-15 00:07:08.000000', 'temperatura', 508.0000, 'ºC'),
	(66649, 112, '2015-02-15 00:07:09.000000', 'temperatura', 758.0000, 'ºC'),
	(66650, 112, '2015-02-15 00:07:10.000000', 'temperatura', 1065.0000, 'ºC'),
	(66651, 112, '2015-02-15 00:07:11.000000', 'temperatura', 654.0000, 'ºC'),
	(66652, 112, '2015-02-15 00:07:12.000000', 'temperatura', 76.0000, 'ºC'),
	(66653, 112, '2015-02-15 00:07:13.000000', 'temperatura', 817.0000, 'ºC'),
	(66654, 112, '2015-02-15 00:07:14.000000', 'temperatura', 259.0000, 'ºC'),
	(66655, 112, '2015-02-15 00:07:15.000000', 'temperatura', 42.0000, 'ºC'),
	(66656, 112, '2015-02-15 00:07:16.000000', 'temperatura', 633.0000, 'ºC'),
	(66657, 112, '2015-02-15 00:07:17.000000', 'temperatura', 641.0000, 'ºC'),
	(66658, 112, '2015-02-15 00:07:18.000000', 'temperatura', 104.0000, 'ºC'),
	(66659, 112, '2015-02-15 00:07:19.000000', 'temperatura', 1001.0000, 'ºC'),
	(66660, 112, '2015-02-15 00:07:20.000000', 'temperatura', 1092.0000, 'ºC'),
	(66661, 112, '2015-02-15 00:07:21.000000', 'temperatura', 58.0000, 'ºC'),
	(66662, 112, '2015-02-15 00:07:22.000000', 'temperatura', 614.0000, 'ºC'),
	(66663, 112, '2015-02-15 00:07:23.000000', 'temperatura', 498.0000, 'ºC'),
	(66664, 112, '2015-02-15 00:07:24.000000', 'temperatura', 649.0000, 'ºC'),
	(66665, 112, '2015-02-15 00:07:25.000000', 'temperatura', 548.0000, 'ºC'),
	(66666, 112, '2015-02-15 00:07:26.000000', 'temperatura', 797.0000, 'ºC'),
	(66667, 112, '2015-02-15 00:07:27.000000', 'temperatura', 1140.0000, 'ºC'),
	(66668, 112, '2015-02-15 00:07:28.000000', 'temperatura', 908.0000, 'ºC'),
	(66669, 112, '2015-02-15 00:07:29.000000', 'temperatura', 1121.0000, 'ºC'),
	(66670, 112, '2015-02-15 00:07:30.000000', 'temperatura', 482.0000, 'ºC'),
	(66671, 112, '2015-02-15 00:07:31.000000', 'temperatura', 247.0000, 'ºC'),
	(66672, 112, '2015-02-15 00:07:32.000000', 'temperatura', 992.0000, 'ºC'),
	(66673, 112, '2015-02-15 00:07:33.000000', 'temperatura', 617.0000, 'ºC'),
	(66674, 112, '2015-02-15 00:07:34.000000', 'temperatura', 111.0000, 'ºC'),
	(66675, 112, '2015-02-15 00:07:35.000000', 'temperatura', 1106.0000, 'ºC'),
	(66676, 112, '2015-02-15 00:07:36.000000', 'temperatura', 396.0000, 'ºC'),
	(66677, 112, '2015-02-15 00:07:37.000000', 'temperatura', 1062.0000, 'ºC'),
	(66678, 112, '2015-02-15 00:07:38.000000', 'temperatura', 524.0000, 'ºC'),
	(66679, 112, '2015-02-15 00:07:39.000000', 'temperatura', 632.0000, 'ºC'),
	(66680, 112, '2015-02-15 00:07:40.000000', 'temperatura', 391.0000, 'ºC'),
	(66681, 112, '2015-02-15 00:07:41.000000', 'temperatura', 58.0000, 'ºC'),
	(66682, 112, '2015-02-15 00:07:42.000000', 'temperatura', 319.0000, 'ºC'),
	(66683, 112, '2015-02-15 00:07:43.000000', 'temperatura', 221.0000, 'ºC'),
	(66684, 112, '2015-02-15 00:07:44.000000', 'temperatura', 148.0000, 'ºC'),
	(66685, 112, '2015-02-15 00:07:45.000000', 'temperatura', 78.0000, 'ºC'),
	(66686, 112, '2015-02-15 00:07:46.000000', 'temperatura', 1147.0000, 'ºC'),
	(66687, 112, '2015-02-15 00:07:47.000000', 'temperatura', 702.0000, 'ºC'),
	(66688, 112, '2015-02-15 00:07:48.000000', 'temperatura', 70.0000, 'ºC'),
	(66689, 112, '2015-02-15 00:07:49.000000', 'temperatura', 645.0000, 'ºC'),
	(66690, 112, '2015-02-15 00:07:50.000000', 'temperatura', 616.0000, 'ºC'),
	(66691, 112, '2015-02-15 00:07:51.000000', 'temperatura', 1143.0000, 'ºC'),
	(66692, 112, '2015-02-15 00:07:52.000000', 'temperatura', 267.0000, 'ºC'),
	(66693, 112, '2015-02-15 00:07:53.000000', 'temperatura', 307.0000, 'ºC'),
	(66694, 112, '2015-02-15 00:07:54.000000', 'temperatura', 734.0000, 'ºC'),
	(66695, 112, '2015-02-15 00:07:55.000000', 'temperatura', 350.0000, 'ºC'),
	(66696, 112, '2015-02-15 00:07:56.000000', 'temperatura', 750.0000, 'ºC'),
	(66697, 112, '2015-02-15 00:07:57.000000', 'temperatura', 298.0000, 'ºC'),
	(66698, 112, '2015-02-15 00:07:58.000000', 'temperatura', 441.0000, 'ºC'),
	(66699, 112, '2015-02-15 00:07:59.000000', 'temperatura', 112.0000, 'ºC'),
	(66700, 112, '2015-02-15 00:08:00.000000', 'temperatura', 439.0000, 'ºC'),
	(66701, 112, '2015-02-15 00:08:01.000000', 'temperatura', 657.0000, 'ºC'),
	(66702, 112, '2015-02-15 00:08:02.000000', 'temperatura', 771.0000, 'ºC'),
	(66703, 112, '2015-02-15 00:08:03.000000', 'temperatura', 682.0000, 'ºC'),
	(66704, 112, '2015-02-15 00:08:04.000000', 'temperatura', 1099.0000, 'ºC'),
	(66705, 112, '2015-02-15 00:08:05.000000', 'temperatura', 1047.0000, 'ºC'),
	(66706, 112, '2015-02-15 00:08:06.000000', 'temperatura', 741.0000, 'ºC'),
	(66707, 112, '2015-02-15 00:08:07.000000', 'temperatura', 563.0000, 'ºC'),
	(66708, 112, '2015-02-15 00:08:08.000000', 'temperatura', 592.0000, 'ºC'),
	(66709, 112, '2015-02-15 00:08:09.000000', 'temperatura', 72.0000, 'ºC'),
	(66710, 112, '2015-02-15 00:08:10.000000', 'temperatura', 985.0000, 'ºC'),
	(66711, 112, '2015-02-15 00:08:11.000000', 'temperatura', 1110.0000, 'ºC'),
	(66712, 112, '2015-02-15 00:08:12.000000', 'temperatura', 195.0000, 'ºC'),
	(66713, 112, '2015-02-15 00:08:13.000000', 'temperatura', 47.0000, 'ºC'),
	(66714, 112, '2015-02-15 00:08:14.000000', 'temperatura', 849.0000, 'ºC'),
	(66715, 112, '2015-02-15 00:08:15.000000', 'temperatura', 503.0000, 'ºC'),
	(66716, 112, '2015-02-15 00:08:16.000000', 'temperatura', 1169.0000, 'ºC'),
	(66717, 112, '2015-02-15 00:08:17.000000', 'temperatura', 736.0000, 'ºC'),
	(66718, 112, '2015-02-15 00:08:18.000000', 'temperatura', 174.0000, 'ºC'),
	(66719, 112, '2015-02-15 00:08:19.000000', 'temperatura', 1062.0000, 'ºC'),
	(66720, 112, '2015-02-15 00:08:20.000000', 'temperatura', 1187.0000, 'ºC'),
	(66721, 112, '2015-02-15 00:08:21.000000', 'temperatura', 353.0000, 'ºC'),
	(66722, 112, '2015-02-15 00:08:22.000000', 'temperatura', 601.0000, 'ºC'),
	(66723, 112, '2015-02-15 00:08:23.000000', 'temperatura', 750.0000, 'ºC'),
	(66724, 112, '2015-02-15 00:08:24.000000', 'temperatura', 744.0000, 'ºC'),
	(66725, 112, '2015-02-15 00:08:25.000000', 'temperatura', 273.0000, 'ºC'),
	(66726, 112, '2015-02-15 00:08:26.000000', 'temperatura', 334.0000, 'ºC'),
	(66727, 112, '2015-02-15 00:08:27.000000', 'temperatura', 849.0000, 'ºC'),
	(66728, 112, '2015-02-15 00:08:28.000000', 'temperatura', 845.0000, 'ºC'),
	(66729, 112, '2015-02-15 00:08:29.000000', 'temperatura', 477.0000, 'ºC'),
	(66730, 112, '2015-02-15 00:08:30.000000', 'temperatura', 1053.0000, 'ºC'),
	(66731, 112, '2015-02-15 00:08:31.000000', 'temperatura', 234.0000, 'ºC'),
	(66732, 112, '2015-02-15 00:08:32.000000', 'temperatura', 411.0000, 'ºC'),
	(66733, 112, '2015-02-15 00:08:33.000000', 'temperatura', 156.0000, 'ºC'),
	(66734, 112, '2015-02-15 00:08:34.000000', 'temperatura', 744.0000, 'ºC'),
	(66735, 112, '2015-02-15 00:08:35.000000', 'temperatura', 852.0000, 'ºC'),
	(66736, 112, '2015-02-15 00:08:36.000000', 'temperatura', 831.0000, 'ºC'),
	(66737, 112, '2015-02-15 00:08:37.000000', 'temperatura', 399.0000, 'ºC'),
	(66738, 112, '2015-02-15 00:08:38.000000', 'temperatura', 702.0000, 'ºC'),
	(66739, 112, '2015-02-15 00:08:39.000000', 'temperatura', 1113.0000, 'ºC'),
	(66740, 112, '2015-02-15 00:08:40.000000', 'temperatura', 1061.0000, 'ºC'),
	(66741, 112, '2015-02-15 00:08:41.000000', 'temperatura', 767.0000, 'ºC'),
	(66742, 112, '2015-02-15 00:08:42.000000', 'temperatura', 653.0000, 'ºC'),
	(66743, 112, '2015-02-15 00:08:43.000000', 'temperatura', 963.0000, 'ºC'),
	(66744, 112, '2015-02-15 00:08:44.000000', 'temperatura', 455.0000, 'ºC'),
	(66745, 112, '2015-02-15 00:08:45.000000', 'temperatura', 588.0000, 'ºC'),
	(66746, 112, '2015-02-15 00:08:46.000000', 'temperatura', 376.0000, 'ºC'),
	(66747, 112, '2015-02-15 00:08:47.000000', 'temperatura', 115.0000, 'ºC'),
	(66748, 112, '2015-02-15 00:08:48.000000', 'temperatura', 649.0000, 'ºC'),
	(66749, 112, '2015-02-15 00:08:49.000000', 'temperatura', 499.0000, 'ºC'),
	(66750, 112, '2015-02-15 00:08:50.000000', 'temperatura', 548.0000, 'ºC'),
	(66751, 112, '2015-02-15 00:08:51.000000', 'temperatura', 45.0000, 'ºC'),
	(66752, 112, '2015-02-15 00:08:52.000000', 'temperatura', 982.0000, 'ºC'),
	(66753, 112, '2015-02-15 00:08:53.000000', 'temperatura', 1173.0000, 'ºC'),
	(66754, 112, '2015-02-15 00:08:54.000000', 'temperatura', 520.0000, 'ºC'),
	(66755, 112, '2015-02-15 00:08:55.000000', 'temperatura', 282.0000, 'ºC'),
	(66756, 112, '2015-02-15 00:08:56.000000', 'temperatura', 1049.0000, 'ºC'),
	(66757, 112, '2015-02-15 00:08:57.000000', 'temperatura', 801.0000, 'ºC'),
	(66758, 112, '2015-02-15 00:08:58.000000', 'temperatura', 860.0000, 'ºC'),
	(66759, 112, '2015-02-15 00:08:59.000000', 'temperatura', 696.0000, 'ºC'),
	(66760, 112, '2015-02-15 00:09:00.000000', 'temperatura', 902.0000, 'ºC'),
	(66761, 112, '2015-02-15 00:09:01.000000', 'temperatura', 20.0000, 'ºC'),
	(66762, 112, '2015-02-15 00:09:02.000000', 'temperatura', 997.0000, 'ºC'),
	(66763, 112, '2015-02-15 00:09:03.000000', 'temperatura', 124.0000, 'ºC'),
	(66764, 112, '2015-02-15 00:09:04.000000', 'temperatura', 31.0000, 'ºC'),
	(66765, 112, '2015-02-15 00:09:05.000000', 'temperatura', 982.0000, 'ºC'),
	(66766, 112, '2015-02-15 00:09:06.000000', 'temperatura', 19.0000, 'ºC'),
	(66767, 112, '2015-02-15 00:09:07.000000', 'temperatura', 748.0000, 'ºC'),
	(66768, 112, '2015-02-15 00:09:08.000000', 'temperatura', 83.0000, 'ºC'),
	(66769, 112, '2015-02-15 00:09:09.000000', 'temperatura', 573.0000, 'ºC'),
	(66770, 112, '2015-02-15 00:09:10.000000', 'temperatura', 214.0000, 'ºC'),
	(66771, 112, '2015-02-15 00:09:11.000000', 'temperatura', 552.0000, 'ºC'),
	(66772, 112, '2015-02-15 00:09:12.000000', 'temperatura', 920.0000, 'ºC'),
	(66773, 112, '2015-02-15 00:09:13.000000', 'temperatura', 544.0000, 'ºC'),
	(66774, 112, '2015-02-15 00:09:14.000000', 'temperatura', 1161.0000, 'ºC'),
	(66775, 112, '2015-02-15 00:09:15.000000', 'temperatura', 575.0000, 'ºC'),
	(66776, 112, '2015-02-15 00:09:16.000000', 'temperatura', 592.0000, 'ºC'),
	(66777, 112, '2015-02-15 00:09:17.000000', 'temperatura', 35.0000, 'ºC'),
	(66778, 112, '2015-02-15 00:09:18.000000', 'temperatura', 798.0000, 'ºC'),
	(66779, 112, '2015-02-15 00:09:19.000000', 'temperatura', 288.0000, 'ºC'),
	(66780, 112, '2015-02-15 00:09:20.000000', 'temperatura', 244.0000, 'ºC'),
	(66781, 112, '2015-02-15 00:09:21.000000', 'temperatura', 356.0000, 'ºC'),
	(66782, 112, '2015-02-15 00:09:22.000000', 'temperatura', 1049.0000, 'ºC'),
	(66783, 112, '2015-02-15 00:09:23.000000', 'temperatura', 576.0000, 'ºC'),
	(66784, 112, '2015-02-15 00:09:24.000000', 'temperatura', 936.0000, 'ºC'),
	(66785, 112, '2015-02-15 00:09:25.000000', 'temperatura', 554.0000, 'ºC'),
	(66786, 112, '2015-02-15 00:09:26.000000', 'temperatura', 1159.0000, 'ºC'),
	(66787, 112, '2015-02-15 00:09:27.000000', 'temperatura', 535.0000, 'ºC'),
	(66788, 112, '2015-02-15 00:09:28.000000', 'temperatura', 398.0000, 'ºC'),
	(66789, 112, '2015-02-15 00:09:29.000000', 'temperatura', 384.0000, 'ºC'),
	(66790, 112, '2015-02-15 00:09:30.000000', 'temperatura', 728.0000, 'ºC'),
	(66791, 112, '2015-02-15 00:09:31.000000', 'temperatura', 89.0000, 'ºC'),
	(66792, 112, '2015-02-15 00:09:32.000000', 'temperatura', 659.0000, 'ºC'),
	(66793, 112, '2015-02-15 00:09:33.000000', 'temperatura', 631.0000, 'ºC'),
	(66794, 112, '2015-02-15 00:09:34.000000', 'temperatura', 1178.0000, 'ºC'),
	(66795, 112, '2015-02-15 00:09:35.000000', 'temperatura', 396.0000, 'ºC'),
	(66796, 112, '2015-02-15 00:09:36.000000', 'temperatura', 847.0000, 'ºC'),
	(66797, 112, '2015-02-15 00:09:37.000000', 'temperatura', 646.0000, 'ºC'),
	(66798, 112, '2015-02-15 00:09:38.000000', 'temperatura', 692.0000, 'ºC'),
	(66799, 112, '2015-02-15 00:09:39.000000', 'temperatura', 320.0000, 'ºC'),
	(66800, 112, '2015-02-15 00:09:40.000000', 'temperatura', 725.0000, 'ºC'),
	(66801, 112, '2015-02-15 00:09:41.000000', 'temperatura', 266.0000, 'ºC'),
	(66802, 112, '2015-02-15 00:09:42.000000', 'temperatura', 355.0000, 'ºC'),
	(66803, 112, '2015-02-15 00:09:43.000000', 'temperatura', 978.0000, 'ºC'),
	(66804, 112, '2015-02-15 00:09:44.000000', 'temperatura', 226.0000, 'ºC'),
	(66805, 112, '2015-02-15 00:09:45.000000', 'temperatura', 597.0000, 'ºC'),
	(66806, 112, '2015-02-15 00:09:46.000000', 'temperatura', 1109.0000, 'ºC'),
	(66807, 112, '2015-02-15 00:09:47.000000', 'temperatura', 152.0000, 'ºC'),
	(66808, 112, '2015-02-15 00:09:48.000000', 'temperatura', 1036.0000, 'ºC'),
	(66809, 112, '2015-02-15 00:09:49.000000', 'temperatura', 1122.0000, 'ºC'),
	(66810, 112, '2015-02-15 00:09:50.000000', 'temperatura', 101.0000, 'ºC'),
	(66811, 112, '2015-02-15 00:09:51.000000', 'temperatura', 743.0000, 'ºC'),
	(66812, 112, '2015-02-15 00:09:52.000000', 'temperatura', 1011.0000, 'ºC'),
	(66813, 112, '2015-02-15 00:09:53.000000', 'temperatura', 427.0000, 'ºC'),
	(66814, 112, '2015-02-15 00:09:54.000000', 'temperatura', 303.0000, 'ºC'),
	(66815, 112, '2015-02-15 00:09:55.000000', 'temperatura', 236.0000, 'ºC'),
	(66816, 112, '2015-02-15 00:09:56.000000', 'temperatura', 269.0000, 'ºC'),
	(66817, 112, '2015-02-15 00:09:57.000000', 'temperatura', 639.0000, 'ºC'),
	(66818, 112, '2015-02-15 00:09:58.000000', 'temperatura', 1187.0000, 'ºC'),
	(66819, 112, '2015-02-15 00:09:59.000000', 'temperatura', 419.0000, 'ºC'),
	(66820, 112, '2015-02-15 00:10:00.000000', 'temperatura', 933.0000, 'ºC'),
	(66821, 112, '2015-02-15 00:10:01.000000', 'temperatura', 1009.0000, 'ºC'),
	(66822, 112, '2015-02-15 00:10:02.000000', 'temperatura', 1047.0000, 'ºC'),
	(66823, 112, '2015-02-15 00:10:03.000000', 'temperatura', 1007.0000, 'ºC'),
	(66824, 112, '2015-02-15 00:10:04.000000', 'temperatura', 695.0000, 'ºC'),
	(66825, 112, '2015-02-15 00:10:05.000000', 'temperatura', 455.0000, 'ºC'),
	(66826, 112, '2015-02-15 00:10:06.000000', 'temperatura', 189.0000, 'ºC'),
	(66827, 112, '2015-02-15 00:10:07.000000', 'temperatura', 783.0000, 'ºC'),
	(66828, 112, '2015-02-15 00:10:08.000000', 'temperatura', 946.0000, 'ºC'),
	(66829, 112, '2015-02-15 00:10:09.000000', 'temperatura', 1181.0000, 'ºC'),
	(66830, 112, '2015-02-15 00:10:10.000000', 'temperatura', 669.0000, 'ºC'),
	(66831, 112, '2015-02-15 00:10:11.000000', 'temperatura', 1004.0000, 'ºC'),
	(66832, 112, '2015-02-15 00:10:12.000000', 'temperatura', 612.0000, 'ºC'),
	(66833, 112, '2015-02-15 00:10:13.000000', 'temperatura', 48.0000, 'ºC'),
	(66834, 112, '2015-02-15 00:10:14.000000', 'temperatura', 807.0000, 'ºC'),
	(66835, 112, '2015-02-15 00:10:15.000000', 'temperatura', 289.0000, 'ºC'),
	(66836, 112, '2015-02-15 00:10:16.000000', 'temperatura', 225.0000, 'ºC'),
	(66837, 112, '2015-02-15 00:10:17.000000', 'temperatura', 257.0000, 'ºC'),
	(66838, 112, '2015-02-15 00:10:18.000000', 'temperatura', 613.0000, 'ºC'),
	(66839, 112, '2015-02-15 00:10:19.000000', 'temperatura', 1093.0000, 'ºC'),
	(66840, 112, '2015-02-15 00:10:20.000000', 'temperatura', 26.0000, 'ºC'),
	(66841, 112, '2015-02-15 00:10:21.000000', 'temperatura', 451.0000, 'ºC'),
	(66842, 112, '2015-02-15 00:10:22.000000', 'temperatura', 980.0000, 'ºC'),
	(66843, 112, '2015-02-15 00:10:23.000000', 'temperatura', 1147.0000, 'ºC'),
	(66844, 112, '2015-02-15 00:10:24.000000', 'temperatura', 394.0000, 'ºC'),
	(66845, 112, '2015-02-15 00:10:25.000000', 'temperatura', 929.0000, 'ºC'),
	(66846, 112, '2015-02-15 00:10:26.000000', 'temperatura', 1065.0000, 'ºC'),
	(66847, 112, '2015-02-15 00:10:27.000000', 'temperatura', 139.0000, 'ºC'),
	(66848, 112, '2015-02-15 00:10:28.000000', 'temperatura', 1101.0000, 'ºC'),
	(66849, 112, '2015-02-15 00:10:29.000000', 'temperatura', 286.0000, 'ºC'),
	(66850, 112, '2015-02-15 00:10:30.000000', 'temperatura', 529.0000, 'ºC'),
	(66851, 112, '2015-02-15 00:10:31.000000', 'temperatura', 589.0000, 'ºC'),
	(66852, 112, '2015-02-15 00:10:32.000000', 'temperatura', 158.0000, 'ºC'),
	(66853, 112, '2015-02-15 00:10:33.000000', 'temperatura', 224.0000, 'ºC'),
	(66854, 112, '2015-02-15 00:10:34.000000', 'temperatura', 648.0000, 'ºC'),
	(66855, 112, '2015-02-15 00:10:35.000000', 'temperatura', 166.0000, 'ºC'),
	(66856, 112, '2015-02-15 00:10:36.000000', 'temperatura', 87.0000, 'ºC'),
	(66857, 112, '2015-02-15 00:10:37.000000', 'temperatura', 1138.0000, 'ºC'),
	(66858, 112, '2015-02-15 00:10:38.000000', 'temperatura', 630.0000, 'ºC'),
	(66859, 112, '2015-02-15 00:10:39.000000', 'temperatura', 937.0000, 'ºC'),
	(66860, 112, '2015-02-15 00:10:40.000000', 'temperatura', 393.0000, 'ºC'),
	(66861, 112, '2015-02-15 00:10:41.000000', 'temperatura', 358.0000, 'ºC'),
	(66862, 112, '2015-02-15 00:10:42.000000', 'temperatura', 608.0000, 'ºC'),
	(66863, 112, '2015-02-15 00:10:43.000000', 'temperatura', 769.0000, 'ºC'),
	(66864, 112, '2015-02-15 00:10:44.000000', 'temperatura', 820.0000, 'ºC'),
	(66865, 112, '2015-02-15 00:10:45.000000', 'temperatura', 594.0000, 'ºC'),
	(66866, 112, '2015-02-15 00:10:46.000000', 'temperatura', 512.0000, 'ºC'),
	(66867, 112, '2015-02-15 00:10:47.000000', 'temperatura', 780.0000, 'ºC'),
	(66868, 112, '2015-02-15 00:10:48.000000', 'temperatura', 1161.0000, 'ºC'),
	(66869, 112, '2015-02-15 00:10:49.000000', 'temperatura', 1066.0000, 'ºC'),
	(66870, 112, '2015-02-15 00:10:50.000000', 'temperatura', 649.0000, 'ºC'),
	(66871, 112, '2015-02-15 00:10:51.000000', 'temperatura', 47.0000, 'ºC'),
	(66872, 112, '2015-02-15 00:10:52.000000', 'temperatura', 687.0000, 'ºC'),
	(66873, 112, '2015-02-15 00:10:53.000000', 'temperatura', 897.0000, 'ºC'),
	(66874, 112, '2015-02-15 00:10:54.000000', 'temperatura', 25.0000, 'ºC'),
	(66875, 112, '2015-02-15 00:10:55.000000', 'temperatura', 1032.0000, 'ºC'),
	(66876, 112, '2015-02-15 00:10:56.000000', 'temperatura', 286.0000, 'ºC'),
	(66877, 112, '2015-02-15 00:10:57.000000', 'temperatura', 735.0000, 'ºC'),
	(66878, 112, '2015-02-15 00:10:58.000000', 'temperatura', 416.0000, 'ºC'),
	(66879, 112, '2015-02-15 00:10:59.000000', 'temperatura', 1079.0000, 'ºC'),
	(66880, 112, '2015-02-15 00:11:00.000000', 'temperatura', 544.0000, 'ºC'),
	(66881, 112, '2015-02-15 00:11:01.000000', 'temperatura', 684.0000, 'ºC'),
	(66882, 112, '2015-02-15 00:11:02.000000', 'temperatura', 587.0000, 'ºC'),
	(66883, 112, '2015-02-15 00:11:03.000000', 'temperatura', 887.0000, 'ºC'),
	(66884, 112, '2015-02-15 00:11:04.000000', 'temperatura', 271.0000, 'ºC'),
	(66885, 112, '2015-02-15 00:11:05.000000', 'temperatura', 1096.0000, 'ºC'),
	(66886, 112, '2015-02-15 00:11:06.000000', 'temperatura', 1067.0000, 'ºC'),
	(66887, 112, '2015-02-15 00:11:07.000000', 'temperatura', 849.0000, 'ºC'),
	(66888, 112, '2015-02-15 00:11:08.000000', 'temperatura', 1043.0000, 'ºC'),
	(66889, 112, '2015-02-15 00:11:09.000000', 'temperatura', 268.0000, 'ºC'),
	(66890, 112, '2015-02-15 00:11:10.000000', 'temperatura', 614.0000, 'ºC'),
	(66891, 112, '2015-02-15 00:11:11.000000', 'temperatura', 1065.0000, 'ºC'),
	(66892, 112, '2015-02-15 00:11:12.000000', 'temperatura', 1083.0000, 'ºC'),
	(66893, 112, '2015-02-15 00:11:13.000000', 'temperatura', 1023.0000, 'ºC'),
	(66894, 112, '2015-02-15 00:11:14.000000', 'temperatura', 665.0000, 'ºC'),
	(66895, 112, '2015-02-15 00:11:15.000000', 'temperatura', 257.0000, 'ºC'),
	(66896, 112, '2015-02-15 00:11:16.000000', 'temperatura', 490.0000, 'ºC'),
	(66897, 112, '2015-02-15 00:11:17.000000', 'temperatura', 478.0000, 'ºC'),
	(66898, 112, '2015-02-15 00:11:18.000000', 'temperatura', 923.0000, 'ºC'),
	(66899, 112, '2015-02-15 00:11:19.000000', 'temperatura', 778.0000, 'ºC'),
	(66900, 112, '2015-02-15 00:11:20.000000', 'temperatura', 1125.0000, 'ºC'),
	(66901, 112, '2015-02-15 00:11:21.000000', 'temperatura', 892.0000, 'ºC'),
	(66902, 112, '2015-02-15 00:11:22.000000', 'temperatura', 1083.0000, 'ºC'),
	(66903, 112, '2015-02-15 00:11:23.000000', 'temperatura', 339.0000, 'ºC'),
	(66904, 112, '2015-02-15 00:11:24.000000', 'temperatura', 847.0000, 'ºC'),
	(66905, 112, '2015-02-15 00:11:25.000000', 'temperatura', 818.0000, 'ºC'),
	(66906, 112, '2015-02-15 00:11:26.000000', 'temperatura', 349.0000, 'ºC'),
	(66907, 112, '2015-02-15 00:11:27.000000', 'temperatura', 491.0000, 'ºC'),
	(66908, 112, '2015-02-15 00:11:28.000000', 'temperatura', 209.0000, 'ºC'),
	(66909, 112, '2015-02-15 00:11:29.000000', 'temperatura', 773.0000, 'ºC'),
	(66910, 112, '2015-02-15 00:11:30.000000', 'temperatura', 838.0000, 'ºC'),
	(66911, 112, '2015-02-15 00:11:31.000000', 'temperatura', 671.0000, 'ºC'),
	(66912, 112, '2015-02-15 00:11:32.000000', 'temperatura', 842.0000, 'ºC'),
	(66913, 112, '2015-02-15 00:11:33.000000', 'temperatura', 998.0000, 'ºC'),
	(66914, 112, '2015-02-15 00:11:34.000000', 'temperatura', 65.0000, 'ºC'),
	(66915, 112, '2015-02-15 00:11:35.000000', 'temperatura', 931.0000, 'ºC'),
	(66916, 112, '2015-02-15 00:11:36.000000', 'temperatura', 861.0000, 'ºC'),
	(66917, 112, '2015-02-15 00:11:37.000000', 'temperatura', 312.0000, 'ºC'),
	(66918, 112, '2015-02-15 00:11:38.000000', 'temperatura', 179.0000, 'ºC'),
	(66919, 112, '2015-02-15 00:11:39.000000', 'temperatura', 1160.0000, 'ºC'),
	(66920, 112, '2015-02-15 00:11:40.000000', 'temperatura', 462.0000, 'ºC'),
	(66921, 112, '2015-02-15 00:11:41.000000', 'temperatura', 32.0000, 'ºC'),
	(66922, 112, '2015-02-15 00:11:42.000000', 'temperatura', 1175.0000, 'ºC'),
	(66923, 112, '2015-02-15 00:11:43.000000', 'temperatura', 978.0000, 'ºC'),
	(66924, 112, '2015-02-15 00:11:44.000000', 'temperatura', 166.0000, 'ºC'),
	(66925, 112, '2015-02-15 00:11:45.000000', 'temperatura', 297.0000, 'ºC'),
	(66926, 112, '2015-02-15 00:11:46.000000', 'temperatura', 989.0000, 'ºC'),
	(66927, 112, '2015-02-15 00:11:47.000000', 'temperatura', 451.0000, 'ºC'),
	(66928, 112, '2015-02-15 00:11:48.000000', 'temperatura', 490.0000, 'ºC'),
	(66929, 112, '2015-02-15 00:11:49.000000', 'temperatura', 1098.0000, 'ºC'),
	(66930, 112, '2015-02-15 00:11:50.000000', 'temperatura', 422.0000, 'ºC'),
	(66931, 112, '2015-02-15 00:11:51.000000', 'temperatura', 15.0000, 'ºC'),
	(66932, 112, '2015-02-15 00:11:52.000000', 'temperatura', 10.0000, 'ºC'),
	(66933, 112, '2015-02-15 00:11:53.000000', 'temperatura', 3.0000, 'ºC'),
	(66934, 112, '2015-02-15 00:11:54.000000', 'temperatura', 1189.0000, 'ºC'),
	(66935, 112, '2015-02-15 00:11:55.000000', 'temperatura', 1136.0000, 'ºC'),
	(66936, 112, '2015-02-15 00:11:56.000000', 'temperatura', 912.0000, 'ºC'),
	(66937, 112, '2015-02-15 00:11:57.000000', 'temperatura', 1151.0000, 'ºC'),
	(66938, 112, '2015-02-15 00:11:58.000000', 'temperatura', 621.0000, 'ºC'),
	(66939, 112, '2015-02-15 00:11:59.000000', 'temperatura', 855.0000, 'ºC'),
	(66940, 112, '2015-02-15 00:12:00.000000', 'temperatura', 9.0000, 'ºC'),
	(66941, 112, '2015-02-15 00:12:01.000000', 'temperatura', 1081.0000, 'ºC'),
	(66942, 112, '2015-02-15 00:12:02.000000', 'temperatura', 577.0000, 'ºC'),
	(66943, 112, '2015-02-15 00:12:03.000000', 'temperatura', 845.0000, 'ºC'),
	(66944, 112, '2015-02-15 00:12:04.000000', 'temperatura', 96.0000, 'ºC'),
	(66945, 112, '2015-02-15 00:12:05.000000', 'temperatura', 342.0000, 'ºC'),
	(66946, 112, '2015-02-15 00:12:06.000000', 'temperatura', 223.0000, 'ºC'),
	(66947, 112, '2015-02-15 00:12:07.000000', 'temperatura', 91.0000, 'ºC'),
	(66948, 112, '2015-02-15 00:12:08.000000', 'temperatura', 988.0000, 'ºC'),
	(66949, 112, '2015-02-15 00:12:09.000000', 'temperatura', 1065.0000, 'ºC'),
	(66950, 112, '2015-02-15 00:12:10.000000', 'temperatura', 1160.0000, 'ºC'),
	(66951, 112, '2015-02-15 00:12:11.000000', 'temperatura', 209.0000, 'ºC'),
	(66952, 112, '2015-02-15 00:12:12.000000', 'temperatura', 1163.0000, 'ºC'),
	(66953, 112, '2015-02-15 00:12:13.000000', 'temperatura', 391.0000, 'ºC'),
	(66954, 112, '2015-02-15 00:12:14.000000', 'temperatura', 866.0000, 'ºC'),
	(66955, 112, '2015-02-15 00:12:15.000000', 'temperatura', 757.0000, 'ºC'),
	(66956, 112, '2015-02-15 00:12:16.000000', 'temperatura', 1187.0000, 'ºC'),
	(66957, 112, '2015-02-15 00:12:17.000000', 'temperatura', 65.0000, 'ºC'),
	(66958, 112, '2015-02-15 00:12:18.000000', 'temperatura', 363.0000, 'ºC'),
	(66959, 112, '2015-02-15 00:12:19.000000', 'temperatura', 420.0000, 'ºC'),
	(66960, 112, '2015-02-15 00:12:20.000000', 'temperatura', 1013.0000, 'ºC'),
	(66961, 112, '2015-02-15 00:12:21.000000', 'temperatura', 205.0000, 'ºC'),
	(66962, 112, '2015-02-15 00:12:22.000000', 'temperatura', 387.0000, 'ºC'),
	(66963, 112, '2015-02-15 00:12:23.000000', 'temperatura', 121.0000, 'ºC'),
	(66964, 112, '2015-02-15 00:12:24.000000', 'temperatura', 642.0000, 'ºC'),
	(66965, 112, '2015-02-15 00:12:25.000000', 'temperatura', 450.0000, 'ºC'),
	(66966, 112, '2015-02-15 00:12:26.000000', 'temperatura', 324.0000, 'ºC'),
	(66967, 112, '2015-02-15 00:12:27.000000', 'temperatura', 269.0000, 'ºC'),
	(66968, 112, '2015-02-15 00:12:28.000000', 'temperatura', 376.0000, 'ºC'),
	(66969, 112, '2015-02-15 00:12:29.000000', 'temperatura', 1073.0000, 'ºC'),
	(66970, 112, '2015-02-15 00:12:30.000000', 'temperatura', 639.0000, 'ºC'),
	(66971, 112, '2015-02-15 00:12:31.000000', 'temperatura', 1175.0000, 'ºC'),
	(66972, 112, '2015-02-15 00:12:32.000000', 'temperatura', 357.0000, 'ºC'),
	(66973, 112, '2015-02-15 00:12:33.000000', 'temperatura', 662.0000, 'ºC'),
	(66974, 112, '2015-02-15 00:12:34.000000', 'temperatura', 1040.0000, 'ºC'),
	(66975, 112, '2015-02-15 00:12:35.000000', 'temperatura', 814.0000, 'ºC'),
	(66976, 112, '2015-02-15 00:12:36.000000', 'temperatura', 949.0000, 'ºC'),
	(66977, 112, '2015-02-15 00:12:37.000000', 'temperatura', 1103.0000, 'ºC'),
	(66978, 112, '2015-02-15 00:12:38.000000', 'temperatura', 271.0000, 'ºC'),
	(66979, 112, '2015-02-15 00:12:39.000000', 'temperatura', 447.0000, 'ºC'),
	(66980, 112, '2015-02-15 00:12:40.000000', 'temperatura', 221.0000, 'ºC'),
	(66981, 112, '2015-02-15 00:12:41.000000', 'temperatura', 967.0000, 'ºC'),
	(66982, 112, '2015-02-15 00:12:42.000000', 'temperatura', 569.0000, 'ºC'),
	(66983, 112, '2015-02-15 00:12:43.000000', 'temperatura', 1145.0000, 'ºC'),
	(66984, 112, '2015-02-15 00:12:44.000000', 'temperatura', 421.0000, 'ºC'),
	(66985, 112, '2015-02-15 00:12:45.000000', 'temperatura', 1067.0000, 'ºC'),
	(66986, 112, '2015-02-15 00:12:46.000000', 'temperatura', 476.0000, 'ºC'),
	(66987, 112, '2015-02-15 00:12:47.000000', 'temperatura', 378.0000, 'ºC'),
	(66988, 112, '2015-02-15 00:12:48.000000', 'temperatura', 465.0000, 'ºC'),
	(66989, 112, '2015-02-15 00:12:49.000000', 'temperatura', 1188.0000, 'ºC'),
	(66990, 112, '2015-02-15 00:12:50.000000', 'temperatura', 946.0000, 'ºC'),
	(66991, 112, '2015-02-15 00:12:51.000000', 'temperatura', 1166.0000, 'ºC'),
	(66992, 112, '2015-02-15 00:12:52.000000', 'temperatura', 591.0000, 'ºC'),
	(66993, 112, '2015-02-15 00:12:53.000000', 'temperatura', 660.0000, 'ºC'),
	(66994, 112, '2015-02-15 00:12:54.000000', 'temperatura', 326.0000, 'ºC'),
	(66995, 112, '2015-02-15 00:12:55.000000', 'temperatura', 849.0000, 'ºC'),
	(66996, 112, '2015-02-15 00:12:56.000000', 'temperatura', 869.0000, 'ºC'),
	(66997, 112, '2015-02-15 00:12:57.000000', 'temperatura', 598.0000, 'ºC'),
	(66998, 112, '2015-02-15 00:12:58.000000', 'temperatura', 383.0000, 'ºC'),
	(66999, 112, '2015-02-15 00:12:59.000000', 'temperatura', 123.0000, 'ºC'),
	(67000, 112, '2015-02-15 00:13:00.000000', 'temperatura', 667.0000, 'ºC'),
	(67001, 112, '2015-02-15 00:13:01.000000', 'temperatura', 568.0000, 'ºC'),
	(67002, 112, '2015-02-15 00:13:02.000000', 'temperatura', 837.0000, 'ºC'),
	(67003, 112, '2015-02-15 00:13:03.000000', 'temperatura', 82.0000, 'ºC'),
	(67004, 112, '2015-02-15 00:13:04.000000', 'temperatura', 298.0000, 'ºC'),
	(67005, 112, '2015-02-15 00:13:05.000000', 'temperatura', 46.0000, 'ºC'),
	(67006, 112, '2015-02-15 00:13:06.000000', 'temperatura', 535.0000, 'ºC'),
	(67007, 112, '2015-02-15 00:13:07.000000', 'temperatura', 136.0000, 'ºC'),
	(67008, 112, '2015-02-15 00:13:08.000000', 'temperatura', 279.0000, 'ºC'),
	(67009, 112, '2015-02-15 00:13:09.000000', 'temperatura', 985.0000, 'ºC'),
	(67010, 112, '2015-02-15 00:13:10.000000', 'temperatura', 490.0000, 'ºC'),
	(67011, 112, '2015-02-15 00:13:11.000000', 'temperatura', 695.0000, 'ºC'),
	(67012, 112, '2015-02-15 00:13:12.000000', 'temperatura', 804.0000, 'ºC'),
	(67013, 112, '2015-02-15 00:13:13.000000', 'temperatura', 735.0000, 'ºC'),
	(67014, 112, '2015-02-15 00:13:14.000000', 'temperatura', 65.0000, 'ºC'),
	(67015, 112, '2015-02-15 00:13:15.000000', 'temperatura', 521.0000, 'ºC'),
	(67016, 112, '2015-02-15 00:13:16.000000', 'temperatura', 8.0000, 'ºC'),
	(67017, 112, '2015-02-15 00:13:17.000000', 'temperatura', 879.0000, 'ºC'),
	(67018, 112, '2015-02-15 00:13:18.000000', 'temperatura', 773.0000, 'ºC'),
	(67019, 112, '2015-02-15 00:13:19.000000', 'temperatura', 28.0000, 'ºC'),
	(67020, 112, '2015-02-15 00:13:20.000000', 'temperatura', 220.0000, 'ºC'),
	(67021, 112, '2015-02-15 00:13:21.000000', 'temperatura', 1016.0000, 'ºC'),
	(67022, 112, '2015-02-15 00:13:22.000000', 'temperatura', 821.0000, 'ºC'),
	(67023, 112, '2015-02-15 00:13:23.000000', 'temperatura', 1060.0000, 'ºC'),
	(67024, 112, '2015-02-15 00:13:24.000000', 'temperatura', 435.0000, 'ºC'),
	(67025, 112, '2015-02-15 00:13:25.000000', 'temperatura', 198.0000, 'ºC'),
	(67026, 112, '2015-02-15 00:13:26.000000', 'temperatura', 885.0000, 'ºC'),
	(67027, 112, '2015-02-15 00:13:27.000000', 'temperatura', 232.0000, 'ºC'),
	(67028, 112, '2015-02-15 00:13:28.000000', 'temperatura', 905.0000, 'ºC'),
	(67029, 112, '2015-02-15 00:13:29.000000', 'temperatura', 229.0000, 'ºC'),
	(67030, 112, '2015-02-15 00:13:30.000000', 'temperatura', 831.0000, 'ºC'),
	(67031, 112, '2015-02-15 00:13:31.000000', 'temperatura', 1070.0000, 'ºC'),
	(67032, 112, '2015-02-15 00:13:32.000000', 'temperatura', 458.0000, 'ºC'),
	(67033, 112, '2015-02-15 00:13:33.000000', 'temperatura', 280.0000, 'ºC'),
	(67034, 112, '2015-02-15 00:13:34.000000', 'temperatura', 24.0000, 'ºC'),
	(67035, 112, '2015-02-15 00:13:35.000000', 'temperatura', 482.0000, 'ºC'),
	(67036, 112, '2015-02-15 00:13:36.000000', 'temperatura', 1138.0000, 'ºC'),
	(67037, 112, '2015-02-15 00:13:37.000000', 'temperatura', 645.0000, 'ºC'),
	(67038, 112, '2015-02-15 00:13:38.000000', 'temperatura', 1013.0000, 'ºC'),
	(67039, 112, '2015-02-15 00:13:39.000000', 'temperatura', 728.0000, 'ºC'),
	(67040, 112, '2015-02-15 00:13:40.000000', 'temperatura', 603.0000, 'ºC'),
	(67041, 112, '2015-02-15 00:13:41.000000', 'temperatura', 830.0000, 'ºC'),
	(67042, 112, '2015-02-15 00:13:42.000000', 'temperatura', 1144.0000, 'ºC'),
	(67043, 112, '2015-02-15 00:13:43.000000', 'temperatura', 830.0000, 'ºC'),
	(67044, 112, '2015-02-15 00:13:44.000000', 'temperatura', 720.0000, 'ºC'),
	(67045, 112, '2015-02-15 00:13:45.000000', 'temperatura', 1109.0000, 'ºC'),
	(67046, 112, '2015-02-15 00:13:46.000000', 'temperatura', 986.0000, 'ºC'),
	(67047, 112, '2015-02-15 00:13:47.000000', 'temperatura', 403.0000, 'ºC'),
	(67048, 112, '2015-02-15 00:13:48.000000', 'temperatura', 257.0000, 'ºC'),
	(67049, 112, '2015-02-15 00:13:49.000000', 'temperatura', 77.0000, 'ºC'),
	(67050, 112, '2015-02-15 00:13:50.000000', 'temperatura', 813.0000, 'ºC'),
	(67051, 112, '2015-02-15 00:13:51.000000', 'temperatura', 234.0000, 'ºC'),
	(67052, 112, '2015-02-15 00:13:52.000000', 'temperatura', 1133.0000, 'ºC'),
	(67053, 112, '2015-02-15 00:13:53.000000', 'temperatura', 162.0000, 'ºC'),
	(67054, 112, '2015-02-15 00:13:54.000000', 'temperatura', 1011.0000, 'ºC'),
	(67055, 112, '2015-02-15 00:13:55.000000', 'temperatura', 969.0000, 'ºC'),
	(67056, 112, '2015-02-15 00:13:56.000000', 'temperatura', 613.0000, 'ºC'),
	(67057, 112, '2015-02-15 00:13:57.000000', 'temperatura', 158.0000, 'ºC'),
	(67058, 112, '2015-02-15 00:13:58.000000', 'temperatura', 150.0000, 'ºC'),
	(67059, 112, '2015-02-15 00:13:59.000000', 'temperatura', 278.0000, 'ºC'),
	(67060, 112, '2015-02-15 00:14:00.000000', 'temperatura', 942.0000, 'ºC'),
	(67061, 112, '2015-02-15 00:14:01.000000', 'temperatura', 277.0000, 'ºC'),
	(67062, 112, '2015-02-15 00:14:02.000000', 'temperatura', 957.0000, 'ºC'),
	(67063, 112, '2015-02-15 00:14:03.000000', 'temperatura', 354.0000, 'ºC'),
	(67064, 112, '2015-02-15 00:14:04.000000', 'temperatura', 100.0000, 'ºC'),
	(67065, 112, '2015-02-15 00:14:05.000000', 'temperatura', 637.0000, 'ºC'),
	(67066, 112, '2015-02-15 00:14:06.000000', 'temperatura', 488.0000, 'ºC'),
	(67067, 112, '2015-02-15 00:14:07.000000', 'temperatura', 530.0000, 'ºC'),
	(67068, 112, '2015-02-15 00:14:08.000000', 'temperatura', 1184.0000, 'ºC'),
	(67069, 112, '2015-02-15 00:14:09.000000', 'temperatura', 730.0000, 'ºC'),
	(67070, 112, '2015-02-15 00:14:10.000000', 'temperatura', 101.0000, 'ºC'),
	(67071, 112, '2015-02-15 00:14:11.000000', 'temperatura', 716.0000, 'ºC'),
	(67072, 112, '2015-02-15 00:14:12.000000', 'temperatura', 878.0000, 'ºC'),
	(67073, 112, '2015-02-15 00:14:13.000000', 'temperatura', 1040.0000, 'ºC'),
	(67074, 112, '2015-02-15 00:14:14.000000', 'temperatura', 169.0000, 'ºC'),
	(67075, 112, '2015-02-15 00:14:15.000000', 'temperatura', 126.0000, 'ºC'),
	(67076, 112, '2015-02-15 00:14:16.000000', 'temperatura', 121.0000, 'ºC'),
	(67077, 112, '2015-02-15 00:14:17.000000', 'temperatura', 227.0000, 'ºC'),
	(67078, 112, '2015-02-15 00:14:18.000000', 'temperatura', 775.0000, 'ºC'),
	(67079, 112, '2015-02-15 00:14:19.000000', 'temperatura', 792.0000, 'ºC'),
	(67080, 112, '2015-02-15 00:14:20.000000', 'temperatura', 435.0000, 'ºC'),
	(67081, 112, '2015-02-15 00:14:21.000000', 'temperatura', 1000.0000, 'ºC'),
	(67082, 112, '2015-02-15 00:14:22.000000', 'temperatura', 97.0000, 'ºC'),
	(67083, 112, '2015-02-15 00:14:23.000000', 'temperatura', 1086.0000, 'ºC'),
	(67084, 112, '2015-02-15 00:14:24.000000', 'temperatura', 337.0000, 'ºC'),
	(67085, 112, '2015-02-15 00:14:25.000000', 'temperatura', 827.0000, 'ºC'),
	(67086, 112, '2015-02-15 00:14:26.000000', 'temperatura', 726.0000, 'ºC'),
	(67087, 112, '2015-02-15 00:14:27.000000', 'temperatura', 1148.0000, 'ºC'),
	(67088, 112, '2015-02-15 00:14:28.000000', 'temperatura', 1163.0000, 'ºC'),
	(67089, 112, '2015-02-15 00:14:29.000000', 'temperatura', 1172.0000, 'ºC'),
	(67090, 112, '2015-02-15 00:14:30.000000', 'temperatura', 1171.0000, 'ºC'),
	(67091, 112, '2015-02-15 00:14:31.000000', 'temperatura', 1138.0000, 'ºC'),
	(67092, 112, '2015-02-15 00:14:32.000000', 'temperatura', 981.0000, 'ºC'),
	(67093, 112, '2015-02-15 00:14:33.000000', 'temperatura', 288.0000, 'ºC'),
	(67094, 112, '2015-02-15 00:14:34.000000', 'temperatura', 899.0000, 'ºC'),
	(67095, 112, '2015-02-15 00:14:35.000000', 'temperatura', 29.0000, 'ºC'),
	(67096, 112, '2015-02-15 00:14:36.000000', 'temperatura', 1051.0000, 'ºC'),
	(67097, 112, '2015-02-15 00:14:37.000000', 'temperatura', 369.0000, 'ºC'),
	(67098, 112, '2015-02-15 00:14:38.000000', 'temperatura', 1092.0000, 'ºC'),
	(67099, 112, '2015-02-15 00:14:39.000000', 'temperatura', 754.0000, 'ºC'),
	(67100, 112, '2015-02-15 00:14:40.000000', 'temperatura', 494.0000, 'ºC'),
	(67101, 112, '2015-02-15 00:14:41.000000', 'temperatura', 207.0000, 'ºC'),
	(67102, 112, '2015-02-15 00:14:42.000000', 'temperatura', 756.0000, 'ºC'),
	(67103, 112, '2015-02-15 00:14:43.000000', 'temperatura', 759.0000, 'ºC'),
	(67104, 112, '2015-02-15 00:14:44.000000', 'temperatura', 326.0000, 'ºC'),
	(67105, 112, '2015-02-15 00:14:45.000000', 'temperatura', 556.0000, 'ºC'),
	(67106, 112, '2015-02-15 00:14:46.000000', 'temperatura', 601.0000, 'ºC'),
	(67107, 112, '2015-02-15 00:14:47.000000', 'temperatura', 137.0000, 'ºC'),
	(67108, 112, '2015-02-15 00:14:48.000000', 'temperatura', 81.0000, 'ºC'),
	(67109, 112, '2015-02-15 00:14:49.000000', 'temperatura', 1196.0000, 'ºC'),
	(67110, 112, '2015-02-15 00:14:50.000000', 'temperatura', 937.0000, 'ºC'),
	(67111, 112, '2015-02-15 00:14:51.000000', 'temperatura', 1098.0000, 'ºC'),
	(67112, 112, '2015-02-15 00:14:52.000000', 'temperatura', 277.0000, 'ºC'),
	(67113, 112, '2015-02-15 00:14:53.000000', 'temperatura', 495.0000, 'ºC'),
	(67114, 112, '2015-02-15 00:14:54.000000', 'temperatura', 444.0000, 'ºC'),
	(67115, 112, '2015-02-15 00:14:55.000000', 'temperatura', 735.0000, 'ºC'),
	(67116, 112, '2015-02-15 00:14:56.000000', 'temperatura', 1145.0000, 'ºC'),
	(67117, 112, '2015-02-15 00:14:57.000000', 'temperatura', 1118.0000, 'ºC'),
	(67118, 112, '2015-02-15 00:14:58.000000', 'temperatura', 957.0000, 'ºC'),
	(67119, 112, '2015-02-15 00:14:59.000000', 'temperatura', 231.0000, 'ºC'),
	(67120, 112, '2015-02-15 00:15:00.000000', 'temperatura', 685.0000, 'ºC'),
	(67121, 112, '2015-02-15 00:15:01.000000', 'temperatura', 332.0000, 'ºC'),
	(67122, 112, '2015-02-15 00:15:02.000000', 'temperatura', 805.0000, 'ºC'),
	(67123, 112, '2015-02-15 00:15:03.000000', 'temperatura', 630.0000, 'ºC'),
	(67124, 112, '2015-02-15 00:15:04.000000', 'temperatura', 735.0000, 'ºC'),
	(67125, 112, '2015-02-15 00:15:05.000000', 'temperatura', 584.0000, 'ºC'),
	(67126, 112, '2015-02-15 00:15:06.000000', 'temperatura', 717.0000, 'ºC'),
	(67127, 112, '2015-02-15 00:15:07.000000', 'temperatura', 635.0000, 'ºC'),
	(67128, 112, '2015-02-15 00:15:08.000000', 'temperatura', 1025.0000, 'ºC'),
	(67129, 112, '2015-02-15 00:15:09.000000', 'temperatura', 821.0000, 'ºC'),
	(67130, 112, '2015-02-15 00:15:10.000000', 'temperatura', 1029.0000, 'ºC'),
	(67131, 112, '2015-02-15 00:15:11.000000', 'temperatura', 283.0000, 'ºC'),
	(67132, 112, '2015-02-15 00:15:12.000000', 'temperatura', 730.0000, 'ºC'),
	(67133, 112, '2015-02-15 00:15:13.000000', 'temperatura', 402.0000, 'ºC'),
	(67134, 112, '2015-02-15 00:15:14.000000', 'temperatura', 1020.0000, 'ºC'),
	(67135, 112, '2015-02-15 00:15:15.000000', 'temperatura', 294.0000, 'ºC'),
	(67136, 112, '2015-02-15 00:15:16.000000', 'temperatura', 811.0000, 'ºC'),
	(67137, 112, '2015-02-15 00:15:17.000000', 'temperatura', 771.0000, 'ºC'),
	(67138, 112, '2015-02-15 00:15:18.000000', 'temperatura', 225.0000, 'ºC'),
	(67139, 112, '2015-02-15 00:15:19.000000', 'temperatura', 13.0000, 'ºC'),
	(67140, 112, '2015-02-15 00:15:20.000000', 'temperatura', 592.0000, 'ºC'),
	(67141, 112, '2015-02-15 00:15:21.000000', 'temperatura', 518.0000, 'ºC'),
	(67142, 112, '2015-02-15 00:15:22.000000', 'temperatura', 815.0000, 'ºC'),
	(67143, 112, '2015-02-15 00:15:23.000000', 'temperatura', 122.0000, 'ºC'),
	(67144, 112, '2015-02-15 00:15:24.000000', 'temperatura', 567.0000, 'ºC'),
	(67145, 112, '2015-02-15 00:15:25.000000', 'temperatura', 67.0000, 'ºC'),
	(67146, 112, '2015-02-15 00:15:26.000000', 'temperatura', 1035.0000, 'ºC'),
	(67147, 112, '2015-02-15 00:15:27.000000', 'temperatura', 174.0000, 'ºC'),
	(67148, 112, '2015-02-15 00:15:28.000000', 'temperatura', 164.0000, 'ºC'),
	(67149, 112, '2015-02-15 00:15:29.000000', 'temperatura', 301.0000, 'ºC'),
	(67150, 112, '2015-02-15 00:15:30.000000', 'temperatura', 1013.0000, 'ºC'),
	(67151, 112, '2015-02-15 00:15:31.000000', 'temperatura', 561.0000, 'ºC'),
	(67152, 112, '2015-02-15 00:15:32.000000', 'temperatura', 966.0000, 'ºC'),
	(67153, 112, '2015-02-15 00:15:33.000000', 'temperatura', 749.0000, 'ºC'),
	(67154, 112, '2015-02-15 00:15:34.000000', 'temperatura', 848.0000, 'ºC'),
	(67155, 112, '2015-02-15 00:15:35.000000', 'temperatura', 795.0000, 'ºC'),
	(67156, 112, '2015-02-15 00:15:36.000000', 'temperatura', 229.0000, 'ºC'),
	(67157, 112, '2015-02-15 00:15:37.000000', 'temperatura', 1160.0000, 'ºC'),
	(67158, 112, '2015-02-15 00:15:38.000000', 'temperatura', 313.0000, 'ºC'),
	(67159, 112, '2015-02-15 00:15:39.000000', 'temperatura', 488.0000, 'ºC'),
	(67160, 112, '2015-02-15 00:15:40.000000', 'temperatura', 300.0000, 'ºC'),
	(67161, 112, '2015-02-15 00:15:41.000000', 'temperatura', 39.0000, 'ºC'),
	(67162, 112, '2015-02-15 00:15:42.000000', 'temperatura', 493.0000, 'ºC'),
	(67163, 112, '2015-02-15 00:15:43.000000', 'temperatura', 1150.0000, 'ºC'),
	(67164, 112, '2015-02-15 00:15:44.000000', 'temperatura', 669.0000, 'ºC'),
	(67165, 112, '2015-02-15 00:15:45.000000', 'temperatura', 1097.0000, 'ºC'),
	(67166, 112, '2015-02-15 00:15:46.000000', 'temperatura', 1078.0000, 'ºC'),
	(67167, 112, '2015-02-15 00:15:47.000000', 'temperatura', 900.0000, 'ºC'),
	(67168, 112, '2015-02-15 00:15:48.000000', 'temperatura', 66.0000, 'ºC'),
	(67169, 112, '2015-02-15 00:15:49.000000', 'temperatura', 31.0000, 'ºC'),
	(67170, 112, '2015-02-15 00:15:50.000000', 'temperatura', 1155.0000, 'ºC'),
	(67171, 112, '2015-02-15 00:15:51.000000', 'temperatura', 886.0000, 'ºC'),
	(67172, 112, '2015-02-15 00:15:52.000000', 'temperatura', 962.0000, 'ºC'),
	(67173, 112, '2015-02-15 00:15:53.000000', 'temperatura', 956.0000, 'ºC'),
	(67174, 112, '2015-02-15 00:15:54.000000', 'temperatura', 692.0000, 'ºC'),
	(67175, 112, '2015-02-15 00:15:55.000000', 'temperatura', 594.0000, 'ºC'),
	(67176, 112, '2015-02-15 00:15:56.000000', 'temperatura', 893.0000, 'ºC'),
	(67177, 112, '2015-02-15 00:15:57.000000', 'temperatura', 283.0000, 'ºC'),
	(67178, 112, '2015-02-15 00:15:58.000000', 'temperatura', 1135.0000, 'ºC'),
	(67179, 112, '2015-02-15 00:15:59.000000', 'temperatura', 30.0000, 'ºC'),
	(67180, 112, '2015-02-15 00:16:00.000000', 'temperatura', 344.0000, 'ºC'),
	(67181, 112, '2015-02-15 00:16:01.000000', 'temperatura', 430.0000, 'ºC'),
	(67182, 112, '2015-02-15 00:16:02.000000', 'temperatura', 1120.0000, 'ºC'),
	(67183, 112, '2015-02-15 00:16:03.000000', 'temperatura', 709.0000, 'ºC'),
	(67184, 112, '2015-02-15 00:16:04.000000', 'temperatura', 185.0000, 'ºC'),
	(67185, 112, '2015-02-15 00:16:05.000000', 'temperatura', 1198.0000, 'ºC'),
	(67186, 112, '2015-02-15 00:16:06.000000', 'temperatura', 636.0000, 'ºC'),
	(67187, 112, '2015-02-15 00:16:07.000000', 'temperatura', 788.0000, 'ºC'),
	(67188, 112, '2015-02-15 00:16:08.000000', 'temperatura', 831.0000, 'ºC'),
	(67189, 112, '2015-02-15 00:16:09.000000', 'temperatura', 591.0000, 'ºC'),
	(67190, 112, '2015-02-15 00:16:10.000000', 'temperatura', 465.0000, 'ºC'),
	(67191, 112, '2015-02-15 00:16:11.000000', 'temperatura', 552.0000, 'ºC'),
	(67192, 112, '2015-02-15 00:16:12.000000', 'temperatura', 163.0000, 'ºC'),
	(67193, 112, '2015-02-15 00:16:13.000000', 'temperatura', 363.0000, 'ºC'),
	(67194, 112, '2015-02-15 00:16:14.000000', 'temperatura', 125.0000, 'ºC'),
	(67195, 112, '2015-02-15 00:16:15.000000', 'temperatura', 736.0000, 'ºC'),
	(67196, 112, '2015-02-15 00:16:16.000000', 'temperatura', 906.0000, 'ºC'),
	(67197, 112, '2015-02-15 00:16:17.000000', 'temperatura', 1124.0000, 'ºC'),
	(67198, 112, '2015-02-15 00:16:18.000000', 'temperatura', 501.0000, 'ºC'),
	(67199, 112, '2015-02-15 00:16:19.000000', 'temperatura', 334.0000, 'ºC'),
	(67200, 112, '2015-02-15 00:16:20.000000', 'temperatura', 168.0000, 'ºC'),
	(67201, 112, '2015-02-15 00:16:21.000000', 'temperatura', 1038.0000, 'ºC'),
	(67202, 112, '2015-02-15 00:16:22.000000', 'temperatura', 1087.0000, 'ºC'),
	(67203, 112, '2015-02-15 00:16:23.000000', 'temperatura', 1119.0000, 'ºC'),
	(67204, 112, '2015-02-15 00:16:24.000000', 'temperatura', 1136.0000, 'ºC'),
	(67205, 112, '2015-02-15 00:16:25.000000', 'temperatura', 1125.0000, 'ºC'),
	(67206, 112, '2015-02-15 00:16:26.000000', 'temperatura', 1016.0000, 'ºC'),
	(67207, 112, '2015-02-15 00:16:27.000000', 'temperatura', 504.0000, 'ºC'),
	(67208, 112, '2015-02-15 00:16:28.000000', 'temperatura', 675.0000, 'ºC'),
	(67209, 112, '2015-02-15 00:16:29.000000', 'temperatura', 661.0000, 'ºC'),
	(67210, 112, '2015-02-15 00:16:30.000000', 'temperatura', 80.0000, 'ºC'),
	(67211, 112, '2015-02-15 00:16:31.000000', 'temperatura', 820.0000, 'ºC'),
	(67212, 112, '2015-02-15 00:16:32.000000', 'temperatura', 262.0000, 'ºC'),
	(67213, 112, '2015-02-15 00:16:33.000000', 'temperatura', 47.0000, 'ºC'),
	(67214, 112, '2015-02-15 00:16:34.000000', 'temperatura', 651.0000, 'ºC'),
	(67215, 112, '2015-02-15 00:16:35.000000', 'temperatura', 712.0000, 'ºC'),
	(67216, 112, '2015-02-15 00:16:36.000000', 'temperatura', 411.0000, 'ºC'),
	(67217, 112, '2015-02-15 00:16:37.000000', 'temperatura', 1118.0000, 'ºC'),
	(67218, 112, '2015-02-15 00:16:38.000000', 'temperatura', 757.0000, 'ºC'),
	(67219, 112, '2015-02-15 00:16:39.000000', 'temperatura', 433.0000, 'ºC'),
	(67220, 112, '2015-02-15 00:16:40.000000', 'temperatura', 1094.0000, 'ºC'),
	(67221, 112, '2015-02-15 00:16:41.000000', 'temperatura', 570.0000, 'ºC'),
	(67222, 112, '2015-02-15 00:16:42.000000', 'temperatura', 770.0000, 'ºC'),
	(67223, 112, '2015-02-15 00:16:43.000000', 'temperatura', 939.0000, 'ºC'),
	(67224, 112, '2015-02-15 00:16:44.000000', 'temperatura', 1188.0000, 'ºC'),
	(67225, 112, '2015-02-15 00:16:45.000000', 'temperatura', 723.0000, 'ºC'),
	(67226, 112, '2015-02-15 00:16:46.000000', 'temperatura', 52.0000, 'ºC'),
	(67227, 112, '2015-02-15 00:16:47.000000', 'temperatura', 493.0000, 'ºC'),
	(67228, 112, '2015-02-15 00:16:48.000000', 'temperatura', 1107.0000, 'ºC'),
	(67229, 112, '2015-02-15 00:16:49.000000', 'temperatura', 458.0000, 'ºC'),
	(67230, 112, '2015-02-15 00:16:50.000000', 'temperatura', 168.0000, 'ºC'),
	(67231, 112, '2015-02-15 00:16:51.000000', 'temperatura', 668.0000, 'ºC'),
	(67232, 112, '2015-02-15 00:16:52.000000', 'temperatura', 437.0000, 'ºC'),
	(67233, 112, '2015-02-15 00:16:53.000000', 'temperatura', 180.0000, 'ºC'),
	(67234, 112, '2015-02-15 00:16:54.000000', 'temperatura', 788.0000, 'ºC'),
	(67235, 112, '2015-02-15 00:16:55.000000', 'temperatura', 1002.0000, 'ºC'),
	(67236, 112, '2015-02-15 00:16:56.000000', 'temperatura', 245.0000, 'ºC'),
	(67237, 112, '2015-02-15 00:16:57.000000', 'temperatura', 621.0000, 'ºC'),
	(67238, 112, '2015-02-15 00:16:58.000000', 'temperatura', 1169.0000, 'ºC'),
	(67239, 112, '2015-02-15 00:16:59.000000', 'temperatura', 385.0000, 'ºC'),
	(67240, 112, '2015-02-15 00:17:00.000000', 'temperatura', 818.0000, 'ºC'),
	(67241, 112, '2015-02-15 00:17:01.000000', 'temperatura', 535.0000, 'ºC'),
	(67242, 112, '2015-02-15 00:17:02.000000', 'temperatura', 221.0000, 'ºC'),
	(67243, 112, '2015-02-15 00:17:03.000000', 'temperatura', 703.0000, 'ºC'),
	(67244, 112, '2015-02-15 00:17:04.000000', 'temperatura', 450.0000, 'ºC'),
	(67245, 112, '2015-02-15 00:17:05.000000', 'temperatura', 142.0000, 'ºC'),
	(67246, 112, '2015-02-15 00:17:06.000000', 'temperatura', 559.0000, 'ºC'),
	(67247, 112, '2015-02-15 00:17:07.000000', 'temperatura', 1171.0000, 'ºC'),
	(67248, 112, '2015-02-15 00:17:08.000000', 'temperatura', 579.0000, 'ºC'),
	(67249, 112, '2015-02-15 00:17:09.000000', 'temperatura', 580.0000, 'ºC'),
	(67250, 112, '2015-02-15 00:17:10.000000', 'temperatura', 1165.0000, 'ºC'),
	(67251, 112, '2015-02-15 00:17:11.000000', 'temperatura', 485.0000, 'ºC'),
	(67252, 112, '2015-02-15 00:17:12.000000', 'temperatura', 133.0000, 'ºC'),
	(67253, 112, '2015-02-15 00:17:13.000000', 'temperatura', 408.0000, 'ºC'),
	(67254, 112, '2015-02-15 00:17:14.000000', 'temperatura', 441.0000, 'ºC'),
	(67255, 112, '2015-02-15 00:17:15.000000', 'temperatura', 982.0000, 'ºC'),
	(67256, 112, '2015-02-15 00:17:16.000000', 'temperatura', 1189.0000, 'ºC'),
	(67257, 112, '2015-02-15 00:17:17.000000', 'temperatura', 599.0000, 'ºC'),
	(67258, 112, '2015-02-15 00:17:18.000000', 'temperatura', 628.0000, 'ºC'),
	(67259, 112, '2015-02-15 00:17:19.000000', 'temperatura', 143.0000, 'ºC'),
	(67260, 112, '2015-02-15 00:17:20.000000', 'temperatura', 32.0000, 'ºC'),
	(67261, 112, '2015-02-15 00:17:21.000000', 'temperatura', 932.0000, 'ºC'),
	(67262, 112, '2015-02-15 00:17:22.000000', 'temperatura', 964.0000, 'ºC'),
	(67263, 112, '2015-02-15 00:17:23.000000', 'temperatura', 826.0000, 'ºC'),
	(67264, 112, '2015-02-15 00:17:24.000000', 'temperatura', 38.0000, 'ºC'),
	(67265, 112, '2015-02-15 00:17:25.000000', 'temperatura', 112.0000, 'ºC'),
	(67266, 112, '2015-02-15 00:17:26.000000', 'temperatura', 449.0000, 'ºC'),
	(67267, 112, '2015-02-15 00:17:27.000000', 'temperatura', 706.0000, 'ºC'),
	(67268, 112, '2015-02-15 00:17:28.000000', 'temperatura', 986.0000, 'ºC'),
	(67269, 112, '2015-02-15 00:17:29.000000', 'temperatura', 410.0000, 'ºC'),
	(67270, 112, '2015-02-15 00:17:30.000000', 'temperatura', 294.0000, 'ºC'),
	(67271, 112, '2015-02-15 00:17:31.000000', 'temperatura', 241.0000, 'ºC'),
	(67272, 112, '2015-02-15 00:17:32.000000', 'temperatura', 322.0000, 'ºC'),
	(67273, 112, '2015-02-15 00:17:33.000000', 'temperatura', 889.0000, 'ºC'),
	(67274, 112, '2015-02-15 00:17:34.000000', 'temperatura', 1079.0000, 'ºC'),
	(67275, 112, '2015-02-15 00:17:35.000000', 'temperatura', 327.0000, 'ºC'),
	(67276, 112, '2015-02-15 00:17:36.000000', 'temperatura', 798.0000, 'ºC'),
	(67277, 112, '2015-02-15 00:17:37.000000', 'temperatura', 611.0000, 'ºC'),
	(67278, 112, '2015-02-15 00:17:38.000000', 'temperatura', 659.0000, 'ºC'),
	(67279, 112, '2015-02-15 00:17:39.000000', 'temperatura', 264.0000, 'ºC'),
	(67280, 112, '2015-02-15 00:17:40.000000', 'temperatura', 545.0000, 'ºC'),
	(67281, 112, '2015-02-15 00:17:41.000000', 'temperatura', 734.0000, 'ºC'),
	(67282, 112, '2015-02-15 00:17:42.000000', 'temperatura', 834.0000, 'ºC'),
	(67283, 112, '2015-02-15 00:17:43.000000', 'temperatura', 769.0000, 'ºC'),
	(67284, 112, '2015-02-15 00:17:44.000000', 'temperatura', 142.0000, 'ºC'),
	(67285, 112, '2015-02-15 00:17:45.000000', 'temperatura', 806.0000, 'ºC'),
	(67286, 112, '2015-02-15 00:17:46.000000', 'temperatura', 3.0000, 'ºC'),
	(67287, 112, '2015-02-15 00:17:47.000000', 'temperatura', 1196.0000, 'ºC'),
	(67288, 112, '2015-02-15 00:17:48.000000', 'temperatura', 1172.0000, 'ºC'),
	(67289, 112, '2015-02-15 00:17:49.000000', 'temperatura', 1075.0000, 'ºC'),
	(67290, 112, '2015-02-15 00:17:50.000000', 'temperatura', 656.0000, 'ºC'),
	(67291, 112, '2015-02-15 00:17:51.000000', 'temperatura', 59.0000, 'ºC'),
	(67292, 112, '2015-02-15 00:17:52.000000', 'temperatura', 726.0000, 'ºC'),
	(67293, 112, '2015-02-15 00:17:53.000000', 'temperatura', 1055.0000, 'ºC'),
	(67294, 112, '2015-02-15 00:17:54.000000', 'temperatura', 695.0000, 'ºC'),
	(67295, 112, '2015-02-15 00:17:55.000000', 'temperatura', 312.0000, 'ºC'),
	(67296, 112, '2015-02-15 00:17:56.000000', 'temperatura', 674.0000, 'ºC'),
	(67297, 112, '2015-02-15 00:17:57.000000', 'temperatura', 37.0000, 'ºC'),
	(67298, 112, '2015-02-15 00:17:58.000000', 'temperatura', 564.0000, 'ºC'),
	(67299, 112, '2015-02-15 00:17:59.000000', 'temperatura', 308.0000, 'ºC'),
	(67300, 112, '2015-02-15 00:18:00.000000', 'temperatura', 1047.0000, 'ºC'),
	(67301, 112, '2015-02-15 00:18:01.000000', 'temperatura', 714.0000, 'ºC'),
	(67302, 112, '2015-02-15 00:18:02.000000', 'temperatura', 428.0000, 'ºC'),
	(67303, 112, '2015-02-15 00:18:03.000000', 'temperatura', 1199.0000, 'ºC'),
	(67304, 112, '2015-02-15 00:18:04.000000', 'temperatura', 1110.0000, 'ºC'),
	(67305, 112, '2015-02-15 00:18:05.000000', 'temperatura', 756.0000, 'ºC'),
	(67306, 112, '2015-02-15 00:18:06.000000', 'temperatura', 447.0000, 'ºC'),
	(67307, 112, '2015-02-15 00:18:07.000000', 'temperatura', 1171.0000, 'ºC'),
	(67308, 112, '2015-02-15 00:18:08.000000', 'temperatura', 913.0000, 'ºC'),
	(67309, 112, '2015-02-15 00:18:09.000000', 'temperatura', 1053.0000, 'ºC'),
	(67310, 112, '2015-02-15 00:18:10.000000', 'temperatura', 125.0000, 'ºC'),
	(67311, 112, '2015-02-15 00:18:11.000000', 'temperatura', 1068.0000, 'ºC'),
	(67312, 112, '2015-02-15 00:18:12.000000', 'temperatura', 163.0000, 'ºC'),
	(67313, 112, '2015-02-15 00:18:13.000000', 'temperatura', 14.0000, 'ºC'),
	(67314, 112, '2015-02-15 00:18:14.000000', 'temperatura', 779.0000, 'ºC'),
	(67315, 112, '2015-02-15 00:18:15.000000', 'temperatura', 256.0000, 'ºC'),
	(67316, 112, '2015-02-15 00:18:16.000000', 'temperatura', 141.0000, 'ºC'),
	(67317, 112, '2015-02-15 00:18:17.000000', 'temperatura', 1137.0000, 'ºC'),
	(67318, 112, '2015-02-15 00:18:18.000000', 'temperatura', 464.0000, 'ºC'),
	(67319, 112, '2015-02-15 00:18:19.000000', 'temperatura', 108.0000, 'ºC'),
	(67320, 112, '2015-02-15 00:18:20.000000', 'temperatura', 351.0000, 'ºC'),
	(67321, 112, '2015-02-15 00:18:21.000000', 'temperatura', 230.0000, 'ºC'),
	(67322, 112, '2015-02-15 00:18:22.000000', 'temperatura', 98.0000, 'ºC'),
	(67323, 112, '2015-02-15 00:18:23.000000', 'temperatura', 1002.0000, 'ºC'),
	(67324, 112, '2015-02-15 00:18:24.000000', 'temperatura', 1114.0000, 'ºC'),
	(67325, 112, '2015-02-15 00:18:25.000000', 'temperatura', 163.0000, 'ºC'),
	(67326, 112, '2015-02-15 00:18:26.000000', 'temperatura', 1077.0000, 'ºC'),
	(67327, 112, '2015-02-15 00:18:27.000000', 'temperatura', 95.0000, 'ºC'),
	(67328, 112, '2015-02-15 00:18:28.000000', 'temperatura', 844.0000, 'ºC'),
	(67329, 112, '2015-02-15 00:18:29.000000', 'temperatura', 334.0000, 'ºC'),
	(67330, 112, '2015-02-15 00:18:30.000000', 'temperatura', 339.0000, 'ºC'),
	(67331, 112, '2015-02-15 00:18:31.000000', 'temperatura', 695.0000, 'ºC'),
	(67332, 112, '2015-02-15 00:18:32.000000', 'temperatura', 58.0000, 'ºC'),
	(67333, 112, '2015-02-15 00:18:33.000000', 'temperatura', 604.0000, 'ºC'),
	(67334, 112, '2015-02-15 00:18:34.000000', 'temperatura', 447.0000, 'ºC'),
	(67335, 112, '2015-02-15 00:18:35.000000', 'temperatura', 424.0000, 'ºC'),
	(67336, 112, '2015-02-15 00:18:36.000000', 'temperatura', 780.0000, 'ºC'),
	(67337, 112, '2015-02-15 00:18:37.000000', 'temperatura', 228.0000, 'ºC'),
	(67338, 112, '2015-02-15 00:18:38.000000', 'temperatura', 2.0000, 'ºC'),
	(67339, 112, '2015-02-15 00:18:39.000000', 'temperatura', 525.0000, 'ºC'),
	(67340, 112, '2015-02-15 00:18:40.000000', 'temperatura', 219.0000, 'ºC'),
	(67341, 112, '2015-02-15 00:18:41.000000', 'temperatura', 721.0000, 'ºC'),
	(67342, 112, '2015-02-15 00:18:42.000000', 'temperatura', 547.0000, 'ºC'),
	(67343, 112, '2015-02-15 00:18:43.000000', 'temperatura', 576.0000, 'ºC'),
	(67344, 112, '2015-02-15 00:18:44.000000', 'temperatura', 37.0000, 'ºC'),
	(67345, 112, '2015-02-15 00:18:45.000000', 'temperatura', 856.0000, 'ºC'),
	(67346, 112, '2015-02-15 00:18:46.000000', 'temperatura', 572.0000, 'ºC'),
	(67347, 112, '2015-02-15 00:18:47.000000', 'temperatura', 291.0000, 'ºC'),
	(67348, 112, '2015-02-15 00:18:48.000000', 'temperatura', 940.0000, 'ºC'),
	(67349, 112, '2015-02-15 00:18:49.000000', 'temperatura', 230.0000, 'ºC'),
	(67350, 112, '2015-02-15 00:18:50.000000', 'temperatura', 727.0000, 'ºC'),
	(67351, 112, '2015-02-15 00:18:51.000000', 'temperatura', 547.0000, 'ºC'),
	(67352, 112, '2015-02-15 00:18:52.000000', 'temperatura', 555.0000, 'ºC'),
	(67353, 112, '2015-02-15 00:18:53.000000', 'temperatura', 1133.0000, 'ºC'),
	(67354, 112, '2015-02-15 00:18:54.000000', 'temperatura', 401.0000, 'ºC'),
	(67355, 112, '2015-02-15 00:18:55.000000', 'temperatura', 1005.0000, 'ºC'),
	(67356, 112, '2015-02-15 00:18:56.000000', 'temperatura', 225.0000, 'ºC'),
	(67357, 112, '2015-02-15 00:18:57.000000', 'temperatura', 510.0000, 'ºC'),
	(67358, 112, '2015-02-15 00:18:58.000000', 'temperatura', 674.0000, 'ºC'),
	(67359, 112, '2015-02-15 00:18:59.000000', 'temperatura', 642.0000, 'ºC'),
	(67360, 112, '2015-02-15 00:19:00.000000', 'temperatura', 1187.0000, 'ºC'),
	(67361, 112, '2015-02-15 00:19:01.000000', 'temperatura', 409.0000, 'ºC'),
	(67362, 112, '2015-02-15 00:19:02.000000', 'temperatura', 885.0000, 'ºC'),
	(67363, 112, '2015-02-15 00:19:03.000000', 'temperatura', 797.0000, 'ºC'),
	(67364, 112, '2015-02-15 00:19:04.000000', 'temperatura', 130.0000, 'ºC'),
	(67365, 112, '2015-02-15 00:19:05.000000', 'temperatura', 661.0000, 'ºC'),
	(67366, 112, '2015-02-15 00:19:06.000000', 'temperatura', 514.0000, 'ºC'),
	(67367, 112, '2015-02-15 00:19:07.000000', 'temperatura', 586.0000, 'ºC'),
	(67368, 112, '2015-02-15 00:19:08.000000', 'temperatura', 192.0000, 'ºC'),
	(67369, 112, '2015-02-15 00:19:09.000000', 'temperatura', 401.0000, 'ºC'),
	(67370, 112, '2015-02-15 00:19:10.000000', 'temperatura', 231.0000, 'ºC'),
	(67371, 112, '2015-02-15 00:19:11.000000', 'temperatura', 1150.0000, 'ºC'),
	(67372, 112, '2015-02-15 00:19:12.000000', 'temperatura', 258.0000, 'ºC'),
	(67373, 112, '2015-02-15 00:19:13.000000', 'temperatura', 240.0000, 'ºC'),
	(67374, 112, '2015-02-15 00:19:14.000000', 'temperatura', 428.0000, 'ºC'),
	(67375, 112, '2015-02-15 00:19:15.000000', 'temperatura', 222.0000, 'ºC'),
	(67376, 112, '2015-02-15 00:19:16.000000', 'temperatura', 1024.0000, 'ºC'),
	(67377, 112, '2015-02-15 00:19:17.000000', 'temperatura', 854.0000, 'ºC'),
	(67378, 112, '2015-02-15 00:19:18.000000', 'temperatura', 1198.0000, 'ºC'),
	(67379, 112, '2015-02-15 00:19:19.000000', 'temperatura', 1029.0000, 'ºC'),
	(67380, 112, '2015-02-15 00:19:20.000000', 'temperatura', 351.0000, 'ºC'),
	(67381, 112, '2015-02-15 00:19:21.000000', 'temperatura', 1068.0000, 'ºC'),
	(67382, 112, '2015-02-15 00:19:22.000000', 'temperatura', 686.0000, 'ºC'),
	(67383, 112, '2015-02-15 00:19:23.000000', 'temperatura', 229.0000, 'ºC'),
	(67384, 112, '2015-02-15 00:19:24.000000', 'temperatura', 285.0000, 'ºC'),
	(67385, 112, '2015-02-15 00:19:25.000000', 'temperatura', 740.0000, 'ºC'),
	(67386, 112, '2015-02-15 00:19:26.000000', 'temperatura', 445.0000, 'ºC'),
	(67387, 112, '2015-02-15 00:19:27.000000', 'temperatura', 7.0000, 'ºC'),
	(67388, 112, '2015-02-15 00:19:28.000000', 'temperatura', 1101.0000, 'ºC'),
	(67389, 112, '2015-02-15 00:19:29.000000', 'temperatura', 683.0000, 'ºC'),
	(67390, 112, '2015-02-15 00:19:30.000000', 'temperatura', 113.0000, 'ºC'),
	(67391, 112, '2015-02-15 00:19:31.000000', 'temperatura', 918.0000, 'ºC'),
	(67392, 112, '2015-02-15 00:19:32.000000', 'temperatura', 651.0000, 'ºC'),
	(67393, 112, '2015-02-15 00:19:33.000000', 'temperatura', 503.0000, 'ºC'),
	(67394, 112, '2015-02-15 00:19:34.000000', 'temperatura', 562.0000, 'ºC'),
	(67395, 112, '2015-02-15 00:19:35.000000', 'temperatura', 100.0000, 'ºC'),
	(67396, 112, '2015-02-15 00:19:36.000000', 'temperatura', 13.0000, 'ºC'),
	(67397, 112, '2015-02-15 00:19:37.000000', 'temperatura', 967.0000, 'ºC'),
	(67398, 112, '2015-02-15 00:19:38.000000', 'temperatura', 1198.0000, 'ºC'),
	(67399, 112, '2015-02-15 00:19:39.000000', 'temperatura', 690.0000, 'ºC'),
	(67400, 112, '2015-02-15 00:19:40.000000', 'temperatura', 1057.0000, 'ºC'),
	(67401, 112, '2015-02-15 00:19:41.000000', 'temperatura', 813.0000, 'ºC'),
	(67402, 112, '2015-02-15 00:19:42.000000', 'temperatura', 894.0000, 'ºC'),
	(67403, 112, '2015-02-15 00:19:43.000000', 'temperatura', 833.0000, 'ºC'),
	(67404, 112, '2015-02-15 00:19:44.000000', 'temperatura', 282.0000, 'ºC'),
	(67405, 112, '2015-02-15 00:19:45.000000', 'temperatura', 112.0000, 'ºC'),
	(67406, 112, '2015-02-15 00:19:46.000000', 'temperatura', 914.0000, 'ºC'),
	(67407, 112, '2015-02-15 00:19:47.000000', 'temperatura', 633.0000, 'ºC'),
	(67408, 112, '2015-02-15 00:19:48.000000', 'temperatura', 424.0000, 'ºC'),
	(67409, 112, '2015-02-15 00:19:49.000000', 'temperatura', 224.0000, 'ºC'),
	(67410, 112, '2015-02-15 00:19:50.000000', 'temperatura', 1047.0000, 'ºC'),
	(67411, 112, '2015-02-15 00:19:51.000000', 'temperatura', 964.0000, 'ºC'),
	(67412, 112, '2015-02-15 00:19:52.000000', 'temperatura', 481.0000, 'ºC'),
	(67413, 112, '2015-02-15 00:19:53.000000', 'temperatura', 710.0000, 'ºC'),
	(67414, 112, '2015-02-15 00:19:54.000000', 'temperatura', 911.0000, 'ºC'),
	(67415, 112, '2015-02-15 00:19:55.000000', 'temperatura', 25.0000, 'ºC'),
	(67416, 112, '2015-02-15 00:19:56.000000', 'temperatura', 992.0000, 'ºC'),
	(67417, 112, '2015-02-15 00:19:57.000000', 'temperatura', 87.0000, 'ºC'),
	(67418, 112, '2015-02-15 00:19:58.000000', 'temperatura', 1059.0000, 'ºC'),
	(67419, 112, '2015-02-15 00:19:59.000000', 'temperatura', 235.0000, 'ºC'),
	(67420, 112, '2015-02-15 00:20:00.000000', 'temperatura', 400.0000, 'ºC'),
	(67421, 112, '2015-02-15 00:20:01.000000', 'temperatura', 93.0000, 'ºC'),
	(67422, 112, '2015-02-15 00:20:02.000000', 'temperatura', 466.0000, 'ºC'),
	(67423, 112, '2015-02-15 00:20:03.000000', 'temperatura', 852.0000, 'ºC'),
	(67424, 112, '2015-02-15 00:20:04.000000', 'temperatura', 462.0000, 'ºC'),
	(67425, 112, '2015-02-15 00:20:05.000000', 'temperatura', 955.0000, 'ºC'),
	(67426, 112, '2015-02-15 00:20:06.000000', 'temperatura', 989.0000, 'ºC'),
	(67427, 112, '2015-02-15 00:20:07.000000', 'temperatura', 880.0000, 'ºC'),
	(67428, 112, '2015-02-15 00:20:08.000000', 'temperatura', 233.0000, 'ºC'),
	(67429, 112, '2015-02-15 00:20:09.000000', 'temperatura', 927.0000, 'ºC'),
	(67430, 112, '2015-02-15 00:20:10.000000', 'temperatura', 338.0000, 'ºC'),
	(67431, 112, '2015-02-15 00:20:11.000000', 'temperatura', 106.0000, 'ºC'),
	(67432, 112, '2015-02-15 00:20:12.000000', 'temperatura', 718.0000, 'ºC'),
	(67433, 112, '2015-02-15 00:20:13.000000', 'temperatura', 871.0000, 'ºC'),
	(67434, 112, '2015-02-15 00:20:14.000000', 'temperatura', 1002.0000, 'ºC'),
	(67435, 112, '2015-02-15 00:20:15.000000', 'temperatura', 0.0000, 'ºC'),
	(67436, 112, '2015-02-15 00:20:16.000000', 'temperatura', 592.0000, 'ºC'),
	(67437, 112, '2015-02-15 00:20:17.000000', 'temperatura', 560.0000, 'ºC'),
	(67438, 112, '2015-02-15 00:20:18.000000', 'temperatura', 1026.0000, 'ºC'),
	(67439, 112, '2015-02-15 00:20:19.000000', 'temperatura', 1052.0000, 'ºC'),
	(67440, 112, '2015-02-15 00:20:20.000000', 'temperatura', 982.0000, 'ºC'),
	(67441, 112, '2015-02-15 00:20:21.000000', 'temperatura', 553.0000, 'ºC'),
	(67442, 112, '2015-02-15 00:20:22.000000', 'temperatura', 1020.0000, 'ºC'),
	(67443, 112, '2015-02-15 00:20:23.000000', 'temperatura', 1043.0000, 'ºC'),
	(67444, 112, '2015-02-15 00:20:24.000000', 'temperatura', 954.0000, 'ºC'),
	(67445, 112, '2015-02-15 00:20:25.000000', 'temperatura', 442.0000, 'ºC'),
	(67446, 112, '2015-02-15 00:20:26.000000', 'temperatura', 546.0000, 'ºC'),
	(67447, 112, '2015-02-15 00:20:27.000000', 'temperatura', 208.0000, 'ºC'),
	(67448, 112, '2015-02-15 00:20:28.000000', 'temperatura', 599.0000, 'ºC'),
	(67449, 112, '2015-02-15 00:20:29.000000', 'temperatura', 1175.0000, 'ºC'),
	(67450, 112, '2015-02-15 00:20:30.000000', 'temperatura', 477.0000, 'ºC'),
	(67451, 112, '2015-02-15 00:20:31.000000', 'temperatura', 60.0000, 'ºC'),
	(67452, 112, '2015-02-15 00:20:32.000000', 'temperatura', 69.0000, 'ºC'),
	(67453, 112, '2015-02-15 00:20:33.000000', 'temperatura', 165.0000, 'ºC'),
	(67454, 112, '2015-02-15 00:20:34.000000', 'temperatura', 620.0000, 'ºC'),
	(67455, 112, '2015-02-15 00:20:35.000000', 'temperatura', 206.0000, 'ºC'),
	(67456, 112, '2015-02-15 00:20:36.000000', 'temperatura', 368.0000, 'ºC'),
	(67457, 112, '2015-02-15 00:20:37.000000', 'temperatura', 22.0000, 'ºC'),
	(67458, 112, '2015-02-15 00:20:38.000000', 'temperatura', 210.0000, 'ºC'),
	(67459, 112, '2015-02-15 00:20:39.000000', 'temperatura', 982.0000, 'ºC'),
	(67460, 112, '2015-02-15 00:20:40.000000', 'temperatura', 680.0000, 'ºC'),
	(67461, 112, '2015-02-15 00:20:41.000000', 'temperatura', 454.0000, 'ºC'),
	(67462, 112, '2015-02-15 00:20:42.000000', 'temperatura', 233.0000, 'ºC'),
	(67463, 112, '2015-02-15 00:20:43.000000', 'temperatura', 1001.0000, 'ºC'),
	(67464, 112, '2015-02-15 00:20:44.000000', 'temperatura', 706.0000, 'ºC'),
	(67465, 112, '2015-02-15 00:20:45.000000', 'temperatura', 529.0000, 'ºC'),
	(67466, 112, '2015-02-15 00:20:46.000000', 'temperatura', 528.0000, 'ºC'),
	(67467, 112, '2015-02-15 00:20:47.000000', 'temperatura', 1052.0000, 'ºC'),
	(67468, 112, '2015-02-15 00:20:48.000000', 'temperatura', 78.0000, 'ºC'),
	(67469, 112, '2015-02-15 00:20:49.000000', 'temperatura', 836.0000, 'ºC'),
	(67470, 112, '2015-02-15 00:20:50.000000', 'temperatura', 345.0000, 'ºC'),
	(67471, 112, '2015-02-15 00:20:51.000000', 'temperatura', 418.0000, 'ºC'),
	(67472, 112, '2015-02-15 00:20:52.000000', 'temperatura', 1054.0000, 'ºC'),
	(67473, 112, '2015-02-15 00:20:53.000000', 'temperatura', 418.0000, 'ºC'),
	(67474, 112, '2015-02-15 00:20:54.000000', 'temperatura', 127.0000, 'ºC'),
	(67475, 112, '2015-02-15 00:20:55.000000', 'temperatura', 584.0000, 'ºC'),
	(67476, 112, '2015-02-15 00:20:56.000000', 'temperatura', 139.0000, 'ºC'),
	(67477, 112, '2015-02-15 00:20:57.000000', 'temperatura', 144.0000, 'ºC'),
	(67478, 112, '2015-02-15 00:20:58.000000', 'temperatura', 302.0000, 'ºC'),
	(67479, 112, '2015-02-15 00:20:59.000000', 'temperatura', 1078.0000, 'ºC'),
	(67480, 112, '2015-02-15 00:21:00.000000', 'temperatura', 884.0000, 'ºC'),
	(67481, 112, '2015-02-15 00:21:01.000000', 'temperatura', 1185.0000, 'ºC'),
	(67482, 112, '2015-02-15 00:21:02.000000', 'temperatura', 877.0000, 'ºC'),
	(67483, 112, '2015-02-15 00:21:03.000000', 'temperatura', 829.0000, 'ºC'),
	(67484, 112, '2015-02-15 00:21:04.000000', 'temperatura', 316.0000, 'ºC'),
	(67485, 112, '2015-02-15 00:21:05.000000', 'temperatura', 293.0000, 'ºC'),
	(67486, 112, '2015-02-15 00:21:06.000000', 'temperatura', 518.0000, 'ºC'),
	(67487, 112, '2015-02-15 00:21:07.000000', 'temperatura', 510.0000, 'ºC'),
	(67488, 112, '2015-02-15 00:21:08.000000', 'temperatura', 999.0000, 'ºC'),
	(67489, 112, '2015-02-15 00:21:09.000000', 'temperatura', 1064.0000, 'ºC'),
	(67490, 112, '2015-02-15 00:21:10.000000', 'temperatura', 1125.0000, 'ºC'),
	(67491, 112, '2015-02-15 00:21:11.000000', 'temperatura', 33.0000, 'ºC'),
	(67492, 112, '2015-02-15 00:21:12.000000', 'temperatura', 391.0000, 'ºC'),
	(67493, 112, '2015-02-15 00:21:13.000000', 'temperatura', 654.0000, 'ºC'),
	(67494, 112, '2015-02-15 00:21:14.000000', 'temperatura', 898.0000, 'ºC'),
	(67495, 112, '2015-02-15 00:21:15.000000', 'temperatura', 131.0000, 'ºC'),
	(67496, 112, '2015-02-15 00:21:16.000000', 'temperatura', 360.0000, 'ºC'),
	(67497, 112, '2015-02-15 00:21:17.000000', 'temperatura', 207.0000, 'ºC'),
	(67498, 112, '2015-02-15 00:21:18.000000', 'temperatura', 1155.0000, 'ºC'),
	(67499, 112, '2015-02-15 00:21:19.000000', 'temperatura', 354.0000, 'ºC'),
	(67500, 112, '2015-02-15 00:21:20.000000', 'temperatura', 708.0000, 'ºC'),
	(67501, 112, '2015-02-15 00:21:21.000000', 'temperatura', 79.0000, 'ºC'),
	(67502, 112, '2015-02-15 00:21:22.000000', 'temperatura', 671.0000, 'ºC'),
	(67503, 112, '2015-02-15 00:21:23.000000', 'temperatura', 719.0000, 'ºC'),
	(67504, 112, '2015-02-15 00:21:24.000000', 'temperatura', 382.0000, 'ºC'),
	(67505, 112, '2015-02-15 00:21:25.000000', 'temperatura', 953.0000, 'ºC'),
	(67506, 112, '2015-02-15 00:21:26.000000', 'temperatura', 20.0000, 'ºC'),
	(67507, 112, '2015-02-15 00:21:27.000000', 'temperatura', 842.0000, 'ºC'),
	(67508, 112, '2015-02-15 00:21:28.000000', 'temperatura', 550.0000, 'ºC'),
	(67509, 112, '2015-02-15 00:21:29.000000', 'temperatura', 222.0000, 'ºC'),
	(67510, 112, '2015-02-15 00:21:30.000000', 'temperatura', 664.0000, 'ºC'),
	(67511, 112, '2015-02-15 00:21:31.000000', 'temperatura', 253.0000, 'ºC'),
	(67512, 112, '2015-02-15 00:21:32.000000', 'temperatura', 473.0000, 'ºC'),
	(67513, 112, '2015-02-15 00:21:33.000000', 'temperatura', 408.0000, 'ºC'),
	(67514, 112, '2015-02-15 00:21:34.000000', 'temperatura', 620.0000, 'ºC'),
	(67515, 112, '2015-02-15 00:21:35.000000', 'temperatura', 677.0000, 'ºC'),
	(67516, 112, '2015-02-15 00:21:36.000000', 'temperatura', 327.0000, 'ºC'),
	(67517, 112, '2015-02-15 00:21:37.000000', 'temperatura', 803.0000, 'ºC'),
	(67518, 112, '2015-02-15 00:21:38.000000', 'temperatura', 637.0000, 'ºC'),
	(67519, 112, '2015-02-15 00:21:39.000000', 'temperatura', 773.0000, 'ºC'),
	(67520, 112, '2015-02-15 00:21:40.000000', 'temperatura', 758.0000, 'ºC'),
	(67521, 112, '2015-02-15 00:21:41.000000', 'temperatura', 270.0000, 'ºC'),
	(67522, 112, '2015-02-15 00:21:42.000000', 'temperatura', 275.0000, 'ºC'),
	(67523, 112, '2015-02-15 00:21:43.000000', 'temperatura', 567.0000, 'ºC'),
	(67524, 112, '2015-02-15 00:21:44.000000', 'temperatura', 811.0000, 'ºC'),
	(67525, 112, '2015-02-15 00:21:45.000000', 'temperatura', 1155.0000, 'ºC'),
	(67526, 112, '2015-02-15 00:21:46.000000', 'temperatura', 941.0000, 'ºC'),
	(67527, 112, '2015-02-15 00:21:47.000000', 'temperatura', 40.0000, 'ºC'),
	(67528, 112, '2015-02-15 00:21:48.000000', 'temperatura', 978.0000, 'ºC'),
	(67529, 112, '2015-02-15 00:21:49.000000', 'temperatura', 1173.0000, 'ºC'),
	(67530, 112, '2015-02-15 00:21:50.000000', 'temperatura', 528.0000, 'ºC'),
	(67531, 112, '2015-02-15 00:21:51.000000', 'temperatura', 322.0000, 'ºC'),
	(67532, 112, '2015-02-15 00:21:52.000000', 'temperatura', 25.0000, 'ºC'),
	(67533, 112, '2015-02-15 00:21:53.000000', 'temperatura', 362.0000, 'ºC'),
	(67534, 112, '2015-02-15 00:21:54.000000', 'temperatura', 535.0000, 'ºC'),
	(67535, 112, '2015-02-15 00:21:55.000000', 'temperatura', 388.0000, 'ºC'),
	(67536, 112, '2015-02-15 00:21:56.000000', 'temperatura', 335.0000, 'ºC'),
	(67537, 112, '2015-02-15 00:21:57.000000', 'temperatura', 511.0000, 'ºC'),
	(67538, 112, '2015-02-15 00:21:58.000000', 'temperatura', 352.0000, 'ºC'),
	(67539, 112, '2015-02-15 00:21:59.000000', 'temperatura', 225.0000, 'ºC'),
	(67540, 112, '2015-02-15 00:22:00.000000', 'temperatura', 73.0000, 'ºC'),
	(67541, 112, '2015-02-15 00:22:01.000000', 'temperatura', 889.0000, 'ºC'),
	(67542, 112, '2015-02-15 00:22:02.000000', 'temperatura', 624.0000, 'ºC'),
	(67543, 112, '2015-02-15 00:22:03.000000', 'temperatura', 457.0000, 'ºC'),
	(67544, 112, '2015-02-15 00:22:04.000000', 'temperatura', 414.0000, 'ºC'),
	(67545, 112, '2015-02-15 00:22:05.000000', 'temperatura', 698.0000, 'ºC'),
	(67546, 112, '2015-02-15 00:22:06.000000', 'temperatura', 1049.0000, 'ºC'),
	(67547, 112, '2015-02-15 00:22:07.000000', 'temperatura', 750.0000, 'ºC'),
	(67548, 112, '2015-02-15 00:22:08.000000', 'temperatura', 604.0000, 'ºC'),
	(67549, 112, '2015-02-15 00:22:09.000000', 'temperatura', 773.0000, 'ºC'),
	(67550, 112, '2015-02-15 00:22:10.000000', 'temperatura', 851.0000, 'ºC'),
	(67551, 112, '2015-02-15 00:22:11.000000', 'temperatura', 735.0000, 'ºC'),
	(67552, 112, '2015-02-15 00:22:12.000000', 'temperatura', 1126.0000, 'ºC'),
	(67553, 112, '2015-02-15 00:22:13.000000', 'temperatura', 1022.0000, 'ºC'),
	(67554, 112, '2015-02-15 00:22:14.000000', 'temperatura', 536.0000, 'ºC'),
	(67555, 112, '2015-02-15 00:22:15.000000', 'temperatura', 811.0000, 'ºC'),
	(67556, 112, '2015-02-15 00:22:16.000000', 'temperatura', 51.0000, 'ºC'),
	(67557, 112, '2015-02-15 00:22:17.000000', 'temperatura', 221.0000, 'ºC'),
	(67558, 112, '2015-02-15 00:22:18.000000', 'temperatura', 953.0000, 'ºC'),
	(67559, 112, '2015-02-15 00:22:19.000000', 'temperatura', 500.0000, 'ºC'),
	(67560, 112, '2015-02-15 00:22:20.000000', 'temperatura', 845.0000, 'ºC'),
	(67561, 112, '2015-02-15 00:22:21.000000', 'temperatura', 323.0000, 'ºC'),
	(67562, 112, '2015-02-15 00:22:22.000000', 'temperatura', 282.0000, 'ºC'),
	(67563, 112, '2015-02-15 00:22:23.000000', 'temperatura', 443.0000, 'ºC'),
	(67564, 112, '2015-02-15 00:22:24.000000', 'temperatura', 168.0000, 'ºC'),
	(67565, 112, '2015-02-15 00:22:25.000000', 'temperatura', 712.0000, 'ºC'),
	(67566, 112, '2015-02-15 00:22:26.000000', 'temperatura', 655.0000, 'ºC'),
	(67567, 112, '2015-02-15 00:22:27.000000', 'temperatura', 1140.0000, 'ºC'),
	(67568, 112, '2015-02-15 00:22:28.000000', 'temperatura', 134.0000, 'ºC'),
	(67569, 112, '2015-02-15 00:22:29.000000', 'temperatura', 853.0000, 'ºC'),
	(67570, 112, '2015-02-15 00:22:30.000000', 'temperatura', 261.0000, 'ºC'),
	(67571, 112, '2015-02-15 00:22:31.000000', 'temperatura', 1147.0000, 'ºC'),
	(67572, 112, '2015-02-15 00:22:32.000000', 'temperatura', 154.0000, 'ºC'),
	(67573, 112, '2015-02-15 00:22:33.000000', 'temperatura', 929.0000, 'ºC'),
	(67574, 112, '2015-02-15 00:22:34.000000', 'temperatura', 585.0000, 'ºC'),
	(67575, 112, '2015-02-15 00:22:35.000000', 'temperatura', 136.0000, 'ºC'),
	(67576, 112, '2015-02-15 00:22:36.000000', 'temperatura', 126.0000, 'ºC'),
	(67577, 112, '2015-02-15 00:22:37.000000', 'temperatura', 222.0000, 'ºC'),
	(67578, 112, '2015-02-15 00:22:38.000000', 'temperatura', 735.0000, 'ºC'),
	(67579, 112, '2015-02-15 00:22:39.000000', 'temperatura', 606.0000, 'ºC'),
	(67580, 112, '2015-02-15 00:22:40.000000', 'temperatura', 829.0000, 'ºC'),
	(67581, 112, '2015-02-15 00:22:41.000000', 'temperatura', 1126.0000, 'ºC'),
	(67582, 112, '2015-02-15 00:22:42.000000', 'temperatura', 742.0000, 'ºC'),
	(67583, 112, '2015-02-15 00:22:43.000000', 'temperatura', 333.0000, 'ºC'),
	(67584, 112, '2015-02-15 00:22:44.000000', 'temperatura', 642.0000, 'ºC'),
	(67585, 112, '2015-02-15 00:22:45.000000', 'temperatura', 1008.0000, 'ºC'),
	(67586, 112, '2015-02-15 00:22:46.000000', 'temperatura', 718.0000, 'ºC'),
	(67587, 112, '2015-02-15 00:22:47.000000', 'temperatura', 564.0000, 'ºC'),
	(67588, 112, '2015-02-15 00:22:48.000000', 'temperatura', 667.0000, 'ºC'),
	(67589, 112, '2015-02-15 00:22:49.000000', 'temperatura', 445.0000, 'ºC'),
	(67590, 112, '2015-02-15 00:22:50.000000', 'temperatura', 222.0000, 'ºC'),
	(67591, 112, '2015-02-15 00:22:51.000000', 'temperatura', 976.0000, 'ºC'),
	(67592, 112, '2015-02-15 00:22:52.000000', 'temperatura', 617.0000, 'ºC'),
	(67593, 112, '2015-02-15 00:22:53.000000', 'temperatura', 156.0000, 'ºC'),
	(67594, 112, '2015-02-15 00:22:54.000000', 'temperatura', 129.0000, 'ºC'),
	(67595, 112, '2015-02-15 00:22:55.000000', 'temperatura', 180.0000, 'ºC'),
	(67596, 112, '2015-02-15 00:22:56.000000', 'temperatura', 511.0000, 'ºC'),
	(67597, 112, '2015-02-15 00:22:57.000000', 'temperatura', 815.0000, 'ºC'),
	(67598, 112, '2015-02-15 00:22:58.000000', 'temperatura', 143.0000, 'ºC'),
	(67599, 112, '2015-02-15 00:22:59.000000', 'temperatura', 670.0000, 'ºC'),
	(67600, 112, '2015-02-15 00:23:00.000000', 'temperatura', 520.0000, 'ºC'),
	(67601, 112, '2015-02-15 00:23:01.000000', 'temperatura', 593.0000, 'ºC'),
	(67602, 112, '2015-02-15 00:23:02.000000', 'temperatura', 204.0000, 'ºC'),
	(67603, 112, '2015-02-15 00:23:03.000000', 'temperatura', 440.0000, 'ºC'),
	(67604, 112, '2015-02-15 00:23:04.000000', 'temperatura', 390.0000, 'ºC'),
	(67605, 112, '2015-02-15 00:23:05.000000', 'temperatura', 629.0000, 'ºC'),
	(67606, 112, '2015-02-15 00:23:06.000000', 'temperatura', 776.0000, 'ºC'),
	(67607, 112, '2015-02-15 00:23:07.000000', 'temperatura', 794.0000, 'ºC'),
	(67608, 112, '2015-02-15 00:23:08.000000', 'temperatura', 444.0000, 'ºC'),
	(67609, 112, '2015-02-15 00:23:09.000000', 'temperatura', 1036.0000, 'ºC'),
	(67610, 112, '2015-02-15 00:23:10.000000', 'temperatura', 249.0000, 'ºC'),
	(67611, 112, '2015-02-15 00:23:11.000000', 'temperatura', 538.0000, 'ºC'),
	(67612, 112, '2015-02-15 00:23:12.000000', 'temperatura', 743.0000, 'ºC'),
	(67613, 112, '2015-02-15 00:23:13.000000', 'temperatura', 901.0000, 'ºC'),
	(67614, 112, '2015-02-15 00:23:14.000000', 'temperatura', 1078.0000, 'ºC'),
	(67615, 112, '2015-02-15 00:23:15.000000', 'temperatura', 286.0000, 'ºC'),
	(67616, 112, '2015-02-15 00:23:16.000000', 'temperatura', 596.0000, 'ºC'),
	(67617, 112, '2015-02-15 00:23:17.000000', 'temperatura', 923.0000, 'ºC'),
	(67618, 112, '2015-02-15 00:23:18.000000', 'temperatura', 428.0000, 'ºC'),
	(67619, 112, '2015-02-15 00:23:19.000000', 'temperatura', 572.0000, 'ºC'),
	(67620, 112, '2015-02-15 00:23:20.000000', 'temperatura', 375.0000, 'ºC'),
	(67621, 112, '2015-02-15 00:23:21.000000', 'temperatura', 158.0000, 'ºC'),
	(67622, 112, '2015-02-15 00:23:22.000000', 'temperatura', 867.0000, 'ºC'),
	(67623, 112, '2015-02-15 00:23:23.000000', 'temperatura', 264.0000, 'ºC'),
	(67624, 112, '2015-02-15 00:23:24.000000', 'temperatura', 1116.0000, 'ºC'),
	(67625, 112, '2015-02-15 00:23:25.000000', 'temperatura', 1189.0000, 'ºC'),
	(67626, 112, '2015-02-15 00:23:26.000000', 'temperatura', 196.0000, 'ºC'),
	(67627, 112, '2015-02-15 00:23:27.000000', 'temperatura', 1017.0000, 'ºC'),
	(67628, 112, '2015-02-15 00:23:28.000000', 'temperatura', 896.0000, 'ºC'),
	(67629, 112, '2015-02-15 00:23:29.000000', 'temperatura', 230.0000, 'ºC'),
	(67630, 112, '2015-02-15 00:23:30.000000', 'temperatura', 861.0000, 'ºC'),
	(67631, 112, '2015-02-15 00:23:31.000000', 'temperatura', 17.0000, 'ºC'),
	(67632, 112, '2015-02-15 00:23:32.000000', 'temperatura', 1102.0000, 'ºC'),
	(67633, 112, '2015-02-15 00:23:33.000000', 'temperatura', 659.0000, 'ºC'),
	(67634, 112, '2015-02-15 00:23:34.000000', 'temperatura', 1189.0000, 'ºC'),
	(67635, 112, '2015-02-15 00:23:35.000000', 'temperatura', 368.0000, 'ºC'),
	(67636, 112, '2015-02-15 00:23:36.000000', 'temperatura', 676.0000, 'ºC'),
	(67637, 112, '2015-02-15 00:23:37.000000', 'temperatura', 1075.0000, 'ºC'),
	(67638, 112, '2015-02-15 00:23:38.000000', 'temperatura', 947.0000, 'ºC'),
	(67639, 112, '2015-02-15 00:23:39.000000', 'temperatura', 312.0000, 'ºC'),
	(67640, 112, '2015-02-15 00:23:40.000000', 'temperatura', 1120.0000, 'ºC'),
	(67641, 112, '2015-02-15 00:23:41.000000', 'temperatura', 1064.0000, 'ºC'),
	(67642, 112, '2015-02-15 00:23:42.000000', 'temperatura', 762.0000, 'ºC'),
	(67643, 112, '2015-02-15 00:23:43.000000', 'temperatura', 616.0000, 'ºC'),
	(67644, 112, '2015-02-15 00:23:44.000000', 'temperatura', 794.0000, 'ºC'),
	(67645, 112, '2015-02-15 00:23:45.000000', 'temperatura', 924.0000, 'ºC'),
	(67646, 112, '2015-02-15 00:23:46.000000', 'temperatura', 1039.0000, 'ºC'),
	(67647, 112, '2015-02-15 00:23:47.000000', 'temperatura', 22.0000, 'ºC'),
	(67648, 112, '2015-02-15 00:23:48.000000', 'temperatura', 594.0000, 'ºC'),
	(67649, 112, '2015-02-15 00:23:49.000000', 'temperatura', 503.0000, 'ºC'),
	(67650, 112, '2015-02-15 00:23:50.000000', 'temperatura', 735.0000, 'ºC'),
	(67651, 112, '2015-02-15 00:23:51.000000', 'temperatura', 967.0000, 'ºC'),
	(67652, 112, '2015-02-15 00:23:52.000000', 'temperatura', 231.0000, 'ºC'),
	(67653, 112, '2015-02-15 00:23:53.000000', 'temperatura', 652.0000, 'ºC'),
	(67654, 112, '2015-02-15 00:23:54.000000', 'temperatura', 170.0000, 'ºC'),
	(67655, 112, '2015-02-15 00:23:55.000000', 'temperatura', 94.0000, 'ºC'),
	(67656, 112, '2015-02-15 00:23:56.000000', 'temperatura', 1160.0000, 'ºC'),
	(67657, 112, '2015-02-15 00:23:57.000000', 'temperatura', 719.0000, 'ºC'),
	(67658, 112, '2015-02-15 00:23:58.000000', 'temperatura', 114.0000, 'ºC'),
	(67659, 112, '2015-02-15 00:23:59.000000', 'temperatura', 813.0000, 'ºC'),
	(67660, 112, '2015-02-15 00:24:00.000000', 'temperatura', 122.0000, 'ºC'),
	(67661, 112, '2015-02-15 00:24:01.000000', 'temperatura', 575.0000, 'ºC'),
	(67662, 112, '2015-02-15 00:24:02.000000', 'temperatura', 107.0000, 'ºC'),
	(67663, 112, '2015-02-15 00:24:03.000000', 'temperatura', 11.0000, 'ºC'),
	(67664, 112, '2015-02-15 00:24:04.000000', 'temperatura', 937.0000, 'ºC'),
	(67665, 112, '2015-02-15 00:24:05.000000', 'temperatura', 1049.0000, 'ºC'),
	(67666, 112, '2015-02-15 00:24:06.000000', 'temperatura', 35.0000, 'ºC'),
	(67667, 112, '2015-02-15 00:24:07.000000', 'temperatura', 631.0000, 'ºC'),
	(67668, 112, '2015-02-15 00:24:08.000000', 'temperatura', 649.0000, 'ºC'),
	(67669, 112, '2015-02-15 00:24:09.000000', 'temperatura', 153.0000, 'ºC'),
	(67670, 112, '2015-02-15 00:24:10.000000', 'temperatura', 18.0000, 'ºC'),
	(67671, 112, '2015-02-15 00:24:11.000000', 'temperatura', 833.0000, 'ºC'),
	(67672, 112, '2015-02-15 00:24:12.000000', 'temperatura', 510.0000, 'ºC'),
	(67673, 112, '2015-02-15 00:24:13.000000', 'temperatura', 51.0000, 'ºC'),
	(67674, 112, '2015-02-15 00:24:14.000000', 'temperatura', 1126.0000, 'ºC'),
	(67675, 112, '2015-02-15 00:24:15.000000', 'temperatura', 677.0000, 'ºC'),
	(67676, 112, '2015-02-15 00:24:16.000000', 'temperatura', 6.0000, 'ºC'),
	(67677, 112, '2015-02-15 00:24:17.000000', 'temperatura', 401.0000, 'ºC'),
	(67678, 112, '2015-02-15 00:24:18.000000', 'temperatura', 785.0000, 'ºC'),
	(67679, 112, '2015-02-15 00:24:19.000000', 'temperatura', 325.0000, 'ºC'),
	(67680, 112, '2015-02-15 00:24:20.000000', 'temperatura', 471.0000, 'ºC'),
	(67681, 112, '2015-02-15 00:24:21.000000', 'temperatura', 182.0000, 'ºC'),
	(67682, 112, '2015-02-15 00:24:22.000000', 'temperatura', 694.0000, 'ºC'),
	(67683, 112, '2015-02-15 00:24:23.000000', 'temperatura', 527.0000, 'ºC'),
	(67684, 112, '2015-02-15 00:24:24.000000', 'temperatura', 552.0000, 'ºC'),
	(67685, 112, '2015-02-15 00:24:25.000000', 'temperatura', 1180.0000, 'ºC'),
	(67686, 112, '2015-02-15 00:24:26.000000', 'temperatura', 646.0000, 'ºC'),
	(67687, 112, '2015-02-15 00:24:27.000000', 'temperatura', 891.0000, 'ºC'),
	(67688, 112, '2015-02-15 00:24:28.000000', 'temperatura', 117.0000, 'ºC'),
	(67689, 112, '2015-02-15 00:24:29.000000', 'temperatura', 311.0000, 'ºC'),
	(67690, 112, '2015-02-15 00:24:30.000000', 'temperatura', 4.0000, 'ºC'),
	(67691, 112, '2015-02-15 00:24:31.000000', 'temperatura', 287.0000, 'ºC'),
	(67692, 112, '2015-02-15 00:24:32.000000', 'temperatura', 224.0000, 'ºC'),
	(67693, 112, '2015-02-15 00:24:33.000000', 'temperatura', 260.0000, 'ºC'),
	(67694, 112, '2015-02-15 00:24:34.000000', 'temperatura', 629.0000, 'ºC'),
	(67695, 112, '2015-02-15 00:24:35.000000', 'temperatura', 1166.0000, 'ºC'),
	(67696, 112, '2015-02-15 00:24:36.000000', 'temperatura', 344.0000, 'ºC'),
	(67697, 112, '2015-02-15 00:24:37.000000', 'temperatura', 622.0000, 'ºC'),
	(67698, 112, '2015-02-15 00:24:38.000000', 'temperatura', 880.0000, 'ºC'),
	(67699, 112, '2015-02-15 00:24:39.000000', 'temperatura', 134.0000, 'ºC'),
	(67700, 112, '2015-02-15 00:24:40.000000', 'temperatura', 430.0000, 'ºC'),
	(67701, 112, '2015-02-15 00:24:41.000000', 'temperatura', 547.0000, 'ºC'),
	(67702, 112, '2015-02-15 00:24:42.000000', 'temperatura', 247.0000, 'ºC'),
	(67703, 112, '2015-02-15 00:24:43.000000', 'temperatura', 794.0000, 'ºC'),
	(67704, 112, '2015-02-15 00:24:44.000000', 'temperatura', 828.0000, 'ºC'),
	(67705, 112, '2015-02-15 00:24:45.000000', 'temperatura', 560.0000, 'ºC'),
	(67706, 112, '2015-02-15 00:24:46.000000', 'temperatura', 317.0000, 'ºC'),
	(67707, 112, '2015-02-15 00:24:47.000000', 'temperatura', 1104.0000, 'ºC'),
	(67708, 112, '2015-02-15 00:24:48.000000', 'temperatura', 972.0000, 'ºC'),
	(67709, 112, '2015-02-15 00:24:49.000000', 'temperatura', 348.0000, 'ºC'),
	(67710, 112, '2015-02-15 00:24:50.000000', 'temperatura', 25.0000, 'ºC'),
	(67711, 112, '2015-02-15 00:24:51.000000', 'temperatura', 282.0000, 'ºC'),
	(67712, 112, '2015-02-15 00:24:52.000000', 'temperatura', 133.0000, 'ºC'),
	(67713, 112, '2015-02-15 00:24:53.000000', 'temperatura', 1019.0000, 'ºC'),
	(67714, 112, '2015-02-15 00:24:54.000000', 'temperatura', 1096.0000, 'ºC'),
	(67715, 112, '2015-02-15 00:24:55.000000', 'temperatura', 26.0000, 'ºC'),
	(67716, 112, '2015-02-15 00:24:56.000000', 'temperatura', 441.0000, 'ºC'),
	(67717, 112, '2015-02-15 00:24:57.000000', 'temperatura', 930.0000, 'ºC'),
	(67718, 112, '2015-02-15 00:24:58.000000', 'temperatura', 925.0000, 'ºC'),
	(67719, 112, '2015-02-15 00:24:59.000000', 'temperatura', 636.0000, 'ºC'),
	(67720, 112, '2015-02-15 00:25:00.000000', 'temperatura', 406.0000, 'ºC'),
	(67721, 112, '2015-02-15 00:25:01.000000', 'temperatura', 120.0000, 'ºC'),
	(67722, 112, '2015-02-15 00:25:02.000000', 'temperatura', 586.0000, 'ºC'),
	(67723, 112, '2015-02-15 00:25:03.000000', 'temperatura', 167.0000, 'ºC'),
	(67724, 112, '2015-02-15 00:25:04.000000', 'temperatura', 281.0000, 'ºC'),
	(67725, 112, '2015-02-15 00:25:05.000000', 'temperatura', 903.0000, 'ºC'),
	(67726, 112, '2015-02-15 00:25:06.000000', 'temperatura', 74.0000, 'ºC'),
	(67727, 112, '2015-02-15 00:25:07.000000', 'temperatura', 61.0000, 'ºC'),
	(67728, 112, '2015-02-15 00:25:08.000000', 'temperatura', 81.0000, 'ºC'),
	(67729, 112, '2015-02-15 00:25:09.000000', 'temperatura', 225.0000, 'ºC'),
	(67730, 112, '2015-02-15 00:25:10.000000', 'temperatura', 880.0000, 'ºC'),
	(67731, 112, '2015-02-15 00:25:11.000000', 'temperatura', 127.0000, 'ºC'),
	(67732, 112, '2015-02-15 00:25:12.000000', 'temperatura', 397.0000, 'ºC'),
	(67733, 112, '2015-02-15 00:25:13.000000', 'temperatura', 404.0000, 'ºC'),
	(67734, 112, '2015-02-15 00:25:14.000000', 'temperatura', 828.0000, 'ºC'),
	(67735, 112, '2015-02-15 00:25:15.000000', 'temperatura', 529.0000, 'ºC'),
	(67736, 112, '2015-02-15 00:25:16.000000', 'temperatura', 162.0000, 'ºC'),
	(67737, 112, '2015-02-15 00:25:17.000000', 'temperatura', 422.0000, 'ºC'),
	(67738, 112, '2015-02-15 00:25:18.000000', 'temperatura', 425.0000, 'ºC'),
	(67739, 112, '2015-02-15 00:25:19.000000', 'temperatura', 862.0000, 'ºC'),
	(67740, 112, '2015-02-15 00:25:20.000000', 'temperatura', 632.0000, 'ºC'),
	(67741, 112, '2015-02-15 00:25:21.000000', 'temperatura', 577.0000, 'ºC'),
	(67742, 112, '2015-02-15 00:25:22.000000', 'temperatura', 990.0000, 'ºC'),
	(67743, 112, '2015-02-15 00:25:23.000000', 'temperatura', 818.0000, 'ºC'),
	(67744, 112, '2015-02-15 00:25:24.000000', 'temperatura', 1121.0000, 'ºC'),
	(67745, 112, '2015-02-15 00:25:25.000000', 'temperatura', 752.0000, 'ºC'),
	(67746, 112, '2015-02-15 00:25:26.000000', 'temperatura', 397.0000, 'ºC'),
	(67747, 112, '2015-02-15 00:25:27.000000', 'temperatura', 931.0000, 'ºC'),
	(67748, 112, '2015-02-15 00:25:28.000000', 'temperatura', 1063.0000, 'ºC'),
	(67749, 112, '2015-02-15 00:25:29.000000', 'temperatura', 124.0000, 'ºC'),
	(67750, 112, '2015-02-15 00:25:30.000000', 'temperatura', 1029.0000, 'ºC'),
	(67751, 112, '2015-02-15 00:25:31.000000', 'temperatura', 1176.0000, 'ºC'),
	(67752, 112, '2015-02-15 00:25:32.000000', 'temperatura', 393.0000, 'ºC'),
	(67753, 112, '2015-02-15 00:25:33.000000', 'temperatura', 836.0000, 'ºC'),
	(67754, 112, '2015-02-15 00:25:34.000000', 'temperatura', 601.0000, 'ºC'),
	(67755, 112, '2015-02-15 00:25:35.000000', 'temperatura', 497.0000, 'ºC'),
	(67756, 112, '2015-02-15 00:25:36.000000', 'temperatura', 683.0000, 'ºC'),
	(67757, 112, '2015-02-15 00:25:37.000000', 'temperatura', 727.0000, 'ºC'),
	(67758, 112, '2015-02-15 00:25:38.000000', 'temperatura', 384.0000, 'ºC'),
	(67759, 112, '2015-02-15 00:25:39.000000', 'temperatura', 942.0000, 'ºC'),
	(67760, 112, '2015-02-15 00:25:40.000000', 'temperatura', 1155.0000, 'ºC'),
	(67761, 112, '2015-02-15 00:25:41.000000', 'temperatura', 553.0000, 'ºC'),
	(67762, 112, '2015-02-15 00:25:42.000000', 'temperatura', 498.0000, 'ºC'),
	(67763, 112, '2015-02-15 00:25:43.000000', 'temperatura', 832.0000, 'ºC'),
	(67764, 112, '2015-02-15 00:25:44.000000', 'temperatura', 266.0000, 'ºC'),
	(67765, 112, '2015-02-15 00:25:45.000000', 'temperatura', 34.0000, 'ºC'),
	(67766, 112, '2015-02-15 00:25:46.000000', 'temperatura', 572.0000, 'ºC'),
	(67767, 112, '2015-02-15 00:25:47.000000', 'temperatura', 359.0000, 'ºC'),
	(67768, 112, '2015-02-15 00:25:48.000000', 'temperatura', 80.0000, 'ºC'),
	(67769, 112, '2015-02-15 00:25:49.000000', 'temperatura', 523.0000, 'ºC'),
	(67770, 112, '2015-02-15 00:25:50.000000', 'temperatura', 1174.0000, 'ºC'),
	(67771, 112, '2015-02-15 00:25:51.000000', 'temperatura', 702.0000, 'ºC'),
	(67772, 112, '2015-02-15 00:25:52.000000', 'temperatura', 1190.0000, 'ºC'),
	(67773, 112, '2015-02-15 00:25:53.000000', 'temperatura', 242.0000, 'ºC'),
	(67774, 112, '2015-02-15 00:25:54.000000', 'temperatura', 40.0000, 'ºC'),
	(67775, 112, '2015-02-15 00:25:55.000000', 'temperatura', 677.0000, 'ºC'),
	(67776, 112, '2015-02-15 00:25:56.000000', 'temperatura', 866.0000, 'ºC'),
	(67777, 112, '2015-02-15 00:25:57.000000', 'temperatura', 1099.0000, 'ºC'),
	(67778, 112, '2015-02-15 00:25:58.000000', 'temperatura', 495.0000, 'ºC'),
	(67779, 112, '2015-02-15 00:25:59.000000', 'temperatura', 381.0000, 'ºC'),
	(67780, 112, '2015-02-15 00:26:00.000000', 'temperatura', 419.0000, 'ºC'),
	(67781, 112, '2015-02-15 00:26:01.000000', 'temperatura', 953.0000, 'ºC'),
	(67782, 112, '2015-02-15 00:26:02.000000', 'temperatura', 1107.0000, 'ºC'),
	(67783, 112, '2015-02-15 00:26:03.000000', 'temperatura', 279.0000, 'ºC'),
	(67784, 112, '2015-02-15 00:26:04.000000', 'temperatura', 474.0000, 'ºC'),
	(67785, 112, '2015-02-15 00:26:05.000000', 'temperatura', 333.0000, 'ºC'),
	(67786, 112, '2015-02-15 00:26:06.000000', 'temperatura', 242.0000, 'ºC'),
	(67787, 112, '2015-02-15 00:26:07.000000', 'temperatura', 212.0000, 'ºC'),
	(67788, 112, '2015-02-15 00:26:08.000000', 'temperatura', 336.0000, 'ºC'),
	(67789, 112, '2015-02-15 00:26:09.000000', 'temperatura', 1042.0000, 'ºC'),
	(67790, 112, '2015-02-15 00:26:10.000000', 'temperatura', 603.0000, 'ºC'),
	(67791, 112, '2015-02-15 00:26:11.000000', 'temperatura', 1088.0000, 'ºC'),
	(67792, 112, '2015-02-15 00:26:12.000000', 'temperatura', 33.0000, 'ºC'),
	(67793, 112, '2015-02-15 00:26:13.000000', 'temperatura', 503.0000, 'ºC'),
	(67794, 112, '2015-02-15 00:26:14.000000', 'temperatura', 17.0000, 'ºC'),
	(67795, 112, '2015-02-15 00:26:15.000000', 'temperatura', 976.0000, 'ºC'),
	(67796, 112, '2015-02-15 00:26:16.000000', 'temperatura', 31.0000, 'ºC'),
	(67797, 112, '2015-02-15 00:26:17.000000', 'temperatura', 826.0000, 'ºC'),
	(67798, 112, '2015-02-15 00:26:18.000000', 'temperatura', 439.0000, 'ºC'),
	(67799, 112, '2015-02-15 00:26:19.000000', 'temperatura', 918.0000, 'ºC'),
	(67800, 112, '2015-02-15 00:26:20.000000', 'temperatura', 874.0000, 'ºC'),
	(67801, 112, '2015-02-15 00:26:21.000000', 'temperatura', 417.0000, 'ºC'),
	(67802, 112, '2015-02-15 00:26:22.000000', 'temperatura', 661.0000, 'ºC'),
	(67803, 112, '2015-02-15 00:26:23.000000', 'temperatura', 856.0000, 'ºC'),
	(67804, 112, '2015-02-15 00:26:24.000000', 'temperatura', 1097.0000, 'ºC'),
	(67805, 112, '2015-02-15 00:26:25.000000', 'temperatura', 519.0000, 'ºC'),
	(67806, 112, '2015-02-15 00:26:26.000000', 'temperatura', 505.0000, 'ºC'),
	(67807, 112, '2015-02-15 00:26:27.000000', 'temperatura', 965.0000, 'ºC'),
	(67808, 112, '2015-02-15 00:26:28.000000', 'temperatura', 914.0000, 'ºC'),
	(67809, 112, '2015-02-15 00:26:29.000000', 'temperatura', 475.0000, 'ºC'),
	(67810, 112, '2015-02-15 00:26:30.000000', 'temperatura', 834.0000, 'ºC'),
	(67811, 112, '2015-02-15 00:26:31.000000', 'temperatura', 344.0000, 'ºC'),
	(67812, 112, '2015-02-15 00:26:32.000000', 'temperatura', 420.0000, 'ºC'),
	(67813, 112, '2015-02-15 00:26:33.000000', 'temperatura', 1068.0000, 'ºC'),
	(67814, 112, '2015-02-15 00:26:34.000000', 'temperatura', 480.0000, 'ºC'),
	(67815, 112, '2015-02-15 00:26:35.000000', 'temperatura', 398.0000, 'ºC'),
	(67816, 112, '2015-02-15 00:26:36.000000', 'temperatura', 551.0000, 'ºC'),
	(67817, 112, '2015-02-15 00:26:37.000000', 'temperatura', 360.0000, 'ºC'),
	(67818, 112, '2015-02-15 00:26:38.000000', 'temperatura', 149.0000, 'ºC'),
	(67819, 112, '2015-02-15 00:26:39.000000', 'temperatura', 866.0000, 'ºC'),
	(67820, 112, '2015-02-15 00:26:40.000000', 'temperatura', 282.0000, 'ºC'),
	(67821, 112, '2015-02-15 00:26:41.000000', 'temperatura', 13.0000, 'ºC'),
	(67822, 112, '2015-02-15 00:26:42.000000', 'temperatura', 419.0000, 'ºC'),
	(67823, 112, '2015-02-15 00:26:43.000000', 'temperatura', 858.0000, 'ºC'),
	(67824, 112, '2015-02-15 00:26:44.000000', 'temperatura', 632.0000, 'ºC'),
	(67825, 112, '2015-02-15 00:26:45.000000', 'temperatura', 589.0000, 'ºC'),
	(67826, 112, '2015-02-15 00:26:46.000000', 'temperatura', 1047.0000, 'ºC'),
	(67827, 112, '2015-02-15 00:26:47.000000', 'temperatura', 1069.0000, 'ºC'),
	(67828, 112, '2015-02-15 00:26:48.000000', 'temperatura', 1004.0000, 'ºC'),
	(67829, 112, '2015-02-15 00:26:49.000000', 'temperatura', 615.0000, 'ºC'),
	(67830, 112, '2015-02-15 00:26:50.000000', 'temperatura', 62.0000, 'ºC'),
	(67831, 112, '2015-02-15 00:26:51.000000', 'temperatura', 865.0000, 'ºC'),
	(67832, 112, '2015-02-15 00:26:52.000000', 'temperatura', 541.0000, 'ºC'),
	(67833, 112, '2015-02-15 00:26:53.000000', 'temperatura', 109.0000, 'ºC'),
	(67834, 112, '2015-02-15 00:26:54.000000', 'temperatura', 122.0000, 'ºC'),
	(67835, 112, '2015-02-15 00:26:55.000000', 'temperatura', 284.0000, 'ºC'),
	(67836, 112, '2015-02-15 00:26:56.000000', 'temperatura', 1054.0000, 'ºC'),
	(67837, 112, '2015-02-15 00:26:57.000000', 'temperatura', 821.0000, 'ºC'),
	(67838, 112, '2015-02-15 00:26:58.000000', 'temperatura', 941.0000, 'ºC'),
	(67839, 112, '2015-02-15 00:26:59.000000', 'temperatura', 1045.0000, 'ºC'),
	(67840, 112, '2015-02-15 00:27:00.000000', 'temperatura', 2.0000, 'ºC'),
	(67841, 112, '2015-02-15 00:27:01.000000', 'temperatura', 473.0000, 'ºC'),
	(67842, 112, '2015-02-15 00:27:02.000000', 'temperatura', 1162.0000, 'ºC'),
	(67843, 112, '2015-02-15 00:27:03.000000', 'temperatura', 791.0000, 'ºC'),
	(67844, 112, '2015-02-15 00:27:04.000000', 'temperatura', 470.0000, 'ºC'),
	(67845, 112, '2015-02-15 00:27:05.000000', 'temperatura', 1178.0000, 'ºC'),
	(67846, 112, '2015-02-15 00:27:06.000000', 'temperatura', 880.0000, 'ºC'),
	(67847, 112, '2015-02-15 00:27:07.000000', 'temperatura', 866.0000, 'ºC'),
	(67848, 112, '2015-02-15 00:27:08.000000', 'temperatura', 492.0000, 'ºC'),
	(67849, 112, '2015-02-15 00:27:09.000000', 'temperatura', 1062.0000, 'ºC'),
	(67850, 112, '2015-02-15 00:27:10.000000', 'temperatura', 235.0000, 'ºC'),
	(67851, 112, '2015-02-15 00:27:11.000000', 'temperatura', 389.0000, 'ºC'),
	(67852, 112, '2015-02-15 00:27:12.000000', 'temperatura', 40.0000, 'ºC'),
	(67853, 112, '2015-02-15 00:27:13.000000', 'temperatura', 236.0000, 'ºC'),
	(67854, 112, '2015-02-15 00:27:14.000000', 'temperatura', 1057.0000, 'ºC'),
	(67855, 112, '2015-02-15 00:27:15.000000', 'temperatura', 979.0000, 'ºC'),
	(67856, 112, '2015-02-15 00:27:16.000000', 'temperatura', 525.0000, 'ºC'),
	(67857, 112, '2015-02-15 00:27:17.000000', 'temperatura', 887.0000, 'ºC'),
	(67858, 112, '2015-02-15 00:27:18.000000', 'temperatura', 463.0000, 'ºC'),
	(67859, 112, '2015-02-15 00:27:19.000000', 'temperatura', 854.0000, 'ºC'),
	(67860, 112, '2015-02-15 00:27:20.000000', 'temperatura', 479.0000, 'ºC'),
	(67861, 112, '2015-02-15 00:27:21.000000', 'temperatura', 1035.0000, 'ºC'),
	(67862, 112, '2015-02-15 00:27:22.000000', 'temperatura', 137.0000, 'ºC'),
	(67863, 112, '2015-02-15 00:27:23.000000', 'temperatura', 1182.0000, 'ºC'),
	(67864, 112, '2015-02-15 00:27:24.000000', 'temperatura', 700.0000, 'ºC'),
	(67865, 112, '2015-02-15 00:27:25.000000', 'temperatura', 1153.0000, 'ºC'),
	(67866, 112, '2015-02-15 00:27:26.000000', 'temperatura', 66.0000, 'ºC'),
	(67867, 112, '2015-02-15 00:27:27.000000', 'temperatura', 471.0000, 'ºC'),
	(67868, 112, '2015-02-15 00:27:28.000000', 'temperatura', 956.0000, 'ºC'),
	(67869, 112, '2015-02-15 00:27:29.000000', 'temperatura', 969.0000, 'ºC'),
	(67870, 112, '2015-02-15 00:27:30.000000', 'temperatura', 779.0000, 'ºC'),
	(67871, 112, '2015-02-15 00:27:31.000000', 'temperatura', 987.0000, 'ºC'),
	(67872, 112, '2015-02-15 00:27:32.000000', 'temperatura', 198.0000, 'ºC'),
	(67873, 112, '2015-02-15 00:27:33.000000', 'temperatura', 432.0000, 'ºC'),
	(67874, 112, '2015-02-15 00:27:34.000000', 'temperatura', 365.0000, 'ºC'),
	(67875, 112, '2015-02-15 00:27:35.000000', 'temperatura', 528.0000, 'ºC'),
	(67876, 112, '2015-02-15 00:27:36.000000', 'temperatura', 346.0000, 'ºC'),
	(67877, 112, '2015-02-15 00:27:37.000000', 'temperatura', 148.0000, 'ºC'),
	(67878, 112, '2015-02-15 00:27:38.000000', 'temperatura', 903.0000, 'ºC'),
	(67879, 112, '2015-02-15 00:27:39.000000', 'temperatura', 472.0000, 'ºC'),
	(67880, 112, '2015-02-15 00:27:40.000000', 'temperatura', 852.0000, 'ºC'),
	(67881, 112, '2015-02-15 00:27:41.000000', 'temperatura', 442.0000, 'ºC'),
	(67882, 112, '2015-02-15 00:27:42.000000', 'temperatura', 857.0000, 'ºC'),
	(67883, 112, '2015-02-15 00:27:43.000000', 'temperatura', 559.0000, 'ºC'),
	(67884, 112, '2015-02-15 00:27:44.000000', 'temperatura', 225.0000, 'ºC'),
	(67885, 112, '2015-02-15 00:27:45.000000', 'temperatura', 648.0000, 'ºC'),
	(67886, 112, '2015-02-15 00:27:46.000000', 'temperatura', 166.0000, 'ºC'),
	(67887, 112, '2015-02-15 00:27:47.000000', 'temperatura', 84.0000, 'ºC'),
	(67888, 112, '2015-02-15 00:27:48.000000', 'temperatura', 1125.0000, 'ºC'),
	(67889, 112, '2015-02-15 00:27:49.000000', 'temperatura', 571.0000, 'ºC'),
	(67890, 112, '2015-02-15 00:27:50.000000', 'temperatura', 681.0000, 'ºC'),
	(67891, 112, '2015-02-15 00:27:51.000000', 'temperatura', 494.0000, 'ºC'),
	(67892, 112, '2015-02-15 00:27:52.000000', 'temperatura', 425.0000, 'ºC'),
	(67893, 112, '2015-02-15 00:27:53.000000', 'temperatura', 646.0000, 'ºC'),
	(67894, 112, '2015-02-15 00:27:54.000000', 'temperatura', 755.0000, 'ºC'),
	(67895, 112, '2015-02-15 00:27:55.000000', 'temperatura', 639.0000, 'ºC'),
	(67896, 112, '2015-02-15 00:27:56.000000', 'temperatura', 929.0000, 'ºC'),
	(67897, 112, '2015-02-15 00:27:57.000000', 'temperatura', 329.0000, 'ºC'),
	(67898, 112, '2015-02-15 00:27:58.000000', 'temperatura', 58.0000, 'ºC'),
	(67899, 112, '2015-02-15 00:27:59.000000', 'temperatura', 506.0000, 'ºC'),
	(67900, 112, '2015-02-15 00:28:00.000000', 'temperatura', 1154.0000, 'ºC'),
	(67901, 112, '2015-02-15 00:28:01.000000', 'temperatura', 651.0000, 'ºC'),
	(67902, 112, '2015-02-15 00:28:02.000000', 'temperatura', 995.0000, 'ºC'),
	(67903, 112, '2015-02-15 00:28:03.000000', 'temperatura', 624.0000, 'ºC'),
	(67904, 112, '2015-02-15 00:28:04.000000', 'temperatura', 133.0000, 'ºC'),
	(67905, 112, '2015-02-15 00:28:05.000000', 'temperatura', 1195.0000, 'ºC'),
	(67906, 112, '2015-02-15 00:28:06.000000', 'temperatura', 776.0000, 'ºC'),
	(67907, 112, '2015-02-15 00:28:07.000000', 'temperatura', 297.0000, 'ºC'),
	(67908, 112, '2015-02-15 00:28:08.000000', 'temperatura', 357.0000, 'ºC'),
	(67909, 112, '2015-02-15 00:28:09.000000', 'temperatura', 893.0000, 'ºC'),
	(67910, 112, '2015-02-15 00:28:10.000000', 'temperatura', 996.0000, 'ºC'),
	(67911, 112, '2015-02-15 00:28:11.000000', 'temperatura', 1102.0000, 'ºC'),
	(67912, 112, '2015-02-15 00:28:12.000000', 'temperatura', 123.0000, 'ºC'),
	(67913, 112, '2015-02-15 00:28:13.000000', 'temperatura', 911.0000, 'ºC'),
	(67914, 112, '2015-02-15 00:28:14.000000', 'temperatura', 584.0000, 'ºC'),
	(67915, 112, '2015-02-15 00:28:15.000000', 'temperatura', 187.0000, 'ºC'),
	(67916, 112, '2015-02-15 00:28:16.000000', 'temperatura', 384.0000, 'ºC'),
	(67917, 112, '2015-02-15 00:28:17.000000', 'temperatura', 161.0000, 'ºC'),
	(67918, 112, '2015-02-15 00:28:18.000000', 'temperatura', 851.0000, 'ºC'),
	(67919, 112, '2015-02-15 00:28:19.000000', 'temperatura', 174.0000, 'ºC'),
	(67920, 112, '2015-02-15 00:28:20.000000', 'temperatura', 716.0000, 'ºC'),
	(67921, 112, '2015-02-15 00:28:21.000000', 'temperatura', 660.0000, 'ºC'),
	(67922, 112, '2015-02-15 00:28:22.000000', 'temperatura', 1150.0000, 'ºC'),
	(67923, 112, '2015-02-15 00:28:23.000000', 'temperatura', 172.0000, 'ºC'),
	(67924, 112, '2015-02-15 00:28:24.000000', 'temperatura', 1011.0000, 'ºC'),
	(67925, 112, '2015-02-15 00:28:25.000000', 'temperatura', 937.0000, 'ºC'),
	(67926, 112, '2015-02-15 00:28:26.000000', 'temperatura', 456.0000, 'ºC'),
	(67927, 112, '2015-02-15 00:28:27.000000', 'temperatura', 666.0000, 'ºC'),
	(67928, 112, '2015-02-15 00:28:28.000000', 'temperatura', 764.0000, 'ºC'),
	(67929, 112, '2015-02-15 00:28:29.000000', 'temperatura', 622.0000, 'ºC'),
	(67930, 112, '2015-02-15 00:28:30.000000', 'temperatura', 819.0000, 'ºC'),
	(67931, 112, '2015-02-15 00:28:31.000000', 'temperatura', 1029.0000, 'ºC'),
	(67932, 112, '2015-02-15 00:28:32.000000', 'temperatura', 287.0000, 'ºC'),
	(67933, 112, '2015-02-15 00:28:33.000000', 'temperatura', 751.0000, 'ºC'),
	(67934, 112, '2015-02-15 00:28:34.000000', 'temperatura', 493.0000, 'ºC'),
	(67935, 112, '2015-02-15 00:28:35.000000', 'temperatura', 215.0000, 'ºC'),
	(67936, 112, '2015-02-15 00:28:36.000000', 'temperatura', 793.0000, 'ºC'),
	(67937, 112, '2015-02-15 00:28:37.000000', 'temperatura', 922.0000, 'ºC'),
	(67938, 112, '2015-02-15 00:28:38.000000', 'temperatura', 1031.0000, 'ºC'),
	(67939, 112, '2015-02-15 00:28:39.000000', 'temperatura', 1190.0000, 'ºC'),
	(67940, 112, '2015-02-15 00:28:40.000000', 'temperatura', 457.0000, 'ºC'),
	(67941, 112, '2015-02-15 00:28:41.000000', 'temperatura', 1117.0000, 'ºC'),
	(67942, 112, '2015-02-15 00:28:42.000000', 'temperatura', 615.0000, 'ºC'),
	(67943, 112, '2015-02-15 00:28:43.000000', 'temperatura', 923.0000, 'ºC'),
	(67944, 112, '2015-02-15 00:28:44.000000', 'temperatura', 371.0000, 'ºC'),
	(67945, 112, '2015-02-15 00:28:45.000000', 'temperatura', 286.0000, 'ºC'),
	(67946, 112, '2015-02-15 00:28:46.000000', 'temperatura', 319.0000, 'ºC'),
	(67947, 112, '2015-02-15 00:28:47.000000', 'temperatura', 737.0000, 'ºC'),
	(67948, 112, '2015-02-15 00:28:48.000000', 'temperatura', 330.0000, 'ºC'),
	(67949, 112, '2015-02-15 00:28:49.000000', 'temperatura', 637.0000, 'ºC'),
	(67950, 112, '2015-02-15 00:28:50.000000', 'temperatura', 995.0000, 'ºC'),
	(67951, 112, '2015-02-15 00:28:51.000000', 'temperatura', 664.0000, 'ºC'),
	(67952, 112, '2015-02-15 00:28:52.000000', 'temperatura', 338.0000, 'ºC'),
	(67953, 112, '2015-02-15 00:28:53.000000', 'temperatura', 896.0000, 'ºC'),
	(67954, 112, '2015-02-15 00:28:54.000000', 'temperatura', 1069.0000, 'ºC'),
	(67955, 112, '2015-02-15 00:28:55.000000', 'temperatura', 256.0000, 'ºC'),
	(67956, 112, '2015-02-15 00:28:56.000000', 'temperatura', 475.0000, 'ºC'),
	(67957, 112, '2015-02-15 00:28:57.000000', 'temperatura', 405.0000, 'ºC'),
	(67958, 112, '2015-02-15 00:28:58.000000', 'temperatura', 601.0000, 'ºC'),
	(67959, 112, '2015-02-15 00:28:59.000000', 'temperatura', 590.0000, 'ºC'),
	(67960, 112, '2015-02-15 00:29:00.000000', 'temperatura', 1149.0000, 'ºC'),
	(67961, 112, '2015-02-15 00:29:01.000000', 'temperatura', 374.0000, 'ºC'),
	(67962, 112, '2015-02-15 00:29:02.000000', 'temperatura', 822.0000, 'ºC'),
	(67963, 112, '2015-02-15 00:29:03.000000', 'temperatura', 590.0000, 'ºC'),
	(67964, 112, '2015-02-15 00:29:04.000000', 'temperatura', 485.0000, 'ºC'),
	(67965, 112, '2015-02-15 00:29:05.000000', 'temperatura', 655.0000, 'ºC'),
	(67966, 112, '2015-02-15 00:29:06.000000', 'temperatura', 620.0000, 'ºC'),
	(67967, 112, '2015-02-15 00:29:07.000000', 'temperatura', 1134.0000, 'ºC'),
	(67968, 112, '2015-02-15 00:29:08.000000', 'temperatura', 213.0000, 'ºC'),
	(67969, 112, '2015-02-15 00:29:09.000000', 'temperatura', 62.0000, 'ºC'),
	(67970, 112, '2015-02-15 00:29:10.000000', 'temperatura', 871.0000, 'ºC'),
	(67971, 112, '2015-02-15 00:29:11.000000', 'temperatura', 569.0000, 'ºC'),
	(67972, 112, '2015-02-15 00:29:12.000000', 'temperatura', 234.0000, 'ºC'),
	(67973, 112, '2015-02-15 00:29:13.000000', 'temperatura', 662.0000, 'ºC'),
	(67974, 112, '2015-02-15 00:29:14.000000', 'temperatura', 209.0000, 'ºC'),
	(67975, 112, '2015-02-15 00:29:15.000000', 'temperatura', 258.0000, 'ºC'),
	(67976, 112, '2015-02-15 00:29:16.000000', 'temperatura', 667.0000, 'ºC'),
	(67977, 112, '2015-02-15 00:29:17.000000', 'temperatura', 159.0000, 'ºC'),
	(67978, 112, '2015-02-15 00:29:18.000000', 'temperatura', 1194.0000, 'ºC'),
	(67979, 112, '2015-02-15 00:29:19.000000', 'temperatura', 696.0000, 'ºC'),
	(67980, 112, '2015-02-15 00:29:20.000000', 'temperatura', 1098.0000, 'ºC'),
	(67981, 112, '2015-02-15 00:29:21.000000', 'temperatura', 1003.0000, 'ºC'),
	(67982, 112, '2015-02-15 00:29:22.000000', 'temperatura', 521.0000, 'ºC'),
	(67983, 112, '2015-02-15 00:29:23.000000', 'temperatura', 796.0000, 'ºC'),
	(67984, 112, '2015-02-15 00:29:24.000000', 'temperatura', 17.0000, 'ºC'),
	(67985, 112, '2015-02-15 00:29:25.000000', 'temperatura', 98.0000, 'ºC'),
	(67986, 112, '2015-02-15 00:29:26.000000', 'temperatura', 441.0000, 'ºC'),
	(67987, 112, '2015-02-15 00:29:27.000000', 'temperatura', 711.0000, 'ºC'),
	(67988, 112, '2015-02-15 00:29:28.000000', 'temperatura', 1031.0000, 'ºC'),
	(67989, 112, '2015-02-15 00:29:29.000000', 'temperatura', 625.0000, 'ºC'),
	(67990, 112, '2015-02-15 00:29:30.000000', 'temperatura', 32.0000, 'ºC'),
	(67991, 112, '2015-02-15 00:29:31.000000', 'temperatura', 684.0000, 'ºC'),
	(67992, 112, '2015-02-15 00:29:32.000000', 'temperatura', 923.0000, 'ºC'),
	(67993, 112, '2015-02-15 00:29:33.000000', 'temperatura', 167.0000, 'ºC'),
	(67994, 112, '2015-02-15 00:29:34.000000', 'temperatura', 465.0000, 'ºC'),
	(67995, 112, '2015-02-15 00:29:35.000000', 'temperatura', 624.0000, 'ºC'),
	(67996, 112, '2015-02-15 00:29:36.000000', 'temperatura', 525.0000, 'ºC'),
	(67997, 112, '2015-02-15 00:29:37.000000', 'temperatura', 754.0000, 'ºC'),
	(67998, 112, '2015-02-15 00:29:38.000000', 'temperatura', 995.0000, 'ºC'),
	(67999, 112, '2015-02-15 00:29:39.000000', 'temperatura', 313.0000, 'ºC'),
	(68000, 112, '2015-02-15 00:29:40.000000', 'temperatura', 981.0000, 'ºC'),
	(68001, 112, '2015-02-15 00:29:41.000000', 'temperatura', 366.0000, 'ºC'),
	(68002, 112, '2015-02-15 00:29:42.000000', 'temperatura', 87.0000, 'ºC'),
	(68003, 112, '2015-02-15 00:29:43.000000', 'temperatura', 539.0000, 'ºC'),
	(68004, 112, '2015-02-15 00:29:44.000000', 'temperatura', 34.0000, 'ºC'),
	(68005, 112, '2015-02-15 00:29:45.000000', 'temperatura', 955.0000, 'ºC'),
	(68006, 112, '2015-02-15 00:29:46.000000', 'temperatura', 1071.0000, 'ºC'),
	(68007, 112, '2015-02-15 00:29:47.000000', 'temperatura', 90.0000, 'ºC'),
	(68008, 112, '2015-02-15 00:29:48.000000', 'temperatura', 837.0000, 'ºC'),
	(68009, 112, '2015-02-15 00:29:49.000000', 'temperatura', 318.0000, 'ºC'),
	(68010, 112, '2015-02-15 00:29:50.000000', 'temperatura', 279.0000, 'ºC'),
	(68011, 112, '2015-02-15 00:29:51.000000', 'temperatura', 441.0000, 'ºC'),
	(68012, 112, '2015-02-15 00:29:52.000000', 'temperatura', 169.0000, 'ºC'),
	(68013, 112, '2015-02-15 00:29:53.000000', 'temperatura', 721.0000, 'ºC'),
	(68014, 112, '2015-02-15 00:29:54.000000', 'temperatura', 701.0000, 'ºC'),
	(68015, 112, '2015-02-15 00:29:55.000000', 'temperatura', 142.0000, 'ºC'),
	(68016, 112, '2015-02-15 00:29:56.000000', 'temperatura', 1006.0000, 'ºC'),
	(68017, 112, '2015-02-15 00:29:57.000000', 'temperatura', 1004.0000, 'ºC'),
	(68018, 112, '2015-02-15 00:29:58.000000', 'temperatura', 802.0000, 'ºC'),
	(68019, 112, '2015-02-15 00:29:59.000000', 'temperatura', 1000.0000, 'ºC'),
	(68020, 112, '2015-02-15 00:30:00.000000', 'temperatura', 196.0000, 'ºC'),
	(68021, 112, '2015-02-15 00:30:01.000000', 'temperatura', 380.0000, 'ºC'),
	(68022, 112, '2015-02-15 00:30:02.000000', 'temperatura', 113.0000, 'ºC'),
	(68023, 112, '2015-02-15 00:30:03.000000', 'temperatura', 624.0000, 'ºC'),
	(68024, 112, '2015-02-15 00:30:04.000000', 'temperatura', 380.0000, 'ºC'),
	(68025, 112, '2015-02-15 00:30:05.000000', 'temperatura', 30.0000, 'ºC'),
	(68026, 112, '2015-02-15 00:30:06.000000', 'temperatura', 209.0000, 'ºC'),
	(68027, 112, '2015-02-15 00:30:07.000000', 'temperatura', 955.0000, 'ºC'),
	(68028, 112, '2015-02-15 00:30:08.000000', 'temperatura', 550.0000, 'ºC'),
	(68029, 112, '2015-02-15 00:30:09.000000', 'temperatura', 1083.0000, 'ºC'),
	(68030, 112, '2015-02-15 00:30:10.000000', 'temperatura', 167.0000, 'ºC'),
	(68031, 112, '2015-02-15 00:30:11.000000', 'temperatura', 1187.0000, 'ºC'),
	(68032, 112, '2015-02-15 00:30:12.000000', 'temperatura', 636.0000, 'ºC'),
	(68033, 112, '2015-02-15 00:30:13.000000', 'temperatura', 817.0000, 'ºC'),
	(68034, 112, '2015-02-15 00:30:14.000000', 'temperatura', 978.0000, 'ºC'),
	(68035, 112, '2015-02-15 00:30:15.000000', 'temperatura', 40.0000, 'ºC'),
	(68036, 112, '2015-02-15 00:30:16.000000', 'temperatura', 866.0000, 'ºC'),
	(68037, 112, '2015-02-15 00:30:17.000000', 'temperatura', 612.0000, 'ºC'),
	(68038, 112, '2015-02-15 00:30:18.000000', 'temperatura', 463.0000, 'ºC'),
	(68039, 112, '2015-02-15 00:30:19.000000', 'temperatura', 478.0000, 'ºC'),
	(68040, 112, '2015-02-15 00:30:20.000000', 'temperatura', 1000.0000, 'ºC'),
	(68041, 112, '2015-02-15 00:30:21.000000', 'temperatura', 1169.0000, 'ºC'),
	(68042, 112, '2015-02-15 00:30:22.000000', 'temperatura', 443.0000, 'ºC'),
	(68043, 112, '2015-02-15 00:30:23.000000', 'temperatura', 1111.0000, 'ºC'),
	(68044, 112, '2015-02-15 00:30:24.000000', 'temperatura', 627.0000, 'ºC'),
	(68045, 112, '2015-02-15 00:30:25.000000', 'temperatura', 1000.0000, 'ºC'),
	(68046, 112, '2015-02-15 00:30:26.000000', 'temperatura', 722.0000, 'ºC'),
	(68047, 112, '2015-02-15 00:30:27.000000', 'temperatura', 611.0000, 'ºC'),
	(68048, 112, '2015-02-15 00:30:28.000000', 'temperatura', 889.0000, 'ºC'),
	(68049, 112, '2015-02-15 00:30:29.000000', 'temperatura', 214.0000, 'ºC'),
	(68050, 112, '2015-02-15 00:30:30.000000', 'temperatura', 801.0000, 'ºC'),
	(68051, 112, '2015-02-15 00:30:31.000000', 'temperatura', 966.0000, 'ºC'),
	(68052, 112, '2015-02-15 00:30:32.000000', 'temperatura', 25.0000, 'ºC'),
	(68053, 112, '2015-02-15 00:30:33.000000', 'temperatura', 826.0000, 'ºC'),
	(68054, 112, '2015-02-15 00:30:34.000000', 'temperatura', 459.0000, 'ºC'),
	(68055, 112, '2015-02-15 00:30:35.000000', 'temperatura', 1017.0000, 'ºC'),
	(68056, 112, '2015-02-15 00:30:36.000000', 'temperatura', 109.0000, 'ºC'),
	(68057, 112, '2015-02-15 00:30:37.000000', 'temperatura', 1094.0000, 'ºC'),
	(68058, 112, '2015-02-15 00:30:38.000000', 'temperatura', 344.0000, 'ºC'),
	(68059, 112, '2015-02-15 00:30:39.000000', 'temperatura', 838.0000, 'ºC'),
	(68060, 112, '2015-02-15 00:30:40.000000', 'temperatura', 758.0000, 'ºC'),
	(68061, 112, '2015-02-15 00:30:41.000000', 'temperatura', 78.0000, 'ºC'),
	(68062, 112, '2015-02-15 00:30:42.000000', 'temperatura', 514.0000, 'ºC'),
	(68063, 112, '2015-02-15 00:30:43.000000', 'temperatura', 1137.0000, 'ºC'),
	(68064, 112, '2015-02-15 00:30:44.000000', 'temperatura', 545.0000, 'ºC'),
	(68065, 112, '2015-02-15 00:30:45.000000', 'temperatura', 516.0000, 'ºC'),
	(68066, 112, '2015-02-15 00:30:46.000000', 'temperatura', 943.0000, 'ºC'),
	(68067, 112, '2015-02-15 00:30:47.000000', 'temperatura', 769.0000, 'ºC'),
	(68068, 112, '2015-02-15 00:30:48.000000', 'temperatura', 1015.0000, 'ºC'),
	(68069, 112, '2015-02-15 00:30:49.000000', 'temperatura', 371.0000, 'ºC'),
	(68070, 112, '2015-02-15 00:30:50.000000', 'temperatura', 9.0000, 'ºC'),
	(68071, 112, '2015-02-15 00:30:51.000000', 'temperatura', 134.0000, 'ºC'),
	(68072, 112, '2015-02-15 00:30:52.000000', 'temperatura', 641.0000, 'ºC'),
	(68073, 112, '2015-02-15 00:30:53.000000', 'temperatura', 405.0000, 'ºC'),
	(68074, 112, '2015-02-15 00:30:54.000000', 'temperatura', 101.0000, 'ºC'),
	(68075, 112, '2015-02-15 00:30:55.000000', 'temperatura', 491.0000, 'ºC'),
	(68076, 112, '2015-02-15 00:30:56.000000', 'temperatura', 952.0000, 'ºC'),
	(68077, 112, '2015-02-15 00:30:57.000000', 'temperatura', 887.0000, 'ºC'),
	(68078, 112, '2015-02-15 00:30:58.000000', 'temperatura', 381.0000, 'ºC'),
	(68079, 112, '2015-02-15 00:30:59.000000', 'temperatura', 442.0000, 'ºC'),
	(68080, 112, '2015-02-15 00:31:00.000000', 'temperatura', 1068.0000, 'ºC'),
	(68081, 112, '2015-02-15 00:31:01.000000', 'temperatura', 417.0000, 'ºC'),
	(68082, 112, '2015-02-15 00:31:02.000000', 'temperatura', 80.0000, 'ºC'),
	(68083, 112, '2015-02-15 00:31:03.000000', 'temperatura', 348.0000, 'ºC'),
	(68084, 112, '2015-02-15 00:31:04.000000', 'temperatura', 300.0000, 'ºC'),
	(68085, 112, '2015-02-15 00:31:05.000000', 'temperatura', 459.0000, 'ºC'),
	(68086, 112, '2015-02-15 00:31:06.000000', 'temperatura', 194.0000, 'ºC'),
	(68087, 112, '2015-02-15 00:31:07.000000', 'temperatura', 796.0000, 'ºC'),
	(68088, 112, '2015-02-15 00:31:08.000000', 'temperatura', 997.0000, 'ºC'),
	(68089, 112, '2015-02-15 00:31:09.000000', 'temperatura', 197.0000, 'ºC'),
	(68090, 112, '2015-02-15 00:31:10.000000', 'temperatura', 393.0000, 'ºC'),
	(68091, 112, '2015-02-15 00:31:11.000000', 'temperatura', 178.0000, 'ºC'),
	(68092, 112, '2015-02-15 00:31:12.000000', 'temperatura', 909.0000, 'ºC'),
	(68093, 112, '2015-02-15 00:31:13.000000', 'temperatura', 412.0000, 'ºC'),
	(68094, 112, '2015-02-15 00:31:14.000000', 'temperatura', 534.0000, 'ºC'),
	(68095, 112, '2015-02-15 00:31:15.000000', 'temperatura', 236.0000, 'ºC'),
	(68096, 112, '2015-02-15 00:31:16.000000', 'temperatura', 778.0000, 'ºC'),
	(68097, 112, '2015-02-15 00:31:17.000000', 'temperatura', 781.0000, 'ºC'),
	(68098, 112, '2015-02-15 00:31:18.000000', 'temperatura', 371.0000, 'ºC'),
	(68099, 112, '2015-02-15 00:31:19.000000', 'temperatura', 713.0000, 'ºC'),
	(68100, 112, '2015-02-15 00:31:20.000000', 'temperatura', 53.0000, 'ºC'),
	(68101, 112, '2015-02-15 00:31:21.000000', 'temperatura', 525.0000, 'ºC'),
	(68102, 112, '2015-02-15 00:31:22.000000', 'temperatura', 67.0000, 'ºC'),
	(68103, 112, '2015-02-15 00:31:23.000000', 'temperatura', 1160.0000, 'ºC'),
	(68104, 112, '2015-02-15 00:31:24.000000', 'temperatura', 800.0000, 'ºC'),
	(68105, 112, '2015-02-15 00:31:25.000000', 'temperatura', 519.0000, 'ºC'),
	(68106, 112, '2015-02-15 00:31:26.000000', 'temperatura', 198.0000, 'ºC'),
	(68107, 112, '2015-02-15 00:31:27.000000', 'temperatura', 632.0000, 'ºC'),
	(68108, 112, '2015-02-15 00:31:28.000000', 'temperatura', 167.0000, 'ºC'),
	(68109, 112, '2015-02-15 00:31:29.000000', 'temperatura', 139.0000, 'ºC'),
	(68110, 112, '2015-02-15 00:31:30.000000', 'temperatura', 193.0000, 'ºC'),
	(68111, 112, '2015-02-15 00:31:31.000000', 'temperatura', 551.0000, 'ºC'),
	(68112, 112, '2015-02-15 00:31:32.000000', 'temperatura', 974.0000, 'ºC'),
	(68113, 112, '2015-02-15 00:31:33.000000', 'temperatura', 819.0000, 'ºC'),
	(68114, 112, '2015-02-15 00:31:34.000000', 'temperatura', 1174.0000, 'ºC'),
	(68115, 112, '2015-02-15 00:31:35.000000', 'temperatura', 1011.0000, 'ºC'),
	(68116, 112, '2015-02-15 00:31:36.000000', 'temperatura', 336.0000, 'ºC'),
	(68117, 112, '2015-02-15 00:31:37.000000', 'temperatura', 1048.0000, 'ºC'),
	(68118, 112, '2015-02-15 00:31:38.000000', 'temperatura', 630.0000, 'ºC'),
	(68119, 112, '2015-02-15 00:31:39.000000', 'temperatura', 8.0000, 'ºC'),
	(68120, 112, '2015-02-15 00:31:40.000000', 'temperatura', 552.0000, 'ºC'),
	(68121, 112, '2015-02-15 00:31:41.000000', 'temperatura', 336.0000, 'ºC'),
	(68122, 112, '2015-02-15 00:31:42.000000', 'temperatura', 22.0000, 'ºC'),
	(68123, 112, '2015-02-15 00:31:43.000000', 'temperatura', 305.0000, 'ºC'),
	(68124, 112, '2015-02-15 00:31:44.000000', 'temperatura', 261.0000, 'ºC'),
	(68125, 112, '2015-02-15 00:31:45.000000', 'temperatura', 388.0000, 'ºC'),
	(68126, 112, '2015-02-15 00:31:46.000000', 'temperatura', 1157.0000, 'ºC'),
	(68127, 112, '2015-02-15 00:31:47.000000', 'temperatura', 1024.0000, 'ºC'),
	(68128, 112, '2015-02-15 00:31:48.000000', 'temperatura', 447.0000, 'ºC'),
	(68129, 112, '2015-02-15 00:31:49.000000', 'temperatura', 363.0000, 'ºC'),
	(68130, 112, '2015-02-15 00:31:50.000000', 'temperatura', 476.0000, 'ºC'),
	(68131, 112, '2015-02-15 00:31:51.000000', 'temperatura', 92.0000, 'ºC'),
	(68132, 112, '2015-02-15 00:31:52.000000', 'temperatura', 234.0000, 'ºC'),
	(68133, 112, '2015-02-15 00:31:53.000000', 'temperatura', 891.0000, 'ºC'),
	(68134, 112, '2015-02-15 00:31:54.000000', 'temperatura', 156.0000, 'ºC'),
	(68135, 112, '2015-02-15 00:31:55.000000', 'temperatura', 508.0000, 'ºC'),
	(68136, 112, '2015-02-15 00:31:56.000000', 'temperatura', 874.0000, 'ºC'),
	(68137, 112, '2015-02-15 00:31:57.000000', 'temperatura', 443.0000, 'ºC'),
	(68138, 112, '2015-02-15 00:31:58.000000', 'temperatura', 796.0000, 'ºC'),
	(68139, 112, '2015-02-15 00:31:59.000000', 'temperatura', 252.0000, 'ºC'),
	(68140, 112, '2015-02-15 00:32:00.000000', 'temperatura', 71.0000, 'ºC'),
	(68141, 112, '2015-02-15 00:32:01.000000', 'temperatura', 799.0000, 'ºC'),
	(68142, 112, '2015-02-15 00:32:02.000000', 'temperatura', 181.0000, 'ºC'),
	(68143, 112, '2015-02-15 00:32:03.000000', 'temperatura', 911.0000, 'ºC'),
	(68144, 112, '2015-02-15 00:32:04.000000', 'temperatura', 414.0000, 'ºC'),
	(68145, 112, '2015-02-15 00:32:05.000000', 'temperatura', 534.0000, 'ºC'),
	(68146, 112, '2015-02-15 00:32:06.000000', 'temperatura', 229.0000, 'ºC'),
	(68147, 112, '2015-02-15 00:32:07.000000', 'temperatura', 746.0000, 'ºC'),
	(68148, 112, '2015-02-15 00:32:08.000000', 'temperatura', 641.0000, 'ºC'),
	(68149, 112, '2015-02-15 00:32:09.000000', 'temperatura', 968.0000, 'ºC'),
	(68150, 112, '2015-02-15 00:32:10.000000', 'temperatura', 516.0000, 'ºC'),
	(68151, 112, '2015-02-15 00:32:11.000000', 'temperatura', 880.0000, 'ºC'),
	(68152, 112, '2015-02-15 00:32:12.000000', 'temperatura', 449.0000, 'ºC'),
	(68153, 112, '2015-02-15 00:32:13.000000', 'temperatura', 807.0000, 'ºC'),
	(68154, 112, '2015-02-15 00:32:14.000000', 'temperatura', 289.0000, 'ºC'),
	(68155, 112, '2015-02-15 00:32:15.000000', 'temperatura', 225.0000, 'ºC'),
	(68156, 112, '2015-02-15 00:32:16.000000', 'temperatura', 256.0000, 'ºC'),
	(68157, 112, '2015-02-15 00:32:17.000000', 'temperatura', 606.0000, 'ºC'),
	(68158, 112, '2015-02-15 00:32:18.000000', 'temperatura', 1063.0000, 'ºC'),
	(68159, 112, '2015-02-15 00:32:19.000000', 'temperatura', 1099.0000, 'ºC'),
	(68160, 112, '2015-02-15 00:32:20.000000', 'temperatura', 1104.0000, 'ºC'),
	(68161, 112, '2015-02-15 00:32:21.000000', 'temperatura', 1027.0000, 'ºC'),
	(68162, 112, '2015-02-15 00:32:22.000000', 'temperatura', 620.0000, 'ºC'),
	(68163, 112, '2015-02-15 00:32:23.000000', 'temperatura', 22.0000, 'ºC'),
	(68164, 112, '2015-02-15 00:32:24.000000', 'temperatura', 648.0000, 'ºC'),
	(68165, 112, '2015-02-15 00:32:25.000000', 'temperatura', 778.0000, 'ºC'),
	(68166, 112, '2015-02-15 00:32:26.000000', 'temperatura', 743.0000, 'ºC'),
	(68167, 112, '2015-02-15 00:32:27.000000', 'temperatura', 183.0000, 'ºC'),
	(68168, 112, '2015-02-15 00:32:28.000000', 'temperatura', 1088.0000, 'ºC'),
	(68169, 112, '2015-02-15 00:32:29.000000', 'temperatura', 92.0000, 'ºC'),
	(68170, 112, '2015-02-15 00:32:30.000000', 'temperatura', 797.0000, 'ºC'),
	(68171, 112, '2015-02-15 00:32:31.000000', 'temperatura', 108.0000, 'ºC'),
	(68172, 112, '2015-02-15 00:32:32.000000', 'temperatura', 550.0000, 'ºC'),
	(68173, 112, '2015-02-15 00:32:33.000000', 'temperatura', 28.0000, 'ºC'),
	(68174, 112, '2015-02-15 00:32:34.000000', 'temperatura', 889.0000, 'ºC'),
	(68175, 112, '2015-02-15 00:32:35.000000', 'temperatura', 760.0000, 'ºC'),
	(68176, 112, '2015-02-15 00:32:36.000000', 'temperatura', 1136.0000, 'ºC'),
	(68177, 112, '2015-02-15 00:32:37.000000', 'temperatura', 999.0000, 'ºC'),
	(68178, 112, '2015-02-15 00:32:38.000000', 'temperatura', 386.0000, 'ºC'),
	(68179, 112, '2015-02-15 00:32:39.000000', 'temperatura', 136.0000, 'ºC'),
	(68180, 112, '2015-02-15 00:32:40.000000', 'temperatura', 721.0000, 'ºC'),
	(68181, 112, '2015-02-15 00:32:41.000000', 'temperatura', 798.0000, 'ºC'),
	(68182, 112, '2015-02-15 00:32:42.000000', 'temperatura', 626.0000, 'ºC'),
	(68183, 112, '2015-02-15 00:32:43.000000', 'temperatura', 739.0000, 'ºC'),
	(68184, 112, '2015-02-15 00:32:44.000000', 'temperatura', 618.0000, 'ºC'),
	(68185, 112, '2015-02-15 00:32:45.000000', 'temperatura', 872.0000, 'ºC'),
	(68186, 112, '2015-02-15 00:32:46.000000', 'temperatura', 108.0000, 'ºC'),
	(68187, 112, '2015-02-15 00:32:47.000000', 'temperatura', 323.0000, 'ºC'),
	(68188, 112, '2015-02-15 00:32:48.000000', 'temperatura', 92.0000, 'ºC'),
	(68189, 112, '2015-02-15 00:32:49.000000', 'temperatura', 692.0000, 'ºC'),
	(68190, 112, '2015-02-15 00:32:50.000000', 'temperatura', 785.0000, 'ºC'),
	(68191, 112, '2015-02-15 00:32:51.000000', 'temperatura', 647.0000, 'ºC'),
	(68192, 112, '2015-02-15 00:32:52.000000', 'temperatura', 882.0000, 'ºC'),
	(68193, 112, '2015-02-15 00:32:53.000000', 'temperatura', 68.0000, 'ºC'),
	(68194, 112, '2015-02-15 00:32:54.000000', 'temperatura', 97.0000, 'ºC'),
	(68195, 112, '2015-02-15 00:32:55.000000', 'temperatura', 281.0000, 'ºC'),
	(68196, 112, '2015-02-15 00:32:56.000000', 'temperatura', 1115.0000, 'ºC'),
	(68197, 112, '2015-02-15 00:32:57.000000', 'temperatura', 1134.0000, 'ºC'),
	(68198, 112, '2015-02-15 00:32:58.000000', 'temperatura', 1123.0000, 'ºC'),
	(68199, 112, '2015-02-15 00:32:59.000000', 'temperatura', 1016.0000, 'ºC'),
	(68200, 112, '2015-02-15 00:33:00.000000', 'temperatura', 508.0000, 'ºC'),
	(68201, 112, '2015-02-15 00:33:01.000000', 'temperatura', 695.0000, 'ºC'),
	(68202, 112, '2015-02-15 00:33:02.000000', 'temperatura', 752.0000, 'ºC'),
	(68203, 112, '2015-02-15 00:33:03.000000', 'temperatura', 474.0000, 'ºC'),
	(68204, 112, '2015-02-15 00:33:04.000000', 'temperatura', 116.0000, 'ºC'),
	(68205, 112, '2015-02-15 00:33:05.000000', 'temperatura', 358.0000, 'ºC'),
	(68206, 112, '2015-02-15 00:33:06.000000', 'temperatura', 242.0000, 'ºC'),
	(68207, 112, '2015-02-15 00:33:07.000000', 'temperatura', 136.0000, 'ºC'),
	(68208, 112, '2015-02-15 00:33:08.000000', 'temperatura', 1156.0000, 'ºC'),
	(68209, 112, '2015-02-15 00:33:09.000000', 'temperatura', 573.0000, 'ºC'),
	(68210, 112, '2015-02-15 00:33:10.000000', 'temperatura', 595.0000, 'ºC'),
	(68211, 112, '2015-02-15 00:33:11.000000', 'temperatura', 59.0000, 'ºC'),
	(68212, 112, '2015-02-15 00:33:12.000000', 'temperatura', 912.0000, 'ºC'),
	(68213, 112, '2015-02-15 00:33:13.000000', 'temperatura', 780.0000, 'ºC'),
	(68214, 112, '2015-02-15 00:33:14.000000', 'temperatura', 1165.0000, 'ºC'),
	(68215, 112, '2015-02-15 00:33:15.000000', 'temperatura', 1085.0000, 'ºC'),
	(68216, 112, '2015-02-15 00:33:16.000000', 'temperatura', 730.0000, 'ºC'),
	(68217, 112, '2015-02-15 00:33:17.000000', 'temperatura', 395.0000, 'ºC'),
	(68218, 112, '2015-02-15 00:33:18.000000', 'temperatura', 988.0000, 'ºC'),
	(68219, 112, '2015-02-15 00:33:19.000000', 'temperatura', 155.0000, 'ºC'),
	(68220, 112, '2015-02-15 00:33:20.000000', 'temperatura', 211.0000, 'ºC'),
	(68221, 112, '2015-02-15 00:33:21.000000', 'temperatura', 589.0000, 'ºC'),
	(68222, 112, '2015-02-15 00:33:22.000000', 'temperatura', 1114.0000, 'ºC'),
	(68223, 112, '2015-02-15 00:33:23.000000', 'temperatura', 204.0000, 'ºC'),
	(68224, 112, '2015-02-15 00:33:24.000000', 'temperatura', 77.0000, 'ºC'),
	(68225, 112, '2015-02-15 00:33:25.000000', 'temperatura', 976.0000, 'ºC'),
	(68226, 112, '2015-02-15 00:33:26.000000', 'temperatura', 1047.0000, 'ºC'),
	(68227, 112, '2015-02-15 00:33:27.000000', 'temperatura', 1107.0000, 'ºC'),
	(68228, 112, '2015-02-15 00:33:28.000000', 'temperatura', 1197.0000, 'ºC'),
	(68229, 112, '2015-02-15 00:33:29.000000', 'temperatura', 264.0000, 'ºC'),
	(68230, 112, '2015-02-15 00:33:30.000000', 'temperatura', 131.0000, 'ºC'),
	(68231, 112, '2015-02-15 00:33:31.000000', 'temperatura', 1062.0000, 'ºC'),
	(68232, 112, '2015-02-15 00:33:32.000000', 'temperatura', 117.0000, 'ºC'),
	(68233, 112, '2015-02-15 00:33:33.000000', 'temperatura', 999.0000, 'ºC'),
	(68234, 112, '2015-02-15 00:33:34.000000', 'temperatura', 1045.0000, 'ºC'),
	(68235, 112, '2015-02-15 00:33:35.000000', 'temperatura', 1028.0000, 'ºC'),
	(68236, 112, '2015-02-15 00:33:36.000000', 'temperatura', 807.0000, 'ºC'),
	(68237, 112, '2015-02-15 00:33:37.000000', 'temperatura', 953.0000, 'ºC'),
	(68238, 112, '2015-02-15 00:33:38.000000', 'temperatura', 1142.0000, 'ºC'),
	(68239, 112, '2015-02-15 00:33:39.000000', 'temperatura', 452.0000, 'ºC'),
	(68240, 112, '2015-02-15 00:33:40.000000', 'temperatura', 35.0000, 'ºC'),
	(68241, 112, '2015-02-15 00:33:41.000000', 'temperatura', 21.0000, 'ºC'),
	(68242, 112, '2015-02-15 00:33:42.000000', 'temperatura', 0.0000, 'ºC'),
	(68243, 112, '2015-02-15 00:33:43.000000', 'temperatura', 1137.0000, 'ºC'),
	(68244, 112, '2015-02-15 00:33:44.000000', 'temperatura', 885.0000, 'ºC'),
	(68245, 112, '2015-02-15 00:33:45.000000', 'temperatura', 1014.0000, 'ºC'),
	(68246, 112, '2015-02-15 00:33:46.000000', 'temperatura', 14.0000, 'ºC'),
	(68247, 112, '2015-02-15 00:33:47.000000', 'temperatura', 631.0000, 'ºC'),
	(68248, 112, '2015-02-15 00:33:48.000000', 'temperatura', 711.0000, 'ºC'),
	(68249, 112, '2015-02-15 00:33:49.000000', 'temperatura', 465.0000, 'ºC'),
	(68250, 112, '2015-02-15 00:33:50.000000', 'temperatura', 190.0000, 'ºC'),
	(68251, 112, '2015-02-15 00:33:51.000000', 'temperatura', 758.0000, 'ºC'),
	(68252, 112, '2015-02-15 00:33:52.000000', 'temperatura', 821.0000, 'ºC'),
	(68253, 112, '2015-02-15 00:33:53.000000', 'temperatura', 630.0000, 'ºC'),
	(68254, 112, '2015-02-15 00:33:54.000000', 'temperatura', 687.0000, 'ºC'),
	(68255, 112, '2015-02-15 00:33:55.000000', 'temperatura', 347.0000, 'ºC'),
	(68256, 112, '2015-02-15 00:33:56.000000', 'temperatura', 873.0000, 'ºC'),
	(68257, 112, '2015-02-15 00:33:57.000000', 'temperatura', 927.0000, 'ºC'),
	(68258, 112, '2015-02-15 00:33:58.000000', 'temperatura', 816.0000, 'ºC'),
	(68259, 112, '2015-02-15 00:33:59.000000', 'temperatura', 99.0000, 'ºC'),
	(68260, 112, '2015-02-15 00:34:00.000000', 'temperatura', 446.0000, 'ºC'),
	(68261, 112, '2015-02-15 00:34:01.000000', 'temperatura', 734.0000, 'ºC'),
	(68262, 112, '2015-02-15 00:34:02.000000', 'temperatura', 1135.0000, 'ºC'),
	(68263, 112, '2015-02-15 00:34:03.000000', 'temperatura', 1071.0000, 'ºC'),
	(68264, 112, '2015-02-15 00:34:04.000000', 'temperatura', 750.0000, 'ºC'),
	(68265, 112, '2015-02-15 00:34:05.000000', 'temperatura', 537.0000, 'ºC'),
	(68266, 112, '2015-02-15 00:34:06.000000', 'temperatura', 437.0000, 'ºC'),
	(68267, 112, '2015-02-15 00:34:07.000000', 'temperatura', 574.0000, 'ºC'),
	(68268, 112, '2015-02-15 00:34:08.000000', 'temperatura', 358.0000, 'ºC'),
	(68269, 112, '2015-02-15 00:34:09.000000', 'temperatura', 71.0000, 'ºC'),
	(68270, 112, '2015-02-15 00:34:10.000000', 'temperatura', 481.0000, 'ºC'),
	(68271, 112, '2015-02-15 00:34:11.000000', 'temperatura', 992.0000, 'ºC'),
	(68272, 112, '2015-02-15 00:34:12.000000', 'temperatura', 1117.0000, 'ºC'),
	(68273, 112, '2015-02-15 00:34:13.000000', 'temperatura', 212.0000, 'ºC'),
	(68274, 112, '2015-02-15 00:34:14.000000', 'temperatura', 107.0000, 'ºC'),
	(68275, 112, '2015-02-15 00:34:15.000000', 'temperatura', 1098.0000, 'ºC'),
	(68276, 112, '2015-02-15 00:34:16.000000', 'temperatura', 373.0000, 'ºC'),
	(68277, 112, '2015-02-15 00:34:17.000000', 'temperatura', 971.0000, 'ºC'),
	(68278, 112, '2015-02-15 00:34:18.000000', 'temperatura', 136.0000, 'ºC'),
	(68279, 112, '2015-02-15 00:34:19.000000', 'temperatura', 168.0000, 'ºC'),
	(68280, 112, '2015-02-15 00:34:20.000000', 'temperatura', 431.0000, 'ºC'),
	(68281, 112, '2015-02-15 00:34:21.000000', 'temperatura', 452.0000, 'ºC'),
	(68282, 112, '2015-02-15 00:34:22.000000', 'temperatura', 969.0000, 'ºC'),
	(68283, 112, '2015-02-15 00:34:23.000000', 'temperatura', 1087.0000, 'ºC'),
	(68284, 112, '2015-02-15 00:34:24.000000', 'temperatura', 131.0000, 'ºC'),
	(68285, 112, '2015-02-15 00:34:25.000000', 'temperatura', 992.0000, 'ºC'),
	(68286, 112, '2015-02-15 00:34:26.000000', 'temperatura', 971.0000, 'ºC'),
	(68287, 112, '2015-02-15 00:34:27.000000', 'temperatura', 677.0000, 'ºC'),
	(68288, 112, '2015-02-15 00:34:28.000000', 'temperatura', 471.0000, 'ºC'),
	(68289, 112, '2015-02-15 00:34:29.000000', 'temperatura', 327.0000, 'ºC'),
	(68290, 112, '2015-02-15 00:34:30.000000', 'temperatura', 221.0000, 'ºC'),
	(68291, 112, '2015-02-15 00:34:31.000000', 'temperatura', 124.0000, 'ºC'),
	(68292, 112, '2015-02-15 00:34:32.000000', 'temperatura', 1159.0000, 'ºC'),
	(68293, 112, '2015-02-15 00:34:33.000000', 'temperatura', 625.0000, 'ºC'),
	(68294, 112, '2015-02-15 00:34:34.000000', 'temperatura', 848.0000, 'ºC'),
	(68295, 112, '2015-02-15 00:34:35.000000', 'temperatura', 1163.0000, 'ºC'),
	(68296, 112, '2015-02-15 00:34:36.000000', 'temperatura', 872.0000, 'ºC'),
	(68297, 112, '2015-02-15 00:34:37.000000', 'temperatura', 872.0000, 'ºC'),
	(68298, 112, '2015-02-15 00:34:38.000000', 'temperatura', 543.0000, 'ºC'),
	(68299, 112, '2015-02-15 00:34:39.000000', 'temperatura', 101.0000, 'ºC'),
	(68300, 112, '2015-02-15 00:34:40.000000', 'temperatura', 77.0000, 'ºC'),
	(68301, 112, '2015-02-15 00:34:41.000000', 'temperatura', 80.0000, 'ºC'),
	(68302, 112, '2015-02-15 00:34:42.000000', 'temperatura', 172.0000, 'ºC'),
	(68303, 112, '2015-02-15 00:34:43.000000', 'temperatura', 620.0000, 'ºC'),
	(68304, 112, '2015-02-15 00:34:44.000000', 'temperatura', 186.0000, 'ºC'),
	(68305, 112, '2015-02-15 00:34:45.000000', 'temperatura', 271.0000, 'ºC'),
	(68306, 112, '2015-02-15 00:34:46.000000', 'temperatura', 796.0000, 'ºC'),
	(68307, 112, '2015-02-15 00:34:47.000000', 'temperatura', 768.0000, 'ºC'),
	(68308, 112, '2015-02-15 00:34:48.000000', 'temperatura', 254.0000, 'ºC'),
	(68309, 112, '2015-02-15 00:34:49.000000', 'temperatura', 166.0000, 'ºC'),
	(68310, 112, '2015-02-15 00:34:50.000000', 'temperatura', 68.0000, 'ºC'),
	(68311, 112, '2015-02-15 00:34:51.000000', 'temperatura', 1043.0000, 'ºC'),
	(68312, 112, '2015-02-15 00:34:52.000000', 'temperatura', 210.0000, 'ºC'),
	(68313, 112, '2015-02-15 00:34:53.000000', 'temperatura', 323.0000, 'ºC'),
	(68314, 112, '2015-02-15 00:34:54.000000', 'temperatura', 985.0000, 'ºC'),
	(68315, 112, '2015-02-15 00:34:55.000000', 'temperatura', 356.0000, 'ºC'),
	(68316, 112, '2015-02-15 00:34:56.000000', 'temperatura', 27.0000, 'ºC'),
	(68317, 112, '2015-02-15 00:34:57.000000', 'temperatura', 266.0000, 'ºC'),
	(68318, 112, '2015-02-15 00:34:58.000000', 'temperatura', 49.0000, 'ºC'),
	(68319, 112, '2015-02-15 00:34:59.000000', 'temperatura', 648.0000, 'ºC'),
	(68320, 112, '2015-02-15 00:35:00.000000', 'temperatura', 692.0000, 'ºC'),
	(68321, 112, '2015-02-15 00:35:01.000000', 'temperatura', 317.0000, 'ºC'),
	(68322, 112, '2015-02-15 00:35:02.000000', 'temperatura', 710.0000, 'ºC'),
	(68323, 112, '2015-02-15 00:35:03.000000', 'temperatura', 200.0000, 'ºC'),
	(68324, 112, '2015-02-15 00:35:04.000000', 'temperatura', 72.0000, 'ºC'),
	(68325, 112, '2015-02-15 00:35:05.000000', 'temperatura', 959.0000, 'ºC'),
	(68326, 112, '2015-02-15 00:35:06.000000', 'temperatura', 978.0000, 'ºC'),
	(68327, 112, '2015-02-15 00:35:07.000000', 'temperatura', 813.0000, 'ºC'),
	(68328, 112, '2015-02-15 00:35:08.000000', 'temperatura', 1134.0000, 'ºC'),
	(68329, 112, '2015-02-15 00:35:09.000000', 'temperatura', 830.0000, 'ºC'),
	(68330, 112, '2015-02-15 00:35:10.000000', 'temperatura', 749.0000, 'ºC'),
	(68331, 112, '2015-02-15 00:35:11.000000', 'temperatura', 55.0000, 'ºC'),
	(68332, 112, '2015-02-15 00:35:12.000000', 'temperatura', 430.0000, 'ºC'),
	(68333, 112, '2015-02-15 00:35:13.000000', 'temperatura', 785.0000, 'ºC'),
	(68334, 112, '2015-02-15 00:35:14.000000', 'temperatura', 237.0000, 'ºC'),
	(68335, 112, '2015-02-15 00:35:15.000000', 'temperatura', 31.0000, 'ºC'),
	(68336, 112, '2015-02-15 00:35:16.000000', 'temperatura', 643.0000, 'ºC'),
	(68337, 112, '2015-02-15 00:35:17.000000', 'temperatura', 724.0000, 'ºC'),
	(68338, 112, '2015-02-15 00:35:18.000000', 'temperatura', 490.0000, 'ºC'),
	(68339, 112, '2015-02-15 00:35:19.000000', 'temperatura', 280.0000, 'ºC'),
	(68340, 112, '2015-02-15 00:35:20.000000', 'temperatura', 1130.0000, 'ºC'),
	(68341, 112, '2015-02-15 00:35:21.000000', 'temperatura', 12.0000, 'ºC'),
	(68342, 112, '2015-02-15 00:35:22.000000', 'temperatura', 269.0000, 'ºC'),
	(68343, 112, '2015-02-15 00:35:23.000000', 'temperatura', 111.0000, 'ºC'),
	(68344, 112, '2015-02-15 00:35:24.000000', 'temperatura', 946.0000, 'ºC'),
	(68345, 112, '2015-02-15 00:35:25.000000', 'temperatura', 798.0000, 'ºC'),
	(68346, 112, '2015-02-15 00:35:26.000000', 'temperatura', 1154.0000, 'ºC'),
	(68347, 112, '2015-02-15 00:35:27.000000', 'temperatura', 975.0000, 'ºC'),
	(68348, 112, '2015-02-15 00:35:28.000000', 'temperatura', 214.0000, 'ºC'),
	(68349, 112, '2015-02-15 00:35:29.000000', 'temperatura', 544.0000, 'ºC'),
	(68350, 112, '2015-02-15 00:35:30.000000', 'temperatura', 878.0000, 'ºC'),
	(68351, 112, '2015-02-15 00:35:31.000000', 'temperatura', 359.0000, 'ºC'),
	(68352, 112, '2015-02-15 00:35:32.000000', 'temperatura', 360.0000, 'ºC'),
	(68353, 112, '2015-02-15 00:35:33.000000', 'temperatura', 727.0000, 'ºC'),
	(68354, 112, '2015-02-15 00:35:34.000000', 'temperatura', 152.0000, 'ºC'),
	(68355, 112, '2015-02-15 00:35:35.000000', 'temperatura', 980.0000, 'ºC'),
	(68356, 112, '2015-02-15 00:35:36.000000', 'temperatura', 846.0000, 'ºC'),
	(68357, 112, '2015-02-15 00:35:37.000000', 'temperatura', 90.0000, 'ºC'),
	(68358, 112, '2015-02-15 00:35:38.000000', 'temperatura', 312.0000, 'ºC'),
	(68359, 112, '2015-02-15 00:35:39.000000', 'temperatura', 91.0000, 'ºC'),
	(68360, 112, '2015-02-15 00:35:40.000000', 'temperatura', 719.0000, 'ºC'),
	(68361, 112, '2015-02-15 00:35:41.000000', 'temperatura', 925.0000, 'ºC'),
	(68362, 112, '2015-02-15 00:35:42.000000', 'temperatura', 66.0000, 'ºC'),
	(68363, 112, '2015-02-15 00:35:43.000000', 'temperatura', 1157.0000, 'ºC'),
	(68364, 112, '2015-02-15 00:35:44.000000', 'temperatura', 787.0000, 'ºC'),
	(68365, 112, '2015-02-15 00:35:45.000000', 'temperatura', 466.0000, 'ºC'),
	(68366, 112, '2015-02-15 00:35:46.000000', 'temperatura', 1170.0000, 'ºC'),
	(68367, 112, '2015-02-15 00:35:47.000000', 'temperatura', 853.0000, 'ºC'),
	(68368, 112, '2015-02-15 00:35:48.000000', 'temperatura', 754.0000, 'ºC'),
	(68369, 112, '2015-02-15 00:35:49.000000', 'temperatura', 12.0000, 'ºC'),
	(68370, 112, '2015-02-15 00:35:50.000000', 'temperatura', 199.0000, 'ºC'),
	(68371, 112, '2015-02-15 00:35:51.000000', 'temperatura', 960.0000, 'ºC'),
	(68372, 112, '2015-02-15 00:35:52.000000', 'temperatura', 603.0000, 'ºC'),
	(68373, 112, '2015-02-15 00:35:53.000000', 'temperatura', 135.0000, 'ºC'),
	(68374, 112, '2015-02-15 00:35:54.000000', 'temperatura', 66.0000, 'ºC'),
	(68375, 112, '2015-02-15 00:35:55.000000', 'temperatura', 1127.0000, 'ºC'),
	(68376, 112, '2015-02-15 00:35:56.000000', 'temperatura', 639.0000, 'ºC'),
	(68377, 112, '2015-02-15 00:35:57.000000', 'temperatura', 1013.0000, 'ºC'),
	(68378, 112, '2015-02-15 00:35:58.000000', 'temperatura', 747.0000, 'ºC'),
	(68379, 112, '2015-02-15 00:35:59.000000', 'temperatura', 700.0000, 'ºC'),
	(68380, 112, '2015-02-15 00:36:00.000000', 'temperatura', 56.0000, 'ºC'),
	(68381, 112, '2015-02-15 00:36:01.000000', 'temperatura', 580.0000, 'ºC'),
	(68382, 112, '2015-02-15 00:36:02.000000', 'temperatura', 335.0000, 'ºC'),
	(68383, 112, '2015-02-15 00:36:03.000000', 'temperatura', 1136.0000, 'ºC'),
	(68384, 112, '2015-02-15 00:36:04.000000', 'temperatura', 1075.0000, 'ºC'),
	(68385, 112, '2015-02-15 00:36:05.000000', 'temperatura', 767.0000, 'ºC'),
	(68386, 112, '2015-02-15 00:36:06.000000', 'temperatura', 609.0000, 'ºC'),
	(68387, 112, '2015-02-15 00:36:07.000000', 'temperatura', 744.0000, 'ºC'),
	(68388, 112, '2015-02-15 00:36:08.000000', 'temperatura', 697.0000, 'ºC'),
	(68389, 112, '2015-02-15 00:36:09.000000', 'temperatura', 51.0000, 'ºC'),
	(68390, 112, '2015-02-15 00:36:10.000000', 'temperatura', 565.0000, 'ºC'),
	(68391, 112, '2015-02-15 00:36:11.000000', 'temperatura', 270.0000, 'ºC'),
	(68392, 112, '2015-02-15 00:36:12.000000', 'temperatura', 859.0000, 'ºC'),
	(68393, 112, '2015-02-15 00:36:13.000000', 'temperatura', 1086.0000, 'ºC'),
	(68394, 112, '2015-02-15 00:36:14.000000', 'temperatura', 451.0000, 'ºC'),
	(68395, 112, '2015-02-15 00:36:15.000000', 'temperatura', 198.0000, 'ºC'),
	(68396, 112, '2015-02-15 00:36:16.000000', 'temperatura', 836.0000, 'ºC'),
	(68397, 112, '2015-02-15 00:36:17.000000', 'temperatura', 1187.0000, 'ºC'),
	(68398, 112, '2015-02-15 00:36:18.000000', 'temperatura', 1029.0000, 'ºC'),
	(68399, 112, '2015-02-15 00:36:19.000000', 'temperatura', 382.0000, 'ºC'),
	(68400, 112, '2015-02-15 00:36:20.000000', 'temperatura', 26.0000, 'ºC'),
	(68401, 112, '2015-02-15 00:36:21.000000', 'temperatura', 184.0000, 'ºC'),
	(68402, 112, '2015-02-15 00:36:22.000000', 'temperatura', 844.0000, 'ºC'),
	(68403, 112, '2015-02-15 00:36:23.000000', 'temperatura', 66.0000, 'ºC'),
	(68404, 112, '2015-02-15 00:36:24.000000', 'temperatura', 201.0000, 'ºC'),
	(68405, 112, '2015-02-15 00:36:25.000000', 'temperatura', 806.0000, 'ºC'),
	(68406, 112, '2015-02-15 00:36:26.000000', 'temperatura', 1027.0000, 'ºC'),
	(68407, 112, '2015-02-15 00:36:27.000000', 'temperatura', 316.0000, 'ºC'),
	(68408, 112, '2015-02-15 00:36:28.000000', 'temperatura', 903.0000, 'ºC'),
	(68409, 112, '2015-02-15 00:36:29.000000', 'temperatura', 1165.0000, 'ºC'),
	(68410, 112, '2015-02-15 00:36:30.000000', 'temperatura', 718.0000, 'ºC'),
	(68411, 112, '2015-02-15 00:36:31.000000', 'temperatura', 96.0000, 'ºC'),
	(68412, 112, '2015-02-15 00:36:32.000000', 'temperatura', 727.0000, 'ºC'),
	(68413, 112, '2015-02-15 00:36:33.000000', 'temperatura', 945.0000, 'ºC'),
	(68414, 112, '2015-02-15 00:36:34.000000', 'temperatura', 145.0000, 'ºC'),
	(68415, 112, '2015-02-15 00:36:35.000000', 'temperatura', 289.0000, 'ºC'),
	(68416, 112, '2015-02-15 00:36:36.000000', 'temperatura', 1012.0000, 'ºC'),
	(68417, 112, '2015-02-15 00:36:37.000000', 'temperatura', 593.0000, 'ºC'),
	(68418, 112, '2015-02-15 00:36:38.000000', 'temperatura', 1128.0000, 'ºC'),
	(68419, 112, '2015-02-15 00:36:39.000000', 'temperatura', 263.0000, 'ºC'),
	(68420, 112, '2015-02-15 00:36:40.000000', 'temperatura', 332.0000, 'ºC'),
	(68421, 112, '2015-02-15 00:36:41.000000', 'temperatura', 870.0000, 'ºC'),
	(68422, 112, '2015-02-15 00:36:42.000000', 'temperatura', 956.0000, 'ºC'),
	(68423, 112, '2015-02-15 00:36:43.000000', 'temperatura', 970.0000, 'ºC'),
	(68424, 112, '2015-02-15 00:36:44.000000', 'temperatura', 781.0000, 'ºC'),
	(68425, 112, '2015-02-15 00:36:45.000000', 'temperatura', 996.0000, 'ºC'),
	(68426, 112, '2015-02-15 00:36:46.000000', 'temperatura', 239.0000, 'ºC'),
	(68427, 112, '2015-02-15 00:36:47.000000', 'temperatura', 608.0000, 'ºC'),
	(68428, 112, '2015-02-15 00:36:48.000000', 'temperatura', 1124.0000, 'ºC'),
	(68429, 112, '2015-02-15 00:36:49.000000', 'temperatura', 197.0000, 'ºC'),
	(68430, 112, '2015-02-15 00:36:50.000000', 'temperatura', 11.0000, 'ºC'),
	(68431, 112, '2015-02-15 00:36:51.000000', 'temperatura', 665.0000, 'ºC'),
	(68432, 112, '2015-02-15 00:36:52.000000', 'temperatura', 892.0000, 'ºC'),
	(68433, 112, '2015-02-15 00:36:53.000000', 'temperatura', 65.0000, 'ºC'),
	(68434, 112, '2015-02-15 00:36:54.000000', 'temperatura', 52.0000, 'ºC'),
	(68435, 112, '2015-02-15 00:36:55.000000', 'temperatura', 65.0000, 'ºC'),
	(68436, 112, '2015-02-15 00:36:56.000000', 'temperatura', 171.0000, 'ºC'),
	(68437, 112, '2015-02-15 00:36:57.000000', 'temperatura', 659.0000, 'ºC'),
	(68438, 112, '2015-02-15 00:36:58.000000', 'temperatura', 382.0000, 'ºC'),
	(68439, 112, '2015-02-15 00:36:59.000000', 'temperatura', 1134.0000, 'ºC'),
	(68440, 112, '2015-02-15 00:37:00.000000', 'temperatura', 923.0000, 'ºC'),
	(68441, 112, '2015-02-15 00:37:01.000000', 'temperatura', 15.0000, 'ºC'),
	(68442, 112, '2015-02-15 00:37:02.000000', 'temperatura', 906.0000, 'ºC'),
	(68443, 112, '2015-02-15 00:37:03.000000', 'temperatura', 887.0000, 'ºC'),
	(68444, 112, '2015-02-15 00:37:04.000000', 'temperatura', 515.0000, 'ºC'),
	(68445, 112, '2015-02-15 00:37:05.000000', 'temperatura', 1114.0000, 'ºC'),
	(68446, 112, '2015-02-15 00:37:06.000000', 'temperatura', 429.0000, 'ºC'),
	(68447, 112, '2015-02-15 00:37:07.000000', 'temperatura', 0.0000, 'ºC'),
	(68448, 112, '2015-02-15 00:37:08.000000', 'temperatura', 1115.0000, 'ºC'),
	(68449, 112, '2015-02-15 00:37:09.000000', 'temperatura', 776.0000, 'ºC'),
	(68450, 112, '2015-02-15 00:37:10.000000', 'temperatura', 534.0000, 'ºC'),
	(68451, 112, '2015-02-15 00:37:11.000000', 'temperatura', 343.0000, 'ºC'),
	(68452, 112, '2015-02-15 00:37:12.000000', 'temperatura', 112.0000, 'ºC'),
	(68453, 112, '2015-02-15 00:37:13.000000', 'temperatura', 734.0000, 'ºC'),
	(68454, 112, '2015-02-15 00:37:14.000000', 'temperatura', 933.0000, 'ºC'),
	(68455, 112, '2015-02-15 00:37:15.000000', 'temperatura', 62.0000, 'ºC'),
	(68456, 112, '2015-02-15 00:37:16.000000', 'temperatura', 1114.0000, 'ºC'),
	(68457, 112, '2015-02-15 00:37:17.000000', 'temperatura', 583.0000, 'ºC'),
	(68458, 112, '2015-02-15 00:37:18.000000', 'temperatura', 773.0000, 'ºC'),
	(68459, 112, '2015-02-15 00:37:19.000000', 'temperatura', 916.0000, 'ºC'),
	(68460, 112, '2015-02-15 00:37:20.000000', 'temperatura', 1064.0000, 'ºC'),
	(68461, 112, '2015-02-15 00:37:21.000000', 'temperatura', 171.0000, 'ºC'),
	(68462, 112, '2015-02-15 00:37:22.000000', 'temperatura', 65.0000, 'ºC'),
	(68463, 112, '2015-02-15 00:37:23.000000', 'temperatura', 1010.0000, 'ºC'),
	(68464, 112, '2015-02-15 00:37:24.000000', 'temperatura', 55.0000, 'ºC'),
	(68465, 112, '2015-02-15 00:37:25.000000', 'temperatura', 847.0000, 'ºC'),
	(68466, 112, '2015-02-15 00:37:26.000000', 'temperatura', 471.0000, 'ºC'),
	(68467, 112, '2015-02-15 00:37:27.000000', 'temperatura', 1015.0000, 'ºC'),
	(68468, 112, '2015-02-15 00:37:28.000000', 'temperatura', 63.0000, 'ºC'),
	(68469, 112, '2015-02-15 00:37:29.000000', 'temperatura', 872.0000, 'ºC'),
	(68470, 112, '2015-02-15 00:37:30.000000', 'temperatura', 568.0000, 'ºC'),
	(68471, 112, '2015-02-15 00:37:31.000000', 'temperatura', 227.0000, 'ºC'),
	(68472, 112, '2015-02-15 00:37:32.000000', 'temperatura', 631.0000, 'ºC'),
	(68473, 112, '2015-02-15 00:37:33.000000', 'temperatura', 75.0000, 'ºC'),
	(68474, 112, '2015-02-15 00:37:34.000000', 'temperatura', 880.0000, 'ºC'),
	(68475, 112, '2015-02-15 00:37:35.000000', 'temperatura', 578.0000, 'ºC'),
	(68476, 112, '2015-02-15 00:37:36.000000', 'temperatura', 250.0000, 'ºC'),
	(68477, 112, '2015-02-15 00:37:37.000000', 'temperatura', 718.0000, 'ºC'),
	(68478, 112, '2015-02-15 00:37:38.000000', 'temperatura', 441.0000, 'ºC'),
	(68479, 112, '2015-02-15 00:37:39.000000', 'temperatura', 51.0000, 'ºC'),
	(68480, 112, '2015-02-15 00:37:40.000000', 'temperatura', 132.0000, 'ºC'),
	(68481, 112, '2015-02-15 00:37:41.000000', 'temperatura', 508.0000, 'ºC'),
	(68482, 112, '2015-02-15 00:37:42.000000', 'temperatura', 946.0000, 'ºC'),
	(68483, 112, '2015-02-15 00:37:43.000000', 'temperatura', 804.0000, 'ºC'),
	(68484, 112, '2015-02-15 00:37:44.000000', 'temperatura', 1183.0000, 'ºC'),
	(68485, 112, '2015-02-15 00:37:45.000000', 'temperatura', 1105.0000, 'ºC'),
	(68486, 112, '2015-02-15 00:37:46.000000', 'temperatura', 774.0000, 'ºC'),
	(68487, 112, '2015-02-15 00:37:47.000000', 'temperatura', 556.0000, 'ºC'),
	(68488, 112, '2015-02-15 00:37:48.000000', 'temperatura', 457.0000, 'ºC'),
	(68489, 112, '2015-02-15 00:37:49.000000', 'temperatura', 620.0000, 'ºC'),
	(68490, 112, '2015-02-15 00:37:50.000000', 'temperatura', 530.0000, 'ºC'),
	(68491, 112, '2015-02-15 00:37:51.000000', 'temperatura', 788.0000, 'ºC'),
	(68492, 112, '2015-02-15 00:37:52.000000', 'temperatura', 1150.0000, 'ºC'),
	(68493, 112, '2015-02-15 00:37:53.000000', 'temperatura', 987.0000, 'ºC'),
	(68494, 112, '2015-02-15 00:37:54.000000', 'temperatura', 288.0000, 'ºC'),
	(68495, 112, '2015-02-15 00:37:55.000000', 'temperatura', 878.0000, 'ºC'),
	(68496, 112, '2015-02-15 00:37:56.000000', 'temperatura', 1128.0000, 'ºC'),
	(68497, 112, '2015-02-15 00:37:57.000000', 'temperatura', 606.0000, 'ºC'),
	(68498, 112, '2015-02-15 00:37:58.000000', 'temperatura', 845.0000, 'ºC'),
	(68499, 112, '2015-02-15 00:37:59.000000', 'temperatura', 10.0000, 'ºC'),
	(68500, 112, '2015-02-15 00:38:00.000000', 'temperatura', 1116.0000, 'ºC'),
	(68501, 112, '2015-02-15 00:38:01.000000', 'temperatura', 749.0000, 'ºC'),
	(68502, 112, '2015-02-15 00:38:02.000000', 'temperatura', 398.0000, 'ºC'),
	(68503, 112, '2015-02-15 00:38:03.000000', 'temperatura', 943.0000, 'ºC'),
	(68504, 112, '2015-02-15 00:38:04.000000', 'temperatura', 1121.0000, 'ºC'),
	(68505, 112, '2015-02-15 00:38:05.000000', 'temperatura', 378.0000, 'ºC'),
	(68506, 112, '2015-02-15 00:38:06.000000', 'temperatura', 929.0000, 'ºC'),
	(68507, 112, '2015-02-15 00:38:07.000000', 'temperatura', 1108.0000, 'ºC'),
	(68508, 112, '2015-02-15 00:38:08.000000', 'temperatura', 355.0000, 'ºC'),
	(68509, 112, '2015-02-15 00:38:09.000000', 'temperatura', 852.0000, 'ºC'),
	(68510, 112, '2015-02-15 00:38:10.000000', 'temperatura', 794.0000, 'ºC'),
	(68511, 112, '2015-02-15 00:38:11.000000', 'temperatura', 217.0000, 'ºC'),
	(68512, 112, '2015-02-15 00:38:12.000000', 'temperatura', 1104.0000, 'ºC'),
	(68513, 112, '2015-02-15 00:38:13.000000', 'temperatura', 68.0000, 'ºC'),
	(68514, 112, '2015-02-15 00:38:14.000000', 'temperatura', 630.0000, 'ºC'),
	(68515, 112, '2015-02-15 00:38:15.000000', 'temperatura', 545.0000, 'ºC'),
	(68516, 112, '2015-02-15 00:38:16.000000', 'temperatura', 835.0000, 'ºC'),
	(68517, 112, '2015-02-15 00:38:17.000000', 'temperatura', 143.0000, 'ºC'),
	(68518, 112, '2015-02-15 00:38:18.000000', 'temperatura', 610.0000, 'ºC'),
	(68519, 112, '2015-02-15 00:38:19.000000', 'temperatura', 222.0000, 'ºC'),
	(68520, 112, '2015-02-15 00:38:20.000000', 'temperatura', 478.0000, 'ºC'),
	(68521, 112, '2015-02-15 00:38:21.000000', 'temperatura', 525.0000, 'ºC'),
	(68522, 112, '2015-02-15 00:38:22.000000', 'temperatura', 1194.0000, 'ºC'),
	(68523, 112, '2015-02-15 00:38:23.000000', 'temperatura', 793.0000, 'ºC'),
	(68524, 112, '2015-02-15 00:38:24.000000', 'temperatura', 383.0000, 'ºC'),
	(68525, 112, '2015-02-15 00:38:25.000000', 'temperatura', 736.0000, 'ºC'),
	(68526, 112, '2015-02-15 00:38:26.000000', 'temperatura', 132.0000, 'ºC'),
	(68527, 112, '2015-02-15 00:38:27.000000', 'temperatura', 854.0000, 'ºC'),
	(68528, 112, '2015-02-15 00:38:28.000000', 'temperatura', 274.0000, 'ºC'),
	(68529, 112, '2015-02-15 00:38:29.000000', 'temperatura', 8.0000, 'ºC'),
	(68530, 112, '2015-02-15 00:38:30.000000', 'temperatura', 417.0000, 'ºC'),
	(68531, 112, '2015-02-15 00:38:31.000000', 'temperatura', 861.0000, 'ºC'),
	(68532, 112, '2015-02-15 00:38:32.000000', 'temperatura', 655.0000, 'ºC'),
	(68533, 112, '2015-02-15 00:38:33.000000', 'temperatura', 695.0000, 'ºC'),
	(68534, 112, '2015-02-15 00:38:34.000000', 'temperatura', 308.0000, 'ºC'),
	(68535, 112, '2015-02-15 00:38:35.000000', 'temperatura', 658.0000, 'ºC'),
	(68536, 112, '2015-02-15 00:38:36.000000', 'temperatura', 1167.0000, 'ºC'),
	(68537, 112, '2015-02-15 00:38:37.000000', 'temperatura', 259.0000, 'ºC'),
	(68538, 112, '2015-02-15 00:38:38.000000', 'temperatura', 196.0000, 'ºC'),
	(68539, 112, '2015-02-15 00:38:39.000000', 'temperatura', 204.0000, 'ºC'),
	(68540, 112, '2015-02-15 00:38:40.000000', 'temperatura', 432.0000, 'ºC'),
	(68541, 112, '2015-02-15 00:38:41.000000', 'temperatura', 349.0000, 'ºC'),
	(68542, 112, '2015-02-15 00:38:42.000000', 'temperatura', 448.0000, 'ºC'),
	(68543, 112, '2015-02-15 00:38:43.000000', 'temperatura', 1193.0000, 'ºC'),
	(68544, 112, '2015-02-15 00:38:44.000000', 'temperatura', 1023.0000, 'ºC'),
	(68545, 112, '2015-02-15 00:38:45.000000', 'temperatura', 336.0000, 'ºC'),
	(68546, 112, '2015-02-15 00:38:46.000000', 'temperatura', 1013.0000, 'ºC'),
	(68547, 112, '2015-02-15 00:38:47.000000', 'temperatura', 458.0000, 'ºC'),
	(68548, 112, '2015-02-15 00:38:48.000000', 'temperatura', 450.0000, 'ºC'),
	(68549, 112, '2015-02-15 00:38:49.000000', 'temperatura', 875.0000, 'ºC'),
	(68550, 112, '2015-02-15 00:38:50.000000', 'temperatura', 627.0000, 'ºC'),
	(68551, 112, '2015-02-15 00:38:51.000000', 'temperatura', 511.0000, 'ºC'),
	(68552, 112, '2015-02-15 00:38:52.000000', 'temperatura', 676.0000, 'ºC'),
	(68553, 112, '2015-02-15 00:38:53.000000', 'temperatura', 645.0000, 'ºC'),
	(68554, 112, '2015-02-15 00:38:54.000000', 'temperatura', 1199.0000, 'ºC'),
	(68555, 112, '2015-02-15 00:38:55.000000', 'temperatura', 459.0000, 'ºC'),
	(68556, 112, '2015-02-15 00:38:56.000000', 'temperatura', 1097.0000, 'ºC'),
	(68557, 112, '2015-02-15 00:38:57.000000', 'temperatura', 512.0000, 'ºC'),
	(68558, 112, '2015-02-15 00:38:58.000000', 'temperatura', 467.0000, 'ºC'),
	(68559, 112, '2015-02-15 00:38:59.000000', 'temperatura', 800.0000, 'ºC'),
	(68560, 112, '2015-02-15 00:39:00.000000', 'temperatura', 201.0000, 'ºC'),
	(68561, 112, '2015-02-15 00:39:01.000000', 'temperatura', 1006.0000, 'ºC'),
	(68562, 112, '2015-02-15 00:39:02.000000', 'temperatura', 826.0000, 'ºC'),
	(68563, 112, '2015-02-15 00:39:03.000000', 'temperatura', 1115.0000, 'ºC'),
	(68564, 112, '2015-02-15 00:39:04.000000', 'temperatura', 695.0000, 'ºC'),
	(68565, 112, '2015-02-15 00:39:05.000000', 'temperatura', 133.0000, 'ºC'),
	(68566, 112, '2015-02-15 00:39:06.000000', 'temperatura', 977.0000, 'ºC'),
	(68567, 112, '2015-02-15 00:39:07.000000', 'temperatura', 889.0000, 'ºC'),
	(68568, 112, '2015-02-15 00:39:08.000000', 'temperatura', 313.0000, 'ºC'),
	(68569, 112, '2015-02-15 00:39:09.000000', 'temperatura', 100.0000, 'ºC'),
	(68570, 112, '2015-02-15 00:39:10.000000', 'temperatura', 760.0000, 'ºC'),
	(68571, 112, '2015-02-15 00:39:11.000000', 'temperatura', 1101.0000, 'ºC'),
	(68572, 112, '2015-02-15 00:39:12.000000', 'temperatura', 826.0000, 'ºC'),
	(68573, 112, '2015-02-15 00:39:13.000000', 'temperatura', 829.0000, 'ºC'),
	(68574, 112, '2015-02-15 00:39:14.000000', 'temperatura', 467.0000, 'ºC'),
	(68575, 112, '2015-02-15 00:39:15.000000', 'temperatura', 1048.0000, 'ºC'),
	(68576, 112, '2015-02-15 00:39:16.000000', 'temperatura', 240.0000, 'ºC'),
	(68577, 112, '2015-02-15 00:39:17.000000', 'temperatura', 458.0000, 'ºC'),
	(68578, 112, '2015-02-15 00:39:18.000000', 'temperatura', 368.0000, 'ºC'),
	(68579, 112, '2015-02-15 00:39:19.000000', 'temperatura', 465.0000, 'ºC'),
	(68580, 112, '2015-02-15 00:39:20.000000', 'temperatura', 24.0000, 'ºC'),
	(68581, 112, '2015-02-15 00:39:21.000000', 'temperatura', 1126.0000, 'ºC'),
	(68582, 112, '2015-02-15 00:39:22.000000', 'temperatura', 757.0000, 'ºC'),
	(68583, 112, '2015-02-15 00:39:23.000000', 'temperatura', 406.0000, 'ºC'),
	(68584, 112, '2015-02-15 00:39:24.000000', 'temperatura', 962.0000, 'ºC'),
	(68585, 112, '2015-02-15 00:39:25.000000', 'temperatura', 1194.0000, 'ºC'),
	(68586, 112, '2015-02-15 00:39:26.000000', 'temperatura', 681.0000, 'ºC'),
	(68587, 112, '2015-02-15 00:39:27.000000', 'temperatura', 1027.0000, 'ºC'),
	(68588, 112, '2015-02-15 00:39:28.000000', 'temperatura', 690.0000, 'ºC'),
	(68589, 112, '2015-02-15 00:39:29.000000', 'temperatura', 372.0000, 'ºC'),
	(68590, 112, '2015-02-15 00:39:30.000000', 'temperatura', 990.0000, 'ºC'),
	(68591, 112, '2015-02-15 00:39:31.000000', 'temperatura', 232.0000, 'ºC'),
	(68592, 112, '2015-02-15 00:39:32.000000', 'temperatura', 593.0000, 'ºC'),
	(68593, 112, '2015-02-15 00:39:33.000000', 'temperatura', 1070.0000, 'ºC'),
	(68594, 112, '2015-02-15 00:39:34.000000', 'temperatura', 1171.0000, 'ºC'),
	(68595, 112, '2015-02-15 00:39:35.000000', 'temperatura', 246.0000, 'ºC'),
	(68596, 112, '2015-02-15 00:39:36.000000', 'temperatura', 119.0000, 'ºC'),
	(68597, 112, '2015-02-15 00:39:37.000000', 'temperatura', 1055.0000, 'ºC'),
	(68598, 112, '2015-02-15 00:39:38.000000', 'temperatura', 121.0000, 'ºC'),
	(68599, 112, '2015-02-15 00:39:39.000000', 'temperatura', 1040.0000, 'ºC'),
	(68600, 112, '2015-02-15 00:39:40.000000', 'temperatura', 36.0000, 'ºC'),
	(68601, 112, '2015-02-15 00:39:41.000000', 'temperatura', 663.0000, 'ºC'),
	(68602, 112, '2015-02-15 00:39:42.000000', 'temperatura', 804.0000, 'ºC'),
	(68603, 112, '2015-02-15 00:39:43.000000', 'temperatura', 834.0000, 'ºC'),
	(68604, 112, '2015-02-15 00:39:44.000000', 'temperatura', 558.0000, 'ºC'),
	(68605, 112, '2015-02-15 00:39:45.000000', 'temperatura', 286.0000, 'ºC'),
	(68606, 112, '2015-02-15 00:39:46.000000', 'temperatura', 960.0000, 'ºC'),
	(68607, 112, '2015-02-15 00:39:47.000000', 'temperatura', 342.0000, 'ºC'),
	(68608, 112, '2015-02-15 00:39:48.000000', 'temperatura', 28.0000, 'ºC'),
	(68609, 112, '2015-02-15 00:39:49.000000', 'temperatura', 315.0000, 'ºC'),
	(68610, 112, '2015-02-15 00:39:50.000000', 'temperatura', 292.0000, 'ºC'),
	(68611, 112, '2015-02-15 00:39:51.000000', 'temperatura', 517.0000, 'ºC'),
	(68612, 112, '2015-02-15 00:39:52.000000', 'temperatura', 511.0000, 'ºC'),
	(68613, 112, '2015-02-15 00:39:53.000000', 'temperatura', 1001.0000, 'ºC'),
	(68614, 112, '2015-02-15 00:39:54.000000', 'temperatura', 1073.0000, 'ºC'),
	(68615, 112, '2015-02-15 00:39:55.000000', 'temperatura', 1162.0000, 'ºC'),
	(68616, 112, '2015-02-15 00:39:56.000000', 'temperatura', 190.0000, 'ºC'),
	(68617, 112, '2015-02-15 00:39:57.000000', 'temperatura', 1068.0000, 'ºC'),
	(68618, 112, '2015-02-15 00:39:58.000000', 'temperatura', 1170.0000, 'ºC'),
	(68619, 112, '2015-02-15 00:39:59.000000', 'temperatura', 245.0000, 'ºC'),
	(68620, 112, '2015-02-15 00:40:00.000000', 'temperatura', 118.0000, 'ºC'),
	(68621, 112, '2015-02-15 00:40:01.000000', 'temperatura', 1054.0000, 'ºC'),
	(68622, 112, '2015-02-15 00:40:02.000000', 'temperatura', 117.0000, 'ºC'),
	(68623, 112, '2015-02-15 00:40:03.000000', 'temperatura', 1025.0000, 'ºC'),
	(68624, 112, '2015-02-15 00:40:04.000000', 'temperatura', 1175.0000, 'ºC'),
	(68625, 112, '2015-02-15 00:40:05.000000', 'temperatura', 397.0000, 'ºC'),
	(68626, 112, '2015-02-15 00:40:06.000000', 'temperatura', 863.0000, 'ºC'),
	(68627, 112, '2015-02-15 00:40:07.000000', 'temperatura', 725.0000, 'ºC'),
	(68628, 112, '2015-02-15 00:40:08.000000', 'temperatura', 1036.0000, 'ºC'),
	(68629, 112, '2015-02-15 00:40:09.000000', 'temperatura', 605.0000, 'ºC'),
	(68630, 112, '2015-02-15 00:40:10.000000', 'temperatura', 1118.0000, 'ºC'),
	(68631, 112, '2015-02-15 00:40:11.000000', 'temperatura', 174.0000, 'ºC'),
	(68632, 112, '2015-02-15 00:40:12.000000', 'temperatura', 1116.0000, 'ºC'),
	(68633, 112, '2015-02-15 00:40:13.000000', 'temperatura', 259.0000, 'ºC'),
	(68634, 112, '2015-02-15 00:40:14.000000', 'temperatura', 349.0000, 'ºC'),
	(68635, 112, '2015-02-15 00:40:15.000000', 'temperatura', 970.0000, 'ºC'),
	(68636, 112, '2015-02-15 00:40:16.000000', 'temperatura', 201.0000, 'ºC'),
	(68637, 112, '2015-02-15 00:40:17.000000', 'temperatura', 496.0000, 'ºC'),
	(68638, 112, '2015-02-15 00:40:18.000000', 'temperatura', 679.0000, 'ºC'),
	(68639, 112, '2015-02-15 00:40:19.000000', 'temperatura', 708.0000, 'ºC'),
	(68640, 112, '2015-02-15 00:40:20.000000', 'temperatura', 304.0000, 'ºC'),
	(68641, 112, '2015-02-15 00:40:21.000000', 'temperatura', 595.0000, 'ºC'),
	(68642, 112, '2015-02-15 00:40:22.000000', 'temperatura', 863.0000, 'ºC'),
	(68643, 112, '2015-02-15 00:40:23.000000', 'temperatura', 130.0000, 'ºC'),
	(68644, 112, '2015-02-15 00:40:24.000000', 'temperatura', 464.0000, 'ºC'),
	(68645, 112, '2015-02-15 00:40:25.000000', 'temperatura', 730.0000, 'ºC'),
	(68646, 112, '2015-02-15 00:40:26.000000', 'temperatura', 1056.0000, 'ºC'),
	(68647, 112, '2015-02-15 00:40:27.000000', 'temperatura', 692.0000, 'ºC'),
	(68648, 112, '2015-02-15 00:40:28.000000', 'temperatura', 293.0000, 'ºC'),
	(68649, 112, '2015-02-15 00:40:29.000000', 'temperatura', 588.0000, 'ºC'),
	(68650, 112, '2015-02-15 00:40:30.000000', 'temperatura', 862.0000, 'ºC'),
	(68651, 112, '2015-02-15 00:40:31.000000', 'temperatura', 146.0000, 'ºC'),
	(68652, 112, '2015-02-15 00:40:32.000000', 'temperatura', 544.0000, 'ºC'),
	(68653, 112, '2015-02-15 00:40:33.000000', 'temperatura', 1082.0000, 'ºC'),
	(68654, 112, '2015-02-15 00:40:34.000000', 'temperatura', 178.0000, 'ºC'),
	(68655, 112, '2015-02-15 00:40:35.000000', 'temperatura', 45.0000, 'ºC'),
	(68656, 112, '2015-02-15 00:40:36.000000', 'temperatura', 893.0000, 'ºC'),
	(68657, 112, '2015-02-15 00:40:37.000000', 'temperatura', 730.0000, 'ºC'),
	(68658, 112, '2015-02-15 00:40:38.000000', 'temperatura', 969.0000, 'ºC'),
	(68659, 112, '2015-02-15 00:40:39.000000', 'temperatura', 258.0000, 'ºC'),
	(68660, 112, '2015-02-15 00:40:40.000000', 'temperatura', 784.0000, 'ºC'),
	(68661, 112, '2015-02-15 00:40:41.000000', 'temperatura', 745.0000, 'ºC'),
	(68662, 112, '2015-02-15 00:40:42.000000', 'temperatura', 173.0000, 'ºC'),
	(68663, 112, '2015-02-15 00:40:43.000000', 'temperatura', 1031.0000, 'ºC'),
	(68664, 112, '2015-02-15 00:40:44.000000', 'temperatura', 1035.0000, 'ºC'),
	(68665, 112, '2015-02-15 00:40:45.000000', 'temperatura', 884.0000, 'ºC'),
	(68666, 112, '2015-02-15 00:40:46.000000', 'temperatura', 117.0000, 'ºC'),
	(68667, 112, '2015-02-15 00:40:47.000000', 'temperatura', 334.0000, 'ºC'),
	(68668, 112, '2015-02-15 00:40:48.000000', 'temperatura', 117.0000, 'ºC'),
	(68669, 112, '2015-02-15 00:40:49.000000', 'temperatura', 786.0000, 'ºC'),
	(68670, 112, '2015-02-15 00:40:50.000000', 'temperatura', 1177.0000, 'ºC'),
	(68671, 112, '2015-02-15 00:40:51.000000', 'temperatura', 1127.0000, 'ºC'),
	(68672, 112, '2015-02-15 00:40:52.000000', 'temperatura', 906.0000, 'ºC'),
	(68673, 112, '2015-02-15 00:40:53.000000', 'temperatura', 1150.0000, 'ºC'),
	(68674, 112, '2015-02-15 00:40:54.000000', 'temperatura', 632.0000, 'ºC'),
	(68675, 112, '2015-02-15 00:40:55.000000', 'temperatura', 912.0000, 'ºC'),
	(68676, 112, '2015-02-15 00:40:56.000000', 'temperatura', 262.0000, 'ºC'),
	(68677, 112, '2015-02-15 00:40:57.000000', 'temperatura', 977.0000, 'ºC'),
	(68678, 112, '2015-02-15 00:40:58.000000', 'temperatura', 499.0000, 'ºC'),
	(68679, 112, '2015-02-15 00:40:59.000000', 'temperatura', 765.0000, 'ºC'),
	(68680, 112, '2015-02-15 00:41:00.000000', 'temperatura', 1129.0000, 'ºC'),
	(68681, 112, '2015-02-15 00:41:01.000000', 'temperatura', 949.0000, 'ºC'),
	(68682, 112, '2015-02-15 00:41:02.000000', 'temperatura', 161.0000, 'ºC'),
	(68683, 112, '2015-02-15 00:41:03.000000', 'temperatura', 356.0000, 'ºC'),
	(68684, 112, '2015-02-15 00:41:04.000000', 'temperatura', 99.0000, 'ºC'),
	(68685, 112, '2015-02-15 00:41:05.000000', 'temperatura', 628.0000, 'ºC'),
	(68686, 112, '2015-02-15 00:41:06.000000', 'temperatura', 442.0000, 'ºC'),
	(68687, 112, '2015-02-15 00:41:07.000000', 'temperatura', 326.0000, 'ºC'),
	(68688, 112, '2015-02-15 00:41:08.000000', 'temperatura', 307.0000, 'ºC'),
	(68689, 112, '2015-02-15 00:41:09.000000', 'temperatura', 556.0000, 'ºC'),
	(68690, 112, '2015-02-15 00:41:10.000000', 'temperatura', 661.0000, 'ºC'),
	(68691, 112, '2015-02-15 00:41:11.000000', 'temperatura', 436.0000, 'ºC'),
	(68692, 112, '2015-02-15 00:41:12.000000', 'temperatura', 196.0000, 'ºC'),
	(68693, 112, '2015-02-15 00:41:13.000000', 'temperatura', 875.0000, 'ºC'),
	(68694, 112, '2015-02-15 00:41:14.000000', 'temperatura', 188.0000, 'ºC'),
	(68695, 112, '2015-02-15 00:41:15.000000', 'temperatura', 716.0000, 'ºC'),
	(68696, 112, '2015-02-15 00:41:16.000000', 'temperatura', 614.0000, 'ºC'),
	(68697, 112, '2015-02-15 00:41:17.000000', 'temperatura', 922.0000, 'ºC'),
	(68698, 112, '2015-02-15 00:41:18.000000', 'temperatura', 369.0000, 'ºC'),
	(68699, 112, '2015-02-15 00:41:19.000000', 'temperatura', 282.0000, 'ºC'),
	(68700, 112, '2015-02-15 00:41:20.000000', 'temperatura', 302.0000, 'ºC'),
	(68701, 112, '2015-02-15 00:41:21.000000', 'temperatura', 665.0000, 'ºC'),
	(68702, 112, '2015-02-15 00:41:22.000000', 'temperatura', 20.0000, 'ºC'),
	(68703, 112, '2015-02-15 00:41:23.000000', 'temperatura', 503.0000, 'ºC'),
	(68704, 112, '2015-02-15 00:41:24.000000', 'temperatura', 58.0000, 'ºC'),
	(68705, 112, '2015-02-15 00:41:25.000000', 'temperatura', 1179.0000, 'ºC'),
	(68706, 112, '2015-02-15 00:41:26.000000', 'temperatura', 922.0000, 'ºC'),
	(68707, 112, '2015-02-15 00:41:27.000000', 'temperatura', 1075.0000, 'ºC'),
	(68708, 112, '2015-02-15 00:41:28.000000', 'temperatura', 209.0000, 'ºC'),
	(68709, 112, '2015-02-15 00:41:29.000000', 'temperatura', 222.0000, 'ºC'),
	(68710, 112, '2015-02-15 00:41:30.000000', 'temperatura', 483.0000, 'ºC'),
	(68711, 112, '2015-02-15 00:41:31.000000', 'temperatura', 550.0000, 'ºC'),
	(68712, 112, '2015-02-15 00:41:32.000000', 'temperatura', 99.0000, 'ºC'),
	(68713, 112, '2015-02-15 00:41:33.000000', 'temperatura', 49.0000, 'ºC'),
	(68714, 112, '2015-02-15 00:41:34.000000', 'temperatura', 1146.0000, 'ºC'),
	(68715, 112, '2015-02-15 00:41:35.000000', 'temperatura', 785.0000, 'ºC'),
	(68716, 112, '2015-02-15 00:41:36.000000', 'temperatura', 487.0000, 'ºC'),
	(68717, 112, '2015-02-15 00:41:37.000000', 'temperatura', 82.0000, 'ºC'),
	(68718, 112, '2015-02-15 00:41:38.000000', 'temperatura', 150.0000, 'ºC'),
	(68719, 112, '2015-02-15 00:41:39.000000', 'temperatura', 504.0000, 'ºC'),
	(68720, 112, '2015-02-15 00:41:40.000000', 'temperatura', 869.0000, 'ºC'),
	(68721, 112, '2015-02-15 00:41:41.000000', 'temperatura', 434.0000, 'ºC'),
	(68722, 112, '2015-02-15 00:41:42.000000', 'temperatura', 766.0000, 'ºC'),
	(68723, 112, '2015-02-15 00:41:43.000000', 'temperatura', 125.0000, 'ºC'),
	(68724, 112, '2015-02-15 00:41:44.000000', 'temperatura', 730.0000, 'ºC'),
	(68725, 112, '2015-02-15 00:41:45.000000', 'temperatura', 876.0000, 'ºC'),
	(68726, 112, '2015-02-15 00:41:46.000000', 'temperatura', 991.0000, 'ºC'),
	(68727, 112, '2015-02-15 00:41:47.000000', 'temperatura', 1127.0000, 'ºC'),
	(68728, 112, '2015-02-15 00:41:48.000000', 'temperatura', 264.0000, 'ºC'),
	(68729, 112, '2015-02-15 00:41:49.000000', 'temperatura', 337.0000, 'ºC'),
	(68730, 112, '2015-02-15 00:41:50.000000', 'temperatura', 894.0000, 'ºC'),
	(68731, 112, '2015-02-15 00:41:51.000000', 'temperatura', 1061.0000, 'ºC'),
	(68732, 112, '2015-02-15 00:41:52.000000', 'temperatura', 222.0000, 'ºC'),
	(68733, 112, '2015-02-15 00:41:53.000000', 'temperatura', 328.0000, 'ºC'),
	(68734, 112, '2015-02-15 00:41:54.000000', 'temperatura', 973.0000, 'ºC'),
	(68735, 112, '2015-02-15 00:41:55.000000', 'temperatura', 283.0000, 'ºC'),
	(68736, 112, '2015-02-15 00:41:56.000000', 'temperatura', 896.0000, 'ºC'),
	(68737, 112, '2015-02-15 00:41:57.000000', 'temperatura', 30.0000, 'ºC'),
	(68738, 112, '2015-02-15 00:41:58.000000', 'temperatura', 1062.0000, 'ºC'),
	(68739, 112, '2015-02-15 00:41:59.000000', 'temperatura', 421.0000, 'ºC'),
	(68740, 112, '2015-02-15 00:42:00.000000', 'temperatura', 121.0000, 'ºC'),
	(68741, 112, '2015-02-15 00:42:01.000000', 'temperatura', 542.0000, 'ºC'),
	(68742, 112, '2015-02-15 00:42:02.000000', 'temperatura', 1148.0000, 'ºC'),
	(68743, 112, '2015-02-15 00:42:03.000000', 'temperatura', 516.0000, 'ºC'),
	(68744, 112, '2015-02-15 00:42:04.000000', 'temperatura', 333.0000, 'ºC'),
	(68745, 112, '2015-02-15 00:42:05.000000', 'temperatura', 120.0000, 'ºC'),
	(68746, 112, '2015-02-15 00:42:06.000000', 'temperatura', 802.0000, 'ºC'),
	(68747, 112, '2015-02-15 00:42:07.000000', 'temperatura', 49.0000, 'ºC'),
	(68748, 112, '2015-02-15 00:42:08.000000', 'temperatura', 241.0000, 'ºC'),
	(68749, 112, '2015-02-15 00:42:09.000000', 'temperatura', 1059.0000, 'ºC'),
	(68750, 112, '2015-02-15 00:42:10.000000', 'temperatura', 974.0000, 'ºC'),
	(68751, 112, '2015-02-15 00:42:11.000000', 'temperatura', 490.0000, 'ºC'),
	(68752, 112, '2015-02-15 00:42:12.000000', 'temperatura', 730.0000, 'ºC'),
	(68753, 112, '2015-02-15 00:42:13.000000', 'temperatura', 980.0000, 'ºC'),
	(68754, 112, '2015-02-15 00:42:14.000000', 'temperatura', 312.0000, 'ºC'),
	(68755, 112, '2015-02-15 00:42:15.000000', 'temperatura', 1018.0000, 'ºC'),
	(68756, 112, '2015-02-15 00:42:16.000000', 'temperatura', 557.0000, 'ºC'),
	(68757, 112, '2015-02-15 00:42:17.000000', 'temperatura', 933.0000, 'ºC'),
	(68758, 112, '2015-02-15 00:42:18.000000', 'temperatura', 591.0000, 'ºC'),
	(68759, 112, '2015-02-15 00:42:19.000000', 'temperatura', 159.0000, 'ºC'),
	(68760, 112, '2015-02-15 00:42:20.000000', 'temperatura', 221.0000, 'ºC'),
	(68761, 112, '2015-02-15 00:42:21.000000', 'temperatura', 628.0000, 'ºC'),
	(68762, 112, '2015-02-15 00:42:22.000000', 'temperatura', 80.0000, 'ºC'),
	(68763, 112, '2015-02-15 00:42:23.000000', 'temperatura', 914.0000, 'ºC'),
	(68764, 112, '2015-02-15 00:42:24.000000', 'temperatura', 730.0000, 'ºC'),
	(68765, 112, '2015-02-15 00:42:25.000000', 'temperatura', 908.0000, 'ºC'),
	(68766, 112, '2015-02-15 00:42:26.000000', 'temperatura', 1153.0000, 'ºC'),
	(68767, 112, '2015-02-15 00:42:27.000000', 'temperatura', 641.0000, 'ºC'),
	(68768, 112, '2015-02-15 00:42:28.000000', 'temperatura', 946.0000, 'ºC'),
	(68769, 112, '2015-02-15 00:42:29.000000', 'temperatura', 407.0000, 'ºC'),
	(68770, 112, '2015-02-15 00:42:30.000000', 'temperatura', 399.0000, 'ºC'),
	(68771, 112, '2015-02-15 00:42:31.000000', 'temperatura', 775.0000, 'ºC'),
	(68772, 112, '2015-02-15 00:42:32.000000', 'temperatura', 276.0000, 'ºC'),
	(68773, 112, '2015-02-15 00:42:33.000000', 'temperatura', 259.0000, 'ºC'),
	(68774, 112, '2015-02-15 00:42:34.000000', 'temperatura', 465.0000, 'ºC'),
	(68775, 112, '2015-02-15 00:42:35.000000', 'temperatura', 347.0000, 'ºC'),
	(68776, 112, '2015-02-15 00:42:36.000000', 'temperatura', 344.0000, 'ºC'),
	(68777, 112, '2015-02-15 00:42:37.000000', 'temperatura', 679.0000, 'ºC'),
	(68778, 112, '2015-02-15 00:42:38.000000', 'temperatura', 1161.0000, 'ºC'),
	(68779, 112, '2015-02-15 00:42:39.000000', 'temperatura', 169.0000, 'ºC'),
	(68780, 112, '2015-02-15 00:42:40.000000', 'temperatura', 964.0000, 'ºC'),
	(68781, 112, '2015-02-15 00:42:41.000000', 'temperatura', 713.0000, 'ºC'),
	(68782, 112, '2015-02-15 00:42:42.000000', 'temperatura', 672.0000, 'ºC'),
	(68783, 112, '2015-02-15 00:42:43.000000', 'temperatura', 22.0000, 'ºC'),
	(68784, 112, '2015-02-15 00:42:44.000000', 'temperatura', 497.0000, 'ºC'),
	(68785, 112, '2015-02-15 00:42:45.000000', 'temperatura', 18.0000, 'ºC'),
	(68786, 112, '2015-02-15 00:42:46.000000', 'temperatura', 998.0000, 'ºC'),
	(68787, 112, '2015-02-15 00:42:47.000000', 'temperatura', 140.0000, 'ºC'),
	(68788, 112, '2015-02-15 00:42:48.000000', 'temperatura', 103.0000, 'ºC'),
	(68789, 112, '2015-02-15 00:42:49.000000', 'temperatura', 98.0000, 'ºC'),
	(68790, 112, '2015-02-15 00:42:50.000000', 'temperatura', 179.0000, 'ºC'),
	(68791, 112, '2015-02-15 00:42:51.000000', 'temperatura', 604.0000, 'ºC'),
	(68792, 112, '2015-02-15 00:42:52.000000', 'temperatura', 81.0000, 'ºC'),
	(68793, 112, '2015-02-15 00:42:53.000000', 'temperatura', 997.0000, 'ºC'),
	(68794, 112, '2015-02-15 00:42:54.000000', 'temperatura', 1139.0000, 'ºC'),
	(68795, 112, '2015-02-15 00:42:55.000000', 'temperatura', 305.0000, 'ºC'),
	(68796, 112, '2015-02-15 00:42:56.000000', 'temperatura', 511.0000, 'ºC'),
	(68797, 112, '2015-02-15 00:42:57.000000', 'temperatura', 440.0000, 'ºC'),
	(68798, 112, '2015-02-15 00:42:58.000000', 'temperatura', 666.0000, 'ºC'),
	(68799, 112, '2015-02-15 00:42:59.000000', 'temperatura', 811.0000, 'ºC'),
	(68800, 112, '2015-02-15 00:43:00.000000', 'temperatura', 856.0000, 'ºC'),
	(68801, 112, '2015-02-15 00:43:01.000000', 'temperatura', 649.0000, 'ºC'),
	(68802, 112, '2015-02-15 00:43:02.000000', 'temperatura', 677.0000, 'ºC'),
	(68803, 112, '2015-02-15 00:43:03.000000', 'temperatura', 237.0000, 'ºC'),
	(68804, 112, '2015-02-15 00:43:04.000000', 'temperatura', 356.0000, 'ºC'),
	(68805, 112, '2015-02-15 00:43:05.000000', 'temperatura', 1068.0000, 'ºC'),
	(68806, 112, '2015-02-15 00:43:06.000000', 'temperatura', 675.0000, 'ºC'),
	(68807, 112, '2015-02-15 00:43:07.000000', 'temperatura', 171.0000, 'ºC'),
	(68808, 112, '2015-02-15 00:43:08.000000', 'temperatura', 32.0000, 'ºC'),
	(68809, 112, '2015-02-15 00:43:09.000000', 'temperatura', 847.0000, 'ºC'),
	(68810, 112, '2015-02-15 00:43:10.000000', 'temperatura', 539.0000, 'ºC'),
	(68811, 112, '2015-02-15 00:43:11.000000', 'temperatura', 153.0000, 'ºC'),
	(68812, 112, '2015-02-15 00:43:12.000000', 'temperatura', 349.0000, 'ºC'),
	(68813, 112, '2015-02-15 00:43:13.000000', 'temperatura', 85.0000, 'ºC'),
	(68814, 112, '2015-02-15 00:43:14.000000', 'temperatura', 581.0000, 'ºC'),
	(68815, 112, '2015-02-15 00:43:15.000000', 'temperatura', 251.0000, 'ºC'),
	(68816, 112, '2015-02-15 00:43:16.000000', 'temperatura', 711.0000, 'ºC'),
	(68817, 112, '2015-02-15 00:43:17.000000', 'temperatura', 403.0000, 'ºC'),
	(68818, 112, '2015-02-15 00:43:18.000000', 'temperatura', 1083.0000, 'ºC'),
	(68819, 112, '2015-02-15 00:43:19.000000', 'temperatura', 604.0000, 'ºC'),
	(68820, 112, '2015-02-15 00:43:20.000000', 'temperatura', 974.0000, 'ºC'),
	(68821, 112, '2015-02-15 00:43:21.000000', 'temperatura', 657.0000, 'ºC'),
	(68822, 112, '2015-02-15 00:43:22.000000', 'temperatura', 365.0000, 'ºC'),
	(68823, 112, '2015-02-15 00:43:23.000000', 'temperatura', 1054.0000, 'ºC'),
	(68824, 112, '2015-02-15 00:43:24.000000', 'temperatura', 577.0000, 'ºC'),
	(68825, 112, '2015-02-15 00:43:25.000000', 'temperatura', 924.0000, 'ºC'),
	(68826, 112, '2015-02-15 00:43:26.000000', 'temperatura', 486.0000, 'ºC'),
	(68827, 112, '2015-02-15 00:43:27.000000', 'temperatura', 862.0000, 'ºC'),
	(68828, 112, '2015-02-15 00:43:28.000000', 'temperatura', 452.0000, 'ºC'),
	(68829, 112, '2015-02-15 00:43:29.000000', 'temperatura', 872.0000, 'ºC'),
	(68830, 112, '2015-02-15 00:43:30.000000', 'temperatura', 608.0000, 'ºC'),
	(68831, 112, '2015-02-15 00:43:31.000000', 'temperatura', 421.0000, 'ºC'),
	(68832, 112, '2015-02-15 00:43:32.000000', 'temperatura', 284.0000, 'ºC'),
	(68833, 112, '2015-02-15 00:43:33.000000', 'temperatura', 157.0000, 'ºC'),
	(68834, 112, '2015-02-15 00:43:34.000000', 'temperatura', 1131.0000, 'ºC'),
	(68835, 112, '2015-02-15 00:43:35.000000', 'temperatura', 387.0000, 'ºC'),
	(68836, 112, '2015-02-15 00:43:36.000000', 'temperatura', 943.0000, 'ºC'),
	(68837, 112, '2015-02-15 00:43:37.000000', 'temperatura', 1153.0000, 'ºC'),
	(68838, 112, '2015-02-15 00:43:38.000000', 'temperatura', 535.0000, 'ºC'),
	(68839, 112, '2015-02-15 00:43:39.000000', 'temperatura', 418.0000, 'ºC'),
	(68840, 112, '2015-02-15 00:43:40.000000', 'temperatura', 485.0000, 'ºC'),
	(68841, 112, '2015-02-15 00:43:41.000000', 'temperatura', 1173.0000, 'ºC'),
	(68842, 112, '2015-02-15 00:43:42.000000', 'temperatura', 808.0000, 'ºC'),
	(68843, 112, '2015-02-15 00:43:43.000000', 'temperatura', 523.0000, 'ºC'),
	(68844, 112, '2015-02-15 00:43:44.000000', 'temperatura', 192.0000, 'ºC'),
	(68845, 112, '2015-02-15 00:43:45.000000', 'temperatura', 591.0000, 'ºC'),
	(68846, 112, '2015-02-15 00:43:46.000000', 'temperatura', 1179.0000, 'ºC'),
	(68847, 112, '2015-02-15 00:43:47.000000', 'temperatura', 524.0000, 'ºC'),
	(68848, 112, '2015-02-15 00:43:48.000000', 'temperatura', 283.0000, 'ºC'),
	(68849, 112, '2015-02-15 00:43:49.000000', 'temperatura', 1045.0000, 'ºC'),
	(68850, 112, '2015-02-15 00:43:50.000000', 'temperatura', 774.0000, 'ºC'),
	(68851, 112, '2015-02-15 00:43:51.000000', 'temperatura', 738.0000, 'ºC'),
	(68852, 112, '2015-02-15 00:43:52.000000', 'temperatura', 167.0000, 'ºC'),
	(68853, 112, '2015-02-15 00:43:53.000000', 'temperatura', 1022.0000, 'ºC'),
	(68854, 112, '2015-02-15 00:43:54.000000', 'temperatura', 1010.0000, 'ºC'),
	(68855, 112, '2015-02-15 00:43:55.000000', 'temperatura', 782.0000, 'ºC'),
	(68856, 112, '2015-02-15 00:43:56.000000', 'temperatura', 882.0000, 'ºC'),
	(68857, 112, '2015-02-15 00:43:57.000000', 'temperatura', 863.0000, 'ºC'),
	(68858, 112, '2015-02-15 00:43:58.000000', 'temperatura', 470.0000, 'ºC'),
	(68859, 112, '2015-02-15 00:43:59.000000', 'temperatura', 960.0000, 'ºC'),
	(68860, 112, '2015-02-15 00:44:00.000000', 'temperatura', 992.0000, 'ºC'),
	(68861, 112, '2015-02-15 00:44:01.000000', 'temperatura', 881.0000, 'ºC'),
	(68862, 112, '2015-02-15 00:44:02.000000', 'temperatura', 231.0000, 'ºC'),
	(68863, 112, '2015-02-15 00:44:03.000000', 'temperatura', 909.0000, 'ºC'),
	(68864, 112, '2015-02-15 00:44:04.000000', 'temperatura', 254.0000, 'ºC'),
	(68865, 112, '2015-02-15 00:44:05.000000', 'temperatura', 945.0000, 'ºC'),
	(68866, 112, '2015-02-15 00:44:06.000000', 'temperatura', 361.0000, 'ºC'),
	(68867, 112, '2015-02-15 00:44:07.000000', 'temperatura', 172.0000, 'ºC'),
	(68868, 112, '2015-02-15 00:44:08.000000', 'temperatura', 976.0000, 'ºC'),
	(68869, 112, '2015-02-15 00:44:09.000000', 'temperatura', 765.0000, 'ºC'),
	(68870, 112, '2015-02-15 00:44:10.000000', 'temperatura', 899.0000, 'ºC'),
	(68871, 112, '2015-02-15 00:44:11.000000', 'temperatura', 1000.0000, 'ºC'),
	(68872, 112, '2015-02-15 00:44:12.000000', 'temperatura', 1103.0000, 'ºC'),
	(68873, 112, '2015-02-15 00:44:13.000000', 'temperatura', 114.0000, 'ºC'),
	(68874, 112, '2015-02-15 00:44:14.000000', 'temperatura', 861.0000, 'ºC'),
	(68875, 112, '2015-02-15 00:44:15.000000', 'temperatura', 366.0000, 'ºC'),
	(68876, 112, '2015-02-15 00:44:16.000000', 'temperatura', 448.0000, 'ºC'),
	(68877, 112, '2015-02-15 00:44:17.000000', 'temperatura', 1141.0000, 'ºC'),
	(68878, 112, '2015-02-15 00:44:18.000000', 'temperatura', 760.0000, 'ºC'),
	(68879, 112, '2015-02-15 00:44:19.000000', 'temperatura', 380.0000, 'ºC'),
	(68880, 112, '2015-02-15 00:44:20.000000', 'temperatura', 818.0000, 'ºC'),
	(68881, 112, '2015-02-15 00:44:21.000000', 'temperatura', 552.0000, 'ºC'),
	(68882, 112, '2015-02-15 00:44:22.000000', 'temperatura', 308.0000, 'ºC'),
	(68883, 112, '2015-02-15 00:44:23.000000', 'temperatura', 1081.0000, 'ºC'),
	(68884, 112, '2015-02-15 00:44:24.000000', 'temperatura', 885.0000, 'ºC'),
	(68885, 112, '2015-02-15 00:44:25.000000', 'temperatura', 1181.0000, 'ºC'),
	(68886, 112, '2015-02-15 00:44:26.000000', 'temperatura', 850.0000, 'ºC'),
	(68887, 112, '2015-02-15 00:44:27.000000', 'temperatura', 708.0000, 'ºC'),
	(68888, 112, '2015-02-15 00:44:28.000000', 'temperatura', 990.0000, 'ºC'),
	(68889, 112, '2015-02-15 00:44:29.000000', 'temperatura', 428.0000, 'ºC'),
	(68890, 112, '2015-02-15 00:44:30.000000', 'temperatura', 369.0000, 'ºC'),
	(68891, 112, '2015-02-15 00:44:31.000000', 'temperatura', 563.0000, 'ºC'),
	(68892, 112, '2015-02-15 00:44:32.000000', 'temperatura', 507.0000, 'ºC'),
	(68893, 112, '2015-02-15 00:44:33.000000', 'temperatura', 846.0000, 'ºC'),
	(68894, 112, '2015-02-15 00:44:34.000000', 'temperatura', 312.0000, 'ºC'),
	(68895, 112, '2015-02-15 00:44:35.000000', 'temperatura', 221.0000, 'ºC'),
	(68896, 112, '2015-02-15 00:44:36.000000', 'temperatura', 168.0000, 'ºC'),
	(68897, 112, '2015-02-15 00:44:37.000000', 'temperatura', 180.0000, 'ºC'),
	(68898, 112, '2015-02-15 00:44:38.000000', 'temperatura', 395.0000, 'ºC'),
	(68899, 112, '2015-02-15 00:44:39.000000', 'temperatura', 234.0000, 'ºC'),
	(68900, 112, '2015-02-15 00:44:40.000000', 'temperatura', 1186.0000, 'ºC'),
	(68901, 112, '2015-02-15 00:44:41.000000', 'temperatura', 431.0000, 'ºC'),
	(68902, 112, '2015-02-15 00:44:42.000000', 'temperatura', 996.0000, 'ºC'),
	(68903, 112, '2015-02-15 00:44:43.000000', 'temperatura', 86.0000, 'ºC'),
	(68904, 112, '2015-02-15 00:44:44.000000', 'temperatura', 1043.0000, 'ºC'),
	(68905, 112, '2015-02-15 00:44:45.000000', 'temperatura', 158.0000, 'ºC'),
	(68906, 112, '2015-02-15 00:44:46.000000', 'temperatura', 61.0000, 'ºC'),
	(68907, 112, '2015-02-15 00:44:47.000000', 'temperatura', 1030.0000, 'ºC'),
	(68908, 112, '2015-02-15 00:44:48.000000', 'temperatura', 169.0000, 'ºC'),
	(68909, 112, '2015-02-15 00:44:49.000000', 'temperatura', 154.0000, 'ºC'),
	(68910, 112, '2015-02-15 00:44:50.000000', 'temperatura', 265.0000, 'ºC'),
	(68911, 112, '2015-02-15 00:44:51.000000', 'temperatura', 862.0000, 'ºC'),
	(68912, 112, '2015-02-15 00:44:52.000000', 'temperatura', 1115.0000, 'ºC'),
	(68913, 112, '2015-02-15 00:44:53.000000', 'temperatura', 589.0000, 'ºC'),
	(68914, 112, '2015-02-15 00:44:54.000000', 'temperatura', 800.0000, 'ºC'),
	(68915, 112, '2015-02-15 00:44:55.000000', 'temperatura', 1034.0000, 'ºC'),
	(68916, 112, '2015-02-15 00:44:56.000000', 'temperatura', 372.0000, 'ºC'),
	(68917, 112, '2015-02-15 00:44:57.000000', 'temperatura', 1159.0000, 'ºC'),
	(68918, 112, '2015-02-15 00:44:58.000000', 'temperatura', 1078.0000, 'ºC'),
	(68919, 112, '2015-02-15 00:44:59.000000', 'temperatura', 715.0000, 'ºC'),
	(68920, 112, '2015-02-15 00:45:00.000000', 'temperatura', 341.0000, 'ºC'),
	(68921, 112, '2015-02-15 00:45:01.000000', 'temperatura', 761.0000, 'ºC'),
	(68922, 112, '2015-02-15 00:45:02.000000', 'temperatura', 381.0000, 'ºC'),
	(68923, 112, '2015-02-15 00:45:03.000000', 'temperatura', 823.0000, 'ºC'),
	(68924, 112, '2015-02-15 00:45:04.000000', 'temperatura', 573.0000, 'ºC'),
	(68925, 112, '2015-02-15 00:45:05.000000', 'temperatura', 395.0000, 'ºC'),
	(68926, 112, '2015-02-15 00:45:06.000000', 'temperatura', 257.0000, 'ºC'),
	(68927, 112, '2015-02-15 00:45:07.000000', 'temperatura', 101.0000, 'ºC'),
	(68928, 112, '2015-02-15 00:45:08.000000', 'temperatura', 934.0000, 'ºC'),
	(68929, 112, '2015-02-15 00:45:09.000000', 'temperatura', 766.0000, 'ºC'),
	(68930, 112, '2015-02-15 00:45:10.000000', 'temperatura', 1031.0000, 'ºC'),
	(68931, 112, '2015-02-15 00:45:11.000000', 'temperatura', 455.0000, 'ºC'),
	(68932, 112, '2015-02-15 00:45:12.000000', 'temperatura', 384.0000, 'ºC'),
	(68933, 112, '2015-02-15 00:45:13.000000', 'temperatura', 553.0000, 'ºC'),
	(68934, 112, '2015-02-15 00:45:14.000000', 'temperatura', 416.0000, 'ºC'),
	(68935, 112, '2015-02-15 00:45:15.000000', 'temperatura', 420.0000, 'ºC'),
	(68936, 112, '2015-02-15 00:45:16.000000', 'temperatura', 855.0000, 'ºC'),
	(68937, 112, '2015-02-15 00:45:17.000000', 'temperatura', 614.0000, 'ºC'),
	(68938, 112, '2015-02-15 00:45:18.000000', 'temperatura', 505.0000, 'ºC'),
	(68939, 112, '2015-02-15 00:45:19.000000', 'temperatura', 686.0000, 'ºC'),
	(68940, 112, '2015-02-15 00:45:20.000000', 'temperatura', 712.0000, 'ºC'),
	(68941, 112, '2015-02-15 00:45:21.000000', 'temperatura', 304.0000, 'ºC'),
	(68942, 112, '2015-02-15 00:45:22.000000', 'temperatura', 583.0000, 'ºC'),
	(68943, 112, '2015-02-15 00:45:23.000000', 'temperatura', 806.0000, 'ºC'),
	(68944, 112, '2015-02-15 00:45:24.000000', 'temperatura', 1079.0000, 'ºC'),
	(68945, 112, '2015-02-15 00:45:25.000000', 'temperatura', 579.0000, 'ºC'),
	(68946, 112, '2015-02-15 00:45:26.000000', 'temperatura', 860.0000, 'ºC'),
	(68947, 112, '2015-02-15 00:45:27.000000', 'temperatura', 163.0000, 'ºC'),
	(68948, 112, '2015-02-15 00:45:28.000000', 'temperatura', 634.0000, 'ºC'),
	(68949, 112, '2015-02-15 00:45:29.000000', 'temperatura', 283.0000, 'ºC'),
	(68950, 112, '2015-02-15 00:45:30.000000', 'temperatura', 713.0000, 'ºC'),
	(68951, 112, '2015-02-15 00:45:31.000000', 'temperatura', 317.0000, 'ºC'),
	(68952, 112, '2015-02-15 00:45:32.000000', 'temperatura', 648.0000, 'ºC'),
	(68953, 112, '2015-02-15 00:45:33.000000', 'temperatura', 1089.0000, 'ºC'),
	(68954, 112, '2015-02-15 00:45:34.000000', 'temperatura', 1100.0000, 'ºC'),
	(68955, 112, '2015-02-15 00:45:35.000000', 'temperatura', 1035.0000, 'ºC'),
	(68956, 112, '2015-02-15 00:45:36.000000', 'temperatura', 675.0000, 'ºC'),
	(68957, 112, '2015-02-15 00:45:37.000000', 'temperatura', 269.0000, 'ºC'),
	(68958, 112, '2015-02-15 00:45:38.000000', 'temperatura', 522.0000, 'ºC'),
	(68959, 112, '2015-02-15 00:45:39.000000', 'temperatura', 603.0000, 'ºC'),
	(68960, 112, '2015-02-15 00:45:40.000000', 'temperatura', 250.0000, 'ºC'),
	(68961, 112, '2015-02-15 00:45:41.000000', 'temperatura', 641.0000, 'ºC'),
	(68962, 112, '2015-02-15 00:45:42.000000', 'temperatura', 55.0000, 'ºC'),
	(68963, 112, '2015-02-15 00:45:43.000000', 'temperatura', 755.0000, 'ºC'),
	(68964, 112, '2015-02-15 00:45:44.000000', 'temperatura', 9.0000, 'ºC'),
	(68965, 112, '2015-02-15 00:45:45.000000', 'temperatura', 181.0000, 'ºC'),
	(68966, 112, '2015-02-15 00:45:46.000000', 'temperatura', 880.0000, 'ºC'),
	(68967, 112, '2015-02-15 00:45:47.000000', 'temperatura', 254.0000, 'ºC'),
	(68968, 112, '2015-02-15 00:45:48.000000', 'temperatura', 1033.0000, 'ºC'),
	(68969, 112, '2015-02-15 00:45:49.000000', 'temperatura', 805.0000, 'ºC'),
	(68970, 112, '2015-02-15 00:45:50.000000', 'temperatura', 923.0000, 'ºC'),
	(68971, 112, '2015-02-15 00:45:51.000000', 'temperatura', 1002.0000, 'ºC'),
	(68972, 112, '2015-02-15 00:45:52.000000', 'temperatura', 1041.0000, 'ºC'),
	(68973, 112, '2015-02-15 00:45:53.000000', 'temperatura', 999.0000, 'ºC'),
	(68974, 112, '2015-02-15 00:45:54.000000', 'temperatura', 674.0000, 'ºC'),
	(68975, 112, '2015-02-15 00:45:55.000000', 'temperatura', 375.0000, 'ºC'),
	(68976, 112, '2015-02-15 00:45:56.000000', 'temperatura', 1051.0000, 'ºC'),
	(68977, 112, '2015-02-15 00:45:57.000000', 'temperatura', 533.0000, 'ºC'),
	(68978, 112, '2015-02-15 00:45:58.000000', 'temperatura', 712.0000, 'ºC'),
	(68979, 112, '2015-02-15 00:45:59.000000', 'temperatura', 761.0000, 'ºC'),
	(68980, 112, '2015-02-15 00:46:00.000000', 'temperatura', 470.0000, 'ºC'),
	(68981, 112, '2015-02-15 00:46:01.000000', 'temperatura', 68.0000, 'ºC'),
	(68982, 112, '2015-02-15 00:46:02.000000', 'temperatura', 128.0000, 'ºC'),
	(68983, 112, '2015-02-15 00:46:03.000000', 'temperatura', 438.0000, 'ºC'),
	(68984, 112, '2015-02-15 00:46:04.000000', 'temperatura', 607.0000, 'ºC'),
	(68985, 112, '2015-02-15 00:46:05.000000', 'temperatura', 523.0000, 'ºC'),
	(68986, 112, '2015-02-15 00:46:06.000000', 'temperatura', 794.0000, 'ºC'),
	(68987, 112, '2015-02-15 00:46:07.000000', 'temperatura', 0.0000, 'ºC'),
	(68988, 112, '2015-02-15 00:46:08.000000', 'temperatura', 18.0000, 'ºC'),
	(68989, 112, '2015-02-15 00:46:09.000000', 'temperatura', 93.0000, 'ºC'),
	(68990, 112, '2015-02-15 00:46:10.000000', 'temperatura', 411.0000, 'ºC'),
	(68991, 112, '2015-02-15 00:46:11.000000', 'temperatura', 575.0000, 'ºC'),
	(68992, 112, '2015-02-15 00:46:12.000000', 'temperatura', 442.0000, 'ºC'),
	(68993, 112, '2015-02-15 00:46:13.000000', 'temperatura', 488.0000, 'ºC'),
	(68994, 112, '2015-02-15 00:46:14.000000', 'temperatura', 1114.0000, 'ºC'),
	(68995, 112, '2015-02-15 00:46:15.000000', 'temperatura', 505.0000, 'ºC'),
	(68996, 112, '2015-02-15 00:46:16.000000', 'temperatura', 383.0000, 'ºC'),
	(68997, 112, '2015-02-15 00:46:17.000000', 'temperatura', 401.0000, 'ºC'),
	(68998, 112, '2015-02-15 00:46:18.000000', 'temperatura', 858.0000, 'ºC'),
	(68999, 112, '2015-02-15 00:46:19.000000', 'temperatura', 685.0000, 'ºC'),
	(69000, 112, '2015-02-15 00:46:20.000000', 'temperatura', 851.0000, 'ºC'),
	(69001, 112, '2015-02-15 00:46:21.000000', 'temperatura', 1003.0000, 'ºC'),
	(69002, 112, '2015-02-15 00:46:22.000000', 'temperatura', 60.0000, 'ºC'),
	(69003, 112, '2015-02-15 00:46:23.000000', 'temperatura', 891.0000, 'ºC'),
	(69004, 112, '2015-02-15 00:46:24.000000', 'temperatura', 675.0000, 'ºC'),
	(69005, 112, '2015-02-15 00:46:25.000000', 'temperatura', 703.0000, 'ºC'),
	(69006, 112, '2015-02-15 00:46:26.000000', 'temperatura', 292.0000, 'ºC'),
	(69007, 112, '2015-02-15 00:46:27.000000', 'temperatura', 551.0000, 'ºC'),
	(69008, 112, '2015-02-15 00:46:28.000000', 'temperatura', 678.0000, 'ºC'),
	(69009, 112, '2015-02-15 00:46:29.000000', 'temperatura', 539.0000, 'ºC'),
	(69010, 112, '2015-02-15 00:46:30.000000', 'temperatura', 661.0000, 'ºC'),
	(69011, 112, '2015-02-15 00:46:31.000000', 'temperatura', 487.0000, 'ºC'),
	(69012, 112, '2015-02-15 00:46:32.000000', 'temperatura', 454.0000, 'ºC'),
	(69013, 112, '2015-02-15 00:46:33.000000', 'temperatura', 810.0000, 'ºC'),
	(69014, 112, '2015-02-15 00:46:34.000000', 'temperatura', 289.0000, 'ºC'),
	(69015, 112, '2015-02-15 00:46:35.000000', 'temperatura', 217.0000, 'ºC'),
	(69016, 112, '2015-02-15 00:46:36.000000', 'temperatura', 215.0000, 'ºC'),
	(69017, 112, '2015-02-15 00:46:37.000000', 'temperatura', 426.0000, 'ºC'),
	(69018, 112, '2015-02-15 00:46:38.000000', 'temperatura', 287.0000, 'ºC'),
	(69019, 112, '2015-02-15 00:46:39.000000', 'temperatura', 157.0000, 'ºC'),
	(69020, 112, '2015-02-15 00:46:40.000000', 'temperatura', 1126.0000, 'ºC'),
	(69021, 112, '2015-02-15 00:46:41.000000', 'temperatura', 357.0000, 'ºC'),
	(69022, 112, '2015-02-15 00:46:42.000000', 'temperatura', 809.0000, 'ºC'),
	(69023, 112, '2015-02-15 00:46:43.000000', 'temperatura', 576.0000, 'ºC'),
	(69024, 112, '2015-02-15 00:46:44.000000', 'temperatura', 452.0000, 'ºC'),
	(69025, 112, '2015-02-15 00:46:45.000000', 'temperatura', 532.0000, 'ºC'),
	(69026, 112, '2015-02-15 00:46:46.000000', 'temperatura', 105.0000, 'ºC'),
	(69027, 112, '2015-02-15 00:46:47.000000', 'temperatura', 129.0000, 'ºC'),
	(69028, 112, '2015-02-15 00:46:48.000000', 'temperatura', 329.0000, 'ºC'),
	(69029, 112, '2015-02-15 00:46:49.000000', 'temperatura', 59.0000, 'ºC'),
	(69030, 112, '2015-02-15 00:46:50.000000', 'temperatura', 509.0000, 'ºC'),
	(69031, 112, '2015-02-15 00:46:51.000000', 'temperatura', 1168.0000, 'ºC'),
	(69032, 112, '2015-02-15 00:46:52.000000', 'temperatura', 715.0000, 'ºC'),
	(69033, 112, '2015-02-15 00:46:53.000000', 'temperatura', 72.0000, 'ºC'),
	(69034, 112, '2015-02-15 00:46:54.000000', 'temperatura', 615.0000, 'ºC'),
	(69035, 112, '2015-02-15 00:46:55.000000', 'temperatura', 460.0000, 'ºC'),
	(69036, 112, '2015-02-15 00:46:56.000000', 'temperatura', 455.0000, 'ºC'),
	(69037, 112, '2015-02-15 00:46:57.000000', 'temperatura', 896.0000, 'ºC'),
	(69038, 112, '2015-02-15 00:46:58.000000', 'temperatura', 716.0000, 'ºC'),
	(69039, 112, '2015-02-15 00:46:59.000000', 'temperatura', 890.0000, 'ºC'),
	(69040, 112, '2015-02-15 00:47:00.000000', 'temperatura', 1106.0000, 'ºC'),
	(69041, 112, '2015-02-15 00:47:01.000000', 'temperatura', 458.0000, 'ºC'),
	(69042, 112, '2015-02-15 00:47:02.000000', 'temperatura', 174.0000, 'ºC'),
	(69043, 112, '2015-02-15 00:47:03.000000', 'temperatura', 694.0000, 'ºC'),
	(69044, 112, '2015-02-15 00:47:04.000000', 'temperatura', 549.0000, 'ºC'),
	(69045, 112, '2015-02-15 00:47:05.000000', 'temperatura', 666.0000, 'ºC'),
	(69046, 112, '2015-02-15 00:47:06.000000', 'temperatura', 480.0000, 'ºC'),
	(69047, 112, '2015-02-15 00:47:07.000000', 'temperatura', 405.0000, 'ºC'),
	(69048, 112, '2015-02-15 00:47:08.000000', 'temperatura', 584.0000, 'ºC'),
	(69049, 112, '2015-02-15 00:47:09.000000', 'temperatura', 504.0000, 'ºC'),
	(69050, 112, '2015-02-15 00:47:10.000000', 'temperatura', 772.0000, 'ºC'),
	(69051, 112, '2015-02-15 00:47:11.000000', 'temperatura', 1145.0000, 'ºC'),
	(69052, 112, '2015-02-15 00:47:12.000000', 'temperatura', 1012.0000, 'ºC'),
	(69053, 112, '2015-02-15 00:47:13.000000', 'temperatura', 423.0000, 'ºC'),
	(69054, 112, '2015-02-15 00:47:14.000000', 'temperatura', 281.0000, 'ºC'),
	(69055, 112, '2015-02-15 00:47:15.000000', 'temperatura', 135.0000, 'ºC'),
	(69056, 112, '2015-02-15 00:47:16.000000', 'temperatura', 1035.0000, 'ºC'),
	(69057, 112, '2015-02-15 00:47:17.000000', 'temperatura', 1171.0000, 'ºC'),
	(69058, 112, '2015-02-15 00:47:18.000000', 'temperatura', 349.0000, 'ºC'),
	(69059, 112, '2015-02-15 00:47:19.000000', 'temperatura', 634.0000, 'ºC'),
	(69060, 112, '2015-02-15 00:47:20.000000', 'temperatura', 922.0000, 'ºC'),
	(69061, 112, '2015-02-15 00:47:21.000000', 'temperatura', 310.0000, 'ºC'),
	(69062, 112, '2015-02-15 00:47:22.000000', 'temperatura', 1183.0000, 'ºC'),
	(69063, 112, '2015-02-15 00:47:23.000000', 'temperatura', 186.0000, 'ºC'),
	(69064, 112, '2015-02-15 00:47:24.000000', 'temperatura', 980.0000, 'ºC'),
	(69065, 112, '2015-02-15 00:47:25.000000', 'temperatura', 746.0000, 'ºC'),
	(69066, 112, '2015-02-15 00:47:26.000000', 'temperatura', 787.0000, 'ºC'),
	(69067, 112, '2015-02-15 00:47:27.000000', 'temperatura', 498.0000, 'ºC'),
	(69068, 112, '2015-02-15 00:47:28.000000', 'temperatura', 128.0000, 'ºC'),
	(69069, 112, '2015-02-15 00:47:29.000000', 'temperatura', 349.0000, 'ºC'),
	(69070, 112, '2015-02-15 00:47:30.000000', 'temperatura', 161.0000, 'ºC'),
	(69071, 112, '2015-02-15 00:47:31.000000', 'temperatura', 958.0000, 'ºC'),
	(69072, 112, '2015-02-15 00:47:32.000000', 'temperatura', 708.0000, 'ºC'),
	(69073, 112, '2015-02-15 00:47:33.000000', 'temperatura', 668.0000, 'ºC'),
	(69074, 112, '2015-02-15 00:47:34.000000', 'temperatura', 17.0000, 'ºC'),
	(69075, 112, '2015-02-15 00:47:35.000000', 'temperatura', 481.0000, 'ºC'),
	(69076, 112, '2015-02-15 00:47:36.000000', 'temperatura', 1154.0000, 'ºC'),
	(69077, 112, '2015-02-15 00:47:37.000000', 'temperatura', 729.0000, 'ºC'),
	(69078, 112, '2015-02-15 00:47:38.000000', 'temperatura', 180.0000, 'ºC'),
	(69079, 112, '2015-02-15 00:47:39.000000', 'temperatura', 1117.0000, 'ºC'),
	(69080, 112, '2015-02-15 00:47:40.000000', 'temperatura', 246.0000, 'ºC'),
	(69081, 112, '2015-02-15 00:47:41.000000', 'temperatura', 278.0000, 'ºC'),
	(69082, 112, '2015-02-15 00:47:42.000000', 'temperatura', 651.0000, 'ºC'),
	(69083, 112, '2015-02-15 00:47:43.000000', 'temperatura', 21.0000, 'ºC'),
	(69084, 112, '2015-02-15 00:47:44.000000', 'temperatura', 554.0000, 'ºC'),
	(69085, 112, '2015-02-15 00:47:45.000000', 'temperatura', 308.0000, 'ºC'),
	(69086, 112, '2015-02-15 00:47:46.000000', 'temperatura', 1079.0000, 'ºC'),
	(69087, 112, '2015-02-15 00:47:47.000000', 'temperatura', 871.0000, 'ºC'),
	(69088, 112, '2015-02-15 00:47:48.000000', 'temperatura', 1120.0000, 'ºC'),
	(69089, 112, '2015-02-15 00:47:49.000000', 'temperatura', 586.0000, 'ºC'),
	(69090, 112, '2015-02-15 00:47:50.000000', 'temperatura', 773.0000, 'ºC'),
	(69091, 112, '2015-02-15 00:47:51.000000', 'temperatura', 905.0000, 'ºC'),
	(69092, 112, '2015-02-15 00:47:52.000000', 'temperatura', 1007.0000, 'ºC'),
	(69093, 112, '2015-02-15 00:47:53.000000', 'temperatura', 1121.0000, 'ºC'),
	(69094, 112, '2015-02-15 00:47:54.000000', 'temperatura', 184.0000, 'ºC'),
	(69095, 112, '2015-02-15 00:47:55.000000', 'temperatura', 1158.0000, 'ºC'),
	(69096, 112, '2015-02-15 00:47:56.000000', 'temperatura', 438.0000, 'ºC'),
	(69097, 112, '2015-02-15 00:47:57.000000', 'temperatura', 1118.0000, 'ºC'),
	(69098, 112, '2015-02-15 00:47:58.000000', 'temperatura', 676.0000, 'ºC'),
	(69099, 112, '2015-02-15 00:47:59.000000', 'temperatura', 25.0000, 'ºC'),
	(69100, 112, '2015-02-15 00:48:00.000000', 'temperatura', 500.0000, 'ºC'),
	(69101, 112, '2015-02-15 00:48:01.000000', 'temperatura', 23.0000, 'ºC'),
	(69102, 112, '2015-02-15 00:48:02.000000', 'temperatura', 1015.0000, 'ºC'),
	(69103, 112, '2015-02-15 00:48:03.000000', 'temperatura', 208.0000, 'ºC'),
	(69104, 112, '2015-02-15 00:48:04.000000', 'temperatura', 396.0000, 'ºC'),
	(69105, 112, '2015-02-15 00:48:05.000000', 'temperatura', 156.0000, 'ºC'),
	(69106, 112, '2015-02-15 00:48:06.000000', 'temperatura', 794.0000, 'ºC'),
	(69107, 112, '2015-02-15 00:48:07.000000', 'temperatura', 1102.0000, 'ºC'),
	(69108, 112, '2015-02-15 00:48:08.000000', 'temperatura', 728.0000, 'ºC'),
	(69109, 112, '2015-02-15 00:48:09.000000', 'temperatura', 333.0000, 'ºC'),
	(69110, 112, '2015-02-15 00:48:10.000000', 'temperatura', 682.0000, 'ºC'),
	(69111, 112, '2015-02-15 00:48:11.000000', 'temperatura', 13.0000, 'ºC'),
	(69112, 112, '2015-02-15 00:48:12.000000', 'temperatura', 421.0000, 'ºC'),
	(69113, 112, '2015-02-15 00:48:13.000000', 'temperatura', 864.0000, 'ºC'),
	(69114, 112, '2015-02-15 00:48:14.000000', 'temperatura', 658.0000, 'ºC'),
	(69115, 112, '2015-02-15 00:48:15.000000', 'temperatura', 698.0000, 'ºC'),
	(69116, 112, '2015-02-15 00:48:16.000000', 'temperatura', 318.0000, 'ºC'),
	(69117, 112, '2015-02-15 00:48:17.000000', 'temperatura', 697.0000, 'ºC'),
	(69118, 112, '2015-02-15 00:48:18.000000', 'temperatura', 131.0000, 'ºC'),
	(69119, 112, '2015-02-15 00:48:19.000000', 'temperatura', 965.0000, 'ºC'),
	(69120, 112, '2015-02-15 00:48:20.000000', 'temperatura', 833.0000, 'ºC'),
	(69121, 112, '2015-02-15 00:48:21.000000', 'temperatura', 71.0000, 'ºC'),
	(69122, 112, '2015-02-15 00:48:22.000000', 'temperatura', 257.0000, 'ºC'),
	(69123, 112, '2015-02-15 00:48:23.000000', 'temperatura', 1073.0000, 'ºC'),
	(69124, 112, '2015-02-15 00:48:24.000000', 'temperatura', 995.0000, 'ºC'),
	(69125, 112, '2015-02-15 00:48:25.000000', 'temperatura', 556.0000, 'ºC'),
	(69126, 112, '2015-02-15 00:48:26.000000', 'temperatura', 997.0000, 'ºC'),
	(69127, 112, '2015-02-15 00:48:27.000000', 'temperatura', 916.0000, 'ºC'),
	(69128, 112, '2015-02-15 00:48:28.000000', 'temperatura', 388.0000, 'ºC'),
	(69129, 112, '2015-02-15 00:48:29.000000', 'temperatura', 396.0000, 'ºC'),
	(69130, 112, '2015-02-15 00:48:30.000000', 'temperatura', 813.0000, 'ºC'),
	(69131, 112, '2015-02-15 00:48:31.000000', 'temperatura', 478.0000, 'ºC'),
	(69132, 112, '2015-02-15 00:48:32.000000', 'temperatura', 1151.0000, 'ºC'),
	(69133, 112, '2015-02-15 00:48:33.000000', 'temperatura', 721.0000, 'ºC'),
	(69134, 112, '2015-02-15 00:48:34.000000', 'temperatura', 155.0000, 'ºC'),
	(69135, 112, '2015-02-15 00:48:35.000000', 'temperatura', 1013.0000, 'ºC'),
	(69136, 112, '2015-02-15 00:48:36.000000', 'temperatura', 999.0000, 'ºC'),
	(69137, 112, '2015-02-15 00:48:37.000000', 'temperatura', 757.0000, 'ºC'),
	(69138, 112, '2015-02-15 00:48:38.000000', 'temperatura', 789.0000, 'ºC'),
	(69139, 112, '2015-02-15 00:48:39.000000', 'temperatura', 475.0000, 'ºC'),
	(69140, 112, '2015-02-15 00:48:40.000000', 'temperatura', 9.0000, 'ºC'),
	(69141, 112, '2015-02-15 00:48:41.000000', 'temperatura', 1018.0000, 'ºC'),
	(69142, 112, '2015-02-15 00:48:42.000000', 'temperatura', 266.0000, 'ºC'),
	(69143, 112, '2015-02-15 00:48:43.000000', 'temperatura', 675.0000, 'ºC'),
	(69144, 112, '2015-02-15 00:48:44.000000', 'temperatura', 176.0000, 'ºC'),
	(69145, 112, '2015-02-15 00:48:45.000000', 'temperatura', 56.0000, 'ºC'),
	(69146, 112, '2015-02-15 00:48:46.000000', 'temperatura', 953.0000, 'ºC'),
	(69147, 112, '2015-02-15 00:48:47.000000', 'temperatura', 999.0000, 'ºC'),
	(69148, 112, '2015-02-15 00:48:48.000000', 'temperatura', 937.0000, 'ºC'),
	(69149, 112, '2015-02-15 00:48:49.000000', 'temperatura', 487.0000, 'ºC'),
	(69150, 112, '2015-02-15 00:48:50.000000', 'temperatura', 823.0000, 'ºC'),
	(69151, 112, '2015-02-15 00:48:51.000000', 'temperatura', 257.0000, 'ºC'),
	(69152, 112, '2015-02-15 00:48:52.000000', 'temperatura', 14.0000, 'ºC'),
	(69153, 112, '2015-02-15 00:48:53.000000', 'temperatura', 502.0000, 'ºC'),
	(69154, 112, '2015-02-15 00:48:54.000000', 'temperatura', 66.0000, 'ºC'),
	(69155, 112, '2015-02-15 00:48:55.000000', 'temperatura', 25.0000, 'ºC'),
	(69156, 112, '2015-02-15 00:48:56.000000', 'temperatura', 1129.0000, 'ºC'),
	(69157, 112, '2015-02-15 00:48:57.000000', 'temperatura', 772.0000, 'ºC'),
	(69158, 112, '2015-02-15 00:48:58.000000', 'temperatura', 470.0000, 'ºC'),
	(69159, 112, '2015-02-15 00:48:59.000000', 'temperatura', 36.0000, 'ºC'),
	(69160, 112, '2015-02-15 00:49:00.000000', 'temperatura', 1172.0000, 'ºC'),
	(69161, 112, '2015-02-15 00:49:01.000000', 'temperatura', 953.0000, 'ºC'),
	(69162, 112, '2015-02-15 00:49:02.000000', 'temperatura', 47.0000, 'ºC'),
	(69163, 112, '2015-02-15 00:49:03.000000', 'temperatura', 979.0000, 'ºC'),
	(69164, 112, '2015-02-15 00:49:04.000000', 'temperatura', 1151.0000, 'ºC'),
	(69165, 112, '2015-02-15 00:49:05.000000', 'temperatura', 422.0000, 'ºC'),
	(69166, 112, '2015-02-15 00:49:06.000000', 'temperatura', 1056.0000, 'ºC'),
	(69167, 112, '2015-02-15 00:49:07.000000', 'temperatura', 413.0000, 'ºC'),
	(69168, 112, '2015-02-15 00:49:08.000000', 'temperatura', 100.0000, 'ºC'),
	(69169, 112, '2015-02-15 00:49:09.000000', 'temperatura', 462.0000, 'ºC'),
	(69170, 112, '2015-02-15 00:49:10.000000', 'temperatura', 810.0000, 'ºC'),
	(69171, 112, '2015-02-15 00:49:11.000000', 'temperatura', 262.0000, 'ºC'),
	(69172, 112, '2015-02-15 00:49:12.000000', 'temperatura', 82.0000, 'ºC'),
	(69173, 112, '2015-02-15 00:49:13.000000', 'temperatura', 825.0000, 'ºC'),
	(69174, 112, '2015-02-15 00:49:14.000000', 'temperatura', 278.0000, 'ºC'),
	(69175, 112, '2015-02-15 00:49:15.000000', 'temperatura', 118.0000, 'ºC'),
	(69176, 112, '2015-02-15 00:49:16.000000', 'temperatura', 956.0000, 'ºC'),
	(69177, 112, '2015-02-15 00:49:17.000000', 'temperatura', 828.0000, 'ºC'),
	(69178, 112, '2015-02-15 00:49:18.000000', 'temperatura', 72.0000, 'ºC'),
	(69179, 112, '2015-02-15 00:49:19.000000', 'temperatura', 275.0000, 'ºC'),
	(69180, 112, '2015-02-15 00:49:20.000000', 'temperatura', 1160.0000, 'ºC'),
	(69181, 112, '2015-02-15 00:49:21.000000', 'temperatura', 175.0000, 'ºC'),
	(69182, 112, '2015-02-15 00:49:22.000000', 'temperatura', 996.0000, 'ºC'),
	(69183, 112, '2015-02-15 00:49:23.000000', 'temperatura', 857.0000, 'ºC'),
	(69184, 112, '2015-02-15 00:49:24.000000', 'temperatura', 97.0000, 'ºC'),
	(69185, 112, '2015-02-15 00:49:25.000000', 'temperatura', 315.0000, 'ºC'),
	(69186, 112, '2015-02-15 00:49:26.000000', 'temperatura', 85.0000, 'ºC'),
	(69187, 112, '2015-02-15 00:49:27.000000', 'temperatura', 678.0000, 'ºC'),
	(69188, 112, '2015-02-15 00:49:28.000000', 'temperatura', 737.0000, 'ºC'),
	(69189, 112, '2015-02-15 00:49:29.000000', 'temperatura', 451.0000, 'ºC'),
	(69190, 112, '2015-02-15 00:49:30.000000', 'temperatura', 45.0000, 'ºC'),
	(69191, 112, '2015-02-15 00:49:31.000000', 'temperatura', 73.0000, 'ºC'),
	(69192, 112, '2015-02-15 00:49:32.000000', 'temperatura', 229.0000, 'ºC'),
	(69193, 112, '2015-02-15 00:49:33.000000', 'temperatura', 927.0000, 'ºC'),
	(69194, 112, '2015-02-15 00:49:34.000000', 'temperatura', 348.0000, 'ºC'),
	(69195, 112, '2015-02-15 00:49:35.000000', 'temperatura', 160.0000, 'ºC'),
	(69196, 112, '2015-02-15 00:49:36.000000', 'temperatura', 956.0000, 'ºC'),
	(69197, 112, '2015-02-15 00:49:37.000000', 'temperatura', 702.0000, 'ºC'),
	(69198, 112, '2015-02-15 00:49:38.000000', 'temperatura', 643.0000, 'ºC'),
	(69199, 112, '2015-02-15 00:49:39.000000', 'temperatura', 1109.0000, 'ºC'),
	(69200, 112, '2015-02-15 00:49:40.000000', 'temperatura', 18.0000, 'ºC'),
	(69201, 112, '2015-02-15 00:49:41.000000', 'temperatura', 361.0000, 'ºC'),
	(69202, 112, '2015-02-15 00:49:42.000000', 'temperatura', 551.0000, 'ºC'),
	(69203, 112, '2015-02-15 00:49:43.000000', 'temperatura', 472.0000, 'ºC'),
	(69204, 112, '2015-02-15 00:49:44.000000', 'temperatura', 707.0000, 'ºC'),
	(69205, 112, '2015-02-15 00:49:45.000000', 'temperatura', 919.0000, 'ºC'),
	(69206, 112, '2015-02-15 00:49:46.000000', 'temperatura', 76.0000, 'ºC'),
	(69207, 112, '2015-02-15 00:49:47.000000', 'temperatura', 24.0000, 'ºC'),
	(69208, 112, '2015-02-15 00:49:48.000000', 'temperatura', 1093.0000, 'ºC'),
	(69209, 112, '2015-02-15 00:49:49.000000', 'temperatura', 591.0000, 'ºC'),
	(69210, 112, '2015-02-15 00:49:50.000000', 'temperatura', 879.0000, 'ºC'),
	(69211, 112, '2015-02-15 00:49:51.000000', 'temperatura', 224.0000, 'ºC'),
	(69212, 112, '2015-02-15 00:49:52.000000', 'temperatura', 881.0000, 'ºC'),
	(69213, 112, '2015-02-15 00:49:53.000000', 'temperatura', 133.0000, 'ºC'),
	(69214, 112, '2015-02-15 00:49:54.000000', 'temperatura', 425.0000, 'ºC'),
	(69215, 112, '2015-02-15 00:49:55.000000', 'temperatura', 524.0000, 'ºC'),
	(69216, 112, '2015-02-15 00:49:56.000000', 'temperatura', 147.0000, 'ºC'),
	(69217, 112, '2015-02-15 00:49:57.000000', 'temperatura', 362.0000, 'ºC'),
	(69218, 112, '2015-02-15 00:49:58.000000', 'temperatura', 172.0000, 'ºC'),
	(69219, 112, '2015-02-15 00:49:59.000000', 'temperatura', 972.0000, 'ºC'),
	(69220, 112, '2015-02-15 00:50:00.000000', 'temperatura', 744.0000, 'ºC'),
	(69221, 112, '2015-02-15 00:50:01.000000', 'temperatura', 804.0000, 'ºC'),
	(69222, 112, '2015-02-15 00:50:02.000000', 'temperatura', 588.0000, 'ºC'),
	(69223, 112, '2015-02-15 00:50:03.000000', 'temperatura', 531.0000, 'ºC'),
	(69224, 112, '2015-02-15 00:50:04.000000', 'temperatura', 892.0000, 'ºC'),
	(69225, 112, '2015-02-15 00:50:05.000000', 'temperatura', 466.0000, 'ºC'),
	(69226, 112, '2015-02-15 00:50:06.000000', 'temperatura', 854.0000, 'ºC'),
	(69227, 112, '2015-02-15 00:50:07.000000', 'temperatura', 473.0000, 'ºC'),
	(69228, 112, '2015-02-15 00:50:08.000000', 'temperatura', 1003.0000, 'ºC'),
	(69229, 112, '2015-02-15 00:50:09.000000', 'temperatura', 1198.0000, 'ºC'),
	(69230, 112, '2015-02-15 00:50:10.000000', 'temperatura', 582.0000, 'ºC'),
	(69231, 112, '2015-02-15 00:50:11.000000', 'temperatura', 516.0000, 'ºC'),
	(69232, 112, '2015-02-15 00:50:12.000000', 'temperatura', 833.0000, 'ºC'),
	(69233, 112, '2015-02-15 00:50:13.000000', 'temperatura', 219.0000, 'ºC'),
	(69234, 112, '2015-02-15 00:50:14.000000', 'temperatura', 994.0000, 'ºC'),
	(69235, 112, '2015-02-15 00:50:15.000000', 'temperatura', 717.0000, 'ºC'),
	(69236, 112, '2015-02-15 00:50:16.000000', 'temperatura', 601.0000, 'ºC'),
	(69237, 112, '2015-02-15 00:50:17.000000', 'temperatura', 856.0000, 'ºC'),
	(69238, 112, '2015-02-15 00:50:18.000000', 'temperatura', 76.0000, 'ºC'),
	(69239, 112, '2015-02-15 00:50:19.000000', 'temperatura', 211.0000, 'ºC'),
	(69240, 112, '2015-02-15 00:50:20.000000', 'temperatura', 830.0000, 'ºC'),
	(69241, 112, '2015-02-15 00:50:21.000000', 'temperatura', 1118.0000, 'ºC'),
	(69242, 112, '2015-02-15 00:50:22.000000', 'temperatura', 702.0000, 'ºC'),
	(69243, 112, '2015-02-15 00:50:23.000000', 'temperatura', 153.0000, 'ºC'),
	(69244, 112, '2015-02-15 00:50:24.000000', 'temperatura', 1063.0000, 'ºC'),
	(69245, 112, '2015-02-15 00:50:25.000000', 'temperatura', 54.0000, 'ºC'),
	(69246, 112, '2015-02-15 00:50:26.000000', 'temperatura', 680.0000, 'ºC'),
	(69247, 112, '2015-02-15 00:50:27.000000', 'temperatura', 842.0000, 'ºC'),
	(69248, 112, '2015-02-15 00:50:28.000000', 'temperatura', 967.0000, 'ºC'),
	(69249, 112, '2015-02-15 00:50:29.000000', 'temperatura', 1111.0000, 'ºC'),
	(69250, 112, '2015-02-15 00:50:30.000000', 'temperatura', 255.0000, 'ºC'),
	(69251, 112, '2015-02-15 00:50:31.000000', 'temperatura', 340.0000, 'ºC'),
	(69252, 112, '2015-02-15 00:50:32.000000', 'temperatura', 938.0000, 'ºC'),
	(69253, 112, '2015-02-15 00:50:33.000000', 'temperatura', 70.0000, 'ºC'),
	(69254, 112, '2015-02-15 00:50:34.000000', 'temperatura', 1138.0000, 'ºC'),
	(69255, 112, '2015-02-15 00:50:35.000000', 'temperatura', 677.0000, 'ºC'),
	(69256, 112, '2015-02-15 00:50:36.000000', 'temperatura', 1175.0000, 'ºC'),
	(69257, 112, '2015-02-15 00:50:37.000000', 'temperatura', 243.0000, 'ºC'),
	(69258, 112, '2015-02-15 00:50:38.000000', 'temperatura', 91.0000, 'ºC'),
	(69259, 112, '2015-02-15 00:50:39.000000', 'temperatura', 927.0000, 'ºC'),
	(69260, 112, '2015-02-15 00:50:40.000000', 'temperatura', 761.0000, 'ºC'),
	(69261, 112, '2015-02-15 00:50:41.000000', 'temperatura', 1026.0000, 'ºC'),
	(69262, 112, '2015-02-15 00:50:42.000000', 'temperatura', 445.0000, 'ºC'),
	(69263, 112, '2015-02-15 00:50:43.000000', 'temperatura', 350.0000, 'ºC'),
	(69264, 112, '2015-02-15 00:50:44.000000', 'temperatura', 413.0000, 'ºC'),
	(69265, 112, '2015-02-15 00:50:45.000000', 'temperatura', 1018.0000, 'ºC'),
	(69266, 112, '2015-02-15 00:50:46.000000', 'temperatura', 249.0000, 'ºC'),
	(69267, 112, '2015-02-15 00:50:47.000000', 'temperatura', 595.0000, 'ºC'),
	(69268, 112, '2015-02-15 00:50:48.000000', 'temperatura', 1025.0000, 'ºC'),
	(69269, 112, '2015-02-15 00:50:49.000000', 'temperatura', 943.0000, 'ºC'),
	(69270, 112, '2015-02-15 00:50:50.000000', 'temperatura', 441.0000, 'ºC'),
	(69271, 112, '2015-02-15 00:50:51.000000', 'temperatura', 574.0000, 'ºC'),
	(69272, 112, '2015-02-15 00:50:52.000000', 'temperatura', 347.0000, 'ºC'),
	(69273, 112, '2015-02-15 00:50:53.000000', 'temperatura', 13.0000, 'ºC'),
	(69274, 112, '2015-02-15 00:50:54.000000', 'temperatura', 226.0000, 'ºC'),
	(69275, 112, '2015-02-15 00:50:55.000000', 'temperatura', 1093.0000, 'ºC'),
	(69276, 112, '2015-02-15 00:50:56.000000', 'temperatura', 1187.0000, 'ºC'),
	(69277, 112, '2015-02-15 00:50:57.000000', 'temperatura', 255.0000, 'ºC'),
	(69278, 112, '2015-02-15 00:50:58.000000', 'temperatura', 114.0000, 'ºC'),
	(69279, 112, '2015-02-15 00:50:59.000000', 'temperatura', 1006.0000, 'ºC'),
	(69280, 112, '2015-02-15 00:51:00.000000', 'temperatura', 1090.0000, 'ºC'),
	(69281, 112, '2015-02-15 00:51:01.000000', 'temperatura', 30.0000, 'ºC'),
	(69282, 112, '2015-02-15 00:51:02.000000', 'temperatura', 482.0000, 'ºC'),
	(69283, 112, '2015-02-15 00:51:03.000000', 'temperatura', 1121.0000, 'ºC'),
	(69284, 112, '2015-02-15 00:51:04.000000', 'temperatura', 557.0000, 'ºC'),
	(69285, 112, '2015-02-15 00:51:05.000000', 'temperatura', 625.0000, 'ºC'),
	(69286, 112, '2015-02-15 00:51:06.000000', 'temperatura', 253.0000, 'ºC'),
	(69287, 112, '2015-02-15 00:51:07.000000', 'temperatura', 593.0000, 'ºC'),
	(69288, 112, '2015-02-15 00:51:08.000000', 'temperatura', 1003.0000, 'ºC'),
	(69289, 112, '2015-02-15 00:51:09.000000', 'temperatura', 838.0000, 'ºC'),
	(69290, 112, '2015-02-15 00:51:10.000000', 'temperatura', 1182.0000, 'ºC'),
	(69291, 112, '2015-02-15 00:51:11.000000', 'temperatura', 997.0000, 'ºC'),
	(69292, 112, '2015-02-15 00:51:12.000000', 'temperatura', 240.0000, 'ºC'),
	(69293, 112, '2015-02-15 00:51:13.000000', 'temperatura', 610.0000, 'ºC'),
	(69294, 112, '2015-02-15 00:51:14.000000', 'temperatura', 1128.0000, 'ºC'),
	(69295, 112, '2015-02-15 00:51:15.000000', 'temperatura', 210.0000, 'ºC'),
	(69296, 112, '2015-02-15 00:51:16.000000', 'temperatura', 67.0000, 'ºC'),
	(69297, 112, '2015-02-15 00:51:17.000000', 'temperatura', 907.0000, 'ºC'),
	(69298, 112, '2015-02-15 00:51:18.000000', 'temperatura', 736.0000, 'ºC'),
	(69299, 112, '2015-02-15 00:51:19.000000', 'temperatura', 957.0000, 'ºC'),
	(69300, 112, '2015-02-15 00:51:20.000000', 'temperatura', 177.0000, 'ºC'),
	(69301, 112, '2015-02-15 00:51:21.000000', 'temperatura', 414.0000, 'ºC'),
	(69302, 112, '2015-02-15 00:51:22.000000', 'temperatura', 342.0000, 'ºC'),
	(69303, 112, '2015-02-15 00:51:23.000000', 'temperatura', 466.0000, 'ºC'),
	(69304, 112, '2015-02-15 00:51:24.000000', 'temperatura', 105.0000, 'ºC'),
	(69305, 112, '2015-02-15 00:51:25.000000', 'temperatura', 329.0000, 'ºC'),
	(69306, 112, '2015-02-15 00:51:26.000000', 'temperatura', 128.0000, 'ºC'),
	(69307, 112, '2015-02-15 00:51:27.000000', 'temperatura', 856.0000, 'ºC'),
	(69308, 112, '2015-02-15 00:51:28.000000', 'temperatura', 295.0000, 'ºC'),
	(69309, 112, '2015-02-15 00:51:29.000000', 'temperatura', 109.0000, 'ºC'),
	(69310, 112, '2015-02-15 00:51:30.000000', 'temperatura', 861.0000, 'ºC'),
	(69311, 112, '2015-02-15 00:51:31.000000', 'temperatura', 380.0000, 'ºC'),
	(69312, 112, '2015-02-15 00:51:32.000000', 'temperatura', 514.0000, 'ºC'),
	(69313, 112, '2015-02-15 00:51:33.000000', 'temperatura', 234.0000, 'ºC'),
	(69314, 112, '2015-02-15 00:51:34.000000', 'temperatura', 826.0000, 'ºC'),
	(69315, 112, '2015-02-15 00:51:35.000000', 'temperatura', 1028.0000, 'ºC'),
	(69316, 112, '2015-02-15 00:51:36.000000', 'temperatura', 265.0000, 'ºC'),
	(69317, 112, '2015-02-15 00:51:37.000000', 'temperatura', 641.0000, 'ºC'),
	(69318, 112, '2015-02-15 00:51:38.000000', 'temperatura', 9.0000, 'ºC'),
	(69319, 112, '2015-02-15 00:51:39.000000', 'temperatura', 524.0000, 'ºC'),
	(69320, 112, '2015-02-15 00:51:40.000000', 'temperatura', 191.0000, 'ºC'),
	(69321, 112, '2015-02-15 00:51:41.000000', 'temperatura', 585.0000, 'ºC'),
	(69322, 112, '2015-02-15 00:51:42.000000', 'temperatura', 1154.0000, 'ºC'),
	(69323, 112, '2015-02-15 00:51:43.000000', 'temperatura', 416.0000, 'ºC'),
	(69324, 112, '2015-02-15 00:51:44.000000', 'temperatura', 1018.0000, 'ºC'),
	(69325, 112, '2015-02-15 00:51:45.000000', 'temperatura', 243.0000, 'ºC'),
	(69326, 112, '2015-02-15 00:51:46.000000', 'temperatura', 560.0000, 'ºC'),
	(69327, 112, '2015-02-15 00:51:47.000000', 'temperatura', 872.0000, 'ºC'),
	(69328, 112, '2015-02-15 00:51:48.000000', 'temperatura', 281.0000, 'ºC'),
	(69329, 112, '2015-02-15 00:51:49.000000', 'temperatura', 1191.0000, 'ºC'),
	(69330, 112, '2015-02-15 00:51:50.000000', 'temperatura', 311.0000, 'ºC'),
	(69331, 112, '2015-02-15 00:51:51.000000', 'temperatura', 381.0000, 'ºC'),
	(69332, 112, '2015-02-15 00:51:52.000000', 'temperatura', 974.0000, 'ºC'),
	(69333, 112, '2015-02-15 00:51:53.000000', 'temperatura', 129.0000, 'ºC'),
	(69334, 112, '2015-02-15 00:51:54.000000', 'temperatura', 123.0000, 'ºC'),
	(69335, 112, '2015-02-15 00:51:55.000000', 'temperatura', 227.0000, 'ºC'),
	(69336, 112, '2015-02-15 00:51:56.000000', 'temperatura', 768.0000, 'ºC'),
	(69337, 112, '2015-02-15 00:51:57.000000', 'temperatura', 757.0000, 'ºC'),
	(69338, 112, '2015-02-15 00:51:58.000000', 'temperatura', 283.0000, 'ºC'),
	(69339, 112, '2015-02-15 00:51:59.000000', 'temperatura', 343.0000, 'ºC'),
	(69340, 112, '2015-02-15 00:52:00.000000', 'temperatura', 868.0000, 'ºC'),
	(69341, 112, '2015-02-15 00:52:01.000000', 'temperatura', 912.0000, 'ºC'),
	(69342, 112, '2015-02-15 00:52:02.000000', 'temperatura', 756.0000, 'ºC'),
	(69343, 112, '2015-02-15 00:52:03.000000', 'temperatura', 1044.0000, 'ºC'),
	(69344, 112, '2015-02-15 00:52:04.000000', 'temperatura', 552.0000, 'ºC'),
	(69345, 112, '2015-02-15 00:52:05.000000', 'temperatura', 829.0000, 'ºC'),
	(69346, 112, '2015-02-15 00:52:06.000000', 'temperatura', 91.0000, 'ºC'),
	(69347, 112, '2015-02-15 00:52:07.000000', 'temperatura', 369.0000, 'ºC'),
	(69348, 112, '2015-02-15 00:52:08.000000', 'temperatura', 371.0000, 'ºC'),
	(69349, 112, '2015-02-15 00:52:09.000000', 'temperatura', 750.0000, 'ºC'),
	(69350, 112, '2015-02-15 00:52:10.000000', 'temperatura', 235.0000, 'ºC'),
	(69351, 112, '2015-02-15 00:52:11.000000', 'temperatura', 128.0000, 'ºC'),
	(69352, 112, '2015-02-15 00:52:12.000000', 'temperatura', 1136.0000, 'ºC'),
	(69353, 112, '2015-02-15 00:52:13.000000', 'temperatura', 494.0000, 'ºC'),
	(69354, 112, '2015-02-15 00:52:14.000000', 'temperatura', 265.0000, 'ºC'),
	(69355, 112, '2015-02-15 00:52:15.000000', 'temperatura', 1040.0000, 'ºC'),
	(69356, 112, '2015-02-15 00:52:16.000000', 'temperatura', 809.0000, 'ºC'),
	(69357, 112, '2015-02-15 00:52:17.000000', 'temperatura', 926.0000, 'ºC'),
	(69358, 112, '2015-02-15 00:52:18.000000', 'temperatura', 1001.0000, 'ºC'),
	(69359, 112, '2015-02-15 00:52:19.000000', 'temperatura', 1028.0000, 'ºC'),
	(69360, 112, '2015-02-15 00:52:20.000000', 'temperatura', 939.0000, 'ºC'),
	(69361, 112, '2015-02-15 00:52:21.000000', 'temperatura', 409.0000, 'ºC'),
	(69362, 112, '2015-02-15 00:52:22.000000', 'temperatura', 428.0000, 'ºC'),
	(69363, 112, '2015-02-15 00:52:23.000000', 'temperatura', 913.0000, 'ºC'),
	(69364, 112, '2015-02-15 00:52:24.000000', 'temperatura', 885.0000, 'ºC'),
	(69365, 112, '2015-02-15 00:52:25.000000', 'temperatura', 484.0000, 'ºC'),
	(69366, 112, '2015-02-15 00:52:26.000000', 'temperatura', 964.0000, 'ºC'),
	(69367, 112, '2015-02-15 00:52:27.000000', 'temperatura', 971.0000, 'ºC'),
	(69368, 112, '2015-02-15 00:52:28.000000', 'temperatura', 764.0000, 'ºC'),
	(69369, 112, '2015-02-15 00:52:29.000000', 'temperatura', 906.0000, 'ºC'),
	(69370, 112, '2015-02-15 00:52:30.000000', 'temperatura', 1040.0000, 'ºC'),
	(69371, 112, '2015-02-15 00:52:31.000000', 'temperatura', 83.0000, 'ºC'),
	(69372, 112, '2015-02-15 00:52:32.000000', 'temperatura', 894.0000, 'ºC'),
	(69373, 112, '2015-02-15 00:52:33.000000', 'temperatura', 623.0000, 'ºC'),
	(69374, 112, '2015-02-15 00:52:34.000000', 'temperatura', 434.0000, 'ºC'),
	(69375, 112, '2015-02-15 00:52:35.000000', 'temperatura', 302.0000, 'ºC'),
	(69376, 112, '2015-02-15 00:52:36.000000', 'temperatura', 209.0000, 'ºC'),
	(69377, 112, '2015-02-15 00:52:37.000000', 'temperatura', 139.0000, 'ºC'),
	(69378, 112, '2015-02-15 00:52:38.000000', 'temperatura', 70.0000, 'ºC'),
	(69379, 112, '2015-02-15 00:52:39.000000', 'temperatura', 1132.0000, 'ºC'),
	(69380, 112, '2015-02-15 00:52:40.000000', 'temperatura', 650.0000, 'ºC'),
	(69381, 112, '2015-02-15 00:52:41.000000', 'temperatura', 1054.0000, 'ºC'),
	(69382, 112, '2015-02-15 00:52:42.000000', 'temperatura', 922.0000, 'ºC'),
	(69383, 112, '2015-02-15 00:52:43.000000', 'temperatura', 248.0000, 'ºC'),
	(69384, 112, '2015-02-15 00:52:44.000000', 'temperatura', 874.0000, 'ºC'),
	(69385, 112, '2015-02-15 00:52:45.000000', 'temperatura', 28.0000, 'ºC'),
	(69386, 112, '2015-02-15 00:52:46.000000', 'temperatura', 1116.0000, 'ºC'),
	(69387, 112, '2015-02-15 00:52:47.000000', 'temperatura', 696.0000, 'ºC'),
	(69388, 112, '2015-02-15 00:52:48.000000', 'temperatura', 133.0000, 'ºC'),
	(69389, 112, '2015-02-15 00:52:49.000000', 'temperatura', 978.0000, 'ºC'),
	(69390, 112, '2015-02-15 00:52:50.000000', 'temperatura', 892.0000, 'ºC'),
	(69391, 112, '2015-02-15 00:52:51.000000', 'temperatura', 324.0000, 'ºC'),
	(69392, 112, '2015-02-15 00:52:52.000000', 'temperatura', 147.0000, 'ºC'),
	(69393, 112, '2015-02-15 00:52:53.000000', 'temperatura', 962.0000, 'ºC'),
	(69394, 112, '2015-02-15 00:52:54.000000', 'temperatura', 770.0000, 'ºC'),
	(69395, 112, '2015-02-15 00:52:55.000000', 'temperatura', 965.0000, 'ºC'),
	(69396, 112, '2015-02-15 00:52:56.000000', 'temperatura', 117.0000, 'ºC'),
	(69397, 112, '2015-02-15 00:52:57.000000', 'temperatura', 90.0000, 'ºC'),
	(69398, 112, '2015-02-15 00:52:58.000000', 'temperatura', 98.0000, 'ºC'),
	(69399, 112, '2015-02-15 00:52:59.000000', 'temperatura', 222.0000, 'ºC'),
	(69400, 112, '2015-02-15 00:53:00.000000', 'temperatura', 815.0000, 'ºC'),
	(69401, 112, '2015-02-15 00:53:01.000000', 'temperatura', 1012.0000, 'ºC'),
	(69402, 112, '2015-02-15 00:53:02.000000', 'temperatura', 213.0000, 'ºC'),
	(69403, 112, '2015-02-15 00:53:03.000000', 'temperatura', 432.0000, 'ºC'),
	(69404, 112, '2015-02-15 00:53:04.000000', 'temperatura', 322.0000, 'ºC'),
	(69405, 112, '2015-02-15 00:53:05.000000', 'temperatura', 313.0000, 'ºC'),
	(69406, 112, '2015-02-15 00:53:06.000000', 'temperatura', 599.0000, 'ºC'),
	(69407, 112, '2015-02-15 00:53:07.000000', 'temperatura', 857.0000, 'ºC'),
	(69408, 112, '2015-02-15 00:53:08.000000', 'temperatura', 88.0000, 'ºC'),
	(69409, 112, '2015-02-15 00:53:09.000000', 'temperatura', 271.0000, 'ºC'),
	(69410, 112, '2015-02-15 00:53:10.000000', 'temperatura', 1092.0000, 'ºC'),
	(69411, 112, '2015-02-15 00:53:11.000000', 'temperatura', 1047.0000, 'ºC'),
	(69412, 112, '2015-02-15 00:53:12.000000', 'temperatura', 759.0000, 'ºC'),
	(69413, 112, '2015-02-15 00:53:13.000000', 'temperatura', 655.0000, 'ºC'),
	(69414, 112, '2015-02-15 00:53:14.000000', 'temperatura', 998.0000, 'ºC'),
	(69415, 112, '2015-02-15 00:53:15.000000', 'temperatura', 624.0000, 'ºC'),
	(69416, 112, '2015-02-15 00:53:16.000000', 'temperatura', 127.0000, 'ºC'),
	(69417, 112, '2015-02-15 00:53:17.000000', 'temperatura', 1163.0000, 'ºC'),
	(69418, 112, '2015-02-15 00:53:18.000000', 'temperatura', 634.0000, 'ºC'),
	(69419, 112, '2015-02-15 00:53:19.000000', 'temperatura', 881.0000, 'ºC'),
	(69420, 112, '2015-02-15 00:53:20.000000', 'temperatura', 104.0000, 'ºC'),
	(69421, 112, '2015-02-15 00:53:21.000000', 'temperatura', 277.0000, 'ºC'),
	(69422, 112, '2015-02-15 00:53:22.000000', 'temperatura', 1073.0000, 'ºC'),
	(69423, 112, '2015-02-15 00:53:23.000000', 'temperatura', 936.0000, 'ºC'),
	(69424, 112, '2015-02-15 00:53:24.000000', 'temperatura', 262.0000, 'ºC'),
	(69425, 112, '2015-02-15 00:53:25.000000', 'temperatura', 900.0000, 'ºC'),
	(69426, 112, '2015-02-15 00:53:26.000000', 'temperatura', 117.0000, 'ºC'),
	(69427, 112, '2015-02-15 00:53:27.000000', 'temperatura', 286.0000, 'ºC'),
	(69428, 112, '2015-02-15 00:53:28.000000', 'temperatura', 1078.0000, 'ºC'),
	(69429, 112, '2015-02-15 00:53:29.000000', 'temperatura', 933.0000, 'ºC'),
	(69430, 112, '2015-02-15 00:53:30.000000', 'temperatura', 231.0000, 'ºC'),
	(69431, 112, '2015-02-15 00:53:31.000000', 'temperatura', 756.0000, 'ºC'),
	(69432, 112, '2015-02-15 00:53:32.000000', 'temperatura', 686.0000, 'ºC'),
	(69433, 112, '2015-02-15 00:53:33.000000', 'temperatura', 1164.0000, 'ºC'),
	(69434, 112, '2015-02-15 00:53:34.000000', 'temperatura', 163.0000, 'ºC'),
	(69435, 112, '2015-02-15 00:53:35.000000', 'temperatura', 924.0000, 'ºC'),
	(69436, 112, '2015-02-15 00:53:36.000000', 'temperatura', 532.0000, 'ºC'),
	(69437, 112, '2015-02-15 00:53:37.000000', 'temperatura', 1088.0000, 'ºC'),
	(69438, 112, '2015-02-15 00:53:38.000000', 'temperatura', 244.0000, 'ºC'),
	(69439, 112, '2015-02-15 00:53:39.000000', 'temperatura', 357.0000, 'ºC'),
	(69440, 112, '2015-02-15 00:53:40.000000', 'temperatura', 1052.0000, 'ºC'),
	(69441, 112, '2015-02-15 00:53:41.000000', 'temperatura', 591.0000, 'ºC'),
	(69442, 112, '2015-02-15 00:53:42.000000', 'temperatura', 998.0000, 'ºC'),
	(69443, 112, '2015-02-15 00:53:43.000000', 'temperatura', 820.0000, 'ºC'),
	(69444, 112, '2015-02-15 00:53:44.000000', 'temperatura', 1106.0000, 'ºC'),
	(69445, 112, '2015-02-15 00:53:45.000000', 'temperatura', 671.0000, 'ºC'),
	(69446, 112, '2015-02-15 00:53:46.000000', 'temperatura', 37.0000, 'ºC'),
	(69447, 112, '2015-02-15 00:53:47.000000', 'temperatura', 570.0000, 'ºC'),
	(69448, 112, '2015-02-15 00:53:48.000000', 'temperatura', 343.0000, 'ºC'),
	(69449, 112, '2015-02-15 00:53:49.000000', 'temperatura', 3.0000, 'ºC'),
	(69450, 112, '2015-02-15 00:53:50.000000', 'temperatura', 189.0000, 'ºC'),
	(69451, 112, '2015-02-15 00:53:51.000000', 'temperatura', 936.0000, 'ºC'),
	(69452, 112, '2015-02-15 00:53:52.000000', 'temperatura', 511.0000, 'ºC'),
	(69453, 112, '2015-02-15 00:53:53.000000', 'temperatura', 951.0000, 'ºC'),
	(69454, 112, '2015-02-15 00:53:54.000000', 'temperatura', 821.0000, 'ºC'),
	(69455, 112, '2015-02-15 00:53:55.000000', 'temperatura', 52.0000, 'ºC'),
	(69456, 112, '2015-02-15 00:53:56.000000', 'temperatura', 198.0000, 'ºC'),
	(69457, 112, '2015-02-15 00:53:57.000000', 'temperatura', 832.0000, 'ºC'),
	(69458, 112, '2015-02-15 00:53:58.000000', 'temperatura', 1170.0000, 'ºC'),
	(69459, 112, '2015-02-15 00:53:59.000000', 'temperatura', 951.0000, 'ºC'),
	(69460, 112, '2015-02-15 00:54:00.000000', 'temperatura', 49.0000, 'ºC'),
	(69461, 112, '2015-02-15 00:54:01.000000', 'temperatura', 991.0000, 'ºC'),
	(69462, 112, '2015-02-15 00:54:02.000000', 'temperatura', 8.0000, 'ºC'),
	(69463, 112, '2015-02-15 00:54:03.000000', 'temperatura', 669.0000, 'ºC'),
	(69464, 112, '2015-02-15 00:54:04.000000', 'temperatura', 920.0000, 'ºC'),
	(69465, 112, '2015-02-15 00:54:05.000000', 'temperatura', 194.0000, 'ºC'),
	(69466, 112, '2015-02-15 00:54:06.000000', 'temperatura', 612.0000, 'ºC'),
	(69467, 112, '2015-02-15 00:54:07.000000', 'temperatura', 78.0000, 'ºC'),
	(69468, 112, '2015-02-15 00:54:08.000000', 'temperatura', 954.0000, 'ºC'),
	(69469, 112, '2015-02-15 00:54:09.000000', 'temperatura', 938.0000, 'ºC'),
	(69470, 112, '2015-02-15 00:54:10.000000', 'temperatura', 629.0000, 'ºC'),
	(69471, 112, '2015-02-15 00:54:11.000000', 'temperatura', 330.0000, 'ºC'),
	(69472, 112, '2015-02-15 00:54:12.000000', 'temperatura', 962.0000, 'ºC'),
	(69473, 112, '2015-02-15 00:54:13.000000', 'temperatura', 221.0000, 'ºC'),
	(69474, 112, '2015-02-15 00:54:14.000000', 'temperatura', 621.0000, 'ºC'),
	(69475, 112, '2015-02-15 00:54:15.000000', 'temperatura', 40.0000, 'ºC'),
	(69476, 112, '2015-02-15 00:54:16.000000', 'temperatura', 741.0000, 'ºC'),
	(69477, 112, '2015-02-15 00:54:17.000000', 'temperatura', 1183.0000, 'ºC'),
	(69478, 112, '2015-02-15 00:54:18.000000', 'temperatura', 95.0000, 'ºC'),
	(69479, 112, '2015-02-15 00:54:19.000000', 'temperatura', 526.0000, 'ºC'),
	(69480, 112, '2015-02-15 00:54:20.000000', 'temperatura', 1144.0000, 'ºC'),
	(69481, 112, '2015-02-15 00:54:21.000000', 'temperatura', 545.0000, 'ºC'),
	(69482, 112, '2015-02-15 00:54:22.000000', 'temperatura', 491.0000, 'ºC'),
	(69483, 112, '2015-02-15 00:54:23.000000', 'temperatura', 822.0000, 'ºC'),
	(69484, 112, '2015-02-15 00:54:24.000000', 'temperatura', 236.0000, 'ºC'),
	(69485, 112, '2015-02-15 00:54:25.000000', 'temperatura', 1114.0000, 'ºC'),
	(69486, 112, '2015-02-15 00:54:26.000000', 'temperatura', 62.0000, 'ºC'),
	(69487, 112, '2015-02-15 00:54:27.000000', 'temperatura', 571.0000, 'ºC'),
	(69488, 112, '2015-02-15 00:54:28.000000', 'temperatura', 268.0000, 'ºC'),
	(69489, 112, '2015-02-15 00:54:29.000000', 'temperatura', 828.0000, 'ºC'),
	(69490, 112, '2015-02-15 00:54:30.000000', 'temperatura', 937.0000, 'ºC'),
	(69491, 112, '2015-02-15 00:54:31.000000', 'temperatura', 999.0000, 'ºC'),
	(69492, 112, '2015-02-15 00:54:32.000000', 'temperatura', 987.0000, 'ºC'),
	(69493, 112, '2015-02-15 00:54:33.000000', 'temperatura', 736.0000, 'ºC'),
	(69494, 112, '2015-02-15 00:54:34.000000', 'temperatura', 722.0000, 'ºC'),
	(69495, 112, '2015-02-15 00:54:35.000000', 'temperatura', 200.0000, 'ºC'),
	(69496, 112, '2015-02-15 00:54:36.000000', 'temperatura', 37.0000, 'ºC'),
	(69497, 112, '2015-02-15 00:54:37.000000', 'temperatura', 785.0000, 'ºC'),
	(69498, 112, '2015-02-15 00:54:38.000000', 'temperatura', 214.0000, 'ºC'),
	(69499, 112, '2015-02-15 00:54:39.000000', 'temperatura', 1115.0000, 'ºC'),
	(69500, 112, '2015-02-15 00:54:40.000000', 'temperatura', 133.0000, 'ºC'),
	(69501, 112, '2015-02-15 00:54:41.000000', 'temperatura', 923.0000, 'ºC'),
	(69502, 112, '2015-02-15 00:54:42.000000', 'temperatura', 613.0000, 'ºC'),
	(69503, 112, '2015-02-15 00:54:43.000000', 'temperatura', 299.0000, 'ºC'),
	(69504, 112, '2015-02-15 00:54:44.000000', 'temperatura', 855.0000, 'ºC'),
	(69505, 112, '2015-02-15 00:54:45.000000', 'temperatura', 980.0000, 'ºC'),
	(69506, 112, '2015-02-15 00:54:46.000000', 'temperatura', 1136.0000, 'ºC'),
	(69507, 112, '2015-02-15 00:54:47.000000', 'temperatura', 340.0000, 'ºC'),
	(69508, 112, '2015-02-15 00:54:48.000000', 'temperatura', 693.0000, 'ºC'),
	(69509, 112, '2015-02-15 00:54:49.000000', 'temperatura', 44.0000, 'ºC'),
	(69510, 112, '2015-02-15 00:54:50.000000', 'temperatura', 541.0000, 'ºC'),
	(69511, 112, '2015-02-15 00:54:51.000000', 'temperatura', 172.0000, 'ºC'),
	(69512, 112, '2015-02-15 00:54:52.000000', 'temperatura', 440.0000, 'ºC'),
	(69513, 112, '2015-02-15 00:54:53.000000', 'temperatura', 484.0000, 'ºC'),
	(69514, 112, '2015-02-15 00:54:54.000000', 'temperatura', 1100.0000, 'ºC'),
	(69515, 112, '2015-02-15 00:54:55.000000', 'temperatura', 448.0000, 'ºC'),
	(69516, 112, '2015-02-15 00:54:56.000000', 'temperatura', 140.0000, 'ºC'),
	(69517, 112, '2015-02-15 00:54:57.000000', 'temperatura', 557.0000, 'ºC'),
	(69518, 112, '2015-02-15 00:54:58.000000', 'temperatura', 1165.0000, 'ºC'),
	(69519, 112, '2015-02-15 00:54:59.000000', 'temperatura', 553.0000, 'ºC'),
	(69520, 112, '2015-02-15 00:55:00.000000', 'temperatura', 473.0000, 'ºC'),
	(69521, 112, '2015-02-15 00:55:01.000000', 'temperatura', 708.0000, 'ºC'),
	(69522, 112, '2015-02-15 00:55:02.000000', 'temperatura', 919.0000, 'ºC'),
	(69523, 112, '2015-02-15 00:55:03.000000', 'temperatura', 71.0000, 'ºC'),
	(69524, 112, '2015-02-15 00:55:04.000000', 'temperatura', 1199.0000, 'ºC'),
	(69525, 112, '2015-02-15 00:55:05.000000', 'temperatura', 981.0000, 'ºC'),
	(69526, 112, '2015-02-15 00:55:06.000000', 'temperatura', 110.0000, 'ºC'),
	(69527, 112, '2015-02-15 00:55:07.000000', 'temperatura', 8.0000, 'ºC'),
	(69528, 112, '2015-02-15 00:55:08.000000', 'temperatura', 911.0000, 'ºC'),
	(69529, 112, '2015-02-15 00:55:09.000000', 'temperatura', 930.0000, 'ºC'),
	(69530, 112, '2015-02-15 00:55:10.000000', 'temperatura', 718.0000, 'ºC'),
	(69531, 112, '2015-02-15 00:55:11.000000', 'temperatura', 800.0000, 'ºC'),
	(69532, 112, '2015-02-15 00:55:12.000000', 'temperatura', 646.0000, 'ºC'),
	(69533, 112, '2015-02-15 00:55:13.000000', 'temperatura', 830.0000, 'ºC'),
	(69534, 112, '2015-02-15 00:55:14.000000', 'temperatura', 1014.0000, 'ºC'),
	(69535, 112, '2015-02-15 00:55:15.000000', 'temperatura', 181.0000, 'ºC'),
	(69536, 112, '2015-02-15 00:55:16.000000', 'temperatura', 263.0000, 'ºC'),
	(69537, 112, '2015-02-15 00:55:17.000000', 'temperatura', 770.0000, 'ºC'),
	(69538, 112, '2015-02-15 00:55:18.000000', 'temperatura', 665.0000, 'ºC'),
	(69539, 112, '2015-02-15 00:55:19.000000', 'temperatura', 1014.0000, 'ºC'),
	(69540, 112, '2015-02-15 00:55:20.000000', 'temperatura', 676.0000, 'ºC'),
	(69541, 112, '2015-02-15 00:55:21.000000', 'temperatura', 338.0000, 'ºC'),
	(69542, 112, '2015-02-15 00:55:22.000000', 'temperatura', 861.0000, 'ºC'),
	(69543, 112, '2015-02-15 00:55:23.000000', 'temperatura', 893.0000, 'ºC'),
	(69544, 112, '2015-02-15 00:55:24.000000', 'temperatura', 681.0000, 'ºC'),
	(69545, 112, '2015-02-15 00:55:25.000000', 'temperatura', 729.0000, 'ºC'),
	(69546, 112, '2015-02-15 00:55:26.000000', 'temperatura', 403.0000, 'ºC'),
	(69547, 112, '2015-02-15 00:55:27.000000', 'temperatura', 1026.0000, 'ºC'),
	(69548, 112, '2015-02-15 00:55:28.000000', 'temperatura', 322.0000, 'ºC'),
	(69549, 112, '2015-02-15 00:55:29.000000', 'temperatura', 934.0000, 'ºC'),
	(69550, 112, '2015-02-15 00:55:30.000000', 'temperatura', 106.0000, 'ºC'),
	(69551, 112, '2015-02-15 00:55:31.000000', 'temperatura', 125.0000, 'ºC'),
	(69552, 112, '2015-02-15 00:55:32.000000', 'temperatura', 310.0000, 'ºC'),
	(69553, 112, '2015-02-15 00:55:33.000000', 'temperatura', 1175.0000, 'ºC'),
	(69554, 112, '2015-02-15 00:55:34.000000', 'temperatura', 144.0000, 'ºC'),
	(69555, 112, '2015-02-15 00:55:35.000000', 'temperatura', 798.0000, 'ºC'),
	(69556, 112, '2015-02-15 00:55:36.000000', 'temperatura', 1157.0000, 'ºC'),
	(69557, 112, '2015-02-15 00:55:37.000000', 'temperatura', 993.0000, 'ºC'),
	(69558, 112, '2015-02-15 00:55:38.000000', 'temperatura', 292.0000, 'ºC'),
	(69559, 112, '2015-02-15 00:55:39.000000', 'temperatura', 881.0000, 'ºC'),
	(69560, 112, '2015-02-15 00:55:40.000000', 'temperatura', 1129.0000, 'ºC'),
	(69561, 112, '2015-02-15 00:55:41.000000', 'temperatura', 603.0000, 'ºC'),
	(69562, 112, '2015-02-15 00:55:42.000000', 'temperatura', 829.0000, 'ºC'),
	(69563, 112, '2015-02-15 00:55:43.000000', 'temperatura', 1138.0000, 'ºC'),
	(69564, 112, '2015-02-15 00:55:44.000000', 'temperatura', 801.0000, 'ºC'),
	(69565, 112, '2015-02-15 00:55:45.000000', 'temperatura', 593.0000, 'ºC'),
	(69566, 112, '2015-02-15 00:55:46.000000', 'temperatura', 564.0000, 'ºC'),
	(69567, 112, '2015-02-15 00:55:47.000000', 'temperatura', 1040.0000, 'ºC'),
	(69568, 112, '2015-02-15 00:55:48.000000', 'temperatura', 1109.0000, 'ºC'),
	(69569, 112, '2015-02-15 00:55:49.000000', 'temperatura', 25.0000, 'ºC'),
	(69570, 112, '2015-02-15 00:55:50.000000', 'temperatura', 397.0000, 'ºC'),
	(69571, 112, '2015-02-15 00:55:51.000000', 'temperatura', 712.0000, 'ºC'),
	(69572, 112, '2015-02-15 00:55:52.000000', 'temperatura', 1168.0000, 'ºC'),
	(69573, 112, '2015-02-15 00:55:53.000000', 'temperatura', 107.0000, 'ºC'),
	(69574, 112, '2015-02-15 00:55:54.000000', 'temperatura', 629.0000, 'ºC'),
	(69575, 112, '2015-02-15 00:55:55.000000', 'temperatura', 426.0000, 'ºC'),
	(69576, 112, '2015-02-15 00:55:56.000000', 'temperatura', 245.0000, 'ºC'),
	(69577, 112, '2015-02-15 00:55:57.000000', 'temperatura', 1144.0000, 'ºC'),
	(69578, 112, '2015-02-15 00:55:58.000000', 'temperatura', 188.0000, 'ºC'),
	(69579, 112, '2015-02-15 00:55:59.000000', 'temperatura', 1106.0000, 'ºC'),
	(69580, 112, '2015-02-15 00:56:00.000000', 'temperatura', 167.0000, 'ºC'),
	(69581, 112, '2015-02-15 00:56:01.000000', 'temperatura', 1118.0000, 'ºC'),
	(69582, 112, '2015-02-15 00:56:02.000000', 'temperatura', 290.0000, 'ºC'),
	(69583, 112, '2015-02-15 00:56:03.000000', 'temperatura', 497.0000, 'ºC'),
	(69584, 112, '2015-02-15 00:56:04.000000', 'temperatura', 415.0000, 'ºC'),
	(69585, 112, '2015-02-15 00:56:05.000000', 'temperatura', 584.0000, 'ºC'),
	(69586, 112, '2015-02-15 00:56:06.000000', 'temperatura', 478.0000, 'ºC'),
	(69587, 112, '2015-02-15 00:56:07.000000', 'temperatura', 636.0000, 'ºC'),
	(69588, 112, '2015-02-15 00:56:08.000000', 'temperatura', 546.0000, 'ºC'),
	(69589, 112, '2015-02-15 00:56:09.000000', 'temperatura', 825.0000, 'ºC'),
	(69590, 112, '2015-02-15 00:56:10.000000', 'temperatura', 87.0000, 'ºC'),
	(69591, 112, '2015-02-15 00:56:11.000000', 'temperatura', 362.0000, 'ºC'),
	(69592, 112, '2015-02-15 00:56:12.000000', 'temperatura', 348.0000, 'ºC'),
	(69593, 112, '2015-02-15 00:56:13.000000', 'temperatura', 656.0000, 'ºC'),
	(69594, 112, '2015-02-15 00:56:14.000000', 'temperatura', 1033.0000, 'ºC'),
	(69595, 112, '2015-02-15 00:56:15.000000', 'temperatura', 801.0000, 'ºC'),
	(69596, 112, '2015-02-15 00:56:16.000000', 'temperatura', 905.0000, 'ºC'),
	(69597, 112, '2015-02-15 00:56:17.000000', 'temperatura', 925.0000, 'ºC'),
	(69598, 112, '2015-02-15 00:56:18.000000', 'temperatura', 708.0000, 'ºC'),
	(69599, 112, '2015-02-15 00:56:19.000000', 'temperatura', 767.0000, 'ºC'),
	(69600, 112, '2015-02-15 00:56:20.000000', 'temperatura', 511.0000, 'ºC'),
	(69601, 112, '2015-02-15 00:56:21.000000', 'temperatura', 256.0000, 'ºC'),
	(69602, 112, '2015-02-15 00:56:22.000000', 'temperatura', 947.0000, 'ºC'),
	(69603, 112, '2015-02-15 00:56:23.000000', 'temperatura', 368.0000, 'ºC'),
	(69604, 112, '2015-02-15 00:56:24.000000', 'temperatura', 198.0000, 'ºC'),
	(69605, 112, '2015-02-15 00:56:25.000000', 'temperatura', 1088.0000, 'ºC'),
	(69606, 112, '2015-02-15 00:56:26.000000', 'temperatura', 44.0000, 'ºC'),
	(69607, 112, '2015-02-15 00:56:27.000000', 'temperatura', 558.0000, 'ºC'),
	(69608, 112, '2015-02-15 00:56:28.000000', 'temperatura', 260.0000, 'ºC'),
	(69609, 112, '2015-02-15 00:56:29.000000', 'temperatura', 825.0000, 'ºC'),
	(69610, 112, '2015-02-15 00:56:30.000000', 'temperatura', 946.0000, 'ºC'),
	(69611, 112, '2015-02-15 00:56:31.000000', 'temperatura', 1055.0000, 'ºC'),
	(69612, 112, '2015-02-15 00:56:32.000000', 'temperatura', 36.0000, 'ºC'),
	(69613, 112, '2015-02-15 00:56:33.000000', 'temperatura', 618.0000, 'ºC'),
	(69614, 112, '2015-02-15 00:56:34.000000', 'temperatura', 582.0000, 'ºC'),
	(69615, 112, '2015-02-15 00:56:35.000000', 'temperatura', 1058.0000, 'ºC'),
	(69616, 112, '2015-02-15 00:56:36.000000', 'temperatura', 1141.0000, 'ºC'),
	(69617, 112, '2015-02-15 00:56:37.000000', 'temperatura', 134.0000, 'ºC'),
	(69618, 112, '2015-02-15 00:56:38.000000', 'temperatura', 847.0000, 'ºC'),
	(69619, 112, '2015-02-15 00:56:39.000000', 'temperatura', 232.0000, 'ºC'),
	(69620, 112, '2015-02-15 00:56:40.000000', 'temperatura', 1019.0000, 'ºC'),
	(69621, 112, '2015-02-15 00:56:41.000000', 'temperatura', 801.0000, 'ºC'),
	(69622, 112, '2015-02-15 00:56:42.000000', 'temperatura', 948.0000, 'ºC'),
	(69623, 112, '2015-02-15 00:56:43.000000', 'temperatura', 1139.0000, 'ºC'),
	(69624, 112, '2015-02-15 00:56:44.000000', 'temperatura', 449.0000, 'ºC'),
	(69625, 112, '2015-02-15 00:56:45.000000', 'temperatura', 31.0000, 'ºC'),
	(69626, 112, '2015-02-15 00:56:46.000000', 'temperatura', 7.0000, 'ºC'),
	(69627, 112, '2015-02-15 00:56:47.000000', 'temperatura', 1141.0000, 'ºC'),
	(69628, 112, '2015-02-15 00:56:48.000000', 'temperatura', 885.0000, 'ºC'),
	(69629, 112, '2015-02-15 00:56:49.000000', 'temperatura', 1002.0000, 'ºC'),
	(69630, 112, '2015-02-15 00:56:50.000000', 'temperatura', 1158.0000, 'ºC'),
	(69631, 112, '2015-02-15 00:56:51.000000', 'temperatura', 383.0000, 'ºC'),
	(69632, 112, '2015-02-15 00:56:52.000000', 'temperatura', 843.0000, 'ºC'),
	(69633, 112, '2015-02-15 00:56:53.000000', 'temperatura', 664.0000, 'ºC'),
	(69634, 112, '2015-02-15 00:56:54.000000', 'temperatura', 794.0000, 'ºC'),
	(69635, 112, '2015-02-15 00:56:55.000000', 'temperatura', 778.0000, 'ºC'),
	(69636, 112, '2015-02-15 00:56:56.000000', 'temperatura', 307.0000, 'ºC'),
	(69637, 112, '2015-02-15 00:56:57.000000', 'temperatura', 403.0000, 'ºC'),
	(69638, 112, '2015-02-15 00:56:58.000000', 'temperatura', 1094.0000, 'ºC'),
	(69639, 112, '2015-02-15 00:56:59.000000', 'temperatura', 663.0000, 'ºC'),
	(69640, 112, '2015-02-15 00:57:00.000000', 'temperatura', 31.0000, 'ºC'),
	(69641, 112, '2015-02-15 00:57:01.000000', 'temperatura', 569.0000, 'ºC'),
	(69642, 112, '2015-02-15 00:57:02.000000', 'temperatura', 350.0000, 'ºC'),
	(69643, 112, '2015-02-15 00:57:03.000000', 'temperatura', 46.0000, 'ºC'),
	(69644, 112, '2015-02-15 00:57:04.000000', 'temperatura', 379.0000, 'ºC'),
	(69645, 112, '2015-02-15 00:57:05.000000', 'temperatura', 556.0000, 'ºC'),
	(69646, 112, '2015-02-15 00:57:06.000000', 'temperatura', 445.0000, 'ºC'),
	(69647, 112, '2015-02-15 00:57:07.000000', 'temperatura', 558.0000, 'ºC'),
	(69648, 112, '2015-02-15 00:57:08.000000', 'temperatura', 257.0000, 'ºC'),
	(69649, 112, '2015-02-15 00:57:09.000000', 'temperatura', 810.0000, 'ºC'),
	(69650, 112, '2015-02-15 00:57:10.000000', 'temperatura', 880.0000, 'ºC'),
	(69651, 112, '2015-02-15 00:57:11.000000', 'temperatura', 772.0000, 'ºC'),
	(69652, 112, '2015-02-15 00:57:12.000000', 'temperatura', 18.0000, 'ºC'),
	(69653, 112, '2015-02-15 00:57:13.000000', 'temperatura', 175.0000, 'ºC'),
	(69654, 112, '2015-02-15 00:57:14.000000', 'temperatura', 822.0000, 'ºC'),
	(69655, 112, '2015-02-15 00:57:15.000000', 'temperatura', 1187.0000, 'ºC'),
	(69656, 112, '2015-02-15 00:57:16.000000', 'temperatura', 1067.0000, 'ºC'),
	(69657, 112, '2015-02-15 00:57:17.000000', 'temperatura', 577.0000, 'ºC'),
	(69658, 112, '2015-02-15 00:57:18.000000', 'temperatura', 883.0000, 'ºC'),
	(69659, 112, '2015-02-15 00:57:19.000000', 'temperatura', 284.0000, 'ºC'),
	(69660, 112, '2015-02-15 00:57:20.000000', 'temperatura', 1173.0000, 'ºC'),
	(69661, 112, '2015-02-15 00:57:21.000000', 'temperatura', 212.0000, 'ºC'),
	(69662, 112, '2015-02-15 00:57:22.000000', 'temperatura', 1141.0000, 'ºC'),
	(69663, 112, '2015-02-15 00:57:23.000000', 'temperatura', 269.0000, 'ºC'),
	(69664, 112, '2015-02-15 00:57:24.000000', 'temperatura', 322.0000, 'ºC'),
	(69665, 112, '2015-02-15 00:57:25.000000', 'temperatura', 804.0000, 'ºC'),
	(69666, 112, '2015-02-15 00:57:26.000000', 'temperatura', 655.0000, 'ºC'),
	(69667, 112, '2015-02-15 00:57:27.000000', 'temperatura', 861.0000, 'ºC'),
	(69668, 112, '2015-02-15 00:57:28.000000', 'temperatura', 1144.0000, 'ºC'),
	(69669, 112, '2015-02-15 00:57:29.000000', 'temperatura', 734.0000, 'ºC'),
	(69670, 112, '2015-02-15 00:57:30.000000', 'temperatura', 241.0000, 'ºC'),
	(69671, 112, '2015-02-15 00:57:31.000000', 'temperatura', 204.0000, 'ºC'),
	(69672, 112, '2015-02-15 00:57:32.000000', 'temperatura', 296.0000, 'ºC'),
	(69673, 112, '2015-02-15 00:57:33.000000', 'temperatura', 869.0000, 'ºC'),
	(69674, 112, '2015-02-15 00:57:34.000000', 'temperatura', 1057.0000, 'ºC'),
	(69675, 112, '2015-02-15 00:57:35.000000', 'temperatura', 278.0000, 'ºC'),
	(69676, 112, '2015-02-15 00:57:36.000000', 'temperatura', 620.0000, 'ºC'),
	(69677, 112, '2015-02-15 00:57:37.000000', 'temperatura', 1066.0000, 'ºC'),
	(69678, 112, '2015-02-15 00:57:38.000000', 'temperatura', 1069.0000, 'ºC'),
	(69679, 112, '2015-02-15 00:57:39.000000', 'temperatura', 951.0000, 'ºC'),
	(69680, 112, '2015-02-15 00:57:40.000000', 'temperatura', 345.0000, 'ºC'),
	(69681, 112, '2015-02-15 00:57:41.000000', 'temperatura', 75.0000, 'ºC'),
	(69682, 112, '2015-02-15 00:57:42.000000', 'temperatura', 541.0000, 'ºC'),
	(69683, 112, '2015-02-15 00:57:43.000000', 'temperatura', 80.0000, 'ºC'),
	(69684, 112, '2015-02-15 00:57:44.000000', 'temperatura', 1178.0000, 'ºC'),
	(69685, 112, '2015-02-15 00:57:45.000000', 'temperatura', 850.0000, 'ºC'),
	(69686, 112, '2015-02-15 00:57:46.000000', 'temperatura', 719.0000, 'ºC'),
	(69687, 112, '2015-02-15 00:57:47.000000', 'temperatura', 1042.0000, 'ºC'),
	(69688, 112, '2015-02-15 00:57:48.000000', 'temperatura', 653.0000, 'ºC'),
	(69689, 112, '2015-02-15 00:57:49.000000', 'temperatura', 141.0000, 'ºC'),
	(69690, 112, '2015-02-15 00:57:50.000000', 'temperatura', 1145.0000, 'ºC'),
	(69691, 112, '2015-02-15 00:57:51.000000', 'temperatura', 503.0000, 'ºC'),
	(69692, 112, '2015-02-15 00:57:52.000000', 'temperatura', 281.0000, 'ºC'),
	(69693, 112, '2015-02-15 00:57:53.000000', 'temperatura', 1096.0000, 'ºC'),
	(69694, 112, '2015-02-15 00:57:54.000000', 'temperatura', 1036.0000, 'ºC'),
	(69695, 112, '2015-02-15 00:57:55.000000', 'temperatura', 694.0000, 'ºC'),
	(69696, 112, '2015-02-15 00:57:56.000000', 'temperatura', 364.0000, 'ºC'),
	(69697, 112, '2015-02-15 00:57:57.000000', 'temperatura', 939.0000, 'ºC'),
	(69698, 112, '2015-02-15 00:57:58.000000', 'temperatura', 1.0000, 'ºC'),
	(69699, 112, '2015-02-15 00:57:59.000000', 'temperatura', 788.0000, 'ºC'),
	(69700, 112, '2015-02-15 00:58:00.000000', 'temperatura', 340.0000, 'ºC'),
	(69701, 112, '2015-02-15 00:58:01.000000', 'temperatura', 536.0000, 'ºC'),
	(69702, 112, '2015-02-15 00:58:02.000000', 'temperatura', 461.0000, 'ºC'),
	(69703, 112, '2015-02-15 00:58:03.000000', 'temperatura', 698.0000, 'ºC'),
	(69704, 112, '2015-02-15 00:58:04.000000', 'temperatura', 908.0000, 'ºC'),
	(69705, 112, '2015-02-15 00:58:05.000000', 'temperatura', 46.0000, 'ºC'),
	(69706, 112, '2015-02-15 00:58:06.000000', 'temperatura', 1107.0000, 'ºC'),
	(69707, 112, '2015-02-15 00:58:07.000000', 'temperatura', 598.0000, 'ºC'),
	(69708, 112, '2015-02-15 00:58:08.000000', 'temperatura', 869.0000, 'ºC'),
	(69709, 112, '2015-02-15 00:58:09.000000', 'temperatura', 153.0000, 'ºC'),
	(69710, 112, '2015-02-15 00:58:10.000000', 'temperatura', 557.0000, 'ºC'),
	(69711, 112, '2015-02-15 00:58:11.000000', 'temperatura', 1125.0000, 'ºC'),
	(69712, 112, '2015-02-15 00:58:12.000000', 'temperatura', 357.0000, 'ºC'),
	(69713, 112, '2015-02-15 00:58:13.000000', 'temperatura', 809.0000, 'ºC'),
	(69714, 112, '2015-02-15 00:58:14.000000', 'temperatura', 576.0000, 'ºC'),
	(69715, 112, '2015-02-15 00:58:15.000000', 'temperatura', 451.0000, 'ºC'),
	(69716, 112, '2015-02-15 00:58:16.000000', 'temperatura', 527.0000, 'ºC'),
	(69717, 112, '2015-02-15 00:58:17.000000', 'temperatura', 84.0000, 'ºC'),
	(69718, 112, '2015-02-15 00:58:18.000000', 'temperatura', 41.0000, 'ºC'),
	(69719, 112, '2015-02-15 00:58:19.000000', 'temperatura', 1152.0000, 'ºC'),
	(69720, 112, '2015-02-15 00:58:20.000000', 'temperatura', 839.0000, 'ºC'),
	(69721, 112, '2015-02-15 00:58:21.000000', 'temperatura', 739.0000, 'ºC'),
	(69722, 112, '2015-02-15 00:58:22.000000', 'temperatura', 1180.0000, 'ºC'),
	(69723, 112, '2015-02-15 00:58:23.000000', 'temperatura', 83.0000, 'ºC'),
	(69724, 112, '2015-02-15 00:58:24.000000', 'temperatura', 473.0000, 'ºC'),
	(69725, 112, '2015-02-15 00:58:25.000000', 'temperatura', 920.0000, 'ºC'),
	(69726, 112, '2015-02-15 00:58:26.000000', 'temperatura', 780.0000, 'ºC'),
	(69727, 112, '2015-02-15 00:58:27.000000', 'temperatura', 1140.0000, 'ºC'),
	(69728, 112, '2015-02-15 00:58:28.000000', 'temperatura', 959.0000, 'ºC'),
	(69729, 112, '2015-02-15 00:58:29.000000', 'temperatura', 178.0000, 'ºC'),
	(69730, 112, '2015-02-15 00:58:30.000000', 'temperatura', 414.0000, 'ºC'),
	(69731, 112, '2015-02-15 00:58:31.000000', 'temperatura', 336.0000, 'ºC'),
	(69732, 112, '2015-02-15 00:58:32.000000', 'temperatura', 438.0000, 'ºC'),
	(69733, 112, '2015-02-15 00:58:33.000000', 'temperatura', 1183.0000, 'ºC'),
	(69734, 112, '2015-02-15 00:58:34.000000', 'temperatura', 1001.0000, 'ºC'),
	(69735, 112, '2015-02-15 00:58:35.000000', 'temperatura', 256.0000, 'ºC'),
	(69736, 112, '2015-02-15 00:58:36.000000', 'temperatura', 679.0000, 'ºC'),
	(69737, 112, '2015-02-15 00:58:37.000000', 'temperatura', 229.0000, 'ºC'),
	(69738, 112, '2015-02-15 00:58:38.000000', 'temperatura', 305.0000, 'ºC'),
	(69739, 112, '2015-02-15 00:58:39.000000', 'temperatura', 841.0000, 'ºC'),
	(69740, 112, '2015-02-15 00:58:40.000000', 'temperatura', 888.0000, 'ºC'),
	(69741, 112, '2015-02-15 00:58:41.000000', 'temperatura', 717.0000, 'ºC'),
	(69742, 112, '2015-02-15 00:58:42.000000', 'temperatura', 924.0000, 'ºC'),
	(69743, 112, '2015-02-15 00:58:43.000000', 'temperatura', 69.0000, 'ºC'),
	(69744, 112, '2015-02-15 00:58:44.000000', 'temperatura', 1174.0000, 'ºC'),
	(69745, 112, '2015-02-15 00:58:45.000000', 'temperatura', 862.0000, 'ºC'),
	(69746, 112, '2015-02-15 00:58:46.000000', 'temperatura', 788.0000, 'ºC'),
	(69747, 112, '2015-02-15 00:58:47.000000', 'temperatura', 155.0000, 'ºC'),
	(69748, 112, '2015-02-15 00:58:48.000000', 'temperatura', 813.0000, 'ºC'),
	(69749, 112, '2015-02-15 00:58:49.000000', 'temperatura', 2.0000, 'ºC'),
	(69750, 112, '2015-02-15 00:58:50.000000', 'temperatura', 1168.0000, 'ºC'),
	(69751, 112, '2015-02-15 00:58:51.000000', 'temperatura', 1038.0000, 'ºC'),
	(69752, 112, '2015-02-15 00:58:52.000000', 'temperatura', 483.0000, 'ºC'),
	(69753, 112, '2015-02-15 00:58:53.000000', 'temperatura', 503.0000, 'ºC'),
	(69754, 112, '2015-02-15 00:58:54.000000', 'temperatura', 1066.0000, 'ºC'),
	(69755, 112, '2015-02-15 00:58:55.000000', 'temperatura', 220.0000, 'ºC'),
	(69756, 112, '2015-02-15 00:58:56.000000', 'temperatura', 304.0000, 'ºC'),
	(69757, 112, '2015-02-15 00:58:57.000000', 'temperatura', 861.0000, 'ºC'),
	(69758, 112, '2015-02-15 00:58:58.000000', 'temperatura', 995.0000, 'ºC'),
	(69759, 112, '2015-02-15 00:58:59.000000', 'temperatura', 1189.0000, 'ºC'),
	(69760, 112, '2015-02-15 00:59:00.000000', 'temperatura', 562.0000, 'ºC'),
	(69761, 112, '2015-02-15 00:59:01.000000', 'temperatura', 443.0000, 'ºC'),
	(69762, 112, '2015-02-15 00:59:02.000000', 'temperatura', 530.0000, 'ºC'),
	(69763, 112, '2015-02-15 00:59:03.000000', 'temperatura', 122.0000, 'ºC'),
	(69764, 112, '2015-02-15 00:59:04.000000', 'temperatura', 219.0000, 'ºC'),
	(69765, 112, '2015-02-15 00:59:05.000000', 'temperatura', 729.0000, 'ºC'),
	(69766, 112, '2015-02-15 00:59:06.000000', 'temperatura', 590.0000, 'ºC'),
	(69767, 112, '2015-02-15 00:59:07.000000', 'temperatura', 765.0000, 'ºC'),
	(69768, 112, '2015-02-15 00:59:08.000000', 'temperatura', 853.0000, 'ºC'),
	(69769, 112, '2015-02-15 00:59:09.000000', 'temperatura', 771.0000, 'ºC'),
	(69770, 112, '2015-02-15 00:59:10.000000', 'temperatura', 98.0000, 'ºC'),
	(69771, 112, '2015-02-15 00:59:11.000000', 'temperatura', 577.0000, 'ºC'),
	(69772, 112, '2015-02-15 00:59:12.000000', 'temperatura', 192.0000, 'ºC'),
	(69773, 112, '2015-02-15 00:59:13.000000', 'temperatura', 428.0000, 'ºC'),
	(69774, 112, '2015-02-15 00:59:14.000000', 'temperatura', 366.0000, 'ºC'),
	(69775, 112, '2015-02-15 00:59:15.000000', 'temperatura', 546.0000, 'ºC'),
	(69776, 112, '2015-02-15 00:59:16.000000', 'temperatura', 432.0000, 'ºC'),
	(69777, 112, '2015-02-15 00:59:17.000000', 'temperatura', 525.0000, 'ºC'),
	(69778, 112, '2015-02-15 00:59:18.000000', 'temperatura', 127.0000, 'ºC'),
	(69779, 112, '2015-02-15 00:59:19.000000', 'temperatura', 259.0000, 'ºC'),
	(69780, 112, '2015-02-15 00:59:20.000000', 'temperatura', 916.0000, 'ºC'),
	(69781, 112, '2015-02-15 00:59:21.000000', 'temperatura', 206.0000, 'ºC'),
	(69782, 112, '2015-02-15 00:59:22.000000', 'temperatura', 679.0000, 'ºC'),
	(69783, 112, '2015-02-15 00:59:23.000000', 'temperatura', 378.0000, 'ºC'),
	(69784, 112, '2015-02-15 00:59:24.000000', 'temperatura', 1054.0000, 'ºC'),
	(69785, 112, '2015-02-15 00:59:25.000000', 'temperatura', 536.0000, 'ºC'),
	(69786, 112, '2015-02-15 00:59:26.000000', 'temperatura', 718.0000, 'ºC'),
	(69787, 112, '2015-02-15 00:59:27.000000', 'temperatura', 783.0000, 'ºC'),
	(69788, 112, '2015-02-15 00:59:28.000000', 'temperatura', 561.0000, 'ºC'),
	(69789, 112, '2015-02-15 00:59:29.000000', 'temperatura', 455.0000, 'ºC'),
	(69790, 112, '2015-02-15 00:59:30.000000', 'temperatura', 594.0000, 'ºC'),
	(69791, 112, '2015-02-15 00:59:31.000000', 'temperatura', 407.0000, 'ºC'),
	(69792, 112, '2015-02-15 00:59:32.000000', 'temperatura', 254.0000, 'ºC'),
	(69793, 112, '2015-02-15 00:59:33.000000', 'temperatura', 48.0000, 'ºC'),
	(69794, 112, '2015-02-15 00:59:34.000000', 'temperatura', 677.0000, 'ºC'),
	(69795, 112, '2015-02-15 00:59:35.000000', 'temperatura', 844.0000, 'ºC'),
	(69796, 112, '2015-02-15 00:59:36.000000', 'temperatura', 991.0000, 'ºC'),
	(69797, 112, '2015-02-15 00:59:37.000000', 'temperatura', 20.0000, 'ºC'),
	(69798, 112, '2015-02-15 00:59:38.000000', 'temperatura', 730.0000, 'ºC'),
	(69799, 112, '2015-02-15 00:59:39.000000', 'temperatura', 1190.0000, 'ºC'),
	(69800, 112, '2015-02-15 00:59:40.000000', 'temperatura', 161.0000, 'ºC'),
	(69801, 112, '2015-02-15 00:59:41.000000', 'temperatura', 836.0000, 'ºC'),
	(69802, 112, '2015-02-15 00:59:42.000000', 'temperatura', 96.0000, 'ºC'),
	(69803, 112, '2015-02-15 00:59:43.000000', 'temperatura', 375.0000, 'ºC'),
	(69804, 112, '2015-02-15 00:59:44.000000', 'temperatura', 385.0000, 'ºC'),
	(69805, 112, '2015-02-15 00:59:45.000000', 'temperatura', 803.0000, 'ºC'),
	(69806, 112, '2015-02-15 00:59:46.000000', 'temperatura', 460.0000, 'ºC'),
	(69807, 112, '2015-02-15 00:59:47.000000', 'temperatura', 1093.0000, 'ºC'),
	(69808, 112, '2015-02-15 00:59:48.000000', 'temperatura', 484.0000, 'ºC'),
	(69809, 112, '2015-02-15 00:59:49.000000', 'temperatura', 343.0000, 'ºC'),
	(69810, 112, '2015-02-15 00:59:50.000000', 'temperatura', 262.0000, 'ºC'),
	(69811, 112, '2015-02-15 00:59:51.000000', 'temperatura', 284.0000, 'ºC'),
	(69812, 112, '2015-02-15 00:59:52.000000', 'temperatura', 633.0000, 'ºC'),
	(69813, 112, '2015-02-15 00:59:53.000000', 'temperatura', 1112.0000, 'ºC'),
	(69814, 112, '2015-02-15 00:59:54.000000', 'temperatura', 62.0000, 'ºC'),
	(69815, 112, '2015-02-15 00:59:55.000000', 'temperatura', 575.0000, 'ºC'),
	(69816, 112, '2015-02-15 00:59:56.000000', 'temperatura', 290.0000, 'ºC'),
	(69817, 112, '2015-02-15 00:59:57.000000', 'temperatura', 923.0000, 'ºC'),
	(69818, 112, '2015-02-15 00:59:58.000000', 'temperatura', 149.0000, 'ºC'),
	(69819, 112, '2015-02-15 00:59:59.000000', 'temperatura', 373.0000, 'ºC'),
	(69820, 112, '2015-02-15 01:00:00.000000', 'temperatura', 220.0000, 'ºC'),
	(69821, 112, '2015-02-15 01:00:01.000000', 'temperatura', 1181.0000, 'ºC'),
	(69822, 112, '2015-02-15 01:00:02.000000', 'temperatura', 447.0000, 'ºC'),
	(69823, 112, '2015-02-15 01:00:03.000000', 'temperatura', 1093.0000, 'ºC'),
	(69824, 112, '2015-02-15 01:00:04.000000', 'temperatura', 525.0000, 'ºC'),
	(69825, 112, '2015-02-15 01:00:05.000000', 'temperatura', 544.0000, 'ºC'),
	(69826, 112, '2015-02-15 01:00:06.000000', 'temperatura', 1148.0000, 'ºC'),
	(69827, 112, '2015-02-15 01:00:07.000000', 'temperatura', 506.0000, 'ºC'),
	(69828, 112, '2015-02-15 01:00:08.000000', 'temperatura', 289.0000, 'ºC'),
	(69829, 112, '2015-02-15 01:00:09.000000', 'temperatura', 1127.0000, 'ºC'),
	(69830, 112, '2015-02-15 01:00:10.000000', 'temperatura', 1166.0000, 'ºC'),
	(69831, 112, '2015-02-15 01:00:11.000000', 'temperatura', 53.0000, 'ºC'),
	(69832, 112, '2015-02-15 01:00:12.000000', 'temperatura', 365.0000, 'ºC'),
	(69833, 112, '2015-02-15 01:00:13.000000', 'temperatura', 468.0000, 'ºC'),
	(69834, 112, '2015-02-15 01:00:14.000000', 'temperatura', 46.0000, 'ºC'),
	(69835, 112, '2015-02-15 01:00:15.000000', 'temperatura', 28.0000, 'ºC'),
	(69836, 112, '2015-02-15 01:00:16.000000', 'temperatura', 0.0000, 'ºC'),
	(69837, 112, '2015-02-15 01:00:17.000000', 'temperatura', 1117.0000, 'ºC'),
	(69838, 112, '2015-02-15 01:00:18.000000', 'temperatura', 787.0000, 'ºC'),
	(69839, 112, '2015-02-15 01:00:19.000000', 'temperatura', 583.0000, 'ºC'),
	(69840, 112, '2015-02-15 01:00:20.000000', 'temperatura', 554.0000, 'ºC'),
	(69841, 112, '2015-02-15 01:00:21.000000', 'temperatura', 1022.0000, 'ºC'),
	(69842, 112, '2015-02-15 01:00:22.000000', 'temperatura', 1049.0000, 'ºC'),
	(69843, 112, '2015-02-15 01:00:23.000000', 'temperatura', 978.0000, 'ºC'),
	(69844, 112, '2015-02-15 01:00:24.000000', 'temperatura', 543.0000, 'ºC'),
	(69845, 112, '2015-02-15 01:00:25.000000', 'temperatura', 983.0000, 'ºC'),
	(69846, 112, '2015-02-15 01:00:26.000000', 'temperatura', 887.0000, 'ºC'),
	(69847, 112, '2015-02-15 01:00:27.000000', 'temperatura', 286.0000, 'ºC'),
	(69848, 112, '2015-02-15 01:00:28.000000', 'temperatura', 1169.0000, 'ºC'),
	(69849, 112, '2015-02-15 01:00:29.000000', 'temperatura', 189.0000, 'ºC'),
	(69850, 112, '2015-02-15 01:00:30.000000', 'temperatura', 1039.0000, 'ºC'),
	(69851, 112, '2015-02-15 01:00:31.000000', 'temperatura', 1030.0000, 'ºC'),
	(69852, 112, '2015-02-15 01:00:32.000000', 'temperatura', 831.0000, 'ºC'),
	(69853, 112, '2015-02-15 01:00:33.000000', 'temperatura', 1064.0000, 'ºC'),
	(69854, 112, '2015-02-15 01:00:34.000000', 'temperatura', 430.0000, 'ºC'),
	(69855, 112, '2015-02-15 01:00:35.000000', 'temperatura', 156.0000, 'ºC'),
	(69856, 112, '2015-02-15 01:00:36.000000', 'temperatura', 693.0000, 'ºC'),
	(69857, 112, '2015-02-15 01:00:37.000000', 'temperatura', 596.0000, 'ºC'),
	(69858, 112, '2015-02-15 01:00:38.000000', 'temperatura', 901.0000, 'ºC'),
	(69859, 112, '2015-02-15 01:00:39.000000', 'temperatura', 318.0000, 'ºC'),
	(69860, 112, '2015-02-15 01:00:40.000000', 'temperatura', 87.0000, 'ºC'),
	(69861, 112, '2015-02-15 01:00:41.000000', 'temperatura', 680.0000, 'ºC'),
	(69862, 112, '2015-02-15 01:00:42.000000', 'temperatura', 742.0000, 'ºC'),
	(69863, 112, '2015-02-15 01:00:43.000000', 'temperatura', 469.0000, 'ºC'),
	(69864, 112, '2015-02-15 01:00:44.000000', 'temperatura', 120.0000, 'ºC'),
	(69865, 112, '2015-02-15 01:00:45.000000', 'temperatura', 391.0000, 'ºC'),
	(69866, 112, '2015-02-15 01:00:46.000000', 'temperatura', 399.0000, 'ºC'),
	(69867, 112, '2015-02-15 01:00:47.000000', 'temperatura', 820.0000, 'ºC'),
	(69868, 112, '2015-02-15 01:00:48.000000', 'temperatura', 506.0000, 'ºC'),
	(69869, 112, '2015-02-15 01:00:49.000000', 'temperatura', 67.0000, 'ºC'),
	(69870, 112, '2015-02-15 01:00:50.000000', 'temperatura', 21.0000, 'ºC'),
	(69871, 112, '2015-02-15 01:00:51.000000', 'temperatura', 1101.0000, 'ºC'),
	(69872, 112, '2015-02-15 01:00:52.000000', 'temperatura', 646.0000, 'ºC'),
	(69873, 112, '2015-02-15 01:00:53.000000', 'temperatura', 1125.0000, 'ºC'),
	(69874, 112, '2015-02-15 01:00:54.000000', 'temperatura', 88.0000, 'ºC'),
	(69875, 112, '2015-02-15 01:00:55.000000', 'temperatura', 666.0000, 'ºC'),
	(69876, 112, '2015-02-15 01:00:56.000000', 'temperatura', 666.0000, 'ºC'),
	(69877, 112, '2015-02-15 01:00:57.000000', 'temperatura', 131.0000, 'ºC'),
	(69878, 112, '2015-02-15 01:00:58.000000', 'temperatura', 1060.0000, 'ºC'),
	(69879, 112, '2015-02-15 01:00:59.000000', 'temperatura', 108.0000, 'ºC'),
	(69880, 112, '2015-02-15 01:01:00.000000', 'temperatura', 961.0000, 'ºC'),
	(69881, 112, '2015-02-15 01:01:01.000000', 'temperatura', 882.0000, 'ºC'),
	(69882, 112, '2015-02-15 01:01:02.000000', 'temperatura', 328.0000, 'ºC'),
	(69883, 112, '2015-02-15 01:01:03.000000', 'temperatura', 192.0000, 'ºC'),
	(69884, 112, '2015-02-15 01:01:04.000000', 'temperatura', 1177.0000, 'ºC'),
	(69885, 112, '2015-02-15 01:01:05.000000', 'temperatura', 510.0000, 'ºC'),
	(69886, 112, '2015-02-15 01:01:06.000000', 'temperatura', 220.0000, 'ºC'),
	(69887, 112, '2015-02-15 01:01:07.000000', 'temperatura', 770.0000, 'ºC'),
	(69888, 112, '2015-02-15 01:01:08.000000', 'temperatura', 790.0000, 'ºC'),
	(69889, 112, '2015-02-15 01:01:09.000000', 'temperatura', 442.0000, 'ºC'),
	(69890, 112, '2015-02-15 01:01:10.000000', 'temperatura', 1041.0000, 'ºC'),
	(69891, 112, '2015-02-15 01:01:11.000000', 'temperatura', 279.0000, 'ºC'),
	(69892, 112, '2015-02-15 01:01:12.000000', 'temperatura', 673.0000, 'ºC'),
	(69893, 112, '2015-02-15 01:01:13.000000', 'temperatura', 128.0000, 'ºC'),
	(69894, 112, '2015-02-15 01:01:14.000000', 'temperatura', 1024.0000, 'ºC'),
	(69895, 112, '2015-02-15 01:01:15.000000', 'temperatura', 1133.0000, 'ºC'),
	(69896, 112, '2015-02-15 01:01:16.000000', 'temperatura', 195.0000, 'ºC'),
	(69897, 112, '2015-02-15 01:01:17.000000', 'temperatura', 1177.0000, 'ºC'),
	(69898, 112, '2015-02-15 01:01:18.000000', 'temperatura', 501.0000, 'ºC'),
	(69899, 112, '2015-02-15 01:01:19.000000', 'temperatura', 175.0000, 'ºC'),
	(69900, 112, '2015-02-15 01:01:20.000000', 'temperatura', 570.0000, 'ºC'),
	(69901, 112, '2015-02-15 01:01:21.000000', 'temperatura', 1125.0000, 'ºC'),
	(69902, 112, '2015-02-15 01:01:22.000000', 'temperatura', 317.0000, 'ºC'),
	(69903, 112, '2015-02-15 01:01:23.000000', 'temperatura', 610.0000, 'ºC'),
	(69904, 112, '2015-02-15 01:01:24.000000', 'temperatura', 899.0000, 'ºC'),
	(69905, 112, '2015-02-15 01:01:25.000000', 'temperatura', 266.0000, 'ºC'),
	(69906, 112, '2015-02-15 01:01:26.000000', 'temperatura', 1032.0000, 'ºC'),
	(69907, 112, '2015-02-15 01:01:27.000000', 'temperatura', 762.0000, 'ºC'),
	(69908, 112, '2015-02-15 01:01:28.000000', 'temperatura', 717.0000, 'ºC'),
	(69909, 112, '2015-02-15 01:01:29.000000', 'temperatura', 98.0000, 'ºC'),
	(69910, 112, '2015-02-15 01:01:30.000000', 'temperatura', 738.0000, 'ºC'),
	(69911, 112, '2015-02-15 01:01:31.000000', 'temperatura', 999.0000, 'ºC'),
	(69912, 112, '2015-02-15 01:01:32.000000', 'temperatura', 382.0000, 'ºC'),
	(69913, 112, '2015-02-15 01:01:33.000000', 'temperatura', 112.0000, 'ºC'),
	(69914, 112, '2015-02-15 01:01:34.000000', 'temperatura', 617.0000, 'ºC'),
	(69915, 112, '2015-02-15 01:01:35.000000', 'temperatura', 348.0000, 'ºC'),
	(69916, 112, '2015-02-15 01:01:36.000000', 'temperatura', 1090.0000, 'ºC'),
	(69917, 112, '2015-02-15 01:01:37.000000', 'temperatura', 807.0000, 'ºC'),
	(69918, 112, '2015-02-15 01:01:38.000000', 'temperatura', 764.0000, 'ºC'),
	(69919, 112, '2015-02-15 01:01:39.000000', 'temperatura', 200.0000, 'ºC'),
	(69920, 112, '2015-02-15 01:01:40.000000', 'temperatura', 1110.0000, 'ºC'),
	(69921, 112, '2015-02-15 01:01:41.000000', 'temperatura', 149.0000, 'ºC'),
	(69922, 112, '2015-02-15 01:01:42.000000', 'temperatura', 1018.0000, 'ºC'),
	(69923, 112, '2015-02-15 01:01:43.000000', 'temperatura', 1042.0000, 'ºC'),
	(69924, 112, '2015-02-15 01:01:44.000000', 'temperatura', 956.0000, 'ºC'),
	(69925, 112, '2015-02-15 01:01:45.000000', 'temperatura', 456.0000, 'ºC'),
	(69926, 112, '2015-02-15 01:01:46.000000', 'temperatura', 611.0000, 'ºC'),
	(69927, 112, '2015-02-15 01:01:47.000000', 'temperatura', 487.0000, 'ºC'),
	(69928, 112, '2015-02-15 01:01:48.000000', 'temperatura', 604.0000, 'ºC'),
	(69929, 112, '2015-02-15 01:01:49.000000', 'temperatura', 357.0000, 'ºC'),
	(69930, 112, '2015-02-15 01:01:50.000000', 'temperatura', 1176.0000, 'ºC'),
	(69931, 112, '2015-02-15 01:01:51.000000', 'temperatura', 10.0000, 'ºC'),
	(69932, 112, '2015-02-15 01:01:52.000000', 'temperatura', 122.0000, 'ºC'),
	(69933, 112, '2015-02-15 01:01:53.000000', 'temperatura', 580.0000, 'ºC'),
	(69934, 112, '2015-02-15 01:01:54.000000', 'temperatura', 133.0000, 'ºC'),
	(69935, 112, '2015-02-15 01:01:55.000000', 'temperatura', 125.0000, 'ºC'),
	(69936, 112, '2015-02-15 01:01:56.000000', 'temperatura', 230.0000, 'ºC'),
	(69937, 112, '2015-02-15 01:01:57.000000', 'temperatura', 773.0000, 'ºC'),
	(69938, 112, '2015-02-15 01:01:58.000000', 'temperatura', 776.0000, 'ºC'),
	(69939, 112, '2015-02-15 01:01:59.000000', 'temperatura', 360.0000, 'ºC'),
	(69940, 112, '2015-02-15 01:02:00.000000', 'temperatura', 674.0000, 'ºC'),
	(69941, 112, '2015-02-15 01:02:01.000000', 'temperatura', 1089.0000, 'ºC'),
	(69942, 112, '2015-02-15 01:02:02.000000', 'temperatura', 1024.0000, 'ºC'),
	(69943, 112, '2015-02-15 01:02:03.000000', 'temperatura', 654.0000, 'ºC'),
	(69944, 112, '2015-02-15 01:02:04.000000', 'temperatura', 198.0000, 'ºC'),
	(69945, 112, '2015-02-15 01:02:05.000000', 'temperatura', 229.0000, 'ºC'),
	(69946, 112, '2015-02-15 01:02:06.000000', 'temperatura', 552.0000, 'ºC'),
	(69947, 112, '2015-02-15 01:02:07.000000', 'temperatura', 875.0000, 'ºC'),
	(69948, 112, '2015-02-15 01:02:08.000000', 'temperatura', 318.0000, 'ºC'),
	(69949, 112, '2015-02-15 01:02:09.000000', 'temperatura', 166.0000, 'ºC'),
	(69950, 112, '2015-02-15 01:02:10.000000', 'temperatura', 1076.0000, 'ºC'),
	(69951, 112, '2015-02-15 01:02:11.000000', 'temperatura', 82.0000, 'ºC'),
	(69952, 112, '2015-02-15 01:02:12.000000', 'temperatura', 783.0000, 'ºC'),
	(69953, 112, '2015-02-15 01:02:13.000000', 'temperatura', 69.0000, 'ºC'),
	(69954, 112, '2015-02-15 01:02:14.000000', 'temperatura', 396.0000, 'ºC'),
	(69955, 112, '2015-02-15 01:02:15.000000', 'temperatura', 575.0000, 'ºC'),
	(69956, 112, '2015-02-15 01:02:16.000000', 'temperatura', 485.0000, 'ºC'),
	(69957, 112, '2015-02-15 01:02:17.000000', 'temperatura', 701.0000, 'ºC'),
	(69958, 112, '2015-02-15 01:02:18.000000', 'temperatura', 851.0000, 'ºC'),
	(69959, 112, '2015-02-15 01:02:19.000000', 'temperatura', 952.0000, 'ºC'),
	(69960, 112, '2015-02-15 01:02:20.000000', 'temperatura', 1008.0000, 'ºC'),
	(69961, 112, '2015-02-15 01:02:21.000000', 'temperatura', 985.0000, 'ºC'),
	(69962, 112, '2015-02-15 01:02:22.000000', 'temperatura', 703.0000, 'ºC'),
	(69963, 112, '2015-02-15 01:02:23.000000', 'temperatura', 558.0000, 'ºC'),
	(69964, 112, '2015-02-15 01:02:24.000000', 'temperatura', 683.0000, 'ºC'),
	(69965, 112, '2015-02-15 01:02:25.000000', 'temperatura', 541.0000, 'ºC'),
	(69966, 112, '2015-02-15 01:02:26.000000', 'temperatura', 658.0000, 'ºC'),
	(69967, 112, '2015-02-15 01:02:27.000000', 'temperatura', 467.0000, 'ºC'),
	(69968, 112, '2015-02-15 01:02:28.000000', 'temperatura', 359.0000, 'ºC'),
	(69969, 112, '2015-02-15 01:02:29.000000', 'temperatura', 398.0000, 'ºC'),
	(69970, 112, '2015-02-15 01:02:30.000000', 'temperatura', 912.0000, 'ºC'),
	(69971, 112, '2015-02-15 01:02:31.000000', 'temperatura', 966.0000, 'ºC'),
	(69972, 112, '2015-02-15 01:02:32.000000', 'temperatura', 896.0000, 'ºC'),
	(69973, 112, '2015-02-15 01:02:33.000000', 'temperatura', 384.0000, 'ºC'),
	(69974, 112, '2015-02-15 01:02:34.000000', 'temperatura', 429.0000, 'ºC'),
	(69975, 112, '2015-02-15 01:02:35.000000', 'temperatura', 994.0000, 'ºC'),
	(69976, 112, '2015-02-15 01:02:36.000000', 'temperatura', 84.0000, 'ºC'),
	(69977, 112, '2015-02-15 01:02:37.000000', 'temperatura', 1038.0000, 'ºC'),
	(69978, 112, '2015-02-15 01:02:38.000000', 'temperatura', 139.0000, 'ºC'),
	(69979, 112, '2015-02-15 01:02:39.000000', 'temperatura', 1179.0000, 'ºC'),
	(69980, 112, '2015-02-15 01:02:40.000000', 'temperatura', 682.0000, 'ºC'),
	(69981, 112, '2015-02-15 01:02:41.000000', 'temperatura', 1071.0000, 'ºC'),
	(69982, 112, '2015-02-15 01:02:42.000000', 'temperatura', 912.0000, 'ºC'),
	(69983, 112, '2015-02-15 01:02:43.000000', 'temperatura', 146.0000, 'ºC'),
	(69984, 112, '2015-02-15 01:02:44.000000', 'temperatura', 393.0000, 'ºC'),
	(69985, 112, '2015-02-15 01:02:45.000000', 'temperatura', 331.0000, 'ºC'),
	(69986, 112, '2015-02-15 01:02:46.000000', 'temperatura', 473.0000, 'ºC'),
	(69987, 112, '2015-02-15 01:02:47.000000', 'temperatura', 175.0000, 'ºC'),
	(69988, 112, '2015-02-15 01:02:48.000000', 'temperatura', 657.0000, 'ºC'),
	(69989, 112, '2015-02-15 01:02:49.000000', 'temperatura', 359.0000, 'ºC'),
	(69990, 112, '2015-02-15 01:02:50.000000', 'temperatura', 1024.0000, 'ºC'),
	(69991, 112, '2015-02-15 01:02:51.000000', 'temperatura', 444.0000, 'ºC'),
	(69992, 112, '2015-02-15 01:02:52.000000', 'temperatura', 347.0000, 'ºC'),
	(69993, 112, '2015-02-15 01:02:53.000000', 'temperatura', 405.0000, 'ºC'),
	(69994, 112, '2015-02-15 01:02:54.000000', 'temperatura', 982.0000, 'ºC'),
	(69995, 112, '2015-02-15 01:02:55.000000', 'temperatura', 98.0000, 'ºC'),
	(69996, 112, '2015-02-15 01:02:56.000000', 'temperatura', 1145.0000, 'ºC'),
	(69997, 112, '2015-02-15 01:02:57.000000', 'temperatura', 629.0000, 'ºC'),
	(69998, 112, '2015-02-15 01:02:58.000000', 'temperatura', 914.0000, 'ºC'),
	(69999, 112, '2015-02-15 01:02:59.000000', 'temperatura', 281.0000, 'ºC'),
	(70000, 112, '2015-02-15 01:03:00.000000', 'temperatura', 1063.0000, 'ºC'),
	(70001, 112, '2015-02-15 01:03:01.000000', 'temperatura', 874.0000, 'ºC'),
	(70002, 112, '2015-02-15 01:03:02.000000', 'temperatura', 1180.0000, 'ºC'),
	(70003, 112, '2015-02-15 01:03:03.000000', 'temperatura', 880.0000, 'ºC'),
	(70004, 112, '2015-02-15 01:03:04.000000', 'temperatura', 861.0000, 'ºC'),
	(70005, 112, '2015-02-15 01:03:05.000000', 'temperatura', 463.0000, 'ºC'),
	(70006, 112, '2015-02-15 01:03:06.000000', 'temperatura', 935.0000, 'ºC'),
	(70007, 112, '2015-02-15 01:03:07.000000', 'temperatura', 886.0000, 'ºC'),
	(70008, 112, '2015-02-15 01:03:08.000000', 'temperatura', 424.0000, 'ºC'),
	(70009, 112, '2015-02-15 01:03:09.000000', 'temperatura', 665.0000, 'ºC'),
	(70010, 112, '2015-02-15 01:03:10.000000', 'temperatura', 851.0000, 'ºC'),
	(70011, 112, '2015-02-15 01:03:11.000000', 'temperatura', 1063.0000, 'ºC'),
	(70012, 112, '2015-02-15 01:03:12.000000', 'temperatura', 362.0000, 'ºC'),
	(70013, 112, '2015-02-15 01:03:13.000000', 'temperatura', 1022.0000, 'ºC'),
	(70014, 112, '2015-02-15 01:03:14.000000', 'temperatura', 426.0000, 'ºC'),
	(70015, 112, '2015-02-15 01:03:15.000000', 'temperatura', 262.0000, 'ºC'),
	(70016, 112, '2015-02-15 01:03:16.000000', 'temperatura', 34.0000, 'ºC'),
	(70017, 112, '2015-02-15 01:03:17.000000', 'temperatura', 585.0000, 'ºC'),
	(70018, 112, '2015-02-15 01:03:18.000000', 'temperatura', 421.0000, 'ºC'),
	(70019, 112, '2015-02-15 01:03:19.000000', 'temperatura', 353.0000, 'ºC'),
	(70020, 112, '2015-02-15 01:03:20.000000', 'temperatura', 501.0000, 'ºC'),
	(70021, 112, '2015-02-15 01:03:21.000000', 'temperatura', 245.0000, 'ºC'),
	(70022, 112, '2015-02-15 01:03:22.000000', 'temperatura', 926.0000, 'ºC'),
	(70023, 112, '2015-02-15 01:03:23.000000', 'temperatura', 292.0000, 'ºC'),
	(70024, 112, '2015-02-15 01:03:24.000000', 'temperatura', 1086.0000, 'ºC'),
	(70025, 112, '2015-02-15 01:03:25.000000', 'temperatura', 951.0000, 'ºC'),
	(70026, 112, '2015-02-15 01:03:26.000000', 'temperatura', 301.0000, 'ºC'),
	(70027, 112, '2015-02-15 01:03:27.000000', 'temperatura', 1049.0000, 'ºC'),
	(70028, 112, '2015-02-15 01:03:28.000000', 'temperatura', 744.0000, 'ºC'),
	(70029, 112, '2015-02-15 01:03:29.000000', 'temperatura', 573.0000, 'ºC'),
	(70030, 112, '2015-02-15 01:03:30.000000', 'temperatura', 633.0000, 'ºC'),
	(70031, 112, '2015-02-15 01:03:31.000000', 'temperatura', 248.0000, 'ºC'),
	(70032, 112, '2015-02-15 01:03:32.000000', 'temperatura', 539.0000, 'ºC'),
	(70033, 112, '2015-02-15 01:03:33.000000', 'temperatura', 754.0000, 'ºC'),
	(70034, 112, '2015-02-15 01:03:34.000000', 'temperatura', 952.0000, 'ºC'),
	(70035, 112, '2015-02-15 01:03:35.000000', 'temperatura', 100.0000, 'ºC'),
	(70036, 112, '2015-02-15 01:03:36.000000', 'temperatura', 42.0000, 'ºC'),
	(70037, 112, '2015-02-15 01:03:37.000000', 'temperatura', 1110.0000, 'ºC'),
	(70038, 112, '2015-02-15 01:03:38.000000', 'temperatura', 628.0000, 'ºC'),
	(70039, 112, '2015-02-15 01:03:39.000000', 'temperatura', 1007.0000, 'ºC'),
	(70040, 112, '2015-02-15 01:03:40.000000', 'temperatura', 755.0000, 'ºC'),
	(70041, 112, '2015-02-15 01:03:41.000000', 'temperatura', 752.0000, 'ºC'),
	(70042, 112, '2015-02-15 01:03:42.000000', 'temperatura', 298.0000, 'ºC'),
	(70043, 112, '2015-02-15 01:03:43.000000', 'temperatura', 433.0000, 'ºC'),
	(70044, 112, '2015-02-15 01:03:44.000000', 'temperatura', 71.0000, 'ºC'),
	(70045, 112, '2015-02-15 01:03:45.000000', 'temperatura', 256.0000, 'ºC'),
	(70046, 112, '2015-02-15 01:03:46.000000', 'temperatura', 1068.0000, 'ºC'),
	(70047, 112, '2015-02-15 01:03:47.000000', 'temperatura', 972.0000, 'ºC'),
	(70048, 112, '2015-02-15 01:03:48.000000', 'temperatura', 457.0000, 'ºC'),
	(70049, 112, '2015-02-15 01:03:49.000000', 'temperatura', 569.0000, 'ºC'),
	(70050, 112, '2015-02-15 01:03:50.000000', 'temperatura', 274.0000, 'ºC'),
	(70051, 112, '2015-02-15 01:03:51.000000', 'temperatura', 866.0000, 'ºC'),
	(70052, 112, '2015-02-15 01:03:52.000000', 'temperatura', 1106.0000, 'ºC'),
	(70053, 112, '2015-02-15 01:03:53.000000', 'temperatura', 532.0000, 'ºC'),
	(70054, 112, '2015-02-15 01:03:54.000000', 'temperatura', 545.0000, 'ºC'),
	(70055, 112, '2015-02-15 01:03:55.000000', 'temperatura', 1129.0000, 'ºC'),
	(70056, 112, '2015-02-15 01:03:56.000000', 'temperatura', 409.0000, 'ºC'),
	(70057, 112, '2015-02-15 01:03:57.000000', 'temperatura', 1057.0000, 'ºC'),
	(70058, 112, '2015-02-15 01:03:58.000000', 'temperatura', 462.0000, 'ºC'),
	(70059, 112, '2015-02-15 01:03:59.000000', 'temperatura', 337.0000, 'ºC'),
	(70060, 112, '2015-02-15 01:04:00.000000', 'temperatura', 301.0000, 'ºC'),
	(70061, 112, '2015-02-15 01:04:01.000000', 'temperatura', 496.0000, 'ºC'),
	(70062, 112, '2015-02-15 01:04:02.000000', 'temperatura', 376.0000, 'ºC'),
	(70063, 112, '2015-02-15 01:04:03.000000', 'temperatura', 394.0000, 'ºC'),
	(70064, 112, '2015-02-15 01:04:04.000000', 'temperatura', 841.0000, 'ºC'),
	(70065, 112, '2015-02-15 01:04:05.000000', 'temperatura', 624.0000, 'ºC'),
	(70066, 112, '2015-02-15 01:04:06.000000', 'temperatura', 599.0000, 'ºC'),
	(70067, 112, '2015-02-15 01:04:07.000000', 'temperatura', 1122.0000, 'ºC'),
	(70068, 112, '2015-02-15 01:04:08.000000', 'temperatura', 216.0000, 'ºC'),
	(70069, 112, '2015-02-15 01:04:09.000000', 'temperatura', 112.0000, 'ºC'),
	(70070, 112, '2015-02-15 01:04:10.000000', 'temperatura', 1111.0000, 'ºC'),
	(70071, 112, '2015-02-15 01:04:11.000000', 'temperatura', 422.0000, 'ºC'),
	(70072, 112, '2015-02-15 01:04:12.000000', 'temperatura', 1177.0000, 'ºC'),
	(70073, 112, '2015-02-15 01:04:13.000000', 'temperatura', 1021.0000, 'ºC'),
	(70074, 112, '2015-02-15 01:04:14.000000', 'temperatura', 373.0000, 'ºC'),
	(70075, 112, '2015-02-15 01:04:15.000000', 'temperatura', 4.0000, 'ºC'),
	(70076, 112, '2015-02-15 01:04:16.000000', 'temperatura', 100.0000, 'ºC'),
	(70077, 112, '2015-02-15 01:04:17.000000', 'temperatura', 487.0000, 'ºC'),
	(70078, 112, '2015-02-15 01:04:18.000000', 'temperatura', 938.0000, 'ºC'),
	(70079, 112, '2015-02-15 01:04:19.000000', 'temperatura', 830.0000, 'ºC'),
	(70080, 112, '2015-02-15 01:04:20.000000', 'temperatura', 135.0000, 'ºC'),
	(70081, 112, '2015-02-15 01:04:21.000000', 'temperatura', 586.0000, 'ºC'),
	(70082, 112, '2015-02-15 01:04:22.000000', 'temperatura', 126.0000, 'ºC'),
	(70083, 112, '2015-02-15 01:04:23.000000', 'temperatura', 70.0000, 'ºC'),
	(70084, 112, '2015-02-15 01:04:24.000000', 'temperatura', 1175.0000, 'ºC'),
	(70085, 112, '2015-02-15 01:04:25.000000', 'temperatura', 863.0000, 'ºC'),
	(70086, 112, '2015-02-15 01:04:26.000000', 'temperatura', 793.0000, 'ºC'),
	(70087, 112, '2015-02-15 01:04:27.000000', 'temperatura', 175.0000, 'ºC'),
	(70088, 112, '2015-02-15 01:04:28.000000', 'temperatura', 896.0000, 'ºC'),
	(70089, 112, '2015-02-15 01:04:29.000000', 'temperatura', 357.0000, 'ºC'),
	(70090, 112, '2015-02-15 01:04:30.000000', 'temperatura', 297.0000, 'ºC'),
	(70091, 112, '2015-02-15 01:04:31.000000', 'temperatura', 413.0000, 'ºC'),
	(70092, 112, '2015-02-15 01:04:32.000000', 'temperatura', 1174.0000, 'ºC'),
	(70093, 112, '2015-02-15 01:04:33.000000', 'temperatura', 1034.0000, 'ºC'),
	(70094, 112, '2015-02-15 01:04:34.000000', 'temperatura', 447.0000, 'ºC'),
	(70095, 112, '2015-02-15 01:04:35.000000', 'temperatura', 333.0000, 'ºC'),
	(70096, 112, '2015-02-15 01:04:36.000000', 'temperatura', 326.0000, 'ºC'),
	(70097, 112, '2015-02-15 01:04:37.000000', 'temperatura', 630.0000, 'ºC'),
	(70098, 112, '2015-02-15 01:04:38.000000', 'temperatura', 972.0000, 'ºC'),
	(70099, 112, '2015-02-15 01:04:39.000000', 'temperatura', 570.0000, 'ºC'),
	(70100, 112, '2015-02-15 01:04:40.000000', 'temperatura', 1136.0000, 'ºC'),
	(70101, 112, '2015-02-15 01:04:41.000000', 'temperatura', 370.0000, 'ºC'),
	(70102, 112, '2015-02-15 01:04:42.000000', 'temperatura', 844.0000, 'ºC'),
	(70103, 112, '2015-02-15 01:04:43.000000', 'temperatura', 708.0000, 'ºC'),
	(70104, 112, '2015-02-15 01:04:44.000000', 'temperatura', 1009.0000, 'ºC'),
	(70105, 112, '2015-02-15 01:04:45.000000', 'temperatura', 520.0000, 'ºC'),
	(70106, 112, '2015-02-15 01:04:46.000000', 'temperatura', 776.0000, 'ºC'),
	(70107, 112, '2015-02-15 01:04:47.000000', 'temperatura', 1122.0000, 'ºC'),
	(70108, 112, '2015-02-15 01:04:48.000000', 'temperatura', 880.0000, 'ºC'),
	(70109, 112, '2015-02-15 01:04:49.000000', 'temperatura', 1034.0000, 'ºC'),
	(70110, 112, '2015-02-15 01:04:50.000000', 'temperatura', 133.0000, 'ºC'),
	(70111, 112, '2015-02-15 01:04:51.000000', 'temperatura', 1160.0000, 'ºC'),
	(70112, 112, '2015-02-15 01:04:52.000000', 'temperatura', 605.0000, 'ºC'),
	(70113, 112, '2015-02-15 01:04:53.000000', 'temperatura', 744.0000, 'ºC'),
	(70114, 112, '2015-02-15 01:04:54.000000', 'temperatura', 705.0000, 'ºC'),
	(70115, 112, '2015-02-15 01:04:55.000000', 'temperatura', 94.0000, 'ºC'),
	(70116, 112, '2015-02-15 01:04:56.000000', 'temperatura', 755.0000, 'ºC'),
	(70117, 112, '2015-02-15 01:04:57.000000', 'temperatura', 1094.0000, 'ºC'),
	(70118, 112, '2015-02-15 01:04:58.000000', 'temperatura', 807.0000, 'ºC'),
	(70119, 112, '2015-02-15 01:04:59.000000', 'temperatura', 752.0000, 'ºC'),
	(70120, 112, '2015-02-15 01:05:00.000000', 'temperatura', 140.0000, 'ºC'),
	(70121, 112, '2015-02-15 01:05:01.000000', 'temperatura', 845.0000, 'ºC'),
	(70122, 112, '2015-02-15 01:05:02.000000', 'temperatura', 207.0000, 'ºC'),
	(70123, 112, '2015-02-15 01:05:03.000000', 'temperatura', 897.0000, 'ºC'),
	(70124, 112, '2015-02-15 01:05:04.000000', 'temperatura', 266.0000, 'ºC'),
	(70125, 112, '2015-02-15 01:05:05.000000', 'temperatura', 1041.0000, 'ºC'),
	(70126, 112, '2015-02-15 01:05:06.000000', 'temperatura', 807.0000, 'ºC'),
	(70127, 112, '2015-02-15 01:05:07.000000', 'temperatura', 911.0000, 'ºC'),
	(70128, 112, '2015-02-15 01:05:08.000000', 'temperatura', 935.0000, 'ºC'),
	(70129, 112, '2015-02-15 01:05:09.000000', 'temperatura', 745.0000, 'ºC'),
	(70130, 112, '2015-02-15 01:05:10.000000', 'temperatura', 918.0000, 'ºC'),
	(70131, 112, '2015-02-15 01:05:11.000000', 'temperatura', 1156.0000, 'ºC'),
	(70132, 112, '2015-02-15 01:05:12.000000', 'temperatura', 628.0000, 'ºC'),
	(70133, 112, '2015-02-15 01:05:13.000000', 'temperatura', 872.0000, 'ºC'),
	(70134, 112, '2015-02-15 01:05:14.000000', 'temperatura', 74.0000, 'ºC'),
	(70135, 112, '2015-02-15 01:05:15.000000', 'temperatura', 158.0000, 'ºC'),
	(70136, 112, '2015-02-15 01:05:16.000000', 'temperatura', 567.0000, 'ºC'),
	(70137, 112, '2015-02-15 01:05:17.000000', 'temperatura', 1163.0000, 'ºC'),
	(70138, 112, '2015-02-15 01:05:18.000000', 'temperatura', 514.0000, 'ºC'),
	(70139, 112, '2015-02-15 01:05:19.000000', 'temperatura', 281.0000, 'ºC'),
	(70140, 112, '2015-02-15 01:05:20.000000', 'temperatura', 1063.0000, 'ºC'),
	(70141, 112, '2015-02-15 01:05:21.000000', 'temperatura', 875.0000, 'ºC'),
	(70142, 112, '2015-02-15 01:05:22.000000', 'temperatura', 1185.0000, 'ºC'),
	(70143, 112, '2015-02-15 01:05:23.000000', 'temperatura', 902.0000, 'ºC'),
	(70144, 112, '2015-02-15 01:05:24.000000', 'temperatura', 954.0000, 'ºC'),
	(70145, 112, '2015-02-15 01:05:25.000000', 'temperatura', 863.0000, 'ºC'),
	(70146, 112, '2015-02-15 01:05:26.000000', 'temperatura', 254.0000, 'ºC'),
	(70147, 112, '2015-02-15 01:05:27.000000', 'temperatura', 1083.0000, 'ºC'),
	(70148, 112, '2015-02-15 01:05:28.000000', 'temperatura', 1051.0000, 'ºC'),
	(70149, 112, '2015-02-15 01:05:29.000000', 'temperatura', 808.0000, 'ºC'),
	(70150, 112, '2015-02-15 01:05:30.000000', 'temperatura', 886.0000, 'ºC'),
	(70151, 112, '2015-02-15 01:05:31.000000', 'temperatura', 807.0000, 'ºC'),
	(70152, 112, '2015-02-15 01:05:32.000000', 'temperatura', 177.0000, 'ºC'),
	(70153, 112, '2015-02-15 01:05:33.000000', 'temperatura', 865.0000, 'ºC'),
	(70154, 112, '2015-02-15 01:05:34.000000', 'temperatura', 196.0000, 'ºC'),
	(70155, 112, '2015-02-15 01:05:35.000000', 'temperatura', 784.0000, 'ºC'),
	(70156, 112, '2015-02-15 01:05:36.000000', 'temperatura', 933.0000, 'ºC'),
	(70157, 112, '2015-02-15 01:05:37.000000', 'temperatura', 1114.0000, 'ºC'),
	(70158, 112, '2015-02-15 01:05:38.000000', 'temperatura', 373.0000, 'ºC'),
	(70159, 112, '2015-02-15 01:05:39.000000', 'temperatura', 921.0000, 'ºC'),
	(70160, 112, '2015-02-15 01:05:40.000000', 'temperatura', 1088.0000, 'ºC'),
	(70161, 112, '2015-02-15 01:05:41.000000', 'temperatura', 276.0000, 'ºC'),
	(70162, 112, '2015-02-15 01:05:42.000000', 'temperatura', 518.0000, 'ºC'),
	(70163, 112, '2015-02-15 01:05:43.000000', 'temperatura', 563.0000, 'ºC'),
	(70164, 112, '2015-02-15 01:05:44.000000', 'temperatura', 60.0000, 'ºC'),
	(70165, 112, '2015-02-15 01:05:45.000000', 'temperatura', 1014.0000, 'ºC'),
	(70166, 112, '2015-02-15 01:05:46.000000', 'temperatura', 87.0000, 'ºC'),
	(70167, 112, '2015-02-15 01:05:47.000000', 'temperatura', 995.0000, 'ºC'),
	(70168, 112, '2015-02-15 01:05:48.000000', 'temperatura', 1116.0000, 'ºC'),
	(70169, 112, '2015-02-15 01:05:49.000000', 'temperatura', 196.0000, 'ºC'),
	(70170, 112, '2015-02-15 01:05:50.000000', 'temperatura', 30.0000, 'ºC'),
	(70171, 112, '2015-02-15 01:05:51.000000', 'temperatura', 762.0000, 'ºC'),
	(70172, 112, '2015-02-15 01:05:52.000000', 'temperatura', 120.0000, 'ºC'),
	(70173, 112, '2015-02-15 01:05:53.000000', 'temperatura', 716.0000, 'ºC'),
	(70174, 112, '2015-02-15 01:05:54.000000', 'temperatura', 820.0000, 'ºC'),
	(70175, 112, '2015-02-15 01:05:55.000000', 'temperatura', 753.0000, 'ºC'),
	(70176, 112, '2015-02-15 01:05:56.000000', 'temperatura', 107.0000, 'ºC'),
	(70177, 112, '2015-02-15 01:05:57.000000', 'temperatura', 675.0000, 'ºC'),
	(70178, 112, '2015-02-15 01:05:58.000000', 'temperatura', 656.0000, 'ºC'),
	(70179, 112, '2015-02-15 01:05:59.000000', 'temperatura', 55.0000, 'ºC'),
	(70180, 112, '2015-02-15 01:06:00.000000', 'temperatura', 709.0000, 'ºC'),
	(70181, 112, '2015-02-15 01:06:01.000000', 'temperatura', 978.0000, 'ºC'),
	(70182, 112, '2015-02-15 01:06:02.000000', 'temperatura', 366.0000, 'ºC'),
	(70183, 112, '2015-02-15 01:06:03.000000', 'temperatura', 96.0000, 'ºC'),
	(70184, 112, '2015-02-15 01:06:04.000000', 'temperatura', 584.0000, 'ºC'),
	(70185, 112, '2015-02-15 01:06:05.000000', 'temperatura', 229.0000, 'ºC'),
	(70186, 112, '2015-02-15 01:06:06.000000', 'temperatura', 595.0000, 'ºC'),
	(70187, 112, '2015-02-15 01:06:07.000000', 'temperatura', 1090.0000, 'ºC'),
	(70188, 112, '2015-02-15 01:06:08.000000', 'temperatura', 66.0000, 'ºC'),
	(70189, 112, '2015-02-15 01:06:09.000000', 'temperatura', 658.0000, 'ºC'),
	(70190, 112, '2015-02-15 01:06:10.000000', 'temperatura', 695.0000, 'ºC'),
	(70191, 112, '2015-02-15 01:06:11.000000', 'temperatura', 298.0000, 'ºC'),
	(70192, 112, '2015-02-15 01:06:12.000000', 'temperatura', 609.0000, 'ºC'),
	(70193, 112, '2015-02-15 01:06:13.000000', 'temperatura', 951.0000, 'ºC'),
	(70194, 112, '2015-02-15 01:06:14.000000', 'temperatura', 527.0000, 'ºC'),
	(70195, 112, '2015-02-15 01:06:15.000000', 'temperatura', 984.0000, 'ºC'),
	(70196, 112, '2015-02-15 01:06:16.000000', 'temperatura', 938.0000, 'ºC'),
	(70197, 112, '2015-02-15 01:06:17.000000', 'temperatura', 539.0000, 'ºC'),
	(70198, 112, '2015-02-15 01:06:18.000000', 'temperatura', 1082.0000, 'ºC'),
	(70199, 112, '2015-02-15 01:06:19.000000', 'temperatura', 194.0000, 'ºC'),
	(70200, 112, '2015-02-15 01:06:20.000000', 'temperatura', 124.0000, 'ºC'),
	(70201, 112, '2015-02-15 01:06:21.000000', 'temperatura', 40.0000, 'ºC'),
	(70202, 112, '2015-02-15 01:06:22.000000', 'temperatura', 1026.0000, 'ºC'),
	(70203, 112, '2015-02-15 01:06:23.000000', 'temperatura', 213.0000, 'ºC'),
	(70204, 112, '2015-02-15 01:06:24.000000', 'temperatura', 387.0000, 'ºC'),
	(70205, 112, '2015-02-15 01:06:25.000000', 'temperatura', 97.0000, 'ºC'),
	(70206, 112, '2015-02-15 01:06:26.000000', 'temperatura', 523.0000, 'ºC'),
	(70207, 112, '2015-02-15 01:06:27.000000', 'temperatura', 1127.0000, 'ºC'),
	(70208, 112, '2015-02-15 01:06:28.000000', 'temperatura', 464.0000, 'ºC'),
	(70209, 112, '2015-02-15 01:06:29.000000', 'temperatura', 142.0000, 'ºC'),
	(70210, 112, '2015-02-15 01:06:30.000000', 'temperatura', 519.0000, 'ºC'),
	(70211, 112, '2015-02-15 01:06:31.000000', 'temperatura', 968.0000, 'ºC'),
	(70212, 112, '2015-02-15 01:06:32.000000', 'temperatura', 884.0000, 'ºC'),
	(70213, 112, '2015-02-15 01:06:33.000000', 'temperatura', 316.0000, 'ºC'),
	(70214, 112, '2015-02-15 01:06:34.000000', 'temperatura', 127.0000, 'ºC'),
	(70215, 112, '2015-02-15 01:06:35.000000', 'temperatura', 890.0000, 'ºC'),
	(70216, 112, '2015-02-15 01:06:36.000000', 'temperatura', 469.0000, 'ºC'),
	(70217, 112, '2015-02-15 01:06:37.000000', 'temperatura', 875.0000, 'ºC'),
	(70218, 112, '2015-02-15 01:06:38.000000', 'temperatura', 568.0000, 'ºC'),
	(70219, 112, '2015-02-15 01:06:39.000000', 'temperatura', 216.0000, 'ºC'),
	(70220, 112, '2015-02-15 01:06:40.000000', 'temperatura', 578.0000, 'ºC'),
	(70221, 112, '2015-02-15 01:06:41.000000', 'temperatura', 1039.0000, 'ºC'),
	(70222, 112, '2015-02-15 01:06:42.000000', 'temperatura', 1065.0000, 'ºC'),
	(70223, 112, '2015-02-15 01:06:43.000000', 'temperatura', 1006.0000, 'ºC'),
	(70224, 112, '2015-02-15 01:06:44.000000', 'temperatura', 638.0000, 'ºC'),
	(70225, 112, '2015-02-15 01:06:45.000000', 'temperatura', 173.0000, 'ºC'),
	(70226, 112, '2015-02-15 01:06:46.000000', 'temperatura', 149.0000, 'ºC'),
	(70227, 112, '2015-02-15 01:06:47.000000', 'temperatura', 229.0000, 'ºC'),
	(70228, 112, '2015-02-15 01:06:48.000000', 'temperatura', 699.0000, 'ºC'),
	(70229, 112, '2015-02-15 01:06:49.000000', 'temperatura', 408.0000, 'ºC'),
	(70230, 112, '2015-02-15 01:06:50.000000', 'temperatura', 1143.0000, 'ºC'),
	(70231, 112, '2015-02-15 01:06:51.000000', 'temperatura', 892.0000, 'ºC'),
	(70232, 112, '2015-02-15 01:06:52.000000', 'temperatura', 1032.0000, 'ºC'),
	(70233, 112, '2015-02-15 01:06:53.000000', 'temperatura', 85.0000, 'ºC'),
	(70234, 112, '2015-02-15 01:06:54.000000', 'temperatura', 929.0000, 'ºC'),
	(70235, 112, '2015-02-15 01:06:55.000000', 'temperatura', 792.0000, 'ºC'),
	(70236, 112, '2015-02-15 01:06:56.000000', 'temperatura', 1170.0000, 'ºC'),
	(70237, 112, '2015-02-15 01:06:57.000000', 'temperatura', 1077.0000, 'ºC'),
	(70238, 112, '2015-02-15 01:06:58.000000', 'temperatura', 676.0000, 'ºC'),
	(70239, 112, '2015-02-15 01:06:59.000000', 'temperatura', 150.0000, 'ºC'),
	(70240, 112, '2015-02-15 01:07:00.000000', 'temperatura', 1123.0000, 'ºC'),
	(70241, 112, '2015-02-15 01:07:01.000000', 'temperatura', 364.0000, 'ºC'),
	(70242, 112, '2015-02-15 01:07:02.000000', 'temperatura', 851.0000, 'ºC'),
	(70243, 112, '2015-02-15 01:07:03.000000', 'temperatura', 766.0000, 'ºC'),
	(70244, 112, '2015-02-15 01:07:04.000000', 'temperatura', 77.0000, 'ºC'),
	(70245, 112, '2015-02-15 01:07:05.000000', 'temperatura', 485.0000, 'ºC'),
	(70246, 112, '2015-02-15 01:07:06.000000', 'temperatura', 997.0000, 'ºC'),
	(70247, 112, '2015-02-15 01:07:07.000000', 'temperatura', 1131.0000, 'ºC'),
	(70248, 112, '2015-02-15 01:07:08.000000', 'temperatura', 263.0000, 'ºC'),
	(70249, 112, '2015-02-15 01:07:09.000000', 'temperatura', 321.0000, 'ºC'),
	(70250, 112, '2015-02-15 01:07:10.000000', 'temperatura', 820.0000, 'ºC'),
	(70251, 112, '2015-02-15 01:07:11.000000', 'temperatura', 735.0000, 'ºC'),
	(70252, 112, '2015-02-15 01:07:12.000000', 'temperatura', 15.0000, 'ºC'),
	(70253, 112, '2015-02-15 01:07:13.000000', 'temperatura', 272.0000, 'ºC'),
	(70254, 112, '2015-02-15 01:07:14.000000', 'temperatura', 113.0000, 'ºC'),
	(70255, 112, '2015-02-15 01:07:15.000000', 'temperatura', 951.0000, 'ºC'),
	(70256, 112, '2015-02-15 01:07:16.000000', 'temperatura', 818.0000, 'ºC'),
	(70257, 112, '2015-02-15 01:07:17.000000', 'temperatura', 38.0000, 'ºC'),
	(70258, 112, '2015-02-15 01:07:18.000000', 'temperatura', 136.0000, 'ºC'),
	(70259, 112, '2015-02-15 01:07:19.000000', 'temperatura', 566.0000, 'ºC'),
	(70260, 112, '2015-02-15 01:07:20.000000', 'temperatura', 24.0000, 'ºC'),
	(70261, 112, '2015-02-15 01:07:21.000000', 'temperatura', 821.0000, 'ºC'),
	(70262, 112, '2015-02-15 01:07:22.000000', 'temperatura', 434.0000, 'ºC'),
	(70263, 112, '2015-02-15 01:07:23.000000', 'temperatura', 908.0000, 'ºC'),
	(70264, 112, '2015-02-15 01:07:24.000000', 'temperatura', 837.0000, 'ºC'),
	(70265, 112, '2015-02-15 01:07:25.000000', 'temperatura', 261.0000, 'ºC'),
	(70266, 112, '2015-02-15 01:07:26.000000', 'temperatura', 1197.0000, 'ºC'),
	(70267, 112, '2015-02-15 01:07:27.000000', 'temperatura', 402.0000, 'ºC'),
	(70268, 112, '2015-02-15 01:07:28.000000', 'temperatura', 818.0000, 'ºC'),
	(70269, 112, '2015-02-15 01:07:29.000000', 'temperatura', 487.0000, 'ºC'),
	(70270, 112, '2015-02-15 01:07:30.000000', 'temperatura', 1179.0000, 'ºC'),
	(70271, 112, '2015-02-15 01:07:31.000000', 'temperatura', 837.0000, 'ºC'),
	(70272, 112, '2015-02-15 01:07:32.000000', 'temperatura', 648.0000, 'ºC'),
	(70273, 112, '2015-02-15 01:07:33.000000', 'temperatura', 731.0000, 'ºC'),
	(70274, 112, '2015-02-15 01:07:34.000000', 'temperatura', 510.0000, 'ºC'),
	(70275, 112, '2015-02-15 01:07:35.000000', 'temperatura', 356.0000, 'ºC'),
	(70276, 112, '2015-02-15 01:07:36.000000', 'temperatura', 253.0000, 'ºC'),
	(70277, 112, '2015-02-15 01:07:37.000000', 'temperatura', 196.0000, 'ºC'),
	(70278, 112, '2015-02-15 01:07:38.000000', 'temperatura', 223.0000, 'ºC'),
	(70279, 112, '2015-02-15 01:07:39.000000', 'temperatura', 527.0000, 'ºC'),
	(70280, 112, '2015-02-15 01:07:40.000000', 'temperatura', 764.0000, 'ºC'),
	(70281, 112, '2015-02-15 01:07:41.000000', 'temperatura', 1042.0000, 'ºC'),
	(70282, 112, '2015-02-15 01:07:42.000000', 'temperatura', 519.0000, 'ºC'),
	(70283, 112, '2015-02-15 01:07:43.000000', 'temperatura', 670.0000, 'ºC'),
	(70284, 112, '2015-02-15 01:07:44.000000', 'temperatura', 593.0000, 'ºC'),
	(70285, 112, '2015-02-15 01:07:45.000000', 'temperatura', 956.0000, 'ºC'),
	(70286, 112, '2015-02-15 01:07:46.000000', 'temperatura', 601.0000, 'ºC'),
	(70287, 112, '2015-02-15 01:07:47.000000', 'temperatura', 136.0000, 'ºC'),
	(70288, 112, '2015-02-15 01:07:48.000000', 'temperatura', 78.0000, 'ºC'),
	(70289, 112, '2015-02-15 01:07:49.000000', 'temperatura', 1184.0000, 'ºC'),
	(70290, 112, '2015-02-15 01:07:50.000000', 'temperatura', 887.0000, 'ºC'),
	(70291, 112, '2015-02-15 01:07:51.000000', 'temperatura', 881.0000, 'ºC'),
	(70292, 112, '2015-02-15 01:07:52.000000', 'temperatura', 547.0000, 'ºC'),
	(70293, 112, '2015-02-15 01:07:53.000000', 'temperatura', 94.0000, 'ºC'),
	(70294, 112, '2015-02-15 01:07:54.000000', 'temperatura', 26.0000, 'ºC'),
	(70295, 112, '2015-02-15 01:07:55.000000', 'temperatura', 1050.0000, 'ºC'),
	(70296, 112, '2015-02-15 01:07:56.000000', 'temperatura', 371.0000, 'ºC'),
	(70297, 112, '2015-02-15 01:07:57.000000', 'temperatura', 1106.0000, 'ºC'),
	(70298, 112, '2015-02-15 01:07:58.000000', 'temperatura', 817.0000, 'ºC'),
	(70299, 112, '2015-02-15 01:07:59.000000', 'temperatura', 766.0000, 'ºC'),
	(70300, 112, '2015-02-15 01:08:00.000000', 'temperatura', 182.0000, 'ºC'),
	(70301, 112, '2015-02-15 01:08:01.000000', 'temperatura', 1014.0000, 'ºC'),
	(70302, 112, '2015-02-15 01:08:02.000000', 'temperatura', 922.0000, 'ºC'),
	(70303, 112, '2015-02-15 01:08:03.000000', 'temperatura', 368.0000, 'ºC'),
	(70304, 112, '2015-02-15 01:08:04.000000', 'temperatura', 273.0000, 'ºC'),
	(70305, 112, '2015-02-15 01:08:05.000000', 'temperatura', 264.0000, 'ºC'),
	(70306, 112, '2015-02-15 01:08:06.000000', 'temperatura', 502.0000, 'ºC'),
	(70307, 112, '2015-02-15 01:08:07.000000', 'temperatura', 516.0000, 'ºC'),
	(70308, 112, '2015-02-15 01:08:08.000000', 'temperatura', 1074.0000, 'ºC'),
	(70309, 112, '2015-02-15 01:08:09.000000', 'temperatura', 224.0000, 'ºC'),
	(70310, 112, '2015-02-15 01:08:10.000000', 'temperatura', 298.0000, 'ºC'),
	(70311, 112, '2015-02-15 01:08:11.000000', 'temperatura', 818.0000, 'ºC'),
	(70312, 112, '2015-02-15 01:08:12.000000', 'temperatura', 797.0000, 'ºC'),
	(70313, 112, '2015-02-15 01:08:13.000000', 'temperatura', 332.0000, 'ºC'),
	(70314, 112, '2015-02-15 01:08:14.000000', 'temperatura', 468.0000, 'ºC'),
	(70315, 112, '2015-02-15 01:08:15.000000', 'temperatura', 147.0000, 'ºC'),
	(70316, 112, '2015-02-15 01:08:16.000000', 'temperatura', 531.0000, 'ºC'),
	(70317, 112, '2015-02-15 01:08:17.000000', 'temperatura', 1013.0000, 'ºC'),
	(70318, 112, '2015-02-15 01:08:18.000000', 'temperatura', 1073.0000, 'ºC'),
	(70319, 112, '2015-02-15 01:08:19.000000', 'temperatura', 1129.0000, 'ºC'),
	(70320, 112, '2015-02-15 01:08:20.000000', 'temperatura', 23.0000, 'ºC'),
	(70321, 112, '2015-02-15 01:08:21.000000', 'temperatura', 330.0000, 'ºC'),
	(70322, 112, '2015-02-15 01:08:22.000000', 'temperatura', 383.0000, 'ºC'),
	(70323, 112, '2015-02-15 01:08:23.000000', 'temperatura', 925.0000, 'ºC'),
	(70324, 112, '2015-02-15 01:08:24.000000', 'temperatura', 1075.0000, 'ºC'),
	(70325, 112, '2015-02-15 01:08:25.000000', 'temperatura', 201.0000, 'ºC'),
	(70326, 112, '2015-02-15 01:08:26.000000', 'temperatura', 182.0000, 'ºC'),
	(70327, 112, '2015-02-15 01:08:27.000000', 'temperatura', 307.0000, 'ºC'),
	(70328, 112, '2015-02-15 01:08:28.000000', 'temperatura', 989.0000, 'ºC'),
	(70329, 112, '2015-02-15 01:08:29.000000', 'temperatura', 424.0000, 'ºC'),
	(70330, 112, '2015-02-15 01:08:30.000000', 'temperatura', 355.0000, 'ºC'),
	(70331, 112, '2015-02-15 01:08:31.000000', 'temperatura', 503.0000, 'ºC'),
	(70332, 112, '2015-02-15 01:08:32.000000', 'temperatura', 250.0000, 'ºC'),
	(70333, 112, '2015-02-15 01:08:33.000000', 'temperatura', 941.0000, 'ºC'),
	(70334, 112, '2015-02-15 01:08:34.000000', 'temperatura', 355.0000, 'ºC'),
	(70335, 112, '2015-02-15 01:08:35.000000', 'temperatura', 154.0000, 'ºC'),
	(70336, 112, '2015-02-15 01:08:36.000000', 'temperatura', 905.0000, 'ºC'),
	(70337, 112, '2015-02-15 01:08:37.000000', 'temperatura', 463.0000, 'ºC'),
	(70338, 112, '2015-02-15 01:08:38.000000', 'temperatura', 799.0000, 'ºC'),
	(70339, 112, '2015-02-15 01:08:39.000000', 'temperatura', 207.0000, 'ºC'),
	(70340, 112, '2015-02-15 01:08:40.000000', 'temperatura', 1038.0000, 'ºC'),
	(70341, 112, '2015-02-15 01:08:41.000000', 'temperatura', 971.0000, 'ºC'),
	(70342, 112, '2015-02-15 01:08:42.000000', 'temperatura', 542.0000, 'ºC'),
	(70343, 112, '2015-02-15 01:08:43.000000', 'temperatura', 995.0000, 'ºC'),
	(70344, 112, '2015-02-15 01:08:44.000000', 'temperatura', 953.0000, 'ºC'),
	(70345, 112, '2015-02-15 01:08:45.000000', 'temperatura', 578.0000, 'ºC'),
	(70346, 112, '2015-02-15 01:08:46.000000', 'temperatura', 33.0000, 'ºC'),
	(70347, 112, '2015-02-15 01:08:47.000000', 'temperatura', 830.0000, 'ºC'),
	(70348, 112, '2015-02-15 01:08:48.000000', 'temperatura', 451.0000, 'ºC'),
	(70349, 112, '2015-02-15 01:08:49.000000', 'temperatura', 967.0000, 'ºC'),
	(70350, 112, '2015-02-15 01:08:50.000000', 'temperatura', 1084.0000, 'ºC'),
	(70351, 112, '2015-02-15 01:08:51.000000', 'temperatura', 117.0000, 'ºC'),
	(70352, 112, '2015-02-15 01:08:52.000000', 'temperatura', 932.0000, 'ºC'),
	(70353, 112, '2015-02-15 01:08:53.000000', 'temperatura', 713.0000, 'ºC'),
	(70354, 112, '2015-02-15 01:08:54.000000', 'temperatura', 769.0000, 'ºC'),
	(70355, 112, '2015-02-15 01:08:55.000000', 'temperatura', 507.0000, 'ºC'),
	(70356, 112, '2015-02-15 01:08:56.000000', 'temperatura', 226.0000, 'ºC'),
	(70357, 112, '2015-02-15 01:08:57.000000', 'temperatura', 811.0000, 'ºC'),
	(70358, 112, '2015-02-15 01:08:58.000000', 'temperatura', 976.0000, 'ºC'),
	(70359, 112, '2015-02-15 01:08:59.000000', 'temperatura', 48.0000, 'ºC'),
	(70360, 112, '2015-02-15 01:09:00.000000', 'temperatura', 914.0000, 'ºC'),
	(70361, 112, '2015-02-15 01:09:01.000000', 'temperatura', 825.0000, 'ºC'),
	(70362, 112, '2015-02-15 01:09:02.000000', 'temperatura', 184.0000, 'ºC'),
	(70363, 112, '2015-02-15 01:09:03.000000', 'temperatura', 844.0000, 'ºC'),
	(70364, 112, '2015-02-15 01:09:04.000000', 'temperatura', 68.0000, 'ºC'),
	(70365, 112, '2015-02-15 01:09:05.000000', 'temperatura', 212.0000, 'ºC'),
	(70366, 112, '2015-02-15 01:09:06.000000', 'temperatura', 853.0000, 'ºC'),
	(70367, 112, '2015-02-15 01:09:07.000000', 'temperatura', 30.0000, 'ºC'),
	(70368, 112, '2015-02-15 01:09:08.000000', 'temperatura', 1193.0000, 'ºC'),
	(70369, 112, '2015-02-15 01:09:09.000000', 'temperatura', 1075.0000, 'ºC'),
	(70370, 112, '2015-02-15 01:09:10.000000', 'temperatura', 598.0000, 'ºC'),
	(70371, 112, '2015-02-15 01:09:11.000000', 'temperatura', 964.0000, 'ºC'),
	(70372, 112, '2015-02-15 01:09:12.000000', 'temperatura', 625.0000, 'ºC'),
	(70373, 112, '2015-02-15 01:09:13.000000', 'temperatura', 236.0000, 'ºC'),
	(70374, 112, '2015-02-15 01:09:14.000000', 'temperatura', 504.0000, 'ºC'),
	(70375, 112, '2015-02-15 01:09:15.000000', 'temperatura', 611.0000, 'ºC'),
	(70376, 112, '2015-02-15 01:09:16.000000', 'temperatura', 345.0000, 'ºC'),
	(70377, 112, '2015-02-15 01:09:17.000000', 'temperatura', 1093.0000, 'ºC'),
	(70378, 112, '2015-02-15 01:09:18.000000', 'temperatura', 830.0000, 'ºC'),
	(70379, 112, '2015-02-15 01:09:19.000000', 'temperatura', 873.0000, 'ºC'),
	(70380, 112, '2015-02-15 01:09:20.000000', 'temperatura', 673.0000, 'ºC'),
	(70381, 112, '2015-02-15 01:09:21.000000', 'temperatura', 749.0000, 'ºC'),
	(70382, 112, '2015-02-15 01:09:22.000000', 'temperatura', 524.0000, 'ºC'),
	(70383, 112, '2015-02-15 01:09:23.000000', 'temperatura', 373.0000, 'ºC'),
	(70384, 112, '2015-02-15 01:09:24.000000', 'temperatura', 296.0000, 'ºC'),
	(70385, 112, '2015-02-15 01:09:25.000000', 'temperatura', 358.0000, 'ºC'),
	(70386, 112, '2015-02-15 01:09:26.000000', 'temperatura', 906.0000, 'ºC'),
	(70387, 112, '2015-02-15 01:09:27.000000', 'temperatura', 1056.0000, 'ºC'),
	(70388, 112, '2015-02-15 01:09:28.000000', 'temperatura', 162.0000, 'ºC'),
	(70389, 112, '2015-02-15 01:09:29.000000', 'temperatura', 44.0000, 'ºC'),
	(70390, 112, '2015-02-15 01:09:30.000000', 'temperatura', 932.0000, 'ºC'),
	(70391, 112, '2015-02-15 01:09:31.000000', 'temperatura', 929.0000, 'ºC'),
	(70392, 112, '2015-02-15 01:09:32.000000', 'temperatura', 648.0000, 'ºC'),
	(70393, 112, '2015-02-15 01:09:33.000000', 'temperatura', 454.0000, 'ºC'),
	(70394, 112, '2015-02-15 01:09:34.000000', 'temperatura', 329.0000, 'ºC'),
	(70395, 112, '2015-02-15 01:09:35.000000', 'temperatura', 281.0000, 'ºC'),
	(70396, 112, '2015-02-15 01:09:36.000000', 'temperatura', 421.0000, 'ºC'),
	(70397, 112, '2015-02-15 01:09:37.000000', 'temperatura', 60.0000, 'ºC'),
	(70398, 112, '2015-02-15 01:09:38.000000', 'temperatura', 239.0000, 'ºC'),
	(70399, 112, '2015-02-15 01:09:39.000000', 'temperatura', 1014.0000, 'ºC'),
	(70400, 112, '2015-02-15 01:09:40.000000', 'temperatura', 756.0000, 'ºC'),
	(70401, 112, '2015-02-15 01:09:41.000000', 'temperatura', 737.0000, 'ºC'),
	(70402, 112, '2015-02-15 01:09:42.000000', 'temperatura', 219.0000, 'ºC'),
	(70403, 112, '2015-02-15 01:09:43.000000', 'temperatura', 83.0000, 'ºC'),
	(70404, 112, '2015-02-15 01:09:44.000000', 'temperatura', 960.0000, 'ºC'),
	(70405, 112, '2015-02-15 01:09:45.000000', 'temperatura', 951.0000, 'ºC'),
	(70406, 112, '2015-02-15 01:09:46.000000', 'temperatura', 676.0000, 'ºC'),
	(70407, 112, '2015-02-15 01:09:47.000000', 'temperatura', 529.0000, 'ºC'),
	(70408, 112, '2015-02-15 01:09:48.000000', 'temperatura', 617.0000, 'ºC'),
	(70409, 112, '2015-02-15 01:09:49.000000', 'temperatura', 296.0000, 'ºC'),
	(70410, 112, '2015-02-15 01:09:50.000000', 'temperatura', 830.0000, 'ºC'),
	(70411, 112, '2015-02-15 01:09:51.000000', 'temperatura', 863.0000, 'ºC'),
	(70412, 112, '2015-02-15 01:09:52.000000', 'temperatura', 626.0000, 'ºC'),
	(70413, 112, '2015-02-15 01:09:53.000000', 'temperatura', 540.0000, 'ºC'),
	(70414, 112, '2015-02-15 01:09:54.000000', 'temperatura', 823.0000, 'ºC'),
	(70415, 112, '2015-02-15 01:09:55.000000', 'temperatura', 94.0000, 'ºC'),
	(70416, 112, '2015-02-15 01:09:56.000000', 'temperatura', 402.0000, 'ºC'),
	(70417, 112, '2015-02-15 01:09:57.000000', 'temperatura', 529.0000, 'ºC'),
	(70418, 112, '2015-02-15 01:09:58.000000', 'temperatura', 239.0000, 'ºC'),
	(70419, 112, '2015-02-15 01:09:59.000000', 'temperatura', 811.0000, 'ºC'),
	(70420, 112, '2015-02-15 01:10:00.000000', 'temperatura', 936.0000, 'ºC'),
	(70421, 112, '2015-02-15 01:10:01.000000', 'temperatura', 1050.0000, 'ºC'),
	(70422, 112, '2015-02-15 01:10:02.000000', 'temperatura', 41.0000, 'ºC'),
	(70423, 112, '2015-02-15 01:10:03.000000', 'temperatura', 657.0000, 'ºC'),
	(70424, 112, '2015-02-15 01:10:04.000000', 'temperatura', 760.0000, 'ºC'),
	(70425, 112, '2015-02-15 01:10:05.000000', 'temperatura', 631.0000, 'ºC'),
	(70426, 112, '2015-02-15 01:10:06.000000', 'temperatura', 875.0000, 'ºC'),
	(70427, 112, '2015-02-15 01:10:07.000000', 'temperatura', 81.0000, 'ºC'),
	(70428, 112, '2015-02-15 01:10:08.000000', 'temperatura', 182.0000, 'ºC'),
	(70429, 112, '2015-02-15 01:10:09.000000', 'temperatura', 667.0000, 'ºC'),
	(70430, 112, '2015-02-15 01:10:10.000000', 'temperatura', 389.0000, 'ºC'),
	(70431, 112, '2015-02-15 01:10:11.000000', 'temperatura', 1147.0000, 'ºC'),
	(70432, 112, '2015-02-15 01:10:12.000000', 'temperatura', 966.0000, 'ºC'),
	(70433, 112, '2015-02-15 01:10:13.000000', 'temperatura', 192.0000, 'ºC'),
	(70434, 112, '2015-02-15 01:10:14.000000', 'temperatura', 463.0000, 'ºC'),
	(70435, 112, '2015-02-15 01:10:15.000000', 'temperatura', 538.0000, 'ºC'),
	(70436, 112, '2015-02-15 01:10:16.000000', 'temperatura', 100.0000, 'ºC'),
	(70437, 112, '2015-02-15 01:10:17.000000', 'temperatura', 89.0000, 'ºC'),
	(70438, 112, '2015-02-15 01:10:18.000000', 'temperatura', 145.0000, 'ºC'),
	(70439, 112, '2015-02-15 01:10:19.000000', 'temperatura', 456.0000, 'ºC'),
	(70440, 112, '2015-02-15 01:10:20.000000', 'temperatura', 648.0000, 'ºC'),
	(70441, 112, '2015-02-15 01:10:21.000000', 'temperatura', 670.0000, 'ºC'),
	(70442, 112, '2015-02-15 01:10:22.000000', 'temperatura', 207.0000, 'ºC'),
	(70443, 112, '2015-02-15 01:10:23.000000', 'temperatura', 227.0000, 'ºC'),
	(70444, 112, '2015-02-15 01:10:24.000000', 'temperatura', 514.0000, 'ºC'),
	(70445, 112, '2015-02-15 01:10:25.000000', 'temperatura', 688.0000, 'ºC'),
	(70446, 112, '2015-02-15 01:10:26.000000', 'temperatura', 700.0000, 'ºC'),
	(70447, 112, '2015-02-15 01:10:27.000000', 'temperatura', 236.0000, 'ºC'),
	(70448, 112, '2015-02-15 01:10:28.000000', 'temperatura', 282.0000, 'ºC'),
	(70449, 112, '2015-02-15 01:10:29.000000', 'temperatura', 700.0000, 'ºC'),
	(70450, 112, '2015-02-15 01:10:30.000000', 'temperatura', 254.0000, 'ºC'),
	(70451, 112, '2015-02-15 01:10:31.000000', 'temperatura', 373.0000, 'ºC'),
	(70452, 112, '2015-02-15 01:10:32.000000', 'temperatura', 1101.0000, 'ºC'),
	(70453, 112, '2015-02-15 01:10:33.000000', 'temperatura', 788.0000, 'ºC'),
	(70454, 112, '2015-02-15 01:10:34.000000', 'temperatura', 635.0000, 'ºC'),
	(70455, 112, '2015-02-15 01:10:35.000000', 'temperatura', 814.0000, 'ºC'),
	(70456, 112, '2015-02-15 01:10:36.000000', 'temperatura', 966.0000, 'ºC'),
	(70457, 112, '2015-02-15 01:10:37.000000', 'temperatura', 1188.0000, 'ºC'),
	(70458, 112, '2015-02-15 01:10:38.000000', 'temperatura', 643.0000, 'ºC'),
	(70459, 112, '2015-02-15 01:10:39.000000', 'temperatura', 852.0000, 'ºC'),
	(70460, 112, '2015-02-15 01:10:40.000000', 'temperatura', 1129.0000, 'ºC'),
	(70461, 112, '2015-02-15 01:10:41.000000', 'temperatura', 690.0000, 'ºC'),
	(70462, 112, '2015-02-15 01:10:42.000000', 'temperatura', 65.0000, 'ºC'),
	(70463, 112, '2015-02-15 01:10:43.000000', 'temperatura', 653.0000, 'ºC'),
	(70464, 112, '2015-02-15 01:10:44.000000', 'temperatura', 673.0000, 'ºC'),
	(70465, 112, '2015-02-15 01:10:45.000000', 'temperatura', 207.0000, 'ºC'),
	(70466, 112, '2015-02-15 01:10:46.000000', 'temperatura', 214.0000, 'ºC'),
	(70467, 112, '2015-02-15 01:10:47.000000', 'temperatura', 451.0000, 'ºC'),
	(70468, 112, '2015-02-15 01:10:48.000000', 'temperatura', 415.0000, 'ºC'),
	(70469, 112, '2015-02-15 01:10:49.000000', 'temperatura', 723.0000, 'ºC'),
	(70470, 112, '2015-02-15 01:10:50.000000', 'temperatura', 1168.0000, 'ºC'),
	(70471, 112, '2015-02-15 01:10:51.000000', 'temperatura', 71.0000, 'ºC'),
	(70472, 112, '2015-02-15 01:10:52.000000', 'temperatura', 453.0000, 'ºC'),
	(70473, 112, '2015-02-15 01:10:53.000000', 'temperatura', 851.0000, 'ºC'),
	(70474, 112, '2015-02-15 01:10:54.000000', 'temperatura', 498.0000, 'ºC'),
	(70475, 112, '2015-02-15 01:10:55.000000', 'temperatura', 1138.0000, 'ºC'),
	(70476, 112, '2015-02-15 01:10:56.000000', 'temperatura', 595.0000, 'ºC'),
	(70477, 112, '2015-02-15 01:10:57.000000', 'temperatura', 761.0000, 'ºC'),
	(70478, 112, '2015-02-15 01:10:58.000000', 'temperatura', 823.0000, 'ºC'),
	(70479, 112, '2015-02-15 01:10:59.000000', 'temperatura', 630.0000, 'ºC'),
	(70480, 112, '2015-02-15 01:11:00.000000', 'temperatura', 684.0000, 'ºC'),
	(70481, 112, '2015-02-15 01:11:01.000000', 'temperatura', 331.0000, 'ºC'),
	(70482, 112, '2015-02-15 01:11:02.000000', 'temperatura', 803.0000, 'ºC'),
	(70483, 112, '2015-02-15 01:11:03.000000', 'temperatura', 620.0000, 'ºC'),
	(70484, 112, '2015-02-15 01:11:04.000000', 'temperatura', 693.0000, 'ºC'),
	(70485, 112, '2015-02-15 01:11:05.000000', 'temperatura', 407.0000, 'ºC'),
	(70486, 112, '2015-02-15 01:11:06.000000', 'temperatura', 1156.0000, 'ºC'),
	(70487, 112, '2015-02-15 01:11:07.000000', 'temperatura', 959.0000, 'ºC'),
	(70488, 112, '2015-02-15 01:11:08.000000', 'temperatura', 126.0000, 'ºC'),
	(70489, 112, '2015-02-15 01:11:09.000000', 'temperatura', 155.0000, 'ºC'),
	(70490, 112, '2015-02-15 01:11:10.000000', 'temperatura', 399.0000, 'ºC'),
	(70491, 112, '2015-02-15 01:11:11.000000', 'temperatura', 330.0000, 'ºC'),
	(70492, 112, '2015-02-15 01:11:12.000000', 'temperatura', 455.0000, 'ºC'),
	(70493, 112, '2015-02-15 01:11:13.000000', 'temperatura', 84.0000, 'ºC'),
	(70494, 112, '2015-02-15 01:11:14.000000', 'temperatura', 258.0000, 'ºC'),
	(70495, 112, '2015-02-15 01:11:15.000000', 'temperatura', 1035.0000, 'ºC'),
	(70496, 112, '2015-02-15 01:11:16.000000', 'temperatura', 803.0000, 'ºC'),
	(70497, 112, '2015-02-15 01:11:17.000000', 'temperatura', 911.0000, 'ºC'),
	(70498, 112, '2015-02-15 01:11:18.000000', 'temperatura', 944.0000, 'ºC'),
	(70499, 112, '2015-02-15 01:11:19.000000', 'temperatura', 789.0000, 'ºC'),
	(70500, 112, '2015-02-15 01:11:20.000000', 'temperatura', 1112.0000, 'ºC'),
	(70501, 112, '2015-02-15 01:11:21.000000', 'temperatura', 795.0000, 'ºC'),
	(70502, 112, '2015-02-15 01:11:22.000000', 'temperatura', 640.0000, 'ºC'),
	(70503, 112, '2015-02-15 01:11:23.000000', 'temperatura', 814.0000, 'ºC'),
	(70504, 112, '2015-02-15 01:11:24.000000', 'temperatura', 950.0000, 'ºC'),
	(70505, 112, '2015-02-15 01:11:25.000000', 'temperatura', 1110.0000, 'ºC'),
	(70506, 112, '2015-02-15 01:11:26.000000', 'temperatura', 302.0000, 'ºC'),
	(70507, 112, '2015-02-15 01:11:27.000000', 'temperatura', 577.0000, 'ºC'),
	(70508, 112, '2015-02-15 01:11:28.000000', 'temperatura', 783.0000, 'ºC'),
	(70509, 112, '2015-02-15 01:11:29.000000', 'temperatura', 983.0000, 'ºC'),
	(70510, 112, '2015-02-15 01:11:30.000000', 'temperatura', 169.0000, 'ºC'),
	(70511, 112, '2015-02-15 01:11:31.000000', 'temperatura', 293.0000, 'ºC'),
	(70512, 112, '2015-02-15 01:11:32.000000', 'temperatura', 961.0000, 'ºC'),
	(70513, 112, '2015-02-15 01:11:33.000000', 'temperatura', 324.0000, 'ºC'),
	(70514, 112, '2015-02-15 01:11:34.000000', 'temperatura', 1139.0000, 'ºC'),
	(70515, 112, '2015-02-15 01:11:35.000000', 'temperatura', 1122.0000, 'ºC'),
	(70516, 112, '2015-02-15 01:11:36.000000', 'temperatura', 995.0000, 'ºC'),
	(70517, 112, '2015-02-15 01:11:37.000000', 'temperatura', 410.0000, 'ºC'),
	(70518, 112, '2015-02-15 01:11:38.000000', 'temperatura', 263.0000, 'ºC'),
	(70519, 112, '2015-02-15 01:11:39.000000', 'temperatura', 86.0000, 'ºC'),
	(70520, 112, '2015-02-15 01:11:40.000000', 'temperatura', 843.0000, 'ºC'),
	(70521, 112, '2015-02-15 01:11:41.000000', 'temperatura', 358.0000, 'ºC'),
	(70522, 112, '2015-02-15 01:11:42.000000', 'temperatura', 460.0000, 'ºC'),
	(70523, 112, '2015-02-15 01:11:43.000000', 'temperatura', 25.0000, 'ºC'),
	(70524, 112, '2015-02-15 01:11:44.000000', 'temperatura', 1147.0000, 'ºC'),
	(70525, 112, '2015-02-15 01:11:45.000000', 'temperatura', 859.0000, 'ºC'),
	(70526, 112, '2015-02-15 01:11:46.000000', 'temperatura', 855.0000, 'ºC'),
	(70527, 112, '2015-02-15 01:11:47.000000', 'temperatura', 498.0000, 'ºC'),
	(70528, 112, '2015-02-15 01:11:48.000000', 'temperatura', 1126.0000, 'ºC'),
	(70529, 112, '2015-02-15 01:11:49.000000', 'temperatura', 537.0000, 'ºC'),
	(70530, 112, '2015-02-15 01:11:50.000000', 'temperatura', 508.0000, 'ºC'),
	(70531, 112, '2015-02-15 01:11:51.000000', 'temperatura', 930.0000, 'ºC'),
	(70532, 112, '2015-02-15 01:11:52.000000', 'temperatura', 727.0000, 'ºC'),
	(70533, 112, '2015-02-15 01:11:53.000000', 'temperatura', 844.0000, 'ºC'),
	(70534, 112, '2015-02-15 01:11:54.000000', 'temperatura', 840.0000, 'ºC'),
	(70535, 112, '2015-02-15 01:11:55.000000', 'temperatura', 470.0000, 'ºC'),
	(70536, 112, '2015-02-15 01:11:56.000000', 'temperatura', 1031.0000, 'ºC'),
	(70537, 112, '2015-02-15 01:11:57.000000', 'temperatura', 146.0000, 'ºC'),
	(70538, 112, '2015-02-15 01:11:58.000000', 'temperatura', 35.0000, 'ºC'),
	(70539, 112, '2015-02-15 01:11:59.000000', 'temperatura', 937.0000, 'ºC'),
	(70540, 112, '2015-02-15 01:12:00.000000', 'temperatura', 980.0000, 'ºC'),
	(70541, 112, '2015-02-15 01:12:01.000000', 'temperatura', 890.0000, 'ºC'),
	(70542, 112, '2015-02-15 01:12:02.000000', 'temperatura', 312.0000, 'ºC'),
	(70543, 112, '2015-02-15 01:12:03.000000', 'temperatura', 92.0000, 'ºC'),
	(70544, 112, '2015-02-15 01:12:04.000000', 'temperatura', 721.0000, 'ºC'),
	(70545, 112, '2015-02-15 01:12:05.000000', 'temperatura', 931.0000, 'ºC'),
	(70546, 112, '2015-02-15 01:12:06.000000', 'temperatura', 93.0000, 'ºC'),
	(70547, 112, '2015-02-15 01:12:07.000000', 'temperatura', 74.0000, 'ºC'),
	(70548, 112, '2015-02-15 01:12:08.000000', 'temperatura', 89.0000, 'ºC'),
	(70549, 112, '2015-02-15 01:12:09.000000', 'temperatura', 225.0000, 'ºC'),
	(70550, 112, '2015-02-15 01:12:10.000000', 'temperatura', 859.0000, 'ºC'),
	(70551, 112, '2015-02-15 01:12:11.000000', 'temperatura', 18.0000, 'ºC'),
	(70552, 112, '2015-02-15 01:12:12.000000', 'temperatura', 1117.0000, 'ºC'),
	(70553, 112, '2015-02-15 01:12:13.000000', 'temperatura', 729.0000, 'ºC'),
	(70554, 112, '2015-02-15 01:12:14.000000', 'temperatura', 294.0000, 'ºC'),
	(70555, 112, '2015-02-15 01:12:15.000000', 'temperatura', 483.0000, 'ºC'),
	(70556, 112, '2015-02-15 01:12:16.000000', 'temperatura', 333.0000, 'ºC'),
	(70557, 112, '2015-02-15 01:12:17.000000', 'temperatura', 218.0000, 'ºC'),
	(70558, 112, '2015-02-15 01:12:18.000000', 'temperatura', 90.0000, 'ºC'),
	(70559, 112, '2015-02-15 01:12:19.000000', 'temperatura', 999.0000, 'ºC'),
	(70560, 112, '2015-02-15 01:12:20.000000', 'temperatura', 1122.0000, 'ºC'),
	(70561, 112, '2015-02-15 01:12:21.000000', 'temperatura', 216.0000, 'ºC'),
	(70562, 112, '2015-02-15 01:12:22.000000', 'temperatura', 115.0000, 'ºC'),
	(70563, 112, '2015-02-15 01:12:23.000000', 'temperatura', 1125.0000, 'ºC'),
	(70564, 112, '2015-02-15 01:12:24.000000', 'temperatura', 483.0000, 'ºC'),
	(70565, 112, '2015-02-15 01:12:25.000000', 'temperatura', 238.0000, 'ºC'),
	(70566, 112, '2015-02-15 01:12:26.000000', 'temperatura', 945.0000, 'ºC'),
	(70567, 112, '2015-02-15 01:12:27.000000', 'temperatura', 409.0000, 'ºC'),
	(70568, 112, '2015-02-15 01:12:28.000000', 'temperatura', 409.0000, 'ºC'),
	(70569, 112, '2015-02-15 01:12:29.000000', 'temperatura', 821.0000, 'ºC'),
	(70570, 112, '2015-02-15 01:12:30.000000', 'temperatura', 479.0000, 'ºC'),
	(70571, 112, '2015-02-15 01:12:31.000000', 'temperatura', 1133.0000, 'ºC'),
	(70572, 112, '2015-02-15 01:12:32.000000', 'temperatura', 629.0000, 'ºC'),
	(70573, 112, '2015-02-15 01:12:33.000000', 'temperatura', 944.0000, 'ºC'),
	(70574, 112, '2015-02-15 01:12:34.000000', 'temperatura', 435.0000, 'ºC'),
	(70575, 112, '2015-02-15 01:12:35.000000', 'temperatura', 542.0000, 'ºC'),
	(70576, 112, '2015-02-15 01:12:36.000000', 'temperatura', 208.0000, 'ºC'),
	(70577, 112, '2015-02-15 01:12:37.000000', 'temperatura', 613.0000, 'ºC'),
	(70578, 112, '2015-02-15 01:12:38.000000', 'temperatura', 43.0000, 'ºC'),
	(70579, 112, '2015-02-15 01:12:39.000000', 'temperatura', 774.0000, 'ºC'),
	(70580, 112, '2015-02-15 01:12:40.000000', 'temperatura', 141.0000, 'ºC'),
	(70581, 112, '2015-02-15 01:12:41.000000', 'temperatura', 785.0000, 'ºC'),
	(70582, 112, '2015-02-15 01:12:42.000000', 'temperatura', 1100.0000, 'ºC'),
	(70583, 112, '2015-02-15 01:12:43.000000', 'temperatura', 748.0000, 'ºC'),
	(70584, 112, '2015-02-15 01:12:44.000000', 'temperatura', 441.0000, 'ºC'),
	(70585, 112, '2015-02-15 01:12:45.000000', 'temperatura', 1163.0000, 'ºC'),
	(70586, 112, '2015-02-15 01:12:46.000000', 'temperatura', 889.0000, 'ºC'),
	(70587, 112, '2015-02-15 01:12:47.000000', 'temperatura', 957.0000, 'ºC'),
	(70588, 112, '2015-02-15 01:12:48.000000', 'temperatura', 921.0000, 'ºC'),
	(70589, 112, '2015-02-15 01:12:49.000000', 'temperatura', 532.0000, 'ºC'),
	(70590, 112, '2015-02-15 01:12:50.000000', 'temperatura', 1099.0000, 'ºC'),
	(70591, 112, '2015-02-15 01:12:51.000000', 'temperatura', 301.0000, 'ºC'),
	(70592, 112, '2015-02-15 01:12:52.000000', 'temperatura', 607.0000, 'ºC'),
	(70593, 112, '2015-02-15 01:12:53.000000', 'temperatura', 931.0000, 'ºC'),
	(70594, 112, '2015-02-15 01:12:54.000000', 'temperatura', 436.0000, 'ºC'),
	(70595, 112, '2015-02-15 01:12:55.000000', 'temperatura', 585.0000, 'ºC'),
	(70596, 112, '2015-02-15 01:12:56.000000', 'temperatura', 420.0000, 'ºC'),
	(70597, 112, '2015-02-15 01:12:57.000000', 'temperatura', 344.0000, 'ºC'),
	(70598, 112, '2015-02-15 01:12:58.000000', 'temperatura', 462.0000, 'ºC'),
	(70599, 112, '2015-02-15 01:12:59.000000', 'temperatura', 79.0000, 'ºC'),
	(70600, 112, '2015-02-15 01:13:00.000000', 'temperatura', 210.0000, 'ºC'),
	(70601, 112, '2015-02-15 01:13:01.000000', 'temperatura', 811.0000, 'ºC'),
	(70602, 112, '2015-02-15 01:13:02.000000', 'temperatura', 1026.0000, 'ºC'),
	(70603, 112, '2015-02-15 01:13:03.000000', 'temperatura', 298.0000, 'ºC'),
	(70604, 112, '2015-02-15 01:13:04.000000', 'temperatura', 812.0000, 'ºC'),
	(70605, 112, '2015-02-15 01:13:05.000000', 'temperatura', 768.0000, 'ºC'),
	(70606, 112, '2015-02-15 01:13:06.000000', 'temperatura', 204.0000, 'ºC'),
	(70607, 112, '2015-02-15 01:13:07.000000', 'temperatura', 1117.0000, 'ºC'),
	(70608, 112, '2015-02-15 01:13:08.000000', 'temperatura', 173.0000, 'ºC'),
	(70609, 112, '2015-02-15 01:13:09.000000', 'temperatura', 1114.0000, 'ºC'),
	(70610, 112, '2015-02-15 01:13:10.000000', 'temperatura', 250.0000, 'ºC'),
	(70611, 112, '2015-02-15 01:13:11.000000', 'temperatura', 312.0000, 'ºC'),
	(70612, 112, '2015-02-15 01:13:12.000000', 'temperatura', 808.0000, 'ºC'),
	(70613, 112, '2015-02-15 01:13:13.000000', 'temperatura', 703.0000, 'ºC'),
	(70614, 112, '2015-02-15 01:13:14.000000', 'temperatura', 1095.0000, 'ºC'),
	(70615, 112, '2015-02-15 01:13:15.000000', 'temperatura', 963.0000, 'ºC'),
	(70616, 112, '2015-02-15 01:13:16.000000', 'temperatura', 333.0000, 'ºC'),
	(70617, 112, '2015-02-15 01:13:17.000000', 'temperatura', 1175.0000, 'ºC'),
	(70618, 112, '2015-02-15 01:13:18.000000', 'temperatura', 75.0000, 'ºC'),
	(70619, 112, '2015-02-15 01:13:19.000000', 'temperatura', 452.0000, 'ºC'),
	(70620, 112, '2015-02-15 01:13:20.000000', 'temperatura', 834.0000, 'ºC'),
	(70621, 112, '2015-02-15 01:13:21.000000', 'temperatura', 414.0000, 'ºC'),
	(70622, 112, '2015-02-15 01:13:22.000000', 'temperatura', 771.0000, 'ºC'),
	(70623, 112, '2015-02-15 01:13:23.000000', 'temperatura', 212.0000, 'ºC'),
	(70624, 112, '2015-02-15 01:13:24.000000', 'temperatura', 1147.0000, 'ºC'),
	(70625, 112, '2015-02-15 01:13:25.000000', 'temperatura', 300.0000, 'ºC'),
	(70626, 112, '2015-02-15 01:13:26.000000', 'temperatura', 459.0000, 'ºC'),
	(70627, 112, '2015-02-15 01:13:27.000000', 'temperatura', 198.0000, 'ºC'),
	(70628, 112, '2015-02-15 01:13:28.000000', 'temperatura', 812.0000, 'ºC'),
	(70629, 112, '2015-02-15 01:13:29.000000', 'temperatura', 1065.0000, 'ºC'),
	(70630, 112, '2015-02-15 01:13:30.000000', 'temperatura', 492.0000, 'ºC'),
	(70631, 112, '2015-02-15 01:13:31.000000', 'temperatura', 464.0000, 'ºC'),
	(70632, 112, '2015-02-15 01:13:32.000000', 'temperatura', 845.0000, 'ºC'),
	(70633, 112, '2015-02-15 01:13:33.000000', 'temperatura', 435.0000, 'ºC'),
	(70634, 112, '2015-02-15 01:13:34.000000', 'temperatura', 839.0000, 'ºC'),
	(70635, 112, '2015-02-15 01:13:35.000000', 'temperatura', 490.0000, 'ºC'),
	(70636, 112, '2015-02-15 01:13:36.000000', 'temperatura', 1134.0000, 'ºC'),
	(70637, 112, '2015-02-15 01:13:37.000000', 'temperatura', 602.0000, 'ºC'),
	(70638, 112, '2015-02-15 01:13:38.000000', 'temperatura', 806.0000, 'ºC'),
	(70639, 112, '2015-02-15 01:13:39.000000', 'temperatura', 1025.0000, 'ºC'),
	(70640, 112, '2015-02-15 01:13:40.000000', 'temperatura', 308.0000, 'ºC'),
	(70641, 112, '2015-02-15 01:13:41.000000', 'temperatura', 866.0000, 'ºC'),
	(70642, 112, '2015-02-15 01:13:42.000000', 'temperatura', 1007.0000, 'ºC'),
	(70643, 112, '2015-02-15 01:13:43.000000', 'temperatura', 36.0000, 'ºC'),
	(70644, 112, '2015-02-15 01:13:44.000000', 'temperatura', 758.0000, 'ºC'),
	(70645, 112, '2015-02-15 01:13:45.000000', 'temperatura', 85.0000, 'ºC'),
	(70646, 112, '2015-02-15 01:13:46.000000', 'temperatura', 551.0000, 'ºC'),
	(70647, 112, '2015-02-15 01:13:47.000000', 'temperatura', 102.0000, 'ºC'),
	(70648, 112, '2015-02-15 01:13:48.000000', 'temperatura', 56.0000, 'ºC'),
	(70649, 112, '2015-02-15 01:13:49.000000', 'temperatura', 1174.0000, 'ºC'),
	(70650, 112, '2015-02-15 01:13:50.000000', 'temperatura', 902.0000, 'ºC'),
	(70651, 112, '2015-02-15 01:13:51.000000', 'temperatura', 987.0000, 'ºC'),
	(70652, 112, '2015-02-15 01:13:52.000000', 'temperatura', 1031.0000, 'ºC'),
	(70653, 112, '2015-02-15 01:13:53.000000', 'temperatura', 996.0000, 'ºC'),
	(70654, 112, '2015-02-15 01:13:54.000000', 'temperatura', 688.0000, 'ºC'),
	(70655, 112, '2015-02-15 01:13:55.000000', 'temperatura', 450.0000, 'ºC'),
	(70656, 112, '2015-02-15 01:13:56.000000', 'temperatura', 188.0000, 'ºC'),
	(70657, 112, '2015-02-15 01:13:57.000000', 'temperatura', 791.0000, 'ºC'),
	(70658, 112, '2015-02-15 01:13:58.000000', 'temperatura', 992.0000, 'ºC'),
	(70659, 112, '2015-02-15 01:13:59.000000', 'temperatura', 186.0000, 'ºC'),
	(70660, 112, '2015-02-15 01:14:00.000000', 'temperatura', 356.0000, 'ºC'),
	(70661, 112, '2015-02-15 01:14:01.000000', 'temperatura', 20.0000, 'ºC'),
	(70662, 112, '2015-02-15 01:14:02.000000', 'temperatura', 233.0000, 'ºC'),
	(70663, 112, '2015-02-15 01:14:03.000000', 'temperatura', 1108.0000, 'ºC'),
	(70664, 112, '2015-02-15 01:14:04.000000', 'temperatura', 39.0000, 'ºC'),
	(70665, 112, '2015-02-15 01:14:05.000000', 'temperatura', 474.0000, 'ºC'),
	(70666, 112, '2015-02-15 01:14:06.000000', 'temperatura', 1052.0000, 'ºC'),
	(70667, 112, '2015-02-15 01:14:07.000000', 'temperatura', 240.0000, 'ºC'),
	(70668, 112, '2015-02-15 01:14:08.000000', 'temperatura', 445.0000, 'ºC'),
	(70669, 112, '2015-02-15 01:14:09.000000', 'temperatura', 304.0000, 'ºC'),
	(70670, 112, '2015-02-15 01:14:10.000000', 'temperatura', 184.0000, 'ºC'),
	(70671, 112, '2015-02-15 01:14:11.000000', 'temperatura', 11.0000, 'ºC'),
	(70672, 112, '2015-02-15 01:14:12.000000', 'temperatura', 704.0000, 'ºC'),
	(70673, 112, '2015-02-15 01:14:13.000000', 'temperatura', 1085.0000, 'ºC'),
	(70674, 112, '2015-02-15 01:14:14.000000', 'temperatura', 913.0000, 'ºC'),
	(70675, 112, '2015-02-15 01:14:15.000000', 'temperatura', 111.0000, 'ºC'),
	(70676, 112, '2015-02-15 01:14:16.000000', 'temperatura', 215.0000, 'ºC'),
	(70677, 112, '2015-02-15 01:14:17.000000', 'temperatura', 743.0000, 'ºC'),
	(70678, 112, '2015-02-15 01:14:18.000000', 'temperatura', 671.0000, 'ºC'),
	(70679, 112, '2015-02-15 01:14:19.000000', 'temperatura', 1125.0000, 'ºC'),
	(70680, 112, '2015-02-15 01:14:20.000000', 'temperatura', 14.0000, 'ºC'),
	(70681, 112, '2015-02-15 01:14:21.000000', 'temperatura', 294.0000, 'ºC'),
	(70682, 112, '2015-02-15 01:14:22.000000', 'temperatura', 231.0000, 'ºC'),
	(70683, 112, '2015-02-15 01:14:23.000000', 'temperatura', 270.0000, 'ºC'),
	(70684, 112, '2015-02-15 01:14:24.000000', 'temperatura', 661.0000, 'ºC'),
	(70685, 112, '2015-02-15 01:14:25.000000', 'temperatura', 94.0000, 'ºC'),
	(70686, 112, '2015-02-15 01:14:26.000000', 'temperatura', 888.0000, 'ºC'),
	(70687, 112, '2015-02-15 01:14:27.000000', 'temperatura', 558.0000, 'ºC'),
	(70688, 112, '2015-02-15 01:14:28.000000', 'temperatura', 126.0000, 'ºC'),
	(70689, 112, '2015-02-15 01:14:29.000000', 'temperatura', 156.0000, 'ºC'),
	(70690, 112, '2015-02-15 01:14:30.000000', 'temperatura', 401.0000, 'ºC'),
	(70691, 112, '2015-02-15 01:14:31.000000', 'temperatura', 340.0000, 'ºC'),
	(70692, 112, '2015-02-15 01:14:32.000000', 'temperatura', 495.0000, 'ºC'),
	(70693, 112, '2015-02-15 01:14:33.000000', 'temperatura', 257.0000, 'ºC'),
	(70694, 112, '2015-02-15 01:14:34.000000', 'temperatura', 999.0000, 'ºC'),
	(70695, 112, '2015-02-15 01:14:35.000000', 'temperatura', 624.0000, 'ºC'),
	(70696, 112, '2015-02-15 01:14:36.000000', 'temperatura', 126.0000, 'ºC'),
	(70697, 112, '2015-02-15 01:14:37.000000', 'temperatura', 1157.0000, 'ºC'),
	(70698, 112, '2015-02-15 01:14:38.000000', 'temperatura', 606.0000, 'ºC'),
	(70699, 112, '2015-02-15 01:14:39.000000', 'temperatura', 760.0000, 'ºC'),
	(70700, 112, '2015-02-15 01:14:40.000000', 'temperatura', 785.0000, 'ºC'),
	(70701, 112, '2015-02-15 01:14:41.000000', 'temperatura', 443.0000, 'ºC'),
	(70702, 112, '2015-02-15 01:14:42.000000', 'temperatura', 1063.0000, 'ºC'),
	(70703, 112, '2015-02-15 01:14:43.000000', 'temperatura', 383.0000, 'ºC'),
	(70704, 112, '2015-02-15 01:14:44.000000', 'temperatura', 1130.0000, 'ºC'),
	(70705, 112, '2015-02-15 01:14:45.000000', 'temperatura', 900.0000, 'ºC'),
	(70706, 112, '2015-02-15 01:14:46.000000', 'temperatura', 1110.0000, 'ºC'),
	(70707, 112, '2015-02-15 01:14:47.000000', 'temperatura', 451.0000, 'ºC'),
	(70708, 112, '2015-02-15 01:14:48.000000', 'temperatura', 126.0000, 'ºC'),
	(70709, 112, '2015-02-15 01:14:49.000000', 'temperatura', 476.0000, 'ºC'),
	(70710, 112, '2015-02-15 01:14:50.000000', 'temperatura', 805.0000, 'ºC'),
	(70711, 112, '2015-02-15 01:14:51.000000', 'temperatura', 195.0000, 'ºC'),
	(70712, 112, '2015-02-15 01:14:52.000000', 'temperatura', 960.0000, 'ºC'),
	(70713, 112, '2015-02-15 01:14:53.000000', 'temperatura', 615.0000, 'ºC'),
	(70714, 112, '2015-02-15 01:14:54.000000', 'temperatura', 196.0000, 'ºC'),
	(70715, 112, '2015-02-15 01:14:55.000000', 'temperatura', 335.0000, 'ºC'),
	(70716, 112, '2015-02-15 01:14:56.000000', 'temperatura', 1089.0000, 'ºC'),
	(70717, 112, '2015-02-15 01:14:57.000000', 'temperatura', 841.0000, 'ºC'),
	(70718, 112, '2015-02-15 01:14:58.000000', 'temperatura', 937.0000, 'ºC'),
	(70719, 112, '2015-02-15 01:14:59.000000', 'temperatura', 964.0000, 'ºC'),
	(70720, 112, '2015-02-15 01:15:00.000000', 'temperatura', 811.0000, 'ºC'),
	(70721, 112, '2015-02-15 01:15:01.000000', 'temperatura', 1161.0000, 'ºC'),
	(70722, 112, '2015-02-15 01:15:02.000000', 'temperatura', 972.0000, 'ºC'),
	(70723, 112, '2015-02-15 01:15:03.000000', 'temperatura', 180.0000, 'ºC'),
	(70724, 112, '2015-02-15 01:15:04.000000', 'temperatura', 382.0000, 'ºC'),
	(70725, 112, '2015-02-15 01:15:05.000000', 'temperatura', 173.0000, 'ºC'),
	(70726, 112, '2015-02-15 01:15:06.000000', 'temperatura', 920.0000, 'ºC'),
	(70727, 112, '2015-02-15 01:15:07.000000', 'temperatura', 481.0000, 'ºC'),
	(70728, 112, '2015-02-15 01:15:08.000000', 'temperatura', 845.0000, 'ºC'),
	(70729, 112, '2015-02-15 01:15:09.000000', 'temperatura', 382.0000, 'ºC'),
	(70730, 112, '2015-02-15 01:15:10.000000', 'temperatura', 575.0000, 'ºC'),
	(70731, 112, '2015-02-15 01:15:11.000000', 'temperatura', 532.0000, 'ºC'),
	(70732, 112, '2015-02-15 01:15:12.000000', 'temperatura', 933.0000, 'ºC'),
	(70733, 112, '2015-02-15 01:15:13.000000', 'temperatura', 669.0000, 'ºC'),
	(70734, 112, '2015-02-15 01:15:14.000000', 'temperatura', 547.0000, 'ºC'),
	(70735, 112, '2015-02-15 01:15:15.000000', 'temperatura', 727.0000, 'ºC'),
	(70736, 112, '2015-02-15 01:15:16.000000', 'temperatura', 797.0000, 'ºC'),
	(70737, 112, '2015-02-15 01:15:17.000000', 'temperatura', 603.0000, 'ºC'),
	(70738, 112, '2015-02-15 01:15:18.000000', 'temperatura', 624.0000, 'ºC'),
	(70739, 112, '2015-02-15 01:15:19.000000', 'temperatura', 111.0000, 'ºC'),
	(70740, 112, '2015-02-15 01:15:20.000000', 'temperatura', 1086.0000, 'ºC'),
	(70741, 112, '2015-02-15 01:15:21.000000', 'temperatura', 296.0000, 'ºC'),
	(70742, 112, '2015-02-15 01:15:22.000000', 'temperatura', 623.0000, 'ºC'),
	(70743, 112, '2015-02-15 01:15:23.000000', 'temperatura', 1026.0000, 'ºC'),
	(70744, 112, '2015-02-15 01:15:24.000000', 'temperatura', 864.0000, 'ºC'),
	(70745, 112, '2015-02-15 01:15:25.000000', 'temperatura', 41.0000, 'ºC'),
	(70746, 112, '2015-02-15 01:15:26.000000', 'temperatura', 16.0000, 'ºC'),
	(70747, 112, '2015-02-15 01:15:27.000000', 'temperatura', 1155.0000, 'ºC'),
	(70748, 112, '2015-02-15 01:15:28.000000', 'temperatura', 928.0000, 'ºC'),
	(70749, 112, '2015-02-15 01:15:29.000000', 'temperatura', 1174.0000, 'ºC'),
	(70750, 112, '2015-02-15 01:15:30.000000', 'temperatura', 689.0000, 'ºC'),
	(70751, 112, '2015-02-15 01:15:31.000000', 'temperatura', 1122.0000, 'ºC'),
	(70752, 112, '2015-02-15 01:15:32.000000', 'temperatura', 1144.0000, 'ºC'),
	(70753, 112, '2015-02-15 01:15:33.000000', 'temperatura', 1155.0000, 'ºC'),
	(70754, 112, '2015-02-15 01:15:34.000000', 'temperatura', 1142.0000, 'ºC'),
	(70755, 112, '2015-02-15 01:15:35.000000', 'temperatura', 1046.0000, 'ºC'),
	(70756, 112, '2015-02-15 01:15:36.000000', 'temperatura', 606.0000, 'ºC'),
	(70757, 112, '2015-02-15 01:15:37.000000', 'temperatura', 1091.0000, 'ºC'),
	(70758, 112, '2015-02-15 01:15:38.000000', 'temperatura', 39.0000, 'ºC'),
	(70759, 112, '2015-02-15 01:15:39.000000', 'temperatura', 524.0000, 'ºC'),
	(70760, 112, '2015-02-15 01:15:40.000000', 'temperatura', 101.0000, 'ºC'),
	(70761, 112, '2015-02-15 01:15:41.000000', 'temperatura', 133.0000, 'ºC'),
	(70762, 112, '2015-02-15 01:15:42.000000', 'temperatura', 364.0000, 'ºC'),
	(70763, 112, '2015-02-15 01:15:43.000000', 'temperatura', 220.0000, 'ºC'),
	(70764, 112, '2015-02-15 01:15:44.000000', 'temperatura', 10.0000, 'ºC'),
	(70765, 112, '2015-02-15 01:15:45.000000', 'temperatura', 590.0000, 'ºC'),
	(70766, 112, '2015-02-15 01:15:46.000000', 'temperatura', 519.0000, 'ºC'),
	(70767, 112, '2015-02-15 01:15:47.000000', 'temperatura', 828.0000, 'ºC'),
	(70768, 112, '2015-02-15 01:15:48.000000', 'temperatura', 184.0000, 'ºC'),
	(70769, 112, '2015-02-15 01:15:49.000000', 'temperatura', 834.0000, 'ºC'),
	(70770, 112, '2015-02-15 01:15:50.000000', 'temperatura', 21.0000, 'ºC'),
	(70771, 112, '2015-02-15 01:15:51.000000', 'temperatura', 3.0000, 'ºC'),
	(70772, 112, '2015-02-15 01:15:52.000000', 'temperatura', 1153.0000, 'ºC'),
	(70773, 112, '2015-02-15 01:15:53.000000', 'temperatura', 955.0000, 'ºC'),
	(70774, 112, '2015-02-15 01:15:54.000000', 'temperatura', 116.0000, 'ºC'),
	(70775, 112, '2015-02-15 01:15:55.000000', 'temperatura', 118.0000, 'ºC'),
	(70776, 112, '2015-02-15 01:15:56.000000', 'temperatura', 242.0000, 'ºC'),
	(70777, 112, '2015-02-15 01:15:57.000000', 'temperatura', 854.0000, 'ºC'),
	(70778, 112, '2015-02-15 01:15:58.000000', 'temperatura', 1148.0000, 'ºC'),
	(70779, 112, '2015-02-15 01:15:59.000000', 'temperatura', 776.0000, 'ºC'),
	(70780, 112, '2015-02-15 01:16:00.000000', 'temperatura', 435.0000, 'ºC'),
	(70781, 112, '2015-02-15 01:16:01.000000', 'temperatura', 1051.0000, 'ºC'),
	(70782, 112, '2015-02-15 01:16:02.000000', 'temperatura', 347.0000, 'ºC'),
	(70783, 112, '2015-02-15 01:16:03.000000', 'temperatura', 986.0000, 'ºC'),
	(70784, 112, '2015-02-15 01:16:04.000000', 'temperatura', 288.0000, 'ºC'),
	(70785, 112, '2015-02-15 01:16:05.000000', 'temperatura', 881.0000, 'ºC'),
	(70786, 112, '2015-02-15 01:16:06.000000', 'temperatura', 1143.0000, 'ºC'),
	(70787, 112, '2015-02-15 01:16:07.000000', 'temperatura', 671.0000, 'ºC'),
	(70788, 112, '2015-02-15 01:16:08.000000', 'temperatura', 1129.0000, 'ºC'),
	(70789, 112, '2015-02-15 01:16:09.000000', 'temperatura', 32.0000, 'ºC'),
	(70790, 112, '2015-02-15 01:16:10.000000', 'temperatura', 372.0000, 'ºC'),
	(70791, 112, '2015-02-15 01:16:11.000000', 'temperatura', 566.0000, 'ºC'),
	(70792, 112, '2015-02-15 01:16:12.000000', 'temperatura', 515.0000, 'ºC'),
	(70793, 112, '2015-02-15 01:16:13.000000', 'temperatura', 876.0000, 'ºC'),
	(70794, 112, '2015-02-15 01:16:14.000000', 'temperatura', 435.0000, 'ºC'),
	(70795, 112, '2015-02-15 01:16:15.000000', 'temperatura', 749.0000, 'ºC'),
	(70796, 112, '2015-02-15 01:16:16.000000', 'temperatura', 42.0000, 'ºC'),
	(70797, 112, '2015-02-15 01:16:17.000000', 'temperatura', 362.0000, 'ºC'),
	(70798, 112, '2015-02-15 01:16:18.000000', 'temperatura', 485.0000, 'ºC'),
	(70799, 112, '2015-02-15 01:16:19.000000', 'temperatura', 138.0000, 'ºC'),
	(70800, 112, '2015-02-15 01:16:20.000000', 'temperatura', 437.0000, 'ºC'),
	(70801, 112, '2015-02-15 01:16:21.000000', 'temperatura', 572.0000, 'ºC'),
	(70802, 112, '2015-02-15 01:16:22.000000', 'temperatura', 347.0000, 'ºC'),
	(70803, 112, '2015-02-15 01:16:23.000000', 'temperatura', 23.0000, 'ºC'),
	(70804, 112, '2015-02-15 01:16:24.000000', 'temperatura', 272.0000, 'ºC'),
	(70805, 112, '2015-02-15 01:16:25.000000', 'temperatura', 91.0000, 'ºC'),
	(70806, 112, '2015-02-15 01:16:26.000000', 'temperatura', 839.0000, 'ºC'),
	(70807, 112, '2015-02-15 01:16:27.000000', 'temperatura', 322.0000, 'ºC'),
	(70808, 112, '2015-02-15 01:16:28.000000', 'temperatura', 293.0000, 'ºC'),
	(70809, 112, '2015-02-15 01:16:29.000000', 'temperatura', 501.0000, 'ºC'),
	(70810, 112, '2015-02-15 01:16:30.000000', 'temperatura', 427.0000, 'ºC'),
	(70811, 112, '2015-02-15 01:16:31.000000', 'temperatura', 633.0000, 'ºC'),
	(70812, 112, '2015-02-15 01:16:32.000000', 'temperatura', 685.0000, 'ºC'),
	(70813, 112, '2015-02-15 01:16:33.000000', 'temperatura', 324.0000, 'ºC'),
	(70814, 112, '2015-02-15 01:16:34.000000', 'temperatura', 765.0000, 'ºC'),
	(70815, 112, '2015-02-15 01:16:35.000000', 'temperatura', 453.0000, 'ºC'),
	(70816, 112, '2015-02-15 01:16:36.000000', 'temperatura', 1172.0000, 'ºC'),
	(70817, 112, '2015-02-15 01:16:37.000000', 'temperatura', 900.0000, 'ºC'),
	(70818, 112, '2015-02-15 01:16:38.000000', 'temperatura', 986.0000, 'ºC'),
	(70819, 112, '2015-02-15 01:16:39.000000', 'temperatura', 1032.0000, 'ºC'),
	(70820, 112, '2015-02-15 01:16:40.000000', 'temperatura', 999.0000, 'ºC'),
	(70821, 112, '2015-02-15 01:16:41.000000', 'temperatura', 701.0000, 'ºC'),
	(70822, 112, '2015-02-15 01:16:42.000000', 'temperatura', 509.0000, 'ºC'),
	(70823, 112, '2015-02-15 01:16:43.000000', 'temperatura', 444.0000, 'ºC'),
	(70824, 112, '2015-02-15 01:16:44.000000', 'temperatura', 692.0000, 'ºC'),
	(70825, 112, '2015-02-15 01:16:45.000000', 'temperatura', 928.0000, 'ºC'),
	(70826, 112, '2015-02-15 01:16:46.000000', 'temperatura', 163.0000, 'ºC'),
	(70827, 112, '2015-02-15 01:16:47.000000', 'temperatura', 434.0000, 'ºC'),
	(70828, 112, '2015-02-15 01:16:48.000000', 'temperatura', 482.0000, 'ºC'),
	(70829, 112, '2015-02-15 01:16:49.000000', 'temperatura', 1107.0000, 'ºC'),
	(70830, 112, '2015-02-15 01:16:50.000000', 'temperatura', 492.0000, 'ºC'),
	(70831, 112, '2015-02-15 01:16:51.000000', 'temperatura', 338.0000, 'ºC'),
	(70832, 112, '2015-02-15 01:16:52.000000', 'temperatura', 214.0000, 'ºC'),
	(70833, 112, '2015-02-15 01:16:53.000000', 'temperatura', 58.0000, 'ºC'),
	(70834, 112, '2015-02-15 01:16:54.000000', 'temperatura', 847.0000, 'ºC'),
	(70835, 112, '2015-02-15 01:16:55.000000', 'temperatura', 461.0000, 'ºC'),
	(70836, 112, '2015-02-15 01:16:56.000000', 'temperatura', 964.0000, 'ºC'),
	(70837, 112, '2015-02-15 01:16:57.000000', 'temperatura', 1036.0000, 'ºC'),
	(70838, 112, '2015-02-15 01:16:58.000000', 'temperatura', 1091.0000, 'ºC'),
	(70839, 112, '2015-02-15 01:16:59.000000', 'temperatura', 1147.0000, 'ºC'),
	(70840, 112, '2015-02-15 01:17:00.000000', 'temperatura', 63.0000, 'ºC'),
	(70841, 112, '2015-02-15 01:17:01.000000', 'temperatura', 473.0000, 'ºC'),
	(70842, 112, '2015-02-15 01:17:02.000000', 'temperatura', 978.0000, 'ºC'),
	(70843, 112, '2015-02-15 01:17:03.000000', 'temperatura', 1069.0000, 'ºC'),
	(70844, 112, '2015-02-15 01:17:04.000000', 'temperatura', 14.0000, 'ºC'),
	(70845, 112, '2015-02-15 01:17:05.000000', 'temperatura', 461.0000, 'ºC'),
	(70846, 112, '2015-02-15 01:17:06.000000', 'temperatura', 1065.0000, 'ºC'),
	(70847, 112, '2015-02-15 01:17:07.000000', 'temperatura', 344.0000, 'ºC'),
	(70848, 112, '2015-02-15 01:17:08.000000', 'temperatura', 924.0000, 'ºC'),
	(70849, 112, '2015-02-15 01:17:09.000000', 'temperatura', 1189.0000, 'ºC'),
	(70850, 112, '2015-02-15 01:17:10.000000', 'temperatura', 772.0000, 'ºC'),
	(70851, 112, '2015-02-15 01:17:11.000000', 'temperatura', 296.0000, 'ºC'),
	(70852, 112, '2015-02-15 01:17:12.000000', 'temperatura', 364.0000, 'ºC'),
	(70853, 112, '2015-02-15 01:17:13.000000', 'temperatura', 934.0000, 'ºC'),
	(70854, 112, '2015-02-15 01:17:14.000000', 'temperatura', 1178.0000, 'ºC'),
	(70855, 112, '2015-02-15 01:17:15.000000', 'temperatura', 688.0000, 'ºC'),
	(70856, 112, '2015-02-15 01:17:16.000000', 'temperatura', 1104.0000, 'ºC'),
	(70857, 112, '2015-02-15 01:17:17.000000', 'temperatura', 1060.0000, 'ºC'),
	(70858, 112, '2015-02-15 01:17:18.000000', 'temperatura', 786.0000, 'ºC'),
	(70859, 112, '2015-02-15 01:17:19.000000', 'temperatura', 750.0000, 'ºC'),
	(70860, 112, '2015-02-15 01:17:20.000000', 'temperatura', 192.0000, 'ºC'),
	(70861, 112, '2015-02-15 01:17:21.000000', 'temperatura', 1113.0000, 'ºC'),
	(70862, 112, '2015-02-15 01:17:22.000000', 'temperatura', 190.0000, 'ºC'),
	(70863, 112, '2015-02-15 01:17:23.000000', 'temperatura', 10.0000, 'ºC'),
	(70864, 112, '2015-02-15 01:17:24.000000', 'temperatura', 679.0000, 'ºC'),
	(70865, 112, '2015-02-15 01:17:25.000000', 'temperatura', 968.0000, 'ºC'),
	(70866, 112, '2015-02-15 01:17:26.000000', 'temperatura', 402.0000, 'ºC'),
	(70867, 112, '2015-02-15 01:17:27.000000', 'temperatura', 307.0000, 'ºC'),
	(70868, 112, '2015-02-15 01:17:28.000000', 'temperatura', 327.0000, 'ºC'),
	(70869, 112, '2015-02-15 01:17:29.000000', 'temperatura', 718.0000, 'ºC'),
	(70870, 112, '2015-02-15 01:17:30.000000', 'temperatura', 208.0000, 'ºC'),
	(70871, 112, '2015-02-15 01:17:31.000000', 'temperatura', 86.0000, 'ºC'),
	(70872, 112, '2015-02-15 01:17:32.000000', 'temperatura', 1009.0000, 'ºC'),
	(70873, 112, '2015-02-15 01:17:33.000000', 'temperatura', 1185.0000, 'ºC'),
	(70874, 112, '2015-02-15 01:17:34.000000', 'temperatura', 501.0000, 'ºC'),
	(70875, 112, '2015-02-15 01:17:35.000000', 'temperatura', 149.0000, 'ºC'),
	(70876, 112, '2015-02-15 01:17:36.000000', 'temperatura', 443.0000, 'ºC'),
	(70877, 112, '2015-02-15 01:17:37.000000', 'temperatura', 568.0000, 'ºC'),
	(70878, 112, '2015-02-15 01:17:38.000000', 'temperatura', 310.0000, 'ºC'),
	(70879, 112, '2015-02-15 01:17:39.000000', 'temperatura', 1049.0000, 'ºC'),
	(70880, 112, '2015-02-15 01:17:40.000000', 'temperatura', 716.0000, 'ºC'),
	(70881, 112, '2015-02-15 01:17:41.000000', 'temperatura', 431.0000, 'ºC'),
	(70882, 112, '2015-02-15 01:17:42.000000', 'temperatura', 10.0000, 'ºC'),
	(70883, 112, '2015-02-15 01:17:43.000000', 'temperatura', 1156.0000, 'ºC'),
	(70884, 112, '2015-02-15 01:17:44.000000', 'temperatura', 949.0000, 'ºC'),
	(70885, 112, '2015-02-15 01:17:45.000000', 'temperatura', 79.0000, 'ºC'),
	(70886, 112, '2015-02-15 01:17:46.000000', 'temperatura', 1149.0000, 'ºC'),
	(70887, 112, '2015-02-15 01:17:47.000000', 'temperatura', 708.0000, 'ºC'),
	(70888, 112, '2015-02-15 01:17:48.000000', 'temperatura', 94.0000, 'ºC'),
	(70889, 112, '2015-02-15 01:17:49.000000', 'temperatura', 747.0000, 'ºC'),
	(70890, 112, '2015-02-15 01:17:50.000000', 'temperatura', 1055.0000, 'ºC'),
	(70891, 112, '2015-02-15 01:17:51.000000', 'temperatura', 633.0000, 'ºC'),
	(70892, 112, '2015-02-15 01:17:52.000000', 'temperatura', 1199.0000, 'ºC'),
	(70893, 112, '2015-02-15 01:17:53.000000', 'temperatura', 499.0000, 'ºC'),
	(70894, 112, '2015-02-15 01:17:54.000000', 'temperatura', 99.0000, 'ºC'),
	(70895, 112, '2015-02-15 01:17:55.000000', 'temperatura', 196.0000, 'ºC'),
	(70896, 112, '2015-02-15 01:17:56.000000', 'temperatura', 686.0000, 'ºC'),
	(70897, 112, '2015-02-15 01:17:57.000000', 'temperatura', 443.0000, 'ºC'),
	(70898, 112, '2015-02-15 01:17:58.000000', 'temperatura', 156.0000, 'ºC'),
	(70899, 112, '2015-02-15 01:17:59.000000', 'temperatura', 650.0000, 'ºC'),
	(70900, 112, '2015-02-15 01:18:00.000000', 'temperatura', 383.0000, 'ºC'),
	(70901, 112, '2015-02-15 01:18:01.000000', 'temperatura', 1165.0000, 'ºC'),
	(70902, 112, '2015-02-15 01:18:02.000000', 'temperatura', 1079.0000, 'ºC'),
	(70903, 112, '2015-02-15 01:18:03.000000', 'temperatura', 699.0000, 'ºC'),
	(70904, 112, '2015-02-15 01:18:04.000000', 'temperatura', 259.0000, 'ºC'),
	(70905, 112, '2015-02-15 01:18:05.000000', 'temperatura', 396.0000, 'ºC'),
	(70906, 112, '2015-02-15 01:18:06.000000', 'temperatura', 7.0000, 'ºC'),
	(70907, 112, '2015-02-15 01:18:07.000000', 'temperatura', 45.0000, 'ºC'),
	(70908, 112, '2015-02-15 01:18:08.000000', 'temperatura', 204.0000, 'ºC'),
	(70909, 112, '2015-02-15 01:18:09.000000', 'temperatura', 888.0000, 'ºC'),
	(70910, 112, '2015-02-15 01:18:10.000000', 'temperatura', 229.0000, 'ºC'),
	(70911, 112, '2015-02-15 01:18:11.000000', 'temperatura', 881.0000, 'ºC'),
	(70912, 112, '2015-02-15 01:18:12.000000', 'temperatura', 119.0000, 'ºC'),
	(70913, 112, '2015-02-15 01:18:13.000000', 'temperatura', 353.0000, 'ºC'),
	(70914, 112, '2015-02-15 01:18:14.000000', 'temperatura', 209.0000, 'ºC'),
	(70915, 112, '2015-02-15 01:18:15.000000', 'temperatura', 1184.0000, 'ºC'),
	(70916, 112, '2015-02-15 01:18:16.000000', 'temperatura', 493.0000, 'ºC'),
	(70917, 112, '2015-02-15 01:18:17.000000', 'temperatura', 115.0000, 'ºC'),
	(70918, 112, '2015-02-15 01:18:18.000000', 'temperatura', 295.0000, 'ºC'),
	(70919, 112, '2015-02-15 01:18:19.000000', 'temperatura', 1133.0000, 'ºC'),
	(70920, 112, '2015-02-15 01:18:20.000000', 'temperatura', 1180.0000, 'ºC'),
	(70921, 112, '2015-02-15 01:18:21.000000', 'temperatura', 99.0000, 'ºC'),
	(70922, 112, '2015-02-15 01:18:22.000000', 'temperatura', 559.0000, 'ºC'),
	(70923, 112, '2015-02-15 01:18:23.000000', 'temperatura', 97.0000, 'ºC'),
	(70924, 112, '2015-02-15 01:18:24.000000', 'temperatura', 7.0000, 'ºC'),
	(70925, 112, '2015-02-15 01:18:25.000000', 'temperatura', 944.0000, 'ºC'),
	(70926, 112, '2015-02-15 01:18:26.000000', 'temperatura', 1100.0000, 'ºC'),
	(70927, 112, '2015-02-15 01:18:27.000000', 'temperatura', 270.0000, 'ºC'),
	(70928, 112, '2015-02-15 01:18:28.000000', 'temperatura', 451.0000, 'ºC'),
	(70929, 112, '2015-02-15 01:18:29.000000', 'temperatura', 245.0000, 'ºC'),
	(70930, 112, '2015-02-15 01:18:30.000000', 'temperatura', 1074.0000, 'ºC'),
	(70931, 112, '2015-02-15 01:18:31.000000', 'temperatura', 1036.0000, 'ºC'),
	(70932, 112, '2015-02-15 01:18:32.000000', 'temperatura', 756.0000, 'ºC'),
	(70933, 112, '2015-02-15 01:18:33.000000', 'temperatura', 673.0000, 'ºC'),
	(70934, 112, '2015-02-15 01:18:34.000000', 'temperatura', 1097.0000, 'ºC'),
	(70935, 112, '2015-02-15 01:18:35.000000', 'temperatura', 1067.0000, 'ºC'),
	(70936, 112, '2015-02-15 01:18:36.000000', 'temperatura', 845.0000, 'ºC'),
	(70937, 112, '2015-02-15 01:18:37.000000', 'temperatura', 1022.0000, 'ºC'),
	(70938, 112, '2015-02-15 01:18:38.000000', 'temperatura', 178.0000, 'ºC'),
	(70939, 112, '2015-02-15 01:18:39.000000', 'temperatura', 224.0000, 'ºC'),
	(70940, 112, '2015-02-15 01:18:40.000000', 'temperatura', 588.0000, 'ºC'),
	(70941, 112, '2015-02-15 01:18:41.000000', 'temperatura', 1068.0000, 'ºC'),
	(70942, 112, '2015-02-15 01:18:42.000000', 'temperatura', 1176.0000, 'ºC'),
	(70943, 112, '2015-02-15 01:18:43.000000', 'temperatura', 276.0000, 'ºC'),
	(70944, 112, '2015-02-15 01:18:44.000000', 'temperatura', 251.0000, 'ºC'),
	(70945, 112, '2015-02-15 01:18:45.000000', 'temperatura', 429.0000, 'ºC'),
	(70946, 112, '2015-02-15 01:18:46.000000', 'temperatura', 193.0000, 'ºC'),
	(70947, 112, '2015-02-15 01:18:47.000000', 'temperatura', 879.0000, 'ºC'),
	(70948, 112, '2015-02-15 01:18:48.000000', 'temperatura', 217.0000, 'ºC'),
	(70949, 112, '2015-02-15 01:18:49.000000', 'temperatura', 848.0000, 'ºC'),
	(70950, 112, '2015-02-15 01:18:50.000000', 'temperatura', 1191.0000, 'ºC'),
	(70951, 112, '2015-02-15 01:18:51.000000', 'temperatura', 1010.0000, 'ºC'),
	(70952, 112, '2015-02-15 01:18:52.000000', 'temperatura', 276.0000, 'ºC'),
	(70953, 112, '2015-02-15 01:18:53.000000', 'temperatura', 750.0000, 'ºC'),
	(70954, 112, '2015-02-15 01:18:54.000000', 'temperatura', 525.0000, 'ºC'),
	(70955, 112, '2015-02-15 01:18:55.000000', 'temperatura', 373.0000, 'ºC'),
	(70956, 112, '2015-02-15 01:18:56.000000', 'temperatura', 290.0000, 'ºC'),
	(70957, 112, '2015-02-15 01:18:57.000000', 'temperatura', 334.0000, 'ºC'),
	(70958, 112, '2015-02-15 01:18:58.000000', 'temperatura', 797.0000, 'ºC'),
	(70959, 112, '2015-02-15 01:18:59.000000', 'temperatura', 587.0000, 'ºC'),
	(70960, 112, '2015-02-15 01:19:00.000000', 'temperatura', 544.0000, 'ºC'),
	(70961, 112, '2015-02-15 01:19:01.000000', 'temperatura', 961.0000, 'ºC'),
	(70962, 112, '2015-02-15 01:19:02.000000', 'temperatura', 772.0000, 'ºC'),
	(70963, 112, '2015-02-15 01:19:03.000000', 'temperatura', 978.0000, 'ºC'),
	(70964, 112, '2015-02-15 01:19:04.000000', 'temperatura', 172.0000, 'ºC'),
	(70965, 112, '2015-02-15 01:19:05.000000', 'temperatura', 330.0000, 'ºC'),
	(70966, 112, '2015-02-15 01:19:06.000000', 'temperatura', 1132.0000, 'ºC'),
	(70967, 112, '2015-02-15 01:19:07.000000', 'temperatura', 1069.0000, 'ºC'),
	(70968, 112, '2015-02-15 01:19:08.000000', 'temperatura', 752.0000, 'ºC'),
	(70969, 112, '2015-02-15 01:19:09.000000', 'temperatura', 552.0000, 'ºC'),
	(70970, 112, '2015-02-15 01:19:10.000000', 'temperatura', 506.0000, 'ºC'),
	(70971, 112, '2015-02-15 01:19:11.000000', 'temperatura', 873.0000, 'ºC'),
	(70972, 112, '2015-02-15 01:19:12.000000', 'temperatura', 449.0000, 'ºC'),
	(70973, 112, '2015-02-15 01:19:13.000000', 'temperatura', 828.0000, 'ºC'),
	(70974, 112, '2015-02-15 01:19:14.000000', 'temperatura', 392.0000, 'ºC'),
	(70975, 112, '2015-02-15 01:19:15.000000', 'temperatura', 677.0000, 'ºC'),
	(70976, 112, '2015-02-15 01:19:16.000000', 'temperatura', 1008.0000, 'ºC'),
	(70977, 112, '2015-02-15 01:19:17.000000', 'temperatura', 609.0000, 'ºC'),
	(70978, 112, '2015-02-15 01:19:18.000000', 'temperatura', 23.0000, 'ºC'),
	(70979, 112, '2015-02-15 01:19:19.000000', 'temperatura', 689.0000, 'ºC'),
	(70980, 112, '2015-02-15 01:19:20.000000', 'temperatura', 974.0000, 'ºC'),
	(70981, 112, '2015-02-15 01:19:21.000000', 'temperatura', 404.0000, 'ºC'),
	(70982, 112, '2015-02-15 01:19:22.000000', 'temperatura', 299.0000, 'ºC'),
	(70983, 112, '2015-02-15 01:19:23.000000', 'temperatura', 282.0000, 'ºC'),
	(70984, 112, '2015-02-15 01:19:24.000000', 'temperatura', 516.0000, 'ºC'),
	(70985, 112, '2015-02-15 01:19:25.000000', 'temperatura', 534.0000, 'ºC'),
	(70986, 112, '2015-02-15 01:19:26.000000', 'temperatura', 1123.0000, 'ºC'),
	(70987, 112, '2015-02-15 01:19:27.000000', 'temperatura', 411.0000, 'ºC'),
	(70988, 112, '2015-02-15 01:19:28.000000', 'temperatura', 1090.0000, 'ºC'),
	(70989, 112, '2015-02-15 01:19:29.000000', 'temperatura', 615.0000, 'ºC'),
	(70990, 112, '2015-02-15 01:19:30.000000', 'temperatura', 1008.0000, 'ºC'),
	(70991, 112, '2015-02-15 01:19:31.000000', 'temperatura', 793.0000, 'ºC'),
	(70992, 112, '2015-02-15 01:19:32.000000', 'temperatura', 943.0000, 'ºC'),
	(70993, 112, '2015-02-15 01:19:33.000000', 'temperatura', 1136.0000, 'ºC'),
	(70994, 112, '2015-02-15 01:19:34.000000', 'temperatura', 451.0000, 'ºC'),
	(70995, 112, '2015-02-15 01:19:35.000000', 'temperatura', 49.0000, 'ºC'),
	(70996, 112, '2015-02-15 01:19:36.000000', 'temperatura', 90.0000, 'ºC'),
	(70997, 112, '2015-02-15 01:19:37.000000', 'temperatura', 304.0000, 'ºC'),
	(70998, 112, '2015-02-15 01:19:38.000000', 'temperatura', 50.0000, 'ºC'),
	(70999, 112, '2015-02-15 01:19:39.000000', 'temperatura', 538.0000, 'ºC'),
	(71000, 112, '2015-02-15 01:19:40.000000', 'temperatura', 141.0000, 'ºC'),
	(71001, 112, '2015-02-15 01:19:41.000000', 'temperatura', 291.0000, 'ºC'),
	(71002, 112, '2015-02-15 01:19:42.000000', 'temperatura', 1033.0000, 'ºC'),
	(71003, 112, '2015-02-15 01:19:43.000000', 'temperatura', 691.0000, 'ºC'),
	(71004, 112, '2015-02-15 01:19:44.000000', 'temperatura', 356.0000, 'ºC'),
	(71005, 112, '2015-02-15 01:19:45.000000', 'temperatura', 907.0000, 'ºC'),
	(71006, 112, '2015-02-15 01:19:46.000000', 'temperatura', 1070.0000, 'ºC'),
	(71007, 112, '2015-02-15 01:19:47.000000', 'temperatura', 230.0000, 'ºC'),
	(71008, 112, '2015-02-15 01:19:48.000000', 'temperatura', 338.0000, 'ºC'),
	(71009, 112, '2015-02-15 01:19:49.000000', 'temperatura', 1003.0000, 'ºC'),
	(71010, 112, '2015-02-15 01:19:50.000000', 'temperatura', 399.0000, 'ºC'),
	(71011, 112, '2015-02-15 01:19:51.000000', 'temperatura', 188.0000, 'ºC'),
	(71012, 112, '2015-02-15 01:19:52.000000', 'temperatura', 942.0000, 'ºC'),
	(71013, 112, '2015-02-15 01:19:53.000000', 'temperatura', 548.0000, 'ºC'),
	(71014, 112, '2015-02-15 01:19:54.000000', 'temperatura', 1114.0000, 'ºC'),
	(71015, 112, '2015-02-15 01:19:55.000000', 'temperatura', 325.0000, 'ºC'),
	(71016, 112, '2015-02-15 01:19:56.000000', 'temperatura', 685.0000, 'ºC'),
	(71017, 112, '2015-02-15 01:19:57.000000', 'temperatura', 50.0000, 'ºC'),
	(71018, 112, '2015-02-15 01:19:58.000000', 'temperatura', 595.0000, 'ºC'),
	(71019, 112, '2015-02-15 01:19:59.000000', 'temperatura', 427.0000, 'ºC'),
	(71020, 112, '2015-02-15 01:20:00.000000', 'temperatura', 351.0000, 'ºC'),
	(71021, 112, '2015-02-15 01:20:01.000000', 'temperatura', 475.0000, 'ºC'),
	(71022, 112, '2015-02-15 01:20:02.000000', 'temperatura', 123.0000, 'ºC'),
	(71023, 112, '2015-02-15 01:20:03.000000', 'temperatura', 389.0000, 'ºC'),
	(71024, 112, '2015-02-15 01:20:04.000000', 'temperatura', 376.0000, 'ºC'),
	(71025, 112, '2015-02-15 01:20:05.000000', 'temperatura', 714.0000, 'ºC'),
	(71026, 112, '2015-02-15 01:20:06.000000', 'temperatura', 44.0000, 'ºC'),
	(71027, 112, '2015-02-15 01:20:07.000000', 'temperatura', 478.0000, 'ºC'),
	(71028, 112, '2015-02-15 01:20:08.000000', 'temperatura', 1058.0000, 'ºC'),
	(71029, 112, '2015-02-15 01:20:09.000000', 'temperatura', 257.0000, 'ºC'),
	(71030, 112, '2015-02-15 01:20:10.000000', 'temperatura', 512.0000, 'ºC'),
	(71031, 112, '2015-02-15 01:20:11.000000', 'temperatura', 587.0000, 'ºC'),
	(71032, 112, '2015-02-15 01:20:12.000000', 'temperatura', 201.0000, 'ºC'),
	(71033, 112, '2015-02-15 01:20:13.000000', 'temperatura', 445.0000, 'ºC'),
	(71034, 112, '2015-02-15 01:20:14.000000', 'temperatura', 423.0000, 'ºC'),
	(71035, 112, '2015-02-15 01:20:15.000000', 'temperatura', 780.0000, 'ºC'),
	(71036, 112, '2015-02-15 01:20:16.000000', 'temperatura', 230.0000, 'ºC'),
	(71037, 112, '2015-02-15 01:20:17.000000', 'temperatura', 14.0000, 'ºC'),
	(71038, 112, '2015-02-15 01:20:18.000000', 'temperatura', 577.0000, 'ºC'),
	(71039, 112, '2015-02-15 01:20:19.000000', 'temperatura', 445.0000, 'ºC'),
	(71040, 112, '2015-02-15 01:20:20.000000', 'temperatura', 496.0000, 'ºC'),
	(71041, 112, '2015-02-15 01:20:21.000000', 'temperatura', 1144.0000, 'ºC'),
	(71042, 112, '2015-02-15 01:20:22.000000', 'temperatura', 631.0000, 'ºC'),
	(71043, 112, '2015-02-15 01:20:23.000000', 'temperatura', 927.0000, 'ºC'),
	(71044, 112, '2015-02-15 01:20:24.000000', 'temperatura', 340.0000, 'ºC'),
	(71045, 112, '2015-02-15 01:20:25.000000', 'temperatura', 119.0000, 'ºC'),
	(71046, 112, '2015-02-15 01:20:26.000000', 'temperatura', 774.0000, 'ºC'),
	(71047, 112, '2015-02-15 01:20:27.000000', 'temperatura', 1116.0000, 'ºC'),
	(71048, 112, '2015-02-15 01:20:28.000000', 'temperatura', 859.0000, 'ºC'),
	(71049, 112, '2015-02-15 01:20:29.000000', 'temperatura', 947.0000, 'ºC'),
	(71050, 112, '2015-02-15 01:20:30.000000', 'temperatura', 960.0000, 'ºC'),
	(71051, 112, '2015-02-15 01:20:31.000000', 'temperatura', 756.0000, 'ºC'),
	(71052, 112, '2015-02-15 01:20:32.000000', 'temperatura', 904.0000, 'ºC'),
	(71053, 112, '2015-02-15 01:20:33.000000', 'temperatura', 1049.0000, 'ºC'),
	(71054, 112, '2015-02-15 01:20:34.000000', 'temperatura', 137.0000, 'ºC'),
	(71055, 112, '2015-02-15 01:20:35.000000', 'temperatura', 1135.0000, 'ºC'),
	(71056, 112, '2015-02-15 01:20:36.000000', 'temperatura', 467.0000, 'ºC'),
	(71057, 112, '2015-02-15 01:20:37.000000', 'temperatura', 130.0000, 'ºC'),
	(71058, 112, '2015-02-15 01:20:38.000000', 'temperatura', 451.0000, 'ºC'),
	(71059, 112, '2015-02-15 01:20:39.000000', 'temperatura', 664.0000, 'ºC'),
	(71060, 112, '2015-02-15 01:20:40.000000', 'temperatura', 770.0000, 'ºC'),
	(71061, 112, '2015-02-15 01:20:41.000000', 'temperatura', 656.0000, 'ºC'),
	(71062, 112, '2015-02-15 01:20:42.000000', 'temperatura', 972.0000, 'ºC'),
	(71063, 112, '2015-02-15 01:20:43.000000', 'temperatura', 492.0000, 'ºC'),
	(71064, 112, '2015-02-15 01:20:44.000000', 'temperatura', 744.0000, 'ºC'),
	(71065, 112, '2015-02-15 01:20:45.000000', 'temperatura', 1044.0000, 'ºC'),
	(71066, 112, '2015-02-15 01:20:46.000000', 'temperatura', 587.0000, 'ºC'),
	(71067, 112, '2015-02-15 01:20:47.000000', 'temperatura', 1006.0000, 'ºC'),
	(71068, 112, '2015-02-15 01:20:48.000000', 'temperatura', 868.0000, 'ºC'),
	(71069, 112, '2015-02-15 01:20:49.000000', 'temperatura', 124.0000, 'ºC'),
	(71070, 112, '2015-02-15 01:20:50.000000', 'temperatura', 417.0000, 'ºC'),
	(71071, 112, '2015-02-15 01:20:51.000000', 'temperatura', 511.0000, 'ºC'),
	(71072, 112, '2015-02-15 01:20:52.000000', 'temperatura', 104.0000, 'ºC'),
	(71073, 112, '2015-02-15 01:20:53.000000', 'temperatura', 189.0000, 'ºC'),
	(71074, 112, '2015-02-15 01:20:54.000000', 'temperatura', 632.0000, 'ºC'),
	(71075, 112, '2015-02-15 01:20:55.000000', 'temperatura', 195.0000, 'ºC'),
	(71076, 112, '2015-02-15 01:20:56.000000', 'temperatura', 281.0000, 'ºC'),
	(71077, 112, '2015-02-15 01:20:57.000000', 'temperatura', 819.0000, 'ºC'),
	(71078, 112, '2015-02-15 01:20:58.000000', 'temperatura', 854.0000, 'ºC'),
	(71079, 112, '2015-02-15 01:20:59.000000', 'temperatura', 613.0000, 'ºC'),
	(71080, 112, '2015-02-15 01:21:00.000000', 'temperatura', 502.0000, 'ºC'),
	(71081, 112, '2015-02-15 01:21:01.000000', 'temperatura', 674.0000, 'ºC'),
	(71082, 112, '2015-02-15 01:21:02.000000', 'temperatura', 665.0000, 'ºC'),
	(71083, 112, '2015-02-15 01:21:03.000000', 'temperatura', 101.0000, 'ºC'),
	(71084, 112, '2015-02-15 01:21:04.000000', 'temperatura', 911.0000, 'ºC'),
	(71085, 112, '2015-02-15 01:21:05.000000', 'temperatura', 651.0000, 'ºC'),
	(71086, 112, '2015-02-15 01:21:06.000000', 'temperatura', 524.0000, 'ºC'),
	(71087, 112, '2015-02-15 01:21:07.000000', 'temperatura', 666.0000, 'ºC'),
	(71088, 112, '2015-02-15 01:21:08.000000', 'temperatura', 560.0000, 'ºC'),
	(71089, 112, '2015-02-15 01:21:09.000000', 'temperatura', 803.0000, 'ºC'),
	(71090, 112, '2015-02-15 01:21:10.000000', 'temperatura', 1135.0000, 'ºC'),
	(71091, 112, '2015-02-15 01:21:11.000000', 'temperatura', 865.0000, 'ºC'),
	(71092, 112, '2015-02-15 01:21:12.000000', 'temperatura', 923.0000, 'ºC'),
	(71093, 112, '2015-02-15 01:21:13.000000', 'temperatura', 822.0000, 'ºC'),
	(71094, 112, '2015-02-15 01:21:14.000000', 'temperatura', 138.0000, 'ºC'),
	(71095, 112, '2015-02-15 01:21:15.000000', 'temperatura', 624.0000, 'ºC'),
	(71096, 112, '2015-02-15 01:21:16.000000', 'temperatura', 307.0000, 'ºC'),
	(71097, 112, '2015-02-15 01:21:17.000000', 'temperatura', 864.0000, 'ºC'),
	(71098, 112, '2015-02-15 01:21:18.000000', 'temperatura', 1001.0000, 'ºC'),
	(71099, 112, '2015-02-15 01:21:19.000000', 'temperatura', 11.0000, 'ºC'),
	(71100, 112, '2015-02-15 01:21:20.000000', 'temperatura', 654.0000, 'ºC'),
	(71101, 112, '2015-02-15 01:21:21.000000', 'temperatura', 839.0000, 'ºC'),
	(71102, 112, '2015-02-15 01:21:22.000000', 'temperatura', 1034.0000, 'ºC'),
	(71103, 112, '2015-02-15 01:21:23.000000', 'temperatura', 250.0000, 'ºC'),
	(71104, 112, '2015-02-15 01:21:24.000000', 'temperatura', 551.0000, 'ºC'),
	(71105, 112, '2015-02-15 01:21:25.000000', 'temperatura', 805.0000, 'ºC'),
	(71106, 112, '2015-02-15 01:21:26.000000', 'temperatura', 1172.0000, 'ºC'),
	(71107, 112, '2015-02-15 01:21:27.000000', 'temperatura', 1047.0000, 'ºC'),
	(71108, 112, '2015-02-15 01:21:28.000000', 'temperatura', 518.0000, 'ºC'),
	(71109, 112, '2015-02-15 01:21:29.000000', 'temperatura', 648.0000, 'ºC'),
	(71110, 112, '2015-02-15 01:21:30.000000', 'temperatura', 490.0000, 'ºC'),
	(71111, 112, '2015-02-15 01:21:31.000000', 'temperatura', 505.0000, 'ºC'),
	(71112, 112, '2015-02-15 01:21:32.000000', 'temperatura', 1054.0000, 'ºC'),
	(71113, 112, '2015-02-15 01:21:33.000000', 'temperatura', 155.0000, 'ºC'),
	(71114, 112, '2015-02-15 01:21:34.000000', 'temperatura', 15.0000, 'ºC'),
	(71115, 112, '2015-02-15 01:21:35.000000', 'temperatura', 812.0000, 'ºC'),
	(71116, 112, '2015-02-15 01:21:36.000000', 'temperatura', 413.0000, 'ºC'),
	(71117, 112, '2015-02-15 01:21:37.000000', 'temperatura', 829.0000, 'ºC'),
	(71118, 112, '2015-02-15 01:21:38.000000', 'temperatura', 509.0000, 'ºC'),
	(71119, 112, '2015-02-15 01:21:39.000000', 'temperatura', 57.0000, 'ºC'),
	(71120, 112, '2015-02-15 01:21:40.000000', 'temperatura', 1160.0000, 'ºC'),
	(71121, 112, '2015-02-15 01:21:41.000000', 'temperatura', 830.0000, 'ºC'),
	(71122, 112, '2015-02-15 01:21:42.000000', 'temperatura', 671.0000, 'ºC'),
	(71123, 112, '2015-02-15 01:21:43.000000', 'temperatura', 863.0000, 'ºC'),
	(71124, 112, '2015-02-15 01:21:44.000000', 'temperatura', 1105.0000, 'ºC'),
	(71125, 112, '2015-02-15 01:21:45.000000', 'temperatura', 535.0000, 'ºC'),
	(71126, 112, '2015-02-15 01:21:46.000000', 'temperatura', 562.0000, 'ºC'),
	(71127, 112, '2015-02-15 01:21:47.000000', 'temperatura', 6.0000, 'ºC'),
	(71128, 112, '2015-02-15 01:21:48.000000', 'temperatura', 742.0000, 'ºC'),
	(71129, 112, '2015-02-15 01:21:49.000000', 'temperatura', 91.0000, 'ºC'),
	(71130, 112, '2015-02-15 01:21:50.000000', 'temperatura', 633.0000, 'ºC'),
	(71131, 112, '2015-02-15 01:21:51.000000', 'temperatura', 493.0000, 'ºC'),
	(71132, 112, '2015-02-15 01:21:52.000000', 'temperatura', 564.0000, 'ºC'),
	(71133, 112, '2015-02-15 01:21:53.000000', 'temperatura', 144.0000, 'ºC'),
	(71134, 112, '2015-02-15 01:21:54.000000', 'temperatura', 226.0000, 'ºC'),
	(71135, 112, '2015-02-15 01:21:55.000000', 'temperatura', 702.0000, 'ºC'),
	(71136, 112, '2015-02-15 01:21:56.000000', 'temperatura', 429.0000, 'ºC'),
	(71137, 112, '2015-02-15 01:21:57.000000', 'temperatura', 40.0000, 'ºC'),
	(71138, 112, '2015-02-15 01:21:58.000000', 'temperatura', 114.0000, 'ºC'),
	(71139, 112, '2015-02-15 01:21:59.000000', 'temperatura', 449.0000, 'ºC'),
	(71140, 112, '2015-02-15 01:22:00.000000', 'temperatura', 703.0000, 'ºC'),
	(71141, 112, '2015-02-15 01:22:01.000000', 'temperatura', 968.0000, 'ºC'),
	(71142, 112, '2015-02-15 01:22:02.000000', 'temperatura', 334.0000, 'ºC'),
	(71143, 112, '2015-02-15 01:22:03.000000', 'temperatura', 1164.0000, 'ºC'),
	(71144, 112, '2015-02-15 01:22:04.000000', 'temperatura', 18.0000, 'ºC'),
	(71145, 112, '2015-02-15 01:22:05.000000', 'temperatura', 201.0000, 'ºC'),
	(71146, 112, '2015-02-15 01:22:06.000000', 'temperatura', 949.0000, 'ºC'),
	(71147, 112, '2015-02-15 01:22:07.000000', 'temperatura', 542.0000, 'ºC'),
	(71148, 112, '2015-02-15 01:22:08.000000', 'temperatura', 1066.0000, 'ºC'),
	(71149, 112, '2015-02-15 01:22:09.000000', 'temperatura', 101.0000, 'ºC'),
	(71150, 112, '2015-02-15 01:22:10.000000', 'temperatura', 911.0000, 'ºC'),
	(71151, 112, '2015-02-15 01:22:11.000000', 'temperatura', 652.0000, 'ºC'),
	(71152, 112, '2015-02-15 01:22:12.000000', 'temperatura', 525.0000, 'ºC'),
	(71153, 112, '2015-02-15 01:22:13.000000', 'temperatura', 672.0000, 'ºC'),
	(71154, 112, '2015-02-15 01:22:14.000000', 'temperatura', 585.0000, 'ºC'),
	(71155, 112, '2015-02-15 01:22:15.000000', 'temperatura', 909.0000, 'ºC'),
	(71156, 112, '2015-02-15 01:22:16.000000', 'temperatura', 390.0000, 'ºC'),
	(71157, 112, '2015-02-15 01:22:17.000000', 'temperatura', 423.0000, 'ºC'),
	(71158, 112, '2015-02-15 01:22:18.000000', 'temperatura', 948.0000, 'ºC'),
	(71159, 112, '2015-02-15 01:22:19.000000', 'temperatura', 1071.0000, 'ºC'),
	(71160, 112, '2015-02-15 01:22:20.000000', 'temperatura', 109.0000, 'ºC'),
	(71161, 112, '2015-02-15 01:22:21.000000', 'temperatura', 935.0000, 'ºC'),
	(71162, 112, '2015-02-15 01:22:22.000000', 'temperatura', 748.0000, 'ºC'),
	(71163, 112, '2015-02-15 01:22:23.000000', 'temperatura', 935.0000, 'ºC'),
	(71164, 112, '2015-02-15 01:22:24.000000', 'temperatura', 30.0000, 'ºC'),
	(71165, 112, '2015-02-15 01:22:25.000000', 'temperatura', 948.0000, 'ºC'),
	(71166, 112, '2015-02-15 01:22:26.000000', 'temperatura', 1051.0000, 'ºC'),
	(71167, 112, '2015-02-15 01:22:27.000000', 'temperatura', 10.0000, 'ºC'),
	(71168, 112, '2015-02-15 01:22:28.000000', 'temperatura', 500.0000, 'ºC'),
	(71169, 112, '2015-02-15 01:22:29.000000', 'temperatura', 67.0000, 'ºC'),
	(71170, 112, '2015-02-15 01:22:30.000000', 'temperatura', 39.0000, 'ºC'),
	(71171, 112, '2015-02-15 01:22:31.000000', 'temperatura', 1191.0000, 'ºC'),
	(71172, 112, '2015-02-15 01:22:32.000000', 'temperatura', 1041.0000, 'ºC'),
	(71173, 112, '2015-02-15 01:22:33.000000', 'temperatura', 431.0000, 'ºC'),
	(71174, 112, '2015-02-15 01:22:34.000000', 'temperatura', 233.0000, 'ºC'),
	(71175, 112, '2015-02-15 01:22:35.000000', 'temperatura', 1074.0000, 'ºC'),
	(71176, 112, '2015-02-15 01:22:36.000000', 'temperatura', 1071.0000, 'ºC'),
	(71177, 112, '2015-02-15 01:22:37.000000', 'temperatura', 935.0000, 'ºC'),
	(71178, 112, '2015-02-15 01:22:38.000000', 'temperatura', 259.0000, 'ºC'),
	(71179, 112, '2015-02-15 01:22:39.000000', 'temperatura', 893.0000, 'ºC'),
	(71180, 112, '2015-02-15 01:22:40.000000', 'temperatura', 89.0000, 'ºC'),
	(71181, 112, '2015-02-15 01:22:41.000000', 'temperatura', 164.0000, 'ºC'),
	(71182, 112, '2015-02-15 01:22:42.000000', 'temperatura', 553.0000, 'ºC'),
	(71183, 112, '2015-02-15 01:22:43.000000', 'temperatura', 1073.0000, 'ºC'),
	(71184, 112, '2015-02-15 01:22:44.000000', 'temperatura', 110.0000, 'ºC'),
	(71185, 112, '2015-02-15 01:22:45.000000', 'temperatura', 929.0000, 'ºC'),
	(71186, 112, '2015-02-15 01:22:46.000000', 'temperatura', 716.0000, 'ºC'),
	(71187, 112, '2015-02-15 01:22:47.000000', 'temperatura', 792.0000, 'ºC'),
	(71188, 112, '2015-02-15 01:22:48.000000', 'temperatura', 613.0000, 'ºC'),
	(71189, 112, '2015-02-15 01:22:49.000000', 'temperatura', 691.0000, 'ºC'),
	(71190, 112, '2015-02-15 01:22:50.000000', 'temperatura', 415.0000, 'ºC'),
	(71191, 112, '2015-02-15 01:22:51.000000', 'temperatura', 3.0000, 'ºC'),
	(71192, 112, '2015-02-15 01:22:52.000000', 'temperatura', 1172.0000, 'ºC'),
	(71193, 112, '2015-02-15 01:22:53.000000', 'temperatura', 1051.0000, 'ºC'),
	(71194, 112, '2015-02-15 01:22:54.000000', 'temperatura', 540.0000, 'ºC'),
	(71195, 112, '2015-02-15 01:22:55.000000', 'temperatura', 747.0000, 'ºC'),
	(71196, 112, '2015-02-15 01:22:56.000000', 'temperatura', 917.0000, 'ºC'),
	(71197, 112, '2015-02-15 01:22:57.000000', 'temperatura', 1142.0000, 'ºC'),
	(71198, 112, '2015-02-15 01:22:58.000000', 'temperatura', 559.0000, 'ºC'),
	(71199, 112, '2015-02-15 01:22:59.000000', 'temperatura', 571.0000, 'ºC'),
	(71200, 112, '2015-02-15 01:23:00.000000', 'temperatura', 1178.0000, 'ºC'),
	(71201, 112, '2015-02-15 01:23:01.000000', 'temperatura', 580.0000, 'ºC'),
	(71202, 112, '2015-02-15 01:23:02.000000', 'temperatura', 564.0000, 'ºC'),
	(71203, 112, '2015-02-15 01:23:03.000000', 'temperatura', 1079.0000, 'ºC'),
	(71204, 112, '2015-02-15 01:23:04.000000', 'temperatura', 106.0000, 'ºC'),
	(71205, 112, '2015-02-15 01:23:05.000000', 'temperatura', 891.0000, 'ºC'),
	(71206, 112, '2015-02-15 01:23:06.000000', 'temperatura', 538.0000, 'ºC'),
	(71207, 112, '2015-02-15 01:23:07.000000', 'temperatura', 17.0000, 'ºC'),
	(71208, 112, '2015-02-15 01:23:08.000000', 'temperatura', 872.0000, 'ºC'),
	(71209, 112, '2015-02-15 01:23:09.000000', 'temperatura', 709.0000, 'ºC'),
	(71210, 112, '2015-02-15 01:23:10.000000', 'temperatura', 929.0000, 'ºC'),
	(71211, 112, '2015-02-15 01:23:11.000000', 'temperatura', 119.0000, 'ºC'),
	(71212, 112, '2015-02-15 01:23:12.000000', 'temperatura', 207.0000, 'ºC'),
	(71213, 112, '2015-02-15 01:23:13.000000', 'temperatura', 680.0000, 'ºC'),
	(71214, 112, '2015-02-15 01:23:14.000000', 'temperatura', 379.0000, 'ºC'),
	(71215, 112, '2015-02-15 01:23:15.000000', 'temperatura', 1054.0000, 'ºC'),
	(71216, 112, '2015-02-15 01:23:16.000000', 'temperatura', 535.0000, 'ºC'),
	(71217, 112, '2015-02-15 01:23:17.000000', 'temperatura', 712.0000, 'ºC'),
	(71218, 112, '2015-02-15 01:23:18.000000', 'temperatura', 757.0000, 'ºC'),
	(71219, 112, '2015-02-15 01:23:19.000000', 'temperatura', 451.0000, 'ºC'),
	(71220, 112, '2015-02-15 01:23:20.000000', 'temperatura', 1182.0000, 'ºC'),
	(71221, 112, '2015-02-15 01:23:21.000000', 'temperatura', 958.0000, 'ºC'),
	(71222, 112, '2015-02-15 01:23:22.000000', 'temperatura', 46.0000, 'ºC'),
	(71223, 112, '2015-02-15 01:23:23.000000', 'temperatura', 956.0000, 'ºC'),
	(71224, 112, '2015-02-15 01:23:24.000000', 'temperatura', 1042.0000, 'ºC'),
	(71225, 112, '2015-02-15 01:23:25.000000', 'temperatura', 1141.0000, 'ºC'),
	(71226, 112, '2015-02-15 01:23:26.000000', 'temperatura', 181.0000, 'ºC'),
	(71227, 112, '2015-02-15 01:23:27.000000', 'temperatura', 1083.0000, 'ºC'),
	(71228, 112, '2015-02-15 01:23:28.000000', 'temperatura', 74.0000, 'ºC'),
	(71229, 112, '2015-02-15 01:23:29.000000', 'temperatura', 720.0000, 'ºC'),
	(71230, 112, '2015-02-15 01:23:30.000000', 'temperatura', 980.0000, 'ºC'),
	(71231, 112, '2015-02-15 01:23:31.000000', 'temperatura', 340.0000, 'ºC'),
	(71232, 112, '2015-02-15 01:23:32.000000', 'temperatura', 1159.0000, 'ºC'),
	(71233, 112, '2015-02-15 01:23:33.000000', 'temperatura', 1175.0000, 'ºC'),
	(71234, 112, '2015-02-15 01:23:34.000000', 'temperatura', 1199.0000, 'ºC'),
	(71235, 112, '2015-02-15 01:23:35.000000', 'temperatura', 70.0000, 'ºC'),
	(71236, 112, '2015-02-15 01:23:36.000000', 'temperatura', 355.0000, 'ºC'),
	(71237, 112, '2015-02-15 01:23:37.000000', 'temperatura', 364.0000, 'ºC'),
	(71238, 112, '2015-02-15 01:23:38.000000', 'temperatura', 755.0000, 'ºC'),
	(71239, 112, '2015-02-15 01:23:39.000000', 'temperatura', 285.0000, 'ºC'),
	(71240, 112, '2015-02-15 01:23:40.000000', 'temperatura', 360.0000, 'ºC'),
	(71241, 112, '2015-02-15 01:23:41.000000', 'temperatura', 945.0000, 'ºC'),
	(71242, 112, '2015-02-15 01:23:42.000000', 'temperatura', 46.0000, 'ºC'),
	(71243, 112, '2015-02-15 01:23:43.000000', 'temperatura', 994.0000, 'ºC'),
	(71244, 112, '2015-02-15 01:23:44.000000', 'temperatura', 33.0000, 'ºC'),
	(71245, 112, '2015-02-15 01:23:45.000000', 'temperatura', 784.0000, 'ºC'),
	(71246, 112, '2015-02-15 01:23:46.000000', 'temperatura', 221.0000, 'ºC'),
	(71247, 112, '2015-02-15 01:23:47.000000', 'temperatura', 1153.0000, 'ºC'),
	(71248, 112, '2015-02-15 01:23:48.000000', 'temperatura', 302.0000, 'ºC'),
	(71249, 112, '2015-02-15 01:23:49.000000', 'temperatura', 451.0000, 'ºC'),
	(71250, 112, '2015-02-15 01:23:50.000000', 'temperatura', 150.0000, 'ºC'),
	(71251, 112, '2015-02-15 01:23:51.000000', 'temperatura', 598.0000, 'ºC'),
	(71252, 112, '2015-02-15 01:23:52.000000', 'temperatura', 140.0000, 'ºC'),
	(71253, 112, '2015-02-15 01:23:53.000000', 'temperatura', 106.0000, 'ºC'),
	(71254, 112, '2015-02-15 01:23:54.000000', 'temperatura', 111.0000, 'ºC'),
	(71255, 112, '2015-02-15 01:23:55.000000', 'temperatura', 237.0000, 'ºC'),
	(71256, 112, '2015-02-15 01:23:56.000000', 'temperatura', 853.0000, 'ºC'),
	(71257, 112, '2015-02-15 01:23:57.000000', 'temperatura', 1153.0000, 'ºC'),
	(71258, 112, '2015-02-15 01:23:58.000000', 'temperatura', 808.0000, 'ºC'),
	(71259, 112, '2015-02-15 01:23:59.000000', 'temperatura', 583.0000, 'ºC'),
	(71260, 112, '2015-02-15 01:24:00.000000', 'temperatura', 489.0000, 'ºC'),
	(71261, 112, '2015-02-15 01:24:01.000000', 'temperatura', 699.0000, 'ºC'),
	(71262, 112, '2015-02-15 01:24:02.000000', 'temperatura', 829.0000, 'ºC'),
	(71263, 112, '2015-02-15 01:24:03.000000', 'temperatura', 846.0000, 'ºC'),
	(71264, 112, '2015-02-15 01:24:04.000000', 'temperatura', 543.0000, 'ºC'),
	(71265, 112, '2015-02-15 01:24:05.000000', 'temperatura', 178.0000, 'ºC'),
	(71266, 112, '2015-02-15 01:24:06.000000', 'temperatura', 464.0000, 'ºC'),
	(71267, 112, '2015-02-15 01:24:07.000000', 'temperatura', 584.0000, 'ºC'),
	(71268, 112, '2015-02-15 01:24:08.000000', 'temperatura', 328.0000, 'ºC'),
	(71269, 112, '2015-02-15 01:24:09.000000', 'temperatura', 1091.0000, 'ºC'),
	(71270, 112, '2015-02-15 01:24:10.000000', 'temperatura', 870.0000, 'ºC'),
	(71271, 112, '2015-02-15 01:24:11.000000', 'temperatura', 1076.0000, 'ºC'),
	(71272, 112, '2015-02-15 01:24:12.000000', 'temperatura', 373.0000, 'ºC'),
	(71273, 112, '2015-02-15 01:24:13.000000', 'temperatura', 1037.0000, 'ºC'),
	(71274, 112, '2015-02-15 01:24:14.000000', 'temperatura', 466.0000, 'ºC'),
	(71275, 112, '2015-02-15 01:24:15.000000', 'temperatura', 418.0000, 'ºC'),
	(71276, 112, '2015-02-15 01:24:16.000000', 'temperatura', 692.0000, 'ºC'),
	(71277, 112, '2015-02-15 01:24:17.000000', 'temperatura', 1007.0000, 'ºC'),
	(71278, 112, '2015-02-15 01:24:18.000000', 'temperatura', 559.0000, 'ºC'),
	(71279, 112, '2015-02-15 01:24:19.000000', 'temperatura', 976.0000, 'ºC'),
	(71280, 112, '2015-02-15 01:24:20.000000', 'temperatura', 802.0000, 'ºC'),
	(71281, 112, '2015-02-15 01:24:21.000000', 'temperatura', 1084.0000, 'ºC'),
	(71282, 112, '2015-02-15 01:24:22.000000', 'temperatura', 614.0000, 'ºC'),
	(71283, 112, '2015-02-15 01:24:23.000000', 'temperatura', 1017.0000, 'ºC'),
	(71284, 112, '2015-02-15 01:24:24.000000', 'temperatura', 845.0000, 'ºC'),
	(71285, 112, '2015-02-15 01:24:25.000000', 'temperatura', 1175.0000, 'ºC'),
	(71286, 112, '2015-02-15 01:24:26.000000', 'temperatura', 939.0000, 'ºC'),
	(71287, 112, '2015-02-15 01:24:27.000000', 'temperatura', 1170.0000, 'ºC'),
	(71288, 112, '2015-02-15 01:24:28.000000', 'temperatura', 635.0000, 'ºC'),
	(71289, 112, '2015-02-15 01:24:29.000000', 'temperatura', 864.0000, 'ºC'),
	(71290, 112, '2015-02-15 01:24:30.000000', 'temperatura', 14.0000, 'ºC'),
	(71291, 112, '2015-02-15 01:24:31.000000', 'temperatura', 1081.0000, 'ºC'),
	(71292, 112, '2015-02-15 01:24:32.000000', 'temperatura', 561.0000, 'ºC'),
	(71293, 112, '2015-02-15 01:24:33.000000', 'temperatura', 765.0000, 'ºC'),
	(71294, 112, '2015-02-15 01:24:34.000000', 'temperatura', 942.0000, 'ºC'),
	(71295, 112, '2015-02-15 01:24:35.000000', 'temperatura', 17.0000, 'ºC'),
	(71296, 112, '2015-02-15 01:24:36.000000', 'temperatura', 858.0000, 'ºC'),
	(71297, 112, '2015-02-15 01:24:37.000000', 'temperatura', 642.0000, 'ºC'),
	(71298, 112, '2015-02-15 01:24:38.000000', 'temperatura', 633.0000, 'ºC'),
	(71299, 112, '2015-02-15 01:24:39.000000', 'temperatura', 42.0000, 'ºC'),
	(71300, 112, '2015-02-15 01:24:40.000000', 'temperatura', 709.0000, 'ºC'),
	(71301, 112, '2015-02-15 01:24:41.000000', 'temperatura', 1023.0000, 'ºC'),
	(71302, 112, '2015-02-15 01:24:42.000000', 'temperatura', 586.0000, 'ºC'),
	(71303, 112, '2015-02-15 01:24:43.000000', 'temperatura', 1062.0000, 'ºC'),
	(71304, 112, '2015-02-15 01:24:44.000000', 'temperatura', 1151.0000, 'ºC'),
	(71305, 112, '2015-02-15 01:24:45.000000', 'temperatura', 170.0000, 'ºC'),
	(71306, 112, '2015-02-15 01:24:46.000000', 'temperatura', 996.0000, 'ºC'),
	(71307, 112, '2015-02-15 01:24:47.000000', 'temperatura', 873.0000, 'ºC'),
	(71308, 112, '2015-02-15 01:24:48.000000', 'temperatura', 177.0000, 'ºC'),
	(71309, 112, '2015-02-15 01:24:49.000000', 'temperatura', 667.0000, 'ºC'),
	(71310, 112, '2015-02-15 01:24:50.000000', 'temperatura', 406.0000, 'ºC'),
	(71311, 112, '2015-02-15 01:24:51.000000', 'temperatura', 27.0000, 'ºC'),
	(71312, 112, '2015-02-15 01:24:52.000000', 'temperatura', 119.0000, 'ºC'),
	(71313, 112, '2015-02-15 01:24:53.000000', 'temperatura', 513.0000, 'ºC'),
	(71314, 112, '2015-02-15 01:24:54.000000', 'temperatura', 1010.0000, 'ºC'),
	(71315, 112, '2015-02-15 01:24:55.000000', 'temperatura', 1112.0000, 'ºC'),
	(71316, 112, '2015-02-15 01:24:56.000000', 'temperatura', 131.0000, 'ºC'),
	(71317, 112, '2015-02-15 01:24:57.000000', 'temperatura', 918.0000, 'ºC'),
	(71318, 112, '2015-02-15 01:24:58.000000', 'temperatura', 597.0000, 'ºC'),
	(71319, 112, '2015-02-15 01:24:59.000000', 'temperatura', 234.0000, 'ºC'),
	(71320, 112, '2015-02-15 01:25:00.000000', 'temperatura', 577.0000, 'ºC'),
	(71321, 112, '2015-02-15 01:25:01.000000', 'temperatura', 984.0000, 'ºC'),
	(71322, 112, '2015-02-15 01:25:02.000000', 'temperatura', 791.0000, 'ºC'),
	(71323, 112, '2015-02-15 01:25:03.000000', 'temperatura', 1002.0000, 'ºC'),
	(71324, 112, '2015-02-15 01:25:04.000000', 'temperatura', 239.0000, 'ºC'),
	(71325, 112, '2015-02-15 01:25:05.000000', 'temperatura', 587.0000, 'ºC'),
	(71326, 112, '2015-02-15 01:25:06.000000', 'temperatura', 1019.0000, 'ºC'),
	(71327, 112, '2015-02-15 01:25:07.000000', 'temperatura', 934.0000, 'ºC'),
	(71328, 112, '2015-02-15 01:25:08.000000', 'temperatura', 415.0000, 'ºC'),
	(71329, 112, '2015-02-15 01:25:09.000000', 'temperatura', 475.0000, 'ºC'),
	(71330, 112, '2015-02-15 01:25:10.000000', 'temperatura', 1129.0000, 'ºC'),
	(71331, 112, '2015-02-15 01:25:11.000000', 'temperatura', 620.0000, 'ºC'),
	(71332, 112, '2015-02-15 01:25:12.000000', 'temperatura', 913.0000, 'ºC'),
	(71333, 112, '2015-02-15 01:25:13.000000', 'temperatura', 306.0000, 'ºC'),
	(71334, 112, '2015-02-15 01:25:14.000000', 'temperatura', 1190.0000, 'ºC'),
	(71335, 112, '2015-02-15 01:25:15.000000', 'temperatura', 232.0000, 'ºC'),
	(71336, 112, '2015-02-15 01:25:16.000000', 'temperatura', 1192.0000, 'ºC'),
	(71337, 112, '2015-02-15 01:25:17.000000', 'temperatura', 465.0000, 'ºC'),
	(71338, 112, '2015-02-15 01:25:18.000000', 'temperatura', 1147.0000, 'ºC'),
	(71339, 112, '2015-02-15 01:25:19.000000', 'temperatura', 744.0000, 'ºC'),
	(71340, 112, '2015-02-15 01:25:20.000000', 'temperatura', 278.0000, 'ºC'),
	(71341, 112, '2015-02-15 01:25:21.000000', 'temperatura', 357.0000, 'ºC'),
	(71342, 112, '2015-02-15 01:25:22.000000', 'temperatura', 953.0000, 'ºC'),
	(71343, 112, '2015-02-15 01:25:23.000000', 'temperatura', 96.0000, 'ºC'),
	(71344, 112, '2015-02-15 01:25:24.000000', 'temperatura', 19.0000, 'ºC'),
	(71345, 112, '2015-02-15 01:25:25.000000', 'temperatura', 1009.0000, 'ºC'),
	(71346, 112, '2015-02-15 01:25:26.000000', 'temperatura', 188.0000, 'ºC'),
	(71347, 112, '2015-02-15 01:25:27.000000', 'temperatura', 314.0000, 'ºC'),
	(71348, 112, '2015-02-15 01:25:28.000000', 'temperatura', 1007.0000, 'ºC'),
	(71349, 112, '2015-02-15 01:25:29.000000', 'temperatura', 494.0000, 'ºC'),
	(71350, 112, '2015-02-15 01:25:30.000000', 'temperatura', 649.0000, 'ºC'),
	(71351, 112, '2015-02-15 01:25:31.000000', 'temperatura', 563.0000, 'ºC'),
	(71352, 112, '2015-02-15 01:25:32.000000', 'temperatura', 869.0000, 'ºC'),
	(71353, 112, '2015-02-15 01:25:33.000000', 'temperatura', 257.0000, 'ºC'),
	(71354, 112, '2015-02-15 01:25:34.000000', 'temperatura', 1078.0000, 'ºC'),
	(71355, 112, '2015-02-15 01:25:35.000000', 'temperatura', 1021.0000, 'ºC'),
	(71356, 112, '2015-02-15 01:25:36.000000', 'temperatura', 671.0000, 'ºC'),
	(71357, 112, '2015-02-15 01:25:37.000000', 'temperatura', 290.0000, 'ºC'),
	(71358, 112, '2015-02-15 01:25:38.000000', 'temperatura', 640.0000, 'ºC'),
	(71359, 112, '2015-02-15 01:25:39.000000', 'temperatura', 1131.0000, 'ºC'),
	(71360, 112, '2015-02-15 01:25:40.000000', 'temperatura', 136.0000, 'ºC'),
	(71361, 112, '2015-02-15 01:25:41.000000', 'temperatura', 888.0000, 'ºC'),
	(71362, 112, '2015-02-15 01:25:42.000000', 'temperatura', 430.0000, 'ºC'),
	(71363, 112, '2015-02-15 01:25:43.000000', 'temperatura', 689.0000, 'ºC'),
	(71364, 112, '2015-02-15 01:25:44.000000', 'temperatura', 956.0000, 'ºC'),
	(71365, 112, '2015-02-15 01:25:45.000000', 'temperatura', 313.0000, 'ºC'),
	(71366, 112, '2015-02-15 01:25:46.000000', 'temperatura', 1096.0000, 'ºC'),
	(71367, 112, '2015-02-15 01:25:47.000000', 'temperatura', 942.0000, 'ºC'),
	(71368, 112, '2015-02-15 01:25:48.000000', 'temperatura', 222.0000, 'ºC'),
	(71369, 112, '2015-02-15 01:25:49.000000', 'temperatura', 687.0000, 'ºC'),
	(71370, 112, '2015-02-15 01:25:50.000000', 'temperatura', 366.0000, 'ºC'),
	(71371, 112, '2015-02-15 01:25:51.000000', 'temperatura', 973.0000, 'ºC'),
	(71372, 112, '2015-02-15 01:25:52.000000', 'temperatura', 166.0000, 'ºC'),
	(71373, 112, '2015-02-15 01:25:53.000000', 'temperatura', 314.0000, 'ºC'),
	(71374, 112, '2015-02-15 01:25:54.000000', 'temperatura', 1069.0000, 'ºC'),
	(71375, 112, '2015-02-15 01:25:55.000000', 'temperatura', 804.0000, 'ºC'),
	(71376, 112, '2015-02-15 01:25:56.000000', 'temperatura', 814.0000, 'ºC'),
	(71377, 112, '2015-02-15 01:25:57.000000', 'temperatura', 456.0000, 'ºC'),
	(71378, 112, '2015-02-15 01:25:58.000000', 'temperatura', 1042.0000, 'ºC'),
	(71379, 112, '2015-02-15 01:25:59.000000', 'temperatura', 242.0000, 'ºC'),
	(71380, 112, '2015-02-15 01:26:00.000000', 'temperatura', 484.0000, 'ºC'),
	(71381, 112, '2015-02-15 01:26:01.000000', 'temperatura', 493.0000, 'ºC'),
	(71382, 112, '2015-02-15 01:26:02.000000', 'temperatura', 1013.0000, 'ºC'),
	(71383, 112, '2015-02-15 01:26:03.000000', 'temperatura', 1187.0000, 'ºC'),
	(71384, 112, '2015-02-15 01:26:04.000000', 'temperatura', 496.0000, 'ºC'),
	(71385, 112, '2015-02-15 01:26:05.000000', 'temperatura', 121.0000, 'ºC'),
	(71386, 112, '2015-02-15 01:26:06.000000', 'temperatura', 317.0000, 'ºC'),
	(71387, 112, '2015-02-15 01:26:07.000000', 'temperatura', 24.0000, 'ºC'),
	(71388, 112, '2015-02-15 01:26:08.000000', 'temperatura', 368.0000, 'ºC'),
	(71389, 112, '2015-02-15 01:26:09.000000', 'temperatura', 568.0000, 'ºC'),
	(71390, 112, '2015-02-15 01:26:10.000000', 'temperatura', 536.0000, 'ºC'),
	(71391, 112, '2015-02-15 01:26:11.000000', 'temperatura', 977.0000, 'ºC'),
	(71392, 112, '2015-02-15 01:26:12.000000', 'temperatura', 877.0000, 'ºC'),
	(71393, 112, '2015-02-15 01:26:13.000000', 'temperatura', 256.0000, 'ºC'),
	(71394, 112, '2015-02-15 01:26:14.000000', 'temperatura', 1047.0000, 'ºC'),
	(71395, 112, '2015-02-15 01:26:15.000000', 'temperatura', 867.0000, 'ºC'),
	(71396, 112, '2015-02-15 01:26:16.000000', 'temperatura', 1197.0000, 'ºC'),
	(71397, 112, '2015-02-15 01:26:17.000000', 'temperatura', 983.0000, 'ºC'),
	(71398, 112, '2015-02-15 01:26:18.000000', 'temperatura', 125.0000, 'ºC'),
	(71399, 112, '2015-02-15 01:26:19.000000', 'temperatura', 77.0000, 'ºC'),
	(71400, 112, '2015-02-15 01:26:20.000000', 'temperatura', 9.0000, 'ºC'),
	(71401, 112, '2015-02-15 01:26:21.000000', 'temperatura', 1015.0000, 'ºC'),
	(71402, 112, '2015-02-15 01:26:22.000000', 'temperatura', 248.0000, 'ºC'),
	(71403, 112, '2015-02-15 01:26:23.000000', 'temperatura', 598.0000, 'ºC'),
	(71404, 112, '2015-02-15 01:26:24.000000', 'temperatura', 1045.0000, 'ºC'),
	(71405, 112, '2015-02-15 01:26:25.000000', 'temperatura', 1033.0000, 'ºC'),
	(71406, 112, '2015-02-15 01:26:26.000000', 'temperatura', 831.0000, 'ºC'),
	(71407, 112, '2015-02-15 01:26:27.000000', 'temperatura', 1057.0000, 'ºC'),
	(71408, 112, '2015-02-15 01:26:28.000000', 'temperatura', 393.0000, 'ºC'),
	(71409, 112, '2015-02-15 01:26:29.000000', 'temperatura', 1194.0000, 'ºC'),
	(71410, 112, '2015-02-15 01:26:30.000000', 'temperatura', 1190.0000, 'ºC'),
	(71411, 112, '2015-02-15 01:26:31.000000', 'temperatura', 1171.0000, 'ºC'),
	(71412, 112, '2015-02-15 01:26:32.000000', 'temperatura', 1083.0000, 'ºC'),
	(71413, 112, '2015-02-15 01:26:33.000000', 'temperatura', 704.0000, 'ºC'),
	(71414, 112, '2015-02-15 01:26:34.000000', 'temperatura', 269.0000, 'ºC'),
	(71415, 112, '2015-02-15 01:26:35.000000', 'temperatura', 436.0000, 'ºC'),
	(71416, 112, '2015-02-15 01:26:36.000000', 'temperatura', 173.0000, 'ºC'),
	(71417, 112, '2015-02-15 01:26:37.000000', 'temperatura', 757.0000, 'ºC'),
	(71418, 112, '2015-02-15 01:26:38.000000', 'temperatura', 867.0000, 'ºC'),
	(71419, 112, '2015-02-15 01:26:39.000000', 'temperatura', 864.0000, 'ºC'),
	(71420, 112, '2015-02-15 01:26:40.000000', 'temperatura', 520.0000, 'ºC'),
	(71421, 112, '2015-02-15 01:26:41.000000', 'temperatura', 6.0000, 'ºC'),
	(71422, 112, '2015-02-15 01:26:42.000000', 'temperatura', 874.0000, 'ºC'),
	(71423, 112, '2015-02-15 01:26:43.000000', 'temperatura', 750.0000, 'ºC'),
	(71424, 112, '2015-02-15 01:26:44.000000', 'temperatura', 1130.0000, 'ºC'),
	(71425, 112, '2015-02-15 01:26:45.000000', 'temperatura', 1002.0000, 'ºC'),
	(71426, 112, '2015-02-15 01:26:46.000000', 'temperatura', 419.0000, 'ºC'),
	(71427, 112, '2015-02-15 01:26:47.000000', 'temperatura', 291.0000, 'ºC'),
	(71428, 112, '2015-02-15 01:26:48.000000', 'temperatura', 199.0000, 'ºC'),
	(71429, 112, '2015-02-15 01:26:49.000000', 'temperatura', 120.0000, 'ºC'),
	(71430, 112, '2015-02-15 01:26:50.000000', 'temperatura', 5.0000, 'ºC'),
	(71431, 112, '2015-02-15 01:26:51.000000', 'temperatura', 867.0000, 'ºC'),
	(71432, 112, '2015-02-15 01:26:52.000000', 'temperatura', 720.0000, 'ºC'),
	(71433, 112, '2015-02-15 01:26:53.000000', 'temperatura', 998.0000, 'ºC'),
	(71434, 112, '2015-02-15 01:26:54.000000', 'temperatura', 432.0000, 'ºC'),
	(71435, 112, '2015-02-15 01:26:55.000000', 'temperatura', 367.0000, 'ºC'),
	(71436, 112, '2015-02-15 01:26:56.000000', 'temperatura', 540.0000, 'ºC'),
	(71437, 112, '2015-02-15 01:26:57.000000', 'temperatura', 397.0000, 'ºC'),
	(71438, 112, '2015-02-15 01:26:58.000000', 'temperatura', 367.0000, 'ºC'),
	(71439, 112, '2015-02-15 01:26:59.000000', 'temperatura', 642.0000, 'ºC'),
	(71440, 112, '2015-02-15 01:27:00.000000', 'temperatura', 912.0000, 'ºC'),
	(71441, 112, '2015-02-15 01:27:01.000000', 'temperatura', 235.0000, 'ºC'),
	(71442, 112, '2015-02-15 01:27:02.000000', 'temperatura', 839.0000, 'ºC'),
	(71443, 112, '2015-02-15 01:27:03.000000', 'temperatura', 1088.0000, 'ºC'),
	(71444, 112, '2015-02-15 01:27:04.000000', 'temperatura', 526.0000, 'ºC'),
	(71445, 112, '2015-02-15 01:27:05.000000', 'temperatura', 565.0000, 'ºC'),
	(71446, 112, '2015-02-15 01:27:06.000000', 'temperatura', 50.0000, 'ºC'),
	(71447, 112, '2015-02-15 01:27:07.000000', 'temperatura', 954.0000, 'ºC'),
	(71448, 112, '2015-02-15 01:27:08.000000', 'temperatura', 1020.0000, 'ºC'),
	(71449, 112, '2015-02-15 01:27:09.000000', 'temperatura', 1041.0000, 'ºC'),
	(71450, 112, '2015-02-15 01:27:10.000000', 'temperatura', 943.0000, 'ºC'),
	(71451, 112, '2015-02-15 01:27:11.000000', 'temperatura', 394.0000, 'ºC'),
	(71452, 112, '2015-02-15 01:27:12.000000', 'temperatura', 339.0000, 'ºC'),
	(71453, 112, '2015-02-15 01:27:13.000000', 'temperatura', 515.0000, 'ºC'),
	(71454, 112, '2015-02-15 01:27:14.000000', 'temperatura', 357.0000, 'ºC'),
	(71455, 112, '2015-02-15 01:27:15.000000', 'temperatura', 244.0000, 'ºC'),
	(71456, 112, '2015-02-15 01:27:16.000000', 'temperatura', 146.0000, 'ºC'),
	(71457, 112, '2015-02-15 01:27:17.000000', 'temperatura', 0.0000, 'ºC'),
	(71458, 112, '2015-02-15 01:27:18.000000', 'temperatura', 764.0000, 'ºC'),
	(71459, 112, '2015-02-15 01:27:19.000000', 'temperatura', 219.0000, 'ºC'),
	(71460, 112, '2015-02-15 01:27:20.000000', 'temperatura', 4.0000, 'ºC'),
	(71461, 112, '2015-02-15 01:27:21.000000', 'temperatura', 562.0000, 'ºC'),
	(71462, 112, '2015-02-15 01:27:22.000000', 'temperatura', 401.0000, 'ºC'),
	(71463, 112, '2015-02-15 01:27:23.000000', 'temperatura', 317.0000, 'ºC'),
	(71464, 112, '2015-02-15 01:27:24.000000', 'temperatura', 384.0000, 'ºC'),
	(71465, 112, '2015-02-15 01:27:25.000000', 'temperatura', 967.0000, 'ºC'),
	(71466, 112, '2015-02-15 01:27:26.000000', 'temperatura', 86.0000, 'ºC'),
	(71467, 112, '2015-02-15 01:27:27.000000', 'temperatura', 1129.0000, 'ºC'),
	(71468, 112, '2015-02-15 01:27:28.000000', 'temperatura', 588.0000, 'ºC'),
	(71469, 112, '2015-02-15 01:27:29.000000', 'temperatura', 754.0000, 'ºC'),
	(71470, 112, '2015-02-15 01:27:30.000000', 'temperatura', 806.0000, 'ºC'),
	(71471, 112, '2015-02-15 01:27:31.000000', 'temperatura', 567.0000, 'ºC'),
	(71472, 112, '2015-02-15 01:27:32.000000', 'temperatura', 418.0000, 'ºC'),
	(71473, 112, '2015-02-15 01:27:33.000000', 'temperatura', 389.0000, 'ºC'),
	(71474, 112, '2015-02-15 01:27:34.000000', 'temperatura', 691.0000, 'ºC'),
	(71475, 112, '2015-02-15 01:27:35.000000', 'temperatura', 1090.0000, 'ºC'),
	(71476, 112, '2015-02-15 01:27:36.000000', 'temperatura', 976.0000, 'ºC'),
	(71477, 112, '2015-02-15 01:27:37.000000', 'temperatura', 411.0000, 'ºC'),
	(71478, 112, '2015-02-15 01:27:38.000000', 'temperatura', 329.0000, 'ºC'),
	(71479, 112, '2015-02-15 01:27:39.000000', 'temperatura', 413.0000, 'ºC'),
	(71480, 112, '2015-02-15 01:27:40.000000', 'temperatura', 1077.0000, 'ºC'),
	(71481, 112, '2015-02-15 01:27:41.000000', 'temperatura', 547.0000, 'ºC'),
	(71482, 112, '2015-02-15 01:27:42.000000', 'temperatura', 704.0000, 'ºC'),
	(71483, 112, '2015-02-15 01:27:43.000000', 'temperatura', 679.0000, 'ºC'),
	(71484, 112, '2015-02-15 01:27:44.000000', 'temperatura', 84.0000, 'ºC'),
	(71485, 112, '2015-02-15 01:27:45.000000', 'temperatura', 785.0000, 'ºC'),
	(71486, 112, '2015-02-15 01:27:46.000000', 'temperatura', 74.0000, 'ºC'),
	(71487, 112, '2015-02-15 01:27:47.000000', 'temperatura', 416.0000, 'ºC'),
	(71488, 112, '2015-02-15 01:27:48.000000', 'temperatura', 658.0000, 'ºC'),
	(71489, 112, '2015-02-15 01:27:49.000000', 'temperatura', 842.0000, 'ºC'),
	(71490, 112, '2015-02-15 01:27:50.000000', 'temperatura', 1036.0000, 'ºC'),
	(71491, 112, '2015-02-15 01:27:51.000000', 'temperatura', 254.0000, 'ºC'),
	(71492, 112, '2015-02-15 01:27:52.000000', 'temperatura', 563.0000, 'ºC'),
	(71493, 112, '2015-02-15 01:27:53.000000', 'temperatura', 852.0000, 'ºC'),
	(71494, 112, '2015-02-15 01:27:54.000000', 'temperatura', 172.0000, 'ºC'),
	(71495, 112, '2015-02-15 01:27:55.000000', 'temperatura', 704.0000, 'ºC'),
	(71496, 112, '2015-02-15 01:27:56.000000', 'temperatura', 605.0000, 'ºC'),
	(71497, 112, '2015-02-15 01:27:57.000000', 'temperatura', 912.0000, 'ºC'),
	(71498, 112, '2015-02-15 01:27:58.000000', 'temperatura', 346.0000, 'ºC'),
	(71499, 112, '2015-02-15 01:27:59.000000', 'temperatura', 194.0000, 'ºC'),
	(71500, 112, '2015-02-15 01:28:00.000000', 'temperatura', 1133.0000, 'ºC'),
	(71501, 112, '2015-02-15 01:28:01.000000', 'temperatura', 284.0000, 'ºC'),
	(71502, 112, '2015-02-15 01:28:02.000000', 'temperatura', 421.0000, 'ºC'),
	(71503, 112, '2015-02-15 01:28:03.000000', 'temperatura', 54.0000, 'ºC'),
	(71504, 112, '2015-02-15 01:28:04.000000', 'temperatura', 207.0000, 'ºC'),
	(71505, 112, '2015-02-15 01:28:05.000000', 'temperatura', 872.0000, 'ºC'),
	(71506, 112, '2015-02-15 01:28:06.000000', 'temperatura', 141.0000, 'ºC'),
	(71507, 112, '2015-02-15 01:28:07.000000', 'temperatura', 491.0000, 'ºC'),
	(71508, 112, '2015-02-15 01:28:08.000000', 'temperatura', 832.0000, 'ºC'),
	(71509, 112, '2015-02-15 01:28:09.000000', 'temperatura', 285.0000, 'ºC'),
	(71510, 112, '2015-02-15 01:28:10.000000', 'temperatura', 131.0000, 'ºC'),
	(71511, 112, '2015-02-15 01:28:11.000000', 'temperatura', 1000.0000, 'ºC'),
	(71512, 112, '2015-02-15 01:28:12.000000', 'temperatura', 1009.0000, 'ºC'),
	(71513, 112, '2015-02-15 01:28:13.000000', 'temperatura', 843.0000, 'ºC'),
	(71514, 112, '2015-02-15 01:28:14.000000', 'temperatura', 1189.0000, 'ºC'),
	(71515, 112, '2015-02-15 01:28:15.000000', 'temperatura', 1018.0000, 'ºC'),
	(71516, 112, '2015-02-15 01:28:16.000000', 'temperatura', 321.0000, 'ºC'),
	(71517, 112, '2015-02-15 01:28:17.000000', 'temperatura', 952.0000, 'ºC'),
	(71518, 112, '2015-02-15 01:28:18.000000', 'temperatura', 199.0000, 'ºC'),
	(71519, 112, '2015-02-15 01:28:19.000000', 'temperatura', 540.0000, 'ºC'),
	(71520, 112, '2015-02-15 01:28:20.000000', 'temperatura', 904.0000, 'ºC'),
	(71521, 112, '2015-02-15 01:28:21.000000', 'temperatura', 500.0000, 'ºC'),
	(71522, 112, '2015-02-15 01:28:22.000000', 'temperatura', 990.0000, 'ºC'),
	(71523, 112, '2015-02-15 01:28:23.000000', 'temperatura', 1049.0000, 'ºC'),
	(71524, 112, '2015-02-15 01:28:24.000000', 'temperatura', 1077.0000, 'ºC'),
	(71525, 112, '2015-02-15 01:28:25.000000', 'temperatura', 1039.0000, 'ºC'),
	(71526, 112, '2015-02-15 01:28:26.000000', 'temperatura', 763.0000, 'ºC'),
	(71527, 112, '2015-02-15 01:28:27.000000', 'temperatura', 697.0000, 'ºC'),
	(71528, 112, '2015-02-15 01:28:28.000000', 'temperatura', 1198.0000, 'ºC'),
	(71529, 112, '2015-02-15 01:28:29.000000', 'temperatura', 299.0000, 'ºC'),
	(71530, 112, '2015-02-15 01:28:30.000000', 'temperatura', 303.0000, 'ºC'),
	(71531, 112, '2015-02-15 01:28:31.000000', 'temperatura', 615.0000, 'ºC'),
	(71532, 112, '2015-02-15 01:28:32.000000', 'temperatura', 970.0000, 'ºC'),
	(71533, 112, '2015-02-15 01:28:33.000000', 'temperatura', 606.0000, 'ºC'),
	(71534, 112, '2015-02-15 01:28:34.000000', 'temperatura', 119.0000, 'ºC'),
	(71535, 112, '2015-02-15 01:28:35.000000', 'temperatura', 1179.0000, 'ºC'),
	(71536, 112, '2015-02-15 01:28:36.000000', 'temperatura', 740.0000, 'ºC'),
	(71537, 112, '2015-02-15 01:28:37.000000', 'temperatura', 161.0000, 'ºC'),
	(71538, 112, '2015-02-15 01:28:38.000000', 'temperatura', 985.0000, 'ºC'),
	(71539, 112, '2015-02-15 01:28:39.000000', 'temperatura', 841.0000, 'ºC'),
	(71540, 112, '2015-02-15 01:28:40.000000', 'temperatura', 53.0000, 'ºC'),
	(71541, 112, '2015-02-15 01:28:41.000000', 'temperatura', 143.0000, 'ºC'),
	(71542, 112, '2015-02-15 01:28:42.000000', 'temperatura', 554.0000, 'ºC'),
	(71543, 112, '2015-02-15 01:28:43.000000', 'temperatura', 1141.0000, 'ºC'),
	(71544, 112, '2015-02-15 01:28:44.000000', 'temperatura', 445.0000, 'ºC'),
	(71545, 112, '2015-02-15 01:28:45.000000', 'temperatura', 3.0000, 'ºC'),
	(71546, 112, '2015-02-15 01:28:46.000000', 'temperatura', 1081.0000, 'ºC'),
	(71547, 112, '2015-02-15 01:28:47.000000', 'temperatura', 598.0000, 'ºC'),
	(71548, 112, '2015-02-15 01:28:48.000000', 'temperatura', 944.0000, 'ºC'),
	(71549, 112, '2015-02-15 01:28:49.000000', 'temperatura', 528.0000, 'ºC'),
	(71550, 112, '2015-02-15 01:28:50.000000', 'temperatura', 1008.0000, 'ºC'),
	(71551, 112, '2015-02-15 01:28:51.000000', 'temperatura', 1059.0000, 'ºC'),
	(71552, 112, '2015-02-15 01:28:52.000000', 'temperatura', 1069.0000, 'ºC'),
	(71553, 112, '2015-02-15 01:28:53.000000', 'temperatura', 969.0000, 'ºC'),
	(71554, 112, '2015-02-15 01:28:54.000000', 'temperatura', 440.0000, 'ºC'),
	(71555, 112, '2015-02-15 01:28:55.000000', 'temperatura', 491.0000, 'ºC'),
	(71556, 112, '2015-02-15 01:28:56.000000', 'temperatura', 1138.0000, 'ºC'),
	(71557, 112, '2015-02-15 01:28:57.000000', 'temperatura', 615.0000, 'ºC'),
	(71558, 112, '2015-02-15 01:28:58.000000', 'temperatura', 864.0000, 'ºC'),
	(71559, 112, '2015-02-15 01:28:59.000000', 'temperatura', 74.0000, 'ºC'),
	(71560, 112, '2015-02-15 01:29:00.000000', 'temperatura', 178.0000, 'ºC'),
	(71561, 112, '2015-02-15 01:29:01.000000', 'temperatura', 669.0000, 'ºC'),
	(71562, 112, '2015-02-15 01:29:02.000000', 'temperatura', 412.0000, 'ºC'),
	(71563, 112, '2015-02-15 01:29:03.000000', 'temperatura', 53.0000, 'ºC'),
	(71564, 112, '2015-02-15 01:29:04.000000', 'temperatura', 229.0000, 'ºC'),
	(71565, 112, '2015-02-15 01:29:05.000000', 'temperatura', 987.0000, 'ºC'),
	(71566, 112, '2015-02-15 01:29:06.000000', 'temperatura', 650.0000, 'ºC'),
	(71567, 112, '2015-02-15 01:29:07.000000', 'temperatura', 290.0000, 'ºC'),
	(71568, 112, '2015-02-15 01:29:08.000000', 'temperatura', 701.0000, 'ºC'),
	(71569, 112, '2015-02-15 01:29:09.000000', 'temperatura', 233.0000, 'ºC'),
	(71570, 112, '2015-02-15 01:29:10.000000', 'temperatura', 266.0000, 'ºC'),
	(71571, 112, '2015-02-15 01:29:11.000000', 'temperatura', 628.0000, 'ºC'),
	(71572, 112, '2015-02-15 01:29:12.000000', 'temperatura', 1144.0000, 'ºC'),
	(71573, 112, '2015-02-15 01:29:13.000000', 'temperatura', 236.0000, 'ºC'),
	(71574, 112, '2015-02-15 01:29:14.000000', 'temperatura', 150.0000, 'ºC'),
	(71575, 112, '2015-02-15 01:29:15.000000', 'temperatura', 43.0000, 'ºC'),
	(71576, 112, '2015-02-15 01:29:16.000000', 'temperatura', 965.0000, 'ºC'),
	(71577, 112, '2015-02-15 01:29:17.000000', 'temperatura', 1095.0000, 'ºC'),
	(71578, 112, '2015-02-15 01:29:18.000000', 'temperatura', 183.0000, 'ºC'),
	(71579, 112, '2015-02-15 01:29:19.000000', 'temperatura', 29.0000, 'ºC'),
	(71580, 112, '2015-02-15 01:29:20.000000', 'temperatura', 797.0000, 'ºC'),
	(71581, 112, '2015-02-15 01:29:21.000000', 'temperatura', 296.0000, 'ºC'),
	(71582, 112, '2015-02-15 01:29:22.000000', 'temperatura', 293.0000, 'ºC'),
	(71583, 112, '2015-02-15 01:29:23.000000', 'temperatura', 577.0000, 'ºC'),
	(71584, 112, '2015-02-15 01:29:24.000000', 'temperatura', 806.0000, 'ºC'),
	(71585, 112, '2015-02-15 01:29:25.000000', 'temperatura', 1100.0000, 'ºC'),
	(71586, 112, '2015-02-15 01:29:26.000000', 'temperatura', 682.0000, 'ºC'),
	(71587, 112, '2015-02-15 01:29:27.000000', 'temperatura', 112.0000, 'ºC'),
	(71588, 112, '2015-02-15 01:29:28.000000', 'temperatura', 914.0000, 'ºC'),
	(71589, 112, '2015-02-15 01:29:29.000000', 'temperatura', 636.0000, 'ºC'),
	(71590, 112, '2015-02-15 01:29:30.000000', 'temperatura', 435.0000, 'ºC'),
	(71591, 112, '2015-02-15 01:29:31.000000', 'temperatura', 271.0000, 'ºC'),
	(71592, 112, '2015-02-15 01:29:32.000000', 'temperatura', 50.0000, 'ºC'),
	(71593, 112, '2015-02-15 01:29:33.000000', 'temperatura', 636.0000, 'ºC'),
	(71594, 112, '2015-02-15 01:29:34.000000', 'temperatura', 631.0000, 'ºC'),
	(71595, 112, '2015-02-15 01:29:35.000000', 'temperatura', 49.0000, 'ºC'),
	(71596, 112, '2015-02-15 01:29:36.000000', 'temperatura', 751.0000, 'ºC'),
	(71597, 112, '2015-02-15 01:29:37.000000', 'temperatura', 11.0000, 'ºC'),
	(71598, 112, '2015-02-15 01:29:38.000000', 'temperatura', 200.0000, 'ºC'),
	(71599, 112, '2015-02-15 01:29:39.000000', 'temperatura', 967.0000, 'ºC'),
	(71600, 112, '2015-02-15 01:29:40.000000', 'temperatura', 638.0000, 'ºC'),
	(71601, 112, '2015-02-15 01:29:41.000000', 'temperatura', 288.0000, 'ºC'),
	(71602, 112, '2015-02-15 01:29:42.000000', 'temperatura', 727.0000, 'ºC'),
	(71603, 112, '2015-02-15 01:29:43.000000', 'temperatura', 373.0000, 'ºC'),
	(71604, 112, '2015-02-15 01:29:44.000000', 'temperatura', 885.0000, 'ºC'),
	(71605, 112, '2015-02-15 01:29:45.000000', 'temperatura', 905.0000, 'ºC'),
	(71606, 112, '2015-02-15 01:29:46.000000', 'temperatura', 670.0000, 'ºC'),
	(71607, 112, '2015-02-15 01:29:47.000000', 'temperatura', 635.0000, 'ºC'),
	(71608, 112, '2015-02-15 01:29:48.000000', 'temperatura', 1167.0000, 'ºC'),
	(71609, 112, '2015-02-15 01:29:49.000000', 'temperatura', 328.0000, 'ºC'),
	(71610, 112, '2015-02-15 01:29:50.000000', 'temperatura', 543.0000, 'ºC'),
	(71611, 112, '2015-02-15 01:29:51.000000', 'temperatura', 529.0000, 'ºC'),
	(71612, 112, '2015-02-15 01:29:52.000000', 'temperatura', 1016.0000, 'ºC'),
	(71613, 112, '2015-02-15 01:29:53.000000', 'temperatura', 1095.0000, 'ºC'),
	(71614, 112, '2015-02-15 01:29:54.000000', 'temperatura', 29.0000, 'ºC'),
	(71615, 112, '2015-02-15 01:29:55.000000', 'temperatura', 457.0000, 'ºC'),
	(71616, 112, '2015-02-15 01:29:56.000000', 'temperatura', 1001.0000, 'ºC'),
	(71617, 112, '2015-02-15 01:29:57.000000', 'temperatura', 32.0000, 'ºC'),
	(71618, 112, '2015-02-15 01:29:58.000000', 'temperatura', 759.0000, 'ºC'),
	(71619, 112, '2015-02-15 01:29:59.000000', 'temperatura', 97.0000, 'ºC'),
	(71620, 112, '2015-02-15 01:30:00.000000', 'temperatura', 612.0000, 'ºC'),
	(71621, 112, '2015-02-15 01:30:01.000000', 'temperatura', 368.0000, 'ºC'),
	(71622, 112, '2015-02-15 01:30:02.000000', 'temperatura', 5.0000, 'ºC'),
	(71623, 112, '2015-02-15 01:30:03.000000', 'temperatura', 123.0000, 'ºC'),
	(71624, 112, '2015-02-15 01:30:04.000000', 'temperatura', 601.0000, 'ºC'),
	(71625, 112, '2015-02-15 01:30:05.000000', 'temperatura', 233.0000, 'ºC'),
	(71626, 112, '2015-02-15 01:30:06.000000', 'temperatura', 565.0000, 'ºC'),
	(71627, 112, '2015-02-15 01:30:07.000000', 'temperatura', 926.0000, 'ºC'),
	(71628, 112, '2015-02-15 01:30:08.000000', 'temperatura', 536.0000, 'ºC'),
	(71629, 112, '2015-02-15 01:30:09.000000', 'temperatura', 1103.0000, 'ºC'),
	(71630, 112, '2015-02-15 01:30:10.000000', 'temperatura', 307.0000, 'ºC'),
	(71631, 112, '2015-02-15 01:30:11.000000', 'temperatura', 629.0000, 'ºC'),
	(71632, 112, '2015-02-15 01:30:12.000000', 'temperatura', 1021.0000, 'ºC'),
	(71633, 112, '2015-02-15 01:30:13.000000', 'temperatura', 818.0000, 'ºC'),
	(71634, 112, '2015-02-15 01:30:14.000000', 'temperatura', 1029.0000, 'ºC'),
	(71635, 112, '2015-02-15 01:30:15.000000', 'temperatura', 293.0000, 'ºC'),
	(71636, 112, '2015-02-15 01:30:16.000000', 'temperatura', 777.0000, 'ºC'),
	(71637, 112, '2015-02-15 01:30:17.000000', 'temperatura', 606.0000, 'ºC'),
	(71638, 112, '2015-02-15 01:30:18.000000', 'temperatura', 700.0000, 'ºC'),
	(71639, 112, '2015-02-15 01:30:19.000000', 'temperatura', 484.0000, 'ºC'),
	(71640, 112, '2015-02-15 01:30:20.000000', 'temperatura', 320.0000, 'ºC'),
	(71641, 112, '2015-02-15 01:30:21.000000', 'temperatura', 149.0000, 'ºC'),
	(71642, 112, '2015-02-15 01:30:22.000000', 'temperatura', 986.0000, 'ºC'),
	(71643, 112, '2015-02-15 01:30:23.000000', 'temperatura', 884.0000, 'ºC'),
	(71644, 112, '2015-02-15 01:30:24.000000', 'temperatura', 262.0000, 'ºC'),
	(71645, 112, '2015-02-15 01:30:25.000000', 'temperatura', 1060.0000, 'ºC'),
	(71646, 112, '2015-02-15 01:30:26.000000', 'temperatura', 912.0000, 'ºC'),
	(71647, 112, '2015-02-15 01:30:27.000000', 'temperatura', 181.0000, 'ºC'),
	(71648, 112, '2015-02-15 01:30:28.000000', 'temperatura', 571.0000, 'ºC'),
	(71649, 112, '2015-02-15 01:30:29.000000', 'temperatura', 1113.0000, 'ºC'),
	(71650, 112, '2015-02-15 01:30:30.000000', 'temperatura', 251.0000, 'ºC'),
	(71651, 112, '2015-02-15 01:30:31.000000', 'temperatura', 316.0000, 'ºC'),
	(71652, 112, '2015-02-15 01:30:32.000000', 'temperatura', 827.0000, 'ºC'),
	(71653, 112, '2015-02-15 01:30:33.000000', 'temperatura', 790.0000, 'ºC'),
	(71654, 112, '2015-02-15 01:30:34.000000', 'temperatura', 270.0000, 'ºC'),
	(71655, 112, '2015-02-15 01:30:35.000000', 'temperatura', 178.0000, 'ºC'),
	(71656, 112, '2015-02-15 01:30:36.000000', 'temperatura', 80.0000, 'ºC'),
	(71657, 112, '2015-02-15 01:30:37.000000', 'temperatura', 1066.0000, 'ºC'),
	(71658, 108, '2015-03-01 00:00:00.000000', 'temperatura', 667.0000, 'ºC'),
	(71659, 108, '2015-03-01 00:00:01.000000', 'temperatura', 57.0000, 'ºC'),
	(71660, 108, '2015-03-01 00:00:02.000000', 'temperatura', 684.0000, 'ºC'),
	(71661, 108, '2015-03-01 00:00:03.000000', 'temperatura', 852.0000, 'ºC'),
	(71662, 108, '2015-03-01 00:00:04.000000', 'temperatura', 1005.0000, 'ºC'),
	(71663, 108, '2015-03-01 00:00:05.000000', 'temperatura', 70.0000, 'ºC'),
	(71664, 108, '2015-03-01 00:00:06.000000', 'temperatura', 934.0000, 'ºC'),
	(71665, 108, '2015-03-01 00:00:07.000000', 'temperatura', 864.0000, 'ºC'),
	(71666, 108, '2015-03-01 00:00:08.000000', 'temperatura', 316.0000, 'ºC'),
	(71667, 108, '2015-03-01 00:00:09.000000', 'temperatura', 187.0000, 'ºC'),
	(71668, 108, '2015-03-01 00:00:10.000000', 'temperatura', 1190.0000, 'ºC'),
	(71669, 108, '2015-03-01 00:00:11.000000', 'temperatura', 588.0000, 'ºC'),
	(71670, 108, '2015-03-01 00:00:12.000000', 'temperatura', 571.0000, 'ºC'),
	(71671, 108, '2015-03-01 00:00:13.000000', 'temperatura', 1092.0000, 'ºC'),
	(71672, 108, '2015-03-01 00:00:14.000000', 'temperatura', 148.0000, 'ºC'),
	(71673, 108, '2015-03-01 00:00:15.000000', 'temperatura', 1064.0000, 'ºC'),
	(71674, 108, '2015-03-01 00:00:16.000000', 'temperatura', 75.0000, 'ºC'),
	(71675, 108, '2015-03-01 00:00:17.000000', 'temperatura', 785.0000, 'ºC'),
	(71676, 108, '2015-03-01 00:00:18.000000', 'temperatura', 99.0000, 'ºC'),
	(71677, 108, '2015-03-01 00:00:19.000000', 'temperatura', 540.0000, 'ºC'),
	(71678, 108, '2015-03-01 00:00:20.000000', 'temperatura', 3.0000, 'ºC'),
	(71679, 108, '2015-03-01 00:00:21.000000', 'temperatura', 795.0000, 'ºC'),
	(71680, 108, '2015-03-01 00:00:22.000000', 'temperatura', 366.0000, 'ºC'),
	(71681, 108, '2015-03-01 00:00:23.000000', 'temperatura', 648.0000, 'ºC'),
	(71682, 108, '2015-03-01 00:00:24.000000', 'temperatura', 943.0000, 'ºC'),
	(71683, 108, '2015-03-01 00:00:25.000000', 'temperatura', 371.0000, 'ºC'),
	(71684, 108, '2015-03-01 00:00:26.000000', 'temperatura', 225.0000, 'ºC'),
	(71685, 108, '2015-03-01 00:00:27.000000', 'temperatura', 14.0000, 'ºC'),
	(71686, 108, '2015-03-01 00:00:28.000000', 'temperatura', 594.0000, 'ºC'),
	(71687, 108, '2015-03-01 00:00:29.000000', 'temperatura', 530.0000, 'ºC'),
	(71688, 108, '2015-03-01 00:00:30.000000', 'temperatura', 866.0000, 'ºC'),
	(71689, 108, '2015-03-01 00:00:31.000000', 'temperatura', 342.0000, 'ºC'),
	(71690, 108, '2015-03-01 00:00:32.000000', 'temperatura', 310.0000, 'ºC'),
	(71691, 108, '2015-03-01 00:00:33.000000', 'temperatura', 528.0000, 'ºC'),
	(71692, 108, '2015-03-01 00:00:34.000000', 'temperatura', 508.0000, 'ºC'),
	(71693, 108, '2015-03-01 00:00:35.000000', 'temperatura', 959.0000, 'ºC'),
	(71694, 108, '2015-03-01 00:00:36.000000', 'temperatura', 869.0000, 'ºC'),
	(71695, 108, '2015-03-01 00:00:37.000000', 'temperatura', 268.0000, 'ºC'),
	(71696, 108, '2015-03-01 00:00:38.000000', 'temperatura', 1135.0000, 'ºC'),
	(71697, 108, '2015-03-01 00:00:39.000000', 'temperatura', 70.0000, 'ºC'),
	(71698, 108, '2015-03-01 00:00:40.000000', 'temperatura', 547.0000, 'ºC'),
	(71699, 108, '2015-03-01 00:00:41.000000', 'temperatura', 126.0000, 'ºC'),
	(71700, 108, '2015-03-01 00:00:42.000000', 'temperatura', 189.0000, 'ºC'),
	(71701, 108, '2015-03-01 00:00:43.000000', 'temperatura', 567.0000, 'ºC'),
	(71702, 108, '2015-03-01 00:00:44.000000', 'temperatura', 1070.0000, 'ºC'),
	(71703, 108, '2015-03-01 00:00:45.000000', 'temperatura', 51.0000, 'ºC'),
	(71704, 108, '2015-03-01 00:00:46.000000', 'temperatura', 642.0000, 'ºC'),
	(71705, 108, '2015-03-01 00:00:47.000000', 'temperatura', 659.0000, 'ºC'),
	(71706, 108, '2015-03-01 00:00:48.000000', 'temperatura', 170.0000, 'ºC'),
	(71707, 108, '2015-03-01 00:00:49.000000', 'temperatura', 72.0000, 'ºC'),
	(71708, 108, '2015-03-01 00:00:50.000000', 'temperatura', 1052.0000, 'ºC'),
	(71709, 108, '2015-03-01 00:00:51.000000', 'temperatura', 244.0000, 'ºC'),
	(71710, 108, '2015-03-01 00:00:52.000000', 'temperatura', 464.0000, 'ºC'),
	(71711, 108, '2015-03-01 00:00:53.000000', 'temperatura', 389.0000, 'ºC'),
	(71712, 108, '2015-03-01 00:00:54.000000', 'temperatura', 555.0000, 'ºC'),
	(71713, 108, '2015-03-01 00:00:55.000000', 'temperatura', 409.0000, 'ºC'),
	(71714, 108, '2015-03-01 00:00:56.000000', 'temperatura', 380.0000, 'ºC'),
	(71715, 108, '2015-03-01 00:00:57.000000', 'temperatura', 673.0000, 'ºC'),
	(71716, 108, '2015-03-01 00:00:58.000000', 'temperatura', 1024.0000, 'ºC'),
	(71717, 108, '2015-03-01 00:00:59.000000', 'temperatura', 704.0000, 'ºC'),
	(71718, 108, '2015-03-01 00:01:00.000000', 'temperatura', 447.0000, 'ºC'),
	(71719, 108, '2015-03-01 00:01:01.000000', 'temperatura', 126.0000, 'ºC'),
	(71720, 108, '2015-03-01 00:01:02.000000', 'temperatura', 487.0000, 'ºC'),
	(71721, 108, '2015-03-01 00:01:03.000000', 'temperatura', 859.0000, 'ºC'),
	(71722, 108, '2015-03-01 00:01:04.000000', 'temperatura', 433.0000, 'ºC'),
	(71723, 108, '2015-03-01 00:01:05.000000', 'temperatura', 791.0000, 'ºC'),
	(71724, 108, '2015-03-01 00:01:06.000000', 'temperatura', 255.0000, 'ºC'),
	(71725, 108, '2015-03-01 00:01:07.000000', 'temperatura', 101.0000, 'ºC'),
	(71726, 108, '2015-03-01 00:01:08.000000', 'temperatura', 943.0000, 'ºC'),
	(71727, 108, '2015-03-01 00:01:09.000000', 'temperatura', 811.0000, 'ºC'),
	(71728, 108, '2015-03-01 00:01:10.000000', 'temperatura', 28.0000, 'ºC'),
	(71729, 108, '2015-03-01 00:01:11.000000', 'temperatura', 106.0000, 'ºC'),
	(71730, 108, '2015-03-01 00:01:12.000000', 'temperatura', 446.0000, 'ºC'),
	(71731, 108, '2015-03-01 00:01:13.000000', 'temperatura', 715.0000, 'ºC'),
	(71732, 108, '2015-03-01 00:01:14.000000', 'temperatura', 1036.0000, 'ºC'),
	(71733, 108, '2015-03-01 00:01:15.000000', 'temperatura', 638.0000, 'ºC'),
	(71734, 108, '2015-03-01 00:01:16.000000', 'temperatura', 79.0000, 'ºC'),
	(71735, 108, '2015-03-01 00:01:17.000000', 'temperatura', 883.0000, 'ºC'),
	(71736, 108, '2015-03-01 00:01:18.000000', 'temperatura', 579.0000, 'ºC'),
	(71737, 108, '2015-03-01 00:01:19.000000', 'temperatura', 247.0000, 'ºC'),
	(71738, 108, '2015-03-01 00:01:20.000000', 'temperatura', 696.0000, 'ºC'),
	(71739, 108, '2015-03-01 00:01:21.000000', 'temperatura', 341.0000, 'ºC'),
	(71740, 108, '2015-03-01 00:01:22.000000', 'temperatura', 816.0000, 'ºC'),
	(71741, 108, '2015-03-01 00:01:23.000000', 'temperatura', 660.0000, 'ºC'),
	(71742, 108, '2015-03-01 00:01:24.000000', 'temperatura', 853.0000, 'ºC'),
	(71743, 108, '2015-03-01 00:01:25.000000', 'temperatura', 1084.0000, 'ºC'),
	(71744, 108, '2015-03-01 00:01:26.000000', 'temperatura', 462.0000, 'ºC'),
	(71745, 108, '2015-03-01 00:01:27.000000', 'temperatura', 259.0000, 'ºC'),
	(71746, 108, '2015-03-01 00:01:28.000000', 'temperatura', 1110.0000, 'ºC'),
	(71747, 108, '2015-03-01 00:01:29.000000', 'temperatura', 1173.0000, 'ºC'),
	(71748, 108, '2015-03-01 00:01:30.000000', 'temperatura', 137.0000, 'ºC'),
	(71749, 108, '2015-03-01 00:01:31.000000', 'temperatura', 765.0000, 'ºC'),
	(71750, 108, '2015-03-01 00:01:32.000000', 'temperatura', 1017.0000, 'ºC'),
	(71751, 108, '2015-03-01 00:01:33.000000', 'temperatura', 388.0000, 'ºC'),
	(71752, 108, '2015-03-01 00:01:34.000000', 'temperatura', 88.0000, 'ºC'),
	(71753, 108, '2015-03-01 00:01:35.000000', 'temperatura', 479.0000, 'ºC'),
	(71754, 108, '2015-03-01 00:01:36.000000', 'temperatura', 929.0000, 'ºC'),
	(71755, 108, '2015-03-01 00:01:37.000000', 'temperatura', 810.0000, 'ºC'),
	(71756, 108, '2015-03-01 00:01:38.000000', 'temperatura', 62.0000, 'ºC'),
	(71757, 108, '2015-03-01 00:01:39.000000', 'temperatura', 282.0000, 'ºC'),
	(71758, 108, '2015-03-01 00:01:40.000000', 'temperatura', 23.0000, 'ºC'),
	(71759, 108, '2015-03-01 00:01:41.000000', 'temperatura', 471.0000, 'ºC'),
	(71760, 108, '2015-03-01 00:01:42.000000', 'temperatura', 1085.0000, 'ºC'),
	(71761, 108, '2015-03-01 00:01:43.000000', 'temperatura', 413.0000, 'ºC'),
	(71762, 108, '2015-03-01 00:01:44.000000', 'temperatura', 11.0000, 'ºC'),
	(71763, 108, '2015-03-01 00:01:45.000000', 'temperatura', 16.0000, 'ºC'),
	(71764, 108, '2015-03-01 00:01:46.000000', 'temperatura', 47.0000, 'ºC'),
	(71765, 108, '2015-03-01 00:01:47.000000', 'temperatura', 188.0000, 'ºC'),
	(71766, 108, '2015-03-01 00:01:48.000000', 'temperatura', 799.0000, 'ºC'),
	(71767, 108, '2015-03-01 00:01:49.000000', 'temperatura', 1033.0000, 'ºC'),
	(71768, 108, '2015-03-01 00:01:50.000000', 'temperatura', 370.0000, 'ºC'),
	(71769, 108, '2015-03-01 00:01:51.000000', 'temperatura', 1149.0000, 'ºC'),
	(71770, 108, '2015-03-01 00:01:52.000000', 'temperatura', 1034.0000, 'ºC'),
	(71771, 108, '2015-03-01 00:01:53.000000', 'temperatura', 526.0000, 'ºC'),
	(71772, 108, '2015-03-01 00:01:54.000000', 'temperatura', 727.0000, 'ºC'),
	(71773, 108, '2015-03-01 00:01:55.000000', 'temperatura', 857.0000, 'ºC'),
	(71774, 108, '2015-03-01 00:01:56.000000', 'temperatura', 904.0000, 'ºC'),
	(71775, 108, '2015-03-01 00:01:57.000000', 'temperatura', 749.0000, 'ºC'),
	(71776, 108, '2015-03-01 00:01:58.000000', 'temperatura', 1033.0000, 'ºC'),
	(71777, 108, '2015-03-01 00:01:59.000000', 'temperatura', 521.0000, 'ºC'),
	(71778, 108, '2015-03-01 00:02:00.000000', 'temperatura', 707.0000, 'ºC'),
	(71779, 108, '2015-03-01 00:02:01.000000', 'temperatura', 773.0000, 'ºC'),
	(71780, 108, '2015-03-01 00:02:02.000000', 'temperatura', 544.0000, 'ºC'),
	(71781, 108, '2015-03-01 00:02:03.000000', 'temperatura', 400.0000, 'ºC'),
	(71782, 108, '2015-03-01 00:02:04.000000', 'temperatura', 371.0000, 'ºC'),
	(71783, 108, '2015-03-01 00:02:05.000000', 'temperatura', 653.0000, 'ºC'),
	(71784, 108, '2015-03-01 00:02:06.000000', 'temperatura', 955.0000, 'ºC'),
	(71785, 108, '2015-03-01 00:02:07.000000', 'temperatura', 415.0000, 'ºC'),
	(71786, 108, '2015-03-01 00:02:08.000000', 'temperatura', 412.0000, 'ºC'),
	(71787, 108, '2015-03-01 00:02:09.000000', 'temperatura', 816.0000, 'ºC'),
	(71788, 108, '2015-03-01 00:02:10.000000', 'temperatura', 443.0000, 'ºC'),
	(71789, 108, '2015-03-01 00:02:11.000000', 'temperatura', 969.0000, 'ºC'),
	(71790, 108, '2015-03-01 00:02:12.000000', 'temperatura', 1116.0000, 'ºC'),
	(71791, 108, '2015-03-01 00:02:13.000000', 'temperatura', 274.0000, 'ºC'),
	(71792, 108, '2015-03-01 00:02:14.000000', 'temperatura', 424.0000, 'ºC'),
	(71793, 108, '2015-03-01 00:02:15.000000', 'temperatura', 98.0000, 'ºC'),
	(71794, 108, '2015-03-01 00:02:16.000000', 'temperatura', 417.0000, 'ºC'),
	(71795, 108, '2015-03-01 00:02:17.000000', 'temperatura', 591.0000, 'ºC'),
	(71796, 108, '2015-03-01 00:02:18.000000', 'temperatura', 504.0000, 'ºC'),
	(71797, 108, '2015-03-01 00:02:19.000000', 'temperatura', 746.0000, 'ºC'),
	(71798, 108, '2015-03-01 00:02:20.000000', 'temperatura', 1022.0000, 'ºC'),
	(71799, 108, '2015-03-01 00:02:21.000000', 'temperatura', 471.0000, 'ºC'),
	(71800, 108, '2015-03-01 00:02:22.000000', 'temperatura', 492.0000, 'ºC'),
	(71801, 108, '2015-03-01 00:02:23.000000', 'temperatura', 1045.0000, 'ºC'),
	(71802, 108, '2015-03-01 00:02:24.000000', 'temperatura', 150.0000, 'ºC'),
	(71803, 108, '2015-03-01 00:02:25.000000', 'temperatura', 14.0000, 'ºC'),
	(71804, 108, '2015-03-01 00:02:26.000000', 'temperatura', 822.0000, 'ºC'),
	(71805, 108, '2015-03-01 00:02:27.000000', 'temperatura', 470.0000, 'ºC'),
	(71806, 108, '2015-03-01 00:02:28.000000', 'temperatura', 1081.0000, 'ºC'),
	(71807, 108, '2015-03-01 00:02:29.000000', 'temperatura', 398.0000, 'ºC'),
	(71808, 108, '2015-03-01 00:02:30.000000', 'temperatura', 1147.0000, 'ºC'),
	(71809, 108, '2015-03-01 00:02:31.000000', 'temperatura', 940.0000, 'ºC'),
	(71810, 108, '2015-03-01 00:02:32.000000', 'temperatura', 60.0000, 'ºC'),
	(71811, 108, '2015-03-01 00:02:33.000000', 'temperatura', 1082.0000, 'ºC'),
	(71812, 108, '2015-03-01 00:02:34.000000', 'temperatura', 429.0000, 'ºC'),
	(71813, 108, '2015-03-01 00:02:35.000000', 'temperatura', 99.0000, 'ºC'),
	(71814, 108, '2015-03-01 00:02:36.000000', 'temperatura', 409.0000, 'ºC'),
	(71815, 108, '2015-03-01 00:02:37.000000', 'temperatura', 548.0000, 'ºC'),
	(71816, 108, '2015-03-01 00:02:38.000000', 'temperatura', 315.0000, 'ºC'),
	(71817, 108, '2015-03-01 00:02:39.000000', 'temperatura', 1130.0000, 'ºC'),
	(71818, 108, '2015-03-01 00:02:40.000000', 'temperatura', 1108.0000, 'ºC'),
	(71819, 108, '2015-03-01 00:02:41.000000', 'temperatura', 949.0000, 'ºC'),
	(71820, 108, '2015-03-01 00:02:42.000000', 'temperatura', 223.0000, 'ºC'),
	(71821, 108, '2015-03-01 00:02:43.000000', 'temperatura', 668.0000, 'ºC'),
	(71822, 108, '2015-03-01 00:02:44.000000', 'temperatura', 269.0000, 'ºC'),
	(71823, 108, '2015-03-01 00:02:45.000000', 'temperatura', 544.0000, 'ºC'),
	(71824, 108, '2015-03-01 00:02:46.000000', 'temperatura', 713.0000, 'ºC'),
	(71825, 108, '2015-03-01 00:02:47.000000', 'temperatura', 732.0000, 'ºC'),
	(71826, 108, '2015-03-01 00:02:48.000000', 'temperatura', 323.0000, 'ºC'),
	(71827, 108, '2015-03-01 00:02:49.000000', 'temperatura', 621.0000, 'ºC'),
	(71828, 108, '2015-03-01 00:02:50.000000', 'temperatura', 934.0000, 'ºC'),
	(71829, 108, '2015-03-01 00:02:51.000000', 'temperatura', 410.0000, 'ºC'),
	(71830, 108, '2015-03-01 00:02:52.000000', 'temperatura', 449.0000, 'ºC'),
	(71831, 108, '2015-03-01 00:02:53.000000', 'temperatura', 1015.0000, 'ºC'),
	(71832, 108, '2015-03-01 00:02:54.000000', 'temperatura', 129.0000, 'ºC'),
	(71833, 108, '2015-03-01 00:02:55.000000', 'temperatura', 0.0000, 'ºC'),
	(71834, 108, '2015-03-01 00:02:56.000000', 'temperatura', 815.0000, 'ºC'),
	(71835, 108, '2015-03-01 00:02:57.000000', 'temperatura', 473.0000, 'ºC'),
	(71836, 108, '2015-03-01 00:02:58.000000', 'temperatura', 1122.0000, 'ºC'),
	(71837, 108, '2015-03-01 00:02:59.000000', 'temperatura', 590.0000, 'ºC'),
	(71838, 108, '2015-03-01 00:03:00.000000', 'temperatura', 783.0000, 'ºC'),
	(71839, 108, '2015-03-01 00:03:01.000000', 'temperatura', 948.0000, 'ºC'),
	(71840, 108, '2015-03-01 00:03:02.000000', 'temperatura', 1191.0000, 'ºC'),
	(71841, 108, '2015-03-01 00:03:03.000000', 'temperatura', 711.0000, 'ºC'),
	(71842, 108, '2015-03-01 00:03:04.000000', 'temperatura', 1184.0000, 'ºC'),
	(71843, 108, '2015-03-01 00:03:05.000000', 'temperatura', 188.0000, 'ºC'),
	(71844, 108, '2015-03-01 00:03:06.000000', 'temperatura', 986.0000, 'ºC'),
	(71845, 108, '2015-03-01 00:03:07.000000', 'temperatura', 768.0000, 'ºC'),
	(71846, 108, '2015-03-01 00:03:08.000000', 'temperatura', 882.0000, 'ºC'),
	(71847, 108, '2015-03-01 00:03:09.000000', 'temperatura', 908.0000, 'ºC'),
	(71848, 108, '2015-03-01 00:03:10.000000', 'temperatura', 694.0000, 'ºC'),
	(71849, 108, '2015-03-01 00:03:11.000000', 'temperatura', 746.0000, 'ºC'),
	(71850, 108, '2015-03-01 00:03:12.000000', 'temperatura', 450.0000, 'ºC'),
	(71851, 108, '2015-03-01 00:03:13.000000', 'temperatura', 13.0000, 'ºC'),
	(71852, 108, '2015-03-01 00:03:14.000000', 'temperatura', 1114.0000, 'ºC'),
	(71853, 108, '2015-03-01 00:03:15.000000', 'temperatura', 730.0000, 'ºC'),
	(71854, 108, '2015-03-01 00:03:16.000000', 'temperatura', 311.0000, 'ºC'),
	(71855, 108, '2015-03-01 00:03:17.000000', 'temperatura', 563.0000, 'ºC'),
	(71856, 108, '2015-03-01 00:03:18.000000', 'temperatura', 682.0000, 'ºC'),
	(71857, 108, '2015-03-01 00:03:19.000000', 'temperatura', 523.0000, 'ºC'),
	(71858, 108, '2015-03-01 00:03:20.000000', 'temperatura', 569.0000, 'ºC'),
	(71859, 108, '2015-03-01 00:03:21.000000', 'temperatura', 79.0000, 'ºC'),
	(71860, 108, '2015-03-01 00:03:22.000000', 'temperatura', 1085.0000, 'ºC'),
	(71861, 108, '2015-03-01 00:03:23.000000', 'temperatura', 389.0000, 'ºC'),
	(71862, 108, '2015-03-01 00:03:24.000000', 'temperatura', 1093.0000, 'ºC'),
	(71863, 108, '2015-03-01 00:03:25.000000', 'temperatura', 696.0000, 'ºC'),
	(71864, 108, '2015-03-01 00:03:26.000000', 'temperatura', 201.0000, 'ºC'),
	(71865, 108, '2015-03-01 00:03:27.000000', 'temperatura', 117.0000, 'ºC'),
	(71866, 108, '2015-03-01 00:03:28.000000', 'temperatura', 1185.0000, 'ºC'),
	(71867, 108, '2015-03-01 00:03:29.000000', 'temperatura', 775.0000, 'ºC'),
	(71868, 108, '2015-03-01 00:03:30.000000', 'temperatura', 318.0000, 'ºC'),
	(71869, 108, '2015-03-01 00:03:31.000000', 'temperatura', 464.0000, 'ºC'),
	(71870, 108, '2015-03-01 00:03:32.000000', 'temperatura', 170.0000, 'ºC'),
	(71871, 108, '2015-03-01 00:03:33.000000', 'temperatura', 658.0000, 'ºC'),
	(71872, 108, '2015-03-01 00:03:34.000000', 'temperatura', 382.0000, 'ºC'),
	(71873, 108, '2015-03-01 00:03:35.000000', 'temperatura', 1135.0000, 'ºC'),
	(71874, 108, '2015-03-01 00:03:36.000000', 'temperatura', 931.0000, 'ºC'),
	(71875, 108, '2015-03-01 00:03:37.000000', 'temperatura', 52.0000, 'ºC'),
	(71876, 108, '2015-03-01 00:03:38.000000', 'temperatura', 1064.0000, 'ºC'),
	(71877, 108, '2015-03-01 00:03:39.000000', 'temperatura', 364.0000, 'ºC'),
	(71878, 108, '2015-03-01 00:03:40.000000', 'temperatura', 1031.0000, 'ºC'),
	(71879, 108, '2015-03-01 00:03:41.000000', 'temperatura', 463.0000, 'ºC'),
	(71880, 108, '2015-03-01 00:03:42.000000', 'temperatura', 420.0000, 'ºC'),
	(71881, 108, '2015-03-01 00:03:43.000000', 'temperatura', 715.0000, 'ºC'),
	(71882, 108, '2015-03-01 00:03:44.000000', 'temperatura', 1115.0000, 'ºC'),
	(71883, 108, '2015-03-01 00:03:45.000000', 'temperatura', 1028.0000, 'ºC'),
	(71884, 108, '2015-03-01 00:03:46.000000', 'temperatura', 598.0000, 'ºC'),
	(71885, 108, '2015-03-01 00:03:47.000000', 'temperatura', 1105.0000, 'ºC'),
	(71886, 108, '2015-03-01 00:03:48.000000', 'temperatura', 132.0000, 'ºC'),
	(71887, 108, '2015-03-01 00:03:49.000000', 'temperatura', 944.0000, 'ºC'),
	(71888, 108, '2015-03-01 00:03:50.000000', 'temperatura', 725.0000, 'ºC'),
	(71889, 108, '2015-03-01 00:03:51.000000', 'temperatura', 793.0000, 'ºC'),
	(71890, 108, '2015-03-01 00:03:52.000000', 'temperatura', 590.0000, 'ºC'),
	(71891, 108, '2015-03-01 00:03:53.000000', 'temperatura', 574.0000, 'ºC'),
	(71892, 108, '2015-03-01 00:03:54.000000', 'temperatura', 1098.0000, 'ºC'),
	(71893, 108, '2015-03-01 00:03:55.000000', 'temperatura', 169.0000, 'ºC'),
	(71894, 108, '2015-03-01 00:03:56.000000', 'temperatura', 1150.0000, 'ºC'),
	(71895, 108, '2015-03-01 00:03:57.000000', 'temperatura', 446.0000, 'ºC'),
	(71896, 108, '2015-03-01 00:03:58.000000', 'temperatura', 1180.0000, 'ºC'),
	(71897, 108, '2015-03-01 00:03:59.000000', 'temperatura', 961.0000, 'ºC'),
	(71898, 108, '2015-03-01 00:04:00.000000', 'temperatura', 65.0000, 'ºC'),
	(71899, 108, '2015-03-01 00:04:01.000000', 'temperatura', 1044.0000, 'ºC'),
	(71900, 108, '2015-03-01 00:04:02.000000', 'temperatura', 223.0000, 'ºC'),
	(71901, 108, '2015-03-01 00:04:03.000000', 'temperatura', 387.0000, 'ºC'),
	(71902, 108, '2015-03-01 00:04:04.000000', 'temperatura', 64.0000, 'ºC'),
	(71903, 108, '2015-03-01 00:04:05.000000', 'temperatura', 362.0000, 'ºC'),
	(71904, 108, '2015-03-01 00:04:06.000000', 'temperatura', 419.0000, 'ºC'),
	(71905, 108, '2015-03-01 00:04:07.000000', 'temperatura', 1008.0000, 'ºC'),
	(71906, 108, '2015-03-01 00:04:08.000000', 'temperatura', 185.0000, 'ºC'),
	(71907, 108, '2015-03-01 00:04:09.000000', 'temperatura', 302.0000, 'ºC'),
	(71908, 108, '2015-03-01 00:04:10.000000', 'temperatura', 953.0000, 'ºC'),
	(71909, 108, '2015-03-01 00:04:11.000000', 'temperatura', 259.0000, 'ºC'),
	(71910, 108, '2015-03-01 00:04:12.000000', 'temperatura', 838.0000, 'ºC'),
	(71911, 108, '2015-03-01 00:04:13.000000', 'temperatura', 1015.0000, 'ºC'),
	(71912, 108, '2015-03-01 00:04:14.000000', 'temperatura', 158.0000, 'ºC'),
	(71913, 108, '2015-03-01 00:04:15.000000', 'temperatura', 149.0000, 'ºC'),
	(71914, 108, '2015-03-01 00:04:16.000000', 'temperatura', 268.0000, 'ºC'),
	(71915, 108, '2015-03-01 00:04:17.000000', 'temperatura', 897.0000, 'ºC'),
	(71916, 108, '2015-03-01 00:04:18.000000', 'temperatura', 79.0000, 'ºC'),
	(71917, 108, '2015-03-01 00:04:19.000000', 'temperatura', 107.0000, 'ºC'),
	(71918, 108, '2015-03-01 00:04:20.000000', 'temperatura', 298.0000, 'ºC'),
	(71919, 108, '2015-03-01 00:04:21.000000', 'temperatura', 1170.0000, 'ºC'),
	(71920, 108, '2015-03-01 00:04:22.000000', 'temperatura', 157.0000, 'ºC'),
	(71921, 108, '2015-03-01 00:04:23.000000', 'temperatura', 873.0000, 'ºC'),
	(71922, 108, '2015-03-01 00:04:24.000000', 'temperatura', 295.0000, 'ºC'),
	(71923, 108, '2015-03-01 00:04:25.000000', 'temperatura', 59.0000, 'ºC'),
	(71924, 108, '2015-03-01 00:04:26.000000', 'temperatura', 607.0000, 'ºC'),
	(71925, 108, '2015-03-01 00:04:27.000000', 'temperatura', 461.0000, 'ºC'),
	(71926, 108, '2015-03-01 00:04:28.000000', 'temperatura', 485.0000, 'ºC'),
	(71927, 108, '2015-03-01 00:04:29.000000', 'temperatura', 1042.0000, 'ºC'),
	(71928, 108, '2015-03-01 00:04:30.000000', 'temperatura', 154.0000, 'ºC'),
	(71929, 108, '2015-03-01 00:04:31.000000', 'temperatura', 47.0000, 'ºC'),
	(71930, 108, '2015-03-01 00:04:32.000000', 'temperatura', 970.0000, 'ºC'),
	(71931, 108, '2015-03-01 00:04:33.000000', 'temperatura', 1113.0000, 'ºC'),
	(71932, 108, '2015-03-01 00:04:34.000000', 'temperatura', 254.0000, 'ºC'),
	(71933, 108, '2015-03-01 00:04:35.000000', 'temperatura', 333.0000, 'ºC'),
	(71934, 108, '2015-03-01 00:04:36.000000', 'temperatura', 903.0000, 'ºC'),
	(71935, 108, '2015-03-01 00:04:37.000000', 'temperatura', 1117.0000, 'ºC'),
	(71936, 108, '2015-03-01 00:04:38.000000', 'temperatura', 477.0000, 'ºC'),
	(71937, 108, '2015-03-01 00:04:39.000000', 'temperatura', 235.0000, 'ºC'),
	(71938, 108, '2015-03-01 00:04:40.000000', 'temperatura', 945.0000, 'ºC'),
	(71939, 108, '2015-03-01 00:04:41.000000', 'temperatura', 420.0000, 'ºC'),
	(71940, 108, '2015-03-01 00:04:42.000000', 'temperatura', 467.0000, 'ºC'),
	(71941, 108, '2015-03-01 00:04:43.000000', 'temperatura', 1074.0000, 'ºC'),
	(71942, 108, '2015-03-01 00:04:44.000000', 'temperatura', 370.0000, 'ºC'),
	(71943, 108, '2015-03-01 00:04:45.000000', 'temperatura', 1027.0000, 'ºC'),
	(71944, 108, '2015-03-01 00:04:46.000000', 'temperatura', 426.0000, 'ºC'),
	(71945, 108, '2015-03-01 00:04:47.000000', 'temperatura', 250.0000, 'ºC'),
	(71946, 108, '2015-03-01 00:04:48.000000', 'temperatura', 1171.0000, 'ºC'),
	(71947, 108, '2015-03-01 00:04:49.000000', 'temperatura', 308.0000, 'ºC'),
	(71948, 108, '2015-03-01 00:04:50.000000', 'temperatura', 428.0000, 'ºC'),
	(71949, 108, '2015-03-01 00:04:51.000000', 'temperatura', 14.0000, 'ºC'),
	(71950, 108, '2015-03-01 00:04:52.000000', 'temperatura', 1187.0000, 'ºC'),
	(71951, 108, '2015-03-01 00:04:53.000000', 'temperatura', 1092.0000, 'ºC'),
	(71952, 108, '2015-03-01 00:04:54.000000', 'temperatura', 703.0000, 'ºC'),
	(71953, 108, '2015-03-01 00:04:55.000000', 'temperatura', 236.0000, 'ºC'),
	(71954, 108, '2015-03-01 00:04:56.000000', 'temperatura', 274.0000, 'ºC'),
	(71955, 108, '2015-03-01 00:04:57.000000', 'temperatura', 661.0000, 'ºC'),
	(71956, 108, '2015-03-01 00:04:58.000000', 'temperatura', 82.0000, 'ºC'),
	(71957, 108, '2015-03-01 00:04:59.000000', 'temperatura', 829.0000, 'ºC'),
	(71958, 108, '2015-03-01 00:05:00.000000', 'temperatura', 299.0000, 'ºC'),
	(71959, 108, '2015-03-01 00:05:01.000000', 'temperatura', 209.0000, 'ºC'),
	(71960, 108, '2015-03-01 00:05:02.000000', 'temperatura', 146.0000, 'ºC'),
	(71961, 108, '2015-03-01 00:05:03.000000', 'temperatura', 107.0000, 'ºC'),
	(71962, 108, '2015-03-01 00:05:04.000000', 'temperatura', 95.0000, 'ºC'),
	(71963, 108, '2015-03-01 00:05:05.000000', 'temperatura', 155.0000, 'ºC'),
	(71964, 108, '2015-03-01 00:05:06.000000', 'temperatura', 490.0000, 'ºC'),
	(71965, 108, '2015-03-01 00:05:07.000000', 'temperatura', 784.0000, 'ºC'),
	(71966, 108, '2015-03-01 00:05:08.000000', 'temperatura', 54.0000, 'ºC'),
	(71967, 108, '2015-03-01 00:05:09.000000', 'temperatura', 316.0000, 'ºC'),
	(71968, 108, '2015-03-01 00:05:10.000000', 'temperatura', 219.0000, 'ºC'),
	(71969, 108, '2015-03-01 00:05:11.000000', 'temperatura', 147.0000, 'ºC'),
	(71970, 108, '2015-03-01 00:05:12.000000', 'temperatura', 77.0000, 'ºC'),
	(71971, 108, '2015-03-01 00:05:13.000000', 'temperatura', 1146.0000, 'ºC'),
	(71972, 108, '2015-03-01 00:05:14.000000', 'temperatura', 701.0000, 'ºC'),
	(71973, 108, '2015-03-01 00:05:15.000000', 'temperatura', 67.0000, 'ºC'),
	(71974, 108, '2015-03-01 00:05:16.000000', 'temperatura', 633.0000, 'ºC'),
	(71975, 108, '2015-03-01 00:05:17.000000', 'temperatura', 562.0000, 'ºC'),
	(71976, 108, '2015-03-01 00:05:18.000000', 'temperatura', 912.0000, 'ºC'),
	(71977, 108, '2015-03-01 00:05:19.000000', 'temperatura', 477.0000, 'ºC'),
	(71978, 108, '2015-03-01 00:05:20.000000', 'temperatura', 848.0000, 'ºC'),
	(71979, 108, '2015-03-01 00:05:21.000000', 'temperatura', 409.0000, 'ºC'),
	(71980, 108, '2015-03-01 00:05:22.000000', 'temperatura', 701.0000, 'ºC'),
	(71981, 108, '2015-03-01 00:05:23.000000', 'temperatura', 1078.0000, 'ºC'),
	(71982, 108, '2015-03-01 00:05:24.000000', 'temperatura', 890.0000, 'ºC'),
	(71983, 108, '2015-03-01 00:05:25.000000', 'temperatura', 15.0000, 'ºC'),
	(71984, 108, '2015-03-01 00:05:26.000000', 'temperatura', 1004.0000, 'ºC'),
	(71985, 108, '2015-03-01 00:05:27.000000', 'temperatura', 177.0000, 'ºC'),
	(71986, 108, '2015-03-01 00:05:28.000000', 'temperatura', 274.0000, 'ºC'),
	(71987, 108, '2015-03-01 00:05:29.000000', 'temperatura', 840.0000, 'ºC'),
	(71988, 108, '2015-03-01 00:05:30.000000', 'temperatura', 980.0000, 'ºC'),
	(71989, 108, '2015-03-01 00:05:31.000000', 'temperatura', 1179.0000, 'ºC'),
	(71990, 108, '2015-03-01 00:05:32.000000', 'temperatura', 554.0000, 'ºC'),
	(71991, 108, '2015-03-01 00:05:33.000000', 'temperatura', 434.0000, 'ºC'),
	(71992, 108, '2015-03-01 00:05:34.000000', 'temperatura', 509.0000, 'ºC'),
	(71993, 108, '2015-03-01 00:05:35.000000', 'temperatura', 44.0000, 'ºC'),
	(71994, 108, '2015-03-01 00:05:36.000000', 'temperatura', 1094.0000, 'ºC'),
	(71995, 108, '2015-03-01 00:05:37.000000', 'temperatura', 538.0000, 'ºC'),
	(71996, 108, '2015-03-01 00:05:38.000000', 'temperatura', 610.0000, 'ºC'),
	(71997, 108, '2015-03-01 00:05:39.000000', 'temperatura', 235.0000, 'ºC'),
	(71998, 108, '2015-03-01 00:05:40.000000', 'temperatura', 547.0000, 'ºC'),
	(71999, 108, '2015-03-01 00:05:41.000000', 'temperatura', 831.0000, 'ºC'),
	(72000, 108, '2015-03-01 00:05:42.000000', 'temperatura', 113.0000, 'ºC'),
	(72001, 108, '2015-03-01 00:05:43.000000', 'temperatura', 474.0000, 'ºC'),
	(72002, 108, '2015-03-01 00:05:44.000000', 'temperatura', 833.0000, 'ºC'),
	(72003, 108, '2015-03-01 00:05:45.000000', 'temperatura', 340.0000, 'ºC'),
	(72004, 108, '2015-03-01 00:05:46.000000', 'temperatura', 403.0000, 'ºC'),
	(72005, 108, '2015-03-01 00:05:47.000000', 'temperatura', 994.0000, 'ºC'),
	(72006, 108, '2015-03-01 00:05:48.000000', 'temperatura', 161.0000, 'ºC'),
	(72007, 108, '2015-03-01 00:05:49.000000', 'temperatura', 223.0000, 'ºC'),
	(72008, 108, '2015-03-01 00:05:50.000000', 'temperatura', 636.0000, 'ºC'),
	(72009, 108, '2015-03-01 00:05:51.000000', 'temperatura', 108.0000, 'ºC'),
	(72010, 108, '2015-03-01 00:05:52.000000', 'temperatura', 1034.0000, 'ºC'),
	(72011, 108, '2015-03-01 00:05:53.000000', 'temperatura', 45.0000, 'ºC'),
	(72012, 108, '2015-03-01 00:05:54.000000', 'temperatura', 724.0000, 'ºC'),
	(72013, 108, '2015-03-01 00:05:55.000000', 'temperatura', 1088.0000, 'ºC'),
	(72014, 108, '2015-03-01 00:05:56.000000', 'temperatura', 866.0000, 'ºC'),
	(72015, 108, '2015-03-01 00:05:57.000000', 'temperatura', 1068.0000, 'ºC'),
	(72016, 108, '2015-03-01 00:05:58.000000', 'temperatura', 341.0000, 'ºC'),
	(72017, 108, '2015-03-01 00:05:59.000000', 'temperatura', 903.0000, 'ºC'),
	(72018, 108, '2015-03-01 00:06:00.000000', 'temperatura', 1091.0000, 'ºC'),
	(72019, 108, '2015-03-01 00:06:01.000000', 'temperatura', 348.0000, 'ºC'),
	(72020, 108, '2015-03-01 00:06:02.000000', 'temperatura', 869.0000, 'ºC'),
	(72021, 108, '2015-03-01 00:06:03.000000', 'temperatura', 898.0000, 'ºC'),
	(72022, 108, '2015-03-01 00:06:04.000000', 'temperatura', 686.0000, 'ºC'),
	(72023, 108, '2015-03-01 00:06:05.000000', 'temperatura', 737.0000, 'ºC'),
	(72024, 108, '2015-03-01 00:06:06.000000', 'temperatura', 427.0000, 'ºC'),
	(72025, 108, '2015-03-01 00:06:07.000000', 'temperatura', 1124.0000, 'ºC'),
	(72026, 108, '2015-03-01 00:06:08.000000', 'temperatura', 739.0000, 'ºC'),
	(72027, 108, '2015-03-01 00:06:09.000000', 'temperatura', 323.0000, 'ºC'),
	(72028, 108, '2015-03-01 00:06:10.000000', 'temperatura', 600.0000, 'ºC'),
	(72029, 108, '2015-03-01 00:06:11.000000', 'temperatura', 830.0000, 'ºC'),
	(72030, 108, '2015-03-01 00:06:12.000000', 'temperatura', 1151.0000, 'ºC'),
	(72031, 108, '2015-03-01 00:06:13.000000', 'temperatura', 864.0000, 'ºC'),
	(72032, 108, '2015-03-01 00:06:14.000000', 'temperatura', 869.0000, 'ºC'),
	(72033, 108, '2015-03-01 00:06:15.000000', 'temperatura', 554.0000, 'ºC'),
	(72034, 108, '2015-03-01 00:06:16.000000', 'temperatura', 161.0000, 'ºC'),
	(72035, 108, '2015-03-01 00:06:17.000000', 'temperatura', 344.0000, 'ºC'),
	(72036, 108, '2015-03-01 00:06:18.000000', 'temperatura', 38.0000, 'ºC'),
	(72037, 108, '2015-03-01 00:06:19.000000', 'temperatura', 360.0000, 'ºC'),
	(72038, 108, '2015-03-01 00:06:20.000000', 'temperatura', 487.0000, 'ºC'),
	(72039, 108, '2015-03-01 00:06:21.000000', 'temperatura', 153.0000, 'ºC'),
	(72040, 108, '2015-03-01 00:06:22.000000', 'temperatura', 506.0000, 'ºC'),
	(72041, 108, '2015-03-01 00:06:23.000000', 'temperatura', 871.0000, 'ºC'),
	(72042, 108, '2015-03-01 00:06:24.000000', 'temperatura', 440.0000, 'ºC'),
	(72043, 108, '2015-03-01 00:06:25.000000', 'temperatura', 785.0000, 'ºC'),
	(72044, 108, '2015-03-01 00:06:26.000000', 'temperatura', 204.0000, 'ºC'),
	(72045, 108, '2015-03-01 00:06:27.000000', 'temperatura', 1067.0000, 'ºC'),
	(72046, 108, '2015-03-01 00:06:28.000000', 'temperatura', 1123.0000, 'ºC'),
	(72047, 108, '2015-03-01 00:06:29.000000', 'temperatura', 13.0000, 'ºC'),
	(72048, 108, '2015-03-01 00:06:30.000000', 'temperatura', 300.0000, 'ºC'),
	(72049, 108, '2015-03-01 00:06:31.000000', 'temperatura', 259.0000, 'ºC'),
	(72050, 108, '2015-03-01 00:06:32.000000', 'temperatura', 398.0000, 'ºC'),
	(72051, 108, '2015-03-01 00:06:33.000000', 'temperatura', 13.0000, 'ºC'),
	(72052, 108, '2015-03-01 00:06:34.000000', 'temperatura', 72.0000, 'ºC'),
	(72053, 108, '2015-03-01 00:06:35.000000', 'temperatura', 319.0000, 'ºC'),
	(72054, 108, '2015-03-01 00:06:36.000000', 'temperatura', 183.0000, 'ºC'),
	(72055, 108, '2015-03-01 00:06:37.000000', 'temperatura', 1156.0000, 'ºC'),
	(72056, 108, '2015-03-01 00:06:38.000000', 'temperatura', 431.0000, 'ºC'),
	(72057, 108, '2015-03-01 00:06:39.000000', 'temperatura', 1089.0000, 'ºC'),
	(72058, 108, '2015-03-01 00:06:40.000000', 'temperatura', 554.0000, 'ºC'),
	(72059, 108, '2015-03-01 00:06:41.000000', 'temperatura', 701.0000, 'ºC'),
	(72060, 108, '2015-03-01 00:06:42.000000', 'temperatura', 645.0000, 'ºC'),
	(72061, 108, '2015-03-01 00:06:43.000000', 'temperatura', 1121.0000, 'ºC'),
	(72062, 108, '2015-03-01 00:06:44.000000', 'temperatura', 70.0000, 'ºC'),
	(72063, 108, '2015-03-01 00:06:45.000000', 'temperatura', 589.0000, 'ºC'),
	(72064, 108, '2015-03-01 00:06:46.000000', 'temperatura', 335.0000, 'ºC'),
	(72065, 108, '2015-03-01 00:06:47.000000', 'temperatura', 1107.0000, 'ºC'),
	(72066, 108, '2015-03-01 00:06:48.000000', 'temperatura', 930.0000, 'ºC'),
	(72067, 108, '2015-03-01 00:06:49.000000', 'temperatura', 130.0000, 'ºC'),
	(72068, 108, '2015-03-01 00:06:50.000000', 'temperatura', 260.0000, 'ºC'),
	(72069, 108, '2015-03-01 00:06:51.000000', 'temperatura', 910.0000, 'ºC'),
	(72070, 108, '2015-03-01 00:06:52.000000', 'temperatura', 171.0000, 'ºC'),
	(72071, 108, '2015-03-01 00:06:53.000000', 'temperatura', 524.0000, 'ºC'),
	(72072, 108, '2015-03-01 00:06:54.000000', 'temperatura', 907.0000, 'ºC'),
	(72073, 108, '2015-03-01 00:06:55.000000', 'temperatura', 565.0000, 'ºC'),
	(72074, 108, '2015-03-01 00:06:56.000000', 'temperatura', 103.0000, 'ºC'),
	(72075, 108, '2015-03-01 00:06:57.000000', 'temperatura', 21.0000, 'ºC'),
	(72076, 108, '2015-03-01 00:06:58.000000', 'temperatura', 995.0000, 'ºC'),
	(72077, 108, '2015-03-01 00:06:59.000000', 'temperatura', 115.0000, 'ºC'),
	(72078, 108, '2015-03-01 00:07:00.000000', 'temperatura', 1191.0000, 'ºC'),
	(72079, 108, '2015-03-01 00:07:01.000000', 'temperatura', 808.0000, 'ºC'),
	(72080, 108, '2015-03-01 00:07:02.000000', 'temperatura', 470.0000, 'ºC'),
	(72081, 108, '2015-03-01 00:07:03.000000', 'temperatura', 1127.0000, 'ºC'),
	(72082, 108, '2015-03-01 00:07:04.000000', 'temperatura', 625.0000, 'ºC'),
	(72083, 108, '2015-03-01 00:07:05.000000', 'temperatura', 946.0000, 'ºC'),
	(72084, 108, '2015-03-01 00:07:06.000000', 'temperatura', 453.0000, 'ºC'),
	(72085, 108, '2015-03-01 00:07:07.000000', 'temperatura', 628.0000, 'ºC'),
	(72086, 108, '2015-03-01 00:07:08.000000', 'temperatura', 584.0000, 'ºC'),
	(72087, 108, '2015-03-01 00:07:09.000000', 'temperatura', 1034.0000, 'ºC'),
	(72088, 108, '2015-03-01 00:07:10.000000', 'temperatura', 1019.0000, 'ºC'),
	(72089, 108, '2015-03-01 00:07:11.000000', 'temperatura', 795.0000, 'ºC'),
	(72090, 108, '2015-03-01 00:07:12.000000', 'temperatura', 918.0000, 'ºC'),
	(72091, 108, '2015-03-01 00:07:13.000000', 'temperatura', 1007.0000, 'ºC'),
	(72092, 108, '2015-03-01 00:07:14.000000', 'temperatura', 1080.0000, 'ºC'),
	(72093, 108, '2015-03-01 00:07:15.000000', 'temperatura', 1178.0000, 'ºC'),
	(72094, 108, '2015-03-01 00:07:16.000000', 'temperatura', 253.0000, 'ºC'),
	(72095, 108, '2015-03-01 00:07:17.000000', 'temperatura', 130.0000, 'ºC'),
	(72096, 108, '2015-03-01 00:07:18.000000', 'temperatura', 1093.0000, 'ºC'),
	(72097, 108, '2015-03-01 00:07:19.000000', 'temperatura', 276.0000, 'ºC'),
	(72098, 108, '2015-03-01 00:07:20.000000', 'temperatura', 499.0000, 'ºC'),
	(72099, 108, '2015-03-01 00:07:21.000000', 'temperatura', 468.0000, 'ºC'),
	(72100, 108, '2015-03-01 00:07:22.000000', 'temperatura', 844.0000, 'ºC'),
	(72101, 108, '2015-03-01 00:07:23.000000', 'temperatura', 415.0000, 'ºC'),
	(72102, 108, '2015-03-01 00:07:24.000000', 'temperatura', 745.0000, 'ºC'),
	(72103, 108, '2015-03-01 00:07:25.000000', 'temperatura', 82.0000, 'ºC'),
	(72104, 108, '2015-03-01 00:07:26.000000', 'temperatura', 576.0000, 'ºC'),
	(72105, 108, '2015-03-01 00:07:27.000000', 'temperatura', 231.0000, 'ºC'),
	(72106, 108, '2015-03-01 00:07:28.000000', 'temperatura', 630.0000, 'ºC'),
	(72107, 108, '2015-03-01 00:07:29.000000', 'temperatura', 59.0000, 'ºC'),
	(72108, 108, '2015-03-01 00:07:30.000000', 'temperatura', 803.0000, 'ºC'),
	(72109, 108, '2015-03-01 00:07:31.000000', 'temperatura', 240.0000, 'ºC'),
	(72110, 108, '2015-03-01 00:07:32.000000', 'temperatura', 1189.0000, 'ºC'),
	(72111, 108, '2015-03-01 00:07:33.000000', 'temperatura', 428.0000, 'ºC'),
	(72112, 108, '2015-03-01 00:07:34.000000', 'temperatura', 971.0000, 'ºC'),
	(72113, 108, '2015-03-01 00:07:35.000000', 'temperatura', 1172.0000, 'ºC'),
	(72114, 108, '2015-03-01 00:07:36.000000', 'temperatura', 546.0000, 'ºC'),
	(72115, 108, '2015-03-01 00:07:37.000000', 'temperatura', 418.0000, 'ºC'),
	(72116, 108, '2015-03-01 00:07:38.000000', 'temperatura', 450.0000, 'ºC'),
	(72117, 108, '2015-03-01 00:07:39.000000', 'temperatura', 997.0000, 'ºC'),
	(72118, 108, '2015-03-01 00:07:40.000000', 'temperatura', 35.0000, 'ºC'),
	(72119, 108, '2015-03-01 00:07:41.000000', 'temperatura', 785.0000, 'ºC'),
	(72120, 108, '2015-03-01 00:07:42.000000', 'temperatura', 222.0000, 'ºC'),
	(72121, 108, '2015-03-01 00:07:43.000000', 'temperatura', 1154.0000, 'ºC'),
	(72122, 108, '2015-03-01 00:07:44.000000', 'temperatura', 306.0000, 'ºC'),
	(72123, 108, '2015-03-01 00:07:45.000000', 'temperatura', 466.0000, 'ºC'),
	(72124, 108, '2015-03-01 00:07:46.000000', 'temperatura', 212.0000, 'ºC'),
	(72125, 108, '2015-03-01 00:07:47.000000', 'temperatura', 862.0000, 'ºC'),
	(72126, 108, '2015-03-01 00:07:48.000000', 'temperatura', 77.0000, 'ºC'),
	(72127, 108, '2015-03-01 00:07:49.000000', 'temperatura', 199.0000, 'ºC'),
	(72128, 108, '2015-03-01 00:07:50.000000', 'temperatura', 766.0000, 'ºC'),
	(72129, 108, '2015-03-01 00:07:51.000000', 'temperatura', 833.0000, 'ºC'),
	(72130, 108, '2015-03-01 00:07:52.000000', 'temperatura', 665.0000, 'ºC'),
	(72131, 108, '2015-03-01 00:07:53.000000', 'temperatura', 829.0000, 'ºC'),
	(72132, 108, '2015-03-01 00:07:54.000000', 'temperatura', 948.0000, 'ºC'),
	(72133, 108, '2015-03-01 00:07:55.000000', 'temperatura', 1055.0000, 'ºC'),
	(72134, 108, '2015-03-01 00:07:56.000000', 'temperatura', 32.0000, 'ºC'),
	(72135, 108, '2015-03-01 00:07:57.000000', 'temperatura', 596.0000, 'ºC'),
	(72136, 108, '2015-03-01 00:07:58.000000', 'temperatura', 484.0000, 'ºC'),
	(72137, 108, '2015-03-01 00:07:59.000000', 'temperatura', 633.0000, 'ºC'),
	(72138, 108, '2015-03-01 00:08:00.000000', 'temperatura', 514.0000, 'ºC'),
	(72139, 108, '2015-03-01 00:08:01.000000', 'temperatura', 672.0000, 'ºC'),
	(72140, 108, '2015-03-01 00:08:02.000000', 'temperatura', 617.0000, 'ºC'),
	(72141, 108, '2015-03-01 00:08:03.000000', 'temperatura', 1071.0000, 'ºC'),
	(72142, 108, '2015-03-01 00:08:04.000000', 'temperatura', 1104.0000, 'ºC'),
	(72143, 108, '2015-03-01 00:08:05.000000', 'temperatura', 1109.0000, 'ºC'),
	(72144, 108, '2015-03-01 00:08:06.000000', 'temperatura', 1034.0000, 'ºC'),
	(72145, 108, '2015-03-01 00:08:07.000000', 'temperatura', 642.0000, 'ºC'),
	(72146, 108, '2015-03-01 00:08:08.000000', 'temperatura', 107.0000, 'ºC'),
	(72147, 108, '2015-03-01 00:08:09.000000', 'temperatura', 1011.0000, 'ºC'),
	(72148, 108, '2015-03-01 00:08:10.000000', 'temperatura', 1135.0000, 'ºC'),
	(72149, 108, '2015-03-01 00:08:11.000000', 'temperatura', 242.0000, 'ºC'),
	(72150, 108, '2015-03-01 00:08:12.000000', 'temperatura', 204.0000, 'ºC'),
	(72151, 108, '2015-03-01 00:08:13.000000', 'temperatura', 296.0000, 'ºC'),
	(72152, 108, '2015-03-01 00:08:14.000000', 'temperatura', 868.0000, 'ºC'),
	(72153, 108, '2015-03-01 00:08:15.000000', 'temperatura', 1051.0000, 'ºC'),
	(72154, 108, '2015-03-01 00:08:16.000000', 'temperatura', 255.0000, 'ºC'),
	(72155, 108, '2015-03-01 00:08:17.000000', 'temperatura', 519.0000, 'ºC'),
	(72156, 108, '2015-03-01 00:08:18.000000', 'temperatura', 631.0000, 'ºC'),
	(72157, 108, '2015-03-01 00:08:19.000000', 'temperatura', 398.0000, 'ºC'),
	(72158, 108, '2015-03-01 00:08:20.000000', 'temperatura', 97.0000, 'ºC'),
	(72159, 108, '2015-03-01 00:08:21.000000', 'temperatura', 493.0000, 'ºC'),
	(72160, 108, '2015-03-01 00:08:22.000000', 'temperatura', 975.0000, 'ºC'),
	(72161, 108, '2015-03-01 00:08:23.000000', 'temperatura', 996.0000, 'ºC'),
	(72162, 108, '2015-03-01 00:08:24.000000', 'temperatura', 856.0000, 'ºC'),
	(72163, 108, '2015-03-01 00:08:25.000000', 'temperatura', 93.0000, 'ºC'),
	(72164, 108, '2015-03-01 00:08:26.000000', 'temperatura', 297.0000, 'ºC'),
	(72165, 108, '2015-03-01 00:08:27.000000', 'temperatura', 5.0000, 'ºC'),
	(72166, 108, '2015-03-01 00:08:28.000000', 'temperatura', 337.0000, 'ºC'),
	(72167, 108, '2015-03-01 00:08:29.000000', 'temperatura', 470.0000, 'ºC'),
	(72168, 108, '2015-03-01 00:08:30.000000', 'temperatura', 137.0000, 'ºC'),
	(72169, 108, '2015-03-01 00:08:31.000000', 'temperatura', 479.0000, 'ºC'),
	(72170, 108, '2015-03-01 00:08:32.000000', 'temperatura', 783.0000, 'ºC'),
	(72171, 108, '2015-03-01 00:08:33.000000', 'temperatura', 78.0000, 'ºC'),
	(72172, 108, '2015-03-01 00:08:34.000000', 'temperatura', 440.0000, 'ºC'),
	(72173, 108, '2015-03-01 00:08:35.000000', 'temperatura', 767.0000, 'ºC'),
	(72174, 108, '2015-03-01 00:08:36.000000', 'temperatura', 115.0000, 'ºC'),
	(72175, 108, '2015-03-01 00:08:37.000000', 'temperatura', 674.0000, 'ºC'),
	(72176, 108, '2015-03-01 00:08:38.000000', 'temperatura', 628.0000, 'ºC'),
	(72177, 108, '2015-03-01 00:08:39.000000', 'temperatura', 1116.0000, 'ºC'),
	(72178, 108, '2015-03-01 00:08:40.000000', 'temperatura', 99.0000, 'ºC'),
	(72179, 108, '2015-03-01 00:08:41.000000', 'temperatura', 747.0000, 'ºC'),
	(72180, 108, '2015-03-01 00:08:42.000000', 'temperatura', 1036.0000, 'ºC'),
	(72181, 108, '2015-03-01 00:08:43.000000', 'temperatura', 543.0000, 'ºC'),
	(72182, 108, '2015-03-01 00:08:44.000000', 'temperatura', 806.0000, 'ºC'),
	(72183, 108, '2015-03-01 00:08:45.000000', 'temperatura', 1.0000, 'ºC'),
	(72184, 108, '2015-03-01 00:08:46.000000', 'temperatura', 1188.0000, 'ºC'),
	(72185, 108, '2015-03-01 00:08:47.000000', 'temperatura', 1138.0000, 'ºC'),
	(72186, 108, '2015-03-01 00:08:48.000000', 'temperatura', 925.0000, 'ºC'),
	(72187, 108, '2015-03-01 00:08:49.000000', 'temperatura', 13.0000, 'ºC'),
	(72188, 108, '2015-03-01 00:08:50.000000', 'temperatura', 890.0000, 'ºC'),
	(72189, 108, '2015-03-01 00:08:51.000000', 'temperatura', 811.0000, 'ºC'),
	(72190, 108, '2015-03-01 00:08:52.000000', 'temperatura', 186.0000, 'ºC'),
	(72191, 108, '2015-03-01 00:08:53.000000', 'temperatura', 897.0000, 'ºC'),
	(72192, 108, '2015-03-01 00:08:54.000000', 'temperatura', 329.0000, 'ºC'),
	(72193, 108, '2015-03-01 00:08:55.000000', 'temperatura', 155.0000, 'ºC'),
	(72194, 108, '2015-03-01 00:08:56.000000', 'temperatura', 989.0000, 'ºC'),
	(72195, 108, '2015-03-01 00:08:57.000000', 'temperatura', 879.0000, 'ºC'),
	(72196, 108, '2015-03-01 00:08:58.000000', 'temperatura', 230.0000, 'ºC'),
	(72197, 108, '2015-03-01 00:08:59.000000', 'temperatura', 913.0000, 'ºC'),
	(72198, 108, '2015-03-01 00:09:00.000000', 'temperatura', 273.0000, 'ºC'),
	(72199, 108, '2015-03-01 00:09:01.000000', 'temperatura', 1029.0000, 'ºC'),
	(72200, 108, '2015-03-01 00:09:02.000000', 'temperatura', 726.0000, 'ºC'),
	(72201, 108, '2015-03-01 00:09:03.000000', 'temperatura', 545.0000, 'ºC'),
	(72202, 108, '2015-03-01 00:09:04.000000', 'temperatura', 546.0000, 'ºC'),
	(72203, 108, '2015-03-01 00:09:05.000000', 'temperatura', 1094.0000, 'ºC'),
	(72204, 108, '2015-03-01 00:09:06.000000', 'temperatura', 235.0000, 'ºC'),
	(72205, 108, '2015-03-01 00:09:07.000000', 'temperatura', 292.0000, 'ºC'),
	(72206, 108, '2015-03-01 00:09:08.000000', 'temperatura', 754.0000, 'ºC'),
	(72207, 108, '2015-03-01 00:09:09.000000', 'temperatura', 495.0000, 'ºC'),
	(72208, 108, '2015-03-01 00:09:10.000000', 'temperatura', 214.0000, 'ºC'),
	(72209, 108, '2015-03-01 00:09:11.000000', 'temperatura', 786.0000, 'ºC'),
	(72210, 108, '2015-03-01 00:09:12.000000', 'temperatura', 888.0000, 'ºC'),
	(72211, 108, '2015-03-01 00:09:13.000000', 'temperatura', 881.0000, 'ºC'),
	(72212, 108, '2015-03-01 00:09:14.000000', 'temperatura', 545.0000, 'ºC'),
	(72213, 108, '2015-03-01 00:09:15.000000', 'temperatura', 79.0000, 'ºC'),
	(72214, 108, '2015-03-01 00:09:16.000000', 'temperatura', 1161.0000, 'ºC'),
	(72215, 108, '2015-03-01 00:09:17.000000', 'temperatura', 771.0000, 'ºC'),
	(72216, 108, '2015-03-01 00:09:18.000000', 'temperatura', 369.0000, 'ºC'),
	(72217, 108, '2015-03-01 00:09:19.000000', 'temperatura', 735.0000, 'ºC'),
	(72218, 108, '2015-03-01 00:09:20.000000', 'temperatura', 167.0000, 'ºC'),
	(72219, 108, '2015-03-01 00:09:21.000000', 'temperatura', 1030.0000, 'ºC'),
	(72220, 108, '2015-03-01 00:09:22.000000', 'temperatura', 1048.0000, 'ºC'),
	(72221, 108, '2015-03-01 00:09:23.000000', 'temperatura', 954.0000, 'ºC'),
	(72222, 108, '2015-03-01 00:09:24.000000', 'temperatura', 424.0000, 'ºC'),
	(72223, 108, '2015-03-01 00:09:25.000000', 'temperatura', 457.0000, 'ºC'),
	(72224, 108, '2015-03-01 00:09:26.000000', 'temperatura', 1016.0000, 'ºC'),
	(72225, 108, '2015-03-01 00:09:27.000000', 'temperatura', 110.0000, 'ºC'),
	(72226, 108, '2015-03-01 00:09:28.000000', 'temperatura', 1104.0000, 'ºC'),
	(72227, 108, '2015-03-01 00:09:29.000000', 'temperatura', 388.0000, 'ºC'),
	(72228, 108, '2015-03-01 00:09:30.000000', 'temperatura', 1031.0000, 'ºC'),
	(72229, 108, '2015-03-01 00:09:31.000000', 'temperatura', 388.0000, 'ºC'),
	(72230, 108, '2015-03-01 00:09:32.000000', 'temperatura', 50.0000, 'ºC'),
	(72231, 108, '2015-03-01 00:09:33.000000', 'temperatura', 285.0000, 'ºC'),
	(72232, 108, '2015-03-01 00:09:34.000000', 'temperatura', 77.0000, 'ºC'),
	(72233, 108, '2015-03-01 00:09:35.000000', 'temperatura', 729.0000, 'ºC'),
	(72234, 108, '2015-03-01 00:09:36.000000', 'temperatura', 1016.0000, 'ºC'),
	(72235, 108, '2015-03-01 00:09:37.000000', 'temperatura', 493.0000, 'ºC'),
	(72236, 108, '2015-03-01 00:09:38.000000', 'temperatura', 619.0000, 'ºC'),
	(72237, 108, '2015-03-01 00:09:39.000000', 'temperatura', 414.0000, 'ºC'),
	(72238, 108, '2015-03-01 00:09:40.000000', 'temperatura', 213.0000, 'ºC'),
	(72239, 108, '2015-03-01 00:09:41.000000', 'temperatura', 1024.0000, 'ºC'),
	(72240, 108, '2015-03-01 00:09:42.000000', 'temperatura', 880.0000, 'ºC'),
	(72241, 108, '2015-03-01 00:09:43.000000', 'temperatura', 131.0000, 'ºC'),
	(72242, 108, '2015-03-01 00:09:44.000000', 'temperatura', 416.0000, 'ºC'),
	(72243, 108, '2015-03-01 00:09:45.000000', 'temperatura', 487.0000, 'ºC'),
	(72244, 108, '2015-03-01 00:09:46.000000', 'temperatura', 1187.0000, 'ºC'),
	(72245, 108, '2015-03-01 00:09:47.000000', 'temperatura', 876.0000, 'ºC'),
	(72246, 108, '2015-03-01 00:09:48.000000', 'temperatura', 818.0000, 'ºC'),
	(72247, 108, '2015-03-01 00:09:49.000000', 'temperatura', 261.0000, 'ºC'),
	(72248, 108, '2015-03-01 00:09:50.000000', 'temperatura', 54.0000, 'ºC'),
	(72249, 108, '2015-03-01 00:09:51.000000', 'temperatura', 685.0000, 'ºC'),
	(72250, 108, '2015-03-01 00:09:52.000000', 'temperatura', 865.0000, 'ºC'),
	(72251, 108, '2015-03-01 00:09:53.000000', 'temperatura', 1072.0000, 'ºC'),
	(72252, 108, '2015-03-01 00:09:54.000000', 'temperatura', 363.0000, 'ºC'),
	(72253, 108, '2015-03-01 00:09:55.000000', 'temperatura', 999.0000, 'ºC'),
	(72254, 108, '2015-03-01 00:09:56.000000', 'temperatura', 307.0000, 'ºC'),
	(72255, 108, '2015-03-01 00:09:57.000000', 'temperatura', 938.0000, 'ºC'),
	(72256, 108, '2015-03-01 00:09:58.000000', 'temperatura', 171.0000, 'ºC'),
	(72257, 108, '2015-03-01 00:09:59.000000', 'temperatura', 442.0000, 'ºC'),
	(72258, 108, '2015-03-01 00:10:00.000000', 'temperatura', 499.0000, 'ºC'),
	(72259, 108, '2015-03-01 00:10:01.000000', 'temperatura', 1166.0000, 'ºC'),
	(72260, 108, '2015-03-01 00:10:02.000000', 'temperatura', 735.0000, 'ºC'),
	(72261, 108, '2015-03-01 00:10:03.000000', 'temperatura', 177.0000, 'ºC'),
	(72262, 108, '2015-03-01 00:10:04.000000', 'temperatura', 1083.0000, 'ºC'),
	(72263, 108, '2015-03-01 00:10:05.000000', 'temperatura', 82.0000, 'ºC'),
	(72264, 108, '2015-03-01 00:10:06.000000', 'temperatura', 761.0000, 'ºC'),
	(72265, 108, '2015-03-01 00:10:07.000000', 'temperatura', 1161.0000, 'ºC'),
	(72266, 108, '2015-03-01 00:10:08.000000', 'temperatura', 1124.0000, 'ºC'),
	(72267, 108, '2015-03-01 00:10:09.000000', 'temperatura', 935.0000, 'ºC'),
	(72268, 108, '2015-03-01 00:10:10.000000', 'temperatura', 105.0000, 'ºC'),
	(72269, 108, '2015-03-01 00:10:11.000000', 'temperatura', 121.0000, 'ºC'),
	(72270, 108, '2015-03-01 00:10:12.000000', 'temperatura', 289.0000, 'ºC'),
	(72271, 108, '2015-03-01 00:10:13.000000', 'temperatura', 1081.0000, 'ºC'),
	(72272, 108, '2015-03-01 00:10:14.000000', 'temperatura', 941.0000, 'ºC'),
	(72273, 108, '2015-03-01 00:10:15.000000', 'temperatura', 261.0000, 'ºC'),
	(72274, 108, '2015-03-01 00:10:16.000000', 'temperatura', 881.0000, 'ºC'),
	(72275, 108, '2015-03-01 00:10:17.000000', 'temperatura', 26.0000, 'ºC'),
	(72276, 108, '2015-03-01 00:10:18.000000', 'temperatura', 1086.0000, 'ºC'),
	(72277, 108, '2015-03-01 00:10:19.000000', 'temperatura', 554.0000, 'ºC'),
	(72278, 108, '2015-03-01 00:10:20.000000', 'temperatura', 710.0000, 'ºC'),
	(72279, 108, '2015-03-01 00:10:21.000000', 'temperatura', 688.0000, 'ºC'),
	(72280, 108, '2015-03-01 00:10:22.000000', 'temperatura', 111.0000, 'ºC'),
	(72281, 108, '2015-03-01 00:10:23.000000', 'temperatura', 893.0000, 'ºC'),
	(72282, 108, '2015-03-01 00:10:24.000000', 'temperatura', 530.0000, 'ºC'),
	(72283, 108, '2015-03-01 00:10:25.000000', 'temperatura', 1172.0000, 'ºC'),
	(72284, 108, '2015-03-01 00:10:26.000000', 'temperatura', 670.0000, 'ºC'),
	(72285, 108, '2015-03-01 00:10:27.000000', 'temperatura', 1034.0000, 'ºC'),
	(72286, 108, '2015-03-01 00:10:28.000000', 'temperatura', 760.0000, 'ºC'),
	(72287, 108, '2015-03-01 00:10:29.000000', 'temperatura', 697.0000, 'ºC'),
	(72288, 108, '2015-03-01 00:10:30.000000', 'temperatura', 9.0000, 'ºC'),
	(72289, 108, '2015-03-01 00:10:31.000000', 'temperatura', 351.0000, 'ºC'),
	(72290, 108, '2015-03-01 00:10:32.000000', 'temperatura', 531.0000, 'ºC'),
	(72291, 108, '2015-03-01 00:10:33.000000', 'temperatura', 401.0000, 'ºC'),
	(72292, 108, '2015-03-01 00:10:34.000000', 'temperatura', 412.0000, 'ºC'),
	(72293, 108, '2015-03-01 00:10:35.000000', 'temperatura', 860.0000, 'ºC'),
	(72294, 108, '2015-03-01 00:10:36.000000', 'temperatura', 662.0000, 'ºC'),
	(72295, 108, '2015-03-01 00:10:37.000000', 'temperatura', 732.0000, 'ºC'),
	(72296, 108, '2015-03-01 00:10:38.000000', 'temperatura', 475.0000, 'ºC'),
	(72297, 108, '2015-03-01 00:10:39.000000', 'temperatura', 179.0000, 'ºC'),
	(72298, 108, '2015-03-01 00:10:40.000000', 'temperatura', 669.0000, 'ºC'),
	(72299, 108, '2015-03-01 00:10:41.000000', 'temperatura', 409.0000, 'ºC'),
	(72300, 108, '2015-03-01 00:10:42.000000', 'temperatura', 40.0000, 'ºC'),
	(72301, 108, '2015-03-01 00:10:43.000000', 'temperatura', 172.0000, 'ºC'),
	(72302, 108, '2015-03-01 00:10:44.000000', 'temperatura', 741.0000, 'ºC'),
	(72303, 108, '2015-03-01 00:10:45.000000', 'temperatura', 791.0000, 'ºC'),
	(72304, 108, '2015-03-01 00:10:46.000000', 'temperatura', 531.0000, 'ºC'),
	(72305, 108, '2015-03-01 00:10:47.000000', 'temperatura', 283.0000, 'ºC'),
	(72306, 108, '2015-03-01 00:10:48.000000', 'temperatura', 1022.0000, 'ºC'),
	(72307, 108, '2015-03-01 00:10:49.000000', 'temperatura', 662.0000, 'ºC'),
	(72308, 108, '2015-03-01 00:10:50.000000', 'temperatura', 244.0000, 'ºC'),
	(72309, 108, '2015-03-01 00:10:51.000000', 'temperatura', 437.0000, 'ºC'),
	(72310, 108, '2015-03-01 00:10:52.000000', 'temperatura', 251.0000, 'ºC'),
	(72311, 108, '2015-03-01 00:10:53.000000', 'temperatura', 1145.0000, 'ºC'),
	(72312, 108, '2015-03-01 00:10:54.000000', 'temperatura', 171.0000, 'ºC'),
	(72313, 108, '2015-03-01 00:10:55.000000', 'temperatura', 1020.0000, 'ºC'),
	(72314, 108, '2015-03-01 00:10:56.000000', 'temperatura', 990.0000, 'ºC'),
	(72315, 108, '2015-03-01 00:10:57.000000', 'temperatura', 691.0000, 'ºC'),
	(72316, 108, '2015-03-01 00:10:58.000000', 'temperatura', 484.0000, 'ºC'),
	(72317, 108, '2015-03-01 00:10:59.000000', 'temperatura', 348.0000, 'ºC'),
	(72318, 108, '2015-03-01 00:11:00.000000', 'temperatura', 290.0000, 'ºC'),
	(72319, 108, '2015-03-01 00:11:01.000000', 'temperatura', 405.0000, 'ºC'),
	(72320, 108, '2015-03-01 00:11:02.000000', 'temperatura', 1157.0000, 'ºC'),
	(72321, 108, '2015-03-01 00:11:03.000000', 'temperatura', 969.0000, 'ºC'),
	(72322, 108, '2015-03-01 00:11:04.000000', 'temperatura', 177.0000, 'ºC'),
	(72323, 108, '2015-03-01 00:11:05.000000', 'temperatura', 375.0000, 'ºC'),
	(72324, 108, '2015-03-01 00:11:06.000000', 'temperatura', 147.0000, 'ºC'),
	(72325, 108, '2015-03-01 00:11:07.000000', 'temperatura', 810.0000, 'ºC'),
	(72326, 108, '2015-03-01 00:11:08.000000', 'temperatura', 9.0000, 'ºC'),
	(72327, 108, '2015-03-01 00:11:09.000000', 'temperatura', 18.0000, 'ºC'),
	(72328, 108, '2015-03-01 00:11:10.000000', 'temperatura', 60.0000, 'ºC'),
	(72329, 108, '2015-03-01 00:11:11.000000', 'temperatura', 247.0000, 'ºC'),
	(72330, 108, '2015-03-01 00:11:12.000000', 'temperatura', 1056.0000, 'ºC'),
	(72331, 108, '2015-03-01 00:11:13.000000', 'temperatura', 941.0000, 'ºC'),
	(72332, 108, '2015-03-01 00:11:14.000000', 'temperatura', 338.0000, 'ºC'),
	(72333, 108, '2015-03-01 00:11:15.000000', 'temperatura', 65.0000, 'ºC'),
	(72334, 108, '2015-03-01 00:11:16.000000', 'temperatura', 513.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(72335, 108, '2015-03-01 00:11:17.000000', 'temperatura', 1172.0000, 'ºC'),
	(72336, 108, '2015-03-01 00:11:18.000000', 'temperatura', 721.0000, 'ºC'),
	(72337, 108, '2015-03-01 00:11:19.000000', 'temperatura', 87.0000, 'ºC'),
	(72338, 108, '2015-03-01 00:11:20.000000', 'temperatura', 673.0000, 'ºC'),
	(72339, 108, '2015-03-01 00:11:21.000000', 'temperatura', 706.0000, 'ºC'),
	(72340, 108, '2015-03-01 00:11:22.000000', 'temperatura', 312.0000, 'ºC'),
	(72341, 108, '2015-03-01 00:11:23.000000', 'temperatura', 644.0000, 'ºC'),
	(72342, 108, '2015-03-01 00:11:24.000000', 'temperatura', 1081.0000, 'ºC'),
	(72343, 108, '2015-03-01 00:11:25.000000', 'temperatura', 1075.0000, 'ºC'),
	(72344, 108, '2015-03-01 00:11:26.000000', 'temperatura', 935.0000, 'ºC'),
	(72345, 108, '2015-03-01 00:11:27.000000', 'temperatura', 247.0000, 'ºC'),
	(72346, 108, '2015-03-01 00:11:28.000000', 'temperatura', 830.0000, 'ºC'),
	(72347, 108, '2015-03-01 00:11:29.000000', 'temperatura', 1010.0000, 'ºC'),
	(72348, 108, '2015-03-01 00:11:30.000000', 'temperatura', 159.0000, 'ºC'),
	(72349, 108, '2015-03-01 00:11:31.000000', 'temperatura', 167.0000, 'ºC'),
	(72350, 108, '2015-03-01 00:11:32.000000', 'temperatura', 358.0000, 'ºC'),
	(72351, 108, '2015-03-01 00:11:33.000000', 'temperatura', 90.0000, 'ºC'),
	(72352, 108, '2015-03-01 00:11:34.000000', 'temperatura', 575.0000, 'ºC'),
	(72353, 108, '2015-03-01 00:11:35.000000', 'temperatura', 206.0000, 'ºC'),
	(72354, 108, '2015-03-01 00:11:36.000000', 'temperatura', 505.0000, 'ºC'),
	(72355, 108, '2015-03-01 00:11:37.000000', 'temperatura', 708.0000, 'ºC'),
	(72356, 108, '2015-03-01 00:11:38.000000', 'temperatura', 826.0000, 'ºC'),
	(72357, 108, '2015-03-01 00:11:39.000000', 'temperatura', 805.0000, 'ºC'),
	(72358, 108, '2015-03-01 00:11:40.000000', 'temperatura', 348.0000, 'ºC'),
	(72359, 108, '2015-03-01 00:11:41.000000', 'temperatura', 527.0000, 'ºC'),
	(72360, 108, '2015-03-01 00:11:42.000000', 'temperatura', 391.0000, 'ºC'),
	(72361, 108, '2015-03-01 00:11:43.000000', 'temperatura', 376.0000, 'ºC'),
	(72362, 108, '2015-03-01 00:11:44.000000', 'temperatura', 706.0000, 'ºC'),
	(72363, 108, '2015-03-01 00:11:45.000000', 'temperatura', 4.0000, 'ºC'),
	(72364, 108, '2015-03-01 00:11:46.000000', 'temperatura', 301.0000, 'ºC'),
	(72365, 108, '2015-03-01 00:11:47.000000', 'temperatura', 293.0000, 'ºC'),
	(72366, 108, '2015-03-01 00:11:48.000000', 'temperatura', 564.0000, 'ºC'),
	(72367, 108, '2015-03-01 00:11:49.000000', 'temperatura', 741.0000, 'ºC'),
	(72368, 108, '2015-03-01 00:11:50.000000', 'temperatura', 814.0000, 'ºC'),
	(72369, 108, '2015-03-01 00:11:51.000000', 'temperatura', 647.0000, 'ºC'),
	(72370, 108, '2015-03-01 00:11:52.000000', 'temperatura', 792.0000, 'ºC'),
	(72371, 108, '2015-03-01 00:11:53.000000', 'temperatura', 822.0000, 'ºC'),
	(72372, 108, '2015-03-01 00:11:54.000000', 'temperatura', 533.0000, 'ºC'),
	(72373, 108, '2015-03-01 00:11:55.000000', 'temperatura', 198.0000, 'ºC'),
	(72374, 108, '2015-03-01 00:11:56.000000', 'temperatura', 594.0000, 'ºC'),
	(72375, 108, '2015-03-01 00:11:57.000000', 'temperatura', 1177.0000, 'ºC'),
	(72376, 108, '2015-03-01 00:11:58.000000', 'temperatura', 505.0000, 'ºC'),
	(72377, 108, '2015-03-01 00:11:59.000000', 'temperatura', 192.0000, 'ºC'),
	(72378, 108, '2015-03-01 00:12:00.000000', 'temperatura', 644.0000, 'ºC'),
	(72379, 108, '2015-03-01 00:12:01.000000', 'temperatura', 246.0000, 'ºC'),
	(72380, 108, '2015-03-01 00:12:02.000000', 'temperatura', 500.0000, 'ºC'),
	(72381, 108, '2015-03-01 00:12:03.000000', 'temperatura', 560.0000, 'ºC'),
	(72382, 108, '2015-03-01 00:12:04.000000', 'temperatura', 104.0000, 'ºC'),
	(72383, 108, '2015-03-01 00:12:05.000000', 'temperatura', 37.0000, 'ºC'),
	(72384, 108, '2015-03-01 00:12:06.000000', 'temperatura', 1073.0000, 'ºC'),
	(72385, 108, '2015-03-01 00:12:07.000000', 'temperatura', 456.0000, 'ºC'),
	(72386, 108, '2015-03-01 00:12:08.000000', 'temperatura', 263.0000, 'ºC'),
	(72387, 108, '2015-03-01 00:12:09.000000', 'temperatura', 1148.0000, 'ºC'),
	(72388, 108, '2015-03-01 00:12:10.000000', 'temperatura', 148.0000, 'ºC'),
	(72389, 108, '2015-03-01 00:12:11.000000', 'temperatura', 899.0000, 'ºC'),
	(72390, 108, '2015-03-01 00:12:12.000000', 'temperatura', 452.0000, 'ºC'),
	(72391, 108, '2015-03-01 00:12:13.000000', 'temperatura', 764.0000, 'ºC'),
	(72392, 108, '2015-03-01 00:12:14.000000', 'temperatura', 65.0000, 'ºC'),
	(72393, 108, '2015-03-01 00:12:15.000000', 'temperatura', 432.0000, 'ºC'),
	(72394, 108, '2015-03-01 00:12:16.000000', 'temperatura', 765.0000, 'ºC'),
	(72395, 108, '2015-03-01 00:12:17.000000', 'temperatura', 129.0000, 'ºC'),
	(72396, 108, '2015-03-01 00:12:18.000000', 'temperatura', 750.0000, 'ºC'),
	(72397, 108, '2015-03-01 00:12:19.000000', 'temperatura', 964.0000, 'ºC'),
	(72398, 108, '2015-03-01 00:12:20.000000', 'temperatura', 172.0000, 'ºC'),
	(72399, 108, '2015-03-01 00:12:21.000000', 'temperatura', 368.0000, 'ºC'),
	(72400, 108, '2015-03-01 00:12:22.000000', 'temperatura', 126.0000, 'ºC'),
	(72401, 108, '2015-03-01 00:12:23.000000', 'temperatura', 723.0000, 'ºC'),
	(72402, 108, '2015-03-01 00:12:24.000000', 'temperatura', 841.0000, 'ºC'),
	(72403, 108, '2015-03-01 00:12:25.000000', 'temperatura', 835.0000, 'ºC'),
	(72404, 108, '2015-03-01 00:12:26.000000', 'temperatura', 453.0000, 'ºC'),
	(72405, 108, '2015-03-01 00:12:27.000000', 'temperatura', 959.0000, 'ºC'),
	(72406, 108, '2015-03-01 00:12:28.000000', 'temperatura', 1037.0000, 'ºC'),
	(72407, 108, '2015-03-01 00:12:29.000000', 'temperatura', 1108.0000, 'ºC'),
	(72408, 108, '2015-03-01 00:12:30.000000', 'temperatura', 29.0000, 'ºC'),
	(72409, 108, '2015-03-01 00:12:31.000000', 'temperatura', 421.0000, 'ºC'),
	(72410, 108, '2015-03-01 00:12:32.000000', 'temperatura', 821.0000, 'ºC'),
	(72411, 108, '2015-03-01 00:12:33.000000', 'temperatura', 443.0000, 'ºC'),
	(72412, 108, '2015-03-01 00:12:34.000000', 'temperatura', 953.0000, 'ºC'),
	(72413, 108, '2015-03-01 00:12:35.000000', 'temperatura', 1036.0000, 'ºC'),
	(72414, 108, '2015-03-01 00:12:36.000000', 'temperatura', 1119.0000, 'ºC'),
	(72415, 108, '2015-03-01 00:12:37.000000', 'temperatura', 90.0000, 'ºC'),
	(72416, 108, '2015-03-01 00:12:38.000000', 'temperatura', 691.0000, 'ºC'),
	(72417, 108, '2015-03-01 00:12:39.000000', 'temperatura', 788.0000, 'ºC'),
	(72418, 108, '2015-03-01 00:12:40.000000', 'temperatura', 666.0000, 'ºC'),
	(72419, 108, '2015-03-01 00:12:41.000000', 'temperatura', 969.0000, 'ºC'),
	(72420, 108, '2015-03-01 00:12:42.000000', 'temperatura', 445.0000, 'ºC'),
	(72421, 108, '2015-03-01 00:12:43.000000', 'temperatura', 521.0000, 'ºC'),
	(72422, 108, '2015-03-01 00:12:44.000000', 'temperatura', 68.0000, 'ºC'),
	(72423, 108, '2015-03-01 00:12:45.000000', 'temperatura', 1179.0000, 'ºC'),
	(72424, 108, '2015-03-01 00:12:46.000000', 'temperatura', 890.0000, 'ºC'),
	(72425, 108, '2015-03-01 00:12:47.000000', 'temperatura', 915.0000, 'ºC'),
	(72426, 108, '2015-03-01 00:12:48.000000', 'temperatura', 705.0000, 'ºC'),
	(72427, 108, '2015-03-01 00:12:49.000000', 'temperatura', 781.0000, 'ºC'),
	(72428, 108, '2015-03-01 00:12:50.000000', 'temperatura', 592.0000, 'ºC'),
	(72429, 108, '2015-03-01 00:12:51.000000', 'temperatura', 616.0000, 'ºC'),
	(72430, 108, '2015-03-01 00:12:52.000000', 'temperatura', 106.0000, 'ºC'),
	(72431, 108, '2015-03-01 00:12:53.000000', 'temperatura', 1080.0000, 'ºC'),
	(72432, 108, '2015-03-01 00:12:54.000000', 'temperatura', 285.0000, 'ºC'),
	(72433, 108, '2015-03-01 00:12:55.000000', 'temperatura', 586.0000, 'ºC'),
	(72434, 108, '2015-03-01 00:12:56.000000', 'temperatura', 876.0000, 'ºC'),
	(72435, 108, '2015-03-01 00:12:57.000000', 'temperatura', 223.0000, 'ºC'),
	(72436, 108, '2015-03-01 00:12:58.000000', 'temperatura', 885.0000, 'ºC'),
	(72437, 108, '2015-03-01 00:12:59.000000', 'temperatura', 156.0000, 'ºC'),
	(72438, 108, '2015-03-01 00:13:00.000000', 'temperatura', 527.0000, 'ºC'),
	(72439, 108, '2015-03-01 00:13:01.000000', 'temperatura', 965.0000, 'ºC'),
	(72440, 108, '2015-03-01 00:13:02.000000', 'temperatura', 848.0000, 'ºC'),
	(72441, 108, '2015-03-01 00:13:03.000000', 'temperatura', 144.0000, 'ºC'),
	(72442, 108, '2015-03-01 00:13:04.000000', 'temperatura', 575.0000, 'ºC'),
	(72443, 108, '2015-03-01 00:13:05.000000', 'temperatura', 46.0000, 'ºC'),
	(72444, 108, '2015-03-01 00:13:06.000000', 'temperatura', 903.0000, 'ºC'),
	(72445, 108, '2015-03-01 00:13:07.000000', 'temperatura', 778.0000, 'ºC'),
	(72446, 108, '2015-03-01 00:13:08.000000', 'temperatura', 1181.0000, 'ºC'),
	(72447, 108, '2015-03-01 00:13:09.000000', 'temperatura', 1171.0000, 'ºC'),
	(72448, 108, '2015-03-01 00:13:10.000000', 'temperatura', 1112.0000, 'ºC'),
	(72449, 108, '2015-03-01 00:13:11.000000', 'temperatura', 848.0000, 'ºC'),
	(72450, 108, '2015-03-01 00:13:12.000000', 'temperatura', 906.0000, 'ºC'),
	(72451, 108, '2015-03-01 00:13:13.000000', 'temperatura', 787.0000, 'ºC'),
	(72452, 108, '2015-03-01 00:13:14.000000', 'temperatura', 16.0000, 'ºC'),
	(72453, 108, '2015-03-01 00:13:15.000000', 'temperatura', 119.0000, 'ºC'),
	(72454, 108, '2015-03-01 00:13:16.000000', 'temperatura', 549.0000, 'ºC'),
	(72455, 108, '2015-03-01 00:13:17.000000', 'temperatura', 1187.0000, 'ºC'),
	(72456, 108, '2015-03-01 00:13:18.000000', 'temperatura', 689.0000, 'ºC'),
	(72457, 108, '2015-03-01 00:13:19.000000', 'temperatura', 1083.0000, 'ºC'),
	(72458, 108, '2015-03-01 00:13:20.000000', 'temperatura', 951.0000, 'ºC'),
	(72459, 108, '2015-03-01 00:13:21.000000', 'temperatura', 304.0000, 'ºC'),
	(72460, 108, '2015-03-01 00:13:22.000000', 'temperatura', 1069.0000, 'ºC'),
	(72461, 108, '2015-03-01 00:13:23.000000', 'temperatura', 832.0000, 'ºC'),
	(72462, 108, '2015-03-01 00:13:24.000000', 'temperatura', 955.0000, 'ºC'),
	(72463, 108, '2015-03-01 00:13:25.000000', 'temperatura', 1080.0000, 'ºC'),
	(72464, 108, '2015-03-01 00:13:26.000000', 'temperatura', 135.0000, 'ºC'),
	(72465, 108, '2015-03-01 00:13:27.000000', 'temperatura', 1033.0000, 'ºC'),
	(72466, 108, '2015-03-01 00:13:28.000000', 'temperatura', 1164.0000, 'ºC'),
	(72467, 108, '2015-03-01 00:13:29.000000', 'temperatura', 320.0000, 'ºC'),
	(72468, 108, '2015-03-01 00:13:30.000000', 'temperatura', 508.0000, 'ºC'),
	(72469, 108, '2015-03-01 00:13:31.000000', 'temperatura', 379.0000, 'ºC'),
	(72470, 108, '2015-03-01 00:13:32.000000', 'temperatura', 372.0000, 'ºC'),
	(72471, 108, '2015-03-01 00:13:33.000000', 'temperatura', 724.0000, 'ºC'),
	(72472, 108, '2015-03-01 00:13:34.000000', 'temperatura', 106.0000, 'ºC'),
	(72473, 108, '2015-03-01 00:13:35.000000', 'temperatura', 758.0000, 'ºC'),
	(72474, 108, '2015-03-01 00:13:36.000000', 'temperatura', 1071.0000, 'ºC'),
	(72475, 108, '2015-03-01 00:13:37.000000', 'temperatura', 681.0000, 'ºC'),
	(72476, 108, '2015-03-01 00:13:38.000000', 'temperatura', 194.0000, 'ºC'),
	(72477, 108, '2015-03-01 00:13:39.000000', 'temperatura', 128.0000, 'ºC'),
	(72478, 108, '2015-03-01 00:13:40.000000', 'temperatura', 59.0000, 'ºC'),
	(72479, 108, '2015-03-01 00:13:41.000000', 'temperatura', 1113.0000, 'ºC'),
	(72480, 108, '2015-03-01 00:13:42.000000', 'temperatura', 585.0000, 'ºC'),
	(72481, 108, '2015-03-01 00:13:43.000000', 'temperatura', 788.0000, 'ºC'),
	(72482, 108, '2015-03-01 00:13:44.000000', 'temperatura', 984.0000, 'ºC'),
	(72483, 108, '2015-03-01 00:13:45.000000', 'temperatura', 157.0000, 'ºC'),
	(72484, 108, '2015-03-01 00:13:46.000000', 'temperatura', 234.0000, 'ºC'),
	(72485, 108, '2015-03-01 00:13:47.000000', 'temperatura', 699.0000, 'ºC'),
	(72486, 108, '2015-03-01 00:13:48.000000', 'temperatura', 395.0000, 'ºC'),
	(72487, 108, '2015-03-01 00:13:49.000000', 'temperatura', 1077.0000, 'ºC'),
	(72488, 108, '2015-03-01 00:13:50.000000', 'temperatura', 602.0000, 'ºC'),
	(72489, 108, '2015-03-01 00:13:51.000000', 'temperatura', 979.0000, 'ºC'),
	(72490, 108, '2015-03-01 00:13:52.000000', 'temperatura', 688.0000, 'ºC'),
	(72491, 108, '2015-03-01 00:13:53.000000', 'temperatura', 504.0000, 'ºC'),
	(72492, 108, '2015-03-01 00:13:54.000000', 'temperatura', 457.0000, 'ºC'),
	(72493, 108, '2015-03-01 00:13:55.000000', 'temperatura', 774.0000, 'ºC'),
	(72494, 108, '2015-03-01 00:13:56.000000', 'temperatura', 97.0000, 'ºC'),
	(72495, 108, '2015-03-01 00:13:57.000000', 'temperatura', 567.0000, 'ºC'),
	(72496, 108, '2015-03-01 00:13:58.000000', 'temperatura', 143.0000, 'ºC'),
	(72497, 108, '2015-03-01 00:13:59.000000', 'temperatura', 214.0000, 'ºC'),
	(72498, 108, '2015-03-01 00:14:00.000000', 'temperatura', 641.0000, 'ºC'),
	(72499, 108, '2015-03-01 00:14:01.000000', 'temperatura', 166.0000, 'ºC'),
	(72500, 108, '2015-03-01 00:14:02.000000', 'temperatura', 105.0000, 'ºC'),
	(72501, 108, '2015-03-01 00:14:03.000000', 'temperatura', 30.0000, 'ºC'),
	(72502, 108, '2015-03-01 00:14:04.000000', 'temperatura', 1035.0000, 'ºC'),
	(72503, 108, '2015-03-01 00:14:05.000000', 'temperatura', 287.0000, 'ºC'),
	(72504, 108, '2015-03-01 00:14:06.000000', 'temperatura', 729.0000, 'ºC'),
	(72505, 108, '2015-03-01 00:14:07.000000', 'temperatura', 386.0000, 'ºC'),
	(72506, 108, '2015-03-01 00:14:08.000000', 'temperatura', 943.0000, 'ºC'),
	(72507, 108, '2015-03-01 00:14:09.000000', 'temperatura', 1156.0000, 'ºC'),
	(72508, 108, '2015-03-01 00:14:10.000000', 'temperatura', 553.0000, 'ºC'),
	(72509, 108, '2015-03-01 00:14:11.000000', 'temperatura', 496.0000, 'ºC'),
	(72510, 108, '2015-03-01 00:14:12.000000', 'temperatura', 822.0000, 'ºC'),
	(72511, 108, '2015-03-01 00:14:13.000000', 'temperatura', 224.0000, 'ºC'),
	(72512, 108, '2015-03-01 00:14:14.000000', 'temperatura', 1053.0000, 'ºC'),
	(72513, 108, '2015-03-01 00:14:15.000000', 'temperatura', 993.0000, 'ºC'),
	(72514, 108, '2015-03-01 00:14:16.000000', 'temperatura', 606.0000, 'ºC'),
	(72515, 108, '2015-03-01 00:14:17.000000', 'temperatura', 50.0000, 'ºC'),
	(72516, 108, '2015-03-01 00:14:18.000000', 'temperatura', 836.0000, 'ºC'),
	(72517, 108, '2015-03-01 00:14:19.000000', 'temperatura', 427.0000, 'ºC'),
	(72518, 108, '2015-03-01 00:14:20.000000', 'temperatura', 831.0000, 'ºC'),
	(72519, 108, '2015-03-01 00:14:21.000000', 'temperatura', 472.0000, 'ºC'),
	(72520, 108, '2015-03-01 00:14:22.000000', 'temperatura', 1066.0000, 'ºC'),
	(72521, 108, '2015-03-01 00:14:23.000000', 'temperatura', 318.0000, 'ºC'),
	(72522, 108, '2015-03-01 00:14:24.000000', 'temperatura', 792.0000, 'ºC'),
	(72523, 108, '2015-03-01 00:14:25.000000', 'temperatura', 606.0000, 'ºC'),
	(72524, 108, '2015-03-01 00:14:26.000000', 'temperatura', 652.0000, 'ºC'),
	(72525, 108, '2015-03-01 00:14:27.000000', 'temperatura', 246.0000, 'ºC'),
	(72526, 108, '2015-03-01 00:14:28.000000', 'temperatura', 472.0000, 'ºC'),
	(72527, 108, '2015-03-01 00:14:29.000000', 'temperatura', 423.0000, 'ºC'),
	(72528, 108, '2015-03-01 00:14:30.000000', 'temperatura', 698.0000, 'ºC'),
	(72529, 108, '2015-03-01 00:14:31.000000', 'temperatura', 1024.0000, 'ºC'),
	(72530, 108, '2015-03-01 00:14:32.000000', 'temperatura', 625.0000, 'ºC'),
	(72531, 108, '2015-03-01 00:14:33.000000', 'temperatura', 52.0000, 'ºC'),
	(72532, 108, '2015-03-01 00:14:34.000000', 'temperatura', 788.0000, 'ºC'),
	(72533, 108, '2015-03-01 00:14:35.000000', 'temperatura', 186.0000, 'ºC'),
	(72534, 108, '2015-03-01 00:14:36.000000', 'temperatura', 963.0000, 'ºC'),
	(72535, 108, '2015-03-01 00:14:37.000000', 'temperatura', 660.0000, 'ºC'),
	(72536, 108, '2015-03-01 00:14:38.000000', 'temperatura', 410.0000, 'ºC'),
	(72537, 108, '2015-03-01 00:14:39.000000', 'temperatura', 69.0000, 'ºC'),
	(72538, 108, '2015-03-01 00:14:40.000000', 'temperatura', 318.0000, 'ºC'),
	(72539, 108, '2015-03-01 00:14:41.000000', 'temperatura', 184.0000, 'ºC'),
	(72540, 108, '2015-03-01 00:14:42.000000', 'temperatura', 1167.0000, 'ºC'),
	(72541, 108, '2015-03-01 00:14:43.000000', 'temperatura', 484.0000, 'ºC'),
	(72542, 108, '2015-03-01 00:14:44.000000', 'temperatura', 119.0000, 'ºC'),
	(72543, 108, '2015-03-01 00:14:45.000000', 'temperatura', 345.0000, 'ºC'),
	(72544, 108, '2015-03-01 00:14:46.000000', 'temperatura', 167.0000, 'ºC'),
	(72545, 108, '2015-03-01 00:14:47.000000', 'temperatura', 1000.0000, 'ºC'),
	(72546, 108, '2015-03-01 00:14:48.000000', 'temperatura', 899.0000, 'ºC'),
	(72547, 108, '2015-03-01 00:14:49.000000', 'temperatura', 294.0000, 'ºC'),
	(72548, 108, '2015-03-01 00:14:50.000000', 'temperatura', 1176.0000, 'ºC'),
	(72549, 108, '2015-03-01 00:14:51.000000', 'temperatura', 199.0000, 'ºC'),
	(72550, 108, '2015-03-01 00:14:52.000000', 'temperatura', 1065.0000, 'ºC'),
	(72551, 108, '2015-03-01 00:14:53.000000', 'temperatura', 1130.0000, 'ºC'),
	(72552, 108, '2015-03-01 00:14:54.000000', 'temperatura', 54.0000, 'ºC'),
	(72553, 108, '2015-03-01 00:14:55.000000', 'temperatura', 482.0000, 'ºC'),
	(72554, 108, '2015-03-01 00:14:56.000000', 'temperatura', 1047.0000, 'ºC'),
	(72555, 108, '2015-03-01 00:14:57.000000', 'temperatura', 192.0000, 'ºC'),
	(72556, 108, '2015-03-01 00:14:58.000000', 'temperatura', 220.0000, 'ºC'),
	(72557, 108, '2015-03-01 00:14:59.000000', 'temperatura', 523.0000, 'ºC'),
	(72558, 108, '2015-03-01 00:15:00.000000', 'temperatura', 755.0000, 'ºC'),
	(72559, 108, '2015-03-01 00:15:01.000000', 'temperatura', 1009.0000, 'ºC'),
	(72560, 108, '2015-03-01 00:15:02.000000', 'temperatura', 377.0000, 'ºC'),
	(72561, 108, '2015-03-01 00:15:03.000000', 'temperatura', 62.0000, 'ºC'),
	(72562, 108, '2015-03-01 00:15:04.000000', 'temperatura', 377.0000, 'ºC'),
	(72563, 108, '2015-03-01 00:15:05.000000', 'temperatura', 502.0000, 'ºC'),
	(72564, 108, '2015-03-01 00:15:06.000000', 'temperatura', 178.0000, 'ºC'),
	(72565, 108, '2015-03-01 00:15:07.000000', 'temperatura', 587.0000, 'ºC'),
	(72566, 108, '2015-03-01 00:15:08.000000', 'temperatura', 1199.0000, 'ºC'),
	(72567, 108, '2015-03-01 00:15:09.000000', 'temperatura', 635.0000, 'ºC'),
	(72568, 108, '2015-03-01 00:15:10.000000', 'temperatura', 777.0000, 'ºC'),
	(72569, 108, '2015-03-01 00:15:11.000000', 'temperatura', 782.0000, 'ºC'),
	(72570, 108, '2015-03-01 00:15:12.000000', 'temperatura', 377.0000, 'ºC'),
	(72571, 108, '2015-03-01 00:15:13.000000', 'temperatura', 743.0000, 'ºC'),
	(72572, 108, '2015-03-01 00:15:14.000000', 'temperatura', 183.0000, 'ºC'),
	(72573, 108, '2015-03-01 00:15:15.000000', 'temperatura', 1085.0000, 'ºC'),
	(72574, 108, '2015-03-01 00:15:16.000000', 'temperatura', 77.0000, 'ºC'),
	(72575, 108, '2015-03-01 00:15:17.000000', 'temperatura', 729.0000, 'ºC'),
	(72576, 108, '2015-03-01 00:15:18.000000', 'temperatura', 1015.0000, 'ºC'),
	(72577, 108, '2015-03-01 00:15:19.000000', 'temperatura', 490.0000, 'ºC'),
	(72578, 108, '2015-03-01 00:15:20.000000', 'temperatura', 606.0000, 'ºC'),
	(72579, 108, '2015-03-01 00:15:21.000000', 'temperatura', 358.0000, 'ºC'),
	(72580, 108, '2015-03-01 00:15:22.000000', 'temperatura', 1173.0000, 'ºC'),
	(72581, 108, '2015-03-01 00:15:23.000000', 'temperatura', 1192.0000, 'ºC'),
	(72582, 108, '2015-03-01 00:15:24.000000', 'temperatura', 42.0000, 'ºC'),
	(72583, 108, '2015-03-01 00:15:25.000000', 'temperatura', 232.0000, 'ºC'),
	(72584, 108, '2015-03-01 00:15:26.000000', 'temperatura', 1036.0000, 'ºC'),
	(72585, 108, '2015-03-01 00:15:27.000000', 'temperatura', 885.0000, 'ºC'),
	(72586, 108, '2015-03-01 00:15:28.000000', 'temperatura', 119.0000, 'ºC'),
	(72587, 108, '2015-03-01 00:15:29.000000', 'temperatura', 339.0000, 'ºC'),
	(72588, 108, '2015-03-01 00:15:30.000000', 'temperatura', 137.0000, 'ºC'),
	(72589, 108, '2015-03-01 00:15:31.000000', 'temperatura', 872.0000, 'ºC'),
	(72590, 108, '2015-03-01 00:15:32.000000', 'temperatura', 346.0000, 'ºC'),
	(72591, 108, '2015-03-01 00:15:33.000000', 'temperatura', 316.0000, 'ºC'),
	(72592, 108, '2015-03-01 00:15:34.000000', 'temperatura', 543.0000, 'ºC'),
	(72593, 108, '2015-03-01 00:15:35.000000', 'temperatura', 567.0000, 'ºC'),
	(72594, 108, '2015-03-01 00:15:36.000000', 'temperatura', 7.0000, 'ºC'),
	(72595, 108, '2015-03-01 00:15:37.000000', 'temperatura', 733.0000, 'ºC'),
	(72596, 108, '2015-03-01 00:15:38.000000', 'temperatura', 45.0000, 'ºC'),
	(72597, 108, '2015-03-01 00:15:39.000000', 'temperatura', 425.0000, 'ºC'),
	(72598, 108, '2015-03-01 00:15:40.000000', 'temperatura', 791.0000, 'ºC'),
	(72599, 108, '2015-03-01 00:15:41.000000', 'temperatura', 282.0000, 'ºC'),
	(72600, 108, '2015-03-01 00:15:42.000000', 'temperatura', 235.0000, 'ºC'),
	(72601, 108, '2015-03-01 00:15:43.000000', 'temperatura', 330.0000, 'ºC'),
	(72602, 108, '2015-03-01 00:15:44.000000', 'temperatura', 945.0000, 'ºC'),
	(72603, 108, '2015-03-01 00:15:45.000000', 'temperatura', 137.0000, 'ºC'),
	(72604, 108, '2015-03-01 00:15:46.000000', 'temperatura', 252.0000, 'ºC'),
	(72605, 108, '2015-03-01 00:15:47.000000', 'temperatura', 848.0000, 'ºC'),
	(72606, 108, '2015-03-01 00:15:48.000000', 'temperatura', 1086.0000, 'ºC'),
	(72607, 108, '2015-03-01 00:15:49.000000', 'temperatura', 487.0000, 'ºC'),
	(72608, 108, '2015-03-01 00:15:50.000000', 'temperatura', 378.0000, 'ºC'),
	(72609, 108, '2015-03-01 00:15:51.000000', 'temperatura', 429.0000, 'ºC'),
	(72610, 108, '2015-03-01 00:15:52.000000', 'temperatura', 1012.0000, 'ºC'),
	(72611, 108, '2015-03-01 00:15:53.000000', 'temperatura', 175.0000, 'ºC'),
	(72612, 108, '2015-03-01 00:15:54.000000', 'temperatura', 237.0000, 'ºC'),
	(72613, 108, '2015-03-01 00:15:55.000000', 'temperatura', 662.0000, 'ºC'),
	(72614, 108, '2015-03-01 00:15:56.000000', 'temperatura', 199.0000, 'ºC'),
	(72615, 108, '2015-03-01 00:15:57.000000', 'temperatura', 209.0000, 'ºC'),
	(72616, 108, '2015-03-01 00:15:58.000000', 'temperatura', 449.0000, 'ºC'),
	(72617, 108, '2015-03-01 00:15:59.000000', 'temperatura', 417.0000, 'ºC'),
	(72618, 108, '2015-03-01 00:16:00.000000', 'temperatura', 739.0000, 'ºC'),
	(72619, 108, '2015-03-01 00:16:01.000000', 'temperatura', 44.0000, 'ºC'),
	(72620, 108, '2015-03-01 00:16:02.000000', 'temperatura', 406.0000, 'ºC'),
	(72621, 108, '2015-03-01 00:16:03.000000', 'temperatura', 696.0000, 'ºC'),
	(72622, 108, '2015-03-01 00:16:04.000000', 'temperatura', 1064.0000, 'ºC'),
	(72623, 108, '2015-03-01 00:16:05.000000', 'temperatura', 830.0000, 'ºC'),
	(72624, 108, '2015-03-01 00:16:06.000000', 'temperatura', 961.0000, 'ºC'),
	(72625, 108, '2015-03-01 00:16:07.000000', 'temperatura', 1114.0000, 'ºC'),
	(72626, 108, '2015-03-01 00:16:08.000000', 'temperatura', 287.0000, 'ºC'),
	(72627, 108, '2015-03-01 00:16:09.000000', 'temperatura', 492.0000, 'ºC'),
	(72628, 108, '2015-03-01 00:16:10.000000', 'temperatura', 402.0000, 'ºC'),
	(72629, 108, '2015-03-01 00:16:11.000000', 'temperatura', 535.0000, 'ºC'),
	(72630, 108, '2015-03-01 00:16:12.000000', 'temperatura', 267.0000, 'ºC'),
	(72631, 108, '2015-03-01 00:16:13.000000', 'temperatura', 931.0000, 'ºC'),
	(72632, 108, '2015-03-01 00:16:14.000000', 'temperatura', 253.0000, 'ºC'),
	(72633, 108, '2015-03-01 00:16:15.000000', 'temperatura', 873.0000, 'ºC'),
	(72634, 108, '2015-03-01 00:16:16.000000', 'temperatura', 9.0000, 'ºC'),
	(72635, 108, '2015-03-01 00:16:17.000000', 'temperatura', 1026.0000, 'ºC'),
	(72636, 108, '2015-03-01 00:16:18.000000', 'temperatura', 302.0000, 'ºC'),
	(72637, 108, '2015-03-01 00:16:19.000000', 'temperatura', 832.0000, 'ºC'),
	(72638, 108, '2015-03-01 00:16:20.000000', 'temperatura', 855.0000, 'ºC'),
	(72639, 108, '2015-03-01 00:16:21.000000', 'temperatura', 578.0000, 'ºC'),
	(72640, 108, '2015-03-01 00:16:22.000000', 'temperatura', 325.0000, 'ºC'),
	(72641, 108, '2015-03-01 00:16:23.000000', 'temperatura', 1093.0000, 'ºC'),
	(72642, 108, '2015-03-01 00:16:24.000000', 'temperatura', 888.0000, 'ºC'),
	(72643, 108, '2015-03-01 00:16:25.000000', 'temperatura', 1165.0000, 'ºC'),
	(72644, 108, '2015-03-01 00:16:26.000000', 'temperatura', 761.0000, 'ºC'),
	(72645, 108, '2015-03-01 00:16:27.000000', 'temperatura', 309.0000, 'ºC'),
	(72646, 108, '2015-03-01 00:16:28.000000', 'temperatura', 462.0000, 'ºC'),
	(72647, 108, '2015-03-01 00:16:29.000000', 'temperatura', 185.0000, 'ºC'),
	(72648, 108, '2015-03-01 00:16:30.000000', 'temperatura', 740.0000, 'ºC'),
	(72649, 108, '2015-03-01 00:16:31.000000', 'temperatura', 745.0000, 'ºC'),
	(72650, 108, '2015-03-01 00:16:32.000000', 'temperatura', 305.0000, 'ºC'),
	(72651, 108, '2015-03-01 00:16:33.000000', 'temperatura', 492.0000, 'ºC'),
	(72652, 108, '2015-03-01 00:16:34.000000', 'temperatura', 346.0000, 'ºC'),
	(72653, 108, '2015-03-01 00:16:35.000000', 'temperatura', 255.0000, 'ºC'),
	(72654, 108, '2015-03-01 00:16:36.000000', 'temperatura', 236.0000, 'ºC'),
	(72655, 108, '2015-03-01 00:16:37.000000', 'temperatura', 417.0000, 'ºC'),
	(72656, 108, '2015-03-01 00:16:38.000000', 'temperatura', 177.0000, 'ºC'),
	(72657, 108, '2015-03-01 00:16:39.000000', 'temperatura', 834.0000, 'ºC'),
	(72658, 108, '2015-03-01 00:16:40.000000', 'temperatura', 38.0000, 'ºC'),
	(72659, 108, '2015-03-01 00:16:41.000000', 'temperatura', 92.0000, 'ºC'),
	(72660, 108, '2015-03-01 00:16:42.000000', 'temperatura', 343.0000, 'ºC'),
	(72661, 108, '2015-03-01 00:16:43.000000', 'temperatura', 241.0000, 'ºC'),
	(72662, 108, '2015-03-01 00:16:44.000000', 'temperatura', 176.0000, 'ºC'),
	(72663, 108, '2015-03-01 00:16:45.000000', 'temperatura', 158.0000, 'ºC'),
	(72664, 108, '2015-03-01 00:16:46.000000', 'temperatura', 262.0000, 'ºC'),
	(72665, 108, '2015-03-01 00:16:47.000000', 'temperatura', 835.0000, 'ºC'),
	(72666, 108, '2015-03-01 00:16:48.000000', 'temperatura', 991.0000, 'ºC'),
	(72667, 108, '2015-03-01 00:16:49.000000', 'temperatura', 51.0000, 'ºC'),
	(72668, 108, '2015-03-01 00:16:50.000000', 'temperatura', 883.0000, 'ºC'),
	(72669, 108, '2015-03-01 00:16:51.000000', 'temperatura', 660.0000, 'ºC'),
	(72670, 108, '2015-03-01 00:16:52.000000', 'temperatura', 654.0000, 'ºC'),
	(72671, 108, '2015-03-01 00:16:53.000000', 'temperatura', 88.0000, 'ºC'),
	(72672, 108, '2015-03-01 00:16:54.000000', 'temperatura', 881.0000, 'ºC'),
	(72673, 108, '2015-03-01 00:16:55.000000', 'temperatura', 541.0000, 'ºC'),
	(72674, 108, '2015-03-01 00:16:56.000000', 'temperatura', 63.0000, 'ºC'),
	(72675, 108, '2015-03-01 00:16:57.000000', 'temperatura', 1091.0000, 'ºC'),
	(72676, 108, '2015-03-01 00:16:58.000000', 'temperatura', 469.0000, 'ºC'),
	(72677, 108, '2015-03-01 00:16:59.000000', 'temperatura', 269.0000, 'ºC'),
	(72678, 108, '2015-03-01 00:17:00.000000', 'temperatura', 1141.0000, 'ºC'),
	(72679, 108, '2015-03-01 00:17:01.000000', 'temperatura', 96.0000, 'ºC'),
	(72680, 108, '2015-03-01 00:17:02.000000', 'temperatura', 660.0000, 'ºC'),
	(72681, 108, '2015-03-01 00:17:03.000000', 'temperatura', 610.0000, 'ºC'),
	(72682, 108, '2015-03-01 00:17:04.000000', 'temperatura', 1072.0000, 'ºC'),
	(72683, 108, '2015-03-01 00:17:05.000000', 'temperatura', 1130.0000, 'ºC'),
	(72684, 108, '2015-03-01 00:17:06.000000', 'temperatura', 37.0000, 'ºC'),
	(72685, 108, '2015-03-01 00:17:07.000000', 'temperatura', 392.0000, 'ºC'),
	(72686, 108, '2015-03-01 00:17:08.000000', 'temperatura', 651.0000, 'ºC'),
	(72687, 108, '2015-03-01 00:17:09.000000', 'temperatura', 879.0000, 'ºC'),
	(72688, 108, '2015-03-01 00:17:10.000000', 'temperatura', 41.0000, 'ºC'),
	(72689, 108, '2015-03-01 00:17:11.000000', 'temperatura', 1168.0000, 'ºC'),
	(72690, 108, '2015-03-01 00:17:12.000000', 'temperatura', 920.0000, 'ºC'),
	(72691, 108, '2015-03-01 00:17:13.000000', 'temperatura', 1094.0000, 'ºC'),
	(72692, 108, '2015-03-01 00:17:14.000000', 'temperatura', 310.0000, 'ºC'),
	(72693, 108, '2015-03-01 00:17:15.000000', 'temperatura', 670.0000, 'ºC'),
	(72694, 108, '2015-03-01 00:17:16.000000', 'temperatura', 22.0000, 'ºC'),
	(72695, 108, '2015-03-01 00:17:17.000000', 'temperatura', 500.0000, 'ºC'),
	(72696, 108, '2015-03-01 00:17:18.000000', 'temperatura', 34.0000, 'ºC'),
	(72697, 108, '2015-03-01 00:17:19.000000', 'temperatura', 1072.0000, 'ºC'),
	(72698, 108, '2015-03-01 00:17:20.000000', 'temperatura', 456.0000, 'ºC'),
	(72699, 108, '2015-03-01 00:17:21.000000', 'temperatura', 264.0000, 'ºC'),
	(72700, 108, '2015-03-01 00:17:22.000000', 'temperatura', 1155.0000, 'ºC'),
	(72701, 108, '2015-03-01 00:17:23.000000', 'temperatura', 182.0000, 'ºC'),
	(72702, 108, '2015-03-01 00:17:24.000000', 'temperatura', 1045.0000, 'ºC'),
	(72703, 108, '2015-03-01 00:17:25.000000', 'temperatura', 1079.0000, 'ºC'),
	(72704, 108, '2015-03-01 00:17:26.000000', 'temperatura', 1062.0000, 'ºC'),
	(72705, 108, '2015-03-01 00:17:27.000000', 'temperatura', 873.0000, 'ºC'),
	(72706, 108, '2015-03-01 00:17:28.000000', 'temperatura', 1180.0000, 'ºC'),
	(72707, 108, '2015-03-01 00:17:29.000000', 'temperatura', 881.0000, 'ºC'),
	(72708, 108, '2015-03-01 00:17:30.000000', 'temperatura', 866.0000, 'ºC'),
	(72709, 108, '2015-03-01 00:17:31.000000', 'temperatura', 488.0000, 'ºC'),
	(72710, 108, '2015-03-01 00:17:32.000000', 'temperatura', 1040.0000, 'ºC'),
	(72711, 108, '2015-03-01 00:17:33.000000', 'temperatura', 140.0000, 'ºC'),
	(72712, 108, '2015-03-01 00:17:34.000000', 'temperatura', 1179.0000, 'ºC'),
	(72713, 108, '2015-03-01 00:17:35.000000', 'temperatura', 675.0000, 'ºC'),
	(72714, 108, '2015-03-01 00:17:36.000000', 'temperatura', 1039.0000, 'ºC'),
	(72715, 108, '2015-03-01 00:17:37.000000', 'temperatura', 771.0000, 'ºC'),
	(72716, 108, '2015-03-01 00:17:38.000000', 'temperatura', 736.0000, 'ºC'),
	(72717, 108, '2015-03-01 00:17:39.000000', 'temperatura', 170.0000, 'ºC'),
	(72718, 108, '2015-03-01 00:17:40.000000', 'temperatura', 1044.0000, 'ºC'),
	(72719, 108, '2015-03-01 00:17:41.000000', 'temperatura', 1108.0000, 'ºC'),
	(72720, 108, '2015-03-01 00:17:42.000000', 'temperatura', 9.0000, 'ºC'),
	(72721, 108, '2015-03-01 00:17:43.000000', 'temperatura', 321.0000, 'ºC'),
	(72722, 108, '2015-03-01 00:17:44.000000', 'temperatura', 380.0000, 'ºC'),
	(72723, 108, '2015-03-01 00:17:45.000000', 'temperatura', 936.0000, 'ºC'),
	(72724, 108, '2015-03-01 00:17:46.000000', 'temperatura', 1141.0000, 'ºC'),
	(72725, 108, '2015-03-01 00:17:47.000000', 'temperatura', 496.0000, 'ºC'),
	(72726, 108, '2015-03-01 00:17:48.000000', 'temperatura', 259.0000, 'ºC'),
	(72727, 108, '2015-03-01 00:17:49.000000', 'temperatura', 1009.0000, 'ºC'),
	(72728, 108, '2015-03-01 00:17:50.000000', 'temperatura', 666.0000, 'ºC'),
	(72729, 108, '2015-03-01 00:17:51.000000', 'temperatura', 303.0000, 'ºC'),
	(72730, 108, '2015-03-01 00:17:52.000000', 'temperatura', 720.0000, 'ºC'),
	(72731, 108, '2015-03-01 00:17:53.000000', 'temperatura', 293.0000, 'ºC'),
	(72732, 108, '2015-03-01 00:17:54.000000', 'temperatura', 502.0000, 'ºC'),
	(72733, 108, '2015-03-01 00:17:55.000000', 'temperatura', 432.0000, 'ºC'),
	(72734, 108, '2015-03-01 00:17:56.000000', 'temperatura', 655.0000, 'ºC'),
	(72735, 108, '2015-03-01 00:17:57.000000', 'temperatura', 778.0000, 'ºC'),
	(72736, 108, '2015-03-01 00:17:58.000000', 'temperatura', 727.0000, 'ºC'),
	(72737, 108, '2015-03-01 00:17:59.000000', 'temperatura', 101.0000, 'ºC'),
	(72738, 108, '2015-03-01 00:18:00.000000', 'temperatura', 725.0000, 'ºC'),
	(72739, 108, '2015-03-01 00:18:01.000000', 'temperatura', 924.0000, 'ºC'),
	(72740, 108, '2015-03-01 00:18:02.000000', 'temperatura', 43.0000, 'ºC'),
	(72741, 108, '2015-03-01 00:18:03.000000', 'temperatura', 1045.0000, 'ºC'),
	(72742, 108, '2015-03-01 00:18:04.000000', 'temperatura', 296.0000, 'ºC'),
	(72743, 108, '2015-03-01 00:18:05.000000', 'temperatura', 744.0000, 'ºC'),
	(72744, 108, '2015-03-01 00:18:06.000000', 'temperatura', 434.0000, 'ºC'),
	(72745, 108, '2015-03-01 00:18:07.000000', 'temperatura', 1138.0000, 'ºC'),
	(72746, 108, '2015-03-01 00:18:08.000000', 'temperatura', 790.0000, 'ºC'),
	(72747, 108, '2015-03-01 00:18:09.000000', 'temperatura', 535.0000, 'ºC'),
	(72748, 108, '2015-03-01 00:18:10.000000', 'temperatura', 307.0000, 'ºC'),
	(72749, 108, '2015-03-01 00:18:11.000000', 'temperatura', 1129.0000, 'ºC'),
	(72750, 108, '2015-03-01 00:18:12.000000', 'temperatura', 1123.0000, 'ºC'),
	(72751, 108, '2015-03-01 00:18:13.000000', 'temperatura', 1032.0000, 'ºC'),
	(72752, 108, '2015-03-01 00:18:14.000000', 'temperatura', 590.0000, 'ºC'),
	(72753, 108, '2015-03-01 00:18:15.000000', 'temperatura', 1054.0000, 'ºC'),
	(72754, 108, '2015-03-01 00:18:16.000000', 'temperatura', 1100.0000, 'ºC'),
	(72755, 108, '2015-03-01 00:18:17.000000', 'temperatura', 1141.0000, 'ºC'),
	(72756, 108, '2015-03-01 00:18:18.000000', 'temperatura', 2.0000, 'ºC'),
	(72757, 108, '2015-03-01 00:18:19.000000', 'temperatura', 190.0000, 'ºC'),
	(72758, 108, '2015-03-01 00:18:20.000000', 'temperatura', 942.0000, 'ºC'),
	(72759, 108, '2015-03-01 00:18:21.000000', 'temperatura', 543.0000, 'ºC'),
	(72760, 108, '2015-03-01 00:18:22.000000', 'temperatura', 1087.0000, 'ºC'),
	(72761, 108, '2015-03-01 00:18:23.000000', 'temperatura', 207.0000, 'ºC'),
	(72762, 108, '2015-03-01 00:18:24.000000', 'temperatura', 173.0000, 'ºC'),
	(72763, 108, '2015-03-01 00:18:25.000000', 'temperatura', 246.0000, 'ºC'),
	(72764, 108, '2015-03-01 00:18:26.000000', 'temperatura', 711.0000, 'ºC'),
	(72765, 108, '2015-03-01 00:18:27.000000', 'temperatura', 418.0000, 'ºC'),
	(72766, 108, '2015-03-01 00:18:28.000000', 'temperatura', 1156.0000, 'ºC'),
	(72767, 108, '2015-03-01 00:18:29.000000', 'temperatura', 927.0000, 'ºC'),
	(72768, 108, '2015-03-01 00:18:30.000000', 'temperatura', 1168.0000, 'ºC'),
	(72769, 108, '2015-03-01 00:18:31.000000', 'temperatura', 658.0000, 'ºC'),
	(72770, 108, '2015-03-01 00:18:32.000000', 'temperatura', 989.0000, 'ºC'),
	(72771, 108, '2015-03-01 00:18:33.000000', 'temperatura', 572.0000, 'ºC'),
	(72772, 108, '2015-03-01 00:18:34.000000', 'temperatura', 1093.0000, 'ºC'),
	(72773, 108, '2015-03-01 00:18:35.000000', 'temperatura', 151.0000, 'ºC'),
	(72774, 108, '2015-03-01 00:18:36.000000', 'temperatura', 1075.0000, 'ºC'),
	(72775, 108, '2015-03-01 00:18:37.000000', 'temperatura', 122.0000, 'ºC'),
	(72776, 108, '2015-03-01 00:18:38.000000', 'temperatura', 985.0000, 'ºC'),
	(72777, 108, '2015-03-01 00:18:39.000000', 'temperatura', 960.0000, 'ºC'),
	(72778, 108, '2015-03-01 00:18:40.000000', 'temperatura', 644.0000, 'ºC'),
	(72779, 108, '2015-03-01 00:18:41.000000', 'temperatura', 342.0000, 'ºC'),
	(72780, 108, '2015-03-01 00:18:42.000000', 'temperatura', 978.0000, 'ºC'),
	(72781, 108, '2015-03-01 00:18:43.000000', 'temperatura', 264.0000, 'ºC'),
	(72782, 108, '2015-03-01 00:18:44.000000', 'temperatura', 788.0000, 'ºC'),
	(72783, 108, '2015-03-01 00:18:45.000000', 'temperatura', 748.0000, 'ºC'),
	(72784, 108, '2015-03-01 00:18:46.000000', 'temperatura', 176.0000, 'ºC'),
	(72785, 108, '2015-03-01 00:18:47.000000', 'temperatura', 1035.0000, 'ºC'),
	(72786, 108, '2015-03-01 00:18:48.000000', 'temperatura', 1050.0000, 'ºC'),
	(72787, 108, '2015-03-01 00:18:49.000000', 'temperatura', 945.0000, 'ºC'),
	(72788, 108, '2015-03-01 00:18:50.000000', 'temperatura', 376.0000, 'ºC'),
	(72789, 108, '2015-03-01 00:18:51.000000', 'temperatura', 247.0000, 'ºC'),
	(72790, 108, '2015-03-01 00:18:52.000000', 'temperatura', 105.0000, 'ºC'),
	(72791, 108, '2015-03-01 00:18:53.000000', 'temperatura', 984.0000, 'ºC'),
	(72792, 108, '2015-03-01 00:18:54.000000', 'temperatura', 1005.0000, 'ºC'),
	(72793, 108, '2015-03-01 00:18:55.000000', 'temperatura', 876.0000, 'ºC'),
	(72794, 108, '2015-03-01 00:18:56.000000', 'temperatura', 165.0000, 'ºC'),
	(72795, 108, '2015-03-01 00:18:57.000000', 'temperatura', 598.0000, 'ºC'),
	(72796, 108, '2015-03-01 00:18:58.000000', 'temperatura', 93.0000, 'ºC'),
	(72797, 108, '2015-03-01 00:18:59.000000', 'temperatura', 1072.0000, 'ºC'),
	(72798, 108, '2015-03-01 00:19:00.000000', 'temperatura', 283.0000, 'ºC'),
	(72799, 108, '2015-03-01 00:19:01.000000', 'temperatura', 597.0000, 'ºC'),
	(72800, 108, '2015-03-01 00:19:02.000000', 'temperatura', 937.0000, 'ºC'),
	(72801, 108, '2015-03-01 00:19:03.000000', 'temperatura', 493.0000, 'ºC'),
	(72802, 108, '2015-03-01 00:19:04.000000', 'temperatura', 857.0000, 'ºC'),
	(72803, 108, '2015-03-01 00:19:05.000000', 'temperatura', 408.0000, 'ºC'),
	(72804, 108, '2015-03-01 00:19:06.000000', 'temperatura', 667.0000, 'ºC'),
	(72805, 108, '2015-03-01 00:19:07.000000', 'temperatura', 912.0000, 'ºC'),
	(72806, 108, '2015-03-01 00:19:08.000000', 'temperatura', 160.0000, 'ºC'),
	(72807, 108, '2015-03-01 00:19:09.000000', 'temperatura', 463.0000, 'ºC'),
	(72808, 108, '2015-03-01 00:19:10.000000', 'temperatura', 637.0000, 'ºC'),
	(72809, 108, '2015-03-01 00:19:11.000000', 'temperatura', 597.0000, 'ºC'),
	(72810, 108, '2015-03-01 00:19:12.000000', 'temperatura', 1074.0000, 'ºC'),
	(72811, 108, '2015-03-01 00:19:13.000000', 'temperatura', 1178.0000, 'ºC'),
	(72812, 108, '2015-03-01 00:19:14.000000', 'temperatura', 271.0000, 'ºC'),
	(72813, 108, '2015-03-01 00:19:15.000000', 'temperatura', 218.0000, 'ºC'),
	(72814, 108, '2015-03-01 00:19:16.000000', 'temperatura', 281.0000, 'ºC'),
	(72815, 108, '2015-03-01 00:19:17.000000', 'temperatura', 750.0000, 'ºC'),
	(72816, 108, '2015-03-01 00:19:18.000000', 'temperatura', 509.0000, 'ºC'),
	(72817, 108, '2015-03-01 00:19:19.000000', 'temperatura', 293.0000, 'ºC'),
	(72818, 108, '2015-03-01 00:19:20.000000', 'temperatura', 1141.0000, 'ºC'),
	(72819, 108, '2015-03-01 00:19:21.000000', 'temperatura', 26.0000, 'ºC'),
	(72820, 108, '2015-03-01 00:19:22.000000', 'temperatura', 309.0000, 'ºC'),
	(72821, 108, '2015-03-01 00:19:23.000000', 'temperatura', 264.0000, 'ºC'),
	(72822, 108, '2015-03-01 00:19:24.000000', 'temperatura', 396.0000, 'ºC'),
	(72823, 108, '2015-03-01 00:19:25.000000', 'temperatura', 1188.0000, 'ºC'),
	(72824, 108, '2015-03-01 00:19:26.000000', 'temperatura', 1153.0000, 'ºC'),
	(72825, 108, '2015-03-01 00:19:27.000000', 'temperatura', 999.0000, 'ºC'),
	(72826, 108, '2015-03-01 00:19:28.000000', 'temperatura', 339.0000, 'ºC'),
	(72827, 108, '2015-03-01 00:19:29.000000', 'temperatura', 1099.0000, 'ºC'),
	(72828, 108, '2015-03-01 00:19:30.000000', 'temperatura', 876.0000, 'ºC'),
	(72829, 108, '2015-03-01 00:19:31.000000', 'temperatura', 1085.0000, 'ºC'),
	(72830, 108, '2015-03-01 00:19:32.000000', 'temperatura', 397.0000, 'ºC'),
	(72831, 108, '2015-03-01 00:19:33.000000', 'temperatura', 1132.0000, 'ºC'),
	(72832, 108, '2015-03-01 00:19:34.000000', 'temperatura', 867.0000, 'ºC'),
	(72833, 108, '2015-03-01 00:19:35.000000', 'temperatura', 940.0000, 'ºC'),
	(72834, 108, '2015-03-01 00:19:36.000000', 'temperatura', 901.0000, 'ºC'),
	(72835, 108, '2015-03-01 00:19:37.000000', 'temperatura', 483.0000, 'ºC'),
	(72836, 108, '2015-03-01 00:19:38.000000', 'temperatura', 913.0000, 'ºC'),
	(72837, 108, '2015-03-01 00:19:39.000000', 'temperatura', 718.0000, 'ºC'),
	(72838, 108, '2015-03-01 00:19:40.000000', 'temperatura', 851.0000, 'ºC'),
	(72839, 108, '2015-03-01 00:19:41.000000', 'temperatura', 900.0000, 'ºC'),
	(72840, 108, '2015-03-01 00:19:42.000000', 'temperatura', 749.0000, 'ºC'),
	(72841, 108, '2015-03-01 00:19:43.000000', 'temperatura', 1045.0000, 'ºC'),
	(72842, 108, '2015-03-01 00:19:44.000000', 'temperatura', 580.0000, 'ºC'),
	(72843, 108, '2015-03-01 00:19:45.000000', 'temperatura', 964.0000, 'ºC'),
	(72844, 108, '2015-03-01 00:19:46.000000', 'temperatura', 681.0000, 'ºC'),
	(72845, 108, '2015-03-01 00:19:47.000000', 'temperatura', 515.0000, 'ºC'),
	(72846, 108, '2015-03-01 00:19:48.000000', 'temperatura', 530.0000, 'ºC'),
	(72847, 108, '2015-03-01 00:19:49.000000', 'temperatura', 1107.0000, 'ºC'),
	(72848, 108, '2015-03-01 00:19:50.000000', 'temperatura', 345.0000, 'ºC'),
	(72849, 108, '2015-03-01 00:19:51.000000', 'temperatura', 803.0000, 'ºC'),
	(72850, 108, '2015-03-01 00:19:52.000000', 'temperatura', 580.0000, 'ºC'),
	(72851, 108, '2015-03-01 00:19:53.000000', 'temperatura', 493.0000, 'ºC'),
	(72852, 108, '2015-03-01 00:19:54.000000', 'temperatura', 724.0000, 'ºC'),
	(72853, 108, '2015-03-01 00:19:55.000000', 'temperatura', 944.0000, 'ºC'),
	(72854, 108, '2015-03-01 00:19:56.000000', 'temperatura', 149.0000, 'ºC'),
	(72855, 108, '2015-03-01 00:19:57.000000', 'temperatura', 312.0000, 'ºC'),
	(72856, 108, '2015-03-01 00:19:58.000000', 'temperatura', 1112.0000, 'ºC'),
	(72857, 108, '2015-03-01 00:19:59.000000', 'temperatura', 1026.0000, 'ºC'),
	(72858, 108, '2015-03-01 00:20:00.000000', 'temperatura', 594.0000, 'ºC'),
	(72859, 108, '2015-03-01 00:20:01.000000', 'temperatura', 1091.0000, 'ºC'),
	(72860, 108, '2015-03-01 00:20:02.000000', 'temperatura', 76.0000, 'ºC'),
	(72861, 108, '2015-03-01 00:20:03.000000', 'temperatura', 706.0000, 'ºC'),
	(72862, 108, '2015-03-01 00:20:04.000000', 'temperatura', 905.0000, 'ºC'),
	(72863, 108, '2015-03-01 00:20:05.000000', 'temperatura', 4.0000, 'ºC'),
	(72864, 108, '2015-03-01 00:20:06.000000', 'temperatura', 907.0000, 'ºC'),
	(72865, 108, '2015-03-01 00:20:07.000000', 'temperatura', 923.0000, 'ºC'),
	(72866, 108, '2015-03-01 00:20:08.000000', 'temperatura', 697.0000, 'ºC'),
	(72867, 108, '2015-03-01 00:20:09.000000', 'temperatura', 714.0000, 'ºC'),
	(72868, 108, '2015-03-01 00:20:10.000000', 'temperatura', 278.0000, 'ºC'),
	(72869, 108, '2015-03-01 00:20:11.000000', 'temperatura', 451.0000, 'ºC'),
	(72870, 108, '2015-03-01 00:20:12.000000', 'temperatura', 221.0000, 'ºC'),
	(72871, 108, '2015-03-01 00:20:13.000000', 'temperatura', 950.0000, 'ºC'),
	(72872, 108, '2015-03-01 00:20:14.000000', 'temperatura', 490.0000, 'ºC'),
	(72873, 108, '2015-03-01 00:20:15.000000', 'temperatura', 801.0000, 'ºC'),
	(72874, 108, '2015-03-01 00:20:16.000000', 'temperatura', 135.0000, 'ºC'),
	(72875, 108, '2015-03-01 00:20:17.000000', 'temperatura', 673.0000, 'ºC'),
	(72876, 108, '2015-03-01 00:20:18.000000', 'temperatura', 562.0000, 'ºC'),
	(72877, 108, '2015-03-01 00:20:19.000000', 'temperatura', 789.0000, 'ºC'),
	(72878, 108, '2015-03-01 00:20:20.000000', 'temperatura', 1060.0000, 'ºC'),
	(72879, 108, '2015-03-01 00:20:21.000000', 'temperatura', 534.0000, 'ºC'),
	(72880, 108, '2015-03-01 00:20:22.000000', 'temperatura', 690.0000, 'ºC'),
	(72881, 108, '2015-03-01 00:20:23.000000', 'temperatura', 647.0000, 'ºC'),
	(72882, 108, '2015-03-01 00:20:24.000000', 'temperatura', 1167.0000, 'ºC'),
	(72883, 108, '2015-03-01 00:20:25.000000', 'temperatura', 294.0000, 'ºC'),
	(72884, 108, '2015-03-01 00:20:26.000000', 'temperatura', 371.0000, 'ºC'),
	(72885, 108, '2015-03-01 00:20:27.000000', 'temperatura', 975.0000, 'ºC'),
	(72886, 108, '2015-03-01 00:20:28.000000', 'temperatura', 159.0000, 'ºC'),
	(72887, 108, '2015-03-01 00:20:29.000000', 'temperatura', 271.0000, 'ºC'),
	(72888, 108, '2015-03-01 00:20:30.000000', 'temperatura', 877.0000, 'ºC'),
	(72889, 108, '2015-03-01 00:20:31.000000', 'temperatura', 1175.0000, 'ºC'),
	(72890, 108, '2015-03-01 00:20:32.000000', 'temperatura', 843.0000, 'ºC'),
	(72891, 108, '2015-03-01 00:20:33.000000', 'temperatura', 691.0000, 'ºC'),
	(72892, 108, '2015-03-01 00:20:34.000000', 'temperatura', 927.0000, 'ºC'),
	(72893, 108, '2015-03-01 00:20:35.000000', 'temperatura', 164.0000, 'ºC'),
	(72894, 108, '2015-03-01 00:20:36.000000', 'temperatura', 439.0000, 'ºC'),
	(72895, 108, '2015-03-01 00:20:37.000000', 'temperatura', 501.0000, 'ºC'),
	(72896, 108, '2015-03-01 00:20:38.000000', 'temperatura', 1191.0000, 'ºC'),
	(72897, 108, '2015-03-01 00:20:39.000000', 'temperatura', 853.0000, 'ºC'),
	(72898, 108, '2015-03-01 00:20:40.000000', 'temperatura', 690.0000, 'ºC'),
	(72899, 108, '2015-03-01 00:20:41.000000', 'temperatura', 891.0000, 'ºC'),
	(72900, 108, '2015-03-01 00:20:42.000000', 'temperatura', 1185.0000, 'ºC'),
	(72901, 108, '2015-03-01 00:20:43.000000', 'temperatura', 853.0000, 'ºC'),
	(72902, 108, '2015-03-01 00:20:44.000000', 'temperatura', 710.0000, 'ºC'),
	(72903, 108, '2015-03-01 00:20:45.000000', 'temperatura', 994.0000, 'ºC'),
	(72904, 108, '2015-03-01 00:20:46.000000', 'temperatura', 437.0000, 'ºC'),
	(72905, 108, '2015-03-01 00:20:47.000000', 'temperatura', 406.0000, 'ºC'),
	(72906, 108, '2015-03-01 00:20:48.000000', 'temperatura', 721.0000, 'ºC'),
	(72907, 108, '2015-03-01 00:20:49.000000', 'temperatura', 1186.0000, 'ºC'),
	(72908, 108, '2015-03-01 00:20:50.000000', 'temperatura', 167.0000, 'ºC'),
	(72909, 108, '2015-03-01 00:20:51.000000', 'temperatura', 877.0000, 'ºC'),
	(72910, 108, '2015-03-01 00:20:52.000000', 'temperatura', 287.0000, 'ºC'),
	(72911, 108, '2015-03-01 00:20:53.000000', 'temperatura', 4.0000, 'ºC'),
	(72912, 108, '2015-03-01 00:20:54.000000', 'temperatura', 359.0000, 'ºC'),
	(72913, 108, '2015-03-01 00:20:55.000000', 'temperatura', 585.0000, 'ºC'),
	(72914, 108, '2015-03-01 00:20:56.000000', 'temperatura', 648.0000, 'ºC'),
	(72915, 108, '2015-03-01 00:20:57.000000', 'temperatura', 286.0000, 'ºC'),
	(72916, 108, '2015-03-01 00:20:58.000000', 'temperatura', 687.0000, 'ºC'),
	(72917, 108, '2015-03-01 00:20:59.000000', 'temperatura', 177.0000, 'ºC'),
	(72918, 108, '2015-03-01 00:21:00.000000', 'temperatura', 23.0000, 'ºC'),
	(72919, 108, '2015-03-01 00:21:01.000000', 'temperatura', 784.0000, 'ºC'),
	(72920, 108, '2015-03-01 00:21:02.000000', 'temperatura', 253.0000, 'ºC'),
	(72921, 108, '2015-03-01 00:21:03.000000', 'temperatura', 114.0000, 'ºC'),
	(72922, 108, '2015-03-01 00:21:04.000000', 'temperatura', 1012.0000, 'ºC'),
	(72923, 108, '2015-03-01 00:21:05.000000', 'temperatura', 1117.0000, 'ºC'),
	(72924, 108, '2015-03-01 00:21:06.000000', 'temperatura', 149.0000, 'ºC'),
	(72925, 108, '2015-03-01 00:21:07.000000', 'temperatura', 995.0000, 'ºC'),
	(72926, 108, '2015-03-01 00:21:08.000000', 'temperatura', 928.0000, 'ºC'),
	(72927, 108, '2015-03-01 00:21:09.000000', 'temperatura', 454.0000, 'ºC'),
	(72928, 108, '2015-03-01 00:21:10.000000', 'temperatura', 688.0000, 'ºC'),
	(72929, 108, '2015-03-01 00:21:11.000000', 'temperatura', 878.0000, 'ºC'),
	(72930, 108, '2015-03-01 00:21:12.000000', 'temperatura', 1125.0000, 'ºC'),
	(72931, 108, '2015-03-01 00:21:13.000000', 'temperatura', 593.0000, 'ºC'),
	(72932, 108, '2015-03-01 00:21:14.000000', 'temperatura', 791.0000, 'ºC'),
	(72933, 108, '2015-03-01 00:21:15.000000', 'temperatura', 974.0000, 'ºC'),
	(72934, 108, '2015-03-01 00:21:16.000000', 'temperatura', 101.0000, 'ºC'),
	(72935, 108, '2015-03-01 00:21:17.000000', 'temperatura', 1181.0000, 'ºC'),
	(72936, 108, '2015-03-01 00:21:18.000000', 'temperatura', 802.0000, 'ºC'),
	(72937, 108, '2015-03-01 00:21:19.000000', 'temperatura', 469.0000, 'ºC'),
	(72938, 108, '2015-03-01 00:21:20.000000', 'temperatura', 1139.0000, 'ºC'),
	(72939, 108, '2015-03-01 00:21:21.000000', 'temperatura', 690.0000, 'ºC'),
	(72940, 108, '2015-03-01 00:21:22.000000', 'temperatura', 31.0000, 'ºC'),
	(72941, 108, '2015-03-01 00:21:23.000000', 'temperatura', 486.0000, 'ºC'),
	(72942, 108, '2015-03-01 00:21:24.000000', 'temperatura', 1136.0000, 'ºC'),
	(72943, 108, '2015-03-01 00:21:25.000000', 'temperatura', 624.0000, 'ºC'),
	(72944, 108, '2015-03-01 00:21:26.000000', 'temperatura', 910.0000, 'ºC'),
	(72945, 108, '2015-03-01 00:21:27.000000', 'temperatura', 282.0000, 'ºC'),
	(72946, 108, '2015-03-01 00:21:28.000000', 'temperatura', 1077.0000, 'ºC'),
	(72947, 108, '2015-03-01 00:21:29.000000', 'temperatura', 942.0000, 'ºC'),
	(72948, 108, '2015-03-01 00:21:30.000000', 'temperatura', 279.0000, 'ºC'),
	(72949, 108, '2015-03-01 00:21:31.000000', 'temperatura', 970.0000, 'ºC'),
	(72950, 108, '2015-03-01 00:21:32.000000', 'temperatura', 411.0000, 'ºC'),
	(72951, 108, '2015-03-01 00:21:33.000000', 'temperatura', 348.0000, 'ºC'),
	(72952, 108, '2015-03-01 00:21:34.000000', 'temperatura', 507.0000, 'ºC'),
	(72953, 108, '2015-03-01 00:21:35.000000', 'temperatura', 293.0000, 'ºC'),
	(72954, 108, '2015-03-01 00:21:36.000000', 'temperatura', 1143.0000, 'ºC'),
	(72955, 108, '2015-03-01 00:21:37.000000', 'temperatura', 39.0000, 'ºC'),
	(72956, 108, '2015-03-01 00:21:38.000000', 'temperatura', 363.0000, 'ºC'),
	(72957, 108, '2015-03-01 00:21:39.000000', 'temperatura', 501.0000, 'ºC'),
	(72958, 108, '2015-03-01 00:21:40.000000', 'temperatura', 214.0000, 'ºC'),
	(72959, 108, '2015-03-01 00:21:41.000000', 'temperatura', 769.0000, 'ºC'),
	(72960, 108, '2015-03-01 00:21:42.000000', 'temperatura', 802.0000, 'ºC'),
	(72961, 108, '2015-03-01 00:21:43.000000', 'temperatura', 505.0000, 'ºC'),
	(72962, 108, '2015-03-01 00:21:44.000000', 'temperatura', 118.0000, 'ºC'),
	(72963, 108, '2015-03-01 00:21:45.000000', 'temperatura', 276.0000, 'ºC'),
	(72964, 108, '2015-03-01 00:21:46.000000', 'temperatura', 1027.0000, 'ºC'),
	(72965, 108, '2015-03-01 00:21:47.000000', 'temperatura', 709.0000, 'ºC'),
	(72966, 108, '2015-03-01 00:21:48.000000', 'temperatura', 464.0000, 'ºC'),
	(72967, 108, '2015-03-01 00:21:49.000000', 'temperatura', 192.0000, 'ºC'),
	(72968, 108, '2015-03-01 00:21:50.000000', 'temperatura', 768.0000, 'ºC'),
	(72969, 108, '2015-03-01 00:21:51.000000', 'temperatura', 865.0000, 'ºC'),
	(72970, 108, '2015-03-01 00:21:52.000000', 'temperatura', 824.0000, 'ºC'),
	(72971, 108, '2015-03-01 00:21:53.000000', 'temperatura', 323.0000, 'ºC'),
	(72972, 108, '2015-03-01 00:21:54.000000', 'temperatura', 346.0000, 'ºC'),
	(72973, 108, '2015-03-01 00:21:55.000000', 'temperatura', 760.0000, 'ºC'),
	(72974, 108, '2015-03-01 00:21:56.000000', 'temperatura', 361.0000, 'ºC'),
	(72975, 108, '2015-03-01 00:21:57.000000', 'temperatura', 725.0000, 'ºC'),
	(72976, 108, '2015-03-01 00:21:58.000000', 'temperatura', 144.0000, 'ºC'),
	(72977, 108, '2015-03-01 00:21:59.000000', 'temperatura', 945.0000, 'ºC'),
	(72978, 108, '2015-03-01 00:22:00.000000', 'temperatura', 696.0000, 'ºC'),
	(72979, 108, '2015-03-01 00:22:01.000000', 'temperatura', 643.0000, 'ºC'),
	(72980, 108, '2015-03-01 00:22:02.000000', 'temperatura', 1127.0000, 'ºC'),
	(72981, 108, '2015-03-01 00:22:03.000000', 'temperatura', 106.0000, 'ºC'),
	(72982, 108, '2015-03-01 00:22:04.000000', 'temperatura', 751.0000, 'ºC'),
	(72983, 108, '2015-03-01 00:22:05.000000', 'temperatura', 1036.0000, 'ºC'),
	(72984, 108, '2015-03-01 00:22:06.000000', 'temperatura', 529.0000, 'ºC'),
	(72985, 108, '2015-03-01 00:22:07.000000', 'temperatura', 737.0000, 'ºC'),
	(72986, 108, '2015-03-01 00:22:08.000000', 'temperatura', 900.0000, 'ºC'),
	(72987, 108, '2015-03-01 00:22:09.000000', 'temperatura', 1088.0000, 'ºC'),
	(72988, 108, '2015-03-01 00:22:10.000000', 'temperatura', 341.0000, 'ºC'),
	(72989, 108, '2015-03-01 00:22:11.000000', 'temperatura', 840.0000, 'ºC'),
	(72990, 108, '2015-03-01 00:22:12.000000', 'temperatura', 777.0000, 'ºC'),
	(72991, 108, '2015-03-01 00:22:13.000000', 'temperatura', 165.0000, 'ºC'),
	(72992, 108, '2015-03-01 00:22:14.000000', 'temperatura', 894.0000, 'ºC'),
	(72993, 108, '2015-03-01 00:22:15.000000', 'temperatura', 377.0000, 'ºC'),
	(72994, 108, '2015-03-01 00:22:16.000000', 'temperatura', 402.0000, 'ºC'),
	(72995, 108, '2015-03-01 00:22:17.000000', 'temperatura', 880.0000, 'ºC'),
	(72996, 108, '2015-03-01 00:22:18.000000', 'temperatura', 796.0000, 'ºC'),
	(72997, 108, '2015-03-01 00:22:19.000000', 'temperatura', 141.0000, 'ºC'),
	(72998, 108, '2015-03-01 00:22:20.000000', 'temperatura', 718.0000, 'ºC'),
	(72999, 108, '2015-03-01 00:22:21.000000', 'temperatura', 766.0000, 'ºC'),
	(73000, 108, '2015-03-01 00:22:22.000000', 'temperatura', 475.0000, 'ºC'),
	(73001, 108, '2015-03-01 00:22:23.000000', 'temperatura', 78.0000, 'ºC'),
	(73002, 108, '2015-03-01 00:22:24.000000', 'temperatura', 166.0000, 'ºC'),
	(73003, 108, '2015-03-01 00:22:25.000000', 'temperatura', 596.0000, 'ºC'),
	(73004, 108, '2015-03-01 00:22:26.000000', 'temperatura', 84.0000, 'ºC'),
	(73005, 108, '2015-03-01 00:22:27.000000', 'temperatura', 1034.0000, 'ºC'),
	(73006, 108, '2015-03-01 00:22:28.000000', 'temperatura', 116.0000, 'ºC'),
	(73007, 108, '2015-03-01 00:22:29.000000', 'temperatura', 1079.0000, 'ºC'),
	(73008, 108, '2015-03-01 00:22:30.000000', 'temperatura', 246.0000, 'ºC'),
	(73009, 108, '2015-03-01 00:22:31.000000', 'temperatura', 393.0000, 'ºC'),
	(73010, 108, '2015-03-01 00:22:32.000000', 'temperatura', 30.0000, 'ºC'),
	(73011, 108, '2015-03-01 00:22:33.000000', 'temperatura', 171.0000, 'ºC'),
	(73012, 108, '2015-03-01 00:22:34.000000', 'temperatura', 764.0000, 'ºC'),
	(73013, 108, '2015-03-01 00:22:35.000000', 'temperatura', 908.0000, 'ºC'),
	(73014, 108, '2015-03-01 00:22:36.000000', 'temperatura', 1050.0000, 'ºC'),
	(73015, 108, '2015-03-01 00:22:37.000000', 'temperatura', 124.0000, 'ºC'),
	(73016, 108, '2015-03-01 00:22:38.000000', 'temperatura', 1072.0000, 'ºC'),
	(73017, 108, '2015-03-01 00:22:39.000000', 'temperatura', 189.0000, 'ºC'),
	(73018, 108, '2015-03-01 00:22:40.000000', 'temperatura', 130.0000, 'ºC'),
	(73019, 108, '2015-03-01 00:22:41.000000', 'temperatura', 84.0000, 'ºC'),
	(73020, 108, '2015-03-01 00:22:42.000000', 'temperatura', 32.0000, 'ºC'),
	(73021, 108, '2015-03-01 00:22:43.000000', 'temperatura', 1105.0000, 'ºC'),
	(73022, 108, '2015-03-01 00:22:44.000000', 'temperatura', 631.0000, 'ºC'),
	(73023, 108, '2015-03-01 00:22:45.000000', 'temperatura', 1041.0000, 'ºC'),
	(73024, 108, '2015-03-01 00:22:46.000000', 'temperatura', 913.0000, 'ºC'),
	(73025, 108, '2015-03-01 00:22:47.000000', 'temperatura', 244.0000, 'ºC'),
	(73026, 108, '2015-03-01 00:22:48.000000', 'temperatura', 878.0000, 'ºC'),
	(73027, 108, '2015-03-01 00:22:49.000000', 'temperatura', 61.0000, 'ºC'),
	(73028, 108, '2015-03-01 00:22:50.000000', 'temperatura', 71.0000, 'ºC'),
	(73029, 108, '2015-03-01 00:22:51.000000', 'temperatura', 174.0000, 'ºC'),
	(73030, 108, '2015-03-01 00:22:52.000000', 'temperatura', 658.0000, 'ºC'),
	(73031, 108, '2015-03-01 00:22:53.000000', 'temperatura', 366.0000, 'ºC'),
	(73032, 108, '2015-03-01 00:22:54.000000', 'temperatura', 1056.0000, 'ºC'),
	(73033, 108, '2015-03-01 00:22:55.000000', 'temperatura', 583.0000, 'ºC'),
	(73034, 108, '2015-03-01 00:22:56.000000', 'temperatura', 949.0000, 'ºC'),
	(73035, 108, '2015-03-01 00:22:57.000000', 'temperatura', 594.0000, 'ºC'),
	(73036, 108, '2015-03-01 00:22:58.000000', 'temperatura', 125.0000, 'ºC'),
	(73037, 108, '2015-03-01 00:22:59.000000', 'temperatura', 42.0000, 'ºC'),
	(73038, 108, '2015-03-01 00:23:00.000000', 'temperatura', 1035.0000, 'ºC'),
	(73039, 108, '2015-03-01 00:23:01.000000', 'temperatura', 250.0000, 'ºC'),
	(73040, 108, '2015-03-01 00:23:02.000000', 'temperatura', 544.0000, 'ºC'),
	(73041, 108, '2015-03-01 00:23:03.000000', 'temperatura', 771.0000, 'ºC'),
	(73042, 108, '2015-03-01 00:23:04.000000', 'temperatura', 1023.0000, 'ºC'),
	(73043, 108, '2015-03-01 00:23:05.000000', 'temperatura', 402.0000, 'ºC'),
	(73044, 108, '2015-03-01 00:23:06.000000', 'temperatura', 141.0000, 'ºC'),
	(73045, 108, '2015-03-01 00:23:07.000000', 'temperatura', 701.0000, 'ºC'),
	(73046, 108, '2015-03-01 00:23:08.000000', 'temperatura', 684.0000, 'ºC'),
	(73047, 108, '2015-03-01 00:23:09.000000', 'temperatura', 114.0000, 'ºC'),
	(73048, 108, '2015-03-01 00:23:10.000000', 'temperatura', 920.0000, 'ºC'),
	(73049, 108, '2015-03-01 00:23:11.000000', 'temperatura', 660.0000, 'ºC'),
	(73050, 108, '2015-03-01 00:23:12.000000', 'temperatura', 539.0000, 'ºC'),
	(73051, 108, '2015-03-01 00:23:13.000000', 'temperatura', 717.0000, 'ºC'),
	(73052, 108, '2015-03-01 00:23:14.000000', 'temperatura', 768.0000, 'ºC'),
	(73053, 108, '2015-03-01 00:23:15.000000', 'temperatura', 489.0000, 'ºC'),
	(73054, 108, '2015-03-01 00:23:16.000000', 'temperatura', 144.0000, 'ºC'),
	(73055, 108, '2015-03-01 00:23:17.000000', 'temperatura', 451.0000, 'ºC'),
	(73056, 108, '2015-03-01 00:23:18.000000', 'temperatura', 623.0000, 'ºC'),
	(73057, 108, '2015-03-01 00:23:19.000000', 'temperatura', 564.0000, 'ºC'),
	(73058, 108, '2015-03-01 00:23:20.000000', 'temperatura', 953.0000, 'ºC'),
	(73059, 108, '2015-03-01 00:23:21.000000', 'temperatura', 672.0000, 'ºC'),
	(73060, 108, '2015-03-01 00:23:22.000000', 'temperatura', 500.0000, 'ºC'),
	(73061, 108, '2015-03-01 00:23:23.000000', 'temperatura', 487.0000, 'ºC'),
	(73062, 108, '2015-03-01 00:23:24.000000', 'temperatura', 933.0000, 'ºC'),
	(73063, 108, '2015-03-01 00:23:25.000000', 'temperatura', 805.0000, 'ºC'),
	(73064, 108, '2015-03-01 00:23:26.000000', 'temperatura', 28.0000, 'ºC'),
	(73065, 108, '2015-03-01 00:23:27.000000', 'temperatura', 125.0000, 'ºC'),
	(73066, 108, '2015-03-01 00:23:28.000000', 'temperatura', 543.0000, 'ºC'),
	(73067, 108, '2015-03-01 00:23:29.000000', 'temperatura', 1140.0000, 'ºC'),
	(73068, 108, '2015-03-01 00:23:30.000000', 'temperatura', 472.0000, 'ºC'),
	(73069, 108, '2015-03-01 00:23:31.000000', 'temperatura', 139.0000, 'ºC'),
	(73070, 108, '2015-03-01 00:23:32.000000', 'temperatura', 480.0000, 'ºC'),
	(73071, 108, '2015-03-01 00:23:33.000000', 'temperatura', 784.0000, 'ºC'),
	(73072, 108, '2015-03-01 00:23:34.000000', 'temperatura', 81.0000, 'ºC'),
	(73073, 108, '2015-03-01 00:23:35.000000', 'temperatura', 451.0000, 'ºC'),
	(73074, 108, '2015-03-01 00:23:36.000000', 'temperatura', 814.0000, 'ºC'),
	(73075, 108, '2015-03-01 00:23:37.000000', 'temperatura', 316.0000, 'ºC'),
	(73076, 108, '2015-03-01 00:23:38.000000', 'temperatura', 341.0000, 'ºC'),
	(73077, 108, '2015-03-01 00:23:39.000000', 'temperatura', 758.0000, 'ºC'),
	(73078, 108, '2015-03-01 00:23:40.000000', 'temperatura', 365.0000, 'ºC'),
	(73079, 108, '2015-03-01 00:23:41.000000', 'temperatura', 754.0000, 'ºC'),
	(73080, 108, '2015-03-01 00:23:42.000000', 'temperatura', 273.0000, 'ºC'),
	(73081, 108, '2015-03-01 00:23:43.000000', 'temperatura', 306.0000, 'ºC'),
	(73082, 108, '2015-03-01 00:23:44.000000', 'temperatura', 709.0000, 'ºC'),
	(73083, 108, '2015-03-01 00:23:45.000000', 'temperatura', 227.0000, 'ºC'),
	(73084, 108, '2015-03-01 00:23:46.000000', 'temperatura', 208.0000, 'ºC'),
	(73085, 108, '2015-03-01 00:23:47.000000', 'temperatura', 361.0000, 'ºC'),
	(73086, 108, '2015-03-01 00:23:48.000000', 'temperatura', 1183.0000, 'ºC'),
	(73087, 108, '2015-03-01 00:23:49.000000', 'temperatura', 29.0000, 'ºC'),
	(73088, 108, '2015-03-01 00:23:50.000000', 'temperatura', 200.0000, 'ºC'),
	(73089, 108, '2015-03-01 00:23:51.000000', 'temperatura', 910.0000, 'ºC'),
	(73090, 108, '2015-03-01 00:23:52.000000', 'temperatura', 354.0000, 'ºC'),
	(73091, 108, '2015-03-01 00:23:53.000000', 'temperatura', 239.0000, 'ºC'),
	(73092, 108, '2015-03-01 00:23:54.000000', 'temperatura', 134.0000, 'ºC'),
	(73093, 108, '2015-03-01 00:23:55.000000', 'temperatura', 1155.0000, 'ºC'),
	(73094, 108, '2015-03-01 00:23:56.000000', 'temperatura', 571.0000, 'ºC'),
	(73095, 108, '2015-03-01 00:23:57.000000', 'temperatura', 592.0000, 'ºC'),
	(73096, 108, '2015-03-01 00:23:58.000000', 'temperatura', 47.0000, 'ºC'),
	(73097, 108, '2015-03-01 00:23:59.000000', 'temperatura', 859.0000, 'ºC'),
	(73098, 108, '2015-03-01 00:24:00.000000', 'temperatura', 556.0000, 'ºC'),
	(73099, 108, '2015-03-01 00:24:01.000000', 'temperatura', 201.0000, 'ºC'),
	(73100, 108, '2015-03-01 00:24:02.000000', 'temperatura', 538.0000, 'ºC'),
	(73101, 108, '2015-03-01 00:24:03.000000', 'temperatura', 886.0000, 'ºC'),
	(73102, 108, '2015-03-01 00:24:04.000000', 'temperatura', 419.0000, 'ºC'),
	(73103, 108, '2015-03-01 00:24:05.000000', 'temperatura', 638.0000, 'ºC'),
	(73104, 108, '2015-03-01 00:24:06.000000', 'temperatura', 731.0000, 'ºC'),
	(73105, 108, '2015-03-01 00:24:07.000000', 'temperatura', 543.0000, 'ºC'),
	(73106, 108, '2015-03-01 00:24:08.000000', 'temperatura', 523.0000, 'ºC'),
	(73107, 108, '2015-03-01 00:24:09.000000', 'temperatura', 987.0000, 'ºC'),
	(73108, 108, '2015-03-01 00:24:10.000000', 'temperatura', 967.0000, 'ºC'),
	(73109, 108, '2015-03-01 00:24:11.000000', 'temperatura', 675.0000, 'ºC'),
	(73110, 108, '2015-03-01 00:24:12.000000', 'temperatura', 473.0000, 'ºC'),
	(73111, 108, '2015-03-01 00:24:13.000000', 'temperatura', 341.0000, 'ºC'),
	(73112, 108, '2015-03-01 00:24:14.000000', 'temperatura', 287.0000, 'ºC'),
	(73113, 108, '2015-03-01 00:24:15.000000', 'temperatura', 414.0000, 'ºC'),
	(73114, 108, '2015-03-01 00:24:16.000000', 'temperatura', 7.0000, 'ºC'),
	(73115, 108, '2015-03-01 00:24:17.000000', 'temperatura', 1194.0000, 'ºC'),
	(73116, 108, '2015-03-01 00:24:18.000000', 'temperatura', 1149.0000, 'ºC'),
	(73117, 108, '2015-03-01 00:24:19.000000', 'temperatura', 965.0000, 'ºC'),
	(73118, 108, '2015-03-01 00:24:20.000000', 'temperatura', 179.0000, 'ºC'),
	(73119, 108, '2015-03-01 00:24:21.000000', 'temperatura', 402.0000, 'ºC'),
	(73120, 108, '2015-03-01 00:24:22.000000', 'temperatura', 270.0000, 'ºC'),
	(73121, 108, '2015-03-01 00:24:23.000000', 'temperatura', 147.0000, 'ºC'),
	(73122, 108, '2015-03-01 00:24:24.000000', 'temperatura', 1126.0000, 'ºC'),
	(73123, 108, '2015-03-01 00:24:25.000000', 'temperatura', 388.0000, 'ºC'),
	(73124, 108, '2015-03-01 00:24:26.000000', 'temperatura', 963.0000, 'ºC'),
	(73125, 108, '2015-03-01 00:24:27.000000', 'temperatura', 50.0000, 'ºC'),
	(73126, 108, '2015-03-01 00:24:28.000000', 'temperatura', 963.0000, 'ºC'),
	(73127, 108, '2015-03-01 00:24:29.000000', 'temperatura', 1066.0000, 'ºC'),
	(73128, 108, '2015-03-01 00:24:30.000000', 'temperatura', 39.0000, 'ºC'),
	(73129, 108, '2015-03-01 00:24:31.000000', 'temperatura', 600.0000, 'ºC'),
	(73130, 108, '2015-03-01 00:24:32.000000', 'temperatura', 481.0000, 'ºC'),
	(73131, 108, '2015-03-01 00:24:33.000000', 'temperatura', 605.0000, 'ºC'),
	(73132, 108, '2015-03-01 00:24:34.000000', 'temperatura', 384.0000, 'ºC'),
	(73133, 108, '2015-03-01 00:24:35.000000', 'temperatura', 105.0000, 'ºC'),
	(73134, 108, '2015-03-01 00:24:36.000000', 'temperatura', 573.0000, 'ºC'),
	(73135, 108, '2015-03-01 00:24:37.000000', 'temperatura', 151.0000, 'ºC'),
	(73136, 108, '2015-03-01 00:24:38.000000', 'temperatura', 235.0000, 'ºC'),
	(73137, 108, '2015-03-01 00:24:39.000000', 'temperatura', 722.0000, 'ºC'),
	(73138, 108, '2015-03-01 00:24:40.000000', 'temperatura', 506.0000, 'ºC'),
	(73139, 108, '2015-03-01 00:24:41.000000', 'temperatura', 366.0000, 'ºC'),
	(73140, 108, '2015-03-01 00:24:42.000000', 'temperatura', 310.0000, 'ºC'),
	(73141, 108, '2015-03-01 00:24:43.000000', 'temperatura', 452.0000, 'ºC'),
	(73142, 108, '2015-03-01 00:24:44.000000', 'temperatura', 133.0000, 'ºC'),
	(73143, 108, '2015-03-01 00:24:45.000000', 'temperatura', 509.0000, 'ºC'),
	(73144, 108, '2015-03-01 00:24:46.000000', 'temperatura', 948.0000, 'ºC'),
	(73145, 108, '2015-03-01 00:24:47.000000', 'temperatura', 810.0000, 'ºC'),
	(73146, 108, '2015-03-01 00:24:48.000000', 'temperatura', 10.0000, 'ºC'),
	(73147, 108, '2015-03-01 00:24:49.000000', 'temperatura', 20.0000, 'ºC'),
	(73148, 108, '2015-03-01 00:24:50.000000', 'temperatura', 68.0000, 'ºC'),
	(73149, 108, '2015-03-01 00:24:51.000000', 'temperatura', 281.0000, 'ºC'),
	(73150, 108, '2015-03-01 00:24:52.000000', 'temperatura', 2.0000, 'ºC'),
	(73151, 108, '2015-03-01 00:24:53.000000', 'temperatura', 367.0000, 'ºC'),
	(73152, 108, '2015-03-01 00:24:54.000000', 'temperatura', 631.0000, 'ºC'),
	(73153, 108, '2015-03-01 00:24:55.000000', 'temperatura', 853.0000, 'ºC'),
	(73154, 108, '2015-03-01 00:24:56.000000', 'temperatura', 1172.0000, 'ºC'),
	(73155, 108, '2015-03-01 00:24:57.000000', 'temperatura', 902.0000, 'ºC'),
	(73156, 108, '2015-03-01 00:24:58.000000', 'temperatura', 995.0000, 'ºC'),
	(73157, 108, '2015-03-01 00:24:59.000000', 'temperatura', 1071.0000, 'ºC'),
	(73158, 108, '2015-03-01 00:25:00.000000', 'temperatura', 1168.0000, 'ºC'),
	(73159, 108, '2015-03-01 00:25:01.000000', 'temperatura', 229.0000, 'ºC'),
	(73160, 108, '2015-03-01 00:25:02.000000', 'temperatura', 42.0000, 'ºC'),
	(73161, 108, '2015-03-01 00:25:03.000000', 'temperatura', 722.0000, 'ºC'),
	(73162, 108, '2015-03-01 00:25:04.000000', 'temperatura', 1083.0000, 'ºC'),
	(73163, 108, '2015-03-01 00:25:05.000000', 'temperatura', 853.0000, 'ºC'),
	(73164, 108, '2015-03-01 00:25:06.000000', 'temperatura', 1014.0000, 'ºC'),
	(73165, 108, '2015-03-01 00:25:07.000000', 'temperatura', 111.0000, 'ºC'),
	(73166, 108, '2015-03-01 00:25:08.000000', 'temperatura', 1114.0000, 'ºC'),
	(73167, 108, '2015-03-01 00:25:09.000000', 'temperatura', 438.0000, 'ºC'),
	(73168, 108, '2015-03-01 00:25:10.000000', 'temperatura', 49.0000, 'ºC'),
	(73169, 108, '2015-03-01 00:25:11.000000', 'temperatura', 130.0000, 'ºC'),
	(73170, 108, '2015-03-01 00:25:12.000000', 'temperatura', 506.0000, 'ºC'),
	(73171, 108, '2015-03-01 00:25:13.000000', 'temperatura', 938.0000, 'ºC'),
	(73172, 108, '2015-03-01 00:25:14.000000', 'temperatura', 775.0000, 'ºC'),
	(73173, 108, '2015-03-01 00:25:15.000000', 'temperatura', 1062.0000, 'ºC'),
	(73174, 108, '2015-03-01 00:25:16.000000', 'temperatura', 582.0000, 'ºC'),
	(73175, 108, '2015-03-01 00:25:17.000000', 'temperatura', 928.0000, 'ºC'),
	(73176, 108, '2015-03-01 00:25:18.000000', 'temperatura', 492.0000, 'ºC'),
	(73177, 108, '2015-03-01 00:25:19.000000', 'temperatura', 879.0000, 'ºC'),
	(73178, 108, '2015-03-01 00:25:20.000000', 'temperatura', 520.0000, 'ºC'),
	(73179, 108, '2015-03-01 00:25:21.000000', 'temperatura', 1161.0000, 'ºC'),
	(73180, 108, '2015-03-01 00:25:22.000000', 'temperatura', 647.0000, 'ºC'),
	(73181, 108, '2015-03-01 00:25:23.000000', 'temperatura', 951.0000, 'ºC'),
	(73182, 108, '2015-03-01 00:25:24.000000', 'temperatura', 417.0000, 'ºC'),
	(73183, 108, '2015-03-01 00:25:25.000000', 'temperatura', 429.0000, 'ºC'),
	(73184, 108, '2015-03-01 00:25:26.000000', 'temperatura', 898.0000, 'ºC'),
	(73185, 108, '2015-03-01 00:25:27.000000', 'temperatura', 800.0000, 'ºC'),
	(73186, 108, '2015-03-01 00:25:28.000000', 'temperatura', 110.0000, 'ºC'),
	(73187, 108, '2015-03-01 00:25:29.000000', 'temperatura', 549.0000, 'ºC'),
	(73188, 108, '2015-03-01 00:25:30.000000', 'temperatura', 17.0000, 'ºC'),
	(73189, 108, '2015-03-01 00:25:31.000000', 'temperatura', 838.0000, 'ºC'),
	(73190, 108, '2015-03-01 00:25:32.000000', 'temperatura', 539.0000, 'ºC'),
	(73191, 108, '2015-03-01 00:25:33.000000', 'temperatura', 182.0000, 'ºC'),
	(73192, 108, '2015-03-01 00:25:34.000000', 'temperatura', 493.0000, 'ºC'),
	(73193, 108, '2015-03-01 00:25:35.000000', 'temperatura', 718.0000, 'ºC'),
	(73194, 108, '2015-03-01 00:25:36.000000', 'temperatura', 914.0000, 'ºC'),
	(73195, 108, '2015-03-01 00:25:37.000000', 'temperatura', 14.0000, 'ºC'),
	(73196, 108, '2015-03-01 00:25:38.000000', 'temperatura', 930.0000, 'ºC'),
	(73197, 108, '2015-03-01 00:25:39.000000', 'temperatura', 1009.0000, 'ºC'),
	(73198, 108, '2015-03-01 00:25:40.000000', 'temperatura', 1056.0000, 'ºC'),
	(73199, 108, '2015-03-01 00:25:41.000000', 'temperatura', 1052.0000, 'ºC'),
	(73200, 108, '2015-03-01 00:25:42.000000', 'temperatura', 891.0000, 'ºC'),
	(73201, 108, '2015-03-01 00:25:43.000000', 'temperatura', 103.0000, 'ºC'),
	(73202, 108, '2015-03-01 00:25:44.000000', 'temperatura', 240.0000, 'ºC'),
	(73203, 108, '2015-03-01 00:25:45.000000', 'temperatura', 890.0000, 'ºC'),
	(73204, 108, '2015-03-01 00:25:46.000000', 'temperatura', 133.0000, 'ºC'),
	(73205, 108, '2015-03-01 00:25:47.000000', 'temperatura', 394.0000, 'ºC'),
	(73206, 108, '2015-03-01 00:25:48.000000', 'temperatura', 370.0000, 'ºC'),
	(73207, 108, '2015-03-01 00:25:49.000000', 'temperatura', 672.0000, 'ºC'),
	(73208, 108, '2015-03-01 00:25:50.000000', 'temperatura', 1047.0000, 'ºC'),
	(73209, 108, '2015-03-01 00:25:51.000000', 'temperatura', 823.0000, 'ºC'),
	(73210, 108, '2015-03-01 00:25:52.000000', 'temperatura', 973.0000, 'ºC'),
	(73211, 108, '2015-03-01 00:25:53.000000', 'temperatura', 1197.0000, 'ºC'),
	(73212, 108, '2015-03-01 00:25:54.000000', 'temperatura', 666.0000, 'ºC'),
	(73213, 108, '2015-03-01 00:25:55.000000', 'temperatura', 941.0000, 'ºC'),
	(73214, 108, '2015-03-01 00:25:56.000000', 'temperatura', 307.0000, 'ºC'),
	(73215, 108, '2015-03-01 00:25:57.000000', 'temperatura', 1113.0000, 'ºC'),
	(73216, 108, '2015-03-01 00:25:58.000000', 'temperatura', 1045.0000, 'ºC'),
	(73217, 108, '2015-03-01 00:25:59.000000', 'temperatura', 687.0000, 'ºC'),
	(73218, 108, '2015-03-01 00:26:00.000000', 'temperatura', 298.0000, 'ºC'),
	(73219, 108, '2015-03-01 00:26:01.000000', 'temperatura', 633.0000, 'ºC'),
	(73220, 108, '2015-03-01 00:26:02.000000', 'temperatura', 1068.0000, 'ºC'),
	(73221, 108, '2015-03-01 00:26:03.000000', 'temperatura', 1043.0000, 'ºC'),
	(73222, 108, '2015-03-01 00:26:04.000000', 'temperatura', 812.0000, 'ºC'),
	(73223, 108, '2015-03-01 00:26:05.000000', 'temperatura', 930.0000, 'ºC'),
	(73224, 108, '2015-03-01 00:26:06.000000', 'temperatura', 1016.0000, 'ºC'),
	(73225, 108, '2015-03-01 00:26:07.000000', 'temperatura', 1091.0000, 'ºC'),
	(73226, 108, '2015-03-01 00:26:08.000000', 'temperatura', 8.0000, 'ºC'),
	(73227, 108, '2015-03-01 00:26:09.000000', 'temperatura', 367.0000, 'ºC'),
	(73228, 108, '2015-03-01 00:26:10.000000', 'temperatura', 610.0000, 'ºC'),
	(73229, 108, '2015-03-01 00:26:11.000000', 'temperatura', 748.0000, 'ºC'),
	(73230, 108, '2015-03-01 00:26:12.000000', 'temperatura', 714.0000, 'ºC'),
	(73231, 108, '2015-03-01 00:26:13.000000', 'temperatura', 123.0000, 'ºC'),
	(73232, 108, '2015-03-01 00:26:14.000000', 'temperatura', 877.0000, 'ºC'),
	(73233, 108, '2015-03-01 00:26:15.000000', 'temperatura', 416.0000, 'ºC'),
	(73234, 108, '2015-03-01 00:26:16.000000', 'temperatura', 648.0000, 'ºC'),
	(73235, 108, '2015-03-01 00:26:17.000000', 'temperatura', 792.0000, 'ºC'),
	(73236, 108, '2015-03-01 00:26:18.000000', 'temperatura', 818.0000, 'ºC'),
	(73237, 108, '2015-03-01 00:26:19.000000', 'temperatura', 515.0000, 'ºC'),
	(73238, 108, '2015-03-01 00:26:20.000000', 'temperatura', 121.0000, 'ºC'),
	(73239, 108, '2015-03-01 00:26:21.000000', 'temperatura', 261.0000, 'ºC'),
	(73240, 108, '2015-03-01 00:26:22.000000', 'temperatura', 942.0000, 'ºC'),
	(73241, 108, '2015-03-01 00:26:23.000000', 'temperatura', 329.0000, 'ºC'),
	(73242, 108, '2015-03-01 00:26:24.000000', 'temperatura', 17.0000, 'ºC'),
	(73243, 108, '2015-03-01 00:26:25.000000', 'temperatura', 299.0000, 'ºC'),
	(73244, 108, '2015-03-01 00:26:26.000000', 'temperatura', 244.0000, 'ºC'),
	(73245, 108, '2015-03-01 00:26:27.000000', 'temperatura', 324.0000, 'ºC'),
	(73246, 108, '2015-03-01 00:26:28.000000', 'temperatura', 890.0000, 'ºC'),
	(73247, 108, '2015-03-01 00:26:29.000000', 'temperatura', 1076.0000, 'ºC'),
	(73248, 108, '2015-03-01 00:26:30.000000', 'temperatura', 314.0000, 'ºC'),
	(73249, 108, '2015-03-01 00:26:31.000000', 'temperatura', 739.0000, 'ºC'),
	(73250, 108, '2015-03-01 00:26:32.000000', 'temperatura', 354.0000, 'ºC'),
	(73251, 108, '2015-03-01 00:26:33.000000', 'temperatura', 753.0000, 'ºC'),
	(73252, 108, '2015-03-01 00:26:34.000000', 'temperatura', 304.0000, 'ºC'),
	(73253, 108, '2015-03-01 00:26:35.000000', 'temperatura', 461.0000, 'ºC'),
	(73254, 108, '2015-03-01 00:26:36.000000', 'temperatura', 194.0000, 'ºC'),
	(73255, 108, '2015-03-01 00:26:37.000000', 'temperatura', 789.0000, 'ºC'),
	(73256, 108, '2015-03-01 00:26:38.000000', 'temperatura', 963.0000, 'ºC'),
	(73257, 108, '2015-03-01 00:26:39.000000', 'temperatura', 47.0000, 'ºC'),
	(73258, 108, '2015-03-01 00:26:40.000000', 'temperatura', 946.0000, 'ºC'),
	(73259, 108, '2015-03-01 00:26:41.000000', 'temperatura', 990.0000, 'ºC'),
	(73260, 108, '2015-03-01 00:26:42.000000', 'temperatura', 915.0000, 'ºC'),
	(73261, 108, '2015-03-01 00:26:43.000000', 'temperatura', 402.0000, 'ºC'),
	(73262, 108, '2015-03-01 00:26:44.000000', 'temperatura', 468.0000, 'ºC'),
	(73263, 108, '2015-03-01 00:26:45.000000', 'temperatura', 1134.0000, 'ºC'),
	(73264, 108, '2015-03-01 00:26:46.000000', 'temperatura', 664.0000, 'ºC'),
	(73265, 108, '2015-03-01 00:26:47.000000', 'temperatura', 1121.0000, 'ºC'),
	(73266, 108, '2015-03-01 00:26:48.000000', 'temperatura', 15.0000, 'ºC'),
	(73267, 108, '2015-03-01 00:26:49.000000', 'temperatura', 309.0000, 'ºC'),
	(73268, 108, '2015-03-01 00:26:50.000000', 'temperatura', 303.0000, 'ºC'),
	(73269, 108, '2015-03-01 00:26:51.000000', 'temperatura', 588.0000, 'ºC'),
	(73270, 108, '2015-03-01 00:26:52.000000', 'temperatura', 831.0000, 'ºC'),
	(73271, 108, '2015-03-01 00:26:53.000000', 'temperatura', 1192.0000, 'ºC'),
	(73272, 108, '2015-03-01 00:26:54.000000', 'temperatura', 1069.0000, 'ºC'),
	(73273, 108, '2015-03-01 00:26:55.000000', 'temperatura', 569.0000, 'ºC'),
	(73274, 108, '2015-03-01 00:26:56.000000', 'temperatura', 839.0000, 'ºC'),
	(73275, 108, '2015-03-01 00:26:57.000000', 'temperatura', 86.0000, 'ºC'),
	(73276, 108, '2015-03-01 00:26:58.000000', 'temperatura', 314.0000, 'ºC'),
	(73277, 108, '2015-03-01 00:26:59.000000', 'temperatura', 113.0000, 'ºC'),
	(73278, 108, '2015-03-01 00:27:00.000000', 'temperatura', 823.0000, 'ºC'),
	(73279, 108, '2015-03-01 00:27:01.000000', 'temperatura', 177.0000, 'ºC'),
	(73280, 108, '2015-03-01 00:27:02.000000', 'temperatura', 819.0000, 'ºC'),
	(73281, 108, '2015-03-01 00:27:03.000000', 'temperatura', 1161.0000, 'ºC'),
	(73282, 108, '2015-03-01 00:27:04.000000', 'temperatura', 949.0000, 'ºC'),
	(73283, 108, '2015-03-01 00:27:05.000000', 'temperatura', 62.0000, 'ºC'),
	(73284, 108, '2015-03-01 00:27:06.000000', 'temperatura', 1064.0000, 'ºC'),
	(73285, 108, '2015-03-01 00:27:07.000000', 'temperatura', 333.0000, 'ºC'),
	(73286, 108, '2015-03-01 00:27:08.000000', 'temperatura', 873.0000, 'ºC'),
	(73287, 108, '2015-03-01 00:27:09.000000', 'temperatura', 966.0000, 'ºC'),
	(73288, 108, '2015-03-01 00:27:10.000000', 'temperatura', 1012.0000, 'ºC'),
	(73289, 108, '2015-03-01 00:27:11.000000', 'temperatura', 963.0000, 'ºC'),
	(73290, 108, '2015-03-01 00:27:12.000000', 'temperatura', 581.0000, 'ºC'),
	(73291, 108, '2015-03-01 00:27:13.000000', 'temperatura', 16.0000, 'ºC'),
	(73292, 108, '2015-03-01 00:27:14.000000', 'temperatura', 735.0000, 'ºC'),
	(73293, 108, '2015-03-01 00:27:15.000000', 'temperatura', 29.0000, 'ºC'),
	(73294, 108, '2015-03-01 00:27:16.000000', 'temperatura', 341.0000, 'ºC'),
	(73295, 108, '2015-03-01 00:27:17.000000', 'temperatura', 417.0000, 'ºC'),
	(73296, 108, '2015-03-01 00:27:18.000000', 'temperatura', 1061.0000, 'ºC'),
	(73297, 108, '2015-03-01 00:27:19.000000', 'temperatura', 457.0000, 'ºC'),
	(73298, 108, '2015-03-01 00:27:20.000000', 'temperatura', 303.0000, 'ºC'),
	(73299, 108, '2015-03-01 00:27:21.000000', 'temperatura', 142.0000, 'ºC'),
	(73300, 108, '2015-03-01 00:27:22.000000', 'temperatura', 1004.0000, 'ºC'),
	(73301, 108, '2015-03-01 00:27:23.000000', 'temperatura', 993.0000, 'ºC'),
	(73302, 108, '2015-03-01 00:27:24.000000', 'temperatura', 754.0000, 'ºC'),
	(73303, 108, '2015-03-01 00:27:25.000000', 'temperatura', 790.0000, 'ºC'),
	(73304, 108, '2015-03-01 00:27:26.000000', 'temperatura', 490.0000, 'ºC'),
	(73305, 108, '2015-03-01 00:27:27.000000', 'temperatura', 80.0000, 'ºC'),
	(73306, 108, '2015-03-01 00:27:28.000000', 'temperatura', 132.0000, 'ºC'),
	(73307, 108, '2015-03-01 00:27:29.000000', 'temperatura', 418.0000, 'ºC'),
	(73308, 108, '2015-03-01 00:27:30.000000', 'temperatura', 497.0000, 'ºC'),
	(73309, 108, '2015-03-01 00:27:31.000000', 'temperatura', 32.0000, 'ºC'),
	(73310, 108, '2015-03-01 00:27:32.000000', 'temperatura', 1071.0000, 'ºC'),
	(73311, 108, '2015-03-01 00:27:33.000000', 'temperatura', 456.0000, 'ºC'),
	(73312, 108, '2015-03-01 00:27:34.000000', 'temperatura', 268.0000, 'ºC'),
	(73313, 108, '2015-03-01 00:27:35.000000', 'temperatura', 1175.0000, 'ºC'),
	(73314, 108, '2015-03-01 00:27:36.000000', 'temperatura', 269.0000, 'ºC'),
	(73315, 108, '2015-03-01 00:27:37.000000', 'temperatura', 223.0000, 'ºC'),
	(73316, 108, '2015-03-01 00:27:38.000000', 'temperatura', 306.0000, 'ºC'),
	(73317, 108, '2015-03-01 00:27:39.000000', 'temperatura', 861.0000, 'ºC'),
	(73318, 108, '2015-03-01 00:27:40.000000', 'temperatura', 991.0000, 'ºC'),
	(73319, 108, '2015-03-01 00:27:41.000000', 'temperatura', 1169.0000, 'ºC'),
	(73320, 108, '2015-03-01 00:27:42.000000', 'temperatura', 472.0000, 'ºC'),
	(73321, 108, '2015-03-01 00:27:43.000000', 'temperatura', 55.0000, 'ºC'),
	(73322, 108, '2015-03-01 00:27:44.000000', 'temperatura', 61.0000, 'ºC'),
	(73323, 108, '2015-03-01 00:27:45.000000', 'temperatura', 139.0000, 'ºC'),
	(73324, 108, '2015-03-01 00:27:46.000000', 'temperatura', 511.0000, 'ºC'),
	(73325, 108, '2015-03-01 00:27:47.000000', 'temperatura', 939.0000, 'ºC'),
	(73326, 108, '2015-03-01 00:27:48.000000', 'temperatura', 763.0000, 'ºC'),
	(73327, 108, '2015-03-01 00:27:49.000000', 'temperatura', 999.0000, 'ºC'),
	(73328, 108, '2015-03-01 00:27:50.000000', 'temperatura', 306.0000, 'ºC'),
	(73329, 108, '2015-03-01 00:27:51.000000', 'temperatura', 935.0000, 'ºC'),
	(73330, 108, '2015-03-01 00:27:52.000000', 'temperatura', 158.0000, 'ºC'),
	(73331, 108, '2015-03-01 00:27:53.000000', 'temperatura', 386.0000, 'ºC'),
	(73332, 108, '2015-03-01 00:27:54.000000', 'temperatura', 256.0000, 'ºC'),
	(73333, 108, '2015-03-01 00:27:55.000000', 'temperatura', 123.0000, 'ºC'),
	(73334, 108, '2015-03-01 00:27:56.000000', 'temperatura', 1045.0000, 'ºC'),
	(73335, 108, '2015-03-01 00:27:57.000000', 'temperatura', 57.0000, 'ºC'),
	(73336, 108, '2015-03-01 00:27:58.000000', 'temperatura', 750.0000, 'ºC'),
	(73337, 108, '2015-03-01 00:27:59.000000', 'temperatura', 1181.0000, 'ºC'),
	(73338, 108, '2015-03-01 00:28:00.000000', 'temperatura', 55.0000, 'ºC'),
	(73339, 108, '2015-03-01 00:28:01.000000', 'temperatura', 334.0000, 'ºC'),
	(73340, 108, '2015-03-01 00:28:02.000000', 'temperatura', 305.0000, 'ºC'),
	(73341, 108, '2015-03-01 00:28:03.000000', 'temperatura', 525.0000, 'ºC'),
	(73342, 108, '2015-03-01 00:28:04.000000', 'temperatura', 509.0000, 'ºC'),
	(73343, 108, '2015-03-01 00:28:05.000000', 'temperatura', 970.0000, 'ºC'),
	(73344, 108, '2015-03-01 00:28:06.000000', 'temperatura', 925.0000, 'ºC'),
	(73345, 108, '2015-03-01 00:28:07.000000', 'temperatura', 514.0000, 'ºC'),
	(73346, 108, '2015-03-01 00:28:08.000000', 'temperatura', 996.0000, 'ºC'),
	(73347, 108, '2015-03-01 00:28:09.000000', 'temperatura', 1041.0000, 'ºC'),
	(73348, 108, '2015-03-01 00:28:10.000000', 'temperatura', 1014.0000, 'ºC'),
	(73349, 108, '2015-03-01 00:28:11.000000', 'temperatura', 750.0000, 'ºC'),
	(73350, 108, '2015-03-01 00:28:12.000000', 'temperatura', 708.0000, 'ºC'),
	(73351, 108, '2015-03-01 00:28:13.000000', 'temperatura', 90.0000, 'ºC'),
	(73352, 108, '2015-03-01 00:28:14.000000', 'temperatura', 729.0000, 'ºC'),
	(73353, 108, '2015-03-01 00:28:15.000000', 'temperatura', 973.0000, 'ºC'),
	(73354, 108, '2015-03-01 00:28:16.000000', 'temperatura', 278.0000, 'ºC'),
	(73355, 108, '2015-03-01 00:28:17.000000', 'temperatura', 874.0000, 'ºC'),
	(73356, 108, '2015-03-01 00:28:18.000000', 'temperatura', 1136.0000, 'ºC'),
	(73357, 108, '2015-03-01 00:28:19.000000', 'temperatura', 656.0000, 'ºC'),
	(73358, 108, '2015-03-01 00:28:20.000000', 'temperatura', 1075.0000, 'ºC'),
	(73359, 108, '2015-03-01 00:28:21.000000', 'temperatura', 1005.0000, 'ºC'),
	(73360, 108, '2015-03-01 00:28:22.000000', 'temperatura', 602.0000, 'ºC'),
	(73361, 108, '2015-03-01 00:28:23.000000', 'temperatura', 1195.0000, 'ºC'),
	(73362, 108, '2015-03-01 00:28:24.000000', 'temperatura', 570.0000, 'ºC'),
	(73363, 108, '2015-03-01 00:28:25.000000', 'temperatura', 464.0000, 'ºC'),
	(73364, 108, '2015-03-01 00:28:26.000000', 'temperatura', 613.0000, 'ºC'),
	(73365, 108, '2015-03-01 00:28:27.000000', 'temperatura', 474.0000, 'ºC'),
	(73366, 108, '2015-03-01 00:28:28.000000', 'temperatura', 530.0000, 'ºC'),
	(73367, 108, '2015-03-01 00:28:29.000000', 'temperatura', 30.0000, 'ºC'),
	(73368, 108, '2015-03-01 00:28:30.000000', 'temperatura', 961.0000, 'ºC'),
	(73369, 108, '2015-03-01 00:28:31.000000', 'temperatura', 1114.0000, 'ºC'),
	(73370, 108, '2015-03-01 00:28:32.000000', 'temperatura', 290.0000, 'ºC'),
	(73371, 108, '2015-03-01 00:28:33.000000', 'temperatura', 507.0000, 'ºC'),
	(73372, 108, '2015-03-01 00:28:34.000000', 'temperatura', 466.0000, 'ºC'),
	(73373, 108, '2015-03-01 00:28:35.000000', 'temperatura', 808.0000, 'ºC'),
	(73374, 108, '2015-03-01 00:28:36.000000', 'temperatura', 245.0000, 'ºC'),
	(73375, 108, '2015-03-01 00:28:37.000000', 'temperatura', 1199.0000, 'ºC'),
	(73376, 108, '2015-03-01 00:28:38.000000', 'temperatura', 463.0000, 'ºC'),
	(73377, 108, '2015-03-01 00:28:39.000000', 'temperatura', 1118.0000, 'ºC'),
	(73378, 108, '2015-03-01 00:28:40.000000', 'temperatura', 600.0000, 'ºC'),
	(73379, 108, '2015-03-01 00:28:41.000000', 'temperatura', 847.0000, 'ºC'),
	(73380, 108, '2015-03-01 00:28:42.000000', 'temperatura', 37.0000, 'ºC'),
	(73381, 108, '2015-03-01 00:28:43.000000', 'temperatura', 43.0000, 'ºC'),
	(73382, 108, '2015-03-01 00:28:44.000000', 'temperatura', 107.0000, 'ºC'),
	(73383, 108, '2015-03-01 00:28:45.000000', 'temperatura', 405.0000, 'ºC'),
	(73384, 108, '2015-03-01 00:28:46.000000', 'temperatura', 504.0000, 'ºC'),
	(73385, 108, '2015-03-01 00:28:47.000000', 'temperatura', 104.0000, 'ºC'),
	(73386, 108, '2015-03-01 00:28:48.000000', 'temperatura', 211.0000, 'ºC'),
	(73387, 108, '2015-03-01 00:28:49.000000', 'temperatura', 742.0000, 'ºC'),
	(73388, 108, '2015-03-01 00:28:50.000000', 'temperatura', 676.0000, 'ºC'),
	(73389, 108, '2015-03-01 00:28:51.000000', 'temperatura', 1157.0000, 'ºC'),
	(73390, 108, '2015-03-01 00:28:52.000000', 'temperatura', 157.0000, 'ºC'),
	(73391, 108, '2015-03-01 00:28:53.000000', 'temperatura', 913.0000, 'ºC'),
	(73392, 108, '2015-03-01 00:28:54.000000', 'temperatura', 495.0000, 'ºC'),
	(73393, 108, '2015-03-01 00:28:55.000000', 'temperatura', 936.0000, 'ºC'),
	(73394, 108, '2015-03-01 00:28:56.000000', 'temperatura', 795.0000, 'ºC'),
	(73395, 108, '2015-03-01 00:28:57.000000', 'temperatura', 1168.0000, 'ºC'),
	(73396, 108, '2015-03-01 00:28:58.000000', 'temperatura', 1054.0000, 'ºC'),
	(73397, 108, '2015-03-01 00:28:59.000000', 'temperatura', 570.0000, 'ºC'),
	(73398, 108, '2015-03-01 00:29:00.000000', 'temperatura', 885.0000, 'ºC'),
	(73399, 108, '2015-03-01 00:29:01.000000', 'temperatura', 316.0000, 'ºC'),
	(73400, 108, '2015-03-01 00:29:02.000000', 'temperatura', 124.0000, 'ºC'),
	(73401, 108, '2015-03-01 00:29:03.000000', 'temperatura', 875.0000, 'ºC'),
	(73402, 108, '2015-03-01 00:29:04.000000', 'temperatura', 403.0000, 'ºC'),
	(73403, 108, '2015-03-01 00:29:05.000000', 'temperatura', 591.0000, 'ºC'),
	(73404, 108, '2015-03-01 00:29:06.000000', 'temperatura', 545.0000, 'ºC'),
	(73405, 108, '2015-03-01 00:29:07.000000', 'temperatura', 952.0000, 'ºC'),
	(73406, 108, '2015-03-01 00:29:08.000000', 'temperatura', 727.0000, 'ºC'),
	(73407, 108, '2015-03-01 00:29:09.000000', 'temperatura', 779.0000, 'ºC'),
	(73408, 108, '2015-03-01 00:29:10.000000', 'temperatura', 516.0000, 'ºC'),
	(73409, 108, '2015-03-01 00:29:11.000000', 'temperatura', 242.0000, 'ºC'),
	(73410, 108, '2015-03-01 00:29:12.000000', 'temperatura', 864.0000, 'ºC'),
	(73411, 108, '2015-03-01 00:29:13.000000', 'temperatura', 1193.0000, 'ºC'),
	(73412, 108, '2015-03-01 00:29:14.000000', 'temperatura', 972.0000, 'ºC'),
	(73413, 108, '2015-03-01 00:29:15.000000', 'temperatura', 85.0000, 'ºC'),
	(73414, 108, '2015-03-01 00:29:16.000000', 'temperatura', 1106.0000, 'ºC'),
	(73415, 108, '2015-03-01 00:29:17.000000', 'temperatura', 478.0000, 'ºC'),
	(73416, 108, '2015-03-01 00:29:18.000000', 'temperatura', 273.0000, 'ºC'),
	(73417, 108, '2015-03-01 00:29:19.000000', 'temperatura', 1130.0000, 'ºC'),
	(73418, 108, '2015-03-01 00:29:20.000000', 'temperatura', 31.0000, 'ºC'),
	(73419, 108, '2015-03-01 00:29:21.000000', 'temperatura', 366.0000, 'ºC'),
	(73420, 108, '2015-03-01 00:29:22.000000', 'temperatura', 538.0000, 'ºC'),
	(73421, 108, '2015-03-01 00:29:23.000000', 'temperatura', 390.0000, 'ºC'),
	(73422, 108, '2015-03-01 00:29:24.000000', 'temperatura', 340.0000, 'ºC'),
	(73423, 108, '2015-03-01 00:29:25.000000', 'temperatura', 527.0000, 'ºC'),
	(73424, 108, '2015-03-01 00:29:26.000000', 'temperatura', 419.0000, 'ºC'),
	(73425, 108, '2015-03-01 00:29:27.000000', 'temperatura', 513.0000, 'ºC'),
	(73426, 108, '2015-03-01 00:29:28.000000', 'temperatura', 110.0000, 'ºC'),
	(73427, 108, '2015-03-01 00:29:29.000000', 'temperatura', 212.0000, 'ºC'),
	(73428, 108, '2015-03-01 00:29:30.000000', 'temperatura', 729.0000, 'ºC'),
	(73429, 108, '2015-03-01 00:29:31.000000', 'temperatura', 611.0000, 'ºC'),
	(73430, 108, '2015-03-01 00:29:32.000000', 'temperatura', 869.0000, 'ºC'),
	(73431, 108, '2015-03-01 00:29:33.000000', 'temperatura', 114.0000, 'ºC'),
	(73432, 108, '2015-03-01 00:29:34.000000', 'temperatura', 360.0000, 'ºC'),
	(73433, 108, '2015-03-01 00:29:35.000000', 'temperatura', 259.0000, 'ºC'),
	(73434, 108, '2015-03-01 00:29:36.000000', 'temperatura', 215.0000, 'ºC'),
	(73435, 108, '2015-03-01 00:29:37.000000', 'temperatura', 299.0000, 'ºC'),
	(73436, 108, '2015-03-01 00:29:38.000000', 'temperatura', 852.0000, 'ºC'),
	(73437, 108, '2015-03-01 00:29:39.000000', 'temperatura', 962.0000, 'ºC'),
	(73438, 108, '2015-03-01 00:29:40.000000', 'temperatura', 1054.0000, 'ºC'),
	(73439, 108, '2015-03-01 00:29:41.000000', 'temperatura', 1184.0000, 'ºC'),
	(73440, 108, '2015-03-01 00:29:42.000000', 'temperatura', 360.0000, 'ºC'),
	(73441, 108, '2015-03-01 00:29:43.000000', 'temperatura', 649.0000, 'ºC'),
	(73442, 108, '2015-03-01 00:29:44.000000', 'temperatura', 964.0000, 'ºC'),
	(73443, 108, '2015-03-01 00:29:45.000000', 'temperatura', 476.0000, 'ºC'),
	(73444, 108, '2015-03-01 00:29:46.000000', 'temperatura', 686.0000, 'ºC'),
	(73445, 108, '2015-03-01 00:29:47.000000', 'temperatura', 805.0000, 'ºC'),
	(73446, 108, '2015-03-01 00:29:48.000000', 'temperatura', 765.0000, 'ºC'),
	(73447, 108, '2015-03-01 00:29:49.000000', 'temperatura', 210.0000, 'ºC'),
	(73448, 108, '2015-03-01 00:29:50.000000', 'temperatura', 1157.0000, 'ºC'),
	(73449, 108, '2015-03-01 00:29:51.000000', 'temperatura', 353.0000, 'ºC'),
	(73450, 108, '2015-03-01 00:29:52.000000', 'temperatura', 696.0000, 'ºC'),
	(73451, 108, '2015-03-01 00:29:53.000000', 'temperatura', 23.0000, 'ºC'),
	(73452, 108, '2015-03-01 00:29:54.000000', 'temperatura', 425.0000, 'ºC'),
	(73453, 108, '2015-03-01 00:29:55.000000', 'temperatura', 857.0000, 'ºC'),
	(73454, 108, '2015-03-01 00:29:56.000000', 'temperatura', 612.0000, 'ºC'),
	(73455, 108, '2015-03-01 00:29:57.000000', 'temperatura', 490.0000, 'ºC'),
	(73456, 108, '2015-03-01 00:29:58.000000', 'temperatura', 615.0000, 'ºC'),
	(73457, 108, '2015-03-01 00:29:59.000000', 'temperatura', 404.0000, 'ºC'),
	(73458, 108, '2015-03-01 00:30:00.000000', 'temperatura', 175.0000, 'ºC'),
	(73459, 108, '2015-03-01 00:30:01.000000', 'temperatura', 865.0000, 'ºC'),
	(73460, 108, '2015-03-01 00:30:02.000000', 'temperatura', 200.0000, 'ºC'),
	(73461, 108, '2015-03-01 00:30:03.000000', 'temperatura', 805.0000, 'ºC'),
	(73462, 108, '2015-03-01 00:30:04.000000', 'temperatura', 1027.0000, 'ºC'),
	(73463, 108, '2015-03-01 00:30:05.000000', 'temperatura', 320.0000, 'ºC'),
	(73464, 108, '2015-03-01 00:30:06.000000', 'temperatura', 919.0000, 'ºC'),
	(73465, 108, '2015-03-01 00:30:07.000000', 'temperatura', 37.0000, 'ºC'),
	(73466, 108, '2015-03-01 00:30:08.000000', 'temperatura', 1030.0000, 'ºC'),
	(73467, 108, '2015-03-01 00:30:09.000000', 'temperatura', 236.0000, 'ºC'),
	(73468, 108, '2015-03-01 00:30:10.000000', 'temperatura', 494.0000, 'ºC'),
	(73469, 108, '2015-03-01 00:30:11.000000', 'temperatura', 560.0000, 'ºC'),
	(73470, 108, '2015-03-01 00:30:12.000000', 'temperatura', 120.0000, 'ºC'),
	(73471, 108, '2015-03-01 00:30:13.000000', 'temperatura', 122.0000, 'ºC'),
	(73472, 108, '2015-03-01 00:30:14.000000', 'temperatura', 247.0000, 'ºC'),
	(73473, 108, '2015-03-01 00:30:15.000000', 'temperatura', 872.0000, 'ºC'),
	(73474, 108, '2015-03-01 00:30:16.000000', 'temperatura', 18.0000, 'ºC'),
	(73475, 108, '2015-03-01 00:30:17.000000', 'temperatura', 1075.0000, 'ºC'),
	(73476, 108, '2015-03-01 00:30:18.000000', 'temperatura', 519.0000, 'ºC'),
	(73477, 108, '2015-03-01 00:30:19.000000', 'temperatura', 574.0000, 'ºC'),
	(73478, 108, '2015-03-01 00:30:20.000000', 'temperatura', 112.0000, 'ºC'),
	(73479, 108, '2015-03-01 00:30:21.000000', 'temperatura', 38.0000, 'ºC'),
	(73480, 108, '2015-03-01 00:30:22.000000', 'temperatura', 1056.0000, 'ºC'),
	(73481, 108, '2015-03-01 00:30:23.000000', 'temperatura', 365.0000, 'ºC'),
	(73482, 108, '2015-03-01 00:30:24.000000', 'temperatura', 1058.0000, 'ºC'),
	(73483, 108, '2015-03-01 00:30:25.000000', 'temperatura', 596.0000, 'ºC'),
	(73484, 108, '2015-03-01 00:30:26.000000', 'temperatura', 1008.0000, 'ºC'),
	(73485, 108, '2015-03-01 00:30:27.000000', 'temperatura', 852.0000, 'ºC'),
	(73486, 108, '2015-03-01 00:30:28.000000', 'temperatura', 36.0000, 'ºC'),
	(73487, 108, '2015-03-01 00:30:29.000000', 'temperatura', 22.0000, 'ºC'),
	(73488, 108, '2015-03-01 00:30:30.000000', 'temperatura', 6.0000, 'ºC'),
	(73489, 108, '2015-03-01 00:30:31.000000', 'temperatura', 1165.0000, 'ºC'),
	(73490, 108, '2015-03-01 00:30:32.000000', 'temperatura', 1005.0000, 'ºC'),
	(73491, 108, '2015-03-01 00:30:33.000000', 'temperatura', 331.0000, 'ºC'),
	(73492, 108, '2015-03-01 00:30:34.000000', 'temperatura', 1039.0000, 'ºC'),
	(73493, 108, '2015-03-01 00:30:35.000000', 'temperatura', 605.0000, 'ºC'),
	(73494, 108, '2015-03-01 00:30:36.000000', 'temperatura', 1106.0000, 'ºC'),
	(73495, 108, '2015-03-01 00:30:37.000000', 'temperatura', 118.0000, 'ºC'),
	(73496, 108, '2015-03-01 00:30:38.000000', 'temperatura', 871.0000, 'ºC'),
	(73497, 108, '2015-03-01 00:30:39.000000', 'temperatura', 402.0000, 'ºC'),
	(73498, 108, '2015-03-01 00:30:40.000000', 'temperatura', 597.0000, 'ºC'),
	(73499, 108, '2015-03-01 00:30:41.000000', 'temperatura', 578.0000, 'ºC'),
	(73500, 108, '2015-03-01 00:30:42.000000', 'temperatura', 1101.0000, 'ºC'),
	(73501, 108, '2015-03-01 00:30:43.000000', 'temperatura', 171.0000, 'ºC'),
	(73502, 108, '2015-03-01 00:30:44.000000', 'temperatura', 1151.0000, 'ºC'),
	(73503, 108, '2015-03-01 00:30:45.000000', 'temperatura', 444.0000, 'ºC'),
	(73504, 108, '2015-03-01 00:30:46.000000', 'temperatura', 1169.0000, 'ºC'),
	(73505, 108, '2015-03-01 00:30:47.000000', 'temperatura', 912.0000, 'ºC'),
	(73506, 108, '2015-03-01 00:30:48.000000', 'temperatura', 1053.0000, 'ºC'),
	(73507, 108, '2015-03-01 00:30:49.000000', 'temperatura', 130.0000, 'ºC'),
	(73508, 108, '2015-03-01 00:30:50.000000', 'temperatura', 1093.0000, 'ºC'),
	(73509, 108, '2015-03-01 00:30:51.000000', 'temperatura', 275.0000, 'ºC'),
	(73510, 108, '2015-03-01 00:30:52.000000', 'temperatura', 495.0000, 'ºC'),
	(73511, 108, '2015-03-01 00:30:53.000000', 'temperatura', 451.0000, 'ºC'),
	(73512, 108, '2015-03-01 00:30:54.000000', 'temperatura', 773.0000, 'ºC'),
	(73513, 108, '2015-03-01 00:30:55.000000', 'temperatura', 109.0000, 'ºC'),
	(73514, 108, '2015-03-01 00:30:56.000000', 'temperatura', 629.0000, 'ºC'),
	(73515, 108, '2015-03-01 00:30:57.000000', 'temperatura', 418.0000, 'ºC'),
	(73516, 108, '2015-03-01 00:30:58.000000', 'temperatura', 205.0000, 'ºC'),
	(73517, 108, '2015-03-01 00:30:59.000000', 'temperatura', 972.0000, 'ºC'),
	(73518, 108, '2015-03-01 00:31:00.000000', 'temperatura', 643.0000, 'ºC'),
	(73519, 108, '2015-03-01 00:31:01.000000', 'temperatura', 300.0000, 'ºC'),
	(73520, 108, '2015-03-01 00:31:02.000000', 'temperatura', 770.0000, 'ºC'),
	(73521, 108, '2015-03-01 00:31:03.000000', 'temperatura', 553.0000, 'ºC'),
	(73522, 108, '2015-03-01 00:31:04.000000', 'temperatura', 454.0000, 'ºC'),
	(73523, 108, '2015-03-01 00:31:05.000000', 'temperatura', 613.0000, 'ºC'),
	(73524, 108, '2015-03-01 00:31:06.000000', 'temperatura', 504.0000, 'ºC'),
	(73525, 108, '2015-03-01 00:31:07.000000', 'temperatura', 681.0000, 'ºC'),
	(73526, 108, '2015-03-01 00:31:08.000000', 'temperatura', 693.0000, 'ºC'),
	(73527, 108, '2015-03-01 00:31:09.000000', 'temperatura', 222.0000, 'ºC'),
	(73528, 108, '2015-03-01 00:31:10.000000', 'temperatura', 234.0000, 'ºC'),
	(73529, 108, '2015-03-01 00:31:11.000000', 'temperatura', 502.0000, 'ºC'),
	(73530, 108, '2015-03-01 00:31:12.000000', 'temperatura', 610.0000, 'ºC'),
	(73531, 108, '2015-03-01 00:31:13.000000', 'temperatura', 342.0000, 'ºC'),
	(73532, 108, '2015-03-01 00:31:14.000000', 'temperatura', 1082.0000, 'ºC'),
	(73533, 108, '2015-03-01 00:31:15.000000', 'temperatura', 784.0000, 'ºC'),
	(73534, 108, '2015-03-01 00:31:16.000000', 'temperatura', 675.0000, 'ºC'),
	(73535, 108, '2015-03-01 00:31:17.000000', 'temperatura', 1024.0000, 'ºC'),
	(73536, 108, '2015-03-01 00:31:18.000000', 'temperatura', 697.0000, 'ºC'),
	(73537, 108, '2015-03-01 00:31:19.000000', 'temperatura', 411.0000, 'ºC'),
	(73538, 108, '2015-03-01 00:31:20.000000', 'temperatura', 1163.0000, 'ºC'),
	(73539, 108, '2015-03-01 00:31:21.000000', 'temperatura', 985.0000, 'ºC'),
	(73540, 108, '2015-03-01 00:31:22.000000', 'temperatura', 237.0000, 'ºC'),
	(73541, 108, '2015-03-01 00:31:23.000000', 'temperatura', 628.0000, 'ºC'),
	(73542, 108, '2015-03-01 00:31:24.000000', 'temperatura', 31.0000, 'ºC'),
	(73543, 108, '2015-03-01 00:31:25.000000', 'temperatura', 672.0000, 'ºC'),
	(73544, 108, '2015-03-01 00:31:26.000000', 'temperatura', 867.0000, 'ºC'),
	(73545, 108, '2015-03-01 00:31:27.000000', 'temperatura', 1118.0000, 'ºC'),
	(73546, 108, '2015-03-01 00:31:28.000000', 'temperatura', 589.0000, 'ºC'),
	(73547, 108, '2015-03-01 00:31:29.000000', 'temperatura', 792.0000, 'ºC'),
	(73548, 108, '2015-03-01 00:31:30.000000', 'temperatura', 995.0000, 'ºC'),
	(73549, 108, '2015-03-01 00:31:31.000000', 'temperatura', 198.0000, 'ºC'),
	(73550, 108, '2015-03-01 00:31:32.000000', 'temperatura', 405.0000, 'ºC'),
	(73551, 108, '2015-03-01 00:31:33.000000', 'temperatura', 234.0000, 'ºC'),
	(73552, 108, '2015-03-01 00:31:34.000000', 'temperatura', 1153.0000, 'ºC'),
	(73553, 108, '2015-03-01 00:31:35.000000', 'temperatura', 263.0000, 'ºC'),
	(73554, 108, '2015-03-01 00:31:36.000000', 'temperatura', 259.0000, 'ºC'),
	(73555, 108, '2015-03-01 00:31:37.000000', 'temperatura', 505.0000, 'ºC'),
	(73556, 108, '2015-03-01 00:31:38.000000', 'temperatura', 547.0000, 'ºC'),
	(73557, 108, '2015-03-01 00:31:39.000000', 'temperatura', 24.0000, 'ºC'),
	(73558, 108, '2015-03-01 00:31:40.000000', 'temperatura', 877.0000, 'ºC'),
	(73559, 108, '2015-03-01 00:31:41.000000', 'temperatura', 713.0000, 'ºC'),
	(73560, 108, '2015-03-01 00:31:42.000000', 'temperatura', 937.0000, 'ºC'),
	(73561, 108, '2015-03-01 00:31:43.000000', 'temperatura', 146.0000, 'ºC'),
	(73562, 108, '2015-03-01 00:31:44.000000', 'temperatura', 321.0000, 'ºC'),
	(73563, 108, '2015-03-01 00:31:45.000000', 'temperatura', 1166.0000, 'ºC'),
	(73564, 108, '2015-03-01 00:31:46.000000', 'temperatura', 69.0000, 'ºC'),
	(73565, 108, '2015-03-01 00:31:47.000000', 'temperatura', 448.0000, 'ºC'),
	(73566, 108, '2015-03-01 00:31:48.000000', 'temperatura', 830.0000, 'ºC'),
	(73567, 108, '2015-03-01 00:31:49.000000', 'temperatura', 410.0000, 'ºC'),
	(73568, 108, '2015-03-01 00:31:50.000000', 'temperatura', 758.0000, 'ºC'),
	(73569, 108, '2015-03-01 00:31:51.000000', 'temperatura', 163.0000, 'ºC'),
	(73570, 108, '2015-03-01 00:31:52.000000', 'temperatura', 940.0000, 'ºC'),
	(73571, 108, '2015-03-01 00:31:53.000000', 'temperatura', 611.0000, 'ºC'),
	(73572, 108, '2015-03-01 00:31:54.000000', 'temperatura', 235.0000, 'ºC'),
	(73573, 108, '2015-03-01 00:31:55.000000', 'temperatura', 544.0000, 'ºC'),
	(73574, 108, '2015-03-01 00:31:56.000000', 'temperatura', 814.0000, 'ºC'),
	(73575, 108, '2015-03-01 00:31:57.000000', 'temperatura', 38.0000, 'ºC'),
	(73576, 108, '2015-03-01 00:31:58.000000', 'temperatura', 149.0000, 'ºC'),
	(73577, 108, '2015-03-01 00:31:59.000000', 'temperatura', 633.0000, 'ºC'),
	(73578, 108, '2015-03-01 00:32:00.000000', 'temperatura', 319.0000, 'ºC'),
	(73579, 108, '2015-03-01 00:32:01.000000', 'temperatura', 896.0000, 'ºC'),
	(73580, 108, '2015-03-01 00:32:02.000000', 'temperatura', 1122.0000, 'ºC'),
	(73581, 108, '2015-03-01 00:32:03.000000', 'temperatura', 524.0000, 'ºC'),
	(73582, 108, '2015-03-01 00:32:04.000000', 'temperatura', 453.0000, 'ºC'),
	(73583, 108, '2015-03-01 00:32:05.000000', 'temperatura', 694.0000, 'ºC'),
	(73584, 108, '2015-03-01 00:32:06.000000', 'temperatura', 913.0000, 'ºC'),
	(73585, 108, '2015-03-01 00:32:07.000000', 'temperatura', 85.0000, 'ºC'),
	(73586, 108, '2015-03-01 00:32:08.000000', 'temperatura', 83.0000, 'ºC'),
	(73587, 108, '2015-03-01 00:32:09.000000', 'temperatura', 162.0000, 'ºC'),
	(73588, 108, '2015-03-01 00:32:10.000000', 'temperatura', 562.0000, 'ºC'),
	(73589, 108, '2015-03-01 00:32:11.000000', 'temperatura', 1124.0000, 'ºC'),
	(73590, 108, '2015-03-01 00:32:12.000000', 'temperatura', 335.0000, 'ºC'),
	(73591, 108, '2015-03-01 00:32:13.000000', 'temperatura', 703.0000, 'ºC'),
	(73592, 108, '2015-03-01 00:32:14.000000', 'temperatura', 112.0000, 'ºC'),
	(73593, 108, '2015-03-01 00:32:15.000000', 'temperatura', 849.0000, 'ºC'),
	(73594, 108, '2015-03-01 00:32:16.000000', 'temperatura', 310.0000, 'ºC'),
	(73595, 108, '2015-03-01 00:32:17.000000', 'temperatura', 202.0000, 'ºC'),
	(73596, 108, '2015-03-01 00:32:18.000000', 'temperatura', 82.0000, 'ºC'),
	(73597, 108, '2015-03-01 00:32:19.000000', 'temperatura', 1003.0000, 'ºC'),
	(73598, 108, '2015-03-01 00:32:20.000000', 'temperatura', 1170.0000, 'ºC'),
	(73599, 108, '2015-03-01 00:32:21.000000', 'temperatura', 441.0000, 'ºC'),
	(73600, 108, '2015-03-01 00:32:22.000000', 'temperatura', 1097.0000, 'ºC'),
	(73601, 108, '2015-03-01 00:32:23.000000', 'temperatura', 561.0000, 'ºC'),
	(73602, 108, '2015-03-01 00:32:24.000000', 'temperatura', 714.0000, 'ºC'),
	(73603, 108, '2015-03-01 00:32:25.000000', 'temperatura', 689.0000, 'ºC'),
	(73604, 108, '2015-03-01 00:32:26.000000', 'temperatura', 103.0000, 'ºC'),
	(73605, 108, '2015-03-01 00:32:27.000000', 'temperatura', 846.0000, 'ºC'),
	(73606, 108, '2015-03-01 00:32:28.000000', 'temperatura', 325.0000, 'ºC'),
	(73607, 108, '2015-03-01 00:32:29.000000', 'temperatura', 285.0000, 'ºC'),
	(73608, 108, '2015-03-01 00:32:30.000000', 'temperatura', 452.0000, 'ºC'),
	(73609, 108, '2015-03-01 00:32:31.000000', 'temperatura', 206.0000, 'ºC'),
	(73610, 108, '2015-03-01 00:32:32.000000', 'temperatura', 872.0000, 'ºC'),
	(73611, 108, '2015-03-01 00:32:33.000000', 'temperatura', 143.0000, 'ºC'),
	(73612, 108, '2015-03-01 00:32:34.000000', 'temperatura', 499.0000, 'ºC'),
	(73613, 108, '2015-03-01 00:32:35.000000', 'temperatura', 869.0000, 'ºC'),
	(73614, 108, '2015-03-01 00:32:36.000000', 'temperatura', 447.0000, 'ºC'),
	(73615, 108, '2015-03-01 00:32:37.000000', 'temperatura', 828.0000, 'ºC'),
	(73616, 108, '2015-03-01 00:32:38.000000', 'temperatura', 399.0000, 'ºC'),
	(73617, 108, '2015-03-01 00:32:39.000000', 'temperatura', 712.0000, 'ºC'),
	(73618, 108, '2015-03-01 00:32:40.000000', 'temperatura', 1166.0000, 'ºC'),
	(73619, 108, '2015-03-01 00:32:41.000000', 'temperatura', 92.0000, 'ºC'),
	(73620, 108, '2015-03-01 00:32:42.000000', 'temperatura', 561.0000, 'ºC'),
	(73621, 108, '2015-03-01 00:32:43.000000', 'temperatura', 133.0000, 'ºC'),
	(73622, 108, '2015-03-01 00:32:44.000000', 'temperatura', 180.0000, 'ºC'),
	(73623, 108, '2015-03-01 00:32:45.000000', 'temperatura', 504.0000, 'ºC'),
	(73624, 108, '2015-03-01 00:32:46.000000', 'temperatura', 778.0000, 'ºC'),
	(73625, 108, '2015-03-01 00:32:47.000000', 'temperatura', 1180.0000, 'ºC'),
	(73626, 108, '2015-03-01 00:32:48.000000', 'temperatura', 1164.0000, 'ºC'),
	(73627, 108, '2015-03-01 00:32:49.000000', 'temperatura', 1083.0000, 'ºC'),
	(73628, 108, '2015-03-01 00:32:50.000000', 'temperatura', 721.0000, 'ºC'),
	(73629, 108, '2015-03-01 00:32:51.000000', 'temperatura', 357.0000, 'ºC'),
	(73630, 108, '2015-03-01 00:32:52.000000', 'temperatura', 821.0000, 'ºC'),
	(73631, 108, '2015-03-01 00:32:53.000000', 'temperatura', 637.0000, 'ºC'),
	(73632, 108, '2015-03-01 00:32:54.000000', 'temperatura', 722.0000, 'ºC'),
	(73633, 108, '2015-03-01 00:32:55.000000', 'temperatura', 500.0000, 'ºC'),
	(73634, 108, '2015-03-01 00:32:56.000000', 'temperatura', 336.0000, 'ºC'),
	(73635, 108, '2015-03-01 00:32:57.000000', 'temperatura', 180.0000, 'ºC'),
	(73636, 108, '2015-03-01 00:32:58.000000', 'temperatura', 1090.0000, 'ºC'),
	(73637, 108, '2015-03-01 00:32:59.000000', 'temperatura', 112.0000, 'ºC'),
	(73638, 108, '2015-03-01 00:33:00.000000', 'temperatura', 890.0000, 'ºC'),
	(73639, 108, '2015-03-01 00:33:01.000000', 'temperatura', 516.0000, 'ºC'),
	(73640, 108, '2015-03-01 00:33:02.000000', 'temperatura', 1111.0000, 'ºC'),
	(73641, 108, '2015-03-01 00:33:03.000000', 'temperatura', 406.0000, 'ºC'),
	(73642, 108, '2015-03-01 00:33:04.000000', 'temperatura', 1096.0000, 'ºC'),
	(73643, 108, '2015-03-01 00:33:05.000000', 'temperatura', 664.0000, 'ºC'),
	(73644, 108, '2015-03-01 00:33:06.000000', 'temperatura', 31.0000, 'ºC'),
	(73645, 108, '2015-03-01 00:33:07.000000', 'temperatura', 565.0000, 'ºC'),
	(73646, 108, '2015-03-01 00:33:08.000000', 'temperatura', 333.0000, 'ºC'),
	(73647, 108, '2015-03-01 00:33:09.000000', 'temperatura', 1171.0000, 'ºC'),
	(73648, 108, '2015-03-01 00:33:10.000000', 'temperatura', 54.0000, 'ºC'),
	(73649, 108, '2015-03-01 00:33:11.000000', 'temperatura', 360.0000, 'ºC'),
	(73650, 108, '2015-03-01 00:33:12.000000', 'temperatura', 438.0000, 'ºC'),
	(73651, 108, '2015-03-01 00:33:13.000000', 'temperatura', 1111.0000, 'ºC'),
	(73652, 108, '2015-03-01 00:33:14.000000', 'temperatura', 640.0000, 'ºC'),
	(73653, 108, '2015-03-01 00:33:15.000000', 'temperatura', 1067.0000, 'ºC'),
	(73654, 108, '2015-03-01 00:33:16.000000', 'temperatura', 1018.0000, 'ºC'),
	(73655, 108, '2015-03-01 00:33:17.000000', 'temperatura', 690.0000, 'ºC'),
	(73656, 108, '2015-03-01 00:33:18.000000', 'temperatura', 394.0000, 'ºC'),
	(73657, 108, '2015-03-01 00:33:19.000000', 'temperatura', 1102.0000, 'ºC'),
	(73658, 108, '2015-03-01 00:33:20.000000', 'temperatura', 727.0000, 'ºC'),
	(73659, 108, '2015-03-01 00:33:21.000000', 'temperatura', 331.0000, 'ºC'),
	(73660, 108, '2015-03-01 00:33:22.000000', 'temperatura', 673.0000, 'ºC'),
	(73661, 108, '2015-03-01 00:33:23.000000', 'temperatura', 1175.0000, 'ºC'),
	(73662, 108, '2015-03-01 00:33:24.000000', 'temperatura', 256.0000, 'ºC'),
	(73663, 108, '2015-03-01 00:33:25.000000', 'temperatura', 154.0000, 'ºC'),
	(73664, 108, '2015-03-01 00:33:26.000000', 'temperatura', 2.0000, 'ºC'),
	(73665, 108, '2015-03-01 00:33:27.000000', 'temperatura', 749.0000, 'ºC'),
	(73666, 108, '2015-03-01 00:33:28.000000', 'temperatura', 139.0000, 'ºC'),
	(73667, 108, '2015-03-01 00:33:29.000000', 'temperatura', 849.0000, 'ºC'),
	(73668, 108, '2015-03-01 00:33:30.000000', 'temperatura', 228.0000, 'ºC'),
	(73669, 108, '2015-03-01 00:33:31.000000', 'temperatura', 993.0000, 'ºC'),
	(73670, 108, '2015-03-01 00:33:32.000000', 'temperatura', 681.0000, 'ºC'),
	(73671, 108, '2015-03-01 00:33:33.000000', 'temperatura', 428.0000, 'ºC'),
	(73672, 108, '2015-03-01 00:33:34.000000', 'temperatura', 95.0000, 'ºC'),
	(73673, 108, '2015-03-01 00:33:35.000000', 'temperatura', 394.0000, 'ºC'),
	(73674, 108, '2015-03-01 00:33:36.000000', 'temperatura', 483.0000, 'ºC'),
	(73675, 108, '2015-03-01 00:33:37.000000', 'temperatura', 35.0000, 'ºC'),
	(73676, 108, '2015-03-01 00:33:38.000000', 'temperatura', 1126.0000, 'ºC'),
	(73677, 108, '2015-03-01 00:33:39.000000', 'temperatura', 725.0000, 'ºC'),
	(73678, 108, '2015-03-01 00:33:40.000000', 'temperatura', 247.0000, 'ºC'),
	(73679, 108, '2015-03-01 00:33:41.000000', 'temperatura', 263.0000, 'ºC'),
	(73680, 108, '2015-03-01 00:33:42.000000', 'temperatura', 573.0000, 'ºC'),
	(73681, 108, '2015-03-01 00:33:43.000000', 'temperatura', 875.0000, 'ºC'),
	(73682, 108, '2015-03-01 00:33:44.000000', 'temperatura', 257.0000, 'ºC'),
	(73683, 108, '2015-03-01 00:33:45.000000', 'temperatura', 1060.0000, 'ºC'),
	(73684, 108, '2015-03-01 00:33:46.000000', 'temperatura', 931.0000, 'ºC'),
	(73685, 108, '2015-03-01 00:33:47.000000', 'temperatura', 276.0000, 'ºC'),
	(73686, 108, '2015-03-01 00:33:48.000000', 'temperatura', 986.0000, 'ºC'),
	(73687, 108, '2015-03-01 00:33:49.000000', 'temperatura', 503.0000, 'ºC'),
	(73688, 108, '2015-03-01 00:33:50.000000', 'temperatura', 758.0000, 'ºC'),
	(73689, 108, '2015-03-01 00:33:51.000000', 'temperatura', 1080.0000, 'ºC'),
	(73690, 108, '2015-03-01 00:33:52.000000', 'temperatura', 726.0000, 'ºC'),
	(73691, 108, '2015-03-01 00:33:53.000000', 'temperatura', 391.0000, 'ºC'),
	(73692, 108, '2015-03-01 00:33:54.000000', 'temperatura', 977.0000, 'ºC'),
	(73693, 108, '2015-03-01 00:33:55.000000', 'temperatura', 114.0000, 'ºC'),
	(73694, 108, '2015-03-01 00:33:56.000000', 'temperatura', 40.0000, 'ºC'),
	(73695, 108, '2015-03-01 00:33:57.000000', 'temperatura', 1057.0000, 'ºC'),
	(73696, 108, '2015-03-01 00:33:58.000000', 'temperatura', 367.0000, 'ºC'),
	(73697, 108, '2015-03-01 00:33:59.000000', 'temperatura', 1062.0000, 'ºC'),
	(73698, 108, '2015-03-01 00:34:00.000000', 'temperatura', 613.0000, 'ºC'),
	(73699, 108, '2015-03-01 00:34:01.000000', 'temperatura', 1077.0000, 'ºC'),
	(73700, 108, '2015-03-01 00:34:02.000000', 'temperatura', 1147.0000, 'ºC'),
	(73701, 108, '2015-03-01 00:34:03.000000', 'temperatura', 104.0000, 'ºC'),
	(73702, 108, '2015-03-01 00:34:04.000000', 'temperatura', 680.0000, 'ºC'),
	(73703, 108, '2015-03-01 00:34:05.000000', 'temperatura', 689.0000, 'ºC'),
	(73704, 108, '2015-03-01 00:34:06.000000', 'temperatura', 204.0000, 'ºC'),
	(73705, 108, '2015-03-01 00:34:07.000000', 'temperatura', 155.0000, 'ºC'),
	(73706, 108, '2015-03-01 00:34:08.000000', 'temperatura', 161.0000, 'ºC'),
	(73707, 108, '2015-03-01 00:34:09.000000', 'temperatura', 344.0000, 'ºC'),
	(73708, 108, '2015-03-01 00:34:10.000000', 'temperatura', 35.0000, 'ºC'),
	(73709, 108, '2015-03-01 00:34:11.000000', 'temperatura', 346.0000, 'ºC'),
	(73710, 108, '2015-03-01 00:34:12.000000', 'temperatura', 424.0000, 'ºC'),
	(73711, 108, '2015-03-01 00:34:13.000000', 'temperatura', 1081.0000, 'ºC'),
	(73712, 108, '2015-03-01 00:34:14.000000', 'temperatura', 533.0000, 'ºC'),
	(73713, 108, '2015-03-01 00:34:15.000000', 'temperatura', 623.0000, 'ºC'),
	(73714, 108, '2015-03-01 00:34:16.000000', 'temperatura', 319.0000, 'ºC'),
	(73715, 108, '2015-03-01 00:34:17.000000', 'temperatura', 924.0000, 'ºC'),
	(73716, 108, '2015-03-01 00:34:18.000000', 'temperatura', 66.0000, 'ºC'),
	(73717, 108, '2015-03-01 00:34:19.000000', 'temperatura', 1158.0000, 'ºC'),
	(73718, 108, '2015-03-01 00:34:20.000000', 'temperatura', 794.0000, 'ºC'),
	(73719, 108, '2015-03-01 00:34:21.000000', 'temperatura', 495.0000, 'ºC'),
	(73720, 108, '2015-03-01 00:34:22.000000', 'temperatura', 92.0000, 'ºC'),
	(73721, 108, '2015-03-01 00:34:23.000000', 'temperatura', 176.0000, 'ºC'),
	(73722, 108, '2015-03-01 00:34:24.000000', 'temperatura', 604.0000, 'ºC'),
	(73723, 108, '2015-03-01 00:34:25.000000', 'temperatura', 93.0000, 'ºC'),
	(73724, 108, '2015-03-01 00:34:26.000000', 'temperatura', 1053.0000, 'ºC'),
	(73725, 108, '2015-03-01 00:34:27.000000', 'temperatura', 186.0000, 'ºC'),
	(73726, 108, '2015-03-01 00:34:28.000000', 'temperatura', 173.0000, 'ºC'),
	(73727, 108, '2015-03-01 00:34:29.000000', 'temperatura', 305.0000, 'ºC'),
	(73728, 108, '2015-03-01 00:34:30.000000', 'temperatura', 1010.0000, 'ºC'),
	(73729, 108, '2015-03-01 00:34:31.000000', 'temperatura', 532.0000, 'ºC'),
	(73730, 108, '2015-03-01 00:34:32.000000', 'temperatura', 832.0000, 'ºC'),
	(73731, 108, '2015-03-01 00:34:33.000000', 'temperatura', 164.0000, 'ºC'),
	(73732, 108, '2015-03-01 00:34:34.000000', 'temperatura', 726.0000, 'ºC'),
	(73733, 108, '2015-03-01 00:34:35.000000', 'temperatura', 740.0000, 'ºC'),
	(73734, 108, '2015-03-01 00:34:36.000000', 'temperatura', 320.0000, 'ºC'),
	(73735, 108, '2015-03-01 00:34:37.000000', 'temperatura', 581.0000, 'ºC'),
	(73736, 108, '2015-03-01 00:34:38.000000', 'temperatura', 745.0000, 'ºC'),
	(73737, 108, '2015-03-01 00:34:39.000000', 'temperatura', 784.0000, 'ºC'),
	(73738, 108, '2015-03-01 00:34:40.000000', 'temperatura', 483.0000, 'ºC'),
	(73739, 108, '2015-03-01 00:34:41.000000', 'temperatura', 66.0000, 'ºC'),
	(73740, 108, '2015-03-01 00:34:42.000000', 'temperatura', 80.0000, 'ºC'),
	(73741, 108, '2015-03-01 00:34:43.000000', 'temperatura', 202.0000, 'ºC'),
	(73742, 108, '2015-03-01 00:34:44.000000', 'temperatura', 772.0000, 'ºC'),
	(73743, 108, '2015-03-01 00:34:45.000000', 'temperatura', 853.0000, 'ºC'),
	(73744, 108, '2015-03-01 00:34:46.000000', 'temperatura', 749.0000, 'ºC'),
	(73745, 108, '2015-03-01 00:34:47.000000', 'temperatura', 1186.0000, 'ºC'),
	(73746, 108, '2015-03-01 00:34:48.000000', 'temperatura', 84.0000, 'ºC'),
	(73747, 108, '2015-03-01 00:34:49.000000', 'temperatura', 464.0000, 'ºC'),
	(73748, 108, '2015-03-01 00:34:50.000000', 'temperatura', 869.0000, 'ºC'),
	(73749, 108, '2015-03-01 00:34:51.000000', 'temperatura', 553.0000, 'ºC'),
	(73750, 108, '2015-03-01 00:34:52.000000', 'temperatura', 159.0000, 'ºC'),
	(73751, 108, '2015-03-01 00:34:53.000000', 'temperatura', 335.0000, 'ºC'),
	(73752, 108, '2015-03-01 00:34:54.000000', 'temperatura', 0.0000, 'ºC'),
	(73753, 108, '2015-03-01 00:34:55.000000', 'temperatura', 194.0000, 'ºC'),
	(73754, 108, '2015-03-01 00:34:56.000000', 'temperatura', 973.0000, 'ºC'),
	(73755, 108, '2015-03-01 00:34:57.000000', 'temperatura', 681.0000, 'ºC'),
	(73756, 108, '2015-03-01 00:34:58.000000', 'temperatura', 486.0000, 'ºC'),
	(73757, 108, '2015-03-01 00:34:59.000000', 'temperatura', 386.0000, 'ºC'),
	(73758, 108, '2015-03-01 00:35:00.000000', 'temperatura', 476.0000, 'ºC'),
	(73759, 108, '2015-03-01 00:35:01.000000', 'temperatura', 19.0000, 'ºC'),
	(73760, 108, '2015-03-01 00:35:02.000000', 'temperatura', 1070.0000, 'ºC'),
	(73761, 108, '2015-03-01 00:35:03.000000', 'temperatura', 492.0000, 'ºC'),
	(73762, 108, '2015-03-01 00:35:04.000000', 'temperatura', 450.0000, 'ºC'),
	(73763, 108, '2015-03-01 00:35:05.000000', 'temperatura', 777.0000, 'ºC'),
	(73764, 108, '2015-03-01 00:35:06.000000', 'temperatura', 133.0000, 'ºC'),
	(73765, 108, '2015-03-01 00:35:07.000000', 'temperatura', 735.0000, 'ºC'),
	(73766, 108, '2015-03-01 00:35:08.000000', 'temperatura', 875.0000, 'ºC'),
	(73767, 108, '2015-03-01 00:35:09.000000', 'temperatura', 970.0000, 'ºC'),
	(73768, 108, '2015-03-01 00:35:10.000000', 'temperatura', 1028.0000, 'ºC'),
	(73769, 108, '2015-03-01 00:35:11.000000', 'temperatura', 1031.0000, 'ºC'),
	(73770, 108, '2015-03-01 00:35:12.000000', 'temperatura', 870.0000, 'ºC'),
	(73771, 108, '2015-03-01 00:35:13.000000', 'temperatura', 58.0000, 'ºC'),
	(73772, 108, '2015-03-01 00:35:14.000000', 'temperatura', 81.0000, 'ºC'),
	(73773, 108, '2015-03-01 00:35:15.000000', 'temperatura', 231.0000, 'ºC'),
	(73774, 108, '2015-03-01 00:35:16.000000', 'temperatura', 914.0000, 'ºC'),
	(73775, 108, '2015-03-01 00:35:17.000000', 'temperatura', 276.0000, 'ºC'),
	(73776, 108, '2015-03-01 00:35:18.000000', 'temperatura', 1039.0000, 'ºC'),
	(73777, 108, '2015-03-01 00:35:19.000000', 'temperatura', 768.0000, 'ºC'),
	(73778, 108, '2015-03-01 00:35:20.000000', 'temperatura', 725.0000, 'ºC'),
	(73779, 108, '2015-03-01 00:35:21.000000', 'temperatura', 119.0000, 'ºC'),
	(73780, 108, '2015-03-01 00:35:22.000000', 'temperatura', 820.0000, 'ºC'),
	(73781, 108, '2015-03-01 00:35:23.000000', 'temperatura', 144.0000, 'ºC'),
	(73782, 108, '2015-03-01 00:35:24.000000', 'temperatura', 660.0000, 'ºC'),
	(73783, 108, '2015-03-01 00:35:25.000000', 'temperatura', 467.0000, 'ºC'),
	(73784, 108, '2015-03-01 00:35:26.000000', 'temperatura', 357.0000, 'ºC'),
	(73785, 108, '2015-03-01 00:35:27.000000', 'temperatura', 384.0000, 'ºC'),
	(73786, 108, '2015-03-01 00:35:28.000000', 'temperatura', 851.0000, 'ºC'),
	(73787, 108, '2015-03-01 00:35:29.000000', 'temperatura', 702.0000, 'ºC'),
	(73788, 108, '2015-03-01 00:35:30.000000', 'temperatura', 957.0000, 'ºC'),
	(73789, 108, '2015-03-01 00:35:31.000000', 'temperatura', 280.0000, 'ºC'),
	(73790, 108, '2015-03-01 00:35:32.000000', 'temperatura', 930.0000, 'ºC'),
	(73791, 108, '2015-03-01 00:35:33.000000', 'temperatura', 209.0000, 'ºC'),
	(73792, 108, '2015-03-01 00:35:34.000000', 'temperatura', 658.0000, 'ºC'),
	(73793, 108, '2015-03-01 00:35:35.000000', 'temperatura', 261.0000, 'ºC'),
	(73794, 108, '2015-03-01 00:35:36.000000', 'temperatura', 534.0000, 'ºC'),
	(73795, 108, '2015-03-01 00:35:37.000000', 'temperatura', 685.0000, 'ºC'),
	(73796, 108, '2015-03-01 00:35:38.000000', 'temperatura', 625.0000, 'ºC'),
	(73797, 108, '2015-03-01 00:35:39.000000', 'temperatura', 1071.0000, 'ºC'),
	(73798, 108, '2015-03-01 00:35:40.000000', 'temperatura', 1080.0000, 'ºC'),
	(73799, 108, '2015-03-01 00:35:41.000000', 'temperatura', 986.0000, 'ºC'),
	(73800, 108, '2015-03-01 00:35:42.000000', 'temperatura', 493.0000, 'ºC'),
	(73801, 108, '2015-03-01 00:35:43.000000', 'temperatura', 706.0000, 'ºC'),
	(73802, 108, '2015-03-01 00:35:44.000000', 'temperatura', 850.0000, 'ºC'),
	(73803, 108, '2015-03-01 00:35:45.000000', 'temperatura', 936.0000, 'ºC'),
	(73804, 108, '2015-03-01 00:35:46.000000', 'temperatura', 927.0000, 'ºC'),
	(73805, 108, '2015-03-01 00:35:47.000000', 'temperatura', 629.0000, 'ºC'),
	(73806, 108, '2015-03-01 00:35:48.000000', 'temperatura', 364.0000, 'ºC'),
	(73807, 108, '2015-03-01 00:35:49.000000', 'temperatura', 1136.0000, 'ºC'),
	(73808, 108, '2015-03-01 00:35:50.000000', 'temperatura', 985.0000, 'ºC'),
	(73809, 108, '2015-03-01 00:35:51.000000', 'temperatura', 320.0000, 'ºC'),
	(73810, 108, '2015-03-01 00:35:52.000000', 'temperatura', 1046.0000, 'ºC'),
	(73811, 108, '2015-03-01 00:35:53.000000', 'temperatura', 671.0000, 'ºC'),
	(73812, 108, '2015-03-01 00:35:54.000000', 'temperatura', 216.0000, 'ºC'),
	(73813, 108, '2015-03-01 00:35:55.000000', 'temperatura', 266.0000, 'ºC'),
	(73814, 108, '2015-03-01 00:35:56.000000', 'temperatura', 686.0000, 'ºC'),
	(73815, 108, '2015-03-01 00:35:57.000000', 'temperatura', 229.0000, 'ºC'),
	(73816, 108, '2015-03-01 00:35:58.000000', 'temperatura', 288.0000, 'ºC'),
	(73817, 108, '2015-03-01 00:35:59.000000', 'temperatura', 754.0000, 'ºC'),
	(73818, 108, '2015-03-01 00:36:00.000000', 'temperatura', 509.0000, 'ºC'),
	(73819, 108, '2015-03-01 00:36:01.000000', 'temperatura', 280.0000, 'ºC'),
	(73820, 108, '2015-03-01 00:36:02.000000', 'temperatura', 1076.0000, 'ºC'),
	(73821, 108, '2015-03-01 00:36:03.000000', 'temperatura', 938.0000, 'ºC'),
	(73822, 108, '2015-03-01 00:36:04.000000', 'temperatura', 265.0000, 'ºC'),
	(73823, 108, '2015-03-01 00:36:05.000000', 'temperatura', 910.0000, 'ºC'),
	(73824, 108, '2015-03-01 00:36:06.000000', 'temperatura', 157.0000, 'ºC'),
	(73825, 108, '2015-03-01 00:36:07.000000', 'temperatura', 456.0000, 'ºC'),
	(73826, 108, '2015-03-01 00:36:08.000000', 'temperatura', 609.0000, 'ºC'),
	(73827, 108, '2015-03-01 00:36:09.000000', 'temperatura', 479.0000, 'ºC'),
	(73828, 108, '2015-03-01 00:36:10.000000', 'temperatura', 566.0000, 'ºC'),
	(73829, 108, '2015-03-01 00:36:11.000000', 'temperatura', 193.0000, 'ºC'),
	(73830, 108, '2015-03-01 00:36:12.000000', 'temperatura', 467.0000, 'ºC'),
	(73831, 108, '2015-03-01 00:36:13.000000', 'temperatura', 558.0000, 'ºC'),
	(73832, 108, '2015-03-01 00:36:14.000000', 'temperatura', 187.0000, 'ºC'),
	(73833, 108, '2015-03-01 00:36:15.000000', 'temperatura', 464.0000, 'ºC'),
	(73834, 108, '2015-03-01 00:36:16.000000', 'temperatura', 560.0000, 'ºC'),
	(73835, 108, '2015-03-01 00:36:17.000000', 'temperatura', 209.0000, 'ºC'),
	(73836, 108, '2015-03-01 00:36:18.000000', 'temperatura', 564.0000, 'ºC'),
	(73837, 108, '2015-03-01 00:36:19.000000', 'temperatura', 994.0000, 'ºC'),
	(73838, 108, '2015-03-01 00:36:20.000000', 'temperatura', 880.0000, 'ºC'),
	(73839, 108, '2015-03-01 00:36:21.000000', 'temperatura', 217.0000, 'ºC'),
	(73840, 108, '2015-03-01 00:36:22.000000', 'temperatura', 846.0000, 'ºC'),
	(73841, 108, '2015-03-01 00:36:23.000000', 'temperatura', 1177.0000, 'ºC'),
	(73842, 108, '2015-03-01 00:36:24.000000', 'temperatura', 951.0000, 'ºC'),
	(73843, 108, '2015-03-01 00:36:25.000000', 'temperatura', 24.0000, 'ºC'),
	(73844, 108, '2015-03-01 00:36:26.000000', 'temperatura', 866.0000, 'ºC'),
	(73845, 108, '2015-03-01 00:36:27.000000', 'temperatura', 660.0000, 'ºC'),
	(73846, 108, '2015-03-01 00:36:28.000000', 'temperatura', 700.0000, 'ºC'),
	(73847, 108, '2015-03-01 00:36:29.000000', 'temperatura', 321.0000, 'ºC'),
	(73848, 108, '2015-03-01 00:36:30.000000', 'temperatura', 706.0000, 'ºC'),
	(73849, 108, '2015-03-01 00:36:31.000000', 'temperatura', 169.0000, 'ºC'),
	(73850, 108, '2015-03-01 00:36:32.000000', 'temperatura', 1125.0000, 'ºC'),
	(73851, 108, '2015-03-01 00:36:33.000000', 'temperatura', 321.0000, 'ºC'),
	(73852, 108, '2015-03-01 00:36:34.000000', 'temperatura', 628.0000, 'ºC'),
	(73853, 108, '2015-03-01 00:36:35.000000', 'temperatura', 978.0000, 'ºC'),
	(73854, 108, '2015-03-01 00:36:36.000000', 'temperatura', 606.0000, 'ºC'),
	(73855, 108, '2015-03-01 00:36:37.000000', 'temperatura', 96.0000, 'ºC'),
	(73856, 108, '2015-03-01 00:36:38.000000', 'temperatura', 1063.0000, 'ºC'),
	(73857, 108, '2015-03-01 00:36:39.000000', 'temperatura', 229.0000, 'ºC'),
	(73858, 108, '2015-03-01 00:36:40.000000', 'temperatura', 356.0000, 'ºC'),
	(73859, 108, '2015-03-01 00:36:41.000000', 'temperatura', 1092.0000, 'ºC'),
	(73860, 108, '2015-03-01 00:36:42.000000', 'temperatura', 795.0000, 'ºC'),
	(73861, 108, '2015-03-01 00:36:43.000000', 'temperatura', 698.0000, 'ºC'),
	(73862, 108, '2015-03-01 00:36:44.000000', 'temperatura', 1105.0000, 'ºC'),
	(73863, 108, '2015-03-01 00:36:45.000000', 'temperatura', 1031.0000, 'ºC'),
	(73864, 108, '2015-03-01 00:36:46.000000', 'temperatura', 640.0000, 'ºC'),
	(73865, 108, '2015-03-01 00:36:47.000000', 'temperatura', 109.0000, 'ºC'),
	(73866, 108, '2015-03-01 00:36:48.000000', 'temperatura', 1023.0000, 'ºC'),
	(73867, 108, '2015-03-01 00:36:49.000000', 'temperatura', 1190.0000, 'ºC'),
	(73868, 108, '2015-03-01 00:36:50.000000', 'temperatura', 483.0000, 'ºC'),
	(73869, 108, '2015-03-01 00:36:51.000000', 'temperatura', 43.0000, 'ºC'),
	(73870, 108, '2015-03-01 00:36:52.000000', 'temperatura', 1166.0000, 'ºC'),
	(73871, 108, '2015-03-01 00:36:53.000000', 'temperatura', 901.0000, 'ºC'),
	(73872, 108, '2015-03-01 00:36:54.000000', 'temperatura', 1007.0000, 'ºC'),
	(73873, 108, '2015-03-01 00:36:55.000000', 'temperatura', 1135.0000, 'ºC'),
	(73874, 108, '2015-03-01 00:36:56.000000', 'temperatura', 252.0000, 'ºC'),
	(73875, 108, '2015-03-01 00:36:57.000000', 'temperatura', 255.0000, 'ºC'),
	(73876, 108, '2015-03-01 00:36:58.000000', 'temperatura', 520.0000, 'ºC'),
	(73877, 108, '2015-03-01 00:36:59.000000', 'temperatura', 635.0000, 'ºC'),
	(73878, 108, '2015-03-01 00:37:00.000000', 'temperatura', 416.0000, 'ºC'),
	(73879, 108, '2015-03-01 00:37:01.000000', 'temperatura', 174.0000, 'ºC'),
	(73880, 108, '2015-03-01 00:37:02.000000', 'temperatura', 823.0000, 'ºC'),
	(73881, 108, '2015-03-01 00:37:03.000000', 'temperatura', 1192.0000, 'ºC'),
	(73882, 108, '2015-03-01 00:37:04.000000', 'temperatura', 1094.0000, 'ºC'),
	(73883, 108, '2015-03-01 00:37:05.000000', 'temperatura', 694.0000, 'ºC'),
	(73884, 108, '2015-03-01 00:37:06.000000', 'temperatura', 190.0000, 'ºC'),
	(73885, 108, '2015-03-01 00:37:07.000000', 'temperatura', 68.0000, 'ºC'),
	(73886, 108, '2015-03-01 00:37:08.000000', 'temperatura', 969.0000, 'ºC'),
	(73887, 108, '2015-03-01 00:37:09.000000', 'temperatura', 1041.0000, 'ºC'),
	(73888, 108, '2015-03-01 00:37:10.000000', 'temperatura', 1100.0000, 'ºC'),
	(73889, 108, '2015-03-01 00:37:11.000000', 'temperatura', 1176.0000, 'ºC'),
	(73890, 108, '2015-03-01 00:37:12.000000', 'temperatura', 182.0000, 'ºC'),
	(73891, 108, '2015-03-01 00:37:13.000000', 'temperatura', 983.0000, 'ºC'),
	(73892, 108, '2015-03-01 00:37:14.000000', 'temperatura', 768.0000, 'ºC'),
	(73893, 108, '2015-03-01 00:37:15.000000', 'temperatura', 893.0000, 'ºC'),
	(73894, 108, '2015-03-01 00:37:16.000000', 'temperatura', 962.0000, 'ºC'),
	(73895, 108, '2015-03-01 00:37:17.000000', 'temperatura', 930.0000, 'ºC'),
	(73896, 108, '2015-03-01 00:37:18.000000', 'temperatura', 564.0000, 'ºC'),
	(73897, 108, '2015-03-01 00:37:19.000000', 'temperatura', 29.0000, 'ºC'),
	(73898, 108, '2015-03-01 00:37:20.000000', 'temperatura', 856.0000, 'ºC'),
	(73899, 108, '2015-03-01 00:37:21.000000', 'temperatura', 592.0000, 'ºC'),
	(73900, 108, '2015-03-01 00:37:22.000000', 'temperatura', 392.0000, 'ºC'),
	(73901, 108, '2015-03-01 00:37:23.000000', 'temperatura', 187.0000, 'ºC'),
	(73902, 108, '2015-03-01 00:37:24.000000', 'temperatura', 958.0000, 'ºC'),
	(73903, 108, '2015-03-01 00:37:25.000000', 'temperatura', 628.0000, 'ºC'),
	(73904, 108, '2015-03-01 00:37:26.000000', 'temperatura', 268.0000, 'ºC'),
	(73905, 108, '2015-03-01 00:37:27.000000', 'temperatura', 658.0000, 'ºC'),
	(73906, 108, '2015-03-01 00:37:28.000000', 'temperatura', 85.0000, 'ºC'),
	(73907, 108, '2015-03-01 00:37:29.000000', 'temperatura', 850.0000, 'ºC'),
	(73908, 108, '2015-03-01 00:37:30.000000', 'temperatura', 398.0000, 'ºC'),
	(73909, 108, '2015-03-01 00:37:31.000000', 'temperatura', 641.0000, 'ºC'),
	(73910, 108, '2015-03-01 00:37:32.000000', 'temperatura', 813.0000, 'ºC'),
	(73911, 108, '2015-03-01 00:37:33.000000', 'temperatura', 939.0000, 'ºC'),
	(73912, 108, '2015-03-01 00:37:34.000000', 'temperatura', 1059.0000, 'ºC'),
	(73913, 108, '2015-03-01 00:37:35.000000', 'temperatura', 78.0000, 'ºC'),
	(73914, 108, '2015-03-01 00:37:36.000000', 'temperatura', 814.0000, 'ºC'),
	(73915, 108, '2015-03-01 00:37:37.000000', 'temperatura', 235.0000, 'ºC'),
	(73916, 108, '2015-03-01 00:37:38.000000', 'temperatura', 1135.0000, 'ºC'),
	(73917, 108, '2015-03-01 00:37:39.000000', 'temperatura', 171.0000, 'ºC'),
	(73918, 108, '2015-03-01 00:37:40.000000', 'temperatura', 1050.0000, 'ºC'),
	(73919, 108, '2015-03-01 00:37:41.000000', 'temperatura', 1137.0000, 'ºC'),
	(73920, 108, '2015-03-01 00:37:42.000000', 'temperatura', 137.0000, 'ºC'),
	(73921, 108, '2015-03-01 00:37:43.000000', 'temperatura', 875.0000, 'ºC'),
	(73922, 108, '2015-03-01 00:37:44.000000', 'temperatura', 363.0000, 'ºC'),
	(73923, 108, '2015-03-01 00:37:45.000000', 'temperatura', 389.0000, 'ºC'),
	(73924, 108, '2015-03-01 00:37:46.000000', 'temperatura', 858.0000, 'ºC'),
	(73925, 108, '2015-03-01 00:37:47.000000', 'temperatura', 722.0000, 'ºC'),
	(73926, 108, '2015-03-01 00:37:48.000000', 'temperatura', 1039.0000, 'ºC'),
	(73927, 108, '2015-03-01 00:37:49.000000', 'temperatura', 629.0000, 'ºC'),
	(73928, 108, '2015-03-01 00:37:50.000000', 'temperatura', 28.0000, 'ºC'),
	(73929, 108, '2015-03-01 00:37:51.000000', 'temperatura', 655.0000, 'ºC'),
	(73930, 108, '2015-03-01 00:37:52.000000', 'temperatura', 792.0000, 'ºC'),
	(73931, 108, '2015-03-01 00:37:53.000000', 'temperatura', 796.0000, 'ºC'),
	(73932, 108, '2015-03-01 00:37:54.000000', 'temperatura', 404.0000, 'ºC'),
	(73933, 108, '2015-03-01 00:37:55.000000', 'temperatura', 833.0000, 'ºC'),
	(73934, 108, '2015-03-01 00:37:56.000000', 'temperatura', 553.0000, 'ºC'),
	(73935, 108, '2015-03-01 00:37:57.000000', 'temperatura', 266.0000, 'ºC'),
	(73936, 108, '2015-03-01 00:37:58.000000', 'temperatura', 871.0000, 'ºC'),
	(73937, 108, '2015-03-01 00:37:59.000000', 'temperatura', 1159.0000, 'ºC'),
	(73938, 108, '2015-03-01 00:38:00.000000', 'temperatura', 784.0000, 'ºC'),
	(73939, 108, '2015-03-01 00:38:01.000000', 'temperatura', 442.0000, 'ºC'),
	(73940, 108, '2015-03-01 00:38:02.000000', 'temperatura', 1058.0000, 'ºC'),
	(73941, 108, '2015-03-01 00:38:03.000000', 'temperatura', 363.0000, 'ºC'),
	(73942, 108, '2015-03-01 00:38:04.000000', 'temperatura', 1043.0000, 'ºC'),
	(73943, 108, '2015-03-01 00:38:05.000000', 'temperatura', 528.0000, 'ºC'),
	(73944, 108, '2015-03-01 00:38:06.000000', 'temperatura', 710.0000, 'ºC'),
	(73945, 108, '2015-03-01 00:38:07.000000', 'temperatura', 767.0000, 'ºC'),
	(73946, 108, '2015-03-01 00:38:08.000000', 'temperatura', 506.0000, 'ºC'),
	(73947, 108, '2015-03-01 00:38:09.000000', 'temperatura', 230.0000, 'ºC'),
	(73948, 108, '2015-03-01 00:38:10.000000', 'temperatura', 832.0000, 'ºC'),
	(73949, 108, '2015-03-01 00:38:11.000000', 'temperatura', 1072.0000, 'ºC'),
	(73950, 108, '2015-03-01 00:38:12.000000', 'temperatura', 463.0000, 'ºC'),
	(73951, 108, '2015-03-01 00:38:13.000000', 'temperatura', 300.0000, 'ºC'),
	(73952, 108, '2015-03-01 00:38:14.000000', 'temperatura', 111.0000, 'ºC'),
	(73953, 108, '2015-03-01 00:38:15.000000', 'temperatura', 855.0000, 'ºC'),
	(73954, 108, '2015-03-01 00:38:16.000000', 'temperatura', 343.0000, 'ºC'),
	(73955, 108, '2015-03-01 00:38:17.000000', 'temperatura', 352.0000, 'ºC'),
	(73956, 108, '2015-03-01 00:38:18.000000', 'temperatura', 732.0000, 'ºC'),
	(73957, 108, '2015-03-01 00:38:19.000000', 'temperatura', 205.0000, 'ºC'),
	(73958, 108, '2015-03-01 00:38:20.000000', 'temperatura', 29.0000, 'ºC'),
	(73959, 108, '2015-03-01 00:38:21.000000', 'temperatura', 729.0000, 'ºC'),
	(73960, 108, '2015-03-01 00:38:22.000000', 'temperatura', 1157.0000, 'ºC'),
	(73961, 108, '2015-03-01 00:38:23.000000', 'temperatura', 2.0000, 'ºC'),
	(73962, 108, '2015-03-01 00:38:24.000000', 'temperatura', 136.0000, 'ºC'),
	(73963, 108, '2015-03-01 00:38:25.000000', 'temperatura', 677.0000, 'ºC'),
	(73964, 108, '2015-03-01 00:38:26.000000', 'temperatura', 577.0000, 'ºC'),
	(73965, 108, '2015-03-01 00:38:27.000000', 'temperatura', 856.0000, 'ºC'),
	(73966, 108, '2015-03-01 00:38:28.000000', 'temperatura', 149.0000, 'ºC'),
	(73967, 108, '2015-03-01 00:38:29.000000', 'temperatura', 576.0000, 'ºC'),
	(73968, 108, '2015-03-01 00:38:30.000000', 'temperatura', 36.0000, 'ºC'),
	(73969, 108, '2015-03-01 00:38:31.000000', 'temperatura', 852.0000, 'ºC'),
	(73970, 108, '2015-03-01 00:38:32.000000', 'temperatura', 551.0000, 'ºC'),
	(73971, 108, '2015-03-01 00:38:33.000000', 'temperatura', 199.0000, 'ºC'),
	(73972, 108, '2015-03-01 00:38:34.000000', 'temperatura', 544.0000, 'ºC'),
	(73973, 108, '2015-03-01 00:38:35.000000', 'temperatura', 922.0000, 'ºC'),
	(73974, 108, '2015-03-01 00:38:36.000000', 'temperatura', 581.0000, 'ºC'),
	(73975, 108, '2015-03-01 00:38:37.000000', 'temperatura', 139.0000, 'ºC'),
	(73976, 108, '2015-03-01 00:38:38.000000', 'temperatura', 150.0000, 'ºC'),
	(73977, 108, '2015-03-01 00:38:39.000000', 'temperatura', 336.0000, 'ºC'),
	(73978, 108, '2015-03-01 00:38:40.000000', 'temperatura', 28.0000, 'ºC'),
	(73979, 108, '2015-03-01 00:38:41.000000', 'temperatura', 333.0000, 'ºC'),
	(73980, 108, '2015-03-01 00:38:42.000000', 'temperatura', 383.0000, 'ºC'),
	(73981, 108, '2015-03-01 00:38:43.000000', 'temperatura', 914.0000, 'ºC'),
	(73982, 108, '2015-03-01 00:38:44.000000', 'temperatura', 1023.0000, 'ºC'),
	(73983, 108, '2015-03-01 00:38:45.000000', 'temperatura', 1172.0000, 'ºC'),
	(73984, 108, '2015-03-01 00:38:46.000000', 'temperatura', 392.0000, 'ºC'),
	(73985, 108, '2015-03-01 00:38:47.000000', 'temperatura', 847.0000, 'ºC'),
	(73986, 108, '2015-03-01 00:38:48.000000', 'temperatura', 656.0000, 'ºC'),
	(73987, 108, '2015-03-01 00:38:49.000000', 'temperatura', 741.0000, 'ºC'),
	(73988, 108, '2015-03-01 00:38:50.000000', 'temperatura', 539.0000, 'ºC'),
	(73989, 108, '2015-03-01 00:38:51.000000', 'temperatura', 471.0000, 'ºC'),
	(73990, 108, '2015-03-01 00:38:52.000000', 'temperatura', 741.0000, 'ºC'),
	(73991, 108, '2015-03-01 00:38:53.000000', 'temperatura', 1090.0000, 'ºC'),
	(73992, 108, '2015-03-01 00:38:54.000000', 'temperatura', 828.0000, 'ºC'),
	(73993, 108, '2015-03-01 00:38:55.000000', 'temperatura', 869.0000, 'ºC'),
	(73994, 108, '2015-03-01 00:38:56.000000', 'temperatura', 663.0000, 'ºC'),
	(73995, 108, '2015-03-01 00:38:57.000000', 'temperatura', 710.0000, 'ºC'),
	(73996, 108, '2015-03-01 00:38:58.000000', 'temperatura', 361.0000, 'ºC'),
	(73997, 108, '2015-03-01 00:38:59.000000', 'temperatura', 877.0000, 'ºC'),
	(73998, 108, '2015-03-01 00:39:00.000000', 'temperatura', 900.0000, 'ºC'),
	(73999, 108, '2015-03-01 00:39:01.000000', 'temperatura', 669.0000, 'ºC'),
	(74000, 108, '2015-03-01 00:39:02.000000', 'temperatura', 647.0000, 'ºC'),
	(74001, 108, '2015-03-01 00:39:03.000000', 'temperatura', 29.0000, 'ºC'),
	(74002, 108, '2015-03-01 00:39:04.000000', 'temperatura', 604.0000, 'ºC'),
	(74003, 108, '2015-03-01 00:39:05.000000', 'temperatura', 533.0000, 'ºC'),
	(74004, 108, '2015-03-01 00:39:06.000000', 'temperatura', 856.0000, 'ºC'),
	(74005, 108, '2015-03-01 00:39:07.000000', 'temperatura', 278.0000, 'ºC'),
	(74006, 108, '2015-03-01 00:39:08.000000', 'temperatura', 25.0000, 'ºC'),
	(74007, 108, '2015-03-01 00:39:09.000000', 'temperatura', 490.0000, 'ºC'),
	(74008, 108, '2015-03-01 00:39:10.000000', 'temperatura', 1175.0000, 'ºC'),
	(74009, 108, '2015-03-01 00:39:11.000000', 'temperatura', 805.0000, 'ºC'),
	(74010, 108, '2015-03-01 00:39:12.000000', 'temperatura', 502.0000, 'ºC'),
	(74011, 108, '2015-03-01 00:39:13.000000', 'temperatura', 97.0000, 'ºC'),
	(74012, 108, '2015-03-01 00:39:14.000000', 'temperatura', 178.0000, 'ºC'),
	(74013, 108, '2015-03-01 00:39:15.000000', 'temperatura', 601.0000, 'ºC'),
	(74014, 108, '2015-03-01 00:39:16.000000', 'temperatura', 69.0000, 'ºC'),
	(74015, 108, '2015-03-01 00:39:17.000000', 'temperatura', 943.0000, 'ºC'),
	(74016, 108, '2015-03-01 00:39:18.000000', 'temperatura', 909.0000, 'ºC'),
	(74017, 108, '2015-03-01 00:39:19.000000', 'temperatura', 515.0000, 'ºC'),
	(74018, 108, '2015-03-01 00:39:20.000000', 'temperatura', 1051.0000, 'ºC'),
	(74019, 108, '2015-03-01 00:39:21.000000', 'temperatura', 108.0000, 'ºC'),
	(74020, 108, '2015-03-01 00:39:22.000000', 'temperatura', 990.0000, 'ºC'),
	(74021, 108, '2015-03-01 00:39:23.000000', 'temperatura', 1027.0000, 'ºC'),
	(74022, 108, '2015-03-01 00:39:24.000000', 'temperatura', 965.0000, 'ºC'),
	(74023, 108, '2015-03-01 00:39:25.000000', 'temperatura', 544.0000, 'ºC'),
	(74024, 108, '2015-03-01 00:39:26.000000', 'temperatura', 1025.0000, 'ºC'),
	(74025, 108, '2015-03-01 00:39:27.000000', 'temperatura', 1096.0000, 'ºC'),
	(74026, 108, '2015-03-01 00:39:28.000000', 'temperatura', 2.0000, 'ºC'),
	(74027, 108, '2015-03-01 00:39:29.000000', 'temperatura', 324.0000, 'ºC'),
	(74028, 108, '2015-03-01 00:39:30.000000', 'temperatura', 416.0000, 'ºC'),
	(74029, 108, '2015-03-01 00:39:31.000000', 'temperatura', 1108.0000, 'ºC'),
	(74030, 108, '2015-03-01 00:39:32.000000', 'temperatura', 691.0000, 'ºC'),
	(74031, 108, '2015-03-01 00:39:33.000000', 'temperatura', 131.0000, 'ºC'),
	(74032, 108, '2015-03-01 00:39:34.000000', 'temperatura', 984.0000, 'ºC'),
	(74033, 108, '2015-03-01 00:39:35.000000', 'temperatura', 926.0000, 'ºC'),
	(74034, 108, '2015-03-01 00:39:36.000000', 'temperatura', 481.0000, 'ºC'),
	(74035, 108, '2015-03-01 00:39:37.000000', 'temperatura', 826.0000, 'ºC'),
	(74036, 108, '2015-03-01 00:39:38.000000', 'temperatura', 287.0000, 'ºC'),
	(74037, 108, '2015-03-01 00:39:39.000000', 'temperatura', 159.0000, 'ºC'),
	(74038, 108, '2015-03-01 00:39:40.000000', 'temperatura', 1134.0000, 'ºC'),
	(74039, 108, '2015-03-01 00:39:41.000000', 'temperatura', 394.0000, 'ºC'),
	(74040, 108, '2015-03-01 00:39:42.000000', 'temperatura', 969.0000, 'ºC'),
	(74041, 108, '2015-03-01 00:39:43.000000', 'temperatura', 63.0000, 'ºC'),
	(74042, 108, '2015-03-01 00:39:44.000000', 'temperatura', 1009.0000, 'ºC'),
	(74043, 108, '2015-03-01 00:39:45.000000', 'temperatura', 55.0000, 'ºC'),
	(74044, 108, '2015-03-01 00:39:46.000000', 'temperatura', 848.0000, 'ºC'),
	(74045, 108, '2015-03-01 00:39:47.000000', 'temperatura', 477.0000, 'ºC'),
	(74046, 108, '2015-03-01 00:39:48.000000', 'temperatura', 1039.0000, 'ºC'),
	(74047, 108, '2015-03-01 00:39:49.000000', 'temperatura', 168.0000, 'ºC'),
	(74048, 108, '2015-03-01 00:39:50.000000', 'temperatura', 122.0000, 'ºC'),
	(74049, 108, '2015-03-01 00:39:51.000000', 'temperatura', 106.0000, 'ºC'),
	(74050, 108, '2015-03-01 00:39:52.000000', 'temperatura', 163.0000, 'ºC'),
	(74051, 108, '2015-03-01 00:39:53.000000', 'temperatura', 501.0000, 'ºC'),
	(74052, 108, '2015-03-01 00:39:54.000000', 'temperatura', 813.0000, 'ºC'),
	(74053, 108, '2015-03-01 00:39:55.000000', 'temperatura', 164.0000, 'ºC'),
	(74054, 108, '2015-03-01 00:39:56.000000', 'temperatura', 783.0000, 'ºC'),
	(74055, 108, '2015-03-01 00:39:57.000000', 'temperatura', 1023.0000, 'ºC'),
	(74056, 108, '2015-03-01 00:39:58.000000', 'temperatura', 365.0000, 'ºC'),
	(74057, 108, '2015-03-01 00:39:59.000000', 'temperatura', 1158.0000, 'ºC'),
	(74058, 108, '2015-03-01 00:40:00.000000', 'temperatura', 1095.0000, 'ºC'),
	(74059, 108, '2015-03-01 00:40:01.000000', 'temperatura', 800.0000, 'ºC'),
	(74060, 108, '2015-03-01 00:40:02.000000', 'temperatura', 715.0000, 'ºC'),
	(74061, 108, '2015-03-01 00:40:03.000000', 'temperatura', 1175.0000, 'ºC'),
	(74062, 108, '2015-03-01 00:40:04.000000', 'temperatura', 130.0000, 'ºC'),
	(74063, 108, '2015-03-01 00:40:05.000000', 'temperatura', 725.0000, 'ºC'),
	(74064, 108, '2015-03-01 00:40:06.000000', 'temperatura', 838.0000, 'ºC'),
	(74065, 108, '2015-03-01 00:40:07.000000', 'temperatura', 816.0000, 'ºC'),
	(74066, 108, '2015-03-01 00:40:08.000000', 'temperatura', 365.0000, 'ºC'),
	(74067, 108, '2015-03-01 00:40:09.000000', 'temperatura', 577.0000, 'ºC'),
	(74068, 108, '2015-03-01 00:40:10.000000', 'temperatura', 590.0000, 'ºC'),
	(74069, 108, '2015-03-01 00:40:11.000000', 'temperatura', 20.0000, 'ºC'),
	(74070, 108, '2015-03-01 00:40:12.000000', 'temperatura', 730.0000, 'ºC'),
	(74071, 108, '2015-03-01 00:40:13.000000', 'temperatura', 1190.0000, 'ºC'),
	(74072, 108, '2015-03-01 00:40:14.000000', 'temperatura', 160.0000, 'ºC'),
	(74073, 108, '2015-03-01 00:40:15.000000', 'temperatura', 831.0000, 'ºC'),
	(74074, 108, '2015-03-01 00:40:16.000000', 'temperatura', 77.0000, 'ºC'),
	(74075, 108, '2015-03-01 00:40:17.000000', 'temperatura', 292.0000, 'ºC'),
	(74076, 108, '2015-03-01 00:40:18.000000', 'temperatura', 31.0000, 'ºC'),
	(74077, 108, '2015-03-01 00:40:19.000000', 'temperatura', 480.0000, 'ºC'),
	(74078, 108, '2015-03-01 00:40:20.000000', 'temperatura', 1105.0000, 'ºC'),
	(74079, 108, '2015-03-01 00:40:21.000000', 'temperatura', 485.0000, 'ºC'),
	(74080, 108, '2015-03-01 00:40:22.000000', 'temperatura', 310.0000, 'ºC'),
	(74081, 108, '2015-03-01 00:40:23.000000', 'temperatura', 97.0000, 'ºC'),
	(74082, 108, '2015-03-01 00:40:24.000000', 'temperatura', 756.0000, 'ºC'),
	(74083, 108, '2015-03-01 00:40:25.000000', 'temperatura', 1088.0000, 'ºC'),
	(74084, 108, '2015-03-01 00:40:26.000000', 'temperatura', 775.0000, 'ºC'),
	(74085, 108, '2015-03-01 00:40:27.000000', 'temperatura', 611.0000, 'ºC'),
	(74086, 108, '2015-03-01 00:40:28.000000', 'temperatura', 731.0000, 'ºC'),
	(74087, 108, '2015-03-01 00:40:29.000000', 'temperatura', 623.0000, 'ºC'),
	(74088, 108, '2015-03-01 00:40:30.000000', 'temperatura', 923.0000, 'ºC'),
	(74089, 108, '2015-03-01 00:40:31.000000', 'temperatura', 346.0000, 'ºC'),
	(74090, 108, '2015-03-01 00:40:32.000000', 'temperatura', 162.0000, 'ºC'),
	(74091, 108, '2015-03-01 00:40:33.000000', 'temperatura', 970.0000, 'ºC'),
	(74092, 108, '2015-03-01 00:40:34.000000', 'temperatura', 767.0000, 'ºC'),
	(74093, 108, '2015-03-01 00:40:35.000000', 'temperatura', 927.0000, 'ºC'),
	(74094, 108, '2015-03-01 00:40:36.000000', 'temperatura', 1132.0000, 'ºC'),
	(74095, 108, '2015-03-01 00:40:37.000000', 'temperatura', 478.0000, 'ºC'),
	(74096, 108, '2015-03-01 00:40:38.000000', 'temperatura', 198.0000, 'ºC'),
	(74097, 108, '2015-03-01 00:40:39.000000', 'temperatura', 754.0000, 'ºC'),
	(74098, 108, '2015-03-01 00:40:40.000000', 'temperatura', 775.0000, 'ºC'),
	(74099, 108, '2015-03-01 00:40:41.000000', 'temperatura', 417.0000, 'ºC'),
	(74100, 108, '2015-03-01 00:40:42.000000', 'temperatura', 958.0000, 'ºC'),
	(74101, 108, '2015-03-01 00:40:43.000000', 'temperatura', 1142.0000, 'ºC'),
	(74102, 108, '2015-03-01 00:40:44.000000', 'temperatura', 436.0000, 'ºC'),
	(74103, 108, '2015-03-01 00:40:45.000000', 'temperatura', 1154.0000, 'ºC'),
	(74104, 108, '2015-03-01 00:40:46.000000', 'temperatura', 864.0000, 'ºC'),
	(74105, 108, '2015-03-01 00:40:47.000000', 'temperatura', 857.0000, 'ºC'),
	(74106, 108, '2015-03-01 00:40:48.000000', 'temperatura', 494.0000, 'ºC'),
	(74107, 108, '2015-03-01 00:40:49.000000', 'temperatura', 1100.0000, 'ºC'),
	(74108, 108, '2015-03-01 00:40:50.000000', 'temperatura', 420.0000, 'ºC'),
	(74109, 108, '2015-03-01 00:40:51.000000', 'temperatura', 1197.0000, 'ºC'),
	(74110, 108, '2015-03-01 00:40:52.000000', 'temperatura', 1128.0000, 'ºC'),
	(74111, 108, '2015-03-01 00:40:53.000000', 'temperatura', 851.0000, 'ºC'),
	(74112, 108, '2015-03-01 00:40:54.000000', 'temperatura', 869.0000, 'ºC'),
	(74113, 108, '2015-03-01 00:40:55.000000', 'temperatura', 594.0000, 'ºC'),
	(74114, 108, '2015-03-01 00:40:56.000000', 'temperatura', 365.0000, 'ºC'),
	(74115, 108, '2015-03-01 00:40:57.000000', 'temperatura', 42.0000, 'ºC'),
	(74116, 108, '2015-03-01 00:40:58.000000', 'temperatura', 317.0000, 'ºC'),
	(74117, 108, '2015-03-01 00:40:59.000000', 'temperatura', 259.0000, 'ºC'),
	(74118, 108, '2015-03-01 00:41:00.000000', 'temperatura', 343.0000, 'ºC'),
	(74119, 108, '2015-03-01 00:41:01.000000', 'temperatura', 938.0000, 'ºC'),
	(74120, 108, '2015-03-01 00:41:02.000000', 'temperatura', 62.0000, 'ºC'),
	(74121, 108, '2015-03-01 00:41:03.000000', 'temperatura', 1096.0000, 'ºC'),
	(74122, 108, '2015-03-01 00:41:04.000000', 'temperatura', 496.0000, 'ºC'),
	(74123, 108, '2015-03-01 00:41:05.000000', 'temperatura', 390.0000, 'ºC'),
	(74124, 108, '2015-03-01 00:41:06.000000', 'temperatura', 466.0000, 'ºC'),
	(74125, 108, '2015-03-01 00:41:07.000000', 'temperatura', 1158.0000, 'ºC'),
	(74126, 108, '2015-03-01 00:41:08.000000', 'temperatura', 792.0000, 'ºC'),
	(74127, 108, '2015-03-01 00:41:09.000000', 'temperatura', 489.0000, 'ºC'),
	(74128, 108, '2015-03-01 00:41:10.000000', 'temperatura', 67.0000, 'ºC'),
	(74129, 108, '2015-03-01 00:41:11.000000', 'temperatura', 69.0000, 'ºC'),
	(74130, 108, '2015-03-01 00:41:12.000000', 'temperatura', 144.0000, 'ºC'),
	(74131, 108, '2015-03-01 00:41:13.000000', 'temperatura', 514.0000, 'ºC'),
	(74132, 108, '2015-03-01 00:41:14.000000', 'temperatura', 936.0000, 'ºC'),
	(74133, 108, '2015-03-01 00:41:15.000000', 'temperatura', 742.0000, 'ºC'),
	(74134, 108, '2015-03-01 00:41:16.000000', 'temperatura', 901.0000, 'ºC'),
	(74135, 108, '2015-03-01 00:41:17.000000', 'temperatura', 1081.0000, 'ºC'),
	(74136, 108, '2015-03-01 00:41:18.000000', 'temperatura', 300.0000, 'ºC'),
	(74137, 108, '2015-03-01 00:41:19.000000', 'temperatura', 658.0000, 'ºC'),
	(74138, 108, '2015-03-01 00:41:20.000000', 'temperatura', 1191.0000, 'ºC'),
	(74139, 108, '2015-03-01 00:41:21.000000', 'temperatura', 381.0000, 'ºC'),
	(74140, 108, '2015-03-01 00:41:22.000000', 'temperatura', 733.0000, 'ºC'),
	(74141, 108, '2015-03-01 00:41:23.000000', 'temperatura', 124.0000, 'ºC'),
	(74142, 108, '2015-03-01 00:41:24.000000', 'temperatura', 822.0000, 'ºC'),
	(74143, 108, '2015-03-01 00:41:25.000000', 'temperatura', 137.0000, 'ºC'),
	(74144, 108, '2015-03-01 00:41:26.000000', 'temperatura', 619.0000, 'ºC'),
	(74145, 108, '2015-03-01 00:41:27.000000', 'temperatura', 285.0000, 'ºC'),
	(74146, 108, '2015-03-01 00:41:28.000000', 'temperatura', 766.0000, 'ºC'),
	(74147, 108, '2015-03-01 00:41:29.000000', 'temperatura', 579.0000, 'ºC'),
	(74148, 108, '2015-03-01 00:41:30.000000', 'temperatura', 597.0000, 'ºC'),
	(74149, 108, '2015-03-01 00:41:31.000000', 'temperatura', 48.0000, 'ºC'),
	(74150, 108, '2015-03-01 00:41:32.000000', 'temperatura', 848.0000, 'ºC'),
	(74151, 108, '2015-03-01 00:41:33.000000', 'temperatura', 498.0000, 'ºC'),
	(74152, 108, '2015-03-01 00:41:34.000000', 'temperatura', 1148.0000, 'ºC'),
	(74153, 108, '2015-03-01 00:41:35.000000', 'temperatura', 643.0000, 'ºC'),
	(74154, 108, '2015-03-01 00:41:36.000000', 'temperatura', 974.0000, 'ºC'),
	(74155, 108, '2015-03-01 00:41:37.000000', 'temperatura', 540.0000, 'ºC'),
	(74156, 108, '2015-03-01 00:41:38.000000', 'temperatura', 978.0000, 'ºC'),
	(74157, 108, '2015-03-01 00:41:39.000000', 'temperatura', 871.0000, 'ºC'),
	(74158, 108, '2015-03-01 00:41:40.000000', 'temperatura', 222.0000, 'ºC'),
	(74159, 108, '2015-03-01 00:41:41.000000', 'temperatura', 895.0000, 'ºC'),
	(74160, 108, '2015-03-01 00:41:42.000000', 'temperatura', 212.0000, 'ºC'),
	(74161, 108, '2015-03-01 00:41:43.000000', 'temperatura', 774.0000, 'ºC'),
	(74162, 108, '2015-03-01 00:41:44.000000', 'temperatura', 836.0000, 'ºC'),
	(74163, 108, '2015-03-01 00:41:45.000000', 'temperatura', 658.0000, 'ºC'),
	(74164, 108, '2015-03-01 00:41:46.000000', 'temperatura', 781.0000, 'ºC'),
	(74165, 108, '2015-03-01 00:41:47.000000', 'temperatura', 734.0000, 'ºC'),
	(74166, 108, '2015-03-01 00:41:48.000000', 'temperatura', 128.0000, 'ºC'),
	(74167, 108, '2015-03-01 00:41:49.000000', 'temperatura', 836.0000, 'ºC'),
	(74168, 108, '2015-03-01 00:41:50.000000', 'temperatura', 196.0000, 'ºC'),
	(74169, 108, '2015-03-01 00:41:51.000000', 'temperatura', 875.0000, 'ºC'),
	(74170, 108, '2015-03-01 00:41:52.000000', 'temperatura', 186.0000, 'ºC'),
	(74171, 108, '2015-03-01 00:41:53.000000', 'temperatura', 707.0000, 'ºC'),
	(74172, 108, '2015-03-01 00:41:54.000000', 'temperatura', 578.0000, 'ºC'),
	(74173, 108, '2015-03-01 00:41:55.000000', 'temperatura', 768.0000, 'ºC'),
	(74174, 108, '2015-03-01 00:41:56.000000', 'temperatura', 907.0000, 'ºC'),
	(74175, 108, '2015-03-01 00:41:57.000000', 'temperatura', 1033.0000, 'ºC'),
	(74176, 108, '2015-03-01 00:41:58.000000', 'temperatura', 42.0000, 'ºC'),
	(74177, 108, '2015-03-01 00:41:59.000000', 'temperatura', 711.0000, 'ºC'),
	(74178, 108, '2015-03-01 00:42:00.000000', 'temperatura', 1032.0000, 'ºC'),
	(74179, 108, '2015-03-01 00:42:01.000000', 'temperatura', 625.0000, 'ºC'),
	(74180, 108, '2015-03-01 00:42:02.000000', 'temperatura', 31.0000, 'ºC'),
	(74181, 108, '2015-03-01 00:42:03.000000', 'temperatura', 679.0000, 'ºC'),
	(74182, 108, '2015-03-01 00:42:04.000000', 'temperatura', 903.0000, 'ºC'),
	(74183, 108, '2015-03-01 00:42:05.000000', 'temperatura', 81.0000, 'ºC'),
	(74184, 108, '2015-03-01 00:42:06.000000', 'temperatura', 94.0000, 'ºC'),
	(74185, 108, '2015-03-01 00:42:07.000000', 'temperatura', 226.0000, 'ºC'),
	(74186, 108, '2015-03-01 00:42:08.000000', 'temperatura', 851.0000, 'ºC'),
	(74187, 108, '2015-03-01 00:42:09.000000', 'temperatura', 1177.0000, 'ºC'),
	(74188, 108, '2015-03-01 00:42:10.000000', 'temperatura', 933.0000, 'ºC'),
	(74189, 108, '2015-03-01 00:42:11.000000', 'temperatura', 1135.0000, 'ºC'),
	(74190, 108, '2015-03-01 00:42:12.000000', 'temperatura', 475.0000, 'ºC'),
	(74191, 108, '2015-03-01 00:42:13.000000', 'temperatura', 173.0000, 'ºC'),
	(74192, 108, '2015-03-01 00:42:14.000000', 'temperatura', 637.0000, 'ºC'),
	(74193, 108, '2015-03-01 00:42:15.000000', 'temperatura', 268.0000, 'ºC'),
	(74194, 108, '2015-03-01 00:42:16.000000', 'temperatura', 631.0000, 'ºC'),
	(74195, 108, '2015-03-01 00:42:17.000000', 'temperatura', 1150.0000, 'ºC'),
	(74196, 108, '2015-03-01 00:42:18.000000', 'temperatura', 258.0000, 'ºC'),
	(74197, 108, '2015-03-01 00:42:19.000000', 'temperatura', 241.0000, 'ºC'),
	(74198, 108, '2015-03-01 00:42:20.000000', 'temperatura', 431.0000, 'ºC'),
	(74199, 108, '2015-03-01 00:42:21.000000', 'temperatura', 234.0000, 'ºC'),
	(74200, 108, '2015-03-01 00:42:22.000000', 'temperatura', 1079.0000, 'ºC'),
	(74201, 108, '2015-03-01 00:42:23.000000', 'temperatura', 1090.0000, 'ºC'),
	(74202, 108, '2015-03-01 00:42:24.000000', 'temperatura', 1015.0000, 'ºC'),
	(74203, 108, '2015-03-01 00:42:25.000000', 'temperatura', 604.0000, 'ºC'),
	(74204, 108, '2015-03-01 00:42:26.000000', 'temperatura', 1178.0000, 'ºC'),
	(74205, 108, '2015-03-01 00:42:27.000000', 'temperatura', 478.0000, 'ºC'),
	(74206, 108, '2015-03-01 00:42:28.000000', 'temperatura', 57.0000, 'ºC'),
	(74207, 108, '2015-03-01 00:42:29.000000', 'temperatura', 52.0000, 'ºC'),
	(74208, 108, '2015-03-01 00:42:30.000000', 'temperatura', 90.0000, 'ºC'),
	(74209, 108, '2015-03-01 00:42:31.000000', 'temperatura', 294.0000, 'ºC'),
	(74210, 108, '2015-03-01 00:42:32.000000', 'temperatura', 1199.0000, 'ºC'),
	(74211, 108, '2015-03-01 00:42:33.000000', 'temperatura', 312.0000, 'ºC'),
	(74212, 108, '2015-03-01 00:42:34.000000', 'temperatura', 367.0000, 'ºC'),
	(74213, 108, '2015-03-01 00:42:35.000000', 'temperatura', 898.0000, 'ºC'),
	(74214, 108, '2015-03-01 00:42:36.000000', 'temperatura', 990.0000, 'ºC'),
	(74215, 108, '2015-03-01 00:42:37.000000', 'temperatura', 1056.0000, 'ºC'),
	(74216, 108, '2015-03-01 00:42:38.000000', 'temperatura', 1110.0000, 'ºC'),
	(74217, 108, '2015-03-01 00:42:39.000000', 'temperatura', 1183.0000, 'ºC'),
	(74218, 108, '2015-03-01 00:42:40.000000', 'temperatura', 187.0000, 'ºC'),
	(74219, 108, '2015-03-01 00:42:41.000000', 'temperatura', 988.0000, 'ºC'),
	(74220, 108, '2015-03-01 00:42:42.000000', 'temperatura', 776.0000, 'ºC'),
	(74221, 108, '2015-03-01 00:42:43.000000', 'temperatura', 917.0000, 'ºC'),
	(74222, 108, '2015-03-01 00:42:44.000000', 'temperatura', 1057.0000, 'ºC'),
	(74223, 108, '2015-03-01 00:42:45.000000', 'temperatura', 133.0000, 'ºC'),
	(74224, 108, '2015-03-01 00:42:46.000000', 'temperatura', 1098.0000, 'ºC'),
	(74225, 108, '2015-03-01 00:42:47.000000', 'temperatura', 290.0000, 'ºC'),
	(74226, 108, '2015-03-01 00:42:48.000000', 'temperatura', 555.0000, 'ºC'),
	(74227, 108, '2015-03-01 00:42:49.000000', 'temperatura', 708.0000, 'ºC'),
	(74228, 108, '2015-03-01 00:42:50.000000', 'temperatura', 676.0000, 'ºC'),
	(74229, 108, '2015-03-01 00:42:51.000000', 'temperatura', 55.0000, 'ºC'),
	(74230, 108, '2015-03-01 00:42:52.000000', 'temperatura', 648.0000, 'ºC'),
	(74231, 108, '2015-03-01 00:42:53.000000', 'temperatura', 677.0000, 'ºC'),
	(74232, 108, '2015-03-01 00:42:54.000000', 'temperatura', 239.0000, 'ºC'),
	(74233, 108, '2015-03-01 00:42:55.000000', 'temperatura', 364.0000, 'ºC'),
	(74234, 108, '2015-03-01 00:42:56.000000', 'temperatura', 1106.0000, 'ºC'),
	(74235, 108, '2015-03-01 00:42:57.000000', 'temperatura', 839.0000, 'ºC'),
	(74236, 108, '2015-03-01 00:42:58.000000', 'temperatura', 876.0000, 'ºC'),
	(74237, 108, '2015-03-01 00:42:59.000000', 'temperatura', 662.0000, 'ºC'),
	(74238, 108, '2015-03-01 00:43:00.000000', 'temperatura', 683.0000, 'ºC'),
	(74239, 108, '2015-03-01 00:43:01.000000', 'temperatura', 228.0000, 'ºC'),
	(74240, 108, '2015-03-01 00:43:02.000000', 'temperatura', 295.0000, 'ºC'),
	(74241, 108, '2015-03-01 00:43:03.000000', 'temperatura', 788.0000, 'ºC'),
	(74242, 108, '2015-03-01 00:43:04.000000', 'temperatura', 659.0000, 'ºC'),
	(74243, 108, '2015-03-01 00:43:05.000000', 'temperatura', 929.0000, 'ºC'),
	(74244, 108, '2015-03-01 00:43:06.000000', 'temperatura', 271.0000, 'ºC'),
	(74245, 108, '2015-03-01 00:43:07.000000', 'temperatura', 967.0000, 'ºC'),
	(74246, 108, '2015-03-01 00:43:08.000000', 'temperatura', 424.0000, 'ºC'),
	(74247, 108, '2015-03-01 00:43:09.000000', 'temperatura', 419.0000, 'ºC'),
	(74248, 108, '2015-03-01 00:43:10.000000', 'temperatura', 825.0000, 'ºC'),
	(74249, 108, '2015-03-01 00:43:11.000000', 'temperatura', 467.0000, 'ºC'),
	(74250, 108, '2015-03-01 00:43:12.000000', 'temperatura', 1063.0000, 'ºC'),
	(74251, 108, '2015-03-01 00:43:13.000000', 'temperatura', 311.0000, 'ºC'),
	(74252, 108, '2015-03-01 00:43:14.000000', 'temperatura', 767.0000, 'ºC'),
	(74253, 108, '2015-03-01 00:43:15.000000', 'temperatura', 503.0000, 'ºC'),
	(74254, 108, '2015-03-01 00:43:16.000000', 'temperatura', 216.0000, 'ºC'),
	(74255, 108, '2015-03-01 00:43:17.000000', 'temperatura', 771.0000, 'ºC'),
	(74256, 108, '2015-03-01 00:43:18.000000', 'temperatura', 807.0000, 'ºC'),
	(74257, 108, '2015-03-01 00:43:19.000000', 'temperatura', 521.0000, 'ºC'),
	(74258, 108, '2015-03-01 00:43:20.000000', 'temperatura', 185.0000, 'ºC'),
	(74259, 108, '2015-03-01 00:43:21.000000', 'temperatura', 564.0000, 'ºC'),
	(74260, 108, '2015-03-01 00:43:22.000000', 'temperatura', 1066.0000, 'ºC'),
	(74261, 108, '2015-03-01 00:43:23.000000', 'temperatura', 37.0000, 'ºC'),
	(74262, 108, '2015-03-01 00:43:24.000000', 'temperatura', 588.0000, 'ºC'),
	(74263, 108, '2015-03-01 00:43:25.000000', 'temperatura', 428.0000, 'ºC'),
	(74264, 108, '2015-03-01 00:43:26.000000', 'temperatura', 379.0000, 'ºC'),
	(74265, 108, '2015-03-01 00:43:27.000000', 'temperatura', 611.0000, 'ºC'),
	(74266, 108, '2015-03-01 00:43:28.000000', 'temperatura', 716.0000, 'ºC'),
	(74267, 108, '2015-03-01 00:43:29.000000', 'temperatura', 551.0000, 'ºC'),
	(74268, 108, '2015-03-01 00:43:30.000000', 'temperatura', 605.0000, 'ºC'),
	(74269, 108, '2015-03-01 00:43:31.000000', 'temperatura', 174.0000, 'ºC'),
	(74270, 108, '2015-03-01 00:43:32.000000', 'temperatura', 254.0000, 'ºC'),
	(74271, 108, '2015-03-01 00:43:33.000000', 'temperatura', 751.0000, 'ºC'),
	(74272, 108, '2015-03-01 00:43:34.000000', 'temperatura', 594.0000, 'ºC'),
	(74273, 108, '2015-03-01 00:43:35.000000', 'temperatura', 714.0000, 'ºC'),
	(74274, 108, '2015-03-01 00:43:36.000000', 'temperatura', 591.0000, 'ºC'),
	(74275, 108, '2015-03-01 00:43:37.000000', 'temperatura', 812.0000, 'ºC'),
	(74276, 108, '2015-03-01 00:43:38.000000', 'temperatura', 1087.0000, 'ºC'),
	(74277, 108, '2015-03-01 00:43:39.000000', 'temperatura', 601.0000, 'ºC'),
	(74278, 108, '2015-03-01 00:43:40.000000', 'temperatura', 946.0000, 'ºC'),
	(74279, 108, '2015-03-01 00:43:41.000000', 'temperatura', 526.0000, 'ºC'),
	(74280, 108, '2015-03-01 00:43:42.000000', 'temperatura', 994.0000, 'ºC'),
	(74281, 108, '2015-03-01 00:43:43.000000', 'temperatura', 991.0000, 'ºC'),
	(74282, 108, '2015-03-01 00:43:44.000000', 'temperatura', 773.0000, 'ºC'),
	(74283, 108, '2015-03-01 00:43:45.000000', 'temperatura', 894.0000, 'ºC'),
	(74284, 108, '2015-03-01 00:43:46.000000', 'temperatura', 951.0000, 'ºC'),
	(74285, 108, '2015-03-01 00:43:47.000000', 'temperatura', 872.0000, 'ºC'),
	(74286, 108, '2015-03-01 00:43:48.000000', 'temperatura', 309.0000, 'ºC'),
	(74287, 108, '2015-03-01 00:43:49.000000', 'temperatura', 130.0000, 'ºC'),
	(74288, 108, '2015-03-01 00:43:50.000000', 'temperatura', 925.0000, 'ºC'),
	(74289, 108, '2015-03-01 00:43:51.000000', 'temperatura', 634.0000, 'ºC'),
	(74290, 108, '2015-03-01 00:43:52.000000', 'temperatura', 396.0000, 'ºC'),
	(74291, 108, '2015-03-01 00:43:53.000000', 'temperatura', 77.0000, 'ºC'),
	(74292, 108, '2015-03-01 00:43:54.000000', 'temperatura', 396.0000, 'ºC'),
	(74293, 108, '2015-03-01 00:43:55.000000', 'temperatura', 553.0000, 'ºC'),
	(74294, 108, '2015-03-01 00:43:56.000000', 'temperatura', 376.0000, 'ºC'),
	(74295, 108, '2015-03-01 00:43:57.000000', 'temperatura', 220.0000, 'ºC'),
	(74296, 108, '2015-03-01 00:43:58.000000', 'temperatura', 1172.0000, 'ºC'),
	(74297, 108, '2015-03-01 00:43:59.000000', 'temperatura', 402.0000, 'ºC'),
	(74298, 108, '2015-03-01 00:44:00.000000', 'temperatura', 893.0000, 'ºC'),
	(74299, 108, '2015-03-01 00:44:01.000000', 'temperatura', 862.0000, 'ºC'),
	(74300, 108, '2015-03-01 00:44:02.000000', 'temperatura', 432.0000, 'ºC'),
	(74301, 108, '2015-03-01 00:44:03.000000', 'temperatura', 772.0000, 'ºC'),
	(74302, 108, '2015-03-01 00:44:04.000000', 'temperatura', 164.0000, 'ºC'),
	(74303, 108, '2015-03-01 00:44:05.000000', 'temperatura', 904.0000, 'ºC'),
	(74304, 108, '2015-03-01 00:44:06.000000', 'temperatura', 431.0000, 'ºC'),
	(74305, 108, '2015-03-01 00:44:07.000000', 'temperatura', 644.0000, 'ºC'),
	(74306, 108, '2015-03-01 00:44:08.000000', 'temperatura', 727.0000, 'ºC'),
	(74307, 108, '2015-03-01 00:44:09.000000', 'temperatura', 504.0000, 'ºC'),
	(74308, 108, '2015-03-01 00:44:10.000000', 'temperatura', 338.0000, 'ºC'),
	(74309, 108, '2015-03-01 00:44:11.000000', 'temperatura', 180.0000, 'ºC'),
	(74310, 108, '2015-03-01 00:44:12.000000', 'temperatura', 1084.0000, 'ºC'),
	(74311, 108, '2015-03-01 00:44:13.000000', 'temperatura', 82.0000, 'ºC'),
	(74312, 108, '2015-03-01 00:44:14.000000', 'temperatura', 757.0000, 'ºC'),
	(74313, 108, '2015-03-01 00:44:15.000000', 'temperatura', 1139.0000, 'ºC'),
	(74314, 108, '2015-03-01 00:44:16.000000', 'temperatura', 1024.0000, 'ºC'),
	(74315, 108, '2015-03-01 00:44:17.000000', 'temperatura', 503.0000, 'ºC'),
	(74316, 108, '2015-03-01 00:44:18.000000', 'temperatura', 645.0000, 'ºC'),
	(74317, 108, '2015-03-01 00:44:19.000000', 'temperatura', 518.0000, 'ºC'),
	(74318, 108, '2015-03-01 00:44:20.000000', 'temperatura', 654.0000, 'ºC'),
	(74319, 108, '2015-03-01 00:44:21.000000', 'temperatura', 519.0000, 'ºC'),
	(74320, 108, '2015-03-01 00:44:22.000000', 'temperatura', 630.0000, 'ºC'),
	(74321, 108, '2015-03-01 00:44:23.000000', 'temperatura', 394.0000, 'ºC'),
	(74322, 108, '2015-03-01 00:44:24.000000', 'temperatura', 80.0000, 'ºC'),
	(74323, 108, '2015-03-01 00:44:25.000000', 'temperatura', 420.0000, 'ºC'),
	(74324, 108, '2015-03-01 00:44:26.000000', 'temperatura', 660.0000, 'ºC'),
	(74325, 108, '2015-03-01 00:44:27.000000', 'temperatura', 839.0000, 'ºC'),
	(74326, 108, '2015-03-01 00:44:28.000000', 'temperatura', 1018.0000, 'ºC'),
	(74327, 108, '2015-03-01 00:44:29.000000', 'temperatura', 173.0000, 'ºC'),
	(74328, 108, '2015-03-01 00:44:30.000000', 'temperatura', 209.0000, 'ºC'),
	(74329, 108, '2015-03-01 00:44:31.000000', 'temperatura', 528.0000, 'ºC'),
	(74330, 108, '2015-03-01 00:44:32.000000', 'temperatura', 815.0000, 'ºC'),
	(74331, 108, '2015-03-01 00:44:33.000000', 'temperatura', 89.0000, 'ºC'),
	(74332, 108, '2015-03-01 00:44:34.000000', 'temperatura', 403.0000, 'ºC'),
	(74333, 108, '2015-03-01 00:44:35.000000', 'temperatura', 546.0000, 'ºC'),
	(74334, 108, '2015-03-01 00:44:36.000000', 'temperatura', 324.0000, 'ºC'),
	(74335, 108, '2015-03-01 00:44:37.000000', 'temperatura', 1181.0000, 'ºC'),
	(74336, 108, '2015-03-01 00:44:38.000000', 'temperatura', 135.0000, 'ºC'),
	(74337, 108, '2015-03-01 00:44:39.000000', 'temperatura', 731.0000, 'ºC'),
	(74338, 108, '2015-03-01 00:44:40.000000', 'temperatura', 849.0000, 'ºC'),
	(74339, 108, '2015-03-01 00:44:41.000000', 'temperatura', 854.0000, 'ºC'),
	(74340, 108, '2015-03-01 00:44:42.000000', 'temperatura', 522.0000, 'ºC'),
	(74341, 108, '2015-03-01 00:44:43.000000', 'temperatura', 50.0000, 'ºC'),
	(74342, 108, '2015-03-01 00:44:44.000000', 'temperatura', 1085.0000, 'ºC'),
	(74343, 108, '2015-03-01 00:44:45.000000', 'temperatura', 476.0000, 'ºC'),
	(74344, 108, '2015-03-01 00:44:46.000000', 'temperatura', 324.0000, 'ºC'),
	(74345, 108, '2015-03-01 00:44:47.000000', 'temperatura', 191.0000, 'ºC'),
	(74346, 108, '2015-03-01 00:44:48.000000', 'temperatura', 1186.0000, 'ºC'),
	(74347, 108, '2015-03-01 00:44:49.000000', 'temperatura', 557.0000, 'ºC'),
	(74348, 108, '2015-03-01 00:44:50.000000', 'temperatura', 428.0000, 'ºC'),
	(74349, 108, '2015-03-01 00:44:51.000000', 'temperatura', 469.0000, 'ºC'),
	(74350, 108, '2015-03-01 00:44:52.000000', 'temperatura', 1062.0000, 'ºC'),
	(74351, 108, '2015-03-01 00:44:53.000000', 'temperatura', 304.0000, 'ºC'),
	(74352, 108, '2015-03-01 00:44:54.000000', 'temperatura', 733.0000, 'ºC'),
	(74353, 108, '2015-03-01 00:44:55.000000', 'temperatura', 356.0000, 'ºC'),
	(74354, 108, '2015-03-01 00:44:56.000000', 'temperatura', 780.0000, 'ºC'),
	(74355, 108, '2015-03-01 00:44:57.000000', 'temperatura', 431.0000, 'ºC'),
	(74356, 108, '2015-03-01 00:44:58.000000', 'temperatura', 1018.0000, 'ºC'),
	(74357, 108, '2015-03-01 00:44:59.000000', 'temperatura', 198.0000, 'ºC'),
	(74358, 108, '2015-03-01 00:45:00.000000', 'temperatura', 334.0000, 'ºC'),
	(74359, 108, '2015-03-01 00:45:01.000000', 'temperatura', 1079.0000, 'ºC'),
	(74360, 108, '2015-03-01 00:45:02.000000', 'temperatura', 791.0000, 'ºC'),
	(74361, 108, '2015-03-01 00:45:03.000000', 'temperatura', 721.0000, 'ºC'),
	(74362, 108, '2015-03-01 00:45:04.000000', 'temperatura', 34.0000, 'ºC'),
	(74363, 108, '2015-03-01 00:45:05.000000', 'temperatura', 404.0000, 'ºC'),
	(74364, 108, '2015-03-01 00:45:06.000000', 'temperatura', 720.0000, 'ºC'),
	(74365, 108, '2015-03-01 00:45:07.000000', 'temperatura', 1186.0000, 'ºC'),
	(74366, 108, '2015-03-01 00:45:08.000000', 'temperatura', 174.0000, 'ºC'),
	(74367, 108, '2015-03-01 00:45:09.000000', 'temperatura', 909.0000, 'ºC'),
	(74368, 108, '2015-03-01 00:45:10.000000', 'temperatura', 425.0000, 'ºC'),
	(74369, 108, '2015-03-01 00:45:11.000000', 'temperatura', 600.0000, 'ºC'),
	(74370, 108, '2015-03-01 00:45:12.000000', 'temperatura', 524.0000, 'ºC'),
	(74371, 108, '2015-03-01 00:45:13.000000', 'temperatura', 821.0000, 'ºC'),
	(74372, 108, '2015-03-01 00:45:14.000000', 'temperatura', 135.0000, 'ºC'),
	(74373, 108, '2015-03-01 00:45:15.000000', 'temperatura', 613.0000, 'ºC'),
	(74374, 108, '2015-03-01 00:45:16.000000', 'temperatura', 258.0000, 'ºC'),
	(74375, 108, '2015-03-01 00:45:17.000000', 'temperatura', 654.0000, 'ºC'),
	(74376, 108, '2015-03-01 00:45:18.000000', 'temperatura', 94.0000, 'ºC'),
	(74377, 108, '2015-03-01 00:45:19.000000', 'temperatura', 911.0000, 'ºC'),
	(74378, 108, '2015-03-01 00:45:20.000000', 'temperatura', 675.0000, 'ºC'),
	(74379, 108, '2015-03-01 00:45:21.000000', 'temperatura', 639.0000, 'ºC'),
	(74380, 108, '2015-03-01 00:45:22.000000', 'temperatura', 1170.0000, 'ºC'),
	(74381, 108, '2015-03-01 00:45:23.000000', 'temperatura', 336.0000, 'ºC'),
	(74382, 108, '2015-03-01 00:45:24.000000', 'temperatura', 570.0000, 'ºC'),
	(74383, 108, '2015-03-01 00:45:25.000000', 'temperatura', 644.0000, 'ºC'),
	(74384, 108, '2015-03-01 00:45:26.000000', 'temperatura', 310.0000, 'ºC'),
	(74385, 108, '2015-03-01 00:45:27.000000', 'temperatura', 817.0000, 'ºC'),
	(74386, 108, '2015-03-01 00:45:28.000000', 'temperatura', 754.0000, 'ºC'),
	(74387, 108, '2015-03-01 00:45:29.000000', 'temperatura', 122.0000, 'ºC'),
	(74388, 108, '2015-03-01 00:45:30.000000', 'temperatura', 746.0000, 'ºC'),
	(74389, 108, '2015-03-01 00:45:31.000000', 'temperatura', 967.0000, 'ºC'),
	(74390, 108, '2015-03-01 00:45:32.000000', 'temperatura', 198.0000, 'ºC'),
	(74391, 108, '2015-03-01 00:45:33.000000', 'temperatura', 487.0000, 'ºC'),
	(74392, 108, '2015-03-01 00:45:34.000000', 'temperatura', 644.0000, 'ºC'),
	(74393, 108, '2015-03-01 00:45:35.000000', 'temperatura', 559.0000, 'ºC'),
	(74394, 108, '2015-03-01 00:45:36.000000', 'temperatura', 864.0000, 'ºC'),
	(74395, 108, '2015-03-01 00:45:37.000000', 'temperatura', 245.0000, 'ºC'),
	(74396, 108, '2015-03-01 00:45:38.000000', 'temperatura', 1030.0000, 'ºC'),
	(74397, 108, '2015-03-01 00:45:39.000000', 'temperatura', 818.0000, 'ºC'),
	(74398, 108, '2015-03-01 00:45:40.000000', 'temperatura', 999.0000, 'ºC'),
	(74399, 108, '2015-03-01 00:45:41.000000', 'temperatura', 143.0000, 'ºC'),
	(74400, 108, '2015-03-01 00:45:42.000000', 'temperatura', 118.0000, 'ºC'),
	(74401, 108, '2015-03-01 00:45:43.000000', 'temperatura', 162.0000, 'ºC'),
	(74402, 108, '2015-03-01 00:45:44.000000', 'temperatura', 455.0000, 'ºC'),
	(74403, 108, '2015-03-01 00:45:45.000000', 'temperatura', 590.0000, 'ºC'),
	(74404, 108, '2015-03-01 00:45:46.000000', 'temperatura', 384.0000, 'ºC'),
	(74405, 108, '2015-03-01 00:45:47.000000', 'temperatura', 150.0000, 'ºC'),
	(74406, 108, '2015-03-01 00:45:48.000000', 'temperatura', 801.0000, 'ºC'),
	(74407, 108, '2015-03-01 00:45:49.000000', 'temperatura', 1153.0000, 'ºC'),
	(74408, 108, '2015-03-01 00:45:50.000000', 'temperatura', 965.0000, 'ºC'),
	(74409, 108, '2015-03-01 00:45:51.000000', 'temperatura', 167.0000, 'ºC'),
	(74410, 108, '2015-03-01 00:45:52.000000', 'temperatura', 341.0000, 'ºC'),
	(74411, 108, '2015-03-01 00:45:53.000000', 'temperatura', 2.0000, 'ºC'),
	(74412, 108, '2015-03-01 00:45:54.000000', 'temperatura', 187.0000, 'ºC'),
	(74413, 108, '2015-03-01 00:45:55.000000', 'temperatura', 930.0000, 'ºC'),
	(74414, 108, '2015-03-01 00:45:56.000000', 'temperatura', 488.0000, 'ºC'),
	(74415, 108, '2015-03-01 00:45:57.000000', 'temperatura', 852.0000, 'ºC'),
	(74416, 108, '2015-03-01 00:45:58.000000', 'temperatura', 394.0000, 'ºC'),
	(74417, 108, '2015-03-01 00:45:59.000000', 'temperatura', 617.0000, 'ºC'),
	(74418, 108, '2015-03-01 00:46:00.000000', 'temperatura', 704.0000, 'ºC'),
	(74419, 108, '2015-03-01 00:46:01.000000', 'temperatura', 468.0000, 'ºC'),
	(74420, 108, '2015-03-01 00:46:02.000000', 'temperatura', 229.0000, 'ºC'),
	(74421, 108, '2015-03-01 00:46:03.000000', 'temperatura', 943.0000, 'ºC'),
	(74422, 108, '2015-03-01 00:46:04.000000', 'temperatura', 428.0000, 'ºC'),
	(74423, 108, '2015-03-01 00:46:05.000000', 'temperatura', 510.0000, 'ºC'),
	(74424, 108, '2015-03-01 00:46:06.000000', 'temperatura', 67.0000, 'ºC'),
	(74425, 108, '2015-03-01 00:46:07.000000', 'temperatura', 8.0000, 'ºC'),
	(74426, 108, '2015-03-01 00:46:08.000000', 'temperatura', 1037.0000, 'ºC'),
	(74427, 108, '2015-03-01 00:46:09.000000', 'temperatura', 362.0000, 'ºC'),
	(74428, 108, '2015-03-01 00:46:10.000000', 'temperatura', 1098.0000, 'ºC'),
	(74429, 108, '2015-03-01 00:46:11.000000', 'temperatura', 806.0000, 'ºC'),
	(74430, 108, '2015-03-01 00:46:12.000000', 'temperatura', 737.0000, 'ºC'),
	(74431, 108, '2015-03-01 00:46:13.000000', 'temperatura', 69.0000, 'ºC'),
	(74432, 108, '2015-03-01 00:46:14.000000', 'temperatura', 533.0000, 'ºC'),
	(74433, 108, '2015-03-01 00:46:15.000000', 'temperatura', 57.0000, 'ºC'),
	(74434, 108, '2015-03-01 00:46:16.000000', 'temperatura', 1086.0000, 'ºC'),
	(74435, 108, '2015-03-01 00:46:17.000000', 'temperatura', 459.0000, 'ºC'),
	(74436, 108, '2015-03-01 00:46:18.000000', 'temperatura', 237.0000, 'ºC'),
	(74437, 108, '2015-03-01 00:46:19.000000', 'temperatura', 1008.0000, 'ºC'),
	(74438, 108, '2015-03-01 00:46:20.000000', 'temperatura', 730.0000, 'ºC'),
	(74439, 108, '2015-03-01 00:46:21.000000', 'temperatura', 626.0000, 'ºC'),
	(74440, 108, '2015-03-01 00:46:22.000000', 'temperatura', 943.0000, 'ºC'),
	(74441, 108, '2015-03-01 00:46:23.000000', 'temperatura', 436.0000, 'ºC'),
	(74442, 108, '2015-03-01 00:46:24.000000', 'temperatura', 552.0000, 'ºC'),
	(74443, 108, '2015-03-01 00:46:25.000000', 'temperatura', 251.0000, 'ºC'),
	(74444, 108, '2015-03-01 00:46:26.000000', 'temperatura', 802.0000, 'ºC'),
	(74445, 108, '2015-03-01 00:46:27.000000', 'temperatura', 856.0000, 'ºC'),
	(74446, 108, '2015-03-01 00:46:28.000000', 'temperatura', 674.0000, 'ºC'),
	(74447, 108, '2015-03-01 00:46:29.000000', 'temperatura', 805.0000, 'ºC'),
	(74448, 108, '2015-03-01 00:46:30.000000', 'temperatura', 801.0000, 'ºC'),
	(74449, 108, '2015-03-01 00:46:31.000000', 'temperatura', 389.0000, 'ºC'),
	(74450, 108, '2015-03-01 00:46:32.000000', 'temperatura', 746.0000, 'ºC'),
	(74451, 108, '2015-03-01 00:46:33.000000', 'temperatura', 160.0000, 'ºC'),
	(74452, 108, '2015-03-01 00:46:34.000000', 'temperatura', 965.0000, 'ºC'),
	(74453, 108, '2015-03-01 00:46:35.000000', 'temperatura', 743.0000, 'ºC'),
	(74454, 108, '2015-03-01 00:46:36.000000', 'temperatura', 821.0000, 'ºC'),
	(74455, 108, '2015-03-01 00:46:37.000000', 'temperatura', 678.0000, 'ºC'),
	(74456, 108, '2015-03-01 00:46:38.000000', 'temperatura', 928.0000, 'ºC'),
	(74457, 108, '2015-03-01 00:46:39.000000', 'temperatura', 205.0000, 'ºC'),
	(74458, 108, '2015-03-01 00:46:40.000000', 'temperatura', 641.0000, 'ºC'),
	(74459, 108, '2015-03-01 00:46:41.000000', 'temperatura', 189.0000, 'ºC'),
	(74460, 108, '2015-03-01 00:46:42.000000', 'temperatura', 225.0000, 'ºC'),
	(74461, 108, '2015-03-01 00:46:43.000000', 'temperatura', 558.0000, 'ºC'),
	(74462, 108, '2015-03-01 00:46:44.000000', 'temperatura', 916.0000, 'ºC'),
	(74463, 108, '2015-03-01 00:46:45.000000', 'temperatura', 505.0000, 'ºC'),
	(74464, 108, '2015-03-01 00:46:46.000000', 'temperatura', 977.0000, 'ºC'),
	(74465, 108, '2015-03-01 00:46:47.000000', 'temperatura', 970.0000, 'ºC'),
	(74466, 108, '2015-03-01 00:46:48.000000', 'temperatura', 722.0000, 'ºC'),
	(74467, 108, '2015-03-01 00:46:49.000000', 'temperatura', 700.0000, 'ºC'),
	(74468, 108, '2015-03-01 00:46:50.000000', 'temperatura', 134.0000, 'ºC'),
	(74469, 108, '2015-03-01 00:46:51.000000', 'temperatura', 970.0000, 'ºC'),
	(74470, 108, '2015-03-01 00:46:52.000000', 'temperatura', 848.0000, 'ºC'),
	(74471, 108, '2015-03-01 00:46:53.000000', 'temperatura', 130.0000, 'ºC'),
	(74472, 108, '2015-03-01 00:46:54.000000', 'temperatura', 508.0000, 'ºC'),
	(74473, 108, '2015-03-01 00:46:55.000000', 'temperatura', 950.0000, 'ºC'),
	(74474, 108, '2015-03-01 00:46:56.000000', 'temperatura', 828.0000, 'ºC'),
	(74475, 108, '2015-03-01 00:46:57.000000', 'temperatura', 89.0000, 'ºC'),
	(74476, 108, '2015-03-01 00:46:58.000000', 'temperatura', 363.0000, 'ºC'),
	(74477, 108, '2015-03-01 00:46:59.000000', 'temperatura', 346.0000, 'ºC'),
	(74478, 108, '2015-03-01 00:47:00.000000', 'temperatura', 641.0000, 'ºC'),
	(74479, 108, '2015-03-01 00:47:01.000000', 'temperatura', 969.0000, 'ºC'),
	(74480, 108, '2015-03-01 00:47:02.000000', 'temperatura', 523.0000, 'ºC'),
	(74481, 108, '2015-03-01 00:47:03.000000', 'temperatura', 908.0000, 'ºC'),
	(74482, 108, '2015-03-01 00:47:04.000000', 'temperatura', 571.0000, 'ºC'),
	(74483, 108, '2015-03-01 00:47:05.000000', 'temperatura', 132.0000, 'ºC'),
	(74484, 108, '2015-03-01 00:47:06.000000', 'temperatura', 148.0000, 'ºC'),
	(74485, 108, '2015-03-01 00:47:07.000000', 'temperatura', 344.0000, 'ºC'),
	(74486, 108, '2015-03-01 00:47:08.000000', 'temperatura', 78.0000, 'ºC'),
	(74487, 108, '2015-03-01 00:47:09.000000', 'temperatura', 559.0000, 'ºC'),
	(74488, 108, '2015-03-01 00:47:10.000000', 'temperatura', 162.0000, 'ºC'),
	(74489, 108, '2015-03-01 00:47:11.000000', 'temperatura', 334.0000, 'ºC'),
	(74490, 108, '2015-03-01 00:47:12.000000', 'temperatura', 1182.0000, 'ºC'),
	(74491, 108, '2015-03-01 00:47:13.000000', 'temperatura', 111.0000, 'ºC'),
	(74492, 108, '2015-03-01 00:47:14.000000', 'temperatura', 609.0000, 'ºC'),
	(74493, 108, '2015-03-01 00:47:15.000000', 'temperatura', 311.0000, 'ºC'),
	(74494, 108, '2015-03-01 00:47:16.000000', 'temperatura', 931.0000, 'ºC'),
	(74495, 108, '2015-03-01 00:47:17.000000', 'temperatura', 121.0000, 'ºC'),
	(74496, 108, '2015-03-01 00:47:18.000000', 'temperatura', 211.0000, 'ºC'),
	(74497, 108, '2015-03-01 00:47:19.000000', 'temperatura', 693.0000, 'ºC'),
	(74498, 108, '2015-03-01 00:47:20.000000', 'temperatura', 435.0000, 'ºC'),
	(74499, 108, '2015-03-01 00:47:21.000000', 'temperatura', 95.0000, 'ºC'),
	(74500, 108, '2015-03-01 00:47:22.000000', 'temperatura', 369.0000, 'ºC'),
	(74501, 108, '2015-03-01 00:47:23.000000', 'temperatura', 363.0000, 'ºC'),
	(74502, 108, '2015-03-01 00:47:24.000000', 'temperatura', 707.0000, 'ºC'),
	(74503, 108, '2015-03-01 00:47:25.000000', 'temperatura', 45.0000, 'ºC'),
	(74504, 108, '2015-03-01 00:47:26.000000', 'temperatura', 506.0000, 'ºC'),
	(74505, 108, '2015-03-01 00:47:27.000000', 'temperatura', 1194.0000, 'ºC'),
	(74506, 108, '2015-03-01 00:47:28.000000', 'temperatura', 855.0000, 'ºC'),
	(74507, 108, '2015-03-01 00:47:29.000000', 'temperatura', 693.0000, 'ºC'),
	(74508, 108, '2015-03-01 00:47:30.000000', 'temperatura', 901.0000, 'ºC'),
	(74509, 108, '2015-03-01 00:47:31.000000', 'temperatura', 25.0000, 'ºC'),
	(74510, 108, '2015-03-01 00:47:32.000000', 'temperatura', 1024.0000, 'ºC'),
	(74511, 108, '2015-03-01 00:47:33.000000', 'temperatura', 243.0000, 'ºC'),
	(74512, 108, '2015-03-01 00:47:34.000000', 'temperatura', 544.0000, 'ºC'),
	(74513, 108, '2015-03-01 00:47:35.000000', 'temperatura', 792.0000, 'ºC'),
	(74514, 108, '2015-03-01 00:47:36.000000', 'temperatura', 1130.0000, 'ºC'),
	(74515, 108, '2015-03-01 00:47:37.000000', 'temperatura', 873.0000, 'ºC'),
	(74516, 108, '2015-03-01 00:47:38.000000', 'temperatura', 974.0000, 'ºC'),
	(74517, 108, '2015-03-01 00:47:39.000000', 'temperatura', 1053.0000, 'ºC'),
	(74518, 108, '2015-03-01 00:47:40.000000', 'temperatura', 1141.0000, 'ºC'),
	(74519, 108, '2015-03-01 00:47:41.000000', 'temperatura', 149.0000, 'ºC'),
	(74520, 108, '2015-03-01 00:47:42.000000', 'temperatura', 923.0000, 'ºC'),
	(74521, 108, '2015-03-01 00:47:43.000000', 'temperatura', 567.0000, 'ºC'),
	(74522, 108, '2015-03-01 00:47:44.000000', 'temperatura', 67.0000, 'ºC'),
	(74523, 108, '2015-03-01 00:47:45.000000', 'temperatura', 1035.0000, 'ºC'),
	(74524, 108, '2015-03-01 00:47:46.000000', 'temperatura', 176.0000, 'ºC'),
	(74525, 108, '2015-03-01 00:47:47.000000', 'temperatura', 172.0000, 'ºC'),
	(74526, 108, '2015-03-01 00:47:48.000000', 'temperatura', 335.0000, 'ºC'),
	(74527, 108, '2015-03-01 00:47:49.000000', 'temperatura', 1158.0000, 'ºC'),
	(74528, 108, '2015-03-01 00:47:50.000000', 'temperatura', 1184.0000, 'ºC'),
	(74529, 108, '2015-03-01 00:47:51.000000', 'temperatura', 48.0000, 'ºC'),
	(74530, 108, '2015-03-01 00:47:52.000000', 'temperatura', 289.0000, 'ºC'),
	(74531, 108, '2015-03-01 00:47:53.000000', 'temperatura', 102.0000, 'ºC'),
	(74532, 108, '2015-03-01 00:47:54.000000', 'temperatura', 843.0000, 'ºC'),
	(74533, 108, '2015-03-01 00:47:55.000000', 'temperatura', 309.0000, 'ºC'),
	(74534, 108, '2015-03-01 00:47:56.000000', 'temperatura', 216.0000, 'ºC'),
	(74535, 108, '2015-03-01 00:47:57.000000', 'temperatura', 152.0000, 'ºC'),
	(74536, 108, '2015-03-01 00:47:58.000000', 'temperatura', 115.0000, 'ºC'),
	(74537, 108, '2015-03-01 00:47:59.000000', 'temperatura', 118.0000, 'ºC'),
	(74538, 108, '2015-03-01 00:48:00.000000', 'temperatura', 246.0000, 'ºC'),
	(74539, 108, '2015-03-01 00:48:01.000000', 'temperatura', 875.0000, 'ºC'),
	(74540, 108, '2015-03-01 00:48:02.000000', 'temperatura', 38.0000, 'ºC'),
	(74541, 108, '2015-03-01 00:48:03.000000', 'temperatura', 1167.0000, 'ºC'),
	(74542, 108, '2015-03-01 00:48:04.000000', 'temperatura', 921.0000, 'ºC'),
	(74543, 108, '2015-03-01 00:48:05.000000', 'temperatura', 1105.0000, 'ºC'),
	(74544, 108, '2015-03-01 00:48:06.000000', 'temperatura', 364.0000, 'ºC'),
	(74545, 108, '2015-03-01 00:48:07.000000', 'temperatura', 903.0000, 'ºC'),
	(74546, 108, '2015-03-01 00:48:08.000000', 'temperatura', 1023.0000, 'ºC'),
	(74547, 108, '2015-03-01 00:48:09.000000', 'temperatura', 9.0000, 'ºC'),
	(74548, 108, '2015-03-01 00:48:10.000000', 'temperatura', 575.0000, 'ºC'),
	(74549, 108, '2015-03-01 00:48:11.000000', 'temperatura', 450.0000, 'ºC'),
	(74550, 108, '2015-03-01 00:48:12.000000', 'temperatura', 523.0000, 'ºC'),
	(74551, 108, '2015-03-01 00:48:13.000000', 'temperatura', 67.0000, 'ºC'),
	(74552, 108, '2015-03-01 00:48:14.000000', 'temperatura', 1165.0000, 'ºC'),
	(74553, 108, '2015-03-01 00:48:15.000000', 'temperatura', 826.0000, 'ºC'),
	(74554, 108, '2015-03-01 00:48:16.000000', 'temperatura', 637.0000, 'ºC'),
	(74555, 108, '2015-03-01 00:48:17.000000', 'temperatura', 706.0000, 'ºC'),
	(74556, 108, '2015-03-01 00:48:18.000000', 'temperatura', 421.0000, 'ºC'),
	(74557, 108, '2015-03-01 00:48:19.000000', 'temperatura', 1186.0000, 'ºC'),
	(74558, 108, '2015-03-01 00:48:20.000000', 'temperatura', 1068.0000, 'ºC'),
	(74559, 108, '2015-03-01 00:48:21.000000', 'temperatura', 581.0000, 'ºC'),
	(74560, 108, '2015-03-01 00:48:22.000000', 'temperatura', 904.0000, 'ºC'),
	(74561, 108, '2015-03-01 00:48:23.000000', 'temperatura', 377.0000, 'ºC'),
	(74562, 108, '2015-03-01 00:48:24.000000', 'temperatura', 372.0000, 'ºC'),
	(74563, 108, '2015-03-01 00:48:25.000000', 'temperatura', 731.0000, 'ºC'),
	(74564, 108, '2015-03-01 00:48:26.000000', 'temperatura', 138.0000, 'ºC'),
	(74565, 108, '2015-03-01 00:48:27.000000', 'temperatura', 900.0000, 'ºC'),
	(74566, 108, '2015-03-01 00:48:28.000000', 'temperatura', 484.0000, 'ºC'),
	(74567, 108, '2015-03-01 00:48:29.000000', 'temperatura', 923.0000, 'ºC'),
	(74568, 108, '2015-03-01 00:48:30.000000', 'temperatura', 762.0000, 'ºC'),
	(74569, 108, '2015-03-01 00:48:31.000000', 'temperatura', 1041.0000, 'ºC'),
	(74570, 108, '2015-03-01 00:48:32.000000', 'temperatura', 522.0000, 'ºC'),
	(74571, 108, '2015-03-01 00:48:33.000000', 'temperatura', 685.0000, 'ºC'),
	(74572, 108, '2015-03-01 00:48:34.000000', 'temperatura', 660.0000, 'ºC'),
	(74573, 108, '2015-03-01 00:48:35.000000', 'temperatura', 46.0000, 'ºC'),
	(74574, 108, '2015-03-01 00:48:36.000000', 'temperatura', 650.0000, 'ºC'),
	(74575, 108, '2015-03-01 00:48:37.000000', 'temperatura', 713.0000, 'ºC'),
	(74576, 108, '2015-03-01 00:48:38.000000', 'temperatura', 414.0000, 'ºC'),
	(74577, 108, '2015-03-01 00:48:39.000000', 'temperatura', 1131.0000, 'ºC'),
	(74578, 108, '2015-03-01 00:48:40.000000', 'temperatura', 814.0000, 'ºC'),
	(74579, 108, '2015-03-01 00:48:41.000000', 'temperatura', 677.0000, 'ºC'),
	(74580, 108, '2015-03-01 00:48:42.000000', 'temperatura', 946.0000, 'ºC'),
	(74581, 108, '2015-03-01 00:48:43.000000', 'temperatura', 298.0000, 'ºC'),
	(74582, 108, '2015-03-01 00:48:44.000000', 'temperatura', 1053.0000, 'ºC'),
	(74583, 108, '2015-03-01 00:48:45.000000', 'temperatura', 770.0000, 'ºC'),
	(74584, 108, '2015-03-01 00:48:46.000000', 'temperatura', 691.0000, 'ºC'),
	(74585, 108, '2015-03-01 00:48:47.000000', 'temperatura', 1148.0000, 'ºC'),
	(74586, 108, '2015-03-01 00:48:48.000000', 'temperatura', 67.0000, 'ºC'),
	(74587, 108, '2015-03-01 00:48:49.000000', 'temperatura', 493.0000, 'ºC'),
	(74588, 108, '2015-03-01 00:48:50.000000', 'temperatura', 1061.0000, 'ºC'),
	(74589, 108, '2015-03-01 00:48:51.000000', 'temperatura', 230.0000, 'ºC'),
	(74590, 108, '2015-03-01 00:48:52.000000', 'temperatura', 366.0000, 'ºC'),
	(74591, 108, '2015-03-01 00:48:53.000000', 'temperatura', 1140.0000, 'ºC'),
	(74592, 108, '2015-03-01 00:48:54.000000', 'temperatura', 1004.0000, 'ºC'),
	(74593, 108, '2015-03-01 00:48:55.000000', 'temperatura', 398.0000, 'ºC'),
	(74594, 108, '2015-03-01 00:48:56.000000', 'temperatura', 180.0000, 'ºC'),
	(74595, 108, '2015-03-01 00:48:57.000000', 'temperatura', 906.0000, 'ºC'),
	(74596, 108, '2015-03-01 00:48:58.000000', 'temperatura', 391.0000, 'ºC'),
	(74597, 108, '2015-03-01 00:48:59.000000', 'temperatura', 439.0000, 'ºC'),
	(74598, 108, '2015-03-01 00:49:00.000000', 'temperatura', 1023.0000, 'ºC'),
	(74599, 108, '2015-03-01 00:49:01.000000', 'temperatura', 198.0000, 'ºC'),
	(74600, 108, '2015-03-01 00:49:02.000000', 'temperatura', 321.0000, 'ºC'),
	(74601, 108, '2015-03-01 00:49:03.000000', 'temperatura', 1013.0000, 'ºC'),
	(74602, 108, '2015-03-01 00:49:04.000000', 'temperatura', 499.0000, 'ºC'),
	(74603, 108, '2015-03-01 00:49:05.000000', 'temperatura', 660.0000, 'ºC'),
	(74604, 108, '2015-03-01 00:49:06.000000', 'temperatura', 601.0000, 'ºC'),
	(74605, 108, '2015-03-01 00:49:07.000000', 'temperatura', 1027.0000, 'ºC'),
	(74606, 108, '2015-03-01 00:49:08.000000', 'temperatura', 932.0000, 'ºC'),
	(74607, 108, '2015-03-01 00:49:09.000000', 'temperatura', 379.0000, 'ºC'),
	(74608, 108, '2015-03-01 00:49:10.000000', 'temperatura', 301.0000, 'ºC'),
	(74609, 108, '2015-03-01 00:49:11.000000', 'temperatura', 367.0000, 'ºC'),
	(74610, 108, '2015-03-01 00:49:12.000000', 'temperatura', 933.0000, 'ºC'),
	(74611, 108, '2015-03-01 00:49:13.000000', 'temperatura', 1163.0000, 'ºC'),
	(74612, 108, '2015-03-01 00:49:14.000000', 'temperatura', 616.0000, 'ºC'),
	(74613, 108, '2015-03-01 00:49:15.000000', 'temperatura', 790.0000, 'ºC'),
	(74614, 108, '2015-03-01 00:49:16.000000', 'temperatura', 906.0000, 'ºC'),
	(74615, 108, '2015-03-01 00:49:17.000000', 'temperatura', 961.0000, 'ºC'),
	(74616, 108, '2015-03-01 00:49:18.000000', 'temperatura', 887.0000, 'ºC'),
	(74617, 108, '2015-03-01 00:49:19.000000', 'temperatura', 353.0000, 'ºC'),
	(74618, 108, '2015-03-01 00:49:20.000000', 'temperatura', 303.0000, 'ºC'),
	(74619, 108, '2015-03-01 00:49:21.000000', 'temperatura', 459.0000, 'ºC'),
	(74620, 108, '2015-03-01 00:49:22.000000', 'temperatura', 185.0000, 'ºC'),
	(74621, 108, '2015-03-01 00:49:23.000000', 'temperatura', 748.0000, 'ºC'),
	(74622, 108, '2015-03-01 00:49:24.000000', 'temperatura', 785.0000, 'ºC'),
	(74623, 108, '2015-03-01 00:49:25.000000', 'temperatura', 481.0000, 'ºC'),
	(74624, 108, '2015-03-01 00:49:26.000000', 'temperatura', 49.0000, 'ºC'),
	(74625, 108, '2015-03-01 00:49:27.000000', 'temperatura', 5.0000, 'ºC'),
	(74626, 108, '2015-03-01 00:49:28.000000', 'temperatura', 1080.0000, 'ºC'),
	(74627, 108, '2015-03-01 00:49:29.000000', 'temperatura', 582.0000, 'ºC'),
	(74628, 108, '2015-03-01 00:49:30.000000', 'temperatura', 873.0000, 'ºC'),
	(74629, 108, '2015-03-01 00:49:31.000000', 'temperatura', 220.0000, 'ºC'),
	(74630, 108, '2015-03-01 00:49:32.000000', 'temperatura', 883.0000, 'ºC'),
	(74631, 108, '2015-03-01 00:49:33.000000', 'temperatura', 152.0000, 'ºC'),
	(74632, 108, '2015-03-01 00:49:34.000000', 'temperatura', 513.0000, 'ºC'),
	(74633, 108, '2015-03-01 00:49:35.000000', 'temperatura', 911.0000, 'ºC'),
	(74634, 108, '2015-03-01 00:49:36.000000', 'temperatura', 616.0000, 'ºC'),
	(74635, 108, '2015-03-01 00:49:37.000000', 'temperatura', 346.0000, 'ºC'),
	(74636, 108, '2015-03-01 00:49:38.000000', 'temperatura', 1084.0000, 'ºC'),
	(74637, 108, '2015-03-01 00:49:39.000000', 'temperatura', 781.0000, 'ºC'),
	(74638, 108, '2015-03-01 00:49:40.000000', 'temperatura', 655.0000, 'ºC'),
	(74639, 108, '2015-03-01 00:49:41.000000', 'temperatura', 933.0000, 'ºC'),
	(74640, 108, '2015-03-01 00:49:42.000000', 'temperatura', 300.0000, 'ºC'),
	(74641, 108, '2015-03-01 00:49:43.000000', 'temperatura', 1102.0000, 'ºC'),
	(74642, 108, '2015-03-01 00:49:44.000000', 'temperatura', 1011.0000, 'ºC'),
	(74643, 108, '2015-03-01 00:49:45.000000', 'temperatura', 549.0000, 'ºC'),
	(74644, 108, '2015-03-01 00:49:46.000000', 'temperatura', 911.0000, 'ºC'),
	(74645, 108, '2015-03-01 00:49:47.000000', 'temperatura', 511.0000, 'ºC'),
	(74646, 108, '2015-03-01 00:49:48.000000', 'temperatura', 1020.0000, 'ºC'),
	(74647, 108, '2015-03-01 00:49:49.000000', 'temperatura', 1171.0000, 'ºC'),
	(74648, 108, '2015-03-01 00:49:50.000000', 'temperatura', 392.0000, 'ºC'),
	(74649, 108, '2015-03-01 00:49:51.000000', 'temperatura', 848.0000, 'ºC'),
	(74650, 108, '2015-03-01 00:49:52.000000', 'temperatura', 665.0000, 'ºC'),
	(74651, 108, '2015-03-01 00:49:53.000000', 'temperatura', 783.0000, 'ºC'),
	(74652, 108, '2015-03-01 00:49:54.000000', 'temperatura', 719.0000, 'ºC'),
	(74653, 108, '2015-03-01 00:49:55.000000', 'temperatura', 47.0000, 'ºC'),
	(74654, 108, '2015-03-01 00:49:56.000000', 'temperatura', 478.0000, 'ºC'),
	(74655, 108, '2015-03-01 00:49:57.000000', 'temperatura', 1051.0000, 'ºC'),
	(74656, 108, '2015-03-01 00:49:58.000000', 'temperatura', 220.0000, 'ºC'),
	(74657, 108, '2015-03-01 00:49:59.000000', 'temperatura', 347.0000, 'ºC'),
	(74658, 108, '2015-03-01 00:50:00.000000', 'temperatura', 1074.0000, 'ºC'),
	(74659, 108, '2015-03-01 00:50:01.000000', 'temperatura', 733.0000, 'ºC'),
	(74660, 108, '2015-03-01 00:50:02.000000', 'temperatura', 441.0000, 'ºC'),
	(74661, 108, '2015-03-01 00:50:03.000000', 'temperatura', 6.0000, 'ºC'),
	(74662, 108, '2015-03-01 00:50:04.000000', 'temperatura', 1110.0000, 'ºC'),
	(74663, 108, '2015-03-01 00:50:05.000000', 'temperatura', 731.0000, 'ºC'),
	(74664, 108, '2015-03-01 00:50:06.000000', 'temperatura', 325.0000, 'ºC'),
	(74665, 108, '2015-03-01 00:50:07.000000', 'temperatura', 632.0000, 'ºC'),
	(74666, 108, '2015-03-01 00:50:08.000000', 'temperatura', 987.0000, 'ºC'),
	(74667, 108, '2015-03-01 00:50:09.000000', 'temperatura', 639.0000, 'ºC'),
	(74668, 108, '2015-03-01 00:50:10.000000', 'temperatura', 234.0000, 'ºC'),
	(74669, 108, '2015-03-01 00:50:11.000000', 'temperatura', 456.0000, 'ºC'),
	(74670, 108, '2015-03-01 00:50:12.000000', 'temperatura', 376.0000, 'ºC'),
	(74671, 108, '2015-03-01 00:50:13.000000', 'temperatura', 512.0000, 'ºC'),
	(74672, 108, '2015-03-01 00:50:14.000000', 'temperatura', 232.0000, 'ºC'),
	(74673, 108, '2015-03-01 00:50:15.000000', 'temperatura', 827.0000, 'ºC'),
	(74674, 108, '2015-03-01 00:50:16.000000', 'temperatura', 1036.0000, 'ºC'),
	(74675, 108, '2015-03-01 00:50:17.000000', 'temperatura', 303.0000, 'ºC'),
	(74676, 108, '2015-03-01 00:50:18.000000', 'temperatura', 806.0000, 'ºC'),
	(74677, 108, '2015-03-01 00:50:19.000000', 'temperatura', 720.0000, 'ºC'),
	(74678, 108, '2015-03-01 00:50:20.000000', 'temperatura', 1185.0000, 'ºC'),
	(74679, 108, '2015-03-01 00:50:21.000000', 'temperatura', 164.0000, 'ºC'),
	(74680, 108, '2015-03-01 00:50:22.000000', 'temperatura', 865.0000, 'ºC'),
	(74681, 108, '2015-03-01 00:50:23.000000', 'temperatura', 234.0000, 'ºC'),
	(74682, 108, '2015-03-01 00:50:24.000000', 'temperatura', 976.0000, 'ºC'),
	(74683, 108, '2015-03-01 00:50:25.000000', 'temperatura', 578.0000, 'ºC'),
	(74684, 108, '2015-03-01 00:50:26.000000', 'temperatura', 1165.0000, 'ºC'),
	(74685, 108, '2015-03-01 00:50:27.000000', 'temperatura', 489.0000, 'ºC'),
	(74686, 108, '2015-03-01 00:50:28.000000', 'temperatura', 151.0000, 'ºC'),
	(74687, 108, '2015-03-01 00:50:29.000000', 'temperatura', 488.0000, 'ºC'),
	(74688, 108, '2015-03-01 00:50:30.000000', 'temperatura', 790.0000, 'ºC'),
	(74689, 108, '2015-03-01 00:50:31.000000', 'temperatura', 84.0000, 'ºC'),
	(74690, 108, '2015-03-01 00:50:32.000000', 'temperatura', 452.0000, 'ºC'),
	(74691, 108, '2015-03-01 00:50:33.000000', 'temperatura', 809.0000, 'ºC'),
	(74692, 108, '2015-03-01 00:50:34.000000', 'temperatura', 288.0000, 'ºC'),
	(74693, 108, '2015-03-01 00:50:35.000000', 'temperatura', 215.0000, 'ºC'),
	(74694, 108, '2015-03-01 00:50:36.000000', 'temperatura', 213.0000, 'ºC'),
	(74695, 108, '2015-03-01 00:50:37.000000', 'temperatura', 418.0000, 'ºC'),
	(74696, 108, '2015-03-01 00:50:38.000000', 'temperatura', 252.0000, 'ºC'),
	(74697, 108, '2015-03-01 00:50:39.000000', 'temperatura', 8.0000, 'ºC'),
	(74698, 108, '2015-03-01 00:50:40.000000', 'temperatura', 484.0000, 'ºC'),
	(74699, 108, '2015-03-01 00:50:41.000000', 'temperatura', 1194.0000, 'ºC'),
	(74700, 108, '2015-03-01 00:50:42.000000', 'temperatura', 921.0000, 'ºC'),
	(74701, 108, '2015-03-01 00:50:43.000000', 'temperatura', 1021.0000, 'ºC'),
	(74702, 108, '2015-03-01 00:50:44.000000', 'temperatura', 1144.0000, 'ºC'),
	(74703, 108, '2015-03-01 00:50:45.000000', 'temperatura', 256.0000, 'ºC'),
	(74704, 108, '2015-03-01 00:50:46.000000', 'temperatura', 248.0000, 'ºC'),
	(74705, 108, '2015-03-01 00:50:47.000000', 'temperatura', 474.0000, 'ºC'),
	(74706, 108, '2015-03-01 00:50:48.000000', 'temperatura', 425.0000, 'ºC'),
	(74707, 108, '2015-03-01 00:50:49.000000', 'temperatura', 705.0000, 'ºC'),
	(74708, 108, '2015-03-01 00:50:50.000000', 'temperatura', 1049.0000, 'ºC'),
	(74709, 108, '2015-03-01 00:50:51.000000', 'temperatura', 733.0000, 'ºC'),
	(74710, 108, '2015-03-01 00:50:52.000000', 'temperatura', 516.0000, 'ºC'),
	(74711, 108, '2015-03-01 00:50:53.000000', 'temperatura', 382.0000, 'ºC'),
	(74712, 108, '2015-03-01 00:50:54.000000', 'temperatura', 364.0000, 'ºC'),
	(74713, 108, '2015-03-01 00:50:55.000000', 'temperatura', 676.0000, 'ºC'),
	(74714, 108, '2015-03-01 00:50:56.000000', 'temperatura', 1085.0000, 'ºC'),
	(74715, 108, '2015-03-01 00:50:57.000000', 'temperatura', 999.0000, 'ºC'),
	(74716, 108, '2015-03-01 00:50:58.000000', 'temperatura', 539.0000, 'ºC'),
	(74717, 108, '2015-03-01 00:50:59.000000', 'temperatura', 898.0000, 'ºC'),
	(74718, 108, '2015-03-01 00:51:00.000000', 'temperatura', 476.0000, 'ºC'),
	(74719, 108, '2015-03-01 00:51:01.000000', 'temperatura', 885.0000, 'ºC'),
	(74720, 108, '2015-03-01 00:51:02.000000', 'temperatura', 596.0000, 'ºC'),
	(74721, 108, '2015-03-01 00:51:03.000000', 'temperatura', 328.0000, 'ºC'),
	(74722, 108, '2015-03-01 00:51:04.000000', 'temperatura', 1050.0000, 'ºC'),
	(74723, 108, '2015-03-01 00:51:05.000000', 'temperatura', 666.0000, 'ºC'),
	(74724, 108, '2015-03-01 00:51:06.000000', 'temperatura', 183.0000, 'ºC'),
	(74725, 108, '2015-03-01 00:51:07.000000', 'temperatura', 118.0000, 'ºC'),
	(74726, 108, '2015-03-01 00:51:08.000000', 'temperatura', 41.0000, 'ºC'),
	(74727, 108, '2015-03-01 00:51:09.000000', 'temperatura', 1053.0000, 'ºC'),
	(74728, 108, '2015-03-01 00:51:10.000000', 'temperatura', 340.0000, 'ºC'),
	(74729, 108, '2015-03-01 00:51:11.000000', 'temperatura', 941.0000, 'ºC'),
	(74730, 108, '2015-03-01 00:51:12.000000', 'temperatura', 87.0000, 'ºC'),
	(74731, 108, '2015-03-01 00:51:13.000000', 'temperatura', 10.0000, 'ºC'),
	(74732, 108, '2015-03-01 00:51:14.000000', 'temperatura', 992.0000, 'ºC'),
	(74733, 108, '2015-03-01 00:51:15.000000', 'temperatura', 129.0000, 'ºC'),
	(74734, 108, '2015-03-01 00:51:16.000000', 'temperatura', 69.0000, 'ºC'),
	(74735, 108, '2015-03-01 00:51:17.000000', 'temperatura', 1158.0000, 'ºC'),
	(74736, 108, '2015-03-01 00:51:18.000000', 'temperatura', 783.0000, 'ºC'),
	(74737, 108, '2015-03-01 00:51:19.000000', 'temperatura', 442.0000, 'ºC'),
	(74738, 108, '2015-03-01 00:51:20.000000', 'temperatura', 1063.0000, 'ºC'),
	(74739, 108, '2015-03-01 00:51:21.000000', 'temperatura', 390.0000, 'ºC'),
	(74740, 108, '2015-03-01 00:51:22.000000', 'temperatura', 1160.0000, 'ºC'),
	(74741, 108, '2015-03-01 00:51:23.000000', 'temperatura', 1033.0000, 'ºC'),
	(74742, 108, '2015-03-01 00:51:24.000000', 'temperatura', 483.0000, 'ºC'),
	(74743, 108, '2015-03-01 00:51:25.000000', 'temperatura', 515.0000, 'ºC'),
	(74744, 108, '2015-03-01 00:51:26.000000', 'temperatura', 1128.0000, 'ºC'),
	(74745, 108, '2015-03-01 00:51:27.000000', 'temperatura', 498.0000, 'ºC'),
	(74746, 108, '2015-03-01 00:51:28.000000', 'temperatura', 303.0000, 'ºC'),
	(74747, 108, '2015-03-01 00:51:29.000000', 'temperatura', 21.0000, 'ºC'),
	(74748, 108, '2015-03-01 00:51:30.000000', 'temperatura', 398.0000, 'ºC'),
	(74749, 108, '2015-03-01 00:51:31.000000', 'temperatura', 729.0000, 'ºC'),
	(74750, 108, '2015-03-01 00:51:32.000000', 'temperatura', 52.0000, 'ºC'),
	(74751, 108, '2015-03-01 00:51:33.000000', 'temperatura', 473.0000, 'ºC'),
	(74752, 108, '2015-03-01 00:51:34.000000', 'temperatura', 1008.0000, 'ºC'),
	(74753, 108, '2015-03-01 00:51:35.000000', 'temperatura', 23.0000, 'ºC'),
	(74754, 108, '2015-03-01 00:51:36.000000', 'temperatura', 691.0000, 'ºC'),
	(74755, 108, '2015-03-01 00:51:37.000000', 'temperatura', 985.0000, 'ºC'),
	(74756, 108, '2015-03-01 00:51:38.000000', 'temperatura', 453.0000, 'ºC'),
	(74757, 108, '2015-03-01 00:51:39.000000', 'temperatura', 513.0000, 'ºC'),
	(74758, 108, '2015-03-01 00:51:40.000000', 'temperatura', 5.0000, 'ºC'),
	(74759, 108, '2015-03-01 00:51:41.000000', 'temperatura', 885.0000, 'ºC'),
	(74760, 108, '2015-03-01 00:51:42.000000', 'temperatura', 812.0000, 'ºC'),
	(74761, 108, '2015-03-01 00:51:43.000000', 'temperatura', 204.0000, 'ºC'),
	(74762, 108, '2015-03-01 00:51:44.000000', 'temperatura', 985.0000, 'ºC'),
	(74763, 108, '2015-03-01 00:51:45.000000', 'temperatura', 714.0000, 'ºC'),
	(74764, 108, '2015-03-01 00:51:46.000000', 'temperatura', 615.0000, 'ºC'),
	(74765, 108, '2015-03-01 00:51:47.000000', 'temperatura', 933.0000, 'ºC'),
	(74766, 108, '2015-03-01 00:51:48.000000', 'temperatura', 420.0000, 'ºC'),
	(74767, 108, '2015-03-01 00:51:49.000000', 'temperatura', 504.0000, 'ºC'),
	(74768, 108, '2015-03-01 00:51:50.000000', 'temperatura', 57.0000, 'ºC'),
	(74769, 108, '2015-03-01 00:51:51.000000', 'temperatura', 1177.0000, 'ºC'),
	(74770, 108, '2015-03-01 00:51:52.000000', 'temperatura', 914.0000, 'ºC'),
	(74771, 108, '2015-03-01 00:51:53.000000', 'temperatura', 1037.0000, 'ºC'),
	(74772, 108, '2015-03-01 00:51:54.000000', 'temperatura', 44.0000, 'ºC'),
	(74773, 108, '2015-03-01 00:51:55.000000', 'temperatura', 710.0000, 'ºC'),
	(74774, 108, '2015-03-01 00:51:56.000000', 'temperatura', 1018.0000, 'ºC'),
	(74775, 108, '2015-03-01 00:51:57.000000', 'temperatura', 560.0000, 'ºC'),
	(74776, 108, '2015-03-01 00:51:58.000000', 'temperatura', 949.0000, 'ºC'),
	(74777, 108, '2015-03-01 00:51:59.000000', 'temperatura', 663.0000, 'ºC'),
	(74778, 108, '2015-03-01 00:52:00.000000', 'temperatura', 470.0000, 'ºC'),
	(74779, 108, '2015-03-01 00:52:01.000000', 'temperatura', 362.0000, 'ºC'),
	(74780, 108, '2015-03-01 00:52:02.000000', 'temperatura', 399.0000, 'ºC'),
	(74781, 108, '2015-03-01 00:52:03.000000', 'temperatura', 909.0000, 'ºC'),
	(74782, 108, '2015-03-01 00:52:04.000000', 'temperatura', 949.0000, 'ºC'),
	(74783, 108, '2015-03-01 00:52:05.000000', 'temperatura', 820.0000, 'ºC'),
	(74784, 108, '2015-03-01 00:52:06.000000', 'temperatura', 53.0000, 'ºC'),
	(74785, 108, '2015-03-01 00:52:07.000000', 'temperatura', 203.0000, 'ºC'),
	(74786, 108, '2015-03-01 00:52:08.000000', 'temperatura', 859.0000, 'ºC'),
	(74787, 108, '2015-03-01 00:52:09.000000', 'temperatura', 85.0000, 'ºC'),
	(74788, 108, '2015-03-01 00:52:10.000000', 'temperatura', 251.0000, 'ºC'),
	(74789, 108, '2015-03-01 00:52:11.000000', 'temperatura', 1000.0000, 'ºC'),
	(74790, 108, '2015-03-01 00:52:12.000000', 'temperatura', 647.0000, 'ºC'),
	(74791, 108, '2015-03-01 00:52:13.000000', 'temperatura', 234.0000, 'ºC'),
	(74792, 108, '2015-03-01 00:52:14.000000', 'temperatura', 429.0000, 'ºC'),
	(74793, 108, '2015-03-01 00:52:15.000000', 'temperatura', 244.0000, 'ºC'),
	(74794, 108, '2015-03-01 00:52:16.000000', 'temperatura', 1133.0000, 'ºC'),
	(74795, 108, '2015-03-01 00:52:17.000000', 'temperatura', 135.0000, 'ºC'),
	(74796, 108, '2015-03-01 00:52:18.000000', 'temperatura', 878.0000, 'ºC'),
	(74797, 108, '2015-03-01 00:52:19.000000', 'temperatura', 383.0000, 'ºC'),
	(74798, 108, '2015-03-01 00:52:20.000000', 'temperatura', 483.0000, 'ºC'),
	(74799, 108, '2015-03-01 00:52:21.000000', 'temperatura', 66.0000, 'ºC'),
	(74800, 108, '2015-03-01 00:52:22.000000', 'temperatura', 82.0000, 'ºC'),
	(74801, 108, '2015-03-01 00:52:23.000000', 'temperatura', 211.0000, 'ºC'),
	(74802, 108, '2015-03-01 00:52:24.000000', 'temperatura', 809.0000, 'ºC'),
	(74803, 108, '2015-03-01 00:52:25.000000', 'temperatura', 1015.0000, 'ºC'),
	(74804, 108, '2015-03-01 00:52:26.000000', 'temperatura', 247.0000, 'ºC'),
	(74805, 108, '2015-03-01 00:52:27.000000', 'temperatura', 592.0000, 'ºC'),
	(74806, 108, '2015-03-01 00:52:28.000000', 'temperatura', 1018.0000, 'ºC'),
	(74807, 108, '2015-03-01 00:52:29.000000', 'temperatura', 915.0000, 'ºC'),
	(74808, 108, '2015-03-01 00:52:30.000000', 'temperatura', 320.0000, 'ºC'),
	(74809, 108, '2015-03-01 00:52:31.000000', 'temperatura', 55.0000, 'ºC'),
	(74810, 108, '2015-03-01 00:52:32.000000', 'temperatura', 516.0000, 'ºC'),
	(74811, 108, '2015-03-01 00:52:33.000000', 'temperatura', 17.0000, 'ºC'),
	(74812, 108, '2015-03-01 00:52:34.000000', 'temperatura', 935.0000, 'ºC'),
	(74813, 108, '2015-03-01 00:52:35.000000', 'temperatura', 1025.0000, 'ºC'),
	(74814, 108, '2015-03-01 00:52:36.000000', 'temperatura', 1123.0000, 'ºC'),
	(74815, 108, '2015-03-01 00:52:37.000000', 'temperatura', 139.0000, 'ºC'),
	(74816, 108, '2015-03-01 00:52:38.000000', 'temperatura', 925.0000, 'ºC'),
	(74817, 108, '2015-03-01 00:52:39.000000', 'temperatura', 610.0000, 'ºC'),
	(74818, 108, '2015-03-01 00:52:40.000000', 'temperatura', 277.0000, 'ºC'),
	(74819, 108, '2015-03-01 00:52:41.000000', 'temperatura', 752.0000, 'ºC'),
	(74820, 108, '2015-03-01 00:52:42.000000', 'temperatura', 533.0000, 'ºC'),
	(74821, 108, '2015-03-01 00:52:43.000000', 'temperatura', 407.0000, 'ºC'),
	(74822, 108, '2015-03-01 00:52:44.000000', 'temperatura', 439.0000, 'ºC'),
	(74823, 108, '2015-03-01 00:52:45.000000', 'temperatura', 974.0000, 'ºC'),
	(74824, 108, '2015-03-01 00:52:46.000000', 'temperatura', 1152.0000, 'ºC'),
	(74825, 108, '2015-03-01 00:52:47.000000', 'temperatura', 439.0000, 'ºC'),
	(74826, 108, '2015-03-01 00:52:48.000000', 'temperatura', 1138.0000, 'ºC'),
	(74827, 108, '2015-03-01 00:52:49.000000', 'temperatura', 776.0000, 'ºC'),
	(74828, 108, '2015-03-01 00:52:50.000000', 'temperatura', 464.0000, 'ºC'),
	(74829, 108, '2015-03-01 00:52:51.000000', 'temperatura', 1193.0000, 'ºC'),
	(74830, 108, '2015-03-01 00:52:52.000000', 'temperatura', 975.0000, 'ºC'),
	(74831, 108, '2015-03-01 00:52:53.000000', 'temperatura', 97.0000, 'ºC'),
	(74832, 108, '2015-03-01 00:52:54.000000', 'temperatura', 1159.0000, 'ºC'),
	(74833, 108, '2015-03-01 00:52:55.000000', 'temperatura', 704.0000, 'ºC'),
	(74834, 108, '2015-03-01 00:52:56.000000', 'temperatura', 45.0000, 'ºC'),
	(74835, 108, '2015-03-01 00:52:57.000000', 'temperatura', 512.0000, 'ºC'),
	(74836, 108, '2015-03-01 00:52:58.000000', 'temperatura', 25.0000, 'ºC'),
	(74837, 108, '2015-03-01 00:52:59.000000', 'temperatura', 992.0000, 'ºC'),
	(74838, 108, '2015-03-01 00:53:00.000000', 'temperatura', 86.0000, 'ºC'),
	(74839, 108, '2015-03-01 00:53:01.000000', 'temperatura', 1053.0000, 'ºC'),
	(74840, 108, '2015-03-01 00:53:02.000000', 'temperatura', 207.0000, 'ºC'),
	(74841, 108, '2015-03-01 00:53:03.000000', 'temperatura', 277.0000, 'ºC'),
	(74842, 108, '2015-03-01 00:53:04.000000', 'temperatura', 763.0000, 'ºC'),
	(74843, 108, '2015-03-01 00:53:05.000000', 'temperatura', 587.0000, 'ºC'),
	(74844, 108, '2015-03-01 00:53:06.000000', 'temperatura', 645.0000, 'ºC'),
	(74845, 108, '2015-03-01 00:53:07.000000', 'temperatura', 264.0000, 'ºC'),
	(74846, 108, '2015-03-01 00:53:08.000000', 'temperatura', 586.0000, 'ºC'),
	(74847, 108, '2015-03-01 00:53:09.000000', 'temperatura', 937.0000, 'ºC'),
	(74848, 108, '2015-03-01 00:53:10.000000', 'temperatura', 528.0000, 'ºC'),
	(74849, 108, '2015-03-01 00:53:11.000000', 'temperatura', 1028.0000, 'ºC'),
	(74850, 108, '2015-03-01 00:53:12.000000', 'temperatura', 1158.0000, 'ºC'),
	(74851, 108, '2015-03-01 00:53:13.000000', 'temperatura', 307.0000, 'ºC'),
	(74852, 108, '2015-03-01 00:53:14.000000', 'temperatura', 463.0000, 'ºC'),
	(74853, 108, '2015-03-01 00:53:15.000000', 'temperatura', 192.0000, 'ºC'),
	(74854, 108, '2015-03-01 00:53:16.000000', 'temperatura', 772.0000, 'ºC'),
	(74855, 108, '2015-03-01 00:53:17.000000', 'temperatura', 886.0000, 'ºC'),
	(74856, 108, '2015-03-01 00:53:18.000000', 'temperatura', 914.0000, 'ºC'),
	(74857, 108, '2015-03-01 00:53:19.000000', 'temperatura', 713.0000, 'ºC'),
	(74858, 108, '2015-03-01 00:53:20.000000', 'temperatura', 823.0000, 'ºC'),
	(74859, 108, '2015-03-01 00:53:21.000000', 'temperatura', 777.0000, 'ºC'),
	(74860, 108, '2015-03-01 00:53:22.000000', 'temperatura', 215.0000, 'ºC'),
	(74861, 108, '2015-03-01 00:53:23.000000', 'temperatura', 1146.0000, 'ºC'),
	(74862, 108, '2015-03-01 00:53:24.000000', 'temperatura', 285.0000, 'ºC'),
	(74863, 108, '2015-03-01 00:53:25.000000', 'temperatura', 389.0000, 'ºC'),
	(74864, 108, '2015-03-01 00:53:26.000000', 'temperatura', 1090.0000, 'ºC'),
	(74865, 108, '2015-03-01 00:53:27.000000', 'temperatura', 684.0000, 'ºC'),
	(74866, 108, '2015-03-01 00:53:28.000000', 'temperatura', 150.0000, 'ºC'),
	(74867, 108, '2015-03-01 00:53:29.000000', 'temperatura', 1098.0000, 'ºC'),
	(74868, 108, '2015-03-01 00:53:30.000000', 'temperatura', 239.0000, 'ºC'),
	(74869, 108, '2015-03-01 00:53:31.000000', 'temperatura', 303.0000, 'ºC'),
	(74870, 108, '2015-03-01 00:53:32.000000', 'temperatura', 799.0000, 'ºC'),
	(74871, 108, '2015-03-01 00:53:33.000000', 'temperatura', 686.0000, 'ºC'),
	(74872, 108, '2015-03-01 00:53:34.000000', 'temperatura', 1034.0000, 'ºC'),
	(74873, 108, '2015-03-01 00:53:35.000000', 'temperatura', 713.0000, 'ºC'),
	(74874, 108, '2015-03-01 00:53:36.000000', 'temperatura', 462.0000, 'ºC'),
	(74875, 108, '2015-03-01 00:53:37.000000', 'temperatura', 173.0000, 'ºC'),
	(74876, 108, '2015-03-01 00:53:38.000000', 'temperatura', 678.0000, 'ºC'),
	(74877, 108, '2015-03-01 00:53:39.000000', 'temperatura', 472.0000, 'ºC'),
	(74878, 108, '2015-03-01 00:53:40.000000', 'temperatura', 326.0000, 'ºC'),
	(74879, 108, '2015-03-01 00:53:41.000000', 'temperatura', 217.0000, 'ºC'),
	(74880, 108, '2015-03-01 00:53:42.000000', 'temperatura', 105.0000, 'ºC'),
	(74881, 108, '2015-03-01 00:53:43.000000', 'temperatura', 1076.0000, 'ºC'),
	(74882, 108, '2015-03-01 00:53:44.000000', 'temperatura', 267.0000, 'ºC'),
	(74883, 108, '2015-03-01 00:53:45.000000', 'temperatura', 506.0000, 'ºC'),
	(74884, 108, '2015-03-01 00:53:46.000000', 'temperatura', 530.0000, 'ºC'),
	(74885, 108, '2015-03-01 00:53:47.000000', 'temperatura', 1132.0000, 'ºC'),
	(74886, 108, '2015-03-01 00:53:48.000000', 'temperatura', 472.0000, 'ºC'),
	(74887, 108, '2015-03-01 00:53:49.000000', 'temperatura', 163.0000, 'ºC'),
	(74888, 108, '2015-03-01 00:53:50.000000', 'temperatura', 601.0000, 'ºC'),
	(74889, 108, '2015-03-01 00:53:51.000000', 'temperatura', 116.0000, 'ºC'),
	(74890, 108, '2015-03-01 00:53:52.000000', 'temperatura', 1178.0000, 'ºC'),
	(74891, 108, '2015-03-01 00:53:53.000000', 'temperatura', 740.0000, 'ºC'),
	(74892, 108, '2015-03-01 00:53:54.000000', 'temperatura', 168.0000, 'ºC'),
	(74893, 108, '2015-03-01 00:53:55.000000', 'temperatura', 1020.0000, 'ºC'),
	(74894, 108, '2015-03-01 00:53:56.000000', 'temperatura', 997.0000, 'ºC'),
	(74895, 108, '2015-03-01 00:53:57.000000', 'temperatura', 726.0000, 'ºC'),
	(74896, 108, '2015-03-01 00:53:58.000000', 'temperatura', 637.0000, 'ºC'),
	(74897, 108, '2015-03-01 00:53:59.000000', 'temperatura', 1010.0000, 'ºC'),
	(74898, 108, '2015-03-01 00:54:00.000000', 'temperatura', 738.0000, 'ºC'),
	(74899, 108, '2015-03-01 00:54:01.000000', 'temperatura', 662.0000, 'ºC'),
	(74900, 108, '2015-03-01 00:54:02.000000', 'temperatura', 1097.0000, 'ºC'),
	(74901, 108, '2015-03-01 00:54:03.000000', 'temperatura', 1099.0000, 'ºC'),
	(74902, 108, '2015-03-01 00:54:04.000000', 'temperatura', 1002.0000, 'ºC'),
	(74903, 108, '2015-03-01 00:54:05.000000', 'temperatura', 517.0000, 'ºC'),
	(74904, 108, '2015-03-01 00:54:06.000000', 'temperatura', 779.0000, 'ºC'),
	(74905, 108, '2015-03-01 00:54:07.000000', 'temperatura', 1143.0000, 'ºC'),
	(74906, 108, '2015-03-01 00:54:08.000000', 'temperatura', 981.0000, 'ºC'),
	(74907, 108, '2015-03-01 00:54:09.000000', 'temperatura', 274.0000, 'ºC'),
	(74908, 108, '2015-03-01 00:54:10.000000', 'temperatura', 828.0000, 'ºC'),
	(74909, 108, '2015-03-01 00:54:11.000000', 'temperatura', 920.0000, 'ºC'),
	(74910, 108, '2015-03-01 00:54:12.000000', 'temperatura', 918.0000, 'ºC'),
	(74911, 108, '2015-03-01 00:54:13.000000', 'temperatura', 627.0000, 'ºC'),
	(74912, 108, '2015-03-01 00:54:14.000000', 'temperatura', 382.0000, 'ºC'),
	(74913, 108, '2015-03-01 00:54:15.000000', 'temperatura', 31.0000, 'ºC'),
	(74914, 108, '2015-03-01 00:54:16.000000', 'temperatura', 211.0000, 'ºC'),
	(74915, 108, '2015-03-01 00:54:17.000000', 'temperatura', 960.0000, 'ºC'),
	(74916, 108, '2015-03-01 00:54:18.000000', 'temperatura', 568.0000, 'ºC'),
	(74917, 108, '2015-03-01 00:54:19.000000', 'temperatura', 1160.0000, 'ºC'),
	(74918, 108, '2015-03-01 00:54:20.000000', 'temperatura', 497.0000, 'ºC'),
	(74919, 108, '2015-03-01 00:54:21.000000', 'temperatura', 206.0000, 'ºC'),
	(74920, 108, '2015-03-01 00:54:22.000000', 'temperatura', 741.0000, 'ºC'),
	(74921, 108, '2015-03-01 00:54:23.000000', 'temperatura', 687.0000, 'ºC'),
	(74922, 108, '2015-03-01 00:54:24.000000', 'temperatura', 10.0000, 'ºC'),
	(74923, 108, '2015-03-01 00:54:25.000000', 'temperatura', 390.0000, 'ºC'),
	(74924, 108, '2015-03-01 00:54:26.000000', 'temperatura', 722.0000, 'ºC'),
	(74925, 108, '2015-03-01 00:54:27.000000', 'temperatura', 40.0000, 'ºC'),
	(74926, 108, '2015-03-01 00:54:28.000000', 'temperatura', 435.0000, 'ºC'),
	(74927, 108, '2015-03-01 00:54:29.000000', 'temperatura', 857.0000, 'ºC'),
	(74928, 108, '2015-03-01 00:54:30.000000', 'temperatura', 579.0000, 'ºC'),
	(74929, 108, '2015-03-01 00:54:31.000000', 'temperatura', 324.0000, 'ºC'),
	(74930, 108, '2015-03-01 00:54:32.000000', 'temperatura', 1084.0000, 'ºC'),
	(74931, 108, '2015-03-01 00:54:33.000000', 'temperatura', 850.0000, 'ºC'),
	(74932, 108, '2015-03-01 00:54:34.000000', 'temperatura', 996.0000, 'ºC'),
	(74933, 108, '2015-03-01 00:54:35.000000', 'temperatura', 33.0000, 'ºC'),
	(74934, 108, '2015-03-01 00:54:36.000000', 'temperatura', 778.0000, 'ºC'),
	(74935, 108, '2015-03-01 00:54:37.000000', 'temperatura', 190.0000, 'ºC'),
	(74936, 108, '2015-03-01 00:54:38.000000', 'temperatura', 1018.0000, 'ºC'),
	(74937, 108, '2015-03-01 00:54:39.000000', 'temperatura', 918.0000, 'ºC'),
	(74938, 108, '2015-03-01 00:54:40.000000', 'temperatura', 338.0000, 'ºC'),
	(74939, 108, '2015-03-01 00:54:41.000000', 'temperatura', 136.0000, 'ºC'),
	(74940, 108, '2015-03-01 00:54:42.000000', 'temperatura', 868.0000, 'ºC'),
	(74941, 108, '2015-03-01 00:54:43.000000', 'temperatura', 330.0000, 'ºC'),
	(74942, 108, '2015-03-01 00:54:44.000000', 'temperatura', 249.0000, 'ºC'),
	(74943, 108, '2015-03-01 00:54:45.000000', 'temperatura', 255.0000, 'ºC'),
	(74944, 108, '2015-03-01 00:54:46.000000', 'temperatura', 526.0000, 'ºC'),
	(74945, 108, '2015-03-01 00:54:47.000000', 'temperatura', 667.0000, 'ºC'),
	(74946, 108, '2015-03-01 00:54:48.000000', 'temperatura', 559.0000, 'ºC'),
	(74947, 108, '2015-03-01 00:54:49.000000', 'temperatura', 793.0000, 'ºC'),
	(74948, 108, '2015-03-01 00:54:50.000000', 'temperatura', 1089.0000, 'ºC'),
	(74949, 108, '2015-03-01 00:54:51.000000', 'temperatura', 665.0000, 'ºC'),
	(74950, 108, '2015-03-01 00:54:52.000000', 'temperatura', 58.0000, 'ºC'),
	(74951, 108, '2015-03-01 00:54:53.000000', 'temperatura', 695.0000, 'ºC'),
	(74952, 108, '2015-03-01 00:54:54.000000', 'temperatura', 903.0000, 'ºC'),
	(74953, 108, '2015-03-01 00:54:55.000000', 'temperatura', 32.0000, 'ºC'),
	(74954, 108, '2015-03-01 00:54:56.000000', 'temperatura', 1050.0000, 'ºC'),
	(74955, 108, '2015-03-01 00:54:57.000000', 'temperatura', 356.0000, 'ºC'),
	(74956, 108, '2015-03-01 00:54:58.000000', 'temperatura', 1028.0000, 'ºC'),
	(74957, 108, '2015-03-01 00:54:59.000000', 'temperatura', 474.0000, 'ºC'),
	(74958, 108, '2015-03-01 00:55:00.000000', 'temperatura', 487.0000, 'ºC'),
	(74959, 108, '2015-03-01 00:55:01.000000', 'temperatura', 1014.0000, 'ºC'),
	(74960, 108, '2015-03-01 00:55:02.000000', 'temperatura', 9.0000, 'ºC'),
	(74961, 108, '2015-03-01 00:55:03.000000', 'temperatura', 605.0000, 'ºC'),
	(74962, 108, '2015-03-01 00:55:04.000000', 'temperatura', 597.0000, 'ºC'),
	(74963, 108, '2015-03-01 00:55:05.000000', 'temperatura', 1169.0000, 'ºC'),
	(74964, 108, '2015-03-01 00:55:06.000000', 'temperatura', 457.0000, 'ºC'),
	(74965, 108, '2015-03-01 00:55:07.000000', 'temperatura', 1179.0000, 'ºC'),
	(74966, 108, '2015-03-01 00:55:08.000000', 'temperatura', 924.0000, 'ºC'),
	(74967, 108, '2015-03-01 00:55:09.000000', 'temperatura', 1082.0000, 'ºC'),
	(74968, 108, '2015-03-01 00:55:10.000000', 'temperatura', 238.0000, 'ºC'),
	(74969, 108, '2015-03-01 00:55:11.000000', 'temperatura', 347.0000, 'ºC'),
	(74970, 108, '2015-03-01 00:55:12.000000', 'temperatura', 1019.0000, 'ºC'),
	(74971, 108, '2015-03-01 00:55:13.000000', 'temperatura', 455.0000, 'ºC'),
	(74972, 108, '2015-03-01 00:55:14.000000', 'temperatura', 418.0000, 'ºC'),
	(74973, 108, '2015-03-01 00:55:15.000000', 'temperatura', 727.0000, 'ºC'),
	(74974, 108, '2015-03-01 00:55:16.000000', 'temperatura', 1179.0000, 'ºC'),
	(74975, 108, '2015-03-01 00:55:17.000000', 'temperatura', 116.0000, 'ºC'),
	(74976, 108, '2015-03-01 00:55:18.000000', 'temperatura', 642.0000, 'ºC'),
	(74977, 108, '2015-03-01 00:55:19.000000', 'temperatura', 465.0000, 'ºC'),
	(74978, 108, '2015-03-01 00:55:20.000000', 'temperatura', 399.0000, 'ºC'),
	(74979, 108, '2015-03-01 00:55:21.000000', 'temperatura', 601.0000, 'ºC'),
	(74980, 108, '2015-03-01 00:55:22.000000', 'temperatura', 608.0000, 'ºC'),
	(74981, 108, '2015-03-01 00:55:23.000000', 'temperatura', 38.0000, 'ºC'),
	(74982, 108, '2015-03-01 00:55:24.000000', 'temperatura', 767.0000, 'ºC'),
	(74983, 108, '2015-03-01 00:55:25.000000', 'temperatura', 123.0000, 'ºC'),
	(74984, 108, '2015-03-01 00:55:26.000000', 'temperatura', 712.0000, 'ºC'),
	(74985, 108, '2015-03-01 00:55:27.000000', 'temperatura', 790.0000, 'ºC'),
	(74986, 108, '2015-03-01 00:55:28.000000', 'temperatura', 618.0000, 'ºC'),
	(74987, 108, '2015-03-01 00:55:29.000000', 'temperatura', 718.0000, 'ºC'),
	(74988, 108, '2015-03-01 00:55:30.000000', 'temperatura', 539.0000, 'ºC'),
	(74989, 108, '2015-03-01 00:55:31.000000', 'temperatura', 542.0000, 'ºC'),
	(74990, 108, '2015-03-01 00:55:32.000000', 'temperatura', 1090.0000, 'ºC'),
	(74991, 108, '2015-03-01 00:55:33.000000', 'temperatura', 227.0000, 'ºC'),
	(74992, 108, '2015-03-01 00:55:34.000000', 'temperatura', 264.0000, 'ºC'),
	(74993, 108, '2015-03-01 00:55:35.000000', 'temperatura', 641.0000, 'ºC'),
	(74994, 108, '2015-03-01 00:55:36.000000', 'temperatura', 14.0000, 'ºC'),
	(74995, 108, '2015-03-01 00:55:37.000000', 'temperatura', 547.0000, 'ºC'),
	(74996, 108, '2015-03-01 00:55:38.000000', 'temperatura', 292.0000, 'ºC'),
	(74997, 108, '2015-03-01 00:55:39.000000', 'temperatura', 1020.0000, 'ºC'),
	(74998, 108, '2015-03-01 00:55:40.000000', 'temperatura', 623.0000, 'ºC'),
	(74999, 108, '2015-03-01 00:55:41.000000', 'temperatura', 56.0000, 'ºC'),
	(75000, 108, '2015-03-01 00:55:42.000000', 'temperatura', 811.0000, 'ºC'),
	(75001, 108, '2015-03-01 00:55:43.000000', 'temperatura', 289.0000, 'ºC'),
	(75002, 108, '2015-03-01 00:55:44.000000', 'temperatura', 213.0000, 'ºC'),
	(75003, 108, '2015-03-01 00:55:45.000000', 'temperatura', 200.0000, 'ºC'),
	(75004, 108, '2015-03-01 00:55:46.000000', 'temperatura', 359.0000, 'ºC'),
	(75005, 108, '2015-03-01 00:55:47.000000', 'temperatura', 1197.0000, 'ºC'),
	(75006, 108, '2015-03-01 00:55:48.000000', 'temperatura', 109.0000, 'ºC'),
	(75007, 108, '2015-03-01 00:55:49.000000', 'temperatura', 552.0000, 'ºC'),
	(75008, 108, '2015-03-01 00:55:50.000000', 'temperatura', 35.0000, 'ºC'),
	(75009, 108, '2015-03-01 00:55:51.000000', 'temperatura', 921.0000, 'ºC'),
	(75010, 108, '2015-03-01 00:55:52.000000', 'temperatura', 899.0000, 'ºC'),
	(75011, 108, '2015-03-01 00:55:53.000000', 'temperatura', 533.0000, 'ºC'),
	(75012, 108, '2015-03-01 00:55:54.000000', 'temperatura', 1170.0000, 'ºC'),
	(75013, 108, '2015-03-01 00:55:55.000000', 'temperatura', 649.0000, 'ºC'),
	(75014, 108, '2015-03-01 00:55:56.000000', 'temperatura', 938.0000, 'ºC'),
	(75015, 108, '2015-03-01 00:55:57.000000', 'temperatura', 342.0000, 'ºC'),
	(75016, 108, '2015-03-01 00:55:58.000000', 'temperatura', 97.0000, 'ºC'),
	(75017, 108, '2015-03-01 00:55:59.000000', 'temperatura', 660.0000, 'ºC'),
	(75018, 108, '2015-03-01 00:56:00.000000', 'temperatura', 608.0000, 'ºC'),
	(75019, 108, '2015-03-01 00:56:01.000000', 'temperatura', 1063.0000, 'ºC'),
	(75020, 108, '2015-03-01 00:56:02.000000', 'temperatura', 1088.0000, 'ºC'),
	(75021, 108, '2015-03-01 00:56:03.000000', 'temperatura', 1055.0000, 'ºC'),
	(75022, 108, '2015-03-01 00:56:04.000000', 'temperatura', 810.0000, 'ºC'),
	(75023, 108, '2015-03-01 00:56:05.000000', 'temperatura', 887.0000, 'ºC'),
	(75024, 108, '2015-03-01 00:56:06.000000', 'temperatura', 803.0000, 'ºC'),
	(75025, 108, '2015-03-01 00:56:07.000000', 'temperatura', 157.0000, 'ºC'),
	(75026, 108, '2015-03-01 00:56:08.000000', 'temperatura', 774.0000, 'ºC'),
	(75027, 108, '2015-03-01 00:56:09.000000', 'temperatura', 1002.0000, 'ºC'),
	(75028, 108, '2015-03-01 00:56:10.000000', 'temperatura', 287.0000, 'ºC'),
	(75029, 108, '2015-03-01 00:56:11.000000', 'temperatura', 832.0000, 'ºC'),
	(75030, 108, '2015-03-01 00:56:12.000000', 'temperatura', 897.0000, 'ºC'),
	(75031, 108, '2015-03-01 00:56:13.000000', 'temperatura', 792.0000, 'ºC'),
	(75032, 108, '2015-03-01 00:56:14.000000', 'temperatura', 68.0000, 'ºC'),
	(75033, 108, '2015-03-01 00:56:15.000000', 'temperatura', 363.0000, 'ºC'),
	(75034, 108, '2015-03-01 00:56:16.000000', 'temperatura', 414.0000, 'ºC'),
	(75035, 108, '2015-03-01 00:56:17.000000', 'temperatura', 981.0000, 'ºC'),
	(75036, 108, '2015-03-01 00:56:18.000000', 'temperatura', 63.0000, 'ºC'),
	(75037, 108, '2015-03-01 00:56:19.000000', 'temperatura', 973.0000, 'ºC'),
	(75038, 108, '2015-03-01 00:56:20.000000', 'temperatura', 1078.0000, 'ºC'),
	(75039, 108, '2015-03-01 00:56:21.000000', 'temperatura', 70.0000, 'ºC'),
	(75040, 108, '2015-03-01 00:56:22.000000', 'temperatura', 716.0000, 'ºC'),
	(75041, 108, '2015-03-01 00:56:23.000000', 'temperatura', 970.0000, 'ºC'),
	(75042, 108, '2015-03-01 00:56:24.000000', 'temperatura', 302.0000, 'ºC'),
	(75043, 108, '2015-03-01 00:56:25.000000', 'temperatura', 1000.0000, 'ºC'),
	(75044, 108, '2015-03-01 00:56:26.000000', 'temperatura', 494.0000, 'ºC'),
	(75045, 108, '2015-03-01 00:56:27.000000', 'temperatura', 672.0000, 'ºC'),
	(75046, 108, '2015-03-01 00:56:28.000000', 'temperatura', 679.0000, 'ºC'),
	(75047, 108, '2015-03-01 00:56:29.000000', 'temperatura', 179.0000, 'ºC'),
	(75048, 108, '2015-03-01 00:56:30.000000', 'temperatura', 58.0000, 'ºC'),
	(75049, 108, '2015-03-01 00:56:31.000000', 'temperatura', 952.0000, 'ºC'),
	(75050, 108, '2015-03-01 00:56:32.000000', 'temperatura', 989.0000, 'ºC'),
	(75051, 108, '2015-03-01 00:56:33.000000', 'temperatura', 889.0000, 'ºC'),
	(75052, 108, '2015-03-01 00:56:34.000000', 'temperatura', 277.0000, 'ºC'),
	(75053, 108, '2015-03-01 00:56:35.000000', 'temperatura', 1117.0000, 'ºC'),
	(75054, 108, '2015-03-01 00:56:36.000000', 'temperatura', 1158.0000, 'ºC'),
	(75055, 108, '2015-03-01 00:56:37.000000', 'temperatura', 36.0000, 'ºC'),
	(75056, 108, '2015-03-01 00:56:38.000000', 'temperatura', 310.0000, 'ºC'),
	(75057, 108, '2015-03-01 00:56:39.000000', 'temperatura', 240.0000, 'ºC'),
	(75058, 108, '2015-03-01 00:56:40.000000', 'temperatura', 270.0000, 'ºC'),
	(75059, 108, '2015-03-01 00:56:41.000000', 'temperatura', 632.0000, 'ºC'),
	(75060, 108, '2015-03-01 00:56:42.000000', 'temperatura', 1150.0000, 'ºC'),
	(75061, 108, '2015-03-01 00:56:43.000000', 'temperatura', 253.0000, 'ºC'),
	(75062, 108, '2015-03-01 00:56:44.000000', 'temperatura', 215.0000, 'ºC'),
	(75063, 108, '2015-03-01 00:56:45.000000', 'temperatura', 319.0000, 'ºC'),
	(75064, 108, '2015-03-01 00:56:46.000000', 'temperatura', 950.0000, 'ºC'),
	(75065, 108, '2015-03-01 00:56:47.000000', 'temperatura', 192.0000, 'ºC'),
	(75066, 108, '2015-03-01 00:56:48.000000', 'temperatura', 509.0000, 'ºC'),
	(75067, 108, '2015-03-01 00:56:49.000000', 'temperatura', 773.0000, 'ºC'),
	(75068, 108, '2015-03-01 00:56:50.000000', 'temperatura', 1137.0000, 'ºC'),
	(75069, 108, '2015-03-01 00:56:51.000000', 'temperatura', 966.0000, 'ºC'),
	(75070, 108, '2015-03-01 00:56:52.000000', 'temperatura', 221.0000, 'ºC'),
	(75071, 108, '2015-03-01 00:56:53.000000', 'temperatura', 608.0000, 'ºC'),
	(75072, 108, '2015-03-01 00:56:54.000000', 'temperatura', 1176.0000, 'ºC'),
	(75073, 108, '2015-03-01 00:56:55.000000', 'temperatura', 456.0000, 'ºC'),
	(75074, 108, '2015-03-01 00:56:56.000000', 'temperatura', 1153.0000, 'ºC'),
	(75075, 108, '2015-03-01 00:56:57.000000', 'temperatura', 799.0000, 'ºC'),
	(75076, 108, '2015-03-01 00:56:58.000000', 'temperatura', 534.0000, 'ºC'),
	(75077, 108, '2015-03-01 00:56:59.000000', 'temperatura', 273.0000, 'ºC'),
	(75078, 108, '2015-03-01 00:57:00.000000', 'temperatura', 963.0000, 'ºC'),
	(75079, 108, '2015-03-01 00:57:01.000000', 'temperatura', 398.0000, 'ºC'),
	(75080, 108, '2015-03-01 00:57:02.000000', 'temperatura', 302.0000, 'ºC'),
	(75081, 108, '2015-03-01 00:57:03.000000', 'temperatura', 314.0000, 'ºC'),
	(75082, 108, '2015-03-01 00:57:04.000000', 'temperatura', 668.0000, 'ºC'),
	(75083, 108, '2015-03-01 00:57:05.000000', 'temperatura', 1197.0000, 'ºC'),
	(75084, 108, '2015-03-01 00:57:06.000000', 'temperatura', 381.0000, 'ºC'),
	(75085, 108, '2015-03-01 00:57:07.000000', 'temperatura', 713.0000, 'ºC'),
	(75086, 108, '2015-03-01 00:57:08.000000', 'temperatura', 23.0000, 'ºC'),
	(75087, 108, '2015-03-01 00:57:09.000000', 'temperatura', 379.0000, 'ºC'),
	(75088, 108, '2015-03-01 00:57:10.000000', 'temperatura', 625.0000, 'ºC'),
	(75089, 108, '2015-03-01 00:57:11.000000', 'temperatura', 787.0000, 'ºC'),
	(75090, 108, '2015-03-01 00:57:12.000000', 'temperatura', 860.0000, 'ºC'),
	(75091, 108, '2015-03-01 00:57:13.000000', 'temperatura', 742.0000, 'ºC'),
	(75092, 108, '2015-03-01 00:57:14.000000', 'temperatura', 1130.0000, 'ºC'),
	(75093, 108, '2015-03-01 00:57:15.000000', 'temperatura', 1025.0000, 'ºC'),
	(75094, 108, '2015-03-01 00:57:16.000000', 'temperatura', 534.0000, 'ºC'),
	(75095, 108, '2015-03-01 00:57:17.000000', 'temperatura', 797.0000, 'ºC'),
	(75096, 108, '2015-03-01 00:57:18.000000', 'temperatura', 1183.0000, 'ºC'),
	(75097, 108, '2015-03-01 00:57:19.000000', 'temperatura', 1124.0000, 'ºC'),
	(75098, 108, '2015-03-01 00:57:20.000000', 'temperatura', 874.0000, 'ºC'),
	(75099, 108, '2015-03-01 00:57:21.000000', 'temperatura', 996.0000, 'ºC'),
	(75100, 108, '2015-03-01 00:57:22.000000', 'temperatura', 1160.0000, 'ºC'),
	(75101, 108, '2015-03-01 00:57:23.000000', 'temperatura', 414.0000, 'ºC'),
	(75102, 108, '2015-03-01 00:57:24.000000', 'temperatura', 988.0000, 'ºC'),
	(75103, 108, '2015-03-01 00:57:25.000000', 'temperatura', 98.0000, 'ºC'),
	(75104, 108, '2015-03-01 00:57:26.000000', 'temperatura', 1129.0000, 'ºC'),
	(75105, 108, '2015-03-01 00:57:27.000000', 'temperatura', 550.0000, 'ºC'),
	(75106, 108, '2015-03-01 00:57:28.000000', 'temperatura', 564.0000, 'ºC'),
	(75107, 108, '2015-03-01 00:57:29.000000', 'temperatura', 1169.0000, 'ºC'),
	(75108, 108, '2015-03-01 00:57:30.000000', 'temperatura', 552.0000, 'ºC'),
	(75109, 108, '2015-03-01 00:57:31.000000', 'temperatura', 457.0000, 'ºC'),
	(75110, 108, '2015-03-01 00:57:32.000000', 'temperatura', 629.0000, 'ºC'),
	(75111, 108, '2015-03-01 00:57:33.000000', 'temperatura', 576.0000, 'ºC'),
	(75112, 108, '2015-03-01 00:57:34.000000', 'temperatura', 992.0000, 'ºC'),
	(75113, 108, '2015-03-01 00:57:35.000000', 'temperatura', 833.0000, 'ºC'),
	(75114, 108, '2015-03-01 00:57:36.000000', 'temperatura', 1191.0000, 'ºC'),
	(75115, 108, '2015-03-01 00:57:37.000000', 'temperatura', 1055.0000, 'ºC'),
	(75116, 108, '2015-03-01 00:57:38.000000', 'temperatura', 505.0000, 'ºC'),
	(75117, 108, '2015-03-01 00:57:39.000000', 'temperatura', 557.0000, 'ºC'),
	(75118, 108, '2015-03-01 00:57:40.000000', 'temperatura', 72.0000, 'ºC'),
	(75119, 108, '2015-03-01 00:57:41.000000', 'temperatura', 1091.0000, 'ºC'),
	(75120, 108, '2015-03-01 00:57:42.000000', 'temperatura', 437.0000, 'ºC'),
	(75121, 108, '2015-03-01 00:57:43.000000', 'temperatura', 113.0000, 'ºC'),
	(75122, 108, '2015-03-01 00:57:44.000000', 'temperatura', 453.0000, 'ºC'),
	(75123, 108, '2015-03-01 00:57:45.000000', 'temperatura', 727.0000, 'ºC'),
	(75124, 108, '2015-03-01 00:57:46.000000', 'temperatura', 1077.0000, 'ºC'),
	(75125, 108, '2015-03-01 00:57:47.000000', 'temperatura', 804.0000, 'ºC'),
	(75126, 108, '2015-03-01 00:57:48.000000', 'temperatura', 790.0000, 'ºC'),
	(75127, 108, '2015-03-01 00:57:49.000000', 'temperatura', 337.0000, 'ºC'),
	(75128, 108, '2015-03-01 00:57:50.000000', 'temperatura', 518.0000, 'ºC'),
	(75129, 108, '2015-03-01 00:57:51.000000', 'temperatura', 377.0000, 'ºC'),
	(75130, 108, '2015-03-01 00:57:52.000000', 'temperatura', 331.0000, 'ºC'),
	(75131, 108, '2015-03-01 00:57:53.000000', 'temperatura', 525.0000, 'ºC'),
	(75132, 108, '2015-03-01 00:57:54.000000', 'temperatura', 432.0000, 'ºC'),
	(75133, 108, '2015-03-01 00:57:55.000000', 'temperatura', 586.0000, 'ºC'),
	(75134, 108, '2015-03-01 00:57:56.000000', 'temperatura', 434.0000, 'ºC'),
	(75135, 108, '2015-03-01 00:57:57.000000', 'temperatura', 414.0000, 'ºC'),
	(75136, 108, '2015-03-01 00:57:58.000000', 'temperatura', 768.0000, 'ºC'),
	(75137, 108, '2015-03-01 00:57:59.000000', 'temperatura', 198.0000, 'ºC'),
	(75138, 108, '2015-03-01 00:58:00.000000', 'temperatura', 1088.0000, 'ºC'),
	(75139, 108, '2015-03-01 00:58:01.000000', 'temperatura', 45.0000, 'ºC'),
	(75140, 108, '2015-03-01 00:58:02.000000', 'temperatura', 564.0000, 'ºC'),
	(75141, 108, '2015-03-01 00:58:03.000000', 'temperatura', 282.0000, 'ºC'),
	(75142, 108, '2015-03-01 00:58:04.000000', 'temperatura', 920.0000, 'ºC'),
	(75143, 108, '2015-03-01 00:58:05.000000', 'temperatura', 154.0000, 'ºC'),
	(75144, 108, '2015-03-01 00:58:06.000000', 'temperatura', 411.0000, 'ºC'),
	(75145, 108, '2015-03-01 00:58:07.000000', 'temperatura', 393.0000, 'ºC'),
	(75146, 108, '2015-03-01 00:58:08.000000', 'temperatura', 734.0000, 'ºC'),
	(75147, 108, '2015-03-01 00:58:09.000000', 'temperatura', 89.0000, 'ºC'),
	(75148, 108, '2015-03-01 00:58:10.000000', 'temperatura', 646.0000, 'ºC'),
	(75149, 108, '2015-03-01 00:58:11.000000', 'temperatura', 562.0000, 'ºC'),
	(75150, 108, '2015-03-01 00:58:12.000000', 'temperatura', 873.0000, 'ºC'),
	(75151, 108, '2015-03-01 00:58:13.000000', 'temperatura', 281.0000, 'ºC'),
	(75152, 108, '2015-03-01 00:58:14.000000', 'temperatura', 1186.0000, 'ºC'),
	(75153, 108, '2015-03-01 00:58:15.000000', 'temperatura', 287.0000, 'ºC'),
	(75154, 108, '2015-03-01 00:58:16.000000', 'temperatura', 279.0000, 'ºC'),
	(75155, 108, '2015-03-01 00:58:17.000000', 'temperatura', 534.0000, 'ºC'),
	(75156, 108, '2015-03-01 00:58:18.000000', 'temperatura', 633.0000, 'ºC'),
	(75157, 108, '2015-03-01 00:58:19.000000', 'temperatura', 365.0000, 'ºC'),
	(75158, 108, '2015-03-01 00:58:20.000000', 'temperatura', 1127.0000, 'ºC'),
	(75159, 108, '2015-03-01 00:58:21.000000', 'temperatura', 938.0000, 'ºC'),
	(75160, 108, '2015-03-01 00:58:22.000000', 'temperatura', 109.0000, 'ºC'),
	(75161, 108, '2015-03-01 00:58:23.000000', 'temperatura', 132.0000, 'ºC'),
	(75162, 108, '2015-03-01 00:58:24.000000', 'temperatura', 333.0000, 'ºC'),
	(75163, 108, '2015-03-01 00:58:25.000000', 'temperatura', 68.0000, 'ºC'),
	(75164, 108, '2015-03-01 00:58:26.000000', 'temperatura', 544.0000, 'ºC'),
	(75165, 108, '2015-03-01 00:58:27.000000', 'temperatura', 117.0000, 'ºC'),
	(75166, 108, '2015-03-01 00:58:28.000000', 'temperatura', 152.0000, 'ºC'),
	(75167, 108, '2015-03-01 00:58:29.000000', 'temperatura', 410.0000, 'ºC'),
	(75168, 108, '2015-03-01 00:58:30.000000', 'temperatura', 395.0000, 'ºC'),
	(75169, 108, '2015-03-01 00:58:31.000000', 'temperatura', 746.0000, 'ºC'),
	(75170, 108, '2015-03-01 00:58:32.000000', 'temperatura', 146.0000, 'ºC'),
	(75171, 108, '2015-03-01 00:58:33.000000', 'temperatura', 891.0000, 'ºC'),
	(75172, 108, '2015-03-01 00:58:34.000000', 'temperatura', 419.0000, 'ºC'),
	(75173, 108, '2015-03-01 00:58:35.000000', 'temperatura', 623.0000, 'ºC'),
	(75174, 108, '2015-03-01 00:58:36.000000', 'temperatura', 657.0000, 'ºC'),
	(75175, 108, '2015-03-01 00:58:37.000000', 'temperatura', 217.0000, 'ºC'),
	(75176, 108, '2015-03-01 00:58:38.000000', 'temperatura', 313.0000, 'ºC'),
	(75177, 108, '2015-03-01 00:58:39.000000', 'temperatura', 914.0000, 'ºC'),
	(75178, 108, '2015-03-01 00:58:40.000000', 'temperatura', 31.0000, 'ºC'),
	(75179, 108, '2015-03-01 00:58:41.000000', 'temperatura', 1016.0000, 'ºC'),
	(75180, 108, '2015-03-01 00:58:42.000000', 'temperatura', 188.0000, 'ºC'),
	(75181, 108, '2015-03-01 00:58:43.000000', 'temperatura', 289.0000, 'ºC'),
	(75182, 108, '2015-03-01 00:58:44.000000', 'temperatura', 885.0000, 'ºC'),
	(75183, 108, '2015-03-01 00:58:45.000000', 'temperatura', 1159.0000, 'ºC'),
	(75184, 108, '2015-03-01 00:58:46.000000', 'temperatura', 738.0000, 'ºC'),
	(75185, 108, '2015-03-01 00:58:47.000000', 'temperatura', 213.0000, 'ºC'),
	(75186, 108, '2015-03-01 00:58:48.000000', 'temperatura', 51.0000, 'ºC'),
	(75187, 108, '2015-03-01 00:58:49.000000', 'temperatura', 816.0000, 'ºC'),
	(75188, 108, '2015-03-01 00:58:50.000000', 'temperatura', 329.0000, 'ºC'),
	(75189, 108, '2015-03-01 00:58:51.000000', 'temperatura', 398.0000, 'ºC'),
	(75190, 108, '2015-03-01 00:58:52.000000', 'temperatura', 1003.0000, 'ºC'),
	(75191, 108, '2015-03-01 00:58:53.000000', 'temperatura', 222.0000, 'ºC'),
	(75192, 108, '2015-03-01 00:58:54.000000', 'temperatura', 502.0000, 'ºC'),
	(75193, 108, '2015-03-01 00:58:55.000000', 'temperatura', 643.0000, 'ºC'),
	(75194, 108, '2015-03-01 00:58:56.000000', 'temperatura', 512.0000, 'ºC'),
	(75195, 108, '2015-03-01 00:58:57.000000', 'temperatura', 630.0000, 'ºC'),
	(75196, 108, '2015-03-01 00:58:58.000000', 'temperatura', 417.0000, 'ºC'),
	(75197, 108, '2015-03-01 00:58:59.000000', 'temperatura', 192.0000, 'ºC'),
	(75198, 108, '2015-03-01 00:59:00.000000', 'temperatura', 910.0000, 'ºC'),
	(75199, 108, '2015-03-01 00:59:01.000000', 'temperatura', 374.0000, 'ºC'),
	(75200, 108, '2015-03-01 00:59:02.000000', 'temperatura', 341.0000, 'ºC'),
	(75201, 108, '2015-03-01 00:59:03.000000', 'temperatura', 584.0000, 'ºC'),
	(75202, 108, '2015-03-01 00:59:04.000000', 'temperatura', 697.0000, 'ºC'),
	(75203, 108, '2015-03-01 00:59:05.000000', 'temperatura', 535.0000, 'ºC'),
	(75204, 108, '2015-03-01 00:59:06.000000', 'temperatura', 586.0000, 'ºC'),
	(75205, 108, '2015-03-01 00:59:07.000000', 'temperatura', 122.0000, 'ºC'),
	(75206, 108, '2015-03-01 00:59:08.000000', 'temperatura', 53.0000, 'ºC'),
	(75207, 108, '2015-03-01 00:59:09.000000', 'temperatura', 1098.0000, 'ºC'),
	(75208, 108, '2015-03-01 00:59:10.000000', 'temperatura', 534.0000, 'ºC'),
	(75209, 108, '2015-03-01 00:59:11.000000', 'temperatura', 575.0000, 'ºC'),
	(75210, 108, '2015-03-01 00:59:12.000000', 'temperatura', 76.0000, 'ºC'),
	(75211, 108, '2015-03-01 00:59:13.000000', 'temperatura', 1054.0000, 'ºC'),
	(75212, 108, '2015-03-01 00:59:14.000000', 'temperatura', 242.0000, 'ºC'),
	(75213, 108, '2015-03-01 00:59:15.000000', 'temperatura', 449.0000, 'ºC'),
	(75214, 108, '2015-03-01 00:59:16.000000', 'temperatura', 319.0000, 'ºC'),
	(75215, 108, '2015-03-01 00:59:17.000000', 'temperatura', 248.0000, 'ºC'),
	(75216, 108, '2015-03-01 00:59:18.000000', 'temperatura', 284.0000, 'ºC'),
	(75217, 108, '2015-03-01 00:59:19.000000', 'temperatura', 678.0000, 'ºC'),
	(75218, 108, '2015-03-01 00:59:20.000000', 'temperatura', 137.0000, 'ºC'),
	(75219, 108, '2015-03-01 00:59:21.000000', 'temperatura', 1050.0000, 'ºC'),
	(75220, 108, '2015-03-01 00:59:22.000000', 'temperatura', 42.0000, 'ºC'),
	(75221, 108, '2015-03-01 00:59:23.000000', 'temperatura', 660.0000, 'ºC'),
	(75222, 108, '2015-03-01 00:59:24.000000', 'temperatura', 774.0000, 'ºC'),
	(75223, 108, '2015-03-01 00:59:25.000000', 'temperatura', 689.0000, 'ºC'),
	(75224, 108, '2015-03-01 00:59:26.000000', 'temperatura', 1124.0000, 'ºC'),
	(75225, 108, '2015-03-01 00:59:27.000000', 'temperatura', 1156.0000, 'ºC'),
	(75226, 108, '2015-03-01 00:59:28.000000', 'temperatura', 7.0000, 'ºC'),
	(75227, 108, '2015-03-01 00:59:29.000000', 'temperatura', 166.0000, 'ºC'),
	(75228, 108, '2015-03-01 00:59:30.000000', 'temperatura', 809.0000, 'ºC'),
	(75229, 108, '2015-03-01 00:59:31.000000', 'temperatura', 1148.0000, 'ºC'),
	(75230, 108, '2015-03-01 00:59:32.000000', 'temperatura', 912.0000, 'ºC'),
	(75231, 108, '2015-03-01 00:59:33.000000', 'temperatura', 1119.0000, 'ºC'),
	(75232, 108, '2015-03-01 00:59:34.000000', 'temperatura', 457.0000, 'ºC'),
	(75233, 108, '2015-03-01 00:59:35.000000', 'temperatura', 131.0000, 'ºC'),
	(75234, 108, '2015-03-01 00:59:36.000000', 'temperatura', 484.0000, 'ºC'),
	(75235, 108, '2015-03-01 00:59:37.000000', 'temperatura', 827.0000, 'ºC'),
	(75236, 108, '2015-03-01 00:59:38.000000', 'temperatura', 284.0000, 'ºC'),
	(75237, 108, '2015-03-01 00:59:39.000000', 'temperatura', 141.0000, 'ºC'),
	(75238, 108, '2015-03-01 00:59:40.000000', 'temperatura', 1050.0000, 'ºC'),
	(75239, 108, '2015-03-01 00:59:41.000000', 'temperatura', 30.0000, 'ºC'),
	(75240, 108, '2015-03-01 00:59:42.000000', 'temperatura', 601.0000, 'ºC'),
	(75241, 108, '2015-03-01 00:59:43.000000', 'temperatura', 513.0000, 'ºC'),
	(75242, 108, '2015-03-01 00:59:44.000000', 'temperatura', 762.0000, 'ºC'),
	(75243, 108, '2015-03-01 00:59:45.000000', 'temperatura', 1072.0000, 'ºC'),
	(75244, 108, '2015-03-01 00:59:46.000000', 'temperatura', 676.0000, 'ºC'),
	(75245, 108, '2015-03-01 00:59:47.000000', 'temperatura', 165.0000, 'ºC'),
	(75246, 108, '2015-03-01 00:59:48.000000', 'temperatura', 1199.0000, 'ºC'),
	(75247, 108, '2015-03-01 00:59:49.000000', 'temperatura', 697.0000, 'ºC'),
	(75248, 108, '2015-03-01 00:59:50.000000', 'temperatura', 1091.0000, 'ºC'),
	(75249, 108, '2015-03-01 00:59:51.000000', 'temperatura', 964.0000, 'ºC'),
	(75250, 108, '2015-03-01 00:59:52.000000', 'temperatura', 347.0000, 'ºC'),
	(75251, 108, '2015-03-01 00:59:53.000000', 'temperatura', 44.0000, 'ºC'),
	(75252, 108, '2015-03-01 00:59:54.000000', 'temperatura', 379.0000, 'ºC'),
	(75253, 108, '2015-03-01 00:59:55.000000', 'temperatura', 565.0000, 'ºC'),
	(75254, 108, '2015-03-01 00:59:56.000000', 'temperatura', 489.0000, 'ºC'),
	(75255, 108, '2015-03-01 00:59:57.000000', 'temperatura', 750.0000, 'ºC'),
	(75256, 108, '2015-03-01 00:59:58.000000', 'temperatura', 1082.0000, 'ºC'),
	(75257, 108, '2015-03-01 00:59:59.000000', 'temperatura', 759.0000, 'ºC'),
	(75258, 108, '2015-03-01 01:00:00.000000', 'temperatura', 553.0000, 'ºC'),
	(75259, 108, '2015-03-01 01:00:01.000000', 'temperatura', 488.0000, 'ºC'),
	(75260, 108, '2015-03-01 01:00:02.000000', 'temperatura', 780.0000, 'ºC'),
	(75261, 108, '2015-03-01 01:00:03.000000', 'temperatura', 39.0000, 'ºC'),
	(75262, 108, '2015-03-01 01:00:04.000000', 'temperatura', 254.0000, 'ºC'),
	(75263, 108, '2015-03-01 01:00:05.000000', 'temperatura', 1156.0000, 'ºC'),
	(75264, 108, '2015-03-01 01:00:06.000000', 'temperatura', 216.0000, 'ºC'),
	(75265, 108, '2015-03-01 01:00:07.000000', 'temperatura', 11.0000, 'ºC'),
	(75266, 108, '2015-03-01 01:00:08.000000', 'temperatura', 611.0000, 'ºC'),
	(75267, 108, '2015-03-01 01:00:09.000000', 'temperatura', 619.0000, 'ºC'),
	(75268, 108, '2015-03-01 01:00:10.000000', 'temperatura', 64.0000, 'ºC'),
	(75269, 108, '2015-03-01 01:00:11.000000', 'temperatura', 862.0000, 'ºC'),
	(75270, 108, '2015-03-01 01:00:12.000000', 'temperatura', 520.0000, 'ºC'),
	(75271, 108, '2015-03-01 01:00:13.000000', 'temperatura', 15.0000, 'ºC'),
	(75272, 108, '2015-03-01 01:00:14.000000', 'temperatura', 917.0000, 'ºC'),
	(75273, 108, '2015-03-01 01:00:15.000000', 'temperatura', 937.0000, 'ºC'),
	(75274, 108, '2015-03-01 01:00:16.000000', 'temperatura', 737.0000, 'ºC'),
	(75275, 108, '2015-03-01 01:00:17.000000', 'temperatura', 874.0000, 'ºC'),
	(75276, 108, '2015-03-01 01:00:18.000000', 'temperatura', 959.0000, 'ºC'),
	(75277, 108, '2015-03-01 01:00:19.000000', 'temperatura', 974.0000, 'ºC'),
	(75278, 108, '2015-03-01 01:00:20.000000', 'temperatura', 792.0000, 'ºC'),
	(75279, 108, '2015-03-01 01:00:21.000000', 'temperatura', 1039.0000, 'ºC'),
	(75280, 108, '2015-03-01 01:00:22.000000', 'temperatura', 419.0000, 'ºC'),
	(75281, 108, '2015-03-01 01:00:23.000000', 'temperatura', 178.0000, 'ºC'),
	(75282, 108, '2015-03-01 01:00:24.000000', 'temperatura', 836.0000, 'ºC'),
	(75283, 108, '2015-03-01 01:00:25.000000', 'temperatura', 46.0000, 'ºC'),
	(75284, 108, '2015-03-01 01:00:26.000000', 'temperatura', 124.0000, 'ºC'),
	(75285, 108, '2015-03-01 01:00:27.000000', 'temperatura', 481.0000, 'ºC'),
	(75286, 108, '2015-03-01 01:00:28.000000', 'temperatura', 835.0000, 'ºC'),
	(75287, 108, '2015-03-01 01:00:29.000000', 'temperatura', 333.0000, 'ºC'),
	(75288, 108, '2015-03-01 01:00:30.000000', 'temperatura', 358.0000, 'ºC'),
	(75289, 108, '2015-03-01 01:00:31.000000', 'temperatura', 791.0000, 'ºC'),
	(75290, 108, '2015-03-01 01:00:32.000000', 'temperatura', 483.0000, 'ºC'),
	(75291, 108, '2015-03-01 01:00:33.000000', 'temperatura', 43.0000, 'ºC'),
	(75292, 108, '2015-03-01 01:00:34.000000', 'temperatura', 1167.0000, 'ºC'),
	(75293, 108, '2015-03-01 01:00:35.000000', 'temperatura', 907.0000, 'ºC'),
	(75294, 108, '2015-03-01 01:00:36.000000', 'temperatura', 1033.0000, 'ºC'),
	(75295, 108, '2015-03-01 01:00:37.000000', 'temperatura', 45.0000, 'ºC'),
	(75296, 108, '2015-03-01 01:00:38.000000', 'temperatura', 728.0000, 'ºC'),
	(75297, 108, '2015-03-01 01:00:39.000000', 'temperatura', 1105.0000, 'ºC'),
	(75298, 108, '2015-03-01 01:00:40.000000', 'temperatura', 939.0000, 'ºC'),
	(75299, 108, '2015-03-01 01:00:41.000000', 'temperatura', 182.0000, 'ºC'),
	(75300, 108, '2015-03-01 01:00:42.000000', 'temperatura', 494.0000, 'ºC'),
	(75301, 108, '2015-03-01 01:00:43.000000', 'temperatura', 725.0000, 'ºC'),
	(75302, 108, '2015-03-01 01:00:44.000000', 'temperatura', 942.0000, 'ºC'),
	(75303, 108, '2015-03-01 01:00:45.000000', 'temperatura', 135.0000, 'ºC'),
	(75304, 108, '2015-03-01 01:00:46.000000', 'temperatura', 249.0000, 'ºC'),
	(75305, 108, '2015-03-01 01:00:47.000000', 'temperatura', 839.0000, 'ºC'),
	(75306, 108, '2015-03-01 01:00:48.000000', 'temperatura', 1052.0000, 'ºC'),
	(75307, 108, '2015-03-01 01:00:49.000000', 'temperatura', 341.0000, 'ºC'),
	(75308, 108, '2015-03-01 01:00:50.000000', 'temperatura', 948.0000, 'ºC'),
	(75309, 108, '2015-03-01 01:00:51.000000', 'temperatura', 120.0000, 'ºC'),
	(75310, 108, '2015-03-01 01:00:52.000000', 'temperatura', 157.0000, 'ºC'),
	(75311, 108, '2015-03-01 01:00:53.000000', 'temperatura', 423.0000, 'ºC'),
	(75312, 108, '2015-03-01 01:00:54.000000', 'temperatura', 445.0000, 'ºC'),
	(75313, 108, '2015-03-01 01:00:55.000000', 'temperatura', 958.0000, 'ºC'),
	(75314, 108, '2015-03-01 01:00:56.000000', 'temperatura', 1053.0000, 'ºC'),
	(75315, 108, '2015-03-01 01:00:57.000000', 'temperatura', 1194.0000, 'ºC'),
	(75316, 108, '2015-03-01 01:00:58.000000', 'temperatura', 411.0000, 'ºC'),
	(75317, 108, '2015-03-01 01:00:59.000000', 'temperatura', 872.0000, 'ºC'),
	(75318, 108, '2015-03-01 01:01:00.000000', 'temperatura', 727.0000, 'ºC'),
	(75319, 108, '2015-03-01 01:01:01.000000', 'temperatura', 1021.0000, 'ºC'),
	(75320, 108, '2015-03-01 01:01:02.000000', 'temperatura', 525.0000, 'ºC'),
	(75321, 108, '2015-03-01 01:01:03.000000', 'temperatura', 763.0000, 'ºC'),
	(75322, 108, '2015-03-01 01:01:04.000000', 'temperatura', 1041.0000, 'ºC'),
	(75323, 108, '2015-03-01 01:01:05.000000', 'temperatura', 516.0000, 'ºC'),
	(75324, 108, '2015-03-01 01:01:06.000000', 'temperatura', 659.0000, 'ºC'),
	(75325, 108, '2015-03-01 01:01:07.000000', 'temperatura', 545.0000, 'ºC'),
	(75326, 108, '2015-03-01 01:01:08.000000', 'temperatura', 752.0000, 'ºC'),
	(75327, 108, '2015-03-01 01:01:09.000000', 'temperatura', 922.0000, 'ºC'),
	(75328, 108, '2015-03-01 01:01:10.000000', 'temperatura', 1154.0000, 'ºC'),
	(75329, 108, '2015-03-01 01:01:11.000000', 'temperatura', 606.0000, 'ºC'),
	(75330, 108, '2015-03-01 01:01:12.000000', 'temperatura', 770.0000, 'ºC'),
	(75331, 108, '2015-03-01 01:01:13.000000', 'temperatura', 831.0000, 'ºC'),
	(75332, 108, '2015-03-01 01:01:14.000000', 'temperatura', 647.0000, 'ºC'),
	(75333, 108, '2015-03-01 01:01:15.000000', 'temperatura', 743.0000, 'ºC'),
	(75334, 108, '2015-03-01 01:01:16.000000', 'temperatura', 575.0000, 'ºC'),
	(75335, 108, '2015-03-01 01:01:17.000000', 'temperatura', 644.0000, 'ºC'),
	(75336, 108, '2015-03-01 01:01:18.000000', 'temperatura', 297.0000, 'ºC'),
	(75337, 108, '2015-03-01 01:01:19.000000', 'temperatura', 753.0000, 'ºC'),
	(75338, 108, '2015-03-01 01:01:20.000000', 'temperatura', 473.0000, 'ºC'),
	(75339, 108, '2015-03-01 01:01:21.000000', 'temperatura', 107.0000, 'ºC'),
	(75340, 108, '2015-03-01 01:01:22.000000', 'temperatura', 315.0000, 'ºC'),
	(75341, 108, '2015-03-01 01:01:23.000000', 'temperatura', 56.0000, 'ºC'),
	(75342, 108, '2015-03-01 01:01:24.000000', 'temperatura', 537.0000, 'ºC'),
	(75343, 108, '2015-03-01 01:01:25.000000', 'temperatura', 115.0000, 'ºC'),
	(75344, 108, '2015-03-01 01:01:26.000000', 'temperatura', 164.0000, 'ºC'),
	(75345, 108, '2015-03-01 01:01:27.000000', 'temperatura', 475.0000, 'ºC'),
	(75346, 108, '2015-03-01 01:01:28.000000', 'temperatura', 686.0000, 'ºC'),
	(75347, 108, '2015-03-01 01:01:29.000000', 'temperatura', 805.0000, 'ºC'),
	(75348, 108, '2015-03-01 01:01:30.000000', 'temperatura', 769.0000, 'ºC'),
	(75349, 108, '2015-03-01 01:01:31.000000', 'temperatura', 228.0000, 'ºC'),
	(75350, 108, '2015-03-01 01:01:32.000000', 'temperatura', 34.0000, 'ºC'),
	(75351, 108, '2015-03-01 01:01:33.000000', 'temperatura', 688.0000, 'ºC'),
	(75352, 108, '2015-03-01 01:01:34.000000', 'temperatura', 939.0000, 'ºC'),
	(75353, 108, '2015-03-01 01:01:35.000000', 'temperatura', 232.0000, 'ºC'),
	(75354, 108, '2015-03-01 01:01:36.000000', 'temperatura', 744.0000, 'ºC'),
	(75355, 108, '2015-03-01 01:01:37.000000', 'temperatura', 625.0000, 'ºC'),
	(75356, 108, '2015-03-01 01:01:38.000000', 'temperatura', 893.0000, 'ºC'),
	(75357, 108, '2015-03-01 01:01:39.000000', 'temperatura', 192.0000, 'ºC'),
	(75358, 108, '2015-03-01 01:01:40.000000', 'temperatura', 678.0000, 'ºC'),
	(75359, 108, '2015-03-01 01:01:41.000000', 'temperatura', 418.0000, 'ºC'),
	(75360, 108, '2015-03-01 01:01:42.000000', 'temperatura', 53.0000, 'ºC'),
	(75361, 108, '2015-03-01 01:01:43.000000', 'temperatura', 214.0000, 'ºC'),
	(75362, 108, '2015-03-01 01:01:44.000000', 'temperatura', 910.0000, 'ºC'),
	(75363, 108, '2015-03-01 01:01:45.000000', 'temperatura', 310.0000, 'ºC'),
	(75364, 108, '2015-03-01 01:01:46.000000', 'temperatura', 19.0000, 'ºC'),
	(75365, 108, '2015-03-01 01:01:47.000000', 'temperatura', 367.0000, 'ºC'),
	(75366, 108, '2015-03-01 01:01:48.000000', 'temperatura', 580.0000, 'ºC'),
	(75367, 108, '2015-03-01 01:01:49.000000', 'temperatura', 596.0000, 'ºC'),
	(75368, 108, '2015-03-01 01:01:50.000000', 'temperatura', 44.0000, 'ºC'),
	(75369, 108, '2015-03-01 01:01:51.000000', 'temperatura', 830.0000, 'ºC'),
	(75370, 108, '2015-03-01 01:01:52.000000', 'temperatura', 419.0000, 'ºC'),
	(75371, 108, '2015-03-01 01:01:53.000000', 'temperatura', 807.0000, 'ºC'),
	(75372, 108, '2015-03-01 01:01:54.000000', 'temperatura', 378.0000, 'ºC'),
	(75373, 108, '2015-03-01 01:01:55.000000', 'temperatura', 670.0000, 'ºC'),
	(75374, 108, '2015-03-01 01:01:56.000000', 'temperatura', 1016.0000, 'ºC'),
	(75375, 108, '2015-03-01 01:01:57.000000', 'temperatura', 673.0000, 'ºC'),
	(75376, 108, '2015-03-01 01:01:58.000000', 'temperatura', 314.0000, 'ºC'),
	(75377, 108, '2015-03-01 01:01:59.000000', 'temperatura', 752.0000, 'ºC'),
	(75378, 108, '2015-03-01 01:02:00.000000', 'temperatura', 420.0000, 'ºC'),
	(75379, 108, '2015-03-01 01:02:01.000000', 'temperatura', 1042.0000, 'ºC'),
	(75380, 108, '2015-03-01 01:02:02.000000', 'temperatura', 351.0000, 'ºC'),
	(75381, 108, '2015-03-01 01:02:03.000000', 'temperatura', 1029.0000, 'ºC'),
	(75382, 108, '2015-03-01 01:02:04.000000', 'temperatura', 494.0000, 'ºC'),
	(75383, 108, '2015-03-01 01:02:05.000000', 'temperatura', 583.0000, 'ºC'),
	(75384, 108, '2015-03-01 01:02:06.000000', 'temperatura', 232.0000, 'ºC'),
	(75385, 108, '2015-03-01 01:02:07.000000', 'temperatura', 611.0000, 'ºC'),
	(75386, 108, '2015-03-01 01:02:08.000000', 'temperatura', 1163.0000, 'ºC'),
	(75387, 108, '2015-03-01 01:02:09.000000', 'temperatura', 379.0000, 'ºC'),
	(75388, 108, '2015-03-01 01:02:10.000000', 'temperatura', 806.0000, 'ºC'),
	(75389, 108, '2015-03-01 01:02:11.000000', 'temperatura', 497.0000, 'ºC'),
	(75390, 108, '2015-03-01 01:02:12.000000', 'temperatura', 64.0000, 'ºC'),
	(75391, 108, '2015-03-01 01:02:13.000000', 'temperatura', 31.0000, 'ºC'),
	(75392, 109, '2015-03-01 00:00:00.000000', 'temperatura', 917.0000, 'ºC'),
	(75393, 109, '2015-03-01 00:00:01.000000', 'temperatura', 1099.0000, 'ºC'),
	(75394, 109, '2015-03-01 00:00:02.000000', 'temperatura', 345.0000, 'ºC'),
	(75395, 109, '2015-03-01 00:00:03.000000', 'temperatura', 827.0000, 'ºC'),
	(75396, 109, '2015-03-01 00:00:04.000000', 'temperatura', 704.0000, 'ºC'),
	(75397, 109, '2015-03-01 00:00:05.000000', 'temperatura', 1038.0000, 'ºC'),
	(75398, 109, '2015-03-01 00:00:06.000000', 'temperatura', 677.0000, 'ºC'),
	(75399, 109, '2015-03-01 00:00:07.000000', 'temperatura', 274.0000, 'ºC'),
	(75400, 109, '2015-03-01 00:00:08.000000', 'temperatura', 538.0000, 'ºC'),
	(75401, 109, '2015-03-01 00:00:09.000000', 'temperatura', 667.0000, 'ºC'),
	(75402, 109, '2015-03-01 00:00:10.000000', 'temperatura', 524.0000, 'ºC'),
	(75403, 109, '2015-03-01 00:00:11.000000', 'temperatura', 617.0000, 'ºC'),
	(75404, 109, '2015-03-01 00:00:12.000000', 'temperatura', 313.0000, 'ºC'),
	(75405, 109, '2015-03-01 00:00:13.000000', 'temperatura', 917.0000, 'ºC'),
	(75406, 109, '2015-03-01 00:00:14.000000', 'temperatura', 45.0000, 'ºC'),
	(75407, 109, '2015-03-01 00:00:15.000000', 'temperatura', 1077.0000, 'ºC'),
	(75408, 109, '2015-03-01 00:00:16.000000', 'temperatura', 447.0000, 'ºC'),
	(75409, 109, '2015-03-01 00:00:17.000000', 'temperatura', 207.0000, 'ºC'),
	(75410, 109, '2015-03-01 00:00:18.000000', 'temperatura', 893.0000, 'ºC'),
	(75411, 109, '2015-03-01 00:00:19.000000', 'temperatura', 246.0000, 'ºC'),
	(75412, 109, '2015-03-01 00:00:20.000000', 'temperatura', 949.0000, 'ºC'),
	(75413, 109, '2015-03-01 00:00:21.000000', 'temperatura', 408.0000, 'ºC'),
	(75414, 109, '2015-03-01 00:00:22.000000', 'temperatura', 395.0000, 'ºC'),
	(75415, 109, '2015-03-01 00:00:23.000000', 'temperatura', 752.0000, 'ºC'),
	(75416, 109, '2015-03-01 00:00:24.000000', 'temperatura', 173.0000, 'ºC'),
	(75417, 109, '2015-03-01 00:00:25.000000', 'temperatura', 1012.0000, 'ºC'),
	(75418, 109, '2015-03-01 00:00:26.000000', 'temperatura', 941.0000, 'ºC'),
	(75419, 109, '2015-03-01 00:00:27.000000', 'temperatura', 468.0000, 'ºC'),
	(75420, 109, '2015-03-01 00:00:28.000000', 'temperatura', 717.0000, 'ºC'),
	(75421, 109, '2015-03-01 00:00:29.000000', 'temperatura', 983.0000, 'ºC'),
	(75422, 109, '2015-03-01 00:00:30.000000', 'temperatura', 364.0000, 'ºC'),
	(75423, 109, '2015-03-01 00:00:31.000000', 'temperatura', 72.0000, 'ºC'),
	(75424, 109, '2015-03-01 00:00:32.000000', 'temperatura', 468.0000, 'ºC'),
	(75425, 109, '2015-03-01 00:00:33.000000', 'temperatura', 924.0000, 'ºC'),
	(75426, 109, '2015-03-01 00:00:34.000000', 'temperatura', 819.0000, 'ºC'),
	(75427, 109, '2015-03-01 00:00:35.000000', 'temperatura', 121.0000, 'ºC'),
	(75428, 109, '2015-03-01 00:00:36.000000', 'temperatura', 549.0000, 'ºC'),
	(75429, 109, '2015-03-01 00:00:37.000000', 'temperatura', 1184.0000, 'ºC'),
	(75430, 109, '2015-03-01 00:00:38.000000', 'temperatura', 672.0000, 'ºC'),
	(75431, 109, '2015-03-01 00:00:39.000000', 'temperatura', 1010.0000, 'ºC'),
	(75432, 109, '2015-03-01 00:00:40.000000', 'temperatura', 634.0000, 'ºC'),
	(75433, 109, '2015-03-01 00:00:41.000000', 'temperatura', 142.0000, 'ºC'),
	(75434, 109, '2015-03-01 00:00:42.000000', 'temperatura', 6.0000, 'ºC'),
	(75435, 109, '2015-03-01 00:00:43.000000', 'temperatura', 804.0000, 'ºC'),
	(75436, 109, '2015-03-01 00:00:44.000000', 'temperatura', 403.0000, 'ºC'),
	(75437, 109, '2015-03-01 00:00:45.000000', 'temperatura', 803.0000, 'ºC'),
	(75438, 109, '2015-03-01 00:00:46.000000', 'temperatura', 409.0000, 'ºC'),
	(75439, 109, '2015-03-01 00:00:47.000000', 'temperatura', 835.0000, 'ºC'),
	(75440, 109, '2015-03-01 00:00:48.000000', 'temperatura', 547.0000, 'ºC'),
	(75441, 109, '2015-03-01 00:00:49.000000', 'temperatura', 233.0000, 'ºC'),
	(75442, 109, '2015-03-01 00:00:50.000000', 'temperatura', 723.0000, 'ºC'),
	(75443, 109, '2015-03-01 00:00:51.000000', 'temperatura', 517.0000, 'ºC'),
	(75444, 109, '2015-03-01 00:00:52.000000', 'temperatura', 415.0000, 'ºC'),
	(75445, 109, '2015-03-01 00:00:53.000000', 'temperatura', 524.0000, 'ºC'),
	(75446, 109, '2015-03-01 00:00:54.000000', 'temperatura', 175.0000, 'ºC'),
	(75447, 109, '2015-03-01 00:00:55.000000', 'temperatura', 507.0000, 'ºC'),
	(75448, 109, '2015-03-01 00:00:56.000000', 'temperatura', 807.0000, 'ºC'),
	(75449, 109, '2015-03-01 00:00:57.000000', 'temperatura', 115.0000, 'ºC'),
	(75450, 109, '2015-03-01 00:00:58.000000', 'temperatura', 554.0000, 'ºC'),
	(75451, 109, '2015-03-01 00:00:59.000000', 'temperatura', 28.0000, 'ºC'),
	(75452, 109, '2015-03-01 00:01:00.000000', 'temperatura', 877.0000, 'ºC'),
	(75453, 109, '2015-03-01 00:01:01.000000', 'temperatura', 703.0000, 'ºC'),
	(75454, 109, '2015-03-01 00:01:02.000000', 'temperatura', 884.0000, 'ºC'),
	(75455, 109, '2015-03-01 00:01:03.000000', 'temperatura', 1113.0000, 'ºC'),
	(75456, 109, '2015-03-01 00:01:04.000000', 'temperatura', 513.0000, 'ºC'),
	(75457, 109, '2015-03-01 00:01:05.000000', 'temperatura', 427.0000, 'ºC'),
	(75458, 109, '2015-03-01 00:01:06.000000', 'temperatura', 594.0000, 'ºC'),
	(75459, 109, '2015-03-01 00:01:07.000000', 'temperatura', 491.0000, 'ºC'),
	(75460, 109, '2015-03-01 00:01:08.000000', 'temperatura', 672.0000, 'ºC'),
	(75461, 109, '2015-03-01 00:01:09.000000', 'temperatura', 687.0000, 'ºC'),
	(75462, 109, '2015-03-01 00:01:10.000000', 'temperatura', 221.0000, 'ºC'),
	(75463, 109, '2015-03-01 00:01:11.000000', 'temperatura', 243.0000, 'ºC'),
	(75464, 109, '2015-03-01 00:01:12.000000', 'temperatura', 553.0000, 'ºC'),
	(75465, 109, '2015-03-01 00:01:13.000000', 'temperatura', 835.0000, 'ºC'),
	(75466, 109, '2015-03-01 00:01:14.000000', 'temperatura', 117.0000, 'ºC'),
	(75467, 109, '2015-03-01 00:01:15.000000', 'temperatura', 481.0000, 'ºC'),
	(75468, 109, '2015-03-01 00:01:16.000000', 'temperatura', 854.0000, 'ºC'),
	(75469, 109, '2015-03-01 00:01:17.000000', 'temperatura', 429.0000, 'ºC'),
	(75470, 109, '2015-03-01 00:01:18.000000', 'temperatura', 785.0000, 'ºC'),
	(75471, 109, '2015-03-01 00:01:19.000000', 'temperatura', 235.0000, 'ºC'),
	(75472, 109, '2015-03-01 00:01:20.000000', 'temperatura', 22.0000, 'ºC'),
	(75473, 109, '2015-03-01 00:01:21.000000', 'temperatura', 607.0000, 'ºC'),
	(75474, 109, '2015-03-01 00:01:22.000000', 'temperatura', 568.0000, 'ºC'),
	(75475, 109, '2015-03-01 00:01:23.000000', 'temperatura', 1020.0000, 'ºC'),
	(75476, 109, '2015-03-01 00:01:24.000000', 'temperatura', 997.0000, 'ºC'),
	(75477, 109, '2015-03-01 00:01:25.000000', 'temperatura', 725.0000, 'ºC'),
	(75478, 109, '2015-03-01 00:01:26.000000', 'temperatura', 637.0000, 'ºC'),
	(75479, 109, '2015-03-01 00:01:27.000000', 'temperatura', 1007.0000, 'ºC'),
	(75480, 109, '2015-03-01 00:01:28.000000', 'temperatura', 724.0000, 'ºC'),
	(75481, 109, '2015-03-01 00:01:29.000000', 'temperatura', 602.0000, 'ºC'),
	(75482, 109, '2015-03-01 00:01:30.000000', 'temperatura', 837.0000, 'ºC'),
	(75483, 109, '2015-03-01 00:01:31.000000', 'temperatura', 1179.0000, 'ºC'),
	(75484, 109, '2015-03-01 00:01:32.000000', 'temperatura', 984.0000, 'ºC'),
	(75485, 109, '2015-03-01 00:01:33.000000', 'temperatura', 185.0000, 'ºC'),
	(75486, 109, '2015-03-01 00:01:34.000000', 'temperatura', 374.0000, 'ºC'),
	(75487, 109, '2015-03-01 00:01:35.000000', 'temperatura', 116.0000, 'ºC'),
	(75488, 109, '2015-03-01 00:01:36.000000', 'temperatura', 659.0000, 'ºC'),
	(75489, 109, '2015-03-01 00:01:37.000000', 'temperatura', 547.0000, 'ºC'),
	(75490, 109, '2015-03-01 00:01:38.000000', 'temperatura', 757.0000, 'ºC'),
	(75491, 109, '2015-03-01 00:01:39.000000', 'temperatura', 945.0000, 'ºC'),
	(75492, 109, '2015-03-01 00:01:40.000000', 'temperatura', 56.0000, 'ºC'),
	(75493, 109, '2015-03-01 00:01:41.000000', 'temperatura', 1046.0000, 'ºC'),
	(75494, 109, '2015-03-01 00:01:42.000000', 'temperatura', 260.0000, 'ºC'),
	(75495, 109, '2015-03-01 00:01:43.000000', 'temperatura', 565.0000, 'ºC'),
	(75496, 109, '2015-03-01 00:01:44.000000', 'temperatura', 846.0000, 'ºC'),
	(75497, 109, '2015-03-01 00:01:45.000000', 'temperatura', 132.0000, 'ºC'),
	(75498, 109, '2015-03-01 00:01:46.000000', 'temperatura', 526.0000, 'ºC'),
	(75499, 109, '2015-03-01 00:01:47.000000', 'temperatura', 1034.0000, 'ºC'),
	(75500, 109, '2015-03-01 00:01:48.000000', 'temperatura', 1190.0000, 'ºC'),
	(75501, 109, '2015-03-01 00:01:49.000000', 'temperatura', 449.0000, 'ºC'),
	(75502, 109, '2015-03-01 00:01:50.000000', 'temperatura', 1078.0000, 'ºC'),
	(75503, 109, '2015-03-01 00:01:51.000000', 'temperatura', 441.0000, 'ºC'),
	(75504, 109, '2015-03-01 00:01:52.000000', 'temperatura', 172.0000, 'ºC'),
	(75505, 109, '2015-03-01 00:01:53.000000', 'temperatura', 740.0000, 'ºC'),
	(75506, 109, '2015-03-01 00:01:54.000000', 'temperatura', 781.0000, 'ºC'),
	(75507, 109, '2015-03-01 00:01:55.000000', 'temperatura', 487.0000, 'ºC'),
	(75508, 109, '2015-03-01 00:01:56.000000', 'temperatura', 93.0000, 'ºC'),
	(75509, 109, '2015-03-01 00:01:57.000000', 'temperatura', 206.0000, 'ºC'),
	(75510, 109, '2015-03-01 00:01:58.000000', 'temperatura', 749.0000, 'ºC'),
	(75511, 109, '2015-03-01 00:01:59.000000', 'temperatura', 728.0000, 'ºC'),
	(75512, 109, '2015-03-01 00:02:00.000000', 'temperatura', 193.0000, 'ºC'),
	(75513, 109, '2015-03-01 00:02:01.000000', 'temperatura', 1180.0000, 'ºC'),
	(75514, 109, '2015-03-01 00:02:02.000000', 'temperatura', 524.0000, 'ºC'),
	(75515, 109, '2015-03-01 00:02:03.000000', 'temperatura', 278.0000, 'ºC'),
	(75516, 109, '2015-03-01 00:02:04.000000', 'temperatura', 1018.0000, 'ºC'),
	(75517, 109, '2015-03-01 00:02:05.000000', 'temperatura', 658.0000, 'ºC'),
	(75518, 109, '2015-03-01 00:02:06.000000', 'temperatura', 237.0000, 'ºC'),
	(75519, 109, '2015-03-01 00:02:07.000000', 'temperatura', 412.0000, 'ºC'),
	(75520, 109, '2015-03-01 00:02:08.000000', 'temperatura', 150.0000, 'ºC'),
	(75521, 109, '2015-03-01 00:02:09.000000', 'temperatura', 714.0000, 'ºC'),
	(75522, 109, '2015-03-01 00:02:10.000000', 'temperatura', 719.0000, 'ºC'),
	(75523, 109, '2015-03-01 00:02:11.000000', 'temperatura', 252.0000, 'ºC'),
	(75524, 109, '2015-03-01 00:02:12.000000', 'temperatura', 306.0000, 'ºC'),
	(75525, 109, '2015-03-01 00:02:13.000000', 'temperatura', 776.0000, 'ºC'),
	(75526, 109, '2015-03-01 00:02:14.000000', 'temperatura', 560.0000, 'ºC'),
	(75527, 109, '2015-03-01 00:02:15.000000', 'temperatura', 474.0000, 'ºC'),
	(75528, 109, '2015-03-01 00:02:16.000000', 'temperatura', 688.0000, 'ºC'),
	(75529, 109, '2015-03-01 00:02:17.000000', 'temperatura', 822.0000, 'ºC'),
	(75530, 109, '2015-03-01 00:02:18.000000', 'temperatura', 844.0000, 'ºC'),
	(75531, 109, '2015-03-01 00:02:19.000000', 'temperatura', 553.0000, 'ºC'),
	(75532, 109, '2015-03-01 00:02:20.000000', 'temperatura', 235.0000, 'ºC'),
	(75533, 109, '2015-03-01 00:02:21.000000', 'temperatura', 718.0000, 'ºC'),
	(75534, 109, '2015-03-01 00:02:22.000000', 'temperatura', 484.0000, 'ºC'),
	(75535, 109, '2015-03-01 00:02:23.000000', 'temperatura', 268.0000, 'ºC'),
	(75536, 109, '2015-03-01 00:02:24.000000', 'temperatura', 1089.0000, 'ºC'),
	(75537, 109, '2015-03-01 00:02:25.000000', 'temperatura', 1042.0000, 'ºC'),
	(75538, 109, '2015-03-01 00:02:26.000000', 'temperatura', 743.0000, 'ºC'),
	(75539, 109, '2015-03-01 00:02:27.000000', 'temperatura', 589.0000, 'ºC'),
	(75540, 109, '2015-03-01 00:02:28.000000', 'temperatura', 717.0000, 'ºC'),
	(75541, 109, '2015-03-01 00:02:29.000000', 'temperatura', 620.0000, 'ºC'),
	(75542, 109, '2015-03-01 00:02:30.000000', 'temperatura', 949.0000, 'ºC'),
	(75543, 109, '2015-03-01 00:02:31.000000', 'temperatura', 483.0000, 'ºC'),
	(75544, 109, '2015-03-01 00:02:32.000000', 'temperatura', 770.0000, 'ºC'),
	(75545, 109, '2015-03-01 00:02:33.000000', 'temperatura', 2.0000, 'ºC'),
	(75546, 109, '2015-03-01 00:02:34.000000', 'temperatura', 100.0000, 'ºC'),
	(75547, 109, '2015-03-01 00:02:35.000000', 'temperatura', 496.0000, 'ºC'),
	(75548, 109, '2015-03-01 00:02:36.000000', 'temperatura', 979.0000, 'ºC'),
	(75549, 109, '2015-03-01 00:02:37.000000', 'temperatura', 1007.0000, 'ºC'),
	(75550, 109, '2015-03-01 00:02:38.000000', 'temperatura', 898.0000, 'ºC'),
	(75551, 109, '2015-03-01 00:02:39.000000', 'temperatura', 269.0000, 'ºC'),
	(75552, 109, '2015-03-01 00:02:40.000000', 'temperatura', 1051.0000, 'ºC'),
	(75553, 109, '2015-03-01 00:02:41.000000', 'temperatura', 849.0000, 'ºC'),
	(75554, 109, '2015-03-01 00:02:42.000000', 'temperatura', 1092.0000, 'ºC'),
	(75555, 109, '2015-03-01 00:02:43.000000', 'temperatura', 514.0000, 'ºC'),
	(75556, 109, '2015-03-01 00:02:44.000000', 'temperatura', 494.0000, 'ºC'),
	(75557, 109, '2015-03-01 00:02:45.000000', 'temperatura', 928.0000, 'ºC'),
	(75558, 109, '2015-03-01 00:02:46.000000', 'temperatura', 759.0000, 'ºC'),
	(75559, 109, '2015-03-01 00:02:47.000000', 'temperatura', 1012.0000, 'ºC'),
	(75560, 109, '2015-03-01 00:02:48.000000', 'temperatura', 381.0000, 'ºC'),
	(75561, 109, '2015-03-01 00:02:49.000000', 'temperatura', 72.0000, 'ºC'),
	(75562, 109, '2015-03-01 00:02:50.000000', 'temperatura', 419.0000, 'ºC'),
	(75563, 109, '2015-03-01 00:02:51.000000', 'temperatura', 677.0000, 'ºC'),
	(75564, 109, '2015-03-01 00:02:52.000000', 'temperatura', 931.0000, 'ºC'),
	(75565, 109, '2015-03-01 00:02:53.000000', 'temperatura', 222.0000, 'ºC'),
	(75566, 109, '2015-03-01 00:02:54.000000', 'temperatura', 719.0000, 'ºC'),
	(75567, 109, '2015-03-01 00:02:55.000000', 'temperatura', 530.0000, 'ºC'),
	(75568, 109, '2015-03-01 00:02:56.000000', 'temperatura', 494.0000, 'ºC'),
	(75569, 109, '2015-03-01 00:02:57.000000', 'temperatura', 880.0000, 'ºC'),
	(75570, 109, '2015-03-01 00:02:58.000000', 'temperatura', 516.0000, 'ºC'),
	(75571, 109, '2015-03-01 00:02:59.000000', 'temperatura', 1144.0000, 'ºC'),
	(75572, 109, '2015-03-01 00:03:00.000000', 'temperatura', 572.0000, 'ºC'),
	(75573, 109, '2015-03-01 00:03:01.000000', 'temperatura', 626.0000, 'ºC'),
	(75574, 109, '2015-03-01 00:03:02.000000', 'temperatura', 217.0000, 'ºC'),
	(75575, 109, '2015-03-01 00:03:03.000000', 'temperatura', 406.0000, 'ºC'),
	(75576, 109, '2015-03-01 00:03:04.000000', 'temperatura', 180.0000, 'ºC'),
	(75577, 109, '2015-03-01 00:03:05.000000', 'temperatura', 881.0000, 'ºC'),
	(75578, 109, '2015-03-01 00:03:06.000000', 'temperatura', 268.0000, 'ºC'),
	(75579, 109, '2015-03-01 00:03:07.000000', 'temperatura', 1096.0000, 'ºC'),
	(75580, 109, '2015-03-01 00:03:08.000000', 'temperatura', 1078.0000, 'ºC'),
	(75581, 109, '2015-03-01 00:03:09.000000', 'temperatura', 901.0000, 'ºC'),
	(75582, 109, '2015-03-01 00:03:10.000000', 'temperatura', 73.0000, 'ºC'),
	(75583, 109, '2015-03-01 00:03:11.000000', 'temperatura', 62.0000, 'ºC'),
	(75584, 109, '2015-03-01 00:03:12.000000', 'temperatura', 91.0000, 'ºC'),
	(75585, 109, '2015-03-01 00:03:13.000000', 'temperatura', 268.0000, 'ºC'),
	(75586, 109, '2015-03-01 00:03:14.000000', 'temperatura', 1068.0000, 'ºC'),
	(75587, 109, '2015-03-01 00:03:15.000000', 'temperatura', 936.0000, 'ºC'),
	(75588, 109, '2015-03-01 00:03:16.000000', 'temperatura', 276.0000, 'ºC'),
	(75589, 109, '2015-03-01 00:03:17.000000', 'temperatura', 974.0000, 'ºC'),
	(75590, 109, '2015-03-01 00:03:18.000000', 'temperatura', 444.0000, 'ºC'),
	(75591, 109, '2015-03-01 00:03:19.000000', 'temperatura', 495.0000, 'ºC'),
	(75592, 109, '2015-03-01 00:03:20.000000', 'temperatura', 1145.0000, 'ºC'),
	(75593, 109, '2015-03-01 00:03:21.000000', 'temperatura', 642.0000, 'ºC'),
	(75594, 109, '2015-03-01 00:03:22.000000', 'temperatura', 973.0000, 'ºC'),
	(75595, 109, '2015-03-01 00:03:23.000000', 'temperatura', 540.0000, 'ºC'),
	(75596, 109, '2015-03-01 00:03:24.000000', 'temperatura', 981.0000, 'ºC'),
	(75597, 109, '2015-03-01 00:03:25.000000', 'temperatura', 885.0000, 'ºC'),
	(75598, 109, '2015-03-01 00:03:26.000000', 'temperatura', 285.0000, 'ºC'),
	(75599, 109, '2015-03-01 00:03:27.000000', 'temperatura', 1170.0000, 'ºC'),
	(75600, 109, '2015-03-01 00:03:28.000000', 'temperatura', 194.0000, 'ºC'),
	(75601, 109, '2015-03-01 00:03:29.000000', 'temperatura', 1060.0000, 'ºC'),
	(75602, 109, '2015-03-01 00:03:30.000000', 'temperatura', 1121.0000, 'ºC'),
	(75603, 109, '2015-03-01 00:03:31.000000', 'temperatura', 24.0000, 'ºC'),
	(75604, 109, '2015-03-01 00:03:32.000000', 'temperatura', 360.0000, 'ºC'),
	(75605, 109, '2015-03-01 00:03:33.000000', 'temperatura', 526.0000, 'ºC'),
	(75606, 109, '2015-03-01 00:03:34.000000', 'temperatura', 352.0000, 'ºC'),
	(75607, 109, '2015-03-01 00:03:35.000000', 'temperatura', 180.0000, 'ºC'),
	(75608, 109, '2015-03-01 00:03:36.000000', 'temperatura', 1047.0000, 'ºC'),
	(75609, 109, '2015-03-01 00:03:37.000000', 'temperatura', 1094.0000, 'ºC'),
	(75610, 109, '2015-03-01 00:03:38.000000', 'temperatura', 1128.0000, 'ºC'),
	(75611, 109, '2015-03-01 00:03:39.000000', 'temperatura', 1159.0000, 'ºC'),
	(75612, 109, '2015-03-01 00:03:40.000000', 'temperatura', 13.0000, 'ºC'),
	(75613, 109, '2015-03-01 00:03:41.000000', 'temperatura', 188.0000, 'ºC'),
	(75614, 109, '2015-03-01 00:03:42.000000', 'temperatura', 900.0000, 'ºC'),
	(75615, 109, '2015-03-01 00:03:43.000000', 'temperatura', 337.0000, 'ºC'),
	(75616, 109, '2015-03-01 00:03:44.000000', 'temperatura', 187.0000, 'ºC'),
	(75617, 109, '2015-03-01 00:03:45.000000', 'temperatura', 1122.0000, 'ºC'),
	(75618, 109, '2015-03-01 00:03:46.000000', 'temperatura', 251.0000, 'ºC'),
	(75619, 109, '2015-03-01 00:03:47.000000', 'temperatura', 291.0000, 'ºC'),
	(75620, 109, '2015-03-01 00:03:48.000000', 'temperatura', 700.0000, 'ºC'),
	(75621, 109, '2015-03-01 00:03:49.000000', 'temperatura', 227.0000, 'ºC'),
	(75622, 109, '2015-03-01 00:03:50.000000', 'temperatura', 235.0000, 'ºC'),
	(75623, 109, '2015-03-01 00:03:51.000000', 'temperatura', 497.0000, 'ºC'),
	(75624, 109, '2015-03-01 00:03:52.000000', 'temperatura', 577.0000, 'ºC'),
	(75625, 109, '2015-03-01 00:03:53.000000', 'temperatura', 198.0000, 'ºC'),
	(75626, 109, '2015-03-01 00:03:54.000000', 'temperatura', 458.0000, 'ºC'),
	(75627, 109, '2015-03-01 00:03:55.000000', 'temperatura', 496.0000, 'ºC'),
	(75628, 109, '2015-03-01 00:03:56.000000', 'temperatura', 1109.0000, 'ºC'),
	(75629, 109, '2015-03-01 00:03:57.000000', 'temperatura', 455.0000, 'ºC'),
	(75630, 109, '2015-03-01 00:03:58.000000', 'temperatura', 150.0000, 'ºC'),
	(75631, 109, '2015-03-01 00:03:59.000000', 'temperatura', 585.0000, 'ºC'),
	(75632, 109, '2015-03-01 00:04:00.000000', 'temperatura', 76.0000, 'ºC'),
	(75633, 109, '2015-03-01 00:04:01.000000', 'temperatura', 1027.0000, 'ºC'),
	(75634, 109, '2015-03-01 00:04:02.000000', 'temperatura', 106.0000, 'ºC'),
	(75635, 109, '2015-03-01 00:04:03.000000', 'temperatura', 1049.0000, 'ºC'),
	(75636, 109, '2015-03-01 00:04:04.000000', 'temperatura', 129.0000, 'ºC'),
	(75637, 109, '2015-03-01 00:04:05.000000', 'temperatura', 1099.0000, 'ºC'),
	(75638, 109, '2015-03-01 00:04:06.000000', 'temperatura', 309.0000, 'ºC'),
	(75639, 109, '2015-03-01 00:04:07.000000', 'temperatura', 645.0000, 'ºC'),
	(75640, 109, '2015-03-01 00:04:08.000000', 'temperatura', 1102.0000, 'ºC'),
	(75641, 109, '2015-03-01 00:04:09.000000', 'temperatura', 1176.0000, 'ºC'),
	(75642, 109, '2015-03-01 00:04:10.000000', 'temperatura', 173.0000, 'ºC'),
	(75643, 109, '2015-03-01 00:04:11.000000', 'temperatura', 936.0000, 'ºC'),
	(75644, 109, '2015-03-01 00:04:12.000000', 'temperatura', 562.0000, 'ºC'),
	(75645, 109, '2015-03-01 00:04:13.000000', 'temperatura', 2.0000, 'ºC'),
	(75646, 109, '2015-03-01 00:04:14.000000', 'temperatura', 726.0000, 'ºC'),
	(75647, 109, '2015-03-01 00:04:15.000000', 'temperatura', 24.0000, 'ºC'),
	(75648, 109, '2015-03-01 00:04:16.000000', 'temperatura', 342.0000, 'ºC'),
	(75649, 109, '2015-03-01 00:04:17.000000', 'temperatura', 439.0000, 'ºC'),
	(75650, 109, '2015-03-01 00:04:18.000000', 'temperatura', 1169.0000, 'ºC'),
	(75651, 109, '2015-03-01 00:04:19.000000', 'temperatura', 928.0000, 'ºC'),
	(75652, 109, '2015-03-01 00:04:20.000000', 'temperatura', 1136.0000, 'ºC'),
	(75653, 109, '2015-03-01 00:04:21.000000', 'temperatura', 494.0000, 'ºC'),
	(75654, 109, '2015-03-01 00:04:22.000000', 'temperatura', 263.0000, 'ºC'),
	(75655, 109, '2015-03-01 00:04:23.000000', 'temperatura', 1032.0000, 'ºC'),
	(75656, 109, '2015-03-01 00:04:24.000000', 'temperatura', 772.0000, 'ºC'),
	(75657, 109, '2015-03-01 00:04:25.000000', 'temperatura', 763.0000, 'ºC'),
	(75658, 109, '2015-03-01 00:04:26.000000', 'temperatura', 302.0000, 'ºC'),
	(75659, 109, '2015-03-01 00:04:27.000000', 'temperatura', 421.0000, 'ºC'),
	(75660, 109, '2015-03-01 00:04:28.000000', 'temperatura', 1199.0000, 'ºC'),
	(75661, 109, '2015-03-01 00:04:29.000000', 'temperatura', 1134.0000, 'ºC'),
	(75662, 109, '2015-03-01 00:04:30.000000', 'temperatura', 874.0000, 'ºC'),
	(75663, 109, '2015-03-01 00:04:31.000000', 'temperatura', 966.0000, 'ºC'),
	(75664, 109, '2015-03-01 00:04:32.000000', 'temperatura', 1008.0000, 'ºC'),
	(75665, 109, '2015-03-01 00:04:33.000000', 'temperatura', 945.0000, 'ºC'),
	(75666, 109, '2015-03-01 00:04:34.000000', 'temperatura', 501.0000, 'ºC'),
	(75667, 109, '2015-03-01 00:04:35.000000', 'temperatura', 870.0000, 'ºC'),
	(75668, 109, '2015-03-01 00:04:36.000000', 'temperatura', 447.0000, 'ºC'),
	(75669, 109, '2015-03-01 00:04:37.000000', 'temperatura', 825.0000, 'ºC'),
	(75670, 109, '2015-03-01 00:04:38.000000', 'temperatura', 383.0000, 'ºC'),
	(75671, 109, '2015-03-01 00:04:39.000000', 'temperatura', 644.0000, 'ºC'),
	(75672, 109, '2015-03-01 00:04:40.000000', 'temperatura', 869.0000, 'ºC'),
	(75673, 109, '2015-03-01 00:04:41.000000', 'temperatura', 14.0000, 'ºC'),
	(75674, 109, '2015-03-01 00:04:42.000000', 'temperatura', 1063.0000, 'ºC'),
	(75675, 109, '2015-03-01 00:04:43.000000', 'temperatura', 474.0000, 'ºC'),
	(75676, 109, '2015-03-01 00:04:44.000000', 'temperatura', 383.0000, 'ºC'),
	(75677, 109, '2015-03-01 00:04:45.000000', 'temperatura', 494.0000, 'ºC'),
	(75678, 109, '2015-03-01 00:04:46.000000', 'temperatura', 122.0000, 'ºC'),
	(75679, 109, '2015-03-01 00:04:47.000000', 'temperatura', 330.0000, 'ºC'),
	(75680, 109, '2015-03-01 00:04:48.000000', 'temperatura', 81.0000, 'ºC'),
	(75681, 109, '2015-03-01 00:04:49.000000', 'temperatura', 615.0000, 'ºC'),
	(75682, 109, '2015-03-01 00:04:50.000000', 'temperatura', 435.0000, 'ºC'),
	(75683, 109, '2015-03-01 00:04:51.000000', 'temperatura', 330.0000, 'ºC'),
	(75684, 109, '2015-03-01 00:04:52.000000', 'temperatura', 346.0000, 'ºC'),
	(75685, 109, '2015-03-01 00:04:53.000000', 'temperatura', 738.0000, 'ºC'),
	(75686, 109, '2015-03-01 00:04:54.000000', 'temperatura', 255.0000, 'ºC'),
	(75687, 109, '2015-03-01 00:04:55.000000', 'temperatura', 263.0000, 'ºC'),
	(75688, 109, '2015-03-01 00:04:56.000000', 'temperatura', 548.0000, 'ºC'),
	(75689, 109, '2015-03-01 00:04:57.000000', 'temperatura', 753.0000, 'ºC'),
	(75690, 109, '2015-03-01 00:04:58.000000', 'temperatura', 921.0000, 'ºC'),
	(75691, 109, '2015-03-01 00:04:59.000000', 'temperatura', 1147.0000, 'ºC'),
	(75692, 109, '2015-03-01 00:05:00.000000', 'temperatura', 571.0000, 'ºC'),
	(75693, 109, '2015-03-01 00:05:01.000000', 'temperatura', 616.0000, 'ºC'),
	(75694, 109, '2015-03-01 00:05:02.000000', 'temperatura', 168.0000, 'ºC'),
	(75695, 109, '2015-03-01 00:05:03.000000', 'temperatura', 191.0000, 'ºC'),
	(75696, 109, '2015-03-01 00:05:04.000000', 'temperatura', 450.0000, 'ºC'),
	(75697, 109, '2015-03-01 00:05:05.000000', 'temperatura', 479.0000, 'ºC'),
	(75698, 109, '2015-03-01 00:05:06.000000', 'temperatura', 1047.0000, 'ºC'),
	(75699, 109, '2015-03-01 00:05:07.000000', 'temperatura', 199.0000, 'ºC'),
	(75700, 109, '2015-03-01 00:05:08.000000', 'temperatura', 255.0000, 'ºC'),
	(75701, 109, '2015-03-01 00:05:09.000000', 'temperatura', 679.0000, 'ºC'),
	(75702, 109, '2015-03-01 00:05:10.000000', 'temperatura', 230.0000, 'ºC'),
	(75703, 109, '2015-03-01 00:05:11.000000', 'temperatura', 312.0000, 'ºC'),
	(75704, 109, '2015-03-01 00:05:12.000000', 'temperatura', 872.0000, 'ºC'),
	(75705, 109, '2015-03-01 00:05:13.000000', 'temperatura', 1022.0000, 'ºC'),
	(75706, 109, '2015-03-01 00:05:14.000000', 'temperatura', 96.0000, 'ºC'),
	(75707, 109, '2015-03-01 00:05:15.000000', 'temperatura', 1016.0000, 'ºC'),
	(75708, 109, '2015-03-01 00:05:16.000000', 'temperatura', 1190.0000, 'ºC'),
	(75709, 109, '2015-03-01 00:05:17.000000', 'temperatura', 502.0000, 'ºC'),
	(75710, 109, '2015-03-01 00:05:18.000000', 'temperatura', 144.0000, 'ºC'),
	(75711, 109, '2015-03-01 00:05:19.000000', 'temperatura', 411.0000, 'ºC'),
	(75712, 109, '2015-03-01 00:05:20.000000', 'temperatura', 424.0000, 'ºC'),
	(75713, 109, '2015-03-01 00:05:21.000000', 'temperatura', 889.0000, 'ºC'),
	(75714, 109, '2015-03-01 00:05:22.000000', 'temperatura', 774.0000, 'ºC'),
	(75715, 109, '2015-03-01 00:05:23.000000', 'temperatura', 1.0000, 'ºC'),
	(75716, 109, '2015-03-01 00:05:24.000000', 'temperatura', 83.0000, 'ºC'),
	(75717, 109, '2015-03-01 00:05:25.000000', 'temperatura', 413.0000, 'ºC'),
	(75718, 109, '2015-03-01 00:05:26.000000', 'temperatura', 618.0000, 'ºC'),
	(75719, 109, '2015-03-01 00:05:27.000000', 'temperatura', 652.0000, 'ºC'),
	(75720, 109, '2015-03-01 00:05:28.000000', 'temperatura', 205.0000, 'ºC'),
	(75721, 109, '2015-03-01 00:05:29.000000', 'temperatura', 268.0000, 'ºC'),
	(75722, 109, '2015-03-01 00:05:30.000000', 'temperatura', 726.0000, 'ºC'),
	(75723, 109, '2015-03-01 00:05:31.000000', 'temperatura', 428.0000, 'ºC'),
	(75724, 109, '2015-03-01 00:05:32.000000', 'temperatura', 1161.0000, 'ºC'),
	(75725, 109, '2015-03-01 00:05:33.000000', 'temperatura', 921.0000, 'ºC'),
	(75726, 109, '2015-03-01 00:05:34.000000', 'temperatura', 1124.0000, 'ºC'),
	(75727, 109, '2015-03-01 00:05:35.000000', 'temperatura', 455.0000, 'ºC'),
	(75728, 109, '2015-03-01 00:05:36.000000', 'temperatura', 106.0000, 'ºC'),
	(75729, 109, '2015-03-01 00:05:37.000000', 'temperatura', 367.0000, 'ºC'),
	(75730, 109, '2015-03-01 00:05:38.000000', 'temperatura', 315.0000, 'ºC'),
	(75731, 109, '2015-03-01 00:05:39.000000', 'temperatura', 476.0000, 'ºC'),
	(75732, 109, '2015-03-01 00:05:40.000000', 'temperatura', 236.0000, 'ºC'),
	(75733, 109, '2015-03-01 00:05:41.000000', 'temperatura', 951.0000, 'ºC'),
	(75734, 109, '2015-03-01 00:05:42.000000', 'temperatura', 447.0000, 'ºC'),
	(75735, 109, '2015-03-01 00:05:43.000000', 'temperatura', 584.0000, 'ºC'),
	(75736, 109, '2015-03-01 00:05:44.000000', 'temperatura', 378.0000, 'ºC'),
	(75737, 109, '2015-03-01 00:05:45.000000', 'temperatura', 141.0000, 'ºC'),
	(75738, 109, '2015-03-01 00:05:46.000000', 'temperatura', 770.0000, 'ºC'),
	(75739, 109, '2015-03-01 00:05:47.000000', 'temperatura', 1028.0000, 'ºC'),
	(75740, 109, '2015-03-01 00:05:48.000000', 'temperatura', 431.0000, 'ºC'),
	(75741, 109, '2015-03-01 00:05:49.000000', 'temperatura', 271.0000, 'ºC'),
	(75742, 109, '2015-03-01 00:05:50.000000', 'temperatura', 63.0000, 'ºC'),
	(75743, 109, '2015-03-01 00:05:51.000000', 'temperatura', 701.0000, 'ºC'),
	(75744, 109, '2015-03-01 00:05:52.000000', 'temperatura', 917.0000, 'ºC'),
	(75745, 109, '2015-03-01 00:05:53.000000', 'temperatura', 81.0000, 'ºC'),
	(75746, 109, '2015-03-01 00:05:54.000000', 'temperatura', 55.0000, 'ºC'),
	(75747, 109, '2015-03-01 00:05:55.000000', 'temperatura', 33.0000, 'ºC'),
	(75748, 109, '2015-03-01 00:05:56.000000', 'temperatura', 0.0000, 'ºC'),
	(75749, 109, '2015-03-01 00:05:57.000000', 'temperatura', 1101.0000, 'ºC'),
	(75750, 109, '2015-03-01 00:05:58.000000', 'temperatura', 708.0000, 'ºC'),
	(75751, 109, '2015-03-01 00:05:59.000000', 'temperatura', 235.0000, 'ºC'),
	(75752, 109, '2015-03-01 00:06:00.000000', 'temperatura', 252.0000, 'ºC'),
	(75753, 109, '2015-03-01 00:06:01.000000', 'temperatura', 556.0000, 'ºC'),
	(75754, 109, '2015-03-01 00:06:02.000000', 'temperatura', 826.0000, 'ºC'),
	(75755, 109, '2015-03-01 00:06:03.000000', 'temperatura', 63.0000, 'ºC'),
	(75756, 109, '2015-03-01 00:06:04.000000', 'temperatura', 235.0000, 'ºC'),
	(75757, 109, '2015-03-01 00:06:05.000000', 'temperatura', 987.0000, 'ºC'),
	(75758, 109, '2015-03-01 00:06:06.000000', 'temperatura', 629.0000, 'ºC'),
	(75759, 109, '2015-03-01 00:06:07.000000', 'temperatura', 186.0000, 'ºC'),
	(75760, 109, '2015-03-01 00:06:08.000000', 'temperatura', 245.0000, 'ºC'),
	(75761, 109, '2015-03-01 00:06:09.000000', 'temperatura', 666.0000, 'ºC'),
	(75762, 109, '2015-03-01 00:06:10.000000', 'temperatura', 194.0000, 'ºC'),
	(75763, 109, '2015-03-01 00:06:11.000000', 'temperatura', 172.0000, 'ºC'),
	(75764, 109, '2015-03-01 00:06:12.000000', 'temperatura', 279.0000, 'ºC'),
	(75765, 109, '2015-03-01 00:06:13.000000', 'temperatura', 882.0000, 'ºC'),
	(75766, 109, '2015-03-01 00:06:14.000000', 'temperatura', 1173.0000, 'ºC'),
	(75767, 109, '2015-03-01 00:06:15.000000', 'temperatura', 817.0000, 'ºC'),
	(75768, 109, '2015-03-01 00:06:16.000000', 'temperatura', 568.0000, 'ºC'),
	(75769, 109, '2015-03-01 00:06:17.000000', 'temperatura', 391.0000, 'ºC'),
	(75770, 109, '2015-03-01 00:06:18.000000', 'temperatura', 251.0000, 'ºC'),
	(75771, 109, '2015-03-01 00:06:19.000000', 'temperatura', 82.0000, 'ºC'),
	(75772, 109, '2015-03-01 00:06:20.000000', 'temperatura', 858.0000, 'ºC'),
	(75773, 109, '2015-03-01 00:06:21.000000', 'temperatura', 442.0000, 'ºC'),
	(75774, 109, '2015-03-01 00:06:22.000000', 'temperatura', 838.0000, 'ºC'),
	(75775, 109, '2015-03-01 00:06:23.000000', 'temperatura', 465.0000, 'ºC'),
	(75776, 109, '2015-03-01 00:06:24.000000', 'temperatura', 1012.0000, 'ºC'),
	(75777, 109, '2015-03-01 00:06:25.000000', 'temperatura', 63.0000, 'ºC'),
	(75778, 109, '2015-03-01 00:06:26.000000', 'temperatura', 880.0000, 'ºC'),
	(75779, 109, '2015-03-01 00:06:27.000000', 'temperatura', 612.0000, 'ºC'),
	(75780, 109, '2015-03-01 00:06:28.000000', 'temperatura', 420.0000, 'ºC'),
	(75781, 109, '2015-03-01 00:06:29.000000', 'temperatura', 264.0000, 'ºC'),
	(75782, 109, '2015-03-01 00:06:30.000000', 'temperatura', 63.0000, 'ºC'),
	(75783, 109, '2015-03-01 00:06:31.000000', 'temperatura', 721.0000, 'ºC'),
	(75784, 109, '2015-03-01 00:06:32.000000', 'temperatura', 1016.0000, 'ºC'),
	(75785, 109, '2015-03-01 00:06:33.000000', 'temperatura', 519.0000, 'ºC'),
	(75786, 109, '2015-03-01 00:06:34.000000', 'temperatura', 747.0000, 'ºC'),
	(75787, 109, '2015-03-01 00:06:35.000000', 'temperatura', 977.0000, 'ºC'),
	(75788, 109, '2015-03-01 00:06:36.000000', 'temperatura', 247.0000, 'ºC'),
	(75789, 109, '2015-03-01 00:06:37.000000', 'temperatura', 704.0000, 'ºC'),
	(75790, 109, '2015-03-01 00:06:38.000000', 'temperatura', 379.0000, 'ºC'),
	(75791, 109, '2015-03-01 00:06:39.000000', 'temperatura', 982.0000, 'ºC'),
	(75792, 109, '2015-03-01 00:06:40.000000', 'temperatura', 177.0000, 'ºC'),
	(75793, 109, '2015-03-01 00:06:41.000000', 'temperatura', 336.0000, 'ºC'),
	(75794, 109, '2015-03-01 00:06:42.000000', 'temperatura', 1150.0000, 'ºC'),
	(75795, 109, '2015-03-01 00:06:43.000000', 'temperatura', 1144.0000, 'ºC'),
	(75796, 109, '2015-03-01 00:06:44.000000', 'temperatura', 1070.0000, 'ºC'),
	(75797, 109, '2015-03-01 00:06:45.000000', 'temperatura', 716.0000, 'ºC'),
	(75798, 109, '2015-03-01 00:06:46.000000', 'temperatura', 373.0000, 'ºC'),
	(75799, 109, '2015-03-01 00:06:47.000000', 'temperatura', 918.0000, 'ºC'),
	(75800, 109, '2015-03-01 00:06:48.000000', 'temperatura', 1072.0000, 'ºC'),
	(75801, 109, '2015-03-01 00:06:49.000000', 'temperatura', 205.0000, 'ºC'),
	(75802, 109, '2015-03-01 00:06:50.000000', 'temperatura', 209.0000, 'ºC'),
	(75803, 109, '2015-03-01 00:06:51.000000', 'temperatura', 433.0000, 'ºC'),
	(75804, 109, '2015-03-01 00:06:52.000000', 'temperatura', 338.0000, 'ºC'),
	(75805, 109, '2015-03-01 00:06:53.000000', 'temperatura', 392.0000, 'ºC'),
	(75806, 109, '2015-03-01 00:06:54.000000', 'temperatura', 945.0000, 'ºC'),
	(75807, 109, '2015-03-01 00:06:55.000000', 'temperatura', 1151.0000, 'ºC'),
	(75808, 109, '2015-03-01 00:06:56.000000', 'temperatura', 520.0000, 'ºC'),
	(75809, 109, '2015-03-01 00:06:57.000000', 'temperatura', 348.0000, 'ºC'),
	(75810, 109, '2015-03-01 00:06:58.000000', 'temperatura', 180.0000, 'ºC'),
	(75811, 109, '2015-03-01 00:06:59.000000', 'temperatura', 1056.0000, 'ºC'),
	(75812, 109, '2015-03-01 00:07:00.000000', 'temperatura', 1140.0000, 'ºC'),
	(75813, 109, '2015-03-01 00:07:01.000000', 'temperatura', 135.0000, 'ºC'),
	(75814, 109, '2015-03-01 00:07:02.000000', 'temperatura', 855.0000, 'ºC'),
	(75815, 109, '2015-03-01 00:07:03.000000', 'temperatura', 268.0000, 'ºC'),
	(75816, 109, '2015-03-01 00:07:04.000000', 'temperatura', 1178.0000, 'ºC'),
	(75817, 109, '2015-03-01 00:07:05.000000', 'temperatura', 288.0000, 'ºC'),
	(75818, 109, '2015-03-01 00:07:06.000000', 'temperatura', 303.0000, 'ºC'),
	(75819, 109, '2015-03-01 00:07:07.000000', 'temperatura', 652.0000, 'ºC'),
	(75820, 109, '2015-03-01 00:07:08.000000', 'temperatura', 1151.0000, 'ºC'),
	(75821, 109, '2015-03-01 00:07:09.000000', 'temperatura', 200.0000, 'ºC'),
	(75822, 109, '2015-03-01 00:07:10.000000', 'temperatura', 1146.0000, 'ºC'),
	(75823, 109, '2015-03-01 00:07:11.000000', 'temperatura', 333.0000, 'ºC'),
	(75824, 109, '2015-03-01 00:07:12.000000', 'temperatura', 626.0000, 'ºC'),
	(75825, 109, '2015-03-01 00:07:13.000000', 'temperatura', 932.0000, 'ºC'),
	(75826, 109, '2015-03-01 00:07:14.000000', 'temperatura', 381.0000, 'ºC'),
	(75827, 109, '2015-03-01 00:07:15.000000', 'temperatura', 311.0000, 'ºC'),
	(75828, 109, '2015-03-01 00:07:16.000000', 'temperatura', 412.0000, 'ºC'),
	(75829, 109, '2015-03-01 00:07:17.000000', 'temperatura', 1127.0000, 'ºC'),
	(75830, 109, '2015-03-01 00:07:18.000000', 'temperatura', 800.0000, 'ºC'),
	(75831, 109, '2015-03-01 00:07:19.000000', 'temperatura', 619.0000, 'ºC'),
	(75832, 109, '2015-03-01 00:07:20.000000', 'temperatura', 694.0000, 'ºC'),
	(75833, 109, '2015-03-01 00:07:21.000000', 'temperatura', 413.0000, 'ºC'),
	(75834, 109, '2015-03-01 00:07:22.000000', 'temperatura', 1186.0000, 'ºC'),
	(75835, 109, '2015-03-01 00:07:23.000000', 'temperatura', 1093.0000, 'ºC'),
	(75836, 109, '2015-03-01 00:07:24.000000', 'temperatura', 705.0000, 'ºC'),
	(75837, 109, '2015-03-01 00:07:25.000000', 'temperatura', 246.0000, 'ºC'),
	(75838, 109, '2015-03-01 00:07:26.000000', 'temperatura', 316.0000, 'ºC'),
	(75839, 109, '2015-03-01 00:07:27.000000', 'temperatura', 843.0000, 'ºC'),
	(75840, 109, '2015-03-01 00:07:28.000000', 'temperatura', 866.0000, 'ºC'),
	(75841, 109, '2015-03-01 00:07:29.000000', 'temperatura', 602.0000, 'ºC'),
	(75842, 109, '2015-03-01 00:07:30.000000', 'temperatura', 415.0000, 'ºC'),
	(75843, 109, '2015-03-01 00:07:31.000000', 'temperatura', 266.0000, 'ºC'),
	(75844, 109, '2015-03-01 00:07:32.000000', 'temperatura', 89.0000, 'ºC'),
	(75845, 109, '2015-03-01 00:07:33.000000', 'temperatura', 846.0000, 'ºC'),
	(75846, 109, '2015-03-01 00:07:34.000000', 'temperatura', 362.0000, 'ºC'),
	(75847, 109, '2015-03-01 00:07:35.000000', 'temperatura', 473.0000, 'ºC'),
	(75848, 109, '2015-03-01 00:07:36.000000', 'temperatura', 81.0000, 'ºC'),
	(75849, 109, '2015-03-01 00:07:37.000000', 'temperatura', 187.0000, 'ºC'),
	(75850, 109, '2015-03-01 00:07:38.000000', 'temperatura', 693.0000, 'ºC'),
	(75851, 109, '2015-03-01 00:07:39.000000', 'temperatura', 504.0000, 'ºC'),
	(75852, 109, '2015-03-01 00:07:40.000000', 'temperatura', 443.0000, 'ºC'),
	(75853, 109, '2015-03-01 00:07:41.000000', 'temperatura', 702.0000, 'ºC'),
	(75854, 109, '2015-03-01 00:07:42.000000', 'temperatura', 983.0000, 'ºC'),
	(75855, 109, '2015-03-01 00:07:43.000000', 'temperatura', 407.0000, 'ºC'),
	(75856, 109, '2015-03-01 00:07:44.000000', 'temperatura', 287.0000, 'ºC'),
	(75857, 109, '2015-03-01 00:07:45.000000', 'temperatura', 214.0000, 'ºC'),
	(75858, 109, '2015-03-01 00:07:46.000000', 'temperatura', 210.0000, 'ºC'),
	(75859, 109, '2015-03-01 00:07:47.000000', 'temperatura', 407.0000, 'ºC'),
	(75860, 109, '2015-03-01 00:07:48.000000', 'temperatura', 207.0000, 'ºC'),
	(75861, 109, '2015-03-01 00:07:49.000000', 'temperatura', 1012.0000, 'ºC'),
	(75862, 109, '2015-03-01 00:07:50.000000', 'temperatura', 842.0000, 'ºC'),
	(75863, 109, '2015-03-01 00:07:51.000000', 'temperatura', 1173.0000, 'ºC'),
	(75864, 109, '2015-03-01 00:07:52.000000', 'temperatura', 941.0000, 'ºC'),
	(75865, 109, '2015-03-01 00:07:53.000000', 'temperatura', 1185.0000, 'ºC'),
	(75866, 109, '2015-03-01 00:07:54.000000', 'temperatura', 702.0000, 'ºC'),
	(75867, 109, '2015-03-01 00:07:55.000000', 'temperatura', 1156.0000, 'ºC'),
	(75868, 109, '2015-03-01 00:07:56.000000', 'temperatura', 73.0000, 'ºC'),
	(75869, 109, '2015-03-01 00:07:57.000000', 'temperatura', 498.0000, 'ºC'),
	(75870, 109, '2015-03-01 00:07:58.000000', 'temperatura', 1070.0000, 'ºC'),
	(75871, 109, '2015-03-01 00:07:59.000000', 'temperatura', 258.0000, 'ºC'),
	(75872, 109, '2015-03-01 00:08:00.000000', 'temperatura', 479.0000, 'ºC'),
	(75873, 109, '2015-03-01 00:08:01.000000', 'temperatura', 423.0000, 'ºC'),
	(75874, 109, '2015-03-01 00:08:02.000000', 'temperatura', 678.0000, 'ºC'),
	(75875, 109, '2015-03-01 00:08:03.000000', 'temperatura', 920.0000, 'ºC'),
	(75876, 109, '2015-03-01 00:08:04.000000', 'temperatura', 169.0000, 'ºC'),
	(75877, 109, '2015-03-01 00:08:05.000000', 'temperatura', 484.0000, 'ºC'),
	(75878, 109, '2015-03-01 00:08:06.000000', 'temperatura', 714.0000, 'ºC'),
	(75879, 109, '2015-03-01 00:08:07.000000', 'temperatura', 920.0000, 'ºC'),
	(75880, 109, '2015-03-01 00:08:08.000000', 'temperatura', 56.0000, 'ºC'),
	(75881, 109, '2015-03-01 00:08:09.000000', 'temperatura', 1122.0000, 'ºC'),
	(75882, 109, '2015-03-01 00:08:10.000000', 'temperatura', 640.0000, 'ºC'),
	(75883, 109, '2015-03-01 00:08:11.000000', 'temperatura', 1036.0000, 'ºC'),
	(75884, 109, '2015-03-01 00:08:12.000000', 'temperatura', 862.0000, 'ºC'),
	(75885, 109, '2015-03-01 00:08:13.000000', 'temperatura', 2.0000, 'ºC'),
	(75886, 109, '2015-03-01 00:08:14.000000', 'temperatura', 1025.0000, 'ºC'),
	(75887, 109, '2015-03-01 00:08:15.000000', 'temperatura', 318.0000, 'ºC'),
	(75888, 109, '2015-03-01 00:08:16.000000', 'temperatura', 916.0000, 'ºC'),
	(75889, 109, '2015-03-01 00:08:17.000000', 'temperatura', 28.0000, 'ºC'),
	(75890, 109, '2015-03-01 00:08:18.000000', 'temperatura', 991.0000, 'ºC'),
	(75891, 109, '2015-03-01 00:08:19.000000', 'temperatura', 71.0000, 'ºC'),
	(75892, 109, '2015-03-01 00:08:20.000000', 'temperatura', 985.0000, 'ºC'),
	(75893, 109, '2015-03-01 00:08:21.000000', 'temperatura', 1111.0000, 'ºC'),
	(75894, 109, '2015-03-01 00:08:22.000000', 'temperatura', 199.0000, 'ºC'),
	(75895, 109, '2015-03-01 00:08:23.000000', 'temperatura', 62.0000, 'ºC'),
	(75896, 109, '2015-03-01 00:08:24.000000', 'temperatura', 916.0000, 'ºC'),
	(75897, 109, '2015-03-01 00:08:25.000000', 'temperatura', 792.0000, 'ºC'),
	(75898, 109, '2015-03-01 00:08:26.000000', 'temperatura', 12.0000, 'ºC'),
	(75899, 109, '2015-03-01 00:08:27.000000', 'temperatura', 86.0000, 'ºC'),
	(75900, 109, '2015-03-01 00:08:28.000000', 'temperatura', 394.0000, 'ºC'),
	(75901, 109, '2015-03-01 00:08:29.000000', 'temperatura', 511.0000, 'ºC'),
	(75902, 109, '2015-03-01 00:08:30.000000', 'temperatura', 176.0000, 'ºC'),
	(75903, 109, '2015-03-01 00:08:31.000000', 'temperatura', 546.0000, 'ºC'),
	(75904, 109, '2015-03-01 00:08:32.000000', 'temperatura', 1004.0000, 'ºC'),
	(75905, 109, '2015-03-01 00:08:33.000000', 'temperatura', 982.0000, 'ºC'),
	(75906, 109, '2015-03-01 00:08:34.000000', 'temperatura', 698.0000, 'ºC'),
	(75907, 109, '2015-03-01 00:08:35.000000', 'temperatura', 543.0000, 'ºC'),
	(75908, 109, '2015-03-01 00:08:36.000000', 'temperatura', 622.0000, 'ºC'),
	(75909, 109, '2015-03-01 00:08:37.000000', 'temperatura', 281.0000, 'ºC'),
	(75910, 109, '2015-03-01 00:08:38.000000', 'temperatura', 742.0000, 'ºC'),
	(75911, 109, '2015-03-01 00:08:39.000000', 'temperatura', 467.0000, 'ºC'),
	(75912, 109, '2015-03-01 00:08:40.000000', 'temperatura', 109.0000, 'ºC'),
	(75913, 109, '2015-03-01 00:08:41.000000', 'temperatura', 343.0000, 'ºC'),
	(75914, 109, '2015-03-01 00:08:42.000000', 'temperatura', 190.0000, 'ºC'),
	(75915, 109, '2015-03-01 00:08:43.000000', 'temperatura', 1121.0000, 'ºC'),
	(75916, 109, '2015-03-01 00:08:44.000000', 'temperatura', 237.0000, 'ºC'),
	(75917, 109, '2015-03-01 00:08:45.000000', 'temperatura', 221.0000, 'ºC'),
	(75918, 109, '2015-03-01 00:08:46.000000', 'temperatura', 396.0000, 'ºC'),
	(75919, 109, '2015-03-01 00:08:47.000000', 'temperatura', 117.0000, 'ºC'),
	(75920, 109, '2015-03-01 00:08:48.000000', 'temperatura', 597.0000, 'ºC'),
	(75921, 109, '2015-03-01 00:08:49.000000', 'temperatura', 236.0000, 'ºC'),
	(75922, 109, '2015-03-01 00:08:50.000000', 'temperatura', 589.0000, 'ºC'),
	(75923, 109, '2015-03-01 00:08:51.000000', 'temperatura', 1038.0000, 'ºC'),
	(75924, 109, '2015-03-01 00:08:52.000000', 'temperatura', 1023.0000, 'ºC'),
	(75925, 109, '2015-03-01 00:08:53.000000', 'temperatura', 802.0000, 'ºC'),
	(75926, 109, '2015-03-01 00:08:54.000000', 'temperatura', 943.0000, 'ºC'),
	(75927, 109, '2015-03-01 00:08:55.000000', 'temperatura', 1109.0000, 'ºC'),
	(75928, 109, '2015-03-01 00:08:56.000000', 'temperatura', 318.0000, 'ºC'),
	(75929, 109, '2015-03-01 00:08:57.000000', 'temperatura', 660.0000, 'ºC'),
	(75930, 109, '2015-03-01 00:08:58.000000', 'temperatura', 1149.0000, 'ºC'),
	(75931, 109, '2015-03-01 00:08:59.000000', 'temperatura', 166.0000, 'ºC'),
	(75932, 109, '2015-03-01 00:09:00.000000', 'temperatura', 981.0000, 'ºC'),
	(75933, 109, '2015-03-01 00:09:01.000000', 'temperatura', 811.0000, 'ºC'),
	(75934, 109, '2015-03-01 00:09:02.000000', 'temperatura', 1109.0000, 'ºC'),
	(75935, 109, '2015-03-01 00:09:03.000000', 'temperatura', 716.0000, 'ºC'),
	(75936, 109, '2015-03-01 00:09:04.000000', 'temperatura', 251.0000, 'ºC'),
	(75937, 109, '2015-03-01 00:09:05.000000', 'temperatura', 307.0000, 'ºC'),
	(75938, 109, '2015-03-01 00:09:06.000000', 'temperatura', 783.0000, 'ºC'),
	(75939, 109, '2015-03-01 00:09:07.000000', 'temperatura', 593.0000, 'ºC'),
	(75940, 109, '2015-03-01 00:09:08.000000', 'temperatura', 618.0000, 'ºC'),
	(75941, 109, '2015-03-01 00:09:09.000000', 'temperatura', 113.0000, 'ºC'),
	(75942, 109, '2015-03-01 00:09:10.000000', 'temperatura', 1110.0000, 'ºC'),
	(75943, 109, '2015-03-01 00:09:11.000000', 'temperatura', 411.0000, 'ºC'),
	(75944, 109, '2015-03-01 00:09:12.000000', 'temperatura', 1125.0000, 'ºC'),
	(75945, 109, '2015-03-01 00:09:13.000000', 'temperatura', 795.0000, 'ºC'),
	(75946, 109, '2015-03-01 00:09:14.000000', 'temperatura', 600.0000, 'ºC'),
	(75947, 109, '2015-03-01 00:09:15.000000', 'temperatura', 614.0000, 'ºC'),
	(75948, 109, '2015-03-01 00:09:16.000000', 'temperatura', 70.0000, 'ºC'),
	(75949, 109, '2015-03-01 00:09:17.000000', 'temperatura', 908.0000, 'ºC'),
	(75950, 109, '2015-03-01 00:09:18.000000', 'temperatura', 730.0000, 'ºC'),
	(75951, 109, '2015-03-01 00:09:19.000000', 'temperatura', 926.0000, 'ºC'),
	(75952, 109, '2015-03-01 00:09:20.000000', 'temperatura', 43.0000, 'ºC'),
	(75953, 109, '2015-03-01 00:09:21.000000', 'temperatura', 1036.0000, 'ºC'),
	(75954, 109, '2015-03-01 00:09:22.000000', 'temperatura', 252.0000, 'ºC'),
	(75955, 109, '2015-03-01 00:09:23.000000', 'temperatura', 553.0000, 'ºC'),
	(75956, 109, '2015-03-01 00:09:24.000000', 'temperatura', 807.0000, 'ºC'),
	(75957, 109, '2015-03-01 00:09:25.000000', 'temperatura', 1180.0000, 'ºC'),
	(75958, 109, '2015-03-01 00:09:26.000000', 'temperatura', 1078.0000, 'ºC'),
	(75959, 109, '2015-03-01 00:09:27.000000', 'temperatura', 652.0000, 'ºC'),
	(75960, 109, '2015-03-01 00:09:28.000000', 'temperatura', 23.0000, 'ºC'),
	(75961, 109, '2015-03-01 00:09:29.000000', 'temperatura', 563.0000, 'ºC'),
	(75962, 109, '2015-03-01 00:09:30.000000', 'temperatura', 347.0000, 'ºC'),
	(75963, 109, '2015-03-01 00:09:31.000000', 'temperatura', 43.0000, 'ºC'),
	(75964, 109, '2015-03-01 00:09:32.000000', 'temperatura', 377.0000, 'ºC'),
	(75965, 109, '2015-03-01 00:09:33.000000', 'temperatura', 557.0000, 'ºC'),
	(75966, 109, '2015-03-01 00:09:34.000000', 'temperatura', 454.0000, 'ºC'),
	(75967, 109, '2015-03-01 00:09:35.000000', 'temperatura', 599.0000, 'ºC'),
	(75968, 109, '2015-03-01 00:09:36.000000', 'temperatura', 436.0000, 'ºC'),
	(75969, 109, '2015-03-01 00:09:37.000000', 'temperatura', 380.0000, 'ºC'),
	(75970, 109, '2015-03-01 00:09:38.000000', 'temperatura', 594.0000, 'ºC'),
	(75971, 109, '2015-03-01 00:09:39.000000', 'temperatura', 630.0000, 'ºC'),
	(75972, 109, '2015-03-01 00:09:40.000000', 'temperatura', 171.0000, 'ºC'),
	(75973, 109, '2015-03-01 00:09:41.000000', 'temperatura', 162.0000, 'ºC'),
	(75974, 109, '2015-03-01 00:09:42.000000', 'temperatura', 300.0000, 'ºC'),
	(75975, 109, '2015-03-01 00:09:43.000000', 'temperatura', 1015.0000, 'ºC'),
	(75976, 109, '2015-03-01 00:09:44.000000', 'temperatura', 576.0000, 'ºC'),
	(75977, 109, '2015-03-01 00:09:45.000000', 'temperatura', 1036.0000, 'ºC'),
	(75978, 109, '2015-03-01 00:09:46.000000', 'temperatura', 1052.0000, 'ºC'),
	(75979, 109, '2015-03-01 00:09:47.000000', 'temperatura', 952.0000, 'ºC'),
	(75980, 109, '2015-03-01 00:09:48.000000', 'temperatura', 406.0000, 'ºC'),
	(75981, 109, '2015-03-01 00:09:49.000000', 'temperatura', 373.0000, 'ºC'),
	(75982, 109, '2015-03-01 00:09:50.000000', 'temperatura', 648.0000, 'ºC'),
	(75983, 109, '2015-03-01 00:09:51.000000', 'temperatura', 919.0000, 'ºC'),
	(75984, 109, '2015-03-01 00:09:52.000000', 'temperatura', 255.0000, 'ºC'),
	(75985, 109, '2015-03-01 00:09:53.000000', 'temperatura', 918.0000, 'ºC'),
	(75986, 109, '2015-03-01 00:09:54.000000', 'temperatura', 226.0000, 'ºC'),
	(75987, 109, '2015-03-01 00:09:55.000000', 'temperatura', 774.0000, 'ºC'),
	(75988, 109, '2015-03-01 00:09:56.000000', 'temperatura', 794.0000, 'ºC'),
	(75989, 109, '2015-03-01 00:09:57.000000', 'temperatura', 449.0000, 'ºC'),
	(75990, 109, '2015-03-01 00:09:58.000000', 'temperatura', 1064.0000, 'ºC'),
	(75991, 109, '2015-03-01 00:09:59.000000', 'temperatura', 373.0000, 'ºC'),
	(75992, 109, '2015-03-01 00:10:00.000000', 'temperatura', 1073.0000, 'ºC'),
	(75993, 109, '2015-03-01 00:10:01.000000', 'temperatura', 648.0000, 'ºC'),
	(75994, 109, '2015-03-01 00:10:02.000000', 'temperatura', 21.0000, 'ºC'),
	(75995, 109, '2015-03-01 00:10:03.000000', 'temperatura', 563.0000, 'ºC'),
	(75996, 109, '2015-03-01 00:10:04.000000', 'temperatura', 352.0000, 'ºC'),
	(75997, 109, '2015-03-01 00:10:05.000000', 'temperatura', 71.0000, 'ºC'),
	(75998, 109, '2015-03-01 00:10:06.000000', 'temperatura', 499.0000, 'ºC'),
	(75999, 109, '2015-03-01 00:10:07.000000', 'temperatura', 1083.0000, 'ºC'),
	(76000, 109, '2015-03-01 00:10:08.000000', 'temperatura', 318.0000, 'ºC'),
	(76001, 109, '2015-03-01 00:10:09.000000', 'temperatura', 743.0000, 'ºC'),
	(76002, 109, '2015-03-01 00:10:10.000000', 'temperatura', 359.0000, 'ºC'),
	(76003, 109, '2015-03-01 00:10:11.000000', 'temperatura', 768.0000, 'ºC'),
	(76004, 109, '2015-03-01 00:10:12.000000', 'temperatura', 362.0000, 'ºC'),
	(76005, 109, '2015-03-01 00:10:13.000000', 'temperatura', 708.0000, 'ºC'),
	(76006, 109, '2015-03-01 00:10:14.000000', 'temperatura', 54.0000, 'ºC'),
	(76007, 109, '2015-03-01 00:10:15.000000', 'temperatura', 548.0000, 'ºC'),
	(76008, 109, '2015-03-01 00:10:16.000000', 'temperatura', 179.0000, 'ºC'),
	(76009, 109, '2015-03-01 00:10:17.000000', 'temperatura', 449.0000, 'ºC'),
	(76010, 109, '2015-03-01 00:10:18.000000', 'temperatura', 510.0000, 'ºC'),
	(76011, 109, '2015-03-01 00:10:19.000000', 'temperatura', 1.0000, 'ºC'),
	(76012, 109, '2015-03-01 00:10:20.000000', 'temperatura', 877.0000, 'ºC'),
	(76013, 109, '2015-03-01 00:10:21.000000', 'temperatura', 784.0000, 'ºC'),
	(76014, 109, '2015-03-01 00:10:22.000000', 'temperatura', 90.0000, 'ºC'),
	(76015, 109, '2015-03-01 00:10:23.000000', 'temperatura', 496.0000, 'ºC'),
	(76016, 109, '2015-03-01 00:10:24.000000', 'temperatura', 1009.0000, 'ºC'),
	(76017, 109, '2015-03-01 00:10:25.000000', 'temperatura', 1161.0000, 'ºC'),
	(76018, 109, '2015-03-01 00:10:26.000000', 'temperatura', 378.0000, 'ºC'),
	(76019, 109, '2015-03-01 00:10:27.000000', 'temperatura', 808.0000, 'ºC'),
	(76020, 109, '2015-03-01 00:10:28.000000', 'temperatura', 505.0000, 'ºC'),
	(76021, 109, '2015-03-01 00:10:29.000000', 'temperatura', 101.0000, 'ºC'),
	(76022, 109, '2015-03-01 00:10:30.000000', 'temperatura', 191.0000, 'ºC'),
	(76023, 109, '2015-03-01 00:10:31.000000', 'temperatura', 652.0000, 'ºC'),
	(76024, 109, '2015-03-01 00:10:32.000000', 'temperatura', 287.0000, 'ºC'),
	(76025, 109, '2015-03-01 00:10:33.000000', 'temperatura', 682.0000, 'ºC'),
	(76026, 109, '2015-03-01 00:10:34.000000', 'temperatura', 147.0000, 'ºC'),
	(76027, 109, '2015-03-01 00:10:35.000000', 'temperatura', 1092.0000, 'ºC'),
	(76028, 109, '2015-03-01 00:10:36.000000', 'temperatura', 219.0000, 'ºC'),
	(76029, 109, '2015-03-01 00:10:37.000000', 'temperatura', 218.0000, 'ºC'),
	(76030, 109, '2015-03-01 00:10:38.000000', 'temperatura', 435.0000, 'ºC'),
	(76031, 109, '2015-03-01 00:10:39.000000', 'temperatura', 319.0000, 'ºC'),
	(76032, 109, '2015-03-01 00:10:40.000000', 'temperatura', 294.0000, 'ºC'),
	(76033, 109, '2015-03-01 00:10:41.000000', 'temperatura', 511.0000, 'ºC'),
	(76034, 109, '2015-03-01 00:10:42.000000', 'temperatura', 475.0000, 'ºC'),
	(76035, 109, '2015-03-01 00:10:43.000000', 'temperatura', 842.0000, 'ºC'),
	(76036, 109, '2015-03-01 00:10:44.000000', 'temperatura', 386.0000, 'ºC'),
	(76037, 109, '2015-03-01 00:10:45.000000', 'temperatura', 602.0000, 'ºC'),
	(76038, 109, '2015-03-01 00:10:46.000000', 'temperatura', 655.0000, 'ºC'),
	(76039, 109, '2015-03-01 00:10:47.000000', 'temperatura', 270.0000, 'ºC'),
	(76040, 109, '2015-03-01 00:10:48.000000', 'temperatura', 583.0000, 'ºC'),
	(76041, 109, '2015-03-01 00:10:49.000000', 'temperatura', 906.0000, 'ºC'),
	(76042, 109, '2015-03-01 00:10:50.000000', 'temperatura', 384.0000, 'ºC'),
	(76043, 109, '2015-03-01 00:10:51.000000', 'temperatura', 401.0000, 'ºC'),
	(76044, 109, '2015-03-01 00:10:52.000000', 'temperatura', 852.0000, 'ºC'),
	(76045, 109, '2015-03-01 00:10:53.000000', 'temperatura', 659.0000, 'ºC'),
	(76046, 109, '2015-03-01 00:10:54.000000', 'temperatura', 738.0000, 'ºC'),
	(76047, 109, '2015-03-01 00:10:55.000000', 'temperatura', 514.0000, 'ºC'),
	(76048, 109, '2015-03-01 00:10:56.000000', 'temperatura', 355.0000, 'ºC'),
	(76049, 109, '2015-03-01 00:10:57.000000', 'temperatura', 235.0000, 'ºC'),
	(76050, 109, '2015-03-01 00:10:58.000000', 'temperatura', 109.0000, 'ºC'),
	(76051, 109, '2015-03-01 00:10:59.000000', 'temperatura', 1040.0000, 'ºC'),
	(76052, 109, '2015-03-01 00:11:00.000000', 'temperatura', 73.0000, 'ºC'),
	(76053, 109, '2015-03-01 00:11:01.000000', 'temperatura', 846.0000, 'ºC'),
	(76054, 109, '2015-03-01 00:11:02.000000', 'temperatura', 413.0000, 'ºC'),
	(76055, 109, '2015-03-01 00:11:03.000000', 'temperatura', 725.0000, 'ºC'),
	(76056, 109, '2015-03-01 00:11:04.000000', 'temperatura', 1188.0000, 'ºC'),
	(76057, 109, '2015-03-01 00:11:05.000000', 'temperatura', 167.0000, 'ºC'),
	(76058, 109, '2015-03-01 00:11:06.000000', 'temperatura', 870.0000, 'ºC'),
	(76059, 109, '2015-03-01 00:11:07.000000', 'temperatura', 248.0000, 'ºC'),
	(76060, 109, '2015-03-01 00:11:08.000000', 'temperatura', 1032.0000, 'ºC'),
	(76061, 109, '2015-03-01 00:11:09.000000', 'temperatura', 818.0000, 'ºC'),
	(76062, 109, '2015-03-01 00:11:10.000000', 'temperatura', 993.0000, 'ºC'),
	(76063, 109, '2015-03-01 00:11:11.000000', 'temperatura', 113.0000, 'ºC'),
	(76064, 109, '2015-03-01 00:11:12.000000', 'temperatura', 1186.0000, 'ºC'),
	(76065, 109, '2015-03-01 00:11:13.000000', 'temperatura', 791.0000, 'ºC'),
	(76066, 109, '2015-03-01 00:11:14.000000', 'temperatura', 400.0000, 'ºC'),
	(76067, 109, '2015-03-01 00:11:15.000000', 'temperatura', 825.0000, 'ºC'),
	(76068, 109, '2015-03-01 00:11:16.000000', 'temperatura', 525.0000, 'ºC'),
	(76069, 109, '2015-03-01 00:11:17.000000', 'temperatura', 151.0000, 'ºC'),
	(76070, 109, '2015-03-01 00:11:18.000000', 'temperatura', 379.0000, 'ºC'),
	(76071, 109, '2015-03-01 00:11:19.000000', 'temperatura', 242.0000, 'ºC'),
	(76072, 109, '2015-03-01 00:11:20.000000', 'temperatura', 75.0000, 'ºC'),
	(76073, 109, '2015-03-01 00:11:21.000000', 'temperatura', 849.0000, 'ºC'),
	(76074, 109, '2015-03-01 00:11:22.000000', 'temperatura', 421.0000, 'ºC'),
	(76075, 109, '2015-03-01 00:11:23.000000', 'temperatura', 757.0000, 'ºC'),
	(76076, 109, '2015-03-01 00:11:24.000000', 'temperatura', 122.0000, 'ºC'),
	(76077, 109, '2015-03-01 00:11:25.000000', 'temperatura', 742.0000, 'ºC'),
	(76078, 109, '2015-03-01 00:11:26.000000', 'temperatura', 943.0000, 'ºC'),
	(76079, 109, '2015-03-01 00:11:27.000000', 'temperatura', 92.0000, 'ºC'),
	(76080, 109, '2015-03-01 00:11:28.000000', 'temperatura', 29.0000, 'ºC'),
	(76081, 109, '2015-03-01 00:11:29.000000', 'temperatura', 1070.0000, 'ºC'),
	(76082, 109, '2015-03-01 00:11:30.000000', 'temperatura', 465.0000, 'ºC'),
	(76083, 109, '2015-03-01 00:11:31.000000', 'temperatura', 312.0000, 'ºC'),
	(76084, 109, '2015-03-01 00:11:32.000000', 'temperatura', 169.0000, 'ºC'),
	(76085, 109, '2015-03-01 00:11:33.000000', 'temperatura', 1110.0000, 'ºC'),
	(76086, 109, '2015-03-01 00:11:34.000000', 'temperatura', 240.0000, 'ºC'),
	(76087, 109, '2015-03-01 00:11:35.000000', 'temperatura', 273.0000, 'ºC'),
	(76088, 109, '2015-03-01 00:11:36.000000', 'temperatura', 647.0000, 'ºC'),
	(76089, 109, '2015-03-01 00:11:37.000000', 'temperatura', 14.0000, 'ºC'),
	(76090, 109, '2015-03-01 00:11:38.000000', 'temperatura', 529.0000, 'ºC'),
	(76091, 109, '2015-03-01 00:11:39.000000', 'temperatura', 206.0000, 'ºC'),
	(76092, 109, '2015-03-01 00:11:40.000000', 'temperatura', 640.0000, 'ºC'),
	(76093, 109, '2015-03-01 00:11:41.000000', 'temperatura', 185.0000, 'ºC'),
	(76094, 109, '2015-03-01 00:11:42.000000', 'temperatura', 207.0000, 'ºC'),
	(76095, 109, '2015-03-01 00:11:43.000000', 'temperatura', 479.0000, 'ºC'),
	(76096, 109, '2015-03-01 00:11:44.000000', 'temperatura', 573.0000, 'ºC'),
	(76097, 109, '2015-03-01 00:11:45.000000', 'temperatura', 228.0000, 'ºC'),
	(76098, 109, '2015-03-01 00:11:46.000000', 'temperatura', 621.0000, 'ºC'),
	(76099, 109, '2015-03-01 00:11:47.000000', 'temperatura', 22.0000, 'ºC'),
	(76100, 109, '2015-03-01 00:11:48.000000', 'temperatura', 646.0000, 'ºC'),
	(76101, 109, '2015-03-01 00:11:49.000000', 'temperatura', 767.0000, 'ºC'),
	(76102, 109, '2015-03-01 00:11:50.000000', 'temperatura', 698.0000, 'ºC'),
	(76103, 109, '2015-03-01 00:11:51.000000', 'temperatura', 1190.0000, 'ºC'),
	(76104, 109, '2015-03-01 00:11:52.000000', 'temperatura', 255.0000, 'ºC'),
	(76105, 109, '2015-03-01 00:11:53.000000', 'temperatura', 106.0000, 'ºC'),
	(76106, 109, '2015-03-01 00:11:54.000000', 'temperatura', 964.0000, 'ºC'),
	(76107, 109, '2015-03-01 00:11:55.000000', 'temperatura', 903.0000, 'ºC'),
	(76108, 109, '2015-03-01 00:11:56.000000', 'temperatura', 423.0000, 'ºC'),
	(76109, 109, '2015-03-01 00:11:57.000000', 'temperatura', 606.0000, 'ºC'),
	(76110, 109, '2015-03-01 00:11:58.000000', 'temperatura', 560.0000, 'ºC'),
	(76111, 109, '2015-03-01 00:11:59.000000', 'temperatura', 986.0000, 'ºC'),
	(76112, 109, '2015-03-01 00:12:00.000000', 'temperatura', 849.0000, 'ºC'),
	(76113, 109, '2015-03-01 00:12:01.000000', 'temperatura', 89.0000, 'ºC'),
	(76114, 109, '2015-03-01 00:12:02.000000', 'temperatura', 296.0000, 'ºC'),
	(76115, 109, '2015-03-01 00:12:03.000000', 'temperatura', 15.0000, 'ºC'),
	(76116, 109, '2015-03-01 00:12:04.000000', 'temperatura', 389.0000, 'ºC'),
	(76117, 109, '2015-03-01 00:12:05.000000', 'temperatura', 699.0000, 'ºC'),
	(76118, 109, '2015-03-01 00:12:06.000000', 'temperatura', 1129.0000, 'ºC'),
	(76119, 109, '2015-03-01 00:12:07.000000', 'temperatura', 1148.0000, 'ºC'),
	(76120, 109, '2015-03-01 00:12:08.000000', 'temperatura', 1155.0000, 'ºC'),
	(76121, 109, '2015-03-01 00:12:09.000000', 'temperatura', 1132.0000, 'ºC'),
	(76122, 109, '2015-03-01 00:12:10.000000', 'temperatura', 994.0000, 'ºC'),
	(76123, 109, '2015-03-01 00:12:11.000000', 'temperatura', 373.0000, 'ºC'),
	(76124, 109, '2015-03-01 00:12:12.000000', 'temperatura', 84.0000, 'ºC'),
	(76125, 109, '2015-03-01 00:12:13.000000', 'temperatura', 501.0000, 'ºC'),
	(76126, 109, '2015-03-01 00:12:14.000000', 'temperatura', 1054.0000, 'ºC'),
	(76127, 109, '2015-03-01 00:12:15.000000', 'temperatura', 166.0000, 'ºC'),
	(76128, 109, '2015-03-01 00:12:16.000000', 'temperatura', 72.0000, 'ºC'),
	(76129, 109, '2015-03-01 00:12:17.000000', 'temperatura', 1060.0000, 'ºC'),
	(76130, 109, '2015-03-01 00:12:18.000000', 'temperatura', 283.0000, 'ºC'),
	(76131, 109, '2015-03-01 00:12:19.000000', 'temperatura', 638.0000, 'ºC'),
	(76132, 109, '2015-03-01 00:12:20.000000', 'temperatura', 1141.0000, 'ºC'),
	(76133, 109, '2015-03-01 00:12:21.000000', 'temperatura', 190.0000, 'ºC'),
	(76134, 109, '2015-03-01 00:12:22.000000', 'temperatura', 1127.0000, 'ºC'),
	(76135, 109, '2015-03-01 00:12:23.000000', 'temperatura', 266.0000, 'ºC'),
	(76136, 109, '2015-03-01 00:12:24.000000', 'temperatura', 350.0000, 'ºC'),
	(76137, 109, '2015-03-01 00:12:25.000000', 'temperatura', 952.0000, 'ºC'),
	(76138, 109, '2015-03-01 00:12:26.000000', 'temperatura', 112.0000, 'ºC'),
	(76139, 109, '2015-03-01 00:12:27.000000', 'temperatura', 103.0000, 'ºC'),
	(76140, 109, '2015-03-01 00:12:28.000000', 'temperatura', 180.0000, 'ºC'),
	(76141, 109, '2015-03-01 00:12:29.000000', 'temperatura', 592.0000, 'ºC'),
	(76142, 109, '2015-03-01 00:12:30.000000', 'temperatura', 21.0000, 'ºC'),
	(76143, 109, '2015-03-01 00:12:31.000000', 'temperatura', 729.0000, 'ºC'),
	(76144, 109, '2015-03-01 00:12:32.000000', 'temperatura', 1182.0000, 'ºC'),
	(76145, 109, '2015-03-01 00:12:33.000000', 'temperatura', 126.0000, 'ºC'),
	(76146, 109, '2015-03-01 00:12:34.000000', 'temperatura', 682.0000, 'ºC'),
	(76147, 109, '2015-03-01 00:12:35.000000', 'temperatura', 633.0000, 'ºC'),
	(76148, 109, '2015-03-01 00:12:36.000000', 'temperatura', 1119.0000, 'ºC'),
	(76149, 109, '2015-03-01 00:12:37.000000', 'temperatura', 96.0000, 'ºC'),
	(76150, 109, '2015-03-01 00:12:38.000000', 'temperatura', 723.0000, 'ºC'),
	(76151, 109, '2015-03-01 00:12:39.000000', 'temperatura', 929.0000, 'ºC'),
	(76152, 109, '2015-03-01 00:12:40.000000', 'temperatura', 78.0000, 'ºC'),
	(76153, 109, '2015-03-01 00:12:41.000000', 'temperatura', 1.0000, 'ºC'),
	(76154, 109, '2015-03-01 00:12:42.000000', 'temperatura', 971.0000, 'ºC'),
	(76155, 109, '2015-03-01 00:12:43.000000', 'temperatura', 52.0000, 'ºC'),
	(76156, 109, '2015-03-01 00:12:44.000000', 'temperatura', 947.0000, 'ºC'),
	(76157, 109, '2015-03-01 00:12:45.000000', 'temperatura', 983.0000, 'ºC'),
	(76158, 109, '2015-03-01 00:12:46.000000', 'temperatura', 871.0000, 'ºC'),
	(76159, 109, '2015-03-01 00:12:47.000000', 'temperatura', 207.0000, 'ºC'),
	(76160, 109, '2015-03-01 00:12:48.000000', 'temperatura', 823.0000, 'ºC'),
	(76161, 109, '2015-03-01 00:12:49.000000', 'temperatura', 1093.0000, 'ºC'),
	(76162, 109, '2015-03-01 00:12:50.000000', 'temperatura', 598.0000, 'ºC'),
	(76163, 109, '2015-03-01 00:12:51.000000', 'temperatura', 912.0000, 'ºC'),
	(76164, 109, '2015-03-01 00:12:52.000000', 'temperatura', 366.0000, 'ºC'),
	(76165, 109, '2015-03-01 00:12:53.000000', 'temperatura', 296.0000, 'ºC'),
	(76166, 109, '2015-03-01 00:12:54.000000', 'temperatura', 380.0000, 'ºC'),
	(76167, 109, '2015-03-01 00:12:55.000000', 'temperatura', 1015.0000, 'ºC'),
	(76168, 109, '2015-03-01 00:12:56.000000', 'temperatura', 336.0000, 'ºC'),
	(76169, 109, '2015-03-01 00:12:57.000000', 'temperatura', 1034.0000, 'ºC'),
	(76170, 109, '2015-03-01 00:12:58.000000', 'temperatura', 565.0000, 'ºC'),
	(76171, 109, '2015-03-01 00:12:59.000000', 'temperatura', 920.0000, 'ºC'),
	(76172, 109, '2015-03-01 00:13:00.000000', 'temperatura', 509.0000, 'ºC'),
	(76173, 109, '2015-03-01 00:13:01.000000', 'temperatura', 983.0000, 'ºC'),
	(76174, 109, '2015-03-01 00:13:02.000000', 'temperatura', 991.0000, 'ºC'),
	(76175, 109, '2015-03-01 00:13:03.000000', 'temperatura', 805.0000, 'ºC'),
	(76176, 109, '2015-03-01 00:13:04.000000', 'temperatura', 1052.0000, 'ºC'),
	(76177, 109, '2015-03-01 00:13:05.000000', 'temperatura', 447.0000, 'ºC'),
	(76178, 109, '2015-03-01 00:13:06.000000', 'temperatura', 279.0000, 'ºC'),
	(76179, 109, '2015-03-01 00:13:07.000000', 'temperatura', 56.0000, 'ºC'),
	(76180, 109, '2015-03-01 00:13:08.000000', 'temperatura', 643.0000, 'ºC'),
	(76181, 109, '2015-03-01 00:13:09.000000', 'temperatura', 648.0000, 'ºC'),
	(76182, 109, '2015-03-01 00:13:10.000000', 'temperatura', 111.0000, 'ºC'),
	(76183, 109, '2015-03-01 00:13:11.000000', 'temperatura', 1013.0000, 'ºC'),
	(76184, 109, '2015-03-01 00:13:12.000000', 'temperatura', 1133.0000, 'ºC'),
	(76185, 109, '2015-03-01 00:13:13.000000', 'temperatura', 227.0000, 'ºC'),
	(76186, 109, '2015-03-01 00:13:14.000000', 'temperatura', 134.0000, 'ºC'),
	(76187, 109, '2015-03-01 00:13:15.000000', 'temperatura', 1190.0000, 'ºC'),
	(76188, 109, '2015-03-01 00:13:16.000000', 'temperatura', 750.0000, 'ºC'),
	(76189, 109, '2015-03-01 00:13:17.000000', 'temperatura', 181.0000, 'ºC'),
	(76190, 109, '2015-03-01 00:13:18.000000', 'temperatura', 1056.0000, 'ºC'),
	(76191, 109, '2015-03-01 00:13:19.000000', 'temperatura', 1137.0000, 'ºC'),
	(76192, 109, '2015-03-01 00:13:20.000000', 'temperatura', 117.0000, 'ºC'),
	(76193, 109, '2015-03-01 00:13:21.000000', 'temperatura', 775.0000, 'ºC'),
	(76194, 109, '2015-03-01 00:13:22.000000', 'temperatura', 1126.0000, 'ºC'),
	(76195, 109, '2015-03-01 00:13:23.000000', 'temperatura', 903.0000, 'ºC'),
	(76196, 109, '2015-03-01 00:13:24.000000', 'temperatura', 1138.0000, 'ºC'),
	(76197, 109, '2015-03-01 00:13:25.000000', 'temperatura', 581.0000, 'ºC'),
	(76198, 109, '2015-03-01 00:13:26.000000', 'temperatura', 694.0000, 'ºC'),
	(76199, 109, '2015-03-01 00:13:27.000000', 'temperatura', 525.0000, 'ºC'),
	(76200, 109, '2015-03-01 00:13:28.000000', 'temperatura', 544.0000, 'ºC'),
	(76201, 109, '2015-03-01 00:13:29.000000', 'temperatura', 1147.0000, 'ºC'),
	(76202, 109, '2015-03-01 00:13:30.000000', 'temperatura', 502.0000, 'ºC'),
	(76203, 109, '2015-03-01 00:13:31.000000', 'temperatura', 271.0000, 'ºC'),
	(76204, 109, '2015-03-01 00:13:32.000000', 'temperatura', 1047.0000, 'ºC'),
	(76205, 109, '2015-03-01 00:13:33.000000', 'temperatura', 826.0000, 'ºC'),
	(76206, 109, '2015-03-01 00:13:34.000000', 'temperatura', 987.0000, 'ºC'),
	(76207, 109, '2015-03-01 00:13:35.000000', 'temperatura', 58.0000, 'ºC'),
	(76208, 109, '2015-03-01 00:13:36.000000', 'temperatura', 931.0000, 'ºC'),
	(76209, 109, '2015-03-01 00:13:37.000000', 'temperatura', 880.0000, 'ºC'),
	(76210, 109, '2015-03-01 00:13:38.000000', 'temperatura', 407.0000, 'ºC'),
	(76211, 109, '2015-03-01 00:13:39.000000', 'temperatura', 597.0000, 'ºC'),
	(76212, 109, '2015-03-01 00:13:40.000000', 'temperatura', 565.0000, 'ºC'),
	(76213, 109, '2015-03-01 00:13:41.000000', 'temperatura', 1035.0000, 'ºC'),
	(76214, 109, '2015-03-01 00:13:42.000000', 'temperatura', 1078.0000, 'ºC'),
	(76215, 109, '2015-03-01 00:13:43.000000', 'temperatura', 1087.0000, 'ºC'),
	(76216, 109, '2015-03-01 00:13:44.000000', 'temperatura', 1000.0000, 'ºC'),
	(76217, 109, '2015-03-01 00:13:45.000000', 'temperatura', 541.0000, 'ºC'),
	(76218, 109, '2015-03-01 00:13:46.000000', 'temperatura', 904.0000, 'ºC'),
	(76219, 109, '2015-03-01 00:13:47.000000', 'temperatura', 499.0000, 'ºC'),
	(76220, 109, '2015-03-01 00:13:48.000000', 'temperatura', 981.0000, 'ºC'),
	(76221, 109, '2015-03-01 00:13:49.000000', 'temperatura', 1011.0000, 'ºC'),
	(76222, 109, '2015-03-01 00:13:50.000000', 'temperatura', 912.0000, 'ºC'),
	(76223, 109, '2015-03-01 00:13:51.000000', 'temperatura', 325.0000, 'ºC'),
	(76224, 109, '2015-03-01 00:13:52.000000', 'temperatura', 92.0000, 'ºC'),
	(76225, 109, '2015-03-01 00:13:53.000000', 'temperatura', 686.0000, 'ºC'),
	(76226, 109, '2015-03-01 00:13:54.000000', 'temperatura', 756.0000, 'ºC'),
	(76227, 109, '2015-03-01 00:13:55.000000', 'temperatura', 519.0000, 'ºC'),
	(76228, 109, '2015-03-01 00:13:56.000000', 'temperatura', 330.0000, 'ºC'),
	(76229, 109, '2015-03-01 00:13:57.000000', 'temperatura', 93.0000, 'ºC'),
	(76230, 109, '2015-03-01 00:13:58.000000', 'temperatura', 676.0000, 'ºC'),
	(76231, 109, '2015-03-01 00:13:59.000000', 'temperatura', 701.0000, 'ºC'),
	(76232, 109, '2015-03-01 00:14:00.000000', 'temperatura', 277.0000, 'ºC'),
	(76233, 109, '2015-03-01 00:14:01.000000', 'temperatura', 483.0000, 'ºC'),
	(76234, 109, '2015-03-01 00:14:02.000000', 'temperatura', 384.0000, 'ºC'),
	(76235, 109, '2015-03-01 00:14:03.000000', 'temperatura', 471.0000, 'ºC'),
	(76236, 109, '2015-03-01 00:14:04.000000', 'temperatura', 5.0000, 'ºC'),
	(76237, 109, '2015-03-01 00:14:05.000000', 'temperatura', 1012.0000, 'ºC'),
	(76238, 109, '2015-03-01 00:14:06.000000', 'temperatura', 244.0000, 'ºC'),
	(76239, 109, '2015-03-01 00:14:07.000000', 'temperatura', 586.0000, 'ºC'),
	(76240, 109, '2015-03-01 00:14:08.000000', 'temperatura', 996.0000, 'ºC'),
	(76241, 109, '2015-03-01 00:14:09.000000', 'temperatura', 824.0000, 'ºC'),
	(76242, 109, '2015-03-01 00:14:10.000000', 'temperatura', 1133.0000, 'ºC'),
	(76243, 109, '2015-03-01 00:14:11.000000', 'temperatura', 793.0000, 'ºC'),
	(76244, 109, '2015-03-01 00:14:12.000000', 'temperatura', 568.0000, 'ºC'),
	(76245, 109, '2015-03-01 00:14:13.000000', 'temperatura', 462.0000, 'ºC'),
	(76246, 109, '2015-03-01 00:14:14.000000', 'temperatura', 607.0000, 'ºC'),
	(76247, 109, '2015-03-01 00:14:15.000000', 'temperatura', 446.0000, 'ºC'),
	(76248, 109, '2015-03-01 00:14:16.000000', 'temperatura', 413.0000, 'ºC'),
	(76249, 109, '2015-03-01 00:14:17.000000', 'temperatura', 726.0000, 'ºC'),
	(76250, 109, '2015-03-01 00:14:18.000000', 'temperatura', 1193.0000, 'ºC'),
	(76251, 109, '2015-03-01 00:14:19.000000', 'temperatura', 187.0000, 'ºC'),
	(76252, 109, '2015-03-01 00:14:20.000000', 'temperatura', 956.0000, 'ºC'),
	(76253, 109, '2015-03-01 00:14:21.000000', 'temperatura', 619.0000, 'ºC'),
	(76254, 109, '2015-03-01 00:14:22.000000', 'temperatura', 228.0000, 'ºC'),
	(76255, 109, '2015-03-01 00:14:23.000000', 'temperatura', 483.0000, 'ºC'),
	(76256, 109, '2015-03-01 00:14:24.000000', 'temperatura', 534.0000, 'ºC'),
	(76257, 109, '2015-03-01 00:14:25.000000', 'temperatura', 19.0000, 'ºC'),
	(76258, 109, '2015-03-01 00:14:26.000000', 'temperatura', 895.0000, 'ºC'),
	(76259, 109, '2015-03-01 00:14:27.000000', 'temperatura', 819.0000, 'ºC'),
	(76260, 109, '2015-03-01 00:14:28.000000', 'temperatura', 208.0000, 'ºC'),
	(76261, 109, '2015-03-01 00:14:29.000000', 'temperatura', 987.0000, 'ºC'),
	(76262, 109, '2015-03-01 00:14:30.000000', 'temperatura', 708.0000, 'ºC'),
	(76263, 109, '2015-03-01 00:14:31.000000', 'temperatura', 580.0000, 'ºC'),
	(76264, 109, '2015-03-01 00:14:32.000000', 'temperatura', 778.0000, 'ºC'),
	(76265, 109, '2015-03-01 00:14:33.000000', 'temperatura', 948.0000, 'ºC'),
	(76266, 109, '2015-03-01 00:14:34.000000', 'temperatura', 8.0000, 'ºC'),
	(76267, 109, '2015-03-01 00:14:35.000000', 'temperatura', 795.0000, 'ºC'),
	(76268, 109, '2015-03-01 00:14:36.000000', 'temperatura', 351.0000, 'ºC'),
	(76269, 109, '2015-03-01 00:14:37.000000', 'temperatura', 571.0000, 'ºC'),
	(76270, 109, '2015-03-01 00:14:38.000000', 'temperatura', 602.0000, 'ºC'),
	(76271, 109, '2015-03-01 00:14:39.000000', 'temperatura', 98.0000, 'ºC'),
	(76272, 109, '2015-03-01 00:14:40.000000', 'temperatura', 1085.0000, 'ºC'),
	(76273, 109, '2015-03-01 00:14:41.000000', 'temperatura', 329.0000, 'ºC'),
	(76274, 109, '2015-03-01 00:14:42.000000', 'temperatura', 794.0000, 'ºC'),
	(76275, 109, '2015-03-01 00:14:43.000000', 'temperatura', 581.0000, 'ºC'),
	(76276, 109, '2015-03-01 00:14:44.000000', 'temperatura', 526.0000, 'ºC'),
	(76277, 109, '2015-03-01 00:14:45.000000', 'temperatura', 885.0000, 'ºC'),
	(76278, 109, '2015-03-01 00:14:46.000000', 'temperatura', 450.0000, 'ºC'),
	(76279, 109, '2015-03-01 00:14:47.000000', 'temperatura', 796.0000, 'ºC'),
	(76280, 109, '2015-03-01 00:14:48.000000', 'temperatura', 230.0000, 'ºC'),
	(76281, 109, '2015-03-01 00:14:49.000000', 'temperatura', 1161.0000, 'ºC'),
	(76282, 109, '2015-03-01 00:14:50.000000', 'temperatura', 316.0000, 'ºC'),
	(76283, 109, '2015-03-01 00:14:51.000000', 'temperatura', 499.0000, 'ºC'),
	(76284, 109, '2015-03-01 00:14:52.000000', 'temperatura', 348.0000, 'ºC'),
	(76285, 109, '2015-03-01 00:14:53.000000', 'temperatura', 242.0000, 'ºC'),
	(76286, 109, '2015-03-01 00:14:54.000000', 'temperatura', 165.0000, 'ºC'),
	(76287, 109, '2015-03-01 00:14:55.000000', 'temperatura', 101.0000, 'ºC'),
	(76288, 109, '2015-03-01 00:14:56.000000', 'temperatura', 10.0000, 'ºC'),
	(76289, 109, '2015-03-01 00:14:57.000000', 'temperatura', 948.0000, 'ºC'),
	(76290, 109, '2015-03-01 00:14:58.000000', 'temperatura', 1109.0000, 'ºC'),
	(76291, 109, '2015-03-01 00:14:59.000000', 'temperatura', 303.0000, 'ºC'),
	(76292, 109, '2015-03-01 00:15:00.000000', 'temperatura', 589.0000, 'ºC'),
	(76293, 109, '2015-03-01 00:15:01.000000', 'temperatura', 837.0000, 'ºC'),
	(76294, 109, '2015-03-01 00:15:02.000000', 'temperatura', 19.0000, 'ºC'),
	(76295, 109, '2015-03-01 00:15:03.000000', 'temperatura', 1185.0000, 'ºC'),
	(76296, 109, '2015-03-01 00:15:04.000000', 'temperatura', 1066.0000, 'ºC'),
	(76297, 109, '2015-03-01 00:15:05.000000', 'temperatura', 578.0000, 'ºC'),
	(76298, 109, '2015-03-01 00:15:06.000000', 'temperatura', 893.0000, 'ºC'),
	(76299, 109, '2015-03-01 00:15:07.000000', 'temperatura', 330.0000, 'ºC'),
	(76300, 109, '2015-03-01 00:15:08.000000', 'temperatura', 174.0000, 'ºC'),
	(76301, 109, '2015-03-01 00:15:09.000000', 'temperatura', 1077.0000, 'ºC'),
	(76302, 109, '2015-03-01 00:15:10.000000', 'temperatura', 66.0000, 'ºC'),
	(76303, 109, '2015-03-01 00:15:11.000000', 'temperatura', 699.0000, 'ºC'),
	(76304, 109, '2015-03-01 00:15:12.000000', 'temperatura', 899.0000, 'ºC'),
	(76305, 109, '2015-03-01 00:15:13.000000', 'temperatura', 1197.0000, 'ºC'),
	(76306, 109, '2015-03-01 00:15:14.000000', 'temperatura', 887.0000, 'ºC'),
	(76307, 109, '2015-03-01 00:15:15.000000', 'temperatura', 845.0000, 'ºC'),
	(76308, 109, '2015-03-01 00:15:16.000000', 'temperatura', 367.0000, 'ºC'),
	(76309, 109, '2015-03-01 00:15:17.000000', 'temperatura', 499.0000, 'ºC'),
	(76310, 109, '2015-03-01 00:15:18.000000', 'temperatura', 196.0000, 'ºC'),
	(76311, 109, '2015-03-01 00:15:19.000000', 'temperatura', 682.0000, 'ºC'),
	(76312, 109, '2015-03-01 00:15:20.000000', 'temperatura', 423.0000, 'ºC'),
	(76313, 109, '2015-03-01 00:15:21.000000', 'temperatura', 68.0000, 'ºC'),
	(76314, 109, '2015-03-01 00:15:22.000000', 'temperatura', 273.0000, 'ºC'),
	(76315, 109, '2015-03-01 00:15:23.000000', 'temperatura', 1162.0000, 'ºC'),
	(76316, 109, '2015-03-01 00:15:24.000000', 'temperatura', 193.0000, 'ºC'),
	(76317, 109, '2015-03-01 00:15:25.000000', 'temperatura', 1078.0000, 'ºC'),
	(76318, 109, '2015-03-01 00:15:26.000000', 'temperatura', 12.0000, 'ºC'),
	(76319, 109, '2015-03-01 00:15:27.000000', 'temperatura', 424.0000, 'ºC'),
	(76320, 109, '2015-03-01 00:15:28.000000', 'temperatura', 888.0000, 'ºC'),
	(76321, 109, '2015-03-01 00:15:29.000000', 'temperatura', 766.0000, 'ºC'),
	(76322, 109, '2015-03-01 00:15:30.000000', 'temperatura', 1166.0000, 'ºC'),
	(76323, 109, '2015-03-01 00:15:31.000000', 'temperatura', 1134.0000, 'ºC'),
	(76324, 109, '2015-03-01 00:15:32.000000', 'temperatura', 972.0000, 'ºC'),
	(76325, 109, '2015-03-01 00:15:33.000000', 'temperatura', 257.0000, 'ºC'),
	(76326, 109, '2015-03-01 00:15:34.000000', 'temperatura', 769.0000, 'ºC'),
	(76327, 109, '2015-03-01 00:15:35.000000', 'temperatura', 678.0000, 'ºC'),
	(76328, 109, '2015-03-01 00:15:36.000000', 'temperatura', 1080.0000, 'ºC'),
	(76329, 109, '2015-03-01 00:15:37.000000', 'temperatura', 967.0000, 'ºC'),
	(76330, 109, '2015-03-01 00:15:38.000000', 'temperatura', 394.0000, 'ºC'),
	(76331, 109, '2015-03-01 00:15:39.000000', 'temperatura', 272.0000, 'ºC'),
	(76332, 109, '2015-03-01 00:15:40.000000', 'temperatura', 178.0000, 'ºC'),
	(76333, 109, '2015-03-01 00:15:41.000000', 'temperatura', 75.0000, 'ºC'),
	(76334, 109, '2015-03-01 00:15:42.000000', 'temperatura', 1039.0000, 'ºC'),
	(76335, 109, '2015-03-01 00:15:43.000000', 'temperatura', 173.0000, 'ºC'),
	(76336, 109, '2015-03-01 00:15:44.000000', 'temperatura', 148.0000, 'ºC'),
	(76337, 109, '2015-03-01 00:15:45.000000', 'temperatura', 221.0000, 'ºC'),
	(76338, 109, '2015-03-01 00:15:46.000000', 'temperatura', 661.0000, 'ºC'),
	(76339, 109, '2015-03-01 00:15:47.000000', 'temperatura', 241.0000, 'ºC'),
	(76340, 109, '2015-03-01 00:15:48.000000', 'temperatura', 425.0000, 'ºC'),
	(76341, 109, '2015-03-01 00:15:49.000000', 'temperatura', 201.0000, 'ºC'),
	(76342, 109, '2015-03-01 00:15:50.000000', 'temperatura', 931.0000, 'ºC'),
	(76343, 109, '2015-03-01 00:15:51.000000', 'temperatura', 454.0000, 'ºC'),
	(76344, 109, '2015-03-01 00:15:52.000000', 'temperatura', 678.0000, 'ºC'),
	(76345, 109, '2015-03-01 00:15:53.000000', 'temperatura', 829.0000, 'ºC'),
	(76346, 109, '2015-03-01 00:15:54.000000', 'temperatura', 912.0000, 'ºC'),
	(76347, 109, '2015-03-01 00:15:55.000000', 'temperatura', 871.0000, 'ºC'),
	(76348, 109, '2015-03-01 00:15:56.000000', 'temperatura', 422.0000, 'ºC'),
	(76349, 109, '2015-03-01 00:15:57.000000', 'temperatura', 695.0000, 'ºC'),
	(76350, 109, '2015-03-01 00:15:58.000000', 'temperatura', 1010.0000, 'ºC'),
	(76351, 109, '2015-03-01 00:15:59.000000', 'temperatura', 565.0000, 'ºC'),
	(76352, 109, '2015-03-01 00:16:00.000000', 'temperatura', 997.0000, 'ºC'),
	(76353, 109, '2015-03-01 00:16:01.000000', 'temperatura', 891.0000, 'ºC'),
	(76354, 109, '2015-03-01 00:16:02.000000', 'temperatura', 262.0000, 'ºC'),
	(76355, 109, '2015-03-01 00:16:03.000000', 'temperatura', 1039.0000, 'ºC'),
	(76356, 109, '2015-03-01 00:16:04.000000', 'temperatura', 809.0000, 'ºC'),
	(76357, 109, '2015-03-01 00:16:05.000000', 'temperatura', 927.0000, 'ºC'),
	(76358, 109, '2015-03-01 00:16:06.000000', 'temperatura', 1010.0000, 'ºC'),
	(76359, 109, '2015-03-01 00:16:07.000000', 'temperatura', 1069.0000, 'ºC'),
	(76360, 109, '2015-03-01 00:16:08.000000', 'temperatura', 1116.0000, 'ºC'),
	(76361, 109, '2015-03-01 00:16:09.000000', 'temperatura', 1174.0000, 'ºC'),
	(76362, 109, '2015-03-01 00:16:10.000000', 'temperatura', 123.0000, 'ºC'),
	(76363, 109, '2015-03-01 00:16:11.000000', 'temperatura', 694.0000, 'ºC'),
	(76364, 109, '2015-03-01 00:16:12.000000', 'temperatura', 701.0000, 'ºC'),
	(76365, 109, '2015-03-01 00:16:13.000000', 'temperatura', 223.0000, 'ºC'),
	(76366, 109, '2015-03-01 00:16:14.000000', 'temperatura', 211.0000, 'ºC'),
	(76367, 109, '2015-03-01 00:16:15.000000', 'temperatura', 389.0000, 'ºC'),
	(76368, 109, '2015-03-01 00:16:16.000000', 'temperatura', 110.0000, 'ºC'),
	(76369, 109, '2015-03-01 00:16:17.000000', 'temperatura', 587.0000, 'ºC'),
	(76370, 109, '2015-03-01 00:16:18.000000', 'temperatura', 202.0000, 'ºC'),
	(76371, 109, '2015-03-01 00:16:19.000000', 'temperatura', 451.0000, 'ºC'),
	(76372, 109, '2015-03-01 00:16:20.000000', 'temperatura', 451.0000, 'ºC'),
	(76373, 109, '2015-03-01 00:16:21.000000', 'temperatura', 901.0000, 'ºC'),
	(76374, 109, '2015-03-01 00:16:22.000000', 'temperatura', 754.0000, 'ºC'),
	(76375, 109, '2015-03-01 00:16:23.000000', 'temperatura', 1066.0000, 'ºC'),
	(76376, 109, '2015-03-01 00:16:24.000000', 'temperatura', 670.0000, 'ºC'),
	(76377, 109, '2015-03-01 00:16:25.000000', 'temperatura', 152.0000, 'ºC'),
	(76378, 109, '2015-03-01 00:16:26.000000', 'temperatura', 1151.0000, 'ºC'),
	(76379, 109, '2015-03-01 00:16:27.000000', 'temperatura', 500.0000, 'ºC'),
	(76380, 109, '2015-03-01 00:16:28.000000', 'temperatura', 248.0000, 'ºC'),
	(76381, 109, '2015-03-01 00:16:29.000000', 'temperatura', 942.0000, 'ºC'),
	(76382, 109, '2015-03-01 00:16:30.000000', 'temperatura', 363.0000, 'ºC'),
	(76383, 109, '2015-03-01 00:16:31.000000', 'temperatura', 190.0000, 'ºC'),
	(76384, 109, '2015-03-01 00:16:32.000000', 'temperatura', 1061.0000, 'ºC'),
	(76385, 109, '2015-03-01 00:16:33.000000', 'temperatura', 1137.0000, 'ºC'),
	(76386, 109, '2015-03-01 00:16:34.000000', 'temperatura', 103.0000, 'ºC'),
	(76387, 109, '2015-03-01 00:16:35.000000', 'temperatura', 702.0000, 'ºC'),
	(76388, 109, '2015-03-01 00:16:36.000000', 'temperatura', 805.0000, 'ºC'),
	(76389, 109, '2015-03-01 00:16:37.000000', 'temperatura', 716.0000, 'ºC'),
	(76390, 109, '2015-03-01 00:16:38.000000', 'temperatura', 1167.0000, 'ºC'),
	(76391, 109, '2015-03-01 00:16:39.000000', 'temperatura', 85.0000, 'ºC'),
	(76392, 109, '2015-03-01 00:16:40.000000', 'temperatura', 527.0000, 'ºC'),
	(76393, 109, '2015-03-01 00:16:41.000000', 'temperatura', 1182.0000, 'ºC'),
	(76394, 109, '2015-03-01 00:16:42.000000', 'temperatura', 728.0000, 'ºC'),
	(76395, 109, '2015-03-01 00:16:43.000000', 'temperatura', 93.0000, 'ºC'),
	(76396, 109, '2015-03-01 00:16:44.000000', 'temperatura', 682.0000, 'ºC'),
	(76397, 109, '2015-03-01 00:16:45.000000', 'temperatura', 732.0000, 'ºC'),
	(76398, 109, '2015-03-01 00:16:46.000000', 'temperatura', 415.0000, 'ºC'),
	(76399, 109, '2015-03-01 00:16:47.000000', 'temperatura', 1079.0000, 'ºC'),
	(76400, 109, '2015-03-01 00:16:48.000000', 'temperatura', 551.0000, 'ºC'),
	(76401, 109, '2015-03-01 00:16:49.000000', 'temperatura', 719.0000, 'ºC'),
	(76402, 109, '2015-03-01 00:16:50.000000', 'temperatura', 743.0000, 'ºC'),
	(76403, 109, '2015-03-01 00:16:51.000000', 'temperatura', 356.0000, 'ºC'),
	(76404, 109, '2015-03-01 00:16:52.000000', 'temperatura', 754.0000, 'ºC'),
	(76405, 109, '2015-03-01 00:16:53.000000', 'temperatura', 300.0000, 'ºC'),
	(76406, 109, '2015-03-01 00:16:54.000000', 'temperatura', 441.0000, 'ºC'),
	(76407, 109, '2015-03-01 00:16:55.000000', 'temperatura', 103.0000, 'ºC'),
	(76408, 109, '2015-03-01 00:16:56.000000', 'temperatura', 393.0000, 'ºC'),
	(76409, 109, '2015-03-01 00:16:57.000000', 'temperatura', 455.0000, 'ºC'),
	(76410, 109, '2015-03-01 00:16:58.000000', 'temperatura', 1098.0000, 'ºC'),
	(76411, 109, '2015-03-01 00:16:59.000000', 'temperatura', 527.0000, 'ºC'),
	(76412, 109, '2015-03-01 00:17:00.000000', 'temperatura', 539.0000, 'ºC'),
	(76413, 109, '2015-03-01 00:17:01.000000', 'temperatura', 1117.0000, 'ºC'),
	(76414, 109, '2015-03-01 00:17:02.000000', 'temperatura', 367.0000, 'ºC'),
	(76415, 109, '2015-03-01 00:17:03.000000', 'temperatura', 886.0000, 'ºC'),
	(76416, 109, '2015-03-01 00:17:04.000000', 'temperatura', 930.0000, 'ºC'),
	(76417, 109, '2015-03-01 00:17:05.000000', 'temperatura', 790.0000, 'ºC'),
	(76418, 109, '2015-03-01 00:17:06.000000', 'temperatura', 1161.0000, 'ºC'),
	(76419, 109, '2015-03-01 00:17:07.000000', 'temperatura', 1038.0000, 'ºC'),
	(76420, 109, '2015-03-01 00:17:08.000000', 'temperatura', 505.0000, 'ºC'),
	(76421, 109, '2015-03-01 00:17:09.000000', 'temperatura', 610.0000, 'ºC'),
	(76422, 109, '2015-03-01 00:17:10.000000', 'temperatura', 337.0000, 'ºC'),
	(76423, 109, '2015-03-01 00:17:11.000000', 'temperatura', 1058.0000, 'ºC'),
	(76424, 109, '2015-03-01 00:17:12.000000', 'temperatura', 676.0000, 'ºC'),
	(76425, 109, '2015-03-01 00:17:13.000000', 'temperatura', 208.0000, 'ºC'),
	(76426, 109, '2015-03-01 00:17:14.000000', 'temperatura', 211.0000, 'ºC'),
	(76427, 109, '2015-03-01 00:17:15.000000', 'temperatura', 431.0000, 'ºC'),
	(76428, 109, '2015-03-01 00:17:16.000000', 'temperatura', 324.0000, 'ºC'),
	(76429, 109, '2015-03-01 00:17:17.000000', 'temperatura', 328.0000, 'ºC'),
	(76430, 109, '2015-03-01 00:17:18.000000', 'temperatura', 667.0000, 'ºC'),
	(76431, 109, '2015-03-01 00:17:19.000000', 'temperatura', 1153.0000, 'ºC'),
	(76432, 109, '2015-03-01 00:17:20.000000', 'temperatura', 162.0000, 'ºC'),
	(76433, 109, '2015-03-01 00:17:21.000000', 'temperatura', 952.0000, 'ºC'),
	(76434, 109, '2015-03-01 00:17:22.000000', 'temperatura', 675.0000, 'ºC'),
	(76435, 109, '2015-03-01 00:17:23.000000', 'temperatura', 520.0000, 'ºC'),
	(76436, 109, '2015-03-01 00:17:24.000000', 'temperatura', 574.0000, 'ºC'),
	(76437, 109, '2015-03-01 00:17:25.000000', 'temperatura', 113.0000, 'ºC'),
	(76438, 109, '2015-03-01 00:17:26.000000', 'temperatura', 42.0000, 'ºC'),
	(76439, 109, '2015-03-01 00:17:27.000000', 'temperatura', 1070.0000, 'ºC'),
	(76440, 109, '2015-03-01 00:17:28.000000', 'temperatura', 425.0000, 'ºC'),
	(76441, 109, '2015-03-01 00:17:29.000000', 'temperatura', 116.0000, 'ºC'),
	(76442, 109, '2015-03-01 00:17:30.000000', 'temperatura', 506.0000, 'ºC'),
	(76443, 109, '2015-03-01 00:17:31.000000', 'temperatura', 984.0000, 'ºC'),
	(76444, 109, '2015-03-01 00:17:32.000000', 'temperatura', 1001.0000, 'ºC'),
	(76445, 109, '2015-03-01 00:17:33.000000', 'temperatura', 854.0000, 'ºC'),
	(76446, 109, '2015-03-01 00:17:34.000000', 'temperatura', 66.0000, 'ºC'),
	(76447, 109, '2015-03-01 00:17:35.000000', 'temperatura', 170.0000, 'ºC'),
	(76448, 109, '2015-03-01 00:17:36.000000', 'temperatura', 651.0000, 'ºC'),
	(76449, 109, '2015-03-01 00:17:37.000000', 'temperatura', 345.0000, 'ºC'),
	(76450, 109, '2015-03-01 00:17:38.000000', 'temperatura', 974.0000, 'ºC'),
	(76451, 109, '2015-03-01 00:17:39.000000', 'temperatura', 234.0000, 'ºC'),
	(76452, 109, '2015-03-01 00:17:40.000000', 'temperatura', 648.0000, 'ºC'),
	(76453, 109, '2015-03-01 00:17:41.000000', 'temperatura', 137.0000, 'ºC'),
	(76454, 109, '2015-03-01 00:17:42.000000', 'temperatura', 1145.0000, 'ºC'),
	(76455, 109, '2015-03-01 00:17:43.000000', 'temperatura', 512.0000, 'ºC'),
	(76456, 109, '2015-03-01 00:17:44.000000', 'temperatura', 325.0000, 'ºC'),
	(76457, 109, '2015-03-01 00:17:45.000000', 'temperatura', 90.0000, 'ºC'),
	(76458, 109, '2015-03-01 00:17:46.000000', 'temperatura', 677.0000, 'ºC'),
	(76459, 109, '2015-03-01 00:17:47.000000', 'temperatura', 713.0000, 'ºC'),
	(76460, 109, '2015-03-01 00:17:48.000000', 'temperatura', 334.0000, 'ºC'),
	(76461, 109, '2015-03-01 00:17:49.000000', 'temperatura', 735.0000, 'ºC'),
	(76462, 109, '2015-03-01 00:17:50.000000', 'temperatura', 271.0000, 'ºC'),
	(76463, 109, '2015-03-01 00:17:51.000000', 'temperatura', 350.0000, 'ºC'),
	(76464, 109, '2015-03-01 00:17:52.000000', 'temperatura', 939.0000, 'ºC'),
	(76465, 109, '2015-03-01 00:17:53.000000', 'temperatura', 45.0000, 'ºC'),
	(76466, 109, '2015-03-01 00:17:54.000000', 'temperatura', 1009.0000, 'ºC'),
	(76467, 109, '2015-03-01 00:17:55.000000', 'temperatura', 109.0000, 'ºC'),
	(76468, 109, '2015-03-01 00:17:56.000000', 'temperatura', 1120.0000, 'ºC'),
	(76469, 109, '2015-03-01 00:17:57.000000', 'temperatura', 473.0000, 'ºC'),
	(76470, 109, '2015-03-01 00:17:58.000000', 'temperatura', 205.0000, 'ºC'),
	(76471, 109, '2015-03-01 00:17:59.000000', 'temperatura', 808.0000, 'ºC'),
	(76472, 109, '2015-03-01 00:18:00.000000', 'temperatura', 1025.0000, 'ºC'),
	(76473, 109, '2015-03-01 00:18:01.000000', 'temperatura', 301.0000, 'ºC'),
	(76474, 109, '2015-03-01 00:18:02.000000', 'temperatura', 830.0000, 'ºC'),
	(76475, 109, '2015-03-01 00:18:03.000000', 'temperatura', 848.0000, 'ºC'),
	(76476, 109, '2015-03-01 00:18:04.000000', 'temperatura', 550.0000, 'ºC'),
	(76477, 109, '2015-03-01 00:18:05.000000', 'temperatura', 208.0000, 'ºC'),
	(76478, 109, '2015-03-01 00:18:06.000000', 'temperatura', 590.0000, 'ºC'),
	(76479, 109, '2015-03-01 00:18:07.000000', 'temperatura', 1124.0000, 'ºC'),
	(76480, 109, '2015-03-01 00:18:08.000000', 'temperatura', 254.0000, 'ºC'),
	(76481, 109, '2015-03-01 00:18:09.000000', 'temperatura', 296.0000, 'ºC'),
	(76482, 109, '2015-03-01 00:18:10.000000', 'temperatura', 720.0000, 'ºC'),
	(76483, 109, '2015-03-01 00:18:11.000000', 'temperatura', 311.0000, 'ºC'),
	(76484, 109, '2015-03-01 00:18:12.000000', 'temperatura', 596.0000, 'ºC'),
	(76485, 109, '2015-03-01 00:18:13.000000', 'temperatura', 847.0000, 'ºC'),
	(76486, 109, '2015-03-01 00:18:14.000000', 'temperatura', 47.0000, 'ºC'),
	(76487, 109, '2015-03-01 00:18:15.000000', 'temperatura', 95.0000, 'ºC'),
	(76488, 109, '2015-03-01 00:18:16.000000', 'temperatura', 333.0000, 'ºC'),
	(76489, 109, '2015-03-01 00:18:17.000000', 'temperatura', 182.0000, 'ºC'),
	(76490, 109, '2015-03-01 00:18:18.000000', 'temperatura', 1110.0000, 'ºC'),
	(76491, 109, '2015-03-01 00:18:19.000000', 'temperatura', 206.0000, 'ºC'),
	(76492, 109, '2015-03-01 00:18:20.000000', 'temperatura', 101.0000, 'ºC'),
	(76493, 109, '2015-03-01 00:18:21.000000', 'temperatura', 1087.0000, 'ºC'),
	(76494, 109, '2015-03-01 00:18:22.000000', 'temperatura', 331.0000, 'ºC'),
	(76495, 109, '2015-03-01 00:18:23.000000', 'temperatura', 795.0000, 'ºC'),
	(76496, 109, '2015-03-01 00:18:24.000000', 'temperatura', 583.0000, 'ºC'),
	(76497, 109, '2015-03-01 00:18:25.000000', 'temperatura', 532.0000, 'ºC'),
	(76498, 109, '2015-03-01 00:18:26.000000', 'temperatura', 910.0000, 'ºC'),
	(76499, 109, '2015-03-01 00:18:27.000000', 'temperatura', 555.0000, 'ºC'),
	(76500, 109, '2015-03-01 00:18:28.000000', 'temperatura', 47.0000, 'ºC'),
	(76501, 109, '2015-03-01 00:18:29.000000', 'temperatura', 968.0000, 'ºC'),
	(76502, 109, '2015-03-01 00:18:30.000000', 'temperatura', 1102.0000, 'ºC'),
	(76503, 109, '2015-03-01 00:18:31.000000', 'temperatura', 206.0000, 'ºC'),
	(76504, 109, '2015-03-01 00:18:32.000000', 'temperatura', 124.0000, 'ºC'),
	(76505, 109, '2015-03-01 00:18:33.000000', 'temperatura', 1.0000, 'ºC'),
	(76506, 109, '2015-03-01 00:18:34.000000', 'temperatura', 835.0000, 'ºC'),
	(76507, 109, '2015-03-01 00:18:35.000000', 'temperatura', 572.0000, 'ºC'),
	(76508, 109, '2015-03-01 00:18:36.000000', 'temperatura', 354.0000, 'ºC'),
	(76509, 109, '2015-03-01 00:18:37.000000', 'temperatura', 55.0000, 'ºC'),
	(76510, 109, '2015-03-01 00:18:38.000000', 'temperatura', 413.0000, 'ºC'),
	(76511, 109, '2015-03-01 00:18:39.000000', 'temperatura', 701.0000, 'ºC'),
	(76512, 109, '2015-03-01 00:18:40.000000', 'temperatura', 1065.0000, 'ºC'),
	(76513, 109, '2015-03-01 00:18:41.000000', 'temperatura', 822.0000, 'ºC'),
	(76514, 109, '2015-03-01 00:18:42.000000', 'temperatura', 917.0000, 'ºC'),
	(76515, 109, '2015-03-01 00:18:43.000000', 'temperatura', 920.0000, 'ºC'),
	(76516, 109, '2015-03-01 00:18:44.000000', 'temperatura', 649.0000, 'ºC'),
	(76517, 109, '2015-03-01 00:18:45.000000', 'temperatura', 484.0000, 'ºC'),
	(76518, 109, '2015-03-01 00:18:46.000000', 'temperatura', 473.0000, 'ºC'),
	(76519, 109, '2015-03-01 00:18:47.000000', 'temperatura', 917.0000, 'ºC'),
	(76520, 109, '2015-03-01 00:18:48.000000', 'temperatura', 763.0000, 'ºC'),
	(76521, 109, '2015-03-01 00:18:49.000000', 'temperatura', 1067.0000, 'ºC'),
	(76522, 109, '2015-03-01 00:18:50.000000', 'temperatura', 644.0000, 'ºC'),
	(76523, 109, '2015-03-01 00:18:51.000000', 'temperatura', 22.0000, 'ºC'),
	(76524, 109, '2015-03-01 00:18:52.000000', 'temperatura', 579.0000, 'ºC'),
	(76525, 109, '2015-03-01 00:18:53.000000', 'temperatura', 429.0000, 'ºC'),
	(76526, 109, '2015-03-01 00:18:54.000000', 'temperatura', 407.0000, 'ºC'),
	(76527, 109, '2015-03-01 00:18:55.000000', 'temperatura', 749.0000, 'ºC'),
	(76528, 109, '2015-03-01 00:18:56.000000', 'temperatura', 125.0000, 'ºC'),
	(76529, 109, '2015-03-01 00:18:57.000000', 'temperatura', 776.0000, 'ºC'),
	(76530, 109, '2015-03-01 00:18:58.000000', 'temperatura', 1109.0000, 'ºC'),
	(76531, 109, '2015-03-01 00:18:59.000000', 'temperatura', 814.0000, 'ºC'),
	(76532, 109, '2015-03-01 00:19:00.000000', 'temperatura', 746.0000, 'ºC'),
	(76533, 109, '2015-03-01 00:19:01.000000', 'temperatura', 88.0000, 'ºC'),
	(76534, 109, '2015-03-01 00:19:02.000000', 'temperatura', 604.0000, 'ºC'),
	(76535, 109, '2015-03-01 00:19:03.000000', 'temperatura', 357.0000, 'ºC'),
	(76536, 109, '2015-03-01 00:19:04.000000', 'temperatura', 1173.0000, 'ºC'),
	(76537, 109, '2015-03-01 00:19:05.000000', 'temperatura', 1193.0000, 'ºC'),
	(76538, 109, '2015-03-01 00:19:06.000000', 'temperatura', 48.0000, 'ºC'),
	(76539, 109, '2015-03-01 00:19:07.000000', 'temperatura', 263.0000, 'ºC'),
	(76540, 109, '2015-03-01 00:19:08.000000', 'temperatura', 1169.0000, 'ºC'),
	(76541, 109, '2015-03-01 00:19:09.000000', 'temperatura', 259.0000, 'ºC'),
	(76542, 109, '2015-03-01 00:19:10.000000', 'temperatura', 185.0000, 'ºC'),
	(76543, 109, '2015-03-01 00:19:11.000000', 'temperatura', 151.0000, 'ºC'),
	(76544, 109, '2015-03-01 00:19:12.000000', 'temperatura', 201.0000, 'ºC'),
	(76545, 109, '2015-03-01 00:19:13.000000', 'temperatura', 554.0000, 'ºC'),
	(76546, 109, '2015-03-01 00:19:14.000000', 'temperatura', 964.0000, 'ºC'),
	(76547, 109, '2015-03-01 00:19:15.000000', 'temperatura', 761.0000, 'ºC'),
	(76548, 109, '2015-03-01 00:19:16.000000', 'temperatura', 911.0000, 'ºC'),
	(76549, 109, '2015-03-01 00:19:17.000000', 'temperatura', 1072.0000, 'ºC'),
	(76550, 109, '2015-03-01 00:19:18.000000', 'temperatura', 230.0000, 'ºC'),
	(76551, 109, '2015-03-01 00:19:19.000000', 'temperatura', 333.0000, 'ºC'),
	(76552, 109, '2015-03-01 00:19:20.000000', 'temperatura', 976.0000, 'ºC'),
	(76553, 109, '2015-03-01 00:19:21.000000', 'temperatura', 281.0000, 'ºC'),
	(76554, 109, '2015-03-01 00:19:22.000000', 'temperatura', 876.0000, 'ºC'),
	(76555, 109, '2015-03-01 00:19:23.000000', 'temperatura', 1139.0000, 'ºC'),
	(76556, 109, '2015-03-01 00:19:24.000000', 'temperatura', 668.0000, 'ºC'),
	(76557, 109, '2015-03-01 00:19:25.000000', 'temperatura', 1121.0000, 'ºC'),
	(76558, 109, '2015-03-01 00:19:26.000000', 'temperatura', 4.0000, 'ºC'),
	(76559, 109, '2015-03-01 00:19:27.000000', 'temperatura', 256.0000, 'ºC'),
	(76560, 109, '2015-03-01 00:19:28.000000', 'temperatura', 68.0000, 'ºC'),
	(76561, 109, '2015-03-01 00:19:29.000000', 'temperatura', 772.0000, 'ºC'),
	(76562, 109, '2015-03-01 00:19:30.000000', 'temperatura', 59.0000, 'ºC'),
	(76563, 109, '2015-03-01 00:19:31.000000', 'temperatura', 379.0000, 'ºC'),
	(76564, 109, '2015-03-01 00:19:32.000000', 'temperatura', 517.0000, 'ºC'),
	(76565, 109, '2015-03-01 00:19:33.000000', 'temperatura', 248.0000, 'ºC'),
	(76566, 109, '2015-03-01 00:19:34.000000', 'temperatura', 892.0000, 'ºC'),
	(76567, 109, '2015-03-01 00:19:35.000000', 'temperatura', 116.0000, 'ºC'),
	(76568, 109, '2015-03-01 00:19:36.000000', 'temperatura', 302.0000, 'ºC'),
	(76569, 109, '2015-03-01 00:19:37.000000', 'temperatura', 1165.0000, 'ºC'),
	(76570, 109, '2015-03-01 00:19:38.000000', 'temperatura', 118.0000, 'ºC'),
	(76571, 109, '2015-03-01 00:19:39.000000', 'temperatura', 698.0000, 'ºC'),
	(76572, 109, '2015-03-01 00:19:40.000000', 'temperatura', 733.0000, 'ºC'),
	(76573, 109, '2015-03-01 00:19:41.000000', 'temperatura', 374.0000, 'ºC'),
	(76574, 109, '2015-03-01 00:19:42.000000', 'temperatura', 870.0000, 'ºC'),
	(76575, 109, '2015-03-01 00:19:43.000000', 'temperatura', 827.0000, 'ºC'),
	(76576, 109, '2015-03-01 00:19:44.000000', 'temperatura', 328.0000, 'ºC'),
	(76577, 109, '2015-03-01 00:19:45.000000', 'temperatura', 361.0000, 'ºC'),
	(76578, 109, '2015-03-01 00:19:46.000000', 'temperatura', 819.0000, 'ºC'),
	(76579, 109, '2015-03-01 00:19:47.000000', 'temperatura', 612.0000, 'ºC'),
	(76580, 109, '2015-03-01 00:19:48.000000', 'temperatura', 606.0000, 'ºC'),
	(76581, 109, '2015-03-01 00:19:49.000000', 'temperatura', 1194.0000, 'ºC'),
	(76582, 109, '2015-03-01 00:19:50.000000', 'temperatura', 553.0000, 'ºC'),
	(76583, 109, '2015-03-01 00:19:51.000000', 'temperatura', 385.0000, 'ºC'),
	(76584, 109, '2015-03-01 00:19:52.000000', 'temperatura', 263.0000, 'ºC'),
	(76585, 109, '2015-03-01 00:19:53.000000', 'temperatura', 164.0000, 'ºC'),
	(76586, 109, '2015-03-01 00:19:54.000000', 'temperatura', 28.0000, 'ºC'),
	(76587, 109, '2015-03-01 00:19:55.000000', 'temperatura', 851.0000, 'ºC'),
	(76588, 109, '2015-03-01 00:19:56.000000', 'temperatura', 573.0000, 'ºC'),
	(76589, 109, '2015-03-01 00:19:57.000000', 'temperatura', 310.0000, 'ºC'),
	(76590, 109, '2015-03-01 00:19:58.000000', 'temperatura', 1033.0000, 'ºC'),
	(76591, 109, '2015-03-01 00:19:59.000000', 'temperatura', 637.0000, 'ºC'),
	(76592, 109, '2015-03-01 00:20:00.000000', 'temperatura', 85.0000, 'ºC'),
	(76593, 109, '2015-03-01 00:20:01.000000', 'temperatura', 915.0000, 'ºC'),
	(76594, 109, '2015-03-01 00:20:02.000000', 'temperatura', 721.0000, 'ºC'),
	(76595, 109, '2015-03-01 00:20:03.000000', 'temperatura', 860.0000, 'ºC'),
	(76596, 109, '2015-03-01 00:20:04.000000', 'temperatura', 937.0000, 'ºC'),
	(76597, 109, '2015-03-01 00:20:05.000000', 'temperatura', 907.0000, 'ºC'),
	(76598, 109, '2015-03-01 00:20:06.000000', 'temperatura', 526.0000, 'ºC'),
	(76599, 109, '2015-03-01 00:20:07.000000', 'temperatura', 1107.0000, 'ºC'),
	(76600, 109, '2015-03-01 00:20:08.000000', 'temperatura', 356.0000, 'ºC'),
	(76601, 109, '2015-03-01 00:20:09.000000', 'temperatura', 861.0000, 'ºC'),
	(76602, 109, '2015-03-01 00:20:10.000000', 'temperatura', 837.0000, 'ºC'),
	(76603, 109, '2015-03-01 00:20:11.000000', 'temperatura', 403.0000, 'ºC'),
	(76604, 109, '2015-03-01 00:20:12.000000', 'temperatura', 704.0000, 'ºC'),
	(76605, 109, '2015-03-01 00:20:13.000000', 'temperatura', 1113.0000, 'ºC'),
	(76606, 109, '2015-03-01 00:20:14.000000', 'temperatura', 1051.0000, 'ºC'),
	(76607, 109, '2015-03-01 00:20:15.000000', 'temperatura', 719.0000, 'ºC'),
	(76608, 109, '2015-03-01 00:20:16.000000', 'temperatura', 441.0000, 'ºC'),
	(76609, 109, '2015-03-01 00:20:17.000000', 'temperatura', 47.0000, 'ºC'),
	(76610, 109, '2015-03-01 00:20:18.000000', 'temperatura', 116.0000, 'ºC'),
	(76611, 109, '2015-03-01 00:20:19.000000', 'temperatura', 437.0000, 'ºC'),
	(76612, 109, '2015-03-01 00:20:20.000000', 'temperatura', 640.0000, 'ºC'),
	(76613, 109, '2015-03-01 00:20:21.000000', 'temperatura', 687.0000, 'ºC'),
	(76614, 109, '2015-03-01 00:20:22.000000', 'temperatura', 314.0000, 'ºC'),
	(76615, 109, '2015-03-01 00:20:23.000000', 'temperatura', 712.0000, 'ºC'),
	(76616, 109, '2015-03-01 00:20:24.000000', 'temperatura', 218.0000, 'ºC'),
	(76617, 109, '2015-03-01 00:20:25.000000', 'temperatura', 155.0000, 'ºC'),
	(76618, 109, '2015-03-01 00:20:26.000000', 'temperatura', 122.0000, 'ºC'),
	(76619, 109, '2015-03-01 00:20:27.000000', 'temperatura', 146.0000, 'ºC'),
	(76620, 109, '2015-03-01 00:20:28.000000', 'temperatura', 364.0000, 'ºC'),
	(76621, 109, '2015-03-01 00:20:29.000000', 'temperatura', 181.0000, 'ºC'),
	(76622, 109, '2015-03-01 00:20:30.000000', 'temperatura', 1016.0000, 'ºC'),
	(76623, 109, '2015-03-01 00:20:31.000000', 'temperatura', 935.0000, 'ºC'),
	(76624, 109, '2015-03-01 00:20:32.000000', 'temperatura', 427.0000, 'ºC'),
	(76625, 109, '2015-03-01 00:20:33.000000', 'temperatura', 533.0000, 'ºC'),
	(76626, 109, '2015-03-01 00:20:34.000000', 'temperatura', 184.0000, 'ºC'),
	(76627, 109, '2015-03-01 00:20:35.000000', 'temperatura', 522.0000, 'ºC'),
	(76628, 109, '2015-03-01 00:20:36.000000', 'temperatura', 856.0000, 'ºC'),
	(76629, 109, '2015-03-01 00:20:37.000000', 'temperatura', 315.0000, 'ºC'),
	(76630, 109, '2015-03-01 00:20:38.000000', 'temperatura', 208.0000, 'ºC'),
	(76631, 109, '2015-03-01 00:20:39.000000', 'temperatura', 94.0000, 'ºC'),
	(76632, 109, '2015-03-01 00:20:40.000000', 'temperatura', 1046.0000, 'ºC'),
	(76633, 109, '2015-03-01 00:20:41.000000', 'temperatura', 150.0000, 'ºC'),
	(76634, 109, '2015-03-01 00:20:42.000000', 'temperatura', 12.0000, 'ºC'),
	(76635, 109, '2015-03-01 00:20:43.000000', 'temperatura', 810.0000, 'ºC'),
	(76636, 109, '2015-03-01 00:20:44.000000', 'temperatura', 414.0000, 'ºC'),
	(76637, 109, '2015-03-01 00:20:45.000000', 'temperatura', 842.0000, 'ºC'),
	(76638, 109, '2015-03-01 00:20:46.000000', 'temperatura', 566.0000, 'ºC'),
	(76639, 109, '2015-03-01 00:20:47.000000', 'temperatura', 306.0000, 'ºC'),
	(76640, 109, '2015-03-01 00:20:48.000000', 'temperatura', 1030.0000, 'ºC'),
	(76641, 109, '2015-03-01 00:20:49.000000', 'temperatura', 635.0000, 'ºC'),
	(76642, 109, '2015-03-01 00:20:50.000000', 'temperatura', 86.0000, 'ºC'),
	(76643, 109, '2015-03-01 00:20:51.000000', 'temperatura', 925.0000, 'ºC'),
	(76644, 109, '2015-03-01 00:20:52.000000', 'temperatura', 765.0000, 'ºC'),
	(76645, 109, '2015-03-01 00:20:53.000000', 'temperatura', 1054.0000, 'ºC'),
	(76646, 109, '2015-03-01 00:20:54.000000', 'temperatura', 575.0000, 'ºC'),
	(76647, 109, '2015-03-01 00:20:55.000000', 'temperatura', 911.0000, 'ºC'),
	(76648, 109, '2015-03-01 00:20:56.000000', 'temperatura', 433.0000, 'ºC'),
	(76649, 109, '2015-03-01 00:20:57.000000', 'temperatura', 633.0000, 'ºC'),
	(76650, 109, '2015-03-01 00:20:58.000000', 'temperatura', 665.0000, 'ºC'),
	(76651, 109, '2015-03-01 00:20:59.000000', 'temperatura', 226.0000, 'ºC'),
	(76652, 109, '2015-03-01 00:21:00.000000', 'temperatura', 336.0000, 'ºC'),
	(76653, 109, '2015-03-01 00:21:01.000000', 'temperatura', 1001.0000, 'ºC'),
	(76654, 109, '2015-03-01 00:21:02.000000', 'temperatura', 400.0000, 'ºC'),
	(76655, 109, '2015-03-01 00:21:03.000000', 'temperatura', 197.0000, 'ºC'),
	(76656, 109, '2015-03-01 00:21:04.000000', 'temperatura', 983.0000, 'ºC'),
	(76657, 109, '2015-03-01 00:21:05.000000', 'temperatura', 727.0000, 'ºC'),
	(76658, 109, '2015-03-01 00:21:06.000000', 'temperatura', 684.0000, 'ºC'),
	(76659, 109, '2015-03-01 00:21:07.000000', 'temperatura', 42.0000, 'ºC'),
	(76660, 109, '2015-03-01 00:21:08.000000', 'temperatura', 559.0000, 'ºC'),
	(76661, 109, '2015-03-01 00:21:09.000000', 'temperatura', 270.0000, 'ºC'),
	(76662, 109, '2015-03-01 00:21:10.000000', 'temperatura', 875.0000, 'ºC'),
	(76663, 109, '2015-03-01 00:21:11.000000', 'temperatura', 1162.0000, 'ºC'),
	(76664, 109, '2015-03-01 00:21:12.000000', 'temperatura', 786.0000, 'ºC'),
	(76665, 109, '2015-03-01 00:21:13.000000', 'temperatura', 445.0000, 'ºC'),
	(76666, 109, '2015-03-01 00:21:14.000000', 'temperatura', 1069.0000, 'ºC'),
	(76667, 109, '2015-03-01 00:21:15.000000', 'temperatura', 410.0000, 'ºC'),
	(76668, 109, '2015-03-01 00:21:16.000000', 'temperatura', 45.0000, 'ºC'),
	(76669, 109, '2015-03-01 00:21:17.000000', 'temperatura', 192.0000, 'ºC'),
	(76670, 109, '2015-03-01 00:21:18.000000', 'temperatura', 828.0000, 'ºC'),
	(76671, 109, '2015-03-01 00:21:19.000000', 'temperatura', 1163.0000, 'ºC'),
	(76672, 109, '2015-03-01 00:21:20.000000', 'temperatura', 932.0000, 'ºC'),
	(76673, 109, '2015-03-01 00:21:21.000000', 'temperatura', 1171.0000, 'ºC'),
	(76674, 109, '2015-03-01 00:21:22.000000', 'temperatura', 660.0000, 'ºC'),
	(76675, 109, '2015-03-01 00:21:23.000000', 'temperatura', 987.0000, 'ºC'),
	(76676, 109, '2015-03-01 00:21:24.000000', 'temperatura', 554.0000, 'ºC'),
	(76677, 109, '2015-03-01 00:21:25.000000', 'temperatura', 1011.0000, 'ºC'),
	(76678, 109, '2015-03-01 00:21:26.000000', 'temperatura', 994.0000, 'ºC'),
	(76679, 109, '2015-03-01 00:21:27.000000', 'temperatura', 735.0000, 'ºC'),
	(76680, 109, '2015-03-01 00:21:28.000000', 'temperatura', 695.0000, 'ºC'),
	(76681, 109, '2015-03-01 00:21:29.000000', 'temperatura', 71.0000, 'ºC'),
	(76682, 109, '2015-03-01 00:21:30.000000', 'temperatura', 668.0000, 'ºC'),
	(76683, 109, '2015-03-01 00:21:31.000000', 'temperatura', 729.0000, 'ºC'),
	(76684, 109, '2015-03-01 00:21:32.000000', 'temperatura', 441.0000, 'ºC'),
	(76685, 109, '2015-03-01 00:21:33.000000', 'temperatura', 18.0000, 'ºC'),
	(76686, 109, '2015-03-01 00:21:34.000000', 'temperatura', 1170.0000, 'ºC'),
	(76687, 109, '2015-03-01 00:21:35.000000', 'temperatura', 994.0000, 'ºC'),
	(76688, 109, '2015-03-01 00:21:36.000000', 'temperatura', 262.0000, 'ºC'),
	(76689, 109, '2015-03-01 00:21:37.000000', 'temperatura', 726.0000, 'ºC'),
	(76690, 109, '2015-03-01 00:21:38.000000', 'temperatura', 447.0000, 'ºC'),
	(76691, 109, '2015-03-01 00:21:39.000000', 'temperatura', 57.0000, 'ºC'),
	(76692, 109, '2015-03-01 00:21:40.000000', 'temperatura', 144.0000, 'ºC'),
	(76693, 109, '2015-03-01 00:21:41.000000', 'temperatura', 549.0000, 'ºC'),
	(76694, 109, '2015-03-01 00:21:42.000000', 'temperatura', 1114.0000, 'ºC'),
	(76695, 109, '2015-03-01 00:21:43.000000', 'temperatura', 323.0000, 'ºC'),
	(76696, 109, '2015-03-01 00:21:44.000000', 'temperatura', 675.0000, 'ºC'),
	(76697, 109, '2015-03-01 00:21:45.000000', 'temperatura', 5.0000, 'ºC'),
	(76698, 109, '2015-03-01 00:21:46.000000', 'temperatura', 401.0000, 'ºC'),
	(76699, 109, '2015-03-01 00:21:47.000000', 'temperatura', 792.0000, 'ºC'),
	(76700, 109, '2015-03-01 00:21:48.000000', 'temperatura', 359.0000, 'ºC'),
	(76701, 109, '2015-03-01 00:21:49.000000', 'temperatura', 616.0000, 'ºC'),
	(76702, 109, '2015-03-01 00:21:50.000000', 'temperatura', 803.0000, 'ºC'),
	(76703, 109, '2015-03-01 00:21:51.000000', 'temperatura', 969.0000, 'ºC'),
	(76704, 109, '2015-03-01 00:21:52.000000', 'temperatura', 35.0000, 'ºC'),
	(76705, 109, '2015-03-01 00:21:53.000000', 'temperatura', 868.0000, 'ºC'),
	(76706, 109, '2015-03-01 00:21:54.000000', 'temperatura', 638.0000, 'ºC'),
	(76707, 109, '2015-03-01 00:21:55.000000', 'temperatura', 587.0000, 'ºC'),
	(76708, 109, '2015-03-01 00:21:56.000000', 'temperatura', 1021.0000, 'ºC'),
	(76709, 109, '2015-03-01 00:21:57.000000', 'temperatura', 946.0000, 'ºC'),
	(76710, 109, '2015-03-01 00:21:58.000000', 'temperatura', 466.0000, 'ºC'),
	(76711, 109, '2015-03-01 00:21:59.000000', 'temperatura', 691.0000, 'ºC'),
	(76712, 109, '2015-03-01 00:22:00.000000', 'temperatura', 857.0000, 'ºC'),
	(76713, 109, '2015-03-01 00:22:01.000000', 'temperatura', 1012.0000, 'ºC'),
	(76714, 109, '2015-03-01 00:22:02.000000', 'temperatura', 91.0000, 'ºC'),
	(76715, 109, '2015-03-01 00:22:03.000000', 'temperatura', 1020.0000, 'ºC'),
	(76716, 109, '2015-03-01 00:22:04.000000', 'temperatura', 28.0000, 'ºC'),
	(76717, 109, '2015-03-01 00:22:05.000000', 'temperatura', 679.0000, 'ºC'),
	(76718, 109, '2015-03-01 00:22:06.000000', 'temperatura', 913.0000, 'ºC'),
	(76719, 109, '2015-03-01 00:22:07.000000', 'temperatura', 127.0000, 'ºC'),
	(76720, 109, '2015-03-01 00:22:08.000000', 'temperatura', 295.0000, 'ºC'),
	(76721, 109, '2015-03-01 00:22:09.000000', 'temperatura', 1097.0000, 'ºC'),
	(76722, 109, '2015-03-01 00:22:10.000000', 'temperatura', 1001.0000, 'ºC'),
	(76723, 109, '2015-03-01 00:22:11.000000', 'temperatura', 513.0000, 'ºC'),
	(76724, 109, '2015-03-01 00:22:12.000000', 'temperatura', 762.0000, 'ºC'),
	(76725, 109, '2015-03-01 00:22:13.000000', 'temperatura', 1071.0000, 'ºC'),
	(76726, 109, '2015-03-01 00:22:14.000000', 'temperatura', 668.0000, 'ºC'),
	(76727, 109, '2015-03-01 00:22:15.000000', 'temperatura', 131.0000, 'ºC'),
	(76728, 109, '2015-03-01 00:22:16.000000', 'temperatura', 1048.0000, 'ºC'),
	(76729, 109, '2015-03-01 00:22:17.000000', 'temperatura', 50.0000, 'ºC'),
	(76730, 109, '2015-03-01 00:22:18.000000', 'temperatura', 706.0000, 'ºC'),
	(76731, 109, '2015-03-01 00:22:19.000000', 'temperatura', 982.0000, 'ºC'),
	(76732, 109, '2015-03-01 00:22:20.000000', 'temperatura', 392.0000, 'ºC'),
	(76733, 109, '2015-03-01 00:22:21.000000', 'temperatura', 216.0000, 'ºC'),
	(76734, 109, '2015-03-01 00:22:22.000000', 'temperatura', 1104.0000, 'ºC'),
	(76735, 109, '2015-03-01 00:22:23.000000', 'temperatura', 71.0000, 'ºC'),
	(76736, 109, '2015-03-01 00:22:24.000000', 'temperatura', 646.0000, 'ºC'),
	(76737, 109, '2015-03-01 00:22:25.000000', 'temperatura', 616.0000, 'ºC'),
	(76738, 109, '2015-03-01 00:22:26.000000', 'temperatura', 1143.0000, 'ºC'),
	(76739, 109, '2015-03-01 00:22:27.000000', 'temperatura', 267.0000, 'ºC'),
	(76740, 109, '2015-03-01 00:22:28.000000', 'temperatura', 306.0000, 'ºC'),
	(76741, 109, '2015-03-01 00:22:29.000000', 'temperatura', 729.0000, 'ºC'),
	(76742, 109, '2015-03-01 00:22:30.000000', 'temperatura', 327.0000, 'ºC'),
	(76743, 109, '2015-03-01 00:22:31.000000', 'temperatura', 651.0000, 'ºC'),
	(76744, 109, '2015-03-01 00:22:32.000000', 'temperatura', 1075.0000, 'ºC'),
	(76745, 109, '2015-03-01 00:22:33.000000', 'temperatura', 1021.0000, 'ºC'),
	(76746, 109, '2015-03-01 00:22:34.000000', 'temperatura', 681.0000, 'ºC'),
	(76747, 109, '2015-03-01 00:22:35.000000', 'temperatura', 344.0000, 'ºC'),
	(76748, 109, '2015-03-01 00:22:36.000000', 'temperatura', 877.0000, 'ºC'),
	(76749, 109, '2015-03-01 00:22:37.000000', 'temperatura', 952.0000, 'ºC'),
	(76750, 109, '2015-03-01 00:22:38.000000', 'temperatura', 929.0000, 'ºC'),
	(76751, 109, '2015-03-01 00:22:39.000000', 'temperatura', 589.0000, 'ºC'),
	(76752, 109, '2015-03-01 00:22:40.000000', 'temperatura', 160.0000, 'ºC'),
	(76753, 109, '2015-03-01 00:22:41.000000', 'temperatura', 232.0000, 'ºC'),
	(76754, 109, '2015-03-01 00:22:42.000000', 'temperatura', 682.0000, 'ºC'),
	(76755, 109, '2015-03-01 00:22:43.000000', 'temperatura', 314.0000, 'ºC'),
	(76756, 109, '2015-03-01 00:22:44.000000', 'temperatura', 724.0000, 'ºC'),
	(76757, 109, '2015-03-01 00:22:45.000000', 'temperatura', 281.0000, 'ºC'),
	(76758, 109, '2015-03-01 00:22:46.000000', 'temperatura', 432.0000, 'ºC'),
	(76759, 109, '2015-03-01 00:22:47.000000', 'temperatura', 117.0000, 'ºC'),
	(76760, 109, '2015-03-01 00:22:48.000000', 'temperatura', 490.0000, 'ºC'),
	(76761, 109, '2015-03-01 00:22:49.000000', 'temperatura', 901.0000, 'ºC'),
	(76762, 109, '2015-03-01 00:22:50.000000', 'temperatura', 636.0000, 'ºC'),
	(76763, 109, '2015-03-01 00:22:51.000000', 'temperatura', 475.0000, 'ºC'),
	(76764, 109, '2015-03-01 00:22:52.000000', 'temperatura', 470.0000, 'ºC'),
	(76765, 109, '2015-03-01 00:22:53.000000', 'temperatura', 926.0000, 'ºC'),
	(76766, 109, '2015-03-01 00:22:54.000000', 'temperatura', 821.0000, 'ºC'),
	(76767, 109, '2015-03-01 00:22:55.000000', 'temperatura', 127.0000, 'ºC'),
	(76768, 109, '2015-03-01 00:22:56.000000', 'temperatura', 571.0000, 'ºC'),
	(76769, 109, '2015-03-01 00:22:57.000000', 'temperatura', 76.0000, 'ºC'),
	(76770, 109, '2015-03-01 00:22:58.000000', 'temperatura', 1065.0000, 'ºC'),
	(76771, 109, '2015-03-01 00:22:59.000000', 'temperatura', 300.0000, 'ºC'),
	(76772, 109, '2015-03-01 00:23:00.000000', 'temperatura', 704.0000, 'ºC'),
	(76773, 109, '2015-03-01 00:23:01.000000', 'temperatura', 220.0000, 'ºC'),
	(76774, 109, '2015-03-01 00:23:02.000000', 'temperatura', 190.0000, 'ºC'),
	(76775, 109, '2015-03-01 00:23:03.000000', 'temperatura', 288.0000, 'ºC'),
	(76776, 109, '2015-03-01 00:23:04.000000', 'temperatura', 871.0000, 'ºC'),
	(76777, 109, '2015-03-01 00:23:05.000000', 'temperatura', 1093.0000, 'ºC'),
	(76778, 109, '2015-03-01 00:23:06.000000', 'temperatura', 451.0000, 'ºC'),
	(76779, 109, '2015-03-01 00:23:07.000000', 'temperatura', 176.0000, 'ºC'),
	(76780, 109, '2015-03-01 00:23:08.000000', 'temperatura', 729.0000, 'ºC'),
	(76781, 109, '2015-03-01 00:23:09.000000', 'temperatura', 715.0000, 'ºC'),
	(76782, 109, '2015-03-01 00:23:10.000000', 'temperatura', 191.0000, 'ºC'),
	(76783, 109, '2015-03-01 00:23:11.000000', 'temperatura', 10.0000, 'ºC'),
	(76784, 109, '2015-03-01 00:23:12.000000', 'temperatura', 675.0000, 'ºC'),
	(76785, 109, '2015-03-01 00:23:13.000000', 'temperatura', 948.0000, 'ºC'),
	(76786, 109, '2015-03-01 00:23:14.000000', 'temperatura', 316.0000, 'ºC'),
	(76787, 109, '2015-03-01 00:23:15.000000', 'temperatura', 1136.0000, 'ºC'),
	(76788, 109, '2015-03-01 00:23:16.000000', 'temperatura', 1131.0000, 'ºC'),
	(76789, 109, '2015-03-01 00:23:17.000000', 'temperatura', 1048.0000, 'ºC'),
	(76790, 109, '2015-03-01 00:23:18.000000', 'temperatura', 647.0000, 'ºC'),
	(76791, 109, '2015-03-01 00:23:19.000000', 'temperatura', 93.0000, 'ºC'),
	(76792, 109, '2015-03-01 00:23:20.000000', 'temperatura', 925.0000, 'ºC'),
	(76793, 109, '2015-03-01 00:23:21.000000', 'temperatura', 745.0000, 'ºC'),
	(76794, 109, '2015-03-01 00:23:22.000000', 'temperatura', 951.0000, 'ºC'),
	(76795, 109, '2015-03-01 00:23:23.000000', 'temperatura', 121.0000, 'ºC'),
	(76796, 109, '2015-03-01 00:23:24.000000', 'temperatura', 152.0000, 'ºC'),
	(76797, 109, '2015-03-01 00:23:25.000000', 'temperatura', 396.0000, 'ºC'),
	(76798, 109, '2015-03-01 00:23:26.000000', 'temperatura', 324.0000, 'ºC'),
	(76799, 109, '2015-03-01 00:23:27.000000', 'temperatura', 432.0000, 'ºC'),
	(76800, 109, '2015-03-01 00:23:28.000000', 'temperatura', 1188.0000, 'ºC'),
	(76801, 109, '2015-03-01 00:23:29.000000', 'temperatura', 1047.0000, 'ºC'),
	(76802, 109, '2015-03-01 00:23:30.000000', 'temperatura', 469.0000, 'ºC'),
	(76803, 109, '2015-03-01 00:23:31.000000', 'temperatura', 404.0000, 'ºC'),
	(76804, 109, '2015-03-01 00:23:32.000000', 'temperatura', 615.0000, 'ºC'),
	(76805, 109, '2015-03-01 00:23:33.000000', 'temperatura', 663.0000, 'ºC'),
	(76806, 109, '2015-03-01 00:23:34.000000', 'temperatura', 272.0000, 'ºC'),
	(76807, 109, '2015-03-01 00:23:35.000000', 'temperatura', 571.0000, 'ºC'),
	(76808, 109, '2015-03-01 00:23:36.000000', 'temperatura', 839.0000, 'ºC'),
	(76809, 109, '2015-03-01 00:23:37.000000', 'temperatura', 84.0000, 'ºC'),
	(76810, 109, '2015-03-01 00:23:38.000000', 'temperatura', 304.0000, 'ºC'),
	(76811, 109, '2015-03-01 00:23:39.000000', 'temperatura', 66.0000, 'ºC'),
	(76812, 109, '2015-03-01 00:23:40.000000', 'temperatura', 619.0000, 'ºC'),
	(76813, 109, '2015-03-01 00:23:41.000000', 'temperatura', 499.0000, 'ºC'),
	(76814, 109, '2015-03-01 00:23:42.000000', 'temperatura', 637.0000, 'ºC'),
	(76815, 109, '2015-03-01 00:23:43.000000', 'temperatura', 487.0000, 'ºC'),
	(76816, 109, '2015-03-01 00:23:44.000000', 'temperatura', 527.0000, 'ºC'),
	(76817, 109, '2015-03-01 00:23:45.000000', 'temperatura', 1174.0000, 'ºC'),
	(76818, 109, '2015-03-01 00:23:46.000000', 'temperatura', 689.0000, 'ºC'),
	(76819, 109, '2015-03-01 00:23:47.000000', 'temperatura', 1122.0000, 'ºC'),
	(76820, 109, '2015-03-01 00:23:48.000000', 'temperatura', 1143.0000, 'ºC'),
	(76821, 109, '2015-03-01 00:23:49.000000', 'temperatura', 1151.0000, 'ºC'),
	(76822, 109, '2015-03-01 00:23:50.000000', 'temperatura', 1125.0000, 'ºC'),
	(76823, 109, '2015-03-01 00:23:51.000000', 'temperatura', 975.0000, 'ºC'),
	(76824, 109, '2015-03-01 00:23:52.000000', 'temperatura', 299.0000, 'ºC'),
	(76825, 109, '2015-03-01 00:23:53.000000', 'temperatura', 972.0000, 'ºC'),
	(76826, 109, '2015-03-01 00:23:54.000000', 'temperatura', 361.0000, 'ºC'),
	(76827, 109, '2015-03-01 00:23:55.000000', 'temperatura', 89.0000, 'ºC'),
	(76828, 109, '2015-03-01 00:23:56.000000', 'temperatura', 565.0000, 'ºC'),
	(76829, 109, '2015-03-01 00:23:57.000000', 'temperatura', 159.0000, 'ºC'),
	(76830, 109, '2015-03-01 00:23:58.000000', 'temperatura', 300.0000, 'ºC'),
	(76831, 109, '2015-03-01 00:23:59.000000', 'temperatura', 1022.0000, 'ºC'),
	(76832, 109, '2015-03-01 00:24:00.000000', 'temperatura', 613.0000, 'ºC'),
	(76833, 109, '2015-03-01 00:24:01.000000', 'temperatura', 1198.0000, 'ºC'),
	(76834, 109, '2015-03-01 00:24:02.000000', 'temperatura', 550.0000, 'ºC'),
	(76835, 109, '2015-03-01 00:24:03.000000', 'temperatura', 359.0000, 'ºC'),
	(76836, 109, '2015-03-01 00:24:04.000000', 'temperatura', 145.0000, 'ºC'),
	(76837, 109, '2015-03-01 00:24:05.000000', 'temperatura', 847.0000, 'ºC'),
	(76838, 109, '2015-03-01 00:24:06.000000', 'temperatura', 200.0000, 'ºC'),
	(76839, 109, '2015-03-01 00:24:07.000000', 'temperatura', 861.0000, 'ºC'),
	(76840, 109, '2015-03-01 00:24:08.000000', 'temperatura', 104.0000, 'ºC'),
	(76841, 109, '2015-03-01 00:24:09.000000', 'temperatura', 340.0000, 'ºC'),
	(76842, 109, '2015-03-01 00:24:10.000000', 'temperatura', 187.0000, 'ºC'),
	(76843, 109, '2015-03-01 00:24:11.000000', 'temperatura', 1116.0000, 'ºC'),
	(76844, 109, '2015-03-01 00:24:12.000000', 'temperatura', 220.0000, 'ºC'),
	(76845, 109, '2015-03-01 00:24:13.000000', 'temperatura', 153.0000, 'ºC'),
	(76846, 109, '2015-03-01 00:24:14.000000', 'temperatura', 103.0000, 'ºC'),
	(76847, 109, '2015-03-01 00:24:15.000000', 'temperatura', 58.0000, 'ºC'),
	(76848, 109, '2015-03-01 00:24:16.000000', 'temperatura', 1182.0000, 'ºC'),
	(76849, 109, '2015-03-01 00:24:17.000000', 'temperatura', 936.0000, 'ºC'),
	(76850, 109, '2015-03-01 00:24:18.000000', 'temperatura', 1136.0000, 'ºC'),
	(76851, 109, '2015-03-01 00:24:19.000000', 'temperatura', 470.0000, 'ºC'),
	(76852, 109, '2015-03-01 00:24:20.000000', 'temperatura', 144.0000, 'ºC'),
	(76853, 109, '2015-03-01 00:24:21.000000', 'temperatura', 509.0000, 'ºC'),
	(76854, 109, '2015-03-01 00:24:22.000000', 'temperatura', 915.0000, 'ºC'),
	(76855, 109, '2015-03-01 00:24:23.000000', 'temperatura', 648.0000, 'ºC'),
	(76856, 109, '2015-03-01 00:24:24.000000', 'temperatura', 496.0000, 'ºC'),
	(76857, 109, '2015-03-01 00:24:25.000000', 'temperatura', 537.0000, 'ºC'),
	(76858, 109, '2015-03-01 00:24:26.000000', 'temperatura', 1197.0000, 'ºC'),
	(76859, 109, '2015-03-01 00:24:27.000000', 'temperatura', 774.0000, 'ºC'),
	(76860, 109, '2015-03-01 00:24:28.000000', 'temperatura', 279.0000, 'ºC'),
	(76861, 109, '2015-03-01 00:24:29.000000', 'temperatura', 273.0000, 'ºC'),
	(76862, 109, '2015-03-01 00:24:30.000000', 'temperatura', 530.0000, 'ºC'),
	(76863, 109, '2015-03-01 00:24:31.000000', 'temperatura', 630.0000, 'ºC'),
	(76864, 109, '2015-03-01 00:24:32.000000', 'temperatura', 359.0000, 'ºC'),
	(76865, 109, '2015-03-01 00:24:33.000000', 'temperatura', 1109.0000, 'ºC'),
	(76866, 109, '2015-03-01 00:24:34.000000', 'temperatura', 867.0000, 'ºC'),
	(76867, 109, '2015-03-01 00:24:35.000000', 'temperatura', 1008.0000, 'ºC'),
	(76868, 109, '2015-03-01 00:24:36.000000', 'temperatura', 41.0000, 'ºC'),
	(76869, 109, '2015-03-01 00:24:37.000000', 'temperatura', 780.0000, 'ºC'),
	(76870, 109, '2015-03-01 00:24:38.000000', 'temperatura', 179.0000, 'ºC'),
	(76871, 109, '2015-03-01 00:24:39.000000', 'temperatura', 955.0000, 'ºC'),
	(76872, 109, '2015-03-01 00:24:40.000000', 'temperatura', 637.0000, 'ºC'),
	(76873, 109, '2015-03-01 00:24:41.000000', 'temperatura', 322.0000, 'ºC'),
	(76874, 109, '2015-03-01 00:24:42.000000', 'temperatura', 900.0000, 'ºC'),
	(76875, 109, '2015-03-01 00:24:43.000000', 'temperatura', 1136.0000, 'ºC'),
	(76876, 109, '2015-03-01 00:24:44.000000', 'temperatura', 578.0000, 'ºC'),
	(76877, 109, '2015-03-01 00:24:45.000000', 'temperatura', 681.0000, 'ºC'),
	(76878, 109, '2015-03-01 00:24:46.000000', 'temperatura', 475.0000, 'ºC'),
	(76879, 109, '2015-03-01 00:24:47.000000', 'temperatura', 330.0000, 'ºC'),
	(76880, 109, '2015-03-01 00:24:48.000000', 'temperatura', 228.0000, 'ºC'),
	(76881, 109, '2015-03-01 00:24:49.000000', 'temperatura', 148.0000, 'ºC'),
	(76882, 109, '2015-03-01 00:24:50.000000', 'temperatura', 59.0000, 'ºC'),
	(76883, 109, '2015-03-01 00:24:51.000000', 'temperatura', 1052.0000, 'ºC'),
	(76884, 109, '2015-03-01 00:24:52.000000', 'temperatura', 284.0000, 'ºC'),
	(76885, 109, '2015-03-01 00:24:53.000000', 'temperatura', 665.0000, 'ºC'),
	(76886, 109, '2015-03-01 00:24:54.000000', 'temperatura', 73.0000, 'ºC'),
	(76887, 109, '2015-03-01 00:24:55.000000', 'temperatura', 770.0000, 'ºC'),
	(76888, 109, '2015-03-01 00:24:56.000000', 'temperatura', 29.0000, 'ºC'),
	(76889, 109, '2015-03-01 00:24:57.000000', 'temperatura', 239.0000, 'ºC'),
	(76890, 109, '2015-03-01 00:24:58.000000', 'temperatura', 1108.0000, 'ºC'),
	(76891, 109, '2015-03-01 00:24:59.000000', 'temperatura', 22.0000, 'ºC'),
	(76892, 109, '2015-03-01 00:25:00.000000', 'temperatura', 389.0000, 'ºC'),
	(76893, 109, '2015-03-01 00:25:01.000000', 'temperatura', 678.0000, 'ºC'),
	(76894, 109, '2015-03-01 00:25:02.000000', 'temperatura', 1023.0000, 'ºC'),
	(76895, 109, '2015-03-01 00:25:03.000000', 'temperatura', 682.0000, 'ºC'),
	(76896, 109, '2015-03-01 00:25:04.000000', 'temperatura', 340.0000, 'ºC'),
	(76897, 109, '2015-03-01 00:25:05.000000', 'temperatura', 856.0000, 'ºC'),
	(76898, 109, '2015-03-01 00:25:06.000000', 'temperatura', 862.0000, 'ºC'),
	(76899, 109, '2015-03-01 00:25:07.000000', 'temperatura', 542.0000, 'ºC'),
	(76900, 109, '2015-03-01 00:25:08.000000', 'temperatura', 125.0000, 'ºC'),
	(76901, 109, '2015-03-01 00:25:09.000000', 'temperatura', 200.0000, 'ºC'),
	(76902, 109, '2015-03-01 00:25:10.000000', 'temperatura', 624.0000, 'ºC'),
	(76903, 109, '2015-03-01 00:25:11.000000', 'temperatura', 123.0000, 'ºC'),
	(76904, 109, '2015-03-01 00:25:12.000000', 'temperatura', 1140.0000, 'ºC'),
	(76905, 109, '2015-03-01 00:25:13.000000', 'temperatura', 535.0000, 'ºC'),
	(76906, 109, '2015-03-01 00:25:14.000000', 'temperatura', 453.0000, 'ºC'),
	(76907, 109, '2015-03-01 00:25:15.000000', 'temperatura', 662.0000, 'ºC'),
	(76908, 109, '2015-03-01 00:25:16.000000', 'temperatura', 749.0000, 'ºC'),
	(76909, 109, '2015-03-01 00:25:17.000000', 'temperatura', 562.0000, 'ºC'),
	(76910, 109, '2015-03-01 00:25:18.000000', 'temperatura', 565.0000, 'ºC'),
	(76911, 109, '2015-03-01 00:25:19.000000', 'temperatura', 1137.0000, 'ºC'),
	(76912, 109, '2015-03-01 00:25:20.000000', 'temperatura', 391.0000, 'ºC'),
	(76913, 109, '2015-03-01 00:25:21.000000', 'temperatura', 943.0000, 'ºC'),
	(76914, 109, '2015-03-01 00:25:22.000000', 'temperatura', 1143.0000, 'ºC'),
	(76915, 109, '2015-03-01 00:25:23.000000', 'temperatura', 487.0000, 'ºC'),
	(76916, 109, '2015-03-01 00:25:24.000000', 'temperatura', 207.0000, 'ºC'),
	(76917, 109, '2015-03-01 00:25:25.000000', 'temperatura', 775.0000, 'ºC'),
	(76918, 109, '2015-03-01 00:25:26.000000', 'temperatura', 854.0000, 'ºC'),
	(76919, 109, '2015-03-01 00:25:27.000000', 'temperatura', 747.0000, 'ºC'),
	(76920, 109, '2015-03-01 00:25:28.000000', 'temperatura', 1173.0000, 'ºC'),
	(76921, 109, '2015-03-01 00:25:29.000000', 'temperatura', 25.0000, 'ºC'),
	(76922, 109, '2015-03-01 00:25:30.000000', 'temperatura', 207.0000, 'ºC'),
	(76923, 109, '2015-03-01 00:25:31.000000', 'temperatura', 962.0000, 'ºC'),
	(76924, 109, '2015-03-01 00:25:32.000000', 'temperatura', 586.0000, 'ºC'),
	(76925, 109, '2015-03-01 00:25:33.000000', 'temperatura', 47.0000, 'ºC'),
	(76926, 109, '2015-03-01 00:25:34.000000', 'temperatura', 877.0000, 'ºC'),
	(76927, 109, '2015-03-01 00:25:35.000000', 'temperatura', 643.0000, 'ºC'),
	(76928, 109, '2015-03-01 00:25:36.000000', 'temperatura', 587.0000, 'ºC'),
	(76929, 109, '2015-03-01 00:25:37.000000', 'temperatura', 1005.0000, 'ºC'),
	(76930, 109, '2015-03-01 00:25:38.000000', 'temperatura', 864.0000, 'ºC'),
	(76931, 109, '2015-03-01 00:25:39.000000', 'temperatura', 106.0000, 'ºC'),
	(76932, 109, '2015-03-01 00:25:40.000000', 'temperatura', 339.0000, 'ºC'),
	(76933, 109, '2015-03-01 00:25:41.000000', 'temperatura', 179.0000, 'ºC'),
	(76934, 109, '2015-03-01 00:25:42.000000', 'temperatura', 1078.0000, 'ºC'),
	(76935, 109, '2015-03-01 00:25:43.000000', 'temperatura', 53.0000, 'ºC'),
	(76936, 109, '2015-03-01 00:25:44.000000', 'temperatura', 630.0000, 'ºC'),
	(76937, 109, '2015-03-01 00:25:45.000000', 'temperatura', 593.0000, 'ºC'),
	(76938, 109, '2015-03-01 00:25:46.000000', 'temperatura', 1074.0000, 'ºC'),
	(76939, 109, '2015-03-01 00:25:47.000000', 'temperatura', 1193.0000, 'ºC'),
	(76940, 109, '2015-03-01 00:25:48.000000', 'temperatura', 344.0000, 'ºC'),
	(76941, 109, '2015-03-01 00:25:49.000000', 'temperatura', 542.0000, 'ºC'),
	(76942, 109, '2015-03-01 00:25:50.000000', 'temperatura', 476.0000, 'ºC'),
	(76943, 109, '2015-03-01 00:25:51.000000', 'temperatura', 758.0000, 'ºC'),
	(76944, 109, '2015-03-01 00:25:52.000000', 'temperatura', 1159.0000, 'ºC'),
	(76945, 109, '2015-03-01 00:25:53.000000', 'temperatura', 1123.0000, 'ºC'),
	(76946, 109, '2015-03-01 00:25:54.000000', 'temperatura', 937.0000, 'ºC'),
	(76947, 109, '2015-03-01 00:25:55.000000', 'temperatura', 117.0000, 'ºC'),
	(76948, 109, '2015-03-01 00:25:56.000000', 'temperatura', 175.0000, 'ºC'),
	(76949, 109, '2015-03-01 00:25:57.000000', 'temperatura', 525.0000, 'ºC'),
	(76950, 109, '2015-03-01 00:25:58.000000', 'temperatura', 898.0000, 'ºC'),
	(76951, 109, '2015-03-01 00:25:59.000000', 'temperatura', 518.0000, 'ºC'),
	(76952, 109, '2015-03-01 00:26:00.000000', 'temperatura', 1094.0000, 'ºC'),
	(76953, 109, '2015-03-01 00:26:01.000000', 'temperatura', 317.0000, 'ºC'),
	(76954, 109, '2015-03-01 00:26:02.000000', 'temperatura', 702.0000, 'ºC'),
	(76955, 109, '2015-03-01 00:26:03.000000', 'temperatura', 160.0000, 'ºC'),
	(76956, 109, '2015-03-01 00:26:04.000000', 'temperatura', 1096.0000, 'ºC'),
	(76957, 109, '2015-03-01 00:26:05.000000', 'temperatura', 202.0000, 'ºC'),
	(76958, 109, '2015-03-01 00:26:06.000000', 'temperatura', 121.0000, 'ºC'),
	(76959, 109, '2015-03-01 00:26:07.000000', 'temperatura', 1198.0000, 'ºC'),
	(76960, 109, '2015-03-01 00:26:08.000000', 'temperatura', 830.0000, 'ºC'),
	(76961, 109, '2015-03-01 00:26:09.000000', 'temperatura', 557.0000, 'ºC'),
	(76962, 109, '2015-03-01 00:26:10.000000', 'temperatura', 292.0000, 'ºC'),
	(76963, 109, '2015-03-01 00:26:11.000000', 'temperatura', 993.0000, 'ºC'),
	(76964, 109, '2015-03-01 00:26:12.000000', 'temperatura', 488.0000, 'ºC'),
	(76965, 109, '2015-03-01 00:26:13.000000', 'temperatura', 663.0000, 'ºC'),
	(76966, 109, '2015-03-01 00:26:14.000000', 'temperatura', 651.0000, 'ºC'),
	(76967, 109, '2015-03-01 00:26:15.000000', 'temperatura', 68.0000, 'ºC'),
	(76968, 109, '2015-03-01 00:26:16.000000', 'temperatura', 787.0000, 'ºC'),
	(76969, 109, '2015-03-01 00:26:17.000000', 'temperatura', 131.0000, 'ºC'),
	(76970, 109, '2015-03-01 00:26:18.000000', 'temperatura', 695.0000, 'ºC'),
	(76971, 109, '2015-03-01 00:26:19.000000', 'temperatura', 684.0000, 'ºC'),
	(76972, 109, '2015-03-01 00:26:20.000000', 'temperatura', 134.0000, 'ºC'),
	(76973, 109, '2015-03-01 00:26:21.000000', 'temperatura', 1019.0000, 'ºC'),
	(76974, 109, '2015-03-01 00:26:22.000000', 'temperatura', 1092.0000, 'ºC'),
	(76975, 109, '2015-03-01 00:26:23.000000', 'temperatura', 6.0000, 'ºC'),
	(76976, 109, '2015-03-01 00:26:24.000000', 'temperatura', 354.0000, 'ºC'),
	(76977, 109, '2015-03-01 00:26:25.000000', 'temperatura', 551.0000, 'ºC'),
	(76978, 109, '2015-03-01 00:26:26.000000', 'temperatura', 493.0000, 'ºC'),
	(76979, 109, '2015-03-01 00:26:27.000000', 'temperatura', 814.0000, 'ºC'),
	(76980, 109, '2015-03-01 00:26:28.000000', 'temperatura', 192.0000, 'ºC'),
	(76981, 109, '2015-03-01 00:26:29.000000', 'temperatura', 916.0000, 'ºC'),
	(76982, 109, '2015-03-01 00:26:30.000000', 'temperatura', 407.0000, 'ºC'),
	(76983, 109, '2015-03-01 00:26:31.000000', 'temperatura', 488.0000, 'ºC'),
	(76984, 109, '2015-03-01 00:26:32.000000', 'temperatura', 18.0000, 'ºC'),
	(76985, 109, '2015-03-01 00:26:33.000000', 'temperatura', 1027.0000, 'ºC'),
	(76986, 109, '2015-03-01 00:26:34.000000', 'temperatura', 280.0000, 'ºC'),
	(76987, 109, '2015-03-01 00:26:35.000000', 'temperatura', 721.0000, 'ºC'),
	(76988, 109, '2015-03-01 00:26:36.000000', 'temperatura', 364.0000, 'ºC'),
	(76989, 109, '2015-03-01 00:26:37.000000', 'temperatura', 856.0000, 'ºC'),
	(76990, 109, '2015-03-01 00:26:38.000000', 'temperatura', 792.0000, 'ºC'),
	(76991, 109, '2015-03-01 00:26:39.000000', 'temperatura', 190.0000, 'ºC'),
	(76992, 109, '2015-03-01 00:26:40.000000', 'temperatura', 975.0000, 'ºC'),
	(76993, 109, '2015-03-01 00:26:41.000000', 'temperatura', 708.0000, 'ºC'),
	(76994, 109, '2015-03-01 00:26:42.000000', 'temperatura', 613.0000, 'ºC'),
	(76995, 109, '2015-03-01 00:26:43.000000', 'temperatura', 944.0000, 'ºC'),
	(76996, 109, '2015-03-01 00:26:44.000000', 'temperatura', 479.0000, 'ºC'),
	(76997, 109, '2015-03-01 00:26:45.000000', 'temperatura', 764.0000, 'ºC'),
	(76998, 109, '2015-03-01 00:26:46.000000', 'temperatura', 1182.0000, 'ºC'),
	(76999, 109, '2015-03-01 00:26:47.000000', 'temperatura', 19.0000, 'ºC'),
	(77000, 109, '2015-03-01 00:26:48.000000', 'temperatura', 151.0000, 'ºC'),
	(77001, 109, '2015-03-01 00:26:49.000000', 'temperatura', 699.0000, 'ºC'),
	(77002, 109, '2015-03-01 00:26:50.000000', 'temperatura', 641.0000, 'ºC'),
	(77003, 109, '2015-03-01 00:26:51.000000', 'temperatura', 1107.0000, 'ºC'),
	(77004, 109, '2015-03-01 00:26:52.000000', 'temperatura', 15.0000, 'ºC'),
	(77005, 109, '2015-03-01 00:26:53.000000', 'temperatura', 352.0000, 'ºC'),
	(77006, 109, '2015-03-01 00:26:54.000000', 'temperatura', 516.0000, 'ºC'),
	(77007, 109, '2015-03-01 00:26:55.000000', 'temperatura', 325.0000, 'ºC'),
	(77008, 109, '2015-03-01 00:26:56.000000', 'temperatura', 76.0000, 'ºC'),
	(77009, 109, '2015-03-01 00:26:57.000000', 'temperatura', 605.0000, 'ºC'),
	(77010, 109, '2015-03-01 00:26:58.000000', 'temperatura', 400.0000, 'ºC'),
	(77011, 109, '2015-03-01 00:26:59.000000', 'temperatura', 185.0000, 'ºC'),
	(77012, 109, '2015-03-01 00:27:00.000000', 'temperatura', 925.0000, 'ºC'),
	(77013, 109, '2015-03-01 00:27:01.000000', 'temperatura', 469.0000, 'ºC'),
	(77014, 109, '2015-03-01 00:27:02.000000', 'temperatura', 771.0000, 'ºC'),
	(77015, 109, '2015-03-01 00:27:03.000000', 'temperatura', 47.0000, 'ºC'),
	(77016, 109, '2015-03-01 00:27:04.000000', 'temperatura', 324.0000, 'ºC'),
	(77017, 109, '2015-03-01 00:27:05.000000', 'temperatura', 280.0000, 'ºC'),
	(77018, 109, '2015-03-01 00:27:06.000000', 'temperatura', 428.0000, 'ºC'),
	(77019, 109, '2015-03-01 00:27:07.000000', 'temperatura', 100.0000, 'ºC'),
	(77020, 109, '2015-03-01 00:27:08.000000', 'temperatura', 417.0000, 'ºC'),
	(77021, 109, '2015-03-01 00:27:09.000000', 'temperatura', 585.0000, 'ºC'),
	(77022, 109, '2015-03-01 00:27:10.000000', 'temperatura', 475.0000, 'ºC'),
	(77023, 109, '2015-03-01 00:27:11.000000', 'temperatura', 619.0000, 'ºC'),
	(77024, 109, '2015-03-01 00:27:12.000000', 'temperatura', 473.0000, 'ºC'),
	(77025, 109, '2015-03-01 00:27:13.000000', 'temperatura', 508.0000, 'ºC'),
	(77026, 109, '2015-03-01 00:27:14.000000', 'temperatura', 1121.0000, 'ºC'),
	(77027, 109, '2015-03-01 00:27:15.000000', 'temperatura', 480.0000, 'ºC'),
	(77028, 109, '2015-03-01 00:27:16.000000', 'temperatura', 238.0000, 'ºC'),
	(77029, 109, '2015-03-01 00:27:17.000000', 'temperatura', 951.0000, 'ºC'),
	(77030, 109, '2015-03-01 00:27:18.000000', 'temperatura', 441.0000, 'ºC'),
	(77031, 109, '2015-03-01 00:27:19.000000', 'temperatura', 552.0000, 'ºC'),
	(77032, 109, '2015-03-01 00:27:20.000000', 'temperatura', 239.0000, 'ºC'),
	(77033, 109, '2015-03-01 00:27:21.000000', 'temperatura', 738.0000, 'ºC'),
	(77034, 109, '2015-03-01 00:27:22.000000', 'temperatura', 575.0000, 'ºC'),
	(77035, 109, '2015-03-01 00:27:23.000000', 'temperatura', 662.0000, 'ºC'),
	(77036, 109, '2015-03-01 00:27:24.000000', 'temperatura', 386.0000, 'ºC'),
	(77037, 109, '2015-03-01 00:27:25.000000', 'temperatura', 1142.0000, 'ºC'),
	(77038, 109, '2015-03-01 00:27:26.000000', 'temperatura', 953.0000, 'ºC'),
	(77039, 109, '2015-03-01 00:27:27.000000', 'temperatura', 142.0000, 'ºC'),
	(77040, 109, '2015-03-01 00:27:28.000000', 'temperatura', 249.0000, 'ºC'),
	(77041, 109, '2015-03-01 00:27:29.000000', 'temperatura', 818.0000, 'ºC'),
	(77042, 109, '2015-03-01 00:27:30.000000', 'temperatura', 946.0000, 'ºC'),
	(77043, 109, '2015-03-01 00:27:31.000000', 'temperatura', 1075.0000, 'ºC'),
	(77044, 109, '2015-03-01 00:27:32.000000', 'temperatura', 139.0000, 'ºC'),
	(77045, 109, '2015-03-01 00:27:33.000000', 'temperatura', 1070.0000, 'ºC'),
	(77046, 109, '2015-03-01 00:27:34.000000', 'temperatura', 133.0000, 'ºC'),
	(77047, 109, '2015-03-01 00:27:35.000000', 'temperatura', 1056.0000, 'ºC'),
	(77048, 109, '2015-03-01 00:27:36.000000', 'temperatura', 81.0000, 'ºC'),
	(77049, 109, '2015-03-01 00:27:37.000000', 'temperatura', 840.0000, 'ºC'),
	(77050, 109, '2015-03-01 00:27:38.000000', 'temperatura', 355.0000, 'ºC'),
	(77051, 109, '2015-03-01 00:27:39.000000', 'temperatura', 455.0000, 'ºC'),
	(77052, 109, '2015-03-01 00:27:40.000000', 'temperatura', 13.0000, 'ºC'),
	(77053, 109, '2015-03-01 00:27:41.000000', 'temperatura', 1099.0000, 'ºC'),
	(77054, 109, '2015-03-01 00:27:42.000000', 'temperatura', 658.0000, 'ºC'),
	(77055, 109, '2015-03-01 00:27:43.000000', 'temperatura', 1191.0000, 'ºC'),
	(77056, 109, '2015-03-01 00:27:44.000000', 'temperatura', 382.0000, 'ºC'),
	(77057, 109, '2015-03-01 00:27:45.000000', 'temperatura', 737.0000, 'ºC'),
	(77058, 109, '2015-03-01 00:27:46.000000', 'temperatura', 141.0000, 'ºC'),
	(77059, 109, '2015-03-01 00:27:47.000000', 'temperatura', 894.0000, 'ºC'),
	(77060, 109, '2015-03-01 00:27:48.000000', 'temperatura', 449.0000, 'ºC'),
	(77061, 109, '2015-03-01 00:27:49.000000', 'temperatura', 762.0000, 'ºC'),
	(77062, 109, '2015-03-01 00:27:50.000000', 'temperatura', 62.0000, 'ºC'),
	(77063, 109, '2015-03-01 00:27:51.000000', 'temperatura', 426.0000, 'ºC'),
	(77064, 109, '2015-03-01 00:27:52.000000', 'temperatura', 743.0000, 'ºC'),
	(77065, 109, '2015-03-01 00:27:53.000000', 'temperatura', 40.0000, 'ºC'),
	(77066, 109, '2015-03-01 00:27:54.000000', 'temperatura', 370.0000, 'ºC'),
	(77067, 109, '2015-03-01 00:27:55.000000', 'temperatura', 532.0000, 'ºC'),
	(77068, 109, '2015-03-01 00:27:56.000000', 'temperatura', 351.0000, 'ºC'),
	(77069, 109, '2015-03-01 00:27:57.000000', 'temperatura', 159.0000, 'ºC'),
	(77070, 109, '2015-03-01 00:27:58.000000', 'temperatura', 944.0000, 'ºC'),
	(77071, 109, '2015-03-01 00:27:59.000000', 'temperatura', 642.0000, 'ºC'),
	(77072, 109, '2015-03-01 00:28:00.000000', 'temperatura', 380.0000, 'ºC'),
	(77073, 109, '2015-03-01 00:28:01.000000', 'temperatura', 1172.0000, 'ºC'),
	(77074, 109, '2015-03-01 00:28:02.000000', 'temperatura', 1122.0000, 'ºC'),
	(77075, 109, '2015-03-01 00:28:03.000000', 'temperatura', 896.0000, 'ºC'),
	(77076, 109, '2015-03-01 00:28:04.000000', 'temperatura', 1114.0000, 'ºC'),
	(77077, 109, '2015-03-01 00:28:05.000000', 'temperatura', 481.0000, 'ºC'),
	(77078, 109, '2015-03-01 00:28:06.000000', 'temperatura', 266.0000, 'ºC'),
	(77079, 109, '2015-03-01 00:28:07.000000', 'temperatura', 1084.0000, 'ºC'),
	(77080, 109, '2015-03-01 00:28:08.000000', 'temperatura', 1026.0000, 'ºC'),
	(77081, 109, '2015-03-01 00:28:09.000000', 'temperatura', 675.0000, 'ºC'),
	(77082, 109, '2015-03-01 00:28:10.000000', 'temperatura', 299.0000, 'ºC'),
	(77083, 109, '2015-03-01 00:28:11.000000', 'temperatura', 671.0000, 'ºC'),
	(77084, 109, '2015-03-01 00:28:12.000000', 'temperatura', 57.0000, 'ºC'),
	(77085, 109, '2015-03-01 00:28:13.000000', 'temperatura', 675.0000, 'ºC'),
	(77086, 109, '2015-03-01 00:28:14.000000', 'temperatura', 801.0000, 'ºC'),
	(77087, 109, '2015-03-01 00:28:15.000000', 'temperatura', 784.0000, 'ºC'),
	(77088, 109, '2015-03-01 00:28:16.000000', 'temperatura', 316.0000, 'ºC'),
	(77089, 109, '2015-03-01 00:28:17.000000', 'temperatura', 429.0000, 'ºC'),
	(77090, 109, '2015-03-01 00:28:18.000000', 'temperatura', 1198.0000, 'ºC'),
	(77091, 109, '2015-03-01 00:28:19.000000', 'temperatura', 1103.0000, 'ºC'),
	(77092, 109, '2015-03-01 00:28:20.000000', 'temperatura', 724.0000, 'ºC'),
	(77093, 109, '2015-03-01 00:28:21.000000', 'temperatura', 308.0000, 'ºC'),
	(77094, 109, '2015-03-01 00:28:22.000000', 'temperatura', 570.0000, 'ºC'),
	(77095, 109, '2015-03-01 00:28:23.000000', 'temperatura', 726.0000, 'ºC'),
	(77096, 109, '2015-03-01 00:28:24.000000', 'temperatura', 723.0000, 'ºC'),
	(77097, 109, '2015-03-01 00:28:25.000000', 'temperatura', 235.0000, 'ºC'),
	(77098, 109, '2015-03-01 00:28:26.000000', 'temperatura', 208.0000, 'ºC'),
	(77099, 109, '2015-03-01 00:28:27.000000', 'temperatura', 336.0000, 'ºC'),
	(77100, 109, '2015-03-01 00:28:28.000000', 'temperatura', 1056.0000, 'ºC'),
	(77101, 109, '2015-03-01 00:28:29.000000', 'temperatura', 673.0000, 'ºC'),
	(77102, 109, '2015-03-01 00:28:30.000000', 'temperatura', 198.0000, 'ºC'),
	(77103, 109, '2015-03-01 00:28:31.000000', 'temperatura', 169.0000, 'ºC'),
	(77104, 109, '2015-03-01 00:28:32.000000', 'temperatura', 254.0000, 'ºC'),
	(77105, 109, '2015-03-01 00:28:33.000000', 'temperatura', 762.0000, 'ºC'),
	(77106, 109, '2015-03-01 00:28:34.000000', 'temperatura', 649.0000, 'ºC'),
	(77107, 109, '2015-03-01 00:28:35.000000', 'temperatura', 961.0000, 'ºC'),
	(77108, 109, '2015-03-01 00:28:36.000000', 'temperatura', 459.0000, 'ºC'),
	(77109, 109, '2015-03-01 00:28:37.000000', 'temperatura', 612.0000, 'ºC'),
	(77110, 109, '2015-03-01 00:28:38.000000', 'temperatura', 484.0000, 'ºC'),
	(77111, 109, '2015-03-01 00:28:39.000000', 'temperatura', 583.0000, 'ºC'),
	(77112, 109, '2015-03-01 00:28:40.000000', 'temperatura', 265.0000, 'ºC'),
	(77113, 109, '2015-03-01 00:28:41.000000', 'temperatura', 776.0000, 'ºC'),
	(77114, 109, '2015-03-01 00:28:42.000000', 'temperatura', 687.0000, 'ºC'),
	(77115, 109, '2015-03-01 00:28:43.000000', 'temperatura', 1108.0000, 'ºC'),
	(77116, 109, '2015-03-01 00:28:44.000000', 'temperatura', 1080.0000, 'ºC'),
	(77117, 109, '2015-03-01 00:28:45.000000', 'temperatura', 873.0000, 'ºC'),
	(77118, 109, '2015-03-01 00:28:46.000000', 'temperatura', 1128.0000, 'ºC'),
	(77119, 109, '2015-03-01 00:28:47.000000', 'temperatura', 623.0000, 'ºC'),
	(77120, 109, '2015-03-01 00:28:48.000000', 'temperatura', 929.0000, 'ºC'),
	(77121, 109, '2015-03-01 00:28:49.000000', 'temperatura', 379.0000, 'ºC'),
	(77122, 109, '2015-03-01 00:28:50.000000', 'temperatura', 308.0000, 'ºC'),
	(77123, 109, '2015-03-01 00:28:51.000000', 'temperatura', 401.0000, 'ºC'),
	(77124, 109, '2015-03-01 00:28:52.000000', 'temperatura', 1084.0000, 'ºC'),
	(77125, 109, '2015-03-01 00:28:53.000000', 'temperatura', 615.0000, 'ºC'),
	(77126, 109, '2015-03-01 00:28:54.000000', 'temperatura', 1025.0000, 'ºC'),
	(77127, 109, '2015-03-01 00:28:55.000000', 'temperatura', 881.0000, 'ºC'),
	(77128, 109, '2015-03-01 00:28:56.000000', 'temperatura', 131.0000, 'ºC'),
	(77129, 109, '2015-03-01 00:28:57.000000', 'temperatura', 410.0000, 'ºC'),
	(77130, 109, '2015-03-01 00:28:58.000000', 'temperatura', 460.0000, 'ºC'),
	(77131, 109, '2015-03-01 00:28:59.000000', 'temperatura', 1070.0000, 'ºC'),
	(77132, 109, '2015-03-01 00:29:00.000000', 'temperatura', 371.0000, 'ºC'),
	(77133, 109, '2015-03-01 00:29:01.000000', 'temperatura', 1044.0000, 'ºC'),
	(77134, 109, '2015-03-01 00:29:02.000000', 'temperatura', 509.0000, 'ºC'),
	(77135, 109, '2015-03-01 00:29:03.000000', 'temperatura', 614.0000, 'ºC'),
	(77136, 109, '2015-03-01 00:29:04.000000', 'temperatura', 342.0000, 'ºC'),
	(77137, 109, '2015-03-01 00:29:05.000000', 'temperatura', 1068.0000, 'ºC'),
	(77138, 109, '2015-03-01 00:29:06.000000', 'temperatura', 717.0000, 'ºC'),
	(77139, 109, '2015-03-01 00:29:07.000000', 'temperatura', 381.0000, 'ºC'),
	(77140, 109, '2015-03-01 00:29:08.000000', 'temperatura', 954.0000, 'ºC'),
	(77141, 109, '2015-03-01 00:29:09.000000', 'temperatura', 29.0000, 'ºC'),
	(77142, 109, '2015-03-01 00:29:10.000000', 'temperatura', 882.0000, 'ºC'),
	(77143, 109, '2015-03-01 00:29:11.000000', 'temperatura', 723.0000, 'ºC'),
	(77144, 109, '2015-03-01 00:29:12.000000', 'temperatura', 971.0000, 'ºC'),
	(77145, 109, '2015-03-01 00:29:13.000000', 'temperatura', 284.0000, 'ºC'),
	(77146, 109, '2015-03-01 00:29:14.000000', 'temperatura', 908.0000, 'ºC'),
	(77147, 109, '2015-03-01 00:29:15.000000', 'temperatura', 89.0000, 'ºC'),
	(77148, 109, '2015-03-01 00:29:16.000000', 'temperatura', 120.0000, 'ºC'),
	(77149, 109, '2015-03-01 00:29:17.000000', 'temperatura', 335.0000, 'ºC'),
	(77150, 109, '2015-03-01 00:29:18.000000', 'temperatura', 117.0000, 'ºC'),
	(77151, 109, '2015-03-01 00:29:19.000000', 'temperatura', 778.0000, 'ºC'),
	(77152, 109, '2015-03-01 00:29:20.000000', 'temperatura', 1139.0000, 'ºC'),
	(77153, 109, '2015-03-01 00:29:21.000000', 'temperatura', 961.0000, 'ºC'),
	(77154, 109, '2015-03-01 00:29:22.000000', 'temperatura', 188.0000, 'ºC'),
	(77155, 109, '2015-03-01 00:29:23.000000', 'temperatura', 459.0000, 'ºC'),
	(77156, 109, '2015-03-01 00:29:24.000000', 'temperatura', 532.0000, 'ºC'),
	(77157, 109, '2015-03-01 00:29:25.000000', 'temperatura', 85.0000, 'ºC'),
	(77158, 109, '2015-03-01 00:29:26.000000', 'temperatura', 28.0000, 'ºC'),
	(77159, 109, '2015-03-01 00:29:27.000000', 'temperatura', 1085.0000, 'ºC'),
	(77160, 109, '2015-03-01 00:29:28.000000', 'temperatura', 544.0000, 'ºC'),
	(77161, 109, '2015-03-01 00:29:29.000000', 'temperatura', 664.0000, 'ºC'),
	(77162, 109, '2015-03-01 00:29:30.000000', 'temperatura', 488.0000, 'ºC'),
	(77163, 109, '2015-03-01 00:29:31.000000', 'temperatura', 451.0000, 'ºC'),
	(77164, 109, '2015-03-01 00:29:32.000000', 'temperatura', 789.0000, 'ºC'),
	(77165, 109, '2015-03-01 00:29:33.000000', 'temperatura', 194.0000, 'ºC'),
	(77166, 109, '2015-03-01 00:29:34.000000', 'temperatura', 1002.0000, 'ºC'),
	(77167, 109, '2015-03-01 00:29:35.000000', 'temperatura', 830.0000, 'ºC'),
	(77168, 109, '2015-03-01 00:29:36.000000', 'temperatura', 1144.0000, 'ºC'),
	(77169, 109, '2015-03-01 00:29:37.000000', 'temperatura', 831.0000, 'ºC'),
	(77170, 109, '2015-03-01 00:29:38.000000', 'temperatura', 724.0000, 'ºC'),
	(77171, 109, '2015-03-01 00:29:39.000000', 'temperatura', 1128.0000, 'ºC'),
	(77172, 109, '2015-03-01 00:29:40.000000', 'temperatura', 1068.0000, 'ºC'),
	(77173, 109, '2015-03-01 00:29:41.000000', 'temperatura', 756.0000, 'ºC'),
	(77174, 109, '2015-03-01 00:29:42.000000', 'temperatura', 577.0000, 'ºC'),
	(77175, 109, '2015-03-01 00:29:43.000000', 'temperatura', 619.0000, 'ºC'),
	(77176, 109, '2015-03-01 00:29:44.000000', 'temperatura', 163.0000, 'ºC'),
	(77177, 109, '2015-03-01 00:29:45.000000', 'temperatura', 158.0000, 'ºC'),
	(77178, 109, '2015-03-01 00:29:46.000000', 'temperatura', 301.0000, 'ºC'),
	(77179, 109, '2015-03-01 00:29:47.000000', 'temperatura', 1030.0000, 'ºC'),
	(77180, 109, '2015-03-01 00:29:48.000000', 'temperatura', 650.0000, 'ºC'),
	(77181, 109, '2015-03-01 00:29:49.000000', 'temperatura', 160.0000, 'ºC'),
	(77182, 109, '2015-03-01 00:29:50.000000', 'temperatura', 50.0000, 'ºC'),
	(77183, 109, '2015-03-01 00:29:51.000000', 'temperatura', 973.0000, 'ºC'),
	(77184, 109, '2015-03-01 00:29:52.000000', 'temperatura', 1113.0000, 'ºC'),
	(77185, 109, '2015-03-01 00:29:53.000000', 'temperatura', 249.0000, 'ºC'),
	(77186, 109, '2015-03-01 00:29:54.000000', 'temperatura', 306.0000, 'ºC'),
	(77187, 109, '2015-03-01 00:29:55.000000', 'temperatura', 783.0000, 'ºC'),
	(77188, 109, '2015-03-01 00:29:56.000000', 'temperatura', 598.0000, 'ºC'),
	(77189, 109, '2015-03-01 00:29:57.000000', 'temperatura', 640.0000, 'ºC'),
	(77190, 109, '2015-03-01 00:29:58.000000', 'temperatura', 209.0000, 'ºC'),
	(77191, 109, '2015-03-01 00:29:59.000000', 'temperatura', 325.0000, 'ºC'),
	(77192, 109, '2015-03-01 00:30:00.000000', 'temperatura', 997.0000, 'ºC'),
	(77193, 109, '2015-03-01 00:30:01.000000', 'temperatura', 412.0000, 'ºC'),
	(77194, 109, '2015-03-01 00:30:02.000000', 'temperatura', 269.0000, 'ºC'),
	(77195, 109, '2015-03-01 00:30:03.000000', 'temperatura', 109.0000, 'ºC'),
	(77196, 109, '2015-03-01 00:30:04.000000', 'temperatura', 940.0000, 'ºC'),
	(77197, 109, '2015-03-01 00:30:05.000000', 'temperatura', 773.0000, 'ºC'),
	(77198, 109, '2015-03-01 00:30:06.000000', 'temperatura', 1046.0000, 'ºC'),
	(77199, 109, '2015-03-01 00:30:07.000000', 'temperatura', 512.0000, 'ºC'),
	(77200, 109, '2015-03-01 00:30:08.000000', 'temperatura', 620.0000, 'ºC'),
	(77201, 109, '2015-03-01 00:30:09.000000', 'temperatura', 365.0000, 'ºC'),
	(77202, 109, '2015-03-01 00:30:10.000000', 'temperatura', 1168.0000, 'ºC'),
	(77203, 109, '2015-03-01 00:30:11.000000', 'temperatura', 1144.0000, 'ºC'),
	(77204, 109, '2015-03-01 00:30:12.000000', 'temperatura', 1018.0000, 'ºC'),
	(77205, 109, '2015-03-01 00:30:13.000000', 'temperatura', 455.0000, 'ºC'),
	(77206, 109, '2015-03-01 00:30:14.000000', 'temperatura', 425.0000, 'ºC'),
	(77207, 109, '2015-03-01 00:30:15.000000', 'temperatura', 760.0000, 'ºC'),
	(77208, 109, '2015-03-01 00:30:16.000000', 'temperatura', 124.0000, 'ºC'),
	(77209, 109, '2015-03-01 00:30:17.000000', 'temperatura', 740.0000, 'ºC'),
	(77210, 109, '2015-03-01 00:30:18.000000', 'temperatura', 929.0000, 'ºC'),
	(77211, 109, '2015-03-01 00:30:19.000000', 'temperatura', 24.0000, 'ºC'),
	(77212, 109, '2015-03-01 00:30:20.000000', 'temperatura', 936.0000, 'ºC'),
	(77213, 109, '2015-03-01 00:30:21.000000', 'temperatura', 1008.0000, 'ºC'),
	(77214, 109, '2015-03-01 00:30:22.000000', 'temperatura', 1031.0000, 'ºC'),
	(77215, 109, '2015-03-01 00:30:23.000000', 'temperatura', 932.0000, 'ºC'),
	(77216, 109, '2015-03-01 00:30:24.000000', 'temperatura', 368.0000, 'ºC'),
	(77217, 109, '2015-03-01 00:30:25.000000', 'temperatura', 243.0000, 'ºC'),
	(77218, 109, '2015-03-01 00:30:26.000000', 'temperatura', 112.0000, 'ºC'),
	(77219, 109, '2015-03-01 00:30:27.000000', 'temperatura', 1031.0000, 'ºC'),
	(77220, 109, '2015-03-01 00:30:28.000000', 'temperatura', 19.0000, 'ºC'),
	(77221, 109, '2015-03-01 00:30:29.000000', 'temperatura', 605.0000, 'ºC'),
	(77222, 109, '2015-03-01 00:30:30.000000', 'temperatura', 568.0000, 'ºC'),
	(77223, 109, '2015-03-01 00:30:31.000000', 'temperatura', 1024.0000, 'ºC'),
	(77224, 109, '2015-03-01 00:30:32.000000', 'temperatura', 1018.0000, 'ºC'),
	(77225, 109, '2015-03-01 00:30:33.000000', 'temperatura', 820.0000, 'ºC'),
	(77226, 109, '2015-03-01 00:30:34.000000', 'temperatura', 1043.0000, 'ºC'),
	(77227, 109, '2015-03-01 00:30:35.000000', 'temperatura', 359.0000, 'ºC'),
	(77228, 109, '2015-03-01 00:30:36.000000', 'temperatura', 1064.0000, 'ºC'),
	(77229, 109, '2015-03-01 00:30:37.000000', 'temperatura', 646.0000, 'ºC'),
	(77230, 109, '2015-03-01 00:30:38.000000', 'temperatura', 38.0000, 'ºC'),
	(77231, 109, '2015-03-01 00:30:39.000000', 'temperatura', 653.0000, 'ºC'),
	(77232, 109, '2015-03-01 00:30:40.000000', 'temperatura', 750.0000, 'ºC'),
	(77233, 109, '2015-03-01 00:30:41.000000', 'temperatura', 591.0000, 'ºC'),
	(77234, 109, '2015-03-01 00:30:42.000000', 'temperatura', 704.0000, 'ºC'),
	(77235, 109, '2015-03-01 00:30:43.000000', 'temperatura', 551.0000, 'ºC'),
	(77236, 109, '2015-03-01 00:30:44.000000', 'temperatura', 642.0000, 'ºC'),
	(77237, 109, '2015-03-01 00:30:45.000000', 'temperatura', 359.0000, 'ºC'),
	(77238, 109, '2015-03-01 00:30:46.000000', 'temperatura', 1068.0000, 'ºC'),
	(77239, 109, '2015-03-01 00:30:47.000000', 'temperatura', 662.0000, 'ºC'),
	(77240, 109, '2015-03-01 00:30:48.000000', 'temperatura', 107.0000, 'ºC'),
	(77241, 109, '2015-03-01 00:30:49.000000', 'temperatura', 952.0000, 'ºC'),
	(77242, 109, '2015-03-01 00:30:50.000000', 'temperatura', 839.0000, 'ºC'),
	(77243, 109, '2015-03-01 00:30:51.000000', 'temperatura', 138.0000, 'ºC'),
	(77244, 109, '2015-03-01 00:30:52.000000', 'temperatura', 572.0000, 'ºC'),
	(77245, 109, '2015-03-01 00:30:53.000000', 'temperatura', 49.0000, 'ºC'),
	(77246, 109, '2015-03-01 00:30:54.000000', 'temperatura', 931.0000, 'ºC'),
	(77247, 109, '2015-03-01 00:30:55.000000', 'temperatura', 906.0000, 'ºC'),
	(77248, 109, '2015-03-01 00:30:56.000000', 'temperatura', 538.0000, 'ºC'),
	(77249, 109, '2015-03-01 00:30:57.000000', 'temperatura', 1171.0000, 'ºC'),
	(77250, 109, '2015-03-01 00:30:58.000000', 'temperatura', 644.0000, 'ºC'),
	(77251, 109, '2015-03-01 00:30:59.000000', 'temperatura', 908.0000, 'ºC'),
	(77252, 109, '2015-03-01 00:31:00.000000', 'temperatura', 208.0000, 'ºC'),
	(77253, 109, '2015-03-01 00:31:01.000000', 'temperatura', 718.0000, 'ºC'),
	(77254, 109, '2015-03-01 00:31:02.000000', 'temperatura', 564.0000, 'ºC'),
	(77255, 109, '2015-03-01 00:31:03.000000', 'temperatura', 666.0000, 'ºC'),
	(77256, 109, '2015-03-01 00:31:04.000000', 'temperatura', 438.0000, 'ºC'),
	(77257, 109, '2015-03-01 00:31:05.000000', 'temperatura', 193.0000, 'ºC'),
	(77258, 109, '2015-03-01 00:31:06.000000', 'temperatura', 850.0000, 'ºC'),
	(77259, 109, '2015-03-01 00:31:07.000000', 'temperatura', 73.0000, 'ºC'),
	(77260, 109, '2015-03-01 00:31:08.000000', 'temperatura', 214.0000, 'ºC'),
	(77261, 109, '2015-03-01 00:31:09.000000', 'temperatura', 854.0000, 'ºC'),
	(77262, 109, '2015-03-01 00:31:10.000000', 'temperatura', 26.0000, 'ºC'),
	(77263, 109, '2015-03-01 00:31:11.000000', 'temperatura', 1169.0000, 'ºC'),
	(77264, 109, '2015-03-01 00:31:12.000000', 'temperatura', 968.0000, 'ºC'),
	(77265, 109, '2015-03-01 00:31:13.000000', 'temperatura', 134.0000, 'ºC'),
	(77266, 109, '2015-03-01 00:31:14.000000', 'temperatura', 168.0000, 'ºC'),
	(77267, 109, '2015-03-01 00:31:15.000000', 'temperatura', 437.0000, 'ºC'),
	(77268, 109, '2015-03-01 00:31:16.000000', 'temperatura', 480.0000, 'ºC'),
	(77269, 109, '2015-03-01 00:31:17.000000', 'temperatura', 1092.0000, 'ºC'),
	(77270, 109, '2015-03-01 00:31:18.000000', 'temperatura', 421.0000, 'ºC'),
	(77271, 109, '2015-03-01 00:31:19.000000', 'temperatura', 30.0000, 'ºC'),
	(77272, 109, '2015-03-01 00:31:20.000000', 'temperatura', 87.0000, 'ºC'),
	(77273, 109, '2015-03-01 00:31:21.000000', 'temperatura', 344.0000, 'ºC'),
	(77274, 109, '2015-03-01 00:31:22.000000', 'temperatura', 261.0000, 'ºC'),
	(77275, 109, '2015-03-01 00:31:23.000000', 'temperatura', 271.0000, 'ºC'),
	(77276, 109, '2015-03-01 00:31:24.000000', 'temperatura', 576.0000, 'ºC'),
	(77277, 109, '2015-03-01 00:31:25.000000', 'temperatura', 865.0000, 'ºC'),
	(77278, 109, '2015-03-01 00:31:26.000000', 'temperatura', 198.0000, 'ºC'),
	(77279, 109, '2015-03-01 00:31:27.000000', 'temperatura', 798.0000, 'ºC'),
	(77280, 109, '2015-03-01 00:31:28.000000', 'temperatura', 993.0000, 'ºC'),
	(77281, 109, '2015-03-01 00:31:29.000000', 'temperatura', 173.0000, 'ºC'),
	(77282, 109, '2015-03-01 00:31:30.000000', 'temperatura', 287.0000, 'ºC'),
	(77283, 109, '2015-03-01 00:31:31.000000', 'temperatura', 916.0000, 'ºC'),
	(77284, 109, '2015-03-01 00:31:32.000000', 'temperatura', 119.0000, 'ºC'),
	(77285, 109, '2015-03-01 00:31:33.000000', 'temperatura', 247.0000, 'ºC'),
	(77286, 109, '2015-03-01 00:31:34.000000', 'temperatura', 880.0000, 'ºC'),
	(77287, 109, '2015-03-01 00:31:35.000000', 'temperatura', 57.0000, 'ºC'),
	(77288, 109, '2015-03-01 00:31:36.000000', 'temperatura', 47.0000, 'ºC'),
	(77289, 109, '2015-03-01 00:31:37.000000', 'temperatura', 64.0000, 'ºC'),
	(77290, 109, '2015-03-01 00:31:38.000000', 'temperatura', 181.0000, 'ºC'),
	(77291, 109, '2015-03-01 00:31:39.000000', 'temperatura', 714.0000, 'ºC'),
	(77292, 109, '2015-03-01 00:31:40.000000', 'temperatura', 625.0000, 'ºC'),
	(77293, 109, '2015-03-01 00:31:41.000000', 'temperatura', 987.0000, 'ºC'),
	(77294, 109, '2015-03-01 00:31:42.000000', 'temperatura', 657.0000, 'ºC'),
	(77295, 109, '2015-03-01 00:31:43.000000', 'temperatura', 324.0000, 'ºC'),
	(77296, 109, '2015-03-01 00:31:44.000000', 'temperatura', 852.0000, 'ºC'),
	(77297, 109, '2015-03-01 00:31:45.000000', 'temperatura', 889.0000, 'ºC'),
	(77298, 109, '2015-03-01 00:31:46.000000', 'temperatura', 688.0000, 'ºC'),
	(77299, 109, '2015-03-01 00:31:47.000000', 'temperatura', 772.0000, 'ºC'),
	(77300, 109, '2015-03-01 00:31:48.000000', 'temperatura', 597.0000, 'ºC'),
	(77301, 109, '2015-03-01 00:31:49.000000', 'temperatura', 670.0000, 'ºC'),
	(77302, 109, '2015-03-01 00:31:50.000000', 'temperatura', 361.0000, 'ºC'),
	(77303, 109, '2015-03-01 00:31:51.000000', 'temperatura', 993.0000, 'ºC'),
	(77304, 109, '2015-03-01 00:31:52.000000', 'temperatura', 284.0000, 'ºC'),
	(77305, 109, '2015-03-01 00:31:53.000000', 'temperatura', 842.0000, 'ºC'),
	(77306, 109, '2015-03-01 00:31:54.000000', 'temperatura', 956.0000, 'ºC'),
	(77307, 109, '2015-03-01 00:31:55.000000', 'temperatura', 1056.0000, 'ºC'),
	(77308, 109, '2015-03-01 00:31:56.000000', 'temperatura', 12.0000, 'ºC'),
	(77309, 109, '2015-03-01 00:31:57.000000', 'temperatura', 493.0000, 'ºC'),
	(77310, 109, '2015-03-01 00:31:58.000000', 'temperatura', 28.0000, 'ºC'),
	(77311, 109, '2015-03-01 00:31:59.000000', 'temperatura', 1061.0000, 'ºC'),
	(77312, 109, '2015-03-01 00:32:00.000000', 'temperatura', 423.0000, 'ºC'),
	(77313, 109, '2015-03-01 00:32:01.000000', 'temperatura', 134.0000, 'ºC'),
	(77314, 109, '2015-03-01 00:32:02.000000', 'temperatura', 602.0000, 'ºC'),
	(77315, 109, '2015-03-01 00:32:03.000000', 'temperatura', 205.0000, 'ºC'),
	(77316, 109, '2015-03-01 00:32:04.000000', 'temperatura', 422.0000, 'ºC'),
	(77317, 109, '2015-03-01 00:32:05.000000', 'temperatura', 293.0000, 'ºC'),
	(77318, 109, '2015-03-01 00:32:06.000000', 'temperatura', 200.0000, 'ºC'),
	(77319, 109, '2015-03-01 00:32:07.000000', 'temperatura', 122.0000, 'ºC'),
	(77320, 109, '2015-03-01 00:32:08.000000', 'temperatura', 9.0000, 'ºC'),
	(77321, 109, '2015-03-01 00:32:09.000000', 'temperatura', 880.0000, 'ºC'),
	(77322, 109, '2015-03-01 00:32:10.000000', 'temperatura', 773.0000, 'ºC'),
	(77323, 109, '2015-03-01 00:32:11.000000', 'temperatura', 28.0000, 'ºC'),
	(77324, 109, '2015-03-01 00:32:12.000000', 'temperatura', 219.0000, 'ºC'),
	(77325, 109, '2015-03-01 00:32:13.000000', 'temperatura', 1011.0000, 'ºC'),
	(77326, 109, '2015-03-01 00:32:14.000000', 'temperatura', 801.0000, 'ºC'),
	(77327, 109, '2015-03-01 00:32:15.000000', 'temperatura', 972.0000, 'ºC'),
	(77328, 109, '2015-03-01 00:32:16.000000', 'temperatura', 56.0000, 'ºC'),
	(77329, 109, '2015-03-01 00:32:17.000000', 'temperatura', 967.0000, 'ºC'),
	(77330, 109, '2015-03-01 00:32:18.000000', 'temperatura', 1067.0000, 'ºC'),
	(77331, 109, '2015-03-01 00:32:19.000000', 'temperatura', 34.0000, 'ºC'),
	(77332, 109, '2015-03-01 00:32:20.000000', 'temperatura', 570.0000, 'ºC'),
	(77333, 109, '2015-03-01 00:32:21.000000', 'temperatura', 350.0000, 'ºC'),
	(77334, 109, '2015-03-01 00:32:22.000000', 'temperatura', 38.0000, 'ºC'),
	(77335, 109, '2015-03-01 00:32:23.000000', 'temperatura', 341.0000, 'ºC'),
	(77336, 109, '2015-03-01 00:32:24.000000', 'temperatura', 391.0000, 'ºC'),
	(77337, 109, '2015-03-01 00:32:25.000000', 'temperatura', 932.0000, 'ºC'),
	(77338, 109, '2015-03-01 00:32:26.000000', 'temperatura', 1090.0000, 'ºC'),
	(77339, 109, '2015-03-01 00:32:27.000000', 'temperatura', 251.0000, 'ºC'),
	(77340, 109, '2015-03-01 00:32:28.000000', 'temperatura', 388.0000, 'ºC'),
	(77341, 109, '2015-03-01 00:32:29.000000', 'temperatura', 1188.0000, 'ºC'),
	(77342, 109, '2015-03-01 00:32:30.000000', 'temperatura', 1174.0000, 'ºC'),
	(77343, 109, '2015-03-01 00:32:31.000000', 'temperatura', 1106.0000, 'ºC'),
	(77344, 109, '2015-03-01 00:32:32.000000', 'temperatura', 811.0000, 'ºC'),
	(77345, 109, '2015-03-01 00:32:33.000000', 'temperatura', 736.0000, 'ºC'),
	(77346, 109, '2015-03-01 00:32:34.000000', 'temperatura', 48.0000, 'ºC'),
	(77347, 109, '2015-03-01 00:32:35.000000', 'temperatura', 432.0000, 'ºC'),
	(77348, 109, '2015-03-01 00:32:36.000000', 'temperatura', 818.0000, 'ºC'),
	(77349, 109, '2015-03-01 00:32:37.000000', 'temperatura', 396.0000, 'ºC'),
	(77350, 109, '2015-03-01 00:32:38.000000', 'temperatura', 723.0000, 'ºC'),
	(77351, 109, '2015-03-01 00:32:39.000000', 'temperatura', 30.0000, 'ºC'),
	(77352, 109, '2015-03-01 00:32:40.000000', 'temperatura', 382.0000, 'ºC'),
	(77353, 109, '2015-03-01 00:32:41.000000', 'temperatura', 618.0000, 'ºC'),
	(77354, 109, '2015-03-01 00:32:42.000000', 'temperatura', 745.0000, 'ºC'),
	(77355, 109, '2015-03-01 00:32:43.000000', 'temperatura', 674.0000, 'ºC'),
	(77356, 109, '2015-03-01 00:32:44.000000', 'temperatura', 1134.0000, 'ºC'),
	(77357, 109, '2015-03-01 00:32:45.000000', 'temperatura', 48.0000, 'ºC'),
	(77358, 109, '2015-03-01 00:32:46.000000', 'temperatura', 440.0000, 'ºC'),
	(77359, 109, '2015-03-01 00:32:47.000000', 'temperatura', 855.0000, 'ºC'),
	(77360, 109, '2015-03-01 00:32:48.000000', 'temperatura', 557.0000, 'ºC'),
	(77361, 109, '2015-03-01 00:32:49.000000', 'temperatura', 220.0000, 'ºC'),
	(77362, 109, '2015-03-01 00:32:50.000000', 'temperatura', 627.0000, 'ºC'),
	(77363, 109, '2015-03-01 00:32:51.000000', 'temperatura', 79.0000, 'ºC'),
	(77364, 109, '2015-03-01 00:32:52.000000', 'temperatura', 912.0000, 'ºC'),
	(77365, 109, '2015-03-01 00:32:53.000000', 'temperatura', 723.0000, 'ºC'),
	(77366, 109, '2015-03-01 00:32:54.000000', 'temperatura', 881.0000, 'ºC'),
	(77367, 109, '2015-03-01 00:32:55.000000', 'temperatura', 1035.0000, 'ºC'),
	(77368, 109, '2015-03-01 00:32:56.000000', 'temperatura', 133.0000, 'ºC'),
	(77369, 109, '2015-03-01 00:32:57.000000', 'temperatura', 1162.0000, 'ºC'),
	(77370, 109, '2015-03-01 00:32:58.000000', 'temperatura', 612.0000, 'ºC'),
	(77371, 109, '2015-03-01 00:32:59.000000', 'temperatura', 772.0000, 'ºC'),
	(77372, 109, '2015-03-01 00:33:00.000000', 'temperatura', 824.0000, 'ºC'),
	(77373, 109, '2015-03-01 00:33:01.000000', 'temperatura', 607.0000, 'ºC'),
	(77374, 109, '2015-03-01 00:33:02.000000', 'temperatura', 564.0000, 'ºC'),
	(77375, 109, '2015-03-01 00:33:03.000000', 'temperatura', 997.0000, 'ºC'),
	(77376, 109, '2015-03-01 00:33:04.000000', 'temperatura', 894.0000, 'ºC'),
	(77377, 109, '2015-03-01 00:33:05.000000', 'temperatura', 282.0000, 'ºC'),
	(77378, 109, '2015-03-01 00:33:06.000000', 'temperatura', 1126.0000, 'ºC'),
	(77379, 109, '2015-03-01 00:33:07.000000', 'temperatura', 1184.0000, 'ºC'),
	(77380, 109, '2015-03-01 00:33:08.000000', 'temperatura', 144.0000, 'ºC'),
	(77381, 109, '2015-03-01 00:33:09.000000', 'temperatura', 767.0000, 'ºC'),
	(77382, 109, '2015-03-01 00:33:10.000000', 'temperatura', 1006.0000, 'ºC'),
	(77383, 109, '2015-03-01 00:33:11.000000', 'temperatura', 329.0000, 'ºC'),
	(77384, 109, '2015-03-01 00:33:12.000000', 'temperatura', 1027.0000, 'ºC'),
	(77385, 109, '2015-03-01 00:33:13.000000', 'temperatura', 549.0000, 'ºC'),
	(77386, 109, '2015-03-01 00:33:14.000000', 'temperatura', 863.0000, 'ºC'),
	(77387, 109, '2015-03-01 00:33:15.000000', 'temperatura', 271.0000, 'ºC'),
	(77388, 109, '2015-03-01 00:33:16.000000', 'temperatura', 1167.0000, 'ºC'),
	(77389, 109, '2015-03-01 00:33:17.000000', 'temperatura', 220.0000, 'ºC'),
	(77390, 109, '2015-03-01 00:33:18.000000', 'temperatura', 1199.0000, 'ºC'),
	(77391, 109, '2015-03-01 00:33:19.000000', 'temperatura', 536.0000, 'ºC'),
	(77392, 109, '2015-03-01 00:33:20.000000', 'temperatura', 284.0000, 'ºC'),
	(77393, 109, '2015-03-01 00:33:21.000000', 'temperatura', 1014.0000, 'ºC'),
	(77394, 109, '2015-03-01 00:33:22.000000', 'temperatura', 618.0000, 'ºC'),
	(77395, 109, '2015-03-01 00:33:23.000000', 'temperatura', 47.0000, 'ºC'),
	(77396, 109, '2015-03-01 00:33:24.000000', 'temperatura', 784.0000, 'ºC'),
	(77397, 109, '2015-03-01 00:33:25.000000', 'temperatura', 178.0000, 'ºC'),
	(77398, 109, '2015-03-01 00:33:26.000000', 'temperatura', 939.0000, 'ºC'),
	(77399, 109, '2015-03-01 00:33:27.000000', 'temperatura', 563.0000, 'ºC'),
	(77400, 109, '2015-03-01 00:33:28.000000', 'temperatura', 1196.0000, 'ºC'),
	(77401, 109, '2015-03-01 00:33:29.000000', 'temperatura', 693.0000, 'ºC'),
	(77402, 109, '2015-03-01 00:33:30.000000', 'temperatura', 1077.0000, 'ºC'),
	(77403, 109, '2015-03-01 00:33:31.000000', 'temperatura', 906.0000, 'ºC'),
	(77404, 109, '2015-03-01 00:33:32.000000', 'temperatura', 101.0000, 'ºC'),
	(77405, 109, '2015-03-01 00:33:33.000000', 'temperatura', 186.0000, 'ºC'),
	(77406, 109, '2015-03-01 00:33:34.000000', 'temperatura', 630.0000, 'ºC'),
	(77407, 109, '2015-03-01 00:33:35.000000', 'temperatura', 189.0000, 'ºC'),
	(77408, 109, '2015-03-01 00:33:36.000000', 'temperatura', 258.0000, 'ºC'),
	(77409, 109, '2015-03-01 00:33:37.000000', 'temperatura', 725.0000, 'ºC'),
	(77410, 109, '2015-03-01 00:33:38.000000', 'temperatura', 449.0000, 'ºC'),
	(77411, 109, '2015-03-01 00:33:39.000000', 'temperatura', 73.0000, 'ºC'),
	(77412, 109, '2015-03-01 00:33:40.000000', 'temperatura', 218.0000, 'ºC'),
	(77413, 109, '2015-03-01 00:33:41.000000', 'temperatura', 873.0000, 'ºC'),
	(77414, 109, '2015-03-01 00:33:42.000000', 'temperatura', 110.0000, 'ºC'),
	(77415, 109, '2015-03-01 00:33:43.000000', 'temperatura', 333.0000, 'ºC'),
	(77416, 109, '2015-03-01 00:33:44.000000', 'temperatura', 134.0000, 'ºC'),
	(77417, 109, '2015-03-01 00:33:45.000000', 'temperatura', 873.0000, 'ºC'),
	(77418, 109, '2015-03-01 00:33:46.000000', 'temperatura', 365.0000, 'ºC'),
	(77419, 109, '2015-03-01 00:33:47.000000', 'temperatura', 404.0000, 'ºC'),
	(77420, 109, '2015-03-01 00:33:48.000000', 'temperatura', 925.0000, 'ºC'),
	(77421, 109, '2015-03-01 00:33:49.000000', 'temperatura', 1013.0000, 'ºC'),
	(77422, 109, '2015-03-01 00:33:50.000000', 'temperatura', 1092.0000, 'ºC'),
	(77423, 109, '2015-03-01 00:33:51.000000', 'temperatura', 22.0000, 'ºC'),
	(77424, 109, '2015-03-01 00:33:52.000000', 'temperatura', 435.0000, 'ºC'),
	(77425, 109, '2015-03-01 00:33:53.000000', 'temperatura', 909.0000, 'ºC'),
	(77426, 109, '2015-03-01 00:33:54.000000', 'temperatura', 840.0000, 'ºC'),
	(77427, 109, '2015-03-01 00:33:55.000000', 'temperatura', 275.0000, 'ºC'),
	(77428, 109, '2015-03-01 00:33:56.000000', 'temperatura', 53.0000, 'ºC'),
	(77429, 109, '2015-03-01 00:33:57.000000', 'temperatura', 643.0000, 'ºC'),
	(77430, 109, '2015-03-01 00:33:58.000000', 'temperatura', 653.0000, 'ºC'),
	(77431, 109, '2015-03-01 00:33:59.000000', 'temperatura', 140.0000, 'ºC'),
	(77432, 109, '2015-03-01 00:34:00.000000', 'temperatura', 1142.0000, 'ºC'),
	(77433, 109, '2015-03-01 00:34:01.000000', 'temperatura', 488.0000, 'ºC'),
	(77434, 109, '2015-03-01 00:34:02.000000', 'temperatura', 215.0000, 'ºC'),
	(77435, 109, '2015-03-01 00:34:03.000000', 'temperatura', 814.0000, 'ºC'),
	(77436, 109, '2015-03-01 00:34:04.000000', 'temperatura', 1023.0000, 'ºC'),
	(77437, 109, '2015-03-01 00:34:05.000000', 'temperatura', 273.0000, 'ºC'),
	(77438, 109, '2015-03-01 00:34:06.000000', 'temperatura', 699.0000, 'ºC'),
	(77439, 109, '2015-03-01 00:34:07.000000', 'temperatura', 274.0000, 'ºC'),
	(77440, 109, '2015-03-01 00:34:08.000000', 'temperatura', 476.0000, 'ºC'),
	(77441, 109, '2015-03-01 00:34:09.000000', 'temperatura', 359.0000, 'ºC'),
	(77442, 109, '2015-03-01 00:34:10.000000', 'temperatura', 367.0000, 'ºC'),
	(77443, 109, '2015-03-01 00:34:11.000000', 'temperatura', 759.0000, 'ºC'),
	(77444, 109, '2015-03-01 00:34:12.000000', 'temperatura', 292.0000, 'ºC'),
	(77445, 109, '2015-03-01 00:34:13.000000', 'temperatura', 385.0000, 'ºC'),
	(77446, 109, '2015-03-01 00:34:14.000000', 'temperatura', 1049.0000, 'ºC'),
	(77447, 109, '2015-03-01 00:34:15.000000', 'temperatura', 491.0000, 'ºC'),
	(77448, 109, '2015-03-01 00:34:16.000000', 'temperatura', 507.0000, 'ºC'),
	(77449, 109, '2015-03-01 00:34:17.000000', 'temperatura', 1062.0000, 'ºC'),
	(77450, 109, '2015-03-01 00:34:18.000000', 'temperatura', 190.0000, 'ºC'),
	(77451, 109, '2015-03-01 00:34:19.000000', 'temperatura', 167.0000, 'ºC'),
	(77452, 109, '2015-03-01 00:34:20.000000', 'temperatura', 262.0000, 'ºC'),
	(77453, 109, '2015-03-01 00:34:21.000000', 'temperatura', 812.0000, 'ºC'),
	(77454, 109, '2015-03-01 00:34:22.000000', 'temperatura', 874.0000, 'ºC'),
	(77455, 109, '2015-03-01 00:34:23.000000', 'temperatura', 733.0000, 'ºC'),
	(77456, 109, '2015-03-01 00:34:24.000000', 'temperatura', 1043.0000, 'ºC'),
	(77457, 109, '2015-03-01 00:34:25.000000', 'temperatura', 616.0000, 'ºC'),
	(77458, 109, '2015-03-01 00:34:26.000000', 'temperatura', 1152.0000, 'ºC'),
	(77459, 109, '2015-03-01 00:34:27.000000', 'temperatura', 312.0000, 'ºC'),
	(77460, 109, '2015-03-01 00:34:28.000000', 'temperatura', 504.0000, 'ºC'),
	(77461, 109, '2015-03-01 00:34:29.000000', 'temperatura', 383.0000, 'ºC'),
	(77462, 109, '2015-03-01 00:34:30.000000', 'temperatura', 407.0000, 'ºC'),
	(77463, 109, '2015-03-01 00:34:31.000000', 'temperatura', 885.0000, 'ºC'),
	(77464, 109, '2015-03-01 00:34:32.000000', 'temperatura', 806.0000, 'ºC'),
	(77465, 109, '2015-03-01 00:34:33.000000', 'temperatura', 176.0000, 'ºC'),
	(77466, 109, '2015-03-01 00:34:34.000000', 'temperatura', 860.0000, 'ºC'),
	(77467, 109, '2015-03-01 00:34:35.000000', 'temperatura', 173.0000, 'ºC'),
	(77468, 109, '2015-03-01 00:34:36.000000', 'temperatura', 686.0000, 'ºC'),
	(77469, 109, '2015-03-01 00:34:37.000000', 'temperatura', 512.0000, 'ºC'),
	(77470, 109, '2015-03-01 00:34:38.000000', 'temperatura', 502.0000, 'ºC'),
	(77471, 109, '2015-03-01 00:34:39.000000', 'temperatura', 976.0000, 'ºC'),
	(77472, 109, '2015-03-01 00:34:40.000000', 'temperatura', 973.0000, 'ºC'),
	(77473, 109, '2015-03-01 00:34:41.000000', 'temperatura', 736.0000, 'ºC'),
	(77474, 109, '2015-03-01 00:34:42.000000', 'temperatura', 765.0000, 'ºC'),
	(77475, 109, '2015-03-01 00:34:43.000000', 'temperatura', 414.0000, 'ºC'),
	(77476, 109, '2015-03-01 00:34:44.000000', 'temperatura', 979.0000, 'ºC'),
	(77477, 109, '2015-03-01 00:34:45.000000', 'temperatura', 51.0000, 'ºC'),
	(77478, 109, '2015-03-01 00:34:46.000000', 'temperatura', 920.0000, 'ºC'),
	(77479, 109, '2015-03-01 00:34:47.000000', 'temperatura', 846.0000, 'ºC'),
	(77480, 109, '2015-03-01 00:34:48.000000', 'temperatura', 271.0000, 'ºC'),
	(77481, 109, '2015-03-01 00:34:49.000000', 'temperatura', 19.0000, 'ºC'),
	(77482, 109, '2015-03-01 00:34:50.000000', 'temperatura', 480.0000, 'ºC'),
	(77483, 109, '2015-03-01 00:34:51.000000', 'temperatura', 1145.0000, 'ºC'),
	(77484, 109, '2015-03-01 00:34:52.000000', 'temperatura', 687.0000, 'ºC'),
	(77485, 109, '2015-03-01 00:34:53.000000', 'temperatura', 1199.0000, 'ºC'),
	(77486, 109, '2015-03-01 00:34:54.000000', 'temperatura', 336.0000, 'ºC'),
	(77487, 109, '2015-03-01 00:34:55.000000', 'temperatura', 483.0000, 'ºC'),
	(77488, 109, '2015-03-01 00:34:56.000000', 'temperatura', 208.0000, 'ºC'),
	(77489, 109, '2015-03-01 00:34:57.000000', 'temperatura', 789.0000, 'ºC'),
	(77490, 109, '2015-03-01 00:34:58.000000', 'temperatura', 923.0000, 'ºC'),
	(77491, 109, '2015-03-01 00:34:59.000000', 'temperatura', 1049.0000, 'ºC'),
	(77492, 109, '2015-03-01 00:35:00.000000', 'temperatura', 78.0000, 'ºC'),
	(77493, 109, '2015-03-01 00:35:01.000000', 'temperatura', 841.0000, 'ºC'),
	(77494, 109, '2015-03-01 00:35:02.000000', 'temperatura', 372.0000, 'ºC'),
	(77495, 109, '2015-03-01 00:35:03.000000', 'temperatura', 540.0000, 'ºC'),
	(77496, 109, '2015-03-01 00:35:04.000000', 'temperatura', 382.0000, 'ºC'),
	(77497, 109, '2015-03-01 00:35:05.000000', 'temperatura', 291.0000, 'ºC'),
	(77498, 109, '2015-03-01 00:35:06.000000', 'temperatura', 309.0000, 'ºC'),
	(77499, 109, '2015-03-01 00:35:07.000000', 'temperatura', 671.0000, 'ºC'),
	(77500, 109, '2015-03-01 00:35:08.000000', 'temperatura', 29.0000, 'ºC'),
	(77501, 109, '2015-03-01 00:35:09.000000', 'temperatura', 534.0000, 'ºC'),
	(77502, 109, '2015-03-01 00:35:10.000000', 'temperatura', 183.0000, 'ºC'),
	(77503, 109, '2015-03-01 00:35:11.000000', 'temperatura', 512.0000, 'ºC'),
	(77504, 109, '2015-03-01 00:35:12.000000', 'temperatura', 812.0000, 'ºC'),
	(77505, 109, '2015-03-01 00:35:13.000000', 'temperatura', 123.0000, 'ºC'),
	(77506, 109, '2015-03-01 00:35:14.000000', 'temperatura', 583.0000, 'ºC'),
	(77507, 109, '2015-03-01 00:35:15.000000', 'temperatura', 144.0000, 'ºC'),
	(77508, 109, '2015-03-01 00:35:16.000000', 'temperatura', 171.0000, 'ºC'),
	(77509, 109, '2015-03-01 00:35:17.000000', 'temperatura', 424.0000, 'ºC'),
	(77510, 109, '2015-03-01 00:35:18.000000', 'temperatura', 406.0000, 'ºC'),
	(77511, 109, '2015-03-01 00:35:19.000000', 'temperatura', 760.0000, 'ºC'),
	(77512, 109, '2015-03-01 00:35:20.000000', 'temperatura', 181.0000, 'ºC'),
	(77513, 109, '2015-03-01 00:35:21.000000', 'temperatura', 1026.0000, 'ºC'),
	(77514, 109, '2015-03-01 00:35:22.000000', 'temperatura', 987.0000, 'ºC'),
	(77515, 109, '2015-03-01 00:35:23.000000', 'temperatura', 658.0000, 'ºC'),
	(77516, 109, '2015-03-01 00:35:24.000000', 'temperatura', 330.0000, 'ºC'),
	(77517, 109, '2015-03-01 00:35:25.000000', 'temperatura', 874.0000, 'ºC'),
	(77518, 109, '2015-03-01 00:35:26.000000', 'temperatura', 983.0000, 'ºC'),
	(77519, 109, '2015-03-01 00:35:27.000000', 'temperatura', 1095.0000, 'ºC'),
	(77520, 109, '2015-03-01 00:35:28.000000', 'temperatura', 124.0000, 'ºC'),
	(77521, 109, '2015-03-01 00:35:29.000000', 'temperatura', 936.0000, 'ºC'),
	(77522, 109, '2015-03-01 00:35:30.000000', 'temperatura', 709.0000, 'ºC'),
	(77523, 109, '2015-03-01 00:35:31.000000', 'temperatura', 737.0000, 'ºC'),
	(77524, 109, '2015-03-01 00:35:32.000000', 'temperatura', 357.0000, 'ºC'),
	(77525, 109, '2015-03-01 00:35:33.000000', 'temperatura', 775.0000, 'ºC'),
	(77526, 109, '2015-03-01 00:35:34.000000', 'temperatura', 404.0000, 'ºC'),
	(77527, 109, '2015-03-01 00:35:35.000000', 'temperatura', 897.0000, 'ºC'),
	(77528, 109, '2015-03-01 00:35:36.000000', 'temperatura', 875.0000, 'ºC'),
	(77529, 109, '2015-03-01 00:35:37.000000', 'temperatura', 481.0000, 'ºC'),
	(77530, 109, '2015-03-01 00:35:38.000000', 'temperatura', 983.0000, 'ºC'),
	(77531, 109, '2015-03-01 00:35:39.000000', 'temperatura', 1072.0000, 'ºC'),
	(77532, 109, '2015-03-01 00:35:40.000000', 'temperatura', 10.0000, 'ºC'),
	(77533, 109, '2015-03-01 00:35:41.000000', 'temperatura', 436.0000, 'ºC'),
	(77534, 109, '2015-03-01 00:35:42.000000', 'temperatura', 951.0000, 'ºC'),
	(77535, 109, '2015-03-01 00:35:43.000000', 'temperatura', 1045.0000, 'ºC'),
	(77536, 109, '2015-03-01 00:35:44.000000', 'temperatura', 1175.0000, 'ºC'),
	(77537, 109, '2015-03-01 00:35:45.000000', 'temperatura', 340.0000, 'ºC'),
	(77538, 109, '2015-03-01 00:35:46.000000', 'temperatura', 577.0000, 'ºC'),
	(77539, 109, '2015-03-01 00:35:47.000000', 'temperatura', 662.0000, 'ºC'),
	(77540, 109, '2015-03-01 00:35:48.000000', 'temperatura', 382.0000, 'ºC'),
	(77541, 109, '2015-03-01 00:35:49.000000', 'temperatura', 1124.0000, 'ºC'),
	(77542, 109, '2015-03-01 00:35:50.000000', 'temperatura', 873.0000, 'ºC'),
	(77543, 109, '2015-03-01 00:35:51.000000', 'temperatura', 993.0000, 'ºC'),
	(77544, 109, '2015-03-01 00:35:52.000000', 'temperatura', 1150.0000, 'ºC'),
	(77545, 109, '2015-03-01 00:35:53.000000', 'temperatura', 368.0000, 'ºC'),
	(77546, 109, '2015-03-01 00:35:54.000000', 'temperatura', 792.0000, 'ºC'),
	(77547, 109, '2015-03-01 00:35:55.000000', 'temperatura', 457.0000, 'ºC'),
	(77548, 109, '2015-03-01 00:35:56.000000', 'temperatura', 1107.0000, 'ºC'),
	(77549, 109, '2015-03-01 00:35:57.000000', 'temperatura', 568.0000, 'ºC'),
	(77550, 109, '2015-03-01 00:35:58.000000', 'temperatura', 718.0000, 'ºC'),
	(77551, 109, '2015-03-01 00:35:59.000000', 'temperatura', 685.0000, 'ºC'),
	(77552, 109, '2015-03-01 00:36:00.000000', 'temperatura', 75.0000, 'ºC'),
	(77553, 109, '2015-03-01 00:36:01.000000', 'temperatura', 717.0000, 'ºC'),
	(77554, 109, '2015-03-01 00:36:02.000000', 'temperatura', 961.0000, 'ºC'),
	(77555, 109, '2015-03-01 00:36:03.000000', 'temperatura', 253.0000, 'ºC'),
	(77556, 109, '2015-03-01 00:36:04.000000', 'temperatura', 786.0000, 'ºC'),
	(77557, 109, '2015-03-01 00:36:05.000000', 'temperatura', 769.0000, 'ºC'),
	(77558, 109, '2015-03-01 00:36:06.000000', 'temperatura', 288.0000, 'ºC'),
	(77559, 109, '2015-03-01 00:36:07.000000', 'temperatura', 332.0000, 'ºC'),
	(77560, 109, '2015-03-01 00:36:08.000000', 'temperatura', 796.0000, 'ºC'),
	(77561, 109, '2015-03-01 00:36:09.000000', 'temperatura', 586.0000, 'ºC'),
	(77562, 109, '2015-03-01 00:36:10.000000', 'temperatura', 544.0000, 'ºC'),
	(77563, 109, '2015-03-01 00:36:11.000000', 'temperatura', 963.0000, 'ºC'),
	(77564, 109, '2015-03-01 00:36:12.000000', 'temperatura', 780.0000, 'ºC'),
	(77565, 109, '2015-03-01 00:36:13.000000', 'temperatura', 1014.0000, 'ºC'),
	(77566, 109, '2015-03-01 00:36:14.000000', 'temperatura', 330.0000, 'ºC'),
	(77567, 109, '2015-03-01 00:36:15.000000', 'temperatura', 1009.0000, 'ºC'),
	(77568, 109, '2015-03-01 00:36:16.000000', 'temperatura', 456.0000, 'ºC'),
	(77569, 109, '2015-03-01 00:36:17.000000', 'temperatura', 454.0000, 'ºC'),
	(77570, 109, '2015-03-01 00:36:18.000000', 'temperatura', 902.0000, 'ºC'),
	(77571, 109, '2015-03-01 00:36:19.000000', 'temperatura', 750.0000, 'ºC'),
	(77572, 109, '2015-03-01 00:36:20.000000', 'temperatura', 1044.0000, 'ºC'),
	(77573, 109, '2015-03-01 00:36:21.000000', 'temperatura', 568.0000, 'ºC'),
	(77574, 109, '2015-03-01 00:36:22.000000', 'temperatura', 912.0000, 'ºC'),
	(77575, 109, '2015-03-01 00:36:23.000000', 'temperatura', 453.0000, 'ºC'),
	(77576, 109, '2015-03-01 00:36:24.000000', 'temperatura', 733.0000, 'ºC'),
	(77577, 109, '2015-03-01 00:36:25.000000', 'temperatura', 1105.0000, 'ºC'),
	(77578, 109, '2015-03-01 00:36:26.000000', 'temperatura', 925.0000, 'ºC'),
	(77579, 109, '2015-03-01 00:36:27.000000', 'temperatura', 113.0000, 'ºC'),
	(77580, 109, '2015-03-01 00:36:28.000000', 'temperatura', 191.0000, 'ºC'),
	(77581, 109, '2015-03-01 00:36:29.000000', 'temperatura', 614.0000, 'ºC'),
	(77582, 109, '2015-03-01 00:36:30.000000', 'temperatura', 98.0000, 'ºC'),
	(77583, 109, '2015-03-01 00:36:31.000000', 'temperatura', 1049.0000, 'ºC'),
	(77584, 109, '2015-03-01 00:36:32.000000', 'temperatura', 151.0000, 'ºC'),
	(77585, 109, '2015-03-01 00:36:33.000000', 'temperatura', 7.0000, 'ºC'),
	(77586, 109, '2015-03-01 00:36:34.000000', 'temperatura', 784.0000, 'ºC'),
	(77587, 109, '2015-03-01 00:36:35.000000', 'temperatura', 299.0000, 'ºC'),
	(77588, 109, '2015-03-01 00:36:36.000000', 'temperatura', 345.0000, 'ºC'),
	(77589, 109, '2015-03-01 00:36:37.000000', 'temperatura', 826.0000, 'ºC'),
	(77590, 109, '2015-03-01 00:36:38.000000', 'temperatura', 698.0000, 'ºC'),
	(77591, 109, '2015-03-01 00:36:39.000000', 'temperatura', 1013.0000, 'ºC'),
	(77592, 109, '2015-03-01 00:36:40.000000', 'temperatura', 572.0000, 'ºC'),
	(77593, 109, '2015-03-01 00:36:41.000000', 'temperatura', 1021.0000, 'ºC'),
	(77594, 109, '2015-03-01 00:36:42.000000', 'temperatura', 988.0000, 'ºC'),
	(77595, 109, '2015-03-01 00:36:43.000000', 'temperatura', 677.0000, 'ºC'),
	(77596, 109, '2015-03-01 00:36:44.000000', 'temperatura', 424.0000, 'ºC'),
	(77597, 109, '2015-03-01 00:36:45.000000', 'temperatura', 87.0000, 'ºC'),
	(77598, 109, '2015-03-01 00:36:46.000000', 'temperatura', 364.0000, 'ºC'),
	(77599, 109, '2015-03-01 00:36:47.000000', 'temperatura', 359.0000, 'ºC'),
	(77600, 109, '2015-03-01 00:36:48.000000', 'temperatura', 703.0000, 'ºC'),
	(77601, 109, '2015-03-01 00:36:49.000000', 'temperatura', 38.0000, 'ºC'),
	(77602, 109, '2015-03-01 00:36:50.000000', 'temperatura', 484.0000, 'ºC'),
	(77603, 109, '2015-03-01 00:36:51.000000', 'temperatura', 1107.0000, 'ºC'),
	(77604, 109, '2015-03-01 00:36:52.000000', 'temperatura', 481.0000, 'ºC'),
	(77605, 109, '2015-03-01 00:36:53.000000', 'temperatura', 284.0000, 'ºC'),
	(77606, 109, '2015-03-01 00:36:54.000000', 'temperatura', 1180.0000, 'ºC'),
	(77607, 109, '2015-03-01 00:36:55.000000', 'temperatura', 249.0000, 'ºC'),
	(77608, 109, '2015-03-01 00:36:56.000000', 'temperatura', 103.0000, 'ºC'),
	(77609, 109, '2015-03-01 00:36:57.000000', 'temperatura', 971.0000, 'ºC'),
	(77610, 109, '2015-03-01 00:36:58.000000', 'temperatura', 947.0000, 'ºC'),
	(77611, 109, '2015-03-01 00:36:59.000000', 'temperatura', 622.0000, 'ºC'),
	(77612, 109, '2015-03-01 00:37:00.000000', 'temperatura', 270.0000, 'ºC'),
	(77613, 109, '2015-03-01 00:37:01.000000', 'temperatura', 686.0000, 'ºC'),
	(77614, 109, '2015-03-01 00:37:02.000000', 'temperatura', 218.0000, 'ºC'),
	(77615, 109, '2015-03-01 00:37:03.000000', 'temperatura', 234.0000, 'ºC'),
	(77616, 109, '2015-03-01 00:37:04.000000', 'temperatura', 515.0000, 'ºC'),
	(77617, 109, '2015-03-01 00:37:05.000000', 'temperatura', 674.0000, 'ºC'),
	(77618, 109, '2015-03-01 00:37:06.000000', 'temperatura', 625.0000, 'ºC'),
	(77619, 109, '2015-03-01 00:37:07.000000', 'temperatura', 1106.0000, 'ºC'),
	(77620, 109, '2015-03-01 00:37:08.000000', 'temperatura', 52.0000, 'ºC'),
	(77621, 109, '2015-03-01 00:37:09.000000', 'temperatura', 544.0000, 'ºC'),
	(77622, 109, '2015-03-01 00:37:10.000000', 'temperatura', 164.0000, 'ºC'),
	(77623, 109, '2015-03-01 00:37:11.000000', 'temperatura', 389.0000, 'ºC'),
	(77624, 109, '2015-03-01 00:37:12.000000', 'temperatura', 253.0000, 'ºC'),
	(77625, 109, '2015-03-01 00:37:13.000000', 'temperatura', 98.0000, 'ºC'),
	(77626, 109, '2015-03-01 00:37:14.000000', 'temperatura', 931.0000, 'ºC'),
	(77627, 109, '2015-03-01 00:37:15.000000', 'temperatura', 761.0000, 'ºC'),
	(77628, 109, '2015-03-01 00:37:16.000000', 'temperatura', 1013.0000, 'ºC'),
	(77629, 109, '2015-03-01 00:37:17.000000', 'temperatura', 384.0000, 'ºC'),
	(77630, 109, '2015-03-01 00:37:18.000000', 'temperatura', 82.0000, 'ºC'),
	(77631, 109, '2015-03-01 00:37:19.000000', 'temperatura', 458.0000, 'ºC'),
	(77632, 109, '2015-03-01 00:37:20.000000', 'temperatura', 844.0000, 'ºC'),
	(77633, 109, '2015-03-01 00:37:21.000000', 'temperatura', 449.0000, 'ºC'),
	(77634, 109, '2015-03-01 00:37:22.000000', 'temperatura', 910.0000, 'ºC'),
	(77635, 109, '2015-03-01 00:37:23.000000', 'temperatura', 807.0000, 'ºC'),
	(77636, 109, '2015-03-01 00:37:24.000000', 'temperatura', 102.0000, 'ºC'),
	(77637, 109, '2015-03-01 00:37:25.000000', 'temperatura', 491.0000, 'ºC'),
	(77638, 109, '2015-03-01 00:37:26.000000', 'temperatura', 952.0000, 'ºC'),
	(77639, 109, '2015-03-01 00:37:27.000000', 'temperatura', 884.0000, 'ºC'),
	(77640, 109, '2015-03-01 00:37:28.000000', 'temperatura', 364.0000, 'ºC'),
	(77641, 109, '2015-03-01 00:37:29.000000', 'temperatura', 370.0000, 'ºC'),
	(77642, 109, '2015-03-01 00:37:30.000000', 'temperatura', 757.0000, 'ºC'),
	(77643, 109, '2015-03-01 00:37:31.000000', 'temperatura', 278.0000, 'ºC'),
	(77644, 109, '2015-03-01 00:37:32.000000', 'temperatura', 317.0000, 'ºC'),
	(77645, 109, '2015-03-01 00:37:33.000000', 'temperatura', 753.0000, 'ºC'),
	(77646, 109, '2015-03-01 00:37:34.000000', 'temperatura', 416.0000, 'ºC'),
	(77647, 109, '2015-03-01 00:37:35.000000', 'temperatura', 1020.0000, 'ºC'),
	(77648, 109, '2015-03-01 00:37:36.000000', 'temperatura', 253.0000, 'ºC'),
	(77649, 109, '2015-03-01 00:37:37.000000', 'temperatura', 604.0000, 'ºC'),
	(77650, 109, '2015-03-01 00:37:38.000000', 'temperatura', 1061.0000, 'ºC'),
	(77651, 109, '2015-03-01 00:37:39.000000', 'temperatura', 1092.0000, 'ºC'),
	(77652, 109, '2015-03-01 00:37:40.000000', 'temperatura', 1081.0000, 'ºC'),
	(77653, 109, '2015-03-01 00:37:41.000000', 'temperatura', 929.0000, 'ºC'),
	(77654, 109, '2015-03-01 00:37:42.000000', 'temperatura', 203.0000, 'ºC'),
	(77655, 109, '2015-03-01 00:37:43.000000', 'temperatura', 629.0000, 'ºC'),
	(77656, 109, '2015-03-01 00:37:44.000000', 'temperatura', 135.0000, 'ºC'),
	(77657, 109, '2015-03-01 00:37:45.000000', 'temperatura', 1187.0000, 'ºC'),
	(77658, 109, '2015-03-01 00:37:46.000000', 'temperatura', 733.0000, 'ºC'),
	(77659, 109, '2015-03-01 00:37:47.000000', 'temperatura', 102.0000, 'ºC'),
	(77660, 109, '2015-03-01 00:37:48.000000', 'temperatura', 713.0000, 'ºC'),
	(77661, 109, '2015-03-01 00:37:49.000000', 'temperatura', 859.0000, 'ºC'),
	(77662, 109, '2015-03-01 00:37:50.000000', 'temperatura', 958.0000, 'ºC'),
	(77663, 109, '2015-03-01 00:37:51.000000', 'temperatura', 1012.0000, 'ºC'),
	(77664, 109, '2015-03-01 00:37:52.000000', 'temperatura', 989.0000, 'ºC'),
	(77665, 109, '2015-03-01 00:37:53.000000', 'temperatura', 708.0000, 'ºC'),
	(77666, 109, '2015-03-01 00:37:54.000000', 'temperatura', 572.0000, 'ºC'),
	(77667, 109, '2015-03-01 00:37:55.000000', 'temperatura', 739.0000, 'ºC'),
	(77668, 109, '2015-03-01 00:37:56.000000', 'temperatura', 780.0000, 'ºC'),
	(77669, 109, '2015-03-01 00:37:57.000000', 'temperatura', 481.0000, 'ºC'),
	(77670, 109, '2015-03-01 00:37:58.000000', 'temperatura', 66.0000, 'ºC'),
	(77671, 109, '2015-03-01 00:37:59.000000', 'temperatura', 86.0000, 'ºC'),
	(77672, 109, '2015-03-01 00:38:00.000000', 'temperatura', 235.0000, 'ºC'),
	(77673, 109, '2015-03-01 00:38:01.000000', 'temperatura', 916.0000, 'ºC'),
	(77674, 109, '2015-03-01 00:38:02.000000', 'temperatura', 275.0000, 'ºC'),
	(77675, 109, '2015-03-01 00:38:03.000000', 'temperatura', 1028.0000, 'ºC'),
	(77676, 109, '2015-03-01 00:38:04.000000', 'temperatura', 715.0000, 'ºC'),
	(77677, 109, '2015-03-01 00:38:05.000000', 'temperatura', 493.0000, 'ºC'),
	(77678, 109, '2015-03-01 00:38:06.000000', 'temperatura', 319.0000, 'ºC'),
	(77679, 109, '2015-03-01 00:38:07.000000', 'temperatura', 119.0000, 'ºC'),
	(77680, 109, '2015-03-01 00:38:08.000000', 'temperatura', 838.0000, 'ºC'),
	(77681, 109, '2015-03-01 00:38:09.000000', 'temperatura', 232.0000, 'ºC'),
	(77682, 109, '2015-03-01 00:38:10.000000', 'temperatura', 1046.0000, 'ºC'),
	(77683, 109, '2015-03-01 00:38:11.000000', 'temperatura', 936.0000, 'ºC'),
	(77684, 109, '2015-03-01 00:38:12.000000', 'temperatura', 340.0000, 'ºC'),
	(77685, 109, '2015-03-01 00:38:13.000000', 'temperatura', 94.0000, 'ºC'),
	(77686, 109, '2015-03-01 00:38:14.000000', 'temperatura', 650.0000, 'ºC'),
	(77687, 109, '2015-03-01 00:38:15.000000', 'temperatura', 571.0000, 'ºC'),
	(77688, 109, '2015-03-01 00:38:16.000000', 'temperatura', 902.0000, 'ºC'),
	(77689, 109, '2015-03-01 00:38:17.000000', 'temperatura', 398.0000, 'ºC'),
	(77690, 109, '2015-03-01 00:38:18.000000', 'temperatura', 487.0000, 'ºC'),
	(77691, 109, '2015-03-01 00:38:19.000000', 'temperatura', 40.0000, 'ºC'),
	(77692, 109, '2015-03-01 00:38:20.000000', 'temperatura', 1141.0000, 'ºC'),
	(77693, 109, '2015-03-01 00:38:21.000000', 'temperatura', 784.0000, 'ºC'),
	(77694, 109, '2015-03-01 00:38:22.000000', 'temperatura', 496.0000, 'ºC'),
	(77695, 109, '2015-03-01 00:38:23.000000', 'temperatura', 129.0000, 'ºC'),
	(77696, 109, '2015-03-01 00:38:24.000000', 'temperatura', 357.0000, 'ºC'),
	(77697, 109, '2015-03-01 00:38:25.000000', 'temperatura', 200.0000, 'ºC'),
	(77698, 109, '2015-03-01 00:38:26.000000', 'temperatura', 1128.0000, 'ºC'),
	(77699, 109, '2015-03-01 00:38:27.000000', 'temperatura', 242.0000, 'ºC'),
	(77700, 109, '2015-03-01 00:38:28.000000', 'temperatura', 227.0000, 'ºC'),
	(77701, 109, '2015-03-01 00:38:29.000000', 'temperatura', 410.0000, 'ºC'),
	(77702, 109, '2015-03-01 00:38:30.000000', 'temperatura', 171.0000, 'ºC'),
	(77703, 109, '2015-03-01 00:38:31.000000', 'temperatura', 822.0000, 'ºC'),
	(77704, 109, '2015-03-01 00:38:32.000000', 'temperatura', 1199.0000, 'ºC'),
	(77705, 109, '2015-03-01 00:38:33.000000', 'temperatura', 1129.0000, 'ºC'),
	(77706, 109, '2015-03-01 00:38:34.000000', 'temperatura', 849.0000, 'ºC'),
	(77707, 109, '2015-03-01 00:38:35.000000', 'temperatura', 859.0000, 'ºC'),
	(77708, 109, '2015-03-01 00:38:36.000000', 'temperatura', 549.0000, 'ºC'),
	(77709, 109, '2015-03-01 00:38:37.000000', 'temperatura', 166.0000, 'ºC'),
	(77710, 109, '2015-03-01 00:38:38.000000', 'temperatura', 385.0000, 'ºC'),
	(77711, 109, '2015-03-01 00:38:39.000000', 'temperatura', 226.0000, 'ºC'),
	(77712, 109, '2015-03-01 00:38:40.000000', 'temperatura', 1176.0000, 'ºC'),
	(77713, 109, '2015-03-01 00:38:41.000000', 'temperatura', 402.0000, 'ºC'),
	(77714, 109, '2015-03-01 00:38:42.000000', 'temperatura', 884.0000, 'ºC'),
	(77715, 109, '2015-03-01 00:38:43.000000', 'temperatura', 814.0000, 'ºC'),
	(77716, 109, '2015-03-01 00:38:44.000000', 'temperatura', 220.0000, 'ºC'),
	(77717, 109, '2015-03-01 00:38:45.000000', 'temperatura', 1058.0000, 'ºC'),
	(77718, 109, '2015-03-01 00:38:46.000000', 'temperatura', 1031.0000, 'ºC'),
	(77719, 109, '2015-03-01 00:38:47.000000', 'temperatura', 782.0000, 'ºC'),
	(77720, 109, '2015-03-01 00:38:48.000000', 'temperatura', 816.0000, 'ºC'),
	(77721, 109, '2015-03-01 00:38:49.000000', 'temperatura', 537.0000, 'ºC'),
	(77722, 109, '2015-03-01 00:38:50.000000', 'temperatura', 237.0000, 'ºC'),
	(77723, 109, '2015-03-01 00:38:51.000000', 'temperatura', 772.0000, 'ºC'),
	(77724, 109, '2015-03-01 00:38:52.000000', 'temperatura', 751.0000, 'ºC'),
	(77725, 109, '2015-03-01 00:38:53.000000', 'temperatura', 239.0000, 'ºC'),
	(77726, 109, '2015-03-01 00:38:54.000000', 'temperatura', 141.0000, 'ºC'),
	(77727, 109, '2015-03-01 00:38:55.000000', 'temperatura', 1189.0000, 'ºC'),
	(77728, 109, '2015-03-01 00:38:56.000000', 'temperatura', 723.0000, 'ºC'),
	(77729, 109, '2015-03-01 00:38:57.000000', 'temperatura', 49.0000, 'ºC'),
	(77730, 109, '2015-03-01 00:38:58.000000', 'temperatura', 476.0000, 'ºC'),
	(77731, 109, '2015-03-01 00:38:59.000000', 'temperatura', 1035.0000, 'ºC'),
	(77732, 109, '2015-03-01 00:39:00.000000', 'temperatura', 148.0000, 'ºC'),
	(77733, 109, '2015-03-01 00:39:01.000000', 'temperatura', 35.0000, 'ºC'),
	(77734, 109, '2015-03-01 00:39:02.000000', 'temperatura', 931.0000, 'ºC'),
	(77735, 109, '2015-03-01 00:39:03.000000', 'temperatura', 953.0000, 'ºC'),
	(77736, 109, '2015-03-01 00:39:04.000000', 'temperatura', 770.0000, 'ºC'),
	(77737, 109, '2015-03-01 00:39:05.000000', 'temperatura', 990.0000, 'ºC'),
	(77738, 109, '2015-03-01 00:39:06.000000', 'temperatura', 242.0000, 'ºC'),
	(77739, 109, '2015-03-01 00:39:07.000000', 'temperatura', 640.0000, 'ºC'),
	(77740, 109, '2015-03-01 00:39:08.000000', 'temperatura', 76.0000, 'ºC'),
	(77741, 109, '2015-03-01 00:39:09.000000', 'temperatura', 861.0000, 'ºC'),
	(77742, 109, '2015-03-01 00:39:10.000000', 'temperatura', 478.0000, 'ºC'),
	(77743, 109, '2015-03-01 00:39:11.000000', 'temperatura', 1007.0000, 'ºC'),
	(77744, 109, '2015-03-01 00:39:12.000000', 'temperatura', 0.0000, 'ºC'),
	(77745, 109, '2015-03-01 00:39:13.000000', 'temperatura', 581.0000, 'ºC'),
	(77746, 109, '2015-03-01 00:39:14.000000', 'temperatura', 503.0000, 'ºC'),
	(77747, 109, '2015-03-01 00:39:15.000000', 'temperatura', 774.0000, 'ºC'),
	(77748, 109, '2015-03-01 00:39:16.000000', 'temperatura', 1163.0000, 'ºC'),
	(77749, 109, '2015-03-01 00:39:17.000000', 'temperatura', 1093.0000, 'ºC'),
	(77750, 109, '2015-03-01 00:39:18.000000', 'temperatura', 777.0000, 'ºC'),
	(77751, 109, '2015-03-01 00:39:19.000000', 'temperatura', 605.0000, 'ºC'),
	(77752, 109, '2015-03-01 00:39:20.000000', 'temperatura', 693.0000, 'ºC'),
	(77753, 109, '2015-03-01 00:39:21.000000', 'temperatura', 452.0000, 'ºC'),
	(77754, 109, '2015-03-01 00:39:22.000000', 'temperatura', 181.0000, 'ºC'),
	(77755, 109, '2015-03-01 00:39:23.000000', 'temperatura', 750.0000, 'ºC'),
	(77756, 109, '2015-03-01 00:39:24.000000', 'temperatura', 809.0000, 'ºC'),
	(77757, 109, '2015-03-01 00:39:25.000000', 'temperatura', 595.0000, 'ºC'),
	(77758, 109, '2015-03-01 00:39:26.000000', 'temperatura', 549.0000, 'ºC'),
	(77759, 109, '2015-03-01 00:39:27.000000', 'temperatura', 960.0000, 'ºC'),
	(77760, 109, '2015-03-01 00:39:28.000000', 'temperatura', 753.0000, 'ºC'),
	(77761, 109, '2015-03-01 00:39:29.000000', 'temperatura', 888.0000, 'ºC'),
	(77762, 109, '2015-03-01 00:39:30.000000', 'temperatura', 979.0000, 'ºC'),
	(77763, 109, '2015-03-01 00:39:31.000000', 'temperatura', 1031.0000, 'ºC'),
	(77764, 109, '2015-03-01 00:39:32.000000', 'temperatura', 1021.0000, 'ºC'),
	(77765, 109, '2015-03-01 00:39:33.000000', 'temperatura', 812.0000, 'ºC'),
	(77766, 109, '2015-03-01 00:39:34.000000', 'temperatura', 995.0000, 'ºC'),
	(77767, 109, '2015-03-01 00:39:35.000000', 'temperatura', 143.0000, 'ºC'),
	(77768, 109, '2015-03-01 00:39:36.000000', 'temperatura', 127.0000, 'ºC'),
	(77769, 109, '2015-03-01 00:39:37.000000', 'temperatura', 209.0000, 'ºC'),
	(77770, 109, '2015-03-01 00:39:38.000000', 'temperatura', 663.0000, 'ºC'),
	(77771, 109, '2015-03-01 00:39:39.000000', 'temperatura', 290.0000, 'ºC'),
	(77772, 109, '2015-03-01 00:39:40.000000', 'temperatura', 659.0000, 'ºC'),
	(77773, 109, '2015-03-01 00:39:41.000000', 'temperatura', 28.0000, 'ºC'),
	(77774, 109, '2015-03-01 00:39:42.000000', 'temperatura', 564.0000, 'ºC'),
	(77775, 109, '2015-03-01 00:39:43.000000', 'temperatura', 336.0000, 'ºC'),
	(77776, 109, '2015-03-01 00:39:44.000000', 'temperatura', 1189.0000, 'ºC'),
	(77777, 109, '2015-03-01 00:39:45.000000', 'temperatura', 138.0000, 'ºC'),
	(77778, 109, '2015-03-01 00:39:46.000000', 'temperatura', 723.0000, 'ºC'),
	(77779, 109, '2015-03-01 00:39:47.000000', 'temperatura', 800.0000, 'ºC'),
	(77780, 109, '2015-03-01 00:39:48.000000', 'temperatura', 631.0000, 'ºC'),
	(77781, 109, '2015-03-01 00:39:49.000000', 'temperatura', 756.0000, 'ºC'),
	(77782, 109, '2015-03-01 00:39:50.000000', 'temperatura', 687.0000, 'ºC'),
	(77783, 109, '2015-03-01 00:39:51.000000', 'temperatura', 1166.0000, 'ºC'),
	(77784, 109, '2015-03-01 00:39:52.000000', 'temperatura', 171.0000, 'ºC'),
	(77785, 109, '2015-03-01 00:39:53.000000', 'temperatura', 958.0000, 'ºC'),
	(77786, 109, '2015-03-01 00:39:54.000000', 'temperatura', 677.0000, 'ºC'),
	(77787, 109, '2015-03-01 00:39:55.000000', 'temperatura', 514.0000, 'ºC'),
	(77788, 109, '2015-03-01 00:39:56.000000', 'temperatura', 536.0000, 'ºC'),
	(77789, 109, '2015-03-01 00:39:57.000000', 'temperatura', 1142.0000, 'ºC'),
	(77790, 109, '2015-03-01 00:39:58.000000', 'temperatura', 500.0000, 'ºC'),
	(77791, 109, '2015-03-01 00:39:59.000000', 'temperatura', 275.0000, 'ºC'),
	(77792, 109, '2015-03-01 00:40:00.000000', 'temperatura', 1077.0000, 'ºC'),
	(77793, 109, '2015-03-01 00:40:01.000000', 'temperatura', 961.0000, 'ºC'),
	(77794, 109, '2015-03-01 00:40:02.000000', 'temperatura', 372.0000, 'ºC'),
	(77795, 109, '2015-03-01 00:40:03.000000', 'temperatura', 180.0000, 'ºC'),
	(77796, 109, '2015-03-01 00:40:04.000000', 'temperatura', 985.0000, 'ºC'),
	(77797, 109, '2015-03-01 00:40:05.000000', 'temperatura', 782.0000, 'ºC'),
	(77798, 109, '2015-03-01 00:40:06.000000', 'temperatura', 959.0000, 'ºC'),
	(77799, 109, '2015-03-01 00:40:07.000000', 'temperatura', 47.0000, 'ºC'),
	(77800, 109, '2015-03-01 00:40:08.000000', 'temperatura', 958.0000, 'ºC'),
	(77801, 109, '2015-03-01 00:40:09.000000', 'temperatura', 1052.0000, 'ºC'),
	(77802, 109, '2015-03-01 00:40:10.000000', 'temperatura', 1187.0000, 'ºC'),
	(77803, 109, '2015-03-01 00:40:11.000000', 'temperatura', 376.0000, 'ºC'),
	(77804, 109, '2015-03-01 00:40:12.000000', 'temperatura', 723.0000, 'ºC'),
	(77805, 109, '2015-03-01 00:40:13.000000', 'temperatura', 86.0000, 'ºC'),
	(77806, 109, '2015-03-01 00:40:14.000000', 'temperatura', 663.0000, 'ºC'),
	(77807, 109, '2015-03-01 00:40:15.000000', 'temperatura', 656.0000, 'ºC'),
	(77808, 109, '2015-03-01 00:40:16.000000', 'temperatura', 91.0000, 'ºC'),
	(77809, 109, '2015-03-01 00:40:17.000000', 'temperatura', 886.0000, 'ºC'),
	(77810, 109, '2015-03-01 00:40:18.000000', 'temperatura', 559.0000, 'ºC'),
	(77811, 109, '2015-03-01 00:40:19.000000', 'temperatura', 139.0000, 'ºC'),
	(77812, 109, '2015-03-01 00:40:20.000000', 'temperatura', 218.0000, 'ºC'),
	(77813, 109, '2015-03-01 00:40:21.000000', 'temperatura', 671.0000, 'ºC'),
	(77814, 109, '2015-03-01 00:40:22.000000', 'temperatura', 303.0000, 'ºC'),
	(77815, 109, '2015-03-01 00:40:23.000000', 'temperatura', 703.0000, 'ºC'),
	(77816, 109, '2015-03-01 00:40:24.000000', 'temperatura', 208.0000, 'ºC'),
	(77817, 109, '2015-03-01 00:40:25.000000', 'temperatura', 131.0000, 'ºC'),
	(77818, 109, '2015-03-01 00:40:26.000000', 'temperatura', 31.0000, 'ºC'),
	(77819, 109, '2015-03-01 00:40:27.000000', 'temperatura', 962.0000, 'ºC'),
	(77820, 109, '2015-03-01 00:40:28.000000', 'temperatura', 1116.0000, 'ºC'),
	(77821, 109, '2015-03-01 00:40:29.000000', 'temperatura', 295.0000, 'ºC'),
	(77822, 109, '2015-03-01 00:40:30.000000', 'temperatura', 530.0000, 'ºC'),
	(77823, 109, '2015-03-01 00:40:31.000000', 'temperatura', 564.0000, 'ºC'),
	(77824, 109, '2015-03-01 00:40:32.000000', 'temperatura', 31.0000, 'ºC'),
	(77825, 109, '2015-03-01 00:40:33.000000', 'temperatura', 863.0000, 'ºC'),
	(77826, 109, '2015-03-01 00:40:34.000000', 'temperatura', 624.0000, 'ºC'),
	(77827, 109, '2015-03-01 00:40:35.000000', 'temperatura', 531.0000, 'ºC'),
	(77828, 109, '2015-03-01 00:40:36.000000', 'temperatura', 783.0000, 'ºC'),
	(77829, 109, '2015-03-01 00:40:37.000000', 'temperatura', 1124.0000, 'ºC'),
	(77830, 109, '2015-03-01 00:40:38.000000', 'temperatura', 872.0000, 'ºC'),
	(77831, 109, '2015-03-01 00:40:39.000000', 'temperatura', 987.0000, 'ºC'),
	(77832, 109, '2015-03-01 00:40:40.000000', 'temperatura', 1119.0000, 'ºC'),
	(77833, 109, '2015-03-01 00:40:41.000000', 'temperatura', 235.0000, 'ºC'),
	(77834, 109, '2015-03-01 00:40:42.000000', 'temperatura', 217.0000, 'ºC'),
	(77835, 109, '2015-03-01 00:40:43.000000', 'temperatura', 381.0000, 'ºC'),
	(77836, 109, '2015-03-01 00:40:44.000000', 'temperatura', 56.0000, 'ºC'),
	(77837, 109, '2015-03-01 00:40:45.000000', 'temperatura', 337.0000, 'ºC'),
	(77838, 109, '2015-03-01 00:40:46.000000', 'temperatura', 316.0000, 'ºC'),
	(77839, 109, '2015-03-01 00:40:47.000000', 'temperatura', 570.0000, 'ºC'),
	(77840, 109, '2015-03-01 00:40:48.000000', 'temperatura', 702.0000, 'ºC'),
	(77841, 109, '2015-03-01 00:40:49.000000', 'temperatura', 602.0000, 'ºC'),
	(77842, 109, '2015-03-01 00:40:50.000000', 'temperatura', 906.0000, 'ºC'),
	(77843, 109, '2015-03-01 00:40:51.000000', 'temperatura', 322.0000, 'ºC'),
	(77844, 109, '2015-03-01 00:40:52.000000', 'temperatura', 93.0000, 'ºC'),
	(77845, 109, '2015-03-01 00:40:53.000000', 'temperatura', 699.0000, 'ºC'),
	(77846, 109, '2015-03-01 00:40:54.000000', 'temperatura', 819.0000, 'ºC'),
	(77847, 109, '2015-03-01 00:40:55.000000', 'temperatura', 797.0000, 'ºC'),
	(77848, 109, '2015-03-01 00:40:56.000000', 'temperatura', 327.0000, 'ºC'),
	(77849, 109, '2015-03-01 00:40:57.000000', 'temperatura', 444.0000, 'ºC'),
	(77850, 109, '2015-03-01 00:40:58.000000', 'temperatura', 42.0000, 'ºC'),
	(77851, 109, '2015-03-01 00:40:59.000000', 'temperatura', 76.0000, 'ºC'),
	(77852, 109, '2015-03-01 00:41:00.000000', 'temperatura', 255.0000, 'ºC'),
	(77853, 109, '2015-03-01 00:41:01.000000', 'temperatura', 1050.0000, 'ºC'),
	(77854, 109, '2015-03-01 00:41:02.000000', 'temperatura', 882.0000, 'ºC'),
	(77855, 109, '2015-03-01 00:41:03.000000', 'temperatura', 63.0000, 'ºC'),
	(77856, 109, '2015-03-01 00:41:04.000000', 'temperatura', 67.0000, 'ºC'),
	(77857, 109, '2015-03-01 00:41:05.000000', 'temperatura', 147.0000, 'ºC'),
	(77858, 109, '2015-03-01 00:41:06.000000', 'temperatura', 535.0000, 'ºC'),
	(77859, 109, '2015-03-01 00:41:07.000000', 'temperatura', 1036.0000, 'ºC'),
	(77860, 109, '2015-03-01 00:41:08.000000', 'temperatura', 1175.0000, 'ºC'),
	(77861, 109, '2015-03-01 00:41:09.000000', 'temperatura', 366.0000, 'ºC'),
	(77862, 109, '2015-03-01 00:41:10.000000', 'temperatura', 707.0000, 'ºC'),
	(77863, 109, '2015-03-01 00:41:11.000000', 'temperatura', 37.0000, 'ºC'),
	(77864, 109, '2015-03-01 00:41:12.000000', 'temperatura', 465.0000, 'ºC'),
	(77865, 109, '2015-03-01 00:41:13.000000', 'temperatura', 1016.0000, 'ºC'),
	(77866, 109, '2015-03-01 00:41:14.000000', 'temperatura', 84.0000, 'ºC'),
	(77867, 109, '2015-03-01 00:41:15.000000', 'temperatura', 974.0000, 'ºC'),
	(77868, 109, '2015-03-01 00:41:16.000000', 'temperatura', 1017.0000, 'ºC'),
	(77869, 109, '2015-03-01 00:41:17.000000', 'temperatura', 962.0000, 'ºC'),
	(77870, 109, '2015-03-01 00:41:18.000000', 'temperatura', 561.0000, 'ºC'),
	(77871, 109, '2015-03-01 00:41:19.000000', 'temperatura', 1119.0000, 'ºC'),
	(77872, 109, '2015-03-01 00:41:20.000000', 'temperatura', 314.0000, 'ºC'),
	(77873, 109, '2015-03-01 00:41:21.000000', 'temperatura', 612.0000, 'ºC'),
	(77874, 109, '2015-03-01 00:41:22.000000', 'temperatura', 917.0000, 'ºC'),
	(77875, 109, '2015-03-01 00:41:23.000000', 'temperatura', 351.0000, 'ºC'),
	(77876, 109, '2015-03-01 00:41:24.000000', 'temperatura', 204.0000, 'ºC'),
	(77877, 109, '2015-03-01 00:41:25.000000', 'temperatura', 1166.0000, 'ºC'),
	(77878, 109, '2015-03-01 00:41:26.000000', 'temperatura', 420.0000, 'ºC'),
	(77879, 109, '2015-03-01 00:41:27.000000', 'temperatura', 1001.0000, 'ºC'),
	(77880, 109, '2015-03-01 00:41:28.000000', 'temperatura', 147.0000, 'ºC'),
	(77881, 109, '2015-03-01 00:41:29.000000', 'temperatura', 131.0000, 'ºC'),
	(77882, 109, '2015-03-01 00:41:30.000000', 'temperatura', 214.0000, 'ºC'),
	(77883, 109, '2015-03-01 00:41:31.000000', 'temperatura', 678.0000, 'ºC'),
	(77884, 109, '2015-03-01 00:41:32.000000', 'temperatura', 348.0000, 'ºC'),
	(77885, 109, '2015-03-01 00:41:33.000000', 'temperatura', 906.0000, 'ºC'),
	(77886, 109, '2015-03-01 00:41:34.000000', 'temperatura', 1087.0000, 'ºC'),
	(77887, 109, '2015-03-01 00:41:35.000000', 'temperatura', 318.0000, 'ºC'),
	(77888, 109, '2015-03-01 00:41:36.000000', 'temperatura', 728.0000, 'ºC'),
	(77889, 109, '2015-03-01 00:41:37.000000', 'temperatura', 287.0000, 'ºC'),
	(77890, 109, '2015-03-01 00:41:38.000000', 'temperatura', 452.0000, 'ºC'),
	(77891, 109, '2015-03-01 00:41:39.000000', 'temperatura', 198.0000, 'ºC'),
	(77892, 109, '2015-03-01 00:41:40.000000', 'temperatura', 834.0000, 'ºC'),
	(77893, 109, '2015-03-01 00:41:41.000000', 'temperatura', 1176.0000, 'ºC'),
	(77894, 109, '2015-03-01 00:41:42.000000', 'temperatura', 979.0000, 'ºC'),
	(77895, 109, '2015-03-01 00:41:43.000000', 'temperatura', 166.0000, 'ºC'),
	(77896, 109, '2015-03-01 00:41:44.000000', 'temperatura', 294.0000, 'ºC'),
	(77897, 109, '2015-03-01 00:41:45.000000', 'temperatura', 972.0000, 'ºC'),
	(77898, 109, '2015-03-01 00:41:46.000000', 'temperatura', 381.0000, 'ºC'),
	(77899, 109, '2015-03-01 00:41:47.000000', 'temperatura', 189.0000, 'ºC'),
	(77900, 109, '2015-03-01 00:41:48.000000', 'temperatura', 1003.0000, 'ºC'),
	(77901, 109, '2015-03-01 00:41:49.000000', 'temperatura', 848.0000, 'ºC'),
	(77902, 109, '2015-03-01 00:41:50.000000', 'temperatura', 31.0000, 'ºC'),
	(77903, 109, '2015-03-01 00:41:51.000000', 'temperatura', 11.0000, 'ºC'),
	(77904, 109, '2015-03-01 00:41:52.000000', 'temperatura', 1163.0000, 'ºC'),
	(77905, 109, '2015-03-01 00:41:53.000000', 'temperatura', 983.0000, 'ºC'),
	(77906, 109, '2015-03-01 00:41:54.000000', 'temperatura', 226.0000, 'ºC'),
	(77907, 109, '2015-03-01 00:41:55.000000', 'temperatura', 581.0000, 'ºC'),
	(77908, 109, '2015-03-01 00:41:56.000000', 'temperatura', 1028.0000, 'ºC'),
	(77909, 109, '2015-03-01 00:41:57.000000', 'temperatura', 997.0000, 'ºC'),
	(77910, 109, '2015-03-01 00:41:58.000000', 'temperatura', 701.0000, 'ºC'),
	(77911, 109, '2015-03-01 00:41:59.000000', 'temperatura', 515.0000, 'ºC'),
	(77912, 109, '2015-03-01 00:42:00.000000', 'temperatura', 471.0000, 'ºC'),
	(77913, 109, '2015-03-01 00:42:01.000000', 'temperatura', 812.0000, 'ºC'),
	(77914, 109, '2015-03-01 00:42:02.000000', 'temperatura', 246.0000, 'ºC'),
	(77915, 109, '2015-03-01 00:42:03.000000', 'temperatura', 1194.0000, 'ºC'),
	(77916, 109, '2015-03-01 00:42:04.000000', 'temperatura', 433.0000, 'ºC'),
	(77917, 109, '2015-03-01 00:42:05.000000', 'temperatura', 984.0000, 'ºC'),
	(77918, 109, '2015-03-01 00:42:06.000000', 'temperatura', 21.0000, 'ºC'),
	(77919, 109, '2015-03-01 00:42:07.000000', 'temperatura', 754.0000, 'ºC'),
	(77920, 109, '2015-03-01 00:42:08.000000', 'temperatura', 108.0000, 'ºC'),
	(77921, 109, '2015-03-01 00:42:09.000000', 'temperatura', 677.0000, 'ºC'),
	(77922, 109, '2015-03-01 00:42:10.000000', 'temperatura', 660.0000, 'ºC'),
	(77923, 109, '2015-03-01 00:42:11.000000', 'temperatura', 73.0000, 'ºC'),
	(77924, 109, '2015-03-01 00:42:12.000000', 'temperatura', 783.0000, 'ºC'),
	(77925, 109, '2015-03-01 00:42:13.000000', 'temperatura', 97.0000, 'ºC'),
	(77926, 109, '2015-03-01 00:42:14.000000', 'temperatura', 536.0000, 'ºC'),
	(77927, 109, '2015-03-01 00:42:15.000000', 'temperatura', 1189.0000, 'ºC'),
	(77928, 109, '2015-03-01 00:42:16.000000', 'temperatura', 736.0000, 'ºC'),
	(77929, 109, '2015-03-01 00:42:17.000000', 'temperatura', 116.0000, 'ºC'),
	(77930, 109, '2015-03-01 00:42:18.000000', 'temperatura', 772.0000, 'ºC'),
	(77931, 109, '2015-03-01 00:42:19.000000', 'temperatura', 1114.0000, 'ºC'),
	(77932, 109, '2015-03-01 00:42:20.000000', 'temperatura', 852.0000, 'ºC'),
	(77933, 109, '2015-03-01 00:42:21.000000', 'temperatura', 921.0000, 'ºC'),
	(77934, 109, '2015-03-01 00:42:22.000000', 'temperatura', 849.0000, 'ºC'),
	(77935, 109, '2015-03-01 00:42:23.000000', 'temperatura', 282.0000, 'ºC'),
	(77936, 109, '2015-03-01 00:42:24.000000', 'temperatura', 64.0000, 'ºC'),
	(77937, 109, '2015-03-01 00:42:25.000000', 'temperatura', 673.0000, 'ºC'),
	(77938, 109, '2015-03-01 00:42:26.000000', 'temperatura', 776.0000, 'ºC'),
	(77939, 109, '2015-03-01 00:42:27.000000', 'temperatura', 662.0000, 'ºC'),
	(77940, 109, '2015-03-01 00:42:28.000000', 'temperatura', 982.0000, 'ºC'),
	(77941, 109, '2015-03-01 00:42:29.000000', 'temperatura', 526.0000, 'ºC'),
	(77942, 109, '2015-03-01 00:42:30.000000', 'temperatura', 881.0000, 'ºC'),
	(77943, 109, '2015-03-01 00:42:31.000000', 'temperatura', 429.0000, 'ºC'),
	(77944, 109, '2015-03-01 00:42:32.000000', 'temperatura', 704.0000, 'ºC'),
	(77945, 109, '2015-03-01 00:42:33.000000', 'temperatura', 1034.0000, 'ºC'),
	(77946, 109, '2015-03-01 00:42:34.000000', 'temperatura', 656.0000, 'ºC'),
	(77947, 109, '2015-03-01 00:42:35.000000', 'temperatura', 181.0000, 'ºC'),
	(77948, 109, '2015-03-01 00:42:36.000000', 'temperatura', 135.0000, 'ºC'),
	(77949, 109, '2015-03-01 00:42:37.000000', 'temperatura', 134.0000, 'ºC'),
	(77950, 109, '2015-03-01 00:42:38.000000', 'temperatura', 265.0000, 'ºC'),
	(77951, 109, '2015-03-01 00:42:39.000000', 'temperatura', 924.0000, 'ºC'),
	(77952, 109, '2015-03-01 00:42:40.000000', 'temperatura', 224.0000, 'ºC'),
	(77953, 109, '2015-03-01 00:42:41.000000', 'temperatura', 749.0000, 'ºC'),
	(77954, 109, '2015-03-01 00:42:42.000000', 'temperatura', 675.0000, 'ºC'),
	(77955, 109, '2015-03-01 00:42:43.000000', 'temperatura', 1128.0000, 'ºC'),
	(77956, 109, '2015-03-01 00:42:44.000000', 'temperatura', 15.0000, 'ºC'),
	(77957, 109, '2015-03-01 00:42:45.000000', 'temperatura', 293.0000, 'ºC'),
	(77958, 109, '2015-03-01 00:42:46.000000', 'temperatura', 218.0000, 'ºC'),
	(77959, 109, '2015-03-01 00:42:47.000000', 'temperatura', 213.0000, 'ºC'),
	(77960, 109, '2015-03-01 00:42:48.000000', 'temperatura', 411.0000, 'ºC'),
	(77961, 109, '2015-03-01 00:42:49.000000', 'temperatura', 218.0000, 'ºC'),
	(77962, 109, '2015-03-01 00:42:50.000000', 'temperatura', 1058.0000, 'ºC'),
	(77963, 109, '2015-03-01 00:42:51.000000', 'temperatura', 1035.0000, 'ºC'),
	(77964, 109, '2015-03-01 00:42:52.000000', 'temperatura', 801.0000, 'ºC'),
	(77965, 109, '2015-03-01 00:42:53.000000', 'temperatura', 903.0000, 'ºC'),
	(77966, 109, '2015-03-01 00:42:54.000000', 'temperatura', 910.0000, 'ºC'),
	(77967, 109, '2015-03-01 00:42:55.000000', 'temperatura', 643.0000, 'ºC'),
	(77968, 109, '2015-03-01 00:42:56.000000', 'temperatura', 484.0000, 'ºC'),
	(77969, 109, '2015-03-01 00:42:57.000000', 'temperatura', 493.0000, 'ºC'),
	(77970, 109, '2015-03-01 00:42:58.000000', 'temperatura', 1013.0000, 'ºC'),
	(77971, 109, '2015-03-01 00:42:59.000000', 'temperatura', 1187.0000, 'ºC'),
	(77972, 109, '2015-03-01 00:43:00.000000', 'temperatura', 496.0000, 'ºC'),
	(77973, 109, '2015-03-01 00:43:01.000000', 'temperatura', 119.0000, 'ºC'),
	(77974, 109, '2015-03-01 00:43:02.000000', 'temperatura', 307.0000, 'ºC'),
	(77975, 109, '2015-03-01 00:43:03.000000', 'temperatura', 1181.0000, 'ºC'),
	(77976, 109, '2015-03-01 00:43:04.000000', 'temperatura', 184.0000, 'ºC'),
	(77977, 109, '2015-03-01 00:43:05.000000', 'temperatura', 975.0000, 'ºC'),
	(77978, 109, '2015-03-01 00:43:06.000000', 'temperatura', 725.0000, 'ºC'),
	(77979, 109, '2015-03-01 00:43:07.000000', 'temperatura', 702.0000, 'ºC'),
	(77980, 109, '2015-03-01 00:43:08.000000', 'temperatura', 136.0000, 'ºC'),
	(77981, 109, '2015-03-01 00:43:09.000000', 'temperatura', 972.0000, 'ºC'),
	(77982, 109, '2015-03-01 00:43:10.000000', 'temperatura', 853.0000, 'ºC'),
	(77983, 109, '2015-03-01 00:43:11.000000', 'temperatura', 150.0000, 'ºC'),
	(77984, 109, '2015-03-01 00:43:12.000000', 'temperatura', 591.0000, 'ºC'),
	(77985, 109, '2015-03-01 00:43:13.000000', 'temperatura', 107.0000, 'ºC'),
	(77986, 109, '2015-03-01 00:43:14.000000', 'temperatura', 1162.0000, 'ºC'),
	(77987, 109, '2015-03-01 00:43:15.000000', 'temperatura', 689.0000, 'ºC'),
	(77988, 109, '2015-03-01 00:43:16.000000', 'temperatura', 1160.0000, 'ºC'),
	(77989, 109, '2015-03-01 00:43:17.000000', 'temperatura', 134.0000, 'ºC'),
	(77990, 109, '2015-03-01 00:43:18.000000', 'temperatura', 791.0000, 'ºC'),
	(77991, 109, '2015-03-01 00:43:19.000000', 'temperatura', 1151.0000, 'ºC'),
	(77992, 109, '2015-03-01 00:43:20.000000', 'temperatura', 984.0000, 'ºC'),
	(77993, 109, '2015-03-01 00:43:21.000000', 'temperatura', 269.0000, 'ºC'),
	(77994, 109, '2015-03-01 00:43:22.000000', 'temperatura', 794.0000, 'ºC'),
	(77995, 109, '2015-03-01 00:43:23.000000', 'temperatura', 762.0000, 'ºC'),
	(77996, 109, '2015-03-01 00:43:24.000000', 'temperatura', 228.0000, 'ºC'),
	(77997, 109, '2015-03-01 00:43:25.000000', 'temperatura', 56.0000, 'ºC'),
	(77998, 109, '2015-03-01 00:43:26.000000', 'temperatura', 795.0000, 'ºC'),
	(77999, 109, '2015-03-01 00:43:27.000000', 'temperatura', 208.0000, 'ºC'),
	(78000, 109, '2015-03-01 00:43:28.000000', 'temperatura', 1057.0000, 'ºC'),
	(78001, 109, '2015-03-01 00:43:29.000000', 'temperatura', 1060.0000, 'ºC'),
	(78002, 109, '2015-03-01 00:43:30.000000', 'temperatura', 930.0000, 'ºC'),
	(78003, 109, '2015-03-01 00:43:31.000000', 'temperatura', 272.0000, 'ºC'),
	(78004, 109, '2015-03-01 00:43:32.000000', 'temperatura', 967.0000, 'ºC'),
	(78005, 109, '2015-03-01 00:43:33.000000', 'temperatura', 423.0000, 'ºC'),
	(78006, 109, '2015-03-01 00:43:34.000000', 'temperatura', 414.0000, 'ºC'),
	(78007, 109, '2015-03-01 00:43:35.000000', 'temperatura', 801.0000, 'ºC'),
	(78008, 109, '2015-03-01 00:43:36.000000', 'temperatura', 363.0000, 'ºC'),
	(78009, 109, '2015-03-01 00:43:37.000000', 'temperatura', 615.0000, 'ºC'),
	(78010, 109, '2015-03-01 00:43:38.000000', 'temperatura', 784.0000, 'ºC'),
	(78011, 109, '2015-03-01 00:43:39.000000', 'temperatura', 878.0000, 'ºC'),
	(78012, 109, '2015-03-01 00:43:40.000000', 'temperatura', 838.0000, 'ºC'),
	(78013, 109, '2015-03-01 00:43:41.000000', 'temperatura', 354.0000, 'ºC'),
	(78014, 109, '2015-03-01 00:43:42.000000', 'temperatura', 460.0000, 'ºC'),
	(78015, 109, '2015-03-01 00:43:43.000000', 'temperatura', 36.0000, 'ºC'),
	(78016, 109, '2015-03-01 00:43:44.000000', 'temperatura', 1199.0000, 'ºC'),
	(78017, 109, '2015-03-01 00:43:45.000000', 'temperatura', 1090.0000, 'ºC'),
	(78018, 109, '2015-03-01 00:43:46.000000', 'temperatura', 652.0000, 'ºC'),
	(78019, 109, '2015-03-01 00:43:47.000000', 'temperatura', 1189.0000, 'ºC'),
	(78020, 109, '2015-03-01 00:43:48.000000', 'temperatura', 391.0000, 'ºC'),
	(78021, 109, '2015-03-01 00:43:49.000000', 'temperatura', 789.0000, 'ºC'),
	(78022, 109, '2015-03-01 00:43:50.000000', 'temperatura', 373.0000, 'ºC'),
	(78023, 109, '2015-03-01 00:43:51.000000', 'temperatura', 699.0000, 'ºC'),
	(78024, 109, '2015-03-01 00:43:52.000000', 'temperatura', 1176.0000, 'ºC'),
	(78025, 109, '2015-03-01 00:43:53.000000', 'temperatura', 184.0000, 'ºC'),
	(78026, 109, '2015-03-01 00:43:54.000000', 'temperatura', 994.0000, 'ºC'),
	(78027, 109, '2015-03-01 00:43:55.000000', 'temperatura', 816.0000, 'ºC'),
	(78028, 109, '2015-03-01 00:43:56.000000', 'temperatura', 1098.0000, 'ºC'),
	(78029, 109, '2015-03-01 00:43:57.000000', 'temperatura', 643.0000, 'ºC'),
	(78030, 109, '2015-03-01 00:43:58.000000', 'temperatura', 1123.0000, 'ºC'),
	(78031, 109, '2015-03-01 00:43:59.000000', 'temperatura', 84.0000, 'ºC'),
	(78032, 109, '2015-03-01 00:44:00.000000', 'temperatura', 653.0000, 'ºC'),
	(78033, 109, '2015-03-01 00:44:01.000000', 'temperatura', 614.0000, 'ºC'),
	(78034, 109, '2015-03-01 00:44:02.000000', 'temperatura', 1113.0000, 'ºC'),
	(78035, 109, '2015-03-01 00:44:03.000000', 'temperatura', 121.0000, 'ºC'),
	(78036, 109, '2015-03-01 00:44:04.000000', 'temperatura', 866.0000, 'ºC'),
	(78037, 109, '2015-03-01 00:44:05.000000', 'temperatura', 368.0000, 'ºC'),
	(78038, 109, '2015-03-01 00:44:06.000000', 'temperatura', 443.0000, 'ºC'),
	(78039, 109, '2015-03-01 00:44:07.000000', 'temperatura', 1112.0000, 'ºC'),
	(78040, 109, '2015-03-01 00:44:08.000000', 'temperatura', 629.0000, 'ºC'),
	(78041, 109, '2015-03-01 00:44:09.000000', 'temperatura', 1012.0000, 'ºC'),
	(78042, 109, '2015-03-01 00:44:10.000000', 'temperatura', 773.0000, 'ºC'),
	(78043, 109, '2015-03-01 00:44:11.000000', 'temperatura', 829.0000, 'ºC'),
	(78044, 109, '2015-03-01 00:44:12.000000', 'temperatura', 626.0000, 'ºC'),
	(78045, 109, '2015-03-01 00:44:13.000000', 'temperatura', 644.0000, 'ºC'),
	(78046, 109, '2015-03-01 00:44:14.000000', 'temperatura', 144.0000, 'ºC'),
	(78047, 109, '2015-03-01 00:44:15.000000', 'temperatura', 1189.0000, 'ºC'),
	(78048, 109, '2015-03-01 00:44:16.000000', 'temperatura', 711.0000, 'ºC'),
	(78049, 109, '2015-03-01 00:44:17.000000', 'temperatura', 1188.0000, 'ºC'),
	(78050, 109, '2015-03-01 00:44:18.000000', 'temperatura', 207.0000, 'ºC'),
	(78051, 109, '2015-03-01 00:44:19.000000', 'temperatura', 1071.0000, 'ºC'),
	(78052, 109, '2015-03-01 00:44:20.000000', 'temperatura', 1138.0000, 'ºC'),
	(78053, 109, '2015-03-01 00:44:21.000000', 'temperatura', 74.0000, 'ºC'),
	(78054, 109, '2015-03-01 00:44:22.000000', 'temperatura', 556.0000, 'ºC'),
	(78055, 109, '2015-03-01 00:44:23.000000', 'temperatura', 162.0000, 'ºC'),
	(78056, 109, '2015-03-01 00:44:24.000000', 'temperatura', 340.0000, 'ºC'),
	(78057, 109, '2015-03-01 00:44:25.000000', 'temperatura', 15.0000, 'ºC'),
	(78058, 109, '2015-03-01 00:44:26.000000', 'temperatura', 258.0000, 'ºC'),
	(78059, 109, '2015-03-01 00:44:27.000000', 'temperatura', 42.0000, 'ºC'),
	(78060, 109, '2015-03-01 00:44:28.000000', 'temperatura', 638.0000, 'ºC'),
	(78061, 109, '2015-03-01 00:44:29.000000', 'temperatura', 665.0000, 'ºC'),
	(78062, 109, '2015-03-01 00:44:30.000000', 'temperatura', 211.0000, 'ºC'),
	(78063, 109, '2015-03-01 00:44:31.000000', 'temperatura', 262.0000, 'ºC'),
	(78064, 109, '2015-03-01 00:44:32.000000', 'temperatura', 677.0000, 'ºC'),
	(78065, 109, '2015-03-01 00:44:33.000000', 'temperatura', 199.0000, 'ºC'),
	(78066, 109, '2015-03-01 00:44:34.000000', 'temperatura', 165.0000, 'ºC'),
	(78067, 109, '2015-03-01 00:44:35.000000', 'temperatura', 230.0000, 'ºC'),
	(78068, 109, '2015-03-01 00:44:36.000000', 'temperatura', 655.0000, 'ºC'),
	(78069, 109, '2015-03-01 00:44:37.000000', 'temperatura', 185.0000, 'ºC'),
	(78070, 109, '2015-03-01 00:44:38.000000', 'temperatura', 159.0000, 'ºC'),
	(78071, 109, '2015-03-01 00:44:39.000000', 'temperatura', 244.0000, 'ºC'),
	(78072, 109, '2015-03-01 00:44:40.000000', 'temperatura', 740.0000, 'ºC'),
	(78073, 109, '2015-03-01 00:44:41.000000', 'temperatura', 571.0000, 'ºC'),
	(78074, 109, '2015-03-01 00:44:42.000000', 'temperatura', 635.0000, 'ºC'),
	(78075, 109, '2015-03-01 00:44:43.000000', 'temperatura', 262.0000, 'ºC'),
	(78076, 109, '2015-03-01 00:44:44.000000', 'temperatura', 604.0000, 'ºC'),
	(78077, 109, '2015-03-01 00:44:45.000000', 'temperatura', 1034.0000, 'ºC'),
	(78078, 109, '2015-03-01 00:44:46.000000', 'temperatura', 959.0000, 'ºC'),
	(78079, 109, '2015-03-01 00:44:47.000000', 'temperatura', 493.0000, 'ºC'),
	(78080, 109, '2015-03-01 00:44:48.000000', 'temperatura', 788.0000, 'ºC'),
	(78081, 109, '2015-03-01 00:44:49.000000', 'temperatura', 62.0000, 'ºC'),
	(78082, 109, '2015-03-01 00:44:50.000000', 'temperatura', 346.0000, 'ºC'),
	(78083, 109, '2015-03-01 00:44:51.000000', 'temperatura', 346.0000, 'ºC'),
	(78084, 109, '2015-03-01 00:44:52.000000', 'temperatura', 690.0000, 'ºC'),
	(78085, 109, '2015-03-01 00:44:53.000000', 'temperatura', 14.0000, 'ºC'),
	(78086, 109, '2015-03-01 00:44:54.000000', 'temperatura', 400.0000, 'ºC'),
	(78087, 109, '2015-03-01 00:44:55.000000', 'temperatura', 759.0000, 'ºC'),
	(78088, 109, '2015-03-01 00:44:56.000000', 'temperatura', 196.0000, 'ºC'),
	(78089, 109, '2015-03-01 00:44:57.000000', 'temperatura', 1105.0000, 'ºC'),
	(78090, 109, '2015-03-01 00:44:58.000000', 'temperatura', 135.0000, 'ºC'),
	(78091, 109, '2015-03-01 00:44:59.000000', 'temperatura', 962.0000, 'ºC'),
	(78092, 109, '2015-03-01 00:45:00.000000', 'temperatura', 807.0000, 'ºC'),
	(78093, 109, '2015-03-01 00:45:01.000000', 'temperatura', 1148.0000, 'ºC'),
	(78094, 109, '2015-03-01 00:45:02.000000', 'temperatura', 919.0000, 'ºC'),
	(78095, 109, '2015-03-01 00:45:03.000000', 'temperatura', 1153.0000, 'ºC'),
	(78096, 109, '2015-03-01 00:45:04.000000', 'temperatura', 606.0000, 'ºC'),
	(78097, 109, '2015-03-01 00:45:05.000000', 'temperatura', 774.0000, 'ºC'),
	(78098, 109, '2015-03-01 00:45:06.000000', 'temperatura', 853.0000, 'ºC'),
	(78099, 109, '2015-03-01 00:45:07.000000', 'temperatura', 741.0000, 'ºC'),
	(78100, 109, '2015-03-01 00:45:08.000000', 'temperatura', 1146.0000, 'ºC'),
	(78101, 109, '2015-03-01 00:45:09.000000', 'temperatura', 1110.0000, 'ºC'),
	(78102, 109, '2015-03-01 00:45:10.000000', 'temperatura', 911.0000, 'ºC'),
	(78103, 109, '2015-03-01 00:45:11.000000', 'temperatura', 27.0000, 'ºC'),
	(78104, 109, '2015-03-01 00:45:12.000000', 'temperatura', 1004.0000, 'ºC'),
	(78105, 109, '2015-03-01 00:45:13.000000', 'temperatura', 136.0000, 'ºC'),
	(78106, 109, '2015-03-01 00:45:14.000000', 'temperatura', 71.0000, 'ºC'),
	(78107, 109, '2015-03-01 00:45:15.000000', 'temperatura', 1146.0000, 'ºC'),
	(78108, 109, '2015-03-01 00:45:16.000000', 'temperatura', 716.0000, 'ºC'),
	(78109, 109, '2015-03-01 00:45:17.000000', 'temperatura', 144.0000, 'ºC'),
	(78110, 109, '2015-03-01 00:45:18.000000', 'temperatura', 974.0000, 'ºC'),
	(78111, 109, '2015-03-01 00:45:19.000000', 'temperatura', 837.0000, 'ºC'),
	(78112, 109, '2015-03-01 00:45:20.000000', 'temperatura', 63.0000, 'ºC'),
	(78113, 109, '2015-03-01 00:45:21.000000', 'temperatura', 205.0000, 'ºC'),
	(78114, 109, '2015-03-01 00:45:22.000000', 'temperatura', 835.0000, 'ºC'),
	(78115, 109, '2015-03-01 00:45:23.000000', 'temperatura', 1160.0000, 'ºC'),
	(78116, 109, '2015-03-01 00:45:24.000000', 'temperatura', 895.0000, 'ºC'),
	(78117, 109, '2015-03-01 00:45:25.000000', 'temperatura', 998.0000, 'ºC'),
	(78118, 109, '2015-03-01 00:45:26.000000', 'temperatura', 1105.0000, 'ºC'),
	(78119, 109, '2015-03-01 00:45:27.000000', 'temperatura', 133.0000, 'ºC'),
	(78120, 109, '2015-03-01 00:45:28.000000', 'temperatura', 950.0000, 'ºC'),
	(78121, 109, '2015-03-01 00:45:29.000000', 'temperatura', 751.0000, 'ºC'),
	(78122, 109, '2015-03-01 00:45:30.000000', 'temperatura', 906.0000, 'ºC'),
	(78123, 109, '2015-03-01 00:45:31.000000', 'temperatura', 1079.0000, 'ºC'),
	(78124, 109, '2015-03-01 00:45:32.000000', 'temperatura', 275.0000, 'ºC'),
	(78125, 109, '2015-03-01 00:45:33.000000', 'temperatura', 540.0000, 'ºC'),
	(78126, 109, '2015-03-01 00:45:34.000000', 'temperatura', 675.0000, 'ºC'),
	(78127, 109, '2015-03-01 00:45:35.000000', 'temperatura', 556.0000, 'ºC'),
	(78128, 109, '2015-03-01 00:45:36.000000', 'temperatura', 755.0000, 'ºC'),
	(78129, 109, '2015-03-01 00:45:37.000000', 'temperatura', 908.0000, 'ºC'),
	(78130, 109, '2015-03-01 00:45:38.000000', 'temperatura', 1077.0000, 'ºC'),
	(78131, 109, '2015-03-01 00:45:39.000000', 'temperatura', 259.0000, 'ºC'),
	(78132, 109, '2015-03-01 00:45:40.000000', 'temperatura', 467.0000, 'ºC'),
	(78133, 109, '2015-03-01 00:45:41.000000', 'temperatura', 358.0000, 'ºC'),
	(78134, 109, '2015-03-01 00:45:42.000000', 'temperatura', 389.0000, 'ºC'),
	(78135, 109, '2015-03-01 00:45:43.000000', 'temperatura', 871.0000, 'ºC'),
	(78136, 109, '2015-03-01 00:45:44.000000', 'temperatura', 789.0000, 'ºC'),
	(78137, 109, '2015-03-01 00:45:45.000000', 'temperatura', 133.0000, 'ºC'),
	(78138, 109, '2015-03-01 00:45:46.000000', 'temperatura', 700.0000, 'ºC'),
	(78139, 109, '2015-03-01 00:45:47.000000', 'temperatura', 701.0000, 'ºC'),
	(78140, 109, '2015-03-01 00:45:48.000000', 'temperatura', 205.0000, 'ºC'),
	(78141, 109, '2015-03-01 00:45:49.000000', 'temperatura', 121.0000, 'ºC'),
	(78142, 109, '2015-03-01 00:45:50.000000', 'temperatura', 1190.0000, 'ºC'),
	(78143, 109, '2015-03-01 00:45:51.000000', 'temperatura', 790.0000, 'ºC'),
	(78144, 109, '2015-03-01 00:45:52.000000', 'temperatura', 381.0000, 'ºC'),
	(78145, 109, '2015-03-01 00:45:53.000000', 'temperatura', 735.0000, 'ºC'),
	(78146, 109, '2015-03-01 00:45:54.000000', 'temperatura', 132.0000, 'ºC'),
	(78147, 109, '2015-03-01 00:45:55.000000', 'temperatura', 854.0000, 'ºC'),
	(78148, 109, '2015-03-01 00:45:56.000000', 'temperatura', 274.0000, 'ºC'),
	(78149, 109, '2015-03-01 00:45:57.000000', 'temperatura', 10.0000, 'ºC'),
	(78150, 109, '2015-03-01 00:45:58.000000', 'temperatura', 430.0000, 'ºC'),
	(78151, 109, '2015-03-01 00:45:59.000000', 'temperatura', 920.0000, 'ºC'),
	(78152, 109, '2015-03-01 00:46:00.000000', 'temperatura', 910.0000, 'ºC'),
	(78153, 109, '2015-03-01 00:46:01.000000', 'temperatura', 590.0000, 'ºC'),
	(78154, 109, '2015-03-01 00:46:02.000000', 'temperatura', 222.0000, 'ºC'),
	(78155, 109, '2015-03-01 00:46:03.000000', 'temperatura', 541.0000, 'ºC'),
	(78156, 109, '2015-03-01 00:46:04.000000', 'temperatura', 837.0000, 'ºC'),
	(78157, 109, '2015-03-01 00:46:05.000000', 'temperatura', 164.0000, 'ºC'),
	(78158, 109, '2015-03-01 00:46:06.000000', 'temperatura', 707.0000, 'ºC'),
	(78159, 109, '2015-03-01 00:46:07.000000', 'temperatura', 646.0000, 'ºC'),
	(78160, 109, '2015-03-01 00:46:08.000000', 'temperatura', 1107.0000, 'ºC'),
	(78161, 109, '2015-03-01 00:46:09.000000', 'temperatura', 1199.0000, 'ºC'),
	(78162, 109, '2015-03-01 00:46:10.000000', 'temperatura', 274.0000, 'ºC'),
	(78163, 109, '2015-03-01 00:46:11.000000', 'temperatura', 175.0000, 'ºC'),
	(78164, 109, '2015-03-01 00:46:12.000000', 'temperatura', 55.0000, 'ºC'),
	(78165, 109, '2015-03-01 00:46:13.000000', 'temperatura', 947.0000, 'ºC'),
	(78166, 109, '2015-03-01 00:46:14.000000', 'temperatura', 973.0000, 'ºC'),
	(78167, 109, '2015-03-01 00:46:15.000000', 'temperatura', 825.0000, 'ºC'),
	(78168, 109, '2015-03-01 00:46:16.000000', 'temperatura', 5.0000, 'ºC'),
	(78169, 109, '2015-03-01 00:46:17.000000', 'temperatura', 1152.0000, 'ºC'),
	(78170, 109, '2015-03-01 00:46:18.000000', 'temperatura', 945.0000, 'ºC'),
	(78171, 109, '2015-03-01 00:46:19.000000', 'temperatura', 67.0000, 'ºC'),
	(78172, 109, '2015-03-01 00:46:20.000000', 'temperatura', 1104.0000, 'ºC'),
	(78173, 109, '2015-03-01 00:46:21.000000', 'temperatura', 518.0000, 'ºC'),
	(78174, 109, '2015-03-01 00:46:22.000000', 'temperatura', 478.0000, 'ºC'),
	(78175, 109, '2015-03-01 00:46:23.000000', 'temperatura', 838.0000, 'ºC'),
	(78176, 109, '2015-03-01 00:46:24.000000', 'temperatura', 358.0000, 'ºC'),
	(78177, 109, '2015-03-01 00:46:25.000000', 'temperatura', 473.0000, 'ºC'),
	(78178, 109, '2015-03-01 00:46:26.000000', 'temperatura', 93.0000, 'ºC'),
	(78179, 109, '2015-03-01 00:46:27.000000', 'temperatura', 246.0000, 'ºC'),
	(78180, 109, '2015-03-01 00:46:28.000000', 'temperatura', 951.0000, 'ºC'),
	(78181, 109, '2015-03-01 00:46:29.000000', 'temperatura', 418.0000, 'ºC'),
	(78182, 109, '2015-03-01 00:46:30.000000', 'temperatura', 437.0000, 'ºC'),
	(78183, 109, '2015-03-01 00:46:31.000000', 'temperatura', 931.0000, 'ºC'),
	(78184, 109, '2015-03-01 00:46:32.000000', 'temperatura', 944.0000, 'ºC'),
	(78185, 109, '2015-03-01 00:46:33.000000', 'temperatura', 727.0000, 'ºC'),
	(78186, 109, '2015-03-01 00:46:34.000000', 'temperatura', 804.0000, 'ºC'),
	(78187, 109, '2015-03-01 00:46:35.000000', 'temperatura', 639.0000, 'ºC'),
	(78188, 109, '2015-03-01 00:46:36.000000', 'temperatura', 785.0000, 'ºC'),
	(78189, 109, '2015-03-01 00:46:37.000000', 'temperatura', 807.0000, 'ºC'),
	(78190, 109, '2015-03-01 00:46:38.000000', 'temperatura', 480.0000, 'ºC'),
	(78191, 109, '2015-03-01 00:46:39.000000', 'temperatura', 1180.0000, 'ºC'),
	(78192, 109, '2015-03-01 00:46:40.000000', 'temperatura', 862.0000, 'ºC'),
	(78193, 109, '2015-03-01 00:46:41.000000', 'temperatura', 771.0000, 'ºC'),
	(78194, 109, '2015-03-01 00:46:42.000000', 'temperatura', 70.0000, 'ºC'),
	(78195, 109, '2015-03-01 00:46:43.000000', 'temperatura', 438.0000, 'ºC'),
	(78196, 109, '2015-03-01 00:46:44.000000', 'temperatura', 779.0000, 'ºC'),
	(78197, 109, '2015-03-01 00:46:45.000000', 'temperatura', 181.0000, 'ºC'),
	(78198, 109, '2015-03-01 00:46:46.000000', 'temperatura', 970.0000, 'ºC'),
	(78199, 109, '2015-03-01 00:46:47.000000', 'temperatura', 708.0000, 'ºC'),
	(78200, 109, '2015-03-01 00:46:48.000000', 'temperatura', 631.0000, 'ºC'),
	(78201, 109, '2015-03-01 00:46:49.000000', 'temperatura', 1030.0000, 'ºC'),
	(78202, 109, '2015-03-01 00:46:50.000000', 'temperatura', 859.0000, 'ºC'),
	(78203, 109, '2015-03-01 00:46:51.000000', 'temperatura', 5.0000, 'ºC'),
	(78204, 109, '2015-03-01 00:46:52.000000', 'temperatura', 1049.0000, 'ºC'),
	(78205, 109, '2015-03-01 00:46:53.000000', 'temperatura', 430.0000, 'ºC'),
	(78206, 109, '2015-03-01 00:46:54.000000', 'temperatura', 205.0000, 'ºC'),
	(78207, 109, '2015-03-01 00:46:55.000000', 'temperatura', 934.0000, 'ºC'),
	(78208, 109, '2015-03-01 00:46:56.000000', 'temperatura', 455.0000, 'ºC'),
	(78209, 109, '2015-03-01 00:46:57.000000', 'temperatura', 675.0000, 'ºC'),
	(78210, 109, '2015-03-01 00:46:58.000000', 'temperatura', 810.0000, 'ºC'),
	(78211, 109, '2015-03-01 00:46:59.000000', 'temperatura', 827.0000, 'ºC'),
	(78212, 109, '2015-03-01 00:47:00.000000', 'temperatura', 506.0000, 'ºC'),
	(78213, 109, '2015-03-01 00:47:01.000000', 'temperatura', 48.0000, 'ºC'),
	(78214, 109, '2015-03-01 00:47:02.000000', 'temperatura', 1123.0000, 'ºC'),
	(78215, 109, '2015-03-01 00:47:03.000000', 'temperatura', 672.0000, 'ºC'),
	(78216, 109, '2015-03-01 00:47:04.000000', 'temperatura', 1192.0000, 'ºC'),
	(78217, 109, '2015-03-01 00:47:05.000000', 'temperatura', 346.0000, 'ºC'),
	(78218, 109, '2015-03-01 00:47:06.000000', 'temperatura', 551.0000, 'ºC'),
	(78219, 109, '2015-03-01 00:47:07.000000', 'temperatura', 518.0000, 'ºC'),
	(78220, 109, '2015-03-01 00:47:08.000000', 'temperatura', 939.0000, 'ºC'),
	(78221, 109, '2015-03-01 00:47:09.000000', 'temperatura', 742.0000, 'ºC'),
	(78222, 109, '2015-03-01 00:47:10.000000', 'temperatura', 895.0000, 'ºC'),
	(78223, 109, '2015-03-01 00:47:11.000000', 'temperatura', 1046.0000, 'ºC'),
	(78224, 109, '2015-03-01 00:47:12.000000', 'temperatura', 146.0000, 'ºC'),
	(78225, 109, '2015-03-01 00:47:13.000000', 'temperatura', 1193.0000, 'ºC'),
	(78226, 109, '2015-03-01 00:47:14.000000', 'temperatura', 728.0000, 'ºC'),
	(78227, 109, '2015-03-01 00:47:15.000000', 'temperatura', 61.0000, 'ºC'),
	(78228, 109, '2015-03-01 00:47:16.000000', 'temperatura', 521.0000, 'ºC'),
	(78229, 109, '2015-03-01 00:47:17.000000', 'temperatura', 22.0000, 'ºC'),
	(78230, 109, '2015-03-01 00:47:18.000000', 'temperatura', 949.0000, 'ºC'),
	(78231, 109, '2015-03-01 00:47:19.000000', 'temperatura', 1079.0000, 'ºC'),
	(78232, 109, '2015-03-01 00:47:20.000000', 'temperatura', 148.0000, 'ºC'),
	(78233, 109, '2015-03-01 00:47:21.000000', 'temperatura', 1104.0000, 'ºC'),
	(78234, 109, '2015-03-01 00:47:22.000000', 'temperatura', 275.0000, 'ºC'),
	(78235, 109, '2015-03-01 00:47:23.000000', 'temperatura', 464.0000, 'ºC'),
	(78236, 109, '2015-03-01 00:47:24.000000', 'temperatura', 294.0000, 'ºC'),
	(78237, 109, '2015-03-01 00:47:25.000000', 'temperatura', 80.0000, 'ºC'),
	(78238, 109, '2015-03-01 00:47:26.000000', 'temperatura', 720.0000, 'ºC'),
	(78239, 109, '2015-03-01 00:47:27.000000', 'temperatura', 958.0000, 'ºC'),
	(78240, 109, '2015-03-01 00:47:28.000000', 'temperatura', 230.0000, 'ºC'),
	(78241, 109, '2015-03-01 00:47:29.000000', 'temperatura', 676.0000, 'ºC'),
	(78242, 109, '2015-03-01 00:47:30.000000', 'temperatura', 291.0000, 'ºC'),
	(78243, 109, '2015-03-01 00:47:31.000000', 'temperatura', 629.0000, 'ºC'),
	(78244, 109, '2015-03-01 00:47:32.000000', 'temperatura', 1072.0000, 'ºC'),
	(78245, 109, '2015-03-01 00:47:33.000000', 'temperatura', 1073.0000, 'ºC'),
	(78246, 109, '2015-03-01 00:47:34.000000', 'temperatura', 949.0000, 'ºC'),
	(78247, 109, '2015-03-01 00:47:35.000000', 'temperatura', 329.0000, 'ºC'),
	(78248, 109, '2015-03-01 00:47:36.000000', 'temperatura', 1196.0000, 'ºC'),
	(78249, 109, '2015-03-01 00:47:37.000000', 'temperatura', 193.0000, 'ºC'),
	(78250, 109, '2015-03-01 00:47:38.000000', 'temperatura', 979.0000, 'ºC'),
	(78251, 109, '2015-03-01 00:47:39.000000', 'temperatura', 716.0000, 'ºC'),
	(78252, 109, '2015-03-01 00:47:40.000000', 'temperatura', 643.0000, 'ºC'),
	(78253, 109, '2015-03-01 00:47:41.000000', 'temperatura', 1068.0000, 'ºC'),
	(78254, 109, '2015-03-01 00:47:42.000000', 'temperatura', 1014.0000, 'ºC'),
	(78255, 109, '2015-03-01 00:47:43.000000', 'temperatura', 663.0000, 'ºC'),
	(78256, 109, '2015-03-01 00:47:44.000000', 'temperatura', 274.0000, 'ºC'),
	(78257, 109, '2015-03-01 00:47:45.000000', 'temperatura', 580.0000, 'ºC'),
	(78258, 109, '2015-03-01 00:47:46.000000', 'temperatura', 881.0000, 'ºC'),
	(78259, 109, '2015-03-01 00:47:47.000000', 'temperatura', 263.0000, 'ºC'),
	(78260, 109, '2015-03-01 00:47:48.000000', 'temperatura', 1072.0000, 'ºC'),
	(78261, 109, '2015-03-01 00:47:49.000000', 'temperatura', 975.0000, 'ºC'),
	(78262, 109, '2015-03-01 00:47:50.000000', 'temperatura', 456.0000, 'ºC'),
	(78263, 109, '2015-03-01 00:47:51.000000', 'temperatura', 558.0000, 'ºC'),
	(78264, 109, '2015-03-01 00:47:52.000000', 'temperatura', 222.0000, 'ºC'),
	(78265, 109, '2015-03-01 00:47:53.000000', 'temperatura', 636.0000, 'ºC'),
	(78266, 109, '2015-03-01 00:47:54.000000', 'temperatura', 115.0000, 'ºC'),
	(78267, 109, '2015-03-01 00:47:55.000000', 'temperatura', 1065.0000, 'ºC'),
	(78268, 109, '2015-03-01 00:47:56.000000', 'temperatura', 183.0000, 'ºC'),
	(78269, 109, '2015-03-01 00:47:57.000000', 'temperatura', 122.0000, 'ºC'),
	(78270, 109, '2015-03-01 00:47:58.000000', 'temperatura', 59.0000, 'ºC'),
	(78271, 109, '2015-03-01 00:47:59.000000', 'temperatura', 1130.0000, 'ºC'),
	(78272, 109, '2015-03-01 00:48:00.000000', 'temperatura', 674.0000, 'ºC'),
	(78273, 109, '2015-03-01 00:48:01.000000', 'temperatura', 1179.0000, 'ºC'),
	(78274, 109, '2015-03-01 00:48:02.000000', 'temperatura', 275.0000, 'ºC'),
	(78275, 109, '2015-03-01 00:48:03.000000', 'temperatura', 236.0000, 'ºC'),
	(78276, 109, '2015-03-01 00:48:04.000000', 'temperatura', 359.0000, 'ºC'),
	(78277, 109, '2015-03-01 00:48:05.000000', 'temperatura', 1085.0000, 'ºC'),
	(78278, 109, '2015-03-01 00:48:06.000000', 'temperatura', 749.0000, 'ºC'),
	(78279, 109, '2015-03-01 00:48:07.000000', 'temperatura', 489.0000, 'ºC'),
	(78280, 109, '2015-03-01 00:48:08.000000', 'temperatura', 198.0000, 'ºC'),
	(78281, 109, '2015-03-01 00:48:09.000000', 'temperatura', 723.0000, 'ºC'),
	(78282, 109, '2015-03-01 00:48:10.000000', 'temperatura', 624.0000, 'ºC'),
	(78283, 109, '2015-03-01 00:48:11.000000', 'temperatura', 949.0000, 'ºC'),
	(78284, 109, '2015-03-01 00:48:12.000000', 'temperatura', 476.0000, 'ºC'),
	(78285, 109, '2015-03-01 00:48:13.000000', 'temperatura', 730.0000, 'ºC'),
	(78286, 109, '2015-03-01 00:48:14.000000', 'temperatura', 1026.0000, 'ºC'),
	(78287, 109, '2015-03-01 00:48:15.000000', 'temperatura', 539.0000, 'ºC'),
	(78288, 109, '2015-03-01 00:48:16.000000', 'temperatura', 819.0000, 'ºC'),
	(78289, 109, '2015-03-01 00:48:17.000000', 'temperatura', 79.0000, 'ºC'),
	(78290, 109, '2015-03-01 00:48:18.000000', 'temperatura', 337.0000, 'ºC'),
	(78291, 109, '2015-03-01 00:48:19.000000', 'temperatura', 250.0000, 'ºC'),
	(78292, 109, '2015-03-01 00:48:20.000000', 'temperatura', 238.0000, 'ºC'),
	(78293, 109, '2015-03-01 00:48:21.000000', 'temperatura', 442.0000, 'ºC'),
	(78294, 109, '2015-03-01 00:48:22.000000', 'temperatura', 296.0000, 'ºC'),
	(78295, 109, '2015-03-01 00:48:23.000000', 'temperatura', 156.0000, 'ºC'),
	(78296, 109, '2015-03-01 00:48:24.000000', 'temperatura', 1090.0000, 'ºC'),
	(78297, 109, '2015-03-01 00:48:25.000000', 'temperatura', 185.0000, 'ºC'),
	(78298, 109, '2015-03-01 00:48:26.000000', 'temperatura', 55.0000, 'ºC'),
	(78299, 109, '2015-03-01 00:48:27.000000', 'temperatura', 920.0000, 'ºC'),
	(78300, 109, '2015-03-01 00:48:28.000000', 'temperatura', 835.0000, 'ºC'),
	(78301, 109, '2015-03-01 00:48:29.000000', 'temperatura', 215.0000, 'ºC'),
	(78302, 109, '2015-03-01 00:48:30.000000', 'temperatura', 970.0000, 'ºC'),
	(78303, 109, '2015-03-01 00:48:31.000000', 'temperatura', 608.0000, 'ºC'),
	(78304, 109, '2015-03-01 00:48:32.000000', 'temperatura', 129.0000, 'ºC'),
	(78305, 109, '2015-03-01 00:48:33.000000', 'temperatura', 20.0000, 'ºC'),
	(78306, 109, '2015-03-01 00:48:34.000000', 'temperatura', 916.0000, 'ºC'),
	(78307, 109, '2015-03-01 00:48:35.000000', 'temperatura', 918.0000, 'ºC'),
	(78308, 109, '2015-03-01 00:48:36.000000', 'temperatura', 643.0000, 'ºC'),
	(78309, 109, '2015-03-01 00:48:37.000000', 'temperatura', 463.0000, 'ºC'),
	(78310, 109, '2015-03-01 00:48:38.000000', 'temperatura', 384.0000, 'ºC'),
	(78311, 109, '2015-03-01 00:48:39.000000', 'temperatura', 534.0000, 'ºC'),
	(78312, 109, '2015-03-01 00:48:40.000000', 'temperatura', 317.0000, 'ºC'),
	(78313, 109, '2015-03-01 00:48:41.000000', 'temperatura', 1183.0000, 'ºC'),
	(78314, 109, '2015-03-01 00:48:42.000000', 'temperatura', 164.0000, 'ºC'),
	(78315, 109, '2015-03-01 00:48:43.000000', 'temperatura', 871.0000, 'ºC'),
	(78316, 109, '2015-03-01 00:48:44.000000', 'temperatura', 265.0000, 'ºC'),
	(78317, 109, '2015-03-01 00:48:45.000000', 'temperatura', 1111.0000, 'ºC'),
	(78318, 109, '2015-03-01 00:48:46.000000', 'temperatura', 1160.0000, 'ºC'),
	(78319, 109, '2015-03-01 00:48:47.000000', 'temperatura', 68.0000, 'ºC'),
	(78320, 109, '2015-03-01 00:48:48.000000', 'temperatura', 463.0000, 'ºC'),
	(78321, 109, '2015-03-01 00:48:49.000000', 'temperatura', 908.0000, 'ºC'),
	(78322, 109, '2015-03-01 00:48:50.000000', 'temperatura', 755.0000, 'ºC'),
	(78323, 109, '2015-03-01 00:48:51.000000', 'temperatura', 1049.0000, 'ºC'),
	(78324, 109, '2015-03-01 00:48:52.000000', 'temperatura', 582.0000, 'ºC'),
	(78325, 109, '2015-03-01 00:48:53.000000', 'temperatura', 961.0000, 'ºC'),
	(78326, 109, '2015-03-01 00:48:54.000000', 'temperatura', 662.0000, 'ºC'),
	(78327, 109, '2015-03-01 00:48:55.000000', 'temperatura', 428.0000, 'ºC'),
	(78328, 109, '2015-03-01 00:48:56.000000', 'temperatura', 154.0000, 'ºC'),
	(78329, 109, '2015-03-01 00:48:57.000000', 'temperatura', 685.0000, 'ºC'),
	(78330, 109, '2015-03-01 00:48:58.000000', 'temperatura', 566.0000, 'ºC'),
	(78331, 109, '2015-03-01 00:48:59.000000', 'temperatura', 773.0000, 'ºC'),
	(78332, 109, '2015-03-01 00:49:00.000000', 'temperatura', 969.0000, 'ºC'),
	(78333, 109, '2015-03-01 00:49:01.000000', 'temperatura', 125.0000, 'ºC'),
	(78334, 109, '2015-03-01 00:49:02.000000', 'temperatura', 120.0000, 'ºC'),
	(78335, 109, '2015-03-01 00:49:03.000000', 'temperatura', 223.0000, 'ºC'),
	(78336, 109, '2015-03-01 00:49:04.000000', 'temperatura', 757.0000, 'ºC'),
	(78337, 109, '2015-03-01 00:49:05.000000', 'temperatura', 718.0000, 'ºC'),
	(78338, 109, '2015-03-01 00:49:06.000000', 'temperatura', 117.0000, 'ºC'),
	(78339, 109, '2015-03-01 00:49:07.000000', 'temperatura', 832.0000, 'ºC'),
	(78340, 109, '2015-03-01 00:49:08.000000', 'temperatura', 211.0000, 'ºC'),
	(78341, 109, '2015-03-01 00:49:09.000000', 'temperatura', 959.0000, 'ºC'),
	(78342, 109, '2015-03-01 00:49:10.000000', 'temperatura', 563.0000, 'ºC'),
	(78343, 109, '2015-03-01 00:49:11.000000', 'temperatura', 1136.0000, 'ºC'),
	(78344, 109, '2015-03-01 00:49:12.000000', 'temperatura', 394.0000, 'ºC'),
	(78345, 109, '2015-03-01 00:49:13.000000', 'temperatura', 961.0000, 'ºC'),
	(78346, 109, '2015-03-01 00:49:14.000000', 'temperatura', 23.0000, 'ºC'),
	(78347, 109, '2015-03-01 00:49:15.000000', 'temperatura', 835.0000, 'ºC'),
	(78348, 109, '2015-03-01 00:49:16.000000', 'temperatura', 503.0000, 'ºC'),
	(78349, 109, '2015-03-01 00:49:17.000000', 'temperatura', 14.0000, 'ºC'),
	(78350, 109, '2015-03-01 00:49:18.000000', 'temperatura', 958.0000, 'ºC'),
	(78351, 109, '2015-03-01 00:49:19.000000', 'temperatura', 1150.0000, 'ºC'),
	(78352, 109, '2015-03-01 00:49:20.000000', 'temperatura', 477.0000, 'ºC'),
	(78353, 109, '2015-03-01 00:49:21.000000', 'temperatura', 136.0000, 'ºC'),
	(78354, 109, '2015-03-01 00:49:22.000000', 'temperatura', 447.0000, 'ºC'),
	(78355, 109, '2015-03-01 00:49:23.000000', 'temperatura', 629.0000, 'ºC'),
	(78356, 109, '2015-03-01 00:49:24.000000', 'temperatura', 604.0000, 'ºC'),
	(78357, 109, '2015-03-01 00:49:25.000000', 'temperatura', 1136.0000, 'ºC'),
	(78358, 109, '2015-03-01 00:49:26.000000', 'temperatura', 266.0000, 'ºC'),
	(78359, 109, '2015-03-01 00:49:27.000000', 'temperatura', 324.0000, 'ºC'),
	(78360, 109, '2015-03-01 00:49:28.000000', 'temperatura', 822.0000, 'ºC'),
	(78361, 109, '2015-03-01 00:49:29.000000', 'temperatura', 738.0000, 'ºC'),
	(78362, 109, '2015-03-01 00:49:30.000000', 'temperatura', 23.0000, 'ºC'),
	(78363, 109, '2015-03-01 00:49:31.000000', 'temperatura', 305.0000, 'ºC'),
	(78364, 109, '2015-03-01 00:49:32.000000', 'temperatura', 254.0000, 'ºC'),
	(78365, 109, '2015-03-01 00:49:33.000000', 'temperatura', 357.0000, 'ºC'),
	(78366, 109, '2015-03-01 00:49:34.000000', 'temperatura', 1021.0000, 'ºC'),
	(78367, 109, '2015-03-01 00:49:35.000000', 'temperatura', 438.0000, 'ºC'),
	(78368, 109, '2015-03-01 00:49:36.000000', 'temperatura', 325.0000, 'ºC'),
	(78369, 109, '2015-03-01 00:49:37.000000', 'temperatura', 314.0000, 'ºC'),
	(78370, 109, '2015-03-01 00:49:38.000000', 'temperatura', 593.0000, 'ºC'),
	(78371, 109, '2015-03-01 00:49:39.000000', 'temperatura', 823.0000, 'ºC'),
	(78372, 109, '2015-03-01 00:49:40.000000', 'temperatura', 1136.0000, 'ºC'),
	(78373, 109, '2015-03-01 00:49:41.000000', 'temperatura', 811.0000, 'ºC'),
	(78374, 109, '2015-03-01 00:49:42.000000', 'temperatura', 650.0000, 'ºC'),
	(78375, 109, '2015-03-01 00:49:43.000000', 'temperatura', 815.0000, 'ºC'),
	(78376, 109, '2015-03-01 00:49:44.000000', 'temperatura', 927.0000, 'ºC'),
	(78377, 109, '2015-03-01 00:49:45.000000', 'temperatura', 990.0000, 'ºC'),
	(78378, 109, '2015-03-01 00:49:46.000000', 'temperatura', 968.0000, 'ºC'),
	(78379, 109, '2015-03-01 00:49:47.000000', 'temperatura', 672.0000, 'ºC'),
	(78380, 109, '2015-03-01 00:49:48.000000', 'temperatura', 455.0000, 'ºC'),
	(78381, 109, '2015-03-01 00:49:49.000000', 'temperatura', 261.0000, 'ºC'),
	(78382, 109, '2015-03-01 00:49:50.000000', 'temperatura', 1138.0000, 'ºC'),
	(78383, 109, '2015-03-01 00:49:51.000000', 'temperatura', 109.0000, 'ºC'),
	(78384, 109, '2015-03-01 00:49:52.000000', 'temperatura', 731.0000, 'ºC'),
	(78385, 109, '2015-03-01 00:49:53.000000', 'temperatura', 929.0000, 'ºC'),
	(78386, 109, '2015-03-01 00:49:54.000000', 'temperatura', 53.0000, 'ºC'),
	(78387, 109, '2015-03-01 00:49:55.000000', 'temperatura', 1076.0000, 'ºC'),
	(78388, 109, '2015-03-01 00:49:56.000000', 'temperatura', 423.0000, 'ºC'),
	(78389, 109, '2015-03-01 00:49:57.000000', 'temperatura', 86.0000, 'ºC'),
	(78390, 109, '2015-03-01 00:49:58.000000', 'temperatura', 364.0000, 'ºC'),
	(78391, 109, '2015-03-01 00:49:59.000000', 'temperatura', 363.0000, 'ºC'),
	(78392, 109, '2015-03-01 00:50:00.000000', 'temperatura', 722.0000, 'ºC'),
	(78393, 109, '2015-03-01 00:50:01.000000', 'temperatura', 122.0000, 'ºC'),
	(78394, 109, '2015-03-01 00:50:02.000000', 'temperatura', 845.0000, 'ºC'),
	(78395, 109, '2015-03-01 00:50:03.000000', 'temperatura', 258.0000, 'ºC'),
	(78396, 109, '2015-03-01 00:50:04.000000', 'temperatura', 1156.0000, 'ºC'),
	(78397, 109, '2015-03-01 00:50:05.000000', 'temperatura', 206.0000, 'ºC'),
	(78398, 109, '2015-03-01 00:50:06.000000', 'temperatura', 1162.0000, 'ºC'),
	(78399, 109, '2015-03-01 00:50:07.000000', 'temperatura', 393.0000, 'ºC'),
	(78400, 109, '2015-03-01 00:50:08.000000', 'temperatura', 881.0000, 'ºC'),
	(78401, 109, '2015-03-01 00:50:09.000000', 'temperatura', 825.0000, 'ºC'),
	(78402, 109, '2015-03-01 00:50:10.000000', 'temperatura', 284.0000, 'ºC'),
	(78403, 109, '2015-03-01 00:50:11.000000', 'temperatura', 145.0000, 'ºC'),
	(78404, 109, '2015-03-01 00:50:12.000000', 'temperatura', 1074.0000, 'ºC'),
	(78405, 109, '2015-03-01 00:50:13.000000', 'temperatura', 134.0000, 'ºC'),
	(78406, 109, '2015-03-01 00:50:14.000000', 'temperatura', 1050.0000, 'ºC'),
	(78407, 109, '2015-03-01 00:50:15.000000', 'temperatura', 48.0000, 'ºC'),
	(78408, 109, '2015-03-01 00:50:16.000000', 'temperatura', 692.0000, 'ºC'),
	(78409, 109, '2015-03-01 00:50:17.000000', 'temperatura', 916.0000, 'ºC'),
	(78410, 109, '2015-03-01 00:50:18.000000', 'temperatura', 102.0000, 'ºC'),
	(78411, 109, '2015-03-01 00:50:19.000000', 'temperatura', 166.0000, 'ºC'),
	(78412, 109, '2015-03-01 00:50:20.000000', 'temperatura', 521.0000, 'ºC'),
	(78413, 109, '2015-03-01 00:50:21.000000', 'temperatura', 909.0000, 'ºC'),
	(78414, 109, '2015-03-01 00:50:22.000000', 'temperatura', 584.0000, 'ºC'),
	(78415, 109, '2015-03-01 00:50:23.000000', 'temperatura', 192.0000, 'ºC'),
	(78416, 109, '2015-03-01 00:50:24.000000', 'temperatura', 410.0000, 'ºC'),
	(78417, 109, '2015-03-01 00:50:25.000000', 'temperatura', 275.0000, 'ºC'),
	(78418, 109, '2015-03-01 00:50:26.000000', 'temperatura', 143.0000, 'ºC'),
	(78419, 109, '2015-03-01 00:50:27.000000', 'temperatura', 1090.0000, 'ºC'),
	(78420, 109, '2015-03-01 00:50:28.000000', 'temperatura', 224.0000, 'ºC'),
	(78421, 109, '2015-03-01 00:50:29.000000', 'temperatura', 250.0000, 'ºC'),
	(78422, 109, '2015-03-01 00:50:30.000000', 'temperatura', 577.0000, 'ºC'),
	(78423, 109, '2015-03-01 00:50:31.000000', 'temperatura', 936.0000, 'ºC'),
	(78424, 109, '2015-03-01 00:50:32.000000', 'temperatura', 549.0000, 'ºC'),
	(78425, 109, '2015-03-01 00:50:33.000000', 'temperatura', 1138.0000, 'ºC'),
	(78426, 109, '2015-03-01 00:50:34.000000', 'temperatura', 445.0000, 'ºC'),
	(78427, 109, '2015-03-01 00:50:35.000000', 'temperatura', 10.0000, 'ºC'),
	(78428, 109, '2015-03-01 00:50:36.000000', 'temperatura', 1114.0000, 'ºC'),
	(78429, 109, '2015-03-01 00:50:37.000000', 'temperatura', 742.0000, 'ºC'),
	(78430, 109, '2015-03-01 00:50:38.000000', 'temperatura', 368.0000, 'ºC'),
	(78431, 109, '2015-03-01 00:50:39.000000', 'temperatura', 815.0000, 'ºC'),
	(78432, 109, '2015-03-01 00:50:40.000000', 'temperatura', 571.0000, 'ºC'),
	(78433, 109, '2015-03-01 00:50:41.000000', 'temperatura', 412.0000, 'ºC'),
	(78434, 109, '2015-03-01 00:50:42.000000', 'temperatura', 345.0000, 'ºC'),
	(78435, 109, '2015-03-01 00:50:43.000000', 'temperatura', 489.0000, 'ºC'),
	(78436, 109, '2015-03-01 00:50:44.000000', 'temperatura', 212.0000, 'ºC'),
	(78437, 109, '2015-03-01 00:50:45.000000', 'temperatura', 792.0000, 'ºC'),
	(78438, 109, '2015-03-01 00:50:46.000000', 'temperatura', 927.0000, 'ºC'),
	(78439, 109, '2015-03-01 00:50:47.000000', 'temperatura', 1060.0000, 'ºC'),
	(78440, 109, '2015-03-01 00:50:48.000000', 'temperatura', 120.0000, 'ºC'),
	(78441, 109, '2015-03-01 00:50:49.000000', 'temperatura', 1019.0000, 'ºC'),
	(78442, 109, '2015-03-01 00:50:50.000000', 'temperatura', 1137.0000, 'ºC'),
	(78443, 109, '2015-03-01 00:50:51.000000', 'temperatura', 226.0000, 'ºC'),
	(78444, 109, '2015-03-01 00:50:52.000000', 'temperatura', 122.0000, 'ºC'),
	(78445, 109, '2015-03-01 00:50:53.000000', 'temperatura', 1132.0000, 'ºC'),
	(78446, 109, '2015-03-01 00:50:54.000000', 'temperatura', 495.0000, 'ºC'),
	(78447, 109, '2015-03-01 00:50:55.000000', 'temperatura', 280.0000, 'ºC'),
	(78448, 109, '2015-03-01 00:50:56.000000', 'temperatura', 1113.0000, 'ºC'),
	(78449, 109, '2015-03-01 00:50:57.000000', 'temperatura', 1129.0000, 'ºC'),
	(78450, 109, '2015-03-01 00:50:58.000000', 'temperatura', 1104.0000, 'ºC'),
	(78451, 109, '2015-03-01 00:50:59.000000', 'temperatura', 934.0000, 'ºC'),
	(78452, 109, '2015-03-01 00:51:00.000000', 'temperatura', 160.0000, 'ºC'),
	(78453, 109, '2015-03-01 00:51:01.000000', 'temperatura', 395.0000, 'ºC'),
	(78454, 109, '2015-03-01 00:51:02.000000', 'temperatura', 299.0000, 'ºC'),
	(78455, 109, '2015-03-01 00:51:03.000000', 'temperatura', 310.0000, 'ºC'),
	(78456, 109, '2015-03-01 00:51:04.000000', 'temperatura', 652.0000, 'ºC'),
	(78457, 109, '2015-03-01 00:51:05.000000', 'temperatura', 1131.0000, 'ºC'),
	(78458, 109, '2015-03-01 00:51:06.000000', 'temperatura', 98.0000, 'ºC'),
	(78459, 109, '2015-03-01 00:51:07.000000', 'temperatura', 699.0000, 'ºC'),
	(78460, 109, '2015-03-01 00:51:08.000000', 'temperatura', 801.0000, 'ºC'),
	(78461, 109, '2015-03-01 00:51:09.000000', 'temperatura', 710.0000, 'ºC'),
	(78462, 109, '2015-03-01 00:51:10.000000', 'temperatura', 1145.0000, 'ºC'),
	(78463, 109, '2015-03-01 00:51:11.000000', 'temperatura', 1196.0000, 'ºC'),
	(78464, 109, '2015-03-01 00:51:12.000000', 'temperatura', 146.0000, 'ºC'),
	(78465, 109, '2015-03-01 00:51:13.000000', 'temperatura', 741.0000, 'ºC'),
	(78466, 109, '2015-03-01 00:51:14.000000', 'temperatura', 868.0000, 'ºC'),
	(78467, 109, '2015-03-01 00:51:15.000000', 'temperatura', 916.0000, 'ºC'),
	(78468, 109, '2015-03-01 00:51:16.000000', 'temperatura', 779.0000, 'ºC'),
	(78469, 109, '2015-03-01 00:51:17.000000', 'temperatura', 1146.0000, 'ºC'),
	(78470, 109, '2015-03-01 00:51:18.000000', 'temperatura', 993.0000, 'ºC'),
	(78471, 109, '2015-03-01 00:51:19.000000', 'temperatura', 328.0000, 'ºC'),
	(78472, 109, '2015-03-01 00:51:20.000000', 'temperatura', 1062.0000, 'ºC'),
	(78473, 109, '2015-03-01 00:51:21.000000', 'temperatura', 725.0000, 'ºC'),
	(78474, 109, '2015-03-01 00:51:22.000000', 'temperatura', 441.0000, 'ºC'),
	(78475, 109, '2015-03-01 00:51:23.000000', 'temperatura', 31.0000, 'ºC'),
	(78476, 109, '2015-03-01 00:51:24.000000', 'temperatura', 32.0000, 'ºC'),
	(78477, 109, '2015-03-01 00:51:25.000000', 'temperatura', 66.0000, 'ºC'),
	(78478, 109, '2015-03-01 00:51:26.000000', 'temperatura', 238.0000, 'ºC'),
	(78479, 109, '2015-03-01 00:51:27.000000', 'temperatura', 989.0000, 'ºC'),
	(78480, 109, '2015-03-01 00:51:28.000000', 'temperatura', 631.0000, 'ºC'),
	(78481, 109, '2015-03-01 00:51:29.000000', 'temperatura', 190.0000, 'ºC'),
	(78482, 109, '2015-03-01 00:51:30.000000', 'temperatura', 259.0000, 'ºC'),
	(78483, 109, '2015-03-01 00:51:31.000000', 'temperatura', 726.0000, 'ºC'),
	(78484, 109, '2015-03-01 00:51:32.000000', 'temperatura', 453.0000, 'ºC'),
	(78485, 109, '2015-03-01 00:51:33.000000', 'temperatura', 86.0000, 'ºC'),
	(78486, 109, '2015-03-01 00:51:34.000000', 'temperatura', 272.0000, 'ºC'),
	(78487, 109, '2015-03-01 00:51:35.000000', 'temperatura', 1103.0000, 'ºC'),
	(78488, 109, '2015-03-01 00:51:36.000000', 'temperatura', 1098.0000, 'ºC'),
	(78489, 109, '2015-03-01 00:51:37.000000', 'temperatura', 981.0000, 'ºC'),
	(78490, 109, '2015-03-01 00:51:38.000000', 'temperatura', 411.0000, 'ºC'),
	(78491, 109, '2015-03-01 00:51:39.000000', 'temperatura', 314.0000, 'ºC'),
	(78492, 109, '2015-03-01 00:51:40.000000', 'temperatura', 335.0000, 'ºC'),
	(78493, 109, '2015-03-01 00:51:41.000000', 'temperatura', 735.0000, 'ºC'),
	(78494, 109, '2015-03-01 00:51:42.000000', 'temperatura', 272.0000, 'ºC'),
	(78495, 109, '2015-03-01 00:51:43.000000', 'temperatura', 356.0000, 'ºC'),
	(78496, 109, '2015-03-01 00:51:44.000000', 'temperatura', 965.0000, 'ºC'),
	(78497, 109, '2015-03-01 00:51:45.000000', 'temperatura', 155.0000, 'ºC'),
	(78498, 109, '2015-03-01 00:51:46.000000', 'temperatura', 282.0000, 'ºC'),
	(78499, 109, '2015-03-01 00:51:47.000000', 'temperatura', 945.0000, 'ºC'),
	(78500, 109, '2015-03-01 00:51:48.000000', 'temperatura', 281.0000, 'ºC'),
	(78501, 109, '2015-03-01 00:51:49.000000', 'temperatura', 969.0000, 'ºC'),
	(78502, 109, '2015-03-01 00:51:50.000000', 'temperatura', 404.0000, 'ºC'),
	(78503, 109, '2015-03-01 00:51:51.000000', 'temperatura', 312.0000, 'ºC'),
	(78504, 109, '2015-03-01 00:51:52.000000', 'temperatura', 350.0000, 'ºC'),
	(78505, 109, '2015-03-01 00:51:53.000000', 'temperatura', 814.0000, 'ºC'),
	(78506, 109, '2015-03-01 00:51:54.000000', 'temperatura', 620.0000, 'ºC'),
	(78507, 109, '2015-03-01 00:51:55.000000', 'temperatura', 661.0000, 'ºC'),
	(78508, 109, '2015-03-01 00:51:56.000000', 'temperatura', 243.0000, 'ºC'),
	(78509, 109, '2015-03-01 00:51:57.000000', 'temperatura', 432.0000, 'ºC'),
	(78510, 109, '2015-03-01 00:51:58.000000', 'temperatura', 232.0000, 'ºC'),
	(78511, 109, '2015-03-01 00:51:59.000000', 'temperatura', 1064.0000, 'ºC'),
	(78512, 109, '2015-03-01 00:52:00.000000', 'temperatura', 1025.0000, 'ºC'),
	(78513, 109, '2015-03-01 00:52:01.000000', 'temperatura', 735.0000, 'ºC'),
	(78514, 109, '2015-03-01 00:52:02.000000', 'temperatura', 599.0000, 'ºC'),
	(78515, 109, '2015-03-01 00:52:03.000000', 'temperatura', 791.0000, 'ºC'),
	(78516, 109, '2015-03-01 00:52:04.000000', 'temperatura', 959.0000, 'ºC'),
	(78517, 109, '2015-03-01 00:52:05.000000', 'temperatura', 22.0000, 'ºC'),
	(78518, 109, '2015-03-01 00:52:06.000000', 'temperatura', 832.0000, 'ºC'),
	(78519, 109, '2015-03-01 00:52:07.000000', 'temperatura', 497.0000, 'ºC'),
	(78520, 109, '2015-03-01 00:52:08.000000', 'temperatura', 1189.0000, 'ºC'),
	(78521, 109, '2015-03-01 00:52:09.000000', 'temperatura', 854.0000, 'ºC'),
	(78522, 109, '2015-03-01 00:52:10.000000', 'temperatura', 702.0000, 'ºC'),
	(78523, 109, '2015-03-01 00:52:11.000000', 'temperatura', 948.0000, 'ºC'),
	(78524, 109, '2015-03-01 00:52:12.000000', 'temperatura', 236.0000, 'ºC'),
	(78525, 109, '2015-03-01 00:52:13.000000', 'temperatura', 738.0000, 'ºC'),
	(78526, 109, '2015-03-01 00:52:14.000000', 'temperatura', 581.0000, 'ºC'),
	(78527, 109, '2015-03-01 00:52:15.000000', 'temperatura', 694.0000, 'ºC'),
	(78528, 109, '2015-03-01 00:52:16.000000', 'temperatura', 524.0000, 'ºC'),
	(78529, 109, '2015-03-01 00:52:17.000000', 'temperatura', 542.0000, 'ºC'),
	(78530, 109, '2015-03-01 00:52:18.000000', 'temperatura', 1135.0000, 'ºC'),
	(78531, 109, '2015-03-01 00:52:19.000000', 'temperatura', 452.0000, 'ºC'),
	(78532, 109, '2015-03-01 00:52:20.000000', 'temperatura', 55.0000, 'ºC'),
	(78533, 109, '2015-03-01 00:52:21.000000', 'temperatura', 119.0000, 'ºC'),
	(78534, 109, '2015-03-01 00:52:22.000000', 'temperatura', 432.0000, 'ºC'),
	(78535, 109, '2015-03-01 00:52:23.000000', 'temperatura', 605.0000, 'ºC'),
	(78536, 109, '2015-03-01 00:52:24.000000', 'temperatura', 526.0000, 'ºC'),
	(78537, 109, '2015-03-01 00:52:25.000000', 'temperatura', 817.0000, 'ºC'),
	(78538, 109, '2015-03-01 00:52:26.000000', 'temperatura', 107.0000, 'ºC'),
	(78539, 109, '2015-03-01 00:52:27.000000', 'temperatura', 483.0000, 'ºC'),
	(78540, 109, '2015-03-01 00:52:28.000000', 'temperatura', 897.0000, 'ºC'),
	(78541, 109, '2015-03-01 00:52:29.000000', 'temperatura', 635.0000, 'ºC'),
	(78542, 109, '2015-03-01 00:52:30.000000', 'temperatura', 485.0000, 'ºC'),
	(78543, 109, '2015-03-01 00:52:31.000000', 'temperatura', 520.0000, 'ºC'),
	(78544, 109, '2015-03-01 00:52:32.000000', 'temperatura', 1147.0000, 'ºC'),
	(78545, 109, '2015-03-01 00:52:33.000000', 'temperatura', 573.0000, 'ºC'),
	(78546, 109, '2015-03-01 00:52:34.000000', 'temperatura', 627.0000, 'ºC'),
	(78547, 109, '2015-03-01 00:52:35.000000', 'temperatura', 216.0000, 'ºC'),
	(78548, 109, '2015-03-01 00:52:36.000000', 'temperatura', 399.0000, 'ºC'),
	(78549, 109, '2015-03-01 00:52:37.000000', 'temperatura', 149.0000, 'ºC'),
	(78550, 109, '2015-03-01 00:52:38.000000', 'temperatura', 747.0000, 'ºC'),
	(78551, 109, '2015-03-01 00:52:39.000000', 'temperatura', 888.0000, 'ºC'),
	(78552, 109, '2015-03-01 00:52:40.000000', 'temperatura', 999.0000, 'ºC'),
	(78553, 109, '2015-03-01 00:52:41.000000', 'temperatura', 1132.0000, 'ºC'),
	(78554, 109, '2015-03-01 00:52:42.000000', 'temperatura', 264.0000, 'ºC'),
	(78555, 109, '2015-03-01 00:52:43.000000', 'temperatura', 323.0000, 'ºC'),
	(78556, 109, '2015-03-01 00:52:44.000000', 'temperatura', 826.0000, 'ºC'),
	(78557, 109, '2015-03-01 00:52:45.000000', 'temperatura', 759.0000, 'ºC'),
	(78558, 109, '2015-03-01 00:52:46.000000', 'temperatura', 121.0000, 'ºC'),
	(78559, 109, '2015-03-01 00:52:47.000000', 'temperatura', 725.0000, 'ºC'),
	(78560, 109, '2015-03-01 00:52:48.000000', 'temperatura', 864.0000, 'ºC'),
	(78561, 109, '2015-03-01 00:52:49.000000', 'temperatura', 944.0000, 'ºC'),
	(78562, 109, '2015-03-01 00:52:50.000000', 'temperatura', 931.0000, 'ºC'),
	(78563, 109, '2015-03-01 00:52:51.000000', 'temperatura', 621.0000, 'ºC'),
	(78564, 109, '2015-03-01 00:52:52.000000', 'temperatura', 315.0000, 'ºC'),
	(78565, 109, '2015-03-01 00:52:53.000000', 'temperatura', 910.0000, 'ºC'),
	(78566, 109, '2015-03-01 00:52:54.000000', 'temperatura', 7.0000, 'ºC'),
	(78567, 109, '2015-03-01 00:52:55.000000', 'temperatura', 905.0000, 'ºC'),
	(78568, 109, '2015-03-01 00:52:56.000000', 'temperatura', 904.0000, 'ºC'),
	(78569, 109, '2015-03-01 00:52:57.000000', 'temperatura', 604.0000, 'ºC'),
	(78570, 109, '2015-03-01 00:52:58.000000', 'temperatura', 309.0000, 'ºC'),
	(78571, 109, '2015-03-01 00:52:59.000000', 'temperatura', 935.0000, 'ºC'),
	(78572, 109, '2015-03-01 00:53:00.000000', 'temperatura', 150.0000, 'ºC'),
	(78573, 109, '2015-03-01 00:53:01.000000', 'temperatura', 343.0000, 'ºC'),
	(78574, 109, '2015-03-01 00:53:02.000000', 'temperatura', 64.0000, 'ºC'),
	(78575, 109, '2015-03-01 00:53:03.000000', 'temperatura', 494.0000, 'ºC'),
	(78576, 109, '2015-03-01 00:53:04.000000', 'temperatura', 1078.0000, 'ºC'),
	(78577, 109, '2015-03-01 00:53:05.000000', 'temperatura', 306.0000, 'ºC'),
	(78578, 109, '2015-03-01 00:53:06.000000', 'temperatura', 700.0000, 'ºC'),
	(78579, 109, '2015-03-01 00:53:07.000000', 'temperatura', 180.0000, 'ºC'),
	(78580, 109, '2015-03-01 00:53:08.000000', 'temperatura', 2.0000, 'ºC'),
	(78581, 109, '2015-03-01 00:53:09.000000', 'temperatura', 668.0000, 'ºC'),
	(78582, 109, '2015-03-01 00:53:10.000000', 'temperatura', 936.0000, 'ºC'),
	(78583, 109, '2015-03-01 00:53:11.000000', 'temperatura', 276.0000, 'ºC'),
	(78584, 109, '2015-03-01 00:53:12.000000', 'temperatura', 973.0000, 'ºC'),
	(78585, 109, '2015-03-01 00:53:13.000000', 'temperatura', 439.0000, 'ºC'),
	(78586, 109, '2015-03-01 00:53:14.000000', 'temperatura', 476.0000, 'ºC'),
	(78587, 109, '2015-03-01 00:53:15.000000', 'temperatura', 1061.0000, 'ºC'),
	(78588, 109, '2015-03-01 00:53:16.000000', 'temperatura', 279.0000, 'ºC'),
	(78589, 109, '2015-03-01 00:53:17.000000', 'temperatura', 611.0000, 'ºC'),
	(78590, 109, '2015-03-01 00:53:18.000000', 'temperatura', 1019.0000, 'ºC'),
	(78591, 109, '2015-03-01 00:53:19.000000', 'temperatura', 862.0000, 'ºC'),
	(78592, 109, '2015-03-01 00:53:20.000000', 'temperatura', 53.0000, 'ºC'),
	(78593, 109, '2015-03-01 00:53:21.000000', 'temperatura', 82.0000, 'ºC'),
	(78594, 109, '2015-03-01 00:53:22.000000', 'temperatura', 252.0000, 'ºC'),
	(78595, 109, '2015-03-01 00:53:23.000000', 'temperatura', 1011.0000, 'ºC'),
	(78596, 109, '2015-03-01 00:53:24.000000', 'temperatura', 702.0000, 'ºC'),
	(78597, 109, '2015-03-01 00:53:25.000000', 'temperatura', 479.0000, 'ºC'),
	(78598, 109, '2015-03-01 00:53:26.000000', 'temperatura', 287.0000, 'ºC'),
	(78599, 109, '2015-03-01 00:53:27.000000', 'temperatura', 1198.0000, 'ºC'),
	(78600, 109, '2015-03-01 00:53:28.000000', 'temperatura', 330.0000, 'ºC'),
	(78601, 109, '2015-03-01 00:53:29.000000', 'temperatura', 457.0000, 'ºC'),
	(78602, 109, '2015-03-01 00:53:30.000000', 'temperatura', 96.0000, 'ºC'),
	(78603, 109, '2015-03-01 00:53:31.000000', 'temperatura', 309.0000, 'ºC'),
	(78604, 109, '2015-03-01 00:53:32.000000', 'temperatura', 59.0000, 'ºC'),
	(78605, 109, '2015-03-01 00:53:33.000000', 'temperatura', 566.0000, 'ºC'),
	(78606, 109, '2015-03-01 00:53:34.000000', 'temperatura', 254.0000, 'ºC'),
	(78607, 109, '2015-03-01 00:53:35.000000', 'temperatura', 772.0000, 'ºC'),
	(78608, 109, '2015-03-01 00:53:36.000000', 'temperatura', 700.0000, 'ºC'),
	(78609, 109, '2015-03-01 00:53:37.000000', 'temperatura', 1184.0000, 'ºC'),
	(78610, 109, '2015-03-01 00:53:38.000000', 'temperatura', 219.0000, 'ºC'),
	(78611, 109, '2015-03-01 00:53:39.000000', 'temperatura', 1144.0000, 'ºC'),
	(78612, 109, '2015-03-01 00:53:40.000000', 'temperatura', 265.0000, 'ºC'),
	(78613, 109, '2015-03-01 00:53:41.000000', 'temperatura', 292.0000, 'ºC'),
	(78614, 109, '2015-03-01 00:53:42.000000', 'temperatura', 668.0000, 'ºC'),
	(78615, 109, '2015-03-01 00:53:43.000000', 'temperatura', 64.0000, 'ºC'),
	(78616, 109, '2015-03-01 00:53:44.000000', 'temperatura', 714.0000, 'ºC'),
	(78617, 109, '2015-03-01 00:53:45.000000', 'temperatura', 980.0000, 'ºC'),
	(78618, 109, '2015-03-01 00:53:46.000000', 'temperatura', 358.0000, 'ºC'),
	(78619, 109, '2015-03-01 00:53:47.000000', 'temperatura', 52.0000, 'ºC'),
	(78620, 109, '2015-03-01 00:53:48.000000', 'temperatura', 387.0000, 'ºC'),
	(78621, 109, '2015-03-01 00:53:49.000000', 'temperatura', 579.0000, 'ºC'),
	(78622, 109, '2015-03-01 00:53:50.000000', 'temperatura', 533.0000, 'ºC'),
	(78623, 109, '2015-03-01 00:53:51.000000', 'temperatura', 928.0000, 'ºC'),
	(78624, 109, '2015-03-01 00:53:52.000000', 'temperatura', 644.0000, 'ºC'),
	(78625, 109, '2015-03-01 00:53:53.000000', 'temperatura', 437.0000, 'ºC'),
	(78626, 109, '2015-03-01 00:53:54.000000', 'temperatura', 251.0000, 'ºC'),
	(78627, 109, '2015-03-01 00:53:55.000000', 'temperatura', 1146.0000, 'ºC'),
	(78628, 109, '2015-03-01 00:53:56.000000', 'temperatura', 176.0000, 'ºC'),
	(78629, 109, '2015-03-01 00:53:57.000000', 'temperatura', 1045.0000, 'ºC'),
	(78630, 109, '2015-03-01 00:53:58.000000', 'temperatura', 1094.0000, 'ºC'),
	(78631, 109, '2015-03-01 00:53:59.000000', 'temperatura', 1138.0000, 'ºC'),
	(78632, 109, '2015-03-01 00:54:00.000000', 'temperatura', 9.0000, 'ºC'),
	(78633, 109, '2015-03-01 00:54:01.000000', 'temperatura', 231.0000, 'ºC'),
	(78634, 109, '2015-03-01 00:54:02.000000', 'temperatura', 1127.0000, 'ºC'),
	(78635, 109, '2015-03-01 00:54:03.000000', 'temperatura', 145.0000, 'ºC'),
	(78636, 109, '2015-03-01 00:54:04.000000', 'temperatura', 941.0000, 'ºC'),
	(78637, 109, '2015-03-01 00:54:05.000000', 'temperatura', 674.0000, 'ºC'),
	(78638, 109, '2015-03-01 00:54:06.000000', 'temperatura', 546.0000, 'ºC'),
	(78639, 109, '2015-03-01 00:54:07.000000', 'temperatura', 709.0000, 'ºC'),
	(78640, 109, '2015-03-01 00:54:08.000000', 'temperatura', 709.0000, 'ºC'),
	(78641, 109, '2015-03-01 00:54:09.000000', 'temperatura', 218.0000, 'ºC'),
	(78642, 109, '2015-03-01 00:54:10.000000', 'temperatura', 164.0000, 'ºC'),
	(78643, 109, '2015-03-01 00:54:11.000000', 'temperatura', 165.0000, 'ºC'),
	(78644, 109, '2015-03-01 00:54:12.000000', 'temperatura', 336.0000, 'ºC'),
	(78645, 109, '2015-03-01 00:54:13.000000', 'temperatura', 1184.0000, 'ºC'),
	(78646, 109, '2015-03-01 00:54:14.000000', 'temperatura', 113.0000, 'ºC'),
	(78647, 109, '2015-03-01 00:54:15.000000', 'temperatura', 613.0000, 'ºC'),
	(78648, 109, '2015-03-01 00:54:16.000000', 'temperatura', 329.0000, 'ºC'),
	(78649, 109, '2015-03-01 00:54:17.000000', 'temperatura', 1003.0000, 'ºC'),
	(78650, 109, '2015-03-01 00:54:18.000000', 'temperatura', 430.0000, 'ºC'),
	(78651, 109, '2015-03-01 00:54:19.000000', 'temperatura', 342.0000, 'ºC'),
	(78652, 109, '2015-03-01 00:54:20.000000', 'temperatura', 421.0000, 'ºC'),
	(78653, 109, '2015-03-01 00:54:21.000000', 'temperatura', 1078.0000, 'ºC'),
	(78654, 109, '2015-03-01 00:54:22.000000', 'temperatura', 528.0000, 'ºC'),
	(78655, 109, '2015-03-01 00:54:23.000000', 'temperatura', 608.0000, 'ºC'),
	(78656, 109, '2015-03-01 00:54:24.000000', 'temperatura', 257.0000, 'ºC'),
	(78657, 109, '2015-03-01 00:54:25.000000', 'temperatura', 660.0000, 'ºC'),
	(78658, 109, '2015-03-01 00:54:26.000000', 'temperatura', 131.0000, 'ºC'),
	(78659, 109, '2015-03-01 00:54:27.000000', 'temperatura', 1076.0000, 'ºC'),
	(78660, 109, '2015-03-01 00:54:28.000000', 'temperatura', 185.0000, 'ºC'),
	(78661, 109, '2015-03-01 00:54:29.000000', 'temperatura', 100.0000, 'ºC'),
	(78662, 109, '2015-03-01 00:54:30.000000', 'temperatura', 1146.0000, 'ºC'),
	(78663, 109, '2015-03-01 00:54:31.000000', 'temperatura', 627.0000, 'ºC'),
	(78664, 109, '2015-03-01 00:54:32.000000', 'temperatura', 901.0000, 'ºC'),
	(78665, 109, '2015-03-01 00:54:33.000000', 'temperatura', 223.0000, 'ºC'),
	(78666, 109, '2015-03-01 00:54:34.000000', 'temperatura', 812.0000, 'ºC'),
	(78667, 109, '2015-03-01 00:54:35.000000', 'temperatura', 993.0000, 'ºC'),
	(78668, 109, '2015-03-01 00:54:36.000000', 'temperatura', 129.0000, 'ºC'),
	(78669, 109, '2015-03-01 00:54:37.000000', 'temperatura', 67.0000, 'ºC'),
	(78670, 109, '2015-03-01 00:54:38.000000', 'temperatura', 1149.0000, 'ºC'),
	(78671, 109, '2015-03-01 00:54:39.000000', 'temperatura', 744.0000, 'ºC'),
	(78672, 109, '2015-03-01 00:54:40.000000', 'temperatura', 273.0000, 'ºC'),
	(78673, 109, '2015-03-01 00:54:41.000000', 'temperatura', 333.0000, 'ºC'),
	(78674, 109, '2015-03-01 00:54:42.000000', 'temperatura', 849.0000, 'ºC'),
	(78675, 109, '2015-03-01 00:54:43.000000', 'temperatura', 844.0000, 'ºC'),
	(78676, 109, '2015-03-01 00:54:44.000000', 'temperatura', 474.0000, 'ºC'),
	(78677, 109, '2015-03-01 00:54:45.000000', 'temperatura', 1039.0000, 'ºC'),
	(78678, 109, '2015-03-01 00:54:46.000000', 'temperatura', 172.0000, 'ºC'),
	(78679, 109, '2015-03-01 00:54:47.000000', 'temperatura', 143.0000, 'ºC'),
	(78680, 109, '2015-03-01 00:54:48.000000', 'temperatura', 201.0000, 'ºC'),
	(78681, 109, '2015-03-01 00:54:49.000000', 'temperatura', 578.0000, 'ºC'),
	(78682, 109, '2015-03-01 00:54:50.000000', 'temperatura', 1087.0000, 'ºC'),
	(78683, 109, '2015-03-01 00:54:51.000000', 'temperatura', 103.0000, 'ºC'),
	(78684, 109, '2015-03-01 00:54:52.000000', 'temperatura', 852.0000, 'ºC'),
	(78685, 109, '2015-03-01 00:54:53.000000', 'temperatura', 353.0000, 'ºC'),
	(78686, 109, '2015-03-01 00:54:54.000000', 'temperatura', 407.0000, 'ºC'),
	(78687, 109, '2015-03-01 00:54:55.000000', 'temperatura', 979.0000, 'ºC'),
	(78688, 109, '2015-03-01 00:54:56.000000', 'temperatura', 73.0000, 'ºC'),
	(78689, 109, '2015-03-01 00:54:57.000000', 'temperatura', 1031.0000, 'ºC'),
	(78690, 109, '2015-03-01 00:54:58.000000', 'temperatura', 134.0000, 'ºC'),
	(78691, 109, '2015-03-01 00:54:59.000000', 'temperatura', 1177.0000, 'ºC'),
	(78692, 109, '2015-03-01 00:55:00.000000', 'temperatura', 686.0000, 'ºC'),
	(78693, 109, '2015-03-01 00:55:01.000000', 'temperatura', 1099.0000, 'ºC'),
	(78694, 109, '2015-03-01 00:55:02.000000', 'temperatura', 1037.0000, 'ºC'),
	(78695, 109, '2015-03-01 00:55:03.000000', 'temperatura', 690.0000, 'ºC'),
	(78696, 109, '2015-03-01 00:55:04.000000', 'temperatura', 339.0000, 'ºC'),
	(78697, 109, '2015-03-01 00:55:05.000000', 'temperatura', 825.0000, 'ºC'),
	(78698, 109, '2015-03-01 00:55:06.000000', 'temperatura', 710.0000, 'ºC'),
	(78699, 109, '2015-03-01 00:55:07.000000', 'temperatura', 1076.0000, 'ºC'),
	(78700, 109, '2015-03-01 00:55:08.000000', 'temperatura', 849.0000, 'ºC'),
	(78701, 109, '2015-03-01 00:55:09.000000', 'temperatura', 1018.0000, 'ºC'),
	(78702, 109, '2015-03-01 00:55:10.000000', 'temperatura', 144.0000, 'ºC'),
	(78703, 109, '2015-03-01 00:55:11.000000', 'temperatura', 68.0000, 'ºC'),
	(78704, 109, '2015-03-01 00:55:12.000000', 'temperatura', 1107.0000, 'ºC'),
	(78705, 109, '2015-03-01 00:55:13.000000', 'temperatura', 530.0000, 'ºC'),
	(78706, 109, '2015-03-01 00:55:14.000000', 'temperatura', 532.0000, 'ºC'),
	(78707, 109, '2015-03-01 00:55:15.000000', 'temperatura', 1068.0000, 'ºC'),
	(78708, 109, '2015-03-01 00:55:16.000000', 'temperatura', 147.0000, 'ºC'),
	(78709, 109, '2015-03-01 00:55:17.000000', 'temperatura', 1132.0000, 'ºC'),
	(78710, 109, '2015-03-01 00:55:18.000000', 'temperatura', 417.0000, 'ºC'),
	(78711, 109, '2015-03-01 00:55:19.000000', 'temperatura', 1091.0000, 'ºC'),
	(78712, 109, '2015-03-01 00:55:20.000000', 'temperatura', 603.0000, 'ºC'),
	(78713, 109, '2015-03-01 00:55:21.000000', 'temperatura', 944.0000, 'ºC'),
	(78714, 109, '2015-03-01 00:55:22.000000', 'temperatura', 509.0000, 'ºC'),
	(78715, 109, '2015-03-01 00:55:23.000000', 'temperatura', 915.0000, 'ºC'),
	(78716, 109, '2015-03-01 00:55:24.000000', 'temperatura', 648.0000, 'ºC'),
	(78717, 109, '2015-03-01 00:55:25.000000', 'temperatura', 496.0000, 'ºC'),
	(78718, 109, '2015-03-01 00:55:26.000000', 'temperatura', 538.0000, 'ºC'),
	(78719, 109, '2015-03-01 00:55:27.000000', 'temperatura', 2.0000, 'ºC'),
	(78720, 109, '2015-03-01 00:55:28.000000', 'temperatura', 797.0000, 'ºC'),
	(78721, 109, '2015-03-01 00:55:29.000000', 'temperatura', 380.0000, 'ºC'),
	(78722, 109, '2015-03-01 00:55:30.000000', 'temperatura', 707.0000, 'ºC'),
	(78723, 109, '2015-03-01 00:55:31.000000', 'temperatura', 1199.0000, 'ºC'),
	(78724, 109, '2015-03-01 00:55:32.000000', 'temperatura', 271.0000, 'ºC'),
	(78725, 109, '2015-03-01 00:55:33.000000', 'temperatura', 159.0000, 'ºC'),
	(78726, 109, '2015-03-01 00:55:34.000000', 'temperatura', 1183.0000, 'ºC'),
	(78727, 109, '2015-03-01 00:55:35.000000', 'temperatura', 637.0000, 'ºC'),
	(78728, 109, '2015-03-01 00:55:36.000000', 'temperatura', 836.0000, 'ºC'),
	(78729, 109, '2015-03-01 00:55:37.000000', 'temperatura', 1071.0000, 'ºC'),
	(78730, 109, '2015-03-01 00:55:38.000000', 'temperatura', 448.0000, 'ºC'),
	(78731, 109, '2015-03-01 00:55:39.000000', 'temperatura', 225.0000, 'ºC'),
	(78732, 109, '2015-03-01 00:55:40.000000', 'temperatura', 983.0000, 'ºC'),
	(78733, 109, '2015-03-01 00:55:41.000000', 'temperatura', 640.0000, 'ºC'),
	(78734, 109, '2015-03-01 00:55:42.000000', 'temperatura', 252.0000, 'ºC'),
	(78735, 109, '2015-03-01 00:55:43.000000', 'temperatura', 538.0000, 'ºC'),
	(78736, 109, '2015-03-01 00:55:44.000000', 'temperatura', 737.0000, 'ºC'),
	(78737, 109, '2015-03-01 00:55:45.000000', 'temperatura', 872.0000, 'ºC'),
	(78738, 109, '2015-03-01 00:55:46.000000', 'temperatura', 949.0000, 'ºC'),
	(78739, 109, '2015-03-01 00:55:47.000000', 'temperatura', 927.0000, 'ºC'),
	(78740, 109, '2015-03-01 00:55:48.000000', 'temperatura', 591.0000, 'ºC'),
	(78741, 109, '2015-03-01 00:55:49.000000', 'temperatura', 173.0000, 'ºC'),
	(78742, 109, '2015-03-01 00:55:50.000000', 'temperatura', 295.0000, 'ºC'),
	(78743, 109, '2015-03-01 00:55:51.000000', 'temperatura', 956.0000, 'ºC'),
	(78744, 109, '2015-03-01 00:55:52.000000', 'temperatura', 296.0000, 'ºC'),
	(78745, 109, '2015-03-01 00:55:53.000000', 'temperatura', 1012.0000, 'ºC'),
	(78746, 109, '2015-03-01 00:55:54.000000', 'temperatura', 572.0000, 'ºC'),
	(78747, 109, '2015-03-01 00:55:55.000000', 'temperatura', 1023.0000, 'ºC'),
	(78748, 109, '2015-03-01 00:55:56.000000', 'temperatura', 1000.0000, 'ºC'),
	(78749, 109, '2015-03-01 00:55:57.000000', 'temperatura', 730.0000, 'ºC'),
	(78750, 109, '2015-03-01 00:55:58.000000', 'temperatura', 652.0000, 'ºC'),
	(78751, 109, '2015-03-01 00:55:59.000000', 'temperatura', 1070.0000, 'ºC'),
	(78752, 109, '2015-03-01 00:56:00.000000', 'temperatura', 994.0000, 'ºC'),
	(78753, 109, '2015-03-01 00:56:01.000000', 'temperatura', 559.0000, 'ºC'),
	(78754, 109, '2015-03-01 00:56:02.000000', 'temperatura', 1017.0000, 'ºC'),
	(78755, 109, '2015-03-01 00:56:03.000000', 'temperatura', 1007.0000, 'ºC'),
	(78756, 109, '2015-03-01 00:56:04.000000', 'temperatura', 785.0000, 'ºC'),
	(78757, 109, '2015-03-01 00:56:05.000000', 'temperatura', 905.0000, 'ºC'),
	(78758, 109, '2015-03-01 00:56:06.000000', 'temperatura', 969.0000, 'ºC'),
	(78759, 109, '2015-03-01 00:56:07.000000', 'temperatura', 931.0000, 'ºC'),
	(78760, 109, '2015-03-01 00:56:08.000000', 'temperatura', 549.0000, 'ºC'),
	(78761, 109, '2015-03-01 00:56:09.000000', 'temperatura', 1154.0000, 'ºC'),
	(78762, 109, '2015-03-01 00:56:10.000000', 'temperatura', 522.0000, 'ºC'),
	(78763, 109, '2015-03-01 00:56:11.000000', 'temperatura', 347.0000, 'ºC'),
	(78764, 109, '2015-03-01 00:56:12.000000', 'temperatura', 170.0000, 'ºC'),
	(78765, 109, '2015-03-01 00:56:13.000000', 'temperatura', 1011.0000, 'ºC'),
	(78766, 109, '2015-03-01 00:56:14.000000', 'temperatura', 944.0000, 'ºC'),
	(78767, 109, '2015-03-01 00:56:15.000000', 'temperatura', 490.0000, 'ºC'),
	(78768, 109, '2015-03-01 00:56:16.000000', 'temperatura', 817.0000, 'ºC'),
	(78769, 109, '2015-03-01 00:56:17.000000', 'temperatura', 217.0000, 'ºC'),
	(78770, 109, '2015-03-01 00:56:18.000000', 'temperatura', 1035.0000, 'ºC'),
	(78771, 109, '2015-03-01 00:56:19.000000', 'temperatura', 925.0000, 'ºC'),
	(78772, 109, '2015-03-01 00:56:20.000000', 'temperatura', 320.0000, 'ºC'),
	(78773, 109, '2015-03-01 00:56:21.000000', 'temperatura', 25.0000, 'ºC'),
	(78774, 109, '2015-03-01 00:56:22.000000', 'temperatura', 365.0000, 'ºC'),
	(78775, 109, '2015-03-01 00:56:23.000000', 'temperatura', 553.0000, 'ºC'),
	(78776, 109, '2015-03-01 00:56:24.000000', 'temperatura', 469.0000, 'ºC'),
	(78777, 109, '2015-03-01 00:56:25.000000', 'temperatura', 685.0000, 'ºC'),
	(78778, 109, '2015-03-01 00:56:26.000000', 'temperatura', 818.0000, 'ºC'),
	(78779, 109, '2015-03-01 00:56:27.000000', 'temperatura', 836.0000, 'ºC'),
	(78780, 109, '2015-03-01 00:56:28.000000', 'temperatura', 528.0000, 'ºC'),
	(78781, 109, '2015-03-01 00:56:29.000000', 'temperatura', 130.0000, 'ºC'),
	(78782, 109, '2015-03-01 00:56:30.000000', 'temperatura', 270.0000, 'ºC'),
	(78783, 109, '2015-03-01 00:56:31.000000', 'temperatura', 958.0000, 'ºC'),
	(78784, 109, '2015-03-01 00:56:32.000000', 'temperatura', 380.0000, 'ºC'),
	(78785, 109, '2015-03-01 00:56:33.000000', 'temperatura', 226.0000, 'ºC'),
	(78786, 109, '2015-03-01 00:56:34.000000', 'temperatura', 1191.0000, 'ºC'),
	(78787, 109, '2015-03-01 00:56:35.000000', 'temperatura', 477.0000, 'ºC'),
	(78788, 109, '2015-03-01 00:56:36.000000', 'temperatura', 12.0000, 'ºC'),
	(78789, 109, '2015-03-01 00:56:37.000000', 'temperatura', 1029.0000, 'ºC'),
	(78790, 109, '2015-03-01 00:56:38.000000', 'temperatura', 312.0000, 'ºC'),
	(78791, 109, '2015-03-01 00:56:39.000000', 'temperatura', 873.0000, 'ºC'),
	(78792, 109, '2015-03-01 00:56:40.000000', 'temperatura', 1027.0000, 'ºC'),
	(78793, 109, '2015-03-01 00:56:41.000000', 'temperatura', 118.0000, 'ºC'),
	(78794, 109, '2015-03-01 00:56:42.000000', 'temperatura', 1109.0000, 'ºC'),
	(78795, 109, '2015-03-01 00:56:43.000000', 'temperatura', 391.0000, 'ºC'),
	(78796, 109, '2015-03-01 00:56:44.000000', 'temperatura', 1030.0000, 'ºC'),
	(78797, 109, '2015-03-01 00:56:45.000000', 'temperatura', 377.0000, 'ºC'),
	(78798, 109, '2015-03-01 00:56:46.000000', 'temperatura', 1194.0000, 'ºC'),
	(78799, 109, '2015-03-01 00:56:47.000000', 'temperatura', 42.0000, 'ºC'),
	(78800, 109, '2015-03-01 00:56:48.000000', 'temperatura', 230.0000, 'ºC'),
	(78801, 109, '2015-03-01 00:56:49.000000', 'temperatura', 1021.0000, 'ºC'),
	(78802, 109, '2015-03-01 00:56:50.000000', 'temperatura', 815.0000, 'ºC'),
	(78803, 109, '2015-03-01 00:56:51.000000', 'temperatura', 1014.0000, 'ºC'),
	(78804, 109, '2015-03-01 00:56:52.000000', 'temperatura', 224.0000, 'ºC'),
	(78805, 109, '2015-03-01 00:56:53.000000', 'temperatura', 481.0000, 'ºC'),
	(78806, 109, '2015-03-01 00:56:54.000000', 'temperatura', 533.0000, 'ºC'),
	(78807, 109, '2015-03-01 00:56:55.000000', 'temperatura', 20.0000, 'ºC'),
	(78808, 109, '2015-03-01 00:56:56.000000', 'temperatura', 904.0000, 'ºC'),
	(78809, 109, '2015-03-01 00:56:57.000000', 'temperatura', 858.0000, 'ºC'),
	(78810, 109, '2015-03-01 00:56:58.000000', 'temperatura', 379.0000, 'ºC'),
	(78811, 109, '2015-03-01 00:56:59.000000', 'temperatura', 521.0000, 'ºC'),
	(78812, 109, '2015-03-01 00:57:00.000000', 'temperatura', 267.0000, 'ºC'),
	(78813, 109, '2015-03-01 00:57:01.000000', 'temperatura', 974.0000, 'ºC'),
	(78814, 109, '2015-03-01 00:57:02.000000', 'temperatura', 472.0000, 'ºC'),
	(78815, 109, '2015-03-01 00:57:03.000000', 'temperatura', 635.0000, 'ºC'),
	(78816, 109, '2015-03-01 00:57:04.000000', 'temperatura', 561.0000, 'ºC'),
	(78817, 109, '2015-03-01 00:57:05.000000', 'temperatura', 902.0000, 'ºC'),
	(78818, 109, '2015-03-01 00:57:06.000000', 'temperatura', 425.0000, 'ºC'),
	(78819, 109, '2015-03-01 00:57:07.000000', 'temperatura', 619.0000, 'ºC'),
	(78820, 109, '2015-03-01 00:57:08.000000', 'temperatura', 620.0000, 'ºC'),
	(78821, 109, '2015-03-01 00:57:09.000000', 'temperatura', 45.0000, 'ºC'),
	(78822, 109, '2015-03-01 00:57:10.000000', 'temperatura', 763.0000, 'ºC'),
	(78823, 109, '2015-03-01 00:57:11.000000', 'temperatura', 83.0000, 'ºC'),
	(78824, 109, '2015-03-01 00:57:12.000000', 'temperatura', 526.0000, 'ºC'),
	(78825, 109, '2015-03-01 00:57:13.000000', 'temperatura', 1183.0000, 'ºC'),
	(78826, 109, '2015-03-01 00:57:14.000000', 'temperatura', 736.0000, 'ºC'),
	(78827, 109, '2015-03-01 00:57:15.000000', 'temperatura', 131.0000, 'ºC'),
	(78828, 109, '2015-03-01 00:57:16.000000', 'temperatura', 846.0000, 'ºC'),
	(78829, 109, '2015-03-01 00:57:17.000000', 'temperatura', 240.0000, 'ºC'),
	(78830, 109, '2015-03-01 00:57:18.000000', 'temperatura', 1060.0000, 'ºC'),
	(78831, 109, '2015-03-01 00:57:19.000000', 'temperatura', 983.0000, 'ºC'),
	(78832, 109, '2015-03-01 00:57:20.000000', 'temperatura', 535.0000, 'ºC'),
	(78833, 109, '2015-03-01 00:57:21.000000', 'temperatura', 927.0000, 'ºC'),
	(78834, 109, '2015-03-01 00:57:22.000000', 'temperatura', 631.0000, 'ºC'),
	(78835, 109, '2015-03-01 00:57:23.000000', 'temperatura', 373.0000, 'ºC'),
	(78836, 109, '2015-03-01 00:57:24.000000', 'temperatura', 1174.0000, 'ºC'),
	(78837, 109, '2015-03-01 00:57:25.000000', 'temperatura', 1153.0000, 'ºC'),
	(78838, 109, '2015-03-01 00:57:26.000000', 'temperatura', 1041.0000, 'ºC'),
	(78839, 109, '2015-03-01 00:57:27.000000', 'temperatura', 548.0000, 'ºC'),
	(78840, 109, '2015-03-01 00:57:28.000000', 'temperatura', 819.0000, 'ºC'),
	(78841, 109, '2015-03-01 00:57:29.000000', 'temperatura', 48.0000, 'ºC'),
	(78842, 109, '2015-03-01 00:57:30.000000', 'temperatura', 187.0000, 'ºC'),
	(78843, 109, '2015-03-01 00:57:31.000000', 'temperatura', 788.0000, 'ºC'),
	(78844, 109, '2015-03-01 00:57:32.000000', 'temperatura', 983.0000, 'ºC'),
	(78845, 109, '2015-03-01 00:57:33.000000', 'temperatura', 150.0000, 'ºC'),
	(78846, 109, '2015-03-01 00:57:34.000000', 'temperatura', 201.0000, 'ºC'),
	(78847, 109, '2015-03-01 00:57:35.000000', 'temperatura', 556.0000, 'ºC'),
	(78848, 109, '2015-03-01 00:57:36.000000', 'temperatura', 977.0000, 'ºC'),
	(78849, 109, '2015-03-01 00:57:37.000000', 'temperatura', 819.0000, 'ºC'),
	(78850, 109, '2015-03-01 00:57:38.000000', 'temperatura', 1164.0000, 'ºC'),
	(78851, 109, '2015-03-01 00:57:39.000000', 'temperatura', 964.0000, 'ºC'),
	(78852, 109, '2015-03-01 00:57:40.000000', 'temperatura', 128.0000, 'ºC'),
	(78853, 109, '2015-03-01 00:57:41.000000', 'temperatura', 149.0000, 'ºC'),
	(78854, 109, '2015-03-01 00:57:42.000000', 'temperatura', 362.0000, 'ºC'),
	(78855, 109, '2015-03-01 00:57:43.000000', 'temperatura', 163.0000, 'ºC'),
	(78856, 109, '2015-03-01 00:57:44.000000', 'temperatura', 927.0000, 'ºC'),
	(78857, 109, '2015-03-01 00:57:45.000000', 'temperatura', 550.0000, 'ºC'),
	(78858, 109, '2015-03-01 00:57:46.000000', 'temperatura', 1167.0000, 'ºC'),
	(78859, 109, '2015-03-01 00:57:47.000000', 'temperatura', 585.0000, 'ºC'),
	(78860, 109, '2015-03-01 00:57:48.000000', 'temperatura', 627.0000, 'ºC'),
	(78861, 109, '2015-03-01 00:57:49.000000', 'temperatura', 180.0000, 'ºC'),
	(78862, 109, '2015-03-01 00:57:50.000000', 'temperatura', 221.0000, 'ºC'),
	(78863, 109, '2015-03-01 00:57:51.000000', 'temperatura', 563.0000, 'ºC'),
	(78864, 109, '2015-03-01 00:57:52.000000', 'temperatura', 955.0000, 'ºC'),
	(78865, 109, '2015-03-01 00:57:53.000000', 'temperatura', 685.0000, 'ºC'),
	(78866, 109, '2015-03-01 00:57:54.000000', 'temperatura', 561.0000, 'ºC'),
	(78867, 109, '2015-03-01 00:57:55.000000', 'temperatura', 748.0000, 'ºC'),
	(78868, 109, '2015-03-01 00:57:56.000000', 'temperatura', 860.0000, 'ºC'),
	(78869, 109, '2015-03-01 00:57:57.000000', 'temperatura', 856.0000, 'ºC'),
	(78870, 109, '2015-03-01 00:57:58.000000', 'temperatura', 502.0000, 'ºC'),
	(78871, 109, '2015-03-01 00:57:59.000000', 'temperatura', 1140.0000, 'ºC'),
	(78872, 109, '2015-03-01 00:58:00.000000', 'temperatura', 595.0000, 'ºC'),
	(78873, 109, '2015-03-01 00:58:01.000000', 'temperatura', 756.0000, 'ºC'),
	(78874, 109, '2015-03-01 00:58:02.000000', 'temperatura', 795.0000, 'ºC'),
	(78875, 109, '2015-03-01 00:58:03.000000', 'temperatura', 506.0000, 'ºC'),
	(78876, 109, '2015-03-01 00:58:04.000000', 'temperatura', 147.0000, 'ºC'),
	(78877, 109, '2015-03-01 00:58:05.000000', 'temperatura', 418.0000, 'ºC'),
	(78878, 109, '2015-03-01 00:58:06.000000', 'temperatura', 448.0000, 'ºC'),
	(78879, 109, '2015-03-01 00:58:07.000000', 'temperatura', 989.0000, 'ºC'),
	(78880, 109, '2015-03-01 00:58:08.000000', 'temperatura', 1.0000, 'ºC'),
	(78881, 109, '2015-03-01 00:58:09.000000', 'temperatura', 638.0000, 'ºC'),
	(78882, 109, '2015-03-01 00:58:10.000000', 'temperatura', 789.0000, 'ºC'),
	(78883, 109, '2015-03-01 00:58:11.000000', 'temperatura', 832.0000, 'ºC'),
	(78884, 109, '2015-03-01 00:58:12.000000', 'temperatura', 593.0000, 'ºC'),
	(78885, 109, '2015-03-01 00:58:13.000000', 'temperatura', 470.0000, 'ºC'),
	(78886, 109, '2015-03-01 00:58:14.000000', 'temperatura', 573.0000, 'ºC'),
	(78887, 109, '2015-03-01 00:58:15.000000', 'temperatura', 254.0000, 'ºC'),
	(78888, 109, '2015-03-01 00:58:16.000000', 'temperatura', 751.0000, 'ºC'),
	(78889, 109, '2015-03-01 00:58:17.000000', 'temperatura', 592.0000, 'ºC'),
	(78890, 109, '2015-03-01 00:58:18.000000', 'temperatura', 710.0000, 'ºC'),
	(78891, 109, '2015-03-01 00:58:19.000000', 'temperatura', 576.0000, 'ºC'),
	(78892, 109, '2015-03-01 00:58:20.000000', 'temperatura', 747.0000, 'ºC'),
	(78893, 109, '2015-03-01 00:58:21.000000', 'temperatura', 810.0000, 'ºC'),
	(78894, 109, '2015-03-01 00:58:22.000000', 'temperatura', 607.0000, 'ºC'),
	(78895, 109, '2015-03-01 00:58:23.000000', 'temperatura', 606.0000, 'ºC'),
	(78896, 109, '2015-03-01 00:58:24.000000', 'temperatura', 11.0000, 'ºC'),
	(78897, 109, '2015-03-01 00:58:25.000000', 'temperatura', 635.0000, 'ºC'),
	(78898, 109, '2015-03-01 00:58:26.000000', 'temperatura', 745.0000, 'ºC'),
	(78899, 109, '2015-03-01 00:58:27.000000', 'temperatura', 620.0000, 'ºC'),
	(78900, 109, '2015-03-01 00:58:28.000000', 'temperatura', 863.0000, 'ºC'),
	(78901, 109, '2015-03-01 00:58:29.000000', 'temperatura', 59.0000, 'ºC'),
	(78902, 109, '2015-03-01 00:58:30.000000', 'temperatura', 104.0000, 'ºC'),
	(78903, 109, '2015-03-01 00:58:31.000000', 'temperatura', 344.0000, 'ºC'),
	(78904, 109, '2015-03-01 00:58:32.000000', 'temperatura', 207.0000, 'ºC'),
	(78905, 109, '2015-03-01 00:58:33.000000', 'temperatura', 4.0000, 'ºC'),
	(78906, 109, '2015-03-01 00:58:34.000000', 'temperatura', 600.0000, 'ºC'),
	(78907, 109, '2015-03-01 00:58:35.000000', 'temperatura', 588.0000, 'ºC'),
	(78908, 109, '2015-03-01 00:58:36.000000', 'temperatura', 1139.0000, 'ºC'),
	(78909, 109, '2015-03-01 00:58:37.000000', 'temperatura', 335.0000, 'ºC'),
	(78910, 109, '2015-03-01 00:58:38.000000', 'temperatura', 655.0000, 'ºC'),
	(78911, 109, '2015-03-01 00:58:39.000000', 'temperatura', 1072.0000, 'ºC'),
	(78912, 109, '2015-03-01 00:58:40.000000', 'temperatura', 994.0000, 'ºC'),
	(78913, 109, '2015-03-01 00:58:41.000000', 'temperatura', 557.0000, 'ºC'),
	(78914, 109, '2015-03-01 00:58:42.000000', 'temperatura', 1004.0000, 'ºC'),
	(78915, 109, '2015-03-01 00:58:43.000000', 'temperatura', 949.0000, 'ºC'),
	(78916, 109, '2015-03-01 00:58:44.000000', 'temperatura', 532.0000, 'ºC'),
	(78917, 109, '2015-03-01 00:58:45.000000', 'temperatura', 1015.0000, 'ºC'),
	(78918, 109, '2015-03-01 00:58:46.000000', 'temperatura', 1078.0000, 'ºC'),
	(78919, 109, '2015-03-01 00:58:47.000000', 'temperatura', 1145.0000, 'ºC'),
	(78920, 109, '2015-03-01 00:58:48.000000', 'temperatura', 91.0000, 'ºC'),
	(78921, 109, '2015-03-01 00:58:49.000000', 'temperatura', 620.0000, 'ºC'),
	(78922, 109, '2015-03-01 00:58:50.000000', 'temperatura', 427.0000, 'ºC'),
	(78923, 109, '2015-03-01 00:58:51.000000', 'temperatura', 275.0000, 'ºC'),
	(78924, 109, '2015-03-01 00:58:52.000000', 'temperatura', 97.0000, 'ºC'),
	(78925, 109, '2015-03-01 00:58:53.000000', 'temperatura', 861.0000, 'ºC'),
	(78926, 109, '2015-03-01 00:58:54.000000', 'temperatura', 412.0000, 'ºC'),
	(78927, 109, '2015-03-01 00:58:55.000000', 'temperatura', 677.0000, 'ºC'),
	(78928, 109, '2015-03-01 00:58:56.000000', 'temperatura', 950.0000, 'ºC'),
	(78929, 109, '2015-03-01 00:58:57.000000', 'temperatura', 320.0000, 'ºC'),
	(78930, 109, '2015-03-01 00:58:58.000000', 'temperatura', 1148.0000, 'ºC'),
	(78931, 109, '2015-03-01 00:58:59.000000', 'temperatura', 1184.0000, 'ºC'),
	(78932, 109, '2015-03-01 00:59:00.000000', 'temperatura', 76.0000, 'ºC'),
	(78933, 109, '2015-03-01 00:59:01.000000', 'temperatura', 429.0000, 'ºC'),
	(78934, 109, '2015-03-01 00:59:02.000000', 'temperatura', 716.0000, 'ºC'),
	(78935, 109, '2015-03-01 00:59:03.000000', 'temperatura', 1093.0000, 'ºC'),
	(78936, 109, '2015-03-01 00:59:04.000000', 'temperatura', 918.0000, 'ºC'),
	(78937, 109, '2015-03-01 00:59:05.000000', 'temperatura', 110.0000, 'ºC'),
	(78938, 109, '2015-03-01 00:59:06.000000', 'temperatura', 199.0000, 'ºC'),
	(78939, 109, '2015-03-01 00:59:07.000000', 'temperatura', 666.0000, 'ºC'),
	(78940, 109, '2015-03-01 00:59:08.000000', 'temperatura', 333.0000, 'ºC'),
	(78941, 109, '2015-03-01 00:59:09.000000', 'temperatura', 868.0000, 'ºC'),
	(78942, 109, '2015-03-01 00:59:10.000000', 'temperatura', 943.0000, 'ºC'),
	(78943, 109, '2015-03-01 00:59:11.000000', 'temperatura', 909.0000, 'ºC'),
	(78944, 109, '2015-03-01 00:59:12.000000', 'temperatura', 519.0000, 'ºC'),
	(78945, 109, '2015-03-01 00:59:13.000000', 'temperatura', 1066.0000, 'ºC'),
	(78946, 109, '2015-03-01 00:59:14.000000', 'temperatura', 173.0000, 'ºC'),
	(78947, 109, '2015-03-01 00:59:15.000000', 'temperatura', 66.0000, 'ºC'),
	(78948, 109, '2015-03-01 00:59:16.000000', 'temperatura', 1015.0000, 'ºC'),
	(78949, 109, '2015-03-01 00:59:17.000000', 'temperatura', 77.0000, 'ºC'),
	(78950, 109, '2015-03-01 00:59:18.000000', 'temperatura', 939.0000, 'ºC'),
	(78951, 109, '2015-03-01 00:59:19.000000', 'temperatura', 867.0000, 'ºC'),
	(78952, 109, '2015-03-01 00:59:20.000000', 'temperatura', 316.0000, 'ºC'),
	(78953, 109, '2015-03-01 00:59:21.000000', 'temperatura', 182.0000, 'ºC'),
	(78954, 109, '2015-03-01 00:59:22.000000', 'temperatura', 1163.0000, 'ºC'),
	(78955, 109, '2015-03-01 00:59:23.000000', 'temperatura', 470.0000, 'ºC'),
	(78956, 109, '2015-03-01 00:59:24.000000', 'temperatura', 61.0000, 'ºC'),
	(78957, 109, '2015-03-01 00:59:25.000000', 'temperatura', 93.0000, 'ºC'),
	(78958, 109, '2015-03-01 00:59:26.000000', 'temperatura', 284.0000, 'ºC'),
	(78959, 109, '2015-03-01 00:59:27.000000', 'temperatura', 1142.0000, 'ºC'),
	(78960, 109, '2015-03-01 00:59:28.000000', 'temperatura', 58.0000, 'ºC'),
	(78961, 109, '2015-03-01 00:59:29.000000', 'temperatura', 463.0000, 'ºC'),
	(78962, 109, '2015-03-01 00:59:30.000000', 'temperatura', 941.0000, 'ºC'),
	(78963, 109, '2015-03-01 00:59:31.000000', 'temperatura', 916.0000, 'ºC'),
	(78964, 109, '2015-03-01 00:59:32.000000', 'temperatura', 560.0000, 'ºC'),
	(78965, 109, '2015-03-01 00:59:33.000000', 'temperatura', 53.0000, 'ºC'),
	(78966, 109, '2015-03-01 00:59:34.000000', 'temperatura', 984.0000, 'ºC'),
	(78967, 109, '2015-03-01 00:59:35.000000', 'temperatura', 1163.0000, 'ºC'),
	(78968, 109, '2015-03-01 00:59:36.000000', 'temperatura', 462.0000, 'ºC'),
	(78969, 109, '2015-03-01 00:59:37.000000', 'temperatura', 22.0000, 'ºC'),
	(78970, 109, '2015-03-01 00:59:38.000000', 'temperatura', 1123.0000, 'ºC'),
	(78971, 109, '2015-03-01 00:59:39.000000', 'temperatura', 750.0000, 'ºC'),
	(78972, 109, '2015-03-01 00:59:40.000000', 'temperatura', 381.0000, 'ºC'),
	(78973, 109, '2015-03-01 00:59:41.000000', 'temperatura', 854.0000, 'ºC'),
	(78974, 109, '2015-03-01 00:59:42.000000', 'temperatura', 730.0000, 'ºC'),
	(78975, 109, '2015-03-01 00:59:43.000000', 'temperatura', 1087.0000, 'ºC'),
	(78976, 109, '2015-03-01 00:59:44.000000', 'temperatura', 845.0000, 'ºC'),
	(78977, 109, '2015-03-01 00:59:45.000000', 'temperatura', 967.0000, 'ºC'),
	(78978, 109, '2015-03-01 00:59:46.000000', 'temperatura', 1098.0000, 'ºC'),
	(78979, 109, '2015-03-01 00:59:47.000000', 'temperatura', 189.0000, 'ºC'),
	(78980, 109, '2015-03-01 00:59:48.000000', 'temperatura', 54.0000, 'ºC'),
	(78981, 109, '2015-03-01 00:59:49.000000', 'temperatura', 903.0000, 'ºC'),
	(78982, 109, '2015-03-01 00:59:50.000000', 'temperatura', 751.0000, 'ºC'),
	(78983, 109, '2015-03-01 00:59:51.000000', 'temperatura', 1049.0000, 'ºC'),
	(78984, 109, '2015-03-01 00:59:52.000000', 'temperatura', 590.0000, 'ºC'),
	(78985, 109, '2015-03-01 00:59:53.000000', 'temperatura', 1005.0000, 'ºC'),
	(78986, 109, '2015-03-01 00:59:54.000000', 'temperatura', 853.0000, 'ºC'),
	(78987, 109, '2015-03-01 00:59:55.000000', 'temperatura', 53.0000, 'ºC'),
	(78988, 109, '2015-03-01 00:59:56.000000', 'temperatura', 106.0000, 'ºC'),
	(78989, 109, '2015-03-01 00:59:57.000000', 'temperatura', 372.0000, 'ºC'),
	(78990, 109, '2015-03-01 00:59:58.000000', 'temperatura', 341.0000, 'ºC'),
	(78991, 109, '2015-03-01 00:59:59.000000', 'temperatura', 590.0000, 'ºC'),
	(78992, 109, '2015-03-01 01:00:00.000000', 'temperatura', 726.0000, 'ºC'),
	(78993, 109, '2015-03-01 01:00:01.000000', 'temperatura', 661.0000, 'ºC'),
	(78994, 109, '2015-03-01 01:00:02.000000', 'temperatura', 1129.0000, 'ºC'),
	(78995, 109, '2015-03-01 01:00:03.000000', 'temperatura', 61.0000, 'ºC'),
	(78996, 109, '2015-03-01 01:00:04.000000', 'temperatura', 520.0000, 'ºC'),
	(78997, 109, '2015-03-01 01:00:05.000000', 'temperatura', 18.0000, 'ºC'),
	(78998, 109, '2015-03-01 01:00:06.000000', 'temperatura', 928.0000, 'ºC'),
	(78999, 109, '2015-03-01 01:00:07.000000', 'temperatura', 989.0000, 'ºC'),
	(79000, 109, '2015-03-01 01:00:08.000000', 'temperatura', 961.0000, 'ºC'),
	(79001, 109, '2015-03-01 01:00:09.000000', 'temperatura', 636.0000, 'ºC'),
	(79002, 109, '2015-03-01 01:00:10.000000', 'temperatura', 300.0000, 'ºC'),
	(79003, 109, '2015-03-01 01:00:11.000000', 'temperatura', 794.0000, 'ºC'),
	(79004, 109, '2015-03-01 01:00:12.000000', 'temperatura', 667.0000, 'ºC'),
	(79005, 109, '2015-03-01 01:00:13.000000', 'temperatura', 954.0000, 'ºC'),
	(79006, 109, '2015-03-01 01:00:14.000000', 'temperatura', 372.0000, 'ºC'),
	(79007, 109, '2015-03-01 01:00:15.000000', 'temperatura', 196.0000, 'ºC'),
	(79008, 109, '2015-03-01 01:00:16.000000', 'temperatura', 1067.0000, 'ºC'),
	(79009, 109, '2015-03-01 01:00:17.000000', 'temperatura', 1145.0000, 'ºC'),
	(79010, 109, '2015-03-01 01:00:18.000000', 'temperatura', 124.0000, 'ºC'),
	(79011, 109, '2015-03-01 01:00:19.000000', 'temperatura', 784.0000, 'ºC'),
	(79012, 109, '2015-03-01 01:00:20.000000', 'temperatura', 1152.0000, 'ºC'),
	(79013, 109, '2015-03-01 01:00:21.000000', 'temperatura', 1008.0000, 'ºC'),
	(79014, 109, '2015-03-01 01:00:22.000000', 'temperatura', 383.0000, 'ºC'),
	(79015, 109, '2015-03-01 01:00:23.000000', 'temperatura', 93.0000, 'ºC'),
	(79016, 109, '2015-03-01 01:00:24.000000', 'temperatura', 517.0000, 'ºC'),
	(79017, 109, '2015-03-01 01:00:25.000000', 'temperatura', 1105.0000, 'ºC'),
	(79018, 109, '2015-03-01 01:00:26.000000', 'temperatura', 373.0000, 'ºC'),
	(79019, 109, '2015-03-01 01:00:27.000000', 'temperatura', 954.0000, 'ºC'),
	(79020, 109, '2015-03-01 01:00:28.000000', 'temperatura', 48.0000, 'ºC'),
	(79021, 109, '2015-03-01 01:00:29.000000', 'temperatura', 980.0000, 'ºC'),
	(79022, 109, '2015-03-01 01:00:30.000000', 'temperatura', 1154.0000, 'ºC'),
	(79023, 109, '2015-03-01 01:00:31.000000', 'temperatura', 434.0000, 'ºC'),
	(79024, 109, '2015-03-01 01:00:32.000000', 'temperatura', 1107.0000, 'ºC'),
	(79025, 109, '2015-03-01 01:00:33.000000', 'temperatura', 634.0000, 'ºC'),
	(79026, 109, '2015-03-01 01:00:34.000000', 'temperatura', 1047.0000, 'ºC'),
	(79027, 109, '2015-03-01 01:00:35.000000', 'temperatura', 937.0000, 'ºC'),
	(79028, 109, '2015-03-01 01:00:36.000000', 'temperatura', 341.0000, 'ºC'),
	(79029, 109, '2015-03-01 01:00:37.000000', 'temperatura', 96.0000, 'ºC'),
	(79030, 109, '2015-03-01 01:00:38.000000', 'temperatura', 659.0000, 'ºC'),
	(79031, 109, '2015-03-01 01:00:39.000000', 'temperatura', 605.0000, 'ºC'),
	(79032, 109, '2015-03-01 01:00:40.000000', 'temperatura', 1048.0000, 'ºC'),
	(79033, 109, '2015-03-01 01:00:41.000000', 'temperatura', 1026.0000, 'ºC'),
	(79034, 109, '2015-03-01 01:00:42.000000', 'temperatura', 786.0000, 'ºC'),
	(79035, 109, '2015-03-01 01:00:43.000000', 'temperatura', 854.0000, 'ºC'),
	(79036, 109, '2015-03-01 01:00:44.000000', 'temperatura', 713.0000, 'ºC'),
	(79037, 109, '2015-03-01 01:00:45.000000', 'temperatura', 1002.0000, 'ºC'),
	(79038, 109, '2015-03-01 01:00:46.000000', 'temperatura', 472.0000, 'ºC'),
	(79039, 109, '2015-03-01 01:00:47.000000', 'temperatura', 556.0000, 'ºC'),
	(79040, 109, '2015-03-01 01:00:48.000000', 'temperatura', 164.0000, 'ºC'),
	(79041, 109, '2015-03-01 01:00:49.000000', 'temperatura', 352.0000, 'ºC'),
	(79042, 109, '2015-03-01 01:00:50.000000', 'temperatura', 70.0000, 'ºC'),
	(79043, 109, '2015-03-01 01:00:51.000000', 'temperatura', 493.0000, 'ºC'),
	(79044, 109, '2015-03-01 01:00:52.000000', 'temperatura', 1056.0000, 'ºC'),
	(79045, 109, '2015-03-01 01:00:53.000000', 'temperatura', 201.0000, 'ºC'),
	(79046, 109, '2015-03-01 01:00:54.000000', 'temperatura', 239.0000, 'ºC'),
	(79047, 109, '2015-03-01 01:00:55.000000', 'temperatura', 593.0000, 'ºC'),
	(79048, 109, '2015-03-01 01:00:56.000000', 'temperatura', 1048.0000, 'ºC'),
	(79049, 109, '2015-03-01 01:00:57.000000', 'temperatura', 1063.0000, 'ºC'),
	(79050, 109, '2015-03-01 01:00:58.000000', 'temperatura', 969.0000, 'ºC'),
	(79051, 109, '2015-03-01 01:00:59.000000', 'temperatura', 457.0000, 'ºC'),
	(79052, 109, '2015-03-01 01:01:00.000000', 'temperatura', 581.0000, 'ºC'),
	(79053, 109, '2015-03-01 01:01:01.000000', 'temperatura', 331.0000, 'ºC'),
	(79054, 109, '2015-03-01 01:01:02.000000', 'temperatura', 1114.0000, 'ºC'),
	(79055, 109, '2015-03-01 01:01:03.000000', 'temperatura', 978.0000, 'ºC'),
	(79056, 109, '2015-03-01 01:01:04.000000', 'temperatura', 350.0000, 'ºC'),
	(79057, 109, '2015-03-01 01:01:05.000000', 'temperatura', 16.0000, 'ºC'),
	(79058, 109, '2015-03-01 01:01:06.000000', 'temperatura', 230.0000, 'ºC'),
	(79059, 109, '2015-03-01 01:01:07.000000', 'temperatura', 1102.0000, 'ºC'),
	(79060, 109, '2015-03-01 01:01:08.000000', 'temperatura', 23.0000, 'ºC'),
	(79061, 109, '2015-03-01 01:01:09.000000', 'temperatura', 407.0000, 'ºC'),
	(79062, 109, '2015-03-01 01:01:10.000000', 'temperatura', 765.0000, 'ºC'),
	(79063, 109, '2015-03-01 01:01:11.000000', 'temperatura', 207.0000, 'ºC'),
	(79064, 109, '2015-03-01 01:01:12.000000', 'temperatura', 1140.0000, 'ºC'),
	(79065, 109, '2015-03-01 01:01:13.000000', 'temperatura', 278.0000, 'ºC'),
	(79066, 109, '2015-03-01 01:01:14.000000', 'temperatura', 373.0000, 'ºC'),
	(79067, 109, '2015-03-01 01:01:15.000000', 'temperatura', 1028.0000, 'ºC'),
	(79068, 109, '2015-03-01 01:01:16.000000', 'temperatura', 425.0000, 'ºC'),
	(79069, 109, '2015-03-01 01:01:17.000000', 'temperatura', 240.0000, 'ºC'),
	(79070, 109, '2015-03-01 01:01:18.000000', 'temperatura', 1127.0000, 'ºC'),
	(79071, 109, '2015-03-01 01:01:19.000000', 'temperatura', 115.0000, 'ºC'),
	(79072, 109, '2015-03-01 01:01:20.000000', 'temperatura', 794.0000, 'ºC'),
	(79073, 109, '2015-03-01 01:01:21.000000', 'temperatura', 24.0000, 'ºC'),
	(79074, 109, '2015-03-01 01:01:22.000000', 'temperatura', 138.0000, 'ºC'),
	(79075, 109, '2015-03-01 01:01:23.000000', 'temperatura', 618.0000, 'ºC'),
	(79076, 109, '2015-03-01 01:01:24.000000', 'temperatura', 277.0000, 'ºC'),
	(79077, 109, '2015-03-01 01:01:25.000000', 'temperatura', 730.0000, 'ºC'),
	(79078, 109, '2015-03-01 01:01:26.000000', 'temperatura', 422.0000, 'ºC'),
	(79079, 109, '2015-03-01 01:01:27.000000', 'temperatura', 1120.0000, 'ºC'),
	(79080, 109, '2015-03-01 01:01:28.000000', 'temperatura', 734.0000, 'ºC'),
	(79081, 109, '2015-03-01 01:01:29.000000', 'temperatura', 310.0000, 'ºC'),
	(79082, 109, '2015-03-01 01:01:30.000000', 'temperatura', 551.0000, 'ºC'),
	(79083, 109, '2015-03-01 01:01:31.000000', 'temperatura', 625.0000, 'ºC'),
	(79084, 109, '2015-03-01 01:01:32.000000', 'temperatura', 271.0000, 'ºC'),
	(79085, 109, '2015-03-01 01:01:33.000000', 'temperatura', 679.0000, 'ºC'),
	(79086, 109, '2015-03-01 01:01:34.000000', 'temperatura', 185.0000, 'ºC'),
	(79087, 109, '2015-03-01 01:01:35.000000', 'temperatura', 88.0000, 'ºC'),
	(79088, 109, '2015-03-01 01:01:36.000000', 'temperatura', 1087.0000, 'ºC'),
	(79089, 109, '2015-03-01 01:01:37.000000', 'temperatura', 370.0000, 'ºC'),
	(79090, 109, '2015-03-01 01:01:38.000000', 'temperatura', 989.0000, 'ºC'),
	(79091, 109, '2015-03-01 01:01:39.000000', 'temperatura', 234.0000, 'ºC'),
	(79092, 109, '2015-03-01 01:01:40.000000', 'temperatura', 607.0000, 'ºC'),
	(79093, 109, '2015-03-01 01:01:41.000000', 'temperatura', 1132.0000, 'ºC'),
	(79094, 109, '2015-03-01 01:01:42.000000', 'temperatura', 238.0000, 'ºC'),
	(79095, 109, '2015-03-01 01:01:43.000000', 'temperatura', 194.0000, 'ºC'),
	(79096, 109, '2015-03-01 01:01:44.000000', 'temperatura', 259.0000, 'ºC'),
	(79097, 109, '2015-03-01 01:01:45.000000', 'temperatura', 714.0000, 'ºC'),
	(79098, 109, '2015-03-01 01:01:46.000000', 'temperatura', 393.0000, 'ºC'),
	(79099, 109, '2015-03-01 01:01:47.000000', 'temperatura', 1023.0000, 'ºC'),
	(79100, 109, '2015-03-01 01:01:48.000000', 'temperatura', 335.0000, 'ºC'),
	(79101, 109, '2015-03-01 01:01:49.000000', 'temperatura', 1008.0000, 'ºC'),
	(79102, 109, '2015-03-01 01:01:50.000000', 'temperatura', 433.0000, 'ºC'),
	(79103, 109, '2015-03-01 01:01:51.000000', 'temperatura', 343.0000, 'ºC'),
	(79104, 109, '2015-03-01 01:01:52.000000', 'temperatura', 418.0000, 'ºC'),
	(79105, 109, '2015-03-01 01:01:53.000000', 'temperatura', 1062.0000, 'ºC'),
	(79106, 109, '2015-03-01 01:01:54.000000', 'temperatura', 453.0000, 'ºC'),
	(79107, 109, '2015-03-01 01:01:55.000000', 'temperatura', 283.0000, 'ºC'),
	(79108, 109, '2015-03-01 01:01:56.000000', 'temperatura', 54.0000, 'ºC'),
	(79109, 109, '2015-03-01 01:01:57.000000', 'temperatura', 622.0000, 'ºC'),
	(79110, 109, '2015-03-01 01:01:58.000000', 'temperatura', 550.0000, 'ºC'),
	(79111, 109, '2015-03-01 01:01:59.000000', 'temperatura', 886.0000, 'ºC'),
	(79112, 109, '2015-03-01 01:02:00.000000', 'temperatura', 377.0000, 'ºC'),
	(79113, 109, '2015-03-01 01:02:01.000000', 'temperatura', 429.0000, 'ºC'),
	(79114, 109, '2015-03-01 01:02:02.000000', 'temperatura', 1015.0000, 'ºC'),
	(79115, 109, '2015-03-01 01:02:03.000000', 'temperatura', 188.0000, 'ºC'),
	(79116, 109, '2015-03-01 01:02:04.000000', 'temperatura', 293.0000, 'ºC'),
	(79117, 109, '2015-03-01 01:02:05.000000', 'temperatura', 905.0000, 'ºC'),
	(79118, 109, '2015-03-01 01:02:06.000000', 'temperatura', 47.0000, 'ºC'),
	(79119, 109, '2015-03-01 01:02:07.000000', 'temperatura', 1118.0000, 'ºC'),
	(79120, 109, '2015-03-01 01:02:08.000000', 'temperatura', 652.0000, 'ºC'),
	(79121, 109, '2015-03-01 01:02:09.000000', 'temperatura', 1105.0000, 'ºC'),
	(79122, 109, '2015-03-01 01:02:10.000000', 'temperatura', 1170.0000, 'ºC'),
	(79123, 109, '2015-03-01 01:02:11.000000', 'temperatura', 135.0000, 'ºC'),
	(79124, 109, '2015-03-01 01:02:12.000000', 'temperatura', 764.0000, 'ºC'),
	(79125, 109, '2015-03-01 01:02:13.000000', 'temperatura', 1018.0000, 'ºC'),
	(79126, 109, '2015-03-01 01:02:14.000000', 'temperatura', 399.0000, 'ºC'),
	(79127, 109, '2015-03-01 01:02:15.000000', 'temperatura', 140.0000, 'ºC'),
	(79128, 109, '2015-03-01 01:02:16.000000', 'temperatura', 702.0000, 'ºC'),
	(79129, 109, '2015-03-01 01:02:17.000000', 'temperatura', 692.0000, 'ºC'),
	(79130, 109, '2015-03-01 01:02:18.000000', 'temperatura', 155.0000, 'ºC'),
	(79131, 109, '2015-03-01 01:02:19.000000', 'temperatura', 1100.0000, 'ºC'),
	(79132, 109, '2015-03-01 01:02:20.000000', 'temperatura', 234.0000, 'ºC'),
	(79133, 109, '2015-03-01 01:02:21.000000', 'temperatura', 270.0000, 'ºC'),
	(79134, 109, '2015-03-01 01:02:22.000000', 'temperatura', 651.0000, 'ºC'),
	(79135, 109, '2015-03-01 01:02:23.000000', 'temperatura', 45.0000, 'ºC'),
	(79136, 109, '2015-03-01 01:02:24.000000', 'temperatura', 672.0000, 'ºC'),
	(79137, 109, '2015-03-01 01:02:25.000000', 'temperatura', 827.0000, 'ºC'),
	(79138, 109, '2015-03-01 01:02:26.000000', 'temperatura', 919.0000, 'ºC'),
	(79139, 109, '2015-03-01 01:02:27.000000', 'temperatura', 913.0000, 'ºC'),
	(79140, 109, '2015-03-01 01:02:28.000000', 'temperatura', 607.0000, 'ºC'),
	(79141, 109, '2015-03-01 01:02:29.000000', 'temperatura', 299.0000, 'ºC'),
	(79142, 109, '2015-03-01 01:02:30.000000', 'temperatura', 876.0000, 'ºC'),
	(79143, 109, '2015-03-01 01:02:31.000000', 'temperatura', 1080.0000, 'ºC'),
	(79144, 109, '2015-03-01 01:02:32.000000', 'temperatura', 375.0000, 'ºC'),
	(79145, 109, '2015-03-01 01:02:33.000000', 'temperatura', 1034.0000, 'ºC'),
	(79146, 109, '2015-03-01 01:02:34.000000', 'temperatura', 446.0000, 'ºC'),
	(79147, 109, '2015-03-01 01:02:35.000000', 'temperatura', 330.0000, 'ºC'),
	(79148, 109, '2015-03-01 01:02:36.000000', 'temperatura', 313.0000, 'ºC'),
	(79149, 109, '2015-03-01 01:02:37.000000', 'temperatura', 575.0000, 'ºC'),
	(79150, 109, '2015-03-01 01:02:38.000000', 'temperatura', 736.0000, 'ºC'),
	(79151, 109, '2015-03-01 01:02:39.000000', 'temperatura', 755.0000, 'ºC'),
	(79152, 109, '2015-03-01 01:02:40.000000', 'temperatura', 366.0000, 'ºC'),
	(79153, 109, '2015-03-01 01:02:41.000000', 'temperatura', 768.0000, 'ºC'),
	(79154, 109, '2015-03-01 01:02:42.000000', 'temperatura', 342.0000, 'ºC'),
	(79155, 109, '2015-03-01 01:02:43.000000', 'temperatura', 607.0000, 'ºC'),
	(79156, 109, '2015-03-01 01:02:44.000000', 'temperatura', 811.0000, 'ºC'),
	(79157, 109, '2015-03-01 01:02:45.000000', 'temperatura', 1031.0000, 'ºC'),
	(79158, 109, '2015-03-01 01:02:46.000000', 'temperatura', 326.0000, 'ºC'),
	(79159, 109, '2015-03-01 01:02:47.000000', 'temperatura', 936.0000, 'ºC'),
	(79160, 109, '2015-03-01 01:02:48.000000', 'temperatura', 104.0000, 'ºC'),
	(79161, 109, '2015-03-01 01:02:49.000000', 'temperatura', 111.0000, 'ºC'),
	(79162, 109, '2015-03-01 01:02:50.000000', 'temperatura', 243.0000, 'ºC'),
	(79163, 109, '2015-03-01 01:02:51.000000', 'temperatura', 884.0000, 'ºC'),
	(79164, 109, '2015-03-01 01:02:52.000000', 'temperatura', 92.0000, 'ºC'),
	(79165, 109, '2015-03-01 01:02:53.000000', 'temperatura', 209.0000, 'ºC'),
	(79166, 109, '2015-03-01 01:02:54.000000', 'temperatura', 769.0000, 'ºC'),
	(79167, 109, '2015-03-01 01:02:55.000000', 'temperatura', 819.0000, 'ºC'),
	(79168, 109, '2015-03-01 01:02:56.000000', 'temperatura', 586.0000, 'ºC'),
	(79169, 109, '2015-03-01 01:02:57.000000', 'temperatura', 477.0000, 'ºC'),
	(79170, 109, '2015-03-01 01:02:58.000000', 'temperatura', 625.0000, 'ºC'),
	(79171, 109, '2015-03-01 01:02:59.000000', 'temperatura', 495.0000, 'ºC'),
	(79172, 109, '2015-03-01 01:03:00.000000', 'temperatura', 599.0000, 'ºC'),
	(79173, 109, '2015-03-01 01:03:01.000000', 'temperatura', 310.0000, 'ºC'),
	(79174, 109, '2015-03-01 01:03:02.000000', 'temperatura', 954.0000, 'ºC'),
	(79175, 109, '2015-03-01 01:03:03.000000', 'temperatura', 242.0000, 'ºC'),
	(79176, 109, '2015-03-01 01:03:04.000000', 'temperatura', 746.0000, 'ºC'),
	(79177, 109, '2015-03-01 01:03:05.000000', 'temperatura', 604.0000, 'ºC'),
	(79178, 109, '2015-03-01 01:03:06.000000', 'temperatura', 786.0000, 'ºC'),
	(79179, 109, '2015-03-01 01:03:07.000000', 'temperatura', 915.0000, 'ºC'),
	(79180, 109, '2015-03-01 01:03:08.000000', 'temperatura', 1020.0000, 'ºC'),
	(79181, 109, '2015-03-01 01:03:09.000000', 'temperatura', 1155.0000, 'ºC'),
	(79182, 109, '2015-03-01 01:03:10.000000', 'temperatura', 314.0000, 'ºC'),
	(79183, 109, '2015-03-01 01:03:11.000000', 'temperatura', 508.0000, 'ºC'),
	(79184, 109, '2015-03-01 01:03:12.000000', 'temperatura', 398.0000, 'ºC'),
	(79185, 109, '2015-03-01 01:03:13.000000', 'temperatura', 466.0000, 'ºC'),
	(79186, 109, '2015-03-01 01:03:14.000000', 'temperatura', 1135.0000, 'ºC'),
	(79187, 109, '2015-03-01 01:03:15.000000', 'temperatura', 679.0000, 'ºC'),
	(79188, 109, '2015-03-01 01:03:16.000000', 'temperatura', 1189.0000, 'ºC'),
	(79189, 109, '2015-03-01 01:03:17.000000', 'temperatura', 311.0000, 'ºC'),
	(79190, 109, '2015-03-01 01:03:18.000000', 'temperatura', 389.0000, 'ºC'),
	(79191, 109, '2015-03-01 01:03:19.000000', 'temperatura', 1012.0000, 'ºC'),
	(79192, 109, '2015-03-01 01:03:20.000000', 'temperatura', 292.0000, 'ºC'),
	(79193, 109, '2015-03-01 01:03:21.000000', 'temperatura', 826.0000, 'ºC'),
	(79194, 109, '2015-03-01 01:03:22.000000', 'temperatura', 853.0000, 'ºC'),
	(79195, 109, '2015-03-01 01:03:23.000000', 'temperatura', 587.0000, 'ºC'),
	(79196, 109, '2015-03-01 01:03:24.000000', 'temperatura', 377.0000, 'ºC'),
	(79197, 109, '2015-03-01 01:03:25.000000', 'temperatura', 124.0000, 'ºC'),
	(79198, 109, '2015-03-01 01:03:26.000000', 'temperatura', 690.0000, 'ºC'),
	(79199, 109, '2015-03-01 01:03:27.000000', 'temperatura', 681.0000, 'ºC'),
	(79200, 109, '2015-03-01 01:03:28.000000', 'temperatura', 132.0000, 'ºC'),
	(79201, 109, '2015-03-01 01:03:29.000000', 'temperatura', 1017.0000, 'ºC'),
	(79202, 109, '2015-03-01 01:03:30.000000', 'temperatura', 1092.0000, 'ºC'),
	(79203, 109, '2015-03-01 01:03:31.000000', 'temperatura', 9.0000, 'ºC'),
	(79204, 109, '2015-03-01 01:03:32.000000', 'temperatura', 371.0000, 'ºC'),
	(79205, 109, '2015-03-01 01:03:33.000000', 'temperatura', 627.0000, 'ºC'),
	(79206, 109, '2015-03-01 01:03:34.000000', 'temperatura', 824.0000, 'ºC'),
	(79207, 109, '2015-03-01 01:03:35.000000', 'temperatura', 1039.0000, 'ºC'),
	(79208, 109, '2015-03-01 01:03:36.000000', 'temperatura', 322.0000, 'ºC'),
	(79209, 109, '2015-03-01 01:03:37.000000', 'temperatura', 895.0000, 'ºC'),
	(79210, 109, '2015-03-01 01:03:38.000000', 'temperatura', 1109.0000, 'ºC'),
	(79211, 109, '2015-03-01 01:03:39.000000', 'temperatura', 460.0000, 'ºC'),
	(79212, 109, '2015-03-01 01:03:40.000000', 'temperatura', 172.0000, 'ºC'),
	(79213, 109, '2015-03-01 01:03:41.000000', 'temperatura', 684.0000, 'ºC'),
	(79214, 109, '2015-03-01 01:03:42.000000', 'temperatura', 503.0000, 'ºC'),
	(79215, 109, '2015-03-01 01:03:43.000000', 'temperatura', 462.0000, 'ºC'),
	(79216, 109, '2015-03-01 01:03:44.000000', 'temperatura', 802.0000, 'ºC'),
	(79217, 109, '2015-03-01 01:03:45.000000', 'temperatura', 223.0000, 'ºC'),
	(79218, 109, '2015-03-01 01:03:46.000000', 'temperatura', 1112.0000, 'ºC'),
	(79219, 109, '2015-03-01 01:03:47.000000', 'temperatura', 89.0000, 'ºC'),
	(79220, 109, '2015-03-01 01:03:48.000000', 'temperatura', 710.0000, 'ºC'),
	(79221, 109, '2015-03-01 01:03:49.000000', 'temperatura', 886.0000, 'ºC'),
	(79222, 109, '2015-03-01 01:03:50.000000', 'temperatura', 1097.0000, 'ºC'),
	(79223, 109, '2015-03-01 01:03:51.000000', 'temperatura', 430.0000, 'ºC'),
	(79224, 109, '2015-03-01 01:03:52.000000', 'temperatura', 57.0000, 'ºC'),
	(79225, 109, '2015-03-01 01:03:53.000000', 'temperatura', 198.0000, 'ºC'),
	(79226, 109, '2015-03-01 01:03:54.000000', 'temperatura', 819.0000, 'ºC'),
	(79227, 109, '2015-03-01 01:03:55.000000', 'temperatura', 1100.0000, 'ºC'),
	(79228, 109, '2015-03-01 01:03:56.000000', 'temperatura', 644.0000, 'ºC'),
	(79229, 109, '2015-03-01 01:03:57.000000', 'temperatura', 1120.0000, 'ºC'),
	(79230, 109, '2015-03-01 01:03:58.000000', 'temperatura', 68.0000, 'ºC'),
	(79231, 109, '2015-03-01 01:03:59.000000', 'temperatura', 581.0000, 'ºC'),
	(79232, 109, '2015-03-01 01:04:00.000000', 'temperatura', 301.0000, 'ºC'),
	(79233, 109, '2015-03-01 01:04:01.000000', 'temperatura', 963.0000, 'ºC'),
	(79234, 109, '2015-03-01 01:04:02.000000', 'temperatura', 311.0000, 'ºC'),
	(79235, 109, '2015-03-01 01:04:03.000000', 'temperatura', 1068.0000, 'ºC'),
	(79236, 109, '2015-03-01 01:04:04.000000', 'temperatura', 805.0000, 'ºC'),
	(79237, 109, '2015-03-01 01:04:05.000000', 'temperatura', 825.0000, 'ºC'),
	(79238, 109, '2015-03-01 01:04:06.000000', 'temperatura', 508.0000, 'ºC'),
	(79239, 109, '2015-03-01 01:04:07.000000', 'temperatura', 64.0000, 'ºC'),
	(79240, 109, '2015-03-01 01:04:08.000000', 'temperatura', 0.0000, 'ºC'),
	(79241, 109, '2015-03-01 01:04:09.000000', 'temperatura', 1007.0000, 'ºC'),
	(79242, 109, '2015-03-01 01:04:10.000000', 'temperatura', 236.0000, 'ºC'),
	(79243, 109, '2015-03-01 01:04:11.000000', 'temperatura', 559.0000, 'ºC'),
	(79244, 109, '2015-03-01 01:04:12.000000', 'temperatura', 888.0000, 'ºC'),
	(79245, 109, '2015-03-01 01:04:13.000000', 'temperatura', 361.0000, 'ºC'),
	(79246, 109, '2015-03-01 01:04:14.000000', 'temperatura', 344.0000, 'ºC'),
	(79247, 109, '2015-03-01 01:04:15.000000', 'temperatura', 637.0000, 'ºC'),
	(79248, 109, '2015-03-01 01:04:16.000000', 'temperatura', 955.0000, 'ºC'),
	(79249, 109, '2015-03-01 01:04:17.000000', 'temperatura', 465.0000, 'ºC'),
	(79250, 109, '2015-03-01 01:04:18.000000', 'temperatura', 659.0000, 'ºC'),
	(79251, 109, '2015-03-01 01:04:19.000000', 'temperatura', 700.0000, 'ºC'),
	(79252, 109, '2015-03-01 01:04:20.000000', 'temperatura', 325.0000, 'ºC'),
	(79253, 109, '2015-03-01 01:04:21.000000', 'temperatura', 724.0000, 'ºC'),
	(79254, 109, '2015-03-01 01:04:22.000000', 'temperatura', 247.0000, 'ºC'),
	(79255, 109, '2015-03-01 01:04:23.000000', 'temperatura', 261.0000, 'ºC'),
	(79256, 109, '2015-03-01 01:04:24.000000', 'temperatura', 567.0000, 'ºC'),
	(79257, 109, '2015-03-01 01:04:25.000000', 'temperatura', 853.0000, 'ºC'),
	(79258, 109, '2015-03-01 01:04:26.000000', 'temperatura', 165.0000, 'ºC'),
	(79259, 109, '2015-03-01 01:04:27.000000', 'temperatura', 664.0000, 'ºC'),
	(79260, 109, '2015-03-01 01:04:28.000000', 'temperatura', 428.0000, 'ºC'),
	(79261, 109, '2015-03-01 01:04:29.000000', 'temperatura', 147.0000, 'ºC'),
	(79262, 109, '2015-03-01 01:04:30.000000', 'temperatura', 653.0000, 'ºC'),
	(79263, 109, '2015-03-01 01:04:31.000000', 'temperatura', 425.0000, 'ºC'),
	(79264, 109, '2015-03-01 01:04:32.000000', 'temperatura', 165.0000, 'ºC'),
	(79265, 109, '2015-03-01 01:04:33.000000', 'temperatura', 751.0000, 'ºC'),
	(79266, 109, '2015-03-01 01:04:34.000000', 'temperatura', 861.0000, 'ºC'),
	(79267, 109, '2015-03-01 01:04:35.000000', 'temperatura', 852.0000, 'ºC'),
	(79268, 109, '2015-03-01 01:04:36.000000', 'temperatura', 477.0000, 'ºC'),
	(79269, 109, '2015-03-01 01:04:37.000000', 'temperatura', 1031.0000, 'ºC'),
	(79270, 109, '2015-03-01 01:04:38.000000', 'temperatura', 125.0000, 'ºC'),
	(79271, 109, '2015-03-01 01:04:39.000000', 'temperatura', 1133.0000, 'ºC'),
	(79272, 109, '2015-03-01 01:04:40.000000', 'temperatura', 488.0000, 'ºC'),
	(79273, 109, '2015-03-01 01:04:41.000000', 'temperatura', 244.0000, 'ºC'),
	(79274, 109, '2015-03-01 01:04:42.000000', 'temperatura', 958.0000, 'ºC'),
	(79275, 109, '2015-03-01 01:04:43.000000', 'temperatura', 455.0000, 'ºC'),
	(79276, 109, '2015-03-01 01:04:44.000000', 'temperatura', 603.0000, 'ºC'),
	(79277, 109, '2015-03-01 01:04:45.000000', 'temperatura', 450.0000, 'ºC'),
	(79278, 109, '2015-03-01 01:04:46.000000', 'temperatura', 441.0000, 'ºC'),
	(79279, 109, '2015-03-01 01:04:47.000000', 'temperatura', 855.0000, 'ºC'),
	(79280, 109, '2015-03-01 01:04:48.000000', 'temperatura', 552.0000, 'ºC'),
	(79281, 109, '2015-03-01 01:04:49.000000', 'temperatura', 196.0000, 'ºC'),
	(79282, 109, '2015-03-01 01:04:50.000000', 'temperatura', 526.0000, 'ºC'),
	(79283, 109, '2015-03-01 01:04:51.000000', 'temperatura', 840.0000, 'ºC'),
	(79284, 109, '2015-03-01 01:04:52.000000', 'temperatura', 223.0000, 'ºC'),
	(79285, 109, '2015-03-01 01:04:53.000000', 'temperatura', 995.0000, 'ºC'),
	(79286, 109, '2015-03-01 01:04:54.000000', 'temperatura', 706.0000, 'ºC'),
	(79287, 109, '2015-03-01 01:04:55.000000', 'temperatura', 546.0000, 'ºC'),
	(79288, 109, '2015-03-01 01:04:56.000000', 'temperatura', 612.0000, 'ºC'),
	(79289, 109, '2015-03-01 01:04:57.000000', 'temperatura', 225.0000, 'ºC'),
	(79290, 109, '2015-03-01 01:04:58.000000', 'temperatura', 487.0000, 'ºC'),
	(79291, 109, '2015-03-01 01:04:59.000000', 'temperatura', 562.0000, 'ºC'),
	(79292, 109, '2015-03-01 01:05:00.000000', 'temperatura', 148.0000, 'ºC'),
	(79293, 109, '2015-03-01 01:05:01.000000', 'temperatura', 256.0000, 'ºC'),
	(79294, 109, '2015-03-01 01:05:02.000000', 'temperatura', 834.0000, 'ºC'),
	(79295, 109, '2015-03-01 01:05:03.000000', 'temperatura', 1005.0000, 'ºC'),
	(79296, 109, '2015-03-01 01:05:04.000000', 'temperatura', 124.0000, 'ºC'),
	(79297, 109, '2015-03-01 01:05:05.000000', 'temperatura', 4.0000, 'ºC'),
	(79298, 109, '2015-03-01 01:05:06.000000', 'temperatura', 850.0000, 'ºC'),
	(79299, 109, '2015-03-01 01:05:07.000000', 'temperatura', 638.0000, 'ºC'),
	(79300, 109, '2015-03-01 01:05:08.000000', 'temperatura', 642.0000, 'ºC'),
	(79301, 109, '2015-03-01 01:05:09.000000', 'temperatura', 93.0000, 'ºC'),
	(79302, 109, '2015-03-01 01:05:10.000000', 'temperatura', 942.0000, 'ºC'),
	(79303, 109, '2015-03-01 01:05:11.000000', 'temperatura', 830.0000, 'ºC'),
	(79304, 109, '2015-03-01 01:05:12.000000', 'temperatura', 127.0000, 'ºC'),
	(79305, 109, '2015-03-01 01:05:13.000000', 'temperatura', 545.0000, 'ºC'),
	(79306, 109, '2015-03-01 01:05:14.000000', 'temperatura', 1144.0000, 'ºC'),
	(79307, 109, '2015-03-01 01:05:15.000000', 'temperatura', 484.0000, 'ºC'),
	(79308, 109, '2015-03-01 01:05:16.000000', 'temperatura', 189.0000, 'ºC'),
	(79309, 109, '2015-03-01 01:05:17.000000', 'temperatura', 693.0000, 'ºC'),
	(79310, 109, '2015-03-01 01:05:18.000000', 'temperatura', 501.0000, 'ºC'),
	(79311, 109, '2015-03-01 01:05:19.000000', 'temperatura', 424.0000, 'ºC'),
	(79312, 109, '2015-03-01 01:05:20.000000', 'temperatura', 618.0000, 'ºC'),
	(79313, 109, '2015-03-01 01:05:21.000000', 'temperatura', 618.0000, 'ºC'),
	(79314, 109, '2015-03-01 01:05:22.000000', 'temperatura', 39.0000, 'ºC'),
	(79315, 109, '2015-03-01 01:05:23.000000', 'temperatura', 740.0000, 'ºC'),
	(79316, 109, '2015-03-01 01:05:24.000000', 'temperatura', 1182.0000, 'ºC'),
	(79317, 109, '2015-03-01 01:05:25.000000', 'temperatura', 92.0000, 'ºC'),
	(79318, 109, '2015-03-01 01:05:26.000000', 'temperatura', 512.0000, 'ºC'),
	(79319, 109, '2015-03-01 01:05:27.000000', 'temperatura', 1088.0000, 'ºC'),
	(79320, 109, '2015-03-01 01:05:28.000000', 'temperatura', 302.0000, 'ºC'),
	(79321, 109, '2015-03-01 01:05:29.000000', 'temperatura', 646.0000, 'ºC'),
	(79322, 109, '2015-03-01 01:05:30.000000', 'temperatura', 1127.0000, 'ºC'),
	(79323, 109, '2015-03-01 01:05:31.000000', 'temperatura', 97.0000, 'ºC'),
	(79324, 109, '2015-03-01 01:05:32.000000', 'temperatura', 702.0000, 'ºC'),
	(79325, 109, '2015-03-01 01:05:33.000000', 'temperatura', 823.0000, 'ºC'),
	(79326, 109, '2015-03-01 01:05:34.000000', 'temperatura', 808.0000, 'ºC'),
	(79327, 109, '2015-03-01 01:05:35.000000', 'temperatura', 371.0000, 'ºC'),
	(79328, 109, '2015-03-01 01:05:36.000000', 'temperatura', 631.0000, 'ºC'),
	(79329, 109, '2015-03-01 01:05:37.000000', 'temperatura', 844.0000, 'ºC'),
	(79330, 109, '2015-03-01 01:05:38.000000', 'temperatura', 1126.0000, 'ºC'),
	(79331, 109, '2015-03-01 01:05:39.000000', 'temperatura', 701.0000, 'ºC'),
	(79332, 109, '2015-03-01 01:05:40.000000', 'temperatura', 127.0000, 'ºC'),
	(79333, 109, '2015-03-01 01:05:41.000000', 'temperatura', 932.0000, 'ºC'),
	(79334, 109, '2015-03-01 01:05:42.000000', 'temperatura', 679.0000, 'ºC'),
	(79335, 109, '2015-03-01 01:05:43.000000', 'temperatura', 598.0000, 'ºC'),
	(79336, 109, '2015-03-01 01:05:44.000000', 'temperatura', 954.0000, 'ºC'),
	(79337, 109, '2015-03-01 01:05:45.000000', 'temperatura', 577.0000, 'ºC'),
	(79338, 109, '2015-03-01 01:05:46.000000', 'temperatura', 21.0000, 'ºC'),
	(79339, 109, '2015-03-01 01:05:47.000000', 'temperatura', 778.0000, 'ºC'),
	(79340, 109, '2015-03-01 01:05:48.000000', 'temperatura', 228.0000, 'ºC'),
	(79341, 109, '2015-03-01 01:05:49.000000', 'temperatura', 4.0000, 'ºC'),
	(79342, 109, '2015-03-01 01:05:50.000000', 'temperatura', 539.0000, 'ºC'),
	(79343, 109, '2015-03-01 01:05:51.000000', 'temperatura', 281.0000, 'ºC'),
	(79344, 109, '2015-03-01 01:05:52.000000', 'temperatura', 989.0000, 'ºC'),
	(79345, 109, '2015-03-01 01:05:53.000000', 'temperatura', 505.0000, 'ºC'),
	(79346, 109, '2015-03-01 01:05:54.000000', 'temperatura', 757.0000, 'ºC'),
	(79347, 109, '2015-03-01 01:05:55.000000', 'temperatura', 1069.0000, 'ºC'),
	(79348, 109, '2015-03-01 01:05:56.000000', 'temperatura', 675.0000, 'ºC'),
	(79349, 109, '2015-03-01 01:05:57.000000', 'temperatura', 167.0000, 'ºC'),
	(79350, 109, '2015-03-01 01:05:58.000000', 'temperatura', 12.0000, 'ºC'),
	(79351, 109, '2015-03-01 01:05:59.000000', 'temperatura', 761.0000, 'ºC'),
	(79352, 109, '2015-03-01 01:06:00.000000', 'temperatura', 167.0000, 'ºC'),
	(79353, 109, '2015-03-01 01:06:01.000000', 'temperatura', 954.0000, 'ºC'),
	(79354, 109, '2015-03-01 01:06:02.000000', 'temperatura', 670.0000, 'ºC'),
	(79355, 109, '2015-03-01 01:06:03.000000', 'temperatura', 487.0000, 'ºC'),
	(79356, 109, '2015-03-01 01:06:04.000000', 'temperatura', 427.0000, 'ºC'),
	(79357, 109, '2015-03-01 01:06:05.000000', 'temperatura', 674.0000, 'ºC'),
	(79358, 109, '2015-03-01 01:06:06.000000', 'temperatura', 891.0000, 'ºC'),
	(79359, 109, '2015-03-01 01:06:07.000000', 'temperatura', 33.0000, 'ºC'),
	(79360, 109, '2015-03-01 01:06:08.000000', 'temperatura', 1092.0000, 'ºC'),
	(79361, 109, '2015-03-01 01:06:09.000000', 'temperatura', 560.0000, 'ºC'),
	(79362, 109, '2015-03-01 01:06:10.000000', 'temperatura', 724.0000, 'ºC'),
	(79363, 109, '2015-03-01 01:06:11.000000', 'temperatura', 743.0000, 'ºC'),
	(79364, 109, '2015-03-01 01:06:12.000000', 'temperatura', 343.0000, 'ºC'),
	(79365, 109, '2015-03-01 01:06:13.000000', 'temperatura', 688.0000, 'ºC'),
	(79366, 109, '2015-03-01 01:06:14.000000', 'temperatura', 10.0000, 'ºC'),
	(79367, 109, '2015-03-01 01:06:15.000000', 'temperatura', 388.0000, 'ºC'),
	(79368, 109, '2015-03-01 01:06:16.000000', 'temperatura', 710.0000, 'ºC'),
	(79369, 109, '2015-03-01 01:06:17.000000', 'temperatura', 1186.0000, 'ºC'),
	(79370, 109, '2015-03-01 01:06:18.000000', 'temperatura', 201.0000, 'ºC'),
	(79371, 109, '2015-03-01 01:06:19.000000', 'temperatura', 1047.0000, 'ºC'),
	(79372, 109, '2015-03-01 01:06:20.000000', 'temperatura', 1034.0000, 'ºC'),
	(79373, 109, '2015-03-01 01:06:21.000000', 'temperatura', 827.0000, 'ºC'),
	(79374, 109, '2015-03-01 01:06:22.000000', 'temperatura', 1035.0000, 'ºC'),
	(79375, 109, '2015-03-01 01:06:23.000000', 'temperatura', 293.0000, 'ºC'),
	(79376, 109, '2015-03-01 01:06:24.000000', 'temperatura', 761.0000, 'ºC'),
	(79377, 109, '2015-03-01 01:06:25.000000', 'temperatura', 527.0000, 'ºC'),
	(79378, 109, '2015-03-01 01:06:26.000000', 'temperatura', 352.0000, 'ºC'),
	(79379, 109, '2015-03-01 01:06:27.000000', 'temperatura', 179.0000, 'ºC'),
	(79380, 109, '2015-03-01 01:06:28.000000', 'temperatura', 1039.0000, 'ºC'),
	(79381, 109, '2015-03-01 01:06:29.000000', 'temperatura', 1061.0000, 'ºC'),
	(79382, 109, '2015-03-01 01:06:30.000000', 'temperatura', 988.0000, 'ºC'),
	(79383, 109, '2015-03-01 01:06:31.000000', 'temperatura', 557.0000, 'ºC'),
	(79384, 109, '2015-03-01 01:06:32.000000', 'temperatura', 1022.0000, 'ºC'),
	(79385, 109, '2015-03-01 01:06:33.000000', 'temperatura', 1040.0000, 'ºC'),
	(79386, 109, '2015-03-01 01:06:34.000000', 'temperatura', 935.0000, 'ºC'),
	(79387, 109, '2015-03-01 01:06:35.000000', 'temperatura', 353.0000, 'ºC'),
	(79388, 109, '2015-03-01 01:06:36.000000', 'temperatura', 163.0000, 'ºC'),
	(79389, 109, '2015-03-01 01:06:37.000000', 'temperatura', 955.0000, 'ºC'),
	(79390, 109, '2015-03-01 01:06:38.000000', 'temperatura', 686.0000, 'ºC'),
	(79391, 109, '2015-03-01 01:06:39.000000', 'temperatura', 565.0000, 'ºC'),
	(79392, 109, '2015-03-01 01:06:40.000000', 'temperatura', 768.0000, 'ºC'),
	(79393, 109, '2015-03-01 01:06:41.000000', 'temperatura', 948.0000, 'ºC'),
	(79394, 109, '2015-03-01 01:06:42.000000', 'temperatura', 33.0000, 'ºC'),
	(79395, 109, '2015-03-01 01:06:43.000000', 'temperatura', 924.0000, 'ºC'),
	(79396, 109, '2015-03-01 01:06:44.000000', 'temperatura', 922.0000, 'ºC'),
	(79397, 109, '2015-03-01 01:06:45.000000', 'temperatura', 638.0000, 'ºC'),
	(79398, 109, '2015-03-01 01:06:46.000000', 'temperatura', 426.0000, 'ºC'),
	(79399, 109, '2015-03-01 01:06:47.000000', 'temperatura', 216.0000, 'ºC'),
	(79400, 109, '2015-03-01 01:06:48.000000', 'temperatura', 1003.0000, 'ºC'),
	(79401, 109, '2015-03-01 01:06:49.000000', 'temperatura', 767.0000, 'ºC'),
	(79402, 109, '2015-03-01 01:06:50.000000', 'temperatura', 825.0000, 'ºC'),
	(79403, 109, '2015-03-01 01:06:51.000000', 'temperatura', 627.0000, 'ºC'),
	(79404, 109, '2015-03-01 01:06:52.000000', 'temperatura', 661.0000, 'ºC'),
	(79405, 109, '2015-03-01 01:06:53.000000', 'temperatura', 224.0000, 'ºC'),
	(79406, 109, '2015-03-01 01:06:54.000000', 'temperatura', 335.0000, 'ºC'),
	(79407, 109, '2015-03-01 01:06:55.000000', 'temperatura', 1006.0000, 'ºC'),
	(79408, 109, '2015-03-01 01:06:56.000000', 'temperatura', 425.0000, 'ºC'),
	(79409, 109, '2015-03-01 01:06:57.000000', 'temperatura', 309.0000, 'ºC'),
	(79410, 109, '2015-03-01 01:06:58.000000', 'temperatura', 270.0000, 'ºC'),
	(79411, 109, '2015-03-01 01:06:59.000000', 'temperatura', 422.0000, 'ºC'),
	(79412, 109, '2015-03-01 01:07:00.000000', 'temperatura', 99.0000, 'ºC'),
	(79413, 109, '2015-03-01 01:07:01.000000', 'temperatura', 432.0000, 'ºC'),
	(79414, 109, '2015-03-01 01:07:02.000000', 'temperatura', 664.0000, 'ºC'),
	(79415, 109, '2015-03-01 01:07:03.000000', 'temperatura', 823.0000, 'ºC'),
	(79416, 109, '2015-03-01 01:07:04.000000', 'temperatura', 924.0000, 'ºC'),
	(79417, 109, '2015-03-01 01:07:05.000000', 'temperatura', 952.0000, 'ºC'),
	(79418, 109, '2015-03-01 01:07:06.000000', 'temperatura', 790.0000, 'ºC'),
	(79419, 109, '2015-03-01 01:07:07.000000', 'temperatura', 1092.0000, 'ºC'),
	(79420, 109, '2015-03-01 01:07:08.000000', 'temperatura', 692.0000, 'ºC'),
	(79421, 109, '2015-03-01 01:07:09.000000', 'temperatura', 182.0000, 'ºC'),
	(79422, 109, '2015-03-01 01:07:10.000000', 'temperatura', 38.0000, 'ºC'),
	(79423, 109, '2015-03-01 01:07:11.000000', 'temperatura', 843.0000, 'ºC'),
	(79424, 109, '2015-03-01 01:07:12.000000', 'temperatura', 501.0000, 'ºC'),
	(79425, 109, '2015-03-01 01:07:13.000000', 'temperatura', 1178.0000, 'ºC'),
	(79426, 109, '2015-03-01 01:07:14.000000', 'temperatura', 788.0000, 'ºC'),
	(79427, 109, '2015-03-01 01:07:15.000000', 'temperatura', 404.0000, 'ºC'),
	(79428, 109, '2015-03-01 01:07:16.000000', 'temperatura', 858.0000, 'ºC'),
	(79429, 109, '2015-03-01 01:07:17.000000', 'temperatura', 678.0000, 'ºC'),
	(79430, 109, '2015-03-01 01:07:18.000000', 'temperatura', 818.0000, 'ºC'),
	(79431, 109, '2015-03-01 01:07:19.000000', 'temperatura', 856.0000, 'ºC'),
	(79432, 109, '2015-03-01 01:07:20.000000', 'temperatura', 626.0000, 'ºC'),
	(79433, 109, '2015-03-01 01:07:21.000000', 'temperatura', 564.0000, 'ºC'),
	(79434, 109, '2015-03-01 01:07:22.000000', 'temperatura', 943.0000, 'ºC'),
	(79435, 109, '2015-03-01 01:07:23.000000', 'temperatura', 621.0000, 'ºC'),
	(79436, 109, '2015-03-01 01:07:24.000000', 'temperatura', 278.0000, 'ºC'),
	(79437, 109, '2015-03-01 01:07:25.000000', 'temperatura', 729.0000, 'ºC'),
	(79438, 109, '2015-03-01 01:07:26.000000', 'temperatura', 408.0000, 'ºC'),
	(79439, 109, '2015-03-01 01:07:27.000000', 'temperatura', 1056.0000, 'ºC'),
	(79440, 109, '2015-03-01 01:07:28.000000', 'temperatura', 455.0000, 'ºC'),
	(79441, 109, '2015-03-01 01:07:29.000000', 'temperatura', 310.0000, 'ºC'),
	(79442, 109, '2015-03-01 01:07:30.000000', 'temperatura', 183.0000, 'ºC'),
	(79443, 109, '2015-03-01 01:07:31.000000', 'temperatura', 1187.0000, 'ºC'),
	(79444, 109, '2015-03-01 01:07:32.000000', 'temperatura', 587.0000, 'ºC'),
	(79445, 109, '2015-03-01 01:07:33.000000', 'temperatura', 572.0000, 'ºC'),
	(79446, 109, '2015-03-01 01:07:34.000000', 'temperatura', 1100.0000, 'ºC'),
	(79447, 109, '2015-03-01 01:07:35.000000', 'temperatura', 186.0000, 'ºC'),
	(79448, 109, '2015-03-01 01:07:36.000000', 'temperatura', 31.0000, 'ºC'),
	(79449, 109, '2015-03-01 01:07:37.000000', 'temperatura', 798.0000, 'ºC'),
	(79450, 109, '2015-03-01 01:07:38.000000', 'temperatura', 298.0000, 'ºC'),
	(79451, 109, '2015-03-01 01:07:39.000000', 'temperatura', 293.0000, 'ºC'),
	(79452, 109, '2015-03-01 01:07:40.000000', 'temperatura', 575.0000, 'ºC'),
	(79453, 109, '2015-03-01 01:07:41.000000', 'temperatura', 795.0000, 'ºC'),
	(79454, 109, '2015-03-01 01:07:42.000000', 'temperatura', 1051.0000, 'ºC'),
	(79455, 109, '2015-03-01 01:07:43.000000', 'temperatura', 472.0000, 'ºC'),
	(79456, 109, '2015-03-01 01:07:44.000000', 'temperatura', 408.0000, 'ºC'),
	(79457, 109, '2015-03-01 01:07:45.000000', 'temperatura', 622.0000, 'ºC'),
	(79458, 109, '2015-03-01 01:07:46.000000', 'temperatura', 688.0000, 'ºC'),
	(79459, 109, '2015-03-01 01:07:47.000000', 'temperatura', 375.0000, 'ºC'),
	(79460, 109, '2015-03-01 01:07:48.000000', 'temperatura', 1013.0000, 'ºC'),
	(79461, 109, '2015-03-01 01:07:49.000000', 'temperatura', 337.0000, 'ºC'),
	(79462, 109, '2015-03-01 01:07:50.000000', 'temperatura', 1048.0000, 'ºC'),
	(79463, 109, '2015-03-01 01:07:51.000000', 'temperatura', 628.0000, 'ºC'),
	(79464, 109, '2015-03-01 01:07:52.000000', 'temperatura', 1197.0000, 'ºC'),
	(79465, 109, '2015-03-01 01:07:53.000000', 'temperatura', 501.0000, 'ºC'),
	(79466, 109, '2015-03-01 01:07:54.000000', 'temperatura', 114.0000, 'ºC'),
	(79467, 109, '2015-03-01 01:07:55.000000', 'temperatura', 267.0000, 'ºC'),
	(79468, 109, '2015-03-01 01:07:56.000000', 'temperatura', 996.0000, 'ºC'),
	(79469, 109, '2015-03-01 01:07:57.000000', 'temperatura', 580.0000, 'ºC'),
	(79470, 109, '2015-03-01 01:07:58.000000', 'temperatura', 1112.0000, 'ºC'),
	(79471, 109, '2015-03-01 01:07:59.000000', 'temperatura', 219.0000, 'ºC'),
	(79472, 109, '2015-03-01 01:08:00.000000', 'temperatura', 161.0000, 'ºC'),
	(79473, 109, '2015-03-01 01:08:01.000000', 'temperatura', 149.0000, 'ºC'),
	(79474, 109, '2015-03-01 01:08:02.000000', 'temperatura', 263.0000, 'ºC'),
	(79475, 109, '2015-03-01 01:08:03.000000', 'temperatura', 866.0000, 'ºC'),
	(79476, 109, '2015-03-01 01:08:04.000000', 'temperatura', 1144.0000, 'ºC'),
	(79477, 109, '2015-03-01 01:08:05.000000', 'temperatura', 721.0000, 'ºC'),
	(79478, 109, '2015-03-01 01:08:06.000000', 'temperatura', 173.0000, 'ºC'),
	(79479, 109, '2015-03-01 01:08:07.000000', 'temperatura', 1105.0000, 'ºC'),
	(79480, 109, '2015-03-01 01:08:08.000000', 'temperatura', 203.0000, 'ºC'),
	(79481, 109, '2015-03-01 01:08:09.000000', 'temperatura', 102.0000, 'ºC'),
	(79482, 109, '2015-03-01 01:08:10.000000', 'temperatura', 1103.0000, 'ºC'),
	(79483, 109, '2015-03-01 01:08:11.000000', 'temperatura', 410.0000, 'ºC'),
	(79484, 109, '2015-03-01 01:08:12.000000', 'temperatura', 1140.0000, 'ºC'),
	(79485, 109, '2015-03-01 01:08:13.000000', 'temperatura', 871.0000, 'ºC'),
	(79486, 109, '2015-03-01 01:08:14.000000', 'temperatura', 936.0000, 'ºC'),
	(79487, 109, '2015-03-01 01:08:15.000000', 'temperatura', 868.0000, 'ºC'),
	(79488, 109, '2015-03-01 01:08:16.000000', 'temperatura', 334.0000, 'ºC'),
	(79489, 109, '2015-03-01 01:08:17.000000', 'temperatura', 263.0000, 'ºC'),
	(79490, 109, '2015-03-01 01:08:18.000000', 'temperatura', 315.0000, 'ºC'),
	(79491, 109, '2015-03-01 01:08:19.000000', 'temperatura', 786.0000, 'ºC'),
	(79492, 109, '2015-03-01 01:08:20.000000', 'temperatura', 588.0000, 'ºC'),
	(79493, 109, '2015-03-01 01:08:21.000000', 'temperatura', 580.0000, 'ºC'),
	(79494, 109, '2015-03-01 01:08:22.000000', 'temperatura', 1136.0000, 'ºC'),
	(79495, 109, '2015-03-01 01:08:23.000000', 'temperatura', 341.0000, 'ºC'),
	(79496, 109, '2015-03-01 01:08:24.000000', 'temperatura', 700.0000, 'ºC'),
	(79497, 109, '2015-03-01 01:08:25.000000', 'temperatura', 74.0000, 'ºC'),
	(79498, 109, '2015-03-01 01:08:26.000000', 'temperatura', 671.0000, 'ºC'),
	(79499, 109, '2015-03-01 01:08:27.000000', 'temperatura', 734.0000, 'ºC'),
	(79500, 109, '2015-03-01 01:08:28.000000', 'temperatura', 456.0000, 'ºC'),
	(79501, 109, '2015-03-01 01:08:29.000000', 'temperatura', 80.0000, 'ºC'),
	(79502, 109, '2015-03-01 01:08:30.000000', 'temperatura', 230.0000, 'ºC'),
	(79503, 109, '2015-03-01 01:08:31.000000', 'temperatura', 912.0000, 'ºC'),
	(79504, 109, '2015-03-01 01:08:32.000000', 'temperatura', 272.0000, 'ºC'),
	(79505, 109, '2015-03-01 01:08:33.000000', 'temperatura', 1025.0000, 'ºC'),
	(79506, 109, '2015-03-01 01:08:34.000000', 'temperatura', 708.0000, 'ºC'),
	(79507, 109, '2015-03-01 01:08:35.000000', 'temperatura', 465.0000, 'ºC'),
	(79508, 109, '2015-03-01 01:08:36.000000', 'temperatura', 204.0000, 'ºC'),
	(79509, 109, '2015-03-01 01:08:37.000000', 'temperatura', 822.0000, 'ºC'),
	(79510, 109, '2015-03-01 01:08:38.000000', 'temperatura', 1101.0000, 'ºC'),
	(79511, 109, '2015-03-01 01:08:39.000000', 'temperatura', 640.0000, 'ºC'),
	(79512, 109, '2015-03-01 01:08:40.000000', 'temperatura', 1098.0000, 'ºC'),
	(79513, 109, '2015-03-01 01:08:41.000000', 'temperatura', 1169.0000, 'ºC'),
	(79514, 109, '2015-03-01 01:08:42.000000', 'temperatura', 153.0000, 'ºC'),
	(79515, 109, '2015-03-01 01:08:43.000000', 'temperatura', 856.0000, 'ºC'),
	(79516, 109, '2015-03-01 01:08:44.000000', 'temperatura', 223.0000, 'ºC'),
	(79517, 109, '2015-03-01 01:08:45.000000', 'temperatura', 945.0000, 'ºC'),
	(79518, 109, '2015-03-01 01:08:46.000000', 'temperatura', 460.0000, 'ºC'),
	(79519, 109, '2015-03-01 01:08:47.000000', 'temperatura', 664.0000, 'ºC'),
	(79520, 109, '2015-03-01 01:08:48.000000', 'temperatura', 740.0000, 'ºC'),
	(79521, 109, '2015-03-01 01:08:49.000000', 'temperatura', 509.0000, 'ºC'),
	(79522, 109, '2015-03-01 01:08:50.000000', 'temperatura', 324.0000, 'ºC'),
	(79523, 109, '2015-03-01 01:08:51.000000', 'temperatura', 94.0000, 'ºC'),
	(79524, 109, '2015-03-01 01:08:52.000000', 'temperatura', 699.0000, 'ºC'),
	(79525, 109, '2015-03-01 01:08:53.000000', 'temperatura', 815.0000, 'ºC'),
	(79526, 109, '2015-03-01 01:08:54.000000', 'temperatura', 779.0000, 'ºC'),
	(79527, 109, '2015-03-01 01:08:55.000000', 'temperatura', 249.0000, 'ºC'),
	(79528, 109, '2015-03-01 01:08:56.000000', 'temperatura', 111.0000, 'ºC'),
	(79529, 109, '2015-03-01 01:08:57.000000', 'temperatura', 1006.0000, 'ºC'),
	(79530, 109, '2015-03-01 01:08:58.000000', 'temperatura', 1096.0000, 'ºC'),
	(79531, 109, '2015-03-01 01:08:59.000000', 'temperatura', 64.0000, 'ºC'),
	(79532, 109, '2015-03-01 01:09:00.000000', 'temperatura', 635.0000, 'ºC'),
	(79533, 109, '2015-03-01 01:09:01.000000', 'temperatura', 580.0000, 'ºC'),
	(79534, 109, '2015-03-01 01:09:02.000000', 'temperatura', 997.0000, 'ºC'),
	(79535, 109, '2015-03-01 01:09:03.000000', 'temperatura', 844.0000, 'ºC'),
	(79536, 109, '2015-03-01 01:09:04.000000', 'temperatura', 32.0000, 'ºC'),
	(79537, 109, '2015-03-01 01:09:05.000000', 'temperatura', 26.0000, 'ºC'),
	(79538, 109, '2015-03-01 01:09:06.000000', 'temperatura', 38.0000, 'ºC'),
	(79539, 109, '2015-03-01 01:09:07.000000', 'temperatura', 109.0000, 'ºC'),
	(79540, 109, '2015-03-01 01:09:08.000000', 'temperatura', 432.0000, 'ºC'),
	(79541, 109, '2015-03-01 01:09:09.000000', 'temperatura', 636.0000, 'ºC'),
	(79542, 109, '2015-03-01 01:09:10.000000', 'temperatura', 682.0000, 'ºC'),
	(79543, 109, '2015-03-01 01:09:11.000000', 'temperatura', 302.0000, 'ºC'),
	(79544, 109, '2015-03-01 01:09:12.000000', 'temperatura', 666.0000, 'ºC'),
	(79545, 109, '2015-03-01 01:09:13.000000', 'temperatura', 24.0000, 'ºC'),
	(79546, 109, '2015-03-01 01:09:14.000000', 'temperatura', 524.0000, 'ºC'),
	(79547, 109, '2015-03-01 01:09:15.000000', 'temperatura', 148.0000, 'ºC'),
	(79548, 109, '2015-03-01 01:09:16.000000', 'temperatura', 369.0000, 'ºC'),
	(79549, 109, '2015-03-01 01:09:17.000000', 'temperatura', 200.0000, 'ºC'),
	(79550, 109, '2015-03-01 01:09:18.000000', 'temperatura', 1092.0000, 'ºC'),
	(79551, 109, '2015-03-01 01:09:19.000000', 'temperatura', 62.0000, 'ºC'),
	(79552, 109, '2015-03-01 01:09:20.000000', 'temperatura', 636.0000, 'ºC'),
	(79553, 109, '2015-03-01 01:09:21.000000', 'temperatura', 594.0000, 'ºC'),
	(79554, 109, '2015-03-01 01:09:22.000000', 'temperatura', 1062.0000, 'ºC'),
	(79555, 109, '2015-03-01 01:09:23.000000', 'temperatura', 1127.0000, 'ºC'),
	(79556, 109, '2015-03-01 01:09:24.000000', 'temperatura', 50.0000, 'ºC'),
	(79557, 109, '2015-03-01 01:09:25.000000', 'temperatura', 468.0000, 'ºC'),
	(79558, 109, '2015-03-01 01:09:26.000000', 'temperatura', 993.0000, 'ºC'),
	(79559, 109, '2015-03-01 01:09:27.000000', 'temperatura', 1159.0000, 'ºC'),
	(79560, 109, '2015-03-01 01:09:28.000000', 'temperatura', 416.0000, 'ºC'),
	(79561, 109, '2015-03-01 01:09:29.000000', 'temperatura', 1003.0000, 'ºC'),
	(79562, 109, '2015-03-01 01:09:30.000000', 'temperatura', 171.0000, 'ºC'),
	(79563, 109, '2015-03-01 01:09:31.000000', 'temperatura', 243.0000, 'ºC'),
	(79564, 109, '2015-03-01 01:09:32.000000', 'temperatura', 704.0000, 'ºC'),
	(79565, 109, '2015-03-01 01:09:33.000000', 'temperatura', 393.0000, 'ºC'),
	(79566, 109, '2015-03-01 01:09:34.000000', 'temperatura', 1054.0000, 'ºC'),
	(79567, 109, '2015-03-01 01:09:35.000000', 'temperatura', 492.0000, 'ºC'),
	(79568, 109, '2015-03-01 01:09:36.000000', 'temperatura', 498.0000, 'ºC'),
	(79569, 109, '2015-03-01 01:09:37.000000', 'temperatura', 1015.0000, 'ºC'),
	(79570, 109, '2015-03-01 01:09:38.000000', 'temperatura', 1181.0000, 'ºC'),
	(79571, 109, '2015-03-01 01:09:39.000000', 'temperatura', 460.0000, 'ºC'),
	(79572, 109, '2015-03-01 01:09:40.000000', 'temperatura', 1158.0000, 'ºC'),
	(79573, 109, '2015-03-01 01:09:41.000000', 'temperatura', 810.0000, 'ºC'),
	(79574, 109, '2015-03-01 01:09:42.000000', 'temperatura', 578.0000, 'ºC'),
	(79575, 109, '2015-03-01 01:09:43.000000', 'temperatura', 458.0000, 'ºC'),
	(79576, 109, '2015-03-01 01:09:44.000000', 'temperatura', 559.0000, 'ºC'),
	(79577, 109, '2015-03-01 01:09:45.000000', 'temperatura', 222.0000, 'ºC'),
	(79578, 109, '2015-03-01 01:09:46.000000', 'temperatura', 633.0000, 'ºC'),
	(79579, 109, '2015-03-01 01:09:47.000000', 'temperatura', 100.0000, 'ºC'),
	(79580, 109, '2015-03-01 01:09:48.000000', 'temperatura', 1002.0000, 'ºC'),
	(79581, 109, '2015-03-01 01:09:49.000000', 'temperatura', 1109.0000, 'ºC'),
	(79582, 109, '2015-03-01 01:09:50.000000', 'temperatura', 139.0000, 'ºC'),
	(79583, 109, '2015-03-01 01:09:51.000000', 'temperatura', 968.0000, 'ºC'),
	(79584, 109, '2015-03-01 01:09:52.000000', 'temperatura', 825.0000, 'ºC'),
	(79585, 109, '2015-03-01 01:09:53.000000', 'temperatura', 19.0000, 'ºC'),
	(79586, 109, '2015-03-01 01:09:54.000000', 'temperatura', 23.0000, 'ºC'),
	(79587, 109, '2015-03-01 01:09:55.000000', 'temperatura', 56.0000, 'ºC'),
	(79588, 109, '2015-03-01 01:09:56.000000', 'temperatura', 213.0000, 'ºC'),
	(79589, 109, '2015-03-01 01:09:57.000000', 'temperatura', 895.0000, 'ºC'),
	(79590, 109, '2015-03-01 01:09:58.000000', 'temperatura', 240.0000, 'ºC'),
	(79591, 109, '2015-03-01 01:09:59.000000', 'temperatura', 912.0000, 'ºC'),
	(79592, 109, '2015-03-01 01:10:00.000000', 'temperatura', 243.0000, 'ºC'),
	(79593, 109, '2015-03-01 01:10:01.000000', 'temperatura', 879.0000, 'ºC'),
	(79594, 109, '2015-03-01 01:10:02.000000', 'temperatura', 65.0000, 'ºC'),
	(79595, 109, '2015-03-01 01:10:03.000000', 'temperatura', 88.0000, 'ºC'),
	(79596, 109, '2015-03-01 01:10:04.000000', 'temperatura', 248.0000, 'ºC'),
	(79597, 109, '2015-03-01 01:10:05.000000', 'temperatura', 975.0000, 'ºC'),
	(79598, 109, '2015-03-01 01:10:06.000000', 'temperatura', 533.0000, 'ºC'),
	(79599, 109, '2015-03-01 01:10:07.000000', 'temperatura', 941.0000, 'ºC'),
	(79600, 109, '2015-03-01 01:10:08.000000', 'temperatura', 704.0000, 'ºC'),
	(79601, 109, '2015-03-01 01:10:09.000000', 'temperatura', 700.0000, 'ºC'),
	(79602, 109, '2015-03-01 01:10:10.000000', 'temperatura', 190.0000, 'ºC'),
	(79603, 109, '2015-03-01 01:10:11.000000', 'temperatura', 47.0000, 'ºC'),
	(79604, 109, '2015-03-01 01:10:12.000000', 'temperatura', 867.0000, 'ºC'),
	(79605, 109, '2015-03-01 01:10:13.000000', 'temperatura', 595.0000, 'ºC'),
	(79606, 109, '2015-03-01 01:10:14.000000', 'temperatura', 373.0000, 'ºC'),
	(79607, 109, '2015-03-01 01:10:15.000000', 'temperatura', 81.0000, 'ºC'),
	(79608, 109, '2015-03-01 01:10:16.000000', 'temperatura', 485.0000, 'ºC'),
	(79609, 109, '2015-03-01 01:10:17.000000', 'temperatura', 983.0000, 'ºC'),
	(79610, 109, '2015-03-01 01:10:18.000000', 'temperatura', 1062.0000, 'ºC'),
	(79611, 109, '2015-03-01 01:10:19.000000', 'temperatura', 1159.0000, 'ºC'),
	(79612, 109, '2015-03-01 01:10:20.000000', 'temperatura', 212.0000, 'ºC'),
	(79613, 109, '2015-03-01 01:10:21.000000', 'temperatura', 1182.0000, 'ºC'),
	(79614, 109, '2015-03-01 01:10:22.000000', 'temperatura', 477.0000, 'ºC'),
	(79615, 109, '2015-03-01 01:10:23.000000', 'temperatura', 36.0000, 'ºC'),
	(79616, 109, '2015-03-01 01:10:24.000000', 'temperatura', 1151.0000, 'ºC'),
	(79617, 109, '2015-03-01 01:10:25.000000', 'temperatura', 848.0000, 'ºC'),
	(79618, 109, '2015-03-01 01:10:26.000000', 'temperatura', 787.0000, 'ºC'),
	(79619, 109, '2015-03-01 01:10:27.000000', 'temperatura', 190.0000, 'ºC'),
	(79620, 109, '2015-03-01 01:10:28.000000', 'temperatura', 989.0000, 'ºC'),
	(79621, 109, '2015-03-01 01:10:29.000000', 'temperatura', 777.0000, 'ºC'),
	(79622, 109, '2015-03-01 01:10:30.000000', 'temperatura', 918.0000, 'ºC'),
	(79623, 109, '2015-03-01 01:10:31.000000', 'temperatura', 1058.0000, 'ºC'),
	(79624, 109, '2015-03-01 01:10:32.000000', 'temperatura', 140.0000, 'ºC'),
	(79625, 109, '2015-03-01 01:10:33.000000', 'temperatura', 1123.0000, 'ºC'),
	(79626, 109, '2015-03-01 01:10:34.000000', 'temperatura', 398.0000, 'ºC'),
	(79627, 109, '2015-03-01 01:10:35.000000', 'temperatura', 1019.0000, 'ºC'),
	(79628, 109, '2015-03-01 01:10:36.000000', 'temperatura', 303.0000, 'ºC'),
	(79629, 109, '2015-03-01 01:10:37.000000', 'temperatura', 860.0000, 'ºC'),
	(79630, 109, '2015-03-01 01:10:38.000000', 'temperatura', 988.0000, 'ºC'),
	(79631, 109, '2015-03-01 01:10:39.000000', 'temperatura', 1163.0000, 'ºC'),
	(79632, 109, '2015-03-01 01:10:40.000000', 'temperatura', 452.0000, 'ºC'),
	(79633, 109, '2015-03-01 01:10:41.000000', 'temperatura', 1169.0000, 'ºC'),
	(79634, 109, '2015-03-01 01:10:42.000000', 'temperatura', 890.0000, 'ºC'),
	(79635, 109, '2015-03-01 01:10:43.000000', 'temperatura', 944.0000, 'ºC'),
	(79636, 109, '2015-03-01 01:10:44.000000', 'temperatura', 850.0000, 'ºC'),
	(79637, 109, '2015-03-01 01:10:45.000000', 'temperatura', 220.0000, 'ºC'),
	(79638, 109, '2015-03-01 01:10:46.000000', 'temperatura', 950.0000, 'ºC'),
	(79639, 109, '2015-03-01 01:10:47.000000', 'temperatura', 490.0000, 'ºC'),
	(79640, 109, '2015-03-01 01:10:48.000000', 'temperatura', 800.0000, 'ºC'),
	(79641, 109, '2015-03-01 01:10:49.000000', 'temperatura', 130.0000, 'ºC'),
	(79642, 109, '2015-03-01 01:10:50.000000', 'temperatura', 653.0000, 'ºC'),
	(79643, 109, '2015-03-01 01:10:51.000000', 'temperatura', 475.0000, 'ºC'),
	(79644, 109, '2015-03-01 01:10:52.000000', 'temperatura', 416.0000, 'ºC'),
	(79645, 109, '2015-03-01 01:10:53.000000', 'temperatura', 657.0000, 'ºC'),
	(79646, 109, '2015-03-01 01:10:54.000000', 'temperatura', 836.0000, 'ºC'),
	(79647, 109, '2015-03-01 01:10:55.000000', 'temperatura', 1009.0000, 'ºC'),
	(79648, 109, '2015-03-01 01:10:56.000000', 'temperatura', 137.0000, 'ºC'),
	(79649, 109, '2015-03-01 01:10:57.000000', 'temperatura', 60.0000, 'ºC'),
	(79650, 109, '2015-03-01 01:10:58.000000', 'temperatura', 1087.0000, 'ºC'),
	(79651, 109, '2015-03-01 01:10:59.000000', 'temperatura', 457.0000, 'ºC'),
	(79652, 109, '2015-03-01 01:11:00.000000', 'temperatura', 223.0000, 'ºC'),
	(79653, 109, '2015-03-01 01:11:01.000000', 'temperatura', 944.0000, 'ºC'),
	(79654, 109, '2015-03-01 01:11:02.000000', 'temperatura', 454.0000, 'ºC'),
	(79655, 109, '2015-03-01 01:11:03.000000', 'temperatura', 638.0000, 'ºC'),
	(79656, 109, '2015-03-01 01:11:04.000000', 'temperatura', 627.0000, 'ºC'),
	(79657, 109, '2015-03-01 01:11:05.000000', 'temperatura', 23.0000, 'ºC'),
	(79658, 109, '2015-03-01 01:11:06.000000', 'temperatura', 634.0000, 'ºC'),
	(79659, 109, '2015-03-01 01:11:07.000000', 'temperatura', 700.0000, 'ºC'),
	(79660, 109, '2015-03-01 01:11:08.000000', 'temperatura', 400.0000, 'ºC'),
	(79661, 109, '2015-03-01 01:11:09.000000', 'temperatura', 1099.0000, 'ºC'),
	(79662, 109, '2015-03-01 01:11:10.000000', 'temperatura', 697.0000, 'ºC'),
	(79663, 109, '2015-03-01 01:11:11.000000', 'temperatura', 188.0000, 'ºC'),
	(79664, 109, '2015-03-01 01:11:12.000000', 'temperatura', 51.0000, 'ºC'),
	(79665, 109, '2015-03-01 01:11:13.000000', 'temperatura', 892.0000, 'ºC'),
	(79666, 109, '2015-03-01 01:11:14.000000', 'temperatura', 706.0000, 'ºC'),
	(79667, 109, '2015-03-01 01:11:15.000000', 'temperatura', 854.0000, 'ºC'),
	(79668, 109, '2015-03-01 01:11:16.000000', 'temperatura', 951.0000, 'ºC'),
	(79669, 109, '2015-03-01 01:11:17.000000', 'temperatura', 997.0000, 'ºC'),
	(79670, 109, '2015-03-01 01:11:18.000000', 'temperatura', 931.0000, 'ºC'),
	(79671, 109, '2015-03-01 01:11:19.000000', 'temperatura', 465.0000, 'ºC'),
	(79672, 109, '2015-03-01 01:11:20.000000', 'temperatura', 732.0000, 'ºC'),
	(79673, 109, '2015-03-01 01:11:21.000000', 'temperatura', 1065.0000, 'ºC'),
	(79674, 109, '2015-03-01 01:11:22.000000', 'temperatura', 730.0000, 'ºC'),
	(79675, 109, '2015-03-01 01:11:23.000000', 'temperatura', 454.0000, 'ºC'),
	(79676, 109, '2015-03-01 01:11:24.000000', 'temperatura', 80.0000, 'ºC'),
	(79677, 109, '2015-03-01 01:11:25.000000', 'temperatura', 241.0000, 'ºC'),
	(79678, 109, '2015-03-01 01:11:26.000000', 'temperatura', 966.0000, 'ºC'),
	(79679, 109, '2015-03-01 01:11:27.000000', 'temperatura', 505.0000, 'ºC'),
	(79680, 109, '2015-03-01 01:11:28.000000', 'temperatura', 830.0000, 'ºC'),
	(79681, 109, '2015-03-01 01:11:29.000000', 'temperatura', 232.0000, 'ºC'),
	(79682, 109, '2015-03-01 01:11:30.000000', 'temperatura', 1074.0000, 'ºC'),
	(79683, 109, '2015-03-01 01:11:31.000000', 'temperatura', 1073.0000, 'ºC'),
	(79684, 109, '2015-03-01 01:11:32.000000', 'temperatura', 943.0000, 'ºC'),
	(79685, 109, '2015-03-01 01:11:33.000000', 'temperatura', 295.0000, 'ºC'),
	(79686, 109, '2015-03-01 01:11:34.000000', 'temperatura', 1047.0000, 'ºC'),
	(79687, 109, '2015-03-01 01:11:35.000000', 'temperatura', 752.0000, 'ºC'),
	(79688, 109, '2015-03-01 01:11:36.000000', 'temperatura', 621.0000, 'ºC'),
	(79689, 109, '2015-03-01 01:11:37.000000', 'temperatura', 848.0000, 'ºC'),
	(79690, 109, '2015-03-01 01:11:38.000000', 'temperatura', 1177.0000, 'ºC'),
	(79691, 109, '2015-03-01 01:11:39.000000', 'temperatura', 940.0000, 'ºC'),
	(79692, 109, '2015-03-01 01:11:40.000000', 'temperatura', 1170.0000, 'ºC'),
	(79693, 109, '2015-03-01 01:11:41.000000', 'temperatura', 630.0000, 'ºC'),
	(79694, 109, '2015-03-01 01:11:42.000000', 'temperatura', 841.0000, 'ºC'),
	(79695, 109, '2015-03-01 01:11:43.000000', 'temperatura', 1117.0000, 'ºC'),
	(79696, 109, '2015-03-01 01:11:44.000000', 'temperatura', 660.0000, 'ºC'),
	(79697, 109, '2015-03-01 01:11:45.000000', 'temperatura', 1151.0000, 'ºC'),
	(79698, 109, '2015-03-01 01:11:46.000000', 'temperatura', 174.0000, 'ºC'),
	(79699, 109, '2015-03-01 01:11:47.000000', 'temperatura', 1017.0000, 'ºC'),
	(79700, 109, '2015-03-01 01:11:48.000000', 'temperatura', 963.0000, 'ºC'),
	(79701, 109, '2015-03-01 01:11:49.000000', 'temperatura', 564.0000, 'ºC'),
	(79702, 109, '2015-03-01 01:11:50.000000', 'temperatura', 1132.0000, 'ºC'),
	(79703, 109, '2015-03-01 01:11:51.000000', 'temperatura', 367.0000, 'ºC'),
	(79704, 109, '2015-03-01 01:11:52.000000', 'temperatura', 840.0000, 'ºC'),
	(79705, 109, '2015-03-01 01:11:53.000000', 'temperatura', 701.0000, 'ºC'),
	(79706, 109, '2015-03-01 01:11:54.000000', 'temperatura', 986.0000, 'ºC'),
	(79707, 109, '2015-03-01 01:11:55.000000', 'temperatura', 427.0000, 'ºC'),
	(79708, 109, '2015-03-01 01:11:56.000000', 'temperatura', 375.0000, 'ºC'),
	(79709, 109, '2015-03-01 01:11:57.000000', 'temperatura', 597.0000, 'ºC'),
	(79710, 109, '2015-03-01 01:11:58.000000', 'temperatura', 659.0000, 'ºC'),
	(79711, 109, '2015-03-01 01:11:59.000000', 'temperatura', 306.0000, 'ºC'),
	(79712, 109, '2015-03-01 01:12:00.000000', 'temperatura', 754.0000, 'ºC'),
	(79713, 109, '2015-03-01 01:12:01.000000', 'temperatura', 451.0000, 'ºC'),
	(79714, 109, '2015-03-01 01:12:02.000000', 'temperatura', 1194.0000, 'ºC'),
	(79715, 109, '2015-03-01 01:12:03.000000', 'temperatura', 1015.0000, 'ºC'),
	(79716, 109, '2015-03-01 01:12:04.000000', 'temperatura', 297.0000, 'ºC'),
	(79717, 109, '2015-03-01 01:12:05.000000', 'temperatura', 841.0000, 'ºC'),
	(79718, 109, '2015-03-01 01:12:06.000000', 'temperatura', 913.0000, 'ºC'),
	(79719, 109, '2015-03-01 01:12:07.000000', 'temperatura', 842.0000, 'ºC'),
	(79720, 109, '2015-03-01 01:12:08.000000', 'temperatura', 270.0000, 'ºC'),
	(79721, 109, '2015-03-01 01:12:09.000000', 'temperatura', 28.0000, 'ºC'),
	(79722, 109, '2015-03-01 01:12:10.000000', 'temperatura', 529.0000, 'ºC'),
	(79723, 109, '2015-03-01 01:12:11.000000', 'temperatura', 161.0000, 'ºC'),
	(79724, 109, '2015-03-01 01:12:12.000000', 'temperatura', 420.0000, 'ºC'),
	(79725, 109, '2015-03-01 01:12:13.000000', 'temperatura', 418.0000, 'ºC'),
	(79726, 109, '2015-03-01 01:12:14.000000', 'temperatura', 829.0000, 'ºC'),
	(79727, 109, '2015-03-01 01:12:15.000000', 'temperatura', 493.0000, 'ºC'),
	(79728, 109, '2015-03-01 01:12:16.000000', 'temperatura', 1176.0000, 'ºC'),
	(79729, 109, '2015-03-01 01:12:17.000000', 'temperatura', 804.0000, 'ºC'),
	(79730, 109, '2015-03-01 01:12:18.000000', 'temperatura', 493.0000, 'ºC'),
	(79731, 109, '2015-03-01 01:12:19.000000', 'temperatura', 54.0000, 'ºC'),
	(79732, 109, '2015-03-01 01:12:20.000000', 'temperatura', 1189.0000, 'ºC'),
	(79733, 109, '2015-03-01 01:12:21.000000', 'temperatura', 984.0000, 'ºC'),
	(79734, 109, '2015-03-01 01:12:22.000000', 'temperatura', 155.0000, 'ºC'),
	(79735, 109, '2015-03-01 01:12:23.000000', 'temperatura', 222.0000, 'ºC'),
	(79736, 109, '2015-03-01 01:12:24.000000', 'temperatura', 647.0000, 'ºC'),
	(79737, 109, '2015-03-01 01:12:25.000000', 'temperatura', 168.0000, 'ºC'),
	(79738, 109, '2015-03-01 01:12:26.000000', 'temperatura', 100.0000, 'ºC'),
	(79739, 109, '2015-03-01 01:12:27.000000', 'temperatura', 1196.0000, 'ºC'),
	(79740, 109, '2015-03-01 01:12:28.000000', 'temperatura', 879.0000, 'ºC'),
	(79741, 109, '2015-03-01 01:12:29.000000', 'temperatura', 810.0000, 'ºC'),
	(79742, 109, '2015-03-01 01:12:30.000000', 'temperatura', 214.0000, 'ºC'),
	(79743, 109, '2015-03-01 01:12:31.000000', 'temperatura', 1041.0000, 'ºC'),
	(79744, 109, '2015-03-01 01:12:32.000000', 'temperatura', 962.0000, 'ºC'),
	(79745, 109, '2015-03-01 01:12:33.000000', 'temperatura', 487.0000, 'ºC'),
	(79746, 109, '2015-03-01 01:12:34.000000', 'temperatura', 751.0000, 'ºC'),
	(79747, 109, '2015-03-01 01:12:35.000000', 'temperatura', 1095.0000, 'ºC'),
	(79748, 109, '2015-03-01 01:12:36.000000', 'temperatura', 821.0000, 'ºC'),
	(79749, 109, '2015-03-01 01:12:37.000000', 'temperatura', 820.0000, 'ºC'),
	(79750, 109, '2015-03-01 01:12:38.000000', 'temperatura', 440.0000, 'ºC'),
	(79751, 109, '2015-03-01 01:12:39.000000', 'temperatura', 939.0000, 'ºC'),
	(79752, 109, '2015-03-01 01:12:40.000000', 'temperatura', 976.0000, 'ºC'),
	(79753, 109, '2015-03-01 01:12:41.000000', 'temperatura', 865.0000, 'ºC'),
	(79754, 109, '2015-03-01 01:12:42.000000', 'temperatura', 196.0000, 'ºC'),
	(79755, 109, '2015-03-01 01:12:43.000000', 'temperatura', 787.0000, 'ºC'),
	(79756, 109, '2015-03-01 01:12:44.000000', 'temperatura', 945.0000, 'ºC'),
	(79757, 109, '2015-03-01 01:12:45.000000', 'temperatura', 1165.0000, 'ºC'),
	(79758, 109, '2015-03-01 01:12:46.000000', 'temperatura', 589.0000, 'ºC'),
	(79759, 109, '2015-03-01 01:12:47.000000', 'temperatura', 652.0000, 'ºC'),
	(79760, 109, '2015-03-01 01:12:48.000000', 'temperatura', 292.0000, 'ºC'),
	(79761, 109, '2015-03-01 01:12:49.000000', 'temperatura', 707.0000, 'ºC'),
	(79762, 109, '2015-03-01 01:12:50.000000', 'temperatura', 259.0000, 'ºC'),
	(79763, 109, '2015-03-01 01:12:51.000000', 'temperatura', 373.0000, 'ºC'),
	(79764, 109, '2015-03-01 01:12:52.000000', 'temperatura', 1088.0000, 'ºC'),
	(79765, 109, '2015-03-01 01:12:53.000000', 'temperatura', 721.0000, 'ºC'),
	(79766, 109, '2015-03-01 01:12:54.000000', 'temperatura', 344.0000, 'ºC'),
	(79767, 109, '2015-03-01 01:12:55.000000', 'temperatura', 758.0000, 'ºC'),
	(79768, 109, '2015-03-01 01:12:56.000000', 'temperatura', 356.0000, 'ºC'),
	(79769, 109, '2015-03-01 01:12:57.000000', 'temperatura', 706.0000, 'ºC'),
	(79770, 109, '2015-03-01 01:12:58.000000', 'temperatura', 64.0000, 'ºC'),
	(79771, 109, '2015-03-01 01:12:59.000000', 'temperatura', 603.0000, 'ºC'),
	(79772, 109, '2015-03-01 01:13:00.000000', 'temperatura', 423.0000, 'ºC'),
	(79773, 109, '2015-03-01 01:13:01.000000', 'temperatura', 307.0000, 'ºC'),
	(79774, 109, '2015-03-01 01:13:02.000000', 'temperatura', 267.0000, 'ºC'),
	(79775, 109, '2015-03-01 01:13:03.000000', 'temperatura', 413.0000, 'ºC'),
	(79776, 109, '2015-03-01 01:13:04.000000', 'temperatura', 65.0000, 'ºC'),
	(79777, 109, '2015-03-01 01:13:05.000000', 'temperatura', 285.0000, 'ºC'),
	(79778, 109, '2015-03-01 01:13:06.000000', 'temperatura', 33.0000, 'ºC'),
	(79779, 109, '2015-03-01 01:13:07.000000', 'temperatura', 508.0000, 'ºC'),
	(79780, 109, '2015-03-01 01:13:08.000000', 'temperatura', 44.0000, 'ºC'),
	(79781, 109, '2015-03-01 01:13:09.000000', 'temperatura', 1095.0000, 'ºC'),
	(79782, 109, '2015-03-01 01:13:10.000000', 'temperatura', 542.0000, 'ºC'),
	(79783, 109, '2015-03-01 01:13:11.000000', 'temperatura', 627.0000, 'ºC'),
	(79784, 109, '2015-03-01 01:13:12.000000', 'temperatura', 308.0000, 'ºC'),
	(79785, 109, '2015-03-01 01:13:13.000000', 'temperatura', 861.0000, 'ºC'),
	(79786, 109, '2015-03-01 01:13:14.000000', 'temperatura', 983.0000, 'ºC'),
	(79787, 109, '2015-03-01 01:13:15.000000', 'temperatura', 1130.0000, 'ºC'),
	(79788, 109, '2015-03-01 01:13:16.000000', 'temperatura', 304.0000, 'ºC'),
	(79789, 109, '2015-03-01 01:13:17.000000', 'temperatura', 528.0000, 'ºC'),
	(79790, 109, '2015-03-01 01:13:18.000000', 'temperatura', 531.0000, 'ºC'),
	(79791, 109, '2015-03-01 01:13:19.000000', 'temperatura', 1069.0000, 'ºC'),
	(79792, 109, '2015-03-01 01:13:20.000000', 'temperatura', 155.0000, 'ºC'),
	(79793, 109, '2015-03-01 01:13:21.000000', 'temperatura', 1168.0000, 'ºC'),
	(79794, 109, '2015-03-01 01:13:22.000000', 'temperatura', 575.0000, 'ºC'),
	(79795, 109, '2015-03-01 01:13:23.000000', 'temperatura', 573.0000, 'ºC'),
	(79796, 109, '2015-03-01 01:13:24.000000', 'temperatura', 1140.0000, 'ºC'),
	(79797, 109, '2015-03-01 01:13:25.000000', 'temperatura', 380.0000, 'ºC'),
	(79798, 109, '2015-03-01 01:13:26.000000', 'temperatura', 880.0000, 'ºC'),
	(79799, 109, '2015-03-01 01:13:27.000000', 'temperatura', 863.0000, 'ºC'),
	(79800, 109, '2015-03-01 01:13:28.000000', 'temperatura', 473.0000, 'ºC'),
	(79801, 109, '2015-03-01 01:13:29.000000', 'temperatura', 978.0000, 'ºC'),
	(79802, 109, '2015-03-01 01:13:30.000000', 'temperatura', 1070.0000, 'ºC'),
	(79803, 109, '2015-03-01 01:13:31.000000', 'temperatura', 18.0000, 'ºC'),
	(79804, 109, '2015-03-01 01:13:32.000000', 'temperatura', 481.0000, 'ºC'),
	(79805, 109, '2015-03-01 01:13:33.000000', 'temperatura', 1150.0000, 'ºC'),
	(79806, 109, '2015-03-01 01:13:34.000000', 'temperatura', 710.0000, 'ºC'),
	(79807, 109, '2015-03-01 01:13:35.000000', 'temperatura', 98.0000, 'ºC'),
	(79808, 109, '2015-03-01 01:13:36.000000', 'temperatura', 761.0000, 'ºC'),
	(79809, 109, '2015-03-01 01:13:37.000000', 'temperatura', 1113.0000, 'ºC'),
	(79810, 109, '2015-03-01 01:13:38.000000', 'temperatura', 880.0000, 'ºC'),
	(79811, 109, '2015-03-01 01:13:39.000000', 'temperatura', 1062.0000, 'ºC'),
	(79812, 109, '2015-03-01 01:13:40.000000', 'temperatura', 270.0000, 'ºC'),
	(79813, 109, '2015-03-01 01:13:41.000000', 'temperatura', 566.0000, 'ºC'),
	(79814, 109, '2015-03-01 01:13:42.000000', 'temperatura', 820.0000, 'ºC'),
	(79815, 109, '2015-03-01 01:13:43.000000', 'temperatura', 2.0000, 'ºC'),
	(79816, 109, '2015-03-01 01:13:44.000000', 'temperatura', 1151.0000, 'ºC'),
	(79817, 109, '2015-03-01 01:13:45.000000', 'temperatura', 949.0000, 'ºC'),
	(79818, 109, '2015-03-01 01:13:46.000000', 'temperatura', 94.0000, 'ºC'),
	(79819, 109, '2015-03-01 01:13:47.000000', 'temperatura', 21.0000, 'ºC'),
	(79820, 109, '2015-03-01 01:13:48.000000', 'temperatura', 1024.0000, 'ºC'),
	(79821, 109, '2015-03-01 01:13:49.000000', 'temperatura', 259.0000, 'ºC'),
	(79822, 109, '2015-03-01 01:13:50.000000', 'temperatura', 621.0000, 'ºC'),
	(79823, 109, '2015-03-01 01:13:51.000000', 'temperatura', 1129.0000, 'ºC'),
	(79824, 109, '2015-03-01 01:13:52.000000', 'temperatura', 185.0000, 'ºC'),
	(79825, 109, '2015-03-01 01:13:53.000000', 'temperatura', 1136.0000, 'ºC'),
	(79826, 109, '2015-03-01 01:13:54.000000', 'temperatura', 327.0000, 'ºC'),
	(79827, 109, '2015-03-01 01:13:55.000000', 'temperatura', 626.0000, 'ºC'),
	(79828, 109, '2015-03-01 01:13:56.000000', 'temperatura', 951.0000, 'ºC'),
	(79829, 109, '2015-03-01 01:13:57.000000', 'temperatura', 479.0000, 'ºC'),
	(79830, 109, '2015-03-01 01:13:58.000000', 'temperatura', 740.0000, 'ºC'),
	(79831, 109, '2015-03-01 01:13:59.000000', 'temperatura', 1065.0000, 'ºC'),
	(79832, 109, '2015-03-01 01:14:00.000000', 'temperatura', 703.0000, 'ºC'),
	(79833, 109, '2015-03-01 01:14:01.000000', 'temperatura', 321.0000, 'ºC'),
	(79834, 109, '2015-03-01 01:14:02.000000', 'temperatura', 698.0000, 'ºC'),
	(79835, 109, '2015-03-01 01:14:03.000000', 'temperatura', 125.0000, 'ºC'),
	(79836, 109, '2015-03-01 01:14:04.000000', 'temperatura', 933.0000, 'ºC'),
	(79837, 109, '2015-03-01 01:14:05.000000', 'temperatura', 692.0000, 'ºC'),
	(79838, 109, '2015-03-01 01:14:06.000000', 'temperatura', 659.0000, 'ºC'),
	(79839, 109, '2015-03-01 01:14:07.000000', 'temperatura', 21.0000, 'ºC'),
	(79840, 109, '2015-03-01 01:14:08.000000', 'temperatura', 527.0000, 'ºC'),
	(79841, 109, '2015-03-01 01:14:09.000000', 'temperatura', 172.0000, 'ºC'),
	(79842, 109, '2015-03-01 01:14:10.000000', 'temperatura', 478.0000, 'ºC'),
	(79843, 109, '2015-03-01 01:14:11.000000', 'temperatura', 678.0000, 'ºC'),
	(79844, 109, '2015-03-01 01:14:12.000000', 'temperatura', 755.0000, 'ºC'),
	(79845, 109, '2015-03-01 01:14:13.000000', 'temperatura', 542.0000, 'ºC'),
	(79846, 109, '2015-03-01 01:14:14.000000', 'temperatura', 446.0000, 'ºC'),
	(79847, 109, '2015-03-01 01:14:15.000000', 'temperatura', 604.0000, 'ºC'),
	(79848, 109, '2015-03-01 01:14:16.000000', 'temperatura', 483.0000, 'ºC'),
	(79849, 109, '2015-03-01 01:14:17.000000', 'temperatura', 602.0000, 'ºC'),
	(79850, 109, '2015-03-01 01:14:18.000000', 'temperatura', 362.0000, 'ºC'),
	(79851, 109, '2015-03-01 01:14:19.000000', 'temperatura', 3.0000, 'ºC'),
	(79852, 109, '2015-03-01 01:14:20.000000', 'temperatura', 129.0000, 'ºC'),
	(79853, 109, '2015-03-01 01:14:21.000000', 'temperatura', 639.0000, 'ºC'),
	(79854, 109, '2015-03-01 01:14:22.000000', 'temperatura', 408.0000, 'ºC'),
	(79855, 109, '2015-03-01 01:14:23.000000', 'temperatura', 121.0000, 'ºC'),
	(79856, 109, '2015-03-01 01:14:24.000000', 'temperatura', 585.0000, 'ºC'),
	(79857, 109, '2015-03-01 01:14:25.000000', 'temperatura', 160.0000, 'ºC'),
	(79858, 109, '2015-03-01 01:14:26.000000', 'temperatura', 248.0000, 'ºC'),
	(79859, 109, '2015-03-01 01:14:27.000000', 'temperatura', 760.0000, 'ºC'),
	(79860, 109, '2015-03-01 01:14:28.000000', 'temperatura', 654.0000, 'ºC'),
	(79861, 109, '2015-03-01 01:14:29.000000', 'temperatura', 993.0000, 'ºC'),
	(79862, 109, '2015-03-01 01:14:30.000000', 'temperatura', 605.0000, 'ºC'),
	(79863, 109, '2015-03-01 01:14:31.000000', 'temperatura', 43.0000, 'ºC'),
	(79864, 109, '2015-03-01 01:14:32.000000', 'temperatura', 803.0000, 'ºC'),
	(79865, 109, '2015-03-01 01:14:33.000000', 'temperatura', 287.0000, 'ºC'),
	(79866, 109, '2015-03-01 01:14:34.000000', 'temperatura', 227.0000, 'ºC'),
	(79867, 109, '2015-03-01 01:14:35.000000', 'temperatura', 272.0000, 'ºC'),
	(79868, 109, '2015-03-01 01:14:36.000000', 'temperatura', 680.0000, 'ºC'),
	(79869, 109, '2015-03-01 01:14:37.000000', 'temperatura', 186.0000, 'ºC'),
	(79870, 109, '2015-03-01 01:14:38.000000', 'temperatura', 91.0000, 'ºC'),
	(79871, 109, '2015-03-01 01:14:39.000000', 'temperatura', 1097.0000, 'ºC'),
	(79872, 109, '2015-03-01 01:14:40.000000', 'temperatura', 412.0000, 'ºC'),
	(79873, 109, '2015-03-01 01:14:41.000000', 'temperatura', 1168.0000, 'ºC'),
	(79874, 109, '2015-03-01 01:14:42.000000', 'temperatura', 1004.0000, 'ºC'),
	(79875, 109, '2015-03-01 01:14:43.000000', 'temperatura', 320.0000, 'ºC'),
	(79876, 109, '2015-03-01 01:14:44.000000', 'temperatura', 985.0000, 'ºC'),
	(79877, 109, '2015-03-01 01:14:45.000000', 'temperatura', 367.0000, 'ºC'),
	(79878, 109, '2015-03-01 01:14:46.000000', 'temperatura', 79.0000, 'ºC'),
	(79879, 109, '2015-03-01 01:14:47.000000', 'temperatura', 496.0000, 'ºC'),
	(79880, 109, '2015-03-01 01:14:48.000000', 'temperatura', 1044.0000, 'ºC'),
	(79881, 109, '2015-03-01 01:14:49.000000', 'temperatura', 133.0000, 'ºC'),
	(79882, 109, '2015-03-01 01:14:50.000000', 'temperatura', 1131.0000, 'ºC'),
	(79883, 109, '2015-03-01 01:14:51.000000', 'temperatura', 460.0000, 'ºC'),
	(79884, 109, '2015-03-01 01:14:52.000000', 'temperatura', 105.0000, 'ºC'),
	(79885, 109, '2015-03-01 01:14:53.000000', 'temperatura', 345.0000, 'ºC'),
	(79886, 109, '2015-03-01 01:14:54.000000', 'temperatura', 211.0000, 'ºC'),
	(79887, 109, '2015-03-01 01:14:55.000000', 'temperatura', 22.0000, 'ºC'),
	(79888, 109, '2015-03-01 01:14:56.000000', 'temperatura', 676.0000, 'ºC'),
	(79889, 109, '2015-03-01 01:14:57.000000', 'temperatura', 916.0000, 'ºC'),
	(79890, 109, '2015-03-01 01:14:58.000000', 'temperatura', 151.0000, 'ºC'),
	(79891, 109, '2015-03-01 01:14:59.000000', 'temperatura', 406.0000, 'ºC'),
	(79892, 109, '2015-03-01 01:15:00.000000', 'temperatura', 381.0000, 'ºC'),
	(79893, 109, '2015-03-01 01:15:01.000000', 'temperatura', 685.0000, 'ºC'),
	(79894, 109, '2015-03-01 01:15:02.000000', 'temperatura', 1082.0000, 'ºC'),
	(79895, 109, '2015-03-01 01:15:03.000000', 'temperatura', 958.0000, 'ºC'),
	(79896, 109, '2015-03-01 01:15:04.000000', 'temperatura', 344.0000, 'ºC'),
	(79897, 109, '2015-03-01 01:15:05.000000', 'temperatura', 46.0000, 'ºC'),
	(79898, 109, '2015-03-01 01:15:06.000000', 'temperatura', 400.0000, 'ºC'),
	(79899, 109, '2015-03-01 01:15:07.000000', 'temperatura', 661.0000, 'ºC'),
	(79900, 109, '2015-03-01 01:15:08.000000', 'temperatura', 904.0000, 'ºC'),
	(79901, 109, '2015-03-01 01:15:09.000000', 'temperatura', 140.0000, 'ºC'),
	(79902, 109, '2015-03-01 01:15:10.000000', 'temperatura', 388.0000, 'ºC'),
	(79903, 109, '2015-03-01 01:15:11.000000', 'temperatura', 319.0000, 'ºC'),
	(79904, 109, '2015-03-01 01:15:12.000000', 'temperatura', 432.0000, 'ºC'),
	(79905, 109, '2015-03-01 01:15:13.000000', 'temperatura', 4.0000, 'ºC'),
	(79906, 109, '2015-03-01 01:15:14.000000', 'temperatura', 1125.0000, 'ºC'),
	(79907, 109, '2015-03-01 01:15:15.000000', 'temperatura', 814.0000, 'ºC'),
	(79908, 109, '2015-03-01 01:15:16.000000', 'temperatura', 694.0000, 'ºC'),
	(79909, 109, '2015-03-01 01:15:17.000000', 'temperatura', 1030.0000, 'ºC'),
	(79910, 109, '2015-03-01 01:15:18.000000', 'temperatura', 667.0000, 'ºC'),
	(79911, 109, '2015-03-01 01:15:19.000000', 'temperatura', 248.0000, 'ºC'),
	(79912, 109, '2015-03-01 01:15:20.000000', 'temperatura', 436.0000, 'ºC'),
	(79913, 109, '2015-03-01 01:15:21.000000', 'temperatura', 239.0000, 'ºC'),
	(79914, 109, '2015-03-01 01:15:22.000000', 'temperatura', 1086.0000, 'ºC'),
	(79915, 109, '2015-03-01 01:15:23.000000', 'temperatura', 1113.0000, 'ºC'),
	(79916, 109, '2015-03-01 01:15:24.000000', 'temperatura', 1110.0000, 'ºC'),
	(79917, 109, '2015-03-01 01:15:25.000000', 'temperatura', 1010.0000, 'ºC'),
	(79918, 109, '2015-03-01 01:15:26.000000', 'temperatura', 520.0000, 'ºC'),
	(79919, 109, '2015-03-01 01:15:27.000000', 'temperatura', 773.0000, 'ºC'),
	(79920, 109, '2015-03-01 01:15:28.000000', 'temperatura', 1104.0000, 'ºC'),
	(79921, 109, '2015-03-01 01:15:29.000000', 'temperatura', 802.0000, 'ºC'),
	(79922, 109, '2015-03-01 01:15:30.000000', 'temperatura', 697.0000, 'ºC'),
	(79923, 109, '2015-03-01 01:15:31.000000', 'temperatura', 1081.0000, 'ºC'),
	(79924, 109, '2015-03-01 01:15:32.000000', 'temperatura', 912.0000, 'ºC'),
	(79925, 109, '2015-03-01 01:15:33.000000', 'temperatura', 121.0000, 'ºC'),
	(79926, 109, '2015-03-01 01:15:34.000000', 'temperatura', 268.0000, 'ºC'),
	(79927, 109, '2015-03-01 01:15:35.000000', 'temperatura', 978.0000, 'ºC'),
	(79928, 109, '2015-03-01 01:15:36.000000', 'temperatura', 488.0000, 'ºC'),
	(79929, 109, '2015-03-01 01:15:37.000000', 'temperatura', 703.0000, 'ºC'),
	(79930, 109, '2015-03-01 01:15:38.000000', 'temperatura', 854.0000, 'ºC'),
	(79931, 109, '2015-03-01 01:15:39.000000', 'temperatura', 959.0000, 'ºC'),
	(79932, 109, '2015-03-01 01:15:40.000000', 'temperatura', 1034.0000, 'ºC'),
	(79933, 109, '2015-03-01 01:15:41.000000', 'temperatura', 1093.0000, 'ºC'),
	(79934, 109, '2015-03-01 01:15:42.000000', 'temperatura', 1164.0000, 'ºC'),
	(79935, 109, '2015-03-01 01:15:43.000000', 'temperatura', 144.0000, 'ºC'),
	(79936, 109, '2015-03-01 01:15:44.000000', 'temperatura', 825.0000, 'ºC'),
	(79937, 109, '2015-03-01 01:15:45.000000', 'temperatura', 97.0000, 'ºC'),
	(79938, 109, '2015-03-01 01:15:46.000000', 'temperatura', 407.0000, 'ºC'),
	(79939, 109, '2015-03-01 01:15:47.000000', 'temperatura', 546.0000, 'ºC'),
	(79940, 109, '2015-03-01 01:15:48.000000', 'temperatura', 308.0000, 'ºC'),
	(79941, 109, '2015-03-01 01:15:49.000000', 'temperatura', 1105.0000, 'ºC'),
	(79942, 109, '2015-03-01 01:15:50.000000', 'temperatura', 1001.0000, 'ºC'),
	(79943, 109, '2015-03-01 01:15:51.000000', 'temperatura', 488.0000, 'ºC'),
	(79944, 109, '2015-03-01 01:15:52.000000', 'temperatura', 639.0000, 'ºC'),
	(79945, 109, '2015-03-01 01:15:53.000000', 'temperatura', 531.0000, 'ºC'),
	(79946, 109, '2015-03-01 01:15:54.000000', 'temperatura', 737.0000, 'ºC'),
	(79947, 109, '2015-03-01 01:15:55.000000', 'temperatura', 895.0000, 'ºC'),
	(79948, 109, '2015-03-01 01:15:56.000000', 'temperatura', 1064.0000, 'ºC'),
	(79949, 109, '2015-03-01 01:15:57.000000', 'temperatura', 235.0000, 'ºC'),
	(79950, 109, '2015-03-01 01:15:58.000000', 'temperatura', 384.0000, 'ºC'),
	(79951, 109, '2015-03-01 01:15:59.000000', 'temperatura', 13.0000, 'ºC'),
	(79952, 109, '2015-03-01 01:16:00.000000', 'temperatura', 117.0000, 'ºC'),
	(79953, 109, '2015-03-01 01:16:01.000000', 'temperatura', 545.0000, 'ºC'),
	(79954, 109, '2015-03-01 01:16:02.000000', 'temperatura', 1177.0000, 'ºC'),
	(79955, 109, '2015-03-01 01:16:03.000000', 'temperatura', 647.0000, 'ºC'),
	(79956, 109, '2015-03-01 01:16:04.000000', 'temperatura', 906.0000, 'ºC'),
	(79957, 109, '2015-03-01 01:16:05.000000', 'temperatura', 191.0000, 'ºC'),
	(79958, 109, '2015-03-01 01:16:06.000000', 'temperatura', 638.0000, 'ºC'),
	(79959, 109, '2015-03-01 01:16:07.000000', 'temperatura', 217.0000, 'ºC'),
	(79960, 109, '2015-03-01 01:16:08.000000', 'temperatura', 370.0000, 'ºC'),
	(79961, 109, '2015-03-01 01:16:09.000000', 'temperatura', 1.0000, 'ºC'),
	(79962, 109, '2015-03-01 01:16:10.000000', 'temperatura', 96.0000, 'ºC'),
	(79963, 109, '2015-03-01 01:16:11.000000', 'temperatura', 478.0000, 'ºC'),
	(79964, 109, '2015-03-01 01:16:12.000000', 'temperatura', 901.0000, 'ºC'),
	(79965, 109, '2015-03-01 01:16:13.000000', 'temperatura', 671.0000, 'ºC'),
	(79966, 109, '2015-03-01 01:16:14.000000', 'temperatura', 655.0000, 'ºC'),
	(79967, 109, '2015-03-01 01:16:15.000000', 'temperatura', 59.0000, 'ºC'),
	(79968, 109, '2015-03-01 01:16:16.000000', 'temperatura', 733.0000, 'ºC'),
	(79969, 109, '2015-03-01 01:16:17.000000', 'temperatura', 1089.0000, 'ºC'),
	(79970, 109, '2015-03-01 01:16:18.000000', 'temperatura', 845.0000, 'ºC'),
	(79971, 109, '2015-03-01 01:16:19.000000', 'temperatura', 958.0000, 'ºC'),
	(79972, 109, '2015-03-01 01:16:20.000000', 'temperatura', 1056.0000, 'ºC'),
	(79973, 109, '2015-03-01 01:16:21.000000', 'temperatura', 6.0000, 'ºC'),
	(79974, 109, '2015-03-01 01:16:22.000000', 'temperatura', 463.0000, 'ºC'),
	(79975, 109, '2015-03-01 01:16:23.000000', 'temperatura', 1099.0000, 'ºC'),
	(79976, 109, '2015-03-01 01:16:24.000000', 'temperatura', 505.0000, 'ºC'),
	(79977, 109, '2015-03-01 01:16:25.000000', 'temperatura', 428.0000, 'ºC'),
	(79978, 109, '2015-03-01 01:16:26.000000', 'temperatura', 626.0000, 'ºC'),
	(79979, 109, '2015-03-01 01:16:27.000000', 'temperatura', 646.0000, 'ºC'),
	(79980, 109, '2015-03-01 01:16:28.000000', 'temperatura', 152.0000, 'ºC'),
	(79981, 109, '2015-03-01 01:16:29.000000', 'temperatura', 21.0000, 'ºC'),
	(79982, 109, '2015-03-01 01:16:30.000000', 'temperatura', 851.0000, 'ºC'),
	(79983, 109, '2015-03-01 01:16:31.000000', 'temperatura', 592.0000, 'ºC'),
	(79984, 109, '2015-03-01 01:16:32.000000', 'temperatura', 408.0000, 'ºC'),
	(79985, 109, '2015-03-01 01:16:33.000000', 'temperatura', 265.0000, 'ºC'),
	(79986, 109, '2015-03-01 01:16:34.000000', 'temperatura', 100.0000, 'ºC'),
	(79987, 109, '2015-03-01 01:16:35.000000', 'temperatura', 907.0000, 'ºC'),
	(79988, 109, '2015-03-01 01:16:36.000000', 'temperatura', 633.0000, 'ºC'),
	(79989, 109, '2015-03-01 01:16:37.000000', 'temperatura', 446.0000, 'ºC'),
	(79990, 109, '2015-03-01 01:16:38.000000', 'temperatura', 333.0000, 'ºC'),
	(79991, 109, '2015-03-01 01:16:39.000000', 'temperatura', 327.0000, 'ºC'),
	(79992, 109, '2015-03-01 01:16:40.000000', 'temperatura', 638.0000, 'ºC'),
	(79993, 109, '2015-03-01 01:16:41.000000', 'temperatura', 1006.0000, 'ºC'),
	(79994, 109, '2015-03-01 01:16:42.000000', 'temperatura', 720.0000, 'ºC'),
	(79995, 109, '2015-03-01 01:16:43.000000', 'temperatura', 580.0000, 'ºC'),
	(79996, 109, '2015-03-01 01:16:44.000000', 'temperatura', 741.0000, 'ºC'),
	(79997, 109, '2015-03-01 01:16:45.000000', 'temperatura', 768.0000, 'ºC'),
	(79998, 109, '2015-03-01 01:16:46.000000', 'temperatura', 414.0000, 'ºC'),
	(79999, 109, '2015-03-01 01:16:47.000000', 'temperatura', 969.0000, 'ºC'),
	(80000, 109, '2015-03-01 01:16:48.000000', 'temperatura', 2.0000, 'ºC'),
	(80001, 109, '2015-03-01 01:16:49.000000', 'temperatura', 703.0000, 'ºC'),
	(80002, 109, '2015-03-01 01:16:50.000000', 'temperatura', 1111.0000, 'ºC'),
	(80003, 109, '2015-03-01 01:16:51.000000', 'temperatura', 1047.0000, 'ºC'),
	(80004, 109, '2015-03-01 01:16:52.000000', 'temperatura', 703.0000, 'ºC'),
	(80005, 109, '2015-03-01 01:16:53.000000', 'temperatura', 375.0000, 'ºC'),
	(80006, 109, '2015-03-01 01:16:54.000000', 'temperatura', 965.0000, 'ºC'),
	(80007, 109, '2015-03-01 01:16:55.000000', 'temperatura', 100.0000, 'ºC'),
	(80008, 109, '2015-03-01 01:16:56.000000', 'temperatura', 5.0000, 'ºC'),
	(80009, 109, '2015-03-01 01:16:57.000000', 'temperatura', 925.0000, 'ºC'),
	(80010, 109, '2015-03-01 01:16:58.000000', 'temperatura', 1012.0000, 'ºC'),
	(80011, 109, '2015-03-01 01:16:59.000000', 'temperatura', 1084.0000, 'ºC'),
	(80012, 109, '2015-03-01 01:17:00.000000', 'temperatura', 1186.0000, 'ºC'),
	(80013, 109, '2015-03-01 01:17:01.000000', 'temperatura', 279.0000, 'ºC'),
	(80014, 109, '2015-03-01 01:17:02.000000', 'temperatura', 235.0000, 'ºC'),
	(80015, 109, '2015-03-01 01:17:03.000000', 'temperatura', 339.0000, 'ºC'),
	(80016, 109, '2015-03-01 01:17:04.000000', 'temperatura', 991.0000, 'ºC'),
	(80017, 109, '2015-03-01 01:17:05.000000', 'temperatura', 337.0000, 'ºC'),
	(80018, 109, '2015-03-01 01:17:06.000000', 'temperatura', 1112.0000, 'ºC'),
	(80019, 109, '2015-03-01 01:17:07.000000', 'temperatura', 949.0000, 'ºC'),
	(80020, 109, '2015-03-01 01:17:08.000000', 'temperatura', 212.0000, 'ºC'),
	(80021, 109, '2015-03-01 01:17:09.000000', 'temperatura', 611.0000, 'ºC'),
	(80022, 109, '2015-03-01 01:17:10.000000', 'temperatura', 20.0000, 'ºC'),
	(80023, 109, '2015-03-01 01:17:11.000000', 'temperatura', 666.0000, 'ºC'),
	(80024, 109, '2015-03-01 01:17:12.000000', 'temperatura', 874.0000, 'ºC'),
	(80025, 109, '2015-03-01 01:17:13.000000', 'temperatura', 1170.0000, 'ºC'),
	(80026, 109, '2015-03-01 01:17:14.000000', 'temperatura', 830.0000, 'ºC'),
	(80027, 109, '2015-03-01 01:17:15.000000', 'temperatura', 642.0000, 'ºC'),
	(80028, 109, '2015-03-01 01:17:16.000000', 'temperatura', 718.0000, 'ºC'),
	(80029, 109, '2015-03-01 01:17:17.000000', 'temperatura', 464.0000, 'ºC'),
	(80030, 109, '2015-03-01 01:17:18.000000', 'temperatura', 169.0000, 'ºC'),
	(80031, 109, '2015-03-01 01:17:19.000000', 'temperatura', 653.0000, 'ºC'),
	(80032, 109, '2015-03-01 01:17:20.000000', 'temperatura', 359.0000, 'ºC'),
	(80033, 109, '2015-03-01 01:17:21.000000', 'temperatura', 1035.0000, 'ºC'),
	(80034, 109, '2015-03-01 01:17:22.000000', 'temperatura', 501.0000, 'ºC'),
	(80035, 109, '2015-03-01 01:17:23.000000', 'temperatura', 598.0000, 'ºC'),
	(80036, 109, '2015-03-01 01:17:24.000000', 'temperatura', 288.0000, 'ºC'),
	(80037, 109, '2015-03-01 01:17:25.000000', 'temperatura', 848.0000, 'ºC'),
	(80038, 109, '2015-03-01 01:17:26.000000', 'temperatura', 974.0000, 'ºC'),
	(80039, 109, '2015-03-01 01:17:27.000000', 'temperatura', 1127.0000, 'ºC'),
	(80040, 109, '2015-03-01 01:17:28.000000', 'temperatura', 315.0000, 'ºC'),
	(80041, 109, '2015-03-01 01:17:29.000000', 'temperatura', 595.0000, 'ºC'),
	(80042, 109, '2015-03-01 01:17:30.000000', 'temperatura', 828.0000, 'ºC'),
	(80043, 109, '2015-03-01 01:17:31.000000', 'temperatura', 1155.0000, 'ºC'),
	(80044, 109, '2015-03-01 01:17:32.000000', 'temperatura', 894.0000, 'ºC'),
	(80045, 109, '2015-03-01 01:17:33.000000', 'temperatura', 1005.0000, 'ºC'),
	(80046, 109, '2015-03-01 01:17:34.000000', 'temperatura', 1144.0000, 'ºC'),
	(80047, 109, '2015-03-01 01:17:35.000000', 'temperatura', 304.0000, 'ºC'),
	(80048, 109, '2015-03-01 01:17:36.000000', 'temperatura', 490.0000, 'ºC'),
	(80049, 109, '2015-03-01 01:17:37.000000', 'temperatura', 337.0000, 'ºC'),
	(80050, 109, '2015-03-01 01:17:38.000000', 'temperatura', 216.0000, 'ºC'),
	(80051, 109, '2015-03-01 01:17:39.000000', 'temperatura', 69.0000, 'ºC'),
	(80052, 109, '2015-03-01 01:17:40.000000', 'temperatura', 899.0000, 'ºC'),
	(80053, 109, '2015-03-01 01:17:41.000000', 'temperatura', 686.0000, 'ºC'),
	(80054, 109, '2015-03-01 01:17:42.000000', 'temperatura', 737.0000, 'ºC'),
	(80055, 109, '2015-03-01 01:17:43.000000', 'temperatura', 424.0000, 'ºC'),
	(80056, 109, '2015-03-01 01:17:44.000000', 'temperatura', 1113.0000, 'ºC'),
	(80057, 109, '2015-03-01 01:17:45.000000', 'temperatura', 691.0000, 'ºC'),
	(80058, 109, '2015-03-01 01:17:46.000000', 'temperatura', 119.0000, 'ºC'),
	(80059, 109, '2015-03-01 01:17:47.000000', 'temperatura', 919.0000, 'ºC'),
	(80060, 109, '2015-03-01 01:17:48.000000', 'temperatura', 641.0000, 'ºC'),
	(80061, 109, '2015-03-01 01:17:49.000000', 'temperatura', 448.0000, 'ºC'),
	(80062, 109, '2015-03-01 01:17:50.000000', 'temperatura', 317.0000, 'ºC'),
	(80063, 109, '2015-03-01 01:17:51.000000', 'temperatura', 240.0000, 'ºC'),
	(80064, 109, '2015-03-01 01:17:52.000000', 'temperatura', 252.0000, 'ºC'),
	(80065, 109, '2015-03-01 01:17:53.000000', 'temperatura', 538.0000, 'ºC'),
	(80066, 109, '2015-03-01 01:17:54.000000', 'temperatura', 736.0000, 'ºC'),
	(80067, 109, '2015-03-01 01:17:55.000000', 'temperatura', 864.0000, 'ºC'),
	(80068, 109, '2015-03-01 01:17:56.000000', 'temperatura', 915.0000, 'ºC'),
	(80069, 109, '2015-03-01 01:17:57.000000', 'temperatura', 781.0000, 'ºC'),
	(80070, 109, '2015-03-01 01:17:58.000000', 'temperatura', 1162.0000, 'ºC'),
	(80071, 109, '2015-03-01 01:17:59.000000', 'temperatura', 1066.0000, 'ºC'),
	(80072, 109, '2015-03-01 01:18:00.000000', 'temperatura', 645.0000, 'ºC'),
	(80073, 109, '2015-03-01 01:18:01.000000', 'temperatura', 29.0000, 'ºC'),
	(80074, 109, '2015-03-01 01:18:02.000000', 'temperatura', 610.0000, 'ºC'),
	(80075, 109, '2015-03-01 01:18:03.000000', 'temperatura', 564.0000, 'ºC'),
	(80076, 109, '2015-03-01 01:18:04.000000', 'temperatura', 991.0000, 'ºC'),
	(80077, 109, '2015-03-01 01:18:05.000000', 'temperatura', 863.0000, 'ºC'),
	(80078, 109, '2015-03-01 01:18:06.000000', 'temperatura', 143.0000, 'ºC'),
	(80079, 109, '2015-03-01 01:18:07.000000', 'temperatura', 525.0000, 'ºC'),
	(80080, 109, '2015-03-01 01:18:08.000000', 'temperatura', 997.0000, 'ºC'),
	(80081, 109, '2015-03-01 01:18:09.000000', 'temperatura', 1011.0000, 'ºC'),
	(80082, 109, '2015-03-01 01:18:10.000000', 'temperatura', 862.0000, 'ºC'),
	(80083, 109, '2015-03-01 01:18:11.000000', 'temperatura', 80.0000, 'ºC'),
	(80084, 109, '2015-03-01 01:18:12.000000', 'temperatura', 215.0000, 'ºC'),
	(80085, 109, '2015-03-01 01:18:13.000000', 'temperatura', 836.0000, 'ºC'),
	(80086, 109, '2015-03-01 01:18:14.000000', 'temperatura', 1134.0000, 'ºC'),
	(80087, 109, '2015-03-01 01:18:15.000000', 'temperatura', 761.0000, 'ºC'),
	(80088, 109, '2015-03-01 01:18:16.000000', 'temperatura', 407.0000, 'ºC'),
	(80089, 109, '2015-03-01 01:18:17.000000', 'temperatura', 950.0000, 'ºC'),
	(80090, 109, '2015-03-01 01:18:18.000000', 'temperatura', 1128.0000, 'ºC'),
	(80091, 109, '2015-03-01 01:18:19.000000', 'temperatura', 393.0000, 'ºC'),
	(80092, 109, '2015-03-01 01:18:20.000000', 'temperatura', 979.0000, 'ºC'),
	(80093, 109, '2015-03-01 01:18:21.000000', 'temperatura', 117.0000, 'ºC'),
	(80094, 109, '2015-03-01 01:18:22.000000', 'temperatura', 47.0000, 'ºC'),
	(80095, 109, '2015-03-01 01:18:23.000000', 'temperatura', 1086.0000, 'ºC'),
	(80096, 109, '2015-03-01 01:18:24.000000', 'temperatura', 489.0000, 'ºC'),
	(80097, 109, '2015-03-01 01:18:25.000000', 'temperatura', 388.0000, 'ºC'),
	(80098, 109, '2015-03-01 01:18:26.000000', 'temperatura', 473.0000, 'ºC'),
	(80099, 109, '2015-03-01 01:18:27.000000', 'temperatura', 2.0000, 'ºC'),
	(80100, 109, '2015-03-01 01:18:28.000000', 'temperatura', 990.0000, 'ºC'),
	(80101, 109, '2015-03-01 01:18:29.000000', 'temperatura', 147.0000, 'ºC'),
	(80102, 109, '2015-03-01 01:18:30.000000', 'temperatura', 163.0000, 'ºC'),
	(80103, 109, '2015-03-01 01:18:31.000000', 'temperatura', 374.0000, 'ºC'),
	(80104, 109, '2015-03-01 01:18:32.000000', 'temperatura', 183.0000, 'ºC'),
	(80105, 109, '2015-03-01 01:18:33.000000', 'temperatura', 995.0000, 'ºC'),
	(80106, 109, '2015-03-01 01:18:34.000000', 'temperatura', 825.0000, 'ºC'),
	(80107, 109, '2015-03-01 01:18:35.000000', 'temperatura', 1142.0000, 'ºC'),
	(80108, 109, '2015-03-01 01:18:36.000000', 'temperatura', 834.0000, 'ºC'),
	(80109, 109, '2015-03-01 01:18:37.000000', 'temperatura', 744.0000, 'ºC'),
	(80110, 109, '2015-03-01 01:18:38.000000', 'temperatura', 21.0000, 'ºC'),
	(80111, 109, '2015-03-01 01:18:39.000000', 'temperatura', 273.0000, 'ºC'),
	(80112, 109, '2015-03-01 01:18:40.000000', 'temperatura', 100.0000, 'ºC'),
	(80113, 109, '2015-03-01 01:18:41.000000', 'temperatura', 882.0000, 'ºC'),
	(80114, 109, '2015-03-01 01:18:42.000000', 'temperatura', 513.0000, 'ºC'),
	(80115, 109, '2015-03-01 01:18:43.000000', 'temperatura', 1118.0000, 'ºC'),
	(80116, 109, '2015-03-01 01:18:44.000000', 'temperatura', 450.0000, 'ºC'),
	(80117, 109, '2015-03-01 01:18:45.000000', 'temperatura', 99.0000, 'ºC'),
	(80118, 109, '2015-03-01 01:18:46.000000', 'temperatura', 344.0000, 'ºC'),
	(80119, 109, '2015-03-01 01:18:47.000000', 'temperatura', 224.0000, 'ºC'),
	(80120, 109, '2015-03-01 01:18:48.000000', 'temperatura', 90.0000, 'ºC'),
	(80121, 109, '2015-03-01 01:18:49.000000', 'temperatura', 977.0000, 'ºC'),
	(80122, 109, '2015-03-01 01:18:50.000000', 'temperatura', 1015.0000, 'ºC'),
	(80123, 109, '2015-03-01 01:18:51.000000', 'temperatura', 944.0000, 'ºC'),
	(80124, 109, '2015-03-01 01:18:52.000000', 'temperatura', 478.0000, 'ºC'),
	(80125, 109, '2015-03-01 01:18:53.000000', 'temperatura', 757.0000, 'ºC'),
	(80126, 109, '2015-03-01 01:18:54.000000', 'temperatura', 1151.0000, 'ºC'),
	(80127, 109, '2015-03-01 01:18:55.000000', 'temperatura', 1084.0000, 'ºC'),
	(80128, 109, '2015-03-01 01:18:56.000000', 'temperatura', 768.0000, 'ºC'),
	(80129, 109, '2015-03-01 01:18:57.000000', 'temperatura', 589.0000, 'ºC'),
	(80130, 109, '2015-03-01 01:18:58.000000', 'temperatura', 643.0000, 'ºC'),
	(80131, 109, '2015-03-01 01:18:59.000000', 'temperatura', 245.0000, 'ºC'),
	(80132, 109, '2015-03-01 01:19:00.000000', 'temperatura', 500.0000, 'ºC'),
	(80133, 109, '2015-03-01 01:19:01.000000', 'temperatura', 563.0000, 'ºC'),
	(80134, 109, '2015-03-01 01:19:02.000000', 'temperatura', 116.0000, 'ºC'),
	(80135, 109, '2015-03-01 01:19:03.000000', 'temperatura', 92.0000, 'ºC'),
	(80136, 109, '2015-03-01 01:19:04.000000', 'temperatura', 114.0000, 'ºC'),
	(80137, 109, '2015-03-01 01:19:05.000000', 'temperatura', 292.0000, 'ºC'),
	(80138, 109, '2015-03-01 01:19:06.000000', 'temperatura', 1120.0000, 'ºC'),
	(80139, 109, '2015-03-01 01:19:07.000000', 'temperatura', 1123.0000, 'ºC'),
	(80140, 109, '2015-03-01 01:19:08.000000', 'temperatura', 1055.0000, 'ºC'),
	(80141, 109, '2015-03-01 01:19:09.000000', 'temperatura', 708.0000, 'ºC'),
	(80142, 109, '2015-03-01 01:19:10.000000', 'temperatura', 375.0000, 'ºC'),
	(80143, 109, '2015-03-01 01:19:11.000000', 'temperatura', 952.0000, 'ºC'),
	(80144, 109, '2015-03-01 01:19:12.000000', 'temperatura', 37.0000, 'ºC'),
	(80145, 109, '2015-03-01 01:19:13.000000', 'temperatura', 929.0000, 'ºC'),
	(80146, 109, '2015-03-01 01:19:14.000000', 'temperatura', 936.0000, 'ºC'),
	(80147, 109, '2015-03-01 01:19:15.000000', 'temperatura', 690.0000, 'ºC'),
	(80148, 109, '2015-03-01 01:19:16.000000', 'temperatura', 644.0000, 'ºC'),
	(80149, 109, '2015-03-01 01:19:17.000000', 'temperatura', 1152.0000, 'ºC'),
	(80150, 109, '2015-03-01 01:19:18.000000', 'temperatura', 229.0000, 'ºC'),
	(80151, 109, '2015-03-01 01:19:19.000000', 'temperatura', 89.0000, 'ºC'),
	(80152, 109, '2015-03-01 01:19:20.000000', 'temperatura', 958.0000, 'ºC'),
	(80153, 109, '2015-03-01 01:19:21.000000', 'temperatura', 925.0000, 'ºC'),
	(80154, 109, '2015-03-01 01:19:22.000000', 'temperatura', 551.0000, 'ºC'),
	(80155, 109, '2015-03-01 01:19:23.000000', 'temperatura', 1180.0000, 'ºC'),
	(80156, 109, '2015-03-01 01:19:24.000000', 'temperatura', 649.0000, 'ºC'),
	(80157, 109, '2015-03-01 01:19:25.000000', 'temperatura', 905.0000, 'ºC'),
	(80158, 109, '2015-03-01 01:19:26.000000', 'temperatura', 180.0000, 'ºC'),
	(80159, 109, '2015-03-01 01:19:27.000000', 'temperatura', 585.0000, 'ºC'),
	(80160, 109, '2015-03-01 01:19:28.000000', 'temperatura', 1184.0000, 'ºC'),
	(80161, 109, '2015-03-01 01:19:29.000000', 'temperatura', 568.0000, 'ºC'),
	(80162, 109, '2015-03-01 01:19:30.000000', 'temperatura', 488.0000, 'ºC'),
	(80163, 109, '2015-03-01 01:19:31.000000', 'temperatura', 737.0000, 'ºC'),
	(80164, 109, '2015-03-01 01:19:32.000000', 'temperatura', 1020.0000, 'ºC'),
	(80165, 109, '2015-03-01 01:19:33.000000', 'temperatura', 491.0000, 'ºC'),
	(80166, 109, '2015-03-01 01:19:34.000000', 'temperatura', 597.0000, 'ºC'),
	(80167, 109, '2015-03-01 01:19:35.000000', 'temperatura', 309.0000, 'ºC'),
	(80168, 109, '2015-03-01 01:19:36.000000', 'temperatura', 956.0000, 'ºC'),
	(80169, 109, '2015-03-01 01:19:37.000000', 'temperatura', 254.0000, 'ºC'),
	(80170, 109, '2015-03-01 01:19:38.000000', 'temperatura', 803.0000, 'ºC'),
	(80171, 109, '2015-03-01 01:19:39.000000', 'temperatura', 852.0000, 'ºC'),
	(80172, 109, '2015-03-01 01:19:40.000000', 'temperatura', 652.0000, 'ºC'),
	(80173, 109, '2015-03-01 01:19:41.000000', 'temperatura', 706.0000, 'ºC'),
	(80174, 109, '2015-03-01 01:19:42.000000', 'temperatura', 372.0000, 'ºC'),
	(80175, 109, '2015-03-01 01:19:43.000000', 'temperatura', 945.0000, 'ºC'),
	(80176, 109, '2015-03-01 01:19:44.000000', 'temperatura', 8.0000, 'ºC'),
	(80177, 109, '2015-03-01 01:19:45.000000', 'temperatura', 804.0000, 'ºC'),
	(80178, 109, '2015-03-01 01:19:46.000000', 'temperatura', 397.0000, 'ºC'),
	(80179, 109, '2015-03-01 01:19:47.000000', 'temperatura', 774.0000, 'ºC'),
	(80180, 109, '2015-03-01 01:19:48.000000', 'temperatura', 280.0000, 'ºC'),
	(80181, 109, '2015-03-01 01:19:49.000000', 'temperatura', 278.0000, 'ºC'),
	(80182, 109, '2015-03-01 01:19:50.000000', 'temperatura', 551.0000, 'ºC'),
	(80183, 109, '2015-03-01 01:19:51.000000', 'temperatura', 721.0000, 'ºC'),
	(80184, 109, '2015-03-01 01:19:52.000000', 'temperatura', 755.0000, 'ºC'),
	(80185, 109, '2015-03-01 01:19:53.000000', 'temperatura', 409.0000, 'ºC'),
	(80186, 109, '2015-03-01 01:19:54.000000', 'temperatura', 984.0000, 'ºC'),
	(80187, 109, '2015-03-01 01:19:55.000000', 'temperatura', 91.0000, 'ºC'),
	(80188, 109, '2015-03-01 01:19:56.000000', 'temperatura', 1103.0000, 'ºC'),
	(80189, 109, '2015-03-01 01:19:57.000000', 'temperatura', 442.0000, 'ºC'),
	(80190, 109, '2015-03-01 01:19:58.000000', 'temperatura', 103.0000, 'ºC'),
	(80191, 109, '2015-03-01 01:19:59.000000', 'temperatura', 389.0000, 'ºC'),
	(80192, 109, '2015-03-01 01:20:00.000000', 'temperatura', 437.0000, 'ºC'),
	(80193, 109, '2015-03-01 01:20:01.000000', 'temperatura', 1017.0000, 'ºC'),
	(80194, 109, '2015-03-01 01:20:02.000000', 'temperatura', 176.0000, 'ºC'),
	(80195, 109, '2015-03-01 01:20:03.000000', 'temperatura', 231.0000, 'ºC'),
	(80196, 109, '2015-03-01 01:20:04.000000', 'temperatura', 624.0000, 'ºC'),
	(80197, 109, '2015-03-01 01:20:05.000000', 'temperatura', 29.0000, 'ºC'),
	(80198, 109, '2015-03-01 01:20:06.000000', 'temperatura', 675.0000, 'ºC'),
	(80199, 109, '2015-03-01 01:20:07.000000', 'temperatura', 889.0000, 'ºC'),
	(80200, 109, '2015-03-01 01:20:08.000000', 'temperatura', 21.0000, 'ºC'),
	(80201, 109, '2015-03-01 01:20:09.000000', 'temperatura', 1039.0000, 'ºC'),
	(80202, 109, '2015-03-01 01:20:10.000000', 'temperatura', 332.0000, 'ºC'),
	(80203, 109, '2015-03-01 01:20:11.000000', 'temperatura', 944.0000, 'ºC'),
	(80204, 109, '2015-03-01 01:20:12.000000', 'temperatura', 124.0000, 'ºC'),
	(80205, 109, '2015-03-01 01:20:13.000000', 'temperatura', 190.0000, 'ºC'),
	(80206, 109, '2015-03-01 01:20:14.000000', 'temperatura', 576.0000, 'ºC'),
	(80207, 109, '2015-03-01 01:20:15.000000', 'temperatura', 1110.0000, 'ºC'),
	(80208, 109, '2015-03-01 01:20:16.000000', 'temperatura', 224.0000, 'ºC'),
	(80209, 109, '2015-03-01 01:20:17.000000', 'temperatura', 190.0000, 'ºC'),
	(80210, 109, '2015-03-01 01:20:18.000000', 'temperatura', 278.0000, 'ºC'),
	(80211, 109, '2015-03-01 01:20:19.000000', 'temperatura', 821.0000, 'ºC'),
	(80212, 109, '2015-03-01 01:20:20.000000', 'temperatura', 873.0000, 'ºC'),
	(80213, 109, '2015-03-01 01:20:21.000000', 'temperatura', 702.0000, 'ºC'),
	(80214, 109, '2015-03-01 01:20:22.000000', 'temperatura', 891.0000, 'ºC'),
	(80215, 109, '2015-03-01 01:20:23.000000', 'temperatura', 1148.0000, 'ºC'),
	(80216, 109, '2015-03-01 01:20:24.000000', 'temperatura', 669.0000, 'ºC'),
	(80217, 109, '2015-03-01 01:20:25.000000', 'temperatura', 1103.0000, 'ºC'),
	(80218, 109, '2015-03-01 01:20:26.000000', 'temperatura', 1105.0000, 'ºC'),
	(80219, 109, '2015-03-01 01:20:27.000000', 'temperatura', 1020.0000, 'ºC'),
	(80220, 109, '2015-03-01 01:20:28.000000', 'temperatura', 584.0000, 'ºC'),
	(80221, 109, '2015-03-01 01:20:29.000000', 'temperatura', 1062.0000, 'ºC'),
	(80222, 109, '2015-03-01 01:20:30.000000', 'temperatura', 1156.0000, 'ºC'),
	(80223, 109, '2015-03-01 01:20:31.000000', 'temperatura', 197.0000, 'ºC'),
	(80224, 109, '2015-03-01 01:20:32.000000', 'temperatura', 1118.0000, 'ºC'),
	(80225, 109, '2015-03-01 01:20:33.000000', 'temperatura', 200.0000, 'ºC'),
	(80226, 109, '2015-03-01 01:20:34.000000', 'temperatura', 46.0000, 'ºC'),
	(80227, 109, '2015-03-01 01:20:35.000000', 'temperatura', 829.0000, 'ºC'),
	(80228, 109, '2015-03-01 01:20:36.000000', 'temperatura', 409.0000, 'ºC'),
	(80229, 109, '2015-03-01 01:20:37.000000', 'temperatura', 760.0000, 'ºC'),
	(80230, 109, '2015-03-01 01:20:38.000000', 'temperatura', 170.0000, 'ºC'),
	(80231, 109, '2015-03-01 01:20:39.000000', 'temperatura', 973.0000, 'ºC'),
	(80232, 109, '2015-03-01 01:20:40.000000', 'temperatura', 755.0000, 'ºC'),
	(80233, 109, '2015-03-01 01:20:41.000000', 'temperatura', 857.0000, 'ºC'),
	(80234, 109, '2015-03-01 01:20:42.000000', 'temperatura', 818.0000, 'ºC'),
	(80235, 109, '2015-03-01 01:20:43.000000', 'temperatura', 321.0000, 'ºC'),
	(80236, 109, '2015-03-01 01:20:44.000000', 'temperatura', 351.0000, 'ºC'),
	(80237, 109, '2015-03-01 01:20:45.000000', 'temperatura', 794.0000, 'ºC'),
	(80238, 109, '2015-03-01 01:20:46.000000', 'temperatura', 517.0000, 'ºC'),
	(80239, 109, '2015-03-01 01:20:47.000000', 'temperatura', 204.0000, 'ºC'),
	(80240, 109, '2015-03-01 01:20:48.000000', 'temperatura', 670.0000, 'ºC'),
	(80241, 109, '2015-03-01 01:20:49.000000', 'temperatura', 337.0000, 'ºC'),
	(80242, 109, '2015-03-01 01:20:50.000000', 'temperatura', 878.0000, 'ºC'),
	(80243, 109, '2015-03-01 01:20:51.000000', 'temperatura', 977.0000, 'ºC'),
	(80244, 109, '2015-03-01 01:20:52.000000', 'temperatura', 1051.0000, 'ºC'),
	(80245, 109, '2015-03-01 01:20:53.000000', 'temperatura', 1124.0000, 'ºC'),
	(80246, 109, '2015-03-01 01:20:54.000000', 'temperatura', 68.0000, 'ºC'),
	(80247, 109, '2015-03-01 01:20:55.000000', 'temperatura', 569.0000, 'ºC'),
	(80248, 109, '2015-03-01 01:20:56.000000', 'temperatura', 240.0000, 'ºC'),
	(80249, 109, '2015-03-01 01:20:57.000000', 'temperatura', 695.0000, 'ºC'),
	(80250, 109, '2015-03-01 01:20:58.000000', 'temperatura', 354.0000, 'ºC'),
	(80251, 109, '2015-03-01 01:20:59.000000', 'temperatura', 886.0000, 'ºC'),
	(80252, 109, '2015-03-01 01:21:00.000000', 'temperatura', 967.0000, 'ºC'),
	(80253, 109, '2015-03-01 01:21:01.000000', 'temperatura', 979.0000, 'ºC'),
	(80254, 109, '2015-03-01 01:21:02.000000', 'temperatura', 795.0000, 'ºC'),
	(80255, 109, '2015-03-01 01:21:03.000000', 'temperatura', 1037.0000, 'ºC'),
	(80256, 109, '2015-03-01 01:21:04.000000', 'temperatura', 402.0000, 'ºC'),
	(80257, 109, '2015-03-01 01:21:05.000000', 'temperatura', 97.0000, 'ºC'),
	(80258, 109, '2015-03-01 01:21:06.000000', 'temperatura', 482.0000, 'ºC'),
	(80259, 109, '2015-03-01 01:21:07.000000', 'temperatura', 919.0000, 'ºC'),
	(80260, 109, '2015-03-01 01:21:08.000000', 'temperatura', 750.0000, 'ºC'),
	(80261, 109, '2015-03-01 01:21:09.000000', 'temperatura', 993.0000, 'ºC'),
	(80262, 109, '2015-03-01 01:21:10.000000', 'temperatura', 317.0000, 'ºC'),
	(80263, 109, '2015-03-01 01:21:11.000000', 'temperatura', 1005.0000, 'ºC'),
	(80264, 109, '2015-03-01 01:21:12.000000', 'temperatura', 474.0000, 'ºC'),
	(80265, 109, '2015-03-01 01:21:13.000000', 'temperatura', 554.0000, 'ºC'),
	(80266, 109, '2015-03-01 01:21:14.000000', 'temperatura', 151.0000, 'ºC'),
	(80267, 109, '2015-03-01 01:21:15.000000', 'temperatura', 293.0000, 'ºC'),
	(80268, 109, '2015-03-01 01:21:16.000000', 'temperatura', 1011.0000, 'ºC'),
	(80269, 109, '2015-03-01 01:21:17.000000', 'temperatura', 578.0000, 'ºC'),
	(80270, 109, '2015-03-01 01:21:18.000000', 'temperatura', 1059.0000, 'ºC'),
	(80271, 109, '2015-03-01 01:21:19.000000', 'temperatura', 1159.0000, 'ºC'),
	(80272, 109, '2015-03-01 01:21:20.000000', 'temperatura', 221.0000, 'ºC'),
	(80273, 109, '2015-03-01 01:21:21.000000', 'temperatura', 26.0000, 'ºC'),
	(80274, 109, '2015-03-01 01:21:22.000000', 'temperatura', 668.0000, 'ºC'),
	(80275, 109, '2015-03-01 01:21:23.000000', 'temperatura', 862.0000, 'ºC'),
	(80276, 109, '2015-03-01 01:21:24.000000', 'temperatura', 1106.0000, 'ºC'),
	(80277, 109, '2015-03-01 01:21:25.000000', 'temperatura', 545.0000, 'ºC'),
	(80278, 109, '2015-03-01 01:21:26.000000', 'temperatura', 610.0000, 'ºC'),
	(80279, 109, '2015-03-01 01:21:27.000000', 'temperatura', 212.0000, 'ºC'),
	(80280, 109, '2015-03-01 01:21:28.000000', 'temperatura', 434.0000, 'ºC'),
	(80281, 109, '2015-03-01 01:21:29.000000', 'temperatura', 332.0000, 'ºC'),
	(80282, 109, '2015-03-01 01:21:30.000000', 'temperatura', 357.0000, 'ºC'),
	(80283, 109, '2015-03-01 01:21:31.000000', 'temperatura', 792.0000, 'ºC'),
	(80284, 109, '2015-03-01 01:21:32.000000', 'temperatura', 489.0000, 'ºC'),
	(80285, 109, '2015-03-01 01:21:33.000000', 'temperatura', 70.0000, 'ºC'),
	(80286, 109, '2015-03-01 01:21:34.000000', 'temperatura', 85.0000, 'ºC'),
	(80287, 109, '2015-03-01 01:21:35.000000', 'temperatura', 213.0000, 'ºC'),
	(80288, 109, '2015-03-01 01:21:36.000000', 'temperatura', 813.0000, 'ºC'),
	(80289, 109, '2015-03-01 01:21:37.000000', 'temperatura', 1023.0000, 'ºC'),
	(80290, 109, '2015-03-01 01:21:38.000000', 'temperatura', 280.0000, 'ºC'),
	(80291, 109, '2015-03-01 01:21:39.000000', 'temperatura', 729.0000, 'ºC'),
	(80292, 109, '2015-03-01 01:21:40.000000', 'temperatura', 406.0000, 'ºC'),
	(80293, 109, '2015-03-01 01:21:41.000000', 'temperatura', 1045.0000, 'ºC'),
	(80294, 109, '2015-03-01 01:21:42.000000', 'temperatura', 408.0000, 'ºC'),
	(80295, 109, '2015-03-01 01:21:43.000000', 'temperatura', 104.0000, 'ºC'),
	(80296, 109, '2015-03-01 01:21:44.000000', 'temperatura', 496.0000, 'ºC'),
	(80297, 109, '2015-03-01 01:21:45.000000', 'temperatura', 967.0000, 'ºC'),
	(80298, 109, '2015-03-01 01:21:46.000000', 'temperatura', 949.0000, 'ºC'),
	(80299, 109, '2015-03-01 01:21:47.000000', 'temperatura', 645.0000, 'ºC'),
	(80300, 109, '2015-03-01 01:21:48.000000', 'temperatura', 380.0000, 'ºC'),
	(80301, 109, '2015-03-01 01:21:49.000000', 'temperatura', 1164.0000, 'ºC'),
	(80302, 109, '2015-03-01 01:21:50.000000', 'temperatura', 1081.0000, 'ºC'),
	(80303, 109, '2015-03-01 01:21:51.000000', 'temperatura', 714.0000, 'ºC'),
	(80304, 109, '2015-03-01 01:21:52.000000', 'temperatura', 327.0000, 'ºC'),
	(80305, 109, '2015-03-01 01:21:53.000000', 'temperatura', 694.0000, 'ºC'),
	(80306, 109, '2015-03-01 01:21:54.000000', 'temperatura', 91.0000, 'ºC'),
	(80307, 109, '2015-03-01 01:21:55.000000', 'temperatura', 772.0000, 'ºC'),
	(80308, 109, '2015-03-01 01:21:56.000000', 'temperatura', 1187.0000, 'ºC'),
	(80309, 109, '2015-03-01 01:21:57.000000', 'temperatura', 21.0000, 'ºC'),
	(80310, 109, '2015-03-01 01:21:58.000000', 'temperatura', 142.0000, 'ºC'),
	(80311, 109, '2015-03-01 01:21:59.000000', 'temperatura', 648.0000, 'ºC'),
	(80312, 109, '2015-03-01 01:22:00.000000', 'temperatura', 414.0000, 'ºC'),
	(80313, 109, '2015-03-01 01:22:01.000000', 'temperatura', 129.0000, 'ºC'),
	(80314, 109, '2015-03-01 01:22:02.000000', 'temperatura', 602.0000, 'ºC'),
	(80315, 109, '2015-03-01 01:22:03.000000', 'temperatura', 223.0000, 'ºC'),
	(80316, 109, '2015-03-01 01:22:04.000000', 'temperatura', 508.0000, 'ºC'),
	(80317, 109, '2015-03-01 01:22:05.000000', 'temperatura', 673.0000, 'ºC'),
	(80318, 109, '2015-03-01 01:22:06.000000', 'temperatura', 640.0000, 'ºC'),
	(80319, 109, '2015-03-01 01:22:07.000000', 'temperatura', 1183.0000, 'ºC'),
	(80320, 109, '2015-03-01 01:22:08.000000', 'temperatura', 394.0000, 'ºC'),
	(80321, 109, '2015-03-01 01:22:09.000000', 'temperatura', 823.0000, 'ºC'),
	(80322, 109, '2015-03-01 01:22:10.000000', 'temperatura', 535.0000, 'ºC'),
	(80323, 109, '2015-03-01 01:22:11.000000', 'temperatura', 205.0000, 'ºC'),
	(80324, 109, '2015-03-01 01:22:12.000000', 'temperatura', 623.0000, 'ºC'),
	(80325, 109, '2015-03-01 01:22:13.000000', 'temperatura', 97.0000, 'ºC'),
	(80326, 109, '2015-03-01 01:22:14.000000', 'temperatura', 1019.0000, 'ºC'),
	(80327, 109, '2015-03-01 01:22:15.000000', 'temperatura', 3.0000, 'ºC'),
	(80328, 109, '2015-03-01 01:22:16.000000', 'temperatura', 557.0000, 'ºC'),
	(80329, 109, '2015-03-01 01:22:17.000000', 'temperatura', 379.0000, 'ºC'),
	(80330, 109, '2015-03-01 01:22:18.000000', 'temperatura', 225.0000, 'ºC'),
	(80331, 109, '2015-03-01 01:22:19.000000', 'temperatura', 1189.0000, 'ºC'),
	(80332, 109, '2015-03-01 01:22:20.000000', 'temperatura', 468.0000, 'ºC'),
	(80333, 109, '2015-03-01 01:22:21.000000', 'temperatura', 1173.0000, 'ºC'),
	(80334, 109, '2015-03-01 01:22:22.000000', 'temperatura', 861.0000, 'ºC'),
	(80335, 109, '2015-03-01 01:22:23.000000', 'temperatura', 788.0000, 'ºC'),
	(80336, 109, '2015-03-01 01:22:24.000000', 'temperatura', 156.0000, 'ºC'),
	(80337, 109, '2015-03-01 01:22:25.000000', 'temperatura', 817.0000, 'ºC'),
	(80338, 109, '2015-03-01 01:22:26.000000', 'temperatura', 17.0000, 'ºC'),
	(80339, 109, '2015-03-01 01:22:27.000000', 'temperatura', 33.0000, 'ºC'),
	(80340, 109, '2015-03-01 01:22:28.000000', 'temperatura', 118.0000, 'ºC'),
	(80341, 109, '2015-03-01 01:22:29.000000', 'temperatura', 489.0000, 'ºC'),
	(80342, 109, '2015-03-01 01:22:30.000000', 'temperatura', 894.0000, 'ºC'),
	(80343, 109, '2015-03-01 01:22:31.000000', 'temperatura', 602.0000, 'ºC'),
	(80344, 109, '2015-03-01 01:22:32.000000', 'temperatura', 328.0000, 'ºC'),
	(80345, 109, '2015-03-01 01:22:33.000000', 'temperatura', 1034.0000, 'ºC'),
	(80346, 109, '2015-03-01 01:22:34.000000', 'temperatura', 585.0000, 'ºC'),
	(80347, 109, '2015-03-01 01:22:35.000000', 'temperatura', 1025.0000, 'ºC'),
	(80348, 109, '2015-03-01 01:22:36.000000', 'temperatura', 971.0000, 'ºC'),
	(80349, 109, '2015-03-01 01:22:37.000000', 'temperatura', 581.0000, 'ºC'),
	(80350, 109, '2015-03-01 01:22:38.000000', 'temperatura', 1193.0000, 'ºC'),
	(80351, 109, '2015-03-01 01:22:39.000000', 'temperatura', 622.0000, 'ºC'),
	(80352, 109, '2015-03-01 01:22:40.000000', 'temperatura', 731.0000, 'ºC'),
	(80353, 109, '2015-03-01 01:22:41.000000', 'temperatura', 591.0000, 'ºC'),
	(80354, 109, '2015-03-01 01:22:42.000000', 'temperatura', 761.0000, 'ºC'),
	(80355, 109, '2015-03-01 01:22:43.000000', 'temperatura', 833.0000, 'ºC'),
	(80356, 109, '2015-03-01 01:22:44.000000', 'temperatura', 681.0000, 'ºC'),
	(80357, 109, '2015-03-01 01:22:45.000000', 'temperatura', 907.0000, 'ºC'),
	(80358, 109, '2015-03-01 01:22:46.000000', 'temperatura', 91.0000, 'ºC'),
	(80359, 109, '2015-03-01 01:22:47.000000', 'temperatura', 137.0000, 'ºC'),
	(80360, 109, '2015-03-01 01:22:48.000000', 'temperatura', 411.0000, 'ºC'),
	(80361, 109, '2015-03-01 01:22:49.000000', 'temperatura', 446.0000, 'ºC'),
	(80362, 109, '2015-03-01 01:22:50.000000', 'temperatura', 996.0000, 'ºC'),
	(80363, 109, '2015-03-01 01:22:51.000000', 'temperatura', 41.0000, 'ºC'),
	(80364, 109, '2015-03-01 01:22:52.000000', 'temperatura', 819.0000, 'ºC'),
	(80365, 109, '2015-03-01 01:22:53.000000', 'temperatura', 374.0000, 'ºC'),
	(80366, 109, '2015-03-01 01:22:54.000000', 'temperatura', 614.0000, 'ºC'),
	(80367, 109, '2015-03-01 01:22:55.000000', 'temperatura', 748.0000, 'ºC'),
	(80368, 109, '2015-03-01 01:22:56.000000', 'temperatura', 699.0000, 'ºC'),
	(80369, 109, '2015-03-01 01:22:57.000000', 'temperatura', 49.0000, 'ºC'),
	(80370, 109, '2015-03-01 01:22:58.000000', 'temperatura', 550.0000, 'ºC'),
	(80371, 109, '2015-03-01 01:22:59.000000', 'temperatura', 205.0000, 'ºC'),
	(80372, 109, '2015-03-01 01:23:00.000000', 'temperatura', 575.0000, 'ºC'),
	(80373, 109, '2015-03-01 01:23:01.000000', 'temperatura', 1062.0000, 'ºC'),
	(80374, 109, '2015-03-01 01:23:02.000000', 'temperatura', 1184.0000, 'ºC'),
	(80375, 109, '2015-03-01 01:23:03.000000', 'temperatura', 333.0000, 'ºC'),
	(80376, 109, '2015-03-01 01:23:04.000000', 'temperatura', 514.0000, 'ºC'),
	(80377, 109, '2015-03-01 01:23:05.000000', 'temperatura', 372.0000, 'ºC'),
	(80378, 109, '2015-03-01 01:23:06.000000', 'temperatura', 320.0000, 'ºC'),
	(80379, 109, '2015-03-01 01:23:07.000000', 'temperatura', 484.0000, 'ºC'),
	(80380, 109, '2015-03-01 01:23:08.000000', 'temperatura', 259.0000, 'ºC'),
	(80381, 109, '2015-03-01 01:23:09.000000', 'temperatura', 1046.0000, 'ºC'),
	(80382, 109, '2015-03-01 01:23:10.000000', 'temperatura', 851.0000, 'ºC'),
	(80383, 109, '2015-03-01 01:23:11.000000', 'temperatura', 1118.0000, 'ºC'),
	(80384, 109, '2015-03-01 01:23:12.000000', 'temperatura', 638.0000, 'ºC'),
	(80385, 109, '2015-03-01 01:23:13.000000', 'temperatura', 1035.0000, 'ºC'),
	(80386, 109, '2015-03-01 01:23:14.000000', 'temperatura', 862.0000, 'ºC'),
	(80387, 109, '2015-03-01 01:23:15.000000', 'temperatura', 6.0000, 'ºC'),
	(80388, 109, '2015-03-01 01:23:16.000000', 'temperatura', 1042.0000, 'ºC'),
	(80389, 109, '2015-03-01 01:23:17.000000', 'temperatura', 395.0000, 'ºC'),
	(80390, 109, '2015-03-01 01:23:18.000000', 'temperatura', 51.0000, 'ºC'),
	(80391, 109, '2015-03-01 01:23:19.000000', 'temperatura', 268.0000, 'ºC'),
	(80392, 109, '2015-03-01 01:23:20.000000', 'temperatura', 1187.0000, 'ºC'),
	(80393, 109, '2015-03-01 01:23:21.000000', 'temperatura', 332.0000, 'ºC'),
	(80394, 109, '2015-03-01 01:23:22.000000', 'temperatura', 498.0000, 'ºC'),
	(80395, 109, '2015-03-01 01:23:23.000000', 'temperatura', 296.0000, 'ºC'),
	(80396, 109, '2015-03-01 01:23:24.000000', 'temperatura', 1185.0000, 'ºC'),
	(80397, 109, '2015-03-01 01:23:25.000000', 'temperatura', 239.0000, 'ºC'),
	(80398, 109, '2015-03-01 01:23:26.000000', 'temperatura', 39.0000, 'ºC'),
	(80399, 109, '2015-03-01 01:23:27.000000', 'temperatura', 678.0000, 'ºC'),
	(80400, 109, '2015-03-01 01:23:28.000000', 'temperatura', 875.0000, 'ºC'),
	(80401, 109, '2015-03-01 01:23:29.000000', 'temperatura', 1143.0000, 'ºC'),
	(80402, 109, '2015-03-01 01:23:30.000000', 'temperatura', 690.0000, 'ºC'),
	(80403, 109, '2015-03-01 01:23:31.000000', 'temperatura', 20.0000, 'ºC'),
	(80404, 109, '2015-03-01 01:23:32.000000', 'temperatura', 430.0000, 'ºC'),
	(80405, 109, '2015-03-01 01:23:33.000000', 'temperatura', 890.0000, 'ºC'),
	(80406, 109, '2015-03-01 01:23:34.000000', 'temperatura', 761.0000, 'ºC'),
	(80407, 109, '2015-03-01 01:23:35.000000', 'temperatura', 1134.0000, 'ºC'),
	(80408, 109, '2015-03-01 01:23:36.000000', 'temperatura', 988.0000, 'ºC'),
	(80409, 109, '2015-03-01 01:23:37.000000', 'temperatura', 338.0000, 'ºC'),
	(80410, 109, '2015-03-01 01:23:38.000000', 'temperatura', 1126.0000, 'ºC'),
	(80411, 109, '2015-03-01 01:23:39.000000', 'temperatura', 1016.0000, 'ºC'),
	(80412, 109, '2015-03-01 01:23:40.000000', 'temperatura', 506.0000, 'ºC'),
	(80413, 109, '2015-03-01 01:23:41.000000', 'temperatura', 679.0000, 'ºC'),
	(80414, 109, '2015-03-01 01:23:42.000000', 'temperatura', 677.0000, 'ºC'),
	(80415, 109, '2015-03-01 01:23:43.000000', 'temperatura', 150.0000, 'ºC'),
	(80416, 109, '2015-03-01 01:23:44.000000', 'temperatura', 1121.0000, 'ºC'),
	(80417, 109, '2015-03-01 01:23:45.000000', 'temperatura', 353.0000, 'ºC'),
	(80418, 109, '2015-03-01 01:23:46.000000', 'temperatura', 803.0000, 'ºC'),
	(80419, 109, '2015-03-01 01:23:47.000000', 'temperatura', 556.0000, 'ºC'),
	(80420, 109, '2015-03-01 01:23:48.000000', 'temperatura', 373.0000, 'ºC'),
	(80421, 109, '2015-03-01 01:23:49.000000', 'temperatura', 195.0000, 'ºC'),
	(80422, 109, '2015-03-01 01:23:50.000000', 'temperatura', 1058.0000, 'ºC'),
	(80423, 109, '2015-03-01 01:23:51.000000', 'temperatura', 1105.0000, 'ºC'),
	(80424, 109, '2015-03-01 01:23:52.000000', 'temperatura', 1151.0000, 'ºC'),
	(80425, 109, '2015-03-01 01:23:53.000000', 'temperatura', 39.0000, 'ºC'),
	(80426, 109, '2015-03-01 01:23:54.000000', 'temperatura', 344.0000, 'ºC'),
	(80427, 109, '2015-03-01 01:23:55.000000', 'temperatura', 402.0000, 'ºC'),
	(80428, 109, '2015-03-01 01:23:56.000000', 'temperatura', 979.0000, 'ºC'),
	(80429, 109, '2015-03-01 01:23:57.000000', 'temperatura', 89.0000, 'ºC'),
	(80430, 109, '2015-03-01 01:23:58.000000', 'temperatura', 1110.0000, 'ºC'),
	(80431, 109, '2015-03-01 01:23:59.000000', 'temperatura', 483.0000, 'ºC'),
	(80432, 109, '2015-03-01 01:24:00.000000', 'temperatura', 285.0000, 'ºC'),
	(80433, 109, '2015-03-01 01:24:01.000000', 'temperatura', 1177.0000, 'ºC'),
	(80434, 109, '2015-03-01 01:24:02.000000', 'temperatura', 230.0000, 'ºC'),
	(80435, 109, '2015-03-01 01:24:03.000000', 'temperatura', 20.0000, 'ºC'),
	(80436, 109, '2015-03-01 01:24:04.000000', 'temperatura', 609.0000, 'ºC'),
	(80437, 109, '2015-03-01 01:24:05.000000', 'temperatura', 588.0000, 'ºC'),
	(80438, 109, '2015-03-01 01:24:06.000000', 'temperatura', 1111.0000, 'ºC'),
	(80439, 109, '2015-03-01 01:24:07.000000', 'temperatura', 193.0000, 'ºC'),
	(80440, 109, '2015-03-01 01:24:08.000000', 'temperatura', 33.0000, 'ºC'),
	(80441, 109, '2015-03-01 01:24:09.000000', 'temperatura', 786.0000, 'ºC'),
	(80442, 109, '2015-03-01 01:24:10.000000', 'temperatura', 231.0000, 'ºC'),
	(80443, 109, '2015-03-01 01:24:11.000000', 'temperatura', 1197.0000, 'ºC'),
	(80444, 109, '2015-03-01 01:24:12.000000', 'temperatura', 492.0000, 'ºC'),
	(80445, 109, '2015-03-01 01:24:13.000000', 'temperatura', 70.0000, 'ºC'),
	(80446, 109, '2015-03-01 01:24:14.000000', 'temperatura', 73.0000, 'ºC'),
	(80447, 109, '2015-03-01 01:24:15.000000', 'temperatura', 158.0000, 'ºC'),
	(80448, 109, '2015-03-01 01:24:16.000000', 'temperatura', 572.0000, 'ºC'),
	(80449, 109, '2015-03-01 01:24:17.000000', 'temperatura', 1184.0000, 'ºC'),
	(80450, 109, '2015-03-01 01:24:18.000000', 'temperatura', 608.0000, 'ºC'),
	(80451, 109, '2015-03-01 01:24:19.000000', 'temperatura', 685.0000, 'ºC'),
	(80452, 109, '2015-03-01 01:24:20.000000', 'temperatura', 403.0000, 'ºC'),
	(80453, 109, '2015-03-01 01:24:21.000000', 'temperatura', 1159.0000, 'ºC'),
	(80454, 109, '2015-03-01 01:24:22.000000', 'temperatura', 987.0000, 'ºC'),
	(80455, 109, '2015-03-01 01:24:23.000000', 'temperatura', 259.0000, 'ºC'),
	(80456, 109, '2015-03-01 01:24:24.000000', 'temperatura', 736.0000, 'ºC'),
	(80457, 109, '2015-03-01 01:24:25.000000', 'temperatura', 501.0000, 'ºC'),
	(80458, 109, '2015-03-01 01:24:26.000000', 'temperatura', 298.0000, 'ºC'),
	(80459, 109, '2015-03-01 01:24:27.000000', 'temperatura', 1188.0000, 'ºC'),
	(80460, 109, '2015-03-01 01:24:28.000000', 'temperatura', 246.0000, 'ºC'),
	(80461, 109, '2015-03-01 01:24:29.000000', 'temperatura', 68.0000, 'ºC'),
	(80462, 109, '2015-03-01 01:24:30.000000', 'temperatura', 800.0000, 'ºC'),
	(80463, 109, '2015-03-01 01:24:31.000000', 'temperatura', 197.0000, 'ºC'),
	(80464, 109, '2015-03-01 01:24:32.000000', 'temperatura', 985.0000, 'ºC'),
	(80465, 109, '2015-03-01 01:24:33.000000', 'temperatura', 735.0000, 'ºC'),
	(80466, 109, '2015-03-01 01:24:34.000000', 'temperatura', 721.0000, 'ºC'),
	(80467, 109, '2015-03-01 01:24:35.000000', 'temperatura', 201.0000, 'ºC'),
	(80468, 109, '2015-03-01 01:24:36.000000', 'temperatura', 40.0000, 'ºC'),
	(80469, 109, '2015-03-01 01:24:37.000000', 'temperatura', 799.0000, 'ºC'),
	(80470, 109, '2015-03-01 01:24:38.000000', 'temperatura', 276.0000, 'ºC'),
	(80471, 109, '2015-03-01 01:24:39.000000', 'temperatura', 182.0000, 'ºC'),
	(80472, 109, '2015-03-01 01:24:40.000000', 'temperatura', 83.0000, 'ºC'),
	(80473, 109, '2015-03-01 01:24:41.000000', 'temperatura', 1069.0000, 'ºC'),
	(80474, 109, '2015-03-01 01:24:42.000000', 'temperatura', 295.0000, 'ºC'),
	(80475, 109, '2015-03-01 01:24:43.000000', 'temperatura', 671.0000, 'ºC'),
	(80476, 109, '2015-03-01 01:24:44.000000', 'temperatura', 70.0000, 'ºC'),
	(80477, 109, '2015-03-01 01:24:45.000000', 'temperatura', 739.0000, 'ºC'),
	(80478, 109, '2015-03-01 01:24:46.000000', 'temperatura', 1085.0000, 'ºC'),
	(80479, 109, '2015-03-01 01:24:47.000000', 'temperatura', 809.0000, 'ºC'),
	(80480, 109, '2015-03-01 01:24:48.000000', 'temperatura', 790.0000, 'ºC'),
	(80481, 109, '2015-03-01 01:24:49.000000', 'temperatura', 322.0000, 'ºC'),
	(80482, 109, '2015-03-01 01:24:50.000000', 'temperatura', 440.0000, 'ºC'),
	(80483, 109, '2015-03-01 01:24:51.000000', 'temperatura', 36.0000, 'ºC'),
	(80484, 109, '2015-03-01 01:24:52.000000', 'temperatura', 60.0000, 'ºC'),
	(80485, 109, '2015-03-01 01:24:53.000000', 'temperatura', 192.0000, 'ºC'),
	(80486, 109, '2015-03-01 01:24:54.000000', 'temperatura', 780.0000, 'ºC'),
	(80487, 109, '2015-03-01 01:24:55.000000', 'temperatura', 925.0000, 'ºC'),
	(80488, 109, '2015-03-01 01:24:56.000000', 'temperatura', 1087.0000, 'ºC'),
	(80489, 109, '2015-03-01 01:24:57.000000', 'temperatura', 258.0000, 'ºC'),
	(80490, 109, '2015-03-01 01:24:58.000000', 'temperatura', 431.0000, 'ºC'),
	(80491, 109, '2015-03-01 01:24:59.000000', 'temperatura', 183.0000, 'ºC'),
	(80492, 109, '2015-03-01 01:25:00.000000', 'temperatura', 821.0000, 'ºC'),
	(80493, 109, '2015-03-01 01:25:01.000000', 'temperatura', 1156.0000, 'ºC'),
	(80494, 109, '2015-03-01 01:25:02.000000', 'temperatura', 917.0000, 'ºC'),
	(80495, 109, '2015-03-01 01:25:03.000000', 'temperatura', 1119.0000, 'ºC'),
	(80496, 109, '2015-03-01 01:25:04.000000', 'temperatura', 446.0000, 'ºC'),
	(80497, 109, '2015-03-01 01:25:05.000000', 'temperatura', 72.0000, 'ºC'),
	(80498, 109, '2015-03-01 01:25:06.000000', 'temperatura', 221.0000, 'ºC'),
	(80499, 109, '2015-03-01 01:25:07.000000', 'temperatura', 892.0000, 'ºC'),
	(80500, 109, '2015-03-01 01:25:08.000000', 'temperatura', 197.0000, 'ºC'),
	(80501, 109, '2015-03-01 01:25:09.000000', 'temperatura', 708.0000, 'ºC'),
	(80502, 109, '2015-03-01 01:25:10.000000', 'temperatura', 551.0000, 'ºC'),
	(80503, 109, '2015-03-01 01:25:11.000000', 'temperatura', 629.0000, 'ºC'),
	(80504, 109, '2015-03-01 01:25:12.000000', 'temperatura', 293.0000, 'ºC'),
	(80505, 109, '2015-03-01 01:25:13.000000', 'temperatura', 781.0000, 'ºC'),
	(80506, 109, '2015-03-01 01:25:14.000000', 'temperatura', 626.0000, 'ºC'),
	(80507, 109, '2015-03-01 01:25:15.000000', 'temperatura', 787.0000, 'ºC'),
	(80508, 109, '2015-03-01 01:25:16.000000', 'temperatura', 855.0000, 'ºC'),
	(80509, 109, '2015-03-01 01:25:17.000000', 'temperatura', 718.0000, 'ºC'),
	(80510, 109, '2015-03-01 01:25:18.000000', 'temperatura', 1023.0000, 'ºC'),
	(80511, 109, '2015-03-01 01:25:19.000000', 'temperatura', 560.0000, 'ºC'),
	(80512, 109, '2015-03-01 01:25:20.000000', 'temperatura', 934.0000, 'ºC'),
	(80513, 109, '2015-03-01 01:25:21.000000', 'temperatura', 591.0000, 'ºC'),
	(80514, 109, '2015-03-01 01:25:22.000000', 'temperatura', 154.0000, 'ºC'),
	(80515, 109, '2015-03-01 01:25:23.000000', 'temperatura', 198.0000, 'ºC'),
	(80516, 109, '2015-03-01 01:25:24.000000', 'temperatura', 528.0000, 'ºC'),
	(80517, 109, '2015-03-01 01:25:25.000000', 'temperatura', 848.0000, 'ºC'),
	(80518, 109, '2015-03-01 01:25:26.000000', 'temperatura', 256.0000, 'ºC'),
	(80519, 109, '2015-03-01 01:25:27.000000', 'temperatura', 1135.0000, 'ºC'),
	(80520, 109, '2015-03-01 01:25:28.000000', 'temperatura', 108.0000, 'ºC'),
	(80521, 109, '2015-03-01 01:25:29.000000', 'temperatura', 735.0000, 'ºC'),
	(80522, 109, '2015-03-01 01:25:30.000000', 'temperatura', 951.0000, 'ºC'),
	(80523, 109, '2015-03-01 01:25:31.000000', 'temperatura', 153.0000, 'ºC'),
	(80524, 109, '2015-03-01 01:25:32.000000', 'temperatura', 309.0000, 'ºC'),
	(80525, 109, '2015-03-01 01:25:33.000000', 'temperatura', 1090.0000, 'ºC'),
	(80526, 109, '2015-03-01 01:25:34.000000', 'temperatura', 921.0000, 'ºC'),
	(80527, 109, '2015-03-01 01:25:35.000000', 'temperatura', 135.0000, 'ºC'),
	(80528, 109, '2015-03-01 01:25:36.000000', 'temperatura', 312.0000, 'ºC'),
	(80529, 109, '2015-03-01 01:25:37.000000', 'temperatura', 1157.0000, 'ºC'),
	(80530, 109, '2015-03-01 01:25:38.000000', 'temperatura', 48.0000, 'ºC'),
	(80531, 109, '2015-03-01 01:25:39.000000', 'temperatura', 368.0000, 'ºC'),
	(80532, 109, '2015-03-01 01:25:40.000000', 'temperatura', 499.0000, 'ºC'),
	(80533, 109, '2015-03-01 01:25:41.000000', 'temperatura', 191.0000, 'ºC'),
	(80534, 109, '2015-03-01 01:25:42.000000', 'temperatura', 660.0000, 'ºC'),
	(80535, 109, '2015-03-01 01:25:43.000000', 'temperatura', 326.0000, 'ºC'),
	(80536, 109, '2015-03-01 01:25:44.000000', 'temperatura', 852.0000, 'ºC'),
	(80537, 109, '2015-03-01 01:25:45.000000', 'temperatura', 883.0000, 'ºC'),
	(80538, 109, '2015-03-01 01:25:46.000000', 'temperatura', 660.0000, 'ºC'),
	(80539, 109, '2015-03-01 01:25:47.000000', 'temperatura', 652.0000, 'ºC'),
	(80540, 109, '2015-03-01 01:25:48.000000', 'temperatura', 79.0000, 'ºC'),
	(80541, 109, '2015-03-01 01:25:49.000000', 'temperatura', 840.0000, 'ºC'),
	(80542, 109, '2015-03-01 01:25:50.000000', 'temperatura', 363.0000, 'ºC'),
	(80543, 109, '2015-03-01 01:25:51.000000', 'temperatura', 497.0000, 'ºC'),
	(80544, 109, '2015-03-01 01:25:52.000000', 'temperatura', 197.0000, 'ºC'),
	(80545, 109, '2015-03-01 01:25:53.000000', 'temperatura', 692.0000, 'ºC'),
	(80546, 109, '2015-03-01 01:25:54.000000', 'temperatura', 469.0000, 'ºC'),
	(80547, 109, '2015-03-01 01:25:55.000000', 'temperatura', 269.0000, 'ºC'),
	(80548, 109, '2015-03-01 01:25:56.000000', 'temperatura', 1138.0000, 'ºC'),
	(80549, 109, '2015-03-01 01:25:57.000000', 'temperatura', 86.0000, 'ºC'),
	(80550, 109, '2015-03-01 01:25:58.000000', 'temperatura', 614.0000, 'ºC'),
	(80551, 109, '2015-03-01 01:25:59.000000', 'temperatura', 414.0000, 'ºC'),
	(80552, 109, '2015-03-01 01:26:00.000000', 'temperatura', 227.0000, 'ºC'),
	(80553, 109, '2015-03-01 01:26:01.000000', 'temperatura', 1095.0000, 'ºC'),
	(80554, 109, '2015-03-01 01:26:02.000000', 'temperatura', 1193.0000, 'ºC'),
	(80555, 109, '2015-03-01 01:26:03.000000', 'temperatura', 280.0000, 'ºC'),
	(80556, 109, '2015-03-01 01:26:04.000000', 'temperatura', 223.0000, 'ºC'),
	(80557, 109, '2015-03-01 01:26:05.000000', 'temperatura', 276.0000, 'ºC'),
	(80558, 109, '2015-03-01 01:26:06.000000', 'temperatura', 710.0000, 'ºC'),
	(80559, 109, '2015-03-01 01:26:07.000000', 'temperatura', 324.0000, 'ºC'),
	(80560, 109, '2015-03-01 01:26:08.000000', 'temperatura', 691.0000, 'ºC'),
	(80561, 109, '2015-03-01 01:26:09.000000', 'temperatura', 84.0000, 'ºC'),
	(80562, 109, '2015-03-01 01:26:10.000000', 'temperatura', 746.0000, 'ºC'),
	(80563, 109, '2015-03-01 01:26:11.000000', 'temperatura', 1078.0000, 'ºC'),
	(80564, 109, '2015-03-01 01:26:12.000000', 'temperatura', 753.0000, 'ºC'),
	(80565, 109, '2015-03-01 01:26:13.000000', 'temperatura', 532.0000, 'ºC'),
	(80566, 109, '2015-03-01 01:26:14.000000', 'temperatura', 399.0000, 'ºC'),
	(80567, 109, '2015-03-01 01:26:15.000000', 'temperatura', 402.0000, 'ºC'),
	(80568, 109, '2015-03-01 01:26:16.000000', 'temperatura', 811.0000, 'ºC'),
	(80569, 109, '2015-03-01 01:26:17.000000', 'temperatura', 451.0000, 'ºC'),
	(80570, 109, '2015-03-01 01:26:18.000000', 'temperatura', 1021.0000, 'ºC'),
	(80571, 109, '2015-03-01 01:26:19.000000', 'temperatura', 153.0000, 'ºC'),
	(80572, 109, '2015-03-01 01:26:20.000000', 'temperatura', 105.0000, 'ºC'),
	(80573, 109, '2015-03-01 01:26:21.000000', 'temperatura', 64.0000, 'ºC'),
	(80574, 109, '2015-03-01 01:26:22.000000', 'temperatura', 7.0000, 'ºC'),
	(80575, 109, '2015-03-01 01:26:23.000000', 'temperatura', 1043.0000, 'ºC'),
	(80576, 109, '2015-03-01 01:26:24.000000', 'temperatura', 393.0000, 'ºC'),
	(80577, 109, '2015-03-01 01:26:25.000000', 'temperatura', 35.0000, 'ºC'),
	(80578, 109, '2015-03-01 01:26:26.000000', 'temperatura', 200.0000, 'ºC'),
	(80579, 109, '2015-03-01 01:26:27.000000', 'temperatura', 894.0000, 'ºC'),
	(80580, 109, '2015-03-01 01:26:28.000000', 'temperatura', 269.0000, 'ºC'),
	(80581, 109, '2015-03-01 01:26:29.000000', 'temperatura', 1066.0000, 'ºC'),
	(80582, 109, '2015-03-01 01:26:30.000000', 'temperatura', 923.0000, 'ºC'),
	(80583, 109, '2015-03-01 01:26:31.000000', 'temperatura', 218.0000, 'ºC'),
	(80584, 109, '2015-03-01 01:26:32.000000', 'temperatura', 721.0000, 'ºC'),
	(80585, 109, '2015-03-01 01:26:33.000000', 'temperatura', 552.0000, 'ºC'),
	(80586, 109, '2015-03-01 01:26:34.000000', 'temperatura', 597.0000, 'ºC'),
	(80587, 109, '2015-03-01 01:26:35.000000', 'temperatura', 129.0000, 'ºC'),
	(80588, 109, '2015-03-01 01:26:36.000000', 'temperatura', 56.0000, 'ºC'),
	(80589, 109, '2015-03-01 01:26:37.000000', 'temperatura', 1091.0000, 'ºC'),
	(80590, 109, '2015-03-01 01:26:38.000000', 'temperatura', 488.0000, 'ºC'),
	(80591, 109, '2015-03-01 01:26:39.000000', 'temperatura', 369.0000, 'ºC'),
	(80592, 109, '2015-03-01 01:26:40.000000', 'temperatura', 380.0000, 'ºC'),
	(80593, 109, '2015-03-01 01:26:41.000000', 'temperatura', 794.0000, 'ºC'),
	(80594, 109, '2015-03-01 01:26:42.000000', 'temperatura', 429.0000, 'ºC'),
	(80595, 109, '2015-03-01 01:26:43.000000', 'temperatura', 966.0000, 'ºC'),
	(80596, 109, '2015-03-01 01:26:44.000000', 'temperatura', 1142.0000, 'ºC'),
	(80597, 109, '2015-03-01 01:26:45.000000', 'temperatura', 415.0000, 'ºC'),
	(80598, 109, '2015-03-01 01:26:46.000000', 'temperatura', 1047.0000, 'ºC'),
	(80599, 109, '2015-03-01 01:26:47.000000', 'temperatura', 393.0000, 'ºC'),
	(80600, 109, '2015-03-01 01:26:48.000000', 'temperatura', 25.0000, 'ºC'),
	(80601, 109, '2015-03-01 01:26:49.000000', 'temperatura', 143.0000, 'ºC'),
	(80602, 109, '2015-03-01 01:26:50.000000', 'temperatura', 643.0000, 'ºC'),
	(80603, 109, '2015-03-01 01:26:51.000000', 'temperatura', 385.0000, 'ºC'),
	(80604, 109, '2015-03-01 01:26:52.000000', 'temperatura', 1195.0000, 'ºC'),
	(80605, 109, '2015-03-01 01:26:53.000000', 'temperatura', 23.0000, 'ºC'),
	(80606, 109, '2015-03-01 01:26:54.000000', 'temperatura', 132.0000, 'ºC'),
	(80607, 109, '2015-03-01 01:26:55.000000', 'temperatura', 588.0000, 'ºC'),
	(80608, 109, '2015-03-01 01:26:56.000000', 'temperatura', 148.0000, 'ºC'),
	(80609, 109, '2015-03-01 01:26:57.000000', 'temperatura', 174.0000, 'ºC'),
	(80610, 109, '2015-03-01 01:26:58.000000', 'temperatura', 425.0000, 'ºC'),
	(80611, 109, '2015-03-01 01:26:59.000000', 'temperatura', 406.0000, 'ºC'),
	(80612, 109, '2015-03-01 01:27:00.000000', 'temperatura', 753.0000, 'ºC'),
	(80613, 109, '2015-03-01 01:27:01.000000', 'temperatura', 151.0000, 'ºC'),
	(80614, 109, '2015-03-01 01:27:02.000000', 'temperatura', 894.0000, 'ºC'),
	(80615, 109, '2015-03-01 01:27:03.000000', 'temperatura', 420.0000, 'ºC'),
	(80616, 109, '2015-03-01 01:27:04.000000', 'temperatura', 615.0000, 'ºC'),
	(80617, 109, '2015-03-01 01:27:05.000000', 'temperatura', 618.0000, 'ºC'),
	(80618, 109, '2015-03-01 01:27:06.000000', 'temperatura', 46.0000, 'ºC'),
	(80619, 109, '2015-03-01 01:27:07.000000', 'temperatura', 776.0000, 'ºC'),
	(80620, 109, '2015-03-01 01:27:08.000000', 'temperatura', 141.0000, 'ºC'),
	(80621, 109, '2015-03-01 01:27:09.000000', 'temperatura', 779.0000, 'ºC'),
	(80622, 109, '2015-03-01 01:27:10.000000', 'temperatura', 1073.0000, 'ºC'),
	(80623, 109, '2015-03-01 01:27:11.000000', 'temperatura', 630.0000, 'ºC'),
	(80624, 109, '2015-03-01 01:27:12.000000', 'temperatura', 1128.0000, 'ºC'),
	(80625, 109, '2015-03-01 01:27:13.000000', 'temperatura', 152.0000, 'ºC'),
	(80626, 109, '2015-03-01 01:27:14.000000', 'temperatura', 974.0000, 'ºC'),
	(80627, 109, '2015-03-01 01:27:15.000000', 'temperatura', 818.0000, 'ºC'),
	(80628, 109, '2015-03-01 01:27:16.000000', 'temperatura', 1166.0000, 'ºC'),
	(80629, 109, '2015-03-01 01:27:17.000000', 'temperatura', 977.0000, 'ºC'),
	(80630, 109, '2015-03-01 01:27:18.000000', 'temperatura', 186.0000, 'ºC'),
	(80631, 109, '2015-03-01 01:27:19.000000', 'temperatura', 400.0000, 'ºC'),
	(80632, 109, '2015-03-01 01:27:20.000000', 'temperatura', 243.0000, 'ºC'),
	(80633, 109, '2015-03-01 01:27:21.000000', 'temperatura', 15.0000, 'ºC'),
	(80634, 109, '2015-03-01 01:27:22.000000', 'temperatura', 545.0000, 'ºC'),
	(80635, 109, '2015-03-01 01:27:23.000000', 'temperatura', 283.0000, 'ºC'),
	(80636, 109, '2015-03-01 01:27:24.000000', 'temperatura', 978.0000, 'ºC'),
	(80637, 109, '2015-03-01 01:27:25.000000', 'temperatura', 444.0000, 'ºC'),
	(80638, 109, '2015-03-01 01:27:26.000000', 'temperatura', 487.0000, 'ºC'),
	(80639, 109, '2015-03-01 01:27:27.000000', 'temperatura', 1101.0000, 'ºC'),
	(80640, 109, '2015-03-01 01:27:28.000000', 'temperatura', 444.0000, 'ºC'),
	(80641, 109, '2015-03-01 01:27:29.000000', 'temperatura', 118.0000, 'ºC'),
	(80642, 109, '2015-03-01 01:27:30.000000', 'temperatura', 461.0000, 'ºC'),
	(80643, 109, '2015-03-01 01:27:31.000000', 'temperatura', 750.0000, 'ºC'),
	(80644, 109, '2015-03-01 01:27:32.000000', 'temperatura', 1168.0000, 'ºC'),
	(80645, 109, '2015-03-01 01:27:33.000000', 'temperatura', 1189.0000, 'ºC'),
	(80646, 109, '2015-03-01 01:27:34.000000', 'temperatura', 40.0000, 'ºC'),
	(80647, 109, '2015-03-01 01:27:35.000000', 'temperatura', 237.0000, 'ºC'),
	(80648, 109, '2015-03-01 01:27:36.000000', 'temperatura', 1062.0000, 'ºC'),
	(80649, 109, '2015-03-01 01:27:37.000000', 'temperatura', 1002.0000, 'ºC'),
	(80650, 109, '2015-03-01 01:27:38.000000', 'temperatura', 622.0000, 'ºC'),
	(80651, 109, '2015-03-01 01:27:39.000000', 'temperatura', 106.0000, 'ºC'),
	(80652, 109, '2015-03-01 01:27:40.000000', 'temperatura', 1065.0000, 'ºC'),
	(80653, 109, '2015-03-01 01:27:41.000000', 'temperatura', 205.0000, 'ºC'),
	(80654, 109, '2015-03-01 01:27:42.000000', 'temperatura', 234.0000, 'ºC'),
	(80655, 109, '2015-03-01 01:27:43.000000', 'temperatura', 552.0000, 'ºC'),
	(80656, 109, '2015-03-01 01:27:44.000000', 'temperatura', 862.0000, 'ºC'),
	(80657, 109, '2015-03-01 01:27:45.000000', 'temperatura', 252.0000, 'ºC'),
	(80658, 109, '2015-03-01 01:27:46.000000', 'temperatura', 1077.0000, 'ºC'),
	(80659, 109, '2015-03-01 01:27:47.000000', 'temperatura', 1028.0000, 'ºC'),
	(80660, 109, '2015-03-01 01:27:48.000000', 'temperatura', 711.0000, 'ºC'),
	(80661, 109, '2015-03-01 01:27:49.000000', 'temperatura', 472.0000, 'ºC'),
	(80662, 109, '2015-03-01 01:27:50.000000', 'temperatura', 227.0000, 'ºC'),
	(80663, 109, '2015-03-01 01:27:51.000000', 'temperatura', 918.0000, 'ºC'),
	(80664, 109, '2015-03-01 01:27:52.000000', 'temperatura', 310.0000, 'ºC'),
	(80665, 109, '2015-03-01 01:27:53.000000', 'temperatura', 1198.0000, 'ºC'),
	(80666, 109, '2015-03-01 01:27:54.000000', 'temperatura', 258.0000, 'ºC'),
	(80667, 109, '2015-03-01 01:27:55.000000', 'temperatura', 99.0000, 'ºC'),
	(80668, 109, '2015-03-01 01:27:56.000000', 'temperatura', 920.0000, 'ºC'),
	(80669, 109, '2015-03-01 01:27:57.000000', 'temperatura', 704.0000, 'ºC'),
	(80670, 109, '2015-03-01 01:27:58.000000', 'temperatura', 758.0000, 'ºC'),
	(80671, 109, '2015-03-01 01:27:59.000000', 'temperatura', 482.0000, 'ºC'),
	(80672, 109, '2015-03-01 01:28:00.000000', 'temperatura', 135.0000, 'ºC'),
	(80673, 109, '2015-03-01 01:28:01.000000', 'temperatura', 428.0000, 'ºC'),
	(80674, 109, '2015-03-01 01:28:02.000000', 'temperatura', 538.0000, 'ºC'),
	(80675, 109, '2015-03-01 01:28:03.000000', 'temperatura', 204.0000, 'ºC'),
	(80676, 109, '2015-03-01 01:28:04.000000', 'temperatura', 606.0000, 'ºC'),
	(80677, 109, '2015-03-01 01:28:05.000000', 'temperatura', 18.0000, 'ºC'),
	(80678, 109, '2015-03-01 01:28:06.000000', 'temperatura', 674.0000, 'ºC'),
	(80679, 109, '2015-03-01 01:28:07.000000', 'temperatura', 918.0000, 'ºC'),
	(80680, 109, '2015-03-01 01:28:08.000000', 'temperatura', 169.0000, 'ºC'),
	(80681, 109, '2015-03-01 01:28:09.000000', 'temperatura', 489.0000, 'ºC'),
	(80682, 109, '2015-03-01 01:28:10.000000', 'temperatura', 740.0000, 'ºC'),
	(80683, 109, '2015-03-01 01:28:11.000000', 'temperatura', 1032.0000, 'ºC'),
	(80684, 109, '2015-03-01 01:28:12.000000', 'temperatura', 539.0000, 'ºC'),
	(80685, 109, '2015-03-01 01:28:13.000000', 'temperatura', 802.0000, 'ºC'),
	(80686, 109, '2015-03-01 01:28:14.000000', 'temperatura', 1192.0000, 'ºC'),
	(80687, 109, '2015-03-01 01:28:15.000000', 'temperatura', 1155.0000, 'ºC'),
	(80688, 109, '2015-03-01 01:28:16.000000', 'temperatura', 1000.0000, 'ºC'),
	(80689, 109, '2015-03-01 01:28:17.000000', 'temperatura', 337.0000, 'ºC'),
	(80690, 109, '2015-03-01 01:28:18.000000', 'temperatura', 1086.0000, 'ºC'),
	(80691, 109, '2015-03-01 01:28:19.000000', 'temperatura', 817.0000, 'ºC'),
	(80692, 109, '2015-03-01 01:28:20.000000', 'temperatura', 828.0000, 'ºC'),
	(80693, 109, '2015-03-01 01:28:21.000000', 'temperatura', 490.0000, 'ºC'),
	(80694, 109, '2015-03-01 01:28:22.000000', 'temperatura', 1166.0000, 'ºC'),
	(80695, 109, '2015-03-01 01:28:23.000000', 'temperatura', 760.0000, 'ºC'),
	(80696, 109, '2015-03-01 01:28:24.000000', 'temperatura', 303.0000, 'ºC'),
	(80697, 109, '2015-03-01 01:28:25.000000', 'temperatura', 438.0000, 'ºC'),
	(80698, 109, '2015-03-01 01:28:26.000000', 'temperatura', 78.0000, 'ºC'),
	(80699, 109, '2015-03-01 01:28:27.000000', 'temperatura', 279.0000, 'ºC'),
	(80700, 109, '2015-03-01 01:28:28.000000', 'temperatura', 1159.0000, 'ºC'),
	(80701, 109, '2015-03-01 01:28:29.000000', 'temperatura', 158.0000, 'ºC'),
	(80702, 109, '2015-03-01 01:28:30.000000', 'temperatura', 914.0000, 'ºC'),
	(80703, 109, '2015-03-01 01:28:31.000000', 'temperatura', 495.0000, 'ºC'),
	(80704, 109, '2015-03-01 01:28:32.000000', 'temperatura', 936.0000, 'ºC'),
	(80705, 109, '2015-03-01 01:28:33.000000', 'temperatura', 795.0000, 'ºC'),
	(80706, 109, '2015-03-01 01:28:34.000000', 'temperatura', 1166.0000, 'ºC'),
	(80707, 109, '2015-03-01 01:28:35.000000', 'temperatura', 1047.0000, 'ºC'),
	(80708, 109, '2015-03-01 01:28:36.000000', 'temperatura', 536.0000, 'ºC'),
	(80709, 109, '2015-03-01 01:28:37.000000', 'temperatura', 741.0000, 'ºC'),
	(80710, 109, '2015-03-01 01:28:38.000000', 'temperatura', 899.0000, 'ºC'),
	(80711, 109, '2015-03-01 01:28:39.000000', 'temperatura', 1069.0000, 'ºC'),
	(80712, 109, '2015-03-01 01:28:40.000000', 'temperatura', 252.0000, 'ºC'),
	(80713, 109, '2015-03-01 01:28:41.000000', 'temperatura', 451.0000, 'ºC'),
	(80714, 109, '2015-03-01 01:28:42.000000', 'temperatura', 299.0000, 'ºC'),
	(80715, 109, '2015-03-01 01:28:43.000000', 'temperatura', 141.0000, 'ºC'),
	(80716, 109, '2015-03-01 01:28:44.000000', 'temperatura', 1012.0000, 'ºC'),
	(80717, 109, '2015-03-01 01:28:45.000000', 'temperatura', 1037.0000, 'ºC'),
	(80718, 109, '2015-03-01 01:28:46.000000', 'temperatura', 947.0000, 'ºC'),
	(80719, 109, '2015-03-01 01:28:47.000000', 'temperatura', 426.0000, 'ºC'),
	(80720, 109, '2015-03-01 01:28:48.000000', 'temperatura', 488.0000, 'ºC'),
	(80721, 109, '2015-03-01 01:28:49.000000', 'temperatura', 1162.0000, 'ºC'),
	(80722, 109, '2015-03-01 01:28:50.000000', 'temperatura', 746.0000, 'ºC'),
	(80723, 109, '2015-03-01 01:28:51.000000', 'temperatura', 245.0000, 'ºC'),
	(80724, 109, '2015-03-01 01:28:52.000000', 'temperatura', 186.0000, 'ºC'),
	(80725, 109, '2015-03-01 01:28:53.000000', 'temperatura', 198.0000, 'ºC'),
	(80726, 109, '2015-03-01 01:28:54.000000', 'temperatura', 433.0000, 'ºC'),
	(80727, 109, '2015-03-01 01:28:55.000000', 'temperatura', 369.0000, 'ºC'),
	(80728, 109, '2015-03-01 01:28:56.000000', 'temperatura', 549.0000, 'ºC'),
	(80729, 109, '2015-03-01 01:28:57.000000', 'temperatura', 437.0000, 'ºC'),
	(80730, 109, '2015-03-01 01:28:58.000000', 'temperatura', 537.0000, 'ºC'),
	(80731, 109, '2015-03-01 01:28:59.000000', 'temperatura', 177.0000, 'ºC'),
	(80732, 109, '2015-03-01 01:29:00.000000', 'temperatura', 475.0000, 'ºC'),
	(80733, 109, '2015-03-01 01:29:01.000000', 'temperatura', 646.0000, 'ºC'),
	(80734, 109, '2015-03-01 01:29:02.000000', 'temperatura', 602.0000, 'ºC'),
	(80735, 109, '2015-03-01 01:29:03.000000', 'temperatura', 1075.0000, 'ºC'),
	(80736, 109, '2015-03-01 01:29:04.000000', 'temperatura', 1168.0000, 'ºC'),
	(80737, 109, '2015-03-01 01:29:05.000000', 'temperatura', 214.0000, 'ºC'),
	(80738, 109, '2015-03-01 01:29:06.000000', 'temperatura', 1167.0000, 'ºC'),
	(80739, 109, '2015-03-01 01:29:07.000000', 'temperatura', 394.0000, 'ºC'),
	(80740, 109, '2015-03-01 01:29:08.000000', 'temperatura', 870.0000, 'ºC'),
	(80741, 109, '2015-03-01 01:29:09.000000', 'temperatura', 770.0000, 'ºC'),
	(80742, 109, '2015-03-01 01:29:10.000000', 'temperatura', 39.0000, 'ºC'),
	(80743, 109, '2015-03-01 01:29:11.000000', 'temperatura', 285.0000, 'ºC'),
	(80744, 109, '2015-03-01 01:29:12.000000', 'temperatura', 108.0000, 'ºC'),
	(80745, 109, '2015-03-01 01:29:13.000000', 'temperatura', 885.0000, 'ºC'),
	(80746, 109, '2015-03-01 01:29:14.000000', 'temperatura', 504.0000, 'ºC'),
	(80747, 109, '2015-03-01 01:29:15.000000', 'temperatura', 1062.0000, 'ºC'),
	(80748, 109, '2015-03-01 01:29:16.000000', 'temperatura', 201.0000, 'ºC'),
	(80749, 109, '2015-03-01 01:29:17.000000', 'temperatura', 221.0000, 'ºC'),
	(80750, 109, '2015-03-01 01:29:18.000000', 'temperatura', 501.0000, 'ºC'),
	(80751, 109, '2015-03-01 01:29:19.000000', 'temperatura', 642.0000, 'ºC'),
	(80752, 109, '2015-03-01 01:29:20.000000', 'temperatura', 508.0000, 'ºC'),
	(80753, 109, '2015-03-01 01:29:21.000000', 'temperatura', 615.0000, 'ºC'),
	(80754, 109, '2015-03-01 01:29:22.000000', 'temperatura', 352.0000, 'ºC'),
	(80755, 109, '2015-03-01 01:29:23.000000', 'temperatura', 1114.0000, 'ºC'),
	(80756, 109, '2015-03-01 01:29:24.000000', 'temperatura', 914.0000, 'ºC'),
	(80757, 109, '2015-03-01 01:29:25.000000', 'temperatura', 28.0000, 'ºC'),
	(80758, 109, '2015-03-01 01:29:26.000000', 'temperatura', 998.0000, 'ºC'),
	(80759, 109, '2015-03-01 01:29:27.000000', 'temperatura', 106.0000, 'ºC'),
	(80760, 109, '2015-03-01 01:29:28.000000', 'temperatura', 1136.0000, 'ºC'),
	(80761, 109, '2015-03-01 01:29:29.000000', 'temperatura', 562.0000, 'ºC'),
	(80762, 109, '2015-03-01 01:29:30.000000', 'temperatura', 604.0000, 'ºC'),
	(80763, 109, '2015-03-01 01:29:31.000000', 'temperatura', 134.0000, 'ºC'),
	(80764, 109, '2015-03-01 01:29:32.000000', 'temperatura', 57.0000, 'ºC'),
	(80765, 109, '2015-03-01 01:29:33.000000', 'temperatura', 1086.0000, 'ºC'),
	(80766, 109, '2015-03-01 01:29:34.000000', 'temperatura', 461.0000, 'ºC'),
	(80767, 109, '2015-03-01 01:29:35.000000', 'temperatura', 245.0000, 'ºC'),
	(80768, 109, '2015-03-01 01:29:36.000000', 'temperatura', 1041.0000, 'ºC'),
	(80769, 109, '2015-03-01 01:29:37.000000', 'temperatura', 872.0000, 'ºC'),
	(80770, 109, '2015-03-01 01:29:38.000000', 'temperatura', 38.0000, 'ºC'),
	(80771, 109, '2015-03-01 01:29:39.000000', 'temperatura', 1173.0000, 'ºC'),
	(80772, 109, '2015-03-01 01:29:40.000000', 'temperatura', 952.0000, 'ºC'),
	(80773, 109, '2015-03-01 01:29:41.000000', 'temperatura', 41.0000, 'ºC'),
	(80774, 109, '2015-03-01 01:29:42.000000', 'temperatura', 952.0000, 'ºC'),
	(80775, 109, '2015-03-01 01:29:43.000000', 'temperatura', 1035.0000, 'ºC'),
	(80776, 109, '2015-03-01 01:29:44.000000', 'temperatura', 1122.0000, 'ºC'),
	(80777, 109, '2015-03-01 01:29:45.000000', 'temperatura', 102.0000, 'ºC'),
	(80778, 109, '2015-03-01 01:29:46.000000', 'temperatura', 747.0000, 'ºC'),
	(80779, 109, '2015-03-01 01:29:47.000000', 'temperatura', 1030.0000, 'ºC'),
	(80780, 109, '2015-03-01 01:29:48.000000', 'temperatura', 507.0000, 'ºC'),
	(80781, 109, '2015-03-01 01:29:49.000000', 'temperatura', 647.0000, 'ºC'),
	(80782, 109, '2015-03-01 01:29:50.000000', 'temperatura', 513.0000, 'ºC'),
	(80783, 109, '2015-03-01 01:29:51.000000', 'temperatura', 626.0000, 'ºC'),
	(80784, 109, '2015-03-01 01:29:52.000000', 'temperatura', 393.0000, 'ºC'),
	(80785, 109, '2015-03-01 01:29:53.000000', 'temperatura', 84.0000, 'ºC'),
	(80786, 109, '2015-03-01 01:29:54.000000', 'temperatura', 444.0000, 'ºC'),
	(80787, 109, '2015-03-01 01:29:55.000000', 'temperatura', 769.0000, 'ºC'),
	(80788, 109, '2015-03-01 01:29:56.000000', 'temperatura', 114.0000, 'ºC'),
	(80789, 109, '2015-03-01 01:29:57.000000', 'temperatura', 663.0000, 'ºC'),
	(80790, 109, '2015-03-01 01:29:58.000000', 'temperatura', 575.0000, 'ºC'),
	(80791, 109, '2015-03-01 01:29:59.000000', 'temperatura', 886.0000, 'ºC'),
	(80792, 109, '2015-03-01 01:30:00.000000', 'temperatura', 304.0000, 'ºC'),
	(80793, 109, '2015-03-01 01:30:01.000000', 'temperatura', 63.0000, 'ºC'),
	(80794, 109, '2015-03-01 01:30:02.000000', 'temperatura', 603.0000, 'ºC'),
	(80795, 109, '2015-03-01 01:30:03.000000', 'temperatura', 426.0000, 'ºC'),
	(80796, 109, '2015-03-01 01:30:04.000000', 'temperatura', 322.0000, 'ºC'),
	(80797, 109, '2015-03-01 01:30:05.000000', 'temperatura', 331.0000, 'ºC'),
	(80798, 109, '2015-03-01 01:30:06.000000', 'temperatura', 691.0000, 'ºC'),
	(80799, 109, '2015-03-01 01:30:07.000000', 'temperatura', 61.0000, 'ºC'),
	(80800, 109, '2015-03-01 01:30:08.000000', 'temperatura', 632.0000, 'ºC'),
	(80801, 109, '2015-03-01 01:30:09.000000', 'temperatura', 579.0000, 'ºC'),
	(80802, 109, '2015-03-01 01:30:10.000000', 'temperatura', 998.0000, 'ºC'),
	(80803, 109, '2015-03-01 01:30:11.000000', 'temperatura', 852.0000, 'ºC'),
	(80804, 109, '2015-03-01 01:30:12.000000', 'temperatura', 70.0000, 'ºC'),
	(80805, 109, '2015-03-01 01:30:13.000000', 'temperatura', 193.0000, 'ºC'),
	(80806, 109, '2015-03-01 01:30:14.000000', 'temperatura', 755.0000, 'ºC'),
	(80807, 109, '2015-03-01 01:30:15.000000', 'temperatura', 797.0000, 'ºC'),
	(80808, 109, '2015-03-01 01:30:16.000000', 'temperatura', 519.0000, 'ºC'),
	(80809, 109, '2015-03-01 01:30:17.000000', 'temperatura', 206.0000, 'ºC'),
	(80810, 109, '2015-03-01 01:30:18.000000', 'temperatura', 672.0000, 'ºC'),
	(80811, 109, '2015-03-01 01:30:19.000000', 'temperatura', 343.0000, 'ºC'),
	(80812, 109, '2015-03-01 01:30:20.000000', 'temperatura', 898.0000, 'ºC'),
	(80813, 109, '2015-03-01 01:30:21.000000', 'temperatura', 1064.0000, 'ºC'),
	(80814, 109, '2015-03-01 01:30:22.000000', 'temperatura', 224.0000, 'ºC'),
	(80815, 109, '2015-03-01 01:30:23.000000', 'temperatura', 328.0000, 'ºC'),
	(80816, 109, '2015-03-01 01:30:24.000000', 'temperatura', 971.0000, 'ºC'),
	(80817, 109, '2015-03-01 01:30:25.000000', 'temperatura', 268.0000, 'ºC'),
	(80818, 109, '2015-03-01 01:30:26.000000', 'temperatura', 831.0000, 'ºC'),
	(80819, 109, '2015-03-01 01:30:27.000000', 'temperatura', 951.0000, 'ºC'),
	(80820, 109, '2015-03-01 01:30:28.000000', 'temperatura', 1063.0000, 'ºC'),
	(80821, 109, '2015-03-01 01:30:29.000000', 'temperatura', 63.0000, 'ºC'),
	(80822, 109, '2015-03-01 01:30:30.000000', 'temperatura', 724.0000, 'ºC'),
	(80823, 109, '2015-03-01 01:30:31.000000', 'temperatura', 1034.0000, 'ºC'),
	(80824, 109, '2015-03-01 01:30:32.000000', 'temperatura', 599.0000, 'ºC'),
	(80825, 109, '2015-03-01 01:30:33.000000', 'temperatura', 1093.0000, 'ºC'),
	(80826, 109, '2015-03-01 01:30:34.000000', 'temperatura', 68.0000, 'ºC'),
	(80827, 109, '2015-03-01 01:30:35.000000', 'temperatura', 660.0000, 'ºC'),
	(80828, 109, '2015-03-01 01:30:36.000000', 'temperatura', 699.0000, 'ºC'),
	(80829, 109, '2015-03-01 01:30:37.000000', 'temperatura', 314.0000, 'ºC'),
	(80830, 109, '2015-03-01 01:30:38.000000', 'temperatura', 674.0000, 'ºC'),
	(80831, 109, '2015-03-01 01:30:39.000000', 'temperatura', 29.0000, 'ºC'),
	(80832, 109, '2015-03-01 01:30:40.000000', 'temperatura', 523.0000, 'ºC'),
	(80833, 109, '2015-03-01 01:30:41.000000', 'temperatura', 129.0000, 'ºC'),
	(80834, 109, '2015-03-01 01:30:42.000000', 'temperatura', 277.0000, 'ºC'),
	(80835, 109, '2015-03-01 01:30:43.000000', 'temperatura', 998.0000, 'ºC'),
	(80836, 109, '2015-03-01 01:30:44.000000', 'temperatura', 559.0000, 'ºC'),
	(80837, 109, '2015-03-01 01:30:45.000000', 'temperatura', 1000.0000, 'ºC'),
	(80838, 109, '2015-03-01 01:30:46.000000', 'temperatura', 925.0000, 'ºC'),
	(80839, 109, '2015-03-01 01:30:47.000000', 'temperatura', 425.0000, 'ºC'),
	(80840, 109, '2015-03-01 01:30:48.000000', 'temperatura', 549.0000, 'ºC'),
	(80841, 109, '2015-03-01 01:30:49.000000', 'temperatura', 272.0000, 'ºC'),
	(80842, 109, '2015-03-01 01:30:50.000000', 'temperatura', 915.0000, 'ºC'),
	(80843, 109, '2015-03-01 01:30:51.000000', 'temperatura', 157.0000, 'ºC'),
	(80844, 109, '2015-03-01 01:30:52.000000', 'temperatura', 443.0000, 'ºC'),
	(80845, 109, '2015-03-01 01:30:53.000000', 'temperatura', 544.0000, 'ºC'),
	(80846, 109, '2015-03-01 01:30:54.000000', 'temperatura', 192.0000, 'ºC'),
	(80847, 109, '2015-03-01 01:30:55.000000', 'temperatura', 526.0000, 'ºC'),
	(80848, 109, '2015-03-01 01:30:56.000000', 'temperatura', 857.0000, 'ºC'),
	(80849, 109, '2015-03-01 01:30:57.000000', 'temperatura', 307.0000, 'ºC'),
	(80850, 109, '2015-03-01 01:30:58.000000', 'temperatura', 166.0000, 'ºC'),
	(80851, 109, '2015-03-01 01:30:59.000000', 'temperatura', 1106.0000, 'ºC'),
	(80852, 109, '2015-03-01 01:31:00.000000', 'temperatura', 236.0000, 'ºC'),
	(80853, 109, '2015-03-01 01:31:01.000000', 'temperatura', 260.0000, 'ºC'),
	(80854, 109, '2015-03-01 01:31:02.000000', 'temperatura', 595.0000, 'ºC'),
	(80855, 109, '2015-03-01 01:31:03.000000', 'temperatura', 996.0000, 'ºC'),
	(80856, 109, '2015-03-01 01:31:04.000000', 'temperatura', 796.0000, 'ºC'),
	(80857, 109, '2015-03-01 01:31:05.000000', 'temperatura', 990.0000, 'ºC'),
	(80858, 109, '2015-03-01 01:31:06.000000', 'temperatura', 165.0000, 'ºC'),
	(80859, 109, '2015-03-01 01:31:07.000000', 'temperatura', 256.0000, 'ºC'),
	(80860, 109, '2015-03-01 01:31:08.000000', 'temperatura', 783.0000, 'ºC'),
	(80861, 109, '2015-03-01 01:31:09.000000', 'temperatura', 748.0000, 'ºC'),
	(80862, 109, '2015-03-01 01:31:10.000000', 'temperatura', 190.0000, 'ºC'),
	(80863, 109, '2015-03-01 01:31:11.000000', 'temperatura', 1108.0000, 'ºC'),
	(80864, 109, '2015-03-01 01:31:12.000000', 'temperatura', 172.0000, 'ºC'),
	(80865, 109, '2015-03-01 01:31:13.000000', 'temperatura', 1136.0000, 'ºC'),
	(80866, 109, '2015-03-01 01:31:14.000000', 'temperatura', 363.0000, 'ºC'),
	(80867, 109, '2015-03-01 01:31:15.000000', 'temperatura', 807.0000, 'ºC'),
	(80868, 109, '2015-03-01 01:31:16.000000', 'temperatura', 548.0000, 'ºC'),
	(80869, 109, '2015-03-01 01:31:17.000000', 'temperatura', 320.0000, 'ºC'),
	(80870, 109, '2015-03-01 01:31:18.000000', 'temperatura', 1154.0000, 'ºC'),
	(80871, 109, '2015-03-01 01:31:19.000000', 'temperatura', 11.0000, 'ºC'),
	(80872, 109, '2015-03-01 01:31:20.000000', 'temperatura', 195.0000, 'ºC'),
	(80873, 109, '2015-03-01 01:31:21.000000', 'temperatura', 943.0000, 'ºC'),
	(80874, 109, '2015-03-01 01:31:22.000000', 'temperatura', 528.0000, 'ºC'),
	(80875, 109, '2015-03-01 01:31:23.000000', 'temperatura', 1012.0000, 'ºC'),
	(80876, 109, '2015-03-01 01:31:24.000000', 'temperatura', 1077.0000, 'ºC'),
	(80877, 109, '2015-03-01 01:31:25.000000', 'temperatura', 1152.0000, 'ºC'),
	(80878, 109, '2015-03-01 01:31:26.000000', 'temperatura', 126.0000, 'ºC'),
	(80879, 109, '2015-03-01 01:31:27.000000', 'temperatura', 775.0000, 'ºC'),
	(80880, 109, '2015-03-01 01:31:28.000000', 'temperatura', 1100.0000, 'ºC'),
	(80881, 109, '2015-03-01 01:31:29.000000', 'temperatura', 773.0000, 'ºC'),
	(80882, 109, '2015-03-01 01:31:30.000000', 'temperatura', 565.0000, 'ºC'),
	(80883, 109, '2015-03-01 01:31:31.000000', 'temperatura', 507.0000, 'ºC'),
	(80884, 109, '2015-03-01 01:31:32.000000', 'temperatura', 841.0000, 'ºC'),
	(80885, 109, '2015-03-01 01:31:33.000000', 'temperatura', 285.0000, 'ºC'),
	(80886, 109, '2015-03-01 01:31:34.000000', 'temperatura', 100.0000, 'ºC'),
	(80887, 109, '2015-03-01 01:31:35.000000', 'temperatura', 847.0000, 'ºC'),
	(80888, 109, '2015-03-01 01:31:36.000000', 'temperatura', 334.0000, 'ºC'),
	(80889, 109, '2015-03-01 01:31:37.000000', 'temperatura', 329.0000, 'ºC'),
	(80890, 109, '2015-03-01 01:31:38.000000', 'temperatura', 646.0000, 'ºC'),
	(80891, 109, '2015-03-01 01:31:39.000000', 'temperatura', 1041.0000, 'ºC'),
	(80892, 109, '2015-03-01 01:31:40.000000', 'temperatura', 867.0000, 'ºC'),
	(80893, 109, '2015-03-01 01:31:41.000000', 'temperatura', 14.0000, 'ºC'),
	(80894, 109, '2015-03-01 01:31:42.000000', 'temperatura', 1069.0000, 'ºC'),
	(80895, 109, '2015-03-01 01:31:43.000000', 'temperatura', 503.0000, 'ºC'),
	(80896, 109, '2015-03-01 01:31:44.000000', 'temperatura', 507.0000, 'ºC'),
	(80897, 109, '2015-03-01 01:31:45.000000', 'temperatura', 1027.0000, 'ºC'),
	(80898, 109, '2015-03-01 01:31:46.000000', 'temperatura', 17.0000, 'ºC'),
	(80899, 109, '2015-03-01 01:31:47.000000', 'temperatura', 603.0000, 'ºC'),
	(80900, 109, '2015-03-01 01:31:48.000000', 'temperatura', 563.0000, 'ºC'),
	(80901, 109, '2015-03-01 01:31:49.000000', 'temperatura', 1010.0000, 'ºC'),
	(80902, 109, '2015-03-01 01:31:50.000000', 'temperatura', 958.0000, 'ºC'),
	(80903, 109, '2015-03-01 01:31:51.000000', 'temperatura', 562.0000, 'ºC'),
	(80904, 109, '2015-03-01 01:31:52.000000', 'temperatura', 1136.0000, 'ºC'),
	(80905, 109, '2015-03-01 01:31:53.000000', 'temperatura', 395.0000, 'ºC'),
	(80906, 109, '2015-03-01 01:31:54.000000', 'temperatura', 966.0000, 'ºC'),
	(80907, 109, '2015-03-01 01:31:55.000000', 'temperatura', 44.0000, 'ºC'),
	(80908, 109, '2015-03-01 01:31:56.000000', 'temperatura', 926.0000, 'ºC'),
	(80909, 109, '2015-03-01 01:31:57.000000', 'temperatura', 897.0000, 'ºC'),
	(80910, 109, '2015-03-01 01:31:58.000000', 'temperatura', 507.0000, 'ºC'),
	(80911, 109, '2015-03-01 01:31:59.000000', 'temperatura', 1045.0000, 'ºC'),
	(80912, 109, '2015-03-01 01:32:00.000000', 'temperatura', 104.0000, 'ºC'),
	(80913, 109, '2015-03-01 01:32:01.000000', 'temperatura', 984.0000, 'ºC'),
	(80914, 109, '2015-03-01 01:32:02.000000', 'temperatura', 1010.0000, 'ºC'),
	(80915, 109, '2015-03-01 01:32:03.000000', 'temperatura', 899.0000, 'ºC'),
	(80916, 109, '2015-03-01 01:32:04.000000', 'temperatura', 267.0000, 'ºC'),
	(80917, 109, '2015-03-01 01:32:05.000000', 'temperatura', 1037.0000, 'ºC'),
	(80918, 109, '2015-03-01 01:32:06.000000', 'temperatura', 783.0000, 'ºC'),
	(80919, 109, '2015-03-01 01:32:07.000000', 'temperatura', 805.0000, 'ºC'),
	(80920, 109, '2015-03-01 01:32:08.000000', 'temperatura', 477.0000, 'ºC'),
	(80921, 109, '2015-03-01 01:32:09.000000', 'temperatura', 1172.0000, 'ºC'),
	(80922, 109, '2015-03-01 01:32:10.000000', 'temperatura', 829.0000, 'ºC'),
	(80923, 109, '2015-03-01 01:32:11.000000', 'temperatura', 630.0000, 'ºC'),
	(80924, 109, '2015-03-01 01:32:12.000000', 'temperatura', 662.0000, 'ºC'),
	(80925, 109, '2015-03-01 01:32:13.000000', 'temperatura', 221.0000, 'ºC'),
	(80926, 109, '2015-03-01 01:32:14.000000', 'temperatura', 322.0000, 'ºC'),
	(80927, 109, '2015-03-01 01:32:15.000000', 'temperatura', 944.0000, 'ºC'),
	(80928, 109, '2015-03-01 01:32:16.000000', 'temperatura', 155.0000, 'ºC'),
	(80929, 109, '2015-03-01 01:32:17.000000', 'temperatura', 346.0000, 'ºC'),
	(80930, 109, '2015-03-01 01:32:18.000000', 'temperatura', 65.0000, 'ºC'),
	(80931, 109, '2015-03-01 01:32:19.000000', 'temperatura', 486.0000, 'ºC'),
	(80932, 109, '2015-03-01 01:32:20.000000', 'temperatura', 1034.0000, 'ºC'),
	(80933, 109, '2015-03-01 01:32:21.000000', 'temperatura', 116.0000, 'ºC'),
	(80934, 109, '2015-03-01 01:32:22.000000', 'temperatura', 1076.0000, 'ºC'),
	(80935, 109, '2015-03-01 01:32:23.000000', 'temperatura', 231.0000, 'ºC'),
	(80936, 109, '2015-03-01 01:32:24.000000', 'temperatura', 331.0000, 'ºC'),
	(80937, 109, '2015-03-01 01:32:25.000000', 'temperatura', 960.0000, 'ºC'),
	(80938, 109, '2015-03-01 01:32:26.000000', 'temperatura', 206.0000, 'ºC'),
	(80939, 109, '2015-03-01 01:32:27.000000', 'temperatura', 553.0000, 'ºC'),
	(80940, 109, '2015-03-01 01:32:28.000000', 'temperatura', 946.0000, 'ºC'),
	(80941, 109, '2015-03-01 01:32:29.000000', 'temperatura', 673.0000, 'ºC'),
	(80942, 109, '2015-03-01 01:32:30.000000', 'temperatura', 526.0000, 'ºC'),
	(80943, 109, '2015-03-01 01:32:31.000000', 'temperatura', 614.0000, 'ºC'),
	(80944, 109, '2015-03-01 01:32:32.000000', 'temperatura', 292.0000, 'ºC'),
	(80945, 109, '2015-03-01 01:32:33.000000', 'temperatura', 817.0000, 'ºC'),
	(80946, 109, '2015-03-01 01:32:34.000000', 'temperatura', 809.0000, 'ºC'),
	(80947, 109, '2015-03-01 01:32:35.000000', 'temperatura', 395.0000, 'ºC'),
	(80948, 109, '2015-03-01 01:32:36.000000', 'temperatura', 749.0000, 'ºC'),
	(80949, 109, '2015-03-01 01:32:37.000000', 'temperatura', 158.0000, 'ºC'),
	(80950, 109, '2015-03-01 01:32:38.000000', 'temperatura', 946.0000, 'ºC'),
	(80951, 109, '2015-03-01 01:32:39.000000', 'temperatura', 658.0000, 'ºC'),
	(80952, 109, '2015-03-01 01:32:40.000000', 'temperatura', 450.0000, 'ºC'),
	(80953, 109, '2015-03-01 01:32:41.000000', 'temperatura', 277.0000, 'ºC'),
	(80954, 109, '2015-03-01 01:32:42.000000', 'temperatura', 37.0000, 'ºC'),
	(80955, 109, '2015-03-01 01:32:43.000000', 'temperatura', 552.0000, 'ºC'),
	(80956, 109, '2015-03-01 01:32:44.000000', 'temperatura', 252.0000, 'ºC'),
	(80957, 109, '2015-03-01 01:32:45.000000', 'temperatura', 804.0000, 'ºC'),
	(80958, 109, '2015-03-01 01:32:46.000000', 'temperatura', 862.0000, 'ºC'),
	(80959, 109, '2015-03-01 01:32:47.000000', 'temperatura', 702.0000, 'ºC'),
	(80960, 109, '2015-03-01 01:32:48.000000', 'temperatura', 923.0000, 'ºC'),
	(80961, 109, '2015-03-01 01:32:49.000000', 'temperatura', 109.0000, 'ºC'),
	(80962, 109, '2015-03-01 01:32:50.000000', 'temperatura', 179.0000, 'ºC'),
	(80963, 109, '2015-03-01 01:32:51.000000', 'temperatura', 566.0000, 'ºC'),
	(80964, 109, '2015-03-01 01:32:52.000000', 'temperatura', 1096.0000, 'ºC'),
	(80965, 109, '2015-03-01 01:32:53.000000', 'temperatura', 180.0000, 'ºC'),
	(80966, 109, '2015-03-01 01:32:54.000000', 'temperatura', 14.0000, 'ºC'),
	(80967, 109, '2015-03-01 01:32:55.000000', 'temperatura', 731.0000, 'ºC'),
	(80968, 109, '2015-03-01 01:32:56.000000', 'temperatura', 13.0000, 'ºC'),
	(80969, 109, '2015-03-01 01:32:57.000000', 'temperatura', 270.0000, 'ºC'),
	(80970, 109, '2015-03-01 01:32:58.000000', 'temperatura', 115.0000, 'ºC'),
	(80971, 109, '2015-03-01 01:32:59.000000', 'temperatura', 963.0000, 'ºC'),
	(80972, 109, '2015-03-01 01:33:00.000000', 'temperatura', 872.0000, 'ºC'),
	(80973, 109, '2015-03-01 01:33:01.000000', 'temperatura', 271.0000, 'ºC'),
	(80974, 109, '2015-03-01 01:33:02.000000', 'temperatura', 1138.0000, 'ºC'),
	(80975, 109, '2015-03-01 01:33:03.000000', 'temperatura', 78.0000, 'ºC'),
	(80976, 109, '2015-03-01 01:33:04.000000', 'temperatura', 577.0000, 'ºC'),
	(80977, 109, '2015-03-01 01:33:05.000000', 'temperatura', 252.0000, 'ºC'),
	(80978, 109, '2015-03-01 01:33:06.000000', 'temperatura', 729.0000, 'ºC'),
	(80979, 109, '2015-03-01 01:33:07.000000', 'temperatura', 490.0000, 'ºC'),
	(80980, 109, '2015-03-01 01:33:08.000000', 'temperatura', 264.0000, 'ºC'),
	(80981, 109, '2015-03-01 01:33:09.000000', 'temperatura', 1048.0000, 'ºC'),
	(80982, 109, '2015-03-01 01:33:10.000000', 'temperatura', 852.0000, 'ºC'),
	(80983, 109, '2015-03-01 01:33:11.000000', 'temperatura', 1114.0000, 'ºC'),
	(80984, 109, '2015-03-01 01:33:12.000000', 'temperatura', 614.0000, 'ºC'),
	(80985, 109, '2015-03-01 01:33:13.000000', 'temperatura', 930.0000, 'ºC'),
	(80986, 109, '2015-03-01 01:33:14.000000', 'temperatura', 406.0000, 'ºC'),
	(80987, 109, '2015-03-01 01:33:15.000000', 'temperatura', 443.0000, 'ºC'),
	(80988, 109, '2015-03-01 01:33:16.000000', 'temperatura', 998.0000, 'ºC'),
	(80989, 109, '2015-03-01 01:33:17.000000', 'temperatura', 59.0000, 'ºC'),
	(80990, 109, '2015-03-01 01:33:18.000000', 'temperatura', 901.0000, 'ºC'),
	(80991, 109, '2015-03-01 01:33:19.000000', 'temperatura', 728.0000, 'ºC'),
	(80992, 109, '2015-03-01 01:33:20.000000', 'temperatura', 940.0000, 'ºC'),
	(80993, 109, '2015-03-01 01:33:21.000000', 'temperatura', 117.0000, 'ºC'),
	(80994, 109, '2015-03-01 01:33:22.000000', 'temperatura', 162.0000, 'ºC'),
	(80995, 109, '2015-03-01 01:33:23.000000', 'temperatura', 463.0000, 'ºC'),
	(80996, 109, '2015-03-01 01:33:24.000000', 'temperatura', 629.0000, 'ºC'),
	(80997, 109, '2015-03-01 01:33:25.000000', 'temperatura', 557.0000, 'ºC'),
	(80998, 109, '2015-03-01 01:33:26.000000', 'temperatura', 897.0000, 'ºC'),
	(80999, 109, '2015-03-01 01:33:27.000000', 'temperatura', 415.0000, 'ºC'),
	(81000, 109, '2015-03-01 01:33:28.000000', 'temperatura', 583.0000, 'ºC'),
	(81001, 109, '2015-03-01 01:33:29.000000', 'temperatura', 470.0000, 'ºC'),
	(81002, 109, '2015-03-01 01:33:30.000000', 'temperatura', 601.0000, 'ºC'),
	(81003, 109, '2015-03-01 01:33:31.000000', 'temperatura', 395.0000, 'ºC'),
	(81004, 109, '2015-03-01 01:33:32.000000', 'temperatura', 173.0000, 'ºC'),
	(81005, 109, '2015-03-01 01:33:33.000000', 'temperatura', 881.0000, 'ºC'),
	(81006, 109, '2015-03-01 01:33:34.000000', 'temperatura', 288.0000, 'ºC'),
	(81007, 109, '2015-03-01 01:33:35.000000', 'temperatura', 1198.0000, 'ºC'),
	(81008, 109, '2015-03-01 01:33:36.000000', 'temperatura', 326.0000, 'ºC'),
	(81009, 109, '2015-03-01 01:33:37.000000', 'temperatura', 436.0000, 'ºC'),
	(81010, 109, '2015-03-01 01:33:38.000000', 'temperatura', 2.0000, 'ºC'),
	(81011, 109, '2015-03-01 01:33:39.000000', 'temperatura', 1102.0000, 'ºC'),
	(81012, 109, '2015-03-01 01:33:40.000000', 'temperatura', 705.0000, 'ºC'),
	(81013, 109, '2015-03-01 01:33:41.000000', 'temperatura', 218.0000, 'ºC'),
	(81014, 109, '2015-03-01 01:33:42.000000', 'temperatura', 177.0000, 'ºC'),
	(81015, 109, '2015-03-01 01:33:43.000000', 'temperatura', 230.0000, 'ºC'),
	(81016, 109, '2015-03-01 01:33:44.000000', 'temperatura', 619.0000, 'ºC'),
	(81017, 109, '2015-03-01 01:33:45.000000', 'temperatura', 7.0000, 'ºC'),
	(81018, 109, '2015-03-01 01:33:46.000000', 'temperatura', 579.0000, 'ºC'),
	(81019, 109, '2015-03-01 01:33:47.000000', 'temperatura', 475.0000, 'ºC'),
	(81020, 109, '2015-03-01 01:33:48.000000', 'temperatura', 638.0000, 'ºC'),
	(81021, 109, '2015-03-01 01:33:49.000000', 'temperatura', 565.0000, 'ºC'),
	(81022, 109, '2015-03-01 01:33:50.000000', 'temperatura', 910.0000, 'ºC'),
	(81023, 109, '2015-03-01 01:33:51.000000', 'temperatura', 456.0000, 'ºC'),
	(81024, 109, '2015-03-01 01:33:52.000000', 'temperatura', 750.0000, 'ºC'),
	(81025, 109, '2015-03-01 01:33:53.000000', 'temperatura', 1185.0000, 'ºC'),
	(81026, 109, '2015-03-01 01:33:54.000000', 'temperatura', 73.0000, 'ºC'),
	(81027, 109, '2015-03-01 01:33:55.000000', 'temperatura', 412.0000, 'ºC'),
	(81028, 109, '2015-03-01 01:33:56.000000', 'temperatura', 640.0000, 'ºC'),
	(81029, 109, '2015-03-01 01:33:57.000000', 'temperatura', 764.0000, 'ºC'),
	(81030, 109, '2015-03-01 01:33:58.000000', 'temperatura', 700.0000, 'ºC'),
	(81031, 109, '2015-03-01 01:33:59.000000', 'temperatura', 7.0000, 'ºC'),
	(81032, 109, '2015-03-01 01:34:00.000000', 'temperatura', 339.0000, 'ºC'),
	(81033, 109, '2015-03-01 01:34:01.000000', 'temperatura', 471.0000, 'ºC'),
	(81034, 109, '2015-03-01 01:34:02.000000', 'temperatura', 141.0000, 'ºC'),
	(81035, 109, '2015-03-01 01:34:03.000000', 'temperatura', 493.0000, 'ºC'),
	(81036, 109, '2015-03-01 01:34:04.000000', 'temperatura', 842.0000, 'ºC'),
	(81037, 109, '2015-03-01 01:34:05.000000', 'temperatura', 331.0000, 'ºC'),
	(81038, 109, '2015-03-01 01:34:06.000000', 'temperatura', 330.0000, 'ºC'),
	(81039, 109, '2015-03-01 01:34:07.000000', 'temperatura', 659.0000, 'ºC'),
	(81040, 109, '2015-03-01 01:34:08.000000', 'temperatura', 1105.0000, 'ºC'),
	(81041, 109, '2015-03-01 01:34:09.000000', 'temperatura', 1147.0000, 'ºC'),
	(81042, 109, '2015-03-01 01:34:10.000000', 'temperatura', 21.0000, 'ºC'),
	(81043, 109, '2015-03-01 01:34:11.000000', 'temperatura', 264.0000, 'ºC'),
	(81044, 109, '2015-03-01 01:34:12.000000', 'temperatura', 60.0000, 'ºC'),
	(81045, 109, '2015-03-01 01:34:13.000000', 'temperatura', 705.0000, 'ºC'),
	(81046, 109, '2015-03-01 01:34:14.000000', 'temperatura', 948.0000, 'ºC'),
	(81047, 109, '2015-03-01 01:34:15.000000', 'temperatura', 225.0000, 'ºC'),
	(81048, 109, '2015-03-01 01:34:16.000000', 'temperatura', 680.0000, 'ºC'),
	(81049, 109, '2015-03-01 01:34:17.000000', 'temperatura', 327.0000, 'ºC'),
	(81050, 109, '2015-03-01 01:34:18.000000', 'temperatura', 795.0000, 'ºC'),
	(81051, 109, '2015-03-01 01:34:19.000000', 'temperatura', 596.0000, 'ºC'),
	(81052, 109, '2015-03-01 01:34:20.000000', 'temperatura', 595.0000, 'ºC'),
	(81053, 109, '2015-03-01 01:34:21.000000', 'temperatura', 1186.0000, 'ºC'),
	(81054, 109, '2015-03-01 01:34:22.000000', 'temperatura', 547.0000, 'ºC'),
	(81055, 109, '2015-03-01 01:34:23.000000', 'temperatura', 376.0000, 'ºC'),
	(81056, 109, '2015-03-01 01:34:24.000000', 'temperatura', 240.0000, 'ºC'),
	(81057, 109, '2015-03-01 01:34:25.000000', 'temperatura', 74.0000, 'ºC'),
	(81058, 109, '2015-03-01 01:34:26.000000', 'temperatura', 850.0000, 'ºC'),
	(81059, 109, '2015-03-01 01:34:27.000000', 'temperatura', 426.0000, 'ºC'),
	(81060, 109, '2015-03-01 01:34:28.000000', 'temperatura', 783.0000, 'ºC'),
	(81061, 109, '2015-03-01 01:34:29.000000', 'temperatura', 236.0000, 'ºC'),
	(81062, 109, '2015-03-01 01:34:30.000000', 'temperatura', 33.0000, 'ºC'),
	(81063, 109, '2015-03-01 01:34:31.000000', 'temperatura', 655.0000, 'ºC'),
	(81064, 109, '2015-03-01 01:34:32.000000', 'temperatura', 777.0000, 'ºC'),
	(81065, 109, '2015-03-01 01:34:33.000000', 'temperatura', 723.0000, 'ºC'),
	(81066, 109, '2015-03-01 01:34:34.000000', 'temperatura', 83.0000, 'ºC'),
	(81067, 109, '2015-03-01 01:34:35.000000', 'temperatura', 648.0000, 'ºC'),
	(81068, 109, '2015-03-01 01:34:36.000000', 'temperatura', 590.0000, 'ºC'),
	(81069, 109, '2015-03-01 01:34:37.000000', 'temperatura', 1007.0000, 'ºC'),
	(81070, 109, '2015-03-01 01:34:38.000000', 'temperatura', 865.0000, 'ºC'),
	(81071, 109, '2015-03-01 01:34:39.000000', 'temperatura', 105.0000, 'ºC'),
	(81072, 109, '2015-03-01 01:34:40.000000', 'temperatura', 331.0000, 'ºC'),
	(81073, 109, '2015-03-01 01:34:41.000000', 'temperatura', 139.0000, 'ºC'),
	(81074, 109, '2015-03-01 01:34:42.000000', 'temperatura', 903.0000, 'ºC'),
	(81075, 109, '2015-03-01 01:34:43.000000', 'temperatura', 497.0000, 'ºC'),
	(81076, 109, '2015-03-01 01:34:44.000000', 'temperatura', 977.0000, 'ºC'),
	(81077, 109, '2015-03-01 01:34:45.000000', 'temperatura', 997.0000, 'ºC'),
	(81078, 109, '2015-03-01 01:34:46.000000', 'temperatura', 853.0000, 'ºC'),
	(81079, 109, '2015-03-01 01:34:47.000000', 'temperatura', 76.0000, 'ºC'),
	(81080, 109, '2015-03-01 01:34:48.000000', 'temperatura', 220.0000, 'ºC'),
	(81081, 109, '2015-03-01 01:34:49.000000', 'temperatura', 873.0000, 'ºC'),
	(81082, 109, '2015-03-01 01:34:50.000000', 'temperatura', 107.0000, 'ºC'),
	(81083, 109, '2015-03-01 01:34:51.000000', 'temperatura', 314.0000, 'ºC'),
	(81084, 109, '2015-03-01 01:34:52.000000', 'temperatura', 51.0000, 'ºC'),
	(81085, 109, '2015-03-01 01:34:53.000000', 'temperatura', 513.0000, 'ºC'),
	(81086, 109, '2015-03-01 01:34:54.000000', 'temperatura', 11.0000, 'ºC'),
	(81087, 109, '2015-03-01 01:34:55.000000', 'temperatura', 918.0000, 'ºC'),
	(81088, 109, '2015-03-01 01:34:56.000000', 'temperatura', 956.0000, 'ºC'),
	(81089, 109, '2015-03-01 01:34:57.000000', 'temperatura', 828.0000, 'ºC'),
	(81090, 109, '2015-03-01 01:34:58.000000', 'temperatura', 72.0000, 'ºC'),
	(81091, 109, '2015-03-01 01:34:59.000000', 'temperatura', 279.0000, 'ºC'),
	(81092, 109, '2015-03-01 01:35:00.000000', 'temperatura', 1176.0000, 'ºC'),
	(81093, 109, '2015-03-01 01:35:01.000000', 'temperatura', 246.0000, 'ºC'),
	(81094, 109, '2015-03-01 01:35:02.000000', 'temperatura', 100.0000, 'ºC'),
	(81095, 109, '2015-03-01 01:35:03.000000', 'temperatura', 963.0000, 'ºC'),
	(81096, 109, '2015-03-01 01:35:04.000000', 'temperatura', 917.0000, 'ºC'),
	(81097, 109, '2015-03-01 01:35:05.000000', 'temperatura', 498.0000, 'ºC'),
	(81098, 109, '2015-03-01 01:35:06.000000', 'temperatura', 937.0000, 'ºC'),
	(81099, 109, '2015-03-01 01:35:07.000000', 'temperatura', 792.0000, 'ºC'),
	(81100, 109, '2015-03-01 01:35:08.000000', 'temperatura', 1148.0000, 'ºC'),
	(81101, 109, '2015-03-01 01:35:09.000000', 'temperatura', 964.0000, 'ºC'),
	(81102, 109, '2015-03-01 01:35:10.000000', 'temperatura', 177.0000, 'ºC'),
	(81103, 109, '2015-03-01 01:35:11.000000', 'temperatura', 396.0000, 'ºC'),
	(81104, 109, '2015-03-01 01:35:12.000000', 'temperatura', 247.0000, 'ºC'),
	(81105, 109, '2015-03-01 01:35:13.000000', 'temperatura', 47.0000, 'ºC'),
	(81106, 109, '2015-03-01 01:35:14.000000', 'temperatura', 695.0000, 'ºC'),
	(81107, 109, '2015-03-01 01:35:15.000000', 'temperatura', 937.0000, 'ºC'),
	(81108, 109, '2015-03-01 01:35:16.000000', 'temperatura', 199.0000, 'ºC'),
	(81109, 109, '2015-03-01 01:35:17.000000', 'temperatura', 582.0000, 'ºC'),
	(81110, 109, '2015-03-01 01:35:18.000000', 'temperatura', 1117.0000, 'ºC'),
	(81111, 109, '2015-03-01 01:35:19.000000', 'temperatura', 238.0000, 'ºC'),
	(81112, 109, '2015-03-01 01:35:20.000000', 'temperatura', 241.0000, 'ºC'),
	(81113, 109, '2015-03-01 01:35:21.000000', 'temperatura', 492.0000, 'ºC'),
	(81114, 109, '2015-03-01 01:35:22.000000', 'temperatura', 538.0000, 'ºC'),
	(81115, 109, '2015-03-01 01:35:23.000000', 'temperatura', 13.0000, 'ºC'),
	(81116, 109, '2015-03-01 01:35:24.000000', 'temperatura', 851.0000, 'ºC'),
	(81117, 109, '2015-03-01 01:35:25.000000', 'temperatura', 619.0000, 'ºC'),
	(81118, 109, '2015-03-01 01:35:26.000000', 'temperatura', 541.0000, 'ºC'),
	(81119, 109, '2015-03-01 01:35:27.000000', 'temperatura', 847.0000, 'ºC'),
	(81120, 109, '2015-03-01 01:35:28.000000', 'temperatura', 215.0000, 'ºC'),
	(81121, 109, '2015-03-01 01:35:29.000000', 'temperatura', 932.0000, 'ºC'),
	(81122, 109, '2015-03-01 01:35:30.000000', 'temperatura', 415.0000, 'ºC'),
	(81123, 109, '2015-03-01 01:35:31.000000', 'temperatura', 479.0000, 'ºC'),
	(81124, 109, '2015-03-01 01:35:32.000000', 'temperatura', 1151.0000, 'ºC'),
	(81125, 109, '2015-03-01 01:35:33.000000', 'temperatura', 718.0000, 'ºC'),
	(81126, 109, '2015-03-01 01:35:34.000000', 'temperatura', 137.0000, 'ºC'),
	(81127, 109, '2015-03-01 01:35:35.000000', 'temperatura', 933.0000, 'ºC'),
	(81128, 109, '2015-03-01 01:35:36.000000', 'temperatura', 655.0000, 'ºC'),
	(81129, 109, '2015-03-01 01:35:37.000000', 'temperatura', 475.0000, 'ºC'),
	(81130, 109, '2015-03-01 01:35:38.000000', 'temperatura', 413.0000, 'ºC'),
	(81131, 109, '2015-03-01 01:35:39.000000', 'temperatura', 638.0000, 'ºC'),
	(81132, 109, '2015-03-01 01:35:40.000000', 'temperatura', 754.0000, 'ºC'),
	(81133, 109, '2015-03-01 01:35:41.000000', 'temperatura', 655.0000, 'ºC'),
	(81134, 109, '2015-03-01 01:35:42.000000', 'temperatura', 1016.0000, 'ºC'),
	(81135, 109, '2015-03-01 01:35:43.000000', 'temperatura', 713.0000, 'ºC'),
	(81136, 109, '2015-03-01 01:35:44.000000', 'temperatura', 519.0000, 'ºC'),
	(81137, 109, '2015-03-01 01:35:45.000000', 'temperatura', 455.0000, 'ºC'),
	(81138, 109, '2015-03-01 01:35:46.000000', 'temperatura', 720.0000, 'ºC'),
	(81139, 109, '2015-03-01 01:35:47.000000', 'temperatura', 1034.0000, 'ºC'),
	(81140, 109, '2015-03-01 01:35:48.000000', 'temperatura', 612.0000, 'ºC'),
	(81141, 109, '2015-03-01 01:35:49.000000', 'temperatura', 1156.0000, 'ºC'),
	(81142, 109, '2015-03-01 01:35:50.000000', 'temperatura', 346.0000, 'ºC'),
	(81143, 109, '2015-03-01 01:35:51.000000', 'temperatura', 661.0000, 'ºC'),
	(81144, 109, '2015-03-01 01:35:52.000000', 'temperatura', 1067.0000, 'ºC'),
	(81145, 109, '2015-03-01 01:35:53.000000', 'temperatura', 952.0000, 'ºC'),
	(81146, 109, '2015-03-01 01:35:54.000000', 'temperatura', 360.0000, 'ºC'),
	(81147, 109, '2015-03-01 01:35:55.000000', 'temperatura', 147.0000, 'ºC'),
	(81148, 109, '2015-03-01 01:35:56.000000', 'temperatura', 853.0000, 'ºC'),
	(81149, 109, '2015-03-01 01:35:57.000000', 'temperatura', 226.0000, 'ºC'),
	(81150, 109, '2015-03-01 01:35:58.000000', 'temperatura', 970.0000, 'ºC'),
	(81151, 109, '2015-03-01 01:35:59.000000', 'temperatura', 575.0000, 'ºC'),
	(81152, 109, '2015-03-01 01:36:00.000000', 'temperatura', 1163.0000, 'ºC'),
	(81153, 109, '2015-03-01 01:36:01.000000', 'temperatura', 490.0000, 'ºC'),
	(81154, 109, '2015-03-01 01:36:02.000000', 'temperatura', 162.0000, 'ºC'),
	(81155, 109, '2015-03-01 01:36:03.000000', 'temperatura', 541.0000, 'ºC'),
	(81156, 109, '2015-03-01 01:36:04.000000', 'temperatura', 1021.0000, 'ºC'),
	(81157, 109, '2015-03-01 01:36:05.000000', 'temperatura', 1080.0000, 'ºC'),
	(81158, 109, '2015-03-01 01:36:06.000000', 'temperatura', 1136.0000, 'ºC'),
	(81159, 109, '2015-03-01 01:36:07.000000', 'temperatura', 44.0000, 'ºC'),
	(81160, 109, '2015-03-01 01:36:08.000000', 'temperatura', 411.0000, 'ºC'),
	(81161, 109, '2015-03-01 01:36:09.000000', 'temperatura', 723.0000, 'ºC'),
	(81162, 109, '2015-03-01 01:36:10.000000', 'temperatura', 1183.0000, 'ºC'),
	(81163, 109, '2015-03-01 01:36:11.000000', 'temperatura', 149.0000, 'ºC'),
	(81164, 109, '2015-03-01 01:36:12.000000', 'temperatura', 793.0000, 'ºC'),
	(81165, 109, '2015-03-01 01:36:13.000000', 'temperatura', 1119.0000, 'ºC'),
	(81166, 109, '2015-03-01 01:36:14.000000', 'temperatura', 817.0000, 'ºC'),
	(81167, 109, '2015-03-01 01:36:15.000000', 'temperatura', 729.0000, 'ºC'),
	(81168, 109, '2015-03-01 01:36:16.000000', 'temperatura', 1194.0000, 'ºC'),
	(81169, 109, '2015-03-01 01:36:17.000000', 'temperatura', 182.0000, 'ºC'),
	(81170, 109, '2015-03-01 01:36:18.000000', 'temperatura', 932.0000, 'ºC'),
	(81171, 109, '2015-03-01 01:36:19.000000', 'temperatura', 511.0000, 'ºC'),
	(81172, 109, '2015-03-01 01:36:20.000000', 'temperatura', 961.0000, 'ºC'),
	(81173, 109, '2015-03-01 01:36:21.000000', 'temperatura', 874.0000, 'ºC'),
	(81174, 109, '2015-03-01 01:36:22.000000', 'temperatura', 288.0000, 'ºC'),
	(81175, 109, '2015-03-01 01:36:23.000000', 'temperatura', 19.0000, 'ºC'),
	(81176, 109, '2015-03-01 01:36:24.000000', 'temperatura', 429.0000, 'ºC'),
	(81177, 109, '2015-03-01 01:36:25.000000', 'temperatura', 889.0000, 'ºC'),
	(81178, 109, '2015-03-01 01:36:26.000000', 'temperatura', 760.0000, 'ºC'),
	(81179, 109, '2015-03-01 01:36:27.000000', 'temperatura', 1135.0000, 'ºC'),
	(81180, 109, '2015-03-01 01:36:28.000000', 'temperatura', 992.0000, 'ºC'),
	(81181, 109, '2015-03-01 01:36:29.000000', 'temperatura', 357.0000, 'ºC'),
	(81182, 109, '2015-03-01 01:36:30.000000', 'temperatura', 9.0000, 'ºC'),
	(81183, 109, '2015-03-01 01:36:31.000000', 'temperatura', 176.0000, 'ºC'),
	(81184, 109, '2015-03-01 01:36:32.000000', 'temperatura', 851.0000, 'ºC'),
	(81185, 109, '2015-03-01 01:36:33.000000', 'temperatura', 127.0000, 'ºC'),
	(81186, 109, '2015-03-01 01:36:34.000000', 'temperatura', 484.0000, 'ºC'),
	(81187, 109, '2015-03-01 01:36:35.000000', 'temperatura', 840.0000, 'ºC'),
	(81188, 109, '2015-03-01 01:36:36.000000', 'temperatura', 350.0000, 'ºC'),
	(81189, 109, '2015-03-01 01:36:37.000000', 'temperatura', 429.0000, 'ºC'),
	(81190, 109, '2015-03-01 01:36:38.000000', 'temperatura', 1096.0000, 'ºC'),
	(81191, 109, '2015-03-01 01:36:39.000000', 'temperatura', 592.0000, 'ºC'),
	(81192, 109, '2015-03-01 01:36:40.000000', 'temperatura', 875.0000, 'ºC'),
	(81193, 109, '2015-03-01 01:36:41.000000', 'temperatura', 200.0000, 'ºC'),
	(81194, 109, '2015-03-01 01:36:42.000000', 'temperatura', 774.0000, 'ºC'),
	(81195, 109, '2015-03-01 01:36:43.000000', 'temperatura', 870.0000, 'ºC'),
	(81196, 109, '2015-03-01 01:36:44.000000', 'temperatura', 827.0000, 'ºC'),
	(81197, 109, '2015-03-01 01:36:45.000000', 'temperatura', 326.0000, 'ºC'),
	(81198, 109, '2015-03-01 01:36:46.000000', 'temperatura', 352.0000, 'ºC'),
	(81199, 109, '2015-03-01 01:36:47.000000', 'temperatura', 780.0000, 'ºC'),
	(81200, 109, '2015-03-01 01:36:48.000000', 'temperatura', 446.0000, 'ºC'),
	(81201, 109, '2015-03-01 01:36:49.000000', 'temperatura', 1091.0000, 'ºC'),
	(81202, 109, '2015-03-01 01:36:50.000000', 'temperatura', 517.0000, 'ºC'),
	(81203, 109, '2015-03-01 01:36:51.000000', 'temperatura', 514.0000, 'ºC'),
	(81204, 109, '2015-03-01 01:36:52.000000', 'temperatura', 1019.0000, 'ºC'),
	(81205, 109, '2015-03-01 01:36:53.000000', 'temperatura', 1153.0000, 'ºC'),
	(81206, 109, '2015-03-01 01:36:54.000000', 'temperatura', 309.0000, 'ºC'),
	(81207, 109, '2015-03-01 01:36:55.000000', 'temperatura', 487.0000, 'ºC'),
	(81208, 109, '2015-03-01 01:36:56.000000', 'temperatura', 310.0000, 'ºC'),
	(81209, 109, '2015-03-01 01:36:57.000000', 'temperatura', 86.0000, 'ºC'),
	(81210, 109, '2015-03-01 01:36:58.000000', 'temperatura', 704.0000, 'ºC'),
	(81211, 109, '2015-03-01 01:36:59.000000', 'temperatura', 861.0000, 'ºC'),
	(81212, 109, '2015-03-01 01:37:00.000000', 'temperatura', 994.0000, 'ºC'),
	(81213, 109, '2015-03-01 01:37:01.000000', 'temperatura', 1186.0000, 'ºC'),
	(81214, 109, '2015-03-01 01:37:02.000000', 'temperatura', 549.0000, 'ºC'),
	(81215, 109, '2015-03-01 01:37:03.000000', 'temperatura', 389.0000, 'ºC'),
	(81216, 109, '2015-03-01 01:37:04.000000', 'temperatura', 299.0000, 'ºC'),
	(81217, 109, '2015-03-01 01:37:05.000000', 'temperatura', 325.0000, 'ºC'),
	(81218, 109, '2015-03-01 01:37:06.000000', 'temperatura', 732.0000, 'ºC'),
	(81219, 109, '2015-03-01 01:37:07.000000', 'temperatura', 286.0000, 'ºC'),
	(81220, 109, '2015-03-01 01:37:08.000000', 'temperatura', 432.0000, 'ºC'),
	(81221, 109, '2015-03-01 01:37:09.000000', 'temperatura', 102.0000, 'ºC'),
	(81222, 109, '2015-03-01 01:37:10.000000', 'temperatura', 416.0000, 'ºC'),
	(81223, 109, '2015-03-01 01:37:11.000000', 'temperatura', 575.0000, 'ºC'),
	(81224, 109, '2015-03-01 01:37:12.000000', 'temperatura', 426.0000, 'ºC'),
	(81225, 109, '2015-03-01 01:37:13.000000', 'temperatura', 408.0000, 'ºC'),
	(81226, 109, '2015-03-01 01:37:14.000000', 'temperatura', 762.0000, 'ºC'),
	(81227, 109, '2015-03-01 01:37:15.000000', 'temperatura', 185.0000, 'ºC'),
	(81228, 109, '2015-03-01 01:37:16.000000', 'temperatura', 1041.0000, 'ºC'),
	(81229, 109, '2015-03-01 01:37:17.000000', 'temperatura', 1051.0000, 'ºC'),
	(81230, 109, '2015-03-01 01:37:18.000000', 'temperatura', 930.0000, 'ºC'),
	(81231, 109, '2015-03-01 01:37:19.000000', 'temperatura', 297.0000, 'ºC'),
	(81232, 109, '2015-03-01 01:37:20.000000', 'temperatura', 1097.0000, 'ºC'),
	(81233, 109, '2015-03-01 01:37:21.000000', 'temperatura', 995.0000, 'ºC'),
	(81234, 109, '2015-03-01 01:37:22.000000', 'temperatura', 485.0000, 'ºC'),
	(81235, 109, '2015-03-01 01:37:23.000000', 'temperatura', 639.0000, 'ºC'),
	(81236, 109, '2015-03-01 01:37:24.000000', 'temperatura', 539.0000, 'ºC'),
	(81237, 109, '2015-03-01 01:37:25.000000', 'temperatura', 781.0000, 'ºC'),
	(81238, 109, '2015-03-01 01:37:26.000000', 'temperatura', 1088.0000, 'ºC'),
	(81239, 109, '2015-03-01 01:37:27.000000', 'temperatura', 696.0000, 'ºC'),
	(81240, 109, '2015-03-01 01:37:28.000000', 'temperatura', 218.0000, 'ºC'),
	(81241, 109, '2015-03-01 01:37:29.000000', 'temperatura', 203.0000, 'ºC'),
	(81242, 109, '2015-03-01 01:37:30.000000', 'temperatura', 362.0000, 'ºC'),
	(81243, 109, '2015-03-01 01:37:31.000000', 'temperatura', 0.0000, 'ºC'),
	(81244, 109, '2015-03-01 01:37:32.000000', 'temperatura', 115.0000, 'ºC'),
	(81245, 109, '2015-03-01 01:37:33.000000', 'temperatura', 576.0000, 'ºC'),
	(81246, 109, '2015-03-01 01:37:34.000000', 'temperatura', 134.0000, 'ºC'),
	(81247, 109, '2015-03-01 01:37:35.000000', 'temperatura', 144.0000, 'ºC'),
	(81248, 109, '2015-03-01 01:37:36.000000', 'temperatura', 316.0000, 'ºC'),
	(81249, 109, '2015-03-01 01:37:37.000000', 'temperatura', 1151.0000, 'ºC'),
	(81250, 109, '2015-03-01 01:37:38.000000', 'temperatura', 7.0000, 'ºC'),
	(81251, 109, '2015-03-01 01:37:39.000000', 'temperatura', 181.0000, 'ºC'),
	(81252, 109, '2015-03-01 01:37:40.000000', 'temperatura', 887.0000, 'ºC'),
	(81253, 109, '2015-03-01 01:37:41.000000', 'temperatura', 290.0000, 'ºC'),
	(81254, 109, '2015-03-01 01:37:42.000000', 'temperatura', 1192.0000, 'ºC'),
	(81255, 109, '2015-03-01 01:37:43.000000', 'temperatura', 289.0000, 'ºC'),
	(81256, 109, '2015-03-01 01:37:44.000000', 'temperatura', 272.0000, 'ºC'),
	(81257, 109, '2015-03-01 01:37:45.000000', 'temperatura', 492.0000, 'ºC'),
	(81258, 109, '2015-03-01 01:37:46.000000', 'temperatura', 443.0000, 'ºC'),
	(81259, 109, '2015-03-01 01:37:47.000000', 'temperatura', 740.0000, 'ºC'),
	(81260, 109, '2015-03-01 01:37:48.000000', 'temperatura', 1174.0000, 'ºC'),
	(81261, 109, '2015-03-01 01:37:49.000000', 'temperatura', 49.0000, 'ºC'),
	(81262, 109, '2015-03-01 01:37:50.000000', 'temperatura', 322.0000, 'ºC'),
	(81263, 109, '2015-03-01 01:37:51.000000', 'temperatura', 267.0000, 'ºC'),
	(81264, 109, '2015-03-01 01:37:52.000000', 'temperatura', 366.0000, 'ºC'),
	(81265, 109, '2015-03-01 01:37:53.000000', 'temperatura', 1031.0000, 'ºC'),
	(81266, 109, '2015-03-01 01:37:54.000000', 'temperatura', 457.0000, 'ºC'),
	(81267, 109, '2015-03-01 01:37:55.000000', 'temperatura', 395.0000, 'ºC'),
	(81268, 109, '2015-03-01 01:37:56.000000', 'temperatura', 601.0000, 'ºC'),
	(81269, 109, '2015-03-01 01:37:57.000000', 'temperatura', 622.0000, 'ºC'),
	(81270, 109, '2015-03-01 01:37:58.000000', 'temperatura', 107.0000, 'ºC'),
	(81271, 109, '2015-03-01 01:37:59.000000', 'temperatura', 1069.0000, 'ºC'),
	(81272, 109, '2015-03-01 01:38:00.000000', 'temperatura', 224.0000, 'ºC'),
	(81273, 109, '2015-03-01 01:38:01.000000', 'temperatura', 312.0000, 'ºC'),
	(81274, 109, '2015-03-01 01:38:02.000000', 'temperatura', 892.0000, 'ºC'),
	(81275, 109, '2015-03-01 01:38:03.000000', 'temperatura', 1123.0000, 'ºC'),
	(81276, 109, '2015-03-01 01:38:04.000000', 'temperatura', 540.0000, 'ºC'),
	(81277, 109, '2015-03-01 01:38:05.000000', 'temperatura', 532.0000, 'ºC'),
	(81278, 109, '2015-03-01 01:38:06.000000', 'temperatura', 1042.0000, 'ºC'),
	(81279, 109, '2015-03-01 01:38:07.000000', 'temperatura', 14.0000, 'ºC'),
	(81280, 109, '2015-03-01 01:38:08.000000', 'temperatura', 542.0000, 'ºC'),
	(81281, 109, '2015-03-01 01:38:09.000000', 'temperatura', 269.0000, 'ºC'),
	(81282, 109, '2015-03-01 01:38:10.000000', 'temperatura', 920.0000, 'ºC'),
	(81283, 109, '2015-03-01 01:38:11.000000', 'temperatura', 195.0000, 'ºC'),
	(81284, 109, '2015-03-01 01:38:12.000000', 'temperatura', 616.0000, 'ºC'),
	(81285, 109, '2015-03-01 01:38:13.000000', 'temperatura', 95.0000, 'ºC'),
	(81286, 109, '2015-03-01 01:38:14.000000', 'temperatura', 1028.0000, 'ºC'),
	(81287, 109, '2015-03-01 01:38:15.000000', 'temperatura', 55.0000, 'ºC'),
	(81288, 109, '2015-03-01 01:38:16.000000', 'temperatura', 790.0000, 'ºC'),
	(81289, 109, '2015-03-01 01:38:17.000000', 'temperatura', 185.0000, 'ºC'),
	(81290, 109, '2015-03-01 01:38:18.000000', 'temperatura', 958.0000, 'ºC'),
	(81291, 109, '2015-03-01 01:38:19.000000', 'temperatura', 634.0000, 'ºC'),
	(81292, 109, '2015-03-01 01:38:20.000000', 'temperatura', 299.0000, 'ºC'),
	(81293, 109, '2015-03-01 01:38:21.000000', 'temperatura', 790.0000, 'ºC'),
	(81294, 109, '2015-03-01 01:38:22.000000', 'temperatura', 654.0000, 'ºC'),
	(81295, 109, '2015-03-01 01:38:23.000000', 'temperatura', 902.0000, 'ºC'),
	(81296, 109, '2015-03-01 01:38:24.000000', 'temperatura', 149.0000, 'ºC'),
	(81297, 110, '2015-03-01 00:00:00.000000', 'temperatura', 551.0000, 'ºC'),
	(81298, 110, '2015-03-01 00:00:01.000000', 'temperatura', 234.0000, 'ºC'),
	(81299, 110, '2015-03-01 00:00:02.000000', 'temperatura', 721.0000, 'ºC'),
	(81300, 110, '2015-03-01 00:00:03.000000', 'temperatura', 504.0000, 'ºC'),
	(81301, 110, '2015-03-01 00:00:04.000000', 'temperatura', 356.0000, 'ºC'),
	(81302, 110, '2015-03-01 00:00:05.000000', 'temperatura', 270.0000, 'ºC'),
	(81303, 110, '2015-03-01 00:00:06.000000', 'temperatura', 283.0000, 'ºC'),
	(81304, 110, '2015-03-01 00:00:07.000000', 'temperatura', 604.0000, 'ºC'),
	(81305, 110, '2015-03-01 00:00:08.000000', 'temperatura', 974.0000, 'ºC'),
	(81306, 110, '2015-03-01 00:00:09.000000', 'temperatura', 656.0000, 'ºC'),
	(81307, 110, '2015-03-01 00:00:10.000000', 'temperatura', 359.0000, 'ºC'),
	(81308, 110, '2015-03-01 00:00:11.000000', 'temperatura', 1027.0000, 'ºC'),
	(81309, 110, '2015-03-01 00:00:12.000000', 'temperatura', 459.0000, 'ºC'),
	(81310, 110, '2015-03-01 00:00:13.000000', 'temperatura', 413.0000, 'ºC'),
	(81311, 110, '2015-03-01 00:00:14.000000', 'temperatura', 689.0000, 'ºC'),
	(81312, 110, '2015-03-01 00:00:15.000000', 'temperatura', 1006.0000, 'ºC'),
	(81313, 110, '2015-03-01 00:00:16.000000', 'temperatura', 563.0000, 'ºC'),
	(81314, 110, '2015-03-01 00:00:17.000000', 'temperatura', 998.0000, 'ºC'),
	(81315, 110, '2015-03-01 00:00:18.000000', 'temperatura', 903.0000, 'ºC'),
	(81316, 110, '2015-03-01 00:00:19.000000', 'temperatura', 320.0000, 'ºC'),
	(81317, 110, '2015-03-01 00:00:20.000000', 'temperatura', 90.0000, 'ºC'),
	(81318, 110, '2015-03-01 00:00:21.000000', 'temperatura', 694.0000, 'ºC'),
	(81319, 110, '2015-03-01 00:00:22.000000', 'temperatura', 797.0000, 'ºC'),
	(81320, 110, '2015-03-01 00:00:23.000000', 'temperatura', 706.0000, 'ºC'),
	(81321, 110, '2015-03-01 00:00:24.000000', 'temperatura', 1140.0000, 'ºC'),
	(81322, 110, '2015-03-01 00:00:25.000000', 'temperatura', 1181.0000, 'ºC'),
	(81323, 110, '2015-03-01 00:00:26.000000', 'temperatura', 84.0000, 'ºC'),
	(81324, 110, '2015-03-01 00:00:27.000000', 'temperatura', 479.0000, 'ºC'),
	(81325, 110, '2015-03-01 00:00:28.000000', 'temperatura', 942.0000, 'ºC'),
	(81326, 110, '2015-03-01 00:00:29.000000', 'temperatura', 876.0000, 'ºC'),
	(81327, 110, '2015-03-01 00:00:30.000000', 'temperatura', 355.0000, 'ºC'),
	(81328, 110, '2015-03-01 00:00:31.000000', 'temperatura', 345.0000, 'ºC'),
	(81329, 110, '2015-03-01 00:00:32.000000', 'temperatura', 661.0000, 'ºC'),
	(81330, 110, '2015-03-01 00:00:33.000000', 'temperatura', 1071.0000, 'ºC'),
	(81331, 110, '2015-03-01 00:00:34.000000', 'temperatura', 972.0000, 'ºC'),
	(81332, 110, '2015-03-01 00:00:35.000000', 'temperatura', 448.0000, 'ºC'),
	(81333, 110, '2015-03-01 00:00:36.000000', 'temperatura', 526.0000, 'ºC'),
	(81334, 110, '2015-03-01 00:00:37.000000', 'temperatura', 86.0000, 'ºC'),
	(81335, 110, '2015-03-01 00:00:38.000000', 'temperatura', 52.0000, 'ºC'),
	(81336, 110, '2015-03-01 00:00:39.000000', 'temperatura', 1.0000, 'ºC'),
	(81337, 110, '2015-03-01 00:00:40.000000', 'temperatura', 1052.0000, 'ºC'),
	(81338, 110, '2015-03-01 00:00:41.000000', 'temperatura', 456.0000, 'ºC'),
	(81339, 110, '2015-03-01 00:00:42.000000', 'temperatura', 324.0000, 'ºC'),
	(81340, 110, '2015-03-01 00:00:43.000000', 'temperatura', 254.0000, 'ºC'),
	(81341, 110, '2015-03-01 00:00:44.000000', 'temperatura', 296.0000, 'ºC'),
	(81342, 110, '2015-03-01 00:00:45.000000', 'temperatura', 719.0000, 'ºC'),
	(81343, 110, '2015-03-01 00:00:46.000000', 'temperatura', 310.0000, 'ºC'),
	(81344, 110, '2015-03-01 00:00:47.000000', 'temperatura', 591.0000, 'ºC'),
	(81345, 110, '2015-03-01 00:00:48.000000', 'temperatura', 827.0000, 'ºC'),
	(81346, 110, '2015-03-01 00:00:49.000000', 'temperatura', 1162.0000, 'ºC'),
	(81347, 110, '2015-03-01 00:00:50.000000', 'temperatura', 928.0000, 'ºC'),
	(81348, 110, '2015-03-01 00:00:51.000000', 'temperatura', 1157.0000, 'ºC'),
	(81349, 110, '2015-03-01 00:00:52.000000', 'temperatura', 598.0000, 'ºC'),
	(81350, 110, '2015-03-01 00:00:53.000000', 'temperatura', 723.0000, 'ºC'),
	(81351, 110, '2015-03-01 00:00:54.000000', 'temperatura', 621.0000, 'ºC'),
	(81352, 110, '2015-03-01 00:00:55.000000', 'temperatura', 936.0000, 'ºC'),
	(81353, 110, '2015-03-01 00:00:56.000000', 'temperatura', 418.0000, 'ºC'),
	(81354, 110, '2015-03-01 00:00:57.000000', 'temperatura', 482.0000, 'ºC'),
	(81355, 110, '2015-03-01 00:00:58.000000', 'temperatura', 1155.0000, 'ºC'),
	(81356, 110, '2015-03-01 00:00:59.000000', 'temperatura', 733.0000, 'ºC'),
	(81357, 110, '2015-03-01 00:01:00.000000', 'temperatura', 197.0000, 'ºC'),
	(81358, 110, '2015-03-01 00:01:01.000000', 'temperatura', 1188.0000, 'ºC'),
	(81359, 110, '2015-03-01 00:01:02.000000', 'temperatura', 551.0000, 'ºC'),
	(81360, 110, '2015-03-01 00:01:03.000000', 'temperatura', 392.0000, 'ºC'),
	(81361, 110, '2015-03-01 00:01:04.000000', 'temperatura', 305.0000, 'ºC'),
	(81362, 110, '2015-03-01 00:01:05.000000', 'temperatura', 348.0000, 'ºC'),
	(81363, 110, '2015-03-01 00:01:06.000000', 'temperatura', 829.0000, 'ºC'),
	(81364, 110, '2015-03-01 00:01:07.000000', 'temperatura', 698.0000, 'ºC'),
	(81365, 110, '2015-03-01 00:01:08.000000', 'temperatura', 1007.0000, 'ºC'),
	(81366, 110, '2015-03-01 00:01:09.000000', 'temperatura', 539.0000, 'ºC'),
	(81367, 110, '2015-03-01 00:01:10.000000', 'temperatura', 874.0000, 'ºC'),
	(81368, 110, '2015-03-01 00:01:11.000000', 'temperatura', 355.0000, 'ºC'),
	(81369, 110, '2015-03-01 00:01:12.000000', 'temperatura', 354.0000, 'ºC'),
	(81370, 110, '2015-03-01 00:01:13.000000', 'temperatura', 704.0000, 'ºC'),
	(81371, 110, '2015-03-01 00:01:14.000000', 'temperatura', 58.0000, 'ºC'),
	(81372, 110, '2015-03-01 00:01:15.000000', 'temperatura', 579.0000, 'ºC'),
	(81373, 110, '2015-03-01 00:01:16.000000', 'temperatura', 323.0000, 'ºC'),
	(81374, 110, '2015-03-01 00:01:17.000000', 'temperatura', 1076.0000, 'ºC'),
	(81375, 110, '2015-03-01 00:01:18.000000', 'temperatura', 813.0000, 'ºC'),
	(81376, 110, '2015-03-01 00:01:19.000000', 'temperatura', 835.0000, 'ºC'),
	(81377, 110, '2015-03-01 00:01:20.000000', 'temperatura', 540.0000, 'ºC'),
	(81378, 110, '2015-03-01 00:01:21.000000', 'temperatura', 194.0000, 'ºC'),
	(81379, 110, '2015-03-01 00:01:22.000000', 'temperatura', 549.0000, 'ºC'),
	(81380, 110, '2015-03-01 00:01:23.000000', 'temperatura', 966.0000, 'ºC'),
	(81381, 110, '2015-03-01 00:01:24.000000', 'temperatura', 783.0000, 'ºC'),
	(81382, 110, '2015-03-01 00:01:25.000000', 'temperatura', 1016.0000, 'ºC'),
	(81383, 110, '2015-03-01 00:01:26.000000', 'temperatura', 332.0000, 'ºC'),
	(81384, 110, '2015-03-01 00:01:27.000000', 'temperatura', 1015.0000, 'ºC'),
	(81385, 110, '2015-03-01 00:01:28.000000', 'temperatura', 476.0000, 'ºC'),
	(81386, 110, '2015-03-01 00:01:29.000000', 'temperatura', 537.0000, 'ºC'),
	(81387, 110, '2015-03-01 00:01:30.000000', 'temperatura', 58.0000, 'ºC'),
	(81388, 110, '2015-03-01 00:01:31.000000', 'temperatura', 1079.0000, 'ºC'),
	(81389, 110, '2015-03-01 00:01:32.000000', 'temperatura', 420.0000, 'ºC'),
	(81390, 110, '2015-03-01 00:01:33.000000', 'temperatura', 63.0000, 'ºC'),
	(81391, 110, '2015-03-01 00:01:34.000000', 'temperatura', 259.0000, 'ºC'),
	(81392, 110, '2015-03-01 00:01:35.000000', 'temperatura', 1104.0000, 'ºC'),
	(81393, 110, '2015-03-01 00:01:36.000000', 'temperatura', 1143.0000, 'ºC'),
	(81394, 110, '2015-03-01 00:01:37.000000', 'temperatura', 4.0000, 'ºC'),
	(81395, 110, '2015-03-01 00:01:38.000000', 'temperatura', 190.0000, 'ºC'),
	(81396, 110, '2015-03-01 00:01:39.000000', 'temperatura', 940.0000, 'ºC'),
	(81397, 110, '2015-03-01 00:01:40.000000', 'temperatura', 530.0000, 'ºC'),
	(81398, 110, '2015-03-01 00:01:41.000000', 'temperatura', 1032.0000, 'ºC'),
	(81399, 110, '2015-03-01 00:01:42.000000', 'temperatura', 1169.0000, 'ºC'),
	(81400, 110, '2015-03-01 00:01:43.000000', 'temperatura', 349.0000, 'ºC'),
	(81401, 110, '2015-03-01 00:01:44.000000', 'temperatura', 641.0000, 'ºC'),
	(81402, 110, '2015-03-01 00:01:45.000000', 'temperatura', 957.0000, 'ºC'),
	(81403, 110, '2015-03-01 00:01:46.000000', 'temperatura', 461.0000, 'ºC'),
	(81404, 110, '2015-03-01 00:01:47.000000', 'temperatura', 636.0000, 'ºC'),
	(81405, 110, '2015-03-01 00:01:48.000000', 'temperatura', 599.0000, 'ºC'),
	(81406, 110, '2015-03-01 00:01:49.000000', 'temperatura', 1085.0000, 'ºC'),
	(81407, 110, '2015-03-01 00:01:50.000000', 'temperatura', 31.0000, 'ºC'),
	(81408, 110, '2015-03-01 00:01:51.000000', 'temperatura', 501.0000, 'ºC'),
	(81409, 110, '2015-03-01 00:01:52.000000', 'temperatura', 13.0000, 'ºC'),
	(81410, 110, '2015-03-01 00:01:53.000000', 'temperatura', 963.0000, 'ºC'),
	(81411, 110, '2015-03-01 00:01:54.000000', 'temperatura', 1175.0000, 'ºC'),
	(81412, 110, '2015-03-01 00:01:55.000000', 'temperatura', 586.0000, 'ºC'),
	(81413, 110, '2015-03-01 00:01:56.000000', 'temperatura', 607.0000, 'ºC'),
	(81414, 110, '2015-03-01 00:01:57.000000', 'temperatura', 77.0000, 'ºC'),
	(81415, 110, '2015-03-01 00:01:58.000000', 'temperatura', 965.0000, 'ºC'),
	(81416, 110, '2015-03-01 00:01:59.000000', 'temperatura', 992.0000, 'ºC'),
	(81417, 110, '2015-03-01 00:02:00.000000', 'temperatura', 868.0000, 'ºC'),
	(81418, 110, '2015-03-01 00:02:01.000000', 'temperatura', 165.0000, 'ºC'),
	(81419, 110, '2015-03-01 00:02:02.000000', 'temperatura', 620.0000, 'ºC'),
	(81420, 110, '2015-03-01 00:02:03.000000', 'temperatura', 204.0000, 'ºC'),
	(81421, 110, '2015-03-01 00:02:04.000000', 'temperatura', 361.0000, 'ºC'),
	(81422, 110, '2015-03-01 00:02:05.000000', 'temperatura', 1195.0000, 'ºC'),
	(81423, 110, '2015-03-01 00:02:06.000000', 'temperatura', 90.0000, 'ºC'),
	(81424, 110, '2015-03-01 00:02:07.000000', 'temperatura', 466.0000, 'ºC'),
	(81425, 110, '2015-03-01 00:02:08.000000', 'temperatura', 863.0000, 'ºC'),
	(81426, 110, '2015-03-01 00:02:09.000000', 'temperatura', 517.0000, 'ºC'),
	(81427, 110, '2015-03-01 00:02:10.000000', 'temperatura', 1196.0000, 'ºC'),
	(81428, 110, '2015-03-01 00:02:11.000000', 'temperatura', 828.0000, 'ºC'),
	(81429, 110, '2015-03-01 00:02:12.000000', 'temperatura', 554.0000, 'ºC'),
	(81430, 110, '2015-03-01 00:02:13.000000', 'temperatura', 285.0000, 'ºC'),
	(81431, 110, '2015-03-01 00:02:14.000000', 'temperatura', 964.0000, 'ºC'),
	(81432, 110, '2015-03-01 00:02:15.000000', 'temperatura', 366.0000, 'ºC'),
	(81433, 110, '2015-03-01 00:02:16.000000', 'temperatura', 139.0000, 'ºC'),
	(81434, 110, '2015-03-01 00:02:17.000000', 'temperatura', 797.0000, 'ºC'),
	(81435, 110, '2015-03-01 00:02:18.000000', 'temperatura', 1168.0000, 'ºC'),
	(81436, 110, '2015-03-01 00:02:19.000000', 'temperatura', 1048.0000, 'ºC'),
	(81437, 110, '2015-03-01 00:02:20.000000', 'temperatura', 540.0000, 'ºC'),
	(81438, 110, '2015-03-01 00:02:21.000000', 'temperatura', 755.0000, 'ºC'),
	(81439, 110, '2015-03-01 00:02:22.000000', 'temperatura', 954.0000, 'ºC'),
	(81440, 110, '2015-03-01 00:02:23.000000', 'temperatura', 106.0000, 'ºC'),
	(81441, 110, '2015-03-01 00:02:24.000000', 'temperatura', 68.0000, 'ºC'),
	(81442, 110, '2015-03-01 00:02:25.000000', 'temperatura', 23.0000, 'ºC'),
	(81443, 110, '2015-03-01 00:02:26.000000', 'temperatura', 1112.0000, 'ºC'),
	(81444, 110, '2015-03-01 00:02:27.000000', 'temperatura', 689.0000, 'ºC'),
	(81445, 110, '2015-03-01 00:02:28.000000', 'temperatura', 113.0000, 'ºC'),
	(81446, 110, '2015-03-01 00:02:29.000000', 'temperatura', 896.0000, 'ºC'),
	(81447, 110, '2015-03-01 00:02:30.000000', 'temperatura', 541.0000, 'ºC'),
	(81448, 110, '2015-03-01 00:02:31.000000', 'temperatura', 18.0000, 'ºC'),
	(81449, 110, '2015-03-01 00:02:32.000000', 'temperatura', 869.0000, 'ºC'),
	(81450, 110, '2015-03-01 00:02:33.000000', 'temperatura', 692.0000, 'ºC'),
	(81451, 110, '2015-03-01 00:02:34.000000', 'temperatura', 851.0000, 'ºC'),
	(81452, 110, '2015-03-01 00:02:35.000000', 'temperatura', 982.0000, 'ºC'),
	(81453, 110, '2015-03-01 00:02:36.000000', 'temperatura', 1157.0000, 'ºC'),
	(81454, 110, '2015-03-01 00:02:37.000000', 'temperatura', 441.0000, 'ºC'),
	(81455, 110, '2015-03-01 00:02:38.000000', 'temperatura', 1131.0000, 'ºC'),
	(81456, 110, '2015-03-01 00:02:39.000000', 'temperatura', 735.0000, 'ºC'),
	(81457, 110, '2015-03-01 00:02:40.000000', 'temperatura', 282.0000, 'ºC'),
	(81458, 110, '2015-03-01 00:02:41.000000', 'temperatura', 404.0000, 'ºC'),
	(81459, 110, '2015-03-01 00:02:42.000000', 'temperatura', 1176.0000, 'ºC'),
	(81460, 110, '2015-03-01 00:02:43.000000', 'temperatura', 1070.0000, 'ºC'),
	(81461, 110, '2015-03-01 00:02:44.000000', 'temperatura', 620.0000, 'ºC'),
	(81462, 110, '2015-03-01 00:02:45.000000', 'temperatura', 1093.0000, 'ºC'),
	(81463, 110, '2015-03-01 00:02:46.000000', 'temperatura', 3.0000, 'ºC'),
	(81464, 110, '2015-03-01 00:02:47.000000', 'temperatura', 336.0000, 'ºC'),
	(81465, 110, '2015-03-01 00:02:48.000000', 'temperatura', 474.0000, 'ºC'),
	(81466, 110, '2015-03-01 00:02:49.000000', 'temperatura', 163.0000, 'ºC'),
	(81467, 110, '2015-03-01 00:02:50.000000', 'temperatura', 593.0000, 'ºC'),
	(81468, 110, '2015-03-01 00:02:51.000000', 'temperatura', 77.0000, 'ºC'),
	(81469, 110, '2015-03-01 00:02:52.000000', 'temperatura', 1005.0000, 'ºC'),
	(81470, 110, '2015-03-01 00:02:53.000000', 'temperatura', 1197.0000, 'ºC'),
	(81471, 110, '2015-03-01 00:02:54.000000', 'temperatura', 570.0000, 'ºC'),
	(81472, 110, '2015-03-01 00:02:55.000000', 'temperatura', 459.0000, 'ºC'),
	(81473, 110, '2015-03-01 00:02:56.000000', 'temperatura', 587.0000, 'ºC'),
	(81474, 110, '2015-03-01 00:02:57.000000', 'temperatura', 357.0000, 'ºC'),
	(81475, 110, '2015-03-01 00:02:58.000000', 'temperatura', 26.0000, 'ºC'),
	(81476, 110, '2015-03-01 00:02:59.000000', 'temperatura', 259.0000, 'ºC'),
	(81477, 110, '2015-03-01 00:03:00.000000', 'temperatura', 15.0000, 'ºC'),
	(81478, 110, '2015-03-01 00:03:01.000000', 'temperatura', 501.0000, 'ºC'),
	(81479, 110, '2015-03-01 00:03:02.000000', 'temperatura', 58.0000, 'ºC'),
	(81480, 110, '2015-03-01 00:03:03.000000', 'temperatura', 1191.0000, 'ºC'),
	(81481, 110, '2015-03-01 00:03:04.000000', 'temperatura', 979.0000, 'ºC'),
	(81482, 110, '2015-03-01 00:03:05.000000', 'temperatura', 121.0000, 'ºC'),
	(81483, 110, '2015-03-01 00:03:06.000000', 'temperatura', 71.0000, 'ºC'),
	(81484, 110, '2015-03-01 00:03:07.000000', 'temperatura', 1192.0000, 'ºC'),
	(81485, 110, '2015-03-01 00:03:08.000000', 'temperatura', 949.0000, 'ºC'),
	(81486, 110, '2015-03-01 00:03:09.000000', 'temperatura', 1170.0000, 'ºC'),
	(81487, 110, '2015-03-01 00:03:10.000000', 'temperatura', 603.0000, 'ºC'),
	(81488, 110, '2015-03-01 00:03:11.000000', 'temperatura', 707.0000, 'ºC'),
	(81489, 110, '2015-03-01 00:03:12.000000', 'temperatura', 524.0000, 'ºC'),
	(81490, 110, '2015-03-01 00:03:13.000000', 'temperatura', 502.0000, 'ºC'),
	(81491, 110, '2015-03-01 00:03:14.000000', 'temperatura', 936.0000, 'ºC'),
	(81492, 110, '2015-03-01 00:03:15.000000', 'temperatura', 777.0000, 'ºC'),
	(81493, 110, '2015-03-01 00:03:16.000000', 'temperatura', 1076.0000, 'ºC'),
	(81494, 110, '2015-03-01 00:03:17.000000', 'temperatura', 650.0000, 'ºC'),
	(81495, 110, '2015-03-01 00:03:18.000000', 'temperatura', 21.0000, 'ºC'),
	(81496, 110, '2015-03-01 00:03:19.000000', 'temperatura', 556.0000, 'ºC'),
	(81497, 110, '2015-03-01 00:03:20.000000', 'temperatura', 320.0000, 'ºC'),
	(81498, 110, '2015-03-01 00:03:21.000000', 'temperatura', 1130.0000, 'ºC'),
	(81499, 110, '2015-03-01 00:03:22.000000', 'temperatura', 1089.0000, 'ºC'),
	(81500, 110, '2015-03-01 00:03:23.000000', 'temperatura', 857.0000, 'ºC'),
	(81501, 110, '2015-03-01 00:03:24.000000', 'temperatura', 1021.0000, 'ºC'),
	(81502, 110, '2015-03-01 00:03:25.000000', 'temperatura', 131.0000, 'ºC'),
	(81503, 110, '2015-03-01 00:03:26.000000', 'temperatura', 1193.0000, 'ºC'),
	(81504, 110, '2015-03-01 00:03:27.000000', 'temperatura', 772.0000, 'ºC'),
	(81505, 110, '2015-03-01 00:03:28.000000', 'temperatura', 283.0000, 'ºC'),
	(81506, 110, '2015-03-01 00:03:29.000000', 'temperatura', 297.0000, 'ºC'),
	(81507, 110, '2015-03-01 00:03:30.000000', 'temperatura', 640.0000, 'ºC'),
	(81508, 110, '2015-03-01 00:03:31.000000', 'temperatura', 1107.0000, 'ºC'),
	(81509, 110, '2015-03-01 00:03:32.000000', 'temperatura', 16.0000, 'ºC'),
	(81510, 110, '2015-03-01 00:03:33.000000', 'temperatura', 360.0000, 'ºC'),
	(81511, 110, '2015-03-01 00:03:34.000000', 'temperatura', 552.0000, 'ºC'),
	(81512, 110, '2015-03-01 00:03:35.000000', 'temperatura', 482.0000, 'ºC'),
	(81513, 110, '2015-03-01 00:03:36.000000', 'temperatura', 755.0000, 'ºC'),
	(81514, 110, '2015-03-01 00:03:37.000000', 'temperatura', 1128.0000, 'ºC'),
	(81515, 110, '2015-03-01 00:03:38.000000', 'temperatura', 978.0000, 'ºC'),
	(81516, 110, '2015-03-01 00:03:39.000000', 'temperatura', 303.0000, 'ºC'),
	(81517, 110, '2015-03-01 00:03:40.000000', 'temperatura', 985.0000, 'ºC'),
	(81518, 110, '2015-03-01 00:03:41.000000', 'temperatura', 414.0000, 'ºC'),
	(81519, 110, '2015-03-01 00:03:42.000000', 'temperatura', 314.0000, 'ºC'),
	(81520, 110, '2015-03-01 00:03:43.000000', 'temperatura', 332.0000, 'ºC'),
	(81521, 110, '2015-03-01 00:03:44.000000', 'temperatura', 717.0000, 'ºC'),
	(81522, 110, '2015-03-01 00:03:45.000000', 'temperatura', 190.0000, 'ºC'),
	(81523, 110, '2015-03-01 00:03:46.000000', 'temperatura', 1.0000, 'ºC'),
	(81524, 110, '2015-03-01 00:03:47.000000', 'temperatura', 636.0000, 'ºC'),
	(81525, 110, '2015-03-01 00:03:48.000000', 'temperatura', 775.0000, 'ºC'),
	(81526, 110, '2015-03-01 00:03:49.000000', 'temperatura', 768.0000, 'ºC'),
	(81527, 110, '2015-03-01 00:03:50.000000', 'temperatura', 315.0000, 'ºC'),
	(81528, 110, '2015-03-01 00:03:51.000000', 'temperatura', 470.0000, 'ºC'),
	(81529, 110, '2015-03-01 00:03:52.000000', 'temperatura', 207.0000, 'ºC'),
	(81530, 110, '2015-03-01 00:03:53.000000', 'temperatura', 825.0000, 'ºC'),
	(81531, 110, '2015-03-01 00:03:54.000000', 'temperatura', 1103.0000, 'ºC'),
	(81532, 110, '2015-03-01 00:03:55.000000', 'temperatura', 641.0000, 'ºC'),
	(81533, 110, '2015-03-01 00:03:56.000000', 'temperatura', 1096.0000, 'ºC'),
	(81534, 110, '2015-03-01 00:03:57.000000', 'temperatura', 1157.0000, 'ºC'),
	(81535, 110, '2015-03-01 00:03:58.000000', 'temperatura', 99.0000, 'ºC'),
	(81536, 110, '2015-03-01 00:03:59.000000', 'temperatura', 624.0000, 'ºC'),
	(81537, 110, '2015-03-01 00:04:00.000000', 'temperatura', 423.0000, 'ºC'),
	(81538, 110, '2015-03-01 00:04:01.000000', 'temperatura', 245.0000, 'ºC'),
	(81539, 110, '2015-03-01 00:04:02.000000', 'temperatura', 1154.0000, 'ºC'),
	(81540, 110, '2015-03-01 00:04:03.000000', 'temperatura', 235.0000, 'ºC'),
	(81541, 110, '2015-03-01 00:04:04.000000', 'temperatura', 114.0000, 'ºC'),
	(81542, 110, '2015-03-01 00:04:05.000000', 'temperatura', 1066.0000, 'ºC'),
	(81543, 110, '2015-03-01 00:04:06.000000', 'temperatura', 189.0000, 'ºC'),
	(81544, 110, '2015-03-01 00:04:07.000000', 'temperatura', 147.0000, 'ºC'),
	(81545, 110, '2015-03-01 00:04:08.000000', 'temperatura', 170.0000, 'ºC'),
	(81546, 110, '2015-03-01 00:04:09.000000', 'temperatura', 411.0000, 'ºC'),
	(81547, 110, '2015-03-01 00:04:10.000000', 'temperatura', 342.0000, 'ºC'),
	(81548, 110, '2015-03-01 00:04:11.000000', 'temperatura', 480.0000, 'ºC'),
	(81549, 110, '2015-03-01 00:04:12.000000', 'temperatura', 174.0000, 'ºC'),
	(81550, 110, '2015-03-01 00:04:13.000000', 'temperatura', 630.0000, 'ºC'),
	(81551, 110, '2015-03-01 00:04:14.000000', 'temperatura', 227.0000, 'ºC'),
	(81552, 110, '2015-03-01 00:04:15.000000', 'temperatura', 449.0000, 'ºC'),
	(81553, 110, '2015-03-01 00:04:16.000000', 'temperatura', 362.0000, 'ºC'),
	(81554, 110, '2015-03-01 00:04:17.000000', 'temperatura', 463.0000, 'ºC'),
	(81555, 110, '2015-03-01 00:04:18.000000', 'temperatura', 32.0000, 'ºC'),
	(81556, 110, '2015-03-01 00:04:19.000000', 'temperatura', 1169.0000, 'ºC'),
	(81557, 110, '2015-03-01 00:04:20.000000', 'temperatura', 949.0000, 'ºC'),
	(81558, 110, '2015-03-01 00:04:21.000000', 'temperatura', 39.0000, 'ºC'),
	(81559, 110, '2015-03-01 00:04:22.000000', 'temperatura', 949.0000, 'ºC'),
	(81560, 110, '2015-03-01 00:04:23.000000', 'temperatura', 1027.0000, 'ºC'),
	(81561, 110, '2015-03-01 00:04:24.000000', 'temperatura', 1090.0000, 'ºC'),
	(81562, 110, '2015-03-01 00:04:25.000000', 'temperatura', 1168.0000, 'ºC'),
	(81563, 110, '2015-03-01 00:04:26.000000', 'temperatura', 169.0000, 'ºC'),
	(81564, 110, '2015-03-01 00:04:27.000000', 'temperatura', 945.0000, 'ºC'),
	(81565, 110, '2015-03-01 00:04:28.000000', 'temperatura', 616.0000, 'ºC'),
	(81566, 110, '2015-03-01 00:04:29.000000', 'temperatura', 245.0000, 'ºC'),
	(81567, 110, '2015-03-01 00:04:30.000000', 'temperatura', 577.0000, 'ºC'),
	(81568, 110, '2015-03-01 00:04:31.000000', 'temperatura', 952.0000, 'ºC'),
	(81569, 110, '2015-03-01 00:04:32.000000', 'temperatura', 628.0000, 'ºC'),
	(81570, 110, '2015-03-01 00:04:33.000000', 'temperatura', 283.0000, 'ºC'),
	(81571, 110, '2015-03-01 00:04:34.000000', 'temperatura', 735.0000, 'ºC'),
	(81572, 110, '2015-03-01 00:04:35.000000', 'temperatura', 425.0000, 'ºC'),
	(81573, 110, '2015-03-01 00:04:36.000000', 'temperatura', 1123.0000, 'ºC'),
	(81574, 110, '2015-03-01 00:04:37.000000', 'temperatura', 737.0000, 'ºC'),
	(81575, 110, '2015-03-01 00:04:38.000000', 'temperatura', 319.0000, 'ºC'),
	(81576, 110, '2015-03-01 00:04:39.000000', 'temperatura', 585.0000, 'ºC'),
	(81577, 110, '2015-03-01 00:04:40.000000', 'temperatura', 766.0000, 'ºC'),
	(81578, 110, '2015-03-01 00:04:41.000000', 'temperatura', 877.0000, 'ºC'),
	(81579, 110, '2015-03-01 00:04:42.000000', 'temperatura', 885.0000, 'ºC'),
	(81580, 110, '2015-03-01 00:04:43.000000', 'temperatura', 598.0000, 'ºC'),
	(81581, 110, '2015-03-01 00:04:44.000000', 'temperatura', 334.0000, 'ºC'),
	(81582, 110, '2015-03-01 00:04:45.000000', 'temperatura', 1076.0000, 'ºC'),
	(81583, 110, '2015-03-01 00:04:46.000000', 'temperatura', 781.0000, 'ºC'),
	(81584, 110, '2015-03-01 00:04:47.000000', 'temperatura', 676.0000, 'ºC'),
	(81585, 110, '2015-03-01 00:04:48.000000', 'temperatura', 1038.0000, 'ºC'),
	(81586, 110, '2015-03-01 00:04:49.000000', 'temperatura', 763.0000, 'ºC'),
	(81587, 110, '2015-03-01 00:04:50.000000', 'temperatura', 702.0000, 'ºC'),
	(81588, 110, '2015-03-01 00:04:51.000000', 'temperatura', 19.0000, 'ºC'),
	(81589, 110, '2015-03-01 00:04:52.000000', 'temperatura', 392.0000, 'ºC'),
	(81590, 110, '2015-03-01 00:04:53.000000', 'temperatura', 701.0000, 'ºC'),
	(81591, 110, '2015-03-01 00:04:54.000000', 'temperatura', 1131.0000, 'ºC'),
	(81592, 110, '2015-03-01 00:04:55.000000', 'temperatura', 1151.0000, 'ºC'),
	(81593, 110, '2015-03-01 00:04:56.000000', 'temperatura', 1162.0000, 'ºC'),
	(81594, 110, '2015-03-01 00:04:57.000000', 'temperatura', 1158.0000, 'ºC'),
	(81595, 110, '2015-03-01 00:04:58.000000', 'temperatura', 1103.0000, 'ºC'),
	(81596, 110, '2015-03-01 00:04:59.000000', 'temperatura', 842.0000, 'ºC'),
	(81597, 110, '2015-03-01 00:05:00.000000', 'temperatura', 903.0000, 'ºC'),
	(81598, 110, '2015-03-01 00:05:01.000000', 'temperatura', 787.0000, 'ºC'),
	(81599, 110, '2015-03-01 00:05:02.000000', 'temperatura', 29.0000, 'ºC'),
	(81600, 110, '2015-03-01 00:05:03.000000', 'temperatura', 182.0000, 'ºC'),
	(81601, 110, '2015-03-01 00:05:04.000000', 'temperatura', 825.0000, 'ºC'),
	(81602, 110, '2015-03-01 00:05:05.000000', 'temperatura', 1178.0000, 'ºC'),
	(81603, 110, '2015-03-01 00:05:06.000000', 'temperatura', 1016.0000, 'ºC'),
	(81604, 110, '2015-03-01 00:05:07.000000', 'temperatura', 349.0000, 'ºC'),
	(81605, 110, '2015-03-01 00:05:08.000000', 'temperatura', 1094.0000, 'ºC'),
	(81606, 110, '2015-03-01 00:05:09.000000', 'temperatura', 825.0000, 'ºC'),
	(81607, 110, '2015-03-01 00:05:10.000000', 'temperatura', 841.0000, 'ºC'),
	(81608, 110, '2015-03-01 00:05:11.000000', 'temperatura', 533.0000, 'ºC'),
	(81609, 110, '2015-03-01 00:05:12.000000', 'temperatura', 143.0000, 'ºC'),
	(81610, 110, '2015-03-01 00:05:13.000000', 'temperatura', 317.0000, 'ºC'),
	(81611, 110, '2015-03-01 00:05:14.000000', 'temperatura', 1158.0000, 'ºC'),
	(81612, 110, '2015-03-01 00:05:15.000000', 'temperatura', 36.0000, 'ºC'),
	(81613, 110, '2015-03-01 00:05:16.000000', 'temperatura', 309.0000, 'ºC'),
	(81614, 110, '2015-03-01 00:05:17.000000', 'temperatura', 236.0000, 'ºC'),
	(81615, 110, '2015-03-01 00:05:18.000000', 'temperatura', 254.0000, 'ºC'),
	(81616, 110, '2015-03-01 00:05:19.000000', 'temperatura', 564.0000, 'ºC'),
	(81617, 110, '2015-03-01 00:05:20.000000', 'temperatura', 858.0000, 'ºC'),
	(81618, 110, '2015-03-01 00:05:21.000000', 'temperatura', 199.0000, 'ºC'),
	(81619, 110, '2015-03-01 00:05:22.000000', 'temperatura', 820.0000, 'ºC'),
	(81620, 110, '2015-03-01 00:05:23.000000', 'temperatura', 1106.0000, 'ºC'),
	(81621, 110, '2015-03-01 00:05:24.000000', 'temperatura', 669.0000, 'ºC'),
	(81622, 110, '2015-03-01 00:05:25.000000', 'temperatura', 26.0000, 'ºC'),
	(81623, 110, '2015-03-01 00:05:26.000000', 'temperatura', 526.0000, 'ºC'),
	(81624, 110, '2015-03-01 00:05:27.000000', 'temperatura', 153.0000, 'ºC'),
	(81625, 110, '2015-03-01 00:05:28.000000', 'temperatura', 385.0000, 'ºC'),
	(81626, 110, '2015-03-01 00:05:29.000000', 'temperatura', 268.0000, 'ºC'),
	(81627, 110, '2015-03-01 00:05:30.000000', 'temperatura', 185.0000, 'ºC'),
	(81628, 110, '2015-03-01 00:05:31.000000', 'temperatura', 120.0000, 'ºC'),
	(81629, 110, '2015-03-01 00:05:32.000000', 'temperatura', 47.0000, 'ºC'),
	(81630, 110, '2015-03-01 00:05:33.000000', 'temperatura', 1077.0000, 'ºC'),
	(81631, 110, '2015-03-01 00:05:34.000000', 'temperatura', 443.0000, 'ºC'),
	(81632, 110, '2015-03-01 00:05:35.000000', 'temperatura', 186.0000, 'ºC'),
	(81633, 110, '2015-03-01 00:05:36.000000', 'temperatura', 800.0000, 'ºC'),
	(81634, 110, '2015-03-01 00:05:37.000000', 'temperatura', 1045.0000, 'ºC'),
	(81635, 110, '2015-03-01 00:05:38.000000', 'temperatura', 424.0000, 'ºC'),
	(81636, 110, '2015-03-01 00:05:39.000000', 'temperatura', 185.0000, 'ºC'),
	(81637, 110, '2015-03-01 00:05:40.000000', 'temperatura', 855.0000, 'ºC'),
	(81638, 110, '2015-03-01 00:05:41.000000', 'temperatura', 120.0000, 'ºC'),
	(81639, 110, '2015-03-01 00:05:42.000000', 'temperatura', 437.0000, 'ºC'),
	(81640, 110, '2015-03-01 00:05:43.000000', 'temperatura', 626.0000, 'ºC'),
	(81641, 110, '2015-03-01 00:05:44.000000', 'temperatura', 618.0000, 'ºC'),
	(81642, 110, '2015-03-01 00:05:45.000000', 'temperatura', 15.0000, 'ºC'),
	(81643, 110, '2015-03-01 00:05:46.000000', 'temperatura', 618.0000, 'ºC'),
	(81644, 110, '2015-03-01 00:05:47.000000', 'temperatura', 648.0000, 'ºC'),
	(81645, 110, '2015-03-01 00:05:48.000000', 'temperatura', 185.0000, 'ºC'),
	(81646, 110, '2015-03-01 00:05:49.000000', 'temperatura', 182.0000, 'ºC'),
	(81647, 110, '2015-03-01 00:05:50.000000', 'temperatura', 355.0000, 'ºC'),
	(81648, 110, '2015-03-01 00:05:51.000000', 'temperatura', 31.0000, 'ºC'),
	(81649, 110, '2015-03-01 00:05:52.000000', 'temperatura', 288.0000, 'ºC'),
	(81650, 110, '2015-03-01 00:05:53.000000', 'temperatura', 151.0000, 'ºC'),
	(81651, 110, '2015-03-01 00:05:54.000000', 'temperatura', 1088.0000, 'ºC'),
	(81652, 110, '2015-03-01 00:05:55.000000', 'temperatura', 191.0000, 'ºC'),
	(81653, 110, '2015-03-01 00:05:56.000000', 'temperatura', 89.0000, 'ºC'),
	(81654, 110, '2015-03-01 00:05:57.000000', 'temperatura', 1071.0000, 'ºC'),
	(81655, 110, '2015-03-01 00:05:58.000000', 'temperatura', 290.0000, 'ºC'),
	(81656, 110, '2015-03-01 00:05:59.000000', 'temperatura', 639.0000, 'ºC'),
	(81657, 110, '2015-03-01 00:06:00.000000', 'temperatura', 1127.0000, 'ºC'),
	(81658, 110, '2015-03-01 00:06:01.000000', 'temperatura', 115.0000, 'ºC'),
	(81659, 110, '2015-03-01 00:06:02.000000', 'temperatura', 794.0000, 'ºC'),
	(81660, 110, '2015-03-01 00:06:03.000000', 'temperatura', 28.0000, 'ºC'),
	(81661, 110, '2015-03-01 00:06:04.000000', 'temperatura', 157.0000, 'ºC'),
	(81662, 110, '2015-03-01 00:06:05.000000', 'temperatura', 700.0000, 'ºC'),
	(81663, 110, '2015-03-01 00:06:06.000000', 'temperatura', 632.0000, 'ºC'),
	(81664, 110, '2015-03-01 00:06:07.000000', 'temperatura', 1060.0000, 'ºC'),
	(81665, 110, '2015-03-01 00:06:08.000000', 'temperatura', 1006.0000, 'ºC'),
	(81666, 110, '2015-03-01 00:06:09.000000', 'temperatura', 648.0000, 'ºC'),
	(81667, 110, '2015-03-01 00:06:10.000000', 'temperatura', 222.0000, 'ºC'),
	(81668, 110, '2015-03-01 00:06:11.000000', 'temperatura', 367.0000, 'ºC'),
	(81669, 110, '2015-03-01 00:06:12.000000', 'temperatura', 1171.0000, 'ºC'),
	(81670, 110, '2015-03-01 00:06:13.000000', 'temperatura', 1152.0000, 'ºC'),
	(81671, 110, '2015-03-01 00:06:14.000000', 'temperatura', 1050.0000, 'ºC'),
	(81672, 110, '2015-03-01 00:06:15.000000', 'temperatura', 593.0000, 'ºC'),
	(81673, 110, '2015-03-01 00:06:16.000000', 'temperatura', 1018.0000, 'ºC'),
	(81674, 110, '2015-03-01 00:06:17.000000', 'temperatura', 909.0000, 'ºC'),
	(81675, 110, '2015-03-01 00:06:18.000000', 'temperatura', 291.0000, 'ºC'),
	(81676, 110, '2015-03-01 00:06:19.000000', 'temperatura', 1128.0000, 'ºC'),
	(81677, 110, '2015-03-01 00:06:20.000000', 'temperatura', 1168.0000, 'ºC'),
	(81678, 110, '2015-03-01 00:06:21.000000', 'temperatura', 56.0000, 'ºC'),
	(81679, 110, '2015-03-01 00:06:22.000000', 'temperatura', 376.0000, 'ºC'),
	(81680, 110, '2015-03-01 00:06:23.000000', 'temperatura', 512.0000, 'ºC'),
	(81681, 110, '2015-03-01 00:06:24.000000', 'temperatura', 235.0000, 'ºC'),
	(81682, 110, '2015-03-01 00:06:25.000000', 'temperatura', 840.0000, 'ºC'),
	(81683, 110, '2015-03-01 00:06:26.000000', 'temperatura', 1096.0000, 'ºC'),
	(81684, 110, '2015-03-01 00:06:27.000000', 'temperatura', 557.0000, 'ºC'),
	(81685, 110, '2015-03-01 00:06:28.000000', 'temperatura', 701.0000, 'ºC'),
	(81686, 110, '2015-03-01 00:06:29.000000', 'temperatura', 633.0000, 'ºC'),
	(81687, 110, '2015-03-01 00:06:30.000000', 'temperatura', 1064.0000, 'ºC'),
	(81688, 110, '2015-03-01 00:06:31.000000', 'temperatura', 1020.0000, 'ºC'),
	(81689, 110, '2015-03-01 00:06:32.000000', 'temperatura', 711.0000, 'ºC'),
	(81690, 110, '2015-03-01 00:06:33.000000', 'temperatura', 492.0000, 'ºC'),
	(81691, 110, '2015-03-01 00:06:34.000000', 'temperatura', 329.0000, 'ºC'),
	(81692, 110, '2015-03-01 00:06:35.000000', 'temperatura', 171.0000, 'ºC'),
	(81693, 110, '2015-03-01 00:06:36.000000', 'temperatura', 1068.0000, 'ºC'),
	(81694, 110, '2015-03-01 00:06:37.000000', 'temperatura', 26.0000, 'ºC'),
	(81695, 110, '2015-03-01 00:06:38.000000', 'temperatura', 528.0000, 'ºC'),
	(81696, 110, '2015-03-01 00:06:39.000000', 'temperatura', 164.0000, 'ºC'),
	(81697, 110, '2015-03-01 00:06:40.000000', 'temperatura', 435.0000, 'ºC'),
	(81698, 110, '2015-03-01 00:06:41.000000', 'temperatura', 485.0000, 'ºC'),
	(81699, 110, '2015-03-01 00:06:42.000000', 'temperatura', 1118.0000, 'ºC'),
	(81700, 110, '2015-03-01 00:06:43.000000', 'temperatura', 536.0000, 'ºC'),
	(81701, 110, '2015-03-01 00:06:44.000000', 'temperatura', 528.0000, 'ºC'),
	(81702, 110, '2015-03-01 00:06:45.000000', 'temperatura', 1031.0000, 'ºC'),
	(81703, 110, '2015-03-01 00:06:46.000000', 'temperatura', 1173.0000, 'ºC'),
	(81704, 110, '2015-03-01 00:06:47.000000', 'temperatura', 372.0000, 'ºC'),
	(81705, 110, '2015-03-01 00:06:48.000000', 'temperatura', 743.0000, 'ºC'),
	(81706, 110, '2015-03-01 00:06:49.000000', 'temperatura', 200.0000, 'ºC'),
	(81707, 110, '2015-03-01 00:06:50.000000', 'temperatura', 1169.0000, 'ºC'),
	(81708, 110, '2015-03-01 00:06:51.000000', 'temperatura', 445.0000, 'ºC'),
	(81709, 110, '2015-03-01 00:06:52.000000', 'temperatura', 1119.0000, 'ºC'),
	(81710, 110, '2015-03-01 00:06:53.000000', 'temperatura', 659.0000, 'ºC'),
	(81711, 110, '2015-03-01 00:06:54.000000', 'temperatura', 1142.0000, 'ºC'),
	(81712, 110, '2015-03-01 00:06:55.000000', 'temperatura', 131.0000, 'ºC'),
	(81713, 110, '2015-03-01 00:06:56.000000', 'temperatura', 830.0000, 'ºC'),
	(81714, 110, '2015-03-01 00:06:57.000000', 'temperatura', 156.0000, 'ºC'),
	(81715, 110, '2015-03-01 00:06:58.000000', 'temperatura', 692.0000, 'ºC'),
	(81716, 110, '2015-03-01 00:06:59.000000', 'temperatura', 594.0000, 'ºC'),
	(81717, 110, '2015-03-01 00:07:00.000000', 'temperatura', 894.0000, 'ºC'),
	(81718, 110, '2015-03-01 00:07:01.000000', 'temperatura', 289.0000, 'ºC'),
	(81719, 110, '2015-03-01 00:07:02.000000', 'temperatura', 1162.0000, 'ºC'),
	(81720, 110, '2015-03-01 00:07:03.000000', 'temperatura', 145.0000, 'ºC'),
	(81721, 110, '2015-03-01 00:07:04.000000', 'temperatura', 838.0000, 'ºC'),
	(81722, 110, '2015-03-01 00:07:05.000000', 'temperatura', 155.0000, 'ºC'),
	(81723, 110, '2015-03-01 00:07:06.000000', 'temperatura', 662.0000, 'ºC'),
	(81724, 110, '2015-03-01 00:07:07.000000', 'temperatura', 446.0000, 'ºC'),
	(81725, 110, '2015-03-01 00:07:08.000000', 'temperatura', 243.0000, 'ºC'),
	(81726, 110, '2015-03-01 00:07:09.000000', 'temperatura', 1078.0000, 'ºC'),
	(81727, 110, '2015-03-01 00:07:10.000000', 'temperatura', 1063.0000, 'ºC'),
	(81728, 110, '2015-03-01 00:07:11.000000', 'temperatura', 880.0000, 'ºC'),
	(81729, 110, '2015-03-01 00:07:12.000000', 'temperatura', 12.0000, 'ºC'),
	(81730, 110, '2015-03-01 00:07:13.000000', 'temperatura', 1019.0000, 'ºC'),
	(81731, 110, '2015-03-01 00:07:14.000000', 'temperatura', 259.0000, 'ºC'),
	(81732, 110, '2015-03-01 00:07:15.000000', 'temperatura', 639.0000, 'ºC'),
	(81733, 110, '2015-03-01 00:07:16.000000', 'temperatura', 21.0000, 'ºC'),
	(81734, 110, '2015-03-01 00:07:17.000000', 'temperatura', 585.0000, 'ºC'),
	(81735, 110, '2015-03-01 00:07:18.000000', 'temperatura', 465.0000, 'ºC'),
	(81736, 110, '2015-03-01 00:07:19.000000', 'temperatura', 570.0000, 'ºC'),
	(81737, 110, '2015-03-01 00:07:20.000000', 'temperatura', 257.0000, 'ºC'),
	(81738, 110, '2015-03-01 00:07:21.000000', 'temperatura', 775.0000, 'ºC'),
	(81739, 110, '2015-03-01 00:07:22.000000', 'temperatura', 706.0000, 'ºC'),
	(81740, 110, '2015-03-01 00:07:23.000000', 'temperatura', 4.0000, 'ºC'),
	(81741, 110, '2015-03-01 00:07:24.000000', 'temperatura', 304.0000, 'ºC'),
	(81742, 110, '2015-03-01 00:07:25.000000', 'temperatura', 308.0000, 'ºC'),
	(81743, 110, '2015-03-01 00:07:26.000000', 'temperatura', 627.0000, 'ºC'),
	(81744, 110, '2015-03-01 00:07:27.000000', 'temperatura', 1013.0000, 'ºC'),
	(81745, 110, '2015-03-01 00:07:28.000000', 'temperatura', 782.0000, 'ºC'),
	(81746, 110, '2015-03-01 00:07:29.000000', 'temperatura', 874.0000, 'ºC'),
	(81747, 110, '2015-03-01 00:07:30.000000', 'temperatura', 825.0000, 'ºC'),
	(81748, 110, '2015-03-01 00:07:31.000000', 'temperatura', 302.0000, 'ºC'),
	(81749, 110, '2015-03-01 00:07:32.000000', 'temperatura', 235.0000, 'ºC'),
	(81750, 110, '2015-03-01 00:07:33.000000', 'temperatura', 272.0000, 'ºC'),
	(81751, 110, '2015-03-01 00:07:34.000000', 'temperatura', 653.0000, 'ºC'),
	(81752, 110, '2015-03-01 00:07:35.000000', 'temperatura', 50.0000, 'ºC'),
	(81753, 110, '2015-03-01 00:07:36.000000', 'temperatura', 693.0000, 'ºC'),
	(81754, 110, '2015-03-01 00:07:37.000000', 'temperatura', 916.0000, 'ºC'),
	(81755, 110, '2015-03-01 00:07:38.000000', 'temperatura', 100.0000, 'ºC'),
	(81756, 110, '2015-03-01 00:07:39.000000', 'temperatura', 153.0000, 'ºC'),
	(81757, 110, '2015-03-01 00:07:40.000000', 'temperatura', 465.0000, 'ºC'),
	(81758, 110, '2015-03-01 00:07:41.000000', 'temperatura', 668.0000, 'ºC'),
	(81759, 110, '2015-03-01 00:07:42.000000', 'temperatura', 745.0000, 'ºC'),
	(81760, 110, '2015-03-01 00:07:43.000000', 'temperatura', 523.0000, 'ºC'),
	(81761, 110, '2015-03-01 00:07:44.000000', 'temperatura', 377.0000, 'ºC'),
	(81762, 110, '2015-03-01 00:07:45.000000', 'temperatura', 319.0000, 'ºC'),
	(81763, 110, '2015-03-01 00:07:46.000000', 'temperatura', 465.0000, 'ºC'),
	(81764, 110, '2015-03-01 00:07:47.000000', 'temperatura', 168.0000, 'ºC'),
	(81765, 110, '2015-03-01 00:07:48.000000', 'temperatura', 644.0000, 'ºC'),
	(81766, 110, '2015-03-01 00:07:49.000000', 'temperatura', 315.0000, 'ºC'),
	(81767, 110, '2015-03-01 00:07:50.000000', 'temperatura', 847.0000, 'ºC'),
	(81768, 110, '2015-03-01 00:07:51.000000', 'temperatura', 887.0000, 'ºC'),
	(81769, 110, '2015-03-01 00:07:52.000000', 'temperatura', 697.0000, 'ºC'),
	(81770, 110, '2015-03-01 00:07:53.000000', 'temperatura', 823.0000, 'ºC'),
	(81771, 110, '2015-03-01 00:07:54.000000', 'temperatura', 827.0000, 'ºC'),
	(81772, 110, '2015-03-01 00:07:55.000000', 'temperatura', 464.0000, 'ºC'),
	(81773, 110, '2015-03-01 00:07:56.000000', 'temperatura', 1038.0000, 'ºC'),
	(81774, 110, '2015-03-01 00:07:57.000000', 'temperatura', 202.0000, 'ºC'),
	(81775, 110, '2015-03-01 00:07:58.000000', 'temperatura', 295.0000, 'ºC'),
	(81776, 110, '2015-03-01 00:07:59.000000', 'temperatura', 871.0000, 'ºC'),
	(81777, 110, '2015-03-01 00:08:00.000000', 'temperatura', 1070.0000, 'ºC'),
	(81778, 110, '2015-03-01 00:08:01.000000', 'temperatura', 338.0000, 'ºC'),
	(81779, 110, '2015-03-01 00:08:02.000000', 'temperatura', 880.0000, 'ºC'),
	(81780, 110, '2015-03-01 00:08:03.000000', 'temperatura', 988.0000, 'ºC'),
	(81781, 110, '2015-03-01 00:08:04.000000', 'temperatura', 1100.0000, 'ºC'),
	(81782, 110, '2015-03-01 00:08:05.000000', 'temperatura', 137.0000, 'ºC'),
	(81783, 110, '2015-03-01 00:08:06.000000', 'temperatura', 985.0000, 'ºC'),
	(81784, 110, '2015-03-01 00:08:07.000000', 'temperatura', 914.0000, 'ºC'),
	(81785, 110, '2015-03-01 00:08:08.000000', 'temperatura', 414.0000, 'ºC'),
	(81786, 110, '2015-03-01 00:08:09.000000', 'temperatura', 531.0000, 'ºC'),
	(81787, 110, '2015-03-01 00:08:10.000000', 'temperatura', 212.0000, 'ºC'),
	(81788, 110, '2015-03-01 00:08:11.000000', 'temperatura', 667.0000, 'ºC'),
	(81789, 110, '2015-03-01 00:08:12.000000', 'temperatura', 299.0000, 'ºC'),
	(81790, 110, '2015-03-01 00:08:13.000000', 'temperatura', 695.0000, 'ºC'),
	(81791, 110, '2015-03-01 00:08:14.000000', 'temperatura', 180.0000, 'ºC'),
	(81792, 110, '2015-03-01 00:08:15.000000', 'temperatura', 14.0000, 'ºC'),
	(81793, 110, '2015-03-01 00:08:16.000000', 'temperatura', 733.0000, 'ºC'),
	(81794, 110, '2015-03-01 00:08:17.000000', 'temperatura', 21.0000, 'ºC'),
	(81795, 110, '2015-03-01 00:08:18.000000', 'temperatura', 306.0000, 'ºC'),
	(81796, 110, '2015-03-01 00:08:19.000000', 'temperatura', 270.0000, 'ºC'),
	(81797, 110, '2015-03-01 00:08:20.000000', 'temperatura', 431.0000, 'ºC'),
	(81798, 110, '2015-03-01 00:08:21.000000', 'temperatura', 144.0000, 'ºC'),
	(81799, 110, '2015-03-01 00:08:22.000000', 'temperatura', 629.0000, 'ºC'),
	(81800, 110, '2015-03-01 00:08:23.000000', 'temperatura', 313.0000, 'ºC'),
	(81801, 110, '2015-03-01 00:08:24.000000', 'temperatura', 880.0000, 'ºC'),
	(81802, 110, '2015-03-01 00:08:25.000000', 'temperatura', 1059.0000, 'ºC'),
	(81803, 110, '2015-03-01 00:08:26.000000', 'temperatura', 256.0000, 'ºC'),
	(81804, 110, '2015-03-01 00:08:27.000000', 'temperatura', 506.0000, 'ºC'),
	(81805, 110, '2015-03-01 00:08:28.000000', 'temperatura', 560.0000, 'ºC'),
	(81806, 110, '2015-03-01 00:08:29.000000', 'temperatura', 82.0000, 'ºC'),
	(81807, 110, '2015-03-01 00:08:30.000000', 'temperatura', 1130.0000, 'ºC'),
	(81808, 110, '2015-03-01 00:08:31.000000', 'temperatura', 605.0000, 'ºC'),
	(81809, 110, '2015-03-01 00:08:32.000000', 'temperatura', 834.0000, 'ºC'),
	(81810, 110, '2015-03-01 00:08:33.000000', 'temperatura', 1159.0000, 'ºC'),
	(81811, 110, '2015-03-01 00:08:34.000000', 'temperatura', 890.0000, 'ºC'),
	(81812, 110, '2015-03-01 00:08:35.000000', 'temperatura', 976.0000, 'ºC'),
	(81813, 110, '2015-03-01 00:08:36.000000', 'temperatura', 1011.0000, 'ºC'),
	(81814, 110, '2015-03-01 00:08:37.000000', 'temperatura', 926.0000, 'ºC'),
	(81815, 110, '2015-03-01 00:08:38.000000', 'temperatura', 399.0000, 'ºC'),
	(81816, 110, '2015-03-01 00:08:39.000000', 'temperatura', 417.0000, 'ºC'),
	(81817, 110, '2015-03-01 00:08:40.000000', 'temperatura', 887.0000, 'ºC'),
	(81818, 110, '2015-03-01 00:08:41.000000', 'temperatura', 787.0000, 'ºC'),
	(81819, 110, '2015-03-01 00:08:42.000000', 'temperatura', 75.0000, 'ºC'),
	(81820, 110, '2015-03-01 00:08:43.000000', 'temperatura', 415.0000, 'ºC'),
	(81821, 110, '2015-03-01 00:08:44.000000', 'temperatura', 651.0000, 'ºC'),
	(81822, 110, '2015-03-01 00:08:45.000000', 'temperatura', 810.0000, 'ºC'),
	(81823, 110, '2015-03-01 00:08:46.000000', 'temperatura', 896.0000, 'ºC'),
	(81824, 110, '2015-03-01 00:08:47.000000', 'temperatura', 850.0000, 'ºC'),
	(81825, 110, '2015-03-01 00:08:48.000000', 'temperatura', 363.0000, 'ºC'),
	(81826, 110, '2015-03-01 00:08:49.000000', 'temperatura', 466.0000, 'ºC'),
	(81827, 110, '2015-03-01 00:08:50.000000', 'temperatura', 41.0000, 'ºC'),
	(81828, 110, '2015-03-01 00:08:51.000000', 'temperatura', 6.0000, 'ºC'),
	(81829, 110, '2015-03-01 00:08:52.000000', 'temperatura', 1109.0000, 'ºC'),
	(81830, 110, '2015-03-01 00:08:53.000000', 'temperatura', 729.0000, 'ºC'),
	(81831, 110, '2015-03-01 00:08:54.000000', 'temperatura', 317.0000, 'ºC'),
	(81832, 110, '2015-03-01 00:08:55.000000', 'temperatura', 598.0000, 'ºC'),
	(81833, 110, '2015-03-01 00:08:56.000000', 'temperatura', 839.0000, 'ºC'),
	(81834, 110, '2015-03-01 00:08:57.000000', 'temperatura', 0.0000, 'ºC'),
	(81835, 110, '2015-03-01 00:08:58.000000', 'temperatura', 1086.0000, 'ºC'),
	(81836, 110, '2015-03-01 00:08:59.000000', 'temperatura', 630.0000, 'ºC'),
	(81837, 110, '2015-03-01 00:09:00.000000', 'temperatura', 1094.0000, 'ºC'),
	(81838, 110, '2015-03-01 00:09:01.000000', 'temperatura', 1180.0000, 'ºC'),
	(81839, 110, '2015-03-01 00:09:02.000000', 'temperatura', 216.0000, 'ºC'),
	(81840, 110, '2015-03-01 00:09:03.000000', 'temperatura', 1143.0000, 'ºC'),
	(81841, 110, '2015-03-01 00:09:04.000000', 'temperatura', 265.0000, 'ºC'),
	(81842, 110, '2015-03-01 00:09:05.000000', 'temperatura', 298.0000, 'ºC'),
	(81843, 110, '2015-03-01 00:09:06.000000', 'temperatura', 696.0000, 'ºC'),
	(81844, 110, '2015-03-01 00:09:07.000000', 'temperatura', 188.0000, 'ºC'),
	(81845, 110, '2015-03-01 00:09:08.000000', 'temperatura', 50.0000, 'ºC'),
	(81846, 110, '2015-03-01 00:09:09.000000', 'temperatura', 888.0000, 'ºC'),
	(81847, 110, '2015-03-01 00:09:10.000000', 'temperatura', 690.0000, 'ºC'),
	(81848, 110, '2015-03-01 00:09:11.000000', 'temperatura', 785.0000, 'ºC'),
	(81849, 110, '2015-03-01 00:09:12.000000', 'temperatura', 658.0000, 'ºC'),
	(81850, 110, '2015-03-01 00:09:13.000000', 'temperatura', 935.0000, 'ºC'),
	(81851, 110, '2015-03-01 00:09:14.000000', 'temperatura', 301.0000, 'ºC'),
	(81852, 110, '2015-03-01 00:09:15.000000', 'temperatura', 1100.0000, 'ºC'),
	(81853, 110, '2015-03-01 00:09:16.000000', 'temperatura', 999.0000, 'ºC'),
	(81854, 110, '2015-03-01 00:09:17.000000', 'temperatura', 494.0000, 'ºC'),
	(81855, 110, '2015-03-01 00:09:18.000000', 'temperatura', 676.0000, 'ºC'),
	(81856, 110, '2015-03-01 00:09:19.000000', 'temperatura', 696.0000, 'ºC'),
	(81857, 110, '2015-03-01 00:09:20.000000', 'temperatura', 254.0000, 'ºC'),
	(81858, 110, '2015-03-01 00:09:21.000000', 'temperatura', 382.0000, 'ºC'),
	(81859, 110, '2015-03-01 00:09:22.000000', 'temperatura', 1148.0000, 'ºC'),
	(81860, 110, '2015-03-01 00:09:23.000000', 'temperatura', 996.0000, 'ºC'),
	(81861, 110, '2015-03-01 00:09:24.000000', 'temperatura', 335.0000, 'ºC'),
	(81862, 110, '2015-03-01 00:09:25.000000', 'temperatura', 1089.0000, 'ºC'),
	(81863, 110, '2015-03-01 00:09:26.000000', 'temperatura', 840.0000, 'ºC'),
	(81864, 110, '2015-03-01 00:09:27.000000', 'temperatura', 932.0000, 'ºC'),
	(81865, 110, '2015-03-01 00:09:28.000000', 'temperatura', 942.0000, 'ºC'),
	(81866, 110, '2015-03-01 00:09:29.000000', 'temperatura', 714.0000, 'ºC'),
	(81867, 110, '2015-03-01 00:09:30.000000', 'temperatura', 745.0000, 'ºC'),
	(81868, 110, '2015-03-01 00:09:31.000000', 'temperatura', 382.0000, 'ºC'),
	(81869, 110, '2015-03-01 00:09:32.000000', 'temperatura', 875.0000, 'ºC'),
	(81870, 110, '2015-03-01 00:09:33.000000', 'temperatura', 830.0000, 'ºC'),
	(81871, 110, '2015-03-01 00:09:34.000000', 'temperatura', 325.0000, 'ºC'),
	(81872, 110, '2015-03-01 00:09:35.000000', 'temperatura', 334.0000, 'ºC'),
	(81873, 110, '2015-03-01 00:09:36.000000', 'temperatura', 697.0000, 'ºC'),
	(81874, 110, '2015-03-01 00:09:37.000000', 'temperatura', 82.0000, 'ºC'),
	(81875, 110, '2015-03-01 00:09:38.000000', 'temperatura', 721.0000, 'ºC'),
	(81876, 110, '2015-03-01 00:09:39.000000', 'temperatura', 960.0000, 'ºC'),
	(81877, 110, '2015-03-01 00:09:40.000000', 'temperatura', 235.0000, 'ºC'),
	(81878, 110, '2015-03-01 00:09:41.000000', 'temperatura', 696.0000, 'ºC'),
	(81879, 110, '2015-03-01 00:09:42.000000', 'temperatura', 376.0000, 'ºC'),
	(81880, 110, '2015-03-01 00:09:43.000000', 'temperatura', 993.0000, 'ºC'),
	(81881, 110, '2015-03-01 00:09:44.000000', 'temperatura', 236.0000, 'ºC'),
	(81882, 110, '2015-03-01 00:09:45.000000', 'temperatura', 602.0000, 'ºC'),
	(81883, 110, '2015-03-01 00:09:46.000000', 'temperatura', 1103.0000, 'ºC'),
	(81884, 110, '2015-03-01 00:09:47.000000', 'temperatura', 108.0000, 'ºC'),
	(81885, 110, '2015-03-01 00:09:48.000000', 'temperatura', 834.0000, 'ºC'),
	(81886, 110, '2015-03-01 00:09:49.000000', 'temperatura', 246.0000, 'ºC'),
	(81887, 110, '2015-03-01 00:09:50.000000', 'temperatura', 1130.0000, 'ºC'),
	(81888, 110, '2015-03-01 00:09:51.000000', 'temperatura', 112.0000, 'ºC'),
	(81889, 110, '2015-03-01 00:09:52.000000', 'temperatura', 770.0000, 'ºC'),
	(81890, 110, '2015-03-01 00:09:53.000000', 'temperatura', 1115.0000, 'ºC'),
	(81891, 110, '2015-03-01 00:09:54.000000', 'temperatura', 867.0000, 'ºC'),
	(81892, 110, '2015-03-01 00:09:55.000000', 'temperatura', 987.0000, 'ºC'),
	(81893, 110, '2015-03-01 00:09:56.000000', 'temperatura', 1137.0000, 'ºC'),
	(81894, 110, '2015-03-01 00:09:57.000000', 'temperatura', 323.0000, 'ºC'),
	(81895, 110, '2015-03-01 00:09:58.000000', 'temperatura', 606.0000, 'ºC'),
	(81896, 110, '2015-03-01 00:09:59.000000', 'temperatura', 862.0000, 'ºC'),
	(81897, 110, '2015-03-01 00:10:00.000000', 'temperatura', 93.0000, 'ºC'),
	(81898, 110, '2015-03-01 00:10:01.000000', 'temperatura', 277.0000, 'ºC'),
	(81899, 110, '2015-03-01 00:10:02.000000', 'temperatura', 1106.0000, 'ºC'),
	(81900, 110, '2015-03-01 00:10:03.000000', 'temperatura', 1100.0000, 'ºC'),
	(81901, 110, '2015-03-01 00:10:04.000000', 'temperatura', 983.0000, 'ºC'),
	(81902, 110, '2015-03-01 00:10:05.000000', 'temperatura', 414.0000, 'ºC'),
	(81903, 110, '2015-03-01 00:10:06.000000', 'temperatura', 324.0000, 'ºC'),
	(81904, 110, '2015-03-01 00:10:07.000000', 'temperatura', 377.0000, 'ºC'),
	(81905, 110, '2015-03-01 00:10:08.000000', 'temperatura', 914.0000, 'ºC'),
	(81906, 110, '2015-03-01 00:10:09.000000', 'temperatura', 1038.0000, 'ºC'),
	(81907, 110, '2015-03-01 00:10:10.000000', 'temperatura', 51.0000, 'ºC'),
	(81908, 110, '2015-03-01 00:10:11.000000', 'temperatura', 741.0000, 'ºC'),
	(81909, 110, '2015-03-01 00:10:12.000000', 'temperatura', 1151.0000, 'ºC'),
	(81910, 110, '2015-03-01 00:10:13.000000', 'temperatura', 1135.0000, 'ºC'),
	(81911, 110, '2015-03-01 00:10:14.000000', 'temperatura', 1022.0000, 'ºC'),
	(81912, 110, '2015-03-01 00:10:15.000000', 'temperatura', 504.0000, 'ºC'),
	(81913, 110, '2015-03-01 00:10:16.000000', 'temperatura', 656.0000, 'ºC'),
	(81914, 110, '2015-03-01 00:10:17.000000', 'temperatura', 566.0000, 'ºC'),
	(81915, 110, '2015-03-01 00:10:18.000000', 'temperatura', 864.0000, 'ºC'),
	(81916, 110, '2015-03-01 00:10:19.000000', 'temperatura', 224.0000, 'ºC'),
	(81917, 110, '2015-03-01 00:10:20.000000', 'temperatura', 927.0000, 'ºC'),
	(81918, 110, '2015-03-01 00:10:21.000000', 'temperatura', 364.0000, 'ºC'),
	(81919, 110, '2015-03-01 00:10:22.000000', 'temperatura', 238.0000, 'ºC'),
	(81920, 110, '2015-03-01 00:10:23.000000', 'temperatura', 98.0000, 'ºC'),
	(81921, 110, '2015-03-01 00:10:24.000000', 'temperatura', 979.0000, 'ºC'),
	(81922, 110, '2015-03-01 00:10:25.000000', 'temperatura', 1001.0000, 'ºC'),
	(81923, 110, '2015-03-01 00:10:26.000000', 'temperatura', 867.0000, 'ºC'),
	(81924, 110, '2015-03-01 00:10:27.000000', 'temperatura', 131.0000, 'ºC'),
	(81925, 110, '2015-03-01 00:10:28.000000', 'temperatura', 457.0000, 'ºC'),
	(81926, 110, '2015-03-01 00:10:29.000000', 'temperatura', 693.0000, 'ºC'),
	(81927, 110, '2015-03-01 00:10:30.000000', 'temperatura', 895.0000, 'ºC'),
	(81928, 110, '2015-03-01 00:10:31.000000', 'temperatura', 1194.0000, 'ºC'),
	(81929, 110, '2015-03-01 00:10:32.000000', 'temperatura', 886.0000, 'ºC'),
	(81930, 110, '2015-03-01 00:10:33.000000', 'temperatura', 849.0000, 'ºC'),
	(81931, 110, '2015-03-01 00:10:34.000000', 'temperatura', 389.0000, 'ºC'),
	(81932, 110, '2015-03-01 00:10:35.000000', 'temperatura', 596.0000, 'ºC'),
	(81933, 110, '2015-03-01 00:10:36.000000', 'temperatura', 616.0000, 'ºC'),
	(81934, 110, '2015-03-01 00:10:37.000000', 'temperatura', 90.0000, 'ºC'),
	(81935, 110, '2015-03-01 00:10:38.000000', 'temperatura', 1006.0000, 'ºC'),
	(81936, 110, '2015-03-01 00:10:39.000000', 'temperatura', 1157.0000, 'ºC'),
	(81937, 110, '2015-03-01 00:10:40.000000', 'temperatura', 369.0000, 'ºC'),
	(81938, 110, '2015-03-01 00:10:41.000000', 'temperatura', 776.0000, 'ºC'),
	(81939, 110, '2015-03-01 00:10:42.000000', 'temperatura', 372.0000, 'ºC'),
	(81940, 110, '2015-03-01 00:10:43.000000', 'temperatura', 732.0000, 'ºC'),
	(81941, 110, '2015-03-01 00:10:44.000000', 'temperatura', 147.0000, 'ºC'),
	(81942, 110, '2015-03-01 00:10:45.000000', 'temperatura', 937.0000, 'ºC'),
	(81943, 110, '2015-03-01 00:10:46.000000', 'temperatura', 647.0000, 'ºC'),
	(81944, 110, '2015-03-01 00:10:47.000000', 'temperatura', 422.0000, 'ºC'),
	(81945, 110, '2015-03-01 00:10:48.000000', 'temperatura', 171.0000, 'ºC'),
	(81946, 110, '2015-03-01 00:10:49.000000', 'temperatura', 790.0000, 'ºC'),
	(81947, 110, '2015-03-01 00:10:50.000000', 'temperatura', 1035.0000, 'ºC'),
	(81948, 110, '2015-03-01 00:10:51.000000', 'temperatura', 406.0000, 'ºC'),
	(81949, 110, '2015-03-01 00:10:52.000000', 'temperatura', 125.0000, 'ºC'),
	(81950, 110, '2015-03-01 00:10:53.000000', 'temperatura', 608.0000, 'ºC'),
	(81951, 110, '2015-03-01 00:10:54.000000', 'temperatura', 266.0000, 'ºC'),
	(81952, 110, '2015-03-01 00:10:55.000000', 'temperatura', 707.0000, 'ºC'),
	(81953, 110, '2015-03-01 00:10:56.000000', 'temperatura', 336.0000, 'ºC'),
	(81954, 110, '2015-03-01 00:10:57.000000', 'temperatura', 761.0000, 'ºC'),
	(81955, 110, '2015-03-01 00:10:58.000000', 'temperatura', 395.0000, 'ºC'),
	(81956, 110, '2015-03-01 00:10:59.000000', 'temperatura', 895.0000, 'ºC'),
	(81957, 110, '2015-03-01 00:11:00.000000', 'temperatura', 888.0000, 'ºC'),
	(81958, 110, '2015-03-01 00:11:01.000000', 'temperatura', 556.0000, 'ºC'),
	(81959, 110, '2015-03-01 00:11:02.000000', 'temperatura', 117.0000, 'ºC'),
	(81960, 110, '2015-03-01 00:11:03.000000', 'temperatura', 118.0000, 'ºC'),
	(81961, 110, '2015-03-01 00:11:04.000000', 'temperatura', 240.0000, 'ºC'),
	(81962, 110, '2015-03-01 00:11:05.000000', 'temperatura', 845.0000, 'ºC'),
	(81963, 110, '2015-03-01 00:11:06.000000', 'temperatura', 1107.0000, 'ºC'),
	(81964, 110, '2015-03-01 00:11:07.000000', 'temperatura', 600.0000, 'ºC'),
	(81965, 110, '2015-03-01 00:11:08.000000', 'temperatura', 879.0000, 'ºC'),
	(81966, 110, '2015-03-01 00:11:09.000000', 'temperatura', 194.0000, 'ºC'),
	(81967, 110, '2015-03-01 00:11:10.000000', 'temperatura', 734.0000, 'ºC'),
	(81968, 110, '2015-03-01 00:11:11.000000', 'temperatura', 691.0000, 'ºC'),
	(81969, 110, '2015-03-01 00:11:12.000000', 'temperatura', 51.0000, 'ºC'),
	(81970, 110, '2015-03-01 00:11:13.000000', 'temperatura', 584.0000, 'ºC'),
	(81971, 110, '2015-03-01 00:11:14.000000', 'temperatura', 366.0000, 'ºC'),
	(81972, 110, '2015-03-01 00:11:15.000000', 'temperatura', 81.0000, 'ºC'),
	(81973, 110, '2015-03-01 00:11:16.000000', 'temperatura', 504.0000, 'ºC'),
	(81974, 110, '2015-03-01 00:11:17.000000', 'temperatura', 1081.0000, 'ºC'),
	(81975, 110, '2015-03-01 00:11:18.000000', 'temperatura', 292.0000, 'ºC'),
	(81976, 110, '2015-03-01 00:11:19.000000', 'temperatura', 618.0000, 'ºC'),
	(81977, 110, '2015-03-01 00:11:20.000000', 'temperatura', 1015.0000, 'ºC'),
	(81978, 110, '2015-03-01 00:11:21.000000', 'temperatura', 821.0000, 'ºC'),
	(81979, 110, '2015-03-01 00:11:22.000000', 'temperatura', 1062.0000, 'ºC'),
	(81980, 110, '2015-03-01 00:11:23.000000', 'temperatura', 447.0000, 'ºC'),
	(81981, 110, '2015-03-01 00:11:24.000000', 'temperatura', 251.0000, 'ºC'),
	(81982, 110, '2015-03-01 00:11:25.000000', 'temperatura', 1111.0000, 'ºC'),
	(81983, 110, '2015-03-01 00:11:26.000000', 'temperatura', 6.0000, 'ºC'),
	(81984, 110, '2015-03-01 00:11:27.000000', 'temperatura', 295.0000, 'ºC'),
	(81985, 110, '2015-03-01 00:11:28.000000', 'temperatura', 258.0000, 'ºC'),
	(81986, 110, '2015-03-01 00:11:29.000000', 'temperatura', 407.0000, 'ºC'),
	(81987, 110, '2015-03-01 00:11:30.000000', 'temperatura', 60.0000, 'ºC'),
	(81988, 110, '2015-03-01 00:11:31.000000', 'temperatura', 280.0000, 'ºC'),
	(81989, 110, '2015-03-01 00:11:32.000000', 'temperatura', 22.0000, 'ºC'),
	(81990, 110, '2015-03-01 00:11:33.000000', 'temperatura', 469.0000, 'ºC'),
	(81991, 110, '2015-03-01 00:11:34.000000', 'temperatura', 1081.0000, 'ºC'),
	(81992, 110, '2015-03-01 00:11:35.000000', 'temperatura', 399.0000, 'ºC'),
	(81993, 110, '2015-03-01 00:11:36.000000', 'temperatura', 1152.0000, 'ºC'),
	(81994, 110, '2015-03-01 00:11:37.000000', 'temperatura', 965.0000, 'ºC'),
	(81995, 110, '2015-03-01 00:11:38.000000', 'temperatura', 169.0000, 'ºC'),
	(81996, 110, '2015-03-01 00:11:39.000000', 'temperatura', 349.0000, 'ºC'),
	(81997, 110, '2015-03-01 00:11:40.000000', 'temperatura', 40.0000, 'ºC'),
	(81998, 110, '2015-03-01 00:11:41.000000', 'temperatura', 352.0000, 'ºC'),
	(81999, 110, '2015-03-01 00:11:42.000000', 'temperatura', 440.0000, 'ºC'),
	(82000, 110, '2015-03-01 00:11:43.000000', 'temperatura', 1145.0000, 'ºC'),
	(82001, 110, '2015-03-01 00:11:44.000000', 'temperatura', 805.0000, 'ºC'),
	(82002, 110, '2015-03-01 00:11:45.000000', 'temperatura', 593.0000, 'ºC'),
	(82003, 110, '2015-03-01 00:11:46.000000', 'temperatura', 547.0000, 'ºC'),
	(82004, 110, '2015-03-01 00:11:47.000000', 'temperatura', 959.0000, 'ºC'),
	(82005, 110, '2015-03-01 00:11:48.000000', 'temperatura', 753.0000, 'ºC'),
	(82006, 110, '2015-03-01 00:11:49.000000', 'temperatura', 889.0000, 'ºC'),
	(82007, 110, '2015-03-01 00:11:50.000000', 'temperatura', 987.0000, 'ºC'),
	(82008, 110, '2015-03-01 00:11:51.000000', 'temperatura', 1070.0000, 'ºC'),
	(82009, 110, '2015-03-01 00:11:52.000000', 'temperatura', 1188.0000, 'ºC'),
	(82010, 110, '2015-03-01 00:11:53.000000', 'temperatura', 329.0000, 'ºC'),
	(82011, 110, '2015-03-01 00:11:54.000000', 'temperatura', 482.0000, 'ºC'),
	(82012, 110, '2015-03-01 00:11:55.000000', 'temperatura', 224.0000, 'ºC'),
	(82013, 110, '2015-03-01 00:11:56.000000', 'temperatura', 875.0000, 'ºC'),
	(82014, 110, '2015-03-01 00:11:57.000000', 'temperatura', 105.0000, 'ºC'),
	(82015, 110, '2015-03-01 00:11:58.000000', 'temperatura', 298.0000, 'ºC'),
	(82016, 110, '2015-03-01 00:11:59.000000', 'temperatura', 1175.0000, 'ºC'),
	(82017, 110, '2015-03-01 00:12:00.000000', 'temperatura', 184.0000, 'ºC'),
	(82018, 110, '2015-03-01 00:12:01.000000', 'temperatura', 996.0000, 'ºC'),
	(82019, 110, '2015-03-01 00:12:02.000000', 'temperatura', 826.0000, 'ºC'),
	(82020, 110, '2015-03-01 00:12:03.000000', 'temperatura', 1145.0000, 'ºC'),
	(82021, 110, '2015-03-01 00:12:04.000000', 'temperatura', 846.0000, 'ºC'),
	(82022, 110, '2015-03-01 00:12:05.000000', 'temperatura', 796.0000, 'ºC'),
	(82023, 110, '2015-03-01 00:12:06.000000', 'temperatura', 244.0000, 'ºC'),
	(82024, 110, '2015-03-01 00:12:07.000000', 'temperatura', 31.0000, 'ºC'),
	(82025, 110, '2015-03-01 00:12:08.000000', 'temperatura', 622.0000, 'ºC'),
	(82026, 110, '2015-03-01 00:12:09.000000', 'temperatura', 618.0000, 'ºC'),
	(82027, 110, '2015-03-01 00:12:10.000000', 'temperatura', 24.0000, 'ºC'),
	(82028, 110, '2015-03-01 00:12:11.000000', 'temperatura', 667.0000, 'ºC'),
	(82029, 110, '2015-03-01 00:12:12.000000', 'temperatura', 863.0000, 'ºC'),
	(82030, 110, '2015-03-01 00:12:13.000000', 'temperatura', 1115.0000, 'ºC'),
	(82031, 110, '2015-03-01 00:12:14.000000', 'temperatura', 589.0000, 'ºC'),
	(82032, 110, '2015-03-01 00:12:15.000000', 'temperatura', 797.0000, 'ºC'),
	(82033, 110, '2015-03-01 00:12:16.000000', 'temperatura', 1019.0000, 'ºC'),
	(82034, 110, '2015-03-01 00:12:17.000000', 'temperatura', 305.0000, 'ºC'),
	(82035, 110, '2015-03-01 00:12:18.000000', 'temperatura', 868.0000, 'ºC'),
	(82036, 110, '2015-03-01 00:12:19.000000', 'temperatura', 1024.0000, 'ºC'),
	(82037, 110, '2015-03-01 00:12:20.000000', 'temperatura', 118.0000, 'ºC'),
	(82038, 110, '2015-03-01 00:12:21.000000', 'temperatura', 1120.0000, 'ºC'),
	(82039, 110, '2015-03-01 00:12:22.000000', 'temperatura', 443.0000, 'ºC'),
	(82040, 110, '2015-03-01 00:12:23.000000', 'temperatura', 59.0000, 'ºC'),
	(82041, 110, '2015-03-01 00:12:24.000000', 'temperatura', 164.0000, 'ºC'),
	(82042, 110, '2015-03-01 00:12:25.000000', 'temperatura', 644.0000, 'ºC'),
	(82043, 110, '2015-03-01 00:12:26.000000', 'temperatura', 330.0000, 'ºC'),
	(82044, 110, '2015-03-01 00:12:27.000000', 'temperatura', 919.0000, 'ºC'),
	(82045, 110, '2015-03-01 00:12:28.000000', 'temperatura', 6.0000, 'ºC'),
	(82046, 110, '2015-03-01 00:12:29.000000', 'temperatura', 875.0000, 'ºC'),
	(82047, 110, '2015-03-01 00:12:30.000000', 'temperatura', 754.0000, 'ºC'),
	(82048, 110, '2015-03-01 00:12:31.000000', 'temperatura', 1145.0000, 'ºC'),
	(82049, 110, '2015-03-01 00:12:32.000000', 'temperatura', 1066.0000, 'ºC'),
	(82050, 110, '2015-03-01 00:12:33.000000', 'temperatura', 693.0000, 'ºC'),
	(82051, 110, '2015-03-01 00:12:34.000000', 'temperatura', 270.0000, 'ºC'),
	(82052, 110, '2015-03-01 00:12:35.000000', 'temperatura', 472.0000, 'ºC'),
	(82053, 110, '2015-03-01 00:12:36.000000', 'temperatura', 349.0000, 'ºC'),
	(82054, 110, '2015-03-01 00:12:37.000000', 'temperatura', 328.0000, 'ºC'),
	(82055, 110, '2015-03-01 00:12:38.000000', 'temperatura', 593.0000, 'ºC'),
	(82056, 110, '2015-03-01 00:12:39.000000', 'temperatura', 785.0000, 'ºC'),
	(82057, 110, '2015-03-01 00:12:40.000000', 'temperatura', 943.0000, 'ºC'),
	(82058, 110, '2015-03-01 00:12:41.000000', 'temperatura', 1163.0000, 'ºC'),
	(82059, 110, '2015-03-01 00:12:42.000000', 'temperatura', 585.0000, 'ºC'),
	(82060, 110, '2015-03-01 00:12:43.000000', 'temperatura', 638.0000, 'ºC'),
	(82061, 110, '2015-03-01 00:12:44.000000', 'temperatura', 234.0000, 'ºC'),
	(82062, 110, '2015-03-01 00:12:45.000000', 'temperatura', 457.0000, 'ºC'),
	(82063, 110, '2015-03-01 00:12:46.000000', 'temperatura', 385.0000, 'ºC'),
	(82064, 110, '2015-03-01 00:12:47.000000', 'temperatura', 554.0000, 'ºC'),
	(82065, 110, '2015-03-01 00:12:48.000000', 'temperatura', 413.0000, 'ºC'),
	(82066, 110, '2015-03-01 00:12:49.000000', 'temperatura', 405.0000, 'ºC'),
	(82067, 110, '2015-03-01 00:12:50.000000', 'temperatura', 788.0000, 'ºC'),
	(82068, 110, '2015-03-01 00:12:51.000000', 'temperatura', 326.0000, 'ºC'),
	(82069, 110, '2015-03-01 00:12:52.000000', 'temperatura', 466.0000, 'ºC'),
	(82070, 110, '2015-03-01 00:12:53.000000', 'temperatura', 151.0000, 'ºC'),
	(82071, 110, '2015-03-01 00:12:54.000000', 'temperatura', 560.0000, 'ºC'),
	(82072, 110, '2015-03-01 00:12:55.000000', 'temperatura', 1148.0000, 'ºC'),
	(82073, 110, '2015-03-01 00:12:56.000000', 'temperatura', 459.0000, 'ºC'),
	(82074, 110, '2015-03-01 00:12:57.000000', 'temperatura', 50.0000, 'ºC'),
	(82075, 110, '2015-03-01 00:12:58.000000', 'temperatura', 77.0000, 'ºC'),
	(82076, 110, '2015-03-01 00:12:59.000000', 'temperatura', 233.0000, 'ºC'),
	(82077, 110, '2015-03-01 00:13:00.000000', 'temperatura', 935.0000, 'ºC'),
	(82078, 110, '2015-03-01 00:13:01.000000', 'temperatura', 375.0000, 'ºC'),
	(82079, 110, '2015-03-01 00:13:02.000000', 'temperatura', 272.0000, 'ºC'),
	(82080, 110, '2015-03-01 00:13:03.000000', 'temperatura', 236.0000, 'ºC'),
	(82081, 110, '2015-03-01 00:13:04.000000', 'temperatura', 365.0000, 'ºC'),
	(82082, 110, '2015-03-01 00:13:05.000000', 'temperatura', 1116.0000, 'ºC'),
	(82083, 110, '2015-03-01 00:13:06.000000', 'temperatura', 887.0000, 'ºC'),
	(82084, 110, '2015-03-01 00:13:07.000000', 'temperatura', 1086.0000, 'ºC'),
	(82085, 110, '2015-03-01 00:13:08.000000', 'temperatura', 369.0000, 'ºC'),
	(82086, 110, '2015-03-01 00:13:09.000000', 'temperatura', 989.0000, 'ºC'),
	(82087, 110, '2015-03-01 00:13:10.000000', 'temperatura', 236.0000, 'ºC'),
	(82088, 110, '2015-03-01 00:13:11.000000', 'temperatura', 617.0000, 'ºC'),
	(82089, 110, '2015-03-01 00:13:12.000000', 'temperatura', 1175.0000, 'ºC'),
	(82090, 110, '2015-03-01 00:13:13.000000', 'temperatura', 426.0000, 'ºC'),
	(82091, 110, '2015-03-01 00:13:14.000000', 'temperatura', 1006.0000, 'ºC'),
	(82092, 110, '2015-03-01 00:13:15.000000', 'temperatura', 153.0000, 'ºC'),
	(82093, 110, '2015-03-01 00:13:16.000000', 'temperatura', 148.0000, 'ºC'),
	(82094, 110, '2015-03-01 00:13:17.000000', 'temperatura', 282.0000, 'ºC'),
	(82095, 110, '2015-03-01 00:13:18.000000', 'temperatura', 965.0000, 'ºC'),
	(82096, 110, '2015-03-01 00:13:19.000000', 'temperatura', 379.0000, 'ºC'),
	(82097, 110, '2015-03-01 00:13:20.000000', 'temperatura', 203.0000, 'ºC'),
	(82098, 110, '2015-03-01 00:13:21.000000', 'temperatura', 1076.0000, 'ºC'),
	(82099, 110, '2015-03-01 00:13:22.000000', 'temperatura', 1173.0000, 'ºC'),
	(82100, 110, '2015-03-01 00:13:23.000000', 'temperatura', 236.0000, 'ºC'),
	(82101, 110, '2015-03-01 00:13:24.000000', 'temperatura', 63.0000, 'ºC'),
	(82102, 110, '2015-03-01 00:13:25.000000', 'temperatura', 807.0000, 'ºC'),
	(82103, 110, '2015-03-01 00:13:26.000000', 'temperatura', 248.0000, 'ºC'),
	(82104, 110, '2015-03-01 00:13:27.000000', 'temperatura', 18.0000, 'ºC'),
	(82105, 110, '2015-03-01 00:13:28.000000', 'temperatura', 548.0000, 'ºC'),
	(82106, 110, '2015-03-01 00:13:29.000000', 'temperatura', 285.0000, 'ºC'),
	(82107, 110, '2015-03-01 00:13:30.000000', 'temperatura', 981.0000, 'ºC'),
	(82108, 110, '2015-03-01 00:13:31.000000', 'temperatura', 453.0000, 'ºC'),
	(82109, 110, '2015-03-01 00:13:32.000000', 'temperatura', 519.0000, 'ºC'),
	(82110, 110, '2015-03-01 00:13:33.000000', 'temperatura', 38.0000, 'ºC'),
	(82111, 110, '2015-03-01 00:13:34.000000', 'temperatura', 1035.0000, 'ºC'),
	(82112, 110, '2015-03-01 00:13:35.000000', 'temperatura', 262.0000, 'ºC'),
	(82113, 110, '2015-03-01 00:13:36.000000', 'temperatura', 606.0000, 'ºC'),
	(82114, 110, '2015-03-01 00:13:37.000000', 'temperatura', 1044.0000, 'ºC'),
	(82115, 110, '2015-03-01 00:13:38.000000', 'temperatura', 1002.0000, 'ºC'),
	(82116, 110, '2015-03-01 00:13:39.000000', 'temperatura', 677.0000, 'ºC'),
	(82117, 110, '2015-03-01 00:13:40.000000', 'temperatura', 380.0000, 'ºC'),
	(82118, 110, '2015-03-01 00:13:41.000000', 'temperatura', 1070.0000, 'ºC'),
	(82119, 110, '2015-03-01 00:13:42.000000', 'temperatura', 610.0000, 'ºC'),
	(82120, 110, '2015-03-01 00:13:43.000000', 'temperatura', 1042.0000, 'ºC'),
	(82121, 110, '2015-03-01 00:13:44.000000', 'temperatura', 980.0000, 'ºC'),
	(82122, 110, '2015-03-01 00:13:45.000000', 'temperatura', 574.0000, 'ºC'),
	(82123, 110, '2015-03-01 00:13:46.000000', 'temperatura', 1130.0000, 'ºC'),
	(82124, 110, '2015-03-01 00:13:47.000000', 'temperatura', 330.0000, 'ºC'),
	(82125, 110, '2015-03-01 00:13:48.000000', 'temperatura', 658.0000, 'ºC'),
	(82126, 110, '2015-03-01 00:13:49.000000', 'temperatura', 1104.0000, 'ºC'),
	(82127, 110, '2015-03-01 00:13:50.000000', 'temperatura', 1144.0000, 'ºC'),
	(82128, 110, '2015-03-01 00:13:51.000000', 'temperatura', 10.0000, 'ºC'),
	(82129, 110, '2015-03-01 00:13:52.000000', 'temperatura', 220.0000, 'ºC'),
	(82130, 110, '2015-03-01 00:13:53.000000', 'temperatura', 1068.0000, 'ºC'),
	(82131, 110, '2015-03-01 00:13:54.000000', 'temperatura', 1082.0000, 'ºC'),
	(82132, 110, '2015-03-01 00:13:55.000000', 'temperatura', 1005.0000, 'ºC'),
	(82133, 110, '2015-03-01 00:13:56.000000', 'temperatura', 580.0000, 'ºC'),
	(82134, 110, '2015-03-01 00:13:57.000000', 'temperatura', 1086.0000, 'ºC'),
	(82135, 110, '2015-03-01 00:13:58.000000', 'temperatura', 91.0000, 'ºC'),
	(82136, 110, '2015-03-01 00:13:59.000000', 'temperatura', 798.0000, 'ºC'),
	(82137, 110, '2015-03-01 00:14:00.000000', 'temperatura', 116.0000, 'ºC'),
	(82138, 110, '2015-03-01 00:14:01.000000', 'temperatura', 587.0000, 'ºC'),
	(82139, 110, '2015-03-01 00:14:02.000000', 'temperatura', 189.0000, 'ºC'),
	(82140, 110, '2015-03-01 00:14:03.000000', 'temperatura', 383.0000, 'ºC'),
	(82141, 110, '2015-03-01 00:14:04.000000', 'temperatura', 148.0000, 'ºC'),
	(82142, 110, '2015-03-01 00:14:05.000000', 'temperatura', 793.0000, 'ºC'),
	(82143, 110, '2015-03-01 00:14:06.000000', 'temperatura', 1121.0000, 'ºC'),
	(82144, 110, '2015-03-01 00:14:07.000000', 'temperatura', 828.0000, 'ºC'),
	(82145, 110, '2015-03-01 00:14:08.000000', 'temperatura', 777.0000, 'ºC'),
	(82146, 110, '2015-03-01 00:14:09.000000', 'temperatura', 201.0000, 'ºC'),
	(82147, 110, '2015-03-01 00:14:10.000000', 'temperatura', 1075.0000, 'ºC'),
	(82148, 110, '2015-03-01 00:14:11.000000', 'temperatura', 1172.0000, 'ºC'),
	(82149, 110, '2015-03-01 00:14:12.000000', 'temperatura', 235.0000, 'ºC'),
	(82150, 110, '2015-03-01 00:14:13.000000', 'temperatura', 58.0000, 'ºC'),
	(82151, 110, '2015-03-01 00:14:14.000000', 'temperatura', 788.0000, 'ºC'),
	(82152, 110, '2015-03-01 00:14:15.000000', 'temperatura', 165.0000, 'ºC'),
	(82153, 110, '2015-03-01 00:14:16.000000', 'temperatura', 861.0000, 'ºC'),
	(82154, 110, '2015-03-01 00:14:17.000000', 'temperatura', 212.0000, 'ºC'),
	(82155, 110, '2015-03-01 00:14:18.000000', 'temperatura', 876.0000, 'ºC'),
	(82156, 110, '2015-03-01 00:14:19.000000', 'temperatura', 145.0000, 'ºC'),
	(82157, 110, '2015-03-01 00:14:20.000000', 'temperatura', 496.0000, 'ºC'),
	(82158, 110, '2015-03-01 00:14:21.000000', 'temperatura', 845.0000, 'ºC'),
	(82159, 110, '2015-03-01 00:14:22.000000', 'temperatura', 338.0000, 'ºC'),
	(82160, 110, '2015-03-01 00:14:23.000000', 'temperatura', 358.0000, 'ºC'),
	(82161, 110, '2015-03-01 00:14:24.000000', 'temperatura', 773.0000, 'ºC'),
	(82162, 110, '2015-03-01 00:14:25.000000', 'temperatura', 394.0000, 'ºC'),
	(82163, 110, '2015-03-01 00:14:26.000000', 'temperatura', 851.0000, 'ºC'),
	(82164, 110, '2015-03-01 00:14:27.000000', 'temperatura', 675.0000, 'ºC'),
	(82165, 110, '2015-03-01 00:14:28.000000', 'temperatura', 820.0000, 'ºC'),
	(82166, 110, '2015-03-01 00:14:29.000000', 'temperatura', 877.0000, 'ºC'),
	(82167, 110, '2015-03-01 00:14:30.000000', 'temperatura', 725.0000, 'ºC'),
	(82168, 110, '2015-03-01 00:14:31.000000', 'temperatura', 994.0000, 'ºC'),
	(82169, 110, '2015-03-01 00:14:32.000000', 'temperatura', 398.0000, 'ºC'),
	(82170, 110, '2015-03-01 00:14:33.000000', 'temperatura', 206.0000, 'ºC'),
	(82171, 110, '2015-03-01 00:14:34.000000', 'temperatura', 1037.0000, 'ºC'),
	(82172, 110, '2015-03-01 00:14:35.000000', 'temperatura', 969.0000, 'ºC'),
	(82173, 110, '2015-03-01 00:14:36.000000', 'temperatura', 532.0000, 'ºC'),
	(82174, 110, '2015-03-01 00:14:37.000000', 'temperatura', 955.0000, 'ºC'),
	(82175, 110, '2015-03-01 00:14:38.000000', 'temperatura', 779.0000, 'ºC'),
	(82176, 110, '2015-03-01 00:14:39.000000', 'temperatura', 1029.0000, 'ºC'),
	(82177, 110, '2015-03-01 00:14:40.000000', 'temperatura', 408.0000, 'ºC'),
	(82178, 110, '2015-03-01 00:14:41.000000', 'temperatura', 155.0000, 'ºC'),
	(82179, 110, '2015-03-01 00:14:42.000000', 'temperatura', 753.0000, 'ºC'),
	(82180, 110, '2015-03-01 00:14:43.000000', 'temperatura', 898.0000, 'ºC'),
	(82181, 110, '2015-03-01 00:14:44.000000', 'temperatura', 1034.0000, 'ºC'),
	(82182, 110, '2015-03-01 00:14:45.000000', 'temperatura', 75.0000, 'ºC'),
	(82183, 110, '2015-03-01 00:14:46.000000', 'temperatura', 874.0000, 'ºC'),
	(82184, 110, '2015-03-01 00:14:47.000000', 'temperatura', 544.0000, 'ºC'),
	(82185, 110, '2015-03-01 00:14:48.000000', 'temperatura', 99.0000, 'ºC'),
	(82186, 110, '2015-03-01 00:14:49.000000', 'temperatura', 66.0000, 'ºC'),
	(82187, 110, '2015-03-01 00:14:50.000000', 'temperatura', 30.0000, 'ºC'),
	(82188, 110, '2015-03-01 00:14:51.000000', 'temperatura', 1153.0000, 'ºC'),
	(82189, 110, '2015-03-01 00:14:52.000000', 'temperatura', 878.0000, 'ºC'),
	(82190, 110, '2015-03-01 00:14:53.000000', 'temperatura', 930.0000, 'ºC'),
	(82191, 110, '2015-03-01 00:14:54.000000', 'temperatura', 817.0000, 'ºC'),
	(82192, 110, '2015-03-01 00:14:55.000000', 'temperatura', 96.0000, 'ºC'),
	(82193, 110, '2015-03-01 00:14:56.000000', 'temperatura', 428.0000, 'ºC'),
	(82194, 110, '2015-03-01 00:14:57.000000', 'temperatura', 654.0000, 'ºC'),
	(82195, 110, '2015-03-01 00:14:58.000000', 'temperatura', 787.0000, 'ºC'),
	(82196, 110, '2015-03-01 00:14:59.000000', 'temperatura', 772.0000, 'ºC'),
	(82197, 110, '2015-03-01 00:15:00.000000', 'temperatura', 302.0000, 'ºC'),
	(82198, 110, '2015-03-01 00:15:01.000000', 'temperatura', 392.0000, 'ºC'),
	(82199, 110, '2015-03-01 00:15:02.000000', 'temperatura', 1057.0000, 'ºC'),
	(82200, 110, '2015-03-01 00:15:03.000000', 'temperatura', 509.0000, 'ºC'),
	(82201, 110, '2015-03-01 00:15:04.000000', 'temperatura', 575.0000, 'ºC'),
	(82202, 110, '2015-03-01 00:15:05.000000', 'temperatura', 149.0000, 'ºC'),
	(82203, 110, '2015-03-01 00:15:06.000000', 'temperatura', 221.0000, 'ºC'),
	(82204, 110, '2015-03-01 00:15:07.000000', 'temperatura', 660.0000, 'ºC'),
	(82205, 110, '2015-03-01 00:15:08.000000', 'temperatura', 234.0000, 'ºC'),
	(82206, 110, '2015-03-01 00:15:09.000000', 'temperatura', 394.0000, 'ºC'),
	(82207, 110, '2015-03-01 00:15:10.000000', 'temperatura', 66.0000, 'ºC'),
	(82208, 110, '2015-03-01 00:15:11.000000', 'temperatura', 348.0000, 'ºC'),
	(82209, 110, '2015-03-01 00:15:12.000000', 'temperatura', 341.0000, 'ºC'),
	(82210, 110, '2015-03-01 00:15:13.000000', 'temperatura', 665.0000, 'ºC'),
	(82211, 110, '2015-03-01 00:15:14.000000', 'temperatura', 1099.0000, 'ºC'),
	(82212, 110, '2015-03-01 00:15:15.000000', 'temperatura', 1103.0000, 'ºC'),
	(82213, 110, '2015-03-01 00:15:16.000000', 'temperatura', 1018.0000, 'ºC'),
	(82214, 110, '2015-03-01 00:15:17.000000', 'temperatura', 580.0000, 'ºC'),
	(82215, 110, '2015-03-01 00:15:18.000000', 'temperatura', 1046.0000, 'ºC'),
	(82216, 110, '2015-03-01 00:15:19.000000', 'temperatura', 1090.0000, 'ºC'),
	(82217, 110, '2015-03-01 00:15:20.000000', 'temperatura', 1115.0000, 'ºC'),
	(82218, 110, '2015-03-01 00:15:21.000000', 'temperatura', 1104.0000, 'ºC'),
	(82219, 110, '2015-03-01 00:15:22.000000', 'temperatura', 975.0000, 'ºC'),
	(82220, 110, '2015-03-01 00:15:23.000000', 'temperatura', 364.0000, 'ºC'),
	(82221, 110, '2015-03-01 00:15:24.000000', 'temperatura', 95.0000, 'ºC'),
	(82222, 110, '2015-03-01 00:15:25.000000', 'temperatura', 582.0000, 'ºC'),
	(82223, 110, '2015-03-01 00:15:26.000000', 'temperatura', 228.0000, 'ºC'),
	(82224, 110, '2015-03-01 00:15:27.000000', 'temperatura', 594.0000, 'ºC'),
	(82225, 110, '2015-03-01 00:15:28.000000', 'temperatura', 1086.0000, 'ºC'),
	(82226, 110, '2015-03-01 00:15:29.000000', 'temperatura', 50.0000, 'ºC'),
	(82227, 110, '2015-03-01 00:15:30.000000', 'temperatura', 594.0000, 'ºC'),
	(82228, 110, '2015-03-01 00:15:31.000000', 'temperatura', 417.0000, 'ºC'),
	(82229, 110, '2015-03-01 00:15:32.000000', 'temperatura', 306.0000, 'ºC'),
	(82230, 110, '2015-03-01 00:15:33.000000', 'temperatura', 280.0000, 'ºC'),
	(82231, 110, '2015-03-01 00:15:34.000000', 'temperatura', 480.0000, 'ºC'),
	(82232, 110, '2015-03-01 00:15:35.000000', 'temperatura', 362.0000, 'ºC'),
	(82233, 110, '2015-03-01 00:15:36.000000', 'temperatura', 369.0000, 'ºC'),
	(82234, 110, '2015-03-01 00:15:37.000000', 'temperatura', 762.0000, 'ºC'),
	(82235, 110, '2015-03-01 00:15:38.000000', 'temperatura', 303.0000, 'ºC'),
	(82236, 110, '2015-03-01 00:15:39.000000', 'temperatura', 429.0000, 'ºC'),
	(82237, 110, '2015-03-01 00:15:40.000000', 'temperatura', 37.0000, 'ºC'),
	(82238, 110, '2015-03-01 00:15:41.000000', 'temperatura', 100.0000, 'ºC'),
	(82239, 110, '2015-03-01 00:15:42.000000', 'temperatura', 389.0000, 'ºC'),
	(82240, 110, '2015-03-01 00:15:43.000000', 'temperatura', 443.0000, 'ºC'),
	(82241, 110, '2015-03-01 00:15:44.000000', 'temperatura', 1051.0000, 'ºC'),
	(82242, 110, '2015-03-01 00:15:45.000000', 'temperatura', 324.0000, 'ºC'),
	(82243, 110, '2015-03-01 00:15:46.000000', 'temperatura', 869.0000, 'ºC'),
	(82244, 110, '2015-03-01 00:15:47.000000', 'temperatura', 974.0000, 'ºC'),
	(82245, 110, '2015-03-01 00:15:48.000000', 'temperatura', 1065.0000, 'ºC'),
	(82246, 110, '2015-03-01 00:15:49.000000', 'temperatura', 1.0000, 'ºC'),
	(82247, 110, '2015-03-01 00:15:50.000000', 'temperatura', 409.0000, 'ºC'),
	(82248, 110, '2015-03-01 00:15:51.000000', 'temperatura', 846.0000, 'ºC'),
	(82249, 110, '2015-03-01 00:15:52.000000', 'temperatura', 603.0000, 'ºC'),
	(82250, 110, '2015-03-01 00:15:53.000000', 'temperatura', 478.0000, 'ºC'),
	(82251, 110, '2015-03-01 00:15:54.000000', 'temperatura', 579.0000, 'ºC'),
	(82252, 110, '2015-03-01 00:15:55.000000', 'temperatura', 264.0000, 'ºC'),
	(82253, 110, '2015-03-01 00:15:56.000000', 'temperatura', 782.0000, 'ºC'),
	(82254, 110, '2015-03-01 00:15:57.000000', 'temperatura', 719.0000, 'ºC'),
	(82255, 110, '2015-03-01 00:15:58.000000', 'temperatura', 50.0000, 'ºC'),
	(82256, 110, '2015-03-01 00:15:59.000000', 'temperatura', 491.0000, 'ºC'),
	(82257, 110, '2015-03-01 00:16:00.000000', 'temperatura', 1109.0000, 'ºC'),
	(82258, 110, '2015-03-01 00:16:01.000000', 'temperatura', 471.0000, 'ºC'),
	(82259, 110, '2015-03-01 00:16:02.000000', 'temperatura', 229.0000, 'ºC'),
	(82260, 110, '2015-03-01 00:16:03.000000', 'temperatura', 930.0000, 'ºC'),
	(82261, 110, '2015-03-01 00:16:04.000000', 'temperatura', 366.0000, 'ºC'),
	(82262, 110, '2015-03-01 00:16:05.000000', 'temperatura', 239.0000, 'ºC'),
	(82263, 110, '2015-03-01 00:16:06.000000', 'temperatura', 97.0000, 'ºC'),
	(82264, 110, '2015-03-01 00:16:07.000000', 'temperatura', 970.0000, 'ºC'),
	(82265, 110, '2015-03-01 00:16:08.000000', 'temperatura', 957.0000, 'ºC'),
	(82266, 110, '2015-03-01 00:16:09.000000', 'temperatura', 677.0000, 'ºC'),
	(82267, 110, '2015-03-01 00:16:10.000000', 'temperatura', 516.0000, 'ºC'),
	(82268, 110, '2015-03-01 00:16:11.000000', 'temperatura', 548.0000, 'ºC'),
	(82269, 110, '2015-03-01 00:16:12.000000', 'temperatura', 1191.0000, 'ºC'),
	(82270, 110, '2015-03-01 00:16:13.000000', 'temperatura', 714.0000, 'ºC'),
	(82271, 110, '2015-03-01 00:16:14.000000', 'temperatura', 1196.0000, 'ºC'),
	(82272, 110, '2015-03-01 00:16:15.000000', 'temperatura', 241.0000, 'ºC'),
	(82273, 110, '2015-03-01 00:16:16.000000', 'temperatura', 14.0000, 'ºC'),
	(82274, 110, '2015-03-01 00:16:17.000000', 'temperatura', 549.0000, 'ºC'),
	(82275, 110, '2015-03-01 00:16:18.000000', 'temperatura', 301.0000, 'ºC'),
	(82276, 110, '2015-03-01 00:16:19.000000', 'temperatura', 1062.0000, 'ºC'),
	(82277, 110, '2015-03-01 00:16:20.000000', 'temperatura', 807.0000, 'ºC'),
	(82278, 110, '2015-03-01 00:16:21.000000', 'temperatura', 850.0000, 'ºC'),
	(82279, 110, '2015-03-01 00:16:22.000000', 'temperatura', 631.0000, 'ºC'),
	(82280, 110, '2015-03-01 00:16:23.000000', 'temperatura', 603.0000, 'ºC'),
	(82281, 110, '2015-03-01 00:16:24.000000', 'temperatura', 1125.0000, 'ºC'),
	(82282, 110, '2015-03-01 00:16:25.000000', 'temperatura', 216.0000, 'ºC'),
	(82283, 110, '2015-03-01 00:16:26.000000', 'temperatura', 104.0000, 'ºC'),
	(82284, 110, '2015-03-01 00:16:27.000000', 'temperatura', 1073.0000, 'ºC'),
	(82285, 110, '2015-03-01 00:16:28.000000', 'temperatura', 255.0000, 'ºC'),
	(82286, 110, '2015-03-01 00:16:29.000000', 'temperatura', 457.0000, 'ºC'),
	(82287, 110, '2015-03-01 00:16:30.000000', 'temperatura', 320.0000, 'ºC'),
	(82288, 110, '2015-03-01 00:16:31.000000', 'temperatura', 230.0000, 'ºC'),
	(82289, 110, '2015-03-01 00:16:32.000000', 'temperatura', 189.0000, 'ºC'),
	(82290, 110, '2015-03-01 00:16:33.000000', 'temperatura', 256.0000, 'ºC'),
	(82291, 110, '2015-03-01 00:16:34.000000', 'temperatura', 712.0000, 'ºC'),
	(82292, 110, '2015-03-01 00:16:35.000000', 'temperatura', 396.0000, 'ºC'),
	(82293, 110, '2015-03-01 00:16:36.000000', 'temperatura', 1041.0000, 'ºC'),
	(82294, 110, '2015-03-01 00:16:37.000000', 'temperatura', 420.0000, 'ºC'),
	(82295, 110, '2015-03-01 00:16:38.000000', 'temperatura', 175.0000, 'ºC'),
	(82296, 110, '2015-03-01 00:16:39.000000', 'temperatura', 817.0000, 'ºC'),
	(82297, 110, '2015-03-01 00:16:40.000000', 'temperatura', 1161.0000, 'ºC'),
	(82298, 110, '2015-03-01 00:16:41.000000', 'temperatura', 956.0000, 'ºC'),
	(82299, 110, '2015-03-01 00:16:42.000000', 'temperatura', 95.0000, 'ºC'),
	(82300, 110, '2015-03-01 00:16:43.000000', 'temperatura', 9.0000, 'ºC'),
	(82301, 110, '2015-03-01 00:16:44.000000', 'temperatura', 961.0000, 'ºC'),
	(82302, 110, '2015-03-01 00:16:45.000000', 'temperatura', 1176.0000, 'ºC'),
	(82303, 110, '2015-03-01 00:16:46.000000', 'temperatura', 598.0000, 'ºC'),
	(82304, 110, '2015-03-01 00:16:47.000000', 'temperatura', 664.0000, 'ºC'),
	(82305, 110, '2015-03-01 00:16:48.000000', 'temperatura', 324.0000, 'ºC'),
	(82306, 110, '2015-03-01 00:16:49.000000', 'temperatura', 831.0000, 'ºC'),
	(82307, 110, '2015-03-01 00:16:50.000000', 'temperatura', 782.0000, 'ºC'),
	(82308, 110, '2015-03-01 00:16:51.000000', 'temperatura', 216.0000, 'ºC'),
	(82309, 110, '2015-03-01 00:16:52.000000', 'temperatura', 1135.0000, 'ºC'),
	(82310, 110, '2015-03-01 00:16:53.000000', 'temperatura', 229.0000, 'ºC'),
	(82311, 110, '2015-03-01 00:16:54.000000', 'temperatura', 138.0000, 'ºC'),
	(82312, 110, '2015-03-01 00:16:55.000000', 'temperatura', 4.0000, 'ºC'),
	(82313, 110, '2015-03-01 00:16:56.000000', 'temperatura', 808.0000, 'ºC'),
	(82314, 110, '2015-03-01 00:16:57.000000', 'temperatura', 430.0000, 'ºC'),
	(82315, 110, '2015-03-01 00:16:58.000000', 'temperatura', 924.0000, 'ºC'),
	(82316, 110, '2015-03-01 00:16:59.000000', 'temperatura', 932.0000, 'ºC'),
	(82317, 110, '2015-03-01 00:17:00.000000', 'temperatura', 689.0000, 'ºC'),
	(82318, 110, '2015-03-01 00:17:01.000000', 'temperatura', 650.0000, 'ºC'),
	(82319, 110, '2015-03-01 00:17:02.000000', 'temperatura', 1181.0000, 'ºC'),
	(82320, 110, '2015-03-01 00:17:03.000000', 'temperatura', 357.0000, 'ºC'),
	(82321, 110, '2015-03-01 00:17:04.000000', 'temperatura', 640.0000, 'ºC'),
	(82322, 110, '2015-03-01 00:17:05.000000', 'temperatura', 932.0000, 'ºC'),
	(82323, 110, '2015-03-01 00:17:06.000000', 'temperatura', 339.0000, 'ºC'),
	(82324, 110, '2015-03-01 00:17:07.000000', 'temperatura', 101.0000, 'ºC'),
	(82325, 110, '2015-03-01 00:17:08.000000', 'temperatura', 687.0000, 'ºC'),
	(82326, 110, '2015-03-01 00:17:09.000000', 'temperatura', 731.0000, 'ºC'),
	(82327, 110, '2015-03-01 00:17:10.000000', 'temperatura', 396.0000, 'ºC'),
	(82328, 110, '2015-03-01 00:17:11.000000', 'temperatura', 989.0000, 'ºC'),
	(82329, 110, '2015-03-01 00:17:12.000000', 'temperatura', 157.0000, 'ºC'),
	(82330, 110, '2015-03-01 00:17:13.000000', 'temperatura', 219.0000, 'ºC'),
	(82331, 110, '2015-03-01 00:17:14.000000', 'temperatura', 622.0000, 'ºC'),
	(82332, 110, '2015-03-01 00:17:15.000000', 'temperatura', 57.0000, 'ºC'),
	(82333, 110, '2015-03-01 00:17:16.000000', 'temperatura', 816.0000, 'ºC'),
	(82334, 110, '2015-03-01 00:17:17.000000', 'temperatura', 312.0000, 'ºC'),
	(82335, 110, '2015-03-01 00:17:18.000000', 'temperatura', 313.0000, 'ºC'),
	(82336, 110, '2015-03-01 00:17:19.000000', 'temperatura', 627.0000, 'ºC'),
	(82337, 110, '2015-03-01 00:17:20.000000', 'temperatura', 996.0000, 'ºC'),
	(82338, 110, '2015-03-01 00:17:21.000000', 'temperatura', 701.0000, 'ºC'),
	(82339, 110, '2015-03-01 00:17:22.000000', 'temperatura', 517.0000, 'ºC'),
	(82340, 110, '2015-03-01 00:17:23.000000', 'temperatura', 484.0000, 'ºC'),
	(82341, 110, '2015-03-01 00:17:24.000000', 'temperatura', 871.0000, 'ºC'),
	(82342, 110, '2015-03-01 00:17:25.000000', 'temperatura', 501.0000, 'ºC'),
	(82343, 110, '2015-03-01 00:17:26.000000', 'temperatura', 1091.0000, 'ºC'),
	(82344, 110, '2015-03-01 00:17:27.000000', 'temperatura', 354.0000, 'ºC'),
	(82345, 110, '2015-03-01 00:17:28.000000', 'temperatura', 898.0000, 'ºC'),
	(82346, 110, '2015-03-01 00:17:29.000000', 'temperatura', 1026.0000, 'ºC'),
	(82347, 110, '2015-03-01 00:17:30.000000', 'temperatura', 40.0000, 'ºC'),
	(82348, 110, '2015-03-01 00:17:31.000000', 'temperatura', 719.0000, 'ºC'),
	(82349, 110, '2015-03-01 00:17:32.000000', 'temperatura', 1078.0000, 'ºC'),
	(82350, 110, '2015-03-01 00:17:33.000000', 'temperatura', 834.0000, 'ºC'),
	(82351, 110, '2015-03-01 00:17:34.000000', 'temperatura', 938.0000, 'ºC'),
	(82352, 110, '2015-03-01 00:17:35.000000', 'temperatura', 985.0000, 'ºC'),
	(82353, 110, '2015-03-01 00:17:36.000000', 'temperatura', 913.0000, 'ºC'),
	(82354, 110, '2015-03-01 00:17:37.000000', 'temperatura', 412.0000, 'ºC'),
	(82355, 110, '2015-03-01 00:17:38.000000', 'temperatura', 520.0000, 'ºC'),
	(82356, 110, '2015-03-01 00:17:39.000000', 'temperatura', 166.0000, 'ºC'),
	(82357, 110, '2015-03-01 00:17:40.000000', 'temperatura', 469.0000, 'ºC'),
	(82358, 110, '2015-03-01 00:17:41.000000', 'temperatura', 647.0000, 'ºC'),
	(82359, 110, '2015-03-01 00:17:42.000000', 'temperatura', 631.0000, 'ºC'),
	(82360, 110, '2015-03-01 00:17:43.000000', 'temperatura', 13.0000, 'ºC'),
	(82361, 110, '2015-03-01 00:17:44.000000', 'temperatura', 571.0000, 'ºC'),
	(82362, 110, '2015-03-01 00:17:45.000000', 'temperatura', 420.0000, 'ºC'),
	(82363, 110, '2015-03-01 00:17:46.000000', 'temperatura', 384.0000, 'ºC'),
	(82364, 110, '2015-03-01 00:17:47.000000', 'temperatura', 663.0000, 'ºC'),
	(82365, 110, '2015-03-01 00:17:48.000000', 'temperatura', 964.0000, 'ºC'),
	(82366, 110, '2015-03-01 00:17:49.000000', 'temperatura', 430.0000, 'ºC'),
	(82367, 110, '2015-03-01 00:17:50.000000', 'temperatura', 457.0000, 'ºC'),
	(82368, 110, '2015-03-01 00:17:51.000000', 'temperatura', 996.0000, 'ºC'),
	(82369, 110, '2015-03-01 00:17:52.000000', 'temperatura', 10.0000, 'ºC'),
	(82370, 110, '2015-03-01 00:17:53.000000', 'temperatura', 661.0000, 'ºC'),
	(82371, 110, '2015-03-01 00:17:54.000000', 'temperatura', 875.0000, 'ºC'),
	(82372, 110, '2015-03-01 00:17:55.000000', 'temperatura', 1194.0000, 'ºC'),
	(82373, 110, '2015-03-01 00:17:56.000000', 'temperatura', 946.0000, 'ºC'),
	(82374, 110, '2015-03-01 00:17:57.000000', 'temperatura', 1147.0000, 'ºC'),
	(82375, 110, '2015-03-01 00:17:58.000000', 'temperatura', 500.0000, 'ºC'),
	(82376, 110, '2015-03-01 00:17:59.000000', 'temperatura', 258.0000, 'ºC'),
	(82377, 110, '2015-03-01 00:18:00.000000', 'temperatura', 990.0000, 'ºC'),
	(82378, 110, '2015-03-01 00:18:01.000000', 'temperatura', 575.0000, 'ºC'),
	(82379, 110, '2015-03-01 00:18:02.000000', 'temperatura', 1109.0000, 'ºC'),
	(82380, 110, '2015-03-01 00:18:03.000000', 'temperatura', 217.0000, 'ºC'),
	(82381, 110, '2015-03-01 00:18:04.000000', 'temperatura', 162.0000, 'ºC'),
	(82382, 110, '2015-03-01 00:18:05.000000', 'temperatura', 158.0000, 'ºC'),
	(82383, 110, '2015-03-01 00:18:06.000000', 'temperatura', 305.0000, 'ºC'),
	(82384, 110, '2015-03-01 00:18:07.000000', 'temperatura', 1050.0000, 'ºC'),
	(82385, 110, '2015-03-01 00:18:08.000000', 'temperatura', 735.0000, 'ºC'),
	(82386, 110, '2015-03-01 00:18:09.000000', 'temperatura', 525.0000, 'ºC'),
	(82387, 110, '2015-03-01 00:18:10.000000', 'temperatura', 422.0000, 'ºC'),
	(82388, 110, '2015-03-01 00:18:11.000000', 'temperatura', 536.0000, 'ºC'),
	(82389, 110, '2015-03-01 00:18:12.000000', 'temperatura', 215.0000, 'ºC'),
	(82390, 110, '2015-03-01 00:18:13.000000', 'temperatura', 668.0000, 'ºC'),
	(82391, 110, '2015-03-01 00:18:14.000000', 'temperatura', 294.0000, 'ºC'),
	(82392, 110, '2015-03-01 00:18:15.000000', 'temperatura', 667.0000, 'ºC'),
	(82393, 110, '2015-03-01 00:18:16.000000', 'temperatura', 55.0000, 'ºC'),
	(82394, 110, '2015-03-01 00:18:17.000000', 'temperatura', 672.0000, 'ºC'),
	(82395, 110, '2015-03-01 00:18:18.000000', 'temperatura', 796.0000, 'ºC'),
	(82396, 110, '2015-03-01 00:18:19.000000', 'temperatura', 764.0000, 'ºC'),
	(82397, 110, '2015-03-01 00:18:20.000000', 'temperatura', 233.0000, 'ºC'),
	(82398, 110, '2015-03-01 00:18:21.000000', 'temperatura', 74.0000, 'ºC'),
	(82399, 110, '2015-03-01 00:18:22.000000', 'temperatura', 872.0000, 'ºC'),
	(82400, 110, '2015-03-01 00:18:23.000000', 'temperatura', 537.0000, 'ºC'),
	(82401, 110, '2015-03-01 00:18:24.000000', 'temperatura', 69.0000, 'ºC'),
	(82402, 110, '2015-03-01 00:18:25.000000', 'temperatura', 1137.0000, 'ºC'),
	(82403, 110, '2015-03-01 00:18:26.000000', 'temperatura', 678.0000, 'ºC'),
	(82404, 110, '2015-03-01 00:18:27.000000', 'temperatura', 1178.0000, 'ºC'),
	(82405, 110, '2015-03-01 00:18:28.000000', 'temperatura', 257.0000, 'ºC'),
	(82406, 110, '2015-03-01 00:18:29.000000', 'temperatura', 150.0000, 'ºC'),
	(82407, 110, '2015-03-01 00:18:30.000000', 'temperatura', 1181.0000, 'ºC'),
	(82408, 110, '2015-03-01 00:18:31.000000', 'temperatura', 656.0000, 'ºC'),
	(82409, 110, '2015-03-01 00:18:32.000000', 'temperatura', 939.0000, 'ºC'),
	(82410, 110, '2015-03-01 00:18:33.000000', 'temperatura', 325.0000, 'ºC'),
	(82411, 110, '2015-03-01 00:18:34.000000', 'temperatura', 7.0000, 'ºC'),
	(82412, 110, '2015-03-01 00:18:35.000000', 'temperatura', 263.0000, 'ºC'),
	(82413, 110, '2015-03-01 00:18:36.000000', 'temperatura', 94.0000, 'ºC'),
	(82414, 110, '2015-03-01 00:18:37.000000', 'temperatura', 882.0000, 'ºC'),
	(82415, 110, '2015-03-01 00:18:38.000000', 'temperatura', 530.0000, 'ºC'),
	(82416, 110, '2015-03-01 00:18:39.000000', 'temperatura', 3.0000, 'ºC'),
	(82417, 110, '2015-03-01 00:18:40.000000', 'temperatura', 826.0000, 'ºC'),
	(82418, 110, '2015-03-01 00:18:41.000000', 'temperatura', 523.0000, 'ºC'),
	(82419, 110, '2015-03-01 00:18:42.000000', 'temperatura', 136.0000, 'ºC'),
	(82420, 110, '2015-03-01 00:18:43.000000', 'temperatura', 310.0000, 'ºC'),
	(82421, 110, '2015-03-01 00:18:44.000000', 'temperatura', 1143.0000, 'ºC'),
	(82422, 110, '2015-03-01 00:18:45.000000', 'temperatura', 1188.0000, 'ºC'),
	(82423, 110, '2015-03-01 00:18:46.000000', 'temperatura', 108.0000, 'ºC'),
	(82424, 110, '2015-03-01 00:18:47.000000', 'temperatura', 578.0000, 'ºC'),
	(82425, 110, '2015-03-01 00:18:48.000000', 'temperatura', 169.0000, 'ºC'),
	(82426, 110, '2015-03-01 00:18:49.000000', 'temperatura', 308.0000, 'ºC'),
	(82427, 110, '2015-03-01 00:18:50.000000', 'temperatura', 1033.0000, 'ºC'),
	(82428, 110, '2015-03-01 00:18:51.000000', 'temperatura', 644.0000, 'ºC'),
	(82429, 110, '2015-03-01 00:18:52.000000', 'temperatura', 122.0000, 'ºC'),
	(82430, 110, '2015-03-01 00:18:53.000000', 'temperatura', 1077.0000, 'ºC'),
	(82431, 110, '2015-03-01 00:18:54.000000', 'temperatura', 219.0000, 'ºC'),
	(82432, 110, '2015-03-01 00:18:55.000000', 'temperatura', 267.0000, 'ºC'),
	(82433, 110, '2015-03-01 00:18:56.000000', 'temperatura', 677.0000, 'ºC'),
	(82434, 110, '2015-03-01 00:18:57.000000', 'temperatura', 186.0000, 'ºC'),
	(82435, 110, '2015-03-01 00:18:58.000000', 'temperatura', 97.0000, 'ºC'),
	(82436, 110, '2015-03-01 00:18:59.000000', 'temperatura', 1129.0000, 'ºC'),
	(82437, 110, '2015-03-01 00:19:00.000000', 'temperatura', 553.0000, 'ºC'),
	(82438, 110, '2015-03-01 00:19:01.000000', 'temperatura', 581.0000, 'ºC'),
	(82439, 110, '2015-03-01 00:19:02.000000', 'temperatura', 46.0000, 'ºC'),
	(82440, 110, '2015-03-01 00:19:03.000000', 'temperatura', 885.0000, 'ºC'),
	(82441, 110, '2015-03-01 00:19:04.000000', 'temperatura', 690.0000, 'ºC'),
	(82442, 110, '2015-03-01 00:19:05.000000', 'temperatura', 793.0000, 'ºC'),
	(82443, 110, '2015-03-01 00:19:06.000000', 'temperatura', 699.0000, 'ºC'),
	(82444, 110, '2015-03-01 00:19:07.000000', 'temperatura', 1114.0000, 'ºC'),
	(82445, 110, '2015-03-01 00:19:08.000000', 'temperatura', 1073.0000, 'ºC'),
	(82446, 110, '2015-03-01 00:19:09.000000', 'temperatura', 826.0000, 'ºC'),
	(82447, 110, '2015-03-01 00:19:10.000000', 'temperatura', 912.0000, 'ºC'),
	(82448, 110, '2015-03-01 00:19:11.000000', 'temperatura', 882.0000, 'ºC'),
	(82449, 110, '2015-03-01 00:19:12.000000', 'temperatura', 472.0000, 'ºC'),
	(82450, 110, '2015-03-01 00:19:13.000000', 'temperatura', 918.0000, 'ºC'),
	(82451, 110, '2015-03-01 00:19:14.000000', 'temperatura', 772.0000, 'ºC'),
	(82452, 110, '2015-03-01 00:19:15.000000', 'temperatura', 1106.0000, 'ºC'),
	(82453, 110, '2015-03-01 00:19:16.000000', 'temperatura', 815.0000, 'ºC'),
	(82454, 110, '2015-03-01 00:19:17.000000', 'temperatura', 757.0000, 'ºC'),
	(82455, 110, '2015-03-01 00:19:18.000000', 'temperatura', 143.0000, 'ºC'),
	(82456, 110, '2015-03-01 00:19:19.000000', 'temperatura', 843.0000, 'ºC'),
	(82457, 110, '2015-03-01 00:19:20.000000', 'temperatura', 186.0000, 'ºC'),
	(82458, 110, '2015-03-01 00:19:21.000000', 'temperatura', 800.0000, 'ºC'),
	(82459, 110, '2015-03-01 00:19:22.000000', 'temperatura', 1044.0000, 'ºC'),
	(82460, 110, '2015-03-01 00:19:23.000000', 'temperatura', 421.0000, 'ºC'),
	(82461, 110, '2015-03-01 00:19:24.000000', 'temperatura', 172.0000, 'ºC'),
	(82462, 110, '2015-03-01 00:19:25.000000', 'temperatura', 800.0000, 'ºC'),
	(82463, 110, '2015-03-01 00:19:26.000000', 'temperatura', 1085.0000, 'ºC'),
	(82464, 110, '2015-03-01 00:19:27.000000', 'temperatura', 623.0000, 'ºC'),
	(82465, 110, '2015-03-01 00:19:28.000000', 'temperatura', 1063.0000, 'ºC'),
	(82466, 110, '2015-03-01 00:19:29.000000', 'temperatura', 1044.0000, 'ºC'),
	(82467, 110, '2015-03-01 00:19:30.000000', 'temperatura', 834.0000, 'ºC'),
	(82468, 110, '2015-03-01 00:19:31.000000', 'temperatura', 1039.0000, 'ºC'),
	(82469, 110, '2015-03-01 00:19:32.000000', 'temperatura', 292.0000, 'ºC'),
	(82470, 110, '2015-03-01 00:19:33.000000', 'temperatura', 745.0000, 'ºC'),
	(82471, 110, '2015-03-01 00:19:34.000000', 'temperatura', 447.0000, 'ºC'),
	(82472, 110, '2015-03-01 00:19:35.000000', 'temperatura', 4.0000, 'ºC'),
	(82473, 110, '2015-03-01 00:19:36.000000', 'temperatura', 1077.0000, 'ºC'),
	(82474, 110, '2015-03-01 00:19:37.000000', 'temperatura', 573.0000, 'ºC'),
	(82475, 110, '2015-03-01 00:19:38.000000', 'temperatura', 836.0000, 'ºC'),
	(82476, 110, '2015-03-01 00:19:39.000000', 'temperatura', 62.0000, 'ºC'),
	(82477, 110, '2015-03-01 00:19:40.000000', 'temperatura', 202.0000, 'ºC'),
	(82478, 110, '2015-03-01 00:19:41.000000', 'temperatura', 824.0000, 'ºC'),
	(82479, 110, '2015-03-01 00:19:42.000000', 'temperatura', 1114.0000, 'ºC'),
	(82480, 110, '2015-03-01 00:19:43.000000', 'temperatura', 701.0000, 'ºC'),
	(82481, 110, '2015-03-01 00:19:44.000000', 'temperatura', 160.0000, 'ºC'),
	(82482, 110, '2015-03-01 00:19:45.000000', 'temperatura', 1099.0000, 'ºC'),
	(82483, 110, '2015-03-01 00:19:46.000000', 'temperatura', 215.0000, 'ºC'),
	(82484, 110, '2015-03-01 00:19:47.000000', 'temperatura', 181.0000, 'ºC'),
	(82485, 110, '2015-03-01 00:19:48.000000', 'temperatura', 258.0000, 'ºC'),
	(82486, 110, '2015-03-01 00:19:49.000000', 'temperatura', 749.0000, 'ºC'),
	(82487, 110, '2015-03-01 00:19:50.000000', 'temperatura', 573.0000, 'ºC'),
	(82488, 110, '2015-03-01 00:19:51.000000', 'temperatura', 616.0000, 'ºC'),
	(82489, 110, '2015-03-01 00:19:52.000000', 'temperatura', 161.0000, 'ºC'),
	(82490, 110, '2015-03-01 00:19:53.000000', 'temperatura', 160.0000, 'ºC'),
	(82491, 110, '2015-03-01 00:19:54.000000', 'temperatura', 318.0000, 'ºC'),
	(82492, 110, '2015-03-01 00:19:55.000000', 'temperatura', 1110.0000, 'ºC'),
	(82493, 110, '2015-03-01 00:19:56.000000', 'temperatura', 997.0000, 'ºC'),
	(82494, 110, '2015-03-01 00:19:57.000000', 'temperatura', 455.0000, 'ºC'),
	(82495, 110, '2015-03-01 00:19:58.000000', 'temperatura', 486.0000, 'ºC'),
	(82496, 110, '2015-03-01 00:19:59.000000', 'temperatura', 1064.0000, 'ºC'),
	(82497, 110, '2015-03-01 00:20:00.000000', 'temperatura', 263.0000, 'ºC'),
	(82498, 110, '2015-03-01 00:20:01.000000', 'temperatura', 523.0000, 'ºC'),
	(82499, 110, '2015-03-01 00:20:02.000000', 'temperatura', 627.0000, 'ºC'),
	(82500, 110, '2015-03-01 00:20:03.000000', 'temperatura', 368.0000, 'ºC'),
	(82501, 110, '2015-03-01 00:20:04.000000', 'temperatura', 1158.0000, 'ºC'),
	(82502, 110, '2015-03-01 00:20:05.000000', 'temperatura', 1088.0000, 'ºC'),
	(82503, 110, '2015-03-01 00:20:06.000000', 'temperatura', 765.0000, 'ºC'),
	(82504, 110, '2015-03-01 00:20:07.000000', 'temperatura', 560.0000, 'ºC'),
	(82505, 110, '2015-03-01 00:20:08.000000', 'temperatura', 508.0000, 'ºC'),
	(82506, 110, '2015-03-01 00:20:09.000000', 'temperatura', 860.0000, 'ºC'),
	(82507, 110, '2015-03-01 00:20:10.000000', 'temperatura', 376.0000, 'ºC'),
	(82508, 110, '2015-03-01 00:20:11.000000', 'temperatura', 500.0000, 'ºC'),
	(82509, 110, '2015-03-01 00:20:12.000000', 'temperatura', 171.0000, 'ºC'),
	(82510, 110, '2015-03-01 00:20:13.000000', 'temperatura', 557.0000, 'ºC'),
	(82511, 110, '2015-03-01 00:20:14.000000', 'temperatura', 1072.0000, 'ºC'),
	(82512, 110, '2015-03-01 00:20:15.000000', 'temperatura', 88.0000, 'ºC'),
	(82513, 110, '2015-03-01 00:20:16.000000', 'temperatura', 824.0000, 'ºC'),
	(82514, 110, '2015-03-01 00:20:17.000000', 'temperatura', 259.0000, 'ºC'),
	(82515, 110, '2015-03-01 00:20:18.000000', 'temperatura', 22.0000, 'ºC'),
	(82516, 110, '2015-03-01 00:20:19.000000', 'temperatura', 535.0000, 'ºC'),
	(82517, 110, '2015-03-01 00:20:20.000000', 'temperatura', 209.0000, 'ºC'),
	(82518, 110, '2015-03-01 00:20:21.000000', 'temperatura', 641.0000, 'ºC'),
	(82519, 110, '2015-03-01 00:20:22.000000', 'temperatura', 180.0000, 'ºC'),
	(82520, 110, '2015-03-01 00:20:23.000000', 'temperatura', 176.0000, 'ºC'),
	(82521, 110, '2015-03-01 00:20:24.000000', 'temperatura', 339.0000, 'ºC'),
	(82522, 110, '2015-03-01 00:20:25.000000', 'temperatura', 1167.0000, 'ºC'),
	(82523, 110, '2015-03-01 00:20:26.000000', 'temperatura', 21.0000, 'ºC'),
	(82524, 110, '2015-03-01 00:20:27.000000', 'temperatura', 202.0000, 'ºC'),
	(82525, 110, '2015-03-01 00:20:28.000000', 'temperatura', 947.0000, 'ºC'),
	(82526, 110, '2015-03-01 00:20:29.000000', 'temperatura', 530.0000, 'ºC'),
	(82527, 110, '2015-03-01 00:20:30.000000', 'temperatura', 1010.0000, 'ºC'),
	(82528, 110, '2015-03-01 00:20:31.000000', 'temperatura', 1061.0000, 'ºC'),
	(82529, 110, '2015-03-01 00:20:32.000000', 'temperatura', 1075.0000, 'ºC'),
	(82530, 110, '2015-03-01 00:20:33.000000', 'temperatura', 993.0000, 'ºC'),
	(82531, 110, '2015-03-01 00:20:34.000000', 'temperatura', 542.0000, 'ºC'),
	(82532, 110, '2015-03-01 00:20:35.000000', 'temperatura', 931.0000, 'ºC'),
	(82533, 110, '2015-03-01 00:20:36.000000', 'temperatura', 627.0000, 'ºC'),
	(82534, 110, '2015-03-01 00:20:37.000000', 'temperatura', 343.0000, 'ºC'),
	(82535, 110, '2015-03-01 00:20:38.000000', 'temperatura', 1036.0000, 'ºC'),
	(82536, 110, '2015-03-01 00:20:39.000000', 'temperatura', 550.0000, 'ºC'),
	(82537, 110, '2015-03-01 00:20:40.000000', 'temperatura', 845.0000, 'ºC'),
	(82538, 110, '2015-03-01 00:20:41.000000', 'temperatura', 173.0000, 'ºC'),
	(82539, 110, '2015-03-01 00:20:42.000000', 'temperatura', 730.0000, 'ºC'),
	(82540, 110, '2015-03-01 00:20:43.000000', 'temperatura', 731.0000, 'ºC'),
	(82541, 110, '2015-03-01 00:20:44.000000', 'temperatura', 265.0000, 'ºC'),
	(82542, 110, '2015-03-01 00:20:45.000000', 'temperatura', 333.0000, 'ºC'),
	(82543, 110, '2015-03-01 00:20:46.000000', 'temperatura', 870.0000, 'ºC'),
	(82544, 110, '2015-03-01 00:20:47.000000', 'temperatura', 952.0000, 'ºC'),
	(82545, 110, '2015-03-01 00:20:48.000000', 'temperatura', 952.0000, 'ºC'),
	(82546, 110, '2015-03-01 00:20:49.000000', 'temperatura', 704.0000, 'ºC'),
	(82547, 110, '2015-03-01 00:20:50.000000', 'temperatura', 663.0000, 'ºC'),
	(82548, 110, '2015-03-01 00:20:51.000000', 'temperatura', 3.0000, 'ºC'),
	(82549, 110, '2015-03-01 00:20:52.000000', 'temperatura', 428.0000, 'ºC'),
	(82550, 110, '2015-03-01 00:20:53.000000', 'temperatura', 933.0000, 'ºC'),
	(82551, 110, '2015-03-01 00:20:54.000000', 'temperatura', 979.0000, 'ºC'),
	(82552, 110, '2015-03-01 00:20:55.000000', 'temperatura', 896.0000, 'ºC'),
	(82553, 110, '2015-03-01 00:20:56.000000', 'temperatura', 343.0000, 'ºC'),
	(82554, 110, '2015-03-01 00:20:57.000000', 'temperatura', 229.0000, 'ºC'),
	(82555, 110, '2015-03-01 00:20:58.000000', 'temperatura', 117.0000, 'ºC'),
	(82556, 110, '2015-03-01 00:20:59.000000', 'temperatura', 1097.0000, 'ºC'),
	(82557, 110, '2015-03-01 00:21:00.000000', 'temperatura', 334.0000, 'ºC'),
	(82558, 110, '2015-03-01 00:21:01.000000', 'temperatura', 780.0000, 'ºC'),
	(82559, 110, '2015-03-01 00:21:02.000000', 'temperatura', 499.0000, 'ºC'),
	(82560, 110, '2015-03-01 00:21:03.000000', 'temperatura', 157.0000, 'ºC'),
	(82561, 110, '2015-03-01 00:21:04.000000', 'temperatura', 485.0000, 'ºC'),
	(82562, 110, '2015-03-01 00:21:05.000000', 'temperatura', 758.0000, 'ºC'),
	(82563, 110, '2015-03-01 00:21:06.000000', 'temperatura', 1134.0000, 'ºC'),
	(82564, 110, '2015-03-01 00:21:07.000000', 'temperatura', 997.0000, 'ºC'),
	(82565, 110, '2015-03-01 00:21:08.000000', 'temperatura', 384.0000, 'ºC'),
	(82566, 110, '2015-03-01 00:21:09.000000', 'temperatura', 131.0000, 'ºC'),
	(82567, 110, '2015-03-01 00:21:10.000000', 'temperatura', 702.0000, 'ºC'),
	(82568, 110, '2015-03-01 00:21:11.000000', 'temperatura', 716.0000, 'ºC'),
	(82569, 110, '2015-03-01 00:21:12.000000', 'temperatura', 276.0000, 'ºC'),
	(82570, 110, '2015-03-01 00:21:13.000000', 'temperatura', 434.0000, 'ºC'),
	(82571, 110, '2015-03-01 00:21:14.000000', 'temperatura', 142.0000, 'ºC'),
	(82572, 110, '2015-03-01 00:21:15.000000', 'temperatura', 606.0000, 'ºC'),
	(82573, 110, '2015-03-01 00:21:16.000000', 'temperatura', 207.0000, 'ºC'),
	(82574, 110, '2015-03-01 00:21:17.000000', 'temperatura', 416.0000, 'ºC'),
	(82575, 110, '2015-03-01 00:21:18.000000', 'temperatura', 259.0000, 'ºC'),
	(82576, 110, '2015-03-01 00:21:19.000000', 'temperatura', 47.0000, 'ºC'),
	(82577, 110, '2015-03-01 00:21:20.000000', 'temperatura', 658.0000, 'ºC'),
	(82578, 110, '2015-03-01 00:21:21.000000', 'temperatura', 752.0000, 'ºC'),
	(82579, 110, '2015-03-01 00:21:22.000000', 'temperatura', 586.0000, 'ºC'),
	(82580, 110, '2015-03-01 00:21:23.000000', 'temperatura', 673.0000, 'ºC'),
	(82581, 110, '2015-03-01 00:21:24.000000', 'temperatura', 407.0000, 'ºC'),
	(82582, 110, '2015-03-01 00:21:25.000000', 'temperatura', 17.0000, 'ºC'),
	(82583, 110, '2015-03-01 00:21:26.000000', 'temperatura', 65.0000, 'ºC'),
	(82584, 110, '2015-03-01 00:21:27.000000', 'temperatura', 275.0000, 'ºC'),
	(82585, 110, '2015-03-01 00:21:28.000000', 'temperatura', 1182.0000, 'ºC'),
	(82586, 110, '2015-03-01 00:21:29.000000', 'temperatura', 282.0000, 'ºC'),
	(82587, 110, '2015-03-01 00:21:30.000000', 'temperatura', 267.0000, 'ºC'),
	(82588, 110, '2015-03-01 00:21:31.000000', 'temperatura', 491.0000, 'ºC'),
	(82589, 110, '2015-03-01 00:21:32.000000', 'temperatura', 451.0000, 'ºC'),
	(82590, 110, '2015-03-01 00:21:33.000000', 'temperatura', 785.0000, 'ºC'),
	(82591, 110, '2015-03-01 00:21:34.000000', 'temperatura', 173.0000, 'ºC'),
	(82592, 110, '2015-03-01 00:21:35.000000', 'temperatura', 908.0000, 'ºC'),
	(82593, 110, '2015-03-01 00:21:36.000000', 'temperatura', 423.0000, 'ºC'),
	(82594, 110, '2015-03-01 00:21:37.000000', 'temperatura', 593.0000, 'ºC'),
	(82595, 110, '2015-03-01 00:21:38.000000', 'temperatura', 494.0000, 'ºC'),
	(82596, 110, '2015-03-01 00:21:39.000000', 'temperatura', 693.0000, 'ºC'),
	(82597, 110, '2015-03-01 00:21:40.000000', 'temperatura', 781.0000, 'ºC'),
	(82598, 110, '2015-03-01 00:21:41.000000', 'temperatura', 630.0000, 'ºC'),
	(82599, 110, '2015-03-01 00:21:42.000000', 'temperatura', 805.0000, 'ºC'),
	(82600, 110, '2015-03-01 00:21:43.000000', 'temperatura', 937.0000, 'ºC'),
	(82601, 110, '2015-03-01 00:21:44.000000', 'temperatura', 1068.0000, 'ºC'),
	(82602, 110, '2015-03-01 00:21:45.000000', 'temperatura', 131.0000, 'ºC'),
	(82603, 110, '2015-03-01 00:21:46.000000', 'temperatura', 1052.0000, 'ºC'),
	(82604, 110, '2015-03-01 00:21:47.000000', 'temperatura', 69.0000, 'ºC'),
	(82605, 110, '2015-03-01 00:21:48.000000', 'temperatura', 787.0000, 'ºC'),
	(82606, 110, '2015-03-01 00:21:49.000000', 'temperatura', 128.0000, 'ºC'),
	(82607, 110, '2015-03-01 00:21:50.000000', 'temperatura', 681.0000, 'ºC'),
	(82608, 110, '2015-03-01 00:21:51.000000', 'temperatura', 621.0000, 'ºC'),
	(82609, 110, '2015-03-01 00:21:52.000000', 'temperatura', 1064.0000, 'ºC'),
	(82610, 110, '2015-03-01 00:21:53.000000', 'temperatura', 1058.0000, 'ºC'),
	(82611, 110, '2015-03-01 00:21:54.000000', 'temperatura', 899.0000, 'ºC'),
	(82612, 110, '2015-03-01 00:21:55.000000', 'temperatura', 121.0000, 'ºC'),
	(82613, 110, '2015-03-01 00:21:56.000000', 'temperatura', 307.0000, 'ºC'),
	(82614, 110, '2015-03-01 00:21:57.000000', 'temperatura', 1173.0000, 'ºC'),
	(82615, 110, '2015-03-01 00:21:58.000000', 'temperatura', 144.0000, 'ºC'),
	(82616, 110, '2015-03-01 00:21:59.000000', 'temperatura', 802.0000, 'ºC'),
	(82617, 110, '2015-03-01 00:22:00.000000', 'temperatura', 1179.0000, 'ºC'),
	(82618, 110, '2015-03-01 00:22:01.000000', 'temperatura', 1090.0000, 'ºC'),
	(82619, 110, '2015-03-01 00:22:02.000000', 'temperatura', 715.0000, 'ºC'),
	(82620, 110, '2015-03-01 00:22:03.000000', 'temperatura', 302.0000, 'ºC'),
	(82621, 110, '2015-03-01 00:22:04.000000', 'temperatura', 568.0000, 'ºC'),
	(82622, 110, '2015-03-01 00:22:05.000000', 'temperatura', 734.0000, 'ºC'),
	(82623, 110, '2015-03-01 00:22:06.000000', 'temperatura', 767.0000, 'ºC'),
	(82624, 110, '2015-03-01 00:22:07.000000', 'temperatura', 433.0000, 'ºC'),
	(82625, 110, '2015-03-01 00:22:08.000000', 'temperatura', 1065.0000, 'ºC'),
	(82626, 110, '2015-03-01 00:22:09.000000', 'temperatura', 425.0000, 'ºC'),
	(82627, 110, '2015-03-01 00:22:10.000000', 'temperatura', 131.0000, 'ºC'),
	(82628, 110, '2015-03-01 00:22:11.000000', 'temperatura', 582.0000, 'ºC'),
	(82629, 110, '2015-03-01 00:22:12.000000', 'temperatura', 117.0000, 'ºC'),
	(82630, 110, '2015-03-01 00:22:13.000000', 'temperatura', 38.0000, 'ºC'),
	(82631, 110, '2015-03-01 00:22:14.000000', 'temperatura', 1039.0000, 'ºC'),
	(82632, 110, '2015-03-01 00:22:15.000000', 'temperatura', 281.0000, 'ºC'),
	(82633, 110, '2015-03-01 00:22:16.000000', 'temperatura', 691.0000, 'ºC'),
	(82634, 110, '2015-03-01 00:22:17.000000', 'temperatura', 212.0000, 'ºC'),
	(82635, 110, '2015-03-01 00:22:18.000000', 'temperatura', 186.0000, 'ºC'),
	(82636, 110, '2015-03-01 00:22:19.000000', 'temperatura', 296.0000, 'ºC'),
	(82637, 110, '2015-03-01 00:22:20.000000', 'temperatura', 923.0000, 'ºC'),
	(82638, 110, '2015-03-01 00:22:21.000000', 'temperatura', 128.0000, 'ºC'),
	(82639, 110, '2015-03-01 00:22:22.000000', 'temperatura', 269.0000, 'ºC'),
	(82640, 110, '2015-03-01 00:22:23.000000', 'temperatura', 965.0000, 'ºC'),
	(82641, 110, '2015-03-01 00:22:24.000000', 'temperatura', 415.0000, 'ºC'),
	(82642, 110, '2015-03-01 00:22:25.000000', 'temperatura', 382.0000, 'ºC'),
	(82643, 110, '2015-03-01 00:22:26.000000', 'temperatura', 663.0000, 'ºC'),
	(82644, 110, '2015-03-01 00:22:27.000000', 'temperatura', 973.0000, 'ºC'),
	(82645, 110, '2015-03-01 00:22:28.000000', 'temperatura', 474.0000, 'ºC'),
	(82646, 110, '2015-03-01 00:22:29.000000', 'temperatura', 652.0000, 'ºC'),
	(82647, 110, '2015-03-01 00:22:30.000000', 'temperatura', 641.0000, 'ºC'),
	(82648, 110, '2015-03-01 00:22:31.000000', 'temperatura', 46.0000, 'ºC'),
	(82649, 110, '2015-03-01 00:22:32.000000', 'temperatura', 709.0000, 'ºC'),
	(82650, 110, '2015-03-01 00:22:33.000000', 'temperatura', 1005.0000, 'ºC'),
	(82651, 110, '2015-03-01 00:22:34.000000', 'temperatura', 502.0000, 'ºC'),
	(82652, 110, '2015-03-01 00:22:35.000000', 'temperatura', 694.0000, 'ºC'),
	(82653, 110, '2015-03-01 00:22:36.000000', 'temperatura', 764.0000, 'ºC'),
	(82654, 110, '2015-03-01 00:22:37.000000', 'temperatura', 537.0000, 'ºC'),
	(82655, 110, '2015-03-01 00:22:38.000000', 'temperatura', 395.0000, 'ºC'),
	(82656, 110, '2015-03-01 00:22:39.000000', 'temperatura', 366.0000, 'ºC'),
	(82657, 110, '2015-03-01 00:22:40.000000', 'temperatura', 643.0000, 'ºC'),
	(82658, 110, '2015-03-01 00:22:41.000000', 'temperatura', 919.0000, 'ºC'),
	(82659, 110, '2015-03-01 00:22:42.000000', 'temperatura', 265.0000, 'ºC'),
	(82660, 110, '2015-03-01 00:22:43.000000', 'temperatura', 968.0000, 'ºC'),
	(82661, 110, '2015-03-01 00:22:44.000000', 'temperatura', 447.0000, 'ºC'),
	(82662, 110, '2015-03-01 00:22:45.000000', 'temperatura', 530.0000, 'ºC'),
	(82663, 110, '2015-03-01 00:22:46.000000', 'temperatura', 109.0000, 'ºC'),
	(82664, 110, '2015-03-01 00:22:47.000000', 'temperatura', 156.0000, 'ºC'),
	(82665, 110, '2015-03-01 00:22:48.000000', 'temperatura', 452.0000, 'ºC'),
	(82666, 110, '2015-03-01 00:22:49.000000', 'temperatura', 594.0000, 'ºC'),
	(82667, 110, '2015-03-01 00:22:50.000000', 'temperatura', 416.0000, 'ºC'),
	(82668, 110, '2015-03-01 00:22:51.000000', 'temperatura', 295.0000, 'ºC'),
	(82669, 110, '2015-03-01 00:22:52.000000', 'temperatura', 230.0000, 'ºC'),
	(82670, 110, '2015-03-01 00:22:53.000000', 'temperatura', 266.0000, 'ºC'),
	(82671, 110, '2015-03-01 00:22:54.000000', 'temperatura', 641.0000, 'ºC'),
	(82672, 110, '2015-03-01 00:22:55.000000', 'temperatura', 5.0000, 'ºC'),
	(82673, 110, '2015-03-01 00:22:56.000000', 'temperatura', 505.0000, 'ºC'),
	(82674, 110, '2015-03-01 00:22:57.000000', 'temperatura', 112.0000, 'ºC'),
	(82675, 110, '2015-03-01 00:22:58.000000', 'temperatura', 242.0000, 'ºC'),
	(82676, 110, '2015-03-01 00:22:59.000000', 'temperatura', 877.0000, 'ºC'),
	(82677, 110, '2015-03-01 00:23:00.000000', 'temperatura', 61.0000, 'ºC'),
	(82678, 110, '2015-03-01 00:23:01.000000', 'temperatura', 72.0000, 'ºC'),
	(82679, 110, '2015-03-01 00:23:02.000000', 'temperatura', 177.0000, 'ºC'),
	(82680, 110, '2015-03-01 00:23:03.000000', 'temperatura', 672.0000, 'ºC'),
	(82681, 110, '2015-03-01 00:23:04.000000', 'temperatura', 430.0000, 'ºC'),
	(82682, 110, '2015-03-01 00:23:05.000000', 'temperatura', 131.0000, 'ºC'),
	(82683, 110, '2015-03-01 00:23:06.000000', 'temperatura', 569.0000, 'ºC'),
	(82684, 110, '2015-03-01 00:23:07.000000', 'temperatura', 50.0000, 'ºC'),
	(82685, 110, '2015-03-01 00:23:08.000000', 'temperatura', 945.0000, 'ºC'),
	(82686, 110, '2015-03-01 00:23:09.000000', 'temperatura', 976.0000, 'ºC'),
	(82687, 110, '2015-03-01 00:23:10.000000', 'temperatura', 845.0000, 'ºC'),
	(82688, 110, '2015-03-01 00:23:11.000000', 'temperatura', 99.0000, 'ºC'),
	(82689, 110, '2015-03-01 00:23:12.000000', 'temperatura', 360.0000, 'ºC'),
	(82690, 110, '2015-03-01 00:23:13.000000', 'temperatura', 302.0000, 'ºC'),
	(82691, 110, '2015-03-01 00:23:14.000000', 'temperatura', 433.0000, 'ºC'),
	(82692, 110, '2015-03-01 00:23:15.000000', 'temperatura', 58.0000, 'ºC'),
	(82693, 110, '2015-03-01 00:23:16.000000', 'temperatura', 194.0000, 'ºC'),
	(82694, 110, '2015-03-01 00:23:17.000000', 'temperatura', 794.0000, 'ºC'),
	(82695, 110, '2015-03-01 00:23:18.000000', 'temperatura', 990.0000, 'ºC'),
	(82696, 110, '2015-03-01 00:23:19.000000', 'temperatura', 166.0000, 'ºC'),
	(82697, 110, '2015-03-01 00:23:20.000000', 'temperatura', 263.0000, 'ºC'),
	(82698, 110, '2015-03-01 00:23:21.000000', 'temperatura', 818.0000, 'ºC'),
	(82699, 110, '2015-03-01 00:23:22.000000', 'temperatura', 901.0000, 'ºC'),
	(82700, 110, '2015-03-01 00:23:23.000000', 'temperatura', 852.0000, 'ºC'),
	(82701, 110, '2015-03-01 00:23:24.000000', 'temperatura', 356.0000, 'ºC'),
	(82702, 110, '2015-03-01 00:23:25.000000', 'temperatura', 426.0000, 'ºC'),
	(82703, 110, '2015-03-01 00:23:26.000000', 'temperatura', 1063.0000, 'ºC'),
	(82704, 110, '2015-03-01 00:23:27.000000', 'temperatura', 436.0000, 'ºC'),
	(82705, 110, '2015-03-01 00:23:28.000000', 'temperatura', 193.0000, 'ºC'),
	(82706, 110, '2015-03-01 00:23:29.000000', 'temperatura', 859.0000, 'ºC'),
	(82707, 110, '2015-03-01 00:23:30.000000', 'temperatura', 114.0000, 'ºC'),
	(82708, 110, '2015-03-01 00:23:31.000000', 'temperatura', 395.0000, 'ºC'),
	(82709, 110, '2015-03-01 00:23:32.000000', 'temperatura', 433.0000, 'ºC'),
	(82710, 110, '2015-03-01 00:23:33.000000', 'temperatura', 979.0000, 'ºC'),
	(82711, 110, '2015-03-01 00:23:34.000000', 'temperatura', 1199.0000, 'ºC'),
	(82712, 110, '2015-03-01 00:23:35.000000', 'temperatura', 656.0000, 'ºC'),
	(82713, 110, '2015-03-01 00:23:36.000000', 'temperatura', 883.0000, 'ºC'),
	(82714, 110, '2015-03-01 00:23:37.000000', 'temperatura', 47.0000, 'ºC'),
	(82715, 110, '2015-03-01 00:23:38.000000', 'temperatura', 1189.0000, 'ºC'),
	(82716, 110, '2015-03-01 00:23:39.000000', 'temperatura', 1004.0000, 'ºC'),
	(82717, 110, '2015-03-01 00:23:40.000000', 'temperatura', 255.0000, 'ºC'),
	(82718, 110, '2015-03-01 00:23:41.000000', 'temperatura', 661.0000, 'ºC'),
	(82719, 110, '2015-03-01 00:23:42.000000', 'temperatura', 142.0000, 'ºC'),
	(82720, 110, '2015-03-01 00:23:43.000000', 'temperatura', 1125.0000, 'ºC'),
	(82721, 110, '2015-03-01 00:23:44.000000', 'temperatura', 403.0000, 'ºC'),
	(82722, 110, '2015-03-01 00:23:45.000000', 'temperatura', 1039.0000, 'ºC'),
	(82723, 110, '2015-03-01 00:23:46.000000', 'temperatura', 386.0000, 'ºC'),
	(82724, 110, '2015-03-01 00:23:47.000000', 'temperatura', 14.0000, 'ºC'),
	(82725, 110, '2015-03-01 00:23:48.000000', 'temperatura', 112.0000, 'ºC'),
	(82726, 110, '2015-03-01 00:23:49.000000', 'temperatura', 521.0000, 'ºC'),
	(82727, 110, '2015-03-01 00:23:50.000000', 'temperatura', 1066.0000, 'ºC'),
	(82728, 110, '2015-03-01 00:23:51.000000', 'temperatura', 169.0000, 'ºC'),
	(82729, 110, '2015-03-01 00:23:52.000000', 'temperatura', 47.0000, 'ºC'),
	(82730, 110, '2015-03-01 00:23:53.000000', 'temperatura', 928.0000, 'ºC'),
	(82731, 110, '2015-03-01 00:23:54.000000', 'temperatura', 898.0000, 'ºC'),
	(82732, 110, '2015-03-01 00:23:55.000000', 'temperatura', 509.0000, 'ºC'),
	(82733, 110, '2015-03-01 00:23:56.000000', 'temperatura', 1051.0000, 'ºC'),
	(82734, 110, '2015-03-01 00:23:57.000000', 'temperatura', 127.0000, 'ºC'),
	(82735, 110, '2015-03-01 00:23:58.000000', 'temperatura', 1084.0000, 'ºC'),
	(82736, 110, '2015-03-01 00:23:59.000000', 'temperatura', 239.0000, 'ºC'),
	(82737, 110, '2015-03-01 00:24:00.000000', 'temperatura', 342.0000, 'ºC'),
	(82738, 110, '2015-03-01 00:24:01.000000', 'temperatura', 994.0000, 'ºC'),
	(82739, 110, '2015-03-01 00:24:02.000000', 'temperatura', 346.0000, 'ºC'),
	(82740, 110, '2015-03-01 00:24:03.000000', 'temperatura', 1146.0000, 'ºC'),
	(82741, 110, '2015-03-01 00:24:04.000000', 'temperatura', 1094.0000, 'ºC'),
	(82742, 110, '2015-03-01 00:24:05.000000', 'temperatura', 831.0000, 'ºC'),
	(82743, 110, '2015-03-01 00:24:06.000000', 'temperatura', 876.0000, 'ºC'),
	(82744, 110, '2015-03-01 00:24:07.000000', 'temperatura', 687.0000, 'ºC'),
	(82745, 110, '2015-03-01 00:24:08.000000', 'temperatura', 809.0000, 'ºC'),
	(82746, 110, '2015-03-01 00:24:09.000000', 'temperatura', 784.0000, 'ºC'),
	(82747, 110, '2015-03-01 00:24:10.000000', 'temperatura', 292.0000, 'ºC'),
	(82748, 110, '2015-03-01 00:24:11.000000', 'temperatura', 307.0000, 'ºC'),
	(82749, 110, '2015-03-01 00:24:12.000000', 'temperatura', 661.0000, 'ºC'),
	(82750, 110, '2015-03-01 00:24:13.000000', 'temperatura', 1186.0000, 'ºC'),
	(82751, 110, '2015-03-01 00:24:14.000000', 'temperatura', 348.0000, 'ºC'),
	(82752, 110, '2015-03-01 00:24:15.000000', 'temperatura', 580.0000, 'ºC'),
	(82753, 110, '2015-03-01 00:24:16.000000', 'temperatura', 657.0000, 'ºC'),
	(82754, 110, '2015-03-01 00:24:17.000000', 'temperatura', 345.0000, 'ºC'),
	(82755, 110, '2015-03-01 00:24:18.000000', 'temperatura', 956.0000, 'ºC'),
	(82756, 110, '2015-03-01 00:24:19.000000', 'temperatura', 146.0000, 'ºC'),
	(82757, 110, '2015-03-01 00:24:20.000000', 'temperatura', 260.0000, 'ºC'),
	(82758, 110, '2015-03-01 00:24:21.000000', 'temperatura', 864.0000, 'ºC'),
	(82759, 110, '2015-03-01 00:24:22.000000', 'temperatura', 1139.0000, 'ºC'),
	(82760, 110, '2015-03-01 00:24:23.000000', 'temperatura', 704.0000, 'ºC'),
	(82761, 110, '2015-03-01 00:24:24.000000', 'temperatura', 104.0000, 'ºC'),
	(82762, 110, '2015-03-01 00:24:25.000000', 'temperatura', 809.0000, 'ºC'),
	(82763, 110, '2015-03-01 00:24:26.000000', 'temperatura', 134.0000, 'ºC'),
	(82764, 110, '2015-03-01 00:24:27.000000', 'temperatura', 644.0000, 'ºC'),
	(82765, 110, '2015-03-01 00:24:28.000000', 'temperatura', 417.0000, 'ºC'),
	(82766, 110, '2015-03-01 00:24:29.000000', 'temperatura', 155.0000, 'ºC'),
	(82767, 110, '2015-03-01 00:24:30.000000', 'temperatura', 723.0000, 'ºC'),
	(82768, 110, '2015-03-01 00:24:31.000000', 'temperatura', 752.0000, 'ºC'),
	(82769, 110, '2015-03-01 00:24:32.000000', 'temperatura', 391.0000, 'ºC'),
	(82770, 110, '2015-03-01 00:24:33.000000', 'temperatura', 899.0000, 'ºC'),
	(82771, 110, '2015-03-01 00:24:34.000000', 'temperatura', 923.0000, 'ºC'),
	(82772, 110, '2015-03-01 00:24:35.000000', 'temperatura', 719.0000, 'ºC'),
	(82773, 110, '2015-03-01 00:24:36.000000', 'temperatura', 828.0000, 'ºC'),
	(82774, 110, '2015-03-01 00:24:37.000000', 'temperatura', 781.0000, 'ºC'),
	(82775, 110, '2015-03-01 00:24:38.000000', 'temperatura', 224.0000, 'ºC'),
	(82776, 110, '2015-03-01 00:24:39.000000', 'temperatura', 1174.0000, 'ºC'),
	(82777, 110, '2015-03-01 00:24:40.000000', 'temperatura', 401.0000, 'ºC'),
	(82778, 110, '2015-03-01 00:24:41.000000', 'temperatura', 884.0000, 'ºC'),
	(82779, 110, '2015-03-01 00:24:42.000000', 'temperatura', 819.0000, 'ºC'),
	(82780, 110, '2015-03-01 00:24:43.000000', 'temperatura', 240.0000, 'ºC'),
	(82781, 110, '2015-03-01 00:24:44.000000', 'temperatura', 1147.0000, 'ºC'),
	(82782, 110, '2015-03-01 00:24:45.000000', 'temperatura', 214.0000, 'ºC'),
	(82783, 110, '2015-03-01 00:24:46.000000', 'temperatura', 28.0000, 'ºC'),
	(82784, 110, '2015-03-01 00:24:47.000000', 'temperatura', 700.0000, 'ºC'),
	(82785, 110, '2015-03-01 00:24:48.000000', 'temperatura', 1018.0000, 'ºC'),
	(82786, 110, '2015-03-01 00:24:49.000000', 'temperatura', 590.0000, 'ºC'),
	(82787, 110, '2015-03-01 00:24:50.000000', 'temperatura', 1098.0000, 'ºC'),
	(82788, 110, '2015-03-01 00:24:51.000000', 'temperatura', 118.0000, 'ºC'),
	(82789, 110, '2015-03-01 00:24:52.000000', 'temperatura', 898.0000, 'ºC'),
	(82790, 110, '2015-03-01 00:24:53.000000', 'temperatura', 535.0000, 'ºC'),
	(82791, 110, '2015-03-01 00:24:54.000000', 'temperatura', 1183.0000, 'ºC'),
	(82792, 110, '2015-03-01 00:24:55.000000', 'temperatura', 710.0000, 'ºC'),
	(82793, 110, '2015-03-01 00:24:56.000000', 'temperatura', 3.0000, 'ºC'),
	(82794, 110, '2015-03-01 00:24:57.000000', 'temperatura', 284.0000, 'ºC'),
	(82795, 110, '2015-03-01 00:24:58.000000', 'temperatura', 214.0000, 'ºC'),
	(82796, 110, '2015-03-01 00:24:59.000000', 'temperatura', 216.0000, 'ºC'),
	(82797, 110, '2015-03-01 00:25:00.000000', 'temperatura', 438.0000, 'ºC'),
	(82798, 110, '2015-03-01 00:25:01.000000', 'temperatura', 345.0000, 'ºC'),
	(82799, 110, '2015-03-01 00:25:02.000000', 'temperatura', 411.0000, 'ºC'),
	(82800, 110, '2015-03-01 00:25:03.000000', 'temperatura', 1018.0000, 'ºC'),
	(82801, 110, '2015-03-01 00:25:04.000000', 'temperatura', 259.0000, 'ºC'),
	(82802, 110, '2015-03-01 00:25:05.000000', 'temperatura', 642.0000, 'ºC'),
	(82803, 110, '2015-03-01 00:25:06.000000', 'temperatura', 32.0000, 'ºC'),
	(82804, 110, '2015-03-01 00:25:07.000000', 'temperatura', 635.0000, 'ºC'),
	(82805, 110, '2015-03-01 00:25:08.000000', 'temperatura', 682.0000, 'ºC'),
	(82806, 110, '2015-03-01 00:25:09.000000', 'temperatura', 303.0000, 'ºC'),
	(82807, 110, '2015-03-01 00:25:10.000000', 'temperatura', 671.0000, 'ºC'),
	(82808, 110, '2015-03-01 00:25:11.000000', 'temperatura', 45.0000, 'ºC'),
	(82809, 110, '2015-03-01 00:25:12.000000', 'temperatura', 614.0000, 'ºC'),
	(82810, 110, '2015-03-01 00:25:13.000000', 'temperatura', 537.0000, 'ºC'),
	(82811, 110, '2015-03-01 00:25:14.000000', 'temperatura', 841.0000, 'ºC'),
	(82812, 110, '2015-03-01 00:25:15.000000', 'temperatura', 195.0000, 'ºC'),
	(82813, 110, '2015-03-01 00:25:16.000000', 'temperatura', 853.0000, 'ºC'),
	(82814, 110, '2015-03-01 00:25:17.000000', 'temperatura', 81.0000, 'ºC'),
	(82815, 110, '2015-03-01 00:25:18.000000', 'temperatura', 245.0000, 'ºC'),
	(82816, 110, '2015-03-01 00:25:19.000000', 'temperatura', 985.0000, 'ºC'),
	(82817, 110, '2015-03-01 00:25:20.000000', 'temperatura', 588.0000, 'ºC'),
	(82818, 110, '2015-03-01 00:25:21.000000', 'temperatura', 1185.0000, 'ºC'),
	(82819, 110, '2015-03-01 00:25:22.000000', 'temperatura', 564.0000, 'ºC'),
	(82820, 110, '2015-03-01 00:25:23.000000', 'temperatura', 464.0000, 'ºC'),
	(82821, 110, '2015-03-01 00:25:24.000000', 'temperatura', 628.0000, 'ºC'),
	(82822, 110, '2015-03-01 00:25:25.000000', 'temperatura', 551.0000, 'ºC'),
	(82823, 110, '2015-03-01 00:25:26.000000', 'temperatura', 870.0000, 'ºC'),
	(82824, 110, '2015-03-01 00:25:27.000000', 'temperatura', 298.0000, 'ºC'),
	(82825, 110, '2015-03-01 00:25:28.000000', 'temperatura', 82.0000, 'ºC'),
	(82826, 110, '2015-03-01 00:25:29.000000', 'temperatura', 715.0000, 'ºC'),
	(82827, 110, '2015-03-01 00:25:30.000000', 'temperatura', 928.0000, 'ºC'),
	(82828, 110, '2015-03-01 00:25:31.000000', 'temperatura', 97.0000, 'ºC'),
	(82829, 110, '2015-03-01 00:25:32.000000', 'temperatura', 100.0000, 'ºC'),
	(82830, 110, '2015-03-01 00:25:33.000000', 'temperatura', 211.0000, 'ºC'),
	(82831, 110, '2015-03-01 00:25:34.000000', 'temperatura', 757.0000, 'ºC'),
	(82832, 110, '2015-03-01 00:25:35.000000', 'temperatura', 749.0000, 'ºC'),
	(82833, 110, '2015-03-01 00:25:36.000000', 'temperatura', 277.0000, 'ºC'),
	(82834, 110, '2015-03-01 00:25:37.000000', 'temperatura', 338.0000, 'ºC'),
	(82835, 110, '2015-03-01 00:25:38.000000', 'temperatura', 858.0000, 'ºC'),
	(82836, 110, '2015-03-01 00:25:39.000000', 'temperatura', 879.0000, 'ºC'),
	(82837, 110, '2015-03-01 00:25:40.000000', 'temperatura', 620.0000, 'ºC'),
	(82838, 110, '2015-03-01 00:25:41.000000', 'temperatura', 462.0000, 'ºC'),
	(82839, 110, '2015-03-01 00:25:42.000000', 'temperatura', 452.0000, 'ºC'),
	(82840, 110, '2015-03-01 00:25:43.000000', 'temperatura', 876.0000, 'ºC'),
	(82841, 110, '2015-03-01 00:25:44.000000', 'temperatura', 625.0000, 'ºC'),
	(82842, 110, '2015-03-01 00:25:45.000000', 'temperatura', 494.0000, 'ºC'),
	(82843, 110, '2015-03-01 00:25:46.000000', 'temperatura', 599.0000, 'ºC'),
	(82844, 110, '2015-03-01 00:25:47.000000', 'temperatura', 313.0000, 'ºC'),
	(82845, 110, '2015-03-01 00:25:48.000000', 'temperatura', 966.0000, 'ºC'),
	(82846, 110, '2015-03-01 00:25:49.000000', 'temperatura', 293.0000, 'ºC'),
	(82847, 110, '2015-03-01 00:25:50.000000', 'temperatura', 967.0000, 'ºC'),
	(82848, 110, '2015-03-01 00:25:51.000000', 'temperatura', 357.0000, 'ºC'),
	(82849, 110, '2015-03-01 00:25:52.000000', 'temperatura', 85.0000, 'ºC'),
	(82850, 110, '2015-03-01 00:25:53.000000', 'temperatura', 555.0000, 'ºC'),
	(82851, 110, '2015-03-01 00:25:54.000000', 'temperatura', 118.0000, 'ºC'),
	(82852, 110, '2015-03-01 00:25:55.000000', 'temperatura', 125.0000, 'ºC'),
	(82853, 110, '2015-03-01 00:25:56.000000', 'temperatura', 275.0000, 'ºC'),
	(82854, 110, '2015-03-01 00:25:57.000000', 'temperatura', 998.0000, 'ºC'),
	(82855, 110, '2015-03-01 00:25:58.000000', 'temperatura', 565.0000, 'ºC'),
	(82856, 110, '2015-03-01 00:25:59.000000', 'temperatura', 1033.0000, 'ºC'),
	(82857, 110, '2015-03-01 00:26:00.000000', 'temperatura', 1070.0000, 'ºC'),
	(82858, 110, '2015-03-01 00:26:01.000000', 'temperatura', 1053.0000, 'ºC'),
	(82859, 110, '2015-03-01 00:26:02.000000', 'temperatura', 855.0000, 'ºC'),
	(82860, 110, '2015-03-01 00:26:03.000000', 'temperatura', 1118.0000, 'ºC'),
	(82861, 110, '2015-03-01 00:26:04.000000', 'temperatura', 625.0000, 'ºC'),
	(82862, 110, '2015-03-01 00:26:05.000000', 'temperatura', 971.0000, 'ºC'),
	(82863, 110, '2015-03-01 00:26:06.000000', 'temperatura', 579.0000, 'ºC'),
	(82864, 110, '2015-03-01 00:26:07.000000', 'temperatura', 1185.0000, 'ºC'),
	(82865, 110, '2015-03-01 00:26:08.000000', 'temperatura', 587.0000, 'ºC'),
	(82866, 110, '2015-03-01 00:26:09.000000', 'temperatura', 579.0000, 'ºC'),
	(82867, 110, '2015-03-01 00:26:10.000000', 'temperatura', 1136.0000, 'ºC'),
	(82868, 110, '2015-03-01 00:26:11.000000', 'temperatura', 344.0000, 'ºC'),
	(82869, 110, '2015-03-01 00:26:12.000000', 'temperatura', 712.0000, 'ºC'),
	(82870, 110, '2015-03-01 00:26:13.000000', 'temperatura', 128.0000, 'ºC'),
	(82871, 110, '2015-03-01 00:26:14.000000', 'temperatura', 904.0000, 'ºC'),
	(82872, 110, '2015-03-01 00:26:15.000000', 'temperatura', 536.0000, 'ºC'),
	(82873, 110, '2015-03-01 00:26:16.000000', 'temperatura', 1171.0000, 'ºC'),
	(82874, 110, '2015-03-01 00:26:17.000000', 'temperatura', 648.0000, 'ºC'),
	(82875, 110, '2015-03-01 00:26:18.000000', 'temperatura', 925.0000, 'ºC'),
	(82876, 110, '2015-03-01 00:26:19.000000', 'temperatura', 282.0000, 'ºC'),
	(82877, 110, '2015-03-01 00:26:20.000000', 'temperatura', 1034.0000, 'ºC'),
	(82878, 110, '2015-03-01 00:26:21.000000', 'temperatura', 726.0000, 'ºC'),
	(82879, 110, '2015-03-01 00:26:22.000000', 'temperatura', 526.0000, 'ºC'),
	(82880, 110, '2015-03-01 00:26:23.000000', 'temperatura', 456.0000, 'ºC'),
	(82881, 110, '2015-03-01 00:26:24.000000', 'temperatura', 700.0000, 'ºC'),
	(82882, 110, '2015-03-01 00:26:25.000000', 'temperatura', 933.0000, 'ºC'),
	(82883, 110, '2015-03-01 00:26:26.000000', 'temperatura', 164.0000, 'ºC'),
	(82884, 110, '2015-03-01 00:26:27.000000', 'temperatura', 423.0000, 'ºC'),
	(82885, 110, '2015-03-01 00:26:28.000000', 'temperatura', 425.0000, 'ºC'),
	(82886, 110, '2015-03-01 00:26:29.000000', 'temperatura', 856.0000, 'ºC'),
	(82887, 110, '2015-03-01 00:26:30.000000', 'temperatura', 606.0000, 'ºC'),
	(82888, 110, '2015-03-01 00:26:31.000000', 'temperatura', 464.0000, 'ºC'),
	(82889, 110, '2015-03-01 00:26:32.000000', 'temperatura', 499.0000, 'ºC'),
	(82890, 110, '2015-03-01 00:26:33.000000', 'temperatura', 1106.0000, 'ºC'),
	(82891, 110, '2015-03-01 00:26:34.000000', 'temperatura', 434.0000, 'ºC'),
	(82892, 110, '2015-03-01 00:26:35.000000', 'temperatura', 51.0000, 'ºC'),
	(82893, 110, '2015-03-01 00:26:36.000000', 'temperatura', 154.0000, 'ºC'),
	(82894, 110, '2015-03-01 00:26:37.000000', 'temperatura', 619.0000, 'ºC'),
	(82895, 110, '2015-03-01 00:26:38.000000', 'temperatura', 230.0000, 'ºC'),
	(82896, 110, '2015-03-01 00:26:39.000000', 'temperatura', 497.0000, 'ºC'),
	(82897, 110, '2015-03-01 00:26:40.000000', 'temperatura', 593.0000, 'ºC'),
	(82898, 110, '2015-03-01 00:26:41.000000', 'temperatura', 277.0000, 'ºC'),
	(82899, 110, '2015-03-01 00:26:42.000000', 'temperatura', 803.0000, 'ºC'),
	(82900, 110, '2015-03-01 00:26:43.000000', 'temperatura', 788.0000, 'ºC'),
	(82901, 110, '2015-03-01 00:26:44.000000', 'temperatura', 331.0000, 'ºC'),
	(82902, 110, '2015-03-01 00:26:45.000000', 'temperatura', 492.0000, 'ºC'),
	(82903, 110, '2015-03-01 00:26:46.000000', 'temperatura', 269.0000, 'ºC'),
	(82904, 110, '2015-03-01 00:26:47.000000', 'temperatura', 1067.0000, 'ºC'),
	(82905, 110, '2015-03-01 00:26:48.000000', 'temperatura', 930.0000, 'ºC'),
	(82906, 110, '2015-03-01 00:26:49.000000', 'temperatura', 247.0000, 'ºC'),
	(82907, 110, '2015-03-01 00:26:50.000000', 'temperatura', 849.0000, 'ºC'),
	(82908, 110, '2015-03-01 00:26:51.000000', 'temperatura', 1103.0000, 'ºC'),
	(82909, 110, '2015-03-01 00:26:52.000000', 'temperatura', 567.0000, 'ºC'),
	(82910, 110, '2015-03-01 00:26:53.000000', 'temperatura', 726.0000, 'ºC'),
	(82911, 110, '2015-03-01 00:26:54.000000', 'temperatura', 730.0000, 'ºC'),
	(82912, 110, '2015-03-01 00:26:55.000000', 'temperatura', 273.0000, 'ºC'),
	(82913, 110, '2015-03-01 00:26:56.000000', 'temperatura', 377.0000, 'ºC'),
	(82914, 110, '2015-03-01 00:26:57.000000', 'temperatura', 1067.0000, 'ºC'),
	(82915, 110, '2015-03-01 00:26:58.000000', 'temperatura', 602.0000, 'ºC'),
	(82916, 110, '2015-03-01 00:26:59.000000', 'temperatura', 1008.0000, 'ºC'),
	(82917, 110, '2015-03-01 00:27:00.000000', 'temperatura', 838.0000, 'ºC'),
	(82918, 110, '2015-03-01 00:27:01.000000', 'temperatura', 1164.0000, 'ºC'),
	(82919, 110, '2015-03-01 00:27:02.000000', 'temperatura', 906.0000, 'ºC'),
	(82920, 110, '2015-03-01 00:27:03.000000', 'temperatura', 1039.0000, 'ºC'),
	(82921, 110, '2015-03-01 00:27:04.000000', 'temperatura', 77.0000, 'ºC'),
	(82922, 110, '2015-03-01 00:27:05.000000', 'temperatura', 868.0000, 'ºC'),
	(82923, 110, '2015-03-01 00:27:06.000000', 'temperatura', 510.0000, 'ºC'),
	(82924, 110, '2015-03-01 00:27:07.000000', 'temperatura', 1145.0000, 'ºC'),
	(82925, 110, '2015-03-01 00:27:08.000000', 'temperatura', 597.0000, 'ºC'),
	(82926, 110, '2015-03-01 00:27:09.000000', 'temperatura', 752.0000, 'ºC'),
	(82927, 110, '2015-03-01 00:27:10.000000', 'temperatura', 770.0000, 'ºC'),
	(82928, 110, '2015-03-01 00:27:11.000000', 'temperatura', 393.0000, 'ºC'),
	(82929, 110, '2015-03-01 00:27:12.000000', 'temperatura', 855.0000, 'ºC'),
	(82930, 110, '2015-03-01 00:27:13.000000', 'temperatura', 697.0000, 'ºC'),
	(82931, 110, '2015-03-01 00:27:14.000000', 'temperatura', 921.0000, 'ºC'),
	(82932, 110, '2015-03-01 00:27:15.000000', 'temperatura', 114.0000, 'ºC'),
	(82933, 110, '2015-03-01 00:27:16.000000', 'temperatura', 208.0000, 'ºC'),
	(82934, 110, '2015-03-01 00:27:17.000000', 'temperatura', 700.0000, 'ºC'),
	(82935, 110, '2015-03-01 00:27:18.000000', 'temperatura', 474.0000, 'ºC'),
	(82936, 110, '2015-03-01 00:27:19.000000', 'temperatura', 271.0000, 'ºC'),
	(82937, 110, '2015-03-01 00:27:20.000000', 'temperatura', 1136.0000, 'ºC'),
	(82938, 110, '2015-03-01 00:27:21.000000', 'temperatura', 64.0000, 'ºC'),
	(82939, 110, '2015-03-01 00:27:22.000000', 'temperatura', 514.0000, 'ºC'),
	(82940, 110, '2015-03-01 00:27:23.000000', 'temperatura', 1178.0000, 'ºC'),
	(82941, 110, '2015-03-01 00:27:24.000000', 'temperatura', 751.0000, 'ºC'),
	(82942, 110, '2015-03-01 00:27:25.000000', 'temperatura', 219.0000, 'ºC'),
	(82943, 110, '2015-03-01 00:27:26.000000', 'temperatura', 42.0000, 'ºC'),
	(82944, 110, '2015-03-01 00:27:27.000000', 'temperatura', 753.0000, 'ºC'),
	(82945, 110, '2015-03-01 00:27:28.000000', 'temperatura', 39.0000, 'ºC'),
	(82946, 110, '2015-03-01 00:27:29.000000', 'temperatura', 339.0000, 'ºC'),
	(82947, 110, '2015-03-01 00:27:30.000000', 'temperatura', 376.0000, 'ºC'),
	(82948, 110, '2015-03-01 00:27:31.000000', 'temperatura', 864.0000, 'ºC'),
	(82949, 110, '2015-03-01 00:27:32.000000', 'temperatura', 792.0000, 'ºC'),
	(82950, 110, '2015-03-01 00:27:33.000000', 'temperatura', 170.0000, 'ºC'),
	(82951, 110, '2015-03-01 00:27:34.000000', 'temperatura', 874.0000, 'ºC'),
	(82952, 110, '2015-03-01 00:27:35.000000', 'temperatura', 261.0000, 'ºC'),
	(82953, 110, '2015-03-01 00:27:36.000000', 'temperatura', 1084.0000, 'ºC'),
	(82954, 110, '2015-03-01 00:27:37.000000', 'temperatura', 1035.0000, 'ºC'),
	(82955, 110, '2015-03-01 00:27:38.000000', 'temperatura', 724.0000, 'ºC'),
	(82956, 110, '2015-03-01 00:27:39.000000', 'temperatura', 518.0000, 'ºC'),
	(82957, 110, '2015-03-01 00:27:40.000000', 'temperatura', 416.0000, 'ºC'),
	(82958, 110, '2015-03-01 00:27:41.000000', 'temperatura', 526.0000, 'ºC'),
	(82959, 110, '2015-03-01 00:27:42.000000', 'temperatura', 184.0000, 'ºC'),
	(82960, 110, '2015-03-01 00:27:43.000000', 'temperatura', 542.0000, 'ºC'),
	(82961, 110, '2015-03-01 00:27:44.000000', 'temperatura', 957.0000, 'ºC'),
	(82962, 110, '2015-03-01 00:27:45.000000', 'temperatura', 761.0000, 'ºC'),
	(82963, 110, '2015-03-01 00:27:46.000000', 'temperatura', 935.0000, 'ºC'),
	(82964, 110, '2015-03-01 00:27:47.000000', 'temperatura', 1191.0000, 'ºC'),
	(82965, 110, '2015-03-01 00:27:48.000000', 'temperatura', 751.0000, 'ºC'),
	(82966, 110, '2015-03-01 00:27:49.000000', 'temperatura', 181.0000, 'ºC'),
	(82967, 110, '2015-03-01 00:27:50.000000', 'temperatura', 1056.0000, 'ºC'),
	(82968, 110, '2015-03-01 00:27:51.000000', 'temperatura', 1134.0000, 'ºC'),
	(82969, 110, '2015-03-01 00:27:52.000000', 'temperatura', 104.0000, 'ºC'),
	(82970, 110, '2015-03-01 00:27:53.000000', 'temperatura', 720.0000, 'ºC'),
	(82971, 110, '2015-03-01 00:27:54.000000', 'temperatura', 886.0000, 'ºC'),
	(82972, 110, '2015-03-01 00:27:55.000000', 'temperatura', 1072.0000, 'ºC'),
	(82973, 110, '2015-03-01 00:27:56.000000', 'temperatura', 301.0000, 'ºC'),
	(82974, 110, '2015-03-01 00:27:57.000000', 'temperatura', 691.0000, 'ºC'),
	(82975, 110, '2015-03-01 00:27:58.000000', 'temperatura', 154.0000, 'ºC'),
	(82976, 110, '2015-03-01 00:27:59.000000', 'temperatura', 1094.0000, 'ºC'),
	(82977, 110, '2015-03-01 00:28:00.000000', 'temperatura', 211.0000, 'ºC'),
	(82978, 110, '2015-03-01 00:28:01.000000', 'temperatura', 171.0000, 'ºC'),
	(82979, 110, '2015-03-01 00:28:02.000000', 'temperatura', 224.0000, 'ºC'),
	(82980, 110, '2015-03-01 00:28:03.000000', 'temperatura', 606.0000, 'ºC'),
	(82981, 110, '2015-03-01 00:28:04.000000', 'temperatura', 1158.0000, 'ºC'),
	(82982, 110, '2015-03-01 00:28:05.000000', 'temperatura', 373.0000, 'ºC'),
	(82983, 110, '2015-03-01 00:28:06.000000', 'temperatura', 793.0000, 'ºC'),
	(82984, 110, '2015-03-01 00:28:07.000000', 'temperatura', 446.0000, 'ºC'),
	(82985, 110, '2015-03-01 00:28:08.000000', 'temperatura', 1052.0000, 'ºC'),
	(82986, 110, '2015-03-01 00:28:09.000000', 'temperatura', 322.0000, 'ºC'),
	(82987, 110, '2015-03-01 00:28:10.000000', 'temperatura', 856.0000, 'ºC'),
	(82988, 110, '2015-03-01 00:28:11.000000', 'temperatura', 914.0000, 'ºC'),
	(82989, 110, '2015-03-01 00:28:12.000000', 'temperatura', 803.0000, 'ºC'),
	(82990, 110, '2015-03-01 00:28:13.000000', 'temperatura', 73.0000, 'ºC'),
	(82991, 110, '2015-03-01 00:28:14.000000', 'temperatura', 357.0000, 'ºC'),
	(82992, 110, '2015-03-01 00:28:15.000000', 'temperatura', 368.0000, 'ºC'),
	(82993, 110, '2015-03-01 00:28:16.000000', 'temperatura', 767.0000, 'ºC'),
	(82994, 110, '2015-03-01 00:28:17.000000', 'temperatura', 334.0000, 'ºC'),
	(82995, 110, '2015-03-01 00:28:18.000000', 'temperatura', 567.0000, 'ºC'),
	(82996, 110, '2015-03-01 00:28:19.000000', 'temperatura', 636.0000, 'ºC'),
	(82997, 110, '2015-03-01 00:28:20.000000', 'temperatura', 278.0000, 'ºC'),
	(82998, 110, '2015-03-01 00:28:21.000000', 'temperatura', 682.0000, 'ºC'),
	(82999, 110, '2015-03-01 00:28:22.000000', 'temperatura', 179.0000, 'ºC'),
	(83000, 110, '2015-03-01 00:28:23.000000', 'temperatura', 47.0000, 'ºC'),
	(83001, 110, '2015-03-01 00:28:24.000000', 'temperatura', 900.0000, 'ºC'),
	(83002, 110, '2015-03-01 00:28:25.000000', 'temperatura', 760.0000, 'ºC'),
	(83003, 110, '2015-03-01 00:28:26.000000', 'temperatura', 1100.0000, 'ºC'),
	(83004, 110, '2015-03-01 00:28:27.000000', 'temperatura', 821.0000, 'ºC'),
	(83005, 110, '2015-03-01 00:28:28.000000', 'temperatura', 806.0000, 'ºC'),
	(83006, 110, '2015-03-01 00:28:29.000000', 'temperatura', 367.0000, 'ºC'),
	(83007, 110, '2015-03-01 00:28:30.000000', 'temperatura', 619.0000, 'ºC'),
	(83008, 110, '2015-03-01 00:28:31.000000', 'temperatura', 795.0000, 'ºC'),
	(83009, 110, '2015-03-01 00:28:32.000000', 'temperatura', 918.0000, 'ºC'),
	(83010, 110, '2015-03-01 00:28:33.000000', 'temperatura', 1004.0000, 'ºC'),
	(83011, 110, '2015-03-01 00:28:34.000000', 'temperatura', 1067.0000, 'ºC'),
	(83012, 110, '2015-03-01 00:28:35.000000', 'temperatura', 1125.0000, 'ºC'),
	(83013, 110, '2015-03-01 00:28:36.000000', 'temperatura', 22.0000, 'ºC'),
	(83014, 110, '2015-03-01 00:28:37.000000', 'temperatura', 336.0000, 'ºC'),
	(83015, 110, '2015-03-01 00:28:38.000000', 'temperatura', 417.0000, 'ºC'),
	(83016, 110, '2015-03-01 00:28:39.000000', 'temperatura', 1076.0000, 'ºC'),
	(83017, 110, '2015-03-01 00:28:40.000000', 'temperatura', 531.0000, 'ºC'),
	(83018, 110, '2015-03-01 00:28:41.000000', 'temperatura', 626.0000, 'ºC'),
	(83019, 110, '2015-03-01 00:28:42.000000', 'temperatura', 338.0000, 'ºC'),
	(83020, 110, '2015-03-01 00:28:43.000000', 'temperatura', 1013.0000, 'ºC'),
	(83021, 110, '2015-03-01 00:28:44.000000', 'temperatura', 452.0000, 'ºC'),
	(83022, 110, '2015-03-01 00:28:45.000000', 'temperatura', 423.0000, 'ºC'),
	(83023, 110, '2015-03-01 00:28:46.000000', 'temperatura', 756.0000, 'ºC'),
	(83024, 110, '2015-03-01 00:28:47.000000', 'temperatura', 114.0000, 'ºC'),
	(83025, 110, '2015-03-01 00:28:48.000000', 'temperatura', 702.0000, 'ºC'),
	(83026, 110, '2015-03-01 00:28:49.000000', 'temperatura', 770.0000, 'ºC'),
	(83027, 110, '2015-03-01 00:28:50.000000', 'temperatura', 542.0000, 'ºC'),
	(83028, 110, '2015-03-01 00:28:51.000000', 'temperatura', 401.0000, 'ºC'),
	(83029, 110, '2015-03-01 00:28:52.000000', 'temperatura', 381.0000, 'ºC'),
	(83030, 110, '2015-03-01 00:28:53.000000', 'temperatura', 701.0000, 'ºC'),
	(83031, 110, '2015-03-01 00:28:54.000000', 'temperatura', 1162.0000, 'ºC'),
	(83032, 110, '2015-03-01 00:28:55.000000', 'temperatura', 106.0000, 'ºC'),
	(83033, 110, '2015-03-01 00:28:56.000000', 'temperatura', 647.0000, 'ºC'),
	(83034, 110, '2015-03-01 00:28:57.000000', 'temperatura', 517.0000, 'ºC'),
	(83035, 110, '2015-03-01 00:28:58.000000', 'temperatura', 645.0000, 'ºC'),
	(83036, 110, '2015-03-01 00:28:59.000000', 'temperatura', 475.0000, 'ºC'),
	(83037, 110, '2015-03-01 00:29:00.000000', 'temperatura', 440.0000, 'ºC'),
	(83038, 110, '2015-03-01 00:29:01.000000', 'temperatura', 774.0000, 'ºC'),
	(83039, 110, '2015-03-01 00:29:02.000000', 'temperatura', 151.0000, 'ºC'),
	(83040, 110, '2015-03-01 00:29:03.000000', 'temperatura', 833.0000, 'ºC'),
	(83041, 110, '2015-03-01 00:29:04.000000', 'temperatura', 115.0000, 'ºC'),
	(83042, 110, '2015-03-01 00:29:05.000000', 'temperatura', 473.0000, 'ºC'),
	(83043, 110, '2015-03-01 00:29:06.000000', 'temperatura', 823.0000, 'ºC'),
	(83044, 110, '2015-03-01 00:29:07.000000', 'temperatura', 295.0000, 'ºC'),
	(83045, 110, '2015-03-01 00:29:08.000000', 'temperatura', 206.0000, 'ºC'),
	(83046, 110, '2015-03-01 00:29:09.000000', 'temperatura', 147.0000, 'ºC'),
	(83047, 110, '2015-03-01 00:29:10.000000', 'temperatura', 119.0000, 'ºC'),
	(83048, 110, '2015-03-01 00:29:11.000000', 'temperatura', 151.0000, 'ºC'),
	(83049, 110, '2015-03-01 00:29:12.000000', 'temperatura', 400.0000, 'ºC'),
	(83050, 110, '2015-03-01 00:29:13.000000', 'temperatura', 349.0000, 'ºC'),
	(83051, 110, '2015-03-01 00:29:14.000000', 'temperatura', 546.0000, 'ºC'),
	(83052, 110, '2015-03-01 00:29:15.000000', 'temperatura', 484.0000, 'ºC'),
	(83053, 110, '2015-03-01 00:29:16.000000', 'temperatura', 782.0000, 'ºC'),
	(83054, 110, '2015-03-01 00:29:17.000000', 'temperatura', 57.0000, 'ºC'),
	(83055, 110, '2015-03-01 00:29:18.000000', 'temperatura', 339.0000, 'ºC'),
	(83056, 110, '2015-03-01 00:29:19.000000', 'temperatura', 324.0000, 'ºC'),
	(83057, 110, '2015-03-01 00:29:20.000000', 'temperatura', 604.0000, 'ºC'),
	(83058, 110, '2015-03-01 00:29:21.000000', 'temperatura', 849.0000, 'ºC'),
	(83059, 110, '2015-03-01 00:29:22.000000', 'temperatura', 35.0000, 'ºC'),
	(83060, 110, '2015-03-01 00:29:23.000000', 'temperatura', 28.0000, 'ºC'),
	(83061, 110, '2015-03-01 00:29:24.000000', 'temperatura', 36.0000, 'ºC'),
	(83062, 110, '2015-03-01 00:29:25.000000', 'temperatura', 95.0000, 'ºC'),
	(83063, 110, '2015-03-01 00:29:26.000000', 'temperatura', 367.0000, 'ºC'),
	(83064, 110, '2015-03-01 00:29:27.000000', 'temperatura', 353.0000, 'ºC'),
	(83065, 110, '2015-03-01 00:29:28.000000', 'temperatura', 664.0000, 'ºC'),
	(83066, 110, '2015-03-01 00:29:29.000000', 'temperatura', 1061.0000, 'ºC'),
	(83067, 110, '2015-03-01 00:29:30.000000', 'temperatura', 915.0000, 'ºC'),
	(83068, 110, '2015-03-01 00:29:31.000000', 'temperatura', 192.0000, 'ºC'),
	(83069, 110, '2015-03-01 00:29:32.000000', 'temperatura', 615.0000, 'ºC'),
	(83070, 110, '2015-03-01 00:29:33.000000', 'temperatura', 99.0000, 'ºC'),
	(83071, 110, '2015-03-01 00:29:34.000000', 'temperatura', 1052.0000, 'ºC'),
	(83072, 110, '2015-03-01 00:29:35.000000', 'temperatura', 164.0000, 'ºC'),
	(83073, 110, '2015-03-01 00:29:36.000000', 'temperatura', 62.0000, 'ºC'),
	(83074, 110, '2015-03-01 00:29:37.000000', 'temperatura', 1021.0000, 'ºC'),
	(83075, 110, '2015-03-01 00:29:38.000000', 'temperatura', 120.0000, 'ºC'),
	(83076, 110, '2015-03-01 00:29:39.000000', 'temperatura', 1135.0000, 'ºC'),
	(83077, 110, '2015-03-01 00:29:40.000000', 'temperatura', 516.0000, 'ºC'),
	(83078, 110, '2015-03-01 00:29:41.000000', 'temperatura', 374.0000, 'ºC'),
	(83079, 110, '2015-03-01 00:29:42.000000', 'temperatura', 325.0000, 'ºC'),
	(83080, 110, '2015-03-01 00:29:43.000000', 'temperatura', 504.0000, 'ºC'),
	(83081, 110, '2015-03-01 00:29:44.000000', 'temperatura', 343.0000, 'ºC'),
	(83082, 110, '2015-03-01 00:29:45.000000', 'temperatura', 203.0000, 'ºC'),
	(83083, 110, '2015-03-01 00:29:46.000000', 'temperatura', 1188.0000, 'ºC'),
	(83084, 110, '2015-03-01 00:29:47.000000', 'temperatura', 532.0000, 'ºC'),
	(83085, 110, '2015-03-01 00:29:48.000000', 'temperatura', 296.0000, 'ºC'),
	(83086, 110, '2015-03-01 00:29:49.000000', 'temperatura', 1084.0000, 'ºC'),
	(83087, 110, '2015-03-01 00:29:50.000000', 'temperatura', 932.0000, 'ºC'),
	(83088, 110, '2015-03-01 00:29:51.000000', 'temperatura', 210.0000, 'ºC'),
	(83089, 110, '2015-03-01 00:29:52.000000', 'temperatura', 654.0000, 'ºC'),
	(83090, 110, '2015-03-01 00:29:53.000000', 'temperatura', 239.0000, 'ºC'),
	(83091, 110, '2015-03-01 00:29:54.000000', 'temperatura', 434.0000, 'ºC'),
	(83092, 110, '2015-03-01 00:29:55.000000', 'temperatura', 254.0000, 'ºC'),
	(83093, 110, '2015-03-01 00:29:56.000000', 'temperatura', 1171.0000, 'ºC'),
	(83094, 110, '2015-03-01 00:29:57.000000', 'temperatura', 290.0000, 'ºC'),
	(83095, 110, '2015-03-01 00:29:58.000000', 'temperatura', 337.0000, 'ºC'),
	(83096, 110, '2015-03-01 00:29:59.000000', 'temperatura', 815.0000, 'ºC'),
	(83097, 110, '2015-03-01 00:30:00.000000', 'temperatura', 666.0000, 'ºC'),
	(83098, 110, '2015-03-01 00:30:01.000000', 'temperatura', 886.0000, 'ºC'),
	(83099, 110, '2015-03-01 00:30:02.000000', 'temperatura', 34.0000, 'ºC'),
	(83100, 110, '2015-03-01 00:30:03.000000', 'temperatura', 1111.0000, 'ºC'),
	(83101, 110, '2015-03-01 00:30:04.000000', 'temperatura', 654.0000, 'ºC'),
	(83102, 110, '2015-03-01 00:30:05.000000', 'temperatura', 1135.0000, 'ºC'),
	(83103, 110, '2015-03-01 00:30:06.000000', 'temperatura', 116.0000, 'ºC'),
	(83104, 110, '2015-03-01 00:30:07.000000', 'temperatura', 773.0000, 'ºC'),
	(83105, 110, '2015-03-01 00:30:08.000000', 'temperatura', 1118.0000, 'ºC'),
	(83106, 110, '2015-03-01 00:30:09.000000', 'temperatura', 871.0000, 'ºC'),
	(83107, 110, '2015-03-01 00:30:10.000000', 'temperatura', 1001.0000, 'ºC'),
	(83108, 110, '2015-03-01 00:30:11.000000', 'temperatura', 1195.0000, 'ºC'),
	(83109, 110, '2015-03-01 00:30:12.000000', 'temperatura', 572.0000, 'ºC'),
	(83110, 110, '2015-03-01 00:30:13.000000', 'temperatura', 476.0000, 'ºC'),
	(83111, 110, '2015-03-01 00:30:14.000000', 'temperatura', 665.0000, 'ºC'),
	(83112, 110, '2015-03-01 00:30:15.000000', 'temperatura', 697.0000, 'ºC'),
	(83113, 110, '2015-03-01 00:30:16.000000', 'temperatura', 290.0000, 'ºC'),
	(83114, 110, '2015-03-01 00:30:17.000000', 'temperatura', 562.0000, 'ºC'),
	(83115, 110, '2015-03-01 00:30:18.000000', 'temperatura', 737.0000, 'ºC'),
	(83116, 110, '2015-03-01 00:30:19.000000', 'temperatura', 801.0000, 'ºC'),
	(83117, 110, '2015-03-01 00:30:20.000000', 'temperatura', 594.0000, 'ºC'),
	(83118, 110, '2015-03-01 00:30:21.000000', 'temperatura', 567.0000, 'ºC'),
	(83119, 110, '2015-03-01 00:30:22.000000', 'temperatura', 1054.0000, 'ºC'),
	(83120, 110, '2015-03-01 00:30:23.000000', 'temperatura', 1170.0000, 'ºC'),
	(83121, 110, '2015-03-01 00:30:24.000000', 'temperatura', 290.0000, 'ºC'),
	(83122, 110, '2015-03-01 00:30:25.000000', 'temperatura', 338.0000, 'ºC'),
	(83123, 110, '2015-03-01 00:30:26.000000', 'temperatura', 820.0000, 'ºC'),
	(83124, 110, '2015-03-01 00:30:27.000000', 'temperatura', 687.0000, 'ºC'),
	(83125, 110, '2015-03-01 00:30:28.000000', 'temperatura', 976.0000, 'ºC'),
	(83126, 110, '2015-03-01 00:30:29.000000', 'temperatura', 418.0000, 'ºC'),
	(83127, 110, '2015-03-01 00:30:30.000000', 'temperatura', 365.0000, 'ºC'),
	(83128, 110, '2015-03-01 00:30:31.000000', 'temperatura', 569.0000, 'ºC'),
	(83129, 110, '2015-03-01 00:30:32.000000', 'temperatura', 553.0000, 'ºC'),
	(83130, 110, '2015-03-01 00:30:33.000000', 'temperatura', 1056.0000, 'ºC'),
	(83131, 110, '2015-03-01 00:30:34.000000', 'temperatura', 23.0000, 'ºC'),
	(83132, 110, '2015-03-01 00:30:35.000000', 'temperatura', 547.0000, 'ºC'),
	(83133, 110, '2015-03-01 00:30:36.000000', 'temperatura', 268.0000, 'ºC'),
	(83134, 110, '2015-03-01 00:30:37.000000', 'temperatura', 897.0000, 'ºC'),
	(83135, 110, '2015-03-01 00:30:38.000000', 'temperatura', 81.0000, 'ºC'),
	(83136, 110, '2015-03-01 00:30:39.000000', 'temperatura', 115.0000, 'ºC'),
	(83137, 110, '2015-03-01 00:30:40.000000', 'temperatura', 332.0000, 'ºC'),
	(83138, 110, '2015-03-01 00:30:41.000000', 'temperatura', 118.0000, 'ºC'),
	(83139, 110, '2015-03-01 00:30:42.000000', 'temperatura', 792.0000, 'ºC'),
	(83140, 110, '2015-03-01 00:30:43.000000', 'temperatura', 5.0000, 'ºC'),
	(83141, 110, '2015-03-01 00:30:44.000000', 'temperatura', 53.0000, 'ºC'),
	(83142, 110, '2015-03-01 00:30:45.000000', 'temperatura', 247.0000, 'ºC'),
	(83143, 110, '2015-03-01 00:30:46.000000', 'temperatura', 1079.0000, 'ºC'),
	(83144, 110, '2015-03-01 00:30:47.000000', 'temperatura', 1055.0000, 'ºC'),
	(83145, 110, '2015-03-01 00:30:48.000000', 'temperatura', 838.0000, 'ºC'),
	(83146, 110, '2015-03-01 00:30:49.000000', 'temperatura', 1026.0000, 'ºC'),
	(83147, 110, '2015-03-01 00:30:50.000000', 'temperatura', 217.0000, 'ºC'),
	(83148, 110, '2015-03-01 00:30:51.000000', 'temperatura', 406.0000, 'ºC'),
	(83149, 110, '2015-03-01 00:30:52.000000', 'temperatura', 179.0000, 'ºC'),
	(83150, 110, '2015-03-01 00:30:53.000000', 'temperatura', 877.0000, 'ºC'),
	(83151, 110, '2015-03-01 00:30:54.000000', 'temperatura', 248.0000, 'ºC'),
	(83152, 110, '2015-03-01 00:30:55.000000', 'temperatura', 1011.0000, 'ºC'),
	(83153, 110, '2015-03-01 00:30:56.000000', 'temperatura', 712.0000, 'ºC'),
	(83154, 110, '2015-03-01 00:30:57.000000', 'temperatura', 526.0000, 'ºC'),
	(83155, 110, '2015-03-01 00:30:58.000000', 'temperatura', 497.0000, 'ºC'),
	(83156, 110, '2015-03-01 00:30:59.000000', 'temperatura', 906.0000, 'ºC'),
	(83157, 110, '2015-03-01 00:31:00.000000', 'temperatura', 638.0000, 'ºC'),
	(83158, 110, '2015-03-01 00:31:01.000000', 'temperatura', 474.0000, 'ºC'),
	(83159, 110, '2015-03-01 00:31:02.000000', 'temperatura', 455.0000, 'ºC'),
	(83160, 110, '2015-03-01 00:31:03.000000', 'temperatura', 855.0000, 'ºC'),
	(83161, 110, '2015-03-01 00:31:04.000000', 'temperatura', 509.0000, 'ºC'),
	(83162, 110, '2015-03-01 00:31:05.000000', 'temperatura', 1179.0000, 'ºC'),
	(83163, 110, '2015-03-01 00:31:06.000000', 'temperatura', 771.0000, 'ºC'),
	(83164, 110, '2015-03-01 00:31:07.000000', 'temperatura', 316.0000, 'ºC'),
	(83165, 110, '2015-03-01 00:31:08.000000', 'temperatura', 469.0000, 'ºC'),
	(83166, 110, '2015-03-01 00:31:09.000000', 'temperatura', 199.0000, 'ºC'),
	(83167, 110, '2015-03-01 00:31:10.000000', 'temperatura', 787.0000, 'ºC'),
	(83168, 110, '2015-03-01 00:31:11.000000', 'temperatura', 940.0000, 'ºC'),
	(83169, 110, '2015-03-01 00:31:12.000000', 'temperatura', 1138.0000, 'ºC'),
	(83170, 110, '2015-03-01 00:31:13.000000', 'temperatura', 472.0000, 'ºC'),
	(83171, 110, '2015-03-01 00:31:14.000000', 'temperatura', 144.0000, 'ºC'),
	(83172, 110, '2015-03-01 00:31:15.000000', 'temperatura', 507.0000, 'ºC'),
	(83173, 110, '2015-03-01 00:31:16.000000', 'temperatura', 904.0000, 'ºC'),
	(83174, 110, '2015-03-01 00:31:17.000000', 'temperatura', 599.0000, 'ºC'),
	(83175, 110, '2015-03-01 00:31:18.000000', 'temperatura', 282.0000, 'ºC'),
	(83176, 110, '2015-03-01 00:31:19.000000', 'temperatura', 813.0000, 'ºC'),
	(83177, 110, '2015-03-01 00:31:20.000000', 'temperatura', 819.0000, 'ºC'),
	(83178, 110, '2015-03-01 00:31:21.000000', 'temperatura', 456.0000, 'ºC'),
	(83179, 110, '2015-03-01 00:31:22.000000', 'temperatura', 1026.0000, 'ºC'),
	(83180, 110, '2015-03-01 00:31:23.000000', 'temperatura', 161.0000, 'ºC'),
	(83181, 110, '2015-03-01 00:31:24.000000', 'temperatura', 129.0000, 'ºC'),
	(83182, 110, '2015-03-01 00:31:25.000000', 'temperatura', 163.0000, 'ºC'),
	(83183, 110, '2015-03-01 00:31:26.000000', 'temperatura', 429.0000, 'ºC'),
	(83184, 110, '2015-03-01 00:31:27.000000', 'temperatura', 457.0000, 'ºC'),
	(83185, 110, '2015-03-01 00:31:28.000000', 'temperatura', 995.0000, 'ºC'),
	(83186, 110, '2015-03-01 00:31:29.000000', 'temperatura', 8.0000, 'ºC'),
	(83187, 110, '2015-03-01 00:31:30.000000', 'temperatura', 653.0000, 'ºC'),
	(83188, 110, '2015-03-01 00:31:31.000000', 'temperatura', 843.0000, 'ºC'),
	(83189, 110, '2015-03-01 00:31:32.000000', 'temperatura', 1054.0000, 'ºC'),
	(83190, 110, '2015-03-01 00:31:33.000000', 'temperatura', 345.0000, 'ºC'),
	(83191, 110, '2015-03-01 00:31:34.000000', 'temperatura', 961.0000, 'ºC'),
	(83192, 110, '2015-03-01 00:31:35.000000', 'temperatura', 170.0000, 'ºC'),
	(83193, 110, '2015-03-01 00:31:36.000000', 'temperatura', 369.0000, 'ºC'),
	(83194, 110, '2015-03-01 00:31:37.000000', 'temperatura', 135.0000, 'ºC'),
	(83195, 110, '2015-03-01 00:31:38.000000', 'temperatura', 767.0000, 'ºC'),
	(83196, 110, '2015-03-01 00:31:39.000000', 'temperatura', 1033.0000, 'ºC'),
	(83197, 110, '2015-03-01 00:31:40.000000', 'temperatura', 463.0000, 'ºC'),
	(83198, 110, '2015-03-01 00:31:41.000000', 'temperatura', 415.0000, 'ºC'),
	(83199, 110, '2015-03-01 00:31:42.000000', 'temperatura', 687.0000, 'ºC'),
	(83200, 110, '2015-03-01 00:31:43.000000', 'temperatura', 993.0000, 'ºC'),
	(83201, 110, '2015-03-01 00:31:44.000000', 'temperatura', 503.0000, 'ºC'),
	(83202, 110, '2015-03-01 00:31:45.000000', 'temperatura', 735.0000, 'ºC'),
	(83203, 110, '2015-03-01 00:31:46.000000', 'temperatura', 968.0000, 'ºC'),
	(83204, 110, '2015-03-01 00:31:47.000000', 'temperatura', 237.0000, 'ºC'),
	(83205, 110, '2015-03-01 00:31:48.000000', 'temperatura', 681.0000, 'ºC'),
	(83206, 110, '2015-03-01 00:31:49.000000', 'temperatura', 293.0000, 'ºC'),
	(83207, 110, '2015-03-01 00:31:50.000000', 'temperatura', 623.0000, 'ºC'),
	(83208, 110, '2015-03-01 00:31:51.000000', 'temperatura', 1035.0000, 'ºC'),
	(83209, 110, '2015-03-01 00:31:52.000000', 'temperatura', 908.0000, 'ºC'),
	(83210, 110, '2015-03-01 00:31:53.000000', 'temperatura', 236.0000, 'ºC'),
	(83211, 110, '2015-03-01 00:31:54.000000', 'temperatura', 857.0000, 'ºC'),
	(83212, 110, '2015-03-01 00:31:55.000000', 'temperatura', 1177.0000, 'ºC'),
	(83213, 110, '2015-03-01 00:31:56.000000', 'temperatura', 914.0000, 'ºC'),
	(83214, 110, '2015-03-01 00:31:57.000000', 'temperatura', 1040.0000, 'ºC'),
	(83215, 110, '2015-03-01 00:31:58.000000', 'temperatura', 56.0000, 'ºC'),
	(83216, 110, '2015-03-01 00:31:59.000000', 'temperatura', 764.0000, 'ºC'),
	(83217, 110, '2015-03-01 00:32:00.000000', 'temperatura', 51.0000, 'ºC'),
	(83218, 110, '2015-03-01 00:32:01.000000', 'temperatura', 364.0000, 'ºC'),
	(83219, 110, '2015-03-01 00:32:02.000000', 'temperatura', 469.0000, 'ºC'),
	(83220, 110, '2015-03-01 00:32:03.000000', 'temperatura', 51.0000, 'ºC'),
	(83221, 110, '2015-03-01 00:32:04.000000', 'temperatura', 48.0000, 'ºC'),
	(83222, 110, '2015-03-01 00:32:05.000000', 'temperatura', 88.0000, 'ºC'),
	(83223, 110, '2015-03-01 00:32:06.000000', 'temperatura', 296.0000, 'ºC'),
	(83224, 110, '2015-03-01 00:32:07.000000', 'temperatura', 17.0000, 'ºC'),
	(83225, 110, '2015-03-01 00:32:08.000000', 'temperatura', 399.0000, 'ºC'),
	(83226, 110, '2015-03-01 00:32:09.000000', 'temperatura', 744.0000, 'ºC'),
	(83227, 110, '2015-03-01 00:32:10.000000', 'temperatura', 121.0000, 'ºC'),
	(83228, 110, '2015-03-01 00:32:11.000000', 'temperatura', 776.0000, 'ºC'),
	(83229, 110, '2015-03-01 00:32:12.000000', 'temperatura', 1116.0000, 'ºC'),
	(83230, 110, '2015-03-01 00:32:13.000000', 'temperatura', 853.0000, 'ºC'),
	(83231, 110, '2015-03-01 00:32:14.000000', 'temperatura', 918.0000, 'ºC'),
	(83232, 110, '2015-03-01 00:32:15.000000', 'temperatura', 829.0000, 'ºC'),
	(83233, 110, '2015-03-01 00:32:16.000000', 'temperatura', 194.0000, 'ºC'),
	(83234, 110, '2015-03-01 00:32:17.000000', 'temperatura', 883.0000, 'ºC'),
	(83235, 110, '2015-03-01 00:32:18.000000', 'temperatura', 233.0000, 'ºC'),
	(83236, 110, '2015-03-01 00:32:19.000000', 'temperatura', 915.0000, 'ºC'),
	(83237, 110, '2015-03-01 00:32:20.000000', 'temperatura', 278.0000, 'ºC'),
	(83238, 110, '2015-03-01 00:32:21.000000', 'temperatura', 1044.0000, 'ºC'),
	(83239, 110, '2015-03-01 00:32:22.000000', 'temperatura', 789.0000, 'ºC'),
	(83240, 110, '2015-03-01 00:32:23.000000', 'temperatura', 810.0000, 'ºC'),
	(83241, 110, '2015-03-01 00:32:24.000000', 'temperatura', 487.0000, 'ºC'),
	(83242, 110, '2015-03-01 00:32:25.000000', 'temperatura', 5.0000, 'ºC'),
	(83243, 110, '2015-03-01 00:32:26.000000', 'temperatura', 964.0000, 'ºC'),
	(83244, 110, '2015-03-01 00:32:27.000000', 'temperatura', 4.0000, 'ºC'),
	(83245, 110, '2015-03-01 00:32:28.000000', 'temperatura', 729.0000, 'ºC'),
	(83246, 110, '2015-03-01 00:32:29.000000', 'temperatura', 32.0000, 'ºC'),
	(83247, 110, '2015-03-01 00:32:30.000000', 'temperatura', 375.0000, 'ºC'),
	(83248, 110, '2015-03-01 00:32:31.000000', 'temperatura', 579.0000, 'ºC'),
	(83249, 110, '2015-03-01 00:32:32.000000', 'temperatura', 571.0000, 'ºC'),
	(83250, 110, '2015-03-01 00:32:33.000000', 'temperatura', 1117.0000, 'ºC'),
	(83251, 110, '2015-03-01 00:32:34.000000', 'temperatura', 273.0000, 'ºC'),
	(83252, 110, '2015-03-01 00:32:35.000000', 'temperatura', 416.0000, 'ºC'),
	(83253, 110, '2015-03-01 00:32:36.000000', 'temperatura', 59.0000, 'ºC'),
	(83254, 110, '2015-03-01 00:32:37.000000', 'temperatura', 249.0000, 'ºC'),
	(83255, 110, '2015-03-01 00:32:38.000000', 'temperatura', 1069.0000, 'ºC'),
	(83256, 110, '2015-03-01 00:32:39.000000', 'temperatura', 999.0000, 'ºC'),
	(83257, 110, '2015-03-01 00:32:40.000000', 'temperatura', 588.0000, 'ºC'),
	(83258, 110, '2015-03-01 00:32:41.000000', 'temperatura', 1145.0000, 'ºC'),
	(83259, 110, '2015-03-01 00:32:42.000000', 'temperatura', 361.0000, 'ºC'),
	(83260, 110, '2015-03-01 00:32:43.000000', 'temperatura', 768.0000, 'ºC'),
	(83261, 110, '2015-03-01 00:32:44.000000', 'temperatura', 360.0000, 'ºC'),
	(83262, 110, '2015-03-01 00:32:45.000000', 'temperatura', 697.0000, 'ºC'),
	(83263, 110, '2015-03-01 00:32:46.000000', 'temperatura', 5.0000, 'ºC'),
	(83264, 110, '2015-03-01 00:32:47.000000', 'temperatura', 335.0000, 'ºC'),
	(83265, 110, '2015-03-01 00:32:48.000000', 'temperatura', 461.0000, 'ºC'),
	(83266, 110, '2015-03-01 00:32:49.000000', 'temperatura', 100.0000, 'ºC'),
	(83267, 110, '2015-03-01 00:32:50.000000', 'temperatura', 318.0000, 'ºC'),
	(83268, 110, '2015-03-01 00:32:51.000000', 'temperatura', 89.0000, 'ºC'),
	(83269, 110, '2015-03-01 00:32:52.000000', 'temperatura', 694.0000, 'ºC'),
	(83270, 110, '2015-03-01 00:32:53.000000', 'temperatura', 801.0000, 'ºC'),
	(83271, 110, '2015-03-01 00:32:54.000000', 'temperatura', 726.0000, 'ºC'),
	(83272, 110, '2015-03-01 00:32:55.000000', 'temperatura', 28.0000, 'ºC'),
	(83273, 110, '2015-03-01 00:32:56.000000', 'temperatura', 362.0000, 'ºC'),
	(83274, 110, '2015-03-01 00:32:57.000000', 'temperatura', 525.0000, 'ºC'),
	(83275, 110, '2015-03-01 00:32:58.000000', 'temperatura', 341.0000, 'ºC'),
	(83276, 110, '2015-03-01 00:32:59.000000', 'temperatura', 128.0000, 'ºC'),
	(83277, 110, '2015-03-01 00:33:00.000000', 'temperatura', 819.0000, 'ºC'),
	(83278, 110, '2015-03-01 00:33:01.000000', 'temperatura', 111.0000, 'ºC'),
	(83279, 110, '2015-03-01 00:33:02.000000', 'temperatura', 499.0000, 'ºC'),
	(83280, 110, '2015-03-01 00:33:03.000000', 'temperatura', 963.0000, 'ºC'),
	(83281, 110, '2015-03-01 00:33:04.000000', 'temperatura', 916.0000, 'ºC'),
	(83282, 110, '2015-03-01 00:33:05.000000', 'temperatura', 495.0000, 'ºC'),
	(83283, 110, '2015-03-01 00:33:06.000000', 'temperatura', 925.0000, 'ºC'),
	(83284, 110, '2015-03-01 00:33:07.000000', 'temperatura', 743.0000, 'ºC'),
	(83285, 110, '2015-03-01 00:33:08.000000', 'temperatura', 941.0000, 'ºC'),
	(83286, 110, '2015-03-01 00:33:09.000000', 'temperatura', 74.0000, 'ºC'),
	(83287, 110, '2015-03-01 00:33:10.000000', 'temperatura', 1149.0000, 'ºC'),
	(83288, 110, '2015-03-01 00:33:11.000000', 'temperatura', 724.0000, 'ºC'),
	(83289, 110, '2015-03-01 00:33:12.000000', 'temperatura', 173.0000, 'ºC'),
	(83290, 110, '2015-03-01 00:33:13.000000', 'temperatura', 1092.0000, 'ºC'),
	(83291, 110, '2015-03-01 00:33:14.000000', 'temperatura', 140.0000, 'ºC'),
	(83292, 110, '2015-03-01 00:33:15.000000', 'temperatura', 1028.0000, 'ºC'),
	(83293, 110, '2015-03-01 00:33:16.000000', 'temperatura', 1121.0000, 'ºC'),
	(83294, 110, '2015-03-01 00:33:17.000000', 'temperatura', 119.0000, 'ºC'),
	(83295, 110, '2015-03-01 00:33:18.000000', 'temperatura', 832.0000, 'ºC'),
	(83296, 110, '2015-03-01 00:33:19.000000', 'temperatura', 202.0000, 'ºC'),
	(83297, 110, '2015-03-01 00:33:20.000000', 'temperatura', 918.0000, 'ºC'),
	(83298, 110, '2015-03-01 00:33:21.000000', 'temperatura', 382.0000, 'ºC'),
	(83299, 110, '2015-03-01 00:33:22.000000', 'temperatura', 356.0000, 'ºC'),
	(83300, 110, '2015-03-01 00:33:23.000000', 'temperatura', 638.0000, 'ºC'),
	(83301, 110, '2015-03-01 00:33:24.000000', 'temperatura', 919.0000, 'ºC'),
	(83302, 110, '2015-03-01 00:33:25.000000', 'temperatura', 282.0000, 'ºC'),
	(83303, 110, '2015-03-01 00:33:26.000000', 'temperatura', 1055.0000, 'ºC'),
	(83304, 110, '2015-03-01 00:33:27.000000', 'temperatura', 831.0000, 'ºC'),
	(83305, 110, '2015-03-01 00:33:28.000000', 'temperatura', 987.0000, 'ºC'),
	(83306, 110, '2015-03-01 00:33:29.000000', 'temperatura', 45.0000, 'ºC'),
	(83307, 110, '2015-03-01 00:33:30.000000', 'temperatura', 862.0000, 'ºC'),
	(83308, 110, '2015-03-01 00:33:31.000000', 'temperatura', 579.0000, 'ºC'),
	(83309, 110, '2015-03-01 00:33:32.000000', 'temperatura', 307.0000, 'ºC'),
	(83310, 110, '2015-03-01 00:33:33.000000', 'temperatura', 999.0000, 'ºC'),
	(83311, 110, '2015-03-01 00:33:34.000000', 'temperatura', 472.0000, 'ºC'),
	(83312, 110, '2015-03-01 00:33:35.000000', 'temperatura', 567.0000, 'ºC'),
	(83313, 110, '2015-03-01 00:33:36.000000', 'temperatura', 220.0000, 'ºC'),
	(83314, 110, '2015-03-01 00:33:37.000000', 'temperatura', 597.0000, 'ºC'),
	(83315, 110, '2015-03-01 00:33:38.000000', 'temperatura', 1127.0000, 'ºC'),
	(83316, 110, '2015-03-01 00:33:39.000000', 'temperatura', 245.0000, 'ºC'),
	(83317, 110, '2015-03-01 00:33:40.000000', 'temperatura', 242.0000, 'ºC'),
	(83318, 110, '2015-03-01 00:33:41.000000', 'temperatura', 477.0000, 'ºC'),
	(83319, 110, '2015-03-01 00:33:42.000000', 'temperatura', 457.0000, 'ºC'),
	(83320, 110, '2015-03-01 00:33:43.000000', 'temperatura', 858.0000, 'ºC'),
	(83321, 110, '2015-03-01 00:33:44.000000', 'temperatura', 518.0000, 'ºC'),
	(83322, 110, '2015-03-01 00:33:45.000000', 'temperatura', 19.0000, 'ºC'),
	(83323, 110, '2015-03-01 00:33:46.000000', 'temperatura', 939.0000, 'ºC'),
	(83324, 110, '2015-03-01 00:33:47.000000', 'temperatura', 1037.0000, 'ºC'),
	(83325, 110, '2015-03-01 00:33:48.000000', 'temperatura', 1170.0000, 'ºC'),
	(83326, 110, '2015-03-01 00:33:49.000000', 'temperatura', 342.0000, 'ºC'),
	(83327, 110, '2015-03-01 00:33:50.000000', 'temperatura', 597.0000, 'ºC'),
	(83328, 110, '2015-03-01 00:33:51.000000', 'temperatura', 761.0000, 'ºC'),
	(83329, 110, '2015-03-01 00:33:52.000000', 'temperatura', 814.0000, 'ºC'),
	(83330, 110, '2015-03-01 00:33:53.000000', 'temperatura', 589.0000, 'ºC'),
	(83331, 110, '2015-03-01 00:33:54.000000', 'temperatura', 503.0000, 'ºC'),
	(83332, 110, '2015-03-01 00:33:55.000000', 'temperatura', 746.0000, 'ºC'),
	(83333, 110, '2015-03-01 00:33:56.000000', 'temperatura', 1025.0000, 'ºC'),
	(83334, 110, '2015-03-01 00:33:57.000000', 'temperatura', 485.0000, 'ºC'),
	(83335, 110, '2015-03-01 00:33:58.000000', 'temperatura', 552.0000, 'ºC'),
	(83336, 110, '2015-03-01 00:33:59.000000', 'temperatura', 106.0000, 'ºC'),
	(83337, 110, '2015-03-01 00:34:00.000000', 'temperatura', 75.0000, 'ºC'),
	(83338, 110, '2015-03-01 00:34:01.000000', 'temperatura', 56.0000, 'ºC'),
	(83339, 110, '2015-03-01 00:34:02.000000', 'temperatura', 54.0000, 'ºC'),
	(83340, 110, '2015-03-01 00:34:03.000000', 'temperatura', 105.0000, 'ºC'),
	(83341, 110, '2015-03-01 00:34:04.000000', 'temperatura', 362.0000, 'ºC'),
	(83342, 110, '2015-03-01 00:34:05.000000', 'temperatura', 295.0000, 'ºC'),
	(83343, 110, '2015-03-01 00:34:06.000000', 'temperatura', 391.0000, 'ºC'),
	(83344, 110, '2015-03-01 00:34:07.000000', 'temperatura', 1069.0000, 'ºC'),
	(83345, 110, '2015-03-01 00:34:08.000000', 'temperatura', 574.0000, 'ºC'),
	(83346, 110, '2015-03-01 00:34:09.000000', 'temperatura', 862.0000, 'ºC'),
	(83347, 110, '2015-03-01 00:34:10.000000', 'temperatura', 187.0000, 'ºC'),
	(83348, 110, '2015-03-01 00:34:11.000000', 'temperatura', 752.0000, 'ºC'),
	(83349, 110, '2015-03-01 00:34:12.000000', 'temperatura', 798.0000, 'ºC'),
	(83350, 110, '2015-03-01 00:34:13.000000', 'temperatura', 536.0000, 'ºC'),
	(83351, 110, '2015-03-01 00:34:14.000000', 'temperatura', 284.0000, 'ºC'),
	(83352, 110, '2015-03-01 00:34:15.000000', 'temperatura', 1015.0000, 'ºC'),
	(83353, 110, '2015-03-01 00:34:16.000000', 'temperatura', 622.0000, 'ºC'),
	(83354, 110, '2015-03-01 00:34:17.000000', 'temperatura', 67.0000, 'ºC'),
	(83355, 110, '2015-03-01 00:34:18.000000', 'temperatura', 869.0000, 'ºC'),
	(83356, 110, '2015-03-01 00:34:19.000000', 'temperatura', 543.0000, 'ºC'),
	(83357, 110, '2015-03-01 00:34:20.000000', 'temperatura', 107.0000, 'ºC'),
	(83358, 110, '2015-03-01 00:34:21.000000', 'temperatura', 110.0000, 'ºC'),
	(83359, 110, '2015-03-01 00:34:22.000000', 'temperatura', 228.0000, 'ºC'),
	(83360, 110, '2015-03-01 00:34:23.000000', 'temperatura', 810.0000, 'ºC'),
	(83361, 110, '2015-03-01 00:34:24.000000', 'temperatura', 966.0000, 'ºC'),
	(83362, 110, '2015-03-01 00:34:25.000000', 'temperatura', 3.0000, 'ºC'),
	(83363, 110, '2015-03-01 00:34:26.000000', 'temperatura', 717.0000, 'ºC'),
	(83364, 110, '2015-03-01 00:34:27.000000', 'temperatura', 1176.0000, 'ºC'),
	(83365, 110, '2015-03-01 00:34:28.000000', 'temperatura', 130.0000, 'ºC'),
	(83366, 110, '2015-03-01 00:34:29.000000', 'temperatura', 724.0000, 'ºC'),
	(83367, 110, '2015-03-01 00:34:30.000000', 'temperatura', 828.0000, 'ºC'),
	(83368, 110, '2015-03-01 00:34:31.000000', 'temperatura', 771.0000, 'ºC'),
	(83369, 110, '2015-03-01 00:34:32.000000', 'temperatura', 169.0000, 'ºC'),
	(83370, 110, '2015-03-01 00:34:33.000000', 'temperatura', 933.0000, 'ºC'),
	(83371, 110, '2015-03-01 00:34:34.000000', 'temperatura', 557.0000, 'ºC'),
	(83372, 110, '2015-03-01 00:34:35.000000', 'temperatura', 1188.0000, 'ºC'),
	(83373, 110, '2015-03-01 00:34:36.000000', 'temperatura', 670.0000, 'ºC'),
	(83374, 110, '2015-03-01 00:34:37.000000', 'temperatura', 988.0000, 'ºC'),
	(83375, 110, '2015-03-01 00:34:38.000000', 'temperatura', 529.0000, 'ºC'),
	(83376, 110, '2015-03-01 00:34:39.000000', 'temperatura', 881.0000, 'ºC'),
	(83377, 110, '2015-03-01 00:34:40.000000', 'temperatura', 417.0000, 'ºC'),
	(83378, 110, '2015-03-01 00:34:41.000000', 'temperatura', 645.0000, 'ºC'),
	(83379, 110, '2015-03-01 00:34:42.000000', 'temperatura', 775.0000, 'ºC'),
	(83380, 110, '2015-03-01 00:34:43.000000', 'temperatura', 741.0000, 'ºC'),
	(83381, 110, '2015-03-01 00:34:44.000000', 'temperatura', 178.0000, 'ºC'),
	(83382, 110, '2015-03-01 00:34:45.000000', 'temperatura', 1068.0000, 'ºC'),
	(83383, 110, '2015-03-01 00:34:46.000000', 'temperatura', 8.0000, 'ºC'),
	(83384, 110, '2015-03-01 00:34:47.000000', 'temperatura', 434.0000, 'ºC'),
	(83385, 110, '2015-03-01 00:34:48.000000', 'temperatura', 948.0000, 'ºC'),
	(83386, 110, '2015-03-01 00:34:49.000000', 'temperatura', 1039.0000, 'ºC'),
	(83387, 110, '2015-03-01 00:34:50.000000', 'temperatura', 1149.0000, 'ºC'),
	(83388, 110, '2015-03-01 00:34:51.000000', 'temperatura', 232.0000, 'ºC'),
	(83389, 110, '2015-03-01 00:34:52.000000', 'temperatura', 110.0000, 'ºC'),
	(83390, 110, '2015-03-01 00:34:53.000000', 'temperatura', 1056.0000, 'ºC'),
	(83391, 110, '2015-03-01 00:34:54.000000', 'temperatura', 152.0000, 'ºC'),
	(83392, 110, '2015-03-01 00:34:55.000000', 'temperatura', 1193.0000, 'ºC'),
	(83393, 110, '2015-03-01 00:34:56.000000', 'temperatura', 707.0000, 'ºC'),
	(83394, 110, '2015-03-01 00:34:57.000000', 'temperatura', 1155.0000, 'ºC'),
	(83395, 110, '2015-03-01 00:34:58.000000', 'temperatura', 58.0000, 'ºC'),
	(83396, 110, '2015-03-01 00:34:59.000000', 'temperatura', 425.0000, 'ºC'),
	(83397, 110, '2015-03-01 00:35:00.000000', 'temperatura', 751.0000, 'ºC'),
	(83398, 110, '2015-03-01 00:35:01.000000', 'temperatura', 81.0000, 'ºC'),
	(83399, 110, '2015-03-01 00:35:02.000000', 'temperatura', 554.0000, 'ºC'),
	(83400, 110, '2015-03-01 00:35:03.000000', 'temperatura', 127.0000, 'ºC'),
	(83401, 110, '2015-03-01 00:35:04.000000', 'temperatura', 175.0000, 'ºC'),
	(83402, 110, '2015-03-01 00:35:05.000000', 'temperatura', 491.0000, 'ºC'),
	(83403, 110, '2015-03-01 00:35:06.000000', 'temperatura', 733.0000, 'ºC'),
	(83404, 110, '2015-03-01 00:35:07.000000', 'temperatura', 993.0000, 'ºC'),
	(83405, 110, '2015-03-01 00:35:08.000000', 'temperatura', 364.0000, 'ºC'),
	(83406, 110, '2015-03-01 00:35:09.000000', 'temperatura', 43.0000, 'ºC'),
	(83407, 110, '2015-03-01 00:35:10.000000', 'temperatura', 324.0000, 'ºC'),
	(83408, 110, '2015-03-01 00:35:11.000000', 'temperatura', 292.0000, 'ºC'),
	(83409, 110, '2015-03-01 00:35:12.000000', 'temperatura', 490.0000, 'ºC'),
	(83410, 110, '2015-03-01 00:35:13.000000', 'temperatura', 372.0000, 'ºC'),
	(83411, 110, '2015-03-01 00:35:14.000000', 'temperatura', 393.0000, 'ºC'),
	(83412, 110, '2015-03-01 00:35:15.000000', 'temperatura', 849.0000, 'ºC'),
	(83413, 110, '2015-03-01 00:35:16.000000', 'temperatura', 667.0000, 'ºC'),
	(83414, 110, '2015-03-01 00:35:17.000000', 'temperatura', 790.0000, 'ºC'),
	(83415, 110, '2015-03-01 00:35:18.000000', 'temperatura', 746.0000, 'ºC'),
	(83416, 110, '2015-03-01 00:35:19.000000', 'temperatura', 162.0000, 'ºC'),
	(83417, 110, '2015-03-01 00:35:20.000000', 'temperatura', 973.0000, 'ºC'),
	(83418, 110, '2015-03-01 00:35:21.000000', 'temperatura', 780.0000, 'ºC'),
	(83419, 110, '2015-03-01 00:35:22.000000', 'temperatura', 980.0000, 'ºC'),
	(83420, 110, '2015-03-01 00:35:23.000000', 'temperatura', 161.0000, 'ºC'),
	(83421, 110, '2015-03-01 00:35:24.000000', 'temperatura', 266.0000, 'ºC'),
	(83422, 110, '2015-03-01 00:35:25.000000', 'temperatura', 848.0000, 'ºC'),
	(83423, 110, '2015-03-01 00:35:26.000000', 'temperatura', 1041.0000, 'ºC'),
	(83424, 110, '2015-03-01 00:35:27.000000', 'temperatura', 263.0000, 'ºC'),
	(83425, 110, '2015-03-01 00:35:28.000000', 'temperatura', 593.0000, 'ºC'),
	(83426, 110, '2015-03-01 00:35:29.000000', 'temperatura', 975.0000, 'ºC'),
	(83427, 110, '2015-03-01 00:35:30.000000', 'temperatura', 697.0000, 'ºC'),
	(83428, 110, '2015-03-01 00:35:31.000000', 'temperatura', 558.0000, 'ºC'),
	(83429, 110, '2015-03-01 00:35:32.000000', 'temperatura', 703.0000, 'ºC'),
	(83430, 110, '2015-03-01 00:35:33.000000', 'temperatura', 641.0000, 'ºC'),
	(83431, 110, '2015-03-01 00:35:34.000000', 'temperatura', 1095.0000, 'ºC'),
	(83432, 110, '2015-03-01 00:35:35.000000', 'temperatura', 1155.0000, 'ºC'),
	(83433, 110, '2015-03-01 00:35:36.000000', 'temperatura', 89.0000, 'ºC'),
	(83434, 110, '2015-03-01 00:35:37.000000', 'temperatura', 582.0000, 'ºC'),
	(83435, 110, '2015-03-01 00:35:38.000000', 'temperatura', 242.0000, 'ºC'),
	(83436, 110, '2015-03-01 00:35:39.000000', 'temperatura', 667.0000, 'ºC'),
	(83437, 110, '2015-03-01 00:35:40.000000', 'temperatura', 207.0000, 'ºC'),
	(83438, 110, '2015-03-01 00:35:41.000000', 'temperatura', 234.0000, 'ºC'),
	(83439, 110, '2015-03-01 00:35:42.000000', 'temperatura', 552.0000, 'ºC'),
	(83440, 110, '2015-03-01 00:35:43.000000', 'temperatura', 858.0000, 'ºC'),
	(83441, 110, '2015-03-01 00:35:44.000000', 'temperatura', 235.0000, 'ºC'),
	(83442, 110, '2015-03-01 00:35:45.000000', 'temperatura', 1002.0000, 'ºC'),
	(83443, 110, '2015-03-01 00:35:46.000000', 'temperatura', 706.0000, 'ºC'),
	(83444, 110, '2015-03-01 00:35:47.000000', 'temperatura', 522.0000, 'ºC'),
	(83445, 110, '2015-03-01 00:35:48.000000', 'temperatura', 493.0000, 'ºC'),
	(83446, 110, '2015-03-01 00:35:49.000000', 'temperatura', 901.0000, 'ºC'),
	(83447, 110, '2015-03-01 00:35:50.000000', 'temperatura', 625.0000, 'ºC'),
	(83448, 110, '2015-03-01 00:35:51.000000', 'temperatura', 423.0000, 'ºC'),
	(83449, 110, '2015-03-01 00:35:52.000000', 'temperatura', 242.0000, 'ºC'),
	(83450, 110, '2015-03-01 00:35:53.000000', 'temperatura', 1139.0000, 'ºC'),
	(83451, 110, '2015-03-01 00:35:54.000000', 'temperatura', 169.0000, 'ºC'),
	(83452, 110, '2015-03-01 00:35:55.000000', 'temperatura', 1029.0000, 'ºC'),
	(83453, 110, '2015-03-01 00:35:56.000000', 'temperatura', 1040.0000, 'ºC'),
	(83454, 110, '2015-03-01 00:35:57.000000', 'temperatura', 914.0000, 'ºC'),
	(83455, 110, '2015-03-01 00:35:58.000000', 'temperatura', 249.0000, 'ºC'),
	(83456, 110, '2015-03-01 00:35:59.000000', 'temperatura', 902.0000, 'ºC'),
	(83457, 110, '2015-03-01 00:36:00.000000', 'temperatura', 166.0000, 'ºC'),
	(83458, 110, '2015-03-01 00:36:01.000000', 'temperatura', 522.0000, 'ºC'),
	(83459, 110, '2015-03-01 00:36:02.000000', 'temperatura', 914.0000, 'ºC'),
	(83460, 110, '2015-03-01 00:36:03.000000', 'temperatura', 602.0000, 'ºC'),
	(83461, 110, '2015-03-01 00:36:04.000000', 'temperatura', 272.0000, 'ºC'),
	(83462, 110, '2015-03-01 00:36:05.000000', 'temperatura', 753.0000, 'ºC'),
	(83463, 110, '2015-03-01 00:36:06.000000', 'temperatura', 551.0000, 'ºC'),
	(83464, 110, '2015-03-01 00:36:07.000000', 'temperatura', 496.0000, 'ºC'),
	(83465, 110, '2015-03-01 00:36:08.000000', 'temperatura', 827.0000, 'ºC'),
	(83466, 110, '2015-03-01 00:36:09.000000', 'temperatura', 248.0000, 'ºC'),
	(83467, 110, '2015-03-01 00:36:10.000000', 'temperatura', 1159.0000, 'ºC'),
	(83468, 110, '2015-03-01 00:36:11.000000', 'temperatura', 254.0000, 'ºC'),
	(83469, 110, '2015-03-01 00:36:12.000000', 'temperatura', 190.0000, 'ºC'),
	(83470, 110, '2015-03-01 00:36:13.000000', 'temperatura', 189.0000, 'ºC'),
	(83471, 110, '2015-03-01 00:36:14.000000', 'temperatura', 377.0000, 'ºC'),
	(83472, 110, '2015-03-01 00:36:15.000000', 'temperatura', 119.0000, 'ºC'),
	(83473, 110, '2015-03-01 00:36:16.000000', 'temperatura', 662.0000, 'ºC'),
	(83474, 110, '2015-03-01 00:36:17.000000', 'temperatura', 553.0000, 'ºC'),
	(83475, 110, '2015-03-01 00:36:18.000000', 'temperatura', 782.0000, 'ºC'),
	(83476, 110, '2015-03-01 00:36:19.000000', 'temperatura', 1051.0000, 'ºC'),
	(83477, 110, '2015-03-01 00:36:20.000000', 'temperatura', 510.0000, 'ºC'),
	(83478, 110, '2015-03-01 00:36:21.000000', 'temperatura', 599.0000, 'ºC'),
	(83479, 110, '2015-03-01 00:36:22.000000', 'temperatura', 264.0000, 'ºC'),
	(83480, 110, '2015-03-01 00:36:23.000000', 'temperatura', 722.0000, 'ºC'),
	(83481, 110, '2015-03-01 00:36:24.000000', 'temperatura', 418.0000, 'ºC'),
	(83482, 110, '2015-03-01 00:36:25.000000', 'temperatura', 1126.0000, 'ºC'),
	(83483, 110, '2015-03-01 00:36:26.000000', 'temperatura', 777.0000, 'ºC'),
	(83484, 110, '2015-03-01 00:36:27.000000', 'temperatura', 508.0000, 'ºC'),
	(83485, 110, '2015-03-01 00:36:28.000000', 'temperatura', 208.0000, 'ºC'),
	(83486, 110, '2015-03-01 00:36:29.000000', 'temperatura', 719.0000, 'ºC'),
	(83487, 110, '2015-03-01 00:36:30.000000', 'temperatura', 569.0000, 'ºC'),
	(83488, 110, '2015-03-01 00:36:31.000000', 'temperatura', 690.0000, 'ºC'),
	(83489, 110, '2015-03-01 00:36:32.000000', 'temperatura', 542.0000, 'ºC'),
	(83490, 110, '2015-03-01 00:36:33.000000', 'temperatura', 641.0000, 'ºC'),
	(83491, 110, '2015-03-01 00:36:34.000000', 'temperatura', 381.0000, 'ºC'),
	(83492, 110, '2015-03-01 00:36:35.000000', 'temperatura', 1180.0000, 'ºC'),
	(83493, 110, '2015-03-01 00:36:36.000000', 'temperatura', 1157.0000, 'ºC'),
	(83494, 110, '2015-03-01 00:36:37.000000', 'temperatura', 1048.0000, 'ºC'),
	(83495, 110, '2015-03-01 00:36:38.000000', 'temperatura', 569.0000, 'ºC'),
	(83496, 110, '2015-03-01 00:36:39.000000', 'temperatura', 902.0000, 'ºC'),
	(83497, 110, '2015-03-01 00:36:40.000000', 'temperatura', 405.0000, 'ºC'),
	(83498, 110, '2015-03-01 00:36:41.000000', 'temperatura', 518.0000, 'ºC'),
	(83499, 110, '2015-03-01 00:36:42.000000', 'temperatura', 177.0000, 'ºC'),
	(83500, 110, '2015-03-01 00:36:43.000000', 'temperatura', 529.0000, 'ºC'),
	(83501, 110, '2015-03-01 00:36:44.000000', 'temperatura', 915.0000, 'ºC'),
	(83502, 110, '2015-03-01 00:36:45.000000', 'temperatura', 589.0000, 'ºC'),
	(83503, 110, '2015-03-01 00:36:46.000000', 'temperatura', 199.0000, 'ºC'),
	(83504, 110, '2015-03-01 00:36:47.000000', 'temperatura', 429.0000, 'ºC'),
	(83505, 110, '2015-03-01 00:36:48.000000', 'temperatura', 349.0000, 'ºC'),
	(83506, 110, '2015-03-01 00:36:49.000000', 'temperatura', 459.0000, 'ºC'),
	(83507, 110, '2015-03-01 00:36:50.000000', 'temperatura', 47.0000, 'ºC'),
	(83508, 110, '2015-03-01 00:36:51.000000', 'temperatura', 60.0000, 'ºC'),
	(83509, 110, '2015-03-01 00:36:52.000000', 'temperatura', 160.0000, 'ºC'),
	(83510, 110, '2015-03-01 00:36:53.000000', 'temperatura', 619.0000, 'ºC'),
	(83511, 110, '2015-03-01 00:36:54.000000', 'temperatura', 218.0000, 'ºC'),
	(83512, 110, '2015-03-01 00:36:55.000000', 'temperatura', 431.0000, 'ºC'),
	(83513, 110, '2015-03-01 00:36:56.000000', 'temperatura', 304.0000, 'ºC'),
	(83514, 110, '2015-03-01 00:36:57.000000', 'temperatura', 228.0000, 'ºC'),
	(83515, 110, '2015-03-01 00:36:58.000000', 'temperatura', 227.0000, 'ºC'),
	(83516, 110, '2015-03-01 00:36:59.000000', 'temperatura', 454.0000, 'ºC'),
	(83517, 110, '2015-03-01 00:37:00.000000', 'temperatura', 387.0000, 'ºC'),
	(83518, 110, '2015-03-01 00:37:01.000000', 'temperatura', 572.0000, 'ºC'),
	(83519, 110, '2015-03-01 00:37:02.000000', 'temperatura', 503.0000, 'ºC'),
	(83520, 110, '2015-03-01 00:37:03.000000', 'temperatura', 797.0000, 'ºC'),
	(83521, 110, '2015-03-01 00:37:04.000000', 'temperatura', 76.0000, 'ºC'),
	(83522, 110, '2015-03-01 00:37:05.000000', 'temperatura', 389.0000, 'ºC'),
	(83523, 110, '2015-03-01 00:37:06.000000', 'temperatura', 518.0000, 'ºC'),
	(83524, 110, '2015-03-01 00:37:07.000000', 'temperatura', 224.0000, 'ºC'),
	(83525, 110, '2015-03-01 00:37:08.000000', 'temperatura', 764.0000, 'ºC'),
	(83526, 110, '2015-03-01 00:37:09.000000', 'temperatura', 752.0000, 'ºC'),
	(83527, 110, '2015-03-01 00:37:10.000000', 'temperatura', 267.0000, 'ºC'),
	(83528, 110, '2015-03-01 00:37:11.000000', 'temperatura', 278.0000, 'ºC'),
	(83529, 110, '2015-03-01 00:37:12.000000', 'temperatura', 590.0000, 'ºC'),
	(83530, 110, '2015-03-01 00:37:13.000000', 'temperatura', 918.0000, 'ºC'),
	(83531, 110, '2015-03-01 00:37:14.000000', 'temperatura', 418.0000, 'ºC'),
	(83532, 110, '2015-03-01 00:37:15.000000', 'temperatura', 539.0000, 'ºC'),
	(83533, 110, '2015-03-01 00:37:16.000000', 'temperatura', 240.0000, 'ºC'),
	(83534, 110, '2015-03-01 00:37:17.000000', 'temperatura', 783.0000, 'ºC'),
	(83535, 110, '2015-03-01 00:37:18.000000', 'temperatura', 795.0000, 'ºC'),
	(83536, 110, '2015-03-01 00:37:19.000000', 'temperatura', 426.0000, 'ºC'),
	(83537, 110, '2015-03-01 00:37:20.000000', 'temperatura', 945.0000, 'ºC'),
	(83538, 110, '2015-03-01 00:37:21.000000', 'temperatura', 1049.0000, 'ºC'),
	(83539, 110, '2015-03-01 00:37:22.000000', 'temperatura', 9.0000, 'ºC'),
	(83540, 110, '2015-03-01 00:37:23.000000', 'temperatura', 500.0000, 'ºC'),
	(83541, 110, '2015-03-01 00:37:24.000000', 'temperatura', 74.0000, 'ºC'),
	(83542, 110, '2015-03-01 00:37:25.000000', 'temperatura', 72.0000, 'ºC'),
	(83543, 110, '2015-03-01 00:37:26.000000', 'temperatura', 136.0000, 'ºC'),
	(83544, 110, '2015-03-01 00:37:27.000000', 'temperatura', 463.0000, 'ºC'),
	(83545, 110, '2015-03-01 00:37:28.000000', 'temperatura', 711.0000, 'ºC'),
	(83546, 110, '2015-03-01 00:37:29.000000', 'temperatura', 966.0000, 'ºC'),
	(83547, 110, '2015-03-01 00:37:30.000000', 'temperatura', 296.0000, 'ºC'),
	(83548, 110, '2015-03-01 00:37:31.000000', 'temperatura', 982.0000, 'ºC'),
	(83549, 110, '2015-03-01 00:37:32.000000', 'temperatura', 425.0000, 'ºC'),
	(83550, 110, '2015-03-01 00:37:33.000000', 'temperatura', 378.0000, 'ºC'),
	(83551, 110, '2015-03-01 00:37:34.000000', 'temperatura', 615.0000, 'ºC'),
	(83552, 110, '2015-03-01 00:37:35.000000', 'temperatura', 741.0000, 'ºC'),
	(83553, 110, '2015-03-01 00:37:36.000000', 'temperatura', 662.0000, 'ºC'),
	(83554, 110, '2015-03-01 00:37:37.000000', 'temperatura', 1086.0000, 'ºC'),
	(83555, 110, '2015-03-01 00:37:38.000000', 'temperatura', 1043.0000, 'ºC'),
	(83556, 110, '2015-03-01 00:37:39.000000', 'temperatura', 760.0000, 'ºC'),
	(83557, 110, '2015-03-01 00:37:40.000000', 'temperatura', 673.0000, 'ºC'),
	(83558, 110, '2015-03-01 00:37:41.000000', 'temperatura', 1083.0000, 'ºC'),
	(83559, 110, '2015-03-01 00:37:42.000000', 'temperatura', 996.0000, 'ºC'),
	(83560, 110, '2015-03-01 00:37:43.000000', 'temperatura', 532.0000, 'ºC'),
	(83561, 110, '2015-03-01 00:37:44.000000', 'temperatura', 874.0000, 'ºC'),
	(83562, 110, '2015-03-01 00:37:45.000000', 'temperatura', 374.0000, 'ºC'),
	(83563, 110, '2015-03-01 00:37:46.000000', 'temperatura', 446.0000, 'ºC'),
	(83564, 110, '2015-03-01 00:37:47.000000', 'temperatura', 1112.0000, 'ºC'),
	(83565, 110, '2015-03-01 00:37:48.000000', 'temperatura', 620.0000, 'ºC'),
	(83566, 110, '2015-03-01 00:37:49.000000', 'temperatura', 964.0000, 'ºC'),
	(83567, 110, '2015-03-01 00:37:50.000000', 'temperatura', 562.0000, 'ºC'),
	(83568, 110, '2015-03-01 00:37:51.000000', 'temperatura', 1117.0000, 'ºC'),
	(83569, 110, '2015-03-01 00:37:52.000000', 'temperatura', 302.0000, 'ºC'),
	(83570, 110, '2015-03-01 00:37:53.000000', 'temperatura', 559.0000, 'ºC'),
	(83571, 110, '2015-03-01 00:37:54.000000', 'temperatura', 689.0000, 'ºC'),
	(83572, 110, '2015-03-01 00:37:55.000000', 'temperatura', 567.0000, 'ºC'),
	(83573, 110, '2015-03-01 00:37:56.000000', 'temperatura', 769.0000, 'ºC'),
	(83574, 110, '2015-03-01 00:37:57.000000', 'temperatura', 946.0000, 'ºC'),
	(83575, 110, '2015-03-01 00:37:58.000000', 'temperatura', 21.0000, 'ºC'),
	(83576, 110, '2015-03-01 00:37:59.000000', 'temperatura', 867.0000, 'ºC'),
	(83577, 110, '2015-03-01 00:38:00.000000', 'temperatura', 676.0000, 'ºC'),
	(83578, 110, '2015-03-01 00:38:01.000000', 'temperatura', 777.0000, 'ºC'),
	(83579, 110, '2015-03-01 00:38:02.000000', 'temperatura', 656.0000, 'ºC'),
	(83580, 110, '2015-03-01 00:38:03.000000', 'temperatura', 953.0000, 'ºC'),
	(83581, 110, '2015-03-01 00:38:04.000000', 'temperatura', 394.0000, 'ºC'),
	(83582, 110, '2015-03-01 00:38:05.000000', 'temperatura', 314.0000, 'ºC'),
	(83583, 110, '2015-03-01 00:38:06.000000', 'temperatura', 387.0000, 'ºC'),
	(83584, 110, '2015-03-01 00:38:07.000000', 'temperatura', 994.0000, 'ºC'),
	(83585, 110, '2015-03-01 00:38:08.000000', 'temperatura', 209.0000, 'ºC'),
	(83586, 110, '2015-03-01 00:38:09.000000', 'temperatura', 462.0000, 'ºC'),
	(83587, 110, '2015-03-01 00:38:10.000000', 'temperatura', 485.0000, 'ºC'),
	(83588, 110, '2015-03-01 00:38:11.000000', 'temperatura', 1040.0000, 'ºC'),
	(83589, 110, '2015-03-01 00:38:12.000000', 'temperatura', 146.0000, 'ºC'),
	(83590, 110, '2015-03-01 00:38:13.000000', 'temperatura', 9.0000, 'ºC'),
	(83591, 110, '2015-03-01 00:38:14.000000', 'temperatura', 810.0000, 'ºC'),
	(83592, 110, '2015-03-01 00:38:15.000000', 'temperatura', 421.0000, 'ºC'),
	(83593, 110, '2015-03-01 00:38:16.000000', 'temperatura', 877.0000, 'ºC'),
	(83594, 110, '2015-03-01 00:38:17.000000', 'temperatura', 723.0000, 'ºC'),
	(83595, 110, '2015-03-01 00:38:18.000000', 'temperatura', 982.0000, 'ºC'),
	(83596, 110, '2015-03-01 00:38:19.000000', 'temperatura', 344.0000, 'ºC'),
	(83597, 110, '2015-03-01 00:38:20.000000', 'temperatura', 1175.0000, 'ºC'),
	(83598, 110, '2015-03-01 00:38:21.000000', 'temperatura', 42.0000, 'ºC'),
	(83599, 110, '2015-03-01 00:38:22.000000', 'temperatura', 285.0000, 'ºC'),
	(83600, 110, '2015-03-01 00:38:23.000000', 'temperatura', 100.0000, 'ºC'),
	(83601, 110, '2015-03-01 00:38:24.000000', 'temperatura', 847.0000, 'ºC'),
	(83602, 110, '2015-03-01 00:38:25.000000', 'temperatura', 336.0000, 'ºC'),
	(83603, 110, '2015-03-01 00:38:26.000000', 'temperatura', 339.0000, 'ºC'),
	(83604, 110, '2015-03-01 00:38:27.000000', 'temperatura', 686.0000, 'ºC'),
	(83605, 110, '2015-03-01 00:38:28.000000', 'temperatura', 16.0000, 'ºC'),
	(83606, 110, '2015-03-01 00:38:29.000000', 'temperatura', 422.0000, 'ºC'),
	(83607, 110, '2015-03-01 00:38:30.000000', 'temperatura', 860.0000, 'ºC'),
	(83608, 110, '2015-03-01 00:38:31.000000', 'temperatura', 637.0000, 'ºC'),
	(83609, 110, '2015-03-01 00:38:32.000000', 'temperatura', 605.0000, 'ºC'),
	(83610, 110, '2015-03-01 00:38:33.000000', 'temperatura', 1114.0000, 'ºC'),
	(83611, 110, '2015-03-01 00:38:34.000000', 'temperatura', 157.0000, 'ºC'),
	(83612, 110, '2015-03-01 00:38:35.000000', 'temperatura', 1042.0000, 'ºC'),
	(83613, 110, '2015-03-01 00:38:36.000000', 'temperatura', 1139.0000, 'ºC'),
	(83614, 110, '2015-03-01 00:38:37.000000', 'temperatura', 172.0000, 'ºC'),
	(83615, 110, '2015-03-01 00:38:38.000000', 'temperatura', 1042.0000, 'ºC'),
	(83616, 110, '2015-03-01 00:38:39.000000', 'temperatura', 1094.0000, 'ºC'),
	(83617, 110, '2015-03-01 00:38:40.000000', 'temperatura', 1143.0000, 'ºC'),
	(83618, 110, '2015-03-01 00:38:41.000000', 'temperatura', 37.0000, 'ºC'),
	(83619, 110, '2015-03-01 00:38:42.000000', 'temperatura', 354.0000, 'ºC'),
	(83620, 110, '2015-03-01 00:38:43.000000', 'temperatura', 458.0000, 'ºC'),
	(83621, 110, '2015-03-01 00:38:44.000000', 'temperatura', 32.0000, 'ºC'),
	(83622, 110, '2015-03-01 00:38:45.000000', 'temperatura', 1185.0000, 'ºC'),
	(83623, 110, '2015-03-01 00:38:46.000000', 'temperatura', 1031.0000, 'ºC'),
	(83624, 110, '2015-03-01 00:38:47.000000', 'temperatura', 401.0000, 'ºC'),
	(83625, 110, '2015-03-01 00:38:48.000000', 'temperatura', 109.0000, 'ºC'),
	(83626, 110, '2015-03-01 00:38:49.000000', 'temperatura', 546.0000, 'ºC'),
	(83627, 110, '2015-03-01 00:38:50.000000', 'temperatura', 2.0000, 'ºC'),
	(83628, 110, '2015-03-01 00:38:51.000000', 'temperatura', 771.0000, 'ºC'),
	(83629, 110, '2015-03-01 00:38:52.000000', 'temperatura', 249.0000, 'ºC'),
	(83630, 110, '2015-03-01 00:38:53.000000', 'temperatura', 135.0000, 'ºC'),
	(83631, 110, '2015-03-01 00:38:54.000000', 'temperatura', 1127.0000, 'ºC'),
	(83632, 110, '2015-03-01 00:38:55.000000', 'temperatura', 433.0000, 'ºC'),
	(83633, 110, '2015-03-01 00:38:56.000000', 'temperatura', 1183.0000, 'ºC'),
	(83634, 110, '2015-03-01 00:38:57.000000', 'temperatura', 1015.0000, 'ºC'),
	(83635, 110, '2015-03-01 00:38:58.000000', 'temperatura', 326.0000, 'ºC'),
	(83636, 110, '2015-03-01 00:38:59.000000', 'temperatura', 988.0000, 'ºC'),
	(83637, 110, '2015-03-01 00:39:00.000000', 'temperatura', 361.0000, 'ºC'),
	(83638, 110, '2015-03-01 00:39:01.000000', 'temperatura', 43.0000, 'ºC'),
	(83639, 110, '2015-03-01 00:39:02.000000', 'temperatura', 334.0000, 'ºC'),
	(83640, 110, '2015-03-01 00:39:03.000000', 'temperatura', 338.0000, 'ºC'),
	(83641, 110, '2015-03-01 00:39:04.000000', 'temperatura', 690.0000, 'ºC'),
	(83642, 110, '2015-03-01 00:39:05.000000', 'temperatura', 35.0000, 'ºC'),
	(83643, 110, '2015-03-01 00:39:06.000000', 'temperatura', 508.0000, 'ºC'),
	(83644, 110, '2015-03-01 00:39:07.000000', 'temperatura', 37.0000, 'ºC'),
	(83645, 110, '2015-03-01 00:39:08.000000', 'temperatura', 1058.0000, 'ºC'),
	(83646, 110, '2015-03-01 00:39:09.000000', 'temperatura', 379.0000, 'ºC'),
	(83647, 110, '2015-03-01 00:39:10.000000', 'temperatura', 1124.0000, 'ºC'),
	(83648, 110, '2015-03-01 00:39:11.000000', 'temperatura', 884.0000, 'ºC'),
	(83649, 110, '2015-03-01 00:39:12.000000', 'temperatura', 1046.0000, 'ºC'),
	(83650, 110, '2015-03-01 00:39:13.000000', 'temperatura', 179.0000, 'ºC'),
	(83651, 110, '2015-03-01 00:39:14.000000', 'temperatura', 159.0000, 'ºC'),
	(83652, 110, '2015-03-01 00:39:15.000000', 'temperatura', 258.0000, 'ºC'),
	(83653, 110, '2015-03-01 00:39:16.000000', 'temperatura', 814.0000, 'ºC'),
	(83654, 110, '2015-03-01 00:39:17.000000', 'temperatura', 895.0000, 'ºC'),
	(83655, 110, '2015-03-01 00:39:18.000000', 'temperatura', 832.0000, 'ºC'),
	(83656, 110, '2015-03-01 00:39:19.000000', 'temperatura', 279.0000, 'ºC'),
	(83657, 110, '2015-03-01 00:39:20.000000', 'temperatura', 97.0000, 'ºC'),
	(83658, 110, '2015-03-01 00:39:21.000000', 'temperatura', 848.0000, 'ºC'),
	(83659, 110, '2015-03-01 00:39:22.000000', 'temperatura', 352.0000, 'ºC'),
	(83660, 110, '2015-03-01 00:39:23.000000', 'temperatura', 417.0000, 'ºC'),
	(83661, 110, '2015-03-01 00:39:24.000000', 'temperatura', 1030.0000, 'ºC'),
	(83662, 110, '2015-03-01 00:39:25.000000', 'temperatura', 299.0000, 'ºC'),
	(83663, 110, '2015-03-01 00:39:26.000000', 'temperatura', 804.0000, 'ºC'),
	(83664, 110, '2015-03-01 00:39:27.000000', 'temperatura', 722.0000, 'ºC'),
	(83665, 110, '2015-03-01 00:39:28.000000', 'temperatura', 1.0000, 'ºC'),
	(83666, 110, '2015-03-01 00:39:29.000000', 'temperatura', 239.0000, 'ºC'),
	(83667, 110, '2015-03-01 00:39:30.000000', 'temperatura', 1193.0000, 'ºC'),
	(83668, 110, '2015-03-01 00:39:31.000000', 'temperatura', 449.0000, 'ºC'),
	(83669, 110, '2015-03-01 00:39:32.000000', 'temperatura', 1066.0000, 'ºC'),
	(83670, 110, '2015-03-01 00:39:33.000000', 'temperatura', 381.0000, 'ºC'),
	(83671, 110, '2015-03-01 00:39:34.000000', 'temperatura', 1111.0000, 'ºC'),
	(83672, 110, '2015-03-01 00:39:35.000000', 'temperatura', 810.0000, 'ºC'),
	(83673, 110, '2015-03-01 00:39:36.000000', 'temperatura', 719.0000, 'ºC'),
	(83674, 110, '2015-03-01 00:39:37.000000', 'temperatura', 1166.0000, 'ºC'),
	(83675, 110, '2015-03-01 00:39:38.000000', 'temperatura', 73.0000, 'ºC'),
	(83676, 110, '2015-03-01 00:39:39.000000', 'temperatura', 467.0000, 'ºC'),
	(83677, 110, '2015-03-01 00:39:40.000000', 'temperatura', 916.0000, 'ºC'),
	(83678, 110, '2015-03-01 00:39:41.000000', 'temperatura', 780.0000, 'ºC'),
	(83679, 110, '2015-03-01 00:39:42.000000', 'temperatura', 1153.0000, 'ºC'),
	(83680, 110, '2015-03-01 00:39:43.000000', 'temperatura', 1025.0000, 'ºC'),
	(83681, 110, '2015-03-01 00:39:44.000000', 'temperatura', 467.0000, 'ºC'),
	(83682, 110, '2015-03-01 00:39:45.000000', 'temperatura', 459.0000, 'ºC'),
	(83683, 110, '2015-03-01 00:39:46.000000', 'temperatura', 897.0000, 'ºC'),
	(83684, 110, '2015-03-01 00:39:47.000000', 'temperatura', 707.0000, 'ºC'),
	(83685, 110, '2015-03-01 00:39:48.000000', 'temperatura', 846.0000, 'ºC'),
	(83686, 110, '2015-03-01 00:39:49.000000', 'temperatura', 907.0000, 'ºC'),
	(83687, 110, '2015-03-01 00:39:50.000000', 'temperatura', 800.0000, 'ºC'),
	(83688, 110, '2015-03-01 00:39:51.000000', 'temperatura', 77.0000, 'ºC'),
	(83689, 110, '2015-03-01 00:39:52.000000', 'temperatura', 385.0000, 'ºC'),
	(83690, 110, '2015-03-01 00:39:53.000000', 'temperatura', 495.0000, 'ºC'),
	(83691, 110, '2015-03-01 00:39:54.000000', 'temperatura', 119.0000, 'ºC'),
	(83692, 110, '2015-03-01 00:39:55.000000', 'temperatura', 311.0000, 'ºC'),
	(83693, 110, '2015-03-01 00:39:56.000000', 'temperatura', 1199.0000, 'ºC'),
	(83694, 110, '2015-03-01 00:39:57.000000', 'temperatura', 262.0000, 'ºC'),
	(83695, 110, '2015-03-01 00:39:58.000000', 'temperatura', 113.0000, 'ºC'),
	(83696, 110, '2015-03-01 00:39:59.000000', 'temperatura', 981.0000, 'ºC'),
	(83697, 110, '2015-03-01 00:40:00.000000', 'temperatura', 964.0000, 'ºC'),
	(83698, 110, '2015-03-01 00:40:01.000000', 'temperatura', 681.0000, 'ºC'),
	(83699, 110, '2015-03-01 00:40:02.000000', 'temperatura', 511.0000, 'ºC'),
	(83700, 110, '2015-03-01 00:40:03.000000', 'temperatura', 511.0000, 'ºC'),
	(83701, 110, '2015-03-01 00:40:04.000000', 'temperatura', 1025.0000, 'ºC'),
	(83702, 110, '2015-03-01 00:40:05.000000', 'temperatura', 1193.0000, 'ºC'),
	(83703, 110, '2015-03-01 00:40:06.000000', 'temperatura', 491.0000, 'ºC'),
	(83704, 110, '2015-03-01 00:40:07.000000', 'temperatura', 78.0000, 'ºC'),
	(83705, 110, '2015-03-01 00:40:08.000000', 'temperatura', 114.0000, 'ºC'),
	(83706, 110, '2015-03-01 00:40:09.000000', 'temperatura', 337.0000, 'ºC'),
	(83707, 110, '2015-03-01 00:40:10.000000', 'temperatura', 145.0000, 'ºC'),
	(83708, 110, '2015-03-01 00:40:11.000000', 'temperatura', 913.0000, 'ºC'),
	(83709, 110, '2015-03-01 00:40:12.000000', 'temperatura', 531.0000, 'ºC'),
	(83710, 110, '2015-03-01 00:40:13.000000', 'temperatura', 1117.0000, 'ºC'),
	(83711, 110, '2015-03-01 00:40:14.000000', 'temperatura', 391.0000, 'ºC'),
	(83712, 110, '2015-03-01 00:40:15.000000', 'temperatura', 1006.0000, 'ºC'),
	(83713, 110, '2015-03-01 00:40:16.000000', 'temperatura', 256.0000, 'ºC'),
	(83714, 110, '2015-03-01 00:40:17.000000', 'temperatura', 663.0000, 'ºC'),
	(83715, 110, '2015-03-01 00:40:18.000000', 'temperatura', 146.0000, 'ºC'),
	(83716, 110, '2015-03-01 00:40:19.000000', 'temperatura', 1143.0000, 'ºC'),
	(83717, 110, '2015-03-01 00:40:20.000000', 'temperatura', 477.0000, 'ºC'),
	(83718, 110, '2015-03-01 00:40:21.000000', 'temperatura', 156.0000, 'ºC'),
	(83719, 110, '2015-03-01 00:40:22.000000', 'temperatura', 549.0000, 'ºC'),
	(83720, 110, '2015-03-01 00:40:23.000000', 'temperatura', 1079.0000, 'ºC'),
	(83721, 110, '2015-03-01 00:40:24.000000', 'temperatura', 148.0000, 'ºC'),
	(83722, 110, '2015-03-01 00:40:25.000000', 'temperatura', 1105.0000, 'ºC'),
	(83723, 110, '2015-03-01 00:40:26.000000', 'temperatura', 282.0000, 'ºC'),
	(83724, 110, '2015-03-01 00:40:27.000000', 'temperatura', 496.0000, 'ºC'),
	(83725, 110, '2015-03-01 00:40:28.000000', 'temperatura', 434.0000, 'ºC'),
	(83726, 110, '2015-03-01 00:40:29.000000', 'temperatura', 680.0000, 'ºC'),
	(83727, 110, '2015-03-01 00:40:30.000000', 'temperatura', 901.0000, 'ºC'),
	(83728, 110, '2015-03-01 00:40:31.000000', 'temperatura', 63.0000, 'ºC'),
	(83729, 110, '2015-03-01 00:40:32.000000', 'temperatura', 15.0000, 'ºC'),
	(83730, 110, '2015-03-01 00:40:33.000000', 'temperatura', 1085.0000, 'ºC'),
	(83731, 110, '2015-03-01 00:40:34.000000', 'temperatura', 582.0000, 'ºC'),
	(83732, 110, '2015-03-01 00:40:35.000000', 'temperatura', 854.0000, 'ºC'),
	(83733, 110, '2015-03-01 00:40:36.000000', 'temperatura', 125.0000, 'ºC'),
	(83734, 110, '2015-03-01 00:40:37.000000', 'temperatura', 463.0000, 'ºC'),
	(83735, 110, '2015-03-01 00:40:38.000000', 'temperatura', 740.0000, 'ºC'),
	(83736, 110, '2015-03-01 00:40:39.000000', 'temperatura', 1113.0000, 'ºC'),
	(83737, 110, '2015-03-01 00:40:40.000000', 'temperatura', 944.0000, 'ºC'),
	(83738, 110, '2015-03-01 00:40:41.000000', 'temperatura', 180.0000, 'ºC'),
	(83739, 110, '2015-03-01 00:40:42.000000', 'temperatura', 470.0000, 'ºC'),
	(83740, 110, '2015-03-01 00:40:43.000000', 'temperatura', 611.0000, 'ºC'),
	(83741, 110, '2015-03-01 00:40:44.000000', 'temperatura', 444.0000, 'ºC'),
	(83742, 110, '2015-03-01 00:40:45.000000', 'temperatura', 390.0000, 'ºC'),
	(83743, 110, '2015-03-01 00:40:46.000000', 'temperatura', 617.0000, 'ºC'),
	(83744, 110, '2015-03-01 00:40:47.000000', 'temperatura', 718.0000, 'ºC'),
	(83745, 110, '2015-03-01 00:40:48.000000', 'temperatura', 536.0000, 'ºC'),
	(83746, 110, '2015-03-01 00:40:49.000000', 'temperatura', 528.0000, 'ºC'),
	(83747, 110, '2015-03-01 00:40:50.000000', 'temperatura', 1032.0000, 'ºC'),
	(83748, 110, '2015-03-01 00:40:51.000000', 'temperatura', 1176.0000, 'ºC'),
	(83749, 110, '2015-03-01 00:40:52.000000', 'temperatura', 384.0000, 'ºC'),
	(83750, 110, '2015-03-01 00:40:53.000000', 'temperatura', 792.0000, 'ºC'),
	(83751, 110, '2015-03-01 00:40:54.000000', 'temperatura', 411.0000, 'ºC'),
	(83752, 110, '2015-03-01 00:40:55.000000', 'temperatura', 877.0000, 'ºC'),
	(83753, 110, '2015-03-01 00:40:56.000000', 'temperatura', 753.0000, 'ºC'),
	(83754, 110, '2015-03-01 00:40:57.000000', 'temperatura', 1134.0000, 'ºC'),
	(83755, 110, '2015-03-01 00:40:58.000000', 'temperatura', 1013.0000, 'ºC'),
	(83756, 110, '2015-03-01 00:40:59.000000', 'temperatura', 463.0000, 'ºC'),
	(83757, 110, '2015-03-01 00:41:00.000000', 'temperatura', 475.0000, 'ºC'),
	(83758, 110, '2015-03-01 00:41:01.000000', 'temperatura', 987.0000, 'ºC'),
	(83759, 110, '2015-03-01 00:41:02.000000', 'temperatura', 1110.0000, 'ºC'),
	(83760, 110, '2015-03-01 00:41:03.000000', 'temperatura', 188.0000, 'ºC'),
	(83761, 110, '2015-03-01 00:41:04.000000', 'temperatura', 14.0000, 'ºC'),
	(83762, 110, '2015-03-01 00:41:05.000000', 'temperatura', 704.0000, 'ºC'),
	(83763, 110, '2015-03-01 00:41:06.000000', 'temperatura', 1078.0000, 'ºC'),
	(83764, 110, '2015-03-01 00:41:07.000000', 'temperatura', 879.0000, 'ºC'),
	(83765, 110, '2015-03-01 00:41:08.000000', 'temperatura', 1160.0000, 'ºC'),
	(83766, 110, '2015-03-01 00:41:09.000000', 'temperatura', 766.0000, 'ºC'),
	(83767, 110, '2015-03-01 00:41:10.000000', 'temperatura', 352.0000, 'ºC'),
	(83768, 110, '2015-03-01 00:41:11.000000', 'temperatura', 659.0000, 'ºC'),
	(83769, 110, '2015-03-01 00:41:12.000000', 'temperatura', 1042.0000, 'ºC'),
	(83770, 110, '2015-03-01 00:41:13.000000', 'temperatura', 835.0000, 'ºC'),
	(83771, 110, '2015-03-01 00:41:14.000000', 'temperatura', 1046.0000, 'ºC'),
	(83772, 110, '2015-03-01 00:41:15.000000', 'temperatura', 327.0000, 'ºC'),
	(83773, 110, '2015-03-01 00:41:16.000000', 'temperatura', 896.0000, 'ºC'),
	(83774, 110, '2015-03-01 00:41:17.000000', 'temperatura', 1102.0000, 'ºC'),
	(83775, 110, '2015-03-01 00:41:18.000000', 'temperatura', 420.0000, 'ºC'),
	(83776, 110, '2015-03-01 00:41:19.000000', 'temperatura', 1197.0000, 'ºC'),
	(83777, 110, '2015-03-01 00:41:20.000000', 'temperatura', 1126.0000, 'ºC'),
	(83778, 110, '2015-03-01 00:41:21.000000', 'temperatura', 837.0000, 'ºC'),
	(83779, 110, '2015-03-01 00:41:22.000000', 'temperatura', 808.0000, 'ºC'),
	(83780, 110, '2015-03-01 00:41:23.000000', 'temperatura', 331.0000, 'ºC'),
	(83781, 110, '2015-03-01 00:41:24.000000', 'temperatura', 432.0000, 'ºC'),
	(83782, 110, '2015-03-01 00:41:25.000000', 'temperatura', 1165.0000, 'ºC'),
	(83783, 110, '2015-03-01 00:41:26.000000', 'temperatura', 931.0000, 'ºC'),
	(83784, 110, '2015-03-01 00:41:27.000000', 'temperatura', 1160.0000, 'ºC'),
	(83785, 110, '2015-03-01 00:41:28.000000', 'temperatura', 609.0000, 'ºC'),
	(83786, 110, '2015-03-01 00:41:29.000000', 'temperatura', 763.0000, 'ºC'),
	(83787, 110, '2015-03-01 00:41:30.000000', 'temperatura', 788.0000, 'ºC'),
	(83788, 110, '2015-03-01 00:41:31.000000', 'temperatura', 454.0000, 'ºC'),
	(83789, 110, '2015-03-01 00:41:32.000000', 'temperatura', 1104.0000, 'ºC'),
	(83790, 110, '2015-03-01 00:41:33.000000', 'temperatura', 557.0000, 'ºC'),
	(83791, 110, '2015-03-01 00:41:34.000000', 'temperatura', 677.0000, 'ºC'),
	(83792, 110, '2015-03-01 00:41:35.000000', 'temperatura', 515.0000, 'ºC'),
	(83793, 110, '2015-03-01 00:41:36.000000', 'temperatura', 543.0000, 'ºC'),
	(83794, 110, '2015-03-01 00:41:37.000000', 'temperatura', 1170.0000, 'ºC'),
	(83795, 110, '2015-03-01 00:41:38.000000', 'temperatura', 623.0000, 'ºC'),
	(83796, 110, '2015-03-01 00:41:39.000000', 'temperatura', 805.0000, 'ºC'),
	(83797, 110, '2015-03-01 00:41:40.000000', 'temperatura', 957.0000, 'ºC'),
	(83798, 110, '2015-03-01 00:41:41.000000', 'temperatura', 1170.0000, 'ºC'),
	(83799, 110, '2015-03-01 00:41:42.000000', 'temperatura', 578.0000, 'ºC'),
	(83800, 110, '2015-03-01 00:41:43.000000', 'temperatura', 583.0000, 'ºC'),
	(83801, 110, '2015-03-01 00:41:44.000000', 'temperatura', 1182.0000, 'ºC'),
	(83802, 110, '2015-03-01 00:41:45.000000', 'temperatura', 560.0000, 'ºC'),
	(83803, 110, '2015-03-01 00:41:46.000000', 'temperatura', 455.0000, 'ºC'),
	(83804, 110, '2015-03-01 00:41:47.000000', 'temperatura', 596.0000, 'ºC'),
	(83805, 110, '2015-03-01 00:41:48.000000', 'temperatura', 415.0000, 'ºC'),
	(83806, 110, '2015-03-01 00:41:49.000000', 'temperatura', 286.0000, 'ºC'),
	(83807, 110, '2015-03-01 00:41:50.000000', 'temperatura', 187.0000, 'ºC'),
	(83808, 110, '2015-03-01 00:41:51.000000', 'temperatura', 78.0000, 'ºC'),
	(83809, 110, '2015-03-01 00:41:52.000000', 'temperatura', 1028.0000, 'ºC'),
	(83810, 110, '2015-03-01 00:41:53.000000', 'temperatura', 109.0000, 'ºC'),
	(83811, 110, '2015-03-01 00:41:54.000000', 'temperatura', 1060.0000, 'ºC'),
	(83812, 110, '2015-03-01 00:41:55.000000', 'temperatura', 174.0000, 'ºC'),
	(83813, 110, '2015-03-01 00:41:56.000000', 'temperatura', 92.0000, 'ºC'),
	(83814, 110, '2015-03-01 00:41:57.000000', 'temperatura', 1137.0000, 'ºC'),
	(83815, 110, '2015-03-01 00:41:58.000000', 'temperatura', 610.0000, 'ºC'),
	(83816, 110, '2015-03-01 00:41:59.000000', 'temperatura', 839.0000, 'ºC'),
	(83817, 110, '2015-03-01 00:42:00.000000', 'temperatura', 1168.0000, 'ºC'),
	(83818, 110, '2015-03-01 00:42:01.000000', 'temperatura', 920.0000, 'ºC'),
	(83819, 110, '2015-03-01 00:42:02.000000', 'temperatura', 1098.0000, 'ºC'),
	(83820, 110, '2015-03-01 00:42:03.000000', 'temperatura', 330.0000, 'ºC'),
	(83821, 110, '2015-03-01 00:42:04.000000', 'temperatura', 758.0000, 'ºC'),
	(83822, 110, '2015-03-01 00:42:05.000000', 'temperatura', 399.0000, 'ºC'),
	(83823, 110, '2015-03-01 00:42:06.000000', 'temperatura', 921.0000, 'ºC'),
	(83824, 110, '2015-03-01 00:42:07.000000', 'temperatura', 1011.0000, 'ºC'),
	(83825, 110, '2015-03-01 00:42:08.000000', 'temperatura', 1089.0000, 'ºC'),
	(83826, 110, '2015-03-01 00:42:09.000000', 'temperatura', 16.0000, 'ºC'),
	(83827, 110, '2015-03-01 00:42:10.000000', 'temperatura', 412.0000, 'ºC'),
	(83828, 110, '2015-03-01 00:42:11.000000', 'temperatura', 812.0000, 'ºC'),
	(83829, 110, '2015-03-01 00:42:12.000000', 'temperatura', 426.0000, 'ºC'),
	(83830, 110, '2015-03-01 00:42:13.000000', 'temperatura', 895.0000, 'ºC'),
	(83831, 110, '2015-03-01 00:42:14.000000', 'temperatura', 795.0000, 'ºC'),
	(83832, 110, '2015-03-01 00:42:15.000000', 'temperatura', 90.0000, 'ºC'),
	(83833, 110, '2015-03-01 00:42:16.000000', 'temperatura', 467.0000, 'ºC'),
	(83834, 110, '2015-03-01 00:42:17.000000', 'temperatura', 867.0000, 'ºC'),
	(83835, 110, '2015-03-01 00:42:18.000000', 'temperatura', 533.0000, 'ºC'),
	(83836, 110, '2015-03-01 00:42:19.000000', 'temperatura', 63.0000, 'ºC'),
	(83837, 110, '2015-03-01 00:42:20.000000', 'temperatura', 1117.0000, 'ºC'),
	(83838, 110, '2015-03-01 00:42:21.000000', 'temperatura', 595.0000, 'ºC'),
	(83839, 110, '2015-03-01 00:42:22.000000', 'temperatura', 825.0000, 'ºC'),
	(83840, 110, '2015-03-01 00:42:23.000000', 'temperatura', 1143.0000, 'ºC'),
	(83841, 110, '2015-03-01 00:42:24.000000', 'temperatura', 840.0000, 'ºC'),
	(83842, 110, '2015-03-01 00:42:25.000000', 'temperatura', 772.0000, 'ºC'),
	(83843, 110, '2015-03-01 00:42:26.000000', 'temperatura', 139.0000, 'ºC'),
	(83844, 110, '2015-03-01 00:42:27.000000', 'temperatura', 779.0000, 'ºC'),
	(83845, 110, '2015-03-01 00:42:28.000000', 'temperatura', 1080.0000, 'ºC'),
	(83846, 110, '2015-03-01 00:42:29.000000', 'temperatura', 662.0000, 'ºC'),
	(83847, 110, '2015-03-01 00:42:30.000000', 'temperatura', 72.0000, 'ºC'),
	(83848, 110, '2015-03-01 00:42:31.000000', 'temperatura', 776.0000, 'ºC'),
	(83849, 110, '2015-03-01 00:42:32.000000', 'temperatura', 61.0000, 'ºC'),
	(83850, 110, '2015-03-01 00:42:33.000000', 'temperatura', 380.0000, 'ºC'),
	(83851, 110, '2015-03-01 00:42:34.000000', 'temperatura', 515.0000, 'ºC'),
	(83852, 110, '2015-03-01 00:42:35.000000', 'temperatura', 239.0000, 'ºC'),
	(83853, 110, '2015-03-01 00:42:36.000000', 'temperatura', 848.0000, 'ºC'),
	(83854, 110, '2015-03-01 00:42:37.000000', 'temperatura', 1124.0000, 'ºC'),
	(83855, 110, '2015-03-01 00:42:38.000000', 'temperatura', 678.0000, 'ºC'),
	(83856, 110, '2015-03-01 00:42:39.000000', 'temperatura', 19.0000, 'ºC'),
	(83857, 110, '2015-03-01 00:42:40.000000', 'temperatura', 462.0000, 'ºC'),
	(83858, 110, '2015-03-01 00:42:41.000000', 'temperatura', 1051.0000, 'ºC'),
	(83859, 110, '2015-03-01 00:42:42.000000', 'temperatura', 269.0000, 'ºC'),
	(83860, 110, '2015-03-01 00:42:43.000000', 'temperatura', 594.0000, 'ºC'),
	(83861, 110, '2015-03-01 00:42:44.000000', 'temperatura', 963.0000, 'ºC'),
	(83862, 110, '2015-03-01 00:42:45.000000', 'temperatura', 632.0000, 'ºC'),
	(83863, 110, '2015-03-01 00:42:46.000000', 'temperatura', 272.0000, 'ºC'),
	(83864, 110, '2015-03-01 00:42:47.000000', 'temperatura', 666.0000, 'ºC'),
	(83865, 110, '2015-03-01 00:42:48.000000', 'temperatura', 115.0000, 'ºC'),
	(83866, 110, '2015-03-01 00:42:49.000000', 'temperatura', 975.0000, 'ºC'),
	(83867, 110, '2015-03-01 00:42:50.000000', 'temperatura', 931.0000, 'ºC'),
	(83868, 110, '2015-03-01 00:42:51.000000', 'temperatura', 531.0000, 'ºC'),
	(83869, 110, '2015-03-01 00:42:52.000000', 'temperatura', 1061.0000, 'ºC'),
	(83870, 110, '2015-03-01 00:42:53.000000', 'temperatura', 114.0000, 'ºC'),
	(83871, 110, '2015-03-01 00:42:54.000000', 'temperatura', 988.0000, 'ºC'),
	(83872, 110, '2015-03-01 00:42:55.000000', 'temperatura', 996.0000, 'ºC'),
	(83873, 110, '2015-03-01 00:42:56.000000', 'temperatura', 818.0000, 'ºC'),
	(83874, 110, '2015-03-01 00:42:57.000000', 'temperatura', 1103.0000, 'ºC'),
	(83875, 110, '2015-03-01 00:42:58.000000', 'temperatura', 662.0000, 'ºC'),
	(83876, 110, '2015-03-01 00:42:59.000000', 'temperatura', 1199.0000, 'ºC'),
	(83877, 110, '2015-03-01 00:43:00.000000', 'temperatura', 412.0000, 'ºC'),
	(83878, 110, '2015-03-01 00:43:01.000000', 'temperatura', 862.0000, 'ºC'),
	(83879, 110, '2015-03-01 00:43:02.000000', 'temperatura', 673.0000, 'ºC'),
	(83880, 110, '2015-03-01 00:43:03.000000', 'temperatura', 782.0000, 'ºC'),
	(83881, 110, '2015-03-01 00:43:04.000000', 'temperatura', 689.0000, 'ºC'),
	(83882, 110, '2015-03-01 00:43:05.000000', 'temperatura', 1100.0000, 'ºC'),
	(83883, 110, '2015-03-01 00:43:06.000000', 'temperatura', 1033.0000, 'ºC'),
	(83884, 110, '2015-03-01 00:43:07.000000', 'temperatura', 668.0000, 'ºC'),
	(83885, 110, '2015-03-01 00:43:08.000000', 'temperatura', 240.0000, 'ºC'),
	(83886, 110, '2015-03-01 00:43:09.000000', 'temperatura', 395.0000, 'ºC'),
	(83887, 110, '2015-03-01 00:43:10.000000', 'temperatura', 57.0000, 'ºC'),
	(83888, 110, '2015-03-01 00:43:11.000000', 'temperatura', 302.0000, 'ºC'),
	(83889, 110, '2015-03-01 00:43:12.000000', 'temperatura', 139.0000, 'ºC'),
	(83890, 110, '2015-03-01 00:43:13.000000', 'temperatura', 991.0000, 'ºC'),
	(83891, 110, '2015-03-01 00:43:14.000000', 'temperatura', 937.0000, 'ºC'),
	(83892, 110, '2015-03-01 00:43:15.000000', 'temperatura', 515.0000, 'ºC'),
	(83893, 110, '2015-03-01 00:43:16.000000', 'temperatura', 961.0000, 'ºC'),
	(83894, 110, '2015-03-01 00:43:17.000000', 'temperatura', 863.0000, 'ºC'),
	(83895, 110, '2015-03-01 00:43:18.000000', 'temperatura', 230.0000, 'ºC'),
	(83896, 110, '2015-03-01 00:43:19.000000', 'temperatura', 961.0000, 'ºC'),
	(83897, 110, '2015-03-01 00:43:20.000000', 'temperatura', 515.0000, 'ºC'),
	(83898, 110, '2015-03-01 00:43:21.000000', 'temperatura', 895.0000, 'ºC'),
	(83899, 110, '2015-03-01 00:43:22.000000', 'temperatura', 530.0000, 'ºC'),
	(83900, 110, '2015-03-01 00:43:23.000000', 'temperatura', 1164.0000, 'ºC'),
	(83901, 110, '2015-03-01 00:43:24.000000', 'temperatura', 633.0000, 'ºC'),
	(83902, 110, '2015-03-01 00:43:25.000000', 'temperatura', 874.0000, 'ºC'),
	(83903, 110, '2015-03-01 00:43:26.000000', 'temperatura', 70.0000, 'ºC'),
	(83904, 110, '2015-03-01 00:43:27.000000', 'temperatura', 128.0000, 'ºC'),
	(83905, 110, '2015-03-01 00:43:28.000000', 'temperatura', 433.0000, 'ºC'),
	(83906, 110, '2015-03-01 00:43:29.000000', 'temperatura', 579.0000, 'ºC'),
	(83907, 110, '2015-03-01 00:43:30.000000', 'temperatura', 395.0000, 'ºC'),
	(83908, 110, '2015-03-01 00:43:31.000000', 'temperatura', 241.0000, 'ºC'),
	(83909, 110, '2015-03-01 00:43:32.000000', 'temperatura', 21.0000, 'ºC'),
	(83910, 110, '2015-03-01 00:43:33.000000', 'temperatura', 580.0000, 'ºC'),
	(83911, 110, '2015-03-01 00:43:34.000000', 'temperatura', 437.0000, 'ºC'),
	(83912, 110, '2015-03-01 00:43:35.000000', 'temperatura', 448.0000, 'ºC'),
	(83913, 110, '2015-03-01 00:43:36.000000', 'temperatura', 927.0000, 'ºC'),
	(83914, 110, '2015-03-01 00:43:37.000000', 'temperatura', 894.0000, 'ºC'),
	(83915, 110, '2015-03-01 00:43:38.000000', 'temperatura', 490.0000, 'ºC'),
	(83916, 110, '2015-03-01 00:43:39.000000', 'temperatura', 968.0000, 'ºC'),
	(83917, 110, '2015-03-01 00:43:40.000000', 'temperatura', 970.0000, 'ºC'),
	(83918, 110, '2015-03-01 00:43:41.000000', 'temperatura', 749.0000, 'ºC'),
	(83919, 110, '2015-03-01 00:43:42.000000', 'temperatura', 832.0000, 'ºC'),
	(83920, 110, '2015-03-01 00:43:43.000000', 'temperatura', 716.0000, 'ºC'),
	(83921, 110, '2015-03-01 00:43:44.000000', 'temperatura', 1085.0000, 'ºC'),
	(83922, 110, '2015-03-01 00:43:45.000000', 'temperatura', 875.0000, 'ºC'),
	(83923, 110, '2015-03-01 00:43:46.000000', 'temperatura', 1122.0000, 'ºC'),
	(83924, 110, '2015-03-01 00:43:47.000000', 'temperatura', 585.0000, 'ºC'),
	(83925, 110, '2015-03-01 00:43:48.000000', 'temperatura', 761.0000, 'ºC'),
	(83926, 110, '2015-03-01 00:43:49.000000', 'temperatura', 848.0000, 'ºC'),
	(83927, 110, '2015-03-01 00:43:50.000000', 'temperatura', 758.0000, 'ºC'),
	(83928, 110, '2015-03-01 00:43:51.000000', 'temperatura', 46.0000, 'ºC'),
	(83929, 110, '2015-03-01 00:43:52.000000', 'temperatura', 358.0000, 'ºC'),
	(83930, 110, '2015-03-01 00:43:53.000000', 'temperatura', 454.0000, 'ºC'),
	(83931, 110, '2015-03-01 00:43:54.000000', 'temperatura', 1195.0000, 'ºC'),
	(83932, 110, '2015-03-01 00:43:55.000000', 'temperatura', 1014.0000, 'ºC'),
	(83933, 110, '2015-03-01 00:43:56.000000', 'temperatura', 287.0000, 'ºC'),
	(83934, 110, '2015-03-01 00:43:57.000000', 'temperatura', 793.0000, 'ºC'),
	(83935, 110, '2015-03-01 00:43:58.000000', 'temperatura', 706.0000, 'ºC'),
	(83936, 110, '2015-03-01 00:43:59.000000', 'temperatura', 1149.0000, 'ºC'),
	(83937, 110, '2015-03-01 00:44:00.000000', 'temperatura', 29.0000, 'ºC'),
	(83938, 110, '2015-03-01 00:44:01.000000', 'temperatura', 297.0000, 'ºC'),
	(83939, 110, '2015-03-01 00:44:02.000000', 'temperatura', 199.0000, 'ºC'),
	(83940, 110, '2015-03-01 00:44:03.000000', 'temperatura', 106.0000, 'ºC'),
	(83941, 110, '2015-03-01 00:44:04.000000', 'temperatura', 1133.0000, 'ºC'),
	(83942, 110, '2015-03-01 00:44:05.000000', 'temperatura', 549.0000, 'ºC'),
	(83943, 110, '2015-03-01 00:44:06.000000', 'temperatura', 545.0000, 'ºC'),
	(83944, 110, '2015-03-01 00:44:07.000000', 'temperatura', 1077.0000, 'ºC'),
	(83945, 110, '2015-03-01 00:44:08.000000', 'temperatura', 153.0000, 'ºC'),
	(83946, 110, '2015-03-01 00:44:09.000000', 'temperatura', 1134.0000, 'ºC'),
	(83947, 110, '2015-03-01 00:44:10.000000', 'temperatura', 411.0000, 'ºC'),
	(83948, 110, '2015-03-01 00:44:11.000000', 'temperatura', 1056.0000, 'ºC'),
	(83949, 110, '2015-03-01 00:44:12.000000', 'temperatura', 445.0000, 'ºC'),
	(83950, 110, '2015-03-01 00:44:13.000000', 'temperatura', 256.0000, 'ºC'),
	(83951, 110, '2015-03-01 00:44:14.000000', 'temperatura', 1149.0000, 'ºC'),
	(83952, 110, '2015-03-01 00:44:15.000000', 'temperatura', 174.0000, 'ºC'),
	(83953, 110, '2015-03-01 00:44:16.000000', 'temperatura', 1025.0000, 'ºC'),
	(83954, 110, '2015-03-01 00:44:17.000000', 'temperatura', 1006.0000, 'ºC'),
	(83955, 110, '2015-03-01 00:44:18.000000', 'temperatura', 752.0000, 'ºC'),
	(83956, 110, '2015-03-01 00:44:19.000000', 'temperatura', 743.0000, 'ºC'),
	(83957, 110, '2015-03-01 00:44:20.000000', 'temperatura', 259.0000, 'ºC'),
	(83958, 110, '2015-03-01 00:44:21.000000', 'temperatura', 267.0000, 'ºC'),
	(83959, 110, '2015-03-01 00:44:22.000000', 'temperatura', 558.0000, 'ºC'),
	(83960, 110, '2015-03-01 00:44:23.000000', 'temperatura', 790.0000, 'ºC'),
	(83961, 110, '2015-03-01 00:44:24.000000', 'temperatura', 1076.0000, 'ºC'),
	(83962, 110, '2015-03-01 00:44:25.000000', 'temperatura', 613.0000, 'ºC'),
	(83963, 110, '2015-03-01 00:44:26.000000', 'temperatura', 1035.0000, 'ºC'),
	(83964, 110, '2015-03-01 00:44:27.000000', 'temperatura', 935.0000, 'ºC'),
	(83965, 110, '2015-03-01 00:44:28.000000', 'temperatura', 374.0000, 'ºC'),
	(83966, 110, '2015-03-01 00:44:29.000000', 'temperatura', 263.0000, 'ºC'),
	(83967, 110, '2015-03-01 00:44:30.000000', 'temperatura', 196.0000, 'ºC'),
	(83968, 110, '2015-03-01 00:44:31.000000', 'temperatura', 189.0000, 'ºC'),
	(83969, 110, '2015-03-01 00:44:32.000000', 'temperatura', 357.0000, 'ºC'),
	(83970, 110, '2015-03-01 00:44:33.000000', 'temperatura', 21.0000, 'ºC'),
	(83971, 110, '2015-03-01 00:44:34.000000', 'temperatura', 232.0000, 'ºC'),
	(83972, 110, '2015-03-01 00:44:35.000000', 'temperatura', 1099.0000, 'ºC'),
	(83973, 110, '2015-03-01 00:44:36.000000', 'temperatura', 0.0000, 'ºC'),
	(83974, 110, '2015-03-01 00:44:37.000000', 'temperatura', 303.0000, 'ºC'),
	(83975, 110, '2015-03-01 00:44:38.000000', 'temperatura', 316.0000, 'ºC'),
	(83976, 110, '2015-03-01 00:44:39.000000', 'temperatura', 670.0000, 'ºC'),
	(83977, 110, '2015-03-01 00:44:40.000000', 'temperatura', 2.0000, 'ºC'),
	(83978, 110, '2015-03-01 00:44:41.000000', 'temperatura', 401.0000, 'ºC'),
	(83979, 110, '2015-03-01 00:44:42.000000', 'temperatura', 801.0000, 'ºC'),
	(83980, 110, '2015-03-01 00:44:43.000000', 'temperatura', 403.0000, 'ºC'),
	(83981, 110, '2015-03-01 00:44:44.000000', 'temperatura', 810.0000, 'ºC'),
	(83982, 110, '2015-03-01 00:44:45.000000', 'temperatura', 443.0000, 'ºC'),
	(83983, 110, '2015-03-01 00:44:46.000000', 'temperatura', 983.0000, 'ºC'),
	(83984, 110, '2015-03-01 00:44:47.000000', 'temperatura', 1190.0000, 'ºC'),
	(83985, 110, '2015-03-01 00:44:48.000000', 'temperatura', 599.0000, 'ºC'),
	(83986, 110, '2015-03-01 00:44:49.000000', 'temperatura', 626.0000, 'ºC'),
	(83987, 110, '2015-03-01 00:44:50.000000', 'temperatura', 134.0000, 'ºC'),
	(83988, 110, '2015-03-01 00:44:51.000000', 'temperatura', 1191.0000, 'ºC'),
	(83989, 110, '2015-03-01 00:44:52.000000', 'temperatura', 755.0000, 'ºC'),
	(83990, 110, '2015-03-01 00:44:53.000000', 'temperatura', 204.0000, 'ºC'),
	(83991, 110, '2015-03-01 00:44:54.000000', 'temperatura', 1153.0000, 'ºC'),
	(83992, 110, '2015-03-01 00:44:55.000000', 'temperatura', 353.0000, 'ºC'),
	(83993, 110, '2015-03-01 00:44:56.000000', 'temperatura', 706.0000, 'ºC'),
	(83994, 110, '2015-03-01 00:44:57.000000', 'temperatura', 71.0000, 'ºC'),
	(83995, 110, '2015-03-01 00:44:58.000000', 'temperatura', 638.0000, 'ºC'),
	(83996, 110, '2015-03-01 00:44:59.000000', 'temperatura', 578.0000, 'ºC'),
	(83997, 110, '2015-03-01 00:45:00.000000', 'temperatura', 975.0000, 'ºC'),
	(83998, 110, '2015-03-01 00:45:01.000000', 'temperatura', 743.0000, 'ºC'),
	(83999, 110, '2015-03-01 00:45:02.000000', 'temperatura', 789.0000, 'ºC'),
	(84000, 110, '2015-03-01 00:45:03.000000', 'temperatura', 518.0000, 'ºC'),
	(84001, 110, '2015-03-01 00:45:04.000000', 'temperatura', 225.0000, 'ºC'),
	(84002, 110, '2015-03-01 00:45:05.000000', 'temperatura', 770.0000, 'ºC'),
	(84003, 110, '2015-03-01 00:45:06.000000', 'temperatura', 774.0000, 'ºC'),
	(84004, 110, '2015-03-01 00:45:07.000000', 'temperatura', 361.0000, 'ºC'),
	(84005, 110, '2015-03-01 00:45:08.000000', 'temperatura', 685.0000, 'ºC'),
	(84006, 110, '2015-03-01 00:45:09.000000', 'temperatura', 1143.0000, 'ºC'),
	(84007, 110, '2015-03-01 00:45:10.000000', 'temperatura', 60.0000, 'ºC'),
	(84008, 110, '2015-03-01 00:45:11.000000', 'temperatura', 470.0000, 'ºC'),
	(84009, 110, '2015-03-01 00:45:12.000000', 'temperatura', 970.0000, 'ºC'),
	(84010, 110, '2015-03-01 00:45:13.000000', 'temperatura', 1040.0000, 'ºC'),
	(84011, 110, '2015-03-01 00:45:14.000000', 'temperatura', 1093.0000, 'ºC'),
	(84012, 110, '2015-03-01 00:45:15.000000', 'temperatura', 1144.0000, 'ºC'),
	(84013, 110, '2015-03-01 00:45:16.000000', 'temperatura', 43.0000, 'ºC'),
	(84014, 110, '2015-03-01 00:45:17.000000', 'temperatura', 384.0000, 'ºC'),
	(84015, 110, '2015-03-01 00:45:18.000000', 'temperatura', 592.0000, 'ºC'),
	(84016, 110, '2015-03-01 00:45:19.000000', 'temperatura', 608.0000, 'ºC'),
	(84017, 110, '2015-03-01 00:45:20.000000', 'temperatura', 62.0000, 'ºC'),
	(84018, 110, '2015-03-01 00:45:21.000000', 'temperatura', 889.0000, 'ºC'),
	(84019, 110, '2015-03-01 00:45:22.000000', 'temperatura', 658.0000, 'ºC'),
	(84020, 110, '2015-03-01 00:45:23.000000', 'temperatura', 626.0000, 'ºC'),
	(84021, 110, '2015-03-01 00:45:24.000000', 'temperatura', 1153.0000, 'ºC'),
	(84022, 110, '2015-03-01 00:45:25.000000', 'temperatura', 290.0000, 'ºC'),
	(84023, 110, '2015-03-01 00:45:26.000000', 'temperatura', 389.0000, 'ºC'),
	(84024, 110, '2015-03-01 00:45:27.000000', 'temperatura', 1078.0000, 'ºC'),
	(84025, 110, '2015-03-01 00:45:28.000000', 'temperatura', 624.0000, 'ºC'),
	(84026, 110, '2015-03-01 00:45:29.000000', 'temperatura', 1084.0000, 'ºC'),
	(84027, 110, '2015-03-01 00:45:30.000000', 'temperatura', 1150.0000, 'ºC'),
	(84028, 110, '2015-03-01 00:45:31.000000', 'temperatura', 98.0000, 'ºC'),
	(84029, 110, '2015-03-01 00:45:32.000000', 'temperatura', 639.0000, 'ºC'),
	(84030, 110, '2015-03-01 00:45:33.000000', 'temperatura', 502.0000, 'ºC'),
	(84031, 110, '2015-03-01 00:45:34.000000', 'temperatura', 593.0000, 'ºC'),
	(84032, 110, '2015-03-01 00:45:35.000000', 'temperatura', 262.0000, 'ºC'),
	(84033, 110, '2015-03-01 00:45:36.000000', 'temperatura', 731.0000, 'ºC'),
	(84034, 110, '2015-03-01 00:45:37.000000', 'temperatura', 470.0000, 'ºC'),
	(84035, 110, '2015-03-01 00:45:38.000000', 'temperatura', 157.0000, 'ºC'),
	(84036, 110, '2015-03-01 00:45:39.000000', 'temperatura', 577.0000, 'ºC'),
	(84037, 110, '2015-03-01 00:45:40.000000', 'temperatura', 11.0000, 'ºC'),
	(84038, 110, '2015-03-01 00:45:41.000000', 'temperatura', 728.0000, 'ºC'),
	(84039, 110, '2015-03-01 00:45:42.000000', 'temperatura', 4.0000, 'ºC'),
	(84040, 110, '2015-03-01 00:45:43.000000', 'temperatura', 239.0000, 'ºC'),
	(84041, 110, '2015-03-01 00:45:44.000000', 'temperatura', 1183.0000, 'ºC'),
	(84042, 110, '2015-03-01 00:45:45.000000', 'temperatura', 400.0000, 'ºC'),
	(84043, 110, '2015-03-01 00:45:46.000000', 'temperatura', 850.0000, 'ºC'),
	(84044, 110, '2015-03-01 00:45:47.000000', 'temperatura', 649.0000, 'ºC'),
	(84045, 110, '2015-03-01 00:45:48.000000', 'temperatura', 698.0000, 'ºC'),
	(84046, 110, '2015-03-01 00:45:49.000000', 'temperatura', 343.0000, 'ºC'),
	(84047, 110, '2015-03-01 00:45:50.000000', 'temperatura', 822.0000, 'ºC'),
	(84048, 110, '2015-03-01 00:45:51.000000', 'temperatura', 683.0000, 'ºC'),
	(84049, 110, '2015-03-01 00:45:52.000000', 'temperatura', 946.0000, 'ºC'),
	(84050, 110, '2015-03-01 00:45:53.000000', 'temperatura', 285.0000, 'ºC'),
	(84051, 110, '2015-03-01 00:45:54.000000', 'temperatura', 986.0000, 'ºC'),
	(84052, 110, '2015-03-01 00:45:55.000000', 'temperatura', 474.0000, 'ºC'),
	(84053, 110, '2015-03-01 00:45:56.000000', 'temperatura', 612.0000, 'ºC'),
	(84054, 110, '2015-03-01 00:45:57.000000', 'temperatura', 439.0000, 'ºC'),
	(84055, 110, '2015-03-01 00:45:58.000000', 'temperatura', 360.0000, 'ºC'),
	(84056, 110, '2015-03-01 00:45:59.000000', 'temperatura', 483.0000, 'ºC'),
	(84057, 110, '2015-03-01 00:46:00.000000', 'temperatura', 135.0000, 'ºC'),
	(84058, 110, '2015-03-01 00:46:01.000000', 'temperatura', 428.0000, 'ºC'),
	(84059, 110, '2015-03-01 00:46:02.000000', 'temperatura', 534.0000, 'ºC'),
	(84060, 110, '2015-03-01 00:46:03.000000', 'temperatura', 189.0000, 'ºC'),
	(84061, 110, '2015-03-01 00:46:04.000000', 'temperatura', 543.0000, 'ºC'),
	(84062, 110, '2015-03-01 00:46:05.000000', 'temperatura', 946.0000, 'ºC'),
	(84063, 110, '2015-03-01 00:46:06.000000', 'temperatura', 704.0000, 'ºC'),
	(84064, 110, '2015-03-01 00:46:07.000000', 'temperatura', 684.0000, 'ºC'),
	(84065, 110, '2015-03-01 00:46:08.000000', 'temperatura', 106.0000, 'ºC'),
	(84066, 110, '2015-03-01 00:46:09.000000', 'temperatura', 877.0000, 'ºC'),
	(84067, 110, '2015-03-01 00:46:10.000000', 'temperatura', 469.0000, 'ºC'),
	(84068, 110, '2015-03-01 00:46:11.000000', 'temperatura', 915.0000, 'ºC'),
	(84069, 110, '2015-03-01 00:46:12.000000', 'temperatura', 768.0000, 'ºC'),
	(84070, 110, '2015-03-01 00:46:13.000000', 'temperatura', 1097.0000, 'ºC'),
	(84071, 110, '2015-03-01 00:46:14.000000', 'temperatura', 780.0000, 'ºC'),
	(84072, 110, '2015-03-01 00:46:15.000000', 'temperatura', 608.0000, 'ºC'),
	(84073, 110, '2015-03-01 00:46:16.000000', 'temperatura', 702.0000, 'ºC'),
	(84074, 110, '2015-03-01 00:46:17.000000', 'temperatura', 487.0000, 'ºC'),
	(84075, 110, '2015-03-01 00:46:18.000000', 'temperatura', 327.0000, 'ºC'),
	(84076, 110, '2015-03-01 00:46:19.000000', 'temperatura', 177.0000, 'ºC'),
	(84077, 110, '2015-03-01 00:46:20.000000', 'temperatura', 1102.0000, 'ºC'),
	(84078, 110, '2015-03-01 00:46:21.000000', 'temperatura', 181.0000, 'ºC'),
	(84079, 110, '2015-03-01 00:46:22.000000', 'temperatura', 1198.0000, 'ºC'),
	(84080, 110, '2015-03-01 00:46:23.000000', 'temperatura', 648.0000, 'ºC'),
	(84081, 110, '2015-03-01 00:46:24.000000', 'temperatura', 846.0000, 'ºC'),
	(84082, 110, '2015-03-01 00:46:25.000000', 'temperatura', 1085.0000, 'ºC'),
	(84083, 110, '2015-03-01 00:46:26.000000', 'temperatura', 489.0000, 'ºC'),
	(84084, 110, '2015-03-01 00:46:27.000000', 'temperatura', 392.0000, 'ºC'),
	(84085, 110, '2015-03-01 00:46:28.000000', 'temperatura', 492.0000, 'ºC'),
	(84086, 110, '2015-03-01 00:46:29.000000', 'temperatura', 83.0000, 'ºC'),
	(84087, 110, '2015-03-01 00:46:30.000000', 'temperatura', 140.0000, 'ºC'),
	(84088, 110, '2015-03-01 00:46:31.000000', 'temperatura', 451.0000, 'ºC'),
	(84089, 110, '2015-03-01 00:46:32.000000', 'temperatura', 638.0000, 'ºC'),
	(84090, 110, '2015-03-01 00:46:33.000000', 'temperatura', 637.0000, 'ºC'),
	(84091, 110, '2015-03-01 00:46:34.000000', 'temperatura', 70.0000, 'ºC'),
	(84092, 110, '2015-03-01 00:46:35.000000', 'temperatura', 840.0000, 'ºC'),
	(84093, 110, '2015-03-01 00:46:36.000000', 'temperatura', 390.0000, 'ºC'),
	(84094, 110, '2015-03-01 00:46:37.000000', 'temperatura', 629.0000, 'ºC'),
	(84095, 110, '2015-03-01 00:46:38.000000', 'temperatura', 778.0000, 'ºC'),
	(84096, 110, '2015-03-01 00:46:39.000000', 'temperatura', 805.0000, 'ºC'),
	(84097, 110, '2015-03-01 00:46:40.000000', 'temperatura', 489.0000, 'ºC'),
	(84098, 110, '2015-03-01 00:46:41.000000', 'temperatura', 29.0000, 'ºC'),
	(84099, 110, '2015-03-01 00:46:42.000000', 'temperatura', 1082.0000, 'ºC'),
	(84100, 110, '2015-03-01 00:46:43.000000', 'temperatura', 520.0000, 'ºC'),
	(84101, 110, '2015-03-01 00:46:44.000000', 'temperatura', 558.0000, 'ºC'),
	(84102, 110, '2015-03-01 00:46:45.000000', 'temperatura', 28.0000, 'ºC'),
	(84103, 110, '2015-03-01 00:46:46.000000', 'temperatura', 868.0000, 'ºC'),
	(84104, 110, '2015-03-01 00:46:47.000000', 'temperatura', 655.0000, 'ºC'),
	(84105, 110, '2015-03-01 00:46:48.000000', 'temperatura', 674.0000, 'ºC'),
	(84106, 110, '2015-03-01 00:46:49.000000', 'temperatura', 203.0000, 'ºC'),
	(84107, 110, '2015-03-01 00:46:50.000000', 'temperatura', 194.0000, 'ºC'),
	(84108, 110, '2015-03-01 00:46:51.000000', 'temperatura', 360.0000, 'ºC'),
	(84109, 110, '2015-03-01 00:46:52.000000', 'temperatura', 20.0000, 'ºC'),
	(84110, 110, '2015-03-01 00:46:53.000000', 'temperatura', 221.0000, 'ºC'),
	(84111, 110, '2015-03-01 00:46:54.000000', 'temperatura', 1045.0000, 'ºC'),
	(84112, 110, '2015-03-01 00:46:55.000000', 'temperatura', 963.0000, 'ºC'),
	(84113, 110, '2015-03-01 00:46:56.000000', 'temperatura', 479.0000, 'ºC'),
	(84114, 110, '2015-03-01 00:46:57.000000', 'temperatura', 708.0000, 'ºC'),
	(84115, 110, '2015-03-01 00:46:58.000000', 'temperatura', 902.0000, 'ºC'),
	(84116, 110, '2015-03-01 00:46:59.000000', 'temperatura', 1186.0000, 'ºC'),
	(84117, 110, '2015-03-01 00:47:00.000000', 'temperatura', 827.0000, 'ºC'),
	(84118, 110, '2015-03-01 00:47:01.000000', 'temperatura', 578.0000, 'ºC'),
	(84119, 110, '2015-03-01 00:47:02.000000', 'temperatura', 409.0000, 'ºC'),
	(84120, 110, '2015-03-01 00:47:03.000000', 'temperatura', 312.0000, 'ºC'),
	(84121, 110, '2015-03-01 00:47:04.000000', 'temperatura', 332.0000, 'ºC'),
	(84122, 110, '2015-03-01 00:47:05.000000', 'temperatura', 724.0000, 'ºC'),
	(84123, 110, '2015-03-01 00:47:06.000000', 'temperatura', 223.0000, 'ºC'),
	(84124, 110, '2015-03-01 00:47:07.000000', 'temperatura', 146.0000, 'ºC'),
	(84125, 110, '2015-03-01 00:47:08.000000', 'temperatura', 59.0000, 'ºC'),
	(84126, 110, '2015-03-01 00:47:09.000000', 'temperatura', 1059.0000, 'ºC'),
	(84127, 110, '2015-03-01 00:47:10.000000', 'temperatura', 320.0000, 'ºC'),
	(84128, 110, '2015-03-01 00:47:11.000000', 'temperatura', 822.0000, 'ºC'),
	(84129, 110, '2015-03-01 00:47:12.000000', 'temperatura', 751.0000, 'ºC'),
	(84130, 110, '2015-03-01 00:47:13.000000', 'temperatura', 91.0000, 'ºC'),
	(84131, 110, '2015-03-01 00:47:14.000000', 'temperatura', 602.0000, 'ºC'),
	(84132, 110, '2015-03-01 00:47:15.000000', 'temperatura', 336.0000, 'ºC'),
	(84133, 110, '2015-03-01 00:47:16.000000', 'temperatura', 1074.0000, 'ºC'),
	(84134, 110, '2015-03-01 00:47:17.000000', 'temperatura', 764.0000, 'ºC'),
	(84135, 110, '2015-03-01 00:47:18.000000', 'temperatura', 597.0000, 'ºC'),
	(84136, 110, '2015-03-01 00:47:19.000000', 'temperatura', 693.0000, 'ºC'),
	(84137, 110, '2015-03-01 00:47:20.000000', 'temperatura', 476.0000, 'ºC'),
	(84138, 110, '2015-03-01 00:47:21.000000', 'temperatura', 301.0000, 'ºC'),
	(84139, 110, '2015-03-01 00:47:22.000000', 'temperatura', 77.0000, 'ºC'),
	(84140, 110, '2015-03-01 00:47:23.000000', 'temperatura', 682.0000, 'ºC'),
	(84141, 110, '2015-03-01 00:47:24.000000', 'temperatura', 782.0000, 'ºC'),
	(84142, 110, '2015-03-01 00:47:25.000000', 'temperatura', 663.0000, 'ºC'),
	(84143, 110, '2015-03-01 00:47:26.000000', 'temperatura', 968.0000, 'ºC'),
	(84144, 110, '2015-03-01 00:47:27.000000', 'temperatura', 452.0000, 'ºC'),
	(84145, 110, '2015-03-01 00:47:28.000000', 'temperatura', 558.0000, 'ºC'),
	(84146, 110, '2015-03-01 00:47:29.000000', 'temperatura', 235.0000, 'ºC'),
	(84147, 110, '2015-03-01 00:47:30.000000', 'temperatura', 700.0000, 'ºC'),
	(84148, 110, '2015-03-01 00:47:31.000000', 'temperatura', 397.0000, 'ºC'),
	(84149, 110, '2015-03-01 00:47:32.000000', 'temperatura', 1084.0000, 'ºC'),
	(84150, 110, '2015-03-01 00:47:33.000000', 'temperatura', 629.0000, 'ºC'),
	(84151, 110, '2015-03-01 00:47:34.000000', 'temperatura', 1092.0000, 'ºC'),
	(84152, 110, '2015-03-01 00:47:35.000000', 'temperatura', 1176.0000, 'ºC'),
	(84153, 110, '2015-03-01 00:47:36.000000', 'temperatura', 203.0000, 'ºC'),
	(84154, 110, '2015-03-01 00:47:37.000000', 'temperatura', 1089.0000, 'ºC'),
	(84155, 110, '2015-03-01 00:47:38.000000', 'temperatura', 37.0000, 'ºC'),
	(84156, 110, '2015-03-01 00:47:39.000000', 'temperatura', 518.0000, 'ºC'),
	(84157, 110, '2015-03-01 00:47:40.000000', 'temperatura', 80.0000, 'ºC'),
	(84158, 110, '2015-03-01 00:47:41.000000', 'temperatura', 45.0000, 'ºC'),
	(84159, 110, '2015-03-01 00:47:42.000000', 'temperatura', 1185.0000, 'ºC'),
	(84160, 110, '2015-03-01 00:47:43.000000', 'temperatura', 991.0000, 'ºC'),
	(84161, 110, '2015-03-01 00:47:44.000000', 'temperatura', 202.0000, 'ºC'),
	(84162, 110, '2015-03-01 00:47:45.000000', 'temperatura', 437.0000, 'ºC'),
	(84163, 110, '2015-03-01 00:47:46.000000', 'temperatura', 379.0000, 'ºC'),
	(84164, 110, '2015-03-01 00:47:47.000000', 'temperatura', 583.0000, 'ºC'),
	(84165, 110, '2015-03-01 00:47:48.000000', 'temperatura', 579.0000, 'ºC'),
	(84166, 110, '2015-03-01 00:47:49.000000', 'temperatura', 1149.0000, 'ºC'),
	(84167, 110, '2015-03-01 00:47:50.000000', 'temperatura', 407.0000, 'ºC'),
	(84168, 110, '2015-03-01 00:47:51.000000', 'temperatura', 991.0000, 'ºC'),
	(84169, 110, '2015-03-01 00:47:52.000000', 'temperatura', 131.0000, 'ºC'),
	(84170, 110, '2015-03-01 00:47:53.000000', 'temperatura', 83.0000, 'ºC'),
	(84171, 110, '2015-03-01 00:47:54.000000', 'temperatura', 22.0000, 'ºC'),
	(84172, 110, '2015-03-01 00:47:55.000000', 'temperatura', 1062.0000, 'ºC'),
	(84173, 110, '2015-03-01 00:47:56.000000', 'temperatura', 445.0000, 'ºC'),
	(84174, 110, '2015-03-01 00:47:57.000000', 'temperatura', 239.0000, 'ºC'),
	(84175, 110, '2015-03-01 00:47:58.000000', 'temperatura', 1061.0000, 'ºC'),
	(84176, 110, '2015-03-01 00:47:59.000000', 'temperatura', 989.0000, 'ºC'),
	(84177, 110, '2015-03-01 00:48:00.000000', 'temperatura', 561.0000, 'ºC'),
	(84178, 110, '2015-03-01 00:48:01.000000', 'temperatura', 1038.0000, 'ºC'),
	(84179, 110, '2015-03-01 00:48:02.000000', 'temperatura', 1108.0000, 'ºC'),
	(84180, 110, '2015-03-01 00:48:03.000000', 'temperatura', 25.0000, 'ºC'),
	(84181, 110, '2015-03-01 00:48:04.000000', 'temperatura', 402.0000, 'ºC'),
	(84182, 110, '2015-03-01 00:48:05.000000', 'temperatura', 737.0000, 'ºC'),
	(84183, 110, '2015-03-01 00:48:06.000000', 'temperatura', 80.0000, 'ºC'),
	(84184, 110, '2015-03-01 00:48:07.000000', 'temperatura', 588.0000, 'ºC'),
	(84185, 110, '2015-03-01 00:48:08.000000', 'temperatura', 303.0000, 'ºC'),
	(84186, 110, '2015-03-01 00:48:09.000000', 'temperatura', 950.0000, 'ºC'),
	(84187, 110, '2015-03-01 00:48:10.000000', 'temperatura', 241.0000, 'ºC'),
	(84188, 110, '2015-03-01 00:48:11.000000', 'temperatura', 758.0000, 'ºC'),
	(84189, 110, '2015-03-01 00:48:12.000000', 'temperatura', 665.0000, 'ºC'),
	(84190, 110, '2015-03-01 00:48:13.000000', 'temperatura', 1053.0000, 'ºC'),
	(84191, 110, '2015-03-01 00:48:14.000000', 'temperatura', 872.0000, 'ºC'),
	(84192, 110, '2015-03-01 00:48:15.000000', 'temperatura', 0.0000, 'ºC'),
	(84193, 110, '2015-03-01 00:48:16.000000', 'temperatura', 983.0000, 'ºC'),
	(84194, 110, '2015-03-01 00:48:17.000000', 'temperatura', 117.0000, 'ºC'),
	(84195, 110, '2015-03-01 00:48:18.000000', 'temperatura', 36.0000, 'ºC'),
	(84196, 110, '2015-03-01 00:48:19.000000', 'temperatura', 1031.0000, 'ºC'),
	(84197, 110, '2015-03-01 00:48:20.000000', 'temperatura', 248.0000, 'ºC'),
	(84198, 110, '2015-03-01 00:48:21.000000', 'temperatura', 548.0000, 'ºC'),
	(84199, 110, '2015-03-01 00:48:22.000000', 'temperatura', 796.0000, 'ºC'),
	(84200, 110, '2015-03-01 00:48:23.000000', 'temperatura', 1137.0000, 'ºC'),
	(84201, 110, '2015-03-01 00:48:24.000000', 'temperatura', 898.0000, 'ºC'),
	(84202, 110, '2015-03-01 00:48:25.000000', 'temperatura', 1078.0000, 'ºC'),
	(84203, 110, '2015-03-01 00:48:26.000000', 'temperatura', 298.0000, 'ºC'),
	(84204, 110, '2015-03-01 00:48:27.000000', 'temperatura', 654.0000, 'ºC'),
	(84205, 110, '2015-03-01 00:48:28.000000', 'temperatura', 1177.0000, 'ºC'),
	(84206, 110, '2015-03-01 00:48:29.000000', 'temperatura', 325.0000, 'ºC'),
	(84207, 110, '2015-03-01 00:48:30.000000', 'temperatura', 492.0000, 'ºC'),
	(84208, 110, '2015-03-01 00:48:31.000000', 'temperatura', 285.0000, 'ºC'),
	(84209, 110, '2015-03-01 00:48:32.000000', 'temperatura', 1153.0000, 'ºC'),
	(84210, 110, '2015-03-01 00:48:33.000000', 'temperatura', 107.0000, 'ºC'),
	(84211, 110, '2015-03-01 00:48:34.000000', 'temperatura', 680.0000, 'ºC'),
	(84212, 110, '2015-03-01 00:48:35.000000', 'temperatura', 677.0000, 'ºC'),
	(84213, 110, '2015-03-01 00:48:36.000000', 'temperatura', 147.0000, 'ºC'),
	(84214, 110, '2015-03-01 00:48:37.000000', 'temperatura', 1104.0000, 'ºC'),
	(84215, 110, '2015-03-01 00:48:38.000000', 'temperatura', 280.0000, 'ºC'),
	(84216, 110, '2015-03-01 00:48:39.000000', 'temperatura', 489.0000, 'ºC'),
	(84217, 110, '2015-03-01 00:48:40.000000', 'temperatura', 405.0000, 'ºC'),
	(84218, 110, '2015-03-01 00:48:41.000000', 'temperatura', 558.0000, 'ºC'),
	(84219, 110, '2015-03-01 00:48:42.000000', 'temperatura', 377.0000, 'ºC'),
	(84220, 110, '2015-03-01 00:48:43.000000', 'temperatura', 211.0000, 'ºC'),
	(84221, 110, '2015-03-01 00:48:44.000000', 'temperatura', 1122.0000, 'ºC'),
	(84222, 110, '2015-03-01 00:48:45.000000', 'temperatura', 180.0000, 'ºC'),
	(84223, 110, '2015-03-01 00:48:46.000000', 'temperatura', 1135.0000, 'ºC'),
	(84224, 110, '2015-03-01 00:48:47.000000', 'temperatura', 337.0000, 'ºC'),
	(84225, 110, '2015-03-01 00:48:48.000000', 'temperatura', 677.0000, 'ºC'),
	(84226, 110, '2015-03-01 00:48:49.000000', 'temperatura', 1177.0000, 'ºC'),
	(84227, 110, '2015-03-01 00:48:50.000000', 'temperatura', 252.0000, 'ºC'),
	(84228, 110, '2015-03-01 00:48:51.000000', 'temperatura', 131.0000, 'ºC'),
	(84229, 110, '2015-03-01 00:48:52.000000', 'temperatura', 1098.0000, 'ºC'),
	(84230, 110, '2015-03-01 00:48:53.000000', 'temperatura', 299.0000, 'ºC'),
	(84231, 110, '2015-03-01 00:48:54.000000', 'temperatura', 599.0000, 'ºC'),
	(84232, 110, '2015-03-01 00:48:55.000000', 'temperatura', 900.0000, 'ºC'),
	(84233, 110, '2015-03-01 00:48:56.000000', 'temperatura', 304.0000, 'ºC'),
	(84234, 110, '2015-03-01 00:48:57.000000', 'temperatura', 19.0000, 'ºC'),
	(84235, 110, '2015-03-01 00:48:58.000000', 'temperatura', 386.0000, 'ºC'),
	(84236, 110, '2015-03-01 00:48:59.000000', 'temperatura', 671.0000, 'ºC'),
	(84237, 110, '2015-03-01 00:49:00.000000', 'temperatura', 998.0000, 'ºC'),
	(84238, 110, '2015-03-01 00:49:01.000000', 'temperatura', 576.0000, 'ºC'),
	(84239, 110, '2015-03-01 00:49:02.000000', 'temperatura', 1090.0000, 'ºC'),
	(84240, 110, '2015-03-01 00:49:03.000000', 'temperatura', 120.0000, 'ºC'),
	(84241, 110, '2015-03-01 00:49:04.000000', 'temperatura', 930.0000, 'ºC'),
	(84242, 110, '2015-03-01 00:49:05.000000', 'temperatura', 691.0000, 'ºC'),
	(84243, 110, '2015-03-01 00:49:06.000000', 'temperatura', 664.0000, 'ºC'),
	(84244, 110, '2015-03-01 00:49:07.000000', 'temperatura', 48.0000, 'ºC'),
	(84245, 110, '2015-03-01 00:49:08.000000', 'temperatura', 647.0000, 'ºC'),
	(84246, 110, '2015-03-01 00:49:09.000000', 'temperatura', 694.0000, 'ºC'),
	(84247, 110, '2015-03-01 00:49:10.000000', 'temperatura', 327.0000, 'ºC'),
	(84248, 110, '2015-03-01 00:49:11.000000', 'temperatura', 756.0000, 'ºC'),
	(84249, 110, '2015-03-01 00:49:12.000000', 'temperatura', 398.0000, 'ºC'),
	(84250, 110, '2015-03-01 00:49:13.000000', 'temperatura', 925.0000, 'ºC'),
	(84251, 110, '2015-03-01 00:49:14.000000', 'temperatura', 1029.0000, 'ºC'),
	(84252, 110, '2015-03-01 00:49:15.000000', 'temperatura', 1171.0000, 'ºC'),
	(84253, 110, '2015-03-01 00:49:16.000000', 'temperatura', 367.0000, 'ºC'),
	(84254, 110, '2015-03-01 00:49:17.000000', 'temperatura', 723.0000, 'ºC'),
	(84255, 110, '2015-03-01 00:49:18.000000', 'temperatura', 114.0000, 'ºC'),
	(84256, 110, '2015-03-01 00:49:19.000000', 'temperatura', 801.0000, 'ºC'),
	(84257, 110, '2015-03-01 00:49:20.000000', 'temperatura', 65.0000, 'ºC'),
	(84258, 110, '2015-03-01 00:49:21.000000', 'temperatura', 323.0000, 'ºC'),
	(84259, 110, '2015-03-01 00:49:22.000000', 'temperatura', 218.0000, 'ºC'),
	(84260, 110, '2015-03-01 00:49:23.000000', 'temperatura', 124.0000, 'ºC'),
	(84261, 110, '2015-03-01 00:49:24.000000', 'temperatura', 1165.0000, 'ºC'),
	(84262, 110, '2015-03-01 00:49:25.000000', 'temperatura', 654.0000, 'ºC'),
	(84263, 110, '2015-03-01 00:49:26.000000', 'temperatura', 974.0000, 'ºC'),
	(84264, 110, '2015-03-01 00:49:27.000000', 'temperatura', 508.0000, 'ºC'),
	(84265, 110, '2015-03-01 00:49:28.000000', 'temperatura', 818.0000, 'ºC'),
	(84266, 110, '2015-03-01 00:49:29.000000', 'temperatura', 168.0000, 'ºC'),
	(84267, 110, '2015-03-01 00:49:30.000000', 'temperatura', 787.0000, 'ºC'),
	(84268, 110, '2015-03-01 00:49:31.000000', 'temperatura', 1030.0000, 'ºC'),
	(84269, 110, '2015-03-01 00:49:32.000000', 'temperatura', 389.0000, 'ºC'),
	(84270, 110, '2015-03-01 00:49:33.000000', 'temperatura', 58.0000, 'ºC'),
	(84271, 110, '2015-03-01 00:49:34.000000', 'temperatura', 320.0000, 'ºC'),
	(84272, 110, '2015-03-01 00:49:35.000000', 'temperatura', 229.0000, 'ºC'),
	(84273, 110, '2015-03-01 00:49:36.000000', 'temperatura', 186.0000, 'ºC'),
	(84274, 110, '2015-03-01 00:49:37.000000', 'temperatura', 242.0000, 'ºC'),
	(84275, 110, '2015-03-01 00:49:38.000000', 'temperatura', 652.0000, 'ºC'),
	(84276, 110, '2015-03-01 00:49:39.000000', 'temperatura', 135.0000, 'ºC'),
	(84277, 110, '2015-03-01 00:49:40.000000', 'temperatura', 1121.0000, 'ºC'),
	(84278, 110, '2015-03-01 00:49:41.000000', 'temperatura', 400.0000, 'ºC'),
	(84279, 110, '2015-03-01 00:49:42.000000', 'temperatura', 1039.0000, 'ºC'),
	(84280, 110, '2015-03-01 00:49:43.000000', 'temperatura', 392.0000, 'ºC'),
	(84281, 110, '2015-03-01 00:49:44.000000', 'temperatura', 47.0000, 'ºC'),
	(84282, 110, '2015-03-01 00:49:45.000000', 'temperatura', 258.0000, 'ºC'),
	(84283, 110, '2015-03-01 00:49:46.000000', 'temperatura', 1150.0000, 'ºC'),
	(84284, 110, '2015-03-01 00:49:47.000000', 'temperatura', 178.0000, 'ºC'),
	(84285, 110, '2015-03-01 00:49:48.000000', 'temperatura', 1039.0000, 'ºC'),
	(84286, 110, '2015-03-01 00:49:49.000000', 'temperatura', 1062.0000, 'ºC'),
	(84287, 110, '2015-03-01 00:49:50.000000', 'temperatura', 991.0000, 'ºC'),
	(84288, 110, '2015-03-01 00:49:51.000000', 'temperatura', 573.0000, 'ºC'),
	(84289, 110, '2015-03-01 00:49:52.000000', 'temperatura', 1091.0000, 'ºC'),
	(84290, 110, '2015-03-01 00:49:53.000000', 'temperatura', 137.0000, 'ºC'),
	(84291, 110, '2015-03-01 00:49:54.000000', 'temperatura', 1012.0000, 'ºC'),
	(84292, 110, '2015-03-01 00:49:55.000000', 'temperatura', 1052.0000, 'ºC'),
	(84293, 110, '2015-03-01 00:49:56.000000', 'temperatura', 1021.0000, 'ºC'),
	(84294, 110, '2015-03-01 00:49:57.000000', 'temperatura', 750.0000, 'ºC'),
	(84295, 110, '2015-03-01 00:49:58.000000', 'temperatura', 689.0000, 'ºC'),
	(84296, 110, '2015-03-01 00:49:59.000000', 'temperatura', 1196.0000, 'ºC'),
	(84297, 110, '2015-03-01 00:50:00.000000', 'temperatura', 312.0000, 'ºC'),
	(84298, 110, '2015-03-01 00:50:01.000000', 'temperatura', 371.0000, 'ºC'),
	(84299, 110, '2015-03-01 00:50:02.000000', 'temperatura', 921.0000, 'ºC'),
	(84300, 110, '2015-03-01 00:50:03.000000', 'temperatura', 1091.0000, 'ºC'),
	(84301, 110, '2015-03-01 00:50:04.000000', 'temperatura', 294.0000, 'ºC'),
	(84302, 110, '2015-03-01 00:50:05.000000', 'temperatura', 596.0000, 'ºC'),
	(84303, 110, '2015-03-01 00:50:06.000000', 'temperatura', 898.0000, 'ºC'),
	(84304, 110, '2015-03-01 00:50:07.000000', 'temperatura', 301.0000, 'ºC'),
	(84305, 110, '2015-03-01 00:50:08.000000', 'temperatura', 15.0000, 'ºC'),
	(84306, 110, '2015-03-01 00:50:09.000000', 'temperatura', 372.0000, 'ºC'),
	(84307, 110, '2015-03-01 00:50:10.000000', 'temperatura', 614.0000, 'ºC'),
	(84308, 110, '2015-03-01 00:50:11.000000', 'temperatura', 756.0000, 'ºC'),
	(84309, 110, '2015-03-01 00:50:12.000000', 'temperatura', 737.0000, 'ºC'),
	(84310, 110, '2015-03-01 00:50:13.000000', 'temperatura', 219.0000, 'ºC'),
	(84311, 110, '2015-03-01 00:50:14.000000', 'temperatura', 84.0000, 'ºC'),
	(84312, 110, '2015-03-01 00:50:15.000000', 'temperatura', 963.0000, 'ºC'),
	(84313, 110, '2015-03-01 00:50:16.000000', 'temperatura', 964.0000, 'ºC'),
	(84314, 110, '2015-03-01 00:50:17.000000', 'temperatura', 731.0000, 'ºC'),
	(84315, 110, '2015-03-01 00:50:18.000000', 'temperatura', 763.0000, 'ºC'),
	(84316, 110, '2015-03-01 00:50:19.000000', 'temperatura', 424.0000, 'ºC'),
	(84317, 110, '2015-03-01 00:50:20.000000', 'temperatura', 1029.0000, 'ºC'),
	(84318, 110, '2015-03-01 00:50:21.000000', 'temperatura', 275.0000, 'ºC'),
	(84319, 110, '2015-03-01 00:50:22.000000', 'temperatura', 688.0000, 'ºC'),
	(84320, 110, '2015-03-01 00:50:23.000000', 'temperatura', 216.0000, 'ºC'),
	(84321, 110, '2015-03-01 00:50:24.000000', 'temperatura', 215.0000, 'ºC'),
	(84322, 110, '2015-03-01 00:50:25.000000', 'temperatura', 427.0000, 'ºC'),
	(84323, 110, '2015-03-01 00:50:26.000000', 'temperatura', 293.0000, 'ºC'),
	(84324, 110, '2015-03-01 00:50:27.000000', 'temperatura', 183.0000, 'ºC'),
	(84325, 110, '2015-03-01 00:50:28.000000', 'temperatura', 36.0000, 'ºC'),
	(84326, 110, '2015-03-01 00:50:29.000000', 'temperatura', 831.0000, 'ºC'),
	(84327, 110, '2015-03-01 00:50:30.000000', 'temperatura', 449.0000, 'ºC'),
	(84328, 110, '2015-03-01 00:50:31.000000', 'temperatura', 952.0000, 'ºC'),
	(84329, 110, '2015-03-01 00:50:32.000000', 'temperatura', 1012.0000, 'ºC'),
	(84330, 110, '2015-03-01 00:50:33.000000', 'temperatura', 1006.0000, 'ºC'),
	(84331, 110, '2015-03-01 00:50:34.000000', 'temperatura', 795.0000, 'ºC'),
	(84332, 110, '2015-03-01 00:50:35.000000', 'temperatura', 959.0000, 'ºC'),
	(84333, 110, '2015-03-01 00:50:36.000000', 'temperatura', 8.0000, 'ºC'),
	(84334, 110, '2015-03-01 00:50:37.000000', 'temperatura', 765.0000, 'ºC'),
	(84335, 110, '2015-03-01 00:50:38.000000', 'temperatura', 199.0000, 'ºC'),
	(84336, 110, '2015-03-01 00:50:39.000000', 'temperatura', 1104.0000, 'ºC'),
	(84337, 110, '2015-03-01 00:50:40.000000', 'temperatura', 122.0000, 'ºC'),
	(84338, 110, '2015-03-01 00:50:41.000000', 'temperatura', 898.0000, 'ºC'),
	(84339, 110, '2015-03-01 00:50:42.000000', 'temperatura', 527.0000, 'ºC'),
	(84340, 110, '2015-03-01 00:50:43.000000', 'temperatura', 1140.0000, 'ºC'),
	(84341, 110, '2015-03-01 00:50:44.000000', 'temperatura', 519.0000, 'ºC'),
	(84342, 110, '2015-03-01 00:50:45.000000', 'temperatura', 375.0000, 'ºC'),
	(84343, 110, '2015-03-01 00:50:46.000000', 'temperatura', 320.0000, 'ºC'),
	(84344, 110, '2015-03-01 00:50:47.000000', 'temperatura', 476.0000, 'ºC'),
	(84345, 110, '2015-03-01 00:50:48.000000', 'temperatura', 219.0000, 'ºC'),
	(84346, 110, '2015-03-01 00:50:49.000000', 'temperatura', 869.0000, 'ºC'),
	(84347, 110, '2015-03-01 00:50:50.000000', 'temperatura', 90.0000, 'ºC'),
	(84348, 110, '2015-03-01 00:50:51.000000', 'temperatura', 240.0000, 'ºC'),
	(84349, 110, '2015-03-01 00:50:52.000000', 'temperatura', 932.0000, 'ºC'),
	(84350, 110, '2015-03-01 00:50:53.000000', 'temperatura', 340.0000, 'ºC'),
	(84351, 110, '2015-03-01 00:50:54.000000', 'temperatura', 107.0000, 'ºC'),
	(84352, 110, '2015-03-01 00:50:55.000000', 'temperatura', 712.0000, 'ºC'),
	(84353, 110, '2015-03-01 00:50:56.000000', 'temperatura', 840.0000, 'ºC'),
	(84354, 110, '2015-03-01 00:50:57.000000', 'temperatura', 866.0000, 'ºC'),
	(84355, 110, '2015-03-01 00:50:58.000000', 'temperatura', 609.0000, 'ºC'),
	(84356, 110, '2015-03-01 00:50:59.000000', 'temperatura', 447.0000, 'ºC'),
	(84357, 110, '2015-03-01 00:51:00.000000', 'temperatura', 407.0000, 'ºC'),
	(84358, 110, '2015-03-01 00:51:01.000000', 'temperatura', 698.0000, 'ºC'),
	(84359, 110, '2015-03-01 00:51:02.000000', 'temperatura', 1068.0000, 'ºC'),
	(84360, 110, '2015-03-01 00:51:03.000000', 'temperatura', 846.0000, 'ºC'),
	(84361, 110, '2015-03-01 00:51:04.000000', 'temperatura', 1025.0000, 'ºC'),
	(84362, 110, '2015-03-01 00:51:05.000000', 'temperatura', 189.0000, 'ºC'),
	(84363, 110, '2015-03-01 00:51:06.000000', 'temperatura', 271.0000, 'ºC'),
	(84364, 110, '2015-03-01 00:51:07.000000', 'temperatura', 788.0000, 'ºC'),
	(84365, 110, '2015-03-01 00:51:08.000000', 'temperatura', 726.0000, 'ºC'),
	(84366, 110, '2015-03-01 00:51:09.000000', 'temperatura', 67.0000, 'ºC'),
	(84367, 110, '2015-03-01 00:51:10.000000', 'temperatura', 557.0000, 'ºC'),
	(84368, 110, '2015-03-01 00:51:11.000000', 'temperatura', 183.0000, 'ºC'),
	(84369, 110, '2015-03-01 00:51:12.000000', 'temperatura', 447.0000, 'ºC'),
	(84370, 110, '2015-03-01 00:51:13.000000', 'temperatura', 486.0000, 'ºC'),
	(84371, 110, '2015-03-01 00:51:14.000000', 'temperatura', 1091.0000, 'ºC'),
	(84372, 110, '2015-03-01 00:51:15.000000', 'temperatura', 398.0000, 'ºC'),
	(84373, 110, '2015-03-01 00:51:16.000000', 'temperatura', 1115.0000, 'ºC'),
	(84374, 110, '2015-03-01 00:51:17.000000', 'temperatura', 784.0000, 'ºC'),
	(84375, 110, '2015-03-01 00:51:18.000000', 'temperatura', 573.0000, 'ºC'),
	(84376, 110, '2015-03-01 00:51:19.000000', 'temperatura', 514.0000, 'ºC'),
	(84377, 110, '2015-03-01 00:51:20.000000', 'temperatura', 853.0000, 'ºC'),
	(84378, 110, '2015-03-01 00:51:21.000000', 'temperatura', 322.0000, 'ºC'),
	(84379, 110, '2015-03-01 00:51:22.000000', 'temperatura', 253.0000, 'ºC'),
	(84380, 110, '2015-03-01 00:51:23.000000', 'temperatura', 300.0000, 'ºC'),
	(84381, 110, '2015-03-01 00:51:24.000000', 'temperatura', 739.0000, 'ºC'),
	(84382, 110, '2015-03-01 00:51:25.000000', 'temperatura', 398.0000, 'ºC'),
	(84383, 110, '2015-03-01 00:51:26.000000', 'temperatura', 971.0000, 'ºC'),
	(84384, 110, '2015-03-01 00:51:27.000000', 'temperatura', 62.0000, 'ºC'),
	(84385, 110, '2015-03-01 00:51:28.000000', 'temperatura', 999.0000, 'ºC'),
	(84386, 110, '2015-03-01 00:51:29.000000', 'temperatura', 9.0000, 'ºC'),
	(84387, 110, '2015-03-01 00:51:30.000000', 'temperatura', 647.0000, 'ºC'),
	(84388, 110, '2015-03-01 00:51:31.000000', 'temperatura', 809.0000, 'ºC'),
	(84389, 110, '2015-03-01 00:51:32.000000', 'temperatura', 906.0000, 'ºC'),
	(84390, 110, '2015-03-01 00:51:33.000000', 'temperatura', 902.0000, 'ºC'),
	(84391, 110, '2015-03-01 00:51:34.000000', 'temperatura', 594.0000, 'ºC'),
	(84392, 110, '2015-03-01 00:51:35.000000', 'temperatura', 265.0000, 'ºC'),
	(84393, 110, '2015-03-01 00:51:36.000000', 'temperatura', 742.0000, 'ºC'),
	(84394, 110, '2015-03-01 00:51:37.000000', 'temperatura', 516.0000, 'ºC'),
	(84395, 110, '2015-03-01 00:51:38.000000', 'temperatura', 356.0000, 'ºC'),
	(84396, 110, '2015-03-01 00:51:39.000000', 'temperatura', 233.0000, 'ºC'),
	(84397, 110, '2015-03-01 00:51:40.000000', 'temperatura', 95.0000, 'ºC'),
	(84398, 110, '2015-03-01 00:51:41.000000', 'temperatura', 976.0000, 'ºC'),
	(84399, 110, '2015-03-01 00:51:42.000000', 'temperatura', 998.0000, 'ºC'),
	(84400, 110, '2015-03-01 00:51:43.000000', 'temperatura', 860.0000, 'ºC'),
	(84401, 110, '2015-03-01 00:51:44.000000', 'temperatura', 108.0000, 'ºC'),
	(84402, 110, '2015-03-01 00:51:45.000000', 'temperatura', 360.0000, 'ºC'),
	(84403, 110, '2015-03-01 00:51:46.000000', 'temperatura', 278.0000, 'ºC'),
	(84404, 110, '2015-03-01 00:51:47.000000', 'temperatura', 311.0000, 'ºC'),
	(84405, 110, '2015-03-01 00:51:48.000000', 'temperatura', 719.0000, 'ºC'),
	(84406, 110, '2015-03-01 00:51:49.000000', 'temperatura', 263.0000, 'ºC'),
	(84407, 110, '2015-03-01 00:51:50.000000', 'temperatura', 357.0000, 'ºC'),
	(84408, 110, '2015-03-01 00:51:51.000000', 'temperatura', 998.0000, 'ºC'),
	(84409, 110, '2015-03-01 00:51:52.000000', 'temperatura', 320.0000, 'ºC'),
	(84410, 110, '2015-03-01 00:51:53.000000', 'temperatura', 1005.0000, 'ºC'),
	(84411, 110, '2015-03-01 00:51:54.000000', 'temperatura', 465.0000, 'ºC'),
	(84412, 110, '2015-03-01 00:51:55.000000', 'temperatura', 510.0000, 'ºC'),
	(84413, 110, '2015-03-01 00:51:56.000000', 'temperatura', 1158.0000, 'ºC'),
	(84414, 110, '2015-03-01 00:51:57.000000', 'temperatura', 661.0000, 'ºC'),
	(84415, 110, '2015-03-01 00:51:58.000000', 'temperatura', 1029.0000, 'ºC'),
	(84416, 110, '2015-03-01 00:51:59.000000', 'temperatura', 764.0000, 'ºC'),
	(84417, 110, '2015-03-01 00:52:00.000000', 'temperatura', 731.0000, 'ºC'),
	(84418, 110, '2015-03-01 00:52:01.000000', 'temperatura', 167.0000, 'ºC'),
	(84419, 110, '2015-03-01 00:52:02.000000', 'temperatura', 1042.0000, 'ºC'),
	(84420, 110, '2015-03-01 00:52:03.000000', 'temperatura', 1107.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(84421, 110, '2015-03-01 00:52:04.000000', 'temperatura', 12.0000, 'ºC'),
	(84422, 110, '2015-03-01 00:52:05.000000', 'temperatura', 338.0000, 'ºC'),
	(84423, 110, '2015-03-01 00:52:06.000000', 'temperatura', 453.0000, 'ºC'),
	(84424, 110, '2015-03-01 00:52:07.000000', 'temperatura', 54.0000, 'ºC'),
	(84425, 110, '2015-03-01 00:52:08.000000', 'temperatura', 113.0000, 'ºC'),
	(84426, 110, '2015-03-01 00:52:09.000000', 'temperatura', 400.0000, 'ºC'),
	(84427, 110, '2015-03-01 00:52:10.000000', 'temperatura', 463.0000, 'ºC'),
	(84428, 110, '2015-03-01 00:52:11.000000', 'temperatura', 1115.0000, 'ºC'),
	(84429, 110, '2015-03-01 00:52:12.000000', 'temperatura', 587.0000, 'ºC'),
	(84430, 110, '2015-03-01 00:52:13.000000', 'temperatura', 791.0000, 'ºC'),
	(84431, 110, '2015-03-01 00:52:14.000000', 'temperatura', 993.0000, 'ºC'),
	(84432, 110, '2015-03-01 00:52:15.000000', 'temperatura', 194.0000, 'ºC'),
	(84433, 110, '2015-03-01 00:52:16.000000', 'temperatura', 389.0000, 'ºC'),
	(84434, 110, '2015-03-01 00:52:17.000000', 'temperatura', 166.0000, 'ºC'),
	(84435, 110, '2015-03-01 00:52:18.000000', 'temperatura', 863.0000, 'ºC'),
	(84436, 110, '2015-03-01 00:52:19.000000', 'temperatura', 218.0000, 'ºC'),
	(84437, 110, '2015-03-01 00:52:20.000000', 'temperatura', 899.0000, 'ºC'),
	(84438, 110, '2015-03-01 00:52:21.000000', 'temperatura', 243.0000, 'ºC'),
	(84439, 110, '2015-03-01 00:52:22.000000', 'temperatura', 917.0000, 'ºC'),
	(84440, 110, '2015-03-01 00:52:23.000000', 'temperatura', 259.0000, 'ºC'),
	(84441, 110, '2015-03-01 00:52:24.000000', 'temperatura', 944.0000, 'ºC'),
	(84442, 110, '2015-03-01 00:52:25.000000', 'temperatura', 343.0000, 'ºC'),
	(84443, 110, '2015-03-01 00:52:26.000000', 'temperatura', 84.0000, 'ºC'),
	(84444, 110, '2015-03-01 00:52:27.000000', 'temperatura', 593.0000, 'ºC'),
	(84445, 110, '2015-03-01 00:52:28.000000', 'temperatura', 313.0000, 'ºC'),
	(84446, 110, '2015-03-01 00:52:29.000000', 'temperatura', 985.0000, 'ºC'),
	(84447, 110, '2015-03-01 00:52:30.000000', 'temperatura', 385.0000, 'ºC'),
	(84448, 110, '2015-03-01 00:52:31.000000', 'temperatura', 173.0000, 'ºC'),
	(84449, 110, '2015-03-01 00:52:32.000000', 'temperatura', 912.0000, 'ºC'),
	(84450, 110, '2015-03-01 00:52:33.000000', 'temperatura', 438.0000, 'ºC'),
	(84451, 110, '2015-03-01 00:52:34.000000', 'temperatura', 656.0000, 'ºC'),
	(84452, 110, '2015-03-01 00:52:35.000000', 'temperatura', 767.0000, 'ºC'),
	(84453, 110, '2015-03-01 00:52:36.000000', 'temperatura', 666.0000, 'ºC'),
	(84454, 110, '2015-03-01 00:52:37.000000', 'temperatura', 1032.0000, 'ºC'),
	(84455, 110, '2015-03-01 00:52:38.000000', 'temperatura', 763.0000, 'ºC'),
	(84456, 110, '2015-03-01 00:52:39.000000', 'temperatura', 717.0000, 'ºC'),
	(84457, 110, '2015-03-01 00:52:40.000000', 'temperatura', 96.0000, 'ºC'),
	(84458, 110, '2015-03-01 00:52:41.000000', 'temperatura', 731.0000, 'ºC'),
	(84459, 110, '2015-03-01 00:52:42.000000', 'temperatura', 968.0000, 'ºC'),
	(84460, 110, '2015-03-01 00:52:43.000000', 'temperatura', 247.0000, 'ºC'),
	(84461, 110, '2015-03-01 00:52:44.000000', 'temperatura', 732.0000, 'ºC'),
	(84462, 110, '2015-03-01 00:52:45.000000', 'temperatura', 520.0000, 'ºC'),
	(84463, 110, '2015-03-01 00:52:46.000000', 'temperatura', 403.0000, 'ºC'),
	(84464, 110, '2015-03-01 00:52:47.000000', 'temperatura', 455.0000, 'ºC'),
	(84465, 110, '2015-03-01 00:52:48.000000', 'temperatura', 1066.0000, 'ºC'),
	(84466, 110, '2015-03-01 00:52:49.000000', 'temperatura', 366.0000, 'ºC'),
	(84467, 110, '2015-03-01 00:52:50.000000', 'temperatura', 1032.0000, 'ºC'),
	(84468, 110, '2015-03-01 00:52:51.000000', 'temperatura', 465.0000, 'ºC'),
	(84469, 110, '2015-03-01 00:52:52.000000', 'temperatura', 427.0000, 'ºC'),
	(84470, 110, '2015-03-01 00:52:53.000000', 'temperatura', 741.0000, 'ºC'),
	(84471, 110, '2015-03-01 00:52:54.000000', 'temperatura', 25.0000, 'ºC'),
	(84472, 110, '2015-03-01 00:52:55.000000', 'temperatura', 302.0000, 'ºC'),
	(84473, 110, '2015-03-01 00:52:56.000000', 'temperatura', 235.0000, 'ºC'),
	(84474, 110, '2015-03-01 00:52:57.000000', 'temperatura', 271.0000, 'ºC'),
	(84475, 110, '2015-03-01 00:52:58.000000', 'temperatura', 651.0000, 'ºC'),
	(84476, 110, '2015-03-01 00:52:59.000000', 'temperatura', 44.0000, 'ºC'),
	(84477, 110, '2015-03-01 00:53:00.000000', 'temperatura', 665.0000, 'ºC'),
	(84478, 110, '2015-03-01 00:53:01.000000', 'temperatura', 793.0000, 'ºC'),
	(84479, 110, '2015-03-01 00:53:02.000000', 'temperatura', 771.0000, 'ºC'),
	(84480, 110, '2015-03-01 00:53:03.000000', 'temperatura', 278.0000, 'ºC'),
	(84481, 110, '2015-03-01 00:53:04.000000', 'temperatura', 275.0000, 'ºC'),
	(84482, 110, '2015-03-01 00:53:05.000000', 'temperatura', 541.0000, 'ºC'),
	(84483, 110, '2015-03-01 00:53:06.000000', 'temperatura', 682.0000, 'ºC'),
	(84484, 110, '2015-03-01 00:53:07.000000', 'temperatura', 586.0000, 'ºC'),
	(84485, 110, '2015-03-01 00:53:08.000000', 'temperatura', 887.0000, 'ºC'),
	(84486, 110, '2015-03-01 00:53:09.000000', 'temperatura', 278.0000, 'ºC'),
	(84487, 110, '2015-03-01 00:53:10.000000', 'temperatura', 1128.0000, 'ºC'),
	(84488, 110, '2015-03-01 00:53:11.000000', 'temperatura', 5.0000, 'ºC'),
	(84489, 110, '2015-03-01 00:53:12.000000', 'temperatura', 244.0000, 'ºC'),
	(84490, 110, '2015-03-01 00:53:13.000000', 'temperatura', 6.0000, 'ºC'),
	(84491, 110, '2015-03-01 00:53:14.000000', 'temperatura', 496.0000, 'ºC'),
	(84492, 110, '2015-03-01 00:53:15.000000', 'temperatura', 65.0000, 'ºC'),
	(84493, 110, '2015-03-01 00:53:16.000000', 'temperatura', 37.0000, 'ºC'),
	(84494, 110, '2015-03-01 00:53:17.000000', 'temperatura', 1191.0000, 'ºC'),
	(84495, 110, '2015-03-01 00:53:18.000000', 'temperatura', 1044.0000, 'ºC'),
	(84496, 110, '2015-03-01 00:53:19.000000', 'temperatura', 446.0000, 'ºC'),
	(84497, 110, '2015-03-01 00:53:20.000000', 'temperatura', 300.0000, 'ºC'),
	(84498, 110, '2015-03-01 00:53:21.000000', 'temperatura', 160.0000, 'ºC'),
	(84499, 110, '2015-03-01 00:53:22.000000', 'temperatura', 1104.0000, 'ºC'),
	(84500, 110, '2015-03-01 00:53:23.000000', 'temperatura', 239.0000, 'ºC'),
	(84501, 110, '2015-03-01 00:53:24.000000', 'temperatura', 285.0000, 'ºC'),
	(84502, 110, '2015-03-01 00:53:25.000000', 'temperatura', 708.0000, 'ºC'),
	(84503, 110, '2015-03-01 00:53:26.000000', 'temperatura', 285.0000, 'ºC'),
	(84504, 110, '2015-03-01 00:53:27.000000', 'temperatura', 500.0000, 'ºC'),
	(84505, 110, '2015-03-01 00:53:28.000000', 'temperatura', 449.0000, 'ºC'),
	(84506, 110, '2015-03-01 00:53:29.000000', 'temperatura', 742.0000, 'ºC'),
	(84507, 110, '2015-03-01 00:53:30.000000', 'temperatura', 1164.0000, 'ºC'),
	(84508, 110, '2015-03-01 00:53:31.000000', 'temperatura', 1196.0000, 'ºC'),
	(84509, 110, '2015-03-01 00:53:32.000000', 'temperatura', 86.0000, 'ºC'),
	(84510, 110, '2015-03-01 00:53:33.000000', 'temperatura', 443.0000, 'ºC'),
	(84511, 110, '2015-03-01 00:53:34.000000', 'temperatura', 759.0000, 'ºC'),
	(84512, 110, '2015-03-01 00:53:35.000000', 'temperatura', 68.0000, 'ºC'),
	(84513, 110, '2015-03-01 00:53:36.000000', 'temperatura', 461.0000, 'ºC'),
	(84514, 110, '2015-03-01 00:53:37.000000', 'temperatura', 904.0000, 'ºC'),
	(84515, 110, '2015-03-01 00:53:38.000000', 'temperatura', 737.0000, 'ºC'),
	(84516, 110, '2015-03-01 00:53:39.000000', 'temperatura', 972.0000, 'ºC'),
	(84517, 110, '2015-03-01 00:53:40.000000', 'temperatura', 250.0000, 'ºC'),
	(84518, 110, '2015-03-01 00:53:41.000000', 'temperatura', 732.0000, 'ºC'),
	(84519, 110, '2015-03-01 00:53:42.000000', 'temperatura', 514.0000, 'ºC'),
	(84520, 110, '2015-03-01 00:53:43.000000', 'temperatura', 375.0000, 'ºC'),
	(84521, 110, '2015-03-01 00:53:44.000000', 'temperatura', 332.0000, 'ºC'),
	(84522, 110, '2015-03-01 00:53:45.000000', 'temperatura', 538.0000, 'ºC'),
	(84523, 110, '2015-03-01 00:53:46.000000', 'temperatura', 492.0000, 'ºC'),
	(84524, 110, '2015-03-01 00:53:47.000000', 'temperatura', 848.0000, 'ºC'),
	(84525, 110, '2015-03-01 00:53:48.000000', 'temperatura', 365.0000, 'ºC'),
	(84526, 110, '2015-03-01 00:53:49.000000', 'temperatura', 479.0000, 'ºC'),
	(84527, 110, '2015-03-01 00:53:50.000000', 'temperatura', 100.0000, 'ºC'),
	(84528, 110, '2015-03-01 00:53:51.000000', 'temperatura', 267.0000, 'ºC'),
	(84529, 110, '2015-03-01 00:53:52.000000', 'temperatura', 1033.0000, 'ºC'),
	(84530, 110, '2015-03-01 00:53:53.000000', 'temperatura', 763.0000, 'ºC'),
	(84531, 110, '2015-03-01 00:53:54.000000', 'temperatura', 720.0000, 'ºC'),
	(84532, 110, '2015-03-01 00:53:55.000000', 'temperatura', 109.0000, 'ºC'),
	(84533, 110, '2015-03-01 00:53:56.000000', 'temperatura', 785.0000, 'ºC'),
	(84534, 110, '2015-03-01 00:53:57.000000', 'temperatura', 1.0000, 'ºC'),
	(84535, 110, '2015-03-01 00:53:58.000000', 'temperatura', 49.0000, 'ºC'),
	(84536, 110, '2015-03-01 00:53:59.000000', 'temperatura', 243.0000, 'ºC'),
	(84537, 110, '2015-03-01 00:54:00.000000', 'temperatura', 1068.0000, 'ºC'),
	(84538, 110, '2015-03-01 00:54:01.000000', 'temperatura', 1010.0000, 'ºC'),
	(84539, 110, '2015-03-01 00:54:02.000000', 'temperatura', 649.0000, 'ºC'),
	(84540, 110, '2015-03-01 00:54:03.000000', 'temperatura', 215.0000, 'ºC'),
	(84541, 110, '2015-03-01 00:54:04.000000', 'temperatura', 328.0000, 'ºC'),
	(84542, 110, '2015-03-01 00:54:05.000000', 'temperatura', 997.0000, 'ºC'),
	(84543, 110, '2015-03-01 00:54:06.000000', 'temperatura', 399.0000, 'ºC'),
	(84544, 110, '2015-03-01 00:54:07.000000', 'temperatura', 205.0000, 'ºC'),
	(84545, 110, '2015-03-01 00:54:08.000000', 'temperatura', 1029.0000, 'ºC'),
	(84546, 110, '2015-03-01 00:54:09.000000', 'temperatura', 929.0000, 'ºC'),
	(84547, 110, '2015-03-01 00:54:10.000000', 'temperatura', 359.0000, 'ºC'),
	(84548, 110, '2015-03-01 00:54:11.000000', 'temperatura', 209.0000, 'ºC'),
	(84549, 110, '2015-03-01 00:54:12.000000', 'temperatura', 1169.0000, 'ºC'),
	(84550, 110, '2015-03-01 00:54:13.000000', 'temperatura', 419.0000, 'ºC'),
	(84551, 110, '2015-03-01 00:54:14.000000', 'temperatura', 986.0000, 'ºC'),
	(84552, 110, '2015-03-01 00:54:15.000000', 'temperatura', 75.0000, 'ºC'),
	(84553, 110, '2015-03-01 00:54:16.000000', 'temperatura', 1017.0000, 'ºC'),
	(84554, 110, '2015-03-01 00:54:17.000000', 'temperatura', 62.0000, 'ºC'),
	(84555, 110, '2015-03-01 00:54:18.000000', 'temperatura', 860.0000, 'ºC'),
	(84556, 110, '2015-03-01 00:54:19.000000', 'temperatura', 515.0000, 'ºC'),
	(84557, 110, '2015-03-01 00:54:20.000000', 'temperatura', 1195.0000, 'ºC'),
	(84558, 110, '2015-03-01 00:54:21.000000', 'temperatura', 832.0000, 'ºC'),
	(84559, 110, '2015-03-01 00:54:22.000000', 'temperatura', 572.0000, 'ºC'),
	(84560, 110, '2015-03-01 00:54:23.000000', 'temperatura', 367.0000, 'ºC'),
	(84561, 110, '2015-03-01 00:54:24.000000', 'temperatura', 121.0000, 'ºC'),
	(84562, 110, '2015-03-01 00:54:25.000000', 'temperatura', 703.0000, 'ºC'),
	(84563, 110, '2015-03-01 00:54:26.000000', 'temperatura', 751.0000, 'ºC'),
	(84564, 110, '2015-03-01 00:54:27.000000', 'temperatura', 449.0000, 'ºC'),
	(84565, 110, '2015-03-01 00:54:28.000000', 'temperatura', 1193.0000, 'ºC'),
	(84566, 110, '2015-03-01 00:54:29.000000', 'temperatura', 1018.0000, 'ºC'),
	(84567, 110, '2015-03-01 00:54:30.000000', 'temperatura', 312.0000, 'ºC'),
	(84568, 110, '2015-03-01 00:54:31.000000', 'temperatura', 907.0000, 'ºC'),
	(84569, 110, '2015-03-01 00:54:32.000000', 'temperatura', 1197.0000, 'ºC'),
	(84570, 110, '2015-03-01 00:54:33.000000', 'temperatura', 865.0000, 'ºC'),
	(84571, 110, '2015-03-01 00:54:34.000000', 'temperatura', 737.0000, 'ºC'),
	(84572, 110, '2015-03-01 00:54:35.000000', 'temperatura', 1088.0000, 'ºC'),
	(84573, 110, '2015-03-01 00:54:36.000000', 'temperatura', 830.0000, 'ºC'),
	(84574, 110, '2015-03-01 00:54:37.000000', 'temperatura', 886.0000, 'ºC'),
	(84575, 110, '2015-03-01 00:54:38.000000', 'temperatura', 741.0000, 'ºC'),
	(84576, 110, '2015-03-01 00:54:39.000000', 'temperatura', 1049.0000, 'ºC'),
	(84577, 110, '2015-03-01 00:54:40.000000', 'temperatura', 620.0000, 'ºC'),
	(84578, 110, '2015-03-01 00:54:41.000000', 'temperatura', 1156.0000, 'ºC'),
	(84579, 110, '2015-03-01 00:54:42.000000', 'temperatura', 320.0000, 'ºC'),
	(84580, 110, '2015-03-01 00:54:43.000000', 'temperatura', 531.0000, 'ºC'),
	(84581, 110, '2015-03-01 00:54:44.000000', 'temperatura', 495.0000, 'ºC'),
	(84582, 110, '2015-03-01 00:54:45.000000', 'temperatura', 884.0000, 'ºC'),
	(84583, 110, '2015-03-01 00:54:46.000000', 'temperatura', 533.0000, 'ºC'),
	(84584, 110, '2015-03-01 00:54:47.000000', 'temperatura', 17.0000, 'ºC'),
	(84585, 110, '2015-03-01 00:54:48.000000', 'temperatura', 884.0000, 'ºC'),
	(84586, 110, '2015-03-01 00:54:49.000000', 'temperatura', 769.0000, 'ºC'),
	(84587, 110, '2015-03-01 00:54:50.000000', 'temperatura', 1194.0000, 'ºC'),
	(84588, 110, '2015-03-01 00:54:51.000000', 'temperatura', 64.0000, 'ºC'),
	(84589, 110, '2015-03-01 00:54:52.000000', 'temperatura', 338.0000, 'ºC'),
	(84590, 110, '2015-03-01 00:54:53.000000', 'temperatura', 299.0000, 'ºC'),
	(84591, 110, '2015-03-01 00:54:54.000000', 'temperatura', 482.0000, 'ºC'),
	(84592, 110, '2015-03-01 00:54:55.000000', 'temperatura', 314.0000, 'ºC'),
	(84593, 110, '2015-03-01 00:54:56.000000', 'temperatura', 125.0000, 'ºC'),
	(84594, 110, '2015-03-01 00:54:57.000000', 'temperatura', 881.0000, 'ºC'),
	(84595, 110, '2015-03-01 00:54:58.000000', 'temperatura', 430.0000, 'ºC'),
	(84596, 110, '2015-03-01 00:54:59.000000', 'temperatura', 711.0000, 'ºC'),
	(84597, 110, '2015-03-01 00:55:00.000000', 'temperatura', 1062.0000, 'ºC'),
	(84598, 110, '2015-03-01 00:55:01.000000', 'temperatura', 779.0000, 'ºC'),
	(84599, 110, '2015-03-01 00:55:02.000000', 'temperatura', 710.0000, 'ºC'),
	(84600, 110, '2015-03-01 00:55:03.000000', 'temperatura', 14.0000, 'ºC'),
	(84601, 110, '2015-03-01 00:55:04.000000', 'temperatura', 341.0000, 'ºC'),
	(84602, 110, '2015-03-01 00:55:05.000000', 'temperatura', 463.0000, 'ºC'),
	(84603, 110, '2015-03-01 00:55:06.000000', 'temperatura', 92.0000, 'ºC'),
	(84604, 110, '2015-03-01 00:55:07.000000', 'temperatura', 270.0000, 'ºC'),
	(84605, 110, '2015-03-01 00:55:08.000000', 'temperatura', 1075.0000, 'ºC'),
	(84606, 110, '2015-03-01 00:55:09.000000', 'temperatura', 966.0000, 'ºC'),
	(84607, 110, '2015-03-01 00:55:10.000000', 'temperatura', 406.0000, 'ºC'),
	(84608, 110, '2015-03-01 00:55:11.000000', 'temperatura', 334.0000, 'ºC'),
	(84609, 110, '2015-03-01 00:55:12.000000', 'temperatura', 449.0000, 'ºC'),
	(84610, 110, '2015-03-01 00:55:13.000000', 'temperatura', 46.0000, 'ºC'),
	(84611, 110, '2015-03-01 00:55:14.000000', 'temperatura', 83.0000, 'ºC'),
	(84612, 110, '2015-03-01 00:55:15.000000', 'temperatura', 276.0000, 'ºC'),
	(84613, 110, '2015-03-01 00:55:16.000000', 'temperatura', 1132.0000, 'ºC'),
	(84614, 110, '2015-03-01 00:55:17.000000', 'temperatura', 32.0000, 'ºC'),
	(84615, 110, '2015-03-01 00:55:18.000000', 'temperatura', 363.0000, 'ºC'),
	(84616, 110, '2015-03-01 00:55:19.000000', 'temperatura', 522.0000, 'ºC'),
	(84617, 110, '2015-03-01 00:55:20.000000', 'temperatura', 322.0000, 'ºC'),
	(84618, 110, '2015-03-01 00:55:21.000000', 'temperatura', 44.0000, 'ºC'),
	(84619, 110, '2015-03-01 00:55:22.000000', 'temperatura', 455.0000, 'ºC'),
	(84620, 110, '2015-03-01 00:55:23.000000', 'temperatura', 942.0000, 'ºC'),
	(84621, 110, '2015-03-01 00:55:24.000000', 'temperatura', 947.0000, 'ºC'),
	(84622, 110, '2015-03-01 00:55:25.000000', 'temperatura', 707.0000, 'ºC'),
	(84623, 110, '2015-03-01 00:55:26.000000', 'temperatura', 696.0000, 'ºC'),
	(84624, 110, '2015-03-01 00:55:27.000000', 'temperatura', 159.0000, 'ºC'),
	(84625, 110, '2015-03-01 00:55:28.000000', 'temperatura', 1110.0000, 'ºC'),
	(84626, 110, '2015-03-01 00:55:29.000000', 'temperatura', 271.0000, 'ºC'),
	(84627, 110, '2015-03-01 00:55:30.000000', 'temperatura', 428.0000, 'ºC'),
	(84628, 110, '2015-03-01 00:55:31.000000', 'temperatura', 125.0000, 'ºC'),
	(84629, 110, '2015-03-01 00:55:32.000000', 'temperatura', 544.0000, 'ºC'),
	(84630, 110, '2015-03-01 00:55:33.000000', 'temperatura', 1145.0000, 'ºC'),
	(84631, 110, '2015-03-01 00:55:34.000000', 'temperatura', 492.0000, 'ºC'),
	(84632, 110, '2015-03-01 00:55:35.000000', 'temperatura', 225.0000, 'ºC'),
	(84633, 110, '2015-03-01 00:55:36.000000', 'temperatura', 849.0000, 'ºC'),
	(84634, 110, '2015-03-01 00:55:37.000000', 'temperatura', 1169.0000, 'ºC'),
	(84635, 110, '2015-03-01 00:55:38.000000', 'temperatura', 902.0000, 'ºC'),
	(84636, 110, '2015-03-01 00:55:39.000000', 'temperatura', 1001.0000, 'ºC'),
	(84637, 110, '2015-03-01 00:55:40.000000', 'temperatura', 1100.0000, 'ºC'),
	(84638, 110, '2015-03-01 00:55:41.000000', 'temperatura', 98.0000, 'ºC'),
	(84639, 110, '2015-03-01 00:55:42.000000', 'temperatura', 789.0000, 'ºC'),
	(84640, 110, '2015-03-01 00:55:43.000000', 'temperatura', 52.0000, 'ºC'),
	(84641, 110, '2015-03-01 00:55:44.000000', 'temperatura', 292.0000, 'ºC'),
	(84642, 110, '2015-03-01 00:55:45.000000', 'temperatura', 106.0000, 'ºC'),
	(84643, 110, '2015-03-01 00:55:46.000000', 'temperatura', 852.0000, 'ºC'),
	(84644, 110, '2015-03-01 00:55:47.000000', 'temperatura', 345.0000, 'ºC'),
	(84645, 110, '2015-03-01 00:55:48.000000', 'temperatura', 369.0000, 'ºC'),
	(84646, 110, '2015-03-01 00:55:49.000000', 'temperatura', 809.0000, 'ºC'),
	(84647, 110, '2015-03-01 00:55:50.000000', 'temperatura', 539.0000, 'ºC'),
	(84648, 110, '2015-03-01 00:55:51.000000', 'temperatura', 268.0000, 'ºC'),
	(84649, 110, '2015-03-01 00:55:52.000000', 'temperatura', 924.0000, 'ºC'),
	(84650, 110, '2015-03-01 00:55:53.000000', 'temperatura', 219.0000, 'ºC'),
	(84651, 110, '2015-03-01 00:55:54.000000', 'temperatura', 720.0000, 'ºC'),
	(84652, 110, '2015-03-01 00:55:55.000000', 'temperatura', 547.0000, 'ºC'),
	(84653, 110, '2015-03-01 00:55:56.000000', 'temperatura', 573.0000, 'ºC'),
	(84654, 110, '2015-03-01 00:55:57.000000', 'temperatura', 24.0000, 'ºC'),
	(84655, 110, '2015-03-01 00:55:58.000000', 'temperatura', 803.0000, 'ºC'),
	(84656, 110, '2015-03-01 00:55:59.000000', 'temperatura', 345.0000, 'ºC'),
	(84657, 110, '2015-03-01 00:56:00.000000', 'temperatura', 514.0000, 'ºC'),
	(84658, 110, '2015-03-01 00:56:01.000000', 'temperatura', 335.0000, 'ºC'),
	(84659, 110, '2015-03-01 00:56:02.000000', 'temperatura', 135.0000, 'ºC'),
	(84660, 110, '2015-03-01 00:56:03.000000', 'temperatura', 872.0000, 'ºC'),
	(84661, 110, '2015-03-01 00:56:04.000000', 'temperatura', 353.0000, 'ºC'),
	(84662, 110, '2015-03-01 00:56:05.000000', 'temperatura', 350.0000, 'ºC'),
	(84663, 110, '2015-03-01 00:56:06.000000', 'temperatura', 690.0000, 'ºC'),
	(84664, 110, '2015-03-01 00:56:07.000000', 'temperatura', 1.0000, 'ºC'),
	(84665, 110, '2015-03-01 00:56:08.000000', 'temperatura', 336.0000, 'ºC'),
	(84666, 110, '2015-03-01 00:56:09.000000', 'temperatura', 478.0000, 'ºC'),
	(84667, 110, '2015-03-01 00:56:10.000000', 'temperatura', 182.0000, 'ºC'),
	(84668, 110, '2015-03-01 00:56:11.000000', 'temperatura', 677.0000, 'ºC'),
	(84669, 110, '2015-03-01 00:56:12.000000', 'temperatura', 440.0000, 'ºC'),
	(84670, 110, '2015-03-01 00:56:13.000000', 'temperatura', 168.0000, 'ºC'),
	(84671, 110, '2015-03-01 00:56:14.000000', 'temperatura', 719.0000, 'ºC'),
	(84672, 110, '2015-03-01 00:56:15.000000', 'temperatura', 693.0000, 'ºC'),
	(84673, 110, '2015-03-01 00:56:16.000000', 'temperatura', 111.0000, 'ºC'),
	(84674, 110, '2015-03-01 00:56:17.000000', 'temperatura', 873.0000, 'ºC'),
	(84675, 110, '2015-03-01 00:56:18.000000', 'temperatura', 432.0000, 'ºC'),
	(84676, 110, '2015-03-01 00:56:19.000000', 'temperatura', 744.0000, 'ºC'),
	(84677, 110, '2015-03-01 00:56:20.000000', 'temperatura', 23.0000, 'ºC'),
	(84678, 110, '2015-03-01 00:56:21.000000', 'temperatura', 284.0000, 'ºC'),
	(84679, 110, '2015-03-01 00:56:22.000000', 'temperatura', 151.0000, 'ºC'),
	(84680, 110, '2015-03-01 00:56:23.000000', 'temperatura', 1105.0000, 'ºC'),
	(84681, 110, '2015-03-01 00:56:24.000000', 'temperatura', 270.0000, 'ºC'),
	(84682, 110, '2015-03-01 00:56:25.000000', 'temperatura', 436.0000, 'ºC'),
	(84683, 110, '2015-03-01 00:56:26.000000', 'temperatura', 169.0000, 'ºC'),
	(84684, 110, '2015-03-01 00:56:27.000000', 'temperatura', 739.0000, 'ºC'),
	(84685, 110, '2015-03-01 00:56:28.000000', 'temperatura', 787.0000, 'ºC'),
	(84686, 110, '2015-03-01 00:56:29.000000', 'temperatura', 518.0000, 'ºC'),
	(84687, 110, '2015-03-01 00:56:30.000000', 'temperatura', 231.0000, 'ºC'),
	(84688, 110, '2015-03-01 00:56:31.000000', 'temperatura', 803.0000, 'ºC'),
	(84689, 110, '2015-03-01 00:56:32.000000', 'temperatura', 923.0000, 'ºC'),
	(84690, 110, '2015-03-01 00:56:33.000000', 'temperatura', 1003.0000, 'ºC'),
	(84691, 110, '2015-03-01 00:56:34.000000', 'temperatura', 1049.0000, 'ºC'),
	(84692, 110, '2015-03-01 00:56:35.000000', 'temperatura', 1038.0000, 'ºC'),
	(84693, 110, '2015-03-01 00:56:36.000000', 'temperatura', 841.0000, 'ºC'),
	(84694, 110, '2015-03-01 00:56:37.000000', 'temperatura', 1090.0000, 'ºC'),
	(84695, 110, '2015-03-01 00:56:38.000000', 'temperatura', 529.0000, 'ºC'),
	(84696, 110, '2015-03-01 00:56:39.000000', 'temperatura', 577.0000, 'ºC'),
	(84697, 110, '2015-03-01 00:56:40.000000', 'temperatura', 97.0000, 'ºC'),
	(84698, 110, '2015-03-01 00:56:41.000000', 'temperatura', 1156.0000, 'ºC'),
	(84699, 110, '2015-03-01 00:56:42.000000', 'temperatura', 690.0000, 'ºC'),
	(84700, 110, '2015-03-01 00:56:43.000000', 'temperatura', 1181.0000, 'ºC'),
	(84701, 110, '2015-03-01 00:56:44.000000', 'temperatura', 237.0000, 'ºC'),
	(84702, 110, '2015-03-01 00:56:45.000000', 'temperatura', 41.0000, 'ºC'),
	(84703, 110, '2015-03-01 00:56:46.000000', 'temperatura', 693.0000, 'ºC'),
	(84704, 110, '2015-03-01 00:56:47.000000', 'temperatura', 944.0000, 'ºC'),
	(84705, 110, '2015-03-01 00:56:48.000000', 'temperatura', 243.0000, 'ºC'),
	(84706, 110, '2015-03-01 00:56:49.000000', 'temperatura', 780.0000, 'ºC'),
	(84707, 110, '2015-03-01 00:56:50.000000', 'temperatura', 775.0000, 'ºC'),
	(84708, 110, '2015-03-01 00:56:51.000000', 'temperatura', 333.0000, 'ºC'),
	(84709, 110, '2015-03-01 00:56:52.000000', 'temperatura', 540.0000, 'ºC'),
	(84710, 110, '2015-03-01 00:56:53.000000', 'temperatura', 501.0000, 'ºC'),
	(84711, 110, '2015-03-01 00:56:54.000000', 'temperatura', 885.0000, 'ºC'),
	(84712, 110, '2015-03-01 00:56:55.000000', 'temperatura', 522.0000, 'ºC'),
	(84713, 110, '2015-03-01 00:56:56.000000', 'temperatura', 1155.0000, 'ºC'),
	(84714, 110, '2015-03-01 00:56:57.000000', 'temperatura', 610.0000, 'ºC'),
	(84715, 110, '2015-03-01 00:56:58.000000', 'temperatura', 786.0000, 'ºC'),
	(84716, 110, '2015-03-01 00:56:59.000000', 'temperatura', 901.0000, 'ºC'),
	(84717, 110, '2015-03-01 00:57:00.000000', 'temperatura', 946.0000, 'ºC'),
	(84718, 110, '2015-03-01 00:57:01.000000', 'temperatura', 830.0000, 'ºC'),
	(84719, 110, '2015-03-01 00:57:02.000000', 'temperatura', 111.0000, 'ºC'),
	(84720, 110, '2015-03-01 00:57:03.000000', 'temperatura', 464.0000, 'ºC'),
	(84721, 110, '2015-03-01 00:57:04.000000', 'temperatura', 789.0000, 'ºC'),
	(84722, 110, '2015-03-01 00:57:05.000000', 'temperatura', 153.0000, 'ºC'),
	(84723, 110, '2015-03-01 00:57:06.000000', 'temperatura', 798.0000, 'ºC'),
	(84724, 110, '2015-03-01 00:57:07.000000', 'temperatura', 1133.0000, 'ºC'),
	(84725, 110, '2015-03-01 00:57:08.000000', 'temperatura', 870.0000, 'ºC'),
	(84726, 110, '2015-03-01 00:57:09.000000', 'temperatura', 951.0000, 'ºC'),
	(84727, 110, '2015-03-01 00:57:10.000000', 'temperatura', 948.0000, 'ºC'),
	(84728, 110, '2015-03-01 00:57:11.000000', 'temperatura', 684.0000, 'ºC'),
	(84729, 110, '2015-03-01 00:57:12.000000', 'temperatura', 579.0000, 'ºC'),
	(84730, 110, '2015-03-01 00:57:13.000000', 'temperatura', 843.0000, 'ºC'),
	(84731, 110, '2015-03-01 00:57:14.000000', 'temperatura', 78.0000, 'ºC'),
	(84732, 110, '2015-03-01 00:57:15.000000', 'temperatura', 261.0000, 'ºC'),
	(84733, 110, '2015-03-01 00:57:16.000000', 'temperatura', 1071.0000, 'ºC'),
	(84734, 110, '2015-03-01 00:57:17.000000', 'temperatura', 972.0000, 'ºC'),
	(84735, 110, '2015-03-01 00:57:18.000000', 'temperatura', 450.0000, 'ºC'),
	(84736, 110, '2015-03-01 00:57:19.000000', 'temperatura', 532.0000, 'ºC'),
	(84737, 110, '2015-03-01 00:57:20.000000', 'temperatura', 110.0000, 'ºC'),
	(84738, 110, '2015-03-01 00:57:21.000000', 'temperatura', 154.0000, 'ºC'),
	(84739, 110, '2015-03-01 00:57:22.000000', 'temperatura', 441.0000, 'ºC'),
	(84740, 110, '2015-03-01 00:57:23.000000', 'temperatura', 546.0000, 'ºC'),
	(84741, 110, '2015-03-01 00:57:24.000000', 'temperatura', 205.0000, 'ºC'),
	(84742, 110, '2015-03-01 00:57:25.000000', 'temperatura', 588.0000, 'ºC'),
	(84743, 110, '2015-03-01 00:57:26.000000', 'temperatura', 1127.0000, 'ºC'),
	(84744, 110, '2015-03-01 00:57:27.000000', 'temperatura', 271.0000, 'ºC'),
	(84745, 110, '2015-03-01 00:57:28.000000', 'temperatura', 375.0000, 'ºC'),
	(84746, 110, '2015-03-01 00:57:29.000000', 'temperatura', 1060.0000, 'ºC'),
	(84747, 110, '2015-03-01 00:57:30.000000', 'temperatura', 579.0000, 'ºC'),
	(84748, 110, '2015-03-01 00:57:31.000000', 'temperatura', 912.0000, 'ºC'),
	(84749, 110, '2015-03-01 00:57:32.000000', 'temperatura', 425.0000, 'ºC'),
	(84750, 110, '2015-03-01 00:57:33.000000', 'temperatura', 590.0000, 'ºC'),
	(84751, 110, '2015-03-01 00:57:34.000000', 'temperatura', 473.0000, 'ºC'),
	(84752, 110, '2015-03-01 00:57:35.000000', 'temperatura', 599.0000, 'ºC'),
	(84753, 110, '2015-03-01 00:57:36.000000', 'temperatura', 374.0000, 'ºC'),
	(84754, 110, '2015-03-01 00:57:37.000000', 'temperatura', 74.0000, 'ºC'),
	(84755, 110, '2015-03-01 00:57:38.000000', 'temperatura', 449.0000, 'ºC'),
	(84756, 110, '2015-03-01 00:57:39.000000', 'temperatura', 824.0000, 'ºC'),
	(84757, 110, '2015-03-01 00:57:40.000000', 'temperatura', 371.0000, 'ºC'),
	(84758, 110, '2015-03-01 00:57:41.000000', 'temperatura', 585.0000, 'ºC'),
	(84759, 110, '2015-03-01 00:57:42.000000', 'temperatura', 611.0000, 'ºC'),
	(84760, 110, '2015-03-01 00:57:43.000000', 'temperatura', 100.0000, 'ºC'),
	(84761, 110, '2015-03-01 00:57:44.000000', 'temperatura', 1070.0000, 'ºC'),
	(84762, 110, '2015-03-01 00:57:45.000000', 'temperatura', 251.0000, 'ºC'),
	(84763, 110, '2015-03-01 00:57:46.000000', 'temperatura', 443.0000, 'ºC'),
	(84764, 110, '2015-03-01 00:57:47.000000', 'temperatura', 265.0000, 'ºC'),
	(84765, 110, '2015-03-01 00:57:48.000000', 'temperatura', 1195.0000, 'ºC'),
	(84766, 110, '2015-03-01 00:57:49.000000', 'temperatura', 380.0000, 'ºC'),
	(84767, 110, '2015-03-01 00:57:50.000000', 'temperatura', 716.0000, 'ºC'),
	(84768, 110, '2015-03-01 00:57:51.000000', 'temperatura', 40.0000, 'ºC'),
	(84769, 110, '2015-03-01 00:57:52.000000', 'temperatura', 454.0000, 'ºC'),
	(84770, 110, '2015-03-01 00:57:53.000000', 'temperatura', 948.0000, 'ºC'),
	(84771, 110, '2015-03-01 00:57:54.000000', 'temperatura', 979.0000, 'ºC'),
	(84772, 110, '2015-03-01 00:57:55.000000', 'temperatura', 853.0000, 'ºC'),
	(84773, 110, '2015-03-01 00:57:56.000000', 'temperatura', 128.0000, 'ºC'),
	(84774, 110, '2015-03-01 00:57:57.000000', 'temperatura', 481.0000, 'ºC'),
	(84775, 110, '2015-03-01 00:57:58.000000', 'temperatura', 820.0000, 'ºC'),
	(84776, 110, '2015-03-01 00:57:59.000000', 'temperatura', 261.0000, 'ºC'),
	(84777, 110, '2015-03-01 00:58:00.000000', 'temperatura', 42.0000, 'ºC'),
	(84778, 110, '2015-03-01 00:58:01.000000', 'temperatura', 629.0000, 'ºC'),
	(84779, 110, '2015-03-01 00:58:02.000000', 'temperatura', 618.0000, 'ºC'),
	(84780, 110, '2015-03-01 00:58:03.000000', 'temperatura', 5.0000, 'ºC'),
	(84781, 110, '2015-03-01 00:58:04.000000', 'temperatura', 571.0000, 'ºC'),
	(84782, 110, '2015-03-01 00:58:05.000000', 'temperatura', 441.0000, 'ºC'),
	(84783, 110, '2015-03-01 00:58:06.000000', 'temperatura', 492.0000, 'ºC'),
	(84784, 110, '2015-03-01 00:58:07.000000', 'temperatura', 1139.0000, 'ºC'),
	(84785, 110, '2015-03-01 00:58:08.000000', 'temperatura', 618.0000, 'ºC'),
	(84786, 110, '2015-03-01 00:58:09.000000', 'temperatura', 874.0000, 'ºC'),
	(84787, 110, '2015-03-01 00:58:10.000000', 'temperatura', 118.0000, 'ºC'),
	(84788, 110, '2015-03-01 00:58:11.000000', 'temperatura', 366.0000, 'ºC'),
	(84789, 110, '2015-03-01 00:58:12.000000', 'temperatura', 278.0000, 'ºC'),
	(84790, 110, '2015-03-01 00:58:13.000000', 'temperatura', 294.0000, 'ºC'),
	(84791, 110, '2015-03-01 00:58:14.000000', 'temperatura', 634.0000, 'ºC'),
	(84792, 110, '2015-03-01 00:58:15.000000', 'temperatura', 1089.0000, 'ºC'),
	(84793, 110, '2015-03-01 00:58:16.000000', 'temperatura', 1143.0000, 'ºC'),
	(84794, 110, '2015-03-01 00:58:17.000000', 'temperatura', 48.0000, 'ºC'),
	(84795, 110, '2015-03-01 00:58:18.000000', 'temperatura', 413.0000, 'ºC'),
	(84796, 110, '2015-03-01 00:58:19.000000', 'temperatura', 720.0000, 'ºC'),
	(84797, 110, '2015-03-01 00:58:20.000000', 'temperatura', 1161.0000, 'ºC'),
	(84798, 110, '2015-03-01 00:58:21.000000', 'temperatura', 46.0000, 'ºC'),
	(84799, 110, '2015-03-01 00:58:22.000000', 'temperatura', 348.0000, 'ºC'),
	(84800, 110, '2015-03-01 00:58:23.000000', 'temperatura', 402.0000, 'ºC'),
	(84801, 110, '2015-03-01 00:58:24.000000', 'temperatura', 966.0000, 'ºC'),
	(84802, 110, '2015-03-01 00:58:25.000000', 'temperatura', 24.0000, 'ºC'),
	(84803, 110, '2015-03-01 00:58:26.000000', 'temperatura', 824.0000, 'ºC'),
	(84804, 110, '2015-03-01 00:58:27.000000', 'temperatura', 446.0000, 'ºC'),
	(84805, 110, '2015-03-01 00:58:28.000000', 'temperatura', 960.0000, 'ºC'),
	(84806, 110, '2015-03-01 00:58:29.000000', 'temperatura', 1063.0000, 'ºC'),
	(84807, 110, '2015-03-01 00:58:30.000000', 'temperatura', 33.0000, 'ºC'),
	(84808, 110, '2015-03-01 00:58:31.000000', 'temperatura', 579.0000, 'ºC'),
	(84809, 110, '2015-03-01 00:58:32.000000', 'temperatura', 395.0000, 'ºC'),
	(84810, 110, '2015-03-01 00:58:33.000000', 'temperatura', 239.0000, 'ºC'),
	(84811, 110, '2015-03-01 00:58:34.000000', 'temperatura', 10.0000, 'ºC'),
	(84812, 110, '2015-03-01 00:58:35.000000', 'temperatura', 533.0000, 'ºC'),
	(84813, 110, '2015-03-01 00:58:36.000000', 'temperatura', 237.0000, 'ºC'),
	(84814, 110, '2015-03-01 00:58:37.000000', 'temperatura', 786.0000, 'ºC'),
	(84815, 110, '2015-03-01 00:58:38.000000', 'temperatura', 820.0000, 'ºC'),
	(84816, 110, '2015-03-01 00:58:39.000000', 'temperatura', 544.0000, 'ºC'),
	(84817, 110, '2015-03-01 00:58:40.000000', 'temperatura', 258.0000, 'ºC'),
	(84818, 110, '2015-03-01 00:58:41.000000', 'temperatura', 860.0000, 'ºC'),
	(84819, 110, '2015-03-01 00:58:42.000000', 'temperatura', 1128.0000, 'ºC'),
	(84820, 110, '2015-03-01 00:58:43.000000', 'temperatura', 658.0000, 'ºC'),
	(84821, 110, '2015-03-01 00:58:44.000000', 'temperatura', 1109.0000, 'ºC'),
	(84822, 110, '2015-03-01 00:58:45.000000', 'temperatura', 1170.0000, 'ºC'),
	(84823, 110, '2015-03-01 00:58:46.000000', 'temperatura', 125.0000, 'ºC'),
	(84824, 110, '2015-03-01 00:58:47.000000', 'temperatura', 716.0000, 'ºC'),
	(84825, 110, '2015-03-01 00:58:48.000000', 'temperatura', 802.0000, 'ºC'),
	(84826, 110, '2015-03-01 00:58:49.000000', 'temperatura', 666.0000, 'ºC'),
	(84827, 110, '2015-03-01 00:58:50.000000', 'temperatura', 923.0000, 'ºC'),
	(84828, 110, '2015-03-01 00:58:51.000000', 'temperatura', 218.0000, 'ºC'),
	(84829, 110, '2015-03-01 00:58:52.000000', 'temperatura', 722.0000, 'ºC'),
	(84830, 110, '2015-03-01 00:58:53.000000', 'temperatura', 556.0000, 'ºC'),
	(84831, 110, '2015-03-01 00:58:54.000000', 'temperatura', 616.0000, 'ºC'),
	(84832, 110, '2015-03-01 00:58:55.000000', 'temperatura', 213.0000, 'ºC'),
	(84833, 110, '2015-03-01 00:58:56.000000', 'temperatura', 417.0000, 'ºC'),
	(84834, 110, '2015-03-01 00:58:57.000000', 'temperatura', 246.0000, 'ºC'),
	(84835, 110, '2015-03-01 00:58:58.000000', 'temperatura', 1181.0000, 'ºC'),
	(84836, 110, '2015-03-01 00:58:59.000000', 'temperatura', 364.0000, 'ºC'),
	(84837, 110, '2015-03-01 00:59:00.000000', 'temperatura', 681.0000, 'ºC'),
	(84838, 110, '2015-03-01 00:59:01.000000', 'temperatura', 1112.0000, 'ºC'),
	(84839, 110, '2015-03-01 00:59:02.000000', 'temperatura', 1116.0000, 'ºC'),
	(84840, 110, '2015-03-01 00:59:03.000000', 'temperatura', 1048.0000, 'ºC'),
	(84841, 110, '2015-03-01 00:59:04.000000', 'temperatura', 689.0000, 'ºC'),
	(84842, 110, '2015-03-01 00:59:05.000000', 'temperatura', 303.0000, 'ºC'),
	(84843, 110, '2015-03-01 00:59:06.000000', 'temperatura', 649.0000, 'ºC'),
	(84844, 110, '2015-03-01 00:59:07.000000', 'temperatura', 1136.0000, 'ºC'),
	(84845, 110, '2015-03-01 00:59:08.000000', 'temperatura', 132.0000, 'ºC'),
	(84846, 110, '2015-03-01 00:59:09.000000', 'temperatura', 852.0000, 'ºC'),
	(84847, 110, '2015-03-01 00:59:10.000000', 'temperatura', 266.0000, 'ºC'),
	(84848, 110, '2015-03-01 00:59:11.000000', 'temperatura', 1175.0000, 'ºC'),
	(84849, 110, '2015-03-01 00:59:12.000000', 'temperatura', 276.0000, 'ºC'),
	(84850, 110, '2015-03-01 00:59:13.000000', 'temperatura', 258.0000, 'ºC'),
	(84851, 110, '2015-03-01 00:59:14.000000', 'temperatura', 462.0000, 'ºC'),
	(84852, 110, '2015-03-01 00:59:15.000000', 'temperatura', 337.0000, 'ºC'),
	(84853, 110, '2015-03-01 00:59:16.000000', 'temperatura', 298.0000, 'ºC'),
	(84854, 110, '2015-03-01 00:59:17.000000', 'temperatura', 481.0000, 'ºC'),
	(84855, 110, '2015-03-01 00:59:18.000000', 'temperatura', 311.0000, 'ºC'),
	(84856, 110, '2015-03-01 00:59:19.000000', 'temperatura', 114.0000, 'ºC'),
	(84857, 110, '2015-03-01 00:59:20.000000', 'temperatura', 838.0000, 'ºC'),
	(84858, 110, '2015-03-01 00:59:21.000000', 'temperatura', 249.0000, 'ºC'),
	(84859, 110, '2015-03-01 00:59:22.000000', 'temperatura', 1132.0000, 'ºC'),
	(84860, 110, '2015-03-01 00:59:23.000000', 'temperatura', 114.0000, 'ºC'),
	(84861, 110, '2015-03-01 00:59:24.000000', 'temperatura', 774.0000, 'ºC'),
	(84862, 110, '2015-03-01 00:59:25.000000', 'temperatura', 1130.0000, 'ºC'),
	(84863, 110, '2015-03-01 00:59:26.000000', 'temperatura', 926.0000, 'ºC'),
	(84864, 110, '2015-03-01 00:59:27.000000', 'temperatura', 41.0000, 'ºC'),
	(84865, 110, '2015-03-01 00:59:28.000000', 'temperatura', 1030.0000, 'ºC'),
	(84866, 110, '2015-03-01 00:59:29.000000', 'temperatura', 224.0000, 'ºC'),
	(84867, 110, '2015-03-01 00:59:30.000000', 'temperatura', 432.0000, 'ºC'),
	(84868, 110, '2015-03-01 00:59:31.000000', 'temperatura', 290.0000, 'ºC'),
	(84869, 110, '2015-03-01 00:59:32.000000', 'temperatura', 155.0000, 'ºC'),
	(84870, 110, '2015-03-01 00:59:33.000000', 'temperatura', 1106.0000, 'ºC'),
	(84871, 110, '2015-03-01 00:59:34.000000', 'temperatura', 264.0000, 'ºC'),
	(84872, 110, '2015-03-01 00:59:35.000000', 'temperatura', 405.0000, 'ºC'),
	(84873, 110, '2015-03-01 00:59:36.000000', 'temperatura', 30.0000, 'ºC'),
	(84874, 110, '2015-03-01 00:59:37.000000', 'temperatura', 137.0000, 'ºC'),
	(84875, 110, '2015-03-01 00:59:38.000000', 'temperatura', 597.0000, 'ºC'),
	(84876, 110, '2015-03-01 00:59:39.000000', 'temperatura', 175.0000, 'ºC'),
	(84877, 110, '2015-03-01 00:59:40.000000', 'temperatura', 284.0000, 'ºC'),
	(84878, 110, '2015-03-01 00:59:41.000000', 'temperatura', 893.0000, 'ºC'),
	(84879, 110, '2015-03-01 00:59:42.000000', 'temperatura', 17.0000, 'ºC'),
	(84880, 110, '2015-03-01 00:59:43.000000', 'temperatura', 1005.0000, 'ºC'),
	(84881, 110, '2015-03-01 00:59:44.000000', 'temperatura', 173.0000, 'ºC'),
	(84882, 110, '2015-03-01 00:59:45.000000', 'temperatura', 251.0000, 'ºC'),
	(84883, 110, '2015-03-01 00:59:46.000000', 'temperatura', 737.0000, 'ºC'),
	(84884, 110, '2015-03-01 00:59:47.000000', 'temperatura', 532.0000, 'ºC'),
	(84885, 110, '2015-03-01 00:59:48.000000', 'temperatura', 450.0000, 'ºC'),
	(84886, 110, '2015-03-01 00:59:49.000000', 'temperatura', 655.0000, 'ºC'),
	(84887, 110, '2015-03-01 00:59:50.000000', 'temperatura', 726.0000, 'ºC'),
	(84888, 110, '2015-03-01 00:59:51.000000', 'temperatura', 464.0000, 'ºC'),
	(84889, 110, '2015-03-01 00:59:52.000000', 'temperatura', 142.0000, 'ºC'),
	(84890, 110, '2015-03-01 00:59:53.000000', 'temperatura', 519.0000, 'ºC'),
	(84891, 110, '2015-03-01 00:59:54.000000', 'temperatura', 968.0000, 'ºC'),
	(84892, 110, '2015-03-01 00:59:55.000000', 'temperatura', 886.0000, 'ºC'),
	(84893, 110, '2015-03-01 00:59:56.000000', 'temperatura', 325.0000, 'ºC'),
	(84894, 110, '2015-03-01 00:59:57.000000', 'temperatura', 169.0000, 'ºC'),
	(84895, 110, '2015-03-01 00:59:58.000000', 'temperatura', 1069.0000, 'ºC'),
	(84896, 110, '2015-03-01 00:59:59.000000', 'temperatura', 41.0000, 'ºC'),
	(84897, 110, '2015-03-01 01:00:00.000000', 'temperatura', 596.0000, 'ºC'),
	(84898, 110, '2015-03-01 01:00:01.000000', 'temperatura', 458.0000, 'ºC'),
	(84899, 110, '2015-03-01 01:00:02.000000', 'temperatura', 502.0000, 'ºC'),
	(84900, 110, '2015-03-01 01:00:03.000000', 'temperatura', 1137.0000, 'ºC'),
	(84901, 110, '2015-03-01 01:00:04.000000', 'temperatura', 581.0000, 'ºC'),
	(84902, 110, '2015-03-01 01:00:05.000000', 'temperatura', 692.0000, 'ºC'),
	(84903, 110, '2015-03-01 01:00:06.000000', 'temperatura', 520.0000, 'ºC'),
	(84904, 110, '2015-03-01 01:00:07.000000', 'temperatura', 524.0000, 'ºC'),
	(84905, 110, '2015-03-01 01:00:08.000000', 'temperatura', 1060.0000, 'ºC'),
	(84906, 110, '2015-03-01 01:00:09.000000', 'temperatura', 130.0000, 'ºC'),
	(84907, 110, '2015-03-01 01:00:10.000000', 'temperatura', 1068.0000, 'ºC'),
	(84908, 110, '2015-03-01 01:00:11.000000', 'temperatura', 150.0000, 'ºC'),
	(84909, 110, '2015-03-01 01:00:12.000000', 'temperatura', 1148.0000, 'ºC'),
	(84910, 110, '2015-03-01 01:00:13.000000', 'temperatura', 491.0000, 'ºC'),
	(84911, 110, '2015-03-01 01:00:14.000000', 'temperatura', 212.0000, 'ºC'),
	(84912, 110, '2015-03-01 01:00:15.000000', 'temperatura', 788.0000, 'ºC'),
	(84913, 110, '2015-03-01 01:00:16.000000', 'temperatura', 905.0000, 'ºC'),
	(84914, 110, '2015-03-01 01:00:17.000000', 'temperatura', 959.0000, 'ºC'),
	(84915, 110, '2015-03-01 01:00:18.000000', 'temperatura', 879.0000, 'ºC'),
	(84916, 110, '2015-03-01 01:00:19.000000', 'temperatura', 322.0000, 'ºC'),
	(84917, 110, '2015-03-01 01:00:20.000000', 'temperatura', 174.0000, 'ºC'),
	(84918, 110, '2015-03-01 01:00:21.000000', 'temperatura', 1103.0000, 'ºC'),
	(84919, 110, '2015-03-01 01:00:22.000000', 'temperatura', 194.0000, 'ºC'),
	(84920, 110, '2015-03-01 01:00:23.000000', 'temperatura', 61.0000, 'ºC'),
	(84921, 110, '2015-03-01 01:00:24.000000', 'temperatura', 922.0000, 'ºC'),
	(84922, 110, '2015-03-01 01:00:25.000000', 'temperatura', 827.0000, 'ºC'),
	(84923, 110, '2015-03-01 01:00:26.000000', 'temperatura', 172.0000, 'ºC'),
	(84924, 110, '2015-03-01 01:00:27.000000', 'temperatura', 778.0000, 'ºC'),
	(84925, 110, '2015-03-01 01:00:28.000000', 'temperatura', 975.0000, 'ºC'),
	(84926, 110, '2015-03-01 01:00:29.000000', 'temperatura', 139.0000, 'ºC'),
	(84927, 110, '2015-03-01 01:00:30.000000', 'temperatura', 174.0000, 'ºC'),
	(84928, 110, '2015-03-01 01:00:31.000000', 'temperatura', 453.0000, 'ºC'),
	(84929, 110, '2015-03-01 01:00:32.000000', 'temperatura', 544.0000, 'ºC'),
	(84930, 110, '2015-03-01 01:00:33.000000', 'temperatura', 162.0000, 'ºC'),
	(84931, 110, '2015-03-01 01:00:34.000000', 'temperatura', 377.0000, 'ºC'),
	(84932, 110, '2015-03-01 01:00:35.000000', 'temperatura', 200.0000, 'ºC'),
	(84933, 110, '2015-03-01 01:00:36.000000', 'temperatura', 1068.0000, 'ºC'),
	(84934, 110, '2015-03-01 01:00:37.000000', 'temperatura', 1140.0000, 'ºC'),
	(84935, 110, '2015-03-01 01:00:38.000000', 'temperatura', 98.0000, 'ºC'),
	(84936, 110, '2015-03-01 01:00:39.000000', 'temperatura', 670.0000, 'ºC'),
	(84937, 110, '2015-03-01 01:00:40.000000', 'temperatura', 658.0000, 'ºC'),
	(84938, 110, '2015-03-01 01:00:41.000000', 'temperatura', 80.0000, 'ºC'),
	(84939, 110, '2015-03-01 01:00:42.000000', 'temperatura', 825.0000, 'ºC'),
	(84940, 110, '2015-03-01 01:00:43.000000', 'temperatura', 286.0000, 'ºC'),
	(84941, 110, '2015-03-01 01:00:44.000000', 'temperatura', 156.0000, 'ºC'),
	(84942, 110, '2015-03-01 01:00:45.000000', 'temperatura', 1123.0000, 'ºC'),
	(84943, 110, '2015-03-01 01:00:46.000000', 'temperatura', 349.0000, 'ºC'),
	(84944, 110, '2015-03-01 01:00:47.000000', 'temperatura', 774.0000, 'ºC'),
	(84945, 110, '2015-03-01 01:00:48.000000', 'temperatura', 425.0000, 'ºC'),
	(84946, 110, '2015-03-01 01:00:49.000000', 'temperatura', 1001.0000, 'ºC'),
	(84947, 110, '2015-03-01 01:00:50.000000', 'temperatura', 133.0000, 'ºC'),
	(84948, 110, '2015-03-01 01:00:51.000000', 'temperatura', 62.0000, 'ºC'),
	(84949, 110, '2015-03-01 01:00:52.000000', 'temperatura', 1113.0000, 'ºC'),
	(84950, 110, '2015-03-01 01:00:53.000000', 'temperatura', 580.0000, 'ºC'),
	(84951, 110, '2015-03-01 01:00:54.000000', 'temperatura', 760.0000, 'ºC'),
	(84952, 110, '2015-03-01 01:00:55.000000', 'temperatura', 862.0000, 'ºC'),
	(84953, 110, '2015-03-01 01:00:56.000000', 'temperatura', 829.0000, 'ºC'),
	(84954, 110, '2015-03-01 01:00:57.000000', 'temperatura', 358.0000, 'ºC'),
	(84955, 110, '2015-03-01 01:00:58.000000', 'temperatura', 506.0000, 'ºC'),
	(84956, 110, '2015-03-01 01:00:59.000000', 'temperatura', 256.0000, 'ºC'),
	(84957, 110, '2015-03-01 01:01:00.000000', 'temperatura', 964.0000, 'ºC'),
	(84958, 110, '2015-03-01 01:01:01.000000', 'temperatura', 450.0000, 'ºC'),
	(84959, 110, '2015-03-01 01:01:02.000000', 'temperatura', 559.0000, 'ºC'),
	(84960, 110, '2015-03-01 01:01:03.000000', 'temperatura', 247.0000, 'ºC'),
	(84961, 110, '2015-03-01 01:01:04.000000', 'temperatura', 759.0000, 'ºC'),
	(84962, 110, '2015-03-01 01:01:05.000000', 'temperatura', 652.0000, 'ºC'),
	(84963, 110, '2015-03-01 01:01:06.000000', 'temperatura', 983.0000, 'ºC'),
	(84964, 110, '2015-03-01 01:01:07.000000', 'temperatura', 559.0000, 'ºC'),
	(84965, 110, '2015-03-01 01:01:08.000000', 'temperatura', 1049.0000, 'ºC'),
	(84966, 110, '2015-03-01 01:01:09.000000', 'temperatura', 1169.0000, 'ºC'),
	(84967, 110, '2015-03-01 01:01:10.000000', 'temperatura', 297.0000, 'ºC'),
	(84968, 110, '2015-03-01 01:01:11.000000', 'temperatura', 379.0000, 'ºC'),
	(84969, 110, '2015-03-01 01:01:12.000000', 'temperatura', 1005.0000, 'ºC'),
	(84970, 110, '2015-03-01 01:01:13.000000', 'temperatura', 288.0000, 'ºC'),
	(84971, 110, '2015-03-01 01:01:14.000000', 'temperatura', 827.0000, 'ºC'),
	(84972, 110, '2015-03-01 01:01:15.000000', 'temperatura', 870.0000, 'ºC'),
	(84973, 110, '2015-03-01 01:01:16.000000', 'temperatura', 671.0000, 'ºC'),
	(84974, 110, '2015-03-01 01:01:17.000000', 'temperatura', 745.0000, 'ºC'),
	(84975, 110, '2015-03-01 01:01:18.000000', 'temperatura', 513.0000, 'ºC'),
	(84976, 110, '2015-03-01 01:01:19.000000', 'temperatura', 331.0000, 'ºC'),
	(84977, 110, '2015-03-01 01:01:20.000000', 'temperatura', 117.0000, 'ºC'),
	(84978, 110, '2015-03-01 01:01:21.000000', 'temperatura', 792.0000, 'ºC'),
	(84979, 110, '2015-03-01 01:01:22.000000', 'temperatura', 11.0000, 'ºC'),
	(84980, 110, '2015-03-01 01:01:23.000000', 'temperatura', 80.0000, 'ºC'),
	(84981, 110, '2015-03-01 01:01:24.000000', 'temperatura', 364.0000, 'ºC'),
	(84982, 110, '2015-03-01 01:01:25.000000', 'temperatura', 384.0000, 'ºC'),
	(84983, 110, '2015-03-01 01:01:26.000000', 'temperatura', 827.0000, 'ºC'),
	(84984, 110, '2015-03-01 01:01:27.000000', 'temperatura', 586.0000, 'ºC'),
	(84985, 110, '2015-03-01 01:01:28.000000', 'temperatura', 446.0000, 'ºC'),
	(84986, 110, '2015-03-01 01:01:29.000000', 'temperatura', 475.0000, 'ºC'),
	(84987, 110, '2015-03-01 01:01:30.000000', 'temperatura', 1035.0000, 'ºC'),
	(84988, 110, '2015-03-01 01:01:31.000000', 'temperatura', 153.0000, 'ºC'),
	(84989, 110, '2015-03-01 01:01:32.000000', 'temperatura', 58.0000, 'ºC'),
	(84990, 110, '2015-03-01 01:01:33.000000', 'temperatura', 1031.0000, 'ºC'),
	(84991, 110, '2015-03-01 01:01:34.000000', 'temperatura', 183.0000, 'ºC'),
	(84992, 110, '2015-03-01 01:01:35.000000', 'temperatura', 223.0000, 'ºC'),
	(84993, 110, '2015-03-01 01:01:36.000000', 'temperatura', 565.0000, 'ºC'),
	(84994, 110, '2015-03-01 01:01:37.000000', 'temperatura', 958.0000, 'ºC'),
	(84995, 110, '2015-03-01 01:01:38.000000', 'temperatura', 697.0000, 'ºC'),
	(84996, 110, '2015-03-01 01:01:39.000000', 'temperatura', 609.0000, 'ºC'),
	(84997, 110, '2015-03-01 01:01:40.000000', 'temperatura', 956.0000, 'ºC'),
	(84998, 110, '2015-03-01 01:01:41.000000', 'temperatura', 554.0000, 'ºC'),
	(84999, 110, '2015-03-01 01:01:42.000000', 'temperatura', 1102.0000, 'ºC'),
	(85000, 110, '2015-03-01 01:01:43.000000', 'temperatura', 247.0000, 'ºC'),
	(85001, 110, '2015-03-01 01:01:44.000000', 'temperatura', 329.0000, 'ºC'),
	(85002, 110, '2015-03-01 01:01:45.000000', 'temperatura', 906.0000, 'ºC'),
	(85003, 110, '2015-03-01 01:01:46.000000', 'temperatura', 1142.0000, 'ºC'),
	(85004, 110, '2015-03-01 01:01:47.000000', 'temperatura', 595.0000, 'ºC'),
	(85005, 110, '2015-03-01 01:01:48.000000', 'temperatura', 747.0000, 'ºC'),
	(85006, 110, '2015-03-01 01:01:49.000000', 'temperatura', 751.0000, 'ºC'),
	(85007, 110, '2015-03-01 01:01:50.000000', 'temperatura', 314.0000, 'ºC'),
	(85008, 110, '2015-03-01 01:01:51.000000', 'temperatura', 519.0000, 'ºC'),
	(85009, 110, '2015-03-01 01:01:52.000000', 'temperatura', 451.0000, 'ºC'),
	(85010, 110, '2015-03-01 01:01:53.000000', 'temperatura', 701.0000, 'ºC'),
	(85011, 110, '2015-03-01 01:01:54.000000', 'temperatura', 952.0000, 'ºC'),
	(85012, 110, '2015-03-01 01:01:55.000000', 'temperatura', 256.0000, 'ºC'),
	(85013, 110, '2015-03-01 01:01:56.000000', 'temperatura', 825.0000, 'ºC'),
	(85014, 110, '2015-03-01 01:01:57.000000', 'temperatura', 956.0000, 'ºC'),
	(85015, 110, '2015-03-01 01:01:58.000000', 'temperatura', 1108.0000, 'ºC'),
	(85016, 110, '2015-03-01 01:01:59.000000', 'temperatura', 273.0000, 'ºC'),
	(85017, 110, '2015-03-01 01:02:00.000000', 'temperatura', 440.0000, 'ºC'),
	(85018, 110, '2015-03-01 01:02:01.000000', 'temperatura', 180.0000, 'ºC'),
	(85019, 110, '2015-03-01 01:02:02.000000', 'temperatura', 784.0000, 'ºC'),
	(85020, 110, '2015-03-01 01:02:03.000000', 'temperatura', 979.0000, 'ºC'),
	(85021, 110, '2015-03-01 01:02:04.000000', 'temperatura', 142.0000, 'ºC'),
	(85022, 110, '2015-03-01 01:02:05.000000', 'temperatura', 176.0000, 'ºC'),
	(85023, 110, '2015-03-01 01:02:06.000000', 'temperatura', 454.0000, 'ºC'),
	(85024, 110, '2015-03-01 01:02:07.000000', 'temperatura', 543.0000, 'ºC'),
	(85025, 110, '2015-03-01 01:02:08.000000', 'temperatura', 154.0000, 'ºC'),
	(85026, 110, '2015-03-01 01:02:09.000000', 'temperatura', 343.0000, 'ºC'),
	(85027, 110, '2015-03-01 01:02:10.000000', 'temperatura', 51.0000, 'ºC'),
	(85028, 110, '2015-03-01 01:02:11.000000', 'temperatura', 428.0000, 'ºC'),
	(85029, 110, '2015-03-01 01:02:12.000000', 'temperatura', 789.0000, 'ºC'),
	(85030, 110, '2015-03-01 01:02:13.000000', 'temperatura', 259.0000, 'ºC'),
	(85031, 110, '2015-03-01 01:02:14.000000', 'temperatura', 128.0000, 'ºC'),
	(85032, 110, '2015-03-01 01:02:15.000000', 'temperatura', 1064.0000, 'ºC'),
	(85033, 110, '2015-03-01 01:02:16.000000', 'temperatura', 135.0000, 'ºC'),
	(85034, 110, '2015-03-01 01:02:17.000000', 'temperatura', 1083.0000, 'ºC'),
	(85035, 110, '2015-03-01 01:02:18.000000', 'temperatura', 212.0000, 'ºC'),
	(85036, 110, '2015-03-01 01:02:19.000000', 'temperatura', 213.0000, 'ºC'),
	(85037, 110, '2015-03-01 01:02:20.000000', 'temperatura', 428.0000, 'ºC'),
	(85038, 110, '2015-03-01 01:02:21.000000', 'temperatura', 302.0000, 'ºC'),
	(85039, 110, '2015-03-01 01:02:22.000000', 'temperatura', 228.0000, 'ºC'),
	(85040, 110, '2015-03-01 01:02:23.000000', 'temperatura', 232.0000, 'ºC'),
	(85041, 110, '2015-03-01 01:02:24.000000', 'temperatura', 478.0000, 'ºC'),
	(85042, 110, '2015-03-01 01:02:25.000000', 'temperatura', 496.0000, 'ºC'),
	(85043, 110, '2015-03-01 01:02:26.000000', 'temperatura', 1045.0000, 'ºC'),
	(85044, 110, '2015-03-01 01:02:27.000000', 'temperatura', 137.0000, 'ºC'),
	(85045, 110, '2015-03-01 01:02:28.000000', 'temperatura', 1149.0000, 'ºC'),
	(85046, 110, '2015-03-01 01:02:29.000000', 'temperatura', 537.0000, 'ºC'),
	(85047, 110, '2015-03-01 01:02:30.000000', 'temperatura', 437.0000, 'ºC'),
	(85048, 110, '2015-03-01 01:02:31.000000', 'temperatura', 574.0000, 'ºC'),
	(85049, 110, '2015-03-01 01:02:32.000000', 'temperatura', 360.0000, 'ºC'),
	(85050, 110, '2015-03-01 01:02:33.000000', 'temperatura', 79.0000, 'ºC'),
	(85051, 110, '2015-03-01 01:02:34.000000', 'temperatura', 514.0000, 'ºC'),
	(85052, 110, '2015-03-01 01:02:35.000000', 'temperatura', 1134.0000, 'ºC'),
	(85053, 110, '2015-03-01 01:02:36.000000', 'temperatura', 530.0000, 'ºC'),
	(85054, 110, '2015-03-01 01:02:37.000000', 'temperatura', 447.0000, 'ºC'),
	(85055, 110, '2015-03-01 01:02:38.000000', 'temperatura', 647.0000, 'ºC'),
	(85056, 110, '2015-03-01 01:02:39.000000', 'temperatura', 693.0000, 'ºC'),
	(85057, 110, '2015-03-01 01:02:40.000000', 'temperatura', 324.0000, 'ºC'),
	(85058, 110, '2015-03-01 01:02:41.000000', 'temperatura', 743.0000, 'ºC'),
	(85059, 110, '2015-03-01 01:02:42.000000', 'temperatura', 342.0000, 'ºC'),
	(85060, 110, '2015-03-01 01:02:43.000000', 'temperatura', 682.0000, 'ºC'),
	(85061, 110, '2015-03-01 01:02:44.000000', 'temperatura', 1186.0000, 'ºC'),
	(85062, 110, '2015-03-01 01:02:45.000000', 'temperatura', 283.0000, 'ºC'),
	(85063, 110, '2015-03-01 01:02:46.000000', 'temperatura', 260.0000, 'ºC'),
	(85064, 110, '2015-03-01 01:02:47.000000', 'temperatura', 449.0000, 'ºC'),
	(85065, 110, '2015-03-01 01:02:48.000000', 'temperatura', 267.0000, 'ºC'),
	(85066, 110, '2015-03-01 01:02:49.000000', 'temperatura', 1189.0000, 'ºC'),
	(85067, 110, '2015-03-01 01:02:50.000000', 'temperatura', 345.0000, 'ºC'),
	(85068, 110, '2015-03-01 01:02:51.000000', 'temperatura', 556.0000, 'ºC'),
	(85069, 110, '2015-03-01 01:02:52.000000', 'temperatura', 548.0000, 'ºC'),
	(85070, 110, '2015-03-01 01:02:53.000000', 'temperatura', 1073.0000, 'ºC'),
	(85071, 110, '2015-03-01 01:02:54.000000', 'temperatura', 119.0000, 'ºC'),
	(85072, 110, '2015-03-01 01:02:55.000000', 'temperatura', 979.0000, 'ºC'),
	(85073, 110, '2015-03-01 01:02:56.000000', 'temperatura', 936.0000, 'ºC'),
	(85074, 110, '2015-03-01 01:02:57.000000', 'temperatura', 543.0000, 'ºC'),
	(85075, 110, '2015-03-01 01:02:58.000000', 'temperatura', 1109.0000, 'ºC'),
	(85076, 110, '2015-03-01 01:02:59.000000', 'temperatura', 315.0000, 'ºC'),
	(85077, 110, '2015-03-01 01:03:00.000000', 'temperatura', 650.0000, 'ºC'),
	(85078, 110, '2015-03-01 01:03:01.000000', 'temperatura', 1106.0000, 'ºC'),
	(85079, 110, '2015-03-01 01:03:02.000000', 'temperatura', 1179.0000, 'ºC'),
	(85080, 110, '2015-03-01 01:03:03.000000', 'temperatura', 177.0000, 'ºC'),
	(85081, 110, '2015-03-01 01:03:04.000000', 'temperatura', 951.0000, 'ºC'),
	(85082, 110, '2015-03-01 01:03:05.000000', 'temperatura', 621.0000, 'ºC'),
	(85083, 110, '2015-03-01 01:03:06.000000', 'temperatura', 255.0000, 'ºC'),
	(85084, 110, '2015-03-01 01:03:07.000000', 'temperatura', 612.0000, 'ºC'),
	(85085, 110, '2015-03-01 01:03:08.000000', 'temperatura', 1094.0000, 'ºC'),
	(85086, 110, '2015-03-01 01:03:09.000000', 'temperatura', 36.0000, 'ºC'),
	(85087, 110, '2015-03-01 01:03:10.000000', 'temperatura', 497.0000, 'ºC'),
	(85088, 110, '2015-03-01 01:03:11.000000', 'temperatura', 1179.0000, 'ºC'),
	(85089, 110, '2015-03-01 01:03:12.000000', 'temperatura', 805.0000, 'ºC'),
	(85090, 110, '2015-03-01 01:03:13.000000', 'temperatura', 489.0000, 'ºC'),
	(85091, 110, '2015-03-01 01:03:14.000000', 'temperatura', 31.0000, 'ºC'),
	(85092, 110, '2015-03-01 01:03:15.000000', 'temperatura', 1088.0000, 'ºC'),
	(85093, 110, '2015-03-01 01:03:16.000000', 'temperatura', 548.0000, 'ºC'),
	(85094, 110, '2015-03-01 01:03:17.000000', 'temperatura', 678.0000, 'ºC'),
	(85095, 110, '2015-03-01 01:03:18.000000', 'temperatura', 545.0000, 'ºC'),
	(85096, 110, '2015-03-01 01:03:19.000000', 'temperatura', 693.0000, 'ºC'),
	(85097, 110, '2015-03-01 01:03:20.000000', 'temperatura', 631.0000, 'ºC'),
	(85098, 110, '2015-03-01 01:03:21.000000', 'temperatura', 1075.0000, 'ºC'),
	(85099, 110, '2015-03-01 01:03:22.000000', 'temperatura', 1083.0000, 'ºC'),
	(85100, 110, '2015-03-01 01:03:23.000000', 'temperatura', 990.0000, 'ºC'),
	(85101, 110, '2015-03-01 01:03:24.000000', 'temperatura', 504.0000, 'ºC'),
	(85102, 110, '2015-03-01 01:03:25.000000', 'temperatura', 748.0000, 'ºC'),
	(85103, 110, '2015-03-01 01:03:26.000000', 'temperatura', 1027.0000, 'ºC'),
	(85104, 110, '2015-03-01 01:03:27.000000', 'temperatura', 493.0000, 'ºC'),
	(85105, 110, '2015-03-01 01:03:28.000000', 'temperatura', 586.0000, 'ºC'),
	(85106, 110, '2015-03-01 01:03:29.000000', 'temperatura', 252.0000, 'ºC'),
	(85107, 110, '2015-03-01 01:03:30.000000', 'temperatura', 704.0000, 'ºC'),
	(85108, 110, '2015-03-01 01:03:31.000000', 'temperatura', 361.0000, 'ºC'),
	(85109, 110, '2015-03-01 01:03:32.000000', 'temperatura', 894.0000, 'ºC'),
	(85110, 110, '2015-03-01 01:03:33.000000', 'temperatura', 986.0000, 'ºC'),
	(85111, 110, '2015-03-01 01:03:34.000000', 'temperatura', 1051.0000, 'ºC'),
	(85112, 110, '2015-03-01 01:03:35.000000', 'temperatura', 1098.0000, 'ºC'),
	(85113, 110, '2015-03-01 01:03:36.000000', 'temperatura', 1137.0000, 'ºC'),
	(85114, 110, '2015-03-01 01:03:37.000000', 'temperatura', 1192.0000, 'ºC'),
	(85115, 110, '2015-03-01 01:03:38.000000', 'temperatura', 149.0000, 'ºC'),
	(85116, 110, '2015-03-01 01:03:39.000000', 'temperatura', 768.0000, 'ºC'),
	(85117, 110, '2015-03-01 01:03:40.000000', 'temperatura', 994.0000, 'ºC'),
	(85118, 110, '2015-03-01 01:03:41.000000', 'temperatura', 267.0000, 'ºC'),
	(85119, 110, '2015-03-01 01:03:42.000000', 'temperatura', 755.0000, 'ºC'),
	(85120, 110, '2015-03-01 01:03:43.000000', 'temperatura', 575.0000, 'ºC'),
	(85121, 110, '2015-03-01 01:03:44.000000', 'temperatura', 609.0000, 'ºC'),
	(85122, 110, '2015-03-01 01:03:45.000000', 'temperatura', 120.0000, 'ºC'),
	(85123, 110, '2015-03-01 01:03:46.000000', 'temperatura', 1176.0000, 'ºC'),
	(85124, 110, '2015-03-01 01:03:47.000000', 'temperatura', 718.0000, 'ºC'),
	(85125, 110, '2015-03-01 01:03:48.000000', 'temperatura', 63.0000, 'ºC'),
	(85126, 110, '2015-03-01 01:03:49.000000', 'temperatura', 561.0000, 'ºC'),
	(85127, 110, '2015-03-01 01:03:50.000000', 'temperatura', 215.0000, 'ºC'),
	(85128, 110, '2015-03-01 01:03:51.000000', 'temperatura', 593.0000, 'ºC'),
	(85129, 110, '2015-03-01 01:03:52.000000', 'temperatura', 1122.0000, 'ºC'),
	(85130, 110, '2015-03-01 01:03:53.000000', 'temperatura', 232.0000, 'ºC'),
	(85131, 110, '2015-03-01 01:03:54.000000', 'temperatura', 194.0000, 'ºC'),
	(85132, 110, '2015-03-01 01:03:55.000000', 'temperatura', 276.0000, 'ºC'),
	(85133, 110, '2015-03-01 01:03:56.000000', 'temperatura', 798.0000, 'ºC'),
	(85134, 110, '2015-03-01 01:03:57.000000', 'temperatura', 762.0000, 'ºC'),
	(85135, 110, '2015-03-01 01:03:58.000000', 'temperatura', 215.0000, 'ºC'),
	(85136, 110, '2015-03-01 01:03:59.000000', 'temperatura', 1189.0000, 'ºC'),
	(85137, 110, '2015-03-01 01:04:00.000000', 'temperatura', 503.0000, 'ºC'),
	(85138, 110, '2015-03-01 01:04:01.000000', 'temperatura', 149.0000, 'ºC'),
	(85139, 110, '2015-03-01 01:04:02.000000', 'temperatura', 434.0000, 'ºC'),
	(85140, 110, '2015-03-01 01:04:03.000000', 'temperatura', 523.0000, 'ºC'),
	(85141, 110, '2015-03-01 01:04:04.000000', 'temperatura', 116.0000, 'ºC'),
	(85142, 110, '2015-03-01 01:04:05.000000', 'temperatura', 211.0000, 'ºC'),
	(85143, 110, '2015-03-01 01:04:06.000000', 'temperatura', 709.0000, 'ºC'),
	(85144, 110, '2015-03-01 01:04:07.000000', 'temperatura', 510.0000, 'ºC'),
	(85145, 110, '2015-03-01 01:04:08.000000', 'temperatura', 425.0000, 'ºC'),
	(85146, 110, '2015-03-01 01:04:09.000000', 'temperatura', 595.0000, 'ºC'),
	(85147, 110, '2015-03-01 01:04:10.000000', 'temperatura', 501.0000, 'ºC'),
	(85148, 110, '2015-03-01 01:04:11.000000', 'temperatura', 718.0000, 'ºC'),
	(85149, 110, '2015-03-01 01:04:12.000000', 'temperatura', 890.0000, 'ºC'),
	(85150, 110, '2015-03-01 01:04:13.000000', 'temperatura', 1095.0000, 'ºC'),
	(85151, 110, '2015-03-01 01:04:14.000000', 'temperatura', 404.0000, 'ºC'),
	(85152, 110, '2015-03-01 01:04:15.000000', 'temperatura', 1139.0000, 'ºC'),
	(85153, 110, '2015-03-01 01:04:16.000000', 'temperatura', 882.0000, 'ºC'),
	(85154, 110, '2015-03-01 01:04:17.000000', 'temperatura', 993.0000, 'ºC'),
	(85155, 110, '2015-03-01 01:04:18.000000', 'temperatura', 1121.0000, 'ºC'),
	(85156, 110, '2015-03-01 01:04:19.000000', 'temperatura', 226.0000, 'ºC'),
	(85157, 110, '2015-03-01 01:04:20.000000', 'temperatura', 166.0000, 'ºC'),
	(85158, 110, '2015-03-01 01:04:21.000000', 'temperatura', 154.0000, 'ºC'),
	(85159, 110, '2015-03-01 01:04:22.000000', 'temperatura', 272.0000, 'ºC'),
	(85160, 110, '2015-03-01 01:04:23.000000', 'temperatura', 899.0000, 'ºC'),
	(85161, 110, '2015-03-01 01:04:24.000000', 'temperatura', 79.0000, 'ºC'),
	(85162, 110, '2015-03-01 01:04:25.000000', 'temperatura', 101.0000, 'ºC'),
	(85163, 110, '2015-03-01 01:04:26.000000', 'temperatura', 265.0000, 'ºC'),
	(85164, 110, '2015-03-01 01:04:27.000000', 'temperatura', 1023.0000, 'ºC'),
	(85165, 110, '2015-03-01 01:04:28.000000', 'temperatura', 721.0000, 'ºC'),
	(85166, 110, '2015-03-01 01:04:29.000000', 'temperatura', 535.0000, 'ºC'),
	(85167, 110, '2015-03-01 01:04:30.000000', 'temperatura', 515.0000, 'ºC'),
	(85168, 110, '2015-03-01 01:04:31.000000', 'temperatura', 968.0000, 'ºC'),
	(85169, 110, '2015-03-01 01:04:32.000000', 'temperatura', 895.0000, 'ºC'),
	(85170, 110, '2015-03-01 01:04:33.000000', 'temperatura', 373.0000, 'ºC'),
	(85171, 110, '2015-03-01 01:04:34.000000', 'temperatura', 381.0000, 'ºC'),
	(85172, 110, '2015-03-01 01:04:35.000000', 'temperatura', 784.0000, 'ºC'),
	(85173, 110, '2015-03-01 01:04:36.000000', 'temperatura', 378.0000, 'ºC'),
	(85174, 110, '2015-03-01 01:04:37.000000', 'temperatura', 740.0000, 'ºC'),
	(85175, 110, '2015-03-01 01:04:38.000000', 'temperatura', 168.0000, 'ºC'),
	(85176, 110, '2015-03-01 01:04:39.000000', 'temperatura', 1018.0000, 'ºC'),
	(85177, 110, '2015-03-01 01:04:40.000000', 'temperatura', 987.0000, 'ºC'),
	(85178, 110, '2015-03-01 01:04:41.000000', 'temperatura', 681.0000, 'ºC'),
	(85179, 110, '2015-03-01 01:04:42.000000', 'temperatura', 447.0000, 'ºC'),
	(85180, 110, '2015-03-01 01:04:43.000000', 'temperatura', 190.0000, 'ºC'),
	(85181, 110, '2015-03-01 01:04:44.000000', 'temperatura', 810.0000, 'ºC'),
	(85182, 110, '2015-03-01 01:04:45.000000', 'temperatura', 1081.0000, 'ºC'),
	(85183, 110, '2015-03-01 01:04:46.000000', 'temperatura', 576.0000, 'ºC'),
	(85184, 110, '2015-03-01 01:04:47.000000', 'temperatura', 836.0000, 'ºC'),
	(85185, 110, '2015-03-01 01:04:48.000000', 'temperatura', 55.0000, 'ºC'),
	(85186, 110, '2015-03-01 01:04:49.000000', 'temperatura', 168.0000, 'ºC'),
	(85187, 110, '2015-03-01 01:04:50.000000', 'temperatura', 673.0000, 'ºC'),
	(85188, 110, '2015-03-01 01:04:51.000000', 'temperatura', 461.0000, 'ºC'),
	(85189, 110, '2015-03-01 01:04:52.000000', 'temperatura', 287.0000, 'ºC'),
	(85190, 110, '2015-03-01 01:04:53.000000', 'temperatura', 54.0000, 'ºC'),
	(85191, 110, '2015-03-01 01:04:54.000000', 'temperatura', 611.0000, 'ºC'),
	(85192, 110, '2015-03-01 01:04:55.000000', 'temperatura', 491.0000, 'ºC'),
	(85193, 110, '2015-03-01 01:04:56.000000', 'temperatura', 624.0000, 'ºC'),
	(85194, 110, '2015-03-01 01:04:57.000000', 'temperatura', 445.0000, 'ºC'),
	(85195, 110, '2015-03-01 01:04:58.000000', 'temperatura', 355.0000, 'ºC'),
	(85196, 110, '2015-03-01 01:04:59.000000', 'temperatura', 442.0000, 'ºC'),
	(85197, 110, '2015-03-01 01:05:00.000000', 'temperatura', 1144.0000, 'ºC'),
	(85198, 110, '2015-03-01 01:05:01.000000', 'temperatura', 793.0000, 'ºC'),
	(85199, 110, '2015-03-01 01:05:02.000000', 'temperatura', 534.0000, 'ºC'),
	(85200, 110, '2015-03-01 01:05:03.000000', 'temperatura', 291.0000, 'ºC'),
	(85201, 110, '2015-03-01 01:05:04.000000', 'temperatura', 1056.0000, 'ºC'),
	(85202, 110, '2015-03-01 01:05:05.000000', 'temperatura', 807.0000, 'ºC'),
	(85203, 110, '2015-03-01 01:05:06.000000', 'temperatura', 868.0000, 'ºC'),
	(85204, 110, '2015-03-01 01:05:07.000000', 'temperatura', 721.0000, 'ºC'),
	(85205, 110, '2015-03-01 01:05:08.000000', 'temperatura', 999.0000, 'ºC'),
	(85206, 110, '2015-03-01 01:05:09.000000', 'temperatura', 434.0000, 'ºC'),
	(85207, 110, '2015-03-01 01:05:10.000000', 'temperatura', 371.0000, 'ºC'),
	(85208, 110, '2015-03-01 01:05:11.000000', 'temperatura', 554.0000, 'ºC'),
	(85209, 110, '2015-03-01 01:05:12.000000', 'temperatura', 460.0000, 'ºC'),
	(85210, 110, '2015-03-01 01:05:13.000000', 'temperatura', 636.0000, 'ºC'),
	(85211, 110, '2015-03-01 01:05:14.000000', 'temperatura', 601.0000, 'ºC'),
	(85212, 110, '2015-03-01 01:05:15.000000', 'temperatura', 1098.0000, 'ºC'),
	(85213, 110, '2015-03-01 01:05:16.000000', 'temperatura', 87.0000, 'ºC'),
	(85214, 110, '2015-03-01 01:05:17.000000', 'temperatura', 742.0000, 'ºC'),
	(85215, 110, '2015-03-01 01:05:18.000000', 'temperatura', 1049.0000, 'ºC'),
	(85216, 110, '2015-03-01 01:05:19.000000', 'temperatura', 618.0000, 'ºC'),
	(85217, 110, '2015-03-01 01:05:20.000000', 'temperatura', 1144.0000, 'ºC'),
	(85218, 110, '2015-03-01 01:05:21.000000', 'temperatura', 269.0000, 'ºC'),
	(85219, 110, '2015-03-01 01:05:22.000000', 'temperatura', 313.0000, 'ºC'),
	(85220, 110, '2015-03-01 01:05:23.000000', 'temperatura', 756.0000, 'ºC'),
	(85221, 110, '2015-03-01 01:05:24.000000', 'temperatura', 443.0000, 'ºC'),
	(85222, 110, '2015-03-01 01:05:25.000000', 'temperatura', 1149.0000, 'ºC'),
	(85223, 110, '2015-03-01 01:05:26.000000', 'temperatura', 817.0000, 'ºC'),
	(85224, 110, '2015-03-01 01:05:27.000000', 'temperatura', 639.0000, 'ºC'),
	(85225, 110, '2015-03-01 01:05:28.000000', 'temperatura', 741.0000, 'ºC'),
	(85226, 110, '2015-03-01 01:05:29.000000', 'temperatura', 591.0000, 'ºC'),
	(85227, 110, '2015-03-01 01:05:30.000000', 'temperatura', 733.0000, 'ºC'),
	(85228, 110, '2015-03-01 01:05:31.000000', 'temperatura', 693.0000, 'ºC'),
	(85229, 110, '2015-03-01 01:05:32.000000', 'temperatura', 64.0000, 'ºC'),
	(85230, 110, '2015-03-01 01:05:33.000000', 'temperatura', 643.0000, 'ºC'),
	(85231, 110, '2015-03-01 01:05:34.000000', 'temperatura', 624.0000, 'ºC'),
	(85232, 110, '2015-03-01 01:05:35.000000', 'temperatura', 1193.0000, 'ºC'),
	(85233, 110, '2015-03-01 01:05:36.000000', 'temperatura', 491.0000, 'ºC'),
	(85234, 110, '2015-03-01 01:05:37.000000', 'temperatura', 76.0000, 'ºC'),
	(85235, 110, '2015-03-01 01:05:38.000000', 'temperatura', 109.0000, 'ºC'),
	(85236, 110, '2015-03-01 01:05:39.000000', 'temperatura', 319.0000, 'ºC'),
	(85237, 110, '2015-03-01 01:05:40.000000', 'temperatura', 68.0000, 'ºC'),
	(85238, 110, '2015-03-01 01:05:41.000000', 'temperatura', 582.0000, 'ºC'),
	(85239, 110, '2015-03-01 01:05:42.000000', 'temperatura', 305.0000, 'ºC'),
	(85240, 110, '2015-03-01 01:05:43.000000', 'temperatura', 982.0000, 'ºC'),
	(85241, 110, '2015-03-01 01:05:44.000000', 'temperatura', 394.0000, 'ºC'),
	(85242, 110, '2015-03-01 01:05:45.000000', 'temperatura', 224.0000, 'ºC'),
	(85243, 110, '2015-03-01 01:05:46.000000', 'temperatura', 1139.0000, 'ºC'),
	(85244, 110, '2015-03-01 01:05:47.000000', 'temperatura', 224.0000, 'ºC'),
	(85245, 110, '2015-03-01 01:05:48.000000', 'temperatura', 104.0000, 'ºC'),
	(85246, 110, '2015-03-01 01:05:49.000000', 'temperatura', 1048.0000, 'ºC'),
	(85247, 110, '2015-03-01 01:05:50.000000', 'temperatura', 127.0000, 'ºC'),
	(85248, 110, '2015-03-01 01:05:51.000000', 'temperatura', 1092.0000, 'ºC'),
	(85249, 110, '2015-03-01 01:05:52.000000', 'temperatura', 280.0000, 'ºC'),
	(85250, 110, '2015-03-01 01:05:53.000000', 'temperatura', 524.0000, 'ºC'),
	(85251, 110, '2015-03-01 01:05:54.000000', 'temperatura', 579.0000, 'ºC'),
	(85252, 110, '2015-03-01 01:05:55.000000', 'temperatura', 127.0000, 'ºC'),
	(85253, 110, '2015-03-01 01:05:56.000000', 'temperatura', 96.0000, 'ºC'),
	(85254, 110, '2015-03-01 01:05:57.000000', 'temperatura', 99.0000, 'ºC'),
	(85255, 110, '2015-03-01 01:05:58.000000', 'temperatura', 207.0000, 'ºC'),
	(85256, 110, '2015-03-01 01:05:59.000000', 'temperatura', 739.0000, 'ºC'),
	(85257, 110, '2015-03-01 01:06:00.000000', 'temperatura', 675.0000, 'ºC'),
	(85258, 110, '2015-03-01 01:06:01.000000', 'temperatura', 1160.0000, 'ºC'),
	(85259, 110, '2015-03-01 01:06:02.000000', 'temperatura', 173.0000, 'ºC'),
	(85260, 110, '2015-03-01 01:06:03.000000', 'temperatura', 987.0000, 'ºC'),
	(85261, 110, '2015-03-01 01:06:04.000000', 'temperatura', 815.0000, 'ºC'),
	(85262, 110, '2015-03-01 01:06:05.000000', 'temperatura', 1114.0000, 'ºC'),
	(85263, 110, '2015-03-01 01:06:06.000000', 'temperatura', 728.0000, 'ºC'),
	(85264, 110, '2015-03-01 01:06:07.000000', 'temperatura', 297.0000, 'ºC'),
	(85265, 110, '2015-03-01 01:06:08.000000', 'temperatura', 500.0000, 'ºC'),
	(85266, 110, '2015-03-01 01:06:09.000000', 'temperatura', 411.0000, 'ºC'),
	(85267, 110, '2015-03-01 01:06:10.000000', 'temperatura', 557.0000, 'ºC'),
	(85268, 110, '2015-03-01 01:06:11.000000', 'temperatura', 352.0000, 'ºC'),
	(85269, 110, '2015-03-01 01:06:12.000000', 'temperatura', 91.0000, 'ºC'),
	(85270, 110, '2015-03-01 01:06:13.000000', 'temperatura', 597.0000, 'ºC'),
	(85271, 110, '2015-03-01 01:06:14.000000', 'temperatura', 314.0000, 'ºC'),
	(85272, 110, '2015-03-01 01:06:15.000000', 'temperatura', 979.0000, 'ºC'),
	(85273, 110, '2015-03-01 01:06:16.000000', 'temperatura', 354.0000, 'ºC'),
	(85274, 110, '2015-03-01 01:06:17.000000', 'temperatura', 32.0000, 'ºC'),
	(85275, 110, '2015-03-01 01:06:18.000000', 'temperatura', 298.0000, 'ºC'),
	(85276, 110, '2015-03-01 01:06:19.000000', 'temperatura', 194.0000, 'ºC'),
	(85277, 110, '2015-03-01 01:06:20.000000', 'temperatura', 77.0000, 'ºC'),
	(85278, 110, '2015-03-01 01:06:21.000000', 'temperatura', 1003.0000, 'ºC'),
	(85279, 110, '2015-03-01 01:06:22.000000', 'temperatura', 1187.0000, 'ºC'),
	(85280, 110, '2015-03-01 01:06:23.000000', 'temperatura', 525.0000, 'ºC'),
	(85281, 110, '2015-03-01 01:06:24.000000', 'temperatura', 264.0000, 'ºC'),
	(85282, 110, '2015-03-01 01:06:25.000000', 'temperatura', 944.0000, 'ºC'),
	(85283, 110, '2015-03-01 01:06:26.000000', 'temperatura', 332.0000, 'ºC'),
	(85284, 110, '2015-03-01 01:06:27.000000', 'temperatura', 26.0000, 'ºC'),
	(85285, 110, '2015-03-01 01:06:28.000000', 'temperatura', 333.0000, 'ºC'),
	(85286, 110, '2015-03-01 01:06:29.000000', 'temperatura', 390.0000, 'ºC'),
	(85287, 110, '2015-03-01 01:06:30.000000', 'temperatura', 952.0000, 'ºC'),
	(85288, 110, '2015-03-01 01:06:31.000000', 'temperatura', 1188.0000, 'ºC'),
	(85289, 110, '2015-03-01 01:06:32.000000', 'temperatura', 684.0000, 'ºC'),
	(85290, 110, '2015-03-01 01:06:33.000000', 'temperatura', 1058.0000, 'ºC'),
	(85291, 110, '2015-03-01 01:06:34.000000', 'temperatura', 837.0000, 'ºC'),
	(85292, 110, '2015-03-01 01:06:35.000000', 'temperatura', 1011.0000, 'ºC'),
	(85293, 110, '2015-03-01 01:06:36.000000', 'temperatura', 147.0000, 'ºC'),
	(85294, 110, '2015-03-01 01:06:37.000000', 'temperatura', 101.0000, 'ºC'),
	(85295, 110, '2015-03-01 01:06:38.000000', 'temperatura', 63.0000, 'ºC'),
	(85296, 110, '2015-03-01 01:06:39.000000', 'temperatura', 13.0000, 'ºC'),
	(85297, 110, '2015-03-01 01:06:40.000000', 'temperatura', 1079.0000, 'ºC'),
	(85298, 110, '2015-03-01 01:06:41.000000', 'temperatura', 555.0000, 'ºC'),
	(85299, 110, '2015-03-01 01:06:42.000000', 'temperatura', 739.0000, 'ºC'),
	(85300, 110, '2015-03-01 01:06:43.000000', 'temperatura', 829.0000, 'ºC'),
	(85301, 110, '2015-03-01 01:06:44.000000', 'temperatura', 728.0000, 'ºC'),
	(85302, 110, '2015-03-01 01:06:45.000000', 'temperatura', 1155.0000, 'ºC'),
	(85303, 110, '2015-03-01 01:06:46.000000', 'temperatura', 1191.0000, 'ºC'),
	(85304, 110, '2015-03-01 01:06:47.000000', 'temperatura', 91.0000, 'ºC'),
	(85305, 110, '2015-03-01 01:06:48.000000', 'temperatura', 481.0000, 'ºC'),
	(85306, 110, '2015-03-01 01:06:49.000000', 'temperatura', 935.0000, 'ºC'),
	(85307, 110, '2015-03-01 01:06:50.000000', 'temperatura', 831.0000, 'ºC'),
	(85308, 110, '2015-03-01 01:06:51.000000', 'temperatura', 150.0000, 'ºC'),
	(85309, 110, '2015-03-01 01:06:52.000000', 'temperatura', 660.0000, 'ºC'),
	(85310, 110, '2015-03-01 01:06:53.000000', 'temperatura', 448.0000, 'ºC'),
	(85311, 110, '2015-03-01 01:06:54.000000', 'temperatura', 263.0000, 'ºC'),
	(85312, 110, '2015-03-01 01:06:55.000000', 'temperatura', 1172.0000, 'ºC'),
	(85313, 110, '2015-03-01 01:06:56.000000', 'temperatura', 270.0000, 'ºC'),
	(85314, 110, '2015-03-01 01:06:57.000000', 'temperatura', 235.0000, 'ºC'),
	(85315, 110, '2015-03-01 01:06:58.000000', 'temperatura', 365.0000, 'ºC'),
	(85316, 110, '2015-03-01 01:06:59.000000', 'temperatura', 1122.0000, 'ºC'),
	(85317, 110, '2015-03-01 01:07:00.000000', 'temperatura', 916.0000, 'ºC'),
	(85318, 110, '2015-03-01 01:07:01.000000', 'temperatura', 14.0000, 'ºC'),
	(85319, 110, '2015-03-01 01:07:02.000000', 'temperatura', 923.0000, 'ºC'),
	(85320, 110, '2015-03-01 01:07:03.000000', 'temperatura', 971.0000, 'ºC'),
	(85321, 110, '2015-03-01 01:07:04.000000', 'temperatura', 887.0000, 'ºC'),
	(85322, 110, '2015-03-01 01:07:05.000000', 'temperatura', 323.0000, 'ºC'),
	(85323, 110, '2015-03-01 01:07:06.000000', 'temperatura', 152.0000, 'ºC'),
	(85324, 110, '2015-03-01 01:07:07.000000', 'temperatura', 995.0000, 'ºC'),
	(85325, 110, '2015-03-01 01:07:08.000000', 'temperatura', 919.0000, 'ºC'),
	(85326, 110, '2015-03-01 01:07:09.000000', 'temperatura', 411.0000, 'ºC'),
	(85327, 110, '2015-03-01 01:07:10.000000', 'temperatura', 498.0000, 'ºC'),
	(85328, 110, '2015-03-01 01:07:11.000000', 'temperatura', 59.0000, 'ºC'),
	(85329, 110, '2015-03-01 01:07:12.000000', 'temperatura', 0.0000, 'ºC'),
	(85330, 110, '2015-03-01 01:07:13.000000', 'temperatura', 1023.0000, 'ºC'),
	(85331, 110, '2015-03-01 01:07:14.000000', 'temperatura', 315.0000, 'ºC'),
	(85332, 110, '2015-03-01 01:07:15.000000', 'temperatura', 905.0000, 'ºC'),
	(85333, 110, '2015-03-01 01:07:16.000000', 'temperatura', 1183.0000, 'ºC'),
	(85334, 110, '2015-03-01 01:07:17.000000', 'temperatura', 800.0000, 'ºC'),
	(85335, 110, '2015-03-01 01:07:18.000000', 'temperatura', 450.0000, 'ºC'),
	(85336, 110, '2015-03-01 01:07:19.000000', 'temperatura', 1050.0000, 'ºC'),
	(85337, 110, '2015-03-01 01:07:20.000000', 'temperatura', 300.0000, 'ºC'),
	(85338, 110, '2015-03-01 01:07:21.000000', 'temperatura', 750.0000, 'ºC'),
	(85339, 110, '2015-03-01 01:07:22.000000', 'temperatura', 453.0000, 'ºC'),
	(85340, 110, '2015-03-01 01:07:23.000000', 'temperatura', 14.0000, 'ºC'),
	(85341, 110, '2015-03-01 01:07:24.000000', 'temperatura', 1113.0000, 'ºC'),
	(85342, 110, '2015-03-01 01:07:25.000000', 'temperatura', 724.0000, 'ºC'),
	(85343, 110, '2015-03-01 01:07:26.000000', 'temperatura', 281.0000, 'ºC'),
	(85344, 110, '2015-03-01 01:07:27.000000', 'temperatura', 434.0000, 'ºC'),
	(85345, 110, '2015-03-01 01:07:28.000000', 'temperatura', 128.0000, 'ºC'),
	(85346, 110, '2015-03-01 01:07:29.000000', 'temperatura', 536.0000, 'ºC'),
	(85347, 110, '2015-03-01 01:07:30.000000', 'temperatura', 1096.0000, 'ºC'),
	(85348, 110, '2015-03-01 01:07:31.000000', 'temperatura', 274.0000, 'ºC'),
	(85349, 110, '2015-03-01 01:07:32.000000', 'temperatura', 484.0000, 'ºC'),
	(85350, 110, '2015-03-01 01:07:33.000000', 'temperatura', 398.0000, 'ºC'),
	(85351, 110, '2015-03-01 01:07:34.000000', 'temperatura', 540.0000, 'ºC'),
	(85352, 110, '2015-03-01 01:07:35.000000', 'temperatura', 305.0000, 'ºC'),
	(85353, 110, '2015-03-01 01:07:36.000000', 'temperatura', 1107.0000, 'ºC'),
	(85354, 110, '2015-03-01 01:07:37.000000', 'temperatura', 1019.0000, 'ºC'),
	(85355, 110, '2015-03-01 01:07:38.000000', 'temperatura', 575.0000, 'ºC'),
	(85356, 110, '2015-03-01 01:07:39.000000', 'temperatura', 1020.0000, 'ºC'),
	(85357, 110, '2015-03-01 01:07:40.000000', 'temperatura', 973.0000, 'ºC'),
	(85358, 110, '2015-03-01 01:07:41.000000', 'temperatura', 606.0000, 'ºC'),
	(85359, 110, '2015-03-01 01:07:42.000000', 'temperatura', 110.0000, 'ºC'),
	(85360, 110, '2015-03-01 01:07:43.000000', 'temperatura', 1133.0000, 'ºC'),
	(85361, 110, '2015-03-01 01:07:44.000000', 'temperatura', 535.0000, 'ºC'),
	(85362, 110, '2015-03-01 01:07:45.000000', 'temperatura', 477.0000, 'ºC'),
	(85363, 110, '2015-03-01 01:07:46.000000', 'temperatura', 779.0000, 'ºC'),
	(85364, 110, '2015-03-01 01:07:47.000000', 'temperatura', 64.0000, 'ºC'),
	(85365, 110, '2015-03-01 01:07:48.000000', 'temperatura', 383.0000, 'ºC'),
	(85366, 110, '2015-03-01 01:07:49.000000', 'temperatura', 527.0000, 'ºC'),
	(85367, 110, '2015-03-01 01:07:50.000000', 'temperatura', 283.0000, 'ºC'),
	(85368, 110, '2015-03-01 01:07:51.000000', 'temperatura', 1036.0000, 'ºC'),
	(85369, 110, '2015-03-01 01:07:52.000000', 'temperatura', 730.0000, 'ºC'),
	(85370, 110, '2015-03-01 01:07:53.000000', 'temperatura', 543.0000, 'ºC'),
	(85371, 110, '2015-03-01 01:07:54.000000', 'temperatura', 527.0000, 'ºC'),
	(85372, 110, '2015-03-01 01:07:55.000000', 'temperatura', 1004.0000, 'ºC'),
	(85373, 110, '2015-03-01 01:07:56.000000', 'temperatura', 1042.0000, 'ºC'),
	(85374, 110, '2015-03-01 01:07:57.000000', 'temperatura', 999.0000, 'ºC'),
	(85375, 110, '2015-03-01 01:07:58.000000', 'temperatura', 669.0000, 'ºC'),
	(85376, 110, '2015-03-01 01:07:59.000000', 'temperatura', 348.0000, 'ºC'),
	(85377, 110, '2015-03-01 01:08:00.000000', 'temperatura', 932.0000, 'ºC'),
	(85378, 110, '2015-03-01 01:08:01.000000', 'temperatura', 19.0000, 'ºC'),
	(85379, 110, '2015-03-01 01:08:02.000000', 'temperatura', 899.0000, 'ºC'),
	(85380, 110, '2015-03-01 01:08:03.000000', 'temperatura', 839.0000, 'ºC'),
	(85381, 110, '2015-03-01 01:08:04.000000', 'temperatura', 298.0000, 'ºC'),
	(85382, 110, '2015-03-01 01:08:05.000000', 'temperatura', 173.0000, 'ºC'),
	(85383, 110, '2015-03-01 01:08:06.000000', 'temperatura', 1174.0000, 'ºC'),
	(85384, 110, '2015-03-01 01:08:07.000000', 'temperatura', 549.0000, 'ºC'),
	(85385, 110, '2015-03-01 01:08:08.000000', 'temperatura', 422.0000, 'ºC'),
	(85386, 110, '2015-03-01 01:08:09.000000', 'temperatura', 465.0000, 'ºC'),
	(85387, 110, '2015-03-01 01:08:10.000000', 'temperatura', 1061.0000, 'ºC'),
	(85388, 110, '2015-03-01 01:08:11.000000', 'temperatura', 310.0000, 'ºC'),
	(85389, 110, '2015-03-01 01:08:12.000000', 'temperatura', 769.0000, 'ºC'),
	(85390, 110, '2015-03-01 01:08:13.000000', 'temperatura', 515.0000, 'ºC'),
	(85391, 110, '2015-03-01 01:08:14.000000', 'temperatura', 268.0000, 'ºC'),
	(85392, 110, '2015-03-01 01:08:15.000000', 'temperatura', 997.0000, 'ºC'),
	(85393, 110, '2015-03-01 01:08:16.000000', 'temperatura', 581.0000, 'ºC'),
	(85394, 110, '2015-03-01 01:08:17.000000', 'temperatura', 1115.0000, 'ºC'),
	(85395, 110, '2015-03-01 01:08:18.000000', 'temperatura', 231.0000, 'ºC'),
	(85396, 110, '2015-03-01 01:08:19.000000', 'temperatura', 211.0000, 'ºC'),
	(85397, 111, '2015-03-01 00:00:00.000000', 'temperatura', 1183.0000, 'ºC'),
	(85398, 111, '2015-03-01 00:00:01.000000', 'temperatura', 28.0000, 'ºC'),
	(85399, 111, '2015-03-01 00:00:02.000000', 'temperatura', 188.0000, 'ºC'),
	(85400, 111, '2015-03-01 00:00:03.000000', 'temperatura', 859.0000, 'ºC'),
	(85401, 111, '2015-03-01 00:00:04.000000', 'temperatura', 133.0000, 'ºC'),
	(85402, 111, '2015-03-01 00:00:05.000000', 'temperatura', 486.0000, 'ºC'),
	(85403, 111, '2015-03-01 00:00:06.000000', 'temperatura', 831.0000, 'ºC'),
	(85404, 111, '2015-03-01 00:00:07.000000', 'temperatura', 300.0000, 'ºC'),
	(85405, 111, '2015-03-01 00:00:08.000000', 'temperatura', 204.0000, 'ºC'),
	(85406, 111, '2015-03-01 00:00:09.000000', 'temperatura', 124.0000, 'ºC'),
	(85407, 111, '2015-03-01 00:00:10.000000', 'temperatura', 7.0000, 'ºC'),
	(85408, 111, '2015-03-01 00:00:11.000000', 'temperatura', 865.0000, 'ºC'),
	(85409, 111, '2015-03-01 00:00:12.000000', 'temperatura', 702.0000, 'ºC'),
	(85410, 111, '2015-03-01 00:00:13.000000', 'temperatura', 915.0000, 'ºC'),
	(85411, 111, '2015-03-01 00:00:14.000000', 'temperatura', 70.0000, 'ºC'),
	(85412, 111, '2015-03-01 00:00:15.000000', 'temperatura', 4.0000, 'ºC'),
	(85413, 111, '2015-03-01 00:00:16.000000', 'temperatura', 1011.0000, 'ºC'),
	(85414, 111, '2015-03-01 00:00:17.000000', 'temperatura', 246.0000, 'ºC'),
	(85415, 111, '2015-03-01 00:00:18.000000', 'temperatura', 597.0000, 'ºC'),
	(85416, 111, '2015-03-01 00:00:19.000000', 'temperatura', 1047.0000, 'ºC'),
	(85417, 111, '2015-03-01 00:00:20.000000', 'temperatura', 1046.0000, 'ºC'),
	(85418, 111, '2015-03-01 00:00:21.000000', 'temperatura', 888.0000, 'ºC'),
	(85419, 111, '2015-03-01 00:00:22.000000', 'temperatura', 103.0000, 'ºC'),
	(85420, 111, '2015-03-01 00:00:23.000000', 'temperatura', 250.0000, 'ºC'),
	(85421, 111, '2015-03-01 00:00:24.000000', 'temperatura', 944.0000, 'ºC'),
	(85422, 111, '2015-03-01 00:00:25.000000', 'temperatura', 368.0000, 'ºC'),
	(85423, 111, '2015-03-01 00:00:26.000000', 'temperatura', 209.0000, 'ºC'),
	(85424, 111, '2015-03-01 00:00:27.000000', 'temperatura', 1142.0000, 'ºC'),
	(85425, 111, '2015-03-01 00:00:28.000000', 'temperatura', 284.0000, 'ºC'),
	(85426, 111, '2015-03-01 00:00:29.000000', 'temperatura', 394.0000, 'ºC'),
	(85427, 111, '2015-03-01 00:00:30.000000', 'temperatura', 1117.0000, 'ºC'),
	(85428, 111, '2015-03-01 00:00:31.000000', 'temperatura', 804.0000, 'ºC'),
	(85429, 111, '2015-03-01 00:00:32.000000', 'temperatura', 672.0000, 'ºC'),
	(85430, 111, '2015-03-01 00:00:33.000000', 'temperatura', 945.0000, 'ºC'),
	(85431, 111, '2015-03-01 00:00:34.000000', 'temperatura', 312.0000, 'ºC'),
	(85432, 111, '2015-03-01 00:00:35.000000', 'temperatura', 1125.0000, 'ºC'),
	(85433, 111, '2015-03-01 00:00:36.000000', 'temperatura', 1090.0000, 'ºC'),
	(85434, 111, '2015-03-01 00:00:37.000000', 'temperatura', 877.0000, 'ºC'),
	(85435, 111, '2015-03-01 00:00:38.000000', 'temperatura', 1113.0000, 'ºC'),
	(85436, 111, '2015-03-01 00:00:39.000000', 'temperatura', 535.0000, 'ºC'),
	(85437, 111, '2015-03-01 00:00:40.000000', 'temperatura', 536.0000, 'ºC'),
	(85438, 111, '2015-03-01 00:00:41.000000', 'temperatura', 1075.0000, 'ºC'),
	(85439, 111, '2015-03-01 00:00:42.000000', 'temperatura', 170.0000, 'ºC'),
	(85440, 111, '2015-03-01 00:00:43.000000', 'temperatura', 22.0000, 'ºC'),
	(85441, 111, '2015-03-01 00:00:44.000000', 'temperatura', 804.0000, 'ºC'),
	(85442, 111, '2015-03-01 00:00:45.000000', 'temperatura', 353.0000, 'ºC'),
	(85443, 111, '2015-03-01 00:00:46.000000', 'temperatura', 552.0000, 'ºC'),
	(85444, 111, '2015-03-01 00:00:47.000000', 'temperatura', 502.0000, 'ºC'),
	(85445, 111, '2015-03-01 00:00:48.000000', 'temperatura', 856.0000, 'ºC'),
	(85446, 111, '2015-03-01 00:00:49.000000', 'temperatura', 374.0000, 'ºC'),
	(85447, 111, '2015-03-01 00:00:50.000000', 'temperatura', 500.0000, 'ºC'),
	(85448, 111, '2015-03-01 00:00:51.000000', 'temperatura', 182.0000, 'ºC'),
	(85449, 111, '2015-03-01 00:00:52.000000', 'temperatura', 610.0000, 'ºC'),
	(85450, 111, '2015-03-01 00:00:53.000000', 'temperatura', 105.0000, 'ºC'),
	(85451, 111, '2015-03-01 00:00:54.000000', 'temperatura', 1097.0000, 'ºC'),
	(85452, 111, '2015-03-01 00:00:55.000000', 'temperatura', 368.0000, 'ºC'),
	(85453, 111, '2015-03-01 00:00:56.000000', 'temperatura', 949.0000, 'ºC'),
	(85454, 111, '2015-03-01 00:00:57.000000', 'temperatura', 42.0000, 'ºC'),
	(85455, 111, '2015-03-01 00:00:58.000000', 'temperatura', 962.0000, 'ºC'),
	(85456, 111, '2015-03-01 00:00:59.000000', 'temperatura', 1086.0000, 'ºC'),
	(85457, 111, '2015-03-01 00:01:00.000000', 'temperatura', 143.0000, 'ºC'),
	(85458, 111, '2015-03-01 00:01:01.000000', 'temperatura', 1059.0000, 'ºC'),
	(85459, 111, '2015-03-01 00:01:02.000000', 'temperatura', 65.0000, 'ºC'),
	(85460, 111, '2015-03-01 00:01:03.000000', 'temperatura', 748.0000, 'ºC'),
	(85461, 111, '2015-03-01 00:01:04.000000', 'temperatura', 1148.0000, 'ºC'),
	(85462, 111, '2015-03-01 00:01:05.000000', 'temperatura', 1096.0000, 'ºC'),
	(85463, 111, '2015-03-01 00:01:06.000000', 'temperatura', 837.0000, 'ºC'),
	(85464, 111, '2015-03-01 00:01:07.000000', 'temperatura', 895.0000, 'ºC'),
	(85465, 111, '2015-03-01 00:01:08.000000', 'temperatura', 768.0000, 'ºC'),
	(85466, 111, '2015-03-01 00:01:09.000000', 'temperatura', 1152.0000, 'ºC'),
	(85467, 111, '2015-03-01 00:01:10.000000', 'temperatura', 1059.0000, 'ºC'),
	(85468, 111, '2015-03-01 00:01:11.000000', 'temperatura', 637.0000, 'ºC'),
	(85469, 111, '2015-03-01 00:01:12.000000', 'temperatura', 9.0000, 'ºC'),
	(85470, 111, '2015-03-01 00:01:13.000000', 'temperatura', 534.0000, 'ºC'),
	(85471, 111, '2015-03-01 00:01:14.000000', 'temperatura', 244.0000, 'ºC'),
	(85472, 111, '2015-03-01 00:01:15.000000', 'temperatura', 819.0000, 'ºC'),
	(85473, 111, '2015-03-01 00:01:16.000000', 'temperatura', 964.0000, 'ºC'),
	(85474, 111, '2015-03-01 00:01:17.000000', 'temperatura', 1161.0000, 'ºC'),
	(85475, 111, '2015-03-01 00:01:18.000000', 'temperatura', 514.0000, 'ºC'),
	(85476, 111, '2015-03-01 00:01:19.000000', 'temperatura', 290.0000, 'ºC'),
	(85477, 111, '2015-03-01 00:01:20.000000', 'temperatura', 1106.0000, 'ºC'),
	(85478, 111, '2015-03-01 00:01:21.000000', 'temperatura', 1061.0000, 'ºC'),
	(85479, 111, '2015-03-01 00:01:22.000000', 'temperatura', 788.0000, 'ºC'),
	(85480, 111, '2015-03-01 00:01:23.000000', 'temperatura', 759.0000, 'ºC'),
	(85481, 111, '2015-03-01 00:01:24.000000', 'temperatura', 232.0000, 'ºC'),
	(85482, 111, '2015-03-01 00:01:25.000000', 'temperatura', 83.0000, 'ºC'),
	(85483, 111, '2015-03-01 00:01:26.000000', 'temperatura', 920.0000, 'ºC'),
	(85484, 111, '2015-03-01 00:01:27.000000', 'temperatura', 752.0000, 'ºC'),
	(85485, 111, '2015-03-01 00:01:28.000000', 'temperatura', 1001.0000, 'ºC'),
	(85486, 111, '2015-03-01 00:01:29.000000', 'temperatura', 350.0000, 'ºC'),
	(85487, 111, '2015-03-01 00:01:30.000000', 'temperatura', 1148.0000, 'ºC'),
	(85488, 111, '2015-03-01 00:01:31.000000', 'temperatura', 1088.0000, 'ºC'),
	(85489, 111, '2015-03-01 00:01:32.000000', 'temperatura', 797.0000, 'ºC'),
	(85490, 111, '2015-03-01 00:01:33.000000', 'temperatura', 721.0000, 'ºC'),
	(85491, 111, '2015-03-01 00:01:34.000000', 'temperatura', 14.0000, 'ºC'),
	(85492, 111, '2015-03-01 00:01:35.000000', 'temperatura', 309.0000, 'ºC'),
	(85493, 111, '2015-03-01 00:01:36.000000', 'temperatura', 303.0000, 'ºC'),
	(85494, 111, '2015-03-01 00:01:37.000000', 'temperatura', 587.0000, 'ºC'),
	(85495, 111, '2015-03-01 00:01:38.000000', 'temperatura', 826.0000, 'ºC'),
	(85496, 111, '2015-03-01 00:01:39.000000', 'temperatura', 1169.0000, 'ºC'),
	(85497, 111, '2015-03-01 00:01:40.000000', 'temperatura', 967.0000, 'ºC'),
	(85498, 111, '2015-03-01 00:01:41.000000', 'temperatura', 130.0000, 'ºC'),
	(85499, 111, '2015-03-01 00:01:42.000000', 'temperatura', 148.0000, 'ºC'),
	(85500, 111, '2015-03-01 00:01:43.000000', 'temperatura', 350.0000, 'ºC'),
	(85501, 111, '2015-03-01 00:01:44.000000', 'temperatura', 109.0000, 'ºC'),
	(85502, 111, '2015-03-01 00:01:45.000000', 'temperatura', 693.0000, 'ºC'),
	(85503, 111, '2015-03-01 00:01:46.000000', 'temperatura', 740.0000, 'ºC'),
	(85504, 111, '2015-03-01 00:01:47.000000', 'temperatura', 419.0000, 'ºC'),
	(85505, 111, '2015-03-01 00:01:48.000000', 'temperatura', 1077.0000, 'ºC'),
	(85506, 111, '2015-03-01 00:01:49.000000', 'temperatura', 530.0000, 'ºC'),
	(85507, 111, '2015-03-01 00:01:50.000000', 'temperatura', 620.0000, 'ºC'),
	(85508, 111, '2015-03-01 00:01:51.000000', 'temperatura', 308.0000, 'ºC'),
	(85509, 111, '2015-03-01 00:01:52.000000', 'temperatura', 883.0000, 'ºC'),
	(85510, 111, '2015-03-01 00:01:53.000000', 'temperatura', 1092.0000, 'ºC'),
	(85511, 111, '2015-03-01 00:01:54.000000', 'temperatura', 411.0000, 'ºC'),
	(85512, 111, '2015-03-01 00:01:55.000000', 'temperatura', 1178.0000, 'ºC'),
	(85513, 111, '2015-03-01 00:01:56.000000', 'temperatura', 1056.0000, 'ºC'),
	(85514, 111, '2015-03-01 00:01:57.000000', 'temperatura', 549.0000, 'ºC'),
	(85515, 111, '2015-03-01 00:01:58.000000', 'temperatura', 775.0000, 'ºC'),
	(85516, 111, '2015-03-01 00:01:59.000000', 'temperatura', 1030.0000, 'ºC'),
	(85517, 111, '2015-03-01 00:02:00.000000', 'temperatura', 427.0000, 'ºC'),
	(85518, 111, '2015-03-01 00:02:01.000000', 'temperatura', 245.0000, 'ºC'),
	(85519, 111, '2015-03-01 00:02:02.000000', 'temperatura', 1144.0000, 'ºC'),
	(85520, 111, '2015-03-01 00:02:03.000000', 'temperatura', 184.0000, 'ºC'),
	(85521, 111, '2015-03-01 00:02:04.000000', 'temperatura', 1091.0000, 'ºC'),
	(85522, 111, '2015-03-01 00:02:05.000000', 'temperatura', 103.0000, 'ºC'),
	(85523, 111, '2015-03-01 00:02:06.000000', 'temperatura', 844.0000, 'ºC'),
	(85524, 111, '2015-03-01 00:02:07.000000', 'temperatura', 309.0000, 'ºC'),
	(85525, 111, '2015-03-01 00:02:08.000000', 'temperatura', 214.0000, 'ºC'),
	(85526, 111, '2015-03-01 00:02:09.000000', 'temperatura', 142.0000, 'ºC'),
	(85527, 111, '2015-03-01 00:02:10.000000', 'temperatura', 69.0000, 'ºC'),
	(85528, 111, '2015-03-01 00:02:11.000000', 'temperatura', 1118.0000, 'ºC'),
	(85529, 111, '2015-03-01 00:02:12.000000', 'temperatura', 585.0000, 'ºC'),
	(85530, 111, '2015-03-01 00:02:13.000000', 'temperatura', 770.0000, 'ºC'),
	(85531, 111, '2015-03-01 00:02:14.000000', 'temperatura', 896.0000, 'ºC'),
	(85532, 111, '2015-03-01 00:02:15.000000', 'temperatura', 971.0000, 'ºC'),
	(85533, 111, '2015-03-01 00:02:16.000000', 'temperatura', 966.0000, 'ºC'),
	(85534, 111, '2015-03-01 00:02:17.000000', 'temperatura', 720.0000, 'ºC'),
	(85535, 111, '2015-03-01 00:02:18.000000', 'temperatura', 700.0000, 'ºC'),
	(85536, 111, '2015-03-01 00:02:19.000000', 'temperatura', 142.0000, 'ºC'),
	(85537, 111, '2015-03-01 00:02:20.000000', 'temperatura', 1011.0000, 'ºC'),
	(85538, 111, '2015-03-01 00:02:21.000000', 'temperatura', 1031.0000, 'ºC'),
	(85539, 111, '2015-03-01 00:02:22.000000', 'temperatura', 919.0000, 'ºC'),
	(85540, 111, '2015-03-01 00:02:23.000000', 'temperatura', 305.0000, 'ºC'),
	(85541, 111, '2015-03-01 00:02:24.000000', 'temperatura', 1170.0000, 'ºC'),
	(85542, 111, '2015-03-01 00:02:25.000000', 'temperatura', 132.0000, 'ºC'),
	(85543, 111, '2015-03-01 00:02:26.000000', 'temperatura', 752.0000, 'ºC'),
	(85544, 111, '2015-03-01 00:02:27.000000', 'temperatura', 966.0000, 'ºC'),
	(85545, 111, '2015-03-01 00:02:28.000000', 'temperatura', 175.0000, 'ºC'),
	(85546, 111, '2015-03-01 00:02:29.000000', 'temperatura', 375.0000, 'ºC'),
	(85547, 111, '2015-03-01 00:02:30.000000', 'temperatura', 150.0000, 'ºC'),
	(85548, 111, '2015-03-01 00:02:31.000000', 'temperatura', 827.0000, 'ºC'),
	(85549, 111, '2015-03-01 00:02:32.000000', 'temperatura', 83.0000, 'ºC'),
	(85550, 111, '2015-03-01 00:02:33.000000', 'temperatura', 336.0000, 'ºC'),
	(85551, 111, '2015-03-01 00:02:34.000000', 'temperatura', 232.0000, 'ºC'),
	(85552, 111, '2015-03-01 00:02:35.000000', 'temperatura', 154.0000, 'ºC'),
	(85553, 111, '2015-03-01 00:02:36.000000', 'temperatura', 72.0000, 'ºC'),
	(85554, 111, '2015-03-01 00:02:37.000000', 'temperatura', 1098.0000, 'ºC'),
	(85555, 111, '2015-03-01 00:02:38.000000', 'temperatura', 475.0000, 'ºC'),
	(85556, 111, '2015-03-01 00:02:39.000000', 'temperatura', 283.0000, 'ºC'),
	(85557, 111, '2015-03-01 00:02:40.000000', 'temperatura', 1190.0000, 'ºC'),
	(85558, 111, '2015-03-01 00:02:41.000000', 'temperatura', 303.0000, 'ºC'),
	(85559, 111, '2015-03-01 00:02:42.000000', 'temperatura', 346.0000, 'ºC'),
	(85560, 111, '2015-03-01 00:02:43.000000', 'temperatura', 820.0000, 'ºC'),
	(85561, 111, '2015-03-01 00:02:44.000000', 'temperatura', 662.0000, 'ºC'),
	(85562, 111, '2015-03-01 00:02:45.000000', 'temperatura', 853.0000, 'ºC'),
	(85563, 111, '2015-03-01 00:02:46.000000', 'temperatura', 1078.0000, 'ºC'),
	(85564, 111, '2015-03-01 00:02:47.000000', 'temperatura', 432.0000, 'ºC'),
	(85565, 111, '2015-03-01 00:02:48.000000', 'temperatura', 128.0000, 'ºC'),
	(85566, 111, '2015-03-01 00:02:49.000000', 'temperatura', 543.0000, 'ºC'),
	(85567, 111, '2015-03-01 00:02:50.000000', 'temperatura', 1131.0000, 'ºC'),
	(85568, 111, '2015-03-01 00:02:51.000000', 'temperatura', 428.0000, 'ºC'),
	(85569, 111, '2015-03-01 00:02:52.000000', 'temperatura', 1146.0000, 'ºC'),
	(85570, 111, '2015-03-01 00:02:53.000000', 'temperatura', 847.0000, 'ºC'),
	(85571, 111, '2015-03-01 00:02:54.000000', 'temperatura', 796.0000, 'ºC'),
	(85572, 111, '2015-03-01 00:02:55.000000', 'temperatura', 241.0000, 'ºC'),
	(85573, 111, '2015-03-01 00:02:56.000000', 'temperatura', 16.0000, 'ºC'),
	(85574, 111, '2015-03-01 00:02:57.000000', 'temperatura', 560.0000, 'ºC'),
	(85575, 111, '2015-03-01 00:02:58.000000', 'temperatura', 351.0000, 'ºC'),
	(85576, 111, '2015-03-01 00:02:59.000000', 'temperatura', 76.0000, 'ºC'),
	(85577, 111, '2015-03-01 00:03:00.000000', 'temperatura', 527.0000, 'ºC'),
	(85578, 111, '2015-03-01 00:03:01.000000', 'temperatura', 7.0000, 'ºC'),
	(85579, 111, '2015-03-01 00:03:02.000000', 'temperatura', 854.0000, 'ºC'),
	(85580, 111, '2015-03-01 00:03:03.000000', 'temperatura', 651.0000, 'ºC'),
	(85581, 111, '2015-03-01 00:03:04.000000', 'temperatura', 691.0000, 'ºC'),
	(85582, 111, '2015-03-01 00:03:05.000000', 'temperatura', 303.0000, 'ºC'),
	(85583, 111, '2015-03-01 00:03:06.000000', 'temperatura', 643.0000, 'ºC'),
	(85584, 111, '2015-03-01 00:03:07.000000', 'temperatura', 1108.0000, 'ºC'),
	(85585, 111, '2015-03-01 00:03:08.000000', 'temperatura', 9.0000, 'ºC'),
	(85586, 111, '2015-03-01 00:03:09.000000', 'temperatura', 324.0000, 'ºC'),
	(85587, 111, '2015-03-01 00:03:10.000000', 'temperatura', 393.0000, 'ºC'),
	(85588, 111, '2015-03-01 00:03:11.000000', 'temperatura', 992.0000, 'ºC'),
	(85589, 111, '2015-03-01 00:03:12.000000', 'temperatura', 181.0000, 'ºC'),
	(85590, 111, '2015-03-01 00:03:13.000000', 'temperatura', 331.0000, 'ºC'),
	(85591, 111, '2015-03-01 00:03:14.000000', 'temperatura', 1112.0000, 'ºC'),
	(85592, 111, '2015-03-01 00:03:15.000000', 'temperatura', 966.0000, 'ºC'),
	(85593, 111, '2015-03-01 00:03:16.000000', 'temperatura', 294.0000, 'ºC'),
	(85594, 111, '2015-03-01 00:03:17.000000', 'temperatura', 973.0000, 'ºC'),
	(85595, 111, '2015-03-01 00:03:18.000000', 'temperatura', 382.0000, 'ºC'),
	(85596, 111, '2015-03-01 00:03:19.000000', 'temperatura', 195.0000, 'ºC'),
	(85597, 111, '2015-03-01 00:03:20.000000', 'temperatura', 1027.0000, 'ºC'),
	(85598, 111, '2015-03-01 00:03:21.000000', 'temperatura', 952.0000, 'ºC'),
	(85599, 111, '2015-03-01 00:03:22.000000', 'temperatura', 478.0000, 'ºC'),
	(85600, 111, '2015-03-01 00:03:23.000000', 'temperatura', 737.0000, 'ºC'),
	(85601, 111, '2015-03-01 00:03:24.000000', 'temperatura', 1049.0000, 'ºC'),
	(85602, 111, '2015-03-01 00:03:25.000000', 'temperatura', 637.0000, 'ºC'),
	(85603, 111, '2015-03-01 00:03:26.000000', 'temperatura', 35.0000, 'ºC'),
	(85604, 111, '2015-03-01 00:03:27.000000', 'temperatura', 668.0000, 'ºC'),
	(85605, 111, '2015-03-01 00:03:28.000000', 'temperatura', 833.0000, 'ºC'),
	(85606, 111, '2015-03-01 00:03:29.000000', 'temperatura', 962.0000, 'ºC'),
	(85607, 111, '2015-03-01 00:03:30.000000', 'temperatura', 1113.0000, 'ºC'),
	(85608, 111, '2015-03-01 00:03:31.000000', 'temperatura', 277.0000, 'ºC'),
	(85609, 111, '2015-03-01 00:03:32.000000', 'temperatura', 449.0000, 'ºC'),
	(85610, 111, '2015-03-01 00:03:33.000000', 'temperatura', 215.0000, 'ºC'),
	(85611, 111, '2015-03-01 00:03:34.000000', 'temperatura', 926.0000, 'ºC'),
	(85612, 111, '2015-03-01 00:03:35.000000', 'temperatura', 386.0000, 'ºC'),
	(85613, 111, '2015-03-01 00:03:36.000000', 'temperatura', 352.0000, 'ºC'),
	(85614, 111, '2015-03-01 00:03:37.000000', 'temperatura', 602.0000, 'ºC'),
	(85615, 111, '2015-03-01 00:03:38.000000', 'temperatura', 755.0000, 'ºC'),
	(85616, 111, '2015-03-01 00:03:39.000000', 'temperatura', 770.0000, 'ºC'),
	(85617, 111, '2015-03-01 00:03:40.000000', 'temperatura', 387.0000, 'ºC'),
	(85618, 111, '2015-03-01 00:03:41.000000', 'temperatura', 825.0000, 'ºC'),
	(85619, 111, '2015-03-01 00:03:42.000000', 'temperatura', 562.0000, 'ºC'),
	(85620, 111, '2015-03-01 00:03:43.000000', 'temperatura', 338.0000, 'ºC'),
	(85621, 111, '2015-03-01 00:03:44.000000', 'temperatura', 3.0000, 'ºC'),
	(85622, 111, '2015-03-01 00:03:45.000000', 'temperatura', 202.0000, 'ºC'),
	(85623, 111, '2015-03-01 00:03:46.000000', 'temperatura', 1001.0000, 'ºC'),
	(85624, 111, '2015-03-01 00:03:47.000000', 'temperatura', 800.0000, 'ºC'),
	(85625, 111, '2015-03-01 00:03:48.000000', 'temperatura', 997.0000, 'ºC'),
	(85626, 111, '2015-03-01 00:03:49.000000', 'temperatura', 186.0000, 'ºC'),
	(85627, 111, '2015-03-01 00:03:50.000000', 'temperatura', 338.0000, 'ºC'),
	(85628, 111, '2015-03-01 00:03:51.000000', 'temperatura', 1133.0000, 'ºC'),
	(85629, 111, '2015-03-01 00:03:52.000000', 'temperatura', 1052.0000, 'ºC'),
	(85630, 111, '2015-03-01 00:03:53.000000', 'temperatura', 663.0000, 'ºC'),
	(85631, 111, '2015-03-01 00:03:54.000000', 'temperatura', 157.0000, 'ºC'),
	(85632, 111, '2015-03-01 00:03:55.000000', 'temperatura', 1199.0000, 'ºC'),
	(85633, 111, '2015-03-01 00:03:56.000000', 'temperatura', 724.0000, 'ºC'),
	(85634, 111, '2015-03-01 00:03:57.000000', 'temperatura', 25.0000, 'ºC'),
	(85635, 111, '2015-03-01 00:03:58.000000', 'temperatura', 351.0000, 'ºC'),
	(85636, 111, '2015-03-01 00:03:59.000000', 'temperatura', 483.0000, 'ºC'),
	(85637, 111, '2015-03-01 00:04:00.000000', 'temperatura', 163.0000, 'ºC'),
	(85638, 111, '2015-03-01 00:04:01.000000', 'temperatura', 563.0000, 'ºC'),
	(85639, 111, '2015-03-01 00:04:02.000000', 'temperatura', 1130.0000, 'ºC'),
	(85640, 111, '2015-03-01 00:04:03.000000', 'temperatura', 359.0000, 'ºC'),
	(85641, 111, '2015-03-01 00:04:04.000000', 'temperatura', 807.0000, 'ºC'),
	(85642, 111, '2015-03-01 00:04:05.000000', 'temperatura', 560.0000, 'ºC'),
	(85643, 111, '2015-03-01 00:04:06.000000', 'temperatura', 379.0000, 'ºC'),
	(85644, 111, '2015-03-01 00:04:07.000000', 'temperatura', 213.0000, 'ºC'),
	(85645, 111, '2015-03-01 00:04:08.000000', 'temperatura', 1129.0000, 'ºC'),
	(85646, 111, '2015-03-01 00:04:09.000000', 'temperatura', 209.0000, 'ºC'),
	(85647, 111, '2015-03-01 00:04:10.000000', 'temperatura', 57.0000, 'ºC'),
	(85648, 111, '2015-03-01 00:04:11.000000', 'temperatura', 859.0000, 'ºC'),
	(85649, 111, '2015-03-01 00:04:12.000000', 'temperatura', 525.0000, 'ºC'),
	(85650, 111, '2015-03-01 00:04:13.000000', 'temperatura', 49.0000, 'ºC'),
	(85651, 111, '2015-03-01 00:04:14.000000', 'temperatura', 1072.0000, 'ºC'),
	(85652, 111, '2015-03-01 00:04:15.000000', 'temperatura', 410.0000, 'ºC'),
	(85653, 111, '2015-03-01 00:04:16.000000', 'temperatura', 36.0000, 'ºC'),
	(85654, 111, '2015-03-01 00:04:17.000000', 'temperatura', 150.0000, 'ºC'),
	(85655, 111, '2015-03-01 00:04:18.000000', 'temperatura', 644.0000, 'ºC'),
	(85656, 111, '2015-03-01 00:04:19.000000', 'temperatura', 368.0000, 'ºC'),
	(85657, 111, '2015-03-01 00:04:20.000000', 'temperatura', 1109.0000, 'ºC'),
	(85658, 111, '2015-03-01 00:04:21.000000', 'temperatura', 841.0000, 'ºC'),
	(85659, 111, '2015-03-01 00:04:22.000000', 'temperatura', 879.0000, 'ºC'),
	(85660, 111, '2015-03-01 00:04:23.000000', 'temperatura', 675.0000, 'ºC'),
	(85661, 111, '2015-03-01 00:04:24.000000', 'temperatura', 735.0000, 'ºC'),
	(85662, 111, '2015-03-01 00:04:25.000000', 'temperatura', 453.0000, 'ºC'),
	(85663, 111, '2015-03-01 00:04:26.000000', 'temperatura', 59.0000, 'ºC'),
	(85664, 111, '2015-03-01 00:04:27.000000', 'temperatura', 136.0000, 'ºC'),
	(85665, 111, '2015-03-01 00:04:28.000000', 'temperatura', 502.0000, 'ºC'),
	(85666, 111, '2015-03-01 00:04:29.000000', 'temperatura', 905.0000, 'ºC'),
	(85667, 111, '2015-03-01 00:04:30.000000', 'temperatura', 619.0000, 'ºC'),
	(85668, 111, '2015-03-01 00:04:31.000000', 'temperatura', 382.0000, 'ºC'),
	(85669, 111, '2015-03-01 00:04:32.000000', 'temperatura', 52.0000, 'ºC'),
	(85670, 111, '2015-03-01 00:04:33.000000', 'temperatura', 316.0000, 'ºC'),
	(85671, 111, '2015-03-01 00:04:34.000000', 'temperatura', 222.0000, 'ºC'),
	(85672, 111, '2015-03-01 00:04:35.000000', 'temperatura', 163.0000, 'ºC'),
	(85673, 111, '2015-03-01 00:04:36.000000', 'temperatura', 151.0000, 'ºC'),
	(85674, 111, '2015-03-01 00:04:37.000000', 'temperatura', 267.0000, 'ºC'),
	(85675, 111, '2015-03-01 00:04:38.000000', 'temperatura', 880.0000, 'ºC'),
	(85676, 111, '2015-03-01 00:04:39.000000', 'temperatura', 1.0000, 'ºC'),
	(85677, 111, '2015-03-01 00:04:40.000000', 'temperatura', 964.0000, 'ºC'),
	(85678, 111, '2015-03-01 00:04:41.000000', 'temperatura', 20.0000, 'ºC'),
	(85679, 111, '2015-03-01 00:04:42.000000', 'temperatura', 807.0000, 'ºC'),
	(85680, 111, '2015-03-01 00:04:43.000000', 'temperatura', 374.0000, 'ºC'),
	(85681, 111, '2015-03-01 00:04:44.000000', 'temperatura', 652.0000, 'ºC'),
	(85682, 111, '2015-03-01 00:04:45.000000', 'temperatura', 938.0000, 'ºC'),
	(85683, 111, '2015-03-01 00:04:46.000000', 'temperatura', 332.0000, 'ºC'),
	(85684, 111, '2015-03-01 00:04:47.000000', 'temperatura', 49.0000, 'ºC'),
	(85685, 111, '2015-03-01 00:04:48.000000', 'temperatura', 449.0000, 'ºC'),
	(85686, 111, '2015-03-01 00:04:49.000000', 'temperatura', 897.0000, 'ºC'),
	(85687, 111, '2015-03-01 00:04:50.000000', 'temperatura', 741.0000, 'ºC'),
	(85688, 111, '2015-03-01 00:04:51.000000', 'temperatura', 1012.0000, 'ºC'),
	(85689, 111, '2015-03-01 00:04:52.000000', 'temperatura', 438.0000, 'ºC'),
	(85690, 111, '2015-03-01 00:04:53.000000', 'temperatura', 354.0000, 'ºC'),
	(85691, 111, '2015-03-01 00:04:54.000000', 'temperatura', 459.0000, 'ºC'),
	(85692, 111, '2015-03-01 00:04:55.000000', 'temperatura', 31.0000, 'ºC'),
	(85693, 111, '2015-03-01 00:04:56.000000', 'temperatura', 1178.0000, 'ºC'),
	(85694, 111, '2015-03-01 00:04:57.000000', 'temperatura', 997.0000, 'ºC'),
	(85695, 111, '2015-03-01 00:04:58.000000', 'temperatura', 252.0000, 'ºC'),
	(85696, 111, '2015-03-01 00:04:59.000000', 'temperatura', 669.0000, 'ºC'),
	(85697, 111, '2015-03-01 00:05:00.000000', 'temperatura', 191.0000, 'ºC'),
	(85698, 111, '2015-03-01 00:05:01.000000', 'temperatura', 148.0000, 'ºC'),
	(85699, 111, '2015-03-01 00:05:02.000000', 'temperatura', 166.0000, 'ºC'),
	(85700, 111, '2015-03-01 00:05:03.000000', 'temperatura', 387.0000, 'ºC'),
	(85701, 111, '2015-03-01 00:05:04.000000', 'temperatura', 237.0000, 'ºC'),
	(85702, 111, '2015-03-01 00:05:05.000000', 'temperatura', 25.0000, 'ºC'),
	(85703, 111, '2015-03-01 00:05:06.000000', 'temperatura', 617.0000, 'ºC'),
	(85704, 111, '2015-03-01 00:05:07.000000', 'temperatura', 607.0000, 'ºC'),
	(85705, 111, '2015-03-01 00:05:08.000000', 'temperatura', 1186.0000, 'ºC'),
	(85706, 111, '2015-03-01 00:05:09.000000', 'temperatura', 507.0000, 'ºC'),
	(85707, 111, '2015-03-01 00:05:10.000000', 'temperatura', 181.0000, 'ºC'),
	(85708, 111, '2015-03-01 00:05:11.000000', 'temperatura', 583.0000, 'ºC'),
	(85709, 111, '2015-03-01 00:05:12.000000', 'temperatura', 1171.0000, 'ºC'),
	(85710, 111, '2015-03-01 00:05:13.000000', 'temperatura', 507.0000, 'ºC'),
	(85711, 111, '2015-03-01 00:05:14.000000', 'temperatura', 223.0000, 'ºC'),
	(85712, 111, '2015-03-01 00:05:15.000000', 'temperatura', 796.0000, 'ºC'),
	(85713, 111, '2015-03-01 00:05:16.000000', 'temperatura', 909.0000, 'ºC'),
	(85714, 111, '2015-03-01 00:05:17.000000', 'temperatura', 957.0000, 'ºC'),
	(85715, 111, '2015-03-01 00:05:18.000000', 'temperatura', 859.0000, 'ºC'),
	(85716, 111, '2015-03-01 00:05:19.000000', 'temperatura', 227.0000, 'ºC'),
	(85717, 111, '2015-03-01 00:05:20.000000', 'temperatura', 956.0000, 'ºC'),
	(85718, 111, '2015-03-01 00:05:21.000000', 'temperatura', 498.0000, 'ºC'),
	(85719, 111, '2015-03-01 00:05:22.000000', 'temperatura', 826.0000, 'ºC'),
	(85720, 111, '2015-03-01 00:05:23.000000', 'temperatura', 234.0000, 'ºC'),
	(85721, 111, '2015-03-01 00:05:24.000000', 'temperatura', 1093.0000, 'ºC'),
	(85722, 111, '2015-03-01 00:05:25.000000', 'temperatura', 1162.0000, 'ºC'),
	(85723, 111, '2015-03-01 00:05:26.000000', 'temperatura', 132.0000, 'ºC'),
	(85724, 111, '2015-03-01 00:05:27.000000', 'temperatura', 777.0000, 'ºC'),
	(85725, 111, '2015-03-01 00:05:28.000000', 'temperatura', 1088.0000, 'ºC'),
	(85726, 111, '2015-03-01 00:05:29.000000', 'temperatura', 711.0000, 'ºC'),
	(85727, 111, '2015-03-01 00:05:30.000000', 'temperatura', 291.0000, 'ºC'),
	(85728, 111, '2015-03-01 00:05:31.000000', 'temperatura', 523.0000, 'ºC'),
	(85729, 111, '2015-03-01 00:05:32.000000', 'temperatura', 543.0000, 'ºC'),
	(85730, 111, '2015-03-01 00:05:33.000000', 'temperatura', 1147.0000, 'ºC'),
	(85731, 111, '2015-03-01 00:05:34.000000', 'temperatura', 506.0000, 'ºC'),
	(85732, 111, '2015-03-01 00:05:35.000000', 'temperatura', 287.0000, 'ºC'),
	(85733, 111, '2015-03-01 00:05:36.000000', 'temperatura', 1121.0000, 'ºC'),
	(85734, 111, '2015-03-01 00:05:37.000000', 'temperatura', 1142.0000, 'ºC'),
	(85735, 111, '2015-03-01 00:05:38.000000', 'temperatura', 1150.0000, 'ºC'),
	(85736, 111, '2015-03-01 00:05:39.000000', 'temperatura', 1123.0000, 'ºC'),
	(85737, 111, '2015-03-01 00:05:40.000000', 'temperatura', 966.0000, 'ºC'),
	(85738, 111, '2015-03-01 00:05:41.000000', 'temperatura', 263.0000, 'ºC'),
	(85739, 111, '2015-03-01 00:05:42.000000', 'temperatura', 818.0000, 'ºC'),
	(85740, 111, '2015-03-01 00:05:43.000000', 'temperatura', 899.0000, 'ºC'),
	(85741, 111, '2015-03-01 00:05:44.000000', 'temperatura', 842.0000, 'ºC'),
	(85742, 111, '2015-03-01 00:05:45.000000', 'temperatura', 315.0000, 'ºC'),
	(85743, 111, '2015-03-01 00:05:46.000000', 'temperatura', 247.0000, 'ºC'),
	(85744, 111, '2015-03-01 00:05:47.000000', 'temperatura', 291.0000, 'ºC'),
	(85745, 111, '2015-03-01 00:05:48.000000', 'temperatura', 716.0000, 'ºC'),
	(85746, 111, '2015-03-01 00:05:49.000000', 'temperatura', 309.0000, 'ºC'),
	(85747, 111, '2015-03-01 00:05:50.000000', 'temperatura', 595.0000, 'ºC'),
	(85748, 111, '2015-03-01 00:05:51.000000', 'temperatura', 851.0000, 'ºC'),
	(85749, 111, '2015-03-01 00:05:52.000000', 'temperatura', 70.0000, 'ºC'),
	(85750, 111, '2015-03-01 00:05:53.000000', 'temperatura', 195.0000, 'ºC'),
	(85751, 111, '2015-03-01 00:05:54.000000', 'temperatura', 767.0000, 'ºC'),
	(85752, 111, '2015-03-01 00:05:55.000000', 'temperatura', 850.0000, 'ºC'),
	(85753, 111, '2015-03-01 00:05:56.000000', 'temperatura', 748.0000, 'ºC'),
	(85754, 111, '2015-03-01 00:05:57.000000', 'temperatura', 1191.0000, 'ºC'),
	(85755, 111, '2015-03-01 00:05:58.000000', 'temperatura', 110.0000, 'ºC'),
	(85756, 111, '2015-03-01 00:05:59.000000', 'temperatura', 579.0000, 'ºC'),
	(85757, 111, '2015-03-01 00:06:00.000000', 'temperatura', 166.0000, 'ºC'),
	(85758, 111, '2015-03-01 00:06:01.000000', 'temperatura', 291.0000, 'ºC'),
	(85759, 111, '2015-03-01 00:06:02.000000', 'temperatura', 960.0000, 'ºC'),
	(85760, 111, '2015-03-01 00:06:03.000000', 'temperatura', 326.0000, 'ºC'),
	(85761, 111, '2015-03-01 00:06:04.000000', 'temperatura', 1151.0000, 'ºC'),
	(85762, 111, '2015-03-01 00:06:05.000000', 'temperatura', 1177.0000, 'ºC'),
	(85763, 111, '2015-03-01 00:06:06.000000', 'temperatura', 32.0000, 'ºC'),
	(85764, 111, '2015-03-01 00:06:07.000000', 'temperatura', 228.0000, 'ºC'),
	(85765, 111, '2015-03-01 00:06:08.000000', 'temperatura', 1048.0000, 'ºC'),
	(85766, 111, '2015-03-01 00:06:09.000000', 'temperatura', 955.0000, 'ºC'),
	(85767, 111, '2015-03-01 00:06:10.000000', 'temperatura', 433.0000, 'ºC'),
	(85768, 111, '2015-03-01 00:06:11.000000', 'temperatura', 498.0000, 'ºC'),
	(85769, 111, '2015-03-01 00:06:12.000000', 'temperatura', 1192.0000, 'ºC'),
	(85770, 111, '2015-03-01 00:06:13.000000', 'temperatura', 867.0000, 'ºC'),
	(85771, 111, '2015-03-01 00:06:14.000000', 'temperatura', 758.0000, 'ºC'),
	(85772, 111, '2015-03-01 00:06:15.000000', 'temperatura', 1189.0000, 'ºC'),
	(85773, 111, '2015-03-01 00:06:16.000000', 'temperatura', 73.0000, 'ºC'),
	(85774, 111, '2015-03-01 00:06:17.000000', 'temperatura', 397.0000, 'ºC'),
	(85775, 111, '2015-03-01 00:06:18.000000', 'temperatura', 567.0000, 'ºC'),
	(85776, 111, '2015-03-01 00:06:19.000000', 'temperatura', 446.0000, 'ºC'),
	(85777, 111, '2015-03-01 00:06:20.000000', 'temperatura', 529.0000, 'ºC'),
	(85778, 111, '2015-03-01 00:06:21.000000', 'temperatura', 105.0000, 'ºC'),
	(85779, 111, '2015-03-01 00:06:22.000000', 'temperatura', 141.0000, 'ºC'),
	(85780, 111, '2015-03-01 00:06:23.000000', 'temperatura', 391.0000, 'ºC'),
	(85781, 111, '2015-03-01 00:06:24.000000', 'temperatura', 330.0000, 'ºC'),
	(85782, 111, '2015-03-01 00:06:25.000000', 'temperatura', 478.0000, 'ºC'),
	(85783, 111, '2015-03-01 00:06:26.000000', 'temperatura', 202.0000, 'ºC'),
	(85784, 111, '2015-03-01 00:06:27.000000', 'temperatura', 777.0000, 'ºC'),
	(85785, 111, '2015-03-01 00:06:28.000000', 'temperatura', 877.0000, 'ºC'),
	(85786, 111, '2015-03-01 00:06:29.000000', 'temperatura', 857.0000, 'ºC'),
	(85787, 111, '2015-03-01 00:06:30.000000', 'temperatura', 455.0000, 'ºC'),
	(85788, 111, '2015-03-01 00:06:31.000000', 'temperatura', 903.0000, 'ºC'),
	(85789, 111, '2015-03-01 00:06:32.000000', 'temperatura', 751.0000, 'ºC'),
	(85790, 111, '2015-03-01 00:06:33.000000', 'temperatura', 1045.0000, 'ºC'),
	(85791, 111, '2015-03-01 00:06:34.000000', 'temperatura', 572.0000, 'ºC'),
	(85792, 111, '2015-03-01 00:06:35.000000', 'temperatura', 925.0000, 'ºC'),
	(85793, 111, '2015-03-01 00:06:36.000000', 'temperatura', 510.0000, 'ºC'),
	(85794, 111, '2015-03-01 00:06:37.000000', 'temperatura', 976.0000, 'ºC'),
	(85795, 111, '2015-03-01 00:06:38.000000', 'temperatura', 952.0000, 'ºC'),
	(85796, 111, '2015-03-01 00:06:39.000000', 'temperatura', 631.0000, 'ºC'),
	(85797, 111, '2015-03-01 00:06:40.000000', 'temperatura', 299.0000, 'ºC'),
	(85798, 111, '2015-03-01 00:06:41.000000', 'temperatura', 802.0000, 'ºC'),
	(85799, 111, '2015-03-01 00:06:42.000000', 'temperatura', 716.0000, 'ºC'),
	(85800, 111, '2015-03-01 00:06:43.000000', 'temperatura', 1174.0000, 'ºC'),
	(85801, 111, '2015-03-01 00:06:44.000000', 'temperatura', 120.0000, 'ºC'),
	(85802, 111, '2015-03-01 00:06:45.000000', 'temperatura', 680.0000, 'ºC'),
	(85803, 111, '2015-03-01 00:06:46.000000', 'temperatura', 639.0000, 'ºC'),
	(85804, 111, '2015-03-01 00:06:47.000000', 'temperatura', 1157.0000, 'ºC'),
	(85805, 111, '2015-03-01 00:06:48.000000', 'temperatura', 267.0000, 'ºC'),
	(85806, 111, '2015-03-01 00:06:49.000000', 'temperatura', 267.0000, 'ºC'),
	(85807, 111, '2015-03-01 00:06:50.000000', 'temperatura', 534.0000, 'ºC'),
	(85808, 111, '2015-03-01 00:06:51.000000', 'temperatura', 667.0000, 'ºC'),
	(85809, 111, '2015-03-01 00:06:52.000000', 'temperatura', 536.0000, 'ºC'),
	(85810, 111, '2015-03-01 00:06:53.000000', 'temperatura', 680.0000, 'ºC'),
	(85811, 111, '2015-03-01 00:06:54.000000', 'temperatura', 592.0000, 'ºC'),
	(85812, 111, '2015-03-01 00:06:55.000000', 'temperatura', 920.0000, 'ºC'),
	(85813, 111, '2015-03-01 00:06:56.000000', 'temperatura', 423.0000, 'ºC'),
	(85814, 111, '2015-03-01 00:06:57.000000', 'temperatura', 555.0000, 'ºC'),
	(85815, 111, '2015-03-01 00:06:58.000000', 'temperatura', 307.0000, 'ºC'),
	(85816, 111, '2015-03-01 00:06:59.000000', 'temperatura', 1072.0000, 'ºC'),
	(85817, 111, '2015-03-01 00:07:00.000000', 'temperatura', 840.0000, 'ºC'),
	(85818, 111, '2015-03-01 00:07:01.000000', 'temperatura', 984.0000, 'ºC'),
	(85819, 111, '2015-03-01 00:07:02.000000', 'temperatura', 1199.0000, 'ºC'),
	(85820, 111, '2015-03-01 00:07:03.000000', 'temperatura', 646.0000, 'ºC'),
	(85821, 111, '2015-03-01 00:07:04.000000', 'temperatura', 832.0000, 'ºC'),
	(85822, 111, '2015-03-01 00:07:05.000000', 'temperatura', 1025.0000, 'ºC'),
	(85823, 111, '2015-03-01 00:07:06.000000', 'temperatura', 226.0000, 'ºC'),
	(85824, 111, '2015-03-01 00:07:07.000000', 'temperatura', 458.0000, 'ºC'),
	(85825, 111, '2015-03-01 00:07:08.000000', 'temperatura', 414.0000, 'ºC'),
	(85826, 111, '2015-03-01 00:07:09.000000', 'temperatura', 694.0000, 'ºC'),
	(85827, 111, '2015-03-01 00:07:10.000000', 'temperatura', 1029.0000, 'ºC'),
	(85828, 111, '2015-03-01 00:07:11.000000', 'temperatura', 665.0000, 'ºC'),
	(85829, 111, '2015-03-01 00:07:12.000000', 'temperatura', 237.0000, 'ºC'),
	(85830, 111, '2015-03-01 00:07:13.000000', 'temperatura', 391.0000, 'ºC'),
	(85831, 111, '2015-03-01 00:07:14.000000', 'temperatura', 44.0000, 'ºC'),
	(85832, 111, '2015-03-01 00:07:15.000000', 'temperatura', 247.0000, 'ºC'),
	(85833, 111, '2015-03-01 00:07:16.000000', 'temperatura', 1105.0000, 'ºC'),
	(85834, 111, '2015-03-01 00:07:17.000000', 'temperatura', 1186.0000, 'ºC'),
	(85835, 111, '2015-03-01 00:07:18.000000', 'temperatura', 213.0000, 'ºC'),
	(85836, 111, '2015-03-01 00:07:19.000000', 'temperatura', 1109.0000, 'ºC'),
	(85837, 111, '2015-03-01 00:07:20.000000', 'temperatura', 107.0000, 'ºC'),
	(85838, 111, '2015-03-01 00:07:21.000000', 'temperatura', 809.0000, 'ºC'),
	(85839, 111, '2015-03-01 00:07:22.000000', 'temperatura', 123.0000, 'ºC'),
	(85840, 111, '2015-03-01 00:07:23.000000', 'temperatura', 587.0000, 'ºC'),
	(85841, 111, '2015-03-01 00:07:24.000000', 'temperatura', 167.0000, 'ºC'),
	(85842, 111, '2015-03-01 00:07:25.000000', 'temperatura', 276.0000, 'ºC'),
	(85843, 111, '2015-03-01 00:07:26.000000', 'temperatura', 879.0000, 'ºC'),
	(85844, 111, '2015-03-01 00:07:27.000000', 'temperatura', 1169.0000, 'ºC'),
	(85845, 111, '2015-03-01 00:07:28.000000', 'temperatura', 807.0000, 'ºC'),
	(85846, 111, '2015-03-01 00:07:29.000000', 'temperatura', 529.0000, 'ºC'),
	(85847, 111, '2015-03-01 00:07:30.000000', 'temperatura', 226.0000, 'ºC'),
	(85848, 111, '2015-03-01 00:07:31.000000', 'temperatura', 744.0000, 'ºC'),
	(85849, 111, '2015-03-01 00:07:32.000000', 'temperatura', 640.0000, 'ºC'),
	(85850, 111, '2015-03-01 00:07:33.000000', 'temperatura', 971.0000, 'ºC'),
	(85851, 111, '2015-03-01 00:07:34.000000', 'temperatura', 536.0000, 'ºC'),
	(85852, 111, '2015-03-01 00:07:35.000000', 'temperatura', 969.0000, 'ºC'),
	(85853, 111, '2015-03-01 00:07:36.000000', 'temperatura', 834.0000, 'ºC'),
	(85854, 111, '2015-03-01 00:07:37.000000', 'temperatura', 63.0000, 'ºC'),
	(85855, 111, '2015-03-01 00:07:38.000000', 'temperatura', 214.0000, 'ºC'),
	(85856, 111, '2015-03-01 00:07:39.000000', 'temperatura', 883.0000, 'ºC'),
	(85857, 111, '2015-03-01 00:07:40.000000', 'temperatura', 174.0000, 'ºC'),
	(85858, 111, '2015-03-01 00:07:41.000000', 'temperatura', 619.0000, 'ºC'),
	(85859, 111, '2015-03-01 00:07:42.000000', 'temperatura', 173.0000, 'ºC'),
	(85860, 111, '2015-03-01 00:07:43.000000', 'temperatura', 209.0000, 'ºC'),
	(85861, 111, '2015-03-01 00:07:44.000000', 'temperatura', 526.0000, 'ºC'),
	(85862, 111, '2015-03-01 00:07:45.000000', 'temperatura', 802.0000, 'ºC'),
	(85863, 111, '2015-03-01 00:07:46.000000', 'temperatura', 36.0000, 'ºC'),
	(85864, 111, '2015-03-01 00:07:47.000000', 'temperatura', 172.0000, 'ºC'),
	(85865, 111, '2015-03-01 00:07:48.000000', 'temperatura', 752.0000, 'ºC'),
	(85866, 111, '2015-03-01 00:07:49.000000', 'temperatura', 844.0000, 'ºC'),
	(85867, 111, '2015-03-01 00:07:50.000000', 'temperatura', 765.0000, 'ºC'),
	(85868, 111, '2015-03-01 00:07:51.000000', 'temperatura', 96.0000, 'ºC'),
	(85869, 111, '2015-03-01 00:07:52.000000', 'temperatura', 582.0000, 'ºC'),
	(85870, 111, '2015-03-01 00:07:53.000000', 'temperatura', 223.0000, 'ºC'),
	(85871, 111, '2015-03-01 00:07:54.000000', 'temperatura', 571.0000, 'ºC'),
	(85872, 111, '2015-03-01 00:07:55.000000', 'temperatura', 987.0000, 'ºC'),
	(85873, 111, '2015-03-01 00:07:56.000000', 'temperatura', 823.0000, 'ºC'),
	(85874, 111, '2015-03-01 00:07:57.000000', 'temperatura', 1154.0000, 'ºC'),
	(85875, 111, '2015-03-01 00:07:58.000000', 'temperatura', 901.0000, 'ºC'),
	(85876, 111, '2015-03-01 00:07:59.000000', 'temperatura', 1042.0000, 'ºC'),
	(85877, 111, '2015-03-01 00:08:00.000000', 'temperatura', 107.0000, 'ºC'),
	(85878, 111, '2015-03-01 00:08:01.000000', 'temperatura', 1010.0000, 'ºC'),
	(85879, 111, '2015-03-01 00:08:02.000000', 'temperatura', 1129.0000, 'ºC'),
	(85880, 111, '2015-03-01 00:08:03.000000', 'temperatura', 217.0000, 'ºC'),
	(85881, 111, '2015-03-01 00:08:04.000000', 'temperatura', 99.0000, 'ºC'),
	(85882, 111, '2015-03-01 00:08:05.000000', 'temperatura', 1045.0000, 'ºC'),
	(85883, 111, '2015-03-01 00:08:06.000000', 'temperatura', 127.0000, 'ºC'),
	(85884, 111, '2015-03-01 00:08:07.000000', 'temperatura', 1102.0000, 'ºC'),
	(85885, 111, '2015-03-01 00:08:08.000000', 'temperatura', 327.0000, 'ºC'),
	(85886, 111, '2015-03-01 00:08:09.000000', 'temperatura', 730.0000, 'ºC'),
	(85887, 111, '2015-03-01 00:08:10.000000', 'temperatura', 272.0000, 'ºC'),
	(85888, 111, '2015-03-01 00:08:11.000000', 'temperatura', 369.0000, 'ºC'),
	(85889, 111, '2015-03-01 00:08:12.000000', 'temperatura', 1030.0000, 'ºC'),
	(85890, 111, '2015-03-01 00:08:13.000000', 'temperatura', 444.0000, 'ºC'),
	(85891, 111, '2015-03-01 00:08:14.000000', 'temperatura', 328.0000, 'ºC'),
	(85892, 111, '2015-03-01 00:08:15.000000', 'temperatura', 311.0000, 'ºC'),
	(85893, 111, '2015-03-01 00:08:16.000000', 'temperatura', 571.0000, 'ºC'),
	(85894, 111, '2015-03-01 00:08:17.000000', 'temperatura', 721.0000, 'ºC'),
	(85895, 111, '2015-03-01 00:08:18.000000', 'temperatura', 695.0000, 'ºC'),
	(85896, 111, '2015-03-01 00:08:19.000000', 'temperatura', 113.0000, 'ºC'),
	(85897, 111, '2015-03-01 00:08:20.000000', 'temperatura', 879.0000, 'ºC'),
	(85898, 111, '2015-03-01 00:08:21.000000', 'temperatura', 456.0000, 'ºC'),
	(85899, 111, '2015-03-01 00:08:22.000000', 'temperatura', 843.0000, 'ºC'),
	(85900, 111, '2015-03-01 00:08:23.000000', 'temperatura', 450.0000, 'ºC'),
	(85901, 111, '2015-03-01 00:08:24.000000', 'temperatura', 919.0000, 'ºC'),
	(85902, 111, '2015-03-01 00:08:25.000000', 'temperatura', 845.0000, 'ºC'),
	(85903, 111, '2015-03-01 00:08:26.000000', 'temperatura', 269.0000, 'ºC'),
	(85904, 111, '2015-03-01 00:08:27.000000', 'temperatura', 9.0000, 'ºC'),
	(85905, 111, '2015-03-01 00:08:28.000000', 'temperatura', 439.0000, 'ºC'),
	(85906, 111, '2015-03-01 00:08:29.000000', 'temperatura', 969.0000, 'ºC'),
	(85907, 111, '2015-03-01 00:08:30.000000', 'temperatura', 1130.0000, 'ºC'),
	(85908, 111, '2015-03-01 00:08:31.000000', 'temperatura', 343.0000, 'ºC'),
	(85909, 111, '2015-03-01 00:08:32.000000', 'temperatura', 725.0000, 'ºC'),
	(85910, 111, '2015-03-01 00:08:33.000000', 'temperatura', 195.0000, 'ºC'),
	(85911, 111, '2015-03-01 00:08:34.000000', 'temperatura', 2.0000, 'ºC'),
	(85912, 111, '2015-03-01 00:08:35.000000', 'temperatura', 624.0000, 'ºC'),
	(85913, 111, '2015-03-01 00:08:36.000000', 'temperatura', 715.0000, 'ºC'),
	(85914, 111, '2015-03-01 00:08:37.000000', 'temperatura', 503.0000, 'ºC'),
	(85915, 111, '2015-03-01 00:08:38.000000', 'temperatura', 373.0000, 'ºC'),
	(85916, 111, '2015-03-01 00:08:39.000000', 'temperatura', 353.0000, 'ºC'),
	(85917, 111, '2015-03-01 00:08:40.000000', 'temperatura', 649.0000, 'ºC'),
	(85918, 111, '2015-03-01 00:08:41.000000', 'temperatura', 987.0000, 'ºC'),
	(85919, 111, '2015-03-01 00:08:42.000000', 'temperatura', 588.0000, 'ºC'),
	(85920, 111, '2015-03-01 00:08:43.000000', 'temperatura', 1180.0000, 'ºC'),
	(85921, 111, '2015-03-01 00:08:44.000000', 'temperatura', 534.0000, 'ºC'),
	(85922, 111, '2015-03-01 00:08:45.000000', 'temperatura', 334.0000, 'ºC'),
	(85923, 111, '2015-03-01 00:08:46.000000', 'temperatura', 65.0000, 'ºC'),
	(85924, 111, '2015-03-01 00:08:47.000000', 'temperatura', 526.0000, 'ºC'),
	(85925, 111, '2015-03-01 00:08:48.000000', 'temperatura', 36.0000, 'ºC'),
	(85926, 111, '2015-03-01 00:08:49.000000', 'temperatura', 1003.0000, 'ºC'),
	(85927, 111, '2015-03-01 00:08:50.000000', 'temperatura', 105.0000, 'ºC'),
	(85928, 111, '2015-03-01 00:08:51.000000', 'temperatura', 1119.0000, 'ºC'),
	(85929, 111, '2015-03-01 00:08:52.000000', 'temperatura', 478.0000, 'ºC'),
	(85930, 111, '2015-03-01 00:08:53.000000', 'temperatura', 235.0000, 'ºC'),
	(85931, 111, '2015-03-01 00:08:54.000000', 'temperatura', 943.0000, 'ºC'),
	(85932, 111, '2015-03-01 00:08:55.000000', 'temperatura', 408.0000, 'ºC'),
	(85933, 111, '2015-03-01 00:08:56.000000', 'temperatura', 414.0000, 'ºC'),
	(85934, 111, '2015-03-01 00:08:57.000000', 'temperatura', 844.0000, 'ºC'),
	(85935, 111, '2015-03-01 00:08:58.000000', 'temperatura', 579.0000, 'ºC'),
	(85936, 111, '2015-03-01 00:08:59.000000', 'temperatura', 363.0000, 'ºC'),
	(85937, 111, '2015-03-01 00:09:00.000000', 'temperatura', 78.0000, 'ºC'),
	(85938, 111, '2015-03-01 00:09:01.000000', 'temperatura', 503.0000, 'ºC'),
	(85939, 111, '2015-03-01 00:09:02.000000', 'temperatura', 1080.0000, 'ºC'),
	(85940, 111, '2015-03-01 00:09:03.000000', 'temperatura', 291.0000, 'ºC'),
	(85941, 111, '2015-03-01 00:09:04.000000', 'temperatura', 615.0000, 'ºC'),
	(85942, 111, '2015-03-01 00:09:05.000000', 'temperatura', 1003.0000, 'ºC'),
	(85943, 111, '2015-03-01 00:09:06.000000', 'temperatura', 769.0000, 'ºC'),
	(85944, 111, '2015-03-01 00:09:07.000000', 'temperatura', 839.0000, 'ºC'),
	(85945, 111, '2015-03-01 00:09:08.000000', 'temperatura', 686.0000, 'ºC'),
	(85946, 111, '2015-03-01 00:09:09.000000', 'temperatura', 916.0000, 'ºC'),
	(85947, 111, '2015-03-01 00:09:10.000000', 'temperatura', 120.0000, 'ºC'),
	(85948, 111, '2015-03-01 00:09:11.000000', 'temperatura', 255.0000, 'ºC'),
	(85949, 111, '2015-03-01 00:09:12.000000', 'temperatura', 916.0000, 'ºC'),
	(85950, 111, '2015-03-01 00:09:13.000000', 'temperatura', 216.0000, 'ºC'),
	(85951, 111, '2015-03-01 00:09:14.000000', 'temperatura', 733.0000, 'ºC'),
	(85952, 111, '2015-03-01 00:09:15.000000', 'temperatura', 616.0000, 'ºC'),
	(85953, 111, '2015-03-01 00:09:16.000000', 'temperatura', 880.0000, 'ºC'),
	(85954, 111, '2015-03-01 00:09:17.000000', 'temperatura', 155.0000, 'ºC'),
	(85955, 111, '2015-03-01 00:09:18.000000', 'temperatura', 534.0000, 'ºC'),
	(85956, 111, '2015-03-01 00:09:19.000000', 'temperatura', 1005.0000, 'ºC'),
	(85957, 111, '2015-03-01 00:09:20.000000', 'temperatura', 1022.0000, 'ºC'),
	(85958, 111, '2015-03-01 00:09:21.000000', 'temperatura', 898.0000, 'ºC'),
	(85959, 111, '2015-03-01 00:09:22.000000', 'temperatura', 223.0000, 'ºC'),
	(85960, 111, '2015-03-01 00:09:23.000000', 'temperatura', 820.0000, 'ºC'),
	(85961, 111, '2015-03-01 00:09:24.000000', 'temperatura', 1033.0000, 'ºC'),
	(85962, 111, '2015-03-01 00:09:25.000000', 'temperatura', 306.0000, 'ºC'),
	(85963, 111, '2015-03-01 00:09:26.000000', 'temperatura', 830.0000, 'ºC'),
	(85964, 111, '2015-03-01 00:09:27.000000', 'temperatura', 834.0000, 'ºC'),
	(85965, 111, '2015-03-01 00:09:28.000000', 'temperatura', 481.0000, 'ºC'),
	(85966, 111, '2015-03-01 00:09:29.000000', 'temperatura', 1102.0000, 'ºC'),
	(85967, 111, '2015-03-01 00:09:30.000000', 'temperatura', 470.0000, 'ºC'),
	(85968, 111, '2015-03-01 00:09:31.000000', 'temperatura', 243.0000, 'ºC'),
	(85969, 111, '2015-03-01 00:09:32.000000', 'temperatura', 1004.0000, 'ºC'),
	(85970, 111, '2015-03-01 00:09:33.000000', 'temperatura', 694.0000, 'ºC'),
	(85971, 111, '2015-03-01 00:09:34.000000', 'temperatura', 459.0000, 'ºC'),
	(85972, 111, '2015-03-01 00:09:35.000000', 'temperatura', 211.0000, 'ºC'),
	(85973, 111, '2015-03-01 00:09:36.000000', 'temperatura', 880.0000, 'ºC'),
	(85974, 111, '2015-03-01 00:09:37.000000', 'temperatura', 168.0000, 'ºC'),
	(85975, 111, '2015-03-01 00:09:38.000000', 'temperatura', 599.0000, 'ºC'),
	(85976, 111, '2015-03-01 00:09:39.000000', 'temperatura', 93.0000, 'ºC'),
	(85977, 111, '2015-03-01 00:09:40.000000', 'temperatura', 1068.0000, 'ºC'),
	(85978, 111, '2015-03-01 00:09:41.000000', 'temperatura', 263.0000, 'ºC'),
	(85979, 111, '2015-03-01 00:09:42.000000', 'temperatura', 512.0000, 'ºC'),
	(85980, 111, '2015-03-01 00:09:43.000000', 'temperatura', 572.0000, 'ºC'),
	(85981, 111, '2015-03-01 00:09:44.000000', 'temperatura', 125.0000, 'ºC'),
	(85982, 111, '2015-03-01 00:09:45.000000', 'temperatura', 109.0000, 'ºC'),
	(85983, 111, '2015-03-01 00:09:46.000000', 'temperatura', 168.0000, 'ºC'),
	(85984, 111, '2015-03-01 00:09:47.000000', 'temperatura', 516.0000, 'ºC'),
	(85985, 111, '2015-03-01 00:09:48.000000', 'temperatura', 876.0000, 'ºC'),
	(85986, 111, '2015-03-01 00:09:49.000000', 'temperatura', 432.0000, 'ºC'),
	(85987, 111, '2015-03-01 00:09:50.000000', 'temperatura', 732.0000, 'ºC'),
	(85988, 111, '2015-03-01 00:09:51.000000', 'temperatura', 1163.0000, 'ºC'),
	(85989, 111, '2015-03-01 00:09:52.000000', 'temperatura', 21.0000, 'ºC'),
	(85990, 111, '2015-03-01 00:09:53.000000', 'temperatura', 216.0000, 'ºC'),
	(85991, 111, '2015-03-01 00:09:54.000000', 'temperatura', 1017.0000, 'ºC'),
	(85992, 111, '2015-03-01 00:09:55.000000', 'temperatura', 836.0000, 'ºC'),
	(85993, 111, '2015-03-01 00:09:56.000000', 'temperatura', 1133.0000, 'ºC'),
	(85994, 111, '2015-03-01 00:09:57.000000', 'temperatura', 755.0000, 'ºC'),
	(85995, 111, '2015-03-01 00:09:58.000000', 'temperatura', 377.0000, 'ºC'),
	(85996, 111, '2015-03-01 00:09:59.000000', 'temperatura', 822.0000, 'ºC'),
	(85997, 111, '2015-03-01 00:10:00.000000', 'temperatura', 581.0000, 'ºC'),
	(85998, 111, '2015-03-01 00:10:01.000000', 'temperatura', 437.0000, 'ºC'),
	(85999, 111, '2015-03-01 00:10:02.000000', 'temperatura', 441.0000, 'ºC'),
	(86000, 111, '2015-03-01 00:10:03.000000', 'temperatura', 896.0000, 'ºC'),
	(86001, 111, '2015-03-01 00:10:04.000000', 'temperatura', 756.0000, 'ºC'),
	(86002, 111, '2015-03-01 00:10:05.000000', 'temperatura', 1094.0000, 'ºC'),
	(86003, 111, '2015-03-01 00:10:06.000000', 'temperatura', 803.0000, 'ºC'),
	(86004, 111, '2015-03-01 00:10:07.000000', 'temperatura', 733.0000, 'ºC'),
	(86005, 111, '2015-03-01 00:10:08.000000', 'temperatura', 58.0000, 'ºC'),
	(86006, 111, '2015-03-01 00:10:09.000000', 'temperatura', 492.0000, 'ºC'),
	(86007, 111, '2015-03-01 00:10:10.000000', 'temperatura', 1084.0000, 'ºC'),
	(86008, 111, '2015-03-01 00:10:11.000000', 'temperatura', 344.0000, 'ºC'),
	(86009, 111, '2015-03-01 00:10:12.000000', 'temperatura', 872.0000, 'ºC'),
	(86010, 111, '2015-03-01 00:10:13.000000', 'temperatura', 925.0000, 'ºC'),
	(86011, 111, '2015-03-01 00:10:14.000000', 'temperatura', 811.0000, 'ºC'),
	(86012, 111, '2015-03-01 00:10:15.000000', 'temperatura', 81.0000, 'ºC'),
	(86013, 111, '2015-03-01 00:10:16.000000', 'temperatura', 371.0000, 'ºC'),
	(86014, 111, '2015-03-01 00:10:17.000000', 'temperatura', 413.0000, 'ºC'),
	(86015, 111, '2015-03-01 00:10:18.000000', 'temperatura', 953.0000, 'ºC'),
	(86016, 111, '2015-03-01 00:10:19.000000', 'temperatura', 1128.0000, 'ºC'),
	(86017, 111, '2015-03-01 00:10:20.000000', 'temperatura', 379.0000, 'ºC'),
	(86018, 111, '2015-03-01 00:10:21.000000', 'temperatura', 914.0000, 'ºC'),
	(86019, 111, '2015-03-01 00:10:22.000000', 'temperatura', 1034.0000, 'ºC'),
	(86020, 111, '2015-03-01 00:10:23.000000', 'temperatura', 29.0000, 'ºC'),
	(86021, 111, '2015-03-01 00:10:24.000000', 'temperatura', 642.0000, 'ºC'),
	(86022, 111, '2015-03-01 00:10:25.000000', 'temperatura', 724.0000, 'ºC'),
	(86023, 111, '2015-03-01 00:10:26.000000', 'temperatura', 495.0000, 'ºC'),
	(86024, 111, '2015-03-01 00:10:27.000000', 'temperatura', 302.0000, 'ºC'),
	(86025, 111, '2015-03-01 00:10:28.000000', 'temperatura', 25.0000, 'ºC'),
	(86026, 111, '2015-03-01 00:10:29.000000', 'temperatura', 421.0000, 'ºC'),
	(86027, 111, '2015-03-01 00:10:30.000000', 'temperatura', 830.0000, 'ºC'),
	(86028, 111, '2015-03-01 00:10:31.000000', 'temperatura', 487.0000, 'ºC'),
	(86029, 111, '2015-03-01 00:10:32.000000', 'temperatura', 1144.0000, 'ºC'),
	(86030, 111, '2015-03-01 00:10:33.000000', 'temperatura', 660.0000, 'ºC'),
	(86031, 111, '2015-03-01 00:10:34.000000', 'temperatura', 1071.0000, 'ºC'),
	(86032, 111, '2015-03-01 00:10:35.000000', 'temperatura', 972.0000, 'ºC'),
	(86033, 111, '2015-03-01 00:10:36.000000', 'temperatura', 451.0000, 'ºC'),
	(86034, 111, '2015-03-01 00:10:37.000000', 'temperatura', 538.0000, 'ºC'),
	(86035, 111, '2015-03-01 00:10:38.000000', 'temperatura', 136.0000, 'ºC'),
	(86036, 111, '2015-03-01 00:10:39.000000', 'temperatura', 266.0000, 'ºC'),
	(86037, 111, '2015-03-01 00:10:40.000000', 'temperatura', 925.0000, 'ºC'),
	(86038, 111, '2015-03-01 00:10:41.000000', 'temperatura', 226.0000, 'ºC'),
	(86039, 111, '2015-03-01 00:10:42.000000', 'temperatura', 757.0000, 'ºC'),
	(86040, 111, '2015-03-01 00:10:43.000000', 'temperatura', 708.0000, 'ºC'),
	(86041, 111, '2015-03-01 00:10:44.000000', 'temperatura', 68.0000, 'ºC'),
	(86042, 111, '2015-03-01 00:10:45.000000', 'temperatura', 618.0000, 'ºC'),
	(86043, 111, '2015-03-01 00:10:46.000000', 'temperatura', 487.0000, 'ºC'),
	(86044, 111, '2015-03-01 00:10:47.000000', 'temperatura', 579.0000, 'ºC'),
	(86045, 111, '2015-03-01 00:10:48.000000', 'temperatura', 235.0000, 'ºC'),
	(86046, 111, '2015-03-01 00:10:49.000000', 'temperatura', 638.0000, 'ºC'),
	(86047, 111, '2015-03-01 00:10:50.000000', 'temperatura', 87.0000, 'ºC'),
	(86048, 111, '2015-03-01 00:10:51.000000', 'temperatura', 921.0000, 'ºC'),
	(86049, 111, '2015-03-01 00:10:52.000000', 'temperatura', 744.0000, 'ºC'),
	(86050, 111, '2015-03-01 00:10:53.000000', 'temperatura', 958.0000, 'ºC'),
	(86051, 111, '2015-03-01 00:10:54.000000', 'temperatura', 157.0000, 'ºC'),
	(86052, 111, '2015-03-01 00:10:55.000000', 'temperatura', 312.0000, 'ºC'),
	(86053, 111, '2015-03-01 00:10:56.000000', 'temperatura', 1090.0000, 'ºC'),
	(86054, 111, '2015-03-01 00:10:57.000000', 'temperatura', 913.0000, 'ºC'),
	(86055, 111, '2015-03-01 00:10:58.000000', 'temperatura', 98.0000, 'ºC'),
	(86056, 111, '2015-03-01 00:10:59.000000', 'temperatura', 149.0000, 'ºC'),
	(86057, 111, '2015-03-01 00:11:00.000000', 'temperatura', 451.0000, 'ºC'),
	(86058, 111, '2015-03-01 00:11:01.000000', 'temperatura', 608.0000, 'ºC'),
	(86059, 111, '2015-03-01 00:11:02.000000', 'temperatura', 488.0000, 'ºC'),
	(86060, 111, '2015-03-01 00:11:03.000000', 'temperatura', 618.0000, 'ºC'),
	(86061, 111, '2015-03-01 00:11:04.000000', 'temperatura', 424.0000, 'ºC'),
	(86062, 111, '2015-03-01 00:11:05.000000', 'temperatura', 267.0000, 'ºC'),
	(86063, 111, '2015-03-01 00:11:06.000000', 'temperatura', 63.0000, 'ºC'),
	(86064, 111, '2015-03-01 00:11:07.000000', 'temperatura', 715.0000, 'ºC'),
	(86065, 111, '2015-03-01 00:11:08.000000', 'temperatura', 989.0000, 'ºC'),
	(86066, 111, '2015-03-01 00:11:09.000000', 'temperatura', 398.0000, 'ºC'),
	(86067, 111, '2015-03-01 00:11:10.000000', 'temperatura', 224.0000, 'ºC'),
	(86068, 111, '2015-03-01 00:11:11.000000', 'temperatura', 1125.0000, 'ºC'),
	(86069, 111, '2015-03-01 00:11:12.000000', 'temperatura', 156.0000, 'ºC'),
	(86070, 111, '2015-03-01 00:11:13.000000', 'temperatura', 1004.0000, 'ºC'),
	(86071, 111, '2015-03-01 00:11:14.000000', 'temperatura', 953.0000, 'ºC'),
	(86072, 111, '2015-03-01 00:11:15.000000', 'temperatura', 555.0000, 'ºC'),
	(86073, 111, '2015-03-01 00:11:16.000000', 'temperatura', 1116.0000, 'ºC'),
	(86074, 111, '2015-03-01 00:11:17.000000', 'temperatura', 315.0000, 'ºC'),
	(86075, 111, '2015-03-01 00:11:18.000000', 'temperatura', 627.0000, 'ºC'),
	(86076, 111, '2015-03-01 00:11:19.000000', 'temperatura', 991.0000, 'ºC'),
	(86077, 111, '2015-03-01 00:11:20.000000', 'temperatura', 676.0000, 'ºC'),
	(86078, 111, '2015-03-01 00:11:21.000000', 'temperatura', 407.0000, 'ºC'),
	(86079, 111, '2015-03-01 00:11:22.000000', 'temperatura', 7.0000, 'ºC'),
	(86080, 111, '2015-03-01 00:11:23.000000', 'temperatura', 14.0000, 'ºC'),
	(86081, 111, '2015-03-01 00:11:24.000000', 'temperatura', 52.0000, 'ºC'),
	(86082, 111, '2015-03-01 00:11:25.000000', 'temperatura', 217.0000, 'ºC'),
	(86083, 111, '2015-03-01 00:11:26.000000', 'temperatura', 928.0000, 'ºC'),
	(86084, 111, '2015-03-01 00:11:27.000000', 'temperatura', 391.0000, 'ºC'),
	(86085, 111, '2015-03-01 00:11:28.000000', 'temperatura', 371.0000, 'ºC'),
	(86086, 111, '2015-03-01 00:11:29.000000', 'temperatura', 681.0000, 'ºC'),
	(86087, 111, '2015-03-01 00:11:30.000000', 'temperatura', 1093.0000, 'ºC'),
	(86088, 111, '2015-03-01 00:11:31.000000', 'temperatura', 1022.0000, 'ºC'),
	(86089, 111, '2015-03-01 00:11:32.000000', 'temperatura', 630.0000, 'ºC'),
	(86090, 111, '2015-03-01 00:11:33.000000', 'temperatura', 88.0000, 'ºC'),
	(86091, 111, '2015-03-01 00:11:34.000000', 'temperatura', 949.0000, 'ºC'),
	(86092, 111, '2015-03-01 00:11:35.000000', 'temperatura', 881.0000, 'ºC'),
	(86093, 111, '2015-03-01 00:11:36.000000', 'temperatura', 359.0000, 'ºC'),
	(86094, 111, '2015-03-01 00:11:37.000000', 'temperatura', 352.0000, 'ºC'),
	(86095, 111, '2015-03-01 00:11:38.000000', 'temperatura', 685.0000, 'ºC'),
	(86096, 111, '2015-03-01 00:11:39.000000', 'temperatura', 1170.0000, 'ºC'),
	(86097, 111, '2015-03-01 00:11:40.000000', 'temperatura', 192.0000, 'ºC'),
	(86098, 111, '2015-03-01 00:11:41.000000', 'temperatura', 1054.0000, 'ºC'),
	(86099, 111, '2015-03-01 00:11:42.000000', 'temperatura', 1094.0000, 'ºC'),
	(86100, 111, '2015-03-01 00:11:43.000000', 'temperatura', 1108.0000, 'ºC'),
	(86101, 111, '2015-03-01 00:11:44.000000', 'temperatura', 1060.0000, 'ºC'),
	(86102, 111, '2015-03-01 00:11:45.000000', 'temperatura', 776.0000, 'ºC'),
	(86103, 111, '2015-03-01 00:11:46.000000', 'temperatura', 699.0000, 'ºC'),
	(86104, 111, '2015-03-01 00:11:47.000000', 'temperatura', 1167.0000, 'ºC'),
	(86105, 111, '2015-03-01 00:11:48.000000', 'temperatura', 139.0000, 'ºC'),
	(86106, 111, '2015-03-01 00:11:49.000000', 'temperatura', 796.0000, 'ºC'),
	(86107, 111, '2015-03-01 00:11:50.000000', 'temperatura', 1162.0000, 'ºC'),
	(86108, 111, '2015-03-01 00:11:51.000000', 'temperatura', 1024.0000, 'ºC'),
	(86109, 111, '2015-03-01 00:11:52.000000', 'temperatura', 433.0000, 'ºC'),
	(86110, 111, '2015-03-01 00:11:53.000000', 'temperatura', 293.0000, 'ºC'),
	(86111, 111, '2015-03-01 00:11:54.000000', 'temperatura', 167.0000, 'ºC'),
	(86112, 111, '2015-03-01 00:11:55.000000', 'temperatura', 1158.0000, 'ºC'),
	(86113, 111, '2015-03-01 00:11:56.000000', 'temperatura', 490.0000, 'ºC'),
	(86114, 111, '2015-03-01 00:11:57.000000', 'temperatura', 178.0000, 'ºC'),
	(86115, 111, '2015-03-01 00:11:58.000000', 'temperatura', 617.0000, 'ºC'),
	(86116, 111, '2015-03-01 00:11:59.000000', 'temperatura', 153.0000, 'ºC'),
	(86117, 111, '2015-03-01 00:12:00.000000', 'temperatura', 113.0000, 'ºC'),
	(86118, 111, '2015-03-01 00:12:01.000000', 'temperatura', 106.0000, 'ºC'),
	(86119, 111, '2015-03-01 00:12:02.000000', 'temperatura', 195.0000, 'ºC'),
	(86120, 111, '2015-03-01 00:12:03.000000', 'temperatura', 654.0000, 'ºC'),
	(86121, 111, '2015-03-01 00:12:04.000000', 'temperatura', 286.0000, 'ºC'),
	(86122, 111, '2015-03-01 00:12:05.000000', 'temperatura', 667.0000, 'ºC'),
	(86123, 111, '2015-03-01 00:12:06.000000', 'temperatura', 80.0000, 'ºC'),
	(86124, 111, '2015-03-01 00:12:07.000000', 'temperatura', 798.0000, 'ºC'),
	(86125, 111, '2015-03-01 00:12:08.000000', 'temperatura', 151.0000, 'ºC'),
	(86126, 111, '2015-03-01 00:12:09.000000', 'temperatura', 760.0000, 'ºC'),
	(86127, 111, '2015-03-01 00:12:10.000000', 'temperatura', 950.0000, 'ºC'),
	(86128, 111, '2015-03-01 00:12:11.000000', 'temperatura', 69.0000, 'ºC'),
	(86129, 111, '2015-03-01 00:12:12.000000', 'temperatura', 1097.0000, 'ºC'),
	(86130, 111, '2015-03-01 00:12:13.000000', 'temperatura', 480.0000, 'ºC'),
	(86131, 111, '2015-03-01 00:12:14.000000', 'temperatura', 306.0000, 'ºC'),
	(86132, 111, '2015-03-01 00:12:15.000000', 'temperatura', 91.0000, 'ºC'),
	(86133, 111, '2015-03-01 00:12:16.000000', 'temperatura', 739.0000, 'ºC'),
	(86134, 111, '2015-03-01 00:12:17.000000', 'temperatura', 1023.0000, 'ºC'),
	(86135, 111, '2015-03-01 00:12:18.000000', 'temperatura', 498.0000, 'ºC'),
	(86136, 111, '2015-03-01 00:12:19.000000', 'temperatura', 621.0000, 'ºC'),
	(86137, 111, '2015-03-01 00:12:20.000000', 'temperatura', 413.0000, 'ºC'),
	(86138, 111, '2015-03-01 00:12:21.000000', 'temperatura', 203.0000, 'ºC'),
	(86139, 111, '2015-03-01 00:12:22.000000', 'temperatura', 976.0000, 'ºC'),
	(86140, 111, '2015-03-01 00:12:23.000000', 'temperatura', 671.0000, 'ºC'),
	(86141, 111, '2015-03-01 00:12:24.000000', 'temperatura', 429.0000, 'ºC'),
	(86142, 111, '2015-03-01 00:12:25.000000', 'temperatura', 133.0000, 'ºC'),
	(86143, 111, '2015-03-01 00:12:26.000000', 'temperatura', 576.0000, 'ºC'),
	(86144, 111, '2015-03-01 00:12:27.000000', 'temperatura', 83.0000, 'ºC'),
	(86145, 111, '2015-03-01 00:12:28.000000', 'temperatura', 1089.0000, 'ºC'),
	(86146, 111, '2015-03-01 00:12:29.000000', 'temperatura', 394.0000, 'ºC'),
	(86147, 111, '2015-03-01 00:12:30.000000', 'temperatura', 1103.0000, 'ºC'),
	(86148, 111, '2015-03-01 00:12:31.000000', 'temperatura', 734.0000, 'ºC'),
	(86149, 111, '2015-03-01 00:12:32.000000', 'temperatura', 364.0000, 'ºC'),
	(86150, 111, '2015-03-01 00:12:33.000000', 'temperatura', 817.0000, 'ºC'),
	(86151, 111, '2015-03-01 00:12:34.000000', 'temperatura', 592.0000, 'ºC'),
	(86152, 111, '2015-03-01 00:12:35.000000', 'temperatura', 509.0000, 'ºC'),
	(86153, 111, '2015-03-01 00:12:36.000000', 'temperatura', 769.0000, 'ºC'),
	(86154, 111, '2015-03-01 00:12:37.000000', 'temperatura', 1120.0000, 'ºC'),
	(86155, 111, '2015-03-01 00:12:38.000000', 'temperatura', 893.0000, 'ºC'),
	(86156, 111, '2015-03-01 00:12:39.000000', 'temperatura', 1107.0000, 'ºC'),
	(86157, 111, '2015-03-01 00:12:40.000000', 'temperatura', 456.0000, 'ºC'),
	(86158, 111, '2015-03-01 00:12:41.000000', 'temperatura', 158.0000, 'ºC'),
	(86159, 111, '2015-03-01 00:12:42.000000', 'temperatura', 625.0000, 'ºC'),
	(86160, 111, '2015-03-01 00:12:43.000000', 'temperatura', 248.0000, 'ºC'),
	(86161, 111, '2015-03-01 00:12:44.000000', 'temperatura', 569.0000, 'ºC'),
	(86162, 111, '2015-03-01 00:12:45.000000', 'temperatura', 898.0000, 'ºC'),
	(86163, 111, '2015-03-01 00:12:46.000000', 'temperatura', 386.0000, 'ºC'),
	(86164, 111, '2015-03-01 00:12:47.000000', 'temperatura', 435.0000, 'ºC'),
	(86165, 111, '2015-03-01 00:12:48.000000', 'temperatura', 1017.0000, 'ºC'),
	(86166, 111, '2015-03-01 00:12:49.000000', 'temperatura', 181.0000, 'ºC'),
	(86167, 111, '2015-03-01 00:12:50.000000', 'temperatura', 256.0000, 'ºC'),
	(86168, 111, '2015-03-01 00:12:51.000000', 'temperatura', 735.0000, 'ºC'),
	(86169, 111, '2015-03-01 00:12:52.000000', 'temperatura', 510.0000, 'ºC'),
	(86170, 111, '2015-03-01 00:12:53.000000', 'temperatura', 346.0000, 'ºC'),
	(86171, 111, '2015-03-01 00:12:54.000000', 'temperatura', 200.0000, 'ºC'),
	(86172, 111, '2015-03-01 00:12:55.000000', 'temperatura', 1162.0000, 'ºC'),
	(86173, 111, '2015-03-01 00:12:56.000000', 'temperatura', 411.0000, 'ºC'),
	(86174, 111, '2015-03-01 00:12:57.000000', 'temperatura', 969.0000, 'ºC'),
	(86175, 111, '2015-03-01 00:12:58.000000', 'temperatura', 15.0000, 'ºC'),
	(86176, 111, '2015-03-01 00:12:59.000000', 'temperatura', 766.0000, 'ºC'),
	(86177, 111, '2015-03-01 00:13:00.000000', 'temperatura', 185.0000, 'ºC'),
	(86178, 111, '2015-03-01 00:13:01.000000', 'temperatura', 1027.0000, 'ºC'),
	(86179, 111, '2015-03-01 00:13:02.000000', 'temperatura', 982.0000, 'ºC'),
	(86180, 111, '2015-03-01 00:13:03.000000', 'temperatura', 628.0000, 'ºC'),
	(86181, 111, '2015-03-01 00:13:04.000000', 'temperatura', 196.0000, 'ºC'),
	(86182, 111, '2015-03-01 00:13:05.000000', 'temperatura', 294.0000, 'ºC'),
	(86183, 111, '2015-03-01 00:13:06.000000', 'temperatura', 886.0000, 'ºC'),
	(86184, 111, '2015-03-01 00:13:07.000000', 'temperatura', 1145.0000, 'ºC'),
	(86185, 111, '2015-03-01 00:13:08.000000', 'temperatura', 670.0000, 'ºC'),
	(86186, 111, '2015-03-01 00:13:09.000000', 'temperatura', 1115.0000, 'ºC'),
	(86187, 111, '2015-03-01 00:13:10.000000', 'temperatura', 1166.0000, 'ºC'),
	(86188, 111, '2015-03-01 00:13:11.000000', 'temperatura', 84.0000, 'ºC'),
	(86189, 111, '2015-03-01 00:13:12.000000', 'temperatura', 521.0000, 'ºC'),
	(86190, 111, '2015-03-01 00:13:13.000000', 'temperatura', 1157.0000, 'ºC'),
	(86191, 111, '2015-03-01 00:13:14.000000', 'temperatura', 620.0000, 'ºC'),
	(86192, 111, '2015-03-01 00:13:15.000000', 'temperatura', 829.0000, 'ºC'),
	(86193, 111, '2015-03-01 00:13:16.000000', 'temperatura', 1086.0000, 'ºC'),
	(86194, 111, '2015-03-01 00:13:17.000000', 'temperatura', 543.0000, 'ºC'),
	(86195, 111, '2015-03-01 00:13:18.000000', 'temperatura', 658.0000, 'ºC'),
	(86196, 111, '2015-03-01 00:13:19.000000', 'temperatura', 461.0000, 'ºC'),
	(86197, 111, '2015-03-01 00:13:20.000000', 'temperatura', 334.0000, 'ºC'),
	(86198, 111, '2015-03-01 00:13:21.000000', 'temperatura', 286.0000, 'ºC'),
	(86199, 111, '2015-03-01 00:13:22.000000', 'temperatura', 427.0000, 'ºC'),
	(86200, 111, '2015-03-01 00:13:23.000000', 'temperatura', 81.0000, 'ºC'),
	(86201, 111, '2015-03-01 00:13:24.000000', 'temperatura', 321.0000, 'ºC'),
	(86202, 111, '2015-03-01 00:13:25.000000', 'temperatura', 163.0000, 'ºC'),
	(86203, 111, '2015-03-01 00:13:26.000000', 'temperatura', 1052.0000, 'ºC'),
	(86204, 111, '2015-03-01 00:13:27.000000', 'temperatura', 1171.0000, 'ºC'),
	(86205, 111, '2015-03-01 00:13:28.000000', 'temperatura', 300.0000, 'ºC'),
	(86206, 111, '2015-03-01 00:13:29.000000', 'temperatura', 386.0000, 'ºC'),
	(86207, 111, '2015-03-01 00:13:30.000000', 'temperatura', 1030.0000, 'ºC'),
	(86208, 111, '2015-03-01 00:13:31.000000', 'temperatura', 395.0000, 'ºC'),
	(86209, 111, '2015-03-01 00:13:32.000000', 'temperatura', 86.0000, 'ºC'),
	(86210, 111, '2015-03-01 00:13:33.000000', 'temperatura', 445.0000, 'ºC'),
	(86211, 111, '2015-03-01 00:13:34.000000', 'temperatura', 766.0000, 'ºC'),
	(86212, 111, '2015-03-01 00:13:35.000000', 'temperatura', 96.0000, 'ºC'),
	(86213, 111, '2015-03-01 00:13:36.000000', 'temperatura', 585.0000, 'ºC'),
	(86214, 111, '2015-03-01 00:13:37.000000', 'temperatura', 235.0000, 'ºC'),
	(86215, 111, '2015-03-01 00:13:38.000000', 'temperatura', 623.0000, 'ºC'),
	(86216, 111, '2015-03-01 00:13:39.000000', 'temperatura', 7.0000, 'ºC'),
	(86217, 111, '2015-03-01 00:13:40.000000', 'temperatura', 570.0000, 'ºC'),
	(86218, 111, '2015-03-01 00:13:41.000000', 'temperatura', 427.0000, 'ºC'),
	(86219, 111, '2015-03-01 00:13:42.000000', 'temperatura', 427.0000, 'ºC'),
	(86220, 111, '2015-03-01 00:13:43.000000', 'temperatura', 854.0000, 'ºC'),
	(86221, 111, '2015-03-01 00:13:44.000000', 'temperatura', 588.0000, 'ºC'),
	(86222, 111, '2015-03-01 00:13:45.000000', 'temperatura', 380.0000, 'ºC'),
	(86223, 111, '2015-03-01 00:13:46.000000', 'temperatura', 134.0000, 'ºC'),
	(86224, 111, '2015-03-01 00:13:47.000000', 'temperatura', 734.0000, 'ºC'),
	(86225, 111, '2015-03-01 00:13:48.000000', 'temperatura', 865.0000, 'ºC'),
	(86226, 111, '2015-03-01 00:13:49.000000', 'temperatura', 926.0000, 'ºC'),
	(86227, 111, '2015-03-01 00:13:50.000000', 'temperatura', 833.0000, 'ºC'),
	(86228, 111, '2015-03-01 00:13:51.000000', 'temperatura', 188.0000, 'ºC'),
	(86229, 111, '2015-03-01 00:13:52.000000', 'temperatura', 841.0000, 'ºC'),
	(86230, 111, '2015-03-01 00:13:53.000000', 'temperatura', 41.0000, 'ºC'),
	(86231, 111, '2015-03-01 00:13:54.000000', 'temperatura', 84.0000, 'ºC'),
	(86232, 111, '2015-03-01 00:13:55.000000', 'temperatura', 296.0000, 'ºC'),
	(86233, 111, '2015-03-01 00:13:56.000000', 'temperatura', 29.0000, 'ºC'),
	(86234, 111, '2015-03-01 00:13:57.000000', 'temperatura', 459.0000, 'ºC'),
	(86235, 111, '2015-03-01 00:13:58.000000', 'temperatura', 1006.0000, 'ºC'),
	(86236, 111, '2015-03-01 00:13:59.000000', 'temperatura', 53.0000, 'ºC'),
	(86237, 111, '2015-03-01 00:14:00.000000', 'temperatura', 851.0000, 'ºC'),
	(86238, 111, '2015-03-01 00:14:01.000000', 'temperatura', 493.0000, 'ºC'),
	(86239, 111, '2015-03-01 00:14:02.000000', 'temperatura', 1113.0000, 'ºC'),
	(86240, 111, '2015-03-01 00:14:03.000000', 'temperatura', 487.0000, 'ºC'),
	(86241, 111, '2015-03-01 00:14:04.000000', 'temperatura', 298.0000, 'ºC'),
	(86242, 111, '2015-03-01 00:14:05.000000', 'temperatura', 27.0000, 'ºC'),
	(86243, 111, '2015-03-01 00:14:06.000000', 'temperatura', 441.0000, 'ºC'),
	(86244, 111, '2015-03-01 00:14:07.000000', 'temperatura', 927.0000, 'ºC'),
	(86245, 111, '2015-03-01 00:14:08.000000', 'temperatura', 912.0000, 'ºC'),
	(86246, 111, '2015-03-01 00:14:09.000000', 'temperatura', 578.0000, 'ºC'),
	(86247, 111, '2015-03-01 00:14:10.000000', 'temperatura', 154.0000, 'ºC'),
	(86248, 111, '2015-03-01 00:14:11.000000', 'temperatura', 236.0000, 'ºC'),
	(86249, 111, '2015-03-01 00:14:12.000000', 'temperatura', 718.0000, 'ºC'),
	(86250, 111, '2015-03-01 00:14:13.000000', 'temperatura', 483.0000, 'ºC'),
	(86251, 111, '2015-03-01 00:14:14.000000', 'temperatura', 262.0000, 'ºC'),
	(86252, 111, '2015-03-01 00:14:15.000000', 'temperatura', 1060.0000, 'ºC'),
	(86253, 111, '2015-03-01 00:14:16.000000', 'temperatura', 917.0000, 'ºC'),
	(86254, 111, '2015-03-01 00:14:17.000000', 'temperatura', 206.0000, 'ºC'),
	(86255, 111, '2015-03-01 00:14:18.000000', 'temperatura', 677.0000, 'ºC'),
	(86256, 111, '2015-03-01 00:14:19.000000', 'temperatura', 368.0000, 'ºC'),
	(86257, 111, '2015-03-01 00:14:20.000000', 'temperatura', 1011.0000, 'ºC'),
	(86258, 111, '2015-03-01 00:14:21.000000', 'temperatura', 352.0000, 'ºC'),
	(86259, 111, '2015-03-01 00:14:22.000000', 'temperatura', 1128.0000, 'ºC'),
	(86260, 111, '2015-03-01 00:14:23.000000', 'temperatura', 982.0000, 'ºC'),
	(86261, 111, '2015-03-01 00:14:24.000000', 'temperatura', 326.0000, 'ºC'),
	(86262, 111, '2015-03-01 00:14:25.000000', 'temperatura', 1085.0000, 'ºC'),
	(86263, 111, '2015-03-01 00:14:26.000000', 'temperatura', 849.0000, 'ºC'),
	(86264, 111, '2015-03-01 00:14:27.000000', 'temperatura', 988.0000, 'ºC'),
	(86265, 111, '2015-03-01 00:14:28.000000', 'temperatura', 1196.0000, 'ºC'),
	(86266, 111, '2015-03-01 00:14:29.000000', 'temperatura', 615.0000, 'ºC'),
	(86267, 111, '2015-03-01 00:14:30.000000', 'temperatura', 686.0000, 'ºC'),
	(86268, 111, '2015-03-01 00:14:31.000000', 'temperatura', 387.0000, 'ºC'),
	(86269, 111, '2015-03-01 00:14:32.000000', 'temperatura', 1079.0000, 'ºC'),
	(86270, 111, '2015-03-01 00:14:33.000000', 'temperatura', 633.0000, 'ºC'),
	(86271, 111, '2015-03-01 00:14:34.000000', 'temperatura', 1128.0000, 'ºC'),
	(86272, 111, '2015-03-01 00:14:35.000000', 'temperatura', 144.0000, 'ºC'),
	(86273, 111, '2015-03-01 00:14:36.000000', 'temperatura', 935.0000, 'ºC'),
	(86274, 111, '2015-03-01 00:14:37.000000', 'temperatura', 645.0000, 'ºC'),
	(86275, 111, '2015-03-01 00:14:38.000000', 'temperatura', 418.0000, 'ºC'),
	(86276, 111, '2015-03-01 00:14:39.000000', 'temperatura', 154.0000, 'ºC'),
	(86277, 111, '2015-03-01 00:14:40.000000', 'temperatura', 720.0000, 'ºC'),
	(86278, 111, '2015-03-01 00:14:41.000000', 'temperatura', 739.0000, 'ºC'),
	(86279, 111, '2015-03-01 00:14:42.000000', 'temperatura', 334.0000, 'ºC'),
	(86280, 111, '2015-03-01 00:14:43.000000', 'temperatura', 654.0000, 'ºC'),
	(86281, 111, '2015-03-01 00:14:44.000000', 'temperatura', 1067.0000, 'ºC'),
	(86282, 111, '2015-03-01 00:14:45.000000', 'temperatura', 975.0000, 'ºC'),
	(86283, 111, '2015-03-01 00:14:46.000000', 'temperatura', 475.0000, 'ºC'),
	(86284, 111, '2015-03-01 00:14:47.000000', 'temperatura', 649.0000, 'ºC'),
	(86285, 111, '2015-03-01 00:14:48.000000', 'temperatura', 622.0000, 'ºC'),
	(86286, 111, '2015-03-01 00:14:49.000000', 'temperatura', 1161.0000, 'ºC'),
	(86287, 111, '2015-03-01 00:14:50.000000', 'temperatura', 341.0000, 'ºC'),
	(86288, 111, '2015-03-01 00:14:51.000000', 'temperatura', 621.0000, 'ºC'),
	(86289, 111, '2015-03-01 00:14:52.000000', 'temperatura', 886.0000, 'ºC'),
	(86290, 111, '2015-03-01 00:14:53.000000', 'temperatura', 164.0000, 'ºC'),
	(86291, 111, '2015-03-01 00:14:54.000000', 'temperatura', 563.0000, 'ºC'),
	(86292, 111, '2015-03-01 00:14:55.000000', 'temperatura', 1122.0000, 'ºC'),
	(86293, 111, '2015-03-01 00:14:56.000000', 'temperatura', 323.0000, 'ºC'),
	(86294, 111, '2015-03-01 00:14:57.000000', 'temperatura', 650.0000, 'ºC'),
	(86295, 111, '2015-03-01 00:14:58.000000', 'temperatura', 1081.0000, 'ºC'),
	(86296, 111, '2015-03-01 00:14:59.000000', 'temperatura', 1054.0000, 'ºC'),
	(86297, 111, '2015-03-01 00:15:00.000000', 'temperatura', 831.0000, 'ºC'),
	(86298, 111, '2015-03-01 00:15:01.000000', 'temperatura', 990.0000, 'ºC'),
	(86299, 111, '2015-03-01 00:15:02.000000', 'temperatura', 59.0000, 'ºC'),
	(86300, 111, '2015-03-01 00:15:03.000000', 'temperatura', 925.0000, 'ºC'),
	(86301, 111, '2015-03-01 00:15:04.000000', 'temperatura', 848.0000, 'ºC'),
	(86302, 111, '2015-03-01 00:15:05.000000', 'temperatura', 264.0000, 'ºC'),
	(86303, 111, '2015-03-01 00:15:06.000000', 'temperatura', 1178.0000, 'ºC'),
	(86304, 111, '2015-03-01 00:15:07.000000', 'temperatura', 298.0000, 'ºC'),
	(86305, 111, '2015-03-01 00:15:08.000000', 'temperatura', 355.0000, 'ºC'),
	(86306, 111, '2015-03-01 00:15:09.000000', 'temperatura', 881.0000, 'ºC'),
	(86307, 111, '2015-03-01 00:15:10.000000', 'temperatura', 944.0000, 'ºC'),
	(86308, 111, '2015-03-01 00:15:11.000000', 'temperatura', 875.0000, 'ºC'),
	(86309, 111, '2015-03-01 00:15:12.000000', 'temperatura', 345.0000, 'ºC'),
	(86310, 111, '2015-03-01 00:15:13.000000', 'temperatura', 298.0000, 'ºC'),
	(86311, 111, '2015-03-01 00:15:14.000000', 'temperatura', 456.0000, 'ºC'),
	(86312, 111, '2015-03-01 00:15:15.000000', 'temperatura', 188.0000, 'ºC'),
	(86313, 111, '2015-03-01 00:15:16.000000', 'temperatura', 770.0000, 'ºC'),
	(86314, 111, '2015-03-01 00:15:17.000000', 'temperatura', 889.0000, 'ºC'),
	(86315, 111, '2015-03-01 00:15:18.000000', 'temperatura', 935.0000, 'ºC'),
	(86316, 111, '2015-03-01 00:15:19.000000', 'temperatura', 810.0000, 'ºC'),
	(86317, 111, '2015-03-01 00:15:20.000000', 'temperatura', 43.0000, 'ºC'),
	(86318, 111, '2015-03-01 00:15:21.000000', 'temperatura', 186.0000, 'ºC'),
	(86319, 111, '2015-03-01 00:15:22.000000', 'temperatura', 802.0000, 'ºC'),
	(86320, 111, '2015-03-01 00:15:23.000000', 'temperatura', 1054.0000, 'ºC'),
	(86321, 111, '2015-03-01 00:15:24.000000', 'temperatura', 462.0000, 'ºC'),
	(86322, 111, '2015-03-01 00:15:25.000000', 'temperatura', 351.0000, 'ºC'),
	(86323, 111, '2015-03-01 00:15:26.000000', 'temperatura', 368.0000, 'ºC'),
	(86324, 111, '2015-03-01 00:15:27.000000', 'temperatura', 788.0000, 'ºC'),
	(86325, 111, '2015-03-01 00:15:28.000000', 'temperatura', 437.0000, 'ºC'),
	(86326, 111, '2015-03-01 00:15:29.000000', 'temperatura', 1021.0000, 'ºC'),
	(86327, 111, '2015-03-01 00:15:30.000000', 'temperatura', 194.0000, 'ºC'),
	(86328, 111, '2015-03-01 00:15:31.000000', 'temperatura', 308.0000, 'ºC'),
	(86329, 111, '2015-03-01 00:15:32.000000', 'temperatura', 957.0000, 'ºC'),
	(86330, 111, '2015-03-01 00:15:33.000000', 'temperatura', 263.0000, 'ºC'),
	(86331, 111, '2015-03-01 00:15:34.000000', 'temperatura', 844.0000, 'ºC'),
	(86332, 111, '2015-03-01 00:15:35.000000', 'temperatura', 1031.0000, 'ºC'),
	(86333, 111, '2015-03-01 00:15:36.000000', 'temperatura', 222.0000, 'ºC'),
	(86334, 111, '2015-03-01 00:15:37.000000', 'temperatura', 420.0000, 'ºC'),
	(86335, 111, '2015-03-01 00:15:38.000000', 'temperatura', 233.0000, 'ºC'),
	(86336, 111, '2015-03-01 00:15:39.000000', 'temperatura', 1108.0000, 'ºC'),
	(86337, 111, '2015-03-01 00:15:40.000000', 'temperatura', 38.0000, 'ºC'),
	(86338, 111, '2015-03-01 00:15:41.000000', 'temperatura', 468.0000, 'ºC'),
	(86339, 111, '2015-03-01 00:15:42.000000', 'temperatura', 1025.0000, 'ºC'),
	(86340, 111, '2015-03-01 00:15:43.000000', 'temperatura', 124.0000, 'ºC'),
	(86341, 111, '2015-03-01 00:15:44.000000', 'temperatura', 1146.0000, 'ºC'),
	(86342, 111, '2015-03-01 00:15:45.000000', 'temperatura', 555.0000, 'ºC'),
	(86343, 111, '2015-03-01 00:15:46.000000', 'temperatura', 541.0000, 'ºC'),
	(86344, 111, '2015-03-01 00:15:47.000000', 'temperatura', 1038.0000, 'ºC'),
	(86345, 111, '2015-03-01 00:15:48.000000', 'temperatura', 1167.0000, 'ºC'),
	(86346, 111, '2015-03-01 00:15:49.000000', 'temperatura', 321.0000, 'ºC'),
	(86347, 111, '2015-03-01 00:15:50.000000', 'temperatura', 504.0000, 'ºC'),
	(86348, 111, '2015-03-01 00:15:51.000000', 'temperatura', 359.0000, 'ºC'),
	(86349, 111, '2015-03-01 00:15:52.000000', 'temperatura', 283.0000, 'ºC'),
	(86350, 111, '2015-03-01 00:15:53.000000', 'temperatura', 341.0000, 'ºC'),
	(86351, 111, '2015-03-01 00:15:54.000000', 'temperatura', 853.0000, 'ºC'),
	(86352, 111, '2015-03-01 00:15:55.000000', 'temperatura', 845.0000, 'ºC'),
	(86353, 111, '2015-03-01 00:15:56.000000', 'temperatura', 466.0000, 'ºC'),
	(86354, 111, '2015-03-01 00:15:57.000000', 'temperatura', 996.0000, 'ºC'),
	(86355, 111, '2015-03-01 00:15:58.000000', 'temperatura', 1182.0000, 'ºC'),
	(86356, 111, '2015-03-01 00:15:59.000000', 'temperatura', 522.0000, 'ºC'),
	(86357, 111, '2015-03-01 00:16:00.000000', 'temperatura', 266.0000, 'ºC'),
	(86358, 111, '2015-03-01 00:16:01.000000', 'temperatura', 964.0000, 'ºC'),
	(86359, 111, '2015-03-01 00:16:02.000000', 'temperatura', 420.0000, 'ºC'),
	(86360, 111, '2015-03-01 00:16:03.000000', 'temperatura', 412.0000, 'ºC'),
	(86361, 111, '2015-03-01 00:16:04.000000', 'temperatura', 799.0000, 'ºC'),
	(86362, 111, '2015-03-01 00:16:05.000000', 'temperatura', 361.0000, 'ºC'),
	(86363, 111, '2015-03-01 00:16:06.000000', 'temperatura', 607.0000, 'ºC'),
	(86364, 111, '2015-03-01 00:16:07.000000', 'temperatura', 752.0000, 'ºC'),
	(86365, 111, '2015-03-01 00:16:08.000000', 'temperatura', 739.0000, 'ºC'),
	(86366, 111, '2015-03-01 00:16:09.000000', 'temperatura', 238.0000, 'ºC'),
	(86367, 111, '2015-03-01 00:16:10.000000', 'temperatura', 176.0000, 'ºC'),
	(86368, 111, '2015-03-01 00:16:11.000000', 'temperatura', 166.0000, 'ºC'),
	(86369, 111, '2015-03-01 00:16:12.000000', 'temperatura', 302.0000, 'ºC'),
	(86370, 111, '2015-03-01 00:16:13.000000', 'temperatura', 1014.0000, 'ºC'),
	(86371, 111, '2015-03-01 00:16:14.000000', 'temperatura', 562.0000, 'ºC'),
	(86372, 111, '2015-03-01 00:16:15.000000', 'temperatura', 969.0000, 'ºC'),
	(86373, 111, '2015-03-01 00:16:16.000000', 'temperatura', 759.0000, 'ºC'),
	(86374, 111, '2015-03-01 00:16:17.000000', 'temperatura', 891.0000, 'ºC'),
	(86375, 111, '2015-03-01 00:16:18.000000', 'temperatura', 977.0000, 'ºC'),
	(86376, 111, '2015-03-01 00:16:19.000000', 'temperatura', 1011.0000, 'ºC'),
	(86377, 111, '2015-03-01 00:16:20.000000', 'temperatura', 928.0000, 'ºC'),
	(86378, 111, '2015-03-01 00:16:21.000000', 'temperatura', 405.0000, 'ºC'),
	(86379, 111, '2015-03-01 00:16:22.000000', 'temperatura', 442.0000, 'ºC'),
	(86380, 111, '2015-03-01 00:16:23.000000', 'temperatura', 994.0000, 'ºC'),
	(86381, 111, '2015-03-01 00:16:24.000000', 'temperatura', 47.0000, 'ºC'),
	(86382, 111, '2015-03-01 00:16:25.000000', 'temperatura', 851.0000, 'ºC'),
	(86383, 111, '2015-03-01 00:16:26.000000', 'temperatura', 514.0000, 'ºC'),
	(86384, 111, '2015-03-01 00:16:27.000000', 'temperatura', 19.0000, 'ºC'),
	(86385, 111, '2015-03-01 00:16:28.000000', 'temperatura', 955.0000, 'ºC'),
	(86386, 111, '2015-03-01 00:16:29.000000', 'temperatura', 1116.0000, 'ºC'),
	(86387, 111, '2015-03-01 00:16:30.000000', 'temperatura', 315.0000, 'ºC'),
	(86388, 111, '2015-03-01 00:16:31.000000', 'temperatura', 629.0000, 'ºC'),
	(86389, 111, '2015-03-01 00:16:32.000000', 'temperatura', 1000.0000, 'ºC'),
	(86390, 111, '2015-03-01 00:16:33.000000', 'temperatura', 712.0000, 'ºC'),
	(86391, 111, '2015-03-01 00:16:34.000000', 'temperatura', 562.0000, 'ºC'),
	(86392, 111, '2015-03-01 00:16:35.000000', 'temperatura', 672.0000, 'ºC'),
	(86393, 111, '2015-03-01 00:16:36.000000', 'temperatura', 477.0000, 'ºC'),
	(86394, 111, '2015-03-01 00:16:37.000000', 'temperatura', 368.0000, 'ºC'),
	(86395, 111, '2015-03-01 00:16:38.000000', 'temperatura', 410.0000, 'ºC'),
	(86396, 111, '2015-03-01 00:16:39.000000', 'temperatura', 946.0000, 'ºC'),
	(86397, 111, '2015-03-01 00:16:40.000000', 'temperatura', 1100.0000, 'ºC'),
	(86398, 111, '2015-03-01 00:16:41.000000', 'temperatura', 262.0000, 'ºC'),
	(86399, 111, '2015-03-01 00:16:42.000000', 'temperatura', 410.0000, 'ºC'),
	(86400, 111, '2015-03-01 00:16:43.000000', 'temperatura', 66.0000, 'ºC'),
	(86401, 111, '2015-03-01 00:16:44.000000', 'temperatura', 299.0000, 'ºC'),
	(86402, 111, '2015-03-01 00:16:45.000000', 'temperatura', 100.0000, 'ºC'),
	(86403, 111, '2015-03-01 00:16:46.000000', 'temperatura', 801.0000, 'ºC'),
	(86404, 111, '2015-03-01 00:16:47.000000', 'temperatura', 107.0000, 'ºC'),
	(86405, 111, '2015-03-01 00:16:48.000000', 'temperatura', 533.0000, 'ºC'),
	(86406, 111, '2015-03-01 00:16:49.000000', 'temperatura', 1143.0000, 'ºC'),
	(86407, 111, '2015-03-01 00:16:50.000000', 'temperatura', 515.0000, 'ºC'),
	(86408, 111, '2015-03-01 00:16:51.000000', 'temperatura', 349.0000, 'ºC'),
	(86409, 111, '2015-03-01 00:16:52.000000', 'temperatura', 199.0000, 'ºC'),
	(86410, 111, '2015-03-01 00:16:53.000000', 'temperatura', 1150.0000, 'ºC'),
	(86411, 111, '2015-03-01 00:16:54.000000', 'temperatura', 355.0000, 'ºC'),
	(86412, 111, '2015-03-01 00:16:55.000000', 'temperatura', 722.0000, 'ºC'),
	(86413, 111, '2015-03-01 00:16:56.000000', 'temperatura', 147.0000, 'ºC'),
	(86414, 111, '2015-03-01 00:16:57.000000', 'temperatura', 971.0000, 'ºC'),
	(86415, 111, '2015-03-01 00:16:58.000000', 'temperatura', 814.0000, 'ºC'),
	(86416, 111, '2015-03-01 00:16:59.000000', 'temperatura', 1156.0000, 'ºC'),
	(86417, 111, '2015-03-01 00:17:00.000000', 'temperatura', 940.0000, 'ºC'),
	(86418, 111, '2015-03-01 00:17:01.000000', 'temperatura', 33.0000, 'ºC'),
	(86419, 111, '2015-03-01 00:17:02.000000', 'temperatura', 943.0000, 'ºC'),
	(86420, 111, '2015-03-01 00:17:03.000000', 'temperatura', 1019.0000, 'ºC'),
	(86421, 111, '2015-03-01 00:17:04.000000', 'temperatura', 1064.0000, 'ºC'),
	(86422, 111, '2015-03-01 00:17:05.000000', 'temperatura', 1063.0000, 'ºC'),
	(86423, 111, '2015-03-01 00:17:06.000000', 'temperatura', 924.0000, 'ºC'),
	(86424, 111, '2015-03-01 00:17:07.000000', 'temperatura', 231.0000, 'ºC'),
	(86425, 111, '2015-03-01 00:17:08.000000', 'temperatura', 784.0000, 'ºC'),
	(86426, 111, '2015-03-01 00:17:09.000000', 'temperatura', 826.0000, 'ºC'),
	(86427, 111, '2015-03-01 00:17:10.000000', 'temperatura', 579.0000, 'ºC'),
	(86428, 111, '2015-03-01 00:17:11.000000', 'temperatura', 418.0000, 'ºC'),
	(86429, 111, '2015-03-01 00:17:12.000000', 'temperatura', 355.0000, 'ºC'),
	(86430, 111, '2015-03-01 00:17:13.000000', 'temperatura', 520.0000, 'ºC'),
	(86431, 111, '2015-03-01 00:17:14.000000', 'temperatura', 335.0000, 'ºC'),
	(86432, 111, '2015-03-01 00:17:15.000000', 'temperatura', 116.0000, 'ºC'),
	(86433, 111, '2015-03-01 00:17:16.000000', 'temperatura', 776.0000, 'ºC'),
	(86434, 111, '2015-03-01 00:17:17.000000', 'temperatura', 1131.0000, 'ºC'),
	(86435, 111, '2015-03-01 00:17:18.000000', 'temperatura', 929.0000, 'ºC'),
	(86436, 111, '2015-03-01 00:17:19.000000', 'temperatura', 52.0000, 'ºC'),
	(86437, 111, '2015-03-01 00:17:20.000000', 'temperatura', 1074.0000, 'ºC'),
	(86438, 111, '2015-03-01 00:17:21.000000', 'temperatura', 413.0000, 'ºC'),
	(86439, 111, '2015-03-01 00:17:22.000000', 'temperatura', 46.0000, 'ºC'),
	(86440, 111, '2015-03-01 00:17:23.000000', 'temperatura', 192.0000, 'ºC'),
	(86441, 111, '2015-03-01 00:17:24.000000', 'temperatura', 821.0000, 'ºC'),
	(86442, 111, '2015-03-01 00:17:25.000000', 'temperatura', 1132.0000, 'ºC'),
	(86443, 111, '2015-03-01 00:17:26.000000', 'temperatura', 795.0000, 'ºC'),
	(86444, 111, '2015-03-01 00:17:27.000000', 'temperatura', 581.0000, 'ºC'),
	(86445, 111, '2015-03-01 00:17:28.000000', 'temperatura', 518.0000, 'ºC'),
	(86446, 111, '2015-03-01 00:17:29.000000', 'temperatura', 850.0000, 'ºC'),
	(86447, 111, '2015-03-01 00:17:30.000000', 'temperatura', 295.0000, 'ºC'),
	(86448, 111, '2015-03-01 00:17:31.000000', 'temperatura', 125.0000, 'ºC'),
	(86449, 111, '2015-03-01 00:17:32.000000', 'temperatura', 943.0000, 'ºC'),
	(86450, 111, '2015-03-01 00:17:33.000000', 'temperatura', 740.0000, 'ºC'),
	(86451, 111, '2015-03-01 00:17:34.000000', 'temperatura', 873.0000, 'ºC'),
	(86452, 111, '2015-03-01 00:17:35.000000', 'temperatura', 943.0000, 'ºC'),
	(86453, 111, '2015-03-01 00:17:36.000000', 'temperatura', 897.0000, 'ºC'),
	(86454, 111, '2015-03-01 00:17:37.000000', 'temperatura', 459.0000, 'ºC'),
	(86455, 111, '2015-03-01 00:17:38.000000', 'temperatura', 802.0000, 'ºC'),
	(86456, 111, '2015-03-01 00:17:39.000000', 'temperatura', 232.0000, 'ºC'),
	(86457, 111, '2015-03-01 00:17:40.000000', 'temperatura', 1157.0000, 'ºC'),
	(86458, 111, '2015-03-01 00:17:41.000000', 'temperatura', 287.0000, 'ºC'),
	(86459, 111, '2015-03-01 00:17:42.000000', 'temperatura', 365.0000, 'ºC'),
	(86460, 111, '2015-03-01 00:17:43.000000', 'temperatura', 964.0000, 'ºC'),
	(86461, 111, '2015-03-01 00:17:44.000000', 'temperatura', 128.0000, 'ºC'),
	(86462, 111, '2015-03-01 00:17:45.000000', 'temperatura', 148.0000, 'ºC'),
	(86463, 111, '2015-03-01 00:17:46.000000', 'temperatura', 355.0000, 'ºC'),
	(86464, 111, '2015-03-01 00:17:47.000000', 'temperatura', 130.0000, 'ºC'),
	(86465, 111, '2015-03-01 00:17:48.000000', 'temperatura', 788.0000, 'ºC'),
	(86466, 111, '2015-03-01 00:17:49.000000', 'temperatura', 1149.0000, 'ºC'),
	(86467, 111, '2015-03-01 00:17:50.000000', 'temperatura', 983.0000, 'ºC'),
	(86468, 111, '2015-03-01 00:17:51.000000', 'temperatura', 269.0000, 'ºC'),
	(86469, 111, '2015-03-01 00:17:52.000000', 'temperatura', 794.0000, 'ºC'),
	(86470, 111, '2015-03-01 00:17:53.000000', 'temperatura', 766.0000, 'ºC'),
	(86471, 111, '2015-03-01 00:17:54.000000', 'temperatura', 250.0000, 'ºC'),
	(86472, 111, '2015-03-01 00:17:55.000000', 'temperatura', 149.0000, 'ºC'),
	(86473, 111, '2015-03-01 00:17:56.000000', 'temperatura', 1199.0000, 'ºC'),
	(86474, 111, '2015-03-01 00:17:57.000000', 'temperatura', 745.0000, 'ºC'),
	(86475, 111, '2015-03-01 00:17:58.000000', 'temperatura', 129.0000, 'ºC'),
	(86476, 111, '2015-03-01 00:17:59.000000', 'temperatura', 812.0000, 'ºC'),
	(86477, 111, '2015-03-01 00:18:00.000000', 'temperatura', 75.0000, 'ºC'),
	(86478, 111, '2015-03-01 00:18:01.000000', 'temperatura', 338.0000, 'ºC'),
	(86479, 111, '2015-03-01 00:18:02.000000', 'temperatura', 265.0000, 'ºC'),
	(86480, 111, '2015-03-01 00:18:03.000000', 'temperatura', 310.0000, 'ºC'),
	(86481, 111, '2015-03-01 00:18:04.000000', 'temperatura', 756.0000, 'ºC'),
	(86482, 111, '2015-03-01 00:18:05.000000', 'temperatura', 450.0000, 'ºC'),
	(86483, 111, '2015-03-01 00:18:06.000000', 'temperatura', 1185.0000, 'ºC'),
	(86484, 111, '2015-03-01 00:18:07.000000', 'temperatura', 973.0000, 'ºC'),
	(86485, 111, '2015-03-01 00:18:08.000000', 'temperatura', 113.0000, 'ºC'),
	(86486, 111, '2015-03-01 00:18:09.000000', 'temperatura', 44.0000, 'ºC'),
	(86487, 111, '2015-03-01 00:18:10.000000', 'temperatura', 1081.0000, 'ºC'),
	(86488, 111, '2015-03-01 00:18:11.000000', 'temperatura', 476.0000, 'ºC'),
	(86489, 111, '2015-03-01 00:18:12.000000', 'temperatura', 337.0000, 'ºC'),
	(86490, 111, '2015-03-01 00:18:13.000000', 'temperatura', 255.0000, 'ºC'),
	(86491, 111, '2015-03-01 00:18:14.000000', 'temperatura', 266.0000, 'ºC'),
	(86492, 111, '2015-03-01 00:18:15.000000', 'temperatura', 565.0000, 'ºC'),
	(86493, 111, '2015-03-01 00:18:16.000000', 'temperatura', 830.0000, 'ºC'),
	(86494, 111, '2015-03-01 00:18:17.000000', 'temperatura', 54.0000, 'ºC'),
	(86495, 111, '2015-03-01 00:18:18.000000', 'temperatura', 180.0000, 'ºC'),
	(86496, 111, '2015-03-01 00:18:19.000000', 'temperatura', 738.0000, 'ºC'),
	(86497, 111, '2015-03-01 00:18:20.000000', 'temperatura', 751.0000, 'ºC'),
	(86498, 111, '2015-03-01 00:18:21.000000', 'temperatura', 342.0000, 'ºC'),
	(86499, 111, '2015-03-01 00:18:22.000000', 'temperatura', 659.0000, 'ºC'),
	(86500, 111, '2015-03-01 00:18:23.000000', 'temperatura', 1069.0000, 'ºC'),
	(86501, 111, '2015-03-01 00:18:24.000000', 'temperatura', 968.0000, 'ºC'),
	(86502, 111, '2015-03-01 00:18:25.000000', 'temperatura', 432.0000, 'ºC'),
	(86503, 111, '2015-03-01 00:18:26.000000', 'temperatura', 459.0000, 'ºC'),
	(86504, 111, '2015-03-01 00:18:27.000000', 'temperatura', 997.0000, 'ºC'),
	(86505, 111, '2015-03-01 00:18:28.000000', 'temperatura', 9.0000, 'ºC'),
	(86506, 111, '2015-03-01 00:18:29.000000', 'temperatura', 654.0000, 'ºC'),
	(86507, 111, '2015-03-01 00:18:30.000000', 'temperatura', 844.0000, 'ºC'),
	(86508, 111, '2015-03-01 00:18:31.000000', 'temperatura', 1057.0000, 'ºC'),
	(86509, 111, '2015-03-01 00:18:32.000000', 'temperatura', 354.0000, 'ºC'),
	(86510, 111, '2015-03-01 00:18:33.000000', 'temperatura', 1002.0000, 'ºC'),
	(86511, 111, '2015-03-01 00:18:34.000000', 'temperatura', 345.0000, 'ºC'),
	(86512, 111, '2015-03-01 00:18:35.000000', 'temperatura', 1121.0000, 'ºC'),
	(86513, 111, '2015-03-01 00:18:36.000000', 'temperatura', 969.0000, 'ºC'),
	(86514, 111, '2015-03-01 00:18:37.000000', 'temperatura', 284.0000, 'ºC'),
	(86515, 111, '2015-03-01 00:18:38.000000', 'temperatura', 915.0000, 'ºC'),
	(86516, 111, '2015-03-01 00:18:39.000000', 'temperatura', 120.0000, 'ºC'),
	(86517, 111, '2015-03-01 00:18:40.000000', 'temperatura', 259.0000, 'ºC'),
	(86518, 111, '2015-03-01 00:18:41.000000', 'temperatura', 932.0000, 'ºC'),
	(86519, 111, '2015-03-01 00:18:42.000000', 'temperatura', 287.0000, 'ºC'),
	(86520, 111, '2015-03-01 00:18:43.000000', 'temperatura', 1037.0000, 'ºC'),
	(86521, 111, '2015-03-01 00:18:44.000000', 'temperatura', 726.0000, 'ºC'),
	(86522, 111, '2015-03-01 00:18:45.000000', 'temperatura', 519.0000, 'ºC'),
	(86523, 111, '2015-03-01 00:18:46.000000', 'temperatura', 416.0000, 'ºC'),
	(86524, 111, '2015-03-01 00:18:47.000000', 'temperatura', 525.0000, 'ºC'),
	(86525, 111, '2015-03-01 00:18:48.000000', 'temperatura', 176.0000, 'ºC'),
	(86526, 111, '2015-03-01 00:18:49.000000', 'temperatura', 508.0000, 'ºC'),
	(86527, 111, '2015-03-01 00:18:50.000000', 'temperatura', 813.0000, 'ºC'),
	(86528, 111, '2015-03-01 00:18:51.000000', 'temperatura', 139.0000, 'ºC'),
	(86529, 111, '2015-03-01 00:18:52.000000', 'temperatura', 657.0000, 'ºC'),
	(86530, 111, '2015-03-01 00:18:53.000000', 'temperatura', 471.0000, 'ºC'),
	(86531, 111, '2015-03-01 00:18:54.000000', 'temperatura', 381.0000, 'ºC'),
	(86532, 111, '2015-03-01 00:18:55.000000', 'temperatura', 493.0000, 'ºC'),
	(86533, 111, '2015-03-01 00:18:56.000000', 'temperatura', 124.0000, 'ºC'),
	(86534, 111, '2015-03-01 00:18:57.000000', 'temperatura', 341.0000, 'ºC'),
	(86535, 111, '2015-03-01 00:18:58.000000', 'temperatura', 132.0000, 'ºC'),
	(86536, 111, '2015-03-01 00:18:59.000000', 'temperatura', 837.0000, 'ºC'),
	(86537, 111, '2015-03-01 00:19:00.000000', 'temperatura', 190.0000, 'ºC'),
	(86538, 111, '2015-03-01 00:19:01.000000', 'temperatura', 839.0000, 'ºC'),
	(86539, 111, '2015-03-01 00:19:02.000000', 'temperatura', 26.0000, 'ºC'),
	(86540, 111, '2015-03-01 00:19:03.000000', 'temperatura', 12.0000, 'ºC'),
	(86541, 111, '2015-03-01 00:19:04.000000', 'temperatura', 1182.0000, 'ºC'),
	(86542, 111, '2015-03-01 00:19:05.000000', 'temperatura', 1075.0000, 'ºC'),
	(86543, 111, '2015-03-01 00:19:06.000000', 'temperatura', 630.0000, 'ºC'),
	(86544, 111, '2015-03-01 00:19:07.000000', 'temperatura', 1126.0000, 'ºC'),
	(86545, 111, '2015-03-01 00:19:08.000000', 'temperatura', 141.0000, 'ºC'),
	(86546, 111, '2015-03-01 00:19:09.000000', 'temperatura', 926.0000, 'ºC'),
	(86547, 111, '2015-03-01 00:19:10.000000', 'temperatura', 607.0000, 'ºC'),
	(86548, 111, '2015-03-01 00:19:11.000000', 'temperatura', 260.0000, 'ºC'),
	(86549, 111, '2015-03-01 00:19:12.000000', 'temperatura', 676.0000, 'ºC'),
	(86550, 111, '2015-03-01 00:19:13.000000', 'temperatura', 203.0000, 'ºC'),
	(86551, 111, '2015-03-01 00:19:14.000000', 'temperatura', 187.0000, 'ºC'),
	(86552, 111, '2015-03-01 00:19:15.000000', 'temperatura', 327.0000, 'ºC'),
	(86553, 111, '2015-03-01 00:19:16.000000', 'temperatura', 1075.0000, 'ºC'),
	(86554, 111, '2015-03-01 00:19:17.000000', 'temperatura', 794.0000, 'ºC'),
	(86555, 111, '2015-03-01 00:19:18.000000', 'temperatura', 746.0000, 'ºC'),
	(86556, 111, '2015-03-01 00:19:19.000000', 'temperatura', 148.0000, 'ºC'),
	(86557, 111, '2015-03-01 00:19:20.000000', 'temperatura', 902.0000, 'ºC'),
	(86558, 111, '2015-03-01 00:19:21.000000', 'temperatura', 467.0000, 'ºC'),
	(86559, 111, '2015-03-01 00:19:22.000000', 'temperatura', 831.0000, 'ºC'),
	(86560, 111, '2015-03-01 00:19:23.000000', 'temperatura', 352.0000, 'ºC'),
	(86561, 111, '2015-03-01 00:19:24.000000', 'temperatura', 469.0000, 'ºC'),
	(86562, 111, '2015-03-01 00:19:25.000000', 'temperatura', 88.0000, 'ºC'),
	(86563, 111, '2015-03-01 00:19:26.000000', 'temperatura', 234.0000, 'ºC'),
	(86564, 111, '2015-03-01 00:19:27.000000', 'temperatura', 908.0000, 'ºC'),
	(86565, 111, '2015-03-01 00:19:28.000000', 'temperatura', 238.0000, 'ºC'),
	(86566, 111, '2015-03-01 00:19:29.000000', 'temperatura', 865.0000, 'ºC'),
	(86567, 111, '2015-03-01 00:19:30.000000', 'temperatura', 12.0000, 'ºC'),
	(86568, 111, '2015-03-01 00:19:31.000000', 'temperatura', 1065.0000, 'ºC'),
	(86569, 111, '2015-03-01 00:19:32.000000', 'temperatura', 491.0000, 'ºC'),
	(86570, 111, '2015-03-01 00:19:33.000000', 'temperatura', 461.0000, 'ºC'),
	(86571, 111, '2015-03-01 00:19:34.000000', 'temperatura', 831.0000, 'ºC'),
	(86572, 111, '2015-03-01 00:19:35.000000', 'temperatura', 373.0000, 'ºC'),
	(86573, 111, '2015-03-01 00:19:36.000000', 'temperatura', 573.0000, 'ºC'),
	(86574, 111, '2015-03-01 00:19:37.000000', 'temperatura', 545.0000, 'ºC'),
	(86575, 111, '2015-03-01 00:19:38.000000', 'temperatura', 1009.0000, 'ºC'),
	(86576, 111, '2015-03-01 00:19:39.000000', 'temperatura', 1010.0000, 'ºC'),
	(86577, 111, '2015-03-01 00:19:40.000000', 'temperatura', 823.0000, 'ºC'),
	(86578, 111, '2015-03-01 00:19:41.000000', 'temperatura', 1086.0000, 'ºC'),
	(86579, 111, '2015-03-01 00:19:42.000000', 'temperatura', 559.0000, 'ºC'),
	(86580, 111, '2015-03-01 00:19:43.000000', 'temperatura', 741.0000, 'ºC'),
	(86581, 111, '2015-03-01 00:19:44.000000', 'temperatura', 827.0000, 'ºC'),
	(86582, 111, '2015-03-01 00:19:45.000000', 'temperatura', 714.0000, 'ºC'),
	(86583, 111, '2015-03-01 00:19:46.000000', 'temperatura', 1089.0000, 'ºC'),
	(86584, 111, '2015-03-01 00:19:47.000000', 'temperatura', 902.0000, 'ºC'),
	(86585, 111, '2015-03-01 00:19:48.000000', 'temperatura', 46.0000, 'ºC'),
	(86586, 111, '2015-03-01 00:19:49.000000', 'temperatura', 1122.0000, 'ºC'),
	(86587, 111, '2015-03-01 00:19:50.000000', 'temperatura', 675.0000, 'ºC'),
	(86588, 111, '2015-03-01 00:19:51.000000', 'temperatura', 11.0000, 'ºC'),
	(86589, 111, '2015-03-01 00:19:52.000000', 'temperatura', 427.0000, 'ºC'),
	(86590, 111, '2015-03-01 00:19:53.000000', 'temperatura', 902.0000, 'ºC'),
	(86591, 111, '2015-03-01 00:19:54.000000', 'temperatura', 831.0000, 'ºC'),
	(86592, 111, '2015-03-01 00:19:55.000000', 'temperatura', 251.0000, 'ºC'),
	(86593, 111, '2015-03-01 00:19:56.000000', 'temperatura', 1162.0000, 'ºC'),
	(86594, 111, '2015-03-01 00:19:57.000000', 'temperatura', 256.0000, 'ºC'),
	(86595, 111, '2015-03-01 00:19:58.000000', 'temperatura', 193.0000, 'ºC'),
	(86596, 111, '2015-03-01 00:19:59.000000', 'temperatura', 200.0000, 'ºC'),
	(86597, 111, '2015-03-01 00:20:00.000000', 'temperatura', 421.0000, 'ºC'),
	(86598, 111, '2015-03-01 00:20:01.000000', 'temperatura', 304.0000, 'ºC'),
	(86599, 111, '2015-03-01 00:20:02.000000', 'temperatura', 257.0000, 'ºC'),
	(86600, 111, '2015-03-01 00:20:03.000000', 'temperatura', 376.0000, 'ºC'),
	(86601, 111, '2015-03-01 00:20:04.000000', 'temperatura', 1109.0000, 'ºC'),
	(86602, 111, '2015-03-01 00:20:05.000000', 'temperatura', 818.0000, 'ºC'),
	(86603, 111, '2015-03-01 00:20:06.000000', 'temperatura', 765.0000, 'ºC'),
	(86604, 111, '2015-03-01 00:20:07.000000', 'temperatura', 169.0000, 'ºC'),
	(86605, 111, '2015-03-01 00:20:08.000000', 'temperatura', 949.0000, 'ºC'),
	(86606, 111, '2015-03-01 00:20:09.000000', 'temperatura', 641.0000, 'ºC'),
	(86607, 111, '2015-03-01 00:20:10.000000', 'temperatura', 359.0000, 'ºC'),
	(86608, 111, '2015-03-01 00:20:11.000000', 'temperatura', 1070.0000, 'ºC'),
	(86609, 111, '2015-03-01 00:20:12.000000', 'temperatura', 673.0000, 'ºC'),
	(86610, 111, '2015-03-01 00:20:13.000000', 'temperatura', 158.0000, 'ºC'),
	(86611, 111, '2015-03-01 00:20:14.000000', 'temperatura', 1172.0000, 'ºC'),
	(86612, 111, '2015-03-01 00:20:15.000000', 'temperatura', 585.0000, 'ºC'),
	(86613, 111, '2015-03-01 00:20:16.000000', 'temperatura', 609.0000, 'ºC'),
	(86614, 111, '2015-03-01 00:20:17.000000', 'temperatura', 91.0000, 'ºC'),
	(86615, 111, '2015-03-01 00:20:18.000000', 'temperatura', 1029.0000, 'ºC'),
	(86616, 111, '2015-03-01 00:20:19.000000', 'temperatura', 74.0000, 'ºC'),
	(86617, 111, '2015-03-01 00:20:20.000000', 'temperatura', 882.0000, 'ºC'),
	(86618, 111, '2015-03-01 00:20:21.000000', 'temperatura', 588.0000, 'ºC'),
	(86619, 111, '2015-03-01 00:20:22.000000', 'temperatura', 295.0000, 'ºC'),
	(86620, 111, '2015-03-01 00:20:23.000000', 'temperatura', 911.0000, 'ºC'),
	(86621, 111, '2015-03-01 00:20:24.000000', 'temperatura', 70.0000, 'ºC'),
	(86622, 111, '2015-03-01 00:20:25.000000', 'temperatura', 16.0000, 'ºC'),
	(86623, 111, '2015-03-01 00:20:26.000000', 'temperatura', 1073.0000, 'ºC'),
	(86624, 111, '2015-03-01 00:20:27.000000', 'temperatura', 517.0000, 'ºC'),
	(86625, 111, '2015-03-01 00:20:28.000000', 'temperatura', 567.0000, 'ºC'),
	(86626, 111, '2015-03-01 00:20:29.000000', 'temperatura', 84.0000, 'ºC'),
	(86627, 111, '2015-03-01 00:20:30.000000', 'temperatura', 1118.0000, 'ºC'),
	(86628, 111, '2015-03-01 00:20:31.000000', 'temperatura', 540.0000, 'ºC'),
	(86629, 111, '2015-03-01 00:20:32.000000', 'temperatura', 547.0000, 'ºC'),
	(86630, 111, '2015-03-01 00:20:33.000000', 'temperatura', 1116.0000, 'ºC'),
	(86631, 111, '2015-03-01 00:20:34.000000', 'temperatura', 340.0000, 'ºC'),
	(86632, 111, '2015-03-01 00:20:35.000000', 'temperatura', 750.0000, 'ºC'),
	(86633, 111, '2015-03-01 00:20:36.000000', 'temperatura', 331.0000, 'ºC'),
	(86634, 111, '2015-03-01 00:20:37.000000', 'temperatura', 604.0000, 'ºC'),
	(86635, 111, '2015-03-01 00:20:38.000000', 'temperatura', 830.0000, 'ºC'),
	(86636, 111, '2015-03-01 00:20:39.000000', 'temperatura', 1139.0000, 'ºC'),
	(86637, 111, '2015-03-01 00:20:40.000000', 'temperatura', 803.0000, 'ºC'),
	(86638, 111, '2015-03-01 00:20:41.000000', 'temperatura', 600.0000, 'ºC'),
	(86639, 111, '2015-03-01 00:20:42.000000', 'temperatura', 590.0000, 'ºC'),
	(86640, 111, '2015-03-01 00:20:43.000000', 'temperatura', 1149.0000, 'ºC'),
	(86641, 111, '2015-03-01 00:20:44.000000', 'temperatura', 379.0000, 'ºC'),
	(86642, 111, '2015-03-01 00:20:45.000000', 'temperatura', 847.0000, 'ºC'),
	(86643, 111, '2015-03-01 00:20:46.000000', 'temperatura', 697.0000, 'ºC'),
	(86644, 111, '2015-03-01 00:20:47.000000', 'temperatura', 947.0000, 'ºC'),
	(86645, 111, '2015-03-01 00:20:48.000000', 'temperatura', 243.0000, 'ºC'),
	(86646, 111, '2015-03-01 00:20:49.000000', 'temperatura', 774.0000, 'ºC'),
	(86647, 111, '2015-03-01 00:20:50.000000', 'temperatura', 742.0000, 'ºC'),
	(86648, 111, '2015-03-01 00:20:51.000000', 'temperatura', 189.0000, 'ºC'),
	(86649, 111, '2015-03-01 00:20:52.000000', 'temperatura', 1118.0000, 'ºC'),
	(86650, 111, '2015-03-01 00:20:53.000000', 'temperatura', 226.0000, 'ºC'),
	(86651, 111, '2015-03-01 00:20:54.000000', 'temperatura', 175.0000, 'ºC'),
	(86652, 111, '2015-03-01 00:20:55.000000', 'temperatura', 197.0000, 'ºC'),
	(86653, 111, '2015-03-01 00:20:56.000000', 'temperatura', 460.0000, 'ºC'),
	(86654, 111, '2015-03-01 00:20:57.000000', 'temperatura', 509.0000, 'ºC'),
	(86655, 111, '2015-03-01 00:20:58.000000', 'temperatura', 1165.0000, 'ºC'),
	(86656, 111, '2015-03-01 00:20:59.000000', 'temperatura', 699.0000, 'ºC'),
	(86657, 111, '2015-03-01 00:21:00.000000', 'temperatura', 2.0000, 'ºC'),
	(86658, 111, '2015-03-01 00:21:01.000000', 'temperatura', 311.0000, 'ºC'),
	(86659, 111, '2015-03-01 00:21:02.000000', 'temperatura', 351.0000, 'ºC'),
	(86660, 111, '2015-03-01 00:21:03.000000', 'temperatura', 821.0000, 'ºC'),
	(86661, 111, '2015-03-01 00:21:04.000000', 'temperatura', 652.0000, 'ºC'),
	(86662, 111, '2015-03-01 00:21:05.000000', 'temperatura', 800.0000, 'ºC'),
	(86663, 111, '2015-03-01 00:21:06.000000', 'temperatura', 842.0000, 'ºC'),
	(86664, 111, '2015-03-01 00:21:07.000000', 'temperatura', 611.0000, 'ºC'),
	(86665, 111, '2015-03-01 00:21:08.000000', 'temperatura', 532.0000, 'ºC'),
	(86666, 111, '2015-03-01 00:21:09.000000', 'temperatura', 825.0000, 'ºC'),
	(86667, 111, '2015-03-01 00:21:10.000000', 'temperatura', 132.0000, 'ºC'),
	(86668, 111, '2015-03-01 00:21:11.000000', 'temperatura', 584.0000, 'ºC'),
	(86669, 111, '2015-03-01 00:21:12.000000', 'temperatura', 123.0000, 'ºC'),
	(86670, 111, '2015-03-01 00:21:13.000000', 'temperatura', 63.0000, 'ºC'),
	(86671, 111, '2015-03-01 00:21:14.000000', 'temperatura', 1148.0000, 'ºC'),
	(86672, 111, '2015-03-01 00:21:15.000000', 'temperatura', 751.0000, 'ºC'),
	(86673, 111, '2015-03-01 00:21:16.000000', 'temperatura', 312.0000, 'ºC'),
	(86674, 111, '2015-03-01 00:21:17.000000', 'temperatura', 509.0000, 'ºC'),
	(86675, 111, '2015-03-01 00:21:18.000000', 'temperatura', 407.0000, 'ºC'),
	(86676, 111, '2015-03-01 00:21:19.000000', 'temperatura', 508.0000, 'ºC'),
	(86677, 111, '2015-03-01 00:21:20.000000', 'temperatura', 119.0000, 'ºC'),
	(86678, 111, '2015-03-01 00:21:21.000000', 'temperatura', 271.0000, 'ºC'),
	(86679, 111, '2015-03-01 00:21:22.000000', 'temperatura', 1001.0000, 'ºC'),
	(86680, 111, '2015-03-01 00:21:23.000000', 'temperatura', 593.0000, 'ºC'),
	(86681, 111, '2015-03-01 00:21:24.000000', 'temperatura', 1161.0000, 'ºC'),
	(86682, 111, '2015-03-01 00:21:25.000000', 'temperatura', 425.0000, 'ºC'),
	(86683, 111, '2015-03-01 00:21:26.000000', 'temperatura', 1044.0000, 'ºC'),
	(86684, 111, '2015-03-01 00:21:27.000000', 'temperatura', 345.0000, 'ºC'),
	(86685, 111, '2015-03-01 00:21:28.000000', 'temperatura', 994.0000, 'ºC'),
	(86686, 111, '2015-03-01 00:21:29.000000', 'temperatura', 336.0000, 'ºC'),
	(86687, 111, '2015-03-01 00:21:30.000000', 'temperatura', 1098.0000, 'ºC'),
	(86688, 111, '2015-03-01 00:21:31.000000', 'temperatura', 881.0000, 'ºC'),
	(86689, 111, '2015-03-01 00:21:32.000000', 'temperatura', 1113.0000, 'ºC'),
	(86690, 111, '2015-03-01 00:21:33.000000', 'temperatura', 522.0000, 'ºC'),
	(86691, 111, '2015-03-01 00:21:34.000000', 'temperatura', 471.0000, 'ºC'),
	(86692, 111, '2015-03-01 00:21:35.000000', 'temperatura', 789.0000, 'ºC'),
	(86693, 111, '2015-03-01 00:21:36.000000', 'temperatura', 132.0000, 'ºC'),
	(86694, 111, '2015-03-01 00:21:37.000000', 'temperatura', 696.0000, 'ºC'),
	(86695, 111, '2015-03-01 00:21:38.000000', 'temperatura', 683.0000, 'ºC'),
	(86696, 111, '2015-03-01 00:21:39.000000', 'temperatura', 127.0000, 'ºC'),
	(86697, 111, '2015-03-01 00:21:40.000000', 'temperatura', 987.0000, 'ºC'),
	(86698, 111, '2015-03-01 00:21:41.000000', 'temperatura', 956.0000, 'ºC'),
	(86699, 111, '2015-03-01 00:21:42.000000', 'temperatura', 617.0000, 'ºC'),
	(86700, 111, '2015-03-01 00:21:43.000000', 'temperatura', 218.0000, 'ºC'),
	(86701, 111, '2015-03-01 00:21:44.000000', 'temperatura', 439.0000, 'ºC'),
	(86702, 111, '2015-03-01 00:21:45.000000', 'temperatura', 341.0000, 'ºC'),
	(86703, 111, '2015-03-01 00:21:46.000000', 'temperatura', 389.0000, 'ºC'),
	(86704, 111, '2015-03-01 00:21:47.000000', 'temperatura', 921.0000, 'ºC'),
	(86705, 111, '2015-03-01 00:21:48.000000', 'temperatura', 1041.0000, 'ºC'),
	(86706, 111, '2015-03-01 00:21:49.000000', 'temperatura', 42.0000, 'ºC'),
	(86707, 111, '2015-03-01 00:21:50.000000', 'temperatura', 685.0000, 'ºC'),
	(86708, 111, '2015-03-01 00:21:51.000000', 'temperatura', 902.0000, 'ºC'),
	(86709, 111, '2015-03-01 00:21:52.000000', 'temperatura', 57.0000, 'ºC'),
	(86710, 111, '2015-03-01 00:21:53.000000', 'temperatura', 1178.0000, 'ºC'),
	(86711, 111, '2015-03-01 00:21:54.000000', 'temperatura', 917.0000, 'ºC'),
	(86712, 111, '2015-03-01 00:21:55.000000', 'temperatura', 1055.0000, 'ºC'),
	(86713, 111, '2015-03-01 00:21:56.000000', 'temperatura', 123.0000, 'ºC'),
	(86714, 111, '2015-03-01 00:21:57.000000', 'temperatura', 1049.0000, 'ºC'),
	(86715, 111, '2015-03-01 00:21:58.000000', 'temperatura', 80.0000, 'ºC'),
	(86716, 111, '2015-03-01 00:21:59.000000', 'temperatura', 850.0000, 'ºC'),
	(86717, 111, '2015-03-01 00:22:00.000000', 'temperatura', 414.0000, 'ºC'),
	(86718, 111, '2015-03-01 00:22:01.000000', 'temperatura', 717.0000, 'ºC'),
	(86719, 111, '2015-03-01 00:22:02.000000', 'temperatura', 1145.0000, 'ºC'),
	(86720, 111, '2015-03-01 00:22:03.000000', 'temperatura', 1174.0000, 'ºC'),
	(86721, 111, '2015-03-01 00:22:04.000000', 'temperatura', 37.0000, 'ºC'),
	(86722, 111, '2015-03-01 00:22:05.000000', 'temperatura', 262.0000, 'ºC'),
	(86723, 111, '2015-03-01 00:22:06.000000', 'temperatura', 1.0000, 'ºC'),
	(86724, 111, '2015-03-01 00:22:07.000000', 'temperatura', 419.0000, 'ºC'),
	(86725, 111, '2015-03-01 00:22:08.000000', 'temperatura', 892.0000, 'ºC'),
	(86726, 111, '2015-03-01 00:22:09.000000', 'temperatura', 804.0000, 'ºC'),
	(86727, 111, '2015-03-01 00:22:10.000000', 'temperatura', 143.0000, 'ºC'),
	(86728, 111, '2015-03-01 00:22:11.000000', 'temperatura', 705.0000, 'ºC'),
	(86729, 111, '2015-03-01 00:22:12.000000', 'temperatura', 698.0000, 'ºC'),
	(86730, 111, '2015-03-01 00:22:13.000000', 'temperatura', 174.0000, 'ºC'),
	(86731, 111, '2015-03-01 00:22:14.000000', 'temperatura', 1177.0000, 'ºC'),
	(86732, 111, '2015-03-01 00:22:15.000000', 'temperatura', 564.0000, 'ºC'),
	(86733, 111, '2015-03-01 00:22:16.000000', 'temperatura', 490.0000, 'ºC'),
	(86734, 111, '2015-03-01 00:22:17.000000', 'temperatura', 759.0000, 'ºC'),
	(86735, 111, '2015-03-01 00:22:18.000000', 'temperatura', 1124.0000, 'ºC'),
	(86736, 111, '2015-03-01 00:22:19.000000', 'temperatura', 945.0000, 'ºC'),
	(86737, 111, '2015-03-01 00:22:20.000000', 'temperatura', 155.0000, 'ºC'),
	(86738, 111, '2015-03-01 00:22:21.000000', 'temperatura', 338.0000, 'ºC'),
	(86739, 111, '2015-03-01 00:22:22.000000', 'temperatura', 26.0000, 'ºC'),
	(86740, 111, '2015-03-01 00:22:23.000000', 'temperatura', 318.0000, 'ºC'),
	(86741, 111, '2015-03-01 00:22:24.000000', 'temperatura', 313.0000, 'ºC'),
	(86742, 111, '2015-03-01 00:22:25.000000', 'temperatura', 609.0000, 'ºC'),
	(86743, 111, '2015-03-01 00:22:26.000000', 'temperatura', 908.0000, 'ºC'),
	(86744, 111, '2015-03-01 00:22:27.000000', 'temperatura', 314.0000, 'ºC'),
	(86745, 111, '2015-03-01 00:22:28.000000', 'temperatura', 47.0000, 'ºC'),
	(86746, 111, '2015-03-01 00:22:29.000000', 'temperatura', 491.0000, 'ºC'),
	(86747, 111, '2015-03-01 00:22:30.000000', 'temperatura', 1115.0000, 'ºC'),
	(86748, 111, '2015-03-01 00:22:31.000000', 'temperatura', 502.0000, 'ºC'),
	(86749, 111, '2015-03-01 00:22:32.000000', 'temperatura', 368.0000, 'ºC'),
	(86750, 111, '2015-03-01 00:22:33.000000', 'temperatura', 335.0000, 'ºC'),
	(86751, 111, '2015-03-01 00:22:34.000000', 'temperatura', 568.0000, 'ºC'),
	(86752, 111, '2015-03-01 00:22:35.000000', 'temperatura', 639.0000, 'ºC'),
	(86753, 111, '2015-03-01 00:22:36.000000', 'temperatura', 288.0000, 'ºC'),
	(86754, 111, '2015-03-01 00:22:37.000000', 'temperatura', 725.0000, 'ºC'),
	(86755, 111, '2015-03-01 00:22:38.000000', 'temperatura', 363.0000, 'ºC'),
	(86756, 111, '2015-03-01 00:22:39.000000', 'temperatura', 838.0000, 'ºC'),
	(86757, 111, '2015-03-01 00:22:40.000000', 'temperatura', 705.0000, 'ºC'),
	(86758, 111, '2015-03-01 00:22:41.000000', 'temperatura', 1008.0000, 'ºC'),
	(86759, 111, '2015-03-01 00:22:42.000000', 'temperatura', 525.0000, 'ºC'),
	(86760, 111, '2015-03-01 00:22:43.000000', 'temperatura', 804.0000, 'ºC'),
	(86761, 111, '2015-03-01 00:22:44.000000', 'temperatura', 46.0000, 'ºC'),
	(86762, 111, '2015-03-01 00:22:45.000000', 'temperatura', 216.0000, 'ºC'),
	(86763, 111, '2015-03-01 00:22:46.000000', 'temperatura', 944.0000, 'ºC'),
	(86764, 111, '2015-03-01 00:22:47.000000', 'temperatura', 470.0000, 'ºC'),
	(86765, 111, '2015-03-01 00:22:48.000000', 'temperatura', 721.0000, 'ºC'),
	(86766, 111, '2015-03-01 00:22:49.000000', 'temperatura', 996.0000, 'ºC'),
	(86767, 111, '2015-03-01 00:22:50.000000', 'temperatura', 419.0000, 'ºC'),
	(86768, 111, '2015-03-01 00:22:51.000000', 'temperatura', 304.0000, 'ºC'),
	(86769, 111, '2015-03-01 00:22:52.000000', 'temperatura', 265.0000, 'ºC'),
	(86770, 111, '2015-03-01 00:22:53.000000', 'temperatura', 414.0000, 'ºC'),
	(86771, 111, '2015-03-01 00:22:54.000000', 'temperatura', 74.0000, 'ºC'),
	(86772, 111, '2015-03-01 00:22:55.000000', 'temperatura', 330.0000, 'ºC'),
	(86773, 111, '2015-03-01 00:22:56.000000', 'temperatura', 227.0000, 'ºC'),
	(86774, 111, '2015-03-01 00:22:57.000000', 'temperatura', 148.0000, 'ºC'),
	(86775, 111, '2015-03-01 00:22:58.000000', 'temperatura', 59.0000, 'ºC'),
	(86776, 111, '2015-03-01 00:22:59.000000', 'temperatura', 1050.0000, 'ºC'),
	(86777, 111, '2015-03-01 00:23:00.000000', 'temperatura', 273.0000, 'ºC'),
	(86778, 111, '2015-03-01 00:23:01.000000', 'temperatura', 615.0000, 'ºC'),
	(86779, 111, '2015-03-01 00:23:02.000000', 'temperatura', 1057.0000, 'ºC'),
	(86780, 111, '2015-03-01 00:23:03.000000', 'temperatura', 1041.0000, 'ºC'),
	(86781, 111, '2015-03-01 00:23:04.000000', 'temperatura', 835.0000, 'ºC'),
	(86782, 111, '2015-03-01 00:23:05.000000', 'temperatura', 1052.0000, 'ºC'),
	(86783, 111, '2015-03-01 00:23:06.000000', 'temperatura', 355.0000, 'ºC'),
	(86784, 111, '2015-03-01 00:23:07.000000', 'temperatura', 1018.0000, 'ºC'),
	(86785, 111, '2015-03-01 00:23:08.000000', 'temperatura', 426.0000, 'ºC'),
	(86786, 111, '2015-03-01 00:23:09.000000', 'temperatura', 279.0000, 'ºC'),
	(86787, 111, '2015-03-01 00:23:10.000000', 'temperatura', 115.0000, 'ºC'),
	(86788, 111, '2015-03-01 00:23:11.000000', 'temperatura', 939.0000, 'ºC'),
	(86789, 111, '2015-03-01 00:23:12.000000', 'temperatura', 750.0000, 'ºC'),
	(86790, 111, '2015-03-01 00:23:13.000000', 'temperatura', 934.0000, 'ºC'),
	(86791, 111, '2015-03-01 00:23:14.000000', 'temperatura', 20.0000, 'ºC'),
	(86792, 111, '2015-03-01 00:23:15.000000', 'temperatura', 898.0000, 'ºC'),
	(86793, 111, '2015-03-01 00:23:16.000000', 'temperatura', 830.0000, 'ºC'),
	(86794, 111, '2015-03-01 00:23:17.000000', 'temperatura', 257.0000, 'ºC'),
	(86795, 111, '2015-03-01 00:23:18.000000', 'temperatura', 1196.0000, 'ºC'),
	(86796, 111, '2015-03-01 00:23:19.000000', 'temperatura', 409.0000, 'ºC'),
	(86797, 111, '2015-03-01 00:23:20.000000', 'temperatura', 860.0000, 'ºC'),
	(86798, 111, '2015-03-01 00:23:21.000000', 'temperatura', 671.0000, 'ºC'),
	(86799, 111, '2015-03-01 00:23:22.000000', 'temperatura', 776.0000, 'ºC'),
	(86800, 111, '2015-03-01 00:23:23.000000', 'temperatura', 666.0000, 'ºC'),
	(86801, 111, '2015-03-01 00:23:24.000000', 'temperatura', 1005.0000, 'ºC'),
	(86802, 111, '2015-03-01 00:23:25.000000', 'temperatura', 627.0000, 'ºC'),
	(86803, 111, '2015-03-01 00:23:26.000000', 'temperatura', 118.0000, 'ºC'),
	(86804, 111, '2015-03-01 00:23:27.000000', 'temperatura', 1112.0000, 'ºC'),
	(86805, 111, '2015-03-01 00:23:28.000000', 'temperatura', 408.0000, 'ºC'),
	(86806, 111, '2015-03-01 00:23:29.000000', 'temperatura', 1102.0000, 'ºC'),
	(86807, 111, '2015-03-01 00:23:30.000000', 'temperatura', 689.0000, 'ºC'),
	(86808, 111, '2015-03-01 00:23:31.000000', 'temperatura', 138.0000, 'ºC'),
	(86809, 111, '2015-03-01 00:23:32.000000', 'temperatura', 1022.0000, 'ºC'),
	(86810, 111, '2015-03-01 00:23:33.000000', 'temperatura', 1099.0000, 'ºC'),
	(86811, 111, '2015-03-01 00:23:34.000000', 'temperatura', 29.0000, 'ºC'),
	(86812, 111, '2015-03-01 00:23:35.000000', 'temperatura', 447.0000, 'ºC'),
	(86813, 111, '2015-03-01 00:23:36.000000', 'temperatura', 948.0000, 'ºC'),
	(86814, 111, '2015-03-01 00:23:37.000000', 'temperatura', 1001.0000, 'ºC'),
	(86815, 111, '2015-03-01 00:23:38.000000', 'temperatura', 959.0000, 'ºC'),
	(86816, 111, '2015-03-01 00:23:39.000000', 'temperatura', 596.0000, 'ºC'),
	(86817, 111, '2015-03-01 00:23:40.000000', 'temperatura', 101.0000, 'ºC'),
	(86818, 111, '2015-03-01 00:23:41.000000', 'temperatura', 1119.0000, 'ºC'),
	(86819, 111, '2015-03-01 00:23:42.000000', 'temperatura', 493.0000, 'ºC'),
	(86820, 111, '2015-03-01 00:23:43.000000', 'temperatura', 309.0000, 'ºC'),
	(86821, 111, '2015-03-01 00:23:44.000000', 'temperatura', 67.0000, 'ºC'),
	(86822, 111, '2015-03-01 00:23:45.000000', 'temperatura', 609.0000, 'ºC'),
	(86823, 111, '2015-03-01 00:23:46.000000', 'temperatura', 442.0000, 'ºC'),
	(86824, 111, '2015-03-01 00:23:47.000000', 'temperatura', 386.0000, 'ºC'),
	(86825, 111, '2015-03-01 00:23:48.000000', 'temperatura', 605.0000, 'ºC'),
	(86826, 111, '2015-03-01 00:23:49.000000', 'temperatura', 666.0000, 'ºC'),
	(86827, 111, '2015-03-01 00:23:50.000000', 'temperatura', 317.0000, 'ºC'),
	(86828, 111, '2015-03-01 00:23:51.000000', 'temperatura', 786.0000, 'ºC'),
	(86829, 111, '2015-03-01 00:23:52.000000', 'temperatura', 580.0000, 'ºC'),
	(86830, 111, '2015-03-01 00:23:53.000000', 'temperatura', 543.0000, 'ºC'),
	(86831, 111, '2015-03-01 00:23:54.000000', 'temperatura', 975.0000, 'ºC'),
	(86832, 111, '2015-03-01 00:23:55.000000', 'temperatura', 846.0000, 'ºC'),
	(86833, 111, '2015-03-01 00:23:56.000000', 'temperatura', 106.0000, 'ºC'),
	(86834, 111, '2015-03-01 00:23:57.000000', 'temperatura', 393.0000, 'ºC'),
	(86835, 111, '2015-03-01 00:23:58.000000', 'temperatura', 448.0000, 'ºC'),
	(86836, 111, '2015-03-01 00:23:59.000000', 'temperatura', 1062.0000, 'ºC'),
	(86837, 111, '2015-03-01 00:24:00.000000', 'temperatura', 364.0000, 'ºC'),
	(86838, 111, '2015-03-01 00:24:01.000000', 'temperatura', 1037.0000, 'ºC'),
	(86839, 111, '2015-03-01 00:24:02.000000', 'temperatura', 492.0000, 'ºC'),
	(86840, 111, '2015-03-01 00:24:03.000000', 'temperatura', 551.0000, 'ºC'),
	(86841, 111, '2015-03-01 00:24:04.000000', 'temperatura', 79.0000, 'ºC'),
	(86842, 111, '2015-03-01 00:24:05.000000', 'temperatura', 1142.0000, 'ºC'),
	(86843, 111, '2015-03-01 00:24:06.000000', 'temperatura', 672.0000, 'ºC'),
	(86844, 111, '2015-03-01 00:24:07.000000', 'temperatura', 1134.0000, 'ºC'),
	(86845, 111, '2015-03-01 00:24:08.000000', 'temperatura', 55.0000, 'ºC'),
	(86846, 111, '2015-03-01 00:24:09.000000', 'temperatura', 475.0000, 'ºC'),
	(86847, 111, '2015-03-01 00:24:10.000000', 'temperatura', 1010.0000, 'ºC'),
	(86848, 111, '2015-03-01 00:24:11.000000', 'temperatura', 24.0000, 'ºC'),
	(86849, 111, '2015-03-01 00:24:12.000000', 'temperatura', 690.0000, 'ºC'),
	(86850, 111, '2015-03-01 00:24:13.000000', 'temperatura', 980.0000, 'ºC'),
	(86851, 111, '2015-03-01 00:24:14.000000', 'temperatura', 429.0000, 'ºC'),
	(86852, 111, '2015-03-01 00:24:15.000000', 'temperatura', 406.0000, 'ºC'),
	(86853, 111, '2015-03-01 00:24:16.000000', 'temperatura', 745.0000, 'ºC'),
	(86854, 111, '2015-03-01 00:24:17.000000', 'temperatura', 108.0000, 'ºC'),
	(86855, 111, '2015-03-01 00:24:18.000000', 'temperatura', 704.0000, 'ºC'),
	(86856, 111, '2015-03-01 00:24:19.000000', 'temperatura', 795.0000, 'ºC'),
	(86857, 111, '2015-03-01 00:24:20.000000', 'temperatura', 667.0000, 'ºC'),
	(86858, 111, '2015-03-01 00:24:21.000000', 'temperatura', 948.0000, 'ºC'),
	(86859, 111, '2015-03-01 00:24:22.000000', 'temperatura', 341.0000, 'ºC'),
	(86860, 111, '2015-03-01 00:24:23.000000', 'temperatura', 60.0000, 'ºC'),
	(86861, 111, '2015-03-01 00:24:24.000000', 'temperatura', 478.0000, 'ºC'),
	(86862, 111, '2015-03-01 00:24:25.000000', 'temperatura', 1012.0000, 'ºC'),
	(86863, 111, '2015-03-01 00:24:26.000000', 'temperatura', 24.0000, 'ºC'),
	(86864, 111, '2015-03-01 00:24:27.000000', 'temperatura', 687.0000, 'ºC'),
	(86865, 111, '2015-03-01 00:24:28.000000', 'temperatura', 960.0000, 'ºC'),
	(86866, 111, '2015-03-01 00:24:29.000000', 'temperatura', 343.0000, 'ºC'),
	(86867, 111, '2015-03-01 00:24:30.000000', 'temperatura', 35.0000, 'ºC'),
	(86868, 111, '2015-03-01 00:24:31.000000', 'temperatura', 345.0000, 'ºC'),
	(86869, 111, '2015-03-01 00:24:32.000000', 'temperatura', 421.0000, 'ºC'),
	(86870, 111, '2015-03-01 00:24:33.000000', 'temperatura', 1070.0000, 'ºC'),
	(86871, 111, '2015-03-01 00:24:34.000000', 'temperatura', 488.0000, 'ºC'),
	(86872, 111, '2015-03-01 00:24:35.000000', 'temperatura', 432.0000, 'ºC'),
	(86873, 111, '2015-03-01 00:24:36.000000', 'temperatura', 694.0000, 'ºC'),
	(86874, 111, '2015-03-01 00:24:37.000000', 'temperatura', 976.0000, 'ºC'),
	(86875, 111, '2015-03-01 00:24:38.000000', 'temperatura', 397.0000, 'ºC'),
	(86876, 111, '2015-03-01 00:24:39.000000', 'temperatura', 258.0000, 'ºC'),
	(86877, 111, '2015-03-01 00:24:40.000000', 'temperatura', 98.0000, 'ºC'),
	(86878, 111, '2015-03-01 00:24:41.000000', 'temperatura', 917.0000, 'ºC'),
	(86879, 111, '2015-03-01 00:24:42.000000', 'temperatura', 692.0000, 'ºC'),
	(86880, 111, '2015-03-01 00:24:43.000000', 'temperatura', 708.0000, 'ºC'),
	(86881, 111, '2015-03-01 00:24:44.000000', 'temperatura', 263.0000, 'ºC'),
	(86882, 111, '2015-03-01 00:24:45.000000', 'temperatura', 395.0000, 'ºC'),
	(86883, 111, '2015-03-01 00:24:46.000000', 'temperatura', 1186.0000, 'ºC'),
	(86884, 111, '2015-03-01 00:24:47.000000', 'temperatura', 1146.0000, 'ºC'),
	(86885, 111, '2015-03-01 00:24:48.000000', 'temperatura', 973.0000, 'ºC'),
	(86886, 111, '2015-03-01 00:24:49.000000', 'temperatura', 229.0000, 'ºC'),
	(86887, 111, '2015-03-01 00:24:50.000000', 'temperatura', 624.0000, 'ºC'),
	(86888, 111, '2015-03-01 00:24:51.000000', 'temperatura', 32.0000, 'ºC'),
	(86889, 111, '2015-03-01 00:24:52.000000', 'temperatura', 691.0000, 'ºC'),
	(86890, 111, '2015-03-01 00:24:53.000000', 'temperatura', 959.0000, 'ºC'),
	(86891, 111, '2015-03-01 00:24:54.000000', 'temperatura', 323.0000, 'ºC'),
	(86892, 111, '2015-03-01 00:24:55.000000', 'temperatura', 1138.0000, 'ºC'),
	(86893, 111, '2015-03-01 00:24:56.000000', 'temperatura', 1120.0000, 'ºC'),
	(86894, 111, '2015-03-01 00:24:57.000000', 'temperatura', 986.0000, 'ºC'),
	(86895, 111, '2015-03-01 00:24:58.000000', 'temperatura', 373.0000, 'ºC'),
	(86896, 111, '2015-03-01 00:24:59.000000', 'temperatura', 106.0000, 'ºC'),
	(86897, 111, '2015-03-01 00:25:00.000000', 'temperatura', 613.0000, 'ºC'),
	(86898, 111, '2015-03-01 00:25:01.000000', 'temperatura', 346.0000, 'ºC'),
	(86899, 111, '2015-03-01 00:25:02.000000', 'temperatura', 1091.0000, 'ºC'),
	(86900, 111, '2015-03-01 00:25:03.000000', 'temperatura', 819.0000, 'ºC'),
	(86901, 111, '2015-03-01 00:25:04.000000', 'temperatura', 820.0000, 'ºC'),
	(86902, 111, '2015-03-01 00:25:05.000000', 'temperatura', 446.0000, 'ºC'),
	(86903, 111, '2015-03-01 00:25:06.000000', 'temperatura', 970.0000, 'ºC'),
	(86904, 111, '2015-03-01 00:25:07.000000', 'temperatura', 1111.0000, 'ºC'),
	(86905, 111, '2015-03-01 00:25:08.000000', 'temperatura', 245.0000, 'ºC'),
	(86906, 111, '2015-03-01 00:25:09.000000', 'temperatura', 293.0000, 'ºC'),
	(86907, 111, '2015-03-01 00:25:10.000000', 'temperatura', 731.0000, 'ºC'),
	(86908, 111, '2015-03-01 00:25:11.000000', 'temperatura', 378.0000, 'ºC'),
	(86909, 111, '2015-03-01 00:25:12.000000', 'temperatura', 897.0000, 'ºC'),
	(86910, 111, '2015-03-01 00:25:13.000000', 'temperatura', 952.0000, 'ºC'),
	(86911, 111, '2015-03-01 00:25:14.000000', 'temperatura', 868.0000, 'ºC'),
	(86912, 111, '2015-03-01 00:25:15.000000', 'temperatura', 284.0000, 'ºC'),
	(86913, 111, '2015-03-01 00:25:16.000000', 'temperatura', 16.0000, 'ºC'),
	(86914, 111, '2015-03-01 00:25:17.000000', 'temperatura', 428.0000, 'ºC'),
	(86915, 111, '2015-03-01 00:25:18.000000', 'temperatura', 892.0000, 'ºC'),
	(86916, 111, '2015-03-01 00:25:19.000000', 'temperatura', 779.0000, 'ºC'),
	(86917, 111, '2015-03-01 00:25:20.000000', 'temperatura', 20.0000, 'ºC'),
	(86918, 111, '2015-03-01 00:25:21.000000', 'temperatura', 164.0000, 'ºC'),
	(86919, 111, '2015-03-01 00:25:22.000000', 'temperatura', 758.0000, 'ºC'),
	(86920, 111, '2015-03-01 00:25:23.000000', 'temperatura', 901.0000, 'ºC'),
	(86921, 111, '2015-03-01 00:25:24.000000', 'temperatura', 1032.0000, 'ºC'),
	(86922, 111, '2015-03-01 00:25:25.000000', 'temperatura', 54.0000, 'ºC'),
	(86923, 111, '2015-03-01 00:25:26.000000', 'temperatura', 778.0000, 'ºC'),
	(86924, 111, '2015-03-01 00:25:27.000000', 'temperatura', 128.0000, 'ºC'),
	(86925, 111, '2015-03-01 00:25:28.000000', 'temperatura', 704.0000, 'ºC'),
	(86926, 111, '2015-03-01 00:25:29.000000', 'temperatura', 738.0000, 'ºC'),
	(86927, 111, '2015-03-01 00:25:30.000000', 'temperatura', 377.0000, 'ºC'),
	(86928, 111, '2015-03-01 00:25:31.000000', 'temperatura', 871.0000, 'ºC'),
	(86929, 111, '2015-03-01 00:25:32.000000', 'temperatura', 825.0000, 'ºC'),
	(86930, 111, '2015-03-01 00:25:33.000000', 'temperatura', 313.0000, 'ºC'),
	(86931, 111, '2015-03-01 00:25:34.000000', 'temperatura', 289.0000, 'ºC'),
	(86932, 111, '2015-03-01 00:25:35.000000', 'temperatura', 508.0000, 'ºC'),
	(86933, 111, '2015-03-01 00:25:36.000000', 'temperatura', 474.0000, 'ºC'),
	(86934, 111, '2015-03-01 00:25:37.000000', 'temperatura', 847.0000, 'ºC'),
	(86935, 111, '2015-03-01 00:25:38.000000', 'temperatura', 415.0000, 'ºC'),
	(86936, 111, '2015-03-01 00:25:39.000000', 'temperatura', 731.0000, 'ºC'),
	(86937, 111, '2015-03-01 00:25:40.000000', 'temperatura', 11.0000, 'ºC'),
	(86938, 111, '2015-03-01 00:25:41.000000', 'temperatura', 265.0000, 'ºC'),
	(86939, 111, '2015-03-01 00:25:42.000000', 'temperatura', 89.0000, 'ºC'),
	(86940, 111, '2015-03-01 00:25:43.000000', 'temperatura', 854.0000, 'ºC'),
	(86941, 111, '2015-03-01 00:25:44.000000', 'temperatura', 402.0000, 'ºC'),
	(86942, 111, '2015-03-01 00:25:45.000000', 'temperatura', 650.0000, 'ºC'),
	(86943, 111, '2015-03-01 00:25:46.000000', 'temperatura', 843.0000, 'ºC'),
	(86944, 111, '2015-03-01 00:25:47.000000', 'temperatura', 1064.0000, 'ºC'),
	(86945, 111, '2015-03-01 00:25:48.000000', 'temperatura', 394.0000, 'ºC'),
	(86946, 111, '2015-03-01 00:25:49.000000', 'temperatura', 1177.0000, 'ºC'),
	(86947, 111, '2015-03-01 00:25:50.000000', 'temperatura', 1102.0000, 'ºC'),
	(86948, 111, '2015-03-01 00:25:51.000000', 'temperatura', 782.0000, 'ºC'),
	(86949, 111, '2015-03-01 00:25:52.000000', 'temperatura', 604.0000, 'ºC'),
	(86950, 111, '2015-03-01 00:25:53.000000', 'temperatura', 672.0000, 'ºC'),
	(86951, 111, '2015-03-01 00:25:54.000000', 'temperatura', 351.0000, 'ºC'),
	(86952, 111, '2015-03-01 00:25:55.000000', 'temperatura', 941.0000, 'ºC'),
	(86953, 111, '2015-03-01 00:25:56.000000', 'temperatura', 50.0000, 'ºC'),
	(86954, 111, '2015-03-01 00:25:57.000000', 'temperatura', 1027.0000, 'ºC'),
	(86955, 111, '2015-03-01 00:25:58.000000', 'temperatura', 186.0000, 'ºC'),
	(86956, 111, '2015-03-01 00:25:59.000000', 'temperatura', 251.0000, 'ºC'),
	(86957, 111, '2015-03-01 00:26:00.000000', 'temperatura', 695.0000, 'ºC'),
	(86958, 111, '2015-03-01 00:26:01.000000', 'temperatura', 324.0000, 'ºC'),
	(86959, 111, '2015-03-01 00:26:02.000000', 'temperatura', 737.0000, 'ºC'),
	(86960, 111, '2015-03-01 00:26:03.000000', 'temperatura', 314.0000, 'ºC'),
	(86961, 111, '2015-03-01 00:26:04.000000', 'temperatura', 557.0000, 'ºC'),
	(86962, 111, '2015-03-01 00:26:05.000000', 'temperatura', 643.0000, 'ºC'),
	(86963, 111, '2015-03-01 00:26:06.000000', 'temperatura', 345.0000, 'ºC'),
	(86964, 111, '2015-03-01 00:26:07.000000', 'temperatura', 999.0000, 'ºC'),
	(86965, 111, '2015-03-01 00:26:08.000000', 'temperatura', 358.0000, 'ºC'),
	(86966, 111, '2015-03-01 00:26:09.000000', 'temperatura', 1195.0000, 'ºC'),
	(86967, 111, '2015-03-01 00:26:10.000000', 'temperatura', 100.0000, 'ºC'),
	(86968, 111, '2015-03-01 00:26:11.000000', 'temperatura', 516.0000, 'ºC'),
	(86969, 111, '2015-03-01 00:26:12.000000', 'temperatura', 1079.0000, 'ºC'),
	(86970, 111, '2015-03-01 00:26:13.000000', 'temperatura', 249.0000, 'ºC'),
	(86971, 111, '2015-03-01 00:26:14.000000', 'temperatura', 406.0000, 'ºC'),
	(86972, 111, '2015-03-01 00:26:15.000000', 'temperatura', 86.0000, 'ºC'),
	(86973, 111, '2015-03-01 00:26:16.000000', 'temperatura', 410.0000, 'ºC'),
	(86974, 111, '2015-03-01 00:26:17.000000', 'temperatura', 594.0000, 'ºC'),
	(86975, 111, '2015-03-01 00:26:18.000000', 'temperatura', 539.0000, 'ºC'),
	(86976, 111, '2015-03-01 00:26:19.000000', 'temperatura', 913.0000, 'ºC'),
	(86977, 111, '2015-03-01 00:26:20.000000', 'temperatura', 548.0000, 'ºC'),
	(86978, 111, '2015-03-01 00:26:21.000000', 'temperatura', 4.0000, 'ºC'),
	(86979, 111, '2015-03-01 00:26:22.000000', 'temperatura', 776.0000, 'ºC'),
	(86980, 111, '2015-03-01 00:26:23.000000', 'temperatura', 270.0000, 'ºC'),
	(86981, 111, '2015-03-01 00:26:24.000000', 'temperatura', 220.0000, 'ºC'),
	(86982, 111, '2015-03-01 00:26:25.000000', 'temperatura', 291.0000, 'ºC'),
	(86983, 111, '2015-03-01 00:26:26.000000', 'temperatura', 795.0000, 'ºC'),
	(86984, 111, '2015-03-01 00:26:27.000000', 'temperatura', 705.0000, 'ºC'),
	(86985, 111, '2015-03-01 00:26:28.000000', 'temperatura', 1137.0000, 'ºC'),
	(86986, 111, '2015-03-01 00:26:29.000000', 'temperatura', 1174.0000, 'ºC'),
	(86987, 111, '2015-03-01 00:26:30.000000', 'temperatura', 56.0000, 'ºC'),
	(86988, 111, '2015-03-01 00:26:31.000000', 'temperatura', 362.0000, 'ºC'),
	(86989, 111, '2015-03-01 00:26:32.000000', 'temperatura', 441.0000, 'ºC'),
	(86990, 111, '2015-03-01 00:26:33.000000', 'temperatura', 1119.0000, 'ºC'),
	(86991, 111, '2015-03-01 00:26:34.000000', 'temperatura', 671.0000, 'ºC'),
	(86992, 111, '2015-03-01 00:26:35.000000', 'temperatura', 1.0000, 'ºC'),
	(86993, 111, '2015-03-01 00:26:36.000000', 'temperatura', 393.0000, 'ºC'),
	(86994, 111, '2015-03-01 00:26:37.000000', 'temperatura', 762.0000, 'ºC'),
	(86995, 111, '2015-03-01 00:26:38.000000', 'temperatura', 232.0000, 'ºC'),
	(86996, 111, '2015-03-01 00:26:39.000000', 'temperatura', 73.0000, 'ºC'),
	(86997, 111, '2015-03-01 00:26:40.000000', 'temperatura', 871.0000, 'ºC'),
	(86998, 111, '2015-03-01 00:26:41.000000', 'temperatura', 537.0000, 'ºC'),
	(86999, 111, '2015-03-01 00:26:42.000000', 'temperatura', 70.0000, 'ºC'),
	(87000, 111, '2015-03-01 00:26:43.000000', 'temperatura', 1140.0000, 'ºC'),
	(87001, 111, '2015-03-01 00:26:44.000000', 'temperatura', 690.0000, 'ºC'),
	(87002, 111, '2015-03-01 00:26:45.000000', 'temperatura', 33.0000, 'ºC'),
	(87003, 111, '2015-03-01 00:26:46.000000', 'temperatura', 495.0000, 'ºC'),
	(87004, 111, '2015-03-01 00:26:47.000000', 'temperatura', 1177.0000, 'ºC'),
	(87005, 111, '2015-03-01 00:26:48.000000', 'temperatura', 798.0000, 'ºC'),
	(87006, 111, '2015-03-01 00:26:49.000000', 'temperatura', 461.0000, 'ºC'),
	(87007, 111, '2015-03-01 00:26:50.000000', 'temperatura', 1113.0000, 'ºC'),
	(87008, 111, '2015-03-01 00:26:51.000000', 'temperatura', 580.0000, 'ºC'),
	(87009, 111, '2015-03-01 00:26:52.000000', 'temperatura', 761.0000, 'ºC'),
	(87010, 111, '2015-03-01 00:26:53.000000', 'temperatura', 865.0000, 'ºC'),
	(87011, 111, '2015-03-01 00:26:54.000000', 'temperatura', 843.0000, 'ºC'),
	(87012, 111, '2015-03-01 00:26:55.000000', 'temperatura', 419.0000, 'ºC'),
	(87013, 111, '2015-03-01 00:26:56.000000', 'temperatura', 769.0000, 'ºC'),
	(87014, 111, '2015-03-01 00:26:57.000000', 'temperatura', 189.0000, 'ºC'),
	(87015, 111, '2015-03-01 00:26:58.000000', 'temperatura', 1036.0000, 'ºC'),
	(87016, 111, '2015-03-01 00:26:59.000000', 'temperatura', 1014.0000, 'ºC'),
	(87017, 111, '2015-03-01 00:27:00.000000', 'temperatura', 764.0000, 'ºC'),
	(87018, 111, '2015-03-01 00:27:01.000000', 'temperatura', 777.0000, 'ºC'),
	(87019, 111, '2015-03-01 00:27:02.000000', 'temperatura', 396.0000, 'ºC'),
	(87020, 111, '2015-03-01 00:27:03.000000', 'temperatura', 848.0000, 'ºC'),
	(87021, 111, '2015-03-01 00:27:04.000000', 'temperatura', 654.0000, 'ºC'),
	(87022, 111, '2015-03-01 00:27:05.000000', 'temperatura', 728.0000, 'ºC'),
	(87023, 111, '2015-03-01 00:27:06.000000', 'temperatura', 475.0000, 'ºC'),
	(87024, 111, '2015-03-01 00:27:07.000000', 'temperatura', 193.0000, 'ºC'),
	(87025, 111, '2015-03-01 00:27:08.000000', 'temperatura', 741.0000, 'ºC'),
	(87026, 111, '2015-03-01 00:27:09.000000', 'temperatura', 727.0000, 'ºC'),
	(87027, 111, '2015-03-01 00:27:10.000000', 'temperatura', 213.0000, 'ºC'),
	(87028, 111, '2015-03-01 00:27:11.000000', 'temperatura', 84.0000, 'ºC'),
	(87029, 111, '2015-03-01 00:27:12.000000', 'temperatura', 981.0000, 'ºC'),
	(87030, 111, '2015-03-01 00:27:13.000000', 'temperatura', 1055.0000, 'ºC'),
	(87031, 111, '2015-03-01 00:27:14.000000', 'temperatura', 1130.0000, 'ºC'),
	(87032, 111, '2015-03-01 00:27:15.000000', 'temperatura', 85.0000, 'ºC'),
	(87033, 111, '2015-03-01 00:27:16.000000', 'temperatura', 637.0000, 'ºC'),
	(87034, 111, '2015-03-01 00:27:17.000000', 'temperatura', 529.0000, 'ºC'),
	(87035, 111, '2015-03-01 00:27:18.000000', 'temperatura', 734.0000, 'ºC'),
	(87036, 111, '2015-03-01 00:27:19.000000', 'temperatura', 887.0000, 'ºC'),
	(87037, 111, '2015-03-01 00:27:20.000000', 'temperatura', 1030.0000, 'ºC'),
	(87038, 111, '2015-03-01 00:27:21.000000', 'temperatura', 90.0000, 'ºC'),
	(87039, 111, '2015-03-01 00:27:22.000000', 'temperatura', 960.0000, 'ºC'),
	(87040, 111, '2015-03-01 00:27:23.000000', 'temperatura', 932.0000, 'ºC'),
	(87041, 111, '2015-03-01 00:27:24.000000', 'temperatura', 578.0000, 'ºC'),
	(87042, 111, '2015-03-01 00:27:25.000000', 'temperatura', 97.0000, 'ºC'),
	(87043, 111, '2015-03-01 00:27:26.000000', 'temperatura', 1149.0000, 'ºC'),
	(87044, 111, '2015-03-01 00:27:27.000000', 'temperatura', 657.0000, 'ºC'),
	(87045, 111, '2015-03-01 00:27:28.000000', 'temperatura', 1039.0000, 'ºC'),
	(87046, 111, '2015-03-01 00:27:29.000000', 'temperatura', 822.0000, 'ºC'),
	(87047, 111, '2015-03-01 00:27:30.000000', 'temperatura', 994.0000, 'ºC'),
	(87048, 111, '2015-03-01 00:27:31.000000', 'temperatura', 103.0000, 'ºC'),
	(87049, 111, '2015-03-01 00:27:32.000000', 'temperatura', 1136.0000, 'ºC'),
	(87050, 111, '2015-03-01 00:27:33.000000', 'temperatura', 571.0000, 'ºC'),
	(87051, 111, '2015-03-01 00:27:34.000000', 'temperatura', 646.0000, 'ºC'),
	(87052, 111, '2015-03-01 00:27:35.000000', 'temperatura', 319.0000, 'ºC'),
	(87053, 111, '2015-03-01 00:27:36.000000', 'temperatura', 856.0000, 'ºC'),
	(87054, 111, '2015-03-01 00:27:37.000000', 'temperatura', 923.0000, 'ºC'),
	(87055, 111, '2015-03-01 00:27:38.000000', 'temperatura', 848.0000, 'ºC'),
	(87056, 111, '2015-03-01 00:27:39.000000', 'temperatura', 271.0000, 'ºC'),
	(87057, 111, '2015-03-01 00:27:40.000000', 'temperatura', 10.0000, 'ºC'),
	(87058, 111, '2015-03-01 00:27:41.000000', 'temperatura', 441.0000, 'ºC'),
	(87059, 111, '2015-03-01 00:27:42.000000', 'temperatura', 973.0000, 'ºC'),
	(87060, 111, '2015-03-01 00:27:43.000000', 'temperatura', 1143.0000, 'ºC'),
	(87061, 111, '2015-03-01 00:27:44.000000', 'temperatura', 397.0000, 'ºC'),
	(87062, 111, '2015-03-01 00:27:45.000000', 'temperatura', 955.0000, 'ºC'),
	(87063, 111, '2015-03-01 00:27:46.000000', 'temperatura', 1187.0000, 'ºC'),
	(87064, 111, '2015-03-01 00:27:47.000000', 'temperatura', 668.0000, 'ºC'),
	(87065, 111, '2015-03-01 00:27:48.000000', 'temperatura', 979.0000, 'ºC'),
	(87066, 111, '2015-03-01 00:27:49.000000', 'temperatura', 491.0000, 'ºC'),
	(87067, 111, '2015-03-01 00:27:50.000000', 'temperatura', 719.0000, 'ºC'),
	(87068, 111, '2015-03-01 00:27:51.000000', 'temperatura', 925.0000, 'ºC'),
	(87069, 111, '2015-03-01 00:27:52.000000', 'temperatura', 66.0000, 'ºC'),
	(87070, 111, '2015-03-01 00:27:53.000000', 'temperatura', 1158.0000, 'ºC'),
	(87071, 111, '2015-03-01 00:27:54.000000', 'temperatura', 793.0000, 'ºC'),
	(87072, 111, '2015-03-01 00:27:55.000000', 'temperatura', 489.0000, 'ºC'),
	(87073, 111, '2015-03-01 00:27:56.000000', 'temperatura', 65.0000, 'ºC'),
	(87074, 111, '2015-03-01 00:27:57.000000', 'temperatura', 62.0000, 'ºC'),
	(87075, 111, '2015-03-01 00:27:58.000000', 'temperatura', 113.0000, 'ºC'),
	(87076, 111, '2015-03-01 00:27:59.000000', 'temperatura', 378.0000, 'ºC'),
	(87077, 111, '2015-03-01 00:28:00.000000', 'temperatura', 354.0000, 'ºC'),
	(87078, 111, '2015-03-01 00:28:01.000000', 'temperatura', 636.0000, 'ºC'),
	(87079, 111, '2015-03-01 00:28:02.000000', 'temperatura', 919.0000, 'ºC'),
	(87080, 111, '2015-03-01 00:28:03.000000', 'temperatura', 287.0000, 'ºC'),
	(87081, 111, '2015-03-01 00:28:04.000000', 'temperatura', 1078.0000, 'ºC'),
	(87082, 111, '2015-03-01 00:28:05.000000', 'temperatura', 929.0000, 'ºC'),
	(87083, 111, '2015-03-01 00:28:06.000000', 'temperatura', 213.0000, 'ºC'),
	(87084, 111, '2015-03-01 00:28:07.000000', 'temperatura', 678.0000, 'ºC'),
	(87085, 111, '2015-03-01 00:28:08.000000', 'temperatura', 351.0000, 'ºC'),
	(87086, 111, '2015-03-01 00:28:09.000000', 'temperatura', 921.0000, 'ºC'),
	(87087, 111, '2015-03-01 00:28:10.000000', 'temperatura', 1154.0000, 'ºC'),
	(87088, 111, '2015-03-01 00:28:11.000000', 'temperatura', 605.0000, 'ºC'),
	(87089, 111, '2015-03-01 00:28:12.000000', 'temperatura', 765.0000, 'ºC'),
	(87090, 111, '2015-03-01 00:28:13.000000', 'temperatura', 809.0000, 'ºC'),
	(87091, 111, '2015-03-01 00:28:14.000000', 'temperatura', 552.0000, 'ºC'),
	(87092, 111, '2015-03-01 00:28:15.000000', 'temperatura', 334.0000, 'ºC'),
	(87093, 111, '2015-03-01 00:28:16.000000', 'temperatura', 16.0000, 'ºC'),
	(87094, 111, '2015-03-01 00:28:17.000000', 'temperatura', 276.0000, 'ºC'),
	(87095, 111, '2015-03-01 00:28:18.000000', 'temperatura', 132.0000, 'ºC'),
	(87096, 111, '2015-03-01 00:28:19.000000', 'temperatura', 1033.0000, 'ºC'),
	(87097, 111, '2015-03-01 00:28:20.000000', 'temperatura', 1171.0000, 'ºC'),
	(87098, 111, '2015-03-01 00:28:21.000000', 'temperatura', 357.0000, 'ºC'),
	(87099, 111, '2015-03-01 00:28:22.000000', 'temperatura', 671.0000, 'ºC'),
	(87100, 111, '2015-03-01 00:28:23.000000', 'temperatura', 1084.0000, 'ºC'),
	(87101, 111, '2015-03-01 00:28:24.000000', 'temperatura', 1006.0000, 'ºC'),
	(87102, 111, '2015-03-01 00:28:25.000000', 'temperatura', 582.0000, 'ºC'),
	(87103, 111, '2015-03-01 00:28:26.000000', 'temperatura', 1089.0000, 'ºC'),
	(87104, 111, '2015-03-01 00:28:27.000000', 'temperatura', 103.0000, 'ºC'),
	(87105, 111, '2015-03-01 00:28:28.000000', 'temperatura', 845.0000, 'ºC'),
	(87106, 111, '2015-03-01 00:28:29.000000', 'temperatura', 318.0000, 'ºC'),
	(87107, 111, '2015-03-01 00:28:30.000000', 'temperatura', 254.0000, 'ºC'),
	(87108, 111, '2015-03-01 00:28:31.000000', 'temperatura', 317.0000, 'ºC'),
	(87109, 111, '2015-03-01 00:28:32.000000', 'temperatura', 823.0000, 'ºC'),
	(87110, 111, '2015-03-01 00:28:33.000000', 'temperatura', 767.0000, 'ºC'),
	(87111, 111, '2015-03-01 00:28:34.000000', 'temperatura', 165.0000, 'ºC'),
	(87112, 111, '2015-03-01 00:28:35.000000', 'temperatura', 923.0000, 'ºC'),
	(87113, 111, '2015-03-01 00:28:36.000000', 'temperatura', 522.0000, 'ºC'),
	(87114, 111, '2015-03-01 00:28:37.000000', 'temperatura', 1042.0000, 'ºC'),
	(87115, 111, '2015-03-01 00:28:38.000000', 'temperatura', 46.0000, 'ºC'),
	(87116, 111, '2015-03-01 00:28:39.000000', 'temperatura', 703.0000, 'ºC'),
	(87117, 111, '2015-03-01 00:28:40.000000', 'temperatura', 978.0000, 'ºC'),
	(87118, 111, '2015-03-01 00:28:41.000000', 'temperatura', 382.0000, 'ºC'),
	(87119, 111, '2015-03-01 00:28:42.000000', 'temperatura', 178.0000, 'ºC'),
	(87120, 111, '2015-03-01 00:28:43.000000', 'temperatura', 943.0000, 'ºC'),
	(87121, 111, '2015-03-01 00:28:44.000000', 'temperatura', 582.0000, 'ºC'),
	(87122, 111, '2015-03-01 00:28:45.000000', 'temperatura', 79.0000, 'ºC'),
	(87123, 111, '2015-03-01 00:28:46.000000', 'temperatura', 1052.0000, 'ºC'),
	(87124, 111, '2015-03-01 00:28:47.000000', 'temperatura', 224.0000, 'ºC'),
	(87125, 111, '2015-03-01 00:28:48.000000', 'temperatura', 365.0000, 'ºC'),
	(87126, 111, '2015-03-01 00:28:49.000000', 'temperatura', 1154.0000, 'ºC'),
	(87127, 111, '2015-03-01 00:28:50.000000', 'temperatura', 1074.0000, 'ºC'),
	(87128, 111, '2015-03-01 00:28:51.000000', 'temperatura', 710.0000, 'ºC'),
	(87129, 111, '2015-03-01 00:28:52.000000', 'temperatura', 328.0000, 'ºC'),
	(87130, 111, '2015-03-01 00:28:53.000000', 'temperatura', 711.0000, 'ºC'),
	(87131, 111, '2015-03-01 00:28:54.000000', 'temperatura', 173.0000, 'ºC'),
	(87132, 111, '2015-03-01 00:28:55.000000', 'temperatura', 1130.0000, 'ºC'),
	(87133, 111, '2015-03-01 00:28:56.000000', 'temperatura', 334.0000, 'ºC'),
	(87134, 111, '2015-03-01 00:28:57.000000', 'temperatura', 678.0000, 'ºC'),
	(87135, 111, '2015-03-01 00:28:58.000000', 'temperatura', 1189.0000, 'ºC'),
	(87136, 111, '2015-03-01 00:28:59.000000', 'temperatura', 310.0000, 'ºC'),
	(87137, 111, '2015-03-01 00:29:00.000000', 'temperatura', 386.0000, 'ºC'),
	(87138, 111, '2015-03-01 00:29:01.000000', 'temperatura', 998.0000, 'ºC'),
	(87139, 111, '2015-03-01 00:29:02.000000', 'temperatura', 232.0000, 'ºC'),
	(87140, 111, '2015-03-01 00:29:03.000000', 'temperatura', 566.0000, 'ºC'),
	(87141, 111, '2015-03-01 00:29:04.000000', 'temperatura', 936.0000, 'ºC'),
	(87142, 111, '2015-03-01 00:29:05.000000', 'temperatura', 582.0000, 'ºC'),
	(87143, 111, '2015-03-01 00:29:06.000000', 'temperatura', 101.0000, 'ºC'),
	(87144, 111, '2015-03-01 00:29:07.000000', 'temperatura', 1161.0000, 'ºC'),
	(87145, 111, '2015-03-01 00:29:08.000000', 'temperatura', 704.0000, 'ºC'),
	(87146, 111, '2015-03-01 00:29:09.000000', 'temperatura', 34.0000, 'ºC'),
	(87147, 111, '2015-03-01 00:29:10.000000', 'temperatura', 461.0000, 'ºC'),
	(87148, 111, '2015-03-01 00:29:11.000000', 'temperatura', 1002.0000, 'ºC'),
	(87149, 111, '2015-03-01 00:29:12.000000', 'temperatura', 26.0000, 'ºC'),
	(87150, 111, '2015-03-01 00:29:13.000000', 'temperatura', 728.0000, 'ºC'),
	(87151, 111, '2015-03-01 00:29:14.000000', 'temperatura', 1160.0000, 'ºC'),
	(87152, 111, '2015-03-01 00:29:15.000000', 'temperatura', 18.0000, 'ºC'),
	(87153, 111, '2015-03-01 00:29:16.000000', 'temperatura', 212.0000, 'ºC'),
	(87154, 111, '2015-03-01 00:29:17.000000', 'temperatura', 1003.0000, 'ºC'),
	(87155, 111, '2015-03-01 00:29:18.000000', 'temperatura', 782.0000, 'ºC'),
	(87156, 111, '2015-03-01 00:29:19.000000', 'temperatura', 899.0000, 'ºC'),
	(87157, 111, '2015-03-01 00:29:20.000000', 'temperatura', 951.0000, 'ºC'),
	(87158, 111, '2015-03-01 00:29:21.000000', 'temperatura', 857.0000, 'ºC'),
	(87159, 111, '2015-03-01 00:29:22.000000', 'temperatura', 234.0000, 'ºC'),
	(87160, 111, '2015-03-01 00:29:23.000000', 'temperatura', 1000.0000, 'ºC'),
	(87161, 111, '2015-03-01 00:29:24.000000', 'temperatura', 697.0000, 'ºC'),
	(87162, 111, '2015-03-01 00:29:25.000000', 'temperatura', 486.0000, 'ºC'),
	(87163, 111, '2015-03-01 00:29:26.000000', 'temperatura', 339.0000, 'ºC'),
	(87164, 111, '2015-03-01 00:29:27.000000', 'temperatura', 238.0000, 'ºC'),
	(87165, 111, '2015-03-01 00:29:28.000000', 'temperatura', 175.0000, 'ºC'),
	(87166, 111, '2015-03-01 00:29:29.000000', 'temperatura', 162.0000, 'ºC'),
	(87167, 111, '2015-03-01 00:29:30.000000', 'temperatura', 285.0000, 'ºC'),
	(87168, 111, '2015-03-01 00:29:31.000000', 'temperatura', 940.0000, 'ºC'),
	(87169, 111, '2015-03-01 00:29:32.000000', 'temperatura', 247.0000, 'ºC'),
	(87170, 111, '2015-03-01 00:29:33.000000', 'temperatura', 812.0000, 'ºC'),
	(87171, 111, '2015-03-01 00:29:34.000000', 'temperatura', 921.0000, 'ºC'),
	(87172, 111, '2015-03-01 00:29:35.000000', 'temperatura', 970.0000, 'ºC'),
	(87173, 111, '2015-03-01 00:29:36.000000', 'temperatura', 889.0000, 'ºC'),
	(87174, 111, '2015-03-01 00:29:37.000000', 'temperatura', 334.0000, 'ºC'),
	(87175, 111, '2015-03-01 00:29:38.000000', 'temperatura', 206.0000, 'ºC'),
	(87176, 111, '2015-03-01 00:29:39.000000', 'temperatura', 25.0000, 'ºC'),
	(87177, 111, '2015-03-01 00:29:40.000000', 'temperatura', 708.0000, 'ºC'),
	(87178, 111, '2015-03-01 00:29:41.000000', 'temperatura', 1067.0000, 'ºC'),
	(87179, 111, '2015-03-01 00:29:42.000000', 'temperatura', 812.0000, 'ºC'),
	(87180, 111, '2015-03-01 00:29:43.000000', 'temperatura', 858.0000, 'ºC'),
	(87181, 111, '2015-03-01 00:29:44.000000', 'temperatura', 657.0000, 'ºC'),
	(87182, 111, '2015-03-01 00:29:45.000000', 'temperatura', 708.0000, 'ºC'),
	(87183, 111, '2015-03-01 00:29:46.000000', 'temperatura', 373.0000, 'ºC'),
	(87184, 111, '2015-03-01 00:29:47.000000', 'temperatura', 940.0000, 'ºC'),
	(87185, 111, '2015-03-01 00:29:48.000000', 'temperatura', 1182.0000, 'ºC'),
	(87186, 111, '2015-03-01 00:29:49.000000', 'temperatura', 690.0000, 'ºC'),
	(87187, 111, '2015-03-01 00:29:50.000000', 'temperatura', 1104.0000, 'ºC'),
	(87188, 111, '2015-03-01 00:29:51.000000', 'temperatura', 1051.0000, 'ºC'),
	(87189, 111, '2015-03-01 00:29:52.000000', 'temperatura', 745.0000, 'ºC'),
	(87190, 111, '2015-03-01 00:29:53.000000', 'temperatura', 572.0000, 'ºC'),
	(87191, 111, '2015-03-01 00:29:54.000000', 'temperatura', 626.0000, 'ºC'),
	(87192, 111, '2015-03-01 00:29:55.000000', 'temperatura', 216.0000, 'ºC'),
	(87193, 111, '2015-03-01 00:29:56.000000', 'temperatura', 401.0000, 'ºC'),
	(87194, 111, '2015-03-01 00:29:57.000000', 'temperatura', 157.0000, 'ºC'),
	(87195, 111, '2015-03-01 00:29:58.000000', 'temperatura', 781.0000, 'ºC'),
	(87196, 111, '2015-03-01 00:29:59.000000', 'temperatura', 1037.0000, 'ºC'),
	(87197, 111, '2015-03-01 00:30:00.000000', 'temperatura', 444.0000, 'ºC'),
	(87198, 111, '2015-03-01 00:30:01.000000', 'temperatura', 307.0000, 'ºC'),
	(87199, 111, '2015-03-01 00:30:02.000000', 'temperatura', 203.0000, 'ºC'),
	(87200, 111, '2015-03-01 00:30:03.000000', 'temperatura', 96.0000, 'ºC'),
	(87201, 111, '2015-03-01 00:30:04.000000', 'temperatura', 1071.0000, 'ºC'),
	(87202, 111, '2015-03-01 00:30:05.000000', 'temperatura', 268.0000, 'ºC'),
	(87203, 111, '2015-03-01 00:30:06.000000', 'temperatura', 526.0000, 'ºC'),
	(87204, 111, '2015-03-01 00:30:07.000000', 'temperatura', 629.0000, 'ºC'),
	(87205, 111, '2015-03-01 00:30:08.000000', 'temperatura', 364.0000, 'ºC'),
	(87206, 111, '2015-03-01 00:30:09.000000', 'temperatura', 1136.0000, 'ºC'),
	(87207, 111, '2015-03-01 00:30:10.000000', 'temperatura', 989.0000, 'ºC'),
	(87208, 111, '2015-03-01 00:30:11.000000', 'temperatura', 338.0000, 'ºC'),
	(87209, 111, '2015-03-01 00:30:12.000000', 'temperatura', 1122.0000, 'ºC'),
	(87210, 111, '2015-03-01 00:30:13.000000', 'temperatura', 996.0000, 'ºC'),
	(87211, 111, '2015-03-01 00:30:14.000000', 'temperatura', 413.0000, 'ºC'),
	(87212, 111, '2015-03-01 00:30:15.000000', 'temperatura', 280.0000, 'ºC'),
	(87213, 111, '2015-03-01 00:30:16.000000', 'temperatura', 160.0000, 'ºC'),
	(87214, 111, '2015-03-01 00:30:17.000000', 'temperatura', 1161.0000, 'ºC'),
	(87215, 111, '2015-03-01 00:30:18.000000', 'temperatura', 527.0000, 'ºC'),
	(87216, 111, '2015-03-01 00:30:19.000000', 'temperatura', 353.0000, 'ºC'),
	(87217, 111, '2015-03-01 00:30:20.000000', 'temperatura', 183.0000, 'ºC'),
	(87218, 111, '2015-03-01 00:30:21.000000', 'temperatura', 1058.0000, 'ºC'),
	(87219, 111, '2015-03-01 00:30:22.000000', 'temperatura', 1141.0000, 'ºC'),
	(87220, 111, '2015-03-01 00:30:23.000000', 'temperatura', 130.0000, 'ºC'),
	(87221, 111, '2015-03-01 00:30:24.000000', 'temperatura', 829.0000, 'ºC'),
	(87222, 111, '2015-03-01 00:30:25.000000', 'temperatura', 157.0000, 'ºC'),
	(87223, 111, '2015-03-01 00:30:26.000000', 'temperatura', 698.0000, 'ºC'),
	(87224, 111, '2015-03-01 00:30:27.000000', 'temperatura', 617.0000, 'ºC'),
	(87225, 111, '2015-03-01 00:30:28.000000', 'temperatura', 993.0000, 'ºC'),
	(87226, 111, '2015-03-01 00:30:29.000000', 'temperatura', 716.0000, 'ºC'),
	(87227, 111, '2015-03-01 00:30:30.000000', 'temperatura', 601.0000, 'ºC'),
	(87228, 111, '2015-03-01 00:30:31.000000', 'temperatura', 857.0000, 'ºC'),
	(87229, 111, '2015-03-01 00:30:32.000000', 'temperatura', 84.0000, 'ºC'),
	(87230, 111, '2015-03-01 00:30:33.000000', 'temperatura', 250.0000, 'ºC'),
	(87231, 111, '2015-03-01 00:30:34.000000', 'temperatura', 996.0000, 'ºC'),
	(87232, 111, '2015-03-01 00:30:35.000000', 'temperatura', 631.0000, 'ºC'),
	(87233, 111, '2015-03-01 00:30:36.000000', 'temperatura', 169.0000, 'ºC'),
	(87234, 111, '2015-03-01 00:30:37.000000', 'temperatura', 151.0000, 'ºC'),
	(87235, 111, '2015-03-01 00:30:38.000000', 'temperatura', 248.0000, 'ºC'),
	(87236, 111, '2015-03-01 00:30:39.000000', 'temperatura', 788.0000, 'ºC'),
	(87237, 111, '2015-03-01 00:30:40.000000', 'temperatura', 795.0000, 'ºC'),
	(87238, 111, '2015-03-01 00:30:41.000000', 'temperatura', 413.0000, 'ºC'),
	(87239, 111, '2015-03-01 00:30:42.000000', 'temperatura', 880.0000, 'ºC'),
	(87240, 111, '2015-03-01 00:30:43.000000', 'temperatura', 760.0000, 'ºC'),
	(87241, 111, '2015-03-01 00:30:44.000000', 'temperatura', 1160.0000, 'ºC'),
	(87242, 111, '2015-03-01 00:30:45.000000', 'temperatura', 1123.0000, 'ºC'),
	(87243, 111, '2015-03-01 00:30:46.000000', 'temperatura', 935.0000, 'ºC'),
	(87244, 111, '2015-03-01 00:30:47.000000', 'temperatura', 106.0000, 'ºC'),
	(87245, 111, '2015-03-01 00:30:48.000000', 'temperatura', 126.0000, 'ºC'),
	(87246, 111, '2015-03-01 00:30:49.000000', 'temperatura', 311.0000, 'ºC'),
	(87247, 111, '2015-03-01 00:30:50.000000', 'temperatura', 1179.0000, 'ºC'),
	(87248, 111, '2015-03-01 00:30:51.000000', 'temperatura', 161.0000, 'ºC'),
	(87249, 111, '2015-03-01 00:30:52.000000', 'temperatura', 868.0000, 'ºC'),
	(87250, 111, '2015-03-01 00:30:53.000000', 'temperatura', 259.0000, 'ºC'),
	(87251, 111, '2015-03-01 00:30:54.000000', 'temperatura', 1089.0000, 'ºC'),
	(87252, 111, '2015-03-01 00:30:55.000000', 'temperatura', 1072.0000, 'ºC'),
	(87253, 111, '2015-03-01 00:30:56.000000', 'temperatura', 891.0000, 'ºC'),
	(87254, 111, '2015-03-01 00:30:57.000000', 'temperatura', 39.0000, 'ºC'),
	(87255, 111, '2015-03-01 00:30:58.000000', 'temperatura', 1123.0000, 'ºC'),
	(87256, 111, '2015-03-01 00:30:59.000000', 'temperatura', 699.0000, 'ºC'),
	(87257, 111, '2015-03-01 00:31:00.000000', 'temperatura', 125.0000, 'ºC'),
	(87258, 111, '2015-03-01 00:31:01.000000', 'temperatura', 929.0000, 'ºC'),
	(87259, 111, '2015-03-01 00:31:02.000000', 'temperatura', 669.0000, 'ºC'),
	(87260, 111, '2015-03-01 00:31:03.000000', 'temperatura', 560.0000, 'ºC'),
	(87261, 111, '2015-03-01 00:31:04.000000', 'temperatura', 794.0000, 'ºC'),
	(87262, 111, '2015-03-01 00:31:05.000000', 'temperatura', 1090.0000, 'ºC'),
	(87263, 111, '2015-03-01 00:31:06.000000', 'temperatura', 669.0000, 'ºC'),
	(87264, 111, '2015-03-01 00:31:07.000000', 'temperatura', 76.0000, 'ºC'),
	(87265, 111, '2015-03-01 00:31:08.000000', 'temperatura', 774.0000, 'ºC'),
	(87266, 111, '2015-03-01 00:31:09.000000', 'temperatura', 43.0000, 'ºC'),
	(87267, 111, '2015-03-01 00:31:10.000000', 'temperatura', 294.0000, 'ºC'),
	(87268, 111, '2015-03-01 00:31:11.000000', 'temperatura', 142.0000, 'ºC'),
	(87269, 111, '2015-03-01 00:31:12.000000', 'temperatura', 1027.0000, 'ºC'),
	(87270, 111, '2015-03-01 00:31:13.000000', 'temperatura', 1112.0000, 'ºC'),
	(87271, 111, '2015-03-01 00:31:14.000000', 'temperatura', 77.0000, 'ºC'),
	(87272, 111, '2015-03-01 00:31:15.000000', 'temperatura', 651.0000, 'ºC'),
	(87273, 111, '2015-03-01 00:31:16.000000', 'temperatura', 625.0000, 'ºC'),
	(87274, 111, '2015-03-01 00:31:17.000000', 'temperatura', 1170.0000, 'ºC'),
	(87275, 111, '2015-03-01 00:31:18.000000', 'temperatura', 376.0000, 'ºC'),
	(87276, 111, '2015-03-01 00:31:19.000000', 'temperatura', 770.0000, 'ºC'),
	(87277, 111, '2015-03-01 00:31:20.000000', 'temperatura', 321.0000, 'ºC'),
	(87278, 111, '2015-03-01 00:31:21.000000', 'temperatura', 498.0000, 'ºC'),
	(87279, 111, '2015-03-01 00:31:22.000000', 'temperatura', 325.0000, 'ºC'),
	(87280, 111, '2015-03-01 00:31:23.000000', 'temperatura', 133.0000, 'ºC'),
	(87281, 111, '2015-03-01 00:31:24.000000', 'temperatura', 891.0000, 'ºC'),
	(87282, 111, '2015-03-01 00:31:25.000000', 'temperatura', 457.0000, 'ºC'),
	(87283, 111, '2015-03-01 00:31:26.000000', 'temperatura', 812.0000, 'ºC'),
	(87284, 111, '2015-03-01 00:31:27.000000', 'temperatura', 290.0000, 'ºC'),
	(87285, 111, '2015-03-01 00:31:28.000000', 'temperatura', 216.0000, 'ºC'),
	(87286, 111, '2015-03-01 00:31:29.000000', 'temperatura', 208.0000, 'ºC'),
	(87287, 111, '2015-03-01 00:31:30.000000', 'temperatura', 391.0000, 'ºC'),
	(87288, 111, '2015-03-01 00:31:31.000000', 'temperatura', 134.0000, 'ºC'),
	(87289, 111, '2015-03-01 00:31:32.000000', 'temperatura', 697.0000, 'ºC'),
	(87290, 111, '2015-03-01 00:31:33.000000', 'temperatura', 682.0000, 'ºC'),
	(87291, 111, '2015-03-01 00:31:34.000000', 'temperatura', 120.0000, 'ºC'),
	(87292, 111, '2015-03-01 00:31:35.000000', 'temperatura', 953.0000, 'ºC'),
	(87293, 111, '2015-03-01 00:31:36.000000', 'temperatura', 808.0000, 'ºC'),
	(87294, 111, '2015-03-01 00:31:37.000000', 'temperatura', 1180.0000, 'ºC'),
	(87295, 111, '2015-03-01 00:31:38.000000', 'temperatura', 1078.0000, 'ºC'),
	(87296, 111, '2015-03-01 00:31:39.000000', 'temperatura', 648.0000, 'ºC'),
	(87297, 111, '2015-03-01 00:31:40.000000', 'temperatura', 8.0000, 'ºC'),
	(87298, 111, '2015-03-01 00:31:41.000000', 'temperatura', 495.0000, 'ºC'),
	(87299, 111, '2015-03-01 00:31:42.000000', 'temperatura', 53.0000, 'ºC'),
	(87300, 111, '2015-03-01 00:31:43.000000', 'temperatura', 1178.0000, 'ºC'),
	(87301, 111, '2015-03-01 00:31:44.000000', 'temperatura', 933.0000, 'ºC'),
	(87302, 111, '2015-03-01 00:31:45.000000', 'temperatura', 1132.0000, 'ºC'),
	(87303, 111, '2015-03-01 00:31:46.000000', 'temperatura', 462.0000, 'ºC'),
	(87304, 111, '2015-03-01 00:31:47.000000', 'temperatura', 114.0000, 'ºC'),
	(87305, 111, '2015-03-01 00:31:48.000000', 'temperatura', 385.0000, 'ºC'),
	(87306, 111, '2015-03-01 00:31:49.000000', 'temperatura', 385.0000, 'ºC'),
	(87307, 111, '2015-03-01 00:31:50.000000', 'temperatura', 770.0000, 'ºC'),
	(87308, 111, '2015-03-01 00:31:51.000000', 'temperatura', 294.0000, 'ºC'),
	(87309, 111, '2015-03-01 00:31:52.000000', 'temperatura', 361.0000, 'ºC'),
	(87310, 111, '2015-03-01 00:31:53.000000', 'temperatura', 924.0000, 'ºC'),
	(87311, 111, '2015-03-01 00:31:54.000000', 'temperatura', 1136.0000, 'ºC'),
	(87312, 111, '2015-03-01 00:31:55.000000', 'temperatura', 510.0000, 'ºC'),
	(87313, 111, '2015-03-01 00:31:56.000000', 'temperatura', 344.0000, 'ºC'),
	(87314, 111, '2015-03-01 00:31:57.000000', 'temperatura', 189.0000, 'ºC'),
	(87315, 111, '2015-03-01 00:31:58.000000', 'temperatura', 1114.0000, 'ºC'),
	(87316, 111, '2015-03-01 00:31:59.000000', 'temperatura', 205.0000, 'ºC'),
	(87317, 111, '2015-03-01 00:32:00.000000', 'temperatura', 82.0000, 'ºC'),
	(87318, 111, '2015-03-01 00:32:01.000000', 'temperatura', 996.0000, 'ºC'),
	(87319, 111, '2015-03-01 00:32:02.000000', 'temperatura', 1136.0000, 'ºC'),
	(87320, 111, '2015-03-01 00:32:03.000000', 'temperatura', 293.0000, 'ºC'),
	(87321, 111, '2015-03-01 00:32:04.000000', 'temperatura', 454.0000, 'ºC'),
	(87322, 111, '2015-03-01 00:32:05.000000', 'temperatura', 194.0000, 'ºC'),
	(87323, 111, '2015-03-01 00:32:06.000000', 'temperatura', 808.0000, 'ºC'),
	(87324, 111, '2015-03-01 00:32:07.000000', 'temperatura', 1057.0000, 'ºC'),
	(87325, 111, '2015-03-01 00:32:08.000000', 'temperatura', 462.0000, 'ºC'),
	(87326, 111, '2015-03-01 00:32:09.000000', 'temperatura', 340.0000, 'ºC'),
	(87327, 111, '2015-03-01 00:32:10.000000', 'temperatura', 313.0000, 'ºC'),
	(87328, 111, '2015-03-01 00:32:11.000000', 'temperatura', 548.0000, 'ºC'),
	(87329, 111, '2015-03-01 00:32:12.000000', 'temperatura', 602.0000, 'ºC'),
	(87330, 111, '2015-03-01 00:32:13.000000', 'temperatura', 164.0000, 'ºC'),
	(87331, 111, '2015-03-01 00:32:14.000000', 'temperatura', 216.0000, 'ºC'),
	(87332, 111, '2015-03-01 00:32:15.000000', 'temperatura', 588.0000, 'ºC'),
	(87333, 111, '2015-03-01 00:32:16.000000', 'temperatura', 1092.0000, 'ºC'),
	(87334, 111, '2015-03-01 00:32:17.000000', 'temperatura', 98.0000, 'ºC'),
	(87335, 111, '2015-03-01 00:32:18.000000', 'temperatura', 812.0000, 'ºC'),
	(87336, 111, '2015-03-01 00:32:19.000000', 'temperatura', 166.0000, 'ºC'),
	(87337, 111, '2015-03-01 00:32:20.000000', 'temperatura', 798.0000, 'ºC'),
	(87338, 111, '2015-03-01 00:32:21.000000', 'temperatura', 1090.0000, 'ºC'),
	(87339, 111, '2015-03-01 00:32:22.000000', 'temperatura', 658.0000, 'ºC'),
	(87340, 111, '2015-03-01 00:32:23.000000', 'temperatura', 18.0000, 'ºC'),
	(87341, 111, '2015-03-01 00:32:24.000000', 'temperatura', 518.0000, 'ºC'),
	(87342, 111, '2015-03-01 00:32:25.000000', 'temperatura', 135.0000, 'ºC'),
	(87343, 111, '2015-03-01 00:32:26.000000', 'temperatura', 322.0000, 'ºC'),
	(87344, 111, '2015-03-01 00:32:27.000000', 'temperatura', 8.0000, 'ºC'),
	(87345, 111, '2015-03-01 00:32:28.000000', 'temperatura', 271.0000, 'ºC'),
	(87346, 111, '2015-03-01 00:32:29.000000', 'temperatura', 134.0000, 'ºC'),
	(87347, 111, '2015-03-01 00:32:30.000000', 'temperatura', 1056.0000, 'ºC'),
	(87348, 111, '2015-03-01 00:32:31.000000', 'temperatura', 79.0000, 'ºC'),
	(87349, 111, '2015-03-01 00:32:32.000000', 'temperatura', 827.0000, 'ºC'),
	(87350, 111, '2015-03-01 00:32:33.000000', 'temperatura', 299.0000, 'ºC'),
	(87351, 111, '2015-03-01 00:32:34.000000', 'temperatura', 214.0000, 'ºC'),
	(87352, 111, '2015-03-01 00:32:35.000000', 'temperatura', 173.0000, 'ºC'),
	(87353, 111, '2015-03-01 00:32:36.000000', 'temperatura', 223.0000, 'ºC'),
	(87354, 111, '2015-03-01 00:32:37.000000', 'temperatura', 598.0000, 'ºC'),
	(87355, 111, '2015-03-01 00:32:38.000000', 'temperatura', 1121.0000, 'ºC'),
	(87356, 111, '2015-03-01 00:32:39.000000', 'temperatura', 213.0000, 'ºC'),
	(87357, 111, '2015-03-01 00:32:40.000000', 'temperatura', 103.0000, 'ºC'),
	(87358, 111, '2015-03-01 00:32:41.000000', 'temperatura', 1075.0000, 'ºC'),
	(87359, 111, '2015-03-01 00:32:42.000000', 'temperatura', 267.0000, 'ºC'),
	(87360, 111, '2015-03-01 00:32:43.000000', 'temperatura', 510.0000, 'ºC'),
	(87361, 111, '2015-03-01 00:32:44.000000', 'temperatura', 550.0000, 'ºC'),
	(87362, 111, '2015-03-01 00:32:45.000000', 'temperatura', 21.0000, 'ºC'),
	(87363, 111, '2015-03-01 00:32:46.000000', 'temperatura', 853.0000, 'ºC'),
	(87364, 111, '2015-03-01 00:32:47.000000', 'temperatura', 604.0000, 'ºC'),
	(87365, 111, '2015-03-01 00:32:48.000000', 'temperatura', 462.0000, 'ºC'),
	(87366, 111, '2015-03-01 00:32:49.000000', 'temperatura', 497.0000, 'ºC'),
	(87367, 111, '2015-03-01 00:32:50.000000', 'temperatura', 1100.0000, 'ºC'),
	(87368, 111, '2015-03-01 00:32:51.000000', 'temperatura', 408.0000, 'ºC'),
	(87369, 111, '2015-03-01 00:32:52.000000', 'temperatura', 1141.0000, 'ºC'),
	(87370, 111, '2015-03-01 00:32:53.000000', 'temperatura', 882.0000, 'ºC'),
	(87371, 111, '2015-03-01 00:32:54.000000', 'temperatura', 989.0000, 'ºC'),
	(87372, 111, '2015-03-01 00:32:55.000000', 'temperatura', 1097.0000, 'ºC'),
	(87373, 111, '2015-03-01 00:32:56.000000', 'temperatura', 121.0000, 'ºC'),
	(87374, 111, '2015-03-01 00:32:57.000000', 'temperatura', 913.0000, 'ºC'),
	(87375, 111, '2015-03-01 00:32:58.000000', 'temperatura', 604.0000, 'ºC'),
	(87376, 111, '2015-03-01 00:32:59.000000', 'temperatura', 279.0000, 'ºC'),
	(87377, 111, '2015-03-01 00:33:00.000000', 'temperatura', 783.0000, 'ºC'),
	(87378, 111, '2015-03-01 00:33:01.000000', 'temperatura', 678.0000, 'ºC'),
	(87379, 111, '2015-03-01 00:33:02.000000', 'temperatura', 1043.0000, 'ºC'),
	(87380, 111, '2015-03-01 00:33:03.000000', 'temperatura', 783.0000, 'ºC'),
	(87381, 111, '2015-03-01 00:33:04.000000', 'temperatura', 784.0000, 'ºC'),
	(87382, 111, '2015-03-01 00:33:05.000000', 'temperatura', 373.0000, 'ºC'),
	(87383, 111, '2015-03-01 00:33:06.000000', 'temperatura', 715.0000, 'ºC'),
	(87384, 111, '2015-03-01 00:33:07.000000', 'temperatura', 54.0000, 'ºC'),
	(87385, 111, '2015-03-01 00:33:08.000000', 'temperatura', 525.0000, 'ºC'),
	(87386, 111, '2015-03-01 00:33:09.000000', 'temperatura', 66.0000, 'ºC'),
	(87387, 111, '2015-03-01 00:33:10.000000', 'temperatura', 1154.0000, 'ºC'),
	(87388, 111, '2015-03-01 00:33:11.000000', 'temperatura', 773.0000, 'ºC'),
	(87389, 111, '2015-03-01 00:33:12.000000', 'temperatura', 405.0000, 'ºC'),
	(87390, 111, '2015-03-01 00:33:13.000000', 'temperatura', 905.0000, 'ºC'),
	(87391, 111, '2015-03-01 00:33:14.000000', 'temperatura', 909.0000, 'ºC'),
	(87392, 111, '2015-03-01 00:33:15.000000', 'temperatura', 633.0000, 'ºC'),
	(87393, 111, '2015-03-01 00:33:16.000000', 'temperatura', 439.0000, 'ºC'),
	(87394, 111, '2015-03-01 00:33:17.000000', 'temperatura', 295.0000, 'ºC'),
	(87395, 111, '2015-03-01 00:33:18.000000', 'temperatura', 160.0000, 'ºC'),
	(87396, 111, '2015-03-01 00:33:19.000000', 'temperatura', 1113.0000, 'ºC'),
	(87397, 111, '2015-03-01 00:33:20.000000', 'temperatura', 286.0000, 'ºC'),
	(87398, 111, '2015-03-01 00:33:21.000000', 'temperatura', 492.0000, 'ºC'),
	(87399, 111, '2015-03-01 00:33:22.000000', 'temperatura', 403.0000, 'ºC'),
	(87400, 111, '2015-03-01 00:33:23.000000', 'temperatura', 539.0000, 'ºC'),
	(87401, 111, '2015-03-01 00:33:24.000000', 'temperatura', 287.0000, 'ºC'),
	(87402, 111, '2015-03-01 00:33:25.000000', 'temperatura', 1018.0000, 'ºC'),
	(87403, 111, '2015-03-01 00:33:26.000000', 'temperatura', 628.0000, 'ºC'),
	(87404, 111, '2015-03-01 00:33:27.000000', 'temperatura', 89.0000, 'ºC'),
	(87405, 111, '2015-03-01 00:33:28.000000', 'temperatura', 959.0000, 'ºC'),
	(87406, 111, '2015-03-01 00:33:29.000000', 'temperatura', 931.0000, 'ºC'),
	(87407, 111, '2015-03-01 00:33:30.000000', 'temperatura', 577.0000, 'ºC'),
	(87408, 111, '2015-03-01 00:33:31.000000', 'temperatura', 95.0000, 'ºC'),
	(87409, 111, '2015-03-01 00:33:32.000000', 'temperatura', 1143.0000, 'ºC'),
	(87410, 111, '2015-03-01 00:33:33.000000', 'temperatura', 629.0000, 'ºC'),
	(87411, 111, '2015-03-01 00:33:34.000000', 'temperatura', 916.0000, 'ºC'),
	(87412, 111, '2015-03-01 00:33:35.000000', 'temperatura', 295.0000, 'ºC'),
	(87413, 111, '2015-03-01 00:33:36.000000', 'temperatura', 1129.0000, 'ºC'),
	(87414, 111, '2015-03-01 00:33:37.000000', 'temperatura', 1157.0000, 'ºC'),
	(87415, 111, '2015-03-01 00:33:38.000000', 'temperatura', 1.0000, 'ºC'),
	(87416, 111, '2015-03-01 00:33:39.000000', 'temperatura', 134.0000, 'ºC'),
	(87417, 111, '2015-03-01 00:33:40.000000', 'temperatura', 668.0000, 'ºC'),
	(87418, 111, '2015-03-01 00:33:41.000000', 'temperatura', 539.0000, 'ºC'),
	(87419, 111, '2015-03-01 00:33:42.000000', 'temperatura', 690.0000, 'ºC'),
	(87420, 111, '2015-03-01 00:33:43.000000', 'temperatura', 632.0000, 'ºC'),
	(87421, 111, '2015-03-01 00:33:44.000000', 'temperatura', 1093.0000, 'ºC'),
	(87422, 111, '2015-03-01 00:33:45.000000', 'temperatura', 1168.0000, 'ºC'),
	(87423, 111, '2015-03-01 00:33:46.000000', 'temperatura', 164.0000, 'ºC'),
	(87424, 111, '2015-03-01 00:33:47.000000', 'temperatura', 915.0000, 'ºC'),
	(87425, 111, '2015-03-01 00:33:48.000000', 'temperatura', 485.0000, 'ºC'),
	(87426, 111, '2015-03-01 00:33:49.000000', 'temperatura', 878.0000, 'ºC'),
	(87427, 111, '2015-03-01 00:33:50.000000', 'temperatura', 537.0000, 'ºC'),
	(87428, 111, '2015-03-01 00:33:51.000000', 'temperatura', 50.0000, 'ºC'),
	(87429, 111, '2015-03-01 00:33:52.000000', 'temperatura', 1042.0000, 'ºC'),
	(87430, 111, '2015-03-01 00:33:53.000000', 'temperatura', 258.0000, 'ºC'),
	(87431, 111, '2015-03-01 00:33:54.000000', 'temperatura', 565.0000, 'ºC'),
	(87432, 111, '2015-03-01 00:33:55.000000', 'temperatura', 854.0000, 'ºC'),
	(87433, 111, '2015-03-01 00:33:56.000000', 'temperatura', 172.0000, 'ºC'),
	(87434, 111, '2015-03-01 00:33:57.000000', 'temperatura', 701.0000, 'ºC'),
	(87435, 111, '2015-03-01 00:33:58.000000', 'temperatura', 588.0000, 'ºC'),
	(87436, 111, '2015-03-01 00:33:59.000000', 'temperatura', 838.0000, 'ºC'),
	(87437, 111, '2015-03-01 00:34:00.000000', 'temperatura', 27.0000, 'ºC'),
	(87438, 111, '2015-03-01 00:34:01.000000', 'temperatura', 22.0000, 'ºC'),
	(87439, 111, '2015-03-01 00:34:02.000000', 'temperatura', 30.0000, 'ºC'),
	(87440, 111, '2015-03-01 00:34:03.000000', 'temperatura', 82.0000, 'ºC'),
	(87441, 111, '2015-03-01 00:34:04.000000', 'temperatura', 322.0000, 'ºC'),
	(87442, 111, '2015-03-01 00:34:05.000000', 'temperatura', 166.0000, 'ºC'),
	(87443, 111, '2015-03-01 00:34:06.000000', 'temperatura', 1064.0000, 'ºC'),
	(87444, 111, '2015-03-01 00:34:07.000000', 'temperatura', 23.0000, 'ºC'),
	(87445, 111, '2015-03-01 00:34:08.000000', 'temperatura', 524.0000, 'ºC'),
	(87446, 111, '2015-03-01 00:34:09.000000', 'temperatura', 153.0000, 'ºC'),
	(87447, 111, '2015-03-01 00:34:10.000000', 'temperatura', 391.0000, 'ºC'),
	(87448, 111, '2015-03-01 00:34:11.000000', 'temperatura', 297.0000, 'ºC'),
	(87449, 111, '2015-03-01 00:34:12.000000', 'temperatura', 315.0000, 'ºC'),
	(87450, 111, '2015-03-01 00:34:13.000000', 'temperatura', 681.0000, 'ºC'),
	(87451, 111, '2015-03-01 00:34:14.000000', 'temperatura', 63.0000, 'ºC'),
	(87452, 111, '2015-03-01 00:34:15.000000', 'temperatura', 671.0000, 'ºC'),
	(87453, 111, '2015-03-01 00:34:16.000000', 'temperatura', 766.0000, 'ºC'),
	(87454, 111, '2015-03-01 00:34:17.000000', 'temperatura', 617.0000, 'ºC'),
	(87455, 111, '2015-03-01 00:34:18.000000', 'temperatura', 789.0000, 'ºC'),
	(87456, 111, '2015-03-01 00:34:19.000000', 'temperatura', 894.0000, 'ºC'),
	(87457, 111, '2015-03-01 00:34:20.000000', 'temperatura', 902.0000, 'ºC'),
	(87458, 111, '2015-03-01 00:34:21.000000', 'temperatura', 630.0000, 'ºC'),
	(87459, 111, '2015-03-01 00:34:22.000000', 'temperatura', 445.0000, 'ºC'),
	(87460, 111, '2015-03-01 00:34:23.000000', 'temperatura', 333.0000, 'ºC'),
	(87461, 111, '2015-03-01 00:34:24.000000', 'temperatura', 334.0000, 'ºC'),
	(87462, 111, '2015-03-01 00:34:25.000000', 'temperatura', 670.0000, 'ºC'),
	(87463, 111, '2015-03-01 00:34:26.000000', 'temperatura', 1148.0000, 'ºC'),
	(87464, 111, '2015-03-01 00:34:27.000000', 'temperatura', 131.0000, 'ºC'),
	(87465, 111, '2015-03-01 00:34:28.000000', 'temperatura', 810.0000, 'ºC'),
	(87466, 111, '2015-03-01 00:34:29.000000', 'temperatura', 57.0000, 'ºC'),
	(87467, 111, '2015-03-01 00:34:30.000000', 'temperatura', 257.0000, 'ºC'),
	(87468, 111, '2015-03-01 00:34:31.000000', 'temperatura', 1113.0000, 'ºC'),
	(87469, 111, '2015-03-01 00:34:32.000000', 'temperatura', 1195.0000, 'ºC'),
	(87470, 111, '2015-03-01 00:34:33.000000', 'temperatura', 237.0000, 'ºC'),
	(87471, 111, '2015-03-01 00:34:34.000000', 'temperatura', 2.0000, 'ºC'),
	(87472, 111, '2015-03-01 00:34:35.000000', 'temperatura', 498.0000, 'ºC'),
	(87473, 111, '2015-03-01 00:34:36.000000', 'temperatura', 83.0000, 'ºC'),
	(87474, 111, '2015-03-01 00:34:37.000000', 'temperatura', 121.0000, 'ºC'),
	(87475, 111, '2015-03-01 00:34:38.000000', 'temperatura', 357.0000, 'ºC'),
	(87476, 111, '2015-03-01 00:34:39.000000', 'temperatura', 224.0000, 'ºC'),
	(87477, 111, '2015-03-01 00:34:40.000000', 'temperatura', 49.0000, 'ºC'),
	(87478, 111, '2015-03-01 00:34:41.000000', 'temperatura', 773.0000, 'ºC'),
	(87479, 111, '2015-03-01 00:34:42.000000', 'temperatura', 119.0000, 'ºC'),
	(87480, 111, '2015-03-01 00:34:43.000000', 'temperatura', 676.0000, 'ºC'),
	(87481, 111, '2015-03-01 00:34:44.000000', 'temperatura', 624.0000, 'ºC'),
	(87482, 111, '2015-03-01 00:34:45.000000', 'temperatura', 1092.0000, 'ºC'),
	(87483, 111, '2015-03-01 00:34:46.000000', 'temperatura', 1188.0000, 'ºC'),
	(87484, 111, '2015-03-01 00:34:47.000000', 'temperatura', 263.0000, 'ºC'),
	(87485, 111, '2015-03-01 00:34:48.000000', 'temperatura', 152.0000, 'ºC'),
	(87486, 111, '2015-03-01 00:34:49.000000', 'temperatura', 1174.0000, 'ºC'),
	(87487, 111, '2015-03-01 00:34:50.000000', 'temperatura', 611.0000, 'ºC'),
	(87488, 111, '2015-03-01 00:34:51.000000', 'temperatura', 736.0000, 'ºC'),
	(87489, 111, '2015-03-01 00:34:52.000000', 'temperatura', 648.0000, 'ºC'),
	(87490, 111, '2015-03-01 00:34:53.000000', 'temperatura', 1032.0000, 'ºC'),
	(87491, 111, '2015-03-01 00:34:54.000000', 'temperatura', 818.0000, 'ºC'),
	(87492, 111, '2015-03-01 00:34:55.000000', 'temperatura', 994.0000, 'ºC'),
	(87493, 111, '2015-03-01 00:34:56.000000', 'temperatura', 116.0000, 'ºC'),
	(87494, 111, '2015-03-01 00:34:57.000000', 'temperatura', 1199.0000, 'ºC'),
	(87495, 111, '2015-03-01 00:34:58.000000', 'temperatura', 847.0000, 'ºC'),
	(87496, 111, '2015-03-01 00:34:59.000000', 'temperatura', 638.0000, 'ºC'),
	(87497, 111, '2015-03-01 00:35:00.000000', 'temperatura', 652.0000, 'ºC'),
	(87498, 111, '2015-03-01 00:35:01.000000', 'temperatura', 145.0000, 'ºC'),
	(87499, 111, '2015-03-01 00:35:02.000000', 'temperatura', 1168.0000, 'ºC'),
	(87500, 111, '2015-03-01 00:35:03.000000', 'temperatura', 606.0000, 'ºC'),
	(87501, 111, '2015-03-01 00:35:04.000000', 'temperatura', 726.0000, 'ºC'),
	(87502, 111, '2015-03-01 00:35:05.000000', 'temperatura', 612.0000, 'ºC'),
	(87503, 111, '2015-03-01 00:35:06.000000', 'temperatura', 881.0000, 'ºC'),
	(87504, 111, '2015-03-01 00:35:07.000000', 'temperatura', 172.0000, 'ºC'),
	(87505, 111, '2015-03-01 00:35:08.000000', 'temperatura', 616.0000, 'ºC'),
	(87506, 111, '2015-03-01 00:35:09.000000', 'temperatura', 166.0000, 'ºC'),
	(87507, 111, '2015-03-01 00:35:10.000000', 'temperatura', 183.0000, 'ºC'),
	(87508, 111, '2015-03-01 00:35:11.000000', 'temperatura', 415.0000, 'ºC'),
	(87509, 111, '2015-03-01 00:35:12.000000', 'temperatura', 329.0000, 'ºC'),
	(87510, 111, '2015-03-01 00:35:13.000000', 'temperatura', 399.0000, 'ºC'),
	(87511, 111, '2015-03-01 00:35:14.000000', 'temperatura', 1008.0000, 'ºC'),
	(87512, 111, '2015-03-01 00:35:15.000000', 'temperatura', 246.0000, 'ºC'),
	(87513, 111, '2015-03-01 00:35:16.000000', 'temperatura', 605.0000, 'ºC'),
	(87514, 111, '2015-03-01 00:35:17.000000', 'temperatura', 1089.0000, 'ºC'),
	(87515, 111, '2015-03-01 00:35:18.000000', 'temperatura', 31.0000, 'ºC'),
	(87516, 111, '2015-03-01 00:35:19.000000', 'temperatura', 489.0000, 'ºC'),
	(87517, 111, '2015-03-01 00:35:20.000000', 'temperatura', 1153.0000, 'ºC'),
	(87518, 111, '2015-03-01 00:35:21.000000', 'temperatura', 698.0000, 'ºC'),
	(87519, 111, '2015-03-01 00:35:22.000000', 'temperatura', 31.0000, 'ºC'),
	(87520, 111, '2015-03-01 00:35:23.000000', 'temperatura', 464.0000, 'ºC'),
	(87521, 111, '2015-03-01 00:35:24.000000', 'temperatura', 1025.0000, 'ºC'),
	(87522, 111, '2015-03-01 00:35:25.000000', 'temperatura', 132.0000, 'ºC'),
	(87523, 111, '2015-03-01 00:35:26.000000', 'temperatura', 1187.0000, 'ºC'),
	(87524, 111, '2015-03-01 00:35:27.000000', 'temperatura', 739.0000, 'ºC'),
	(87525, 111, '2015-03-01 00:35:28.000000', 'temperatura', 137.0000, 'ºC'),
	(87526, 111, '2015-03-01 00:35:29.000000', 'temperatura', 865.0000, 'ºC'),
	(87527, 111, '2015-03-01 00:35:30.000000', 'temperatura', 316.0000, 'ºC'),
	(87528, 111, '2015-03-01 00:35:31.000000', 'temperatura', 187.0000, 'ºC'),
	(87529, 111, '2015-03-01 00:35:32.000000', 'temperatura', 1186.0000, 'ºC'),
	(87530, 111, '2015-03-01 00:35:33.000000', 'temperatura', 570.0000, 'ºC'),
	(87531, 111, '2015-03-01 00:35:34.000000', 'temperatura', 493.0000, 'ºC'),
	(87532, 111, '2015-03-01 00:35:35.000000', 'temperatura', 757.0000, 'ºC'),
	(87533, 111, '2015-03-01 00:35:36.000000', 'temperatura', 1105.0000, 'ºC'),
	(87534, 111, '2015-03-01 00:35:37.000000', 'temperatura', 855.0000, 'ºC'),
	(87535, 111, '2015-03-01 00:35:38.000000', 'temperatura', 962.0000, 'ºC'),
	(87536, 111, '2015-03-01 00:35:39.000000', 'temperatura', 1044.0000, 'ºC'),
	(87537, 111, '2015-03-01 00:35:40.000000', 'temperatura', 1136.0000, 'ºC'),
	(87538, 111, '2015-03-01 00:35:41.000000', 'temperatura', 147.0000, 'ºC'),
	(87539, 111, '2015-03-01 00:35:42.000000', 'temperatura', 929.0000, 'ºC'),
	(87540, 111, '2015-03-01 00:35:43.000000', 'temperatura', 602.0000, 'ºC'),
	(87541, 111, '2015-03-01 00:35:44.000000', 'temperatura', 227.0000, 'ºC'),
	(87542, 111, '2015-03-01 00:35:45.000000', 'temperatura', 527.0000, 'ºC'),
	(87543, 111, '2015-03-01 00:35:46.000000', 'temperatura', 756.0000, 'ºC'),
	(87544, 111, '2015-03-01 00:35:47.000000', 'temperatura', 1000.0000, 'ºC'),
	(87545, 111, '2015-03-01 00:35:48.000000', 'temperatura', 333.0000, 'ºC'),
	(87546, 111, '2015-03-01 00:35:49.000000', 'temperatura', 1065.0000, 'ºC'),
	(87547, 111, '2015-03-01 00:35:50.000000', 'temperatura', 727.0000, 'ºC'),
	(87548, 111, '2015-03-01 00:35:51.000000', 'temperatura', 441.0000, 'ºC'),
	(87549, 111, '2015-03-01 00:35:52.000000', 'temperatura', 25.0000, 'ºC'),
	(87550, 111, '2015-03-01 00:35:53.000000', 'temperatura', 0.0000, 'ºC'),
	(87551, 111, '2015-03-01 00:35:54.000000', 'temperatura', 1125.0000, 'ºC'),
	(87552, 111, '2015-03-01 00:35:55.000000', 'temperatura', 828.0000, 'ºC'),
	(87553, 111, '2015-03-01 00:35:56.000000', 'temperatura', 765.0000, 'ºC'),
	(87554, 111, '2015-03-01 00:35:57.000000', 'temperatura', 142.0000, 'ºC'),
	(87555, 111, '2015-03-01 00:35:58.000000', 'temperatura', 813.0000, 'ºC'),
	(87556, 111, '2015-03-01 00:35:59.000000', 'temperatura', 40.0000, 'ºC'),
	(87557, 111, '2015-03-01 00:36:00.000000', 'temperatura', 163.0000, 'ºC'),
	(87558, 111, '2015-03-01 00:36:01.000000', 'temperatura', 696.0000, 'ºC'),
	(87559, 111, '2015-03-01 00:36:02.000000', 'temperatura', 590.0000, 'ºC'),
	(87560, 111, '2015-03-01 00:36:03.000000', 'temperatura', 864.0000, 'ºC'),
	(87561, 111, '2015-03-01 00:36:04.000000', 'temperatura', 152.0000, 'ºC'),
	(87562, 111, '2015-03-01 00:36:05.000000', 'temperatura', 567.0000, 'ºC'),
	(87563, 111, '2015-03-01 00:36:06.000000', 'temperatura', 1178.0000, 'ºC'),
	(87564, 111, '2015-03-01 00:36:07.000000', 'temperatura', 589.0000, 'ºC'),
	(87565, 111, '2015-03-01 00:36:08.000000', 'temperatura', 613.0000, 'ºC'),
	(87566, 111, '2015-03-01 00:36:09.000000', 'temperatura', 98.0000, 'ºC'),
	(87567, 111, '2015-03-01 00:36:10.000000', 'temperatura', 1050.0000, 'ºC'),
	(87568, 111, '2015-03-01 00:36:11.000000', 'temperatura', 156.0000, 'ºC'),
	(87569, 111, '2015-03-01 00:36:12.000000', 'temperatura', 31.0000, 'ºC'),
	(87570, 111, '2015-03-01 00:36:13.000000', 'temperatura', 889.0000, 'ºC'),
	(87571, 111, '2015-03-01 00:36:14.000000', 'temperatura', 750.0000, 'ºC'),
	(87572, 111, '2015-03-01 00:36:15.000000', 'temperatura', 1085.0000, 'ºC'),
	(87573, 111, '2015-03-01 00:36:16.000000', 'temperatura', 777.0000, 'ºC'),
	(87574, 111, '2015-03-01 00:36:17.000000', 'temperatura', 630.0000, 'ºC'),
	(87575, 111, '2015-03-01 00:36:18.000000', 'temperatura', 820.0000, 'ºC'),
	(87576, 111, '2015-03-01 00:36:19.000000', 'temperatura', 1012.0000, 'ºC'),
	(87577, 111, '2015-03-01 00:36:20.000000', 'temperatura', 197.0000, 'ºC'),
	(87578, 111, '2015-03-01 00:36:21.000000', 'temperatura', 351.0000, 'ºC'),
	(87579, 111, '2015-03-01 00:36:22.000000', 'temperatura', 1163.0000, 'ºC'),
	(87580, 111, '2015-03-01 00:36:23.000000', 'temperatura', 1166.0000, 'ºC'),
	(87581, 111, '2015-03-01 00:36:24.000000', 'temperatura', 1138.0000, 'ºC'),
	(87582, 111, '2015-03-01 00:36:25.000000', 'temperatura', 992.0000, 'ºC'),
	(87583, 111, '2015-03-01 00:36:26.000000', 'temperatura', 349.0000, 'ºC'),
	(87584, 111, '2015-03-01 00:36:27.000000', 'temperatura', 1169.0000, 'ºC'),
	(87585, 111, '2015-03-01 00:36:28.000000', 'temperatura', 1197.0000, 'ºC'),
	(87586, 111, '2015-03-01 00:36:29.000000', 'temperatura', 78.0000, 'ºC'),
	(87587, 111, '2015-03-01 00:36:30.000000', 'temperatura', 402.0000, 'ºC'),
	(87588, 111, '2015-03-01 00:36:31.000000', 'temperatura', 577.0000, 'ºC'),
	(87589, 111, '2015-03-01 00:36:32.000000', 'temperatura', 480.0000, 'ºC'),
	(87590, 111, '2015-03-01 00:36:33.000000', 'temperatura', 670.0000, 'ºC'),
	(87591, 111, '2015-03-01 00:36:34.000000', 'temperatura', 708.0000, 'ºC'),
	(87592, 111, '2015-03-01 00:36:35.000000', 'temperatura', 332.0000, 'ºC'),
	(87593, 111, '2015-03-01 00:36:36.000000', 'temperatura', 734.0000, 'ºC'),
	(87594, 111, '2015-03-01 00:36:37.000000', 'temperatura', 278.0000, 'ºC'),
	(87595, 111, '2015-03-01 00:36:38.000000', 'temperatura', 385.0000, 'ºC'),
	(87596, 111, '2015-03-01 00:36:39.000000', 'temperatura', 1095.0000, 'ºC'),
	(87597, 111, '2015-03-01 00:36:40.000000', 'temperatura', 719.0000, 'ºC'),
	(87598, 111, '2015-03-01 00:36:41.000000', 'temperatura', 311.0000, 'ºC'),
	(87599, 111, '2015-03-01 00:36:42.000000', 'temperatura', 596.0000, 'ºC'),
	(87600, 111, '2015-03-01 00:36:43.000000', 'temperatura', 849.0000, 'ºC'),
	(87601, 111, '2015-03-01 00:36:44.000000', 'temperatura', 59.0000, 'ºC'),
	(87602, 111, '2015-03-01 00:36:45.000000', 'temperatura', 150.0000, 'ºC'),
	(87603, 111, '2015-03-01 00:36:46.000000', 'temperatura', 570.0000, 'ºC'),
	(87604, 111, '2015-03-01 00:36:47.000000', 'temperatura', 1.0000, 'ºC'),
	(87605, 111, '2015-03-01 00:36:48.000000', 'temperatura', 696.0000, 'ºC'),
	(87606, 111, '2015-03-01 00:36:49.000000', 'temperatura', 1075.0000, 'ºC'),
	(87607, 111, '2015-03-01 00:36:50.000000', 'temperatura', 891.0000, 'ºC'),
	(87608, 111, '2015-03-01 00:36:51.000000', 'temperatura', 29.0000, 'ºC'),
	(87609, 111, '2015-03-01 00:36:52.000000', 'temperatura', 1071.0000, 'ºC'),
	(87610, 111, '2015-03-01 00:36:53.000000', 'temperatura', 469.0000, 'ºC'),
	(87611, 111, '2015-03-01 00:36:54.000000', 'temperatura', 332.0000, 'ºC'),
	(87612, 111, '2015-03-01 00:36:55.000000', 'temperatura', 256.0000, 'ºC'),
	(87613, 111, '2015-03-01 00:36:56.000000', 'temperatura', 284.0000, 'ºC'),
	(87614, 111, '2015-03-01 00:36:57.000000', 'temperatura', 652.0000, 'ºC'),
	(87615, 111, '2015-03-01 00:36:58.000000', 'temperatura', 10.0000, 'ºC'),
	(87616, 111, '2015-03-01 00:36:59.000000', 'temperatura', 493.0000, 'ºC'),
	(87617, 111, '2015-03-01 00:37:00.000000', 'temperatura', 37.0000, 'ºC'),
	(87618, 111, '2015-03-01 00:37:01.000000', 'temperatura', 1105.0000, 'ºC'),
	(87619, 111, '2015-03-01 00:37:02.000000', 'temperatura', 617.0000, 'ºC'),
	(87620, 111, '2015-03-01 00:37:03.000000', 'temperatura', 967.0000, 'ºC'),
	(87621, 111, '2015-03-01 00:37:04.000000', 'temperatura', 586.0000, 'ºC'),
	(87622, 111, '2015-03-01 00:37:05.000000', 'temperatura', 30.0000, 'ºC'),
	(87623, 111, '2015-03-01 00:37:06.000000', 'temperatura', 791.0000, 'ºC'),
	(87624, 111, '2015-03-01 00:37:07.000000', 'temperatura', 268.0000, 'ºC'),
	(87625, 111, '2015-03-01 00:37:08.000000', 'temperatura', 167.0000, 'ºC'),
	(87626, 111, '2015-03-01 00:37:09.000000', 'temperatura', 31.0000, 'ºC'),
	(87627, 111, '2015-03-01 00:37:10.000000', 'temperatura', 853.0000, 'ºC'),
	(87628, 111, '2015-03-01 00:37:11.000000', 'temperatura', 572.0000, 'ºC'),
	(87629, 111, '2015-03-01 00:37:12.000000', 'temperatura', 302.0000, 'ºC'),
	(87630, 111, '2015-03-01 00:37:13.000000', 'temperatura', 995.0000, 'ºC'),
	(87631, 111, '2015-03-01 00:37:14.000000', 'temperatura', 470.0000, 'ºC'),
	(87632, 111, '2015-03-01 00:37:15.000000', 'temperatura', 567.0000, 'ºC'),
	(87633, 111, '2015-03-01 00:37:16.000000', 'temperatura', 224.0000, 'ºC'),
	(87634, 111, '2015-03-01 00:37:17.000000', 'temperatura', 618.0000, 'ºC'),
	(87635, 111, '2015-03-01 00:37:18.000000', 'temperatura', 20.0000, 'ºC'),
	(87636, 111, '2015-03-01 00:37:19.000000', 'temperatura', 646.0000, 'ºC'),
	(87637, 111, '2015-03-01 00:37:20.000000', 'temperatura', 771.0000, 'ºC'),
	(87638, 111, '2015-03-01 00:37:21.000000', 'temperatura', 719.0000, 'ºC'),
	(87639, 111, '2015-03-01 00:37:22.000000', 'temperatura', 82.0000, 'ºC'),
	(87640, 111, '2015-03-01 00:37:23.000000', 'temperatura', 652.0000, 'ºC'),
	(87641, 111, '2015-03-01 00:37:24.000000', 'temperatura', 614.0000, 'ºC'),
	(87642, 111, '2015-03-01 00:37:25.000000', 'temperatura', 1117.0000, 'ºC'),
	(87643, 111, '2015-03-01 00:37:26.000000', 'temperatura', 144.0000, 'ºC'),
	(87644, 111, '2015-03-01 00:37:27.000000', 'temperatura', 970.0000, 'ºC'),
	(87645, 111, '2015-03-01 00:37:28.000000', 'temperatura', 818.0000, 'ºC'),
	(87646, 111, '2015-03-01 00:37:29.000000', 'temperatura', 1182.0000, 'ºC'),
	(87647, 111, '2015-03-01 00:37:30.000000', 'temperatura', 1054.0000, 'ºC'),
	(87648, 111, '2015-03-01 00:37:31.000000', 'temperatura', 525.0000, 'ºC'),
	(87649, 111, '2015-03-01 00:37:32.000000', 'temperatura', 665.0000, 'ºC'),
	(87650, 111, '2015-03-01 00:37:33.000000', 'temperatura', 549.0000, 'ºC'),
	(87651, 111, '2015-03-01 00:37:34.000000', 'temperatura', 751.0000, 'ºC'),
	(87652, 111, '2015-03-01 00:37:35.000000', 'temperatura', 907.0000, 'ºC'),
	(87653, 111, '2015-03-01 00:37:36.000000', 'temperatura', 1084.0000, 'ºC'),
	(87654, 111, '2015-03-01 00:37:37.000000', 'temperatura', 299.0000, 'ºC'),
	(87655, 111, '2015-03-01 00:37:38.000000', 'temperatura', 642.0000, 'ºC'),
	(87656, 111, '2015-03-01 00:37:39.000000', 'temperatura', 1114.0000, 'ºC'),
	(87657, 111, '2015-03-01 00:37:40.000000', 'temperatura', 46.0000, 'ºC'),
	(87658, 111, '2015-03-01 00:37:41.000000', 'temperatura', 489.0000, 'ºC'),
	(87659, 111, '2015-03-01 00:37:42.000000', 'temperatura', 1109.0000, 'ºC'),
	(87660, 111, '2015-03-01 00:37:43.000000', 'temperatura', 475.0000, 'ºC'),
	(87661, 111, '2015-03-01 00:37:44.000000', 'temperatura', 249.0000, 'ºC'),
	(87662, 111, '2015-03-01 00:37:45.000000', 'temperatura', 1019.0000, 'ºC'),
	(87663, 111, '2015-03-01 00:37:46.000000', 'temperatura', 750.0000, 'ºC'),
	(87664, 111, '2015-03-01 00:37:47.000000', 'temperatura', 692.0000, 'ºC'),
	(87665, 111, '2015-03-01 00:37:48.000000', 'temperatura', 13.0000, 'ºC'),
	(87666, 111, '2015-03-01 00:37:49.000000', 'temperatura', 387.0000, 'ºC'),
	(87667, 111, '2015-03-01 00:37:50.000000', 'temperatura', 699.0000, 'ºC'),
	(87668, 111, '2015-03-01 00:37:51.000000', 'temperatura', 1133.0000, 'ºC'),
	(87669, 111, '2015-03-01 00:37:52.000000', 'temperatura', 1169.0000, 'ºC'),
	(87670, 111, '2015-03-01 00:37:53.000000', 'temperatura', 46.0000, 'ºC'),
	(87671, 111, '2015-03-01 00:37:54.000000', 'temperatura', 325.0000, 'ºC'),
	(87672, 111, '2015-03-01 00:37:55.000000', 'temperatura', 288.0000, 'ºC'),
	(87673, 111, '2015-03-01 00:37:56.000000', 'temperatura', 463.0000, 'ºC'),
	(87674, 111, '2015-03-01 00:37:57.000000', 'temperatura', 253.0000, 'ºC'),
	(87675, 111, '2015-03-01 00:37:58.000000', 'temperatura', 1078.0000, 'ºC'),
	(87676, 111, '2015-03-01 00:37:59.000000', 'temperatura', 1030.0000, 'ºC'),
	(87677, 111, '2015-03-01 00:38:00.000000', 'temperatura', 716.0000, 'ºC'),
	(87678, 111, '2015-03-01 00:38:01.000000', 'temperatura', 489.0000, 'ºC'),
	(87679, 111, '2015-03-01 00:38:02.000000', 'temperatura', 300.0000, 'ºC'),
	(87680, 111, '2015-03-01 00:38:03.000000', 'temperatura', 33.0000, 'ºC'),
	(87681, 111, '2015-03-01 00:38:04.000000', 'temperatura', 465.0000, 'ºC'),
	(87682, 111, '2015-03-01 00:38:05.000000', 'temperatura', 1026.0000, 'ºC'),
	(87683, 111, '2015-03-01 00:38:06.000000', 'temperatura', 134.0000, 'ºC'),
	(87684, 111, '2015-03-01 00:38:07.000000', 'temperatura', 1194.0000, 'ºC'),
	(87685, 111, '2015-03-01 00:38:08.000000', 'temperatura', 767.0000, 'ºC'),
	(87686, 111, '2015-03-01 00:38:09.000000', 'temperatura', 255.0000, 'ºC'),
	(87687, 111, '2015-03-01 00:38:10.000000', 'temperatura', 172.0000, 'ºC'),
	(87688, 111, '2015-03-01 00:38:11.000000', 'temperatura', 98.0000, 'ºC'),
	(87689, 111, '2015-03-01 00:38:12.000000', 'temperatura', 1173.0000, 'ºC'),
	(87690, 111, '2015-03-01 00:38:13.000000', 'temperatura', 770.0000, 'ºC'),
	(87691, 111, '2015-03-01 00:38:14.000000', 'temperatura', 335.0000, 'ºC'),
	(87692, 111, '2015-03-01 00:38:15.000000', 'temperatura', 562.0000, 'ºC'),
	(87693, 111, '2015-03-01 00:38:16.000000', 'temperatura', 607.0000, 'ºC'),
	(87694, 111, '2015-03-01 00:38:17.000000', 'temperatura', 148.0000, 'ºC'),
	(87695, 111, '2015-03-01 00:38:18.000000', 'temperatura', 120.0000, 'ºC'),
	(87696, 111, '2015-03-01 00:38:19.000000', 'temperatura', 155.0000, 'ºC'),
	(87697, 111, '2015-03-01 00:38:20.000000', 'temperatura', 419.0000, 'ºC'),
	(87698, 111, '2015-03-01 00:38:21.000000', 'temperatura', 427.0000, 'ºC'),
	(87699, 111, '2015-03-01 00:38:22.000000', 'temperatura', 881.0000, 'ºC'),
	(87700, 111, '2015-03-01 00:38:23.000000', 'temperatura', 726.0000, 'ºC'),
	(87701, 111, '2015-03-01 00:38:24.000000', 'temperatura', 984.0000, 'ºC'),
	(87702, 111, '2015-03-01 00:38:25.000000', 'temperatura', 345.0000, 'ºC'),
	(87703, 111, '2015-03-01 00:38:26.000000', 'temperatura', 1174.0000, 'ºC'),
	(87704, 111, '2015-03-01 00:38:27.000000', 'temperatura', 33.0000, 'ºC'),
	(87705, 111, '2015-03-01 00:38:28.000000', 'temperatura', 245.0000, 'ºC'),
	(87706, 111, '2015-03-01 00:38:29.000000', 'temperatura', 1128.0000, 'ºC'),
	(87707, 111, '2015-03-01 00:38:30.000000', 'temperatura', 103.0000, 'ºC'),
	(87708, 111, '2015-03-01 00:38:31.000000', 'temperatura', 730.0000, 'ºC'),
	(87709, 111, '2015-03-01 00:38:32.000000', 'temperatura', 945.0000, 'ºC'),
	(87710, 111, '2015-03-01 00:38:33.000000', 'temperatura', 133.0000, 'ºC'),
	(87711, 111, '2015-03-01 00:38:34.000000', 'temperatura', 233.0000, 'ºC'),
	(87712, 111, '2015-03-01 00:38:35.000000', 'temperatura', 766.0000, 'ºC'),
	(87713, 111, '2015-03-01 00:38:36.000000', 'temperatura', 729.0000, 'ºC'),
	(87714, 111, '2015-03-01 00:38:37.000000', 'temperatura', 151.0000, 'ºC'),
	(87715, 111, '2015-03-01 00:38:38.000000', 'temperatura', 967.0000, 'ºC'),
	(87716, 111, '2015-03-01 00:38:39.000000', 'temperatura', 784.0000, 'ºC'),
	(87717, 111, '2015-03-01 00:38:40.000000', 'temperatura', 1019.0000, 'ºC'),
	(87718, 111, '2015-03-01 00:38:41.000000', 'temperatura', 341.0000, 'ºC'),
	(87719, 111, '2015-03-01 00:38:42.000000', 'temperatura', 1050.0000, 'ºC'),
	(87720, 111, '2015-03-01 00:38:43.000000', 'temperatura', 630.0000, 'ºC'),
	(87721, 111, '2015-03-01 00:38:44.000000', 'temperatura', 1197.0000, 'ºC'),
	(87722, 111, '2015-03-01 00:38:45.000000', 'temperatura', 496.0000, 'ºC'),
	(87723, 111, '2015-03-01 00:38:46.000000', 'temperatura', 92.0000, 'ºC'),
	(87724, 111, '2015-03-01 00:38:47.000000', 'temperatura', 170.0000, 'ºC'),
	(87725, 111, '2015-03-01 00:38:48.000000', 'temperatura', 577.0000, 'ºC'),
	(87726, 111, '2015-03-01 00:38:49.000000', 'temperatura', 1175.0000, 'ºC'),
	(87727, 111, '2015-03-01 00:38:50.000000', 'temperatura', 542.0000, 'ºC'),
	(87728, 111, '2015-03-01 00:38:51.000000', 'temperatura', 387.0000, 'ºC'),
	(87729, 111, '2015-03-01 00:38:52.000000', 'temperatura', 310.0000, 'ºC'),
	(87730, 111, '2015-03-01 00:38:53.000000', 'temperatura', 387.0000, 'ºC'),
	(87731, 111, '2015-03-01 00:38:54.000000', 'temperatura', 1009.0000, 'ºC'),
	(87732, 111, '2015-03-01 00:38:55.000000', 'temperatura', 282.0000, 'ºC'),
	(87733, 111, '2015-03-01 00:38:56.000000', 'temperatura', 785.0000, 'ºC'),
	(87734, 111, '2015-03-01 00:38:57.000000', 'temperatura', 680.0000, 'ºC'),
	(87735, 111, '2015-03-01 00:38:58.000000', 'temperatura', 1044.0000, 'ºC'),
	(87736, 111, '2015-03-01 00:38:59.000000', 'temperatura', 782.0000, 'ºC'),
	(87737, 111, '2015-03-01 00:39:00.000000', 'temperatura', 777.0000, 'ºC'),
	(87738, 111, '2015-03-01 00:39:01.000000', 'temperatura', 342.0000, 'ºC'),
	(87739, 111, '2015-03-01 00:39:02.000000', 'temperatura', 578.0000, 'ºC'),
	(87740, 111, '2015-03-01 00:39:03.000000', 'temperatura', 663.0000, 'ºC'),
	(87741, 111, '2015-03-01 00:39:04.000000', 'temperatura', 384.0000, 'ºC'),
	(87742, 111, '2015-03-01 00:39:05.000000', 'temperatura', 1130.0000, 'ºC'),
	(87743, 111, '2015-03-01 00:39:06.000000', 'temperatura', 898.0000, 'ºC'),
	(87744, 111, '2015-03-01 00:39:07.000000', 'temperatura', 1101.0000, 'ºC'),
	(87745, 111, '2015-03-01 00:39:08.000000', 'temperatura', 412.0000, 'ºC'),
	(87746, 111, '2015-03-01 00:39:09.000000', 'temperatura', 1158.0000, 'ºC'),
	(87747, 111, '2015-03-01 00:39:10.000000', 'temperatura', 956.0000, 'ºC'),
	(87748, 111, '2015-03-01 00:39:11.000000', 'temperatura', 105.0000, 'ºC'),
	(87749, 111, '2015-03-01 00:39:12.000000', 'temperatura', 56.0000, 'ºC'),
	(87750, 111, '2015-03-01 00:39:13.000000', 'temperatura', 1165.0000, 'ºC'),
	(87751, 111, '2015-03-01 00:39:14.000000', 'temperatura', 859.0000, 'ºC'),
	(87752, 111, '2015-03-01 00:39:15.000000', 'temperatura', 799.0000, 'ºC'),
	(87753, 111, '2015-03-01 00:39:16.000000', 'temperatura', 220.0000, 'ºC'),
	(87754, 111, '2015-03-01 00:39:17.000000', 'temperatura', 1102.0000, 'ºC'),
	(87755, 111, '2015-03-01 00:39:18.000000', 'temperatura', 52.0000, 'ºC'),
	(87756, 111, '2015-03-01 00:39:19.000000', 'temperatura', 555.0000, 'ºC'),
	(87757, 111, '2015-03-01 00:39:20.000000', 'temperatura', 220.0000, 'ºC'),
	(87758, 111, '2015-03-01 00:39:21.000000', 'temperatura', 636.0000, 'ºC'),
	(87759, 111, '2015-03-01 00:39:22.000000', 'temperatura', 120.0000, 'ºC'),
	(87760, 111, '2015-03-01 00:39:23.000000', 'temperatura', 1092.0000, 'ºC'),
	(87761, 111, '2015-03-01 00:39:24.000000', 'temperatura', 300.0000, 'ºC'),
	(87762, 111, '2015-03-01 00:39:25.000000', 'temperatura', 627.0000, 'ºC'),
	(87763, 111, '2015-03-01 00:39:26.000000', 'temperatura', 1034.0000, 'ºC'),
	(87764, 111, '2015-03-01 00:39:27.000000', 'temperatura', 889.0000, 'ºC'),
	(87765, 111, '2015-03-01 00:39:28.000000', 'temperatura', 142.0000, 'ºC'),
	(87766, 111, '2015-03-01 00:39:29.000000', 'temperatura', 446.0000, 'ºC'),
	(87767, 111, '2015-03-01 00:39:30.000000', 'temperatura', 603.0000, 'ºC'),
	(87768, 111, '2015-03-01 00:39:31.000000', 'temperatura', 477.0000, 'ºC'),
	(87769, 111, '2015-03-01 00:39:32.000000', 'temperatura', 577.0000, 'ºC'),
	(87770, 111, '2015-03-01 00:39:33.000000', 'temperatura', 256.0000, 'ºC'),
	(87771, 111, '2015-03-01 00:39:34.000000', 'temperatura', 747.0000, 'ºC'),
	(87772, 111, '2015-03-01 00:39:35.000000', 'temperatura', 567.0000, 'ºC'),
	(87773, 111, '2015-03-01 00:39:36.000000', 'temperatura', 594.0000, 'ºC'),
	(87774, 111, '2015-03-01 00:39:37.000000', 'temperatura', 69.0000, 'ºC'),
	(87775, 111, '2015-03-01 00:39:38.000000', 'temperatura', 964.0000, 'ºC'),
	(87776, 111, '2015-03-01 00:39:39.000000', 'temperatura', 1012.0000, 'ºC'),
	(87777, 111, '2015-03-01 00:39:40.000000', 'temperatura', 971.0000, 'ºC'),
	(87778, 111, '2015-03-01 00:39:41.000000', 'temperatura', 620.0000, 'ºC'),
	(87779, 111, '2015-03-01 00:39:42.000000', 'temperatura', 187.0000, 'ºC'),
	(87780, 111, '2015-03-01 00:39:43.000000', 'temperatura', 274.0000, 'ºC'),
	(87781, 111, '2015-03-01 00:39:44.000000', 'temperatura', 812.0000, 'ºC'),
	(87782, 111, '2015-03-01 00:39:45.000000', 'temperatura', 838.0000, 'ºC'),
	(87783, 111, '2015-03-01 00:39:46.000000', 'temperatura', 556.0000, 'ºC'),
	(87784, 111, '2015-03-01 00:39:47.000000', 'temperatura', 265.0000, 'ºC'),
	(87785, 111, '2015-03-01 00:39:48.000000', 'temperatura', 857.0000, 'ºC'),
	(87786, 111, '2015-03-01 00:39:49.000000', 'temperatura', 1093.0000, 'ºC'),
	(87787, 111, '2015-03-01 00:39:50.000000', 'temperatura', 491.0000, 'ºC'),
	(87788, 111, '2015-03-01 00:39:51.000000', 'temperatura', 379.0000, 'ºC'),
	(87789, 111, '2015-03-01 00:39:52.000000', 'temperatura', 421.0000, 'ºC'),
	(87790, 111, '2015-03-01 00:39:53.000000', 'temperatura', 969.0000, 'ºC'),
	(87791, 111, '2015-03-01 00:39:54.000000', 'temperatura', 1182.0000, 'ºC'),
	(87792, 111, '2015-03-01 00:39:55.000000', 'temperatura', 603.0000, 'ºC'),
	(87793, 111, '2015-03-01 00:39:56.000000', 'temperatura', 669.0000, 'ºC'),
	(87794, 111, '2015-03-01 00:39:57.000000', 'temperatura', 335.0000, 'ºC'),
	(87795, 111, '2015-03-01 00:39:58.000000', 'temperatura', 871.0000, 'ºC'),
	(87796, 111, '2015-03-01 00:39:59.000000', 'temperatura', 950.0000, 'ºC'),
	(87797, 111, '2015-03-01 00:40:00.000000', 'temperatura', 939.0000, 'ºC'),
	(87798, 111, '2015-03-01 00:40:01.000000', 'temperatura', 645.0000, 'ºC'),
	(87799, 111, '2015-03-01 00:40:02.000000', 'temperatura', 408.0000, 'ºC'),
	(87800, 111, '2015-03-01 00:40:03.000000', 'temperatura', 107.0000, 'ºC'),
	(87801, 111, '2015-03-01 00:40:04.000000', 'temperatura', 511.0000, 'ºC'),
	(87802, 111, '2015-03-01 00:40:05.000000', 'temperatura', 1034.0000, 'ºC'),
	(87803, 111, '2015-03-01 00:40:06.000000', 'temperatura', 40.0000, 'ºC'),
	(87804, 111, '2015-03-01 00:40:07.000000', 'temperatura', 695.0000, 'ºC'),
	(87805, 111, '2015-03-01 00:40:08.000000', 'temperatura', 956.0000, 'ºC'),
	(87806, 111, '2015-03-01 00:40:09.000000', 'temperatura', 295.0000, 'ºC'),
	(87807, 111, '2015-03-01 00:40:10.000000', 'temperatura', 1007.0000, 'ºC'),
	(87808, 111, '2015-03-01 00:40:11.000000', 'temperatura', 549.0000, 'ºC'),
	(87809, 111, '2015-03-01 00:40:12.000000', 'temperatura', 927.0000, 'ºC'),
	(87810, 111, '2015-03-01 00:40:13.000000', 'temperatura', 589.0000, 'ºC'),
	(87811, 111, '2015-03-01 00:40:14.000000', 'temperatura', 164.0000, 'ºC'),
	(87812, 111, '2015-03-01 00:40:15.000000', 'temperatura', 253.0000, 'ºC'),
	(87813, 111, '2015-03-01 00:40:16.000000', 'temperatura', 773.0000, 'ºC'),
	(87814, 111, '2015-03-01 00:40:17.000000', 'temperatura', 706.0000, 'ºC'),
	(87815, 111, '2015-03-01 00:40:18.000000', 'temperatura', 14.0000, 'ºC'),
	(87816, 111, '2015-03-01 00:40:19.000000', 'temperatura', 351.0000, 'ºC'),
	(87817, 111, '2015-03-01 00:40:20.000000', 'temperatura', 515.0000, 'ºC'),
	(87818, 111, '2015-03-01 00:40:21.000000', 'temperatura', 321.0000, 'ºC'),
	(87819, 111, '2015-03-01 00:40:22.000000', 'temperatura', 62.0000, 'ºC'),
	(87820, 111, '2015-03-01 00:40:23.000000', 'temperatura', 549.0000, 'ºC'),
	(87821, 111, '2015-03-01 00:40:24.000000', 'temperatura', 157.0000, 'ºC'),
	(87822, 111, '2015-03-01 00:40:25.000000', 'temperatura', 337.0000, 'ºC'),
	(87823, 111, '2015-03-01 00:40:26.000000', 'temperatura', 17.0000, 'ºC'),
	(87824, 111, '2015-03-01 00:40:27.000000', 'temperatura', 274.0000, 'ºC'),
	(87825, 111, '2015-03-01 00:40:28.000000', 'temperatura', 118.0000, 'ºC'),
	(87826, 111, '2015-03-01 00:40:29.000000', 'temperatura', 971.0000, 'ºC'),
	(87827, 111, '2015-03-01 00:40:30.000000', 'temperatura', 901.0000, 'ºC'),
	(87828, 111, '2015-03-01 00:40:31.000000', 'temperatura', 394.0000, 'ºC'),
	(87829, 111, '2015-03-01 00:40:32.000000', 'temperatura', 464.0000, 'ºC'),
	(87830, 111, '2015-03-01 00:40:33.000000', 'temperatura', 1141.0000, 'ºC'),
	(87831, 111, '2015-03-01 00:40:34.000000', 'temperatura', 712.0000, 'ºC'),
	(87832, 111, '2015-03-01 00:40:35.000000', 'temperatura', 140.0000, 'ºC'),
	(87833, 111, '2015-03-01 00:40:36.000000', 'temperatura', 962.0000, 'ºC'),
	(87834, 111, '2015-03-01 00:40:37.000000', 'temperatura', 793.0000, 'ºC'),
	(87835, 111, '2015-03-01 00:40:38.000000', 'temperatura', 1078.0000, 'ºC'),
	(87836, 111, '2015-03-01 00:40:39.000000', 'temperatura', 613.0000, 'ºC'),
	(87837, 111, '2015-03-01 00:40:40.000000', 'temperatura', 1032.0000, 'ºC'),
	(87838, 111, '2015-03-01 00:40:41.000000', 'temperatura', 919.0000, 'ºC'),
	(87839, 111, '2015-03-01 00:40:42.000000', 'temperatura', 300.0000, 'ºC'),
	(87840, 111, '2015-03-01 00:40:43.000000', 'temperatura', 1143.0000, 'ºC'),
	(87841, 111, '2015-03-01 00:40:44.000000', 'temperatura', 16.0000, 'ºC'),
	(87842, 111, '2015-03-01 00:40:45.000000', 'temperatura', 252.0000, 'ºC'),
	(87843, 111, '2015-03-01 00:40:46.000000', 'temperatura', 10.0000, 'ºC'),
	(87844, 111, '2015-03-01 00:40:47.000000', 'temperatura', 498.0000, 'ºC'),
	(87845, 111, '2015-03-01 00:40:48.000000', 'temperatura', 57.0000, 'ºC'),
	(87846, 111, '2015-03-01 00:40:49.000000', 'temperatura', 1194.0000, 'ºC'),
	(87847, 111, '2015-03-01 00:40:50.000000', 'temperatura', 999.0000, 'ºC'),
	(87848, 111, '2015-03-01 00:40:51.000000', 'temperatura', 214.0000, 'ºC'),
	(87849, 111, '2015-03-01 00:40:52.000000', 'temperatura', 475.0000, 'ºC'),
	(87850, 111, '2015-03-01 00:40:53.000000', 'temperatura', 531.0000, 'ºC'),
	(87851, 111, '2015-03-01 00:40:54.000000', 'temperatura', 31.0000, 'ºC'),
	(87852, 111, '2015-03-01 00:40:55.000000', 'temperatura', 964.0000, 'ºC'),
	(87853, 111, '2015-03-01 00:40:56.000000', 'temperatura', 1126.0000, 'ºC'),
	(87854, 111, '2015-03-01 00:40:57.000000', 'temperatura', 340.0000, 'ºC'),
	(87855, 111, '2015-03-01 00:40:58.000000', 'temperatura', 720.0000, 'ºC'),
	(87856, 111, '2015-03-01 00:40:59.000000', 'temperatura', 180.0000, 'ºC'),
	(87857, 111, '2015-03-01 00:41:00.000000', 'temperatura', 1144.0000, 'ºC'),
	(87858, 111, '2015-03-01 00:41:01.000000', 'temperatura', 378.0000, 'ºC'),
	(87859, 111, '2015-03-01 00:41:02.000000', 'temperatura', 860.0000, 'ºC'),
	(87860, 111, '2015-03-01 00:41:03.000000', 'temperatura', 766.0000, 'ºC'),
	(87861, 111, '2015-03-01 00:41:04.000000', 'temperatura', 52.0000, 'ºC'),
	(87862, 111, '2015-03-01 00:41:05.000000', 'temperatura', 361.0000, 'ºC'),
	(87863, 111, '2015-03-01 00:41:06.000000', 'temperatura', 450.0000, 'ºC'),
	(87864, 111, '2015-03-01 00:41:07.000000', 'temperatura', 1166.0000, 'ºC'),
	(87865, 111, '2015-03-01 00:41:08.000000', 'temperatura', 880.0000, 'ºC'),
	(87866, 111, '2015-03-01 00:41:09.000000', 'temperatura', 905.0000, 'ºC'),
	(87867, 111, '2015-03-01 00:41:10.000000', 'temperatura', 685.0000, 'ºC'),
	(87868, 111, '2015-03-01 00:41:11.000000', 'temperatura', 712.0000, 'ºC'),
	(87869, 111, '2015-03-01 00:41:12.000000', 'temperatura', 302.0000, 'ºC'),
	(87870, 111, '2015-03-01 00:41:13.000000', 'temperatura', 576.0000, 'ºC'),
	(87871, 111, '2015-03-01 00:41:14.000000', 'temperatura', 775.0000, 'ºC'),
	(87872, 111, '2015-03-01 00:41:15.000000', 'temperatura', 949.0000, 'ºC'),
	(87873, 111, '2015-03-01 00:41:16.000000', 'temperatura', 18.0000, 'ºC'),
	(87874, 111, '2015-03-01 00:41:17.000000', 'temperatura', 845.0000, 'ºC'),
	(87875, 111, '2015-03-01 00:41:18.000000', 'temperatura', 571.0000, 'ºC'),
	(87876, 111, '2015-03-01 00:41:19.000000', 'temperatura', 318.0000, 'ºC'),
	(87877, 111, '2015-03-01 00:41:20.000000', 'temperatura', 1081.0000, 'ºC'),
	(87878, 111, '2015-03-01 00:41:21.000000', 'temperatura', 850.0000, 'ºC'),
	(87879, 111, '2015-03-01 00:41:22.000000', 'temperatura', 1009.0000, 'ºC'),
	(87880, 111, '2015-03-01 00:41:23.000000', 'temperatura', 95.0000, 'ºC'),
	(87881, 111, '2015-03-01 00:41:24.000000', 'temperatura', 1049.0000, 'ºC'),
	(87882, 111, '2015-03-01 00:41:25.000000', 'temperatura', 160.0000, 'ºC'),
	(87883, 111, '2015-03-01 00:41:26.000000', 'temperatura', 55.0000, 'ºC'),
	(87884, 111, '2015-03-01 00:41:27.000000', 'temperatura', 992.0000, 'ºC'),
	(87885, 111, '2015-03-01 00:41:28.000000', 'temperatura', 1199.0000, 'ºC'),
	(87886, 111, '2015-03-01 00:41:29.000000', 'temperatura', 618.0000, 'ºC'),
	(87887, 111, '2015-03-01 00:41:30.000000', 'temperatura', 694.0000, 'ºC'),
	(87888, 111, '2015-03-01 00:41:31.000000', 'temperatura', 416.0000, 'ºC'),
	(87889, 111, '2015-03-01 00:41:32.000000', 'temperatura', 1197.0000, 'ºC'),
	(87890, 111, '2015-03-01 00:41:33.000000', 'temperatura', 1140.0000, 'ºC'),
	(87891, 111, '2015-03-01 00:41:34.000000', 'temperatura', 907.0000, 'ºC'),
	(87892, 111, '2015-03-01 00:41:35.000000', 'temperatura', 1115.0000, 'ºC'),
	(87893, 111, '2015-03-01 00:41:36.000000', 'temperatura', 455.0000, 'ºC'),
	(87894, 111, '2015-03-01 00:41:37.000000', 'temperatura', 132.0000, 'ºC'),
	(87895, 111, '2015-03-01 00:41:38.000000', 'temperatura', 493.0000, 'ºC'),
	(87896, 111, '2015-03-01 00:41:39.000000', 'temperatura', 872.0000, 'ºC'),
	(87897, 111, '2015-03-01 00:41:40.000000', 'temperatura', 480.0000, 'ºC'),
	(87898, 111, '2015-03-01 00:41:41.000000', 'temperatura', 986.0000, 'ºC'),
	(87899, 111, '2015-03-01 00:41:42.000000', 'temperatura', 1090.0000, 'ºC'),
	(87900, 111, '2015-03-01 00:41:43.000000', 'temperatura', 91.0000, 'ºC'),
	(87901, 111, '2015-03-01 00:41:44.000000', 'temperatura', 788.0000, 'ºC'),
	(87902, 111, '2015-03-01 00:41:45.000000', 'temperatura', 67.0000, 'ºC'),
	(87903, 111, '2015-03-01 00:41:46.000000', 'temperatura', 372.0000, 'ºC'),
	(87904, 111, '2015-03-01 00:41:47.000000', 'temperatura', 460.0000, 'ºC'),
	(87905, 111, '2015-03-01 00:41:48.000000', 'temperatura', 1184.0000, 'ºC'),
	(87906, 111, '2015-03-01 00:41:49.000000', 'temperatura', 942.0000, 'ºC'),
	(87907, 111, '2015-03-01 00:41:50.000000', 'temperatura', 1159.0000, 'ºC'),
	(87908, 111, '2015-03-01 00:41:51.000000', 'temperatura', 567.0000, 'ºC'),
	(87909, 111, '2015-03-01 00:41:52.000000', 'temperatura', 560.0000, 'ºC'),
	(87910, 111, '2015-03-01 00:41:53.000000', 'temperatura', 1097.0000, 'ºC'),
	(87911, 111, '2015-03-01 00:41:54.000000', 'temperatura', 208.0000, 'ºC'),
	(87912, 111, '2015-03-01 00:41:55.000000', 'temperatura', 148.0000, 'ºC'),
	(87913, 111, '2015-03-01 00:41:56.000000', 'temperatura', 115.0000, 'ºC'),
	(87914, 111, '2015-03-01 00:41:57.000000', 'temperatura', 133.0000, 'ºC'),
	(87915, 111, '2015-03-01 00:41:58.000000', 'temperatura', 319.0000, 'ºC'),
	(87916, 111, '2015-03-01 00:41:59.000000', 'temperatura', 1196.0000, 'ºC'),
	(87917, 111, '2015-03-01 00:42:00.000000', 'temperatura', 225.0000, 'ºC'),
	(87918, 111, '2015-03-01 00:42:01.000000', 'temperatura', 1135.0000, 'ºC'),
	(87919, 111, '2015-03-01 00:42:02.000000', 'temperatura', 203.0000, 'ºC'),
	(87920, 111, '2015-03-01 00:42:03.000000', 'temperatura', 12.0000, 'ºC'),
	(87921, 111, '2015-03-01 00:42:04.000000', 'temperatura', 650.0000, 'ºC'),
	(87922, 111, '2015-03-01 00:42:05.000000', 'temperatura', 813.0000, 'ºC'),
	(87923, 111, '2015-03-01 00:42:06.000000', 'temperatura', 918.0000, 'ºC'),
	(87924, 111, '2015-03-01 00:42:07.000000', 'temperatura', 952.0000, 'ºC'),
	(87925, 111, '2015-03-01 00:42:08.000000', 'temperatura', 807.0000, 'ºC'),
	(87926, 111, '2015-03-01 00:42:09.000000', 'temperatura', 1176.0000, 'ºC'),
	(87927, 111, '2015-03-01 00:42:10.000000', 'temperatura', 1062.0000, 'ºC'),
	(87928, 111, '2015-03-01 00:42:11.000000', 'temperatura', 583.0000, 'ºC'),
	(87929, 111, '2015-03-01 00:42:12.000000', 'temperatura', 930.0000, 'ºC'),
	(87930, 111, '2015-03-01 00:42:13.000000', 'temperatura', 502.0000, 'ºC'),
	(87931, 111, '2015-03-01 00:42:14.000000', 'temperatura', 918.0000, 'ºC'),
	(87932, 111, '2015-03-01 00:42:15.000000', 'temperatura', 688.0000, 'ºC'),
	(87933, 111, '2015-03-01 00:42:16.000000', 'temperatura', 684.0000, 'ºC'),
	(87934, 111, '2015-03-01 00:42:17.000000', 'temperatura', 155.0000, 'ºC'),
	(87935, 111, '2015-03-01 00:42:18.000000', 'temperatura', 1126.0000, 'ºC'),
	(87936, 111, '2015-03-01 00:42:19.000000', 'temperatura', 364.0000, 'ºC'),
	(87937, 111, '2015-03-01 00:42:20.000000', 'temperatura', 842.0000, 'ºC'),
	(87938, 111, '2015-03-01 00:42:21.000000', 'temperatura', 718.0000, 'ºC'),
	(87939, 111, '2015-03-01 00:42:22.000000', 'temperatura', 1064.0000, 'ºC'),
	(87940, 111, '2015-03-01 00:42:23.000000', 'temperatura', 766.0000, 'ºC'),
	(87941, 111, '2015-03-01 00:42:24.000000', 'temperatura', 642.0000, 'ºC'),
	(87942, 111, '2015-03-01 00:42:25.000000', 'temperatura', 909.0000, 'ºC'),
	(87943, 111, '2015-03-01 00:42:26.000000', 'temperatura', 220.0000, 'ºC'),
	(87944, 111, '2015-03-01 00:42:27.000000', 'temperatura', 772.0000, 'ºC'),
	(87945, 111, '2015-03-01 00:42:28.000000', 'temperatura', 801.0000, 'ºC'),
	(87946, 111, '2015-03-01 00:42:29.000000', 'temperatura', 492.0000, 'ºC'),
	(87947, 111, '2015-03-01 00:42:30.000000', 'temperatura', 56.0000, 'ºC'),
	(87948, 111, '2015-03-01 00:42:31.000000', 'temperatura', 6.0000, 'ºC'),
	(87949, 111, '2015-03-01 00:42:32.000000', 'temperatura', 1063.0000, 'ºC'),
	(87950, 111, '2015-03-01 00:42:33.000000', 'temperatura', 498.0000, 'ºC'),
	(87951, 111, '2015-03-01 00:42:34.000000', 'temperatura', 499.0000, 'ºC'),
	(87952, 111, '2015-03-01 00:42:35.000000', 'temperatura', 1004.0000, 'ºC'),
	(87953, 111, '2015-03-01 00:42:36.000000', 'temperatura', 1124.0000, 'ºC'),
	(87954, 111, '2015-03-01 00:42:37.000000', 'temperatura', 209.0000, 'ºC'),
	(87955, 111, '2015-03-01 00:42:38.000000', 'temperatura', 72.0000, 'ºC'),
	(87956, 111, '2015-03-01 00:42:39.000000', 'temperatura', 935.0000, 'ºC'),
	(87957, 111, '2015-03-01 00:42:40.000000', 'temperatura', 857.0000, 'ºC'),
	(87958, 111, '2015-03-01 00:42:41.000000', 'temperatura', 282.0000, 'ºC'),
	(87959, 111, '2015-03-01 00:42:42.000000', 'temperatura', 39.0000, 'ºC'),
	(87960, 111, '2015-03-01 00:42:43.000000', 'temperatura', 549.0000, 'ºC'),
	(87961, 111, '2015-03-01 00:42:44.000000', 'temperatura', 227.0000, 'ºC'),
	(87962, 111, '2015-03-01 00:42:45.000000', 'temperatura', 692.0000, 'ºC'),
	(87963, 111, '2015-03-01 00:42:46.000000', 'temperatura', 378.0000, 'ºC'),
	(87964, 111, '2015-03-01 00:42:47.000000', 'temperatura', 1013.0000, 'ºC'),
	(87965, 111, '2015-03-01 00:42:48.000000', 'temperatura', 333.0000, 'ºC'),
	(87966, 111, '2015-03-01 00:42:49.000000', 'temperatura', 1028.0000, 'ºC'),
	(87967, 111, '2015-03-01 00:42:50.000000', 'temperatura', 541.0000, 'ºC'),
	(87968, 111, '2015-03-01 00:42:51.000000', 'temperatura', 820.0000, 'ºC'),
	(87969, 111, '2015-03-01 00:42:52.000000', 'temperatura', 80.0000, 'ºC'),
	(87970, 111, '2015-03-01 00:42:53.000000', 'temperatura', 340.0000, 'ºC'),
	(87971, 111, '2015-03-01 00:42:54.000000', 'temperatura', 261.0000, 'ºC'),
	(87972, 111, '2015-03-01 00:42:55.000000', 'temperatura', 287.0000, 'ºC'),
	(87973, 111, '2015-03-01 00:42:56.000000', 'temperatura', 649.0000, 'ºC'),
	(87974, 111, '2015-03-01 00:42:57.000000', 'temperatura', 1185.0000, 'ºC'),
	(87975, 111, '2015-03-01 00:42:58.000000', 'temperatura', 380.0000, 'ºC'),
	(87976, 111, '2015-03-01 00:42:59.000000', 'temperatura', 744.0000, 'ºC'),
	(87977, 111, '2015-03-01 00:43:00.000000', 'temperatura', 181.0000, 'ºC'),
	(87978, 111, '2015-03-01 00:43:01.000000', 'temperatura', 1074.0000, 'ºC'),
	(87979, 111, '2015-03-01 00:43:02.000000', 'temperatura', 27.0000, 'ºC'),
	(87980, 111, '2015-03-01 00:43:03.000000', 'temperatura', 512.0000, 'ºC'),
	(87981, 111, '2015-03-01 00:43:04.000000', 'temperatura', 81.0000, 'ºC'),
	(87982, 111, '2015-03-01 00:43:05.000000', 'temperatura', 70.0000, 'ºC'),
	(87983, 111, '2015-03-01 00:43:06.000000', 'temperatura', 107.0000, 'ºC'),
	(87984, 111, '2015-03-01 00:43:07.000000', 'temperatura', 326.0000, 'ºC'),
	(87985, 111, '2015-03-01 00:43:08.000000', 'temperatura', 107.0000, 'ºC'),
	(87986, 111, '2015-03-01 00:43:09.000000', 'temperatura', 759.0000, 'ºC'),
	(87987, 111, '2015-03-01 00:43:10.000000', 'temperatura', 1076.0000, 'ºC'),
	(87988, 111, '2015-03-01 00:43:11.000000', 'temperatura', 701.0000, 'ºC'),
	(87989, 111, '2015-03-01 00:43:12.000000', 'temperatura', 280.0000, 'ºC'),
	(87990, 111, '2015-03-01 00:43:13.000000', 'temperatura', 498.0000, 'ºC'),
	(87991, 111, '2015-03-01 00:43:14.000000', 'temperatura', 451.0000, 'ºC'),
	(87992, 111, '2015-03-01 00:43:15.000000', 'temperatura', 761.0000, 'ºC'),
	(87993, 111, '2015-03-01 00:43:16.000000', 'temperatura', 50.0000, 'ºC'),
	(87994, 111, '2015-03-01 00:43:17.000000', 'temperatura', 370.0000, 'ºC'),
	(87995, 111, '2015-03-01 00:43:18.000000', 'temperatura', 498.0000, 'ºC'),
	(87996, 111, '2015-03-01 00:43:19.000000', 'temperatura', 184.0000, 'ºC'),
	(87997, 111, '2015-03-01 00:43:20.000000', 'temperatura', 623.0000, 'ºC'),
	(87998, 111, '2015-03-01 00:43:21.000000', 'temperatura', 165.0000, 'ºC'),
	(87999, 111, '2015-03-01 00:43:22.000000', 'temperatura', 158.0000, 'ºC'),
	(88000, 111, '2015-03-01 00:43:23.000000', 'temperatura', 296.0000, 'ºC'),
	(88001, 111, '2015-03-01 00:43:24.000000', 'temperatura', 1006.0000, 'ºC'),
	(88002, 111, '2015-03-01 00:43:25.000000', 'temperatura', 542.0000, 'ºC'),
	(88003, 111, '2015-03-01 00:43:26.000000', 'temperatura', 891.0000, 'ºC'),
	(88004, 111, '2015-03-01 00:43:27.000000', 'temperatura', 430.0000, 'ºC'),
	(88005, 111, '2015-03-01 00:43:28.000000', 'temperatura', 677.0000, 'ºC'),
	(88006, 111, '2015-03-01 00:43:29.000000', 'temperatura', 897.0000, 'ºC'),
	(88007, 111, '2015-03-01 00:43:30.000000', 'temperatura', 55.0000, 'ºC'),
	(88008, 111, '2015-03-01 00:43:31.000000', 'temperatura', 1182.0000, 'ºC'),
	(88009, 111, '2015-03-01 00:43:32.000000', 'temperatura', 945.0000, 'ºC'),
	(88010, 111, '2015-03-01 00:43:33.000000', 'temperatura', 1183.0000, 'ºC'),
	(88011, 111, '2015-03-01 00:43:34.000000', 'temperatura', 678.0000, 'ºC'),
	(88012, 111, '2015-03-01 00:43:35.000000', 'temperatura', 1043.0000, 'ºC'),
	(88013, 111, '2015-03-01 00:43:36.000000', 'temperatura', 780.0000, 'ºC'),
	(88014, 111, '2015-03-01 00:43:37.000000', 'temperatura', 773.0000, 'ºC'),
	(88015, 111, '2015-03-01 00:43:38.000000', 'temperatura', 325.0000, 'ºC'),
	(88016, 111, '2015-03-01 00:43:39.000000', 'temperatura', 505.0000, 'ºC'),
	(88017, 111, '2015-03-01 00:43:40.000000', 'temperatura', 351.0000, 'ºC'),
	(88018, 111, '2015-03-01 00:43:41.000000', 'temperatura', 239.0000, 'ºC'),
	(88019, 111, '2015-03-01 00:43:42.000000', 'temperatura', 146.0000, 'ºC'),
	(88020, 111, '2015-03-01 00:43:43.000000', 'temperatura', 11.0000, 'ºC'),
	(88021, 111, '2015-03-01 00:43:44.000000', 'temperatura', 819.0000, 'ºC'),
	(88022, 111, '2015-03-01 00:43:45.000000', 'temperatura', 463.0000, 'ºC'),
	(88023, 111, '2015-03-01 00:43:46.000000', 'temperatura', 1058.0000, 'ºC'),
	(88024, 111, '2015-03-01 00:43:47.000000', 'temperatura', 303.0000, 'ºC'),
	(88025, 111, '2015-03-01 00:43:48.000000', 'temperatura', 740.0000, 'ºC'),
	(88026, 111, '2015-03-01 00:43:49.000000', 'temperatura', 390.0000, 'ºC'),
	(88027, 111, '2015-03-01 00:43:50.000000', 'temperatura', 932.0000, 'ºC'),
	(88028, 111, '2015-03-01 00:43:51.000000', 'temperatura', 1090.0000, 'ºC'),
	(88029, 111, '2015-03-01 00:43:52.000000', 'temperatura', 254.0000, 'ºC'),
	(88030, 111, '2015-03-01 00:43:53.000000', 'temperatura', 401.0000, 'ºC'),
	(88031, 111, '2015-03-01 00:43:54.000000', 'temperatura', 44.0000, 'ºC'),
	(88032, 111, '2015-03-01 00:43:55.000000', 'temperatura', 217.0000, 'ºC'),
	(88033, 111, '2015-03-01 00:43:56.000000', 'temperatura', 952.0000, 'ºC'),
	(88034, 111, '2015-03-01 00:43:57.000000', 'temperatura', 510.0000, 'ºC'),
	(88035, 111, '2015-03-01 00:43:58.000000', 'temperatura', 893.0000, 'ºC'),
	(88036, 111, '2015-03-01 00:43:59.000000', 'temperatura', 537.0000, 'ºC'),
	(88037, 111, '2015-03-01 00:44:00.000000', 'temperatura', 5.0000, 'ºC'),
	(88038, 111, '2015-03-01 00:44:01.000000', 'temperatura', 814.0000, 'ºC'),
	(88039, 111, '2015-03-01 00:44:02.000000', 'temperatura', 457.0000, 'ºC'),
	(88040, 111, '2015-03-01 00:44:03.000000', 'temperatura', 1042.0000, 'ºC'),
	(88041, 111, '2015-03-01 00:44:04.000000', 'temperatura', 240.0000, 'ºC'),
	(88042, 111, '2015-03-01 00:44:05.000000', 'temperatura', 477.0000, 'ºC'),
	(88043, 111, '2015-03-01 00:44:06.000000', 'temperatura', 463.0000, 'ºC'),
	(88044, 111, '2015-03-01 00:44:07.000000', 'temperatura', 884.0000, 'ºC'),
	(88045, 111, '2015-03-01 00:44:08.000000', 'temperatura', 634.0000, 'ºC'),
	(88046, 111, '2015-03-01 00:44:09.000000', 'temperatura', 518.0000, 'ºC'),
	(88047, 111, '2015-03-01 00:44:10.000000', 'temperatura', 686.0000, 'ºC'),
	(88048, 111, '2015-03-01 00:44:11.000000', 'temperatura', 680.0000, 'ºC'),
	(88049, 111, '2015-03-01 00:44:12.000000', 'temperatura', 141.0000, 'ºC'),
	(88050, 111, '2015-03-01 00:44:13.000000', 'temperatura', 1066.0000, 'ºC'),
	(88051, 111, '2015-03-01 00:44:14.000000', 'temperatura', 109.0000, 'ºC'),
	(88052, 111, '2015-03-01 00:44:15.000000', 'temperatura', 947.0000, 'ºC'),
	(88053, 111, '2015-03-01 00:44:16.000000', 'temperatura', 807.0000, 'ºC'),
	(88054, 111, '2015-03-01 00:44:17.000000', 'temperatura', 1196.0000, 'ºC'),
	(88055, 111, '2015-03-01 00:44:18.000000', 'temperatura', 1161.0000, 'ºC'),
	(88056, 111, '2015-03-01 00:44:19.000000', 'temperatura', 1016.0000, 'ºC'),
	(88057, 111, '2015-03-01 00:44:20.000000', 'temperatura', 397.0000, 'ºC'),
	(88058, 111, '2015-03-01 00:44:21.000000', 'temperatura', 136.0000, 'ºC'),
	(88059, 111, '2015-03-01 00:44:22.000000', 'temperatura', 691.0000, 'ºC'),
	(88060, 111, '2015-03-01 00:44:23.000000', 'temperatura', 649.0000, 'ºC'),
	(88061, 111, '2015-03-01 00:44:24.000000', 'temperatura', 1172.0000, 'ºC'),
	(88062, 111, '2015-03-01 00:44:25.000000', 'temperatura', 312.0000, 'ºC'),
	(88063, 111, '2015-03-01 00:44:26.000000', 'temperatura', 444.0000, 'ºC'),
	(88064, 111, '2015-03-01 00:44:27.000000', 'temperatura', 87.0000, 'ºC'),
	(88065, 111, '2015-03-01 00:44:28.000000', 'temperatura', 301.0000, 'ºC'),
	(88066, 111, '2015-03-01 00:44:29.000000', 'temperatura', 45.0000, 'ºC'),
	(88067, 111, '2015-03-01 00:44:30.000000', 'temperatura', 524.0000, 'ºC'),
	(88068, 111, '2015-03-01 00:44:31.000000', 'temperatura', 86.0000, 'ºC'),
	(88069, 111, '2015-03-01 00:44:32.000000', 'temperatura', 57.0000, 'ºC'),
	(88070, 111, '2015-03-01 00:44:33.000000', 'temperatura', 27.0000, 'ºC'),
	(88071, 111, '2015-03-01 00:44:34.000000', 'temperatura', 1166.0000, 'ºC'),
	(88072, 111, '2015-03-01 00:44:35.000000', 'temperatura', 950.0000, 'ºC'),
	(88073, 111, '2015-03-01 00:44:36.000000', 'temperatura', 51.0000, 'ºC'),
	(88074, 111, '2015-03-01 00:44:37.000000', 'temperatura', 1006.0000, 'ºC'),
	(88075, 111, '2015-03-01 00:44:38.000000', 'temperatura', 79.0000, 'ºC'),
	(88076, 111, '2015-03-01 00:44:39.000000', 'temperatura', 977.0000, 'ºC'),
	(88077, 111, '2015-03-01 00:44:40.000000', 'temperatura', 1047.0000, 'ºC'),
	(88078, 111, '2015-03-01 00:44:41.000000', 'temperatura', 1106.0000, 'ºC'),
	(88079, 111, '2015-03-01 00:44:42.000000', 'temperatura', 1191.0000, 'ºC'),
	(88080, 111, '2015-03-01 00:44:43.000000', 'temperatura', 236.0000, 'ºC'),
	(88081, 111, '2015-03-01 00:44:44.000000', 'temperatura', 9.0000, 'ºC'),
	(88082, 111, '2015-03-01 00:44:45.000000', 'temperatura', 535.0000, 'ºC'),
	(88083, 111, '2015-03-01 00:44:46.000000', 'temperatura', 248.0000, 'ºC'),
	(88084, 111, '2015-03-01 00:44:47.000000', 'temperatura', 834.0000, 'ºC'),
	(88085, 111, '2015-03-01 00:44:48.000000', 'temperatura', 1030.0000, 'ºC'),
	(88086, 111, '2015-03-01 00:44:49.000000', 'temperatura', 248.0000, 'ºC'),
	(88087, 111, '2015-03-01 00:44:50.000000', 'temperatura', 552.0000, 'ºC'),
	(88088, 111, '2015-03-01 00:44:51.000000', 'temperatura', 814.0000, 'ºC'),
	(88089, 111, '2015-03-01 00:44:52.000000', 'temperatura', 15.0000, 'ºC'),
	(88090, 111, '2015-03-01 00:44:53.000000', 'temperatura', 35.0000, 'ºC'),
	(88091, 111, '2015-03-01 00:44:54.000000', 'temperatura', 129.0000, 'ºC'),
	(88092, 111, '2015-03-01 00:44:55.000000', 'temperatura', 540.0000, 'ºC'),
	(88093, 111, '2015-03-01 00:44:56.000000', 'temperatura', 1113.0000, 'ºC'),
	(88094, 111, '2015-03-01 00:44:57.000000', 'temperatura', 345.0000, 'ºC'),
	(88095, 111, '2015-03-01 00:44:58.000000', 'temperatura', 788.0000, 'ºC'),
	(88096, 111, '2015-03-01 00:44:59.000000', 'temperatura', 505.0000, 'ºC'),
	(88097, 111, '2015-03-01 00:45:00.000000', 'temperatura', 161.0000, 'ºC'),
	(88098, 111, '2015-03-01 00:45:01.000000', 'temperatura', 490.0000, 'ºC'),
	(88099, 111, '2015-03-01 00:45:02.000000', 'temperatura', 768.0000, 'ºC'),
	(88100, 111, '2015-03-01 00:45:03.000000', 'temperatura', 1171.0000, 'ºC'),
	(88101, 111, '2015-03-01 00:45:04.000000', 'temperatura', 1150.0000, 'ºC'),
	(88102, 111, '2015-03-01 00:45:05.000000', 'temperatura', 1039.0000, 'ºC'),
	(88103, 111, '2015-03-01 00:45:06.000000', 'temperatura', 546.0000, 'ºC'),
	(88104, 111, '2015-03-01 00:45:07.000000', 'temperatura', 813.0000, 'ºC'),
	(88105, 111, '2015-03-01 00:45:08.000000', 'temperatura', 29.0000, 'ºC'),
	(88106, 111, '2015-03-01 00:45:09.000000', 'temperatura', 107.0000, 'ºC'),
	(88107, 111, '2015-03-01 00:45:10.000000', 'temperatura', 449.0000, 'ºC'),
	(88108, 111, '2015-03-01 00:45:11.000000', 'temperatura', 725.0000, 'ºC'),
	(88109, 111, '2015-03-01 00:45:12.000000', 'temperatura', 1079.0000, 'ºC'),
	(88110, 111, '2015-03-01 00:45:13.000000', 'temperatura', 819.0000, 'ºC'),
	(88111, 111, '2015-03-01 00:45:14.000000', 'temperatura', 860.0000, 'ºC'),
	(88112, 111, '2015-03-01 00:45:15.000000', 'temperatura', 645.0000, 'ºC'),
	(88113, 111, '2015-03-01 00:45:16.000000', 'temperatura', 643.0000, 'ºC'),
	(88114, 111, '2015-03-01 00:45:17.000000', 'temperatura', 79.0000, 'ºC'),
	(88115, 111, '2015-03-01 00:45:18.000000', 'temperatura', 868.0000, 'ºC'),
	(88116, 111, '2015-03-01 00:45:19.000000', 'temperatura', 503.0000, 'ºC'),
	(88117, 111, '2015-03-01 00:45:20.000000', 'temperatura', 1112.0000, 'ºC'),
	(88118, 111, '2015-03-01 00:45:21.000000', 'temperatura', 451.0000, 'ºC'),
	(88119, 111, '2015-03-01 00:45:22.000000', 'temperatura', 121.0000, 'ºC'),
	(88120, 111, '2015-03-01 00:45:23.000000', 'temperatura', 454.0000, 'ºC'),
	(88121, 111, '2015-03-01 00:45:24.000000', 'temperatura', 704.0000, 'ºC'),
	(88122, 111, '2015-03-01 00:45:25.000000', 'temperatura', 961.0000, 'ºC'),
	(88123, 111, '2015-03-01 00:45:26.000000', 'temperatura', 292.0000, 'ºC'),
	(88124, 111, '2015-03-01 00:45:27.000000', 'temperatura', 978.0000, 'ºC'),
	(88125, 111, '2015-03-01 00:45:28.000000', 'temperatura', 416.0000, 'ºC'),
	(88126, 111, '2015-03-01 00:45:29.000000', 'temperatura', 346.0000, 'ºC'),
	(88127, 111, '2015-03-01 00:45:30.000000', 'temperatura', 481.0000, 'ºC'),
	(88128, 111, '2015-03-01 00:45:31.000000', 'temperatura', 170.0000, 'ºC'),
	(88129, 111, '2015-03-01 00:45:32.000000', 'temperatura', 604.0000, 'ºC'),
	(88130, 111, '2015-03-01 00:45:33.000000', 'temperatura', 113.0000, 'ºC'),
	(88131, 111, '2015-03-01 00:45:34.000000', 'temperatura', 1154.0000, 'ºC'),
	(88132, 111, '2015-03-01 00:45:35.000000', 'temperatura', 632.0000, 'ºC'),
	(88133, 111, '2015-03-01 00:45:36.000000', 'temperatura', 898.0000, 'ºC'),
	(88134, 111, '2015-03-01 00:45:37.000000', 'temperatura', 196.0000, 'ºC'),
	(88135, 111, '2015-03-01 00:45:38.000000', 'temperatura', 686.0000, 'ºC'),
	(88136, 111, '2015-03-01 00:45:39.000000', 'temperatura', 440.0000, 'ºC'),
	(88137, 111, '2015-03-01 00:45:40.000000', 'temperatura', 143.0000, 'ºC'),
	(88138, 111, '2015-03-01 00:45:41.000000', 'temperatura', 598.0000, 'ºC'),
	(88139, 111, '2015-03-01 00:45:42.000000', 'temperatura', 159.0000, 'ºC'),
	(88140, 111, '2015-03-01 00:45:43.000000', 'temperatura', 202.0000, 'ºC'),
	(88141, 111, '2015-03-01 00:45:44.000000', 'temperatura', 534.0000, 'ºC'),
	(88142, 111, '2015-03-01 00:45:45.000000', 'temperatura', 864.0000, 'ºC'),
	(88143, 111, '2015-03-01 00:45:46.000000', 'temperatura', 317.0000, 'ºC'),
	(88144, 111, '2015-03-01 00:45:47.000000', 'temperatura', 193.0000, 'ºC'),
	(88145, 111, '2015-03-01 00:45:48.000000', 'temperatura', 17.0000, 'ºC'),
	(88146, 111, '2015-03-01 00:45:49.000000', 'temperatura', 706.0000, 'ºC'),
	(88147, 111, '2015-03-01 00:45:50.000000', 'temperatura', 1078.0000, 'ºC'),
	(88148, 111, '2015-03-01 00:45:51.000000', 'temperatura', 871.0000, 'ºC'),
	(88149, 111, '2015-03-01 00:45:52.000000', 'temperatura', 1124.0000, 'ºC'),
	(88150, 111, '2015-03-01 00:45:53.000000', 'temperatura', 607.0000, 'ºC'),
	(88151, 111, '2015-03-01 00:45:54.000000', 'temperatura', 864.0000, 'ºC'),
	(88152, 111, '2015-03-01 00:45:55.000000', 'temperatura', 100.0000, 'ºC'),
	(88153, 111, '2015-03-01 00:45:56.000000', 'temperatura', 310.0000, 'ºC'),
	(88154, 111, '2015-03-01 00:45:57.000000', 'temperatura', 48.0000, 'ºC'),
	(88155, 111, '2015-03-01 00:45:58.000000', 'temperatura', 513.0000, 'ºC'),
	(88156, 111, '2015-03-01 00:45:59.000000', 'temperatura', 22.0000, 'ºC'),
	(88157, 111, '2015-03-01 00:46:00.000000', 'temperatura', 969.0000, 'ºC'),
	(88158, 111, '2015-03-01 00:46:01.000000', 'temperatura', 1182.0000, 'ºC'),
	(88159, 111, '2015-03-01 00:46:02.000000', 'temperatura', 602.0000, 'ºC'),
	(88160, 111, '2015-03-01 00:46:03.000000', 'temperatura', 663.0000, 'ºC'),
	(88161, 111, '2015-03-01 00:46:04.000000', 'temperatura', 311.0000, 'ºC'),
	(88162, 111, '2015-03-01 00:46:05.000000', 'temperatura', 766.0000, 'ºC'),
	(88163, 111, '2015-03-01 00:46:06.000000', 'temperatura', 499.0000, 'ºC'),
	(88164, 111, '2015-03-01 00:46:07.000000', 'temperatura', 198.0000, 'ºC'),
	(88165, 111, '2015-03-01 00:46:08.000000', 'temperatura', 693.0000, 'ºC'),
	(88166, 111, '2015-03-01 00:46:09.000000', 'temperatura', 469.0000, 'ºC'),
	(88167, 111, '2015-03-01 00:46:10.000000', 'temperatura', 268.0000, 'ºC'),
	(88168, 111, '2015-03-01 00:46:11.000000', 'temperatura', 1135.0000, 'ºC'),
	(88169, 111, '2015-03-01 00:46:12.000000', 'temperatura', 69.0000, 'ºC'),
	(88170, 111, '2015-03-01 00:46:13.000000', 'temperatura', 540.0000, 'ºC'),
	(88171, 111, '2015-03-01 00:46:14.000000', 'temperatura', 96.0000, 'ºC'),
	(88172, 111, '2015-03-01 00:46:15.000000', 'temperatura', 60.0000, 'ºC'),
	(88173, 111, '2015-03-01 00:46:16.000000', 'temperatura', 14.0000, 'ºC'),
	(88174, 111, '2015-03-01 00:46:17.000000', 'temperatura', 1088.0000, 'ºC'),
	(88175, 111, '2015-03-01 00:46:18.000000', 'temperatura', 599.0000, 'ºC'),
	(88176, 111, '2015-03-01 00:46:19.000000', 'temperatura', 934.0000, 'ºC'),
	(88177, 111, '2015-03-01 00:46:20.000000', 'temperatura', 470.0000, 'ºC'),
	(88178, 111, '2015-03-01 00:46:21.000000', 'temperatura', 752.0000, 'ºC'),
	(88179, 111, '2015-03-01 00:46:22.000000', 'temperatura', 1147.0000, 'ºC'),
	(88180, 111, '2015-03-01 00:46:23.000000', 'temperatura', 1082.0000, 'ºC'),
	(88181, 111, '2015-03-01 00:46:24.000000', 'temperatura', 769.0000, 'ºC'),
	(88182, 111, '2015-03-01 00:46:25.000000', 'temperatura', 597.0000, 'ºC'),
	(88183, 111, '2015-03-01 00:46:26.000000', 'temperatura', 681.0000, 'ºC'),
	(88184, 111, '2015-03-01 00:46:27.000000', 'temperatura', 414.0000, 'ºC'),
	(88185, 111, '2015-03-01 00:46:28.000000', 'temperatura', 27.0000, 'ºC'),
	(88186, 111, '2015-03-01 00:46:29.000000', 'temperatura', 95.0000, 'ºC'),
	(88187, 111, '2015-03-01 00:46:30.000000', 'temperatura', 394.0000, 'ºC'),
	(88188, 111, '2015-03-01 00:46:31.000000', 'temperatura', 484.0000, 'ºC'),
	(88189, 111, '2015-03-01 00:46:32.000000', 'temperatura', 40.0000, 'ºC'),
	(88190, 111, '2015-03-01 00:46:33.000000', 'temperatura', 1150.0000, 'ºC'),
	(88191, 111, '2015-03-01 00:46:34.000000', 'temperatura', 827.0000, 'ºC'),
	(88192, 111, '2015-03-01 00:46:35.000000', 'temperatura', 689.0000, 'ºC'),
	(88193, 111, '2015-03-01 00:46:36.000000', 'temperatura', 963.0000, 'ºC'),
	(88194, 111, '2015-03-01 00:46:37.000000', 'temperatura', 349.0000, 'ºC'),
	(88195, 111, '2015-03-01 00:46:38.000000', 'temperatura', 55.0000, 'ºC'),
	(88196, 111, '2015-03-01 00:46:39.000000', 'temperatura', 428.0000, 'ºC'),
	(88197, 111, '2015-03-01 00:46:40.000000', 'temperatura', 778.0000, 'ºC'),
	(88198, 111, '2015-03-01 00:46:41.000000', 'temperatura', 207.0000, 'ºC'),
	(88199, 111, '2015-03-01 00:46:42.000000', 'temperatura', 1099.0000, 'ºC'),
	(88200, 111, '2015-03-01 00:46:43.000000', 'temperatura', 75.0000, 'ºC'),
	(88201, 111, '2015-03-01 00:46:44.000000', 'temperatura', 678.0000, 'ºC'),
	(88202, 111, '2015-03-01 00:46:45.000000', 'temperatura', 767.0000, 'ºC'),
	(88203, 111, '2015-03-01 00:46:46.000000', 'temperatura', 602.0000, 'ºC'),
	(88204, 111, '2015-03-01 00:46:47.000000', 'temperatura', 711.0000, 'ºC'),
	(88205, 111, '2015-03-01 00:46:48.000000', 'temperatura', 546.0000, 'ºC'),
	(88206, 111, '2015-03-01 00:46:49.000000', 'temperatura', 601.0000, 'ºC'),
	(88207, 111, '2015-03-01 00:46:50.000000', 'temperatura', 165.0000, 'ºC'),
	(88208, 111, '2015-03-01 00:46:51.000000', 'temperatura', 224.0000, 'ºC'),
	(88209, 111, '2015-03-01 00:46:52.000000', 'temperatura', 625.0000, 'ºC'),
	(88210, 111, '2015-03-01 00:46:53.000000', 'temperatura', 53.0000, 'ºC'),
	(88211, 111, '2015-03-01 00:46:54.000000', 'temperatura', 793.0000, 'ºC'),
	(88212, 111, '2015-03-01 00:46:55.000000', 'temperatura', 203.0000, 'ºC'),
	(88213, 111, '2015-03-01 00:46:56.000000', 'temperatura', 1039.0000, 'ºC'),
	(88214, 111, '2015-03-01 00:46:57.000000', 'temperatura', 984.0000, 'ºC'),
	(88215, 111, '2015-03-01 00:46:58.000000', 'temperatura', 605.0000, 'ºC'),
	(88216, 111, '2015-03-01 00:46:59.000000', 'temperatura', 75.0000, 'ºC'),
	(88217, 111, '2015-03-01 00:47:00.000000', 'temperatura', 958.0000, 'ºC'),
	(88218, 111, '2015-03-01 00:47:01.000000', 'temperatura', 967.0000, 'ºC'),
	(88219, 111, '2015-03-01 00:47:02.000000', 'temperatura', 763.0000, 'ºC'),
	(88220, 111, '2015-03-01 00:47:03.000000', 'temperatura', 911.0000, 'ºC'),
	(88221, 111, '2015-03-01 00:47:04.000000', 'temperatura', 1068.0000, 'ºC'),
	(88222, 111, '2015-03-01 00:47:05.000000', 'temperatura', 209.0000, 'ºC'),
	(88223, 111, '2015-03-01 00:47:06.000000', 'temperatura', 241.0000, 'ºC'),
	(88224, 111, '2015-03-01 00:47:07.000000', 'temperatura', 577.0000, 'ºC'),
	(88225, 111, '2015-03-01 00:47:08.000000', 'temperatura', 963.0000, 'ºC'),
	(88226, 111, '2015-03-01 00:47:09.000000', 'temperatura', 686.0000, 'ºC'),
	(88227, 111, '2015-03-01 00:47:10.000000', 'temperatura', 539.0000, 'ºC'),
	(88228, 111, '2015-03-01 00:47:11.000000', 'temperatura', 637.0000, 'ºC'),
	(88229, 111, '2015-03-01 00:47:12.000000', 'temperatura', 368.0000, 'ºC'),
	(88230, 111, '2015-03-01 00:47:13.000000', 'temperatura', 1130.0000, 'ºC'),
	(88231, 111, '2015-03-01 00:47:14.000000', 'temperatura', 948.0000, 'ºC'),
	(88232, 111, '2015-03-01 00:47:15.000000', 'temperatura', 151.0000, 'ºC'),
	(88233, 111, '2015-03-01 00:47:16.000000', 'temperatura', 312.0000, 'ºC'),
	(88234, 111, '2015-03-01 00:47:17.000000', 'temperatura', 1107.0000, 'ºC'),
	(88235, 111, '2015-03-01 00:47:18.000000', 'temperatura', 999.0000, 'ºC'),
	(88236, 111, '2015-03-01 00:47:19.000000', 'temperatura', 475.0000, 'ºC'),
	(88237, 111, '2015-03-01 00:47:20.000000', 'temperatura', 579.0000, 'ºC'),
	(88238, 111, '2015-03-01 00:47:21.000000', 'temperatura', 272.0000, 'ºC'),
	(88239, 111, '2015-03-01 00:47:22.000000', 'temperatura', 820.0000, 'ºC'),
	(88240, 111, '2015-03-01 00:47:23.000000', 'temperatura', 887.0000, 'ºC'),
	(88241, 111, '2015-03-01 00:47:24.000000', 'temperatura', 775.0000, 'ºC'),
	(88242, 111, '2015-03-01 00:47:25.000000', 'temperatura', 15.0000, 'ºC'),
	(88243, 111, '2015-03-01 00:47:26.000000', 'temperatura', 151.0000, 'ºC'),
	(88244, 111, '2015-03-01 00:47:27.000000', 'temperatura', 708.0000, 'ºC'),
	(88245, 111, '2015-03-01 00:47:28.000000', 'temperatura', 689.0000, 'ºC'),
	(88246, 111, '2015-03-01 00:47:29.000000', 'temperatura', 123.0000, 'ºC'),
	(88247, 111, '2015-03-01 00:47:30.000000', 'temperatura', 947.0000, 'ºC'),
	(88248, 111, '2015-03-01 00:47:31.000000', 'temperatura', 769.0000, 'ºC'),
	(88249, 111, '2015-03-01 00:47:32.000000', 'temperatura', 1001.0000, 'ºC'),
	(88250, 111, '2015-03-01 00:47:33.000000', 'temperatura', 301.0000, 'ºC'),
	(88251, 111, '2015-03-01 00:47:34.000000', 'temperatura', 902.0000, 'ºC'),
	(88252, 111, '2015-03-01 00:47:35.000000', 'temperatura', 8.0000, 'ºC'),
	(88253, 111, '2015-03-01 00:47:36.000000', 'temperatura', 936.0000, 'ºC'),
	(88254, 111, '2015-03-01 00:47:37.000000', 'temperatura', 1056.0000, 'ºC'),
	(88255, 111, '2015-03-01 00:47:38.000000', 'temperatura', 71.0000, 'ºC'),
	(88256, 111, '2015-03-01 00:47:39.000000', 'temperatura', 786.0000, 'ºC'),
	(88257, 111, '2015-03-01 00:47:40.000000', 'temperatura', 121.0000, 'ºC'),
	(88258, 111, '2015-03-01 00:47:41.000000', 'temperatura', 646.0000, 'ºC'),
	(88259, 111, '2015-03-01 00:47:42.000000', 'temperatura', 468.0000, 'ºC'),
	(88260, 111, '2015-03-01 00:47:43.000000', 'temperatura', 404.0000, 'ºC'),
	(88261, 111, '2015-03-01 00:47:44.000000', 'temperatura', 614.0000, 'ºC'),
	(88262, 111, '2015-03-01 00:47:45.000000', 'temperatura', 660.0000, 'ºC'),
	(88263, 111, '2015-03-01 00:47:46.000000', 'temperatura', 259.0000, 'ºC'),
	(88264, 111, '2015-03-01 00:47:47.000000', 'temperatura', 514.0000, 'ºC'),
	(88265, 111, '2015-03-01 00:47:48.000000', 'temperatura', 594.0000, 'ºC'),
	(88266, 111, '2015-03-01 00:47:49.000000', 'temperatura', 230.0000, 'ºC'),
	(88267, 111, '2015-03-01 00:47:50.000000', 'temperatura', 568.0000, 'ºC'),
	(88268, 111, '2015-03-01 00:47:51.000000', 'temperatura', 951.0000, 'ºC'),
	(88269, 111, '2015-03-01 00:47:52.000000', 'temperatura', 653.0000, 'ºC'),
	(88270, 111, '2015-03-01 00:47:53.000000', 'temperatura', 410.0000, 'ºC'),
	(88271, 111, '2015-03-01 00:47:54.000000', 'temperatura', 91.0000, 'ºC'),
	(88272, 111, '2015-03-01 00:47:55.000000', 'temperatura', 427.0000, 'ºC'),
	(88273, 111, '2015-03-01 00:47:56.000000', 'temperatura', 663.0000, 'ºC'),
	(88274, 111, '2015-03-01 00:47:57.000000', 'temperatura', 835.0000, 'ºC'),
	(88275, 111, '2015-03-01 00:47:58.000000', 'temperatura', 984.0000, 'ºC'),
	(88276, 111, '2015-03-01 00:47:59.000000', 'temperatura', 17.0000, 'ºC'),
	(88277, 111, '2015-03-01 00:48:00.000000', 'temperatura', 735.0000, 'ºC'),
	(88278, 111, '2015-03-01 00:48:01.000000', 'temperatura', 25.0000, 'ºC'),
	(88279, 111, '2015-03-01 00:48:02.000000', 'temperatura', 318.0000, 'ºC'),
	(88280, 111, '2015-03-01 00:48:03.000000', 'temperatura', 315.0000, 'ºC'),
	(88281, 111, '2015-03-01 00:48:04.000000', 'temperatura', 621.0000, 'ºC'),
	(88282, 111, '2015-03-01 00:48:05.000000', 'temperatura', 962.0000, 'ºC'),
	(88283, 111, '2015-03-01 00:48:06.000000', 'temperatura', 546.0000, 'ºC'),
	(88284, 111, '2015-03-01 00:48:07.000000', 'temperatura', 1046.0000, 'ºC'),
	(88285, 111, '2015-03-01 00:48:08.000000', 'temperatura', 1193.0000, 'ºC'),
	(88286, 111, '2015-03-01 00:48:09.000000', 'temperatura', 429.0000, 'ºC'),
	(88287, 111, '2015-03-01 00:48:10.000000', 'temperatura', 963.0000, 'ºC'),
	(88288, 111, '2015-03-01 00:48:11.000000', 'temperatura', 1130.0000, 'ºC'),
	(88289, 111, '2015-03-01 00:48:12.000000', 'temperatura', 361.0000, 'ºC'),
	(88290, 111, '2015-03-01 00:48:13.000000', 'temperatura', 815.0000, 'ºC'),
	(88291, 111, '2015-03-01 00:48:14.000000', 'temperatura', 592.0000, 'ºC'),
	(88292, 111, '2015-03-01 00:48:15.000000', 'temperatura', 515.0000, 'ºC'),
	(88293, 111, '2015-03-01 00:48:16.000000', 'temperatura', 800.0000, 'ºC'),
	(88294, 111, '2015-03-01 00:48:17.000000', 'temperatura', 55.0000, 'ºC'),
	(88295, 111, '2015-03-01 00:48:18.000000', 'temperatura', 277.0000, 'ºC'),
	(88296, 111, '2015-03-01 00:48:19.000000', 'temperatura', 18.0000, 'ºC'),
	(88297, 111, '2015-03-01 00:48:20.000000', 'temperatura', 461.0000, 'ºC'),
	(88298, 111, '2015-03-01 00:48:21.000000', 'temperatura', 1050.0000, 'ºC'),
	(88299, 111, '2015-03-01 00:48:22.000000', 'temperatura', 270.0000, 'ºC'),
	(88300, 111, '2015-03-01 00:48:23.000000', 'temperatura', 598.0000, 'ºC'),
	(88301, 111, '2015-03-01 00:48:24.000000', 'temperatura', 980.0000, 'ºC'),
	(88302, 111, '2015-03-01 00:48:25.000000', 'temperatura', 707.0000, 'ºC'),
	(88303, 111, '2015-03-01 00:48:26.000000', 'temperatura', 597.0000, 'ºC'),
	(88304, 111, '2015-03-01 00:48:27.000000', 'temperatura', 865.0000, 'ºC'),
	(88305, 111, '2015-03-01 00:48:28.000000', 'temperatura', 133.0000, 'ºC'),
	(88306, 111, '2015-03-01 00:48:29.000000', 'temperatura', 469.0000, 'ºC'),
	(88307, 111, '2015-03-01 00:48:30.000000', 'temperatura', 749.0000, 'ºC'),
	(88308, 111, '2015-03-01 00:48:31.000000', 'temperatura', 1136.0000, 'ºC'),
	(88309, 111, '2015-03-01 00:48:32.000000', 'temperatura', 1033.0000, 'ºC'),
	(88310, 111, '2015-03-01 00:48:33.000000', 'temperatura', 560.0000, 'ºC'),
	(88311, 111, '2015-03-01 00:48:34.000000', 'temperatura', 902.0000, 'ºC'),
	(88312, 111, '2015-03-01 00:48:35.000000', 'temperatura', 427.0000, 'ºC'),
	(88313, 111, '2015-03-01 00:48:36.000000', 'temperatura', 633.0000, 'ºC'),
	(88314, 111, '2015-03-01 00:48:37.000000', 'temperatura', 684.0000, 'ºC'),
	(88315, 111, '2015-03-01 00:48:38.000000', 'temperatura', 319.0000, 'ºC'),
	(88316, 111, '2015-03-01 00:48:39.000000', 'temperatura', 745.0000, 'ºC'),
	(88317, 111, '2015-03-01 00:48:40.000000', 'temperatura', 370.0000, 'ºC'),
	(88318, 111, '2015-03-01 00:48:41.000000', 'temperatura', 813.0000, 'ºC'),
	(88319, 111, '2015-03-01 00:48:42.000000', 'temperatura', 558.0000, 'ºC'),
	(88320, 111, '2015-03-01 00:48:43.000000', 'temperatura', 352.0000, 'ºC'),
	(88321, 111, '2015-03-01 00:48:44.000000', 'temperatura', 85.0000, 'ºC'),
	(88322, 111, '2015-03-01 00:48:45.000000', 'temperatura', 569.0000, 'ºC'),
	(88323, 111, '2015-03-01 00:48:46.000000', 'temperatura', 192.0000, 'ºC'),
	(88324, 111, '2015-03-01 00:48:47.000000', 'temperatura', 453.0000, 'ºC'),
	(88325, 111, '2015-03-01 00:48:48.000000', 'temperatura', 490.0000, 'ºC'),
	(88326, 111, '2015-03-01 00:48:49.000000', 'temperatura', 1092.0000, 'ºC'),
	(88327, 111, '2015-03-01 00:48:50.000000', 'temperatura', 391.0000, 'ºC'),
	(88328, 111, '2015-03-01 00:48:51.000000', 'temperatura', 1080.0000, 'ºC'),
	(88329, 111, '2015-03-01 00:48:52.000000', 'temperatura', 628.0000, 'ºC'),
	(88330, 111, '2015-03-01 00:48:53.000000', 'temperatura', 1101.0000, 'ºC'),
	(88331, 111, '2015-03-01 00:48:54.000000', 'temperatura', 22.0000, 'ºC'),
	(88332, 111, '2015-03-01 00:48:55.000000', 'temperatura', 407.0000, 'ºC'),
	(88333, 111, '2015-03-01 00:48:56.000000', 'temperatura', 768.0000, 'ºC'),
	(88334, 111, '2015-03-01 00:48:57.000000', 'temperatura', 221.0000, 'ºC'),
	(88335, 111, '2015-03-01 00:48:58.000000', 'temperatura', 3.0000, 'ºC'),
	(88336, 111, '2015-03-01 00:48:59.000000', 'temperatura', 550.0000, 'ºC'),
	(88337, 111, '2015-03-01 00:49:00.000000', 'temperatura', 342.0000, 'ºC'),
	(88338, 111, '2015-03-01 00:49:01.000000', 'temperatura', 62.0000, 'ºC'),
	(88339, 111, '2015-03-01 00:49:02.000000', 'temperatura', 483.0000, 'ºC'),
	(88340, 111, '2015-03-01 00:49:03.000000', 'temperatura', 1030.0000, 'ºC'),
	(88341, 111, '2015-03-01 00:49:04.000000', 'temperatura', 101.0000, 'ºC'),
	(88342, 111, '2015-03-01 00:49:05.000000', 'temperatura', 1018.0000, 'ºC'),
	(88343, 111, '2015-03-01 00:49:06.000000', 'temperatura', 1184.0000, 'ºC'),
	(88344, 111, '2015-03-01 00:49:07.000000', 'temperatura', 470.0000, 'ºC'),
	(88345, 111, '2015-03-01 00:49:08.000000', 'temperatura', 1197.0000, 'ºC'),
	(88346, 111, '2015-03-01 00:49:09.000000', 'temperatura', 975.0000, 'ºC'),
	(88347, 111, '2015-03-01 00:49:10.000000', 'temperatura', 85.0000, 'ºC'),
	(88348, 111, '2015-03-01 00:49:11.000000', 'temperatura', 1102.0000, 'ºC'),
	(88349, 111, '2015-03-01 00:49:12.000000', 'temperatura', 456.0000, 'ºC'),
	(88350, 111, '2015-03-01 00:49:13.000000', 'temperatura', 174.0000, 'ºC'),
	(88351, 111, '2015-03-01 00:49:14.000000', 'temperatura', 701.0000, 'ºC'),
	(88352, 111, '2015-03-01 00:49:15.000000', 'temperatura', 584.0000, 'ºC'),
	(88353, 111, '2015-03-01 00:49:16.000000', 'temperatura', 816.0000, 'ºC'),
	(88354, 111, '2015-03-01 00:49:17.000000', 'temperatura', 1131.0000, 'ºC'),
	(88355, 111, '2015-03-01 00:49:18.000000', 'temperatura', 808.0000, 'ºC'),
	(88356, 111, '2015-03-01 00:49:19.000000', 'temperatura', 646.0000, 'ºC'),
	(88357, 111, '2015-03-01 00:49:20.000000', 'temperatura', 809.0000, 'ºC'),
	(88358, 111, '2015-03-01 00:49:21.000000', 'temperatura', 905.0000, 'ºC'),
	(88359, 111, '2015-03-01 00:49:22.000000', 'temperatura', 897.0000, 'ºC'),
	(88360, 111, '2015-03-01 00:49:23.000000', 'temperatura', 573.0000, 'ºC'),
	(88361, 111, '2015-03-01 00:49:24.000000', 'temperatura', 174.0000, 'ºC'),
	(88362, 111, '2015-03-01 00:49:25.000000', 'temperatura', 351.0000, 'ºC'),
	(88363, 111, '2015-03-01 00:49:26.000000', 'temperatura', 35.0000, 'ºC'),
	(88364, 111, '2015-03-01 00:49:27.000000', 'temperatura', 322.0000, 'ºC'),
	(88365, 111, '2015-03-01 00:49:28.000000', 'temperatura', 305.0000, 'ºC'),
	(88366, 111, '2015-03-01 00:49:29.000000', 'temperatura', 558.0000, 'ºC'),
	(88367, 111, '2015-03-01 00:49:30.000000', 'temperatura', 678.0000, 'ºC'),
	(88368, 111, '2015-03-01 00:49:31.000000', 'temperatura', 514.0000, 'ºC'),
	(88369, 111, '2015-03-01 00:49:32.000000', 'temperatura', 539.0000, 'ºC'),
	(88370, 111, '2015-03-01 00:49:33.000000', 'temperatura', 1155.0000, 'ºC'),
	(88371, 111, '2015-03-01 00:49:34.000000', 'temperatura', 555.0000, 'ºC'),
	(88372, 111, '2015-03-01 00:49:35.000000', 'temperatura', 511.0000, 'ºC'),
	(88373, 111, '2015-03-01 00:49:36.000000', 'temperatura', 889.0000, 'ºC'),
	(88374, 111, '2015-03-01 00:49:37.000000', 'temperatura', 515.0000, 'ºC'),
	(88375, 111, '2015-03-01 00:49:38.000000', 'temperatura', 1108.0000, 'ºC'),
	(88376, 111, '2015-03-01 00:49:39.000000', 'temperatura', 396.0000, 'ºC'),
	(88377, 111, '2015-03-01 00:49:40.000000', 'temperatura', 1057.0000, 'ºC'),
	(88378, 111, '2015-03-01 00:49:41.000000', 'temperatura', 496.0000, 'ºC'),
	(88379, 111, '2015-03-01 00:49:42.000000', 'temperatura', 512.0000, 'ºC'),
	(88380, 111, '2015-03-01 00:49:43.000000', 'temperatura', 1072.0000, 'ºC'),
	(88381, 111, '2015-03-01 00:49:44.000000', 'temperatura', 224.0000, 'ºC'),
	(88382, 111, '2015-03-01 00:49:45.000000', 'temperatura', 303.0000, 'ºC'),
	(88383, 111, '2015-03-01 00:49:46.000000', 'temperatura', 845.0000, 'ºC'),
	(88384, 111, '2015-03-01 00:49:47.000000', 'temperatura', 917.0000, 'ºC'),
	(88385, 111, '2015-03-01 00:49:48.000000', 'temperatura', 849.0000, 'ºC'),
	(88386, 111, '2015-03-01 00:49:49.000000', 'temperatura', 295.0000, 'ºC'),
	(88387, 111, '2015-03-01 00:49:50.000000', 'temperatura', 127.0000, 'ºC'),
	(88388, 111, '2015-03-01 00:49:51.000000', 'temperatura', 951.0000, 'ºC'),
	(88389, 111, '2015-03-01 00:49:52.000000', 'temperatura', 776.0000, 'ºC'),
	(88390, 111, '2015-03-01 00:49:53.000000', 'temperatura', 1026.0000, 'ºC'),
	(88391, 111, '2015-03-01 00:49:54.000000', 'temperatura', 405.0000, 'ºC'),
	(88392, 111, '2015-03-01 00:49:55.000000', 'temperatura', 146.0000, 'ºC'),
	(88393, 111, '2015-03-01 00:49:56.000000', 'temperatura', 716.0000, 'ºC'),
	(88394, 111, '2015-03-01 00:49:57.000000', 'temperatura', 742.0000, 'ºC'),
	(88395, 111, '2015-03-01 00:49:58.000000', 'temperatura', 361.0000, 'ºC'),
	(88396, 111, '2015-03-01 00:49:59.000000', 'temperatura', 783.0000, 'ºC'),
	(88397, 111, '2015-03-01 00:50:00.000000', 'temperatura', 430.0000, 'ºC'),
	(88398, 111, '2015-03-01 00:50:01.000000', 'temperatura', 1001.0000, 'ºC'),
	(88399, 111, '2015-03-01 00:50:02.000000', 'temperatura', 118.0000, 'ºC'),
	(88400, 111, '2015-03-01 00:50:03.000000', 'temperatura', 1185.0000, 'ºC'),
	(88401, 111, '2015-03-01 00:50:04.000000', 'temperatura', 772.0000, 'ºC'),
	(88402, 111, '2015-03-01 00:50:05.000000', 'temperatura', 308.0000, 'ºC'),
	(88403, 111, '2015-03-01 00:50:06.000000', 'temperatura', 421.0000, 'ºC'),
	(88404, 111, '2015-03-01 00:50:07.000000', 'temperatura', 1184.0000, 'ºC'),
	(88405, 111, '2015-03-01 00:50:08.000000', 'temperatura', 1058.0000, 'ºC'),
	(88406, 111, '2015-03-01 00:50:09.000000', 'temperatura', 537.0000, 'ºC'),
	(88407, 111, '2015-03-01 00:50:10.000000', 'temperatura', 713.0000, 'ºC'),
	(88408, 111, '2015-03-01 00:50:11.000000', 'temperatura', 753.0000, 'ºC'),
	(88409, 111, '2015-03-01 00:50:12.000000', 'temperatura', 426.0000, 'ºC'),
	(88410, 111, '2015-03-01 00:50:13.000000', 'temperatura', 1073.0000, 'ºC'),
	(88411, 111, '2015-03-01 00:50:14.000000', 'temperatura', 487.0000, 'ºC'),
	(88412, 111, '2015-03-01 00:50:15.000000', 'temperatura', 418.0000, 'ºC'),
	(88413, 111, '2015-03-01 00:50:16.000000', 'temperatura', 628.0000, 'ºC'),
	(88414, 111, '2015-03-01 00:50:17.000000', 'temperatura', 687.0000, 'ºC'),
	(88415, 111, '2015-03-01 00:50:18.000000', 'temperatura', 353.0000, 'ºC'),
	(88416, 111, '2015-03-01 00:50:19.000000', 'temperatura', 904.0000, 'ºC'),
	(88417, 111, '2015-03-01 00:50:20.000000', 'temperatura', 1061.0000, 'ºC'),
	(88418, 111, '2015-03-01 00:50:21.000000', 'temperatura', 194.0000, 'ºC'),
	(88419, 111, '2015-03-01 00:50:22.000000', 'temperatura', 188.0000, 'ºC'),
	(88420, 111, '2015-03-01 00:50:23.000000', 'temperatura', 359.0000, 'ºC'),
	(88421, 111, '2015-03-01 00:50:24.000000', 'temperatura', 31.0000, 'ºC'),
	(88422, 111, '2015-03-01 00:50:25.000000', 'temperatura', 277.0000, 'ºC'),
	(88423, 111, '2015-03-01 00:50:26.000000', 'temperatura', 94.0000, 'ºC'),
	(88424, 111, '2015-03-01 00:50:27.000000', 'temperatura', 838.0000, 'ºC'),
	(88425, 111, '2015-03-01 00:50:28.000000', 'temperatura', 310.0000, 'ºC'),
	(88426, 111, '2015-03-01 00:50:29.000000', 'temperatura', 235.0000, 'ºC'),
	(88427, 111, '2015-03-01 00:50:30.000000', 'temperatura', 247.0000, 'ºC'),
	(88428, 111, '2015-03-01 00:50:31.000000', 'temperatura', 529.0000, 'ºC'),
	(88429, 111, '2015-03-01 00:50:32.000000', 'temperatura', 704.0000, 'ºC'),
	(88430, 111, '2015-03-01 00:50:33.000000', 'temperatura', 733.0000, 'ºC'),
	(88431, 111, '2015-03-01 00:50:34.000000', 'temperatura', 355.0000, 'ºC'),
	(88432, 111, '2015-03-01 00:50:35.000000', 'temperatura', 778.0000, 'ºC'),
	(88433, 111, '2015-03-01 00:50:36.000000', 'temperatura', 424.0000, 'ºC'),
	(88434, 111, '2015-03-01 00:50:37.000000', 'temperatura', 985.0000, 'ºC'),
	(88435, 111, '2015-03-01 00:50:38.000000', 'temperatura', 55.0000, 'ºC'),
	(88436, 111, '2015-03-01 00:50:39.000000', 'temperatura', 921.0000, 'ºC'),
	(88437, 111, '2015-03-01 00:50:40.000000', 'temperatura', 840.0000, 'ºC'),
	(88438, 111, '2015-03-01 00:50:41.000000', 'temperatura', 238.0000, 'ºC'),
	(88439, 111, '2015-03-01 00:50:42.000000', 'temperatura', 1071.0000, 'ºC'),
	(88440, 111, '2015-03-01 00:50:43.000000', 'temperatura', 1039.0000, 'ºC'),
	(88441, 111, '2015-03-01 00:50:44.000000', 'temperatura', 786.0000, 'ºC'),
	(88442, 111, '2015-03-01 00:50:45.000000', 'temperatura', 810.0000, 'ºC'),
	(88443, 111, '2015-03-01 00:50:46.000000', 'temperatura', 495.0000, 'ºC'),
	(88444, 111, '2015-03-01 00:50:47.000000', 'temperatura', 44.0000, 'ºC'),
	(88445, 111, '2015-03-01 00:50:48.000000', 'temperatura', 1135.0000, 'ºC'),
	(88446, 111, '2015-03-01 00:50:49.000000', 'temperatura', 745.0000, 'ºC'),
	(88447, 111, '2015-03-01 00:50:50.000000', 'temperatura', 322.0000, 'ºC'),
	(88448, 111, '2015-03-01 00:50:51.000000', 'temperatura', 574.0000, 'ºC'),
	(88449, 111, '2015-03-01 00:50:52.000000', 'temperatura', 703.0000, 'ºC'),
	(88450, 111, '2015-03-01 00:50:53.000000', 'temperatura', 594.0000, 'ºC'),
	(88451, 111, '2015-03-01 00:50:54.000000', 'temperatura', 862.0000, 'ºC'),
	(88452, 111, '2015-03-01 00:50:55.000000', 'temperatura', 126.0000, 'ºC'),
	(88453, 111, '2015-03-01 00:50:56.000000', 'temperatura', 448.0000, 'ºC'),
	(88454, 111, '2015-03-01 00:50:57.000000', 'temperatura', 661.0000, 'ºC'),
	(88455, 111, '2015-03-01 00:50:58.000000', 'temperatura', 761.0000, 'ºC'),
	(88456, 111, '2015-03-01 00:50:59.000000', 'temperatura', 625.0000, 'ºC'),
	(88457, 111, '2015-03-01 00:51:00.000000', 'temperatura', 841.0000, 'ºC'),
	(88458, 111, '2015-03-01 00:51:01.000000', 'temperatura', 1132.0000, 'ºC'),
	(88459, 111, '2015-03-01 00:51:02.000000', 'temperatura', 739.0000, 'ºC'),
	(88460, 111, '2015-03-01 00:51:03.000000', 'temperatura', 296.0000, 'ºC'),
	(88461, 111, '2015-03-01 00:51:04.000000', 'temperatura', 464.0000, 'ºC'),
	(88462, 111, '2015-03-01 00:51:05.000000', 'temperatura', 232.0000, 'ºC'),
	(88463, 111, '2015-03-01 00:51:06.000000', 'temperatura', 969.0000, 'ºC'),
	(88464, 111, '2015-03-01 00:51:07.000000', 'temperatura', 548.0000, 'ºC'),
	(88465, 111, '2015-03-01 00:51:08.000000', 'temperatura', 1034.0000, 'ºC'),
	(88466, 111, '2015-03-01 00:51:09.000000', 'temperatura', 1126.0000, 'ºC'),
	(88467, 111, '2015-03-01 00:51:10.000000', 'temperatura', 129.0000, 'ºC'),
	(88468, 111, '2015-03-01 00:51:11.000000', 'temperatura', 866.0000, 'ºC'),
	(88469, 111, '2015-03-01 00:51:12.000000', 'temperatura', 343.0000, 'ºC'),
	(88470, 111, '2015-03-01 00:51:13.000000', 'temperatura', 317.0000, 'ºC'),
	(88471, 111, '2015-03-01 00:51:14.000000', 'temperatura', 559.0000, 'ºC'),
	(88472, 111, '2015-03-01 00:51:15.000000', 'temperatura', 645.0000, 'ºC'),
	(88473, 111, '2015-03-01 00:51:16.000000', 'temperatura', 348.0000, 'ºC'),
	(88474, 111, '2015-03-01 00:51:17.000000', 'temperatura', 1006.0000, 'ºC'),
	(88475, 111, '2015-03-01 00:51:18.000000', 'temperatura', 387.0000, 'ºC'),
	(88476, 111, '2015-03-01 00:51:19.000000', 'temperatura', 117.0000, 'ºC'),
	(88477, 111, '2015-03-01 00:51:20.000000', 'temperatura', 623.0000, 'ºC'),
	(88478, 111, '2015-03-01 00:51:21.000000', 'temperatura', 364.0000, 'ºC'),
	(88479, 111, '2015-03-01 00:51:22.000000', 'temperatura', 1152.0000, 'ºC'),
	(88480, 111, '2015-03-01 00:51:23.000000', 'temperatura', 1068.0000, 'ºC'),
	(88481, 111, '2015-03-01 00:51:24.000000', 'temperatura', 683.0000, 'ºC'),
	(88482, 111, '2015-03-01 00:51:25.000000', 'temperatura', 213.0000, 'ºC'),
	(88483, 111, '2015-03-01 00:51:26.000000', 'temperatura', 216.0000, 'ºC'),
	(88484, 111, '2015-03-01 00:51:27.000000', 'temperatura', 441.0000, 'ºC'),
	(88485, 111, '2015-03-01 00:51:28.000000', 'temperatura', 357.0000, 'ºC'),
	(88486, 111, '2015-03-01 00:51:29.000000', 'temperatura', 461.0000, 'ºC'),
	(88487, 111, '2015-03-01 00:51:30.000000', 'temperatura', 37.0000, 'ºC'),
	(88488, 111, '2015-03-01 00:51:31.000000', 'temperatura', 1.0000, 'ºC'),
	(88489, 111, '2015-03-01 00:51:32.000000', 'temperatura', 1094.0000, 'ºC'),
	(88490, 111, '2015-03-01 00:51:33.000000', 'temperatura', 668.0000, 'ºC'),
	(88491, 111, '2015-03-01 00:51:34.000000', 'temperatura', 60.0000, 'ºC'),
	(88492, 111, '2015-03-01 00:51:35.000000', 'temperatura', 694.0000, 'ºC'),
	(88493, 111, '2015-03-01 00:51:36.000000', 'temperatura', 891.0000, 'ºC'),
	(88494, 111, '2015-03-01 00:51:37.000000', 'temperatura', 1175.0000, 'ºC'),
	(88495, 111, '2015-03-01 00:51:38.000000', 'temperatura', 802.0000, 'ºC'),
	(88496, 111, '2015-03-01 00:51:39.000000', 'temperatura', 484.0000, 'ºC'),
	(88497, 111, '2015-03-01 00:51:40.000000', 'temperatura', 15.0000, 'ºC'),
	(88498, 111, '2015-03-01 00:51:41.000000', 'temperatura', 1022.0000, 'ºC'),
	(88499, 111, '2015-03-01 00:51:42.000000', 'temperatura', 268.0000, 'ºC'),
	(88500, 111, '2015-03-01 00:51:43.000000', 'temperatura', 672.0000, 'ºC'),
	(88501, 111, '2015-03-01 00:51:44.000000', 'temperatura', 159.0000, 'ºC'),
	(88502, 111, '2015-03-01 00:51:45.000000', 'temperatura', 1180.0000, 'ºC'),
	(88503, 111, '2015-03-01 00:51:46.000000', 'temperatura', 624.0000, 'ºC'),
	(88504, 111, '2015-03-01 00:51:47.000000', 'temperatura', 779.0000, 'ºC'),
	(88505, 111, '2015-03-01 00:51:48.000000', 'temperatura', 824.0000, 'ºC'),
	(88506, 111, '2015-03-01 00:51:49.000000', 'temperatura', 583.0000, 'ºC'),
	(88507, 111, '2015-03-01 00:51:50.000000', 'temperatura', 443.0000, 'ºC'),
	(88508, 111, '2015-03-01 00:51:51.000000', 'temperatura', 467.0000, 'ºC'),
	(88509, 111, '2015-03-01 00:51:52.000000', 'temperatura', 1005.0000, 'ºC'),
	(88510, 111, '2015-03-01 00:51:53.000000', 'temperatura', 26.0000, 'ºC'),
	(88511, 111, '2015-03-01 00:51:54.000000', 'temperatura', 716.0000, 'ºC'),
	(88512, 111, '2015-03-01 00:51:55.000000', 'temperatura', 1100.0000, 'ºC'),
	(88513, 111, '2015-03-01 00:51:56.000000', 'temperatura', 956.0000, 'ºC'),
	(88514, 111, '2015-03-01 00:51:57.000000', 'temperatura', 278.0000, 'ºC'),
	(88515, 111, '2015-03-01 00:51:58.000000', 'temperatura', 922.0000, 'ºC'),
	(88516, 111, '2015-03-01 00:51:59.000000', 'temperatura', 178.0000, 'ºC'),
	(88517, 111, '2015-03-01 00:52:00.000000', 'temperatura', 523.0000, 'ºC'),
	(88518, 111, '2015-03-01 00:52:01.000000', 'temperatura', 883.0000, 'ºC'),
	(88519, 111, '2015-03-01 00:52:02.000000', 'temperatura', 445.0000, 'ºC'),
	(88520, 111, '2015-03-01 00:52:03.000000', 'temperatura', 778.0000, 'ºC'),
	(88521, 111, '2015-03-01 00:52:04.000000', 'temperatura', 155.0000, 'ºC'),
	(88522, 111, '2015-03-01 00:52:05.000000', 'temperatura', 843.0000, 'ºC'),
	(88523, 111, '2015-03-01 00:52:06.000000', 'temperatura', 148.0000, 'ºC'),
	(88524, 111, '2015-03-01 00:52:07.000000', 'temperatura', 611.0000, 'ºC'),
	(88525, 111, '2015-03-01 00:52:08.000000', 'temperatura', 214.0000, 'ºC'),
	(88526, 111, '2015-03-01 00:52:09.000000', 'temperatura', 437.0000, 'ºC'),
	(88527, 111, '2015-03-01 00:52:10.000000', 'temperatura', 343.0000, 'ºC'),
	(88528, 111, '2015-03-01 00:52:11.000000', 'temperatura', 405.0000, 'ºC'),
	(88529, 111, '2015-03-01 00:52:12.000000', 'temperatura', 998.0000, 'ºC'),
	(88530, 111, '2015-03-01 00:52:13.000000', 'temperatura', 175.0000, 'ºC'),
	(88531, 111, '2015-03-01 00:52:14.000000', 'temperatura', 280.0000, 'ºC'),
	(88532, 111, '2015-03-01 00:52:15.000000', 'temperatura', 875.0000, 'ºC'),
	(88533, 111, '2015-03-01 00:52:16.000000', 'temperatura', 1135.0000, 'ºC'),
	(88534, 111, '2015-03-01 00:52:17.000000', 'temperatura', 652.0000, 'ºC'),
	(88535, 111, '2015-03-01 00:52:18.000000', 'temperatura', 1055.0000, 'ºC'),
	(88536, 111, '2015-03-01 00:52:19.000000', 'temperatura', 918.0000, 'ºC'),
	(88537, 111, '2015-03-01 00:52:20.000000', 'temperatura', 227.0000, 'ºC'),
	(88538, 111, '2015-03-01 00:52:21.000000', 'temperatura', 783.0000, 'ºC'),
	(88539, 111, '2015-03-01 00:52:22.000000', 'temperatura', 833.0000, 'ºC'),
	(88540, 111, '2015-03-01 00:52:23.000000', 'temperatura', 616.0000, 'ºC'),
	(88541, 111, '2015-03-01 00:52:24.000000', 'temperatura', 583.0000, 'ºC'),
	(88542, 111, '2015-03-01 00:52:25.000000', 'temperatura', 1068.0000, 'ºC'),
	(88543, 111, '2015-03-01 00:52:26.000000', 'temperatura', 1191.0000, 'ºC'),
	(88544, 111, '2015-03-01 00:52:27.000000', 'temperatura', 351.0000, 'ºC'),
	(88545, 111, '2015-03-01 00:52:28.000000', 'temperatura', 584.0000, 'ºC'),
	(88546, 111, '2015-03-01 00:52:29.000000', 'temperatura', 665.0000, 'ºC'),
	(88547, 111, '2015-03-01 00:52:30.000000', 'temperatura', 375.0000, 'ºC'),
	(88548, 111, '2015-03-01 00:52:31.000000', 'temperatura', 1082.0000, 'ºC'),
	(88549, 111, '2015-03-01 00:52:32.000000', 'temperatura', 684.0000, 'ºC'),
	(88550, 111, '2015-03-01 00:52:33.000000', 'temperatura', 174.0000, 'ºC'),
	(88551, 111, '2015-03-01 00:52:34.000000', 'temperatura', 19.0000, 'ºC'),
	(88552, 111, '2015-03-01 00:52:35.000000', 'temperatura', 772.0000, 'ºC'),
	(88553, 111, '2015-03-01 00:52:36.000000', 'temperatura', 206.0000, 'ºC'),
	(88554, 111, '2015-03-01 00:52:37.000000', 'temperatura', 1115.0000, 'ºC'),
	(88555, 111, '2015-03-01 00:52:38.000000', 'temperatura', 157.0000, 'ºC'),
	(88556, 111, '2015-03-01 00:52:39.000000', 'temperatura', 1039.0000, 'ºC'),
	(88557, 111, '2015-03-01 00:52:40.000000', 'temperatura', 1126.0000, 'ºC'),
	(88558, 111, '2015-03-01 00:52:41.000000', 'temperatura', 115.0000, 'ºC'),
	(88559, 111, '2015-03-01 00:52:42.000000', 'temperatura', 796.0000, 'ºC'),
	(88560, 111, '2015-03-01 00:52:43.000000', 'temperatura', 37.0000, 'ºC'),
	(88561, 111, '2015-03-01 00:52:44.000000', 'temperatura', 195.0000, 'ºC'),
	(88562, 111, '2015-03-01 00:52:45.000000', 'temperatura', 865.0000, 'ºC'),
	(88563, 111, '2015-03-01 00:52:46.000000', 'temperatura', 140.0000, 'ºC'),
	(88564, 111, '2015-03-01 00:52:47.000000', 'temperatura', 504.0000, 'ºC'),
	(88565, 111, '2015-03-01 00:52:48.000000', 'temperatura', 903.0000, 'ºC'),
	(88566, 111, '2015-03-01 00:52:49.000000', 'temperatura', 601.0000, 'ºC'),
	(88567, 111, '2015-03-01 00:52:50.000000', 'temperatura', 298.0000, 'ºC'),
	(88568, 111, '2015-03-01 00:52:51.000000', 'temperatura', 886.0000, 'ºC'),
	(88569, 111, '2015-03-01 00:52:52.000000', 'temperatura', 1138.0000, 'ºC'),
	(88570, 111, '2015-03-01 00:52:53.000000', 'temperatura', 633.0000, 'ºC'),
	(88571, 111, '2015-03-01 00:52:54.000000', 'temperatura', 952.0000, 'ºC'),
	(88572, 111, '2015-03-01 00:52:55.000000', 'temperatura', 460.0000, 'ºC'),
	(88573, 111, '2015-03-01 00:52:56.000000', 'temperatura', 643.0000, 'ºC'),
	(88574, 111, '2015-03-01 00:52:57.000000', 'temperatura', 638.0000, 'ºC'),
	(88575, 111, '2015-03-01 00:52:58.000000', 'temperatura', 60.0000, 'ºC'),
	(88576, 111, '2015-03-01 00:52:59.000000', 'temperatura', 785.0000, 'ºC'),
	(88577, 111, '2015-03-01 00:53:00.000000', 'temperatura', 147.0000, 'ºC'),
	(88578, 111, '2015-03-01 00:53:01.000000', 'temperatura', 780.0000, 'ºC'),
	(88579, 111, '2015-03-01 00:53:02.000000', 'temperatura', 1061.0000, 'ºC'),
	(88580, 111, '2015-03-01 00:53:03.000000', 'temperatura', 566.0000, 'ºC'),
	(88581, 111, '2015-03-01 00:53:04.000000', 'temperatura', 848.0000, 'ºC'),
	(88582, 111, '2015-03-01 00:53:05.000000', 'temperatura', 143.0000, 'ºC'),
	(88583, 111, '2015-03-01 00:53:06.000000', 'temperatura', 572.0000, 'ºC'),
	(88584, 111, '2015-03-01 00:53:07.000000', 'temperatura', 33.0000, 'ºC'),
	(88585, 111, '2015-03-01 00:53:08.000000', 'temperatura', 846.0000, 'ºC'),
	(88586, 111, '2015-03-01 00:53:09.000000', 'temperatura', 531.0000, 'ºC'),
	(88587, 111, '2015-03-01 00:53:10.000000', 'temperatura', 120.0000, 'ºC'),
	(88588, 111, '2015-03-01 00:53:11.000000', 'temperatura', 209.0000, 'ºC'),
	(88589, 111, '2015-03-01 00:53:12.000000', 'temperatura', 682.0000, 'ºC'),
	(88590, 111, '2015-03-01 00:53:13.000000', 'temperatura', 384.0000, 'ºC'),
	(88591, 111, '2015-03-01 00:53:14.000000', 'temperatura', 1074.0000, 'ºC'),
	(88592, 111, '2015-03-01 00:53:15.000000', 'temperatura', 620.0000, 'ºC'),
	(88593, 111, '2015-03-01 00:53:16.000000', 'temperatura', 1079.0000, 'ºC'),
	(88594, 111, '2015-03-01 00:53:17.000000', 'temperatura', 1133.0000, 'ºC'),
	(88595, 111, '2015-03-01 00:53:18.000000', 'temperatura', 30.0000, 'ºC'),
	(88596, 111, '2015-03-01 00:53:19.000000', 'temperatura', 352.0000, 'ºC'),
	(88597, 111, '2015-03-01 00:53:20.000000', 'temperatura', 468.0000, 'ºC'),
	(88598, 111, '2015-03-01 00:53:21.000000', 'temperatura', 87.0000, 'ºC'),
	(88599, 111, '2015-03-01 00:53:22.000000', 'temperatura', 232.0000, 'ºC'),
	(88600, 111, '2015-03-01 00:53:23.000000', 'temperatura', 900.0000, 'ºC'),
	(88601, 111, '2015-03-01 00:53:24.000000', 'temperatura', 202.0000, 'ºC'),
	(88602, 111, '2015-03-01 00:53:25.000000', 'temperatura', 712.0000, 'ºC'),
	(88603, 111, '2015-03-01 00:53:26.000000', 'temperatura', 554.0000, 'ºC'),
	(88604, 111, '2015-03-01 00:53:27.000000', 'temperatura', 633.0000, 'ºC'),
	(88605, 111, '2015-03-01 00:53:28.000000', 'temperatura', 306.0000, 'ºC'),
	(88606, 111, '2015-03-01 00:53:29.000000', 'temperatura', 829.0000, 'ºC'),
	(88607, 111, '2015-03-01 00:53:30.000000', 'temperatura', 830.0000, 'ºC'),
	(88608, 111, '2015-03-01 00:53:31.000000', 'temperatura', 463.0000, 'ºC'),
	(88609, 111, '2015-03-01 00:53:32.000000', 'temperatura', 1027.0000, 'ºC'),
	(88610, 111, '2015-03-01 00:53:33.000000', 'temperatura', 145.0000, 'ºC'),
	(88611, 111, '2015-03-01 00:53:34.000000', 'temperatura', 43.0000, 'ºC'),
	(88612, 111, '2015-03-01 00:53:35.000000', 'temperatura', 982.0000, 'ºC'),
	(88613, 111, '2015-03-01 00:53:36.000000', 'temperatura', 1179.0000, 'ºC'),
	(88614, 111, '2015-03-01 00:53:37.000000', 'temperatura', 552.0000, 'ºC'),
	(88615, 111, '2015-03-01 00:53:38.000000', 'temperatura', 422.0000, 'ºC'),
	(88616, 111, '2015-03-01 00:53:39.000000', 'temperatura', 455.0000, 'ºC'),
	(88617, 111, '2015-03-01 00:53:40.000000', 'temperatura', 1009.0000, 'ºC'),
	(88618, 111, '2015-03-01 00:53:41.000000', 'temperatura', 80.0000, 'ºC'),
	(88619, 111, '2015-03-01 00:53:42.000000', 'temperatura', 975.0000, 'ºC'),
	(88620, 111, '2015-03-01 00:53:43.000000', 'temperatura', 1035.0000, 'ºC'),
	(88621, 111, '2015-03-01 00:53:44.000000', 'temperatura', 1051.0000, 'ºC'),
	(88622, 111, '2015-03-01 00:53:45.000000', 'temperatura', 952.0000, 'ºC'),
	(88623, 111, '2015-03-01 00:53:46.000000', 'temperatura', 407.0000, 'ºC'),
	(88624, 111, '2015-03-01 00:53:47.000000', 'temperatura', 378.0000, 'ºC'),
	(88625, 111, '2015-03-01 00:53:48.000000', 'temperatura', 670.0000, 'ºC'),
	(88626, 111, '2015-03-01 00:53:49.000000', 'temperatura', 1015.0000, 'ºC'),
	(88627, 111, '2015-03-01 00:53:50.000000', 'temperatura', 667.0000, 'ºC'),
	(88628, 111, '2015-03-01 00:53:51.000000', 'temperatura', 290.0000, 'ºC'),
	(88629, 111, '2015-03-01 00:53:52.000000', 'temperatura', 651.0000, 'ºC'),
	(88630, 111, '2015-03-01 00:53:53.000000', 'temperatura', 1182.0000, 'ºC'),
	(88631, 111, '2015-03-01 00:53:54.000000', 'temperatura', 361.0000, 'ºC'),
	(88632, 111, '2015-03-01 00:53:55.000000', 'temperatura', 660.0000, 'ºC'),
	(88633, 111, '2015-03-01 00:53:56.000000', 'temperatura', 1016.0000, 'ºC'),
	(88634, 111, '2015-03-01 00:53:57.000000', 'temperatura', 699.0000, 'ºC'),
	(88635, 111, '2015-03-01 00:53:58.000000', 'temperatura', 448.0000, 'ºC'),
	(88636, 111, '2015-03-01 00:53:59.000000', 'temperatura', 144.0000, 'ºC'),
	(88637, 111, '2015-03-01 00:54:00.000000', 'temperatura', 578.0000, 'ºC'),
	(88638, 111, '2015-03-01 00:54:01.000000', 'temperatura', 57.0000, 'ºC'),
	(88639, 111, '2015-03-01 00:54:02.000000', 'temperatura', 951.0000, 'ºC'),
	(88640, 111, '2015-03-01 00:54:03.000000', 'temperatura', 986.0000, 'ºC'),
	(88641, 111, '2015-03-01 00:54:04.000000', 'temperatura', 877.0000, 'ºC'),
	(88642, 111, '2015-03-01 00:54:05.000000', 'temperatura', 228.0000, 'ºC'),
	(88643, 111, '2015-03-01 00:54:06.000000', 'temperatura', 910.0000, 'ºC'),
	(88644, 111, '2015-03-01 00:54:07.000000', 'temperatura', 265.0000, 'ºC'),
	(88645, 111, '2015-03-01 00:54:08.000000', 'temperatura', 995.0000, 'ºC'),
	(88646, 111, '2015-03-01 00:54:09.000000', 'temperatura', 582.0000, 'ºC'),
	(88647, 111, '2015-03-01 00:54:10.000000', 'temperatura', 1127.0000, 'ºC'),
	(88648, 111, '2015-03-01 00:54:11.000000', 'temperatura', 287.0000, 'ºC'),
	(88649, 111, '2015-03-01 00:54:12.000000', 'temperatura', 455.0000, 'ºC'),
	(88650, 111, '2015-03-01 00:54:13.000000', 'temperatura', 216.0000, 'ºC'),
	(88651, 111, '2015-03-01 00:54:14.000000', 'temperatura', 915.0000, 'ºC'),
	(88652, 111, '2015-03-01 00:54:15.000000', 'temperatura', 326.0000, 'ºC'),
	(88653, 111, '2015-03-01 00:54:16.000000', 'temperatura', 85.0000, 'ºC'),
	(88654, 111, '2015-03-01 00:54:17.000000', 'temperatura', 650.0000, 'ºC'),
	(88655, 111, '2015-03-01 00:54:18.000000', 'temperatura', 592.0000, 'ºC'),
	(88656, 111, '2015-03-01 00:54:19.000000', 'temperatura', 1014.0000, 'ºC'),
	(88657, 111, '2015-03-01 00:54:20.000000', 'temperatura', 894.0000, 'ºC'),
	(88658, 111, '2015-03-01 00:54:21.000000', 'temperatura', 227.0000, 'ºC'),
	(88659, 111, '2015-03-01 00:54:22.000000', 'temperatura', 855.0000, 'ºC'),
	(88660, 111, '2015-03-01 00:54:23.000000', 'temperatura', 1194.0000, 'ºC'),
	(88661, 111, '2015-03-01 00:54:24.000000', 'temperatura', 1004.0000, 'ºC'),
	(88662, 111, '2015-03-01 00:54:25.000000', 'temperatura', 240.0000, 'ºC'),
	(88663, 111, '2015-03-01 00:54:26.000000', 'temperatura', 586.0000, 'ºC'),
	(88664, 111, '2015-03-01 00:54:27.000000', 'temperatura', 1013.0000, 'ºC'),
	(88665, 111, '2015-03-01 00:54:28.000000', 'temperatura', 908.0000, 'ºC'),
	(88666, 111, '2015-03-01 00:54:29.000000', 'temperatura', 300.0000, 'ºC'),
	(88667, 111, '2015-03-01 00:54:30.000000', 'temperatura', 1177.0000, 'ºC'),
	(88668, 111, '2015-03-01 00:54:31.000000', 'temperatura', 186.0000, 'ºC'),
	(88669, 111, '2015-03-01 00:54:32.000000', 'temperatura', 999.0000, 'ºC'),
	(88670, 111, '2015-03-01 00:54:33.000000', 'temperatura', 836.0000, 'ºC'),
	(88671, 111, '2015-03-01 00:54:34.000000', 'temperatura', 1183.0000, 'ºC'),
	(88672, 111, '2015-03-01 00:54:35.000000', 'temperatura', 1007.0000, 'ºC'),
	(88673, 111, '2015-03-01 00:54:36.000000', 'temperatura', 286.0000, 'ºC'),
	(88674, 111, '2015-03-01 00:54:37.000000', 'temperatura', 812.0000, 'ºC'),
	(88675, 111, '2015-03-01 00:54:38.000000', 'temperatura', 803.0000, 'ºC'),
	(88676, 111, '2015-03-01 00:54:39.000000', 'temperatura', 380.0000, 'ºC'),
	(88677, 111, '2015-03-01 00:54:40.000000', 'temperatura', 689.0000, 'ºC'),
	(88678, 111, '2015-03-01 00:54:41.000000', 'temperatura', 1106.0000, 'ºC'),
	(88679, 111, '2015-03-01 00:54:42.000000', 'temperatura', 1063.0000, 'ºC'),
	(88680, 111, '2015-03-01 00:54:43.000000', 'temperatura', 798.0000, 'ºC'),
	(88681, 111, '2015-03-01 00:54:44.000000', 'temperatura', 802.0000, 'ºC'),
	(88682, 111, '2015-03-01 00:54:45.000000', 'temperatura', 417.0000, 'ºC'),
	(88683, 111, '2015-03-01 00:54:46.000000', 'temperatura', 881.0000, 'ºC'),
	(88684, 111, '2015-03-01 00:54:47.000000', 'temperatura', 753.0000, 'ºC'),
	(88685, 111, '2015-03-01 00:54:48.000000', 'temperatura', 1121.0000, 'ºC'),
	(88686, 111, '2015-03-01 00:54:49.000000', 'temperatura', 949.0000, 'ºC'),
	(88687, 111, '2015-03-01 00:54:50.000000', 'temperatura', 183.0000, 'ºC'),
	(88688, 111, '2015-03-01 00:54:51.000000', 'temperatura', 466.0000, 'ºC'),
	(88689, 111, '2015-03-01 00:54:52.000000', 'temperatura', 582.0000, 'ºC'),
	(88690, 111, '2015-03-01 00:54:53.000000', 'temperatura', 313.0000, 'ºC'),
	(88691, 111, '2015-03-01 00:54:54.000000', 'temperatura', 1021.0000, 'ºC'),
	(88692, 111, '2015-03-01 00:54:55.000000', 'temperatura', 567.0000, 'ºC'),
	(88693, 111, '2015-03-01 00:54:56.000000', 'temperatura', 971.0000, 'ºC'),
	(88694, 111, '2015-03-01 00:54:57.000000', 'temperatura', 755.0000, 'ºC'),
	(88695, 111, '2015-03-01 00:54:58.000000', 'temperatura', 862.0000, 'ºC'),
	(88696, 111, '2015-03-01 00:54:59.000000', 'temperatura', 846.0000, 'ºC'),
	(88697, 111, '2015-03-01 00:55:00.000000', 'temperatura', 443.0000, 'ºC'),
	(88698, 111, '2015-03-01 00:55:01.000000', 'temperatura', 877.0000, 'ºC'),
	(88699, 111, '2015-03-01 00:55:02.000000', 'temperatura', 656.0000, 'ºC'),
	(88700, 111, '2015-03-01 00:55:03.000000', 'temperatura', 650.0000, 'ºC'),
	(88701, 111, '2015-03-01 00:55:04.000000', 'temperatura', 84.0000, 'ºC'),
	(88702, 111, '2015-03-01 00:55:05.000000', 'temperatura', 872.0000, 'ºC'),
	(88703, 111, '2015-03-01 00:55:06.000000', 'temperatura', 505.0000, 'ºC'),
	(88704, 111, '2015-03-01 00:55:07.000000', 'temperatura', 1111.0000, 'ºC'),
	(88705, 111, '2015-03-01 00:55:08.000000', 'temperatura', 442.0000, 'ºC'),
	(88706, 111, '2015-03-01 00:55:09.000000', 'temperatura', 74.0000, 'ºC'),
	(88707, 111, '2015-03-01 00:55:10.000000', 'temperatura', 248.0000, 'ºC'),
	(88708, 111, '2015-03-01 00:55:11.000000', 'temperatura', 1018.0000, 'ºC'),
	(88709, 111, '2015-03-01 00:55:12.000000', 'temperatura', 745.0000, 'ºC'),
	(88710, 111, '2015-03-01 00:55:13.000000', 'temperatura', 673.0000, 'ºC'),
	(88711, 111, '2015-03-01 00:55:14.000000', 'temperatura', 1129.0000, 'ºC'),
	(88712, 111, '2015-03-01 00:55:15.000000', 'temperatura', 28.0000, 'ºC'),
	(88713, 111, '2015-03-01 00:55:16.000000', 'temperatura', 354.0000, 'ºC'),
	(88714, 111, '2015-03-01 00:55:17.000000', 'temperatura', 485.0000, 'ºC'),
	(88715, 111, '2015-03-01 00:55:18.000000', 'temperatura', 165.0000, 'ºC'),
	(88716, 111, '2015-03-01 00:55:19.000000', 'temperatura', 568.0000, 'ºC'),
	(88717, 111, '2015-03-01 00:55:20.000000', 'temperatura', 1146.0000, 'ºC'),
	(88718, 111, '2015-03-01 00:55:21.000000', 'temperatura', 427.0000, 'ºC'),
	(88719, 111, '2015-03-01 00:55:22.000000', 'temperatura', 1100.0000, 'ºC'),
	(88720, 111, '2015-03-01 00:55:23.000000', 'temperatura', 616.0000, 'ºC'),
	(88721, 111, '2015-03-01 00:55:24.000000', 'temperatura', 981.0000, 'ºC'),
	(88722, 111, '2015-03-01 00:55:25.000000', 'temperatura', 659.0000, 'ºC'),
	(88723, 111, '2015-03-01 00:55:26.000000', 'temperatura', 354.0000, 'ºC'),
	(88724, 111, '2015-03-01 00:55:27.000000', 'temperatura', 991.0000, 'ºC'),
	(88725, 111, '2015-03-01 00:55:28.000000', 'temperatura', 295.0000, 'ºC'),
	(88726, 111, '2015-03-01 00:55:29.000000', 'temperatura', 902.0000, 'ºC'),
	(88727, 111, '2015-03-01 00:55:30.000000', 'temperatura', 26.0000, 'ºC'),
	(88728, 111, '2015-03-01 00:55:31.000000', 'temperatura', 1026.0000, 'ºC'),
	(88729, 111, '2015-03-01 00:55:32.000000', 'temperatura', 251.0000, 'ºC'),
	(88730, 111, '2015-03-01 00:55:33.000000', 'temperatura', 578.0000, 'ºC'),
	(88731, 111, '2015-03-01 00:55:34.000000', 'temperatura', 939.0000, 'ºC'),
	(88732, 111, '2015-03-01 00:55:35.000000', 'temperatura', 561.0000, 'ºC'),
	(88733, 111, '2015-03-01 00:55:36.000000', 'temperatura', 1189.0000, 'ºC'),
	(88734, 111, '2015-03-01 00:55:37.000000', 'temperatura', 660.0000, 'ºC'),
	(88735, 111, '2015-03-01 00:55:38.000000', 'temperatura', 934.0000, 'ºC'),
	(88736, 111, '2015-03-01 00:55:39.000000', 'temperatura', 291.0000, 'ºC'),
	(88737, 111, '2015-03-01 00:55:40.000000', 'temperatura', 1054.0000, 'ºC'),
	(88738, 111, '2015-03-01 00:55:41.000000', 'temperatura', 796.0000, 'ºC'),
	(88739, 111, '2015-03-01 00:55:42.000000', 'temperatura', 818.0000, 'ºC'),
	(88740, 111, '2015-03-01 00:55:43.000000', 'temperatura', 504.0000, 'ºC'),
	(88741, 111, '2015-03-01 00:55:44.000000', 'temperatura', 66.0000, 'ºC'),
	(88742, 111, '2015-03-01 00:55:45.000000', 'temperatura', 19.0000, 'ºC'),
	(88743, 111, '2015-03-01 00:55:46.000000', 'temperatura', 1098.0000, 'ºC'),
	(88744, 111, '2015-03-01 00:55:47.000000', 'temperatura', 635.0000, 'ºC'),
	(88745, 111, '2015-03-01 00:55:48.000000', 'temperatura', 1080.0000, 'ºC'),
	(88746, 111, '2015-03-01 00:55:49.000000', 'temperatura', 1097.0000, 'ºC'),
	(88747, 111, '2015-03-01 00:55:50.000000', 'temperatura', 1044.0000, 'ºC'),
	(88748, 111, '2015-03-01 00:55:51.000000', 'temperatura', 728.0000, 'ºC'),
	(88749, 111, '2015-03-01 00:55:52.000000', 'temperatura', 509.0000, 'ºC'),
	(88750, 111, '2015-03-01 00:55:53.000000', 'temperatura', 361.0000, 'ºC'),
	(88751, 111, '2015-03-01 00:55:54.000000', 'temperatura', 277.0000, 'ºC'),
	(88752, 111, '2015-03-01 00:55:55.000000', 'temperatura', 306.0000, 'ºC'),
	(88753, 111, '2015-03-01 00:55:56.000000', 'temperatura', 697.0000, 'ºC'),
	(88754, 111, '2015-03-01 00:55:57.000000', 'temperatura', 166.0000, 'ºC'),
	(88755, 111, '2015-03-01 00:55:58.000000', 'temperatura', 1142.0000, 'ºC'),
	(88756, 111, '2015-03-01 00:55:59.000000', 'temperatura', 411.0000, 'ºC'),
	(88757, 111, '2015-03-01 00:56:00.000000', 'temperatura', 1029.0000, 'ºC'),
	(88758, 111, '2015-03-01 00:56:01.000000', 'temperatura', 313.0000, 'ºC'),
	(88759, 111, '2015-03-01 00:56:02.000000', 'temperatura', 879.0000, 'ºC'),
	(88760, 111, '2015-03-01 00:56:03.000000', 'temperatura', 1056.0000, 'ºC'),
	(88761, 111, '2015-03-01 00:56:04.000000', 'temperatura', 245.0000, 'ºC'),
	(88762, 111, '2015-03-01 00:56:05.000000', 'temperatura', 456.0000, 'ºC'),
	(88763, 111, '2015-03-01 00:56:06.000000', 'temperatura', 345.0000, 'ºC'),
	(88764, 111, '2015-03-01 00:56:07.000000', 'temperatura', 360.0000, 'ºC'),
	(88765, 111, '2015-03-01 00:56:08.000000', 'temperatura', 763.0000, 'ºC'),
	(88766, 111, '2015-03-01 00:56:09.000000', 'temperatura', 336.0000, 'ºC'),
	(88767, 111, '2015-03-01 00:56:10.000000', 'temperatura', 593.0000, 'ºC'),
	(88768, 111, '2015-03-01 00:56:11.000000', 'temperatura', 757.0000, 'ºC'),
	(88769, 111, '2015-03-01 00:56:12.000000', 'temperatura', 806.0000, 'ºC'),
	(88770, 111, '2015-03-01 00:56:13.000000', 'temperatura', 558.0000, 'ºC'),
	(88771, 111, '2015-03-01 00:56:14.000000', 'temperatura', 373.0000, 'ºC'),
	(88772, 111, '2015-03-01 00:56:15.000000', 'temperatura', 191.0000, 'ºC'),
	(88773, 111, '2015-03-01 00:56:16.000000', 'temperatura', 1036.0000, 'ºC'),
	(88774, 111, '2015-03-01 00:56:17.000000', 'temperatura', 1006.0000, 'ºC'),
	(88775, 111, '2015-03-01 00:56:18.000000', 'temperatura', 725.0000, 'ºC'),
	(88776, 111, '2015-03-01 00:56:19.000000', 'temperatura', 608.0000, 'ºC'),
	(88777, 111, '2015-03-01 00:56:20.000000', 'temperatura', 865.0000, 'ºC'),
	(88778, 111, '2015-03-01 00:56:21.000000', 'temperatura', 102.0000, 'ºC'),
	(88779, 111, '2015-03-01 00:56:22.000000', 'temperatura', 315.0000, 'ºC'),
	(88780, 111, '2015-03-01 00:56:23.000000', 'temperatura', 69.0000, 'ºC'),
	(88781, 111, '2015-03-01 00:56:24.000000', 'temperatura', 599.0000, 'ºC'),
	(88782, 111, '2015-03-01 00:56:25.000000', 'temperatura', 389.0000, 'ºC'),
	(88783, 111, '2015-03-01 00:56:26.000000', 'temperatura', 147.0000, 'ºC'),
	(88784, 111, '2015-03-01 00:56:27.000000', 'temperatura', 770.0000, 'ºC'),
	(88785, 111, '2015-03-01 00:56:28.000000', 'temperatura', 1011.0000, 'ºC'),
	(88786, 111, '2015-03-01 00:56:29.000000', 'temperatura', 343.0000, 'ºC'),
	(88787, 111, '2015-03-01 00:56:30.000000', 'temperatura', 1082.0000, 'ºC'),
	(88788, 111, '2015-03-01 00:56:31.000000', 'temperatura', 783.0000, 'ºC'),
	(88789, 111, '2015-03-01 00:56:32.000000', 'temperatura', 667.0000, 'ºC'),
	(88790, 111, '2015-03-01 00:56:33.000000', 'temperatura', 989.0000, 'ºC'),
	(88791, 111, '2015-03-01 00:56:34.000000', 'temperatura', 545.0000, 'ºC'),
	(88792, 111, '2015-03-01 00:56:35.000000', 'temperatura', 958.0000, 'ºC'),
	(88793, 111, '2015-03-01 00:56:36.000000', 'temperatura', 757.0000, 'ºC'),
	(88794, 111, '2015-03-01 00:56:37.000000', 'temperatura', 910.0000, 'ºC'),
	(88795, 111, '2015-03-01 00:56:38.000000', 'temperatura', 1078.0000, 'ºC'),
	(88796, 111, '2015-03-01 00:56:39.000000', 'temperatura', 263.0000, 'ºC'),
	(88797, 111, '2015-03-01 00:56:40.000000', 'temperatura', 480.0000, 'ºC'),
	(88798, 111, '2015-03-01 00:56:41.000000', 'temperatura', 412.0000, 'ºC'),
	(88799, 111, '2015-03-01 00:56:42.000000', 'temperatura', 622.0000, 'ºC'),
	(88800, 111, '2015-03-01 00:56:43.000000', 'temperatura', 674.0000, 'ºC'),
	(88801, 111, '2015-03-01 00:56:44.000000', 'temperatura', 304.0000, 'ºC'),
	(88802, 111, '2015-03-01 00:56:45.000000', 'temperatura', 698.0000, 'ºC'),
	(88803, 111, '2015-03-01 00:56:46.000000', 'temperatura', 181.0000, 'ºC'),
	(88804, 111, '2015-03-01 00:56:47.000000', 'temperatura', 10.0000, 'ºC'),
	(88805, 111, '2015-03-01 00:56:48.000000', 'temperatura', 708.0000, 'ºC'),
	(88806, 111, '2015-03-01 00:56:49.000000', 'temperatura', 1111.0000, 'ºC'),
	(88807, 111, '2015-03-01 00:56:50.000000', 'temperatura', 1033.0000, 'ºC'),
	(88808, 111, '2015-03-01 00:56:51.000000', 'temperatura', 630.0000, 'ºC'),
	(88809, 111, '2015-03-01 00:56:52.000000', 'temperatura', 51.0000, 'ºC'),
	(88810, 111, '2015-03-01 00:56:53.000000', 'temperatura', 768.0000, 'ºC'),
	(88811, 111, '2015-03-01 00:56:54.000000', 'temperatura', 86.0000, 'ºC'),
	(88812, 111, '2015-03-01 00:56:55.000000', 'temperatura', 526.0000, 'ºC'),
	(88813, 111, '2015-03-01 00:56:56.000000', 'temperatura', 1174.0000, 'ºC'),
	(88814, 111, '2015-03-01 00:56:57.000000', 'temperatura', 693.0000, 'ºC'),
	(88815, 111, '2015-03-01 00:56:58.000000', 'temperatura', 1144.0000, 'ºC'),
	(88816, 111, '2015-03-01 00:56:59.000000', 'temperatura', 39.0000, 'ºC'),
	(88817, 111, '2015-03-01 00:57:00.000000', 'temperatura', 365.0000, 'ºC'),
	(88818, 111, '2015-03-01 00:57:01.000000', 'temperatura', 509.0000, 'ºC'),
	(88819, 111, '2015-03-01 00:57:02.000000', 'temperatura', 252.0000, 'ºC'),
	(88820, 111, '2015-03-01 00:57:03.000000', 'temperatura', 931.0000, 'ºC'),
	(88821, 111, '2015-03-01 00:57:04.000000', 'temperatura', 300.0000, 'ºC'),
	(88822, 111, '2015-03-01 00:57:05.000000', 'temperatura', 1108.0000, 'ºC'),
	(88823, 111, '2015-03-01 00:57:06.000000', 'temperatura', 1039.0000, 'ºC'),
	(88824, 111, '2015-03-01 00:57:07.000000', 'temperatura', 674.0000, 'ºC'),
	(88825, 111, '2015-03-01 00:57:08.000000', 'temperatura', 254.0000, 'ºC'),
	(88826, 111, '2015-03-01 00:57:09.000000', 'temperatura', 449.0000, 'ºC'),
	(88827, 111, '2015-03-01 00:57:10.000000', 'temperatura', 284.0000, 'ºC'),
	(88828, 111, '2015-03-01 00:57:11.000000', 'temperatura', 71.0000, 'ºC'),
	(88829, 111, '2015-03-01 00:57:12.000000', 'temperatura', 705.0000, 'ºC'),
	(88830, 111, '2015-03-01 00:57:13.000000', 'temperatura', 913.0000, 'ºC'),
	(88831, 111, '2015-03-01 00:57:14.000000', 'temperatura', 48.0000, 'ºC'),
	(88832, 111, '2015-03-01 00:57:15.000000', 'temperatura', 1103.0000, 'ºC'),
	(88833, 111, '2015-03-01 00:57:16.000000', 'temperatura', 571.0000, 'ºC'),
	(88834, 111, '2015-03-01 00:57:17.000000', 'temperatura', 746.0000, 'ºC'),
	(88835, 111, '2015-03-01 00:57:18.000000', 'temperatura', 817.0000, 'ºC'),
	(88836, 111, '2015-03-01 00:57:19.000000', 'temperatura', 648.0000, 'ºC'),
	(88837, 111, '2015-03-01 00:57:20.000000', 'temperatura', 789.0000, 'ºC'),
	(88838, 111, '2015-03-01 00:57:21.000000', 'temperatura', 802.0000, 'ºC'),
	(88839, 111, '2015-03-01 00:57:22.000000', 'temperatura', 442.0000, 'ºC'),
	(88840, 111, '2015-03-01 00:57:23.000000', 'temperatura', 1006.0000, 'ºC'),
	(88841, 111, '2015-03-01 00:57:24.000000', 'temperatura', 105.0000, 'ºC'),
	(88842, 111, '2015-03-01 00:57:25.000000', 'temperatura', 1106.0000, 'ºC'),
	(88843, 111, '2015-03-01 00:57:26.000000', 'temperatura', 415.0000, 'ºC'),
	(88844, 111, '2015-03-01 00:57:27.000000', 'temperatura', 1158.0000, 'ºC'),
	(88845, 111, '2015-03-01 00:57:28.000000', 'temperatura', 944.0000, 'ºC'),
	(88846, 111, '2015-03-01 00:57:29.000000', 'temperatura', 49.0000, 'ºC'),
	(88847, 111, '2015-03-01 00:57:30.000000', 'temperatura', 1014.0000, 'ºC'),
	(88848, 111, '2015-03-01 00:57:31.000000', 'temperatura', 121.0000, 'ºC'),
	(88849, 111, '2015-03-01 00:57:32.000000', 'temperatura', 1164.0000, 'ºC'),
	(88850, 111, '2015-03-01 00:57:33.000000', 'temperatura', 659.0000, 'ºC'),
	(88851, 111, '2015-03-01 00:57:34.000000', 'temperatura', 1004.0000, 'ºC'),
	(88852, 111, '2015-03-01 00:57:35.000000', 'temperatura', 641.0000, 'ºC'),
	(88853, 111, '2015-03-01 00:57:36.000000', 'temperatura', 195.0000, 'ºC'),
	(88854, 111, '2015-03-01 00:57:37.000000', 'temperatura', 252.0000, 'ºC'),
	(88855, 111, '2015-03-01 00:57:38.000000', 'temperatura', 678.0000, 'ºC'),
	(88856, 111, '2015-03-01 00:57:39.000000', 'temperatura', 232.0000, 'ºC'),
	(88857, 111, '2015-03-01 00:57:40.000000', 'temperatura', 325.0000, 'ºC'),
	(88858, 111, '2015-03-01 00:57:41.000000', 'temperatura', 932.0000, 'ºC'),
	(88859, 111, '2015-03-01 00:57:42.000000', 'temperatura', 83.0000, 'ºC'),
	(88860, 111, '2015-03-01 00:57:43.000000', 'temperatura', 22.0000, 'ºC'),
	(88861, 111, '2015-03-01 00:57:44.000000', 'temperatura', 1059.0000, 'ºC'),
	(88862, 111, '2015-03-01 00:57:45.000000', 'temperatura', 429.0000, 'ºC'),
	(88863, 111, '2015-03-01 00:57:46.000000', 'temperatura', 169.0000, 'ºC'),
	(88864, 111, '2015-03-01 00:57:47.000000', 'temperatura', 758.0000, 'ºC'),
	(88865, 111, '2015-03-01 00:57:48.000000', 'temperatura', 883.0000, 'ºC'),
	(88866, 111, '2015-03-01 00:57:49.000000', 'temperatura', 943.0000, 'ºC'),
	(88867, 111, '2015-03-01 00:57:50.000000', 'temperatura', 868.0000, 'ºC'),
	(88868, 111, '2015-03-01 00:57:51.000000', 'temperatura', 311.0000, 'ºC'),
	(88869, 111, '2015-03-01 00:57:52.000000', 'temperatura', 150.0000, 'ºC'),
	(88870, 111, '2015-03-01 00:57:53.000000', 'temperatura', 1019.0000, 'ºC'),
	(88871, 111, '2015-03-01 00:57:54.000000', 'temperatura', 1044.0000, 'ºC'),
	(88872, 111, '2015-03-01 00:57:55.000000', 'temperatura', 963.0000, 'ºC'),
	(88873, 111, '2015-03-01 00:57:56.000000', 'temperatura', 486.0000, 'ºC'),
	(88874, 111, '2015-03-01 00:57:57.000000', 'temperatura', 741.0000, 'ºC'),
	(88875, 111, '2015-03-01 00:57:58.000000', 'temperatura', 1049.0000, 'ºC'),
	(88876, 111, '2015-03-01 00:57:59.000000', 'temperatura', 619.0000, 'ºC'),
	(88877, 111, '2015-03-01 00:58:00.000000', 'temperatura', 1151.0000, 'ºC'),
	(88878, 111, '2015-03-01 00:58:01.000000', 'temperatura', 297.0000, 'ºC'),
	(88879, 111, '2015-03-01 00:58:02.000000', 'temperatura', 432.0000, 'ºC'),
	(88880, 111, '2015-03-01 00:58:03.000000', 'temperatura', 71.0000, 'ºC'),
	(88881, 111, '2015-03-01 00:58:04.000000', 'temperatura', 259.0000, 'ºC'),
	(88882, 111, '2015-03-01 00:58:05.000000', 'temperatura', 1083.0000, 'ºC'),
	(88883, 111, '2015-03-01 00:58:06.000000', 'temperatura', 1036.0000, 'ºC'),
	(88884, 111, '2015-03-01 00:58:07.000000', 'temperatura', 733.0000, 'ºC'),
	(88885, 111, '2015-03-01 00:58:08.000000', 'temperatura', 558.0000, 'ºC'),
	(88886, 111, '2015-03-01 00:58:09.000000', 'temperatura', 589.0000, 'ºC'),
	(88887, 111, '2015-03-01 00:58:10.000000', 'temperatura', 74.0000, 'ºC'),
	(88888, 111, '2015-03-01 00:58:11.000000', 'temperatura', 1004.0000, 'ºC'),
	(88889, 111, '2015-03-01 00:58:12.000000', 'temperatura', 1199.0000, 'ºC'),
	(88890, 111, '2015-03-01 00:58:13.000000', 'temperatura', 583.0000, 'ºC'),
	(88891, 111, '2015-03-01 00:58:14.000000', 'temperatura', 518.0000, 'ºC'),
	(88892, 111, '2015-03-01 00:58:15.000000', 'temperatura', 840.0000, 'ºC'),
	(88893, 111, '2015-03-01 00:58:16.000000', 'temperatura', 247.0000, 'ºC'),
	(88894, 111, '2015-03-01 00:58:17.000000', 'temperatura', 1116.0000, 'ºC'),
	(88895, 111, '2015-03-01 00:58:18.000000', 'temperatura', 42.0000, 'ºC'),
	(88896, 111, '2015-03-01 00:58:19.000000', 'temperatura', 459.0000, 'ºC'),
	(88897, 111, '2015-03-01 00:58:20.000000', 'temperatura', 970.0000, 'ºC'),
	(88898, 111, '2015-03-01 00:58:21.000000', 'temperatura', 1075.0000, 'ºC'),
	(88899, 111, '2015-03-01 00:58:22.000000', 'temperatura', 63.0000, 'ºC'),
	(88900, 111, '2015-03-01 00:58:23.000000', 'temperatura', 693.0000, 'ºC'),
	(88901, 111, '2015-03-01 00:58:24.000000', 'temperatura', 876.0000, 'ºC'),
	(88902, 111, '2015-03-01 00:58:25.000000', 'temperatura', 1100.0000, 'ºC'),
	(88903, 111, '2015-03-01 00:58:26.000000', 'temperatura', 472.0000, 'ºC'),
	(88904, 111, '2015-03-01 00:58:27.000000', 'temperatura', 262.0000, 'ºC'),
	(88905, 111, '2015-03-01 00:58:28.000000', 'temperatura', 1092.0000, 'ºC'),
	(88906, 111, '2015-03-01 00:58:29.000000', 'temperatura', 1076.0000, 'ºC'),
	(88907, 111, '2015-03-01 00:58:30.000000', 'temperatura', 904.0000, 'ºC'),
	(88908, 111, '2015-03-01 00:58:31.000000', 'temperatura', 95.0000, 'ºC'),
	(88909, 111, '2015-03-01 00:58:32.000000', 'temperatura', 162.0000, 'ºC'),
	(88910, 111, '2015-03-01 00:58:33.000000', 'temperatura', 524.0000, 'ºC'),
	(88911, 111, '2015-03-01 00:58:34.000000', 'temperatura', 936.0000, 'ºC'),
	(88912, 111, '2015-03-01 00:58:35.000000', 'temperatura', 709.0000, 'ºC'),
	(88913, 111, '2015-03-01 00:58:36.000000', 'temperatura', 735.0000, 'ºC'),
	(88914, 111, '2015-03-01 00:58:37.000000', 'temperatura', 351.0000, 'ºC'),
	(88915, 111, '2015-03-01 00:58:38.000000', 'temperatura', 750.0000, 'ºC'),
	(88916, 111, '2015-03-01 00:58:39.000000', 'temperatura', 299.0000, 'ºC'),
	(88917, 111, '2015-03-01 00:58:40.000000', 'temperatura', 446.0000, 'ºC'),
	(88918, 111, '2015-03-01 00:58:41.000000', 'temperatura', 131.0000, 'ºC'),
	(88919, 111, '2015-03-01 00:58:42.000000', 'temperatura', 520.0000, 'ºC'),
	(88920, 111, '2015-03-01 00:58:43.000000', 'temperatura', 1008.0000, 'ºC'),
	(88921, 111, '2015-03-01 00:58:44.000000', 'temperatura', 1080.0000, 'ºC'),
	(88922, 111, '2015-03-01 00:58:45.000000', 'temperatura', 1178.0000, 'ºC'),
	(88923, 111, '2015-03-01 00:58:46.000000', 'temperatura', 250.0000, 'ºC'),
	(88924, 111, '2015-03-01 00:58:47.000000', 'temperatura', 116.0000, 'ºC'),
	(88925, 111, '2015-03-01 00:58:48.000000', 'temperatura', 1031.0000, 'ºC'),
	(88926, 111, '2015-03-01 00:58:49.000000', 'temperatura', 6.0000, 'ºC'),
	(88927, 111, '2015-03-01 00:58:50.000000', 'temperatura', 539.0000, 'ºC'),
	(88928, 111, '2015-03-01 00:58:51.000000', 'temperatura', 279.0000, 'ºC'),
	(88929, 111, '2015-03-01 00:58:52.000000', 'temperatura', 975.0000, 'ºC'),
	(88930, 111, '2015-03-01 00:58:53.000000', 'temperatura', 440.0000, 'ºC'),
	(88931, 111, '2015-03-01 00:58:54.000000', 'temperatura', 475.0000, 'ºC'),
	(88932, 111, '2015-03-01 00:58:55.000000', 'temperatura', 1054.0000, 'ºC'),
	(88933, 111, '2015-03-01 00:58:56.000000', 'temperatura', 246.0000, 'ºC'),
	(88934, 111, '2015-03-01 00:58:57.000000', 'temperatura', 469.0000, 'ºC'),
	(88935, 111, '2015-03-01 00:58:58.000000', 'temperatura', 408.0000, 'ºC'),
	(88936, 111, '2015-03-01 00:58:59.000000', 'temperatura', 631.0000, 'ºC'),
	(88937, 111, '2015-03-01 00:59:00.000000', 'temperatura', 733.0000, 'ºC'),
	(88938, 111, '2015-03-01 00:59:01.000000', 'temperatura', 573.0000, 'ºC'),
	(88939, 111, '2015-03-01 00:59:02.000000', 'temperatura', 667.0000, 'ºC'),
	(88940, 111, '2015-03-01 00:59:03.000000', 'temperatura', 414.0000, 'ºC'),
	(88941, 111, '2015-03-01 00:59:04.000000', 'temperatura', 71.0000, 'ºC'),
	(88942, 111, '2015-03-01 00:59:05.000000', 'temperatura', 311.0000, 'ºC'),
	(88943, 111, '2015-03-01 00:59:06.000000', 'temperatura', 145.0000, 'ºC'),
	(88944, 111, '2015-03-01 00:59:07.000000', 'temperatura', 994.0000, 'ºC'),
	(88945, 111, '2015-03-01 00:59:08.000000', 'temperatura', 933.0000, 'ºC'),
	(88946, 111, '2015-03-01 00:59:09.000000', 'temperatura', 486.0000, 'ºC'),
	(88947, 111, '2015-03-01 00:59:10.000000', 'temperatura', 829.0000, 'ºC'),
	(88948, 111, '2015-03-01 00:59:11.000000', 'temperatura', 288.0000, 'ºC'),
	(88949, 111, '2015-03-01 00:59:12.000000', 'temperatura', 156.0000, 'ºC'),
	(88950, 111, '2015-03-01 00:59:13.000000', 'temperatura', 1114.0000, 'ºC'),
	(88951, 111, '2015-03-01 00:59:14.000000', 'temperatura', 305.0000, 'ºC'),
	(88952, 111, '2015-03-01 00:59:15.000000', 'temperatura', 583.0000, 'ºC'),
	(88953, 111, '2015-03-01 00:59:16.000000', 'temperatura', 798.0000, 'ºC'),
	(88954, 111, '2015-03-01 00:59:17.000000', 'temperatura', 1043.0000, 'ºC'),
	(88955, 111, '2015-03-01 00:59:18.000000', 'temperatura', 423.0000, 'ºC'),
	(88956, 111, '2015-03-01 00:59:19.000000', 'temperatura', 186.0000, 'ºC'),
	(88957, 111, '2015-03-01 00:59:20.000000', 'temperatura', 861.0000, 'ºC'),
	(88958, 111, '2015-03-01 00:59:21.000000', 'temperatura', 149.0000, 'ºC'),
	(88959, 111, '2015-03-01 00:59:22.000000', 'temperatura', 563.0000, 'ºC'),
	(88960, 111, '2015-03-01 00:59:23.000000', 'temperatura', 1169.0000, 'ºC'),
	(88961, 111, '2015-03-01 00:59:24.000000', 'temperatura', 555.0000, 'ºC'),
	(88962, 111, '2015-03-01 00:59:25.000000', 'temperatura', 469.0000, 'ºC'),
	(88963, 111, '2015-03-01 00:59:26.000000', 'temperatura', 681.0000, 'ºC'),
	(88964, 111, '2015-03-01 00:59:27.000000', 'temperatura', 799.0000, 'ºC'),
	(88965, 111, '2015-03-01 00:59:28.000000', 'temperatura', 753.0000, 'ºC'),
	(88966, 111, '2015-03-01 00:59:29.000000', 'temperatura', 167.0000, 'ºC'),
	(88967, 111, '2015-03-01 00:59:30.000000', 'temperatura', 978.0000, 'ºC'),
	(88968, 111, '2015-03-01 00:59:31.000000', 'temperatura', 790.0000, 'ºC'),
	(88969, 111, '2015-03-01 00:59:32.000000', 'temperatura', 1017.0000, 'ºC'),
	(88970, 111, '2015-03-01 00:59:33.000000', 'temperatura', 315.0000, 'ºC'),
	(88971, 111, '2015-03-01 00:59:34.000000', 'temperatura', 923.0000, 'ºC'),
	(88972, 111, '2015-03-01 00:59:35.000000', 'temperatura', 72.0000, 'ºC'),
	(88973, 111, '2015-03-01 00:59:36.000000', 'temperatura', 1191.0000, 'ºC'),
	(88974, 111, '2015-03-01 00:59:37.000000', 'temperatura', 940.0000, 'ºC'),
	(88975, 111, '2015-03-01 00:59:38.000000', 'temperatura', 1126.0000, 'ºC'),
	(88976, 111, '2015-03-01 00:59:39.000000', 'temperatura', 412.0000, 'ºC'),
	(88977, 111, '2015-03-01 00:59:40.000000', 'temperatura', 1083.0000, 'ºC'),
	(88978, 111, '2015-03-01 00:59:41.000000', 'temperatura', 579.0000, 'ºC'),
	(88979, 111, '2015-03-01 00:59:42.000000', 'temperatura', 848.0000, 'ºC'),
	(88980, 111, '2015-03-01 00:59:43.000000', 'temperatura', 102.0000, 'ºC'),
	(88981, 111, '2015-03-01 00:59:44.000000', 'temperatura', 368.0000, 'ºC'),
	(88982, 111, '2015-03-01 00:59:45.000000', 'temperatura', 334.0000, 'ºC'),
	(88983, 111, '2015-03-01 00:59:46.000000', 'temperatura', 566.0000, 'ºC'),
	(88984, 111, '2015-03-01 00:59:47.000000', 'temperatura', 627.0000, 'ºC'),
	(88985, 111, '2015-03-01 00:59:48.000000', 'temperatura', 240.0000, 'ºC'),
	(88986, 111, '2015-03-01 00:59:49.000000', 'temperatura', 520.0000, 'ºC'),
	(88987, 111, '2015-03-01 00:59:50.000000', 'temperatura', 681.0000, 'ºC'),
	(88988, 111, '2015-03-01 00:59:51.000000', 'temperatura', 646.0000, 'ºC'),
	(88989, 111, '2015-03-01 00:59:52.000000', 'temperatura', 1187.0000, 'ºC'),
	(88990, 111, '2015-03-01 00:59:53.000000', 'temperatura', 397.0000, 'ºC'),
	(88991, 111, '2015-03-01 00:59:54.000000', 'temperatura', 823.0000, 'ºC'),
	(88992, 111, '2015-03-01 00:59:55.000000', 'temperatura', 524.0000, 'ºC'),
	(88993, 111, '2015-03-01 00:59:56.000000', 'temperatura', 153.0000, 'ºC'),
	(88994, 111, '2015-03-01 00:59:57.000000', 'temperatura', 391.0000, 'ºC'),
	(88995, 111, '2015-03-01 00:59:58.000000', 'temperatura', 299.0000, 'ºC'),
	(88996, 111, '2015-03-01 00:59:59.000000', 'temperatura', 322.0000, 'ºC'),
	(88997, 111, '2015-03-01 01:00:00.000000', 'temperatura', 713.0000, 'ºC'),
	(88998, 111, '2015-03-01 01:00:01.000000', 'temperatura', 199.0000, 'ºC'),
	(88999, 111, '2015-03-01 01:00:02.000000', 'temperatura', 57.0000, 'ºC'),
	(89000, 111, '2015-03-01 01:00:03.000000', 'temperatura', 887.0000, 'ºC'),
	(89001, 111, '2015-03-01 01:00:04.000000', 'temperatura', 664.0000, 'ºC'),
	(89002, 111, '2015-03-01 01:00:05.000000', 'temperatura', 660.0000, 'ºC'),
	(89003, 111, '2015-03-01 01:00:06.000000', 'temperatura', 109.0000, 'ºC'),
	(89004, 111, '2015-03-01 01:00:07.000000', 'temperatura', 964.0000, 'ºC'),
	(89005, 111, '2015-03-01 01:00:08.000000', 'temperatura', 894.0000, 'ºC'),
	(89006, 111, '2015-03-01 01:00:09.000000', 'temperatura', 380.0000, 'ºC'),
	(89007, 111, '2015-03-01 01:00:10.000000', 'temperatura', 417.0000, 'ºC'),
	(89008, 111, '2015-03-01 01:00:11.000000', 'temperatura', 945.0000, 'ºC'),
	(89009, 111, '2015-03-01 01:00:12.000000', 'temperatura', 1075.0000, 'ºC'),
	(89010, 111, '2015-03-01 01:00:13.000000', 'temperatura', 142.0000, 'ºC'),
	(89011, 111, '2015-03-01 01:00:14.000000', 'temperatura', 1084.0000, 'ºC'),
	(89012, 111, '2015-03-01 01:00:15.000000', 'temperatura', 197.0000, 'ºC'),
	(89013, 111, '2015-03-01 01:00:16.000000', 'temperatura', 132.0000, 'ºC'),
	(89014, 111, '2015-03-01 01:00:17.000000', 'temperatura', 70.0000, 'ºC'),
	(89015, 111, '2015-03-01 01:00:18.000000', 'temperatura', 1152.0000, 'ºC'),
	(89016, 111, '2015-03-01 01:00:19.000000', 'temperatura', 752.0000, 'ºC'),
	(89017, 111, '2015-03-01 01:00:20.000000', 'temperatura', 305.0000, 'ºC'),
	(89018, 111, '2015-03-01 01:00:21.000000', 'temperatura', 470.0000, 'ºC'),
	(89019, 111, '2015-03-01 01:00:22.000000', 'temperatura', 233.0000, 'ºC'),
	(89020, 111, '2015-03-01 01:00:23.000000', 'temperatura', 957.0000, 'ºC'),
	(89021, 111, '2015-03-01 01:00:24.000000', 'temperatura', 487.0000, 'ºC'),
	(89022, 111, '2015-03-01 01:00:25.000000', 'temperatura', 765.0000, 'ºC'),
	(89023, 111, '2015-03-01 01:00:26.000000', 'temperatura', 1165.0000, 'ºC'),
	(89024, 111, '2015-03-01 01:00:27.000000', 'temperatura', 1132.0000, 'ºC'),
	(89025, 111, '2015-03-01 01:00:28.000000', 'temperatura', 962.0000, 'ºC'),
	(89026, 111, '2015-03-01 01:00:29.000000', 'temperatura', 215.0000, 'ºC'),
	(89027, 111, '2015-03-01 01:00:30.000000', 'temperatura', 590.0000, 'ºC'),
	(89028, 111, '2015-03-01 01:00:31.000000', 'temperatura', 1103.0000, 'ºC'),
	(89029, 111, '2015-03-01 01:00:32.000000', 'temperatura', 149.0000, 'ºC'),
	(89030, 111, '2015-03-01 01:00:33.000000', 'temperatura', 1035.0000, 'ºC'),
	(89031, 111, '2015-03-01 01:00:34.000000', 'temperatura', 1131.0000, 'ºC'),
	(89032, 111, '2015-03-01 01:00:35.000000', 'temperatura', 148.0000, 'ºC'),
	(89033, 111, '2015-03-01 01:00:36.000000', 'temperatura', 949.0000, 'ºC'),
	(89034, 111, '2015-03-01 01:00:37.000000', 'temperatura', 701.0000, 'ºC'),
	(89035, 111, '2015-03-01 01:00:38.000000', 'temperatura', 657.0000, 'ºC'),
	(89036, 111, '2015-03-01 01:00:39.000000', 'temperatura', 1182.0000, 'ºC'),
	(89037, 111, '2015-03-01 01:00:40.000000', 'temperatura', 340.0000, 'ºC'),
	(89038, 111, '2015-03-01 01:00:41.000000', 'temperatura', 556.0000, 'ºC'),
	(89039, 111, '2015-03-01 01:00:42.000000', 'temperatura', 562.0000, 'ºC'),
	(89040, 111, '2015-03-01 01:00:43.000000', 'temperatura', 1140.0000, 'ºC'),
	(89041, 111, '2015-03-01 01:00:44.000000', 'temperatura', 416.0000, 'ºC'),
	(89042, 111, '2015-03-01 01:00:45.000000', 'temperatura', 1061.0000, 'ºC'),
	(89043, 111, '2015-03-01 01:00:46.000000', 'temperatura', 455.0000, 'ºC'),
	(89044, 111, '2015-03-01 01:00:47.000000', 'temperatura', 294.0000, 'ºC'),
	(89045, 111, '2015-03-01 01:00:48.000000', 'temperatura', 105.0000, 'ºC'),
	(89046, 111, '2015-03-01 01:00:49.000000', 'temperatura', 845.0000, 'ºC'),
	(89047, 111, '2015-03-01 01:00:50.000000', 'temperatura', 308.0000, 'ºC'),
	(89048, 111, '2015-03-01 01:00:51.000000', 'temperatura', 208.0000, 'ºC'),
	(89049, 111, '2015-03-01 01:00:52.000000', 'temperatura', 114.0000, 'ºC'),
	(89050, 111, '2015-03-01 01:00:53.000000', 'temperatura', 1149.0000, 'ºC'),
	(89051, 111, '2015-03-01 01:00:54.000000', 'temperatura', 604.0000, 'ºC'),
	(89052, 111, '2015-03-01 01:00:55.000000', 'temperatura', 772.0000, 'ºC'),
	(89053, 111, '2015-03-01 01:00:56.000000', 'temperatura', 851.0000, 'ºC'),
	(89054, 111, '2015-03-01 01:00:57.000000', 'temperatura', 737.0000, 'ºC'),
	(89055, 111, '2015-03-01 01:00:58.000000', 'temperatura', 1132.0000, 'ºC'),
	(89056, 111, '2015-03-01 01:00:59.000000', 'temperatura', 1051.0000, 'ºC'),
	(89057, 111, '2015-03-01 01:01:00.000000', 'temperatura', 659.0000, 'ºC'),
	(89058, 111, '2015-03-01 01:01:01.000000', 'temperatura', 143.0000, 'ºC'),
	(89059, 111, '2015-03-01 01:01:02.000000', 'temperatura', 1137.0000, 'ºC'),
	(89060, 111, '2015-03-01 01:01:03.000000', 'temperatura', 457.0000, 'ºC'),
	(89061, 111, '2015-03-01 01:01:04.000000', 'temperatura', 77.0000, 'ºC'),
	(89062, 111, '2015-03-01 01:01:05.000000', 'temperatura', 212.0000, 'ºC'),
	(89063, 111, '2015-03-01 01:01:06.000000', 'temperatura', 830.0000, 'ºC'),
	(89064, 111, '2015-03-01 01:01:07.000000', 'temperatura', 1115.0000, 'ºC'),
	(89065, 111, '2015-03-01 01:01:08.000000', 'temperatura', 686.0000, 'ºC'),
	(89066, 111, '2015-03-01 01:01:09.000000', 'temperatura', 85.0000, 'ºC'),
	(89067, 111, '2015-03-01 01:01:10.000000', 'temperatura', 766.0000, 'ºC'),
	(89068, 111, '2015-03-01 01:01:11.000000', 'temperatura', 1176.0000, 'ºC'),
	(89069, 111, '2015-03-01 01:01:12.000000', 'temperatura', 1183.0000, 'ºC'),
	(89070, 111, '2015-03-01 01:01:13.000000', 'temperatura', 1187.0000, 'ºC'),
	(89071, 111, '2015-03-01 01:01:14.000000', 'temperatura', 1189.0000, 'ºC'),
	(89072, 111, '2015-03-01 01:01:15.000000', 'temperatura', 1182.0000, 'ºC'),
	(89073, 111, '2015-03-01 01:01:16.000000', 'temperatura', 1146.0000, 'ºC'),
	(89074, 111, '2015-03-01 01:01:17.000000', 'temperatura', 983.0000, 'ºC'),
	(89075, 111, '2015-03-01 01:01:18.000000', 'temperatura', 278.0000, 'ºC'),
	(89076, 111, '2015-03-01 01:01:19.000000', 'temperatura', 842.0000, 'ºC'),
	(89077, 111, '2015-03-01 01:01:20.000000', 'temperatura', 978.0000, 'ºC'),
	(89078, 111, '2015-03-01 01:01:21.000000', 'temperatura', 1163.0000, 'ºC'),
	(89079, 111, '2015-03-01 01:01:22.000000', 'temperatura', 483.0000, 'ºC'),
	(89080, 111, '2015-03-01 01:01:23.000000', 'temperatura', 126.0000, 'ºC'),
	(89081, 111, '2015-03-01 01:01:24.000000', 'temperatura', 379.0000, 'ºC'),
	(89082, 111, '2015-03-01 01:01:25.000000', 'temperatura', 320.0000, 'ºC'),
	(89083, 111, '2015-03-01 01:01:26.000000', 'temperatura', 464.0000, 'ºC'),
	(89084, 111, '2015-03-01 01:01:27.000000', 'temperatura', 159.0000, 'ºC'),
	(89085, 111, '2015-03-01 01:01:28.000000', 'temperatura', 603.0000, 'ºC'),
	(89086, 111, '2015-03-01 01:01:29.000000', 'temperatura', 141.0000, 'ºC'),
	(89087, 111, '2015-03-01 01:01:30.000000', 'temperatura', 93.0000, 'ºC'),
	(89088, 111, '2015-03-01 01:01:31.000000', 'temperatura', 45.0000, 'ºC'),
	(89089, 111, '2015-03-01 01:01:32.000000', 'temperatura', 1144.0000, 'ºC'),
	(89090, 111, '2015-03-01 01:01:33.000000', 'temperatura', 786.0000, 'ºC'),
	(89091, 111, '2015-03-01 01:01:34.000000', 'temperatura', 500.0000, 'ºC'),
	(89092, 111, '2015-03-01 01:01:35.000000', 'temperatura', 142.0000, 'ºC'),
	(89093, 111, '2015-03-01 01:01:36.000000', 'temperatura', 410.0000, 'ºC'),
	(89094, 111, '2015-03-01 01:01:37.000000', 'temperatura', 423.0000, 'ºC'),
	(89095, 111, '2015-03-01 01:01:38.000000', 'temperatura', 888.0000, 'ºC'),
	(89096, 111, '2015-03-01 01:01:39.000000', 'temperatura', 770.0000, 'ºC'),
	(89097, 111, '2015-03-01 01:01:40.000000', 'temperatura', 1187.0000, 'ºC'),
	(89098, 111, '2015-03-01 01:01:41.000000', 'temperatura', 23.0000, 'ºC'),
	(89099, 111, '2015-03-01 01:01:42.000000', 'temperatura', 158.0000, 'ºC'),
	(89100, 111, '2015-03-01 01:01:43.000000', 'temperatura', 721.0000, 'ºC'),
	(89101, 111, '2015-03-01 01:01:44.000000', 'temperatura', 733.0000, 'ºC'),
	(89102, 111, '2015-03-01 01:01:45.000000', 'temperatura', 301.0000, 'ºC'),
	(89103, 111, '2015-03-01 01:01:46.000000', 'temperatura', 506.0000, 'ºC'),
	(89104, 111, '2015-03-01 01:01:47.000000', 'temperatura', 428.0000, 'ºC'),
	(89105, 111, '2015-03-01 01:01:48.000000', 'temperatura', 622.0000, 'ºC'),
	(89106, 111, '2015-03-01 01:01:49.000000', 'temperatura', 628.0000, 'ºC'),
	(89107, 111, '2015-03-01 01:01:50.000000', 'temperatura', 72.0000, 'ºC'),
	(89108, 111, '2015-03-01 01:01:51.000000', 'temperatura', 879.0000, 'ºC'),
	(89109, 111, '2015-03-01 01:01:52.000000', 'temperatura', 577.0000, 'ºC'),
	(89110, 111, '2015-03-01 01:01:53.000000', 'temperatura', 251.0000, 'ºC'),
	(89111, 111, '2015-03-01 01:01:54.000000', 'temperatura', 723.0000, 'ºC'),
	(89112, 111, '2015-03-01 01:01:55.000000', 'temperatura', 464.0000, 'ºC'),
	(89113, 111, '2015-03-01 01:01:56.000000', 'temperatura', 150.0000, 'ºC'),
	(89114, 111, '2015-03-01 01:01:57.000000', 'temperatura', 560.0000, 'ºC'),
	(89115, 111, '2015-03-01 01:01:58.000000', 'temperatura', 1150.0000, 'ºC'),
	(89116, 111, '2015-03-01 01:01:59.000000', 'temperatura', 470.0000, 'ºC'),
	(89117, 111, '2015-03-01 01:02:00.000000', 'temperatura', 101.0000, 'ºC'),
	(89118, 111, '2015-03-01 01:02:01.000000', 'temperatura', 297.0000, 'ºC'),
	(89119, 111, '2015-03-01 01:02:02.000000', 'temperatura', 1183.0000, 'ºC'),
	(89120, 111, '2015-03-01 01:02:03.000000', 'temperatura', 225.0000, 'ºC'),
	(89121, 111, '2015-03-01 01:02:04.000000', 'temperatura', 1175.0000, 'ºC'),
	(89122, 111, '2015-03-01 01:02:05.000000', 'temperatura', 399.0000, 'ºC'),
	(89123, 111, '2015-03-01 01:02:06.000000', 'temperatura', 872.0000, 'ºC'),
	(89124, 111, '2015-03-01 01:02:07.000000', 'temperatura', 762.0000, 'ºC'),
	(89125, 111, '2015-03-01 01:02:08.000000', 'temperatura', 1196.0000, 'ºC'),
	(89126, 111, '2015-03-01 01:02:09.000000', 'temperatura', 96.0000, 'ºC'),
	(89127, 111, '2015-03-01 01:02:10.000000', 'temperatura', 491.0000, 'ºC'),
	(89128, 111, '2015-03-01 01:02:11.000000', 'temperatura', 966.0000, 'ºC'),
	(89129, 111, '2015-03-01 01:02:12.000000', 'temperatura', 957.0000, 'ºC'),
	(89130, 111, '2015-03-01 01:02:13.000000', 'temperatura', 690.0000, 'ºC'),
	(89131, 111, '2015-03-01 01:02:14.000000', 'temperatura', 578.0000, 'ºC'),
	(89132, 111, '2015-03-01 01:02:15.000000', 'temperatura', 823.0000, 'ºC'),
	(89133, 111, '2015-03-01 01:02:16.000000', 'temperatura', 1180.0000, 'ºC'),
	(89134, 111, '2015-03-01 01:02:17.000000', 'temperatura', 1030.0000, 'ºC'),
	(89135, 111, '2015-03-01 01:02:18.000000', 'temperatura', 412.0000, 'ºC'),
	(89136, 111, '2015-03-01 01:02:19.000000', 'temperatura', 171.0000, 'ºC'),
	(89137, 111, '2015-03-01 01:02:20.000000', 'temperatura', 818.0000, 'ºC'),
	(89138, 111, '2015-03-01 01:02:21.000000', 'temperatura', 1179.0000, 'ºC'),
	(89139, 111, '2015-03-01 01:02:22.000000', 'temperatura', 1041.0000, 'ºC'),
	(89140, 111, '2015-03-01 01:02:23.000000', 'temperatura', 469.0000, 'ºC'),
	(89141, 111, '2015-03-01 01:02:24.000000', 'temperatura', 420.0000, 'ºC'),
	(89142, 111, '2015-03-01 01:02:25.000000', 'temperatura', 696.0000, 'ºC'),
	(89143, 111, '2015-03-01 01:02:26.000000', 'temperatura', 1020.0000, 'ºC'),
	(89144, 111, '2015-03-01 01:02:27.000000', 'temperatura', 611.0000, 'ºC'),
	(89145, 111, '2015-03-01 01:02:28.000000', 'temperatura', 1197.0000, 'ºC'),
	(89146, 111, '2015-03-01 01:02:29.000000', 'temperatura', 552.0000, 'ºC'),
	(89147, 111, '2015-03-01 01:02:30.000000', 'temperatura', 370.0000, 'ºC'),
	(89148, 111, '2015-03-01 01:02:31.000000', 'temperatura', 195.0000, 'ºC'),
	(89149, 111, '2015-03-01 01:02:32.000000', 'temperatura', 1066.0000, 'ºC'),
	(89150, 111, '2015-03-01 01:02:33.000000', 'temperatura', 1146.0000, 'ºC'),
	(89151, 111, '2015-03-01 01:02:34.000000', 'temperatura', 131.0000, 'ºC'),
	(89152, 111, '2015-03-01 01:02:35.000000', 'temperatura', 817.0000, 'ºC'),
	(89153, 111, '2015-03-01 01:02:36.000000', 'temperatura', 94.0000, 'ºC'),
	(89154, 111, '2015-03-01 01:02:37.000000', 'temperatura', 420.0000, 'ºC'),
	(89155, 111, '2015-03-01 01:02:38.000000', 'temperatura', 616.0000, 'ºC'),
	(89156, 111, '2015-03-01 01:02:39.000000', 'temperatura', 623.0000, 'ºC'),
	(89157, 111, '2015-03-01 01:02:40.000000', 'temperatura', 69.0000, 'ºC'),
	(89158, 111, '2015-03-01 01:02:41.000000', 'temperatura', 873.0000, 'ºC'),
	(89159, 111, '2015-03-01 01:02:42.000000', 'temperatura', 562.0000, 'ºC'),
	(89160, 111, '2015-03-01 01:02:43.000000', 'temperatura', 188.0000, 'ºC'),
	(89161, 111, '2015-03-01 01:02:44.000000', 'temperatura', 457.0000, 'ºC'),
	(89162, 111, '2015-03-01 01:02:45.000000', 'temperatura', 521.0000, 'ºC'),
	(89163, 111, '2015-03-01 01:02:46.000000', 'temperatura', 34.0000, 'ºC'),
	(89164, 111, '2015-03-01 01:02:47.000000', 'temperatura', 1006.0000, 'ºC'),
	(89165, 111, '2015-03-01 01:02:48.000000', 'temperatura', 130.0000, 'ºC'),
	(89166, 111, '2015-03-01 01:02:49.000000', 'temperatura', 33.0000, 'ºC'),
	(89167, 111, '2015-03-01 01:02:50.000000', 'temperatura', 976.0000, 'ºC'),
	(89168, 111, '2015-03-01 01:02:51.000000', 'temperatura', 1181.0000, 'ºC'),
	(89169, 111, '2015-03-01 01:02:52.000000', 'temperatura', 575.0000, 'ºC'),
	(89170, 111, '2015-03-01 01:02:53.000000', 'temperatura', 535.0000, 'ºC'),
	(89171, 111, '2015-03-01 01:02:54.000000', 'temperatura', 951.0000, 'ºC'),
	(89172, 111, '2015-03-01 01:02:55.000000', 'temperatura', 751.0000, 'ºC'),
	(89173, 111, '2015-03-01 01:02:56.000000', 'temperatura', 900.0000, 'ºC'),
	(89174, 111, '2015-03-01 01:02:57.000000', 'temperatura', 1047.0000, 'ºC'),
	(89175, 111, '2015-03-01 01:02:58.000000', 'temperatura', 137.0000, 'ºC'),
	(89176, 111, '2015-03-01 01:02:59.000000', 'temperatura', 1143.0000, 'ºC'),
	(89177, 111, '2015-03-01 01:03:00.000000', 'temperatura', 504.0000, 'ºC'),
	(89178, 111, '2015-03-01 01:03:01.000000', 'temperatura', 294.0000, 'ºC'),
	(89179, 111, '2015-03-01 01:03:02.000000', 'temperatura', 1158.0000, 'ºC'),
	(89180, 111, '2015-03-01 01:03:03.000000', 'temperatura', 106.0000, 'ºC'),
	(89181, 111, '2015-03-01 01:03:04.000000', 'temperatura', 660.0000, 'ºC'),
	(89182, 111, '2015-03-01 01:03:05.000000', 'temperatura', 580.0000, 'ºC'),
	(89183, 111, '2015-03-01 01:03:06.000000', 'temperatura', 921.0000, 'ºC'),
	(89184, 111, '2015-03-01 01:03:07.000000', 'temperatura', 467.0000, 'ºC'),
	(89185, 111, '2015-03-01 01:03:08.000000', 'temperatura', 771.0000, 'ºC'),
	(89186, 111, '2015-03-01 01:03:09.000000', 'temperatura', 55.0000, 'ºC'),
	(89187, 111, '2015-03-01 01:03:10.000000', 'temperatura', 361.0000, 'ºC'),
	(89188, 111, '2015-03-01 01:03:11.000000', 'temperatura', 440.0000, 'ºC'),
	(89189, 111, '2015-03-01 01:03:12.000000', 'temperatura', 1119.0000, 'ºC'),
	(89190, 111, '2015-03-01 01:03:13.000000', 'temperatura', 673.0000, 'ºC'),
	(89191, 111, '2015-03-01 01:03:14.000000', 'temperatura', 11.0000, 'ºC'),
	(89192, 111, '2015-03-01 01:03:15.000000', 'temperatura', 434.0000, 'ºC'),
	(89193, 111, '2015-03-01 01:03:16.000000', 'temperatura', 940.0000, 'ºC'),
	(89194, 111, '2015-03-01 01:03:17.000000', 'temperatura', 999.0000, 'ºC'),
	(89195, 111, '2015-03-01 01:03:18.000000', 'temperatura', 977.0000, 'ºC'),
	(89196, 111, '2015-03-01 01:03:19.000000', 'temperatura', 685.0000, 'ºC'),
	(89197, 111, '2015-03-01 01:03:20.000000', 'temperatura', 494.0000, 'ºC'),
	(89198, 111, '2015-03-01 01:03:21.000000', 'temperatura', 418.0000, 'ºC'),
	(89199, 111, '2015-03-01 01:03:22.000000', 'temperatura', 608.0000, 'ºC'),
	(89200, 111, '2015-03-01 01:03:23.000000', 'temperatura', 587.0000, 'ºC'),
	(89201, 111, '2015-03-01 01:03:24.000000', 'temperatura', 1113.0000, 'ºC'),
	(89202, 111, '2015-03-01 01:03:25.000000', 'temperatura', 201.0000, 'ºC'),
	(89203, 111, '2015-03-01 01:03:26.000000', 'temperatura', 68.0000, 'ºC'),
	(89204, 111, '2015-03-01 01:03:27.000000', 'temperatura', 939.0000, 'ºC'),
	(89205, 111, '2015-03-01 01:03:28.000000', 'temperatura', 889.0000, 'ºC'),
	(89206, 111, '2015-03-01 01:03:29.000000', 'temperatura', 431.0000, 'ºC'),
	(89207, 111, '2015-03-01 01:03:30.000000', 'temperatura', 689.0000, 'ºC'),
	(89208, 111, '2015-03-01 01:03:31.000000', 'temperatura', 953.0000, 'ºC'),
	(89209, 111, '2015-03-01 01:03:32.000000', 'temperatura', 299.0000, 'ºC'),
	(89210, 111, '2015-03-01 01:03:33.000000', 'temperatura', 1036.0000, 'ºC'),
	(89211, 111, '2015-03-01 01:03:34.000000', 'temperatura', 682.0000, 'ºC'),
	(89212, 111, '2015-03-01 01:03:35.000000', 'temperatura', 305.0000, 'ºC'),
	(89213, 111, '2015-03-01 01:03:36.000000', 'temperatura', 678.0000, 'ºC'),
	(89214, 111, '2015-03-01 01:03:37.000000', 'temperatura', 75.0000, 'ºC'),
	(89215, 111, '2015-03-01 01:03:38.000000', 'temperatura', 741.0000, 'ºC'),
	(89216, 111, '2015-03-01 01:03:39.000000', 'temperatura', 1082.0000, 'ºC'),
	(89217, 111, '2015-03-01 01:03:40.000000', 'temperatura', 789.0000, 'ºC'),
	(89218, 111, '2015-03-01 01:03:41.000000', 'temperatura', 697.0000, 'ºC'),
	(89219, 111, '2015-03-01 01:03:42.000000', 'temperatura', 1120.0000, 'ºC'),
	(89220, 111, '2015-03-01 01:03:43.000000', 'temperatura', 1110.0000, 'ºC'),
	(89221, 111, '2015-03-01 01:03:44.000000', 'temperatura', 991.0000, 'ºC'),
	(89222, 111, '2015-03-01 01:03:45.000000', 'temperatura', 427.0000, 'ºC'),
	(89223, 111, '2015-03-01 01:03:46.000000', 'temperatura', 359.0000, 'ºC'),
	(89224, 111, '2015-03-01 01:03:47.000000', 'temperatura', 518.0000, 'ºC'),
	(89225, 111, '2015-03-01 01:03:48.000000', 'temperatura', 310.0000, 'ºC'),
	(89226, 111, '2015-03-01 01:03:49.000000', 'temperatura', 1199.0000, 'ºC'),
	(89227, 111, '2015-03-01 01:03:50.000000', 'temperatura', 264.0000, 'ºC'),
	(89228, 111, '2015-03-01 01:03:51.000000', 'temperatura', 124.0000, 'ºC'),
	(89229, 111, '2015-03-01 01:03:52.000000', 'temperatura', 1030.0000, 'ºC'),
	(89230, 111, '2015-03-01 01:03:53.000000', 'temperatura', 1179.0000, 'ºC'),
	(89231, 111, '2015-03-01 01:03:54.000000', 'temperatura', 404.0000, 'ºC'),
	(89232, 111, '2015-03-01 01:03:55.000000', 'temperatura', 882.0000, 'ºC'),
	(89233, 111, '2015-03-01 01:03:56.000000', 'temperatura', 801.0000, 'ºC'),
	(89234, 111, '2015-03-01 01:03:57.000000', 'temperatura', 160.0000, 'ºC'),
	(89235, 111, '2015-03-01 01:03:58.000000', 'temperatura', 796.0000, 'ºC'),
	(89236, 111, '2015-03-01 01:03:59.000000', 'temperatura', 1101.0000, 'ºC'),
	(89237, 111, '2015-03-01 01:04:00.000000', 'temperatura', 717.0000, 'ºC'),
	(89238, 111, '2015-03-01 01:04:01.000000', 'temperatura', 282.0000, 'ºC'),
	(89239, 111, '2015-03-01 01:04:02.000000', 'temperatura', 462.0000, 'ºC'),
	(89240, 111, '2015-03-01 01:04:03.000000', 'temperatura', 262.0000, 'ºC'),
	(89241, 111, '2015-03-01 01:04:04.000000', 'temperatura', 1127.0000, 'ºC'),
	(89242, 111, '2015-03-01 01:04:05.000000', 'temperatura', 47.0000, 'ºC'),
	(89243, 111, '2015-03-01 01:04:06.000000', 'temperatura', 458.0000, 'ºC'),
	(89244, 111, '2015-03-01 01:04:07.000000', 'temperatura', 946.0000, 'ºC'),
	(89245, 111, '2015-03-01 01:04:08.000000', 'temperatura', 956.0000, 'ºC'),
	(89246, 111, '2015-03-01 01:04:09.000000', 'temperatura', 744.0000, 'ºC'),
	(89247, 111, '2015-03-01 01:04:10.000000', 'temperatura', 852.0000, 'ºC'),
	(89248, 111, '2015-03-01 01:04:11.000000', 'temperatura', 829.0000, 'ºC'),
	(89249, 111, '2015-03-01 01:04:12.000000', 'temperatura', 391.0000, 'ºC'),
	(89250, 111, '2015-03-01 01:04:13.000000', 'temperatura', 665.0000, 'ºC'),
	(89251, 111, '2015-03-01 01:04:14.000000', 'temperatura', 956.0000, 'ºC'),
	(89252, 111, '2015-03-01 01:04:15.000000', 'temperatura', 384.0000, 'ºC'),
	(89253, 111, '2015-03-01 01:04:16.000000', 'temperatura', 252.0000, 'ºC'),
	(89254, 111, '2015-03-01 01:04:17.000000', 'temperatura', 107.0000, 'ºC'),
	(89255, 111, '2015-03-01 01:04:18.000000', 'temperatura', 982.0000, 'ºC'),
	(89256, 111, '2015-03-01 01:04:19.000000', 'temperatura', 990.0000, 'ºC'),
	(89257, 111, '2015-03-01 01:04:20.000000', 'temperatura', 804.0000, 'ºC'),
	(89258, 111, '2015-03-01 01:04:21.000000', 'temperatura', 1052.0000, 'ºC'),
	(89259, 111, '2015-03-01 01:04:22.000000', 'temperatura', 448.0000, 'ºC'),
	(89260, 111, '2015-03-01 01:04:23.000000', 'temperatura', 283.0000, 'ºC'),
	(89261, 111, '2015-03-01 01:04:24.000000', 'temperatura', 72.0000, 'ºC'),
	(89262, 111, '2015-03-01 01:04:25.000000', 'temperatura', 712.0000, 'ºC'),
	(89263, 111, '2015-03-01 01:04:26.000000', 'temperatura', 943.0000, 'ºC'),
	(89264, 111, '2015-03-01 01:04:27.000000', 'temperatura', 179.0000, 'ºC'),
	(89265, 111, '2015-03-01 01:04:28.000000', 'temperatura', 466.0000, 'ºC'),
	(89266, 111, '2015-03-01 01:04:29.000000', 'temperatura', 594.0000, 'ºC'),
	(89267, 111, '2015-03-01 01:04:30.000000', 'temperatura', 371.0000, 'ºC'),
	(89268, 111, '2015-03-01 01:04:31.000000', 'temperatura', 74.0000, 'ºC'),
	(89269, 111, '2015-03-01 01:04:32.000000', 'temperatura', 456.0000, 'ºC'),
	(89270, 111, '2015-03-01 01:04:33.000000', 'temperatura', 862.0000, 'ºC'),
	(89271, 111, '2015-03-01 01:04:34.000000', 'temperatura', 540.0000, 'ºC'),
	(89272, 111, '2015-03-01 01:04:35.000000', 'temperatura', 117.0000, 'ºC'),
	(89273, 111, '2015-03-01 01:04:36.000000', 'temperatura', 164.0000, 'ºC'),
	(89274, 111, '2015-03-01 01:04:37.000000', 'temperatura', 470.0000, 'ºC'),
	(89275, 111, '2015-03-01 01:04:38.000000', 'temperatura', 657.0000, 'ºC'),
	(89276, 111, '2015-03-01 01:04:39.000000', 'temperatura', 676.0000, 'ºC'),
	(89277, 111, '2015-03-01 01:04:40.000000', 'temperatura', 210.0000, 'ºC'),
	(89278, 111, '2015-03-01 01:04:41.000000', 'temperatura', 223.0000, 'ºC'),
	(89279, 111, '2015-03-01 01:04:42.000000', 'temperatura', 486.0000, 'ºC'),
	(89280, 111, '2015-03-01 01:04:43.000000', 'temperatura', 559.0000, 'ºC'),
	(89281, 111, '2015-03-01 01:04:44.000000', 'temperatura', 140.0000, 'ºC'),
	(89282, 111, '2015-03-01 01:04:45.000000', 'temperatura', 224.0000, 'ºC'),
	(89283, 111, '2015-03-01 01:04:46.000000', 'temperatura', 700.0000, 'ºC'),
	(89284, 111, '2015-03-01 01:04:47.000000', 'temperatura', 428.0000, 'ºC'),
	(89285, 111, '2015-03-01 01:04:48.000000', 'temperatura', 40.0000, 'ºC'),
	(89286, 111, '2015-03-01 01:04:49.000000', 'temperatura', 117.0000, 'ºC'),
	(89287, 111, '2015-03-01 01:04:50.000000', 'temperatura', 468.0000, 'ºC'),
	(89288, 111, '2015-03-01 01:04:51.000000', 'temperatura', 786.0000, 'ºC'),
	(89289, 111, '2015-03-01 01:04:52.000000', 'temperatura', 127.0000, 'ºC'),
	(89290, 111, '2015-03-01 01:04:53.000000', 'temperatura', 680.0000, 'ºC'),
	(89291, 111, '2015-03-01 01:04:54.000000', 'temperatura', 617.0000, 'ºC'),
	(89292, 111, '2015-03-01 01:04:55.000000', 'temperatura', 1046.0000, 'ºC'),
	(89293, 111, '2015-03-01 01:04:56.000000', 'temperatura', 981.0000, 'ºC'),
	(89294, 111, '2015-03-01 01:04:57.000000', 'temperatura', 568.0000, 'ºC'),
	(89295, 111, '2015-03-01 01:04:58.000000', 'temperatura', 1099.0000, 'ºC'),
	(89296, 111, '2015-03-01 01:04:59.000000', 'temperatura', 188.0000, 'ºC'),
	(89297, 111, '2015-03-01 01:05:00.000000', 'temperatura', 45.0000, 'ºC'),
	(89298, 111, '2015-03-01 01:05:01.000000', 'temperatura', 860.0000, 'ºC'),
	(89299, 111, '2015-03-01 01:05:02.000000', 'temperatura', 568.0000, 'ºC'),
	(89300, 111, '2015-03-01 01:05:03.000000', 'temperatura', 261.0000, 'ºC'),
	(89301, 111, '2015-03-01 01:05:04.000000', 'temperatura', 801.0000, 'ºC'),
	(89302, 111, '2015-03-01 01:05:05.000000', 'temperatura', 821.0000, 'ºC'),
	(89303, 111, '2015-03-01 01:05:06.000000', 'temperatura', 505.0000, 'ºC'),
	(89304, 111, '2015-03-01 01:05:07.000000', 'temperatura', 61.0000, 'ºC'),
	(89305, 111, '2015-03-01 01:05:08.000000', 'temperatura', 1190.0000, 'ºC'),
	(89306, 112, '2015-03-01 00:00:00.000000', 'temperatura', 66.0000, 'ºC'),
	(89307, 112, '2015-03-01 00:00:01.000000', 'temperatura', 1031.0000, 'ºC'),
	(89308, 112, '2015-03-01 00:00:02.000000', 'temperatura', 158.0000, 'ºC'),
	(89309, 112, '2015-03-01 00:00:03.000000', 'temperatura', 97.0000, 'ºC'),
	(89310, 112, '2015-03-01 00:00:04.000000', 'temperatura', 10.0000, 'ºC'),
	(89311, 112, '2015-03-01 00:00:05.000000', 'temperatura', 960.0000, 'ºC'),
	(89312, 112, '2015-03-01 00:00:06.000000', 'temperatura', 1171.0000, 'ºC'),
	(89313, 112, '2015-03-01 00:00:07.000000', 'temperatura', 577.0000, 'ºC'),
	(89314, 112, '2015-03-01 00:00:08.000000', 'temperatura', 570.0000, 'ºC'),
	(89315, 112, '2015-03-01 00:00:09.000000', 'temperatura', 1119.0000, 'ºC'),
	(89316, 112, '2015-03-01 00:00:10.000000', 'temperatura', 289.0000, 'ºC'),
	(89317, 112, '2015-03-01 00:00:11.000000', 'temperatura', 485.0000, 'ºC'),
	(89318, 112, '2015-03-01 00:00:12.000000', 'temperatura', 360.0000, 'ºC'),
	(89319, 112, '2015-03-01 00:00:13.000000', 'temperatura', 346.0000, 'ºC'),
	(89320, 112, '2015-03-01 00:00:14.000000', 'temperatura', 652.0000, 'ºC'),
	(89321, 112, '2015-03-01 00:00:15.000000', 'temperatura', 1021.0000, 'ºC'),
	(89322, 112, '2015-03-01 00:00:16.000000', 'temperatura', 750.0000, 'ºC'),
	(89323, 112, '2015-03-01 00:00:17.000000', 'temperatura', 688.0000, 'ºC'),
	(89324, 112, '2015-03-01 00:00:18.000000', 'temperatura', 1189.0000, 'ºC'),
	(89325, 112, '2015-03-01 00:00:19.000000', 'temperatura', 283.0000, 'ºC'),
	(89326, 112, '2015-03-01 00:00:20.000000', 'temperatura', 247.0000, 'ºC'),
	(89327, 112, '2015-03-01 00:00:21.000000', 'temperatura', 387.0000, 'ºC'),
	(89328, 112, '2015-03-01 00:00:22.000000', 'temperatura', 1194.0000, 'ºC'),
	(89329, 112, '2015-03-01 00:00:23.000000', 'temperatura', 8.0000, 'ºC'),
	(89330, 112, '2015-03-01 00:00:24.000000', 'temperatura', 61.0000, 'ºC'),
	(89331, 112, '2015-03-01 00:00:25.000000', 'temperatura', 283.0000, 'ºC'),
	(89332, 112, '2015-03-01 00:00:26.000000', 'temperatura', 30.0000, 'ºC'),
	(89333, 112, '2015-03-01 00:00:27.000000', 'temperatura', 500.0000, 'ºC'),
	(89334, 112, '2015-03-01 00:00:28.000000', 'temperatura', 14.0000, 'ºC'),
	(89335, 112, '2015-03-01 00:00:29.000000', 'temperatura', 969.0000, 'ºC'),
	(89336, 112, '2015-03-01 00:00:30.000000', 'temperatura', 2.0000, 'ºC'),
	(89337, 112, '2015-03-01 00:00:31.000000', 'temperatura', 703.0000, 'ºC'),
	(89338, 112, '2015-03-01 00:00:32.000000', 'temperatura', 1110.0000, 'ºC'),
	(89339, 112, '2015-03-01 00:00:33.000000', 'temperatura', 1040.0000, 'ºC'),
	(89340, 112, '2015-03-01 00:00:34.000000', 'temperatura', 674.0000, 'ºC'),
	(89341, 112, '2015-03-01 00:00:35.000000', 'temperatura', 248.0000, 'ºC'),
	(89342, 112, '2015-03-01 00:00:36.000000', 'temperatura', 418.0000, 'ºC'),
	(89343, 112, '2015-03-01 00:00:37.000000', 'temperatura', 145.0000, 'ºC'),
	(89344, 112, '2015-03-01 00:00:38.000000', 'temperatura', 675.0000, 'ºC'),
	(89345, 112, '2015-03-01 00:00:39.000000', 'temperatura', 538.0000, 'ºC'),
	(89346, 112, '2015-03-01 00:00:40.000000', 'temperatura', 664.0000, 'ºC'),
	(89347, 112, '2015-03-01 00:00:41.000000', 'temperatura', 510.0000, 'ºC'),
	(89348, 112, '2015-03-01 00:00:42.000000', 'temperatura', 557.0000, 'ºC'),
	(89349, 112, '2015-03-01 00:00:43.000000', 'temperatura', 56.0000, 'ºC'),
	(89350, 112, '2015-03-01 00:00:44.000000', 'temperatura', 1009.0000, 'ºC'),
	(89351, 112, '2015-03-01 00:00:45.000000', 'temperatura', 77.0000, 'ºC'),
	(89352, 112, '2015-03-01 00:00:46.000000', 'temperatura', 959.0000, 'ºC'),
	(89353, 112, '2015-03-01 00:00:47.000000', 'temperatura', 966.0000, 'ºC'),
	(89354, 112, '2015-03-01 00:00:48.000000', 'temperatura', 753.0000, 'ºC'),
	(89355, 112, '2015-03-01 00:00:49.000000', 'temperatura', 866.0000, 'ºC'),
	(89356, 112, '2015-03-01 00:00:50.000000', 'temperatura', 871.0000, 'ºC'),
	(89357, 112, '2015-03-01 00:00:51.000000', 'temperatura', 556.0000, 'ºC'),
	(89358, 112, '2015-03-01 00:00:52.000000', 'temperatura', 170.0000, 'ºC'),
	(89359, 112, '2015-03-01 00:00:53.000000', 'temperatura', 383.0000, 'ºC'),
	(89360, 112, '2015-03-01 00:00:54.000000', 'temperatura', 207.0000, 'ºC'),
	(89361, 112, '2015-03-01 00:00:55.000000', 'temperatura', 1083.0000, 'ºC'),
	(89362, 112, '2015-03-01 00:00:56.000000', 'temperatura', 1197.0000, 'ºC'),
	(89363, 112, '2015-03-01 00:00:57.000000', 'temperatura', 337.0000, 'ºC'),
	(89364, 112, '2015-03-01 00:00:58.000000', 'temperatura', 493.0000, 'ºC'),
	(89365, 112, '2015-03-01 00:00:59.000000', 'temperatura', 256.0000, 'ºC'),
	(89366, 112, '2015-03-01 00:01:00.000000', 'temperatura', 999.0000, 'ºC'),
	(89367, 112, '2015-03-01 00:01:01.000000', 'temperatura', 629.0000, 'ºC'),
	(89368, 112, '2015-03-01 00:01:02.000000', 'temperatura', 149.0000, 'ºC'),
	(89369, 112, '2015-03-01 00:01:03.000000', 'temperatura', 59.0000, 'ºC'),
	(89370, 112, '2015-03-01 00:01:04.000000', 'temperatura', 1047.0000, 'ºC'),
	(89371, 112, '2015-03-01 00:01:05.000000', 'temperatura', 261.0000, 'ºC'),
	(89372, 112, '2015-03-01 00:01:06.000000', 'temperatura', 564.0000, 'ºC'),
	(89373, 112, '2015-03-01 00:01:07.000000', 'temperatura', 835.0000, 'ºC'),
	(89374, 112, '2015-03-01 00:01:08.000000', 'temperatura', 86.0000, 'ºC'),
	(89375, 112, '2015-03-01 00:01:09.000000', 'temperatura', 324.0000, 'ºC'),
	(89376, 112, '2015-03-01 00:01:10.000000', 'temperatura', 162.0000, 'ºC'),
	(89377, 112, '2015-03-01 00:01:11.000000', 'temperatura', 1037.0000, 'ºC'),
	(89378, 112, '2015-03-01 00:01:12.000000', 'temperatura', 1103.0000, 'ºC'),
	(89379, 112, '2015-03-01 00:01:13.000000', 'temperatura', 2.0000, 'ºC'),
	(89380, 112, '2015-03-01 00:01:14.000000', 'temperatura', 304.0000, 'ºC'),
	(89381, 112, '2015-03-01 00:01:15.000000', 'temperatura', 315.0000, 'ºC'),
	(89382, 112, '2015-03-01 00:01:16.000000', 'temperatura', 661.0000, 'ºC'),
	(89383, 112, '2015-03-01 00:01:17.000000', 'temperatura', 1163.0000, 'ºC'),
	(89384, 112, '2015-03-01 00:01:18.000000', 'temperatura', 231.0000, 'ºC'),
	(89385, 112, '2015-03-01 00:01:19.000000', 'temperatura', 67.0000, 'ºC'),
	(89386, 112, '2015-03-01 00:01:20.000000', 'temperatura', 842.0000, 'ºC'),
	(89387, 112, '2015-03-01 00:01:21.000000', 'temperatura', 411.0000, 'ºC'),
	(89388, 112, '2015-03-01 00:01:22.000000', 'temperatura', 728.0000, 'ºC'),
	(89389, 112, '2015-03-01 00:01:23.000000', 'temperatura', 9.0000, 'ºC'),
	(89390, 112, '2015-03-01 00:01:24.000000', 'temperatura', 262.0000, 'ºC'),
	(89391, 112, '2015-03-01 00:01:25.000000', 'temperatura', 84.0000, 'ºC'),
	(89392, 112, '2015-03-01 00:01:26.000000', 'temperatura', 835.0000, 'ºC'),
	(89393, 112, '2015-03-01 00:01:27.000000', 'temperatura', 323.0000, 'ºC'),
	(89394, 112, '2015-03-01 00:01:28.000000', 'temperatura', 311.0000, 'ºC'),
	(89395, 112, '2015-03-01 00:01:29.000000', 'temperatura', 586.0000, 'ºC'),
	(89396, 112, '2015-03-01 00:01:30.000000', 'temperatura', 799.0000, 'ºC'),
	(89397, 112, '2015-03-01 00:01:31.000000', 'temperatura', 1036.0000, 'ºC'),
	(89398, 112, '2015-03-01 00:01:32.000000', 'temperatura', 383.0000, 'ºC'),
	(89399, 112, '2015-03-01 00:01:33.000000', 'temperatura', 7.0000, 'ºC'),
	(89400, 112, '2015-03-01 00:01:34.000000', 'temperatura', 88.0000, 'ºC'),
	(89401, 112, '2015-03-01 00:01:35.000000', 'temperatura', 420.0000, 'ºC'),
	(89402, 112, '2015-03-01 00:01:36.000000', 'temperatura', 638.0000, 'ºC'),
	(89403, 112, '2015-03-01 00:01:37.000000', 'temperatura', 727.0000, 'ºC'),
	(89404, 112, '2015-03-01 00:01:38.000000', 'temperatura', 524.0000, 'ºC'),
	(89405, 112, '2015-03-01 00:01:39.000000', 'temperatura', 438.0000, 'ºC'),
	(89406, 112, '2015-03-01 00:01:40.000000', 'temperatura', 619.0000, 'ºC'),
	(89407, 112, '2015-03-01 00:01:41.000000', 'temperatura', 583.0000, 'ºC'),
	(89408, 112, '2015-03-01 00:01:42.000000', 'temperatura', 1056.0000, 'ºC'),
	(89409, 112, '2015-03-01 00:01:43.000000', 'temperatura', 1132.0000, 'ºC'),
	(89410, 112, '2015-03-01 00:01:44.000000', 'temperatura', 95.0000, 'ºC'),
	(89411, 112, '2015-03-01 00:01:45.000000', 'temperatura', 676.0000, 'ºC'),
	(89412, 112, '2015-03-01 00:01:46.000000', 'temperatura', 697.0000, 'ºC'),
	(89413, 112, '2015-03-01 00:01:47.000000', 'temperatura', 257.0000, 'ºC'),
	(89414, 112, '2015-03-01 00:01:48.000000', 'temperatura', 395.0000, 'ºC'),
	(89415, 112, '2015-03-01 00:01:49.000000', 'temperatura', 2.0000, 'ºC'),
	(89416, 112, '2015-03-01 00:01:50.000000', 'temperatura', 28.0000, 'ºC'),
	(89417, 112, '2015-03-01 00:01:51.000000', 'temperatura', 135.0000, 'ºC'),
	(89418, 112, '2015-03-01 00:01:52.000000', 'temperatura', 591.0000, 'ºC'),
	(89419, 112, '2015-03-01 00:01:53.000000', 'temperatura', 151.0000, 'ºC'),
	(89420, 112, '2015-03-01 00:01:54.000000', 'temperatura', 183.0000, 'ºC'),
	(89421, 112, '2015-03-01 00:01:55.000000', 'temperatura', 462.0000, 'ºC'),
	(89422, 112, '2015-03-01 00:01:56.000000', 'temperatura', 563.0000, 'ºC'),
	(89423, 112, '2015-03-01 00:01:57.000000', 'temperatura', 229.0000, 'ºC'),
	(89424, 112, '2015-03-01 00:01:58.000000', 'temperatura', 656.0000, 'ºC'),
	(89425, 112, '2015-03-01 00:01:59.000000', 'temperatura', 194.0000, 'ºC'),
	(89426, 112, '2015-03-01 00:02:00.000000', 'temperatura', 203.0000, 'ºC'),
	(89427, 112, '2015-03-01 00:02:01.000000', 'temperatura', 433.0000, 'ºC'),
	(89428, 112, '2015-03-01 00:02:02.000000', 'temperatura', 357.0000, 'ºC'),
	(89429, 112, '2015-03-01 00:02:03.000000', 'temperatura', 486.0000, 'ºC'),
	(89430, 112, '2015-03-01 00:02:04.000000', 'temperatura', 160.0000, 'ºC'),
	(89431, 112, '2015-03-01 00:02:05.000000', 'temperatura', 543.0000, 'ºC'),
	(89432, 112, '2015-03-01 00:02:06.000000', 'temperatura', 1033.0000, 'ºC'),
	(89433, 112, '2015-03-01 00:02:07.000000', 'temperatura', 1138.0000, 'ºC'),
	(89434, 112, '2015-03-01 00:02:08.000000', 'temperatura', 192.0000, 'ºC'),
	(89435, 112, '2015-03-01 00:02:09.000000', 'temperatura', 1146.0000, 'ºC'),
	(89436, 112, '2015-03-01 00:02:10.000000', 'temperatura', 356.0000, 'ºC'),
	(89437, 112, '2015-03-01 00:02:11.000000', 'temperatura', 742.0000, 'ºC'),
	(89438, 112, '2015-03-01 00:02:12.000000', 'temperatura', 242.0000, 'ºC'),
	(89439, 112, '2015-03-01 00:02:13.000000', 'temperatura', 184.0000, 'ºC'),
	(89440, 112, '2015-03-01 00:02:14.000000', 'temperatura', 195.0000, 'ºC'),
	(89441, 112, '2015-03-01 00:02:15.000000', 'temperatura', 423.0000, 'ºC'),
	(89442, 112, '2015-03-01 00:02:16.000000', 'temperatura', 333.0000, 'ºC'),
	(89443, 112, '2015-03-01 00:02:17.000000', 'temperatura', 394.0000, 'ºC'),
	(89444, 112, '2015-03-01 00:02:18.000000', 'temperatura', 974.0000, 'ºC'),
	(89445, 112, '2015-03-01 00:02:19.000000', 'temperatura', 88.0000, 'ºC'),
	(89446, 112, '2015-03-01 00:02:20.000000', 'temperatura', 1120.0000, 'ºC'),
	(89447, 112, '2015-03-01 00:02:21.000000', 'temperatura', 535.0000, 'ºC'),
	(89448, 112, '2015-03-01 00:02:22.000000', 'temperatura', 517.0000, 'ºC'),
	(89449, 112, '2015-03-01 00:02:23.000000', 'temperatura', 979.0000, 'ºC'),
	(89450, 112, '2015-03-01 00:02:24.000000', 'temperatura', 947.0000, 'ºC'),
	(89451, 112, '2015-03-01 00:02:25.000000', 'temperatura', 595.0000, 'ºC'),
	(89452, 112, '2015-03-01 00:02:26.000000', 'temperatura', 136.0000, 'ºC'),
	(89453, 112, '2015-03-01 00:02:27.000000', 'temperatura', 97.0000, 'ºC'),
	(89454, 112, '2015-03-01 00:02:28.000000', 'temperatura', 75.0000, 'ºC'),
	(89455, 112, '2015-03-01 00:02:29.000000', 'temperatura', 86.0000, 'ºC'),
	(89456, 112, '2015-03-01 00:02:30.000000', 'temperatura', 207.0000, 'ºC'),
	(89457, 112, '2015-03-01 00:02:31.000000', 'temperatura', 777.0000, 'ºC'),
	(89458, 112, '2015-03-01 00:02:32.000000', 'temperatura', 863.0000, 'ºC'),
	(89459, 112, '2015-03-01 00:02:33.000000', 'temperatura', 786.0000, 'ºC'),
	(89460, 112, '2015-03-01 00:02:34.000000', 'temperatura', 139.0000, 'ºC'),
	(89461, 112, '2015-03-01 00:02:35.000000', 'temperatura', 739.0000, 'ºC'),
	(89462, 112, '2015-03-01 00:02:36.000000', 'temperatura', 879.0000, 'ºC'),
	(89463, 112, '2015-03-01 00:02:37.000000', 'temperatura', 977.0000, 'ºC'),
	(89464, 112, '2015-03-01 00:02:38.000000', 'temperatura', 1048.0000, 'ºC'),
	(89465, 112, '2015-03-01 00:02:39.000000', 'temperatura', 1108.0000, 'ºC'),
	(89466, 112, '2015-03-01 00:02:40.000000', 'temperatura', 0.0000, 'ºC'),
	(89467, 112, '2015-03-01 00:02:41.000000', 'temperatura', 276.0000, 'ºC'),
	(89468, 112, '2015-03-01 00:02:42.000000', 'temperatura', 181.0000, 'ºC'),
	(89469, 112, '2015-03-01 00:02:43.000000', 'temperatura', 77.0000, 'ºC'),
	(89470, 112, '2015-03-01 00:02:44.000000', 'temperatura', 1041.0000, 'ºC'),
	(89471, 112, '2015-03-01 00:02:45.000000', 'temperatura', 174.0000, 'ºC'),
	(89472, 112, '2015-03-01 00:02:46.000000', 'temperatura', 149.0000, 'ºC'),
	(89473, 112, '2015-03-01 00:02:47.000000', 'temperatura', 224.0000, 'ºC'),
	(89474, 112, '2015-03-01 00:02:48.000000', 'temperatura', 675.0000, 'ºC'),
	(89475, 112, '2015-03-01 00:02:49.000000', 'temperatura', 300.0000, 'ºC'),
	(89476, 112, '2015-03-01 00:02:50.000000', 'temperatura', 679.0000, 'ºC'),
	(89477, 112, '2015-03-01 00:02:51.000000', 'temperatura', 93.0000, 'ºC'),
	(89478, 112, '2015-03-01 00:02:52.000000', 'temperatura', 828.0000, 'ºC'),
	(89479, 112, '2015-03-01 00:02:53.000000', 'temperatura', 261.0000, 'ºC'),
	(89480, 112, '2015-03-01 00:02:54.000000', 'temperatura', 22.0000, 'ºC'),
	(89481, 112, '2015-03-01 00:02:55.000000', 'temperatura', 529.0000, 'ºC'),
	(89482, 112, '2015-03-01 00:02:56.000000', 'temperatura', 180.0000, 'ºC'),
	(89483, 112, '2015-03-01 00:02:57.000000', 'temperatura', 511.0000, 'ºC'),
	(89484, 112, '2015-03-01 00:02:58.000000', 'temperatura', 818.0000, 'ºC'),
	(89485, 112, '2015-03-01 00:02:59.000000', 'temperatura', 157.0000, 'ºC'),
	(89486, 112, '2015-03-01 00:03:00.000000', 'temperatura', 733.0000, 'ºC'),
	(89487, 112, '2015-03-01 00:03:01.000000', 'temperatura', 792.0000, 'ºC'),
	(89488, 112, '2015-03-01 00:03:02.000000', 'temperatura', 562.0000, 'ºC'),
	(89489, 112, '2015-03-01 00:03:03.000000', 'temperatura', 435.0000, 'ºC'),
	(89490, 112, '2015-03-01 00:03:04.000000', 'temperatura', 488.0000, 'ºC'),
	(89491, 112, '2015-03-01 00:03:05.000000', 'temperatura', 1135.0000, 'ºC'),
	(89492, 112, '2015-03-01 00:03:06.000000', 'temperatura', 614.0000, 'ºC'),
	(89493, 112, '2015-03-01 00:03:07.000000', 'temperatura', 866.0000, 'ºC'),
	(89494, 112, '2015-03-01 00:03:08.000000', 'temperatura', 87.0000, 'ºC'),
	(89495, 112, '2015-03-01 00:03:09.000000', 'temperatura', 239.0000, 'ºC'),
	(89496, 112, '2015-03-01 00:03:10.000000', 'temperatura', 934.0000, 'ºC'),
	(89497, 112, '2015-03-01 00:03:11.000000', 'temperatura', 352.0000, 'ºC'),
	(89498, 112, '2015-03-01 00:03:12.000000', 'temperatura', 158.0000, 'ºC'),
	(89499, 112, '2015-03-01 00:03:13.000000', 'temperatura', 935.0000, 'ºC'),
	(89500, 112, '2015-03-01 00:03:14.000000', 'temperatura', 601.0000, 'ºC'),
	(89501, 112, '2015-03-01 00:03:15.000000', 'temperatura', 201.0000, 'ºC'),
	(89502, 112, '2015-03-01 00:03:16.000000', 'temperatura', 403.0000, 'ºC'),
	(89503, 112, '2015-03-01 00:03:17.000000', 'temperatura', 213.0000, 'ºC'),
	(89504, 112, '2015-03-01 00:03:18.000000', 'temperatura', 1057.0000, 'ºC'),
	(89505, 112, '2015-03-01 00:03:19.000000', 'temperatura', 1044.0000, 'ºC'),
	(89506, 112, '2015-03-01 00:03:20.000000', 'temperatura', 853.0000, 'ºC'),
	(89507, 112, '2015-03-01 00:03:21.000000', 'temperatura', 1131.0000, 'ºC'),
	(89508, 112, '2015-03-01 00:03:22.000000', 'temperatura', 697.0000, 'ºC'),
	(89509, 112, '2015-03-01 00:03:23.000000', 'temperatura', 93.0000, 'ºC'),
	(89510, 112, '2015-03-01 00:03:24.000000', 'temperatura', 775.0000, 'ºC'),
	(89511, 112, '2015-03-01 00:03:25.000000', 'temperatura', 1196.0000, 'ºC'),
	(89512, 112, '2015-03-01 00:03:26.000000', 'temperatura', 53.0000, 'ºC'),
	(89513, 112, '2015-03-01 00:03:27.000000', 'temperatura', 281.0000, 'ºC'),
	(89514, 112, '2015-03-01 00:03:28.000000', 'temperatura', 45.0000, 'ºC'),
	(89515, 112, '2015-03-01 00:03:29.000000', 'temperatura', 582.0000, 'ºC'),
	(89516, 112, '2015-03-01 00:03:30.000000', 'temperatura', 375.0000, 'ºC'),
	(89517, 112, '2015-03-01 00:03:31.000000', 'temperatura', 130.0000, 'ºC'),
	(89518, 112, '2015-03-01 00:03:32.000000', 'temperatura', 724.0000, 'ºC'),
	(89519, 112, '2015-03-01 00:03:33.000000', 'temperatura', 830.0000, 'ºC'),
	(89520, 112, '2015-03-01 00:03:34.000000', 'temperatura', 778.0000, 'ºC'),
	(89521, 112, '2015-03-01 00:03:35.000000', 'temperatura', 200.0000, 'ºC'),
	(89522, 112, '2015-03-01 00:03:36.000000', 'temperatura', 1069.0000, 'ºC'),
	(89523, 112, '2015-03-01 00:03:37.000000', 'temperatura', 1147.0000, 'ºC'),
	(89524, 112, '2015-03-01 00:03:38.000000', 'temperatura', 125.0000, 'ºC'),
	(89525, 112, '2015-03-01 00:03:39.000000', 'temperatura', 787.0000, 'ºC'),
	(89526, 112, '2015-03-01 00:03:40.000000', 'temperatura', 1160.0000, 'ºC'),
	(89527, 112, '2015-03-01 00:03:41.000000', 'temperatura', 1038.0000, 'ºC'),
	(89528, 112, '2015-03-01 00:03:42.000000', 'temperatura', 510.0000, 'ºC'),
	(89529, 112, '2015-03-01 00:03:43.000000', 'temperatura', 636.0000, 'ºC'),
	(89530, 112, '2015-03-01 00:03:44.000000', 'temperatura', 451.0000, 'ºC'),
	(89531, 112, '2015-03-01 00:03:45.000000', 'temperatura', 347.0000, 'ºC'),
	(89532, 112, '2015-03-01 00:03:46.000000', 'temperatura', 384.0000, 'ºC'),
	(89533, 112, '2015-03-01 00:03:47.000000', 'temperatura', 878.0000, 'ºC'),
	(89534, 112, '2015-03-01 00:03:48.000000', 'temperatura', 838.0000, 'ºC'),
	(89535, 112, '2015-03-01 00:03:49.000000', 'temperatura', 356.0000, 'ºC'),
	(89536, 112, '2015-03-01 00:03:50.000000', 'temperatura', 469.0000, 'ºC'),
	(89537, 112, '2015-03-01 00:03:51.000000', 'temperatura', 77.0000, 'ºC'),
	(89538, 112, '2015-03-01 00:03:52.000000', 'temperatura', 176.0000, 'ºC'),
	(89539, 112, '2015-03-01 00:03:53.000000', 'temperatura', 652.0000, 'ºC'),
	(89540, 112, '2015-03-01 00:03:54.000000', 'temperatura', 331.0000, 'ºC'),
	(89541, 112, '2015-03-01 00:03:55.000000', 'temperatura', 901.0000, 'ºC'),
	(89542, 112, '2015-03-01 00:03:56.000000', 'temperatura', 1113.0000, 'ºC'),
	(89543, 112, '2015-03-01 00:03:57.000000', 'temperatura', 461.0000, 'ºC'),
	(89544, 112, '2015-03-01 00:03:58.000000', 'temperatura', 166.0000, 'ºC'),
	(89545, 112, '2015-03-01 00:03:59.000000', 'temperatura', 648.0000, 'ºC'),
	(89546, 112, '2015-03-01 00:04:00.000000', 'temperatura', 344.0000, 'ºC'),
	(89547, 112, '2015-03-01 00:04:01.000000', 'temperatura', 977.0000, 'ºC'),
	(89548, 112, '2015-03-01 00:04:02.000000', 'temperatura', 253.0000, 'ºC'),
	(89549, 112, '2015-03-01 00:04:03.000000', 'temperatura', 736.0000, 'ºC'),
	(89550, 112, '2015-03-01 00:04:04.000000', 'temperatura', 519.0000, 'ºC'),
	(89551, 112, '2015-03-01 00:04:05.000000', 'temperatura', 388.0000, 'ºC'),
	(89552, 112, '2015-03-01 00:04:06.000000', 'temperatura', 383.0000, 'ºC'),
	(89553, 112, '2015-03-01 00:04:07.000000', 'temperatura', 750.0000, 'ºC'),
	(89554, 112, '2015-03-01 00:04:08.000000', 'temperatura', 205.0000, 'ºC'),
	(89555, 112, '2015-03-01 00:04:09.000000', 'temperatura', 1173.0000, 'ºC'),
	(89556, 112, '2015-03-01 00:04:10.000000', 'temperatura', 450.0000, 'ºC'),
	(89557, 112, '2015-03-01 00:04:11.000000', 'temperatura', 1134.0000, 'ºC'),
	(89558, 112, '2015-03-01 00:04:12.000000', 'temperatura', 718.0000, 'ºC'),
	(89559, 112, '2015-03-01 00:04:13.000000', 'temperatura', 191.0000, 'ºC'),
	(89560, 112, '2015-03-01 00:04:14.000000', 'temperatura', 0.0000, 'ºC'),
	(89561, 112, '2015-03-01 00:04:15.000000', 'temperatura', 627.0000, 'ºC'),
	(89562, 112, '2015-03-01 00:04:16.000000', 'temperatura', 736.0000, 'ºC'),
	(89563, 112, '2015-03-01 00:04:17.000000', 'temperatura', 600.0000, 'ºC'),
	(89564, 112, '2015-03-01 00:04:18.000000', 'temperatura', 792.0000, 'ºC'),
	(89565, 112, '2015-03-01 00:04:19.000000', 'temperatura', 959.0000, 'ºC'),
	(89566, 112, '2015-03-01 00:04:20.000000', 'temperatura', 19.0000, 'ºC'),
	(89567, 112, '2015-03-01 00:04:21.000000', 'temperatura', 821.0000, 'ºC'),
	(89568, 112, '2015-03-01 00:04:22.000000', 'temperatura', 447.0000, 'ºC'),
	(89569, 112, '2015-03-01 00:04:23.000000', 'temperatura', 974.0000, 'ºC'),
	(89570, 112, '2015-03-01 00:04:24.000000', 'temperatura', 1127.0000, 'ºC'),
	(89571, 112, '2015-03-01 00:04:25.000000', 'temperatura', 316.0000, 'ºC'),
	(89572, 112, '2015-03-01 00:04:26.000000', 'temperatura', 598.0000, 'ºC'),
	(89573, 112, '2015-03-01 00:04:27.000000', 'temperatura', 845.0000, 'ºC'),
	(89574, 112, '2015-03-01 00:04:28.000000', 'temperatura', 29.0000, 'ºC'),
	(89575, 112, '2015-03-01 00:04:29.000000', 'temperatura', 10.0000, 'ºC'),
	(89576, 112, '2015-03-01 00:04:30.000000', 'temperatura', 1163.0000, 'ºC'),
	(89577, 112, '2015-03-01 00:04:31.000000', 'temperatura', 987.0000, 'ºC'),
	(89578, 112, '2015-03-01 00:04:32.000000', 'temperatura', 245.0000, 'ºC'),
	(89579, 112, '2015-03-01 00:04:33.000000', 'temperatura', 666.0000, 'ºC'),
	(89580, 112, '2015-03-01 00:04:34.000000', 'temperatura', 195.0000, 'ºC'),
	(89581, 112, '2015-03-01 00:04:35.000000', 'temperatura', 179.0000, 'ºC'),
	(89582, 112, '2015-03-01 00:04:36.000000', 'temperatura', 307.0000, 'ºC'),
	(89583, 112, '2015-03-01 00:04:37.000000', 'temperatura', 1002.0000, 'ºC'),
	(89584, 112, '2015-03-01 00:04:38.000000', 'temperatura', 487.0000, 'ºC'),
	(89585, 112, '2015-03-01 00:04:39.000000', 'temperatura', 631.0000, 'ºC'),
	(89586, 112, '2015-03-01 00:04:40.000000', 'temperatura', 496.0000, 'ºC'),
	(89587, 112, '2015-03-01 00:04:41.000000', 'temperatura', 584.0000, 'ºC'),
	(89588, 112, '2015-03-01 00:04:42.000000', 'temperatura', 235.0000, 'ºC'),
	(89589, 112, '2015-03-01 00:04:43.000000', 'temperatura', 624.0000, 'ºC'),
	(89590, 112, '2015-03-01 00:04:44.000000', 'temperatura', 14.0000, 'ºC'),
	(89591, 112, '2015-03-01 00:04:45.000000', 'temperatura', 598.0000, 'ºC'),
	(89592, 112, '2015-03-01 00:04:46.000000', 'temperatura', 549.0000, 'ºC'),
	(89593, 112, '2015-03-01 00:04:47.000000', 'temperatura', 950.0000, 'ºC'),
	(89594, 112, '2015-03-01 00:04:48.000000', 'temperatura', 705.0000, 'ºC'),
	(89595, 112, '2015-03-01 00:04:49.000000', 'temperatura', 677.0000, 'ºC'),
	(89596, 112, '2015-03-01 00:04:50.000000', 'temperatura', 67.0000, 'ºC'),
	(89597, 112, '2015-03-01 00:04:51.000000', 'temperatura', 708.0000, 'ºC'),
	(89598, 112, '2015-03-01 00:04:52.000000', 'temperatura', 938.0000, 'ºC'),
	(89599, 112, '2015-03-01 00:04:53.000000', 'temperatura', 168.0000, 'ºC'),
	(89600, 112, '2015-03-01 00:04:54.000000', 'temperatura', 426.0000, 'ºC'),
	(89601, 112, '2015-03-01 00:04:55.000000', 'temperatura', 426.0000, 'ºC'),
	(89602, 112, '2015-03-01 00:04:56.000000', 'temperatura', 852.0000, 'ºC'),
	(89603, 112, '2015-03-01 00:04:57.000000', 'temperatura', 581.0000, 'ºC'),
	(89604, 112, '2015-03-01 00:04:58.000000', 'temperatura', 351.0000, 'ºC'),
	(89605, 112, '2015-03-01 00:04:59.000000', 'temperatura', 12.0000, 'ºC'),
	(89606, 112, '2015-03-01 00:05:00.000000', 'temperatura', 209.0000, 'ºC'),
	(89607, 112, '2015-03-01 00:05:01.000000', 'temperatura', 1009.0000, 'ºC'),
	(89608, 112, '2015-03-01 00:05:02.000000', 'temperatura', 819.0000, 'ºC'),
	(89609, 112, '2015-03-01 00:05:03.000000', 'temperatura', 1068.0000, 'ºC'),
	(89610, 112, '2015-03-01 00:05:04.000000', 'temperatura', 482.0000, 'ºC'),
	(89611, 112, '2015-03-01 00:05:05.000000', 'temperatura', 408.0000, 'ºC'),
	(89612, 112, '2015-03-01 00:05:06.000000', 'temperatura', 593.0000, 'ºC'),
	(89613, 112, '2015-03-01 00:05:07.000000', 'temperatura', 544.0000, 'ºC'),
	(89614, 112, '2015-03-01 00:05:08.000000', 'temperatura', 940.0000, 'ºC'),
	(89615, 112, '2015-03-01 00:05:09.000000', 'temperatura', 668.0000, 'ºC'),
	(89616, 112, '2015-03-01 00:05:10.000000', 'temperatura', 521.0000, 'ºC'),
	(89617, 112, '2015-03-01 00:05:11.000000', 'temperatura', 601.0000, 'ºC'),
	(89618, 112, '2015-03-01 00:05:12.000000', 'temperatura', 241.0000, 'ºC'),
	(89619, 112, '2015-03-01 00:05:13.000000', 'temperatura', 604.0000, 'ºC'),
	(89620, 112, '2015-03-01 00:05:14.000000', 'temperatura', 1098.0000, 'ºC'),
	(89621, 112, '2015-03-01 00:05:15.000000', 'temperatura', 79.0000, 'ºC'),
	(89622, 112, '2015-03-01 00:05:16.000000', 'temperatura', 702.0000, 'ºC'),
	(89623, 112, '2015-03-01 00:05:17.000000', 'temperatura', 874.0000, 'ºC'),
	(89624, 112, '2015-03-01 00:05:18.000000', 'temperatura', 1063.0000, 'ºC'),
	(89625, 112, '2015-03-01 00:05:19.000000', 'temperatura', 292.0000, 'ºC'),
	(89626, 112, '2015-03-01 00:05:20.000000', 'temperatura', 674.0000, 'ºC'),
	(89627, 112, '2015-03-01 00:05:21.000000', 'temperatura', 93.0000, 'ºC'),
	(89628, 112, '2015-03-01 00:05:22.000000', 'temperatura', 845.0000, 'ºC'),
	(89629, 112, '2015-03-01 00:05:23.000000', 'temperatura', 347.0000, 'ºC'),
	(89630, 112, '2015-03-01 00:05:24.000000', 'temperatura', 398.0000, 'ºC'),
	(89631, 112, '2015-03-01 00:05:25.000000', 'temperatura', 949.0000, 'ºC'),
	(89632, 112, '2015-03-01 00:05:26.000000', 'temperatura', 1153.0000, 'ºC'),
	(89633, 112, '2015-03-01 00:05:27.000000', 'temperatura', 518.0000, 'ºC'),
	(89634, 112, '2015-03-01 00:05:28.000000', 'temperatura', 330.0000, 'ºC'),
	(89635, 112, '2015-03-01 00:05:29.000000', 'temperatura', 98.0000, 'ºC'),
	(89636, 112, '2015-03-01 00:05:30.000000', 'temperatura', 699.0000, 'ºC'),
	(89637, 112, '2015-03-01 00:05:31.000000', 'temperatura', 803.0000, 'ºC'),
	(89638, 112, '2015-03-01 00:05:32.000000', 'temperatura', 720.0000, 'ºC'),
	(89639, 112, '2015-03-01 00:05:33.000000', 'temperatura', 1189.0000, 'ºC'),
	(89640, 112, '2015-03-01 00:05:34.000000', 'temperatura', 186.0000, 'ºC'),
	(89641, 112, '2015-03-01 00:05:35.000000', 'temperatura', 965.0000, 'ºC'),
	(89642, 112, '2015-03-01 00:05:36.000000', 'temperatura', 668.0000, 'ºC'),
	(89643, 112, '2015-03-01 00:05:37.000000', 'temperatura', 444.0000, 'ºC'),
	(89644, 112, '2015-03-01 00:05:38.000000', 'temperatura', 215.0000, 'ºC'),
	(89645, 112, '2015-03-01 00:05:39.000000', 'temperatura', 946.0000, 'ºC'),
	(89646, 112, '2015-03-01 00:05:40.000000', 'temperatura', 485.0000, 'ºC'),
	(89647, 112, '2015-03-01 00:05:41.000000', 'temperatura', 788.0000, 'ºC'),
	(89648, 112, '2015-03-01 00:05:42.000000', 'temperatura', 87.0000, 'ºC'),
	(89649, 112, '2015-03-01 00:05:43.000000', 'temperatura', 470.0000, 'ºC'),
	(89650, 112, '2015-03-01 00:05:44.000000', 'temperatura', 889.0000, 'ºC'),
	(89651, 112, '2015-03-01 00:05:45.000000', 'temperatura', 634.0000, 'ºC'),
	(89652, 112, '2015-03-01 00:05:46.000000', 'temperatura', 506.0000, 'ºC'),
	(89653, 112, '2015-03-01 00:05:47.000000', 'temperatura', 627.0000, 'ºC'),
	(89654, 112, '2015-03-01 00:05:48.000000', 'temperatura', 417.0000, 'ºC'),
	(89655, 112, '2015-03-01 00:05:49.000000', 'temperatura', 203.0000, 'ºC'),
	(89656, 112, '2015-03-01 00:05:50.000000', 'temperatura', 966.0000, 'ºC'),
	(89657, 112, '2015-03-01 00:05:51.000000', 'temperatura', 622.0000, 'ºC'),
	(89658, 112, '2015-03-01 00:05:52.000000', 'temperatura', 214.0000, 'ºC'),
	(89659, 112, '2015-03-01 00:05:53.000000', 'temperatura', 402.0000, 'ºC'),
	(89660, 112, '2015-03-01 00:05:54.000000', 'temperatura', 171.0000, 'ºC'),
	(89661, 112, '2015-03-01 00:05:55.000000', 'temperatura', 850.0000, 'ºC'),
	(89662, 112, '2015-03-01 00:05:56.000000', 'temperatura', 138.0000, 'ºC'),
	(89663, 112, '2015-03-01 00:05:57.000000', 'temperatura', 539.0000, 'ºC'),
	(89664, 112, '2015-03-01 00:05:58.000000', 'temperatura', 1081.0000, 'ºC'),
	(89665, 112, '2015-03-01 00:05:59.000000', 'temperatura', 189.0000, 'ºC'),
	(89666, 112, '2015-03-01 00:06:00.000000', 'temperatura', 104.0000, 'ºC'),
	(89667, 112, '2015-03-01 00:06:01.000000', 'temperatura', 1153.0000, 'ºC'),
	(89668, 112, '2015-03-01 00:06:02.000000', 'temperatura', 655.0000, 'ºC'),
	(89669, 112, '2015-03-01 00:06:03.000000', 'temperatura', 1014.0000, 'ºC'),
	(89670, 112, '2015-03-01 00:06:04.000000', 'temperatura', 704.0000, 'ºC'),
	(89671, 112, '2015-03-01 00:06:05.000000', 'temperatura', 482.0000, 'ºC'),
	(89672, 112, '2015-03-01 00:06:06.000000', 'temperatura', 297.0000, 'ºC'),
	(89673, 112, '2015-03-01 00:06:07.000000', 'temperatura', 40.0000, 'ºC'),
	(89674, 112, '2015-03-01 00:06:08.000000', 'temperatura', 511.0000, 'ºC'),
	(89675, 112, '2015-03-01 00:06:09.000000', 'temperatura', 34.0000, 'ºC'),
	(89676, 112, '2015-03-01 00:06:10.000000', 'temperatura', 1037.0000, 'ºC'),
	(89677, 112, '2015-03-01 00:06:11.000000', 'temperatura', 282.0000, 'ºC'),
	(89678, 112, '2015-03-01 00:06:12.000000', 'temperatura', 702.0000, 'ºC'),
	(89679, 112, '2015-03-01 00:06:13.000000', 'temperatura', 262.0000, 'ºC'),
	(89680, 112, '2015-03-01 00:06:14.000000', 'temperatura', 404.0000, 'ºC'),
	(89681, 112, '2015-03-01 00:06:15.000000', 'temperatura', 37.0000, 'ºC'),
	(89682, 112, '2015-03-01 00:06:16.000000', 'temperatura', 171.0000, 'ºC'),
	(89683, 112, '2015-03-01 00:06:17.000000', 'temperatura', 745.0000, 'ºC'),
	(89684, 112, '2015-03-01 00:06:18.000000', 'temperatura', 811.0000, 'ºC'),
	(89685, 112, '2015-03-01 00:06:19.000000', 'temperatura', 622.0000, 'ºC'),
	(89686, 112, '2015-03-01 00:06:20.000000', 'temperatura', 675.0000, 'ºC'),
	(89687, 112, '2015-03-01 00:06:21.000000', 'temperatura', 313.0000, 'ºC'),
	(89688, 112, '2015-03-01 00:06:22.000000', 'temperatura', 739.0000, 'ºC'),
	(89689, 112, '2015-03-01 00:06:23.000000', 'temperatura', 356.0000, 'ºC'),
	(89690, 112, '2015-03-01 00:06:24.000000', 'temperatura', 763.0000, 'ºC'),
	(89691, 112, '2015-03-01 00:06:25.000000', 'temperatura', 350.0000, 'ºC'),
	(89692, 112, '2015-03-01 00:06:26.000000', 'temperatura', 659.0000, 'ºC'),
	(89693, 112, '2015-03-01 00:06:27.000000', 'temperatura', 1048.0000, 'ºC'),
	(89694, 112, '2015-03-01 00:06:28.000000', 'temperatura', 862.0000, 'ºC'),
	(89695, 112, '2015-03-01 00:06:29.000000', 'temperatura', 1166.0000, 'ºC'),
	(89696, 112, '2015-03-01 00:06:30.000000', 'temperatura', 846.0000, 'ºC'),
	(89697, 112, '2015-03-01 00:06:31.000000', 'temperatura', 730.0000, 'ºC'),
	(89698, 112, '2015-03-01 00:06:32.000000', 'temperatura', 1113.0000, 'ºC'),
	(89699, 112, '2015-03-01 00:06:33.000000', 'temperatura', 976.0000, 'ºC'),
	(89700, 112, '2015-03-01 00:06:34.000000', 'temperatura', 340.0000, 'ºC'),
	(89701, 112, '2015-03-01 00:06:35.000000', 'temperatura', 1173.0000, 'ºC'),
	(89702, 112, '2015-03-01 00:06:36.000000', 'temperatura', 45.0000, 'ºC'),
	(89703, 112, '2015-03-01 00:06:37.000000', 'temperatura', 308.0000, 'ºC'),
	(89704, 112, '2015-03-01 00:06:38.000000', 'temperatura', 203.0000, 'ºC'),
	(89705, 112, '2015-03-01 00:06:39.000000', 'temperatura', 94.0000, 'ºC'),
	(89706, 112, '2015-03-01 00:06:40.000000', 'temperatura', 1060.0000, 'ºC'),
	(89707, 112, '2015-03-01 00:06:41.000000', 'temperatura', 218.0000, 'ºC'),
	(89708, 112, '2015-03-01 00:06:42.000000', 'temperatura', 313.0000, 'ºC'),
	(89709, 112, '2015-03-01 00:06:43.000000', 'temperatura', 911.0000, 'ºC'),
	(89710, 112, '2015-03-01 00:06:44.000000', 'temperatura', 17.0000, 'ºC'),
	(89711, 112, '2015-03-01 00:06:45.000000', 'temperatura', 953.0000, 'ºC'),
	(89712, 112, '2015-03-01 00:06:46.000000', 'temperatura', 1112.0000, 'ºC'),
	(89713, 112, '2015-03-01 00:06:47.000000', 'temperatura', 303.0000, 'ºC'),
	(89714, 112, '2015-03-01 00:06:48.000000', 'temperatura', 580.0000, 'ºC'),
	(89715, 112, '2015-03-01 00:06:49.000000', 'temperatura', 789.0000, 'ºC'),
	(89716, 112, '2015-03-01 00:06:50.000000', 'temperatura', 1007.0000, 'ºC'),
	(89717, 112, '2015-03-01 00:06:51.000000', 'temperatura', 270.0000, 'ºC'),
	(89718, 112, '2015-03-01 00:06:52.000000', 'temperatura', 727.0000, 'ºC'),
	(89719, 112, '2015-03-01 00:06:53.000000', 'temperatura', 425.0000, 'ºC'),
	(89720, 112, '2015-03-01 00:06:54.000000', 'temperatura', 1145.0000, 'ºC'),
	(89721, 112, '2015-03-01 00:06:55.000000', 'temperatura', 851.0000, 'ºC'),
	(89722, 112, '2015-03-01 00:06:56.000000', 'temperatura', 821.0000, 'ºC'),
	(89723, 112, '2015-03-01 00:06:57.000000', 'temperatura', 353.0000, 'ºC'),
	(89724, 112, '2015-03-01 00:06:58.000000', 'temperatura', 504.0000, 'ºC'),
	(89725, 112, '2015-03-01 00:06:59.000000', 'temperatura', 258.0000, 'ºC'),
	(89726, 112, '2015-03-01 00:07:00.000000', 'temperatura', 979.0000, 'ºC'),
	(89727, 112, '2015-03-01 00:07:01.000000', 'temperatura', 524.0000, 'ºC'),
	(89728, 112, '2015-03-01 00:07:02.000000', 'temperatura', 880.0000, 'ºC'),
	(89729, 112, '2015-03-01 00:07:03.000000', 'temperatura', 432.0000, 'ºC'),
	(89730, 112, '2015-03-01 00:07:04.000000', 'temperatura', 717.0000, 'ºC'),
	(89731, 112, '2015-03-01 00:07:05.000000', 'temperatura', 1092.0000, 'ºC'),
	(89732, 112, '2015-03-01 00:07:06.000000', 'temperatura', 907.0000, 'ºC'),
	(89733, 112, '2015-03-01 00:07:07.000000', 'temperatura', 59.0000, 'ºC'),
	(89734, 112, '2015-03-01 00:07:08.000000', 'temperatura', 1178.0000, 'ºC'),
	(89735, 112, '2015-03-01 00:07:09.000000', 'temperatura', 910.0000, 'ºC'),
	(89736, 112, '2015-03-01 00:07:10.000000', 'temperatura', 1018.0000, 'ºC'),
	(89737, 112, '2015-03-01 00:07:11.000000', 'temperatura', 1159.0000, 'ºC'),
	(89738, 112, '2015-03-01 00:07:12.000000', 'temperatura', 341.0000, 'ºC'),
	(89739, 112, '2015-03-01 00:07:13.000000', 'temperatura', 628.0000, 'ºC'),
	(89740, 112, '2015-03-01 00:07:14.000000', 'temperatura', 919.0000, 'ºC'),
	(89741, 112, '2015-03-01 00:07:15.000000', 'temperatura', 311.0000, 'ºC'),
	(89742, 112, '2015-03-01 00:07:16.000000', 'temperatura', 0.0000, 'ºC'),
	(89743, 112, '2015-03-01 00:07:17.000000', 'temperatura', 265.0000, 'ºC'),
	(89744, 112, '2015-03-01 00:07:18.000000', 'temperatura', 128.0000, 'ºC'),
	(89745, 112, '2015-03-01 00:07:19.000000', 'temperatura', 1046.0000, 'ºC'),
	(89746, 112, '2015-03-01 00:07:20.000000', 'temperatura', 45.0000, 'ºC'),
	(89747, 112, '2015-03-01 00:07:21.000000', 'temperatura', 686.0000, 'ºC'),
	(89748, 112, '2015-03-01 00:07:22.000000', 'temperatura', 898.0000, 'ºC'),
	(89749, 112, '2015-03-01 00:07:23.000000', 'temperatura', 32.0000, 'ºC'),
	(89750, 112, '2015-03-01 00:07:24.000000', 'temperatura', 1065.0000, 'ºC'),
	(89751, 112, '2015-03-01 00:07:25.000000', 'temperatura', 429.0000, 'ºC'),
	(89752, 112, '2015-03-01 00:07:26.000000', 'temperatura', 153.0000, 'ºC'),
	(89753, 112, '2015-03-01 00:07:27.000000', 'temperatura', 679.0000, 'ºC'),
	(89754, 112, '2015-03-01 00:07:28.000000', 'temperatura', 538.0000, 'ºC'),
	(89755, 112, '2015-03-01 00:07:29.000000', 'temperatura', 650.0000, 'ºC'),
	(89756, 112, '2015-03-01 00:07:30.000000', 'temperatura', 436.0000, 'ºC'),
	(89757, 112, '2015-03-01 00:07:31.000000', 'temperatura', 232.0000, 'ºC'),
	(89758, 112, '2015-03-01 00:07:32.000000', 'temperatura', 1052.0000, 'ºC'),
	(89759, 112, '2015-03-01 00:07:33.000000', 'temperatura', 966.0000, 'ºC'),
	(89760, 112, '2015-03-01 00:07:34.000000', 'temperatura', 474.0000, 'ºC'),
	(89761, 112, '2015-03-01 00:07:35.000000', 'temperatura', 672.0000, 'ºC'),
	(89762, 112, '2015-03-01 00:07:36.000000', 'temperatura', 739.0000, 'ºC'),
	(89763, 112, '2015-03-01 00:07:37.000000', 'temperatura', 481.0000, 'ºC'),
	(89764, 112, '2015-03-01 00:07:38.000000', 'temperatura', 188.0000, 'ºC'),
	(89765, 112, '2015-03-01 00:07:39.000000', 'temperatura', 697.0000, 'ºC'),
	(89766, 112, '2015-03-01 00:07:40.000000', 'temperatura', 520.0000, 'ºC'),
	(89767, 112, '2015-03-01 00:07:41.000000', 'temperatura', 508.0000, 'ºC'),
	(89768, 112, '2015-03-01 00:07:42.000000', 'temperatura', 984.0000, 'ºC'),
	(89769, 112, '2015-03-01 00:07:43.000000', 'temperatura', 996.0000, 'ºC'),
	(89770, 112, '2015-03-01 00:07:44.000000', 'temperatura', 829.0000, 'ºC'),
	(89771, 112, '2015-03-01 00:07:45.000000', 'temperatura', 1158.0000, 'ºC'),
	(89772, 112, '2015-03-01 00:07:46.000000', 'temperatura', 902.0000, 'ºC'),
	(89773, 112, '2015-03-01 00:07:47.000000', 'temperatura', 1039.0000, 'ºC'),
	(89774, 112, '2015-03-01 00:07:48.000000', 'temperatura', 89.0000, 'ºC'),
	(89775, 112, '2015-03-01 00:07:49.000000', 'temperatura', 926.0000, 'ºC'),
	(89776, 112, '2015-03-01 00:07:50.000000', 'temperatura', 764.0000, 'ºC'),
	(89777, 112, '2015-03-01 00:07:51.000000', 'temperatura', 1044.0000, 'ºC'),
	(89778, 112, '2015-03-01 00:07:52.000000', 'temperatura', 529.0000, 'ºC'),
	(89779, 112, '2015-03-01 00:07:53.000000', 'temperatura', 715.0000, 'ºC'),
	(89780, 112, '2015-03-01 00:07:54.000000', 'temperatura', 786.0000, 'ºC'),
	(89781, 112, '2015-03-01 00:07:55.000000', 'temperatura', 587.0000, 'ºC'),
	(89782, 112, '2015-03-01 00:07:56.000000', 'temperatura', 577.0000, 'ºC'),
	(89783, 112, '2015-03-01 00:07:57.000000', 'temperatura', 1125.0000, 'ºC'),
	(89784, 112, '2015-03-01 00:07:58.000000', 'temperatura', 294.0000, 'ºC'),
	(89785, 112, '2015-03-01 00:07:59.000000', 'temperatura', 497.0000, 'ºC'),
	(89786, 112, '2015-03-01 00:08:00.000000', 'temperatura', 401.0000, 'ºC'),
	(89787, 112, '2015-03-01 00:08:01.000000', 'temperatura', 516.0000, 'ºC'),
	(89788, 112, '2015-03-01 00:08:02.000000', 'temperatura', 178.0000, 'ºC'),
	(89789, 112, '2015-03-01 00:08:03.000000', 'temperatura', 542.0000, 'ºC'),
	(89790, 112, '2015-03-01 00:08:04.000000', 'temperatura', 976.0000, 'ºC'),
	(89791, 112, '2015-03-01 00:08:05.000000', 'temperatura', 854.0000, 'ºC'),
	(89792, 112, '2015-03-01 00:08:06.000000', 'temperatura', 144.0000, 'ºC'),
	(89793, 112, '2015-03-01 00:08:07.000000', 'temperatura', 558.0000, 'ºC'),
	(89794, 112, '2015-03-01 00:08:08.000000', 'temperatura', 1160.0000, 'ºC'),
	(89795, 112, '2015-03-01 00:08:09.000000', 'temperatura', 525.0000, 'ºC'),
	(89796, 112, '2015-03-01 00:08:10.000000', 'temperatura', 347.0000, 'ºC'),
	(89797, 112, '2015-03-01 00:08:11.000000', 'temperatura', 162.0000, 'ºC'),
	(89798, 112, '2015-03-01 00:08:12.000000', 'temperatura', 966.0000, 'ºC'),
	(89799, 112, '2015-03-01 00:08:13.000000', 'temperatura', 745.0000, 'ºC'),
	(89800, 112, '2015-03-01 00:08:14.000000', 'temperatura', 827.0000, 'ºC'),
	(89801, 112, '2015-03-01 00:08:15.000000', 'temperatura', 701.0000, 'ºC'),
	(89802, 112, '2015-03-01 00:08:16.000000', 'temperatura', 1024.0000, 'ºC'),
	(89803, 112, '2015-03-01 00:08:17.000000', 'temperatura', 620.0000, 'ºC'),
	(89804, 112, '2015-03-01 00:08:18.000000', 'temperatura', 27.0000, 'ºC'),
	(89805, 112, '2015-03-01 00:08:19.000000', 'temperatura', 676.0000, 'ºC'),
	(89806, 112, '2015-03-01 00:08:20.000000', 'temperatura', 899.0000, 'ºC'),
	(89807, 112, '2015-03-01 00:08:21.000000', 'temperatura', 68.0000, 'ºC'),
	(89808, 112, '2015-03-01 00:08:22.000000', 'temperatura', 41.0000, 'ºC'),
	(89809, 112, '2015-03-01 00:08:23.000000', 'temperatura', 5.0000, 'ºC'),
	(89810, 112, '2015-03-01 00:08:24.000000', 'temperatura', 1102.0000, 'ºC'),
	(89811, 112, '2015-03-01 00:08:25.000000', 'temperatura', 695.0000, 'ºC'),
	(89812, 112, '2015-03-01 00:08:26.000000', 'temperatura', 170.0000, 'ºC'),
	(89813, 112, '2015-03-01 00:08:27.000000', 'temperatura', 1164.0000, 'ºC'),
	(89814, 112, '2015-03-01 00:08:28.000000', 'temperatura', 511.0000, 'ºC'),
	(89815, 112, '2015-03-01 00:08:29.000000', 'temperatura', 265.0000, 'ºC'),
	(89816, 112, '2015-03-01 00:08:30.000000', 'temperatura', 993.0000, 'ºC'),
	(89817, 112, '2015-03-01 00:08:31.000000', 'temperatura', 569.0000, 'ºC'),
	(89818, 112, '2015-03-01 00:08:32.000000', 'temperatura', 1069.0000, 'ºC'),
	(89819, 112, '2015-03-01 00:08:33.000000', 'temperatura', 37.0000, 'ºC'),
	(89820, 112, '2015-03-01 00:08:34.000000', 'temperatura', 577.0000, 'ºC'),
	(89821, 112, '2015-03-01 00:08:35.000000', 'temperatura', 374.0000, 'ºC'),
	(89822, 112, '2015-03-01 00:08:36.000000', 'temperatura', 141.0000, 'ºC'),
	(89823, 112, '2015-03-01 00:08:37.000000', 'temperatura', 785.0000, 'ºC'),
	(89824, 112, '2015-03-01 00:08:38.000000', 'temperatura', 1101.0000, 'ºC'),
	(89825, 112, '2015-03-01 00:08:39.000000', 'temperatura', 751.0000, 'ºC'),
	(89826, 112, '2015-03-01 00:08:40.000000', 'temperatura', 453.0000, 'ºC'),
	(89827, 112, '2015-03-01 00:08:41.000000', 'temperatura', 14.0000, 'ºC'),
	(89828, 112, '2015-03-01 00:08:42.000000', 'temperatura', 1109.0000, 'ºC'),
	(89829, 112, '2015-03-01 00:08:43.000000', 'temperatura', 702.0000, 'ºC'),
	(89830, 112, '2015-03-01 00:08:44.000000', 'temperatura', 187.0000, 'ºC'),
	(89831, 112, '2015-03-01 00:08:45.000000', 'temperatura', 28.0000, 'ºC'),
	(89832, 112, '2015-03-01 00:08:46.000000', 'temperatura', 778.0000, 'ºC'),
	(89833, 112, '2015-03-01 00:08:47.000000', 'temperatura', 207.0000, 'ºC'),
	(89834, 112, '2015-03-01 00:08:48.000000', 'temperatura', 1101.0000, 'ºC'),
	(89835, 112, '2015-03-01 00:08:49.000000', 'temperatura', 86.0000, 'ºC'),
	(89836, 112, '2015-03-01 00:08:50.000000', 'temperatura', 726.0000, 'ºC'),
	(89837, 112, '2015-03-01 00:08:51.000000', 'temperatura', 974.0000, 'ºC'),
	(89838, 112, '2015-03-01 00:08:52.000000', 'temperatura', 291.0000, 'ºC'),
	(89839, 112, '2015-03-01 00:08:53.000000', 'temperatura', 934.0000, 'ºC'),
	(89840, 112, '2015-03-01 00:08:54.000000', 'temperatura', 196.0000, 'ºC'),
	(89841, 112, '2015-03-01 00:08:55.000000', 'temperatura', 578.0000, 'ºC'),
	(89842, 112, '2015-03-01 00:08:56.000000', 'temperatura', 1103.0000, 'ºC'),
	(89843, 112, '2015-03-01 00:08:57.000000', 'temperatura', 182.0000, 'ºC'),
	(89844, 112, '2015-03-01 00:08:58.000000', 'temperatura', 3.0000, 'ºC'),
	(89845, 112, '2015-03-01 00:08:59.000000', 'temperatura', 670.0000, 'ºC'),
	(89846, 112, '2015-03-01 00:09:00.000000', 'temperatura', 938.0000, 'ºC'),
	(89847, 112, '2015-03-01 00:09:01.000000', 'temperatura', 283.0000, 'ºC'),
	(89848, 112, '2015-03-01 00:09:02.000000', 'temperatura', 1002.0000, 'ºC'),
	(89849, 112, '2015-03-01 00:09:03.000000', 'temperatura', 563.0000, 'ºC'),
	(89850, 112, '2015-03-01 00:09:04.000000', 'temperatura', 1007.0000, 'ºC'),
	(89851, 112, '2015-03-01 00:09:05.000000', 'temperatura', 946.0000, 'ºC'),
	(89852, 112, '2015-03-01 00:09:06.000000', 'temperatura', 510.0000, 'ºC'),
	(89853, 112, '2015-03-01 00:09:07.000000', 'temperatura', 912.0000, 'ºC'),
	(89854, 112, '2015-03-01 00:09:08.000000', 'temperatura', 630.0000, 'ºC'),
	(89855, 112, '2015-03-01 00:09:09.000000', 'temperatura', 416.0000, 'ºC'),
	(89856, 112, '2015-03-01 00:09:10.000000', 'temperatura', 188.0000, 'ºC'),
	(89857, 112, '2015-03-01 00:09:11.000000', 'temperatura', 894.0000, 'ºC'),
	(89858, 112, '2015-03-01 00:09:12.000000', 'temperatura', 305.0000, 'ºC'),
	(89859, 112, '2015-03-01 00:09:13.000000', 'temperatura', 43.0000, 'ºC'),
	(89860, 112, '2015-03-01 00:09:14.000000', 'temperatura', 500.0000, 'ºC'),
	(89861, 112, '2015-03-01 00:09:15.000000', 'temperatura', 1171.0000, 'ºC'),
	(89862, 112, '2015-03-01 00:09:16.000000', 'temperatura', 757.0000, 'ºC'),
	(89863, 112, '2015-03-01 00:09:17.000000', 'temperatura', 274.0000, 'ºC'),
	(89864, 112, '2015-03-01 00:09:18.000000', 'temperatura', 298.0000, 'ºC'),
	(89865, 112, '2015-03-01 00:09:19.000000', 'temperatura', 667.0000, 'ºC'),
	(89866, 112, '2015-03-01 00:09:20.000000', 'temperatura', 45.0000, 'ºC'),
	(89867, 112, '2015-03-01 00:09:21.000000', 'temperatura', 621.0000, 'ºC'),
	(89868, 112, '2015-03-01 00:09:22.000000', 'temperatura', 572.0000, 'ºC'),
	(89869, 112, '2015-03-01 00:09:23.000000', 'temperatura', 996.0000, 'ºC'),
	(89870, 112, '2015-03-01 00:09:24.000000', 'temperatura', 863.0000, 'ºC'),
	(89871, 112, '2015-03-01 00:09:25.000000', 'temperatura', 131.0000, 'ºC'),
	(89872, 112, '2015-03-01 00:09:26.000000', 'temperatura', 463.0000, 'ºC'),
	(89873, 112, '2015-03-01 00:09:27.000000', 'temperatura', 725.0000, 'ºC'),
	(89874, 112, '2015-03-01 00:09:28.000000', 'temperatura', 1036.0000, 'ºC'),
	(89875, 112, '2015-03-01 00:09:29.000000', 'temperatura', 607.0000, 'ºC'),
	(89876, 112, '2015-03-01 00:09:30.000000', 'temperatura', 1125.0000, 'ºC'),
	(89877, 112, '2015-03-01 00:09:31.000000', 'temperatura', 204.0000, 'ºC'),
	(89878, 112, '2015-03-01 00:09:32.000000', 'temperatura', 48.0000, 'ºC'),
	(89879, 112, '2015-03-01 00:09:33.000000', 'temperatura', 827.0000, 'ºC'),
	(89880, 112, '2015-03-01 00:09:34.000000', 'temperatura', 391.0000, 'ºC'),
	(89881, 112, '2015-03-01 00:09:35.000000', 'temperatura', 676.0000, 'ºC'),
	(89882, 112, '2015-03-01 00:09:36.000000', 'temperatura', 1008.0000, 'ºC'),
	(89883, 112, '2015-03-01 00:09:37.000000', 'temperatura', 611.0000, 'ºC'),
	(89884, 112, '2015-03-01 00:09:38.000000', 'temperatura', 32.0000, 'ºC'),
	(89885, 112, '2015-03-01 00:09:39.000000', 'temperatura', 726.0000, 'ºC'),
	(89886, 112, '2015-03-01 00:09:40.000000', 'temperatura', 1135.0000, 'ºC'),
	(89887, 112, '2015-03-01 00:09:41.000000', 'temperatura', 1097.0000, 'ºC'),
	(89888, 112, '2015-03-01 00:09:42.000000', 'temperatura', 881.0000, 'ºC'),
	(89889, 112, '2015-03-01 00:09:43.000000', 'temperatura', 1115.0000, 'ºC'),
	(89890, 112, '2015-03-01 00:09:44.000000', 'temperatura', 534.0000, 'ºC'),
	(89891, 112, '2015-03-01 00:09:45.000000', 'temperatura', 525.0000, 'ºC'),
	(89892, 112, '2015-03-01 00:09:46.000000', 'temperatura', 1022.0000, 'ºC'),
	(89893, 112, '2015-03-01 00:09:47.000000', 'temperatura', 1136.0000, 'ºC'),
	(89894, 112, '2015-03-01 00:09:48.000000', 'temperatura', 216.0000, 'ºC'),
	(89895, 112, '2015-03-01 00:09:49.000000', 'temperatura', 70.0000, 'ºC'),
	(89896, 112, '2015-03-01 00:09:50.000000', 'temperatura', 903.0000, 'ºC'),
	(89897, 112, '2015-03-01 00:09:51.000000', 'temperatura', 707.0000, 'ºC'),
	(89898, 112, '2015-03-01 00:09:52.000000', 'temperatura', 825.0000, 'ºC'),
	(89899, 112, '2015-03-01 00:09:53.000000', 'temperatura', 803.0000, 'ºC'),
	(89900, 112, '2015-03-01 00:09:54.000000', 'temperatura', 342.0000, 'ºC'),
	(89901, 112, '2015-03-01 00:09:55.000000', 'temperatura', 502.0000, 'ºC'),
	(89902, 112, '2015-03-01 00:09:56.000000', 'temperatura', 283.0000, 'ºC'),
	(89903, 112, '2015-03-01 00:09:57.000000', 'temperatura', 1111.0000, 'ºC'),
	(89904, 112, '2015-03-01 00:09:58.000000', 'temperatura', 1106.0000, 'ºC'),
	(89905, 112, '2015-03-01 00:09:59.000000', 'temperatura', 999.0000, 'ºC'),
	(89906, 112, '2015-03-01 00:10:00.000000', 'temperatura', 476.0000, 'ºC'),
	(89907, 112, '2015-03-01 00:10:01.000000', 'temperatura', 582.0000, 'ºC'),
	(89908, 112, '2015-03-01 00:10:02.000000', 'temperatura', 285.0000, 'ºC'),
	(89909, 112, '2015-03-01 00:10:03.000000', 'temperatura', 878.0000, 'ºC'),
	(89910, 112, '2015-03-01 00:10:04.000000', 'temperatura', 1135.0000, 'ºC'),
	(89911, 112, '2015-03-01 00:10:05.000000', 'temperatura', 643.0000, 'ºC'),
	(89912, 112, '2015-03-01 00:10:06.000000', 'temperatura', 1011.0000, 'ºC'),
	(89913, 112, '2015-03-01 00:10:07.000000', 'temperatura', 725.0000, 'ºC'),
	(89914, 112, '2015-03-01 00:10:08.000000', 'temperatura', 594.0000, 'ºC'),
	(89915, 112, '2015-03-01 00:10:09.000000', 'temperatura', 794.0000, 'ºC'),
	(89916, 112, '2015-03-01 00:10:10.000000', 'temperatura', 990.0000, 'ºC'),
	(89917, 112, '2015-03-01 00:10:11.000000', 'temperatura', 166.0000, 'ºC'),
	(89918, 112, '2015-03-01 00:10:12.000000', 'temperatura', 264.0000, 'ºC'),
	(89919, 112, '2015-03-01 00:10:13.000000', 'temperatura', 819.0000, 'ºC'),
	(89920, 112, '2015-03-01 00:10:14.000000', 'temperatura', 907.0000, 'ºC'),
	(89921, 112, '2015-03-01 00:10:15.000000', 'temperatura', 875.0000, 'ºC'),
	(89922, 112, '2015-03-01 00:10:16.000000', 'temperatura', 457.0000, 'ºC'),
	(89923, 112, '2015-03-01 00:10:17.000000', 'temperatura', 860.0000, 'ºC'),
	(89924, 112, '2015-03-01 00:10:18.000000', 'temperatura', 528.0000, 'ºC'),
	(89925, 112, '2015-03-01 00:10:19.000000', 'temperatura', 63.0000, 'ºC'),
	(89926, 112, '2015-03-01 00:10:20.000000', 'temperatura', 1130.0000, 'ºC'),
	(89927, 112, '2015-03-01 00:10:21.000000', 'temperatura', 663.0000, 'ºC'),
	(89928, 112, '2015-03-01 00:10:22.000000', 'temperatura', 1123.0000, 'ºC'),
	(89929, 112, '2015-03-01 00:10:23.000000', 'temperatura', 27.0000, 'ºC'),
	(89930, 112, '2015-03-01 00:10:24.000000', 'temperatura', 368.0000, 'ºC'),
	(89931, 112, '2015-03-01 00:10:25.000000', 'temperatura', 558.0000, 'ºC'),
	(89932, 112, '2015-03-01 00:10:26.000000', 'temperatura', 489.0000, 'ºC'),
	(89933, 112, '2015-03-01 00:10:27.000000', 'temperatura', 770.0000, 'ºC'),
	(89934, 112, '2015-03-01 00:10:28.000000', 'temperatura', 1182.0000, 'ºC'),
	(89935, 112, '2015-03-01 00:10:29.000000', 'temperatura', 2.0000, 'ºC'),
	(89936, 112, '2015-03-01 00:10:30.000000', 'temperatura', 64.0000, 'ºC'),
	(89937, 112, '2015-03-01 00:10:31.000000', 'temperatura', 315.0000, 'ºC'),
	(89938, 112, '2015-03-01 00:10:32.000000', 'temperatura', 185.0000, 'ºC'),
	(89939, 112, '2015-03-01 00:10:33.000000', 'temperatura', 1180.0000, 'ºC'),
	(89940, 112, '2015-03-01 00:10:34.000000', 'temperatura', 545.0000, 'ºC'),
	(89941, 112, '2015-03-01 00:10:35.000000', 'temperatura', 386.0000, 'ºC'),
	(89942, 112, '2015-03-01 00:10:36.000000', 'temperatura', 293.0000, 'ºC'),
	(89943, 112, '2015-03-01 00:10:37.000000', 'temperatura', 309.0000, 'ºC'),
	(89944, 112, '2015-03-01 00:10:38.000000', 'temperatura', 668.0000, 'ºC'),
	(89945, 112, '2015-03-01 00:10:39.000000', 'temperatura', 13.0000, 'ºC'),
	(89946, 112, '2015-03-01 00:10:40.000000', 'temperatura', 460.0000, 'ºC'),
	(89947, 112, '2015-03-01 00:10:41.000000', 'temperatura', 1062.0000, 'ºC'),
	(89948, 112, '2015-03-01 00:10:42.000000', 'temperatura', 330.0000, 'ºC'),
	(89949, 112, '2015-03-01 00:10:43.000000', 'temperatura', 865.0000, 'ºC'),
	(89950, 112, '2015-03-01 00:10:44.000000', 'temperatura', 936.0000, 'ºC'),
	(89951, 112, '2015-03-01 00:10:45.000000', 'temperatura', 885.0000, 'ºC'),
	(89952, 112, '2015-03-01 00:10:46.000000', 'temperatura', 419.0000, 'ºC'),
	(89953, 112, '2015-03-01 00:10:47.000000', 'temperatura', 642.0000, 'ºC'),
	(89954, 112, '2015-03-01 00:10:48.000000', 'temperatura', 750.0000, 'ºC'),
	(89955, 112, '2015-03-01 00:10:49.000000', 'temperatura', 627.0000, 'ºC'),
	(89956, 112, '2015-03-01 00:10:50.000000', 'temperatura', 883.0000, 'ºC'),
	(89957, 112, '2015-03-01 00:10:51.000000', 'temperatura', 136.0000, 'ºC'),
	(89958, 112, '2015-03-01 00:10:52.000000', 'temperatura', 430.0000, 'ºC'),
	(89959, 112, '2015-03-01 00:10:53.000000', 'temperatura', 545.0000, 'ºC'),
	(89960, 112, '2015-03-01 00:10:54.000000', 'temperatura', 236.0000, 'ºC'),
	(89961, 112, '2015-03-01 00:10:55.000000', 'temperatura', 743.0000, 'ºC'),
	(89962, 112, '2015-03-01 00:10:56.000000', 'temperatura', 607.0000, 'ºC'),
	(89963, 112, '2015-03-01 00:10:57.000000', 'temperatura', 807.0000, 'ºC'),
	(89964, 112, '2015-03-01 00:10:58.000000', 'temperatura', 1014.0000, 'ºC'),
	(89965, 112, '2015-03-01 00:10:59.000000', 'temperatura', 250.0000, 'ºC'),
	(89966, 112, '2015-03-01 00:11:00.000000', 'temperatura', 610.0000, 'ºC'),
	(89967, 112, '2015-03-01 00:11:01.000000', 'temperatura', 1101.0000, 'ºC'),
	(89968, 112, '2015-03-01 00:11:02.000000', 'temperatura', 73.0000, 'ºC'),
	(89969, 112, '2015-03-01 00:11:03.000000', 'temperatura', 665.0000, 'ºC'),
	(89970, 112, '2015-03-01 00:11:04.000000', 'temperatura', 706.0000, 'ºC'),
	(89971, 112, '2015-03-01 00:11:05.000000', 'temperatura', 336.0000, 'ºC'),
	(89972, 112, '2015-03-01 00:11:06.000000', 'temperatura', 764.0000, 'ºC'),
	(89973, 112, '2015-03-01 00:11:07.000000', 'temperatura', 410.0000, 'ºC'),
	(89974, 112, '2015-03-01 00:11:08.000000', 'temperatura', 958.0000, 'ºC'),
	(89975, 112, '2015-03-01 00:11:09.000000', 'temperatura', 1160.0000, 'ºC'),
	(89976, 112, '2015-03-01 00:11:10.000000', 'temperatura', 527.0000, 'ºC'),
	(89977, 112, '2015-03-01 00:11:11.000000', 'temperatura', 357.0000, 'ºC'),
	(89978, 112, '2015-03-01 00:11:12.000000', 'temperatura', 203.0000, 'ºC'),
	(89979, 112, '2015-03-01 00:11:13.000000', 'temperatura', 1146.0000, 'ºC'),
	(89980, 112, '2015-03-01 00:11:14.000000', 'temperatura', 321.0000, 'ºC'),
	(89981, 112, '2015-03-01 00:11:15.000000', 'temperatura', 567.0000, 'ºC'),
	(89982, 112, '2015-03-01 00:11:16.000000', 'temperatura', 672.0000, 'ºC'),
	(89983, 112, '2015-03-01 00:11:17.000000', 'temperatura', 459.0000, 'ºC'),
	(89984, 112, '2015-03-01 00:11:18.000000', 'temperatura', 281.0000, 'ºC'),
	(89985, 112, '2015-03-01 00:11:19.000000', 'temperatura', 29.0000, 'ºC'),
	(89986, 112, '2015-03-01 00:11:20.000000', 'temperatura', 501.0000, 'ºC'),
	(89987, 112, '2015-03-01 00:11:21.000000', 'temperatura', 18.0000, 'ºC'),
	(89988, 112, '2015-03-01 00:11:22.000000', 'temperatura', 989.0000, 'ºC'),
	(89989, 112, '2015-03-01 00:11:23.000000', 'temperatura', 90.0000, 'ºC'),
	(89990, 112, '2015-03-01 00:11:24.000000', 'temperatura', 1084.0000, 'ºC'),
	(89991, 112, '2015-03-01 00:11:25.000000', 'temperatura', 350.0000, 'ºC'),
	(89992, 112, '2015-03-01 00:11:26.000000', 'temperatura', 900.0000, 'ºC'),
	(89993, 112, '2015-03-01 00:11:27.000000', 'temperatura', 1050.0000, 'ºC'),
	(89994, 112, '2015-03-01 00:11:28.000000', 'temperatura', 151.0000, 'ºC'),
	(89995, 112, '2015-03-01 00:11:29.000000', 'temperatura', 5.0000, 'ºC'),
	(89996, 112, '2015-03-01 00:11:30.000000', 'temperatura', 773.0000, 'ºC'),
	(89997, 112, '2015-03-01 00:11:31.000000', 'temperatura', 250.0000, 'ºC'),
	(89998, 112, '2015-03-01 00:11:32.000000', 'temperatura', 130.0000, 'ºC'),
	(89999, 112, '2015-03-01 00:11:33.000000', 'temperatura', 1102.0000, 'ºC'),
	(90000, 112, '2015-03-01 00:11:34.000000', 'temperatura', 319.0000, 'ºC'),
	(90001, 112, '2015-03-01 00:11:35.000000', 'temperatura', 692.0000, 'ºC'),
	(90002, 112, '2015-03-01 00:11:36.000000', 'temperatura', 102.0000, 'ºC'),
	(90003, 112, '2015-03-01 00:11:37.000000', 'temperatura', 837.0000, 'ºC'),
	(90004, 112, '2015-03-01 00:11:38.000000', 'temperatura', 277.0000, 'ºC'),
	(90005, 112, '2015-03-01 00:11:39.000000', 'temperatura', 75.0000, 'ºC'),
	(90006, 112, '2015-03-01 00:11:40.000000', 'temperatura', 743.0000, 'ºC'),
	(90007, 112, '2015-03-01 00:11:41.000000', 'temperatura', 1093.0000, 'ºC'),
	(90008, 112, '2015-03-01 00:11:42.000000', 'temperatura', 835.0000, 'ºC'),
	(90009, 112, '2015-03-01 00:11:43.000000', 'temperatura', 896.0000, 'ºC'),
	(90010, 112, '2015-03-01 00:11:44.000000', 'temperatura', 777.0000, 'ºC'),
	(90011, 112, '2015-03-01 00:11:45.000000', 'temperatura', 1196.0000, 'ºC'),
	(90012, 112, '2015-03-01 00:11:46.000000', 'temperatura', 49.0000, 'ºC'),
	(90013, 112, '2015-03-01 00:11:47.000000', 'temperatura', 259.0000, 'ºC'),
	(90014, 112, '2015-03-01 00:11:48.000000', 'temperatura', 1147.0000, 'ºC'),
	(90015, 112, '2015-03-01 00:11:49.000000', 'temperatura', 160.0000, 'ºC'),
	(90016, 112, '2015-03-01 00:11:50.000000', 'temperatura', 959.0000, 'ºC'),
	(90017, 112, '2015-03-01 00:11:51.000000', 'temperatura', 715.0000, 'ºC'),
	(90018, 112, '2015-03-01 00:11:52.000000', 'temperatura', 700.0000, 'ºC'),
	(90019, 112, '2015-03-01 00:11:53.000000', 'temperatura', 154.0000, 'ºC'),
	(90020, 112, '2015-03-01 00:11:54.000000', 'temperatura', 1071.0000, 'ºC'),
	(90021, 112, '2015-03-01 00:11:55.000000', 'temperatura', 93.0000, 'ºC'),
	(90022, 112, '2015-03-01 00:11:56.000000', 'temperatura', 851.0000, 'ºC'),
	(90023, 112, '2015-03-01 00:11:57.000000', 'temperatura', 378.0000, 'ºC'),
	(90024, 112, '2015-03-01 00:11:58.000000', 'temperatura', 537.0000, 'ºC'),
	(90025, 112, '2015-03-01 00:11:59.000000', 'temperatura', 351.0000, 'ºC'),
	(90026, 112, '2015-03-01 00:12:00.000000', 'temperatura', 144.0000, 'ºC'),
	(90027, 112, '2015-03-01 00:12:01.000000', 'temperatura', 869.0000, 'ºC'),
	(90028, 112, '2015-03-01 00:12:02.000000', 'temperatura', 312.0000, 'ºC'),
	(90029, 112, '2015-03-01 00:12:03.000000', 'temperatura', 155.0000, 'ºC'),
	(90030, 112, '2015-03-01 00:12:04.000000', 'temperatura', 1040.0000, 'ºC'),
	(90031, 112, '2015-03-01 00:12:05.000000', 'temperatura', 1135.0000, 'ºC'),
	(90032, 112, '2015-03-01 00:12:06.000000', 'temperatura', 155.0000, 'ºC'),
	(90033, 112, '2015-03-01 00:12:07.000000', 'temperatura', 971.0000, 'ºC'),
	(90034, 112, '2015-03-01 00:12:08.000000', 'temperatura', 790.0000, 'ºC'),
	(90035, 112, '2015-03-01 00:12:09.000000', 'temperatura', 1036.0000, 'ºC'),
	(90036, 112, '2015-03-01 00:12:10.000000', 'temperatura', 413.0000, 'ºC'),
	(90037, 112, '2015-03-01 00:12:11.000000', 'temperatura', 157.0000, 'ºC'),
	(90038, 112, '2015-03-01 00:12:12.000000', 'temperatura', 747.0000, 'ºC'),
	(90039, 112, '2015-03-01 00:12:13.000000', 'temperatura', 863.0000, 'ºC'),
	(90040, 112, '2015-03-01 00:12:14.000000', 'temperatura', 874.0000, 'ºC'),
	(90041, 112, '2015-03-01 00:12:15.000000', 'temperatura', 582.0000, 'ºC'),
	(90042, 112, '2015-03-01 00:12:16.000000', 'temperatura', 287.0000, 'ºC'),
	(90043, 112, '2015-03-01 00:12:17.000000', 'temperatura', 892.0000, 'ºC'),
	(90044, 112, '2015-03-01 00:12:18.000000', 'temperatura', 1198.0000, 'ºC'),
	(90045, 112, '2015-03-01 00:12:19.000000', 'temperatura', 917.0000, 'ºC'),
	(90046, 112, '2015-03-01 00:12:20.000000', 'temperatura', 989.0000, 'ºC'),
	(90047, 112, '2015-03-01 00:12:21.000000', 'temperatura', 997.0000, 'ºC'),
	(90048, 112, '2015-03-01 00:12:22.000000', 'temperatura', 817.0000, 'ºC'),
	(90049, 112, '2015-03-01 00:12:23.000000', 'temperatura', 1093.0000, 'ºC'),
	(90050, 112, '2015-03-01 00:12:24.000000', 'temperatura', 615.0000, 'ºC'),
	(90051, 112, '2015-03-01 00:12:25.000000', 'temperatura', 997.0000, 'ºC'),
	(90052, 112, '2015-03-01 00:12:26.000000', 'temperatura', 742.0000, 'ºC'),
	(90053, 112, '2015-03-01 00:12:27.000000', 'temperatura', 719.0000, 'ºC'),
	(90054, 112, '2015-03-01 00:12:28.000000', 'temperatura', 170.0000, 'ºC'),
	(90055, 112, '2015-03-01 00:12:29.000000', 'temperatura', 1093.0000, 'ºC'),
	(90056, 112, '2015-03-01 00:12:30.000000', 'temperatura', 154.0000, 'ºC'),
	(90057, 112, '2015-03-01 00:12:31.000000', 'temperatura', 1091.0000, 'ºC'),
	(90058, 112, '2015-03-01 00:12:32.000000', 'temperatura', 197.0000, 'ºC'),
	(90059, 112, '2015-03-01 00:12:33.000000', 'temperatura', 109.0000, 'ºC'),
	(90060, 112, '2015-03-01 00:12:34.000000', 'temperatura', 1156.0000, 'ºC'),
	(90061, 112, '2015-03-01 00:12:35.000000', 'temperatura', 653.0000, 'ºC'),
	(90062, 112, '2015-03-01 00:12:36.000000', 'temperatura', 999.0000, 'ºC'),
	(90063, 112, '2015-03-01 00:12:37.000000', 'temperatura', 635.0000, 'ºC'),
	(90064, 112, '2015-03-01 00:12:38.000000', 'temperatura', 180.0000, 'ºC'),
	(90065, 112, '2015-03-01 00:12:39.000000', 'temperatura', 195.0000, 'ºC'),
	(90066, 112, '2015-03-01 00:12:40.000000', 'temperatura', 436.0000, 'ºC'),
	(90067, 112, '2015-03-01 00:12:41.000000', 'temperatura', 394.0000, 'ºC'),
	(90068, 112, '2015-03-01 00:12:42.000000', 'temperatura', 661.0000, 'ºC'),
	(90069, 112, '2015-03-01 00:12:43.000000', 'temperatura', 925.0000, 'ºC'),
	(90070, 112, '2015-03-01 00:12:44.000000', 'temperatura', 245.0000, 'ºC'),
	(90071, 112, '2015-03-01 00:12:45.000000', 'temperatura', 847.0000, 'ºC'),
	(90072, 112, '2015-03-01 00:12:46.000000', 'temperatura', 1103.0000, 'ºC'),
	(90073, 112, '2015-03-01 00:12:47.000000', 'temperatura', 575.0000, 'ºC'),
	(90074, 112, '2015-03-01 00:12:48.000000', 'temperatura', 764.0000, 'ºC'),
	(90075, 112, '2015-03-01 00:12:49.000000', 'temperatura', 895.0000, 'ºC'),
	(90076, 112, '2015-03-01 00:12:50.000000', 'temperatura', 983.0000, 'ºC'),
	(90077, 112, '2015-03-01 00:12:51.000000', 'temperatura', 1032.0000, 'ºC'),
	(90078, 112, '2015-03-01 00:12:52.000000', 'temperatura', 1012.0000, 'ºC'),
	(90079, 112, '2015-03-01 00:12:53.000000', 'temperatura', 762.0000, 'ºC'),
	(90080, 112, '2015-03-01 00:12:54.000000', 'temperatura', 778.0000, 'ºC'),
	(90081, 112, '2015-03-01 00:12:55.000000', 'temperatura', 403.0000, 'ºC'),
	(90082, 112, '2015-03-01 00:12:56.000000', 'temperatura', 881.0000, 'ºC'),
	(90083, 112, '2015-03-01 00:12:57.000000', 'temperatura', 797.0000, 'ºC'),
	(90084, 112, '2015-03-01 00:12:58.000000', 'temperatura', 141.0000, 'ºC'),
	(90085, 112, '2015-03-01 00:12:59.000000', 'temperatura', 717.0000, 'ºC'),
	(90086, 112, '2015-03-01 00:13:00.000000', 'temperatura', 760.0000, 'ºC'),
	(90087, 112, '2015-03-01 00:13:01.000000', 'temperatura', 449.0000, 'ºC'),
	(90088, 112, '2015-03-01 00:13:02.000000', 'temperatura', 1167.0000, 'ºC'),
	(90089, 112, '2015-03-01 00:13:03.000000', 'temperatura', 888.0000, 'ºC'),
	(90090, 112, '2015-03-01 00:13:04.000000', 'temperatura', 939.0000, 'ºC'),
	(90091, 112, '2015-03-01 00:13:05.000000', 'temperatura', 833.0000, 'ºC'),
	(90092, 112, '2015-03-01 00:13:06.000000', 'temperatura', 148.0000, 'ºC'),
	(90093, 112, '2015-03-01 00:13:07.000000', 'temperatura', 641.0000, 'ºC'),
	(90094, 112, '2015-03-01 00:13:08.000000', 'temperatura', 363.0000, 'ºC'),
	(90095, 112, '2015-03-01 00:13:09.000000', 'temperatura', 1091.0000, 'ºC'),
	(90096, 112, '2015-03-01 00:13:10.000000', 'temperatura', 767.0000, 'ºC'),
	(90097, 112, '2015-03-01 00:13:11.000000', 'temperatura', 562.0000, 'ºC'),
	(90098, 112, '2015-03-01 00:13:12.000000', 'temperatura', 511.0000, 'ºC'),
	(90099, 112, '2015-03-01 00:13:13.000000', 'temperatura', 867.0000, 'ºC'),
	(90100, 112, '2015-03-01 00:13:14.000000', 'temperatura', 406.0000, 'ºC'),
	(90101, 112, '2015-03-01 00:13:15.000000', 'temperatura', 626.0000, 'ºC'),
	(90102, 112, '2015-03-01 00:13:16.000000', 'temperatura', 715.0000, 'ºC'),
	(90103, 112, '2015-03-01 00:13:17.000000', 'temperatura', 496.0000, 'ºC'),
	(90104, 112, '2015-03-01 00:13:18.000000', 'temperatura', 334.0000, 'ºC'),
	(90105, 112, '2015-03-01 00:13:19.000000', 'temperatura', 183.0000, 'ºC'),
	(90106, 112, '2015-03-01 00:13:20.000000', 'temperatura', 1115.0000, 'ºC'),
	(90107, 112, '2015-03-01 00:13:21.000000', 'temperatura', 225.0000, 'ºC'),
	(90108, 112, '2015-03-01 00:13:22.000000', 'temperatura', 181.0000, 'ºC'),
	(90109, 112, '2015-03-01 00:13:23.000000', 'temperatura', 232.0000, 'ºC'),
	(90110, 112, '2015-03-01 00:13:24.000000', 'temperatura', 614.0000, 'ºC'),
	(90111, 112, '2015-03-01 00:13:25.000000', 'temperatura', 1178.0000, 'ºC'),
	(90112, 112, '2015-03-01 00:13:26.000000', 'temperatura', 448.0000, 'ºC'),
	(90113, 112, '2015-03-01 00:13:27.000000', 'temperatura', 1106.0000, 'ºC'),
	(90114, 112, '2015-03-01 00:13:28.000000', 'temperatura', 588.0000, 'ºC'),
	(90115, 112, '2015-03-01 00:13:29.000000', 'temperatura', 823.0000, 'ºC'),
	(90116, 112, '2015-03-01 00:13:30.000000', 'temperatura', 1150.0000, 'ºC'),
	(90117, 112, '2015-03-01 00:13:31.000000', 'temperatura', 880.0000, 'ºC'),
	(90118, 112, '2015-03-01 00:13:32.000000', 'temperatura', 954.0000, 'ºC'),
	(90119, 112, '2015-03-01 00:13:33.000000', 'temperatura', 927.0000, 'ºC'),
	(90120, 112, '2015-03-01 00:13:34.000000', 'temperatura', 576.0000, 'ºC'),
	(90121, 112, '2015-03-01 00:13:35.000000', 'temperatura', 100.0000, 'ºC'),
	(90122, 112, '2015-03-01 00:13:36.000000', 'temperatura', 1172.0000, 'ºC'),
	(90123, 112, '2015-03-01 00:13:37.000000', 'temperatura', 761.0000, 'ºC'),
	(90124, 112, '2015-03-01 00:13:38.000000', 'temperatura', 289.0000, 'ºC'),
	(90125, 112, '2015-03-01 00:13:39.000000', 'temperatura', 361.0000, 'ºC'),
	(90126, 112, '2015-03-01 00:13:40.000000', 'temperatura', 940.0000, 'ºC'),
	(90127, 112, '2015-03-01 00:13:41.000000', 'temperatura', 18.0000, 'ºC'),
	(90128, 112, '2015-03-01 00:13:42.000000', 'temperatura', 872.0000, 'ºC'),
	(90129, 112, '2015-03-01 00:13:43.000000', 'temperatura', 705.0000, 'ºC'),
	(90130, 112, '2015-03-01 00:13:44.000000', 'temperatura', 909.0000, 'ºC'),
	(90131, 112, '2015-03-01 00:13:45.000000', 'temperatura', 30.0000, 'ºC'),
	(90132, 112, '2015-03-01 00:13:46.000000', 'temperatura', 1024.0000, 'ºC'),
	(90133, 112, '2015-03-01 00:13:47.000000', 'temperatura', 230.0000, 'ºC'),
	(90134, 112, '2015-03-01 00:13:48.000000', 'temperatura', 479.0000, 'ºC'),
	(90135, 112, '2015-03-01 00:13:49.000000', 'temperatura', 507.0000, 'ºC'),
	(90136, 112, '2015-03-01 00:13:50.000000', 'temperatura', 1098.0000, 'ºC'),
	(90137, 112, '2015-03-01 00:13:51.000000', 'temperatura', 370.0000, 'ºC'),
	(90138, 112, '2015-03-01 00:13:52.000000', 'temperatura', 957.0000, 'ºC'),
	(90139, 112, '2015-03-01 00:13:53.000000', 'temperatura', 74.0000, 'ºC'),
	(90140, 112, '2015-03-01 00:13:54.000000', 'temperatura', 1098.0000, 'ºC'),
	(90141, 112, '2015-03-01 00:13:55.000000', 'temperatura', 470.0000, 'ºC'),
	(90142, 112, '2015-03-01 00:13:56.000000', 'temperatura', 255.0000, 'ºC'),
	(90143, 112, '2015-03-01 00:13:57.000000', 'temperatura', 1066.0000, 'ºC'),
	(90144, 112, '2015-03-01 00:13:58.000000', 'temperatura', 965.0000, 'ºC'),
	(90145, 112, '2015-03-01 00:13:59.000000', 'temperatura', 429.0000, 'ºC'),
	(90146, 112, '2015-03-01 00:14:00.000000', 'temperatura', 450.0000, 'ºC'),
	(90147, 112, '2015-03-01 00:14:01.000000', 'temperatura', 963.0000, 'ºC'),
	(90148, 112, '2015-03-01 00:14:02.000000', 'temperatura', 1064.0000, 'ºC'),
	(90149, 112, '2015-03-01 00:14:03.000000', 'temperatura', 32.0000, 'ºC'),
	(90150, 112, '2015-03-01 00:14:04.000000', 'temperatura', 568.0000, 'ºC'),
	(90151, 112, '2015-03-01 00:14:05.000000', 'temperatura', 344.0000, 'ºC'),
	(90152, 112, '2015-03-01 00:14:06.000000', 'temperatura', 19.0000, 'ºC'),
	(90153, 112, '2015-03-01 00:14:07.000000', 'temperatura', 263.0000, 'ºC'),
	(90154, 112, '2015-03-01 00:14:08.000000', 'temperatura', 60.0000, 'ºC'),
	(90155, 112, '2015-03-01 00:14:09.000000', 'temperatura', 711.0000, 'ºC'),
	(90156, 112, '2015-03-01 00:14:10.000000', 'temperatura', 973.0000, 'ºC'),
	(90157, 112, '2015-03-01 00:14:11.000000', 'temperatura', 334.0000, 'ºC'),
	(90158, 112, '2015-03-01 00:14:12.000000', 'temperatura', 1152.0000, 'ºC'),
	(90159, 112, '2015-03-01 00:14:13.000000', 'temperatura', 1158.0000, 'ºC'),
	(90160, 112, '2015-03-01 00:14:14.000000', 'temperatura', 1135.0000, 'ºC'),
	(90161, 112, '2015-03-01 00:14:15.000000', 'temperatura', 1000.0000, 'ºC'),
	(90162, 112, '2015-03-01 00:14:16.000000', 'temperatura', 398.0000, 'ºC'),
	(90163, 112, '2015-03-01 00:14:17.000000', 'temperatura', 189.0000, 'ºC'),
	(90164, 112, '2015-03-01 00:14:18.000000', 'temperatura', 954.0000, 'ºC'),
	(90165, 112, '2015-03-01 00:14:19.000000', 'temperatura', 600.0000, 'ºC'),
	(90166, 112, '2015-03-01 00:14:20.000000', 'temperatura', 140.0000, 'ºC'),
	(90167, 112, '2015-03-01 00:14:21.000000', 'temperatura', 100.0000, 'ºC'),
	(90168, 112, '2015-03-01 00:14:22.000000', 'temperatura', 82.0000, 'ºC'),
	(90169, 112, '2015-03-01 00:14:23.000000', 'temperatura', 110.0000, 'ºC'),
	(90170, 112, '2015-03-01 00:14:24.000000', 'temperatura', 306.0000, 'ºC'),
	(90171, 112, '2015-03-01 00:14:25.000000', 'temperatura', 0.0000, 'ºC'),
	(90172, 112, '2015-03-01 00:14:26.000000', 'temperatura', 281.0000, 'ºC'),
	(90173, 112, '2015-03-01 00:14:27.000000', 'temperatura', 206.0000, 'ºC'),
	(90174, 112, '2015-03-01 00:14:28.000000', 'temperatura', 188.0000, 'ºC'),
	(90175, 112, '2015-03-01 00:14:29.000000', 'temperatura', 321.0000, 'ºC'),
	(90176, 112, '2015-03-01 00:14:30.000000', 'temperatura', 1041.0000, 'ºC'),
	(90177, 112, '2015-03-01 00:14:31.000000', 'temperatura', 644.0000, 'ºC'),
	(90178, 112, '2015-03-01 00:14:32.000000', 'temperatura', 96.0000, 'ºC'),
	(90179, 112, '2015-03-01 00:14:33.000000', 'temperatura', 950.0000, 'ºC'),
	(90180, 112, '2015-03-01 00:14:34.000000', 'temperatura', 863.0000, 'ºC'),
	(90181, 112, '2015-03-01 00:14:35.000000', 'temperatura', 263.0000, 'ºC'),
	(90182, 112, '2015-03-01 00:14:36.000000', 'temperatura', 1127.0000, 'ºC'),
	(90183, 112, '2015-03-01 00:14:37.000000', 'temperatura', 49.0000, 'ºC'),
	(90184, 112, '2015-03-01 00:14:38.000000', 'temperatura', 462.0000, 'ºC'),
	(90185, 112, '2015-03-01 00:14:39.000000', 'temperatura', 966.0000, 'ºC'),
	(90186, 112, '2015-03-01 00:14:40.000000', 'temperatura', 1044.0000, 'ºC'),
	(90187, 112, '2015-03-01 00:14:41.000000', 'temperatura', 1123.0000, 'ºC'),
	(90188, 112, '2015-03-01 00:14:42.000000', 'temperatura', 82.0000, 'ºC'),
	(90189, 112, '2015-03-01 00:14:43.000000', 'temperatura', 644.0000, 'ºC'),
	(90190, 112, '2015-03-01 00:14:44.000000', 'temperatura', 571.0000, 'ºC'),
	(90191, 112, '2015-03-01 00:14:45.000000', 'temperatura', 926.0000, 'ºC'),
	(90192, 112, '2015-03-01 00:14:46.000000', 'temperatura', 516.0000, 'ºC'),
	(90193, 112, '2015-03-01 00:14:47.000000', 'temperatura', 1002.0000, 'ºC'),
	(90194, 112, '2015-03-01 00:14:48.000000', 'temperatura', 1064.0000, 'ºC'),
	(90195, 112, '2015-03-01 00:14:49.000000', 'temperatura', 1114.0000, 'ºC'),
	(90196, 112, '2015-03-01 00:14:50.000000', 'temperatura', 1179.0000, 'ºC'),
	(90197, 112, '2015-03-01 00:14:51.000000', 'temperatura', 153.0000, 'ºC'),
	(90198, 112, '2015-03-01 00:14:52.000000', 'temperatura', 830.0000, 'ºC'),
	(90199, 112, '2015-03-01 00:14:53.000000', 'temperatura', 92.0000, 'ºC'),
	(90200, 112, '2015-03-01 00:14:54.000000', 'temperatura', 370.0000, 'ºC'),
	(90201, 112, '2015-03-01 00:14:55.000000', 'temperatura', 373.0000, 'ºC'),
	(90202, 112, '2015-03-01 00:14:56.000000', 'temperatura', 756.0000, 'ºC'),
	(90203, 112, '2015-03-01 00:14:57.000000', 'temperatura', 260.0000, 'ºC'),
	(90204, 112, '2015-03-01 00:14:58.000000', 'temperatura', 235.0000, 'ºC'),
	(90205, 112, '2015-03-01 00:14:59.000000', 'temperatura', 396.0000, 'ºC'),
	(90206, 112, '2015-03-01 00:15:00.000000', 'temperatura', 72.0000, 'ºC'),
	(90207, 112, '2015-03-01 00:15:01.000000', 'temperatura', 376.0000, 'ºC'),
	(90208, 112, '2015-03-01 00:15:02.000000', 'temperatura', 464.0000, 'ºC'),
	(90209, 112, '2015-03-01 00:15:03.000000', 'temperatura', 1194.0000, 'ºC'),
	(90210, 112, '2015-03-01 00:15:04.000000', 'temperatura', 977.0000, 'ºC'),
	(90211, 112, '2015-03-01 00:15:05.000000', 'temperatura', 102.0000, 'ºC'),
	(90212, 112, '2015-03-01 00:15:06.000000', 'temperatura', 1180.0000, 'ºC'),
	(90213, 112, '2015-03-01 00:15:07.000000', 'temperatura', 795.0000, 'ºC'),
	(90214, 112, '2015-03-01 00:15:08.000000', 'temperatura', 434.0000, 'ºC'),
	(90215, 112, '2015-03-01 00:15:09.000000', 'temperatura', 989.0000, 'ºC'),
	(90216, 112, '2015-03-01 00:15:10.000000', 'temperatura', 40.0000, 'ºC'),
	(90217, 112, '2015-03-01 00:15:11.000000', 'temperatura', 835.0000, 'ºC'),
	(90218, 112, '2015-03-01 00:15:12.000000', 'temperatura', 454.0000, 'ºC'),
	(90219, 112, '2015-03-01 00:15:13.000000', 'temperatura', 966.0000, 'ºC'),
	(90220, 112, '2015-03-01 00:15:14.000000', 'temperatura', 1070.0000, 'ºC'),
	(90221, 112, '2015-03-01 00:15:15.000000', 'temperatura', 53.0000, 'ºC'),
	(90222, 112, '2015-03-01 00:15:16.000000', 'temperatura', 652.0000, 'ºC'),
	(90223, 112, '2015-03-01 00:15:17.000000', 'temperatura', 705.0000, 'ºC'),
	(90224, 112, '2015-03-01 00:15:18.000000', 'temperatura', 370.0000, 'ºC'),
	(90225, 112, '2015-03-01 00:15:19.000000', 'temperatura', 934.0000, 'ºC'),
	(90226, 112, '2015-03-01 00:15:20.000000', 'temperatura', 1162.0000, 'ºC'),
	(90227, 112, '2015-03-01 00:15:21.000000', 'temperatura', 607.0000, 'ºC'),
	(90228, 112, '2015-03-01 00:15:22.000000', 'temperatura', 752.0000, 'ºC'),
	(90229, 112, '2015-03-01 00:15:23.000000', 'temperatura', 738.0000, 'ºC'),
	(90230, 112, '2015-03-01 00:15:24.000000', 'temperatura', 236.0000, 'ºC'),
	(90231, 112, '2015-03-01 00:15:25.000000', 'temperatura', 164.0000, 'ºC'),
	(90232, 112, '2015-03-01 00:15:26.000000', 'temperatura', 112.0000, 'ºC'),
	(90233, 112, '2015-03-01 00:15:27.000000', 'temperatura', 72.0000, 'ºC'),
	(90234, 112, '2015-03-01 00:15:28.000000', 'temperatura', 21.0000, 'ºC'),
	(90235, 112, '2015-03-01 00:15:29.000000', 'temperatura', 1091.0000, 'ºC'),
	(90236, 112, '2015-03-01 00:15:30.000000', 'temperatura', 594.0000, 'ºC'),
	(90237, 112, '2015-03-01 00:15:31.000000', 'temperatura', 896.0000, 'ºC'),
	(90238, 112, '2015-03-01 00:15:32.000000', 'temperatura', 300.0000, 'ºC'),
	(90239, 112, '2015-03-01 00:15:33.000000', 'temperatura', 10.0000, 'ºC'),
	(90240, 112, '2015-03-01 00:15:34.000000', 'temperatura', 352.0000, 'ºC'),
	(90241, 112, '2015-03-01 00:15:35.000000', 'temperatura', 531.0000, 'ºC'),
	(90242, 112, '2015-03-01 00:15:36.000000', 'temperatura', 401.0000, 'ºC'),
	(90243, 112, '2015-03-01 00:15:37.000000', 'temperatura', 411.0000, 'ºC'),
	(90244, 112, '2015-03-01 00:15:38.000000', 'temperatura', 853.0000, 'ºC'),
	(90245, 112, '2015-03-01 00:15:39.000000', 'temperatura', 633.0000, 'ºC'),
	(90246, 112, '2015-03-01 00:15:40.000000', 'temperatura', 606.0000, 'ºC'),
	(90247, 112, '2015-03-01 00:15:41.000000', 'temperatura', 1132.0000, 'ºC'),
	(90248, 112, '2015-03-01 00:15:42.000000', 'temperatura', 242.0000, 'ºC'),
	(90249, 112, '2015-03-01 00:15:43.000000', 'temperatura', 214.0000, 'ºC'),
	(90250, 112, '2015-03-01 00:15:44.000000', 'temperatura', 346.0000, 'ºC'),
	(90251, 112, '2015-03-01 00:15:45.000000', 'temperatura', 1087.0000, 'ºC'),
	(90252, 112, '2015-03-01 00:15:46.000000', 'temperatura', 796.0000, 'ºC'),
	(90253, 112, '2015-03-01 00:15:47.000000', 'temperatura', 722.0000, 'ºC'),
	(90254, 112, '2015-03-01 00:15:48.000000', 'temperatura', 20.0000, 'ºC'),
	(90255, 112, '2015-03-01 00:15:49.000000', 'temperatura', 338.0000, 'ºC'),
	(90256, 112, '2015-03-01 00:15:50.000000', 'temperatura', 428.0000, 'ºC'),
	(90257, 112, '2015-03-01 00:15:51.000000', 'temperatura', 1127.0000, 'ºC'),
	(90258, 112, '2015-03-01 00:15:52.000000', 'temperatura', 754.0000, 'ºC'),
	(90259, 112, '2015-03-01 00:15:53.000000', 'temperatura', 387.0000, 'ºC'),
	(90260, 112, '2015-03-01 00:15:54.000000', 'temperatura', 872.0000, 'ºC'),
	(90261, 112, '2015-03-01 00:15:55.000000', 'temperatura', 801.0000, 'ºC'),
	(90262, 112, '2015-03-01 00:15:56.000000', 'temperatura', 190.0000, 'ºC'),
	(90263, 112, '2015-03-01 00:15:57.000000', 'temperatura', 948.0000, 'ºC'),
	(90264, 112, '2015-03-01 00:15:58.000000', 'temperatura', 569.0000, 'ºC'),
	(90265, 112, '2015-03-01 00:15:59.000000', 'temperatura', 4.0000, 'ºC'),
	(90266, 112, '2015-03-01 00:16:00.000000', 'temperatura', 711.0000, 'ºC'),
	(90267, 112, '2015-03-01 00:16:01.000000', 'temperatura', 1144.0000, 'ºC'),
	(90268, 112, '2015-03-01 00:16:02.000000', 'temperatura', 1186.0000, 'ºC'),
	(90269, 112, '2015-03-01 00:16:03.000000', 'temperatura', 100.0000, 'ºC'),
	(90270, 112, '2015-03-01 00:16:04.000000', 'temperatura', 541.0000, 'ºC'),
	(90271, 112, '2015-03-01 00:16:05.000000', 'temperatura', 5.0000, 'ºC'),
	(90272, 112, '2015-03-01 00:16:06.000000', 'temperatura', 804.0000, 'ºC'),
	(90273, 112, '2015-03-01 00:16:07.000000', 'temperatura', 406.0000, 'ºC'),
	(90274, 112, '2015-03-01 00:16:08.000000', 'temperatura', 817.0000, 'ºC'),
	(90275, 112, '2015-03-01 00:16:09.000000', 'temperatura', 467.0000, 'ºC'),
	(90276, 112, '2015-03-01 00:16:10.000000', 'temperatura', 1087.0000, 'ºC'),
	(90277, 112, '2015-03-01 00:16:11.000000', 'temperatura', 432.0000, 'ºC'),
	(90278, 112, '2015-03-01 00:16:12.000000', 'temperatura', 101.0000, 'ºC'),
	(90279, 112, '2015-03-01 00:16:13.000000', 'temperatura', 410.0000, 'ºC'),
	(90280, 112, '2015-03-01 00:16:14.000000', 'temperatura', 545.0000, 'ºC'),
	(90281, 112, '2015-03-01 00:16:15.000000', 'temperatura', 297.0000, 'ºC'),
	(90282, 112, '2015-03-01 00:16:16.000000', 'temperatura', 1051.0000, 'ºC'),
	(90283, 112, '2015-03-01 00:16:17.000000', 'temperatura', 763.0000, 'ºC'),
	(90284, 112, '2015-03-01 00:16:18.000000', 'temperatura', 663.0000, 'ºC'),
	(90285, 112, '2015-03-01 00:16:19.000000', 'temperatura', 1026.0000, 'ºC'),
	(90286, 112, '2015-03-01 00:16:20.000000', 'temperatura', 742.0000, 'ºC'),
	(90287, 112, '2015-03-01 00:16:21.000000', 'temperatura', 634.0000, 'ºC'),
	(90288, 112, '2015-03-01 00:16:22.000000', 'temperatura', 941.0000, 'ºC'),
	(90289, 112, '2015-03-01 00:16:23.000000', 'temperatura', 407.0000, 'ºC'),
	(90290, 112, '2015-03-01 00:16:24.000000', 'temperatura', 412.0000, 'ºC'),
	(90291, 112, '2015-03-01 00:16:25.000000', 'temperatura', 840.0000, 'ºC'),
	(90292, 112, '2015-03-01 00:16:26.000000', 'temperatura', 565.0000, 'ºC'),
	(90293, 112, '2015-03-01 00:16:27.000000', 'temperatura', 303.0000, 'ºC'),
	(90294, 112, '2015-03-01 00:16:28.000000', 'temperatura', 1024.0000, 'ºC'),
	(90295, 112, '2015-03-01 00:16:29.000000', 'temperatura', 608.0000, 'ºC'),
	(90296, 112, '2015-03-01 00:16:30.000000', 'temperatura', 1172.0000, 'ºC'),
	(90297, 112, '2015-03-01 00:16:31.000000', 'temperatura', 434.0000, 'ºC'),
	(90298, 112, '2015-03-01 00:16:32.000000', 'temperatura', 1054.0000, 'ºC'),
	(90299, 112, '2015-03-01 00:16:33.000000', 'temperatura', 371.0000, 'ºC'),
	(90300, 112, '2015-03-01 00:16:34.000000', 'temperatura', 1093.0000, 'ºC'),
	(90301, 112, '2015-03-01 00:16:35.000000', 'temperatura', 752.0000, 'ºC'),
	(90302, 112, '2015-03-01 00:16:36.000000', 'temperatura', 483.0000, 'ºC'),
	(90303, 112, '2015-03-01 00:16:37.000000', 'temperatura', 158.0000, 'ºC'),
	(90304, 112, '2015-03-01 00:16:38.000000', 'temperatura', 543.0000, 'ºC'),
	(90305, 112, '2015-03-01 00:16:39.000000', 'temperatura', 1041.0000, 'ºC'),
	(90306, 112, '2015-03-01 00:16:40.000000', 'temperatura', 1178.0000, 'ºC'),
	(90307, 112, '2015-03-01 00:16:41.000000', 'temperatura', 367.0000, 'ºC'),
	(90308, 112, '2015-03-01 00:16:42.000000', 'temperatura', 699.0000, 'ºC'),
	(90309, 112, '2015-03-01 00:16:43.000000', 'temperatura', 1196.0000, 'ºC'),
	(90310, 112, '2015-03-01 00:16:44.000000', 'temperatura', 284.0000, 'ºC'),
	(90311, 112, '2015-03-01 00:16:45.000000', 'temperatura', 230.0000, 'ºC'),
	(90312, 112, '2015-03-01 00:16:46.000000', 'temperatura', 301.0000, 'ºC'),
	(90313, 112, '2015-03-01 00:16:47.000000', 'temperatura', 815.0000, 'ºC'),
	(90314, 112, '2015-03-01 00:16:48.000000', 'temperatura', 774.0000, 'ºC'),
	(90315, 112, '2015-03-01 00:16:49.000000', 'temperatura', 224.0000, 'ºC'),
	(90316, 112, '2015-03-01 00:16:50.000000', 'temperatura', 1197.0000, 'ºC'),
	(90317, 112, '2015-03-01 00:16:51.000000', 'temperatura', 515.0000, 'ºC'),
	(90318, 112, '2015-03-01 00:16:52.000000', 'temperatura', 182.0000, 'ºC'),
	(90319, 112, '2015-03-01 00:16:53.000000', 'temperatura', 569.0000, 'ºC'),
	(90320, 112, '2015-03-01 00:16:54.000000', 'temperatura', 1097.0000, 'ºC'),
	(90321, 112, '2015-03-01 00:16:55.000000', 'temperatura', 178.0000, 'ºC'),
	(90322, 112, '2015-03-01 00:16:56.000000', 'temperatura', 0.0000, 'ºC'),
	(90323, 112, '2015-03-01 00:16:57.000000', 'temperatura', 665.0000, 'ºC'),
	(90324, 112, '2015-03-01 00:16:58.000000', 'temperatura', 927.0000, 'ºC'),
	(90325, 112, '2015-03-01 00:16:59.000000', 'temperatura', 239.0000, 'ºC'),
	(90326, 112, '2015-03-01 00:17:00.000000', 'temperatura', 817.0000, 'ºC'),
	(90327, 112, '2015-03-01 00:17:01.000000', 'temperatura', 969.0000, 'ºC'),
	(90328, 112, '2015-03-01 00:17:02.000000', 'temperatura', 1192.0000, 'ºC'),
	(90329, 112, '2015-03-01 00:17:03.000000', 'temperatura', 656.0000, 'ºC'),
	(90330, 112, '2015-03-01 00:17:04.000000', 'temperatura', 904.0000, 'ºC'),
	(90331, 112, '2015-03-01 00:17:05.000000', 'temperatura', 154.0000, 'ºC'),
	(90332, 112, '2015-03-01 00:17:06.000000', 'temperatura', 456.0000, 'ºC'),
	(90333, 112, '2015-03-01 00:17:07.000000', 'temperatura', 620.0000, 'ºC'),
	(90334, 112, '2015-03-01 00:17:08.000000', 'temperatura', 530.0000, 'ºC'),
	(90335, 112, '2015-03-01 00:17:09.000000', 'temperatura', 792.0000, 'ºC'),
	(90336, 112, '2015-03-01 00:17:10.000000', 'temperatura', 1169.0000, 'ºC'),
	(90337, 112, '2015-03-01 00:17:11.000000', 'temperatura', 1072.0000, 'ºC'),
	(90338, 112, '2015-03-01 00:17:12.000000', 'temperatura', 652.0000, 'ºC'),
	(90339, 112, '2015-03-01 00:17:13.000000', 'temperatura', 43.0000, 'ºC'),
	(90340, 112, '2015-03-01 00:17:14.000000', 'temperatura', 662.0000, 'ºC'),
	(90341, 112, '2015-03-01 00:17:15.000000', 'temperatura', 779.0000, 'ºC'),
	(90342, 112, '2015-03-01 00:17:16.000000', 'temperatura', 711.0000, 'ºC'),
	(90343, 112, '2015-03-01 00:17:17.000000', 'temperatura', 17.0000, 'ºC'),
	(90344, 112, '2015-03-01 00:17:18.000000', 'temperatura', 353.0000, 'ºC'),
	(90345, 112, '2015-03-01 00:17:19.000000', 'temperatura', 517.0000, 'ºC'),
	(90346, 112, '2015-03-01 00:17:20.000000', 'temperatura', 323.0000, 'ºC'),
	(90347, 112, '2015-03-01 00:17:21.000000', 'temperatura', 66.0000, 'ºC'),
	(90348, 112, '2015-03-01 00:17:22.000000', 'temperatura', 563.0000, 'ºC'),
	(90349, 112, '2015-03-01 00:17:23.000000', 'temperatura', 217.0000, 'ºC'),
	(90350, 112, '2015-03-01 00:17:24.000000', 'temperatura', 596.0000, 'ºC'),
	(90351, 112, '2015-03-01 00:17:25.000000', 'temperatura', 1129.0000, 'ºC'),
	(90352, 112, '2015-03-01 00:17:26.000000', 'temperatura', 257.0000, 'ºC'),
	(90353, 112, '2015-03-01 00:17:27.000000', 'temperatura', 299.0000, 'ºC'),
	(90354, 112, '2015-03-01 00:17:28.000000', 'temperatura', 723.0000, 'ºC'),
	(90355, 112, '2015-03-01 00:17:29.000000', 'temperatura', 321.0000, 'ºC'),
	(90356, 112, '2015-03-01 00:17:30.000000', 'temperatura', 638.0000, 'ºC'),
	(90357, 112, '2015-03-01 00:17:31.000000', 'temperatura', 1024.0000, 'ºC'),
	(90358, 112, '2015-03-01 00:17:32.000000', 'temperatura', 806.0000, 'ºC'),
	(90359, 112, '2015-03-01 00:17:33.000000', 'temperatura', 961.0000, 'ºC'),
	(90360, 112, '2015-03-01 00:17:34.000000', 'temperatura', 1187.0000, 'ºC'),
	(90361, 112, '2015-03-01 00:17:35.000000', 'temperatura', 654.0000, 'ºC'),
	(90362, 112, '2015-03-01 00:17:36.000000', 'temperatura', 906.0000, 'ºC'),
	(90363, 112, '2015-03-01 00:17:37.000000', 'temperatura', 172.0000, 'ºC'),
	(90364, 112, '2015-03-01 00:17:38.000000', 'temperatura', 539.0000, 'ºC'),
	(90365, 112, '2015-03-01 00:17:39.000000', 'temperatura', 981.0000, 'ºC'),
	(90366, 112, '2015-03-01 00:17:40.000000', 'temperatura', 890.0000, 'ºC'),
	(90367, 112, '2015-03-01 00:17:41.000000', 'temperatura', 306.0000, 'ºC'),
	(90368, 112, '2015-03-01 00:17:42.000000', 'temperatura', 61.0000, 'ºC'),
	(90369, 112, '2015-03-01 00:17:43.000000', 'temperatura', 585.0000, 'ºC'),
	(90370, 112, '2015-03-01 00:17:44.000000', 'temperatura', 345.0000, 'ºC'),
	(90371, 112, '2015-03-01 00:17:45.000000', 'temperatura', 1171.0000, 'ºC'),
	(90372, 112, '2015-03-01 00:17:46.000000', 'temperatura', 19.0000, 'ºC'),
	(90373, 112, '2015-03-01 00:17:47.000000', 'temperatura', 183.0000, 'ºC'),
	(90374, 112, '2015-03-01 00:17:48.000000', 'temperatura', 858.0000, 'ºC'),
	(90375, 112, '2015-03-01 00:17:49.000000', 'temperatura', 143.0000, 'ºC'),
	(90376, 112, '2015-03-01 00:17:50.000000', 'temperatura', 542.0000, 'ºC'),
	(90377, 112, '2015-03-01 00:17:51.000000', 'temperatura', 1081.0000, 'ºC'),
	(90378, 112, '2015-03-01 00:17:52.000000', 'temperatura', 181.0000, 'ºC'),
	(90379, 112, '2015-03-01 00:17:53.000000', 'temperatura', 60.0000, 'ºC'),
	(90380, 112, '2015-03-01 00:17:54.000000', 'temperatura', 958.0000, 'ºC'),
	(90381, 112, '2015-03-01 00:17:55.000000', 'temperatura', 1009.0000, 'ºC'),
	(90382, 112, '2015-03-01 00:17:56.000000', 'temperatura', 972.0000, 'ºC'),
	(90383, 112, '2015-03-01 00:17:57.000000', 'temperatura', 634.0000, 'ºC'),
	(90384, 112, '2015-03-01 00:17:58.000000', 'temperatura', 255.0000, 'ºC'),
	(90385, 112, '2015-03-01 00:17:59.000000', 'temperatura', 573.0000, 'ºC'),
	(90386, 112, '2015-03-01 00:18:00.000000', 'temperatura', 902.0000, 'ºC'),
	(90387, 112, '2015-03-01 00:18:01.000000', 'temperatura', 392.0000, 'ºC'),
	(90388, 112, '2015-03-01 00:18:02.000000', 'temperatura', 453.0000, 'ºC'),
	(90389, 112, '2015-03-01 00:18:03.000000', 'temperatura', 1091.0000, 'ºC'),
	(90390, 112, '2015-03-01 00:18:04.000000', 'temperatura', 498.0000, 'ºC'),
	(90391, 112, '2015-03-01 00:18:05.000000', 'temperatura', 414.0000, 'ºC'),
	(90392, 112, '2015-03-01 00:18:06.000000', 'temperatura', 578.0000, 'ºC'),
	(90393, 112, '2015-03-01 00:18:07.000000', 'temperatura', 447.0000, 'ºC'),
	(90394, 112, '2015-03-01 00:18:08.000000', 'temperatura', 503.0000, 'ºC'),
	(90395, 112, '2015-03-01 00:18:09.000000', 'temperatura', 1172.0000, 'ºC'),
	(90396, 112, '2015-03-01 00:18:10.000000', 'temperatura', 754.0000, 'ºC'),
	(90397, 112, '2015-03-01 00:18:11.000000', 'temperatura', 255.0000, 'ºC'),
	(90398, 112, '2015-03-01 00:18:12.000000', 'temperatura', 212.0000, 'ºC'),
	(90399, 112, '2015-03-01 00:18:13.000000', 'temperatura', 294.0000, 'ºC'),
	(90400, 112, '2015-03-01 00:18:14.000000', 'temperatura', 836.0000, 'ºC'),
	(90401, 112, '2015-03-01 00:18:15.000000', 'temperatura', 897.0000, 'ºC'),
	(90402, 112, '2015-03-01 00:18:16.000000', 'temperatura', 781.0000, 'ºC'),
	(90403, 112, '2015-03-01 00:18:17.000000', 'temperatura', 11.0000, 'ºC'),
	(90404, 112, '2015-03-01 00:18:18.000000', 'temperatura', 114.0000, 'ºC'),
	(90405, 112, '2015-03-01 00:18:19.000000', 'temperatura', 537.0000, 'ºC'),
	(90406, 112, '2015-03-01 00:18:20.000000', 'temperatura', 1145.0000, 'ºC'),
	(90407, 112, '2015-03-01 00:18:21.000000', 'temperatura', 513.0000, 'ºC'),
	(90408, 112, '2015-03-01 00:18:22.000000', 'temperatura', 333.0000, 'ºC'),
	(90409, 112, '2015-03-01 00:18:23.000000', 'temperatura', 124.0000, 'ºC'),
	(90410, 112, '2015-03-01 00:18:24.000000', 'temperatura', 821.0000, 'ºC'),
	(90411, 112, '2015-03-01 00:18:25.000000', 'temperatura', 134.0000, 'ºC'),
	(90412, 112, '2015-03-01 00:18:26.000000', 'temperatura', 607.0000, 'ºC'),
	(90413, 112, '2015-03-01 00:18:27.000000', 'temperatura', 235.0000, 'ºC'),
	(90414, 112, '2015-03-01 00:18:28.000000', 'temperatura', 556.0000, 'ºC'),
	(90415, 112, '2015-03-01 00:18:29.000000', 'temperatura', 873.0000, 'ºC'),
	(90416, 112, '2015-03-01 00:18:30.000000', 'temperatura', 300.0000, 'ºC'),
	(90417, 112, '2015-03-01 00:18:31.000000', 'temperatura', 80.0000, 'ºC'),
	(90418, 112, '2015-03-01 00:18:32.000000', 'temperatura', 701.0000, 'ºC'),
	(90419, 112, '2015-03-01 00:18:33.000000', 'temperatura', 865.0000, 'ºC'),
	(90420, 112, '2015-03-01 00:18:34.000000', 'temperatura', 1022.0000, 'ºC'),
	(90421, 112, '2015-03-01 00:18:35.000000', 'temperatura', 117.0000, 'ºC'),
	(90422, 112, '2015-03-01 00:18:36.000000', 'temperatura', 1119.0000, 'ºC'),
	(90423, 112, '2015-03-01 00:18:37.000000', 'temperatura', 443.0000, 'ºC'),
	(90424, 112, '2015-03-01 00:18:38.000000', 'temperatura', 58.0000, 'ºC'),
	(90425, 112, '2015-03-01 00:18:39.000000', 'temperatura', 164.0000, 'ºC'),
	(90426, 112, '2015-03-01 00:18:40.000000', 'temperatura', 647.0000, 'ºC'),
	(90427, 112, '2015-03-01 00:18:41.000000', 'temperatura', 343.0000, 'ºC'),
	(90428, 112, '2015-03-01 00:18:42.000000', 'temperatura', 973.0000, 'ºC'),
	(90429, 112, '2015-03-01 00:18:43.000000', 'temperatura', 237.0000, 'ºC'),
	(90430, 112, '2015-03-01 00:18:44.000000', 'temperatura', 666.0000, 'ºC'),
	(90431, 112, '2015-03-01 00:18:45.000000', 'temperatura', 219.0000, 'ºC'),
	(90432, 112, '2015-03-01 00:18:46.000000', 'temperatura', 296.0000, 'ºC'),
	(90433, 112, '2015-03-01 00:18:47.000000', 'temperatura', 826.0000, 'ºC'),
	(90434, 112, '2015-03-01 00:18:48.000000', 'temperatura', 840.0000, 'ºC'),
	(90435, 112, '2015-03-01 00:18:49.000000', 'temperatura', 526.0000, 'ºC'),
	(90436, 112, '2015-03-01 00:18:50.000000', 'temperatura', 108.0000, 'ºC'),
	(90437, 112, '2015-03-01 00:18:51.000000', 'temperatura', 162.0000, 'ºC'),
	(90438, 112, '2015-03-01 00:18:52.000000', 'temperatura', 486.0000, 'ºC'),
	(90439, 112, '2015-03-01 00:18:53.000000', 'temperatura', 747.0000, 'ºC'),
	(90440, 112, '2015-03-01 00:18:54.000000', 'temperatura', 1079.0000, 'ºC'),
	(90441, 112, '2015-03-01 00:18:55.000000', 'temperatura', 751.0000, 'ºC'),
	(90442, 112, '2015-03-01 00:18:56.000000', 'temperatura', 518.0000, 'ºC'),
	(90443, 112, '2015-03-01 00:18:57.000000', 'temperatura', 339.0000, 'ºC'),
	(90444, 112, '2015-03-01 00:18:58.000000', 'temperatura', 140.0000, 'ºC'),
	(90445, 112, '2015-03-01 00:18:59.000000', 'temperatura', 882.0000, 'ºC'),
	(90446, 112, '2015-03-01 00:19:00.000000', 'temperatura', 394.0000, 'ºC'),
	(90447, 112, '2015-03-01 00:19:01.000000', 'temperatura', 524.0000, 'ºC'),
	(90448, 112, '2015-03-01 00:19:02.000000', 'temperatura', 237.0000, 'ºC'),
	(90449, 112, '2015-03-01 00:19:03.000000', 'temperatura', 813.0000, 'ºC'),
	(90450, 112, '2015-03-01 00:19:04.000000', 'temperatura', 957.0000, 'ºC'),
	(90451, 112, '2015-03-01 00:19:05.000000', 'temperatura', 1143.0000, 'ºC'),
	(90452, 112, '2015-03-01 00:19:06.000000', 'temperatura', 448.0000, 'ºC'),
	(90453, 112, '2015-03-01 00:19:07.000000', 'temperatura', 9.0000, 'ºC'),
	(90454, 112, '2015-03-01 00:19:08.000000', 'temperatura', 1103.0000, 'ºC'),
	(90455, 112, '2015-03-01 00:19:09.000000', 'temperatura', 688.0000, 'ºC'),
	(90456, 112, '2015-03-01 00:19:10.000000', 'temperatura', 130.0000, 'ºC'),
	(90457, 112, '2015-03-01 00:19:11.000000', 'temperatura', 986.0000, 'ºC'),
	(90458, 112, '2015-03-01 00:19:12.000000', 'temperatura', 941.0000, 'ºC'),
	(90459, 112, '2015-03-01 00:19:13.000000', 'temperatura', 548.0000, 'ºC'),
	(90460, 112, '2015-03-01 00:19:14.000000', 'temperatura', 1118.0000, 'ºC'),
	(90461, 112, '2015-03-01 00:19:15.000000', 'temperatura', 344.0000, 'ºC'),
	(90462, 112, '2015-03-01 00:19:16.000000', 'temperatura', 769.0000, 'ºC'),
	(90463, 112, '2015-03-01 00:19:17.000000', 'temperatura', 412.0000, 'ºC'),
	(90464, 112, '2015-03-01 00:19:18.000000', 'temperatura', 953.0000, 'ºC'),
	(90465, 112, '2015-03-01 00:19:19.000000', 'temperatura', 1129.0000, 'ºC'),
	(90466, 112, '2015-03-01 00:19:20.000000', 'temperatura', 387.0000, 'ºC'),
	(90467, 112, '2015-03-01 00:19:21.000000', 'temperatura', 949.0000, 'ºC'),
	(90468, 112, '2015-03-01 00:19:22.000000', 'temperatura', 1183.0000, 'ºC'),
	(90469, 112, '2015-03-01 00:19:23.000000', 'temperatura', 671.0000, 'ºC'),
	(90470, 112, '2015-03-01 00:19:24.000000', 'temperatura', 1007.0000, 'ºC'),
	(90471, 112, '2015-03-01 00:19:25.000000', 'temperatura', 620.0000, 'ºC'),
	(90472, 112, '2015-03-01 00:19:26.000000', 'temperatura', 81.0000, 'ºC'),
	(90473, 112, '2015-03-01 00:19:27.000000', 'temperatura', 943.0000, 'ºC'),
	(90474, 112, '2015-03-01 00:19:28.000000', 'temperatura', 875.0000, 'ºC'),
	(90475, 112, '2015-03-01 00:19:29.000000', 'temperatura', 344.0000, 'ºC'),
	(90476, 112, '2015-03-01 00:19:30.000000', 'temperatura', 298.0000, 'ºC'),
	(90477, 112, '2015-03-01 00:19:31.000000', 'temperatura', 458.0000, 'ºC'),
	(90478, 112, '2015-03-01 00:19:32.000000', 'temperatura', 196.0000, 'ºC'),
	(90479, 112, '2015-03-01 00:19:33.000000', 'temperatura', 808.0000, 'ºC'),
	(90480, 112, '2015-03-01 00:19:34.000000', 'temperatura', 1051.0000, 'ºC'),
	(90481, 112, '2015-03-01 00:19:35.000000', 'temperatura', 430.0000, 'ºC'),
	(90482, 112, '2015-03-01 00:19:36.000000', 'temperatura', 198.0000, 'ºC'),
	(90483, 112, '2015-03-01 00:19:37.000000', 'temperatura', 901.0000, 'ºC'),
	(90484, 112, '2015-03-01 00:19:38.000000', 'temperatura', 310.0000, 'ºC'),
	(90485, 112, '2015-03-01 00:19:39.000000', 'temperatura', 49.0000, 'ºC'),
	(90486, 112, '2015-03-01 00:19:40.000000', 'temperatura', 516.0000, 'ºC'),
	(90487, 112, '2015-03-01 00:19:41.000000', 'temperatura', 35.0000, 'ºC'),
	(90488, 112, '2015-03-01 00:19:42.000000', 'temperatura', 1024.0000, 'ºC'),
	(90489, 112, '2015-03-01 00:19:43.000000', 'temperatura', 217.0000, 'ºC'),
	(90490, 112, '2015-03-01 00:19:44.000000', 'temperatura', 413.0000, 'ºC'),
	(90491, 112, '2015-03-01 00:19:45.000000', 'temperatura', 216.0000, 'ºC'),
	(90492, 112, '2015-03-01 00:19:46.000000', 'temperatura', 1039.0000, 'ºC'),
	(90493, 112, '2015-03-01 00:19:47.000000', 'temperatura', 947.0000, 'ºC'),
	(90494, 112, '2015-03-01 00:19:48.000000', 'temperatura', 420.0000, 'ºC'),
	(90495, 112, '2015-03-01 00:19:49.000000', 'temperatura', 461.0000, 'ºC'),
	(90496, 112, '2015-03-01 00:19:50.000000', 'temperatura', 1043.0000, 'ºC'),
	(90497, 112, '2015-03-01 00:19:51.000000', 'temperatura', 233.0000, 'ºC'),
	(90498, 112, '2015-03-01 00:19:52.000000', 'temperatura', 435.0000, 'ºC'),
	(90499, 112, '2015-03-01 00:19:53.000000', 'temperatura', 278.0000, 'ºC'),
	(90500, 112, '2015-03-01 00:19:54.000000', 'temperatura', 86.0000, 'ºC'),
	(90501, 112, '2015-03-01 00:19:55.000000', 'temperatura', 795.0000, 'ºC'),
	(90502, 112, '2015-03-01 00:19:56.000000', 'temperatura', 119.0000, 'ºC'),
	(90503, 112, '2015-03-01 00:19:57.000000', 'temperatura', 610.0000, 'ºC'),
	(90504, 112, '2015-03-01 00:19:58.000000', 'temperatura', 295.0000, 'ºC'),
	(90505, 112, '2015-03-01 00:19:59.000000', 'temperatura', 843.0000, 'ºC'),
	(90506, 112, '2015-03-01 00:20:00.000000', 'temperatura', 932.0000, 'ºC'),
	(90507, 112, '2015-03-01 00:20:01.000000', 'temperatura', 933.0000, 'ºC'),
	(90508, 112, '2015-03-01 00:20:02.000000', 'temperatura', 668.0000, 'ºC'),
	(90509, 112, '2015-03-01 00:20:03.000000', 'temperatura', 543.0000, 'ºC'),
	(90510, 112, '2015-03-01 00:20:04.000000', 'temperatura', 713.0000, 'ºC'),
	(90511, 112, '2015-03-01 00:20:05.000000', 'temperatura', 733.0000, 'ºC'),
	(90512, 112, '2015-03-01 00:20:06.000000', 'temperatura', 330.0000, 'ºC'),
	(90513, 112, '2015-03-01 00:20:07.000000', 'temperatura', 649.0000, 'ºC'),
	(90514, 112, '2015-03-01 00:20:08.000000', 'temperatura', 1054.0000, 'ºC'),
	(90515, 112, '2015-03-01 00:20:09.000000', 'temperatura', 927.0000, 'ºC'),
	(90516, 112, '2015-03-01 00:20:10.000000', 'temperatura', 271.0000, 'ºC'),
	(90517, 112, '2015-03-01 00:20:11.000000', 'temperatura', 976.0000, 'ºC'),
	(90518, 112, '2015-03-01 00:20:12.000000', 'temperatura', 468.0000, 'ºC'),
	(90519, 112, '2015-03-01 00:20:13.000000', 'temperatura', 611.0000, 'ºC'),
	(90520, 112, '2015-03-01 00:20:14.000000', 'temperatura', 454.0000, 'ºC'),
	(90521, 112, '2015-03-01 00:20:15.000000', 'temperatura', 436.0000, 'ºC'),
	(90522, 112, '2015-03-01 00:20:16.000000', 'temperatura', 817.0000, 'ºC'),
	(90523, 112, '2015-03-01 00:20:17.000000', 'temperatura', 380.0000, 'ºC'),
	(90524, 112, '2015-03-01 00:20:18.000000', 'temperatura', 650.0000, 'ºC'),
	(90525, 112, '2015-03-01 00:20:19.000000', 'temperatura', 911.0000, 'ºC'),
	(90526, 112, '2015-03-01 00:20:20.000000', 'temperatura', 204.0000, 'ºC'),
	(90527, 112, '2015-03-01 00:20:21.000000', 'temperatura', 686.0000, 'ºC'),
	(90528, 112, '2015-03-01 00:20:22.000000', 'temperatura', 419.0000, 'ºC'),
	(90529, 112, '2015-03-01 00:20:23.000000', 'temperatura', 38.0000, 'ºC'),
	(90530, 112, '2015-03-01 00:20:24.000000', 'temperatura', 135.0000, 'ºC'),
	(90531, 112, '2015-03-01 00:20:25.000000', 'temperatura', 560.0000, 'ºC'),
	(90532, 112, '2015-03-01 00:20:26.000000', 'temperatura', 1196.0000, 'ºC'),
	(90533, 112, '2015-03-01 00:20:27.000000', 'temperatura', 700.0000, 'ºC'),
	(90534, 112, '2015-03-01 00:20:28.000000', 'temperatura', 1114.0000, 'ºC'),
	(90535, 112, '2015-03-01 00:20:29.000000', 'temperatura', 1069.0000, 'ºC'),
	(90536, 112, '2015-03-01 00:20:30.000000', 'temperatura', 805.0000, 'ºC'),
	(90537, 112, '2015-03-01 00:20:31.000000', 'temperatura', 816.0000, 'ºC'),
	(90538, 112, '2015-03-01 00:20:32.000000', 'temperatura', 465.0000, 'ºC'),
	(90539, 112, '2015-03-01 00:20:33.000000', 'temperatura', 1079.0000, 'ºC'),
	(90540, 112, '2015-03-01 00:20:34.000000', 'temperatura', 401.0000, 'ºC'),
	(90541, 112, '2015-03-01 00:20:35.000000', 'temperatura', 1168.0000, 'ºC'),
	(90542, 112, '2015-03-01 00:20:36.000000', 'temperatura', 1037.0000, 'ºC'),
	(90543, 112, '2015-03-01 00:20:37.000000', 'temperatura', 482.0000, 'ºC'),
	(90544, 112, '2015-03-01 00:20:38.000000', 'temperatura', 499.0000, 'ºC'),
	(90545, 112, '2015-03-01 00:20:39.000000', 'temperatura', 1049.0000, 'ºC'),
	(90546, 112, '2015-03-01 00:20:40.000000', 'temperatura', 147.0000, 'ºC'),
	(90547, 112, '2015-03-01 00:20:41.000000', 'temperatura', 1191.0000, 'ºC'),
	(90548, 112, '2015-03-01 00:20:42.000000', 'temperatura', 715.0000, 'ºC'),
	(90549, 112, '2015-03-01 00:20:43.000000', 'temperatura', 3.0000, 'ºC'),
	(90550, 112, '2015-03-01 00:20:44.000000', 'temperatura', 271.0000, 'ºC'),
	(90551, 112, '2015-03-01 00:20:45.000000', 'temperatura', 145.0000, 'ºC'),
	(90552, 112, '2015-03-01 00:20:46.000000', 'temperatura', 1111.0000, 'ºC'),
	(90553, 112, '2015-03-01 00:20:47.000000', 'temperatura', 324.0000, 'ºC'),
	(90554, 112, '2015-03-01 00:20:48.000000', 'temperatura', 685.0000, 'ºC'),
	(90555, 112, '2015-03-01 00:20:49.000000', 'temperatura', 56.0000, 'ºC'),
	(90556, 112, '2015-03-01 00:20:50.000000', 'temperatura', 623.0000, 'ºC'),
	(90557, 112, '2015-03-01 00:20:51.000000', 'temperatura', 546.0000, 'ºC'),
	(90558, 112, '2015-03-01 00:20:52.000000', 'temperatura', 864.0000, 'ºC'),
	(90559, 112, '2015-03-01 00:20:53.000000', 'temperatura', 284.0000, 'ºC'),
	(90560, 112, '2015-03-01 00:20:54.000000', 'temperatura', 25.0000, 'ºC'),
	(90561, 112, '2015-03-01 00:20:55.000000', 'temperatura', 476.0000, 'ºC'),
	(90562, 112, '2015-03-01 00:20:56.000000', 'temperatura', 1105.0000, 'ºC'),
	(90563, 112, '2015-03-01 00:20:57.000000', 'temperatura', 499.0000, 'ºC'),
	(90564, 112, '2015-03-01 00:20:58.000000', 'temperatura', 379.0000, 'ºC'),
	(90565, 112, '2015-03-01 00:20:59.000000', 'temperatura', 400.0000, 'ºC'),
	(90566, 112, '2015-03-01 00:21:00.000000', 'temperatura', 861.0000, 'ºC'),
	(90567, 112, '2015-03-01 00:21:01.000000', 'temperatura', 705.0000, 'ºC'),
	(90568, 112, '2015-03-01 00:21:02.000000', 'temperatura', 945.0000, 'ºC'),
	(90569, 112, '2015-03-01 00:21:03.000000', 'temperatura', 210.0000, 'ºC'),
	(90570, 112, '2015-03-01 00:21:04.000000', 'temperatura', 615.0000, 'ºC'),
	(90571, 112, '2015-03-01 00:21:05.000000', 'temperatura', 48.0000, 'ºC'),
	(90572, 112, '2015-03-01 00:21:06.000000', 'temperatura', 792.0000, 'ºC'),
	(90573, 112, '2015-03-01 00:21:07.000000', 'temperatura', 218.0000, 'ºC'),
	(90574, 112, '2015-03-01 00:21:08.000000', 'temperatura', 1116.0000, 'ºC'),
	(90575, 112, '2015-03-01 00:21:09.000000', 'temperatura', 125.0000, 'ºC'),
	(90576, 112, '2015-03-01 00:21:10.000000', 'temperatura', 878.0000, 'ºC'),
	(90577, 112, '2015-03-01 00:21:11.000000', 'temperatura', 415.0000, 'ºC'),
	(90578, 112, '2015-03-01 00:21:12.000000', 'temperatura', 641.0000, 'ºC'),
	(90579, 112, '2015-03-01 00:21:13.000000', 'temperatura', 760.0000, 'ºC'),
	(90580, 112, '2015-03-01 00:21:14.000000', 'temperatura', 679.0000, 'ºC'),
	(90581, 112, '2015-03-01 00:21:15.000000', 'temperatura', 1114.0000, 'ºC'),
	(90582, 112, '2015-03-01 00:21:16.000000', 'temperatura', 1136.0000, 'ºC'),
	(90583, 112, '2015-03-01 00:21:17.000000', 'temperatura', 1137.0000, 'ºC'),
	(90584, 112, '2015-03-01 00:21:18.000000', 'temperatura', 1079.0000, 'ºC'),
	(90585, 112, '2015-03-01 00:21:19.000000', 'temperatura', 784.0000, 'ºC'),
	(90586, 112, '2015-03-01 00:21:20.000000', 'temperatura', 682.0000, 'ºC'),
	(90587, 112, '2015-03-01 00:21:21.000000', 'temperatura', 1059.0000, 'ºC'),
	(90588, 112, '2015-03-01 00:21:22.000000', 'temperatura', 851.0000, 'ºC'),
	(90589, 112, '2015-03-01 00:21:23.000000', 'temperatura', 1076.0000, 'ºC'),
	(90590, 112, '2015-03-01 00:21:24.000000', 'temperatura', 429.0000, 'ºC'),
	(90591, 112, '2015-03-01 00:21:25.000000', 'temperatura', 117.0000, 'ºC'),
	(90592, 112, '2015-03-01 00:21:26.000000', 'temperatura', 500.0000, 'ºC'),
	(90593, 112, '2015-03-01 00:21:27.000000', 'temperatura', 950.0000, 'ºC'),
	(90594, 112, '2015-03-01 00:21:28.000000', 'temperatura', 848.0000, 'ºC'),
	(90595, 112, '2015-03-01 00:21:29.000000', 'temperatura', 192.0000, 'ºC'),
	(90596, 112, '2015-03-01 00:21:30.000000', 'temperatura', 817.0000, 'ºC'),
	(90597, 112, '2015-03-01 00:21:31.000000', 'temperatura', 1108.0000, 'ºC'),
	(90598, 112, '2015-03-01 00:21:32.000000', 'temperatura', 690.0000, 'ºC'),
	(90599, 112, '2015-03-01 00:21:33.000000', 'temperatura', 127.0000, 'ºC'),
	(90600, 112, '2015-03-01 00:21:34.000000', 'temperatura', 966.0000, 'ºC'),
	(90601, 112, '2015-03-01 00:21:35.000000', 'temperatura', 847.0000, 'ºC'),
	(90602, 112, '2015-03-01 00:21:36.000000', 'temperatura', 138.0000, 'ºC'),
	(90603, 112, '2015-03-01 00:21:37.000000', 'temperatura', 551.0000, 'ºC'),
	(90604, 112, '2015-03-01 00:21:38.000000', 'temperatura', 1140.0000, 'ºC'),
	(90605, 112, '2015-03-01 00:21:39.000000', 'temperatura', 449.0000, 'ºC'),
	(90606, 112, '2015-03-01 00:21:40.000000', 'temperatura', 26.0000, 'ºC'),
	(90607, 112, '2015-03-01 00:21:41.000000', 'temperatura', 1184.0000, 'ºC'),
	(90608, 112, '2015-03-01 00:21:42.000000', 'temperatura', 1043.0000, 'ºC'),
	(90609, 112, '2015-03-01 00:21:43.000000', 'temperatura', 462.0000, 'ºC'),
	(90610, 112, '2015-03-01 00:21:44.000000', 'temperatura', 381.0000, 'ºC'),
	(90611, 112, '2015-03-01 00:21:45.000000', 'temperatura', 522.0000, 'ºC'),
	(90612, 112, '2015-03-01 00:21:46.000000', 'temperatura', 264.0000, 'ºC'),
	(90613, 112, '2015-03-01 00:21:47.000000', 'temperatura', 958.0000, 'ºC'),
	(90614, 112, '2015-03-01 00:21:48.000000', 'temperatura', 396.0000, 'ºC'),
	(90615, 112, '2015-03-01 00:21:49.000000', 'temperatura', 309.0000, 'ºC'),
	(90616, 112, '2015-03-01 00:21:50.000000', 'temperatura', 357.0000, 'ºC'),
	(90617, 112, '2015-03-01 00:21:51.000000', 'temperatura', 858.0000, 'ºC'),
	(90618, 112, '2015-03-01 00:21:52.000000', 'temperatura', 818.0000, 'ºC'),
	(90619, 112, '2015-03-01 00:21:53.000000', 'temperatura', 316.0000, 'ºC'),
	(90620, 112, '2015-03-01 00:21:54.000000', 'temperatura', 329.0000, 'ºC'),
	(90621, 112, '2015-03-01 00:21:55.000000', 'temperatura', 696.0000, 'ºC'),
	(90622, 112, '2015-03-01 00:21:56.000000', 'temperatura', 94.0000, 'ºC'),
	(90623, 112, '2015-03-01 00:21:57.000000', 'temperatura', 781.0000, 'ºC'),
	(90624, 112, '2015-03-01 00:21:58.000000', 'temperatura', 24.0000, 'ºC'),
	(90625, 112, '2015-03-01 00:21:59.000000', 'temperatura', 179.0000, 'ºC'),
	(90626, 112, '2015-03-01 00:22:00.000000', 'temperatura', 821.0000, 'ºC'),
	(90627, 112, '2015-03-01 00:22:01.000000', 'temperatura', 1170.0000, 'ºC'),
	(90628, 112, '2015-03-01 00:22:02.000000', 'temperatura', 986.0000, 'ºC'),
	(90629, 112, '2015-03-01 00:22:03.000000', 'temperatura', 223.0000, 'ºC'),
	(90630, 112, '2015-03-01 00:22:04.000000', 'temperatura', 555.0000, 'ºC'),
	(90631, 112, '2015-03-01 00:22:05.000000', 'temperatura', 906.0000, 'ºC'),
	(90632, 112, '2015-03-01 00:22:06.000000', 'temperatura', 467.0000, 'ºC'),
	(90633, 112, '2015-03-01 00:22:07.000000', 'temperatura', 815.0000, 'ºC'),
	(90634, 112, '2015-03-01 00:22:08.000000', 'temperatura', 278.0000, 'ºC'),
	(90635, 112, '2015-03-01 00:22:09.000000', 'temperatura', 144.0000, 'ºC'),
	(90636, 112, '2015-03-01 00:22:10.000000', 'temperatura', 1087.0000, 'ºC'),
	(90637, 112, '2015-03-01 00:22:11.000000', 'temperatura', 204.0000, 'ºC'),
	(90638, 112, '2015-03-01 00:22:12.000000', 'temperatura', 160.0000, 'ºC'),
	(90639, 112, '2015-03-01 00:22:13.000000', 'temperatura', 189.0000, 'ºC'),
	(90640, 112, '2015-03-01 00:22:14.000000', 'temperatura', 465.0000, 'ºC'),
	(90641, 112, '2015-03-01 00:22:15.000000', 'temperatura', 556.0000, 'ºC'),
	(90642, 112, '2015-03-01 00:22:16.000000', 'temperatura', 188.0000, 'ºC'),
	(90643, 112, '2015-03-01 00:22:17.000000', 'temperatura', 473.0000, 'ºC'),
	(90644, 112, '2015-03-01 00:22:18.000000', 'temperatura', 600.0000, 'ºC'),
	(90645, 112, '2015-03-01 00:22:19.000000', 'temperatura', 384.0000, 'ºC'),
	(90646, 112, '2015-03-01 00:22:20.000000', 'temperatura', 119.0000, 'ºC'),
	(90647, 112, '2015-03-01 00:22:21.000000', 'temperatura', 644.0000, 'ºC'),
	(90648, 112, '2015-03-01 00:22:22.000000', 'temperatura', 463.0000, 'ºC'),
	(90649, 112, '2015-03-01 00:22:23.000000', 'temperatura', 382.0000, 'ºC'),
	(90650, 112, '2015-03-01 00:22:24.000000', 'temperatura', 521.0000, 'ºC'),
	(90651, 112, '2015-03-01 00:22:25.000000', 'temperatura', 262.0000, 'ºC'),
	(90652, 112, '2015-03-01 00:22:26.000000', 'temperatura', 945.0000, 'ºC'),
	(90653, 112, '2015-03-01 00:22:27.000000', 'temperatura', 342.0000, 'ºC'),
	(90654, 112, '2015-03-01 00:22:28.000000', 'temperatura', 74.0000, 'ºC'),
	(90655, 112, '2015-03-01 00:22:29.000000', 'temperatura', 545.0000, 'ºC'),
	(90656, 112, '2015-03-01 00:22:30.000000', 'temperatura', 104.0000, 'ºC'),
	(90657, 112, '2015-03-01 00:22:31.000000', 'temperatura', 85.0000, 'ºC'),
	(90658, 112, '2015-03-01 00:22:32.000000', 'temperatura', 115.0000, 'ºC'),
	(90659, 112, '2015-03-01 00:22:33.000000', 'temperatura', 317.0000, 'ºC'),
	(90660, 112, '2015-03-01 00:22:34.000000', 'temperatura', 44.0000, 'ºC'),
	(90661, 112, '2015-03-01 00:22:35.000000', 'temperatura', 469.0000, 'ºC'),
	(90662, 112, '2015-03-01 00:22:36.000000', 'temperatura', 1015.0000, 'ºC'),
	(90663, 112, '2015-03-01 00:22:37.000000', 'temperatura', 65.0000, 'ºC'),
	(90664, 112, '2015-03-01 00:22:38.000000', 'temperatura', 882.0000, 'ºC'),
	(90665, 112, '2015-03-01 00:22:39.000000', 'temperatura', 615.0000, 'ºC'),
	(90666, 112, '2015-03-01 00:22:40.000000', 'temperatura', 430.0000, 'ºC'),
	(90667, 112, '2015-03-01 00:22:41.000000', 'temperatura', 303.0000, 'ºC'),
	(90668, 112, '2015-03-01 00:22:42.000000', 'temperatura', 229.0000, 'ºC'),
	(90669, 112, '2015-03-01 00:22:43.000000', 'temperatura', 236.0000, 'ºC'),
	(90670, 112, '2015-03-01 00:22:44.000000', 'temperatura', 491.0000, 'ºC'),
	(90671, 112, '2015-03-01 00:22:45.000000', 'temperatura', 550.0000, 'ºC'),
	(90672, 112, '2015-03-01 00:22:46.000000', 'temperatura', 78.0000, 'ºC'),
	(90673, 112, '2015-03-01 00:22:47.000000', 'temperatura', 1140.0000, 'ºC'),
	(90674, 112, '2015-03-01 00:22:48.000000', 'temperatura', 664.0000, 'ºC'),
	(90675, 112, '2015-03-01 00:22:49.000000', 'temperatura', 1102.0000, 'ºC'),
	(90676, 112, '2015-03-01 00:22:50.000000', 'temperatura', 1120.0000, 'ºC'),
	(90677, 112, '2015-03-01 00:22:51.000000', 'temperatura', 1094.0000, 'ºC'),
	(90678, 112, '2015-03-01 00:22:52.000000', 'temperatura', 910.0000, 'ºC'),
	(90679, 112, '2015-03-01 00:22:53.000000', 'temperatura', 67.0000, 'ºC'),
	(90680, 112, '2015-03-01 00:22:54.000000', 'temperatura', 6.0000, 'ºC'),
	(90681, 112, '2015-03-01 00:22:55.000000', 'temperatura', 1029.0000, 'ºC'),
	(90682, 112, '2015-03-01 00:22:56.000000', 'temperatura', 328.0000, 'ºC'),
	(90683, 112, '2015-03-01 00:22:57.000000', 'temperatura', 951.0000, 'ºC'),
	(90684, 112, '2015-03-01 00:22:58.000000', 'temperatura', 175.0000, 'ºC'),
	(90685, 112, '2015-03-01 00:22:59.000000', 'temperatura', 423.0000, 'ºC'),
	(90686, 112, '2015-03-01 00:23:00.000000', 'temperatura', 389.0000, 'ºC'),
	(90687, 112, '2015-03-01 00:23:01.000000', 'temperatura', 675.0000, 'ºC'),
	(90688, 112, '2015-03-01 00:23:02.000000', 'temperatura', 1008.0000, 'ºC'),
	(90689, 112, '2015-03-01 00:23:03.000000', 'temperatura', 618.0000, 'ºC'),
	(90690, 112, '2015-03-01 00:23:04.000000', 'temperatura', 65.0000, 'ºC'),
	(90691, 112, '2015-03-01 00:23:05.000000', 'temperatura', 870.0000, 'ºC'),
	(90692, 112, '2015-03-01 00:23:06.000000', 'temperatura', 556.0000, 'ºC'),
	(90693, 112, '2015-03-01 00:23:07.000000', 'temperatura', 171.0000, 'ºC'),
	(90694, 112, '2015-03-01 00:23:08.000000', 'temperatura', 386.0000, 'ºC'),
	(90695, 112, '2015-03-01 00:23:09.000000', 'temperatura', 220.0000, 'ºC'),
	(90696, 112, '2015-03-01 00:23:10.000000', 'temperatura', 1143.0000, 'ºC'),
	(90697, 112, '2015-03-01 00:23:11.000000', 'temperatura', 253.0000, 'ºC'),
	(90698, 112, '2015-03-01 00:23:12.000000', 'temperatura', 239.0000, 'ºC'),
	(90699, 112, '2015-03-01 00:23:13.000000', 'temperatura', 434.0000, 'ºC'),
	(90700, 112, '2015-03-01 00:23:14.000000', 'temperatura', 253.0000, 'ºC'),
	(90701, 112, '2015-03-01 00:23:15.000000', 'temperatura', 1165.0000, 'ºC'),
	(90702, 112, '2015-03-01 00:23:16.000000', 'temperatura', 267.0000, 'ºC'),
	(90703, 112, '2015-03-01 00:23:17.000000', 'temperatura', 240.0000, 'ºC'),
	(90704, 112, '2015-03-01 00:23:18.000000', 'temperatura', 399.0000, 'ºC'),
	(90705, 112, '2015-03-01 00:23:19.000000', 'temperatura', 77.0000, 'ºC'),
	(90706, 112, '2015-03-01 00:23:20.000000', 'temperatura', 387.0000, 'ºC'),
	(90707, 112, '2015-03-01 00:23:21.000000', 'temperatura', 506.0000, 'ºC'),
	(90708, 112, '2015-03-01 00:23:22.000000', 'temperatura', 167.0000, 'ºC'),
	(90709, 112, '2015-03-01 00:23:23.000000', 'temperatura', 518.0000, 'ºC'),
	(90710, 112, '2015-03-01 00:23:24.000000', 'temperatura', 890.0000, 'ºC'),
	(90711, 112, '2015-03-01 00:23:25.000000', 'temperatura', 497.0000, 'ºC'),
	(90712, 112, '2015-03-01 00:23:26.000000', 'temperatura', 1014.0000, 'ºC'),
	(90713, 112, '2015-03-01 00:23:27.000000', 'temperatura', 1182.0000, 'ºC'),
	(90714, 112, '2015-03-01 00:23:28.000000', 'temperatura', 469.0000, 'ºC'),
	(90715, 112, '2015-03-01 00:23:29.000000', 'temperatura', 1197.0000, 'ºC'),
	(90716, 112, '2015-03-01 00:23:30.000000', 'temperatura', 981.0000, 'ºC'),
	(90717, 112, '2015-03-01 00:23:31.000000', 'temperatura', 114.0000, 'ºC'),
	(90718, 112, '2015-03-01 00:23:32.000000', 'temperatura', 27.0000, 'ºC'),
	(90719, 112, '2015-03-01 00:23:33.000000', 'temperatura', 994.0000, 'ºC'),
	(90720, 112, '2015-03-01 00:23:34.000000', 'temperatura', 88.0000, 'ºC'),
	(90721, 112, '2015-03-01 00:23:35.000000', 'temperatura', 1058.0000, 'ºC'),
	(90722, 112, '2015-03-01 00:23:36.000000', 'temperatura', 226.0000, 'ºC'),
	(90723, 112, '2015-03-01 00:23:37.000000', 'temperatura', 358.0000, 'ºC'),
	(90724, 112, '2015-03-01 00:23:38.000000', 'temperatura', 1110.0000, 'ºC'),
	(90725, 112, '2015-03-01 00:23:39.000000', 'temperatura', 880.0000, 'ºC'),
	(90726, 112, '2015-03-01 00:23:40.000000', 'temperatura', 1070.0000, 'ºC'),
	(90727, 112, '2015-03-01 00:23:41.000000', 'temperatura', 308.0000, 'ºC'),
	(90728, 112, '2015-03-01 00:23:42.000000', 'temperatura', 732.0000, 'ºC'),
	(90729, 112, '2015-03-01 00:23:43.000000', 'temperatura', 337.0000, 'ºC'),
	(90730, 112, '2015-03-01 00:23:44.000000', 'temperatura', 691.0000, 'ºC'),
	(90731, 112, '2015-03-01 00:23:45.000000', 'temperatura', 41.0000, 'ºC'),
	(90732, 112, '2015-03-01 00:23:46.000000', 'temperatura', 536.0000, 'ºC'),
	(90733, 112, '2015-03-01 00:23:47.000000', 'temperatura', 157.0000, 'ºC'),
	(90734, 112, '2015-03-01 00:23:48.000000', 'temperatura', 375.0000, 'ºC'),
	(90735, 112, '2015-03-01 00:23:49.000000', 'temperatura', 205.0000, 'ºC'),
	(90736, 112, '2015-03-01 00:23:50.000000', 'temperatura', 1100.0000, 'ºC'),
	(90737, 112, '2015-03-01 00:23:51.000000', 'temperatura', 86.0000, 'ºC'),
	(90738, 112, '2015-03-01 00:23:52.000000', 'temperatura', 731.0000, 'ºC'),
	(90739, 112, '2015-03-01 00:23:53.000000', 'temperatura', 999.0000, 'ºC'),
	(90740, 112, '2015-03-01 00:23:54.000000', 'temperatura', 400.0000, 'ºC'),
	(90741, 112, '2015-03-01 00:23:55.000000', 'temperatura', 205.0000, 'ºC'),
	(90742, 112, '2015-03-01 00:23:56.000000', 'temperatura', 1027.0000, 'ºC'),
	(90743, 112, '2015-03-01 00:23:57.000000', 'temperatura', 918.0000, 'ºC'),
	(90744, 112, '2015-03-01 00:23:58.000000', 'temperatura', 309.0000, 'ºC'),
	(90745, 112, '2015-03-01 00:23:59.000000', 'temperatura', 1191.0000, 'ºC'),
	(90746, 112, '2015-03-01 00:24:00.000000', 'temperatura', 230.0000, 'ºC'),
	(90747, 112, '2015-03-01 00:24:01.000000', 'temperatura', 1176.0000, 'ºC'),
	(90748, 112, '2015-03-01 00:24:02.000000', 'temperatura', 393.0000, 'ºC'),
	(90749, 112, '2015-03-01 00:24:03.000000', 'temperatura', 836.0000, 'ºC'),
	(90750, 112, '2015-03-01 00:24:04.000000', 'temperatura', 601.0000, 'ºC'),
	(90751, 112, '2015-03-01 00:24:05.000000', 'temperatura', 496.0000, 'ºC'),
	(90752, 112, '2015-03-01 00:24:06.000000', 'temperatura', 680.0000, 'ºC'),
	(90753, 112, '2015-03-01 00:24:07.000000', 'temperatura', 711.0000, 'ºC'),
	(90754, 112, '2015-03-01 00:24:08.000000', 'temperatura', 314.0000, 'ºC'),
	(90755, 112, '2015-03-01 00:24:09.000000', 'temperatura', 640.0000, 'ºC'),
	(90756, 112, '2015-03-01 00:24:10.000000', 'temperatura', 1060.0000, 'ºC'),
	(90757, 112, '2015-03-01 00:24:11.000000', 'temperatura', 977.0000, 'ºC'),
	(90758, 112, '2015-03-01 00:24:12.000000', 'temperatura', 506.0000, 'ºC'),
	(90759, 112, '2015-03-01 00:24:13.000000', 'temperatura', 801.0000, 'ºC'),
	(90760, 112, '2015-03-01 00:24:14.000000', 'temperatura', 87.0000, 'ºC'),
	(90761, 112, '2015-03-01 00:24:15.000000', 'temperatura', 434.0000, 'ºC'),
	(90762, 112, '2015-03-01 00:24:16.000000', 'temperatura', 710.0000, 'ºC'),
	(90763, 112, '2015-03-01 00:24:17.000000', 'temperatura', 1047.0000, 'ºC'),
	(90764, 112, '2015-03-01 00:24:18.000000', 'temperatura', 706.0000, 'ºC'),
	(90765, 112, '2015-03-01 00:24:19.000000', 'temperatura', 390.0000, 'ºC'),
	(90766, 112, '2015-03-01 00:24:20.000000', 'temperatura', 1031.0000, 'ºC'),
	(90767, 112, '2015-03-01 00:24:21.000000', 'temperatura', 386.0000, 'ºC'),
	(90768, 112, '2015-03-01 00:24:22.000000', 'temperatura', 37.0000, 'ºC'),
	(90769, 112, '2015-03-01 00:24:23.000000', 'temperatura', 229.0000, 'ºC'),
	(90770, 112, '2015-03-01 00:24:24.000000', 'temperatura', 1032.0000, 'ºC'),
	(90771, 112, '2015-03-01 00:24:25.000000', 'temperatura', 875.0000, 'ºC'),
	(90772, 112, '2015-03-01 00:24:26.000000', 'temperatura', 80.0000, 'ºC'),
	(90773, 112, '2015-03-01 00:24:27.000000', 'temperatura', 175.0000, 'ºC'),
	(90774, 112, '2015-03-01 00:24:28.000000', 'temperatura', 636.0000, 'ºC'),
	(90775, 112, '2015-03-01 00:24:29.000000', 'temperatura', 256.0000, 'ºC'),
	(90776, 112, '2015-03-01 00:24:30.000000', 'temperatura', 570.0000, 'ºC'),
	(90777, 112, '2015-03-01 00:24:31.000000', 'temperatura', 885.0000, 'ºC'),
	(90778, 112, '2015-03-01 00:24:32.000000', 'temperatura', 315.0000, 'ºC'),
	(90779, 112, '2015-03-01 00:24:33.000000', 'temperatura', 122.0000, 'ºC'),
	(90780, 112, '2015-03-01 00:24:34.000000', 'temperatura', 865.0000, 'ºC'),
	(90781, 112, '2015-03-01 00:24:35.000000', 'temperatura', 358.0000, 'ºC'),
	(90782, 112, '2015-03-01 00:24:36.000000', 'temperatura', 395.0000, 'ºC'),
	(90783, 112, '2015-03-01 00:24:37.000000', 'temperatura', 904.0000, 'ºC'),
	(90784, 112, '2015-03-01 00:24:38.000000', 'temperatura', 935.0000, 'ºC'),
	(90785, 112, '2015-03-01 00:24:39.000000', 'temperatura', 764.0000, 'ºC'),
	(90786, 112, '2015-03-01 00:24:40.000000', 'temperatura', 1013.0000, 'ºC'),
	(90787, 112, '2015-03-01 00:24:41.000000', 'temperatura', 374.0000, 'ºC'),
	(90788, 112, '2015-03-01 00:24:42.000000', 'temperatura', 32.0000, 'ºC'),
	(90789, 112, '2015-03-01 00:24:43.000000', 'temperatura', 237.0000, 'ºC'),
	(90790, 112, '2015-03-01 00:24:44.000000', 'temperatura', 1090.0000, 'ºC'),
	(90791, 112, '2015-03-01 00:24:45.000000', 'temperatura', 1140.0000, 'ºC'),
	(90792, 112, '2015-03-01 00:24:46.000000', 'temperatura', 31.0000, 'ºC'),
	(90793, 112, '2015-03-01 00:24:47.000000', 'temperatura', 334.0000, 'ºC'),
	(90794, 112, '2015-03-01 00:24:48.000000', 'temperatura', 378.0000, 'ºC'),
	(90795, 112, '2015-03-01 00:24:49.000000', 'temperatura', 888.0000, 'ºC'),
	(90796, 112, '2015-03-01 00:24:50.000000', 'temperatura', 907.0000, 'ºC'),
	(90797, 112, '2015-03-01 00:24:51.000000', 'temperatura', 671.0000, 'ºC'),
	(90798, 112, '2015-03-01 00:24:52.000000', 'temperatura', 634.0000, 'ºC'),
	(90799, 112, '2015-03-01 00:24:53.000000', 'temperatura', 1158.0000, 'ºC'),
	(90800, 112, '2015-03-01 00:24:54.000000', 'temperatura', 288.0000, 'ºC'),
	(90801, 112, '2015-03-01 00:24:55.000000', 'temperatura', 365.0000, 'ºC'),
	(90802, 112, '2015-03-01 00:24:56.000000', 'temperatura', 964.0000, 'ºC'),
	(90803, 112, '2015-03-01 00:24:57.000000', 'temperatura', 125.0000, 'ºC'),
	(90804, 112, '2015-03-01 00:24:58.000000', 'temperatura', 132.0000, 'ºC'),
	(90805, 112, '2015-03-01 00:24:59.000000', 'temperatura', 288.0000, 'ºC'),
	(90806, 112, '2015-03-01 00:25:00.000000', 'temperatura', 1044.0000, 'ºC'),
	(90807, 112, '2015-03-01 00:25:01.000000', 'temperatura', 755.0000, 'ºC'),
	(90808, 112, '2015-03-01 00:25:02.000000', 'temperatura', 645.0000, 'ºC'),
	(90809, 112, '2015-03-01 00:25:03.000000', 'temperatura', 960.0000, 'ºC'),
	(90810, 112, '2015-03-01 00:25:04.000000', 'temperatura', 466.0000, 'ºC'),
	(90811, 112, '2015-03-01 00:25:05.000000', 'temperatura', 650.0000, 'ºC'),
	(90812, 112, '2015-03-01 00:25:06.000000', 'temperatura', 653.0000, 'ºC'),
	(90813, 112, '2015-03-01 00:25:07.000000', 'temperatura', 114.0000, 'ºC'),
	(90814, 112, '2015-03-01 00:25:08.000000', 'temperatura', 1011.0000, 'ºC'),
	(90815, 112, '2015-03-01 00:25:09.000000', 'temperatura', 1116.0000, 'ºC'),
	(90816, 112, '2015-03-01 00:25:10.000000', 'temperatura', 147.0000, 'ºC'),
	(90817, 112, '2015-03-01 00:25:11.000000', 'temperatura', 985.0000, 'ºC'),
	(90818, 112, '2015-03-01 00:25:12.000000', 'temperatura', 886.0000, 'ºC'),
	(90819, 112, '2015-03-01 00:25:13.000000', 'temperatura', 276.0000, 'ºC'),
	(90820, 112, '2015-03-01 00:25:14.000000', 'temperatura', 1121.0000, 'ºC'),
	(90821, 112, '2015-03-01 00:25:15.000000', 'temperatura', 1178.0000, 'ºC'),
	(90822, 112, '2015-03-01 00:25:16.000000', 'temperatura', 128.0000, 'ºC'),
	(90823, 112, '2015-03-01 00:25:17.000000', 'temperatura', 706.0000, 'ºC'),
	(90824, 112, '2015-03-01 00:25:18.000000', 'temperatura', 745.0000, 'ºC'),
	(90825, 112, '2015-03-01 00:25:19.000000', 'temperatura', 407.0000, 'ºC'),
	(90826, 112, '2015-03-01 00:25:20.000000', 'temperatura', 1001.0000, 'ºC'),
	(90827, 112, '2015-03-01 00:25:21.000000', 'temperatura', 187.0000, 'ºC'),
	(90828, 112, '2015-03-01 00:25:22.000000', 'temperatura', 330.0000, 'ºC'),
	(90829, 112, '2015-03-01 00:25:23.000000', 'temperatura', 1090.0000, 'ºC'),
	(90830, 112, '2015-03-01 00:25:24.000000', 'temperatura', 861.0000, 'ºC'),
	(90831, 112, '2015-03-01 00:25:25.000000', 'temperatura', 1036.0000, 'ºC'),
	(90832, 112, '2015-03-01 00:25:26.000000', 'temperatura', 196.0000, 'ºC'),
	(90833, 112, '2015-03-01 00:25:27.000000', 'temperatura', 272.0000, 'ºC'),
	(90834, 112, '2015-03-01 00:25:28.000000', 'temperatura', 773.0000, 'ºC'),
	(90835, 112, '2015-03-01 00:25:29.000000', 'temperatura', 650.0000, 'ºC'),
	(90836, 112, '2015-03-01 00:25:30.000000', 'temperatura', 931.0000, 'ºC'),
	(90837, 112, '2015-03-01 00:25:31.000000', 'temperatura', 304.0000, 'ºC'),
	(90838, 112, '2015-03-01 00:25:32.000000', 'temperatura', 1129.0000, 'ºC'),
	(90839, 112, '2015-03-01 00:25:33.000000', 'temperatura', 1131.0000, 'ºC'),
	(90840, 112, '2015-03-01 00:25:34.000000', 'temperatura', 1072.0000, 'ºC'),
	(90841, 112, '2015-03-01 00:25:35.000000', 'temperatura', 767.0000, 'ºC'),
	(90842, 112, '2015-03-01 00:25:36.000000', 'temperatura', 620.0000, 'ºC'),
	(90843, 112, '2015-03-01 00:25:37.000000', 'temperatura', 798.0000, 'ºC'),
	(90844, 112, '2015-03-01 00:25:38.000000', 'temperatura', 930.0000, 'ºC'),
	(90845, 112, '2015-03-01 00:25:39.000000', 'temperatura', 1056.0000, 'ºC'),
	(90846, 112, '2015-03-01 00:25:40.000000', 'temperatura', 92.0000, 'ºC'),
	(90847, 112, '2015-03-01 00:25:41.000000', 'temperatura', 891.0000, 'ºC'),
	(90848, 112, '2015-03-01 00:25:42.000000', 'temperatura', 582.0000, 'ºC'),
	(90849, 112, '2015-03-01 00:25:43.000000', 'temperatura', 238.0000, 'ºC'),
	(90850, 112, '2015-03-01 00:25:44.000000', 'temperatura', 641.0000, 'ºC'),
	(90851, 112, '2015-03-01 00:25:45.000000', 'temperatura', 94.0000, 'ºC'),
	(90852, 112, '2015-03-01 00:25:46.000000', 'temperatura', 946.0000, 'ºC'),
	(90853, 112, '2015-03-01 00:25:47.000000', 'temperatura', 848.0000, 'ºC'),
	(90854, 112, '2015-03-01 00:25:48.000000', 'temperatura', 205.0000, 'ºC'),
	(90855, 112, '2015-03-01 00:25:49.000000', 'temperatura', 882.0000, 'ºC'),
	(90856, 112, '2015-03-01 00:25:50.000000', 'temperatura', 193.0000, 'ºC'),
	(90857, 112, '2015-03-01 00:25:51.000000', 'temperatura', 722.0000, 'ºC'),
	(90858, 112, '2015-03-01 00:25:52.000000', 'temperatura', 630.0000, 'ºC'),
	(90859, 112, '2015-03-01 00:25:53.000000', 'temperatura', 986.0000, 'ºC'),
	(90860, 112, '2015-03-01 00:25:54.000000', 'temperatura', 639.0000, 'ºC'),
	(90861, 112, '2015-03-01 00:25:55.000000', 'temperatura', 239.0000, 'ºC'),
	(90862, 112, '2015-03-01 00:25:56.000000', 'temperatura', 477.0000, 'ºC'),
	(90863, 112, '2015-03-01 00:25:57.000000', 'temperatura', 468.0000, 'ºC'),
	(90864, 112, '2015-03-01 00:25:58.000000', 'temperatura', 912.0000, 'ºC'),
	(90865, 112, '2015-03-01 00:25:59.000000', 'temperatura', 756.0000, 'ºC'),
	(90866, 112, '2015-03-01 00:26:00.000000', 'temperatura', 1045.0000, 'ºC'),
	(90867, 112, '2015-03-01 00:26:01.000000', 'temperatura', 558.0000, 'ºC'),
	(90868, 112, '2015-03-01 00:26:02.000000', 'temperatura', 854.0000, 'ºC'),
	(90869, 112, '2015-03-01 00:26:03.000000', 'temperatura', 197.0000, 'ºC'),
	(90870, 112, '2015-03-01 00:26:04.000000', 'temperatura', 825.0000, 'ºC'),
	(90871, 112, '2015-03-01 00:26:05.000000', 'temperatura', 1136.0000, 'ºC'),
	(90872, 112, '2015-03-01 00:26:06.000000', 'temperatura', 802.0000, 'ºC'),
	(90873, 112, '2015-03-01 00:26:07.000000', 'temperatura', 602.0000, 'ºC'),
	(90874, 112, '2015-03-01 00:26:08.000000', 'temperatura', 605.0000, 'ºC'),
	(90875, 112, '2015-03-01 00:26:09.000000', 'temperatura', 21.0000, 'ºC'),
	(90876, 112, '2015-03-01 00:26:10.000000', 'temperatura', 690.0000, 'ºC'),
	(90877, 112, '2015-03-01 00:26:11.000000', 'temperatura', 989.0000, 'ºC'),
	(90878, 112, '2015-03-01 00:26:12.000000', 'temperatura', 475.0000, 'ºC'),
	(90879, 112, '2015-03-01 00:26:13.000000', 'temperatura', 606.0000, 'ºC'),
	(90880, 112, '2015-03-01 00:26:14.000000', 'temperatura', 408.0000, 'ºC'),
	(90881, 112, '2015-03-01 00:26:15.000000', 'temperatura', 222.0000, 'ºC'),
	(90882, 112, '2015-03-01 00:26:16.000000', 'temperatura', 1085.0000, 'ºC'),
	(90883, 112, '2015-03-01 00:26:17.000000', 'temperatura', 1161.0000, 'ºC'),
	(90884, 112, '2015-03-01 00:26:18.000000', 'temperatura', 151.0000, 'ºC'),
	(90885, 112, '2015-03-01 00:26:19.000000', 'temperatura', 870.0000, 'ºC'),
	(90886, 112, '2015-03-01 00:26:20.000000', 'temperatura', 299.0000, 'ºC'),
	(90887, 112, '2015-03-01 00:26:21.000000', 'temperatura', 87.0000, 'ºC'),
	(90888, 112, '2015-03-01 00:26:22.000000', 'temperatura', 738.0000, 'ºC'),
	(90889, 112, '2015-03-01 00:26:23.000000', 'temperatura', 1028.0000, 'ºC'),
	(90890, 112, '2015-03-01 00:26:24.000000', 'temperatura', 528.0000, 'ºC'),
	(90891, 112, '2015-03-01 00:26:25.000000', 'temperatura', 754.0000, 'ºC'),
	(90892, 112, '2015-03-01 00:26:26.000000', 'temperatura', 988.0000, 'ºC'),
	(90893, 112, '2015-03-01 00:26:27.000000', 'temperatura', 277.0000, 'ºC'),
	(90894, 112, '2015-03-01 00:26:28.000000', 'temperatura', 823.0000, 'ºC'),
	(90895, 112, '2015-03-01 00:26:29.000000', 'temperatura', 884.0000, 'ºC'),
	(90896, 112, '2015-03-01 00:26:30.000000', 'temperatura', 753.0000, 'ºC'),
	(90897, 112, '2015-03-01 00:26:31.000000', 'temperatura', 1112.0000, 'ºC'),
	(90898, 112, '2015-03-01 00:26:32.000000', 'temperatura', 900.0000, 'ºC'),
	(90899, 112, '2015-03-01 00:26:33.000000', 'temperatura', 1167.0000, 'ºC'),
	(90900, 112, '2015-03-01 00:26:34.000000', 'temperatura', 733.0000, 'ºC'),
	(90901, 112, '2015-03-01 00:26:35.000000', 'temperatura', 165.0000, 'ºC'),
	(90902, 112, '2015-03-01 00:26:36.000000', 'temperatura', 1027.0000, 'ºC'),
	(90903, 112, '2015-03-01 00:26:37.000000', 'temperatura', 1041.0000, 'ºC'),
	(90904, 112, '2015-03-01 00:26:38.000000', 'temperatura', 923.0000, 'ºC'),
	(90905, 112, '2015-03-01 00:26:39.000000', 'temperatura', 292.0000, 'ºC'),
	(90906, 112, '2015-03-01 00:26:40.000000', 'temperatura', 1092.0000, 'ºC'),
	(90907, 112, '2015-03-01 00:26:41.000000', 'temperatura', 983.0000, 'ºC'),
	(90908, 112, '2015-03-01 00:26:42.000000', 'temperatura', 440.0000, 'ºC'),
	(90909, 112, '2015-03-01 00:26:43.000000', 'temperatura', 451.0000, 'ºC'),
	(90910, 112, '2015-03-01 00:26:44.000000', 'temperatura', 935.0000, 'ºC'),
	(90911, 112, '2015-03-01 00:26:45.000000', 'temperatura', 924.0000, 'ºC'),
	(90912, 112, '2015-03-01 00:26:46.000000', 'temperatura', 616.0000, 'ºC'),
	(90913, 112, '2015-03-01 00:26:47.000000', 'temperatura', 306.0000, 'ºC'),
	(90914, 112, '2015-03-01 00:26:48.000000', 'temperatura', 883.0000, 'ºC'),
	(90915, 112, '2015-03-01 00:26:49.000000', 'temperatura', 1099.0000, 'ºC'),
	(90916, 112, '2015-03-01 00:26:50.000000', 'temperatura', 448.0000, 'ºC'),
	(90917, 112, '2015-03-01 00:26:51.000000', 'temperatura', 140.0000, 'ºC'),
	(90918, 112, '2015-03-01 00:26:52.000000', 'temperatura', 558.0000, 'ºC'),
	(90919, 112, '2015-03-01 00:26:53.000000', 'temperatura', 1170.0000, 'ºC'),
	(90920, 112, '2015-03-01 00:26:54.000000', 'temperatura', 578.0000, 'ºC'),
	(90921, 112, '2015-03-01 00:26:55.000000', 'temperatura', 579.0000, 'ºC'),
	(90922, 112, '2015-03-01 00:26:56.000000', 'temperatura', 1162.0000, 'ºC'),
	(90923, 112, '2015-03-01 00:26:57.000000', 'temperatura', 473.0000, 'ºC'),
	(90924, 112, '2015-03-01 00:26:58.000000', 'temperatura', 81.0000, 'ºC'),
	(90925, 112, '2015-03-01 00:26:59.000000', 'temperatura', 188.0000, 'ºC'),
	(90926, 112, '2015-03-01 00:27:00.000000', 'temperatura', 694.0000, 'ºC'),
	(90927, 112, '2015-03-01 00:27:01.000000', 'temperatura', 510.0000, 'ºC'),
	(90928, 112, '2015-03-01 00:27:02.000000', 'temperatura', 466.0000, 'ºC'),
	(90929, 112, '2015-03-01 00:27:03.000000', 'temperatura', 800.0000, 'ºC'),
	(90930, 112, '2015-03-01 00:27:04.000000', 'temperatura', 204.0000, 'ºC'),
	(90931, 112, '2015-03-01 00:27:05.000000', 'temperatura', 1021.0000, 'ºC'),
	(90932, 112, '2015-03-01 00:27:06.000000', 'temperatura', 892.0000, 'ºC'),
	(90933, 112, '2015-03-01 00:27:07.000000', 'temperatura', 197.0000, 'ºC'),
	(90934, 112, '2015-03-01 00:27:08.000000', 'temperatura', 712.0000, 'ºC'),
	(90935, 112, '2015-03-01 00:27:09.000000', 'temperatura', 568.0000, 'ºC'),
	(90936, 112, '2015-03-01 00:27:10.000000', 'temperatura', 704.0000, 'ºC'),
	(90937, 112, '2015-03-01 00:27:11.000000', 'temperatura', 615.0000, 'ºC'),
	(90938, 112, '2015-03-01 00:27:12.000000', 'temperatura', 964.0000, 'ºC'),
	(90939, 112, '2015-03-01 00:27:13.000000', 'temperatura', 577.0000, 'ºC'),
	(90940, 112, '2015-03-01 00:27:14.000000', 'temperatura', 1194.0000, 'ºC'),
	(90941, 112, '2015-03-01 00:27:15.000000', 'temperatura', 638.0000, 'ºC'),
	(90942, 112, '2015-03-01 00:27:16.000000', 'temperatura', 811.0000, 'ºC'),
	(90943, 112, '2015-03-01 00:27:17.000000', 'temperatura', 940.0000, 'ºC'),
	(90944, 112, '2015-03-01 00:27:18.000000', 'temperatura', 1067.0000, 'ºC'),
	(90945, 112, '2015-03-01 00:27:19.000000', 'temperatura', 116.0000, 'ºC'),
	(90946, 112, '2015-03-01 00:27:20.000000', 'temperatura', 981.0000, 'ºC'),
	(90947, 112, '2015-03-01 00:27:21.000000', 'temperatura', 956.0000, 'ºC'),
	(90948, 112, '2015-03-01 00:27:22.000000', 'temperatura', 639.0000, 'ºC'),
	(90949, 112, '2015-03-01 00:27:23.000000', 'temperatura', 327.0000, 'ºC'),
	(90950, 112, '2015-03-01 00:27:24.000000', 'temperatura', 917.0000, 'ºC'),
	(90951, 112, '2015-03-01 00:27:25.000000', 'temperatura', 4.0000, 'ºC'),
	(90952, 112, '2015-03-01 00:27:26.000000', 'temperatura', 872.0000, 'ºC'),
	(90953, 112, '2015-03-01 00:27:27.000000', 'temperatura', 746.0000, 'ºC'),
	(90954, 112, '2015-03-01 00:27:28.000000', 'temperatura', 1115.0000, 'ºC'),
	(90955, 112, '2015-03-01 00:27:29.000000', 'temperatura', 938.0000, 'ºC'),
	(90956, 112, '2015-03-01 00:27:30.000000', 'temperatura', 145.0000, 'ºC'),
	(90957, 112, '2015-03-01 00:27:31.000000', 'temperatura', 313.0000, 'ºC'),
	(90958, 112, '2015-03-01 00:27:32.000000', 'temperatura', 1128.0000, 'ºC'),
	(90959, 112, '2015-03-01 00:27:33.000000', 'temperatura', 1103.0000, 'ºC'),
	(90960, 112, '2015-03-01 00:27:34.000000', 'temperatura', 933.0000, 'ºC'),
	(90961, 112, '2015-03-01 00:27:35.000000', 'temperatura', 155.0000, 'ºC'),
	(90962, 112, '2015-03-01 00:27:36.000000', 'temperatura', 376.0000, 'ºC'),
	(90963, 112, '2015-03-01 00:27:37.000000', 'temperatura', 217.0000, 'ºC'),
	(90964, 112, '2015-03-01 00:27:38.000000', 'temperatura', 1159.0000, 'ºC'),
	(90965, 112, '2015-03-01 00:27:39.000000', 'temperatura', 342.0000, 'ºC'),
	(90966, 112, '2015-03-01 00:27:40.000000', 'temperatura', 633.0000, 'ºC'),
	(90967, 112, '2015-03-01 00:27:41.000000', 'temperatura', 939.0000, 'ºC'),
	(90968, 112, '2015-03-01 00:27:42.000000', 'temperatura', 399.0000, 'ºC'),
	(90969, 112, '2015-03-01 00:27:43.000000', 'temperatura', 377.0000, 'ºC'),
	(90970, 112, '2015-03-01 00:27:44.000000', 'temperatura', 687.0000, 'ºC'),
	(90971, 112, '2015-03-01 00:27:45.000000', 'temperatura', 1105.0000, 'ºC'),
	(90972, 112, '2015-03-01 00:27:46.000000', 'temperatura', 1065.0000, 'ºC'),
	(90973, 112, '2015-03-01 00:27:47.000000', 'temperatura', 809.0000, 'ºC'),
	(90974, 112, '2015-03-01 00:27:48.000000', 'temperatura', 850.0000, 'ºC'),
	(90975, 112, '2015-03-01 00:27:49.000000', 'temperatura', 625.0000, 'ºC'),
	(90976, 112, '2015-03-01 00:27:50.000000', 'temperatura', 574.0000, 'ºC'),
	(90977, 112, '2015-03-01 00:27:51.000000', 'temperatura', 996.0000, 'ºC'),
	(90978, 112, '2015-03-01 00:27:52.000000', 'temperatura', 859.0000, 'ºC'),
	(90979, 112, '2015-03-01 00:27:53.000000', 'temperatura', 106.0000, 'ºC'),
	(90980, 112, '2015-03-01 00:27:54.000000', 'temperatura', 353.0000, 'ºC'),
	(90981, 112, '2015-03-01 00:27:55.000000', 'temperatura', 249.0000, 'ºC'),
	(90982, 112, '2015-03-01 00:27:56.000000', 'temperatura', 188.0000, 'ºC'),
	(90983, 112, '2015-03-01 00:27:57.000000', 'temperatura', 193.0000, 'ºC'),
	(90984, 112, '2015-03-01 00:27:58.000000', 'temperatura', 401.0000, 'ºC'),
	(90985, 112, '2015-03-01 00:27:59.000000', 'temperatura', 228.0000, 'ºC'),
	(90986, 112, '2015-03-01 00:28:00.000000', 'temperatura', 1134.0000, 'ºC'),
	(90987, 112, '2015-03-01 00:28:01.000000', 'temperatura', 190.0000, 'ºC'),
	(90988, 112, '2015-03-01 00:28:02.000000', 'temperatura', 1147.0000, 'ºC'),
	(90989, 112, '2015-03-01 00:28:03.000000', 'temperatura', 367.0000, 'ºC'),
	(90990, 112, '2015-03-01 00:28:04.000000', 'temperatura', 795.0000, 'ºC'),
	(90991, 112, '2015-03-01 00:28:05.000000', 'temperatura', 472.0000, 'ºC'),
	(90992, 112, '2015-03-01 00:28:06.000000', 'temperatura', 1176.0000, 'ºC'),
	(90993, 112, '2015-03-01 00:28:07.000000', 'temperatura', 863.0000, 'ºC'),
	(90994, 112, '2015-03-01 00:28:08.000000', 'temperatura', 789.0000, 'ºC'),
	(90995, 112, '2015-03-01 00:28:09.000000', 'temperatura', 157.0000, 'ºC'),
	(90996, 112, '2015-03-01 00:28:10.000000', 'temperatura', 820.0000, 'ºC'),
	(90997, 112, '2015-03-01 00:28:11.000000', 'temperatura', 28.0000, 'ºC'),
	(90998, 112, '2015-03-01 00:28:12.000000', 'temperatura', 80.0000, 'ºC'),
	(90999, 112, '2015-03-01 00:28:13.000000', 'temperatura', 315.0000, 'ºC'),
	(91000, 112, '2015-03-01 00:28:14.000000', 'temperatura', 137.0000, 'ºC'),
	(91001, 112, '2015-03-01 00:28:15.000000', 'temperatura', 939.0000, 'ºC'),
	(91002, 112, '2015-03-01 00:28:16.000000', 'temperatura', 685.0000, 'ºC'),
	(91003, 112, '2015-03-01 00:28:17.000000', 'temperatura', 607.0000, 'ºC'),
	(91004, 112, '2015-03-01 00:28:18.000000', 'temperatura', 981.0000, 'ºC'),
	(91005, 112, '2015-03-01 00:28:19.000000', 'temperatura', 684.0000, 'ºC'),
	(91006, 112, '2015-03-01 00:28:20.000000', 'temperatura', 480.0000, 'ºC'),
	(91007, 112, '2015-03-01 00:28:21.000000', 'temperatura', 347.0000, 'ºC'),
	(91008, 112, '2015-03-01 00:28:22.000000', 'temperatura', 297.0000, 'ºC'),
	(91009, 112, '2015-03-01 00:28:23.000000', 'temperatura', 443.0000, 'ºC'),
	(91010, 112, '2015-03-01 00:28:24.000000', 'temperatura', 123.0000, 'ºC'),
	(91011, 112, '2015-03-01 00:28:25.000000', 'temperatura', 487.0000, 'ºC'),
	(91012, 112, '2015-03-01 00:28:26.000000', 'temperatura', 869.0000, 'ºC'),
	(91013, 112, '2015-03-01 00:28:27.000000', 'temperatura', 481.0000, 'ºC'),
	(91014, 112, '2015-03-01 00:28:28.000000', 'temperatura', 1001.0000, 'ºC'),
	(91015, 112, '2015-03-01 00:28:29.000000', 'temperatura', 1162.0000, 'ºC'),
	(91016, 112, '2015-03-01 00:28:30.000000', 'temperatura', 409.0000, 'ºC'),
	(91017, 112, '2015-03-01 00:28:31.000000', 'temperatura', 958.0000, 'ºC'),
	(91018, 112, '2015-03-01 00:28:32.000000', 'temperatura', 1166.0000, 'ºC'),
	(91019, 112, '2015-03-01 00:28:33.000000', 'temperatura', 554.0000, 'ºC'),
	(91020, 112, '2015-03-01 00:28:34.000000', 'temperatura', 475.0000, 'ºC'),
	(91021, 112, '2015-03-01 00:28:35.000000', 'temperatura', 711.0000, 'ºC'),
	(91022, 112, '2015-03-01 00:28:36.000000', 'temperatura', 932.0000, 'ºC'),
	(91023, 112, '2015-03-01 00:28:37.000000', 'temperatura', 129.0000, 'ºC'),
	(91024, 112, '2015-03-01 00:28:38.000000', 'temperatura', 248.0000, 'ºC'),
	(91025, 112, '2015-03-01 00:28:39.000000', 'temperatura', 855.0000, 'ºC'),
	(91026, 112, '2015-03-01 00:28:40.000000', 'temperatura', 1130.0000, 'ºC'),
	(91027, 112, '2015-03-01 00:28:41.000000', 'temperatura', 685.0000, 'ºC'),
	(91028, 112, '2015-03-01 00:28:42.000000', 'temperatura', 35.0000, 'ºC'),
	(91029, 112, '2015-03-01 00:28:43.000000', 'temperatura', 522.0000, 'ºC'),
	(91030, 112, '2015-03-01 00:28:44.000000', 'temperatura', 105.0000, 'ºC'),
	(91031, 112, '2015-03-01 00:28:45.000000', 'temperatura', 161.0000, 'ºC'),
	(91032, 112, '2015-03-01 00:28:46.000000', 'temperatura', 488.0000, 'ºC'),
	(91033, 112, '2015-03-01 00:28:47.000000', 'temperatura', 760.0000, 'ºC'),
	(91034, 112, '2015-03-01 00:28:48.000000', 'temperatura', 1136.0000, 'ºC'),
	(91035, 112, '2015-03-01 00:28:49.000000', 'temperatura', 1001.0000, 'ºC'),
	(91036, 112, '2015-03-01 00:28:50.000000', 'temperatura', 397.0000, 'ºC'),
	(91037, 112, '2015-03-01 00:28:51.000000', 'temperatura', 184.0000, 'ºC'),
	(91038, 112, '2015-03-01 00:28:52.000000', 'temperatura', 927.0000, 'ºC'),
	(91039, 112, '2015-03-01 00:28:53.000000', 'temperatura', 483.0000, 'ºC'),
	(91040, 112, '2015-03-01 00:28:54.000000', 'temperatura', 833.0000, 'ºC'),
	(91041, 112, '2015-03-01 00:28:55.000000', 'temperatura', 320.0000, 'ºC'),
	(91042, 112, '2015-03-01 00:28:56.000000', 'temperatura', 301.0000, 'ºC'),
	(91043, 112, '2015-03-01 00:28:57.000000', 'temperatura', 546.0000, 'ºC'),
	(91044, 112, '2015-03-01 00:28:58.000000', 'temperatura', 626.0000, 'ºC'),
	(91045, 112, '2015-03-01 00:28:59.000000', 'temperatura', 294.0000, 'ºC'),
	(91046, 112, '2015-03-01 00:29:00.000000', 'temperatura', 792.0000, 'ºC'),
	(91047, 112, '2015-03-01 00:29:01.000000', 'temperatura', 678.0000, 'ºC'),
	(91048, 112, '2015-03-01 00:29:02.000000', 'temperatura', 1014.0000, 'ºC'),
	(91049, 112, '2015-03-01 00:29:03.000000', 'temperatura', 637.0000, 'ºC'),
	(91050, 112, '2015-03-01 00:29:04.000000', 'temperatura', 144.0000, 'ºC'),
	(91051, 112, '2015-03-01 00:29:05.000000', 'temperatura', 10.0000, 'ºC'),
	(91052, 112, '2015-03-01 00:29:06.000000', 'temperatura', 817.0000, 'ºC'),
	(91053, 112, '2015-03-01 00:29:07.000000', 'temperatura', 455.0000, 'ºC'),
	(91054, 112, '2015-03-01 00:29:08.000000', 'temperatura', 1024.0000, 'ºC'),
	(91055, 112, '2015-03-01 00:29:09.000000', 'temperatura', 156.0000, 'ºC'),
	(91056, 112, '2015-03-01 00:29:10.000000', 'temperatura', 110.0000, 'ºC'),
	(91057, 112, '2015-03-01 00:29:11.000000', 'temperatura', 80.0000, 'ºC'),
	(91058, 112, '2015-03-01 00:29:12.000000', 'temperatura', 71.0000, 'ºC'),
	(91059, 112, '2015-03-01 00:29:13.000000', 'temperatura', 115.0000, 'ºC'),
	(91060, 112, '2015-03-01 00:29:14.000000', 'temperatura', 365.0000, 'ºC'),
	(91061, 112, '2015-03-01 00:29:15.000000', 'temperatura', 279.0000, 'ºC'),
	(91062, 112, '2015-03-01 00:29:16.000000', 'temperatura', 299.0000, 'ºC'),
	(91063, 112, '2015-03-01 00:29:17.000000', 'temperatura', 659.0000, 'ºC'),
	(91064, 112, '2015-03-01 00:29:18.000000', 'temperatura', 1198.0000, 'ºC'),
	(91065, 112, '2015-03-01 00:29:19.000000', 'temperatura', 412.0000, 'ºC'),
	(91066, 112, '2015-03-01 00:29:20.000000', 'temperatura', 869.0000, 'ºC'),
	(91067, 112, '2015-03-01 00:29:21.000000', 'temperatura', 708.0000, 'ºC'),
	(91068, 112, '2015-03-01 00:29:22.000000', 'temperatura', 934.0000, 'ºC'),
	(91069, 112, '2015-03-01 00:29:23.000000', 'temperatura', 146.0000, 'ºC'),
	(91070, 112, '2015-03-01 00:29:24.000000', 'temperatura', 330.0000, 'ºC'),
	(91071, 112, '2015-03-01 00:29:25.000000', 'temperatura', 11.0000, 'ºC'),
	(91072, 112, '2015-03-01 00:29:26.000000', 'temperatura', 268.0000, 'ºC'),
	(91073, 112, '2015-03-01 00:29:27.000000', 'temperatura', 104.0000, 'ºC'),
	(91074, 112, '2015-03-01 00:29:28.000000', 'temperatura', 920.0000, 'ºC'),
	(91075, 112, '2015-03-01 00:29:29.000000', 'temperatura', 685.0000, 'ºC'),
	(91076, 112, '2015-03-01 00:29:30.000000', 'temperatura', 668.0000, 'ºC'),
	(91077, 112, '2015-03-01 00:29:31.000000', 'temperatura', 87.0000, 'ºC'),
	(91078, 112, '2015-03-01 00:29:32.000000', 'temperatura', 829.0000, 'ºC'),
	(91079, 112, '2015-03-01 00:29:33.000000', 'temperatura', 285.0000, 'ºC'),
	(91080, 112, '2015-03-01 00:29:34.000000', 'temperatura', 140.0000, 'ºC'),
	(91081, 112, '2015-03-01 00:29:35.000000', 'temperatura', 1045.0000, 'ºC'),
	(91082, 112, '2015-03-01 00:29:36.000000', 'temperatura', 7.0000, 'ºC'),
	(91083, 112, '2015-03-01 00:29:37.000000', 'temperatura', 497.0000, 'ºC'),
	(91084, 112, '2015-03-01 00:29:38.000000', 'temperatura', 68.0000, 'ºC'),
	(91085, 112, '2015-03-01 00:29:39.000000', 'temperatura', 47.0000, 'ºC'),
	(91086, 112, '2015-03-01 00:29:40.000000', 'temperatura', 32.0000, 'ºC'),
	(91087, 112, '2015-03-01 00:29:41.000000', 'temperatura', 22.0000, 'ºC'),
	(91088, 112, '2015-03-01 00:29:42.000000', 'temperatura', 12.0000, 'ºC'),
	(91089, 112, '2015-03-01 00:29:43.000000', 'temperatura', 1196.0000, 'ºC'),
	(91090, 112, '2015-03-01 00:29:44.000000', 'temperatura', 1143.0000, 'ºC'),
	(91091, 112, '2015-03-01 00:29:45.000000', 'temperatura', 930.0000, 'ºC'),
	(91092, 112, '2015-03-01 00:29:46.000000', 'temperatura', 21.0000, 'ºC'),
	(91093, 112, '2015-03-01 00:29:47.000000', 'temperatura', 916.0000, 'ºC'),
	(91094, 112, '2015-03-01 00:29:48.000000', 'temperatura', 919.0000, 'ºC'),
	(91095, 112, '2015-03-01 00:29:49.000000', 'temperatura', 644.0000, 'ºC'),
	(91096, 112, '2015-03-01 00:29:50.000000', 'temperatura', 465.0000, 'ºC'),
	(91097, 112, '2015-03-01 00:29:51.000000', 'temperatura', 394.0000, 'ºC'),
	(91098, 112, '2015-03-01 00:29:52.000000', 'temperatura', 574.0000, 'ºC'),
	(91099, 112, '2015-03-01 00:29:53.000000', 'temperatura', 488.0000, 'ºC'),
	(91100, 112, '2015-03-01 00:29:54.000000', 'temperatura', 719.0000, 'ºC'),
	(91101, 112, '2015-03-01 00:29:55.000000', 'temperatura', 933.0000, 'ºC'),
	(91102, 112, '2015-03-01 00:29:56.000000', 'temperatura', 109.0000, 'ºC'),
	(91103, 112, '2015-03-01 00:29:57.000000', 'temperatura', 144.0000, 'ºC'),
	(91104, 112, '2015-03-01 00:29:58.000000', 'temperatura', 394.0000, 'ºC'),
	(91105, 112, '2015-03-01 00:29:59.000000', 'temperatura', 339.0000, 'ºC'),
	(91106, 112, '2015-03-01 00:30:00.000000', 'temperatura', 514.0000, 'ºC'),
	(91107, 112, '2015-03-01 00:30:01.000000', 'temperatura', 353.0000, 'ºC'),
	(91108, 112, '2015-03-01 00:30:02.000000', 'temperatura', 225.0000, 'ºC'),
	(91109, 112, '2015-03-01 00:30:03.000000', 'temperatura', 65.0000, 'ºC'),
	(91110, 112, '2015-03-01 00:30:04.000000', 'temperatura', 850.0000, 'ºC'),
	(91111, 112, '2015-03-01 00:30:05.000000', 'temperatura', 458.0000, 'ºC'),
	(91112, 112, '2015-03-01 00:30:06.000000', 'temperatura', 939.0000, 'ºC'),
	(91113, 112, '2015-03-01 00:30:07.000000', 'temperatura', 922.0000, 'ºC'),
	(91114, 112, '2015-03-01 00:30:08.000000', 'temperatura', 592.0000, 'ºC'),
	(91115, 112, '2015-03-01 00:30:09.000000', 'temperatura', 194.0000, 'ºC'),
	(91116, 112, '2015-03-01 00:30:10.000000', 'temperatura', 396.0000, 'ºC'),
	(91117, 112, '2015-03-01 00:30:11.000000', 'temperatura', 196.0000, 'ºC'),
	(91118, 112, '2015-03-01 00:30:12.000000', 'temperatura', 994.0000, 'ºC'),
	(91119, 112, '2015-03-01 00:30:13.000000', 'temperatura', 785.0000, 'ºC'),
	(91120, 112, '2015-03-01 00:30:14.000000', 'temperatura', 940.0000, 'ºC'),
	(91121, 112, '2015-03-01 00:30:15.000000', 'temperatura', 1146.0000, 'ºC'),
	(91122, 112, '2015-03-01 00:30:16.000000', 'temperatura', 509.0000, 'ºC'),
	(91123, 112, '2015-03-01 00:30:17.000000', 'temperatura', 308.0000, 'ºC'),
	(91124, 112, '2015-03-01 00:30:18.000000', 'temperatura', 16.0000, 'ºC'),
	(91125, 112, '2015-03-01 00:30:19.000000', 'temperatura', 353.0000, 'ºC'),
	(91126, 112, '2015-03-01 00:30:20.000000', 'temperatura', 521.0000, 'ºC'),
	(91127, 112, '2015-03-01 00:30:21.000000', 'temperatura', 345.0000, 'ºC'),
	(91128, 112, '2015-03-01 00:30:22.000000', 'temperatura', 163.0000, 'ºC'),
	(91129, 112, '2015-03-01 00:30:23.000000', 'temperatura', 982.0000, 'ºC'),
	(91130, 112, '2015-03-01 00:30:24.000000', 'temperatura', 819.0000, 'ºC'),
	(91131, 112, '2015-03-01 00:30:25.000000', 'temperatura', 1149.0000, 'ºC'),
	(91132, 112, '2015-03-01 00:30:26.000000', 'temperatura', 891.0000, 'ºC'),
	(91133, 112, '2015-03-01 00:30:27.000000', 'temperatura', 1007.0000, 'ºC'),
	(91134, 112, '2015-03-01 00:30:28.000000', 'temperatura', 1161.0000, 'ºC'),
	(91135, 112, '2015-03-01 00:30:29.000000', 'temperatura', 386.0000, 'ºC'),
	(91136, 112, '2015-03-01 00:30:30.000000', 'temperatura', 848.0000, 'ºC'),
	(91137, 112, '2015-03-01 00:30:31.000000', 'temperatura', 684.0000, 'ºC'),
	(91138, 112, '2015-03-01 00:30:32.000000', 'temperatura', 874.0000, 'ºC'),
	(91139, 112, '2015-03-01 00:30:33.000000', 'temperatura', 1118.0000, 'ºC'),
	(91140, 112, '2015-03-01 00:30:34.000000', 'temperatura', 569.0000, 'ºC'),
	(91141, 112, '2015-03-01 00:30:35.000000', 'temperatura', 692.0000, 'ºC'),
	(91142, 112, '2015-03-01 00:30:36.000000', 'temperatura', 554.0000, 'ºC'),
	(91143, 112, '2015-03-01 00:30:37.000000', 'temperatura', 695.0000, 'ºC'),
	(91144, 112, '2015-03-01 00:30:38.000000', 'temperatura', 613.0000, 'ºC'),
	(91145, 112, '2015-03-01 00:30:39.000000', 'temperatura', 980.0000, 'ºC'),
	(91146, 112, '2015-03-01 00:30:40.000000', 'temperatura', 662.0000, 'ºC'),
	(91147, 112, '2015-03-01 00:30:41.000000', 'temperatura', 371.0000, 'ºC'),
	(91148, 112, '2015-03-01 00:30:42.000000', 'temperatura', 1071.0000, 'ºC'),
	(91149, 112, '2015-03-01 00:30:43.000000', 'temperatura', 640.0000, 'ºC'),
	(91150, 112, '2015-03-01 00:30:44.000000', 'temperatura', 1187.0000, 'ºC'),
	(91151, 112, '2015-03-01 00:30:45.000000', 'temperatura', 417.0000, 'ºC'),
	(91152, 112, '2015-03-01 00:30:46.000000', 'temperatura', 925.0000, 'ºC'),
	(91153, 112, '2015-03-01 00:30:47.000000', 'temperatura', 975.0000, 'ºC'),
	(91154, 112, '2015-03-01 00:30:48.000000', 'temperatura', 900.0000, 'ºC'),
	(91155, 112, '2015-03-01 00:30:49.000000', 'temperatura', 375.0000, 'ºC'),
	(91156, 112, '2015-03-01 00:30:50.000000', 'temperatura', 374.0000, 'ºC'),
	(91157, 112, '2015-03-01 00:30:51.000000', 'temperatura', 747.0000, 'ºC'),
	(91158, 112, '2015-03-01 00:30:52.000000', 'temperatura', 212.0000, 'ºC'),
	(91159, 112, '2015-03-01 00:30:53.000000', 'temperatura', 21.0000, 'ºC'),
	(91160, 112, '2015-03-01 00:30:54.000000', 'temperatura', 670.0000, 'ºC'),
	(91161, 112, '2015-03-01 00:30:55.000000', 'temperatura', 887.0000, 'ºC'),
	(91162, 112, '2015-03-01 00:30:56.000000', 'temperatura', 26.0000, 'ºC'),
	(91163, 112, '2015-03-01 00:30:57.000000', 'temperatura', 1069.0000, 'ºC'),
	(91164, 112, '2015-03-01 00:30:58.000000', 'temperatura', 466.0000, 'ºC'),
	(91165, 112, '2015-03-01 00:30:59.000000', 'temperatura', 323.0000, 'ºC'),
	(91166, 112, '2015-03-01 00:31:00.000000', 'temperatura', 220.0000, 'ºC'),
	(91167, 112, '2015-03-01 00:31:01.000000', 'temperatura', 132.0000, 'ºC'),
	(91168, 112, '2015-03-01 00:31:02.000000', 'temperatura', 1.0000, 'ºC'),
	(91169, 112, '2015-03-01 00:31:03.000000', 'temperatura', 809.0000, 'ºC'),
	(91170, 112, '2015-03-01 00:31:04.000000', 'temperatura', 444.0000, 'ºC'),
	(91171, 112, '2015-03-01 00:31:05.000000', 'temperatura', 992.0000, 'ºC'),
	(91172, 112, '2015-03-01 00:31:06.000000', 'temperatura', 28.0000, 'ºC'),
	(91173, 112, '2015-03-01 00:31:07.000000', 'temperatura', 766.0000, 'ºC'),
	(91174, 112, '2015-03-01 00:31:08.000000', 'temperatura', 144.0000, 'ºC'),
	(91175, 112, '2015-03-01 00:31:09.000000', 'temperatura', 826.0000, 'ºC'),
	(91176, 112, '2015-03-01 00:31:10.000000', 'temperatura', 96.0000, 'ºC'),
	(91177, 112, '2015-03-01 00:31:11.000000', 'temperatura', 403.0000, 'ºC'),
	(91178, 112, '2015-03-01 00:31:12.000000', 'temperatura', 528.0000, 'ºC'),
	(91179, 112, '2015-03-01 00:31:13.000000', 'temperatura', 230.0000, 'ºC'),
	(91180, 112, '2015-03-01 00:31:14.000000', 'temperatura', 769.0000, 'ºC'),
	(91181, 112, '2015-03-01 00:31:15.000000', 'temperatura', 756.0000, 'ºC'),
	(91182, 112, '2015-03-01 00:31:16.000000', 'temperatura', 274.0000, 'ºC'),
	(91183, 112, '2015-03-01 00:31:17.000000', 'temperatura', 302.0000, 'ºC'),
	(91184, 112, '2015-03-01 00:31:18.000000', 'temperatura', 690.0000, 'ºC'),
	(91185, 112, '2015-03-01 00:31:19.000000', 'temperatura', 143.0000, 'ºC'),
	(91186, 112, '2015-03-01 00:31:20.000000', 'temperatura', 1044.0000, 'ºC'),
	(91187, 112, '2015-03-01 00:31:21.000000', 'temperatura', 1191.0000, 'ºC'),
	(91188, 112, '2015-03-01 00:31:22.000000', 'temperatura', 427.0000, 'ºC'),
	(91189, 112, '2015-03-01 00:31:23.000000', 'temperatura', 959.0000, 'ºC'),
	(91190, 112, '2015-03-01 00:31:24.000000', 'temperatura', 1115.0000, 'ºC'),
	(91191, 112, '2015-03-01 00:31:25.000000', 'temperatura', 299.0000, 'ºC'),
	(91192, 112, '2015-03-01 00:31:26.000000', 'temperatura', 551.0000, 'ºC'),
	(91193, 112, '2015-03-01 00:31:27.000000', 'temperatura', 657.0000, 'ºC'),
	(91194, 112, '2015-03-01 00:31:28.000000', 'temperatura', 435.0000, 'ºC'),
	(91195, 112, '2015-03-01 00:31:29.000000', 'temperatura', 205.0000, 'ºC'),
	(91196, 112, '2015-03-01 00:31:30.000000', 'temperatura', 918.0000, 'ºC'),
	(91197, 112, '2015-03-01 00:31:31.000000', 'temperatura', 375.0000, 'ºC'),
	(91198, 112, '2015-03-01 00:31:32.000000', 'temperatura', 324.0000, 'ºC'),
	(91199, 112, '2015-03-01 00:31:33.000000', 'temperatura', 493.0000, 'ºC'),
	(91200, 112, '2015-03-01 00:31:34.000000', 'temperatura', 296.0000, 'ºC'),
	(91201, 112, '2015-03-01 00:31:35.000000', 'temperatura', 0.0000, 'ºC'),
	(91202, 112, '2015-03-01 00:31:36.000000', 'temperatura', 314.0000, 'ºC'),
	(91203, 112, '2015-03-01 00:31:37.000000', 'temperatura', 370.0000, 'ºC'),
	(91204, 112, '2015-03-01 00:31:38.000000', 'temperatura', 909.0000, 'ºC'),
	(91205, 112, '2015-03-01 00:31:39.000000', 'temperatura', 1034.0000, 'ºC'),
	(91206, 112, '2015-03-01 00:31:40.000000', 'temperatura', 44.0000, 'ºC'),
	(91207, 112, '2015-03-01 00:31:41.000000', 'temperatura', 720.0000, 'ºC'),
	(91208, 112, '2015-03-01 00:31:42.000000', 'temperatura', 1069.0000, 'ºC'),
	(91209, 112, '2015-03-01 00:31:43.000000', 'temperatura', 783.0000, 'ºC'),
	(91210, 112, '2015-03-01 00:31:44.000000', 'temperatura', 708.0000, 'ºC'),
	(91211, 112, '2015-03-01 00:31:45.000000', 'temperatura', 1194.0000, 'ºC'),
	(91212, 112, '2015-03-01 00:31:46.000000', 'temperatura', 246.0000, 'ºC'),
	(91213, 112, '2015-03-01 00:31:47.000000', 'temperatura', 49.0000, 'ºC'),
	(91214, 112, '2015-03-01 00:31:48.000000', 'temperatura', 705.0000, 'ºC'),
	(91215, 112, '2015-03-01 00:31:49.000000', 'temperatura', 980.0000, 'ºC'),
	(91216, 112, '2015-03-01 00:31:50.000000', 'temperatura', 384.0000, 'ºC'),
	(91217, 112, '2015-03-01 00:31:51.000000', 'temperatura', 180.0000, 'ºC'),
	(91218, 112, '2015-03-01 00:31:52.000000', 'temperatura', 947.0000, 'ºC'),
	(91219, 112, '2015-03-01 00:31:53.000000', 'temperatura', 599.0000, 'ºC'),
	(91220, 112, '2015-03-01 00:31:54.000000', 'temperatura', 154.0000, 'ºC'),
	(91221, 112, '2015-03-01 00:31:55.000000', 'temperatura', 172.0000, 'ºC'),
	(91222, 112, '2015-03-01 00:31:56.000000', 'temperatura', 399.0000, 'ºC'),
	(91223, 112, '2015-03-01 00:31:57.000000', 'temperatura', 279.0000, 'ºC'),
	(91224, 112, '2015-03-01 00:31:58.000000', 'temperatura', 198.0000, 'ºC'),
	(91225, 112, '2015-03-01 00:31:59.000000', 'temperatura', 155.0000, 'ºC'),
	(91226, 112, '2015-03-01 00:32:00.000000', 'temperatura', 182.0000, 'ºC'),
	(91227, 112, '2015-03-01 00:32:01.000000', 'temperatura', 445.0000, 'ºC'),
	(91228, 112, '2015-03-01 00:32:02.000000', 'temperatura', 478.0000, 'ºC'),
	(91229, 112, '2015-03-01 00:32:03.000000', 'temperatura', 1058.0000, 'ºC'),
	(91230, 112, '2015-03-01 00:32:04.000000', 'temperatura', 254.0000, 'ºC'),
	(91231, 112, '2015-03-01 00:32:05.000000', 'temperatura', 497.0000, 'ºC'),
	(91232, 112, '2015-03-01 00:32:06.000000', 'temperatura', 525.0000, 'ºC'),
	(91233, 112, '2015-03-01 00:32:07.000000', 'temperatura', 1135.0000, 'ºC'),
	(91234, 112, '2015-03-01 00:32:08.000000', 'temperatura', 499.0000, 'ºC'),
	(91235, 112, '2015-03-01 00:32:09.000000', 'temperatura', 293.0000, 'ºC'),
	(91236, 112, '2015-03-01 00:32:10.000000', 'temperatura', 1167.0000, 'ºC'),
	(91237, 112, '2015-03-01 00:32:11.000000', 'temperatura', 157.0000, 'ºC'),
	(91238, 112, '2015-03-01 00:32:12.000000', 'temperatura', 883.0000, 'ºC'),
	(91239, 112, '2015-03-01 00:32:13.000000', 'temperatura', 347.0000, 'ºC'),
	(91240, 112, '2015-03-01 00:32:14.000000', 'temperatura', 286.0000, 'ºC'),
	(91241, 112, '2015-03-01 00:32:15.000000', 'temperatura', 389.0000, 'ºC'),
	(91242, 112, '2015-03-01 00:32:16.000000', 'temperatura', 1088.0000, 'ºC'),
	(91243, 112, '2015-03-01 00:32:17.000000', 'temperatura', 672.0000, 'ºC'),
	(91244, 112, '2015-03-01 00:32:18.000000', 'temperatura', 99.0000, 'ºC'),
	(91245, 112, '2015-03-01 00:32:19.000000', 'temperatura', 877.0000, 'ºC'),
	(91246, 112, '2015-03-01 00:32:20.000000', 'temperatura', 490.0000, 'ºC'),
	(91247, 112, '2015-03-01 00:32:21.000000', 'temperatura', 1019.0000, 'ºC'),
	(91248, 112, '2015-03-01 00:32:22.000000', 'temperatura', 24.0000, 'ºC'),
	(91249, 112, '2015-03-01 00:32:23.000000', 'temperatura', 666.0000, 'ºC'),
	(91250, 112, '2015-03-01 00:32:24.000000', 'temperatura', 858.0000, 'ºC'),
	(91251, 112, '2015-03-01 00:32:25.000000', 'temperatura', 1094.0000, 'ºC'),
	(91252, 112, '2015-03-01 00:32:26.000000', 'temperatura', 495.0000, 'ºC'),
	(91253, 112, '2015-03-01 00:32:27.000000', 'temperatura', 393.0000, 'ºC'),
	(91254, 112, '2015-03-01 00:32:28.000000', 'temperatura', 480.0000, 'ºC'),
	(91255, 112, '2015-03-01 00:32:29.000000', 'temperatura', 21.0000, 'ºC'),
	(91256, 112, '2015-03-01 00:32:30.000000', 'temperatura', 1068.0000, 'ºC'),
	(91257, 112, '2015-03-01 00:32:31.000000', 'temperatura', 476.0000, 'ºC'),
	(91258, 112, '2015-03-01 00:32:32.000000', 'temperatura', 377.0000, 'ºC'),
	(91259, 112, '2015-03-01 00:32:33.000000', 'temperatura', 458.0000, 'ºC'),
	(91260, 112, '2015-03-01 00:32:34.000000', 'temperatura', 1158.0000, 'ºC'),
	(91261, 112, '2015-03-01 00:32:35.000000', 'temperatura', 816.0000, 'ºC'),
	(91262, 112, '2015-03-01 00:32:36.000000', 'temperatura', 606.0000, 'ºC'),
	(91263, 112, '2015-03-01 00:32:37.000000', 'temperatura', 582.0000, 'ºC'),
	(91264, 112, '2015-03-01 00:32:38.000000', 'temperatura', 1095.0000, 'ºC'),
	(91265, 112, '2015-03-01 00:32:39.000000', 'temperatura', 126.0000, 'ºC'),
	(91266, 112, '2015-03-01 00:32:40.000000', 'temperatura', 949.0000, 'ºC'),
	(91267, 112, '2015-03-01 00:32:41.000000', 'temperatura', 767.0000, 'ºC'),
	(91268, 112, '2015-03-01 00:32:42.000000', 'temperatura', 989.0000, 'ºC'),
	(91269, 112, '2015-03-01 00:32:43.000000', 'temperatura', 245.0000, 'ºC'),
	(91270, 112, '2015-03-01 00:32:44.000000', 'temperatura', 659.0000, 'ºC'),
	(91271, 112, '2015-03-01 00:32:45.000000', 'temperatura', 161.0000, 'ºC'),
	(91272, 112, '2015-03-01 00:32:46.000000', 'temperatura', 28.0000, 'ºC'),
	(91273, 112, '2015-03-01 00:32:47.000000', 'temperatura', 856.0000, 'ºC'),
	(91274, 112, '2015-03-01 00:32:48.000000', 'temperatura', 595.0000, 'ºC'),
	(91275, 112, '2015-03-01 00:32:49.000000', 'temperatura', 410.0000, 'ºC'),
	(91276, 112, '2015-03-01 00:32:50.000000', 'temperatura', 265.0000, 'ºC'),
	(91277, 112, '2015-03-01 00:32:51.000000', 'temperatura', 94.0000, 'ºC'),
	(91278, 112, '2015-03-01 00:32:52.000000', 'temperatura', 876.0000, 'ºC'),
	(91279, 112, '2015-03-01 00:32:53.000000', 'temperatura', 498.0000, 'ºC'),
	(91280, 112, '2015-03-01 00:32:54.000000', 'temperatura', 1065.0000, 'ºC'),
	(91281, 112, '2015-03-01 00:32:55.000000', 'temperatura', 228.0000, 'ºC'),
	(91282, 112, '2015-03-01 00:32:56.000000', 'temperatura', 348.0000, 'ºC'),
	(91283, 112, '2015-03-01 00:32:57.000000', 'temperatura', 1057.0000, 'ºC'),
	(91284, 112, '2015-03-01 00:32:58.000000', 'temperatura', 643.0000, 'ºC'),
	(91285, 112, '2015-03-01 00:32:59.000000', 'temperatura', 42.0000, 'ºC'),
	(91286, 112, '2015-03-01 00:33:00.000000', 'temperatura', 682.0000, 'ºC'),
	(91287, 112, '2015-03-01 00:33:01.000000', 'temperatura', 883.0000, 'ºC'),
	(91288, 112, '2015-03-01 00:33:02.000000', 'temperatura', 1169.0000, 'ºC'),
	(91289, 112, '2015-03-01 00:33:03.000000', 'temperatura', 798.0000, 'ºC'),
	(91290, 112, '2015-03-01 00:33:04.000000', 'temperatura', 482.0000, 'ºC'),
	(91291, 112, '2015-03-01 00:33:05.000000', 'temperatura', 15.0000, 'ºC'),
	(91292, 112, '2015-03-01 00:33:06.000000', 'temperatura', 1033.0000, 'ºC'),
	(91293, 112, '2015-03-01 00:33:07.000000', 'temperatura', 319.0000, 'ºC'),
	(91294, 112, '2015-03-01 00:33:08.000000', 'temperatura', 899.0000, 'ºC'),
	(91295, 112, '2015-03-01 00:33:09.000000', 'temperatura', 1135.0000, 'ºC'),
	(91296, 112, '2015-03-01 00:33:10.000000', 'temperatura', 580.0000, 'ºC'),
	(91297, 112, '2015-03-01 00:33:11.000000', 'temperatura', 697.0000, 'ºC'),
	(91298, 112, '2015-03-01 00:33:12.000000', 'temperatura', 543.0000, 'ºC'),
	(91299, 112, '2015-03-01 00:33:13.000000', 'temperatura', 624.0000, 'ºC'),
	(91300, 112, '2015-03-01 00:33:14.000000', 'temperatura', 291.0000, 'ºC'),
	(91301, 112, '2015-03-01 00:33:15.000000', 'temperatura', 786.0000, 'ºC'),
	(91302, 112, '2015-03-01 00:33:16.000000', 'temperatura', 655.0000, 'ºC'),
	(91303, 112, '2015-03-01 00:33:17.000000', 'temperatura', 921.0000, 'ºC'),
	(91304, 112, '2015-03-01 00:33:18.000000', 'temperatura', 237.0000, 'ºC'),
	(91305, 112, '2015-03-01 00:33:19.000000', 'temperatura', 823.0000, 'ºC'),
	(91306, 112, '2015-03-01 00:33:20.000000', 'temperatura', 1005.0000, 'ºC'),
	(91307, 112, '2015-03-01 00:33:21.000000', 'temperatura', 157.0000, 'ºC'),
	(91308, 112, '2015-03-01 00:33:22.000000', 'temperatura', 171.0000, 'ºC'),
	(91309, 112, '2015-03-01 00:33:23.000000', 'temperatura', 384.0000, 'ºC'),
	(91310, 112, '2015-03-01 00:33:24.000000', 'temperatura', 206.0000, 'ºC'),
	(91311, 112, '2015-03-01 00:33:25.000000', 'temperatura', 1079.0000, 'ºC'),
	(91312, 112, '2015-03-01 00:33:26.000000', 'temperatura', 1180.0000, 'ºC'),
	(91313, 112, '2015-03-01 00:33:27.000000', 'temperatura', 261.0000, 'ºC'),
	(91314, 112, '2015-03-01 00:33:28.000000', 'temperatura', 165.0000, 'ºC'),
	(91315, 112, '2015-03-01 00:33:29.000000', 'temperatura', 45.0000, 'ºC'),
	(91316, 112, '2015-03-01 00:33:30.000000', 'temperatura', 930.0000, 'ºC'),
	(91317, 112, '2015-03-01 00:33:31.000000', 'temperatura', 916.0000, 'ºC'),
	(91318, 112, '2015-03-01 00:33:32.000000', 'temperatura', 590.0000, 'ºC'),
	(91319, 112, '2015-03-01 00:33:33.000000', 'temperatura', 204.0000, 'ºC'),
	(91320, 112, '2015-03-01 00:33:34.000000', 'temperatura', 450.0000, 'ºC'),
	(91321, 112, '2015-03-01 00:33:35.000000', 'temperatura', 439.0000, 'ºC'),
	(91322, 112, '2015-03-01 00:33:36.000000', 'temperatura', 845.0000, 'ºC'),
	(91323, 112, '2015-03-01 00:33:37.000000', 'temperatura', 511.0000, 'ºC'),
	(91324, 112, '2015-03-01 00:33:38.000000', 'temperatura', 17.0000, 'ºC'),
	(91325, 112, '2015-03-01 00:33:39.000000', 'temperatura', 952.0000, 'ºC'),
	(91326, 112, '2015-03-01 00:33:40.000000', 'temperatura', 1111.0000, 'ºC'),
	(91327, 112, '2015-03-01 00:33:41.000000', 'temperatura', 300.0000, 'ºC'),
	(91328, 112, '2015-03-01 00:33:42.000000', 'temperatura', 566.0000, 'ºC'),
	(91329, 112, '2015-03-01 00:33:43.000000', 'temperatura', 730.0000, 'ºC'),
	(91330, 112, '2015-03-01 00:33:44.000000', 'temperatura', 752.0000, 'ºC'),
	(91331, 112, '2015-03-01 00:33:45.000000', 'temperatura', 370.0000, 'ºC'),
	(91332, 112, '2015-03-01 00:33:46.000000', 'temperatura', 795.0000, 'ºC'),
	(91333, 112, '2015-03-01 00:33:47.000000', 'temperatura', 468.0000, 'ºC'),
	(91334, 112, '2015-03-01 00:33:48.000000', 'temperatura', 1152.0000, 'ºC'),
	(91335, 112, '2015-03-01 00:33:49.000000', 'temperatura', 758.0000, 'ºC'),
	(91336, 112, '2015-03-01 00:33:50.000000', 'temperatura', 334.0000, 'ºC'),
	(91337, 112, '2015-03-01 00:33:51.000000', 'temperatura', 599.0000, 'ºC'),
	(91338, 112, '2015-03-01 00:33:52.000000', 'temperatura', 790.0000, 'ºC'),
	(91339, 112, '2015-03-01 00:33:53.000000', 'temperatura', 956.0000, 'ºC'),
	(91340, 112, '2015-03-01 00:33:54.000000', 'temperatura', 10.0000, 'ºC'),
	(91341, 112, '2015-03-01 00:33:55.000000', 'temperatura', 782.0000, 'ºC'),
	(91342, 112, '2015-03-01 00:33:56.000000', 'temperatura', 282.0000, 'ºC'),
	(91343, 112, '2015-03-01 00:33:57.000000', 'temperatura', 264.0000, 'ºC'),
	(91344, 112, '2015-03-01 00:33:58.000000', 'temperatura', 475.0000, 'ºC'),
	(91345, 112, '2015-03-01 00:33:59.000000', 'temperatura', 384.0000, 'ºC'),
	(91346, 112, '2015-03-01 00:34:00.000000', 'temperatura', 495.0000, 'ºC'),
	(91347, 112, '2015-03-01 00:34:01.000000', 'temperatura', 124.0000, 'ºC'),
	(91348, 112, '2015-03-01 00:34:02.000000', 'temperatura', 337.0000, 'ºC'),
	(91349, 112, '2015-03-01 00:34:03.000000', 'temperatura', 112.0000, 'ºC'),
	(91350, 112, '2015-03-01 00:34:04.000000', 'temperatura', 751.0000, 'ºC'),
	(91351, 112, '2015-03-01 00:34:05.000000', 'temperatura', 1019.0000, 'ºC'),
	(91352, 112, '2015-03-01 00:34:06.000000', 'temperatura', 441.0000, 'ºC'),
	(91353, 112, '2015-03-01 00:34:07.000000', 'temperatura', 351.0000, 'ºC'),
	(91354, 112, '2015-03-01 00:34:08.000000', 'temperatura', 430.0000, 'ºC'),
	(91355, 112, '2015-03-01 00:34:09.000000', 'temperatura', 1100.0000, 'ºC'),
	(91356, 112, '2015-03-01 00:34:10.000000', 'temperatura', 609.0000, 'ºC'),
	(91357, 112, '2015-03-01 00:34:11.000000', 'temperatura', 947.0000, 'ºC'),
	(91358, 112, '2015-03-01 00:34:12.000000', 'temperatura', 506.0000, 'ºC'),
	(91359, 112, '2015-03-01 00:34:13.000000', 'temperatura', 890.0000, 'ºC'),
	(91360, 112, '2015-03-01 00:34:14.000000', 'temperatura', 532.0000, 'ºC'),
	(91361, 112, '2015-03-01 00:34:15.000000', 'temperatura', 1189.0000, 'ºC'),
	(91362, 112, '2015-03-01 00:34:16.000000', 'temperatura', 752.0000, 'ºC'),
	(91363, 112, '2015-03-01 00:34:17.000000', 'temperatura', 192.0000, 'ºC'),
	(91364, 112, '2015-03-01 00:34:18.000000', 'temperatura', 1107.0000, 'ºC'),
	(91365, 112, '2015-03-01 00:34:19.000000', 'temperatura', 156.0000, 'ºC'),
	(91366, 112, '2015-03-01 00:34:20.000000', 'temperatura', 1063.0000, 'ºC'),
	(91367, 112, '2015-03-01 00:34:21.000000', 'temperatura', 46.0000, 'ºC'),
	(91368, 112, '2015-03-01 00:34:22.000000', 'temperatura', 641.0000, 'ºC'),
	(91369, 112, '2015-03-01 00:34:23.000000', 'temperatura', 669.0000, 'ºC'),
	(91370, 112, '2015-03-01 00:34:24.000000', 'temperatura', 224.0000, 'ºC'),
	(91371, 112, '2015-03-01 00:34:25.000000', 'temperatura', 311.0000, 'ºC'),
	(91372, 112, '2015-03-01 00:34:26.000000', 'temperatura', 885.0000, 'ºC'),
	(91373, 112, '2015-03-01 00:34:27.000000', 'temperatura', 1092.0000, 'ºC'),
	(91374, 112, '2015-03-01 00:34:28.000000', 'temperatura', 406.0000, 'ºC'),
	(91375, 112, '2015-03-01 00:34:29.000000', 'temperatura', 1154.0000, 'ºC'),
	(91376, 112, '2015-03-01 00:34:30.000000', 'temperatura', 952.0000, 'ºC'),
	(91377, 112, '2015-03-01 00:34:31.000000', 'temperatura', 100.0000, 'ºC'),
	(91378, 112, '2015-03-01 00:34:32.000000', 'temperatura', 43.0000, 'ºC'),
	(91379, 112, '2015-03-01 00:34:33.000000', 'temperatura', 1114.0000, 'ºC'),
	(91380, 112, '2015-03-01 00:34:34.000000', 'temperatura', 643.0000, 'ºC'),
	(91381, 112, '2015-03-01 00:34:35.000000', 'temperatura', 1073.0000, 'ºC'),
	(91382, 112, '2015-03-01 00:34:36.000000', 'temperatura', 1038.0000, 'ºC'),
	(91383, 112, '2015-03-01 00:34:37.000000', 'temperatura', 770.0000, 'ºC'),
	(91384, 112, '2015-03-01 00:34:38.000000', 'temperatura', 737.0000, 'ºC'),
	(91385, 112, '2015-03-01 00:34:39.000000', 'temperatura', 177.0000, 'ºC'),
	(91386, 112, '2015-03-01 00:34:40.000000', 'temperatura', 1073.0000, 'ºC'),
	(91387, 112, '2015-03-01 00:34:41.000000', 'temperatura', 34.0000, 'ºC'),
	(91388, 112, '2015-03-01 00:34:42.000000', 'temperatura', 550.0000, 'ºC'),
	(91389, 112, '2015-03-01 00:34:43.000000', 'temperatura', 252.0000, 'ºC'),
	(91390, 112, '2015-03-01 00:34:44.000000', 'temperatura', 808.0000, 'ºC'),
	(91391, 112, '2015-03-01 00:34:45.000000', 'temperatura', 887.0000, 'ºC'),
	(91392, 112, '2015-03-01 00:34:46.000000', 'temperatura', 810.0000, 'ºC'),
	(91393, 112, '2015-03-01 00:34:47.000000', 'temperatura', 188.0000, 'ºC'),
	(91394, 112, '2015-03-01 00:34:48.000000', 'temperatura', 912.0000, 'ºC'),
	(91395, 112, '2015-03-01 00:34:49.000000', 'temperatura', 395.0000, 'ºC'),
	(91396, 112, '2015-03-01 00:34:50.000000', 'temperatura', 442.0000, 'ºC'),
	(91397, 112, '2015-03-01 00:34:51.000000', 'temperatura', 1024.0000, 'ºC'),
	(91398, 112, '2015-03-01 00:34:52.000000', 'temperatura', 194.0000, 'ºC'),
	(91399, 112, '2015-03-01 00:34:53.000000', 'temperatura', 297.0000, 'ºC'),
	(91400, 112, '2015-03-01 00:34:54.000000', 'temperatura', 905.0000, 'ºC'),
	(91401, 112, '2015-03-01 00:34:55.000000', 'temperatura', 34.0000, 'ºC'),
	(91402, 112, '2015-03-01 00:34:56.000000', 'temperatura', 1055.0000, 'ºC'),
	(91403, 112, '2015-03-01 00:34:57.000000', 'temperatura', 375.0000, 'ºC'),
	(91404, 112, '2015-03-01 00:34:58.000000', 'temperatura', 1108.0000, 'ºC'),
	(91405, 112, '2015-03-01 00:34:59.000000', 'temperatura', 817.0000, 'ºC'),
	(91406, 112, '2015-03-01 00:35:00.000000', 'temperatura', 760.0000, 'ºC'),
	(91407, 112, '2015-03-01 00:35:01.000000', 'temperatura', 151.0000, 'ºC'),
	(91408, 112, '2015-03-01 00:35:02.000000', 'temperatura', 875.0000, 'ºC'),
	(91409, 112, '2015-03-01 00:35:03.000000', 'temperatura', 324.0000, 'ºC'),
	(91410, 112, '2015-03-01 00:35:04.000000', 'temperatura', 193.0000, 'ºC'),
	(91411, 112, '2015-03-01 00:35:05.000000', 'temperatura', 1196.0000, 'ºC'),
	(91412, 112, '2015-03-01 00:35:06.000000', 'temperatura', 602.0000, 'ºC'),
	(91413, 112, '2015-03-01 00:35:07.000000', 'temperatura', 620.0000, 'ºC'),
	(91414, 112, '2015-03-01 00:35:08.000000', 'temperatura', 94.0000, 'ºC'),
	(91415, 112, '2015-03-01 00:35:09.000000', 'temperatura', 1009.0000, 'ºC'),
	(91416, 112, '2015-03-01 00:35:10.000000', 'temperatura', 1167.0000, 'ºC'),
	(91417, 112, '2015-03-01 00:35:11.000000', 'temperatura', 409.0000, 'ºC'),
	(91418, 112, '2015-03-01 00:35:12.000000', 'temperatura', 943.0000, 'ºC'),
	(91419, 112, '2015-03-01 00:35:13.000000', 'temperatura', 1091.0000, 'ºC'),
	(91420, 112, '2015-03-01 00:35:14.000000', 'temperatura', 223.0000, 'ºC'),
	(91421, 112, '2015-03-01 00:35:15.000000', 'temperatura', 244.0000, 'ºC'),
	(91422, 112, '2015-03-01 00:35:16.000000', 'temperatura', 551.0000, 'ºC'),
	(91423, 112, '2015-03-01 00:35:17.000000', 'temperatura', 824.0000, 'ºC'),
	(91424, 112, '2015-03-01 00:35:18.000000', 'temperatura', 67.0000, 'ºC'),
	(91425, 112, '2015-03-01 00:35:19.000000', 'temperatura', 263.0000, 'ºC'),
	(91426, 112, '2015-03-01 00:35:20.000000', 'temperatura', 1116.0000, 'ºC'),
	(91427, 112, '2015-03-01 00:35:21.000000', 'temperatura', 1192.0000, 'ºC'),
	(91428, 112, '2015-03-01 00:35:22.000000', 'temperatura', 214.0000, 'ºC'),
	(91429, 112, '2015-03-01 00:35:23.000000', 'temperatura', 1091.0000, 'ºC'),
	(91430, 112, '2015-03-01 00:35:24.000000', 'temperatura', 17.0000, 'ºC'),
	(91431, 112, '2015-03-01 00:35:25.000000', 'temperatura', 409.0000, 'ºC'),
	(91432, 112, '2015-03-01 00:35:26.000000', 'temperatura', 796.0000, 'ºC'),
	(91433, 112, '2015-03-01 00:35:27.000000', 'temperatura', 355.0000, 'ºC'),
	(91434, 112, '2015-03-01 00:35:28.000000', 'temperatura', 587.0000, 'ºC'),
	(91435, 112, '2015-03-01 00:35:29.000000', 'temperatura', 670.0000, 'ºC'),
	(91436, 112, '2015-03-01 00:35:30.000000', 'temperatura', 389.0000, 'ºC'),
	(91437, 112, '2015-03-01 00:35:31.000000', 'temperatura', 1134.0000, 'ºC'),
	(91438, 112, '2015-03-01 00:35:32.000000', 'temperatura', 906.0000, 'ºC'),
	(91439, 112, '2015-03-01 00:35:33.000000', 'temperatura', 1126.0000, 'ºC'),
	(91440, 112, '2015-03-01 00:35:34.000000', 'temperatura', 513.0000, 'ºC'),
	(91441, 112, '2015-03-01 00:35:35.000000', 'temperatura', 386.0000, 'ºC'),
	(91442, 112, '2015-03-01 00:35:36.000000', 'temperatura', 394.0000, 'ºC'),
	(91443, 112, '2015-03-01 00:35:37.000000', 'temperatura', 812.0000, 'ºC'),
	(91444, 112, '2015-03-01 00:35:38.000000', 'temperatura', 479.0000, 'ºC'),
	(91445, 112, '2015-03-01 00:35:39.000000', 'temperatura', 1158.0000, 'ºC'),
	(91446, 112, '2015-03-01 00:35:40.000000', 'temperatura', 752.0000, 'ºC'),
	(91447, 112, '2015-03-01 00:35:41.000000', 'temperatura', 289.0000, 'ºC'),
	(91448, 112, '2015-03-01 00:35:42.000000', 'temperatura', 388.0000, 'ºC'),
	(91449, 112, '2015-03-01 00:35:43.000000', 'temperatura', 1074.0000, 'ºC'),
	(91450, 112, '2015-03-01 00:35:44.000000', 'temperatura', 608.0000, 'ºC'),
	(91451, 112, '2015-03-01 00:35:45.000000', 'temperatura', 1018.0000, 'ºC'),
	(91452, 112, '2015-03-01 00:35:46.000000', 'temperatura', 867.0000, 'ºC'),
	(91453, 112, '2015-03-01 00:35:47.000000', 'temperatura', 79.0000, 'ºC'),
	(91454, 112, '2015-03-01 00:35:48.000000', 'temperatura', 197.0000, 'ºC'),
	(91455, 112, '2015-03-01 00:35:49.000000', 'temperatura', 746.0000, 'ºC'),
	(91456, 112, '2015-03-01 00:35:50.000000', 'temperatura', 740.0000, 'ºC'),
	(91457, 112, '2015-03-01 00:35:51.000000', 'temperatura', 264.0000, 'ºC'),
	(91458, 112, '2015-03-01 00:35:52.000000', 'temperatura', 299.0000, 'ºC'),
	(91459, 112, '2015-03-01 00:35:53.000000', 'temperatura', 703.0000, 'ºC'),
	(91460, 112, '2015-03-01 00:35:54.000000', 'temperatura', 218.0000, 'ºC'),
	(91461, 112, '2015-03-01 00:35:55.000000', 'temperatura', 182.0000, 'ºC'),
	(91462, 112, '2015-03-01 00:35:56.000000', 'temperatura', 258.0000, 'ºC'),
	(91463, 112, '2015-03-01 00:35:57.000000', 'temperatura', 745.0000, 'ºC'),
	(91464, 112, '2015-03-01 00:35:58.000000', 'temperatura', 551.0000, 'ºC'),
	(91465, 112, '2015-03-01 00:35:59.000000', 'temperatura', 519.0000, 'ºC'),
	(91466, 112, '2015-03-01 00:36:00.000000', 'temperatura', 944.0000, 'ºC'),
	(91467, 112, '2015-03-01 00:36:01.000000', 'temperatura', 764.0000, 'ºC'),
	(91468, 112, '2015-03-01 00:36:02.000000', 'temperatura', 988.0000, 'ºC'),
	(91469, 112, '2015-03-01 00:36:03.000000', 'temperatura', 250.0000, 'ºC'),
	(91470, 112, '2015-03-01 00:36:04.000000', 'temperatura', 685.0000, 'ºC'),
	(91471, 112, '2015-03-01 00:36:05.000000', 'temperatura', 275.0000, 'ºC'),
	(91472, 112, '2015-03-01 00:36:06.000000', 'temperatura', 522.0000, 'ºC'),
	(91473, 112, '2015-03-01 00:36:07.000000', 'temperatura', 585.0000, 'ºC'),
	(91474, 112, '2015-03-01 00:36:08.000000', 'temperatura', 161.0000, 'ºC'),
	(91475, 112, '2015-03-01 00:36:09.000000', 'temperatura', 251.0000, 'ºC'),
	(91476, 112, '2015-03-01 00:36:10.000000', 'temperatura', 770.0000, 'ºC'),
	(91477, 112, '2015-03-01 00:36:11.000000', 'temperatura', 700.0000, 'ºC'),
	(91478, 112, '2015-03-01 00:36:12.000000', 'temperatura', 1190.0000, 'ºC'),
	(91479, 112, '2015-03-01 00:36:13.000000', 'temperatura', 248.0000, 'ºC'),
	(91480, 112, '2015-03-01 00:36:14.000000', 'temperatura', 73.0000, 'ºC'),
	(91481, 112, '2015-03-01 00:36:15.000000', 'temperatura', 822.0000, 'ºC'),
	(91482, 112, '2015-03-01 00:36:16.000000', 'temperatura', 289.0000, 'ºC'),
	(91483, 112, '2015-03-01 00:36:17.000000', 'temperatura', 182.0000, 'ºC'),
	(91484, 112, '2015-03-01 00:36:18.000000', 'temperatura', 43.0000, 'ºC'),
	(91485, 112, '2015-03-01 00:36:19.000000', 'temperatura', 869.0000, 'ºC'),
	(91486, 112, '2015-03-01 00:36:20.000000', 'temperatura', 617.0000, 'ºC'),
	(91487, 112, '2015-03-01 00:36:21.000000', 'temperatura', 478.0000, 'ºC'),
	(91488, 112, '2015-03-01 00:36:22.000000', 'temperatura', 539.0000, 'ºC'),
	(91489, 112, '2015-03-01 00:36:23.000000', 'temperatura', 62.0000, 'ºC'),
	(91490, 112, '2015-03-01 00:36:24.000000', 'temperatura', 1094.0000, 'ºC'),
	(91491, 112, '2015-03-01 00:36:25.000000', 'temperatura', 483.0000, 'ºC'),
	(91492, 112, '2015-03-01 00:36:26.000000', 'temperatura', 333.0000, 'ºC'),
	(91493, 112, '2015-03-01 00:36:27.000000', 'temperatura', 217.0000, 'ºC'),
	(91494, 112, '2015-03-01 00:36:28.000000', 'temperatura', 85.0000, 'ºC'),
	(91495, 112, '2015-03-01 00:36:29.000000', 'temperatura', 975.0000, 'ºC'),
	(91496, 112, '2015-03-01 00:36:30.000000', 'temperatura', 1019.0000, 'ºC'),
	(91497, 112, '2015-03-01 00:36:31.000000', 'temperatura', 973.0000, 'ºC'),
	(91498, 112, '2015-03-01 00:36:32.000000', 'temperatura', 607.0000, 'ºC'),
	(91499, 112, '2015-03-01 00:36:33.000000', 'temperatura', 117.0000, 'ºC'),
	(91500, 112, '2015-03-01 00:36:34.000000', 'temperatura', 1165.0000, 'ºC'),
	(91501, 112, '2015-03-01 00:36:35.000000', 'temperatura', 674.0000, 'ºC'),
	(91502, 112, '2015-03-01 00:36:36.000000', 'temperatura', 1076.0000, 'ºC'),
	(91503, 112, '2015-03-01 00:36:37.000000', 'temperatura', 959.0000, 'ºC'),
	(91504, 112, '2015-03-01 00:36:38.000000', 'temperatura', 365.0000, 'ºC'),
	(91505, 112, '2015-03-01 00:36:39.000000', 'temperatura', 151.0000, 'ºC'),
	(91506, 112, '2015-03-01 00:36:40.000000', 'temperatura', 859.0000, 'ºC'),
	(91507, 112, '2015-03-01 00:36:41.000000', 'temperatura', 242.0000, 'ºC'),
	(91508, 112, '2015-03-01 00:36:42.000000', 'temperatura', 1034.0000, 'ºC'),
	(91509, 112, '2015-03-01 00:36:43.000000', 'temperatura', 846.0000, 'ºC'),
	(91510, 112, '2015-03-01 00:36:44.000000', 'temperatura', 1128.0000, 'ºC'),
	(91511, 112, '2015-03-01 00:36:45.000000', 'temperatura', 703.0000, 'ºC'),
	(91512, 112, '2015-03-01 00:36:46.000000', 'temperatura', 130.0000, 'ºC'),
	(91513, 112, '2015-03-01 00:36:47.000000', 'temperatura', 942.0000, 'ºC'),
	(91514, 112, '2015-03-01 00:36:48.000000', 'temperatura', 719.0000, 'ºC'),
	(91515, 112, '2015-03-01 00:36:49.000000', 'temperatura', 770.0000, 'ºC'),
	(91516, 112, '2015-03-01 00:36:50.000000', 'temperatura', 493.0000, 'ºC'),
	(91517, 112, '2015-03-01 00:36:51.000000', 'temperatura', 158.0000, 'ºC'),
	(91518, 112, '2015-03-01 00:36:52.000000', 'temperatura', 510.0000, 'ºC'),
	(91519, 112, '2015-03-01 00:36:53.000000', 'temperatura', 875.0000, 'ºC'),
	(91520, 112, '2015-03-01 00:36:54.000000', 'temperatura', 447.0000, 'ºC'),
	(91521, 112, '2015-03-01 00:36:55.000000', 'temperatura', 812.0000, 'ºC'),
	(91522, 112, '2015-03-01 00:36:56.000000', 'temperatura', 318.0000, 'ºC'),
	(91523, 112, '2015-03-01 00:36:57.000000', 'temperatura', 357.0000, 'ºC'),
	(91524, 112, '2015-03-01 00:36:58.000000', 'temperatura', 828.0000, 'ºC'),
	(91525, 112, '2015-03-01 00:36:59.000000', 'temperatura', 671.0000, 'ºC'),
	(91526, 112, '2015-03-01 00:37:00.000000', 'temperatura', 871.0000, 'ºC'),
	(91527, 112, '2015-03-01 00:37:01.000000', 'temperatura', 1144.0000, 'ºC'),
	(91528, 112, '2015-03-01 00:37:02.000000', 'temperatura', 708.0000, 'ºC'),
	(91529, 112, '2015-03-01 00:37:03.000000', 'temperatura', 110.0000, 'ºC'),
	(91530, 112, '2015-03-01 00:37:04.000000', 'temperatura', 823.0000, 'ºC'),
	(91531, 112, '2015-03-01 00:37:05.000000', 'temperatura', 186.0000, 'ºC'),
	(91532, 112, '2015-03-01 00:37:06.000000', 'temperatura', 862.0000, 'ºC'),
	(91533, 112, '2015-03-01 00:37:07.000000', 'temperatura', 151.0000, 'ºC'),
	(91534, 112, '2015-03-01 00:37:08.000000', 'temperatura', 569.0000, 'ºC'),
	(91535, 112, '2015-03-01 00:37:09.000000', 'temperatura', 1194.0000, 'ºC'),
	(91536, 112, '2015-03-01 00:37:10.000000', 'temperatura', 663.0000, 'ºC'),
	(91537, 112, '2015-03-01 00:37:11.000000', 'temperatura', 934.0000, 'ºC'),
	(91538, 112, '2015-03-01 00:37:12.000000', 'temperatura', 283.0000, 'ºC'),
	(91539, 112, '2015-03-01 00:37:13.000000', 'temperatura', 1011.0000, 'ºC'),
	(91540, 112, '2015-03-01 00:37:14.000000', 'temperatura', 608.0000, 'ºC'),
	(91541, 112, '2015-03-01 00:37:15.000000', 'temperatura', 7.0000, 'ºC'),
	(91542, 112, '2015-03-01 00:37:16.000000', 'temperatura', 611.0000, 'ºC'),
	(91543, 112, '2015-03-01 00:37:17.000000', 'temperatura', 634.0000, 'ºC'),
	(91544, 112, '2015-03-01 00:37:18.000000', 'temperatura', 136.0000, 'ºC'),
	(91545, 112, '2015-03-01 00:37:19.000000', 'temperatura', 1180.0000, 'ºC'),
	(91546, 112, '2015-03-01 00:37:20.000000', 'temperatura', 693.0000, 'ºC'),
	(91547, 112, '2015-03-01 00:37:21.000000', 'temperatura', 1125.0000, 'ºC'),
	(91548, 112, '2015-03-01 00:37:22.000000', 'temperatura', 1146.0000, 'ºC'),
	(91549, 112, '2015-03-01 00:37:23.000000', 'temperatura', 1157.0000, 'ºC'),
	(91550, 112, '2015-03-01 00:37:24.000000', 'temperatura', 1145.0000, 'ºC'),
	(91551, 112, '2015-03-01 00:37:25.000000', 'temperatura', 1057.0000, 'ºC'),
	(91552, 112, '2015-03-01 00:37:26.000000', 'temperatura', 650.0000, 'ºC'),
	(91553, 112, '2015-03-01 00:37:27.000000', 'temperatura', 79.0000, 'ºC'),
	(91554, 112, '2015-03-01 00:37:28.000000', 'temperatura', 846.0000, 'ºC'),
	(91555, 112, '2015-03-01 00:37:29.000000', 'temperatura', 394.0000, 'ºC'),
	(91556, 112, '2015-03-01 00:37:30.000000', 'temperatura', 633.0000, 'ºC'),
	(91557, 112, '2015-03-01 00:37:31.000000', 'temperatura', 784.0000, 'ºC'),
	(91558, 112, '2015-03-01 00:37:32.000000', 'temperatura', 820.0000, 'ºC'),
	(91559, 112, '2015-03-01 00:37:33.000000', 'temperatura', 550.0000, 'ºC'),
	(91560, 112, '2015-03-01 00:37:34.000000', 'temperatura', 289.0000, 'ºC'),
	(91561, 112, '2015-03-01 00:37:35.000000', 'temperatura', 995.0000, 'ºC'),
	(91562, 112, '2015-03-01 00:37:36.000000', 'temperatura', 510.0000, 'ºC'),
	(91563, 112, '2015-03-01 00:37:37.000000', 'temperatura', 764.0000, 'ºC'),
	(91564, 112, '2015-03-01 00:37:38.000000', 'temperatura', 1091.0000, 'ºC'),
	(91565, 112, '2015-03-01 00:37:39.000000', 'temperatura', 762.0000, 'ºC'),
	(91566, 112, '2015-03-01 00:37:40.000000', 'temperatura', 537.0000, 'ºC'),
	(91567, 112, '2015-03-01 00:37:41.000000', 'temperatura', 399.0000, 'ºC'),
	(91568, 112, '2015-03-01 00:37:42.000000', 'temperatura', 386.0000, 'ºC'),
	(91569, 112, '2015-03-01 00:37:43.000000', 'temperatura', 733.0000, 'ºC'),
	(91570, 112, '2015-03-01 00:37:44.000000', 'temperatura', 106.0000, 'ºC'),
	(91571, 112, '2015-03-01 00:37:45.000000', 'temperatura', 732.0000, 'ºC'),
	(91572, 112, '2015-03-01 00:37:46.000000', 'temperatura', 942.0000, 'ºC'),
	(91573, 112, '2015-03-01 00:37:47.000000', 'temperatura', 113.0000, 'ºC'),
	(91574, 112, '2015-03-01 00:37:48.000000', 'temperatura', 142.0000, 'ºC'),
	(91575, 112, '2015-03-01 00:37:49.000000', 'temperatura', 371.0000, 'ºC'),
	(91576, 112, '2015-03-01 00:37:50.000000', 'temperatura', 230.0000, 'ºC'),
	(91577, 112, '2015-03-01 00:37:51.000000', 'temperatura', 37.0000, 'ºC'),
	(91578, 112, '2015-03-01 00:37:52.000000', 'temperatura', 696.0000, 'ºC'),
	(91579, 112, '2015-03-01 00:37:53.000000', 'temperatura', 971.0000, 'ºC'),
	(91580, 112, '2015-03-01 00:37:54.000000', 'temperatura', 367.0000, 'ºC'),
	(91581, 112, '2015-03-01 00:37:55.000000', 'temperatura', 122.0000, 'ºC'),
	(91582, 112, '2015-03-01 00:37:56.000000', 'temperatura', 709.0000, 'ºC'),
	(91583, 112, '2015-03-01 00:37:57.000000', 'temperatura', 779.0000, 'ºC'),
	(91584, 112, '2015-03-01 00:37:58.000000', 'temperatura', 569.0000, 'ºC'),
	(91585, 112, '2015-03-01 00:37:59.000000', 'temperatura', 510.0000, 'ºC'),
	(91586, 112, '2015-03-01 00:38:00.000000', 'temperatura', 842.0000, 'ºC'),
	(91587, 112, '2015-03-01 00:38:01.000000', 'temperatura', 283.0000, 'ºC'),
	(91588, 112, '2015-03-01 00:38:02.000000', 'temperatura', 87.0000, 'ºC'),
	(91589, 112, '2015-03-01 00:38:03.000000', 'temperatura', 786.0000, 'ºC'),
	(91590, 112, '2015-03-01 00:38:04.000000', 'temperatura', 72.0000, 'ºC'),
	(91591, 112, '2015-03-01 00:38:05.000000', 'temperatura', 403.0000, 'ºC'),
	(91592, 112, '2015-03-01 00:38:06.000000', 'temperatura', 597.0000, 'ºC'),
	(91593, 112, '2015-03-01 00:38:07.000000', 'temperatura', 576.0000, 'ºC'),
	(91594, 112, '2015-03-01 00:38:08.000000', 'temperatura', 1091.0000, 'ºC'),
	(91595, 112, '2015-03-01 00:38:09.000000', 'temperatura', 129.0000, 'ºC'),
	(91596, 112, '2015-03-01 00:38:10.000000', 'temperatura', 969.0000, 'ºC'),
	(91597, 112, '2015-03-01 00:38:11.000000', 'temperatura', 861.0000, 'ºC'),
	(91598, 112, '2015-03-01 00:38:12.000000', 'temperatura', 197.0000, 'ºC'),
	(91599, 112, '2015-03-01 00:38:13.000000', 'temperatura', 803.0000, 'ºC'),
	(91600, 112, '2015-03-01 00:38:14.000000', 'temperatura', 1026.0000, 'ºC'),
	(91601, 112, '2015-03-01 00:38:15.000000', 'temperatura', 319.0000, 'ºC'),
	(91602, 112, '2015-03-01 00:38:16.000000', 'temperatura', 918.0000, 'ºC'),
	(91603, 112, '2015-03-01 00:38:17.000000', 'temperatura', 35.0000, 'ºC'),
	(91604, 112, '2015-03-01 00:38:18.000000', 'temperatura', 1020.0000, 'ºC'),
	(91605, 112, '2015-03-01 00:38:19.000000', 'temperatura', 195.0000, 'ºC'),
	(91606, 112, '2015-03-01 00:38:20.000000', 'temperatura', 314.0000, 'ºC'),
	(91607, 112, '2015-03-01 00:38:21.000000', 'temperatura', 988.0000, 'ºC'),
	(91608, 112, '2015-03-01 00:38:22.000000', 'temperatura', 399.0000, 'ºC'),
	(91609, 112, '2015-03-01 00:38:23.000000', 'temperatura', 232.0000, 'ºC'),
	(91610, 112, '2015-03-01 00:38:24.000000', 'temperatura', 1163.0000, 'ºC'),
	(91611, 112, '2015-03-01 00:38:25.000000', 'temperatura', 321.0000, 'ºC'),
	(91612, 112, '2015-03-01 00:38:26.000000', 'temperatura', 515.0000, 'ºC'),
	(91613, 112, '2015-03-01 00:38:27.000000', 'temperatura', 414.0000, 'ºC'),
	(91614, 112, '2015-03-01 00:38:28.000000', 'temperatura', 524.0000, 'ºC'),
	(91615, 112, '2015-03-01 00:38:29.000000', 'temperatura', 181.0000, 'ºC'),
	(91616, 112, '2015-03-01 00:38:30.000000', 'temperatura', 531.0000, 'ºC'),
	(91617, 112, '2015-03-01 00:38:31.000000', 'temperatura', 915.0000, 'ºC'),
	(91618, 112, '2015-03-01 00:38:32.000000', 'temperatura', 581.0000, 'ºC'),
	(91619, 112, '2015-03-01 00:38:33.000000', 'temperatura', 162.0000, 'ºC'),
	(91620, 112, '2015-03-01 00:38:34.000000', 'temperatura', 268.0000, 'ºC'),
	(91621, 112, '2015-03-01 00:38:35.000000', 'temperatura', 854.0000, 'ºC'),
	(91622, 112, '2015-03-01 00:38:36.000000', 'temperatura', 1065.0000, 'ºC'),
	(91623, 112, '2015-03-01 00:38:37.000000', 'temperatura', 365.0000, 'ºC'),
	(91624, 112, '2015-03-01 00:38:38.000000', 'temperatura', 1031.0000, 'ºC'),
	(91625, 112, '2015-03-01 00:38:39.000000', 'temperatura', 462.0000, 'ºC'),
	(91626, 112, '2015-03-01 00:38:40.000000', 'temperatura', 415.0000, 'ºC'),
	(91627, 112, '2015-03-01 00:38:41.000000', 'temperatura', 690.0000, 'ºC'),
	(91628, 112, '2015-03-01 00:38:42.000000', 'temperatura', 1005.0000, 'ºC'),
	(91629, 112, '2015-03-01 00:38:43.000000', 'temperatura', 556.0000, 'ºC'),
	(91630, 112, '2015-03-01 00:38:44.000000', 'temperatura', 967.0000, 'ºC'),
	(91631, 112, '2015-03-01 00:38:45.000000', 'temperatura', 766.0000, 'ºC'),
	(91632, 112, '2015-03-01 00:38:46.000000', 'temperatura', 930.0000, 'ºC'),
	(91633, 112, '2015-03-01 00:38:47.000000', 'temperatura', 1152.0000, 'ºC'),
	(91634, 112, '2015-03-01 00:38:48.000000', 'temperatura', 570.0000, 'ºC'),
	(91635, 112, '2015-03-01 00:38:49.000000', 'temperatura', 594.0000, 'ºC'),
	(91636, 112, '2015-03-01 00:38:50.000000', 'temperatura', 63.0000, 'ºC'),
	(91637, 112, '2015-03-01 00:38:51.000000', 'temperatura', 932.0000, 'ºC'),
	(91638, 112, '2015-03-01 00:38:52.000000', 'temperatura', 874.0000, 'ºC'),
	(91639, 112, '2015-03-01 00:38:53.000000', 'temperatura', 371.0000, 'ºC'),
	(91640, 112, '2015-03-01 00:38:54.000000', 'temperatura', 434.0000, 'ºC'),
	(91641, 112, '2015-03-01 00:38:55.000000', 'temperatura', 1060.0000, 'ºC'),
	(91642, 112, '2015-03-01 00:38:56.000000', 'temperatura', 398.0000, 'ºC'),
	(91643, 112, '2015-03-01 00:38:57.000000', 'temperatura', 9.0000, 'ºC'),
	(91644, 112, '2015-03-01 00:38:58.000000', 'temperatura', 51.0000, 'ºC'),
	(91645, 112, '2015-03-01 00:38:59.000000', 'temperatura', 230.0000, 'ºC'),
	(91646, 112, '2015-03-01 00:39:00.000000', 'temperatura', 995.0000, 'ºC'),
	(91647, 112, '2015-03-01 00:39:01.000000', 'temperatura', 688.0000, 'ºC'),
	(91648, 112, '2015-03-01 00:39:02.000000', 'temperatura', 456.0000, 'ºC'),
	(91649, 112, '2015-03-01 00:39:03.000000', 'temperatura', 216.0000, 'ºC'),
	(91650, 112, '2015-03-01 00:39:04.000000', 'temperatura', 911.0000, 'ºC'),
	(91651, 112, '2015-03-01 00:39:05.000000', 'temperatura', 308.0000, 'ºC'),
	(91652, 112, '2015-03-01 00:39:06.000000', 'temperatura', 6.0000, 'ºC'),
	(91653, 112, '2015-03-01 00:39:07.000000', 'temperatura', 306.0000, 'ºC'),
	(91654, 112, '2015-03-01 00:39:08.000000', 'temperatura', 315.0000, 'ºC'),
	(91655, 112, '2015-03-01 00:39:09.000000', 'temperatura', 657.0000, 'ºC'),
	(91656, 112, '2015-03-01 00:39:10.000000', 'temperatura', 1141.0000, 'ºC'),
	(91657, 112, '2015-03-01 00:39:11.000000', 'temperatura', 134.0000, 'ºC'),
	(91658, 112, '2015-03-01 00:39:12.000000', 'temperatura', 847.0000, 'ºC'),
	(91659, 112, '2015-03-01 00:39:13.000000', 'temperatura', 232.0000, 'ºC'),
	(91660, 112, '2015-03-01 00:39:14.000000', 'temperatura', 1022.0000, 'ºC'),
	(91661, 112, '2015-03-01 00:39:15.000000', 'temperatura', 812.0000, 'ºC'),
	(91662, 112, '2015-03-01 00:39:16.000000', 'temperatura', 994.0000, 'ºC'),
	(91663, 112, '2015-03-01 00:39:17.000000', 'temperatura', 134.0000, 'ºC'),
	(91664, 112, '2015-03-01 00:39:18.000000', 'temperatura', 90.0000, 'ºC'),
	(91665, 112, '2015-03-01 00:39:19.000000', 'temperatura', 48.0000, 'ºC'),
	(91666, 112, '2015-03-01 00:39:20.000000', 'temperatura', 1173.0000, 'ºC'),
	(91667, 112, '2015-03-01 00:39:21.000000', 'temperatura', 919.0000, 'ºC'),
	(91668, 112, '2015-03-01 00:39:22.000000', 'temperatura', 1077.0000, 'ºC'),
	(91669, 112, '2015-03-01 00:39:23.000000', 'temperatura', 230.0000, 'ºC'),
	(91670, 112, '2015-03-01 00:39:24.000000', 'temperatura', 319.0000, 'ºC'),
	(91671, 112, '2015-03-01 00:39:25.000000', 'temperatura', 905.0000, 'ºC'),
	(91672, 112, '2015-03-01 00:39:26.000000', 'temperatura', 1168.0000, 'ºC'),
	(91673, 112, '2015-03-01 00:39:27.000000', 'temperatura', 725.0000, 'ºC'),
	(91674, 112, '2015-03-01 00:39:28.000000', 'temperatura', 124.0000, 'ºC'),
	(91675, 112, '2015-03-01 00:39:29.000000', 'temperatura', 843.0000, 'ºC'),
	(91676, 112, '2015-03-01 00:39:30.000000', 'temperatura', 243.0000, 'ºC'),
	(91677, 112, '2015-03-01 00:39:31.000000', 'temperatura', 1088.0000, 'ºC'),
	(91678, 112, '2015-03-01 00:39:32.000000', 'temperatura', 1110.0000, 'ºC'),
	(91679, 112, '2015-03-01 00:39:33.000000', 'temperatura', 1089.0000, 'ºC'),
	(91680, 112, '2015-03-01 00:39:34.000000', 'temperatura', 915.0000, 'ºC'),
	(91681, 112, '2015-03-01 00:39:35.000000', 'temperatura', 107.0000, 'ºC'),
	(91682, 112, '2015-03-01 00:39:36.000000', 'temperatura', 192.0000, 'ºC'),
	(91683, 112, '2015-03-01 00:39:37.000000', 'temperatura', 638.0000, 'ºC'),
	(91684, 112, '2015-03-01 00:39:38.000000', 'temperatura', 217.0000, 'ºC'),
	(91685, 112, '2015-03-01 00:39:39.000000', 'temperatura', 369.0000, 'ºC'),
	(91686, 112, '2015-03-01 00:39:40.000000', 'temperatura', 1195.0000, 'ºC'),
	(91687, 112, '2015-03-01 00:39:41.000000', 'temperatura', 67.0000, 'ºC'),
	(91688, 112, '2015-03-01 00:39:42.000000', 'temperatura', 353.0000, 'ºC'),
	(91689, 112, '2015-03-01 00:39:43.000000', 'temperatura', 362.0000, 'ºC'),
	(91690, 112, '2015-03-01 00:39:44.000000', 'temperatura', 755.0000, 'ºC'),
	(91691, 112, '2015-03-01 00:39:45.000000', 'temperatura', 287.0000, 'ºC'),
	(91692, 112, '2015-03-01 00:39:46.000000', 'temperatura', 370.0000, 'ºC'),
	(91693, 112, '2015-03-01 00:39:47.000000', 'temperatura', 992.0000, 'ºC'),
	(91694, 112, '2015-03-01 00:39:48.000000', 'temperatura', 249.0000, 'ºC'),
	(91695, 112, '2015-03-01 00:39:49.000000', 'temperatura', 669.0000, 'ºC'),
	(91696, 112, '2015-03-01 00:39:50.000000', 'temperatura', 200.0000, 'ºC'),
	(91697, 112, '2015-03-01 00:39:51.000000', 'temperatura', 191.0000, 'ºC'),
	(91698, 112, '2015-03-01 00:39:52.000000', 'temperatura', 358.0000, 'ºC'),
	(91699, 112, '2015-03-01 00:39:53.000000', 'temperatura', 18.0000, 'ºC'),
	(91700, 112, '2015-03-01 00:39:54.000000', 'temperatura', 214.0000, 'ºC'),
	(91701, 112, '2015-03-01 00:39:55.000000', 'temperatura', 1016.0000, 'ºC'),
	(91702, 112, '2015-03-01 00:39:56.000000', 'temperatura', 841.0000, 'ºC'),
	(91703, 112, '2015-03-01 00:39:57.000000', 'temperatura', 1156.0000, 'ºC'),
	(91704, 112, '2015-03-01 00:39:58.000000', 'temperatura', 856.0000, 'ºC'),
	(91705, 112, '2015-03-01 00:39:59.000000', 'temperatura', 813.0000, 'ºC'),
	(91706, 112, '2015-03-01 00:40:00.000000', 'temperatura', 297.0000, 'ºC'),
	(91707, 112, '2015-03-01 00:40:01.000000', 'temperatura', 246.0000, 'ºC'),
	(91708, 112, '2015-03-01 00:40:02.000000', 'temperatura', 339.0000, 'ºC'),
	(91709, 112, '2015-03-01 00:40:03.000000', 'temperatura', 958.0000, 'ºC'),
	(91710, 112, '2015-03-01 00:40:04.000000', 'temperatura', 175.0000, 'ºC'),
	(91711, 112, '2015-03-01 00:40:05.000000', 'temperatura', 401.0000, 'ºC'),
	(91712, 112, '2015-03-01 00:40:06.000000', 'temperatura', 281.0000, 'ºC'),
	(91713, 112, '2015-03-01 00:40:07.000000', 'temperatura', 202.0000, 'ºC'),
	(91714, 112, '2015-03-01 00:40:08.000000', 'temperatura', 167.0000, 'ºC'),
	(91715, 112, '2015-03-01 00:40:09.000000', 'temperatura', 232.0000, 'ºC'),
	(91716, 112, '2015-03-01 00:40:10.000000', 'temperatura', 656.0000, 'ºC'),
	(91717, 112, '2015-03-01 00:40:11.000000', 'temperatura', 188.0000, 'ºC'),
	(91718, 112, '2015-03-01 00:40:12.000000', 'temperatura', 170.0000, 'ºC'),
	(91719, 112, '2015-03-01 00:40:13.000000', 'temperatura', 287.0000, 'ºC'),
	(91720, 112, '2015-03-01 00:40:14.000000', 'temperatura', 926.0000, 'ºC'),
	(91721, 112, '2015-03-01 00:40:15.000000', 'temperatura', 170.0000, 'ºC'),
	(91722, 112, '2015-03-01 00:40:16.000000', 'temperatura', 471.0000, 'ºC'),
	(91723, 112, '2015-03-01 00:40:17.000000', 'temperatura', 644.0000, 'ºC'),
	(91724, 112, '2015-03-01 00:40:18.000000', 'temperatura', 609.0000, 'ºC'),
	(91725, 112, '2015-03-01 00:40:19.000000', 'temperatura', 1115.0000, 'ºC'),
	(91726, 112, '2015-03-01 00:40:20.000000', 'temperatura', 148.0000, 'ºC'),
	(91727, 112, '2015-03-01 00:40:21.000000', 'temperatura', 996.0000, 'ºC'),
	(91728, 112, '2015-03-01 00:40:22.000000', 'temperatura', 936.0000, 'ºC'),
	(91729, 112, '2015-03-01 00:40:23.000000', 'temperatura', 494.0000, 'ºC'),
	(91730, 112, '2015-03-01 00:40:24.000000', 'temperatura', 861.0000, 'ºC'),
	(91731, 112, '2015-03-01 00:40:25.000000', 'temperatura', 422.0000, 'ºC'),
	(91732, 112, '2015-03-01 00:40:26.000000', 'temperatura', 727.0000, 'ºC'),
	(91733, 112, '2015-03-01 00:40:27.000000', 'temperatura', 1172.0000, 'ºC'),
	(91734, 112, '2015-03-01 00:40:28.000000', 'temperatura', 78.0000, 'ºC'),
	(91735, 112, '2015-03-01 00:40:29.000000', 'temperatura', 475.0000, 'ºC'),
	(91736, 112, '2015-03-01 00:40:30.000000', 'temperatura', 941.0000, 'ºC'),
	(91737, 112, '2015-03-01 00:40:31.000000', 'temperatura', 879.0000, 'ºC'),
	(91738, 112, '2015-03-01 00:40:32.000000', 'temperatura', 372.0000, 'ºC'),
	(91739, 112, '2015-03-01 00:40:33.000000', 'temperatura', 427.0000, 'ºC'),
	(91740, 112, '2015-03-01 00:40:34.000000', 'temperatura', 1016.0000, 'ºC'),
	(91741, 112, '2015-03-01 00:40:35.000000', 'temperatura', 200.0000, 'ºC'),
	(91742, 112, '2015-03-01 00:40:36.000000', 'temperatura', 355.0000, 'ºC'),
	(91743, 112, '2015-03-01 00:40:37.000000', 'temperatura', 1174.0000, 'ºC'),
	(91744, 112, '2015-03-01 00:40:38.000000', 'temperatura', 6.0000, 'ºC'),
	(91745, 112, '2015-03-01 00:40:39.000000', 'temperatura', 107.0000, 'ºC'),
	(91746, 112, '2015-03-01 00:40:40.000000', 'temperatura', 520.0000, 'ºC'),
	(91747, 112, '2015-03-01 00:40:41.000000', 'temperatura', 1077.0000, 'ºC'),
	(91748, 112, '2015-03-01 00:40:42.000000', 'temperatura', 228.0000, 'ºC'),
	(91749, 112, '2015-03-01 00:40:43.000000', 'temperatura', 310.0000, 'ºC'),
	(91750, 112, '2015-03-01 00:40:44.000000', 'temperatura', 867.0000, 'ºC'),
	(91751, 112, '2015-03-01 00:40:45.000000', 'temperatura', 1003.0000, 'ºC'),
	(91752, 112, '2015-03-01 00:40:46.000000', 'temperatura', 17.0000, 'ºC'),
	(91753, 112, '2015-03-01 00:40:47.000000', 'temperatura', 677.0000, 'ºC'),
	(91754, 112, '2015-03-01 00:40:48.000000', 'temperatura', 933.0000, 'ºC'),
	(91755, 112, '2015-03-01 00:40:49.000000', 'temperatura', 233.0000, 'ºC'),
	(91756, 112, '2015-03-01 00:40:50.000000', 'temperatura', 769.0000, 'ºC'),
	(91757, 112, '2015-03-01 00:40:51.000000', 'temperatura', 744.0000, 'ºC'),
	(91758, 112, '2015-03-01 00:40:52.000000', 'temperatura', 215.0000, 'ºC'),
	(91759, 112, '2015-03-01 00:40:53.000000', 'temperatura', 45.0000, 'ºC'),
	(91760, 112, '2015-03-01 00:40:54.000000', 'temperatura', 780.0000, 'ºC'),
	(91761, 112, '2015-03-01 00:40:55.000000', 'temperatura', 163.0000, 'ºC'),
	(91762, 112, '2015-03-01 00:40:56.000000', 'temperatura', 878.0000, 'ºC'),
	(91763, 112, '2015-03-01 00:40:57.000000', 'temperatura', 303.0000, 'ºC'),
	(91764, 112, '2015-03-01 00:40:58.000000', 'temperatura', 79.0000, 'ºC'),
	(91765, 112, '2015-03-01 00:40:59.000000', 'temperatura', 686.0000, 'ºC'),
	(91766, 112, '2015-03-01 00:41:00.000000', 'temperatura', 793.0000, 'ºC'),
	(91767, 112, '2015-03-01 00:41:01.000000', 'temperatura', 706.0000, 'ºC'),
	(91768, 112, '2015-03-01 00:41:02.000000', 'temperatura', 1155.0000, 'ºC'),
	(91769, 112, '2015-03-01 00:41:03.000000', 'temperatura', 56.0000, 'ºC'),
	(91770, 112, '2015-03-01 00:41:04.000000', 'temperatura', 416.0000, 'ºC'),
	(91771, 112, '2015-03-01 00:41:05.000000', 'temperatura', 714.0000, 'ºC'),
	(91772, 112, '2015-03-01 00:41:06.000000', 'temperatura', 1121.0000, 'ºC'),
	(91773, 112, '2015-03-01 00:41:07.000000', 'temperatura', 1064.0000, 'ºC'),
	(91774, 112, '2015-03-01 00:41:08.000000', 'temperatura', 758.0000, 'ºC'),
	(91775, 112, '2015-03-01 00:41:09.000000', 'temperatura', 596.0000, 'ºC'),
	(91776, 112, '2015-03-01 00:41:10.000000', 'temperatura', 708.0000, 'ºC'),
	(91777, 112, '2015-03-01 00:41:11.000000', 'temperatura', 551.0000, 'ºC'),
	(91778, 112, '2015-03-01 00:41:12.000000', 'temperatura', 632.0000, 'ºC'),
	(91779, 112, '2015-03-01 00:41:13.000000', 'temperatura', 308.0000, 'ºC'),
	(91780, 112, '2015-03-01 00:41:14.000000', 'temperatura', 842.0000, 'ºC'),
	(91781, 112, '2015-03-01 00:41:15.000000', 'temperatura', 889.0000, 'ºC'),
	(91782, 112, '2015-03-01 00:41:16.000000', 'temperatura', 721.0000, 'ºC'),
	(91783, 112, '2015-03-01 00:41:17.000000', 'temperatura', 936.0000, 'ºC'),
	(91784, 112, '2015-03-01 00:41:18.000000', 'temperatura', 117.0000, 'ºC'),
	(91785, 112, '2015-03-01 00:41:19.000000', 'temperatura', 179.0000, 'ºC'),
	(91786, 112, '2015-03-01 00:41:20.000000', 'temperatura', 545.0000, 'ºC'),
	(91787, 112, '2015-03-01 00:41:21.000000', 'temperatura', 987.0000, 'ºC'),
	(91788, 112, '2015-03-01 00:41:22.000000', 'temperatura', 900.0000, 'ºC'),
	(91789, 112, '2015-03-01 00:41:23.000000', 'temperatura', 341.0000, 'ºC'),
	(91790, 112, '2015-03-01 00:41:24.000000', 'temperatura', 206.0000, 'ºC'),
	(91791, 112, '2015-03-01 00:41:25.000000', 'temperatura', 5.0000, 'ºC'),
	(91792, 112, '2015-03-01 00:41:26.000000', 'temperatura', 608.0000, 'ºC'),
	(91793, 112, '2015-03-01 00:41:27.000000', 'temperatura', 627.0000, 'ºC'),
	(91794, 112, '2015-03-01 00:41:28.000000', 'temperatura', 110.0000, 'ºC'),
	(91795, 112, '2015-03-01 00:41:29.000000', 'temperatura', 1070.0000, 'ºC'),
	(91796, 112, '2015-03-01 00:41:30.000000', 'temperatura', 221.0000, 'ºC'),
	(91797, 112, '2015-03-01 00:41:31.000000', 'temperatura', 294.0000, 'ºC'),
	(91798, 112, '2015-03-01 00:41:32.000000', 'temperatura', 806.0000, 'ºC'),
	(91799, 112, '2015-03-01 00:41:33.000000', 'temperatura', 752.0000, 'ºC'),
	(91800, 112, '2015-03-01 00:41:34.000000', 'temperatura', 141.0000, 'ºC'),
	(91801, 112, '2015-03-01 00:41:35.000000', 'temperatura', 848.0000, 'ºC'),
	(91802, 112, '2015-03-01 00:41:36.000000', 'temperatura', 218.0000, 'ºC'),
	(91803, 112, '2015-03-01 00:41:37.000000', 'temperatura', 949.0000, 'ºC'),
	(91804, 112, '2015-03-01 00:41:38.000000', 'temperatura', 490.0000, 'ºC'),
	(91805, 112, '2015-03-01 00:41:39.000000', 'temperatura', 803.0000, 'ºC'),
	(91806, 112, '2015-03-01 00:41:40.000000', 'temperatura', 146.0000, 'ºC'),
	(91807, 112, '2015-03-01 00:41:41.000000', 'temperatura', 723.0000, 'ºC'),
	(91808, 112, '2015-03-01 00:41:42.000000', 'temperatura', 776.0000, 'ºC'),
	(91809, 112, '2015-03-01 00:41:43.000000', 'temperatura', 514.0000, 'ºC'),
	(91810, 112, '2015-03-01 00:41:44.000000', 'temperatura', 239.0000, 'ºC'),
	(91811, 112, '2015-03-01 00:41:45.000000', 'temperatura', 856.0000, 'ºC'),
	(91812, 112, '2015-03-01 00:41:46.000000', 'temperatura', 1163.0000, 'ºC'),
	(91813, 112, '2015-03-01 00:41:47.000000', 'temperatura', 846.0000, 'ºC'),
	(91814, 112, '2015-03-01 00:41:48.000000', 'temperatura', 743.0000, 'ºC'),
	(91815, 112, '2015-03-01 00:41:49.000000', 'temperatura', 1177.0000, 'ºC'),
	(91816, 112, '2015-03-01 00:41:50.000000', 'temperatura', 56.0000, 'ºC'),
	(91817, 112, '2015-03-01 00:41:51.000000', 'temperatura', 350.0000, 'ºC'),
	(91818, 112, '2015-03-01 00:41:52.000000', 'temperatura', 384.0000, 'ºC'),
	(91819, 112, '2015-03-01 00:41:53.000000', 'temperatura', 871.0000, 'ºC'),
	(91820, 112, '2015-03-01 00:41:54.000000', 'temperatura', 800.0000, 'ºC'),
	(91821, 112, '2015-03-01 00:41:55.000000', 'temperatura', 191.0000, 'ºC'),
	(91822, 112, '2015-03-01 00:41:56.000000', 'temperatura', 953.0000, 'ºC'),
	(91823, 112, '2015-03-01 00:41:57.000000', 'temperatura', 594.0000, 'ºC'),
	(91824, 112, '2015-03-01 00:41:58.000000', 'temperatura', 111.0000, 'ºC'),
	(91825, 112, '2015-03-01 00:41:59.000000', 'temperatura', 1173.0000, 'ºC'),
	(91826, 112, '2015-03-01 00:42:00.000000', 'temperatura', 731.0000, 'ºC'),
	(91827, 112, '2015-03-01 00:42:01.000000', 'temperatura', 139.0000, 'ºC'),
	(91828, 112, '2015-03-01 00:42:02.000000', 'temperatura', 902.0000, 'ºC'),
	(91829, 112, '2015-03-01 00:42:03.000000', 'temperatura', 494.0000, 'ºC'),
	(91830, 112, '2015-03-01 00:42:04.000000', 'temperatura', 965.0000, 'ºC'),
	(91831, 112, '2015-03-01 00:42:05.000000', 'temperatura', 943.0000, 'ºC'),
	(91832, 112, '2015-03-01 00:42:06.000000', 'temperatura', 622.0000, 'ºC'),
	(91833, 112, '2015-03-01 00:42:07.000000', 'temperatura', 281.0000, 'ºC'),
	(91834, 112, '2015-03-01 00:42:08.000000', 'temperatura', 738.0000, 'ºC'),
	(91835, 112, '2015-03-01 00:42:09.000000', 'temperatura', 450.0000, 'ºC'),
	(91836, 112, '2015-03-01 00:42:10.000000', 'temperatura', 36.0000, 'ºC'),
	(91837, 112, '2015-03-01 00:42:11.000000', 'temperatura', 28.0000, 'ºC'),
	(91838, 112, '2015-03-01 00:42:12.000000', 'temperatura', 34.0000, 'ºC'),
	(91839, 112, '2015-03-01 00:42:13.000000', 'temperatura', 87.0000, 'ºC'),
	(91840, 112, '2015-03-01 00:42:14.000000', 'temperatura', 332.0000, 'ºC'),
	(91841, 112, '2015-03-01 00:42:15.000000', 'temperatura', 199.0000, 'ºC'),
	(91842, 112, '2015-03-01 00:42:16.000000', 'temperatura', 1.0000, 'ºC'),
	(91843, 112, '2015-03-01 00:42:17.000000', 'temperatura', 610.0000, 'ºC'),
	(91844, 112, '2015-03-01 00:42:18.000000', 'temperatura', 647.0000, 'ºC'),
	(91845, 112, '2015-03-01 00:42:19.000000', 'temperatura', 204.0000, 'ºC'),
	(91846, 112, '2015-03-01 00:42:20.000000', 'temperatura', 281.0000, 'ºC'),
	(91847, 112, '2015-03-01 00:42:21.000000', 'temperatura', 791.0000, 'ºC'),
	(91848, 112, '2015-03-01 00:42:22.000000', 'temperatura', 716.0000, 'ºC'),
	(91849, 112, '2015-03-01 00:42:23.000000', 'temperatura', 6.0000, 'ºC'),
	(91850, 112, '2015-03-01 00:42:24.000000', 'temperatura', 282.0000, 'ºC'),
	(91851, 112, '2015-03-01 00:42:25.000000', 'temperatura', 192.0000, 'ºC'),
	(91852, 112, '2015-03-01 00:42:26.000000', 'temperatura', 116.0000, 'ºC'),
	(91853, 112, '2015-03-01 00:42:27.000000', 'temperatura', 5.0000, 'ºC'),
	(91854, 112, '2015-03-01 00:42:28.000000', 'temperatura', 878.0000, 'ºC'),
	(91855, 112, '2015-03-01 00:42:29.000000', 'temperatura', 775.0000, 'ºC'),
	(91856, 112, '2015-03-01 00:42:30.000000', 'temperatura', 41.0000, 'ºC'),
	(91857, 112, '2015-03-01 00:42:31.000000', 'temperatura', 281.0000, 'ºC'),
	(91858, 112, '2015-03-01 00:42:32.000000', 'temperatura', 82.0000, 'ºC'),
	(91859, 112, '2015-03-01 00:42:33.000000', 'temperatura', 767.0000, 'ºC'),
	(91860, 112, '2015-03-01 00:42:34.000000', 'temperatura', 1191.0000, 'ºC'),
	(91861, 112, '2015-03-01 00:42:35.000000', 'temperatura', 54.0000, 'ºC'),
	(91862, 112, '2015-03-01 00:42:36.000000', 'temperatura', 298.0000, 'ºC'),
	(91863, 112, '2015-03-01 00:42:37.000000', 'temperatura', 128.0000, 'ºC'),
	(91864, 112, '2015-03-01 00:42:38.000000', 'temperatura', 948.0000, 'ºC'),
	(91865, 112, '2015-03-01 00:42:39.000000', 'temperatura', 756.0000, 'ºC'),
	(91866, 112, '2015-03-01 00:42:40.000000', 'temperatura', 937.0000, 'ºC'),
	(91867, 112, '2015-03-01 00:42:41.000000', 'temperatura', 17.0000, 'ºC'),
	(91868, 112, '2015-03-01 00:42:42.000000', 'temperatura', 876.0000, 'ºC'),
	(91869, 112, '2015-03-01 00:42:43.000000', 'temperatura', 730.0000, 'ºC'),
	(91870, 112, '2015-03-01 00:42:44.000000', 'temperatura', 1021.0000, 'ºC'),
	(91871, 112, '2015-03-01 00:42:45.000000', 'temperatura', 517.0000, 'ºC'),
	(91872, 112, '2015-03-01 00:42:46.000000', 'temperatura', 721.0000, 'ºC'),
	(91873, 112, '2015-03-01 00:42:47.000000', 'temperatura', 853.0000, 'ºC'),
	(91874, 112, '2015-03-01 00:42:48.000000', 'temperatura', 905.0000, 'ºC'),
	(91875, 112, '2015-03-01 00:42:49.000000', 'temperatura', 764.0000, 'ºC'),
	(91876, 112, '2015-03-01 00:42:50.000000', 'temperatura', 1107.0000, 'ºC'),
	(91877, 112, '2015-03-01 00:42:51.000000', 'temperatura', 844.0000, 'ºC'),
	(91878, 112, '2015-03-01 00:42:52.000000', 'temperatura', 901.0000, 'ºC'),
	(91879, 112, '2015-03-01 00:42:53.000000', 'temperatura', 771.0000, 'ºC'),
	(91880, 112, '2015-03-01 00:42:54.000000', 'temperatura', 1154.0000, 'ºC'),
	(91881, 112, '2015-03-01 00:42:55.000000', 'temperatura', 1059.0000, 'ºC'),
	(91882, 112, '2015-03-01 00:42:56.000000', 'temperatura', 633.0000, 'ºC'),
	(91883, 112, '2015-03-01 00:42:57.000000', 'temperatura', 1187.0000, 'ºC'),
	(91884, 112, '2015-03-01 00:42:58.000000', 'temperatura', 435.0000, 'ºC'),
	(91885, 112, '2015-03-01 00:42:59.000000', 'temperatura', 1017.0000, 'ºC'),
	(91886, 112, '2015-03-01 00:43:00.000000', 'temperatura', 180.0000, 'ºC'),
	(91887, 112, '2015-03-01 00:43:01.000000', 'temperatura', 250.0000, 'ºC'),
	(91888, 112, '2015-03-01 00:43:02.000000', 'temperatura', 710.0000, 'ºC'),
	(91889, 112, '2015-03-01 00:43:03.000000', 'temperatura', 400.0000, 'ºC'),
	(91890, 112, '2015-03-01 00:43:04.000000', 'temperatura', 1071.0000, 'ºC'),
	(91891, 112, '2015-03-01 00:43:05.000000', 'temperatura', 556.0000, 'ºC'),
	(91892, 112, '2015-03-01 00:43:06.000000', 'temperatura', 769.0000, 'ºC'),
	(91893, 112, '2015-03-01 00:43:07.000000', 'temperatura', 976.0000, 'ºC'),
	(91894, 112, '2015-03-01 00:43:08.000000', 'temperatura', 174.0000, 'ºC'),
	(91895, 112, '2015-03-01 00:43:09.000000', 'temperatura', 340.0000, 'ºC'),
	(91896, 112, '2015-03-01 00:43:10.000000', 'temperatura', 1182.0000, 'ºC'),
	(91897, 112, '2015-03-01 00:43:11.000000', 'temperatura', 89.0000, 'ºC'),
	(91898, 112, '2015-03-01 00:43:12.000000', 'temperatura', 500.0000, 'ºC'),
	(91899, 112, '2015-03-01 00:43:13.000000', 'temperatura', 1035.0000, 'ºC'),
	(91900, 112, '2015-03-01 00:43:14.000000', 'temperatura', 73.0000, 'ºC'),
	(91901, 112, '2015-03-01 00:43:15.000000', 'temperatura', 862.0000, 'ºC'),
	(91902, 112, '2015-03-01 00:43:16.000000', 'temperatura', 493.0000, 'ºC'),
	(91903, 112, '2015-03-01 00:43:17.000000', 'temperatura', 1077.0000, 'ºC'),
	(91904, 112, '2015-03-01 00:43:18.000000', 'temperatura', 309.0000, 'ºC'),
	(91905, 112, '2015-03-01 00:43:19.000000', 'temperatura', 714.0000, 'ºC'),
	(91906, 112, '2015-03-01 00:43:20.000000', 'temperatura', 242.0000, 'ºC'),
	(91907, 112, '2015-03-01 00:43:21.000000', 'temperatura', 268.0000, 'ºC'),
	(91908, 112, '2015-03-01 00:43:22.000000', 'temperatura', 616.0000, 'ºC'),
	(91909, 112, '2015-03-01 00:43:23.000000', 'temperatura', 1076.0000, 'ºC'),
	(91910, 112, '2015-03-01 00:43:24.000000', 'temperatura', 1133.0000, 'ºC'),
	(91911, 112, '2015-03-01 00:43:25.000000', 'temperatura', 38.0000, 'ºC'),
	(91912, 112, '2015-03-01 00:43:26.000000', 'temperatura', 390.0000, 'ºC'),
	(91913, 112, '2015-03-01 00:43:27.000000', 'temperatura', 637.0000, 'ºC'),
	(91914, 112, '2015-03-01 00:43:28.000000', 'temperatura', 815.0000, 'ºC'),
	(91915, 112, '2015-03-01 00:43:29.000000', 'temperatura', 964.0000, 'ºC'),
	(91916, 112, '2015-03-01 00:43:30.000000', 'temperatura', 1177.0000, 'ºC'),
	(91917, 112, '2015-03-01 00:43:31.000000', 'temperatura', 592.0000, 'ºC'),
	(91918, 112, '2015-03-01 00:43:32.000000', 'temperatura', 628.0000, 'ºC'),
	(91919, 112, '2015-03-01 00:43:33.000000', 'temperatura', 167.0000, 'ºC'),
	(91920, 112, '2015-03-01 00:43:34.000000', 'temperatura', 150.0000, 'ºC'),
	(91921, 112, '2015-03-01 00:43:35.000000', 'temperatura', 249.0000, 'ºC'),
	(91922, 112, '2015-03-01 00:43:36.000000', 'temperatura', 797.0000, 'ºC'),
	(91923, 112, '2015-03-01 00:43:37.000000', 'temperatura', 837.0000, 'ºC'),
	(91924, 112, '2015-03-01 00:43:38.000000', 'temperatura', 595.0000, 'ºC'),
	(91925, 112, '2015-03-01 00:43:39.000000', 'temperatura', 466.0000, 'ºC'),
	(91926, 112, '2015-03-01 00:43:40.000000', 'temperatura', 546.0000, 'ºC'),
	(91927, 112, '2015-03-01 00:43:41.000000', 'temperatura', 130.0000, 'ºC'),
	(91928, 112, '2015-03-01 00:43:42.000000', 'temperatura', 211.0000, 'ºC'),
	(91929, 112, '2015-03-01 00:43:43.000000', 'temperatura', 669.0000, 'ºC'),
	(91930, 112, '2015-03-01 00:43:44.000000', 'temperatura', 312.0000, 'ºC'),
	(91931, 112, '2015-03-01 00:43:45.000000', 'temperatura', 754.0000, 'ºC'),
	(91932, 112, '2015-03-01 00:43:46.000000', 'temperatura', 435.0000, 'ºC'),
	(91933, 112, '2015-03-01 00:43:47.000000', 'temperatura', 1114.0000, 'ºC'),
	(91934, 112, '2015-03-01 00:43:48.000000', 'temperatura', 664.0000, 'ºC'),
	(91935, 112, '2015-03-01 00:43:49.000000', 'temperatura', 1178.0000, 'ºC'),
	(91936, 112, '2015-03-01 00:43:50.000000', 'temperatura', 298.0000, 'ºC'),
	(91937, 112, '2015-03-01 00:43:51.000000', 'temperatura', 356.0000, 'ºC'),
	(91938, 112, '2015-03-01 00:43:52.000000', 'temperatura', 888.0000, 'ºC'),
	(91939, 112, '2015-03-01 00:43:53.000000', 'temperatura', 972.0000, 'ºC'),
	(91940, 112, '2015-03-01 00:43:54.000000', 'temperatura', 998.0000, 'ºC'),
	(91941, 112, '2015-03-01 00:43:55.000000', 'temperatura', 874.0000, 'ºC'),
	(91942, 112, '2015-03-01 00:43:56.000000', 'temperatura', 176.0000, 'ºC'),
	(91943, 112, '2015-03-01 00:43:57.000000', 'temperatura', 657.0000, 'ºC'),
	(91944, 112, '2015-03-01 00:43:58.000000', 'temperatura', 359.0000, 'ºC'),
	(91945, 112, '2015-03-01 00:43:59.000000', 'temperatura', 1024.0000, 'ºC'),
	(91946, 112, '2015-03-01 00:44:00.000000', 'temperatura', 443.0000, 'ºC'),
	(91947, 112, '2015-03-01 00:44:01.000000', 'temperatura', 345.0000, 'ºC'),
	(91948, 112, '2015-03-01 00:44:02.000000', 'temperatura', 395.0000, 'ºC'),
	(91949, 112, '2015-03-01 00:44:03.000000', 'temperatura', 941.0000, 'ºC'),
	(91950, 112, '2015-03-01 00:44:04.000000', 'temperatura', 1122.0000, 'ºC'),
	(91951, 112, '2015-03-01 00:44:05.000000', 'temperatura', 388.0000, 'ºC'),
	(91952, 112, '2015-03-01 00:44:06.000000', 'temperatura', 973.0000, 'ºC'),
	(91953, 112, '2015-03-01 00:44:07.000000', 'temperatura', 101.0000, 'ºC'),
	(91954, 112, '2015-03-01 00:44:08.000000', 'temperatura', 1188.0000, 'ºC'),
	(91955, 112, '2015-03-01 00:44:09.000000', 'temperatura', 836.0000, 'ºC'),
	(91956, 112, '2015-03-01 00:44:10.000000', 'temperatura', 617.0000, 'ºC'),
	(91957, 112, '2015-03-01 00:44:11.000000', 'temperatura', 577.0000, 'ºC'),
	(91958, 112, '2015-03-01 00:44:12.000000', 'temperatura', 1037.0000, 'ºC'),
	(91959, 112, '2015-03-01 00:44:13.000000', 'temperatura', 1053.0000, 'ºC'),
	(91960, 112, '2015-03-01 00:44:14.000000', 'temperatura', 955.0000, 'ºC'),
	(91961, 112, '2015-03-01 00:44:15.000000', 'temperatura', 415.0000, 'ºC'),
	(91962, 112, '2015-03-01 00:44:16.000000', 'temperatura', 411.0000, 'ºC'),
	(91963, 112, '2015-03-01 00:44:17.000000', 'temperatura', 809.0000, 'ºC'),
	(91964, 112, '2015-03-01 00:44:18.000000', 'temperatura', 413.0000, 'ºC'),
	(91965, 112, '2015-03-01 00:44:19.000000', 'temperatura', 840.0000, 'ºC'),
	(91966, 112, '2015-03-01 00:44:20.000000', 'temperatura', 563.0000, 'ºC'),
	(91967, 112, '2015-03-01 00:44:21.000000', 'temperatura', 294.0000, 'ºC'),
	(91968, 112, '2015-03-01 00:44:22.000000', 'temperatura', 980.0000, 'ºC'),
	(91969, 112, '2015-03-01 00:44:23.000000', 'temperatura', 419.0000, 'ºC'),
	(91970, 112, '2015-03-01 00:44:24.000000', 'temperatura', 356.0000, 'ºC'),
	(91971, 112, '2015-03-01 00:44:25.000000', 'temperatura', 526.0000, 'ºC'),
	(91972, 112, '2015-03-01 00:44:26.000000', 'temperatura', 359.0000, 'ºC'),
	(91973, 112, '2015-03-01 00:44:27.000000', 'temperatura', 217.0000, 'ºC'),
	(91974, 112, '2015-03-01 00:44:28.000000', 'temperatura', 12.0000, 'ºC'),
	(91975, 112, '2015-03-01 00:44:29.000000', 'temperatura', 607.0000, 'ºC'),
	(91976, 112, '2015-03-01 00:44:30.000000', 'temperatura', 600.0000, 'ºC'),
	(91977, 112, '2015-03-01 00:44:31.000000', 'temperatura', 1182.0000, 'ºC'),
	(91978, 112, '2015-03-01 00:44:32.000000', 'temperatura', 507.0000, 'ºC'),
	(91979, 112, '2015-03-01 00:44:33.000000', 'temperatura', 190.0000, 'ºC'),
	(91980, 112, '2015-03-01 00:44:34.000000', 'temperatura', 630.0000, 'ºC'),
	(91981, 112, '2015-03-01 00:44:35.000000', 'temperatura', 181.0000, 'ºC'),
	(91982, 112, '2015-03-01 00:44:36.000000', 'temperatura', 213.0000, 'ºC'),
	(91983, 112, '2015-03-01 00:44:37.000000', 'temperatura', 524.0000, 'ºC'),
	(91984, 112, '2015-03-01 00:44:38.000000', 'temperatura', 783.0000, 'ºC'),
	(91985, 112, '2015-03-01 00:44:39.000000', 'temperatura', 1142.0000, 'ºC'),
	(91986, 112, '2015-03-01 00:44:40.000000', 'temperatura', 964.0000, 'ºC'),
	(91987, 112, '2015-03-01 00:44:41.000000', 'temperatura', 191.0000, 'ºC'),
	(91988, 112, '2015-03-01 00:44:42.000000', 'temperatura', 467.0000, 'ºC'),
	(91989, 112, '2015-03-01 00:44:43.000000', 'temperatura', 561.0000, 'ºC'),
	(91990, 112, '2015-03-01 00:44:44.000000', 'temperatura', 205.0000, 'ºC'),
	(91991, 112, '2015-03-01 00:44:45.000000', 'temperatura', 542.0000, 'ºC'),
	(91992, 112, '2015-03-01 00:44:46.000000', 'temperatura', 894.0000, 'ºC'),
	(91993, 112, '2015-03-01 00:44:47.000000', 'temperatura', 446.0000, 'ºC'),
	(91994, 112, '2015-03-01 00:44:48.000000', 'temperatura', 749.0000, 'ºC'),
	(91995, 112, '2015-03-01 00:44:49.000000', 'temperatura', 8.0000, 'ºC'),
	(91996, 112, '2015-03-01 00:44:50.000000', 'temperatura', 193.0000, 'ºC'),
	(91997, 112, '2015-03-01 00:44:51.000000', 'temperatura', 941.0000, 'ºC'),
	(91998, 112, '2015-03-01 00:44:52.000000', 'temperatura', 526.0000, 'ºC'),
	(91999, 112, '2015-03-01 00:44:53.000000', 'temperatura', 1008.0000, 'ºC'),
	(92000, 112, '2015-03-01 00:44:54.000000', 'temperatura', 1062.0000, 'ºC'),
	(92001, 112, '2015-03-01 00:44:55.000000', 'temperatura', 1086.0000, 'ºC'),
	(92002, 112, '2015-03-01 00:44:56.000000', 'temperatura', 1043.0000, 'ºC'),
	(92003, 112, '2015-03-01 00:44:57.000000', 'temperatura', 761.0000, 'ºC'),
	(92004, 112, '2015-03-01 00:44:58.000000', 'temperatura', 673.0000, 'ºC'),
	(92005, 112, '2015-03-01 00:44:59.000000', 'temperatura', 1085.0000, 'ºC'),
	(92006, 112, '2015-03-01 00:45:00.000000', 'temperatura', 1004.0000, 'ºC'),
	(92007, 112, '2015-03-01 00:45:01.000000', 'temperatura', 567.0000, 'ºC'),
	(92008, 112, '2015-03-01 00:45:02.000000', 'temperatura', 1025.0000, 'ºC'),
	(92009, 112, '2015-03-01 00:45:03.000000', 'temperatura', 1024.0000, 'ºC'),
	(92010, 112, '2015-03-01 00:45:04.000000', 'temperatura', 843.0000, 'ºC'),
	(92011, 112, '2015-03-01 00:45:05.000000', 'temperatura', 1146.0000, 'ºC'),
	(92012, 112, '2015-03-01 00:45:06.000000', 'temperatura', 803.0000, 'ºC'),
	(92013, 112, '2015-03-01 00:45:07.000000', 'temperatura', 575.0000, 'ºC'),
	(92014, 112, '2015-03-01 00:45:08.000000', 'temperatura', 468.0000, 'ºC'),
	(92015, 112, '2015-03-01 00:45:09.000000', 'temperatura', 617.0000, 'ºC'),
	(92016, 112, '2015-03-01 00:45:10.000000', 'temperatura', 480.0000, 'ºC'),
	(92017, 112, '2015-03-01 00:45:11.000000', 'temperatura', 549.0000, 'ºC'),
	(92018, 112, '2015-03-01 00:45:12.000000', 'temperatura', 104.0000, 'ºC'),
	(92019, 112, '2015-03-01 00:45:13.000000', 'temperatura', 76.0000, 'ºC'),
	(92020, 112, '2015-03-01 00:45:14.000000', 'temperatura', 69.0000, 'ºC'),
	(92021, 112, '2015-03-01 00:45:15.000000', 'temperatura', 116.0000, 'ºC'),
	(92022, 112, '2015-03-01 00:45:16.000000', 'temperatura', 372.0000, 'ºC'),
	(92023, 112, '2015-03-01 00:45:17.000000', 'temperatura', 314.0000, 'ºC'),
	(92024, 112, '2015-03-01 00:45:18.000000', 'temperatura', 454.0000, 'ºC'),
	(92025, 112, '2015-03-01 00:45:19.000000', 'temperatura', 129.0000, 'ºC'),
	(92026, 112, '2015-03-01 00:45:20.000000', 'temperatura', 483.0000, 'ºC'),
	(92027, 112, '2015-03-01 00:45:21.000000', 'temperatura', 830.0000, 'ºC'),
	(92028, 112, '2015-03-01 00:45:22.000000', 'temperatura', 299.0000, 'ºC'),
	(92029, 112, '2015-03-01 00:45:23.000000', 'temperatura', 207.0000, 'ºC'),
	(92030, 112, '2015-03-01 00:45:24.000000', 'temperatura', 140.0000, 'ºC'),
	(92031, 112, '2015-03-01 00:45:25.000000', 'temperatura', 80.0000, 'ºC'),
	(92032, 112, '2015-03-01 00:45:26.000000', 'temperatura', 1178.0000, 'ºC'),
	(92033, 112, '2015-03-01 00:45:27.000000', 'temperatura', 852.0000, 'ºC'),
	(92034, 112, '2015-03-01 00:45:28.000000', 'temperatura', 728.0000, 'ºC'),
	(92035, 112, '2015-03-01 00:45:29.000000', 'temperatura', 1081.0000, 'ºC'),
	(92036, 112, '2015-03-01 00:45:30.000000', 'temperatura', 824.0000, 'ºC'),
	(92037, 112, '2015-03-01 00:45:31.000000', 'temperatura', 875.0000, 'ºC'),
	(92038, 112, '2015-03-01 00:45:32.000000', 'temperatura', 704.0000, 'ºC'),
	(92039, 112, '2015-03-01 00:45:33.000000', 'temperatura', 895.0000, 'ºC'),
	(92040, 112, '2015-03-01 00:45:34.000000', 'temperatura', 1163.0000, 'ºC'),
	(92041, 112, '2015-03-01 00:45:35.000000', 'temperatura', 730.0000, 'ºC'),
	(92042, 112, '2015-03-01 00:45:36.000000', 'temperatura', 161.0000, 'ºC'),
	(92043, 112, '2015-03-01 00:45:37.000000', 'temperatura', 1015.0000, 'ºC'),
	(92044, 112, '2015-03-01 00:45:38.000000', 'temperatura', 993.0000, 'ºC'),
	(92045, 112, '2015-03-01 00:45:39.000000', 'temperatura', 722.0000, 'ºC'),
	(92046, 112, '2015-03-01 00:45:40.000000', 'temperatura', 633.0000, 'ºC'),
	(92047, 112, '2015-03-01 00:45:41.000000', 'temperatura', 997.0000, 'ºC'),
	(92048, 112, '2015-03-01 00:45:42.000000', 'temperatura', 686.0000, 'ºC'),
	(92049, 112, '2015-03-01 00:45:43.000000', 'temperatura', 442.0000, 'ºC'),
	(92050, 112, '2015-03-01 00:45:44.000000', 'temperatura', 151.0000, 'ºC'),
	(92051, 112, '2015-03-01 00:45:45.000000', 'temperatura', 628.0000, 'ºC'),
	(92052, 112, '2015-03-01 00:45:46.000000', 'temperatura', 288.0000, 'ºC'),
	(92053, 112, '2015-03-01 00:45:47.000000', 'temperatura', 758.0000, 'ºC'),
	(92054, 112, '2015-03-01 00:45:48.000000', 'temperatura', 526.0000, 'ºC'),
	(92055, 112, '2015-03-01 00:45:49.000000', 'temperatura', 357.0000, 'ºC'),
	(92056, 112, '2015-03-01 00:45:50.000000', 'temperatura', 207.0000, 'ºC'),
	(92057, 112, '2015-03-01 00:45:51.000000', 'temperatura', 1163.0000, 'ºC'),
	(92058, 112, '2015-03-01 00:45:52.000000', 'temperatura', 397.0000, 'ºC'),
	(92059, 112, '2015-03-01 00:45:53.000000', 'temperatura', 896.0000, 'ºC'),
	(92060, 112, '2015-03-01 00:45:54.000000', 'temperatura', 890.0000, 'ºC'),
	(92061, 112, '2015-03-01 00:45:55.000000', 'temperatura', 561.0000, 'ºC'),
	(92062, 112, '2015-03-01 00:45:56.000000', 'temperatura', 134.0000, 'ºC'),
	(92063, 112, '2015-03-01 00:45:57.000000', 'temperatura', 190.0000, 'ºC'),
	(92064, 112, '2015-03-01 00:45:58.000000', 'temperatura', 548.0000, 'ºC'),
	(92065, 112, '2015-03-01 00:45:59.000000', 'temperatura', 969.0000, 'ºC'),
	(92066, 112, '2015-03-01 00:46:00.000000', 'temperatura', 803.0000, 'ºC'),
	(92067, 112, '2015-03-01 00:46:01.000000', 'temperatura', 1106.0000, 'ºC'),
	(92068, 112, '2015-03-01 00:46:02.000000', 'temperatura', 724.0000, 'ºC'),
	(92069, 112, '2015-03-01 00:46:03.000000', 'temperatura', 300.0000, 'ºC'),
	(92070, 112, '2015-03-01 00:46:04.000000', 'temperatura', 529.0000, 'ºC'),
	(92071, 112, '2015-03-01 00:46:05.000000', 'temperatura', 545.0000, 'ºC'),
	(92072, 112, '2015-03-01 00:46:06.000000', 'temperatura', 1138.0000, 'ºC'),
	(92073, 112, '2015-03-01 00:46:07.000000', 'temperatura', 457.0000, 'ºC'),
	(92074, 112, '2015-03-01 00:46:08.000000', 'temperatura', 73.0000, 'ºC'),
	(92075, 112, '2015-03-01 00:46:09.000000', 'temperatura', 193.0000, 'ºC'),
	(92076, 112, '2015-03-01 00:46:10.000000', 'temperatura', 747.0000, 'ºC'),
	(92077, 112, '2015-03-01 00:46:11.000000', 'temperatura', 755.0000, 'ºC'),
	(92078, 112, '2015-03-01 00:46:12.000000', 'temperatura', 334.0000, 'ºC'),
	(92079, 112, '2015-03-01 00:46:13.000000', 'temperatura', 606.0000, 'ºC'),
	(92080, 112, '2015-03-01 00:46:14.000000', 'temperatura', 831.0000, 'ºC'),
	(92081, 112, '2015-03-01 00:46:15.000000', 'temperatura', 1135.0000, 'ºC'),
	(92082, 112, '2015-03-01 00:46:16.000000', 'temperatura', 785.0000, 'ºC'),
	(92083, 112, '2015-03-01 00:46:17.000000', 'temperatura', 518.0000, 'ºC'),
	(92084, 112, '2015-03-01 00:46:18.000000', 'temperatura', 238.0000, 'ºC'),
	(92085, 112, '2015-03-01 00:46:19.000000', 'temperatura', 834.0000, 'ºC'),
	(92086, 112, '2015-03-01 00:46:20.000000', 'temperatura', 1057.0000, 'ºC'),
	(92087, 112, '2015-03-01 00:46:21.000000', 'temperatura', 384.0000, 'ºC'),
	(92088, 112, '2015-03-01 00:46:22.000000', 'temperatura', 1147.0000, 'ºC'),
	(92089, 112, '2015-03-01 00:46:23.000000', 'temperatura', 987.0000, 'ºC'),
	(92090, 112, '2015-03-01 00:46:24.000000', 'temperatura', 294.0000, 'ºC'),
	(92091, 112, '2015-03-01 00:46:25.000000', 'temperatura', 911.0000, 'ºC'),
	(92092, 112, '2015-03-01 00:46:26.000000', 'temperatura', 70.0000, 'ºC'),
	(92093, 112, '2015-03-01 00:46:27.000000', 'temperatura', 19.0000, 'ºC'),
	(92094, 112, '2015-03-01 00:46:28.000000', 'temperatura', 1087.0000, 'ºC'),
	(92095, 112, '2015-03-01 00:46:29.000000', 'temperatura', 578.0000, 'ºC'),
	(92096, 112, '2015-03-01 00:46:30.000000', 'temperatura', 830.0000, 'ºC'),
	(92097, 112, '2015-03-01 00:46:31.000000', 'temperatura', 17.0000, 'ºC'),
	(92098, 112, '2015-03-01 00:46:32.000000', 'temperatura', 1193.0000, 'ºC'),
	(92099, 112, '2015-03-01 00:46:33.000000', 'temperatura', 1115.0000, 'ºC'),
	(92100, 112, '2015-03-01 00:46:34.000000', 'temperatura', 796.0000, 'ºC'),
	(92101, 112, '2015-03-01 00:46:35.000000', 'temperatura', 635.0000, 'ºC'),
	(92102, 112, '2015-03-01 00:46:36.000000', 'temperatura', 787.0000, 'ºC'),
	(92103, 112, '2015-03-01 00:46:37.000000', 'temperatura', 831.0000, 'ºC'),
	(92104, 112, '2015-03-01 00:46:38.000000', 'temperatura', 596.0000, 'ºC'),
	(92105, 112, '2015-03-01 00:46:39.000000', 'temperatura', 485.0000, 'ºC'),
	(92106, 112, '2015-03-01 00:46:40.000000', 'temperatura', 640.0000, 'ºC'),
	(92107, 112, '2015-03-01 00:46:41.000000', 'temperatura', 544.0000, 'ºC'),
	(92108, 112, '2015-03-01 00:46:42.000000', 'temperatura', 799.0000, 'ºC'),
	(92109, 112, '2015-03-01 00:46:43.000000', 'temperatura', 1165.0000, 'ºC'),
	(92110, 112, '2015-03-01 00:46:44.000000', 'temperatura', 1029.0000, 'ºC'),
	(92111, 112, '2015-03-01 00:46:45.000000', 'temperatura', 449.0000, 'ºC'),
	(92112, 112, '2015-03-01 00:46:46.000000', 'temperatura', 360.0000, 'ºC'),
	(92113, 112, '2015-03-01 00:46:47.000000', 'temperatura', 451.0000, 'ºC'),
	(92114, 112, '2015-03-01 00:46:48.000000', 'temperatura', 1176.0000, 'ºC'),
	(92115, 112, '2015-03-01 00:46:49.000000', 'temperatura', 930.0000, 'ºC'),
	(92116, 112, '2015-03-01 00:46:50.000000', 'temperatura', 1122.0000, 'ºC'),
	(92117, 112, '2015-03-01 00:46:51.000000', 'temperatura', 421.0000, 'ºC'),
	(92118, 112, '2015-03-01 00:46:52.000000', 'temperatura', 1139.0000, 'ºC'),
	(92119, 112, '2015-03-01 00:46:53.000000', 'temperatura', 832.0000, 'ºC'),
	(92120, 112, '2015-03-01 00:46:54.000000', 'temperatura', 744.0000, 'ºC'),
	(92121, 112, '2015-03-01 00:46:55.000000', 'temperatura', 23.0000, 'ºC'),
	(92122, 112, '2015-03-01 00:46:56.000000', 'temperatura', 284.0000, 'ºC'),
	(92123, 112, '2015-03-01 00:46:57.000000', 'temperatura', 154.0000, 'ºC'),
	(92124, 112, '2015-03-01 00:46:58.000000', 'temperatura', 1115.0000, 'ºC'),
	(92125, 112, '2015-03-01 00:46:59.000000', 'temperatura', 315.0000, 'ºC'),
	(92126, 112, '2015-03-01 00:47:00.000000', 'temperatura', 631.0000, 'ºC'),
	(92127, 112, '2015-03-01 00:47:01.000000', 'temperatura', 1012.0000, 'ºC'),
	(92128, 112, '2015-03-01 00:47:02.000000', 'temperatura', 764.0000, 'ºC'),
	(92129, 112, '2015-03-01 00:47:03.000000', 'temperatura', 786.0000, 'ºC'),
	(92130, 112, '2015-03-01 00:47:04.000000', 'temperatura', 439.0000, 'ºC'),
	(92131, 112, '2015-03-01 00:47:05.000000', 'temperatura', 1037.0000, 'ºC'),
	(92132, 112, '2015-03-01 00:47:06.000000', 'temperatura', 269.0000, 'ºC'),
	(92133, 112, '2015-03-01 00:47:07.000000', 'temperatura', 634.0000, 'ºC'),
	(92134, 112, '2015-03-01 00:47:08.000000', 'temperatura', 1166.0000, 'ºC'),
	(92135, 112, '2015-03-01 00:47:09.000000', 'temperatura', 326.0000, 'ºC'),
	(92136, 112, '2015-03-01 00:47:10.000000', 'temperatura', 533.0000, 'ºC'),
	(92137, 112, '2015-03-01 00:47:11.000000', 'temperatura', 486.0000, 'ºC'),
	(92138, 112, '2015-03-01 00:47:12.000000', 'temperatura', 834.0000, 'ºC'),
	(92139, 112, '2015-03-01 00:47:13.000000', 'temperatura', 313.0000, 'ºC'),
	(92140, 112, '2015-03-01 00:47:14.000000', 'temperatura', 263.0000, 'ºC'),
	(92141, 112, '2015-03-01 00:47:15.000000', 'temperatura', 377.0000, 'ºC'),
	(92142, 112, '2015-03-01 00:47:16.000000', 'temperatura', 1095.0000, 'ºC'),
	(92143, 112, '2015-03-01 00:47:17.000000', 'temperatura', 745.0000, 'ºC'),
	(92144, 112, '2015-03-01 00:47:18.000000', 'temperatura', 442.0000, 'ºC'),
	(92145, 112, '2015-03-01 00:47:19.000000', 'temperatura', 1177.0000, 'ºC'),
	(92146, 112, '2015-03-01 00:47:20.000000', 'temperatura', 956.0000, 'ºC'),
	(92147, 112, '2015-03-01 00:47:21.000000', 'temperatura', 50.0000, 'ºC'),
	(92148, 112, '2015-03-01 00:47:22.000000', 'temperatura', 984.0000, 'ºC'),
	(92149, 112, '2015-03-01 00:47:23.000000', 'temperatura', 1171.0000, 'ºC'),
	(92150, 112, '2015-03-01 00:47:24.000000', 'temperatura', 504.0000, 'ºC'),
	(92151, 112, '2015-03-01 00:47:25.000000', 'temperatura', 207.0000, 'ºC'),
	(92152, 112, '2015-03-01 00:47:26.000000', 'temperatura', 724.0000, 'ºC'),
	(92153, 112, '2015-03-01 00:47:27.000000', 'temperatura', 601.0000, 'ºC'),
	(92154, 112, '2015-03-01 00:47:28.000000', 'temperatura', 831.0000, 'ºC'),
	(92155, 112, '2015-03-01 00:47:29.000000', 'temperatura', 1153.0000, 'ºC'),
	(92156, 112, '2015-03-01 00:47:30.000000', 'temperatura', 874.0000, 'ºC'),
	(92157, 112, '2015-03-01 00:47:31.000000', 'temperatura', 909.0000, 'ºC'),
	(92158, 112, '2015-03-01 00:47:32.000000', 'temperatura', 725.0000, 'ºC'),
	(92159, 112, '2015-03-01 00:47:33.000000', 'temperatura', 898.0000, 'ºC'),
	(92160, 112, '2015-03-01 00:47:34.000000', 'temperatura', 1116.0000, 'ºC'),
	(92161, 112, '2015-03-01 00:47:35.000000', 'temperatura', 485.0000, 'ºC'),
	(92162, 112, '2015-03-01 00:47:36.000000', 'temperatura', 280.0000, 'ºC'),
	(92163, 112, '2015-03-01 00:47:37.000000', 'temperatura', 1145.0000, 'ºC'),
	(92164, 112, '2015-03-01 00:47:38.000000', 'temperatura', 84.0000, 'ºC'),
	(92165, 112, '2015-03-01 00:47:39.000000', 'temperatura', 587.0000, 'ºC'),
	(92166, 112, '2015-03-01 00:47:40.000000', 'temperatura', 285.0000, 'ºC'),
	(92167, 112, '2015-03-01 00:47:41.000000', 'temperatura', 863.0000, 'ºC'),
	(92168, 112, '2015-03-01 00:47:42.000000', 'temperatura', 1059.0000, 'ºC'),
	(92169, 112, '2015-03-01 00:47:43.000000', 'temperatura', 308.0000, 'ºC'),
	(92170, 112, '2015-03-01 00:47:44.000000', 'temperatura', 762.0000, 'ºC'),
	(92171, 112, '2015-03-01 00:47:45.000000', 'temperatura', 486.0000, 'ºC'),
	(92172, 112, '2015-03-01 00:47:46.000000', 'temperatura', 145.0000, 'ºC'),
	(92173, 112, '2015-03-01 00:47:47.000000', 'temperatura', 466.0000, 'ºC'),
	(92174, 112, '2015-03-01 00:47:48.000000', 'temperatura', 696.0000, 'ºC'),
	(92175, 112, '2015-03-01 00:47:49.000000', 'temperatura', 884.0000, 'ºC'),
	(92176, 112, '2015-03-01 00:47:50.000000', 'temperatura', 1133.0000, 'ºC'),
	(92177, 112, '2015-03-01 00:47:51.000000', 'temperatura', 613.0000, 'ºC'),
	(92178, 112, '2015-03-01 00:47:52.000000', 'temperatura', 867.0000, 'ºC'),
	(92179, 112, '2015-03-01 00:47:53.000000', 'temperatura', 98.0000, 'ºC'),
	(92180, 112, '2015-03-01 00:47:54.000000', 'temperatura', 287.0000, 'ºC'),
	(92181, 112, '2015-03-01 00:47:55.000000', 'temperatura', 1142.0000, 'ºC'),
	(92182, 112, '2015-03-01 00:47:56.000000', 'temperatura', 51.0000, 'ºC'),
	(92183, 112, '2015-03-01 00:47:57.000000', 'temperatura', 430.0000, 'ºC'),
	(92184, 112, '2015-03-01 00:47:58.000000', 'temperatura', 795.0000, 'ºC'),
	(92185, 112, '2015-03-01 00:47:59.000000', 'temperatura', 286.0000, 'ºC'),
	(92186, 112, '2015-03-01 00:48:00.000000', 'temperatura', 244.0000, 'ºC'),
	(92187, 112, '2015-03-01 00:48:01.000000', 'temperatura', 363.0000, 'ºC'),
	(92188, 112, '2015-03-01 00:48:02.000000', 'temperatura', 1085.0000, 'ºC'),
	(92189, 112, '2015-03-01 00:48:03.000000', 'temperatura', 735.0000, 'ºC'),
	(92190, 112, '2015-03-01 00:48:04.000000', 'temperatura', 422.0000, 'ºC'),
	(92191, 112, '2015-03-01 00:48:05.000000', 'temperatura', 1103.0000, 'ºC'),
	(92192, 112, '2015-03-01 00:48:06.000000', 'temperatura', 652.0000, 'ºC'),
	(92193, 112, '2015-03-01 00:48:07.000000', 'temperatura', 1152.0000, 'ºC'),
	(92194, 112, '2015-03-01 00:48:08.000000', 'temperatura', 204.0000, 'ºC'),
	(92195, 112, '2015-03-01 00:48:09.000000', 'temperatura', 1164.0000, 'ºC'),
	(92196, 112, '2015-03-01 00:48:10.000000', 'temperatura', 409.0000, 'ºC'),
	(92197, 112, '2015-03-01 00:48:11.000000', 'temperatura', 954.0000, 'ºC'),
	(92198, 112, '2015-03-01 00:48:12.000000', 'temperatura', 1143.0000, 'ºC'),
	(92199, 112, '2015-03-01 00:48:13.000000', 'temperatura', 455.0000, 'ºC'),
	(92200, 112, '2015-03-01 00:48:14.000000', 'temperatura', 46.0000, 'ºC'),
	(92201, 112, '2015-03-01 00:48:15.000000', 'temperatura', 66.0000, 'ºC'),
	(92202, 112, '2015-03-01 00:48:16.000000', 'temperatura', 194.0000, 'ºC'),
	(92203, 112, '2015-03-01 00:48:17.000000', 'temperatura', 769.0000, 'ºC'),
	(92204, 112, '2015-03-01 00:48:18.000000', 'temperatura', 867.0000, 'ºC'),
	(92205, 112, '2015-03-01 00:48:19.000000', 'temperatura', 826.0000, 'ºC'),
	(92206, 112, '2015-03-01 00:48:20.000000', 'temperatura', 331.0000, 'ºC'),
	(92207, 112, '2015-03-01 00:48:21.000000', 'temperatura', 378.0000, 'ºC'),
	(92208, 112, '2015-03-01 00:48:22.000000', 'temperatura', 899.0000, 'ºC'),
	(92209, 112, '2015-03-01 00:48:23.000000', 'temperatura', 960.0000, 'ºC'),
	(92210, 112, '2015-03-01 00:48:24.000000', 'temperatura', 902.0000, 'ºC'),
	(92211, 112, '2015-03-01 00:48:25.000000', 'temperatura', 429.0000, 'ºC'),
	(92212, 112, '2015-03-01 00:48:26.000000', 'temperatura', 643.0000, 'ºC'),
	(92213, 112, '2015-03-01 00:48:27.000000', 'temperatura', 729.0000, 'ºC'),
	(92214, 112, '2015-03-01 00:48:28.000000', 'temperatura', 513.0000, 'ºC'),
	(92215, 112, '2015-03-01 00:48:29.000000', 'temperatura', 381.0000, 'ºC'),
	(92216, 112, '2015-03-01 00:48:30.000000', 'temperatura', 365.0000, 'ºC'),
	(92217, 112, '2015-03-01 00:48:31.000000', 'temperatura', 684.0000, 'ºC'),
	(92218, 112, '2015-03-01 00:48:32.000000', 'temperatura', 1123.0000, 'ºC'),
	(92219, 112, '2015-03-01 00:48:33.000000', 'temperatura', 1165.0000, 'ºC'),
	(92220, 112, '2015-03-01 00:48:34.000000', 'temperatura', 54.0000, 'ºC'),
	(92221, 112, '2015-03-01 00:48:35.000000', 'temperatura', 378.0000, 'ºC'),
	(92222, 112, '2015-03-01 00:48:36.000000', 'temperatura', 529.0000, 'ºC'),
	(92223, 112, '2015-03-01 00:48:37.000000', 'temperatura', 310.0000, 'ºC'),
	(92224, 112, '2015-03-01 00:48:38.000000', 'temperatura', 1163.0000, 'ºC'),
	(92225, 112, '2015-03-01 00:48:39.000000', 'temperatura', 86.0000, 'ºC'),
	(92226, 112, '2015-03-01 00:48:40.000000', 'temperatura', 542.0000, 'ºC'),
	(92227, 112, '2015-03-01 00:48:41.000000', 'temperatura', 54.0000, 'ºC'),
	(92228, 112, '2015-03-01 00:48:42.000000', 'temperatura', 1042.0000, 'ºC'),
	(92229, 112, '2015-03-01 00:48:43.000000', 'temperatura', 250.0000, 'ºC'),
	(92230, 112, '2015-03-01 00:48:44.000000', 'temperatura', 523.0000, 'ºC'),
	(92231, 112, '2015-03-01 00:48:45.000000', 'temperatura', 667.0000, 'ºC'),
	(92232, 112, '2015-03-01 00:48:46.000000', 'temperatura', 568.0000, 'ºC'),
	(92233, 112, '2015-03-01 00:48:47.000000', 'temperatura', 836.0000, 'ºC'),
	(92234, 112, '2015-03-01 00:48:48.000000', 'temperatura', 78.0000, 'ºC'),
	(92235, 112, '2015-03-01 00:48:49.000000', 'temperatura', 282.0000, 'ºC'),
	(92236, 112, '2015-03-01 00:48:50.000000', 'temperatura', 1177.0000, 'ºC'),
	(92237, 112, '2015-03-01 00:48:51.000000', 'temperatura', 241.0000, 'ºC'),
	(92238, 112, '2015-03-01 00:48:52.000000', 'temperatura', 73.0000, 'ºC'),
	(92239, 112, '2015-03-01 00:48:53.000000', 'temperatura', 842.0000, 'ºC'),
	(92240, 112, '2015-03-01 00:48:54.000000', 'temperatura', 392.0000, 'ºC'),
	(92241, 112, '2015-03-01 00:48:55.000000', 'temperatura', 633.0000, 'ºC'),
	(92242, 112, '2015-03-01 00:48:56.000000', 'temperatura', 791.0000, 'ºC'),
	(92243, 112, '2015-03-01 00:48:57.000000', 'temperatura', 856.0000, 'ºC'),
	(92244, 112, '2015-03-01 00:48:58.000000', 'temperatura', 708.0000, 'ºC'),
	(92245, 112, '2015-03-01 00:48:59.000000', 'temperatura', 970.0000, 'ºC'),
	(92246, 112, '2015-03-01 00:49:00.000000', 'temperatura', 329.0000, 'ºC'),
	(92247, 112, '2015-03-01 00:49:01.000000', 'temperatura', 1136.0000, 'ºC'),
	(92248, 112, '2015-03-01 00:49:02.000000', 'temperatura', 1093.0000, 'ºC'),
	(92249, 112, '2015-03-01 00:49:03.000000', 'temperatura', 855.0000, 'ºC'),
	(92250, 112, '2015-03-01 00:49:04.000000', 'temperatura', 1000.0000, 'ºC'),
	(92251, 112, '2015-03-01 00:49:05.000000', 'temperatura', 35.0000, 'ºC'),
	(92252, 112, '2015-03-01 00:49:06.000000', 'temperatura', 774.0000, 'ºC'),
	(92253, 112, '2015-03-01 00:49:07.000000', 'temperatura', 165.0000, 'ºC'),
	(92254, 112, '2015-03-01 00:49:08.000000', 'temperatura', 904.0000, 'ºC'),
	(92255, 112, '2015-03-01 00:49:09.000000', 'temperatura', 427.0000, 'ºC'),
	(92256, 112, '2015-03-01 00:49:10.000000', 'temperatura', 623.0000, 'ºC'),
	(92257, 112, '2015-03-01 00:49:11.000000', 'temperatura', 633.0000, 'ºC'),
	(92258, 112, '2015-03-01 00:49:12.000000', 'temperatura', 98.0000, 'ºC'),
	(92259, 112, '2015-03-01 00:49:13.000000', 'temperatura', 992.0000, 'ºC'),
	(92260, 112, '2015-03-01 00:49:14.000000', 'temperatura', 1064.0000, 'ºC'),
	(92261, 112, '2015-03-01 00:49:15.000000', 'temperatura', 1147.0000, 'ºC'),
	(92262, 112, '2015-03-01 00:49:16.000000', 'temperatura', 144.0000, 'ºC'),
	(92263, 112, '2015-03-01 00:49:17.000000', 'temperatura', 878.0000, 'ºC'),
	(92264, 112, '2015-03-01 00:49:18.000000', 'temperatura', 360.0000, 'ºC'),
	(92265, 112, '2015-03-01 00:49:19.000000', 'temperatura', 364.0000, 'ºC'),
	(92266, 112, '2015-03-01 00:49:20.000000', 'temperatura', 740.0000, 'ºC'),
	(92267, 112, '2015-03-01 00:49:21.000000', 'temperatura', 211.0000, 'ºC'),
	(92268, 112, '2015-03-01 00:49:22.000000', 'temperatura', 34.0000, 'ºC'),
	(92269, 112, '2015-03-01 00:49:23.000000', 'temperatura', 737.0000, 'ºC'),
	(92270, 112, '2015-03-01 00:49:24.000000', 'temperatura', 1184.0000, 'ºC'),
	(92271, 112, '2015-03-01 00:49:25.000000', 'temperatura', 111.0000, 'ºC'),
	(92272, 112, '2015-03-01 00:49:26.000000', 'temperatura', 603.0000, 'ºC'),
	(92273, 112, '2015-03-01 00:49:27.000000', 'temperatura', 282.0000, 'ºC'),
	(92274, 112, '2015-03-01 00:49:28.000000', 'temperatura', 803.0000, 'ºC'),
	(92275, 112, '2015-03-01 00:49:29.000000', 'temperatura', 770.0000, 'ºC'),
	(92276, 112, '2015-03-01 00:49:30.000000', 'temperatura', 239.0000, 'ºC'),
	(92277, 112, '2015-03-01 00:49:31.000000', 'temperatura', 87.0000, 'ºC'),
	(92278, 112, '2015-03-01 00:49:32.000000', 'temperatura', 917.0000, 'ºC'),
	(92279, 112, '2015-03-01 00:49:33.000000', 'temperatura', 724.0000, 'ºC'),
	(92280, 112, '2015-03-01 00:49:34.000000', 'temperatura', 872.0000, 'ºC'),
	(92281, 112, '2015-03-01 00:49:35.000000', 'temperatura', 986.0000, 'ºC'),
	(92282, 112, '2015-03-01 00:49:36.000000', 'temperatura', 1113.0000, 'ºC'),
	(92283, 112, '2015-03-01 00:49:37.000000', 'temperatura', 211.0000, 'ºC'),
	(92284, 112, '2015-03-01 00:49:38.000000', 'temperatura', 116.0000, 'ºC'),
	(92285, 112, '2015-03-01 00:49:39.000000', 'temperatura', 1146.0000, 'ºC'),
	(92286, 112, '2015-03-01 00:49:40.000000', 'temperatura', 582.0000, 'ºC'),
	(92287, 112, '2015-03-01 00:49:41.000000', 'temperatura', 674.0000, 'ºC'),
	(92288, 112, '2015-03-01 00:49:42.000000', 'temperatura', 426.0000, 'ºC'),
	(92289, 112, '2015-03-01 00:49:43.000000', 'temperatura', 106.0000, 'ºC'),
	(92290, 112, '2015-03-01 00:49:44.000000', 'temperatura', 453.0000, 'ºC'),
	(92291, 112, '2015-03-01 00:49:45.000000', 'temperatura', 748.0000, 'ºC'),
	(92292, 112, '2015-03-01 00:49:46.000000', 'temperatura', 1183.0000, 'ºC'),
	(92293, 112, '2015-03-01 00:49:47.000000', 'temperatura', 72.0000, 'ºC'),
	(92294, 112, '2015-03-01 00:49:48.000000', 'temperatura', 410.0000, 'ºC'),
	(92295, 112, '2015-03-01 00:49:49.000000', 'temperatura', 633.0000, 'ºC'),
	(92296, 112, '2015-03-01 00:49:50.000000', 'temperatura', 738.0000, 'ºC'),
	(92297, 112, '2015-03-01 00:49:51.000000', 'temperatura', 590.0000, 'ºC'),
	(92298, 112, '2015-03-01 00:49:52.000000', 'temperatura', 737.0000, 'ºC'),
	(92299, 112, '2015-03-01 00:49:53.000000', 'temperatura', 716.0000, 'ºC'),
	(92300, 112, '2015-03-01 00:49:54.000000', 'temperatura', 168.0000, 'ºC'),
	(92301, 112, '2015-03-01 00:49:55.000000', 'temperatura', 1094.0000, 'ºC'),
	(92302, 112, '2015-03-01 00:49:56.000000', 'temperatura', 164.0000, 'ºC'),
	(92303, 112, '2015-03-01 00:49:57.000000', 'temperatura', 1142.0000, 'ºC'),
	(92304, 112, '2015-03-01 00:49:58.000000', 'temperatura', 416.0000, 'ºC'),
	(92305, 112, '2015-03-01 00:49:59.000000', 'temperatura', 1055.0000, 'ºC'),
	(92306, 112, '2015-03-01 00:50:00.000000', 'temperatura', 428.0000, 'ºC'),
	(92307, 112, '2015-03-01 00:50:01.000000', 'temperatura', 175.0000, 'ºC'),
	(92308, 112, '2015-03-01 00:50:02.000000', 'temperatura', 792.0000, 'ºC'),
	(92309, 112, '2015-03-01 00:50:03.000000', 'temperatura', 1036.0000, 'ºC'),
	(92310, 112, '2015-03-01 00:50:04.000000', 'temperatura', 403.0000, 'ºC'),
	(92311, 112, '2015-03-01 00:50:05.000000', 'temperatura', 108.0000, 'ºC'),
	(92312, 112, '2015-03-01 00:50:06.000000', 'temperatura', 533.0000, 'ºC'),
	(92313, 112, '2015-03-01 00:50:07.000000', 'temperatura', 1143.0000, 'ºC'),
	(92314, 112, '2015-03-01 00:50:08.000000', 'temperatura', 513.0000, 'ºC'),
	(92315, 112, '2015-03-01 00:50:09.000000', 'temperatura', 339.0000, 'ºC'),
	(92316, 112, '2015-03-01 00:50:10.000000', 'temperatura', 155.0000, 'ºC'),
	(92317, 112, '2015-03-01 00:50:11.000000', 'temperatura', 959.0000, 'ºC'),
	(92318, 112, '2015-03-01 00:50:12.000000', 'temperatura', 731.0000, 'ºC'),
	(92319, 112, '2015-03-01 00:50:13.000000', 'temperatura', 777.0000, 'ºC'),
	(92320, 112, '2015-03-01 00:50:14.000000', 'temperatura', 492.0000, 'ºC'),
	(92321, 112, '2015-03-01 00:50:15.000000', 'temperatura', 130.0000, 'ºC'),
	(92322, 112, '2015-03-01 00:50:16.000000', 'temperatura', 375.0000, 'ºC'),
	(92323, 112, '2015-03-01 00:50:17.000000', 'temperatura', 286.0000, 'ºC'),
	(92324, 112, '2015-03-01 00:50:18.000000', 'temperatura', 305.0000, 'ºC'),
	(92325, 112, '2015-03-01 00:50:19.000000', 'temperatura', 669.0000, 'ºC'),
	(92326, 112, '2015-03-01 00:50:20.000000', 'temperatura', 29.0000, 'ºC'),
	(92327, 112, '2015-03-01 00:50:21.000000', 'temperatura', 540.0000, 'ºC'),
	(92328, 112, '2015-03-01 00:50:22.000000', 'temperatura', 211.0000, 'ºC'),
	(92329, 112, '2015-03-01 00:50:23.000000', 'temperatura', 637.0000, 'ºC'),
	(92330, 112, '2015-03-01 00:50:24.000000', 'temperatura', 151.0000, 'ºC'),
	(92331, 112, '2015-03-01 00:50:25.000000', 'temperatura', 43.0000, 'ºC'),
	(92332, 112, '2015-03-01 00:50:26.000000', 'temperatura', 966.0000, 'ºC'),
	(92333, 112, '2015-03-01 00:50:27.000000', 'temperatura', 1100.0000, 'ºC'),
	(92334, 112, '2015-03-01 00:50:28.000000', 'temperatura', 201.0000, 'ºC'),
	(92335, 112, '2015-03-01 00:50:29.000000', 'temperatura', 105.0000, 'ºC'),
	(92336, 112, '2015-03-01 00:50:30.000000', 'temperatura', 1125.0000, 'ºC'),
	(92337, 112, '2015-03-01 00:50:31.000000', 'temperatura', 509.0000, 'ºC'),
	(92338, 112, '2015-03-01 00:50:32.000000', 'temperatura', 369.0000, 'ºC'),
	(92339, 112, '2015-03-01 00:50:33.000000', 'temperatura', 322.0000, 'ºC'),
	(92340, 112, '2015-03-01 00:50:34.000000', 'temperatura', 501.0000, 'ºC'),
	(92341, 112, '2015-03-01 00:50:35.000000', 'temperatura', 341.0000, 'ºC'),
	(92342, 112, '2015-03-01 00:50:36.000000', 'temperatura', 203.0000, 'ºC'),
	(92343, 112, '2015-03-01 00:50:37.000000', 'temperatura', 1192.0000, 'ºC'),
	(92344, 112, '2015-03-01 00:50:38.000000', 'temperatura', 553.0000, 'ºC'),
	(92345, 112, '2015-03-01 00:50:39.000000', 'temperatura', 388.0000, 'ºC'),
	(92346, 112, '2015-03-01 00:50:40.000000', 'temperatura', 280.0000, 'ºC'),
	(92347, 112, '2015-03-01 00:50:41.000000', 'temperatura', 240.0000, 'ºC'),
	(92348, 112, '2015-03-01 00:50:42.000000', 'temperatura', 358.0000, 'ºC'),
	(92349, 112, '2015-03-01 00:50:43.000000', 'temperatura', 1070.0000, 'ºC'),
	(92350, 112, '2015-03-01 00:50:44.000000', 'temperatura', 678.0000, 'ºC'),
	(92351, 112, '2015-03-01 00:50:45.000000', 'temperatura', 181.0000, 'ºC'),
	(92352, 112, '2015-03-01 00:50:46.000000', 'temperatura', 72.0000, 'ºC'),
	(92353, 112, '2015-03-01 00:50:47.000000', 'temperatura', 1018.0000, 'ºC'),
	(92354, 112, '2015-03-01 00:50:48.000000', 'temperatura', 75.0000, 'ºC'),
	(92355, 112, '2015-03-01 00:50:49.000000', 'temperatura', 919.0000, 'ºC'),
	(92356, 112, '2015-03-01 00:50:50.000000', 'temperatura', 770.0000, 'ºC'),
	(92357, 112, '2015-03-01 00:50:51.000000', 'temperatura', 1096.0000, 'ºC'),
	(92358, 112, '2015-03-01 00:50:52.000000', 'temperatura', 769.0000, 'ºC'),
	(92359, 112, '2015-03-01 00:50:53.000000', 'temperatura', 559.0000, 'ºC'),
	(92360, 112, '2015-03-01 00:50:54.000000', 'temperatura', 487.0000, 'ºC'),
	(92361, 112, '2015-03-01 00:50:55.000000', 'temperatura', 758.0000, 'ºC'),
	(92362, 112, '2015-03-01 00:50:56.000000', 'temperatura', 1130.0000, 'ºC'),
	(92363, 112, '2015-03-01 00:50:57.000000', 'temperatura', 977.0000, 'ºC'),
	(92364, 112, '2015-03-01 00:50:58.000000', 'temperatura', 295.0000, 'ºC'),
	(92365, 112, '2015-03-01 00:50:59.000000', 'temperatura', 947.0000, 'ºC'),
	(92366, 112, '2015-03-01 00:51:00.000000', 'temperatura', 247.0000, 'ºC'),
	(92367, 112, '2015-03-01 00:51:01.000000', 'temperatura', 798.0000, 'ºC'),
	(92368, 112, '2015-03-01 00:51:02.000000', 'temperatura', 848.0000, 'ºC'),
	(92369, 112, '2015-03-01 00:51:03.000000', 'temperatura', 645.0000, 'ºC'),
	(92370, 112, '2015-03-01 00:51:04.000000', 'temperatura', 683.0000, 'ºC'),
	(92371, 112, '2015-03-01 00:51:05.000000', 'temperatura', 282.0000, 'ºC'),
	(92372, 112, '2015-03-01 00:51:06.000000', 'temperatura', 561.0000, 'ºC'),
	(92373, 112, '2015-03-01 00:51:07.000000', 'temperatura', 761.0000, 'ºC'),
	(92374, 112, '2015-03-01 00:51:08.000000', 'temperatura', 921.0000, 'ºC'),
	(92375, 112, '2015-03-01 00:51:09.000000', 'temperatura', 1124.0000, 'ºC'),
	(92376, 112, '2015-03-01 00:51:10.000000', 'temperatura', 456.0000, 'ºC'),
	(92377, 112, '2015-03-01 00:51:11.000000', 'temperatura', 107.0000, 'ºC'),
	(92378, 112, '2015-03-01 00:51:12.000000', 'temperatura', 368.0000, 'ºC'),
	(92379, 112, '2015-03-01 00:51:13.000000', 'temperatura', 320.0000, 'ºC'),
	(92380, 112, '2015-03-01 00:51:14.000000', 'temperatura', 497.0000, 'ºC'),
	(92381, 112, '2015-03-01 00:51:15.000000', 'temperatura', 326.0000, 'ºC'),
	(92382, 112, '2015-03-01 00:51:16.000000', 'temperatura', 139.0000, 'ºC'),
	(92383, 112, '2015-03-01 00:51:17.000000', 'temperatura', 918.0000, 'ºC'),
	(92384, 112, '2015-03-01 00:51:18.000000', 'temperatura', 574.0000, 'ºC'),
	(92385, 112, '2015-03-01 00:51:19.000000', 'temperatura', 114.0000, 'ºC'),
	(92386, 112, '2015-03-01 00:51:20.000000', 'temperatura', 50.0000, 'ºC'),
	(92387, 112, '2015-03-01 00:51:21.000000', 'temperatura', 1110.0000, 'ºC'),
	(92388, 112, '2015-03-01 00:51:22.000000', 'temperatura', 599.0000, 'ºC'),
	(92389, 112, '2015-03-01 00:51:23.000000', 'temperatura', 865.0000, 'ºC'),
	(92390, 112, '2015-03-01 00:51:24.000000', 'temperatura', 131.0000, 'ºC'),
	(92391, 112, '2015-03-01 00:51:25.000000', 'temperatura', 457.0000, 'ºC'),
	(92392, 112, '2015-03-01 00:51:26.000000', 'temperatura', 696.0000, 'ºC'),
	(92393, 112, '2015-03-01 00:51:27.000000', 'temperatura', 906.0000, 'ºC'),
	(92394, 112, '2015-03-01 00:51:28.000000', 'temperatura', 44.0000, 'ºC'),
	(92395, 112, '2015-03-01 00:51:29.000000', 'temperatura', 1102.0000, 'ºC'),
	(92396, 112, '2015-03-01 00:51:30.000000', 'temperatura', 579.0000, 'ºC'),
	(92397, 112, '2015-03-01 00:51:31.000000', 'temperatura', 791.0000, 'ºC'),
	(92398, 112, '2015-03-01 00:51:32.000000', 'temperatura', 1016.0000, 'ºC'),
	(92399, 112, '2015-03-01 00:51:33.000000', 'temperatura', 309.0000, 'ºC'),
	(92400, 112, '2015-03-01 00:51:34.000000', 'temperatura', 896.0000, 'ºC'),
	(92401, 112, '2015-03-01 00:51:35.000000', 'temperatura', 1154.0000, 'ºC'),
	(92402, 112, '2015-03-01 00:51:36.000000', 'temperatura', 685.0000, 'ºC'),
	(92403, 112, '2015-03-01 00:51:37.000000', 'temperatura', 1160.0000, 'ºC'),
	(92404, 112, '2015-03-01 00:51:38.000000', 'temperatura', 147.0000, 'ºC'),
	(92405, 112, '2015-03-01 00:51:39.000000', 'temperatura', 854.0000, 'ºC'),
	(92406, 112, '2015-03-01 00:51:40.000000', 'temperatura', 229.0000, 'ºC'),
	(92407, 112, '2015-03-01 00:51:41.000000', 'temperatura', 985.0000, 'ºC'),
	(92408, 112, '2015-03-01 00:51:42.000000', 'temperatura', 639.0000, 'ºC'),
	(92409, 112, '2015-03-01 00:51:43.000000', 'temperatura', 239.0000, 'ºC'),
	(92410, 112, '2015-03-01 00:51:44.000000', 'temperatura', 478.0000, 'ºC'),
	(92411, 112, '2015-03-01 00:51:45.000000', 'temperatura', 476.0000, 'ºC'),
	(92412, 112, '2015-03-01 00:51:46.000000', 'temperatura', 945.0000, 'ºC'),
	(92413, 112, '2015-03-01 00:51:47.000000', 'temperatura', 899.0000, 'ºC'),
	(92414, 112, '2015-03-01 00:51:48.000000', 'temperatura', 460.0000, 'ºC'),
	(92415, 112, '2015-03-01 00:51:49.000000', 'temperatura', 804.0000, 'ºC'),
	(92416, 112, '2015-03-01 00:51:50.000000', 'temperatura', 238.0000, 'ºC'),
	(92417, 112, '2015-03-01 00:51:51.000000', 'temperatura', 1181.0000, 'ºC'),
	(92418, 112, '2015-03-01 00:51:52.000000', 'temperatura', 389.0000, 'ºC'),
	(92419, 112, '2015-03-01 00:51:53.000000', 'temperatura', 802.0000, 'ºC'),
	(92420, 112, '2015-03-01 00:51:54.000000', 'temperatura', 445.0000, 'ºC'),
	(92421, 112, '2015-03-01 00:51:55.000000', 'temperatura', 1018.0000, 'ºC'),
	(92422, 112, '2015-03-01 00:51:56.000000', 'temperatura', 155.0000, 'ºC'),
	(92423, 112, '2015-03-01 00:51:57.000000', 'temperatura', 124.0000, 'ºC'),
	(92424, 112, '2015-03-01 00:51:58.000000', 'temperatura', 155.0000, 'ºC'),
	(92425, 112, '2015-03-01 00:51:59.000000', 'temperatura', 403.0000, 'ºC'),
	(92426, 112, '2015-03-01 00:52:00.000000', 'temperatura', 349.0000, 'ºC'),
	(92427, 112, '2015-03-01 00:52:01.000000', 'temperatura', 537.0000, 'ºC'),
	(92428, 112, '2015-03-01 00:52:02.000000', 'temperatura', 441.0000, 'ºC'),
	(92429, 112, '2015-03-01 00:52:03.000000', 'temperatura', 593.0000, 'ºC'),
	(92430, 112, '2015-03-01 00:52:04.000000', 'temperatura', 442.0000, 'ºC'),
	(92431, 112, '2015-03-01 00:52:05.000000', 'temperatura', 432.0000, 'ºC'),
	(92432, 112, '2015-03-01 00:52:06.000000', 'temperatura', 836.0000, 'ºC'),
	(92433, 112, '2015-03-01 00:52:07.000000', 'temperatura', 484.0000, 'ºC'),
	(92434, 112, '2015-03-01 00:52:08.000000', 'temperatura', 1114.0000, 'ºC'),
	(92435, 112, '2015-03-01 00:52:09.000000', 'temperatura', 516.0000, 'ºC'),
	(92436, 112, '2015-03-01 00:52:10.000000', 'temperatura', 440.0000, 'ºC'),
	(92437, 112, '2015-03-01 00:52:11.000000', 'temperatura', 654.0000, 'ºC'),
	(92438, 112, '2015-03-01 00:52:12.000000', 'temperatura', 749.0000, 'ºC'),
	(92439, 112, '2015-03-01 00:52:13.000000', 'temperatura', 582.0000, 'ºC'),
	(92440, 112, '2015-03-01 00:52:14.000000', 'temperatura', 665.0000, 'ºC'),
	(92441, 112, '2015-03-01 00:52:15.000000', 'temperatura', 379.0000, 'ºC'),
	(92442, 112, '2015-03-01 00:52:16.000000', 'temperatura', 1101.0000, 'ºC'),
	(92443, 112, '2015-03-01 00:52:17.000000', 'temperatura', 770.0000, 'ºC'),
	(92444, 112, '2015-03-01 00:52:18.000000', 'temperatura', 547.0000, 'ºC'),
	(92445, 112, '2015-03-01 00:52:19.000000', 'temperatura', 425.0000, 'ºC'),
	(92446, 112, '2015-03-01 00:52:20.000000', 'temperatura', 485.0000, 'ºC'),
	(92447, 112, '2015-03-01 00:52:21.000000', 'temperatura', 1151.0000, 'ºC'),
	(92448, 112, '2015-03-01 00:52:22.000000', 'temperatura', 702.0000, 'ºC'),
	(92449, 112, '2015-03-01 00:52:23.000000', 'temperatura', 54.0000, 'ºC'),
	(92450, 112, '2015-03-01 00:52:24.000000', 'temperatura', 568.0000, 'ºC'),
	(92451, 112, '2015-03-01 00:52:25.000000', 'temperatura', 277.0000, 'ºC'),
	(92452, 112, '2015-03-01 00:52:26.000000', 'temperatura', 880.0000, 'ºC'),
	(92453, 112, '2015-03-01 00:52:27.000000', 'temperatura', 1169.0000, 'ºC'),
	(92454, 112, '2015-03-01 00:52:28.000000', 'temperatura', 805.0000, 'ºC'),
	(92455, 112, '2015-03-01 00:52:29.000000', 'temperatura', 518.0000, 'ºC'),
	(92456, 112, '2015-03-01 00:52:30.000000', 'temperatura', 178.0000, 'ºC'),
	(92457, 112, '2015-03-01 00:52:31.000000', 'temperatura', 535.0000, 'ºC'),
	(92458, 112, '2015-03-01 00:52:32.000000', 'temperatura', 942.0000, 'ºC'),
	(92459, 112, '2015-03-01 00:52:33.000000', 'temperatura', 704.0000, 'ºC'),
	(92460, 112, '2015-03-01 00:52:34.000000', 'temperatura', 696.0000, 'ºC'),
	(92461, 112, '2015-03-01 00:52:35.000000', 'temperatura', 167.0000, 'ºC'),
	(92462, 112, '2015-03-01 00:52:36.000000', 'temperatura', 1149.0000, 'ºC'),
	(92463, 112, '2015-03-01 00:52:37.000000', 'temperatura', 443.0000, 'ºC'),
	(92464, 112, '2015-03-01 00:52:38.000000', 'temperatura', 1167.0000, 'ºC'),
	(92465, 112, '2015-03-01 00:52:39.000000', 'temperatura', 909.0000, 'ºC'),
	(92466, 112, '2015-03-01 00:52:40.000000', 'temperatura', 1046.0000, 'ºC'),
	(92467, 112, '2015-03-01 00:52:41.000000', 'temperatura', 101.0000, 'ºC'),
	(92468, 112, '2015-03-01 00:52:42.000000', 'temperatura', 970.0000, 'ºC'),
	(92469, 112, '2015-03-01 00:52:43.000000', 'temperatura', 945.0000, 'ºC'),
	(92470, 112, '2015-03-01 00:52:44.000000', 'temperatura', 617.0000, 'ºC'),
	(92471, 112, '2015-03-01 00:52:45.000000', 'temperatura', 251.0000, 'ºC'),
	(92472, 112, '2015-03-01 00:52:46.000000', 'temperatura', 606.0000, 'ºC'),
	(92473, 112, '2015-03-01 00:52:47.000000', 'temperatura', 1074.0000, 'ºC'),
	(92474, 112, '2015-03-01 00:52:48.000000', 'temperatura', 1155.0000, 'ºC'),
	(92475, 112, '2015-03-01 00:52:49.000000', 'temperatura', 152.0000, 'ºC'),
	(92476, 112, '2015-03-01 00:52:50.000000', 'temperatura', 896.0000, 'ºC'),
	(92477, 112, '2015-03-01 00:52:51.000000', 'temperatura', 423.0000, 'ºC'),
	(92478, 112, '2015-03-01 00:52:52.000000', 'temperatura', 628.0000, 'ºC'),
	(92479, 112, '2015-03-01 00:52:53.000000', 'temperatura', 670.0000, 'ºC'),
	(92480, 112, '2015-03-01 00:52:54.000000', 'temperatura', 269.0000, 'ºC'),
	(92481, 112, '2015-03-01 00:52:55.000000', 'temperatura', 536.0000, 'ºC'),
	(92482, 112, '2015-03-01 00:52:56.000000', 'temperatura', 671.0000, 'ºC'),
	(92483, 112, '2015-03-01 00:52:57.000000', 'temperatura', 550.0000, 'ºC'),
	(92484, 112, '2015-03-01 00:52:58.000000', 'temperatura', 737.0000, 'ºC'),
	(92485, 112, '2015-03-01 00:52:59.000000', 'temperatura', 835.0000, 'ºC'),
	(92486, 112, '2015-03-01 00:53:00.000000', 'temperatura', 763.0000, 'ºC'),
	(92487, 112, '2015-03-01 00:53:01.000000', 'temperatura', 112.0000, 'ºC'),
	(92488, 112, '2015-03-01 00:53:02.000000', 'temperatura', 672.0000, 'ºC'),
	(92489, 112, '2015-03-01 00:53:03.000000', 'temperatura', 622.0000, 'ºC'),
	(92490, 112, '2015-03-01 00:53:04.000000', 'temperatura', 1097.0000, 'ºC'),
	(92491, 112, '2015-03-01 00:53:05.000000', 'temperatura', 17.0000, 'ºC'),
	(92492, 112, '2015-03-01 00:53:06.000000', 'temperatura', 397.0000, 'ºC'),
	(92493, 112, '2015-03-01 00:53:07.000000', 'temperatura', 732.0000, 'ºC'),
	(92494, 112, '2015-03-01 00:53:08.000000', 'temperatura', 70.0000, 'ºC'),
	(92495, 112, '2015-03-01 00:53:09.000000', 'temperatura', 554.0000, 'ºC'),
	(92496, 112, '2015-03-01 00:53:10.000000', 'temperatura', 161.0000, 'ºC'),
	(92497, 112, '2015-03-01 00:53:11.000000', 'temperatura', 342.0000, 'ºC'),
	(92498, 112, '2015-03-01 00:53:12.000000', 'temperatura', 27.0000, 'ºC'),
	(92499, 112, '2015-03-01 00:53:13.000000', 'temperatura', 310.0000, 'ºC'),
	(92500, 112, '2015-03-01 00:53:14.000000', 'temperatura', 269.0000, 'ºC'),
	(92501, 112, '2015-03-01 00:53:15.000000', 'temperatura', 417.0000, 'ºC'),
	(92502, 112, '2015-03-01 00:53:16.000000', 'temperatura', 79.0000, 'ºC'),
	(92503, 112, '2015-03-01 00:53:17.000000', 'temperatura', 344.0000, 'ºC'),
	(92504, 112, '2015-03-01 00:53:18.000000', 'temperatura', 284.0000, 'ºC'),
	(92505, 112, '2015-03-01 00:53:19.000000', 'temperatura', 390.0000, 'ºC'),
	(92506, 112, '2015-03-01 00:53:20.000000', 'temperatura', 1096.0000, 'ºC'),
	(92507, 112, '2015-03-01 00:53:21.000000', 'temperatura', 712.0000, 'ºC'),
	(92508, 112, '2015-03-01 00:53:22.000000', 'temperatura', 272.0000, 'ºC'),
	(92509, 112, '2015-03-01 00:53:23.000000', 'temperatura', 423.0000, 'ºC'),
	(92510, 112, '2015-03-01 00:53:24.000000', 'temperatura', 103.0000, 'ºC'),
	(92511, 112, '2015-03-01 00:53:25.000000', 'temperatura', 443.0000, 'ºC'),
	(92512, 112, '2015-03-01 00:53:26.000000', 'temperatura', 708.0000, 'ºC'),
	(92513, 112, '2015-03-01 00:53:27.000000', 'temperatura', 1012.0000, 'ºC'),
	(92514, 112, '2015-03-01 00:53:28.000000', 'temperatura', 535.0000, 'ºC'),
	(92515, 112, '2015-03-01 00:53:29.000000', 'temperatura', 839.0000, 'ºC'),
	(92516, 112, '2015-03-01 00:53:30.000000', 'temperatura', 190.0000, 'ºC'),
	(92517, 112, '2015-03-01 00:53:31.000000', 'temperatura', 833.0000, 'ºC'),
	(92518, 112, '2015-03-01 00:53:32.000000', 'temperatura', 1196.0000, 'ºC'),
	(92519, 112, '2015-03-01 00:53:33.000000', 'temperatura', 1084.0000, 'ºC'),
	(92520, 112, '2015-03-01 00:53:34.000000', 'temperatura', 630.0000, 'ºC'),
	(92521, 112, '2015-03-01 00:53:35.000000', 'temperatura', 1100.0000, 'ºC'),
	(92522, 112, '2015-03-01 00:53:36.000000', 'temperatura', 11.0000, 'ºC'),
	(92523, 112, '2015-03-01 00:53:37.000000', 'temperatura', 357.0000, 'ºC'),
	(92524, 112, '2015-03-01 00:53:38.000000', 'temperatura', 550.0000, 'ºC'),
	(92525, 112, '2015-03-01 00:53:39.000000', 'temperatura', 479.0000, 'ºC'),
	(92526, 112, '2015-03-01 00:53:40.000000', 'temperatura', 747.0000, 'ºC'),
	(92527, 112, '2015-03-01 00:53:41.000000', 'temperatura', 1097.0000, 'ºC'),
	(92528, 112, '2015-03-01 00:53:42.000000', 'temperatura', 846.0000, 'ºC'),
	(92529, 112, '2015-03-01 00:53:43.000000', 'temperatura', 939.0000, 'ºC'),
	(92530, 112, '2015-03-01 00:53:44.000000', 'temperatura', 957.0000, 'ºC'),
	(92531, 112, '2015-03-01 00:53:45.000000', 'temperatura', 770.0000, 'ºC'),
	(92532, 112, '2015-03-01 00:53:46.000000', 'temperatura', 977.0000, 'ºC'),
	(92533, 112, '2015-03-01 00:53:47.000000', 'temperatura', 178.0000, 'ºC'),
	(92534, 112, '2015-03-01 00:53:48.000000', 'temperatura', 360.0000, 'ºC'),
	(92535, 112, '2015-03-01 00:53:49.000000', 'temperatura', 66.0000, 'ºC'),
	(92536, 112, '2015-03-01 00:53:50.000000', 'temperatura', 452.0000, 'ºC'),
	(92537, 112, '2015-03-01 00:53:51.000000', 'temperatura', 862.0000, 'ºC'),
	(92538, 112, '2015-03-01 00:53:52.000000', 'temperatura', 555.0000, 'ºC'),
	(92539, 112, '2015-03-01 00:53:53.000000', 'temperatura', 187.0000, 'ºC'),
	(92540, 112, '2015-03-01 00:53:54.000000', 'temperatura', 471.0000, 'ºC'),
	(92541, 112, '2015-03-01 00:53:55.000000', 'temperatura', 597.0000, 'ºC'),
	(92542, 112, '2015-03-01 00:53:56.000000', 'temperatura', 369.0000, 'ºC'),
	(92543, 112, '2015-03-01 00:53:57.000000', 'temperatura', 57.0000, 'ºC'),
	(92544, 112, '2015-03-01 00:53:58.000000', 'temperatura', 379.0000, 'ºC'),
	(92545, 112, '2015-03-01 00:53:59.000000', 'temperatura', 524.0000, 'ºC'),
	(92546, 112, '2015-03-01 00:54:00.000000', 'temperatura', 283.0000, 'ºC'),
	(92547, 112, '2015-03-01 00:54:01.000000', 'temperatura', 1043.0000, 'ºC'),
	(92548, 112, '2015-03-01 00:54:02.000000', 'temperatura', 768.0000, 'ºC'),
	(92549, 112, '2015-03-01 00:54:03.000000', 'temperatura', 710.0000, 'ºC'),
	(92550, 112, '2015-03-01 00:54:04.000000', 'temperatura', 45.0000, 'ºC'),
	(92551, 112, '2015-03-01 00:54:05.000000', 'temperatura', 497.0000, 'ºC'),
	(92552, 112, '2015-03-01 00:54:06.000000', 'temperatura', 1149.0000, 'ºC'),
	(92553, 112, '2015-03-01 00:54:07.000000', 'temperatura', 655.0000, 'ºC'),
	(92554, 112, '2015-03-01 00:54:08.000000', 'temperatura', 1027.0000, 'ºC'),
	(92555, 112, '2015-03-01 00:54:09.000000', 'temperatura', 773.0000, 'ºC'),
	(92556, 112, '2015-03-01 00:54:10.000000', 'temperatura', 785.0000, 'ºC'),
	(92557, 112, '2015-03-01 00:54:11.000000', 'temperatura', 406.0000, 'ºC'),
	(92558, 112, '2015-03-01 00:54:12.000000', 'temperatura', 876.0000, 'ºC'),
	(92559, 112, '2015-03-01 00:54:13.000000', 'temperatura', 760.0000, 'ºC'),
	(92560, 112, '2015-03-01 00:54:14.000000', 'temperatura', 1176.0000, 'ºC'),
	(92561, 112, '2015-03-01 00:54:15.000000', 'temperatura', 1198.0000, 'ºC'),
	(92562, 112, '2015-03-01 00:54:16.000000', 'temperatura', 65.0000, 'ºC'),
	(92563, 112, '2015-03-01 00:54:17.000000', 'temperatura', 330.0000, 'ºC'),
	(92564, 112, '2015-03-01 00:54:18.000000', 'temperatura', 255.0000, 'ºC'),
	(92565, 112, '2015-03-01 00:54:19.000000', 'temperatura', 287.0000, 'ºC'),
	(92566, 112, '2015-03-01 00:54:20.000000', 'temperatura', 670.0000, 'ºC'),
	(92567, 112, '2015-03-01 00:54:21.000000', 'temperatura', 88.0000, 'ºC'),
	(92568, 112, '2015-03-01 00:54:22.000000', 'temperatura', 833.0000, 'ºC'),
	(92569, 112, '2015-03-01 00:54:23.000000', 'temperatura', 300.0000, 'ºC'),
	(92570, 112, '2015-03-01 00:54:24.000000', 'temperatura', 201.0000, 'ºC'),
	(92571, 112, '2015-03-01 00:54:25.000000', 'temperatura', 104.0000, 'ºC'),
	(92572, 112, '2015-03-01 00:54:26.000000', 'temperatura', 1119.0000, 'ºC'),
	(92573, 112, '2015-03-01 00:54:27.000000', 'temperatura', 484.0000, 'ºC'),
	(92574, 112, '2015-03-01 00:54:28.000000', 'temperatura', 263.0000, 'ºC'),
	(92575, 112, '2015-03-01 00:54:29.000000', 'temperatura', 1062.0000, 'ºC'),
	(92576, 112, '2015-03-01 00:54:30.000000', 'temperatura', 924.0000, 'ºC'),
	(92577, 112, '2015-03-01 00:54:31.000000', 'temperatura', 235.0000, 'ºC'),
	(92578, 112, '2015-03-01 00:54:32.000000', 'temperatura', 804.0000, 'ºC'),
	(92579, 112, '2015-03-01 00:54:33.000000', 'temperatura', 914.0000, 'ºC'),
	(92580, 112, '2015-03-01 00:54:34.000000', 'temperatura', 961.0000, 'ºC'),
	(92581, 112, '2015-03-01 00:54:35.000000', 'temperatura', 860.0000, 'ºC'),
	(92582, 112, '2015-03-01 00:54:36.000000', 'temperatura', 221.0000, 'ºC'),
	(92583, 112, '2015-03-01 00:54:37.000000', 'temperatura', 924.0000, 'ºC'),
	(92584, 112, '2015-03-01 00:54:38.000000', 'temperatura', 357.0000, 'ºC'),
	(92585, 112, '2015-03-01 00:54:39.000000', 'temperatura', 213.0000, 'ºC'),
	(92586, 112, '2015-03-01 00:54:40.000000', 'temperatura', 1195.0000, 'ºC'),
	(92587, 112, '2015-03-01 00:54:41.000000', 'temperatura', 537.0000, 'ºC'),
	(92588, 112, '2015-03-01 00:54:42.000000', 'temperatura', 298.0000, 'ºC'),
	(92589, 112, '2015-03-01 00:54:43.000000', 'temperatura', 1081.0000, 'ºC'),
	(92590, 112, '2015-03-01 00:54:44.000000', 'temperatura', 913.0000, 'ºC'),
	(92591, 112, '2015-03-01 00:54:45.000000', 'temperatura', 121.0000, 'ºC'),
	(92592, 112, '2015-03-01 00:54:46.000000', 'temperatura', 269.0000, 'ºC'),
	(92593, 112, '2015-03-01 00:54:47.000000', 'temperatura', 981.0000, 'ºC'),
	(92594, 112, '2015-03-01 00:54:48.000000', 'temperatura', 497.0000, 'ºC'),
	(92595, 112, '2015-03-01 00:54:49.000000', 'temperatura', 745.0000, 'ºC'),
	(92596, 112, '2015-03-01 00:54:50.000000', 'temperatura', 1035.0000, 'ºC'),
	(92597, 112, '2015-03-01 00:54:51.000000', 'temperatura', 540.0000, 'ºC'),
	(92598, 112, '2015-03-01 00:54:52.000000', 'temperatura', 794.0000, 'ºC'),
	(92599, 112, '2015-03-01 00:54:53.000000', 'temperatura', 1152.0000, 'ºC'),
	(92600, 112, '2015-03-01 00:54:54.000000', 'temperatura', 977.0000, 'ºC'),
	(92601, 112, '2015-03-01 00:54:55.000000', 'temperatura', 229.0000, 'ºC'),
	(92602, 112, '2015-03-01 00:54:56.000000', 'temperatura', 615.0000, 'ºC'),
	(92603, 112, '2015-03-01 00:54:57.000000', 'temperatura', 1189.0000, 'ºC'),
	(92604, 112, '2015-03-01 00:54:58.000000', 'temperatura', 499.0000, 'ºC'),
	(92605, 112, '2015-03-01 00:54:59.000000', 'temperatura', 127.0000, 'ºC'),
	(92606, 112, '2015-03-01 00:55:00.000000', 'temperatura', 342.0000, 'ºC'),
	(92607, 112, '2015-03-01 00:55:01.000000', 'temperatura', 128.0000, 'ºC'),
	(92608, 112, '2015-03-01 00:55:02.000000', 'temperatura', 814.0000, 'ºC'),
	(92609, 112, '2015-03-01 00:55:03.000000', 'temperatura', 88.0000, 'ºC'),
	(92610, 112, '2015-03-01 00:55:04.000000', 'temperatura', 396.0000, 'ºC'),
	(92611, 112, '2015-03-01 00:55:05.000000', 'temperatura', 517.0000, 'ºC'),
	(92612, 112, '2015-03-01 00:55:06.000000', 'temperatura', 197.0000, 'ºC'),
	(92613, 112, '2015-03-01 00:55:07.000000', 'temperatura', 634.0000, 'ºC'),
	(92614, 112, '2015-03-01 00:55:08.000000', 'temperatura', 181.0000, 'ºC'),
	(92615, 112, '2015-03-01 00:55:09.000000', 'temperatura', 204.0000, 'ºC'),
	(92616, 112, '2015-03-01 00:55:10.000000', 'temperatura', 477.0000, 'ºC'),
	(92617, 112, '2015-03-01 00:55:11.000000', 'temperatura', 572.0000, 'ºC'),
	(92618, 112, '2015-03-01 00:55:12.000000', 'temperatura', 230.0000, 'ºC'),
	(92619, 112, '2015-03-01 00:55:13.000000', 'temperatura', 633.0000, 'ºC'),
	(92620, 112, '2015-03-01 00:55:14.000000', 'temperatura', 77.0000, 'ºC'),
	(92621, 112, '2015-03-01 00:55:15.000000', 'temperatura', 888.0000, 'ºC'),
	(92622, 112, '2015-03-01 00:55:16.000000', 'temperatura', 607.0000, 'ºC'),
	(92623, 112, '2015-03-01 00:55:17.000000', 'temperatura', 372.0000, 'ºC'),
	(92624, 112, '2015-03-01 00:55:18.000000', 'temperatura', 38.0000, 'ºC'),
	(92625, 112, '2015-03-01 00:55:19.000000', 'temperatura', 276.0000, 'ºC'),
	(92626, 112, '2015-03-01 00:55:20.000000', 'temperatura', 66.0000, 'ºC'),
	(92627, 112, '2015-03-01 00:55:21.000000', 'temperatura', 704.0000, 'ºC'),
	(92628, 112, '2015-03-01 00:55:22.000000', 'temperatura', 921.0000, 'ºC'),
	(92629, 112, '2015-03-01 00:55:23.000000', 'temperatura', 93.0000, 'ºC'),
	(92630, 112, '2015-03-01 00:55:24.000000', 'temperatura', 104.0000, 'ºC'),
	(92631, 112, '2015-03-01 00:55:25.000000', 'temperatura', 240.0000, 'ºC'),
	(92632, 112, '2015-03-01 00:55:26.000000', 'temperatura', 887.0000, 'ºC'),
	(92633, 112, '2015-03-01 00:55:27.000000', 'temperatura', 118.0000, 'ºC'),
	(92634, 112, '2015-03-01 00:55:28.000000', 'temperatura', 327.0000, 'ºC'),
	(92635, 112, '2015-03-01 00:55:29.000000', 'temperatura', 82.0000, 'ºC'),
	(92636, 112, '2015-03-01 00:55:30.000000', 'temperatura', 629.0000, 'ºC'),
	(92637, 112, '2015-03-01 00:55:31.000000', 'temperatura', 502.0000, 'ºC'),
	(92638, 112, '2015-03-01 00:55:32.000000', 'temperatura', 622.0000, 'ºC'),
	(92639, 112, '2015-03-01 00:55:33.000000', 'temperatura', 407.0000, 'ºC'),
	(92640, 112, '2015-03-01 00:55:34.000000', 'temperatura', 166.0000, 'ºC'),
	(92641, 112, '2015-03-01 00:55:35.000000', 'temperatura', 811.0000, 'ºC'),
	(92642, 112, '2015-03-01 00:55:36.000000', 'temperatura', 1158.0000, 'ºC'),
	(92643, 112, '2015-03-01 00:55:37.000000', 'temperatura', 959.0000, 'ºC'),
	(92644, 112, '2015-03-01 00:55:38.000000', 'temperatura', 120.0000, 'ºC'),
	(92645, 112, '2015-03-01 00:55:39.000000', 'temperatura', 122.0000, 'ºC'),
	(92646, 112, '2015-03-01 00:55:40.000000', 'temperatura', 251.0000, 'ºC'),
	(92647, 112, '2015-03-01 00:55:41.000000', 'temperatura', 891.0000, 'ºC'),
	(92648, 112, '2015-03-01 00:55:42.000000', 'temperatura', 103.0000, 'ºC'),
	(92649, 112, '2015-03-01 00:55:43.000000', 'temperatura', 241.0000, 'ºC'),
	(92650, 112, '2015-03-01 00:55:44.000000', 'temperatura', 897.0000, 'ºC'),
	(92651, 112, '2015-03-01 00:55:45.000000', 'temperatura', 162.0000, 'ºC'),
	(92652, 112, '2015-03-01 00:55:46.000000', 'temperatura', 522.0000, 'ºC'),
	(92653, 112, '2015-03-01 00:55:47.000000', 'temperatura', 922.0000, 'ºC'),
	(92654, 112, '2015-03-01 00:55:48.000000', 'temperatura', 645.0000, 'ºC'),
	(92655, 112, '2015-03-01 00:55:49.000000', 'temperatura', 458.0000, 'ºC'),
	(92656, 112, '2015-03-01 00:55:50.000000', 'temperatura', 355.0000, 'ºC'),
	(92657, 112, '2015-03-01 00:55:51.000000', 'temperatura', 402.0000, 'ºC'),
	(92658, 112, '2015-03-01 00:55:52.000000', 'temperatura', 944.0000, 'ºC'),
	(92659, 112, '2015-03-01 00:55:53.000000', 'temperatura', 1117.0000, 'ºC'),
	(92660, 112, '2015-03-01 00:55:54.000000', 'temperatura', 353.0000, 'ºC'),
	(92661, 112, '2015-03-01 00:55:55.000000', 'temperatura', 814.0000, 'ºC'),
	(92662, 112, '2015-03-01 00:55:56.000000', 'temperatura', 613.0000, 'ºC'),
	(92663, 112, '2015-03-01 00:55:57.000000', 'temperatura', 622.0000, 'ºC'),
	(92664, 112, '2015-03-01 00:55:58.000000', 'temperatura', 73.0000, 'ºC'),
	(92665, 112, '2015-03-01 00:55:59.000000', 'temperatura', 899.0000, 'ºC'),
	(92666, 112, '2015-03-01 00:56:00.000000', 'temperatura', 674.0000, 'ºC'),
	(92667, 112, '2015-03-01 00:56:01.000000', 'temperatura', 676.0000, 'ºC'),
	(92668, 112, '2015-03-01 00:56:02.000000', 'temperatura', 157.0000, 'ºC'),
	(92669, 112, '2015-03-01 00:56:03.000000', 'temperatura', 1160.0000, 'ºC'),
	(92670, 112, '2015-03-01 00:56:04.000000', 'temperatura', 528.0000, 'ºC'),
	(92671, 112, '2015-03-01 00:56:05.000000', 'temperatura', 361.0000, 'ºC'),
	(92672, 112, '2015-03-01 00:56:06.000000', 'temperatura', 221.0000, 'ºC'),
	(92673, 112, '2015-03-01 00:56:07.000000', 'temperatura', 25.0000, 'ºC'),
	(92674, 112, '2015-03-01 00:56:08.000000', 'temperatura', 659.0000, 'ºC'),
	(92675, 112, '2015-03-01 00:56:09.000000', 'temperatura', 823.0000, 'ºC'),
	(92676, 112, '2015-03-01 00:56:10.000000', 'temperatura', 937.0000, 'ºC'),
	(92677, 112, '2015-03-01 00:56:11.000000', 'temperatura', 1019.0000, 'ºC'),
	(92678, 112, '2015-03-01 00:56:12.000000', 'temperatura', 1083.0000, 'ºC'),
	(92679, 112, '2015-03-01 00:56:13.000000', 'temperatura', 1160.0000, 'ºC'),
	(92680, 112, '2015-03-01 00:56:14.000000', 'temperatura', 149.0000, 'ºC'),
	(92681, 112, '2015-03-01 00:56:15.000000', 'temperatura', 869.0000, 'ºC'),
	(92682, 112, '2015-03-01 00:56:16.000000', 'temperatura', 295.0000, 'ºC'),
	(92683, 112, '2015-03-01 00:56:17.000000', 'temperatura', 69.0000, 'ºC'),
	(92684, 112, '2015-03-01 00:56:18.000000', 'temperatura', 663.0000, 'ºC'),
	(92685, 112, '2015-03-01 00:56:19.000000', 'temperatura', 705.0000, 'ºC'),
	(92686, 112, '2015-03-01 00:56:20.000000', 'temperatura', 339.0000, 'ºC'),
	(92687, 112, '2015-03-01 00:56:21.000000', 'temperatura', 778.0000, 'ºC'),
	(92688, 112, '2015-03-01 00:56:22.000000', 'temperatura', 475.0000, 'ºC'),
	(92689, 112, '2015-03-01 00:56:23.000000', 'temperatura', 43.0000, 'ºC'),
	(92690, 112, '2015-03-01 00:56:24.000000', 'temperatura', 1189.0000, 'ºC'),
	(92691, 112, '2015-03-01 00:56:25.000000', 'temperatura', 1016.0000, 'ºC'),
	(92692, 112, '2015-03-01 00:56:26.000000', 'temperatura', 315.0000, 'ºC'),
	(92693, 112, '2015-03-01 00:56:27.000000', 'temperatura', 928.0000, 'ºC'),
	(92694, 112, '2015-03-01 00:56:28.000000', 'temperatura', 96.0000, 'ºC'),
	(92695, 112, '2015-03-01 00:56:29.000000', 'temperatura', 97.0000, 'ºC'),
	(92696, 112, '2015-03-01 00:56:30.000000', 'temperatura', 196.0000, 'ºC'),
	(92697, 112, '2015-03-01 00:56:31.000000', 'temperatura', 688.0000, 'ºC'),
	(92698, 112, '2015-03-01 00:56:32.000000', 'temperatura', 456.0000, 'ºC'),
	(92699, 112, '2015-03-01 00:56:33.000000', 'temperatura', 214.0000, 'ºC'),
	(92700, 112, '2015-03-01 00:56:34.000000', 'temperatura', 901.0000, 'ºC'),
	(92701, 112, '2015-03-01 00:56:35.000000', 'temperatura', 267.0000, 'ºC'),
	(92702, 112, '2015-03-01 00:56:36.000000', 'temperatura', 1031.0000, 'ºC'),
	(92703, 112, '2015-03-01 00:56:37.000000', 'temperatura', 753.0000, 'ºC'),
	(92704, 112, '2015-03-01 00:56:38.000000', 'temperatura', 672.0000, 'ºC'),
	(92705, 112, '2015-03-01 00:56:39.000000', 'temperatura', 1104.0000, 'ºC'),
	(92706, 112, '2015-03-01 00:56:40.000000', 'temperatura', 1104.0000, 'ºC'),
	(92707, 112, '2015-03-01 00:56:41.000000', 'temperatura', 1007.0000, 'ºC'),
	(92708, 112, '2015-03-01 00:56:42.000000', 'temperatura', 525.0000, 'ºC'),
	(92709, 112, '2015-03-01 00:56:43.000000', 'temperatura', 802.0000, 'ºC'),
	(92710, 112, '2015-03-01 00:56:44.000000', 'temperatura', 39.0000, 'ºC'),
	(92711, 112, '2015-03-01 00:56:45.000000', 'temperatura', 186.0000, 'ºC'),
	(92712, 112, '2015-03-01 00:56:46.000000', 'temperatura', 816.0000, 'ºC'),
	(92713, 112, '2015-03-01 00:56:47.000000', 'temperatura', 1122.0000, 'ºC'),
	(92714, 112, '2015-03-01 00:56:48.000000', 'temperatura', 762.0000, 'ºC'),
	(92715, 112, '2015-03-01 00:56:49.000000', 'temperatura', 444.0000, 'ºC'),
	(92716, 112, '2015-03-01 00:56:50.000000', 'temperatura', 1136.0000, 'ºC'),
	(92717, 112, '2015-03-01 00:56:51.000000', 'temperatura', 750.0000, 'ºC'),
	(92718, 112, '2015-03-01 00:56:52.000000', 'temperatura', 339.0000, 'ºC'),
	(92719, 112, '2015-03-01 00:56:53.000000', 'temperatura', 648.0000, 'ºC'),
	(92720, 112, '2015-03-01 00:56:54.000000', 'temperatura', 1021.0000, 'ºC'),
	(92721, 112, '2015-03-01 00:56:55.000000', 'temperatura', 765.0000, 'ºC'),
	(92722, 112, '2015-03-01 00:56:56.000000', 'temperatura', 760.0000, 'ºC'),
	(92723, 112, '2015-03-01 00:56:57.000000', 'temperatura', 304.0000, 'ºC'),
	(92724, 112, '2015-03-01 00:56:58.000000', 'temperatura', 444.0000, 'ºC'),
	(92725, 112, '2015-03-01 00:56:59.000000', 'temperatura', 105.0000, 'ºC'),
	(92726, 112, '2015-03-01 00:57:00.000000', 'temperatura', 395.0000, 'ºC'),
	(92727, 112, '2015-03-01 00:57:01.000000', 'temperatura', 462.0000, 'ºC'),
	(92728, 112, '2015-03-01 00:57:02.000000', 'temperatura', 1123.0000, 'ºC'),
	(92729, 112, '2015-03-01 00:57:03.000000', 'temperatura', 631.0000, 'ºC'),
	(92730, 112, '2015-03-01 00:57:04.000000', 'temperatura', 986.0000, 'ºC'),
	(92731, 112, '2015-03-01 00:57:05.000000', 'temperatura', 639.0000, 'ºC'),
	(92732, 112, '2015-03-01 00:57:06.000000', 'temperatura', 237.0000, 'ºC'),
	(92733, 112, '2015-03-01 00:57:07.000000', 'temperatura', 468.0000, 'ºC'),
	(92734, 112, '2015-03-01 00:57:08.000000', 'temperatura', 429.0000, 'ºC'),
	(92735, 112, '2015-03-01 00:57:09.000000', 'temperatura', 742.0000, 'ºC'),
	(92736, 112, '2015-03-01 00:57:10.000000', 'temperatura', 21.0000, 'ºC'),
	(92737, 112, '2015-03-01 00:57:11.000000', 'temperatura', 283.0000, 'ºC'),
	(92738, 112, '2015-03-01 00:57:12.000000', 'temperatura', 152.0000, 'ºC'),
	(92739, 112, '2015-03-01 00:57:13.000000', 'temperatura', 1109.0000, 'ºC'),
	(92740, 112, '2015-03-01 00:57:14.000000', 'temperatura', 291.0000, 'ºC'),
	(92741, 112, '2015-03-01 00:57:15.000000', 'temperatura', 528.0000, 'ºC'),
	(92742, 112, '2015-03-01 00:57:16.000000', 'temperatura', 570.0000, 'ºC'),
	(92743, 112, '2015-03-01 00:57:17.000000', 'temperatura', 64.0000, 'ºC'),
	(92744, 112, '2015-03-01 00:57:18.000000', 'temperatura', 1013.0000, 'ºC'),
	(92745, 112, '2015-03-01 00:57:19.000000', 'temperatura', 72.0000, 'ºC'),
	(92746, 112, '2015-03-01 00:57:20.000000', 'temperatura', 922.0000, 'ºC'),
	(92747, 112, '2015-03-01 00:57:21.000000', 'temperatura', 794.0000, 'ºC'),
	(92748, 112, '2015-03-01 00:57:22.000000', 'temperatura', 6.0000, 'ºC'),
	(92749, 112, '2015-03-01 00:57:23.000000', 'temperatura', 48.0000, 'ºC'),
	(92750, 112, '2015-03-01 00:57:24.000000', 'temperatura', 221.0000, 'ºC'),
	(92751, 112, '2015-03-01 00:57:25.000000', 'temperatura', 962.0000, 'ºC'),
	(92752, 112, '2015-03-01 00:57:26.000000', 'temperatura', 549.0000, 'ºC'),
	(92753, 112, '2015-03-01 00:57:27.000000', 'temperatura', 1059.0000, 'ºC'),
	(92754, 112, '2015-03-01 00:57:28.000000', 'temperatura', 47.0000, 'ºC'),
	(92755, 112, '2015-03-01 00:57:29.000000', 'temperatura', 661.0000, 'ºC'),
	(92756, 112, '2015-03-01 00:57:30.000000', 'temperatura', 765.0000, 'ºC'),
	(92757, 112, '2015-03-01 00:57:31.000000', 'temperatura', 643.0000, 'ºC'),
	(92758, 112, '2015-03-01 00:57:32.000000', 'temperatura', 920.0000, 'ºC'),
	(92759, 112, '2015-03-01 00:57:33.000000', 'temperatura', 271.0000, 'ºC'),
	(92760, 112, '2015-03-01 00:57:34.000000', 'temperatura', 994.0000, 'ºC'),
	(92761, 112, '2015-03-01 00:57:35.000000', 'temperatura', 558.0000, 'ºC'),
	(92762, 112, '2015-03-01 00:57:36.000000', 'temperatura', 1008.0000, 'ºC'),
	(92763, 112, '2015-03-01 00:57:37.000000', 'temperatura', 967.0000, 'ºC'),
	(92764, 112, '2015-03-01 00:57:38.000000', 'temperatura', 614.0000, 'ºC'),
	(92765, 112, '2015-03-01 00:57:39.000000', 'temperatura', 166.0000, 'ºC'),
	(92766, 112, '2015-03-01 00:57:40.000000', 'temperatura', 191.0000, 'ºC'),
	(92767, 112, '2015-03-01 00:57:41.000000', 'temperatura', 455.0000, 'ºC'),
	(92768, 112, '2015-03-01 00:57:42.000000', 'temperatura', 502.0000, 'ºC'),
	(92769, 112, '2015-03-01 00:57:43.000000', 'temperatura', 1146.0000, 'ºC'),
	(92770, 112, '2015-03-01 00:57:44.000000', 'temperatura', 625.0000, 'ºC'),
	(92771, 112, '2015-03-01 00:57:45.000000', 'temperatura', 888.0000, 'ºC'),
	(92772, 112, '2015-03-01 00:57:46.000000', 'temperatura', 165.0000, 'ºC'),
	(92773, 112, '2015-03-01 00:57:47.000000', 'temperatura', 560.0000, 'ºC'),
	(92774, 112, '2015-03-01 00:57:48.000000', 'temperatura', 1105.0000, 'ºC'),
	(92775, 112, '2015-03-01 00:57:49.000000', 'temperatura', 247.0000, 'ºC'),
	(92776, 112, '2015-03-01 00:57:50.000000', 'temperatura', 321.0000, 'ºC'),
	(92777, 112, '2015-03-01 00:57:51.000000', 'temperatura', 862.0000, 'ºC'),
	(92778, 112, '2015-03-01 00:57:52.000000', 'temperatura', 951.0000, 'ºC'),
	(92779, 112, '2015-03-01 00:57:53.000000', 'temperatura', 968.0000, 'ºC'),
	(92780, 112, '2015-03-01 00:57:54.000000', 'temperatura', 788.0000, 'ºC'),
	(92781, 112, '2015-03-01 00:57:55.000000', 'temperatura', 1034.0000, 'ºC'),
	(92782, 112, '2015-03-01 00:57:56.000000', 'temperatura', 409.0000, 'ºC'),
	(92783, 112, '2015-03-01 00:57:57.000000', 'temperatura', 142.0000, 'ºC'),
	(92784, 112, '2015-03-01 00:57:58.000000', 'temperatura', 686.0000, 'ºC'),
	(92785, 112, '2015-03-01 00:57:59.000000', 'temperatura', 604.0000, 'ºC'),
	(92786, 112, '2015-03-01 00:58:00.000000', 'temperatura', 960.0000, 'ºC'),
	(92787, 112, '2015-03-01 00:58:01.000000', 'temperatura', 590.0000, 'ºC'),
	(92788, 112, '2015-03-01 00:58:02.000000', 'temperatura', 71.0000, 'ºC'),
	(92789, 112, '2015-03-01 00:58:03.000000', 'temperatura', 985.0000, 'ºC'),
	(92790, 112, '2015-03-01 00:58:04.000000', 'temperatura', 1111.0000, 'ºC'),
	(92791, 112, '2015-03-01 00:58:05.000000', 'temperatura', 201.0000, 'ºC'),
	(92792, 112, '2015-03-01 00:58:06.000000', 'temperatura', 73.0000, 'ºC'),
	(92793, 112, '2015-03-01 00:58:07.000000', 'temperatura', 961.0000, 'ºC'),
	(92794, 112, '2015-03-01 00:58:08.000000', 'temperatura', 988.0000, 'ºC'),
	(92795, 112, '2015-03-01 00:58:09.000000', 'temperatura', 857.0000, 'ºC'),
	(92796, 112, '2015-03-01 00:58:10.000000', 'temperatura', 121.0000, 'ºC'),
	(92797, 112, '2015-03-01 00:58:11.000000', 'temperatura', 437.0000, 'ºC'),
	(92798, 112, '2015-03-01 00:58:12.000000', 'temperatura', 619.0000, 'ºC'),
	(92799, 112, '2015-03-01 00:58:13.000000', 'temperatura', 587.0000, 'ºC'),
	(92800, 112, '2015-03-01 00:58:14.000000', 'temperatura', 1076.0000, 'ºC'),
	(92801, 112, '2015-03-01 00:58:15.000000', 'temperatura', 20.0000, 'ºC'),
	(92802, 112, '2015-03-01 00:58:16.000000', 'temperatura', 472.0000, 'ºC'),
	(92803, 112, '2015-03-01 00:58:17.000000', 'temperatura', 1100.0000, 'ºC'),
	(92804, 112, '2015-03-01 00:58:18.000000', 'temperatura', 485.0000, 'ºC'),
	(92805, 112, '2015-03-01 00:58:19.000000', 'temperatura', 324.0000, 'ºC'),
	(92806, 112, '2015-03-01 00:58:20.000000', 'temperatura', 166.0000, 'ºC'),
	(92807, 112, '2015-03-01 00:58:21.000000', 'temperatura', 1059.0000, 'ºC'),
	(92808, 112, '2015-03-01 00:58:22.000000', 'temperatura', 1199.0000, 'ºC'),
	(92809, 112, '2015-03-01 00:58:23.000000', 'temperatura', 419.0000, 'ºC'),
	(92810, 112, '2015-03-01 00:58:24.000000', 'temperatura', 898.0000, 'ºC'),
	(92811, 112, '2015-03-01 00:58:25.000000', 'temperatura', 833.0000, 'ºC'),
	(92812, 112, '2015-03-01 00:58:26.000000', 'temperatura', 273.0000, 'ºC'),
	(92813, 112, '2015-03-01 00:58:27.000000', 'temperatura', 66.0000, 'ºC'),
	(92814, 112, '2015-03-01 00:58:28.000000', 'temperatura', 713.0000, 'ºC'),
	(92815, 112, '2015-03-01 00:58:29.000000', 'temperatura', 966.0000, 'ºC'),
	(92816, 112, '2015-03-01 00:58:30.000000', 'temperatura', 292.0000, 'ºC'),
	(92817, 112, '2015-03-01 00:58:31.000000', 'temperatura', 963.0000, 'ºC'),
	(92818, 112, '2015-03-01 00:58:32.000000', 'temperatura', 337.0000, 'ºC'),
	(92819, 112, '2015-03-01 00:58:33.000000', 'temperatura', 1199.0000, 'ºC'),
	(92820, 112, '2015-03-01 00:58:34.000000', 'temperatura', 182.0000, 'ºC'),
	(92821, 112, '2015-03-01 00:58:35.000000', 'temperatura', 917.0000, 'ºC'),
	(92822, 112, '2015-03-01 00:58:36.000000', 'temperatura', 436.0000, 'ºC'),
	(92823, 112, '2015-03-01 00:58:37.000000', 'temperatura', 632.0000, 'ºC'),
	(92824, 112, '2015-03-01 00:58:38.000000', 'temperatura', 650.0000, 'ºC'),
	(92825, 112, '2015-03-01 00:58:39.000000', 'temperatura', 155.0000, 'ºC'),
	(92826, 112, '2015-03-01 00:58:40.000000', 'temperatura', 27.0000, 'ºC'),
	(92827, 112, '2015-03-01 00:58:41.000000', 'temperatura', 871.0000, 'ºC'),
	(92828, 112, '2015-03-01 00:58:42.000000', 'temperatura', 672.0000, 'ºC'),
	(92829, 112, '2015-03-01 00:58:43.000000', 'temperatura', 748.0000, 'ºC'),
	(92830, 112, '2015-03-01 00:58:44.000000', 'temperatura', 524.0000, 'ºC'),
	(92831, 112, '2015-03-01 00:58:45.000000', 'temperatura', 376.0000, 'ºC'),
	(92832, 112, '2015-03-01 00:58:46.000000', 'temperatura', 309.0000, 'ºC'),
	(92833, 112, '2015-03-01 00:58:47.000000', 'temperatura', 416.0000, 'ºC'),
	(92834, 112, '2015-03-01 00:58:48.000000', 'temperatura', 1154.0000, 'ºC'),
	(92835, 112, '2015-03-01 00:58:49.000000', 'temperatura', 922.0000, 'ºC'),
	(92836, 112, '2015-03-01 00:58:50.000000', 'temperatura', 1147.0000, 'ºC'),
	(92837, 112, '2015-03-01 00:58:51.000000', 'temperatura', 571.0000, 'ºC'),
	(92838, 112, '2015-03-01 00:58:52.000000', 'temperatura', 616.0000, 'ºC'),
	(92839, 112, '2015-03-01 00:58:53.000000', 'temperatura', 168.0000, 'ºC'),
	(92840, 112, '2015-03-01 00:58:54.000000', 'temperatura', 192.0000, 'ºC'),
	(92841, 112, '2015-03-01 00:58:55.000000', 'temperatura', 457.0000, 'ºC'),
	(92842, 112, '2015-03-01 00:58:56.000000', 'temperatura', 509.0000, 'ºC'),
	(92843, 112, '2015-03-01 00:58:57.000000', 'temperatura', 1172.0000, 'ºC'),
	(92844, 112, '2015-03-01 00:58:58.000000', 'temperatura', 737.0000, 'ºC'),
	(92845, 112, '2015-03-01 00:58:59.000000', 'temperatura', 167.0000, 'ºC'),
	(92846, 112, '2015-03-01 00:59:00.000000', 'temperatura', 1025.0000, 'ºC'),
	(92847, 112, '2015-03-01 00:59:01.000000', 'temperatura', 1027.0000, 'ºC'),
	(92848, 112, '2015-03-01 00:59:02.000000', 'temperatura', 857.0000, 'ºC'),
	(92849, 112, '2015-03-01 00:59:03.000000', 'temperatura', 7.0000, 'ºC'),
	(92850, 112, '2015-03-01 00:59:04.000000', 'temperatura', 1064.0000, 'ºC'),
	(92851, 112, '2015-03-01 00:59:05.000000', 'temperatura', 498.0000, 'ºC'),
	(92852, 112, '2015-03-01 00:59:06.000000', 'temperatura', 498.0000, 'ºC'),
	(92853, 112, '2015-03-01 00:59:07.000000', 'temperatura', 998.0000, 'ºC'),
	(92854, 112, '2015-03-01 00:59:08.000000', 'temperatura', 1095.0000, 'ºC'),
	(92855, 112, '2015-03-01 00:59:09.000000', 'temperatura', 81.0000, 'ºC'),
	(92856, 112, '2015-03-01 00:59:10.000000', 'temperatura', 720.0000, 'ºC'),
	(92857, 112, '2015-03-01 00:59:11.000000', 'temperatura', 958.0000, 'ºC'),
	(92858, 112, '2015-03-01 00:59:12.000000', 'temperatura', 233.0000, 'ºC'),
	(92859, 112, '2015-03-01 00:59:13.000000', 'temperatura', 689.0000, 'ºC'),
	(92860, 112, '2015-03-01 00:59:14.000000', 'temperatura', 349.0000, 'ºC'),
	(92861, 112, '2015-03-01 00:59:15.000000', 'temperatura', 878.0000, 'ºC'),
	(92862, 112, '2015-03-01 00:59:16.000000', 'temperatura', 941.0000, 'ºC'),
	(92863, 112, '2015-03-01 00:59:17.000000', 'temperatura', 874.0000, 'ºC'),
	(92864, 112, '2015-03-01 00:59:18.000000', 'temperatura', 345.0000, 'ºC'),
	(92865, 112, '2015-03-01 00:59:19.000000', 'temperatura', 305.0000, 'ºC'),
	(92866, 112, '2015-03-01 00:59:20.000000', 'temperatura', 491.0000, 'ºC'),
	(92867, 112, '2015-03-01 00:59:21.000000', 'temperatura', 340.0000, 'ºC'),
	(92868, 112, '2015-03-01 00:59:22.000000', 'temperatura', 226.0000, 'ºC'),
	(92869, 112, '2015-03-01 00:59:23.000000', 'temperatura', 110.0000, 'ºC'),
	(92870, 112, '2015-03-01 00:59:24.000000', 'temperatura', 1073.0000, 'ºC'),
	(92871, 112, '2015-03-01 00:59:25.000000', 'temperatura', 236.0000, 'ºC'),
	(92872, 112, '2015-03-01 00:59:26.000000', 'temperatura', 361.0000, 'ºC'),
	(92873, 112, '2015-03-01 00:59:27.000000', 'temperatura', 1099.0000, 'ºC'),
	(92874, 112, '2015-03-01 00:59:28.000000', 'temperatura', 813.0000, 'ºC'),
	(92875, 112, '2015-03-01 00:59:29.000000', 'temperatura', 770.0000, 'ºC'),
	(92876, 112, '2015-03-01 00:59:30.000000', 'temperatura', 209.0000, 'ºC'),
	(92877, 112, '2015-03-01 00:59:31.000000', 'temperatura', 1134.0000, 'ºC'),
	(92878, 112, '2015-03-01 00:59:32.000000', 'temperatura', 245.0000, 'ºC'),
	(92879, 112, '2015-03-01 00:59:33.000000', 'temperatura', 223.0000, 'ºC'),
	(92880, 112, '2015-03-01 00:59:34.000000', 'temperatura', 380.0000, 'ºC'),
	(92881, 112, '2015-03-01 00:59:35.000000', 'temperatura', 34.0000, 'ºC'),
	(92882, 112, '2015-03-01 00:59:36.000000', 'temperatura', 230.0000, 'ºC'),
	(92883, 112, '2015-03-01 00:59:37.000000', 'temperatura', 1048.0000, 'ºC'),
	(92884, 112, '2015-03-01 00:59:38.000000', 'temperatura', 948.0000, 'ºC'),
	(92885, 112, '2015-03-01 00:59:39.000000', 'temperatura', 400.0000, 'ºC'),
	(92886, 112, '2015-03-01 00:59:40.000000', 'temperatura', 354.0000, 'ºC'),
	(92887, 112, '2015-03-01 00:59:41.000000', 'temperatura', 570.0000, 'ºC'),
	(92888, 112, '2015-03-01 00:59:42.000000', 'temperatura', 589.0000, 'ºC'),
	(92889, 112, '2015-03-01 00:59:43.000000', 'temperatura', 36.0000, 'ºC'),
	(92890, 112, '2015-03-01 00:59:44.000000', 'temperatura', 814.0000, 'ºC'),
	(92891, 112, '2015-03-01 00:59:45.000000', 'temperatura', 364.0000, 'ºC'),
	(92892, 112, '2015-03-01 00:59:46.000000', 'temperatura', 576.0000, 'ºC'),
	(92893, 112, '2015-03-01 00:59:47.000000', 'temperatura', 589.0000, 'ºC'),
	(92894, 112, '2015-03-01 00:59:48.000000', 'temperatura', 19.0000, 'ºC'),
	(92895, 112, '2015-03-01 00:59:49.000000', 'temperatura', 728.0000, 'ºC'),
	(92896, 112, '2015-03-01 00:59:50.000000', 'temperatura', 1183.0000, 'ºC'),
	(92897, 112, '2015-03-01 00:59:51.000000', 'temperatura', 133.0000, 'ºC'),
	(92898, 112, '2015-03-01 00:59:52.000000', 'temperatura', 715.0000, 'ºC'),
	(92899, 112, '2015-03-01 00:59:53.000000', 'temperatura', 776.0000, 'ºC'),
	(92900, 112, '2015-03-01 00:59:54.000000', 'temperatura', 534.0000, 'ºC'),
	(92901, 112, '2015-03-01 00:59:55.000000', 'temperatura', 345.0000, 'ºC'),
	(92902, 112, '2015-03-01 00:59:56.000000', 'temperatura', 124.0000, 'ºC'),
	(92903, 112, '2015-03-01 00:59:57.000000', 'temperatura', 785.0000, 'ºC'),
	(92904, 112, '2015-03-01 00:59:58.000000', 'temperatura', 1153.0000, 'ºC'),
	(92905, 112, '2015-03-01 00:59:59.000000', 'temperatura', 1011.0000, 'ºC'),
	(92906, 112, '2015-03-01 01:00:00.000000', 'temperatura', 397.0000, 'ºC'),
	(92907, 112, '2015-03-01 01:00:01.000000', 'temperatura', 152.0000, 'ºC'),
	(92908, 112, '2015-03-01 01:00:02.000000', 'temperatura', 771.0000, 'ºC'),
	(92909, 112, '2015-03-01 01:00:03.000000', 'temperatura', 1000.0000, 'ºC'),
	(92910, 112, '2015-03-01 01:00:04.000000', 'temperatura', 288.0000, 'ºC'),
	(92911, 112, '2015-03-01 01:00:05.000000', 'temperatura', 840.0000, 'ºC'),
	(92912, 112, '2015-03-01 01:00:06.000000', 'temperatura', 937.0000, 'ºC'),
	(92913, 112, '2015-03-01 01:00:07.000000', 'temperatura', 964.0000, 'ºC'),
	(92914, 112, '2015-03-01 01:00:08.000000', 'temperatura', 809.0000, 'ºC'),
	(92915, 112, '2015-03-01 01:00:09.000000', 'temperatura', 1153.0000, 'ºC'),
	(92916, 112, '2015-03-01 01:00:10.000000', 'temperatura', 937.0000, 'ºC'),
	(92917, 112, '2015-03-01 01:00:11.000000', 'temperatura', 30.0000, 'ºC'),
	(92918, 112, '2015-03-01 01:00:12.000000', 'temperatura', 937.0000, 'ºC'),
	(92919, 112, '2015-03-01 01:00:13.000000', 'temperatura', 998.0000, 'ºC'),
	(92920, 112, '2015-03-01 01:00:14.000000', 'temperatura', 979.0000, 'ºC'),
	(92921, 112, '2015-03-01 01:00:15.000000', 'temperatura', 702.0000, 'ºC'),
	(92922, 112, '2015-03-01 01:00:16.000000', 'temperatura', 575.0000, 'ºC'),
	(92923, 112, '2015-03-01 01:00:17.000000', 'temperatura', 767.0000, 'ºC'),
	(92924, 112, '2015-03-01 01:00:18.000000', 'temperatura', 910.0000, 'ºC'),
	(92925, 112, '2015-03-01 01:00:19.000000', 'temperatura', 1051.0000, 'ºC'),
	(92926, 112, '2015-03-01 01:00:20.000000', 'temperatura', 123.0000, 'ºC'),
	(92927, 112, '2015-03-01 01:00:21.000000', 'temperatura', 1064.0000, 'ºC'),
	(92928, 112, '2015-03-01 01:00:22.000000', 'temperatura', 153.0000, 'ºC'),
	(92929, 112, '2015-03-01 01:00:23.000000', 'temperatura', 1172.0000, 'ºC'),
	(92930, 112, '2015-03-01 01:00:24.000000', 'temperatura', 603.0000, 'ºC'),
	(92931, 112, '2015-03-01 01:00:25.000000', 'temperatura', 698.0000, 'ºC'),
	(92932, 112, '2015-03-01 01:00:26.000000', 'temperatura', 483.0000, 'ºC'),
	(92933, 112, '2015-03-01 01:00:27.000000', 'temperatura', 323.0000, 'ºC'),
	(92934, 112, '2015-03-01 01:00:28.000000', 'temperatura', 163.0000, 'ºC'),
	(92935, 112, '2015-03-01 01:00:29.000000', 'temperatura', 1047.0000, 'ºC'),
	(92936, 112, '2015-03-01 01:00:30.000000', 'temperatura', 1148.0000, 'ºC'),
	(92937, 112, '2015-03-01 01:00:31.000000', 'temperatura', 199.0000, 'ºC'),
	(92938, 112, '2015-03-01 01:00:32.000000', 'temperatura', 1153.0000, 'ºC'),
	(92939, 112, '2015-03-01 01:00:33.000000', 'temperatura', 368.0000, 'ºC'),
	(92940, 112, '2015-03-01 01:00:34.000000', 'temperatura', 783.0000, 'ºC'),
	(92941, 112, '2015-03-01 01:00:35.000000', 'temperatura', 408.0000, 'ºC'),
	(92942, 112, '2015-03-01 01:00:36.000000', 'temperatura', 893.0000, 'ºC'),
	(92943, 112, '2015-03-01 01:00:37.000000', 'temperatura', 842.0000, 'ºC'),
	(92944, 112, '2015-03-01 01:00:38.000000', 'temperatura', 331.0000, 'ºC'),
	(92945, 112, '2015-03-01 01:00:39.000000', 'temperatura', 330.0000, 'ºC'),
	(92946, 112, '2015-03-01 01:00:40.000000', 'temperatura', 657.0000, 'ºC'),
	(92947, 112, '2015-03-01 01:00:41.000000', 'temperatura', 1097.0000, 'ºC'),
	(92948, 112, '2015-03-01 01:00:42.000000', 'temperatura', 1112.0000, 'ºC'),
	(92949, 112, '2015-03-01 01:00:43.000000', 'temperatura', 1072.0000, 'ºC'),
	(92950, 112, '2015-03-01 01:00:44.000000', 'temperatura', 825.0000, 'ºC'),
	(92951, 112, '2015-03-01 01:00:45.000000', 'temperatura', 910.0000, 'ºC'),
	(92952, 112, '2015-03-01 01:00:46.000000', 'temperatura', 875.0000, 'ºC'),
	(92953, 112, '2015-03-01 01:00:47.000000', 'temperatura', 444.0000, 'ºC'),
	(92954, 112, '2015-03-01 01:00:48.000000', 'temperatura', 797.0000, 'ºC'),
	(92955, 112, '2015-03-01 01:00:49.000000', 'temperatura', 252.0000, 'ºC'),
	(92956, 112, '2015-03-01 01:00:50.000000', 'temperatura', 69.0000, 'ºC'),
	(92957, 112, '2015-03-01 01:00:51.000000', 'temperatura', 789.0000, 'ºC'),
	(92958, 112, '2015-03-01 01:00:52.000000', 'temperatura', 139.0000, 'ºC'),
	(92959, 112, '2015-03-01 01:00:53.000000', 'temperatura', 728.0000, 'ºC'),
	(92960, 112, '2015-03-01 01:00:54.000000', 'temperatura', 823.0000, 'ºC'),
	(92961, 112, '2015-03-01 01:00:55.000000', 'temperatura', 730.0000, 'ºC'),
	(92962, 112, '2015-03-01 01:00:56.000000', 'temperatura', 1184.0000, 'ºC'),
	(92963, 112, '2015-03-01 01:00:57.000000', 'temperatura', 132.0000, 'ºC'),
	(92964, 112, '2015-03-01 01:00:58.000000', 'temperatura', 705.0000, 'ºC'),
	(92965, 112, '2015-03-01 01:00:59.000000', 'temperatura', 731.0000, 'ºC'),
	(92966, 112, '2015-03-01 01:01:00.000000', 'temperatura', 342.0000, 'ºC'),
	(92967, 112, '2015-03-01 01:01:01.000000', 'temperatura', 717.0000, 'ºC'),
	(92968, 112, '2015-03-01 01:01:02.000000', 'temperatura', 158.0000, 'ºC'),
	(92969, 112, '2015-03-01 01:01:03.000000', 'temperatura', 1038.0000, 'ºC'),
	(92970, 112, '2015-03-01 01:01:04.000000', 'temperatura', 1120.0000, 'ºC'),
	(92971, 112, '2015-03-01 01:01:05.000000', 'temperatura', 84.0000, 'ºC'),
	(92972, 112, '2015-03-01 01:01:06.000000', 'temperatura', 663.0000, 'ºC'),
	(92973, 112, '2015-03-01 01:01:07.000000', 'temperatura', 661.0000, 'ºC'),
	(92974, 112, '2015-03-01 01:01:08.000000', 'temperatura', 118.0000, 'ºC'),
	(92975, 112, '2015-03-01 01:01:09.000000', 'temperatura', 1006.0000, 'ºC'),
	(92976, 112, '2015-03-01 01:01:10.000000', 'temperatura', 1079.0000, 'ºC'),
	(92977, 112, '2015-03-01 01:01:11.000000', 'temperatura', 1175.0000, 'ºC'),
	(92978, 112, '2015-03-01 01:01:12.000000', 'temperatura', 239.0000, 'ºC'),
	(92979, 112, '2015-03-01 01:01:13.000000', 'temperatura', 69.0000, 'ºC'),
	(92980, 112, '2015-03-01 01:01:14.000000', 'temperatura', 829.0000, 'ºC'),
	(92981, 112, '2015-03-01 01:01:15.000000', 'temperatura', 339.0000, 'ºC'),
	(92982, 112, '2015-03-01 01:01:16.000000', 'temperatura', 409.0000, 'ºC'),
	(92983, 112, '2015-03-01 01:01:17.000000', 'temperatura', 1029.0000, 'ºC'),
	(92984, 112, '2015-03-01 01:01:18.000000', 'temperatura', 320.0000, 'ºC'),
	(92985, 112, '2015-03-01 01:01:19.000000', 'temperatura', 912.0000, 'ºC'),
	(92986, 112, '2015-03-01 01:01:20.000000', 'temperatura', 1.0000, 'ºC'),
	(92987, 112, '2015-03-01 01:01:21.000000', 'temperatura', 870.0000, 'ºC'),
	(92988, 112, '2015-03-01 01:01:22.000000', 'temperatura', 749.0000, 'ºC'),
	(92989, 112, '2015-03-01 01:01:23.000000', 'temperatura', 1132.0000, 'ºC'),
	(92990, 112, '2015-03-01 01:01:24.000000', 'temperatura', 1016.0000, 'ºC'),
	(92991, 112, '2015-03-01 01:01:25.000000', 'temperatura', 486.0000, 'ºC'),
	(92992, 112, '2015-03-01 01:01:26.000000', 'temperatura', 579.0000, 'ºC'),
	(92993, 112, '2015-03-01 01:01:27.000000', 'temperatura', 238.0000, 'ºC'),
	(92994, 112, '2015-03-01 01:01:28.000000', 'temperatura', 656.0000, 'ºC'),
	(92995, 112, '2015-03-01 01:01:29.000000', 'temperatura', 165.0000, 'ºC'),
	(92996, 112, '2015-03-01 01:01:30.000000', 'temperatura', 57.0000, 'ºC'),
	(92997, 112, '2015-03-01 01:01:31.000000', 'temperatura', 989.0000, 'ºC'),
	(92998, 112, '2015-03-01 01:01:32.000000', 'temperatura', 1177.0000, 'ºC'),
	(92999, 112, '2015-03-01 01:01:33.000000', 'temperatura', 516.0000, 'ºC'),
	(93000, 112, '2015-03-01 01:01:34.000000', 'temperatura', 252.0000, 'ºC'),
	(93001, 112, '2015-03-01 01:01:35.000000', 'temperatura', 913.0000, 'ºC'),
	(93002, 112, '2015-03-01 01:01:36.000000', 'temperatura', 210.0000, 'ºC'),
	(93003, 112, '2015-03-01 01:01:37.000000', 'temperatura', 712.0000, 'ºC'),
	(93004, 112, '2015-03-01 01:01:38.000000', 'temperatura', 529.0000, 'ºC'),
	(93005, 112, '2015-03-01 01:01:39.000000', 'temperatura', 508.0000, 'ºC'),
	(93006, 112, '2015-03-01 01:01:40.000000', 'temperatura', 956.0000, 'ºC'),
	(93007, 112, '2015-03-01 01:01:41.000000', 'temperatura', 856.0000, 'ºC'),
	(93008, 112, '2015-03-01 01:01:42.000000', 'temperatura', 210.0000, 'ºC'),
	(93009, 112, '2015-03-01 01:01:43.000000', 'temperatura', 885.0000, 'ºC'),
	(93010, 112, '2015-03-01 01:01:44.000000', 'temperatura', 196.0000, 'ºC'),
	(93011, 112, '2015-03-01 01:01:45.000000', 'temperatura', 727.0000, 'ºC'),
	(93012, 112, '2015-03-01 01:01:46.000000', 'temperatura', 644.0000, 'ºC'),
	(93013, 112, '2015-03-01 01:01:47.000000', 'temperatura', 1043.0000, 'ºC'),
	(93014, 112, '2015-03-01 01:01:48.000000', 'temperatura', 881.0000, 'ºC'),
	(93015, 112, '2015-03-01 01:01:49.000000', 'temperatura', 79.0000, 'ºC'),
	(93016, 112, '2015-03-01 01:01:50.000000', 'temperatura', 152.0000, 'ºC'),
	(93017, 112, '2015-03-01 01:01:51.000000', 'temperatura', 521.0000, 'ºC'),
	(93018, 112, '2015-03-01 01:01:52.000000', 'temperatura', 952.0000, 'ºC'),
	(93019, 112, '2015-03-01 01:01:53.000000', 'temperatura', 799.0000, 'ºC'),
	(93020, 112, '2015-03-01 01:01:54.000000', 'temperatura', 1136.0000, 'ºC'),
	(93021, 112, '2015-03-01 01:01:55.000000', 'temperatura', 885.0000, 'ºC'),
	(93022, 112, '2015-03-01 01:01:56.000000', 'temperatura', 1016.0000, 'ºC'),
	(93023, 112, '2015-03-01 01:01:57.000000', 'temperatura', 27.0000, 'ºC'),
	(93024, 112, '2015-03-01 01:01:58.000000', 'temperatura', 687.0000, 'ºC'),
	(93025, 112, '2015-03-01 01:01:59.000000', 'temperatura', 954.0000, 'ºC'),
	(93026, 112, '2015-03-01 01:02:00.000000', 'temperatura', 309.0000, 'ºC'),
	(93027, 112, '2015-03-01 01:02:01.000000', 'temperatura', 1085.0000, 'ºC'),
	(93028, 112, '2015-03-01 01:02:02.000000', 'temperatura', 897.0000, 'ºC'),
	(93029, 112, '2015-03-01 01:02:03.000000', 'temperatura', 31.0000, 'ºC'),
	(93030, 112, '2015-03-01 01:02:04.000000', 'temperatura', 1065.0000, 'ºC'),
	(93031, 112, '2015-03-01 01:02:05.000000', 'temperatura', 430.0000, 'ºC'),
	(93032, 112, '2015-03-01 01:02:06.000000', 'temperatura', 159.0000, 'ºC'),
	(93033, 112, '2015-03-01 01:02:07.000000', 'temperatura', 704.0000, 'ºC'),
	(93034, 112, '2015-03-01 01:02:08.000000', 'temperatura', 645.0000, 'ºC'),
	(93035, 112, '2015-03-01 01:02:09.000000', 'temperatura', 1114.0000, 'ºC'),
	(93036, 112, '2015-03-01 01:02:10.000000', 'temperatura', 36.0000, 'ºC'),
	(93037, 112, '2015-03-01 01:02:11.000000', 'temperatura', 439.0000, 'ºC'),
	(93038, 112, '2015-03-01 01:02:12.000000', 'temperatura', 886.0000, 'ºC'),
	(93039, 112, '2015-03-01 01:02:13.000000', 'temperatura', 713.0000, 'ºC'),
	(93040, 112, '2015-03-01 01:02:14.000000', 'temperatura', 909.0000, 'ºC'),
	(93041, 112, '2015-03-01 01:02:15.000000', 'temperatura', 5.0000, 'ºC'),
	(93042, 112, '2015-03-01 01:02:16.000000', 'temperatura', 899.0000, 'ºC'),
	(93043, 112, '2015-03-01 01:02:17.000000', 'temperatura', 880.0000, 'ºC'),
	(93044, 112, '2015-03-01 01:02:18.000000', 'temperatura', 504.0000, 'ºC'),
	(93045, 112, '2015-03-01 01:02:19.000000', 'temperatura', 1080.0000, 'ºC'),
	(93046, 112, '2015-03-01 01:02:20.000000', 'temperatura', 290.0000, 'ºC'),
	(93047, 112, '2015-03-01 01:02:21.000000', 'temperatura', 612.0000, 'ºC'),
	(93048, 112, '2015-03-01 01:02:22.000000', 'temperatura', 987.0000, 'ºC'),
	(93049, 112, '2015-03-01 01:02:23.000000', 'temperatura', 701.0000, 'ºC'),
	(93050, 112, '2015-03-01 01:02:24.000000', 'temperatura', 546.0000, 'ºC'),
	(93051, 112, '2015-03-01 01:02:25.000000', 'temperatura', 628.0000, 'ºC'),
	(93052, 112, '2015-03-01 01:02:26.000000', 'temperatura', 303.0000, 'ºC'),
	(93053, 112, '2015-03-01 01:02:27.000000', 'temperatura', 830.0000, 'ºC'),
	(93054, 112, '2015-03-01 01:02:28.000000', 'temperatura', 842.0000, 'ºC'),
	(93055, 112, '2015-03-01 01:02:29.000000', 'temperatura', 520.0000, 'ºC'),
	(93056, 112, '2015-03-01 01:02:30.000000', 'temperatura', 73.0000, 'ºC'),
	(93057, 112, '2015-03-01 01:02:31.000000', 'temperatura', 7.0000, 'ºC'),
	(93058, 112, '2015-03-01 01:02:32.000000', 'temperatura', 1018.0000, 'ºC'),
	(93059, 112, '2015-03-01 01:02:33.000000', 'temperatura', 269.0000, 'ºC'),
	(93060, 112, '2015-03-01 01:02:34.000000', 'temperatura', 692.0000, 'ºC'),
	(93061, 112, '2015-03-01 01:02:35.000000', 'temperatura', 253.0000, 'ºC'),
	(93062, 112, '2015-03-01 01:02:36.000000', 'temperatura', 391.0000, 'ºC'),
	(93063, 112, '2015-03-01 01:02:37.000000', 'temperatura', 1195.0000, 'ºC'),
	(93064, 112, '2015-03-01 01:02:38.000000', 'temperatura', 1.0000, 'ºC'),
	(93065, 112, '2015-03-01 01:02:39.000000', 'temperatura', 24.0000, 'ºC'),
	(93066, 112, '2015-03-01 01:02:40.000000', 'temperatura', 115.0000, 'ºC'),
	(93067, 112, '2015-03-01 01:02:41.000000', 'temperatura', 504.0000, 'ºC'),
	(93068, 112, '2015-03-01 01:02:42.000000', 'temperatura', 974.0000, 'ºC'),
	(93069, 112, '2015-03-01 01:02:43.000000', 'temperatura', 958.0000, 'ºC'),
	(93070, 112, '2015-03-01 01:02:44.000000', 'temperatura', 668.0000, 'ºC'),
	(93071, 112, '2015-03-01 01:02:45.000000', 'temperatura', 470.0000, 'ºC'),
	(93072, 112, '2015-03-01 01:02:46.000000', 'temperatura', 343.0000, 'ºC'),
	(93073, 112, '2015-03-01 01:02:47.000000', 'temperatura', 306.0000, 'ºC'),
	(93074, 112, '2015-03-01 01:02:48.000000', 'temperatura', 502.0000, 'ºC'),
	(93075, 112, '2015-03-01 01:02:49.000000', 'temperatura', 390.0000, 'ºC'),
	(93076, 112, '2015-03-01 01:02:50.000000', 'temperatura', 448.0000, 'ºC'),
	(93077, 112, '2015-03-01 01:02:51.000000', 'temperatura', 1069.0000, 'ºC'),
	(93078, 112, '2015-03-01 01:02:52.000000', 'temperatura', 403.0000, 'ºC'),
	(93079, 112, '2015-03-01 01:02:53.000000', 'temperatura', 8.0000, 'ºC'),
	(93080, 112, '2015-03-01 01:02:54.000000', 'temperatura', 32.0000, 'ºC'),
	(93081, 112, '2015-03-01 01:02:55.000000', 'temperatura', 136.0000, 'ºC'),
	(93082, 112, '2015-03-01 01:02:56.000000', 'temperatura', 585.0000, 'ºC'),
	(93083, 112, '2015-03-01 01:02:57.000000', 'temperatura', 117.0000, 'ºC'),
	(93084, 112, '2015-03-01 01:02:58.000000', 'temperatura', 32.0000, 'ºC'),
	(93085, 112, '2015-03-01 01:02:59.000000', 'temperatura', 1007.0000, 'ºC'),
	(93086, 112, '2015-03-01 01:03:00.000000', 'temperatura', 142.0000, 'ºC'),
	(93087, 112, '2015-03-01 01:03:01.000000', 'temperatura', 88.0000, 'ºC'),
	(93088, 112, '2015-03-01 01:03:02.000000', 'temperatura', 14.0000, 'ºC'),
	(93089, 112, '2015-03-01 01:03:03.000000', 'temperatura', 1008.0000, 'ºC'),
	(93090, 112, '2015-03-01 01:03:04.000000', 'temperatura', 199.0000, 'ºC'),
	(93091, 112, '2015-03-01 01:03:05.000000', 'temperatura', 372.0000, 'ºC'),
	(93092, 112, '2015-03-01 01:03:06.000000', 'temperatura', 63.0000, 'ºC'),
	(93093, 112, '2015-03-01 01:03:07.000000', 'temperatura', 400.0000, 'ºC'),
	(93094, 112, '2015-03-01 01:03:08.000000', 'temperatura', 610.0000, 'ºC'),
	(93095, 112, '2015-03-01 01:03:09.000000', 'temperatura', 652.0000, 'ºC'),
	(93096, 112, '2015-03-01 01:03:10.000000', 'temperatura', 228.0000, 'ºC'),
	(93097, 112, '2015-03-01 01:03:11.000000', 'temperatura', 388.0000, 'ºC'),
	(93098, 112, '2015-03-01 01:03:12.000000', 'temperatura', 53.0000, 'ºC'),
	(93099, 112, '2015-03-01 01:03:13.000000', 'temperatura', 303.0000, 'ºC'),
	(93100, 112, '2015-03-01 01:03:14.000000', 'temperatura', 155.0000, 'ºC'),
	(93101, 112, '2015-03-01 01:03:15.000000', 'temperatura', 1066.0000, 'ºC'),
	(93102, 112, '2015-03-01 01:03:16.000000', 'temperatura', 67.0000, 'ºC'),
	(93103, 112, '2015-03-01 01:03:17.000000', 'temperatura', 738.0000, 'ºC'),
	(93104, 112, '2015-03-01 01:03:18.000000', 'temperatura', 1088.0000, 'ºC'),
	(93105, 112, '2015-03-01 01:03:19.000000', 'temperatura', 826.0000, 'ºC'),
	(93106, 112, '2015-03-01 01:03:20.000000', 'temperatura', 866.0000, 'ºC'),
	(93107, 112, '2015-03-01 01:03:21.000000', 'temperatura', 654.0000, 'ºC'),
	(93108, 112, '2015-03-01 01:03:22.000000', 'temperatura', 673.0000, 'ºC'),
	(93109, 112, '2015-03-01 01:03:23.000000', 'temperatura', 204.0000, 'ºC'),
	(93110, 112, '2015-03-01 01:03:24.000000', 'temperatura', 202.0000, 'ºC'),
	(93111, 112, '2015-03-01 01:03:25.000000', 'temperatura', 396.0000, 'ºC'),
	(93112, 112, '2015-03-01 01:03:26.000000', 'temperatura', 177.0000, 'ºC'),
	(93113, 112, '2015-03-01 01:03:27.000000', 'temperatura', 898.0000, 'ºC'),
	(93114, 112, '2015-03-01 01:03:28.000000', 'temperatura', 359.0000, 'ºC'),
	(93115, 112, '2015-03-01 01:03:29.000000', 'temperatura', 299.0000, 'ºC'),
	(93116, 112, '2015-03-01 01:03:30.000000', 'temperatura', 422.0000, 'ºC'),
	(93117, 112, '2015-03-01 01:03:31.000000', 'temperatura', 12.0000, 'ºC'),
	(93118, 112, '2015-03-01 01:03:32.000000', 'temperatura', 1197.0000, 'ºC'),
	(93119, 112, '2015-03-01 01:03:33.000000', 'temperatura', 1146.0000, 'ºC'),
	(93120, 112, '2015-03-01 01:03:34.000000', 'temperatura', 942.0000, 'ºC'),
	(93121, 112, '2015-03-01 01:03:35.000000', 'temperatura', 73.0000, 'ºC'),
	(93122, 112, '2015-03-01 01:03:36.000000', 'temperatura', 1138.0000, 'ºC'),
	(93123, 112, '2015-03-01 01:03:37.000000', 'temperatura', 674.0000, 'ºC'),
	(93124, 112, '2015-03-01 01:03:38.000000', 'temperatura', 1154.0000, 'ºC'),
	(93125, 112, '2015-03-01 01:03:39.000000', 'temperatura', 149.0000, 'ºC'),
	(93126, 112, '2015-03-01 01:03:40.000000', 'temperatura', 882.0000, 'ºC'),
	(93127, 112, '2015-03-01 01:03:41.000000', 'temperatura', 367.0000, 'ºC'),
	(93128, 112, '2015-03-01 01:03:42.000000', 'temperatura', 387.0000, 'ºC'),
	(93129, 112, '2015-03-01 01:03:43.000000', 'temperatura', 834.0000, 'ºC'),
	(93130, 112, '2015-03-01 01:03:44.000000', 'temperatura', 610.0000, 'ºC'),
	(93131, 112, '2015-03-01 01:03:45.000000', 'temperatura', 547.0000, 'ºC'),
	(93132, 112, '2015-03-01 01:03:46.000000', 'temperatura', 906.0000, 'ºC'),
	(93133, 112, '2015-03-01 01:03:47.000000', 'temperatura', 491.0000, 'ºC'),
	(93134, 112, '2015-03-01 01:03:48.000000', 'temperatura', 939.0000, 'ºC'),
	(93135, 112, '2015-03-01 01:03:49.000000', 'temperatura', 820.0000, 'ºC'),
	(93136, 112, '2015-03-01 01:03:50.000000', 'temperatura', 82.0000, 'ºC'),
	(93137, 112, '2015-03-01 01:03:51.000000', 'temperatura', 353.0000, 'ºC'),
	(93138, 112, '2015-03-01 01:03:52.000000', 'temperatura', 317.0000, 'ºC'),
	(93139, 112, '2015-03-01 01:03:53.000000', 'temperatura', 528.0000, 'ºC'),
	(93140, 112, '2015-03-01 01:03:54.000000', 'temperatura', 490.0000, 'ºC'),
	(93141, 112, '2015-03-01 01:03:55.000000', 'temperatura', 864.0000, 'ºC'),
	(93142, 112, '2015-03-01 01:03:56.000000', 'temperatura', 453.0000, 'ºC'),
	(93143, 112, '2015-03-01 01:03:57.000000', 'temperatura', 875.0000, 'ºC'),
	(93144, 112, '2015-03-01 01:03:58.000000', 'temperatura', 614.0000, 'ºC'),
	(93145, 112, '2015-03-01 01:03:59.000000', 'temperatura', 445.0000, 'ºC'),
	(93146, 112, '2015-03-01 01:04:00.000000', 'temperatura', 384.0000, 'ºC'),
	(93147, 112, '2015-03-01 01:04:01.000000', 'temperatura', 587.0000, 'ºC'),
	(93148, 112, '2015-03-01 01:04:02.000000', 'temperatura', 582.0000, 'ºC'),
	(93149, 112, '2015-03-01 01:04:03.000000', 'temperatura', 1151.0000, 'ºC'),
	(93150, 112, '2015-03-01 01:04:04.000000', 'temperatura', 409.0000, 'ºC'),
	(93151, 112, '2015-03-01 01:04:05.000000', 'temperatura', 991.0000, 'ºC'),
	(93152, 112, '2015-03-01 01:04:06.000000', 'temperatura', 130.0000, 'ºC'),
	(93153, 112, '2015-03-01 01:04:07.000000', 'temperatura', 76.0000, 'ºC'),
	(93154, 112, '2015-03-01 01:04:08.000000', 'temperatura', 1190.0000, 'ºC'),
	(93155, 112, '2015-03-01 01:04:09.000000', 'temperatura', 925.0000, 'ºC'),
	(93156, 112, '2015-03-01 01:04:10.000000', 'temperatura', 1056.0000, 'ºC'),
	(93157, 112, '2015-03-01 01:04:11.000000', 'temperatura', 105.0000, 'ºC'),
	(93158, 112, '2015-03-01 01:04:12.000000', 'temperatura', 957.0000, 'ºC'),
	(93159, 112, '2015-03-01 01:04:13.000000', 'temperatura', 869.0000, 'ºC'),
	(93160, 112, '2015-03-01 01:04:14.000000', 'temperatura', 275.0000, 'ºC'),
	(93161, 112, '2015-03-01 01:04:15.000000', 'temperatura', 1169.0000, 'ºC'),
	(93162, 112, '2015-03-01 01:04:16.000000', 'temperatura', 219.0000, 'ºC'),
	(93163, 112, '2015-03-01 01:04:17.000000', 'temperatura', 1189.0000, 'ºC'),
	(93164, 112, '2015-03-01 01:04:18.000000', 'temperatura', 489.0000, 'ºC'),
	(93165, 112, '2015-03-01 01:04:19.000000', 'temperatura', 78.0000, 'ºC'),
	(93166, 112, '2015-03-01 01:04:20.000000', 'temperatura', 125.0000, 'ºC'),
	(93167, 112, '2015-03-01 01:04:21.000000', 'temperatura', 390.0000, 'ºC'),
	(93168, 112, '2015-03-01 01:04:22.000000', 'temperatura', 375.0000, 'ºC'),
	(93169, 112, '2015-03-01 01:04:23.000000', 'temperatura', 705.0000, 'ºC'),
	(93170, 112, '2015-03-01 01:04:24.000000', 'temperatura', 1.0000, 'ºC'),
	(93171, 112, '2015-03-01 01:04:25.000000', 'temperatura', 289.0000, 'ºC'),
	(93172, 112, '2015-03-01 01:04:26.000000', 'temperatura', 244.0000, 'ºC'),
	(93173, 112, '2015-03-01 01:04:27.000000', 'temperatura', 352.0000, 'ºC'),
	(93174, 112, '2015-03-01 01:04:28.000000', 'temperatura', 1031.0000, 'ºC'),
	(93175, 112, '2015-03-01 01:04:29.000000', 'temperatura', 497.0000, 'ºC'),
	(93176, 112, '2015-03-01 01:04:30.000000', 'temperatura', 594.0000, 'ºC'),
	(93177, 112, '2015-03-01 01:04:31.000000', 'temperatura', 279.0000, 'ºC'),
	(93178, 112, '2015-03-01 01:04:32.000000', 'temperatura', 814.0000, 'ºC'),
	(93179, 112, '2015-03-01 01:04:33.000000', 'temperatura', 832.0000, 'ºC'),
	(93180, 112, '2015-03-01 01:04:34.000000', 'temperatura', 520.0000, 'ºC'),
	(93181, 112, '2015-03-01 01:04:35.000000', 'temperatura', 105.0000, 'ºC'),
	(93182, 112, '2015-03-01 01:04:36.000000', 'temperatura', 164.0000, 'ºC'),
	(93183, 112, '2015-03-01 01:04:37.000000', 'temperatura', 507.0000, 'ºC'),
	(93184, 112, '2015-03-01 01:04:38.000000', 'temperatura', 843.0000, 'ºC'),
	(93185, 112, '2015-03-01 01:04:39.000000', 'temperatura', 294.0000, 'ºC'),
	(93186, 112, '2015-03-01 01:04:40.000000', 'temperatura', 143.0000, 'ºC'),
	(93187, 112, '2015-03-01 01:04:41.000000', 'temperatura', 1031.0000, 'ºC'),
	(93188, 112, '2015-03-01 01:04:42.000000', 'temperatura', 1126.0000, 'ºC'),
	(93189, 112, '2015-03-01 01:04:43.000000', 'temperatura', 140.0000, 'ºC'),
	(93190, 112, '2015-03-01 01:04:44.000000', 'temperatura', 921.0000, 'ºC'),
	(93191, 112, '2015-03-01 01:04:45.000000', 'temperatura', 585.0000, 'ºC'),
	(93192, 112, '2015-03-01 01:04:46.000000', 'temperatura', 163.0000, 'ºC'),
	(93193, 112, '2015-03-01 01:04:47.000000', 'temperatura', 262.0000, 'ºC'),
	(93194, 112, '2015-03-01 01:04:48.000000', 'temperatura', 819.0000, 'ºC'),
	(93195, 112, '2015-03-01 01:04:49.000000', 'temperatura', 910.0000, 'ºC'),
	(93196, 112, '2015-03-01 01:04:50.000000', 'temperatura', 896.0000, 'ºC'),
	(93197, 112, '2015-03-01 01:04:51.000000', 'temperatura', 549.0000, 'ºC'),
	(93198, 112, '2015-03-01 01:04:52.000000', 'temperatura', 57.0000, 'ºC'),
	(93199, 112, '2015-03-01 01:04:53.000000', 'temperatura', 1040.0000, 'ºC'),
	(93200, 112, '2015-03-01 01:04:54.000000', 'temperatura', 230.0000, 'ºC'),
	(93201, 112, '2015-03-01 01:04:55.000000', 'temperatura', 428.0000, 'ºC'),
	(93202, 112, '2015-03-01 01:04:56.000000', 'temperatura', 253.0000, 'ºC'),
	(93203, 112, '2015-03-01 01:04:57.000000', 'temperatura', 1180.0000, 'ºC'),
	(93204, 112, '2015-03-01 01:04:58.000000', 'temperatura', 344.0000, 'ºC'),
	(93205, 112, '2015-03-01 01:04:59.000000', 'temperatura', 578.0000, 'ºC'),
	(93206, 112, '2015-03-01 01:05:00.000000', 'temperatura', 659.0000, 'ºC'),
	(93207, 112, '2015-03-01 01:05:01.000000', 'temperatura', 362.0000, 'ºC'),
	(93208, 112, '2015-03-01 01:05:02.000000', 'temperatura', 1033.0000, 'ºC'),
	(93209, 112, '2015-03-01 01:05:03.000000', 'temperatura', 480.0000, 'ºC'),
	(93210, 112, '2015-03-01 01:05:04.000000', 'temperatura', 502.0000, 'ºC'),
	(93211, 112, '2015-03-01 01:05:05.000000', 'temperatura', 1069.0000, 'ºC'),
	(93212, 112, '2015-03-01 01:05:06.000000', 'temperatura', 242.0000, 'ºC'),
	(93213, 112, '2015-03-01 01:05:07.000000', 'temperatura', 402.0000, 'ºC'),
	(93214, 112, '2015-03-01 01:05:08.000000', 'temperatura', 86.0000, 'ºC'),
	(93215, 112, '2015-03-01 01:05:09.000000', 'temperatura', 423.0000, 'ºC'),
	(93216, 112, '2015-03-01 01:05:10.000000', 'temperatura', 656.0000, 'ºC'),
	(93217, 112, '2015-03-01 01:05:11.000000', 'temperatura', 815.0000, 'ºC'),
	(93218, 112, '2015-03-01 01:05:12.000000', 'temperatura', 905.0000, 'ºC'),
	(93219, 112, '2015-03-01 01:05:13.000000', 'temperatura', 882.0000, 'ºC'),
	(93220, 112, '2015-03-01 01:05:14.000000', 'temperatura', 497.0000, 'ºC'),
	(93221, 112, '2015-03-01 01:05:15.000000', 'temperatura', 1036.0000, 'ºC'),
	(93222, 112, '2015-03-01 01:05:16.000000', 'temperatura', 93.0000, 'ºC'),
	(93223, 112, '2015-03-01 01:05:17.000000', 'temperatura', 954.0000, 'ºC'),
	(93224, 112, '2015-03-01 01:05:18.000000', 'temperatura', 893.0000, 'ºC'),
	(93225, 112, '2015-03-01 01:05:19.000000', 'temperatura', 403.0000, 'ºC'),
	(93226, 112, '2015-03-01 01:05:20.000000', 'temperatura', 539.0000, 'ºC'),
	(93227, 112, '2015-03-01 01:05:21.000000', 'temperatura', 284.0000, 'ºC'),
	(93228, 112, '2015-03-01 01:05:22.000000', 'temperatura', 1006.0000, 'ºC'),
	(93229, 112, '2015-03-01 01:05:23.000000', 'temperatura', 576.0000, 'ºC'),
	(93230, 112, '2015-03-01 01:05:24.000000', 'temperatura', 1062.0000, 'ºC'),
	(93231, 112, '2015-03-01 01:05:25.000000', 'temperatura', 1182.0000, 'ºC'),
	(93232, 112, '2015-03-01 01:05:26.000000', 'temperatura', 324.0000, 'ºC'),
	(93233, 112, '2015-03-01 01:05:27.000000', 'temperatura', 477.0000, 'ºC'),
	(93234, 112, '2015-03-01 01:05:28.000000', 'temperatura', 211.0000, 'ºC'),
	(93235, 112, '2015-03-01 01:05:29.000000', 'temperatura', 828.0000, 'ºC'),
	(93236, 112, '2015-03-01 01:05:30.000000', 'temperatura', 1104.0000, 'ºC'),
	(93237, 112, '2015-03-01 01:05:31.000000', 'temperatura', 637.0000, 'ºC'),
	(93238, 112, '2015-03-01 01:05:32.000000', 'temperatura', 1073.0000, 'ºC'),
	(93239, 112, '2015-03-01 01:05:33.000000', 'temperatura', 1053.0000, 'ºC'),
	(93240, 112, '2015-03-01 01:05:34.000000', 'temperatura', 848.0000, 'ºC'),
	(93241, 112, '2015-03-01 01:05:35.000000', 'temperatura', 1083.0000, 'ºC'),
	(93242, 112, '2015-03-01 01:05:36.000000', 'temperatura', 471.0000, 'ºC'),
	(93243, 112, '2015-03-01 01:05:37.000000', 'temperatura', 304.0000, 'ºC'),
	(93244, 112, '2015-03-01 01:05:38.000000', 'temperatura', 111.0000, 'ºC'),
	(93245, 112, '2015-03-01 01:05:39.000000', 'temperatura', 841.0000, 'ºC'),
	(93246, 112, '2015-03-01 01:05:40.000000', 'temperatura', 271.0000, 'ºC'),
	(93247, 112, '2015-03-01 01:05:41.000000', 'temperatura', 35.0000, 'ºC'),
	(93248, 112, '2015-03-01 01:05:42.000000', 'temperatura', 560.0000, 'ºC'),
	(93249, 112, '2015-03-01 01:05:43.000000', 'temperatura', 299.0000, 'ºC'),
	(93250, 112, '2015-03-01 01:05:44.000000', 'temperatura', 1013.0000, 'ºC'),
	(93251, 112, '2015-03-01 01:05:45.000000', 'temperatura', 568.0000, 'ºC'),
	(93252, 112, '2015-03-01 01:05:46.000000', 'temperatura', 1003.0000, 'ºC'),
	(93253, 112, '2015-03-01 01:05:47.000000', 'temperatura', 911.0000, 'ºC'),
	(93254, 112, '2015-03-01 01:05:48.000000', 'temperatura', 346.0000, 'ºC'),
	(93255, 112, '2015-03-01 01:05:49.000000', 'temperatura', 197.0000, 'ºC'),
	(93256, 112, '2015-03-01 01:05:50.000000', 'temperatura', 1147.0000, 'ºC'),
	(93257, 112, '2015-03-01 01:05:51.000000', 'temperatura', 346.0000, 'ºC'),
	(93258, 112, '2015-03-01 01:05:52.000000', 'temperatura', 689.0000, 'ºC'),
	(93259, 112, '2015-03-01 01:05:53.000000', 'temperatura', 8.0000, 'ºC'),
	(93260, 112, '2015-03-01 01:05:54.000000', 'temperatura', 373.0000, 'ºC'),
	(93261, 112, '2015-03-01 01:05:55.000000', 'temperatura', 643.0000, 'ºC'),
	(93262, 112, '2015-03-01 01:05:56.000000', 'temperatura', 896.0000, 'ºC'),
	(93263, 112, '2015-03-01 01:05:57.000000', 'temperatura', 150.0000, 'ºC'),
	(93264, 112, '2015-03-01 01:05:58.000000', 'temperatura', 464.0000, 'ºC'),
	(93265, 112, '2015-03-01 01:05:59.000000', 'temperatura', 671.0000, 'ºC'),
	(93266, 112, '2015-03-01 01:06:00.000000', 'temperatura', 762.0000, 'ºC'),
	(93267, 112, '2015-03-01 01:06:01.000000', 'temperatura', 598.0000, 'ºC'),
	(93268, 112, '2015-03-01 01:06:02.000000', 'temperatura', 703.0000, 'ºC'),
	(93269, 112, '2015-03-01 01:06:03.000000', 'temperatura', 521.0000, 'ºC'),
	(93270, 112, '2015-03-01 01:06:04.000000', 'temperatura', 499.0000, 'ºC'),
	(93271, 112, '2015-03-01 01:06:05.000000', 'temperatura', 930.0000, 'ºC'),
	(93272, 112, '2015-03-01 01:06:06.000000', 'temperatura', 753.0000, 'ºC'),
	(93273, 112, '2015-03-01 01:06:07.000000', 'temperatura', 975.0000, 'ºC'),
	(93274, 112, '2015-03-01 01:06:08.000000', 'temperatura', 217.0000, 'ºC'),
	(93275, 112, '2015-03-01 01:06:09.000000', 'temperatura', 561.0000, 'ºC'),
	(93276, 112, '2015-03-01 01:06:10.000000', 'temperatura', 953.0000, 'ºC'),
	(93277, 112, '2015-03-01 01:06:11.000000', 'temperatura', 683.0000, 'ºC'),
	(93278, 112, '2015-03-01 01:06:12.000000', 'temperatura', 558.0000, 'ºC'),
	(93279, 112, '2015-03-01 01:06:13.000000', 'temperatura', 743.0000, 'ºC'),
	(93280, 112, '2015-03-01 01:06:14.000000', 'temperatura', 839.0000, 'ºC'),
	(93281, 112, '2015-03-01 01:06:15.000000', 'temperatura', 766.0000, 'ºC'),
	(93282, 112, '2015-03-01 01:06:16.000000', 'temperatura', 115.0000, 'ºC'),
	(93283, 112, '2015-03-01 01:06:17.000000', 'temperatura', 676.0000, 'ºC'),
	(93284, 112, '2015-03-01 01:06:18.000000', 'temperatura', 637.0000, 'ºC'),
	(93285, 112, '2015-03-01 01:06:19.000000', 'temperatura', 1155.0000, 'ºC'),
	(93286, 112, '2015-03-01 01:06:20.000000', 'temperatura', 267.0000, 'ºC'),
	(93287, 112, '2015-03-01 01:06:21.000000', 'temperatura', 269.0000, 'ºC'),
	(93288, 112, '2015-03-01 01:06:22.000000', 'temperatura', 546.0000, 'ºC'),
	(93289, 112, '2015-03-01 01:06:23.000000', 'temperatura', 721.0000, 'ºC'),
	(93290, 112, '2015-03-01 01:06:24.000000', 'temperatura', 769.0000, 'ºC'),
	(93291, 112, '2015-03-01 01:06:25.000000', 'temperatura', 482.0000, 'ºC'),
	(93292, 112, '2015-03-01 01:06:26.000000', 'temperatura', 105.0000, 'ºC'),
	(93293, 112, '2015-03-01 01:06:27.000000', 'temperatura', 280.0000, 'ºC'),
	(93294, 112, '2015-03-01 01:06:28.000000', 'temperatura', 1085.0000, 'ºC'),
	(93295, 112, '2015-03-01 01:06:29.000000', 'temperatura', 984.0000, 'ºC'),
	(93296, 112, '2015-03-01 01:06:30.000000', 'temperatura', 466.0000, 'ºC'),
	(93297, 112, '2015-03-01 01:06:31.000000', 'temperatura', 577.0000, 'ºC'),
	(93298, 112, '2015-03-01 01:06:32.000000', 'temperatura', 290.0000, 'ºC'),
	(93299, 112, '2015-03-01 01:06:33.000000', 'temperatura', 921.0000, 'ºC'),
	(93300, 112, '2015-03-01 01:06:34.000000', 'temperatura', 132.0000, 'ºC'),
	(93301, 112, '2015-03-01 01:06:35.000000', 'temperatura', 298.0000, 'ºC'),
	(93302, 112, '2015-03-01 01:06:36.000000', 'temperatura', 1096.0000, 'ºC'),
	(93303, 112, '2015-03-01 01:06:37.000000', 'temperatura', 986.0000, 'ºC'),
	(93304, 112, '2015-03-01 01:06:38.000000', 'temperatura', 442.0000, 'ºC'),
	(93305, 112, '2015-03-01 01:06:39.000000', 'temperatura', 454.0000, 'ºC'),
	(93306, 112, '2015-03-01 01:06:40.000000', 'temperatura', 945.0000, 'ºC'),
	(93307, 112, '2015-03-01 01:06:41.000000', 'temperatura', 963.0000, 'ºC'),
	(93308, 112, '2015-03-01 01:06:42.000000', 'temperatura', 780.0000, 'ºC'),
	(93309, 112, '2015-03-01 01:06:43.000000', 'temperatura', 1010.0000, 'ºC'),
	(93310, 112, '2015-03-01 01:06:44.000000', 'temperatura', 310.0000, 'ºC'),
	(93311, 112, '2015-03-01 01:06:45.000000', 'temperatura', 922.0000, 'ºC'),
	(93312, 112, '2015-03-01 01:06:46.000000', 'temperatura', 80.0000, 'ºC'),
	(93313, 112, '2015-03-01 01:06:47.000000', 'temperatura', 36.0000, 'ºC'),
	(93314, 112, '2015-03-01 01:06:48.000000', 'temperatura', 1140.0000, 'ºC'),
	(93315, 112, '2015-03-01 01:06:49.000000', 'temperatura', 793.0000, 'ºC'),
	(93316, 112, '2015-03-01 01:06:50.000000', 'temperatura', 543.0000, 'ºC'),
	(93317, 112, '2015-03-01 01:06:51.000000', 'temperatura', 338.0000, 'ºC'),
	(93318, 112, '2015-03-01 01:06:52.000000', 'temperatura', 62.0000, 'ºC'),
	(93319, 112, '2015-03-01 01:06:53.000000', 'temperatura', 498.0000, 'ºC'),
	(93320, 112, '2015-03-01 01:06:54.000000', 'temperatura', 1104.0000, 'ºC'),
	(93321, 112, '2015-03-01 01:06:55.000000', 'temperatura', 425.0000, 'ºC'),
	(93322, 112, '2015-03-01 01:06:56.000000', 'temperatura', 15.0000, 'ºC'),
	(93323, 112, '2015-03-01 01:06:57.000000', 'temperatura', 1.0000, 'ºC'),
	(93324, 112, '2015-03-01 01:06:58.000000', 'temperatura', 1160.0000, 'ºC'),
	(93325, 112, '2015-03-01 01:06:59.000000', 'temperatura', 996.0000, 'ºC'),
	(93326, 112, '2015-03-01 01:07:00.000000', 'temperatura', 303.0000, 'ºC'),
	(93327, 112, '2015-03-01 01:07:01.000000', 'temperatura', 926.0000, 'ºC'),
	(93328, 112, '2015-03-01 01:07:02.000000', 'temperatura', 120.0000, 'ºC'),
	(93329, 112, '2015-03-01 01:07:03.000000', 'temperatura', 226.0000, 'ºC'),
	(93330, 112, '2015-03-01 01:07:04.000000', 'temperatura', 767.0000, 'ºC'),
	(93331, 112, '2015-03-01 01:07:05.000000', 'temperatura', 761.0000, 'ºC'),
	(93332, 112, '2015-03-01 01:07:06.000000', 'temperatura', 303.0000, 'ºC'),
	(93333, 112, '2015-03-01 01:07:07.000000', 'temperatura', 430.0000, 'ºC'),
	(93334, 112, '2015-03-01 01:07:08.000000', 'temperatura', 45.0000, 'ºC'),
	(93335, 112, '2015-03-01 01:07:09.000000', 'temperatura', 135.0000, 'ºC'),
	(93336, 112, '2015-03-01 01:07:10.000000', 'temperatura', 540.0000, 'ºC'),
	(93337, 112, '2015-03-01 01:07:11.000000', 'temperatura', 1093.0000, 'ºC'),
	(93338, 112, '2015-03-01 01:07:12.000000', 'temperatura', 249.0000, 'ºC'),
	(93339, 112, '2015-03-01 01:07:13.000000', 'temperatura', 365.0000, 'ºC'),
	(93340, 112, '2015-03-01 01:07:14.000000', 'temperatura', 1080.0000, 'ºC'),
	(93341, 112, '2015-03-01 01:07:15.000000', 'temperatura', 703.0000, 'ºC'),
	(93342, 112, '2015-03-01 01:07:16.000000', 'temperatura', 277.0000, 'ºC'),
	(93343, 112, '2015-03-01 01:07:17.000000', 'temperatura', 475.0000, 'ºC'),
	(93344, 112, '2015-03-01 01:07:18.000000', 'temperatura', 347.0000, 'ºC'),
	(93345, 112, '2015-03-01 01:07:19.000000', 'temperatura', 309.0000, 'ºC'),
	(93346, 112, '2015-03-01 01:07:20.000000', 'temperatura', 504.0000, 'ºC'),
	(93347, 112, '2015-03-01 01:07:21.000000', 'temperatura', 396.0000, 'ºC'),
	(93348, 112, '2015-03-01 01:07:22.000000', 'temperatura', 465.0000, 'ºC'),
	(93349, 112, '2015-03-01 01:07:23.000000', 'temperatura', 1141.0000, 'ºC'),
	(93350, 112, '2015-03-01 01:07:24.000000', 'temperatura', 708.0000, 'ºC'),
	(93351, 112, '2015-03-01 01:07:25.000000', 'temperatura', 117.0000, 'ºC'),
	(93352, 112, '2015-03-01 01:07:26.000000', 'temperatura', 862.0000, 'ºC'),
	(93353, 112, '2015-03-01 01:07:27.000000', 'temperatura', 361.0000, 'ºC'),
	(93354, 112, '2015-03-01 01:07:28.000000', 'temperatura', 417.0000, 'ºC'),
	(93355, 112, '2015-03-01 01:07:29.000000', 'temperatura', 1002.0000, 'ºC'),
	(93356, 112, '2015-03-01 01:07:30.000000', 'temperatura', 162.0000, 'ºC'),
	(93357, 112, '2015-03-01 01:07:31.000000', 'temperatura', 205.0000, 'ºC'),
	(93358, 112, '2015-03-01 01:07:32.000000', 'temperatura', 537.0000, 'ºC'),
	(93359, 112, '2015-03-01 01:07:33.000000', 'temperatura', 873.0000, 'ºC'),
	(93360, 112, '2015-03-01 01:07:34.000000', 'temperatura', 351.0000, 'ºC'),
	(93361, 112, '2015-03-01 01:07:35.000000', 'temperatura', 340.0000, 'ºC'),
	(93362, 112, '2015-03-01 01:07:36.000000', 'temperatura', 647.0000, 'ºC'),
	(93363, 112, '2015-03-01 01:07:37.000000', 'temperatura', 1016.0000, 'ºC'),
	(93364, 112, '2015-03-01 01:07:38.000000', 'temperatura', 738.0000, 'ºC'),
	(93365, 112, '2015-03-01 01:07:39.000000', 'temperatura', 641.0000, 'ºC'),
	(93366, 112, '2015-03-01 01:07:40.000000', 'temperatura', 993.0000, 'ºC'),
	(93367, 112, '2015-03-01 01:07:41.000000', 'temperatura', 642.0000, 'ºC'),
	(93368, 112, '2015-03-01 01:07:42.000000', 'temperatura', 232.0000, 'ºC'),
	(93369, 112, '2015-03-01 01:07:43.000000', 'temperatura', 436.0000, 'ºC'),
	(93370, 112, '2015-03-01 01:07:44.000000', 'temperatura', 282.0000, 'ºC'),
	(93371, 112, '2015-03-01 01:07:45.000000', 'temperatura', 105.0000, 'ºC'),
	(93372, 112, '2015-03-01 01:07:46.000000', 'temperatura', 877.0000, 'ºC'),
	(93373, 112, '2015-03-01 01:07:47.000000', 'temperatura', 472.0000, 'ºC'),
	(93374, 112, '2015-03-01 01:07:48.000000', 'temperatura', 930.0000, 'ºC'),
	(93375, 112, '2015-03-01 01:07:49.000000', 'temperatura', 832.0000, 'ºC'),
	(93376, 112, '2015-03-01 01:07:50.000000', 'temperatura', 171.0000, 'ºC'),
	(93377, 112, '2015-03-01 01:07:51.000000', 'temperatura', 760.0000, 'ºC'),
	(93378, 112, '2015-03-01 01:07:52.000000', 'temperatura', 886.0000, 'ºC'),
	(93379, 112, '2015-03-01 01:07:53.000000', 'temperatura', 954.0000, 'ºC'),
	(93380, 112, '2015-03-01 01:07:54.000000', 'temperatura', 909.0000, 'ºC'),
	(93381, 112, '2015-03-01 01:07:55.000000', 'temperatura', 486.0000, 'ºC'),
	(93382, 112, '2015-03-01 01:07:56.000000', 'temperatura', 904.0000, 'ºC'),
	(93383, 112, '2015-03-01 01:07:57.000000', 'temperatura', 660.0000, 'ºC'),
	(93384, 112, '2015-03-01 01:07:58.000000', 'temperatura', 591.0000, 'ºC'),
	(93385, 112, '2015-03-01 01:07:59.000000', 'temperatura', 975.0000, 'ºC'),
	(93386, 112, '2015-03-01 01:08:00.000000', 'temperatura', 702.0000, 'ºC'),
	(93387, 112, '2015-03-01 01:08:01.000000', 'temperatura', 584.0000, 'ºC'),
	(93388, 112, '2015-03-01 01:08:02.000000', 'temperatura', 816.0000, 'ºC'),
	(93389, 112, '2015-03-01 01:08:03.000000', 'temperatura', 1130.0000, 'ºC'),
	(93390, 112, '2015-03-01 01:08:04.000000', 'temperatura', 801.0000, 'ºC'),
	(93391, 112, '2015-03-01 01:08:05.000000', 'temperatura', 614.0000, 'ºC'),
	(93392, 112, '2015-03-01 01:08:06.000000', 'temperatura', 669.0000, 'ºC'),
	(93393, 112, '2015-03-01 01:08:07.000000', 'temperatura', 302.0000, 'ºC'),
	(93394, 112, '2015-03-01 01:08:08.000000', 'temperatura', 704.0000, 'ºC'),
	(93395, 112, '2015-03-01 01:08:09.000000', 'temperatura', 216.0000, 'ºC'),
	(93396, 112, '2015-03-01 01:08:10.000000', 'temperatura', 168.0000, 'ºC'),
	(93397, 112, '2015-03-01 01:08:11.000000', 'temperatura', 191.0000, 'ºC'),
	(93398, 112, '2015-03-01 01:08:12.000000', 'temperatura', 453.0000, 'ºC'),
	(93399, 112, '2015-03-01 01:08:13.000000', 'temperatura', 494.0000, 'ºC'),
	(93400, 112, '2015-03-01 01:08:14.000000', 'temperatura', 1109.0000, 'ºC'),
	(93401, 112, '2015-03-01 01:08:15.000000', 'temperatura', 464.0000, 'ºC'),
	(93402, 112, '2015-03-01 01:08:16.000000', 'temperatura', 195.0000, 'ºC'),
	(93403, 112, '2015-03-01 01:08:17.000000', 'temperatura', 784.0000, 'ºC'),
	(93404, 112, '2015-03-01 01:08:18.000000', 'temperatura', 934.0000, 'ºC'),
	(93405, 112, '2015-03-01 01:08:19.000000', 'temperatura', 1119.0000, 'ºC'),
	(93406, 112, '2015-03-01 01:08:20.000000', 'temperatura', 391.0000, 'ºC'),
	(93407, 112, '2015-03-01 01:08:21.000000', 'temperatura', 1002.0000, 'ºC'),
	(93408, 112, '2015-03-01 01:08:22.000000', 'temperatura', 237.0000, 'ºC'),
	(93409, 112, '2015-03-01 01:08:23.000000', 'temperatura', 577.0000, 'ºC'),
	(93410, 112, '2015-03-01 01:08:24.000000', 'temperatura', 975.0000, 'ºC'),
	(93411, 112, '2015-03-01 01:08:25.000000', 'temperatura', 746.0000, 'ºC'),
	(93412, 112, '2015-03-01 01:08:26.000000', 'temperatura', 803.0000, 'ºC'),
	(93413, 112, '2015-03-01 01:08:27.000000', 'temperatura', 578.0000, 'ºC'),
	(93414, 112, '2015-03-01 01:08:28.000000', 'temperatura', 483.0000, 'ºC'),
	(93415, 112, '2015-03-01 01:08:29.000000', 'temperatura', 680.0000, 'ºC'),
	(93416, 112, '2015-03-01 01:08:30.000000', 'temperatura', 750.0000, 'ºC'),
	(93417, 112, '2015-03-01 01:08:31.000000', 'temperatura', 513.0000, 'ºC'),
	(93418, 112, '2015-03-01 01:08:32.000000', 'temperatura', 316.0000, 'ºC'),
	(93419, 112, '2015-03-01 01:08:33.000000', 'temperatura', 39.0000, 'ºC'),
	(93420, 112, '2015-03-01 01:08:34.000000', 'temperatura', 449.0000, 'ºC'),
	(93421, 112, '2015-03-01 01:08:35.000000', 'temperatura', 929.0000, 'ºC'),
	(93422, 112, '2015-03-01 01:08:36.000000', 'temperatura', 899.0000, 'ºC'),
	(93423, 112, '2015-03-01 01:08:37.000000', 'temperatura', 506.0000, 'ºC'),
	(93424, 112, '2015-03-01 01:08:38.000000', 'temperatura', 1034.0000, 'ºC'),
	(93425, 112, '2015-03-01 01:08:39.000000', 'temperatura', 54.0000, 'ºC'),
	(93426, 112, '2015-03-01 01:08:40.000000', 'temperatura', 770.0000, 'ºC'),
	(93427, 112, '2015-03-01 01:08:41.000000', 'temperatura', 85.0000, 'ºC'),
	(93428, 112, '2015-03-01 01:08:42.000000', 'temperatura', 518.0000, 'ºC'),
	(93429, 112, '2015-03-01 01:08:43.000000', 'temperatura', 1133.0000, 'ºC'),
	(93430, 112, '2015-03-01 01:08:44.000000', 'temperatura', 514.0000, 'ºC'),
	(93431, 112, '2015-03-01 01:08:45.000000', 'temperatura', 371.0000, 'ºC'),
	(93432, 112, '2015-03-01 01:08:46.000000', 'temperatura', 312.0000, 'ºC'),
	(93433, 112, '2015-03-01 01:08:47.000000', 'temperatura', 448.0000, 'ºC'),
	(93434, 112, '2015-03-01 01:08:48.000000', 'temperatura', 105.0000, 'ºC'),
	(93435, 112, '2015-03-01 01:08:49.000000', 'temperatura', 383.0000, 'ºC'),
	(93436, 112, '2015-03-01 01:08:50.000000', 'temperatura', 399.0000, 'ºC'),
	(93437, 112, '2015-03-01 01:08:51.000000', 'temperatura', 848.0000, 'ºC'),
	(93438, 112, '2015-03-01 01:08:52.000000', 'temperatura', 645.0000, 'ºC'),
	(93439, 112, '2015-03-01 01:08:53.000000', 'temperatura', 678.0000, 'ºC'),
	(93440, 112, '2015-03-01 01:08:54.000000', 'temperatura', 258.0000, 'ºC'),
	(93441, 112, '2015-03-01 01:08:55.000000', 'temperatura', 456.0000, 'ºC'),
	(93442, 112, '2015-03-01 01:08:56.000000', 'temperatura', 304.0000, 'ºC'),
	(93443, 112, '2015-03-01 01:08:57.000000', 'temperatura', 156.0000, 'ºC'),
	(93444, 112, '2015-03-01 01:08:58.000000', 'temperatura', 1067.0000, 'ºC'),
	(93445, 112, '2015-03-01 01:08:59.000000', 'temperatura', 66.0000, 'ºC'),
	(93446, 112, '2015-03-01 01:09:00.000000', 'temperatura', 729.0000, 'ºC'),
	(93447, 112, '2015-03-01 01:09:01.000000', 'temperatura', 1048.0000, 'ºC'),
	(93448, 112, '2015-03-01 01:09:02.000000', 'temperatura', 652.0000, 'ºC'),
	(93449, 112, '2015-03-01 01:09:03.000000', 'temperatura', 118.0000, 'ºC'),
	(93450, 112, '2015-03-01 01:09:04.000000', 'temperatura', 1034.0000, 'ºC'),
	(93451, 112, '2015-03-01 01:09:05.000000', 'temperatura', 15.0000, 'ºC'),
	(93452, 112, '2015-03-01 01:09:06.000000', 'temperatura', 575.0000, 'ºC'),
	(93453, 112, '2015-03-01 01:09:07.000000', 'temperatura', 432.0000, 'ºC'),
	(93454, 112, '2015-03-01 01:09:08.000000', 'temperatura', 435.0000, 'ºC'),
	(93455, 112, '2015-03-01 01:09:09.000000', 'temperatura', 881.0000, 'ºC'),
	(93456, 112, '2015-03-01 01:09:10.000000', 'temperatura', 699.0000, 'ºC'),
	(93457, 112, '2015-03-01 01:09:11.000000', 'temperatura', 853.0000, 'ºC'),
	(93458, 112, '2015-03-01 01:09:12.000000', 'temperatura', 969.0000, 'ºC'),
	(93459, 112, '2015-03-01 01:09:13.000000', 'temperatura', 1087.0000, 'ºC'),
	(93460, 112, '2015-03-01 01:09:14.000000', 'temperatura', 128.0000, 'ºC'),
	(93461, 112, '2015-03-01 01:09:15.000000', 'temperatura', 979.0000, 'ºC'),
	(93462, 112, '2015-03-01 01:09:16.000000', 'temperatura', 910.0000, 'ºC'),
	(93463, 112, '2015-03-01 01:09:17.000000', 'temperatura', 416.0000, 'ºC'),
	(93464, 112, '2015-03-01 01:09:18.000000', 'temperatura', 551.0000, 'ºC'),
	(93465, 112, '2015-03-01 01:09:19.000000', 'temperatura', 307.0000, 'ºC'),
	(93466, 112, '2015-03-01 01:09:20.000000', 'temperatura', 1084.0000, 'ºC'),
	(93467, 112, '2015-03-01 01:09:21.000000', 'temperatura', 899.0000, 'ºC'),
	(93468, 112, '2015-03-01 01:09:22.000000', 'temperatura', 43.0000, 'ºC'),
	(93469, 112, '2015-03-01 01:09:23.000000', 'temperatura', 1120.0000, 'ºC'),
	(93470, 112, '2015-03-01 01:09:24.000000', 'temperatura', 669.0000, 'ºC'),
	(93471, 112, '2015-03-01 01:09:25.000000', 'temperatura', 1186.0000, 'ºC'),
	(93472, 112, '2015-03-01 01:09:26.000000', 'temperatura', 322.0000, 'ºC'),
	(93473, 112, '2015-03-01 01:09:27.000000', 'temperatura', 456.0000, 'ºC'),
	(93474, 112, '2015-03-01 01:09:28.000000', 'temperatura', 112.0000, 'ºC'),
	(93475, 112, '2015-03-01 01:09:29.000000', 'temperatura', 394.0000, 'ºC'),
	(93476, 112, '2015-03-01 01:09:30.000000', 'temperatura', 433.0000, 'ºC'),
	(93477, 112, '2015-03-01 01:09:31.000000', 'temperatura', 986.0000, 'ºC'),
	(93478, 112, '2015-03-01 01:09:32.000000', 'temperatura', 28.0000, 'ºC'),
	(93479, 112, '2015-03-01 01:09:33.000000', 'temperatura', 786.0000, 'ºC'),
	(93480, 112, '2015-03-01 01:09:34.000000', 'temperatura', 243.0000, 'ºC'),
	(93481, 112, '2015-03-01 01:09:35.000000', 'temperatura', 59.0000, 'ºC'),
	(93482, 112, '2015-03-01 01:09:36.000000', 'temperatura', 767.0000, 'ºC'),
	(93483, 112, '2015-03-01 01:09:37.000000', 'temperatura', 60.0000, 'ºC'),
	(93484, 112, '2015-03-01 01:09:38.000000', 'temperatura', 396.0000, 'ºC'),
	(93485, 112, '2015-03-01 01:09:39.000000', 'temperatura', 604.0000, 'ºC'),
	(93486, 112, '2015-03-01 01:09:40.000000', 'temperatura', 631.0000, 'ºC'),
	(93487, 112, '2015-03-01 01:09:41.000000', 'temperatura', 143.0000, 'ºC'),
	(93488, 112, '2015-03-01 01:09:42.000000', 'temperatura', 21.0000, 'ºC'),
	(93489, 112, '2015-03-01 01:09:43.000000', 'temperatura', 879.0000, 'ºC'),
	(93490, 112, '2015-03-01 01:09:44.000000', 'temperatura', 731.0000, 'ºC'),
	(93491, 112, '2015-03-01 01:09:45.000000', 'temperatura', 1017.0000, 'ºC'),
	(93492, 112, '2015-03-01 01:09:46.000000', 'temperatura', 495.0000, 'ºC'),
	(93493, 112, '2015-03-01 01:09:47.000000', 'temperatura', 624.0000, 'ºC'),
	(93494, 112, '2015-03-01 01:09:48.000000', 'temperatura', 436.0000, 'ºC'),
	(93495, 112, '2015-03-01 01:09:49.000000', 'temperatura', 308.0000, 'ºC'),
	(93496, 112, '2015-03-01 01:09:50.000000', 'temperatura', 233.0000, 'ºC'),
	(93497, 112, '2015-03-01 01:09:51.000000', 'temperatura', 239.0000, 'ºC'),
	(93498, 112, '2015-03-01 01:09:52.000000', 'temperatura', 499.0000, 'ºC'),
	(93499, 112, '2015-03-01 01:09:53.000000', 'temperatura', 578.0000, 'ºC'),
	(93500, 112, '2015-03-01 01:09:54.000000', 'temperatura', 194.0000, 'ºC'),
	(93501, 112, '2015-03-01 01:09:55.000000', 'temperatura', 436.0000, 'ºC'),
	(93502, 112, '2015-03-01 01:09:56.000000', 'temperatura', 400.0000, 'ºC'),
	(93503, 112, '2015-03-01 01:09:57.000000', 'temperatura', 693.0000, 'ºC'),
	(93504, 112, '2015-03-01 01:09:58.000000', 'temperatura', 1064.0000, 'ºC'),
	(93505, 112, '2015-03-01 01:09:59.000000', 'temperatura', 842.0000, 'ºC'),
	(93506, 112, '2015-03-01 01:10:00.000000', 'temperatura', 1017.0000, 'ºC'),
	(93507, 112, '2015-03-01 01:10:01.000000', 'temperatura', 160.0000, 'ºC'),
	(93508, 112, '2015-03-01 01:10:02.000000', 'temperatura', 151.0000, 'ºC'),
	(93509, 112, '2015-03-01 01:10:03.000000', 'temperatura', 275.0000, 'ºC'),
	(93510, 112, '2015-03-01 01:10:04.000000', 'temperatura', 921.0000, 'ºC'),
	(93511, 112, '2015-03-01 01:10:05.000000', 'temperatura', 183.0000, 'ºC'),
	(93512, 112, '2015-03-01 01:10:06.000000', 'temperatura', 552.0000, 'ºC'),
	(93513, 112, '2015-03-01 01:10:07.000000', 'temperatura', 1011.0000, 'ºC'),
	(93514, 112, '2015-03-01 01:10:08.000000', 'temperatura', 999.0000, 'ºC'),
	(93515, 112, '2015-03-01 01:10:09.000000', 'temperatura', 761.0000, 'ºC'),
	(93516, 112, '2015-03-01 01:10:10.000000', 'temperatura', 810.0000, 'ºC'),
	(93517, 112, '2015-03-01 01:10:11.000000', 'temperatura', 569.0000, 'ºC'),
	(93518, 112, '2015-03-01 01:10:12.000000', 'temperatura', 415.0000, 'ºC'),
	(93519, 112, '2015-03-01 01:10:13.000000', 'temperatura', 369.0000, 'ºC'),
	(93520, 112, '2015-03-01 01:10:14.000000', 'temperatura', 602.0000, 'ºC'),
	(93521, 112, '2015-03-01 01:10:15.000000', 'temperatura', 702.0000, 'ºC'),
	(93522, 112, '2015-03-01 01:10:16.000000', 'temperatura', 503.0000, 'ºC'),
	(93523, 112, '2015-03-01 01:10:17.000000', 'temperatura', 409.0000, 'ºC'),
	(93524, 112, '2015-03-01 01:10:18.000000', 'temperatura', 536.0000, 'ºC'),
	(93525, 112, '2015-03-01 01:10:19.000000', 'temperatura', 257.0000, 'ºC'),
	(93526, 112, '2015-03-01 01:10:20.000000', 'temperatura', 874.0000, 'ºC'),
	(93527, 112, '2015-03-01 01:10:21.000000', 'temperatura', 3.0000, 'ºC'),
	(93528, 112, '2015-03-01 01:10:22.000000', 'temperatura', 990.0000, 'ºC'),
	(93529, 112, '2015-03-01 01:10:23.000000', 'temperatura', 143.0000, 'ºC'),
	(93530, 112, '2015-03-01 01:10:24.000000', 'temperatura', 146.0000, 'ºC'),
	(93531, 112, '2015-03-01 01:10:25.000000', 'temperatura', 302.0000, 'ºC'),
	(93532, 112, '2015-03-01 01:10:26.000000', 'temperatura', 1070.0000, 'ºC'),
	(93533, 112, '2015-03-01 01:10:27.000000', 'temperatura', 847.0000, 'ºC'),
	(93534, 112, '2015-03-01 01:10:28.000000', 'temperatura', 1025.0000, 'ºC'),
	(93535, 112, '2015-03-01 01:10:29.000000', 'temperatura', 184.0000, 'ºC'),
	(93536, 112, '2015-03-01 01:10:30.000000', 'temperatura', 246.0000, 'ºC'),
	(93537, 112, '2015-03-01 01:10:31.000000', 'temperatura', 680.0000, 'ºC'),
	(93538, 112, '2015-03-01 01:10:32.000000', 'temperatura', 260.0000, 'ºC'),
	(93539, 112, '2015-03-01 01:10:33.000000', 'temperatura', 460.0000, 'ºC'),
	(93540, 112, '2015-03-01 01:10:34.000000', 'temperatura', 321.0000, 'ºC'),
	(93541, 112, '2015-03-01 01:10:35.000000', 'temperatura', 227.0000, 'ºC'),
	(93542, 112, '2015-03-01 01:10:36.000000', 'temperatura', 173.0000, 'ºC'),
	(93543, 112, '2015-03-01 01:10:37.000000', 'temperatura', 182.0000, 'ºC'),
	(93544, 112, '2015-03-01 01:10:38.000000', 'temperatura', 391.0000, 'ºC'),
	(93545, 112, '2015-03-01 01:10:39.000000', 'temperatura', 210.0000, 'ºC'),
	(93546, 112, '2015-03-01 01:10:40.000000', 'temperatura', 1076.0000, 'ºC'),
	(93547, 112, '2015-03-01 01:10:41.000000', 'temperatura', 1151.0000, 'ºC'),
	(93548, 112, '2015-03-01 01:10:42.000000', 'temperatura', 129.0000, 'ºC'),
	(93549, 112, '2015-03-01 01:10:43.000000', 'temperatura', 792.0000, 'ºC'),
	(93550, 112, '2015-03-01 01:10:44.000000', 'temperatura', 1173.0000, 'ºC'),
	(93551, 112, '2015-03-01 01:10:45.000000', 'temperatura', 1089.0000, 'ºC'),
	(93552, 112, '2015-03-01 01:10:46.000000', 'temperatura', 727.0000, 'ºC'),
	(93553, 112, '2015-03-01 01:10:47.000000', 'temperatura', 370.0000, 'ºC'),
	(93554, 112, '2015-03-01 01:10:48.000000', 'temperatura', 868.0000, 'ºC'),
	(93555, 112, '2015-03-01 01:10:49.000000', 'temperatura', 830.0000, 'ºC'),
	(93556, 112, '2015-03-01 01:10:50.000000', 'temperatura', 347.0000, 'ºC'),
	(93557, 112, '2015-03-01 01:10:51.000000', 'temperatura', 445.0000, 'ºC'),
	(93558, 112, '2015-03-01 01:10:52.000000', 'temperatura', 1183.0000, 'ºC'),
	(93559, 112, '2015-03-01 01:10:53.000000', 'temperatura', 983.0000, 'ºC'),
	(93560, 112, '2015-03-01 01:10:54.000000', 'temperatura', 165.0000, 'ºC'),
	(93561, 112, '2015-03-01 01:10:55.000000', 'temperatura', 277.0000, 'ºC'),
	(93562, 112, '2015-03-01 01:10:56.000000', 'temperatura', 890.0000, 'ºC'),
	(93563, 112, '2015-03-01 01:10:57.000000', 'temperatura', 22.0000, 'ºC'),
	(93564, 112, '2015-03-01 01:10:58.000000', 'temperatura', 1037.0000, 'ºC'),
	(93565, 112, '2015-03-01 01:10:59.000000', 'temperatura', 321.0000, 'ºC'),
	(93566, 112, '2015-03-01 01:11:00.000000', 'temperatura', 895.0000, 'ºC'),
	(93567, 112, '2015-03-01 01:11:01.000000', 'temperatura', 1112.0000, 'ºC'),
	(93568, 112, '2015-03-01 01:11:02.000000', 'temperatura', 476.0000, 'ºC'),
	(93569, 112, '2015-03-01 01:11:03.000000', 'temperatura', 243.0000, 'ºC'),
	(93570, 112, '2015-03-01 01:11:04.000000', 'temperatura', 990.0000, 'ºC'),
	(93571, 112, '2015-03-01 01:11:05.000000', 'temperatura', 621.0000, 'ºC'),
	(93572, 112, '2015-03-01 01:11:06.000000', 'temperatura', 135.0000, 'ºC'),
	(93573, 112, '2015-03-01 01:11:07.000000', 'temperatura', 13.0000, 'ºC'),
	(93574, 112, '2015-03-01 01:11:08.000000', 'temperatura', 859.0000, 'ºC'),
	(93575, 112, '2015-03-01 01:11:09.000000', 'temperatura', 659.0000, 'ºC'),
	(93576, 112, '2015-03-01 01:11:10.000000', 'temperatura', 716.0000, 'ºC'),
	(93577, 112, '2015-03-01 01:11:11.000000', 'temperatura', 403.0000, 'ºC'),
	(93578, 112, '2015-03-01 01:11:12.000000', 'temperatura', 1068.0000, 'ºC'),
	(93579, 112, '2015-03-01 01:11:13.000000', 'temperatura', 534.0000, 'ºC'),
	(93580, 112, '2015-03-01 01:11:14.000000', 'temperatura', 664.0000, 'ºC'),
	(93581, 112, '2015-03-01 01:11:15.000000', 'temperatura', 520.0000, 'ºC'),
	(93582, 112, '2015-03-01 01:11:16.000000', 'temperatura', 609.0000, 'ºC'),
	(93583, 112, '2015-03-01 01:11:17.000000', 'temperatura', 284.0000, 'ºC'),
	(93584, 112, '2015-03-01 01:11:18.000000', 'temperatura', 792.0000, 'ºC'),
	(93585, 112, '2015-03-01 01:11:19.000000', 'temperatura', 711.0000, 'ºC'),
	(93586, 112, '2015-03-01 01:11:20.000000', 'temperatura', 1178.0000, 'ºC'),
	(93587, 112, '2015-03-01 01:11:21.000000', 'temperatura', 157.0000, 'ºC'),
	(93588, 112, '2015-03-01 01:11:22.000000', 'temperatura', 853.0000, 'ºC'),
	(93589, 112, '2015-03-01 01:11:23.000000', 'temperatura', 196.0000, 'ºC'),
	(93590, 112, '2015-03-01 01:11:24.000000', 'temperatura', 818.0000, 'ºC'),
	(93591, 112, '2015-03-01 01:11:25.000000', 'temperatura', 1104.0000, 'ºC'),
	(93592, 112, '2015-03-01 01:11:26.000000', 'temperatura', 668.0000, 'ºC'),
	(93593, 112, '2015-03-01 01:11:27.000000', 'temperatura', 29.0000, 'ºC'),
	(93594, 112, '2015-03-01 01:11:28.000000', 'temperatura', 542.0000, 'ºC'),
	(93595, 112, '2015-03-01 01:11:29.000000', 'temperatura', 222.0000, 'ºC'),
	(93596, 112, '2015-03-01 01:11:30.000000', 'temperatura', 687.0000, 'ºC'),
	(93597, 112, '2015-03-01 01:11:31.000000', 'temperatura', 366.0000, 'ºC'),
	(93598, 112, '2015-03-01 01:11:32.000000', 'temperatura', 973.0000, 'ºC'),
	(93599, 112, '2015-03-01 01:11:33.000000', 'temperatura', 164.0000, 'ºC'),
	(93600, 112, '2015-03-01 01:11:34.000000', 'temperatura', 303.0000, 'ºC'),
	(93601, 112, '2015-03-01 01:11:35.000000', 'temperatura', 1024.0000, 'ºC'),
	(93602, 112, '2015-03-01 01:11:36.000000', 'temperatura', 610.0000, 'ºC'),
	(93603, 112, '2015-03-01 01:11:37.000000', 'temperatura', 1181.0000, 'ºC'),
	(93604, 112, '2015-03-01 01:11:38.000000', 'temperatura', 475.0000, 'ºC'),
	(93605, 112, '2015-03-01 01:11:39.000000', 'temperatura', 32.0000, 'ºC'),
	(93606, 112, '2015-03-01 01:11:40.000000', 'temperatura', 1135.0000, 'ºC'),
	(93607, 112, '2015-03-01 01:11:41.000000', 'temperatura', 778.0000, 'ºC'),
	(93608, 112, '2015-03-01 01:11:42.000000', 'temperatura', 486.0000, 'ºC'),
	(93609, 112, '2015-03-01 01:11:43.000000', 'temperatura', 97.0000, 'ºC'),
	(93610, 112, '2015-03-01 01:11:44.000000', 'temperatura', 229.0000, 'ºC'),
	(93611, 112, '2015-03-01 01:11:45.000000', 'temperatura', 855.0000, 'ºC'),
	(93612, 112, '2015-03-01 01:11:46.000000', 'temperatura', 1189.0000, 'ºC'),
	(93613, 112, '2015-03-01 01:11:47.000000', 'temperatura', 978.0000, 'ºC'),
	(93614, 112, '2015-03-01 01:11:48.000000', 'temperatura', 126.0000, 'ºC'),
	(93615, 112, '2015-03-01 01:11:49.000000', 'temperatura', 94.0000, 'ºC'),
	(93616, 112, '2015-03-01 01:11:50.000000', 'temperatura', 93.0000, 'ºC'),
	(93617, 112, '2015-03-01 01:11:51.000000', 'temperatura', 184.0000, 'ºC'),
	(93618, 112, '2015-03-01 01:11:52.000000', 'temperatura', 640.0000, 'ºC'),
	(93619, 112, '2015-03-01 01:11:53.000000', 'temperatura', 250.0000, 'ºC'),
	(93620, 112, '2015-03-01 01:11:54.000000', 'temperatura', 530.0000, 'ºC'),
	(93621, 112, '2015-03-01 01:11:55.000000', 'temperatura', 702.0000, 'ºC'),
	(93622, 112, '2015-03-01 01:11:56.000000', 'temperatura', 720.0000, 'ºC'),
	(93623, 112, '2015-03-01 01:11:57.000000', 'temperatura', 294.0000, 'ºC'),
	(93624, 112, '2015-03-01 01:11:58.000000', 'temperatura', 511.0000, 'ºC'),
	(93625, 112, '2015-03-01 01:11:59.000000', 'temperatura', 474.0000, 'ºC'),
	(93626, 112, '2015-03-01 01:12:00.000000', 'temperatura', 839.0000, 'ºC'),
	(93627, 112, '2015-03-01 01:12:01.000000', 'temperatura', 371.0000, 'ºC'),
	(93628, 112, '2015-03-01 01:12:02.000000', 'temperatura', 540.0000, 'ºC'),
	(93629, 112, '2015-03-01 01:12:03.000000', 'temperatura', 389.0000, 'ºC'),
	(93630, 112, '2015-03-01 01:12:04.000000', 'temperatura', 323.0000, 'ºC'),
	(93631, 112, '2015-03-01 01:12:05.000000', 'temperatura', 449.0000, 'ºC'),
	(93632, 112, '2015-03-01 01:12:06.000000', 'temperatura', 75.0000, 'ºC'),
	(93633, 112, '2015-03-01 01:12:07.000000', 'temperatura', 229.0000, 'ºC'),
	(93634, 112, '2015-03-01 01:12:08.000000', 'temperatura', 922.0000, 'ºC'),
	(93635, 112, '2015-03-01 01:12:09.000000', 'temperatura', 323.0000, 'ºC'),
	(93636, 112, '2015-03-01 01:12:10.000000', 'temperatura', 50.0000, 'ºC'),
	(93637, 112, '2015-03-01 01:12:11.000000', 'temperatura', 480.0000, 'ºC'),
	(93638, 112, '2015-03-01 01:12:12.000000', 'temperatura', 1051.0000, 'ºC'),
	(93639, 112, '2015-03-01 01:12:13.000000', 'temperatura', 214.0000, 'ºC'),
	(93640, 112, '2015-03-01 01:12:14.000000', 'temperatura', 318.0000, 'ºC'),
	(93641, 112, '2015-03-01 01:12:15.000000', 'temperatura', 949.0000, 'ºC'),
	(93642, 112, '2015-03-01 01:12:16.000000', 'temperatura', 192.0000, 'ºC'),
	(93643, 112, '2015-03-01 01:12:17.000000', 'temperatura', 511.0000, 'ºC'),
	(93644, 112, '2015-03-01 01:12:18.000000', 'temperatura', 782.0000, 'ºC'),
	(93645, 112, '2015-03-01 01:12:19.000000', 'temperatura', 1176.0000, 'ºC'),
	(93646, 112, '2015-03-01 01:12:20.000000', 'temperatura', 1135.0000, 'ºC'),
	(93647, 112, '2015-03-01 01:12:21.000000', 'temperatura', 948.0000, 'ºC'),
	(93648, 112, '2015-03-01 01:12:22.000000', 'temperatura', 135.0000, 'ºC'),
	(93649, 112, '2015-03-01 01:12:23.000000', 'temperatura', 233.0000, 'ºC'),
	(93650, 112, '2015-03-01 01:12:24.000000', 'temperatura', 761.0000, 'ºC'),
	(93651, 112, '2015-03-01 01:12:25.000000', 'temperatura', 707.0000, 'ºC'),
	(93652, 112, '2015-03-01 01:12:26.000000', 'temperatura', 53.0000, 'ºC'),
	(93653, 112, '2015-03-01 01:12:27.000000', 'temperatura', 542.0000, 'ºC'),
	(93654, 112, '2015-03-01 01:12:28.000000', 'temperatura', 153.0000, 'ºC'),
	(93655, 112, '2015-03-01 01:12:29.000000', 'temperatura', 340.0000, 'ºC'),
	(93656, 112, '2015-03-01 01:12:30.000000', 'temperatura', 39.0000, 'ºC'),
	(93657, 112, '2015-03-01 01:12:31.000000', 'temperatura', 376.0000, 'ºC'),
	(93658, 112, '2015-03-01 01:12:32.000000', 'temperatura', 566.0000, 'ºC'),
	(93659, 112, '2015-03-01 01:12:33.000000', 'temperatura', 501.0000, 'ºC'),
	(93660, 112, '2015-03-01 01:12:34.000000', 'temperatura', 810.0000, 'ºC'),
	(93661, 112, '2015-03-01 01:12:35.000000', 'temperatura', 145.0000, 'ºC'),
	(93662, 112, '2015-03-01 01:12:36.000000', 'temperatura', 694.0000, 'ºC'),
	(93663, 112, '2015-03-01 01:12:37.000000', 'temperatura', 639.0000, 'ºC'),
	(93664, 112, '2015-03-01 01:12:38.000000', 'temperatura', 1111.0000, 'ºC'),
	(93665, 112, '2015-03-01 01:12:39.000000', 'temperatura', 41.0000, 'ºC'),
	(93666, 112, '2015-03-01 01:12:40.000000', 'temperatura', 470.0000, 'ºC'),
	(93667, 112, '2015-03-01 01:12:41.000000', 'temperatura', 1028.0000, 'ºC'),
	(93668, 112, '2015-03-01 01:12:42.000000', 'temperatura', 133.0000, 'ºC'),
	(93669, 112, '2015-03-01 01:12:43.000000', 'temperatura', 1179.0000, 'ºC'),
	(93670, 112, '2015-03-01 01:12:44.000000', 'temperatura', 699.0000, 'ºC'),
	(93671, 112, '2015-03-01 01:12:45.000000', 'temperatura', 1156.0000, 'ºC'),
	(93672, 112, '2015-03-01 01:12:46.000000', 'temperatura', 84.0000, 'ºC'),
	(93673, 112, '2015-03-01 01:12:47.000000', 'temperatura', 552.0000, 'ºC'),
	(93674, 112, '2015-03-01 01:12:48.000000', 'temperatura', 110.0000, 'ºC'),
	(93675, 112, '2015-03-01 01:12:49.000000', 'temperatura', 94.0000, 'ºC'),
	(93676, 112, '2015-03-01 01:12:50.000000', 'temperatura', 138.0000, 'ºC'),
	(93677, 112, '2015-03-01 01:12:51.000000', 'temperatura', 412.0000, 'ºC'),
	(93678, 112, '2015-03-01 01:12:52.000000', 'temperatura', 446.0000, 'ºC'),
	(93679, 112, '2015-03-01 01:12:53.000000', 'temperatura', 992.0000, 'ºC'),
	(93680, 112, '2015-03-01 01:12:54.000000', 'temperatura', 25.0000, 'ºC'),
	(93681, 112, '2015-03-01 01:12:55.000000', 'temperatura', 748.0000, 'ºC'),
	(93682, 112, '2015-03-01 01:12:56.000000', 'temperatura', 67.0000, 'ºC'),
	(93683, 112, '2015-03-01 01:12:57.000000', 'temperatura', 491.0000, 'ºC'),
	(93684, 112, '2015-03-01 01:12:58.000000', 'temperatura', 1055.0000, 'ºC'),
	(93685, 112, '2015-03-01 01:12:59.000000', 'temperatura', 201.0000, 'ºC'),
	(93686, 112, '2015-03-01 01:13:00.000000', 'temperatura', 242.0000, 'ºC'),
	(93687, 112, '2015-03-01 01:13:01.000000', 'temperatura', 608.0000, 'ºC'),
	(93688, 112, '2015-03-01 01:13:02.000000', 'temperatura', 1112.0000, 'ºC'),
	(93689, 112, '2015-03-01 01:13:03.000000', 'temperatura', 137.0000, 'ºC'),
	(93690, 112, '2015-03-01 01:13:04.000000', 'temperatura', 949.0000, 'ºC'),
	(93691, 112, '2015-03-01 01:13:05.000000', 'temperatura', 733.0000, 'ºC'),
	(93692, 112, '2015-03-01 01:13:06.000000', 'temperatura', 820.0000, 'ºC'),
	(93693, 112, '2015-03-01 01:13:07.000000', 'temperatura', 703.0000, 'ºC'),
	(93694, 112, '2015-03-01 01:13:08.000000', 'temperatura', 1056.0000, 'ºC'),
	(93695, 112, '2015-03-01 01:13:09.000000', 'temperatura', 770.0000, 'ºC'),
	(93696, 112, '2015-03-01 01:13:10.000000', 'temperatura', 682.0000, 'ºC'),
	(93697, 112, '2015-03-01 01:13:11.000000', 'temperatura', 1099.0000, 'ºC'),
	(93698, 112, '2015-03-01 01:13:12.000000', 'temperatura', 1052.0000, 'ºC'),
	(93699, 112, '2015-03-01 01:13:13.000000', 'temperatura', 763.0000, 'ºC'),
	(93700, 112, '2015-03-01 01:13:14.000000', 'temperatura', 661.0000, 'ºC'),
	(93701, 112, '2015-03-01 01:13:15.000000', 'temperatura', 1016.0000, 'ºC'),
	(93702, 112, '2015-03-01 01:13:16.000000', 'temperatura', 697.0000, 'ºC'),
	(93703, 112, '2015-03-01 01:13:17.000000', 'temperatura', 437.0000, 'ºC'),
	(93704, 112, '2015-03-01 01:13:18.000000', 'temperatura', 93.0000, 'ºC'),
	(93705, 112, '2015-03-01 01:13:19.000000', 'temperatura', 357.0000, 'ºC'),
	(93706, 112, '2015-03-01 01:13:20.000000', 'temperatura', 304.0000, 'ºC'),
	(93707, 112, '2015-03-01 01:13:21.000000', 'temperatura', 450.0000, 'ºC'),
	(93708, 112, '2015-03-01 01:13:22.000000', 'temperatura', 138.0000, 'ºC'),
	(93709, 112, '2015-03-01 01:13:23.000000', 'temperatura', 542.0000, 'ºC'),
	(93710, 112, '2015-03-01 01:13:24.000000', 'temperatura', 1095.0000, 'ºC'),
	(93711, 112, '2015-03-01 01:13:25.000000', 'temperatura', 249.0000, 'ºC'),
	(93712, 112, '2015-03-01 01:13:26.000000', 'temperatura', 362.0000, 'ºC'),
	(93713, 112, '2015-03-01 01:13:27.000000', 'temperatura', 1062.0000, 'ºC'),
	(93714, 112, '2015-03-01 01:13:28.000000', 'temperatura', 624.0000, 'ºC'),
	(93715, 112, '2015-03-01 01:13:29.000000', 'temperatura', 1134.0000, 'ºC'),
	(93716, 112, '2015-03-01 01:13:30.000000', 'temperatura', 199.0000, 'ºC'),
	(93717, 112, '2015-03-01 01:13:31.000000', 'temperatura', 1192.0000, 'ºC'),
	(93718, 112, '2015-03-01 01:13:32.000000', 'temperatura', 563.0000, 'ºC'),
	(93719, 112, '2015-03-01 01:13:33.000000', 'temperatura', 442.0000, 'ºC'),
	(93720, 112, '2015-03-01 01:13:34.000000', 'temperatura', 523.0000, 'ºC'),
	(93721, 112, '2015-03-01 01:13:35.000000', 'temperatura', 87.0000, 'ºC'),
	(93722, 112, '2015-03-01 01:13:36.000000', 'temperatura', 65.0000, 'ºC'),
	(93723, 112, '2015-03-01 01:13:37.000000', 'temperatura', 66.0000, 'ºC'),
	(93724, 112, '2015-03-01 01:13:38.000000', 'temperatura', 135.0000, 'ºC'),
	(93725, 112, '2015-03-01 01:13:39.000000', 'temperatura', 477.0000, 'ºC'),
	(93726, 112, '2015-03-01 01:13:40.000000', 'temperatura', 782.0000, 'ºC'),
	(93727, 112, '2015-03-01 01:13:41.000000', 'temperatura', 78.0000, 'ºC'),
	(93728, 112, '2015-03-01 01:13:42.000000', 'temperatura', 447.0000, 'ºC'),
	(93729, 112, '2015-03-01 01:13:43.000000', 'temperatura', 799.0000, 'ºC'),
	(93730, 112, '2015-03-01 01:13:44.000000', 'temperatura', 256.0000, 'ºC'),
	(93731, 112, '2015-03-01 01:13:45.000000', 'temperatura', 82.0000, 'ºC'),
	(93732, 112, '2015-03-01 01:13:46.000000', 'temperatura', 845.0000, 'ºC'),
	(93733, 112, '2015-03-01 01:13:47.000000', 'temperatura', 378.0000, 'ºC'),
	(93734, 112, '2015-03-01 01:13:48.000000', 'temperatura', 556.0000, 'ºC'),
	(93735, 112, '2015-03-01 01:13:49.000000', 'temperatura', 447.0000, 'ºC'),
	(93736, 112, '2015-03-01 01:13:50.000000', 'temperatura', 567.0000, 'ºC'),
	(93737, 112, '2015-03-01 01:13:51.000000', 'temperatura', 296.0000, 'ºC'),
	(93738, 112, '2015-03-01 01:13:52.000000', 'temperatura', 979.0000, 'ºC'),
	(93739, 112, '2015-03-01 01:13:53.000000', 'temperatura', 409.0000, 'ºC'),
	(93740, 112, '2015-03-01 01:13:54.000000', 'temperatura', 306.0000, 'ºC'),
	(93741, 112, '2015-03-01 01:13:55.000000', 'temperatura', 305.0000, 'ºC'),
	(93742, 112, '2015-03-01 01:13:56.000000', 'temperatura', 605.0000, 'ºC'),
	(93743, 112, '2015-03-01 01:13:57.000000', 'temperatura', 914.0000, 'ºC'),
	(93744, 112, '2015-03-01 01:13:58.000000', 'temperatura', 353.0000, 'ºC'),
	(93745, 112, '2015-03-01 01:13:59.000000', 'temperatura', 223.0000, 'ºC'),
	(93746, 112, '2015-03-01 01:14:00.000000', 'temperatura', 58.0000, 'ºC'),
	(93747, 112, '2015-03-01 01:14:01.000000', 'temperatura', 820.0000, 'ºC'),
	(93748, 112, '2015-03-01 01:14:02.000000', 'temperatura', 326.0000, 'ºC'),
	(93749, 112, '2015-03-01 01:14:03.000000', 'temperatura', 371.0000, 'ºC'),
	(93750, 112, '2015-03-01 01:14:04.000000', 'temperatura', 878.0000, 'ºC'),
	(93751, 112, '2015-03-01 01:14:05.000000', 'temperatura', 876.0000, 'ºC'),
	(93752, 112, '2015-03-01 01:14:06.000000', 'temperatura', 549.0000, 'ºC'),
	(93753, 112, '2015-03-01 01:14:07.000000', 'temperatura', 116.0000, 'ºC'),
	(93754, 112, '2015-03-01 01:14:08.000000', 'temperatura', 134.0000, 'ºC'),
	(93755, 112, '2015-03-01 01:14:09.000000', 'temperatura', 324.0000, 'ºC'),
	(93756, 112, '2015-03-01 01:14:10.000000', 'temperatura', 16.0000, 'ºC'),
	(93757, 112, '2015-03-01 01:14:11.000000', 'temperatura', 311.0000, 'ºC'),
	(93758, 112, '2015-03-01 01:14:12.000000', 'temperatura', 307.0000, 'ºC'),
	(93759, 112, '2015-03-01 01:14:13.000000', 'temperatura', 602.0000, 'ºC'),
	(93760, 112, '2015-03-01 01:14:14.000000', 'temperatura', 888.0000, 'ºC'),
	(93761, 112, '2015-03-01 01:14:15.000000', 'temperatura', 234.0000, 'ºC'),
	(93762, 112, '2015-03-01 01:14:16.000000', 'temperatura', 909.0000, 'ºC'),
	(93763, 112, '2015-03-01 01:14:17.000000', 'temperatura', 242.0000, 'ºC'),
	(93764, 112, '2015-03-01 01:14:18.000000', 'temperatura', 883.0000, 'ºC'),
	(93765, 112, '2015-03-01 01:14:19.000000', 'temperatura', 91.0000, 'ºC'),
	(93766, 112, '2015-03-01 01:14:20.000000', 'temperatura', 205.0000, 'ºC'),
	(93767, 112, '2015-03-01 01:14:21.000000', 'temperatura', 751.0000, 'ºC'),
	(93768, 112, '2015-03-01 01:14:22.000000', 'temperatura', 744.0000, 'ºC'),
	(93769, 112, '2015-03-01 01:14:23.000000', 'temperatura', 266.0000, 'ºC'),
	(93770, 112, '2015-03-01 01:14:24.000000', 'temperatura', 297.0000, 'ºC'),
	(93771, 112, '2015-03-01 01:14:25.000000', 'temperatura', 690.0000, 'ºC'),
	(93772, 112, '2015-03-01 01:14:26.000000', 'temperatura', 160.0000, 'ºC'),
	(93773, 112, '2015-03-01 01:14:27.000000', 'temperatura', 1129.0000, 'ºC'),
	(93774, 112, '2015-03-01 01:14:28.000000', 'temperatura', 367.0000, 'ºC'),
	(93775, 112, '2015-03-01 01:14:29.000000', 'temperatura', 848.0000, 'ºC'),
	(93776, 112, '2015-03-01 01:14:30.000000', 'temperatura', 741.0000, 'ºC'),
	(93777, 112, '2015-03-01 01:14:31.000000', 'temperatura', 1159.0000, 'ºC'),
	(93778, 112, '2015-03-01 01:14:32.000000', 'temperatura', 1172.0000, 'ºC'),
	(93779, 112, '2015-03-01 01:14:33.000000', 'temperatura', 1184.0000, 'ºC'),
	(93780, 112, '2015-03-01 01:14:34.000000', 'temperatura', 4.0000, 'ºC'),
	(93781, 112, '2015-03-01 01:14:35.000000', 'temperatura', 71.0000, 'ºC'),
	(93782, 112, '2015-03-01 01:14:36.000000', 'temperatura', 342.0000, 'ºC'),
	(93783, 112, '2015-03-01 01:14:37.000000', 'temperatura', 300.0000, 'ºC'),
	(93784, 112, '2015-03-01 01:14:38.000000', 'temperatura', 471.0000, 'ºC'),
	(93785, 112, '2015-03-01 01:14:39.000000', 'temperatura', 258.0000, 'ºC'),
	(93786, 112, '2015-03-01 01:14:40.000000', 'temperatura', 1077.0000, 'ºC'),
	(93787, 112, '2015-03-01 01:14:41.000000', 'temperatura', 1010.0000, 'ºC'),
	(93788, 112, '2015-03-01 01:14:42.000000', 'temperatura', 619.0000, 'ºC'),
	(93789, 112, '2015-03-01 01:14:43.000000', 'temperatura', 65.0000, 'ºC'),
	(93790, 112, '2015-03-01 01:14:44.000000', 'temperatura', 872.0000, 'ºC'),
	(93791, 112, '2015-03-01 01:14:45.000000', 'temperatura', 562.0000, 'ºC'),
	(93792, 112, '2015-03-01 01:14:46.000000', 'temperatura', 194.0000, 'ºC'),
	(93793, 112, '2015-03-01 01:14:47.000000', 'temperatura', 487.0000, 'ºC'),
	(93794, 112, '2015-03-01 01:14:48.000000', 'temperatura', 651.0000, 'ºC'),
	(93795, 112, '2015-03-01 01:14:49.000000', 'temperatura', 597.0000, 'ºC'),
	(93796, 112, '2015-03-01 01:14:50.000000', 'temperatura', 1034.0000, 'ºC'),
	(93797, 112, '2015-03-01 01:14:51.000000', 'temperatura', 976.0000, 'ºC'),
	(93798, 112, '2015-03-01 01:14:52.000000', 'temperatura', 581.0000, 'ºC'),
	(93799, 112, '2015-03-01 01:14:53.000000', 'temperatura', 1175.0000, 'ºC'),
	(93800, 112, '2015-03-01 01:14:54.000000', 'temperatura', 532.0000, 'ºC'),
	(93801, 112, '2015-03-01 01:14:55.000000', 'temperatura', 336.0000, 'ºC'),
	(93802, 112, '2015-03-01 01:14:56.000000', 'temperatura', 85.0000, 'ºC'),
	(93803, 112, '2015-03-01 01:14:57.000000', 'temperatura', 619.0000, 'ºC'),
	(93804, 112, '2015-03-01 01:14:58.000000', 'temperatura', 438.0000, 'ºC'),
	(93805, 112, '2015-03-01 01:14:59.000000', 'temperatura', 335.0000, 'ºC'),
	(93806, 112, '2015-03-01 01:15:00.000000', 'temperatura', 362.0000, 'ºC'),
	(93807, 112, '2015-03-01 01:15:01.000000', 'temperatura', 805.0000, 'ºC'),
	(93808, 112, '2015-03-01 01:15:02.000000', 'temperatura', 539.0000, 'ºC'),
	(93809, 112, '2015-03-01 01:15:03.000000', 'temperatura', 282.0000, 'ºC'),
	(93810, 112, '2015-03-01 01:15:04.000000', 'temperatura', 992.0000, 'ºC'),
	(93811, 112, '2015-03-01 01:15:05.000000', 'temperatura', 517.0000, 'ºC'),
	(93812, 112, '2015-03-01 01:15:06.000000', 'temperatura', 807.0000, 'ºC'),
	(93813, 112, '2015-03-01 01:15:07.000000', 'temperatura', 83.0000, 'ºC'),
	(93814, 112, '2015-03-01 01:15:08.000000', 'temperatura', 398.0000, 'ºC'),
	(93815, 112, '2015-03-01 01:15:09.000000', 'temperatura', 540.0000, 'ºC'),
	(93816, 112, '2015-03-01 01:15:10.000000', 'temperatura', 308.0000, 'ºC'),
	(93817, 112, '2015-03-01 01:15:11.000000', 'temperatura', 1118.0000, 'ºC'),
	(93818, 112, '2015-03-01 01:15:12.000000', 'temperatura', 1069.0000, 'ºC'),
	(93819, 112, '2015-03-01 01:15:13.000000', 'temperatura', 790.0000, 'ºC'),
	(93820, 112, '2015-03-01 01:15:14.000000', 'temperatura', 744.0000, 'ºC'),
	(93821, 112, '2015-03-01 01:15:15.000000', 'temperatura', 149.0000, 'ºC'),
	(93822, 112, '2015-03-01 01:15:16.000000', 'temperatura', 913.0000, 'ºC'),
	(93823, 112, '2015-03-01 01:15:17.000000', 'temperatura', 520.0000, 'ºC'),
	(93824, 112, '2015-03-01 01:15:18.000000', 'temperatura', 1060.0000, 'ºC'),
	(93825, 112, '2015-03-01 01:15:19.000000', 'temperatura', 140.0000, 'ºC'),
	(93826, 112, '2015-03-01 01:15:20.000000', 'temperatura', 1124.0000, 'ºC'),
	(93827, 112, '2015-03-01 01:15:21.000000', 'temperatura', 397.0000, 'ºC'),
	(93828, 112, '2015-03-01 01:15:22.000000', 'temperatura', 1013.0000, 'ºC'),
	(93829, 112, '2015-03-01 01:15:23.000000', 'temperatura', 276.0000, 'ºC'),
	(93830, 112, '2015-03-01 01:15:24.000000', 'temperatura', 740.0000, 'ºC'),
	(93831, 112, '2015-03-01 01:15:25.000000', 'temperatura', 472.0000, 'ºC'),
	(93832, 112, '2015-03-01 01:15:26.000000', 'temperatura', 141.0000, 'ºC'),
	(93833, 112, '2015-03-01 01:15:27.000000', 'temperatura', 492.0000, 'ºC'),
	(93834, 112, '2015-03-01 01:15:28.000000', 'temperatura', 835.0000, 'ºC'),
	(93835, 112, '2015-03-01 01:15:29.000000', 'temperatura', 300.0000, 'ºC'),
	(93836, 112, '2015-03-01 01:15:30.000000', 'temperatura', 197.0000, 'ºC'),
	(93837, 112, '2015-03-01 01:15:31.000000', 'temperatura', 85.0000, 'ºC'),
	(93838, 112, '2015-03-01 01:15:32.000000', 'temperatura', 1033.0000, 'ºC'),
	(93839, 112, '2015-03-01 01:15:33.000000', 'temperatura', 109.0000, 'ºC'),
	(93840, 112, '2015-03-01 01:15:34.000000', 'temperatura', 1050.0000, 'ºC'),
	(93841, 112, '2015-03-01 01:15:35.000000', 'temperatura', 121.0000, 'ºC'),
	(93842, 112, '2015-03-01 01:15:36.000000', 'temperatura', 1055.0000, 'ºC'),
	(93843, 112, '2015-03-01 01:15:37.000000', 'temperatura', 115.0000, 'ºC'),
	(93844, 112, '2015-03-01 01:15:38.000000', 'temperatura', 1009.0000, 'ºC'),
	(93845, 112, '2015-03-01 01:15:39.000000', 'temperatura', 1102.0000, 'ºC'),
	(93846, 112, '2015-03-01 01:15:40.000000', 'temperatura', 85.0000, 'ºC'),
	(93847, 112, '2015-03-01 01:15:41.000000', 'temperatura', 716.0000, 'ºC'),
	(93848, 112, '2015-03-01 01:15:42.000000', 'temperatura', 927.0000, 'ºC'),
	(93849, 112, '2015-03-01 01:15:43.000000', 'temperatura', 89.0000, 'ºC'),
	(93850, 112, '2015-03-01 01:15:44.000000', 'temperatura', 61.0000, 'ºC'),
	(93851, 112, '2015-03-01 01:15:45.000000', 'temperatura', 41.0000, 'ºC'),
	(93852, 112, '2015-03-01 01:15:46.000000', 'temperatura', 22.0000, 'ºC'),
	(93853, 112, '2015-03-01 01:15:47.000000', 'temperatura', 1189.0000, 'ºC'),
	(93854, 112, '2015-03-01 01:15:48.000000', 'temperatura', 1078.0000, 'ºC'),
	(93855, 112, '2015-03-01 01:15:49.000000', 'temperatura', 623.0000, 'ºC'),
	(93856, 112, '2015-03-01 01:15:50.000000', 'temperatura', 1081.0000, 'ºC'),
	(93857, 112, '2015-03-01 01:15:51.000000', 'temperatura', 1139.0000, 'ºC'),
	(93858, 112, '2015-03-01 01:15:52.000000', 'temperatura', 49.0000, 'ºC'),
	(93859, 112, '2015-03-01 01:15:53.000000', 'temperatura', 431.0000, 'ºC'),
	(93860, 112, '2015-03-01 01:15:54.000000', 'temperatura', 807.0000, 'ºC'),
	(93861, 112, '2015-03-01 01:15:55.000000', 'temperatura', 345.0000, 'ºC'),
	(93862, 112, '2015-03-01 01:15:56.000000', 'temperatura', 501.0000, 'ºC'),
	(93863, 112, '2015-03-01 01:15:57.000000', 'temperatura', 273.0000, 'ºC'),
	(93864, 112, '2015-03-01 01:15:58.000000', 'temperatura', 1062.0000, 'ºC'),
	(93865, 112, '2015-03-01 01:15:59.000000', 'temperatura', 893.0000, 'ºC'),
	(93866, 112, '2015-03-01 01:16:00.000000', 'temperatura', 77.0000, 'ºC'),
	(93867, 112, '2015-03-01 01:16:01.000000', 'temperatura', 108.0000, 'ºC'),
	(93868, 112, '2015-03-01 01:16:02.000000', 'temperatura', 311.0000, 'ºC'),
	(93869, 112, '2015-03-01 01:16:03.000000', 'temperatura', 29.0000, 'ºC'),
	(93870, 112, '2015-03-01 01:16:04.000000', 'temperatura', 411.0000, 'ºC'),
	(93871, 112, '2015-03-01 01:16:05.000000', 'temperatura', 772.0000, 'ºC'),
	(93872, 112, '2015-03-01 01:16:06.000000', 'temperatura', 227.0000, 'ºC'),
	(93873, 112, '2015-03-01 01:16:07.000000', 'temperatura', 17.0000, 'ºC'),
	(93874, 112, '2015-03-01 01:16:08.000000', 'temperatura', 608.0000, 'ºC'),
	(93875, 112, '2015-03-01 01:16:09.000000', 'temperatura', 587.0000, 'ºC'),
	(93876, 112, '2015-03-01 01:16:10.000000', 'temperatura', 1111.0000, 'ºC'),
	(93877, 112, '2015-03-01 01:16:11.000000', 'temperatura', 194.0000, 'ºC'),
	(93878, 112, '2015-03-01 01:16:12.000000', 'temperatura', 40.0000, 'ºC'),
	(93879, 112, '2015-03-01 01:16:13.000000', 'temperatura', 816.0000, 'ºC'),
	(93880, 112, '2015-03-01 01:16:14.000000', 'temperatura', 361.0000, 'ºC'),
	(93881, 112, '2015-03-01 01:16:15.000000', 'temperatura', 557.0000, 'ºC'),
	(93882, 112, '2015-03-01 01:16:16.000000', 'temperatura', 504.0000, 'ºC'),
	(93883, 112, '2015-03-01 01:16:17.000000', 'temperatura', 848.0000, 'ºC'),
	(93884, 112, '2015-03-01 01:16:18.000000', 'temperatura', 330.0000, 'ºC'),
	(93885, 112, '2015-03-01 01:16:19.000000', 'temperatura', 307.0000, 'ºC'),
	(93886, 112, '2015-03-01 01:16:20.000000', 'temperatura', 543.0000, 'ºC'),
	(93887, 112, '2015-03-01 01:16:21.000000', 'temperatura', 595.0000, 'ºC'),
	(93888, 112, '2015-03-01 01:16:22.000000', 'temperatura', 146.0000, 'ºC'),
	(93889, 112, '2015-03-01 01:16:23.000000', 'temperatura', 148.0000, 'ºC'),
	(93890, 112, '2015-03-01 01:16:24.000000', 'temperatura', 300.0000, 'ºC'),
	(93891, 112, '2015-03-01 01:16:25.000000', 'temperatura', 1058.0000, 'ºC'),
	(93892, 112, '2015-03-01 01:16:26.000000', 'temperatura', 790.0000, 'ºC'),
	(93893, 112, '2015-03-01 01:16:27.000000', 'temperatura', 777.0000, 'ºC'),
	(93894, 112, '2015-03-01 01:16:28.000000', 'temperatura', 314.0000, 'ºC'),
	(93895, 112, '2015-03-01 01:16:29.000000', 'temperatura', 439.0000, 'ºC'),
	(93896, 112, '2015-03-01 01:16:30.000000', 'temperatura', 54.0000, 'ºC'),
	(93897, 112, '2015-03-01 01:16:31.000000', 'temperatura', 153.0000, 'ºC'),
	(93898, 112, '2015-03-01 01:16:32.000000', 'temperatura', 603.0000, 'ºC'),
	(93899, 112, '2015-03-01 01:16:33.000000', 'temperatura', 158.0000, 'ºC'),
	(93900, 112, '2015-03-01 01:16:34.000000', 'temperatura', 181.0000, 'ºC'),
	(93901, 112, '2015-03-01 01:16:35.000000', 'temperatura', 431.0000, 'ºC'),
	(93902, 112, '2015-03-01 01:16:36.000000', 'temperatura', 411.0000, 'ºC'),
	(93903, 112, '2015-03-01 01:16:37.000000', 'temperatura', 765.0000, 'ºC'),
	(93904, 112, '2015-03-01 01:16:38.000000', 'temperatura', 194.0000, 'ºC'),
	(93905, 112, '2015-03-01 01:16:39.000000', 'temperatura', 1072.0000, 'ºC'),
	(93906, 112, '2015-03-01 01:16:40.000000', 'temperatura', 1182.0000, 'ºC'),
	(93907, 112, '2015-03-01 01:16:41.000000', 'temperatura', 291.0000, 'ºC'),
	(93908, 112, '2015-03-01 01:16:42.000000', 'temperatura', 312.0000, 'ºC'),
	(93909, 112, '2015-03-01 01:16:43.000000', 'temperatura', 685.0000, 'ºC'),
	(93910, 112, '2015-03-01 01:16:44.000000', 'temperatura', 92.0000, 'ºC'),
	(93911, 112, '2015-03-01 01:16:45.000000', 'temperatura', 803.0000, 'ºC'),
	(93912, 112, '2015-03-01 01:16:46.000000', 'temperatura', 140.0000, 'ºC'),
	(93913, 112, '2015-03-01 01:16:47.000000', 'temperatura', 693.0000, 'ºC'),
	(93914, 112, '2015-03-01 01:16:48.000000', 'temperatura', 644.0000, 'ºC'),
	(93915, 112, '2015-03-01 01:16:49.000000', 'temperatura', 1140.0000, 'ºC'),
	(93916, 112, '2015-03-01 01:16:50.000000', 'temperatura', 170.0000, 'ºC'),
	(93917, 112, '2015-03-01 01:16:51.000000', 'temperatura', 1028.0000, 'ºC'),
	(93918, 112, '2015-03-01 01:16:52.000000', 'temperatura', 1034.0000, 'ºC'),
	(93919, 112, '2015-03-01 01:16:53.000000', 'temperatura', 884.0000, 'ºC'),
	(93920, 112, '2015-03-01 01:16:54.000000', 'temperatura', 120.0000, 'ºC'),
	(93921, 112, '2015-03-01 01:16:55.000000', 'temperatura', 346.0000, 'ºC'),
	(93922, 112, '2015-03-01 01:16:56.000000', 'temperatura', 173.0000, 'ºC'),
	(93923, 112, '2015-03-01 01:16:57.000000', 'temperatura', 1026.0000, 'ºC'),
	(93924, 112, '2015-03-01 01:16:58.000000', 'temperatura', 1011.0000, 'ºC'),
	(93925, 112, '2015-03-01 01:16:59.000000', 'temperatura', 777.0000, 'ºC'),
	(93926, 112, '2015-03-01 01:17:00.000000', 'temperatura', 853.0000, 'ºC'),
	(93927, 112, '2015-03-01 01:17:01.000000', 'temperatura', 733.0000, 'ºC'),
	(93928, 112, '2015-03-01 01:17:02.000000', 'temperatura', 1108.0000, 'ºC'),
	(93929, 112, '2015-03-01 01:17:03.000000', 'temperatura', 941.0000, 'ºC'),
	(93930, 112, '2015-03-01 01:17:04.000000', 'temperatura', 183.0000, 'ºC'),
	(93931, 112, '2015-03-01 01:17:05.000000', 'temperatura', 493.0000, 'ºC'),
	(93932, 112, '2015-03-01 01:17:06.000000', 'temperatura', 716.0000, 'ºC'),
	(93933, 112, '2015-03-01 01:17:07.000000', 'temperatura', 902.0000, 'ºC'),
	(93934, 112, '2015-03-01 01:17:08.000000', 'temperatura', 1160.0000, 'ºC'),
	(93935, 112, '2015-03-01 01:17:09.000000', 'temperatura', 696.0000, 'ºC'),
	(93936, 112, '2015-03-01 01:17:10.000000', 'temperatura', 1199.0000, 'ºC'),
	(93937, 112, '2015-03-01 01:17:11.000000', 'temperatura', 308.0000, 'ºC'),
	(93938, 112, '2015-03-01 01:17:12.000000', 'temperatura', 345.0000, 'ºC'),
	(93939, 112, '2015-03-01 01:17:13.000000', 'temperatura', 801.0000, 'ºC'),
	(93940, 112, '2015-03-01 01:17:14.000000', 'temperatura', 572.0000, 'ºC'),
	(93941, 112, '2015-03-01 01:17:15.000000', 'temperatura', 457.0000, 'ºC'),
	(93942, 112, '2015-03-01 01:17:16.000000', 'temperatura', 568.0000, 'ºC'),
	(93943, 112, '2015-03-01 01:17:17.000000', 'temperatura', 271.0000, 'ºC'),
	(93944, 112, '2015-03-01 01:17:18.000000', 'temperatura', 851.0000, 'ºC'),
	(93945, 112, '2015-03-01 01:17:19.000000', 'temperatura', 1042.0000, 'ºC'),
	(93946, 112, '2015-03-01 01:17:20.000000', 'temperatura', 257.0000, 'ºC'),
	(93947, 112, '2015-03-01 01:17:21.000000', 'temperatura', 558.0000, 'ºC'),
	(93948, 112, '2015-03-01 01:17:22.000000', 'temperatura', 821.0000, 'ºC'),
	(93949, 112, '2015-03-01 01:17:23.000000', 'temperatura', 34.0000, 'ºC'),
	(93950, 112, '2015-03-01 01:17:24.000000', 'temperatura', 104.0000, 'ºC'),
	(93951, 112, '2015-03-01 01:17:25.000000', 'temperatura', 420.0000, 'ºC'),
	(93952, 112, '2015-03-01 01:17:26.000000', 'temperatura', 586.0000, 'ºC'),
	(93953, 112, '2015-03-01 01:17:27.000000', 'temperatura', 474.0000, 'ºC'),
	(93954, 112, '2015-03-01 01:17:28.000000', 'temperatura', 612.0000, 'ºC'),
	(93955, 112, '2015-03-01 01:17:29.000000', 'temperatura', 436.0000, 'ºC'),
	(93956, 112, '2015-03-01 01:17:30.000000', 'temperatura', 346.0000, 'ºC'),
	(93957, 112, '2015-03-01 01:17:31.000000', 'temperatura', 424.0000, 'ºC'),
	(93958, 112, '2015-03-01 01:17:32.000000', 'temperatura', 1083.0000, 'ºC'),
	(93959, 112, '2015-03-01 01:17:33.000000', 'temperatura', 540.0000, 'ºC'),
	(93960, 112, '2015-03-01 01:17:34.000000', 'temperatura', 654.0000, 'ºC'),
	(93961, 112, '2015-03-01 01:17:35.000000', 'temperatura', 451.0000, 'ºC'),
	(93962, 112, '2015-03-01 01:17:36.000000', 'temperatura', 294.0000, 'ºC'),
	(93963, 112, '2015-03-01 01:17:37.000000', 'temperatura', 116.0000, 'ºC'),
	(93964, 112, '2015-03-01 01:17:38.000000', 'temperatura', 900.0000, 'ºC'),
	(93965, 112, '2015-03-01 01:17:39.000000', 'temperatura', 550.0000, 'ºC'),
	(93966, 112, '2015-03-01 01:17:40.000000', 'temperatura', 52.0000, 'ºC'),
	(93967, 112, '2015-03-01 01:17:41.000000', 'temperatura', 1009.0000, 'ºC'),
	(93968, 112, '2015-03-01 01:17:42.000000', 'temperatura', 90.0000, 'ºC'),
	(93969, 112, '2015-03-01 01:17:43.000000', 'temperatura', 1024.0000, 'ºC'),
	(93970, 112, '2015-03-01 01:17:44.000000', 'temperatura', 51.0000, 'ºC'),
	(93971, 112, '2015-03-01 01:17:45.000000', 'temperatura', 782.0000, 'ºC'),
	(93972, 112, '2015-03-01 01:17:46.000000', 'temperatura', 157.0000, 'ºC'),
	(93973, 112, '2015-03-01 01:17:47.000000', 'temperatura', 839.0000, 'ºC'),
	(93974, 112, '2015-03-01 01:17:48.000000', 'temperatura', 126.0000, 'ºC'),
	(93975, 112, '2015-03-01 01:17:49.000000', 'temperatura', 515.0000, 'ºC'),
	(93976, 112, '2015-03-01 01:17:50.000000', 'temperatura', 994.0000, 'ºC'),
	(93977, 112, '2015-03-01 01:17:51.000000', 'temperatura', 1028.0000, 'ºC'),
	(93978, 112, '2015-03-01 01:17:52.000000', 'temperatura', 958.0000, 'ºC'),
	(93979, 112, '2015-03-01 01:17:53.000000', 'temperatura', 506.0000, 'ºC'),
	(93980, 112, '2015-03-01 01:17:54.000000', 'temperatura', 855.0000, 'ºC'),
	(93981, 112, '2015-03-01 01:17:55.000000', 'temperatura', 360.0000, 'ºC'),
	(93982, 112, '2015-03-01 01:17:56.000000', 'temperatura', 433.0000, 'ºC'),
	(93983, 112, '2015-03-01 01:17:57.000000', 'temperatura', 1087.0000, 'ºC'),
	(93984, 112, '2015-03-01 01:17:58.000000', 'temperatura', 535.0000, 'ºC'),
	(93985, 112, '2015-03-01 01:17:59.000000', 'temperatura', 614.0000, 'ºC'),
	(93986, 112, '2015-03-01 01:18:00.000000', 'temperatura', 265.0000, 'ºC'),
	(93987, 112, '2015-03-01 01:18:01.000000', 'temperatura', 685.0000, 'ºC'),
	(93988, 112, '2015-03-01 01:18:02.000000', 'temperatura', 228.0000, 'ºC'),
	(93989, 112, '2015-03-01 01:18:03.000000', 'temperatura', 287.0000, 'ºC'),
	(93990, 112, '2015-03-01 01:18:04.000000', 'temperatura', 752.0000, 'ºC'),
	(93991, 112, '2015-03-01 01:18:05.000000', 'temperatura', 499.0000, 'ºC'),
	(93992, 112, '2015-03-01 01:18:06.000000', 'temperatura', 242.0000, 'ºC'),
	(93993, 112, '2015-03-01 01:18:07.000000', 'temperatura', 910.0000, 'ºC'),
	(93994, 112, '2015-03-01 01:18:08.000000', 'temperatura', 225.0000, 'ºC'),
	(93995, 112, '2015-03-01 01:18:09.000000', 'temperatura', 797.0000, 'ºC'),
	(93996, 112, '2015-03-01 01:18:10.000000', 'temperatura', 908.0000, 'ºC'),
	(93997, 112, '2015-03-01 01:18:11.000000', 'temperatura', 952.0000, 'ºC'),
	(93998, 112, '2015-03-01 01:18:12.000000', 'temperatura', 836.0000, 'ºC'),
	(93999, 112, '2015-03-01 01:18:13.000000', 'temperatura', 126.0000, 'ºC'),
	(94000, 112, '2015-03-01 01:18:14.000000', 'temperatura', 520.0000, 'ºC'),
	(94001, 112, '2015-03-01 01:18:15.000000', 'temperatura', 1025.0000, 'ºC'),
	(94002, 112, '2015-03-01 01:18:16.000000', 'temperatura', 1163.0000, 'ºC'),
	(94003, 112, '2015-03-01 01:18:17.000000', 'temperatura', 340.0000, 'ºC'),
	(94004, 112, '2015-03-01 01:18:18.000000', 'temperatura', 612.0000, 'ºC'),
	(94005, 112, '2015-03-01 01:18:19.000000', 'temperatura', 842.0000, 'ºC'),
	(94006, 112, '2015-03-01 01:18:20.000000', 'temperatura', 1172.0000, 'ºC'),
	(94007, 112, '2015-03-01 01:18:21.000000', 'temperatura', 934.0000, 'ºC'),
	(94008, 112, '2015-03-01 01:18:22.000000', 'temperatura', 1156.0000, 'ºC'),
	(94009, 112, '2015-03-01 01:18:23.000000', 'temperatura', 579.0000, 'ºC'),
	(94010, 112, '2015-03-01 01:18:24.000000', 'temperatura', 627.0000, 'ºC'),
	(94011, 112, '2015-03-01 01:18:25.000000', 'temperatura', 200.0000, 'ºC'),
	(94012, 112, '2015-03-01 01:18:26.000000', 'temperatura', 317.0000, 'ºC'),
	(94013, 112, '2015-03-01 01:18:27.000000', 'temperatura', 987.0000, 'ºC'),
	(94014, 112, '2015-03-01 01:18:28.000000', 'temperatura', 385.0000, 'ºC'),
	(94015, 112, '2015-03-01 01:18:29.000000', 'temperatura', 166.0000, 'ºC'),
	(94016, 112, '2015-03-01 01:18:30.000000', 'temperatura', 874.0000, 'ºC'),
	(94017, 112, '2015-03-01 01:18:31.000000', 'temperatura', 272.0000, 'ºC'),
	(94018, 112, '2015-03-01 01:18:32.000000', 'temperatura', 1139.0000, 'ºC'),
	(94019, 112, '2015-03-01 01:18:33.000000', 'temperatura', 79.0000, 'ºC'),
	(94020, 112, '2015-03-01 01:18:34.000000', 'temperatura', 579.0000, 'ºC'),
	(94021, 112, '2015-03-01 01:18:35.000000', 'temperatura', 256.0000, 'ºC'),
	(94022, 112, '2015-03-01 01:18:36.000000', 'temperatura', 746.0000, 'ºC'),
	(94023, 112, '2015-03-01 01:18:37.000000', 'temperatura', 563.0000, 'ºC'),
	(94024, 112, '2015-03-01 01:18:38.000000', 'temperatura', 576.0000, 'ºC'),
	(94025, 112, '2015-03-01 01:18:39.000000', 'temperatura', 1191.0000, 'ºC'),
	(94026, 112, '2015-03-01 01:18:40.000000', 'temperatura', 629.0000, 'ºC'),
	(94027, 112, '2015-03-01 01:18:41.000000', 'temperatura', 771.0000, 'ºC'),
	(94028, 112, '2015-03-01 01:18:42.000000', 'temperatura', 769.0000, 'ºC'),
	(94029, 112, '2015-03-01 01:18:43.000000', 'temperatura', 331.0000, 'ºC'),
	(94030, 112, '2015-03-01 01:18:44.000000', 'temperatura', 549.0000, 'ºC'),
	(94031, 112, '2015-03-01 01:18:45.000000', 'temperatura', 553.0000, 'ºC'),
	(94032, 112, '2015-03-01 01:18:46.000000', 'temperatura', 1119.0000, 'ºC'),
	(94033, 112, '2015-03-01 01:18:47.000000', 'temperatura', 338.0000, 'ºC'),
	(94034, 112, '2015-03-01 01:18:48.000000', 'temperatura', 731.0000, 'ºC'),
	(94035, 112, '2015-03-01 01:18:49.000000', 'temperatura', 243.0000, 'ºC'),
	(94036, 112, '2015-03-01 01:18:50.000000', 'temperatura', 224.0000, 'ºC'),
	(94037, 112, '2015-03-01 01:18:51.000000', 'temperatura', 389.0000, 'ºC'),
	(94038, 112, '2015-03-01 01:18:52.000000', 'temperatura', 74.0000, 'ºC'),
	(94039, 112, '2015-03-01 01:18:53.000000', 'temperatura', 405.0000, 'ºC'),
	(94040, 112, '2015-03-01 01:18:54.000000', 'temperatura', 603.0000, 'ºC'),
	(94041, 112, '2015-03-01 01:18:55.000000', 'temperatura', 601.0000, 'ºC'),
	(94042, 112, '2015-03-01 01:18:56.000000', 'temperatura', 1196.0000, 'ºC'),
	(94043, 112, '2015-03-01 01:18:57.000000', 'temperatura', 576.0000, 'ºC'),
	(94044, 112, '2015-03-01 01:18:58.000000', 'temperatura', 495.0000, 'ºC'),
	(94045, 112, '2015-03-01 01:18:59.000000', 'temperatura', 746.0000, 'ºC'),
	(94046, 112, '2015-03-01 01:19:00.000000', 'temperatura', 1044.0000, 'ºC'),
	(94047, 112, '2015-03-01 01:19:01.000000', 'temperatura', 583.0000, 'ºC'),
	(94048, 112, '2015-03-01 01:19:02.000000', 'temperatura', 984.0000, 'ºC'),
	(94049, 112, '2015-03-01 01:19:03.000000', 'temperatura', 771.0000, 'ºC'),
	(94050, 112, '2015-03-01 01:19:04.000000', 'temperatura', 902.0000, 'ºC'),
	(94051, 112, '2015-03-01 01:19:05.000000', 'temperatura', 999.0000, 'ºC'),
	(94052, 112, '2015-03-01 01:19:06.000000', 'temperatura', 1089.0000, 'ºC'),
	(94053, 112, '2015-03-01 01:19:07.000000', 'temperatura', 51.0000, 'ºC'),
	(94054, 112, '2015-03-01 01:19:08.000000', 'temperatura', 586.0000, 'ºC'),
	(94055, 112, '2015-03-01 01:19:09.000000', 'temperatura', 379.0000, 'ºC'),
	(94056, 112, '2015-03-01 01:19:10.000000', 'temperatura', 135.0000, 'ºC'),
	(94057, 112, '2015-03-01 01:19:11.000000', 'temperatura', 740.0000, 'ºC'),
	(94058, 112, '2015-03-01 01:19:12.000000', 'temperatura', 897.0000, 'ºC'),
	(94059, 112, '2015-03-01 01:19:13.000000', 'temperatura', 1065.0000, 'ºC'),
	(94060, 112, '2015-03-01 01:19:14.000000', 'temperatura', 236.0000, 'ºC'),
	(94061, 112, '2015-03-01 01:19:15.000000', 'temperatura', 383.0000, 'ºC'),
	(94062, 112, '2015-03-01 01:19:16.000000', 'temperatura', 8.0000, 'ºC'),
	(94063, 112, '2015-03-01 01:19:17.000000', 'temperatura', 94.0000, 'ºC'),
	(94064, 112, '2015-03-01 01:19:18.000000', 'temperatura', 443.0000, 'ºC'),
	(94065, 112, '2015-03-01 01:19:19.000000', 'temperatura', 734.0000, 'ºC'),
	(94066, 112, '2015-03-01 01:19:20.000000', 'temperatura', 1143.0000, 'ºC'),
	(94067, 112, '2015-03-01 01:19:21.000000', 'temperatura', 1111.0000, 'ºC'),
	(94068, 112, '2015-03-01 01:19:22.000000', 'temperatura', 929.0000, 'ºC'),
	(94069, 112, '2015-03-01 01:19:23.000000', 'temperatura', 111.0000, 'ºC'),
	(94070, 112, '2015-03-01 01:19:24.000000', 'temperatura', 168.0000, 'ºC'),
	(94071, 112, '2015-03-01 01:19:25.000000', 'temperatura', 507.0000, 'ºC'),
	(94072, 112, '2015-03-01 01:19:26.000000', 'temperatura', 831.0000, 'ºC'),
	(94073, 112, '2015-03-01 01:19:27.000000', 'temperatura', 235.0000, 'ºC'),
	(94074, 112, '2015-03-01 01:19:28.000000', 'temperatura', 1083.0000, 'ºC'),
	(94075, 112, '2015-03-01 01:19:29.000000', 'temperatura', 1111.0000, 'ºC'),
	(94076, 112, '2015-03-01 01:19:30.000000', 'temperatura', 1107.0000, 'ºC'),
	(94077, 112, '2015-03-01 01:19:31.000000', 'temperatura', 1001.0000, 'ºC'),
	(94078, 112, '2015-03-01 01:19:32.000000', 'temperatura', 484.0000, 'ºC'),
	(94079, 112, '2015-03-01 01:19:33.000000', 'temperatura', 619.0000, 'ºC'),
	(94080, 112, '2015-03-01 01:19:34.000000', 'temperatura', 444.0000, 'ºC'),
	(94081, 112, '2015-03-01 01:19:35.000000', 'temperatura', 362.0000, 'ºC'),
	(94082, 112, '2015-03-01 01:19:36.000000', 'temperatura', 479.0000, 'ºC'),
	(94083, 112, '2015-03-01 01:19:37.000000', 'temperatura', 109.0000, 'ºC'),
	(94084, 112, '2015-03-01 01:19:38.000000', 'temperatura', 310.0000, 'ºC'),
	(94085, 112, '2015-03-01 01:19:39.000000', 'temperatura', 22.0000, 'ºC'),
	(94086, 112, '2015-03-01 01:19:40.000000', 'temperatura', 380.0000, 'ºC'),
	(94087, 112, '2015-03-01 01:19:41.000000', 'temperatura', 635.0000, 'ºC'),
	(94088, 112, '2015-03-01 01:19:42.000000', 'temperatura', 835.0000, 'ºC'),
	(94089, 112, '2015-03-01 01:19:43.000000', 'temperatura', 1069.0000, 'ºC'),
	(94090, 112, '2015-03-01 01:19:44.000000', 'temperatura', 444.0000, 'ºC'),
	(94091, 112, '2015-03-01 01:19:45.000000', 'temperatura', 211.0000, 'ºC'),
	(94092, 112, '2015-03-01 01:19:46.000000', 'temperatura', 922.0000, 'ºC'),
	(94093, 112, '2015-03-01 01:19:47.000000', 'temperatura', 380.0000, 'ºC'),
	(94094, 112, '2015-03-01 01:19:48.000000', 'temperatura', 335.0000, 'ºC'),
	(94095, 112, '2015-03-01 01:19:49.000000', 'temperatura', 534.0000, 'ºC'),
	(94096, 112, '2015-03-01 01:19:50.000000', 'temperatura', 467.0000, 'ºC'),
	(94097, 112, '2015-03-01 01:19:51.000000', 'temperatura', 734.0000, 'ºC'),
	(94098, 112, '2015-03-01 01:19:52.000000', 'temperatura', 1068.0000, 'ºC'),
	(94099, 112, '2015-03-01 01:19:53.000000', 'temperatura', 741.0000, 'ºC'),
	(94100, 112, '2015-03-01 01:19:54.000000', 'temperatura', 498.0000, 'ºC'),
	(94101, 112, '2015-03-01 01:19:55.000000', 'temperatura', 269.0000, 'ºC'),
	(94102, 112, '2015-03-01 01:19:56.000000', 'temperatura', 1051.0000, 'ºC'),
	(94103, 112, '2015-03-01 01:19:57.000000', 'temperatura', 851.0000, 'ºC'),
	(94104, 112, '2015-03-01 01:19:58.000000', 'temperatura', 1100.0000, 'ºC'),
	(94105, 112, '2015-03-01 01:19:59.000000', 'temperatura', 550.0000, 'ºC'),
	(94106, 112, '2015-03-01 01:20:00.000000', 'temperatura', 650.0000, 'ºC'),
	(94107, 112, '2015-03-01 01:20:01.000000', 'temperatura', 400.0000, 'ºC'),
	(94108, 112, '2015-03-01 01:20:02.000000', 'temperatura', 52.0000, 'ºC'),
	(94109, 112, '2015-03-01 01:20:03.000000', 'temperatura', 261.0000, 'ºC'),
	(94110, 112, '2015-03-01 01:20:04.000000', 'temperatura', 1149.0000, 'ºC'),
	(94111, 112, '2015-03-01 01:20:05.000000', 'temperatura', 160.0000, 'ºC'),
	(94112, 112, '2015-03-01 01:20:06.000000', 'temperatura', 955.0000, 'ºC'),
	(94113, 112, '2015-03-01 01:20:07.000000', 'temperatura', 694.0000, 'ºC'),
	(94114, 112, '2015-03-01 01:20:08.000000', 'temperatura', 607.0000, 'ºC'),
	(94115, 112, '2015-03-01 01:20:09.000000', 'temperatura', 955.0000, 'ºC'),
	(94116, 112, '2015-03-01 01:20:10.000000', 'temperatura', 552.0000, 'ºC'),
	(94117, 112, '2015-03-01 01:20:11.000000', 'temperatura', 1096.0000, 'ºC'),
	(94118, 112, '2015-03-01 01:20:12.000000', 'temperatura', 227.0000, 'ºC'),
	(94119, 112, '2015-03-01 01:20:13.000000', 'temperatura', 245.0000, 'ºC'),
	(94120, 112, '2015-03-01 01:20:14.000000', 'temperatura', 545.0000, 'ºC'),
	(94121, 112, '2015-03-01 01:20:15.000000', 'temperatura', 791.0000, 'ºC'),
	(94122, 112, '2015-03-01 01:20:16.000000', 'temperatura', 1119.0000, 'ºC'),
	(94123, 112, '2015-03-01 01:20:17.000000', 'temperatura', 825.0000, 'ºC'),
	(94124, 112, '2015-03-01 01:20:18.000000', 'temperatura', 766.0000, 'ºC'),
	(94125, 112, '2015-03-01 01:20:19.000000', 'temperatura', 156.0000, 'ºC'),
	(94126, 112, '2015-03-01 01:20:20.000000', 'temperatura', 883.0000, 'ºC'),
	(94127, 112, '2015-03-01 01:20:21.000000', 'temperatura', 347.0000, 'ºC'),
	(94128, 112, '2015-03-01 01:20:22.000000', 'temperatura', 289.0000, 'ºC'),
	(94129, 112, '2015-03-01 01:20:23.000000', 'temperatura', 401.0000, 'ºC'),
	(94130, 112, '2015-03-01 01:20:24.000000', 'temperatura', 1141.0000, 'ºC'),
	(94131, 112, '2015-03-01 01:20:25.000000', 'temperatura', 900.0000, 'ºC'),
	(94132, 112, '2015-03-01 01:20:26.000000', 'temperatura', 1080.0000, 'ºC'),
	(94133, 112, '2015-03-01 01:20:27.000000', 'temperatura', 300.0000, 'ºC'),
	(94134, 112, '2015-03-01 01:20:28.000000', 'temperatura', 659.0000, 'ºC'),
	(94135, 112, '2015-03-01 01:20:29.000000', 'temperatura', 1196.0000, 'ºC'),
	(94136, 112, '2015-03-01 01:20:30.000000', 'temperatura', 406.0000, 'ºC'),
	(94137, 112, '2015-03-01 01:20:31.000000', 'temperatura', 839.0000, 'ºC'),
	(94138, 112, '2015-03-01 01:20:32.000000', 'temperatura', 580.0000, 'ºC'),
	(94139, 112, '2015-03-01 01:20:33.000000', 'temperatura', 382.0000, 'ºC'),
	(94140, 112, '2015-03-01 01:20:34.000000', 'temperatura', 170.0000, 'ºC'),
	(94141, 112, '2015-03-01 01:20:35.000000', 'temperatura', 906.0000, 'ºC'),
	(94142, 112, '2015-03-01 01:20:36.000000', 'temperatura', 419.0000, 'ºC'),
	(94143, 112, '2015-03-01 01:20:37.000000', 'temperatura', 580.0000, 'ºC'),
	(94144, 112, '2015-03-01 01:20:38.000000', 'temperatura', 441.0000, 'ºC'),
	(94145, 112, '2015-03-01 01:20:39.000000', 'temperatura', 468.0000, 'ºC'),
	(94146, 112, '2015-03-01 01:20:40.000000', 'temperatura', 1017.0000, 'ºC'),
	(94147, 112, '2015-03-01 01:20:41.000000', 'temperatura', 81.0000, 'ºC'),
	(94148, 112, '2015-03-01 01:20:42.000000', 'temperatura', 954.0000, 'ºC'),
	(94149, 112, '2015-03-01 01:20:43.000000', 'temperatura', 929.0000, 'ºC'),
	(94150, 112, '2015-03-01 01:20:44.000000', 'temperatura', 584.0000, 'ºC'),
	(94151, 112, '2015-03-01 01:20:45.000000', 'temperatura', 132.0000, 'ºC'),
	(94152, 112, '2015-03-01 01:20:46.000000', 'temperatura', 107.0000, 'ºC'),
	(94153, 112, '2015-03-01 01:20:47.000000', 'temperatura', 141.0000, 'ºC'),
	(94154, 112, '2015-03-01 01:20:48.000000', 'temperatura', 385.0000, 'ºC'),
	(94155, 112, '2015-03-01 01:20:49.000000', 'temperatura', 302.0000, 'ºC'),
	(94156, 112, '2015-03-01 01:20:50.000000', 'temperatura', 354.0000, 'ºC'),
	(94157, 112, '2015-03-01 01:20:51.000000', 'temperatura', 866.0000, 'ºC'),
	(94158, 112, '2015-03-01 01:20:52.000000', 'temperatura', 866.0000, 'ºC'),
	(94159, 112, '2015-03-01 01:20:53.000000', 'temperatura', 536.0000, 'ºC'),
	(94160, 112, '2015-03-01 01:20:54.000000', 'temperatura', 81.0000, 'ºC'),
	(94161, 112, '2015-03-01 01:20:55.000000', 'temperatura', 1196.0000, 'ºC'),
	(94162, 112, '2015-03-01 01:20:56.000000', 'temperatura', 938.0000, 'ºC'),
	(94163, 112, '2015-03-01 01:20:57.000000', 'temperatura', 1102.0000, 'ºC'),
	(94164, 112, '2015-03-01 01:20:58.000000', 'temperatura', 296.0000, 'ºC'),
	(94165, 112, '2015-03-01 01:20:59.000000', 'temperatura', 575.0000, 'ºC'),
	(94166, 112, '2015-03-01 01:21:00.000000', 'temperatura', 787.0000, 'ºC'),
	(94167, 112, '2015-03-01 01:21:01.000000', 'temperatura', 1012.0000, 'ºC'),
	(94168, 112, '2015-03-01 01:21:02.000000', 'temperatura', 299.0000, 'ºC'),
	(94169, 112, '2015-03-01 01:21:03.000000', 'temperatura', 861.0000, 'ºC'),
	(94170, 112, '2015-03-01 01:21:04.000000', 'temperatura', 1005.0000, 'ºC'),
	(94171, 112, '2015-03-01 01:21:05.000000', 'temperatura', 45.0000, 'ºC'),
	(94172, 112, '2015-03-01 01:21:06.000000', 'temperatura', 811.0000, 'ºC'),
	(94173, 112, '2015-03-01 01:21:07.000000', 'temperatura', 320.0000, 'ºC'),
	(94174, 112, '2015-03-01 01:21:08.000000', 'temperatura', 369.0000, 'ºC'),
	(94175, 112, '2015-03-01 01:21:09.000000', 'temperatura', 883.0000, 'ºC'),
	(94176, 112, '2015-03-01 01:21:10.000000', 'temperatura', 911.0000, 'ºC'),
	(94177, 112, '2015-03-01 01:21:11.000000', 'temperatura', 706.0000, 'ºC'),
	(94178, 112, '2015-03-01 01:21:12.000000', 'temperatura', 797.0000, 'ºC'),
	(94179, 112, '2015-03-01 01:21:13.000000', 'temperatura', 669.0000, 'ºC'),
	(94180, 112, '2015-03-01 01:21:14.000000', 'temperatura', 955.0000, 'ºC'),
	(94181, 112, '2015-03-01 01:21:15.000000', 'temperatura', 367.0000, 'ºC'),
	(94182, 112, '2015-03-01 01:21:16.000000', 'temperatura', 169.0000, 'ºC'),
	(94183, 112, '2015-03-01 01:21:17.000000', 'temperatura', 948.0000, 'ºC'),
	(94184, 112, '2015-03-01 01:21:18.000000', 'temperatura', 631.0000, 'ºC'),
	(94185, 112, '2015-03-01 01:21:19.000000', 'temperatura', 311.0000, 'ºC'),
	(94186, 112, '2015-03-01 01:21:20.000000', 'temperatura', 862.0000, 'ºC'),
	(94187, 112, '2015-03-01 01:21:21.000000', 'temperatura', 978.0000, 'ºC'),
	(94188, 112, '2015-03-01 01:21:22.000000', 'temperatura', 1105.0000, 'ºC'),
	(94189, 112, '2015-03-01 01:21:23.000000', 'temperatura', 191.0000, 'ºC'),
	(94190, 112, '2015-03-01 01:21:24.000000', 'temperatura', 43.0000, 'ºC'),
	(94191, 112, '2015-03-01 01:21:25.000000', 'temperatura', 839.0000, 'ºC'),
	(94192, 112, '2015-03-01 01:21:26.000000', 'temperatura', 468.0000, 'ºC'),
	(94193, 112, '2015-03-01 01:21:27.000000', 'temperatura', 1023.0000, 'ºC'),
	(94194, 112, '2015-03-01 01:21:28.000000', 'temperatura', 111.0000, 'ºC'),
	(94195, 112, '2015-03-01 01:21:29.000000', 'temperatura', 1088.0000, 'ºC'),
	(94196, 112, '2015-03-01 01:21:30.000000', 'temperatura', 307.0000, 'ºC'),
	(94197, 112, '2015-03-01 01:21:31.000000', 'temperatura', 671.0000, 'ºC'),
	(94198, 112, '2015-03-01 01:21:32.000000', 'temperatura', 33.0000, 'ºC'),
	(94199, 112, '2015-03-01 01:21:33.000000', 'temperatura', 555.0000, 'ºC'),
	(94200, 112, '2015-03-01 01:21:34.000000', 'temperatura', 276.0000, 'ºC'),
	(94201, 112, '2015-03-01 01:21:35.000000', 'temperatura', 917.0000, 'ºC'),
	(94202, 112, '2015-03-01 01:21:36.000000', 'temperatura', 157.0000, 'ºC'),
	(94203, 112, '2015-03-01 01:21:37.000000', 'temperatura', 434.0000, 'ºC'),
	(94204, 112, '2015-03-01 01:21:38.000000', 'temperatura', 500.0000, 'ºC'),
	(94205, 112, '2015-03-01 01:21:39.000000', 'temperatura', 1197.0000, 'ºC'),
	(94206, 112, '2015-03-01 01:21:40.000000', 'temperatura', 884.0000, 'ºC'),
	(94207, 112, '2015-03-01 01:21:41.000000', 'temperatura', 832.0000, 'ºC'),
	(94208, 112, '2015-03-01 01:21:42.000000', 'temperatura', 310.0000, 'ºC'),
	(94209, 112, '2015-03-01 01:21:43.000000', 'temperatura', 252.0000, 'ºC'),
	(94210, 112, '2015-03-01 01:21:44.000000', 'temperatura', 330.0000, 'ºC'),
	(94211, 112, '2015-03-01 01:21:45.000000', 'temperatura', 895.0000, 'ºC'),
	(94212, 112, '2015-03-01 01:21:46.000000', 'temperatura', 1087.0000, 'ºC'),
	(94213, 112, '2015-03-01 01:21:47.000000', 'temperatura', 348.0000, 'ºC'),
	(94214, 112, '2015-03-01 01:21:48.000000', 'temperatura', 880.0000, 'ºC'),
	(94215, 112, '2015-03-01 01:21:49.000000', 'temperatura', 958.0000, 'ºC'),
	(94216, 112, '2015-03-01 01:21:50.000000', 'temperatura', 949.0000, 'ºC'),
	(94217, 112, '2015-03-01 01:21:51.000000', 'temperatura', 673.0000, 'ºC'),
	(94218, 112, '2015-03-01 01:21:52.000000', 'temperatura', 518.0000, 'ºC'),
	(94219, 112, '2015-03-01 01:21:53.000000', 'temperatura', 570.0000, 'ºC'),
	(94220, 112, '2015-03-01 01:21:54.000000', 'temperatura', 99.0000, 'ºC'),
	(94221, 112, '2015-03-01 01:21:55.000000', 'temperatura', 1185.0000, 'ºC'),
	(94222, 112, '2015-03-01 01:21:56.000000', 'temperatura', 830.0000, 'ºC'),
	(94223, 112, '2015-03-01 01:21:57.000000', 'temperatura', 593.0000, 'ºC'),
	(94224, 112, '2015-03-01 01:21:58.000000', 'temperatura', 478.0000, 'ºC'),
	(94225, 112, '2015-03-01 01:21:59.000000', 'temperatura', 611.0000, 'ºC'),
	(94226, 112, '2015-03-01 01:22:00.000000', 'temperatura', 420.0000, 'ºC'),
	(94227, 112, '2015-03-01 01:22:01.000000', 'temperatura', 266.0000, 'ºC'),
	(94228, 112, '2015-03-01 01:22:02.000000', 'temperatura', 74.0000, 'ºC'),
	(94229, 112, '2015-03-01 01:22:03.000000', 'temperatura', 771.0000, 'ºC'),
	(94230, 112, '2015-03-01 01:22:04.000000', 'temperatura', 32.0000, 'ºC'),
	(94231, 112, '2015-03-01 01:22:05.000000', 'temperatura', 251.0000, 'ºC'),
	(94232, 112, '2015-03-01 01:22:06.000000', 'temperatura', 1157.0000, 'ºC'),
	(94233, 112, '2015-03-01 01:22:07.000000', 'temperatura', 232.0000, 'ºC'),
	(94234, 112, '2015-03-01 01:22:08.000000', 'temperatura', 91.0000, 'ºC'),
	(94235, 112, '2015-03-01 01:22:09.000000', 'temperatura', 959.0000, 'ºC'),
	(94236, 112, '2015-03-01 01:22:10.000000', 'temperatura', 922.0000, 'ºC'),
	(94237, 112, '2015-03-01 01:22:11.000000', 'temperatura', 534.0000, 'ºC'),
	(94238, 112, '2015-03-01 01:22:12.000000', 'temperatura', 1106.0000, 'ºC'),
	(94239, 112, '2015-03-01 01:22:13.000000', 'temperatura', 329.0000, 'ºC'),
	(94240, 112, '2015-03-01 01:22:14.000000', 'temperatura', 725.0000, 'ºC'),
	(94241, 112, '2015-03-01 01:22:15.000000', 'temperatura', 240.0000, 'ºC'),
	(94242, 112, '2015-03-01 01:22:16.000000', 'temperatura', 226.0000, 'ºC'),
	(94243, 112, '2015-03-01 01:22:17.000000', 'temperatura', 410.0000, 'ºC'),
	(94244, 112, '2015-03-01 01:22:18.000000', 'temperatura', 173.0000, 'ºC'),
	(94245, 112, '2015-03-01 01:22:19.000000', 'temperatura', 836.0000, 'ºC'),
	(94246, 112, '2015-03-01 01:22:20.000000', 'temperatura', 62.0000, 'ºC'),
	(94247, 112, '2015-03-01 01:22:21.000000', 'temperatura', 200.0000, 'ºC'),
	(94248, 112, '2015-03-01 01:22:22.000000', 'temperatura', 816.0000, 'ºC'),
	(94249, 112, '2015-03-01 01:22:23.000000', 'temperatura', 1082.0000, 'ºC'),
	(94250, 112, '2015-03-01 01:22:24.000000', 'temperatura', 561.0000, 'ºC'),
	(94251, 112, '2015-03-01 01:22:25.000000', 'temperatura', 761.0000, 'ºC'),
	(94252, 112, '2015-03-01 01:22:26.000000', 'temperatura', 921.0000, 'ºC'),
	(94253, 112, '2015-03-01 01:22:27.000000', 'temperatura', 1122.0000, 'ºC'),
	(94254, 112, '2015-03-01 01:22:28.000000', 'temperatura', 450.0000, 'ºC'),
	(94255, 112, '2015-03-01 01:22:29.000000', 'temperatura', 82.0000, 'ºC'),
	(94256, 112, '2015-03-01 01:22:30.000000', 'temperatura', 262.0000, 'ºC'),
	(94257, 112, '2015-03-01 01:22:31.000000', 'temperatura', 1063.0000, 'ºC'),
	(94258, 112, '2015-03-01 01:22:32.000000', 'temperatura', 932.0000, 'ºC'),
	(94259, 112, '2015-03-01 01:22:33.000000', 'temperatura', 270.0000, 'ºC'),
	(94260, 112, '2015-03-01 01:22:34.000000', 'temperatura', 957.0000, 'ºC'),
	(94261, 112, '2015-03-01 01:22:35.000000', 'temperatura', 373.0000, 'ºC'),
	(94262, 112, '2015-03-01 01:22:36.000000', 'temperatura', 194.0000, 'ºC'),
	(94263, 112, '2015-03-01 01:22:37.000000', 'temperatura', 1052.0000, 'ºC'),
	(94264, 112, '2015-03-01 01:22:38.000000', 'temperatura', 1079.0000, 'ºC'),
	(94265, 112, '2015-03-01 01:22:39.000000', 'temperatura', 1041.0000, 'ºC'),
	(94266, 112, '2015-03-01 01:22:40.000000', 'temperatura', 766.0000, 'ºC'),
	(94267, 112, '2015-03-01 01:22:41.000000', 'temperatura', 706.0000, 'ºC'),
	(94268, 112, '2015-03-01 01:22:42.000000', 'temperatura', 36.0000, 'ºC'),
	(94269, 112, '2015-03-01 01:22:43.000000', 'temperatura', 461.0000, 'ºC'),
	(94270, 112, '2015-03-01 01:22:44.000000', 'temperatura', 996.0000, 'ºC'),
	(94271, 112, '2015-03-01 01:22:45.000000', 'temperatura', 1197.0000, 'ºC'),
	(94272, 112, '2015-03-01 01:22:46.000000', 'temperatura', 597.0000, 'ºC'),
	(94273, 112, '2015-03-01 01:22:47.000000', 'temperatura', 596.0000, 'ºC'),
	(94274, 112, '2015-03-01 01:22:48.000000', 'temperatura', 1188.0000, 'ºC'),
	(94275, 112, '2015-03-01 01:22:49.000000', 'temperatura', 551.0000, 'ºC'),
	(94276, 112, '2015-03-01 01:22:50.000000', 'temperatura', 395.0000, 'ºC'),
	(94277, 112, '2015-03-01 01:22:51.000000', 'temperatura', 322.0000, 'ºC'),
	(94278, 112, '2015-03-01 01:22:52.000000', 'temperatura', 423.0000, 'ºC'),
	(94279, 112, '2015-03-01 01:22:53.000000', 'temperatura', 1151.0000, 'ºC'),
	(94280, 112, '2015-03-01 01:22:54.000000', 'temperatura', 885.0000, 'ºC'),
	(94281, 112, '2015-03-01 01:22:55.000000', 'temperatura', 975.0000, 'ºC'),
	(94282, 112, '2015-03-01 01:22:56.000000', 'temperatura', 1021.0000, 'ºC'),
	(94283, 112, '2015-03-01 01:22:57.000000', 'temperatura', 979.0000, 'ºC'),
	(94284, 112, '2015-03-01 01:22:58.000000', 'temperatura', 634.0000, 'ºC'),
	(94285, 112, '2015-03-01 01:22:59.000000', 'temperatura', 233.0000, 'ºC'),
	(94286, 112, '2015-03-01 01:23:00.000000', 'temperatura', 464.0000, 'ºC'),
	(94287, 112, '2015-03-01 01:23:01.000000', 'temperatura', 421.0000, 'ºC'),
	(94288, 112, '2015-03-01 01:23:02.000000', 'temperatura', 712.0000, 'ºC'),
	(94289, 112, '2015-03-01 01:23:03.000000', 'temperatura', 1098.0000, 'ºC'),
	(94290, 112, '2015-03-01 01:23:04.000000', 'temperatura', 954.0000, 'ºC'),
	(94291, 112, '2015-03-01 01:23:05.000000', 'temperatura', 276.0000, 'ºC'),
	(94292, 112, '2015-03-01 01:23:06.000000', 'temperatura', 920.0000, 'ºC'),
	(94293, 112, '2015-03-01 01:23:07.000000', 'temperatura', 172.0000, 'ºC'),
	(94294, 112, '2015-03-01 01:23:08.000000', 'temperatura', 502.0000, 'ºC'),
	(94295, 112, '2015-03-01 01:23:09.000000', 'temperatura', 796.0000, 'ºC'),
	(94296, 112, '2015-03-01 01:23:10.000000', 'temperatura', 71.0000, 'ºC'),
	(94297, 112, '2015-03-01 01:23:11.000000', 'temperatura', 368.0000, 'ºC'),
	(94298, 112, '2015-03-01 01:23:12.000000', 'temperatura', 429.0000, 'ºC'),
	(94299, 112, '2015-03-01 01:23:13.000000', 'temperatura', 1040.0000, 'ºC'),
	(94300, 112, '2015-03-01 01:23:14.000000', 'temperatura', 314.0000, 'ºC'),
	(94301, 112, '2015-03-01 01:23:15.000000', 'temperatura', 849.0000, 'ºC'),
	(94302, 112, '2015-03-01 01:23:16.000000', 'temperatura', 904.0000, 'ºC'),
	(94303, 112, '2015-03-01 01:23:17.000000', 'temperatura', 775.0000, 'ºC'),
	(94304, 112, '2015-03-01 01:23:18.000000', 'temperatura', 1164.0000, 'ºC'),
	(94305, 112, '2015-03-01 01:23:19.000000', 'temperatura', 1097.0000, 'ºC'),
	(94306, 112, '2015-03-01 01:23:20.000000', 'temperatura', 790.0000, 'ºC'),
	(94307, 112, '2015-03-01 01:23:21.000000', 'temperatura', 661.0000, 'ºC'),
	(94308, 112, '2015-03-01 01:23:22.000000', 'temperatura', 935.0000, 'ºC'),
	(94309, 112, '2015-03-01 01:23:23.000000', 'temperatura', 292.0000, 'ºC'),
	(94310, 112, '2015-03-01 01:23:24.000000', 'temperatura', 1058.0000, 'ºC'),
	(94311, 112, '2015-03-01 01:23:25.000000', 'temperatura', 812.0000, 'ºC'),
	(94312, 112, '2015-03-01 01:23:26.000000', 'temperatura', 886.0000, 'ºC'),
	(94313, 112, '2015-03-01 01:23:27.000000', 'temperatura', 796.0000, 'ºC'),
	(94314, 112, '2015-03-01 01:23:28.000000', 'temperatura', 122.0000, 'ºC'),
	(94315, 112, '2015-03-01 01:23:29.000000', 'temperatura', 621.0000, 'ºC'),
	(94316, 112, '2015-03-01 01:23:30.000000', 'temperatura', 341.0000, 'ºC'),
	(94317, 112, '2015-03-01 01:23:31.000000', 'temperatura', 1044.0000, 'ºC'),
	(94318, 112, '2015-03-01 01:23:32.000000', 'temperatura', 595.0000, 'ºC'),
	(94319, 112, '2015-03-01 01:23:33.000000', 'temperatura', 1047.0000, 'ºC'),
	(94320, 112, '2015-03-01 01:23:34.000000', 'temperatura', 1047.0000, 'ºC'),
	(94321, 112, '2015-03-01 01:23:35.000000', 'temperatura', 894.0000, 'ºC'),
	(94322, 112, '2015-03-01 01:23:36.000000', 'temperatura', 131.0000, 'ºC'),
	(94323, 112, '2015-03-01 01:23:37.000000', 'temperatura', 372.0000, 'ºC'),
	(94324, 112, '2015-03-01 01:23:38.000000', 'temperatura', 270.0000, 'ºC'),
	(94325, 112, '2015-03-01 01:23:39.000000', 'temperatura', 232.0000, 'ºC'),
	(94326, 112, '2015-03-01 01:23:40.000000', 'temperatura', 352.0000, 'ºC'),
	(94327, 112, '2015-03-01 01:23:41.000000', 'temperatura', 1064.0000, 'ºC'),
	(94328, 112, '2015-03-01 01:23:42.000000', 'temperatura', 663.0000, 'ºC'),
	(94329, 112, '2015-03-01 01:23:43.000000', 'temperatura', 124.0000, 'ºC'),
	(94330, 112, '2015-03-01 01:23:44.000000', 'temperatura', 1032.0000, 'ºC'),
	(94331, 112, '2015-03-01 01:23:45.000000', 'temperatura', 1188.0000, 'ºC'),
	(94332, 112, '2015-03-01 01:23:46.000000', 'temperatura', 443.0000, 'ºC'),
	(94333, 112, '2015-03-01 01:23:47.000000', 'temperatura', 1052.0000, 'ºC'),
	(94334, 112, '2015-03-01 01:23:48.000000', 'temperatura', 330.0000, 'ºC'),
	(94335, 112, '2015-03-01 01:23:49.000000', 'temperatura', 896.0000, 'ºC'),
	(94336, 112, '2015-03-01 01:23:50.000000', 'temperatura', 1091.0000, 'ºC'),
	(94337, 112, '2015-03-01 01:23:51.000000', 'temperatura', 369.0000, 'ºC'),
	(94338, 112, '2015-03-01 01:23:52.000000', 'temperatura', 971.0000, 'ºC'),
	(94339, 112, '2015-03-01 01:23:53.000000', 'temperatura', 149.0000, 'ºC'),
	(94340, 112, '2015-03-01 01:23:54.000000', 'temperatura', 232.0000, 'ºC'),
	(94341, 112, '2015-03-01 01:23:55.000000', 'temperatura', 715.0000, 'ºC'),
	(94342, 112, '2015-03-01 01:23:56.000000', 'temperatura', 479.0000, 'ºC'),
	(94343, 112, '2015-03-01 01:23:57.000000', 'temperatura', 249.0000, 'ºC'),
	(94344, 112, '2015-03-01 01:23:58.000000', 'temperatura', 1007.0000, 'ºC'),
	(94345, 112, '2015-03-01 01:23:59.000000', 'temperatura', 692.0000, 'ºC'),
	(94346, 112, '2015-03-01 01:24:00.000000', 'temperatura', 437.0000, 'ºC'),
	(94347, 112, '2015-03-01 01:24:01.000000', 'temperatura', 111.0000, 'ºC'),
	(94348, 112, '2015-03-01 01:24:02.000000', 'temperatura', 445.0000, 'ºC'),
	(94349, 112, '2015-03-01 01:24:03.000000', 'temperatura', 692.0000, 'ºC'),
	(94350, 112, '2015-03-01 01:24:04.000000', 'temperatura', 924.0000, 'ºC'),
	(94351, 112, '2015-03-01 01:24:05.000000', 'temperatura', 146.0000, 'ºC'),
	(94352, 112, '2015-03-01 01:24:06.000000', 'temperatura', 360.0000, 'ºC'),
	(94353, 112, '2015-03-01 01:24:07.000000', 'temperatura', 160.0000, 'ºC'),
	(94354, 112, '2015-03-01 01:24:08.000000', 'temperatura', 920.0000, 'ºC'),
	(94355, 112, '2015-03-01 01:24:09.000000', 'temperatura', 522.0000, 'ºC'),
	(94356, 112, '2015-03-01 01:24:10.000000', 'temperatura', 1048.0000, 'ºC'),
	(94357, 112, '2015-03-01 01:24:11.000000', 'temperatura', 77.0000, 'ºC'),
	(94358, 112, '2015-03-01 01:24:12.000000', 'temperatura', 843.0000, 'ºC'),
	(94359, 112, '2015-03-01 01:24:13.000000', 'temperatura', 382.0000, 'ºC'),
	(94360, 112, '2015-03-01 01:24:14.000000', 'temperatura', 582.0000, 'ºC'),
	(94361, 112, '2015-03-01 01:24:15.000000', 'temperatura', 563.0000, 'ºC'),
	(94362, 112, '2015-03-01 01:24:16.000000', 'temperatura', 1069.0000, 'ºC'),
	(94363, 112, '2015-03-01 01:24:17.000000', 'temperatura', 57.0000, 'ºC'),
	(94364, 112, '2015-03-01 01:24:18.000000', 'temperatura', 681.0000, 'ºC'),
	(94365, 112, '2015-03-01 01:24:19.000000', 'temperatura', 833.0000, 'ºC'),
	(94366, 112, '2015-03-01 01:24:20.000000', 'temperatura', 922.0000, 'ºC'),
	(94367, 112, '2015-03-01 01:24:21.000000', 'temperatura', 911.0000, 'ºC'),
	(94368, 112, '2015-03-01 01:24:22.000000', 'temperatura', 589.0000, 'ºC'),
	(94369, 112, '2015-03-01 01:24:23.000000', 'temperatura', 213.0000, 'ºC'),
	(94370, 112, '2015-03-01 01:24:24.000000', 'temperatura', 497.0000, 'ºC'),
	(94371, 112, '2015-03-01 01:24:25.000000', 'temperatura', 649.0000, 'ºC'),
	(94372, 112, '2015-03-01 01:24:26.000000', 'temperatura', 553.0000, 'ºC'),
	(94373, 112, '2015-03-01 01:24:27.000000', 'temperatura', 820.0000, 'ºC'),
	(94374, 112, '2015-03-01 01:24:28.000000', 'temperatura', 42.0000, 'ºC'),
	(94375, 112, '2015-03-01 01:24:29.000000', 'temperatura', 149.0000, 'ºC'),
	(94376, 112, '2015-03-01 01:24:30.000000', 'temperatura', 622.0000, 'ºC'),
	(94377, 112, '2015-03-01 01:24:31.000000', 'temperatura', 260.0000, 'ºC'),
	(94378, 112, '2015-03-01 01:24:32.000000', 'temperatura', 637.0000, 'ºC'),
	(94379, 112, '2015-03-01 01:24:33.000000', 'temperatura', 6.0000, 'ºC'),
	(94380, 112, '2015-03-01 01:24:34.000000', 'temperatura', 521.0000, 'ºC'),
	(94381, 112, '2015-03-01 01:24:35.000000', 'temperatura', 184.0000, 'ºC'),
	(94382, 112, '2015-03-01 01:24:36.000000', 'temperatura', 559.0000, 'ºC'),
	(94383, 112, '2015-03-01 01:24:37.000000', 'temperatura', 1044.0000, 'ºC'),
	(94384, 112, '2015-03-01 01:24:38.000000', 'temperatura', 1141.0000, 'ºC'),
	(94385, 112, '2015-03-01 01:24:39.000000', 'temperatura', 176.0000, 'ºC'),
	(94386, 112, '2015-03-01 01:24:40.000000', 'temperatura', 1055.0000, 'ºC'),
	(94387, 112, '2015-03-01 01:24:41.000000', 'temperatura', 1149.0000, 'ºC'),
	(94388, 112, '2015-03-01 01:24:42.000000', 'temperatura', 182.0000, 'ºC'),
	(94389, 112, '2015-03-01 01:24:43.000000', 'temperatura', 1064.0000, 'ºC'),
	(94390, 112, '2015-03-01 01:24:44.000000', 'temperatura', 1171.0000, 'ºC'),
	(94391, 112, '2015-03-01 01:24:45.000000', 'temperatura', 267.0000, 'ºC'),
	(94392, 112, '2015-03-01 01:24:46.000000', 'temperatura', 221.0000, 'ºC'),
	(94393, 112, '2015-03-01 01:24:47.000000', 'temperatura', 306.0000, 'ºC'),
	(94394, 112, '2015-03-01 01:24:48.000000', 'temperatura', 867.0000, 'ºC'),
	(94395, 112, '2015-03-01 01:24:49.000000', 'temperatura', 1017.0000, 'ºC'),
	(94396, 112, '2015-03-01 01:24:50.000000', 'temperatura', 86.0000, 'ºC'),
	(94397, 112, '2015-03-01 01:24:51.000000', 'temperatura', 979.0000, 'ºC'),
	(94398, 112, '2015-03-01 01:24:52.000000', 'temperatura', 1037.0000, 'ºC'),
	(94399, 112, '2015-03-01 01:24:53.000000', 'temperatura', 1048.0000, 'ºC'),
	(94400, 112, '2015-03-01 01:24:54.000000', 'temperatura', 929.0000, 'ºC'),
	(94401, 112, '2015-03-01 01:24:55.000000', 'temperatura', 302.0000, 'ºC'),
	(94402, 112, '2015-03-01 01:24:56.000000', 'temperatura', 1124.0000, 'ºC'),
	(94403, 112, '2015-03-01 01:24:57.000000', 'temperatura', 1114.0000, 'ºC'),
	(94404, 112, '2015-03-01 01:24:58.000000', 'temperatura', 1001.0000, 'ºC'),
	(94405, 112, '2015-03-01 01:24:59.000000', 'temperatura', 461.0000, 'ºC'),
	(94406, 112, '2015-03-01 01:25:00.000000', 'temperatura', 502.0000, 'ºC'),
	(94407, 112, '2015-03-01 01:25:01.000000', 'temperatura', 1130.0000, 'ºC'),
	(94408, 112, '2015-03-01 01:25:02.000000', 'temperatura', 544.0000, 'ºC'),
	(94409, 112, '2015-03-01 01:25:03.000000', 'temperatura', 532.0000, 'ºC'),
	(94410, 112, '2015-03-01 01:25:04.000000', 'temperatura', 1026.0000, 'ºC'),
	(94411, 112, '2015-03-01 01:25:05.000000', 'temperatura', 1136.0000, 'ºC'),
	(94412, 112, '2015-03-01 01:25:06.000000', 'temperatura', 200.0000, 'ºC'),
	(94413, 112, '2015-03-01 01:25:07.000000', 'temperatura', 1196.0000, 'ºC'),
	(94414, 112, '2015-03-01 01:25:08.000000', 'temperatura', 579.0000, 'ºC'),
	(94415, 112, '2015-03-01 01:25:09.000000', 'temperatura', 507.0000, 'ºC'),
	(94416, 112, '2015-03-01 01:25:10.000000', 'temperatura', 797.0000, 'ºC'),
	(94417, 112, '2015-03-01 01:25:11.000000', 'temperatura', 67.0000, 'ºC'),
	(94418, 112, '2015-03-01 01:25:12.000000', 'temperatura', 344.0000, 'ºC'),
	(94419, 112, '2015-03-01 01:25:13.000000', 'temperatura', 318.0000, 'ºC'),
	(94420, 112, '2015-03-01 01:25:14.000000', 'temperatura', 558.0000, 'ºC'),
	(94421, 112, '2015-03-01 01:25:15.000000', 'temperatura', 636.0000, 'ºC'),
	(94422, 112, '2015-03-01 01:25:16.000000', 'temperatura', 309.0000, 'ºC'),
	(94423, 112, '2015-03-01 01:25:17.000000', 'temperatura', 838.0000, 'ºC'),
	(94424, 112, '2015-03-01 01:25:18.000000', 'temperatura', 861.0000, 'ºC'),
	(94425, 112, '2015-03-01 01:25:19.000000', 'temperatura', 594.0000, 'ºC'),
	(94426, 112, '2015-03-01 01:25:20.000000', 'temperatura', 386.0000, 'ºC'),
	(94427, 112, '2015-03-01 01:25:21.000000', 'temperatura', 147.0000, 'ºC'),
	(94428, 112, '2015-03-01 01:25:22.000000', 'temperatura', 777.0000, 'ºC'),
	(94429, 112, '2015-03-01 01:25:23.000000', 'temperatura', 1048.0000, 'ºC'),
	(94430, 112, '2015-03-01 01:25:24.000000', 'temperatura', 507.0000, 'ºC'),
	(94431, 112, '2015-03-01 01:25:25.000000', 'temperatura', 591.0000, 'ºC'),
	(94432, 112, '2015-03-01 01:25:26.000000', 'temperatura', 236.0000, 'ºC'),
	(94433, 112, '2015-03-01 01:25:27.000000', 'temperatura', 609.0000, 'ºC'),
	(94434, 112, '2015-03-01 01:25:28.000000', 'temperatura', 1135.0000, 'ºC'),
	(94435, 112, '2015-03-01 01:25:29.000000', 'temperatura', 251.0000, 'ºC'),
	(94436, 112, '2015-03-01 01:25:30.000000', 'temperatura', 249.0000, 'ºC'),
	(94437, 112, '2015-03-01 01:25:31.000000', 'temperatura', 491.0000, 'ºC'),
	(94438, 112, '2015-03-01 01:25:32.000000', 'temperatura', 508.0000, 'ºC'),
	(94439, 112, '2015-03-01 01:25:33.000000', 'temperatura', 1068.0000, 'ºC'),
	(94440, 112, '2015-03-01 01:25:34.000000', 'temperatura', 219.0000, 'ºC'),
	(94441, 112, '2015-03-01 01:25:35.000000', 'temperatura', 290.0000, 'ºC'),
	(94442, 112, '2015-03-01 01:25:36.000000', 'temperatura', 793.0000, 'ºC'),
	(94443, 112, '2015-03-01 01:25:37.000000', 'temperatura', 697.0000, 'ºC'),
	(94444, 112, '2015-03-01 01:25:38.000000', 'temperatura', 1107.0000, 'ºC'),
	(94445, 112, '2015-03-01 01:25:39.000000', 'temperatura', 1044.0000, 'ºC'),
	(94446, 112, '2015-03-01 01:25:40.000000', 'temperatura', 701.0000, 'ºC'),
	(94447, 112, '2015-03-01 01:25:41.000000', 'temperatura', 374.0000, 'ºC'),
	(94448, 112, '2015-03-01 01:25:42.000000', 'temperatura', 965.0000, 'ºC'),
	(94449, 112, '2015-03-01 01:25:43.000000', 'temperatura', 102.0000, 'ºC'),
	(94450, 112, '2015-03-01 01:25:44.000000', 'temperatura', 19.0000, 'ºC'),
	(94451, 112, '2015-03-01 01:25:45.000000', 'temperatura', 989.0000, 'ºC'),
	(94452, 112, '2015-03-01 01:25:46.000000', 'temperatura', 90.0000, 'ºC'),
	(94453, 112, '2015-03-01 01:25:47.000000', 'temperatura', 1080.0000, 'ºC'),
	(94454, 112, '2015-03-01 01:25:48.000000', 'temperatura', 332.0000, 'ºC'),
	(94455, 112, '2015-03-01 01:25:49.000000', 'temperatura', 820.0000, 'ºC'),
	(94456, 112, '2015-03-01 01:25:50.000000', 'temperatura', 706.0000, 'ºC'),
	(94457, 112, '2015-03-01 01:25:51.000000', 'temperatura', 1069.0000, 'ºC'),
	(94458, 112, '2015-03-01 01:25:52.000000', 'temperatura', 827.0000, 'ºC'),
	(94459, 112, '2015-03-01 01:25:53.000000', 'temperatura', 928.0000, 'ºC'),
	(94460, 112, '2015-03-01 01:25:54.000000', 'temperatura', 961.0000, 'ºC'),
	(94461, 112, '2015-03-01 01:25:55.000000', 'temperatura', 821.0000, 'ºC'),
	(94462, 112, '2015-03-01 01:25:56.000000', 'temperatura', 22.0000, 'ºC'),
	(94463, 112, '2015-03-01 01:25:57.000000', 'temperatura', 47.0000, 'ºC'),
	(94464, 112, '2015-03-01 01:25:58.000000', 'temperatura', 171.0000, 'ºC'),
	(94465, 112, '2015-03-01 01:25:59.000000', 'temperatura', 716.0000, 'ºC'),
	(94466, 112, '2015-03-01 01:26:00.000000', 'temperatura', 665.0000, 'ºC'),
	(94467, 112, '2015-03-01 01:26:01.000000', 'temperatura', 1177.0000, 'ºC'),
	(94468, 112, '2015-03-01 01:26:02.000000', 'temperatura', 293.0000, 'ºC'),
	(94469, 112, '2015-03-01 01:26:03.000000', 'temperatura', 334.0000, 'ºC'),
	(94470, 112, '2015-03-01 01:26:04.000000', 'temperatura', 792.0000, 'ºC'),
	(94471, 112, '2015-03-01 01:26:05.000000', 'temperatura', 556.0000, 'ºC'),
	(94472, 112, '2015-03-01 01:26:06.000000', 'temperatura', 408.0000, 'ºC'),
	(94473, 112, '2015-03-01 01:26:07.000000', 'temperatura', 370.0000, 'ºC'),
	(94474, 112, '2015-03-01 01:26:08.000000', 'temperatura', 628.0000, 'ºC'),
	(94475, 112, '2015-03-01 01:26:09.000000', 'temperatura', 829.0000, 'ºC'),
	(94476, 112, '2015-03-01 01:26:10.000000', 'temperatura', 1060.0000, 'ºC'),
	(94477, 112, '2015-03-01 01:26:11.000000', 'temperatura', 416.0000, 'ºC'),
	(94478, 112, '2015-03-01 01:26:12.000000', 'temperatura', 98.0000, 'ºC'),
	(94479, 112, '2015-03-01 01:26:13.000000', 'temperatura', 445.0000, 'ºC'),
	(94480, 112, '2015-03-01 01:26:14.000000', 'temperatura', 730.0000, 'ºC'),
	(94481, 112, '2015-03-01 01:26:15.000000', 'temperatura', 1115.0000, 'ºC'),
	(94482, 112, '2015-03-01 01:26:16.000000', 'temperatura', 986.0000, 'ºC'),
	(94483, 112, '2015-03-01 01:26:17.000000', 'temperatura', 383.0000, 'ºC'),
	(94484, 112, '2015-03-01 01:26:18.000000', 'temperatura', 161.0000, 'ºC'),
	(94485, 112, '2015-03-01 01:26:19.000000', 'temperatura', 857.0000, 'ºC'),
	(94486, 112, '2015-03-01 01:26:20.000000', 'temperatura', 200.0000, 'ºC'),
	(94487, 112, '2015-03-01 01:26:21.000000', 'temperatura', 830.0000, 'ºC'),
	(94488, 112, '2015-03-01 01:26:22.000000', 'temperatura', 1152.0000, 'ºC'),
	(94489, 112, '2015-03-01 01:26:23.000000', 'temperatura', 871.0000, 'ºC'),
	(94490, 112, '2015-03-01 01:26:24.000000', 'temperatura', 897.0000, 'ºC'),
	(94491, 112, '2015-03-01 01:26:25.000000', 'temperatura', 672.0000, 'ºC'),
	(94492, 112, '2015-03-01 01:26:26.000000', 'temperatura', 671.0000, 'ºC'),
	(94493, 112, '2015-03-01 01:26:27.000000', 'temperatura', 138.0000, 'ºC'),
	(94494, 112, '2015-03-01 01:26:28.000000', 'temperatura', 1077.0000, 'ºC'),
	(94495, 112, '2015-03-01 01:26:29.000000', 'temperatura', 170.0000, 'ºC'),
	(94496, 112, '2015-03-01 01:26:30.000000', 'temperatura', 23.0000, 'ºC'),
	(94497, 112, '2015-03-01 01:26:31.000000', 'temperatura', 805.0000, 'ºC'),
	(94498, 112, '2015-03-01 01:26:32.000000', 'temperatura', 358.0000, 'ºC'),
	(94499, 112, '2015-03-01 01:26:33.000000', 'temperatura', 575.0000, 'ºC'),
	(94500, 112, '2015-03-01 01:26:34.000000', 'temperatura', 599.0000, 'ºC'),
	(94501, 112, '2015-03-01 01:26:35.000000', 'temperatura', 73.0000, 'ºC'),
	(94502, 112, '2015-03-01 01:26:36.000000', 'temperatura', 967.0000, 'ºC'),
	(94503, 112, '2015-03-01 01:26:37.000000', 'temperatura', 1019.0000, 'ºC'),
	(94504, 112, '2015-03-01 01:26:38.000000', 'temperatura', 994.0000, 'ºC'),
	(94505, 112, '2015-03-01 01:26:39.000000', 'temperatura', 711.0000, 'ºC'),
	(94506, 112, '2015-03-01 01:26:40.000000', 'temperatura', 574.0000, 'ºC'),
	(94507, 112, '2015-03-01 01:26:41.000000', 'temperatura', 737.0000, 'ºC'),
	(94508, 112, '2015-03-01 01:26:42.000000', 'temperatura', 766.0000, 'ºC'),
	(94509, 112, '2015-03-01 01:26:43.000000', 'temperatura', 418.0000, 'ºC'),
	(94510, 112, '2015-03-01 01:26:44.000000', 'temperatura', 992.0000, 'ºC'),
	(94511, 112, '2015-03-01 01:26:45.000000', 'temperatura', 108.0000, 'ºC'),
	(94512, 112, '2015-03-01 01:26:46.000000', 'temperatura', 1164.0000, 'ºC'),
	(94513, 112, '2015-03-01 01:26:47.000000', 'temperatura', 697.0000, 'ºC'),
	(94514, 112, '2015-03-01 01:26:48.000000', 'temperatura', 1194.0000, 'ºC'),
	(94515, 112, '2015-03-01 01:26:49.000000', 'temperatura', 279.0000, 'ºC'),
	(94516, 112, '2015-03-01 01:26:50.000000', 'temperatura', 211.0000, 'ºC'),
	(94517, 112, '2015-03-01 01:26:51.000000', 'temperatura', 222.0000, 'ºC'),
	(94518, 112, '2015-03-01 01:26:52.000000', 'temperatura', 476.0000, 'ºC'),
	(94519, 112, '2015-03-01 01:26:53.000000', 'temperatura', 513.0000, 'ºC'),
	(94520, 112, '2015-03-01 01:26:54.000000', 'temperatura', 1139.0000, 'ºC'),
	(94521, 112, '2015-03-01 01:26:55.000000', 'temperatura', 555.0000, 'ºC'),
	(94522, 112, '2015-03-01 01:26:56.000000', 'temperatura', 559.0000, 'ºC'),
	(94523, 112, '2015-03-01 01:26:57.000000', 'temperatura', 1131.0000, 'ºC'),
	(94524, 112, '2015-03-01 01:26:58.000000', 'temperatura', 379.0000, 'ºC'),
	(94525, 112, '2015-03-01 01:26:59.000000', 'temperatura', 903.0000, 'ºC'),
	(94526, 112, '2015-03-01 01:27:00.000000', 'temperatura', 976.0000, 'ºC'),
	(94527, 112, '2015-03-01 01:27:01.000000', 'temperatura', 972.0000, 'ºC'),
	(94528, 112, '2015-03-01 01:27:02.000000', 'temperatura', 731.0000, 'ºC'),
	(94529, 112, '2015-03-01 01:27:03.000000', 'temperatura', 743.0000, 'ºC'),
	(94530, 112, '2015-03-01 01:27:04.000000', 'temperatura', 320.0000, 'ºC'),
	(94531, 112, '2015-03-01 01:27:05.000000', 'temperatura', 574.0000, 'ºC'),
	(94532, 112, '2015-03-01 01:27:06.000000', 'temperatura', 708.0000, 'ºC'),
	(94533, 112, '2015-03-01 01:27:07.000000', 'temperatura', 620.0000, 'ºC'),
	(94534, 112, '2015-03-01 01:27:08.000000', 'temperatura', 976.0000, 'ºC'),
	(94535, 112, '2015-03-01 01:27:09.000000', 'temperatura', 618.0000, 'ºC'),
	(94536, 112, '2015-03-01 01:27:10.000000', 'temperatura', 166.0000, 'ºC'),
	(94537, 112, '2015-03-01 01:27:11.000000', 'temperatura', 176.0000, 'ºC'),
	(94538, 112, '2015-03-01 01:27:12.000000', 'temperatura', 381.0000, 'ºC'),
	(94539, 112, '2015-03-01 01:27:13.000000', 'temperatura', 177.0000, 'ºC'),
	(94540, 112, '2015-03-01 01:27:14.000000', 'temperatura', 945.0000, 'ºC'),
	(94541, 112, '2015-03-01 01:27:15.000000', 'temperatura', 594.0000, 'ºC'),
	(94542, 112, '2015-03-01 01:27:16.000000', 'temperatura', 134.0000, 'ºC'),
	(94543, 112, '2015-03-01 01:27:17.000000', 'temperatura', 89.0000, 'ºC'),
	(94544, 112, '2015-03-01 01:27:18.000000', 'temperatura', 42.0000, 'ºC'),
	(94545, 112, '2015-03-01 01:27:19.000000', 'temperatura', 1144.0000, 'ºC'),
	(94546, 112, '2015-03-01 01:27:20.000000', 'temperatura', 794.0000, 'ºC'),
	(94547, 112, '2015-03-01 01:27:21.000000', 'temperatura', 541.0000, 'ºC'),
	(94548, 112, '2015-03-01 01:27:22.000000', 'temperatura', 323.0000, 'ºC'),
	(94549, 112, '2015-03-01 01:27:23.000000', 'temperatura', 1192.0000, 'ºC'),
	(94550, 112, '2015-03-01 01:27:24.000000', 'temperatura', 193.0000, 'ºC'),
	(94551, 112, '2015-03-01 01:27:25.000000', 'temperatura', 988.0000, 'ºC'),
	(94552, 112, '2015-03-01 01:27:26.000000', 'temperatura', 760.0000, 'ºC'),
	(94553, 112, '2015-03-01 01:27:27.000000', 'temperatura', 838.0000, 'ºC'),
	(94554, 112, '2015-03-01 01:27:28.000000', 'temperatura', 710.0000, 'ºC'),
	(94555, 112, '2015-03-01 01:27:29.000000', 'temperatura', 1036.0000, 'ºC'),
	(94556, 112, '2015-03-01 01:27:30.000000', 'temperatura', 649.0000, 'ºC'),
	(94557, 112, '2015-03-01 01:27:31.000000', 'temperatura', 138.0000, 'ºC'),
	(94558, 112, '2015-03-01 01:27:32.000000', 'temperatura', 1146.0000, 'ºC'),
	(94559, 112, '2015-03-01 01:27:33.000000', 'temperatura', 514.0000, 'ºC'),
	(94560, 112, '2015-03-01 01:27:34.000000', 'temperatura', 332.0000, 'ºC'),
	(94561, 112, '2015-03-01 01:27:35.000000', 'temperatura', 119.0000, 'ºC'),
	(94562, 112, '2015-03-01 01:27:36.000000', 'temperatura', 802.0000, 'ºC'),
	(94563, 112, '2015-03-01 01:27:37.000000', 'temperatura', 51.0000, 'ºC'),
	(94564, 112, '2015-03-01 01:27:38.000000', 'temperatura', 249.0000, 'ºC'),
	(94565, 112, '2015-03-01 01:27:39.000000', 'temperatura', 1094.0000, 'ºC'),
	(94566, 112, '2015-03-01 01:27:40.000000', 'temperatura', 1122.0000, 'ºC'),
	(94567, 112, '2015-03-01 01:27:41.000000', 'temperatura', 1130.0000, 'ºC'),
	(94568, 112, '2015-03-01 01:27:42.000000', 'temperatura', 1085.0000, 'ºC'),
	(94569, 112, '2015-03-01 01:27:43.000000', 'temperatura', 835.0000, 'ºC'),
	(94570, 112, '2015-03-01 01:27:44.000000', 'temperatura', 919.0000, 'ºC'),
	(94571, 112, '2015-03-01 01:27:45.000000', 'temperatura', 893.0000, 'ºC'),
	(94572, 112, '2015-03-01 01:27:46.000000', 'temperatura', 506.0000, 'ºC'),
	(94573, 112, '2015-03-01 01:27:47.000000', 'temperatura', 1054.0000, 'ºC'),
	(94574, 112, '2015-03-01 01:27:48.000000', 'temperatura', 150.0000, 'ºC'),
	(94575, 112, '2015-03-01 01:27:49.000000', 'temperatura', 1188.0000, 'ºC'),
	(94576, 112, '2015-03-01 01:27:50.000000', 'temperatura', 690.0000, 'ºC'),
	(94577, 112, '2015-03-01 01:27:51.000000', 'temperatura', 1086.0000, 'ºC'),
	(94578, 112, '2015-03-01 01:27:52.000000', 'temperatura', 962.0000, 'ºC'),
	(94579, 112, '2015-03-01 01:27:53.000000', 'temperatura', 353.0000, 'ºC'),
	(94580, 112, '2015-03-01 01:27:54.000000', 'temperatura', 79.0000, 'ºC'),
	(94581, 112, '2015-03-01 01:27:55.000000', 'temperatura', 537.0000, 'ºC'),
	(94582, 112, '2015-03-01 01:27:56.000000', 'temperatura', 49.0000, 'ºC'),
	(94583, 112, '2015-03-01 01:27:57.000000', 'temperatura', 1034.0000, 'ºC'),
	(94584, 112, '2015-03-01 01:27:58.000000', 'temperatura', 224.0000, 'ºC'),
	(94585, 112, '2015-03-01 01:27:59.000000', 'temperatura', 419.0000, 'ºC'),
	(94586, 112, '2015-03-01 01:28:00.000000', 'temperatura', 221.0000, 'ºC'),
	(94587, 112, '2015-03-01 01:28:01.000000', 'temperatura', 1051.0000, 'ºC'),
	(94588, 112, '2015-03-01 01:28:02.000000', 'temperatura', 994.0000, 'ºC'),
	(94589, 112, '2015-03-01 01:28:03.000000', 'temperatura', 615.0000, 'ºC'),
	(94590, 112, '2015-03-01 01:28:04.000000', 'temperatura', 94.0000, 'ºC'),
	(94591, 112, '2015-03-01 01:28:05.000000', 'temperatura', 1026.0000, 'ºC'),
	(94592, 112, '2015-03-01 01:28:06.000000', 'temperatura', 46.0000, 'ºC'),
	(94593, 112, '2015-03-01 01:28:07.000000', 'temperatura', 755.0000, 'ºC'),
	(94594, 112, '2015-03-01 01:28:08.000000', 'temperatura', 36.0000, 'ºC'),
	(94595, 112, '2015-03-01 01:28:09.000000', 'temperatura', 315.0000, 'ºC'),
	(94596, 112, '2015-03-01 01:28:10.000000', 'temperatura', 268.0000, 'ºC'),
	(94597, 112, '2015-03-01 01:28:11.000000', 'temperatura', 395.0000, 'ºC'),
	(94598, 112, '2015-03-01 01:28:12.000000', 'temperatura', 1172.0000, 'ºC'),
	(94599, 112, '2015-03-01 01:28:13.000000', 'temperatura', 1074.0000, 'ºC'),
	(94600, 112, '2015-03-01 01:28:14.000000', 'temperatura', 654.0000, 'ºC'),
	(94601, 112, '2015-03-01 01:28:15.000000', 'temperatura', 49.0000, 'ºC'),
	(94602, 112, '2015-03-01 01:28:16.000000', 'temperatura', 682.0000, 'ºC'),
	(94603, 112, '2015-03-01 01:28:17.000000', 'temperatura', 866.0000, 'ºC'),
	(94604, 112, '2015-03-01 01:28:18.000000', 'temperatura', 1084.0000, 'ºC'),
	(94605, 112, '2015-03-01 01:28:19.000000', 'temperatura', 423.0000, 'ºC'),
	(94606, 112, '2015-03-01 01:28:20.000000', 'temperatura', 62.0000, 'ºC'),
	(94607, 112, '2015-03-01 01:28:21.000000', 'temperatura', 241.0000, 'ºC'),
	(94608, 112, '2015-03-01 01:28:22.000000', 'temperatura', 1019.0000, 'ºC'),
	(94609, 112, '2015-03-01 01:28:23.000000', 'temperatura', 771.0000, 'ºC'),
	(94610, 112, '2015-03-01 01:28:24.000000', 'temperatura', 802.0000, 'ºC'),
	(94611, 112, '2015-03-01 01:28:25.000000', 'temperatura', 496.0000, 'ºC'),
	(94612, 112, '2015-03-01 01:28:26.000000', 'temperatura', 73.0000, 'ºC'),
	(94613, 112, '2015-03-01 01:28:27.000000', 'temperatura', 79.0000, 'ºC'),
	(94614, 112, '2015-03-01 01:28:28.000000', 'temperatura', 174.0000, 'ºC'),
	(94615, 112, '2015-03-01 01:28:29.000000', 'temperatura', 636.0000, 'ºC'),
	(94616, 112, '2015-03-01 01:28:30.000000', 'temperatura', 258.0000, 'ºC'),
	(94617, 112, '2015-03-01 01:28:31.000000', 'temperatura', 582.0000, 'ºC'),
	(94618, 112, '2015-03-01 01:28:32.000000', 'temperatura', 938.0000, 'ºC'),
	(94619, 112, '2015-03-01 01:28:33.000000', 'temperatura', 544.0000, 'ºC'),
	(94620, 112, '2015-03-01 01:28:34.000000', 'temperatura', 1106.0000, 'ºC'),
	(94621, 112, '2015-03-01 01:28:35.000000', 'temperatura', 297.0000, 'ºC'),
	(94622, 112, '2015-03-01 01:28:36.000000', 'temperatura', 570.0000, 'ºC'),
	(94623, 112, '2015-03-01 01:28:37.000000', 'temperatura', 758.0000, 'ºC'),
	(94624, 112, '2015-03-01 01:28:38.000000', 'temperatura', 882.0000, 'ºC'),
	(94625, 112, '2015-03-01 01:28:39.000000', 'temperatura', 936.0000, 'ºC'),
	(94626, 112, '2015-03-01 01:28:40.000000', 'temperatura', 833.0000, 'ºC'),
	(94627, 112, '2015-03-01 01:28:41.000000', 'temperatura', 158.0000, 'ºC'),
	(94628, 112, '2015-03-01 01:28:42.000000', 'temperatura', 690.0000, 'ºC'),
	(94629, 112, '2015-03-01 01:28:43.000000', 'temperatura', 577.0000, 'ºC'),
	(94630, 112, '2015-03-01 01:28:44.000000', 'temperatura', 817.0000, 'ºC'),
	(94631, 112, '2015-03-01 01:28:45.000000', 'temperatura', 1153.0000, 'ºC'),
	(94632, 112, '2015-03-01 01:28:46.000000', 'temperatura', 917.0000, 'ºC'),
	(94633, 112, '2015-03-01 01:28:47.000000', 'temperatura', 1125.0000, 'ºC'),
	(94634, 112, '2015-03-01 01:28:48.000000', 'temperatura', 475.0000, 'ºC'),
	(94635, 112, '2015-03-01 01:28:49.000000', 'temperatura', 199.0000, 'ºC'),
	(94636, 112, '2015-03-01 01:28:50.000000', 'temperatura', 771.0000, 'ºC'),
	(94637, 112, '2015-03-01 01:28:51.000000', 'temperatura', 860.0000, 'ºC'),
	(94638, 112, '2015-03-01 01:28:52.000000', 'temperatura', 786.0000, 'ºC'),
	(94639, 112, '2015-03-01 01:28:53.000000', 'temperatura', 151.0000, 'ºC'),
	(94640, 112, '2015-03-01 01:28:54.000000', 'temperatura', 798.0000, 'ºC'),
	(94641, 112, '2015-03-01 01:28:55.000000', 'temperatura', 1136.0000, 'ºC'),
	(94642, 112, '2015-03-01 01:28:56.000000', 'temperatura', 887.0000, 'ºC'),
	(94643, 112, '2015-03-01 01:28:57.000000', 'temperatura', 1026.0000, 'ºC'),
	(94644, 112, '2015-03-01 01:28:58.000000', 'temperatura', 70.0000, 'ºC'),
	(94645, 112, '2015-03-01 01:28:59.000000', 'temperatura', 872.0000, 'ºC'),
	(94646, 112, '2015-03-01 01:29:00.000000', 'temperatura', 549.0000, 'ºC'),
	(94647, 112, '2015-03-01 01:29:01.000000', 'temperatura', 131.0000, 'ºC'),
	(94648, 112, '2015-03-01 01:29:02.000000', 'temperatura', 211.0000, 'ºC'),
	(94649, 112, '2015-03-01 01:29:03.000000', 'temperatura', 659.0000, 'ºC'),
	(94650, 112, '2015-03-01 01:29:04.000000', 'temperatura', 265.0000, 'ºC'),
	(94651, 112, '2015-03-01 01:29:05.000000', 'temperatura', 548.0000, 'ºC'),
	(94652, 112, '2015-03-01 01:29:06.000000', 'temperatura', 744.0000, 'ºC'),
	(94653, 112, '2015-03-01 01:29:07.000000', 'temperatura', 879.0000, 'ºC'),
	(94654, 112, '2015-03-01 01:29:08.000000', 'temperatura', 961.0000, 'ºC'),
	(94655, 112, '2015-03-01 01:29:09.000000', 'temperatura', 969.0000, 'ºC'),
	(94656, 112, '2015-03-01 01:29:10.000000', 'temperatura', 764.0000, 'ºC'),
	(94657, 112, '2015-03-01 01:29:11.000000', 'temperatura', 914.0000, 'ºC'),
	(94658, 112, '2015-03-01 01:29:12.000000', 'temperatura', 1076.0000, 'ºC'),
	(94659, 112, '2015-03-01 01:29:13.000000', 'temperatura', 240.0000, 'ºC'),
	(94660, 112, '2015-03-01 01:29:14.000000', 'temperatura', 371.0000, 'ºC'),
	(94661, 112, '2015-03-01 01:29:15.000000', 'temperatura', 1138.0000, 'ºC'),
	(94662, 112, '2015-03-01 01:29:16.000000', 'temperatura', 974.0000, 'ºC'),
	(94663, 112, '2015-03-01 01:29:17.000000', 'temperatura', 260.0000, 'ºC'),
	(94664, 112, '2015-03-01 01:29:18.000000', 'temperatura', 777.0000, 'ºC'),
	(94665, 112, '2015-03-01 01:29:19.000000', 'temperatura', 704.0000, 'ºC'),
	(94666, 112, '2015-03-01 01:29:20.000000', 'temperatura', 1192.0000, 'ºC'),
	(94667, 112, '2015-03-01 01:29:21.000000', 'temperatura', 246.0000, 'ºC'),
	(94668, 112, '2015-03-01 01:29:22.000000', 'temperatura', 55.0000, 'ºC'),
	(94669, 112, '2015-03-01 01:29:23.000000', 'temperatura', 736.0000, 'ºC'),
	(94670, 112, '2015-03-01 01:29:24.000000', 'temperatura', 1118.0000, 'ºC'),
	(94671, 112, '2015-03-01 01:29:25.000000', 'temperatura', 982.0000, 'ºC'),
	(94672, 112, '2015-03-01 01:29:26.000000', 'temperatura', 357.0000, 'ºC'),
	(94673, 112, '2015-03-01 01:29:27.000000', 'temperatura', 39.0000, 'ºC'),
	(94674, 112, '2015-03-01 01:29:28.000000', 'temperatura', 326.0000, 'ºC'),
	(94675, 112, '2015-03-01 01:29:29.000000', 'temperatura', 312.0000, 'ºC'),
	(94676, 112, '2015-03-01 01:29:30.000000', 'temperatura', 581.0000, 'ºC'),
	(94677, 112, '2015-03-01 01:29:31.000000', 'temperatura', 771.0000, 'ºC'),
	(94678, 112, '2015-03-01 01:29:32.000000', 'temperatura', 914.0000, 'ºC'),
	(94679, 112, '2015-03-01 01:29:33.000000', 'temperatura', 1058.0000, 'ºC'),
	(94680, 112, '2015-03-01 01:29:34.000000', 'temperatura', 148.0000, 'ºC'),
	(94681, 112, '2015-03-01 01:29:35.000000', 'temperatura', 1164.0000, 'ºC'),
	(94682, 112, '2015-03-01 01:29:36.000000', 'temperatura', 579.0000, 'ºC'),
	(94683, 112, '2015-03-01 01:29:37.000000', 'temperatura', 602.0000, 'ºC'),
	(94684, 112, '2015-03-01 01:29:38.000000', 'temperatura', 74.0000, 'ºC'),
	(94685, 112, '2015-03-01 01:29:39.000000', 'temperatura', 964.0000, 'ºC'),
	(94686, 112, '2015-03-01 01:29:40.000000', 'temperatura', 1000.0000, 'ºC'),
	(94687, 112, '2015-03-01 01:29:41.000000', 'temperatura', 908.0000, 'ºC'),
	(94688, 112, '2015-03-01 01:29:42.000000', 'temperatura', 339.0000, 'ºC'),
	(94689, 112, '2015-03-01 01:29:43.000000', 'temperatura', 172.0000, 'ºC'),
	(94690, 112, '2015-03-01 01:29:44.000000', 'temperatura', 1042.0000, 'ºC'),
	(94691, 112, '2015-03-01 01:29:45.000000', 'temperatura', 1098.0000, 'ºC'),
	(94692, 112, '2015-03-01 01:29:46.000000', 'temperatura', 1162.0000, 'ºC'),
	(94693, 112, '2015-03-01 01:29:47.000000', 'temperatura', 117.0000, 'ºC'),
	(94694, 112, '2015-03-01 01:29:48.000000', 'temperatura', 698.0000, 'ºC'),
	(94695, 112, '2015-03-01 01:29:49.000000', 'temperatura', 739.0000, 'ºC'),
	(94696, 112, '2015-03-01 01:29:50.000000', 'temperatura', 404.0000, 'ºC'),
	(94697, 112, '2015-03-01 01:29:51.000000', 'temperatura', 1005.0000, 'ºC'),
	(94698, 112, '2015-03-01 01:29:52.000000', 'temperatura', 210.0000, 'ºC'),
	(94699, 112, '2015-03-01 01:29:53.000000', 'temperatura', 437.0000, 'ºC'),
	(94700, 112, '2015-03-01 01:29:54.000000', 'temperatura', 354.0000, 'ºC'),
	(94701, 112, '2015-03-01 01:29:55.000000', 'temperatura', 460.0000, 'ºC'),
	(94702, 112, '2015-03-01 01:29:56.000000', 'temperatura', 38.0000, 'ºC'),
	(94703, 112, '2015-03-01 01:29:57.000000', 'temperatura', 12.0000, 'ºC'),
	(94704, 112, '2015-03-01 01:29:58.000000', 'temperatura', 1146.0000, 'ºC'),
	(94705, 112, '2015-03-01 01:29:59.000000', 'temperatura', 894.0000, 'ºC'),
	(94706, 112, '2015-03-01 01:30:00.000000', 'temperatura', 1032.0000, 'ºC'),
	(94707, 112, '2015-03-01 01:30:01.000000', 'temperatura', 79.0000, 'ºC'),
	(94708, 112, '2015-03-01 01:30:02.000000', 'temperatura', 901.0000, 'ºC'),
	(94709, 112, '2015-03-01 01:30:03.000000', 'temperatura', 669.0000, 'ºC'),
	(94710, 112, '2015-03-01 01:30:04.000000', 'temperatura', 643.0000, 'ºC'),
	(94711, 112, '2015-03-01 01:30:05.000000', 'temperatura', 7.0000, 'ºC'),
	(94712, 112, '2015-03-01 01:30:06.000000', 'temperatura', 509.0000, 'ºC'),
	(94713, 112, '2015-03-01 01:30:07.000000', 'temperatura', 122.0000, 'ºC'),
	(94714, 112, '2015-03-01 01:30:08.000000', 'temperatura', 284.0000, 'ºC'),
	(94715, 112, '2015-03-01 01:30:09.000000', 'temperatura', 1055.0000, 'ºC'),
	(94716, 112, '2015-03-01 01:30:10.000000', 'temperatura', 822.0000, 'ºC'),
	(94717, 112, '2015-03-01 01:30:11.000000', 'temperatura', 945.0000, 'ºC'),
	(94718, 112, '2015-03-01 01:30:12.000000', 'temperatura', 1060.0000, 'ºC'),
	(94719, 112, '2015-03-01 01:30:13.000000', 'temperatura', 67.0000, 'ºC'),
	(94720, 112, '2015-03-01 01:30:14.000000', 'temperatura', 756.0000, 'ºC'),
	(94721, 112, '2015-03-01 01:30:15.000000', 'temperatura', 1177.0000, 'ºC'),
	(94722, 112, '2015-03-01 01:30:16.000000', 'temperatura', 20.0000, 'ºC'),
	(94723, 112, '2015-03-01 01:30:17.000000', 'temperatura', 169.0000, 'ºC'),
	(94724, 108, '2015-03-15 00:00:00.000000', 'temperatura', 1024.0000, 'ºC'),
	(94725, 108, '2015-03-15 00:00:01.000000', 'temperatura', 360.0000, 'ºC'),
	(94726, 108, '2015-03-15 00:00:02.000000', 'temperatura', 1129.0000, 'ºC'),
	(94727, 108, '2015-03-15 00:00:03.000000', 'temperatura', 964.0000, 'ºC'),
	(94728, 108, '2015-03-15 00:00:04.000000', 'temperatura', 236.0000, 'ºC'),
	(94729, 108, '2015-03-15 00:00:05.000000', 'temperatura', 687.0000, 'ºC'),
	(94730, 108, '2015-03-15 00:00:06.000000', 'temperatura', 329.0000, 'ºC'),
	(94731, 108, '2015-03-15 00:00:07.000000', 'temperatura', 782.0000, 'ºC'),
	(94732, 108, '2015-03-15 00:00:08.000000', 'temperatura', 526.0000, 'ºC'),
	(94733, 108, '2015-03-15 00:00:09.000000', 'temperatura', 283.0000, 'ºC'),
	(94734, 108, '2015-03-15 00:00:10.000000', 'temperatura', 1038.0000, 'ºC'),
	(94735, 108, '2015-03-15 00:00:11.000000', 'temperatura', 742.0000, 'ºC'),
	(94736, 108, '2015-03-15 00:00:12.000000', 'temperatura', 596.0000, 'ºC'),
	(94737, 108, '2015-03-15 00:00:13.000000', 'temperatura', 755.0000, 'ºC'),
	(94738, 108, '2015-03-15 00:00:14.000000', 'temperatura', 788.0000, 'ºC'),
	(94739, 108, '2015-03-15 00:00:15.000000', 'temperatura', 476.0000, 'ºC'),
	(94740, 108, '2015-03-15 00:00:16.000000', 'temperatura', 18.0000, 'ºC'),
	(94741, 108, '2015-03-15 00:00:17.000000', 'temperatura', 1059.0000, 'ºC'),
	(94742, 108, '2015-03-15 00:00:18.000000', 'temperatura', 443.0000, 'ºC'),
	(94743, 108, '2015-03-15 00:00:19.000000', 'temperatura', 236.0000, 'ºC'),
	(94744, 108, '2015-03-15 00:00:20.000000', 'temperatura', 1055.0000, 'ºC'),
	(94745, 108, '2015-03-15 00:00:21.000000', 'temperatura', 966.0000, 'ºC'),
	(94746, 108, '2015-03-15 00:00:22.000000', 'temperatura', 467.0000, 'ºC'),
	(94747, 108, '2015-03-15 00:00:23.000000', 'temperatura', 635.0000, 'ºC'),
	(94748, 108, '2015-03-15 00:00:24.000000', 'temperatura', 576.0000, 'ºC'),
	(94749, 108, '2015-03-15 00:00:25.000000', 'temperatura', 973.0000, 'ºC'),
	(94750, 108, '2015-03-15 00:00:26.000000', 'temperatura', 741.0000, 'ºC'),
	(94751, 108, '2015-03-15 00:00:27.000000', 'temperatura', 785.0000, 'ºC'),
	(94752, 108, '2015-03-15 00:00:28.000000', 'temperatura', 501.0000, 'ºC'),
	(94753, 108, '2015-03-15 00:00:29.000000', 'temperatura', 151.0000, 'ºC'),
	(94754, 108, '2015-03-15 00:00:30.000000', 'temperatura', 455.0000, 'ºC'),
	(94755, 108, '2015-03-15 00:00:31.000000', 'temperatura', 621.0000, 'ºC'),
	(94756, 108, '2015-03-15 00:00:32.000000', 'temperatura', 540.0000, 'ºC'),
	(94757, 108, '2015-03-15 00:00:33.000000', 'temperatura', 837.0000, 'ºC'),
	(94758, 108, '2015-03-15 00:00:34.000000', 'temperatura', 165.0000, 'ºC'),
	(94759, 108, '2015-03-15 00:00:35.000000', 'temperatura', 716.0000, 'ºC'),
	(94760, 108, '2015-03-15 00:00:36.000000', 'temperatura', 685.0000, 'ºC'),
	(94761, 108, '2015-03-15 00:00:37.000000', 'temperatura', 76.0000, 'ºC'),
	(94762, 108, '2015-03-15 00:00:38.000000', 'temperatura', 727.0000, 'ºC'),
	(94763, 108, '2015-03-15 00:00:39.000000', 'temperatura', 1007.0000, 'ºC'),
	(94764, 108, '2015-03-15 00:00:40.000000', 'temperatura', 453.0000, 'ºC'),
	(94765, 108, '2015-03-15 00:00:41.000000', 'temperatura', 444.0000, 'ºC'),
	(94766, 108, '2015-03-15 00:00:42.000000', 'temperatura', 861.0000, 'ºC'),
	(94767, 108, '2015-03-15 00:00:43.000000', 'temperatura', 573.0000, 'ºC'),
	(94768, 108, '2015-03-15 00:00:44.000000', 'temperatura', 283.0000, 'ºC'),
	(94769, 108, '2015-03-15 00:00:45.000000', 'temperatura', 897.0000, 'ºC'),
	(94770, 108, '2015-03-15 00:00:46.000000', 'temperatura', 38.0000, 'ºC'),
	(94771, 108, '2015-03-15 00:00:47.000000', 'temperatura', 1100.0000, 'ºC'),
	(94772, 108, '2015-03-15 00:00:48.000000', 'temperatura', 585.0000, 'ºC'),
	(94773, 108, '2015-03-15 00:00:49.000000', 'temperatura', 826.0000, 'ºC'),
	(94774, 108, '2015-03-15 00:00:50.000000', 'temperatura', 1174.0000, 'ºC'),
	(94775, 108, '2015-03-15 00:00:51.000000', 'temperatura', 994.0000, 'ºC'),
	(94776, 108, '2015-03-15 00:00:52.000000', 'temperatura', 247.0000, 'ºC'),
	(94777, 108, '2015-03-15 00:00:53.000000', 'temperatura', 653.0000, 'ºC'),
	(94778, 108, '2015-03-15 00:00:54.000000', 'temperatura', 124.0000, 'ºC'),
	(94779, 108, '2015-03-15 00:00:55.000000', 'temperatura', 1062.0000, 'ºC'),
	(94780, 108, '2015-03-15 00:00:56.000000', 'temperatura', 140.0000, 'ºC'),
	(94781, 108, '2015-03-15 00:00:57.000000', 'temperatura', 1115.0000, 'ºC'),
	(94782, 108, '2015-03-15 00:00:58.000000', 'temperatura', 356.0000, 'ºC'),
	(94783, 108, '2015-03-15 00:00:59.000000', 'temperatura', 836.0000, 'ºC'),
	(94784, 108, '2015-03-15 00:01:00.000000', 'temperatura', 713.0000, 'ºC'),
	(94785, 108, '2015-03-15 00:01:01.000000', 'temperatura', 1058.0000, 'ºC'),
	(94786, 108, '2015-03-15 00:01:02.000000', 'temperatura', 749.0000, 'ºC'),
	(94787, 108, '2015-03-15 00:01:03.000000', 'temperatura', 573.0000, 'ºC'),
	(94788, 108, '2015-03-15 00:01:04.000000', 'temperatura', 618.0000, 'ºC'),
	(94789, 108, '2015-03-15 00:01:05.000000', 'temperatura', 173.0000, 'ºC'),
	(94790, 108, '2015-03-15 00:01:06.000000', 'temperatura', 211.0000, 'ºC'),
	(94791, 108, '2015-03-15 00:01:07.000000', 'temperatura', 535.0000, 'ºC'),
	(94792, 108, '2015-03-15 00:01:08.000000', 'temperatura', 842.0000, 'ºC'),
	(94793, 108, '2015-03-15 00:01:09.000000', 'temperatura', 208.0000, 'ºC'),
	(94794, 108, '2015-03-15 00:01:10.000000', 'temperatura', 915.0000, 'ºC'),
	(94795, 108, '2015-03-15 00:01:11.000000', 'temperatura', 349.0000, 'ºC'),
	(94796, 108, '2015-03-15 00:01:12.000000', 'temperatura', 199.0000, 'ºC'),
	(94797, 108, '2015-03-15 00:01:13.000000', 'temperatura', 1152.0000, 'ºC'),
	(94798, 108, '2015-03-15 00:01:14.000000', 'temperatura', 363.0000, 'ºC'),
	(94799, 108, '2015-03-15 00:01:15.000000', 'temperatura', 761.0000, 'ºC'),
	(94800, 108, '2015-03-15 00:01:16.000000', 'temperatura', 315.0000, 'ºC'),
	(94801, 108, '2015-03-15 00:01:17.000000', 'temperatura', 491.0000, 'ºC'),
	(94802, 108, '2015-03-15 00:01:18.000000', 'temperatura', 313.0000, 'ºC'),
	(94803, 108, '2015-03-15 00:01:19.000000', 'temperatura', 92.0000, 'ºC'),
	(94804, 108, '2015-03-15 00:01:20.000000', 'temperatura', 722.0000, 'ºC'),
	(94805, 108, '2015-03-15 00:01:21.000000', 'temperatura', 935.0000, 'ºC'),
	(94806, 108, '2015-03-15 00:01:22.000000', 'temperatura', 108.0000, 'ºC'),
	(94807, 108, '2015-03-15 00:01:23.000000', 'temperatura', 135.0000, 'ºC'),
	(94808, 108, '2015-03-15 00:01:24.000000', 'temperatura', 351.0000, 'ºC'),
	(94809, 108, '2015-03-15 00:01:25.000000', 'temperatura', 151.0000, 'ºC'),
	(94810, 108, '2015-03-15 00:01:26.000000', 'temperatura', 903.0000, 'ºC'),
	(94811, 108, '2015-03-15 00:01:27.000000', 'temperatura', 462.0000, 'ºC'),
	(94812, 108, '2015-03-15 00:01:28.000000', 'temperatura', 800.0000, 'ºC'),
	(94813, 108, '2015-03-15 00:01:29.000000', 'temperatura', 214.0000, 'ºC'),
	(94814, 108, '2015-03-15 00:01:30.000000', 'temperatura', 1071.0000, 'ºC'),
	(94815, 108, '2015-03-15 00:01:31.000000', 'temperatura', 1116.0000, 'ºC'),
	(94816, 108, '2015-03-15 00:01:32.000000', 'temperatura', 1166.0000, 'ºC'),
	(94817, 108, '2015-03-15 00:01:33.000000', 'temperatura', 84.0000, 'ºC'),
	(94818, 108, '2015-03-15 00:01:34.000000', 'temperatura', 522.0000, 'ºC'),
	(94819, 108, '2015-03-15 00:01:35.000000', 'temperatura', 1159.0000, 'ºC'),
	(94820, 108, '2015-03-15 00:01:36.000000', 'temperatura', 627.0000, 'ºC'),
	(94821, 108, '2015-03-15 00:01:37.000000', 'temperatura', 861.0000, 'ºC'),
	(94822, 108, '2015-03-15 00:01:38.000000', 'temperatura', 25.0000, 'ºC'),
	(94823, 108, '2015-03-15 00:01:39.000000', 'temperatura', 1143.0000, 'ºC'),
	(94824, 108, '2015-03-15 00:01:40.000000', 'temperatura', 838.0000, 'ºC'),
	(94825, 108, '2015-03-15 00:01:41.000000', 'temperatura', 764.0000, 'ºC'),
	(94826, 108, '2015-03-15 00:01:42.000000', 'temperatura', 107.0000, 'ºC'),
	(94827, 108, '2015-03-15 00:01:43.000000', 'temperatura', 643.0000, 'ºC'),
	(94828, 108, '2015-03-15 00:01:44.000000', 'temperatura', 494.0000, 'ºC'),
	(94829, 108, '2015-03-15 00:01:45.000000', 'temperatura', 540.0000, 'ºC'),
	(94830, 108, '2015-03-15 00:01:46.000000', 'temperatura', 19.0000, 'ºC'),
	(94831, 108, '2015-03-15 00:01:47.000000', 'temperatura', 878.0000, 'ºC'),
	(94832, 108, '2015-03-15 00:01:48.000000', 'temperatura', 731.0000, 'ºC'),
	(94833, 108, '2015-03-15 00:01:49.000000', 'temperatura', 1022.0000, 'ºC'),
	(94834, 108, '2015-03-15 00:01:50.000000', 'temperatura', 516.0000, 'ºC'),
	(94835, 108, '2015-03-15 00:01:51.000000', 'temperatura', 718.0000, 'ºC'),
	(94836, 108, '2015-03-15 00:01:52.000000', 'temperatura', 840.0000, 'ºC'),
	(94837, 108, '2015-03-15 00:01:53.000000', 'temperatura', 846.0000, 'ºC'),
	(94838, 108, '2015-03-15 00:01:54.000000', 'temperatura', 512.0000, 'ºC'),
	(94839, 108, '2015-03-15 00:01:55.000000', 'temperatura', 23.0000, 'ºC'),
	(94840, 108, '2015-03-15 00:01:56.000000', 'temperatura', 977.0000, 'ºC'),
	(94841, 108, '2015-03-15 00:01:57.000000', 'temperatura', 18.0000, 'ºC'),
	(94842, 108, '2015-03-15 00:01:58.000000', 'temperatura', 758.0000, 'ºC'),
	(94843, 108, '2015-03-15 00:01:59.000000', 'temperatura', 139.0000, 'ºC'),
	(94844, 108, '2015-03-15 00:02:00.000000', 'temperatura', 820.0000, 'ºC'),
	(94845, 108, '2015-03-15 00:02:01.000000', 'temperatura', 83.0000, 'ºC'),
	(94846, 108, '2015-03-15 00:02:02.000000', 'temperatura', 355.0000, 'ºC'),
	(94847, 108, '2015-03-15 00:02:03.000000', 'temperatura', 328.0000, 'ºC'),
	(94848, 108, '2015-03-15 00:02:04.000000', 'temperatura', 576.0000, 'ºC'),
	(94849, 108, '2015-03-15 00:02:05.000000', 'temperatura', 696.0000, 'ºC'),
	(94850, 108, '2015-03-15 00:02:06.000000', 'temperatura', 554.0000, 'ºC'),
	(94851, 108, '2015-03-15 00:02:07.000000', 'temperatura', 683.0000, 'ºC'),
	(94852, 108, '2015-03-15 00:02:08.000000', 'temperatura', 554.0000, 'ºC'),
	(94853, 108, '2015-03-15 00:02:09.000000', 'temperatura', 718.0000, 'ºC'),
	(94854, 108, '2015-03-15 00:02:10.000000', 'temperatura', 732.0000, 'ºC'),
	(94855, 108, '2015-03-15 00:02:11.000000', 'temperatura', 305.0000, 'ºC'),
	(94856, 108, '2015-03-15 00:02:12.000000', 'temperatura', 530.0000, 'ºC'),
	(94857, 108, '2015-03-15 00:02:13.000000', 'temperatura', 535.0000, 'ºC'),
	(94858, 108, '2015-03-15 00:02:14.000000', 'temperatura', 1088.0000, 'ºC'),
	(94859, 108, '2015-03-15 00:02:15.000000', 'temperatura', 232.0000, 'ºC'),
	(94860, 108, '2015-03-15 00:02:16.000000', 'temperatura', 300.0000, 'ºC'),
	(94861, 108, '2015-03-15 00:02:17.000000', 'temperatura', 802.0000, 'ºC'),
	(94862, 108, '2015-03-15 00:02:18.000000', 'temperatura', 711.0000, 'ºC'),
	(94863, 108, '2015-03-15 00:02:19.000000', 'temperatura', 1150.0000, 'ºC'),
	(94864, 108, '2015-03-15 00:02:20.000000', 'temperatura', 17.0000, 'ºC'),
	(94865, 108, '2015-03-15 00:02:21.000000', 'temperatura', 235.0000, 'ºC'),
	(94866, 108, '2015-03-15 00:02:22.000000', 'temperatura', 1124.0000, 'ºC'),
	(94867, 108, '2015-03-15 00:02:23.000000', 'temperatura', 117.0000, 'ºC'),
	(94868, 108, '2015-03-15 00:02:24.000000', 'temperatura', 814.0000, 'ºC'),
	(94869, 108, '2015-03-15 00:02:25.000000', 'temperatura', 119.0000, 'ºC'),
	(94870, 108, '2015-03-15 00:02:26.000000', 'temperatura', 552.0000, 'ºC'),
	(94871, 108, '2015-03-15 00:02:27.000000', 'temperatura', 5.0000, 'ºC'),
	(94872, 108, '2015-03-15 00:02:28.000000', 'temperatura', 770.0000, 'ºC'),
	(94873, 108, '2015-03-15 00:02:29.000000', 'temperatura', 236.0000, 'ºC'),
	(94874, 108, '2015-03-15 00:02:30.000000', 'temperatura', 70.0000, 'ºC'),
	(94875, 108, '2015-03-15 00:02:31.000000', 'temperatura', 843.0000, 'ºC'),
	(94876, 108, '2015-03-15 00:02:32.000000', 'temperatura', 404.0000, 'ºC'),
	(94877, 108, '2015-03-15 00:02:33.000000', 'temperatura', 694.0000, 'ºC'),
	(94878, 108, '2015-03-15 00:02:34.000000', 'temperatura', 1058.0000, 'ºC'),
	(94879, 108, '2015-03-15 00:02:35.000000', 'temperatura', 809.0000, 'ºC'),
	(94880, 108, '2015-03-15 00:02:36.000000', 'temperatura', 873.0000, 'ºC'),
	(94881, 108, '2015-03-15 00:02:37.000000', 'temperatura', 737.0000, 'ºC'),
	(94882, 108, '2015-03-15 00:02:38.000000', 'temperatura', 1064.0000, 'ºC'),
	(94883, 108, '2015-03-15 00:02:39.000000', 'temperatura', 713.0000, 'ºC'),
	(94884, 108, '2015-03-15 00:02:40.000000', 'temperatura', 373.0000, 'ºC'),
	(94885, 108, '2015-03-15 00:02:41.000000', 'temperatura', 927.0000, 'ºC'),
	(94886, 108, '2015-03-15 00:02:42.000000', 'temperatura', 1114.0000, 'ºC'),
	(94887, 108, '2015-03-15 00:02:43.000000', 'temperatura', 391.0000, 'ºC'),
	(94888, 108, '2015-03-15 00:02:44.000000', 'temperatura', 1012.0000, 'ºC'),
	(94889, 108, '2015-03-15 00:02:45.000000', 'temperatura', 289.0000, 'ºC'),
	(94890, 108, '2015-03-15 00:02:46.000000', 'temperatura', 811.0000, 'ºC'),
	(94891, 108, '2015-03-15 00:02:47.000000', 'temperatura', 787.0000, 'ºC'),
	(94892, 108, '2015-03-15 00:02:48.000000', 'temperatura', 302.0000, 'ºC'),
	(94893, 108, '2015-03-15 00:02:49.000000', 'temperatura', 351.0000, 'ºC'),
	(94894, 108, '2015-03-15 00:02:50.000000', 'temperatura', 849.0000, 'ºC'),
	(94895, 108, '2015-03-15 00:02:51.000000', 'temperatura', 792.0000, 'ºC'),
	(94896, 108, '2015-03-15 00:02:52.000000', 'temperatura', 212.0000, 'ºC'),
	(94897, 108, '2015-03-15 00:02:53.000000', 'temperatura', 1087.0000, 'ºC'),
	(94898, 108, '2015-03-15 00:02:54.000000', 'temperatura', 1199.0000, 'ºC'),
	(94899, 108, '2015-03-15 00:02:55.000000', 'temperatura', 334.0000, 'ºC'),
	(94900, 108, '2015-03-15 00:02:56.000000', 'temperatura', 475.0000, 'ºC'),
	(94901, 108, '2015-03-15 00:02:57.000000', 'temperatura', 174.0000, 'ºC'),
	(94902, 108, '2015-03-15 00:02:58.000000', 'temperatura', 646.0000, 'ºC'),
	(94903, 108, '2015-03-15 00:02:59.000000', 'temperatura', 305.0000, 'ºC'),
	(94904, 108, '2015-03-15 00:03:00.000000', 'temperatura', 791.0000, 'ºC'),
	(94905, 108, '2015-03-15 00:03:01.000000', 'temperatura', 638.0000, 'ºC'),
	(94906, 108, '2015-03-15 00:03:02.000000', 'temperatura', 819.0000, 'ºC'),
	(94907, 108, '2015-03-15 00:03:03.000000', 'temperatura', 982.0000, 'ºC'),
	(94908, 108, '2015-03-15 00:03:04.000000', 'temperatura', 55.0000, 'ºC'),
	(94909, 108, '2015-03-15 00:03:05.000000', 'temperatura', 927.0000, 'ºC'),
	(94910, 108, '2015-03-15 00:03:06.000000', 'temperatura', 872.0000, 'ºC'),
	(94911, 108, '2015-03-15 00:03:07.000000', 'temperatura', 377.0000, 'ºC'),
	(94912, 108, '2015-03-15 00:03:08.000000', 'temperatura', 472.0000, 'ºC'),
	(94913, 108, '2015-03-15 00:03:09.000000', 'temperatura', 29.0000, 'ºC'),
	(94914, 108, '2015-03-15 00:03:10.000000', 'temperatura', 1130.0000, 'ºC'),
	(94915, 108, '2015-03-15 00:03:11.000000', 'temperatura', 764.0000, 'ºC'),
	(94916, 108, '2015-03-15 00:03:12.000000', 'temperatura', 432.0000, 'ºC'),
	(94917, 108, '2015-03-15 00:03:13.000000', 'temperatura', 1066.0000, 'ºC'),
	(94918, 108, '2015-03-15 00:03:14.000000', 'temperatura', 435.0000, 'ºC'),
	(94919, 108, '2015-03-15 00:03:15.000000', 'temperatura', 179.0000, 'ºC'),
	(94920, 108, '2015-03-15 00:03:16.000000', 'temperatura', 788.0000, 'ºC'),
	(94921, 108, '2015-03-15 00:03:17.000000', 'temperatura', 1006.0000, 'ºC'),
	(94922, 108, '2015-03-15 00:03:18.000000', 'temperatura', 266.0000, 'ºC'),
	(94923, 108, '2015-03-15 00:03:19.000000', 'temperatura', 710.0000, 'ºC'),
	(94924, 108, '2015-03-15 00:03:20.000000', 'temperatura', 354.0000, 'ºC'),
	(94925, 108, '2015-03-15 00:03:21.000000', 'temperatura', 842.0000, 'ºC'),
	(94926, 108, '2015-03-15 00:03:22.000000', 'temperatura', 746.0000, 'ºC'),
	(94927, 108, '2015-03-15 00:03:23.000000', 'temperatura', 5.0000, 'ºC'),
	(94928, 108, '2015-03-15 00:03:24.000000', 'temperatura', 189.0000, 'ºC'),
	(94929, 108, '2015-03-15 00:03:25.000000', 'temperatura', 930.0000, 'ºC'),
	(94930, 108, '2015-03-15 00:03:26.000000', 'temperatura', 484.0000, 'ºC'),
	(94931, 108, '2015-03-15 00:03:27.000000', 'temperatura', 830.0000, 'ºC'),
	(94932, 108, '2015-03-15 00:03:28.000000', 'temperatura', 300.0000, 'ºC'),
	(94933, 108, '2015-03-15 00:03:29.000000', 'temperatura', 208.0000, 'ºC'),
	(94934, 108, '2015-03-15 00:03:30.000000', 'temperatura', 141.0000, 'ºC'),
	(94935, 108, '2015-03-15 00:03:31.000000', 'temperatura', 81.0000, 'ºC'),
	(94936, 108, '2015-03-15 00:03:32.000000', 'temperatura', 1184.0000, 'ºC'),
	(94937, 108, '2015-03-15 00:03:33.000000', 'temperatura', 876.0000, 'ºC'),
	(94938, 108, '2015-03-15 00:03:34.000000', 'temperatura', 831.0000, 'ºC'),
	(94939, 108, '2015-03-15 00:03:35.000000', 'temperatura', 326.0000, 'ºC'),
	(94940, 108, '2015-03-15 00:03:36.000000', 'temperatura', 336.0000, 'ºC'),
	(94941, 108, '2015-03-15 00:03:37.000000', 'temperatura', 705.0000, 'ºC'),
	(94942, 108, '2015-03-15 00:03:38.000000', 'temperatura', 118.0000, 'ºC'),
	(94943, 108, '2015-03-15 00:03:39.000000', 'temperatura', 874.0000, 'ºC'),
	(94944, 108, '2015-03-15 00:03:40.000000', 'temperatura', 415.0000, 'ºC'),
	(94945, 108, '2015-03-15 00:03:41.000000', 'temperatura', 654.0000, 'ºC'),
	(94946, 108, '2015-03-15 00:03:42.000000', 'temperatura', 827.0000, 'ºC'),
	(94947, 108, '2015-03-15 00:03:43.000000', 'temperatura', 973.0000, 'ºC'),
	(94948, 108, '2015-03-15 00:03:44.000000', 'temperatura', 1183.0000, 'ºC'),
	(94949, 108, '2015-03-15 00:03:45.000000', 'temperatura', 596.0000, 'ºC'),
	(94950, 108, '2015-03-15 00:03:46.000000', 'temperatura', 635.0000, 'ºC'),
	(94951, 108, '2015-03-15 00:03:47.000000', 'temperatura', 184.0000, 'ºC'),
	(94952, 108, '2015-03-15 00:03:48.000000', 'temperatura', 216.0000, 'ºC'),
	(94953, 108, '2015-03-15 00:03:49.000000', 'temperatura', 527.0000, 'ºC'),
	(94954, 108, '2015-03-15 00:03:50.000000', 'temperatura', 789.0000, 'ºC'),
	(94955, 108, '2015-03-15 00:03:51.000000', 'temperatura', 1166.0000, 'ºC'),
	(94956, 108, '2015-03-15 00:03:52.000000', 'temperatura', 1062.0000, 'ºC'),
	(94957, 108, '2015-03-15 00:03:53.000000', 'temperatura', 613.0000, 'ºC'),
	(94958, 108, '2015-03-15 00:03:54.000000', 'temperatura', 1081.0000, 'ºC'),
	(94959, 108, '2015-03-15 00:03:55.000000', 'temperatura', 1166.0000, 'ºC'),
	(94960, 108, '2015-03-15 00:03:56.000000', 'temperatura', 188.0000, 'ºC'),
	(94961, 108, '2015-03-15 00:03:57.000000', 'temperatura', 1040.0000, 'ºC'),
	(94962, 108, '2015-03-15 00:03:58.000000', 'temperatura', 1040.0000, 'ºC'),
	(94963, 108, '2015-03-15 00:03:59.000000', 'temperatura', 878.0000, 'ºC'),
	(94964, 108, '2015-03-15 00:04:00.000000', 'temperatura', 73.0000, 'ºC'),
	(94965, 108, '2015-03-15 00:04:01.000000', 'temperatura', 128.0000, 'ºC'),
	(94966, 108, '2015-03-15 00:04:02.000000', 'temperatura', 424.0000, 'ºC'),
	(94967, 108, '2015-03-15 00:04:03.000000', 'temperatura', 535.0000, 'ºC'),
	(94968, 108, '2015-03-15 00:04:04.000000', 'temperatura', 206.0000, 'ºC'),
	(94969, 108, '2015-03-15 00:04:05.000000', 'temperatura', 623.0000, 'ºC'),
	(94970, 108, '2015-03-15 00:04:06.000000', 'temperatura', 100.0000, 'ºC'),
	(94971, 108, '2015-03-15 00:04:07.000000', 'temperatura', 1030.0000, 'ºC'),
	(94972, 108, '2015-03-15 00:04:08.000000', 'temperatura', 52.0000, 'ºC'),
	(94973, 108, '2015-03-15 00:04:09.000000', 'temperatura', 770.0000, 'ºC'),
	(94974, 108, '2015-03-15 00:04:10.000000', 'temperatura', 93.0000, 'ºC'),
	(94975, 108, '2015-03-15 00:04:11.000000', 'temperatura', 557.0000, 'ºC'),
	(94976, 108, '2015-03-15 00:04:12.000000', 'temperatura', 105.0000, 'ºC'),
	(94977, 108, '2015-03-15 00:04:13.000000', 'temperatura', 57.0000, 'ºC'),
	(94978, 108, '2015-03-15 00:04:14.000000', 'temperatura', 1170.0000, 'ºC'),
	(94979, 108, '2015-03-15 00:04:15.000000', 'temperatura', 879.0000, 'ºC'),
	(94980, 108, '2015-03-15 00:04:16.000000', 'temperatura', 886.0000, 'ºC'),
	(94981, 108, '2015-03-15 00:04:17.000000', 'temperatura', 595.0000, 'ºC'),
	(94982, 108, '2015-03-15 00:04:18.000000', 'temperatura', 317.0000, 'ºC'),
	(94983, 108, '2015-03-15 00:04:19.000000', 'temperatura', 999.0000, 'ºC'),
	(94984, 108, '2015-03-15 00:04:20.000000', 'temperatura', 446.0000, 'ºC'),
	(94985, 108, '2015-03-15 00:04:21.000000', 'temperatura', 432.0000, 'ºC'),
	(94986, 108, '2015-03-15 00:04:22.000000', 'temperatura', 821.0000, 'ºC'),
	(94987, 108, '2015-03-15 00:04:23.000000', 'temperatura', 413.0000, 'ºC'),
	(94988, 108, '2015-03-15 00:04:24.000000', 'temperatura', 799.0000, 'ºC'),
	(94989, 108, '2015-03-15 00:04:25.000000', 'temperatura', 358.0000, 'ºC'),
	(94990, 108, '2015-03-15 00:04:26.000000', 'temperatura', 596.0000, 'ºC'),
	(94991, 108, '2015-03-15 00:04:27.000000', 'temperatura', 703.0000, 'ºC'),
	(94992, 108, '2015-03-15 00:04:28.000000', 'temperatura', 528.0000, 'ºC'),
	(94993, 108, '2015-03-15 00:04:29.000000', 'temperatura', 531.0000, 'ºC'),
	(94994, 108, '2015-03-15 00:04:30.000000', 'temperatura', 1072.0000, 'ºC'),
	(94995, 108, '2015-03-15 00:04:31.000000', 'temperatura', 168.0000, 'ºC'),
	(94996, 108, '2015-03-15 00:04:32.000000', 'temperatura', 25.0000, 'ºC'),
	(94997, 108, '2015-03-15 00:04:33.000000', 'temperatura', 822.0000, 'ºC'),
	(94998, 108, '2015-03-15 00:04:34.000000', 'temperatura', 437.0000, 'ºC'),
	(94999, 108, '2015-03-15 00:04:35.000000', 'temperatura', 917.0000, 'ºC'),
	(95000, 108, '2015-03-15 00:04:36.000000', 'temperatura', 875.0000, 'ºC'),
	(95001, 108, '2015-03-15 00:04:37.000000', 'temperatura', 423.0000, 'ºC'),
	(95002, 108, '2015-03-15 00:04:38.000000', 'temperatura', 693.0000, 'ºC'),
	(95003, 108, '2015-03-15 00:04:39.000000', 'temperatura', 998.0000, 'ºC'),
	(95004, 108, '2015-03-15 00:04:40.000000', 'temperatura', 508.0000, 'ºC'),
	(95005, 108, '2015-03-15 00:04:41.000000', 'temperatura', 746.0000, 'ºC'),
	(95006, 108, '2015-03-15 00:04:42.000000', 'temperatura', 1009.0000, 'ºC'),
	(95007, 108, '2015-03-15 00:04:43.000000', 'temperatura', 407.0000, 'ºC'),
	(95008, 108, '2015-03-15 00:04:44.000000', 'temperatura', 209.0000, 'ºC'),
	(95009, 108, '2015-03-15 00:04:45.000000', 'temperatura', 1025.0000, 'ºC'),
	(95010, 108, '2015-03-15 00:04:46.000000', 'temperatura', 899.0000, 'ºC'),
	(95011, 108, '2015-03-15 00:04:47.000000', 'temperatura', 218.0000, 'ºC'),
	(95012, 108, '2015-03-15 00:04:48.000000', 'temperatura', 796.0000, 'ºC'),
	(95013, 108, '2015-03-15 00:04:49.000000', 'temperatura', 928.0000, 'ºC'),
	(95014, 108, '2015-03-15 00:04:50.000000', 'temperatura', 1049.0000, 'ºC'),
	(95015, 108, '2015-03-15 00:04:51.000000', 'temperatura', 64.0000, 'ºC'),
	(95016, 108, '2015-03-15 00:04:52.000000', 'temperatura', 771.0000, 'ºC'),
	(95017, 108, '2015-03-15 00:04:53.000000', 'temperatura', 65.0000, 'ºC'),
	(95018, 108, '2015-03-15 00:04:54.000000', 'temperatura', 414.0000, 'ºC'),
	(95019, 108, '2015-03-15 00:04:55.000000', 'temperatura', 675.0000, 'ºC'),
	(95020, 108, '2015-03-15 00:04:56.000000', 'temperatura', 933.0000, 'ºC'),
	(95021, 108, '2015-03-15 00:04:57.000000', 'temperatura', 238.0000, 'ºC'),
	(95022, 108, '2015-03-15 00:04:58.000000', 'temperatura', 795.0000, 'ºC'),
	(95023, 108, '2015-03-15 00:04:59.000000', 'temperatura', 861.0000, 'ºC'),
	(95024, 108, '2015-03-15 00:05:00.000000', 'temperatura', 720.0000, 'ºC'),
	(95025, 108, '2015-03-15 00:05:01.000000', 'temperatura', 1019.0000, 'ºC'),
	(95026, 108, '2015-03-15 00:05:02.000000', 'temperatura', 534.0000, 'ºC'),
	(95027, 108, '2015-03-15 00:05:03.000000', 'temperatura', 814.0000, 'ºC'),
	(95028, 108, '2015-03-15 00:05:04.000000', 'temperatura', 66.0000, 'ºC'),
	(95029, 108, '2015-03-15 00:05:05.000000', 'temperatura', 291.0000, 'ºC'),
	(95030, 108, '2015-03-15 00:05:06.000000', 'temperatura', 58.0000, 'ºC'),
	(95031, 108, '2015-03-15 00:05:07.000000', 'temperatura', 617.0000, 'ºC'),
	(95032, 108, '2015-03-15 00:05:08.000000', 'temperatura', 510.0000, 'ºC'),
	(95033, 108, '2015-03-15 00:05:09.000000', 'temperatura', 701.0000, 'ºC'),
	(95034, 108, '2015-03-15 00:05:10.000000', 'temperatura', 774.0000, 'ºC'),
	(95035, 108, '2015-03-15 00:05:11.000000', 'temperatura', 570.0000, 'ºC'),
	(95036, 108, '2015-03-15 00:05:12.000000', 'temperatura', 526.0000, 'ºC'),
	(95037, 108, '2015-03-15 00:05:13.000000', 'temperatura', 920.0000, 'ºC'),
	(95038, 108, '2015-03-15 00:05:14.000000', 'temperatura', 624.0000, 'ºC'),
	(95039, 108, '2015-03-15 00:05:15.000000', 'temperatura', 358.0000, 'ºC'),
	(95040, 108, '2015-03-15 00:05:16.000000', 'temperatura', 1122.0000, 'ºC'),
	(95041, 108, '2015-03-15 00:05:17.000000', 'temperatura', 935.0000, 'ºC'),
	(95042, 108, '2015-03-15 00:05:18.000000', 'temperatura', 109.0000, 'ºC'),
	(95043, 108, '2015-03-15 00:05:19.000000', 'temperatura', 142.0000, 'ºC'),
	(95044, 108, '2015-03-15 00:05:20.000000', 'temperatura', 381.0000, 'ºC'),
	(95045, 108, '2015-03-15 00:05:21.000000', 'temperatura', 281.0000, 'ºC'),
	(95046, 108, '2015-03-15 00:05:22.000000', 'temperatura', 260.0000, 'ºC'),
	(95047, 108, '2015-03-15 00:05:23.000000', 'temperatura', 461.0000, 'ºC'),
	(95048, 108, '2015-03-15 00:05:24.000000', 'temperatura', 325.0000, 'ºC'),
	(95049, 108, '2015-03-15 00:05:25.000000', 'temperatura', 240.0000, 'ºC'),
	(95050, 108, '2015-03-15 00:05:26.000000', 'temperatura', 229.0000, 'ºC'),
	(95051, 108, '2015-03-15 00:05:27.000000', 'temperatura', 423.0000, 'ºC'),
	(95052, 108, '2015-03-15 00:05:28.000000', 'temperatura', 229.0000, 'ºC'),
	(95053, 108, '2015-03-15 00:05:29.000000', 'temperatura', 1078.0000, 'ºC'),
	(95054, 108, '2015-03-15 00:05:30.000000', 'temperatura', 1103.0000, 'ºC'),
	(95055, 108, '2015-03-15 00:05:31.000000', 'temperatura', 1082.0000, 'ºC'),
	(95056, 108, '2015-03-15 00:05:32.000000', 'temperatura', 902.0000, 'ºC'),
	(95057, 108, '2015-03-15 00:05:33.000000', 'temperatura', 64.0000, 'ºC'),
	(95058, 108, '2015-03-15 00:05:34.000000', 'temperatura', 12.0000, 'ºC'),
	(95059, 108, '2015-03-15 00:05:35.000000', 'temperatura', 1072.0000, 'ºC'),
	(95060, 108, '2015-03-15 00:05:36.000000', 'temperatura', 521.0000, 'ºC'),
	(95061, 108, '2015-03-15 00:05:37.000000', 'temperatura', 592.0000, 'ºC'),
	(95062, 108, '2015-03-15 00:05:38.000000', 'temperatura', 195.0000, 'ºC'),
	(95063, 108, '2015-03-15 00:05:39.000000', 'temperatura', 400.0000, 'ºC'),
	(95064, 108, '2015-03-15 00:05:40.000000', 'temperatura', 218.0000, 'ºC'),
	(95065, 108, '2015-03-15 00:05:41.000000', 'temperatura', 1089.0000, 'ºC'),
	(95066, 108, '2015-03-15 00:05:42.000000', 'temperatura', 1192.0000, 'ºC'),
	(95067, 108, '2015-03-15 00:05:43.000000', 'temperatura', 295.0000, 'ºC'),
	(95068, 108, '2015-03-15 00:05:44.000000', 'temperatura', 298.0000, 'ºC'),
	(95069, 108, '2015-03-15 00:05:45.000000', 'temperatura', 606.0000, 'ºC'),
	(95070, 108, '2015-03-15 00:05:46.000000', 'temperatura', 936.0000, 'ºC'),
	(95071, 108, '2015-03-15 00:05:47.000000', 'temperatura', 463.0000, 'ºC'),
	(95072, 108, '2015-03-15 00:05:48.000000', 'temperatura', 708.0000, 'ºC'),
	(95073, 108, '2015-03-15 00:05:49.000000', 'temperatura', 953.0000, 'ºC'),
	(95074, 108, '2015-03-15 00:05:50.000000', 'temperatura', 239.0000, 'ºC'),
	(95075, 108, '2015-03-15 00:05:51.000000', 'temperatura', 738.0000, 'ºC'),
	(95076, 108, '2015-03-15 00:05:52.000000', 'temperatura', 571.0000, 'ºC'),
	(95077, 108, '2015-03-15 00:05:53.000000', 'temperatura', 643.0000, 'ºC'),
	(95078, 108, '2015-03-15 00:05:54.000000', 'temperatura', 301.0000, 'ºC'),
	(95079, 108, '2015-03-15 00:05:55.000000', 'temperatura', 777.0000, 'ºC'),
	(95080, 108, '2015-03-15 00:05:56.000000', 'temperatura', 581.0000, 'ºC'),
	(95081, 108, '2015-03-15 00:05:57.000000', 'temperatura', 575.0000, 'ºC'),
	(95082, 108, '2015-03-15 00:05:58.000000', 'temperatura', 1132.0000, 'ºC'),
	(95083, 108, '2015-03-15 00:05:59.000000', 'temperatura', 336.0000, 'ºC'),
	(95084, 108, '2015-03-15 00:06:00.000000', 'temperatura', 684.0000, 'ºC'),
	(95085, 108, '2015-03-15 00:06:01.000000', 'temperatura', 11.0000, 'ºC'),
	(95086, 108, '2015-03-15 00:06:02.000000', 'temperatura', 405.0000, 'ºC'),
	(95087, 108, '2015-03-15 00:06:03.000000', 'temperatura', 791.0000, 'ºC'),
	(95088, 108, '2015-03-15 00:06:04.000000', 'temperatura', 340.0000, 'ºC'),
	(95089, 108, '2015-03-15 00:06:05.000000', 'temperatura', 527.0000, 'ºC'),
	(95090, 108, '2015-03-15 00:06:06.000000', 'temperatura', 415.0000, 'ºC'),
	(95091, 108, '2015-03-15 00:06:07.000000', 'temperatura', 496.0000, 'ºC'),
	(95092, 108, '2015-03-15 00:06:08.000000', 'temperatura', 34.0000, 'ºC'),
	(95093, 108, '2015-03-15 00:06:09.000000', 'temperatura', 1084.0000, 'ºC'),
	(95094, 108, '2015-03-15 00:06:10.000000', 'temperatura', 520.0000, 'ºC'),
	(95095, 108, '2015-03-15 00:06:11.000000', 'temperatura', 545.0000, 'ºC'),
	(95096, 108, '2015-03-15 00:06:12.000000', 'temperatura', 1167.0000, 'ºC'),
	(95097, 108, '2015-03-15 00:06:13.000000', 'temperatura', 602.0000, 'ºC'),
	(95098, 108, '2015-03-15 00:06:14.000000', 'temperatura', 708.0000, 'ºC'),
	(95099, 108, '2015-03-15 00:06:15.000000', 'temperatura', 533.0000, 'ºC'),
	(95100, 108, '2015-03-15 00:06:16.000000', 'temperatura', 544.0000, 'ºC'),
	(95101, 108, '2015-03-15 00:06:17.000000', 'temperatura', 1120.0000, 'ºC'),
	(95102, 108, '2015-03-15 00:06:18.000000', 'temperatura', 369.0000, 'ºC'),
	(95103, 108, '2015-03-15 00:06:19.000000', 'temperatura', 884.0000, 'ºC'),
	(95104, 108, '2015-03-15 00:06:20.000000', 'temperatura', 916.0000, 'ºC'),
	(95105, 108, '2015-03-15 00:06:21.000000', 'temperatura', 726.0000, 'ºC'),
	(95106, 108, '2015-03-15 00:06:22.000000', 'temperatura', 886.0000, 'ºC'),
	(95107, 108, '2015-03-15 00:06:23.000000', 'temperatura', 1049.0000, 'ºC'),
	(95108, 108, '2015-03-15 00:06:24.000000', 'temperatura', 190.0000, 'ºC'),
	(95109, 108, '2015-03-15 00:06:25.000000', 'temperatura', 201.0000, 'ºC'),
	(95110, 108, '2015-03-15 00:06:26.000000', 'temperatura', 438.0000, 'ºC'),
	(95111, 108, '2015-03-15 00:06:27.000000', 'temperatura', 388.0000, 'ºC'),
	(95112, 108, '2015-03-15 00:06:28.000000', 'temperatura', 625.0000, 'ºC'),
	(95113, 108, '2015-03-15 00:06:29.000000', 'temperatura', 762.0000, 'ºC'),
	(95114, 108, '2015-03-15 00:06:30.000000', 'temperatura', 734.0000, 'ºC'),
	(95115, 108, '2015-03-15 00:06:31.000000', 'temperatura', 185.0000, 'ºC'),
	(95116, 108, '2015-03-15 00:06:32.000000', 'temperatura', 1122.0000, 'ºC'),
	(95117, 108, '2015-03-15 00:06:33.000000', 'temperatura', 256.0000, 'ºC'),
	(95118, 108, '2015-03-15 00:06:34.000000', 'temperatura', 314.0000, 'ºC'),
	(95119, 108, '2015-03-15 00:06:35.000000', 'temperatura', 803.0000, 'ºC'),
	(95120, 108, '2015-03-15 00:06:36.000000', 'temperatura', 674.0000, 'ºC'),
	(95121, 108, '2015-03-15 00:06:37.000000', 'temperatura', 962.0000, 'ºC'),
	(95122, 108, '2015-03-15 00:06:38.000000', 'temperatura', 389.0000, 'ºC'),
	(95123, 108, '2015-03-15 00:06:39.000000', 'temperatura', 260.0000, 'ºC'),
	(95124, 108, '2015-03-15 00:06:40.000000', 'temperatura', 133.0000, 'ºC'),
	(95125, 108, '2015-03-15 00:06:41.000000', 'temperatura', 1084.0000, 'ºC'),
	(95126, 108, '2015-03-15 00:06:42.000000', 'temperatura', 224.0000, 'ºC'),
	(95127, 108, '2015-03-15 00:06:43.000000', 'temperatura', 269.0000, 'ºC'),
	(95128, 108, '2015-03-15 00:06:44.000000', 'temperatura', 673.0000, 'ºC'),
	(95129, 108, '2015-03-15 00:06:45.000000', 'temperatura', 157.0000, 'ºC'),
	(95130, 108, '2015-03-15 00:06:46.000000', 'temperatura', 1165.0000, 'ºC'),
	(95131, 108, '2015-03-15 00:06:47.000000', 'temperatura', 557.0000, 'ºC'),
	(95132, 108, '2015-03-15 00:06:48.000000', 'temperatura', 489.0000, 'ºC'),
	(95133, 108, '2015-03-15 00:06:49.000000', 'temperatura', 775.0000, 'ºC'),
	(95134, 108, '2015-03-15 00:06:50.000000', 'temperatura', 8.0000, 'ºC'),
	(95135, 108, '2015-03-15 00:06:51.000000', 'temperatura', 115.0000, 'ºC'),
	(95136, 108, '2015-03-15 00:06:52.000000', 'temperatura', 551.0000, 'ºC'),
	(95137, 108, '2015-03-15 00:06:53.000000', 'temperatura', 10.0000, 'ºC'),
	(95138, 108, '2015-03-15 00:06:54.000000', 'temperatura', 799.0000, 'ºC'),
	(95139, 108, '2015-03-15 00:06:55.000000', 'temperatura', 365.0000, 'ºC'),
	(95140, 108, '2015-03-15 00:06:56.000000', 'temperatura', 629.0000, 'ºC'),
	(95141, 108, '2015-03-15 00:06:57.000000', 'temperatura', 852.0000, 'ºC'),
	(95142, 108, '2015-03-15 00:06:58.000000', 'temperatura', 1173.0000, 'ºC'),
	(95143, 108, '2015-03-15 00:06:59.000000', 'temperatura', 907.0000, 'ºC'),
	(95144, 108, '2015-03-15 00:07:00.000000', 'temperatura', 1018.0000, 'ºC'),
	(95145, 108, '2015-03-15 00:07:01.000000', 'temperatura', 1171.0000, 'ºC'),
	(95146, 108, '2015-03-15 00:07:02.000000', 'temperatura', 401.0000, 'ºC'),
	(95147, 108, '2015-03-15 00:07:03.000000', 'temperatura', 891.0000, 'ºC'),
	(95148, 108, '2015-03-15 00:07:04.000000', 'temperatura', 855.0000, 'ºC'),
	(95149, 108, '2015-03-15 00:07:05.000000', 'temperatura', 402.0000, 'ºC'),
	(95150, 108, '2015-03-15 00:07:06.000000', 'temperatura', 644.0000, 'ºC'),
	(95151, 108, '2015-03-15 00:07:07.000000', 'temperatura', 814.0000, 'ºC'),
	(95152, 108, '2015-03-15 00:07:08.000000', 'temperatura', 941.0000, 'ºC'),
	(95153, 108, '2015-03-15 00:07:09.000000', 'temperatura', 1064.0000, 'ºC'),
	(95154, 108, '2015-03-15 00:07:10.000000', 'temperatura', 98.0000, 'ºC'),
	(95155, 108, '2015-03-15 00:07:11.000000', 'temperatura', 898.0000, 'ºC'),
	(95156, 108, '2015-03-15 00:07:12.000000', 'temperatura', 595.0000, 'ºC'),
	(95157, 108, '2015-03-15 00:07:13.000000', 'temperatura', 283.0000, 'ºC'),
	(95158, 108, '2015-03-15 00:07:14.000000', 'temperatura', 830.0000, 'ºC'),
	(95159, 108, '2015-03-15 00:07:15.000000', 'temperatura', 900.0000, 'ºC'),
	(95160, 108, '2015-03-15 00:07:16.000000', 'temperatura', 810.0000, 'ºC'),
	(95161, 108, '2015-03-15 00:07:17.000000', 'temperatura', 153.0000, 'ºC'),
	(95162, 108, '2015-03-15 00:07:18.000000', 'temperatura', 735.0000, 'ºC'),
	(95163, 108, '2015-03-15 00:07:19.000000', 'temperatura', 816.0000, 'ºC'),
	(95164, 108, '2015-03-15 00:07:20.000000', 'temperatura', 675.0000, 'ºC'),
	(95165, 108, '2015-03-15 00:07:21.000000', 'temperatura', 926.0000, 'ºC'),
	(95166, 108, '2015-03-15 00:07:22.000000', 'temperatura', 209.0000, 'ºC'),
	(95167, 108, '2015-03-15 00:07:23.000000', 'temperatura', 664.0000, 'ºC'),
	(95168, 108, '2015-03-15 00:07:24.000000', 'temperatura', 297.0000, 'ºC'),
	(95169, 108, '2015-03-15 00:07:25.000000', 'temperatura', 691.0000, 'ºC'),
	(95170, 108, '2015-03-15 00:07:26.000000', 'temperatura', 167.0000, 'ºC'),
	(95171, 108, '2015-03-15 00:07:27.000000', 'temperatura', 1161.0000, 'ºC'),
	(95172, 108, '2015-03-15 00:07:28.000000', 'temperatura', 503.0000, 'ºC'),
	(95173, 108, '2015-03-15 00:07:29.000000', 'temperatura', 233.0000, 'ºC'),
	(95174, 108, '2015-03-15 00:07:30.000000', 'temperatura', 855.0000, 'ºC'),
	(95175, 108, '2015-03-15 00:07:31.000000', 'temperatura', 1178.0000, 'ºC'),
	(95176, 108, '2015-03-15 00:07:32.000000', 'temperatura', 925.0000, 'ºC'),
	(95177, 108, '2015-03-15 00:07:33.000000', 'temperatura', 1093.0000, 'ºC'),
	(95178, 108, '2015-03-15 00:07:34.000000', 'temperatura', 289.0000, 'ºC'),
	(95179, 108, '2015-03-15 00:07:35.000000', 'temperatura', 566.0000, 'ºC'),
	(95180, 108, '2015-03-15 00:07:36.000000', 'temperatura', 762.0000, 'ºC'),
	(95181, 108, '2015-03-15 00:07:37.000000', 'temperatura', 914.0000, 'ºC'),
	(95182, 108, '2015-03-15 00:07:38.000000', 'temperatura', 1085.0000, 'ºC'),
	(95183, 108, '2015-03-15 00:07:39.000000', 'temperatura', 285.0000, 'ºC'),
	(95184, 108, '2015-03-15 00:07:40.000000', 'temperatura', 569.0000, 'ºC'),
	(95185, 108, '2015-03-15 00:07:41.000000', 'temperatura', 792.0000, 'ºC'),
	(95186, 108, '2015-03-15 00:07:42.000000', 'temperatura', 1050.0000, 'ºC'),
	(95187, 108, '2015-03-15 00:07:43.000000', 'temperatura', 478.0000, 'ºC'),
	(95188, 108, '2015-03-15 00:07:44.000000', 'temperatura', 440.0000, 'ºC'),
	(95189, 108, '2015-03-15 00:07:45.000000', 'temperatura', 767.0000, 'ºC'),
	(95190, 108, '2015-03-15 00:07:46.000000', 'temperatura', 115.0000, 'ºC'),
	(95191, 108, '2015-03-15 00:07:47.000000', 'temperatura', 676.0000, 'ºC'),
	(95192, 108, '2015-03-15 00:07:48.000000', 'temperatura', 634.0000, 'ºC'),
	(95193, 108, '2015-03-15 00:07:49.000000', 'temperatura', 1144.0000, 'ºC'),
	(95194, 108, '2015-03-15 00:07:50.000000', 'temperatura', 216.0000, 'ºC'),
	(95195, 108, '2015-03-15 00:07:51.000000', 'temperatura', 48.0000, 'ºC'),
	(95196, 108, '2015-03-15 00:07:52.000000', 'temperatura', 793.0000, 'ºC'),
	(95197, 108, '2015-03-15 00:07:53.000000', 'temperatura', 221.0000, 'ºC'),
	(95198, 108, '2015-03-15 00:07:54.000000', 'temperatura', 1127.0000, 'ºC'),
	(95199, 108, '2015-03-15 00:07:55.000000', 'temperatura', 174.0000, 'ºC'),
	(95200, 108, '2015-03-15 00:07:56.000000', 'temperatura', 1088.0000, 'ºC'),
	(95201, 108, '2015-03-15 00:07:57.000000', 'temperatura', 117.0000, 'ºC'),
	(95202, 108, '2015-03-15 00:07:58.000000', 'temperatura', 922.0000, 'ºC'),
	(95203, 108, '2015-03-15 00:07:59.000000', 'temperatura', 659.0000, 'ºC'),
	(95204, 108, '2015-03-15 00:08:00.000000', 'temperatura', 529.0000, 'ºC'),
	(95205, 108, '2015-03-15 00:08:01.000000', 'temperatura', 667.0000, 'ºC'),
	(95206, 108, '2015-03-15 00:08:02.000000', 'temperatura', 551.0000, 'ºC'),
	(95207, 108, '2015-03-15 00:08:03.000000', 'temperatura', 754.0000, 'ºC'),
	(95208, 108, '2015-03-15 00:08:04.000000', 'temperatura', 919.0000, 'ºC'),
	(95209, 108, '2015-03-15 00:08:05.000000', 'temperatura', 1132.0000, 'ºC'),
	(95210, 108, '2015-03-15 00:08:06.000000', 'temperatura', 505.0000, 'ºC'),
	(95211, 108, '2015-03-15 00:08:07.000000', 'temperatura', 328.0000, 'ºC'),
	(95212, 108, '2015-03-15 00:08:08.000000', 'temperatura', 128.0000, 'ºC'),
	(95213, 108, '2015-03-15 00:08:09.000000', 'temperatura', 854.0000, 'ºC'),
	(95214, 108, '2015-03-15 00:08:10.000000', 'temperatura', 286.0000, 'ºC'),
	(95215, 108, '2015-03-15 00:08:11.000000', 'temperatura', 69.0000, 'ºC'),
	(95216, 108, '2015-03-15 00:08:12.000000', 'temperatura', 687.0000, 'ºC'),
	(95217, 108, '2015-03-15 00:08:13.000000', 'temperatura', 828.0000, 'ºC'),
	(95218, 108, '2015-03-15 00:08:14.000000', 'temperatura', 881.0000, 'ºC'),
	(95219, 108, '2015-03-15 00:08:15.000000', 'temperatura', 720.0000, 'ºC'),
	(95220, 108, '2015-03-15 00:08:16.000000', 'temperatura', 959.0000, 'ºC'),
	(95221, 108, '2015-03-15 00:08:17.000000', 'temperatura', 234.0000, 'ºC'),
	(95222, 108, '2015-03-15 00:08:18.000000', 'temperatura', 694.0000, 'ºC'),
	(95223, 108, '2015-03-15 00:08:19.000000', 'temperatura', 370.0000, 'ºC'),
	(95224, 108, '2015-03-15 00:08:20.000000', 'temperatura', 967.0000, 'ºC'),
	(95225, 108, '2015-03-15 00:08:21.000000', 'temperatura', 127.0000, 'ºC'),
	(95226, 108, '2015-03-15 00:08:22.000000', 'temperatura', 133.0000, 'ºC'),
	(95227, 108, '2015-03-15 00:08:23.000000', 'temperatura', 284.0000, 'ºC'),
	(95228, 108, '2015-03-15 00:08:24.000000', 'temperatura', 1023.0000, 'ºC'),
	(95229, 108, '2015-03-15 00:08:25.000000', 'temperatura', 662.0000, 'ºC'),
	(95230, 108, '2015-03-15 00:08:26.000000', 'temperatura', 244.0000, 'ºC'),
	(95231, 108, '2015-03-15 00:08:27.000000', 'temperatura', 432.0000, 'ºC'),
	(95232, 108, '2015-03-15 00:08:28.000000', 'temperatura', 230.0000, 'ºC'),
	(95233, 108, '2015-03-15 00:08:29.000000', 'temperatura', 1055.0000, 'ºC'),
	(95234, 108, '2015-03-15 00:08:30.000000', 'temperatura', 984.0000, 'ºC'),
	(95235, 108, '2015-03-15 00:08:31.000000', 'temperatura', 555.0000, 'ºC'),
	(95236, 108, '2015-03-15 00:08:32.000000', 'temperatura', 1023.0000, 'ºC'),
	(95237, 108, '2015-03-15 00:08:33.000000', 'temperatura', 1051.0000, 'ºC'),
	(95238, 108, '2015-03-15 00:08:34.000000', 'temperatura', 989.0000, 'ºC'),
	(95239, 108, '2015-03-15 00:08:35.000000', 'temperatura', 590.0000, 'ºC'),
	(95240, 108, '2015-03-15 00:08:36.000000', 'temperatura', 1182.0000, 'ºC'),
	(95241, 108, '2015-03-15 00:08:37.000000', 'temperatura', 542.0000, 'ºC'),
	(95242, 108, '2015-03-15 00:08:38.000000', 'temperatura', 365.0000, 'ºC'),
	(95243, 108, '2015-03-15 00:08:39.000000', 'temperatura', 197.0000, 'ºC'),
	(95244, 108, '2015-03-15 00:08:40.000000', 'temperatura', 1093.0000, 'ºC'),
	(95245, 108, '2015-03-15 00:08:41.000000', 'temperatura', 76.0000, 'ºC'),
	(95246, 108, '2015-03-15 00:08:42.000000', 'temperatura', 699.0000, 'ºC'),
	(95247, 108, '2015-03-15 00:08:43.000000', 'temperatura', 869.0000, 'ºC'),
	(95248, 108, '2015-03-15 00:08:44.000000', 'temperatura', 1049.0000, 'ºC'),
	(95249, 108, '2015-03-15 00:08:45.000000', 'temperatura', 237.0000, 'ºC'),
	(95250, 108, '2015-03-15 00:08:46.000000', 'temperatura', 438.0000, 'ºC'),
	(95251, 108, '2015-03-15 00:08:47.000000', 'temperatura', 280.0000, 'ºC'),
	(95252, 108, '2015-03-15 00:08:48.000000', 'temperatura', 87.0000, 'ºC'),
	(95253, 108, '2015-03-15 00:08:49.000000', 'temperatura', 795.0000, 'ºC'),
	(95254, 108, '2015-03-15 00:08:50.000000', 'temperatura', 115.0000, 'ºC'),
	(95255, 108, '2015-03-15 00:08:51.000000', 'temperatura', 591.0000, 'ºC'),
	(95256, 108, '2015-03-15 00:08:52.000000', 'temperatura', 210.0000, 'ºC'),
	(95257, 108, '2015-03-15 00:08:53.000000', 'temperatura', 478.0000, 'ºC'),
	(95258, 108, '2015-03-15 00:08:54.000000', 'temperatura', 561.0000, 'ºC'),
	(95259, 108, '2015-03-15 00:08:55.000000', 'temperatura', 171.0000, 'ºC'),
	(95260, 108, '2015-03-15 00:08:56.000000', 'temperatura', 371.0000, 'ºC'),
	(95261, 108, '2015-03-15 00:08:57.000000', 'temperatura', 142.0000, 'ºC'),
	(95262, 108, '2015-03-15 00:08:58.000000', 'temperatura', 797.0000, 'ºC'),
	(95263, 108, '2015-03-15 00:08:59.000000', 'temperatura', 1159.0000, 'ºC'),
	(95264, 108, '2015-03-15 00:09:00.000000', 'temperatura', 1004.0000, 'ºC'),
	(95265, 108, '2015-03-15 00:09:01.000000', 'temperatura', 343.0000, 'ºC'),
	(95266, 108, '2015-03-15 00:09:02.000000', 'temperatura', 1105.0000, 'ºC'),
	(95267, 108, '2015-03-15 00:09:03.000000', 'temperatura', 898.0000, 'ºC'),
	(95268, 108, '2015-03-15 00:09:04.000000', 'temperatura', 1173.0000, 'ºC'),
	(95269, 108, '2015-03-15 00:09:05.000000', 'temperatura', 774.0000, 'ºC'),
	(95270, 108, '2015-03-15 00:09:06.000000', 'temperatura', 349.0000, 'ºC'),
	(95271, 108, '2015-03-15 00:09:07.000000', 'temperatura', 625.0000, 'ºC'),
	(95272, 108, '2015-03-15 00:09:08.000000', 'temperatura', 877.0000, 'ºC'),
	(95273, 108, '2015-03-15 00:09:09.000000', 'temperatura', 112.0000, 'ºC'),
	(95274, 108, '2015-03-15 00:09:10.000000', 'temperatura', 329.0000, 'ºC'),
	(95275, 108, '2015-03-15 00:09:11.000000', 'temperatura', 111.0000, 'ºC'),
	(95276, 108, '2015-03-15 00:09:12.000000', 'temperatura', 765.0000, 'ºC'),
	(95277, 108, '2015-03-15 00:09:13.000000', 'temperatura', 1096.0000, 'ºC'),
	(95278, 108, '2015-03-15 00:09:14.000000', 'temperatura', 782.0000, 'ºC'),
	(95279, 108, '2015-03-15 00:09:15.000000', 'temperatura', 626.0000, 'ºC'),
	(95280, 108, '2015-03-15 00:09:16.000000', 'temperatura', 784.0000, 'ºC'),
	(95281, 108, '2015-03-15 00:09:17.000000', 'temperatura', 840.0000, 'ºC'),
	(95282, 108, '2015-03-15 00:09:18.000000', 'temperatura', 650.0000, 'ºC'),
	(95283, 108, '2015-03-15 00:09:19.000000', 'temperatura', 732.0000, 'ºC'),
	(95284, 108, '2015-03-15 00:09:20.000000', 'temperatura', 509.0000, 'ºC'),
	(95285, 108, '2015-03-15 00:09:21.000000', 'temperatura', 352.0000, 'ºC'),
	(95286, 108, '2015-03-15 00:09:22.000000', 'temperatura', 231.0000, 'ºC'),
	(95287, 108, '2015-03-15 00:09:23.000000', 'temperatura', 101.0000, 'ºC'),
	(95288, 108, '2015-03-15 00:09:24.000000', 'temperatura', 1010.0000, 'ºC'),
	(95289, 108, '2015-03-15 00:09:25.000000', 'temperatura', 1150.0000, 'ºC'),
	(95290, 108, '2015-03-15 00:09:26.000000', 'temperatura', 319.0000, 'ºC'),
	(95291, 108, '2015-03-15 00:09:27.000000', 'temperatura', 545.0000, 'ºC'),
	(95292, 108, '2015-03-15 00:09:28.000000', 'temperatura', 567.0000, 'ºC'),
	(95293, 108, '2015-03-15 00:09:29.000000', 'temperatura', 3.0000, 'ºC'),
	(95294, 108, '2015-03-15 00:09:30.000000', 'temperatura', 715.0000, 'ºC'),
	(95295, 108, '2015-03-15 00:09:31.000000', 'temperatura', 1167.0000, 'ºC'),
	(95296, 108, '2015-03-15 00:09:32.000000', 'temperatura', 89.0000, 'ºC'),
	(95297, 108, '2015-03-15 00:09:33.000000', 'temperatura', 543.0000, 'ºC'),
	(95298, 108, '2015-03-15 00:09:34.000000', 'temperatura', 49.0000, 'ºC'),
	(95299, 108, '2015-03-15 00:09:35.000000', 'temperatura', 1016.0000, 'ºC'),
	(95300, 108, '2015-03-15 00:09:36.000000', 'temperatura', 136.0000, 'ºC'),
	(95301, 108, '2015-03-15 00:09:37.000000', 'temperatura', 30.0000, 'ºC'),
	(95302, 108, '2015-03-15 00:09:38.000000', 'temperatura', 943.0000, 'ºC'),
	(95303, 108, '2015-03-15 00:09:39.000000', 'temperatura', 1025.0000, 'ºC'),
	(95304, 108, '2015-03-15 00:09:40.000000', 'temperatura', 1097.0000, 'ºC'),
	(95305, 108, '2015-03-15 00:09:41.000000', 'temperatura', 9.0000, 'ºC'),
	(95306, 108, '2015-03-15 00:09:42.000000', 'temperatura', 354.0000, 'ºC'),
	(95307, 108, '2015-03-15 00:09:43.000000', 'temperatura', 543.0000, 'ºC'),
	(95308, 108, '2015-03-15 00:09:44.000000', 'temperatura', 454.0000, 'ºC'),
	(95309, 108, '2015-03-15 00:09:45.000000', 'temperatura', 643.0000, 'ºC'),
	(95310, 108, '2015-03-15 00:09:46.000000', 'temperatura', 654.0000, 'ºC'),
	(95311, 108, '2015-03-15 00:09:47.000000', 'temperatura', 141.0000, 'ºC'),
	(95312, 108, '2015-03-15 00:09:48.000000', 'temperatura', 1144.0000, 'ºC'),
	(95313, 108, '2015-03-15 00:09:49.000000', 'temperatura', 499.0000, 'ºC'),
	(95314, 108, '2015-03-15 00:09:50.000000', 'temperatura', 260.0000, 'ºC'),
	(95315, 108, '2015-03-15 00:09:51.000000', 'temperatura', 1007.0000, 'ºC'),
	(95316, 108, '2015-03-15 00:09:52.000000', 'temperatura', 654.0000, 'ºC'),
	(95317, 108, '2015-03-15 00:09:53.000000', 'temperatura', 251.0000, 'ºC'),
	(95318, 108, '2015-03-15 00:09:54.000000', 'temperatura', 494.0000, 'ºC'),
	(95319, 108, '2015-03-15 00:09:55.000000', 'temperatura', 515.0000, 'ºC'),
	(95320, 108, '2015-03-15 00:09:56.000000', 'temperatura', 1093.0000, 'ºC'),
	(95321, 108, '2015-03-15 00:09:57.000000', 'temperatura', 322.0000, 'ºC'),
	(95322, 108, '2015-03-15 00:09:58.000000', 'temperatura', 733.0000, 'ºC'),
	(95323, 108, '2015-03-15 00:09:59.000000', 'temperatura', 297.0000, 'ºC'),
	(95324, 108, '2015-03-15 00:10:00.000000', 'temperatura', 489.0000, 'ºC'),
	(95325, 108, '2015-03-15 00:10:01.000000', 'temperatura', 353.0000, 'ºC'),
	(95326, 108, '2015-03-15 00:10:02.000000', 'temperatura', 298.0000, 'ºC'),
	(95327, 108, '2015-03-15 00:10:03.000000', 'temperatura', 430.0000, 'ºC'),
	(95328, 108, '2015-03-15 00:10:04.000000', 'temperatura', 59.0000, 'ºC'),
	(95329, 108, '2015-03-15 00:10:05.000000', 'temperatura', 207.0000, 'ºC'),
	(95330, 108, '2015-03-15 00:10:06.000000', 'temperatura', 855.0000, 'ºC'),
	(95331, 108, '2015-03-15 00:10:07.000000', 'temperatura', 56.0000, 'ºC'),
	(95332, 108, '2015-03-15 00:10:08.000000', 'temperatura', 116.0000, 'ºC'),
	(95333, 108, '2015-03-15 00:10:09.000000', 'temperatura', 411.0000, 'ºC'),
	(95334, 108, '2015-03-15 00:10:10.000000', 'temperatura', 509.0000, 'ºC'),
	(95335, 108, '2015-03-15 00:10:11.000000', 'temperatura', 111.0000, 'ºC'),
	(95336, 108, '2015-03-15 00:10:12.000000', 'temperatura', 230.0000, 'ºC'),
	(95337, 108, '2015-03-15 00:10:13.000000', 'temperatura', 818.0000, 'ºC'),
	(95338, 108, '2015-03-15 00:10:14.000000', 'temperatura', 999.0000, 'ºC'),
	(95339, 108, '2015-03-15 00:10:15.000000', 'temperatura', 142.0000, 'ºC'),
	(95340, 108, '2015-03-15 00:10:16.000000', 'temperatura', 113.0000, 'ºC'),
	(95341, 108, '2015-03-15 00:10:17.000000', 'temperatura', 142.0000, 'ºC'),
	(95342, 108, '2015-03-15 00:10:18.000000', 'temperatura', 369.0000, 'ºC'),
	(95343, 108, '2015-03-15 00:10:19.000000', 'temperatura', 221.0000, 'ºC'),
	(95344, 108, '2015-03-15 00:10:20.000000', 'temperatura', 1197.0000, 'ºC'),
	(95345, 108, '2015-03-15 00:10:21.000000', 'temperatura', 522.0000, 'ºC'),
	(95346, 108, '2015-03-15 00:10:22.000000', 'temperatura', 221.0000, 'ºC'),
	(95347, 108, '2015-03-15 00:10:23.000000', 'temperatura', 739.0000, 'ºC'),
	(95348, 108, '2015-03-15 00:10:24.000000', 'temperatura', 631.0000, 'ºC'),
	(95349, 108, '2015-03-15 00:10:25.000000', 'temperatura', 941.0000, 'ºC'),
	(95350, 108, '2015-03-15 00:10:26.000000', 'temperatura', 411.0000, 'ºC'),
	(95351, 108, '2015-03-15 00:10:27.000000', 'temperatura', 434.0000, 'ºC'),
	(95352, 108, '2015-03-15 00:10:28.000000', 'temperatura', 937.0000, 'ºC'),
	(95353, 108, '2015-03-15 00:10:29.000000', 'temperatura', 985.0000, 'ºC'),
	(95354, 108, '2015-03-15 00:10:30.000000', 'temperatura', 913.0000, 'ºC'),
	(95355, 108, '2015-03-15 00:10:31.000000', 'temperatura', 411.0000, 'ºC'),
	(95356, 108, '2015-03-15 00:10:32.000000', 'temperatura', 516.0000, 'ºC'),
	(95357, 108, '2015-03-15 00:10:33.000000', 'temperatura', 149.0000, 'ºC'),
	(95358, 108, '2015-03-15 00:10:34.000000', 'temperatura', 397.0000, 'ºC'),
	(95359, 108, '2015-03-15 00:10:35.000000', 'temperatura', 337.0000, 'ºC'),
	(95360, 108, '2015-03-15 00:10:36.000000', 'temperatura', 495.0000, 'ºC'),
	(95361, 108, '2015-03-15 00:10:37.000000', 'temperatura', 263.0000, 'ºC'),
	(95362, 108, '2015-03-15 00:10:38.000000', 'temperatura', 1032.0000, 'ºC'),
	(95363, 108, '2015-03-15 00:10:39.000000', 'temperatura', 771.0000, 'ºC'),
	(95364, 108, '2015-03-15 00:10:40.000000', 'temperatura', 761.0000, 'ºC'),
	(95365, 108, '2015-03-15 00:10:41.000000', 'temperatura', 293.0000, 'ºC'),
	(95366, 108, '2015-03-15 00:10:42.000000', 'temperatura', 382.0000, 'ºC'),
	(95367, 108, '2015-03-15 00:10:43.000000', 'temperatura', 1031.0000, 'ºC'),
	(95368, 108, '2015-03-15 00:10:44.000000', 'temperatura', 410.0000, 'ºC'),
	(95369, 108, '2015-03-15 00:10:45.000000', 'temperatura', 156.0000, 'ºC'),
	(95370, 108, '2015-03-15 00:10:46.000000', 'temperatura', 752.0000, 'ºC'),
	(95371, 108, '2015-03-15 00:10:47.000000', 'temperatura', 890.0000, 'ºC'),
	(95372, 108, '2015-03-15 00:10:48.000000', 'temperatura', 996.0000, 'ºC'),
	(95373, 108, '2015-03-15 00:10:49.000000', 'temperatura', 1112.0000, 'ºC'),
	(95374, 108, '2015-03-15 00:10:50.000000', 'temperatura', 173.0000, 'ºC'),
	(95375, 108, '2015-03-15 00:10:51.000000', 'temperatura', 1127.0000, 'ºC'),
	(95376, 108, '2015-03-15 00:10:52.000000', 'temperatura', 318.0000, 'ºC'),
	(95377, 108, '2015-03-15 00:10:53.000000', 'temperatura', 610.0000, 'ºC'),
	(95378, 108, '2015-03-15 00:10:54.000000', 'temperatura', 895.0000, 'ºC'),
	(95379, 108, '2015-03-15 00:10:55.000000', 'temperatura', 248.0000, 'ºC'),
	(95380, 108, '2015-03-15 00:10:56.000000', 'temperatura', 953.0000, 'ºC'),
	(95381, 108, '2015-03-15 00:10:57.000000', 'temperatura', 423.0000, 'ºC'),
	(95382, 108, '2015-03-15 00:10:58.000000', 'temperatura', 455.0000, 'ºC'),
	(95383, 108, '2015-03-15 00:10:59.000000', 'temperatura', 1009.0000, 'ºC'),
	(95384, 108, '2015-03-15 00:11:00.000000', 'temperatura', 78.0000, 'ºC'),
	(95385, 108, '2015-03-15 00:11:01.000000', 'temperatura', 962.0000, 'ºC'),
	(95386, 108, '2015-03-15 00:11:02.000000', 'temperatura', 979.0000, 'ºC'),
	(95387, 108, '2015-03-15 00:11:03.000000', 'temperatura', 810.0000, 'ºC'),
	(95388, 108, '2015-03-15 00:11:04.000000', 'temperatura', 1115.0000, 'ºC'),
	(95389, 108, '2015-03-15 00:11:05.000000', 'temperatura', 743.0000, 'ºC'),
	(95390, 108, '2015-03-15 00:11:06.000000', 'temperatura', 370.0000, 'ºC'),
	(95391, 108, '2015-03-15 00:11:07.000000', 'temperatura', 821.0000, 'ºC'),
	(95392, 108, '2015-03-15 00:11:08.000000', 'temperatura', 594.0000, 'ºC'),
	(95393, 108, '2015-03-15 00:11:09.000000', 'temperatura', 511.0000, 'ºC'),
	(95394, 108, '2015-03-15 00:11:10.000000', 'temperatura', 770.0000, 'ºC'),
	(95395, 108, '2015-03-15 00:11:11.000000', 'temperatura', 1121.0000, 'ºC'),
	(95396, 108, '2015-03-15 00:11:12.000000', 'temperatura', 893.0000, 'ºC'),
	(95397, 108, '2015-03-15 00:11:13.000000', 'temperatura', 1102.0000, 'ºC'),
	(95398, 108, '2015-03-15 00:11:14.000000', 'temperatura', 432.0000, 'ºC'),
	(95399, 108, '2015-03-15 00:11:15.000000', 'temperatura', 57.0000, 'ºC'),
	(95400, 108, '2015-03-15 00:11:16.000000', 'temperatura', 187.0000, 'ºC'),
	(95401, 108, '2015-03-15 00:11:17.000000', 'temperatura', 763.0000, 'ºC'),
	(95402, 108, '2015-03-15 00:11:18.000000', 'temperatura', 856.0000, 'ºC'),
	(95403, 108, '2015-03-15 00:11:19.000000', 'temperatura', 793.0000, 'ºC'),
	(95404, 108, '2015-03-15 00:11:20.000000', 'temperatura', 197.0000, 'ºC'),
	(95405, 108, '2015-03-15 00:11:21.000000', 'temperatura', 1006.0000, 'ºC'),
	(95406, 108, '2015-03-15 00:11:22.000000', 'temperatura', 841.0000, 'ºC'),
	(95407, 108, '2015-03-15 00:11:23.000000', 'temperatura', 1187.0000, 'ºC'),
	(95408, 108, '2015-03-15 00:11:24.000000', 'temperatura', 1013.0000, 'ºC'),
	(95409, 108, '2015-03-15 00:11:25.000000', 'temperatura', 305.0000, 'ºC'),
	(95410, 108, '2015-03-15 00:11:26.000000', 'temperatura', 887.0000, 'ºC'),
	(95411, 108, '2015-03-15 00:11:27.000000', 'temperatura', 1118.0000, 'ºC'),
	(95412, 108, '2015-03-15 00:11:28.000000', 'temperatura', 529.0000, 'ºC'),
	(95413, 108, '2015-03-15 00:11:29.000000', 'temperatura', 494.0000, 'ºC'),
	(95414, 108, '2015-03-15 00:11:30.000000', 'temperatura', 884.0000, 'ºC'),
	(95415, 108, '2015-03-15 00:11:31.000000', 'temperatura', 536.0000, 'ºC'),
	(95416, 108, '2015-03-15 00:11:32.000000', 'temperatura', 29.0000, 'ºC'),
	(95417, 108, '2015-03-15 00:11:33.000000', 'temperatura', 936.0000, 'ºC'),
	(95418, 108, '2015-03-15 00:11:34.000000', 'temperatura', 996.0000, 'ºC'),
	(95419, 108, '2015-03-15 00:11:35.000000', 'temperatura', 973.0000, 'ºC'),
	(95420, 108, '2015-03-15 00:11:36.000000', 'temperatura', 676.0000, 'ºC'),
	(95421, 108, '2015-03-15 00:11:37.000000', 'temperatura', 461.0000, 'ºC'),
	(95422, 108, '2015-03-15 00:11:38.000000', 'temperatura', 276.0000, 'ºC'),
	(95423, 108, '2015-03-15 00:11:39.000000', 'temperatura', 0.0000, 'ºC'),
	(95424, 108, '2015-03-15 00:11:40.000000', 'temperatura', 372.0000, 'ºC'),
	(95425, 108, '2015-03-15 00:11:41.000000', 'temperatura', 661.0000, 'ºC'),
	(95426, 108, '2015-03-15 00:11:42.000000', 'temperatura', 990.0000, 'ºC'),
	(95427, 108, '2015-03-15 00:11:43.000000', 'temperatura', 569.0000, 'ºC'),
	(95428, 108, '2015-03-15 00:11:44.000000', 'temperatura', 1072.0000, 'ºC'),
	(95429, 108, '2015-03-15 00:11:45.000000', 'temperatura', 55.0000, 'ºC'),
	(95430, 108, '2015-03-15 00:11:46.000000', 'temperatura', 660.0000, 'ºC'),
	(95431, 108, '2015-03-15 00:11:47.000000', 'temperatura', 734.0000, 'ºC'),
	(95432, 108, '2015-03-15 00:11:48.000000', 'temperatura', 492.0000, 'ºC'),
	(95433, 108, '2015-03-15 00:11:49.000000', 'temperatura', 258.0000, 'ºC'),
	(95434, 108, '2015-03-15 00:11:50.000000', 'temperatura', 1014.0000, 'ºC'),
	(95435, 108, '2015-03-15 00:11:51.000000', 'temperatura', 696.0000, 'ºC'),
	(95436, 108, '2015-03-15 00:11:52.000000', 'temperatura', 439.0000, 'ºC'),
	(95437, 108, '2015-03-15 00:11:53.000000', 'temperatura', 109.0000, 'ºC'),
	(95438, 108, '2015-03-15 00:11:54.000000', 'temperatura', 427.0000, 'ºC'),
	(95439, 108, '2015-03-15 00:11:55.000000', 'temperatura', 609.0000, 'ºC'),
	(95440, 108, '2015-03-15 00:11:56.000000', 'temperatura', 565.0000, 'ºC'),
	(95441, 108, '2015-03-15 00:11:57.000000', 'temperatura', 999.0000, 'ºC'),
	(95442, 108, '2015-03-15 00:11:58.000000', 'temperatura', 898.0000, 'ºC'),
	(95443, 108, '2015-03-15 00:11:59.000000', 'temperatura', 296.0000, 'ºC'),
	(95444, 108, '2015-03-15 00:12:00.000000', 'temperatura', 1188.0000, 'ºC'),
	(95445, 108, '2015-03-15 00:12:01.000000', 'temperatura', 249.0000, 'ºC'),
	(95446, 108, '2015-03-15 00:12:02.000000', 'temperatura', 84.0000, 'ºC'),
	(95447, 108, '2015-03-15 00:12:03.000000', 'temperatura', 874.0000, 'ºC'),
	(95448, 108, '2015-03-15 00:12:04.000000', 'temperatura', 519.0000, 'ºC'),
	(95449, 108, '2015-03-15 00:12:05.000000', 'temperatura', 1171.0000, 'ºC'),
	(95450, 108, '2015-03-15 00:12:06.000000', 'temperatura', 698.0000, 'ºC'),
	(95451, 108, '2015-03-15 00:12:07.000000', 'temperatura', 1177.0000, 'ºC'),
	(95452, 108, '2015-03-15 00:12:08.000000', 'temperatura', 194.0000, 'ºC'),
	(95453, 108, '2015-03-15 00:12:09.000000', 'temperatura', 1039.0000, 'ºC'),
	(95454, 108, '2015-03-15 00:12:10.000000', 'temperatura', 1013.0000, 'ºC'),
	(95455, 108, '2015-03-15 00:12:11.000000', 'temperatura', 750.0000, 'ºC'),
	(95456, 108, '2015-03-15 00:12:12.000000', 'temperatura', 711.0000, 'ºC'),
	(95457, 108, '2015-03-15 00:12:13.000000', 'temperatura', 105.0000, 'ºC'),
	(95458, 108, '2015-03-15 00:12:14.000000', 'temperatura', 794.0000, 'ºC'),
	(95459, 108, '2015-03-15 00:12:15.000000', 'temperatura', 56.0000, 'ºC'),
	(95460, 108, '2015-03-15 00:12:16.000000', 'temperatura', 296.0000, 'ºC'),
	(95461, 108, '2015-03-15 00:12:17.000000', 'temperatura', 114.0000, 'ºC'),
	(95462, 108, '2015-03-15 00:12:18.000000', 'temperatura', 882.0000, 'ºC'),
	(95463, 108, '2015-03-15 00:12:19.000000', 'temperatura', 469.0000, 'ºC'),
	(95464, 108, '2015-03-15 00:12:20.000000', 'temperatura', 899.0000, 'ºC'),
	(95465, 108, '2015-03-15 00:12:21.000000', 'temperatura', 687.0000, 'ºC'),
	(95466, 108, '2015-03-15 00:12:22.000000', 'temperatura', 741.0000, 'ºC'),
	(95467, 108, '2015-03-15 00:12:23.000000', 'temperatura', 443.0000, 'ºC'),
	(95468, 108, '2015-03-15 00:12:24.000000', 'temperatura', 1192.0000, 'ºC'),
	(95469, 108, '2015-03-15 00:12:25.000000', 'temperatura', 1030.0000, 'ºC'),
	(95470, 108, '2015-03-15 00:12:26.000000', 'temperatura', 378.0000, 'ºC'),
	(95471, 108, '2015-03-15 00:12:27.000000', 'temperatura', 1199.0000, 'ºC'),
	(95472, 108, '2015-03-15 00:12:28.000000', 'temperatura', 63.0000, 'ºC'),
	(95473, 108, '2015-03-15 00:12:29.000000', 'temperatura', 317.0000, 'ºC'),
	(95474, 108, '2015-03-15 00:12:30.000000', 'temperatura', 198.0000, 'ºC'),
	(95475, 108, '2015-03-15 00:12:31.000000', 'temperatura', 39.0000, 'ºC'),
	(95476, 108, '2015-03-15 00:12:32.000000', 'temperatura', 803.0000, 'ºC'),
	(95477, 108, '2015-03-15 00:12:33.000000', 'temperatura', 299.0000, 'ºC'),
	(95478, 108, '2015-03-15 00:12:34.000000', 'temperatura', 283.0000, 'ºC'),
	(95479, 108, '2015-03-15 00:12:35.000000', 'temperatura', 522.0000, 'ºC'),
	(95480, 108, '2015-03-15 00:12:36.000000', 'temperatura', 559.0000, 'ºC'),
	(95481, 108, '2015-03-15 00:12:37.000000', 'temperatura', 31.0000, 'ºC'),
	(95482, 108, '2015-03-15 00:12:38.000000', 'temperatura', 879.0000, 'ºC'),
	(95483, 108, '2015-03-15 00:12:39.000000', 'temperatura', 704.0000, 'ºC'),
	(95484, 108, '2015-03-15 00:12:40.000000', 'temperatura', 881.0000, 'ºC'),
	(95485, 108, '2015-03-15 00:12:41.000000', 'temperatura', 1094.0000, 'ºC'),
	(95486, 108, '2015-03-15 00:12:42.000000', 'temperatura', 426.0000, 'ºC'),
	(95487, 108, '2015-03-15 00:12:43.000000', 'temperatura', 49.0000, 'ºC'),
	(95488, 108, '2015-03-15 00:12:44.000000', 'temperatura', 167.0000, 'ºC'),
	(95489, 108, '2015-03-15 00:12:45.000000', 'temperatura', 688.0000, 'ºC'),
	(95490, 108, '2015-03-15 00:12:46.000000', 'temperatura', 539.0000, 'ºC'),
	(95491, 108, '2015-03-15 00:12:47.000000', 'temperatura', 631.0000, 'ºC'),
	(95492, 108, '2015-03-15 00:12:48.000000', 'temperatura', 339.0000, 'ºC'),
	(95493, 108, '2015-03-15 00:12:49.000000', 'temperatura', 1004.0000, 'ºC'),
	(95494, 108, '2015-03-15 00:12:50.000000', 'temperatura', 401.0000, 'ºC'),
	(95495, 108, '2015-03-15 00:12:51.000000', 'temperatura', 193.0000, 'ºC'),
	(95496, 108, '2015-03-15 00:12:52.000000', 'temperatura', 962.0000, 'ºC'),
	(95497, 108, '2015-03-15 00:12:53.000000', 'temperatura', 634.0000, 'ºC'),
	(95498, 108, '2015-03-15 00:12:54.000000', 'temperatura', 285.0000, 'ºC'),
	(95499, 108, '2015-03-15 00:12:55.000000', 'temperatura', 722.0000, 'ºC'),
	(95500, 108, '2015-03-15 00:12:56.000000', 'temperatura', 356.0000, 'ºC'),
	(95501, 108, '2015-03-15 00:12:57.000000', 'temperatura', 813.0000, 'ºC'),
	(95502, 108, '2015-03-15 00:12:58.000000', 'temperatura', 598.0000, 'ºC'),
	(95503, 108, '2015-03-15 00:12:59.000000', 'temperatura', 550.0000, 'ºC'),
	(95504, 108, '2015-03-15 00:13:00.000000', 'temperatura', 957.0000, 'ºC'),
	(95505, 108, '2015-03-15 00:13:01.000000', 'temperatura', 735.0000, 'ºC'),
	(95506, 108, '2015-03-15 00:13:02.000000', 'temperatura', 805.0000, 'ºC'),
	(95507, 108, '2015-03-15 00:13:03.000000', 'temperatura', 620.0000, 'ºC'),
	(95508, 108, '2015-03-15 00:13:04.000000', 'temperatura', 685.0000, 'ºC'),
	(95509, 108, '2015-03-15 00:13:05.000000', 'temperatura', 368.0000, 'ºC'),
	(95510, 108, '2015-03-15 00:13:06.000000', 'temperatura', 985.0000, 'ºC'),
	(95511, 108, '2015-03-15 00:13:07.000000', 'temperatura', 220.0000, 'ºC'),
	(95512, 108, '2015-03-15 00:13:08.000000', 'temperatura', 545.0000, 'ºC'),
	(95513, 108, '2015-03-15 00:13:09.000000', 'temperatura', 868.0000, 'ºC'),
	(95514, 108, '2015-03-15 00:13:10.000000', 'temperatura', 302.0000, 'ºC'),
	(95515, 108, '2015-03-15 00:13:11.000000', 'temperatura', 109.0000, 'ºC'),
	(95516, 108, '2015-03-15 00:13:12.000000', 'temperatura', 840.0000, 'ºC'),
	(95517, 108, '2015-03-15 00:13:13.000000', 'temperatura', 275.0000, 'ºC'),
	(95518, 108, '2015-03-15 00:13:14.000000', 'temperatura', 52.0000, 'ºC'),
	(95519, 108, '2015-03-15 00:13:15.000000', 'temperatura', 639.0000, 'ºC'),
	(95520, 108, '2015-03-15 00:13:16.000000', 'temperatura', 638.0000, 'ºC'),
	(95521, 108, '2015-03-15 00:13:17.000000', 'temperatura', 73.0000, 'ºC'),
	(95522, 108, '2015-03-15 00:13:18.000000', 'temperatura', 853.0000, 'ºC'),
	(95523, 108, '2015-03-15 00:13:19.000000', 'temperatura', 444.0000, 'ºC'),
	(95524, 108, '2015-03-15 00:13:20.000000', 'temperatura', 861.0000, 'ºC'),
	(95525, 108, '2015-03-15 00:13:21.000000', 'temperatura', 577.0000, 'ºC'),
	(95526, 108, '2015-03-15 00:13:22.000000', 'temperatura', 299.0000, 'ºC'),
	(95527, 108, '2015-03-15 00:13:23.000000', 'temperatura', 965.0000, 'ºC'),
	(95528, 108, '2015-03-15 00:13:24.000000', 'temperatura', 330.0000, 'ºC'),
	(95529, 108, '2015-03-15 00:13:25.000000', 'temperatura', 1156.0000, 'ºC'),
	(95530, 108, '2015-03-15 00:13:26.000000', 'temperatura', 1190.0000, 'ºC'),
	(95531, 108, '2015-03-15 00:13:27.000000', 'temperatura', 84.0000, 'ºC'),
	(95532, 108, '2015-03-15 00:13:28.000000', 'temperatura', 448.0000, 'ºC'),
	(95533, 108, '2015-03-15 00:13:29.000000', 'temperatura', 791.0000, 'ºC'),
	(95534, 108, '2015-03-15 00:13:30.000000', 'temperatura', 211.0000, 'ºC'),
	(95535, 108, '2015-03-15 00:13:31.000000', 'temperatura', 1081.0000, 'ºC'),
	(95536, 108, '2015-03-15 00:13:32.000000', 'temperatura', 1172.0000, 'ºC'),
	(95537, 108, '2015-03-15 00:13:33.000000', 'temperatura', 220.0000, 'ºC'),
	(95538, 108, '2015-03-15 00:13:34.000000', 'temperatura', 1183.0000, 'ºC'),
	(95539, 108, '2015-03-15 00:13:35.000000', 'temperatura', 457.0000, 'ºC'),
	(95540, 108, '2015-03-15 00:13:36.000000', 'temperatura', 1137.0000, 'ºC'),
	(95541, 108, '2015-03-15 00:13:37.000000', 'temperatura', 713.0000, 'ºC'),
	(95542, 108, '2015-03-15 00:13:38.000000', 'temperatura', 155.0000, 'ºC'),
	(95543, 108, '2015-03-15 00:13:39.000000', 'temperatura', 1037.0000, 'ºC'),
	(95544, 108, '2015-03-15 00:13:40.000000', 'temperatura', 1122.0000, 'ºC'),
	(95545, 108, '2015-03-15 00:13:41.000000', 'temperatura', 98.0000, 'ºC'),
	(95546, 108, '2015-03-15 00:13:42.000000', 'temperatura', 725.0000, 'ºC'),
	(95547, 108, '2015-03-15 00:13:43.000000', 'temperatura', 931.0000, 'ºC'),
	(95548, 108, '2015-03-15 00:13:44.000000', 'temperatura', 81.0000, 'ºC'),
	(95549, 108, '2015-03-15 00:13:45.000000', 'temperatura', 13.0000, 'ºC'),
	(95550, 108, '2015-03-15 00:13:46.000000', 'temperatura', 1021.0000, 'ºC'),
	(95551, 108, '2015-03-15 00:13:47.000000', 'temperatura', 266.0000, 'ºC'),
	(95552, 108, '2015-03-15 00:13:48.000000', 'temperatura', 669.0000, 'ºC'),
	(95553, 108, '2015-03-15 00:13:49.000000', 'temperatura', 148.0000, 'ºC'),
	(95554, 108, '2015-03-15 00:13:50.000000', 'temperatura', 1133.0000, 'ºC'),
	(95555, 108, '2015-03-15 00:13:51.000000', 'temperatura', 420.0000, 'ºC'),
	(95556, 108, '2015-03-15 00:13:52.000000', 'temperatura', 1105.0000, 'ºC'),
	(95557, 108, '2015-03-15 00:13:53.000000', 'temperatura', 662.0000, 'ºC'),
	(95558, 108, '2015-03-15 00:13:54.000000', 'temperatura', 1197.0000, 'ºC'),
	(95559, 108, '2015-03-15 00:13:55.000000', 'temperatura', 397.0000, 'ºC'),
	(95560, 108, '2015-03-15 00:13:56.000000', 'temperatura', 798.0000, 'ºC'),
	(95561, 108, '2015-03-15 00:13:57.000000', 'temperatura', 398.0000, 'ºC'),
	(95562, 108, '2015-03-15 00:13:58.000000', 'temperatura', 797.0000, 'ºC'),
	(95563, 108, '2015-03-15 00:13:59.000000', 'temperatura', 391.0000, 'ºC'),
	(95564, 108, '2015-03-15 00:14:00.000000', 'temperatura', 765.0000, 'ºC'),
	(95565, 108, '2015-03-15 00:14:01.000000', 'temperatura', 251.0000, 'ºC'),
	(95566, 108, '2015-03-15 00:14:02.000000', 'temperatura', 162.0000, 'ºC'),
	(95567, 108, '2015-03-15 00:14:03.000000', 'temperatura', 59.0000, 'ºC'),
	(95568, 108, '2015-03-15 00:14:04.000000', 'temperatura', 1008.0000, 'ºC'),
	(95569, 108, '2015-03-15 00:14:05.000000', 'temperatura', 65.0000, 'ºC'),
	(95570, 108, '2015-03-15 00:14:06.000000', 'temperatura', 899.0000, 'ºC'),
	(95571, 108, '2015-03-15 00:14:07.000000', 'temperatura', 703.0000, 'ºC'),
	(95572, 108, '2015-03-15 00:14:08.000000', 'temperatura', 818.0000, 'ºC'),
	(95573, 108, '2015-03-15 00:14:09.000000', 'temperatura', 780.0000, 'ºC'),
	(95574, 108, '2015-03-15 00:14:10.000000', 'temperatura', 246.0000, 'ºC'),
	(95575, 108, '2015-03-15 00:14:11.000000', 'temperatura', 92.0000, 'ºC'),
	(95576, 108, '2015-03-15 00:14:12.000000', 'temperatura', 922.0000, 'ºC'),
	(95577, 108, '2015-03-15 00:14:13.000000', 'temperatura', 735.0000, 'ºC'),
	(95578, 108, '2015-03-15 00:14:14.000000', 'temperatura', 911.0000, 'ºC'),
	(95579, 108, '2015-03-15 00:14:15.000000', 'temperatura', 1149.0000, 'ºC'),
	(95580, 108, '2015-03-15 00:14:16.000000', 'temperatura', 611.0000, 'ºC'),
	(95581, 108, '2015-03-15 00:14:17.000000', 'temperatura', 811.0000, 'ºC'),
	(95582, 108, '2015-03-15 00:14:18.000000', 'temperatura', 1021.0000, 'ºC'),
	(95583, 108, '2015-03-15 00:14:19.000000', 'temperatura', 273.0000, 'ºC'),
	(95584, 108, '2015-03-15 00:14:20.000000', 'temperatura', 703.0000, 'ºC'),
	(95585, 108, '2015-03-15 00:14:21.000000', 'temperatura', 296.0000, 'ºC'),
	(95586, 108, '2015-03-15 00:14:22.000000', 'temperatura', 572.0000, 'ºC'),
	(95587, 108, '2015-03-15 00:14:23.000000', 'temperatura', 772.0000, 'ºC'),
	(95588, 108, '2015-03-15 00:14:24.000000', 'temperatura', 946.0000, 'ºC'),
	(95589, 108, '2015-03-15 00:14:25.000000', 'temperatura', 11.0000, 'ºC'),
	(95590, 108, '2015-03-15 00:14:26.000000', 'temperatura', 821.0000, 'ºC'),
	(95591, 108, '2015-03-15 00:14:27.000000', 'temperatura', 472.0000, 'ºC'),
	(95592, 108, '2015-03-15 00:14:28.000000', 'temperatura', 1096.0000, 'ºC'),
	(95593, 108, '2015-03-15 00:14:29.000000', 'temperatura', 467.0000, 'ºC'),
	(95594, 108, '2015-03-15 00:14:30.000000', 'temperatura', 246.0000, 'ºC'),
	(95595, 108, '2015-03-15 00:14:31.000000', 'temperatura', 1032.0000, 'ºC'),
	(95596, 108, '2015-03-15 00:14:32.000000', 'temperatura', 820.0000, 'ºC'),
	(95597, 108, '2015-03-15 00:14:33.000000', 'temperatura', 1003.0000, 'ºC'),
	(95598, 108, '2015-03-15 00:14:34.000000', 'temperatura', 157.0000, 'ºC'),
	(95599, 108, '2015-03-15 00:14:35.000000', 'temperatura', 178.0000, 'ºC'),
	(95600, 108, '2015-03-15 00:14:36.000000', 'temperatura', 417.0000, 'ºC'),
	(95601, 108, '2015-03-15 00:14:37.000000', 'temperatura', 352.0000, 'ºC'),
	(95602, 108, '2015-03-15 00:14:38.000000', 'temperatura', 512.0000, 'ºC'),
	(95603, 108, '2015-03-15 00:14:39.000000', 'temperatura', 303.0000, 'ºC'),
	(95604, 108, '2015-03-15 00:14:40.000000', 'temperatura', 1179.0000, 'ºC'),
	(95605, 108, '2015-03-15 00:14:41.000000', 'temperatura', 186.0000, 'ºC'),
	(95606, 108, '2015-03-15 00:14:42.000000', 'temperatura', 996.0000, 'ºC'),
	(95607, 108, '2015-03-15 00:14:43.000000', 'temperatura', 821.0000, 'ºC'),
	(95608, 108, '2015-03-15 00:14:44.000000', 'temperatura', 1119.0000, 'ºC'),
	(95609, 108, '2015-03-15 00:14:45.000000', 'temperatura', 732.0000, 'ºC'),
	(95610, 108, '2015-03-15 00:14:46.000000', 'temperatura', 304.0000, 'ºC'),
	(95611, 108, '2015-03-15 00:14:47.000000', 'temperatura', 524.0000, 'ºC'),
	(95612, 108, '2015-03-15 00:14:48.000000', 'temperatura', 508.0000, 'ºC'),
	(95613, 108, '2015-03-15 00:14:49.000000', 'temperatura', 967.0000, 'ºC'),
	(95614, 108, '2015-03-15 00:14:50.000000', 'temperatura', 913.0000, 'ºC'),
	(95615, 108, '2015-03-15 00:14:51.000000', 'temperatura', 466.0000, 'ºC'),
	(95616, 108, '2015-03-15 00:14:52.000000', 'temperatura', 792.0000, 'ºC'),
	(95617, 108, '2015-03-15 00:14:53.000000', 'temperatura', 162.0000, 'ºC'),
	(95618, 108, '2015-03-15 00:14:54.000000', 'temperatura', 834.0000, 'ºC'),
	(95619, 108, '2015-03-15 00:14:55.000000', 'temperatura', 83.0000, 'ºC'),
	(95620, 108, '2015-03-15 00:14:56.000000', 'temperatura', 315.0000, 'ºC'),
	(95621, 108, '2015-03-15 00:14:57.000000', 'temperatura', 128.0000, 'ºC'),
	(95622, 108, '2015-03-15 00:14:58.000000', 'temperatura', 896.0000, 'ºC'),
	(95623, 108, '2015-03-15 00:14:59.000000', 'temperatura', 494.0000, 'ºC'),
	(95624, 108, '2015-03-15 00:15:00.000000', 'temperatura', 984.0000, 'ºC'),
	(95625, 108, '2015-03-15 00:15:01.000000', 'temperatura', 1038.0000, 'ºC'),
	(95626, 108, '2015-03-15 00:15:02.000000', 'temperatura', 1038.0000, 'ºC'),
	(95627, 108, '2015-03-15 00:15:03.000000', 'temperatura', 877.0000, 'ºC'),
	(95628, 108, '2015-03-15 00:15:04.000000', 'temperatura', 70.0000, 'ºC'),
	(95629, 108, '2015-03-15 00:15:05.000000', 'temperatura', 119.0000, 'ºC'),
	(95630, 108, '2015-03-15 00:15:06.000000', 'temperatura', 388.0000, 'ºC'),
	(95631, 108, '2015-03-15 00:15:07.000000', 'temperatura', 381.0000, 'ºC'),
	(95632, 108, '2015-03-15 00:15:08.000000', 'temperatura', 741.0000, 'ºC'),
	(95633, 108, '2015-03-15 00:15:09.000000', 'temperatura', 164.0000, 'ºC'),
	(95634, 108, '2015-03-15 00:15:10.000000', 'temperatura', 996.0000, 'ºC'),
	(95635, 108, '2015-03-15 00:15:11.000000', 'temperatura', 888.0000, 'ºC'),
	(95636, 108, '2015-03-15 00:15:12.000000', 'temperatura', 253.0000, 'ºC'),
	(95637, 108, '2015-03-15 00:15:13.000000', 'temperatura', 1003.0000, 'ºC'),
	(95638, 108, '2015-03-15 00:15:14.000000', 'temperatura', 657.0000, 'ºC'),
	(95639, 108, '2015-03-15 00:15:15.000000', 'temperatura', 275.0000, 'ºC'),
	(95640, 108, '2015-03-15 00:15:16.000000', 'temperatura', 603.0000, 'ºC'),
	(95641, 108, '2015-03-15 00:15:17.000000', 'temperatura', 992.0000, 'ºC'),
	(95642, 108, '2015-03-15 00:15:18.000000', 'temperatura', 751.0000, 'ºC'),
	(95643, 108, '2015-03-15 00:15:19.000000', 'temperatura', 778.0000, 'ºC'),
	(95644, 108, '2015-03-15 00:15:20.000000', 'temperatura', 438.0000, 'ºC'),
	(95645, 108, '2015-03-15 00:15:21.000000', 'temperatura', 1055.0000, 'ºC'),
	(95646, 108, '2015-03-15 00:15:22.000000', 'temperatura', 363.0000, 'ºC'),
	(95647, 108, '2015-03-15 00:15:23.000000', 'temperatura', 1049.0000, 'ºC'),
	(95648, 108, '2015-03-15 00:15:24.000000', 'temperatura', 559.0000, 'ºC'),
	(95649, 108, '2015-03-15 00:15:25.000000', 'temperatura', 849.0000, 'ºC'),
	(95650, 108, '2015-03-15 00:15:26.000000', 'temperatura', 169.0000, 'ºC'),
	(95651, 108, '2015-03-15 00:15:27.000000', 'temperatura', 699.0000, 'ºC'),
	(95652, 108, '2015-03-15 00:15:28.000000', 'temperatura', 588.0000, 'ºC'),
	(95653, 108, '2015-03-15 00:15:29.000000', 'temperatura', 842.0000, 'ºC'),
	(95654, 108, '2015-03-15 00:15:30.000000', 'temperatura', 48.0000, 'ºC'),
	(95655, 108, '2015-03-15 00:15:31.000000', 'temperatura', 112.0000, 'ºC'),
	(95656, 108, '2015-03-15 00:15:32.000000', 'temperatura', 418.0000, 'ºC'),
	(95657, 108, '2015-03-15 00:15:33.000000', 'temperatura', 553.0000, 'ºC'),
	(95658, 108, '2015-03-15 00:15:34.000000', 'temperatura', 314.0000, 'ºC'),
	(95659, 108, '2015-03-15 00:15:35.000000', 'temperatura', 1110.0000, 'ºC'),
	(95660, 108, '2015-03-15 00:15:36.000000', 'temperatura', 1009.0000, 'ºC'),
	(95661, 108, '2015-03-15 00:15:37.000000', 'temperatura', 517.0000, 'ºC'),
	(95662, 108, '2015-03-15 00:15:38.000000', 'temperatura', 758.0000, 'ºC'),
	(95663, 108, '2015-03-15 00:15:39.000000', 'temperatura', 1037.0000, 'ºC'),
	(95664, 108, '2015-03-15 00:15:40.000000', 'temperatura', 513.0000, 'ºC'),
	(95665, 108, '2015-03-15 00:15:41.000000', 'temperatura', 654.0000, 'ºC'),
	(95666, 108, '2015-03-15 00:15:42.000000', 'temperatura', 530.0000, 'ºC'),
	(95667, 108, '2015-03-15 00:15:43.000000', 'temperatura', 690.0000, 'ºC'),
	(95668, 108, '2015-03-15 00:15:44.000000', 'temperatura', 658.0000, 'ºC'),
	(95669, 108, '2015-03-15 00:15:45.000000', 'temperatura', 24.0000, 'ºC'),
	(95670, 108, '2015-03-15 00:15:46.000000', 'temperatura', 545.0000, 'ºC'),
	(95671, 108, '2015-03-15 00:15:47.000000', 'temperatura', 255.0000, 'ºC'),
	(95672, 108, '2015-03-15 00:15:48.000000', 'temperatura', 840.0000, 'ºC'),
	(95673, 108, '2015-03-15 00:15:49.000000', 'temperatura', 1035.0000, 'ºC'),
	(95674, 108, '2015-03-15 00:15:50.000000', 'temperatura', 255.0000, 'ºC'),
	(95675, 108, '2015-03-15 00:15:51.000000', 'temperatura', 572.0000, 'ºC'),
	(95676, 108, '2015-03-15 00:15:52.000000', 'temperatura', 893.0000, 'ºC'),
	(95677, 108, '2015-03-15 00:15:53.000000', 'temperatura', 351.0000, 'ºC'),
	(95678, 108, '2015-03-15 00:15:54.000000', 'temperatura', 278.0000, 'ºC'),
	(95679, 108, '2015-03-15 00:15:55.000000', 'temperatura', 335.0000, 'ºC'),
	(95680, 108, '2015-03-15 00:15:56.000000', 'temperatura', 842.0000, 'ºC'),
	(95681, 108, '2015-03-15 00:15:57.000000', 'temperatura', 807.0000, 'ºC'),
	(95682, 108, '2015-03-15 00:15:58.000000', 'temperatura', 308.0000, 'ºC'),
	(95683, 108, '2015-03-15 00:15:59.000000', 'temperatura', 320.0000, 'ºC'),
	(95684, 108, '2015-03-15 00:16:00.000000', 'temperatura', 676.0000, 'ºC'),
	(95685, 108, '2015-03-15 00:16:01.000000', 'temperatura', 22.0000, 'ºC'),
	(95686, 108, '2015-03-15 00:16:02.000000', 'temperatura', 482.0000, 'ºC'),
	(95687, 108, '2015-03-15 00:16:03.000000', 'temperatura', 1144.0000, 'ºC'),
	(95688, 108, '2015-03-15 00:16:04.000000', 'temperatura', 676.0000, 'ºC'),
	(95689, 108, '2015-03-15 00:16:05.000000', 'temperatura', 1147.0000, 'ºC'),
	(95690, 108, '2015-03-15 00:16:06.000000', 'temperatura', 108.0000, 'ºC'),
	(95691, 108, '2015-03-15 00:16:07.000000', 'temperatura', 698.0000, 'ºC'),
	(95692, 108, '2015-03-15 00:16:08.000000', 'temperatura', 770.0000, 'ºC'),
	(95693, 108, '2015-03-15 00:16:09.000000', 'temperatura', 553.0000, 'ºC'),
	(95694, 108, '2015-03-15 00:16:10.000000', 'temperatura', 457.0000, 'ºC'),
	(95695, 108, '2015-03-15 00:16:11.000000', 'temperatura', 626.0000, 'ºC'),
	(95696, 108, '2015-03-15 00:16:12.000000', 'temperatura', 560.0000, 'ºC'),
	(95697, 108, '2015-03-15 00:16:13.000000', 'temperatura', 922.0000, 'ºC'),
	(95698, 108, '2015-03-15 00:16:14.000000', 'temperatura', 530.0000, 'ºC'),
	(95699, 108, '2015-03-15 00:16:15.000000', 'temperatura', 1086.0000, 'ºC'),
	(95700, 108, '2015-03-15 00:16:16.000000', 'temperatura', 239.0000, 'ºC'),
	(95701, 108, '2015-03-15 00:16:17.000000', 'temperatura', 340.0000, 'ºC'),
	(95702, 108, '2015-03-15 00:16:18.000000', 'temperatura', 983.0000, 'ºC'),
	(95703, 108, '2015-03-15 00:16:19.000000', 'temperatura', 295.0000, 'ºC'),
	(95704, 108, '2015-03-15 00:16:20.000000', 'temperatura', 925.0000, 'ºC'),
	(95705, 108, '2015-03-15 00:16:21.000000', 'temperatura', 143.0000, 'ºC'),
	(95706, 108, '2015-03-15 00:16:22.000000', 'temperatura', 339.0000, 'ºC'),
	(95707, 108, '2015-03-15 00:16:23.000000', 'temperatura', 67.0000, 'ºC'),
	(95708, 108, '2015-03-15 00:16:24.000000', 'temperatura', 519.0000, 'ºC'),
	(95709, 108, '2015-03-15 00:16:25.000000', 'temperatura', 1192.0000, 'ºC'),
	(95710, 108, '2015-03-15 00:16:26.000000', 'temperatura', 805.0000, 'ºC'),
	(95711, 108, '2015-03-15 00:16:27.000000', 'temperatura', 451.0000, 'ºC'),
	(95712, 108, '2015-03-15 00:16:28.000000', 'temperatura', 1038.0000, 'ºC'),
	(95713, 108, '2015-03-15 00:16:29.000000', 'temperatura', 238.0000, 'ºC'),
	(95714, 108, '2015-03-15 00:16:30.000000', 'temperatura', 476.0000, 'ºC'),
	(95715, 108, '2015-03-15 00:16:31.000000', 'temperatura', 467.0000, 'ºC'),
	(95716, 108, '2015-03-15 00:16:32.000000', 'temperatura', 906.0000, 'ºC'),
	(95717, 108, '2015-03-15 00:16:33.000000', 'temperatura', 731.0000, 'ºC'),
	(95718, 108, '2015-03-15 00:16:34.000000', 'temperatura', 939.0000, 'ºC'),
	(95719, 108, '2015-03-15 00:16:35.000000', 'temperatura', 100.0000, 'ºC'),
	(95720, 108, '2015-03-15 00:16:36.000000', 'temperatura', 83.0000, 'ºC'),
	(95721, 108, '2015-03-15 00:16:37.000000', 'temperatura', 116.0000, 'ºC'),
	(95722, 108, '2015-03-15 00:16:38.000000', 'temperatura', 332.0000, 'ºC'),
	(95723, 108, '2015-03-15 00:16:39.000000', 'temperatura', 112.0000, 'ºC'),
	(95724, 108, '2015-03-15 00:16:40.000000', 'temperatura', 767.0000, 'ºC'),
	(95725, 108, '2015-03-15 00:16:41.000000', 'temperatura', 1096.0000, 'ºC'),
	(95726, 108, '2015-03-15 00:16:42.000000', 'temperatura', 782.0000, 'ºC'),
	(95727, 108, '2015-03-15 00:16:43.000000', 'temperatura', 622.0000, 'ºC'),
	(95728, 108, '2015-03-15 00:16:44.000000', 'temperatura', 766.0000, 'ºC'),
	(95729, 108, '2015-03-15 00:16:45.000000', 'temperatura', 764.0000, 'ºC'),
	(95730, 108, '2015-03-15 00:16:46.000000', 'temperatura', 324.0000, 'ºC'),
	(95731, 108, '2015-03-15 00:16:47.000000', 'temperatura', 526.0000, 'ºC'),
	(95732, 108, '2015-03-15 00:16:48.000000', 'temperatura', 457.0000, 'ºC'),
	(95733, 108, '2015-03-15 00:16:49.000000', 'temperatura', 711.0000, 'ºC'),
	(95734, 108, '2015-03-15 00:16:50.000000', 'temperatura', 984.0000, 'ºC'),
	(95735, 108, '2015-03-15 00:16:51.000000', 'temperatura', 385.0000, 'ºC'),
	(95736, 108, '2015-03-15 00:16:52.000000', 'temperatura', 176.0000, 'ºC'),
	(95737, 108, '2015-03-15 00:16:53.000000', 'temperatura', 924.0000, 'ºC'),
	(95738, 108, '2015-03-15 00:16:54.000000', 'temperatura', 494.0000, 'ºC'),
	(95739, 108, '2015-03-15 00:16:55.000000', 'temperatura', 896.0000, 'ºC'),
	(95740, 108, '2015-03-15 00:16:56.000000', 'temperatura', 600.0000, 'ºC'),
	(95741, 108, '2015-03-15 00:16:57.000000', 'temperatura', 312.0000, 'ºC'),
	(95742, 108, '2015-03-15 00:16:58.000000', 'temperatura', 962.0000, 'ºC'),
	(95743, 108, '2015-03-15 00:16:59.000000', 'temperatura', 273.0000, 'ºC'),
	(95744, 108, '2015-03-15 00:17:00.000000', 'temperatura', 881.0000, 'ºC'),
	(95745, 108, '2015-03-15 00:17:01.000000', 'temperatura', 1187.0000, 'ºC'),
	(95746, 108, '2015-03-15 00:17:02.000000', 'temperatura', 892.0000, 'ºC'),
	(95747, 108, '2015-03-15 00:17:03.000000', 'temperatura', 898.0000, 'ºC'),
	(95748, 108, '2015-03-15 00:17:04.000000', 'temperatura', 613.0000, 'ºC'),
	(95749, 108, '2015-03-15 00:17:05.000000', 'temperatura', 375.0000, 'ºC'),
	(95750, 108, '2015-03-15 00:17:06.000000', 'temperatura', 34.0000, 'ºC'),
	(95751, 108, '2015-03-15 00:17:07.000000', 'temperatura', 244.0000, 'ºC'),
	(95752, 108, '2015-03-15 00:17:08.000000', 'temperatura', 1122.0000, 'ºC'),
	(95753, 108, '2015-03-15 00:17:09.000000', 'temperatura', 78.0000, 'ºC'),
	(95754, 108, '2015-03-15 00:17:10.000000', 'temperatura', 624.0000, 'ºC'),
	(95755, 108, '2015-03-15 00:17:11.000000', 'temperatura', 486.0000, 'ºC'),
	(95756, 108, '2015-03-15 00:17:12.000000', 'temperatura', 560.0000, 'ºC'),
	(95757, 108, '2015-03-15 00:17:13.000000', 'temperatura', 140.0000, 'ºC'),
	(95758, 108, '2015-03-15 00:17:14.000000', 'temperatura', 224.0000, 'ºC'),
	(95759, 108, '2015-03-15 00:17:15.000000', 'temperatura', 697.0000, 'ºC'),
	(95760, 108, '2015-03-15 00:17:16.000000', 'temperatura', 415.0000, 'ºC'),
	(95761, 108, '2015-03-15 00:17:17.000000', 'temperatura', 1182.0000, 'ºC'),
	(95762, 108, '2015-03-15 00:17:18.000000', 'temperatura', 1068.0000, 'ºC'),
	(95763, 108, '2015-03-15 00:17:19.000000', 'temperatura', 594.0000, 'ºC'),
	(95764, 108, '2015-03-15 00:17:20.000000', 'temperatura', 969.0000, 'ºC'),
	(95765, 108, '2015-03-15 00:17:21.000000', 'temperatura', 660.0000, 'ºC'),
	(95766, 108, '2015-03-15 00:17:22.000000', 'temperatura', 393.0000, 'ºC'),
	(95767, 108, '2015-03-15 00:17:23.000000', 'temperatura', 1188.0000, 'ºC'),
	(95768, 108, '2015-03-15 00:17:24.000000', 'temperatura', 1161.0000, 'ºC'),
	(95769, 108, '2015-03-15 00:17:25.000000', 'temperatura', 1041.0000, 'ºC'),
	(95770, 108, '2015-03-15 00:17:26.000000', 'temperatura', 524.0000, 'ºC'),
	(95771, 108, '2015-03-15 00:17:27.000000', 'temperatura', 696.0000, 'ºC'),
	(95772, 108, '2015-03-15 00:17:28.000000', 'temperatura', 708.0000, 'ºC'),
	(95773, 108, '2015-03-15 00:17:29.000000', 'temperatura', 253.0000, 'ºC'),
	(95774, 108, '2015-03-15 00:17:30.000000', 'temperatura', 343.0000, 'ºC'),
	(95775, 108, '2015-03-15 00:17:31.000000', 'temperatura', 957.0000, 'ºC'),
	(95776, 108, '2015-03-15 00:17:32.000000', 'temperatura', 157.0000, 'ºC'),
	(95777, 108, '2015-03-15 00:17:33.000000', 'temperatura', 312.0000, 'ºC'),
	(95778, 108, '2015-03-15 00:17:34.000000', 'temperatura', 1090.0000, 'ºC'),
	(95779, 108, '2015-03-15 00:17:35.000000', 'temperatura', 913.0000, 'ºC'),
	(95780, 108, '2015-03-15 00:17:36.000000', 'temperatura', 96.0000, 'ºC'),
	(95781, 108, '2015-03-15 00:17:37.000000', 'temperatura', 141.0000, 'ºC'),
	(95782, 108, '2015-03-15 00:17:38.000000', 'temperatura', 420.0000, 'ºC'),
	(95783, 108, '2015-03-15 00:17:39.000000', 'temperatura', 478.0000, 'ºC'),
	(95784, 108, '2015-03-15 00:17:40.000000', 'temperatura', 1127.0000, 'ºC'),
	(95785, 108, '2015-03-15 00:17:41.000000', 'temperatura', 604.0000, 'ºC'),
	(95786, 108, '2015-03-15 00:17:42.000000', 'temperatura', 840.0000, 'ºC'),
	(95787, 108, '2015-03-15 00:17:43.000000', 'temperatura', 1186.0000, 'ºC'),
	(95788, 108, '2015-03-15 00:17:44.000000', 'temperatura', 1013.0000, 'ºC'),
	(95789, 108, '2015-03-15 00:17:45.000000', 'temperatura', 306.0000, 'ºC'),
	(95790, 108, '2015-03-15 00:17:46.000000', 'temperatura', 893.0000, 'ºC'),
	(95791, 108, '2015-03-15 00:17:47.000000', 'temperatura', 1146.0000, 'ºC'),
	(95792, 108, '2015-03-15 00:17:48.000000', 'temperatura', 653.0000, 'ºC'),
	(95793, 108, '2015-03-15 00:17:49.000000', 'temperatura', 1028.0000, 'ºC'),
	(95794, 108, '2015-03-15 00:17:50.000000', 'temperatura', 781.0000, 'ºC'),
	(95795, 108, '2015-03-15 00:17:51.000000', 'temperatura', 821.0000, 'ºC'),
	(95796, 108, '2015-03-15 00:17:52.000000', 'temperatura', 561.0000, 'ºC'),
	(95797, 108, '2015-03-15 00:17:53.000000', 'temperatura', 344.0000, 'ºC'),
	(95798, 108, '2015-03-15 00:17:54.000000', 'temperatura', 38.0000, 'ºC'),
	(95799, 108, '2015-03-15 00:17:55.000000', 'temperatura', 356.0000, 'ºC'),
	(95800, 108, '2015-03-15 00:17:56.000000', 'temperatura', 469.0000, 'ºC'),
	(95801, 108, '2015-03-15 00:17:57.000000', 'temperatura', 77.0000, 'ºC'),
	(95802, 108, '2015-03-15 00:17:58.000000', 'temperatura', 177.0000, 'ºC'),
	(95803, 108, '2015-03-15 00:17:59.000000', 'temperatura', 657.0000, 'ºC'),
	(95804, 108, '2015-03-15 00:18:00.000000', 'temperatura', 355.0000, 'ºC'),
	(95805, 108, '2015-03-15 00:18:01.000000', 'temperatura', 1005.0000, 'ºC'),
	(95806, 108, '2015-03-15 00:18:02.000000', 'temperatura', 361.0000, 'ºC'),
	(95807, 108, '2015-03-15 00:18:03.000000', 'temperatura', 1187.0000, 'ºC'),
	(95808, 108, '2015-03-15 00:18:04.000000', 'temperatura', 56.0000, 'ºC'),
	(95809, 108, '2015-03-15 00:18:05.000000', 'temperatura', 316.0000, 'ºC'),
	(95810, 108, '2015-03-15 00:18:06.000000', 'temperatura', 215.0000, 'ºC'),
	(95811, 108, '2015-03-15 00:18:07.000000', 'temperatura', 128.0000, 'ºC'),
	(95812, 108, '2015-03-15 00:18:08.000000', 'temperatura', 1194.0000, 'ºC'),
	(95813, 108, '2015-03-15 00:18:09.000000', 'temperatura', 788.0000, 'ºC'),
	(95814, 108, '2015-03-15 00:18:10.000000', 'temperatura', 358.0000, 'ºC'),
	(95815, 108, '2015-03-15 00:18:11.000000', 'temperatura', 627.0000, 'ºC'),
	(95816, 108, '2015-03-15 00:18:12.000000', 'temperatura', 862.0000, 'ºC'),
	(95817, 108, '2015-03-15 00:18:13.000000', 'temperatura', 31.0000, 'ºC'),
	(95818, 108, '2015-03-15 00:18:14.000000', 'temperatura', 1167.0000, 'ºC'),
	(95819, 108, '2015-03-15 00:18:15.000000', 'temperatura', 942.0000, 'ºC'),
	(95820, 108, '2015-03-15 00:18:16.000000', 'temperatura', 10.0000, 'ºC'),
	(95821, 108, '2015-03-15 00:18:17.000000', 'temperatura', 823.0000, 'ºC'),
	(95822, 108, '2015-03-15 00:18:18.000000', 'temperatura', 487.0000, 'ºC'),
	(95823, 108, '2015-03-15 00:18:19.000000', 'temperatura', 1165.0000, 'ºC'),
	(95824, 108, '2015-03-15 00:18:20.000000', 'temperatura', 764.0000, 'ºC'),
	(95825, 108, '2015-03-15 00:18:21.000000', 'temperatura', 327.0000, 'ºC'),
	(95826, 108, '2015-03-15 00:18:22.000000', 'temperatura', 542.0000, 'ºC'),
	(95827, 108, '2015-03-15 00:18:23.000000', 'temperatura', 531.0000, 'ºC'),
	(95828, 108, '2015-03-15 00:18:24.000000', 'temperatura', 1028.0000, 'ºC'),
	(95829, 108, '2015-03-15 00:18:25.000000', 'temperatura', 1149.0000, 'ºC'),
	(95830, 108, '2015-03-15 00:18:26.000000', 'temperatura', 263.0000, 'ºC'),
	(95831, 108, '2015-03-15 00:18:27.000000', 'temperatura', 266.0000, 'ºC'),
	(95832, 108, '2015-03-15 00:18:28.000000', 'temperatura', 541.0000, 'ºC'),
	(95833, 108, '2015-03-15 00:18:29.000000', 'temperatura', 707.0000, 'ºC'),
	(95834, 108, '2015-03-15 00:18:30.000000', 'temperatura', 715.0000, 'ºC'),
	(95835, 108, '2015-03-15 00:18:31.000000', 'temperatura', 253.0000, 'ºC'),
	(95836, 108, '2015-03-15 00:18:32.000000', 'temperatura', 320.0000, 'ºC'),
	(95837, 108, '2015-03-15 00:18:33.000000', 'temperatura', 841.0000, 'ºC'),
	(95838, 108, '2015-03-15 00:18:34.000000', 'temperatura', 848.0000, 'ºC'),
	(95839, 108, '2015-03-15 00:18:35.000000', 'temperatura', 516.0000, 'ºC'),
	(95840, 108, '2015-03-15 00:18:36.000000', 'temperatura', 36.0000, 'ºC'),
	(95841, 108, '2015-03-15 00:18:37.000000', 'temperatura', 1032.0000, 'ºC'),
	(95842, 108, '2015-03-15 00:18:38.000000', 'temperatura', 253.0000, 'ºC'),
	(95843, 108, '2015-03-15 00:18:39.000000', 'temperatura', 571.0000, 'ºC'),
	(95844, 108, '2015-03-15 00:18:40.000000', 'temperatura', 894.0000, 'ºC'),
	(95845, 108, '2015-03-15 00:18:41.000000', 'temperatura', 359.0000, 'ºC'),
	(95846, 108, '2015-03-15 00:18:42.000000', 'temperatura', 313.0000, 'ºC'),
	(95847, 108, '2015-03-15 00:18:43.000000', 'temperatura', 489.0000, 'ºC'),
	(95848, 108, '2015-03-15 00:18:44.000000', 'temperatura', 305.0000, 'ºC'),
	(95849, 108, '2015-03-15 00:18:45.000000', 'temperatura', 61.0000, 'ºC'),
	(95850, 108, '2015-03-15 00:18:46.000000', 'temperatura', 588.0000, 'ºC'),
	(95851, 108, '2015-03-15 00:18:47.000000', 'temperatura', 357.0000, 'ºC'),
	(95852, 108, '2015-03-15 00:18:48.000000', 'temperatura', 22.0000, 'ºC'),
	(95853, 108, '2015-03-15 00:18:49.000000', 'temperatura', 240.0000, 'ºC'),
	(95854, 108, '2015-03-15 00:18:50.000000', 'temperatura', 1132.0000, 'ºC'),
	(95855, 108, '2015-03-15 00:18:51.000000', 'temperatura', 144.0000, 'ºC'),
	(95856, 108, '2015-03-15 00:18:52.000000', 'temperatura', 922.0000, 'ºC'),
	(95857, 108, '2015-03-15 00:18:53.000000', 'temperatura', 578.0000, 'ºC'),
	(95858, 108, '2015-03-15 00:18:54.000000', 'temperatura', 127.0000, 'ºC'),
	(95859, 108, '2015-03-15 00:18:55.000000', 'temperatura', 102.0000, 'ºC'),
	(95860, 108, '2015-03-15 00:18:56.000000', 'temperatura', 130.0000, 'ºC'),
	(95861, 108, '2015-03-15 00:18:57.000000', 'temperatura', 344.0000, 'ºC'),
	(95862, 108, '2015-03-15 00:18:58.000000', 'temperatura', 132.0000, 'ºC'),
	(95863, 108, '2015-03-15 00:18:59.000000', 'temperatura', 826.0000, 'ºC'),
	(95864, 108, '2015-03-15 00:19:00.000000', 'temperatura', 136.0000, 'ºC'),
	(95865, 108, '2015-03-15 00:19:01.000000', 'temperatura', 600.0000, 'ºC'),
	(95866, 108, '2015-03-15 00:19:02.000000', 'temperatura', 193.0000, 'ºC'),
	(95867, 108, '2015-03-15 00:19:03.000000', 'temperatura', 368.0000, 'ºC'),
	(95868, 108, '2015-03-15 00:19:04.000000', 'temperatura', 59.0000, 'ºC'),
	(95869, 108, '2015-03-15 00:19:05.000000', 'temperatura', 393.0000, 'ºC'),
	(95870, 108, '2015-03-15 00:19:06.000000', 'temperatura', 589.0000, 'ºC'),
	(95871, 108, '2015-03-15 00:19:07.000000', 'temperatura', 566.0000, 'ºC'),
	(95872, 108, '2015-03-15 00:19:08.000000', 'temperatura', 1063.0000, 'ºC'),
	(95873, 108, '2015-03-15 00:19:09.000000', 'temperatura', 19.0000, 'ºC'),
	(95874, 108, '2015-03-15 00:19:10.000000', 'temperatura', 504.0000, 'ºC'),
	(95875, 108, '2015-03-15 00:19:11.000000', 'temperatura', 65.0000, 'ºC'),
	(95876, 108, '2015-03-15 00:19:12.000000', 'temperatura', 15.0000, 'ºC'),
	(95877, 108, '2015-03-15 00:19:13.000000', 'temperatura', 1078.0000, 'ºC'),
	(95878, 108, '2015-03-15 00:19:14.000000', 'temperatura', 544.0000, 'ºC'),
	(95879, 108, '2015-03-15 00:19:15.000000', 'temperatura', 690.0000, 'ºC'),
	(95880, 108, '2015-03-15 00:19:16.000000', 'temperatura', 617.0000, 'ºC'),
	(95881, 108, '2015-03-15 00:19:17.000000', 'temperatura', 1016.0000, 'ºC'),
	(95882, 108, '2015-03-15 00:19:18.000000', 'temperatura', 831.0000, 'ºC'),
	(95883, 108, '2015-03-15 00:19:19.000000', 'temperatura', 1108.0000, 'ºC'),
	(95884, 108, '2015-03-15 00:19:20.000000', 'temperatura', 646.0000, 'ºC'),
	(95885, 108, '2015-03-15 00:19:21.000000', 'temperatura', 1107.0000, 'ºC'),
	(95886, 108, '2015-03-15 00:19:22.000000', 'temperatura', 1197.0000, 'ºC'),
	(95887, 108, '2015-03-15 00:19:23.000000', 'temperatura', 265.0000, 'ºC'),
	(95888, 108, '2015-03-15 00:19:24.000000', 'temperatura', 133.0000, 'ºC'),
	(95889, 108, '2015-03-15 00:19:25.000000', 'temperatura', 1070.0000, 'ºC'),
	(95890, 108, '2015-03-15 00:19:26.000000', 'temperatura', 154.0000, 'ºC'),
	(95891, 108, '2015-03-15 00:19:27.000000', 'temperatura', 1158.0000, 'ºC'),
	(95892, 108, '2015-03-15 00:19:28.000000', 'temperatura', 529.0000, 'ºC'),
	(95893, 108, '2015-03-15 00:19:29.000000', 'temperatura', 372.0000, 'ºC'),
	(95894, 108, '2015-03-15 00:19:30.000000', 'temperatura', 275.0000, 'ºC'),
	(95895, 108, '2015-03-15 00:19:31.000000', 'temperatura', 259.0000, 'ºC'),
	(95896, 108, '2015-03-15 00:19:32.000000', 'temperatura', 470.0000, 'ºC'),
	(95897, 108, '2015-03-15 00:19:33.000000', 'temperatura', 372.0000, 'ºC'),
	(95898, 108, '2015-03-15 00:19:34.000000', 'temperatura', 453.0000, 'ºC'),
	(95899, 108, '2015-03-15 00:19:35.000000', 'temperatura', 1151.0000, 'ºC'),
	(95900, 108, '2015-03-15 00:19:36.000000', 'temperatura', 793.0000, 'ºC'),
	(95901, 108, '2015-03-15 00:19:37.000000', 'temperatura', 512.0000, 'ºC'),
	(95902, 108, '2015-03-15 00:19:38.000000', 'temperatura', 185.0000, 'ºC'),
	(95903, 108, '2015-03-15 00:19:39.000000', 'temperatura', 586.0000, 'ºC'),
	(95904, 108, '2015-03-15 00:19:40.000000', 'temperatura', 1178.0000, 'ºC'),
	(95905, 108, '2015-03-15 00:19:41.000000', 'temperatura', 532.0000, 'ºC'),
	(95906, 108, '2015-03-15 00:19:42.000000', 'temperatura', 325.0000, 'ºC'),
	(95907, 108, '2015-03-15 00:19:43.000000', 'temperatura', 30.0000, 'ºC'),
	(95908, 108, '2015-03-15 00:19:44.000000', 'temperatura', 375.0000, 'ºC'),
	(95909, 108, '2015-03-15 00:19:45.000000', 'temperatura', 585.0000, 'ºC'),
	(95910, 108, '2015-03-15 00:19:46.000000', 'temperatura', 599.0000, 'ºC'),
	(95911, 108, '2015-03-15 00:19:47.000000', 'temperatura', 43.0000, 'ºC'),
	(95912, 108, '2015-03-15 00:19:48.000000', 'temperatura', 816.0000, 'ºC'),
	(95913, 108, '2015-03-15 00:19:49.000000', 'temperatura', 352.0000, 'ºC'),
	(95914, 108, '2015-03-15 00:19:50.000000', 'temperatura', 513.0000, 'ºC'),
	(95915, 108, '2015-03-15 00:19:51.000000', 'temperatura', 309.0000, 'ºC'),
	(95916, 108, '2015-03-15 00:19:52.000000', 'temperatura', 7.0000, 'ºC'),
	(95917, 108, '2015-03-15 00:19:53.000000', 'temperatura', 307.0000, 'ºC'),
	(95918, 108, '2015-03-15 00:19:54.000000', 'temperatura', 314.0000, 'ºC'),
	(95919, 108, '2015-03-15 00:19:55.000000', 'temperatura', 650.0000, 'ºC'),
	(95920, 108, '2015-03-15 00:19:56.000000', 'temperatura', 1110.0000, 'ºC'),
	(95921, 108, '2015-03-15 00:19:57.000000', 'temperatura', 1199.0000, 'ºC'),
	(95922, 108, '2015-03-15 00:19:58.000000', 'temperatura', 265.0000, 'ºC'),
	(95923, 108, '2015-03-15 00:19:59.000000', 'temperatura', 131.0000, 'ºC'),
	(95924, 108, '2015-03-15 00:20:00.000000', 'temperatura', 1060.0000, 'ºC'),
	(95925, 108, '2015-03-15 00:20:01.000000', 'temperatura', 105.0000, 'ºC'),
	(95926, 108, '2015-03-15 00:20:02.000000', 'temperatura', 948.0000, 'ºC'),
	(95927, 108, '2015-03-15 00:20:03.000000', 'temperatura', 824.0000, 'ºC'),
	(95928, 108, '2015-03-15 00:20:04.000000', 'temperatura', 77.0000, 'ºC'),
	(95929, 108, '2015-03-15 00:20:05.000000', 'temperatura', 313.0000, 'ºC'),
	(95930, 108, '2015-03-15 00:20:06.000000', 'temperatura', 135.0000, 'ºC'),
	(95931, 108, '2015-03-15 00:20:07.000000', 'temperatura', 934.0000, 'ºC'),
	(95932, 108, '2015-03-15 00:20:08.000000', 'temperatura', 669.0000, 'ºC'),
	(95933, 108, '2015-03-15 00:20:09.000000', 'temperatura', 542.0000, 'ºC'),
	(95934, 108, '2015-03-15 00:20:10.000000', 'temperatura', 705.0000, 'ºC'),
	(95935, 108, '2015-03-15 00:20:11.000000', 'temperatura', 700.0000, 'ºC'),
	(95936, 108, '2015-03-15 00:20:12.000000', 'temperatura', 185.0000, 'ºC'),
	(95937, 108, '2015-03-15 00:20:13.000000', 'temperatura', 26.0000, 'ºC'),
	(95938, 108, '2015-03-15 00:20:14.000000', 'temperatura', 776.0000, 'ºC'),
	(95939, 108, '2015-03-15 00:20:15.000000', 'temperatura', 200.0000, 'ºC'),
	(95940, 108, '2015-03-15 00:20:16.000000', 'temperatura', 1074.0000, 'ºC'),
	(95941, 108, '2015-03-15 00:20:17.000000', 'temperatura', 1170.0000, 'ºC'),
	(95942, 108, '2015-03-15 00:20:18.000000', 'temperatura', 229.0000, 'ºC'),
	(95943, 108, '2015-03-15 00:20:19.000000', 'temperatura', 36.0000, 'ºC'),
	(95944, 108, '2015-03-15 00:20:20.000000', 'temperatura', 691.0000, 'ºC'),
	(95945, 108, '2015-03-15 00:20:21.000000', 'temperatura', 951.0000, 'ºC'),
	(95946, 108, '2015-03-15 00:20:22.000000', 'temperatura', 280.0000, 'ºC'),
	(95947, 108, '2015-03-15 00:20:23.000000', 'temperatura', 950.0000, 'ºC'),
	(95948, 108, '2015-03-15 00:20:24.000000', 'temperatura', 307.0000, 'ºC'),
	(95949, 108, '2015-03-15 00:20:25.000000', 'temperatura', 1089.0000, 'ºC'),
	(95950, 108, '2015-03-15 00:20:26.000000', 'temperatura', 923.0000, 'ºC'),
	(95951, 108, '2015-03-15 00:20:27.000000', 'temperatura', 149.0000, 'ºC'),
	(95952, 108, '2015-03-15 00:20:28.000000', 'temperatura', 374.0000, 'ºC'),
	(95953, 108, '2015-03-15 00:20:29.000000', 'temperatura', 226.0000, 'ºC'),
	(95954, 108, '2015-03-15 00:20:30.000000', 'temperatura', 8.0000, 'ºC'),
	(95955, 108, '2015-03-15 00:20:31.000000', 'temperatura', 560.0000, 'ºC'),
	(95956, 108, '2015-03-15 00:20:32.000000', 'temperatura', 380.0000, 'ºC'),
	(95957, 108, '2015-03-15 00:20:33.000000', 'temperatura', 218.0000, 'ºC'),
	(95958, 108, '2015-03-15 00:20:34.000000', 'temperatura', 1152.0000, 'ºC'),
	(95959, 108, '2015-03-15 00:20:35.000000', 'temperatura', 307.0000, 'ºC'),
	(95960, 108, '2015-03-15 00:20:36.000000', 'temperatura', 480.0000, 'ºC'),
	(95961, 108, '2015-03-15 00:20:37.000000', 'temperatura', 280.0000, 'ºC'),
	(95962, 108, '2015-03-15 00:20:38.000000', 'temperatura', 1159.0000, 'ºC'),
	(95963, 108, '2015-03-15 00:20:39.000000', 'temperatura', 154.0000, 'ºC'),
	(95964, 108, '2015-03-15 00:20:40.000000', 'temperatura', 896.0000, 'ºC'),
	(95965, 108, '2015-03-15 00:20:41.000000', 'temperatura', 419.0000, 'ºC'),
	(95966, 108, '2015-03-15 00:20:42.000000', 'temperatura', 606.0000, 'ºC'),
	(95967, 108, '2015-03-15 00:20:43.000000', 'temperatura', 573.0000, 'ºC'),
	(95968, 108, '2015-03-15 00:20:44.000000', 'temperatura', 1047.0000, 'ºC'),
	(95969, 108, '2015-03-15 00:20:45.000000', 'temperatura', 1117.0000, 'ºC'),
	(95970, 108, '2015-03-15 00:20:46.000000', 'temperatura', 45.0000, 'ºC'),
	(95971, 108, '2015-03-15 00:20:47.000000', 'temperatura', 472.0000, 'ºC'),
	(95972, 108, '2015-03-15 00:20:48.000000', 'temperatura', 1028.0000, 'ºC'),
	(95973, 108, '2015-03-15 00:20:49.000000', 'temperatura', 124.0000, 'ºC'),
	(95974, 108, '2015-03-15 00:20:50.000000', 'temperatura', 1137.0000, 'ºC'),
	(95975, 108, '2015-03-15 00:20:51.000000', 'temperatura', 514.0000, 'ºC'),
	(95976, 108, '2015-03-15 00:20:52.000000', 'temperatura', 359.0000, 'ºC'),
	(95977, 108, '2015-03-15 00:20:53.000000', 'temperatura', 254.0000, 'ºC'),
	(95978, 108, '2015-03-15 00:20:54.000000', 'temperatura', 194.0000, 'ºC'),
	(95979, 108, '2015-03-15 00:20:55.000000', 'temperatura', 208.0000, 'ºC'),
	(95980, 108, '2015-03-15 00:20:56.000000', 'temperatura', 459.0000, 'ºC'),
	(95981, 108, '2015-03-15 00:20:57.000000', 'temperatura', 470.0000, 'ºC'),
	(95982, 108, '2015-03-15 00:20:58.000000', 'temperatura', 974.0000, 'ºC'),
	(95983, 108, '2015-03-15 00:20:59.000000', 'temperatura', 1062.0000, 'ºC'),
	(95984, 108, '2015-03-15 00:21:00.000000', 'temperatura', 1188.0000, 'ºC'),
	(95985, 108, '2015-03-15 00:21:01.000000', 'temperatura', 355.0000, 'ºC'),
	(95986, 108, '2015-03-15 00:21:02.000000', 'temperatura', 612.0000, 'ºC'),
	(95987, 108, '2015-03-15 00:21:03.000000', 'temperatura', 794.0000, 'ºC'),
	(95988, 108, '2015-03-15 00:21:04.000000', 'temperatura', 936.0000, 'ºC'),
	(95989, 108, '2015-03-15 00:21:05.000000', 'temperatura', 1099.0000, 'ºC'),
	(95990, 108, '2015-03-15 00:21:06.000000', 'temperatura', 286.0000, 'ºC'),
	(95991, 108, '2015-03-15 00:21:07.000000', 'temperatura', 533.0000, 'ºC'),
	(95992, 108, '2015-03-15 00:21:08.000000', 'temperatura', 609.0000, 'ºC'),
	(95993, 108, '2015-03-15 00:21:09.000000', 'temperatura', 246.0000, 'ºC'),
	(95994, 108, '2015-03-15 00:21:10.000000', 'temperatura', 603.0000, 'ºC'),
	(95995, 108, '2015-03-15 00:21:11.000000', 'temperatura', 1077.0000, 'ºC'),
	(95996, 108, '2015-03-15 00:21:12.000000', 'temperatura', 1179.0000, 'ºC'),
	(95997, 108, '2015-03-15 00:21:13.000000', 'temperatura', 261.0000, 'ºC'),
	(95998, 108, '2015-03-15 00:21:14.000000', 'temperatura', 171.0000, 'ºC'),
	(95999, 108, '2015-03-15 00:21:15.000000', 'temperatura', 72.0000, 'ºC'),
	(96000, 108, '2015-03-15 00:21:16.000000', 'temperatura', 1049.0000, 'ºC'),
	(96001, 108, '2015-03-15 00:21:17.000000', 'temperatura', 230.0000, 'ºC'),
	(96002, 108, '2015-03-15 00:21:18.000000', 'temperatura', 404.0000, 'ºC'),
	(96003, 108, '2015-03-15 00:21:19.000000', 'temperatura', 128.0000, 'ºC'),
	(96004, 108, '2015-03-15 00:21:20.000000', 'temperatura', 628.0000, 'ºC'),
	(96005, 108, '2015-03-15 00:21:21.000000', 'temperatura', 356.0000, 'ºC'),
	(96006, 108, '2015-03-15 00:21:22.000000', 'temperatura', 1096.0000, 'ºC'),
	(96007, 108, '2015-03-15 00:21:23.000000', 'temperatura', 816.0000, 'ºC'),
	(96008, 108, '2015-03-15 00:21:24.000000', 'temperatura', 789.0000, 'ºC'),
	(96009, 108, '2015-03-15 00:21:25.000000', 'temperatura', 299.0000, 'ºC'),
	(96010, 108, '2015-03-15 00:21:26.000000', 'temperatura', 328.0000, 'ºC'),
	(96011, 108, '2015-03-15 00:21:27.000000', 'temperatura', 742.0000, 'ºC'),
	(96012, 108, '2015-03-15 00:21:28.000000', 'temperatura', 329.0000, 'ºC'),
	(96013, 108, '2015-03-15 00:21:29.000000', 'temperatura', 617.0000, 'ºC'),
	(96014, 108, '2015-03-15 00:21:30.000000', 'temperatura', 900.0000, 'ºC'),
	(96015, 108, '2015-03-15 00:21:31.000000', 'temperatura', 248.0000, 'ºC'),
	(96016, 108, '2015-03-15 00:21:32.000000', 'temperatura', 941.0000, 'ºC'),
	(96017, 108, '2015-03-15 00:21:33.000000', 'temperatura', 362.0000, 'ºC'),
	(96018, 108, '2015-03-15 00:21:34.000000', 'temperatura', 186.0000, 'ºC'),
	(96019, 108, '2015-03-15 00:21:35.000000', 'temperatura', 1047.0000, 'ºC'),
	(96020, 108, '2015-03-15 00:21:36.000000', 'temperatura', 1078.0000, 'ºC'),
	(96021, 108, '2015-03-15 00:21:37.000000', 'temperatura', 1049.0000, 'ºC'),
	(96022, 108, '2015-03-15 00:21:38.000000', 'temperatura', 812.0000, 'ºC'),
	(96023, 108, '2015-03-15 00:21:39.000000', 'temperatura', 912.0000, 'ºC'),
	(96024, 108, '2015-03-15 00:21:40.000000', 'temperatura', 925.0000, 'ºC'),
	(96025, 108, '2015-03-15 00:21:41.000000', 'temperatura', 691.0000, 'ºC'),
	(96026, 108, '2015-03-15 00:21:42.000000', 'temperatura', 681.0000, 'ºC'),
	(96027, 108, '2015-03-15 00:21:43.000000', 'temperatura', 130.0000, 'ºC'),
	(96028, 108, '2015-03-15 00:21:44.000000', 'temperatura', 1008.0000, 'ºC'),
	(96029, 108, '2015-03-15 00:21:45.000000', 'temperatura', 1050.0000, 'ºC'),
	(96030, 108, '2015-03-15 00:21:46.000000', 'temperatura', 1028.0000, 'ºC'),
	(96031, 108, '2015-03-15 00:21:47.000000', 'temperatura', 790.0000, 'ºC'),
	(96032, 108, '2015-03-15 00:21:48.000000', 'temperatura', 866.0000, 'ºC'),
	(96033, 108, '2015-03-15 00:21:49.000000', 'temperatura', 759.0000, 'ºC'),
	(96034, 108, '2015-03-15 00:21:50.000000', 'temperatura', 1.0000, 'ºC'),
	(96035, 108, '2015-03-15 00:21:51.000000', 'temperatura', 126.0000, 'ºC'),
	(96036, 108, '2015-03-15 00:21:52.000000', 'temperatura', 627.0000, 'ºC'),
	(96037, 108, '2015-03-15 00:21:53.000000', 'temperatura', 358.0000, 'ºC'),
	(96038, 108, '2015-03-15 00:21:54.000000', 'temperatura', 1110.0000, 'ºC'),
	(96039, 108, '2015-03-15 00:21:55.000000', 'temperatura', 877.0000, 'ºC'),
	(96040, 108, '2015-03-15 00:21:56.000000', 'temperatura', 1053.0000, 'ºC'),
	(96041, 108, '2015-03-15 00:21:57.000000', 'temperatura', 237.0000, 'ºC'),
	(96042, 108, '2015-03-15 00:21:58.000000', 'temperatura', 427.0000, 'ºC'),
	(96043, 108, '2015-03-15 00:21:59.000000', 'temperatura', 224.0000, 'ºC'),
	(96044, 108, '2015-03-15 00:22:00.000000', 'temperatura', 1039.0000, 'ºC'),
	(96045, 108, '2015-03-15 00:22:01.000000', 'temperatura', 922.0000, 'ºC'),
	(96046, 108, '2015-03-15 00:22:02.000000', 'temperatura', 293.0000, 'ºC'),
	(96047, 108, '2015-03-15 00:22:03.000000', 'temperatura', 1099.0000, 'ºC'),
	(96048, 108, '2015-03-15 00:22:04.000000', 'temperatura', 1018.0000, 'ºC'),
	(96049, 108, '2015-03-15 00:22:05.000000', 'temperatura', 592.0000, 'ºC'),
	(96050, 108, '2015-03-15 00:22:06.000000', 'temperatura', 1106.0000, 'ºC'),
	(96051, 108, '2015-03-15 00:22:07.000000', 'temperatura', 157.0000, 'ºC'),
	(96052, 108, '2015-03-15 00:22:08.000000', 'temperatura', 1066.0000, 'ºC'),
	(96053, 108, '2015-03-15 00:22:09.000000', 'temperatura', 60.0000, 'ºC'),
	(96054, 108, '2015-03-15 00:22:10.000000', 'temperatura', 702.0000, 'ºC'),
	(96055, 108, '2015-03-15 00:22:11.000000', 'temperatura', 930.0000, 'ºC'),
	(96056, 108, '2015-03-15 00:22:12.000000', 'temperatura', 147.0000, 'ºC'),
	(96057, 108, '2015-03-15 00:22:13.000000', 'temperatura', 343.0000, 'ºC'),
	(96058, 108, '2015-03-15 00:22:14.000000', 'temperatura', 75.0000, 'ºC'),
	(96059, 108, '2015-03-15 00:22:15.000000', 'temperatura', 547.0000, 'ºC'),
	(96060, 108, '2015-03-15 00:22:16.000000', 'temperatura', 110.0000, 'ºC'),
	(96061, 108, '2015-03-15 00:22:17.000000', 'temperatura', 109.0000, 'ºC'),
	(96062, 108, '2015-03-15 00:22:18.000000', 'temperatura', 215.0000, 'ºC'),
	(96063, 108, '2015-03-15 00:22:19.000000', 'temperatura', 751.0000, 'ºC'),
	(96064, 108, '2015-03-15 00:22:20.000000', 'temperatura', 708.0000, 'ºC'),
	(96065, 108, '2015-03-15 00:22:21.000000', 'temperatura', 89.0000, 'ºC'),
	(96066, 108, '2015-03-15 00:22:22.000000', 'temperatura', 720.0000, 'ºC'),
	(96067, 108, '2015-03-15 00:22:23.000000', 'temperatura', 933.0000, 'ºC'),
	(96068, 108, '2015-03-15 00:22:24.000000', 'temperatura', 105.0000, 'ºC'),
	(96069, 108, '2015-03-15 00:22:25.000000', 'temperatura', 126.0000, 'ºC'),
	(96070, 108, '2015-03-15 00:22:26.000000', 'temperatura', 315.0000, 'ºC'),
	(96071, 108, '2015-03-15 00:22:27.000000', 'temperatura', 0.0000, 'ºC'),
	(96072, 108, '2015-03-15 00:22:28.000000', 'temperatura', 255.0000, 'ºC'),
	(96073, 108, '2015-03-15 00:22:29.000000', 'temperatura', 77.0000, 'ºC'),
	(96074, 108, '2015-03-15 00:22:30.000000', 'temperatura', 818.0000, 'ºC'),
	(96075, 108, '2015-03-15 00:22:31.000000', 'temperatura', 259.0000, 'ºC'),
	(96076, 108, '2015-03-15 00:22:32.000000', 'temperatura', 44.0000, 'ºC'),
	(96077, 108, '2015-03-15 00:22:33.000000', 'temperatura', 644.0000, 'ºC'),
	(96078, 108, '2015-03-15 00:22:34.000000', 'temperatura', 686.0000, 'ºC'),
	(96079, 108, '2015-03-15 00:22:35.000000', 'temperatura', 298.0000, 'ºC'),
	(96080, 108, '2015-03-15 00:22:36.000000', 'temperatura', 635.0000, 'ºC'),
	(96081, 108, '2015-03-15 00:22:37.000000', 'temperatura', 1082.0000, 'ºC'),
	(96082, 108, '2015-03-15 00:22:38.000000', 'temperatura', 1106.0000, 'ºC'),
	(96083, 108, '2015-03-15 00:22:39.000000', 'temperatura', 1082.0000, 'ºC'),
	(96084, 108, '2015-03-15 00:22:40.000000', 'temperatura', 893.0000, 'ºC'),
	(96085, 108, '2015-03-15 00:22:41.000000', 'temperatura', 18.0000, 'ºC'),
	(96086, 108, '2015-03-15 00:22:42.000000', 'temperatura', 1013.0000, 'ºC'),
	(96087, 108, '2015-03-15 00:22:43.000000', 'temperatura', 213.0000, 'ºC'),
	(96088, 108, '2015-03-15 00:22:44.000000', 'temperatura', 426.0000, 'ºC'),
	(96089, 108, '2015-03-15 00:22:45.000000', 'temperatura', 292.0000, 'ºC'),
	(96090, 108, '2015-03-15 00:22:46.000000', 'temperatura', 181.0000, 'ºC'),
	(96091, 108, '2015-03-15 00:22:47.000000', 'temperatura', 31.0000, 'ºC'),
	(96092, 108, '2015-03-15 00:22:48.000000', 'temperatura', 812.0000, 'ºC'),
	(96093, 108, '2015-03-15 00:22:49.000000', 'temperatura', 368.0000, 'ºC'),
	(96094, 108, '2015-03-15 00:22:50.000000', 'temperatura', 604.0000, 'ºC'),
	(96095, 108, '2015-03-15 00:22:51.000000', 'temperatura', 715.0000, 'ºC'),
	(96096, 108, '2015-03-15 00:22:52.000000', 'temperatura', 567.0000, 'ºC'),
	(96097, 108, '2015-03-15 00:22:53.000000', 'temperatura', 687.0000, 'ºC'),
	(96098, 108, '2015-03-15 00:22:54.000000', 'temperatura', 535.0000, 'ºC'),
	(96099, 108, '2015-03-15 00:22:55.000000', 'temperatura', 617.0000, 'ºC'),
	(96100, 108, '2015-03-15 00:22:56.000000', 'temperatura', 278.0000, 'ºC'),
	(96101, 108, '2015-03-15 00:22:57.000000', 'temperatura', 741.0000, 'ºC'),
	(96102, 108, '2015-03-15 00:22:58.000000', 'temperatura', 473.0000, 'ºC'),
	(96103, 108, '2015-03-15 00:22:59.000000', 'temperatura', 140.0000, 'ºC'),
	(96104, 108, '2015-03-15 00:23:00.000000', 'temperatura', 482.0000, 'ºC'),
	(96105, 108, '2015-03-15 00:23:01.000000', 'temperatura', 789.0000, 'ºC'),
	(96106, 108, '2015-03-15 00:23:02.000000', 'temperatura', 100.0000, 'ºC'),
	(96107, 108, '2015-03-15 00:23:03.000000', 'temperatura', 534.0000, 'ºC'),
	(96108, 108, '2015-03-15 00:23:04.000000', 'temperatura', 1172.0000, 'ºC'),
	(96109, 108, '2015-03-15 00:23:05.000000', 'temperatura', 655.0000, 'ºC'),
	(96110, 108, '2015-03-15 00:23:06.000000', 'temperatura', 963.0000, 'ºC'),
	(96111, 108, '2015-03-15 00:23:07.000000', 'temperatura', 450.0000, 'ºC'),
	(96112, 108, '2015-03-15 00:23:08.000000', 'temperatura', 563.0000, 'ºC'),
	(96113, 108, '2015-03-15 00:23:09.000000', 'temperatura', 264.0000, 'ºC'),
	(96114, 108, '2015-03-15 00:23:10.000000', 'temperatura', 830.0000, 'ºC'),
	(96115, 108, '2015-03-15 00:23:11.000000', 'temperatura', 960.0000, 'ºC'),
	(96116, 108, '2015-03-15 00:23:12.000000', 'temperatura', 1112.0000, 'ºC'),
	(96117, 108, '2015-03-15 00:23:13.000000', 'temperatura', 279.0000, 'ºC'),
	(96118, 108, '2015-03-15 00:23:14.000000', 'temperatura', 460.0000, 'ºC'),
	(96119, 108, '2015-03-15 00:23:15.000000', 'temperatura', 265.0000, 'ºC'),
	(96120, 108, '2015-03-15 00:23:16.000000', 'temperatura', 1144.0000, 'ºC'),
	(96121, 108, '2015-03-15 00:23:17.000000', 'temperatura', 127.0000, 'ºC'),
	(96122, 108, '2015-03-15 00:23:18.000000', 'temperatura', 804.0000, 'ºC'),
	(96123, 108, '2015-03-15 00:23:19.000000', 'temperatura', 40.0000, 'ºC'),
	(96124, 108, '2015-03-15 00:23:20.000000', 'temperatura', 188.0000, 'ºC'),
	(96125, 108, '2015-03-15 00:23:21.000000', 'temperatura', 818.0000, 'ºC'),
	(96126, 108, '2015-03-15 00:23:22.000000', 'temperatura', 1129.0000, 'ºC'),
	(96127, 108, '2015-03-15 00:23:23.000000', 'temperatura', 790.0000, 'ºC'),
	(96128, 108, '2015-03-15 00:23:24.000000', 'temperatura', 565.0000, 'ºC'),
	(96129, 108, '2015-03-15 00:23:25.000000', 'temperatura', 457.0000, 'ºC'),
	(96130, 108, '2015-03-15 00:23:26.000000', 'temperatura', 587.0000, 'ºC'),
	(96131, 108, '2015-03-15 00:23:27.000000', 'temperatura', 366.0000, 'ºC'),
	(96132, 108, '2015-03-15 00:23:28.000000', 'temperatura', 68.0000, 'ºC'),
	(96133, 108, '2015-03-15 00:23:29.000000', 'temperatura', 441.0000, 'ºC'),
	(96134, 108, '2015-03-15 00:23:30.000000', 'temperatura', 805.0000, 'ºC'),
	(96135, 108, '2015-03-15 00:23:31.000000', 'temperatura', 302.0000, 'ºC'),
	(96136, 108, '2015-03-15 00:23:32.000000', 'temperatura', 295.0000, 'ºC'),
	(96137, 108, '2015-03-15 00:23:33.000000', 'temperatura', 570.0000, 'ºC'),
	(96138, 108, '2015-03-15 00:23:34.000000', 'temperatura', 765.0000, 'ºC'),
	(96139, 108, '2015-03-15 00:23:35.000000', 'temperatura', 917.0000, 'ºC'),
	(96140, 108, '2015-03-15 00:23:36.000000', 'temperatura', 1092.0000, 'ºC'),
	(96141, 108, '2015-03-15 00:23:37.000000', 'temperatura', 306.0000, 'ºC'),
	(96142, 108, '2015-03-15 00:23:38.000000', 'temperatura', 656.0000, 'ºC'),
	(96143, 108, '2015-03-15 00:23:39.000000', 'temperatura', 1162.0000, 'ºC'),
	(96144, 108, '2015-03-15 00:23:40.000000', 'temperatura', 242.0000, 'ºC'),
	(96145, 108, '2015-03-15 00:23:41.000000', 'temperatura', 126.0000, 'ºC'),
	(96146, 108, '2015-03-15 00:23:42.000000', 'temperatura', 1105.0000, 'ºC'),
	(96147, 108, '2015-03-15 00:23:43.000000', 'temperatura', 348.0000, 'ºC'),
	(96148, 108, '2015-03-15 00:23:44.000000', 'temperatura', 825.0000, 'ºC'),
	(96149, 108, '2015-03-15 00:23:45.000000', 'temperatura', 683.0000, 'ºC'),
	(96150, 108, '2015-03-15 00:23:46.000000', 'temperatura', 940.0000, 'ºC'),
	(96151, 108, '2015-03-15 00:23:47.000000', 'temperatura', 253.0000, 'ºC'),
	(96152, 108, '2015-03-15 00:23:48.000000', 'temperatura', 844.0000, 'ºC'),
	(96153, 108, '2015-03-15 00:23:49.000000', 'temperatura', 1063.0000, 'ºC'),
	(96154, 108, '2015-03-15 00:23:50.000000', 'temperatura', 385.0000, 'ºC'),
	(96155, 108, '2015-03-15 00:23:51.000000', 'temperatura', 1133.0000, 'ºC'),
	(96156, 108, '2015-03-15 00:23:52.000000', 'temperatura', 913.0000, 'ºC'),
	(96157, 108, '2015-03-15 00:23:53.000000', 'temperatura', 1164.0000, 'ºC'),
	(96158, 108, '2015-03-15 00:23:54.000000', 'temperatura', 684.0000, 'ºC'),
	(96159, 108, '2015-03-15 00:23:55.000000', 'temperatura', 1128.0000, 'ºC'),
	(96160, 108, '2015-03-15 00:23:56.000000', 'temperatura', 1190.0000, 'ºC'),
	(96161, 108, '2015-03-15 00:23:57.000000', 'temperatura', 165.0000, 'ºC'),
	(96162, 108, '2015-03-15 00:23:58.000000', 'temperatura', 856.0000, 'ºC'),
	(96163, 108, '2015-03-15 00:23:59.000000', 'temperatura', 184.0000, 'ºC'),
	(96164, 108, '2015-03-15 00:24:00.000000', 'temperatura', 754.0000, 'ºC'),
	(96165, 108, '2015-03-15 00:24:01.000000', 'temperatura', 817.0000, 'ºC'),
	(96166, 108, '2015-03-15 00:24:02.000000', 'temperatura', 626.0000, 'ºC'),
	(96167, 108, '2015-03-15 00:24:03.000000', 'temperatura', 677.0000, 'ºC'),
	(96168, 108, '2015-03-15 00:24:04.000000', 'temperatura', 307.0000, 'ºC'),
	(96169, 108, '2015-03-15 00:24:05.000000', 'temperatura', 707.0000, 'ºC'),
	(96170, 108, '2015-03-15 00:24:06.000000', 'temperatura', 215.0000, 'ºC'),
	(96171, 108, '2015-03-15 00:24:07.000000', 'temperatura', 155.0000, 'ºC'),
	(96172, 108, '2015-03-15 00:24:08.000000', 'temperatura', 128.0000, 'ºC'),
	(96173, 108, '2015-03-15 00:24:09.000000', 'temperatura', 175.0000, 'ºC'),
	(96174, 108, '2015-03-15 00:24:10.000000', 'temperatura', 491.0000, 'ºC'),
	(96175, 108, '2015-03-15 00:24:11.000000', 'temperatura', 730.0000, 'ºC'),
	(96176, 108, '2015-03-15 00:24:12.000000', 'temperatura', 978.0000, 'ºC'),
	(96177, 108, '2015-03-15 00:24:13.000000', 'temperatura', 301.0000, 'ºC'),
	(96178, 108, '2015-03-15 00:24:14.000000', 'temperatura', 973.0000, 'ºC'),
	(96179, 108, '2015-03-15 00:24:15.000000', 'temperatura', 363.0000, 'ºC'),
	(96180, 108, '2015-03-15 00:24:16.000000', 'temperatura', 94.0000, 'ºC'),
	(96181, 108, '2015-03-15 00:24:17.000000', 'temperatura', 581.0000, 'ºC'),
	(96182, 108, '2015-03-15 00:24:18.000000', 'temperatura', 223.0000, 'ºC'),
	(96183, 108, '2015-03-15 00:24:19.000000', 'temperatura', 574.0000, 'ºC'),
	(96184, 108, '2015-03-15 00:24:20.000000', 'temperatura', 1000.0000, 'ºC'),
	(96185, 108, '2015-03-15 00:24:21.000000', 'temperatura', 881.0000, 'ºC'),
	(96186, 108, '2015-03-15 00:24:22.000000', 'temperatura', 204.0000, 'ºC'),
	(96187, 108, '2015-03-15 00:24:23.000000', 'temperatura', 780.0000, 'ºC'),
	(96188, 108, '2015-03-15 00:24:24.000000', 'temperatura', 886.0000, 'ºC'),
	(96189, 108, '2015-03-15 00:24:25.000000', 'temperatura', 893.0000, 'ºC'),
	(96190, 108, '2015-03-15 00:24:26.000000', 'temperatura', 605.0000, 'ºC'),
	(96191, 108, '2015-03-15 00:24:27.000000', 'temperatura', 348.0000, 'ºC'),
	(96192, 108, '2015-03-15 00:24:28.000000', 'temperatura', 1126.0000, 'ºC'),
	(96193, 108, '2015-03-15 00:24:29.000000', 'temperatura', 985.0000, 'ºC'),
	(96194, 108, '2015-03-15 00:24:30.000000', 'temperatura', 348.0000, 'ºC'),
	(96195, 108, '2015-03-15 00:24:31.000000', 'temperatura', 1187.0000, 'ºC'),
	(96196, 108, '2015-03-15 00:24:32.000000', 'temperatura', 90.0000, 'ºC'),
	(96197, 108, '2015-03-15 00:24:33.000000', 'temperatura', 491.0000, 'ºC'),
	(96198, 108, '2015-03-15 00:24:34.000000', 'temperatura', 986.0000, 'ºC'),
	(96199, 108, '2015-03-15 00:24:35.000000', 'temperatura', 1058.0000, 'ºC'),
	(96200, 108, '2015-03-15 00:24:36.000000', 'temperatura', 1132.0000, 'ºC'),
	(96201, 108, '2015-03-15 00:24:37.000000', 'temperatura', 85.0000, 'ºC'),
	(96202, 108, '2015-03-15 00:24:38.000000', 'temperatura', 629.0000, 'ºC'),
	(96203, 108, '2015-03-15 00:24:39.000000', 'temperatura', 493.0000, 'ºC'),
	(96204, 108, '2015-03-15 00:24:40.000000', 'temperatura', 578.0000, 'ºC'),
	(96205, 108, '2015-03-15 00:24:41.000000', 'temperatura', 211.0000, 'ºC'),
	(96206, 108, '2015-03-15 00:24:42.000000', 'temperatura', 521.0000, 'ºC'),
	(96207, 108, '2015-03-15 00:24:43.000000', 'temperatura', 774.0000, 'ºC'),
	(96208, 108, '2015-03-15 00:24:44.000000', 'temperatura', 1108.0000, 'ºC'),
	(96209, 108, '2015-03-15 00:24:45.000000', 'temperatura', 820.0000, 'ºC'),
	(96210, 108, '2015-03-15 00:24:46.000000', 'temperatura', 773.0000, 'ºC'),
	(96211, 108, '2015-03-15 00:24:47.000000', 'temperatura', 209.0000, 'ºC'),
	(96212, 108, '2015-03-15 00:24:48.000000', 'temperatura', 1123.0000, 'ºC'),
	(96213, 108, '2015-03-15 00:24:49.000000', 'temperatura', 191.0000, 'ºC'),
	(96214, 108, '2015-03-15 00:24:50.000000', 'temperatura', 1185.0000, 'ºC'),
	(96215, 108, '2015-03-15 00:24:51.000000', 'temperatura', 553.0000, 'ºC'),
	(96216, 108, '2015-03-15 00:24:52.000000', 'temperatura', 410.0000, 'ºC'),
	(96217, 108, '2015-03-15 00:24:53.000000', 'temperatura', 392.0000, 'ºC'),
	(96218, 108, '2015-03-15 00:24:54.000000', 'temperatura', 730.0000, 'ºC'),
	(96219, 108, '2015-03-15 00:24:55.000000', 'temperatura', 74.0000, 'ºC'),
	(96220, 108, '2015-03-15 00:24:56.000000', 'temperatura', 583.0000, 'ºC'),
	(96221, 108, '2015-03-15 00:24:57.000000', 'temperatura', 292.0000, 'ºC'),
	(96222, 108, '2015-03-15 00:24:58.000000', 'temperatura', 910.0000, 'ºC'),
	(96223, 108, '2015-03-15 00:24:59.000000', 'temperatura', 75.0000, 'ºC'),
	(96224, 108, '2015-03-15 00:25:00.000000', 'temperatura', 47.0000, 'ºC'),
	(96225, 108, '2015-03-15 00:25:01.000000', 'temperatura', 10.0000, 'ºC'),
	(96226, 108, '2015-03-15 00:25:02.000000', 'temperatura', 1111.0000, 'ºC'),
	(96227, 108, '2015-03-15 00:25:03.000000', 'temperatura', 724.0000, 'ºC'),
	(96228, 108, '2015-03-15 00:25:04.000000', 'temperatura', 286.0000, 'ºC'),
	(96229, 108, '2015-03-15 00:25:05.000000', 'temperatura', 462.0000, 'ºC'),
	(96230, 108, '2015-03-15 00:25:06.000000', 'temperatura', 250.0000, 'ºC'),
	(96231, 108, '2015-03-15 00:25:07.000000', 'temperatura', 1065.0000, 'ºC'),
	(96232, 108, '2015-03-15 00:25:08.000000', 'temperatura', 975.0000, 'ºC'),
	(96233, 108, '2015-03-15 00:25:09.000000', 'temperatura', 479.0000, 'ºC'),
	(96234, 108, '2015-03-15 00:25:10.000000', 'temperatura', 673.0000, 'ºC'),
	(96235, 108, '2015-03-15 00:25:11.000000', 'temperatura', 727.0000, 'ºC'),
	(96236, 108, '2015-03-15 00:25:12.000000', 'temperatura', 416.0000, 'ºC'),
	(96237, 108, '2015-03-15 00:25:13.000000', 'temperatura', 1101.0000, 'ºC'),
	(96238, 108, '2015-03-15 00:25:14.000000', 'temperatura', 659.0000, 'ºC'),
	(96239, 108, '2015-03-15 00:25:15.000000', 'temperatura', 1191.0000, 'ºC'),
	(96240, 108, '2015-03-15 00:25:16.000000', 'temperatura', 378.0000, 'ºC'),
	(96241, 108, '2015-03-15 00:25:17.000000', 'temperatura', 717.0000, 'ºC'),
	(96242, 108, '2015-03-15 00:25:18.000000', 'temperatura', 51.0000, 'ºC'),
	(96243, 108, '2015-03-15 00:25:19.000000', 'temperatura', 507.0000, 'ºC'),
	(96244, 108, '2015-03-15 00:25:20.000000', 'temperatura', 1182.0000, 'ºC'),
	(96245, 108, '2015-03-15 00:25:21.000000', 'temperatura', 788.0000, 'ºC'),
	(96246, 108, '2015-03-15 00:25:22.000000', 'temperatura', 395.0000, 'ºC'),
	(96247, 108, '2015-03-15 00:25:23.000000', 'temperatura', 812.0000, 'ºC'),
	(96248, 108, '2015-03-15 00:25:24.000000', 'temperatura', 474.0000, 'ºC'),
	(96249, 108, '2015-03-15 00:25:25.000000', 'temperatura', 1135.0000, 'ºC'),
	(96250, 108, '2015-03-15 00:25:26.000000', 'temperatura', 655.0000, 'ºC'),
	(96251, 108, '2015-03-15 00:25:27.000000', 'temperatura', 1071.0000, 'ºC'),
	(96252, 108, '2015-03-15 00:25:28.000000', 'temperatura', 989.0000, 'ºC'),
	(96253, 108, '2015-03-15 00:25:29.000000', 'temperatura', 534.0000, 'ºC'),
	(96254, 108, '2015-03-15 00:25:30.000000', 'temperatura', 903.0000, 'ºC'),
	(96255, 108, '2015-03-15 00:25:31.000000', 'temperatura', 514.0000, 'ºC'),
	(96256, 108, '2015-03-15 00:25:32.000000', 'temperatura', 1063.0000, 'ºC'),
	(96257, 108, '2015-03-15 00:25:33.000000', 'temperatura', 172.0000, 'ºC'),
	(96258, 108, '2015-03-15 00:25:34.000000', 'temperatura', 71.0000, 'ºC'),
	(96259, 108, '2015-03-15 00:25:35.000000', 'temperatura', 1040.0000, 'ºC'),
	(96260, 108, '2015-03-15 00:25:36.000000', 'temperatura', 186.0000, 'ºC'),
	(96261, 108, '2015-03-15 00:25:37.000000', 'temperatura', 211.0000, 'ºC'),
	(96262, 108, '2015-03-15 00:25:38.000000', 'temperatura', 498.0000, 'ºC'),
	(96263, 108, '2015-03-15 00:25:39.000000', 'temperatura', 658.0000, 'ºC'),
	(96264, 108, '2015-03-15 00:25:40.000000', 'temperatura', 595.0000, 'ºC'),
	(96265, 108, '2015-03-15 00:25:41.000000', 'temperatura', 1003.0000, 'ºC'),
	(96266, 108, '2015-03-15 00:25:42.000000', 'temperatura', 831.0000, 'ºC'),
	(96267, 108, '2015-03-15 00:25:43.000000', 'temperatura', 1148.0000, 'ºC'),
	(96268, 108, '2015-03-15 00:25:44.000000', 'temperatura', 845.0000, 'ºC'),
	(96269, 108, '2015-03-15 00:25:45.000000', 'temperatura', 781.0000, 'ºC'),
	(96270, 108, '2015-03-15 00:25:46.000000', 'temperatura', 170.0000, 'ºC'),
	(96271, 108, '2015-03-15 00:25:47.000000', 'temperatura', 909.0000, 'ºC'),
	(96272, 108, '2015-03-15 00:25:48.000000', 'temperatura', 435.0000, 'ºC'),
	(96273, 108, '2015-03-15 00:25:49.000000', 'temperatura', 650.0000, 'ºC'),
	(96274, 108, '2015-03-15 00:25:50.000000', 'temperatura', 744.0000, 'ºC'),
	(96275, 108, '2015-03-15 00:25:51.000000', 'temperatura', 572.0000, 'ºC'),
	(96276, 108, '2015-03-15 00:25:52.000000', 'temperatura', 629.0000, 'ºC'),
	(96277, 108, '2015-03-15 00:25:53.000000', 'temperatura', 228.0000, 'ºC'),
	(96278, 108, '2015-03-15 00:25:54.000000', 'temperatura', 452.0000, 'ºC'),
	(96279, 108, '2015-03-15 00:25:55.000000', 'temperatura', 377.0000, 'ºC'),
	(96280, 108, '2015-03-15 00:25:56.000000', 'temperatura', 532.0000, 'ºC'),
	(96281, 108, '2015-03-15 00:25:57.000000', 'temperatura', 328.0000, 'ºC'),
	(96282, 108, '2015-03-15 00:25:58.000000', 'temperatura', 46.0000, 'ºC'),
	(96283, 108, '2015-03-15 00:25:59.000000', 'temperatura', 447.0000, 'ºC'),
	(96284, 108, '2015-03-15 00:26:00.000000', 'temperatura', 894.0000, 'ºC'),
	(96285, 108, '2015-03-15 00:26:01.000000', 'temperatura', 733.0000, 'ºC'),
	(96286, 108, '2015-03-15 00:26:02.000000', 'temperatura', 982.0000, 'ºC'),
	(96287, 108, '2015-03-15 00:26:03.000000', 'temperatura', 311.0000, 'ºC'),
	(96288, 108, '2015-03-15 00:26:04.000000', 'temperatura', 1011.0000, 'ºC'),
	(96289, 108, '2015-03-15 00:26:05.000000', 'temperatura', 524.0000, 'ºC'),
	(96290, 108, '2015-03-15 00:26:06.000000', 'temperatura', 784.0000, 'ºC'),
	(96291, 108, '2015-03-15 00:26:07.000000', 'temperatura', 1152.0000, 'ºC'),
	(96292, 108, '2015-03-15 00:26:08.000000', 'temperatura', 1007.0000, 'ºC'),
	(96293, 108, '2015-03-15 00:26:09.000000', 'temperatura', 378.0000, 'ºC'),
	(96294, 108, '2015-03-15 00:26:10.000000', 'temperatura', 69.0000, 'ºC'),
	(96295, 108, '2015-03-15 00:26:11.000000', 'temperatura', 411.0000, 'ºC'),
	(96296, 108, '2015-03-15 00:26:12.000000', 'temperatura', 649.0000, 'ºC'),
	(96297, 108, '2015-03-15 00:26:13.000000', 'temperatura', 813.0000, 'ºC'),
	(96298, 108, '2015-03-15 00:26:14.000000', 'temperatura', 917.0000, 'ºC'),
	(96299, 108, '2015-03-15 00:26:15.000000', 'temperatura', 948.0000, 'ºC'),
	(96300, 108, '2015-03-15 00:26:16.000000', 'temperatura', 791.0000, 'ºC'),
	(96301, 108, '2015-03-15 00:26:17.000000', 'temperatura', 1108.0000, 'ºC'),
	(96302, 108, '2015-03-15 00:26:18.000000', 'temperatura', 771.0000, 'ºC'),
	(96303, 108, '2015-03-15 00:26:19.000000', 'temperatura', 529.0000, 'ºC'),
	(96304, 108, '2015-03-15 00:26:20.000000', 'temperatura', 334.0000, 'ºC'),
	(96305, 108, '2015-03-15 00:26:21.000000', 'temperatura', 83.0000, 'ºC'),
	(96306, 108, '2015-03-15 00:26:22.000000', 'temperatura', 612.0000, 'ºC'),
	(96307, 108, '2015-03-15 00:26:23.000000', 'temperatura', 413.0000, 'ºC'),
	(96308, 108, '2015-03-15 00:26:24.000000', 'temperatura', 230.0000, 'ºC'),
	(96309, 108, '2015-03-15 00:26:25.000000', 'temperatura', 1110.0000, 'ºC'),
	(96310, 108, '2015-03-15 00:26:26.000000', 'temperatura', 61.0000, 'ºC'),
	(96311, 108, '2015-03-15 00:26:27.000000', 'temperatura', 575.0000, 'ºC'),
	(96312, 108, '2015-03-15 00:26:28.000000', 'temperatura', 295.0000, 'ºC'),
	(96313, 108, '2015-03-15 00:26:29.000000', 'temperatura', 949.0000, 'ºC'),
	(96314, 108, '2015-03-15 00:26:30.000000', 'temperatura', 258.0000, 'ºC'),
	(96315, 108, '2015-03-15 00:26:31.000000', 'temperatura', 847.0000, 'ºC'),
	(96316, 108, '2015-03-15 00:26:32.000000', 'temperatura', 1062.0000, 'ºC'),
	(96317, 108, '2015-03-15 00:26:33.000000', 'temperatura', 367.0000, 'ºC'),
	(96318, 108, '2015-03-15 00:26:34.000000', 'temperatura', 1052.0000, 'ºC'),
	(96319, 108, '2015-03-15 00:26:35.000000', 'temperatura', 557.0000, 'ºC'),
	(96320, 108, '2015-03-15 00:26:36.000000', 'temperatura', 832.0000, 'ºC'),
	(96321, 108, '2015-03-15 00:26:37.000000', 'temperatura', 87.0000, 'ºC'),
	(96322, 108, '2015-03-15 00:26:38.000000', 'temperatura', 341.0000, 'ºC'),
	(96323, 108, '2015-03-15 00:26:39.000000', 'temperatura', 243.0000, 'ºC'),
	(96324, 108, '2015-03-15 00:26:40.000000', 'temperatura', 192.0000, 'ºC'),
	(96325, 108, '2015-03-15 00:26:41.000000', 'temperatura', 232.0000, 'ºC'),
	(96326, 108, '2015-03-15 00:26:42.000000', 'temperatura', 583.0000, 'ºC'),
	(96327, 108, '2015-03-15 00:26:43.000000', 'temperatura', 1020.0000, 'ºC'),
	(96328, 108, '2015-03-15 00:26:44.000000', 'temperatura', 954.0000, 'ºC'),
	(96329, 108, '2015-03-15 00:26:45.000000', 'temperatura', 508.0000, 'ºC'),
	(96330, 108, '2015-03-15 00:26:46.000000', 'temperatura', 880.0000, 'ºC'),
	(96331, 108, '2015-03-15 00:26:47.000000', 'temperatura', 477.0000, 'ºC'),
	(96332, 108, '2015-03-15 00:26:48.000000', 'temperatura', 946.0000, 'ºC'),
	(96333, 108, '2015-03-15 00:26:49.000000', 'temperatura', 898.0000, 'ºC'),
	(96334, 108, '2015-03-15 00:26:50.000000', 'temperatura', 452.0000, 'ºC'),
	(96335, 108, '2015-03-15 00:26:51.000000', 'temperatura', 767.0000, 'ºC'),
	(96336, 108, '2015-03-15 00:26:52.000000', 'temperatura', 81.0000, 'ºC'),
	(96337, 108, '2015-03-15 00:26:53.000000', 'temperatura', 502.0000, 'ºC'),
	(96338, 108, '2015-03-15 00:26:54.000000', 'temperatura', 1067.0000, 'ºC'),
	(96339, 108, '2015-03-15 00:26:55.000000', 'temperatura', 230.0000, 'ºC'),
	(96340, 108, '2015-03-15 00:26:56.000000', 'temperatura', 351.0000, 'ºC'),
	(96341, 108, '2015-03-15 00:26:57.000000', 'temperatura', 1067.0000, 'ºC'),
	(96342, 108, '2015-03-15 00:26:58.000000', 'temperatura', 680.0000, 'ºC'),
	(96343, 108, '2015-03-15 00:26:59.000000', 'temperatura', 202.0000, 'ºC'),
	(96344, 108, '2015-03-15 00:27:00.000000', 'temperatura', 169.0000, 'ºC'),
	(96345, 108, '2015-03-15 00:27:01.000000', 'temperatura', 238.0000, 'ºC'),
	(96346, 108, '2015-03-15 00:27:02.000000', 'temperatura', 687.0000, 'ºC'),
	(96347, 108, '2015-03-15 00:27:03.000000', 'temperatura', 318.0000, 'ºC'),
	(96348, 108, '2015-03-15 00:27:04.000000', 'temperatura', 731.0000, 'ºC'),
	(96349, 108, '2015-03-15 00:27:05.000000', 'temperatura', 302.0000, 'ºC'),
	(96350, 108, '2015-03-15 00:27:06.000000', 'temperatura', 518.0000, 'ºC'),
	(96351, 108, '2015-03-15 00:27:07.000000', 'temperatura', 486.0000, 'ºC'),
	(96352, 108, '2015-03-15 00:27:08.000000', 'temperatura', 875.0000, 'ºC'),
	(96353, 108, '2015-03-15 00:27:09.000000', 'temperatura', 517.0000, 'ºC'),
	(96354, 108, '2015-03-15 00:27:10.000000', 'temperatura', 1159.0000, 'ºC'),
	(96355, 108, '2015-03-15 00:27:11.000000', 'temperatura', 645.0000, 'ºC'),
	(96356, 108, '2015-03-15 00:27:12.000000', 'temperatura', 949.0000, 'ºC'),
	(96357, 108, '2015-03-15 00:27:13.000000', 'temperatura', 409.0000, 'ºC'),
	(96358, 108, '2015-03-15 00:27:14.000000', 'temperatura', 399.0000, 'ºC'),
	(96359, 108, '2015-03-15 00:27:15.000000', 'temperatura', 769.0000, 'ºC'),
	(96360, 108, '2015-03-15 00:27:16.000000', 'temperatura', 250.0000, 'ºC'),
	(96361, 108, '2015-03-15 00:27:17.000000', 'temperatura', 141.0000, 'ºC'),
	(96362, 108, '2015-03-15 00:27:18.000000', 'temperatura', 1156.0000, 'ºC'),
	(96363, 108, '2015-03-15 00:27:19.000000', 'temperatura', 557.0000, 'ºC'),
	(96364, 108, '2015-03-15 00:27:20.000000', 'temperatura', 518.0000, 'ºC'),
	(96365, 108, '2015-03-15 00:27:21.000000', 'temperatura', 919.0000, 'ºC'),
	(96366, 108, '2015-03-15 00:27:22.000000', 'temperatura', 643.0000, 'ºC'),
	(96367, 108, '2015-03-15 00:27:23.000000', 'temperatura', 456.0000, 'ºC'),
	(96368, 108, '2015-03-15 00:27:24.000000', 'temperatura', 355.0000, 'ºC'),
	(96369, 108, '2015-03-15 00:27:25.000000', 'temperatura', 405.0000, 'ºC'),
	(96370, 108, '2015-03-15 00:27:26.000000', 'temperatura', 962.0000, 'ºC'),
	(96371, 108, '2015-03-15 00:27:27.000000', 'temperatura', 1195.0000, 'ºC'),
	(96372, 108, '2015-03-15 00:27:28.000000', 'temperatura', 691.0000, 'ºC'),
	(96373, 108, '2015-03-15 00:27:29.000000', 'temperatura', 1071.0000, 'ºC'),
	(96374, 108, '2015-03-15 00:27:30.000000', 'temperatura', 883.0000, 'ºC'),
	(96375, 108, '2015-03-15 00:27:31.000000', 'temperatura', 1.0000, 'ºC'),
	(96376, 108, '2015-03-15 00:27:32.000000', 'temperatura', 958.0000, 'ºC'),
	(96377, 108, '2015-03-15 00:27:33.000000', 'temperatura', 1189.0000, 'ºC'),
	(96378, 108, '2015-03-15 00:27:34.000000', 'temperatura', 668.0000, 'ºC'),
	(96379, 108, '2015-03-15 00:27:35.000000', 'temperatura', 976.0000, 'ºC'),
	(96380, 108, '2015-03-15 00:27:36.000000', 'temperatura', 477.0000, 'ºC'),
	(96381, 108, '2015-03-15 00:27:37.000000', 'temperatura', 656.0000, 'ºC'),
	(96382, 108, '2015-03-15 00:27:38.000000', 'temperatura', 649.0000, 'ºC'),
	(96383, 108, '2015-03-15 00:27:39.000000', 'temperatura', 80.0000, 'ºC'),
	(96384, 108, '2015-03-15 00:27:40.000000', 'temperatura', 853.0000, 'ºC'),
	(96385, 108, '2015-03-15 00:27:41.000000', 'temperatura', 425.0000, 'ºC'),
	(96386, 108, '2015-03-15 00:27:42.000000', 'temperatura', 767.0000, 'ºC'),
	(96387, 108, '2015-03-15 00:27:43.000000', 'temperatura', 159.0000, 'ºC'),
	(96388, 108, '2015-03-15 00:27:44.000000', 'temperatura', 895.0000, 'ºC'),
	(96389, 108, '2015-03-15 00:27:45.000000', 'temperatura', 399.0000, 'ºC'),
	(96390, 108, '2015-03-15 00:27:46.000000', 'temperatura', 510.0000, 'ºC'),
	(96391, 108, '2015-03-15 00:27:47.000000', 'temperatura', 155.0000, 'ºC'),
	(96392, 108, '2015-03-15 00:27:48.000000', 'temperatura', 445.0000, 'ºC'),
	(96393, 108, '2015-03-15 00:27:49.000000', 'temperatura', 562.0000, 'ºC'),
	(96394, 108, '2015-03-15 00:27:50.000000', 'temperatura', 276.0000, 'ºC'),
	(96395, 108, '2015-03-15 00:27:51.000000', 'temperatura', 891.0000, 'ºC'),
	(96396, 108, '2015-03-15 00:27:52.000000', 'temperatura', 31.0000, 'ºC'),
	(96397, 108, '2015-03-15 00:27:53.000000', 'temperatura', 1080.0000, 'ºC'),
	(96398, 108, '2015-03-15 00:27:54.000000', 'temperatura', 509.0000, 'ºC'),
	(96399, 108, '2015-03-15 00:27:55.000000', 'temperatura', 506.0000, 'ºC'),
	(96400, 108, '2015-03-15 00:27:56.000000', 'temperatura', 1001.0000, 'ºC'),
	(96401, 108, '2015-03-15 00:27:57.000000', 'temperatura', 1090.0000, 'ºC'),
	(96402, 108, '2015-03-15 00:27:58.000000', 'temperatura', 45.0000, 'ºC'),
	(96403, 108, '2015-03-15 00:27:59.000000', 'temperatura', 556.0000, 'ºC'),
	(96404, 108, '2015-03-15 00:28:00.000000', 'temperatura', 246.0000, 'ºC'),
	(96405, 108, '2015-03-15 00:28:01.000000', 'temperatura', 761.0000, 'ºC'),
	(96406, 108, '2015-03-15 00:28:02.000000', 'temperatura', 670.0000, 'ºC'),
	(96407, 108, '2015-03-15 00:28:03.000000', 'temperatura', 1067.0000, 'ºC'),
	(96408, 108, '2015-03-15 00:28:04.000000', 'temperatura', 926.0000, 'ºC'),
	(96409, 108, '2015-03-15 00:28:05.000000', 'temperatura', 228.0000, 'ºC'),
	(96410, 108, '2015-03-15 00:28:06.000000', 'temperatura', 764.0000, 'ºC'),
	(96411, 108, '2015-03-15 00:28:07.000000', 'temperatura', 736.0000, 'ºC'),
	(96412, 108, '2015-03-15 00:28:08.000000', 'temperatura', 189.0000, 'ºC'),
	(96413, 108, '2015-03-15 00:28:09.000000', 'temperatura', 1137.0000, 'ºC'),
	(96414, 108, '2015-03-15 00:28:10.000000', 'temperatura', 317.0000, 'ºC'),
	(96415, 108, '2015-03-15 00:28:11.000000', 'temperatura', 577.0000, 'ºC'),
	(96416, 108, '2015-03-15 00:28:12.000000', 'temperatura', 733.0000, 'ºC'),
	(96417, 108, '2015-03-15 00:28:13.000000', 'temperatura', 737.0000, 'ºC'),
	(96418, 108, '2015-03-15 00:28:14.000000', 'temperatura', 285.0000, 'ºC'),
	(96419, 108, '2015-03-15 00:28:15.000000', 'temperatura', 413.0000, 'ºC'),
	(96420, 108, '2015-03-15 00:28:16.000000', 'temperatura', 10.0000, 'ºC'),
	(96421, 108, '2015-03-15 00:28:17.000000', 'temperatura', 11.0000, 'ºC'),
	(96422, 108, '2015-03-15 00:28:18.000000', 'temperatura', 28.0000, 'ºC'),
	(96423, 108, '2015-03-15 00:28:19.000000', 'temperatura', 108.0000, 'ºC'),
	(96424, 108, '2015-03-15 00:28:20.000000', 'temperatura', 454.0000, 'ºC'),
	(96425, 108, '2015-03-15 00:28:21.000000', 'temperatura', 746.0000, 'ºC'),
	(96426, 108, '2015-03-15 00:28:22.000000', 'temperatura', 1170.0000, 'ºC'),
	(96427, 108, '2015-03-15 00:28:23.000000', 'temperatura', 12.0000, 'ºC'),
	(96428, 108, '2015-03-15 00:28:24.000000', 'temperatura', 150.0000, 'ºC'),
	(96429, 108, '2015-03-15 00:28:25.000000', 'temperatura', 716.0000, 'ºC'),
	(96430, 108, '2015-03-15 00:28:26.000000', 'temperatura', 732.0000, 'ºC'),
	(96431, 108, '2015-03-15 00:28:27.000000', 'temperatura', 309.0000, 'ºC'),
	(96432, 108, '2015-03-15 00:28:28.000000', 'temperatura', 551.0000, 'ºC'),
	(96433, 108, '2015-03-15 00:28:29.000000', 'temperatura', 629.0000, 'ºC'),
	(96434, 108, '2015-03-15 00:28:30.000000', 'temperatura', 292.0000, 'ºC'),
	(96435, 108, '2015-03-15 00:28:31.000000', 'temperatura', 773.0000, 'ºC'),
	(96436, 108, '2015-03-15 00:28:32.000000', 'temperatura', 592.0000, 'ºC'),
	(96437, 108, '2015-03-15 00:28:33.000000', 'temperatura', 638.0000, 'ºC'),
	(96438, 108, '2015-03-15 00:28:34.000000', 'temperatura', 215.0000, 'ºC'),
	(96439, 108, '2015-03-15 00:28:35.000000', 'temperatura', 364.0000, 'ºC'),
	(96440, 108, '2015-03-15 00:28:36.000000', 'temperatura', 1175.0000, 'ºC'),
	(96441, 108, '2015-03-15 00:28:37.000000', 'temperatura', 1182.0000, 'ºC'),
	(96442, 108, '2015-03-15 00:28:38.000000', 'temperatura', 1186.0000, 'ºC'),
	(96443, 108, '2015-03-15 00:28:39.000000', 'temperatura', 1185.0000, 'ºC'),
	(96444, 108, '2015-03-15 00:28:40.000000', 'temperatura', 1168.0000, 'ºC'),
	(96445, 108, '2015-03-15 00:28:41.000000', 'temperatura', 1083.0000, 'ºC'),
	(96446, 108, '2015-03-15 00:28:42.000000', 'temperatura', 715.0000, 'ºC'),
	(96447, 108, '2015-03-15 00:28:43.000000', 'temperatura', 324.0000, 'ºC'),
	(96448, 108, '2015-03-15 00:28:44.000000', 'temperatura', 676.0000, 'ºC'),
	(96449, 108, '2015-03-15 00:28:45.000000', 'temperatura', 9.0000, 'ºC'),
	(96450, 108, '2015-03-15 00:28:46.000000', 'temperatura', 417.0000, 'ºC'),
	(96451, 108, '2015-03-15 00:28:47.000000', 'temperatura', 857.0000, 'ºC'),
	(96452, 108, '2015-03-15 00:28:48.000000', 'temperatura', 634.0000, 'ºC'),
	(96453, 108, '2015-03-15 00:28:49.000000', 'temperatura', 601.0000, 'ºC'),
	(96454, 108, '2015-03-15 00:28:50.000000', 'temperatura', 1102.0000, 'ºC'),
	(96455, 108, '2015-03-15 00:28:51.000000', 'temperatura', 106.0000, 'ºC'),
	(96456, 108, '2015-03-15 00:28:52.000000', 'temperatura', 828.0000, 'ºC'),
	(96457, 108, '2015-03-15 00:28:53.000000', 'temperatura', 222.0000, 'ºC'),
	(96458, 108, '2015-03-15 00:28:54.000000', 'temperatura', 1027.0000, 'ºC'),
	(96459, 108, '2015-03-15 00:28:55.000000', 'temperatura', 869.0000, 'ºC'),
	(96460, 108, '2015-03-15 00:28:56.000000', 'temperatura', 65.0000, 'ºC'),
	(96461, 108, '2015-03-15 00:28:57.000000', 'temperatura', 116.0000, 'ºC'),
	(96462, 108, '2015-03-15 00:28:58.000000', 'temperatura', 388.0000, 'ºC'),
	(96463, 108, '2015-03-15 00:28:59.000000', 'temperatura', 390.0000, 'ºC'),
	(96464, 108, '2015-03-15 00:29:00.000000', 'temperatura', 788.0000, 'ºC'),
	(96465, 108, '2015-03-15 00:29:01.000000', 'temperatura', 368.0000, 'ºC'),
	(96466, 108, '2015-03-15 00:29:02.000000', 'temperatura', 679.0000, 'ºC'),
	(96467, 108, '2015-03-15 00:29:03.000000', 'temperatura', 1091.0000, 'ºC'),
	(96468, 108, '2015-03-15 00:29:04.000000', 'temperatura', 1020.0000, 'ºC'),
	(96469, 108, '2015-03-15 00:29:05.000000', 'temperatura', 628.0000, 'ºC'),
	(96470, 108, '2015-03-15 00:29:06.000000', 'temperatura', 79.0000, 'ºC'),
	(96471, 108, '2015-03-15 00:29:07.000000', 'temperatura', 910.0000, 'ºC'),
	(96472, 108, '2015-03-15 00:29:08.000000', 'temperatura', 715.0000, 'ºC'),
	(96473, 108, '2015-03-15 00:29:09.000000', 'temperatura', 847.0000, 'ºC'),
	(96474, 108, '2015-03-15 00:29:10.000000', 'temperatura', 889.0000, 'ºC'),
	(96475, 108, '2015-03-15 00:29:11.000000', 'temperatura', 706.0000, 'ºC'),
	(96476, 108, '2015-03-15 00:29:12.000000', 'temperatura', 861.0000, 'ºC'),
	(96477, 108, '2015-03-15 00:29:13.000000', 'temperatura', 989.0000, 'ºC'),
	(96478, 108, '2015-03-15 00:29:14.000000', 'temperatura', 1163.0000, 'ºC'),
	(96479, 108, '2015-03-15 00:29:15.000000', 'temperatura', 448.0000, 'ºC'),
	(96480, 108, '2015-03-15 00:29:16.000000', 'temperatura', 1150.0000, 'ºC'),
	(96481, 108, '2015-03-15 00:29:17.000000', 'temperatura', 807.0000, 'ºC'),
	(96482, 108, '2015-03-15 00:29:18.000000', 'temperatura', 586.0000, 'ºC'),
	(96483, 108, '2015-03-15 00:29:19.000000', 'temperatura', 510.0000, 'ºC'),
	(96484, 108, '2015-03-15 00:29:20.000000', 'temperatura', 793.0000, 'ºC'),
	(96485, 108, '2015-03-15 00:29:21.000000', 'temperatura', 34.0000, 'ºC'),
	(96486, 108, '2015-03-15 00:29:22.000000', 'temperatura', 194.0000, 'ºC'),
	(96487, 108, '2015-03-15 00:29:23.000000', 'temperatura', 868.0000, 'ºC'),
	(96488, 108, '2015-03-15 00:29:24.000000', 'temperatura', 158.0000, 'ºC'),
	(96489, 108, '2015-03-15 00:29:25.000000', 'temperatura', 585.0000, 'ºC'),
	(96490, 108, '2015-03-15 00:29:26.000000', 'temperatura', 52.0000, 'ºC'),
	(96491, 108, '2015-03-15 00:29:27.000000', 'temperatura', 905.0000, 'ºC'),
	(96492, 108, '2015-03-15 00:29:28.000000', 'temperatura', 772.0000, 'ºC'),
	(96493, 108, '2015-03-15 00:29:29.000000', 'temperatura', 1143.0000, 'ºC'),
	(96494, 108, '2015-03-15 00:29:30.000000', 'temperatura', 998.0000, 'ºC'),
	(96495, 108, '2015-03-15 00:29:31.000000', 'temperatura', 365.0000, 'ºC'),
	(96496, 108, '2015-03-15 00:29:32.000000', 'temperatura', 28.0000, 'ºC'),
	(96497, 108, '2015-03-15 00:29:33.000000', 'temperatura', 249.0000, 'ºC'),
	(96498, 108, '2015-03-15 00:29:34.000000', 'temperatura', 1161.0000, 'ºC'),
	(96499, 108, '2015-03-15 00:29:35.000000', 'temperatura', 256.0000, 'ºC'),
	(96500, 108, '2015-03-15 00:29:36.000000', 'temperatura', 200.0000, 'ºC'),
	(96501, 108, '2015-03-15 00:29:37.000000', 'temperatura', 233.0000, 'ºC'),
	(96502, 108, '2015-03-15 00:29:38.000000', 'temperatura', 566.0000, 'ºC'),
	(96503, 108, '2015-03-15 00:29:39.000000', 'temperatura', 929.0000, 'ºC'),
	(96504, 108, '2015-03-15 00:29:40.000000', 'temperatura', 549.0000, 'ºC'),
	(96505, 108, '2015-03-15 00:29:41.000000', 'temperatura', 1160.0000, 'ºC'),
	(96506, 108, '2015-03-15 00:29:42.000000', 'temperatura', 552.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(96507, 108, '2015-03-15 00:29:43.000000', 'temperatura', 483.0000, 'ºC'),
	(96508, 108, '2015-03-15 00:29:44.000000', 'temperatura', 756.0000, 'ºC'),
	(96509, 108, '2015-03-15 00:29:45.000000', 'temperatura', 1135.0000, 'ºC'),
	(96510, 108, '2015-03-15 00:29:46.000000', 'temperatura', 1004.0000, 'ºC'),
	(96511, 108, '2015-03-15 00:29:47.000000', 'temperatura', 417.0000, 'ºC'),
	(96512, 108, '2015-03-15 00:29:48.000000', 'temperatura', 275.0000, 'ºC'),
	(96513, 108, '2015-03-15 00:29:49.000000', 'temperatura', 123.0000, 'ºC'),
	(96514, 108, '2015-03-15 00:29:50.000000', 'temperatura', 991.0000, 'ºC'),
	(96515, 108, '2015-03-15 00:29:51.000000', 'temperatura', 984.0000, 'ºC'),
	(96516, 108, '2015-03-15 00:29:52.000000', 'temperatura', 751.0000, 'ºC'),
	(96517, 108, '2015-03-15 00:29:53.000000', 'temperatura', 803.0000, 'ºC'),
	(96518, 108, '2015-03-15 00:29:54.000000', 'temperatura', 561.0000, 'ºC'),
	(96519, 108, '2015-03-15 00:29:55.000000', 'temperatura', 398.0000, 'ºC'),
	(96520, 108, '2015-03-15 00:29:56.000000', 'temperatura', 309.0000, 'ºC'),
	(96521, 108, '2015-03-15 00:29:57.000000', 'temperatura', 350.0000, 'ºC'),
	(96522, 108, '2015-03-15 00:29:58.000000', 'temperatura', 824.0000, 'ºC'),
	(96523, 108, '2015-03-15 00:29:59.000000', 'temperatura', 671.0000, 'ºC'),
	(96524, 108, '2015-03-15 00:30:00.000000', 'temperatura', 885.0000, 'ºC'),
	(96525, 108, '2015-03-15 00:30:01.000000', 'temperatura', 10.0000, 'ºC'),
	(96526, 108, '2015-03-15 00:30:02.000000', 'temperatura', 998.0000, 'ºC'),
	(96527, 108, '2015-03-15 00:30:03.000000', 'temperatura', 160.0000, 'ºC'),
	(96528, 108, '2015-03-15 00:30:04.000000', 'temperatura', 205.0000, 'ºC'),
	(96529, 108, '2015-03-15 00:30:05.000000', 'temperatura', 546.0000, 'ºC'),
	(96530, 108, '2015-03-15 00:30:06.000000', 'temperatura', 916.0000, 'ºC'),
	(96531, 108, '2015-03-15 00:30:07.000000', 'temperatura', 543.0000, 'ºC'),
	(96532, 108, '2015-03-15 00:30:08.000000', 'temperatura', 1167.0000, 'ºC'),
	(96533, 108, '2015-03-15 00:30:09.000000', 'temperatura', 608.0000, 'ºC'),
	(96534, 108, '2015-03-15 00:30:10.000000', 'temperatura', 739.0000, 'ºC'),
	(96535, 108, '2015-03-15 00:30:11.000000', 'temperatura', 669.0000, 'ºC'),
	(96536, 108, '2015-03-15 00:30:12.000000', 'temperatura', 1132.0000, 'ºC'),
	(96537, 108, '2015-03-15 00:30:13.000000', 'temperatura', 52.0000, 'ºC'),
	(96538, 108, '2015-03-15 00:30:14.000000', 'temperatura', 465.0000, 'ºC'),
	(96539, 108, '2015-03-15 00:30:15.000000', 'temperatura', 968.0000, 'ºC'),
	(96540, 108, '2015-03-15 00:30:16.000000', 'temperatura', 1045.0000, 'ºC'),
	(96541, 108, '2015-03-15 00:30:17.000000', 'temperatura', 1121.0000, 'ºC'),
	(96542, 108, '2015-03-15 00:30:18.000000', 'temperatura', 72.0000, 'ºC'),
	(96543, 108, '2015-03-15 00:30:19.000000', 'temperatura', 599.0000, 'ºC'),
	(96544, 108, '2015-03-15 00:30:20.000000', 'temperatura', 379.0000, 'ºC'),
	(96545, 108, '2015-03-15 00:30:21.000000', 'temperatura', 96.0000, 'ºC'),
	(96546, 108, '2015-03-15 00:30:22.000000', 'temperatura', 547.0000, 'ºC'),
	(96547, 108, '2015-03-15 00:30:23.000000', 'temperatura', 46.0000, 'ºC'),
	(96548, 108, '2015-03-15 00:30:24.000000', 'temperatura', 989.0000, 'ºC'),
	(96549, 108, '2015-03-15 00:30:25.000000', 'temperatura', 7.0000, 'ºC'),
	(96550, 108, '2015-03-15 00:30:26.000000', 'temperatura', 669.0000, 'ºC'),
	(96551, 108, '2015-03-15 00:30:27.000000', 'temperatura', 923.0000, 'ºC'),
	(96552, 108, '2015-03-15 00:30:28.000000', 'temperatura', 208.0000, 'ºC'),
	(96553, 108, '2015-03-15 00:30:29.000000', 'temperatura', 671.0000, 'ºC'),
	(96554, 108, '2015-03-15 00:30:30.000000', 'temperatura', 332.0000, 'ºC'),
	(96555, 108, '2015-03-15 00:30:31.000000', 'temperatura', 849.0000, 'ºC'),
	(96556, 108, '2015-03-15 00:30:32.000000', 'temperatura', 851.0000, 'ºC'),
	(96557, 108, '2015-03-15 00:30:33.000000', 'temperatura', 505.0000, 'ºC'),
	(96558, 108, '2015-03-15 00:30:34.000000', 'temperatura', 1175.0000, 'ºC'),
	(96559, 108, '2015-03-15 00:30:35.000000', 'temperatura', 760.0000, 'ºC'),
	(96560, 108, '2015-03-15 00:30:36.000000', 'temperatura', 276.0000, 'ºC'),
	(96561, 108, '2015-03-15 00:30:37.000000', 'temperatura', 299.0000, 'ºC'),
	(96562, 108, '2015-03-15 00:30:38.000000', 'temperatura', 667.0000, 'ºC'),
	(96563, 108, '2015-03-15 00:30:39.000000', 'temperatura', 41.0000, 'ºC'),
	(96564, 108, '2015-03-15 00:30:40.000000', 'temperatura', 605.0000, 'ºC'),
	(96565, 108, '2015-03-15 00:30:41.000000', 'temperatura', 501.0000, 'ºC'),
	(96566, 108, '2015-03-15 00:30:42.000000', 'temperatura', 692.0000, 'ºC'),
	(96567, 108, '2015-03-15 00:30:43.000000', 'temperatura', 755.0000, 'ºC'),
	(96568, 108, '2015-03-15 00:30:44.000000', 'temperatura', 501.0000, 'ºC'),
	(96569, 108, '2015-03-15 00:30:45.000000', 'temperatura', 241.0000, 'ºC'),
	(96570, 108, '2015-03-15 00:30:46.000000', 'temperatura', 903.0000, 'ºC'),
	(96571, 108, '2015-03-15 00:30:47.000000', 'temperatura', 191.0000, 'ºC'),
	(96572, 108, '2015-03-15 00:30:48.000000', 'temperatura', 649.0000, 'ºC'),
	(96573, 108, '2015-03-15 00:30:49.000000', 'temperatura', 271.0000, 'ºC'),
	(96574, 108, '2015-03-15 00:30:50.000000', 'temperatura', 611.0000, 'ºC'),
	(96575, 108, '2015-03-15 00:30:51.000000', 'temperatura', 1039.0000, 'ºC'),
	(96576, 108, '2015-03-15 00:30:52.000000', 'temperatura', 965.0000, 'ºC'),
	(96577, 108, '2015-03-15 00:30:53.000000', 'temperatura', 509.0000, 'ºC'),
	(96578, 108, '2015-03-15 00:30:54.000000', 'temperatura', 849.0000, 'ºC'),
	(96579, 108, '2015-03-15 00:30:55.000000', 'temperatura', 317.0000, 'ºC'),
	(96580, 108, '2015-03-15 00:30:56.000000', 'temperatura', 241.0000, 'ºC'),
	(96581, 108, '2015-03-15 00:30:57.000000', 'temperatura', 252.0000, 'ºC'),
	(96582, 108, '2015-03-15 00:30:58.000000', 'temperatura', 539.0000, 'ºC'),
	(96583, 108, '2015-03-15 00:30:59.000000', 'temperatura', 738.0000, 'ºC'),
	(96584, 108, '2015-03-15 00:31:00.000000', 'temperatura', 875.0000, 'ºC'),
	(96585, 108, '2015-03-15 00:31:01.000000', 'temperatura', 961.0000, 'ºC'),
	(96586, 108, '2015-03-15 00:31:02.000000', 'temperatura', 982.0000, 'ºC'),
	(96587, 108, '2015-03-15 00:31:03.000000', 'temperatura', 827.0000, 'ºC'),
	(96588, 108, '2015-03-15 00:31:04.000000', 'temperatura', 1189.0000, 'ºC'),
	(96589, 108, '2015-03-15 00:31:05.000000', 'temperatura', 1065.0000, 'ºC'),
	(96590, 108, '2015-03-15 00:31:06.000000', 'temperatura', 557.0000, 'ºC'),
	(96591, 108, '2015-03-15 00:31:07.000000', 'temperatura', 792.0000, 'ºC'),
	(96592, 108, '2015-03-15 00:31:08.000000', 'temperatura', 1090.0000, 'ºC'),
	(96593, 108, '2015-03-15 00:31:09.000000', 'temperatura', 675.0000, 'ºC'),
	(96594, 108, '2015-03-15 00:31:10.000000', 'temperatura', 107.0000, 'ºC'),
	(96595, 108, '2015-03-15 00:31:11.000000', 'temperatura', 907.0000, 'ºC'),
	(96596, 108, '2015-03-15 00:31:12.000000', 'temperatura', 617.0000, 'ºC'),
	(96597, 108, '2015-03-15 00:31:13.000000', 'temperatura', 364.0000, 'ºC'),
	(96598, 108, '2015-03-15 00:31:14.000000', 'temperatura', 1168.0000, 'ºC'),
	(96599, 108, '2015-03-15 00:31:15.000000', 'temperatura', 1151.0000, 'ºC'),
	(96600, 108, '2015-03-15 00:31:16.000000', 'temperatura', 1051.0000, 'ºC'),
	(96601, 108, '2015-03-15 00:31:17.000000', 'temperatura', 601.0000, 'ºC'),
	(96602, 108, '2015-03-15 00:31:18.000000', 'temperatura', 1055.0000, 'ºC'),
	(96603, 108, '2015-03-15 00:31:19.000000', 'temperatura', 1070.0000, 'ºC'),
	(96604, 108, '2015-03-15 00:31:20.000000', 'temperatura', 988.0000, 'ºC'),
	(96605, 108, '2015-03-15 00:31:21.000000', 'temperatura', 531.0000, 'ºC'),
	(96606, 108, '2015-03-15 00:31:22.000000', 'temperatura', 892.0000, 'ºC'),
	(96607, 108, '2015-03-15 00:31:23.000000', 'temperatura', 468.0000, 'ºC'),
	(96608, 108, '2015-03-15 00:31:24.000000', 'temperatura', 864.0000, 'ºC'),
	(96609, 108, '2015-03-15 00:31:25.000000', 'temperatura', 516.0000, 'ºC'),
	(96610, 108, '2015-03-15 00:31:26.000000', 'temperatura', 1189.0000, 'ºC'),
	(96611, 108, '2015-03-15 00:31:27.000000', 'temperatura', 796.0000, 'ºC'),
	(96612, 108, '2015-03-15 00:31:28.000000', 'temperatura', 414.0000, 'ºC'),
	(96613, 108, '2015-03-15 00:31:29.000000', 'temperatura', 884.0000, 'ºC'),
	(96614, 108, '2015-03-15 00:31:30.000000', 'temperatura', 777.0000, 'ºC'),
	(96615, 108, '2015-03-15 00:31:31.000000', 'temperatura', 35.0000, 'ºC'),
	(96616, 108, '2015-03-15 00:31:32.000000', 'temperatura', 244.0000, 'ºC'),
	(96617, 108, '2015-03-15 00:31:33.000000', 'temperatura', 1114.0000, 'ºC'),
	(96618, 108, '2015-03-15 00:31:34.000000', 'temperatura', 38.0000, 'ºC'),
	(96619, 108, '2015-03-15 00:31:35.000000', 'temperatura', 451.0000, 'ºC'),
	(96620, 108, '2015-03-15 00:31:36.000000', 'temperatura', 941.0000, 'ºC'),
	(96621, 108, '2015-03-15 00:31:37.000000', 'temperatura', 952.0000, 'ºC'),
	(96622, 108, '2015-03-15 00:31:38.000000', 'temperatura', 736.0000, 'ºC'),
	(96623, 108, '2015-03-15 00:31:39.000000', 'temperatura', 828.0000, 'ºC'),
	(96624, 108, '2015-03-15 00:31:40.000000', 'temperatura', 729.0000, 'ºC'),
	(96625, 108, '2015-03-15 00:31:41.000000', 'temperatura', 1165.0000, 'ºC'),
	(96626, 108, '2015-03-15 00:31:42.000000', 'temperatura', 36.0000, 'ºC'),
	(96627, 108, '2015-03-15 00:31:43.000000', 'temperatura', 285.0000, 'ºC'),
	(96628, 108, '2015-03-15 00:31:44.000000', 'temperatura', 119.0000, 'ºC'),
	(96629, 108, '2015-03-15 00:31:45.000000', 'temperatura', 938.0000, 'ºC'),
	(96630, 108, '2015-03-15 00:31:46.000000', 'temperatura', 737.0000, 'ºC'),
	(96631, 108, '2015-03-15 00:31:47.000000', 'temperatura', 870.0000, 'ºC'),
	(96632, 108, '2015-03-15 00:31:48.000000', 'temperatura', 940.0000, 'ºC'),
	(96633, 108, '2015-03-15 00:31:49.000000', 'temperatura', 891.0000, 'ºC'),
	(96634, 108, '2015-03-15 00:31:50.000000', 'temperatura', 435.0000, 'ºC'),
	(96635, 108, '2015-03-15 00:31:51.000000', 'temperatura', 702.0000, 'ºC'),
	(96636, 108, '2015-03-15 00:31:52.000000', 'temperatura', 1007.0000, 'ºC'),
	(96637, 108, '2015-03-15 00:31:53.000000', 'temperatura', 527.0000, 'ºC'),
	(96638, 108, '2015-03-15 00:31:54.000000', 'temperatura', 816.0000, 'ºC'),
	(96639, 108, '2015-03-15 00:31:55.000000', 'temperatura', 97.0000, 'ºC'),
	(96640, 108, '2015-03-15 00:31:56.000000', 'temperatura', 440.0000, 'ºC'),
	(96641, 108, '2015-03-15 00:31:57.000000', 'temperatura', 710.0000, 'ºC'),
	(96642, 108, '2015-03-15 00:31:58.000000', 'temperatura', 1029.0000, 'ºC'),
	(96643, 108, '2015-03-15 00:31:59.000000', 'temperatura', 617.0000, 'ºC'),
	(96644, 108, '2015-03-15 00:32:00.000000', 'temperatura', 1196.0000, 'ºC'),
	(96645, 108, '2015-03-15 00:32:01.000000', 'temperatura', 533.0000, 'ºC'),
	(96646, 108, '2015-03-15 00:32:02.000000', 'temperatura', 275.0000, 'ºC'),
	(96647, 108, '2015-03-15 00:32:03.000000', 'temperatura', 975.0000, 'ºC'),
	(96648, 108, '2015-03-15 00:32:04.000000', 'temperatura', 453.0000, 'ºC'),
	(96649, 108, '2015-03-15 00:32:05.000000', 'temperatura', 538.0000, 'ºC'),
	(96650, 108, '2015-03-15 00:32:06.000000', 'temperatura', 134.0000, 'ºC'),
	(96651, 108, '2015-03-15 00:32:07.000000', 'temperatura', 255.0000, 'ºC'),
	(96652, 108, '2015-03-15 00:32:08.000000', 'temperatura', 875.0000, 'ºC'),
	(96653, 108, '2015-03-15 00:32:09.000000', 'temperatura', 9.0000, 'ºC'),
	(96654, 108, '2015-03-15 00:32:10.000000', 'temperatura', 1021.0000, 'ºC'),
	(96655, 108, '2015-03-15 00:32:11.000000', 'temperatura', 280.0000, 'ºC'),
	(96656, 108, '2015-03-15 00:32:12.000000', 'temperatura', 735.0000, 'ºC'),
	(96657, 108, '2015-03-15 00:32:13.000000', 'temperatura', 435.0000, 'ºC'),
	(96658, 108, '2015-03-15 00:32:14.000000', 'temperatura', 1173.0000, 'ºC'),
	(96659, 108, '2015-03-15 00:32:15.000000', 'temperatura', 959.0000, 'ºC'),
	(96660, 108, '2015-03-15 00:32:16.000000', 'temperatura', 76.0000, 'ºC'),
	(96661, 108, '2015-03-15 00:32:17.000000', 'temperatura', 1103.0000, 'ºC'),
	(96662, 108, '2015-03-15 00:32:18.000000', 'temperatura', 487.0000, 'ºC'),
	(96663, 108, '2015-03-15 00:32:19.000000', 'temperatura', 328.0000, 'ºC'),
	(96664, 108, '2015-03-15 00:32:20.000000', 'temperatura', 177.0000, 'ºC'),
	(96665, 108, '2015-03-15 00:32:21.000000', 'temperatura', 1105.0000, 'ºC'),
	(96666, 108, '2015-03-15 00:32:22.000000', 'temperatura', 192.0000, 'ºC'),
	(96667, 108, '2015-03-15 00:32:23.000000', 'temperatura', 44.0000, 'ºC'),
	(96668, 108, '2015-03-15 00:32:24.000000', 'temperatura', 847.0000, 'ºC'),
	(96669, 108, '2015-03-15 00:32:25.000000', 'temperatura', 502.0000, 'ºC'),
	(96670, 108, '2015-03-15 00:32:26.000000', 'temperatura', 1169.0000, 'ºC'),
	(96671, 108, '2015-03-15 00:32:27.000000', 'temperatura', 740.0000, 'ºC'),
	(96672, 108, '2015-03-15 00:32:28.000000', 'temperatura', 195.0000, 'ºC'),
	(96673, 108, '2015-03-15 00:32:29.000000', 'temperatura', 1153.0000, 'ºC'),
	(96674, 108, '2015-03-15 00:32:30.000000', 'temperatura', 380.0000, 'ºC'),
	(96675, 108, '2015-03-15 00:32:31.000000', 'temperatura', 844.0000, 'ºC'),
	(96676, 108, '2015-03-15 00:32:32.000000', 'temperatura', 679.0000, 'ºC'),
	(96677, 108, '2015-03-15 00:32:33.000000', 'temperatura', 864.0000, 'ºC'),
	(96678, 108, '2015-03-15 00:32:34.000000', 'temperatura', 1085.0000, 'ºC'),
	(96679, 108, '2015-03-15 00:32:35.000000', 'temperatura', 435.0000, 'ºC'),
	(96680, 108, '2015-03-15 00:32:36.000000', 'temperatura', 117.0000, 'ºC'),
	(96681, 108, '2015-03-15 00:32:37.000000', 'temperatura', 480.0000, 'ºC'),
	(96682, 108, '2015-03-15 00:32:38.000000', 'temperatura', 850.0000, 'ºC'),
	(96683, 108, '2015-03-15 00:32:39.000000', 'temperatura', 412.0000, 'ºC'),
	(96684, 108, '2015-03-15 00:32:40.000000', 'temperatura', 710.0000, 'ºC'),
	(96685, 108, '2015-03-15 00:32:41.000000', 'temperatura', 1114.0000, 'ºC'),
	(96686, 108, '2015-03-15 00:32:42.000000', 'temperatura', 1041.0000, 'ºC'),
	(96687, 108, '2015-03-15 00:32:43.000000', 'temperatura', 665.0000, 'ºC'),
	(96688, 108, '2015-03-15 00:32:44.000000', 'temperatura', 203.0000, 'ºC'),
	(96689, 108, '2015-03-15 00:32:45.000000', 'temperatura', 219.0000, 'ºC'),
	(96690, 108, '2015-03-15 00:32:46.000000', 'temperatura', 486.0000, 'ºC'),
	(96691, 108, '2015-03-15 00:32:47.000000', 'temperatura', 573.0000, 'ºC'),
	(96692, 108, '2015-03-15 00:32:48.000000', 'temperatura', 210.0000, 'ºC'),
	(96693, 108, '2015-03-15 00:32:49.000000', 'temperatura', 529.0000, 'ºC'),
	(96694, 108, '2015-03-15 00:32:50.000000', 'temperatura', 817.0000, 'ºC'),
	(96695, 108, '2015-03-15 00:32:51.000000', 'temperatura', 98.0000, 'ºC'),
	(96696, 108, '2015-03-15 00:32:52.000000', 'temperatura', 439.0000, 'ºC'),
	(96697, 108, '2015-03-15 00:32:53.000000', 'temperatura', 702.0000, 'ºC'),
	(96698, 108, '2015-03-15 00:32:54.000000', 'temperatura', 995.0000, 'ºC'),
	(96699, 108, '2015-03-15 00:32:55.000000', 'temperatura', 468.0000, 'ºC'),
	(96700, 108, '2015-03-15 00:32:56.000000', 'temperatura', 556.0000, 'ºC'),
	(96701, 108, '2015-03-15 00:32:57.000000', 'temperatura', 175.0000, 'ºC'),
	(96702, 108, '2015-03-15 00:32:58.000000', 'temperatura', 410.0000, 'ºC'),
	(96703, 108, '2015-03-15 00:32:59.000000', 'temperatura', 324.0000, 'ºC'),
	(96704, 108, '2015-03-15 00:33:00.000000', 'temperatura', 390.0000, 'ºC'),
	(96705, 108, '2015-03-15 00:33:01.000000', 'temperatura', 979.0000, 'ºC'),
	(96706, 108, '2015-03-15 00:33:02.000000', 'temperatura', 127.0000, 'ºC'),
	(96707, 108, '2015-03-15 00:33:03.000000', 'temperatura', 97.0000, 'ºC'),
	(96708, 108, '2015-03-15 00:33:04.000000', 'temperatura', 105.0000, 'ºC'),
	(96709, 108, '2015-03-15 00:33:05.000000', 'temperatura', 234.0000, 'ºC'),
	(96710, 108, '2015-03-15 00:33:06.000000', 'temperatura', 854.0000, 'ºC'),
	(96711, 108, '2015-03-15 00:33:07.000000', 'temperatura', 1169.0000, 'ºC'),
	(96712, 108, '2015-03-15 00:33:08.000000', 'temperatura', 883.0000, 'ºC'),
	(96713, 108, '2015-03-15 00:33:09.000000', 'temperatura', 910.0000, 'ºC'),
	(96714, 108, '2015-03-15 00:33:10.000000', 'temperatura', 703.0000, 'ºC'),
	(96715, 108, '2015-03-15 00:33:11.000000', 'temperatura', 782.0000, 'ºC'),
	(96716, 108, '2015-03-15 00:33:12.000000', 'temperatura', 603.0000, 'ºC'),
	(96717, 108, '2015-03-15 00:33:13.000000', 'temperatura', 671.0000, 'ºC'),
	(96718, 108, '2015-03-15 00:33:14.000000', 'temperatura', 347.0000, 'ºC'),
	(96719, 108, '2015-03-15 00:33:15.000000', 'temperatura', 922.0000, 'ºC'),
	(96720, 108, '2015-03-15 00:33:16.000000', 'temperatura', 1171.0000, 'ºC'),
	(96721, 108, '2015-03-15 00:33:17.000000', 'temperatura', 688.0000, 'ºC'),
	(96722, 108, '2015-03-15 00:33:18.000000', 'temperatura', 1128.0000, 'ºC'),
	(96723, 108, '2015-03-15 00:33:19.000000', 'temperatura', 1178.0000, 'ºC'),
	(96724, 108, '2015-03-15 00:33:20.000000', 'temperatura', 106.0000, 'ºC'),
	(96725, 108, '2015-03-15 00:33:21.000000', 'temperatura', 596.0000, 'ºC'),
	(96726, 108, '2015-03-15 00:33:22.000000', 'temperatura', 261.0000, 'ºC'),
	(96727, 108, '2015-03-15 00:33:23.000000', 'temperatura', 717.0000, 'ºC'),
	(96728, 108, '2015-03-15 00:33:24.000000', 'temperatura', 404.0000, 'ºC'),
	(96729, 108, '2015-03-15 00:33:25.000000', 'temperatura', 1070.0000, 'ºC'),
	(96730, 108, '2015-03-15 00:33:26.000000', 'temperatura', 540.0000, 'ºC'),
	(96731, 108, '2015-03-15 00:33:27.000000', 'temperatura', 687.0000, 'ºC'),
	(96732, 108, '2015-03-15 00:33:28.000000', 'temperatura', 618.0000, 'ºC'),
	(96733, 108, '2015-03-15 00:33:29.000000', 'temperatura', 1027.0000, 'ºC'),
	(96734, 108, '2015-03-15 00:33:30.000000', 'temperatura', 882.0000, 'ºC'),
	(96735, 108, '2015-03-15 00:33:31.000000', 'temperatura', 130.0000, 'ºC'),
	(96736, 108, '2015-03-15 00:33:32.000000', 'temperatura', 406.0000, 'ºC'),
	(96737, 108, '2015-03-15 00:33:33.000000', 'temperatura', 441.0000, 'ºC'),
	(96738, 108, '2015-03-15 00:33:34.000000', 'temperatura', 987.0000, 'ºC'),
	(96739, 108, '2015-03-15 00:33:35.000000', 'temperatura', 13.0000, 'ºC'),
	(96740, 108, '2015-03-15 00:33:36.000000', 'temperatura', 706.0000, 'ºC'),
	(96741, 108, '2015-03-15 00:33:37.000000', 'temperatura', 1089.0000, 'ºC'),
	(96742, 108, '2015-03-15 00:33:38.000000', 'temperatura', 929.0000, 'ºC'),
	(96743, 108, '2015-03-15 00:33:39.000000', 'temperatura', 179.0000, 'ºC'),
	(96744, 108, '2015-03-15 00:33:40.000000', 'temperatura', 508.0000, 'ºC'),
	(96745, 108, '2015-03-15 00:33:41.000000', 'temperatura', 802.0000, 'ºC'),
	(96746, 108, '2015-03-15 00:33:42.000000', 'temperatura', 87.0000, 'ºC'),
	(96747, 108, '2015-03-15 00:33:43.000000', 'temperatura', 428.0000, 'ºC'),
	(96748, 108, '2015-03-15 00:33:44.000000', 'temperatura', 683.0000, 'ºC'),
	(96749, 108, '2015-03-15 00:33:45.000000', 'temperatura', 929.0000, 'ºC'),
	(96750, 108, '2015-03-15 00:33:46.000000', 'temperatura', 198.0000, 'ºC'),
	(96751, 108, '2015-03-15 00:33:47.000000', 'temperatura', 604.0000, 'ºC'),
	(96752, 108, '2015-03-15 00:33:48.000000', 'temperatura', 25.0000, 'ºC'),
	(96753, 108, '2015-03-15 00:33:49.000000', 'temperatura', 712.0000, 'ºC'),
	(96754, 108, '2015-03-15 00:33:50.000000', 'temperatura', 1088.0000, 'ºC'),
	(96755, 108, '2015-03-15 00:33:51.000000', 'temperatura', 905.0000, 'ºC'),
	(96756, 108, '2015-03-15 00:33:52.000000', 'temperatura', 61.0000, 'ºC'),
	(96757, 108, '2015-03-15 00:33:53.000000', 'temperatura', 1188.0000, 'ºC'),
	(96758, 108, '2015-03-15 00:33:54.000000', 'temperatura', 959.0000, 'ºC'),
	(96759, 108, '2015-03-15 00:33:55.000000', 'temperatura', 33.0000, 'ºC'),
	(96760, 108, '2015-03-15 00:33:56.000000', 'temperatura', 890.0000, 'ºC'),
	(96761, 108, '2015-03-15 00:33:57.000000', 'temperatura', 748.0000, 'ºC'),
	(96762, 108, '2015-03-15 00:33:58.000000', 'temperatura', 1071.0000, 'ºC'),
	(96763, 108, '2015-03-15 00:33:59.000000', 'temperatura', 713.0000, 'ºC'),
	(96764, 108, '2015-03-15 00:34:00.000000', 'temperatura', 350.0000, 'ºC'),
	(96765, 108, '2015-03-15 00:34:01.000000', 'temperatura', 812.0000, 'ºC'),
	(96766, 108, '2015-03-15 00:34:02.000000', 'temperatura', 610.0000, 'ºC'),
	(96767, 108, '2015-03-15 00:34:03.000000', 'temperatura', 616.0000, 'ºC'),
	(96768, 108, '2015-03-15 00:34:04.000000', 'temperatura', 48.0000, 'ºC'),
	(96769, 108, '2015-03-15 00:34:05.000000', 'temperatura', 794.0000, 'ºC'),
	(96770, 108, '2015-03-15 00:34:06.000000', 'temperatura', 226.0000, 'ºC'),
	(96771, 108, '2015-03-15 00:34:07.000000', 'temperatura', 1149.0000, 'ºC'),
	(96772, 108, '2015-03-15 00:34:08.000000', 'temperatura', 267.0000, 'ºC'),
	(96773, 108, '2015-03-15 00:34:09.000000', 'temperatura', 290.0000, 'ºC'),
	(96774, 108, '2015-03-15 00:34:10.000000', 'temperatura', 650.0000, 'ºC'),
	(96775, 108, '2015-03-15 00:34:11.000000', 'temperatura', 1181.0000, 'ºC'),
	(96776, 108, '2015-03-15 00:34:12.000000', 'temperatura', 356.0000, 'ºC'),
	(96777, 108, '2015-03-15 00:34:13.000000', 'temperatura', 636.0000, 'ºC'),
	(96778, 108, '2015-03-15 00:34:14.000000', 'temperatura', 913.0000, 'ºC'),
	(96779, 108, '2015-03-15 00:34:15.000000', 'temperatura', 258.0000, 'ºC'),
	(96780, 108, '2015-03-15 00:34:16.000000', 'temperatura', 950.0000, 'ºC'),
	(96781, 108, '2015-03-15 00:34:17.000000', 'temperatura', 376.0000, 'ºC'),
	(96782, 108, '2015-03-15 00:34:18.000000', 'temperatura', 231.0000, 'ºC'),
	(96783, 108, '2015-03-15 00:34:19.000000', 'temperatura', 30.0000, 'ºC'),
	(96784, 108, '2015-03-15 00:34:20.000000', 'temperatura', 655.0000, 'ºC'),
	(96785, 108, '2015-03-15 00:34:21.000000', 'temperatura', 787.0000, 'ºC'),
	(96786, 108, '2015-03-15 00:34:22.000000', 'temperatura', 770.0000, 'ºC'),
	(96787, 108, '2015-03-15 00:34:23.000000', 'temperatura', 288.0000, 'ºC'),
	(96788, 108, '2015-03-15 00:34:24.000000', 'temperatura', 332.0000, 'ºC'),
	(96789, 108, '2015-03-15 00:34:25.000000', 'temperatura', 795.0000, 'ºC'),
	(96790, 108, '2015-03-15 00:34:26.000000', 'temperatura', 582.0000, 'ºC'),
	(96791, 108, '2015-03-15 00:34:27.000000', 'temperatura', 524.0000, 'ºC'),
	(96792, 108, '2015-03-15 00:34:28.000000', 'temperatura', 876.0000, 'ºC'),
	(96793, 108, '2015-03-15 00:34:29.000000', 'temperatura', 406.0000, 'ºC'),
	(96794, 108, '2015-03-15 00:34:30.000000', 'temperatura', 602.0000, 'ºC'),
	(96795, 108, '2015-03-15 00:34:31.000000', 'temperatura', 592.0000, 'ºC'),
	(96796, 108, '2015-03-15 00:34:32.000000', 'temperatura', 1155.0000, 'ºC'),
	(96797, 108, '2015-03-15 00:34:33.000000', 'temperatura', 401.0000, 'ºC'),
	(96798, 108, '2015-03-15 00:34:34.000000', 'temperatura', 940.0000, 'ºC'),
	(96799, 108, '2015-03-15 00:34:35.000000', 'temperatura', 1096.0000, 'ºC'),
	(96800, 108, '2015-03-15 00:34:36.000000', 'temperatura', 262.0000, 'ºC'),
	(96801, 108, '2015-03-15 00:34:37.000000', 'temperatura', 420.0000, 'ºC'),
	(96802, 108, '2015-03-15 00:34:38.000000', 'temperatura', 118.0000, 'ºC'),
	(96803, 108, '2015-03-15 00:34:39.000000', 'temperatura', 528.0000, 'ºC'),
	(96804, 108, '2015-03-15 00:34:40.000000', 'temperatura', 1087.0000, 'ºC'),
	(96805, 108, '2015-03-15 00:34:41.000000', 'temperatura', 250.0000, 'ºC'),
	(96806, 108, '2015-03-15 00:34:42.000000', 'temperatura', 389.0000, 'ºC'),
	(96807, 108, '2015-03-15 00:34:43.000000', 'temperatura', 1197.0000, 'ºC'),
	(96808, 108, '2015-03-15 00:34:44.000000', 'temperatura', 18.0000, 'ºC'),
	(96809, 108, '2015-03-15 00:34:45.000000', 'temperatura', 98.0000, 'ºC'),
	(96810, 108, '2015-03-15 00:34:46.000000', 'temperatura', 438.0000, 'ºC'),
	(96811, 108, '2015-03-15 00:34:47.000000', 'temperatura', 697.0000, 'ºC'),
	(96812, 108, '2015-03-15 00:34:48.000000', 'temperatura', 970.0000, 'ºC'),
	(96813, 108, '2015-03-15 00:34:49.000000', 'temperatura', 359.0000, 'ºC'),
	(96814, 108, '2015-03-15 00:34:50.000000', 'temperatura', 87.0000, 'ºC'),
	(96815, 108, '2015-03-15 00:34:51.000000', 'temperatura', 558.0000, 'ºC'),
	(96816, 108, '2015-03-15 00:34:52.000000', 'temperatura', 128.0000, 'ºC'),
	(96817, 108, '2015-03-15 00:34:53.000000', 'temperatura', 168.0000, 'ºC'),
	(96818, 108, '2015-03-15 00:34:54.000000', 'temperatura', 457.0000, 'ºC'),
	(96819, 108, '2015-03-15 00:34:55.000000', 'temperatura', 581.0000, 'ºC'),
	(96820, 108, '2015-03-15 00:34:56.000000', 'temperatura', 335.0000, 'ºC'),
	(96821, 108, '2015-03-15 00:34:57.000000', 'temperatura', 1134.0000, 'ºC'),
	(96822, 108, '2015-03-15 00:34:58.000000', 'temperatura', 1063.0000, 'ºC'),
	(96823, 108, '2015-03-15 00:34:59.000000', 'temperatura', 716.0000, 'ºC'),
	(96824, 108, '2015-03-15 00:35:00.000000', 'temperatura', 390.0000, 'ºC'),
	(96825, 108, '2015-03-15 00:35:01.000000', 'temperatura', 1003.0000, 'ºC'),
	(96826, 108, '2015-03-15 00:35:02.000000', 'temperatura', 244.0000, 'ºC'),
	(96827, 108, '2015-03-15 00:35:03.000000', 'temperatura', 611.0000, 'ºC'),
	(96828, 108, '2015-03-15 00:35:04.000000', 'temperatura', 1126.0000, 'ºC'),
	(96829, 108, '2015-03-15 00:35:05.000000', 'temperatura', 195.0000, 'ºC'),
	(96830, 108, '2015-03-15 00:35:06.000000', 'temperatura', 1196.0000, 'ºC'),
	(96831, 108, '2015-03-15 00:35:07.000000', 'temperatura', 599.0000, 'ºC'),
	(96832, 108, '2015-03-15 00:35:08.000000', 'temperatura', 606.0000, 'ºC'),
	(96833, 108, '2015-03-15 00:35:09.000000', 'temperatura', 33.0000, 'ºC'),
	(96834, 108, '2015-03-15 00:35:10.000000', 'temperatura', 750.0000, 'ºC'),
	(96835, 108, '2015-03-15 00:35:11.000000', 'temperatura', 51.0000, 'ºC'),
	(96836, 108, '2015-03-15 00:35:12.000000', 'temperatura', 403.0000, 'ºC'),
	(96837, 108, '2015-03-15 00:35:13.000000', 'temperatura', 663.0000, 'ºC'),
	(96838, 108, '2015-03-15 00:35:14.000000', 'temperatura', 909.0000, 'ºC'),
	(96839, 108, '2015-03-15 00:35:15.000000', 'temperatura', 155.0000, 'ºC'),
	(96840, 108, '2015-03-15 00:35:16.000000', 'temperatura', 450.0000, 'ºC'),
	(96841, 108, '2015-03-15 00:35:17.000000', 'temperatura', 583.0000, 'ºC'),
	(96842, 108, '2015-03-15 00:35:18.000000', 'temperatura', 368.0000, 'ºC'),
	(96843, 108, '2015-03-15 00:35:19.000000', 'temperatura', 91.0000, 'ºC'),
	(96844, 108, '2015-03-15 00:35:20.000000', 'temperatura', 552.0000, 'ºC'),
	(96845, 108, '2015-03-15 00:35:21.000000', 'temperatura', 86.0000, 'ºC'),
	(96846, 108, '2015-03-15 00:35:22.000000', 'temperatura', 1176.0000, 'ºC'),
	(96847, 108, '2015-03-15 00:35:23.000000', 'temperatura', 820.0000, 'ºC'),
	(96848, 108, '2015-03-15 00:35:24.000000', 'temperatura', 574.0000, 'ºC'),
	(96849, 108, '2015-03-15 00:35:25.000000', 'temperatura', 412.0000, 'ºC'),
	(96850, 108, '2015-03-15 00:35:26.000000', 'temperatura', 338.0000, 'ºC'),
	(96851, 108, '2015-03-15 00:35:27.000000', 'temperatura', 454.0000, 'ºC'),
	(96852, 108, '2015-03-15 00:35:28.000000', 'temperatura', 56.0000, 'ºC'),
	(96853, 108, '2015-03-15 00:35:29.000000', 'temperatura', 117.0000, 'ºC'),
	(96854, 108, '2015-03-15 00:35:30.000000', 'temperatura', 421.0000, 'ºC'),
	(96855, 108, '2015-03-15 00:35:31.000000', 'temperatura', 552.0000, 'ºC'),
	(96856, 108, '2015-03-15 00:35:32.000000', 'temperatura', 298.0000, 'ºC'),
	(96857, 108, '2015-03-15 00:35:33.000000', 'temperatura', 1033.0000, 'ºC'),
	(96858, 108, '2015-03-15 00:35:34.000000', 'temperatura', 672.0000, 'ºC'),
	(96859, 108, '2015-03-15 00:35:35.000000', 'temperatura', 261.0000, 'ºC'),
	(96860, 108, '2015-03-15 00:35:36.000000', 'temperatura', 489.0000, 'ºC'),
	(96861, 108, '2015-03-15 00:35:37.000000', 'temperatura', 463.0000, 'ºC'),
	(96862, 108, '2015-03-15 00:35:38.000000', 'temperatura', 847.0000, 'ºC'),
	(96863, 108, '2015-03-15 00:35:39.000000', 'temperatura', 448.0000, 'ºC'),
	(96864, 108, '2015-03-15 00:35:40.000000', 'temperatura', 900.0000, 'ºC'),
	(96865, 108, '2015-03-15 00:35:41.000000', 'temperatura', 756.0000, 'ºC'),
	(96866, 108, '2015-03-15 00:35:42.000000', 'temperatura', 1079.0000, 'ºC'),
	(96867, 108, '2015-03-15 00:35:43.000000', 'temperatura', 729.0000, 'ºC'),
	(96868, 108, '2015-03-15 00:35:44.000000', 'temperatura', 408.0000, 'ºC'),
	(96869, 108, '2015-03-15 00:35:45.000000', 'temperatura', 1054.0000, 'ºC'),
	(96870, 108, '2015-03-15 00:35:46.000000', 'temperatura', 445.0000, 'ºC'),
	(96871, 108, '2015-03-15 00:35:47.000000', 'temperatura', 262.0000, 'ºC'),
	(96872, 108, '2015-03-15 00:35:48.000000', 'temperatura', 1178.0000, 'ºC'),
	(96873, 108, '2015-03-15 00:35:49.000000', 'temperatura', 305.0000, 'ºC'),
	(96874, 108, '2015-03-15 00:35:50.000000', 'temperatura', 393.0000, 'ºC'),
	(96875, 108, '2015-03-15 00:35:51.000000', 'temperatura', 1048.0000, 'ºC'),
	(96876, 108, '2015-03-15 00:35:52.000000', 'temperatura', 464.0000, 'ºC'),
	(96877, 108, '2015-03-15 00:35:53.000000', 'temperatura', 375.0000, 'ºC'),
	(96878, 108, '2015-03-15 00:35:54.000000', 'temperatura', 485.0000, 'ºC'),
	(96879, 108, '2015-03-15 00:35:55.000000', 'temperatura', 100.0000, 'ºC'),
	(96880, 108, '2015-03-15 00:35:56.000000', 'temperatura', 246.0000, 'ºC'),
	(96881, 108, '2015-03-15 00:35:57.000000', 'temperatura', 931.0000, 'ºC'),
	(96882, 108, '2015-03-15 00:35:58.000000', 'temperatura', 316.0000, 'ºC'),
	(96883, 108, '2015-03-15 00:35:59.000000', 'temperatura', 1189.0000, 'ºC'),
	(96884, 108, '2015-03-15 00:36:00.000000', 'temperatura', 197.0000, 'ºC'),
	(96885, 108, '2015-03-15 00:36:01.000000', 'temperatura', 1019.0000, 'ºC'),
	(96886, 108, '2015-03-15 00:36:02.000000', 'temperatura', 903.0000, 'ºC'),
	(96887, 108, '2015-03-15 00:36:03.000000', 'temperatura', 261.0000, 'ºC'),
	(96888, 108, '2015-03-15 00:36:04.000000', 'temperatura', 997.0000, 'ºC'),
	(96889, 108, '2015-03-15 00:36:05.000000', 'temperatura', 600.0000, 'ºC'),
	(96890, 108, '2015-03-15 00:36:06.000000', 'temperatura', 9.0000, 'ºC'),
	(96891, 108, '2015-03-15 00:36:07.000000', 'temperatura', 647.0000, 'ºC'),
	(96892, 108, '2015-03-15 00:36:08.000000', 'temperatura', 809.0000, 'ºC'),
	(96893, 108, '2015-03-15 00:36:09.000000', 'temperatura', 906.0000, 'ºC'),
	(96894, 108, '2015-03-15 00:36:10.000000', 'temperatura', 902.0000, 'ºC'),
	(96895, 108, '2015-03-15 00:36:11.000000', 'temperatura', 591.0000, 'ºC'),
	(96896, 108, '2015-03-15 00:36:12.000000', 'temperatura', 252.0000, 'ºC'),
	(96897, 108, '2015-03-15 00:36:13.000000', 'temperatura', 684.0000, 'ºC'),
	(96898, 108, '2015-03-15 00:36:14.000000', 'temperatura', 268.0000, 'ºC'),
	(96899, 108, '2015-03-15 00:36:15.000000', 'temperatura', 486.0000, 'ºC'),
	(96900, 108, '2015-03-15 00:36:16.000000', 'temperatura', 428.0000, 'ºC'),
	(96901, 108, '2015-03-15 00:36:17.000000', 'temperatura', 683.0000, 'ºC'),
	(96902, 108, '2015-03-15 00:36:18.000000', 'temperatura', 929.0000, 'ºC'),
	(96903, 108, '2015-03-15 00:36:19.000000', 'temperatura', 199.0000, 'ºC'),
	(96904, 108, '2015-03-15 00:36:20.000000', 'temperatura', 607.0000, 'ºC'),
	(96905, 108, '2015-03-15 00:36:21.000000', 'temperatura', 40.0000, 'ºC'),
	(96906, 108, '2015-03-15 00:36:22.000000', 'temperatura', 778.0000, 'ºC'),
	(96907, 108, '2015-03-15 00:36:23.000000', 'temperatura', 173.0000, 'ºC'),
	(96908, 108, '2015-03-15 00:36:24.000000', 'temperatura', 930.0000, 'ºC'),
	(96909, 108, '2015-03-15 00:36:25.000000', 'temperatura', 532.0000, 'ºC'),
	(96910, 108, '2015-03-15 00:36:26.000000', 'temperatura', 1071.0000, 'ºC'),
	(96911, 108, '2015-03-15 00:36:27.000000', 'temperatura', 159.0000, 'ºC'),
	(96912, 108, '2015-03-15 00:36:28.000000', 'temperatura', 1183.0000, 'ºC'),
	(96913, 108, '2015-03-15 00:36:29.000000', 'temperatura', 637.0000, 'ºC'),
	(96914, 108, '2015-03-15 00:36:30.000000', 'temperatura', 836.0000, 'ºC'),
	(96915, 108, '2015-03-15 00:36:31.000000', 'temperatura', 1070.0000, 'ºC'),
	(96916, 108, '2015-03-15 00:36:32.000000', 'temperatura', 443.0000, 'ºC'),
	(96917, 108, '2015-03-15 00:36:33.000000', 'temperatura', 203.0000, 'ºC'),
	(96918, 108, '2015-03-15 00:36:34.000000', 'temperatura', 889.0000, 'ºC'),
	(96919, 108, '2015-03-15 00:36:35.000000', 'temperatura', 238.0000, 'ºC'),
	(96920, 108, '2015-03-15 00:36:36.000000', 'temperatura', 922.0000, 'ºC'),
	(96921, 108, '2015-03-15 00:36:37.000000', 'temperatura', 295.0000, 'ºC'),
	(96922, 108, '2015-03-15 00:36:38.000000', 'temperatura', 1111.0000, 'ºC'),
	(96923, 108, '2015-03-15 00:36:39.000000', 'temperatura', 1071.0000, 'ºC'),
	(96924, 108, '2015-03-15 00:36:40.000000', 'temperatura', 824.0000, 'ºC'),
	(96925, 108, '2015-03-15 00:36:41.000000', 'temperatura', 905.0000, 'ºC'),
	(96926, 108, '2015-03-15 00:36:42.000000', 'temperatura', 855.0000, 'ºC'),
	(96927, 108, '2015-03-15 00:36:43.000000', 'temperatura', 360.0000, 'ºC'),
	(96928, 108, '2015-03-15 00:36:44.000000', 'temperatura', 437.0000, 'ºC'),
	(96929, 108, '2015-03-15 00:36:45.000000', 'temperatura', 1106.0000, 'ºC'),
	(96930, 108, '2015-03-15 00:36:46.000000', 'temperatura', 618.0000, 'ºC'),
	(96931, 108, '2015-03-15 00:36:47.000000', 'temperatura', 972.0000, 'ºC'),
	(96932, 108, '2015-03-15 00:36:48.000000', 'temperatura', 607.0000, 'ºC'),
	(96933, 108, '2015-03-15 00:36:49.000000', 'temperatura', 121.0000, 'ºC'),
	(96934, 108, '2015-03-15 00:36:50.000000', 'temperatura', 1184.0000, 'ºC'),
	(96935, 108, '2015-03-15 00:36:51.000000', 'temperatura', 757.0000, 'ºC'),
	(96936, 108, '2015-03-15 00:36:52.000000', 'temperatura', 232.0000, 'ºC'),
	(96937, 108, '2015-03-15 00:36:53.000000', 'temperatura', 90.0000, 'ºC'),
	(96938, 108, '2015-03-15 00:36:54.000000', 'temperatura', 956.0000, 'ºC'),
	(96939, 108, '2015-03-15 00:36:55.000000', 'temperatura', 912.0000, 'ºC'),
	(96940, 108, '2015-03-15 00:36:56.000000', 'temperatura', 490.0000, 'ºC'),
	(96941, 108, '2015-03-15 00:36:57.000000', 'temperatura', 916.0000, 'ºC'),
	(96942, 108, '2015-03-15 00:36:58.000000', 'temperatura', 710.0000, 'ºC'),
	(96943, 108, '2015-03-15 00:36:59.000000', 'temperatura', 805.0000, 'ºC'),
	(96944, 108, '2015-03-15 00:37:00.000000', 'temperatura', 692.0000, 'ºC'),
	(96945, 108, '2015-03-15 00:37:01.000000', 'temperatura', 1045.0000, 'ºC'),
	(96946, 108, '2015-03-15 00:37:02.000000', 'temperatura', 751.0000, 'ºC'),
	(96947, 108, '2015-03-15 00:37:03.000000', 'temperatura', 619.0000, 'ºC'),
	(96948, 108, '2015-03-15 00:37:04.000000', 'temperatura', 843.0000, 'ºC'),
	(96949, 108, '2015-03-15 00:37:05.000000', 'temperatura', 1159.0000, 'ºC'),
	(96950, 108, '2015-03-15 00:37:06.000000', 'temperatura', 866.0000, 'ºC'),
	(96951, 108, '2015-03-15 00:37:07.000000', 'temperatura', 853.0000, 'ºC'),
	(96952, 108, '2015-03-15 00:37:08.000000', 'temperatura', 467.0000, 'ºC'),
	(96953, 108, '2015-03-15 00:37:09.000000', 'temperatura', 978.0000, 'ºC'),
	(96954, 108, '2015-03-15 00:37:10.000000', 'temperatura', 1088.0000, 'ºC'),
	(96955, 108, '2015-03-15 00:37:11.000000', 'temperatura', 108.0000, 'ºC'),
	(96956, 108, '2015-03-15 00:37:12.000000', 'temperatura', 875.0000, 'ºC'),
	(96957, 108, '2015-03-15 00:37:13.000000', 'temperatura', 452.0000, 'ºC'),
	(96958, 108, '2015-03-15 00:37:14.000000', 'temperatura', 834.0000, 'ºC'),
	(96959, 108, '2015-03-15 00:37:15.000000', 'temperatura', 417.0000, 'ºC'),
	(96960, 108, '2015-03-15 00:37:16.000000', 'temperatura', 781.0000, 'ºC'),
	(96961, 108, '2015-03-15 00:37:17.000000', 'temperatura', 256.0000, 'ºC'),
	(96962, 108, '2015-03-15 00:37:18.000000', 'temperatura', 136.0000, 'ºC'),
	(96963, 108, '2015-03-15 00:37:19.000000', 'temperatura', 1114.0000, 'ºC'),
	(96964, 108, '2015-03-15 00:37:20.000000', 'temperatura', 364.0000, 'ºC'),
	(96965, 108, '2015-03-15 00:37:21.000000', 'temperatura', 878.0000, 'ºC'),
	(96966, 108, '2015-03-15 00:37:22.000000', 'temperatura', 897.0000, 'ºC'),
	(96967, 108, '2015-03-15 00:37:23.000000', 'temperatura', 651.0000, 'ºC'),
	(96968, 108, '2015-03-15 00:37:24.000000', 'temperatura', 565.0000, 'ºC'),
	(96969, 108, '2015-03-15 00:37:25.000000', 'temperatura', 873.0000, 'ºC'),
	(96970, 108, '2015-03-15 00:37:26.000000', 'temperatura', 272.0000, 'ºC'),
	(96971, 108, '2015-03-15 00:37:27.000000', 'temperatura', 1142.0000, 'ºC'),
	(96972, 108, '2015-03-15 00:37:28.000000', 'temperatura', 92.0000, 'ºC'),
	(96973, 108, '2015-03-15 00:37:29.000000', 'temperatura', 636.0000, 'ºC'),
	(96974, 108, '2015-03-15 00:37:30.000000', 'temperatura', 504.0000, 'ºC'),
	(96975, 108, '2015-03-15 00:37:31.000000', 'temperatura', 614.0000, 'ºC'),
	(96976, 108, '2015-03-15 00:37:32.000000', 'temperatura', 356.0000, 'ºC'),
	(96977, 108, '2015-03-15 00:37:33.000000', 'temperatura', 1139.0000, 'ºC'),
	(96978, 108, '2015-03-15 00:37:34.000000', 'temperatura', 1026.0000, 'ºC'),
	(96979, 108, '2015-03-15 00:37:35.000000', 'temperatura', 516.0000, 'ºC'),
	(96980, 108, '2015-03-15 00:37:36.000000', 'temperatura', 703.0000, 'ºC'),
	(96981, 108, '2015-03-15 00:37:37.000000', 'temperatura', 765.0000, 'ºC'),
	(96982, 108, '2015-03-15 00:37:38.000000', 'temperatura', 517.0000, 'ºC'),
	(96983, 108, '2015-03-15 00:37:39.000000', 'temperatura', 290.0000, 'ºC'),
	(96984, 108, '2015-03-15 00:37:40.000000', 'temperatura', 1098.0000, 'ºC'),
	(96985, 108, '2015-03-15 00:37:41.000000', 'temperatura', 1022.0000, 'ºC'),
	(96986, 108, '2015-03-15 00:37:42.000000', 'temperatura', 617.0000, 'ºC'),
	(96987, 108, '2015-03-15 00:37:43.000000', 'temperatura', 20.0000, 'ºC'),
	(96988, 108, '2015-03-15 00:37:44.000000', 'temperatura', 650.0000, 'ºC'),
	(96989, 108, '2015-03-15 00:37:45.000000', 'temperatura', 790.0000, 'ºC'),
	(96990, 108, '2015-03-15 00:37:46.000000', 'temperatura', 802.0000, 'ºC'),
	(96991, 108, '2015-03-15 00:37:47.000000', 'temperatura', 440.0000, 'ºC'),
	(96992, 108, '2015-03-15 00:37:48.000000', 'temperatura', 994.0000, 'ºC'),
	(96993, 108, '2015-03-15 00:37:49.000000', 'temperatura', 51.0000, 'ºC'),
	(96994, 108, '2015-03-15 00:37:50.000000', 'temperatura', 873.0000, 'ºC'),
	(96995, 108, '2015-03-15 00:37:51.000000', 'temperatura', 614.0000, 'ºC'),
	(96996, 108, '2015-03-15 00:37:52.000000', 'temperatura', 449.0000, 'ºC'),
	(96997, 108, '2015-03-15 00:37:53.000000', 'temperatura', 406.0000, 'ºC'),
	(96998, 108, '2015-03-15 00:37:54.000000', 'temperatura', 683.0000, 'ºC'),
	(96999, 108, '2015-03-15 00:37:55.000000', 'temperatura', 999.0000, 'ºC'),
	(97000, 108, '2015-03-15 00:37:56.000000', 'temperatura', 544.0000, 'ºC'),
	(97001, 108, '2015-03-15 00:37:57.000000', 'temperatura', 924.0000, 'ºC'),
	(97002, 108, '2015-03-15 00:37:58.000000', 'temperatura', 588.0000, 'ºC'),
	(97003, 108, '2015-03-15 00:37:59.000000', 'temperatura', 171.0000, 'ºC'),
	(97004, 108, '2015-03-15 00:38:00.000000', 'temperatura', 289.0000, 'ºC'),
	(97005, 108, '2015-03-15 00:38:01.000000', 'temperatura', 932.0000, 'ºC'),
	(97006, 108, '2015-03-15 00:38:02.000000', 'temperatura', 197.0000, 'ºC'),
	(97007, 108, '2015-03-15 00:38:03.000000', 'temperatura', 586.0000, 'ºC'),
	(97008, 108, '2015-03-15 00:38:04.000000', 'temperatura', 1139.0000, 'ºC'),
	(97009, 108, '2015-03-15 00:38:05.000000', 'temperatura', 340.0000, 'ºC'),
	(97010, 108, '2015-03-15 00:38:06.000000', 'temperatura', 681.0000, 'ºC'),
	(97011, 108, '2015-03-15 00:38:07.000000', 'temperatura', 1185.0000, 'ºC'),
	(97012, 108, '2015-03-15 00:38:08.000000', 'temperatura', 285.0000, 'ºC'),
	(97013, 108, '2015-03-15 00:38:09.000000', 'temperatura', 269.0000, 'ºC'),
	(97014, 108, '2015-03-15 00:38:10.000000', 'temperatura', 492.0000, 'ºC'),
	(97015, 108, '2015-03-15 00:38:11.000000', 'temperatura', 454.0000, 'ºC'),
	(97016, 108, '2015-03-15 00:38:12.000000', 'temperatura', 795.0000, 'ºC'),
	(97017, 108, '2015-03-15 00:38:13.000000', 'temperatura', 214.0000, 'ºC'),
	(97018, 108, '2015-03-15 00:38:14.000000', 'temperatura', 1083.0000, 'ºC'),
	(97019, 108, '2015-03-15 00:38:15.000000', 'temperatura', 1176.0000, 'ºC'),
	(97020, 108, '2015-03-15 00:38:16.000000', 'temperatura', 232.0000, 'ºC'),
	(97021, 108, '2015-03-15 00:38:17.000000', 'temperatura', 30.0000, 'ºC'),
	(97022, 108, '2015-03-15 00:38:18.000000', 'temperatura', 654.0000, 'ºC'),
	(97023, 108, '2015-03-15 00:38:19.000000', 'temperatura', 783.0000, 'ºC'),
	(97024, 108, '2015-03-15 00:38:20.000000', 'temperatura', 752.0000, 'ºC'),
	(97025, 108, '2015-03-15 00:38:21.000000', 'temperatura', 210.0000, 'ºC'),
	(97026, 108, '2015-03-15 00:38:22.000000', 'temperatura', 1197.0000, 'ºC'),
	(97027, 108, '2015-03-15 00:38:23.000000', 'temperatura', 555.0000, 'ºC'),
	(97028, 108, '2015-03-15 00:38:24.000000', 'temperatura', 386.0000, 'ºC'),
	(97029, 108, '2015-03-15 00:38:25.000000', 'temperatura', 263.0000, 'ºC'),
	(97030, 108, '2015-03-15 00:38:26.000000', 'temperatura', 158.0000, 'ºC'),
	(97031, 108, '2015-03-15 00:38:27.000000', 'temperatura', 3.0000, 'ºC'),
	(97032, 108, '2015-03-15 00:38:28.000000', 'temperatura', 743.0000, 'ºC'),
	(97033, 108, '2015-03-15 00:38:29.000000', 'temperatura', 103.0000, 'ºC'),
	(97034, 108, '2015-03-15 00:38:30.000000', 'temperatura', 687.0000, 'ºC'),
	(97035, 108, '2015-03-15 00:38:31.000000', 'temperatura', 729.0000, 'ºC'),
	(97036, 108, '2015-03-15 00:38:32.000000', 'temperatura', 383.0000, 'ºC'),
	(97037, 108, '2015-03-15 00:38:33.000000', 'temperatura', 927.0000, 'ºC'),
	(97038, 108, '2015-03-15 00:38:34.000000', 'temperatura', 1086.0000, 'ºC'),
	(97039, 108, '2015-03-15 00:38:35.000000', 'temperatura', 249.0000, 'ºC'),
	(97040, 108, '2015-03-15 00:38:36.000000', 'temperatura', 389.0000, 'ºC'),
	(97041, 108, '2015-03-15 00:38:37.000000', 'temperatura', 1199.0000, 'ºC'),
	(97042, 108, '2015-03-15 00:38:38.000000', 'temperatura', 30.0000, 'ºC'),
	(97043, 108, '2015-03-15 00:38:39.000000', 'temperatura', 152.0000, 'ºC'),
	(97044, 108, '2015-03-15 00:38:40.000000', 'temperatura', 669.0000, 'ºC'),
	(97045, 108, '2015-03-15 00:38:41.000000', 'temperatura', 489.0000, 'ºC'),
	(97046, 108, '2015-03-15 00:38:42.000000', 'temperatura', 439.0000, 'ºC'),
	(97047, 108, '2015-03-15 00:38:43.000000', 'temperatura', 727.0000, 'ºC'),
	(97048, 108, '2015-03-15 00:38:44.000000', 'temperatura', 1122.0000, 'ºC'),
	(97049, 108, '2015-03-15 00:38:45.000000', 'temperatura', 1027.0000, 'ºC'),
	(97050, 108, '2015-03-15 00:38:46.000000', 'temperatura', 568.0000, 'ºC'),
	(97051, 108, '2015-03-15 00:38:47.000000', 'temperatura', 962.0000, 'ºC'),
	(97052, 108, '2015-03-15 00:38:48.000000', 'temperatura', 705.0000, 'ºC'),
	(97053, 108, '2015-03-15 00:38:49.000000', 'temperatura', 642.0000, 'ºC'),
	(97054, 108, '2015-03-15 00:38:50.000000', 'temperatura', 1095.0000, 'ºC'),
	(97055, 108, '2015-03-15 00:38:51.000000', 'temperatura', 1147.0000, 'ºC'),
	(97056, 108, '2015-03-15 00:38:52.000000', 'temperatura', 53.0000, 'ºC'),
	(97057, 108, '2015-03-15 00:38:53.000000', 'temperatura', 423.0000, 'ºC'),
	(97058, 108, '2015-03-15 00:38:54.000000', 'temperatura', 757.0000, 'ºC'),
	(97059, 108, '2015-03-15 00:38:55.000000', 'temperatura', 118.0000, 'ºC'),
	(97060, 108, '2015-03-15 00:38:56.000000', 'temperatura', 718.0000, 'ºC'),
	(97061, 108, '2015-03-15 00:38:57.000000', 'temperatura', 837.0000, 'ºC'),
	(97062, 108, '2015-03-15 00:38:58.000000', 'temperatura', 830.0000, 'ºC'),
	(97063, 108, '2015-03-15 00:38:59.000000', 'temperatura', 440.0000, 'ºC'),
	(97064, 108, '2015-03-15 00:39:00.000000', 'temperatura', 909.0000, 'ºC'),
	(97065, 108, '2015-03-15 00:39:01.000000', 'temperatura', 828.0000, 'ºC'),
	(97066, 108, '2015-03-15 00:39:02.000000', 'temperatura', 214.0000, 'ºC'),
	(97067, 108, '2015-03-15 00:39:03.000000', 'temperatura', 986.0000, 'ºC'),
	(97068, 108, '2015-03-15 00:39:04.000000', 'temperatura', 689.0000, 'ºC'),
	(97069, 108, '2015-03-15 00:39:05.000000', 'temperatura', 487.0000, 'ºC'),
	(97070, 108, '2015-03-15 00:39:06.000000', 'temperatura', 371.0000, 'ºC'),
	(97071, 108, '2015-03-15 00:39:07.000000', 'temperatura', 391.0000, 'ºC'),
	(97072, 108, '2015-03-15 00:39:08.000000', 'temperatura', 843.0000, 'ºC'),
	(97073, 108, '2015-03-15 00:39:09.000000', 'temperatura', 643.0000, 'ºC'),
	(97074, 108, '2015-03-15 00:39:10.000000', 'temperatura', 688.0000, 'ºC'),
	(97075, 108, '2015-03-15 00:39:11.000000', 'temperatura', 311.0000, 'ºC'),
	(97076, 108, '2015-03-15 00:39:12.000000', 'temperatura', 692.0000, 'ºC'),
	(97077, 108, '2015-03-15 00:39:13.000000', 'temperatura', 125.0000, 'ºC'),
	(97078, 108, '2015-03-15 00:39:14.000000', 'temperatura', 951.0000, 'ºC'),
	(97079, 108, '2015-03-15 00:39:15.000000', 'temperatura', 781.0000, 'ºC'),
	(97080, 108, '2015-03-15 00:39:16.000000', 'temperatura', 1052.0000, 'ºC'),
	(97081, 108, '2015-03-15 00:39:17.000000', 'temperatura', 518.0000, 'ºC'),
	(97082, 108, '2015-03-15 00:39:18.000000', 'temperatura', 635.0000, 'ºC'),
	(97083, 108, '2015-03-15 00:39:19.000000', 'temperatura', 423.0000, 'ºC'),
	(97084, 108, '2015-03-15 00:39:20.000000', 'temperatura', 209.0000, 'ºC'),
	(97085, 108, '2015-03-15 00:39:21.000000', 'temperatura', 976.0000, 'ºC'),
	(97086, 108, '2015-03-15 00:39:22.000000', 'temperatura', 653.0000, 'ºC'),
	(97087, 108, '2015-03-15 00:39:23.000000', 'temperatura', 336.0000, 'ºC'),
	(97088, 108, '2015-03-15 00:39:24.000000', 'temperatura', 923.0000, 'ºC'),
	(97089, 108, '2015-03-15 00:39:25.000000', 'temperatura', 8.0000, 'ºC'),
	(97090, 108, '2015-03-15 00:39:26.000000', 'temperatura', 873.0000, 'ºC'),
	(97091, 108, '2015-03-15 00:39:27.000000', 'temperatura', 740.0000, 'ºC'),
	(97092, 108, '2015-03-15 00:39:28.000000', 'temperatura', 1083.0000, 'ºC'),
	(97093, 108, '2015-03-15 00:39:29.000000', 'temperatura', 794.0000, 'ºC'),
	(97094, 108, '2015-03-15 00:39:30.000000', 'temperatura', 721.0000, 'ºC'),
	(97095, 108, '2015-03-15 00:39:31.000000', 'temperatura', 22.0000, 'ºC'),
	(97096, 108, '2015-03-15 00:39:32.000000', 'temperatura', 350.0000, 'ºC'),
	(97097, 108, '2015-03-15 00:39:33.000000', 'temperatura', 482.0000, 'ºC'),
	(97098, 108, '2015-03-15 00:39:34.000000', 'temperatura', 163.0000, 'ºC'),
	(97099, 108, '2015-03-15 00:39:35.000000', 'temperatura', 569.0000, 'ºC'),
	(97100, 108, '2015-03-15 00:39:36.000000', 'temperatura', 1156.0000, 'ºC'),
	(97101, 108, '2015-03-15 00:39:37.000000', 'temperatura', 475.0000, 'ºC'),
	(97102, 108, '2015-03-15 00:39:38.000000', 'temperatura', 108.0000, 'ºC'),
	(97103, 108, '2015-03-15 00:39:39.000000', 'temperatura', 315.0000, 'ºC'),
	(97104, 108, '2015-03-15 00:39:40.000000', 'temperatura', 52.0000, 'ºC'),
	(97105, 108, '2015-03-15 00:39:41.000000', 'temperatura', 517.0000, 'ºC'),
	(97106, 108, '2015-03-15 00:39:42.000000', 'temperatura', 27.0000, 'ºC'),
	(97107, 108, '2015-03-15 00:39:43.000000', 'temperatura', 985.0000, 'ºC'),
	(97108, 108, '2015-03-15 00:39:44.000000', 'temperatura', 45.0000, 'ºC'),
	(97109, 108, '2015-03-15 00:39:45.000000', 'temperatura', 870.0000, 'ºC'),
	(97110, 108, '2015-03-15 00:39:46.000000', 'temperatura', 617.0000, 'ºC'),
	(97111, 108, '2015-03-15 00:39:47.000000', 'temperatura', 474.0000, 'ºC'),
	(97112, 108, '2015-03-15 00:39:48.000000', 'temperatura', 518.0000, 'ºC'),
	(97113, 108, '2015-03-15 00:39:49.000000', 'temperatura', 1169.0000, 'ºC'),
	(97114, 108, '2015-03-15 00:39:50.000000', 'temperatura', 692.0000, 'ºC'),
	(97115, 108, '2015-03-15 00:39:51.000000', 'temperatura', 1154.0000, 'ºC'),
	(97116, 108, '2015-03-15 00:39:52.000000', 'temperatura', 93.0000, 'ºC'),
	(97117, 108, '2015-03-15 00:39:53.000000', 'temperatura', 606.0000, 'ºC'),
	(97118, 108, '2015-03-15 00:39:54.000000', 'temperatura', 350.0000, 'ºC'),
	(97119, 108, '2015-03-15 00:39:55.000000', 'temperatura', 1131.0000, 'ºC'),
	(97120, 108, '2015-03-15 00:39:56.000000', 'temperatura', 1008.0000, 'ºC'),
	(97121, 108, '2015-03-15 00:39:57.000000', 'temperatura', 446.0000, 'ºC'),
	(97122, 108, '2015-03-15 00:39:58.000000', 'temperatura', 407.0000, 'ºC'),
	(97123, 108, '2015-03-15 00:39:59.000000', 'temperatura', 697.0000, 'ºC'),
	(97124, 108, '2015-03-15 00:40:00.000000', 'temperatura', 1067.0000, 'ºC'),
	(97125, 108, '2015-03-15 00:40:01.000000', 'temperatura', 842.0000, 'ºC'),
	(97126, 108, '2015-03-15 00:40:02.000000', 'temperatura', 1009.0000, 'ºC'),
	(97127, 108, '2015-03-15 00:40:03.000000', 'temperatura', 121.0000, 'ºC'),
	(97128, 108, '2015-03-15 00:40:04.000000', 'temperatura', 1177.0000, 'ºC'),
	(97129, 108, '2015-03-15 00:40:05.000000', 'temperatura', 721.0000, 'ºC'),
	(97130, 108, '2015-03-15 00:40:06.000000', 'temperatura', 77.0000, 'ºC'),
	(97131, 108, '2015-03-15 00:40:07.000000', 'temperatura', 624.0000, 'ºC'),
	(97132, 108, '2015-03-15 00:40:08.000000', 'temperatura', 487.0000, 'ºC'),
	(97133, 108, '2015-03-15 00:40:09.000000', 'temperatura', 565.0000, 'ºC'),
	(97134, 108, '2015-03-15 00:40:10.000000', 'temperatura', 163.0000, 'ºC'),
	(97135, 108, '2015-03-15 00:40:11.000000', 'temperatura', 323.0000, 'ºC'),
	(97136, 108, '2015-03-15 00:40:12.000000', 'temperatura', 1126.0000, 'ºC'),
	(97137, 108, '2015-03-15 00:40:13.000000', 'temperatura', 1062.0000, 'ºC'),
	(97138, 108, '2015-03-15 00:40:14.000000', 'temperatura', 732.0000, 'ºC'),
	(97139, 108, '2015-03-15 00:40:15.000000', 'temperatura', 476.0000, 'ºC'),
	(97140, 108, '2015-03-15 00:40:16.000000', 'temperatura', 184.0000, 'ºC'),
	(97141, 108, '2015-03-15 00:40:17.000000', 'temperatura', 693.0000, 'ºC'),
	(97142, 108, '2015-03-15 00:40:18.000000', 'temperatura', 514.0000, 'ºC'),
	(97143, 108, '2015-03-15 00:40:19.000000', 'temperatura', 489.0000, 'ºC'),
	(97144, 108, '2015-03-15 00:40:20.000000', 'temperatura', 903.0000, 'ºC'),
	(97145, 108, '2015-03-15 00:40:21.000000', 'temperatura', 652.0000, 'ºC'),
	(97146, 108, '2015-03-15 00:40:22.000000', 'temperatura', 549.0000, 'ºC'),
	(97147, 108, '2015-03-15 00:40:23.000000', 'temperatura', 790.0000, 'ºC'),
	(97148, 108, '2015-03-15 00:40:24.000000', 'temperatura', 1104.0000, 'ºC'),
	(97149, 108, '2015-03-15 00:40:25.000000', 'temperatura', 751.0000, 'ºC'),
	(97150, 108, '2015-03-15 00:40:26.000000', 'temperatura', 442.0000, 'ºC'),
	(97151, 108, '2015-03-15 00:40:27.000000', 'temperatura', 1157.0000, 'ºC'),
	(97152, 108, '2015-03-15 00:40:28.000000', 'temperatura', 859.0000, 'ºC'),
	(97153, 108, '2015-03-15 00:40:29.000000', 'temperatura', 826.0000, 'ºC'),
	(97154, 108, '2015-03-15 00:40:30.000000', 'temperatura', 354.0000, 'ºC'),
	(97155, 108, '2015-03-15 00:40:31.000000', 'temperatura', 491.0000, 'ºC'),
	(97156, 108, '2015-03-15 00:40:32.000000', 'temperatura', 194.0000, 'ºC'),
	(97157, 108, '2015-03-15 00:40:33.000000', 'temperatura', 698.0000, 'ºC'),
	(97158, 108, '2015-03-15 00:40:34.000000', 'temperatura', 510.0000, 'ºC'),
	(97159, 108, '2015-03-15 00:40:35.000000', 'temperatura', 453.0000, 'ºC'),
	(97160, 108, '2015-03-15 00:40:36.000000', 'temperatura', 739.0000, 'ºC'),
	(97161, 108, '2015-03-15 00:40:37.000000', 'temperatura', 1134.0000, 'ºC'),
	(97162, 108, '2015-03-15 00:40:38.000000', 'temperatura', 1053.0000, 'ºC'),
	(97163, 108, '2015-03-15 00:40:39.000000', 'temperatura', 664.0000, 'ºC'),
	(97164, 108, '2015-03-15 00:40:40.000000', 'temperatura', 160.0000, 'ºC'),
	(97165, 108, '2015-03-15 00:40:41.000000', 'temperatura', 9.0000, 'ºC'),
	(97166, 108, '2015-03-15 00:40:42.000000', 'temperatura', 766.0000, 'ºC'),
	(97167, 108, '2015-03-15 00:40:43.000000', 'temperatura', 206.0000, 'ºC'),
	(97168, 108, '2015-03-15 00:40:44.000000', 'temperatura', 1129.0000, 'ºC'),
	(97169, 108, '2015-03-15 00:40:45.000000', 'temperatura', 229.0000, 'ºC'),
	(97170, 108, '2015-03-15 00:40:46.000000', 'temperatura', 159.0000, 'ºC'),
	(97171, 108, '2015-03-15 00:40:47.000000', 'temperatura', 106.0000, 'ºC'),
	(97172, 108, '2015-03-15 00:40:48.000000', 'temperatura', 57.0000, 'ºC'),
	(97173, 108, '2015-03-15 00:40:49.000000', 'temperatura', 1164.0000, 'ºC'),
	(97174, 108, '2015-03-15 00:40:50.000000', 'temperatura', 852.0000, 'ºC'),
	(97175, 108, '2015-03-15 00:40:51.000000', 'temperatura', 769.0000, 'ºC'),
	(97176, 108, '2015-03-15 00:40:52.000000', 'temperatura', 88.0000, 'ºC'),
	(97177, 108, '2015-03-15 00:40:53.000000', 'temperatura', 532.0000, 'ºC'),
	(97178, 108, '2015-03-15 00:40:54.000000', 'temperatura', 1198.0000, 'ºC'),
	(97179, 108, '2015-03-15 00:40:55.000000', 'temperatura', 795.0000, 'ºC'),
	(97180, 108, '2015-03-15 00:40:56.000000', 'temperatura', 382.0000, 'ºC'),
	(97181, 108, '2015-03-15 00:40:57.000000', 'temperatura', 725.0000, 'ºC'),
	(97182, 108, '2015-03-15 00:40:58.000000', 'temperatura', 80.0000, 'ºC'),
	(97183, 108, '2015-03-15 00:40:59.000000', 'temperatura', 625.0000, 'ºC'),
	(97184, 108, '2015-03-15 00:41:00.000000', 'temperatura', 486.0000, 'ºC'),
	(97185, 108, '2015-03-15 00:41:01.000000', 'temperatura', 557.0000, 'ºC'),
	(97186, 108, '2015-03-15 00:41:02.000000', 'temperatura', 125.0000, 'ºC'),
	(97187, 108, '2015-03-15 00:41:03.000000', 'temperatura', 156.0000, 'ºC'),
	(97188, 108, '2015-03-15 00:41:04.000000', 'temperatura', 406.0000, 'ºC'),
	(97189, 108, '2015-03-15 00:41:05.000000', 'temperatura', 361.0000, 'ºC'),
	(97190, 108, '2015-03-15 00:41:06.000000', 'temperatura', 587.0000, 'ºC'),
	(97191, 108, '2015-03-15 00:41:07.000000', 'temperatura', 652.0000, 'ºC'),
	(97192, 108, '2015-03-15 00:41:08.000000', 'temperatura', 301.0000, 'ºC'),
	(97193, 108, '2015-03-15 00:41:09.000000', 'temperatura', 751.0000, 'ºC'),
	(97194, 108, '2015-03-15 00:41:10.000000', 'temperatura', 451.0000, 'ºC'),
	(97195, 108, '2015-03-15 00:41:11.000000', 'temperatura', 3.0000, 'ºC'),
	(97196, 108, '2015-03-15 00:41:12.000000', 'temperatura', 1060.0000, 'ºC'),
	(97197, 108, '2015-03-15 00:41:13.000000', 'temperatura', 494.0000, 'ºC'),
	(97198, 108, '2015-03-15 00:41:14.000000', 'temperatura', 490.0000, 'ºC'),
	(97199, 108, '2015-03-15 00:41:15.000000', 'temperatura', 968.0000, 'ºC'),
	(97200, 108, '2015-03-15 00:41:16.000000', 'temperatura', 971.0000, 'ºC'),
	(97201, 108, '2015-03-15 00:41:17.000000', 'temperatura', 749.0000, 'ºC'),
	(97202, 108, '2015-03-15 00:41:18.000000', 'temperatura', 835.0000, 'ºC'),
	(97203, 108, '2015-03-15 00:41:19.000000', 'temperatura', 729.0000, 'ºC'),
	(97204, 108, '2015-03-15 00:41:20.000000', 'temperatura', 1141.0000, 'ºC'),
	(97205, 108, '2015-03-15 00:41:21.000000', 'temperatura', 1117.0000, 'ºC'),
	(97206, 108, '2015-03-15 00:41:22.000000', 'temperatura', 965.0000, 'ºC'),
	(97207, 108, '2015-03-15 00:41:23.000000', 'temperatura', 273.0000, 'ºC'),
	(97208, 108, '2015-03-15 00:41:24.000000', 'temperatura', 869.0000, 'ºC'),
	(97209, 108, '2015-03-15 00:41:25.000000', 'temperatura', 1127.0000, 'ºC'),
	(97210, 108, '2015-03-15 00:41:26.000000', 'temperatura', 629.0000, 'ºC'),
	(97211, 108, '2015-03-15 00:41:27.000000', 'temperatura', 963.0000, 'ºC'),
	(97212, 108, '2015-03-15 00:41:28.000000', 'temperatura', 528.0000, 'ºC'),
	(97213, 108, '2015-03-15 00:41:29.000000', 'temperatura', 954.0000, 'ºC'),
	(97214, 108, '2015-03-15 00:41:30.000000', 'temperatura', 785.0000, 'ºC'),
	(97215, 108, '2015-03-15 00:41:31.000000', 'temperatura', 1066.0000, 'ºC'),
	(97216, 108, '2015-03-15 00:41:32.000000', 'temperatura', 574.0000, 'ºC'),
	(97217, 108, '2015-03-15 00:41:33.000000', 'temperatura', 870.0000, 'ºC'),
	(97218, 108, '2015-03-15 00:41:34.000000', 'temperatura', 232.0000, 'ºC'),
	(97219, 108, '2015-03-15 00:41:35.000000', 'temperatura', 949.0000, 'ºC'),
	(97220, 108, '2015-03-15 00:41:36.000000', 'temperatura', 450.0000, 'ºC'),
	(97221, 108, '2015-03-15 00:41:37.000000', 'temperatura', 603.0000, 'ºC'),
	(97222, 108, '2015-03-15 00:41:38.000000', 'temperatura', 464.0000, 'ºC'),
	(97223, 108, '2015-03-15 00:41:39.000000', 'temperatura', 512.0000, 'ºC'),
	(97224, 108, '2015-03-15 00:41:40.000000', 'temperatura', 1168.0000, 'ºC'),
	(97225, 108, '2015-03-15 00:41:41.000000', 'temperatura', 703.0000, 'ºC'),
	(97226, 108, '2015-03-15 00:41:42.000000', 'temperatura', 14.0000, 'ºC'),
	(97227, 108, '2015-03-15 00:41:43.000000', 'temperatura', 360.0000, 'ºC'),
	(97228, 108, '2015-03-15 00:41:44.000000', 'temperatura', 559.0000, 'ºC'),
	(97229, 108, '2015-03-15 00:41:45.000000', 'temperatura', 514.0000, 'ºC'),
	(97230, 108, '2015-03-15 00:41:46.000000', 'temperatura', 896.0000, 'ºC'),
	(97231, 108, '2015-03-15 00:41:47.000000', 'temperatura', 536.0000, 'ºC'),
	(97232, 108, '2015-03-15 00:41:48.000000', 'temperatura', 1192.0000, 'ºC'),
	(97233, 108, '2015-03-15 00:41:49.000000', 'temperatura', 753.0000, 'ºC'),
	(97234, 108, '2015-03-15 00:41:50.000000', 'temperatura', 191.0000, 'ºC'),
	(97235, 108, '2015-03-15 00:41:51.000000', 'temperatura', 1094.0000, 'ºC'),
	(97236, 108, '2015-03-15 00:41:52.000000', 'temperatura', 98.0000, 'ºC'),
	(97237, 108, '2015-03-15 00:41:53.000000', 'temperatura', 809.0000, 'ºC'),
	(97238, 108, '2015-03-15 00:41:54.000000', 'temperatura', 150.0000, 'ºC'),
	(97239, 108, '2015-03-15 00:41:55.000000', 'temperatura', 726.0000, 'ºC'),
	(97240, 108, '2015-03-15 00:41:56.000000', 'temperatura', 779.0000, 'ºC'),
	(97241, 108, '2015-03-15 00:41:57.000000', 'temperatura', 518.0000, 'ºC'),
	(97242, 108, '2015-03-15 00:41:58.000000', 'temperatura', 252.0000, 'ºC'),
	(97243, 108, '2015-03-15 00:41:59.000000', 'temperatura', 907.0000, 'ºC'),
	(97244, 108, '2015-03-15 00:42:00.000000', 'temperatura', 181.0000, 'ºC'),
	(97245, 108, '2015-03-15 00:42:01.000000', 'temperatura', 582.0000, 'ºC'),
	(97246, 108, '2015-03-15 00:42:02.000000', 'temperatura', 1170.0000, 'ºC'),
	(97247, 108, '2015-03-15 00:42:03.000000', 'temperatura', 505.0000, 'ºC'),
	(97248, 108, '2015-03-15 00:42:04.000000', 'temperatura', 214.0000, 'ºC'),
	(97249, 108, '2015-03-15 00:42:05.000000', 'temperatura', 757.0000, 'ºC'),
	(97250, 108, '2015-03-15 00:42:06.000000', 'temperatura', 743.0000, 'ºC'),
	(97251, 108, '2015-03-15 00:42:07.000000', 'temperatura', 244.0000, 'ºC'),
	(97252, 108, '2015-03-15 00:42:08.000000', 'temperatura', 193.0000, 'ºC'),
	(97253, 108, '2015-03-15 00:42:09.000000', 'temperatura', 233.0000, 'ºC'),
	(97254, 108, '2015-03-15 00:42:10.000000', 'temperatura', 586.0000, 'ºC'),
	(97255, 108, '2015-03-15 00:42:11.000000', 'temperatura', 1032.0000, 'ºC'),
	(97256, 108, '2015-03-15 00:42:12.000000', 'temperatura', 1004.0000, 'ºC'),
	(97257, 108, '2015-03-15 00:42:13.000000', 'temperatura', 722.0000, 'ºC'),
	(97258, 108, '2015-03-15 00:42:14.000000', 'temperatura', 600.0000, 'ºC'),
	(97259, 108, '2015-03-15 00:42:15.000000', 'temperatura', 836.0000, 'ºC'),
	(97260, 108, '2015-03-15 00:42:16.000000', 'temperatura', 1179.0000, 'ºC'),
	(97261, 108, '2015-03-15 00:42:17.000000', 'temperatura', 988.0000, 'ºC'),
	(97262, 108, '2015-03-15 00:42:18.000000', 'temperatura', 202.0000, 'ºC'),
	(97263, 108, '2015-03-15 00:42:19.000000', 'temperatura', 447.0000, 'ºC'),
	(97264, 108, '2015-03-15 00:42:20.000000', 'temperatura', 431.0000, 'ºC'),
	(97265, 108, '2015-03-15 00:42:21.000000', 'temperatura', 812.0000, 'ºC'),
	(97266, 108, '2015-03-15 00:42:22.000000', 'temperatura', 371.0000, 'ºC'),
	(97267, 108, '2015-03-15 00:42:23.000000', 'temperatura', 616.0000, 'ºC'),
	(97268, 108, '2015-03-15 00:42:24.000000', 'temperatura', 770.0000, 'ºC'),
	(97269, 108, '2015-03-15 00:42:25.000000', 'temperatura', 801.0000, 'ºC'),
	(97270, 108, '2015-03-15 00:42:26.000000', 'temperatura', 497.0000, 'ºC'),
	(97271, 108, '2015-03-15 00:42:27.000000', 'temperatura', 80.0000, 'ºC'),
	(97272, 108, '2015-03-15 00:42:28.000000', 'temperatura', 111.0000, 'ºC'),
	(97273, 108, '2015-03-15 00:42:29.000000', 'temperatura', 316.0000, 'ºC'),
	(97274, 108, '2015-03-15 00:42:30.000000', 'temperatura', 47.0000, 'ºC'),
	(97275, 108, '2015-03-15 00:42:31.000000', 'temperatura', 488.0000, 'ºC'),
	(97276, 108, '2015-03-15 00:42:32.000000', 'temperatura', 1098.0000, 'ºC'),
	(97277, 108, '2015-03-15 00:42:33.000000', 'temperatura', 426.0000, 'ºC'),
	(97278, 108, '2015-03-15 00:42:34.000000', 'temperatura', 38.0000, 'ºC'),
	(97279, 108, '2015-03-15 00:42:35.000000', 'temperatura', 111.0000, 'ºC'),
	(97280, 108, '2015-03-15 00:42:36.000000', 'temperatura', 441.0000, 'ºC'),
	(97281, 108, '2015-03-15 00:42:37.000000', 'temperatura', 673.0000, 'ºC'),
	(97282, 108, '2015-03-15 00:42:38.000000', 'temperatura', 841.0000, 'ºC'),
	(97283, 108, '2015-03-15 00:42:39.000000', 'temperatura', 987.0000, 'ºC'),
	(97284, 108, '2015-03-15 00:42:40.000000', 'temperatura', 13.0000, 'ºC'),
	(97285, 108, '2015-03-15 00:42:41.000000', 'temperatura', 703.0000, 'ºC'),
	(97286, 108, '2015-03-15 00:42:42.000000', 'temperatura', 1077.0000, 'ºC'),
	(97287, 108, '2015-03-15 00:42:43.000000', 'temperatura', 877.0000, 'ºC'),
	(97288, 108, '2015-03-15 00:42:44.000000', 'temperatura', 1155.0000, 'ºC'),
	(97289, 108, '2015-03-15 00:42:45.000000', 'temperatura', 746.0000, 'ºC'),
	(97290, 108, '2015-03-15 00:42:46.000000', 'temperatura', 263.0000, 'ºC'),
	(97291, 108, '2015-03-15 00:42:47.000000', 'temperatura', 278.0000, 'ºC'),
	(97292, 108, '2015-03-15 00:42:48.000000', 'temperatura', 602.0000, 'ºC'),
	(97293, 108, '2015-03-15 00:42:49.000000', 'temperatura', 974.0000, 'ºC'),
	(97294, 108, '2015-03-15 00:42:50.000000', 'temperatura', 667.0000, 'ºC'),
	(97295, 108, '2015-03-15 00:42:51.000000', 'temperatura', 414.0000, 'ºC'),
	(97296, 108, '2015-03-15 00:42:52.000000', 'temperatura', 69.0000, 'ºC'),
	(97297, 108, '2015-03-15 00:42:53.000000', 'temperatura', 303.0000, 'ºC'),
	(97298, 108, '2015-03-15 00:42:54.000000', 'temperatura', 110.0000, 'ºC'),
	(97299, 108, '2015-03-15 00:42:55.000000', 'temperatura', 841.0000, 'ºC'),
	(97300, 108, '2015-03-15 00:42:56.000000', 'temperatura', 276.0000, 'ºC'),
	(97301, 108, '2015-03-15 00:42:57.000000', 'temperatura', 57.0000, 'ºC'),
	(97302, 108, '2015-03-15 00:42:58.000000', 'temperatura', 657.0000, 'ºC'),
	(97303, 108, '2015-03-15 00:42:59.000000', 'temperatura', 717.0000, 'ºC'),
	(97304, 108, '2015-03-15 00:43:00.000000', 'temperatura', 413.0000, 'ºC'),
	(97305, 108, '2015-03-15 00:43:01.000000', 'temperatura', 1114.0000, 'ºC'),
	(97306, 108, '2015-03-15 00:43:02.000000', 'temperatura', 732.0000, 'ºC'),
	(97307, 108, '2015-03-15 00:43:03.000000', 'temperatura', 318.0000, 'ºC'),
	(97308, 108, '2015-03-15 00:43:04.000000', 'temperatura', 597.0000, 'ºC'),
	(97309, 108, '2015-03-15 00:43:05.000000', 'temperatura', 829.0000, 'ºC'),
	(97310, 108, '2015-03-15 00:43:06.000000', 'temperatura', 1155.0000, 'ºC'),
	(97311, 108, '2015-03-15 00:43:07.000000', 'temperatura', 887.0000, 'ºC'),
	(97312, 108, '2015-03-15 00:43:08.000000', 'temperatura', 972.0000, 'ºC'),
	(97313, 108, '2015-03-15 00:43:09.000000', 'temperatura', 998.0000, 'ºC'),
	(97314, 108, '2015-03-15 00:43:10.000000', 'temperatura', 877.0000, 'ºC'),
	(97315, 108, '2015-03-15 00:43:11.000000', 'temperatura', 192.0000, 'ºC'),
	(97316, 108, '2015-03-15 00:43:12.000000', 'temperatura', 727.0000, 'ºC'),
	(97317, 108, '2015-03-15 00:43:13.000000', 'temperatura', 663.0000, 'ºC'),
	(97318, 108, '2015-03-15 00:43:14.000000', 'temperatura', 1131.0000, 'ºC'),
	(97319, 108, '2015-03-15 00:43:15.000000', 'temperatura', 67.0000, 'ºC'),
	(97320, 108, '2015-03-15 00:43:16.000000', 'temperatura', 543.0000, 'ºC'),
	(97321, 108, '2015-03-15 00:43:17.000000', 'temperatura', 116.0000, 'ºC'),
	(97322, 108, '2015-03-15 00:43:18.000000', 'temperatura', 152.0000, 'ºC'),
	(97323, 108, '2015-03-15 00:43:19.000000', 'temperatura', 413.0000, 'ºC'),
	(97324, 108, '2015-03-15 00:43:20.000000', 'temperatura', 410.0000, 'ºC'),
	(97325, 108, '2015-03-15 00:43:21.000000', 'temperatura', 812.0000, 'ºC'),
	(97326, 108, '2015-03-15 00:43:22.000000', 'temperatura', 431.0000, 'ºC'),
	(97327, 108, '2015-03-15 00:43:23.000000', 'temperatura', 919.0000, 'ºC'),
	(97328, 108, '2015-03-15 00:43:24.000000', 'temperatura', 903.0000, 'ºC'),
	(97329, 108, '2015-03-15 00:43:25.000000', 'temperatura', 558.0000, 'ºC'),
	(97330, 108, '2015-03-15 00:43:26.000000', 'temperatura', 79.0000, 'ºC'),
	(97331, 108, '2015-03-15 00:43:27.000000', 'temperatura', 1125.0000, 'ºC'),
	(97332, 108, '2015-03-15 00:43:28.000000', 'temperatura', 586.0000, 'ºC'),
	(97333, 108, '2015-03-15 00:43:29.000000', 'temperatura', 755.0000, 'ºC'),
	(97334, 108, '2015-03-15 00:43:30.000000', 'temperatura', 819.0000, 'ºC'),
	(97335, 108, '2015-03-15 00:43:31.000000', 'temperatura', 629.0000, 'ºC'),
	(97336, 108, '2015-03-15 00:43:32.000000', 'temperatura', 688.0000, 'ºC'),
	(97337, 108, '2015-03-15 00:43:33.000000', 'temperatura', 355.0000, 'ºC'),
	(97338, 108, '2015-03-15 00:43:34.000000', 'temperatura', 913.0000, 'ºC'),
	(97339, 108, '2015-03-15 00:43:35.000000', 'temperatura', 1097.0000, 'ºC'),
	(97340, 108, '2015-03-15 00:43:36.000000', 'temperatura', 349.0000, 'ºC'),
	(97341, 108, '2015-03-15 00:43:37.000000', 'temperatura', 853.0000, 'ºC'),
	(97342, 108, '2015-03-15 00:43:38.000000', 'temperatura', 819.0000, 'ºC'),
	(97343, 108, '2015-03-15 00:43:39.000000', 'temperatura', 336.0000, 'ºC'),
	(97344, 108, '2015-03-15 00:43:40.000000', 'temperatura', 425.0000, 'ºC'),
	(97345, 108, '2015-03-15 00:43:41.000000', 'temperatura', 1117.0000, 'ºC'),
	(97346, 108, '2015-03-15 00:43:42.000000', 'temperatura', 710.0000, 'ºC'),
	(97347, 108, '2015-03-15 00:43:43.000000', 'temperatura', 201.0000, 'ºC'),
	(97348, 108, '2015-03-15 00:43:44.000000', 'temperatura', 75.0000, 'ºC'),
	(97349, 108, '2015-03-15 00:43:45.000000', 'temperatura', 973.0000, 'ºC'),
	(97350, 108, '2015-03-15 00:43:46.000000', 'temperatura', 1040.0000, 'ºC'),
	(97351, 108, '2015-03-15 00:43:47.000000', 'temperatura', 1082.0000, 'ºC'),
	(97352, 108, '2015-03-15 00:43:48.000000', 'temperatura', 1089.0000, 'ºC'),
	(97353, 108, '2015-03-15 00:43:49.000000', 'temperatura', 1000.0000, 'ºC'),
	(97354, 108, '2015-03-15 00:43:50.000000', 'temperatura', 535.0000, 'ºC'),
	(97355, 108, '2015-03-15 00:43:51.000000', 'temperatura', 876.0000, 'ºC'),
	(97356, 108, '2015-03-15 00:43:52.000000', 'temperatura', 376.0000, 'ºC'),
	(97357, 108, '2015-03-15 00:43:53.000000', 'temperatura', 452.0000, 'ºC'),
	(97358, 108, '2015-03-15 00:43:54.000000', 'temperatura', 1131.0000, 'ºC'),
	(97359, 108, '2015-03-15 00:43:55.000000', 'temperatura', 701.0000, 'ºC'),
	(97360, 108, '2015-03-15 00:43:56.000000', 'temperatura', 112.0000, 'ºC'),
	(97361, 108, '2015-03-15 00:43:57.000000', 'temperatura', 858.0000, 'ºC'),
	(97362, 108, '2015-03-15 00:43:58.000000', 'temperatura', 353.0000, 'ºC'),
	(97363, 108, '2015-03-15 00:43:59.000000', 'temperatura', 391.0000, 'ºC'),
	(97364, 108, '2015-03-15 00:44:00.000000', 'temperatura', 897.0000, 'ºC'),
	(97365, 108, '2015-03-15 00:44:01.000000', 'temperatura', 912.0000, 'ºC'),
	(97366, 108, '2015-03-15 00:44:02.000000', 'temperatura', 668.0000, 'ºC'),
	(97367, 108, '2015-03-15 00:44:03.000000', 'temperatura', 608.0000, 'ºC'),
	(97368, 108, '2015-03-15 00:44:04.000000', 'temperatura', 1035.0000, 'ºC'),
	(97369, 108, '2015-03-15 00:44:05.000000', 'temperatura', 950.0000, 'ºC'),
	(97370, 108, '2015-03-15 00:44:06.000000', 'temperatura', 446.0000, 'ºC'),
	(97371, 108, '2015-03-15 00:44:07.000000', 'temperatura', 580.0000, 'ºC'),
	(97372, 108, '2015-03-15 00:44:08.000000', 'temperatura', 364.0000, 'ºC'),
	(97373, 108, '2015-03-15 00:44:09.000000', 'temperatura', 82.0000, 'ºC'),
	(97374, 108, '2015-03-15 00:44:10.000000', 'temperatura', 515.0000, 'ºC'),
	(97375, 108, '2015-03-15 00:44:11.000000', 'temperatura', 1132.0000, 'ºC'),
	(97376, 108, '2015-03-15 00:44:12.000000', 'temperatura', 514.0000, 'ºC'),
	(97377, 108, '2015-03-15 00:44:13.000000', 'temperatura', 377.0000, 'ºC'),
	(97378, 108, '2015-03-15 00:44:14.000000', 'temperatura', 340.0000, 'ºC'),
	(97379, 108, '2015-03-15 00:44:15.000000', 'temperatura', 572.0000, 'ºC'),
	(97380, 108, '2015-03-15 00:44:16.000000', 'temperatura', 642.0000, 'ºC'),
	(97381, 108, '2015-03-15 00:44:17.000000', 'temperatura', 292.0000, 'ºC'),
	(97382, 108, '2015-03-15 00:44:18.000000', 'temperatura', 736.0000, 'ºC'),
	(97383, 108, '2015-03-15 00:44:19.000000', 'temperatura', 405.0000, 'ºC'),
	(97384, 108, '2015-03-15 00:44:20.000000', 'temperatura', 1016.0000, 'ºC'),
	(97385, 108, '2015-03-15 00:44:21.000000', 'temperatura', 265.0000, 'ºC'),
	(97386, 108, '2015-03-15 00:44:22.000000', 'temperatura', 680.0000, 'ºC'),
	(97387, 108, '2015-03-15 00:44:23.000000', 'temperatura', 203.0000, 'ºC'),
	(97388, 108, '2015-03-15 00:44:24.000000', 'temperatura', 175.0000, 'ºC'),
	(97389, 108, '2015-03-15 00:44:25.000000', 'temperatura', 267.0000, 'ºC'),
	(97390, 108, '2015-03-15 00:44:26.000000', 'temperatura', 809.0000, 'ºC'),
	(97391, 108, '2015-03-15 00:44:27.000000', 'temperatura', 847.0000, 'ºC'),
	(97392, 108, '2015-03-15 00:44:28.000000', 'temperatura', 607.0000, 'ºC'),
	(97393, 108, '2015-03-15 00:44:29.000000', 'temperatura', 494.0000, 'ºC'),
	(97394, 108, '2015-03-15 00:44:30.000000', 'temperatura', 648.0000, 'ºC'),
	(97395, 108, '2015-03-15 00:44:31.000000', 'temperatura', 560.0000, 'ºC'),
	(97396, 108, '2015-03-15 00:44:32.000000', 'temperatura', 858.0000, 'ºC'),
	(97397, 108, '2015-03-15 00:44:33.000000', 'temperatura', 208.0000, 'ºC'),
	(97398, 108, '2015-03-15 00:44:34.000000', 'temperatura', 868.0000, 'ºC'),
	(97399, 108, '2015-03-15 00:44:35.000000', 'temperatura', 115.0000, 'ºC'),
	(97400, 108, '2015-03-15 00:44:36.000000', 'temperatura', 371.0000, 'ºC'),
	(97401, 108, '2015-03-15 00:44:37.000000', 'temperatura', 312.0000, 'ºC'),
	(97402, 108, '2015-03-15 00:44:38.000000', 'temperatura', 449.0000, 'ºC'),
	(97403, 108, '2015-03-15 00:44:39.000000', 'temperatura', 108.0000, 'ºC'),
	(97404, 108, '2015-03-15 00:44:40.000000', 'temperatura', 395.0000, 'ºC'),
	(97405, 108, '2015-03-15 00:44:41.000000', 'temperatura', 450.0000, 'ºC'),
	(97406, 108, '2015-03-15 00:44:42.000000', 'temperatura', 1067.0000, 'ºC'),
	(97407, 108, '2015-03-15 00:44:43.000000', 'temperatura', 387.0000, 'ºC'),
	(97408, 108, '2015-03-15 00:44:44.000000', 'temperatura', 1131.0000, 'ºC'),
	(97409, 108, '2015-03-15 00:44:45.000000', 'temperatura', 898.0000, 'ºC'),
	(97410, 108, '2015-03-15 00:44:46.000000', 'temperatura', 1094.0000, 'ºC'),
	(97411, 108, '2015-03-15 00:44:47.000000', 'temperatura', 378.0000, 'ºC'),
	(97412, 108, '2015-03-15 00:44:48.000000', 'temperatura', 1009.0000, 'ºC'),
	(97413, 108, '2015-03-15 00:44:49.000000', 'temperatura', 311.0000, 'ºC'),
	(97414, 108, '2015-03-15 00:44:50.000000', 'temperatura', 929.0000, 'ºC'),
	(97415, 108, '2015-03-15 00:44:51.000000', 'temperatura', 111.0000, 'ºC'),
	(97416, 108, '2015-03-15 00:44:52.000000', 'temperatura', 169.0000, 'ºC'),
	(97417, 108, '2015-03-15 00:44:53.000000', 'temperatura', 512.0000, 'ºC'),
	(97418, 108, '2015-03-15 00:44:54.000000', 'temperatura', 854.0000, 'ºC'),
	(97419, 108, '2015-03-15 00:44:55.000000', 'temperatura', 333.0000, 'ºC'),
	(97420, 108, '2015-03-15 00:44:56.000000', 'temperatura', 304.0000, 'ºC'),
	(97421, 108, '2015-03-15 00:44:57.000000', 'temperatura', 520.0000, 'ºC'),
	(97422, 108, '2015-03-15 00:44:58.000000', 'temperatura', 491.0000, 'ºC'),
	(97423, 108, '2015-03-15 00:44:59.000000', 'temperatura', 894.0000, 'ºC'),
	(97424, 108, '2015-03-15 00:45:00.000000', 'temperatura', 599.0000, 'ºC'),
	(97425, 108, '2015-03-15 00:45:01.000000', 'temperatura', 312.0000, 'ºC'),
	(97426, 108, '2015-03-15 00:45:02.000000', 'temperatura', 966.0000, 'ºC'),
	(97427, 108, '2015-03-15 00:45:03.000000', 'temperatura', 292.0000, 'ºC'),
	(97428, 108, '2015-03-15 00:45:04.000000', 'temperatura', 961.0000, 'ºC'),
	(97429, 108, '2015-03-15 00:45:05.000000', 'temperatura', 333.0000, 'ºC'),
	(97430, 108, '2015-03-15 00:45:06.000000', 'temperatura', 1180.0000, 'ºC'),
	(97431, 108, '2015-03-15 00:45:07.000000', 'temperatura', 103.0000, 'ºC'),
	(97432, 108, '2015-03-15 00:45:08.000000', 'temperatura', 576.0000, 'ºC'),
	(97433, 108, '2015-03-15 00:45:09.000000', 'temperatura', 171.0000, 'ºC'),
	(97434, 108, '2015-03-15 00:45:10.000000', 'temperatura', 327.0000, 'ºC'),
	(97435, 108, '2015-03-15 00:45:11.000000', 'temperatura', 1122.0000, 'ºC'),
	(97436, 108, '2015-03-15 00:45:12.000000', 'temperatura', 1031.0000, 'ºC'),
	(97437, 108, '2015-03-15 00:45:13.000000', 'temperatura', 587.0000, 'ºC'),
	(97438, 108, '2015-03-15 00:45:14.000000', 'temperatura', 1043.0000, 'ºC'),
	(97439, 108, '2015-03-15 00:45:15.000000', 'temperatura', 1055.0000, 'ºC'),
	(97440, 108, '2015-03-15 00:45:16.000000', 'temperatura', 946.0000, 'ºC'),
	(97441, 108, '2015-03-15 00:45:17.000000', 'temperatura', 367.0000, 'ºC'),
	(97442, 108, '2015-03-15 00:45:18.000000', 'temperatura', 195.0000, 'ºC'),
	(97443, 108, '2015-03-15 00:45:19.000000', 'temperatura', 1076.0000, 'ºC'),
	(97444, 108, '2015-03-15 00:45:20.000000', 'temperatura', 1196.0000, 'ºC'),
	(97445, 108, '2015-03-15 00:45:21.000000', 'temperatura', 351.0000, 'ºC'),
	(97446, 108, '2015-03-15 00:45:22.000000', 'temperatura', 568.0000, 'ºC'),
	(97447, 108, '2015-03-15 00:45:23.000000', 'temperatura', 588.0000, 'ºC'),
	(97448, 108, '2015-03-15 00:45:24.000000', 'temperatura', 36.0000, 'ºC'),
	(97449, 108, '2015-03-15 00:45:25.000000', 'temperatura', 817.0000, 'ºC'),
	(97450, 108, '2015-03-15 00:45:26.000000', 'temperatura', 375.0000, 'ºC'),
	(97451, 108, '2015-03-15 00:45:27.000000', 'temperatura', 628.0000, 'ºC'),
	(97452, 108, '2015-03-15 00:45:28.000000', 'temperatura', 813.0000, 'ºC'),
	(97453, 108, '2015-03-15 00:45:29.000000', 'temperatura', 984.0000, 'ºC'),
	(97454, 108, '2015-03-15 00:45:30.000000', 'temperatura', 81.0000, 'ºC'),
	(97455, 108, '2015-03-15 00:45:31.000000', 'temperatura', 1054.0000, 'ºC'),
	(97456, 108, '2015-03-15 00:45:32.000000', 'temperatura', 228.0000, 'ºC'),
	(97457, 108, '2015-03-15 00:45:33.000000', 'temperatura', 378.0000, 'ºC'),
	(97458, 108, '2015-03-15 00:45:34.000000', 'temperatura', 6.0000, 'ºC'),
	(97459, 108, '2015-03-15 00:45:35.000000', 'temperatura', 98.0000, 'ºC'),
	(97460, 108, '2015-03-15 00:45:36.000000', 'temperatura', 471.0000, 'ºC'),
	(97461, 108, '2015-03-15 00:45:37.000000', 'temperatura', 863.0000, 'ºC'),
	(97462, 108, '2015-03-15 00:45:38.000000', 'temperatura', 502.0000, 'ºC'),
	(97463, 108, '2015-03-15 00:45:39.000000', 'temperatura', 1121.0000, 'ºC'),
	(97464, 108, '2015-03-15 00:45:40.000000', 'temperatura', 500.0000, 'ºC'),
	(97465, 108, '2015-03-15 00:45:41.000000', 'temperatura', 336.0000, 'ºC'),
	(97466, 108, '2015-03-15 00:45:42.000000', 'temperatura', 183.0000, 'ºC'),
	(97467, 108, '2015-03-15 00:45:43.000000', 'temperatura', 1106.0000, 'ºC'),
	(97468, 108, '2015-03-15 00:45:44.000000', 'temperatura', 184.0000, 'ºC'),
	(97469, 108, '2015-03-15 00:45:45.000000', 'temperatura', 0.0000, 'ºC'),
	(97470, 108, '2015-03-15 00:45:46.000000', 'temperatura', 647.0000, 'ºC'),
	(97471, 108, '2015-03-15 00:45:47.000000', 'temperatura', 838.0000, 'ºC'),
	(97472, 108, '2015-03-15 00:45:48.000000', 'temperatura', 1048.0000, 'ºC'),
	(97473, 108, '2015-03-15 00:45:49.000000', 'temperatura', 325.0000, 'ºC'),
	(97474, 108, '2015-03-15 00:45:50.000000', 'temperatura', 885.0000, 'ºC'),
	(97475, 108, '2015-03-15 00:45:51.000000', 'temperatura', 1047.0000, 'ºC'),
	(97476, 108, '2015-03-15 00:45:52.000000', 'temperatura', 182.0000, 'ºC'),
	(97477, 108, '2015-03-15 00:45:53.000000', 'temperatura', 171.0000, 'ºC'),
	(97478, 108, '2015-03-15 00:45:54.000000', 'temperatura', 307.0000, 'ºC'),
	(97479, 108, '2015-03-15 00:45:55.000000', 'temperatura', 1025.0000, 'ºC'),
	(97480, 108, '2015-03-15 00:45:56.000000', 'temperatura', 605.0000, 'ºC'),
	(97481, 108, '2015-03-15 00:45:57.000000', 'temperatura', 1148.0000, 'ºC'),
	(97482, 108, '2015-03-15 00:45:58.000000', 'temperatura', 326.0000, 'ºC'),
	(97483, 108, '2015-03-15 00:45:59.000000', 'temperatura', 586.0000, 'ºC'),
	(97484, 108, '2015-03-15 00:46:00.000000', 'temperatura', 752.0000, 'ºC'),
	(97485, 108, '2015-03-15 00:46:01.000000', 'temperatura', 805.0000, 'ºC'),
	(97486, 108, '2015-03-15 00:46:02.000000', 'temperatura', 570.0000, 'ºC'),
	(97487, 108, '2015-03-15 00:46:03.000000', 'temperatura', 432.0000, 'ºC'),
	(97488, 108, '2015-03-15 00:46:04.000000', 'temperatura', 453.0000, 'ºC'),
	(97489, 108, '2015-03-15 00:46:05.000000', 'temperatura', 968.0000, 'ºC'),
	(97490, 108, '2015-03-15 00:46:06.000000', 'temperatura', 1083.0000, 'ºC'),
	(97491, 108, '2015-03-15 00:46:07.000000', 'temperatura', 112.0000, 'ºC'),
	(97492, 108, '2015-03-15 00:46:08.000000', 'temperatura', 910.0000, 'ºC'),
	(97493, 108, '2015-03-15 00:46:09.000000', 'temperatura', 616.0000, 'ºC'),
	(97494, 108, '2015-03-15 00:46:10.000000', 'temperatura', 348.0000, 'ºC'),
	(97495, 108, '2015-03-15 00:46:11.000000', 'temperatura', 1093.0000, 'ºC'),
	(97496, 108, '2015-03-15 00:46:12.000000', 'temperatura', 823.0000, 'ºC'),
	(97497, 108, '2015-03-15 00:46:13.000000', 'temperatura', 837.0000, 'ºC'),
	(97498, 108, '2015-03-15 00:46:14.000000', 'temperatura', 517.0000, 'ºC'),
	(97499, 108, '2015-03-15 00:46:15.000000', 'temperatura', 72.0000, 'ºC'),
	(97500, 108, '2015-03-15 00:46:16.000000', 'temperatura', 10.0000, 'ºC'),
	(97501, 108, '2015-03-15 00:46:17.000000', 'temperatura', 1034.0000, 'ºC'),
	(97502, 108, '2015-03-15 00:46:18.000000', 'temperatura', 342.0000, 'ºC'),
	(97503, 108, '2015-03-15 00:46:19.000000', 'temperatura', 1008.0000, 'ºC'),
	(97504, 108, '2015-03-15 00:46:20.000000', 'temperatura', 413.0000, 'ºC'),
	(97505, 108, '2015-03-15 00:46:21.000000', 'temperatura', 243.0000, 'ºC'),
	(97506, 108, '2015-03-15 00:46:22.000000', 'temperatura', 1178.0000, 'ºC'),
	(97507, 108, '2015-03-15 00:46:23.000000', 'temperatura', 360.0000, 'ºC'),
	(97508, 108, '2015-03-15 00:46:24.000000', 'temperatura', 665.0000, 'ºC'),
	(97509, 108, '2015-03-15 00:46:25.000000', 'temperatura', 1047.0000, 'ºC'),
	(97510, 108, '2015-03-15 00:46:26.000000', 'temperatura', 842.0000, 'ºC'),
	(97511, 108, '2015-03-15 00:46:27.000000', 'temperatura', 1066.0000, 'ºC'),
	(97512, 108, '2015-03-15 00:46:28.000000', 'temperatura', 408.0000, 'ºC'),
	(97513, 108, '2015-03-15 00:46:29.000000', 'temperatura', 40.0000, 'ºC'),
	(97514, 108, '2015-03-15 00:46:30.000000', 'temperatura', 179.0000, 'ºC'),
	(97515, 108, '2015-03-15 00:46:31.000000', 'temperatura', 775.0000, 'ºC'),
	(97516, 108, '2015-03-15 00:46:32.000000', 'temperatura', 936.0000, 'ºC'),
	(97517, 108, '2015-03-15 00:46:33.000000', 'temperatura', 1159.0000, 'ºC'),
	(97518, 108, '2015-03-15 00:46:34.000000', 'temperatura', 586.0000, 'ºC'),
	(97519, 108, '2015-03-15 00:46:35.000000', 'temperatura', 655.0000, 'ºC'),
	(97520, 108, '2015-03-15 00:46:36.000000', 'temperatura', 316.0000, 'ºC'),
	(97521, 108, '2015-03-15 00:46:37.000000', 'temperatura', 814.0000, 'ºC'),
	(97522, 108, '2015-03-15 00:46:38.000000', 'temperatura', 724.0000, 'ºC'),
	(97523, 108, '2015-03-15 00:46:39.000000', 'temperatura', 1180.0000, 'ºC'),
	(97524, 108, '2015-03-15 00:46:40.000000', 'temperatura', 127.0000, 'ºC'),
	(97525, 108, '2015-03-15 00:46:41.000000', 'temperatura', 697.0000, 'ºC'),
	(97526, 108, '2015-03-15 00:46:42.000000', 'temperatura', 702.0000, 'ºC'),
	(97527, 108, '2015-03-15 00:46:43.000000', 'temperatura', 219.0000, 'ºC'),
	(97528, 108, '2015-03-15 00:46:44.000000', 'temperatura', 192.0000, 'ºC'),
	(97529, 108, '2015-03-15 00:46:45.000000', 'temperatura', 302.0000, 'ºC'),
	(97530, 108, '2015-03-15 00:46:46.000000', 'temperatura', 936.0000, 'ºC'),
	(97531, 108, '2015-03-15 00:46:47.000000', 'temperatura', 174.0000, 'ºC'),
	(97532, 108, '2015-03-15 00:46:48.000000', 'temperatura', 464.0000, 'ºC'),
	(97533, 108, '2015-03-15 00:46:49.000000', 'temperatura', 599.0000, 'ºC'),
	(97534, 108, '2015-03-15 00:46:50.000000', 'temperatura', 403.0000, 'ºC'),
	(97535, 108, '2015-03-15 00:46:51.000000', 'temperatura', 220.0000, 'ºC'),
	(97536, 108, '2015-03-15 00:46:52.000000', 'temperatura', 1089.0000, 'ºC'),
	(97537, 108, '2015-03-15 00:46:53.000000', 'temperatura', 1187.0000, 'ºC'),
	(97538, 108, '2015-03-15 00:46:54.000000', 'temperatura', 270.0000, 'ºC'),
	(97539, 108, '2015-03-15 00:46:55.000000', 'temperatura', 186.0000, 'ºC'),
	(97540, 108, '2015-03-15 00:46:56.000000', 'temperatura', 122.0000, 'ºC'),
	(97541, 108, '2015-03-15 00:46:57.000000', 'temperatura', 52.0000, 'ºC'),
	(97542, 108, '2015-03-15 00:46:58.000000', 'temperatura', 1094.0000, 'ºC'),
	(97543, 108, '2015-03-15 00:46:59.000000', 'temperatura', 517.0000, 'ºC'),
	(97544, 108, '2015-03-15 00:47:00.000000', 'temperatura', 501.0000, 'ºC'),
	(97545, 108, '2015-03-15 00:47:01.000000', 'temperatura', 957.0000, 'ºC'),
	(97546, 108, '2015-03-15 00:47:02.000000', 'temperatura', 883.0000, 'ºC'),
	(97547, 108, '2015-03-15 00:47:03.000000', 'temperatura', 344.0000, 'ºC'),
	(97548, 108, '2015-03-15 00:47:04.000000', 'temperatura', 269.0000, 'ºC'),
	(97549, 108, '2015-03-15 00:47:05.000000', 'temperatura', 315.0000, 'ºC'),
	(97550, 108, '2015-03-15 00:47:06.000000', 'temperatura', 770.0000, 'ºC'),
	(97551, 108, '2015-03-15 00:47:07.000000', 'temperatura', 505.0000, 'ºC'),
	(97552, 108, '2015-03-15 00:47:08.000000', 'temperatura', 213.0000, 'ºC'),
	(97553, 108, '2015-03-15 00:47:09.000000', 'temperatura', 753.0000, 'ºC'),
	(97554, 108, '2015-03-15 00:47:10.000000', 'temperatura', 727.0000, 'ºC'),
	(97555, 108, '2015-03-15 00:47:11.000000', 'temperatura', 175.0000, 'ºC'),
	(97556, 108, '2015-03-15 00:47:12.000000', 'temperatura', 1094.0000, 'ºC'),
	(97557, 108, '2015-03-15 00:47:13.000000', 'temperatura', 147.0000, 'ºC'),
	(97558, 108, '2015-03-15 00:47:14.000000', 'temperatura', 1052.0000, 'ºC'),
	(97559, 108, '2015-03-15 00:47:15.000000', 'temperatura', 20.0000, 'ºC'),
	(97560, 108, '2015-03-15 00:47:16.000000', 'temperatura', 543.0000, 'ºC'),
	(97561, 108, '2015-03-15 00:47:17.000000', 'temperatura', 255.0000, 'ºC'),
	(97562, 108, '2015-03-15 00:47:18.000000', 'temperatura', 847.0000, 'ºC'),
	(97563, 108, '2015-03-15 00:47:19.000000', 'temperatura', 1071.0000, 'ºC'),
	(97564, 108, '2015-03-15 00:47:20.000000', 'temperatura', 413.0000, 'ºC'),
	(97565, 108, '2015-03-15 00:47:21.000000', 'temperatura', 54.0000, 'ºC'),
	(97566, 108, '2015-03-15 00:47:22.000000', 'temperatura', 232.0000, 'ºC'),
	(97567, 108, '2015-03-15 00:47:23.000000', 'temperatura', 1000.0000, 'ºC'),
	(97568, 108, '2015-03-15 00:47:24.000000', 'temperatura', 702.0000, 'ºC'),
	(97569, 108, '2015-03-15 00:47:25.000000', 'temperatura', 511.0000, 'ºC'),
	(97570, 108, '2015-03-15 00:47:26.000000', 'temperatura', 451.0000, 'ºC'),
	(97571, 108, '2015-03-15 00:47:27.000000', 'temperatura', 721.0000, 'ºC'),
	(97572, 108, '2015-03-15 00:47:28.000000', 'temperatura', 1052.0000, 'ºC'),
	(97573, 108, '2015-03-15 00:47:29.000000', 'temperatura', 697.0000, 'ºC'),
	(97574, 108, '2015-03-15 00:47:30.000000', 'temperatura', 329.0000, 'ºC'),
	(97575, 108, '2015-03-15 00:47:31.000000', 'temperatura', 757.0000, 'ºC'),
	(97576, 108, '2015-03-15 00:47:32.000000', 'temperatura', 399.0000, 'ºC'),
	(97577, 108, '2015-03-15 00:47:33.000000', 'temperatura', 924.0000, 'ºC'),
	(97578, 108, '2015-03-15 00:47:34.000000', 'temperatura', 1025.0000, 'ºC'),
	(97579, 108, '2015-03-15 00:47:35.000000', 'temperatura', 1151.0000, 'ºC'),
	(97580, 108, '2015-03-15 00:47:36.000000', 'temperatura', 282.0000, 'ºC'),
	(97581, 108, '2015-03-15 00:47:37.000000', 'temperatura', 357.0000, 'ºC'),
	(97582, 108, '2015-03-15 00:47:38.000000', 'temperatura', 938.0000, 'ºC'),
	(97583, 108, '2015-03-15 00:47:39.000000', 'temperatura', 20.0000, 'ºC'),
	(97584, 108, '2015-03-15 00:47:40.000000', 'temperatura', 888.0000, 'ºC'),
	(97585, 108, '2015-03-15 00:47:41.000000', 'temperatura', 779.0000, 'ºC'),
	(97586, 108, '2015-03-15 00:47:42.000000', 'temperatura', 31.0000, 'ºC'),
	(97587, 108, '2015-03-15 00:47:43.000000', 'temperatura', 218.0000, 'ºC'),
	(97588, 108, '2015-03-15 00:47:44.000000', 'temperatura', 1000.0000, 'ºC'),
	(97589, 108, '2015-03-15 00:47:45.000000', 'temperatura', 747.0000, 'ºC'),
	(97590, 108, '2015-03-15 00:47:46.000000', 'temperatura', 732.0000, 'ºC'),
	(97591, 108, '2015-03-15 00:47:47.000000', 'temperatura', 223.0000, 'ºC'),
	(97592, 108, '2015-03-15 00:47:48.000000', 'temperatura', 119.0000, 'ºC'),
	(97593, 108, '2015-03-15 00:47:49.000000', 'temperatura', 1125.0000, 'ºC'),
	(97594, 108, '2015-03-15 00:47:50.000000', 'temperatura', 469.0000, 'ºC'),
	(97595, 108, '2015-03-15 00:47:51.000000', 'temperatura', 170.0000, 'ºC'),
	(97596, 108, '2015-03-15 00:47:52.000000', 'temperatura', 645.0000, 'ºC'),
	(97597, 108, '2015-03-15 00:47:53.000000', 'temperatura', 316.0000, 'ºC'),
	(97598, 108, '2015-03-15 00:47:54.000000', 'temperatura', 846.0000, 'ºC'),
	(97599, 108, '2015-03-15 00:47:55.000000', 'temperatura', 881.0000, 'ºC'),
	(97600, 108, '2015-03-15 00:47:56.000000', 'temperatura', 670.0000, 'ºC'),
	(97601, 108, '2015-03-15 00:47:57.000000', 'temperatura', 705.0000, 'ºC'),
	(97602, 108, '2015-03-15 00:47:58.000000', 'temperatura', 318.0000, 'ºC'),
	(97603, 108, '2015-03-15 00:47:59.000000', 'temperatura', 672.0000, 'ºC'),
	(97604, 108, '2015-03-15 00:48:00.000000', 'temperatura', 10.0000, 'ºC'),
	(97605, 108, '2015-03-15 00:48:01.000000', 'temperatura', 431.0000, 'ºC'),
	(97606, 108, '2015-03-15 00:48:02.000000', 'temperatura', 928.0000, 'ºC'),
	(97607, 108, '2015-03-15 00:48:03.000000', 'temperatura', 945.0000, 'ºC'),
	(97608, 108, '2015-03-15 00:48:04.000000', 'temperatura', 743.0000, 'ºC'),
	(97609, 108, '2015-03-15 00:48:05.000000', 'temperatura', 881.0000, 'ºC'),
	(97610, 108, '2015-03-15 00:48:06.000000', 'temperatura', 978.0000, 'ºC'),
	(97611, 108, '2015-03-15 00:48:07.000000', 'temperatura', 1045.0000, 'ºC'),
	(97612, 108, '2015-03-15 00:48:08.000000', 'temperatura', 1093.0000, 'ºC'),
	(97613, 108, '2015-03-15 00:48:09.000000', 'temperatura', 1130.0000, 'ºC'),
	(97614, 108, '2015-03-15 00:48:10.000000', 'temperatura', 1171.0000, 'ºC'),
	(97615, 108, '2015-03-15 00:48:11.000000', 'temperatura', 65.0000, 'ºC'),
	(97616, 108, '2015-03-15 00:48:12.000000', 'temperatura', 412.0000, 'ºC'),
	(97617, 108, '2015-03-15 00:48:13.000000', 'temperatura', 665.0000, 'ºC'),
	(97618, 108, '2015-03-15 00:48:14.000000', 'temperatura', 891.0000, 'ºC'),
	(97619, 108, '2015-03-15 00:48:15.000000', 'temperatura', 60.0000, 'ºC'),
	(97620, 108, '2015-03-15 00:48:16.000000', 'temperatura', 29.0000, 'ºC'),
	(97621, 108, '2015-03-15 00:48:17.000000', 'temperatura', 1163.0000, 'ºC'),
	(97622, 108, '2015-03-15 00:48:18.000000', 'temperatura', 932.0000, 'ºC'),
	(97623, 108, '2015-03-15 00:48:19.000000', 'temperatura', 1168.0000, 'ºC'),
	(97624, 108, '2015-03-15 00:48:20.000000', 'temperatura', 647.0000, 'ºC'),
	(97625, 108, '2015-03-15 00:48:21.000000', 'temperatura', 929.0000, 'ºC'),
	(97626, 108, '2015-03-15 00:48:22.000000', 'temperatura', 305.0000, 'ºC'),
	(97627, 108, '2015-03-15 00:48:23.000000', 'temperatura', 1138.0000, 'ºC'),
	(97628, 108, '2015-03-15 00:48:24.000000', 'temperatura', 1178.0000, 'ºC'),
	(97629, 108, '2015-03-15 00:48:25.000000', 'temperatura', 74.0000, 'ºC'),
	(97630, 108, '2015-03-15 00:48:26.000000', 'temperatura', 436.0000, 'ºC'),
	(97631, 108, '2015-03-15 00:48:27.000000', 'temperatura', 761.0000, 'ºC'),
	(97632, 108, '2015-03-15 00:48:28.000000', 'temperatura', 95.0000, 'ºC'),
	(97633, 108, '2015-03-15 00:48:29.000000', 'temperatura', 595.0000, 'ºC'),
	(97634, 108, '2015-03-15 00:48:30.000000', 'temperatura', 288.0000, 'ºC'),
	(97635, 108, '2015-03-15 00:48:31.000000', 'temperatura', 855.0000, 'ºC'),
	(97636, 108, '2015-03-15 00:48:32.000000', 'temperatura', 1014.0000, 'ºC'),
	(97637, 108, '2015-03-15 00:48:33.000000', 'temperatura', 106.0000, 'ºC'),
	(97638, 108, '2015-03-15 00:48:34.000000', 'temperatura', 1087.0000, 'ºC'),
	(97639, 108, '2015-03-15 00:48:35.000000', 'temperatura', 316.0000, 'ºC'),
	(97640, 108, '2015-03-15 00:48:36.000000', 'temperatura', 722.0000, 'ºC'),
	(97641, 108, '2015-03-15 00:48:37.000000', 'temperatura', 264.0000, 'ºC'),
	(97642, 108, '2015-03-15 00:48:38.000000', 'temperatura', 351.0000, 'ºC'),
	(97643, 108, '2015-03-15 00:48:39.000000', 'temperatura', 964.0000, 'ºC'),
	(97644, 108, '2015-03-15 00:48:40.000000', 'temperatura', 167.0000, 'ºC'),
	(97645, 108, '2015-03-15 00:48:41.000000', 'temperatura', 343.0000, 'ºC'),
	(97646, 108, '2015-03-15 00:48:42.000000', 'temperatura', 14.0000, 'ºC'),
	(97647, 108, '2015-03-15 00:48:43.000000', 'temperatura', 244.0000, 'ºC'),
	(97648, 108, '2015-03-15 00:48:44.000000', 'temperatura', 1177.0000, 'ºC'),
	(97649, 108, '2015-03-15 00:48:45.000000', 'temperatura', 352.0000, 'ºC'),
	(97650, 108, '2015-03-15 00:48:46.000000', 'temperatura', 631.0000, 'ºC'),
	(97651, 108, '2015-03-15 00:48:47.000000', 'temperatura', 899.0000, 'ºC'),
	(97652, 108, '2015-03-15 00:48:48.000000', 'temperatura', 201.0000, 'ºC'),
	(97653, 108, '2015-03-15 00:48:49.000000', 'temperatura', 710.0000, 'ºC'),
	(97654, 108, '2015-03-15 00:48:50.000000', 'temperatura', 549.0000, 'ºC'),
	(97655, 108, '2015-03-15 00:48:51.000000', 'temperatura', 613.0000, 'ºC'),
	(97656, 108, '2015-03-15 00:48:52.000000', 'temperatura', 220.0000, 'ºC'),
	(97657, 108, '2015-03-15 00:48:53.000000', 'temperatura', 462.0000, 'ºC'),
	(97658, 108, '2015-03-15 00:48:54.000000', 'temperatura', 448.0000, 'ºC'),
	(97659, 108, '2015-03-15 00:48:55.000000', 'temperatura', 855.0000, 'ºC'),
	(97660, 108, '2015-03-15 00:48:56.000000', 'temperatura', 531.0000, 'ºC'),
	(97661, 108, '2015-03-15 00:48:57.000000', 'temperatura', 92.0000, 'ºC'),
	(97662, 108, '2015-03-15 00:48:58.000000', 'temperatura', 66.0000, 'ºC'),
	(97663, 108, '2015-03-15 00:48:59.000000', 'temperatura', 56.0000, 'ºC'),
	(97664, 108, '2015-03-15 00:49:00.000000', 'temperatura', 81.0000, 'ºC'),
	(97665, 108, '2015-03-15 00:49:01.000000', 'temperatura', 237.0000, 'ºC'),
	(97666, 108, '2015-03-15 00:49:02.000000', 'temperatura', 943.0000, 'ºC'),
	(97667, 108, '2015-03-15 00:49:03.000000', 'temperatura', 406.0000, 'ºC'),
	(97668, 108, '2015-03-15 00:49:04.000000', 'temperatura', 399.0000, 'ºC'),
	(97669, 108, '2015-03-15 00:49:05.000000', 'temperatura', 777.0000, 'ºC'),
	(97670, 108, '2015-03-15 00:49:06.000000', 'temperatura', 291.0000, 'ºC'),
	(97671, 108, '2015-03-15 00:49:07.000000', 'temperatura', 324.0000, 'ºC'),
	(97672, 108, '2015-03-15 00:49:08.000000', 'temperatura', 746.0000, 'ºC'),
	(97673, 108, '2015-03-15 00:49:09.000000', 'temperatura', 357.0000, 'ºC'),
	(97674, 108, '2015-03-15 00:49:10.000000', 'temperatura', 750.0000, 'ºC'),
	(97675, 108, '2015-03-15 00:49:11.000000', 'temperatura', 279.0000, 'ºC'),
	(97676, 108, '2015-03-15 00:49:12.000000', 'temperatura', 345.0000, 'ºC'),
	(97677, 108, '2015-03-15 00:49:13.000000', 'temperatura', 888.0000, 'ºC'),
	(97678, 108, '2015-03-15 00:49:14.000000', 'temperatura', 1005.0000, 'ºC'),
	(97679, 108, '2015-03-15 00:49:15.000000', 'temperatura', 1160.0000, 'ºC'),
	(97680, 108, '2015-03-15 00:49:16.000000', 'temperatura', 388.0000, 'ºC'),
	(97681, 108, '2015-03-15 00:49:17.000000', 'temperatura', 861.0000, 'ºC'),
	(97682, 108, '2015-03-15 00:49:18.000000', 'temperatura', 739.0000, 'ºC'),
	(97683, 108, '2015-03-15 00:49:19.000000', 'temperatura', 1113.0000, 'ºC'),
	(97684, 108, '2015-03-15 00:49:20.000000', 'temperatura', 948.0000, 'ºC'),
	(97685, 108, '2015-03-15 00:49:21.000000', 'temperatura', 201.0000, 'ºC'),
	(97686, 108, '2015-03-15 00:49:22.000000', 'temperatura', 563.0000, 'ºC'),
	(97687, 108, '2015-03-15 00:49:23.000000', 'temperatura', 1014.0000, 'ºC'),
	(97688, 108, '2015-03-15 00:49:24.000000', 'temperatura', 979.0000, 'ºC'),
	(97689, 108, '2015-03-15 00:49:25.000000', 'temperatura', 655.0000, 'ºC'),
	(97690, 108, '2015-03-15 00:49:26.000000', 'temperatura', 339.0000, 'ºC'),
	(97691, 108, '2015-03-15 00:49:27.000000', 'temperatura', 932.0000, 'ºC'),
	(97692, 108, '2015-03-15 00:49:28.000000', 'temperatura', 40.0000, 'ºC'),
	(97693, 108, '2015-03-15 00:49:29.000000', 'temperatura', 1007.0000, 'ºC'),
	(97694, 108, '2015-03-15 00:49:30.000000', 'temperatura', 113.0000, 'ºC'),
	(97695, 108, '2015-03-15 00:49:31.000000', 'temperatura', 1145.0000, 'ºC'),
	(97696, 108, '2015-03-15 00:49:32.000000', 'temperatura', 587.0000, 'ºC'),
	(97697, 108, '2015-03-15 00:49:33.000000', 'temperatura', 701.0000, 'ºC'),
	(97698, 108, '2015-03-15 00:49:34.000000', 'temperatura', 545.0000, 'ºC'),
	(97699, 108, '2015-03-15 00:49:35.000000', 'temperatura', 622.0000, 'ºC'),
	(97700, 108, '2015-03-15 00:49:36.000000', 'temperatura', 277.0000, 'ºC'),
	(97701, 108, '2015-03-15 00:49:37.000000', 'temperatura', 719.0000, 'ºC'),
	(97702, 108, '2015-03-15 00:49:38.000000', 'temperatura', 364.0000, 'ºC'),
	(97703, 108, '2015-03-15 00:49:39.000000', 'temperatura', 864.0000, 'ºC'),
	(97704, 108, '2015-03-15 00:49:40.000000', 'temperatura', 827.0000, 'ºC'),
	(97705, 108, '2015-03-15 00:49:41.000000', 'temperatura', 346.0000, 'ºC'),
	(97706, 108, '2015-03-15 00:49:42.000000', 'temperatura', 450.0000, 'ºC'),
	(97707, 108, '2015-03-15 00:49:43.000000', 'temperatura', 11.0000, 'ºC'),
	(97708, 108, '2015-03-15 00:49:44.000000', 'temperatura', 1106.0000, 'ºC'),
	(97709, 108, '2015-03-15 00:49:45.000000', 'temperatura', 699.0000, 'ºC'),
	(97710, 108, '2015-03-15 00:49:46.000000', 'temperatura', 175.0000, 'ºC'),
	(97711, 108, '2015-03-15 00:49:47.000000', 'temperatura', 1179.0000, 'ºC'),
	(97712, 108, '2015-03-15 00:49:48.000000', 'temperatura', 570.0000, 'ºC'),
	(97713, 108, '2015-03-15 00:49:49.000000', 'temperatura', 514.0000, 'ºC'),
	(97714, 108, '2015-03-15 00:49:50.000000', 'temperatura', 860.0000, 'ºC'),
	(97715, 108, '2015-03-15 00:49:51.000000', 'temperatura', 358.0000, 'ºC'),
	(97716, 108, '2015-03-15 00:49:52.000000', 'temperatura', 412.0000, 'ºC'),
	(97717, 108, '2015-03-15 00:49:53.000000', 'temperatura', 986.0000, 'ºC'),
	(97718, 108, '2015-03-15 00:49:54.000000', 'temperatura', 92.0000, 'ºC'),
	(97719, 108, '2015-03-15 00:49:55.000000', 'temperatura', 1106.0000, 'ºC'),
	(97720, 108, '2015-03-15 00:49:56.000000', 'temperatura', 454.0000, 'ºC'),
	(97721, 108, '2015-03-15 00:49:57.000000', 'temperatura', 153.0000, 'ºC'),
	(97722, 108, '2015-03-15 00:49:58.000000', 'temperatura', 605.0000, 'ºC'),
	(97723, 108, '2015-03-15 00:49:59.000000', 'temperatura', 164.0000, 'ºC'),
	(97724, 108, '2015-03-15 00:50:00.000000', 'temperatura', 206.0000, 'ºC'),
	(97725, 108, '2015-03-15 00:50:01.000000', 'temperatura', 541.0000, 'ºC'),
	(97726, 108, '2015-03-15 00:50:02.000000', 'temperatura', 884.0000, 'ºC'),
	(97727, 108, '2015-03-15 00:50:03.000000', 'temperatura', 397.0000, 'ºC'),
	(97728, 108, '2015-03-15 00:50:04.000000', 'temperatura', 537.0000, 'ºC'),
	(97729, 108, '2015-03-15 00:50:05.000000', 'temperatura', 291.0000, 'ºC'),
	(97730, 108, '2015-03-15 00:50:06.000000', 'temperatura', 1046.0000, 'ºC'),
	(97731, 108, '2015-03-15 00:50:07.000000', 'temperatura', 758.0000, 'ºC'),
	(97732, 108, '2015-03-15 00:50:08.000000', 'temperatura', 654.0000, 'ºC'),
	(97733, 108, '2015-03-15 00:50:09.000000', 'temperatura', 996.0000, 'ºC'),
	(97734, 108, '2015-03-15 00:50:10.000000', 'temperatura', 617.0000, 'ºC'),
	(97735, 108, '2015-03-15 00:50:11.000000', 'temperatura', 97.0000, 'ºC'),
	(97736, 108, '2015-03-15 00:50:12.000000', 'temperatura', 1034.0000, 'ºC'),
	(97737, 108, '2015-03-15 00:50:13.000000', 'temperatura', 80.0000, 'ºC'),
	(97738, 108, '2015-03-15 00:50:14.000000', 'temperatura', 898.0000, 'ºC'),
	(97739, 108, '2015-03-15 00:50:15.000000', 'temperatura', 652.0000, 'ºC'),
	(97740, 108, '2015-03-15 00:50:16.000000', 'temperatura', 567.0000, 'ºC'),
	(97741, 108, '2015-03-15 00:50:17.000000', 'temperatura', 881.0000, 'ºC'),
	(97742, 108, '2015-03-15 00:50:18.000000', 'temperatura', 301.0000, 'ºC'),
	(97743, 108, '2015-03-15 00:50:19.000000', 'temperatura', 65.0000, 'ºC'),
	(97744, 108, '2015-03-15 00:50:20.000000', 'temperatura', 620.0000, 'ºC'),
	(97745, 108, '2015-03-15 00:50:21.000000', 'temperatura', 506.0000, 'ºC'),
	(97746, 108, '2015-03-15 00:50:22.000000', 'temperatura', 672.0000, 'ºC'),
	(97747, 108, '2015-03-15 00:50:23.000000', 'temperatura', 643.0000, 'ºC'),
	(97748, 108, '2015-03-15 00:50:24.000000', 'temperatura', 1199.0000, 'ºC'),
	(97749, 108, '2015-03-15 00:50:25.000000', 'temperatura', 464.0000, 'ºC'),
	(97750, 108, '2015-03-15 00:50:26.000000', 'temperatura', 1126.0000, 'ºC'),
	(97751, 108, '2015-03-15 00:50:27.000000', 'temperatura', 640.0000, 'ºC'),
	(97752, 108, '2015-03-15 00:50:28.000000', 'temperatura', 1021.0000, 'ºC'),
	(97753, 108, '2015-03-15 00:50:29.000000', 'temperatura', 783.0000, 'ºC'),
	(97754, 108, '2015-03-15 00:50:30.000000', 'temperatura', 856.0000, 'ºC'),
	(97755, 108, '2015-03-15 00:50:31.000000', 'temperatura', 730.0000, 'ºC'),
	(97756, 108, '2015-03-15 00:50:32.000000', 'temperatura', 1082.0000, 'ºC'),
	(97757, 108, '2015-03-15 00:50:33.000000', 'temperatura', 821.0000, 'ºC'),
	(97758, 108, '2015-03-15 00:50:34.000000', 'temperatura', 861.0000, 'ºC'),
	(97759, 108, '2015-03-15 00:50:35.000000', 'temperatura', 643.0000, 'ºC'),
	(97760, 108, '2015-03-15 00:50:36.000000', 'temperatura', 633.0000, 'ºC'),
	(97761, 108, '2015-03-15 00:50:37.000000', 'temperatura', 36.0000, 'ºC'),
	(97762, 108, '2015-03-15 00:50:38.000000', 'temperatura', 681.0000, 'ºC'),
	(97763, 108, '2015-03-15 00:50:39.000000', 'temperatura', 896.0000, 'ºC'),
	(97764, 108, '2015-03-15 00:50:40.000000', 'temperatura', 41.0000, 'ºC'),
	(97765, 108, '2015-03-15 00:50:41.000000', 'temperatura', 1114.0000, 'ºC'),
	(97766, 108, '2015-03-15 00:50:42.000000', 'temperatura', 649.0000, 'ºC'),
	(97767, 108, '2015-03-15 00:50:43.000000', 'temperatura', 1103.0000, 'ºC'),
	(97768, 108, '2015-03-15 00:50:44.000000', 'temperatura', 1170.0000, 'ºC'),
	(97769, 108, '2015-03-15 00:50:45.000000', 'temperatura', 139.0000, 'ºC'),
	(97770, 108, '2015-03-15 00:50:46.000000', 'temperatura', 786.0000, 'ºC'),
	(97771, 108, '2015-03-15 00:50:47.000000', 'temperatura', 1112.0000, 'ºC'),
	(97772, 108, '2015-03-15 00:50:48.000000', 'temperatura', 804.0000, 'ºC'),
	(97773, 108, '2015-03-15 00:50:49.000000', 'temperatura', 683.0000, 'ºC'),
	(97774, 108, '2015-03-15 00:50:50.000000', 'temperatura', 1004.0000, 'ºC'),
	(97775, 108, '2015-03-15 00:50:51.000000', 'temperatura', 571.0000, 'ºC'),
	(97776, 108, '2015-03-15 00:50:52.000000', 'temperatura', 1043.0000, 'ºC'),
	(97777, 108, '2015-03-15 00:50:53.000000', 'temperatura', 1102.0000, 'ºC'),
	(97778, 108, '2015-03-15 00:50:54.000000', 'temperatura', 1181.0000, 'ºC'),
	(97779, 108, '2015-03-15 00:50:55.000000', 'temperatura', 202.0000, 'ºC'),
	(97780, 108, '2015-03-15 00:50:56.000000', 'temperatura', 1067.0000, 'ºC'),
	(97781, 108, '2015-03-15 00:50:57.000000', 'temperatura', 1130.0000, 'ºC'),
	(97782, 108, '2015-03-15 00:50:58.000000', 'temperatura', 47.0000, 'ºC'),
	(97783, 108, '2015-03-15 00:50:59.000000', 'temperatura', 448.0000, 'ºC'),
	(97784, 108, '2015-03-15 00:51:00.000000', 'temperatura', 897.0000, 'ºC'),
	(97785, 108, '2015-03-15 00:51:01.000000', 'temperatura', 742.0000, 'ºC'),
	(97786, 108, '2015-03-15 00:51:02.000000', 'temperatura', 1021.0000, 'ºC'),
	(97787, 108, '2015-03-15 00:51:03.000000', 'temperatura', 479.0000, 'ºC'),
	(97788, 108, '2015-03-15 00:51:04.000000', 'temperatura', 532.0000, 'ºC'),
	(97789, 108, '2015-03-15 00:51:05.000000', 'temperatura', 25.0000, 'ºC'),
	(97790, 108, '2015-03-15 00:51:06.000000', 'temperatura', 928.0000, 'ºC'),
	(97791, 108, '2015-03-15 00:51:07.000000', 'temperatura', 966.0000, 'ºC'),
	(97792, 108, '2015-03-15 00:51:08.000000', 'temperatura', 846.0000, 'ºC'),
	(97793, 108, '2015-03-15 00:51:09.000000', 'temperatura', 135.0000, 'ºC'),
	(97794, 108, '2015-03-15 00:51:10.000000', 'temperatura', 535.0000, 'ºC'),
	(97795, 108, '2015-03-15 00:51:11.000000', 'temperatura', 1071.0000, 'ºC'),
	(97796, 108, '2015-03-15 00:51:12.000000', 'temperatura', 151.0000, 'ºC'),
	(97797, 108, '2015-03-15 00:51:13.000000', 'temperatura', 1141.0000, 'ºC'),
	(97798, 108, '2015-03-15 00:51:14.000000', 'temperatura', 452.0000, 'ºC'),
	(97799, 108, '2015-03-15 00:51:15.000000', 'temperatura', 40.0000, 'ºC'),
	(97800, 108, '2015-03-15 00:51:16.000000', 'temperatura', 43.0000, 'ºC'),
	(97801, 108, '2015-03-15 00:51:17.000000', 'temperatura', 95.0000, 'ºC'),
	(97802, 108, '2015-03-15 00:51:18.000000', 'temperatura', 346.0000, 'ºC'),
	(97803, 108, '2015-03-15 00:51:19.000000', 'temperatura', 248.0000, 'ºC'),
	(97804, 108, '2015-03-15 00:51:20.000000', 'temperatura', 200.0000, 'ºC'),
	(97805, 108, '2015-03-15 00:51:21.000000', 'temperatura', 256.0000, 'ºC'),
	(97806, 108, '2015-03-15 00:51:22.000000', 'temperatura', 683.0000, 'ºC'),
	(97807, 108, '2015-03-15 00:51:23.000000', 'temperatura', 245.0000, 'ºC'),
	(97808, 108, '2015-03-15 00:51:24.000000', 'temperatura', 378.0000, 'ºC'),
	(97809, 108, '2015-03-15 00:51:25.000000', 'temperatura', 1154.0000, 'ºC'),
	(97810, 108, '2015-03-15 00:51:26.000000', 'temperatura', 1039.0000, 'ºC'),
	(97811, 108, '2015-03-15 00:51:27.000000', 'temperatura', 530.0000, 'ºC'),
	(97812, 108, '2015-03-15 00:51:28.000000', 'temperatura', 736.0000, 'ºC'),
	(97813, 108, '2015-03-15 00:51:29.000000', 'temperatura', 889.0000, 'ºC'),
	(97814, 108, '2015-03-15 00:51:30.000000', 'temperatura', 1039.0000, 'ºC'),
	(97815, 108, '2015-03-15 00:51:31.000000', 'temperatura', 128.0000, 'ºC'),
	(97816, 108, '2015-03-15 00:51:32.000000', 'temperatura', 1124.0000, 'ºC'),
	(97817, 108, '2015-03-15 00:51:33.000000', 'temperatura', 437.0000, 'ºC'),
	(97818, 108, '2015-03-15 00:51:34.000000', 'temperatura', 14.0000, 'ºC'),
	(97819, 108, '2015-03-15 00:51:35.000000', 'temperatura', 1157.0000, 'ºC'),
	(97820, 108, '2015-03-15 00:51:36.000000', 'temperatura', 946.0000, 'ºC'),
	(97821, 108, '2015-03-15 00:51:37.000000', 'temperatura', 60.0000, 'ºC'),
	(97822, 108, '2015-03-15 00:51:38.000000', 'temperatura', 1062.0000, 'ºC'),
	(97823, 108, '2015-03-15 00:51:39.000000', 'temperatura', 331.0000, 'ºC'),
	(97824, 108, '2015-03-15 00:51:40.000000', 'temperatura', 867.0000, 'ºC'),
	(97825, 108, '2015-03-15 00:51:41.000000', 'temperatura', 945.0000, 'ºC'),
	(97826, 108, '2015-03-15 00:51:42.000000', 'temperatura', 924.0000, 'ºC'),
	(97827, 108, '2015-03-15 00:51:43.000000', 'temperatura', 586.0000, 'ºC'),
	(97828, 108, '2015-03-15 00:51:44.000000', 'temperatura', 158.0000, 'ºC'),
	(97829, 108, '2015-03-15 00:51:45.000000', 'temperatura', 230.0000, 'ºC'),
	(97830, 108, '2015-03-15 00:51:46.000000', 'temperatura', 680.0000, 'ºC'),
	(97831, 108, '2015-03-15 00:51:47.000000', 'temperatura', 309.0000, 'ºC'),
	(97832, 108, '2015-03-15 00:51:48.000000', 'temperatura', 704.0000, 'ºC'),
	(97833, 108, '2015-03-15 00:51:49.000000', 'temperatura', 195.0000, 'ºC'),
	(97834, 108, '2015-03-15 00:51:50.000000', 'temperatura', 65.0000, 'ºC'),
	(97835, 108, '2015-03-15 00:51:51.000000', 'temperatura', 939.0000, 'ºC'),
	(97836, 108, '2015-03-15 00:51:52.000000', 'temperatura', 901.0000, 'ºC'),
	(97837, 108, '2015-03-15 00:51:53.000000', 'temperatura', 490.0000, 'ºC'),
	(97838, 108, '2015-03-15 00:51:54.000000', 'temperatura', 947.0000, 'ºC'),
	(97839, 108, '2015-03-15 00:51:55.000000', 'temperatura', 867.0000, 'ºC'),
	(97840, 108, '2015-03-15 00:51:56.000000', 'temperatura', 293.0000, 'ºC'),
	(97841, 108, '2015-03-15 00:51:57.000000', 'temperatura', 63.0000, 'ºC'),
	(97842, 108, '2015-03-15 00:51:58.000000', 'temperatura', 637.0000, 'ºC'),
	(97843, 108, '2015-03-15 00:51:59.000000', 'temperatura', 595.0000, 'ºC'),
	(97844, 108, '2015-03-15 00:52:00.000000', 'temperatura', 1068.0000, 'ºC'),
	(97845, 108, '2015-03-15 00:52:01.000000', 'temperatura', 1154.0000, 'ºC'),
	(97846, 108, '2015-03-15 00:52:02.000000', 'temperatura', 166.0000, 'ºC'),
	(97847, 108, '2015-03-15 00:52:03.000000', 'temperatura', 967.0000, 'ºC'),
	(97848, 108, '2015-03-15 00:52:04.000000', 'temperatura', 738.0000, 'ºC'),
	(97849, 108, '2015-03-15 00:52:05.000000', 'temperatura', 789.0000, 'ºC'),
	(97850, 108, '2015-03-15 00:52:06.000000', 'temperatura', 532.0000, 'ºC'),
	(97851, 108, '2015-03-15 00:52:07.000000', 'temperatura', 292.0000, 'ºC'),
	(97852, 108, '2015-03-15 00:52:08.000000', 'temperatura', 1064.0000, 'ºC'),
	(97853, 108, '2015-03-15 00:52:09.000000', 'temperatura', 847.0000, 'ºC'),
	(97854, 108, '2015-03-15 00:52:10.000000', 'temperatura', 1041.0000, 'ºC'),
	(97855, 108, '2015-03-15 00:52:11.000000', 'temperatura', 264.0000, 'ºC'),
	(97856, 108, '2015-03-15 00:52:12.000000', 'temperatura', 598.0000, 'ºC'),
	(97857, 108, '2015-03-15 00:52:13.000000', 'temperatura', 1000.0000, 'ºC'),
	(97858, 108, '2015-03-15 00:52:14.000000', 'temperatura', 806.0000, 'ºC'),
	(97859, 108, '2015-03-15 00:52:15.000000', 'temperatura', 1032.0000, 'ºC'),
	(97860, 108, '2015-03-15 00:52:16.000000', 'temperatura', 343.0000, 'ºC'),
	(97861, 108, '2015-03-15 00:52:17.000000', 'temperatura', 1017.0000, 'ºC'),
	(97862, 108, '2015-03-15 00:52:18.000000', 'temperatura', 457.0000, 'ºC'),
	(97863, 108, '2015-03-15 00:52:19.000000', 'temperatura', 434.0000, 'ºC'),
	(97864, 108, '2015-03-15 00:52:20.000000', 'temperatura', 800.0000, 'ºC'),
	(97865, 108, '2015-03-15 00:52:21.000000', 'temperatura', 300.0000, 'ºC'),
	(97866, 108, '2015-03-15 00:52:22.000000', 'temperatura', 300.0000, 'ºC'),
	(97867, 108, '2015-03-15 00:52:23.000000', 'temperatura', 599.0000, 'ºC'),
	(97868, 108, '2015-03-15 00:52:24.000000', 'temperatura', 897.0000, 'ºC'),
	(97869, 108, '2015-03-15 00:52:25.000000', 'temperatura', 287.0000, 'ºC'),
	(97870, 108, '2015-03-15 00:52:26.000000', 'temperatura', 1146.0000, 'ºC'),
	(97871, 108, '2015-03-15 00:52:27.000000', 'temperatura', 67.0000, 'ºC'),
	(97872, 108, '2015-03-15 00:52:28.000000', 'temperatura', 501.0000, 'ºC'),
	(97873, 108, '2015-03-15 00:52:29.000000', 'temperatura', 1101.0000, 'ºC'),
	(97874, 108, '2015-03-15 00:52:30.000000', 'temperatura', 405.0000, 'ºC'),
	(97875, 108, '2015-03-15 00:52:31.000000', 'temperatura', 1121.0000, 'ºC'),
	(97876, 108, '2015-03-15 00:52:32.000000', 'temperatura', 792.0000, 'ºC'),
	(97877, 108, '2015-03-15 00:52:33.000000', 'temperatura', 597.0000, 'ºC'),
	(97878, 108, '2015-03-15 00:52:34.000000', 'temperatura', 608.0000, 'ºC'),
	(97879, 108, '2015-03-15 00:52:35.000000', 'temperatura', 51.0000, 'ºC'),
	(97880, 108, '2015-03-15 00:52:36.000000', 'temperatura', 832.0000, 'ºC'),
	(97881, 108, '2015-03-15 00:52:37.000000', 'temperatura', 407.0000, 'ºC'),
	(97882, 108, '2015-03-15 00:52:38.000000', 'temperatura', 740.0000, 'ºC'),
	(97883, 108, '2015-03-15 00:52:39.000000', 'temperatura', 81.0000, 'ºC'),
	(97884, 108, '2015-03-15 00:52:40.000000', 'temperatura', 585.0000, 'ºC'),
	(97885, 108, '2015-03-15 00:52:41.000000', 'temperatura', 280.0000, 'ºC'),
	(97886, 108, '2015-03-15 00:52:42.000000', 'temperatura', 848.0000, 'ºC'),
	(97887, 108, '2015-03-15 00:52:43.000000', 'temperatura', 1000.0000, 'ºC'),
	(97888, 108, '2015-03-15 00:52:44.000000', 'temperatura', 57.0000, 'ºC'),
	(97889, 108, '2015-03-15 00:52:45.000000', 'temperatura', 884.0000, 'ºC'),
	(97890, 108, '2015-03-15 00:52:46.000000', 'temperatura', 650.0000, 'ºC'),
	(97891, 108, '2015-03-15 00:52:47.000000', 'temperatura', 597.0000, 'ºC'),
	(97892, 108, '2015-03-15 00:52:48.000000', 'temperatura', 1038.0000, 'ºC'),
	(97893, 108, '2015-03-15 00:52:49.000000', 'temperatura', 997.0000, 'ºC'),
	(97894, 108, '2015-03-15 00:52:50.000000', 'temperatura', 672.0000, 'ºC'),
	(97895, 108, '2015-03-15 00:52:51.000000', 'temperatura', 368.0000, 'ºC'),
	(97896, 108, '2015-03-15 00:52:52.000000', 'temperatura', 1025.0000, 'ºC'),
	(97897, 108, '2015-03-15 00:52:53.000000', 'temperatura', 423.0000, 'ºC'),
	(97898, 108, '2015-03-15 00:52:54.000000', 'temperatura', 240.0000, 'ºC'),
	(97899, 108, '2015-03-15 00:52:55.000000', 'temperatura', 1132.0000, 'ºC'),
	(97900, 108, '2015-03-15 00:52:56.000000', 'temperatura', 139.0000, 'ºC'),
	(97901, 108, '2015-03-15 00:52:57.000000', 'temperatura', 902.0000, 'ºC'),
	(97902, 108, '2015-03-15 00:52:58.000000', 'temperatura', 491.0000, 'ºC'),
	(97903, 108, '2015-03-15 00:52:59.000000', 'temperatura', 952.0000, 'ºC'),
	(97904, 108, '2015-03-15 00:53:00.000000', 'temperatura', 887.0000, 'ºC'),
	(97905, 108, '2015-03-15 00:53:01.000000', 'temperatura', 380.0000, 'ºC'),
	(97906, 108, '2015-03-15 00:53:02.000000', 'temperatura', 440.0000, 'ºC'),
	(97907, 108, '2015-03-15 00:53:03.000000', 'temperatura', 1062.0000, 'ºC'),
	(97908, 108, '2015-03-15 00:53:04.000000', 'temperatura', 388.0000, 'ºC'),
	(97909, 108, '2015-03-15 00:53:05.000000', 'temperatura', 1155.0000, 'ºC'),
	(97910, 108, '2015-03-15 00:53:06.000000', 'temperatura', 1012.0000, 'ºC'),
	(97911, 108, '2015-03-15 00:53:07.000000', 'temperatura', 394.0000, 'ºC'),
	(97912, 108, '2015-03-15 00:53:08.000000', 'temperatura', 135.0000, 'ºC'),
	(97913, 108, '2015-03-15 00:53:09.000000', 'temperatura', 694.0000, 'ºC'),
	(97914, 108, '2015-03-15 00:53:10.000000', 'temperatura', 667.0000, 'ºC'),
	(97915, 108, '2015-03-15 00:53:11.000000', 'temperatura', 54.0000, 'ºC'),
	(97916, 108, '2015-03-15 00:53:12.000000', 'temperatura', 666.0000, 'ºC'),
	(97917, 108, '2015-03-15 00:53:13.000000', 'temperatura', 772.0000, 'ºC'),
	(97918, 108, '2015-03-15 00:53:14.000000', 'temperatura', 661.0000, 'ºC'),
	(97919, 108, '2015-03-15 00:53:15.000000', 'temperatura', 988.0000, 'ºC'),
	(97920, 108, '2015-03-15 00:53:16.000000', 'temperatura', 557.0000, 'ºC'),
	(97921, 108, '2015-03-15 00:53:17.000000', 'temperatura', 1023.0000, 'ºC'),
	(97922, 108, '2015-03-15 00:53:18.000000', 'temperatura', 1044.0000, 'ºC'),
	(97923, 108, '2015-03-15 00:53:19.000000', 'temperatura', 954.0000, 'ºC'),
	(97924, 108, '2015-03-15 00:53:20.000000', 'temperatura', 435.0000, 'ºC'),
	(97925, 108, '2015-03-15 00:53:21.000000', 'temperatura', 515.0000, 'ºC'),
	(97926, 108, '2015-03-15 00:53:22.000000', 'temperatura', 69.0000, 'ºC'),
	(97927, 108, '2015-03-15 00:53:23.000000', 'temperatura', 1.0000, 'ºC'),
	(97928, 108, '2015-03-15 00:53:24.000000', 'temperatura', 999.0000, 'ºC'),
	(97929, 108, '2015-03-15 00:53:25.000000', 'temperatura', 194.0000, 'ºC'),
	(97930, 108, '2015-03-15 00:53:26.000000', 'temperatura', 372.0000, 'ºC'),
	(97931, 108, '2015-03-15 00:53:27.000000', 'temperatura', 77.0000, 'ºC'),
	(97932, 108, '2015-03-15 00:53:28.000000', 'temperatura', 471.0000, 'ºC'),
	(97933, 108, '2015-03-15 00:53:29.000000', 'temperatura', 924.0000, 'ºC'),
	(97934, 108, '2015-03-15 00:53:30.000000', 'temperatura', 809.0000, 'ºC'),
	(97935, 108, '2015-03-15 00:53:31.000000', 'temperatura', 73.0000, 'ºC'),
	(97936, 108, '2015-03-15 00:53:32.000000', 'temperatura', 339.0000, 'ºC'),
	(97937, 108, '2015-03-15 00:53:33.000000', 'temperatura', 278.0000, 'ºC'),
	(97938, 108, '2015-03-15 00:53:34.000000', 'temperatura', 371.0000, 'ºC'),
	(97939, 108, '2015-03-15 00:53:35.000000', 'temperatura', 1022.0000, 'ºC'),
	(97940, 108, '2015-03-15 00:53:36.000000', 'temperatura', 398.0000, 'ºC'),
	(97941, 108, '2015-03-15 00:53:37.000000', 'temperatura', 125.0000, 'ºC'),
	(97942, 108, '2015-03-15 00:53:38.000000', 'temperatura', 632.0000, 'ºC'),
	(97943, 108, '2015-03-15 00:53:39.000000', 'temperatura', 387.0000, 'ºC'),
	(97944, 108, '2015-03-15 00:53:40.000000', 'temperatura', 36.0000, 'ºC'),
	(97945, 108, '2015-03-15 00:53:41.000000', 'temperatura', 220.0000, 'ºC'),
	(97946, 108, '2015-03-15 00:53:42.000000', 'temperatura', 994.0000, 'ºC'),
	(97947, 108, '2015-03-15 00:53:43.000000', 'temperatura', 711.0000, 'ºC'),
	(97948, 108, '2015-03-15 00:53:44.000000', 'temperatura', 571.0000, 'ºC'),
	(97949, 108, '2015-03-15 00:53:45.000000', 'temperatura', 725.0000, 'ºC'),
	(97950, 108, '2015-03-15 00:53:46.000000', 'temperatura', 712.0000, 'ºC'),
	(97951, 108, '2015-03-15 00:53:47.000000', 'temperatura', 184.0000, 'ºC'),
	(97952, 108, '2015-03-15 00:53:48.000000', 'temperatura', 1187.0000, 'ºC'),
	(97953, 108, '2015-03-15 00:53:49.000000', 'temperatura', 583.0000, 'ºC'),
	(97954, 108, '2015-03-15 00:53:50.000000', 'temperatura', 554.0000, 'ºC'),
	(97955, 108, '2015-03-15 00:53:51.000000', 'temperatura', 1022.0000, 'ºC'),
	(97956, 108, '2015-03-15 00:53:52.000000', 'temperatura', 1046.0000, 'ºC'),
	(97957, 108, '2015-03-15 00:53:53.000000', 'temperatura', 967.0000, 'ºC'),
	(97958, 108, '2015-03-15 00:53:54.000000', 'temperatura', 499.0000, 'ºC'),
	(97959, 108, '2015-03-15 00:53:55.000000', 'temperatura', 793.0000, 'ºC'),
	(97960, 108, '2015-03-15 00:53:56.000000', 'temperatura', 66.0000, 'ºC'),
	(97961, 108, '2015-03-15 00:53:57.000000', 'temperatura', 355.0000, 'ºC'),
	(97962, 108, '2015-03-15 00:53:58.000000', 'temperatura', 377.0000, 'ºC'),
	(97963, 108, '2015-03-15 00:53:59.000000', 'temperatura', 820.0000, 'ºC'),
	(97964, 108, '2015-03-15 00:54:00.000000', 'temperatura', 571.0000, 'ºC'),
	(97965, 108, '2015-03-15 00:54:01.000000', 'temperatura', 395.0000, 'ºC'),
	(97966, 108, '2015-03-15 00:54:02.000000', 'temperatura', 261.0000, 'ºC'),
	(97967, 108, '2015-03-15 00:54:03.000000', 'temperatura', 119.0000, 'ºC'),
	(97968, 108, '2015-03-15 00:54:04.000000', 'temperatura', 1016.0000, 'ºC'),
	(97969, 108, '2015-03-15 00:54:05.000000', 'temperatura', 1123.0000, 'ºC'),
	(97970, 108, '2015-03-15 00:54:06.000000', 'temperatura', 168.0000, 'ºC'),
	(97971, 108, '2015-03-15 00:54:07.000000', 'temperatura', 1069.0000, 'ºC'),
	(97972, 108, '2015-03-15 00:54:08.000000', 'temperatura', 44.0000, 'ºC'),
	(97973, 108, '2015-03-15 00:54:09.000000', 'temperatura', 614.0000, 'ºC'),
	(97974, 108, '2015-03-15 00:54:10.000000', 'temperatura', 536.0000, 'ºC'),
	(97975, 108, '2015-03-15 00:54:11.000000', 'temperatura', 838.0000, 'ºC'),
	(97976, 108, '2015-03-15 00:54:12.000000', 'temperatura', 183.0000, 'ºC'),
	(97977, 108, '2015-03-15 00:54:13.000000', 'temperatura', 800.0000, 'ºC'),
	(97978, 108, '2015-03-15 00:54:14.000000', 'temperatura', 1054.0000, 'ºC'),
	(97979, 108, '2015-03-15 00:54:15.000000', 'temperatura', 468.0000, 'ºC'),
	(97980, 108, '2015-03-15 00:54:16.000000', 'temperatura', 379.0000, 'ºC'),
	(97981, 108, '2015-03-15 00:54:17.000000', 'temperatura', 493.0000, 'ºC'),
	(97982, 108, '2015-03-15 00:54:18.000000', 'temperatura', 128.0000, 'ºC'),
	(97983, 108, '2015-03-15 00:54:19.000000', 'temperatura', 360.0000, 'ºC'),
	(97984, 108, '2015-03-15 00:54:20.000000', 'temperatura', 217.0000, 'ºC'),
	(97985, 108, '2015-03-15 00:54:21.000000', 'temperatura', 7.0000, 'ºC'),
	(97986, 108, '2015-03-15 00:54:22.000000', 'temperatura', 583.0000, 'ºC'),
	(97987, 108, '2015-03-15 00:54:23.000000', 'temperatura', 496.0000, 'ºC'),
	(97988, 108, '2015-03-15 00:54:24.000000', 'temperatura', 730.0000, 'ºC'),
	(97989, 108, '2015-03-15 00:54:25.000000', 'temperatura', 963.0000, 'ºC'),
	(97990, 108, '2015-03-15 00:54:26.000000', 'temperatura', 226.0000, 'ºC'),
	(97991, 108, '2015-03-15 00:54:27.000000', 'temperatura', 639.0000, 'ºC'),
	(97992, 108, '2015-03-15 00:54:28.000000', 'temperatura', 120.0000, 'ºC'),
	(97993, 108, '2015-03-15 00:54:29.000000', 'temperatura', 1084.0000, 'ºC'),
	(97994, 108, '2015-03-15 00:54:30.000000', 'temperatura', 260.0000, 'ºC'),
	(97995, 108, '2015-03-15 00:54:31.000000', 'temperatura', 449.0000, 'ºC'),
	(97996, 108, '2015-03-15 00:54:32.000000', 'temperatura', 265.0000, 'ºC'),
	(97997, 108, '2015-03-15 00:54:33.000000', 'temperatura', 1179.0000, 'ºC'),
	(97998, 108, '2015-03-15 00:54:34.000000', 'temperatura', 300.0000, 'ºC'),
	(97999, 108, '2015-03-15 00:54:35.000000', 'temperatura', 364.0000, 'ºC'),
	(98000, 108, '2015-03-15 00:54:36.000000', 'temperatura', 921.0000, 'ºC'),
	(98001, 108, '2015-03-15 00:54:37.000000', 'temperatura', 1114.0000, 'ºC'),
	(98002, 108, '2015-03-15 00:54:38.000000', 'temperatura', 408.0000, 'ºC'),
	(98003, 108, '2015-03-15 00:54:39.000000', 'temperatura', 1097.0000, 'ºC'),
	(98004, 108, '2015-03-15 00:54:40.000000', 'temperatura', 661.0000, 'ºC'),
	(98005, 108, '2015-03-15 00:54:41.000000', 'temperatura', 13.0000, 'ºC'),
	(98006, 108, '2015-03-15 00:54:42.000000', 'temperatura', 486.0000, 'ºC'),
	(98007, 108, '2015-03-15 00:54:43.000000', 'temperatura', 1188.0000, 'ºC'),
	(98008, 108, '2015-03-15 00:54:44.000000', 'temperatura', 886.0000, 'ºC'),
	(98009, 108, '2015-03-15 00:54:45.000000', 'temperatura', 865.0000, 'ºC'),
	(98010, 108, '2015-03-15 00:54:46.000000', 'temperatura', 466.0000, 'ºC'),
	(98011, 108, '2015-03-15 00:54:47.000000', 'temperatura', 936.0000, 'ºC'),
	(98012, 108, '2015-03-15 00:54:48.000000', 'temperatura', 884.0000, 'ºC'),
	(98013, 108, '2015-03-15 00:54:49.000000', 'temperatura', 412.0000, 'ºC'),
	(98014, 108, '2015-03-15 00:54:50.000000', 'temperatura', 609.0000, 'ºC'),
	(98015, 108, '2015-03-15 00:54:51.000000', 'temperatura', 609.0000, 'ºC'),
	(98016, 108, '2015-03-15 00:54:52.000000', 'temperatura', 20.0000, 'ºC'),
	(98017, 108, '2015-03-15 00:54:53.000000', 'temperatura', 671.0000, 'ºC'),
	(98018, 108, '2015-03-15 00:54:54.000000', 'temperatura', 895.0000, 'ºC'),
	(98019, 108, '2015-03-15 00:54:55.000000', 'temperatura', 62.0000, 'ºC'),
	(98020, 108, '2015-03-15 00:54:56.000000', 'temperatura', 27.0000, 'ºC'),
	(98021, 108, '2015-03-15 00:54:57.000000', 'temperatura', 1149.0000, 'ºC'),
	(98022, 108, '2015-03-15 00:54:58.000000', 'temperatura', 865.0000, 'ºC'),
	(98023, 108, '2015-03-15 00:54:59.000000', 'temperatura', 879.0000, 'ºC'),
	(98024, 108, '2015-03-15 00:55:00.000000', 'temperatura', 600.0000, 'ºC'),
	(98025, 108, '2015-03-15 00:55:01.000000', 'temperatura', 362.0000, 'ºC'),
	(98026, 108, '2015-03-15 00:55:02.000000', 'temperatura', 12.0000, 'ºC'),
	(98027, 108, '2015-03-15 00:55:03.000000', 'temperatura', 176.0000, 'ºC'),
	(98028, 108, '2015-03-15 00:55:04.000000', 'temperatura', 842.0000, 'ºC'),
	(98029, 108, '2015-03-15 00:55:05.000000', 'temperatura', 83.0000, 'ºC'),
	(98030, 108, '2015-03-15 00:55:06.000000', 'temperatura', 292.0000, 'ºC'),
	(98031, 108, '2015-03-15 00:55:07.000000', 'temperatura', 8.0000, 'ºC'),
	(98032, 108, '2015-03-15 00:55:08.000000', 'temperatura', 368.0000, 'ºC'),
	(98033, 108, '2015-03-15 00:55:09.000000', 'temperatura', 613.0000, 'ºC'),
	(98034, 108, '2015-03-15 00:55:10.000000', 'temperatura', 765.0000, 'ºC'),
	(98035, 108, '2015-03-15 00:55:11.000000', 'temperatura', 784.0000, 'ºC'),
	(98036, 108, '2015-03-15 00:55:12.000000', 'temperatura', 427.0000, 'ºC'),
	(98037, 108, '2015-03-15 00:55:13.000000', 'temperatura', 984.0000, 'ºC'),
	(98038, 108, '2015-03-15 00:55:14.000000', 'temperatura', 38.0000, 'ºC'),
	(98039, 108, '2015-03-15 00:55:15.000000', 'temperatura', 840.0000, 'ºC'),
	(98040, 108, '2015-03-15 00:55:16.000000', 'temperatura', 487.0000, 'ºC'),
	(98041, 108, '2015-03-15 00:55:17.000000', 'temperatura', 1114.0000, 'ºC'),
	(98042, 108, '2015-03-15 00:55:18.000000', 'temperatura', 510.0000, 'ºC'),
	(98043, 108, '2015-03-15 00:55:19.000000', 'temperatura', 408.0000, 'ºC'),
	(98044, 108, '2015-03-15 00:55:20.000000', 'temperatura', 510.0000, 'ºC'),
	(98045, 108, '2015-03-15 00:55:21.000000', 'temperatura', 126.0000, 'ºC'),
	(98046, 108, '2015-03-15 00:55:22.000000', 'temperatura', 301.0000, 'ºC'),
	(98047, 108, '2015-03-15 00:55:23.000000', 'temperatura', 1127.0000, 'ºC'),
	(98048, 108, '2015-03-15 00:55:24.000000', 'temperatura', 1135.0000, 'ºC'),
	(98049, 108, '2015-03-15 00:55:25.000000', 'temperatura', 1094.0000, 'ºC'),
	(98050, 108, '2015-03-15 00:55:26.000000', 'temperatura', 863.0000, 'ºC'),
	(98051, 108, '2015-03-15 00:55:27.000000', 'temperatura', 1034.0000, 'ºC'),
	(98052, 108, '2015-03-15 00:55:28.000000', 'temperatura', 182.0000, 'ºC'),
	(98053, 108, '2015-03-15 00:55:29.000000', 'temperatura', 211.0000, 'ºC'),
	(98054, 108, '2015-03-15 00:55:30.000000', 'temperatura', 506.0000, 'ºC'),
	(98055, 108, '2015-03-15 00:55:31.000000', 'temperatura', 697.0000, 'ºC'),
	(98056, 108, '2015-03-15 00:55:32.000000', 'temperatura', 770.0000, 'ºC'),
	(98057, 108, '2015-03-15 00:55:33.000000', 'temperatura', 559.0000, 'ºC'),
	(98058, 108, '2015-03-15 00:55:34.000000', 'temperatura', 483.0000, 'ºC'),
	(98059, 108, '2015-03-15 00:55:35.000000', 'temperatura', 741.0000, 'ºC'),
	(98060, 108, '2015-03-15 00:55:36.000000', 'temperatura', 1057.0000, 'ºC'),
	(98061, 108, '2015-03-15 00:55:37.000000', 'temperatura', 660.0000, 'ºC'),
	(98062, 108, '2015-03-15 00:55:38.000000', 'temperatura', 129.0000, 'ºC'),
	(98063, 108, '2015-03-15 00:55:39.000000', 'temperatura', 1067.0000, 'ºC'),
	(98064, 108, '2015-03-15 00:55:40.000000', 'temperatura', 148.0000, 'ºC'),
	(98065, 108, '2015-03-15 00:55:41.000000', 'temperatura', 1139.0000, 'ºC'),
	(98066, 108, '2015-03-15 00:55:42.000000', 'temperatura', 450.0000, 'ºC'),
	(98067, 108, '2015-03-15 00:55:43.000000', 'temperatura', 36.0000, 'ºC'),
	(98068, 108, '2015-03-15 00:55:44.000000', 'temperatura', 29.0000, 'ºC'),
	(98069, 108, '2015-03-15 00:55:45.000000', 'temperatura', 36.0000, 'ºC'),
	(98070, 108, '2015-03-15 00:55:46.000000', 'temperatura', 96.0000, 'ºC'),
	(98071, 108, '2015-03-15 00:55:47.000000', 'temperatura', 370.0000, 'ºC'),
	(98072, 108, '2015-03-15 00:55:48.000000', 'temperatura', 364.0000, 'ºC'),
	(98073, 108, '2015-03-15 00:55:49.000000', 'temperatura', 712.0000, 'ºC'),
	(98074, 108, '2015-03-15 00:55:50.000000', 'temperatura', 67.0000, 'ºC'),
	(98075, 108, '2015-03-15 00:55:51.000000', 'temperatura', 598.0000, 'ºC'),
	(98076, 108, '2015-03-15 00:55:52.000000', 'temperatura', 393.0000, 'ºC'),
	(98077, 108, '2015-03-15 00:55:53.000000', 'temperatura', 169.0000, 'ºC'),
	(98078, 108, '2015-03-15 00:55:54.000000', 'temperatura', 868.0000, 'ºC'),
	(98079, 108, '2015-03-15 00:55:55.000000', 'temperatura', 233.0000, 'ºC'),
	(98080, 108, '2015-03-15 00:55:56.000000', 'temperatura', 962.0000, 'ºC'),
	(98081, 108, '2015-03-15 00:55:57.000000', 'temperatura', 510.0000, 'ºC'),
	(98082, 108, '2015-03-15 00:55:58.000000', 'temperatura', 864.0000, 'ºC'),
	(98083, 108, '2015-03-15 00:55:59.000000', 'temperatura', 393.0000, 'ºC'),
	(98084, 108, '2015-03-15 00:56:00.000000', 'temperatura', 572.0000, 'ºC'),
	(98085, 108, '2015-03-15 00:56:01.000000', 'temperatura', 481.0000, 'ºC'),
	(98086, 108, '2015-03-15 00:56:02.000000', 'temperatura', 691.0000, 'ºC'),
	(98087, 108, '2015-03-15 00:56:03.000000', 'temperatura', 813.0000, 'ºC'),
	(98088, 108, '2015-03-15 00:56:04.000000', 'temperatura', 790.0000, 'ºC'),
	(98089, 108, '2015-03-15 00:56:05.000000', 'temperatura', 314.0000, 'ºC'),
	(98090, 108, '2015-03-15 00:56:06.000000', 'temperatura', 399.0000, 'ºC'),
	(98091, 108, '2015-03-15 00:56:07.000000', 'temperatura', 1054.0000, 'ºC'),
	(98092, 108, '2015-03-15 00:56:08.000000', 'temperatura', 473.0000, 'ºC'),
	(98093, 108, '2015-03-15 00:56:09.000000', 'temperatura', 405.0000, 'ºC'),
	(98094, 108, '2015-03-15 00:56:10.000000', 'temperatura', 605.0000, 'ºC'),
	(98095, 108, '2015-03-15 00:56:11.000000', 'temperatura', 611.0000, 'ºC'),
	(98096, 108, '2015-03-15 00:56:12.000000', 'temperatura', 39.0000, 'ºC'),
	(98097, 108, '2015-03-15 00:56:13.000000', 'temperatura', 763.0000, 'ºC'),
	(98098, 108, '2015-03-15 00:56:14.000000', 'temperatura', 98.0000, 'ºC'),
	(98099, 108, '2015-03-15 00:56:15.000000', 'temperatura', 601.0000, 'ºC'),
	(98100, 108, '2015-03-15 00:56:16.000000', 'temperatura', 310.0000, 'ºC'),
	(98101, 108, '2015-03-15 00:56:17.000000', 'temperatura', 950.0000, 'ºC'),
	(98102, 108, '2015-03-15 00:56:18.000000', 'temperatura', 221.0000, 'ºC'),
	(98103, 108, '2015-03-15 00:56:19.000000', 'temperatura', 654.0000, 'ºC'),
	(98104, 108, '2015-03-15 00:56:20.000000', 'temperatura', 206.0000, 'ºC'),
	(98105, 108, '2015-03-15 00:56:21.000000', 'temperatura', 272.0000, 'ºC'),
	(98106, 108, '2015-03-15 00:56:22.000000', 'temperatura', 741.0000, 'ºC'),
	(98107, 108, '2015-03-15 00:56:23.000000', 'temperatura', 487.0000, 'ºC'),
	(98108, 108, '2015-03-15 00:56:24.000000', 'temperatura', 216.0000, 'ºC'),
	(98109, 108, '2015-03-15 00:56:25.000000', 'temperatura', 818.0000, 'ºC'),
	(98110, 108, '2015-03-15 00:56:26.000000', 'temperatura', 1041.0000, 'ºC'),
	(98111, 108, '2015-03-15 00:56:27.000000', 'temperatura', 353.0000, 'ºC'),
	(98112, 108, '2015-03-15 00:56:28.000000', 'temperatura', 1044.0000, 'ºC'),
	(98113, 108, '2015-03-15 00:56:29.000000', 'temperatura', 559.0000, 'ºC'),
	(98114, 108, '2015-03-15 00:56:30.000000', 'temperatura', 866.0000, 'ºC'),
	(98115, 108, '2015-03-15 00:56:31.000000', 'temperatura', 250.0000, 'ºC'),
	(98116, 108, '2015-03-15 00:56:32.000000', 'temperatura', 1055.0000, 'ºC'),
	(98117, 108, '2015-03-15 00:56:33.000000', 'temperatura', 926.0000, 'ºC'),
	(98118, 108, '2015-03-15 00:56:34.000000', 'temperatura', 267.0000, 'ºC'),
	(98119, 108, '2015-03-15 00:56:35.000000', 'temperatura', 955.0000, 'ºC'),
	(98120, 108, '2015-03-15 00:56:36.000000', 'temperatura', 373.0000, 'ºC'),
	(98121, 108, '2015-03-15 00:56:37.000000', 'temperatura', 204.0000, 'ºC'),
	(98122, 108, '2015-03-15 00:56:38.000000', 'temperatura', 1098.0000, 'ºC'),
	(98123, 108, '2015-03-15 00:56:39.000000', 'temperatura', 80.0000, 'ºC'),
	(98124, 108, '2015-03-15 00:56:40.000000', 'temperatura', 707.0000, 'ºC'),
	(98125, 108, '2015-03-15 00:56:41.000000', 'temperatura', 893.0000, 'ºC'),
	(98126, 108, '2015-03-15 00:56:42.000000', 'temperatura', 1146.0000, 'ºC'),
	(98127, 108, '2015-03-15 00:56:43.000000', 'temperatura', 652.0000, 'ºC'),
	(98128, 108, '2015-03-15 00:56:44.000000', 'temperatura', 1024.0000, 'ºC'),
	(98129, 108, '2015-03-15 00:56:45.000000', 'temperatura', 763.0000, 'ºC'),
	(98130, 108, '2015-03-15 00:56:46.000000', 'temperatura', 743.0000, 'ºC'),
	(98131, 108, '2015-03-15 00:56:47.000000', 'temperatura', 229.0000, 'ºC'),
	(98132, 108, '2015-03-15 00:56:48.000000', 'temperatura', 115.0000, 'ºC'),
	(98133, 108, '2015-03-15 00:56:49.000000', 'temperatura', 1089.0000, 'ºC'),
	(98134, 108, '2015-03-15 00:56:50.000000', 'temperatura', 302.0000, 'ºC'),
	(98135, 108, '2015-03-15 00:56:51.000000', 'temperatura', 642.0000, 'ºC'),
	(98136, 108, '2015-03-15 00:56:52.000000', 'temperatura', 1106.0000, 'ºC'),
	(98137, 108, '2015-03-15 00:56:53.000000', 'temperatura', 2.0000, 'ºC'),
	(98138, 108, '2015-03-15 00:56:54.000000', 'temperatura', 292.0000, 'ºC'),
	(98139, 108, '2015-03-15 00:56:55.000000', 'temperatura', 254.0000, 'ºC'),
	(98140, 108, '2015-03-15 00:56:56.000000', 'temperatura', 396.0000, 'ºC'),
	(98141, 108, '2015-03-15 00:56:57.000000', 'temperatura', 19.0000, 'ºC'),
	(98142, 108, '2015-03-15 00:56:58.000000', 'temperatura', 108.0000, 'ºC'),
	(98143, 108, '2015-03-15 00:56:59.000000', 'temperatura', 481.0000, 'ºC'),
	(98144, 108, '2015-03-15 00:57:00.000000', 'temperatura', 882.0000, 'ºC'),
	(98145, 108, '2015-03-15 00:57:01.000000', 'temperatura', 567.0000, 'ºC'),
	(98146, 108, '2015-03-15 00:57:02.000000', 'temperatura', 192.0000, 'ºC'),
	(98147, 108, '2015-03-15 00:57:03.000000', 'temperatura', 459.0000, 'ºC'),
	(98148, 108, '2015-03-15 00:57:04.000000', 'temperatura', 518.0000, 'ºC'),
	(98149, 108, '2015-03-15 00:57:05.000000', 'temperatura', 12.0000, 'ºC'),
	(98150, 108, '2015-03-15 00:57:06.000000', 'temperatura', 909.0000, 'ºC'),
	(98151, 108, '2015-03-15 00:57:07.000000', 'temperatura', 911.0000, 'ºC'),
	(98152, 108, '2015-03-15 00:57:08.000000', 'temperatura', 625.0000, 'ºC'),
	(98153, 108, '2015-03-15 00:57:09.000000', 'temperatura', 394.0000, 'ºC'),
	(98154, 108, '2015-03-15 00:57:10.000000', 'temperatura', 95.0000, 'ºC'),
	(98155, 108, '2015-03-15 00:57:11.000000', 'temperatura', 492.0000, 'ºC'),
	(98156, 108, '2015-03-15 00:57:12.000000', 'temperatura', 978.0000, 'ºC'),
	(98157, 108, '2015-03-15 00:57:13.000000', 'temperatura', 1015.0000, 'ºC'),
	(98158, 108, '2015-03-15 00:57:14.000000', 'temperatura', 939.0000, 'ºC'),
	(98159, 108, '2015-03-15 00:57:15.000000', 'temperatura', 451.0000, 'ºC'),
	(98160, 108, '2015-03-15 00:57:16.000000', 'temperatura', 640.0000, 'ºC'),
	(98161, 108, '2015-03-15 00:57:17.000000', 'temperatura', 648.0000, 'ºC'),
	(98162, 108, '2015-03-15 00:57:18.000000', 'temperatura', 119.0000, 'ºC'),
	(98163, 108, '2015-03-15 00:57:19.000000', 'temperatura', 1051.0000, 'ºC'),
	(98164, 108, '2015-03-15 00:57:20.000000', 'temperatura', 100.0000, 'ºC'),
	(98165, 108, '2015-03-15 00:57:21.000000', 'temperatura', 946.0000, 'ºC'),
	(98166, 108, '2015-03-15 00:57:22.000000', 'temperatura', 831.0000, 'ºC'),
	(98167, 108, '2015-03-15 00:57:23.000000', 'temperatura', 120.0000, 'ºC'),
	(98168, 108, '2015-03-15 00:57:24.000000', 'temperatura', 504.0000, 'ºC'),
	(98169, 108, '2015-03-15 00:57:25.000000', 'temperatura', 963.0000, 'ºC'),
	(98170, 108, '2015-03-15 00:57:26.000000', 'temperatura', 903.0000, 'ºC'),
	(98171, 108, '2015-03-15 00:57:27.000000', 'temperatura', 426.0000, 'ºC'),
	(98172, 108, '2015-03-15 00:57:28.000000', 'temperatura', 620.0000, 'ºC'),
	(98173, 108, '2015-03-15 00:57:29.000000', 'temperatura', 623.0000, 'ºC'),
	(98174, 108, '2015-03-15 00:57:30.000000', 'temperatura', 54.0000, 'ºC'),
	(98175, 108, '2015-03-15 00:57:31.000000', 'temperatura', 803.0000, 'ºC'),
	(98176, 108, '2015-03-15 00:57:32.000000', 'temperatura', 254.0000, 'ºC'),
	(98177, 108, '2015-03-15 00:57:33.000000', 'temperatura', 59.0000, 'ºC'),
	(98178, 108, '2015-03-15 00:57:34.000000', 'temperatura', 736.0000, 'ºC'),
	(98179, 108, '2015-03-15 00:57:35.000000', 'temperatura', 1102.0000, 'ºC'),
	(98180, 108, '2015-03-15 00:57:36.000000', 'temperatura', 905.0000, 'ºC'),
	(98181, 108, '2015-03-15 00:57:37.000000', 'temperatura', 18.0000, 'ºC'),
	(98182, 108, '2015-03-15 00:57:38.000000', 'temperatura', 974.0000, 'ºC'),
	(98183, 108, '2015-03-15 00:57:39.000000', 'temperatura', 17.0000, 'ºC'),
	(98184, 108, '2015-03-15 00:57:40.000000', 'temperatura', 764.0000, 'ºC'),
	(98185, 108, '2015-03-15 00:57:41.000000', 'temperatura', 167.0000, 'ºC'),
	(98186, 108, '2015-03-15 00:57:42.000000', 'temperatura', 947.0000, 'ºC'),
	(98187, 108, '2015-03-15 00:57:43.000000', 'temperatura', 634.0000, 'ºC'),
	(98188, 108, '2015-03-15 00:57:44.000000', 'temperatura', 328.0000, 'ºC'),
	(98189, 108, '2015-03-15 00:57:45.000000', 'temperatura', 937.0000, 'ºC'),
	(98190, 108, '2015-03-15 00:57:46.000000', 'temperatura', 104.0000, 'ºC'),
	(98191, 108, '2015-03-15 00:57:47.000000', 'temperatura', 108.0000, 'ºC'),
	(98192, 108, '2015-03-15 00:57:48.000000', 'temperatura', 228.0000, 'ºC'),
	(98193, 108, '2015-03-15 00:57:49.000000', 'temperatura', 818.0000, 'ºC'),
	(98194, 108, '2015-03-15 00:57:50.000000', 'temperatura', 1006.0000, 'ºC'),
	(98195, 108, '2015-03-15 00:57:51.000000', 'temperatura', 178.0000, 'ºC'),
	(98196, 108, '2015-03-15 00:57:52.000000', 'temperatura', 272.0000, 'ºC'),
	(98197, 108, '2015-03-15 00:57:53.000000', 'temperatura', 826.0000, 'ºC'),
	(98198, 108, '2015-03-15 00:57:54.000000', 'temperatura', 916.0000, 'ºC'),
	(98199, 108, '2015-03-15 00:57:55.000000', 'temperatura', 900.0000, 'ºC'),
	(98200, 108, '2015-03-15 00:57:56.000000', 'temperatura', 552.0000, 'ºC'),
	(98201, 108, '2015-03-15 00:57:57.000000', 'temperatura', 61.0000, 'ºC'),
	(98202, 108, '2015-03-15 00:57:58.000000', 'temperatura', 1048.0000, 'ºC'),
	(98203, 108, '2015-03-15 00:57:59.000000', 'temperatura', 259.0000, 'ºC'),
	(98204, 108, '2015-03-15 00:58:00.000000', 'temperatura', 550.0000, 'ºC'),
	(98205, 108, '2015-03-15 00:58:01.000000', 'temperatura', 776.0000, 'ºC'),
	(98206, 108, '2015-03-15 00:58:02.000000', 'temperatura', 1030.0000, 'ºC'),
	(98207, 108, '2015-03-15 00:58:03.000000', 'temperatura', 420.0000, 'ºC'),
	(98208, 108, '2015-03-15 00:58:04.000000', 'temperatura', 214.0000, 'ºC'),
	(98209, 108, '2015-03-15 00:58:05.000000', 'temperatura', 1008.0000, 'ºC'),
	(98210, 108, '2015-03-15 00:58:06.000000', 'temperatura', 797.0000, 'ºC'),
	(98211, 108, '2015-03-15 00:58:07.000000', 'temperatura', 964.0000, 'ºC'),
	(98212, 108, '2015-03-15 00:58:08.000000', 'temperatura', 28.0000, 'ºC'),
	(98213, 108, '2015-03-15 00:58:09.000000', 'temperatura', 847.0000, 'ºC'),
	(98214, 108, '2015-03-15 00:58:10.000000', 'temperatura', 554.0000, 'ºC'),
	(98215, 108, '2015-03-15 00:58:11.000000', 'temperatura', 231.0000, 'ºC'),
	(98216, 108, '2015-03-15 00:58:12.000000', 'temperatura', 692.0000, 'ºC'),
	(98217, 108, '2015-03-15 00:58:13.000000', 'temperatura', 365.0000, 'ºC'),
	(98218, 108, '2015-03-15 00:58:14.000000', 'temperatura', 953.0000, 'ºC'),
	(98219, 108, '2015-03-15 00:58:15.000000', 'temperatura', 69.0000, 'ºC'),
	(98220, 108, '2015-03-15 00:58:16.000000', 'temperatura', 1086.0000, 'ºC'),
	(98221, 108, '2015-03-15 00:58:17.000000', 'temperatura', 425.0000, 'ºC'),
	(98222, 108, '2015-03-15 00:58:18.000000', 'temperatura', 67.0000, 'ºC'),
	(98223, 108, '2015-03-15 00:58:19.000000', 'temperatura', 260.0000, 'ºC'),
	(98224, 108, '2015-03-15 00:58:20.000000', 'temperatura', 1102.0000, 'ºC'),
	(98225, 108, '2015-03-15 00:58:21.000000', 'temperatura', 1127.0000, 'ºC'),
	(98226, 108, '2015-03-15 00:58:22.000000', 'temperatura', 1130.0000, 'ºC'),
	(98227, 108, '2015-03-15 00:58:23.000000', 'temperatura', 1071.0000, 'ºC'),
	(98228, 108, '2015-03-15 00:58:24.000000', 'temperatura', 766.0000, 'ºC'),
	(98229, 108, '2015-03-15 00:58:25.000000', 'temperatura', 615.0000, 'ºC'),
	(98230, 108, '2015-03-15 00:58:26.000000', 'temperatura', 779.0000, 'ºC'),
	(98231, 108, '2015-03-15 00:58:27.000000', 'temperatura', 851.0000, 'ºC'),
	(98232, 108, '2015-03-15 00:58:28.000000', 'temperatura', 719.0000, 'ºC'),
	(98233, 108, '2015-03-15 00:58:29.000000', 'temperatura', 1044.0000, 'ºC'),
	(98234, 108, '2015-03-15 00:58:30.000000', 'temperatura', 661.0000, 'ºC'),
	(98235, 108, '2015-03-15 00:58:31.000000', 'temperatura', 176.0000, 'ºC'),
	(98236, 108, '2015-03-15 00:58:32.000000', 'temperatura', 95.0000, 'ºC'),
	(98237, 108, '2015-03-15 00:58:33.000000', 'temperatura', 1150.0000, 'ºC'),
	(98238, 108, '2015-03-15 00:58:34.000000', 'temperatura', 665.0000, 'ºC'),
	(98239, 108, '2015-03-15 00:58:35.000000', 'temperatura', 1074.0000, 'ºC'),
	(98240, 108, '2015-03-15 00:58:36.000000', 'temperatura', 975.0000, 'ºC'),
	(98241, 108, '2015-03-15 00:58:37.000000', 'temperatura', 454.0000, 'ºC'),
	(98242, 108, '2015-03-15 00:58:38.000000', 'temperatura', 547.0000, 'ºC'),
	(98243, 108, '2015-03-15 00:58:39.000000', 'temperatura', 175.0000, 'ºC'),
	(98244, 108, '2015-03-15 00:58:40.000000', 'temperatura', 431.0000, 'ºC'),
	(98245, 108, '2015-03-15 00:58:41.000000', 'temperatura', 433.0000, 'ºC'),
	(98246, 108, '2015-03-15 00:58:42.000000', 'temperatura', 871.0000, 'ºC'),
	(98247, 108, '2015-03-15 00:58:43.000000', 'temperatura', 659.0000, 'ºC'),
	(98248, 108, '2015-03-15 00:58:44.000000', 'temperatura', 681.0000, 'ºC'),
	(98249, 108, '2015-03-15 00:58:45.000000', 'temperatura', 228.0000, 'ºC'),
	(98250, 108, '2015-03-15 00:58:46.000000', 'temperatura', 298.0000, 'ºC'),
	(98251, 108, '2015-03-15 00:58:47.000000', 'temperatura', 807.0000, 'ºC'),
	(98252, 108, '2015-03-15 00:58:48.000000', 'temperatura', 740.0000, 'ºC'),
	(98253, 108, '2015-03-15 00:58:49.000000', 'temperatura', 81.0000, 'ºC'),
	(98254, 108, '2015-03-15 00:58:50.000000', 'temperatura', 586.0000, 'ºC'),
	(98255, 108, '2015-03-15 00:58:51.000000', 'temperatura', 289.0000, 'ºC'),
	(98256, 108, '2015-03-15 00:58:52.000000', 'temperatura', 885.0000, 'ºC'),
	(98257, 108, '2015-03-15 00:58:53.000000', 'temperatura', 1161.0000, 'ºC'),
	(98258, 108, '2015-03-15 00:58:54.000000', 'temperatura', 750.0000, 'ºC'),
	(98259, 108, '2015-03-15 00:58:55.000000', 'temperatura', 266.0000, 'ºC'),
	(98260, 108, '2015-03-15 00:58:56.000000', 'temperatura', 283.0000, 'ºC'),
	(98261, 108, '2015-03-15 00:58:57.000000', 'temperatura', 617.0000, 'ºC'),
	(98262, 108, '2015-03-15 00:58:58.000000', 'temperatura', 1035.0000, 'ºC'),
	(98263, 108, '2015-03-15 00:58:59.000000', 'temperatura', 924.0000, 'ºC'),
	(98264, 108, '2015-03-15 00:59:00.000000', 'temperatura', 318.0000, 'ºC'),
	(98265, 108, '2015-03-15 00:59:01.000000', 'temperatura', 16.0000, 'ºC'),
	(98266, 108, '2015-03-15 00:59:02.000000', 'temperatura', 328.0000, 'ºC'),
	(98267, 108, '2015-03-15 00:59:03.000000', 'temperatura', 390.0000, 'ºC'),
	(98268, 108, '2015-03-15 00:59:04.000000', 'temperatura', 969.0000, 'ºC'),
	(98269, 108, '2015-03-15 00:59:05.000000', 'temperatura', 74.0000, 'ºC'),
	(98270, 108, '2015-03-15 00:59:06.000000', 'temperatura', 1064.0000, 'ºC'),
	(98271, 108, '2015-03-15 00:59:07.000000', 'temperatura', 299.0000, 'ºC'),
	(98272, 108, '2015-03-15 00:59:08.000000', 'temperatura', 703.0000, 'ºC'),
	(98273, 108, '2015-03-15 00:59:09.000000', 'temperatura', 217.0000, 'ºC'),
	(98274, 108, '2015-03-15 00:59:10.000000', 'temperatura', 176.0000, 'ºC'),
	(98275, 108, '2015-03-15 00:59:11.000000', 'temperatura', 228.0000, 'ºC'),
	(98276, 108, '2015-03-15 00:59:12.000000', 'temperatura', 616.0000, 'ºC'),
	(98277, 108, '2015-03-15 00:59:13.000000', 'temperatura', 1197.0000, 'ºC'),
	(98278, 108, '2015-03-15 00:59:14.000000', 'temperatura', 537.0000, 'ºC'),
	(98279, 108, '2015-03-15 00:59:15.000000', 'temperatura', 295.0000, 'ºC'),
	(98280, 108, '2015-03-15 00:59:16.000000', 'temperatura', 1062.0000, 'ºC'),
	(98281, 108, '2015-03-15 00:59:17.000000', 'temperatura', 826.0000, 'ºC'),
	(98282, 108, '2015-03-15 00:59:18.000000', 'temperatura', 946.0000, 'ºC'),
	(98283, 108, '2015-03-15 00:59:19.000000', 'temperatura', 1053.0000, 'ºC'),
	(98284, 108, '2015-03-15 00:59:20.000000', 'temperatura', 28.0000, 'ºC'),
	(98285, 108, '2015-03-15 00:59:21.000000', 'temperatura', 581.0000, 'ºC'),
	(98286, 108, '2015-03-15 00:59:22.000000', 'temperatura', 419.0000, 'ºC'),
	(98287, 108, '2015-03-15 00:59:23.000000', 'temperatura', 355.0000, 'ºC'),
	(98288, 108, '2015-03-15 00:59:24.000000', 'temperatura', 516.0000, 'ºC'),
	(98289, 108, '2015-03-15 00:59:25.000000', 'temperatura', 318.0000, 'ºC'),
	(98290, 108, '2015-03-15 00:59:26.000000', 'temperatura', 43.0000, 'ºC'),
	(98291, 108, '2015-03-15 00:59:27.000000', 'temperatura', 458.0000, 'ºC'),
	(98292, 108, '2015-03-15 00:59:28.000000', 'temperatura', 965.0000, 'ºC'),
	(98293, 108, '2015-03-15 00:59:29.000000', 'temperatura', 1052.0000, 'ºC'),
	(98294, 108, '2015-03-15 00:59:30.000000', 'temperatura', 1162.0000, 'ºC'),
	(98295, 108, '2015-03-15 00:59:31.000000', 'temperatura', 257.0000, 'ºC'),
	(98296, 108, '2015-03-15 00:59:32.000000', 'temperatura', 200.0000, 'ºC'),
	(98297, 108, '2015-03-15 00:59:33.000000', 'temperatura', 228.0000, 'ºC'),
	(98298, 108, '2015-03-15 00:59:34.000000', 'temperatura', 540.0000, 'ºC'),
	(98299, 108, '2015-03-15 00:59:35.000000', 'temperatura', 819.0000, 'ºC'),
	(98300, 108, '2015-03-15 00:59:36.000000', 'temperatura', 75.0000, 'ºC'),
	(98301, 108, '2015-03-15 00:59:37.000000', 'temperatura', 319.0000, 'ºC'),
	(98302, 108, '2015-03-15 00:59:38.000000', 'temperatura', 170.0000, 'ºC'),
	(98303, 108, '2015-03-15 00:59:39.000000', 'temperatura', 1093.0000, 'ºC'),
	(98304, 108, '2015-03-15 00:59:40.000000', 'temperatura', 156.0000, 'ºC'),
	(98305, 108, '2015-03-15 00:59:41.000000', 'temperatura', 1101.0000, 'ºC'),
	(98306, 108, '2015-03-15 00:59:42.000000', 'temperatura', 236.0000, 'ºC'),
	(98307, 108, '2015-03-15 00:59:43.000000', 'temperatura', 278.0000, 'ºC'),
	(98308, 108, '2015-03-15 00:59:44.000000', 'temperatura', 685.0000, 'ºC'),
	(98309, 108, '2015-03-15 00:59:45.000000', 'temperatura', 189.0000, 'ºC'),
	(98310, 108, '2015-03-15 00:59:46.000000', 'temperatura', 92.0000, 'ºC'),
	(98311, 108, '2015-03-15 00:59:47.000000', 'temperatura', 1094.0000, 'ºC'),
	(98312, 108, '2015-03-15 00:59:48.000000', 'temperatura', 395.0000, 'ºC'),
	(98313, 108, '2015-03-15 00:59:49.000000', 'temperatura', 1095.0000, 'ºC'),
	(98314, 108, '2015-03-15 00:59:50.000000', 'temperatura', 688.0000, 'ºC'),
	(98315, 108, '2015-03-15 00:59:51.000000', 'temperatura', 156.0000, 'ºC'),
	(98316, 108, '2015-03-15 00:59:52.000000', 'temperatura', 1117.0000, 'ºC'),
	(98317, 108, '2015-03-15 00:59:53.000000', 'temperatura', 318.0000, 'ºC'),
	(98318, 108, '2015-03-15 00:59:54.000000', 'temperatura', 640.0000, 'ºC'),
	(98319, 108, '2015-03-15 00:59:55.000000', 'temperatura', 1047.0000, 'ºC'),
	(98320, 108, '2015-03-15 00:59:56.000000', 'temperatura', 914.0000, 'ºC'),
	(98321, 108, '2015-03-15 00:59:57.000000', 'temperatura', 232.0000, 'ºC'),
	(98322, 108, '2015-03-15 00:59:58.000000', 'temperatura', 816.0000, 'ºC'),
	(98323, 108, '2015-03-15 00:59:59.000000', 'temperatura', 987.0000, 'ºC'),
	(98324, 108, '2015-03-15 01:00:00.000000', 'temperatura', 87.0000, 'ºC'),
	(98325, 108, '2015-03-15 01:00:01.000000', 'temperatura', 1074.0000, 'ºC'),
	(98326, 108, '2015-03-15 01:00:02.000000', 'temperatura', 309.0000, 'ºC'),
	(98327, 108, '2015-03-15 01:00:03.000000', 'temperatura', 722.0000, 'ºC'),
	(98328, 108, '2015-03-15 01:00:04.000000', 'temperatura', 285.0000, 'ºC'),
	(98329, 108, '2015-03-15 01:00:05.000000', 'temperatura', 460.0000, 'ºC'),
	(98330, 108, '2015-03-15 01:00:06.000000', 'temperatura', 243.0000, 'ºC'),
	(98331, 108, '2015-03-15 01:00:07.000000', 'temperatura', 1037.0000, 'ºC'),
	(98332, 108, '2015-03-15 01:00:08.000000', 'temperatura', 856.0000, 'ºC'),
	(98333, 108, '2015-03-15 01:00:09.000000', 'temperatura', 1169.0000, 'ºC'),
	(98334, 108, '2015-03-15 01:00:10.000000', 'temperatura', 878.0000, 'ºC'),
	(98335, 108, '2015-03-15 01:00:11.000000', 'temperatura', 884.0000, 'ºC'),
	(98336, 108, '2015-03-15 01:00:12.000000', 'temperatura', 586.0000, 'ºC'),
	(98337, 108, '2015-03-15 01:00:13.000000', 'temperatura', 278.0000, 'ºC'),
	(98338, 108, '2015-03-15 01:00:14.000000', 'temperatura', 831.0000, 'ºC'),
	(98339, 108, '2015-03-15 01:00:15.000000', 'temperatura', 922.0000, 'ºC'),
	(98340, 108, '2015-03-15 01:00:16.000000', 'temperatura', 920.0000, 'ºC'),
	(98341, 108, '2015-03-15 01:00:17.000000', 'temperatura', 633.0000, 'ºC'),
	(98342, 108, '2015-03-15 01:00:18.000000', 'temperatura', 406.0000, 'ºC'),
	(98343, 108, '2015-03-15 01:00:19.000000', 'temperatura', 129.0000, 'ºC'),
	(98344, 108, '2015-03-15 01:00:20.000000', 'temperatura', 630.0000, 'ºC'),
	(98345, 108, '2015-03-15 01:00:21.000000', 'temperatura', 362.0000, 'ºC'),
	(98346, 108, '2015-03-15 01:00:22.000000', 'temperatura', 1122.0000, 'ºC'),
	(98347, 108, '2015-03-15 01:00:23.000000', 'temperatura', 925.0000, 'ºC'),
	(98348, 108, '2015-03-15 01:00:24.000000', 'temperatura', 59.0000, 'ºC'),
	(98349, 108, '2015-03-15 01:00:25.000000', 'temperatura', 1120.0000, 'ºC'),
	(98350, 108, '2015-03-15 01:00:26.000000', 'temperatura', 625.0000, 'ºC'),
	(98351, 108, '2015-03-15 01:00:27.000000', 'temperatura', 965.0000, 'ºC'),
	(98352, 108, '2015-03-15 01:00:28.000000', 'temperatura', 552.0000, 'ºC'),
	(98353, 108, '2015-03-15 01:00:29.000000', 'temperatura', 1065.0000, 'ºC'),
	(98354, 108, '2015-03-15 01:00:30.000000', 'temperatura', 71.0000, 'ºC'),
	(98355, 108, '2015-03-15 01:00:31.000000', 'temperatura', 758.0000, 'ºC'),
	(98356, 108, '2015-03-15 01:00:32.000000', 'temperatura', 1176.0000, 'ºC'),
	(98357, 108, '2015-03-15 01:00:33.000000', 'temperatura', 10.0000, 'ºC'),
	(98358, 108, '2015-03-15 01:00:34.000000', 'temperatura', 119.0000, 'ºC'),
	(98359, 108, '2015-03-15 01:00:35.000000', 'temperatura', 568.0000, 'ºC'),
	(98360, 108, '2015-03-15 01:00:36.000000', 'temperatura', 83.0000, 'ºC'),
	(98361, 108, '2015-03-15 01:00:37.000000', 'temperatura', 1111.0000, 'ºC'),
	(98362, 108, '2015-03-15 01:00:38.000000', 'temperatura', 506.0000, 'ºC'),
	(98363, 108, '2015-03-15 01:00:39.000000', 'temperatura', 399.0000, 'ºC'),
	(98364, 108, '2015-03-15 01:00:40.000000', 'temperatura', 479.0000, 'ºC'),
	(98365, 108, '2015-03-15 01:00:41.000000', 'temperatura', 1195.0000, 'ºC'),
	(98366, 108, '2015-03-15 01:00:42.000000', 'temperatura', 940.0000, 'ºC'),
	(98367, 108, '2015-03-15 01:00:43.000000', 'temperatura', 1115.0000, 'ºC'),
	(98368, 108, '2015-03-15 01:00:44.000000', 'temperatura', 354.0000, 'ºC'),
	(98369, 108, '2015-03-15 01:00:45.000000', 'temperatura', 828.0000, 'ºC'),
	(98370, 108, '2015-03-15 01:00:46.000000', 'temperatura', 676.0000, 'ºC'),
	(98371, 108, '2015-03-15 01:00:47.000000', 'temperatura', 897.0000, 'ºC'),
	(98372, 108, '2015-03-15 01:00:48.000000', 'temperatura', 60.0000, 'ºC'),
	(98373, 108, '2015-03-15 01:00:49.000000', 'temperatura', 8.0000, 'ºC'),
	(98374, 108, '2015-03-15 01:00:50.000000', 'temperatura', 1060.0000, 'ºC'),
	(98375, 108, '2015-03-15 01:00:51.000000', 'temperatura', 479.0000, 'ºC'),
	(98376, 108, '2015-03-15 01:00:52.000000', 'temperatura', 412.0000, 'ºC'),
	(98377, 108, '2015-03-15 01:00:53.000000', 'temperatura', 625.0000, 'ºC'),
	(98378, 108, '2015-03-15 01:00:54.000000', 'temperatura', 689.0000, 'ºC'),
	(98379, 108, '2015-03-15 01:00:55.000000', 'temperatura', 371.0000, 'ºC'),
	(98380, 108, '2015-03-15 01:00:56.000000', 'temperatura', 987.0000, 'ºC'),
	(98381, 108, '2015-03-15 01:00:57.000000', 'temperatura', 223.0000, 'ºC'),
	(98382, 108, '2015-03-15 01:00:58.000000', 'temperatura', 556.0000, 'ºC'),
	(98383, 108, '2015-03-15 01:00:59.000000', 'temperatura', 909.0000, 'ºC'),
	(98384, 108, '2015-03-15 01:01:00.000000', 'temperatura', 481.0000, 'ºC'),
	(98385, 108, '2015-03-15 01:01:01.000000', 'temperatura', 875.0000, 'ºC'),
	(98386, 108, '2015-03-15 01:01:02.000000', 'temperatura', 536.0000, 'ºC'),
	(98387, 108, '2015-03-15 01:01:03.000000', 'temperatura', 52.0000, 'ºC'),
	(98388, 108, '2015-03-15 01:01:04.000000', 'temperatura', 1054.0000, 'ºC'),
	(98389, 108, '2015-03-15 01:01:05.000000', 'temperatura', 315.0000, 'ºC'),
	(98390, 108, '2015-03-15 01:01:06.000000', 'temperatura', 814.0000, 'ºC'),
	(98391, 108, '2015-03-15 01:01:07.000000', 'temperatura', 723.0000, 'ºC'),
	(98392, 108, '2015-03-15 01:01:08.000000', 'temperatura', 1174.0000, 'ºC'),
	(98393, 108, '2015-03-15 01:01:09.000000', 'temperatura', 104.0000, 'ºC'),
	(98394, 108, '2015-03-15 01:01:10.000000', 'temperatura', 596.0000, 'ºC'),
	(98395, 108, '2015-03-15 01:01:11.000000', 'temperatura', 270.0000, 'ºC'),
	(98396, 108, '2015-03-15 01:01:12.000000', 'temperatura', 760.0000, 'ºC'),
	(98397, 108, '2015-03-15 01:01:13.000000', 'temperatura', 593.0000, 'ºC'),
	(98398, 108, '2015-03-15 01:01:14.000000', 'temperatura', 684.0000, 'ºC'),
	(98399, 108, '2015-03-15 01:01:15.000000', 'temperatura', 440.0000, 'ºC'),
	(98400, 108, '2015-03-15 01:01:16.000000', 'temperatura', 150.0000, 'ºC'),
	(98401, 108, '2015-03-15 01:01:17.000000', 'temperatura', 630.0000, 'ºC'),
	(98402, 108, '2015-03-15 01:01:18.000000', 'temperatura', 301.0000, 'ºC'),
	(98403, 108, '2015-03-15 01:01:19.000000', 'temperatura', 814.0000, 'ºC'),
	(98404, 108, '2015-03-15 01:01:20.000000', 'temperatura', 767.0000, 'ºC'),
	(98405, 108, '2015-03-15 01:01:21.000000', 'temperatura', 195.0000, 'ºC'),
	(98406, 108, '2015-03-15 01:01:22.000000', 'temperatura', 1076.0000, 'ºC'),
	(98407, 108, '2015-03-15 01:01:23.000000', 'temperatura', 1195.0000, 'ºC'),
	(98408, 108, '2015-03-15 01:01:24.000000', 'temperatura', 346.0000, 'ºC'),
	(98409, 108, '2015-03-15 01:01:25.000000', 'temperatura', 548.0000, 'ºC'),
	(98410, 108, '2015-03-15 01:01:26.000000', 'temperatura', 500.0000, 'ºC'),
	(98411, 108, '2015-03-15 01:01:27.000000', 'temperatura', 858.0000, 'ºC'),
	(98412, 108, '2015-03-15 01:01:28.000000', 'temperatura', 389.0000, 'ºC'),
	(98413, 108, '2015-03-15 01:01:29.000000', 'temperatura', 572.0000, 'ºC'),
	(98414, 108, '2015-03-15 01:01:30.000000', 'temperatura', 492.0000, 'ºC'),
	(98415, 108, '2015-03-15 01:01:31.000000', 'temperatura', 745.0000, 'ºC'),
	(98416, 108, '2015-03-15 01:01:32.000000', 'temperatura', 1048.0000, 'ºC'),
	(98417, 108, '2015-03-15 01:01:33.000000', 'temperatura', 608.0000, 'ºC'),
	(98418, 108, '2015-03-15 01:01:34.000000', 'temperatura', 1095.0000, 'ºC'),
	(98419, 108, '2015-03-15 01:01:35.000000', 'temperatura', 52.0000, 'ºC'),
	(98420, 108, '2015-03-15 01:01:36.000000', 'temperatura', 576.0000, 'ºC'),
	(98421, 108, '2015-03-15 01:01:37.000000', 'temperatura', 324.0000, 'ºC'),
	(98422, 108, '2015-03-15 01:01:38.000000', 'temperatura', 1093.0000, 'ºC'),
	(98423, 108, '2015-03-15 01:01:39.000000', 'temperatura', 894.0000, 'ºC'),
	(98424, 108, '2015-03-15 01:01:40.000000', 'temperatura', 1189.0000, 'ºC'),
	(98425, 108, '2015-03-15 01:01:41.000000', 'temperatura', 865.0000, 'ºC'),
	(98426, 108, '2015-03-15 01:01:42.000000', 'temperatura', 760.0000, 'ºC'),
	(98427, 108, '2015-03-15 01:01:43.000000', 'temperatura', 6.0000, 'ºC'),
	(98428, 108, '2015-03-15 01:01:44.000000', 'temperatura', 148.0000, 'ºC'),
	(98429, 108, '2015-03-15 01:01:45.000000', 'temperatura', 722.0000, 'ºC'),
	(98430, 108, '2015-03-15 01:01:46.000000', 'temperatura', 769.0000, 'ºC'),
	(98431, 108, '2015-03-15 01:01:47.000000', 'temperatura', 480.0000, 'ºC'),
	(98432, 108, '2015-03-15 01:01:48.000000', 'temperatura', 91.0000, 'ºC'),
	(98433, 108, '2015-03-15 01:01:49.000000', 'temperatura', 214.0000, 'ºC'),
	(98434, 108, '2015-03-15 01:01:50.000000', 'temperatura', 801.0000, 'ºC'),
	(98435, 108, '2015-03-15 01:01:51.000000', 'temperatura', 962.0000, 'ºC'),
	(98436, 108, '2015-03-15 01:01:52.000000', 'temperatura', 6.0000, 'ºC'),
	(98437, 108, '2015-03-15 01:01:53.000000', 'temperatura', 748.0000, 'ºC'),
	(98438, 108, '2015-03-15 01:01:54.000000', 'temperatura', 119.0000, 'ºC'),
	(98439, 108, '2015-03-15 01:01:55.000000', 'temperatura', 753.0000, 'ºC'),
	(98440, 108, '2015-03-15 01:01:56.000000', 'temperatura', 1007.0000, 'ºC'),
	(98441, 108, '2015-03-15 01:01:57.000000', 'temperatura', 379.0000, 'ºC'),
	(98442, 108, '2015-03-15 01:01:58.000000', 'temperatura', 74.0000, 'ºC'),
	(98443, 108, '2015-03-15 01:01:59.000000', 'temperatura', 433.0000, 'ºC'),
	(98444, 108, '2015-03-15 01:02:00.000000', 'temperatura', 742.0000, 'ºC'),
	(98445, 108, '2015-03-15 01:02:01.000000', 'temperatura', 13.0000, 'ºC'),
	(98446, 108, '2015-03-15 01:02:02.000000', 'temperatura', 237.0000, 'ºC'),
	(98447, 108, '2015-03-15 01:02:03.000000', 'temperatura', 1148.0000, 'ºC'),
	(98448, 108, '2015-03-15 01:02:04.000000', 'temperatura', 231.0000, 'ºC'),
	(98449, 108, '2015-03-15 01:02:05.000000', 'temperatura', 111.0000, 'ºC'),
	(98450, 108, '2015-03-15 01:02:06.000000', 'temperatura', 1062.0000, 'ºC'),
	(98451, 108, '2015-03-15 01:02:07.000000', 'temperatura', 177.0000, 'ºC'),
	(98452, 108, '2015-03-15 01:02:08.000000', 'temperatura', 100.0000, 'ºC'),
	(98453, 108, '2015-03-15 01:02:09.000000', 'temperatura', 1171.0000, 'ºC'),
	(98454, 108, '2015-03-15 01:02:10.000000', 'temperatura', 754.0000, 'ºC'),
	(98455, 108, '2015-03-15 01:02:11.000000', 'temperatura', 257.0000, 'ºC'),
	(98456, 108, '2015-03-15 01:02:12.000000', 'temperatura', 222.0000, 'ºC'),
	(98457, 108, '2015-03-15 01:02:13.000000', 'temperatura', 342.0000, 'ºC'),
	(98458, 108, '2015-03-15 01:02:14.000000', 'temperatura', 1044.0000, 'ºC'),
	(98459, 108, '2015-03-15 01:02:15.000000', 'temperatura', 594.0000, 'ºC'),
	(98460, 108, '2015-03-15 01:02:16.000000', 'temperatura', 1037.0000, 'ºC'),
	(98461, 108, '2015-03-15 01:02:17.000000', 'temperatura', 1007.0000, 'ºC'),
	(98462, 108, '2015-03-15 01:02:18.000000', 'temperatura', 722.0000, 'ºC'),
	(98463, 108, '2015-03-15 01:02:19.000000', 'temperatura', 589.0000, 'ºC'),
	(98464, 108, '2015-03-15 01:02:20.000000', 'temperatura', 780.0000, 'ºC'),
	(98465, 108, '2015-03-15 01:02:21.000000', 'temperatura', 933.0000, 'ºC'),
	(98466, 108, '2015-03-15 01:02:22.000000', 'temperatura', 1124.0000, 'ºC'),
	(98467, 108, '2015-03-15 01:02:23.000000', 'temperatura', 425.0000, 'ºC'),
	(98468, 108, '2015-03-15 01:02:24.000000', 'temperatura', 1152.0000, 'ºC'),
	(98469, 108, '2015-03-15 01:02:25.000000', 'temperatura', 886.0000, 'ºC'),
	(98470, 108, '2015-03-15 01:02:26.000000', 'temperatura', 975.0000, 'ºC'),
	(98471, 108, '2015-03-15 01:02:27.000000', 'temperatura', 1017.0000, 'ºC'),
	(98472, 108, '2015-03-15 01:02:28.000000', 'temperatura', 959.0000, 'ºC'),
	(98473, 108, '2015-03-15 01:02:29.000000', 'temperatura', 545.0000, 'ºC'),
	(98474, 108, '2015-03-15 01:02:30.000000', 'temperatura', 1048.0000, 'ºC'),
	(98475, 108, '2015-03-15 01:02:31.000000', 'temperatura', 8.0000, 'ºC'),
	(98476, 108, '2015-03-15 01:02:32.000000', 'temperatura', 494.0000, 'ºC'),
	(98477, 108, '2015-03-15 01:02:33.000000', 'temperatura', 47.0000, 'ºC'),
	(98478, 108, '2015-03-15 01:02:34.000000', 'temperatura', 1153.0000, 'ºC'),
	(98479, 108, '2015-03-15 01:02:35.000000', 'temperatura', 823.0000, 'ºC'),
	(98480, 108, '2015-03-15 01:02:36.000000', 'temperatura', 659.0000, 'ºC'),
	(98481, 108, '2015-03-15 01:02:37.000000', 'temperatura', 826.0000, 'ºC'),
	(98482, 108, '2015-03-15 01:02:38.000000', 'temperatura', 953.0000, 'ºC'),
	(98483, 108, '2015-03-15 01:02:39.000000', 'temperatura', 1089.0000, 'ºC'),
	(98484, 108, '2015-03-15 01:02:40.000000', 'temperatura', 184.0000, 'ºC'),
	(98485, 108, '2015-03-15 01:02:41.000000', 'temperatura', 54.0000, 'ºC'),
	(98486, 108, '2015-03-15 01:02:42.000000', 'temperatura', 920.0000, 'ºC'),
	(98487, 108, '2015-03-15 01:02:43.000000', 'temperatura', 838.0000, 'ºC'),
	(98488, 108, '2015-03-15 01:02:44.000000', 'temperatura', 232.0000, 'ºC'),
	(98489, 108, '2015-03-15 01:02:45.000000', 'temperatura', 1046.0000, 'ºC'),
	(98490, 108, '2015-03-15 01:02:46.000000', 'temperatura', 932.0000, 'ºC'),
	(98491, 108, '2015-03-15 01:02:47.000000', 'temperatura', 325.0000, 'ºC'),
	(98492, 108, '2015-03-15 01:02:48.000000', 'temperatura', 30.0000, 'ºC'),
	(98493, 108, '2015-03-15 01:02:49.000000', 'temperatura', 374.0000, 'ºC'),
	(98494, 108, '2015-03-15 01:02:50.000000', 'temperatura', 582.0000, 'ºC'),
	(98495, 108, '2015-03-15 01:02:51.000000', 'temperatura', 589.0000, 'ºC'),
	(98496, 108, '2015-03-15 01:02:52.000000', 'temperatura', 0.0000, 'ºC'),
	(98497, 108, '2015-03-15 01:02:53.000000', 'temperatura', 633.0000, 'ºC'),
	(98498, 108, '2015-03-15 01:02:54.000000', 'temperatura', 767.0000, 'ºC'),
	(98499, 108, '2015-03-15 01:02:55.000000', 'temperatura', 736.0000, 'ºC'),
	(98500, 108, '2015-03-15 01:02:56.000000', 'temperatura', 181.0000, 'ºC'),
	(98501, 108, '2015-03-15 01:02:57.000000', 'temperatura', 1094.0000, 'ºC'),
	(98502, 108, '2015-03-15 01:02:58.000000', 'temperatura', 129.0000, 'ºC'),
	(98503, 108, '2015-03-15 01:02:59.000000', 'temperatura', 964.0000, 'ºC'),
	(98504, 108, '2015-03-15 01:03:00.000000', 'temperatura', 831.0000, 'ºC'),
	(98505, 108, '2015-03-15 01:03:01.000000', 'temperatura', 66.0000, 'ºC'),
	(98506, 108, '2015-03-15 01:03:02.000000', 'temperatura', 238.0000, 'ºC'),
	(98507, 108, '2015-03-15 01:03:03.000000', 'temperatura', 993.0000, 'ºC'),
	(98508, 108, '2015-03-15 01:03:04.000000', 'temperatura', 652.0000, 'ºC'),
	(98509, 108, '2015-03-15 01:03:05.000000', 'temperatura', 282.0000, 'ºC'),
	(98510, 108, '2015-03-15 01:03:06.000000', 'temperatura', 653.0000, 'ºC'),
	(98511, 108, '2015-03-15 01:03:07.000000', 'temperatura', 19.0000, 'ºC'),
	(98512, 108, '2015-03-15 01:03:08.000000', 'temperatura', 537.0000, 'ºC'),
	(98513, 108, '2015-03-15 01:03:09.000000', 'temperatura', 230.0000, 'ºC'),
	(98514, 108, '2015-03-15 01:03:10.000000', 'temperatura', 739.0000, 'ºC'),
	(98515, 108, '2015-03-15 01:03:11.000000', 'temperatura', 606.0000, 'ºC'),
	(98516, 108, '2015-03-15 01:03:12.000000', 'temperatura', 812.0000, 'ºC'),
	(98517, 108, '2015-03-15 01:03:13.000000', 'temperatura', 1043.0000, 'ºC'),
	(98518, 108, '2015-03-15 01:03:14.000000', 'temperatura', 379.0000, 'ºC'),
	(98519, 108, '2015-03-15 01:03:15.000000', 'temperatura', 1167.0000, 'ºC'),
	(98520, 108, '2015-03-15 01:03:16.000000', 'temperatura', 1097.0000, 'ºC'),
	(98521, 108, '2015-03-15 01:03:17.000000', 'temperatura', 785.0000, 'ºC'),
	(98522, 108, '2015-03-15 01:03:18.000000', 'temperatura', 633.0000, 'ºC'),
	(98523, 108, '2015-03-15 01:03:19.000000', 'temperatura', 812.0000, 'ºC'),
	(98524, 108, '2015-03-15 01:03:20.000000', 'temperatura', 963.0000, 'ºC'),
	(98525, 108, '2015-03-15 01:03:21.000000', 'temperatura', 1179.0000, 'ºC'),
	(98526, 108, '2015-03-15 01:03:22.000000', 'temperatura', 606.0000, 'ºC'),
	(98527, 108, '2015-03-15 01:03:23.000000', 'temperatura', 692.0000, 'ºC'),
	(98528, 108, '2015-03-15 01:03:24.000000', 'temperatura', 445.0000, 'ºC'),
	(98529, 108, '2015-03-15 01:03:25.000000', 'temperatura', 151.0000, 'ºC'),
	(98530, 108, '2015-03-15 01:03:26.000000', 'temperatura', 617.0000, 'ºC'),
	(98531, 108, '2015-03-15 01:03:27.000000', 'temperatura', 233.0000, 'ºC'),
	(98532, 108, '2015-03-15 01:03:28.000000', 'temperatura', 513.0000, 'ºC'),
	(98533, 108, '2015-03-15 01:03:29.000000', 'temperatura', 669.0000, 'ºC'),
	(98534, 108, '2015-03-15 01:03:30.000000', 'temperatura', 604.0000, 'ºC'),
	(98535, 108, '2015-03-15 01:03:31.000000', 'temperatura', 1013.0000, 'ºC'),
	(98536, 108, '2015-03-15 01:03:32.000000', 'temperatura', 857.0000, 'ºC'),
	(98537, 108, '2015-03-15 01:03:33.000000', 'temperatura', 43.0000, 'ºC'),
	(98538, 108, '2015-03-15 01:03:34.000000', 'temperatura', 46.0000, 'ºC'),
	(98539, 108, '2015-03-15 01:03:35.000000', 'temperatura', 103.0000, 'ºC'),
	(98540, 108, '2015-03-15 01:03:36.000000', 'temperatura', 375.0000, 'ºC'),
	(98541, 108, '2015-03-15 01:03:37.000000', 'temperatura', 369.0000, 'ºC'),
	(98542, 108, '2015-03-15 01:03:38.000000', 'temperatura', 719.0000, 'ºC'),
	(98543, 108, '2015-03-15 01:03:39.000000', 'temperatura', 88.0000, 'ºC'),
	(98544, 108, '2015-03-15 01:03:40.000000', 'temperatura', 685.0000, 'ºC'),
	(98545, 108, '2015-03-15 01:03:41.000000', 'temperatura', 762.0000, 'ºC'),
	(98546, 108, '2015-03-15 01:03:42.000000', 'temperatura', 556.0000, 'ºC'),
	(98547, 108, '2015-03-15 01:03:43.000000', 'temperatura', 492.0000, 'ºC'),
	(98548, 108, '2015-03-15 01:03:44.000000', 'temperatura', 795.0000, 'ºC'),
	(98549, 108, '2015-03-15 01:03:45.000000', 'temperatura', 97.0000, 'ºC'),
	(98550, 108, '2015-03-15 01:03:46.000000', 'temperatura', 502.0000, 'ºC'),
	(98551, 108, '2015-03-15 01:03:47.000000', 'temperatura', 1021.0000, 'ºC'),
	(98552, 108, '2015-03-15 01:03:48.000000', 'temperatura', 1199.0000, 'ºC'),
	(98553, 108, '2015-03-15 01:03:49.000000', 'temperatura', 534.0000, 'ºC'),
	(98554, 108, '2015-03-15 01:03:50.000000', 'temperatura', 271.0000, 'ºC'),
	(98555, 108, '2015-03-15 01:03:51.000000', 'temperatura', 953.0000, 'ºC'),
	(98556, 108, '2015-03-15 01:03:52.000000', 'temperatura', 353.0000, 'ºC'),
	(98557, 108, '2015-03-15 01:03:53.000000', 'temperatura', 107.0000, 'ºC'),
	(98558, 108, '2015-03-15 01:03:54.000000', 'temperatura', 677.0000, 'ºC'),
	(98559, 108, '2015-03-15 01:03:55.000000', 'temperatura', 665.0000, 'ºC'),
	(98560, 108, '2015-03-15 01:03:56.000000', 'temperatura', 93.0000, 'ºC'),
	(98561, 108, '2015-03-15 01:03:57.000000', 'temperatura', 870.0000, 'ºC'),
	(98562, 108, '2015-03-15 01:03:58.000000', 'temperatura', 474.0000, 'ºC'),
	(98563, 108, '2015-03-15 01:03:59.000000', 'temperatura', 960.0000, 'ºC'),
	(98564, 108, '2015-03-15 01:04:00.000000', 'temperatura', 976.0000, 'ºC'),
	(98565, 108, '2015-03-15 01:04:01.000000', 'temperatura', 803.0000, 'ºC'),
	(98566, 108, '2015-03-15 01:04:02.000000', 'temperatura', 1086.0000, 'ºC'),
	(98567, 108, '2015-03-15 01:04:03.000000', 'temperatura', 621.0000, 'ºC'),
	(98568, 108, '2015-03-15 01:04:04.000000', 'temperatura', 1050.0000, 'ºC'),
	(98569, 108, '2015-03-15 01:04:05.000000', 'temperatura', 987.0000, 'ºC'),
	(98570, 108, '2015-03-15 01:04:06.000000', 'temperatura', 586.0000, 'ºC'),
	(98571, 108, '2015-03-15 01:04:07.000000', 'temperatura', 1169.0000, 'ºC'),
	(98572, 108, '2015-03-15 01:04:08.000000', 'temperatura', 486.0000, 'ºC'),
	(98573, 108, '2015-03-15 01:04:09.000000', 'temperatura', 126.0000, 'ºC'),
	(98574, 108, '2015-03-15 01:04:10.000000', 'temperatura', 370.0000, 'ºC'),
	(98575, 108, '2015-03-15 01:04:11.000000', 'temperatura', 274.0000, 'ºC'),
	(98576, 108, '2015-03-15 01:04:12.000000', 'temperatura', 261.0000, 'ºC'),
	(98577, 108, '2015-03-15 01:04:13.000000', 'temperatura', 483.0000, 'ºC'),
	(98578, 108, '2015-03-15 01:04:14.000000', 'temperatura', 433.0000, 'ºC'),
	(98579, 108, '2015-03-15 01:04:15.000000', 'temperatura', 717.0000, 'ºC'),
	(98580, 108, '2015-03-15 01:04:16.000000', 'temperatura', 1085.0000, 'ºC'),
	(98581, 108, '2015-03-15 01:04:17.000000', 'temperatura', 874.0000, 'ºC'),
	(98582, 108, '2015-03-15 01:04:18.000000', 'temperatura', 1117.0000, 'ºC'),
	(98583, 108, '2015-03-15 01:04:19.000000', 'temperatura', 561.0000, 'ºC'),
	(98584, 108, '2015-03-15 01:04:20.000000', 'temperatura', 657.0000, 'ºC'),
	(98585, 108, '2015-03-15 01:04:21.000000', 'temperatura', 404.0000, 'ºC'),
	(98586, 108, '2015-03-15 01:04:22.000000', 'temperatura', 47.0000, 'ºC'),
	(98587, 108, '2015-03-15 01:04:23.000000', 'temperatura', 222.0000, 'ºC'),
	(98588, 108, '2015-03-15 01:04:24.000000', 'temperatura', 973.0000, 'ºC'),
	(98589, 108, '2015-03-15 01:04:25.000000', 'temperatura', 597.0000, 'ºC'),
	(98590, 108, '2015-03-15 01:04:26.000000', 'temperatura', 67.0000, 'ºC'),
	(98591, 108, '2015-03-15 01:04:27.000000', 'temperatura', 944.0000, 'ºC'),
	(98592, 108, '2015-03-15 01:04:28.000000', 'temperatura', 919.0000, 'ºC'),
	(98593, 108, '2015-03-15 01:04:29.000000', 'temperatura', 565.0000, 'ºC'),
	(98594, 108, '2015-03-15 01:04:30.000000', 'temperatura', 69.0000, 'ºC'),
	(98595, 108, '2015-03-15 01:04:31.000000', 'temperatura', 1048.0000, 'ºC'),
	(98596, 108, '2015-03-15 01:04:32.000000', 'temperatura', 236.0000, 'ºC'),
	(98597, 108, '2015-03-15 01:04:33.000000', 'temperatura', 436.0000, 'ºC'),
	(98598, 108, '2015-03-15 01:04:34.000000', 'temperatura', 271.0000, 'ºC'),
	(98599, 108, '2015-03-15 01:04:35.000000', 'temperatura', 47.0000, 'ºC'),
	(98600, 108, '2015-03-15 01:04:36.000000', 'temperatura', 623.0000, 'ºC'),
	(98601, 108, '2015-03-15 01:04:37.000000', 'temperatura', 574.0000, 'ºC'),
	(98602, 108, '2015-03-15 01:04:38.000000', 'temperatura', 1001.0000, 'ºC'),
	(98603, 108, '2015-03-15 01:04:39.000000', 'temperatura', 884.0000, 'ºC'),
	(98604, 108, '2015-03-15 01:04:40.000000', 'temperatura', 217.0000, 'ºC'),
	(98605, 108, '2015-03-15 01:04:41.000000', 'temperatura', 834.0000, 'ºC'),
	(98606, 108, '2015-03-15 01:04:42.000000', 'temperatura', 1119.0000, 'ºC'),
	(98607, 108, '2015-03-15 01:04:43.000000', 'temperatura', 696.0000, 'ºC'),
	(98608, 108, '2015-03-15 01:04:44.000000', 'temperatura', 120.0000, 'ºC'),
	(98609, 108, '2015-03-15 01:04:45.000000', 'temperatura', 915.0000, 'ºC'),
	(98610, 108, '2015-03-15 01:04:46.000000', 'temperatura', 614.0000, 'ºC'),
	(98611, 108, '2015-03-15 01:04:47.000000', 'temperatura', 325.0000, 'ºC'),
	(98612, 108, '2015-03-15 01:04:48.000000', 'temperatura', 986.0000, 'ºC'),
	(98613, 108, '2015-03-15 01:04:49.000000', 'temperatura', 352.0000, 'ºC'),
	(98614, 108, '2015-03-15 01:04:50.000000', 'temperatura', 6.0000, 'ºC'),
	(98615, 108, '2015-03-15 01:04:51.000000', 'temperatura', 172.0000, 'ºC'),
	(98616, 108, '2015-03-15 01:04:52.000000', 'temperatura', 845.0000, 'ºC'),
	(98617, 108, '2015-03-15 01:04:53.000000', 'temperatura', 108.0000, 'ºC'),
	(98618, 108, '2015-03-15 01:04:54.000000', 'temperatura', 404.0000, 'ºC'),
	(98619, 108, '2015-03-15 01:04:55.000000', 'temperatura', 496.0000, 'ºC'),
	(98620, 108, '2015-03-15 01:04:56.000000', 'temperatura', 71.0000, 'ºC'),
	(98621, 108, '2015-03-15 01:04:57.000000', 'temperatura', 65.0000, 'ºC'),
	(98622, 108, '2015-03-15 01:04:58.000000', 'temperatura', 115.0000, 'ºC'),
	(98623, 108, '2015-03-15 01:04:59.000000', 'temperatura', 378.0000, 'ºC'),
	(98624, 108, '2015-03-15 01:05:00.000000', 'temperatura', 345.0000, 'ºC'),
	(98625, 108, '2015-03-15 01:05:01.000000', 'temperatura', 594.0000, 'ºC'),
	(98626, 108, '2015-03-15 01:05:02.000000', 'temperatura', 734.0000, 'ºC'),
	(98627, 108, '2015-03-15 01:05:03.000000', 'temperatura', 690.0000, 'ºC'),
	(98628, 108, '2015-03-15 01:05:04.000000', 'temperatura', 46.0000, 'ºC'),
	(98629, 108, '2015-03-15 01:05:05.000000', 'temperatura', 562.0000, 'ºC'),
	(98630, 108, '2015-03-15 01:05:06.000000', 'temperatura', 271.0000, 'ºC'),
	(98631, 108, '2015-03-15 01:05:07.000000', 'temperatura', 873.0000, 'ºC'),
	(98632, 108, '2015-03-15 01:05:08.000000', 'temperatura', 1149.0000, 'ºC'),
	(98633, 108, '2015-03-15 01:05:09.000000', 'temperatura', 726.0000, 'ºC'),
	(98634, 108, '2015-03-15 01:05:10.000000', 'temperatura', 186.0000, 'ºC'),
	(98635, 108, '2015-03-15 01:05:11.000000', 'temperatura', 1150.0000, 'ºC'),
	(98636, 108, '2015-03-15 01:05:12.000000', 'temperatura', 395.0000, 'ºC'),
	(98637, 108, '2015-03-15 01:05:13.000000', 'temperatura', 926.0000, 'ºC'),
	(98638, 108, '2015-03-15 01:05:14.000000', 'temperatura', 1044.0000, 'ºC'),
	(98639, 108, '2015-03-15 01:05:15.000000', 'temperatura', 41.0000, 'ºC'),
	(98640, 108, '2015-03-15 01:05:16.000000', 'temperatura', 675.0000, 'ºC'),
	(98641, 108, '2015-03-15 01:05:17.000000', 'temperatura', 854.0000, 'ºC'),
	(98642, 108, '2015-03-15 01:05:18.000000', 'temperatura', 1043.0000, 'ºC'),
	(98643, 108, '2015-03-15 01:05:19.000000', 'temperatura', 253.0000, 'ºC'),
	(98644, 108, '2015-03-15 01:05:20.000000', 'temperatura', 536.0000, 'ºC'),
	(98645, 108, '2015-03-15 01:05:21.000000', 'temperatura', 723.0000, 'ºC'),
	(98646, 108, '2015-03-15 01:05:22.000000', 'temperatura', 807.0000, 'ºC'),
	(98647, 108, '2015-03-15 01:05:23.000000', 'temperatura', 665.0000, 'ºC'),
	(98648, 108, '2015-03-15 01:05:24.000000', 'temperatura', 906.0000, 'ºC'),
	(98649, 108, '2015-03-15 01:05:25.000000', 'temperatura', 136.0000, 'ºC'),
	(98650, 108, '2015-03-15 01:05:26.000000', 'temperatura', 361.0000, 'ºC'),
	(98651, 108, '2015-03-15 01:05:27.000000', 'temperatura', 197.0000, 'ºC'),
	(98652, 108, '2015-03-15 01:05:28.000000', 'temperatura', 1104.0000, 'ºC'),
	(98653, 108, '2015-03-15 01:05:29.000000', 'temperatura', 130.0000, 'ºC'),
	(98654, 108, '2015-03-15 01:05:30.000000', 'temperatura', 940.0000, 'ºC'),
	(98655, 108, '2015-03-15 01:05:31.000000', 'temperatura', 709.0000, 'ºC'),
	(98656, 108, '2015-03-15 01:05:32.000000', 'temperatura', 725.0000, 'ºC'),
	(98657, 108, '2015-03-15 01:05:33.000000', 'temperatura', 298.0000, 'ºC'),
	(98658, 108, '2015-03-15 01:05:34.000000', 'temperatura', 515.0000, 'ºC'),
	(98659, 108, '2015-03-15 01:05:35.000000', 'temperatura', 480.0000, 'ºC'),
	(98660, 108, '2015-03-15 01:05:36.000000', 'temperatura', 858.0000, 'ºC'),
	(98661, 108, '2015-03-15 01:05:37.000000', 'temperatura', 448.0000, 'ºC'),
	(98662, 108, '2015-03-15 01:05:38.000000', 'temperatura', 868.0000, 'ºC'),
	(98663, 108, '2015-03-15 01:05:39.000000', 'temperatura', 596.0000, 'ºC'),
	(98664, 108, '2015-03-15 01:05:40.000000', 'temperatura', 379.0000, 'ºC'),
	(98665, 108, '2015-03-15 01:05:41.000000', 'temperatura', 104.0000, 'ºC'),
	(98666, 108, '2015-03-15 01:05:42.000000', 'temperatura', 585.0000, 'ºC'),
	(98667, 108, '2015-03-15 01:05:43.000000', 'temperatura', 213.0000, 'ºC'),
	(98668, 108, '2015-03-15 01:05:44.000000', 'temperatura', 510.0000, 'ºC'),
	(98669, 108, '2015-03-15 01:05:45.000000', 'temperatura', 711.0000, 'ºC'),
	(98670, 108, '2015-03-15 01:05:46.000000', 'temperatura', 828.0000, 'ºC'),
	(98671, 108, '2015-03-15 01:05:47.000000', 'temperatura', 806.0000, 'ºC'),
	(98672, 108, '2015-03-15 01:05:48.000000', 'temperatura', 347.0000, 'ºC'),
	(98673, 108, '2015-03-15 01:05:49.000000', 'temperatura', 519.0000, 'ºC'),
	(98674, 108, '2015-03-15 01:05:50.000000', 'temperatura', 353.0000, 'ºC'),
	(98675, 108, '2015-03-15 01:05:51.000000', 'temperatura', 207.0000, 'ºC'),
	(98676, 108, '2015-03-15 01:05:52.000000', 'temperatura', 1177.0000, 'ºC'),
	(98677, 108, '2015-03-15 01:05:53.000000', 'temperatura', 466.0000, 'ºC'),
	(98678, 108, '2015-03-15 01:05:54.000000', 'temperatura', 1198.0000, 'ºC'),
	(98679, 108, '2015-03-15 01:05:55.000000', 'temperatura', 993.0000, 'ºC'),
	(98680, 108, '2015-03-15 01:05:56.000000', 'temperatura', 171.0000, 'ºC'),
	(98681, 108, '2015-03-15 01:05:57.000000', 'temperatura', 275.0000, 'ºC'),
	(98682, 108, '2015-03-15 01:05:58.000000', 'temperatura', 863.0000, 'ºC'),
	(98683, 108, '2015-03-15 01:05:59.000000', 'temperatura', 1092.0000, 'ºC'),
	(98684, 108, '2015-03-15 01:06:00.000000', 'temperatura', 472.0000, 'ºC'),
	(98685, 108, '2015-03-15 01:06:01.000000', 'temperatura', 285.0000, 'ºC'),
	(98686, 108, '2015-03-15 01:06:02.000000', 'temperatura', 10.0000, 'ºC'),
	(98687, 108, '2015-03-15 01:06:03.000000', 'temperatura', 393.0000, 'ºC'),
	(98688, 108, '2015-03-15 01:06:04.000000', 'temperatura', 738.0000, 'ºC'),
	(98689, 108, '2015-03-15 01:06:05.000000', 'temperatura', 109.0000, 'ºC'),
	(98690, 108, '2015-03-15 01:06:06.000000', 'temperatura', 732.0000, 'ºC'),
	(98691, 108, '2015-03-15 01:06:07.000000', 'temperatura', 934.0000, 'ºC'),
	(98692, 108, '2015-03-15 01:06:08.000000', 'temperatura', 75.0000, 'ºC'),
	(98693, 108, '2015-03-15 01:06:09.000000', 'temperatura', 1174.0000, 'ºC'),
	(98694, 108, '2015-03-15 01:06:10.000000', 'temperatura', 844.0000, 'ºC'),
	(98695, 108, '2015-03-15 01:06:11.000000', 'temperatura', 700.0000, 'ºC'),
	(98696, 108, '2015-03-15 01:06:12.000000', 'temperatura', 967.0000, 'ºC'),
	(98697, 108, '2015-03-15 01:06:13.000000', 'temperatura', 335.0000, 'ºC'),
	(98698, 108, '2015-03-15 01:06:14.000000', 'temperatura', 1175.0000, 'ºC'),
	(98699, 108, '2015-03-15 01:06:15.000000', 'temperatura', 71.0000, 'ºC'),
	(98700, 108, '2015-03-15 01:06:16.000000', 'temperatura', 429.0000, 'ºC'),
	(98701, 108, '2015-03-15 01:06:17.000000', 'temperatura', 734.0000, 'ºC'),
	(98702, 108, '2015-03-15 01:06:18.000000', 'temperatura', 1185.0000, 'ºC'),
	(98703, 108, '2015-03-15 01:06:19.000000', 'temperatura', 121.0000, 'ºC'),
	(98704, 108, '2015-03-15 01:06:20.000000', 'temperatura', 650.0000, 'ºC'),
	(98705, 108, '2015-03-15 01:06:21.000000', 'temperatura', 487.0000, 'ºC'),
	(98706, 108, '2015-03-15 01:06:22.000000', 'temperatura', 487.0000, 'ºC'),
	(98707, 108, '2015-03-15 01:06:23.000000', 'temperatura', 975.0000, 'ºC'),
	(98708, 108, '2015-03-15 01:06:24.000000', 'temperatura', 1014.0000, 'ºC'),
	(98709, 108, '2015-03-15 01:06:25.000000', 'temperatura', 946.0000, 'ºC'),
	(98710, 108, '2015-03-15 01:06:26.000000', 'temperatura', 490.0000, 'ºC'),
	(98711, 108, '2015-03-15 01:06:27.000000', 'temperatura', 809.0000, 'ºC'),
	(98712, 108, '2015-03-15 01:06:28.000000', 'temperatura', 178.0000, 'ºC'),
	(98713, 108, '2015-03-15 01:06:29.000000', 'temperatura', 862.0000, 'ºC'),
	(98714, 108, '2015-03-15 01:06:30.000000', 'temperatura', 176.0000, 'ºC'),
	(98715, 108, '2015-03-15 01:06:31.000000', 'temperatura', 696.0000, 'ºC'),
	(98716, 108, '2015-03-15 01:06:32.000000', 'temperatura', 553.0000, 'ºC'),
	(98717, 108, '2015-03-15 01:06:33.000000', 'temperatura', 675.0000, 'ºC'),
	(98718, 108, '2015-03-15 01:06:34.000000', 'temperatura', 517.0000, 'ºC'),
	(98719, 108, '2015-03-15 01:06:35.000000', 'temperatura', 561.0000, 'ºC'),
	(98720, 108, '2015-03-15 01:06:36.000000', 'temperatura', 53.0000, 'ºC'),
	(98721, 108, '2015-03-15 01:06:37.000000', 'temperatura', 984.0000, 'ºC'),
	(98722, 108, '2015-03-15 01:06:38.000000', 'temperatura', 1162.0000, 'ºC'),
	(98723, 108, '2015-03-15 01:06:39.000000', 'temperatura', 459.0000, 'ºC'),
	(98724, 108, '2015-03-15 01:06:40.000000', 'temperatura', 8.0000, 'ºC'),
	(98725, 108, '2015-03-15 01:06:41.000000', 'temperatura', 1064.0000, 'ºC'),
	(98726, 108, '2015-03-15 01:06:42.000000', 'temperatura', 495.0000, 'ºC'),
	(98727, 108, '2015-03-15 01:06:43.000000', 'temperatura', 485.0000, 'ºC'),
	(98728, 108, '2015-03-15 01:06:44.000000', 'temperatura', 939.0000, 'ºC'),
	(98729, 108, '2015-03-15 01:06:45.000000', 'temperatura', 840.0000, 'ºC'),
	(98730, 108, '2015-03-15 01:06:46.000000', 'temperatura', 184.0000, 'ºC'),
	(98731, 108, '2015-03-15 01:06:47.000000', 'temperatura', 801.0000, 'ºC'),
	(98732, 108, '2015-03-15 01:06:48.000000', 'temperatura', 1053.0000, 'ºC'),
	(98733, 108, '2015-03-15 01:06:49.000000', 'temperatura', 464.0000, 'ºC'),
	(98734, 108, '2015-03-15 01:06:50.000000', 'temperatura', 359.0000, 'ºC'),
	(98735, 108, '2015-03-15 01:06:51.000000', 'temperatura', 403.0000, 'ºC'),
	(98736, 108, '2015-03-15 01:06:52.000000', 'temperatura', 941.0000, 'ºC'),
	(98737, 108, '2015-03-15 01:06:53.000000', 'temperatura', 1096.0000, 'ºC'),
	(98738, 108, '2015-03-15 01:06:54.000000', 'temperatura', 258.0000, 'ºC'),
	(98739, 108, '2015-03-15 01:06:55.000000', 'temperatura', 402.0000, 'ºC'),
	(98740, 108, '2015-03-15 01:06:56.000000', 'temperatura', 35.0000, 'ºC'),
	(98741, 108, '2015-03-15 01:06:57.000000', 'temperatura', 172.0000, 'ºC'),
	(98742, 108, '2015-03-15 01:06:58.000000', 'temperatura', 755.0000, 'ºC'),
	(98743, 108, '2015-03-15 01:06:59.000000', 'temperatura', 859.0000, 'ºC'),
	(98744, 108, '2015-03-15 01:07:00.000000', 'temperatura', 831.0000, 'ºC'),
	(98745, 108, '2015-03-15 01:07:01.000000', 'temperatura', 378.0000, 'ºC'),
	(98746, 108, '2015-03-15 01:07:02.000000', 'temperatura', 599.0000, 'ºC'),
	(98747, 108, '2015-03-15 01:07:03.000000', 'temperatura', 662.0000, 'ºC'),
	(98748, 108, '2015-03-15 01:07:04.000000', 'temperatura', 315.0000, 'ºC'),
	(98749, 108, '2015-03-15 01:07:05.000000', 'temperatura', 786.0000, 'ºC'),
	(98750, 108, '2015-03-15 01:07:06.000000', 'temperatura', 586.0000, 'ºC'),
	(98751, 108, '2015-03-15 01:07:07.000000', 'temperatura', 574.0000, 'ºC'),
	(98752, 108, '2015-03-15 01:07:08.000000', 'temperatura', 1113.0000, 'ºC'),
	(98753, 108, '2015-03-15 01:07:09.000000', 'temperatura', 242.0000, 'ºC'),
	(98754, 108, '2015-03-15 01:07:10.000000', 'temperatura', 274.0000, 'ºC'),
	(98755, 108, '2015-03-15 01:07:11.000000', 'temperatura', 643.0000, 'ºC'),
	(98756, 108, '2015-03-15 01:07:12.000000', 'temperatura', 1194.0000, 'ºC'),
	(98757, 108, '2015-03-15 01:07:13.000000', 'temperatura', 439.0000, 'ºC'),
	(98758, 108, '2015-03-15 01:07:14.000000', 'temperatura', 1016.0000, 'ºC'),
	(98759, 108, '2015-03-15 01:07:15.000000', 'temperatura', 163.0000, 'ºC'),
	(98760, 108, '2015-03-15 01:07:16.000000', 'temperatura', 165.0000, 'ºC'),
	(98761, 108, '2015-03-15 01:07:17.000000', 'temperatura', 340.0000, 'ºC'),
	(98762, 108, '2015-03-15 01:07:18.000000', 'temperatura', 5.0000, 'ºC'),
	(98763, 108, '2015-03-15 01:07:19.000000', 'temperatura', 206.0000, 'ºC'),
	(98764, 108, '2015-03-15 01:07:20.000000', 'temperatura', 1016.0000, 'ºC'),
	(98765, 108, '2015-03-15 01:07:21.000000', 'temperatura', 861.0000, 'ºC'),
	(98766, 108, '2015-03-15 01:07:22.000000', 'temperatura', 58.0000, 'ºC'),
	(98767, 108, '2015-03-15 01:07:23.000000', 'temperatura', 108.0000, 'ºC'),
	(98768, 108, '2015-03-15 01:07:24.000000', 'temperatura', 367.0000, 'ºC'),
	(98769, 108, '2015-03-15 01:07:25.000000', 'temperatura', 310.0000, 'ºC'),
	(98770, 108, '2015-03-15 01:07:26.000000', 'temperatura', 449.0000, 'ºC'),
	(98771, 108, '2015-03-15 01:07:27.000000', 'temperatura', 118.0000, 'ºC'),
	(98772, 108, '2015-03-15 01:07:28.000000', 'temperatura', 442.0000, 'ºC'),
	(98773, 108, '2015-03-15 01:07:29.000000', 'temperatura', 657.0000, 'ºC'),
	(98774, 108, '2015-03-15 01:07:30.000000', 'temperatura', 760.0000, 'ºC'),
	(98775, 108, '2015-03-15 01:07:31.000000', 'temperatura', 630.0000, 'ºC'),
	(98776, 108, '2015-03-15 01:07:32.000000', 'temperatura', 870.0000, 'ºC'),
	(98777, 108, '2015-03-15 01:07:33.000000', 'temperatura', 61.0000, 'ºC'),
	(98778, 108, '2015-03-15 01:07:34.000000', 'temperatura', 97.0000, 'ºC'),
	(98779, 108, '2015-03-15 01:07:35.000000', 'temperatura', 302.0000, 'ºC'),
	(98780, 108, '2015-03-15 01:07:36.000000', 'temperatura', 19.0000, 'ºC'),
	(98781, 108, '2015-03-15 01:07:37.000000', 'temperatura', 389.0000, 'ºC'),
	(98782, 108, '2015-03-15 01:07:38.000000', 'temperatura', 688.0000, 'ºC'),
	(98783, 108, '2015-03-15 01:07:39.000000', 'temperatura', 1075.0000, 'ºC'),
	(98784, 108, '2015-03-15 01:07:40.000000', 'temperatura', 909.0000, 'ºC'),
	(98785, 108, '2015-03-15 01:07:41.000000', 'temperatura', 124.0000, 'ºC'),
	(98786, 108, '2015-03-15 01:07:42.000000', 'temperatura', 290.0000, 'ºC'),
	(98787, 108, '2015-03-15 01:07:43.000000', 'temperatura', 1080.0000, 'ºC'),
	(98788, 108, '2015-03-15 01:07:44.000000', 'temperatura', 929.0000, 'ºC'),
	(98789, 108, '2015-03-15 01:07:45.000000', 'temperatura', 207.0000, 'ºC'),
	(98790, 108, '2015-03-15 01:07:46.000000', 'temperatura', 648.0000, 'ºC'),
	(98791, 108, '2015-03-15 01:07:47.000000', 'temperatura', 221.0000, 'ºC'),
	(98792, 108, '2015-03-15 01:07:48.000000', 'temperatura', 362.0000, 'ºC'),
	(98793, 108, '2015-03-15 01:07:49.000000', 'temperatura', 1146.0000, 'ºC'),
	(98794, 108, '2015-03-15 01:07:50.000000', 'temperatura', 1045.0000, 'ºC'),
	(98795, 108, '2015-03-15 01:07:51.000000', 'temperatura', 589.0000, 'ºC'),
	(98796, 108, '2015-03-15 01:07:52.000000', 'temperatura', 1008.0000, 'ºC'),
	(98797, 108, '2015-03-15 01:07:53.000000', 'temperatura', 873.0000, 'ºC'),
	(98798, 108, '2015-03-15 01:07:54.000000', 'temperatura', 144.0000, 'ºC'),
	(98799, 108, '2015-03-15 01:07:55.000000', 'temperatura', 499.0000, 'ºC'),
	(98800, 108, '2015-03-15 01:07:56.000000', 'temperatura', 864.0000, 'ºC'),
	(98801, 108, '2015-03-15 01:07:57.000000', 'temperatura', 422.0000, 'ºC'),
	(98802, 108, '2015-03-15 01:07:58.000000', 'temperatura', 719.0000, 'ºC'),
	(98803, 108, '2015-03-15 01:07:59.000000', 'temperatura', 1130.0000, 'ºC'),
	(98804, 108, '2015-03-15 01:08:00.000000', 'temperatura', 1092.0000, 'ºC'),
	(98805, 108, '2015-03-15 01:08:01.000000', 'temperatura', 871.0000, 'ºC'),
	(98806, 108, '2015-03-15 01:08:02.000000', 'temperatura', 1081.0000, 'ºC'),
	(98807, 108, '2015-03-15 01:08:03.000000', 'temperatura', 390.0000, 'ºC'),
	(98808, 108, '2015-03-15 01:08:04.000000', 'temperatura', 1110.0000, 'ºC'),
	(98809, 108, '2015-03-15 01:08:05.000000', 'temperatura', 782.0000, 'ºC'),
	(98810, 108, '2015-03-15 01:08:06.000000', 'temperatura', 577.0000, 'ºC'),
	(98811, 108, '2015-03-15 01:08:07.000000', 'temperatura', 543.0000, 'ºC'),
	(98812, 108, '2015-03-15 01:08:08.000000', 'temperatura', 982.0000, 'ºC'),
	(98813, 108, '2015-03-15 01:08:09.000000', 'temperatura', 882.0000, 'ºC'),
	(98814, 108, '2015-03-15 01:08:10.000000', 'temperatura', 265.0000, 'ºC'),
	(98815, 108, '2015-03-15 01:08:11.000000', 'temperatura', 1079.0000, 'ºC'),
	(98816, 108, '2015-03-15 01:08:12.000000', 'temperatura', 999.0000, 'ºC'),
	(98817, 108, '2015-03-15 01:08:13.000000', 'temperatura', 559.0000, 'ºC'),
	(98818, 108, '2015-03-15 01:08:14.000000', 'temperatura', 1001.0000, 'ºC'),
	(98819, 108, '2015-03-15 01:08:15.000000', 'temperatura', 927.0000, 'ºC'),
	(98820, 108, '2015-03-15 01:08:16.000000', 'temperatura', 431.0000, 'ºC'),
	(98821, 108, '2015-03-15 01:08:17.000000', 'temperatura', 577.0000, 'ºC'),
	(98822, 108, '2015-03-15 01:08:18.000000', 'temperatura', 390.0000, 'ºC'),
	(98823, 108, '2015-03-15 01:08:19.000000', 'temperatura', 219.0000, 'ºC'),
	(98824, 108, '2015-03-15 01:08:20.000000', 'temperatura', 1126.0000, 'ºC'),
	(98825, 108, '2015-03-15 01:08:21.000000', 'temperatura', 174.0000, 'ºC'),
	(98826, 108, '2015-03-15 01:08:22.000000', 'temperatura', 1091.0000, 'ºC'),
	(98827, 108, '2015-03-15 01:08:23.000000', 'temperatura', 134.0000, 'ºC'),
	(98828, 108, '2015-03-15 01:08:24.000000', 'temperatura', 999.0000, 'ºC'),
	(98829, 108, '2015-03-15 01:08:25.000000', 'temperatura', 994.0000, 'ºC'),
	(98830, 108, '2015-03-15 01:08:26.000000', 'temperatura', 771.0000, 'ºC'),
	(98831, 108, '2015-03-15 01:08:27.000000', 'temperatura', 876.0000, 'ºC'),
	(98832, 108, '2015-03-15 01:08:28.000000', 'temperatura', 867.0000, 'ºC'),
	(98833, 108, '2015-03-15 01:08:29.000000', 'temperatura', 508.0000, 'ºC'),
	(98834, 108, '2015-03-15 01:08:30.000000', 'temperatura', 1141.0000, 'ºC'),
	(98835, 108, '2015-03-15 01:08:31.000000', 'temperatura', 578.0000, 'ºC'),
	(98836, 108, '2015-03-15 01:08:32.000000', 'temperatura', 669.0000, 'ºC'),
	(98837, 108, '2015-03-15 01:08:33.000000', 'temperatura', 411.0000, 'ºC'),
	(98838, 108, '2015-03-15 01:08:34.000000', 'temperatura', 49.0000, 'ºC'),
	(98839, 108, '2015-03-15 01:08:35.000000', 'temperatura', 213.0000, 'ºC'),
	(98840, 108, '2015-03-15 01:08:36.000000', 'temperatura', 917.0000, 'ºC'),
	(98841, 108, '2015-03-15 01:08:37.000000', 'temperatura', 346.0000, 'ºC'),
	(98842, 108, '2015-03-15 01:08:38.000000', 'temperatura', 182.0000, 'ºC'),
	(98843, 108, '2015-03-15 01:08:39.000000', 'temperatura', 1072.0000, 'ºC'),
	(98844, 108, '2015-03-15 01:08:40.000000', 'temperatura', 15.0000, 'ºC'),
	(98845, 108, '2015-03-15 01:08:41.000000', 'temperatura', 459.0000, 'ºC'),
	(98846, 108, '2015-03-15 01:08:42.000000', 'temperatura', 1052.0000, 'ºC'),
	(98847, 108, '2015-03-15 01:08:43.000000', 'temperatura', 282.0000, 'ºC'),
	(98848, 108, '2015-03-15 01:08:44.000000', 'temperatura', 656.0000, 'ºC'),
	(98849, 108, '2015-03-15 01:08:45.000000', 'temperatura', 36.0000, 'ºC'),
	(98850, 108, '2015-03-15 01:08:46.000000', 'temperatura', 610.0000, 'ºC'),
	(98851, 108, '2015-03-15 01:08:47.000000', 'temperatura', 542.0000, 'ºC'),
	(98852, 108, '2015-03-15 01:08:48.000000', 'temperatura', 880.0000, 'ºC'),
	(98853, 108, '2015-03-15 01:08:49.000000', 'temperatura', 377.0000, 'ºC'),
	(98854, 108, '2015-03-15 01:08:50.000000', 'temperatura', 443.0000, 'ºC'),
	(98855, 108, '2015-03-15 01:08:51.000000', 'temperatura', 1087.0000, 'ºC'),
	(98856, 108, '2015-03-15 01:08:52.000000', 'temperatura', 506.0000, 'ºC'),
	(98857, 108, '2015-03-15 01:08:53.000000', 'temperatura', 467.0000, 'ºC'),
	(98858, 108, '2015-03-15 01:08:54.000000', 'temperatura', 820.0000, 'ºC'),
	(98859, 108, '2015-03-15 01:08:55.000000', 'temperatura', 297.0000, 'ºC'),
	(98860, 108, '2015-03-15 01:08:56.000000', 'temperatura', 228.0000, 'ºC'),
	(98861, 108, '2015-03-15 01:08:57.000000', 'temperatura', 249.0000, 'ºC'),
	(98862, 108, '2015-03-15 01:08:58.000000', 'temperatura', 560.0000, 'ºC'),
	(98863, 108, '2015-03-15 01:08:59.000000', 'temperatura', 855.0000, 'ºC'),
	(98864, 108, '2015-03-15 01:09:00.000000', 'temperatura', 194.0000, 'ºC'),
	(98865, 108, '2015-03-15 01:09:01.000000', 'temperatura', 804.0000, 'ºC'),
	(98866, 108, '2015-03-15 01:09:02.000000', 'temperatura', 1041.0000, 'ºC'),
	(98867, 108, '2015-03-15 01:09:03.000000', 'temperatura', 391.0000, 'ºC'),
	(98868, 108, '2015-03-15 01:09:04.000000', 'temperatura', 36.0000, 'ºC'),
	(98869, 108, '2015-03-15 01:09:05.000000', 'temperatura', 204.0000, 'ºC'),
	(98870, 108, '2015-03-15 01:09:06.000000', 'temperatura', 913.0000, 'ºC'),
	(98871, 108, '2015-03-15 01:09:07.000000', 'temperatura', 356.0000, 'ºC'),
	(98872, 108, '2015-03-15 01:09:08.000000', 'temperatura', 241.0000, 'ºC'),
	(98873, 108, '2015-03-15 01:09:09.000000', 'temperatura', 135.0000, 'ºC'),
	(98874, 108, '2015-03-15 01:09:10.000000', 'temperatura', 1155.0000, 'ºC'),
	(98875, 108, '2015-03-15 01:09:11.000000', 'temperatura', 568.0000, 'ºC'),
	(98876, 108, '2015-03-15 01:09:12.000000', 'temperatura', 576.0000, 'ºC'),
	(98877, 108, '2015-03-15 01:09:13.000000', 'temperatura', 1175.0000, 'ºC'),
	(98878, 108, '2015-03-15 01:09:14.000000', 'temperatura', 550.0000, 'ºC'),
	(98879, 108, '2015-03-15 01:09:15.000000', 'temperatura', 426.0000, 'ºC'),
	(98880, 108, '2015-03-15 01:09:16.000000', 'temperatura', 481.0000, 'ºC'),
	(98881, 108, '2015-03-15 01:09:17.000000', 'temperatura', 1125.0000, 'ºC'),
	(98882, 108, '2015-03-15 01:09:18.000000', 'temperatura', 585.0000, 'ºC'),
	(98883, 108, '2015-03-15 01:09:19.000000', 'temperatura', 749.0000, 'ºC'),
	(98884, 108, '2015-03-15 01:09:20.000000', 'temperatura', 792.0000, 'ºC'),
	(98885, 108, '2015-03-15 01:09:21.000000', 'temperatura', 513.0000, 'ºC'),
	(98886, 108, '2015-03-15 01:09:22.000000', 'temperatura', 189.0000, 'ºC'),
	(98887, 108, '2015-03-15 01:09:23.000000', 'temperatura', 609.0000, 'ºC'),
	(98888, 108, '2015-03-15 01:09:24.000000', 'temperatura', 75.0000, 'ºC'),
	(98889, 108, '2015-03-15 01:09:25.000000', 'temperatura', 949.0000, 'ºC'),
	(98890, 108, '2015-03-15 01:09:26.000000', 'temperatura', 922.0000, 'ºC'),
	(98891, 108, '2015-03-15 01:09:27.000000', 'temperatura', 563.0000, 'ºC'),
	(98892, 108, '2015-03-15 01:09:28.000000', 'temperatura', 51.0000, 'ºC'),
	(98893, 108, '2015-03-15 01:09:29.000000', 'temperatura', 967.0000, 'ºC'),
	(98894, 108, '2015-03-15 01:09:30.000000', 'temperatura', 1080.0000, 'ºC'),
	(98895, 108, '2015-03-15 01:09:31.000000', 'temperatura', 101.0000, 'ºC'),
	(98896, 108, '2015-03-15 01:09:32.000000', 'temperatura', 863.0000, 'ºC'),
	(98897, 108, '2015-03-15 01:09:33.000000', 'temperatura', 415.0000, 'ºC'),
	(98898, 108, '2015-03-15 01:09:34.000000', 'temperatura', 687.0000, 'ºC'),
	(98899, 108, '2015-03-15 01:09:35.000000', 'temperatura', 989.0000, 'ºC'),
	(98900, 108, '2015-03-15 01:09:36.000000', 'temperatura', 485.0000, 'ºC'),
	(98901, 108, '2015-03-15 01:09:37.000000', 'temperatura', 657.0000, 'ºC'),
	(98902, 108, '2015-03-15 01:09:38.000000', 'temperatura', 633.0000, 'ºC'),
	(98903, 108, '2015-03-15 01:09:39.000000', 'temperatura', 1194.0000, 'ºC'),
	(98904, 108, '2015-03-15 01:09:40.000000', 'temperatura', 473.0000, 'ºC'),
	(98905, 108, '2015-03-15 01:09:41.000000', 'temperatura', 1181.0000, 'ºC'),
	(98906, 108, '2015-03-15 01:09:42.000000', 'temperatura', 889.0000, 'ºC'),
	(98907, 108, '2015-03-15 01:09:43.000000', 'temperatura', 902.0000, 'ºC'),
	(98908, 108, '2015-03-15 01:09:44.000000', 'temperatura', 644.0000, 'ºC'),
	(98909, 108, '2015-03-15 01:09:45.000000', 'temperatura', 513.0000, 'ºC'),
	(98910, 108, '2015-03-15 01:09:46.000000', 'temperatura', 633.0000, 'ºC'),
	(98911, 108, '2015-03-15 01:09:47.000000', 'temperatura', 429.0000, 'ºC'),
	(98912, 108, '2015-03-15 01:09:48.000000', 'temperatura', 247.0000, 'ºC'),
	(98913, 108, '2015-03-15 01:09:49.000000', 'temperatura', 1145.0000, 'ºC'),
	(98914, 108, '2015-03-15 01:09:50.000000', 'temperatura', 187.0000, 'ºC'),
	(98915, 108, '2015-03-15 01:09:51.000000', 'temperatura', 1100.0000, 'ºC'),
	(98916, 108, '2015-03-15 01:09:52.000000', 'temperatura', 141.0000, 'ºC'),
	(98917, 108, '2015-03-15 01:09:53.000000', 'temperatura', 1005.0000, 'ºC'),
	(98918, 108, '2015-03-15 01:09:54.000000', 'temperatura', 1004.0000, 'ºC'),
	(98919, 108, '2015-03-15 01:09:55.000000', 'temperatura', 802.0000, 'ºC'),
	(98920, 108, '2015-03-15 01:09:56.000000', 'temperatura', 1001.0000, 'ºC'),
	(98921, 108, '2015-03-15 01:09:57.000000', 'temperatura', 200.0000, 'ºC'),
	(98922, 108, '2015-03-15 01:09:58.000000', 'temperatura', 397.0000, 'ºC'),
	(98923, 108, '2015-03-15 01:09:59.000000', 'temperatura', 186.0000, 'ºC'),
	(98924, 108, '2015-03-15 01:10:00.000000', 'temperatura', 937.0000, 'ºC'),
	(98925, 108, '2015-03-15 01:10:01.000000', 'temperatura', 529.0000, 'ºC'),
	(98926, 108, '2015-03-15 01:10:02.000000', 'temperatura', 1034.0000, 'ºC'),
	(98927, 108, '2015-03-15 01:10:03.000000', 'temperatura', 1183.0000, 'ºC'),
	(98928, 108, '2015-03-15 01:10:04.000000', 'temperatura', 414.0000, 'ºC'),
	(98929, 108, '2015-03-15 01:10:05.000000', 'temperatura', 921.0000, 'ºC'),
	(98930, 108, '2015-03-15 01:10:06.000000', 'temperatura', 962.0000, 'ºC'),
	(98931, 108, '2015-03-15 01:10:07.000000', 'temperatura', 849.0000, 'ºC'),
	(98932, 108, '2015-03-15 01:10:08.000000', 'temperatura', 158.0000, 'ºC'),
	(98933, 108, '2015-03-15 01:10:09.000000', 'temperatura', 646.0000, 'ºC'),
	(98934, 108, '2015-03-15 01:10:10.000000', 'temperatura', 356.0000, 'ºC'),
	(98935, 108, '2015-03-15 01:10:11.000000', 'temperatura', 1043.0000, 'ºC'),
	(98936, 108, '2015-03-15 01:10:12.000000', 'temperatura', 548.0000, 'ºC'),
	(98937, 108, '2015-03-15 01:10:13.000000', 'temperatura', 812.0000, 'ºC'),
	(98938, 108, '2015-03-15 01:10:14.000000', 'temperatura', 14.0000, 'ºC'),
	(98939, 108, '2015-03-15 01:10:15.000000', 'temperatura', 35.0000, 'ºC'),
	(98940, 108, '2015-03-15 01:10:16.000000', 'temperatura', 135.0000, 'ºC'),
	(98941, 108, '2015-03-15 01:10:17.000000', 'temperatura', 568.0000, 'ºC'),
	(98942, 108, '2015-03-15 01:10:18.000000', 'temperatura', 37.0000, 'ºC'),
	(98943, 108, '2015-03-15 01:10:19.000000', 'temperatura', 881.0000, 'ºC'),
	(98944, 108, '2015-03-15 01:10:20.000000', 'temperatura', 695.0000, 'ºC'),
	(98945, 108, '2015-03-15 01:10:21.000000', 'temperatura', 832.0000, 'ºC'),
	(98946, 108, '2015-03-15 01:10:22.000000', 'temperatura', 878.0000, 'ºC'),
	(98947, 108, '2015-03-15 01:10:23.000000', 'temperatura', 691.0000, 'ºC'),
	(98948, 108, '2015-03-15 01:10:24.000000', 'temperatura', 824.0000, 'ºC'),
	(98949, 108, '2015-03-15 01:10:25.000000', 'temperatura', 847.0000, 'ºC'),
	(98950, 108, '2015-03-15 01:10:26.000000', 'temperatura', 562.0000, 'ºC'),
	(98951, 108, '2015-03-15 01:10:27.000000', 'temperatura', 271.0000, 'ºC'),
	(98952, 108, '2015-03-15 01:10:28.000000', 'temperatura', 869.0000, 'ºC'),
	(98953, 108, '2015-03-15 01:10:29.000000', 'temperatura', 1132.0000, 'ºC'),
	(98954, 108, '2015-03-15 01:10:30.000000', 'temperatura', 652.0000, 'ºC'),
	(98955, 108, '2015-03-15 01:10:31.000000', 'temperatura', 1065.0000, 'ºC'),
	(98956, 108, '2015-03-15 01:10:32.000000', 'temperatura', 971.0000, 'ºC'),
	(98957, 108, '2015-03-15 01:10:33.000000', 'temperatura', 462.0000, 'ºC'),
	(98958, 108, '2015-03-15 01:10:34.000000', 'temperatura', 595.0000, 'ºC'),
	(98959, 108, '2015-03-15 01:10:35.000000', 'temperatura', 390.0000, 'ºC'),
	(98960, 108, '2015-03-15 01:10:36.000000', 'temperatura', 165.0000, 'ºC'),
	(98961, 108, '2015-03-15 01:10:37.000000', 'temperatura', 857.0000, 'ºC'),
	(98962, 108, '2015-03-15 01:10:38.000000', 'temperatura', 190.0000, 'ºC'),
	(98963, 108, '2015-03-15 01:10:39.000000', 'temperatura', 781.0000, 'ºC'),
	(98964, 108, '2015-03-15 01:10:40.000000', 'temperatura', 932.0000, 'ºC'),
	(98965, 108, '2015-03-15 01:10:41.000000', 'temperatura', 1121.0000, 'ºC'),
	(98966, 108, '2015-03-15 01:10:42.000000', 'temperatura', 406.0000, 'ºC'),
	(98967, 108, '2015-03-15 01:10:43.000000', 'temperatura', 1069.0000, 'ºC'),
	(98968, 108, '2015-03-15 01:10:44.000000', 'temperatura', 529.0000, 'ºC'),
	(98969, 108, '2015-03-15 01:10:45.000000', 'temperatura', 637.0000, 'ºC'),
	(98970, 108, '2015-03-15 01:10:46.000000', 'temperatura', 400.0000, 'ºC'),
	(98971, 108, '2015-03-15 01:10:47.000000', 'temperatura', 90.0000, 'ºC'),
	(98972, 108, '2015-03-15 01:10:48.000000', 'temperatura', 450.0000, 'ºC'),
	(98973, 108, '2015-03-15 01:10:49.000000', 'temperatura', 781.0000, 'ºC'),
	(98974, 108, '2015-03-15 01:10:50.000000', 'temperatura', 154.0000, 'ºC'),
	(98975, 108, '2015-03-15 01:10:51.000000', 'temperatura', 826.0000, 'ºC'),
	(98976, 108, '2015-03-15 01:10:52.000000', 'temperatura', 72.0000, 'ºC'),
	(98977, 108, '2015-03-15 01:10:53.000000', 'temperatura', 280.0000, 'ºC'),
	(98978, 108, '2015-03-15 01:10:54.000000', 'temperatura', 1187.0000, 'ºC'),
	(98979, 108, '2015-03-15 01:10:55.000000', 'temperatura', 296.0000, 'ºC'),
	(98980, 108, '2015-03-15 01:10:56.000000', 'temperatura', 316.0000, 'ºC'),
	(98981, 108, '2015-03-15 01:10:57.000000', 'temperatura', 695.0000, 'ºC'),
	(98982, 108, '2015-03-15 01:10:58.000000', 'temperatura', 127.0000, 'ºC'),
	(98983, 108, '2015-03-15 01:10:59.000000', 'temperatura', 949.0000, 'ºC'),
	(98984, 108, '2015-03-15 01:11:00.000000', 'temperatura', 764.0000, 'ºC'),
	(98985, 108, '2015-03-15 01:11:01.000000', 'temperatura', 976.0000, 'ºC'),
	(98986, 108, '2015-03-15 01:11:02.000000', 'temperatura', 189.0000, 'ºC'),
	(98987, 108, '2015-03-15 01:11:03.000000', 'temperatura', 417.0000, 'ºC'),
	(98988, 108, '2015-03-15 01:11:04.000000', 'temperatura', 317.0000, 'ºC'),
	(98989, 108, '2015-03-15 01:11:05.000000', 'temperatura', 335.0000, 'ºC'),
	(98990, 108, '2015-03-15 01:11:06.000000', 'temperatura', 724.0000, 'ºC'),
	(98991, 108, '2015-03-15 01:11:07.000000', 'temperatura', 217.0000, 'ºC'),
	(98992, 108, '2015-03-15 01:11:08.000000', 'temperatura', 114.0000, 'ºC'),
	(98993, 108, '2015-03-15 01:11:09.000000', 'temperatura', 1120.0000, 'ºC'),
	(98994, 108, '2015-03-15 01:11:10.000000', 'temperatura', 457.0000, 'ºC'),
	(98995, 108, '2015-03-15 01:11:11.000000', 'temperatura', 125.0000, 'ºC'),
	(98996, 108, '2015-03-15 01:11:12.000000', 'temperatura', 455.0000, 'ºC'),
	(98997, 108, '2015-03-15 01:11:13.000000', 'temperatura', 702.0000, 'ºC'),
	(98998, 108, '2015-03-15 01:11:14.000000', 'temperatura', 944.0000, 'ºC'),
	(98999, 108, '2015-03-15 01:11:15.000000', 'temperatura', 213.0000, 'ºC'),
	(99000, 108, '2015-03-15 01:11:16.000000', 'temperatura', 637.0000, 'ºC'),
	(99001, 108, '2015-03-15 01:11:17.000000', 'temperatura', 143.0000, 'ºC'),
	(99002, 108, '2015-03-15 01:11:18.000000', 'temperatura', 6.0000, 'ºC'),
	(99003, 108, '2015-03-15 01:11:19.000000', 'temperatura', 800.0000, 'ºC'),
	(99004, 108, '2015-03-15 01:11:20.000000', 'temperatura', 382.0000, 'ºC'),
	(99005, 108, '2015-03-15 01:11:21.000000', 'temperatura', 713.0000, 'ºC'),
	(99006, 108, '2015-03-15 01:11:22.000000', 'temperatura', 19.0000, 'ºC'),
	(99007, 108, '2015-03-15 01:11:23.000000', 'temperatura', 356.0000, 'ºC'),
	(99008, 108, '2015-03-15 01:11:24.000000', 'temperatura', 522.0000, 'ºC'),
	(99009, 108, '2015-03-15 01:11:25.000000', 'temperatura', 345.0000, 'ºC'),
	(99010, 108, '2015-03-15 01:11:26.000000', 'temperatura', 158.0000, 'ºC'),
	(99011, 108, '2015-03-15 01:11:27.000000', 'temperatura', 956.0000, 'ºC'),
	(99012, 108, '2015-03-15 01:11:28.000000', 'temperatura', 706.0000, 'ºC'),
	(99013, 108, '2015-03-15 01:11:29.000000', 'temperatura', 662.0000, 'ºC'),
	(99014, 108, '2015-03-15 01:11:30.000000', 'temperatura', 1194.0000, 'ºC'),
	(99015, 108, '2015-03-15 01:11:31.000000', 'temperatura', 383.0000, 'ºC'),
	(99016, 108, '2015-03-15 01:11:32.000000', 'temperatura', 733.0000, 'ºC'),
	(99017, 108, '2015-03-15 01:11:33.000000', 'temperatura', 119.0000, 'ºC'),
	(99018, 108, '2015-03-15 01:11:34.000000', 'temperatura', 794.0000, 'ºC'),
	(99019, 108, '2015-03-15 01:11:35.000000', 'temperatura', 13.0000, 'ºC'),
	(99020, 108, '2015-03-15 01:11:36.000000', 'temperatura', 86.0000, 'ºC'),
	(99021, 108, '2015-03-15 01:11:37.000000', 'temperatura', 391.0000, 'ºC'),
	(99022, 108, '2015-03-15 01:11:38.000000', 'temperatura', 498.0000, 'ºC'),
	(99023, 108, '2015-03-15 01:11:39.000000', 'temperatura', 116.0000, 'ºC'),
	(99024, 108, '2015-03-15 01:11:40.000000', 'temperatura', 286.0000, 'ºC'),
	(99025, 108, '2015-03-15 01:11:41.000000', 'temperatura', 1085.0000, 'ºC'),
	(99026, 108, '2015-03-15 01:11:42.000000', 'temperatura', 966.0000, 'ºC'),
	(99027, 108, '2015-03-15 01:11:43.000000', 'temperatura', 375.0000, 'ºC'),
	(99028, 108, '2015-03-15 01:11:44.000000', 'temperatura', 177.0000, 'ºC'),
	(99029, 108, '2015-03-15 01:11:45.000000', 'temperatura', 960.0000, 'ºC'),
	(99030, 108, '2015-03-15 01:11:46.000000', 'temperatura', 671.0000, 'ºC'),
	(99031, 108, '2015-03-15 01:11:47.000000', 'temperatura', 477.0000, 'ºC'),
	(99032, 108, '2015-03-15 01:11:48.000000', 'temperatura', 371.0000, 'ºC'),
	(99033, 108, '2015-03-15 01:11:49.000000', 'temperatura', 424.0000, 'ºC'),
	(99034, 108, '2015-03-15 01:11:50.000000', 'temperatura', 1008.0000, 'ºC'),
	(99035, 108, '2015-03-15 01:11:51.000000', 'temperatura', 171.0000, 'ºC'),
	(99036, 108, '2015-03-15 01:11:52.000000', 'temperatura', 228.0000, 'ºC'),
	(99037, 108, '2015-03-15 01:11:53.000000', 'temperatura', 628.0000, 'ºC'),
	(99038, 108, '2015-03-15 01:11:54.000000', 'temperatura', 59.0000, 'ºC'),
	(99039, 108, '2015-03-15 01:11:55.000000', 'temperatura', 808.0000, 'ºC'),
	(99040, 108, '2015-03-15 01:11:56.000000', 'temperatura', 266.0000, 'ºC'),
	(99041, 108, '2015-03-15 01:11:57.000000', 'temperatura', 104.0000, 'ºC'),
	(99042, 108, '2015-03-15 01:11:58.000000', 'temperatura', 924.0000, 'ºC'),
	(99043, 108, '2015-03-15 01:11:59.000000', 'temperatura', 710.0000, 'ºC'),
	(99044, 108, '2015-03-15 01:12:00.000000', 'temperatura', 777.0000, 'ºC'),
	(99045, 108, '2015-03-15 01:12:01.000000', 'temperatura', 558.0000, 'ºC'),
	(99046, 108, '2015-03-15 01:12:02.000000', 'temperatura', 456.0000, 'ºC'),
	(99047, 108, '2015-03-15 01:12:03.000000', 'temperatura', 608.0000, 'ºC'),
	(99048, 108, '2015-03-15 01:12:04.000000', 'temperatura', 473.0000, 'ºC'),
	(99049, 108, '2015-03-15 01:12:05.000000', 'temperatura', 541.0000, 'ºC'),
	(99050, 108, '2015-03-15 01:12:06.000000', 'temperatura', 89.0000, 'ºC'),
	(99051, 108, '2015-03-15 01:12:07.000000', 'temperatura', 19.0000, 'ºC'),
	(99052, 108, '2015-03-15 01:12:08.000000', 'temperatura', 1030.0000, 'ºC'),
	(99053, 108, '2015-03-15 01:12:09.000000', 'temperatura', 293.0000, 'ºC'),
	(99054, 108, '2015-03-15 01:12:10.000000', 'temperatura', 778.0000, 'ºC'),
	(99055, 108, '2015-03-15 01:12:11.000000', 'temperatura', 609.0000, 'ºC'),
	(99056, 108, '2015-03-15 01:12:12.000000', 'temperatura', 712.0000, 'ºC'),
	(99057, 108, '2015-03-15 01:12:13.000000', 'temperatura', 532.0000, 'ºC'),
	(99058, 108, '2015-03-15 01:12:14.000000', 'temperatura', 526.0000, 'ºC'),
	(99059, 108, '2015-03-15 01:12:15.000000', 'temperatura', 1034.0000, 'ºC'),
	(99060, 108, '2015-03-15 01:12:16.000000', 'temperatura', 1191.0000, 'ºC'),
	(99061, 108, '2015-03-15 01:12:17.000000', 'temperatura', 455.0000, 'ºC'),
	(99062, 108, '2015-03-15 01:12:18.000000', 'temperatura', 1102.0000, 'ºC'),
	(99063, 108, '2015-03-15 01:12:19.000000', 'temperatura', 547.0000, 'ºC'),
	(99064, 108, '2015-03-15 01:12:20.000000', 'temperatura', 629.0000, 'ºC'),
	(99065, 108, '2015-03-15 01:12:21.000000', 'temperatura', 305.0000, 'ºC'),
	(99066, 108, '2015-03-15 01:12:22.000000', 'temperatura', 840.0000, 'ºC'),
	(99067, 108, '2015-03-15 01:12:23.000000', 'temperatura', 883.0000, 'ºC'),
	(99068, 108, '2015-03-15 01:12:24.000000', 'temperatura', 698.0000, 'ºC'),
	(99069, 108, '2015-03-15 01:12:25.000000', 'temperatura', 841.0000, 'ºC'),
	(99070, 108, '2015-03-15 01:12:26.000000', 'temperatura', 909.0000, 'ºC'),
	(99071, 108, '2015-03-15 01:12:27.000000', 'temperatura', 825.0000, 'ºC'),
	(99072, 108, '2015-03-15 01:12:28.000000', 'temperatura', 198.0000, 'ºC'),
	(99073, 108, '2015-03-15 01:12:29.000000', 'temperatura', 913.0000, 'ºC'),
	(99074, 108, '2015-03-15 01:12:30.000000', 'temperatura', 374.0000, 'ºC'),
	(99075, 108, '2015-03-15 01:12:31.000000', 'temperatura', 333.0000, 'ºC'),
	(99076, 108, '2015-03-15 01:12:32.000000', 'temperatura', 540.0000, 'ºC'),
	(99077, 108, '2015-03-15 01:12:33.000000', 'temperatura', 502.0000, 'ºC'),
	(99078, 108, '2015-03-15 01:12:34.000000', 'temperatura', 893.0000, 'ºC'),
	(99079, 108, '2015-03-15 01:12:35.000000', 'temperatura', 559.0000, 'ºC'),
	(99080, 108, '2015-03-15 01:12:36.000000', 'temperatura', 118.0000, 'ºC'),
	(99081, 108, '2015-03-15 01:12:37.000000', 'temperatura', 110.0000, 'ºC'),
	(99082, 108, '2015-03-15 01:12:38.000000', 'temperatura', 200.0000, 'ºC'),
	(99083, 108, '2015-03-15 01:12:39.000000', 'temperatura', 669.0000, 'ºC'),
	(99084, 108, '2015-03-15 01:12:40.000000', 'temperatura', 346.0000, 'ºC'),
	(99085, 108, '2015-03-15 01:12:41.000000', 'temperatura', 922.0000, 'ºC'),
	(99086, 108, '2015-03-15 01:12:42.000000', 'temperatura', 1174.0000, 'ºC'),
	(99087, 108, '2015-03-15 01:12:43.000000', 'temperatura', 703.0000, 'ºC'),
	(99088, 108, '2015-03-15 01:12:44.000000', 'temperatura', 1196.0000, 'ºC'),
	(99089, 108, '2015-03-15 01:12:45.000000', 'temperatura', 272.0000, 'ºC'),
	(99090, 108, '2015-03-15 01:12:46.000000', 'temperatura', 169.0000, 'ºC'),
	(99091, 108, '2015-03-15 01:12:47.000000', 'temperatura', 33.0000, 'ºC'),
	(99092, 108, '2015-03-15 01:12:48.000000', 'temperatura', 857.0000, 'ºC'),
	(99093, 108, '2015-03-15 01:12:49.000000', 'temperatura', 586.0000, 'ºC'),
	(99094, 108, '2015-03-15 01:12:50.000000', 'temperatura', 360.0000, 'ºC'),
	(99095, 108, '2015-03-15 01:12:51.000000', 'temperatura', 41.0000, 'ºC'),
	(99096, 108, '2015-03-15 01:12:52.000000', 'temperatura', 327.0000, 'ºC'),
	(99097, 108, '2015-03-15 01:12:53.000000', 'temperatura', 314.0000, 'ºC'),
	(99098, 108, '2015-03-15 01:12:54.000000', 'temperatura', 588.0000, 'ºC'),
	(99099, 108, '2015-03-15 01:12:55.000000', 'temperatura', 797.0000, 'ºC'),
	(99100, 108, '2015-03-15 01:12:56.000000', 'temperatura', 1023.0000, 'ºC'),
	(99101, 108, '2015-03-15 01:12:57.000000', 'temperatura', 323.0000, 'ºC'),
	(99102, 108, '2015-03-15 01:12:58.000000', 'temperatura', 947.0000, 'ºC'),
	(99103, 108, '2015-03-15 01:12:59.000000', 'temperatura', 166.0000, 'ºC'),
	(99104, 108, '2015-03-15 01:13:00.000000', 'temperatura', 390.0000, 'ºC'),
	(99105, 108, '2015-03-15 01:13:01.000000', 'temperatura', 253.0000, 'ºC'),
	(99106, 108, '2015-03-15 01:13:02.000000', 'temperatura', 95.0000, 'ºC'),
	(99107, 108, '2015-03-15 01:13:03.000000', 'temperatura', 915.0000, 'ºC'),
	(99108, 108, '2015-03-15 01:13:04.000000', 'temperatura', 693.0000, 'ºC'),
	(99109, 108, '2015-03-15 01:13:05.000000', 'temperatura', 721.0000, 'ºC'),
	(99110, 108, '2015-03-15 01:13:06.000000', 'temperatura', 325.0000, 'ºC'),
	(99111, 108, '2015-03-15 01:13:07.000000', 'temperatura', 665.0000, 'ºC'),
	(99112, 108, '2015-03-15 01:13:08.000000', 'temperatura', 1148.0000, 'ºC'),
	(99113, 108, '2015-03-15 01:13:09.000000', 'temperatura', 148.0000, 'ºC'),
	(99114, 108, '2015-03-15 01:13:10.000000', 'temperatura', 896.0000, 'ºC'),
	(99115, 108, '2015-03-15 01:13:11.000000', 'temperatura', 436.0000, 'ºC'),
	(99116, 108, '2015-03-15 01:13:12.000000', 'temperatura', 691.0000, 'ºC'),
	(99117, 108, '2015-03-15 01:13:13.000000', 'temperatura', 950.0000, 'ºC'),
	(99118, 108, '2015-03-15 01:13:14.000000', 'temperatura', 276.0000, 'ºC'),
	(99119, 108, '2015-03-15 01:13:15.000000', 'temperatura', 931.0000, 'ºC'),
	(99120, 108, '2015-03-15 01:13:16.000000', 'temperatura', 229.0000, 'ºC'),
	(99121, 108, '2015-03-15 01:13:17.000000', 'temperatura', 753.0000, 'ºC'),
	(99122, 108, '2015-03-15 01:13:18.000000', 'temperatura', 676.0000, 'ºC'),
	(99123, 108, '2015-03-15 01:13:19.000000', 'temperatura', 1123.0000, 'ºC'),
	(99124, 108, '2015-03-15 01:13:20.000000', 'temperatura', 1187.0000, 'ºC'),
	(99125, 108, '2015-03-15 01:13:21.000000', 'temperatura', 166.0000, 'ºC'),
	(99126, 108, '2015-03-15 01:13:22.000000', 'temperatura', 872.0000, 'ºC'),
	(99127, 108, '2015-03-15 01:13:23.000000', 'temperatura', 260.0000, 'ºC'),
	(99128, 108, '2015-03-15 01:13:24.000000', 'temperatura', 1085.0000, 'ºC'),
	(99129, 108, '2015-03-15 01:13:25.000000', 'temperatura', 1047.0000, 'ºC'),
	(99130, 108, '2015-03-15 01:13:26.000000', 'temperatura', 780.0000, 'ºC'),
	(99131, 108, '2015-03-15 01:13:27.000000', 'temperatura', 760.0000, 'ºC'),
	(99132, 108, '2015-03-15 01:13:28.000000', 'temperatura', 258.0000, 'ºC'),
	(99133, 108, '2015-03-15 01:13:29.000000', 'temperatura', 213.0000, 'ºC'),
	(99134, 108, '2015-03-15 01:13:30.000000', 'temperatura', 293.0000, 'ºC'),
	(99135, 108, '2015-03-15 01:13:31.000000', 'temperatura', 824.0000, 'ºC'),
	(99136, 108, '2015-03-15 01:13:32.000000', 'temperatura', 842.0000, 'ºC'),
	(99137, 108, '2015-03-15 01:13:33.000000', 'temperatura', 539.0000, 'ºC'),
	(99138, 108, '2015-03-15 01:13:34.000000', 'temperatura', 168.0000, 'ºC'),
	(99139, 108, '2015-03-15 01:13:35.000000', 'temperatura', 422.0000, 'ºC'),
	(99140, 108, '2015-03-15 01:13:36.000000', 'temperatura', 410.0000, 'ºC'),
	(99141, 108, '2015-03-15 01:13:37.000000', 'temperatura', 783.0000, 'ºC'),
	(99142, 108, '2015-03-15 01:13:38.000000', 'temperatura', 285.0000, 'ºC'),
	(99143, 108, '2015-03-15 01:13:39.000000', 'temperatura', 278.0000, 'ºC'),
	(99144, 108, '2015-03-15 01:13:40.000000', 'temperatura', 533.0000, 'ºC'),
	(99145, 108, '2015-03-15 01:13:41.000000', 'temperatura', 632.0000, 'ºC'),
	(99146, 108, '2015-03-15 01:13:42.000000', 'temperatura', 360.0000, 'ºC'),
	(99147, 108, '2015-03-15 01:13:43.000000', 'temperatura', 1107.0000, 'ºC'),
	(99148, 108, '2015-03-15 01:13:44.000000', 'temperatura', 854.0000, 'ºC'),
	(99149, 108, '2015-03-15 01:13:45.000000', 'temperatura', 950.0000, 'ºC'),
	(99150, 108, '2015-03-15 01:13:46.000000', 'temperatura', 989.0000, 'ºC'),
	(99151, 108, '2015-03-15 01:13:47.000000', 'temperatura', 896.0000, 'ºC'),
	(99152, 108, '2015-03-15 01:13:48.000000', 'temperatura', 311.0000, 'ºC'),
	(99153, 108, '2015-03-15 01:13:49.000000', 'temperatura', 69.0000, 'ºC'),
	(99154, 108, '2015-03-15 01:13:50.000000', 'temperatura', 614.0000, 'ºC'),
	(99155, 108, '2015-03-15 01:13:51.000000', 'temperatura', 462.0000, 'ºC'),
	(99156, 108, '2015-03-15 01:13:52.000000', 'temperatura', 470.0000, 'ºC'),
	(99157, 108, '2015-03-15 01:13:53.000000', 'temperatura', 964.0000, 'ºC'),
	(99158, 108, '2015-03-15 01:13:54.000000', 'temperatura', 1008.0000, 'ºC'),
	(99159, 108, '2015-03-15 01:13:55.000000', 'temperatura', 952.0000, 'ºC'),
	(99160, 108, '2015-03-15 01:13:56.000000', 'temperatura', 533.0000, 'ºC'),
	(99161, 108, '2015-03-15 01:13:57.000000', 'temperatura', 1012.0000, 'ºC'),
	(99162, 108, '2015-03-15 01:13:58.000000', 'temperatura', 1062.0000, 'ºC'),
	(99163, 108, '2015-03-15 01:13:59.000000', 'temperatura', 1072.0000, 'ºC'),
	(99164, 108, '2015-03-15 01:14:00.000000', 'temperatura', 975.0000, 'ºC'),
	(99165, 108, '2015-03-15 01:14:01.000000', 'temperatura', 460.0000, 'ºC'),
	(99166, 108, '2015-03-15 01:14:02.000000', 'temperatura', 574.0000, 'ºC'),
	(99167, 108, '2015-03-15 01:14:03.000000', 'temperatura', 293.0000, 'ºC'),
	(99168, 108, '2015-03-15 01:14:04.000000', 'temperatura', 941.0000, 'ºC'),
	(99169, 108, '2015-03-15 01:14:05.000000', 'temperatura', 228.0000, 'ºC'),
	(99170, 108, '2015-03-15 01:14:06.000000', 'temperatura', 717.0000, 'ºC'),
	(99171, 108, '2015-03-15 01:14:07.000000', 'temperatura', 502.0000, 'ºC'),
	(99172, 108, '2015-03-15 01:14:08.000000', 'temperatura', 361.0000, 'ºC'),
	(99173, 108, '2015-03-15 01:14:09.000000', 'temperatura', 299.0000, 'ºC'),
	(99174, 108, '2015-03-15 01:14:10.000000', 'temperatura', 413.0000, 'ºC'),
	(99175, 108, '2015-03-15 01:14:11.000000', 'temperatura', 1170.0000, 'ºC'),
	(99176, 108, '2015-03-15 01:14:12.000000', 'temperatura', 1010.0000, 'ºC'),
	(99177, 108, '2015-03-15 01:14:13.000000', 'temperatura', 338.0000, 'ºC'),
	(99178, 108, '2015-03-15 01:14:14.000000', 'temperatura', 1064.0000, 'ºC'),
	(99179, 108, '2015-03-15 01:14:15.000000', 'temperatura', 705.0000, 'ºC'),
	(99180, 108, '2015-03-15 01:14:16.000000', 'temperatura', 335.0000, 'ºC'),
	(99181, 108, '2015-03-15 01:14:17.000000', 'temperatura', 757.0000, 'ºC'),
	(99182, 108, '2015-03-15 01:14:18.000000', 'temperatura', 384.0000, 'ºC'),
	(99183, 108, '2015-03-15 01:14:19.000000', 'temperatura', 849.0000, 'ºC'),
	(99184, 108, '2015-03-15 01:14:20.000000', 'temperatura', 693.0000, 'ºC'),
	(99185, 108, '2015-03-15 01:14:21.000000', 'temperatura', 920.0000, 'ºC'),
	(99186, 108, '2015-03-15 01:14:22.000000', 'temperatura', 120.0000, 'ºC'),
	(99187, 108, '2015-03-15 01:14:23.000000', 'temperatura', 241.0000, 'ºC'),
	(99188, 108, '2015-03-15 01:14:24.000000', 'temperatura', 844.0000, 'ºC'),
	(99189, 108, '2015-03-15 01:14:25.000000', 'temperatura', 1097.0000, 'ºC'),
	(99190, 108, '2015-03-15 01:14:26.000000', 'temperatura', 555.0000, 'ºC'),
	(99191, 108, '2015-03-15 01:14:27.000000', 'temperatura', 684.0000, 'ºC'),
	(99192, 108, '2015-03-15 01:14:28.000000', 'temperatura', 556.0000, 'ºC'),
	(99193, 108, '2015-03-15 01:14:29.000000', 'temperatura', 730.0000, 'ºC'),
	(99194, 108, '2015-03-15 01:14:30.000000', 'temperatura', 780.0000, 'ºC'),
	(99195, 108, '2015-03-15 01:14:31.000000', 'temperatura', 511.0000, 'ºC'),
	(99196, 108, '2015-03-15 01:14:32.000000', 'temperatura', 215.0000, 'ºC'),
	(99197, 108, '2015-03-15 01:14:33.000000', 'temperatura', 745.0000, 'ºC'),
	(99198, 108, '2015-03-15 01:14:34.000000', 'temperatura', 677.0000, 'ºC'),
	(99199, 108, '2015-03-15 01:14:35.000000', 'temperatura', 1153.0000, 'ºC'),
	(99200, 108, '2015-03-15 01:14:36.000000', 'temperatura', 132.0000, 'ºC'),
	(99201, 108, '2015-03-15 01:14:37.000000', 'temperatura', 804.0000, 'ºC'),
	(99202, 108, '2015-03-15 01:14:38.000000', 'temperatura', 22.0000, 'ºC'),
	(99203, 108, '2015-03-15 01:14:39.000000', 'temperatura', 101.0000, 'ºC'),
	(99204, 108, '2015-03-15 01:14:40.000000', 'temperatura', 438.0000, 'ºC'),
	(99205, 108, '2015-03-15 01:14:41.000000', 'temperatura', 686.0000, 'ºC'),
	(99206, 108, '2015-03-15 01:14:42.000000', 'temperatura', 919.0000, 'ºC'),
	(99207, 108, '2015-03-15 01:14:43.000000', 'temperatura', 135.0000, 'ºC'),
	(99208, 108, '2015-03-15 01:14:44.000000', 'temperatura', 321.0000, 'ºC'),
	(99209, 108, '2015-03-15 01:14:45.000000', 'temperatura', 0.0000, 'ºC'),
	(99210, 108, '2015-03-15 01:14:46.000000', 'temperatura', 238.0000, 'ºC'),
	(99211, 108, '2015-03-15 01:14:47.000000', 'temperatura', 1189.0000, 'ºC'),
	(99212, 108, '2015-03-15 01:14:48.000000', 'temperatura', 432.0000, 'ºC'),
	(99213, 108, '2015-03-15 01:14:49.000000', 'temperatura', 992.0000, 'ºC'),
	(99214, 108, '2015-03-15 01:14:50.000000', 'temperatura', 66.0000, 'ºC'),
	(99215, 108, '2015-03-15 01:14:51.000000', 'temperatura', 956.0000, 'ºC'),
	(99216, 108, '2015-03-15 01:14:52.000000', 'temperatura', 979.0000, 'ºC'),
	(99217, 108, '2015-03-15 01:14:53.000000', 'temperatura', 830.0000, 'ºC'),
	(99218, 108, '2015-03-15 01:14:54.000000', 'temperatura', 15.0000, 'ºC'),
	(99219, 108, '2015-03-15 01:14:55.000000', 'temperatura', 1183.0000, 'ºC'),
	(99220, 108, '2015-03-15 01:14:56.000000', 'temperatura', 1070.0000, 'ºC'),
	(99221, 108, '2015-03-15 01:14:57.000000', 'temperatura', 602.0000, 'ºC'),
	(99222, 108, '2015-03-15 01:14:58.000000', 'temperatura', 1002.0000, 'ºC'),
	(99223, 108, '2015-03-15 01:14:59.000000', 'temperatura', 802.0000, 'ºC'),
	(99224, 108, '2015-03-15 01:15:00.000000', 'temperatura', 1006.0000, 'ºC'),
	(99225, 108, '2015-03-15 01:15:01.000000', 'temperatura', 223.0000, 'ºC'),
	(99226, 108, '2015-03-15 01:15:02.000000', 'temperatura', 496.0000, 'ºC'),
	(99227, 108, '2015-03-15 01:15:03.000000', 'temperatura', 615.0000, 'ºC'),
	(99228, 108, '2015-03-15 01:15:04.000000', 'temperatura', 387.0000, 'ºC'),
	(99229, 108, '2015-03-15 01:15:05.000000', 'temperatura', 89.0000, 'ºC'),
	(99230, 108, '2015-03-15 01:15:06.000000', 'temperatura', 486.0000, 'ºC'),
	(99231, 108, '2015-03-15 01:15:07.000000', 'temperatura', 962.0000, 'ºC'),
	(99232, 108, '2015-03-15 01:15:08.000000', 'temperatura', 954.0000, 'ºC'),
	(99233, 108, '2015-03-15 01:15:09.000000', 'temperatura', 684.0000, 'ºC'),
	(99234, 108, '2015-03-15 01:15:10.000000', 'temperatura', 559.0000, 'ºC'),
	(99235, 108, '2015-03-15 01:15:11.000000', 'temperatura', 745.0000, 'ºC'),
	(99236, 108, '2015-03-15 01:15:12.000000', 'temperatura', 847.0000, 'ºC'),
	(99237, 108, '2015-03-15 01:15:13.000000', 'temperatura', 799.0000, 'ºC'),
	(99238, 108, '2015-03-15 01:15:14.000000', 'temperatura', 254.0000, 'ºC'),
	(99239, 108, '2015-03-15 01:15:15.000000', 'temperatura', 74.0000, 'ºC'),
	(99240, 108, '2015-03-15 01:15:16.000000', 'temperatura', 810.0000, 'ºC'),
	(99241, 108, '2015-03-15 01:15:17.000000', 'temperatura', 229.0000, 'ºC'),
	(99242, 108, '2015-03-15 01:15:18.000000', 'temperatura', 1117.0000, 'ºC'),
	(99243, 108, '2015-03-15 01:15:19.000000', 'temperatura', 95.0000, 'ºC'),
	(99244, 108, '2015-03-15 01:15:20.000000', 'temperatura', 727.0000, 'ºC'),
	(99245, 108, '2015-03-15 01:15:21.000000', 'temperatura', 948.0000, 'ºC'),
	(99246, 108, '2015-03-15 01:15:22.000000', 'temperatura', 161.0000, 'ºC'),
	(99247, 108, '2015-03-15 01:15:23.000000', 'temperatura', 361.0000, 'ºC'),
	(99248, 108, '2015-03-15 01:15:24.000000', 'temperatura', 122.0000, 'ºC'),
	(99249, 108, '2015-03-15 01:15:25.000000', 'temperatura', 726.0000, 'ºC'),
	(99250, 108, '2015-03-15 01:15:26.000000', 'temperatura', 865.0000, 'ºC'),
	(99251, 108, '2015-03-15 01:15:27.000000', 'temperatura', 949.0000, 'ºC'),
	(99252, 108, '2015-03-15 01:15:28.000000', 'temperatura', 949.0000, 'ºC'),
	(99253, 108, '2015-03-15 01:15:29.000000', 'temperatura', 697.0000, 'ºC'),
	(99254, 108, '2015-03-15 01:15:30.000000', 'temperatura', 642.0000, 'ºC'),
	(99255, 108, '2015-03-15 01:15:31.000000', 'temperatura', 1118.0000, 'ºC'),
	(99256, 108, '2015-03-15 01:15:32.000000', 'temperatura', 66.0000, 'ºC'),
	(99257, 108, '2015-03-15 01:15:33.000000', 'temperatura', 575.0000, 'ºC'),
	(99258, 108, '2015-03-15 01:15:34.000000', 'temperatura', 277.0000, 'ºC'),
	(99259, 108, '2015-03-15 01:15:35.000000', 'temperatura', 863.0000, 'ºC'),
	(99260, 108, '2015-03-15 01:15:36.000000', 'temperatura', 1081.0000, 'ºC'),
	(99261, 108, '2015-03-15 01:15:37.000000', 'temperatura', 418.0000, 'ºC'),
	(99262, 108, '2015-03-15 01:15:38.000000', 'temperatura', 50.0000, 'ºC'),
	(99263, 108, '2015-03-15 01:15:39.000000', 'temperatura', 193.0000, 'ºC'),
	(99264, 108, '2015-03-15 01:15:40.000000', 'temperatura', 816.0000, 'ºC'),
	(99265, 108, '2015-03-15 01:15:41.000000', 'temperatura', 1103.0000, 'ºC'),
	(99266, 108, '2015-03-15 01:15:42.000000', 'temperatura', 668.0000, 'ºC'),
	(99267, 108, '2015-03-15 01:15:43.000000', 'temperatura', 29.0000, 'ºC'),
	(99268, 108, '2015-03-15 01:15:44.000000', 'temperatura', 542.0000, 'ºC'),
	(99269, 108, '2015-03-15 01:15:45.000000', 'temperatura', 224.0000, 'ºC'),
	(99270, 108, '2015-03-15 01:15:46.000000', 'temperatura', 692.0000, 'ºC'),
	(99271, 108, '2015-03-15 01:15:47.000000', 'temperatura', 392.0000, 'ºC'),
	(99272, 108, '2015-03-15 01:15:48.000000', 'temperatura', 1084.0000, 'ºC'),
	(99273, 108, '2015-03-15 01:15:49.000000', 'temperatura', 645.0000, 'ºC'),
	(99274, 108, '2015-03-15 01:15:50.000000', 'temperatura', 1171.0000, 'ºC'),
	(99275, 108, '2015-03-15 01:15:51.000000', 'temperatura', 321.0000, 'ºC'),
	(99276, 108, '2015-03-15 01:15:52.000000', 'temperatura', 492.0000, 'ºC'),
	(99277, 108, '2015-03-15 01:15:53.000000', 'temperatura', 300.0000, 'ºC'),
	(99278, 108, '2015-03-15 01:15:54.000000', 'temperatura', 22.0000, 'ºC'),
	(99279, 108, '2015-03-15 01:15:55.000000', 'temperatura', 409.0000, 'ºC'),
	(99280, 108, '2015-03-15 01:15:56.000000', 'temperatura', 783.0000, 'ºC'),
	(99281, 108, '2015-03-15 01:15:57.000000', 'temperatura', 288.0000, 'ºC'),
	(99282, 108, '2015-03-15 01:15:58.000000', 'temperatura', 292.0000, 'ºC'),
	(99283, 108, '2015-03-15 01:15:59.000000', 'temperatura', 597.0000, 'ºC'),
	(99284, 108, '2015-03-15 01:16:00.000000', 'temperatura', 910.0000, 'ºC'),
	(99285, 108, '2015-03-15 01:16:01.000000', 'temperatura', 358.0000, 'ºC'),
	(99286, 108, '2015-03-15 01:16:02.000000', 'temperatura', 260.0000, 'ºC'),
	(99287, 108, '2015-03-15 01:16:03.000000', 'temperatura', 227.0000, 'ºC'),
	(99288, 108, '2015-03-15 01:16:04.000000', 'temperatura', 354.0000, 'ºC'),
	(99289, 108, '2015-03-15 01:16:05.000000', 'temperatura', 1089.0000, 'ºC'),
	(99290, 108, '2015-03-15 01:16:06.000000', 'temperatura', 786.0000, 'ºC'),
	(99291, 108, '2015-03-15 01:16:07.000000', 'temperatura', 661.0000, 'ºC'),
	(99292, 108, '2015-03-15 01:16:08.000000', 'temperatura', 948.0000, 'ºC'),
	(99293, 108, '2015-03-15 01:16:09.000000', 'temperatura', 358.0000, 'ºC'),
	(99294, 108, '2015-03-15 01:16:10.000000', 'temperatura', 146.0000, 'ºC'),
	(99295, 108, '2015-03-15 01:16:11.000000', 'temperatura', 857.0000, 'ºC'),
	(99296, 108, '2015-03-15 01:16:12.000000', 'temperatura', 249.0000, 'ºC'),
	(99297, 108, '2015-03-15 01:16:13.000000', 'temperatura', 1072.0000, 'ºC'),
	(99298, 108, '2015-03-15 01:16:14.000000', 'temperatura', 1013.0000, 'ºC'),
	(99299, 108, '2015-03-15 01:16:15.000000', 'temperatura', 653.0000, 'ºC'),
	(99300, 108, '2015-03-15 01:16:16.000000', 'temperatura', 223.0000, 'ºC'),
	(99301, 108, '2015-03-15 01:16:17.000000', 'temperatura', 356.0000, 'ºC'),
	(99302, 108, '2015-03-15 01:16:18.000000', 'temperatura', 1115.0000, 'ºC'),
	(99303, 108, '2015-03-15 01:16:19.000000', 'temperatura', 905.0000, 'ºC'),
	(99304, 108, '2015-03-15 01:16:20.000000', 'temperatura', 1180.0000, 'ºC'),
	(99305, 108, '2015-03-15 01:16:21.000000', 'temperatura', 784.0000, 'ºC'),
	(99306, 108, '2015-03-15 01:16:22.000000', 'temperatura', 384.0000, 'ºC'),
	(99307, 108, '2015-03-15 01:16:23.000000', 'temperatura', 766.0000, 'ºC'),
	(99308, 108, '2015-03-15 01:16:24.000000', 'temperatura', 279.0000, 'ºC'),
	(99309, 108, '2015-03-15 01:16:25.000000', 'temperatura', 300.0000, 'ºC'),
	(99310, 108, '2015-03-15 01:16:26.000000', 'temperatura', 661.0000, 'ºC'),
	(99311, 108, '2015-03-15 01:16:27.000000', 'temperatura', 5.0000, 'ºC'),
	(99312, 108, '2015-03-15 01:16:28.000000', 'temperatura', 442.0000, 'ºC'),
	(99313, 108, '2015-03-15 01:16:29.000000', 'temperatura', 998.0000, 'ºC'),
	(99314, 108, '2015-03-15 01:16:30.000000', 'temperatura', 64.0000, 'ºC'),
	(99315, 108, '2015-03-15 01:16:31.000000', 'temperatura', 927.0000, 'ºC'),
	(99316, 108, '2015-03-15 01:16:32.000000', 'temperatura', 844.0000, 'ºC'),
	(99317, 108, '2015-03-15 01:16:33.000000', 'temperatura', 239.0000, 'ºC'),
	(99318, 108, '2015-03-15 01:16:34.000000', 'temperatura', 1063.0000, 'ºC'),
	(99319, 108, '2015-03-15 01:16:35.000000', 'temperatura', 997.0000, 'ºC'),
	(99320, 108, '2015-03-15 01:16:36.000000', 'temperatura', 598.0000, 'ºC'),
	(99321, 108, '2015-03-15 01:16:37.000000', 'temperatura', 1198.0000, 'ºC'),
	(99322, 108, '2015-03-15 01:16:38.000000', 'temperatura', 596.0000, 'ºC'),
	(99323, 108, '2015-03-15 01:16:39.000000', 'temperatura', 589.0000, 'ºC'),
	(99324, 108, '2015-03-15 01:16:40.000000', 'temperatura', 1157.0000, 'ºC'),
	(99325, 108, '2015-03-15 01:16:41.000000', 'temperatura', 417.0000, 'ºC'),
	(99326, 108, '2015-03-15 01:16:42.000000', 'temperatura', 1017.0000, 'ºC'),
	(99327, 108, '2015-03-15 01:16:43.000000', 'temperatura', 234.0000, 'ºC'),
	(99328, 108, '2015-03-15 01:16:44.000000', 'temperatura', 518.0000, 'ºC'),
	(99329, 108, '2015-03-15 01:16:45.000000', 'temperatura', 689.0000, 'ºC'),
	(99330, 108, '2015-03-15 01:16:46.000000', 'temperatura', 690.0000, 'ºC'),
	(99331, 108, '2015-03-15 01:16:47.000000', 'temperatura', 185.0000, 'ºC'),
	(99332, 108, '2015-03-15 01:16:48.000000', 'temperatura', 56.0000, 'ºC'),
	(99333, 108, '2015-03-15 01:16:49.000000', 'temperatura', 925.0000, 'ºC'),
	(99334, 108, '2015-03-15 01:16:50.000000', 'temperatura', 859.0000, 'ºC'),
	(99335, 108, '2015-03-15 01:16:51.000000', 'temperatura', 319.0000, 'ºC'),
	(99336, 108, '2015-03-15 01:16:52.000000', 'temperatura', 221.0000, 'ºC'),
	(99337, 108, '2015-03-15 01:16:53.000000', 'temperatura', 145.0000, 'ºC'),
	(99338, 108, '2015-03-15 01:16:54.000000', 'temperatura', 65.0000, 'ºC'),
	(99339, 108, '2015-03-15 01:16:55.000000', 'temperatura', 1091.0000, 'ºC'),
	(99340, 108, '2015-03-15 01:16:56.000000', 'temperatura', 460.0000, 'ºC'),
	(99341, 108, '2015-03-15 01:16:57.000000', 'temperatura', 226.0000, 'ºC'),
	(99342, 108, '2015-03-15 01:16:58.000000', 'temperatura', 952.0000, 'ºC'),
	(99343, 108, '2015-03-15 01:16:59.000000', 'temperatura', 484.0000, 'ºC'),
	(99344, 108, '2015-03-15 01:17:00.000000', 'temperatura', 763.0000, 'ºC'),
	(99345, 108, '2015-03-15 01:17:01.000000', 'temperatura', 1165.0000, 'ºC'),
	(99346, 108, '2015-03-15 01:17:02.000000', 'temperatura', 1138.0000, 'ºC'),
	(99347, 108, '2015-03-15 01:17:03.000000', 'temperatura', 992.0000, 'ºC'),
	(99348, 108, '2015-03-15 01:17:04.000000', 'temperatura', 348.0000, 'ºC'),
	(99349, 108, '2015-03-15 01:17:05.000000', 'temperatura', 1165.0000, 'ºC'),
	(99350, 108, '2015-03-15 01:17:06.000000', 'temperatura', 1181.0000, 'ºC'),
	(99351, 108, '2015-03-15 01:17:07.000000', 'temperatura', 10.0000, 'ºC'),
	(99352, 108, '2015-03-15 01:17:08.000000', 'temperatura', 107.0000, 'ºC'),
	(99353, 108, '2015-03-15 01:17:09.000000', 'temperatura', 506.0000, 'ºC'),
	(99354, 108, '2015-03-15 01:17:10.000000', 'temperatura', 1011.0000, 'ºC'),
	(99355, 108, '2015-03-15 01:17:11.000000', 'temperatura', 1136.0000, 'ºC'),
	(99356, 108, '2015-03-15 01:17:12.000000', 'temperatura', 246.0000, 'ºC'),
	(99357, 108, '2015-03-15 01:17:13.000000', 'temperatura', 225.0000, 'ºC'),
	(99358, 108, '2015-03-15 01:17:14.000000', 'temperatura', 387.0000, 'ºC'),
	(99359, 108, '2015-03-15 01:17:15.000000', 'temperatura', 58.0000, 'ºC'),
	(99360, 108, '2015-03-15 01:17:16.000000', 'temperatura', 332.0000, 'ºC'),
	(99361, 108, '2015-03-15 01:17:17.000000', 'temperatura', 287.0000, 'ºC'),
	(99362, 108, '2015-03-15 01:17:18.000000', 'temperatura', 439.0000, 'ºC'),
	(99363, 108, '2015-03-15 01:17:19.000000', 'temperatura', 133.0000, 'ºC'),
	(99364, 108, '2015-03-15 01:17:20.000000', 'temperatura', 548.0000, 'ºC'),
	(99365, 108, '2015-03-15 01:17:21.000000', 'temperatura', 1144.0000, 'ºC'),
	(99366, 108, '2015-03-15 01:17:22.000000', 'temperatura', 476.0000, 'ºC'),
	(99367, 108, '2015-03-15 01:17:23.000000', 'temperatura', 150.0000, 'ºC'),
	(99368, 108, '2015-03-15 01:17:24.000000', 'temperatura', 519.0000, 'ºC'),
	(99369, 108, '2015-03-15 01:17:25.000000', 'temperatura', 948.0000, 'ºC'),
	(99370, 108, '2015-03-15 01:17:26.000000', 'temperatura', 782.0000, 'ºC'),
	(99371, 108, '2015-03-15 01:17:27.000000', 'temperatura', 1065.0000, 'ºC'),
	(99372, 108, '2015-03-15 01:17:28.000000', 'temperatura', 581.0000, 'ºC'),
	(99373, 108, '2015-03-15 01:17:29.000000', 'temperatura', 912.0000, 'ºC'),
	(99374, 108, '2015-03-15 01:17:30.000000', 'temperatura', 418.0000, 'ºC'),
	(99375, 108, '2015-03-15 01:17:31.000000', 'temperatura', 552.0000, 'ºC'),
	(99376, 108, '2015-03-15 01:17:32.000000', 'temperatura', 306.0000, 'ºC'),
	(99377, 108, '2015-03-15 01:17:33.000000', 'temperatura', 1075.0000, 'ºC'),
	(99378, 108, '2015-03-15 01:17:34.000000', 'temperatura', 859.0000, 'ºC'),
	(99379, 108, '2015-03-15 01:17:35.000000', 'temperatura', 1068.0000, 'ºC'),
	(99380, 108, '2015-03-15 01:17:36.000000', 'temperatura', 364.0000, 'ºC'),
	(99381, 108, '2015-03-15 01:17:37.000000', 'temperatura', 1015.0000, 'ºC'),
	(99382, 108, '2015-03-15 01:17:38.000000', 'temperatura', 384.0000, 'ºC'),
	(99383, 108, '2015-03-15 01:17:39.000000', 'temperatura', 78.0000, 'ºC'),
	(99384, 108, '2015-03-15 01:17:40.000000', 'temperatura', 436.0000, 'ºC'),
	(99385, 108, '2015-03-15 01:17:41.000000', 'temperatura', 746.0000, 'ºC'),
	(99386, 108, '2015-03-15 01:17:42.000000', 'temperatura', 23.0000, 'ºC'),
	(99387, 108, '2015-03-15 01:17:43.000000', 'temperatura', 279.0000, 'ºC'),
	(99388, 108, '2015-03-15 01:17:44.000000', 'temperatura', 124.0000, 'ºC'),
	(99389, 108, '2015-03-15 01:17:45.000000', 'temperatura', 984.0000, 'ºC'),
	(99390, 108, '2015-03-15 01:17:46.000000', 'temperatura', 949.0000, 'ºC'),
	(99391, 108, '2015-03-15 01:17:47.000000', 'temperatura', 595.0000, 'ºC'),
	(99392, 108, '2015-03-15 01:17:48.000000', 'temperatura', 126.0000, 'ºC'),
	(99393, 108, '2015-03-15 01:17:49.000000', 'temperatura', 48.0000, 'ºC'),
	(99394, 108, '2015-03-15 01:17:50.000000', 'temperatura', 1062.0000, 'ºC'),
	(99395, 108, '2015-03-15 01:17:51.000000', 'temperatura', 364.0000, 'ºC'),
	(99396, 108, '2015-03-15 01:17:52.000000', 'temperatura', 1037.0000, 'ºC'),
	(99397, 108, '2015-03-15 01:17:53.000000', 'temperatura', 491.0000, 'ºC'),
	(99398, 108, '2015-03-15 01:17:54.000000', 'temperatura', 544.0000, 'ºC'),
	(99399, 108, '2015-03-15 01:17:55.000000', 'temperatura', 50.0000, 'ºC'),
	(99400, 108, '2015-03-15 01:17:56.000000', 'temperatura', 1016.0000, 'ºC'),
	(99401, 108, '2015-03-15 01:17:57.000000', 'temperatura', 130.0000, 'ºC'),
	(99402, 108, '2015-03-15 01:17:58.000000', 'temperatura', 4.0000, 'ºC'),
	(99403, 108, '2015-03-15 01:17:59.000000', 'temperatura', 830.0000, 'ºC'),
	(99404, 108, '2015-03-15 01:18:00.000000', 'temperatura', 540.0000, 'ºC'),
	(99405, 108, '2015-03-15 01:18:01.000000', 'temperatura', 208.0000, 'ºC'),
	(99406, 108, '2015-03-15 01:18:02.000000', 'temperatura', 623.0000, 'ºC'),
	(99407, 108, '2015-03-15 01:18:03.000000', 'temperatura', 92.0000, 'ºC'),
	(99408, 108, '2015-03-15 01:18:04.000000', 'temperatura', 989.0000, 'ºC'),
	(99409, 108, '2015-03-15 01:18:05.000000', 'temperatura', 1072.0000, 'ºC'),
	(99410, 108, '2015-03-15 01:18:06.000000', 'temperatura', 1193.0000, 'ºC'),
	(99411, 108, '2015-03-15 01:18:07.000000', 'temperatura', 350.0000, 'ºC'),
	(99412, 108, '2015-03-15 01:18:08.000000', 'temperatura', 573.0000, 'ºC'),
	(99413, 108, '2015-03-15 01:18:09.000000', 'temperatura', 614.0000, 'ºC'),
	(99414, 108, '2015-03-15 01:18:10.000000', 'temperatura', 150.0000, 'ºC'),
	(99415, 108, '2015-03-15 01:18:11.000000', 'temperatura', 108.0000, 'ºC'),
	(99416, 108, '2015-03-15 01:18:12.000000', 'temperatura', 94.0000, 'ºC'),
	(99417, 108, '2015-03-15 01:18:13.000000', 'temperatura', 143.0000, 'ºC'),
	(99418, 108, '2015-03-15 01:18:14.000000', 'temperatura', 435.0000, 'ºC'),
	(99419, 108, '2015-03-15 01:18:15.000000', 'temperatura', 548.0000, 'ºC'),
	(99420, 108, '2015-03-15 01:18:16.000000', 'temperatura', 235.0000, 'ºC'),
	(99421, 108, '2015-03-15 01:18:17.000000', 'temperatura', 733.0000, 'ºC'),
	(99422, 108, '2015-03-15 01:18:18.000000', 'temperatura', 557.0000, 'ºC'),
	(99423, 108, '2015-03-15 01:18:19.000000', 'temperatura', 589.0000, 'ºC'),
	(99424, 108, '2015-03-15 01:18:20.000000', 'temperatura', 72.0000, 'ºC'),
	(99425, 108, '2015-03-15 01:18:21.000000', 'temperatura', 996.0000, 'ºC'),
	(99426, 108, '2015-03-15 01:18:22.000000', 'temperatura', 1163.0000, 'ºC'),
	(99427, 108, '2015-03-15 01:18:23.000000', 'temperatura', 426.0000, 'ºC'),
	(99428, 108, '2015-03-15 01:18:24.000000', 'temperatura', 1043.0000, 'ºC'),
	(99429, 108, '2015-03-15 01:18:25.000000', 'temperatura', 337.0000, 'ºC'),
	(99430, 108, '2015-03-15 01:18:26.000000', 'temperatura', 957.0000, 'ºC'),
	(99431, 108, '2015-03-15 01:18:27.000000', 'temperatura', 174.0000, 'ºC'),
	(99432, 108, '2015-03-15 01:18:28.000000', 'temperatura', 399.0000, 'ºC'),
	(99433, 108, '2015-03-15 01:18:29.000000', 'temperatura', 272.0000, 'ºC'),
	(99434, 108, '2015-03-15 01:18:30.000000', 'temperatura', 165.0000, 'ºC'),
	(99435, 108, '2015-03-15 01:18:31.000000', 'temperatura', 9.0000, 'ºC'),
	(99436, 108, '2015-03-15 01:18:32.000000', 'temperatura', 751.0000, 'ºC'),
	(99437, 108, '2015-03-15 01:18:33.000000', 'temperatura', 128.0000, 'ºC'),
	(99438, 108, '2015-03-15 01:18:34.000000', 'temperatura', 789.0000, 'ºC'),
	(99439, 108, '2015-03-15 01:18:35.000000', 'temperatura', 1160.0000, 'ºC'),
	(99440, 108, '2015-03-15 01:18:36.000000', 'temperatura', 1035.0000, 'ºC'),
	(99441, 108, '2015-03-15 01:18:37.000000', 'temperatura', 496.0000, 'ºC'),
	(99442, 108, '2015-03-15 01:18:38.000000', 'temperatura', 576.0000, 'ºC'),
	(99443, 108, '2015-03-15 01:18:39.000000', 'temperatura', 193.0000, 'ºC'),
	(99444, 108, '2015-03-15 01:18:40.000000', 'temperatura', 435.0000, 'ºC'),
	(99445, 108, '2015-03-15 01:18:41.000000', 'temperatura', 398.0000, 'ºC'),
	(99446, 108, '2015-03-15 01:18:42.000000', 'temperatura', 686.0000, 'ºC'),
	(99447, 108, '2015-03-15 01:18:43.000000', 'temperatura', 1034.0000, 'ºC'),
	(99448, 108, '2015-03-15 01:18:44.000000', 'temperatura', 714.0000, 'ºC'),
	(99449, 108, '2015-03-15 01:18:45.000000', 'temperatura', 470.0000, 'ºC'),
	(99450, 108, '2015-03-15 01:18:46.000000', 'temperatura', 208.0000, 'ºC'),
	(99451, 108, '2015-03-15 01:18:47.000000', 'temperatura', 828.0000, 'ºC'),
	(99452, 108, '2015-03-15 01:18:48.000000', 'temperatura', 1118.0000, 'ºC'),
	(99453, 108, '2015-03-15 01:18:49.000000', 'temperatura', 705.0000, 'ºC'),
	(99454, 108, '2015-03-15 01:18:50.000000', 'temperatura', 172.0000, 'ºC'),
	(99455, 108, '2015-03-15 01:18:51.000000', 'temperatura', 1147.0000, 'ºC'),
	(99456, 108, '2015-03-15 01:18:52.000000', 'temperatura', 417.0000, 'ºC'),
	(99457, 108, '2015-03-15 01:18:53.000000', 'temperatura', 1044.0000, 'ºC'),
	(99458, 108, '2015-03-15 01:18:54.000000', 'temperatura', 372.0000, 'ºC'),
	(99459, 108, '2015-03-15 01:18:55.000000', 'temperatura', 1126.0000, 'ºC'),
	(99460, 108, '2015-03-15 01:18:56.000000', 'temperatura', 914.0000, 'ºC'),
	(99461, 108, '2015-03-15 01:18:57.000000', 'temperatura', 1195.0000, 'ºC'),
	(99462, 108, '2015-03-15 01:18:58.000000', 'temperatura', 834.0000, 'ºC'),
	(99463, 108, '2015-03-15 01:18:59.000000', 'temperatura', 583.0000, 'ºC'),
	(99464, 108, '2015-03-15 01:19:00.000000', 'temperatura', 415.0000, 'ºC'),
	(99465, 108, '2015-03-15 01:19:01.000000', 'temperatura', 325.0000, 'ºC'),
	(99466, 108, '2015-03-15 01:19:02.000000', 'temperatura', 382.0000, 'ºC'),
	(99467, 108, '2015-03-15 01:19:03.000000', 'temperatura', 937.0000, 'ºC'),
	(99468, 108, '2015-03-15 01:19:04.000000', 'temperatura', 1138.0000, 'ºC'),
	(99469, 108, '2015-03-15 01:19:05.000000', 'temperatura', 480.0000, 'ºC'),
	(99470, 108, '2015-03-15 01:19:06.000000', 'temperatura', 187.0000, 'ºC'),
	(99471, 108, '2015-03-15 01:19:07.000000', 'temperatura', 697.0000, 'ºC'),
	(99472, 108, '2015-03-15 01:19:08.000000', 'temperatura', 523.0000, 'ºC'),
	(99473, 108, '2015-03-15 01:19:09.000000', 'temperatura', 523.0000, 'ºC'),
	(99474, 108, '2015-03-15 01:19:10.000000', 'temperatura', 1049.0000, 'ºC'),
	(99475, 108, '2015-03-15 01:19:11.000000', 'temperatura', 76.0000, 'ºC'),
	(99476, 108, '2015-03-15 01:19:12.000000', 'temperatura', 835.0000, 'ºC'),
	(99477, 108, '2015-03-15 01:19:13.000000', 'temperatura', 345.0000, 'ºC'),
	(99478, 108, '2015-03-15 01:19:14.000000', 'temperatura', 422.0000, 'ºC'),
	(99479, 108, '2015-03-15 01:19:15.000000', 'temperatura', 1076.0000, 'ºC'),
	(99480, 108, '2015-03-15 01:19:16.000000', 'temperatura', 515.0000, 'ºC'),
	(99481, 108, '2015-03-15 01:19:17.000000', 'temperatura', 545.0000, 'ºC'),
	(99482, 108, '2015-03-15 01:19:18.000000', 'temperatura', 1183.0000, 'ºC'),
	(99483, 108, '2015-03-15 01:19:19.000000', 'temperatura', 680.0000, 'ºC'),
	(99484, 108, '2015-03-15 01:19:20.000000', 'temperatura', 1053.0000, 'ºC'),
	(99485, 108, '2015-03-15 01:19:21.000000', 'temperatura', 824.0000, 'ºC'),
	(99486, 108, '2015-03-15 01:19:22.000000', 'temperatura', 962.0000, 'ºC'),
	(99487, 108, '2015-03-15 01:19:23.000000', 'temperatura', 1140.0000, 'ºC'),
	(99488, 108, '2015-03-15 01:19:24.000000', 'temperatura', 412.0000, 'ºC'),
	(99489, 108, '2015-03-15 01:19:25.000000', 'temperatura', 1039.0000, 'ºC'),
	(99490, 108, '2015-03-15 01:19:26.000000', 'temperatura', 363.0000, 'ºC'),
	(99491, 108, '2015-03-15 01:19:27.000000', 'temperatura', 1096.0000, 'ºC'),
	(99492, 108, '2015-03-15 01:19:28.000000', 'temperatura', 791.0000, 'ºC'),
	(99493, 108, '2015-03-15 01:19:29.000000', 'temperatura', 670.0000, 'ºC'),
	(99494, 108, '2015-03-15 01:19:30.000000', 'temperatura', 978.0000, 'ºC'),
	(99495, 108, '2015-03-15 01:19:31.000000', 'temperatura', 480.0000, 'ºC'),
	(99496, 108, '2015-03-15 01:19:32.000000', 'temperatura', 668.0000, 'ºC'),
	(99497, 108, '2015-03-15 01:19:33.000000', 'temperatura', 699.0000, 'ºC'),
	(99498, 108, '2015-03-15 01:19:34.000000', 'temperatura', 294.0000, 'ºC'),
	(99499, 108, '2015-03-15 01:19:35.000000', 'temperatura', 570.0000, 'ºC'),
	(99500, 108, '2015-03-15 01:19:36.000000', 'temperatura', 770.0000, 'ºC'),
	(99501, 108, '2015-03-15 01:19:37.000000', 'temperatura', 939.0000, 'ºC'),
	(99502, 108, '2015-03-15 01:19:38.000000', 'temperatura', 1186.0000, 'ºC'),
	(99503, 108, '2015-03-15 01:19:39.000000', 'temperatura', 715.0000, 'ºC'),
	(99504, 108, '2015-03-15 01:19:40.000000', 'temperatura', 17.0000, 'ºC'),
	(99505, 108, '2015-03-15 01:19:41.000000', 'temperatura', 342.0000, 'ºC'),
	(99506, 108, '2015-03-15 01:19:42.000000', 'temperatura', 459.0000, 'ºC'),
	(99507, 108, '2015-03-15 01:19:43.000000', 'temperatura', 67.0000, 'ºC'),
	(99508, 108, '2015-03-15 01:19:44.000000', 'temperatura', 159.0000, 'ºC'),
	(99509, 108, '2015-03-15 01:19:45.000000', 'temperatura', 596.0000, 'ºC'),
	(99510, 108, '2015-03-15 01:19:46.000000', 'temperatura', 105.0000, 'ºC'),
	(99511, 108, '2015-03-15 01:19:47.000000', 'temperatura', 1134.0000, 'ºC'),
	(99512, 108, '2015-03-15 01:19:48.000000', 'temperatura', 557.0000, 'ºC'),
	(99513, 108, '2015-03-15 01:19:49.000000', 'temperatura', 585.0000, 'ºC'),
	(99514, 108, '2015-03-15 01:19:50.000000', 'temperatura', 54.0000, 'ºC'),
	(99515, 108, '2015-03-15 01:19:51.000000', 'temperatura', 915.0000, 'ºC'),
	(99516, 108, '2015-03-15 01:19:52.000000', 'temperatura', 813.0000, 'ºC'),
	(99517, 108, '2015-03-15 01:19:53.000000', 'temperatura', 122.0000, 'ºC'),
	(99518, 108, '2015-03-15 01:19:54.000000', 'temperatura', 571.0000, 'ºC'),
	(99519, 108, '2015-03-15 01:19:55.000000', 'temperatura', 88.0000, 'ºC'),
	(99520, 108, '2015-03-15 01:19:56.000000', 'temperatura', 1130.0000, 'ºC'),
	(99521, 108, '2015-03-15 01:19:57.000000', 'temperatura', 584.0000, 'ºC'),
	(99522, 108, '2015-03-15 01:19:58.000000', 'temperatura', 731.0000, 'ºC'),
	(99523, 108, '2015-03-15 01:19:59.000000', 'temperatura', 704.0000, 'ºC'),
	(99524, 108, '2015-03-15 01:20:00.000000', 'temperatura', 129.0000, 'ºC'),
	(99525, 108, '2015-03-15 01:20:01.000000', 'temperatura', 933.0000, 'ºC'),
	(99526, 108, '2015-03-15 01:20:02.000000', 'temperatura', 678.0000, 'ºC'),
	(99527, 108, '2015-03-15 01:20:03.000000', 'temperatura', 594.0000, 'ºC'),
	(99528, 108, '2015-03-15 01:20:04.000000', 'temperatura', 933.0000, 'ºC'),
	(99529, 108, '2015-03-15 01:20:05.000000', 'temperatura', 486.0000, 'ºC'),
	(99530, 108, '2015-03-15 01:20:06.000000', 'temperatura', 830.0000, 'ºC'),
	(99531, 108, '2015-03-15 01:20:07.000000', 'temperatura', 293.0000, 'ºC'),
	(99532, 108, '2015-03-15 01:20:08.000000', 'temperatura', 175.0000, 'ºC'),
	(99533, 108, '2015-03-15 01:20:09.000000', 'temperatura', 1197.0000, 'ºC'),
	(99534, 108, '2015-03-15 01:20:10.000000', 'temperatura', 662.0000, 'ºC'),
	(99535, 108, '2015-03-15 01:20:11.000000', 'temperatura', 919.0000, 'ºC'),
	(99536, 108, '2015-03-15 01:20:12.000000', 'temperatura', 209.0000, 'ºC'),
	(99537, 108, '2015-03-15 01:20:13.000000', 'temperatura', 687.0000, 'ºC'),
	(99538, 108, '2015-03-15 01:20:14.000000', 'temperatura', 408.0000, 'ºC'),
	(99539, 108, '2015-03-15 01:20:15.000000', 'temperatura', 1180.0000, 'ºC'),
	(99540, 108, '2015-03-15 01:20:16.000000', 'temperatura', 1078.0000, 'ºC'),
	(99541, 108, '2015-03-15 01:20:17.000000', 'temperatura', 651.0000, 'ºC'),
	(99542, 108, '2015-03-15 01:20:18.000000', 'temperatura', 22.0000, 'ºC'),
	(99543, 108, '2015-03-15 01:20:19.000000', 'temperatura', 555.0000, 'ºC'),
	(99544, 108, '2015-03-15 01:20:20.000000', 'temperatura', 312.0000, 'ºC'),
	(99545, 108, '2015-03-15 01:20:21.000000', 'temperatura', 1094.0000, 'ºC'),
	(99546, 108, '2015-03-15 01:20:22.000000', 'temperatura', 934.0000, 'ºC'),
	(99547, 108, '2015-03-15 01:20:23.000000', 'temperatura', 188.0000, 'ºC'),
	(99548, 108, '2015-03-15 01:20:24.000000', 'temperatura', 539.0000, 'ºC'),
	(99549, 108, '2015-03-15 01:20:25.000000', 'temperatura', 932.0000, 'ºC'),
	(99550, 108, '2015-03-15 01:20:26.000000', 'temperatura', 643.0000, 'ºC'),
	(99551, 108, '2015-03-15 01:20:27.000000', 'temperatura', 418.0000, 'ºC'),
	(99552, 108, '2015-03-15 01:20:28.000000', 'temperatura', 165.0000, 'ºC'),
	(99553, 108, '2015-03-15 01:20:29.000000', 'temperatura', 768.0000, 'ºC'),
	(99554, 108, '2015-03-15 01:20:30.000000', 'temperatura', 947.0000, 'ºC'),
	(99555, 108, '2015-03-15 01:20:31.000000', 'temperatura', 30.0000, 'ºC'),
	(99556, 108, '2015-03-15 01:20:32.000000', 'temperatura', 909.0000, 'ºC'),
	(99557, 108, '2015-03-15 01:20:33.000000', 'temperatura', 857.0000, 'ºC'),
	(99558, 108, '2015-03-15 01:20:34.000000', 'temperatura', 356.0000, 'ºC'),
	(99559, 108, '2015-03-15 01:20:35.000000', 'temperatura', 412.0000, 'ºC'),
	(99560, 108, '2015-03-15 01:20:36.000000', 'temperatura', 991.0000, 'ºC'),
	(99561, 108, '2015-03-15 01:20:37.000000', 'temperatura', 119.0000, 'ºC'),
	(99562, 108, '2015-03-15 01:20:38.000000', 'temperatura', 21.0000, 'ºC'),
	(99563, 108, '2015-03-15 01:20:39.000000', 'temperatura', 951.0000, 'ºC'),
	(99564, 108, '2015-03-15 01:20:40.000000', 'temperatura', 1091.0000, 'ºC'),
	(99565, 108, '2015-03-15 01:20:41.000000', 'temperatura', 203.0000, 'ºC'),
	(99566, 108, '2015-03-15 01:20:42.000000', 'temperatura', 141.0000, 'ºC'),
	(99567, 108, '2015-03-15 01:20:43.000000', 'temperatura', 99.0000, 'ºC'),
	(99568, 108, '2015-03-15 01:20:44.000000', 'temperatura', 71.0000, 'ºC'),
	(99569, 108, '2015-03-15 01:20:45.000000', 'temperatura', 61.0000, 'ºC'),
	(99570, 108, '2015-03-15 01:20:46.000000', 'temperatura', 90.0000, 'ºC'),
	(99571, 108, '2015-03-15 01:20:47.000000', 'temperatura', 269.0000, 'ºC'),
	(99572, 108, '2015-03-15 01:20:48.000000', 'temperatura', 1073.0000, 'ºC'),
	(99573, 108, '2015-03-15 01:20:49.000000', 'temperatura', 962.0000, 'ºC'),
	(99574, 108, '2015-03-15 01:20:50.000000', 'temperatura', 389.0000, 'ºC'),
	(99575, 108, '2015-03-15 01:20:51.000000', 'temperatura', 262.0000, 'ºC'),
	(99576, 108, '2015-03-15 01:20:52.000000', 'temperatura', 143.0000, 'ºC'),
	(99577, 108, '2015-03-15 01:20:53.000000', 'temperatura', 1131.0000, 'ºC'),
	(99578, 108, '2015-03-15 01:20:54.000000', 'temperatura', 424.0000, 'ºC'),
	(99579, 108, '2015-03-15 01:20:55.000000', 'temperatura', 1126.0000, 'ºC'),
	(99580, 108, '2015-03-15 01:20:56.000000', 'temperatura', 762.0000, 'ºC'),
	(99581, 108, '2015-03-15 01:20:57.000000', 'temperatura', 430.0000, 'ºC'),
	(99582, 108, '2015-03-15 01:20:58.000000', 'temperatura', 1065.0000, 'ºC'),
	(99583, 108, '2015-03-15 01:20:59.000000', 'temperatura', 434.0000, 'ºC'),
	(99584, 108, '2015-03-15 01:21:00.000000', 'temperatura', 176.0000, 'ºC'),
	(99585, 108, '2015-03-15 01:21:01.000000', 'temperatura', 779.0000, 'ºC'),
	(99586, 108, '2015-03-15 01:21:02.000000', 'temperatura', 970.0000, 'ºC'),
	(99587, 108, '2015-03-15 01:21:03.000000', 'temperatura', 110.0000, 'ºC'),
	(99588, 108, '2015-03-15 01:21:04.000000', 'temperatura', 42.0000, 'ºC'),
	(99589, 108, '2015-03-15 01:21:05.000000', 'temperatura', 1078.0000, 'ºC'),
	(99590, 108, '2015-03-15 01:21:06.000000', 'temperatura', 468.0000, 'ºC'),
	(99591, 108, '2015-03-15 01:21:07.000000', 'temperatura', 303.0000, 'ºC'),
	(99592, 108, '2015-03-15 01:21:08.000000', 'temperatura', 113.0000, 'ºC'),
	(99593, 108, '2015-03-15 01:21:09.000000', 'temperatura', 858.0000, 'ºC'),
	(99594, 108, '2015-03-15 01:21:10.000000', 'temperatura', 349.0000, 'ºC'),
	(99595, 108, '2015-03-15 01:21:11.000000', 'temperatura', 373.0000, 'ºC'),
	(99596, 108, '2015-03-15 01:21:12.000000', 'temperatura', 819.0000, 'ºC'),
	(99597, 108, '2015-03-15 01:21:13.000000', 'temperatura', 576.0000, 'ºC'),
	(99598, 108, '2015-03-15 01:21:14.000000', 'temperatura', 423.0000, 'ºC'),
	(99599, 108, '2015-03-15 01:21:15.000000', 'temperatura', 389.0000, 'ºC'),
	(99600, 108, '2015-03-15 01:21:16.000000', 'temperatura', 676.0000, 'ºC'),
	(99601, 108, '2015-03-15 01:21:17.000000', 'temperatura', 1012.0000, 'ºC'),
	(99602, 108, '2015-03-15 01:21:18.000000', 'temperatura', 634.0000, 'ºC'),
	(99603, 108, '2015-03-15 01:21:19.000000', 'temperatura', 133.0000, 'ºC'),
	(99604, 108, '2015-03-15 01:21:20.000000', 'temperatura', 1164.0000, 'ºC'),
	(99605, 108, '2015-03-15 01:21:21.000000', 'temperatura', 620.0000, 'ºC'),
	(99606, 108, '2015-03-15 01:21:22.000000', 'temperatura', 809.0000, 'ºC'),
	(99607, 108, '2015-03-15 01:21:23.000000', 'temperatura', 984.0000, 'ºC'),
	(99608, 108, '2015-03-15 01:21:24.000000', 'temperatura', 96.0000, 'ºC'),
	(99609, 108, '2015-03-15 01:21:25.000000', 'temperatura', 1129.0000, 'ºC'),
	(99610, 108, '2015-03-15 01:21:26.000000', 'temperatura', 555.0000, 'ºC'),
	(99611, 108, '2015-03-15 01:21:27.000000', 'temperatura', 589.0000, 'ºC'),
	(99612, 108, '2015-03-15 01:21:28.000000', 'temperatura', 83.0000, 'ºC'),
	(99613, 108, '2015-03-15 01:21:29.000000', 'temperatura', 1047.0000, 'ºC'),
	(99614, 108, '2015-03-15 01:21:30.000000', 'temperatura', 186.0000, 'ºC'),
	(99615, 108, '2015-03-15 01:21:31.000000', 'temperatura', 191.0000, 'ºC'),
	(99616, 108, '2015-03-15 01:21:32.000000', 'temperatura', 396.0000, 'ºC'),
	(99617, 108, '2015-03-15 01:21:33.000000', 'temperatura', 208.0000, 'ºC'),
	(99618, 108, '2015-03-15 01:21:34.000000', 'temperatura', 1052.0000, 'ºC'),
	(99619, 108, '2015-03-15 01:21:35.000000', 'temperatura', 1036.0000, 'ºC'),
	(99620, 108, '2015-03-15 01:21:36.000000', 'temperatura', 825.0000, 'ºC'),
	(99621, 108, '2015-03-15 01:21:37.000000', 'temperatura', 1018.0000, 'ºC'),
	(99622, 108, '2015-03-15 01:21:38.000000', 'temperatura', 215.0000, 'ºC'),
	(99623, 108, '2015-03-15 01:21:39.000000', 'temperatura', 422.0000, 'ºC'),
	(99624, 108, '2015-03-15 01:21:40.000000', 'temperatura', 266.0000, 'ºC'),
	(99625, 108, '2015-03-15 01:21:41.000000', 'temperatura', 63.0000, 'ºC'),
	(99626, 108, '2015-03-15 01:21:42.000000', 'temperatura', 717.0000, 'ºC'),
	(99627, 108, '2015-03-15 01:21:43.000000', 'temperatura', 999.0000, 'ºC'),
	(99628, 108, '2015-03-15 01:21:44.000000', 'temperatura', 444.0000, 'ºC'),
	(99629, 108, '2015-03-15 01:21:45.000000', 'temperatura', 424.0000, 'ºC'),
	(99630, 108, '2015-03-15 01:21:46.000000', 'temperatura', 788.0000, 'ºC'),
	(99631, 108, '2015-03-15 01:21:47.000000', 'temperatura', 267.0000, 'ºC'),
	(99632, 108, '2015-03-15 01:21:48.000000', 'temperatura', 171.0000, 'ºC'),
	(99633, 108, '2015-03-15 01:21:49.000000', 'temperatura', 55.0000, 'ºC'),
	(99634, 108, '2015-03-15 01:21:50.000000', 'temperatura', 962.0000, 'ºC'),
	(99635, 108, '2015-03-15 01:21:51.000000', 'temperatura', 1047.0000, 'ºC'),
	(99636, 108, '2015-03-15 01:21:52.000000', 'temperatura', 1149.0000, 'ºC'),
	(99637, 108, '2015-03-15 01:21:53.000000', 'temperatura', 206.0000, 'ºC'),
	(99638, 108, '2015-03-15 01:21:54.000000', 'temperatura', 1184.0000, 'ºC'),
	(99639, 108, '2015-03-15 01:21:55.000000', 'temperatura', 500.0000, 'ºC'),
	(99640, 108, '2015-03-15 01:21:56.000000', 'temperatura', 148.0000, 'ºC'),
	(99641, 108, '2015-03-15 01:21:57.000000', 'temperatura', 443.0000, 'ºC'),
	(99642, 108, '2015-03-15 01:21:58.000000', 'temperatura', 572.0000, 'ºC'),
	(99643, 108, '2015-03-15 01:21:59.000000', 'temperatura', 332.0000, 'ºC'),
	(99644, 108, '2015-03-15 01:22:00.000000', 'temperatura', 1144.0000, 'ºC'),
	(99645, 108, '2015-03-15 01:22:01.000000', 'temperatura', 1125.0000, 'ºC'),
	(99646, 108, '2015-03-15 01:22:02.000000', 'temperatura', 992.0000, 'ºC'),
	(99647, 108, '2015-03-15 01:22:03.000000', 'temperatura', 386.0000, 'ºC'),
	(99648, 108, '2015-03-15 01:22:04.000000', 'temperatura', 154.0000, 'ºC'),
	(99649, 108, '2015-03-15 01:22:05.000000', 'temperatura', 813.0000, 'ºC'),
	(99650, 108, '2015-03-15 01:22:06.000000', 'temperatura', 2.0000, 'ºC'),
	(99651, 108, '2015-03-15 01:22:07.000000', 'temperatura', 1172.0000, 'ºC'),
	(99652, 108, '2015-03-15 01:22:08.000000', 'temperatura', 1055.0000, 'ºC'),
	(99653, 108, '2015-03-15 01:22:09.000000', 'temperatura', 560.0000, 'ºC'),
	(99654, 108, '2015-03-15 01:22:10.000000', 'temperatura', 836.0000, 'ºC'),
	(99655, 108, '2015-03-15 01:22:11.000000', 'temperatura', 101.0000, 'ºC'),
	(99656, 108, '2015-03-15 01:22:12.000000', 'temperatura', 395.0000, 'ºC'),
	(99657, 108, '2015-03-15 01:22:13.000000', 'temperatura', 474.0000, 'ºC'),
	(99658, 108, '2015-03-15 01:22:14.000000', 'temperatura', 1184.0000, 'ºC'),
	(99659, 108, '2015-03-15 01:22:15.000000', 'temperatura', 901.0000, 'ºC'),
	(99660, 108, '2015-03-15 01:22:16.000000', 'temperatura', 952.0000, 'ºC'),
	(99661, 108, '2015-03-15 01:22:17.000000', 'temperatura', 858.0000, 'ºC'),
	(99662, 108, '2015-03-15 01:22:18.000000', 'temperatura', 234.0000, 'ºC'),
	(99663, 108, '2015-03-15 01:22:19.000000', 'temperatura', 996.0000, 'ºC'),
	(99664, 108, '2015-03-15 01:22:20.000000', 'temperatura', 678.0000, 'ºC'),
	(99665, 108, '2015-03-15 01:22:21.000000', 'temperatura', 402.0000, 'ºC'),
	(99666, 108, '2015-03-15 01:22:22.000000', 'temperatura', 1178.0000, 'ºC'),
	(99667, 108, '2015-03-15 01:22:23.000000', 'temperatura', 1086.0000, 'ºC'),
	(99668, 108, '2015-03-15 01:22:24.000000', 'temperatura', 694.0000, 'ºC'),
	(99669, 108, '2015-03-15 01:22:25.000000', 'temperatura', 215.0000, 'ºC'),
	(99670, 108, '2015-03-15 01:22:26.000000', 'temperatura', 192.0000, 'ºC'),
	(99671, 108, '2015-03-15 01:22:27.000000', 'temperatura', 316.0000, 'ºC'),
	(99672, 108, '2015-03-15 01:22:28.000000', 'temperatura', 1004.0000, 'ºC'),
	(99673, 108, '2015-03-15 01:22:29.000000', 'temperatura', 474.0000, 'ºC'),
	(99674, 108, '2015-03-15 01:22:30.000000', 'temperatura', 556.0000, 'ºC'),
	(99675, 108, '2015-03-15 01:22:31.000000', 'temperatura', 159.0000, 'ºC'),
	(99676, 108, '2015-03-15 01:22:32.000000', 'temperatura', 328.0000, 'ºC'),
	(99677, 108, '2015-03-15 01:22:33.000000', 'temperatura', 1164.0000, 'ºC'),
	(99678, 108, '2015-03-15 01:22:34.000000', 'temperatura', 34.0000, 'ºC'),
	(99679, 108, '2015-03-15 01:22:35.000000', 'temperatura', 281.0000, 'ºC'),
	(99680, 108, '2015-03-15 01:22:36.000000', 'temperatura', 105.0000, 'ºC'),
	(99681, 108, '2015-03-15 01:22:37.000000', 'temperatura', 879.0000, 'ºC'),
	(99682, 108, '2015-03-15 01:22:38.000000', 'temperatura', 484.0000, 'ºC'),
	(99683, 108, '2015-03-15 01:22:39.000000', 'temperatura', 982.0000, 'ºC'),
	(99684, 108, '2015-03-15 01:22:40.000000', 'temperatura', 1058.0000, 'ºC'),
	(99685, 108, '2015-03-15 01:22:41.000000', 'temperatura', 1143.0000, 'ºC'),
	(99686, 108, '2015-03-15 01:22:42.000000', 'temperatura', 142.0000, 'ºC'),
	(99687, 108, '2015-03-15 01:22:43.000000', 'temperatura', 881.0000, 'ºC'),
	(99688, 108, '2015-03-15 01:22:44.000000', 'temperatura', 382.0000, 'ºC'),
	(99689, 108, '2015-03-15 01:22:45.000000', 'temperatura', 468.0000, 'ºC'),
	(99690, 109, '2015-03-15 00:00:00.000000', 'temperatura', 959.0000, 'ºC'),
	(99691, 109, '2015-03-15 00:00:01.000000', 'temperatura', 19.0000, 'ºC'),
	(99692, 109, '2015-03-15 00:00:02.000000', 'temperatura', 817.0000, 'ºC'),
	(99693, 109, '2015-03-15 00:00:03.000000', 'temperatura', 431.0000, 'ºC'),
	(99694, 109, '2015-03-15 00:00:04.000000', 'temperatura', 904.0000, 'ºC'),
	(99695, 109, '2015-03-15 00:00:05.000000', 'temperatura', 825.0000, 'ºC'),
	(99696, 109, '2015-03-15 00:00:06.000000', 'temperatura', 215.0000, 'ºC'),
	(99697, 109, '2015-03-15 00:00:07.000000', 'temperatura', 1002.0000, 'ºC'),
	(99698, 109, '2015-03-15 00:00:08.000000', 'temperatura', 762.0000, 'ºC'),
	(99699, 109, '2015-03-15 00:00:09.000000', 'temperatura', 808.0000, 'ºC'),
	(99700, 109, '2015-03-15 00:00:10.000000', 'temperatura', 553.0000, 'ºC'),
	(99701, 109, '2015-03-15 00:00:11.000000', 'temperatura', 344.0000, 'ºC'),
	(99702, 109, '2015-03-15 00:00:12.000000', 'temperatura', 59.0000, 'ºC'),
	(99703, 109, '2015-03-15 00:00:13.000000', 'temperatura', 463.0000, 'ºC'),
	(99704, 109, '2015-03-15 00:00:14.000000', 'temperatura', 940.0000, 'ºC'),
	(99705, 109, '2015-03-15 00:00:15.000000', 'temperatura', 909.0000, 'ºC'),
	(99706, 109, '2015-03-15 00:00:16.000000', 'temperatura', 529.0000, 'ºC'),
	(99707, 109, '2015-03-15 00:00:17.000000', 'temperatura', 1115.0000, 'ºC'),
	(99708, 109, '2015-03-15 00:00:18.000000', 'temperatura', 392.0000, 'ºC'),
	(99709, 109, '2015-03-15 00:00:19.000000', 'temperatura', 1013.0000, 'ºC'),
	(99710, 109, '2015-03-15 00:00:20.000000', 'temperatura', 291.0000, 'ºC'),
	(99711, 109, '2015-03-15 00:00:21.000000', 'temperatura', 817.0000, 'ºC'),
	(99712, 109, '2015-03-15 00:00:22.000000', 'temperatura', 813.0000, 'ºC'),
	(99713, 109, '2015-03-15 00:00:23.000000', 'temperatura', 413.0000, 'ºC'),
	(99714, 109, '2015-03-15 00:00:24.000000', 'temperatura', 826.0000, 'ºC'),
	(99715, 109, '2015-03-15 00:00:25.000000', 'temperatura', 491.0000, 'ºC'),
	(99716, 109, '2015-03-15 00:00:26.000000', 'temperatura', 1177.0000, 'ºC'),
	(99717, 109, '2015-03-15 00:00:27.000000', 'temperatura', 815.0000, 'ºC'),
	(99718, 109, '2015-03-15 00:00:28.000000', 'temperatura', 544.0000, 'ºC'),
	(99719, 109, '2015-03-15 00:00:29.000000', 'temperatura', 277.0000, 'ºC'),
	(99720, 109, '2015-03-15 00:00:30.000000', 'temperatura', 950.0000, 'ºC'),
	(99721, 109, '2015-03-15 00:00:31.000000', 'temperatura', 323.0000, 'ºC'),
	(99722, 109, '2015-03-15 00:00:32.000000', 'temperatura', 1164.0000, 'ºC'),
	(99723, 109, '2015-03-15 00:00:33.000000', 'temperatura', 51.0000, 'ºC'),
	(99724, 109, '2015-03-15 00:00:34.000000', 'temperatura', 362.0000, 'ºC'),
	(99725, 109, '2015-03-15 00:00:35.000000', 'temperatura', 459.0000, 'ºC'),
	(99726, 109, '2015-03-15 00:00:36.000000', 'temperatura', 8.0000, 'ºC'),
	(99727, 109, '2015-03-15 00:00:37.000000', 'temperatura', 1065.0000, 'ºC'),
	(99728, 109, '2015-03-15 00:00:38.000000', 'temperatura', 501.0000, 'ºC'),
	(99729, 109, '2015-03-15 00:00:39.000000', 'temperatura', 509.0000, 'ºC'),
	(99730, 109, '2015-03-15 00:00:40.000000', 'temperatura', 1044.0000, 'ºC'),
	(99731, 109, '2015-03-15 00:00:41.000000', 'temperatura', 93.0000, 'ºC'),
	(99732, 109, '2015-03-15 00:00:42.000000', 'temperatura', 935.0000, 'ºC'),
	(99733, 109, '2015-03-15 00:00:43.000000', 'temperatura', 797.0000, 'ºC'),
	(99734, 109, '2015-03-15 00:00:44.000000', 'temperatura', 1179.0000, 'ºC'),
	(99735, 109, '2015-03-15 00:00:45.000000', 'temperatura', 1106.0000, 'ºC'),
	(99736, 109, '2015-03-15 00:00:46.000000', 'temperatura', 792.0000, 'ºC'),
	(99737, 109, '2015-03-15 00:00:47.000000', 'temperatura', 644.0000, 'ºC'),
	(99738, 109, '2015-03-15 00:00:48.000000', 'temperatura', 843.0000, 'ºC'),
	(99739, 109, '2015-03-15 00:00:49.000000', 'temperatura', 1086.0000, 'ºC'),
	(99740, 109, '2015-03-15 00:00:50.000000', 'temperatura', 499.0000, 'ºC'),
	(99741, 109, '2015-03-15 00:00:51.000000', 'temperatura', 439.0000, 'ºC'),
	(99742, 109, '2015-03-15 00:00:52.000000', 'temperatura', 697.0000, 'ºC'),
	(99743, 109, '2015-03-15 00:00:53.000000', 'temperatura', 968.0000, 'ºC'),
	(99744, 109, '2015-03-15 00:00:54.000000', 'temperatura', 351.0000, 'ºC'),
	(99745, 109, '2015-03-15 00:00:55.000000', 'temperatura', 52.0000, 'ºC'),
	(99746, 109, '2015-03-15 00:00:56.000000', 'temperatura', 405.0000, 'ºC'),
	(99747, 109, '2015-03-15 00:00:57.000000', 'temperatura', 670.0000, 'ºC'),
	(99748, 109, '2015-03-15 00:00:58.000000', 'temperatura', 938.0000, 'ºC'),
	(99749, 109, '2015-03-15 00:00:59.000000', 'temperatura', 277.0000, 'ºC'),
	(99750, 109, '2015-03-15 00:01:00.000000', 'temperatura', 975.0000, 'ºC'),
	(99751, 109, '2015-03-15 00:01:01.000000', 'temperatura', 443.0000, 'ºC'),
	(99752, 109, '2015-03-15 00:01:02.000000', 'temperatura', 490.0000, 'ºC'),
	(99753, 109, '2015-03-15 00:01:03.000000', 'temperatura', 1124.0000, 'ºC'),
	(99754, 109, '2015-03-15 00:01:04.000000', 'temperatura', 548.0000, 'ºC'),
	(99755, 109, '2015-03-15 00:01:05.000000', 'temperatura', 570.0000, 'ºC'),
	(99756, 109, '2015-03-15 00:01:06.000000', 'temperatura', 6.0000, 'ºC'),
	(99757, 109, '2015-03-15 00:01:07.000000', 'temperatura', 719.0000, 'ºC'),
	(99758, 109, '2015-03-15 00:01:08.000000', 'temperatura', 1177.0000, 'ºC'),
	(99759, 109, '2015-03-15 00:01:09.000000', 'temperatura', 130.0000, 'ºC'),
	(99760, 109, '2015-03-15 00:01:10.000000', 'temperatura', 721.0000, 'ºC'),
	(99761, 109, '2015-03-15 00:01:11.000000', 'temperatura', 816.0000, 'ºC'),
	(99762, 109, '2015-03-15 00:01:12.000000', 'temperatura', 715.0000, 'ºC'),
	(99763, 109, '2015-03-15 00:01:13.000000', 'temperatura', 1127.0000, 'ºC'),
	(99764, 109, '2015-03-15 00:01:14.000000', 'temperatura', 1094.0000, 'ºC'),
	(99765, 109, '2015-03-15 00:01:15.000000', 'temperatura', 886.0000, 'ºC'),
	(99766, 109, '2015-03-15 00:01:16.000000', 'temperatura', 1149.0000, 'ºC'),
	(99767, 109, '2015-03-15 00:01:17.000000', 'temperatura', 690.0000, 'ºC'),
	(99768, 109, '2015-03-15 00:01:18.000000', 'temperatura', 1.0000, 'ºC'),
	(99769, 109, '2015-03-15 00:01:19.000000', 'temperatura', 337.0000, 'ºC'),
	(99770, 109, '2015-03-15 00:01:20.000000', 'temperatura', 481.0000, 'ºC'),
	(99771, 109, '2015-03-15 00:01:21.000000', 'temperatura', 196.0000, 'ºC'),
	(99772, 109, '2015-03-15 00:01:22.000000', 'temperatura', 736.0000, 'ºC'),
	(99773, 109, '2015-03-15 00:01:23.000000', 'temperatura', 692.0000, 'ºC'),
	(99774, 109, '2015-03-15 00:01:24.000000', 'temperatura', 52.0000, 'ºC'),
	(99775, 109, '2015-03-15 00:01:25.000000', 'temperatura', 584.0000, 'ºC'),
	(99776, 109, '2015-03-15 00:01:26.000000', 'temperatura', 367.0000, 'ºC'),
	(99777, 109, '2015-03-15 00:01:27.000000', 'temperatura', 83.0000, 'ºC'),
	(99778, 109, '2015-03-15 00:01:28.000000', 'temperatura', 513.0000, 'ºC'),
	(99779, 109, '2015-03-15 00:01:29.000000', 'temperatura', 1115.0000, 'ºC'),
	(99780, 109, '2015-03-15 00:01:30.000000', 'temperatura', 439.0000, 'ºC'),
	(99781, 109, '2015-03-15 00:01:31.000000', 'temperatura', 51.0000, 'ºC'),
	(99782, 109, '2015-03-15 00:01:32.000000', 'temperatura', 137.0000, 'ºC'),
	(99783, 109, '2015-03-15 00:01:33.000000', 'temperatura', 535.0000, 'ºC'),
	(99784, 109, '2015-03-15 00:01:34.000000', 'temperatura', 1062.0000, 'ºC'),
	(99785, 109, '2015-03-15 00:01:35.000000', 'temperatura', 107.0000, 'ºC'),
	(99786, 109, '2015-03-15 00:01:36.000000', 'temperatura', 948.0000, 'ºC'),
	(99787, 109, '2015-03-15 00:01:37.000000', 'temperatura', 818.0000, 'ºC'),
	(99788, 109, '2015-03-15 00:01:38.000000', 'temperatura', 48.0000, 'ºC'),
	(99789, 109, '2015-03-15 00:01:39.000000', 'temperatura', 188.0000, 'ºC'),
	(99790, 109, '2015-03-15 00:01:40.000000', 'temperatura', 797.0000, 'ºC'),
	(99791, 109, '2015-03-15 00:01:41.000000', 'temperatura', 1019.0000, 'ºC'),
	(99792, 109, '2015-03-15 00:01:42.000000', 'temperatura', 304.0000, 'ºC'),
	(99793, 109, '2015-03-15 00:01:43.000000', 'temperatura', 862.0000, 'ºC'),
	(99794, 109, '2015-03-15 00:01:44.000000', 'temperatura', 1002.0000, 'ºC'),
	(99795, 109, '2015-03-15 00:01:45.000000', 'temperatura', 23.0000, 'ºC'),
	(99796, 109, '2015-03-15 00:01:46.000000', 'temperatura', 711.0000, 'ºC'),
	(99797, 109, '2015-03-15 00:01:47.000000', 'temperatura', 1085.0000, 'ºC'),
	(99798, 109, '2015-03-15 00:01:48.000000', 'temperatura', 894.0000, 'ºC'),
	(99799, 109, '2015-03-15 00:01:49.000000', 'temperatura', 14.0000, 'ºC'),
	(99800, 109, '2015-03-15 00:01:50.000000', 'temperatura', 989.0000, 'ºC'),
	(99801, 109, '2015-03-15 00:01:51.000000', 'temperatura', 105.0000, 'ºC'),
	(99802, 109, '2015-03-15 00:01:52.000000', 'temperatura', 1159.0000, 'ºC'),
	(99803, 109, '2015-03-15 00:01:53.000000', 'temperatura', 678.0000, 'ºC'),
	(99804, 109, '2015-03-15 00:01:54.000000', 'temperatura', 1117.0000, 'ºC'),
	(99805, 109, '2015-03-15 00:01:55.000000', 'temperatura', 1148.0000, 'ºC'),
	(99806, 109, '2015-03-15 00:01:56.000000', 'temperatura', 1190.0000, 'ºC'),
	(99807, 109, '2015-03-15 00:01:57.000000', 'temperatura', 105.0000, 'ºC'),
	(99808, 109, '2015-03-15 00:01:58.000000', 'temperatura', 557.0000, 'ºC'),
	(99809, 109, '2015-03-15 00:01:59.000000', 'temperatura', 72.0000, 'ºC'),
	(99810, 109, '2015-03-15 00:02:00.000000', 'temperatura', 1089.0000, 'ºC'),
	(99811, 109, '2015-03-15 00:02:01.000000', 'temperatura', 429.0000, 'ºC'),
	(99812, 109, '2015-03-15 00:02:02.000000', 'temperatura', 80.0000, 'ºC'),
	(99813, 109, '2015-03-15 00:02:03.000000', 'temperatura', 313.0000, 'ºC'),
	(99814, 109, '2015-03-15 00:02:04.000000', 'temperatura', 127.0000, 'ºC'),
	(99815, 109, '2015-03-15 00:02:05.000000', 'temperatura', 894.0000, 'ºC'),
	(99816, 109, '2015-03-15 00:02:06.000000', 'temperatura', 492.0000, 'ºC'),
	(99817, 109, '2015-03-15 00:02:07.000000', 'temperatura', 975.0000, 'ºC'),
	(99818, 109, '2015-03-15 00:02:08.000000', 'temperatura', 1003.0000, 'ºC'),
	(99819, 109, '2015-03-15 00:02:09.000000', 'temperatura', 889.0000, 'ºC'),
	(99820, 109, '2015-03-15 00:02:10.000000', 'temperatura', 237.0000, 'ºC'),
	(99821, 109, '2015-03-15 00:02:11.000000', 'temperatura', 918.0000, 'ºC'),
	(99822, 109, '2015-03-15 00:02:12.000000', 'temperatura', 281.0000, 'ºC'),
	(99823, 109, '2015-03-15 00:02:13.000000', 'temperatura', 1052.0000, 'ºC'),
	(99824, 109, '2015-03-15 00:02:14.000000', 'temperatura', 818.0000, 'ºC'),
	(99825, 109, '2015-03-15 00:02:15.000000', 'temperatura', 933.0000, 'ºC'),
	(99826, 109, '2015-03-15 00:02:16.000000', 'temperatura', 1010.0000, 'ºC'),
	(99827, 109, '2015-03-15 00:02:17.000000', 'temperatura', 1051.0000, 'ºC'),
	(99828, 109, '2015-03-15 00:02:18.000000', 'temperatura', 1029.0000, 'ºC'),
	(99829, 109, '2015-03-15 00:02:19.000000', 'temperatura', 789.0000, 'ºC'),
	(99830, 109, '2015-03-15 00:02:20.000000', 'temperatura', 860.0000, 'ºC'),
	(99831, 109, '2015-03-15 00:02:21.000000', 'temperatura', 732.0000, 'ºC'),
	(99832, 109, '2015-03-15 00:02:22.000000', 'temperatura', 1083.0000, 'ºC'),
	(99833, 109, '2015-03-15 00:02:23.000000', 'temperatura', 816.0000, 'ºC'),
	(99834, 109, '2015-03-15 00:02:24.000000', 'temperatura', 835.0000, 'ºC'),
	(99835, 109, '2015-03-15 00:02:25.000000', 'temperatura', 527.0000, 'ºC'),
	(99836, 109, '2015-03-15 00:02:26.000000', 'temperatura', 129.0000, 'ºC'),
	(99837, 109, '2015-03-15 00:02:27.000000', 'temperatura', 267.0000, 'ºC'),
	(99838, 109, '2015-03-15 00:02:28.000000', 'temperatura', 946.0000, 'ºC'),
	(99839, 109, '2015-03-15 00:02:29.000000', 'temperatura', 331.0000, 'ºC'),
	(99840, 109, '2015-03-15 00:02:30.000000', 'temperatura', 16.0000, 'ºC'),
	(99841, 109, '2015-03-15 00:02:31.000000', 'temperatura', 289.0000, 'ºC'),
	(99842, 109, '2015-03-15 00:02:32.000000', 'temperatura', 198.0000, 'ºC'),
	(99843, 109, '2015-03-15 00:02:33.000000', 'temperatura', 122.0000, 'ºC'),
	(99844, 109, '2015-03-15 00:02:34.000000', 'temperatura', 16.0000, 'ºC'),
	(99845, 109, '2015-03-15 00:02:35.000000', 'temperatura', 914.0000, 'ºC'),
	(99846, 109, '2015-03-15 00:02:36.000000', 'temperatura', 924.0000, 'ºC'),
	(99847, 109, '2015-03-15 00:02:37.000000', 'temperatura', 677.0000, 'ºC'),
	(99848, 109, '2015-03-15 00:02:38.000000', 'temperatura', 612.0000, 'ºC'),
	(99849, 109, '2015-03-15 00:02:39.000000', 'temperatura', 1032.0000, 'ºC'),
	(99850, 109, '2015-03-15 00:02:40.000000', 'temperatura', 924.0000, 'ºC'),
	(99851, 109, '2015-03-15 00:02:41.000000', 'temperatura', 325.0000, 'ºC'),
	(99852, 109, '2015-03-15 00:02:42.000000', 'temperatura', 52.0000, 'ºC'),
	(99853, 109, '2015-03-15 00:02:43.000000', 'temperatura', 484.0000, 'ºC'),
	(99854, 109, '2015-03-15 00:02:44.000000', 'temperatura', 1068.0000, 'ºC'),
	(99855, 109, '2015-03-15 00:02:45.000000', 'temperatura', 285.0000, 'ºC'),
	(99856, 109, '2015-03-15 00:02:46.000000', 'temperatura', 623.0000, 'ºC'),
	(99857, 109, '2015-03-15 00:02:47.000000', 'temperatura', 1062.0000, 'ºC'),
	(99858, 109, '2015-03-15 00:02:48.000000', 'temperatura', 1041.0000, 'ºC'),
	(99859, 109, '2015-03-15 00:02:49.000000', 'temperatura', 817.0000, 'ºC'),
	(99860, 109, '2015-03-15 00:02:50.000000', 'temperatura', 965.0000, 'ºC'),
	(99861, 109, '2015-03-15 00:02:51.000000', 'temperatura', 1174.0000, 'ºC'),
	(99862, 109, '2015-03-15 00:02:52.000000', 'temperatura', 578.0000, 'ºC'),
	(99863, 109, '2015-03-15 00:02:53.000000', 'temperatura', 565.0000, 'ºC'),
	(99864, 109, '2015-03-15 00:02:54.000000', 'temperatura', 1091.0000, 'ºC'),
	(99865, 109, '2015-03-15 00:02:55.000000', 'temperatura', 160.0000, 'ºC'),
	(99866, 109, '2015-03-15 00:02:56.000000', 'temperatura', 1128.0000, 'ºC'),
	(99867, 109, '2015-03-15 00:02:57.000000', 'temperatura', 359.0000, 'ºC'),
	(99868, 109, '2015-03-15 00:02:58.000000', 'temperatura', 813.0000, 'ºC'),
	(99869, 109, '2015-03-15 00:02:59.000000', 'temperatura', 590.0000, 'ºC'),
	(99870, 109, '2015-03-15 00:03:00.000000', 'temperatura', 509.0000, 'ºC'),
	(99871, 109, '2015-03-15 00:03:01.000000', 'temperatura', 776.0000, 'ºC'),
	(99872, 109, '2015-03-15 00:03:02.000000', 'temperatura', 1152.0000, 'ºC'),
	(99873, 109, '2015-03-15 00:03:03.000000', 'temperatura', 1035.0000, 'ºC'),
	(99874, 109, '2015-03-15 00:03:04.000000', 'temperatura', 518.0000, 'ºC'),
	(99875, 109, '2015-03-15 00:03:05.000000', 'temperatura', 686.0000, 'ºC'),
	(99876, 109, '2015-03-15 00:03:06.000000', 'temperatura', 675.0000, 'ºC'),
	(99877, 109, '2015-03-15 00:03:07.000000', 'temperatura', 121.0000, 'ºC'),
	(99878, 109, '2015-03-15 00:03:08.000000', 'temperatura', 977.0000, 'ºC'),
	(99879, 109, '2015-03-15 00:03:09.000000', 'temperatura', 924.0000, 'ºC'),
	(99880, 109, '2015-03-15 00:03:10.000000', 'temperatura', 490.0000, 'ºC'),
	(99881, 109, '2015-03-15 00:03:11.000000', 'temperatura', 877.0000, 'ºC'),
	(99882, 109, '2015-03-15 00:03:12.000000', 'temperatura', 517.0000, 'ºC'),
	(99883, 109, '2015-03-15 00:03:13.000000', 'temperatura', 1152.0000, 'ºC'),
	(99884, 109, '2015-03-15 00:03:14.000000', 'temperatura', 613.0000, 'ºC'),
	(99885, 109, '2015-03-15 00:03:15.000000', 'temperatura', 807.0000, 'ºC'),
	(99886, 109, '2015-03-15 00:03:16.000000', 'temperatura', 996.0000, 'ºC'),
	(99887, 109, '2015-03-15 00:03:17.000000', 'temperatura', 160.0000, 'ºC'),
	(99888, 109, '2015-03-15 00:03:18.000000', 'temperatura', 212.0000, 'ºC'),
	(99889, 109, '2015-03-15 00:03:19.000000', 'temperatura', 583.0000, 'ºC'),
	(99890, 109, '2015-03-15 00:03:20.000000', 'temperatura', 1077.0000, 'ºC'),
	(99891, 109, '2015-03-15 00:03:21.000000', 'temperatura', 38.0000, 'ºC'),
	(99892, 109, '2015-03-15 00:03:22.000000', 'temperatura', 560.0000, 'ºC'),
	(99893, 109, '2015-03-15 00:03:23.000000', 'temperatura', 286.0000, 'ºC'),
	(99894, 109, '2015-03-15 00:03:24.000000', 'temperatura', 950.0000, 'ºC'),
	(99895, 109, '2015-03-15 00:03:25.000000', 'temperatura', 293.0000, 'ºC'),
	(99896, 109, '2015-03-15 00:03:26.000000', 'temperatura', 1016.0000, 'ºC'),
	(99897, 109, '2015-03-15 00:03:27.000000', 'temperatura', 600.0000, 'ºC'),
	(99898, 109, '2015-03-15 00:03:28.000000', 'temperatura', 1154.0000, 'ºC'),
	(99899, 109, '2015-03-15 00:03:29.000000', 'temperatura', 370.0000, 'ºC'),
	(99900, 109, '2015-03-15 00:03:30.000000', 'temperatura', 787.0000, 'ºC'),
	(99901, 109, '2015-03-15 00:03:31.000000', 'temperatura', 429.0000, 'ºC'),
	(99902, 109, '2015-03-15 00:03:32.000000', 'temperatura', 981.0000, 'ºC'),
	(99903, 109, '2015-03-15 00:03:33.000000', 'temperatura', 21.0000, 'ºC'),
	(99904, 109, '2015-03-15 00:03:34.000000', 'temperatura', 762.0000, 'ºC'),
	(99905, 109, '2015-03-15 00:03:35.000000', 'temperatura', 145.0000, 'ºC'),
	(99906, 109, '2015-03-15 00:03:36.000000', 'temperatura', 842.0000, 'ºC'),
	(99907, 109, '2015-03-15 00:03:37.000000', 'temperatura', 174.0000, 'ºC'),
	(99908, 109, '2015-03-15 00:03:38.000000', 'temperatura', 745.0000, 'ºC'),
	(99909, 109, '2015-03-15 00:03:39.000000', 'temperatura', 805.0000, 'ºC'),
	(99910, 109, '2015-03-15 00:03:40.000000', 'temperatura', 588.0000, 'ºC'),
	(99911, 109, '2015-03-15 00:03:41.000000', 'temperatura', 526.0000, 'ºC'),
	(99912, 109, '2015-03-15 00:03:42.000000', 'temperatura', 866.0000, 'ºC'),
	(99913, 109, '2015-03-15 00:03:43.000000', 'temperatura', 355.0000, 'ºC'),
	(99914, 109, '2015-03-15 00:03:44.000000', 'temperatura', 376.0000, 'ºC'),
	(99915, 109, '2015-03-15 00:03:45.000000', 'temperatura', 814.0000, 'ºC'),
	(99916, 109, '2015-03-15 00:03:46.000000', 'temperatura', 542.0000, 'ºC'),
	(99917, 109, '2015-03-15 00:03:47.000000', 'temperatura', 268.0000, 'ºC'),
	(99918, 109, '2015-03-15 00:03:48.000000', 'temperatura', 916.0000, 'ºC'),
	(99919, 109, '2015-03-15 00:03:49.000000', 'temperatura', 176.0000, 'ºC'),
	(99920, 109, '2015-03-15 00:03:50.000000', 'temperatura', 531.0000, 'ºC'),
	(99921, 109, '2015-03-15 00:03:51.000000', 'temperatura', 929.0000, 'ºC'),
	(99922, 109, '2015-03-15 00:03:52.000000', 'temperatura', 654.0000, 'ºC'),
	(99923, 109, '2015-03-15 00:03:53.000000', 'temperatura', 480.0000, 'ºC'),
	(99924, 109, '2015-03-15 00:03:54.000000', 'temperatura', 442.0000, 'ºC'),
	(99925, 109, '2015-03-15 00:03:55.000000', 'temperatura', 769.0000, 'ºC'),
	(99926, 109, '2015-03-15 00:03:56.000000', 'temperatura', 121.0000, 'ºC'),
	(99927, 109, '2015-03-15 00:03:57.000000', 'temperatura', 695.0000, 'ºC'),
	(99928, 109, '2015-03-15 00:03:58.000000', 'temperatura', 716.0000, 'ºC'),
	(99929, 109, '2015-03-15 00:03:59.000000', 'temperatura', 296.0000, 'ºC'),
	(99930, 109, '2015-03-15 00:04:00.000000', 'temperatura', 530.0000, 'ºC'),
	(99931, 109, '2015-03-15 00:04:01.000000', 'temperatura', 563.0000, 'ºC'),
	(99932, 109, '2015-03-15 00:04:02.000000', 'temperatura', 24.0000, 'ºC'),
	(99933, 109, '2015-03-15 00:04:03.000000', 'temperatura', 834.0000, 'ºC'),
	(99934, 109, '2015-03-15 00:04:04.000000', 'temperatura', 499.0000, 'ºC'),
	(99935, 109, '2015-03-15 00:04:05.000000', 'temperatura', 1191.0000, 'ºC'),
	(99936, 109, '2015-03-15 00:04:06.000000', 'temperatura', 861.0000, 'ºC'),
	(99937, 109, '2015-03-15 00:04:07.000000', 'temperatura', 732.0000, 'ºC'),
	(99938, 109, '2015-03-15 00:04:08.000000', 'temperatura', 1078.0000, 'ºC'),
	(99939, 109, '2015-03-15 00:04:09.000000', 'temperatura', 795.0000, 'ºC'),
	(99940, 109, '2015-03-15 00:04:10.000000', 'temperatura', 741.0000, 'ºC'),
	(99941, 109, '2015-03-15 00:04:11.000000', 'temperatura', 121.0000, 'ºC'),
	(99942, 109, '2015-03-15 00:04:12.000000', 'temperatura', 782.0000, 'ºC'),
	(99943, 109, '2015-03-15 00:04:13.000000', 'temperatura', 1149.0000, 'ºC'),
	(99944, 109, '2015-03-15 00:04:14.000000', 'temperatura', 1000.0000, 'ºC'),
	(99945, 109, '2015-03-15 00:04:15.000000', 'temperatura', 352.0000, 'ºC'),
	(99946, 109, '2015-03-15 00:04:16.000000', 'temperatura', 1159.0000, 'ºC'),
	(99947, 109, '2015-03-15 00:04:17.000000', 'temperatura', 1143.0000, 'ºC'),
	(99948, 109, '2015-03-15 00:04:18.000000', 'temperatura', 1035.0000, 'ºC'),
	(99949, 109, '2015-03-15 00:04:19.000000', 'temperatura', 548.0000, 'ºC'),
	(99950, 109, '2015-03-15 00:04:20.000000', 'temperatura', 836.0000, 'ºC'),
	(99951, 109, '2015-03-15 00:04:21.000000', 'temperatura', 136.0000, 'ºC'),
	(99952, 109, '2015-03-15 00:04:22.000000', 'temperatura', 573.0000, 'ºC'),
	(99953, 109, '2015-03-15 00:04:23.000000', 'temperatura', 56.0000, 'ºC'),
	(99954, 109, '2015-03-15 00:04:24.000000', 'temperatura', 961.0000, 'ºC'),
	(99955, 109, '2015-03-15 00:04:25.000000', 'temperatura', 1039.0000, 'ºC'),
	(99956, 109, '2015-03-15 00:04:26.000000', 'temperatura', 1111.0000, 'ºC'),
	(99957, 109, '2015-03-15 00:04:27.000000', 'temperatura', 38.0000, 'ºC'),
	(99958, 109, '2015-03-15 00:04:28.000000', 'temperatura', 459.0000, 'ºC'),
	(99959, 109, '2015-03-15 00:04:29.000000', 'temperatura', 980.0000, 'ºC'),
	(99960, 109, '2015-03-15 00:04:30.000000', 'temperatura', 1124.0000, 'ºC'),
	(99961, 109, '2015-03-15 00:04:31.000000', 'temperatura', 282.0000, 'ºC'),
	(99962, 109, '2015-03-15 00:04:32.000000', 'temperatura', 437.0000, 'ºC'),
	(99963, 109, '2015-03-15 00:04:33.000000', 'temperatura', 139.0000, 'ºC'),
	(99964, 109, '2015-03-15 00:04:34.000000', 'temperatura', 585.0000, 'ºC'),
	(99965, 109, '2015-03-15 00:04:35.000000', 'temperatura', 107.0000, 'ºC'),
	(99966, 109, '2015-03-15 00:04:36.000000', 'temperatura', 1184.0000, 'ºC'),
	(99967, 109, '2015-03-15 00:04:37.000000', 'temperatura', 797.0000, 'ºC'),
	(99968, 109, '2015-03-15 00:04:38.000000', 'temperatura', 433.0000, 'ºC'),
	(99969, 109, '2015-03-15 00:04:39.000000', 'temperatura', 973.0000, 'ºC'),
	(99970, 109, '2015-03-15 00:04:40.000000', 'temperatura', 1170.0000, 'ºC'),
	(99971, 109, '2015-03-15 00:04:41.000000', 'temperatura', 528.0000, 'ºC'),
	(99972, 109, '2015-03-15 00:04:42.000000', 'temperatura', 333.0000, 'ºC'),
	(99973, 109, '2015-03-15 00:04:43.000000', 'temperatura', 83.0000, 'ºC'),
	(99974, 109, '2015-03-15 00:04:44.000000', 'temperatura', 614.0000, 'ºC'),
	(99975, 109, '2015-03-15 00:04:45.000000', 'temperatura', 420.0000, 'ºC'),
	(99976, 109, '2015-03-15 00:04:46.000000', 'temperatura', 261.0000, 'ºC'),
	(99977, 109, '2015-03-15 00:04:47.000000', 'temperatura', 45.0000, 'ºC'),
	(99978, 109, '2015-03-15 00:04:48.000000', 'temperatura', 643.0000, 'ºC'),
	(99979, 109, '2015-03-15 00:04:49.000000', 'temperatura', 679.0000, 'ºC'),
	(99980, 109, '2015-03-15 00:04:50.000000', 'temperatura', 269.0000, 'ºC'),
	(99981, 109, '2015-03-15 00:04:51.000000', 'temperatura', 509.0000, 'ºC'),
	(99982, 109, '2015-03-15 00:04:52.000000', 'temperatura', 536.0000, 'ºC'),
	(99983, 109, '2015-03-15 00:04:53.000000', 'temperatura', 1152.0000, 'ºC'),
	(99984, 109, '2015-03-15 00:04:54.000000', 'temperatura', 555.0000, 'ºC'),
	(99985, 109, '2015-03-15 00:04:55.000000', 'temperatura', 521.0000, 'ºC'),
	(99986, 109, '2015-03-15 00:04:56.000000', 'temperatura', 938.0000, 'ºC'),
	(99987, 109, '2015-03-15 00:04:57.000000', 'temperatura', 727.0000, 'ºC'),
	(99988, 109, '2015-03-15 00:04:58.000000', 'temperatura', 821.0000, 'ºC'),
	(99989, 109, '2015-03-15 00:04:59.000000', 'temperatura', 723.0000, 'ºC'),
	(99990, 109, '2015-03-15 00:05:00.000000', 'temperatura', 1156.0000, 'ºC'),
	(99991, 109, '2015-03-15 00:05:01.000000', 'temperatura', 8.0000, 'ºC'),
	(99992, 109, '2015-03-15 00:05:02.000000', 'temperatura', 175.0000, 'ºC'),
	(99993, 109, '2015-03-15 00:05:03.000000', 'temperatura', 850.0000, 'ºC'),
	(99994, 109, '2015-03-15 00:05:04.000000', 'temperatura', 126.0000, 'ºC'),
	(99995, 109, '2015-03-15 00:05:05.000000', 'temperatura', 479.0000, 'ºC'),
	(99996, 109, '2015-03-15 00:05:06.000000', 'temperatura', 819.0000, 'ºC'),
	(99997, 109, '2015-03-15 00:05:07.000000', 'temperatura', 257.0000, 'ºC'),
	(99998, 109, '2015-03-15 00:05:08.000000', 'temperatura', 28.0000, 'ºC'),
	(99999, 109, '2015-03-15 00:05:09.000000', 'temperatura', 570.0000, 'ºC'),
	(100000, 109, '2015-03-15 00:05:10.000000', 'temperatura', 366.0000, 'ºC'),
	(100001, 109, '2015-03-15 00:05:11.000000', 'temperatura', 119.0000, 'ºC'),
	(100002, 109, '2015-03-15 00:05:12.000000', 'temperatura', 701.0000, 'ºC'),
	(100003, 109, '2015-03-15 00:05:13.000000', 'temperatura', 745.0000, 'ºC'),
	(100004, 109, '2015-03-15 00:05:14.000000', 'temperatura', 426.0000, 'ºC'),
	(100005, 109, '2015-03-15 00:05:15.000000', 'temperatura', 1094.0000, 'ºC'),
	(100006, 109, '2015-03-15 00:05:16.000000', 'temperatura', 594.0000, 'ºC'),
	(100007, 109, '2015-03-15 00:05:17.000000', 'temperatura', 888.0000, 'ºC'),
	(100008, 109, '2015-03-15 00:05:18.000000', 'temperatura', 259.0000, 'ºC'),
	(100009, 109, '2015-03-15 00:05:19.000000', 'temperatura', 1033.0000, 'ºC'),
	(100010, 109, '2015-03-15 00:05:20.000000', 'temperatura', 787.0000, 'ºC'),
	(100011, 109, '2015-03-15 00:05:21.000000', 'temperatura', 835.0000, 'ºC'),
	(100012, 109, '2015-03-15 00:05:22.000000', 'temperatura', 615.0000, 'ºC'),
	(100013, 109, '2015-03-15 00:05:23.000000', 'temperatura', 571.0000, 'ºC'),
	(100014, 109, '2015-03-15 00:05:24.000000', 'temperatura', 1010.0000, 'ºC'),
	(100015, 109, '2015-03-15 00:05:25.000000', 'temperatura', 936.0000, 'ºC'),
	(100016, 109, '2015-03-15 00:05:26.000000', 'temperatura', 452.0000, 'ºC'),
	(100017, 109, '2015-03-15 00:05:27.000000', 'temperatura', 651.0000, 'ºC'),
	(100018, 109, '2015-03-15 00:05:28.000000', 'temperatura', 698.0000, 'ºC'),
	(100019, 109, '2015-03-15 00:05:29.000000', 'temperatura', 341.0000, 'ºC'),
	(100020, 109, '2015-03-15 00:05:30.000000', 'temperatura', 809.0000, 'ºC'),
	(100021, 109, '2015-03-15 00:05:31.000000', 'temperatura', 623.0000, 'ºC'),
	(100022, 109, '2015-03-15 00:05:32.000000', 'temperatura', 688.0000, 'ºC'),
	(100023, 109, '2015-03-15 00:05:33.000000', 'temperatura', 371.0000, 'ºC'),
	(100024, 109, '2015-03-15 00:05:34.000000', 'temperatura', 994.0000, 'ºC'),
	(100025, 109, '2015-03-15 00:05:35.000000', 'temperatura', 254.0000, 'ºC'),
	(100026, 109, '2015-03-15 00:05:36.000000', 'temperatura', 691.0000, 'ºC'),
	(100027, 109, '2015-03-15 00:05:37.000000', 'temperatura', 294.0000, 'ºC'),
	(100028, 109, '2015-03-15 00:05:38.000000', 'temperatura', 598.0000, 'ºC'),
	(100029, 109, '2015-03-15 00:05:39.000000', 'temperatura', 907.0000, 'ºC'),
	(100030, 109, '2015-03-15 00:05:40.000000', 'temperatura', 341.0000, 'ºC'),
	(100031, 109, '2015-03-15 00:05:41.000000', 'temperatura', 187.0000, 'ºC'),
	(100032, 109, '2015-03-15 00:05:42.000000', 'temperatura', 1112.0000, 'ºC'),
	(100033, 109, '2015-03-15 00:05:43.000000', 'temperatura', 198.0000, 'ºC'),
	(100034, 109, '2015-03-15 00:05:44.000000', 'temperatura', 53.0000, 'ºC'),
	(100035, 109, '2015-03-15 00:05:45.000000', 'temperatura', 874.0000, 'ºC'),
	(100036, 109, '2015-03-15 00:05:46.000000', 'temperatura', 613.0000, 'ºC'),
	(100037, 109, '2015-03-15 00:05:47.000000', 'temperatura', 440.0000, 'ºC'),
	(100038, 109, '2015-03-15 00:05:48.000000', 'temperatura', 364.0000, 'ºC'),
	(100039, 109, '2015-03-15 00:05:49.000000', 'temperatura', 502.0000, 'ºC'),
	(100040, 109, '2015-03-15 00:05:50.000000', 'temperatura', 216.0000, 'ºC'),
	(100041, 109, '2015-03-15 00:05:51.000000', 'temperatura', 774.0000, 'ºC'),
	(100042, 109, '2015-03-15 00:05:52.000000', 'temperatura', 821.0000, 'ºC'),
	(100043, 109, '2015-03-15 00:05:53.000000', 'temperatura', 587.0000, 'ºC'),
	(100044, 109, '2015-03-15 00:05:54.000000', 'temperatura', 471.0000, 'ºC'),
	(100045, 109, '2015-03-15 00:05:55.000000', 'temperatura', 597.0000, 'ºC'),
	(100046, 109, '2015-03-15 00:05:56.000000', 'temperatura', 369.0000, 'ºC'),
	(100047, 109, '2015-03-15 00:05:57.000000', 'temperatura', 58.0000, 'ºC'),
	(100048, 109, '2015-03-15 00:05:58.000000', 'temperatura', 380.0000, 'ºC'),
	(100049, 109, '2015-03-15 00:05:59.000000', 'temperatura', 529.0000, 'ºC'),
	(100050, 109, '2015-03-15 00:06:00.000000', 'temperatura', 304.0000, 'ºC'),
	(100051, 109, '2015-03-15 00:06:01.000000', 'temperatura', 1135.0000, 'ºC'),
	(100052, 109, '2015-03-15 00:06:02.000000', 'temperatura', 1161.0000, 'ºC'),
	(100053, 109, '2015-03-15 00:06:03.000000', 'temperatura', 1.0000, 'ºC'),
	(100054, 109, '2015-03-15 00:06:04.000000', 'temperatura', 124.0000, 'ºC'),
	(100055, 109, '2015-03-15 00:06:05.000000', 'temperatura', 618.0000, 'ºC'),
	(100056, 109, '2015-03-15 00:06:06.000000', 'temperatura', 319.0000, 'ºC'),
	(100057, 109, '2015-03-15 00:06:07.000000', 'temperatura', 939.0000, 'ºC'),
	(100058, 109, '2015-03-15 00:06:08.000000', 'temperatura', 139.0000, 'ºC'),
	(100059, 109, '2015-03-15 00:06:09.000000', 'temperatura', 280.0000, 'ºC'),
	(100060, 109, '2015-03-15 00:06:10.000000', 'temperatura', 983.0000, 'ºC'),
	(100061, 109, '2015-03-15 00:06:11.000000', 'temperatura', 474.0000, 'ºC'),
	(100062, 109, '2015-03-15 00:06:12.000000', 'temperatura', 624.0000, 'ºC'),
	(100063, 109, '2015-03-15 00:06:13.000000', 'temperatura', 496.0000, 'ºC'),
	(100064, 109, '2015-03-15 00:06:14.000000', 'temperatura', 610.0000, 'ºC'),
	(100065, 109, '2015-03-15 00:06:15.000000', 'temperatura', 364.0000, 'ºC'),
	(100066, 109, '2015-03-15 00:06:16.000000', 'temperatura', 1188.0000, 'ºC'),
	(100067, 109, '2015-03-15 00:06:17.000000', 'temperatura', 49.0000, 'ºC'),
	(100068, 109, '2015-03-15 00:06:18.000000', 'temperatura', 283.0000, 'ºC'),
	(100069, 109, '2015-03-15 00:06:19.000000', 'temperatura', 66.0000, 'ºC'),
	(100070, 109, '2015-03-15 00:06:20.000000', 'temperatura', 684.0000, 'ºC'),
	(100071, 109, '2015-03-15 00:06:21.000000', 'temperatura', 821.0000, 'ºC'),
	(100072, 109, '2015-03-15 00:06:22.000000', 'temperatura', 852.0000, 'ºC'),
	(100073, 109, '2015-03-15 00:06:23.000000', 'temperatura', 601.0000, 'ºC'),
	(100074, 109, '2015-03-15 00:06:24.000000', 'temperatura', 446.0000, 'ºC'),
	(100075, 109, '2015-03-15 00:06:25.000000', 'temperatura', 431.0000, 'ºC'),
	(100076, 109, '2015-03-15 00:06:26.000000', 'temperatura', 814.0000, 'ºC'),
	(100077, 109, '2015-03-15 00:06:27.000000', 'temperatura', 379.0000, 'ºC'),
	(100078, 109, '2015-03-15 00:06:28.000000', 'temperatura', 655.0000, 'ºC'),
	(100079, 109, '2015-03-15 00:06:29.000000', 'temperatura', 939.0000, 'ºC'),
	(100080, 109, '2015-03-15 00:06:30.000000', 'temperatura', 330.0000, 'ºC'),
	(100081, 109, '2015-03-15 00:06:31.000000', 'temperatura', 32.0000, 'ºC'),
	(100082, 109, '2015-03-15 00:06:32.000000', 'temperatura', 372.0000, 'ºC'),
	(100083, 109, '2015-03-15 00:06:33.000000', 'temperatura', 564.0000, 'ºC'),
	(100084, 109, '2015-03-15 00:06:34.000000', 'temperatura', 504.0000, 'ºC'),
	(100085, 109, '2015-03-15 00:06:35.000000', 'temperatura', 829.0000, 'ºC'),
	(100086, 109, '2015-03-15 00:06:36.000000', 'temperatura', 234.0000, 'ºC'),
	(100087, 109, '2015-03-15 00:06:37.000000', 'temperatura', 1083.0000, 'ºC'),
	(100088, 109, '2015-03-15 00:06:38.000000', 'temperatura', 1114.0000, 'ºC'),
	(100089, 109, '2015-03-15 00:06:39.000000', 'temperatura', 1123.0000, 'ºC'),
	(100090, 109, '2015-03-15 00:06:40.000000', 'temperatura', 1070.0000, 'ºC'),
	(100091, 109, '2015-03-15 00:06:41.000000', 'temperatura', 785.0000, 'ºC'),
	(100092, 109, '2015-03-15 00:06:42.000000', 'temperatura', 715.0000, 'ºC'),
	(100093, 109, '2015-03-15 00:06:43.000000', 'temperatura', 19.0000, 'ºC'),
	(100094, 109, '2015-03-15 00:06:44.000000', 'temperatura', 350.0000, 'ºC'),
	(100095, 109, '2015-03-15 00:06:45.000000', 'temperatura', 496.0000, 'ºC'),
	(100096, 109, '2015-03-15 00:06:46.000000', 'temperatura', 228.0000, 'ºC'),
	(100097, 109, '2015-03-15 00:06:47.000000', 'temperatura', 855.0000, 'ºC'),
	(100098, 109, '2015-03-15 00:06:48.000000', 'temperatura', 1189.0000, 'ºC'),
	(100099, 109, '2015-03-15 00:06:49.000000', 'temperatura', 984.0000, 'ºC'),
	(100100, 109, '2015-03-15 00:06:50.000000', 'temperatura', 150.0000, 'ºC'),
	(100101, 109, '2015-03-15 00:06:51.000000', 'temperatura', 199.0000, 'ºC'),
	(100102, 109, '2015-03-15 00:06:52.000000', 'temperatura', 546.0000, 'ºC'),
	(100103, 109, '2015-03-15 00:06:53.000000', 'temperatura', 932.0000, 'ºC'),
	(100104, 109, '2015-03-15 00:06:54.000000', 'temperatura', 621.0000, 'ºC'),
	(100105, 109, '2015-03-15 00:06:55.000000', 'temperatura', 313.0000, 'ºC'),
	(100106, 109, '2015-03-15 00:06:56.000000', 'temperatura', 903.0000, 'ºC'),
	(100107, 109, '2015-03-15 00:06:57.000000', 'temperatura', 1176.0000, 'ºC'),
	(100108, 109, '2015-03-15 00:06:58.000000', 'temperatura', 770.0000, 'ºC'),
	(100109, 109, '2015-03-15 00:06:59.000000', 'temperatura', 324.0000, 'ºC'),
	(100110, 109, '2015-03-15 00:07:00.000000', 'temperatura', 511.0000, 'ºC'),
	(100111, 109, '2015-03-15 00:07:01.000000', 'temperatura', 384.0000, 'ºC'),
	(100112, 109, '2015-03-15 00:07:02.000000', 'temperatura', 389.0000, 'ºC'),
	(100113, 109, '2015-03-15 00:07:03.000000', 'temperatura', 790.0000, 'ºC'),
	(100114, 109, '2015-03-15 00:07:04.000000', 'temperatura', 385.0000, 'ºC'),
	(100115, 109, '2015-03-15 00:07:05.000000', 'temperatura', 755.0000, 'ºC'),
	(100116, 109, '2015-03-15 00:07:06.000000', 'temperatura', 220.0000, 'ºC'),
	(100117, 109, '2015-03-15 00:07:07.000000', 'temperatura', 34.0000, 'ºC'),
	(100118, 109, '2015-03-15 00:07:08.000000', 'temperatura', 713.0000, 'ºC'),
	(100119, 109, '2015-03-15 00:07:09.000000', 'temperatura', 1063.0000, 'ºC'),
	(100120, 109, '2015-03-15 00:07:10.000000', 'temperatura', 775.0000, 'ºC'),
	(100121, 109, '2015-03-15 00:07:11.000000', 'temperatura', 687.0000, 'ºC'),
	(100122, 109, '2015-03-15 00:07:12.000000', 'temperatura', 1111.0000, 'ºC'),
	(100123, 109, '2015-03-15 00:07:13.000000', 'temperatura', 1095.0000, 'ºC'),
	(100124, 109, '2015-03-15 00:07:14.000000', 'temperatura', 942.0000, 'ºC'),
	(100125, 109, '2015-03-15 00:07:15.000000', 'temperatura', 225.0000, 'ºC'),
	(100126, 109, '2015-03-15 00:07:16.000000', 'temperatura', 698.0000, 'ºC'),
	(100127, 109, '2015-03-15 00:07:17.000000', 'temperatura', 419.0000, 'ºC'),
	(100128, 109, '2015-03-15 00:07:18.000000', 'temperatura', 1199.0000, 'ºC'),
	(100129, 109, '2015-03-15 00:07:19.000000', 'temperatura', 1140.0000, 'ºC'),
	(100130, 109, '2015-03-15 00:07:20.000000', 'temperatura', 901.0000, 'ºC'),
	(100131, 109, '2015-03-15 00:07:21.000000', 'temperatura', 1086.0000, 'ºC'),
	(100132, 109, '2015-03-15 00:07:22.000000', 'temperatura', 329.0000, 'ºC'),
	(100133, 109, '2015-03-15 00:07:23.000000', 'temperatura', 787.0000, 'ºC'),
	(100134, 109, '2015-03-15 00:07:24.000000', 'temperatura', 547.0000, 'ºC'),
	(100135, 109, '2015-03-15 00:07:25.000000', 'temperatura', 377.0000, 'ºC'),
	(100136, 109, '2015-03-15 00:07:26.000000', 'temperatura', 244.0000, 'ºC'),
	(100137, 109, '2015-03-15 00:07:27.000000', 'temperatura', 88.0000, 'ºC'),
	(100138, 109, '2015-03-15 00:07:28.000000', 'temperatura', 907.0000, 'ºC'),
	(100139, 109, '2015-03-15 00:07:29.000000', 'temperatura', 675.0000, 'ºC'),
	(100140, 109, '2015-03-15 00:07:30.000000', 'temperatura', 654.0000, 'ºC'),
	(100141, 109, '2015-03-15 00:07:31.000000', 'temperatura', 43.0000, 'ºC'),
	(100142, 109, '2015-03-15 00:07:32.000000', 'temperatura', 655.0000, 'ºC'),
	(100143, 109, '2015-03-15 00:07:33.000000', 'temperatura', 747.0000, 'ºC'),
	(100144, 109, '2015-03-15 00:07:34.000000', 'temperatura', 571.0000, 'ºC'),
	(100145, 109, '2015-03-15 00:07:35.000000', 'temperatura', 612.0000, 'ºC'),
	(100146, 109, '2015-03-15 00:07:36.000000', 'temperatura', 149.0000, 'ºC'),
	(100147, 109, '2015-03-15 00:07:37.000000', 'temperatura', 111.0000, 'ºC'),
	(100148, 109, '2015-03-15 00:07:38.000000', 'temperatura', 105.0000, 'ºC'),
	(100149, 109, '2015-03-15 00:07:39.000000', 'temperatura', 196.0000, 'ºC'),
	(100150, 109, '2015-03-15 00:07:40.000000', 'temperatura', 663.0000, 'ºC'),
	(100151, 109, '2015-03-15 00:07:41.000000', 'temperatura', 330.0000, 'ºC'),
	(100152, 109, '2015-03-15 00:07:42.000000', 'temperatura', 861.0000, 'ºC'),
	(100153, 109, '2015-03-15 00:07:43.000000', 'temperatura', 917.0000, 'ºC'),
	(100154, 109, '2015-03-15 00:07:44.000000', 'temperatura', 802.0000, 'ºC'),
	(100155, 109, '2015-03-15 00:07:45.000000', 'temperatura', 58.0000, 'ºC'),
	(100156, 109, '2015-03-15 00:07:46.000000', 'temperatura', 285.0000, 'ºC'),
	(100157, 109, '2015-03-15 00:07:47.000000', 'temperatura', 51.0000, 'ºC'),
	(100158, 109, '2015-03-15 00:07:48.000000', 'temperatura', 600.0000, 'ºC'),
	(100159, 109, '2015-03-15 00:07:49.000000', 'temperatura', 446.0000, 'ºC'),
	(100160, 109, '2015-03-15 00:07:50.000000', 'temperatura', 433.0000, 'ºC'),
	(100161, 109, '2015-03-15 00:07:51.000000', 'temperatura', 825.0000, 'ºC'),
	(100162, 109, '2015-03-15 00:07:52.000000', 'temperatura', 428.0000, 'ºC'),
	(100163, 109, '2015-03-15 00:07:53.000000', 'temperatura', 864.0000, 'ºC'),
	(100164, 109, '2015-03-15 00:07:54.000000', 'temperatura', 636.0000, 'ºC'),
	(100165, 109, '2015-03-15 00:07:55.000000', 'temperatura', 588.0000, 'ºC'),
	(100166, 109, '2015-03-15 00:07:56.000000', 'temperatura', 1033.0000, 'ºC'),
	(100167, 109, '2015-03-15 00:07:57.000000', 'temperatura', 1001.0000, 'ºC'),
	(100168, 109, '2015-03-15 00:07:58.000000', 'temperatura', 709.0000, 'ºC'),
	(100169, 109, '2015-03-15 00:07:59.000000', 'temperatura', 539.0000, 'ºC'),
	(100170, 109, '2015-03-15 00:08:00.000000', 'temperatura', 571.0000, 'ºC'),
	(100171, 109, '2015-03-15 00:08:01.000000', 'temperatura', 38.0000, 'ºC'),
	(100172, 109, '2015-03-15 00:08:02.000000', 'temperatura', 875.0000, 'ºC'),
	(100173, 109, '2015-03-15 00:08:03.000000', 'temperatura', 665.0000, 'ºC'),
	(100174, 109, '2015-03-15 00:08:04.000000', 'temperatura', 700.0000, 'ºC'),
	(100175, 109, '2015-03-15 00:08:05.000000', 'temperatura', 303.0000, 'ºC'),
	(100176, 109, '2015-03-15 00:08:06.000000', 'temperatura', 618.0000, 'ºC'),
	(100177, 109, '2015-03-15 00:08:07.000000', 'temperatura', 981.0000, 'ºC'),
	(100178, 109, '2015-03-15 00:08:08.000000', 'temperatura', 650.0000, 'ºC'),
	(100179, 109, '2015-03-15 00:08:09.000000', 'temperatura', 308.0000, 'ºC'),
	(100180, 109, '2015-03-15 00:08:10.000000', 'temperatura', 791.0000, 'ºC'),
	(100181, 109, '2015-03-15 00:08:11.000000', 'temperatura', 632.0000, 'ºC'),
	(100182, 109, '2015-03-15 00:08:12.000000', 'temperatura', 787.0000, 'ºC'),
	(100183, 109, '2015-03-15 00:08:13.000000', 'temperatura', 840.0000, 'ºC'),
	(100184, 109, '2015-03-15 00:08:14.000000', 'temperatura', 640.0000, 'ºC'),
	(100185, 109, '2015-03-15 00:08:15.000000', 'temperatura', 680.0000, 'ºC'),
	(100186, 109, '2015-03-15 00:08:16.000000', 'temperatura', 282.0000, 'ºC'),
	(100187, 109, '2015-03-15 00:08:17.000000', 'temperatura', 567.0000, 'ºC'),
	(100188, 109, '2015-03-15 00:08:18.000000', 'temperatura', 793.0000, 'ºC'),
	(100189, 109, '2015-03-15 00:08:19.000000', 'temperatura', 1063.0000, 'ºC'),
	(100190, 109, '2015-03-15 00:08:20.000000', 'temperatura', 537.0000, 'ºC'),
	(100191, 109, '2015-03-15 00:08:21.000000', 'temperatura', 696.0000, 'ºC'),
	(100192, 109, '2015-03-15 00:08:22.000000', 'temperatura', 670.0000, 'ºC'),
	(100193, 109, '2015-03-15 00:08:23.000000', 'temperatura', 61.0000, 'ºC'),
	(100194, 109, '2015-03-15 00:08:24.000000', 'temperatura', 698.0000, 'ºC'),
	(100195, 109, '2015-03-15 00:08:25.000000', 'temperatura', 907.0000, 'ºC'),
	(100196, 109, '2015-03-15 00:08:26.000000', 'temperatura', 41.0000, 'ºC'),
	(100197, 109, '2015-03-15 00:08:27.000000', 'temperatura', 1085.0000, 'ºC'),
	(100198, 109, '2015-03-15 00:08:28.000000', 'temperatura', 504.0000, 'ºC'),
	(100199, 109, '2015-03-15 00:08:29.000000', 'temperatura', 465.0000, 'ºC'),
	(100200, 109, '2015-03-15 00:08:30.000000', 'temperatura', 813.0000, 'ºC'),
	(100201, 109, '2015-03-15 00:08:31.000000', 'temperatura', 270.0000, 'ºC'),
	(100202, 109, '2015-03-15 00:08:32.000000', 'temperatura', 111.0000, 'ºC'),
	(100203, 109, '2015-03-15 00:08:33.000000', 'temperatura', 947.0000, 'ºC'),
	(100204, 109, '2015-03-15 00:08:34.000000', 'temperatura', 802.0000, 'ºC'),
	(100205, 109, '2015-03-15 00:08:35.000000', 'temperatura', 1170.0000, 'ºC'),
	(100206, 109, '2015-03-15 00:08:36.000000', 'temperatura', 1045.0000, 'ºC'),
	(100207, 109, '2015-03-15 00:08:37.000000', 'temperatura', 515.0000, 'ºC'),
	(100208, 109, '2015-03-15 00:08:38.000000', 'temperatura', 642.0000, 'ºC'),
	(100209, 109, '2015-03-15 00:08:39.000000', 'temperatura', 465.0000, 'ºC'),
	(100210, 109, '2015-03-15 00:08:40.000000', 'temperatura', 400.0000, 'ºC'),
	(100211, 109, '2015-03-15 00:08:41.000000', 'temperatura', 606.0000, 'ºC'),
	(100212, 109, '2015-03-15 00:08:42.000000', 'temperatura', 629.0000, 'ºC'),
	(100213, 109, '2015-03-15 00:08:43.000000', 'temperatura', 127.0000, 'ºC'),
	(100214, 109, '2015-03-15 00:08:44.000000', 'temperatura', 1150.0000, 'ºC'),
	(100215, 109, '2015-03-15 00:08:45.000000', 'temperatura', 569.0000, 'ºC'),
	(100216, 109, '2015-03-15 00:08:46.000000', 'temperatura', 596.0000, 'ºC'),
	(100217, 109, '2015-03-15 00:08:47.000000', 'temperatura', 73.0000, 'ºC'),
	(100218, 109, '2015-03-15 00:08:48.000000', 'temperatura', 977.0000, 'ºC'),
	(100219, 109, '2015-03-15 00:08:49.000000', 'temperatura', 1067.0000, 'ºC'),
	(100220, 109, '2015-03-15 00:08:50.000000', 'temperatura', 3.0000, 'ºC'),
	(100221, 109, '2015-03-15 00:08:51.000000', 'temperatura', 414.0000, 'ºC'),
	(100222, 109, '2015-03-15 00:08:52.000000', 'temperatura', 862.0000, 'ºC'),
	(100223, 109, '2015-03-15 00:08:53.000000', 'temperatura', 670.0000, 'ºC'),
	(100224, 109, '2015-03-15 00:08:54.000000', 'temperatura', 765.0000, 'ºC'),
	(100225, 109, '2015-03-15 00:08:55.000000', 'temperatura', 615.0000, 'ºC'),
	(100226, 109, '2015-03-15 00:08:56.000000', 'temperatura', 782.0000, 'ºC'),
	(100227, 109, '2015-03-15 00:08:57.000000', 'temperatura', 865.0000, 'ºC'),
	(100228, 109, '2015-03-15 00:08:58.000000', 'temperatura', 780.0000, 'ºC'),
	(100229, 109, '2015-03-15 00:08:59.000000', 'temperatura', 107.0000, 'ºC'),
	(100230, 109, '2015-03-15 00:09:00.000000', 'temperatura', 594.0000, 'ºC'),
	(100231, 109, '2015-03-15 00:09:01.000000', 'temperatura', 248.0000, 'ºC'),
	(100232, 109, '2015-03-15 00:09:02.000000', 'temperatura', 659.0000, 'ºC'),
	(100233, 109, '2015-03-15 00:09:03.000000', 'temperatura', 153.0000, 'ºC'),
	(100234, 109, '2015-03-15 00:09:04.000000', 'temperatura', 1186.0000, 'ºC'),
	(100235, 109, '2015-03-15 00:09:05.000000', 'temperatura', 671.0000, 'ºC'),
	(100236, 109, '2015-03-15 00:09:06.000000', 'temperatura', 1001.0000, 'ºC'),
	(100237, 109, '2015-03-15 00:09:07.000000', 'temperatura', 590.0000, 'ºC'),
	(100238, 109, '2015-03-15 00:09:08.000000', 'temperatura', 1147.0000, 'ºC'),
	(100239, 109, '2015-03-15 00:09:09.000000', 'temperatura', 367.0000, 'ºC'),
	(100240, 109, '2015-03-15 00:09:10.000000', 'temperatura', 794.0000, 'ºC'),
	(100241, 109, '2015-03-15 00:09:11.000000', 'temperatura', 471.0000, 'ºC'),
	(100242, 109, '2015-03-15 00:09:12.000000', 'temperatura', 1175.0000, 'ºC'),
	(100243, 109, '2015-03-15 00:09:13.000000', 'temperatura', 859.0000, 'ºC'),
	(100244, 109, '2015-03-15 00:09:14.000000', 'temperatura', 770.0000, 'ºC'),
	(100245, 109, '2015-03-15 00:09:15.000000', 'temperatura', 76.0000, 'ºC'),
	(100246, 109, '2015-03-15 00:09:16.000000', 'temperatura', 470.0000, 'ºC'),
	(100247, 109, '2015-03-15 00:09:17.000000', 'temperatura', 921.0000, 'ºC'),
	(100248, 109, '2015-03-15 00:09:18.000000', 'temperatura', 796.0000, 'ºC'),
	(100249, 109, '2015-03-15 00:09:19.000000', 'temperatura', 20.0000, 'ºC'),
	(100250, 109, '2015-03-15 00:09:20.000000', 'temperatura', 109.0000, 'ºC'),
	(100251, 109, '2015-03-15 00:09:21.000000', 'temperatura', 486.0000, 'ºC'),
	(100252, 109, '2015-03-15 00:09:22.000000', 'temperatura', 906.0000, 'ºC'),
	(100253, 109, '2015-03-15 00:09:23.000000', 'temperatura', 670.0000, 'ºC'),
	(100254, 109, '2015-03-15 00:09:24.000000', 'temperatura', 635.0000, 'ºC'),
	(100255, 109, '2015-03-15 00:09:25.000000', 'temperatura', 1166.0000, 'ºC'),
	(100256, 109, '2015-03-15 00:09:26.000000', 'temperatura', 324.0000, 'ºC'),
	(100257, 109, '2015-03-15 00:09:27.000000', 'temperatura', 521.0000, 'ºC'),
	(100258, 109, '2015-03-15 00:09:28.000000', 'temperatura', 437.0000, 'ºC'),
	(100259, 109, '2015-03-15 00:09:29.000000', 'temperatura', 619.0000, 'ºC'),
	(100260, 109, '2015-03-15 00:09:30.000000', 'temperatura', 585.0000, 'ºC'),
	(100261, 109, '2015-03-15 00:09:31.000000', 'temperatura', 1071.0000, 'ºC'),
	(100262, 109, '2015-03-15 00:09:32.000000', 'temperatura', 1199.0000, 'ºC'),
	(100263, 109, '2015-03-15 00:09:33.000000', 'temperatura', 381.0000, 'ºC'),
	(100264, 109, '2015-03-15 00:09:34.000000', 'temperatura', 709.0000, 'ºC'),
	(100265, 109, '2015-03-15 00:09:35.000000', 'temperatura', 2.0000, 'ºC'),
	(100266, 109, '2015-03-15 00:09:36.000000', 'temperatura', 284.0000, 'ºC'),
	(100267, 109, '2015-03-15 00:09:37.000000', 'temperatura', 213.0000, 'ºC'),
	(100268, 109, '2015-03-15 00:09:38.000000', 'temperatura', 214.0000, 'ºC'),
	(100269, 109, '2015-03-15 00:09:39.000000', 'temperatura', 432.0000, 'ºC'),
	(100270, 109, '2015-03-15 00:09:40.000000', 'temperatura', 319.0000, 'ºC'),
	(100271, 109, '2015-03-15 00:09:41.000000', 'temperatura', 298.0000, 'ºC'),
	(100272, 109, '2015-03-15 00:09:42.000000', 'temperatura', 533.0000, 'ºC'),
	(100273, 109, '2015-03-15 00:09:43.000000', 'temperatura', 572.0000, 'ºC'),
	(100274, 109, '2015-03-15 00:09:44.000000', 'temperatura', 63.0000, 'ºC'),
	(100275, 109, '2015-03-15 00:09:45.000000', 'temperatura', 997.0000, 'ºC'),
	(100276, 109, '2015-03-15 00:09:46.000000', 'temperatura', 1199.0000, 'ºC'),
	(100277, 109, '2015-03-15 00:09:47.000000', 'temperatura', 605.0000, 'ºC'),
	(100278, 109, '2015-03-15 00:09:48.000000', 'temperatura', 626.0000, 'ºC'),
	(100279, 109, '2015-03-15 00:09:49.000000', 'temperatura', 118.0000, 'ºC'),
	(100280, 109, '2015-03-15 00:09:50.000000', 'temperatura', 1113.0000, 'ºC'),
	(100281, 109, '2015-03-15 00:09:51.000000', 'temperatura', 410.0000, 'ºC'),
	(100282, 109, '2015-03-15 00:09:52.000000', 'temperatura', 1110.0000, 'ºC'),
	(100283, 109, '2015-03-15 00:09:53.000000', 'temperatura', 721.0000, 'ºC'),
	(100284, 109, '2015-03-15 00:09:54.000000', 'temperatura', 278.0000, 'ºC'),
	(100285, 109, '2015-03-15 00:09:55.000000', 'temperatura', 426.0000, 'ºC'),
	(100286, 109, '2015-03-15 00:09:56.000000', 'temperatura', 95.0000, 'ºC'),
	(100287, 109, '2015-03-15 00:09:57.000000', 'temperatura', 401.0000, 'ºC'),
	(100288, 109, '2015-03-15 00:09:58.000000', 'temperatura', 517.0000, 'ºC'),
	(100289, 109, '2015-03-15 00:09:59.000000', 'temperatura', 183.0000, 'ºC'),
	(100290, 109, '2015-03-15 00:10:00.000000', 'temperatura', 564.0000, 'ºC'),
	(100291, 109, '2015-03-15 00:10:01.000000', 'temperatura', 1071.0000, 'ºC'),
	(100292, 109, '2015-03-15 00:10:02.000000', 'temperatura', 63.0000, 'ºC'),
	(100293, 109, '2015-03-15 00:10:03.000000', 'temperatura', 702.0000, 'ºC'),
	(100294, 109, '2015-03-15 00:10:04.000000', 'temperatura', 923.0000, 'ºC'),
	(100295, 109, '2015-03-15 00:10:05.000000', 'temperatura', 110.0000, 'ºC'),
	(100296, 109, '2015-03-15 00:10:06.000000', 'temperatura', 181.0000, 'ºC'),
	(100297, 109, '2015-03-15 00:10:07.000000', 'temperatura', 577.0000, 'ºC'),
	(100298, 109, '2015-03-15 00:10:08.000000', 'temperatura', 1143.0000, 'ºC'),
	(100299, 109, '2015-03-15 00:10:09.000000', 'temperatura', 385.0000, 'ºC'),
	(100300, 109, '2015-03-15 00:10:10.000000', 'temperatura', 895.0000, 'ºC'),
	(100301, 109, '2015-03-15 00:10:11.000000', 'temperatura', 919.0000, 'ºC'),
	(100302, 109, '2015-03-15 00:10:12.000000', 'temperatura', 712.0000, 'ºC'),
	(100303, 109, '2015-03-15 00:10:13.000000', 'temperatura', 803.0000, 'ºC'),
	(100304, 109, '2015-03-15 00:10:14.000000', 'temperatura', 680.0000, 'ºC'),
	(100305, 109, '2015-03-15 00:10:15.000000', 'temperatura', 991.0000, 'ºC'),
	(100306, 109, '2015-03-15 00:10:16.000000', 'temperatura', 516.0000, 'ºC'),
	(100307, 109, '2015-03-15 00:10:17.000000', 'temperatura', 808.0000, 'ºC'),
	(100308, 109, '2015-03-15 00:10:18.000000', 'temperatura', 90.0000, 'ºC'),
	(100309, 109, '2015-03-15 00:10:19.000000', 'temperatura', 429.0000, 'ºC'),
	(100310, 109, '2015-03-15 00:10:20.000000', 'temperatura', 674.0000, 'ºC'),
	(100311, 109, '2015-03-15 00:10:21.000000', 'temperatura', 886.0000, 'ºC'),
	(100312, 109, '2015-03-15 00:10:22.000000', 'temperatura', 6.0000, 'ºC'),
	(100313, 109, '2015-03-15 00:10:23.000000', 'temperatura', 972.0000, 'ºC'),
	(100314, 109, '2015-03-15 00:10:24.000000', 'temperatura', 42.0000, 'ºC'),
	(100315, 109, '2015-03-15 00:10:25.000000', 'temperatura', 897.0000, 'ºC'),
	(100316, 109, '2015-03-15 00:10:26.000000', 'temperatura', 758.0000, 'ºC'),
	(100317, 109, '2015-03-15 00:10:27.000000', 'temperatura', 1102.0000, 'ºC'),
	(100318, 109, '2015-03-15 00:10:28.000000', 'temperatura', 833.0000, 'ºC'),
	(100319, 109, '2015-03-15 00:10:29.000000', 'temperatura', 861.0000, 'ºC'),
	(100320, 109, '2015-03-15 00:10:30.000000', 'temperatura', 607.0000, 'ºC'),
	(100321, 109, '2015-03-15 00:10:31.000000', 'temperatura', 451.0000, 'ºC'),
	(100322, 109, '2015-03-15 00:10:32.000000', 'temperatura', 436.0000, 'ºC'),
	(100323, 109, '2015-03-15 00:10:33.000000', 'temperatura', 827.0000, 'ºC'),
	(100324, 109, '2015-03-15 00:10:34.000000', 'temperatura', 428.0000, 'ºC'),
	(100325, 109, '2015-03-15 00:10:35.000000', 'temperatura', 859.0000, 'ºC'),
	(100326, 109, '2015-03-15 00:10:36.000000', 'temperatura', 611.0000, 'ºC'),
	(100327, 109, '2015-03-15 00:10:37.000000', 'temperatura', 478.0000, 'ºC'),
	(100328, 109, '2015-03-15 00:10:38.000000', 'temperatura', 557.0000, 'ºC'),
	(100329, 109, '2015-03-15 00:10:39.000000', 'temperatura', 152.0000, 'ºC'),
	(100330, 109, '2015-03-15 00:10:40.000000', 'temperatura', 290.0000, 'ºC'),
	(100331, 109, '2015-03-15 00:10:41.000000', 'temperatura', 993.0000, 'ºC'),
	(100332, 109, '2015-03-15 00:10:42.000000', 'temperatura', 497.0000, 'ºC'),
	(100333, 109, '2015-03-15 00:10:43.000000', 'temperatura', 705.0000, 'ºC'),
	(100334, 109, '2015-03-15 00:10:44.000000', 'temperatura', 833.0000, 'ºC'),
	(100335, 109, '2015-03-15 00:10:45.000000', 'temperatura', 854.0000, 'ºC'),
	(100336, 109, '2015-03-15 00:10:46.000000', 'temperatura', 569.0000, 'ºC'),
	(100337, 109, '2015-03-15 00:10:47.000000', 'temperatura', 286.0000, 'ºC'),
	(100338, 109, '2015-03-15 00:10:48.000000', 'temperatura', 922.0000, 'ºC'),
	(100339, 109, '2015-03-15 00:10:49.000000', 'temperatura', 155.0000, 'ºC'),
	(100340, 109, '2015-03-15 00:10:50.000000', 'temperatura', 407.0000, 'ºC'),
	(100341, 109, '2015-03-15 00:10:51.000000', 'temperatura', 372.0000, 'ºC'),
	(100342, 109, '2015-03-15 00:10:52.000000', 'temperatura', 640.0000, 'ºC'),
	(100343, 109, '2015-03-15 00:10:53.000000', 'temperatura', 883.0000, 'ºC'),
	(100344, 109, '2015-03-15 00:10:54.000000', 'temperatura', 97.0000, 'ºC'),
	(100345, 109, '2015-03-15 00:10:55.000000', 'temperatura', 237.0000, 'ºC'),
	(100346, 109, '2015-03-15 00:10:56.000000', 'temperatura', 893.0000, 'ºC'),
	(100347, 109, '2015-03-15 00:10:57.000000', 'temperatura', 153.0000, 'ºC'),
	(100348, 109, '2015-03-15 00:10:58.000000', 'temperatura', 488.0000, 'ºC'),
	(100349, 109, '2015-03-15 00:10:59.000000', 'temperatura', 783.0000, 'ºC'),
	(100350, 109, '2015-03-15 00:11:00.000000', 'temperatura', 50.0000, 'ºC'),
	(100351, 109, '2015-03-15 00:11:01.000000', 'temperatura', 301.0000, 'ºC'),
	(100352, 109, '2015-03-15 00:11:02.000000', 'temperatura', 156.0000, 'ºC'),
	(100353, 109, '2015-03-15 00:11:03.000000', 'temperatura', 1077.0000, 'ºC'),
	(100354, 109, '2015-03-15 00:11:04.000000', 'temperatura', 119.0000, 'ºC'),
	(100355, 109, '2015-03-15 00:11:05.000000', 'temperatura', 962.0000, 'ºC'),
	(100356, 109, '2015-03-15 00:11:06.000000', 'temperatura', 854.0000, 'ºC'),
	(100357, 109, '2015-03-15 00:11:07.000000', 'temperatura', 186.0000, 'ºC'),
	(100358, 109, '2015-03-15 00:11:08.000000', 'temperatura', 769.0000, 'ºC'),
	(100359, 109, '2015-03-15 00:11:09.000000', 'temperatura', 885.0000, 'ºC'),
	(100360, 109, '2015-03-15 00:11:10.000000', 'temperatura', 920.0000, 'ºC'),
	(100361, 109, '2015-03-15 00:11:11.000000', 'temperatura', 744.0000, 'ºC'),
	(100362, 109, '2015-03-15 00:11:12.000000', 'temperatura', 961.0000, 'ºC'),
	(100363, 109, '2015-03-15 00:11:13.000000', 'temperatura', 175.0000, 'ºC'),
	(100364, 109, '2015-03-15 00:11:14.000000', 'temperatura', 390.0000, 'ºC'),
	(100365, 109, '2015-03-15 00:11:15.000000', 'temperatura', 228.0000, 'ºC'),
	(100366, 109, '2015-03-15 00:11:16.000000', 'temperatura', 1169.0000, 'ºC'),
	(100367, 109, '2015-03-15 00:11:17.000000', 'temperatura', 364.0000, 'ºC'),
	(100368, 109, '2015-03-15 00:11:18.000000', 'temperatura', 711.0000, 'ºC'),
	(100369, 109, '2015-03-15 00:11:19.000000', 'temperatura', 65.0000, 'ºC'),
	(100370, 109, '2015-03-15 00:11:20.000000', 'temperatura', 592.0000, 'ºC'),
	(100371, 109, '2015-03-15 00:11:21.000000', 'temperatura', 366.0000, 'ºC'),
	(100372, 109, '2015-03-15 00:11:22.000000', 'temperatura', 55.0000, 'ºC'),
	(100373, 109, '2015-03-15 00:11:23.000000', 'temperatura', 376.0000, 'ºC'),
	(100374, 109, '2015-03-15 00:11:24.000000', 'temperatura', 518.0000, 'ºC'),
	(100375, 109, '2015-03-15 00:11:25.000000', 'temperatura', 261.0000, 'ºC'),
	(100376, 109, '2015-03-15 00:11:26.000000', 'temperatura', 953.0000, 'ºC'),
	(100377, 109, '2015-03-15 00:11:27.000000', 'temperatura', 381.0000, 'ºC'),
	(100378, 109, '2015-03-15 00:11:28.000000', 'temperatura', 245.0000, 'ºC'),
	(100379, 109, '2015-03-15 00:11:29.000000', 'temperatura', 85.0000, 'ºC'),
	(100380, 109, '2015-03-15 00:11:30.000000', 'temperatura', 892.0000, 'ºC'),
	(100381, 109, '2015-03-15 00:11:31.000000', 'temperatura', 602.0000, 'ºC'),
	(100382, 109, '2015-03-15 00:11:32.000000', 'temperatura', 337.0000, 'ºC'),
	(100383, 109, '2015-03-15 00:11:33.000000', 'temperatura', 1080.0000, 'ºC'),
	(100384, 109, '2015-03-15 00:11:34.000000', 'temperatura', 789.0000, 'ºC'),
	(100385, 109, '2015-03-15 00:11:35.000000', 'temperatura', 707.0000, 'ºC'),
	(100386, 109, '2015-03-15 00:11:36.000000', 'temperatura', 1168.0000, 'ºC'),
	(100387, 109, '2015-03-15 00:11:37.000000', 'temperatura', 119.0000, 'ºC'),
	(100388, 109, '2015-03-15 00:11:38.000000', 'temperatura', 693.0000, 'ºC'),
	(100389, 109, '2015-03-15 00:11:39.000000', 'temperatura', 707.0000, 'ºC'),
	(100390, 109, '2015-03-15 00:11:40.000000', 'temperatura', 259.0000, 'ºC'),
	(100391, 109, '2015-03-15 00:11:41.000000', 'temperatura', 372.0000, 'ºC'),
	(100392, 109, '2015-03-15 00:11:42.000000', 'temperatura', 1083.0000, 'ºC'),
	(100393, 109, '2015-03-15 00:11:43.000000', 'temperatura', 702.0000, 'ºC'),
	(100394, 109, '2015-03-15 00:11:44.000000', 'temperatura', 262.0000, 'ºC'),
	(100395, 109, '2015-03-15 00:11:45.000000', 'temperatura', 402.0000, 'ºC'),
	(100396, 109, '2015-03-15 00:11:46.000000', 'temperatura', 25.0000, 'ºC'),
	(100397, 109, '2015-03-15 00:11:47.000000', 'temperatura', 118.0000, 'ºC'),
	(100398, 109, '2015-03-15 00:11:48.000000', 'temperatura', 516.0000, 'ºC'),
	(100399, 109, '2015-03-15 00:11:49.000000', 'temperatura', 1026.0000, 'ºC'),
	(100400, 109, '2015-03-15 00:11:50.000000', 'temperatura', 1184.0000, 'ºC'),
	(100401, 109, '2015-03-15 00:11:51.000000', 'temperatura', 442.0000, 'ºC'),
	(100402, 109, '2015-03-15 00:11:52.000000', 'temperatura', 1060.0000, 'ºC'),
	(100403, 109, '2015-03-15 00:11:53.000000', 'temperatura', 374.0000, 'ºC'),
	(100404, 109, '2015-03-15 00:11:54.000000', 'temperatura', 1088.0000, 'ºC'),
	(100405, 109, '2015-03-15 00:11:55.000000', 'temperatura', 721.0000, 'ºC'),
	(100406, 109, '2015-03-15 00:11:56.000000', 'temperatura', 343.0000, 'ºC'),
	(100407, 109, '2015-03-15 00:11:57.000000', 'temperatura', 751.0000, 'ºC'),
	(100408, 109, '2015-03-15 00:11:58.000000', 'temperatura', 325.0000, 'ºC'),
	(100409, 109, '2015-03-15 00:11:59.000000', 'temperatura', 573.0000, 'ºC'),
	(100410, 109, '2015-03-15 00:12:00.000000', 'temperatura', 691.0000, 'ºC'),
	(100411, 109, '2015-03-15 00:12:01.000000', 'temperatura', 537.0000, 'ºC'),
	(100412, 109, '2015-03-15 00:12:02.000000', 'temperatura', 612.0000, 'ºC'),
	(100413, 109, '2015-03-15 00:12:03.000000', 'temperatura', 251.0000, 'ºC'),
	(100414, 109, '2015-03-15 00:12:04.000000', 'temperatura', 618.0000, 'ºC'),
	(100415, 109, '2015-03-15 00:12:05.000000', 'temperatura', 1138.0000, 'ºC'),
	(100416, 109, '2015-03-15 00:12:06.000000', 'temperatura', 237.0000, 'ºC'),
	(100417, 109, '2015-03-15 00:12:07.000000', 'temperatura', 172.0000, 'ºC'),
	(100418, 109, '2015-03-15 00:12:08.000000', 'temperatura', 150.0000, 'ºC'),
	(100419, 109, '2015-03-15 00:12:09.000000', 'temperatura', 232.0000, 'ºC'),
	(100420, 109, '2015-03-15 00:12:10.000000', 'temperatura', 713.0000, 'ºC'),
	(100421, 109, '2015-03-15 00:12:11.000000', 'temperatura', 470.0000, 'ºC'),
	(100422, 109, '2015-03-15 00:12:12.000000', 'temperatura', 212.0000, 'ºC'),
	(100423, 109, '2015-03-15 00:12:13.000000', 'temperatura', 851.0000, 'ºC'),
	(100424, 109, '2015-03-15 00:12:14.000000', 'temperatura', 17.0000, 'ºC'),
	(100425, 109, '2015-03-15 00:12:15.000000', 'temperatura', 1134.0000, 'ºC'),
	(100426, 109, '2015-03-15 00:12:16.000000', 'temperatura', 819.0000, 'ºC'),
	(100427, 109, '2015-03-15 00:12:17.000000', 'temperatura', 695.0000, 'ºC'),
	(100428, 109, '2015-03-15 00:12:18.000000', 'temperatura', 1020.0000, 'ºC'),
	(100429, 109, '2015-03-15 00:12:19.000000', 'temperatura', 612.0000, 'ºC'),
	(100430, 109, '2015-03-15 00:12:20.000000', 'temperatura', 2.0000, 'ºC'),
	(100431, 109, '2015-03-15 00:12:21.000000', 'temperatura', 575.0000, 'ºC'),
	(100432, 109, '2015-03-15 00:12:22.000000', 'temperatura', 468.0000, 'ºC'),
	(100433, 109, '2015-03-15 00:12:23.000000', 'temperatura', 616.0000, 'ºC'),
	(100434, 109, '2015-03-15 00:12:24.000000', 'temperatura', 475.0000, 'ºC'),
	(100435, 109, '2015-03-15 00:12:25.000000', 'temperatura', 529.0000, 'ºC'),
	(100436, 109, '2015-03-15 00:12:26.000000', 'temperatura', 21.0000, 'ºC'),
	(100437, 109, '2015-03-15 00:12:27.000000', 'temperatura', 918.0000, 'ºC'),
	(100438, 109, '2015-03-15 00:12:28.000000', 'temperatura', 926.0000, 'ºC'),
	(100439, 109, '2015-03-15 00:12:29.000000', 'temperatura', 677.0000, 'ºC'),
	(100440, 109, '2015-03-15 00:12:30.000000', 'temperatura', 610.0000, 'ºC'),
	(100441, 109, '2015-03-15 00:12:31.000000', 'temperatura', 1017.0000, 'ºC'),
	(100442, 109, '2015-03-15 00:12:32.000000', 'temperatura', 855.0000, 'ºC'),
	(100443, 109, '2015-03-15 00:12:33.000000', 'temperatura', 25.0000, 'ºC'),
	(100444, 109, '2015-03-15 00:12:34.000000', 'temperatura', 1162.0000, 'ºC'),
	(100445, 109, '2015-03-15 00:12:35.000000', 'temperatura', 934.0000, 'ºC'),
	(100446, 109, '2015-03-15 00:12:36.000000', 'temperatura', 1185.0000, 'ºC'),
	(100447, 109, '2015-03-15 00:12:37.000000', 'temperatura', 725.0000, 'ºC'),
	(100448, 109, '2015-03-15 00:12:38.000000', 'temperatura', 71.0000, 'ºC'),
	(100449, 109, '2015-03-15 00:12:39.000000', 'temperatura', 579.0000, 'ºC'),
	(100450, 109, '2015-03-15 00:12:40.000000', 'temperatura', 285.0000, 'ºC'),
	(100451, 109, '2015-03-15 00:12:41.000000', 'temperatura', 886.0000, 'ºC'),
	(100452, 109, '2015-03-15 00:12:42.000000', 'temperatura', 1175.0000, 'ºC'),
	(100453, 109, '2015-03-15 00:12:43.000000', 'temperatura', 816.0000, 'ºC'),
	(100454, 109, '2015-03-15 00:12:44.000000', 'temperatura', 559.0000, 'ºC'),
	(100455, 109, '2015-03-15 00:12:45.000000', 'temperatura', 345.0000, 'ºC'),
	(100456, 109, '2015-03-15 00:12:46.000000', 'temperatura', 48.0000, 'ºC'),
	(100457, 109, '2015-03-15 00:12:47.000000', 'temperatura', 405.0000, 'ºC'),
	(100458, 109, '2015-03-15 00:12:48.000000', 'temperatura', 683.0000, 'ºC'),
	(100459, 109, '2015-03-15 00:12:49.000000', 'temperatura', 999.0000, 'ºC'),
	(100460, 109, '2015-03-15 00:12:50.000000', 'temperatura', 546.0000, 'ºC'),
	(100461, 109, '2015-03-15 00:12:51.000000', 'temperatura', 935.0000, 'ºC'),
	(100462, 109, '2015-03-15 00:12:52.000000', 'temperatura', 639.0000, 'ºC'),
	(100463, 109, '2015-03-15 00:12:53.000000', 'temperatura', 388.0000, 'ºC'),
	(100464, 109, '2015-03-15 00:12:54.000000', 'temperatura', 26.0000, 'ºC'),
	(100465, 109, '2015-03-15 00:12:55.000000', 'temperatura', 164.0000, 'ºC'),
	(100466, 109, '2015-03-15 00:12:56.000000', 'temperatura', 742.0000, 'ºC'),
	(100467, 109, '2015-03-15 00:12:57.000000', 'temperatura', 821.0000, 'ºC'),
	(100468, 109, '2015-03-15 00:12:58.000000', 'temperatura', 678.0000, 'ºC'),
	(100469, 109, '2015-03-15 00:12:59.000000', 'temperatura', 926.0000, 'ºC'),
	(100470, 109, '2015-03-15 00:13:00.000000', 'temperatura', 199.0000, 'ºC'),
	(100471, 109, '2015-03-15 00:13:01.000000', 'temperatura', 618.0000, 'ºC'),
	(100472, 109, '2015-03-15 00:13:02.000000', 'temperatura', 91.0000, 'ºC'),
	(100473, 109, '2015-03-15 00:13:03.000000', 'temperatura', 1002.0000, 'ºC'),
	(100474, 109, '2015-03-15 00:13:04.000000', 'temperatura', 1136.0000, 'ºC'),
	(100475, 109, '2015-03-15 00:13:05.000000', 'temperatura', 275.0000, 'ºC'),
	(100476, 109, '2015-03-15 00:13:06.000000', 'temperatura', 370.0000, 'ºC'),
	(100477, 109, '2015-03-15 00:13:07.000000', 'temperatura', 1022.0000, 'ºC'),
	(100478, 109, '2015-03-15 00:13:08.000000', 'temperatura', 402.0000, 'ºC'),
	(100479, 109, '2015-03-15 00:13:09.000000', 'temperatura', 146.0000, 'ºC'),
	(100480, 109, '2015-03-15 00:13:10.000000', 'temperatura', 724.0000, 'ºC'),
	(100481, 109, '2015-03-15 00:13:11.000000', 'temperatura', 782.0000, 'ºC'),
	(100482, 109, '2015-03-15 00:13:12.000000', 'temperatura', 539.0000, 'ºC'),
	(100483, 109, '2015-03-15 00:13:13.000000', 'temperatura', 349.0000, 'ºC'),
	(100484, 109, '2015-03-15 00:13:14.000000', 'temperatura', 129.0000, 'ºC'),
	(100485, 109, '2015-03-15 00:13:15.000000', 'temperatura', 796.0000, 'ºC'),
	(100486, 109, '2015-03-15 00:13:16.000000', 'temperatura', 1196.0000, 'ºC'),
	(100487, 109, '2015-03-15 00:13:17.000000', 'temperatura', 1192.0000, 'ºC'),
	(100488, 109, '2015-03-15 00:13:18.000000', 'temperatura', 1173.0000, 'ºC'),
	(100489, 109, '2015-03-15 00:13:19.000000', 'temperatura', 1088.0000, 'ºC'),
	(100490, 109, '2015-03-15 00:13:20.000000', 'temperatura', 724.0000, 'ºC'),
	(100491, 109, '2015-03-15 00:13:21.000000', 'temperatura', 354.0000, 'ºC'),
	(100492, 109, '2015-03-15 00:13:22.000000', 'temperatura', 799.0000, 'ºC'),
	(100493, 109, '2015-03-15 00:13:23.000000', 'temperatura', 535.0000, 'ºC'),
	(100494, 109, '2015-03-15 00:13:24.000000', 'temperatura', 278.0000, 'ºC'),
	(100495, 109, '2015-03-15 00:13:25.000000', 'temperatura', 986.0000, 'ºC'),
	(100496, 109, '2015-03-15 00:13:26.000000', 'temperatura', 495.0000, 'ºC'),
	(100497, 109, '2015-03-15 00:13:27.000000', 'temperatura', 719.0000, 'ºC'),
	(100498, 109, '2015-03-15 00:13:28.000000', 'temperatura', 909.0000, 'ºC'),
	(100499, 109, '2015-03-15 00:13:29.000000', 'temperatura', 1188.0000, 'ºC'),
	(100500, 109, '2015-03-15 00:13:30.000000', 'temperatura', 814.0000, 'ºC'),
	(100501, 109, '2015-03-15 00:13:31.000000', 'temperatura', 505.0000, 'ºC'),
	(100502, 109, '2015-03-15 00:13:32.000000', 'temperatura', 84.0000, 'ºC'),
	(100503, 109, '2015-03-15 00:13:33.000000', 'temperatura', 107.0000, 'ºC'),
	(100504, 109, '2015-03-15 00:13:34.000000', 'temperatura', 283.0000, 'ºC'),
	(100505, 109, '2015-03-15 00:13:35.000000', 'temperatura', 1093.0000, 'ºC'),
	(100506, 109, '2015-03-15 00:13:36.000000', 'temperatura', 1017.0000, 'ºC'),
	(100507, 109, '2015-03-15 00:13:37.000000', 'temperatura', 609.0000, 'ºC'),
	(100508, 109, '2015-03-15 00:13:38.000000', 'temperatura', 1193.0000, 'ºC'),
	(100509, 109, '2015-03-15 00:13:39.000000', 'temperatura', 537.0000, 'ºC'),
	(100510, 109, '2015-03-15 00:13:40.000000', 'temperatura', 306.0000, 'ºC'),
	(100511, 109, '2015-03-15 00:13:41.000000', 'temperatura', 1121.0000, 'ºC'),
	(100512, 109, '2015-03-15 00:13:42.000000', 'temperatura', 1088.0000, 'ºC'),
	(100513, 109, '2015-03-15 00:13:43.000000', 'temperatura', 879.0000, 'ºC'),
	(100514, 109, '2015-03-15 00:13:44.000000', 'temperatura', 1130.0000, 'ºC'),
	(100515, 109, '2015-03-15 00:13:45.000000', 'temperatura', 611.0000, 'ºC'),
	(100516, 109, '2015-03-15 00:13:46.000000', 'temperatura', 869.0000, 'ºC'),
	(100517, 109, '2015-03-15 00:13:47.000000', 'temperatura', 113.0000, 'ºC'),
	(100518, 109, '2015-03-15 00:13:48.000000', 'temperatura', 357.0000, 'ºC'),
	(100519, 109, '2015-03-15 00:13:49.000000', 'temperatura', 245.0000, 'ºC'),
	(100520, 109, '2015-03-15 00:13:50.000000', 'temperatura', 156.0000, 'ºC'),
	(100521, 109, '2015-03-15 00:13:51.000000', 'temperatura', 44.0000, 'ºC'),
	(100522, 109, '2015-03-15 00:13:52.000000', 'temperatura', 954.0000, 'ºC'),
	(100523, 109, '2015-03-15 00:13:53.000000', 'temperatura', 1040.0000, 'ºC'),
	(100524, 109, '2015-03-15 00:13:54.000000', 'temperatura', 1137.0000, 'ºC'),
	(100525, 109, '2015-03-15 00:13:55.000000', 'temperatura', 165.0000, 'ºC'),
	(100526, 109, '2015-03-15 00:13:56.000000', 'temperatura', 1016.0000, 'ºC'),
	(100527, 109, '2015-03-15 00:13:57.000000', 'temperatura', 984.0000, 'ºC'),
	(100528, 109, '2015-03-15 00:13:58.000000', 'temperatura', 673.0000, 'ºC'),
	(100529, 109, '2015-03-15 00:13:59.000000', 'temperatura', 415.0000, 'ºC'),
	(100530, 109, '2015-03-15 00:14:00.000000', 'temperatura', 56.0000, 'ºC'),
	(100531, 109, '2015-03-15 00:14:01.000000', 'temperatura', 236.0000, 'ºC'),
	(100532, 109, '2015-03-15 00:14:02.000000', 'temperatura', 1011.0000, 'ºC'),
	(100533, 109, '2015-03-15 00:14:03.000000', 'temperatura', 750.0000, 'ºC'),
	(100534, 109, '2015-03-15 00:14:04.000000', 'temperatura', 716.0000, 'ºC'),
	(100535, 109, '2015-03-15 00:14:05.000000', 'temperatura', 129.0000, 'ºC'),
	(100536, 109, '2015-03-15 00:14:06.000000', 'temperatura', 900.0000, 'ºC'),
	(100537, 109, '2015-03-15 00:14:07.000000', 'temperatura', 511.0000, 'ºC'),
	(100538, 109, '2015-03-15 00:14:08.000000', 'temperatura', 1058.0000, 'ºC'),
	(100539, 109, '2015-03-15 00:14:09.000000', 'temperatura', 155.0000, 'ºC'),
	(100540, 109, '2015-03-15 00:14:10.000000', 'temperatura', 4.0000, 'ºC'),
	(100541, 109, '2015-03-15 00:14:11.000000', 'temperatura', 755.0000, 'ºC'),
	(100542, 109, '2015-03-15 00:14:12.000000', 'temperatura', 163.0000, 'ºC'),
	(100543, 109, '2015-03-15 00:14:13.000000', 'temperatura', 952.0000, 'ºC'),
	(100544, 109, '2015-03-15 00:14:14.000000', 'temperatura', 669.0000, 'ºC'),
	(100545, 109, '2015-03-15 00:14:15.000000', 'temperatura', 490.0000, 'ºC'),
	(100546, 109, '2015-03-15 00:14:16.000000', 'temperatura', 444.0000, 'ºC'),
	(100547, 109, '2015-03-15 00:14:17.000000', 'temperatura', 749.0000, 'ºC'),
	(100548, 109, '2015-03-15 00:14:18.000000', 'temperatura', 13.0000, 'ºC'),
	(100549, 109, '2015-03-15 00:14:19.000000', 'temperatura', 220.0000, 'ºC'),
	(100550, 109, '2015-03-15 00:14:20.000000', 'temperatura', 1060.0000, 'ºC'),
	(100551, 109, '2015-03-15 00:14:21.000000', 'temperatura', 1039.0000, 'ºC'),
	(100552, 109, '2015-03-15 00:14:22.000000', 'temperatura', 818.0000, 'ºC'),
	(100553, 109, '2015-03-15 00:14:23.000000', 'temperatura', 973.0000, 'ºC'),
	(100554, 109, '2015-03-15 00:14:24.000000', 'temperatura', 13.0000, 'ºC'),
	(100555, 109, '2015-03-15 00:14:25.000000', 'temperatura', 747.0000, 'ºC'),
	(100556, 109, '2015-03-15 00:14:26.000000', 'temperatura', 94.0000, 'ºC'),
	(100557, 109, '2015-03-15 00:14:27.000000', 'temperatura', 633.0000, 'ºC'),
	(100558, 109, '2015-03-15 00:14:28.000000', 'temperatura', 480.0000, 'ºC'),
	(100559, 109, '2015-03-15 00:14:29.000000', 'temperatura', 502.0000, 'ºC'),
	(100560, 109, '2015-03-15 00:14:30.000000', 'temperatura', 1070.0000, 'ºC'),
	(100561, 109, '2015-03-15 00:14:31.000000', 'temperatura', 244.0000, 'ºC'),
	(100562, 109, '2015-03-15 00:14:32.000000', 'temperatura', 411.0000, 'ºC'),
	(100563, 109, '2015-03-15 00:14:33.000000', 'temperatura', 125.0000, 'ºC'),
	(100564, 109, '2015-03-15 00:14:34.000000', 'temperatura', 592.0000, 'ºC'),
	(100565, 109, '2015-03-15 00:14:35.000000', 'temperatura', 186.0000, 'ºC'),
	(100566, 109, '2015-03-15 00:14:36.000000', 'temperatura', 352.0000, 'ºC'),
	(100567, 109, '2015-03-15 00:14:37.000000', 'temperatura', 6.0000, 'ºC'),
	(100568, 109, '2015-03-15 00:14:38.000000', 'temperatura', 172.0000, 'ºC'),
	(100569, 109, '2015-03-15 00:14:39.000000', 'temperatura', 845.0000, 'ºC'),
	(100570, 109, '2015-03-15 00:14:40.000000', 'temperatura', 109.0000, 'ºC'),
	(100571, 109, '2015-03-15 00:14:41.000000', 'temperatura', 408.0000, 'ºC'),
	(100572, 109, '2015-03-15 00:14:42.000000', 'temperatura', 515.0000, 'ºC'),
	(100573, 109, '2015-03-15 00:14:43.000000', 'temperatura', 151.0000, 'ºC'),
	(100574, 109, '2015-03-15 00:14:44.000000', 'temperatura', 413.0000, 'ºC'),
	(100575, 109, '2015-03-15 00:14:45.000000', 'temperatura', 409.0000, 'ºC'),
	(100576, 109, '2015-03-15 00:14:46.000000', 'temperatura', 810.0000, 'ºC'),
	(100577, 109, '2015-03-15 00:14:47.000000', 'temperatura', 421.0000, 'ºC'),
	(100578, 109, '2015-03-15 00:14:48.000000', 'temperatura', 875.0000, 'ºC'),
	(100579, 109, '2015-03-15 00:14:49.000000', 'temperatura', 715.0000, 'ºC'),
	(100580, 109, '2015-03-15 00:14:50.000000', 'temperatura', 950.0000, 'ºC'),
	(100581, 109, '2015-03-15 00:14:51.000000', 'temperatura', 206.0000, 'ºC'),
	(100582, 109, '2015-03-15 00:14:52.000000', 'temperatura', 578.0000, 'ºC'),
	(100583, 109, '2015-03-15 00:14:53.000000', 'temperatura', 1074.0000, 'ºC'),
	(100584, 109, '2015-03-15 00:14:54.000000', 'temperatura', 38.0000, 'ºC'),
	(100585, 109, '2015-03-15 00:14:55.000000', 'temperatura', 566.0000, 'ºC'),
	(100586, 109, '2015-03-15 00:14:56.000000', 'temperatura', 317.0000, 'ºC'),
	(100587, 109, '2015-03-15 00:14:57.000000', 'temperatura', 1090.0000, 'ºC'),
	(100588, 109, '2015-03-15 00:14:58.000000', 'temperatura', 898.0000, 'ºC'),
	(100589, 109, '2015-03-15 00:14:59.000000', 'temperatura', 19.0000, 'ºC'),
	(100590, 109, '2015-03-15 00:15:00.000000', 'temperatura', 1001.0000, 'ºC'),
	(100591, 109, '2015-03-15 00:15:01.000000', 'temperatura', 151.0000, 'ºC'),
	(100592, 109, '2015-03-15 00:15:02.000000', 'temperatura', 154.0000, 'ºC'),
	(100593, 109, '2015-03-15 00:15:03.000000', 'temperatura', 314.0000, 'ºC'),
	(100594, 109, '2015-03-15 00:15:04.000000', 'temperatura', 1110.0000, 'ºC'),
	(100595, 109, '2015-03-15 00:15:05.000000', 'temperatura', 1010.0000, 'ºC'),
	(100596, 109, '2015-03-15 00:15:06.000000', 'temperatura', 520.0000, 'ºC'),
	(100597, 109, '2015-03-15 00:15:07.000000', 'temperatura', 769.0000, 'ºC'),
	(100598, 109, '2015-03-15 00:15:08.000000', 'temperatura', 1087.0000, 'ºC'),
	(100599, 109, '2015-03-15 00:15:09.000000', 'temperatura', 727.0000, 'ºC'),
	(100600, 109, '2015-03-15 00:15:10.000000', 'temperatura', 377.0000, 'ºC'),
	(100601, 109, '2015-03-15 00:15:11.000000', 'temperatura', 904.0000, 'ºC'),
	(100602, 109, '2015-03-15 00:15:12.000000', 'temperatura', 988.0000, 'ºC'),
	(100603, 109, '2015-03-15 00:15:13.000000', 'temperatura', 1028.0000, 'ºC'),
	(100604, 109, '2015-03-15 00:15:14.000000', 'temperatura', 977.0000, 'ºC'),
	(100605, 109, '2015-03-15 00:15:15.000000', 'temperatura', 601.0000, 'ºC'),
	(100606, 109, '2015-03-15 00:15:16.000000', 'temperatura', 73.0000, 'ºC'),
	(100607, 109, '2015-03-15 00:15:17.000000', 'temperatura', 964.0000, 'ºC'),
	(100608, 109, '2015-03-15 00:15:18.000000', 'temperatura', 1000.0000, 'ºC'),
	(100609, 109, '2015-03-15 00:15:19.000000', 'temperatura', 909.0000, 'ºC'),
	(100610, 109, '2015-03-15 00:15:20.000000', 'temperatura', 346.0000, 'ºC'),
	(100611, 109, '2015-03-15 00:15:21.000000', 'temperatura', 205.0000, 'ºC'),
	(100612, 109, '2015-03-15 00:15:22.000000', 'temperatura', 1187.0000, 'ºC'),
	(100613, 109, '2015-03-15 00:15:23.000000', 'temperatura', 522.0000, 'ºC'),
	(100614, 109, '2015-03-15 00:15:24.000000', 'temperatura', 249.0000, 'ºC'),
	(100615, 109, '2015-03-15 00:15:25.000000', 'temperatura', 877.0000, 'ºC'),
	(100616, 109, '2015-03-15 00:15:26.000000', 'temperatura', 39.0000, 'ºC'),
	(100617, 109, '2015-03-15 00:15:27.000000', 'temperatura', 1167.0000, 'ºC'),
	(100618, 109, '2015-03-15 00:15:28.000000', 'temperatura', 915.0000, 'ºC'),
	(100619, 109, '2015-03-15 00:15:29.000000', 'temperatura', 1077.0000, 'ºC'),
	(100620, 109, '2015-03-15 00:15:30.000000', 'temperatura', 239.0000, 'ºC'),
	(100621, 109, '2015-03-15 00:15:31.000000', 'temperatura', 364.0000, 'ºC'),
	(100622, 109, '2015-03-15 00:15:32.000000', 'temperatura', 1106.0000, 'ºC'),
	(100623, 109, '2015-03-15 00:15:33.000000', 'temperatura', 837.0000, 'ºC'),
	(100624, 109, '2015-03-15 00:15:34.000000', 'temperatura', 866.0000, 'ºC'),
	(100625, 109, '2015-03-15 00:15:35.000000', 'temperatura', 621.0000, 'ºC'),
	(100626, 109, '2015-03-15 00:15:36.000000', 'temperatura', 505.0000, 'ºC'),
	(100627, 109, '2015-03-15 00:15:37.000000', 'temperatura', 665.0000, 'ºC'),
	(100628, 109, '2015-03-15 00:15:38.000000', 'temperatura', 609.0000, 'ºC'),
	(100629, 109, '2015-03-15 00:15:39.000000', 'temperatura', 1053.0000, 'ºC'),
	(100630, 109, '2015-03-15 00:15:40.000000', 'temperatura', 1037.0000, 'ºC'),
	(100631, 109, '2015-03-15 00:15:41.000000', 'temperatura', 827.0000, 'ºC'),
	(100632, 109, '2015-03-15 00:15:42.000000', 'temperatura', 1024.0000, 'ºC'),
	(100633, 109, '2015-03-15 00:15:43.000000', 'temperatura', 241.0000, 'ºC'),
	(100634, 109, '2015-03-15 00:15:44.000000', 'temperatura', 533.0000, 'ºC'),
	(100635, 109, '2015-03-15 00:15:45.000000', 'temperatura', 741.0000, 'ºC'),
	(100636, 109, '2015-03-15 00:15:46.000000', 'temperatura', 907.0000, 'ºC'),
	(100637, 109, '2015-03-15 00:15:47.000000', 'temperatura', 1113.0000, 'ºC'),
	(100638, 109, '2015-03-15 00:15:48.000000', 'temperatura', 443.0000, 'ºC'),
	(100639, 109, '2015-03-15 00:15:49.000000', 'temperatura', 76.0000, 'ºC'),
	(100640, 109, '2015-03-15 00:15:50.000000', 'temperatura', 254.0000, 'ºC'),
	(100641, 109, '2015-03-15 00:15:51.000000', 'temperatura', 1041.0000, 'ºC'),
	(100642, 109, '2015-03-15 00:15:52.000000', 'temperatura', 846.0000, 'ºC'),
	(100643, 109, '2015-03-15 00:15:53.000000', 'temperatura', 1105.0000, 'ºC'),
	(100644, 109, '2015-03-15 00:15:54.000000', 'temperatura', 587.0000, 'ºC'),
	(100645, 109, '2015-03-15 00:15:55.000000', 'temperatura', 819.0000, 'ºC'),
	(100646, 109, '2015-03-15 00:15:56.000000', 'temperatura', 1138.0000, 'ºC'),
	(100647, 109, '2015-03-15 00:15:57.000000', 'temperatura', 833.0000, 'ºC'),
	(100648, 109, '2015-03-15 00:15:58.000000', 'temperatura', 749.0000, 'ºC'),
	(100649, 109, '2015-03-15 00:15:59.000000', 'temperatura', 47.0000, 'ºC'),
	(100650, 109, '2015-03-15 00:16:00.000000', 'temperatura', 391.0000, 'ºC'),
	(100651, 109, '2015-03-15 00:16:01.000000', 'temperatura', 612.0000, 'ºC'),
	(100652, 109, '2015-03-15 00:16:02.000000', 'temperatura', 688.0000, 'ºC'),
	(100653, 109, '2015-03-15 00:16:03.000000', 'temperatura', 405.0000, 'ºC'),
	(100654, 109, '2015-03-15 00:16:04.000000', 'temperatura', 1162.0000, 'ºC'),
	(100655, 109, '2015-03-15 00:16:05.000000', 'temperatura', 994.0000, 'ºC'),
	(100656, 109, '2015-03-15 00:16:06.000000', 'temperatura', 284.0000, 'ºC'),
	(100657, 109, '2015-03-15 00:16:07.000000', 'temperatura', 838.0000, 'ºC'),
	(100658, 109, '2015-03-15 00:16:08.000000', 'temperatura', 938.0000, 'ºC'),
	(100659, 109, '2015-03-15 00:16:09.000000', 'temperatura', 978.0000, 'ºC'),
	(100660, 109, '2015-03-15 00:16:10.000000', 'temperatura', 875.0000, 'ºC'),
	(100661, 109, '2015-03-15 00:16:11.000000', 'temperatura', 243.0000, 'ºC'),
	(100662, 109, '2015-03-15 00:16:12.000000', 'temperatura', 991.0000, 'ºC'),
	(100663, 109, '2015-03-15 00:16:13.000000', 'temperatura', 625.0000, 'ºC'),
	(100664, 109, '2015-03-15 00:16:14.000000', 'temperatura', 154.0000, 'ºC'),
	(100665, 109, '2015-03-15 00:16:15.000000', 'temperatura', 94.0000, 'ºC'),
	(100666, 109, '2015-03-15 00:16:16.000000', 'temperatura', 7.0000, 'ºC'),
	(100667, 109, '2015-03-15 00:16:17.000000', 'temperatura', 955.0000, 'ºC'),
	(100668, 109, '2015-03-15 00:16:18.000000', 'temperatura', 1155.0000, 'ºC'),
	(100669, 109, '2015-03-15 00:16:19.000000', 'temperatura', 512.0000, 'ºC'),
	(100670, 109, '2015-03-15 00:16:20.000000', 'temperatura', 293.0000, 'ºC'),
	(100671, 109, '2015-03-15 00:16:21.000000', 'temperatura', 1129.0000, 'ºC'),
	(100672, 109, '2015-03-15 00:16:22.000000', 'temperatura', 1167.0000, 'ºC'),
	(100673, 109, '2015-03-15 00:16:23.000000', 'temperatura', 51.0000, 'ºC'),
	(100674, 109, '2015-03-15 00:16:24.000000', 'temperatura', 351.0000, 'ºC'),
	(100675, 109, '2015-03-15 00:16:25.000000', 'temperatura', 403.0000, 'ºC'),
	(100676, 109, '2015-03-15 00:16:26.000000', 'temperatura', 964.0000, 'ºC'),
	(100677, 109, '2015-03-15 00:16:27.000000', 'temperatura', 10.0000, 'ºC'),
	(100678, 109, '2015-03-15 00:16:28.000000', 'temperatura', 757.0000, 'ºC'),
	(100679, 109, '2015-03-15 00:16:29.000000', 'temperatura', 158.0000, 'ºC'),
	(100680, 109, '2015-03-15 00:16:30.000000', 'temperatura', 918.0000, 'ºC'),
	(100681, 109, '2015-03-15 00:16:31.000000', 'temperatura', 515.0000, 'ºC'),
	(100682, 109, '2015-03-15 00:16:32.000000', 'temperatura', 1023.0000, 'ºC'),
	(100683, 109, '2015-03-15 00:16:33.000000', 'temperatura', 1170.0000, 'ºC'),
	(100684, 109, '2015-03-15 00:16:34.000000', 'temperatura', 384.0000, 'ºC'),
	(100685, 109, '2015-03-15 00:16:35.000000', 'temperatura', 808.0000, 'ºC'),
	(100686, 109, '2015-03-15 00:16:36.000000', 'temperatura', 487.0000, 'ºC'),
	(100687, 109, '2015-03-15 00:16:37.000000', 'temperatura', 15.0000, 'ºC'),
	(100688, 109, '2015-03-15 00:16:38.000000', 'temperatura', 1011.0000, 'ºC'),
	(100689, 109, '2015-03-15 00:16:39.000000', 'temperatura', 214.0000, 'ºC'),
	(100690, 109, '2015-03-15 00:16:40.000000', 'temperatura', 436.0000, 'ºC'),
	(100691, 109, '2015-03-15 00:16:41.000000', 'temperatura', 337.0000, 'ºC'),
	(100692, 109, '2015-03-15 00:16:42.000000', 'temperatura', 380.0000, 'ºC'),
	(100693, 109, '2015-03-15 00:16:43.000000', 'temperatura', 887.0000, 'ºC'),
	(100694, 109, '2015-03-15 00:16:44.000000', 'temperatura', 897.0000, 'ºC'),
	(100695, 109, '2015-03-15 00:16:45.000000', 'temperatura', 623.0000, 'ºC'),
	(100696, 109, '2015-03-15 00:16:46.000000', 'temperatura', 424.0000, 'ºC'),
	(100697, 109, '2015-03-15 00:16:47.000000', 'temperatura', 253.0000, 'ºC'),
	(100698, 109, '2015-03-15 00:16:48.000000', 'temperatura', 1192.0000, 'ºC'),
	(100699, 109, '2015-03-15 00:16:49.000000', 'temperatura', 401.0000, 'ºC'),
	(100700, 109, '2015-03-15 00:16:50.000000', 'temperatura', 831.0000, 'ºC'),
	(100701, 109, '2015-03-15 00:16:51.000000', 'temperatura', 551.0000, 'ºC'),
	(100702, 109, '2015-03-15 00:16:52.000000', 'temperatura', 262.0000, 'ºC'),
	(100703, 109, '2015-03-15 00:16:53.000000', 'temperatura', 857.0000, 'ºC'),
	(100704, 109, '2015-03-15 00:16:54.000000', 'temperatura', 1099.0000, 'ºC'),
	(100705, 109, '2015-03-15 00:16:55.000000', 'temperatura', 525.0000, 'ºC'),
	(100706, 109, '2015-03-15 00:16:56.000000', 'temperatura', 529.0000, 'ºC'),
	(100707, 109, '2015-03-15 00:16:57.000000', 'temperatura', 1070.0000, 'ºC'),
	(100708, 109, '2015-03-15 00:16:58.000000', 'temperatura', 164.0000, 'ºC'),
	(100709, 109, '2015-03-15 00:16:59.000000', 'temperatura', 10.0000, 'ºC'),
	(100710, 109, '2015-03-15 00:17:00.000000', 'temperatura', 758.0000, 'ºC'),
	(100711, 109, '2015-03-15 00:17:01.000000', 'temperatura', 160.0000, 'ºC'),
	(100712, 109, '2015-03-15 00:17:02.000000', 'temperatura', 928.0000, 'ºC'),
	(100713, 109, '2015-03-15 00:17:03.000000', 'temperatura', 560.0000, 'ºC'),
	(100714, 109, '2015-03-15 00:17:04.000000', 'temperatura', 17.0000, 'ºC'),
	(100715, 109, '2015-03-15 00:17:05.000000', 'temperatura', 804.0000, 'ºC'),
	(100716, 109, '2015-03-15 00:17:06.000000', 'temperatura', 372.0000, 'ºC'),
	(100717, 109, '2015-03-15 00:17:07.000000', 'temperatura', 648.0000, 'ºC'),
	(100718, 109, '2015-03-15 00:17:08.000000', 'temperatura', 924.0000, 'ºC'),
	(100719, 109, '2015-03-15 00:17:09.000000', 'temperatura', 276.0000, 'ºC'),
	(100720, 109, '2015-03-15 00:17:10.000000', 'temperatura', 1010.0000, 'ºC'),
	(100721, 109, '2015-03-15 00:17:11.000000', 'temperatura', 624.0000, 'ºC'),
	(100722, 109, '2015-03-15 00:17:12.000000', 'temperatura', 88.0000, 'ºC'),
	(100723, 109, '2015-03-15 00:17:13.000000', 'temperatura', 968.0000, 'ºC'),
	(100724, 109, '2015-03-15 00:17:14.000000', 'temperatura', 977.0000, 'ºC'),
	(100725, 109, '2015-03-15 00:17:15.000000', 'temperatura', 782.0000, 'ºC'),
	(100726, 109, '2015-03-15 00:17:16.000000', 'temperatura', 977.0000, 'ºC'),
	(100727, 109, '2015-03-15 00:17:17.000000', 'temperatura', 143.0000, 'ºC'),
	(100728, 109, '2015-03-15 00:17:18.000000', 'temperatura', 183.0000, 'ºC'),
	(100729, 109, '2015-03-15 00:17:19.000000', 'temperatura', 485.0000, 'ºC'),
	(100730, 109, '2015-03-15 00:17:20.000000', 'temperatura', 677.0000, 'ºC'),
	(100731, 109, '2015-03-15 00:17:21.000000', 'temperatura', 732.0000, 'ºC'),
	(100732, 109, '2015-03-15 00:17:22.000000', 'temperatura', 431.0000, 'ºC'),
	(100733, 109, '2015-03-15 00:17:23.000000', 'temperatura', 1156.0000, 'ºC'),
	(100734, 109, '2015-03-15 00:17:24.000000', 'temperatura', 890.0000, 'ºC'),
	(100735, 109, '2015-03-15 00:17:25.000000', 'temperatura', 980.0000, 'ºC'),
	(100736, 109, '2015-03-15 00:17:26.000000', 'temperatura', 1031.0000, 'ºC'),
	(100737, 109, '2015-03-15 00:17:27.000000', 'temperatura', 1017.0000, 'ºC'),
	(100738, 109, '2015-03-15 00:17:28.000000', 'temperatura', 791.0000, 'ºC'),
	(100739, 109, '2015-03-15 00:17:29.000000', 'temperatura', 906.0000, 'ºC'),
	(100740, 109, '2015-03-15 00:17:30.000000', 'temperatura', 957.0000, 'ºC'),
	(100741, 109, '2015-03-15 00:17:31.000000', 'temperatura', 869.0000, 'ºC'),
	(100742, 109, '2015-03-15 00:17:32.000000', 'temperatura', 275.0000, 'ºC'),
	(100743, 109, '2015-03-15 00:17:33.000000', 'temperatura', 1169.0000, 'ºC'),
	(100744, 109, '2015-03-15 00:17:34.000000', 'temperatura', 220.0000, 'ºC'),
	(100745, 109, '2015-03-15 00:17:35.000000', 'temperatura', 1193.0000, 'ºC'),
	(100746, 109, '2015-03-15 00:17:36.000000', 'temperatura', 507.0000, 'ºC'),
	(100747, 109, '2015-03-15 00:17:37.000000', 'temperatura', 154.0000, 'ºC'),
	(100748, 109, '2015-03-15 00:17:38.000000', 'temperatura', 449.0000, 'ºC'),
	(100749, 109, '2015-03-15 00:17:39.000000', 'temperatura', 584.0000, 'ºC'),
	(100750, 109, '2015-03-15 00:17:40.000000', 'temperatura', 372.0000, 'ºC'),
	(100751, 109, '2015-03-15 00:17:41.000000', 'temperatura', 109.0000, 'ºC'),
	(100752, 109, '2015-03-15 00:17:42.000000', 'temperatura', 630.0000, 'ºC'),
	(100753, 109, '2015-03-15 00:17:43.000000', 'temperatura', 424.0000, 'ºC'),
	(100754, 109, '2015-03-15 00:17:44.000000', 'temperatura', 231.0000, 'ºC'),
	(100755, 109, '2015-03-15 00:17:45.000000', 'temperatura', 1085.0000, 'ºC'),
	(100756, 109, '2015-03-15 00:17:46.000000', 'temperatura', 1130.0000, 'ºC'),
	(100757, 109, '2015-03-15 00:17:47.000000', 'temperatura', 1194.0000, 'ºC'),
	(100758, 109, '2015-03-15 00:17:48.000000', 'temperatura', 184.0000, 'ºC'),
	(100759, 109, '2015-03-15 00:17:49.000000', 'temperatura', 935.0000, 'ºC'),
	(100760, 109, '2015-03-15 00:17:50.000000', 'temperatura', 525.0000, 'ºC'),
	(100761, 109, '2015-03-15 00:17:51.000000', 'temperatura', 1022.0000, 'ºC'),
	(100762, 109, '2015-03-15 00:17:52.000000', 'temperatura', 1133.0000, 'ºC'),
	(100763, 109, '2015-03-15 00:17:53.000000', 'temperatura', 199.0000, 'ºC'),
	(100764, 109, '2015-03-15 00:17:54.000000', 'temperatura', 1196.0000, 'ºC'),
	(100765, 109, '2015-03-15 00:17:55.000000', 'temperatura', 586.0000, 'ºC'),
	(100766, 109, '2015-03-15 00:17:56.000000', 'temperatura', 542.0000, 'ºC'),
	(100767, 109, '2015-03-15 00:17:57.000000', 'temperatura', 953.0000, 'ºC'),
	(100768, 109, '2015-03-15 00:17:58.000000', 'temperatura', 737.0000, 'ºC'),
	(100769, 109, '2015-03-15 00:17:59.000000', 'temperatura', 827.0000, 'ºC'),
	(100770, 109, '2015-03-15 00:18:00.000000', 'temperatura', 726.0000, 'ºC'),
	(100771, 109, '2015-03-15 00:18:01.000000', 'temperatura', 1148.0000, 'ºC'),
	(100772, 109, '2015-03-15 00:18:02.000000', 'temperatura', 1163.0000, 'ºC'),
	(100773, 109, '2015-03-15 00:18:03.000000', 'temperatura', 1173.0000, 'ºC'),
	(100774, 109, '2015-03-15 00:18:04.000000', 'temperatura', 1175.0000, 'ºC'),
	(100775, 109, '2015-03-15 00:18:05.000000', 'temperatura', 1157.0000, 'ºC'),
	(100776, 109, '2015-03-15 00:18:06.000000', 'temperatura', 1060.0000, 'ºC'),
	(100777, 109, '2015-03-15 00:18:07.000000', 'temperatura', 629.0000, 'ºC'),
	(100778, 109, '2015-03-15 00:18:08.000000', 'temperatura', 1164.0000, 'ºC'),
	(100779, 109, '2015-03-15 00:18:09.000000', 'temperatura', 337.0000, 'ºC'),
	(100780, 109, '2015-03-15 00:18:10.000000', 'temperatura', 590.0000, 'ºC'),
	(100781, 109, '2015-03-15 00:18:11.000000', 'temperatura', 742.0000, 'ºC'),
	(100782, 109, '2015-03-15 00:18:12.000000', 'temperatura', 741.0000, 'ºC'),
	(100783, 109, '2015-03-15 00:18:13.000000', 'temperatura', 278.0000, 'ºC'),
	(100784, 109, '2015-03-15 00:18:14.000000', 'temperatura', 367.0000, 'ºC'),
	(100785, 109, '2015-03-15 00:18:15.000000', 'temperatura', 1003.0000, 'ºC'),
	(100786, 109, '2015-03-15 00:18:16.000000', 'temperatura', 314.0000, 'ºC'),
	(100787, 109, '2015-03-15 00:18:17.000000', 'temperatura', 963.0000, 'ºC'),
	(100788, 109, '2015-03-15 00:18:18.000000', 'temperatura', 273.0000, 'ºC'),
	(100789, 109, '2015-03-15 00:18:19.000000', 'temperatura', 877.0000, 'ºC'),
	(100790, 109, '2015-03-15 00:18:20.000000', 'temperatura', 1166.0000, 'ºC'),
	(100791, 109, '2015-03-15 00:18:21.000000', 'temperatura', 800.0000, 'ºC'),
	(100792, 109, '2015-03-15 00:18:22.000000', 'temperatura', 500.0000, 'ºC'),
	(100793, 109, '2015-03-15 00:18:23.000000', 'temperatura', 103.0000, 'ºC'),
	(100794, 109, '2015-03-15 00:18:24.000000', 'temperatura', 217.0000, 'ºC'),
	(100795, 109, '2015-03-15 00:18:25.000000', 'temperatura', 773.0000, 'ºC'),
	(100796, 109, '2015-03-15 00:18:26.000000', 'temperatura', 817.0000, 'ºC'),
	(100797, 109, '2015-03-15 00:18:27.000000', 'temperatura', 567.0000, 'ºC'),
	(100798, 109, '2015-03-15 00:18:28.000000', 'temperatura', 382.0000, 'ºC'),
	(100799, 109, '2015-03-15 00:18:29.000000', 'temperatura', 209.0000, 'ºC'),
	(100800, 109, '2015-03-15 00:18:30.000000', 'temperatura', 1102.0000, 'ºC'),
	(100801, 109, '2015-03-15 00:18:31.000000', 'temperatura', 84.0000, 'ºC'),
	(100802, 109, '2015-03-15 00:18:32.000000', 'temperatura', 715.0000, 'ºC'),
	(100803, 109, '2015-03-15 00:18:33.000000', 'temperatura', 922.0000, 'ºC'),
	(100804, 109, '2015-03-15 00:18:34.000000', 'temperatura', 66.0000, 'ºC'),
	(100805, 109, '2015-03-15 00:18:35.000000', 'temperatura', 1166.0000, 'ºC'),
	(100806, 109, '2015-03-15 00:18:36.000000', 'temperatura', 832.0000, 'ºC'),
	(100807, 109, '2015-03-15 00:18:37.000000', 'temperatura', 660.0000, 'ºC'),
	(100808, 109, '2015-03-15 00:18:38.000000', 'temperatura', 806.0000, 'ºC'),
	(100809, 109, '2015-03-15 00:18:39.000000', 'temperatura', 852.0000, 'ºC'),
	(100810, 109, '2015-03-15 00:18:40.000000', 'temperatura', 642.0000, 'ºC'),
	(100811, 109, '2015-03-15 00:18:41.000000', 'temperatura', 656.0000, 'ºC'),
	(100812, 109, '2015-03-15 00:18:42.000000', 'temperatura', 154.0000, 'ºC'),
	(100813, 109, '2015-03-15 00:18:43.000000', 'temperatura', 1.0000, 'ºC'),
	(100814, 109, '2015-03-15 00:18:44.000000', 'temperatura', 746.0000, 'ºC'),
	(100815, 109, '2015-03-15 00:18:45.000000', 'temperatura', 126.0000, 'ºC'),
	(100816, 109, '2015-03-15 00:18:46.000000', 'temperatura', 792.0000, 'ºC'),
	(100817, 109, '2015-03-15 00:18:47.000000', 'temperatura', 1185.0000, 'ºC'),
	(100818, 109, '2015-03-15 00:18:48.000000', 'temperatura', 1147.0000, 'ºC'),
	(100819, 109, '2015-03-15 00:18:49.000000', 'temperatura', 982.0000, 'ºC'),
	(100820, 109, '2015-03-15 00:18:50.000000', 'temperatura', 268.0000, 'ºC'),
	(100821, 109, '2015-03-15 00:18:51.000000', 'temperatura', 797.0000, 'ºC'),
	(100822, 109, '2015-03-15 00:18:52.000000', 'temperatura', 781.0000, 'ºC'),
	(100823, 109, '2015-03-15 00:18:53.000000', 'temperatura', 314.0000, 'ºC'),
	(100824, 109, '2015-03-15 00:18:54.000000', 'temperatura', 429.0000, 'ºC'),
	(100825, 109, '2015-03-15 00:18:55.000000', 'temperatura', 1.0000, 'ºC'),
	(100826, 109, '2015-03-15 00:18:56.000000', 'temperatura', 1121.0000, 'ºC'),
	(100827, 109, '2015-03-15 00:18:57.000000', 'temperatura', 799.0000, 'ºC'),
	(100828, 109, '2015-03-15 00:18:58.000000', 'temperatura', 636.0000, 'ºC'),
	(100829, 109, '2015-03-15 00:18:59.000000', 'temperatura', 783.0000, 'ºC'),
	(100830, 109, '2015-03-15 00:19:00.000000', 'temperatura', 806.0000, 'ºC'),
	(100831, 109, '2015-03-15 00:19:01.000000', 'temperatura', 484.0000, 'ºC'),
	(100832, 109, '2015-03-15 00:19:02.000000', 'temperatura', 2.0000, 'ºC'),
	(100833, 109, '2015-03-15 00:19:03.000000', 'temperatura', 959.0000, 'ºC'),
	(100834, 109, '2015-03-15 00:19:04.000000', 'temperatura', 1187.0000, 'ºC'),
	(100835, 109, '2015-03-15 00:19:05.000000', 'temperatura', 659.0000, 'ºC'),
	(100836, 109, '2015-03-15 00:19:06.000000', 'temperatura', 936.0000, 'ºC'),
	(100837, 109, '2015-03-15 00:19:07.000000', 'temperatura', 304.0000, 'ºC'),
	(100838, 109, '2015-03-15 00:19:08.000000', 'temperatura', 1113.0000, 'ºC'),
	(100839, 109, '2015-03-15 00:19:09.000000', 'temperatura', 1054.0000, 'ºC'),
	(100840, 109, '2015-03-15 00:19:10.000000', 'temperatura', 732.0000, 'ºC'),
	(100841, 109, '2015-03-15 00:19:11.000000', 'temperatura', 495.0000, 'ºC'),
	(100842, 109, '2015-03-15 00:19:12.000000', 'temperatura', 283.0000, 'ºC'),
	(100843, 109, '2015-03-15 00:19:13.000000', 'temperatura', 1130.0000, 'ºC'),
	(100844, 109, '2015-03-15 00:19:14.000000', 'temperatura', 1.0000, 'ºC'),
	(100845, 109, '2015-03-15 00:19:15.000000', 'temperatura', 214.0000, 'ºC'),
	(100846, 109, '2015-03-15 00:19:16.000000', 'temperatura', 1069.0000, 'ºC'),
	(100847, 109, '2015-03-15 00:19:17.000000', 'temperatura', 1103.0000, 'ºC'),
	(100848, 109, '2015-03-15 00:19:18.000000', 'temperatura', 1109.0000, 'ºC'),
	(100849, 109, '2015-03-15 00:19:19.000000', 'temperatura', 1037.0000, 'ºC'),
	(100850, 109, '2015-03-15 00:19:20.000000', 'temperatura', 658.0000, 'ºC'),
	(100851, 109, '2015-03-15 00:19:21.000000', 'temperatura', 178.0000, 'ºC'),
	(100852, 109, '2015-03-15 00:19:22.000000', 'temperatura', 115.0000, 'ºC'),
	(100853, 109, '2015-03-15 00:19:23.000000', 'temperatura', 45.0000, 'ºC'),
	(100854, 109, '2015-03-15 00:19:24.000000', 'temperatura', 1080.0000, 'ºC'),
	(100855, 109, '2015-03-15 00:19:25.000000', 'temperatura', 466.0000, 'ºC'),
	(100856, 109, '2015-03-15 00:19:26.000000', 'temperatura', 290.0000, 'ºC'),
	(100857, 109, '2015-03-15 00:19:27.000000', 'temperatura', 52.0000, 'ºC'),
	(100858, 109, '2015-03-15 00:19:28.000000', 'temperatura', 591.0000, 'ºC'),
	(100859, 109, '2015-03-15 00:19:29.000000', 'temperatura', 398.0000, 'ºC'),
	(100860, 109, '2015-03-15 00:19:30.000000', 'temperatura', 217.0000, 'ºC'),
	(100861, 109, '2015-03-15 00:19:31.000000', 'temperatura', 1094.0000, 'ºC'),
	(100862, 109, '2015-03-15 00:19:32.000000', 'temperatura', 18.0000, 'ºC'),
	(100863, 109, '2015-03-15 00:19:33.000000', 'temperatura', 409.0000, 'ºC'),
	(100864, 109, '2015-03-15 00:19:34.000000', 'temperatura', 791.0000, 'ºC'),
	(100865, 109, '2015-03-15 00:19:35.000000', 'temperatura', 328.0000, 'ºC'),
	(100866, 109, '2015-03-15 00:19:36.000000', 'temperatura', 470.0000, 'ºC'),
	(100867, 109, '2015-03-15 00:19:37.000000', 'temperatura', 163.0000, 'ºC'),
	(100868, 109, '2015-03-15 00:19:38.000000', 'temperatura', 609.0000, 'ºC'),
	(100869, 109, '2015-03-15 00:19:39.000000', 'temperatura', 154.0000, 'ºC'),
	(100870, 109, '2015-03-15 00:19:40.000000', 'temperatura', 144.0000, 'ºC'),
	(100871, 109, '2015-03-15 00:19:41.000000', 'temperatura', 257.0000, 'ºC'),
	(100872, 109, '2015-03-15 00:19:42.000000', 'temperatura', 853.0000, 'ºC'),
	(100873, 109, '2015-03-15 00:19:43.000000', 'temperatura', 1095.0000, 'ºC'),
	(100874, 109, '2015-03-15 00:19:44.000000', 'temperatura', 517.0000, 'ºC'),
	(100875, 109, '2015-03-15 00:19:45.000000', 'temperatura', 502.0000, 'ºC'),
	(100876, 109, '2015-03-15 00:19:46.000000', 'temperatura', 957.0000, 'ºC'),
	(100877, 109, '2015-03-15 00:19:47.000000', 'temperatura', 879.0000, 'ºC'),
	(100878, 109, '2015-03-15 00:19:48.000000', 'temperatura', 327.0000, 'ºC'),
	(100879, 109, '2015-03-15 00:19:49.000000', 'temperatura', 199.0000, 'ºC'),
	(100880, 109, '2015-03-15 00:19:50.000000', 'temperatura', 13.0000, 'ºC'),
	(100881, 109, '2015-03-15 00:19:51.000000', 'temperatura', 670.0000, 'ºC'),
	(100882, 109, '2015-03-15 00:19:52.000000', 'temperatura', 912.0000, 'ºC'),
	(100883, 109, '2015-03-15 00:19:53.000000', 'temperatura', 151.0000, 'ºC'),
	(100884, 109, '2015-03-15 00:19:54.000000', 'temperatura', 419.0000, 'ºC'),
	(100885, 109, '2015-03-15 00:19:55.000000', 'temperatura', 441.0000, 'ºC'),
	(100886, 109, '2015-03-15 00:19:56.000000', 'temperatura', 948.0000, 'ºC'),
	(100887, 109, '2015-03-15 00:19:57.000000', 'temperatura', 1019.0000, 'ºC'),
	(100888, 109, '2015-03-15 00:19:58.000000', 'temperatura', 1052.0000, 'ºC'),
	(100889, 109, '2015-03-15 00:19:59.000000', 'temperatura', 1003.0000, 'ºC'),
	(100890, 109, '2015-03-15 00:20:00.000000', 'temperatura', 659.0000, 'ºC'),
	(100891, 109, '2015-03-15 00:20:01.000000', 'temperatura', 287.0000, 'ºC'),
	(100892, 109, '2015-03-15 00:20:02.000000', 'temperatura', 658.0000, 'ºC'),
	(100893, 109, '2015-03-15 00:20:03.000000', 'temperatura', 31.0000, 'ºC'),
	(100894, 109, '2015-03-15 00:20:04.000000', 'temperatura', 579.0000, 'ºC'),
	(100895, 109, '2015-03-15 00:20:05.000000', 'temperatura', 405.0000, 'ºC'),
	(100896, 109, '2015-03-15 00:20:06.000000', 'temperatura', 285.0000, 'ºC'),
	(100897, 109, '2015-03-15 00:20:07.000000', 'temperatura', 214.0000, 'ºC'),
	(100898, 109, '2015-03-15 00:20:08.000000', 'temperatura', 216.0000, 'ºC'),
	(100899, 109, '2015-03-15 00:20:09.000000', 'temperatura', 437.0000, 'ºC'),
	(100900, 109, '2015-03-15 00:20:10.000000', 'temperatura', 336.0000, 'ºC'),
	(100901, 109, '2015-03-15 00:20:11.000000', 'temperatura', 372.0000, 'ºC'),
	(100902, 109, '2015-03-15 00:20:12.000000', 'temperatura', 850.0000, 'ºC'),
	(100903, 109, '2015-03-15 00:20:13.000000', 'temperatura', 734.0000, 'ºC'),
	(100904, 109, '2015-03-15 00:20:14.000000', 'temperatura', 1121.0000, 'ºC'),
	(100905, 109, '2015-03-15 00:20:15.000000', 'temperatura', 1002.0000, 'ºC'),
	(100906, 109, '2015-03-15 00:20:16.000000', 'temperatura', 450.0000, 'ºC'),
	(100907, 109, '2015-03-15 00:20:17.000000', 'temperatura', 444.0000, 'ºC'),
	(100908, 109, '2015-03-15 00:20:18.000000', 'temperatura', 870.0000, 'ºC'),
	(100909, 109, '2015-03-15 00:20:19.000000', 'temperatura', 618.0000, 'ºC'),
	(100910, 109, '2015-03-15 00:20:20.000000', 'temperatura', 481.0000, 'ºC'),
	(100911, 109, '2015-03-15 00:20:21.000000', 'temperatura', 553.0000, 'ºC'),
	(100912, 109, '2015-03-15 00:20:22.000000', 'temperatura', 123.0000, 'ºC'),
	(100913, 109, '2015-03-15 00:20:23.000000', 'temperatura', 154.0000, 'ºC'),
	(100914, 109, '2015-03-15 00:20:24.000000', 'temperatura', 404.0000, 'ºC'),
	(100915, 109, '2015-03-15 00:20:25.000000', 'temperatura', 357.0000, 'ºC'),
	(100916, 109, '2015-03-15 00:20:26.000000', 'temperatura', 574.0000, 'ºC'),
	(100917, 109, '2015-03-15 00:20:27.000000', 'temperatura', 601.0000, 'ºC'),
	(100918, 109, '2015-03-15 00:20:28.000000', 'temperatura', 82.0000, 'ºC'),
	(100919, 109, '2015-03-15 00:20:29.000000', 'temperatura', 1010.0000, 'ºC'),
	(100920, 109, '2015-03-15 00:20:30.000000', 'temperatura', 2.0000, 'ºC'),
	(100921, 109, '2015-03-15 00:20:31.000000', 'temperatura', 582.0000, 'ºC'),
	(100922, 109, '2015-03-15 00:20:32.000000', 'temperatura', 503.0000, 'ºC'),
	(100923, 109, '2015-03-15 00:20:33.000000', 'temperatura', 772.0000, 'ºC'),
	(100924, 109, '2015-03-15 00:20:34.000000', 'temperatura', 1151.0000, 'ºC'),
	(100925, 109, '2015-03-15 00:20:35.000000', 'temperatura', 1040.0000, 'ºC'),
	(100926, 109, '2015-03-15 00:20:36.000000', 'temperatura', 547.0000, 'ºC'),
	(100927, 109, '2015-03-15 00:20:37.000000', 'temperatura', 816.0000, 'ºC'),
	(100928, 109, '2015-03-15 00:20:38.000000', 'temperatura', 38.0000, 'ºC'),
	(100929, 109, '2015-03-15 00:20:39.000000', 'temperatura', 143.0000, 'ºC'),
	(100930, 109, '2015-03-15 00:20:40.000000', 'temperatura', 602.0000, 'ºC'),
	(100931, 109, '2015-03-15 00:20:41.000000', 'temperatura', 183.0000, 'ºC'),
	(100932, 109, '2015-03-15 00:20:42.000000', 'temperatura', 309.0000, 'ºC'),
	(100933, 109, '2015-03-15 00:20:43.000000', 'temperatura', 997.0000, 'ºC'),
	(100934, 109, '2015-03-15 00:20:44.000000', 'temperatura', 458.0000, 'ºC'),
	(100935, 109, '2015-03-15 00:20:45.000000', 'temperatura', 500.0000, 'ºC'),
	(100936, 109, '2015-03-15 00:20:46.000000', 'temperatura', 1128.0000, 'ºC'),
	(100937, 109, '2015-03-15 00:20:47.000000', 'temperatura', 540.0000, 'ºC'),
	(100938, 109, '2015-03-15 00:20:48.000000', 'temperatura', 515.0000, 'ºC'),
	(100939, 109, '2015-03-15 00:20:49.000000', 'temperatura', 955.0000, 'ºC'),
	(100940, 109, '2015-03-15 00:20:50.000000', 'temperatura', 831.0000, 'ºC'),
	(100941, 109, '2015-03-15 00:20:51.000000', 'temperatura', 91.0000, 'ºC'),
	(100942, 109, '2015-03-15 00:20:52.000000', 'temperatura', 363.0000, 'ºC'),
	(100943, 109, '2015-03-15 00:20:53.000000', 'temperatura', 343.0000, 'ºC'),
	(100944, 109, '2015-03-15 00:20:54.000000', 'temperatura', 625.0000, 'ºC'),
	(100945, 109, '2015-03-15 00:20:55.000000', 'temperatura', 898.0000, 'ºC'),
	(100946, 109, '2015-03-15 00:20:56.000000', 'temperatura', 213.0000, 'ºC'),
	(100947, 109, '2015-03-15 00:20:57.000000', 'temperatura', 773.0000, 'ºC'),
	(100948, 109, '2015-03-15 00:20:58.000000', 'temperatura', 828.0000, 'ºC'),
	(100949, 109, '2015-03-15 00:20:59.000000', 'temperatura', 622.0000, 'ºC'),
	(100950, 109, '2015-03-15 00:21:00.000000', 'temperatura', 626.0000, 'ºC'),
	(100951, 109, '2015-03-15 00:21:01.000000', 'temperatura', 65.0000, 'ºC'),
	(100952, 109, '2015-03-15 00:21:02.000000', 'temperatura', 845.0000, 'ºC'),
	(100953, 109, '2015-03-15 00:21:03.000000', 'temperatura', 431.0000, 'ºC'),
	(100954, 109, '2015-03-15 00:21:04.000000', 'temperatura', 822.0000, 'ºC'),
	(100955, 109, '2015-03-15 00:21:05.000000', 'temperatura', 415.0000, 'ºC'),
	(100956, 109, '2015-03-15 00:21:06.000000', 'temperatura', 811.0000, 'ºC'),
	(100957, 109, '2015-03-15 00:21:07.000000', 'temperatura', 411.0000, 'ºC'),
	(100958, 109, '2015-03-15 00:21:08.000000', 'temperatura', 821.0000, 'ºC'),
	(100959, 109, '2015-03-15 00:21:09.000000', 'temperatura', 473.0000, 'ºC'),
	(100960, 109, '2015-03-15 00:21:10.000000', 'temperatura', 1104.0000, 'ºC'),
	(100961, 109, '2015-03-15 00:21:11.000000', 'temperatura', 501.0000, 'ºC'),
	(100962, 109, '2015-03-15 00:21:12.000000', 'temperatura', 392.0000, 'ºC'),
	(100963, 109, '2015-03-15 00:21:13.000000', 'temperatura', 460.0000, 'ºC'),
	(100964, 109, '2015-03-15 00:21:14.000000', 'temperatura', 1125.0000, 'ºC'),
	(100965, 109, '2015-03-15 00:21:15.000000', 'temperatura', 643.0000, 'ºC'),
	(100966, 109, '2015-03-15 00:21:16.000000', 'temperatura', 1040.0000, 'ºC'),
	(100967, 109, '2015-03-15 00:21:17.000000', 'temperatura', 871.0000, 'ºC'),
	(100968, 109, '2015-03-15 00:21:18.000000', 'temperatura', 38.0000, 'ºC'),
	(100969, 109, '2015-03-15 00:21:19.000000', 'temperatura', 1176.0000, 'ºC'),
	(100970, 109, '2015-03-15 00:21:20.000000', 'temperatura', 969.0000, 'ºC'),
	(100971, 109, '2015-03-15 00:21:21.000000', 'temperatura', 114.0000, 'ºC'),
	(100972, 109, '2015-03-15 00:21:22.000000', 'temperatura', 66.0000, 'ºC'),
	(100973, 109, '2015-03-15 00:21:23.000000', 'temperatura', 1186.0000, 'ºC'),
	(100974, 109, '2015-03-15 00:21:24.000000', 'temperatura', 935.0000, 'ºC'),
	(100975, 109, '2015-03-15 00:21:25.000000', 'temperatura', 1117.0000, 'ºC'),
	(100976, 109, '2015-03-15 00:21:26.000000', 'temperatura', 380.0000, 'ºC'),
	(100977, 109, '2015-03-15 00:21:27.000000', 'temperatura', 951.0000, 'ºC'),
	(100978, 109, '2015-03-15 00:21:28.000000', 'temperatura', 14.0000, 'ºC'),
	(100979, 109, '2015-03-15 00:21:29.000000', 'temperatura', 817.0000, 'ºC'),
	(100980, 109, '2015-03-15 00:21:30.000000', 'temperatura', 444.0000, 'ºC'),
	(100981, 109, '2015-03-15 00:21:31.000000', 'temperatura', 971.0000, 'ºC'),
	(100982, 109, '2015-03-15 00:21:32.000000', 'temperatura', 1120.0000, 'ºC'),
	(100983, 109, '2015-03-15 00:21:33.000000', 'temperatura', 291.0000, 'ºC'),
	(100984, 109, '2015-03-15 00:21:34.000000', 'temperatura', 494.0000, 'ºC'),
	(100985, 109, '2015-03-15 00:21:35.000000', 'temperatura', 399.0000, 'ºC'),
	(100986, 109, '2015-03-15 00:21:36.000000', 'temperatura', 512.0000, 'ºC'),
	(100987, 109, '2015-03-15 00:21:37.000000', 'temperatura', 164.0000, 'ºC'),
	(100988, 109, '2015-03-15 00:21:38.000000', 'temperatura', 485.0000, 'ºC'),
	(100989, 109, '2015-03-15 00:21:39.000000', 'temperatura', 733.0000, 'ºC'),
	(100990, 109, '2015-03-15 00:21:40.000000', 'temperatura', 1011.0000, 'ºC'),
	(100991, 109, '2015-03-15 00:21:41.000000', 'temperatura', 458.0000, 'ºC'),
	(100992, 109, '2015-03-15 00:21:42.000000', 'temperatura', 456.0000, 'ºC'),
	(100993, 109, '2015-03-15 00:21:43.000000', 'temperatura', 905.0000, 'ºC'),
	(100994, 109, '2015-03-15 00:21:44.000000', 'temperatura', 760.0000, 'ºC'),
	(100995, 109, '2015-03-15 00:21:45.000000', 'temperatura', 1082.0000, 'ºC'),
	(100996, 109, '2015-03-15 00:21:46.000000', 'temperatura', 734.0000, 'ºC'),
	(100997, 109, '2015-03-15 00:21:47.000000', 'temperatura', 425.0000, 'ºC'),
	(100998, 109, '2015-03-15 00:21:48.000000', 'temperatura', 1120.0000, 'ºC'),
	(100999, 109, '2015-03-15 00:21:49.000000', 'temperatura', 728.0000, 'ºC'),
	(101000, 109, '2015-03-15 00:21:50.000000', 'temperatura', 281.0000, 'ºC'),
	(101001, 109, '2015-03-15 00:21:51.000000', 'temperatura', 421.0000, 'ºC'),
	(101002, 109, '2015-03-15 00:21:52.000000', 'temperatura', 63.0000, 'ºC'),
	(101003, 109, '2015-03-15 00:21:53.000000', 'temperatura', 251.0000, 'ºC'),
	(101004, 109, '2015-03-15 00:21:54.000000', 'temperatura', 1066.0000, 'ºC'),
	(101005, 109, '2015-03-15 00:21:55.000000', 'temperatura', 980.0000, 'ºC'),
	(101006, 109, '2015-03-15 00:21:56.000000', 'temperatura', 502.0000, 'ºC'),
	(101007, 109, '2015-03-15 00:21:57.000000', 'temperatura', 772.0000, 'ºC'),
	(101008, 109, '2015-03-15 00:21:58.000000', 'temperatura', 1154.0000, 'ºC'),
	(101009, 109, '2015-03-15 00:21:59.000000', 'temperatura', 1052.0000, 'ºC'),
	(101010, 109, '2015-03-15 00:22:00.000000', 'temperatura', 601.0000, 'ºC'),
	(101011, 109, '2015-03-15 00:22:01.000000', 'temperatura', 1048.0000, 'ºC'),
	(101012, 109, '2015-03-15 00:22:02.000000', 'temperatura', 1038.0000, 'ºC'),
	(101013, 109, '2015-03-15 00:22:03.000000', 'temperatura', 848.0000, 'ºC'),
	(101014, 109, '2015-03-15 00:22:04.000000', 'temperatura', 1125.0000, 'ºC'),
	(101015, 109, '2015-03-15 00:22:05.000000', 'temperatura', 680.0000, 'ºC'),
	(101016, 109, '2015-03-15 00:22:06.000000', 'temperatura', 26.0000, 'ºC'),
	(101017, 109, '2015-03-15 00:22:07.000000', 'temperatura', 492.0000, 'ºC'),
	(101018, 109, '2015-03-15 00:22:08.000000', 'temperatura', 1180.0000, 'ºC'),
	(101019, 109, '2015-03-15 00:22:09.000000', 'temperatura', 825.0000, 'ºC'),
	(101020, 109, '2015-03-15 00:22:10.000000', 'temperatura', 584.0000, 'ºC'),
	(101021, 109, '2015-03-15 00:22:11.000000', 'temperatura', 447.0000, 'ºC'),
	(101022, 109, '2015-03-15 00:22:12.000000', 'temperatura', 483.0000, 'ºC'),
	(101023, 109, '2015-03-15 00:22:13.000000', 'temperatura', 1077.0000, 'ºC'),
	(101024, 109, '2015-03-15 00:22:14.000000', 'temperatura', 334.0000, 'ºC'),
	(101025, 109, '2015-03-15 00:22:15.000000', 'temperatura', 841.0000, 'ºC'),
	(101026, 109, '2015-03-15 00:22:16.000000', 'temperatura', 801.0000, 'ºC'),
	(101027, 109, '2015-03-15 00:22:17.000000', 'temperatura', 284.0000, 'ºC'),
	(101028, 109, '2015-03-15 00:22:18.000000', 'temperatura', 219.0000, 'ºC'),
	(101029, 109, '2015-03-15 00:22:19.000000', 'temperatura', 244.0000, 'ºC'),
	(101030, 109, '2015-03-15 00:22:20.000000', 'temperatura', 561.0000, 'ºC'),
	(101031, 109, '2015-03-15 00:22:21.000000', 'temperatura', 873.0000, 'ºC'),
	(101032, 109, '2015-03-15 00:22:22.000000', 'temperatura', 282.0000, 'ºC'),
	(101033, 109, '2015-03-15 00:22:23.000000', 'temperatura', 1191.0000, 'ºC'),
	(101034, 109, '2015-03-15 00:22:24.000000', 'temperatura', 309.0000, 'ºC'),
	(101035, 109, '2015-03-15 00:22:25.000000', 'temperatura', 374.0000, 'ºC'),
	(101036, 109, '2015-03-15 00:22:26.000000', 'temperatura', 944.0000, 'ºC'),
	(101037, 109, '2015-03-15 00:22:27.000000', 'temperatura', 1196.0000, 'ºC'),
	(101038, 109, '2015-03-15 00:22:28.000000', 'temperatura', 749.0000, 'ºC'),
	(101039, 109, '2015-03-15 00:22:29.000000', 'temperatura', 159.0000, 'ºC'),
	(101040, 109, '2015-03-15 00:22:30.000000', 'temperatura', 949.0000, 'ºC'),
	(101041, 109, '2015-03-15 00:22:31.000000', 'temperatura', 668.0000, 'ºC'),
	(101042, 109, '2015-03-15 00:22:32.000000', 'temperatura', 491.0000, 'ºC'),
	(101043, 109, '2015-03-15 00:22:33.000000', 'temperatura', 455.0000, 'ºC'),
	(101044, 109, '2015-03-15 00:22:34.000000', 'temperatura', 800.0000, 'ºC'),
	(101045, 109, '2015-03-15 00:22:35.000000', 'temperatura', 235.0000, 'ºC'),
	(101046, 109, '2015-03-15 00:22:36.000000', 'temperatura', 1175.0000, 'ºC'),
	(101047, 109, '2015-03-15 00:22:37.000000', 'temperatura', 372.0000, 'ºC'),
	(101048, 109, '2015-03-15 00:22:38.000000', 'temperatura', 736.0000, 'ºC'),
	(101049, 109, '2015-03-15 00:22:39.000000', 'temperatura', 163.0000, 'ºC'),
	(101050, 109, '2015-03-15 00:22:40.000000', 'temperatura', 1010.0000, 'ºC'),
	(101051, 109, '2015-03-15 00:22:41.000000', 'temperatura', 961.0000, 'ºC'),
	(101052, 109, '2015-03-15 00:22:42.000000', 'temperatura', 573.0000, 'ºC'),
	(101053, 109, '2015-03-15 00:22:43.000000', 'temperatura', 1183.0000, 'ºC'),
	(101054, 109, '2015-03-15 00:22:44.000000', 'temperatura', 599.0000, 'ºC'),
	(101055, 109, '2015-03-15 00:22:45.000000', 'temperatura', 645.0000, 'ºC'),
	(101056, 109, '2015-03-15 00:22:46.000000', 'temperatura', 228.0000, 'ºC'),
	(101057, 109, '2015-03-15 00:22:47.000000', 'temperatura', 407.0000, 'ºC'),
	(101058, 109, '2015-03-15 00:22:48.000000', 'temperatura', 149.0000, 'ºC'),
	(101059, 109, '2015-03-15 00:22:49.000000', 'temperatura', 726.0000, 'ºC'),
	(101060, 109, '2015-03-15 00:22:50.000000', 'temperatura', 782.0000, 'ºC'),
	(101061, 109, '2015-03-15 00:22:51.000000', 'temperatura', 532.0000, 'ºC'),
	(101062, 109, '2015-03-15 00:22:52.000000', 'temperatura', 316.0000, 'ºC'),
	(101063, 109, '2015-03-15 00:22:53.000000', 'temperatura', 1183.0000, 'ºC'),
	(101064, 109, '2015-03-15 00:22:54.000000', 'temperatura', 167.0000, 'ºC'),
	(101065, 109, '2015-03-15 00:22:55.000000', 'temperatura', 888.0000, 'ºC'),
	(101066, 109, '2015-03-15 00:22:56.000000', 'temperatura', 341.0000, 'ºC'),
	(101067, 109, '2015-03-15 00:22:57.000000', 'temperatura', 241.0000, 'ºC'),
	(101068, 109, '2015-03-15 00:22:58.000000', 'temperatura', 180.0000, 'ºC'),
	(101069, 109, '2015-03-15 00:22:59.000000', 'temperatura', 179.0000, 'ºC'),
	(101070, 109, '2015-03-15 00:23:00.000000', 'temperatura', 354.0000, 'ºC'),
	(101071, 109, '2015-03-15 00:23:01.000000', 'temperatura', 35.0000, 'ºC'),
	(101072, 109, '2015-03-15 00:23:02.000000', 'temperatura', 314.0000, 'ºC'),
	(101073, 109, '2015-03-15 00:23:03.000000', 'temperatura', 266.0000, 'ºC'),
	(101074, 109, '2015-03-15 00:23:04.000000', 'temperatura', 386.0000, 'ºC'),
	(101075, 109, '2015-03-15 00:23:05.000000', 'temperatura', 1132.0000, 'ºC'),
	(101076, 109, '2015-03-15 00:23:06.000000', 'temperatura', 904.0000, 'ºC'),
	(101077, 109, '2015-03-15 00:23:07.000000', 'temperatura', 1124.0000, 'ºC'),
	(101078, 109, '2015-03-15 00:23:08.000000', 'temperatura', 511.0000, 'ºC'),
	(101079, 109, '2015-03-15 00:23:09.000000', 'temperatura', 380.0000, 'ºC'),
	(101080, 109, '2015-03-15 00:23:10.000000', 'temperatura', 371.0000, 'ºC'),
	(101081, 109, '2015-03-15 00:23:11.000000', 'temperatura', 713.0000, 'ºC'),
	(101082, 109, '2015-03-15 00:23:12.000000', 'temperatura', 51.0000, 'ºC'),
	(101083, 109, '2015-03-15 00:23:13.000000', 'temperatura', 520.0000, 'ºC'),
	(101084, 109, '2015-03-15 00:23:14.000000', 'temperatura', 46.0000, 'ºC'),
	(101085, 109, '2015-03-15 00:23:15.000000', 'temperatura', 1072.0000, 'ºC'),
	(101086, 109, '2015-03-15 00:23:16.000000', 'temperatura', 421.0000, 'ºC'),
	(101087, 109, '2015-03-15 00:23:17.000000', 'temperatura', 90.0000, 'ºC'),
	(101088, 109, '2015-03-15 00:23:18.000000', 'temperatura', 389.0000, 'ºC'),
	(101089, 109, '2015-03-15 00:23:19.000000', 'temperatura', 474.0000, 'ºC'),
	(101090, 109, '2015-03-15 00:23:20.000000', 'temperatura', 2.0000, 'ºC'),
	(101091, 109, '2015-03-15 00:23:21.000000', 'temperatura', 988.0000, 'ºC'),
	(101092, 109, '2015-03-15 00:23:22.000000', 'temperatura', 136.0000, 'ºC'),
	(101093, 109, '2015-03-15 00:23:23.000000', 'temperatura', 118.0000, 'ºC'),
	(101094, 109, '2015-03-15 00:23:24.000000', 'temperatura', 183.0000, 'ºC'),
	(101095, 109, '2015-03-15 00:23:25.000000', 'temperatura', 559.0000, 'ºC'),
	(101096, 109, '2015-03-15 00:23:26.000000', 'temperatura', 1047.0000, 'ºC'),
	(101097, 109, '2015-03-15 00:23:27.000000', 'temperatura', 1160.0000, 'ºC'),
	(101098, 109, '2015-03-15 00:23:28.000000', 'temperatura', 260.0000, 'ºC'),
	(101099, 109, '2015-03-15 00:23:29.000000', 'temperatura', 221.0000, 'ºC'),
	(101100, 109, '2015-03-15 00:23:30.000000', 'temperatura', 326.0000, 'ºC'),
	(101101, 109, '2015-03-15 00:23:31.000000', 'temperatura', 965.0000, 'ºC'),
	(101102, 109, '2015-03-15 00:23:32.000000', 'temperatura', 249.0000, 'ºC'),
	(101103, 109, '2015-03-15 00:23:33.000000', 'temperatura', 749.0000, 'ºC'),
	(101104, 109, '2015-03-15 00:23:34.000000', 'temperatura', 601.0000, 'ºC'),
	(101105, 109, '2015-03-15 00:23:35.000000', 'temperatura', 759.0000, 'ºC'),
	(101106, 109, '2015-03-15 00:23:36.000000', 'temperatura', 791.0000, 'ºC'),
	(101107, 109, '2015-03-15 00:23:37.000000', 'temperatura', 477.0000, 'ºC'),
	(101108, 109, '2015-03-15 00:23:38.000000', 'temperatura', 14.0000, 'ºC'),
	(101109, 109, '2015-03-15 00:23:39.000000', 'temperatura', 1039.0000, 'ºC'),
	(101110, 109, '2015-03-15 00:23:40.000000', 'temperatura', 353.0000, 'ºC'),
	(101111, 109, '2015-03-15 00:23:41.000000', 'temperatura', 1049.0000, 'ºC'),
	(101112, 109, '2015-03-15 00:23:42.000000', 'temperatura', 586.0000, 'ºC'),
	(101113, 109, '2015-03-15 00:23:43.000000', 'temperatura', 985.0000, 'ºC'),
	(101114, 109, '2015-03-15 00:23:44.000000', 'temperatura', 765.0000, 'ºC'),
	(101115, 109, '2015-03-15 00:23:45.000000', 'temperatura', 874.0000, 'ºC'),
	(101116, 109, '2015-03-15 00:23:46.000000', 'temperatura', 872.0000, 'ºC'),
	(101117, 109, '2015-03-15 00:23:47.000000', 'temperatura', 541.0000, 'ºC'),
	(101118, 109, '2015-03-15 00:23:48.000000', 'temperatura', 87.0000, 'ºC'),
	(101119, 109, '2015-03-15 00:23:49.000000', 'temperatura', 15.0000, 'ºC'),
	(101120, 109, '2015-03-15 00:23:50.000000', 'temperatura', 1012.0000, 'ºC'),
	(101121, 109, '2015-03-15 00:23:51.000000', 'temperatura', 215.0000, 'ºC'),
	(101122, 109, '2015-03-15 00:23:52.000000', 'temperatura', 441.0000, 'ºC'),
	(101123, 109, '2015-03-15 00:23:53.000000', 'temperatura', 358.0000, 'ºC'),
	(101124, 109, '2015-03-15 00:23:54.000000', 'temperatura', 470.0000, 'ºC'),
	(101125, 109, '2015-03-15 00:23:55.000000', 'temperatura', 78.0000, 'ºC'),
	(101126, 109, '2015-03-15 00:23:56.000000', 'temperatura', 179.0000, 'ºC'),
	(101127, 109, '2015-03-15 00:23:57.000000', 'temperatura', 660.0000, 'ºC'),
	(101128, 109, '2015-03-15 00:23:58.000000', 'temperatura', 364.0000, 'ºC'),
	(101129, 109, '2015-03-15 00:23:59.000000', 'temperatura', 1041.0000, 'ºC'),
	(101130, 109, '2015-03-15 00:24:00.000000', 'temperatura', 515.0000, 'ºC'),
	(101131, 109, '2015-03-15 00:24:01.000000', 'temperatura', 651.0000, 'ºC'),
	(101132, 109, '2015-03-15 00:24:02.000000', 'temperatura', 510.0000, 'ºC'),
	(101133, 109, '2015-03-15 00:24:03.000000', 'temperatura', 599.0000, 'ºC'),
	(101134, 109, '2015-03-15 00:24:04.000000', 'temperatura', 264.0000, 'ºC'),
	(101135, 109, '2015-03-15 00:24:05.000000', 'temperatura', 726.0000, 'ºC'),
	(101136, 109, '2015-03-15 00:24:06.000000', 'temperatura', 436.0000, 'ºC'),
	(101137, 109, '2015-03-15 00:24:07.000000', 'temperatura', 4.0000, 'ºC'),
	(101138, 109, '2015-03-15 00:24:08.000000', 'temperatura', 1113.0000, 'ºC'),
	(101139, 109, '2015-03-15 00:24:09.000000', 'temperatura', 752.0000, 'ºC'),
	(101140, 109, '2015-03-15 00:24:10.000000', 'temperatura', 420.0000, 'ºC'),
	(101141, 109, '2015-03-15 00:24:11.000000', 'temperatura', 1046.0000, 'ºC'),
	(101142, 109, '2015-03-15 00:24:12.000000', 'temperatura', 372.0000, 'ºC'),
	(101143, 109, '2015-03-15 00:24:13.000000', 'temperatura', 1120.0000, 'ºC'),
	(101144, 109, '2015-03-15 00:24:14.000000', 'temperatura', 883.0000, 'ºC'),
	(101145, 109, '2015-03-15 00:24:15.000000', 'temperatura', 1059.0000, 'ºC'),
	(101146, 109, '2015-03-15 00:24:16.000000', 'temperatura', 247.0000, 'ºC'),
	(101147, 109, '2015-03-15 00:24:17.000000', 'temperatura', 456.0000, 'ºC'),
	(101148, 109, '2015-03-15 00:24:18.000000', 'temperatura', 339.0000, 'ºC'),
	(101149, 109, '2015-03-15 00:24:19.000000', 'temperatura', 327.0000, 'ºC'),
	(101150, 109, '2015-03-15 00:24:20.000000', 'temperatura', 618.0000, 'ºC'),
	(101151, 109, '2015-03-15 00:24:21.000000', 'temperatura', 912.0000, 'ºC'),
	(101152, 109, '2015-03-15 00:24:22.000000', 'temperatura', 304.0000, 'ºC'),
	(101153, 109, '2015-03-15 00:24:23.000000', 'temperatura', 1186.0000, 'ºC'),
	(101154, 109, '2015-03-15 00:24:24.000000', 'temperatura', 220.0000, 'ºC'),
	(101155, 109, '2015-03-15 00:24:25.000000', 'temperatura', 1142.0000, 'ºC'),
	(101156, 109, '2015-03-15 00:24:26.000000', 'temperatura', 249.0000, 'ºC'),
	(101157, 109, '2015-03-15 00:24:27.000000', 'temperatura', 221.0000, 'ºC'),
	(101158, 109, '2015-03-15 00:24:28.000000', 'temperatura', 356.0000, 'ºC'),
	(101159, 109, '2015-03-15 00:24:29.000000', 'temperatura', 1118.0000, 'ºC'),
	(101160, 109, '2015-03-15 00:24:30.000000', 'temperatura', 925.0000, 'ºC'),
	(101161, 109, '2015-03-15 00:24:31.000000', 'temperatura', 71.0000, 'ºC'),
	(101162, 109, '2015-03-15 00:24:32.000000', 'temperatura', 1179.0000, 'ºC'),
	(101163, 109, '2015-03-15 00:24:33.000000', 'temperatura', 883.0000, 'ºC'),
	(101164, 109, '2015-03-15 00:24:34.000000', 'temperatura', 880.0000, 'ºC'),
	(101165, 109, '2015-03-15 00:24:35.000000', 'temperatura', 552.0000, 'ºC'),
	(101166, 109, '2015-03-15 00:24:36.000000', 'temperatura', 120.0000, 'ºC'),
	(101167, 109, '2015-03-15 00:24:37.000000', 'temperatura', 142.0000, 'ºC'),
	(101168, 109, '2015-03-15 00:24:38.000000', 'temperatura', 352.0000, 'ºC'),
	(101169, 109, '2015-03-15 00:24:39.000000', 'temperatura', 135.0000, 'ºC'),
	(101170, 109, '2015-03-15 00:24:40.000000', 'temperatura', 817.0000, 'ºC'),
	(101171, 109, '2015-03-15 00:24:41.000000', 'temperatura', 82.0000, 'ºC'),
	(101172, 109, '2015-03-15 00:24:42.000000', 'temperatura', 361.0000, 'ºC'),
	(101173, 109, '2015-03-15 00:24:43.000000', 'temperatura', 357.0000, 'ºC'),
	(101174, 109, '2015-03-15 00:24:44.000000', 'temperatura', 704.0000, 'ºC'),
	(101175, 109, '2015-03-15 00:24:45.000000', 'temperatura', 49.0000, 'ºC'),
	(101176, 109, '2015-03-15 00:24:46.000000', 'temperatura', 532.0000, 'ºC'),
	(101177, 109, '2015-03-15 00:24:47.000000', 'temperatura', 115.0000, 'ºC'),
	(101178, 109, '2015-03-15 00:24:48.000000', 'temperatura', 179.0000, 'ºC'),
	(101179, 109, '2015-03-15 00:24:49.000000', 'temperatura', 550.0000, 'ºC'),
	(101180, 109, '2015-03-15 00:24:50.000000', 'temperatura', 1016.0000, 'ºC'),
	(101181, 109, '2015-03-15 00:24:51.000000', 'temperatura', 1029.0000, 'ºC'),
	(101182, 109, '2015-03-15 00:24:52.000000', 'temperatura', 899.0000, 'ºC'),
	(101183, 109, '2015-03-15 00:24:53.000000', 'temperatura', 206.0000, 'ºC'),
	(101184, 109, '2015-03-15 00:24:54.000000', 'temperatura', 735.0000, 'ºC'),
	(101185, 109, '2015-03-15 00:24:55.000000', 'temperatura', 656.0000, 'ºC'),
	(101186, 109, '2015-03-15 00:24:56.000000', 'temperatura', 1077.0000, 'ºC'),
	(101187, 109, '2015-03-15 00:24:57.000000', 'temperatura', 1019.0000, 'ºC'),
	(101188, 109, '2015-03-15 00:24:58.000000', 'temperatura', 661.0000, 'ºC'),
	(101189, 109, '2015-03-15 00:24:59.000000', 'temperatura', 250.0000, 'ºC'),
	(101190, 109, '2015-03-15 00:25:00.000000', 'temperatura', 469.0000, 'ºC'),
	(101191, 109, '2015-03-15 00:25:01.000000', 'temperatura', 395.0000, 'ºC'),
	(101192, 109, '2015-03-15 00:25:02.000000', 'temperatura', 570.0000, 'ºC'),
	(101193, 109, '2015-03-15 00:25:03.000000', 'temperatura', 464.0000, 'ºC'),
	(101194, 109, '2015-03-15 00:25:04.000000', 'temperatura', 608.0000, 'ºC'),
	(101195, 109, '2015-03-15 00:25:05.000000', 'temperatura', 452.0000, 'ºC'),
	(101196, 109, '2015-03-15 00:25:06.000000', 'temperatura', 437.0000, 'ºC'),
	(101197, 109, '2015-03-15 00:25:07.000000', 'temperatura', 829.0000, 'ºC'),
	(101198, 109, '2015-03-15 00:25:08.000000', 'temperatura', 436.0000, 'ºC'),
	(101199, 109, '2015-03-15 00:25:09.000000', 'temperatura', 891.0000, 'ºC'),
	(101200, 109, '2015-03-15 00:25:10.000000', 'temperatura', 750.0000, 'ºC'),
	(101201, 109, '2015-03-15 00:25:11.000000', 'temperatura', 1078.0000, 'ºC'),
	(101202, 109, '2015-03-15 00:25:12.000000', 'temperatura', 740.0000, 'ºC'),
	(101203, 109, '2015-03-15 00:25:13.000000', 'temperatura', 464.0000, 'ºC'),
	(101204, 109, '2015-03-15 00:25:14.000000', 'temperatura', 102.0000, 'ºC'),
	(101205, 109, '2015-03-15 00:25:15.000000', 'temperatura', 318.0000, 'ºC'),
	(101206, 109, '2015-03-15 00:25:16.000000', 'temperatura', 84.0000, 'ºC'),
	(101207, 109, '2015-03-15 00:25:17.000000', 'temperatura', 669.0000, 'ºC'),
	(101208, 109, '2015-03-15 00:25:18.000000', 'temperatura', 691.0000, 'ºC'),
	(101209, 109, '2015-03-15 00:25:19.000000', 'temperatura', 248.0000, 'ºC'),
	(101210, 109, '2015-03-15 00:25:20.000000', 'temperatura', 370.0000, 'ºC'),
	(101211, 109, '2015-03-15 00:25:21.000000', 'temperatura', 1105.0000, 'ºC'),
	(101212, 109, '2015-03-15 00:25:22.000000', 'temperatura', 815.0000, 'ºC'),
	(101213, 109, '2015-03-15 00:25:23.000000', 'temperatura', 760.0000, 'ºC'),
	(101214, 109, '2015-03-15 00:25:24.000000', 'temperatura', 156.0000, 'ºC'),
	(101215, 109, '2015-03-15 00:25:25.000000', 'temperatura', 901.0000, 'ºC'),
	(101216, 109, '2015-03-15 00:25:26.000000', 'temperatura', 436.0000, 'ºC'),
	(101217, 109, '2015-03-15 00:25:27.000000', 'temperatura', 680.0000, 'ºC'),
	(101218, 109, '2015-03-15 00:25:28.000000', 'temperatura', 893.0000, 'ºC'),
	(101219, 109, '2015-03-15 00:25:29.000000', 'temperatura', 25.0000, 'ºC'),
	(101220, 109, '2015-03-15 00:25:30.000000', 'temperatura', 1044.0000, 'ºC'),
	(101221, 109, '2015-03-15 00:25:31.000000', 'temperatura', 348.0000, 'ºC'),
	(101222, 109, '2015-03-15 00:25:32.000000', 'temperatura', 1006.0000, 'ºC'),
	(101223, 109, '2015-03-15 00:25:33.000000', 'temperatura', 388.0000, 'ºC'),
	(101224, 109, '2015-03-15 00:25:34.000000', 'temperatura', 123.0000, 'ºC'),
	(101225, 109, '2015-03-15 00:25:35.000000', 'temperatura', 651.0000, 'ºC'),
	(101226, 109, '2015-03-15 00:25:36.000000', 'temperatura', 485.0000, 'ºC'),
	(101227, 109, '2015-03-15 00:25:37.000000', 'temperatura', 475.0000, 'ºC'),
	(101228, 109, '2015-03-15 00:25:38.000000', 'temperatura', 919.0000, 'ºC'),
	(101229, 109, '2015-03-15 00:25:39.000000', 'temperatura', 770.0000, 'ºC'),
	(101230, 109, '2015-03-15 00:25:40.000000', 'temperatura', 1093.0000, 'ºC'),
	(101231, 109, '2015-03-15 00:25:41.000000', 'temperatura', 756.0000, 'ºC'),
	(101232, 109, '2015-03-15 00:25:42.000000', 'temperatura', 502.0000, 'ºC'),
	(101233, 109, '2015-03-15 00:25:43.000000', 'temperatura', 243.0000, 'ºC'),
	(101234, 109, '2015-03-15 00:25:44.000000', 'temperatura', 908.0000, 'ºC'),
	(101235, 109, '2015-03-15 00:25:45.000000', 'temperatura', 212.0000, 'ºC'),
	(101236, 109, '2015-03-15 00:25:46.000000', 'temperatura', 735.0000, 'ºC'),
	(101237, 109, '2015-03-15 00:25:47.000000', 'temperatura', 641.0000, 'ºC'),
	(101238, 109, '2015-03-15 00:25:48.000000', 'temperatura', 1002.0000, 'ºC'),
	(101239, 109, '2015-03-15 00:25:49.000000', 'temperatura', 685.0000, 'ºC'),
	(101240, 109, '2015-03-15 00:25:50.000000', 'temperatura', 418.0000, 'ºC'),
	(101241, 109, '2015-03-15 00:25:51.000000', 'temperatura', 39.0000, 'ºC'),
	(101242, 109, '2015-03-15 00:25:52.000000', 'temperatura', 142.0000, 'ºC'),
	(101243, 109, '2015-03-15 00:25:53.000000', 'temperatura', 590.0000, 'ºC'),
	(101244, 109, '2015-03-15 00:25:54.000000', 'temperatura', 128.0000, 'ºC'),
	(101245, 109, '2015-03-15 00:25:55.000000', 'temperatura', 70.0000, 'ºC'),
	(101246, 109, '2015-03-15 00:25:56.000000', 'temperatura', 1166.0000, 'ºC'),
	(101247, 109, '2015-03-15 00:25:57.000000', 'temperatura', 819.0000, 'ºC'),
	(101248, 109, '2015-03-15 00:25:58.000000', 'temperatura', 600.0000, 'ºC'),
	(101249, 109, '2015-03-15 00:25:59.000000', 'temperatura', 544.0000, 'ºC'),
	(101250, 109, '2015-03-15 00:26:00.000000', 'temperatura', 921.0000, 'ºC'),
	(101251, 109, '2015-03-15 00:26:01.000000', 'temperatura', 572.0000, 'ºC'),
	(101252, 109, '2015-03-15 00:26:02.000000', 'temperatura', 98.0000, 'ºC'),
	(101253, 109, '2015-03-15 00:26:03.000000', 'temperatura', 1173.0000, 'ºC'),
	(101254, 109, '2015-03-15 00:26:04.000000', 'temperatura', 774.0000, 'ºC'),
	(101255, 109, '2015-03-15 00:26:05.000000', 'temperatura', 349.0000, 'ºC'),
	(101256, 109, '2015-03-15 00:26:06.000000', 'temperatura', 625.0000, 'ºC'),
	(101257, 109, '2015-03-15 00:26:07.000000', 'temperatura', 880.0000, 'ºC'),
	(101258, 109, '2015-03-15 00:26:08.000000', 'temperatura', 124.0000, 'ºC'),
	(101259, 109, '2015-03-15 00:26:09.000000', 'temperatura', 379.0000, 'ºC'),
	(101260, 109, '2015-03-15 00:26:10.000000', 'temperatura', 323.0000, 'ºC'),
	(101261, 109, '2015-03-15 00:26:11.000000', 'temperatura', 479.0000, 'ºC'),
	(101262, 109, '2015-03-15 00:26:12.000000', 'temperatura', 226.0000, 'ºC'),
	(101263, 109, '2015-03-15 00:26:13.000000', 'temperatura', 896.0000, 'ºC'),
	(101264, 109, '2015-03-15 00:26:14.000000', 'temperatura', 202.0000, 'ºC'),
	(101265, 109, '2015-03-15 00:26:15.000000', 'temperatura', 722.0000, 'ºC'),
	(101266, 109, '2015-03-15 00:26:16.000000', 'temperatura', 606.0000, 'ºC'),
	(101267, 109, '2015-03-15 00:26:17.000000', 'temperatura', 866.0000, 'ºC'),
	(101268, 109, '2015-03-15 00:26:18.000000', 'temperatura', 109.0000, 'ºC'),
	(101269, 109, '2015-03-15 00:26:19.000000', 'temperatura', 347.0000, 'ºC'),
	(101270, 109, '2015-03-15 00:26:20.000000', 'temperatura', 211.0000, 'ºC'),
	(101271, 109, '2015-03-15 00:26:21.000000', 'temperatura', 11.0000, 'ºC'),
	(101272, 109, '2015-03-15 00:26:22.000000', 'temperatura', 626.0000, 'ºC'),
	(101273, 109, '2015-03-15 00:26:23.000000', 'temperatura', 697.0000, 'ºC'),
	(101274, 109, '2015-03-15 00:26:24.000000', 'temperatura', 408.0000, 'ºC'),
	(101275, 109, '2015-03-15 00:26:25.000000', 'temperatura', 1147.0000, 'ºC'),
	(101276, 109, '2015-03-15 00:26:26.000000', 'temperatura', 912.0000, 'ºC'),
	(101277, 109, '2015-03-15 00:26:27.000000', 'temperatura', 1120.0000, 'ºC'),
	(101278, 109, '2015-03-15 00:26:28.000000', 'temperatura', 464.0000, 'ºC'),
	(101279, 109, '2015-03-15 00:26:29.000000', 'temperatura', 159.0000, 'ºC'),
	(101280, 109, '2015-03-15 00:26:30.000000', 'temperatura', 607.0000, 'ºC'),
	(101281, 109, '2015-03-15 00:26:31.000000', 'temperatura', 156.0000, 'ºC'),
	(101282, 109, '2015-03-15 00:26:32.000000', 'temperatura', 159.0000, 'ºC'),
	(101283, 109, '2015-03-15 00:26:33.000000', 'temperatura', 329.0000, 'ºC'),
	(101284, 109, '2015-03-15 00:26:34.000000', 'temperatura', 1167.0000, 'ºC'),
	(101285, 109, '2015-03-15 00:26:35.000000', 'temperatura', 48.0000, 'ºC'),
	(101286, 109, '2015-03-15 00:26:36.000000', 'temperatura', 338.0000, 'ºC'),
	(101287, 109, '2015-03-15 00:26:37.000000', 'temperatura', 349.0000, 'ºC'),
	(101288, 109, '2015-03-15 00:26:38.000000', 'temperatura', 733.0000, 'ºC'),
	(101289, 109, '2015-03-15 00:26:39.000000', 'temperatura', 217.0000, 'ºC'),
	(101290, 109, '2015-03-15 00:26:40.000000', 'temperatura', 86.0000, 'ºC'),
	(101291, 109, '2015-03-15 00:26:41.000000', 'temperatura', 982.0000, 'ºC'),
	(101292, 109, '2015-03-15 00:26:42.000000', 'temperatura', 1051.0000, 'ºC'),
	(101293, 109, '2015-03-15 00:26:43.000000', 'temperatura', 1110.0000, 'ºC'),
	(101294, 109, '2015-03-15 00:26:44.000000', 'temperatura', 1196.0000, 'ºC'),
	(101295, 109, '2015-03-15 00:26:45.000000', 'temperatura', 253.0000, 'ºC'),
	(101296, 109, '2015-03-15 00:26:46.000000', 'temperatura', 74.0000, 'ºC'),
	(101297, 109, '2015-03-15 00:26:47.000000', 'temperatura', 814.0000, 'ºC'),
	(101298, 109, '2015-03-15 00:26:48.000000', 'temperatura', 249.0000, 'ºC'),
	(101299, 109, '2015-03-15 00:26:49.000000', 'temperatura', 1.0000, 'ºC'),
	(101300, 109, '2015-03-15 00:26:50.000000', 'temperatura', 458.0000, 'ºC'),
	(101301, 109, '2015-03-15 00:26:51.000000', 'temperatura', 1089.0000, 'ºC'),
	(101302, 109, '2015-03-15 00:26:52.000000', 'temperatura', 471.0000, 'ºC'),
	(101303, 109, '2015-03-15 00:26:53.000000', 'temperatura', 287.0000, 'ºC'),
	(101304, 109, '2015-03-15 00:26:54.000000', 'temperatura', 23.0000, 'ºC'),
	(101305, 109, '2015-03-15 00:26:55.000000', 'temperatura', 454.0000, 'ºC'),
	(101306, 109, '2015-03-15 00:26:56.000000', 'temperatura', 1003.0000, 'ºC'),
	(101307, 109, '2015-03-15 00:26:57.000000', 'temperatura', 53.0000, 'ºC'),
	(101308, 109, '2015-03-15 00:26:58.000000', 'temperatura', 855.0000, 'ºC'),
	(101309, 109, '2015-03-15 00:26:59.000000', 'temperatura', 516.0000, 'ºC'),
	(101310, 109, '2015-03-15 00:27:00.000000', 'temperatura', 15.0000, 'ºC'),
	(101311, 109, '2015-03-15 00:27:01.000000', 'temperatura', 927.0000, 'ºC'),
	(101312, 109, '2015-03-15 00:27:02.000000', 'temperatura', 993.0000, 'ºC'),
	(101313, 109, '2015-03-15 00:27:03.000000', 'temperatura', 984.0000, 'ºC'),
	(101314, 109, '2015-03-15 00:27:04.000000', 'temperatura', 741.0000, 'ºC'),
	(101315, 109, '2015-03-15 00:27:05.000000', 'temperatura', 753.0000, 'ºC'),
	(101316, 109, '2015-03-15 00:27:06.000000', 'temperatura', 342.0000, 'ºC'),
	(101317, 109, '2015-03-15 00:27:07.000000', 'temperatura', 652.0000, 'ºC'),
	(101318, 109, '2015-03-15 00:27:08.000000', 'temperatura', 1033.0000, 'ºC'),
	(101319, 109, '2015-03-15 00:27:09.000000', 'temperatura', 813.0000, 'ºC'),
	(101320, 109, '2015-03-15 00:27:10.000000', 'temperatura', 963.0000, 'ºC'),
	(101321, 109, '2015-03-15 00:27:11.000000', 'temperatura', 1176.0000, 'ºC'),
	(101322, 109, '2015-03-15 00:27:12.000000', 'temperatura', 595.0000, 'ºC'),
	(101323, 109, '2015-03-15 00:27:13.000000', 'temperatura', 645.0000, 'ºC'),
	(101324, 109, '2015-03-15 00:27:14.000000', 'temperatura', 242.0000, 'ºC'),
	(101325, 109, '2015-03-15 00:27:15.000000', 'temperatura', 475.0000, 'ºC'),
	(101326, 109, '2015-03-15 00:27:16.000000', 'temperatura', 451.0000, 'ºC'),
	(101327, 109, '2015-03-15 00:27:17.000000', 'temperatura', 829.0000, 'ºC'),
	(101328, 109, '2015-03-15 00:27:18.000000', 'temperatura', 393.0000, 'ºC'),
	(101329, 109, '2015-03-15 00:27:19.000000', 'temperatura', 677.0000, 'ºC'),
	(101330, 109, '2015-03-15 00:27:20.000000', 'temperatura', 1008.0000, 'ºC'),
	(101331, 109, '2015-03-15 00:27:21.000000', 'temperatura', 609.0000, 'ºC'),
	(101332, 109, '2015-03-15 00:27:22.000000', 'temperatura', 21.0000, 'ºC'),
	(101333, 109, '2015-03-15 00:27:23.000000', 'temperatura', 678.0000, 'ºC'),
	(101334, 109, '2015-03-15 00:27:24.000000', 'temperatura', 928.0000, 'ºC'),
	(101335, 109, '2015-03-15 00:27:25.000000', 'temperatura', 206.0000, 'ºC'),
	(101336, 109, '2015-03-15 00:27:26.000000', 'temperatura', 648.0000, 'ºC'),
	(101337, 109, '2015-03-15 00:27:27.000000', 'temperatura', 220.0000, 'ºC'),
	(101338, 109, '2015-03-15 00:27:28.000000', 'temperatura', 358.0000, 'ºC'),
	(101339, 109, '2015-03-15 00:27:29.000000', 'temperatura', 1132.0000, 'ºC'),
	(101340, 109, '2015-03-15 00:27:30.000000', 'temperatura', 987.0000, 'ºC'),
	(101341, 109, '2015-03-15 00:27:31.000000', 'temperatura', 337.0000, 'ºC'),
	(101342, 109, '2015-03-15 00:27:32.000000', 'temperatura', 1124.0000, 'ºC'),
	(101343, 109, '2015-03-15 00:27:33.000000', 'temperatura', 1011.0000, 'ºC'),
	(101344, 109, '2015-03-15 00:27:34.000000', 'temperatura', 485.0000, 'ºC'),
	(101345, 109, '2015-03-15 00:27:35.000000', 'temperatura', 592.0000, 'ºC'),
	(101346, 109, '2015-03-15 00:27:36.000000', 'temperatura', 306.0000, 'ºC'),
	(101347, 109, '2015-03-15 00:27:37.000000', 'temperatura', 956.0000, 'ºC'),
	(101348, 109, '2015-03-15 00:27:38.000000', 'temperatura', 261.0000, 'ºC'),
	(101349, 109, '2015-03-15 00:27:39.000000', 'temperatura', 835.0000, 'ºC'),
	(101350, 109, '2015-03-15 00:27:40.000000', 'temperatura', 996.0000, 'ºC'),
	(101351, 109, '2015-03-15 00:27:41.000000', 'temperatura', 74.0000, 'ºC'),
	(101352, 109, '2015-03-15 00:27:42.000000', 'temperatura', 984.0000, 'ºC'),
	(101353, 109, '2015-03-15 00:27:43.000000', 'temperatura', 1097.0000, 'ºC'),
	(101354, 109, '2015-03-15 00:27:44.000000', 'temperatura', 135.0000, 'ºC'),
	(101355, 109, '2015-03-15 00:27:45.000000', 'temperatura', 983.0000, 'ºC'),
	(101356, 109, '2015-03-15 00:27:46.000000', 'temperatura', 912.0000, 'ºC'),
	(101357, 109, '2015-03-15 00:27:47.000000', 'temperatura', 412.0000, 'ºC'),
	(101358, 109, '2015-03-15 00:27:48.000000', 'temperatura', 524.0000, 'ºC'),
	(101359, 109, '2015-03-15 00:27:49.000000', 'temperatura', 182.0000, 'ºC'),
	(101360, 109, '2015-03-15 00:27:50.000000', 'temperatura', 541.0000, 'ºC'),
	(101361, 109, '2015-03-15 00:27:51.000000', 'temperatura', 958.0000, 'ºC'),
	(101362, 109, '2015-03-15 00:27:52.000000', 'temperatura', 770.0000, 'ºC'),
	(101363, 109, '2015-03-15 00:27:53.000000', 'temperatura', 974.0000, 'ºC'),
	(101364, 109, '2015-03-15 00:27:54.000000', 'temperatura', 163.0000, 'ºC'),
	(101365, 109, '2015-03-15 00:27:55.000000', 'temperatura', 290.0000, 'ºC'),
	(101366, 109, '2015-03-15 00:27:56.000000', 'temperatura', 964.0000, 'ºC'),
	(101367, 109, '2015-03-15 00:27:57.000000', 'temperatura', 351.0000, 'ºC'),
	(101368, 109, '2015-03-15 00:27:58.000000', 'temperatura', 61.0000, 'ºC'),
	(101369, 109, '2015-03-15 00:27:59.000000', 'temperatura', 455.0000, 'ºC'),
	(101370, 109, '2015-03-15 00:28:00.000000', 'temperatura', 893.0000, 'ºC'),
	(101371, 109, '2015-03-15 00:28:01.000000', 'temperatura', 701.0000, 'ºC'),
	(101372, 109, '2015-03-15 00:28:02.000000', 'temperatura', 825.0000, 'ºC'),
	(101373, 109, '2015-03-15 00:28:03.000000', 'temperatura', 822.0000, 'ºC'),
	(101374, 109, '2015-03-15 00:28:04.000000', 'temperatura', 436.0000, 'ºC'),
	(101375, 109, '2015-03-15 00:28:05.000000', 'temperatura', 914.0000, 'ºC'),
	(101376, 109, '2015-03-15 00:28:06.000000', 'temperatura', 862.0000, 'ºC'),
	(101377, 109, '2015-03-15 00:28:07.000000', 'temperatura', 368.0000, 'ºC'),
	(101378, 109, '2015-03-15 00:28:08.000000', 'temperatura', 454.0000, 'ºC'),
	(101379, 109, '2015-03-15 00:28:09.000000', 'temperatura', 1167.0000, 'ºC'),
	(101380, 109, '2015-03-15 00:28:10.000000', 'temperatura', 873.0000, 'ºC'),
	(101381, 109, '2015-03-15 00:28:11.000000', 'temperatura', 867.0000, 'ºC'),
	(101382, 109, '2015-03-15 00:28:12.000000', 'temperatura', 516.0000, 'ºC'),
	(101383, 109, '2015-03-15 00:28:13.000000', 'temperatura', 1178.0000, 'ºC'),
	(101384, 109, '2015-03-15 00:28:14.000000', 'temperatura', 744.0000, 'ºC'),
	(101385, 109, '2015-03-15 00:28:15.000000', 'temperatura', 186.0000, 'ºC'),
	(101386, 109, '2015-03-15 00:28:16.000000', 'temperatura', 1096.0000, 'ºC'),
	(101387, 109, '2015-03-15 00:28:17.000000', 'temperatura', 126.0000, 'ºC'),
	(101388, 109, '2015-03-15 00:28:18.000000', 'temperatura', 940.0000, 'ºC'),
	(101389, 109, '2015-03-15 00:28:19.000000', 'temperatura', 722.0000, 'ºC'),
	(101390, 109, '2015-03-15 00:28:20.000000', 'temperatura', 791.0000, 'ºC'),
	(101391, 109, '2015-03-15 00:28:21.000000', 'temperatura', 588.0000, 'ºC'),
	(101392, 109, '2015-03-15 00:28:22.000000', 'temperatura', 567.0000, 'ºC'),
	(101393, 109, '2015-03-15 00:28:23.000000', 'temperatura', 1075.0000, 'ºC'),
	(101394, 109, '2015-03-15 00:28:24.000000', 'temperatura', 72.0000, 'ºC'),
	(101395, 109, '2015-03-15 00:28:25.000000', 'temperatura', 735.0000, 'ºC'),
	(101396, 109, '2015-03-15 00:28:26.000000', 'temperatura', 1058.0000, 'ºC'),
	(101397, 109, '2015-03-15 00:28:27.000000', 'temperatura', 688.0000, 'ºC'),
	(101398, 109, '2015-03-15 00:28:28.000000', 'temperatura', 265.0000, 'ºC'),
	(101399, 109, '2015-03-15 00:28:29.000000', 'temperatura', 462.0000, 'ºC'),
	(101400, 109, '2015-03-15 00:28:30.000000', 'temperatura', 317.0000, 'ºC'),
	(101401, 109, '2015-03-15 00:28:31.000000', 'temperatura', 198.0000, 'ºC'),
	(101402, 109, '2015-03-15 00:28:32.000000', 'temperatura', 42.0000, 'ºC'),
	(101403, 109, '2015-03-15 00:28:33.000000', 'temperatura', 813.0000, 'ºC'),
	(101404, 109, '2015-03-15 00:28:34.000000', 'temperatura', 343.0000, 'ºC'),
	(101405, 109, '2015-03-15 00:28:35.000000', 'temperatura', 473.0000, 'ºC'),
	(101406, 109, '2015-03-15 00:28:36.000000', 'temperatura', 139.0000, 'ºC'),
	(101407, 109, '2015-03-15 00:28:37.000000', 'temperatura', 475.0000, 'ºC'),
	(101408, 109, '2015-03-15 00:28:38.000000', 'temperatura', 757.0000, 'ºC'),
	(101409, 109, '2015-03-15 00:28:39.000000', 'temperatura', 1164.0000, 'ºC'),
	(101410, 109, '2015-03-15 00:28:40.000000', 'temperatura', 1148.0000, 'ºC'),
	(101411, 109, '2015-03-15 00:28:41.000000', 'temperatura', 1048.0000, 'ºC'),
	(101412, 109, '2015-03-15 00:28:42.000000', 'temperatura', 598.0000, 'ºC'),
	(101413, 109, '2015-03-15 00:28:43.000000', 'temperatura', 1044.0000, 'ºC'),
	(101414, 109, '2015-03-15 00:28:44.000000', 'temperatura', 1027.0000, 'ºC'),
	(101415, 109, '2015-03-15 00:28:45.000000', 'temperatura', 805.0000, 'ºC'),
	(101416, 109, '2015-03-15 00:28:46.000000', 'temperatura', 945.0000, 'ºC'),
	(101417, 109, '2015-03-15 00:28:47.000000', 'temperatura', 1111.0000, 'ºC'),
	(101418, 109, '2015-03-15 00:28:48.000000', 'temperatura', 319.0000, 'ºC'),
	(101419, 109, '2015-03-15 00:28:49.000000', 'temperatura', 665.0000, 'ºC'),
	(101420, 109, '2015-03-15 00:28:50.000000', 'temperatura', 1167.0000, 'ºC'),
	(101421, 109, '2015-03-15 00:28:51.000000', 'temperatura', 241.0000, 'ºC'),
	(101422, 109, '2015-03-15 00:28:52.000000', 'temperatura', 103.0000, 'ºC'),
	(101423, 109, '2015-03-15 00:28:53.000000', 'temperatura', 992.0000, 'ºC'),
	(101424, 109, '2015-03-15 00:28:54.000000', 'temperatura', 1053.0000, 'ºC'),
	(101425, 109, '2015-03-15 00:28:55.000000', 'temperatura', 1091.0000, 'ºC'),
	(101426, 109, '2015-03-15 00:28:56.000000', 'temperatura', 1095.0000, 'ºC'),
	(101427, 109, '2015-03-15 00:28:57.000000', 'temperatura', 1001.0000, 'ºC'),
	(101428, 109, '2015-03-15 00:28:58.000000', 'temperatura', 522.0000, 'ºC'),
	(101429, 109, '2015-03-15 00:28:59.000000', 'temperatura', 807.0000, 'ºC'),
	(101430, 109, '2015-03-15 00:29:00.000000', 'temperatura', 70.0000, 'ºC'),
	(101431, 109, '2015-03-15 00:29:01.000000', 'temperatura', 329.0000, 'ºC'),
	(101432, 109, '2015-03-15 00:29:02.000000', 'temperatura', 236.0000, 'ºC'),
	(101433, 109, '2015-03-15 00:29:03.000000', 'temperatura', 191.0000, 'ºC'),
	(101434, 109, '2015-03-15 00:29:04.000000', 'temperatura', 251.0000, 'ºC'),
	(101435, 109, '2015-03-15 00:29:05.000000', 'temperatura', 680.0000, 'ºC'),
	(101436, 109, '2015-03-15 00:29:06.000000', 'temperatura', 247.0000, 'ºC'),
	(101437, 109, '2015-03-15 00:29:07.000000', 'temperatura', 397.0000, 'ºC'),
	(101438, 109, '2015-03-15 00:29:08.000000', 'temperatura', 46.0000, 'ºC'),
	(101439, 109, '2015-03-15 00:29:09.000000', 'temperatura', 236.0000, 'ºC'),
	(101440, 109, '2015-03-15 00:29:10.000000', 'temperatura', 1046.0000, 'ºC'),
	(101441, 109, '2015-03-15 00:29:11.000000', 'temperatura', 919.0000, 'ºC'),
	(101442, 109, '2015-03-15 00:29:12.000000', 'temperatura', 259.0000, 'ºC'),
	(101443, 109, '2015-03-15 00:29:13.000000', 'temperatura', 939.0000, 'ºC'),
	(101444, 109, '2015-03-15 00:29:14.000000', 'temperatura', 320.0000, 'ºC'),
	(101445, 109, '2015-03-15 00:29:15.000000', 'temperatura', 1182.0000, 'ºC'),
	(101446, 109, '2015-03-15 00:29:16.000000', 'temperatura', 149.0000, 'ºC'),
	(101447, 109, '2015-03-15 00:29:17.000000', 'temperatura', 802.0000, 'ºC'),
	(101448, 109, '2015-03-15 00:29:18.000000', 'temperatura', 1163.0000, 'ºC'),
	(101449, 109, '2015-03-15 00:29:19.000000', 'temperatura', 1009.0000, 'ºC'),
	(101450, 109, '2015-03-15 00:29:20.000000', 'temperatura', 355.0000, 'ºC'),
	(101451, 109, '2015-03-15 00:29:21.000000', 'temperatura', 1149.0000, 'ºC'),
	(101452, 109, '2015-03-15 00:29:22.000000', 'temperatura', 1082.0000, 'ºC'),
	(101453, 109, '2015-03-15 00:29:23.000000', 'temperatura', 763.0000, 'ºC'),
	(101454, 109, '2015-03-15 00:29:24.000000', 'temperatura', 571.0000, 'ºC'),
	(101455, 109, '2015-03-15 00:29:25.000000', 'temperatura', 567.0000, 'ºC'),
	(101456, 109, '2015-03-15 00:29:26.000000', 'temperatura', 1120.0000, 'ºC'),
	(101457, 109, '2015-03-15 00:29:27.000000', 'temperatura', 302.0000, 'ºC'),
	(101458, 109, '2015-03-15 00:29:28.000000', 'temperatura', 547.0000, 'ºC'),
	(101459, 109, '2015-03-15 00:29:29.000000', 'temperatura', 632.0000, 'ºC'),
	(101460, 109, '2015-03-15 00:29:30.000000', 'temperatura', 321.0000, 'ºC'),
	(101461, 109, '2015-03-15 00:29:31.000000', 'temperatura', 907.0000, 'ºC'),
	(101462, 109, '2015-03-15 00:29:32.000000', 'temperatura', 1172.0000, 'ºC'),
	(101463, 109, '2015-03-15 00:29:33.000000', 'temperatura', 739.0000, 'ºC'),
	(101464, 109, '2015-03-15 00:29:34.000000', 'temperatura', 180.0000, 'ºC'),
	(101465, 109, '2015-03-15 00:29:35.000000', 'temperatura', 1085.0000, 'ºC'),
	(101466, 109, '2015-03-15 00:29:36.000000', 'temperatura', 85.0000, 'ºC'),
	(101467, 109, '2015-03-15 00:29:37.000000', 'temperatura', 772.0000, 'ºC'),
	(101468, 109, '2015-03-15 00:29:38.000000', 'temperatura', 3.0000, 'ºC'),
	(101469, 109, '2015-03-15 00:29:39.000000', 'temperatura', 102.0000, 'ºC'),
	(101470, 109, '2015-03-15 00:29:40.000000', 'temperatura', 502.0000, 'ºC'),
	(101471, 109, '2015-03-15 00:29:41.000000', 'temperatura', 1005.0000, 'ºC'),
	(101472, 109, '2015-03-15 00:29:42.000000', 'temperatura', 1120.0000, 'ºC'),
	(101473, 109, '2015-03-15 00:29:43.000000', 'temperatura', 182.0000, 'ºC'),
	(101474, 109, '2015-03-15 00:29:44.000000', 'temperatura', 1154.0000, 'ºC'),
	(101475, 109, '2015-03-15 00:29:45.000000', 'temperatura', 424.0000, 'ºC'),
	(101476, 109, '2015-03-15 00:29:46.000000', 'temperatura', 1059.0000, 'ºC'),
	(101477, 109, '2015-03-15 00:29:47.000000', 'temperatura', 424.0000, 'ºC'),
	(101478, 109, '2015-03-15 00:29:48.000000', 'temperatura', 141.0000, 'ºC'),
	(101479, 109, '2015-03-15 00:29:49.000000', 'temperatura', 633.0000, 'ºC'),
	(101480, 109, '2015-03-15 00:29:50.000000', 'temperatura', 342.0000, 'ºC'),
	(101481, 109, '2015-03-15 00:29:51.000000', 'temperatura', 1014.0000, 'ºC'),
	(101482, 109, '2015-03-15 00:29:52.000000', 'temperatura', 443.0000, 'ºC'),
	(101483, 109, '2015-03-15 00:29:53.000000', 'temperatura', 376.0000, 'ºC'),
	(101484, 109, '2015-03-15 00:29:54.000000', 'temperatura', 549.0000, 'ºC'),
	(101485, 109, '2015-03-15 00:29:55.000000', 'temperatura', 417.0000, 'ºC'),
	(101486, 109, '2015-03-15 00:29:56.000000', 'temperatura', 440.0000, 'ºC'),
	(101487, 109, '2015-03-15 00:29:57.000000', 'temperatura', 949.0000, 'ºC'),
	(101488, 109, '2015-03-15 00:29:58.000000', 'temperatura', 1027.0000, 'ºC'),
	(101489, 109, '2015-03-15 00:29:59.000000', 'temperatura', 1087.0000, 'ºC'),
	(101490, 109, '2015-03-15 00:30:00.000000', 'temperatura', 1153.0000, 'ºC'),
	(101491, 109, '2015-03-15 00:30:01.000000', 'temperatura', 106.0000, 'ºC'),
	(101492, 109, '2015-03-15 00:30:02.000000', 'temperatura', 673.0000, 'ºC'),
	(101493, 109, '2015-03-15 00:30:03.000000', 'temperatura', 645.0000, 'ºC'),
	(101494, 109, '2015-03-15 00:30:04.000000', 'temperatura', 9.0000, 'ºC'),
	(101495, 109, '2015-03-15 00:30:05.000000', 'temperatura', 510.0000, 'ºC'),
	(101496, 109, '2015-03-15 00:30:06.000000', 'temperatura', 125.0000, 'ºC'),
	(101497, 109, '2015-03-15 00:30:07.000000', 'temperatura', 294.0000, 'ºC'),
	(101498, 109, '2015-03-15 00:30:08.000000', 'temperatura', 1094.0000, 'ºC'),
	(101499, 109, '2015-03-15 00:30:09.000000', 'temperatura', 990.0000, 'ºC'),
	(101500, 109, '2015-03-15 00:30:10.000000', 'temperatura', 469.0000, 'ºC'),
	(101501, 109, '2015-03-15 00:30:11.000000', 'temperatura', 573.0000, 'ºC'),
	(101502, 109, '2015-03-15 00:30:12.000000', 'temperatura', 261.0000, 'ºC'),
	(101503, 109, '2015-03-15 00:30:13.000000', 'temperatura', 788.0000, 'ºC'),
	(101504, 109, '2015-03-15 00:30:14.000000', 'temperatura', 755.0000, 'ºC'),
	(101505, 109, '2015-03-15 00:30:15.000000', 'temperatura', 210.0000, 'ºC'),
	(101506, 109, '2015-03-15 00:30:16.000000', 'temperatura', 1187.0000, 'ºC'),
	(101507, 109, '2015-03-15 00:30:17.000000', 'temperatura', 506.0000, 'ºC'),
	(101508, 109, '2015-03-15 00:30:18.000000', 'temperatura', 171.0000, 'ºC'),
	(101509, 109, '2015-03-15 00:30:19.000000', 'temperatura', 537.0000, 'ºC'),
	(101510, 109, '2015-03-15 00:30:20.000000', 'temperatura', 970.0000, 'ºC'),
	(101511, 109, '2015-03-15 00:30:21.000000', 'temperatura', 842.0000, 'ºC'),
	(101512, 109, '2015-03-15 00:30:22.000000', 'temperatura', 99.0000, 'ºC'),
	(101513, 109, '2015-03-15 00:30:23.000000', 'temperatura', 372.0000, 'ºC'),
	(101514, 109, '2015-03-15 00:30:24.000000', 'temperatura', 361.0000, 'ºC'),
	(101515, 109, '2015-03-15 00:30:25.000000', 'temperatura', 689.0000, 'ºC'),
	(101516, 109, '2015-03-15 00:30:26.000000', 'temperatura', 1163.0000, 'ºC'),
	(101517, 109, '2015-03-15 00:30:27.000000', 'temperatura', 151.0000, 'ºC'),
	(101518, 109, '2015-03-15 00:30:28.000000', 'temperatura', 864.0000, 'ºC'),
	(101519, 109, '2015-03-15 00:30:29.000000', 'temperatura', 270.0000, 'ºC'),
	(101520, 109, '2015-03-15 00:30:30.000000', 'temperatura', 1157.0000, 'ºC'),
	(101521, 109, '2015-03-15 00:30:31.000000', 'temperatura', 174.0000, 'ºC'),
	(101522, 109, '2015-03-15 00:30:32.000000', 'temperatura', 1000.0000, 'ºC'),
	(101523, 109, '2015-03-15 00:30:33.000000', 'temperatura', 878.0000, 'ºC'),
	(101524, 109, '2015-03-15 00:30:34.000000', 'temperatura', 189.0000, 'ºC'),
	(101525, 109, '2015-03-15 00:30:35.000000', 'temperatura', 713.0000, 'ºC'),
	(101526, 109, '2015-03-15 00:30:36.000000', 'temperatura', 600.0000, 'ºC'),
	(101527, 109, '2015-03-15 00:30:37.000000', 'temperatura', 859.0000, 'ºC'),
	(101528, 109, '2015-03-15 00:30:38.000000', 'temperatura', 95.0000, 'ºC'),
	(101529, 109, '2015-03-15 00:30:39.000000', 'temperatura', 300.0000, 'ºC'),
	(101530, 109, '2015-03-15 00:30:40.000000', 'temperatura', 17.0000, 'ºC'),
	(101531, 109, '2015-03-15 00:30:41.000000', 'temperatura', 384.0000, 'ºC'),
	(101532, 109, '2015-03-15 00:30:42.000000', 'temperatura', 669.0000, 'ºC'),
	(101533, 109, '2015-03-15 00:30:43.000000', 'temperatura', 994.0000, 'ºC'),
	(101534, 109, '2015-03-15 00:30:44.000000', 'temperatura', 562.0000, 'ºC'),
	(101535, 109, '2015-03-15 00:30:45.000000', 'temperatura', 1029.0000, 'ºC'),
	(101536, 109, '2015-03-15 00:30:46.000000', 'temperatura', 1061.0000, 'ºC'),
	(101537, 109, '2015-03-15 00:30:47.000000', 'temperatura', 1019.0000, 'ºC'),
	(101538, 109, '2015-03-15 00:30:48.000000', 'temperatura', 713.0000, 'ºC'),
	(101539, 109, '2015-03-15 00:30:49.000000', 'temperatura', 507.0000, 'ºC'),
	(101540, 109, '2015-03-15 00:30:50.000000', 'temperatura', 395.0000, 'ºC'),
	(101541, 109, '2015-03-15 00:30:51.000000', 'temperatura', 455.0000, 'ºC'),
	(101542, 109, '2015-03-15 00:30:52.000000', 'temperatura', 1091.0000, 'ºC'),
	(101543, 109, '2015-03-15 00:30:53.000000', 'temperatura', 490.0000, 'ºC'),
	(101544, 109, '2015-03-15 00:30:54.000000', 'temperatura', 376.0000, 'ºC'),
	(101545, 109, '2015-03-15 00:30:55.000000', 'temperatura', 413.0000, 'ºC'),
	(101546, 109, '2015-03-15 00:30:56.000000', 'temperatura', 938.0000, 'ºC'),
	(101547, 109, '2015-03-15 00:30:57.000000', 'temperatura', 1050.0000, 'ºC'),
	(101548, 109, '2015-03-15 00:30:58.000000', 'temperatura', 36.0000, 'ºC'),
	(101549, 109, '2015-03-15 00:30:59.000000', 'temperatura', 631.0000, 'ºC'),
	(101550, 109, '2015-03-15 00:31:00.000000', 'temperatura', 646.0000, 'ºC'),
	(101551, 109, '2015-03-15 00:31:01.000000', 'temperatura', 141.0000, 'ºC'),
	(101552, 109, '2015-03-15 00:31:02.000000', 'temperatura', 1164.0000, 'ºC'),
	(101553, 109, '2015-03-15 00:31:03.000000', 'temperatura', 600.0000, 'ºC'),
	(101554, 109, '2015-03-15 00:31:04.000000', 'temperatura', 708.0000, 'ºC'),
	(101555, 109, '2015-03-15 00:31:05.000000', 'temperatura', 539.0000, 'ºC'),
	(101556, 109, '2015-03-15 00:31:06.000000', 'temperatura', 574.0000, 'ºC'),
	(101557, 109, '2015-03-15 00:31:07.000000', 'temperatura', 53.0000, 'ºC'),
	(101558, 109, '2015-03-15 00:31:08.000000', 'temperatura', 945.0000, 'ºC'),
	(101559, 109, '2015-03-15 00:31:09.000000', 'temperatura', 965.0000, 'ºC'),
	(101560, 109, '2015-03-15 00:31:10.000000', 'temperatura', 791.0000, 'ºC'),
	(101561, 109, '2015-03-15 00:31:11.000000', 'temperatura', 1058.0000, 'ºC'),
	(101562, 109, '2015-03-15 00:31:12.000000', 'temperatura', 521.0000, 'ºC'),
	(101563, 109, '2015-03-15 00:31:13.000000', 'temperatura', 631.0000, 'ºC'),
	(101564, 109, '2015-03-15 00:31:14.000000', 'temperatura', 391.0000, 'ºC'),
	(101565, 109, '2015-03-15 00:31:15.000000', 'temperatura', 65.0000, 'ºC'),
	(101566, 109, '2015-03-15 00:31:16.000000', 'temperatura', 351.0000, 'ºC'),
	(101567, 109, '2015-03-15 00:31:17.000000', 'temperatura', 363.0000, 'ºC'),
	(101568, 109, '2015-03-15 00:31:18.000000', 'temperatura', 760.0000, 'ºC'),
	(101569, 109, '2015-03-15 00:31:19.000000', 'temperatura', 312.0000, 'ºC'),
	(101570, 109, '2015-03-15 00:31:20.000000', 'temperatura', 479.0000, 'ºC'),
	(101571, 109, '2015-03-15 00:31:21.000000', 'temperatura', 259.0000, 'ºC'),
	(101572, 109, '2015-03-15 00:31:22.000000', 'temperatura', 1060.0000, 'ºC'),
	(101573, 109, '2015-03-15 00:31:23.000000', 'temperatura', 921.0000, 'ºC'),
	(101574, 109, '2015-03-15 00:31:24.000000', 'temperatura', 228.0000, 'ºC'),
	(101575, 109, '2015-03-15 00:31:25.000000', 'temperatura', 778.0000, 'ºC'),
	(101576, 109, '2015-03-15 00:31:26.000000', 'temperatura', 806.0000, 'ºC'),
	(101577, 109, '2015-03-15 00:31:27.000000', 'temperatura', 497.0000, 'ºC'),
	(101578, 109, '2015-03-15 00:31:28.000000', 'temperatura', 65.0000, 'ºC'),
	(101579, 109, '2015-03-15 00:31:29.000000', 'temperatura', 37.0000, 'ºC'),
	(101580, 109, '2015-03-15 00:31:30.000000', 'temperatura', 1189.0000, 'ºC'),
	(101581, 109, '2015-03-15 00:31:31.000000', 'temperatura', 1036.0000, 'ºC'),
	(101582, 109, '2015-03-15 00:31:32.000000', 'temperatura', 413.0000, 'ºC'),
	(101583, 109, '2015-03-15 00:31:33.000000', 'temperatura', 159.0000, 'ºC'),
	(101584, 109, '2015-03-15 00:31:34.000000', 'temperatura', 757.0000, 'ºC'),
	(101585, 109, '2015-03-15 00:31:35.000000', 'temperatura', 905.0000, 'ºC'),
	(101586, 109, '2015-03-15 00:31:36.000000', 'temperatura', 1058.0000, 'ºC'),
	(101587, 109, '2015-03-15 00:31:37.000000', 'temperatura', 174.0000, 'ºC'),
	(101588, 109, '2015-03-15 00:31:38.000000', 'temperatura', 98.0000, 'ºC'),
	(101589, 109, '2015-03-15 00:31:39.000000', 'temperatura', 1165.0000, 'ºC'),
	(101590, 109, '2015-03-15 00:31:40.000000', 'temperatura', 735.0000, 'ºC'),
	(101591, 109, '2015-03-15 00:31:41.000000', 'temperatura', 180.0000, 'ºC'),
	(101592, 109, '2015-03-15 00:31:42.000000', 'temperatura', 1097.0000, 'ºC'),
	(101593, 109, '2015-03-15 00:31:43.000000', 'temperatura', 144.0000, 'ºC'),
	(101594, 109, '2015-03-15 00:31:44.000000', 'temperatura', 1031.0000, 'ºC'),
	(101595, 109, '2015-03-15 00:31:45.000000', 'temperatura', 1124.0000, 'ºC'),
	(101596, 109, '2015-03-15 00:31:46.000000', 'temperatura', 125.0000, 'ºC'),
	(101597, 109, '2015-03-15 00:31:47.000000', 'temperatura', 855.0000, 'ºC'),
	(101598, 109, '2015-03-15 00:31:48.000000', 'temperatura', 301.0000, 'ºC'),
	(101599, 109, '2015-03-15 00:31:49.000000', 'temperatura', 139.0000, 'ºC'),
	(101600, 109, '2015-03-15 00:31:50.000000', 'temperatura', 993.0000, 'ºC'),
	(101601, 109, '2015-03-15 00:31:51.000000', 'temperatura', 947.0000, 'ºC'),
	(101602, 109, '2015-03-15 00:31:52.000000', 'temperatura', 559.0000, 'ºC'),
	(101603, 109, '2015-03-15 00:31:53.000000', 'temperatura', 1152.0000, 'ºC'),
	(101604, 109, '2015-03-15 00:31:54.000000', 'temperatura', 485.0000, 'ºC'),
	(101605, 109, '2015-03-15 00:31:55.000000', 'temperatura', 170.0000, 'ºC'),
	(101606, 109, '2015-03-15 00:31:56.000000', 'temperatura', 597.0000, 'ºC'),
	(101607, 109, '2015-03-15 00:31:57.000000', 'temperatura', 72.0000, 'ºC'),
	(101608, 109, '2015-03-15 00:31:58.000000', 'temperatura', 971.0000, 'ºC'),
	(101609, 109, '2015-03-15 00:31:59.000000', 'temperatura', 1040.0000, 'ºC'),
	(101610, 109, '2015-03-15 00:32:00.000000', 'temperatura', 1087.0000, 'ºC'),
	(101611, 109, '2015-03-15 00:32:01.000000', 'temperatura', 1114.0000, 'ºC'),
	(101612, 109, '2015-03-15 00:32:02.000000', 'temperatura', 1109.0000, 'ºC'),
	(101613, 109, '2015-03-15 00:32:03.000000', 'temperatura', 1005.0000, 'ºC'),
	(101614, 109, '2015-03-15 00:32:04.000000', 'temperatura', 498.0000, 'ºC'),
	(101615, 109, '2015-03-15 00:32:05.000000', 'temperatura', 675.0000, 'ºC'),
	(101616, 109, '2015-03-15 00:32:06.000000', 'temperatura', 680.0000, 'ºC'),
	(101617, 109, '2015-03-15 00:32:07.000000', 'temperatura', 176.0000, 'ºC'),
	(101618, 109, '2015-03-15 00:32:08.000000', 'temperatura', 41.0000, 'ºC'),
	(101619, 109, '2015-03-15 00:32:09.000000', 'temperatura', 879.0000, 'ºC'),
	(101620, 109, '2015-03-15 00:32:10.000000', 'temperatura', 672.0000, 'ºC'),
	(101621, 109, '2015-03-15 00:32:11.000000', 'temperatura', 724.0000, 'ºC'),
	(101622, 109, '2015-03-15 00:32:12.000000', 'temperatura', 405.0000, 'ºC'),
	(101623, 109, '2015-03-15 00:32:13.000000', 'temperatura', 1053.0000, 'ºC'),
	(101624, 109, '2015-03-15 00:32:14.000000', 'temperatura', 450.0000, 'ºC'),
	(101625, 109, '2015-03-15 00:32:15.000000', 'temperatura', 292.0000, 'ºC'),
	(101626, 109, '2015-03-15 00:32:16.000000', 'temperatura', 110.0000, 'ºC'),
	(101627, 109, '2015-03-15 00:32:17.000000', 'temperatura', 876.0000, 'ºC'),
	(101628, 109, '2015-03-15 00:32:18.000000', 'temperatura', 449.0000, 'ºC'),
	(101629, 109, '2015-03-15 00:32:19.000000', 'temperatura', 816.0000, 'ºC'),
	(101630, 109, '2015-03-15 00:32:20.000000', 'temperatura', 337.0000, 'ºC'),
	(101631, 109, '2015-03-15 00:32:21.000000', 'temperatura', 436.0000, 'ºC'),
	(101632, 109, '2015-03-15 00:32:22.000000', 'temperatura', 1169.0000, 'ºC'),
	(101633, 109, '2015-03-15 00:32:23.000000', 'temperatura', 937.0000, 'ºC'),
	(101634, 109, '2015-03-15 00:32:24.000000', 'temperatura', 1178.0000, 'ºC'),
	(101635, 109, '2015-03-15 00:32:25.000000', 'temperatura', 680.0000, 'ºC'),
	(101636, 109, '2015-03-15 00:32:26.000000', 'temperatura', 1066.0000, 'ºC'),
	(101637, 109, '2015-03-15 00:32:27.000000', 'temperatura', 892.0000, 'ºC'),
	(101638, 109, '2015-03-15 00:32:28.000000', 'temperatura', 63.0000, 'ºC'),
	(101639, 109, '2015-03-15 00:32:29.000000', 'temperatura', 39.0000, 'ºC'),
	(101640, 109, '2015-03-15 00:32:30.000000', 'temperatura', 6.0000, 'ºC'),
	(101641, 109, '2015-03-15 00:32:31.000000', 'temperatura', 1112.0000, 'ºC'),
	(101642, 109, '2015-03-15 00:32:32.000000', 'temperatura', 743.0000, 'ºC'),
	(101643, 109, '2015-03-15 00:32:33.000000', 'temperatura', 379.0000, 'ºC'),
	(101644, 109, '2015-03-15 00:32:34.000000', 'temperatura', 869.0000, 'ºC'),
	(101645, 109, '2015-03-15 00:32:35.000000', 'temperatura', 806.0000, 'ºC'),
	(101646, 109, '2015-03-15 00:32:36.000000', 'temperatura', 224.0000, 'ºC'),
	(101647, 109, '2015-03-15 00:32:37.000000', 'temperatura', 1104.0000, 'ºC'),
	(101648, 109, '2015-03-15 00:32:38.000000', 'temperatura', 46.0000, 'ºC'),
	(101649, 109, '2015-03-15 00:32:39.000000', 'temperatura', 522.0000, 'ºC'),
	(101650, 109, '2015-03-15 00:32:40.000000', 'temperatura', 70.0000, 'ºC'),
	(101651, 109, '2015-03-15 00:32:41.000000', 'temperatura', 1185.0000, 'ºC'),
	(101652, 109, '2015-03-15 00:32:42.000000', 'temperatura', 914.0000, 'ºC'),
	(101653, 109, '2015-03-15 00:32:43.000000', 'temperatura', 1016.0000, 'ºC'),
	(101654, 109, '2015-03-15 00:32:44.000000', 'temperatura', 1141.0000, 'ºC'),
	(101655, 109, '2015-03-15 00:32:45.000000', 'temperatura', 254.0000, 'ºC'),
	(101656, 109, '2015-03-15 00:32:46.000000', 'temperatura', 250.0000, 'ºC'),
	(101657, 109, '2015-03-15 00:32:47.000000', 'temperatura', 486.0000, 'ºC'),
	(101658, 109, '2015-03-15 00:32:48.000000', 'temperatura', 482.0000, 'ºC'),
	(101659, 109, '2015-03-15 00:32:49.000000', 'temperatura', 954.0000, 'ºC'),
	(101660, 109, '2015-03-15 00:32:50.000000', 'temperatura', 924.0000, 'ºC'),
	(101661, 109, '2015-03-15 00:32:51.000000', 'temperatura', 559.0000, 'ºC'),
	(101662, 109, '2015-03-15 00:32:52.000000', 'temperatura', 23.0000, 'ºC'),
	(101663, 109, '2015-03-15 00:32:53.000000', 'temperatura', 838.0000, 'ºC'),
	(101664, 109, '2015-03-15 00:32:54.000000', 'temperatura', 520.0000, 'ºC'),
	(101665, 109, '2015-03-15 00:32:55.000000', 'temperatura', 86.0000, 'ºC'),
	(101666, 109, '2015-03-15 00:32:56.000000', 'temperatura', 74.0000, 'ºC'),
	(101667, 109, '2015-03-15 00:32:57.000000', 'temperatura', 110.0000, 'ºC'),
	(101668, 109, '2015-03-15 00:32:58.000000', 'temperatura', 329.0000, 'ºC'),
	(101669, 109, '2015-03-15 00:32:59.000000', 'temperatura', 116.0000, 'ºC'),
	(101670, 109, '2015-03-15 00:33:00.000000', 'temperatura', 795.0000, 'ºC'),
	(101671, 109, '2015-03-15 00:33:01.000000', 'temperatura', 27.0000, 'ºC'),
	(101672, 109, '2015-03-15 00:33:02.000000', 'temperatura', 148.0000, 'ºC'),
	(101673, 109, '2015-03-15 00:33:03.000000', 'temperatura', 661.0000, 'ºC'),
	(101674, 109, '2015-03-15 00:33:04.000000', 'temperatura', 462.0000, 'ºC'),
	(101675, 109, '2015-03-15 00:33:05.000000', 'temperatura', 328.0000, 'ºC'),
	(101676, 109, '2015-03-15 00:33:06.000000', 'temperatura', 254.0000, 'ºC'),
	(101677, 109, '2015-03-15 00:33:07.000000', 'temperatura', 288.0000, 'ºC'),
	(101678, 109, '2015-03-15 00:33:08.000000', 'temperatura', 676.0000, 'ºC'),
	(101679, 109, '2015-03-15 00:33:09.000000', 'temperatura', 116.0000, 'ºC'),
	(101680, 109, '2015-03-15 00:33:10.000000', 'temperatura', 953.0000, 'ºC'),
	(101681, 109, '2015-03-15 00:33:11.000000', 'temperatura', 817.0000, 'ºC'),
	(101682, 109, '2015-03-15 00:33:12.000000', 'temperatura', 27.0000, 'ºC'),
	(101683, 109, '2015-03-15 00:33:13.000000', 'temperatura', 83.0000, 'ºC'),
	(101684, 109, '2015-03-15 00:33:14.000000', 'temperatura', 337.0000, 'ºC'),
	(101685, 109, '2015-03-15 00:33:15.000000', 'temperatura', 234.0000, 'ºC'),
	(101686, 109, '2015-03-15 00:33:16.000000', 'temperatura', 160.0000, 'ºC'),
	(101687, 109, '2015-03-15 00:33:17.000000', 'temperatura', 99.0000, 'ºC'),
	(101688, 109, '2015-03-15 00:33:18.000000', 'temperatura', 17.0000, 'ºC'),
	(101689, 109, '2015-03-15 00:33:19.000000', 'temperatura', 986.0000, 'ºC'),
	(101690, 109, '2015-03-15 00:33:20.000000', 'temperatura', 81.0000, 'ºC'),
	(101691, 109, '2015-03-15 00:33:21.000000', 'temperatura', 1045.0000, 'ºC'),
	(101692, 109, '2015-03-15 00:33:22.000000', 'temperatura', 186.0000, 'ºC'),
	(101693, 109, '2015-03-15 00:33:23.000000', 'temperatura', 193.0000, 'ºC'),
	(101694, 109, '2015-03-15 00:33:24.000000', 'temperatura', 408.0000, 'ºC'),
	(101695, 109, '2015-03-15 00:33:25.000000', 'temperatura', 263.0000, 'ºC'),
	(101696, 109, '2015-03-15 00:33:26.000000', 'temperatura', 89.0000, 'ºC'),
	(101697, 109, '2015-03-15 00:33:27.000000', 'temperatura', 860.0000, 'ºC'),
	(101698, 109, '2015-03-15 00:33:28.000000', 'temperatura', 430.0000, 'ºC'),
	(101699, 109, '2015-03-15 00:33:29.000000', 'temperatura', 771.0000, 'ºC'),
	(101700, 109, '2015-03-15 00:33:30.000000', 'temperatura', 167.0000, 'ºC'),
	(101701, 109, '2015-03-15 00:33:31.000000', 'temperatura', 922.0000, 'ºC'),
	(101702, 109, '2015-03-15 00:33:32.000000', 'temperatura', 508.0000, 'ºC'),
	(101703, 109, '2015-03-15 00:33:33.000000', 'temperatura', 977.0000, 'ºC'),
	(101704, 109, '2015-03-15 00:33:34.000000', 'temperatura', 961.0000, 'ºC'),
	(101705, 109, '2015-03-15 00:33:35.000000', 'temperatura', 673.0000, 'ºC'),
	(101706, 109, '2015-03-15 00:33:36.000000', 'temperatura', 484.0000, 'ºC'),
	(101707, 109, '2015-03-15 00:33:37.000000', 'temperatura', 402.0000, 'ºC'),
	(101708, 109, '2015-03-15 00:33:38.000000', 'temperatura', 558.0000, 'ºC'),
	(101709, 109, '2015-03-15 00:33:39.000000', 'temperatura', 383.0000, 'ºC'),
	(101710, 109, '2015-03-15 00:33:40.000000', 'temperatura', 243.0000, 'ºC'),
	(101711, 109, '2015-03-15 00:33:41.000000', 'temperatura', 68.0000, 'ºC'),
	(101712, 109, '2015-03-15 00:33:42.000000', 'temperatura', 808.0000, 'ºC'),
	(101713, 109, '2015-03-15 00:33:43.000000', 'temperatura', 240.0000, 'ºC'),
	(101714, 109, '2015-03-15 00:33:44.000000', 'temperatura', 1174.0000, 'ºC'),
	(101715, 109, '2015-03-15 00:33:45.000000', 'temperatura', 351.0000, 'ºC'),
	(101716, 109, '2015-03-15 00:33:46.000000', 'temperatura', 632.0000, 'ºC'),
	(101717, 109, '2015-03-15 00:33:47.000000', 'temperatura', 908.0000, 'ºC'),
	(101718, 109, '2015-03-15 00:33:48.000000', 'temperatura', 243.0000, 'ºC'),
	(101719, 109, '2015-03-15 00:33:49.000000', 'temperatura', 894.0000, 'ºC'),
	(101720, 109, '2015-03-15 00:33:50.000000', 'temperatura', 142.0000, 'ºC'),
	(101721, 109, '2015-03-15 00:33:51.000000', 'temperatura', 429.0000, 'ºC'),
	(101722, 109, '2015-03-15 00:33:52.000000', 'temperatura', 518.0000, 'ºC'),
	(101723, 109, '2015-03-15 00:33:53.000000', 'temperatura', 103.0000, 'ºC'),
	(101724, 109, '2015-03-15 00:33:54.000000', 'temperatura', 160.0000, 'ºC'),
	(101725, 109, '2015-03-15 00:33:55.000000', 'temperatura', 493.0000, 'ºC'),
	(101726, 109, '2015-03-15 00:33:56.000000', 'temperatura', 786.0000, 'ºC'),
	(101727, 109, '2015-03-15 00:33:57.000000', 'temperatura', 51.0000, 'ºC'),
	(101728, 109, '2015-03-15 00:33:58.000000', 'temperatura', 296.0000, 'ºC'),
	(101729, 109, '2015-03-15 00:33:59.000000', 'temperatura', 130.0000, 'ºC'),
	(101730, 109, '2015-03-15 00:34:00.000000', 'temperatura', 960.0000, 'ºC'),
	(101731, 109, '2015-03-15 00:34:01.000000', 'temperatura', 813.0000, 'ºC'),
	(101732, 109, '2015-03-15 00:34:02.000000', 'temperatura', 1183.0000, 'ºC'),
	(101733, 109, '2015-03-15 00:34:03.000000', 'temperatura', 1078.0000, 'ºC'),
	(101734, 109, '2015-03-15 00:34:04.000000', 'temperatura', 642.0000, 'ºC'),
	(101735, 109, '2015-03-15 00:34:05.000000', 'temperatura', 1177.0000, 'ºC'),
	(101736, 109, '2015-03-15 00:34:06.000000', 'temperatura', 358.0000, 'ºC'),
	(101737, 109, '2015-03-15 00:34:07.000000', 'temperatura', 660.0000, 'ºC'),
	(101738, 109, '2015-03-15 00:34:08.000000', 'temperatura', 1028.0000, 'ºC'),
	(101739, 109, '2015-03-15 00:34:09.000000', 'temperatura', 761.0000, 'ºC'),
	(101740, 109, '2015-03-15 00:34:10.000000', 'temperatura', 719.0000, 'ºC'),
	(101741, 109, '2015-03-15 00:34:11.000000', 'temperatura', 112.0000, 'ºC'),
	(101742, 109, '2015-03-15 00:34:12.000000', 'temperatura', 803.0000, 'ºC'),
	(101743, 109, '2015-03-15 00:34:13.000000', 'temperatura', 82.0000, 'ºC'),
	(101744, 109, '2015-03-15 00:34:14.000000', 'temperatura', 401.0000, 'ºC'),
	(101745, 109, '2015-03-15 00:34:15.000000', 'temperatura', 557.0000, 'ºC'),
	(101746, 109, '2015-03-15 00:34:16.000000', 'temperatura', 385.0000, 'ºC'),
	(101747, 109, '2015-03-15 00:34:17.000000', 'temperatura', 255.0000, 'ºC'),
	(101748, 109, '2015-03-15 00:34:18.000000', 'temperatura', 121.0000, 'ºC'),
	(101749, 109, '2015-03-15 00:34:19.000000', 'temperatura', 1040.0000, 'ºC'),
	(101750, 109, '2015-03-15 00:34:20.000000', 'temperatura', 37.0000, 'ºC'),
	(101751, 109, '2015-03-15 00:34:21.000000', 'temperatura', 665.0000, 'ºC'),
	(101752, 109, '2015-03-15 00:34:22.000000', 'temperatura', 813.0000, 'ºC'),
	(101753, 109, '2015-03-15 00:34:23.000000', 'temperatura', 872.0000, 'ºC'),
	(101754, 109, '2015-03-15 00:34:24.000000', 'temperatura', 722.0000, 'ºC'),
	(101755, 109, '2015-03-15 00:34:25.000000', 'temperatura', 996.0000, 'ºC'),
	(101756, 109, '2015-03-15 00:34:26.000000', 'temperatura', 412.0000, 'ºC'),
	(101757, 109, '2015-03-15 00:34:27.000000', 'temperatura', 272.0000, 'ºC'),
	(101758, 109, '2015-03-15 00:34:28.000000', 'temperatura', 127.0000, 'ºC'),
	(101759, 109, '2015-03-15 00:34:29.000000', 'temperatura', 1020.0000, 'ºC'),
	(101760, 109, '2015-03-15 00:34:30.000000', 'temperatura', 1120.0000, 'ºC'),
	(101761, 109, '2015-03-15 00:34:31.000000', 'temperatura', 140.0000, 'ºC'),
	(101762, 109, '2015-03-15 00:34:32.000000', 'temperatura', 939.0000, 'ºC'),
	(101763, 109, '2015-03-15 00:34:33.000000', 'temperatura', 676.0000, 'ºC'),
	(101764, 109, '2015-03-15 00:34:34.000000', 'temperatura', 564.0000, 'ºC'),
	(101765, 109, '2015-03-15 00:34:35.000000', 'temperatura', 794.0000, 'ºC'),
	(101766, 109, '2015-03-15 00:34:36.000000', 'temperatura', 1077.0000, 'ºC'),
	(101767, 109, '2015-03-15 00:34:37.000000', 'temperatura', 602.0000, 'ºC'),
	(101768, 109, '2015-03-15 00:34:38.000000', 'temperatura', 980.0000, 'ºC'),
	(101769, 109, '2015-03-15 00:34:39.000000', 'temperatura', 695.0000, 'ºC'),
	(101770, 109, '2015-03-15 00:34:40.000000', 'temperatura', 534.0000, 'ºC'),
	(101771, 109, '2015-03-15 00:34:41.000000', 'temperatura', 585.0000, 'ºC'),
	(101772, 109, '2015-03-15 00:34:42.000000', 'temperatura', 125.0000, 'ºC'),
	(101773, 109, '2015-03-15 00:34:43.000000', 'temperatura', 71.0000, 'ºC'),
	(101774, 109, '2015-03-15 00:34:44.000000', 'temperatura', 1178.0000, 'ºC'),
	(101775, 109, '2015-03-15 00:34:45.000000', 'temperatura', 880.0000, 'ºC'),
	(101776, 109, '2015-03-15 00:34:46.000000', 'temperatura', 866.0000, 'ºC'),
	(101777, 109, '2015-03-15 00:34:47.000000', 'temperatura', 490.0000, 'ºC'),
	(101778, 109, '2015-03-15 00:34:48.000000', 'temperatura', 1051.0000, 'ºC'),
	(101779, 109, '2015-03-15 00:34:49.000000', 'temperatura', 185.0000, 'ºC'),
	(101780, 109, '2015-03-15 00:34:50.000000', 'temperatura', 175.0000, 'ºC'),
	(101781, 109, '2015-03-15 00:34:51.000000', 'temperatura', 320.0000, 'ºC'),
	(101782, 109, '2015-03-15 00:34:52.000000', 'temperatura', 1073.0000, 'ºC'),
	(101783, 109, '2015-03-15 00:34:53.000000', 'temperatura', 809.0000, 'ºC'),
	(101784, 109, '2015-03-15 00:34:54.000000', 'temperatura', 824.0000, 'ºC'),
	(101785, 109, '2015-03-15 00:34:55.000000', 'temperatura', 496.0000, 'ºC'),
	(101786, 109, '2015-03-15 00:34:56.000000', 'temperatura', 5.0000, 'ºC'),
	(101787, 109, '2015-03-15 00:34:57.000000', 'temperatura', 941.0000, 'ºC'),
	(101788, 109, '2015-03-15 00:34:58.000000', 'temperatura', 1089.0000, 'ºC'),
	(101789, 109, '2015-03-15 00:34:59.000000', 'temperatura', 223.0000, 'ºC'),
	(101790, 109, '2015-03-15 00:35:00.000000', 'temperatura', 247.0000, 'ºC'),
	(101791, 109, '2015-03-15 00:35:01.000000', 'temperatura', 566.0000, 'ºC'),
	(101792, 109, '2015-03-15 00:35:02.000000', 'temperatura', 892.0000, 'ºC'),
	(101793, 109, '2015-03-15 00:35:03.000000', 'temperatura', 360.0000, 'ºC'),
	(101794, 109, '2015-03-15 00:35:04.000000', 'temperatura', 325.0000, 'ºC'),
	(101795, 109, '2015-03-15 00:35:05.000000', 'temperatura', 545.0000, 'ºC'),
	(101796, 109, '2015-03-15 00:35:06.000000', 'temperatura', 550.0000, 'ºC'),
	(101797, 109, '2015-03-15 00:35:07.000000', 'temperatura', 1115.0000, 'ºC'),
	(101798, 109, '2015-03-15 00:35:08.000000', 'temperatura', 328.0000, 'ºC'),
	(101799, 109, '2015-03-15 00:35:09.000000', 'temperatura', 693.0000, 'ºC'),
	(101800, 109, '2015-03-15 00:35:10.000000', 'temperatura', 81.0000, 'ºC'),
	(101801, 109, '2015-03-15 00:35:11.000000', 'temperatura', 727.0000, 'ºC'),
	(101802, 109, '2015-03-15 00:35:12.000000', 'temperatura', 991.0000, 'ºC'),
	(101803, 109, '2015-03-15 00:35:13.000000', 'temperatura', 377.0000, 'ºC'),
	(101804, 109, '2015-03-15 00:35:14.000000', 'temperatura', 110.0000, 'ºC'),
	(101805, 109, '2015-03-15 00:35:15.000000', 'temperatura', 620.0000, 'ºC'),
	(101806, 109, '2015-03-15 00:35:16.000000', 'temperatura', 372.0000, 'ºC'),
	(101807, 109, '2015-03-15 00:35:17.000000', 'temperatura', 1.0000, 'ºC'),
	(101808, 109, '2015-03-15 00:35:18.000000', 'temperatura', 89.0000, 'ºC'),
	(101809, 109, '2015-03-15 00:35:19.000000', 'temperatura', 443.0000, 'ºC'),
	(101810, 109, '2015-03-15 00:35:20.000000', 'temperatura', 748.0000, 'ºC'),
	(101811, 109, '2015-03-15 00:35:21.000000', 'temperatura', 13.0000, 'ºC'),
	(101812, 109, '2015-03-15 00:35:22.000000', 'temperatura', 222.0000, 'ºC'),
	(101813, 109, '2015-03-15 00:35:23.000000', 'temperatura', 1071.0000, 'ºC'),
	(101814, 109, '2015-03-15 00:35:24.000000', 'temperatura', 1089.0000, 'ºC'),
	(101815, 109, '2015-03-15 00:35:25.000000', 'temperatura', 1032.0000, 'ºC'),
	(101816, 109, '2015-03-15 00:35:26.000000', 'temperatura', 695.0000, 'ºC'),
	(101817, 109, '2015-03-15 00:35:27.000000', 'temperatura', 379.0000, 'ºC'),
	(101818, 109, '2015-03-15 00:35:28.000000', 'temperatura', 1009.0000, 'ºC'),
	(101819, 109, '2015-03-15 00:35:29.000000', 'temperatura', 309.0000, 'ºC'),
	(101820, 109, '2015-03-15 00:35:30.000000', 'temperatura', 920.0000, 'ºC'),
	(101821, 109, '2015-03-15 00:35:31.000000', 'temperatura', 72.0000, 'ºC'),
	(101822, 109, '2015-03-15 00:35:32.000000', 'temperatura', 3.0000, 'ºC'),
	(101823, 109, '2015-03-15 00:35:33.000000', 'temperatura', 998.0000, 'ºC'),
	(101824, 109, '2015-03-15 00:35:34.000000', 'temperatura', 180.0000, 'ºC'),
	(101825, 109, '2015-03-15 00:35:35.000000', 'temperatura', 309.0000, 'ºC'),
	(101826, 109, '2015-03-15 00:35:36.000000', 'temperatura', 1005.0000, 'ºC'),
	(101827, 109, '2015-03-15 00:35:37.000000', 'temperatura', 496.0000, 'ºC'),
	(101828, 109, '2015-03-15 00:35:38.000000', 'temperatura', 668.0000, 'ºC'),
	(101829, 109, '2015-03-15 00:35:39.000000', 'temperatura', 653.0000, 'ºC'),
	(101830, 109, '2015-03-15 00:35:40.000000', 'temperatura', 62.0000, 'ºC'),
	(101831, 109, '2015-03-15 00:35:41.000000', 'temperatura', 750.0000, 'ºC'),
	(101832, 109, '2015-03-15 00:35:42.000000', 'temperatura', 1166.0000, 'ºC'),
	(101833, 109, '2015-03-15 00:35:43.000000', 'temperatura', 1178.0000, 'ºC'),
	(101834, 109, '2015-03-15 00:35:44.000000', 'temperatura', 1193.0000, 'ºC'),
	(101835, 109, '2015-03-15 00:35:45.000000', 'temperatura', 34.0000, 'ºC'),
	(101836, 109, '2015-03-15 00:35:46.000000', 'temperatura', 189.0000, 'ºC'),
	(101837, 109, '2015-03-15 00:35:47.000000', 'temperatura', 842.0000, 'ºC'),
	(101838, 109, '2015-03-15 00:35:48.000000', 'temperatura', 47.0000, 'ºC'),
	(101839, 109, '2015-03-15 00:35:49.000000', 'temperatura', 108.0000, 'ºC'),
	(101840, 109, '2015-03-15 00:35:50.000000', 'temperatura', 400.0000, 'ºC'),
	(101841, 109, '2015-03-15 00:35:51.000000', 'temperatura', 477.0000, 'ºC'),
	(101842, 109, '2015-03-15 00:35:52.000000', 'temperatura', 1185.0000, 'ºC'),
	(101843, 109, '2015-03-15 00:35:53.000000', 'temperatura', 894.0000, 'ºC'),
	(101844, 109, '2015-03-15 00:35:54.000000', 'temperatura', 917.0000, 'ºC'),
	(101845, 109, '2015-03-15 00:35:55.000000', 'temperatura', 702.0000, 'ºC'),
	(101846, 109, '2015-03-15 00:35:56.000000', 'temperatura', 759.0000, 'ºC'),
	(101847, 109, '2015-03-15 00:35:57.000000', 'temperatura', 488.0000, 'ºC'),
	(101848, 109, '2015-03-15 00:35:58.000000', 'temperatura', 166.0000, 'ºC'),
	(101849, 109, '2015-03-15 00:35:59.000000', 'temperatura', 567.0000, 'ºC'),
	(101850, 109, '2015-03-15 00:36:00.000000', 'temperatura', 1137.0000, 'ºC'),
	(101851, 109, '2015-03-15 00:36:01.000000', 'temperatura', 386.0000, 'ºC'),
	(101852, 109, '2015-03-15 00:36:02.000000', 'temperatura', 919.0000, 'ºC'),
	(101853, 109, '2015-03-15 00:36:03.000000', 'temperatura', 1036.0000, 'ºC'),
	(101854, 109, '2015-03-15 00:36:04.000000', 'temperatura', 24.0000, 'ºC'),
	(101855, 109, '2015-03-15 00:36:05.000000', 'temperatura', 611.0000, 'ºC'),
	(101856, 109, '2015-03-15 00:36:06.000000', 'temperatura', 586.0000, 'ºC'),
	(101857, 109, '2015-03-15 00:36:07.000000', 'temperatura', 1098.0000, 'ºC'),
	(101858, 109, '2015-03-15 00:36:08.000000', 'temperatura', 131.0000, 'ºC'),
	(101859, 109, '2015-03-15 00:36:09.000000', 'temperatura', 961.0000, 'ºC'),
	(101860, 109, '2015-03-15 00:36:10.000000', 'temperatura', 812.0000, 'ºC'),
	(101861, 109, '2015-03-15 00:36:11.000000', 'temperatura', 1177.0000, 'ºC'),
	(101862, 109, '2015-03-15 00:36:12.000000', 'temperatura', 1051.0000, 'ºC'),
	(101863, 109, '2015-03-15 00:36:13.000000', 'temperatura', 526.0000, 'ºC'),
	(101864, 109, '2015-03-15 00:36:14.000000', 'temperatura', 676.0000, 'ºC'),
	(101865, 109, '2015-03-15 00:36:15.000000', 'temperatura', 604.0000, 'ºC'),
	(101866, 109, '2015-03-15 00:36:16.000000', 'temperatura', 993.0000, 'ºC'),
	(101867, 109, '2015-03-15 00:36:17.000000', 'temperatura', 754.0000, 'ºC'),
	(101868, 109, '2015-03-15 00:36:18.000000', 'temperatura', 790.0000, 'ºC'),
	(101869, 109, '2015-03-15 00:36:19.000000', 'temperatura', 490.0000, 'ºC'),
	(101870, 109, '2015-03-15 00:36:20.000000', 'temperatura', 81.0000, 'ºC'),
	(101871, 109, '2015-03-15 00:36:21.000000', 'temperatura', 134.0000, 'ºC'),
	(101872, 109, '2015-03-15 00:36:22.000000', 'temperatura', 428.0000, 'ºC'),
	(101873, 109, '2015-03-15 00:36:23.000000', 'temperatura', 537.0000, 'ºC'),
	(101874, 109, '2015-03-15 00:36:24.000000', 'temperatura', 202.0000, 'ºC'),
	(101875, 109, '2015-03-15 00:36:25.000000', 'temperatura', 598.0000, 'ºC'),
	(101876, 109, '2015-03-15 00:36:26.000000', 'temperatura', 1185.0000, 'ºC'),
	(101877, 109, '2015-03-15 00:36:27.000000', 'temperatura', 532.0000, 'ºC'),
	(101878, 109, '2015-03-15 00:36:28.000000', 'temperatura', 306.0000, 'ºC'),
	(101879, 109, '2015-03-15 00:36:29.000000', 'temperatura', 1136.0000, 'ºC'),
	(101880, 109, '2015-03-15 00:36:30.000000', 'temperatura', 1160.0000, 'ºC'),
	(101881, 109, '2015-03-15 00:36:31.000000', 'temperatura', 1194.0000, 'ºC'),
	(101882, 109, '2015-03-15 00:36:32.000000', 'temperatura', 90.0000, 'ºC'),
	(101883, 109, '2015-03-15 00:36:33.000000', 'temperatura', 469.0000, 'ºC'),
	(101884, 109, '2015-03-15 00:36:34.000000', 'temperatura', 877.0000, 'ºC'),
	(101885, 109, '2015-03-15 00:36:35.000000', 'temperatura', 579.0000, 'ºC'),
	(101886, 109, '2015-03-15 00:36:36.000000', 'temperatura', 261.0000, 'ºC'),
	(101887, 109, '2015-03-15 00:36:37.000000', 'temperatura', 771.0000, 'ºC'),
	(101888, 109, '2015-03-15 00:36:38.000000', 'temperatura', 670.0000, 'ºC'),
	(101889, 109, '2015-03-15 00:36:39.000000', 'temperatura', 1040.0000, 'ºC'),
	(101890, 109, '2015-03-15 00:36:40.000000', 'temperatura', 789.0000, 'ºC'),
	(101891, 109, '2015-03-15 00:36:41.000000', 'temperatura', 824.0000, 'ºC'),
	(101892, 109, '2015-03-15 00:36:42.000000', 'temperatura', 556.0000, 'ºC'),
	(101893, 109, '2015-03-15 00:36:43.000000', 'temperatura', 309.0000, 'ºC'),
	(101894, 109, '2015-03-15 00:36:44.000000', 'temperatura', 1077.0000, 'ºC'),
	(101895, 109, '2015-03-15 00:36:45.000000', 'temperatura', 859.0000, 'ºC'),
	(101896, 109, '2015-03-15 00:36:46.000000', 'temperatura', 1065.0000, 'ºC'),
	(101897, 109, '2015-03-15 00:36:47.000000', 'temperatura', 348.0000, 'ºC'),
	(101898, 109, '2015-03-15 00:36:48.000000', 'temperatura', 945.0000, 'ºC'),
	(101899, 109, '2015-03-15 00:36:49.000000', 'temperatura', 82.0000, 'ºC'),
	(101900, 109, '2015-03-15 00:36:50.000000', 'temperatura', 1176.0000, 'ºC'),
	(101901, 109, '2015-03-15 00:36:51.000000', 'temperatura', 834.0000, 'ºC'),
	(101902, 109, '2015-03-15 00:36:52.000000', 'temperatura', 641.0000, 'ºC'),
	(101903, 109, '2015-03-15 00:36:53.000000', 'temperatura', 703.0000, 'ºC'),
	(101904, 109, '2015-03-15 00:36:54.000000', 'temperatura', 392.0000, 'ºC'),
	(101905, 109, '2015-03-15 00:36:55.000000', 'temperatura', 1054.0000, 'ºC'),
	(101906, 109, '2015-03-15 00:36:56.000000', 'temperatura', 494.0000, 'ºC'),
	(101907, 109, '2015-03-15 00:36:57.000000', 'temperatura', 509.0000, 'ºC'),
	(101908, 109, '2015-03-15 00:36:58.000000', 'temperatura', 1062.0000, 'ºC'),
	(101909, 109, '2015-03-15 00:36:59.000000', 'temperatura', 186.0000, 'ºC'),
	(101910, 109, '2015-03-15 00:37:00.000000', 'temperatura', 142.0000, 'ºC'),
	(101911, 109, '2015-03-15 00:37:01.000000', 'temperatura', 155.0000, 'ºC'),
	(101912, 109, '2015-03-15 00:37:02.000000', 'temperatura', 350.0000, 'ºC'),
	(101913, 109, '2015-03-15 00:37:03.000000', 'temperatura', 86.0000, 'ºC'),
	(101914, 109, '2015-03-15 00:37:04.000000', 'temperatura', 580.0000, 'ºC'),
	(101915, 109, '2015-03-15 00:37:05.000000', 'temperatura', 243.0000, 'ºC'),
	(101916, 109, '2015-03-15 00:37:06.000000', 'temperatura', 674.0000, 'ºC'),
	(101917, 109, '2015-03-15 00:37:07.000000', 'temperatura', 240.0000, 'ºC'),
	(101918, 109, '2015-03-15 00:37:08.000000', 'temperatura', 381.0000, 'ºC'),
	(101919, 109, '2015-03-15 00:37:09.000000', 'temperatura', 1187.0000, 'ºC'),
	(101920, 109, '2015-03-15 00:37:10.000000', 'temperatura', 1189.0000, 'ºC'),
	(101921, 109, '2015-03-15 00:37:11.000000', 'temperatura', 1188.0000, 'ºC'),
	(101922, 109, '2015-03-15 00:37:12.000000', 'temperatura', 1172.0000, 'ºC'),
	(101923, 109, '2015-03-15 00:37:13.000000', 'temperatura', 1096.0000, 'ºC'),
	(101924, 109, '2015-03-15 00:37:14.000000', 'temperatura', 763.0000, 'ºC'),
	(101925, 109, '2015-03-15 00:37:15.000000', 'temperatura', 528.0000, 'ºC'),
	(101926, 109, '2015-03-15 00:37:16.000000', 'temperatura', 350.0000, 'ºC'),
	(101927, 109, '2015-03-15 00:37:17.000000', 'temperatura', 168.0000, 'ºC'),
	(101928, 109, '2015-03-15 00:37:18.000000', 'temperatura', 990.0000, 'ºC'),
	(101929, 109, '2015-03-15 00:37:19.000000', 'temperatura', 849.0000, 'ºC'),
	(101930, 109, '2015-03-15 00:37:20.000000', 'temperatura', 74.0000, 'ºC'),
	(101931, 109, '2015-03-15 00:37:21.000000', 'temperatura', 222.0000, 'ºC'),
	(101932, 109, '2015-03-15 00:37:22.000000', 'temperatura', 891.0000, 'ºC'),
	(101933, 109, '2015-03-15 00:37:23.000000', 'temperatura', 189.0000, 'ºC'),
	(101934, 109, '2015-03-15 00:37:24.000000', 'temperatura', 670.0000, 'ºC'),
	(101935, 109, '2015-03-15 00:37:25.000000', 'temperatura', 385.0000, 'ºC'),
	(101936, 109, '2015-03-15 00:37:26.000000', 'temperatura', 1117.0000, 'ºC'),
	(101937, 109, '2015-03-15 00:37:27.000000', 'temperatura', 831.0000, 'ºC'),
	(101938, 109, '2015-03-15 00:37:28.000000', 'temperatura', 805.0000, 'ºC'),
	(101939, 109, '2015-03-15 00:37:29.000000', 'temperatura', 332.0000, 'ºC'),
	(101940, 109, '2015-03-15 00:37:30.000000', 'temperatura', 443.0000, 'ºC'),
	(101941, 109, '2015-03-15 00:37:31.000000', 'temperatura', 22.0000, 'ºC'),
	(101942, 109, '2015-03-15 00:37:32.000000', 'temperatura', 1181.0000, 'ºC'),
	(101943, 109, '2015-03-15 00:37:33.000000', 'temperatura', 1041.0000, 'ºC'),
	(101944, 109, '2015-03-15 00:37:34.000000', 'temperatura', 462.0000, 'ºC'),
	(101945, 109, '2015-03-15 00:37:35.000000', 'temperatura', 386.0000, 'ºC'),
	(101946, 109, '2015-03-15 00:37:36.000000', 'temperatura', 547.0000, 'ºC'),
	(101947, 109, '2015-03-15 00:37:37.000000', 'temperatura', 375.0000, 'ºC'),
	(101948, 109, '2015-03-15 00:37:38.000000', 'temperatura', 235.0000, 'ºC'),
	(101949, 109, '2015-03-15 00:37:39.000000', 'temperatura', 52.0000, 'ºC'),
	(101950, 109, '2015-03-15 00:37:40.000000', 'temperatura', 753.0000, 'ºC'),
	(101951, 109, '2015-03-15 00:37:41.000000', 'temperatura', 11.0000, 'ºC'),
	(101952, 109, '2015-03-15 00:37:42.000000', 'temperatura', 196.0000, 'ºC'),
	(101953, 109, '2015-03-15 00:37:43.000000', 'temperatura', 950.0000, 'ºC'),
	(101954, 109, '2015-03-15 00:37:44.000000', 'temperatura', 560.0000, 'ºC'),
	(101955, 109, '2015-03-15 00:37:45.000000', 'temperatura', 1150.0000, 'ºC'),
	(101956, 109, '2015-03-15 00:37:46.000000', 'temperatura', 471.0000, 'ºC'),
	(101957, 109, '2015-03-15 00:37:47.000000', 'temperatura', 106.0000, 'ºC'),
	(101958, 109, '2015-03-15 00:37:48.000000', 'temperatura', 317.0000, 'ºC'),
	(101959, 109, '2015-03-15 00:37:49.000000', 'temperatura', 69.0000, 'ºC'),
	(101960, 109, '2015-03-15 00:37:50.000000', 'temperatura', 593.0000, 'ºC'),
	(101961, 109, '2015-03-15 00:37:51.000000', 'temperatura', 358.0000, 'ºC'),
	(101962, 109, '2015-03-15 00:37:52.000000', 'temperatura', 13.0000, 'ºC'),
	(101963, 109, '2015-03-15 00:37:53.000000', 'temperatura', 190.0000, 'ºC'),
	(101964, 109, '2015-03-15 00:37:54.000000', 'temperatura', 912.0000, 'ºC'),
	(101965, 109, '2015-03-15 00:37:55.000000', 'temperatura', 389.0000, 'ºC'),
	(101966, 109, '2015-03-15 00:37:56.000000', 'temperatura', 409.0000, 'ºC'),
	(101967, 109, '2015-03-15 00:37:57.000000', 'temperatura', 879.0000, 'ºC'),
	(101968, 109, '2015-03-15 00:37:58.000000', 'temperatura', 770.0000, 'ºC'),
	(101969, 109, '2015-03-15 00:37:59.000000', 'temperatura', 13.0000, 'ºC'),
	(101970, 109, '2015-03-15 00:38:00.000000', 'temperatura', 156.0000, 'ºC'),
	(101971, 109, '2015-03-15 00:38:01.000000', 'temperatura', 739.0000, 'ºC'),
	(101972, 109, '2015-03-15 00:38:02.000000', 'temperatura', 830.0000, 'ºC'),
	(101973, 109, '2015-03-15 00:38:03.000000', 'temperatura', 731.0000, 'ºC'),
	(101974, 109, '2015-03-15 00:38:04.000000', 'temperatura', 1166.0000, 'ºC'),
	(101975, 109, '2015-03-15 00:38:05.000000', 'temperatura', 39.0000, 'ºC'),
	(101976, 109, '2015-03-15 00:38:06.000000', 'temperatura', 297.0000, 'ºC'),
	(101977, 109, '2015-03-15 00:38:07.000000', 'temperatura', 169.0000, 'ºC'),
	(101978, 109, '2015-03-15 00:38:08.000000', 'temperatura', 1153.0000, 'ºC'),
	(101979, 109, '2015-03-15 00:38:09.000000', 'temperatura', 460.0000, 'ºC'),
	(101980, 109, '2015-03-15 00:38:10.000000', 'temperatura', 41.0000, 'ºC'),
	(101981, 109, '2015-03-15 00:38:11.000000', 'temperatura', 28.0000, 'ºC'),
	(101982, 109, '2015-03-15 00:38:12.000000', 'temperatura', 14.0000, 'ºC'),
	(101983, 109, '2015-03-15 00:38:13.000000', 'temperatura', 1187.0000, 'ºC'),
	(101984, 109, '2015-03-15 00:38:14.000000', 'temperatura', 1095.0000, 'ºC'),
	(101985, 109, '2015-03-15 00:38:15.000000', 'temperatura', 712.0000, 'ºC'),
	(101986, 109, '2015-03-15 00:38:16.000000', 'temperatura', 277.0000, 'ºC'),
	(101987, 109, '2015-03-15 00:38:17.000000', 'temperatura', 450.0000, 'ºC'),
	(101988, 109, '2015-03-15 00:38:18.000000', 'temperatura', 221.0000, 'ºC'),
	(101989, 109, '2015-03-15 00:38:19.000000', 'temperatura', 952.0000, 'ºC'),
	(101990, 109, '2015-03-15 00:38:20.000000', 'temperatura', 499.0000, 'ºC'),
	(101991, 109, '2015-03-15 00:38:21.000000', 'temperatura', 839.0000, 'ºC'),
	(101992, 109, '2015-03-15 00:38:22.000000', 'temperatura', 300.0000, 'ºC'),
	(101993, 109, '2015-03-15 00:38:23.000000', 'temperatura', 183.0000, 'ºC'),
	(101994, 109, '2015-03-15 00:38:24.000000', 'temperatura', 14.0000, 'ºC'),
	(101995, 109, '2015-03-15 00:38:25.000000', 'temperatura', 722.0000, 'ºC'),
	(101996, 109, '2015-03-15 00:38:26.000000', 'temperatura', 1169.0000, 'ºC'),
	(101997, 109, '2015-03-15 00:38:27.000000', 'temperatura', 79.0000, 'ºC'),
	(101998, 109, '2015-03-15 00:38:28.000000', 'temperatura', 489.0000, 'ºC'),
	(101999, 109, '2015-03-15 00:38:29.000000', 'temperatura', 1006.0000, 'ºC'),
	(102000, 109, '2015-03-15 00:38:30.000000', 'temperatura', 1167.0000, 'ºC'),
	(102001, 109, '2015-03-15 00:38:31.000000', 'temperatura', 415.0000, 'ºC'),
	(102002, 109, '2015-03-15 00:38:32.000000', 'temperatura', 977.0000, 'ºC'),
	(102003, 109, '2015-03-15 00:38:33.000000', 'temperatura', 38.0000, 'ºC'),
	(102004, 109, '2015-03-15 00:38:34.000000', 'temperatura', 860.0000, 'ºC'),
	(102005, 109, '2015-03-15 00:38:35.000000', 'temperatura', 586.0000, 'ºC'),
	(102006, 109, '2015-03-15 00:38:36.000000', 'temperatura', 350.0000, 'ºC'),
	(102007, 109, '2015-03-15 00:38:37.000000', 'temperatura', 1192.0000, 'ºC'),
	(102008, 109, '2015-03-15 00:38:38.000000', 'temperatura', 112.0000, 'ºC'),
	(102009, 109, '2015-03-15 00:38:39.000000', 'temperatura', 584.0000, 'ºC'),
	(102010, 109, '2015-03-15 00:38:40.000000', 'temperatura', 186.0000, 'ºC'),
	(102011, 109, '2015-03-15 00:38:41.000000', 'temperatura', 376.0000, 'ºC'),
	(102012, 109, '2015-03-15 00:38:42.000000', 'temperatura', 122.0000, 'ºC'),
	(102013, 109, '2015-03-15 00:38:43.000000', 'temperatura', 682.0000, 'ºC'),
	(102014, 109, '2015-03-15 00:38:44.000000', 'temperatura', 646.0000, 'ºC'),
	(102015, 109, '2015-03-15 00:38:45.000000', 'temperatura', 1186.0000, 'ºC'),
	(102016, 109, '2015-03-15 00:38:46.000000', 'temperatura', 389.0000, 'ºC'),
	(102017, 109, '2015-03-15 00:38:47.000000', 'temperatura', 790.0000, 'ºC'),
	(102018, 109, '2015-03-15 00:38:48.000000', 'temperatura', 383.0000, 'ºC'),
	(102019, 109, '2015-03-15 00:38:49.000000', 'temperatura', 746.0000, 'ºC'),
	(102020, 109, '2015-03-15 00:38:50.000000', 'temperatura', 181.0000, 'ºC'),
	(102021, 109, '2015-03-15 00:38:51.000000', 'temperatura', 1066.0000, 'ºC'),
	(102022, 109, '2015-03-15 00:38:52.000000', 'temperatura', 1188.0000, 'ºC'),
	(102023, 109, '2015-03-15 00:38:53.000000', 'temperatura', 342.0000, 'ºC'),
	(102024, 109, '2015-03-15 00:38:54.000000', 'temperatura', 545.0000, 'ºC'),
	(102025, 109, '2015-03-15 00:38:55.000000', 'temperatura', 502.0000, 'ºC'),
	(102026, 109, '2015-03-15 00:38:56.000000', 'temperatura', 876.0000, 'ºC'),
	(102027, 109, '2015-03-15 00:38:57.000000', 'temperatura', 473.0000, 'ºC'),
	(102028, 109, '2015-03-15 00:38:58.000000', 'temperatura', 939.0000, 'ºC'),
	(102029, 109, '2015-03-15 00:38:59.000000', 'temperatura', 875.0000, 'ºC'),
	(102030, 109, '2015-03-15 00:39:00.000000', 'temperatura', 359.0000, 'ºC'),
	(102031, 109, '2015-03-15 00:39:01.000000', 'temperatura', 370.0000, 'ºC'),
	(102032, 109, '2015-03-15 00:39:02.000000', 'temperatura', 772.0000, 'ºC'),
	(102033, 109, '2015-03-15 00:39:03.000000', 'temperatura', 351.0000, 'ºC'),
	(102034, 109, '2015-03-15 00:39:04.000000', 'temperatura', 639.0000, 'ºC'),
	(102035, 109, '2015-03-15 00:39:05.000000', 'temperatura', 945.0000, 'ºC'),
	(102036, 109, '2015-03-15 00:39:06.000000', 'temperatura', 408.0000, 'ºC'),
	(102037, 109, '2015-03-15 00:39:07.000000', 'temperatura', 407.0000, 'ºC'),
	(102038, 109, '2015-03-15 00:39:08.000000', 'temperatura', 809.0000, 'ºC'),
	(102039, 109, '2015-03-15 00:39:09.000000', 'temperatura', 426.0000, 'ºC'),
	(102040, 109, '2015-03-15 00:39:10.000000', 'temperatura', 904.0000, 'ºC'),
	(102041, 109, '2015-03-15 00:39:11.000000', 'temperatura', 843.0000, 'ºC'),
	(102042, 109, '2015-03-15 00:39:12.000000', 'temperatura', 302.0000, 'ºC'),
	(102043, 109, '2015-03-15 00:39:13.000000', 'temperatura', 181.0000, 'ºC'),
	(102044, 109, '2015-03-15 00:39:14.000000', 'temperatura', 1.0000, 'ºC'),
	(102045, 109, '2015-03-15 00:39:15.000000', 'temperatura', 661.0000, 'ºC'),
	(102046, 109, '2015-03-15 00:39:16.000000', 'temperatura', 904.0000, 'ºC'),
	(102047, 109, '2015-03-15 00:39:17.000000', 'temperatura', 137.0000, 'ºC'),
	(102048, 109, '2015-03-15 00:39:18.000000', 'temperatura', 374.0000, 'ºC'),
	(102049, 109, '2015-03-15 00:39:19.000000', 'temperatura', 257.0000, 'ºC'),
	(102050, 109, '2015-03-15 00:39:20.000000', 'temperatura', 165.0000, 'ºC'),
	(102051, 109, '2015-03-15 00:39:21.000000', 'temperatura', 55.0000, 'ºC'),
	(102052, 109, '2015-03-15 00:39:22.000000', 'temperatura', 982.0000, 'ºC'),
	(102053, 109, '2015-03-15 00:39:23.000000', 'temperatura', 1145.0000, 'ºC'),
	(102054, 109, '2015-03-15 00:39:24.000000', 'temperatura', 380.0000, 'ºC'),
	(102055, 109, '2015-03-15 00:39:25.000000', 'temperatura', 866.0000, 'ºC'),
	(102056, 109, '2015-03-15 00:39:26.000000', 'temperatura', 791.0000, 'ºC'),
	(102057, 109, '2015-03-15 00:39:27.000000', 'temperatura', 158.0000, 'ºC'),
	(102058, 109, '2015-03-15 00:39:28.000000', 'temperatura', 817.0000, 'ºC'),
	(102059, 109, '2015-03-15 00:39:29.000000', 'temperatura', 11.0000, 'ºC'),
	(102060, 109, '2015-03-15 00:39:30.000000', 'temperatura', 5.0000, 'ºC'),
	(102061, 109, '2015-03-15 00:39:31.000000', 'temperatura', 1193.0000, 'ºC'),
	(102062, 109, '2015-03-15 00:39:32.000000', 'temperatura', 1151.0000, 'ºC'),
	(102063, 109, '2015-03-15 00:39:33.000000', 'temperatura', 975.0000, 'ºC'),
	(102064, 109, '2015-03-15 00:39:34.000000', 'temperatura', 224.0000, 'ºC'),
	(102065, 109, '2015-03-15 00:39:35.000000', 'temperatura', 594.0000, 'ºC'),
	(102066, 109, '2015-03-15 00:39:36.000000', 'temperatura', 1100.0000, 'ºC'),
	(102067, 109, '2015-03-15 00:39:37.000000', 'temperatura', 116.0000, 'ºC'),
	(102068, 109, '2015-03-15 00:39:38.000000', 'temperatura', 881.0000, 'ºC'),
	(102069, 109, '2015-03-15 00:39:39.000000', 'temperatura', 459.0000, 'ºC'),
	(102070, 109, '2015-03-15 00:39:40.000000', 'temperatura', 851.0000, 'ºC'),
	(102071, 109, '2015-03-15 00:39:41.000000', 'temperatura', 477.0000, 'ºC'),
	(102072, 109, '2015-03-15 00:39:42.000000', 'temperatura', 1035.0000, 'ºC'),
	(102073, 109, '2015-03-15 00:39:43.000000', 'temperatura', 142.0000, 'ºC'),
	(102074, 109, '2015-03-15 00:39:44.000000', 'temperatura', 7.0000, 'ºC'),
	(102075, 109, '2015-03-15 00:39:45.000000', 'temperatura', 811.0000, 'ºC'),
	(102076, 109, '2015-03-15 00:39:46.000000', 'temperatura', 432.0000, 'ºC'),
	(102077, 109, '2015-03-15 00:39:47.000000', 'temperatura', 928.0000, 'ºC'),
	(102078, 109, '2015-03-15 00:39:48.000000', 'temperatura', 944.0000, 'ºC'),
	(102079, 109, '2015-03-15 00:39:49.000000', 'temperatura', 736.0000, 'ºC'),
	(102080, 109, '2015-03-15 00:39:50.000000', 'temperatura', 849.0000, 'ºC'),
	(102081, 109, '2015-03-15 00:39:51.000000', 'temperatura', 839.0000, 'ºC'),
	(102082, 109, '2015-03-15 00:39:52.000000', 'temperatura', 446.0000, 'ºC'),
	(102083, 109, '2015-03-15 00:39:53.000000', 'temperatura', 915.0000, 'ºC'),
	(102084, 109, '2015-03-15 00:39:54.000000', 'temperatura', 837.0000, 'ºC'),
	(102085, 109, '2015-03-15 00:39:55.000000', 'temperatura', 239.0000, 'ºC'),
	(102086, 109, '2015-03-15 00:39:56.000000', 'temperatura', 1084.0000, 'ºC'),
	(102087, 109, '2015-03-15 00:39:57.000000', 'temperatura', 1104.0000, 'ºC'),
	(102088, 109, '2015-03-15 00:39:58.000000', 'temperatura', 1071.0000, 'ºC'),
	(102089, 109, '2015-03-15 00:39:59.000000', 'temperatura', 843.0000, 'ºC'),
	(102090, 109, '2015-03-15 00:40:00.000000', 'temperatura', 1000.0000, 'ºC'),
	(102091, 109, '2015-03-15 00:40:01.000000', 'temperatura', 72.0000, 'ºC'),
	(102092, 109, '2015-03-15 00:40:02.000000', 'temperatura', 961.0000, 'ºC'),
	(102093, 109, '2015-03-15 00:40:03.000000', 'temperatura', 988.0000, 'ºC'),
	(102094, 109, '2015-03-15 00:40:04.000000', 'temperatura', 857.0000, 'ºC'),
	(102095, 109, '2015-03-15 00:40:05.000000', 'temperatura', 123.0000, 'ºC'),
	(102096, 109, '2015-03-15 00:40:06.000000', 'temperatura', 444.0000, 'ºC'),
	(102097, 109, '2015-03-15 00:40:07.000000', 'temperatura', 652.0000, 'ºC'),
	(102098, 109, '2015-03-15 00:40:08.000000', 'temperatura', 727.0000, 'ºC'),
	(102099, 109, '2015-03-15 00:40:09.000000', 'temperatura', 481.0000, 'ºC'),
	(102100, 109, '2015-03-15 00:40:10.000000', 'temperatura', 225.0000, 'ºC'),
	(102101, 109, '2015-03-15 00:40:11.000000', 'temperatura', 883.0000, 'ºC'),
	(102102, 109, '2015-03-15 00:40:12.000000', 'temperatura', 140.0000, 'ºC'),
	(102103, 109, '2015-03-15 00:40:13.000000', 'temperatura', 453.0000, 'ºC'),
	(102104, 109, '2015-03-15 00:40:14.000000', 'temperatura', 646.0000, 'ºC'),
	(102105, 109, '2015-03-15 00:40:15.000000', 'temperatura', 671.0000, 'ºC'),
	(102106, 109, '2015-03-15 00:40:16.000000', 'temperatura', 216.0000, 'ºC'),
	(102107, 109, '2015-03-15 00:40:17.000000', 'temperatura', 270.0000, 'ºC'),
	(102108, 109, '2015-03-15 00:40:18.000000', 'temperatura', 702.0000, 'ºC'),
	(102109, 109, '2015-03-15 00:40:19.000000', 'temperatura', 299.0000, 'ºC'),
	(102110, 109, '2015-03-15 00:40:20.000000', 'temperatura', 591.0000, 'ºC'),
	(102111, 109, '2015-03-15 00:40:21.000000', 'temperatura', 858.0000, 'ºC'),
	(102112, 109, '2015-03-15 00:40:22.000000', 'temperatura', 119.0000, 'ºC'),
	(102113, 109, '2015-03-15 00:40:23.000000', 'temperatura', 421.0000, 'ºC'),
	(102114, 109, '2015-03-15 00:40:24.000000', 'temperatura', 549.0000, 'ºC'),
	(102115, 109, '2015-03-15 00:40:25.000000', 'temperatura', 281.0000, 'ºC'),
	(102116, 109, '2015-03-15 00:40:26.000000', 'temperatura', 959.0000, 'ºC'),
	(102117, 109, '2015-03-15 00:40:27.000000', 'temperatura', 353.0000, 'ºC'),
	(102118, 109, '2015-03-15 00:40:28.000000', 'temperatura', 86.0000, 'ºC'),
	(102119, 109, '2015-03-15 00:40:29.000000', 'temperatura', 573.0000, 'ºC'),
	(102120, 109, '2015-03-15 00:40:30.000000', 'temperatura', 210.0000, 'ºC'),
	(102121, 109, '2015-03-15 00:40:31.000000', 'temperatura', 528.0000, 'ºC'),
	(102122, 109, '2015-03-15 00:40:32.000000', 'temperatura', 811.0000, 'ºC'),
	(102123, 109, '2015-03-15 00:40:33.000000', 'temperatura', 73.0000, 'ºC'),
	(102124, 109, '2015-03-15 00:40:34.000000', 'temperatura', 330.0000, 'ºC'),
	(102125, 109, '2015-03-15 00:40:35.000000', 'temperatura', 234.0000, 'ºC'),
	(102126, 109, '2015-03-15 00:40:36.000000', 'temperatura', 179.0000, 'ºC'),
	(102127, 109, '2015-03-15 00:40:37.000000', 'temperatura', 195.0000, 'ºC'),
	(102128, 109, '2015-03-15 00:40:38.000000', 'temperatura', 440.0000, 'ºC'),
	(102129, 109, '2015-03-15 00:40:39.000000', 'temperatura', 414.0000, 'ºC'),
	(102130, 109, '2015-03-15 00:40:40.000000', 'temperatura', 748.0000, 'ºC'),
	(102131, 109, '2015-03-15 00:40:41.000000', 'temperatura', 102.0000, 'ºC'),
	(102132, 109, '2015-03-15 00:40:42.000000', 'temperatura', 665.0000, 'ºC'),
	(102133, 109, '2015-03-15 00:40:43.000000', 'temperatura', 621.0000, 'ºC'),
	(102134, 109, '2015-03-15 00:40:44.000000', 'temperatura', 1111.0000, 'ºC'),
	(102135, 109, '2015-03-15 00:40:45.000000', 'temperatura', 93.0000, 'ºC'),
	(102136, 109, '2015-03-15 00:40:46.000000', 'temperatura', 733.0000, 'ºC'),
	(102137, 109, '2015-03-15 00:40:47.000000', 'temperatura', 984.0000, 'ºC'),
	(102138, 109, '2015-03-15 00:40:48.000000', 'temperatura', 322.0000, 'ºC'),
	(102139, 109, '2015-03-15 00:40:49.000000', 'temperatura', 1059.0000, 'ºC'),
	(102140, 109, '2015-03-15 00:40:50.000000', 'temperatura', 730.0000, 'ºC'),
	(102141, 109, '2015-03-15 00:40:51.000000', 'temperatura', 472.0000, 'ºC'),
	(102142, 109, '2015-03-15 00:40:52.000000', 'temperatura', 170.0000, 'ºC'),
	(102143, 109, '2015-03-15 00:40:53.000000', 'temperatura', 636.0000, 'ºC'),
	(102144, 109, '2015-03-15 00:40:54.000000', 'temperatura', 268.0000, 'ºC'),
	(102145, 109, '2015-03-15 00:40:55.000000', 'temperatura', 634.0000, 'ºC'),
	(102146, 109, '2015-03-15 00:40:56.000000', 'temperatura', 1167.0000, 'ºC'),
	(102147, 109, '2015-03-15 00:40:57.000000', 'temperatura', 333.0000, 'ºC'),
	(102148, 109, '2015-03-15 00:40:58.000000', 'temperatura', 565.0000, 'ºC'),
	(102149, 109, '2015-03-15 00:40:59.000000', 'temperatura', 627.0000, 'ºC'),
	(102150, 109, '2015-03-15 00:41:00.000000', 'temperatura', 238.0000, 'ºC'),
	(102151, 109, '2015-03-15 00:41:01.000000', 'temperatura', 511.0000, 'ºC'),
	(102152, 109, '2015-03-15 00:41:02.000000', 'temperatura', 643.0000, 'ºC'),
	(102153, 109, '2015-03-15 00:41:03.000000', 'temperatura', 483.0000, 'ºC'),
	(102154, 109, '2015-03-15 00:41:04.000000', 'temperatura', 484.0000, 'ºC'),
	(102155, 109, '2015-03-15 00:41:05.000000', 'temperatura', 971.0000, 'ºC'),
	(102156, 109, '2015-03-15 00:41:06.000000', 'temperatura', 1006.0000, 'ºC'),
	(102157, 109, '2015-03-15 00:41:07.000000', 'temperatura', 914.0000, 'ºC'),
	(102158, 109, '2015-03-15 00:41:08.000000', 'temperatura', 356.0000, 'ºC'),
	(102159, 109, '2015-03-15 00:41:09.000000', 'temperatura', 237.0000, 'ºC'),
	(102160, 109, '2015-03-15 00:41:10.000000', 'temperatura', 119.0000, 'ºC'),
	(102161, 109, '2015-03-15 00:41:11.000000', 'temperatura', 1082.0000, 'ºC'),
	(102162, 109, '2015-03-15 00:41:12.000000', 'temperatura', 256.0000, 'ºC'),
	(102163, 109, '2015-03-15 00:41:13.000000', 'temperatura', 435.0000, 'ºC'),
	(102164, 109, '2015-03-15 00:41:14.000000', 'temperatura', 206.0000, 'ºC'),
	(102165, 109, '2015-03-15 00:41:15.000000', 'temperatura', 924.0000, 'ºC'),
	(102166, 109, '2015-03-15 00:41:16.000000', 'temperatura', 404.0000, 'ºC'),
	(102167, 109, '2015-03-15 00:41:17.000000', 'temperatura', 449.0000, 'ºC'),
	(102168, 109, '2015-03-15 00:41:18.000000', 'temperatura', 1033.0000, 'ºC'),
	(102169, 109, '2015-03-15 00:41:19.000000', 'temperatura', 217.0000, 'ºC'),
	(102170, 109, '2015-03-15 00:41:20.000000', 'temperatura', 387.0000, 'ºC'),
	(102171, 109, '2015-03-15 00:41:21.000000', 'temperatura', 85.0000, 'ºC'),
	(102172, 109, '2015-03-15 00:41:22.000000', 'temperatura', 465.0000, 'ºC'),
	(102173, 109, '2015-03-15 00:41:23.000000', 'temperatura', 871.0000, 'ºC'),
	(102174, 109, '2015-03-15 00:41:24.000000', 'temperatura', 561.0000, 'ºC'),
	(102175, 109, '2015-03-15 00:41:25.000000', 'temperatura', 190.0000, 'ºC'),
	(102176, 109, '2015-03-15 00:41:26.000000', 'temperatura', 468.0000, 'ºC'),
	(102177, 109, '2015-03-15 00:41:27.000000', 'temperatura', 573.0000, 'ºC'),
	(102178, 109, '2015-03-15 00:41:28.000000', 'temperatura', 261.0000, 'ºC'),
	(102179, 109, '2015-03-15 00:41:29.000000', 'temperatura', 784.0000, 'ºC'),
	(102180, 109, '2015-03-15 00:41:30.000000', 'temperatura', 739.0000, 'ºC'),
	(102181, 109, '2015-03-15 00:41:31.000000', 'temperatura', 145.0000, 'ºC'),
	(102182, 109, '2015-03-15 00:41:32.000000', 'temperatura', 907.0000, 'ºC'),
	(102183, 109, '2015-03-15 00:41:33.000000', 'temperatura', 503.0000, 'ºC'),
	(102184, 109, '2015-03-15 00:41:34.000000', 'temperatura', 992.0000, 'ºC'),
	(102185, 109, '2015-03-15 00:41:35.000000', 'temperatura', 1052.0000, 'ºC'),
	(102186, 109, '2015-03-15 00:41:36.000000', 'temperatura', 1084.0000, 'ºC'),
	(102187, 109, '2015-03-15 00:41:37.000000', 'temperatura', 1064.0000, 'ºC'),
	(102188, 109, '2015-03-15 00:41:38.000000', 'temperatura', 868.0000, 'ºC'),
	(102189, 109, '2015-03-15 00:41:39.000000', 'temperatura', 1147.0000, 'ºC'),
	(102190, 109, '2015-03-15 00:41:40.000000', 'temperatura', 734.0000, 'ºC'),
	(102191, 109, '2015-03-15 00:41:41.000000', 'temperatura', 230.0000, 'ºC'),
	(102192, 109, '2015-03-15 00:41:42.000000', 'temperatura', 149.0000, 'ºC'),
	(102193, 109, '2015-03-15 00:41:43.000000', 'temperatura', 53.0000, 'ºC'),
	(102194, 109, '2015-03-15 00:41:44.000000', 'temperatura', 1021.0000, 'ºC'),
	(102195, 109, '2015-03-15 00:41:45.000000', 'temperatura', 145.0000, 'ºC'),
	(102196, 109, '2015-03-15 00:41:46.000000', 'temperatura', 62.0000, 'ºC'),
	(102197, 109, '2015-03-15 00:41:47.000000', 'temperatura', 1077.0000, 'ºC'),
	(102198, 109, '2015-03-15 00:41:48.000000', 'temperatura', 398.0000, 'ºC'),
	(102199, 109, '2015-03-15 00:41:49.000000', 'temperatura', 1162.0000, 'ºC'),
	(102200, 109, '2015-03-15 00:41:50.000000', 'temperatura', 1014.0000, 'ºC'),
	(102201, 109, '2015-03-15 00:41:51.000000', 'temperatura', 387.0000, 'ºC'),
	(102202, 109, '2015-03-15 00:41:52.000000', 'temperatura', 92.0000, 'ºC'),
	(102203, 109, '2015-03-15 00:41:53.000000', 'temperatura', 501.0000, 'ºC'),
	(102204, 109, '2015-03-15 00:41:54.000000', 'temperatura', 1027.0000, 'ºC'),
	(102205, 109, '2015-03-15 00:41:55.000000', 'temperatura', 33.0000, 'ºC'),
	(102206, 109, '2015-03-15 00:41:56.000000', 'temperatura', 686.0000, 'ºC'),
	(102207, 109, '2015-03-15 00:41:57.000000', 'temperatura', 930.0000, 'ºC'),
	(102208, 109, '2015-03-15 00:41:58.000000', 'temperatura', 191.0000, 'ºC'),
	(102209, 109, '2015-03-15 00:41:59.000000', 'temperatura', 568.0000, 'ºC'),
	(102210, 109, '2015-03-15 00:42:00.000000', 'temperatura', 1068.0000, 'ºC'),
	(102211, 109, '2015-03-15 00:42:01.000000', 'temperatura', 36.0000, 'ºC'),
	(102212, 109, '2015-03-15 00:42:02.000000', 'temperatura', 576.0000, 'ºC'),
	(102213, 109, '2015-03-15 00:42:03.000000', 'temperatura', 371.0000, 'ºC'),
	(102214, 109, '2015-03-15 00:42:04.000000', 'temperatura', 130.0000, 'ºC'),
	(102215, 109, '2015-03-15 00:42:05.000000', 'temperatura', 736.0000, 'ºC'),
	(102216, 109, '2015-03-15 00:42:06.000000', 'temperatura', 892.0000, 'ºC'),
	(102217, 109, '2015-03-15 00:42:07.000000', 'temperatura', 1053.0000, 'ºC'),
	(102218, 109, '2015-03-15 00:42:08.000000', 'temperatura', 187.0000, 'ºC'),
	(102219, 109, '2015-03-15 00:42:09.000000', 'temperatura', 180.0000, 'ºC'),
	(102220, 109, '2015-03-15 00:42:10.000000', 'temperatura', 336.0000, 'ºC'),
	(102221, 109, '2015-03-15 00:42:11.000000', 'temperatura', 1142.0000, 'ºC'),
	(102222, 109, '2015-03-15 00:42:12.000000', 'temperatura', 1103.0000, 'ºC'),
	(102223, 109, '2015-03-15 00:42:13.000000', 'temperatura', 888.0000, 'ºC'),
	(102224, 109, '2015-03-15 00:42:14.000000', 'temperatura', 1134.0000, 'ºC'),
	(102225, 109, '2015-03-15 00:42:15.000000', 'temperatura', 606.0000, 'ºC'),
	(102226, 109, '2015-03-15 00:42:16.000000', 'temperatura', 826.0000, 'ºC'),
	(102227, 109, '2015-03-15 00:42:17.000000', 'temperatura', 1115.0000, 'ºC'),
	(102228, 109, '2015-03-15 00:42:18.000000', 'temperatura', 698.0000, 'ºC'),
	(102229, 109, '2015-03-15 00:42:19.000000', 'temperatura', 145.0000, 'ºC'),
	(102230, 109, '2015-03-15 00:42:20.000000', 'temperatura', 1033.0000, 'ºC'),
	(102231, 109, '2015-03-15 00:42:21.000000', 'temperatura', 1128.0000, 'ºC'),
	(102232, 109, '2015-03-15 00:42:22.000000', 'temperatura', 143.0000, 'ºC'),
	(102233, 109, '2015-03-15 00:42:23.000000', 'temperatura', 929.0000, 'ºC'),
	(102234, 109, '2015-03-15 00:42:24.000000', 'temperatura', 620.0000, 'ºC'),
	(102235, 109, '2015-03-15 00:42:25.000000', 'temperatura', 311.0000, 'ºC'),
	(102236, 109, '2015-03-15 00:42:26.000000', 'temperatura', 897.0000, 'ºC'),
	(102237, 109, '2015-03-15 00:42:27.000000', 'temperatura', 1152.0000, 'ºC'),
	(102238, 109, '2015-03-15 00:42:28.000000', 'temperatura', 671.0000, 'ºC'),
	(102239, 109, '2015-03-15 00:42:29.000000', 'temperatura', 1098.0000, 'ºC'),
	(102240, 109, '2015-03-15 00:42:30.000000', 'temperatura', 1078.0000, 'ºC'),
	(102241, 109, '2015-03-15 00:42:31.000000', 'temperatura', 897.0000, 'ºC'),
	(102242, 109, '2015-03-15 00:42:32.000000', 'temperatura', 51.0000, 'ºC'),
	(102243, 109, '2015-03-15 00:42:33.000000', 'temperatura', 1166.0000, 'ºC'),
	(102244, 109, '2015-03-15 00:42:34.000000', 'temperatura', 875.0000, 'ºC'),
	(102245, 109, '2015-03-15 00:42:35.000000', 'temperatura', 880.0000, 'ºC'),
	(102246, 109, '2015-03-15 00:42:36.000000', 'temperatura', 576.0000, 'ºC'),
	(102247, 109, '2015-03-15 00:42:37.000000', 'temperatura', 238.0000, 'ºC'),
	(102248, 109, '2015-03-15 00:42:38.000000', 'temperatura', 662.0000, 'ºC'),
	(102249, 109, '2015-03-15 00:42:39.000000', 'temperatura', 198.0000, 'ºC'),
	(102250, 109, '2015-03-15 00:42:40.000000', 'temperatura', 206.0000, 'ºC'),
	(102251, 109, '2015-03-15 00:42:41.000000', 'temperatura', 436.0000, 'ºC'),
	(102252, 109, '2015-03-15 00:42:42.000000', 'temperatura', 362.0000, 'ºC'),
	(102253, 109, '2015-03-15 00:42:43.000000', 'temperatura', 501.0000, 'ºC'),
	(102254, 109, '2015-03-15 00:42:44.000000', 'temperatura', 220.0000, 'ºC'),
	(102255, 109, '2015-03-15 00:42:45.000000', 'temperatura', 799.0000, 'ºC'),
	(102256, 109, '2015-03-15 00:42:46.000000', 'temperatura', 936.0000, 'ºC'),
	(102257, 109, '2015-03-15 00:42:47.000000', 'temperatura', 1081.0000, 'ºC'),
	(102258, 109, '2015-03-15 00:42:48.000000', 'temperatura', 198.0000, 'ºC'),
	(102259, 109, '2015-03-15 00:42:49.000000', 'temperatura', 148.0000, 'ºC'),
	(102260, 109, '2015-03-15 00:42:50.000000', 'temperatura', 145.0000, 'ºC'),
	(102261, 109, '2015-03-15 00:42:51.000000', 'temperatura', 281.0000, 'ºC'),
	(102262, 109, '2015-03-15 00:42:52.000000', 'temperatura', 973.0000, 'ºC'),
	(102263, 109, '2015-03-15 00:42:53.000000', 'temperatura', 421.0000, 'ºC'),
	(102264, 109, '2015-03-15 00:42:54.000000', 'temperatura', 385.0000, 'ºC'),
	(102265, 109, '2015-03-15 00:42:55.000000', 'temperatura', 663.0000, 'ºC'),
	(102266, 109, '2015-03-15 00:42:56.000000', 'temperatura', 963.0000, 'ºC'),
	(102267, 109, '2015-03-15 00:42:57.000000', 'temperatura', 425.0000, 'ºC'),
	(102268, 109, '2015-03-15 00:42:58.000000', 'temperatura', 436.0000, 'ºC'),
	(102269, 109, '2015-03-15 00:42:59.000000', 'temperatura', 904.0000, 'ºC'),
	(102270, 109, '2015-03-15 00:43:00.000000', 'temperatura', 815.0000, 'ºC'),
	(102271, 109, '2015-03-15 00:43:01.000000', 'temperatura', 162.0000, 'ºC'),
	(102272, 109, '2015-03-15 00:43:02.000000', 'temperatura', 768.0000, 'ºC'),
	(102273, 109, '2015-03-15 00:43:03.000000', 'temperatura', 952.0000, 'ºC'),
	(102274, 109, '2015-03-15 00:43:04.000000', 'temperatura', 58.0000, 'ºC'),
	(102275, 109, '2015-03-15 00:43:05.000000', 'temperatura', 1032.0000, 'ºC'),
	(102276, 109, '2015-03-15 00:43:06.000000', 'temperatura', 189.0000, 'ºC'),
	(102277, 109, '2015-03-15 00:43:07.000000', 'temperatura', 249.0000, 'ºC'),
	(102278, 109, '2015-03-15 00:43:08.000000', 'temperatura', 676.0000, 'ºC'),
	(102279, 109, '2015-03-15 00:43:09.000000', 'temperatura', 237.0000, 'ºC'),
	(102280, 109, '2015-03-15 00:43:10.000000', 'temperatura', 356.0000, 'ºC'),
	(102281, 109, '2015-03-15 00:43:11.000000', 'temperatura', 1071.0000, 'ºC'),
	(102282, 109, '2015-03-15 00:43:12.000000', 'temperatura', 686.0000, 'ºC'),
	(102283, 109, '2015-03-15 00:43:13.000000', 'temperatura', 219.0000, 'ºC'),
	(102284, 109, '2015-03-15 00:43:14.000000', 'temperatura', 235.0000, 'ºC'),
	(102285, 109, '2015-03-15 00:43:15.000000', 'temperatura', 522.0000, 'ºC'),
	(102286, 109, '2015-03-15 00:43:16.000000', 'temperatura', 702.0000, 'ºC'),
	(102287, 109, '2015-03-15 00:43:17.000000', 'temperatura', 745.0000, 'ºC'),
	(102288, 109, '2015-03-15 00:43:18.000000', 'temperatura', 422.0000, 'ºC'),
	(102289, 109, '2015-03-15 00:43:19.000000', 'temperatura', 1073.0000, 'ºC'),
	(102290, 109, '2015-03-15 00:43:20.000000', 'temperatura', 498.0000, 'ºC'),
	(102291, 109, '2015-03-15 00:43:21.000000', 'temperatura', 474.0000, 'ºC'),
	(102292, 109, '2015-03-15 00:43:22.000000', 'temperatura', 877.0000, 'ºC'),
	(102293, 109, '2015-03-15 00:43:23.000000', 'temperatura', 561.0000, 'ºC'),
	(102294, 109, '2015-03-15 00:43:24.000000', 'temperatura', 174.0000, 'ºC'),
	(102295, 109, '2015-03-15 00:43:25.000000', 'temperatura', 389.0000, 'ºC'),
	(102296, 109, '2015-03-15 00:43:26.000000', 'temperatura', 223.0000, 'ºC'),
	(102297, 109, '2015-03-15 00:43:27.000000', 'temperatura', 1147.0000, 'ºC'),
	(102298, 109, '2015-03-15 00:43:28.000000', 'temperatura', 269.0000, 'ºC'),
	(102299, 109, '2015-03-15 00:43:29.000000', 'temperatura', 301.0000, 'ºC'),
	(102300, 109, '2015-03-15 00:43:30.000000', 'temperatura', 702.0000, 'ºC'),
	(102301, 109, '2015-03-15 00:43:31.000000', 'temperatura', 207.0000, 'ºC'),
	(102302, 109, '2015-03-15 00:43:32.000000', 'temperatura', 130.0000, 'ºC'),
	(102303, 109, '2015-03-15 00:43:33.000000', 'temperatura', 29.0000, 'ºC'),
	(102304, 109, '2015-03-15 00:43:34.000000', 'temperatura', 956.0000, 'ºC'),
	(102305, 109, '2015-03-15 00:43:35.000000', 'temperatura', 1092.0000, 'ºC'),
	(102306, 109, '2015-03-15 00:43:36.000000', 'temperatura', 193.0000, 'ºC'),
	(102307, 109, '2015-03-15 00:43:37.000000', 'temperatura', 91.0000, 'ºC'),
	(102308, 109, '2015-03-15 00:43:38.000000', 'temperatura', 1073.0000, 'ºC'),
	(102309, 109, '2015-03-15 00:43:39.000000', 'temperatura', 296.0000, 'ºC'),
	(102310, 109, '2015-03-15 00:43:40.000000', 'temperatura', 662.0000, 'ºC'),
	(102311, 109, '2015-03-15 00:43:41.000000', 'temperatura', 22.0000, 'ºC'),
	(102312, 109, '2015-03-15 00:43:42.000000', 'temperatura', 525.0000, 'ºC'),
	(102313, 109, '2015-03-15 00:43:43.000000', 'temperatura', 157.0000, 'ºC'),
	(102314, 109, '2015-03-15 00:43:44.000000', 'temperatura', 411.0000, 'ºC'),
	(102315, 109, '2015-03-15 00:43:45.000000', 'temperatura', 385.0000, 'ºC'),
	(102316, 109, '2015-03-15 00:43:46.000000', 'temperatura', 690.0000, 'ºC'),
	(102317, 109, '2015-03-15 00:43:47.000000', 'temperatura', 1099.0000, 'ºC'),
	(102318, 109, '2015-03-15 00:43:48.000000', 'temperatura', 1026.0000, 'ºC'),
	(102319, 109, '2015-03-15 00:43:49.000000', 'temperatura', 632.0000, 'ºC'),
	(102320, 109, '2015-03-15 00:43:50.000000', 'temperatura', 84.0000, 'ºC'),
	(102321, 109, '2015-03-15 00:43:51.000000', 'temperatura', 922.0000, 'ºC'),
	(102322, 109, '2015-03-15 00:43:52.000000', 'temperatura', 760.0000, 'ºC'),
	(102323, 109, '2015-03-15 00:43:53.000000', 'temperatura', 1033.0000, 'ºC'),
	(102324, 109, '2015-03-15 00:43:54.000000', 'temperatura', 488.0000, 'ºC'),
	(102325, 109, '2015-03-15 00:43:55.000000', 'temperatura', 540.0000, 'ºC'),
	(102326, 109, '2015-03-15 00:43:56.000000', 'temperatura', 39.0000, 'ºC'),
	(102327, 109, '2015-03-15 00:43:57.000000', 'temperatura', 973.0000, 'ºC'),
	(102328, 109, '2015-03-15 00:43:58.000000', 'temperatura', 1151.0000, 'ºC'),
	(102329, 109, '2015-03-15 00:43:59.000000', 'temperatura', 434.0000, 'ºC'),
	(102330, 109, '2015-03-15 00:44:00.000000', 'temperatura', 1120.0000, 'ºC'),
	(102331, 109, '2015-03-15 00:44:01.000000', 'temperatura', 699.0000, 'ºC'),
	(102332, 109, '2015-03-15 00:44:02.000000', 'temperatura', 135.0000, 'ºC'),
	(102333, 109, '2015-03-15 00:44:03.000000', 'temperatura', 979.0000, 'ºC'),
	(102334, 109, '2015-03-15 00:44:04.000000', 'temperatura', 890.0000, 'ºC'),
	(102335, 109, '2015-03-15 00:44:05.000000', 'temperatura', 315.0000, 'ºC'),
	(102336, 109, '2015-03-15 00:44:06.000000', 'temperatura', 104.0000, 'ºC'),
	(102337, 109, '2015-03-15 00:44:07.000000', 'temperatura', 777.0000, 'ºC'),
	(102338, 109, '2015-03-15 00:44:08.000000', 'temperatura', 1172.0000, 'ºC'),
	(102339, 109, '2015-03-15 00:44:09.000000', 'temperatura', 1132.0000, 'ºC'),
	(102340, 109, '2015-03-15 00:44:10.000000', 'temperatura', 941.0000, 'ºC'),
	(102341, 109, '2015-03-15 00:44:11.000000', 'temperatura', 111.0000, 'ºC'),
	(102342, 109, '2015-03-15 00:44:12.000000', 'temperatura', 132.0000, 'ºC'),
	(102343, 109, '2015-03-15 00:44:13.000000', 'temperatura', 329.0000, 'ºC'),
	(102344, 109, '2015-03-15 00:44:14.000000', 'temperatura', 50.0000, 'ºC'),
	(102345, 109, '2015-03-15 00:44:15.000000', 'temperatura', 462.0000, 'ºC'),
	(102346, 109, '2015-03-15 00:44:16.000000', 'temperatura', 960.0000, 'ºC'),
	(102347, 109, '2015-03-15 00:44:17.000000', 'temperatura', 1016.0000, 'ºC'),
	(102348, 109, '2015-03-15 00:44:18.000000', 'temperatura', 1002.0000, 'ºC'),
	(102349, 109, '2015-03-15 00:44:19.000000', 'temperatura', 760.0000, 'ºC'),
	(102350, 109, '2015-03-15 00:44:20.000000', 'temperatura', 794.0000, 'ºC'),
	(102351, 109, '2015-03-15 00:44:21.000000', 'temperatura', 490.0000, 'ºC'),
	(102352, 109, '2015-03-15 00:44:22.000000', 'temperatura', 67.0000, 'ºC'),
	(102353, 109, '2015-03-15 00:44:23.000000', 'temperatura', 69.0000, 'ºC'),
	(102354, 109, '2015-03-15 00:44:24.000000', 'temperatura', 145.0000, 'ºC'),
	(102355, 109, '2015-03-15 00:44:25.000000', 'temperatura', 516.0000, 'ºC'),
	(102356, 109, '2015-03-15 00:44:26.000000', 'temperatura', 945.0000, 'ºC'),
	(102357, 109, '2015-03-15 00:44:27.000000', 'temperatura', 777.0000, 'ºC'),
	(102358, 109, '2015-03-15 00:44:28.000000', 'temperatura', 1051.0000, 'ºC'),
	(102359, 109, '2015-03-15 00:44:29.000000', 'temperatura', 525.0000, 'ºC'),
	(102360, 109, '2015-03-15 00:44:30.000000', 'temperatura', 670.0000, 'ºC'),
	(102361, 109, '2015-03-15 00:44:31.000000', 'temperatura', 578.0000, 'ºC'),
	(102362, 109, '2015-03-15 00:44:32.000000', 'temperatura', 882.0000, 'ºC'),
	(102363, 109, '2015-03-15 00:44:33.000000', 'temperatura', 275.0000, 'ºC'),
	(102364, 109, '2015-03-15 00:44:34.000000', 'temperatura', 1127.0000, 'ºC'),
	(102365, 109, '2015-03-15 00:44:35.000000', 'temperatura', 14.0000, 'ºC'),
	(102366, 109, '2015-03-15 00:44:36.000000', 'temperatura', 288.0000, 'ºC'),
	(102367, 109, '2015-03-15 00:44:37.000000', 'temperatura', 200.0000, 'ºC'),
	(102368, 109, '2015-03-15 00:44:38.000000', 'temperatura', 137.0000, 'ºC'),
	(102369, 109, '2015-03-15 00:44:39.000000', 'temperatura', 84.0000, 'ºC'),
	(102370, 109, '2015-03-15 00:44:40.000000', 'temperatura', 9.0000, 'ºC'),
	(102371, 109, '2015-03-15 00:44:41.000000', 'temperatura', 995.0000, 'ºC'),
	(102372, 109, '2015-03-15 00:44:42.000000', 'temperatura', 148.0000, 'ºC'),
	(102373, 109, '2015-03-15 00:44:43.000000', 'temperatura', 155.0000, 'ºC'),
	(102374, 109, '2015-03-15 00:44:44.000000', 'temperatura', 332.0000, 'ºC'),
	(102375, 109, '2015-03-15 00:44:45.000000', 'temperatura', 1195.0000, 'ºC'),
	(102376, 109, '2015-03-15 00:44:46.000000', 'temperatura', 181.0000, 'ºC'),
	(102377, 109, '2015-03-15 00:44:47.000000', 'temperatura', 920.0000, 'ºC'),
	(102378, 109, '2015-03-15 00:44:48.000000', 'temperatura', 457.0000, 'ºC'),
	(102379, 109, '2015-03-15 00:44:49.000000', 'temperatura', 726.0000, 'ºC'),
	(102380, 109, '2015-03-15 00:44:50.000000', 'temperatura', 1058.0000, 'ºC'),
	(102381, 109, '2015-03-15 00:44:51.000000', 'temperatura', 712.0000, 'ºC'),
	(102382, 109, '2015-03-15 00:44:52.000000', 'temperatura', 387.0000, 'ºC'),
	(102383, 109, '2015-03-15 00:44:53.000000', 'temperatura', 999.0000, 'ºC'),
	(102384, 109, '2015-03-15 00:44:54.000000', 'temperatura', 237.0000, 'ºC'),
	(102385, 109, '2015-03-15 00:44:55.000000', 'temperatura', 588.0000, 'ºC'),
	(102386, 109, '2015-03-15 00:44:56.000000', 'temperatura', 1028.0000, 'ºC'),
	(102387, 109, '2015-03-15 00:44:57.000000', 'temperatura', 978.0000, 'ºC'),
	(102388, 109, '2015-03-15 00:44:58.000000', 'temperatura', 604.0000, 'ºC'),
	(102389, 109, '2015-03-15 00:44:59.000000', 'temperatura', 89.0000, 'ºC'),
	(102390, 109, '2015-03-15 00:45:00.000000', 'temperatura', 1032.0000, 'ºC'),
	(102391, 109, '2015-03-15 00:45:01.000000', 'temperatura', 96.0000, 'ºC'),
	(102392, 109, '2015-03-15 00:45:02.000000', 'temperatura', 983.0000, 'ºC'),
	(102393, 109, '2015-03-15 00:45:03.000000', 'temperatura', 1027.0000, 'ºC'),
	(102394, 109, '2015-03-15 00:45:04.000000', 'temperatura', 986.0000, 'ºC'),
	(102395, 109, '2015-03-15 00:45:05.000000', 'temperatura', 650.0000, 'ºC'),
	(102396, 109, '2015-03-15 00:45:06.000000', 'temperatura', 291.0000, 'ºC'),
	(102397, 109, '2015-03-15 00:45:07.000000', 'temperatura', 706.0000, 'ºC'),
	(102398, 109, '2015-03-15 00:45:08.000000', 'temperatura', 257.0000, 'ºC'),
	(102399, 109, '2015-03-15 00:45:09.000000', 'temperatura', 369.0000, 'ºC'),
	(102400, 109, '2015-03-15 00:45:10.000000', 'temperatura', 1072.0000, 'ºC'),
	(102401, 109, '2015-03-15 00:45:11.000000', 'temperatura', 657.0000, 'ºC'),
	(102402, 109, '2015-03-15 00:45:12.000000', 'temperatura', 67.0000, 'ºC'),
	(102403, 109, '2015-03-15 00:45:13.000000', 'temperatura', 766.0000, 'ºC'),
	(102404, 109, '2015-03-15 00:45:14.000000', 'temperatura', 28.0000, 'ºC'),
	(102405, 109, '2015-03-15 00:45:15.000000', 'temperatura', 243.0000, 'ºC'),
	(102406, 109, '2015-03-15 00:45:16.000000', 'temperatura', 1133.0000, 'ºC'),
	(102407, 109, '2015-03-15 00:45:17.000000', 'temperatura', 136.0000, 'ºC'),
	(102408, 109, '2015-03-15 00:45:18.000000', 'temperatura', 883.0000, 'ºC'),
	(102409, 109, '2015-03-15 00:45:19.000000', 'temperatura', 406.0000, 'ºC'),
	(102410, 109, '2015-03-15 00:45:20.000000', 'temperatura', 580.0000, 'ºC'),
	(102411, 109, '2015-03-15 00:45:21.000000', 'temperatura', 484.0000, 'ºC'),
	(102412, 109, '2015-03-15 00:45:22.000000', 'temperatura', 682.0000, 'ºC'),
	(102413, 109, '2015-03-15 00:45:23.000000', 'temperatura', 759.0000, 'ºC'),
	(102414, 109, '2015-03-15 00:45:24.000000', 'temperatura', 548.0000, 'ºC'),
	(102415, 109, '2015-03-15 00:45:25.000000', 'temperatura', 464.0000, 'ºC'),
	(102416, 109, '2015-03-15 00:45:26.000000', 'temperatura', 677.0000, 'ºC'),
	(102417, 109, '2015-03-15 00:45:27.000000', 'temperatura', 792.0000, 'ºC'),
	(102418, 109, '2015-03-15 00:45:28.000000', 'temperatura', 728.0000, 'ºC'),
	(102419, 109, '2015-03-15 00:45:29.000000', 'temperatura', 67.0000, 'ºC'),
	(102420, 109, '2015-03-15 00:45:30.000000', 'temperatura', 550.0000, 'ºC'),
	(102421, 109, '2015-03-15 00:45:31.000000', 'temperatura', 151.0000, 'ºC'),
	(102422, 109, '2015-03-15 00:45:32.000000', 'temperatura', 306.0000, 'ºC'),
	(102423, 109, '2015-03-15 00:45:33.000000', 'temperatura', 1076.0000, 'ºC'),
	(102424, 109, '2015-03-15 00:45:34.000000', 'temperatura', 864.0000, 'ºC'),
	(102425, 109, '2015-03-15 00:45:35.000000', 'temperatura', 1091.0000, 'ºC'),
	(102426, 109, '2015-03-15 00:45:36.000000', 'temperatura', 465.0000, 'ºC'),
	(102427, 109, '2015-03-15 00:45:37.000000', 'temperatura', 251.0000, 'ºC'),
	(102428, 109, '2015-03-15 00:45:38.000000', 'temperatura', 1060.0000, 'ºC'),
	(102429, 109, '2015-03-15 00:45:39.000000', 'temperatura', 949.0000, 'ºC'),
	(102430, 109, '2015-03-15 00:45:40.000000', 'temperatura', 363.0000, 'ºC'),
	(102431, 109, '2015-03-15 00:45:41.000000', 'temperatura', 171.0000, 'ºC'),
	(102432, 109, '2015-03-15 00:45:42.000000', 'temperatura', 964.0000, 'ºC'),
	(102433, 109, '2015-03-15 00:45:43.000000', 'temperatura', 710.0000, 'ºC'),
	(102434, 109, '2015-03-15 00:45:44.000000', 'temperatura', 660.0000, 'ºC'),
	(102435, 109, '2015-03-15 00:45:45.000000', 'temperatura', 1168.0000, 'ºC'),
	(102436, 109, '2015-03-15 00:45:46.000000', 'temperatura', 260.0000, 'ºC'),
	(102437, 109, '2015-03-15 00:45:47.000000', 'temperatura', 196.0000, 'ºC'),
	(102438, 109, '2015-03-15 00:45:48.000000', 'temperatura', 201.0000, 'ºC'),
	(102439, 109, '2015-03-15 00:45:49.000000', 'temperatura', 418.0000, 'ºC'),
	(102440, 109, '2015-03-15 00:45:50.000000', 'temperatura', 288.0000, 'ºC'),
	(102441, 109, '2015-03-15 00:45:51.000000', 'temperatura', 184.0000, 'ºC'),
	(102442, 109, '2015-03-15 00:45:52.000000', 'temperatura', 60.0000, 'ºC'),
	(102443, 109, '2015-03-15 00:45:53.000000', 'temperatura', 947.0000, 'ºC'),
	(102444, 109, '2015-03-15 00:45:54.000000', 'temperatura', 955.0000, 'ºC'),
	(102445, 109, '2015-03-15 00:45:55.000000', 'temperatura', 736.0000, 'ºC'),
	(102446, 109, '2015-03-15 00:45:56.000000', 'temperatura', 814.0000, 'ºC'),
	(102447, 109, '2015-03-15 00:45:57.000000', 'temperatura', 664.0000, 'ºC'),
	(102448, 109, '2015-03-15 00:45:58.000000', 'temperatura', 876.0000, 'ºC'),
	(102449, 109, '2015-03-15 00:45:59.000000', 'temperatura', 1188.0000, 'ºC'),
	(102450, 109, '2015-03-15 00:46:00.000000', 'temperatura', 916.0000, 'ºC'),
	(102451, 109, '2015-03-15 00:46:01.000000', 'temperatura', 1014.0000, 'ºC'),
	(102452, 109, '2015-03-15 00:46:02.000000', 'temperatura', 1125.0000, 'ºC'),
	(102453, 109, '2015-03-15 00:46:03.000000', 'temperatura', 181.0000, 'ºC'),
	(102454, 109, '2015-03-15 00:46:04.000000', 'temperatura', 1131.0000, 'ºC'),
	(102455, 109, '2015-03-15 00:46:05.000000', 'temperatura', 311.0000, 'ºC'),
	(102456, 109, '2015-03-15 00:46:06.000000', 'temperatura', 565.0000, 'ºC'),
	(102457, 109, '2015-03-15 00:46:07.000000', 'temperatura', 690.0000, 'ºC'),
	(102458, 109, '2015-03-15 00:46:08.000000', 'temperatura', 558.0000, 'ºC'),
	(102459, 109, '2015-03-15 00:46:09.000000', 'temperatura', 721.0000, 'ºC'),
	(102460, 109, '2015-03-15 00:46:10.000000', 'temperatura', 732.0000, 'ºC'),
	(102461, 109, '2015-03-15 00:46:11.000000', 'temperatura', 298.0000, 'ºC'),
	(102462, 109, '2015-03-15 00:46:12.000000', 'temperatura', 493.0000, 'ºC'),
	(102463, 109, '2015-03-15 00:46:13.000000', 'temperatura', 370.0000, 'ºC'),
	(102464, 109, '2015-03-15 00:46:14.000000', 'temperatura', 373.0000, 'ºC'),
	(102465, 109, '2015-03-15 00:46:15.000000', 'temperatura', 757.0000, 'ºC'),
	(102466, 109, '2015-03-15 00:46:16.000000', 'temperatura', 264.0000, 'ºC'),
	(102467, 109, '2015-03-15 00:46:17.000000', 'temperatura', 251.0000, 'ºC'),
	(102468, 109, '2015-03-15 00:46:18.000000', 'temperatura', 463.0000, 'ºC'),
	(102469, 109, '2015-03-15 00:46:19.000000', 'temperatura', 362.0000, 'ºC'),
	(102470, 109, '2015-03-15 00:46:20.000000', 'temperatura', 422.0000, 'ºC'),
	(102471, 109, '2015-03-15 00:46:21.000000', 'temperatura', 1025.0000, 'ºC'),
	(102472, 109, '2015-03-15 00:46:22.000000', 'temperatura', 258.0000, 'ºC'),
	(102473, 109, '2015-03-15 00:46:23.000000', 'temperatura', 614.0000, 'ºC'),
	(102474, 109, '2015-03-15 00:46:24.000000', 'temperatura', 1099.0000, 'ºC'),
	(102475, 109, '2015-03-15 00:46:25.000000', 'temperatura', 54.0000, 'ºC'),
	(102476, 109, '2015-03-15 00:46:26.000000', 'temperatura', 574.0000, 'ºC'),
	(102477, 109, '2015-03-15 00:46:27.000000', 'temperatura', 307.0000, 'ºC'),
	(102478, 109, '2015-03-15 00:46:28.000000', 'temperatura', 1014.0000, 'ºC'),
	(102479, 109, '2015-03-15 00:46:29.000000', 'temperatura', 550.0000, 'ºC'),
	(102480, 109, '2015-03-15 00:46:30.000000', 'temperatura', 908.0000, 'ºC'),
	(102481, 109, '2015-03-15 00:46:31.000000', 'temperatura', 492.0000, 'ºC'),
	(102482, 109, '2015-03-15 00:46:32.000000', 'temperatura', 934.0000, 'ºC'),
	(102483, 109, '2015-03-15 00:46:33.000000', 'temperatura', 796.0000, 'ºC'),
	(102484, 109, '2015-03-15 00:46:34.000000', 'temperatura', 1180.0000, 'ºC'),
	(102485, 109, '2015-03-15 00:46:35.000000', 'temperatura', 1112.0000, 'ºC'),
	(102486, 109, '2015-03-15 00:46:36.000000', 'temperatura', 821.0000, 'ºC'),
	(102487, 109, '2015-03-15 00:46:37.000000', 'temperatura', 770.0000, 'ºC'),
	(102488, 109, '2015-03-15 00:46:38.000000', 'temperatura', 187.0000, 'ºC'),
	(102489, 109, '2015-03-15 00:46:39.000000', 'temperatura', 1024.0000, 'ºC'),
	(102490, 109, '2015-03-15 00:46:40.000000', 'temperatura', 961.0000, 'ºC'),
	(102491, 109, '2015-03-15 00:46:41.000000', 'temperatura', 535.0000, 'ºC'),
	(102492, 109, '2015-03-15 00:46:42.000000', 'temperatura', 991.0000, 'ºC'),
	(102493, 109, '2015-03-15 00:46:43.000000', 'temperatura', 951.0000, 'ºC'),
	(102494, 109, '2015-03-15 00:46:44.000000', 'temperatura', 582.0000, 'ºC'),
	(102495, 109, '2015-03-15 00:46:45.000000', 'temperatura', 60.0000, 'ºC'),
	(102496, 109, '2015-03-15 00:46:46.000000', 'temperatura', 951.0000, 'ºC'),
	(102497, 109, '2015-03-15 00:46:47.000000', 'temperatura', 978.0000, 'ºC'),
	(102498, 109, '2015-03-15 00:46:48.000000', 'temperatura', 838.0000, 'ºC'),
	(102499, 109, '2015-03-15 00:46:49.000000', 'temperatura', 54.0000, 'ºC'),
	(102500, 109, '2015-03-15 00:46:50.000000', 'temperatura', 157.0000, 'ºC'),
	(102501, 109, '2015-03-15 00:46:51.000000', 'temperatura', 623.0000, 'ºC'),
	(102502, 109, '2015-03-15 00:46:52.000000', 'temperatura', 244.0000, 'ºC'),
	(102503, 109, '2015-03-15 00:46:53.000000', 'temperatura', 554.0000, 'ºC'),
	(102504, 109, '2015-03-15 00:46:54.000000', 'temperatura', 838.0000, 'ºC'),
	(102505, 109, '2015-03-15 00:46:55.000000', 'temperatura', 127.0000, 'ºC'),
	(102506, 109, '2015-03-15 00:46:56.000000', 'temperatura', 522.0000, 'ºC'),
	(102507, 109, '2015-03-15 00:46:57.000000', 'temperatura', 1031.0000, 'ºC'),
	(102508, 109, '2015-03-15 00:46:58.000000', 'temperatura', 1189.0000, 'ºC'),
	(102509, 109, '2015-03-15 00:46:59.000000', 'temperatura', 452.0000, 'ºC'),
	(102510, 109, '2015-03-15 00:47:00.000000', 'temperatura', 1093.0000, 'ºC'),
	(102511, 109, '2015-03-15 00:47:01.000000', 'temperatura', 512.0000, 'ºC'),
	(102512, 109, '2015-03-15 00:47:02.000000', 'temperatura', 480.0000, 'ºC'),
	(102513, 109, '2015-03-15 00:47:03.000000', 'temperatura', 866.0000, 'ºC'),
	(102514, 109, '2015-03-15 00:47:04.000000', 'temperatura', 491.0000, 'ºC'),
	(102515, 109, '2015-03-15 00:47:05.000000', 'temperatura', 1058.0000, 'ºC'),
	(102516, 109, '2015-03-15 00:47:06.000000', 'temperatura', 217.0000, 'ºC'),
	(102517, 109, '2015-03-15 00:47:07.000000', 'temperatura', 311.0000, 'ºC'),
	(102518, 109, '2015-03-15 00:47:08.000000', 'temperatura', 904.0000, 'ºC'),
	(102519, 109, '2015-03-15 00:47:09.000000', 'temperatura', 1190.0000, 'ºC'),
	(102520, 109, '2015-03-15 00:47:10.000000', 'temperatura', 836.0000, 'ºC'),
	(102521, 109, '2015-03-15 00:47:11.000000', 'temperatura', 610.0000, 'ºC'),
	(102522, 109, '2015-03-15 00:47:12.000000', 'temperatura', 542.0000, 'ºC'),
	(102523, 109, '2015-03-15 00:47:13.000000', 'temperatura', 881.0000, 'ºC'),
	(102524, 109, '2015-03-15 00:47:14.000000', 'temperatura', 380.0000, 'ºC'),
	(102525, 109, '2015-03-15 00:47:15.000000', 'temperatura', 458.0000, 'ºC'),
	(102526, 109, '2015-03-15 00:47:16.000000', 'temperatura', 1151.0000, 'ºC'),
	(102527, 109, '2015-03-15 00:47:17.000000', 'temperatura', 782.0000, 'ºC'),
	(102528, 109, '2015-03-15 00:47:18.000000', 'temperatura', 458.0000, 'ºC'),
	(102529, 109, '2015-03-15 00:47:19.000000', 'temperatura', 1141.0000, 'ºC'),
	(102530, 109, '2015-03-15 00:47:20.000000', 'temperatura', 735.0000, 'ºC'),
	(102531, 109, '2015-03-15 00:47:21.000000', 'temperatura', 252.0000, 'ºC'),
	(102532, 109, '2015-03-15 00:47:22.000000', 'temperatura', 256.0000, 'ºC'),
	(102533, 109, '2015-03-15 00:47:23.000000', 'temperatura', 526.0000, 'ºC'),
	(102534, 109, '2015-03-15 00:47:24.000000', 'temperatura', 660.0000, 'ºC'),
	(102535, 109, '2015-03-15 00:47:25.000000', 'temperatura', 524.0000, 'ºC'),
	(102536, 109, '2015-03-15 00:47:26.000000', 'temperatura', 641.0000, 'ºC'),
	(102537, 109, '2015-03-15 00:47:27.000000', 'temperatura', 434.0000, 'ºC'),
	(102538, 109, '2015-03-15 00:47:28.000000', 'temperatura', 246.0000, 'ºC'),
	(102539, 109, '2015-03-15 00:47:29.000000', 'temperatura', 1130.0000, 'ºC'),
	(102540, 109, '2015-03-15 00:47:30.000000', 'temperatura', 113.0000, 'ºC'),
	(102541, 109, '2015-03-15 00:47:31.000000', 'temperatura', 774.0000, 'ºC'),
	(102542, 109, '2015-03-15 00:47:32.000000', 'temperatura', 1133.0000, 'ºC'),
	(102543, 109, '2015-03-15 00:47:33.000000', 'temperatura', 943.0000, 'ºC'),
	(102544, 109, '2015-03-15 00:47:34.000000', 'temperatura', 116.0000, 'ºC'),
	(102545, 109, '2015-03-15 00:47:35.000000', 'temperatura', 152.0000, 'ºC'),
	(102546, 109, '2015-03-15 00:47:36.000000', 'temperatura', 414.0000, 'ºC'),
	(102547, 109, '2015-03-15 00:47:37.000000', 'temperatura', 414.0000, 'ºC'),
	(102548, 109, '2015-03-15 00:47:38.000000', 'temperatura', 827.0000, 'ºC'),
	(102549, 109, '2015-03-15 00:47:39.000000', 'temperatura', 492.0000, 'ºC'),
	(102550, 109, '2015-03-15 00:47:40.000000', 'temperatura', 1181.0000, 'ºC'),
	(102551, 109, '2015-03-15 00:47:41.000000', 'temperatura', 831.0000, 'ºC'),
	(102552, 109, '2015-03-15 00:47:42.000000', 'temperatura', 612.0000, 'ºC'),
	(102553, 109, '2015-03-15 00:47:43.000000', 'temperatura', 569.0000, 'ºC'),
	(102554, 109, '2015-03-15 00:47:44.000000', 'temperatura', 1006.0000, 'ºC'),
	(102555, 109, '2015-03-15 00:47:45.000000', 'temperatura', 926.0000, 'ºC'),
	(102556, 109, '2015-03-15 00:47:46.000000', 'temperatura', 410.0000, 'ºC'),
	(102557, 109, '2015-03-15 00:47:47.000000', 'temperatura', 473.0000, 'ºC'),
	(102558, 109, '2015-03-15 00:47:48.000000', 'temperatura', 1135.0000, 'ºC'),
	(102559, 109, '2015-03-15 00:47:49.000000', 'temperatura', 658.0000, 'ºC'),
	(102560, 109, '2015-03-15 00:47:50.000000', 'temperatura', 1084.0000, 'ºC'),
	(102561, 109, '2015-03-15 00:47:51.000000', 'temperatura', 1049.0000, 'ºC'),
	(102562, 109, '2015-03-15 00:47:52.000000', 'temperatura', 792.0000, 'ºC'),
	(102563, 109, '2015-03-15 00:47:53.000000', 'temperatura', 815.0000, 'ºC'),
	(102564, 109, '2015-03-15 00:47:54.000000', 'temperatura', 497.0000, 'ºC'),
	(102565, 109, '2015-03-15 00:47:55.000000', 'temperatura', 41.0000, 'ºC'),
	(102566, 109, '2015-03-15 00:47:56.000000', 'temperatura', 1114.0000, 'ºC'),
	(102567, 109, '2015-03-15 00:47:57.000000', 'temperatura', 649.0000, 'ºC'),
	(102568, 109, '2015-03-15 00:47:58.000000', 'temperatura', 1101.0000, 'ºC'),
	(102569, 109, '2015-03-15 00:47:59.000000', 'temperatura', 1161.0000, 'ºC'),
	(102570, 109, '2015-03-15 00:48:00.000000', 'temperatura', 103.0000, 'ºC'),
	(102571, 109, '2015-03-15 00:48:01.000000', 'temperatura', 632.0000, 'ºC'),
	(102572, 109, '2015-03-15 00:48:02.000000', 'temperatura', 449.0000, 'ºC'),
	(102573, 109, '2015-03-15 00:48:03.000000', 'temperatura', 352.0000, 'ºC'),
	(102574, 109, '2015-03-15 00:48:04.000000', 'temperatura', 413.0000, 'ºC'),
	(102575, 109, '2015-03-15 00:48:05.000000', 'temperatura', 1008.0000, 'ºC'),
	(102576, 109, '2015-03-15 00:48:06.000000', 'temperatura', 204.0000, 'ºC'),
	(102577, 109, '2015-03-15 00:48:07.000000', 'temperatura', 393.0000, 'ºC'),
	(102578, 109, '2015-03-15 00:48:08.000000', 'temperatura', 157.0000, 'ºC'),
	(102579, 109, '2015-03-15 00:48:09.000000', 'temperatura', 806.0000, 'ºC'),
	(102580, 109, '2015-03-15 00:48:10.000000', 'temperatura', 1159.0000, 'ºC'),
	(102581, 109, '2015-03-15 00:48:11.000000', 'temperatura', 979.0000, 'ºC'),
	(102582, 109, '2015-03-15 00:48:12.000000', 'temperatura', 216.0000, 'ºC'),
	(102583, 109, '2015-03-15 00:48:13.000000', 'temperatura', 543.0000, 'ºC'),
	(102584, 109, '2015-03-15 00:48:14.000000', 'temperatura', 869.0000, 'ºC'),
	(102585, 109, '2015-03-15 00:48:15.000000', 'temperatura', 317.0000, 'ºC'),
	(102586, 109, '2015-03-15 00:48:16.000000', 'temperatura', 178.0000, 'ºC'),
	(102587, 109, '2015-03-15 00:48:17.000000', 'temperatura', 1141.0000, 'ºC'),
	(102588, 109, '2015-03-15 00:48:18.000000', 'temperatura', 370.0000, 'ºC'),
	(102589, 109, '2015-03-15 00:48:19.000000', 'temperatura', 830.0000, 'ºC'),
	(102590, 109, '2015-03-15 00:48:20.000000', 'temperatura', 638.0000, 'ºC'),
	(102591, 109, '2015-03-15 00:48:21.000000', 'temperatura', 702.0000, 'ºC'),
	(102592, 109, '2015-03-15 00:48:22.000000', 'temperatura', 396.0000, 'ºC'),
	(102593, 109, '2015-03-15 00:48:23.000000', 'temperatura', 1073.0000, 'ºC'),
	(102594, 109, '2015-03-15 00:48:24.000000', 'temperatura', 579.0000, 'ºC'),
	(102595, 109, '2015-03-15 00:48:25.000000', 'temperatura', 875.0000, 'ºC'),
	(102596, 109, '2015-03-15 00:48:26.000000', 'temperatura', 237.0000, 'ºC'),
	(102597, 109, '2015-03-15 00:48:27.000000', 'temperatura', 964.0000, 'ºC'),
	(102598, 109, '2015-03-15 00:48:28.000000', 'temperatura', 507.0000, 'ºC'),
	(102599, 109, '2015-03-15 00:48:29.000000', 'temperatura', 846.0000, 'ºC'),
	(102600, 109, '2015-03-15 00:48:30.000000', 'temperatura', 306.0000, 'ºC'),
	(102601, 109, '2015-03-15 00:48:31.000000', 'temperatura', 196.0000, 'ºC'),
	(102602, 109, '2015-03-15 00:48:32.000000', 'temperatura', 60.0000, 'ºC'),
	(102603, 109, '2015-03-15 00:48:33.000000', 'temperatura', 914.0000, 'ºC'),
	(102604, 109, '2015-03-15 00:48:34.000000', 'temperatura', 789.0000, 'ºC'),
	(102605, 109, '2015-03-15 00:48:35.000000', 'temperatura', 3.0000, 'ºC'),
	(102606, 109, '2015-03-15 00:48:36.000000', 'temperatura', 50.0000, 'ºC'),
	(102607, 109, '2015-03-15 00:48:37.000000', 'temperatura', 242.0000, 'ºC'),
	(102608, 109, '2015-03-15 00:48:38.000000', 'temperatura', 1058.0000, 'ºC'),
	(102609, 109, '2015-03-15 00:48:39.000000', 'temperatura', 965.0000, 'ºC'),
	(102610, 109, '2015-03-15 00:48:40.000000', 'temperatura', 453.0000, 'ºC'),
	(102611, 109, '2015-03-15 00:48:41.000000', 'temperatura', 571.0000, 'ºC'),
	(102612, 109, '2015-03-15 00:48:42.000000', 'temperatura', 295.0000, 'ºC'),
	(102613, 109, '2015-03-15 00:48:43.000000', 'temperatura', 962.0000, 'ºC'),
	(102614, 109, '2015-03-15 00:48:44.000000', 'temperatura', 326.0000, 'ºC'),
	(102615, 109, '2015-03-15 00:48:45.000000', 'temperatura', 1144.0000, 'ºC'),
	(102616, 109, '2015-03-15 00:48:46.000000', 'temperatura', 1144.0000, 'ºC'),
	(102617, 109, '2015-03-15 00:48:47.000000', 'temperatura', 1086.0000, 'ºC'),
	(102618, 109, '2015-03-15 00:48:48.000000', 'temperatura', 798.0000, 'ºC'),
	(102619, 109, '2015-03-15 00:48:49.000000', 'temperatura', 735.0000, 'ºC'),
	(102620, 109, '2015-03-15 00:48:50.000000', 'temperatura', 81.0000, 'ºC'),
	(102621, 109, '2015-03-15 00:48:51.000000', 'temperatura', 601.0000, 'ºC'),
	(102622, 109, '2015-03-15 00:48:52.000000', 'temperatura', 361.0000, 'ºC'),
	(102623, 109, '2015-03-15 00:48:53.000000', 'temperatura', 4.0000, 'ºC'),
	(102624, 109, '2015-03-15 00:48:54.000000', 'temperatura', 139.0000, 'ºC'),
	(102625, 109, '2015-03-15 00:48:55.000000', 'temperatura', 680.0000, 'ºC'),
	(102626, 109, '2015-03-15 00:48:56.000000', 'temperatura', 586.0000, 'ºC'),
	(102627, 109, '2015-03-15 00:48:57.000000', 'temperatura', 889.0000, 'ºC'),
	(102628, 109, '2015-03-15 00:48:58.000000', 'temperatura', 286.0000, 'ºC'),
	(102629, 109, '2015-03-15 00:48:59.000000', 'temperatura', 1165.0000, 'ºC'),
	(102630, 109, '2015-03-15 00:49:00.000000', 'temperatura', 168.0000, 'ºC'),
	(102631, 109, '2015-03-15 00:49:01.000000', 'temperatura', 943.0000, 'ºC'),
	(102632, 109, '2015-03-15 00:49:02.000000', 'temperatura', 614.0000, 'ºC'),
	(102633, 109, '2015-03-15 00:49:03.000000', 'temperatura', 241.0000, 'ºC'),
	(102634, 109, '2015-03-15 00:49:04.000000', 'temperatura', 563.0000, 'ºC'),
	(102635, 109, '2015-03-15 00:49:05.000000', 'temperatura', 893.0000, 'ºC'),
	(102636, 109, '2015-03-15 00:49:06.000000', 'temperatura', 378.0000, 'ºC'),
	(102637, 109, '2015-03-15 00:49:07.000000', 'temperatura', 412.0000, 'ºC'),
	(102638, 109, '2015-03-15 00:49:08.000000', 'temperatura', 924.0000, 'ºC'),
	(102639, 109, '2015-03-15 00:49:09.000000', 'temperatura', 985.0000, 'ºC'),
	(102640, 109, '2015-03-15 00:49:10.000000', 'temperatura', 952.0000, 'ºC'),
	(102641, 109, '2015-03-15 00:49:11.000000', 'temperatura', 607.0000, 'ºC'),
	(102642, 109, '2015-03-15 00:49:12.000000', 'temperatura', 178.0000, 'ºC'),
	(102643, 109, '2015-03-15 00:49:13.000000', 'temperatura', 268.0000, 'ºC'),
	(102644, 109, '2015-03-15 00:49:14.000000', 'temperatura', 810.0000, 'ºC'),
	(102645, 109, '2015-03-15 00:49:15.000000', 'temperatura', 846.0000, 'ºC'),
	(102646, 109, '2015-03-15 00:49:16.000000', 'temperatura', 599.0000, 'ºC'),
	(102647, 109, '2015-03-15 00:49:17.000000', 'temperatura', 457.0000, 'ºC'),
	(102648, 109, '2015-03-15 00:49:18.000000', 'temperatura', 488.0000, 'ºC'),
	(102649, 109, '2015-03-15 00:49:19.000000', 'temperatura', 1070.0000, 'ºC'),
	(102650, 109, '2015-03-15 00:49:20.000000', 'temperatura', 285.0000, 'ºC'),
	(102651, 109, '2015-03-15 00:49:21.000000', 'temperatura', 615.0000, 'ºC'),
	(102652, 109, '2015-03-15 00:49:22.000000', 'temperatura', 1023.0000, 'ºC'),
	(102653, 109, '2015-03-15 00:49:23.000000', 'temperatura', 871.0000, 'ºC'),
	(102654, 109, '2015-03-15 00:49:24.000000', 'temperatura', 84.0000, 'ºC'),
	(102655, 109, '2015-03-15 00:49:25.000000', 'temperatura', 210.0000, 'ºC'),
	(102656, 109, '2015-03-15 00:49:26.000000', 'temperatura', 796.0000, 'ºC'),
	(102657, 109, '2015-03-15 00:49:27.000000', 'temperatura', 951.0000, 'ºC'),
	(102658, 109, '2015-03-15 00:49:28.000000', 'temperatura', 1167.0000, 'ºC'),
	(102659, 109, '2015-03-15 00:49:29.000000', 'temperatura', 581.0000, 'ºC'),
	(102660, 109, '2015-03-15 00:49:30.000000', 'temperatura', 606.0000, 'ºC'),
	(102661, 109, '2015-03-15 00:49:31.000000', 'temperatura', 88.0000, 'ºC'),
	(102662, 109, '2015-03-15 00:49:32.000000', 'temperatura', 1023.0000, 'ºC'),
	(102663, 109, '2015-03-15 00:49:33.000000', 'temperatura', 50.0000, 'ºC'),
	(102664, 109, '2015-03-15 00:49:34.000000', 'temperatura', 784.0000, 'ºC'),
	(102665, 109, '2015-03-15 00:49:35.000000', 'temperatura', 167.0000, 'ºC'),
	(102666, 109, '2015-03-15 00:49:36.000000', 'temperatura', 886.0000, 'ºC'),
	(102667, 109, '2015-03-15 00:49:37.000000', 'temperatura', 330.0000, 'ºC'),
	(102668, 109, '2015-03-15 00:49:38.000000', 'temperatura', 193.0000, 'ºC'),
	(102669, 109, '2015-03-15 00:49:39.000000', 'temperatura', 1174.0000, 'ºC'),
	(102670, 109, '2015-03-15 00:49:40.000000', 'temperatura', 491.0000, 'ºC'),
	(102671, 109, '2015-03-15 00:49:41.000000', 'temperatura', 136.0000, 'ºC'),
	(102672, 109, '2015-03-15 00:49:42.000000', 'temperatura', 407.0000, 'ºC'),
	(102673, 109, '2015-03-15 00:49:43.000000', 'temperatura', 427.0000, 'ºC'),
	(102674, 109, '2015-03-15 00:49:44.000000', 'temperatura', 913.0000, 'ºC'),
	(102675, 109, '2015-03-15 00:49:45.000000', 'temperatura', 887.0000, 'ºC'),
	(102676, 109, '2015-03-15 00:49:46.000000', 'temperatura', 497.0000, 'ºC'),
	(102677, 109, '2015-03-15 00:49:47.000000', 'temperatura', 1021.0000, 'ºC'),
	(102678, 109, '2015-03-15 00:49:48.000000', 'temperatura', 18.0000, 'ºC'),
	(102679, 109, '2015-03-15 00:49:49.000000', 'temperatura', 626.0000, 'ºC'),
	(102680, 109, '2015-03-15 00:49:50.000000', 'temperatura', 678.0000, 'ºC'),
	(102681, 109, '2015-03-15 00:49:51.000000', 'temperatura', 312.0000, 'ºC'),
	(102682, 109, '2015-03-15 00:49:52.000000', 'temperatura', 726.0000, 'ºC'),
	(102683, 109, '2015-03-15 00:49:53.000000', 'temperatura', 293.0000, 'ºC'),
	(102684, 109, '2015-03-15 00:49:54.000000', 'temperatura', 488.0000, 'ºC'),
	(102685, 109, '2015-03-15 00:49:55.000000', 'temperatura', 362.0000, 'ºC'),
	(102686, 109, '2015-03-15 00:49:56.000000', 'temperatura', 345.0000, 'ºC'),
	(102687, 109, '2015-03-15 00:49:57.000000', 'temperatura', 642.0000, 'ºC'),
	(102688, 109, '2015-03-15 00:49:58.000000', 'temperatura', 973.0000, 'ºC'),
	(102689, 109, '2015-03-15 00:49:59.000000', 'temperatura', 540.0000, 'ºC'),
	(102690, 109, '2015-03-15 00:50:00.000000', 'temperatura', 981.0000, 'ºC'),
	(102691, 109, '2015-03-15 00:50:01.000000', 'temperatura', 888.0000, 'ºC'),
	(102692, 109, '2015-03-15 00:50:02.000000', 'temperatura', 296.0000, 'ºC'),
	(102693, 109, '2015-03-15 00:50:03.000000', 'temperatura', 17.0000, 'ºC'),
	(102694, 109, '2015-03-15 00:50:04.000000', 'temperatura', 397.0000, 'ºC'),
	(102695, 109, '2015-03-15 00:50:05.000000', 'temperatura', 736.0000, 'ºC'),
	(102696, 109, '2015-03-15 00:50:06.000000', 'temperatura', 90.0000, 'ºC'),
	(102697, 109, '2015-03-15 00:50:07.000000', 'temperatura', 642.0000, 'ºC'),
	(102698, 109, '2015-03-15 00:50:08.000000', 'temperatura', 539.0000, 'ºC'),
	(102699, 109, '2015-03-15 00:50:09.000000', 'temperatura', 772.0000, 'ºC'),
	(102700, 109, '2015-03-15 00:50:10.000000', 'temperatura', 1042.0000, 'ºC'),
	(102701, 109, '2015-03-15 00:50:11.000000', 'temperatura', 495.0000, 'ºC'),
	(102702, 109, '2015-03-15 00:50:12.000000', 'temperatura', 550.0000, 'ºC'),
	(102703, 109, '2015-03-15 00:50:13.000000', 'temperatura', 66.0000, 'ºC'),
	(102704, 109, '2015-03-15 00:50:14.000000', 'temperatura', 1078.0000, 'ºC'),
	(102705, 109, '2015-03-15 00:50:15.000000', 'temperatura', 394.0000, 'ºC'),
	(102706, 109, '2015-03-15 00:50:16.000000', 'temperatura', 1136.0000, 'ºC'),
	(102707, 109, '2015-03-15 00:50:17.000000', 'temperatura', 901.0000, 'ºC'),
	(102708, 109, '2015-03-15 00:50:18.000000', 'temperatura', 1095.0000, 'ºC'),
	(102709, 109, '2015-03-15 00:50:19.000000', 'temperatura', 371.0000, 'ºC'),
	(102710, 109, '2015-03-15 00:50:20.000000', 'temperatura', 974.0000, 'ºC'),
	(102711, 109, '2015-03-15 00:50:21.000000', 'temperatura', 155.0000, 'ºC'),
	(102712, 109, '2015-03-15 00:50:22.000000', 'temperatura', 254.0000, 'ºC'),
	(102713, 109, '2015-03-15 00:50:23.000000', 'temperatura', 808.0000, 'ºC'),
	(102714, 109, '2015-03-15 00:50:24.000000', 'temperatura', 876.0000, 'ºC'),
	(102715, 109, '2015-03-15 00:50:25.000000', 'temperatura', 755.0000, 'ºC'),
	(102716, 109, '2015-03-15 00:50:26.000000', 'temperatura', 1150.0000, 'ºC'),
	(102717, 109, '2015-03-15 00:50:27.000000', 'temperatura', 1084.0000, 'ºC'),
	(102718, 109, '2015-03-15 00:50:28.000000', 'temperatura', 770.0000, 'ºC'),
	(102719, 109, '2015-03-15 00:50:29.000000', 'temperatura', 600.0000, 'ºC'),
	(102720, 109, '2015-03-15 00:50:30.000000', 'temperatura', 692.0000, 'ºC'),
	(102721, 109, '2015-03-15 00:50:31.000000', 'temperatura', 457.0000, 'ºC'),
	(102722, 109, '2015-03-15 00:50:32.000000', 'temperatura', 211.0000, 'ºC'),
	(102723, 109, '2015-03-15 00:50:33.000000', 'temperatura', 883.0000, 'ºC'),
	(102724, 109, '2015-03-15 00:50:34.000000', 'temperatura', 184.0000, 'ºC'),
	(102725, 109, '2015-03-15 00:50:35.000000', 'temperatura', 670.0000, 'ºC'),
	(102726, 109, '2015-03-15 00:50:36.000000', 'temperatura', 397.0000, 'ºC'),
	(102727, 109, '2015-03-15 00:50:37.000000', 'temperatura', 1179.0000, 'ºC'),
	(102728, 109, '2015-03-15 00:50:38.000000', 'temperatura', 1103.0000, 'ºC'),
	(102729, 109, '2015-03-15 00:50:39.000000', 'temperatura', 778.0000, 'ºC'),
	(102730, 109, '2015-03-15 00:50:40.000000', 'temperatura', 580.0000, 'ºC'),
	(102731, 109, '2015-03-15 00:50:41.000000', 'temperatura', 569.0000, 'ºC'),
	(102732, 109, '2015-03-15 00:50:42.000000', 'temperatura', 1104.0000, 'ºC'),
	(102733, 109, '2015-03-15 00:50:43.000000', 'temperatura', 214.0000, 'ºC'),
	(102734, 109, '2015-03-15 00:50:44.000000', 'temperatura', 157.0000, 'ºC'),
	(102735, 109, '2015-03-15 00:50:45.000000', 'temperatura', 145.0000, 'ºC'),
	(102736, 109, '2015-03-15 00:50:46.000000', 'temperatura', 253.0000, 'ºC'),
	(102737, 109, '2015-03-15 00:50:47.000000', 'temperatura', 830.0000, 'ºC'),
	(102738, 109, '2015-03-15 00:50:48.000000', 'temperatura', 990.0000, 'ºC'),
	(102739, 109, '2015-03-15 00:50:49.000000', 'temperatura', 64.0000, 'ºC'),
	(102740, 109, '2015-03-15 00:50:50.000000', 'temperatura', 948.0000, 'ºC'),
	(102741, 109, '2015-03-15 00:50:51.000000', 'temperatura', 950.0000, 'ºC'),
	(102742, 109, '2015-03-15 00:50:52.000000', 'temperatura', 708.0000, 'ºC'),
	(102743, 109, '2015-03-15 00:50:53.000000', 'temperatura', 690.0000, 'ºC'),
	(102744, 109, '2015-03-15 00:50:54.000000', 'temperatura', 126.0000, 'ºC'),
	(102745, 109, '2015-03-15 00:50:55.000000', 'temperatura', 959.0000, 'ºC'),
	(102746, 109, '2015-03-15 00:50:56.000000', 'temperatura', 818.0000, 'ºC'),
	(102747, 109, '2015-03-15 00:50:57.000000', 'temperatura', 13.0000, 'ºC'),
	(102748, 109, '2015-03-15 00:50:58.000000', 'temperatura', 13.0000, 'ºC'),
	(102749, 109, '2015-03-15 00:50:59.000000', 'temperatura', 24.0000, 'ºC'),
	(102750, 109, '2015-03-15 00:51:00.000000', 'temperatura', 82.0000, 'ºC'),
	(102751, 109, '2015-03-15 00:51:01.000000', 'temperatura', 340.0000, 'ºC'),
	(102752, 109, '2015-03-15 00:51:02.000000', 'temperatura', 253.0000, 'ºC'),
	(102753, 109, '2015-03-15 00:51:03.000000', 'temperatura', 247.0000, 'ºC'),
	(102754, 109, '2015-03-15 00:51:04.000000', 'temperatura', 477.0000, 'ºC'),
	(102755, 109, '2015-03-15 00:51:05.000000', 'temperatura', 444.0000, 'ºC'),
	(102756, 109, '2015-03-15 00:51:06.000000', 'temperatura', 788.0000, 'ºC'),
	(102757, 109, '2015-03-15 00:51:07.000000', 'temperatura', 211.0000, 'ºC'),
	(102758, 109, '2015-03-15 00:51:08.000000', 'temperatura', 1092.0000, 'ºC'),
	(102759, 109, '2015-03-15 00:51:09.000000', 'temperatura', 27.0000, 'ºC'),
	(102760, 109, '2015-03-15 00:51:10.000000', 'temperatura', 461.0000, 'ºC'),
	(102761, 109, '2015-03-15 00:51:11.000000', 'temperatura', 1024.0000, 'ºC'),
	(102762, 109, '2015-03-15 00:51:12.000000', 'temperatura', 136.0000, 'ºC'),
	(102763, 109, '2015-03-15 00:51:13.000000', 'temperatura', 11.0000, 'ºC'),
	(102764, 109, '2015-03-15 00:51:14.000000', 'temperatura', 844.0000, 'ºC'),
	(102765, 109, '2015-03-15 00:51:15.000000', 'temperatura', 591.0000, 'ºC'),
	(102766, 109, '2015-03-15 00:51:16.000000', 'temperatura', 423.0000, 'ºC'),
	(102767, 109, '2015-03-15 00:51:17.000000', 'temperatura', 340.0000, 'ºC'),
	(102768, 109, '2015-03-15 00:51:18.000000', 'temperatura', 432.0000, 'ºC'),
	(102769, 109, '2015-03-15 00:51:19.000000', 'temperatura', 1143.0000, 'ºC'),
	(102770, 109, '2015-03-15 00:51:20.000000', 'temperatura', 819.0000, 'ºC'),
	(102771, 109, '2015-03-15 00:51:21.000000', 'temperatura', 665.0000, 'ºC'),
	(102772, 109, '2015-03-15 00:51:22.000000', 'temperatura', 869.0000, 'ºC'),
	(102773, 109, '2015-03-15 00:51:23.000000', 'temperatura', 1149.0000, 'ºC'),
	(102774, 109, '2015-03-15 00:51:24.000000', 'temperatura', 741.0000, 'ºC'),
	(102775, 109, '2015-03-15 00:51:25.000000', 'temperatura', 259.0000, 'ºC'),
	(102776, 109, '2015-03-15 00:51:26.000000', 'temperatura', 269.0000, 'ºC'),
	(102777, 109, '2015-03-15 00:51:27.000000', 'temperatura', 572.0000, 'ºC'),
	(102778, 109, '2015-03-15 00:51:28.000000', 'temperatura', 852.0000, 'ºC'),
	(102779, 109, '2015-03-15 00:51:29.000000', 'temperatura', 143.0000, 'ºC'),
	(102780, 109, '2015-03-15 00:51:30.000000', 'temperatura', 562.0000, 'ºC'),
	(102781, 109, '2015-03-15 00:51:31.000000', 'temperatura', 1181.0000, 'ºC'),
	(102782, 109, '2015-03-15 00:51:32.000000', 'temperatura', 618.0000, 'ºC'),
	(102783, 109, '2015-03-15 00:51:33.000000', 'temperatura', 750.0000, 'ºC'),
	(102784, 109, '2015-03-15 00:51:34.000000', 'temperatura', 694.0000, 'ºC'),
	(102785, 109, '2015-03-15 00:51:35.000000', 'temperatura', 20.0000, 'ºC'),
	(102786, 109, '2015-03-15 00:51:36.000000', 'temperatura', 419.0000, 'ºC'),
	(102787, 109, '2015-03-15 00:51:37.000000', 'temperatura', 837.0000, 'ºC'),
	(102788, 109, '2015-03-15 00:51:38.000000', 'temperatura', 526.0000, 'ºC'),
	(102789, 109, '2015-03-15 00:51:39.000000', 'temperatura', 119.0000, 'ºC'),
	(102790, 109, '2015-03-15 00:51:40.000000', 'temperatura', 219.0000, 'ºC'),
	(102791, 109, '2015-03-15 00:51:41.000000', 'temperatura', 739.0000, 'ºC'),
	(102792, 109, '2015-03-15 00:51:42.000000', 'temperatura', 637.0000, 'ºC'),
	(102793, 109, '2015-03-15 00:51:43.000000', 'temperatura', 971.0000, 'ºC'),
	(102794, 109, '2015-03-15 00:51:44.000000', 'temperatura', 544.0000, 'ºC'),
	(102795, 109, '2015-03-15 00:51:45.000000', 'temperatura', 1006.0000, 'ºC'),
	(102796, 109, '2015-03-15 00:51:46.000000', 'temperatura', 1000.0000, 'ºC'),
	(102797, 109, '2015-03-15 00:51:47.000000', 'temperatura', 782.0000, 'ºC'),
	(102798, 109, '2015-03-15 00:51:48.000000', 'temperatura', 909.0000, 'ºC'),
	(102799, 109, '2015-03-15 00:51:49.000000', 'temperatura', 1003.0000, 'ºC'),
	(102800, 109, '2015-03-15 00:51:50.000000', 'temperatura', 1085.0000, 'ºC'),
	(102801, 109, '2015-03-15 00:51:51.000000', 'temperatura', 17.0000, 'ºC'),
	(102802, 109, '2015-03-15 00:51:52.000000', 'temperatura', 430.0000, 'ºC'),
	(102803, 109, '2015-03-15 00:51:53.000000', 'temperatura', 902.0000, 'ºC'),
	(102804, 109, '2015-03-15 00:51:54.000000', 'temperatura', 819.0000, 'ºC'),
	(102805, 109, '2015-03-15 00:51:55.000000', 'temperatura', 190.0000, 'ºC'),
	(102806, 109, '2015-03-15 00:51:56.000000', 'temperatura', 892.0000, 'ºC'),
	(102807, 109, '2015-03-15 00:51:57.000000', 'temperatura', 293.0000, 'ºC'),
	(102808, 109, '2015-03-15 00:51:58.000000', 'temperatura', 1187.0000, 'ºC'),
	(102809, 109, '2015-03-15 00:51:59.000000', 'temperatura', 257.0000, 'ºC'),
	(102810, 109, '2015-03-15 00:52:00.000000', 'temperatura', 124.0000, 'ºC'),
	(102811, 109, '2015-03-15 00:52:01.000000', 'temperatura', 1052.0000, 'ºC'),
	(102812, 109, '2015-03-15 00:52:02.000000', 'temperatura', 86.0000, 'ºC'),
	(102813, 109, '2015-03-15 00:52:03.000000', 'temperatura', 877.0000, 'ºC'),
	(102814, 109, '2015-03-15 00:52:04.000000', 'temperatura', 527.0000, 'ºC'),
	(102815, 109, '2015-03-15 00:52:05.000000', 'temperatura', 3.0000, 'ºC'),
	(102816, 109, '2015-03-15 00:52:06.000000', 'temperatura', 834.0000, 'ºC'),
	(102817, 109, '2015-03-15 00:52:07.000000', 'temperatura', 563.0000, 'ºC'),
	(102818, 109, '2015-03-15 00:52:08.000000', 'temperatura', 311.0000, 'ºC'),
	(102819, 109, '2015-03-15 00:52:09.000000', 'temperatura', 1068.0000, 'ºC'),
	(102820, 109, '2015-03-15 00:52:10.000000', 'temperatura', 808.0000, 'ºC'),
	(102821, 109, '2015-03-15 00:52:11.000000', 'temperatura', 838.0000, 'ºC'),
	(102822, 109, '2015-03-15 00:52:12.000000', 'temperatura', 563.0000, 'ºC'),
	(102823, 109, '2015-03-15 00:52:13.000000', 'temperatura', 304.0000, 'ºC'),
	(102824, 109, '2015-03-15 00:52:14.000000', 'temperatura', 1031.0000, 'ºC'),
	(102825, 109, '2015-03-15 00:52:15.000000', 'temperatura', 644.0000, 'ºC'),
	(102826, 109, '2015-03-15 00:52:16.000000', 'temperatura', 125.0000, 'ºC'),
	(102827, 109, '2015-03-15 00:52:17.000000', 'temperatura', 1095.0000, 'ºC'),
	(102828, 109, '2015-03-15 00:52:18.000000', 'temperatura', 301.0000, 'ºC'),
	(102829, 109, '2015-03-15 00:52:19.000000', 'temperatura', 621.0000, 'ºC'),
	(102830, 109, '2015-03-15 00:52:20.000000', 'temperatura', 1004.0000, 'ºC'),
	(102831, 109, '2015-03-15 00:52:21.000000', 'temperatura', 755.0000, 'ºC'),
	(102832, 109, '2015-03-15 00:52:22.000000', 'temperatura', 762.0000, 'ºC'),
	(102833, 109, '2015-03-15 00:52:23.000000', 'temperatura', 349.0000, 'ºC'),
	(102834, 109, '2015-03-15 00:52:24.000000', 'temperatura', 658.0000, 'ºC'),
	(102835, 109, '2015-03-15 00:52:25.000000', 'temperatura', 1046.0000, 'ºC'),
	(102836, 109, '2015-03-15 00:52:26.000000', 'temperatura', 853.0000, 'ºC'),
	(102837, 109, '2015-03-15 00:52:27.000000', 'temperatura', 1128.0000, 'ºC'),
	(102838, 109, '2015-03-15 00:52:28.000000', 'temperatura', 681.0000, 'ºC'),
	(102839, 109, '2015-03-15 00:52:29.000000', 'temperatura', 23.0000, 'ºC'),
	(102840, 109, '2015-03-15 00:52:30.000000', 'temperatura', 471.0000, 'ºC'),
	(102841, 109, '2015-03-15 00:52:31.000000', 'temperatura', 1087.0000, 'ºC'),
	(102842, 109, '2015-03-15 00:52:32.000000', 'temperatura', 422.0000, 'ºC'),
	(102843, 109, '2015-03-15 00:52:33.000000', 'temperatura', 50.0000, 'ºC'),
	(102844, 109, '2015-03-15 00:52:34.000000', 'temperatura', 185.0000, 'ºC'),
	(102845, 109, '2015-03-15 00:52:35.000000', 'temperatura', 774.0000, 'ºC'),
	(102846, 109, '2015-03-15 00:52:36.000000', 'temperatura', 915.0000, 'ºC'),
	(102847, 109, '2015-03-15 00:52:37.000000', 'temperatura', 1055.0000, 'ºC'),
	(102848, 109, '2015-03-15 00:52:38.000000', 'temperatura', 131.0000, 'ºC'),
	(102849, 109, '2015-03-15 00:52:39.000000', 'temperatura', 1089.0000, 'ºC'),
	(102850, 109, '2015-03-15 00:52:40.000000', 'temperatura', 254.0000, 'ºC'),
	(102851, 109, '2015-03-15 00:52:41.000000', 'temperatura', 402.0000, 'ºC'),
	(102852, 109, '2015-03-15 00:52:42.000000', 'temperatura', 48.0000, 'ºC'),
	(102853, 109, '2015-03-15 00:52:43.000000', 'temperatura', 234.0000, 'ºC'),
	(102854, 109, '2015-03-15 00:52:44.000000', 'temperatura', 1028.0000, 'ºC'),
	(102855, 109, '2015-03-15 00:52:45.000000', 'temperatura', 839.0000, 'ºC'),
	(102856, 109, '2015-03-15 00:52:46.000000', 'temperatura', 1111.0000, 'ºC'),
	(102857, 109, '2015-03-15 00:52:47.000000', 'temperatura', 638.0000, 'ºC'),
	(102858, 109, '2015-03-15 00:52:48.000000', 'temperatura', 1056.0000, 'ºC'),
	(102859, 109, '2015-03-15 00:52:49.000000', 'temperatura', 967.0000, 'ºC'),
	(102860, 109, '2015-03-15 00:52:50.000000', 'temperatura', 467.0000, 'ºC'),
	(102861, 109, '2015-03-15 00:52:51.000000', 'temperatura', 637.0000, 'ºC'),
	(102862, 109, '2015-03-15 00:52:52.000000', 'temperatura', 584.0000, 'ºC'),
	(102863, 109, '2015-03-15 00:52:53.000000', 'temperatura', 1009.0000, 'ºC'),
	(102864, 109, '2015-03-15 00:52:54.000000', 'temperatura', 892.0000, 'ºC'),
	(102865, 109, '2015-03-15 00:52:55.000000', 'temperatura', 233.0000, 'ºC'),
	(102866, 109, '2015-03-15 00:52:56.000000', 'temperatura', 892.0000, 'ºC'),
	(102867, 109, '2015-03-15 00:52:57.000000', 'temperatura', 161.0000, 'ºC'),
	(102868, 109, '2015-03-15 00:52:58.000000', 'temperatura', 528.0000, 'ºC'),
	(102869, 109, '2015-03-15 00:52:59.000000', 'temperatura', 959.0000, 'ºC'),
	(102870, 109, '2015-03-15 00:53:00.000000', 'temperatura', 813.0000, 'ºC'),
	(102871, 109, '2015-03-15 00:53:01.000000', 'temperatura', 1187.0000, 'ºC'),
	(102872, 109, '2015-03-15 00:53:02.000000', 'temperatura', 1095.0000, 'ºC'),
	(102873, 109, '2015-03-15 00:53:03.000000', 'temperatura', 715.0000, 'ºC'),
	(102874, 109, '2015-03-15 00:53:04.000000', 'temperatura', 291.0000, 'ºC'),
	(102875, 109, '2015-03-15 00:53:05.000000', 'temperatura', 512.0000, 'ºC'),
	(102876, 109, '2015-03-15 00:53:06.000000', 'temperatura', 485.0000, 'ºC'),
	(102877, 109, '2015-03-15 00:53:07.000000', 'temperatura', 890.0000, 'ºC'),
	(102878, 109, '2015-03-15 00:53:08.000000', 'temperatura', 595.0000, 'ºC'),
	(102879, 109, '2015-03-15 00:53:09.000000', 'temperatura', 308.0000, 'ºC'),
	(102880, 109, '2015-03-15 00:53:10.000000', 'temperatura', 953.0000, 'ºC'),
	(102881, 109, '2015-03-15 00:53:11.000000', 'temperatura', 241.0000, 'ºC'),
	(102882, 109, '2015-03-15 00:53:12.000000', 'temperatura', 746.0000, 'ºC'),
	(102883, 109, '2015-03-15 00:53:13.000000', 'temperatura', 608.0000, 'ºC'),
	(102884, 109, '2015-03-15 00:53:14.000000', 'temperatura', 803.0000, 'ºC'),
	(102885, 109, '2015-03-15 00:53:15.000000', 'temperatura', 989.0000, 'ºC'),
	(102886, 109, '2015-03-15 00:53:16.000000', 'temperatura', 139.0000, 'ºC'),
	(102887, 109, '2015-03-15 00:53:17.000000', 'temperatura', 130.0000, 'ºC'),
	(102888, 109, '2015-03-15 00:53:18.000000', 'temperatura', 231.0000, 'ºC'),
	(102889, 109, '2015-03-15 00:53:19.000000', 'temperatura', 767.0000, 'ºC'),
	(102890, 109, '2015-03-15 00:53:20.000000', 'temperatura', 741.0000, 'ºC'),
	(102891, 109, '2015-03-15 00:53:21.000000', 'temperatura', 206.0000, 'ºC'),
	(102892, 109, '2015-03-15 00:53:22.000000', 'temperatura', 6.0000, 'ºC'),
	(102893, 109, '2015-03-15 00:53:23.000000', 'temperatura', 613.0000, 'ºC'),
	(102894, 109, '2015-03-15 00:53:24.000000', 'temperatura', 648.0000, 'ºC'),
	(102895, 109, '2015-03-15 00:53:25.000000', 'temperatura', 199.0000, 'ºC'),
	(102896, 109, '2015-03-15 00:53:26.000000', 'temperatura', 254.0000, 'ºC'),
	(102897, 109, '2015-03-15 00:53:27.000000', 'temperatura', 673.0000, 'ºC'),
	(102898, 109, '2015-03-15 00:53:28.000000', 'temperatura', 204.0000, 'ºC'),
	(102899, 109, '2015-03-15 00:53:29.000000', 'temperatura', 202.0000, 'ºC'),
	(102900, 109, '2015-03-15 00:53:30.000000', 'temperatura', 397.0000, 'ºC'),
	(102901, 109, '2015-03-15 00:53:31.000000', 'temperatura', 180.0000, 'ºC'),
	(102902, 109, '2015-03-15 00:53:32.000000', 'temperatura', 909.0000, 'ºC'),
	(102903, 109, '2015-03-15 00:53:33.000000', 'temperatura', 405.0000, 'ºC'),
	(102904, 109, '2015-03-15 00:53:34.000000', 'temperatura', 501.0000, 'ºC'),
	(102905, 109, '2015-03-15 00:53:35.000000', 'temperatura', 89.0000, 'ºC'),
	(102906, 109, '2015-03-15 00:53:36.000000', 'temperatura', 141.0000, 'ºC'),
	(102907, 109, '2015-03-15 00:53:37.000000', 'temperatura', 438.0000, 'ºC'),
	(102908, 109, '2015-03-15 00:53:38.000000', 'temperatura', 571.0000, 'ºC'),
	(102909, 109, '2015-03-15 00:53:39.000000', 'temperatura', 338.0000, 'ºC'),
	(102910, 109, '2015-03-15 00:53:40.000000', 'temperatura', 1180.0000, 'ºC'),
	(102911, 109, '2015-03-15 00:53:41.000000', 'temperatura', 86.0000, 'ºC'),
	(102912, 109, '2015-03-15 00:53:42.000000', 'temperatura', 489.0000, 'ºC'),
	(102913, 109, '2015-03-15 00:53:43.000000', 'temperatura', 990.0000, 'ºC'),
	(102914, 109, '2015-03-15 00:53:44.000000', 'temperatura', 1080.0000, 'ºC'),
	(102915, 109, '2015-03-15 00:53:45.000000', 'temperatura', 34.0000, 'ºC'),
	(102916, 109, '2015-03-15 00:53:46.000000', 'temperatura', 529.0000, 'ºC'),
	(102917, 109, '2015-03-15 00:53:47.000000', 'temperatura', 142.0000, 'ºC'),
	(102918, 109, '2015-03-15 00:53:48.000000', 'temperatura', 323.0000, 'ºC'),
	(102919, 109, '2015-03-15 00:53:49.000000', 'temperatura', 1190.0000, 'ºC'),
	(102920, 109, '2015-03-15 00:53:50.000000', 'temperatura', 183.0000, 'ºC'),
	(102921, 109, '2015-03-15 00:53:51.000000', 'temperatura', 946.0000, 'ºC'),
	(102922, 109, '2015-03-15 00:53:52.000000', 'temperatura', 583.0000, 'ºC'),
	(102923, 109, '2015-03-15 00:53:53.000000', 'temperatura', 74.0000, 'ºC'),
	(102924, 109, '2015-03-15 00:53:54.000000', 'temperatura', 1024.0000, 'ºC'),
	(102925, 109, '2015-03-15 00:53:55.000000', 'temperatura', 98.0000, 'ºC'),
	(102926, 109, '2015-03-15 00:53:56.000000', 'temperatura', 1019.0000, 'ºC'),
	(102927, 109, '2015-03-15 00:53:57.000000', 'temperatura', 1.0000, 'ºC'),
	(102928, 109, '2015-03-15 00:53:58.000000', 'temperatura', 548.0000, 'ºC'),
	(102929, 109, '2015-03-15 00:53:59.000000', 'temperatura', 339.0000, 'ºC'),
	(102930, 109, '2015-03-15 00:54:00.000000', 'temperatura', 50.0000, 'ºC'),
	(102931, 109, '2015-03-15 00:54:01.000000', 'temperatura', 433.0000, 'ºC'),
	(102932, 109, '2015-03-15 00:54:02.000000', 'temperatura', 818.0000, 'ºC'),
	(102933, 109, '2015-03-15 00:54:03.000000', 'temperatura', 391.0000, 'ºC'),
	(102934, 109, '2015-03-15 00:54:04.000000', 'temperatura', 699.0000, 'ºC'),
	(102935, 109, '2015-03-15 00:54:05.000000', 'temperatura', 1126.0000, 'ºC'),
	(102936, 109, '2015-03-15 00:54:06.000000', 'temperatura', 1130.0000, 'ºC'),
	(102937, 109, '2015-03-15 00:54:07.000000', 'temperatura', 1074.0000, 'ºC'),
	(102938, 109, '2015-03-15 00:54:08.000000', 'temperatura', 782.0000, 'ºC'),
	(102939, 109, '2015-03-15 00:54:09.000000', 'temperatura', 687.0000, 'ºC'),
	(102940, 109, '2015-03-15 00:54:10.000000', 'temperatura', 1089.0000, 'ºC'),
	(102941, 109, '2015-03-15 00:54:11.000000', 'temperatura', 985.0000, 'ºC'),
	(102942, 109, '2015-03-15 00:54:12.000000', 'temperatura', 457.0000, 'ºC'),
	(102943, 109, '2015-03-15 00:54:13.000000', 'temperatura', 530.0000, 'ºC'),
	(102944, 109, '2015-03-15 00:54:14.000000', 'temperatura', 79.0000, 'ºC'),
	(102945, 109, '2015-03-15 00:54:15.000000', 'temperatura', 8.0000, 'ºC'),
	(102946, 109, '2015-03-15 00:54:16.000000', 'temperatura', 1004.0000, 'ºC'),
	(102947, 109, '2015-03-15 00:54:17.000000', 'temperatura', 196.0000, 'ºC'),
	(102948, 109, '2015-03-15 00:54:18.000000', 'temperatura', 367.0000, 'ºC'),
	(102949, 109, '2015-03-15 00:54:19.000000', 'temperatura', 49.0000, 'ºC'),
	(102950, 109, '2015-03-15 00:54:20.000000', 'temperatura', 342.0000, 'ºC'),
	(102951, 109, '2015-03-15 00:54:21.000000', 'temperatura', 365.0000, 'ºC'),
	(102952, 109, '2015-03-15 00:54:22.000000', 'temperatura', 799.0000, 'ºC'),
	(102953, 109, '2015-03-15 00:54:23.000000', 'temperatura', 499.0000, 'ºC'),
	(102954, 109, '2015-03-15 00:54:24.000000', 'temperatura', 100.0000, 'ºC'),
	(102955, 109, '2015-03-15 00:54:25.000000', 'temperatura', 201.0000, 'ºC'),
	(102956, 109, '2015-03-15 00:54:26.000000', 'temperatura', 709.0000, 'ºC'),
	(102957, 109, '2015-03-15 00:54:27.000000', 'temperatura', 541.0000, 'ºC'),
	(102958, 109, '2015-03-15 00:54:28.000000', 'temperatura', 578.0000, 'ºC'),
	(102959, 109, '2015-03-15 00:54:29.000000', 'temperatura', 68.0000, 'ºC'),
	(102960, 109, '2015-03-15 00:54:30.000000', 'temperatura', 1006.0000, 'ºC'),
	(102961, 109, '2015-03-15 00:54:31.000000', 'temperatura', 25.0000, 'ºC'),
	(102962, 109, '2015-03-15 00:54:32.000000', 'temperatura', 707.0000, 'ºC'),
	(102963, 109, '2015-03-15 00:54:33.000000', 'temperatura', 1063.0000, 'ºC'),
	(102964, 109, '2015-03-15 00:54:34.000000', 'temperatura', 795.0000, 'ºC'),
	(102965, 109, '2015-03-15 00:54:35.000000', 'temperatura', 787.0000, 'ºC'),
	(102966, 109, '2015-03-15 00:54:36.000000', 'temperatura', 351.0000, 'ºC'),
	(102967, 109, '2015-03-15 00:54:37.000000', 'temperatura', 592.0000, 'ºC'),
	(102968, 109, '2015-03-15 00:54:38.000000', 'temperatura', 707.0000, 'ºC'),
	(102969, 109, '2015-03-15 00:54:39.000000', 'temperatura', 559.0000, 'ºC'),
	(102970, 109, '2015-03-15 00:54:40.000000', 'temperatura', 676.0000, 'ºC'),
	(102971, 109, '2015-03-15 00:54:41.000000', 'temperatura', 502.0000, 'ºC'),
	(102972, 109, '2015-03-15 00:54:42.000000', 'temperatura', 485.0000, 'ºC'),
	(102973, 109, '2015-03-15 00:54:43.000000', 'temperatura', 917.0000, 'ºC'),
	(102974, 109, '2015-03-15 00:54:44.000000', 'temperatura', 733.0000, 'ºC'),
	(102975, 109, '2015-03-15 00:54:45.000000', 'temperatura', 915.0000, 'ºC'),
	(102976, 109, '2015-03-15 00:54:46.000000', 'temperatura', 1174.0000, 'ºC'),
	(102977, 109, '2015-03-15 00:54:47.000000', 'temperatura', 726.0000, 'ºC'),
	(102978, 109, '2015-03-15 00:54:48.000000', 'temperatura', 109.0000, 'ºC'),
	(102979, 109, '2015-03-15 00:54:49.000000', 'temperatura', 769.0000, 'ºC'),
	(102980, 109, '2015-03-15 00:54:50.000000', 'temperatura', 1117.0000, 'ºC'),
	(102981, 109, '2015-03-15 00:54:51.000000', 'temperatura', 879.0000, 'ºC'),
	(102982, 109, '2015-03-15 00:54:52.000000', 'temperatura', 1045.0000, 'ºC'),
	(102983, 109, '2015-03-15 00:54:53.000000', 'temperatura', 188.0000, 'ºC'),
	(102984, 109, '2015-03-15 00:54:54.000000', 'temperatura', 205.0000, 'ºC'),
	(102985, 109, '2015-03-15 00:54:55.000000', 'temperatura', 461.0000, 'ºC'),
	(102986, 109, '2015-03-15 00:54:56.000000', 'temperatura', 492.0000, 'ºC'),
	(102987, 109, '2015-03-15 00:54:57.000000', 'temperatura', 1077.0000, 'ºC'),
	(102988, 109, '2015-03-15 00:54:58.000000', 'temperatura', 308.0000, 'ºC'),
	(102989, 109, '2015-03-15 00:54:59.000000', 'temperatura', 711.0000, 'ºC'),
	(102990, 109, '2015-03-15 00:55:00.000000', 'temperatura', 232.0000, 'ºC'),
	(102991, 109, '2015-03-15 00:55:01.000000', 'temperatura', 228.0000, 'ºC'),
	(102992, 109, '2015-03-15 00:55:02.000000', 'temperatura', 444.0000, 'ºC'),
	(102993, 109, '2015-03-15 00:55:03.000000', 'temperatura', 337.0000, 'ºC'),
	(102994, 109, '2015-03-15 00:55:04.000000', 'temperatura', 355.0000, 'ºC'),
	(102995, 109, '2015-03-15 00:55:05.000000', 'temperatura', 764.0000, 'ºC'),
	(102996, 109, '2015-03-15 00:55:06.000000', 'temperatura', 354.0000, 'ºC'),
	(102997, 109, '2015-03-15 00:55:07.000000', 'temperatura', 677.0000, 'ºC'),
	(102998, 109, '2015-03-15 00:55:08.000000', 'temperatura', 1125.0000, 'ºC'),
	(102999, 109, '2015-03-15 00:55:09.000000', 'temperatura', 1197.0000, 'ºC'),
	(103000, 109, '2015-03-15 00:55:10.000000', 'temperatura', 207.0000, 'ºC'),
	(103001, 109, '2015-03-15 00:55:11.000000', 'temperatura', 1045.0000, 'ºC'),
	(103002, 109, '2015-03-15 00:55:12.000000', 'temperatura', 1006.0000, 'ºC'),
	(103003, 109, '2015-03-15 00:55:13.000000', 'temperatura', 697.0000, 'ºC'),
	(103004, 109, '2015-03-15 00:55:14.000000', 'temperatura', 465.0000, 'ºC'),
	(103005, 109, '2015-03-15 00:55:15.000000', 'temperatura', 237.0000, 'ºC'),
	(103006, 109, '2015-03-15 00:55:16.000000', 'temperatura', 989.0000, 'ºC'),
	(103007, 109, '2015-03-15 00:55:17.000000', 'temperatura', 635.0000, 'ºC'),
	(103008, 109, '2015-03-15 00:55:18.000000', 'temperatura', 206.0000, 'ºC'),
	(103009, 109, '2015-03-15 00:55:19.000000', 'temperatura', 328.0000, 'ºC'),
	(103010, 109, '2015-03-15 00:55:20.000000', 'temperatura', 1023.0000, 'ºC'),
	(103011, 109, '2015-03-15 00:55:21.000000', 'temperatura', 531.0000, 'ºC'),
	(103012, 109, '2015-03-15 00:55:22.000000', 'temperatura', 786.0000, 'ºC'),
	(103013, 109, '2015-03-15 00:55:23.000000', 'temperatura', 1136.0000, 'ºC'),
	(103014, 109, '2015-03-15 00:55:24.000000', 'temperatura', 925.0000, 'ºC'),
	(103015, 109, '2015-03-15 00:55:25.000000', 'temperatura', 15.0000, 'ºC'),
	(103016, 109, '2015-03-15 00:55:26.000000', 'temperatura', 901.0000, 'ºC'),
	(103017, 109, '2015-03-15 00:55:27.000000', 'temperatura', 861.0000, 'ºC'),
	(103018, 109, '2015-03-15 00:55:28.000000', 'temperatura', 401.0000, 'ºC'),
	(103019, 109, '2015-03-15 00:55:29.000000', 'temperatura', 624.0000, 'ºC'),
	(103020, 109, '2015-03-15 00:55:30.000000', 'temperatura', 716.0000, 'ºC'),
	(103021, 109, '2015-03-15 00:55:31.000000', 'temperatura', 509.0000, 'ºC'),
	(103022, 109, '2015-03-15 00:55:32.000000', 'temperatura', 396.0000, 'ºC'),
	(103023, 109, '2015-03-15 00:55:33.000000', 'temperatura', 454.0000, 'ºC'),
	(103024, 109, '2015-03-15 00:55:34.000000', 'temperatura', 1083.0000, 'ºC'),
	(103025, 109, '2015-03-15 00:55:35.000000', 'temperatura', 454.0000, 'ºC'),
	(103026, 109, '2015-03-15 00:55:36.000000', 'temperatura', 222.0000, 'ºC'),
	(103027, 109, '2015-03-15 00:55:37.000000', 'temperatura', 948.0000, 'ºC'),
	(103028, 109, '2015-03-15 00:55:38.000000', 'temperatura', 474.0000, 'ºC'),
	(103029, 109, '2015-03-15 00:55:39.000000', 'temperatura', 729.0000, 'ºC'),
	(103030, 109, '2015-03-15 00:55:40.000000', 'temperatura', 1021.0000, 'ºC'),
	(103031, 109, '2015-03-15 00:55:41.000000', 'temperatura', 519.0000, 'ºC'),
	(103032, 109, '2015-03-15 00:55:42.000000', 'temperatura', 734.0000, 'ºC'),
	(103033, 109, '2015-03-15 00:55:43.000000', 'temperatura', 911.0000, 'ºC'),
	(103034, 109, '2015-03-15 00:55:44.000000', 'temperatura', 1155.0000, 'ºC'),
	(103035, 109, '2015-03-15 00:55:45.000000', 'temperatura', 642.0000, 'ºC'),
	(103036, 109, '2015-03-15 00:55:46.000000', 'temperatura', 946.0000, 'ºC'),
	(103037, 109, '2015-03-15 00:55:47.000000', 'temperatura', 406.0000, 'ºC'),
	(103038, 109, '2015-03-15 00:55:48.000000', 'temperatura', 392.0000, 'ºC'),
	(103039, 109, '2015-03-15 00:55:49.000000', 'temperatura', 741.0000, 'ºC'),
	(103040, 109, '2015-03-15 00:55:50.000000', 'temperatura', 130.0000, 'ºC'),
	(103041, 109, '2015-03-15 00:55:51.000000', 'temperatura', 828.0000, 'ºC'),
	(103042, 109, '2015-03-15 00:55:52.000000', 'temperatura', 150.0000, 'ºC'),
	(103043, 109, '2015-03-15 00:55:53.000000', 'temperatura', 666.0000, 'ºC'),
	(103044, 109, '2015-03-15 00:55:54.000000', 'temperatura', 480.0000, 'ºC'),
	(103045, 109, '2015-03-15 00:55:55.000000', 'temperatura', 403.0000, 'ºC'),
	(103046, 109, '2015-03-15 00:55:56.000000', 'temperatura', 574.0000, 'ºC'),
	(103047, 109, '2015-03-15 00:55:57.000000', 'temperatura', 462.0000, 'ºC'),
	(103048, 109, '2015-03-15 00:55:58.000000', 'temperatura', 591.0000, 'ºC'),
	(103049, 109, '2015-03-15 00:55:59.000000', 'temperatura', 368.0000, 'ºC'),
	(103050, 109, '2015-03-15 00:56:00.000000', 'temperatura', 67.0000, 'ºC'),
	(103051, 109, '2015-03-15 00:56:01.000000', 'temperatura', 433.0000, 'ºC'),
	(103052, 109, '2015-03-15 00:56:02.000000', 'temperatura', 764.0000, 'ºC'),
	(103053, 109, '2015-03-15 00:56:03.000000', 'temperatura', 119.0000, 'ºC'),
	(103054, 109, '2015-03-15 00:56:04.000000', 'temperatura', 707.0000, 'ºC'),
	(103055, 109, '2015-03-15 00:56:05.000000', 'temperatura', 775.0000, 'ºC'),
	(103056, 109, '2015-03-15 00:56:06.000000', 'temperatura', 557.0000, 'ºC'),
	(103057, 109, '2015-03-15 00:56:07.000000', 'temperatura', 462.0000, 'ºC'),
	(103058, 109, '2015-03-15 00:56:08.000000', 'temperatura', 637.0000, 'ºC'),
	(103059, 109, '2015-03-15 00:56:09.000000', 'temperatura', 599.0000, 'ºC'),
	(103060, 109, '2015-03-15 00:56:10.000000', 'temperatura', 1087.0000, 'ºC'),
	(103061, 109, '2015-03-15 00:56:11.000000', 'temperatura', 36.0000, 'ºC'),
	(103062, 109, '2015-03-15 00:56:12.000000', 'temperatura', 519.0000, 'ºC'),
	(103063, 109, '2015-03-15 00:56:13.000000', 'temperatura', 87.0000, 'ºC'),
	(103064, 109, '2015-03-15 00:56:14.000000', 'temperatura', 78.0000, 'ºC'),
	(103065, 109, '2015-03-15 00:56:15.000000', 'temperatura', 130.0000, 'ºC'),
	(103066, 109, '2015-03-15 00:56:16.000000', 'temperatura', 419.0000, 'ºC'),
	(103067, 109, '2015-03-15 00:56:17.000000', 'temperatura', 504.0000, 'ºC'),
	(103068, 109, '2015-03-15 00:56:18.000000', 'temperatura', 62.0000, 'ºC'),
	(103069, 109, '2015-03-15 00:56:19.000000', 'temperatura', 0.0000, 'ºC'),
	(103070, 109, '2015-03-15 00:56:20.000000', 'temperatura', 1014.0000, 'ºC'),
	(103071, 109, '2015-03-15 00:56:21.000000', 'temperatura', 271.0000, 'ºC'),
	(103072, 109, '2015-03-15 00:56:22.000000', 'temperatura', 714.0000, 'ºC'),
	(103073, 109, '2015-03-15 00:56:23.000000', 'temperatura', 359.0000, 'ºC'),
	(103074, 109, '2015-03-15 00:56:24.000000', 'temperatura', 852.0000, 'ºC'),
	(103075, 109, '2015-03-15 00:56:25.000000', 'temperatura', 783.0000, 'ºC'),
	(103076, 109, '2015-03-15 00:56:26.000000', 'temperatura', 158.0000, 'ºC'),
	(103077, 109, '2015-03-15 00:56:27.000000', 'temperatura', 844.0000, 'ºC'),
	(103078, 109, '2015-03-15 00:56:28.000000', 'temperatura', 147.0000, 'ºC'),
	(103079, 109, '2015-03-15 00:56:29.000000', 'temperatura', 603.0000, 'ºC'),
	(103080, 109, '2015-03-15 00:56:30.000000', 'temperatura', 175.0000, 'ºC'),
	(103081, 109, '2015-03-15 00:56:31.000000', 'temperatura', 265.0000, 'ºC'),
	(103082, 109, '2015-03-15 00:56:32.000000', 'temperatura', 802.0000, 'ºC'),
	(103083, 109, '2015-03-15 00:56:33.000000', 'temperatura', 816.0000, 'ºC'),
	(103084, 109, '2015-03-15 00:56:34.000000', 'temperatura', 473.0000, 'ºC'),
	(103085, 109, '2015-03-15 00:56:35.000000', 'temperatura', 1120.0000, 'ºC'),
	(103086, 109, '2015-03-15 00:56:36.000000', 'temperatura', 581.0000, 'ºC'),
	(103087, 109, '2015-03-15 00:56:37.000000', 'temperatura', 743.0000, 'ºC'),
	(103088, 109, '2015-03-15 00:56:38.000000', 'temperatura', 775.0000, 'ºC'),
	(103089, 109, '2015-03-15 00:56:39.000000', 'temperatura', 444.0000, 'ºC'),
	(103090, 109, '2015-03-15 00:56:40.000000', 'temperatura', 1095.0000, 'ºC'),
	(103091, 109, '2015-03-15 00:56:41.000000', 'temperatura', 546.0000, 'ºC'),
	(103092, 109, '2015-03-15 00:56:42.000000', 'temperatura', 646.0000, 'ºC'),
	(103093, 109, '2015-03-15 00:56:43.000000', 'temperatura', 393.0000, 'ºC'),
	(103094, 109, '2015-03-15 00:56:44.000000', 'temperatura', 25.0000, 'ºC'),
	(103095, 109, '2015-03-15 00:56:45.000000', 'temperatura', 148.0000, 'ºC'),
	(103096, 109, '2015-03-15 00:56:46.000000', 'temperatura', 663.0000, 'ºC'),
	(103097, 109, '2015-03-15 00:56:47.000000', 'temperatura', 475.0000, 'ºC'),
	(103098, 109, '2015-03-15 00:56:48.000000', 'temperatura', 385.0000, 'ºC'),
	(103099, 109, '2015-03-15 00:56:49.000000', 'temperatura', 502.0000, 'ºC'),
	(103100, 109, '2015-03-15 00:56:50.000000', 'temperatura', 154.0000, 'ºC'),
	(103101, 109, '2015-03-15 00:56:51.000000', 'temperatura', 466.0000, 'ºC'),
	(103102, 109, '2015-03-15 00:56:52.000000', 'temperatura', 667.0000, 'ºC'),
	(103103, 109, '2015-03-15 00:56:53.000000', 'temperatura', 738.0000, 'ºC'),
	(103104, 109, '2015-03-15 00:56:54.000000', 'temperatura', 491.0000, 'ºC'),
	(103105, 109, '2015-03-15 00:56:55.000000', 'temperatura', 242.0000, 'ºC'),
	(103106, 109, '2015-03-15 00:56:56.000000', 'temperatura', 934.0000, 'ºC'),
	(103107, 109, '2015-03-15 00:56:57.000000', 'temperatura', 348.0000, 'ºC'),
	(103108, 109, '2015-03-15 00:56:58.000000', 'temperatura', 139.0000, 'ºC'),
	(103109, 109, '2015-03-15 00:56:59.000000', 'temperatura', 848.0000, 'ºC'),
	(103110, 109, '2015-03-15 00:57:00.000000', 'temperatura', 227.0000, 'ºC'),
	(103111, 109, '2015-03-15 00:57:01.000000', 'temperatura', 991.0000, 'ºC'),
	(103112, 109, '2015-03-15 00:57:02.000000', 'temperatura', 674.0000, 'ºC'),
	(103113, 109, '2015-03-15 00:57:03.000000', 'temperatura', 398.0000, 'ºC'),
	(103114, 109, '2015-03-15 00:57:04.000000', 'temperatura', 1170.0000, 'ºC'),
	(103115, 109, '2015-03-15 00:57:05.000000', 'temperatura', 1053.0000, 'ºC'),
	(103116, 109, '2015-03-15 00:57:06.000000', 'temperatura', 559.0000, 'ºC'),
	(103117, 109, '2015-03-15 00:57:07.000000', 'temperatura', 834.0000, 'ºC'),
	(103118, 109, '2015-03-15 00:57:08.000000', 'temperatura', 94.0000, 'ºC'),
	(103119, 109, '2015-03-15 00:57:09.000000', 'temperatura', 368.0000, 'ºC'),
	(103120, 109, '2015-03-15 00:57:10.000000', 'temperatura', 358.0000, 'ºC'),
	(103121, 109, '2015-03-15 00:57:11.000000', 'temperatura', 688.0000, 'ºC'),
	(103122, 109, '2015-03-15 00:57:12.000000', 'temperatura', 1165.0000, 'ºC'),
	(103123, 109, '2015-03-15 00:57:13.000000', 'temperatura', 163.0000, 'ºC'),
	(103124, 109, '2015-03-15 00:57:14.000000', 'temperatura', 918.0000, 'ºC'),
	(103125, 109, '2015-03-15 00:57:15.000000', 'temperatura', 502.0000, 'ºC'),
	(103126, 109, '2015-03-15 00:57:16.000000', 'temperatura', 959.0000, 'ºC'),
	(103127, 109, '2015-03-15 00:57:17.000000', 'temperatura', 887.0000, 'ºC'),
	(103128, 109, '2015-03-15 00:57:18.000000', 'temperatura', 359.0000, 'ºC'),
	(103129, 109, '2015-03-15 00:57:19.000000', 'temperatura', 337.0000, 'ºC'),
	(103130, 109, '2015-03-15 00:57:20.000000', 'temperatura', 606.0000, 'ºC'),
	(103131, 109, '2015-03-15 00:57:21.000000', 'temperatura', 821.0000, 'ºC'),
	(103132, 109, '2015-03-15 00:57:22.000000', 'temperatura', 1089.0000, 'ºC'),
	(103133, 109, '2015-03-15 00:57:23.000000', 'temperatura', 580.0000, 'ºC'),
	(103134, 109, '2015-03-15 00:57:24.000000', 'temperatura', 832.0000, 'ºC'),
	(103135, 109, '2015-03-15 00:57:25.000000', 'temperatura', 22.0000, 'ºC'),
	(103136, 109, '2015-03-15 00:57:26.000000', 'temperatura', 16.0000, 'ºC'),
	(103137, 109, '2015-03-15 00:57:27.000000', 'temperatura', 15.0000, 'ºC'),
	(103138, 109, '2015-03-15 00:57:28.000000', 'temperatura', 26.0000, 'ºC'),
	(103139, 109, '2015-03-15 00:57:29.000000', 'temperatura', 86.0000, 'ºC'),
	(103140, 109, '2015-03-15 00:57:30.000000', 'temperatura', 352.0000, 'ºC'),
	(103141, 109, '2015-03-15 00:57:31.000000', 'temperatura', 303.0000, 'ºC'),
	(103142, 109, '2015-03-15 00:57:32.000000', 'temperatura', 459.0000, 'ºC'),
	(103143, 109, '2015-03-15 00:57:33.000000', 'temperatura', 187.0000, 'ºC'),
	(103144, 109, '2015-03-15 00:57:34.000000', 'temperatura', 760.0000, 'ºC'),
	(103145, 109, '2015-03-15 00:57:35.000000', 'temperatura', 838.0000, 'ºC'),
	(103146, 109, '2015-03-15 00:57:36.000000', 'temperatura', 709.0000, 'ºC'),
	(103147, 109, '2015-03-15 00:57:37.000000', 'temperatura', 1034.0000, 'ºC'),
	(103148, 109, '2015-03-15 00:57:38.000000', 'temperatura', 641.0000, 'ºC'),
	(103149, 109, '2015-03-15 00:57:39.000000', 'temperatura', 106.0000, 'ºC'),
	(103150, 109, '2015-03-15 00:57:40.000000', 'temperatura', 1005.0000, 'ºC'),
	(103151, 109, '2015-03-15 00:57:41.000000', 'temperatura', 1109.0000, 'ºC'),
	(103152, 109, '2015-03-15 00:57:42.000000', 'temperatura', 130.0000, 'ºC'),
	(103153, 109, '2015-03-15 00:57:43.000000', 'temperatura', 926.0000, 'ºC'),
	(103154, 109, '2015-03-15 00:57:44.000000', 'temperatura', 637.0000, 'ºC'),
	(103155, 109, '2015-03-15 00:57:45.000000', 'temperatura', 409.0000, 'ºC'),
	(103156, 109, '2015-03-15 00:57:46.000000', 'temperatura', 133.0000, 'ºC'),
	(103157, 109, '2015-03-15 00:57:47.000000', 'temperatura', 638.0000, 'ºC'),
	(103158, 109, '2015-03-15 00:57:48.000000', 'temperatura', 392.0000, 'ºC'),
	(103159, 109, '2015-03-15 00:57:49.000000', 'temperatura', 48.0000, 'ºC'),
	(103160, 109, '2015-03-15 00:57:50.000000', 'temperatura', 262.0000, 'ºC'),
	(103161, 109, '2015-03-15 00:57:51.000000', 'temperatura', 1170.0000, 'ºC'),
	(103162, 109, '2015-03-15 00:57:52.000000', 'temperatura', 262.0000, 'ºC'),
	(103163, 109, '2015-03-15 00:57:53.000000', 'temperatura', 201.0000, 'ºC'),
	(103164, 109, '2015-03-15 00:57:54.000000', 'temperatura', 220.0000, 'ºC'),
	(103165, 109, '2015-03-15 00:57:55.000000', 'temperatura', 495.0000, 'ºC'),
	(103166, 109, '2015-03-15 00:57:56.000000', 'temperatura', 618.0000, 'ºC'),
	(103167, 109, '2015-03-15 00:57:57.000000', 'temperatura', 405.0000, 'ºC'),
	(103168, 109, '2015-03-15 00:57:58.000000', 'temperatura', 172.0000, 'ºC'),
	(103169, 109, '2015-03-15 00:57:59.000000', 'temperatura', 845.0000, 'ºC'),
	(103170, 109, '2015-03-15 00:58:00.000000', 'temperatura', 110.0000, 'ºC'),
	(103171, 109, '2015-03-15 00:58:01.000000', 'temperatura', 416.0000, 'ºC'),
	(103172, 109, '2015-03-15 00:58:02.000000', 'temperatura', 550.0000, 'ºC'),
	(103173, 109, '2015-03-15 00:58:03.000000', 'temperatura', 304.0000, 'ºC'),
	(103174, 109, '2015-03-15 00:58:04.000000', 'temperatura', 1070.0000, 'ºC'),
	(103175, 109, '2015-03-15 00:58:05.000000', 'temperatura', 837.0000, 'ºC'),
	(103176, 109, '2015-03-15 00:58:06.000000', 'temperatura', 976.0000, 'ºC'),
	(103177, 109, '2015-03-15 00:58:07.000000', 'temperatura', 1170.0000, 'ºC'),
	(103178, 109, '2015-03-15 00:58:08.000000', 'temperatura', 520.0000, 'ºC'),
	(103179, 109, '2015-03-15 00:58:09.000000', 'temperatura', 294.0000, 'ºC'),
	(103180, 109, '2015-03-15 00:58:10.000000', 'temperatura', 1110.0000, 'ºC'),
	(103181, 109, '2015-03-15 00:58:11.000000', 'temperatura', 1068.0000, 'ºC'),
	(103182, 109, '2015-03-15 00:58:12.000000', 'temperatura', 809.0000, 'ºC'),
	(103183, 109, '2015-03-15 00:58:13.000000', 'temperatura', 844.0000, 'ºC'),
	(103184, 109, '2015-03-15 00:58:14.000000', 'temperatura', 594.0000, 'ºC'),
	(103185, 109, '2015-03-15 00:58:15.000000', 'temperatura', 436.0000, 'ºC'),
	(103186, 109, '2015-03-15 00:58:16.000000', 'temperatura', 401.0000, 'ºC'),
	(103187, 109, '2015-03-15 00:58:17.000000', 'temperatura', 697.0000, 'ºC'),
	(103188, 109, '2015-03-15 00:58:18.000000', 'temperatura', 1082.0000, 'ºC'),
	(103189, 109, '2015-03-15 00:58:19.000000', 'temperatura', 919.0000, 'ºC'),
	(103190, 109, '2015-03-15 00:58:20.000000', 'temperatura', 149.0000, 'ºC'),
	(103191, 109, '2015-03-15 00:58:21.000000', 'temperatura', 389.0000, 'ºC'),
	(103192, 109, '2015-03-15 00:58:22.000000', 'temperatura', 298.0000, 'ºC'),
	(103193, 109, '2015-03-15 00:58:23.000000', 'temperatura', 324.0000, 'ºC'),
	(103194, 109, '2015-03-15 00:58:24.000000', 'temperatura', 728.0000, 'ºC'),
	(103195, 109, '2015-03-15 00:58:25.000000', 'temperatura', 267.0000, 'ºC'),
	(103196, 109, '2015-03-15 00:58:26.000000', 'temperatura', 353.0000, 'ºC'),
	(103197, 109, '2015-03-15 00:58:27.000000', 'temperatura', 963.0000, 'ºC'),
	(103198, 109, '2015-03-15 00:58:28.000000', 'temperatura', 156.0000, 'ºC'),
	(103199, 109, '2015-03-15 00:58:29.000000', 'temperatura', 292.0000, 'ºC'),
	(103200, 109, '2015-03-15 00:58:30.000000', 'temperatura', 994.0000, 'ºC'),
	(103201, 109, '2015-03-15 00:58:31.000000', 'temperatura', 492.0000, 'ºC'),
	(103202, 109, '2015-03-15 00:58:32.000000', 'temperatura', 680.0000, 'ºC'),
	(103203, 109, '2015-03-15 00:58:33.000000', 'temperatura', 723.0000, 'ºC'),
	(103204, 109, '2015-03-15 00:58:34.000000', 'temperatura', 375.0000, 'ºC'),
	(103205, 109, '2015-03-15 00:58:35.000000', 'temperatura', 907.0000, 'ºC'),
	(103206, 109, '2015-03-15 00:58:36.000000', 'temperatura', 1012.0000, 'ºC'),
	(103207, 109, '2015-03-15 00:58:37.000000', 'temperatura', 1140.0000, 'ºC'),
	(103208, 109, '2015-03-15 00:58:38.000000', 'temperatura', 263.0000, 'ºC'),
	(103209, 109, '2015-03-15 00:58:39.000000', 'temperatura', 295.0000, 'ºC'),
	(103210, 109, '2015-03-15 00:58:40.000000', 'temperatura', 689.0000, 'ºC'),
	(103211, 109, '2015-03-15 00:58:41.000000', 'temperatura', 159.0000, 'ºC'),
	(103212, 109, '2015-03-15 00:58:42.000000', 'temperatura', 1129.0000, 'ºC'),
	(103213, 109, '2015-03-15 00:58:43.000000', 'temperatura', 369.0000, 'ºC'),
	(103214, 109, '2015-03-15 00:58:44.000000', 'temperatura', 858.0000, 'ºC'),
	(103215, 109, '2015-03-15 00:58:45.000000', 'temperatura', 783.0000, 'ºC'),
	(103216, 109, '2015-03-15 00:58:46.000000', 'temperatura', 141.0000, 'ºC'),
	(103217, 109, '2015-03-15 00:58:47.000000', 'temperatura', 758.0000, 'ºC'),
	(103218, 109, '2015-03-15 00:58:48.000000', 'temperatura', 965.0000, 'ºC'),
	(103219, 109, '2015-03-15 00:58:49.000000', 'temperatura', 152.0000, 'ºC'),
	(103220, 109, '2015-03-15 00:58:50.000000', 'temperatura', 267.0000, 'ºC'),
	(103221, 109, '2015-03-15 00:58:51.000000', 'temperatura', 877.0000, 'ºC'),
	(103222, 109, '2015-03-15 00:58:52.000000', 'temperatura', 1187.0000, 'ºC'),
	(103223, 109, '2015-03-15 00:58:53.000000', 'temperatura', 903.0000, 'ºC'),
	(103224, 109, '2015-03-15 00:58:54.000000', 'temperatura', 956.0000, 'ºC'),
	(103225, 109, '2015-03-15 00:58:55.000000', 'temperatura', 872.0000, 'ºC'),
	(103226, 109, '2015-03-15 00:58:56.000000', 'temperatura', 291.0000, 'ºC'),
	(103227, 109, '2015-03-15 00:58:57.000000', 'temperatura', 41.0000, 'ºC'),
	(103228, 109, '2015-03-15 00:58:58.000000', 'temperatura', 532.0000, 'ºC'),
	(103229, 109, '2015-03-15 00:58:59.000000', 'temperatura', 136.0000, 'ºC'),
	(103230, 109, '2015-03-15 00:59:00.000000', 'temperatura', 284.0000, 'ºC'),
	(103231, 109, '2015-03-15 00:59:01.000000', 'temperatura', 1013.0000, 'ºC'),
	(103232, 109, '2015-03-15 00:59:02.000000', 'temperatura', 613.0000, 'ºC'),
	(103233, 109, '2015-03-15 00:59:03.000000', 'temperatura', 26.0000, 'ºC'),
	(103234, 109, '2015-03-15 00:59:04.000000', 'temperatura', 694.0000, 'ºC'),
	(103235, 109, '2015-03-15 00:59:05.000000', 'temperatura', 993.0000, 'ºC'),
	(103236, 109, '2015-03-15 00:59:06.000000', 'temperatura', 481.0000, 'ºC'),
	(103237, 109, '2015-03-15 00:59:07.000000', 'temperatura', 627.0000, 'ºC'),
	(103238, 109, '2015-03-15 00:59:08.000000', 'temperatura', 492.0000, 'ºC'),
	(103239, 109, '2015-03-15 00:59:09.000000', 'temperatura', 579.0000, 'ºC'),
	(103240, 109, '2015-03-15 00:59:10.000000', 'temperatura', 218.0000, 'ºC'),
	(103241, 109, '2015-03-15 00:59:11.000000', 'temperatura', 556.0000, 'ºC'),
	(103242, 109, '2015-03-15 00:59:12.000000', 'temperatura', 926.0000, 'ºC'),
	(103243, 109, '2015-03-15 00:59:13.000000', 'temperatura', 562.0000, 'ºC'),
	(103244, 109, '2015-03-15 00:59:14.000000', 'temperatura', 33.0000, 'ºC'),
	(103245, 109, '2015-03-15 00:59:15.000000', 'temperatura', 879.0000, 'ºC'),
	(103246, 109, '2015-03-15 00:59:16.000000', 'temperatura', 698.0000, 'ºC'),
	(103247, 109, '2015-03-15 00:59:17.000000', 'temperatura', 854.0000, 'ºC'),
	(103248, 109, '2015-03-15 00:59:18.000000', 'temperatura', 975.0000, 'ºC'),
	(103249, 109, '2015-03-15 00:59:19.000000', 'temperatura', 1116.0000, 'ºC'),
	(103250, 109, '2015-03-15 00:59:20.000000', 'temperatura', 253.0000, 'ºC'),
	(103251, 109, '2015-03-15 00:59:21.000000', 'temperatura', 318.0000, 'ºC'),
	(103252, 109, '2015-03-15 00:59:22.000000', 'temperatura', 832.0000, 'ºC'),
	(103253, 109, '2015-03-15 00:59:23.000000', 'temperatura', 808.0000, 'ºC'),
	(103254, 109, '2015-03-15 00:59:24.000000', 'temperatura', 342.0000, 'ºC'),
	(103255, 109, '2015-03-15 00:59:25.000000', 'temperatura', 487.0000, 'ºC'),
	(103256, 109, '2015-03-15 00:59:26.000000', 'temperatura', 211.0000, 'ºC'),
	(103257, 109, '2015-03-15 00:59:27.000000', 'temperatura', 792.0000, 'ºC'),
	(103258, 109, '2015-03-15 00:59:28.000000', 'temperatura', 931.0000, 'ºC'),
	(103259, 109, '2015-03-15 00:59:29.000000', 'temperatura', 1076.0000, 'ºC'),
	(103260, 109, '2015-03-15 00:59:30.000000', 'temperatura', 188.0000, 'ºC'),
	(103261, 109, '2015-03-15 00:59:31.000000', 'temperatura', 112.0000, 'ºC'),
	(103262, 109, '2015-03-15 00:59:32.000000', 'temperatura', 1196.0000, 'ºC'),
	(103263, 109, '2015-03-15 00:59:33.000000', 'temperatura', 844.0000, 'ºC'),
	(103264, 109, '2015-03-15 00:59:34.000000', 'temperatura', 635.0000, 'ºC'),
	(103265, 109, '2015-03-15 00:59:35.000000', 'temperatura', 643.0000, 'ºC'),
	(103266, 109, '2015-03-15 00:59:36.000000', 'temperatura', 112.0000, 'ºC'),
	(103267, 109, '2015-03-15 00:59:37.000000', 'temperatura', 1029.0000, 'ºC'),
	(103268, 109, '2015-03-15 00:59:38.000000', 'temperatura', 12.0000, 'ºC'),
	(103269, 109, '2015-03-15 00:59:39.000000', 'temperatura', 573.0000, 'ºC'),
	(103270, 109, '2015-03-15 00:59:40.000000', 'temperatura', 430.0000, 'ºC'),
	(103271, 109, '2015-03-15 00:59:41.000000', 'temperatura', 432.0000, 'ºC'),
	(103272, 109, '2015-03-15 00:59:42.000000', 'temperatura', 869.0000, 'ºC'),
	(103273, 109, '2015-03-15 00:59:43.000000', 'temperatura', 652.0000, 'ºC'),
	(103274, 109, '2015-03-15 00:59:44.000000', 'temperatura', 650.0000, 'ºC'),
	(103275, 109, '2015-03-15 00:59:45.000000', 'temperatura', 97.0000, 'ºC'),
	(103276, 109, '2015-03-15 00:59:46.000000', 'temperatura', 935.0000, 'ºC'),
	(103277, 109, '2015-03-15 00:59:47.000000', 'temperatura', 784.0000, 'ºC'),
	(103278, 109, '2015-03-15 00:59:48.000000', 'temperatura', 1116.0000, 'ºC'),
	(103279, 109, '2015-03-15 00:59:49.000000', 'temperatura', 830.0000, 'ºC'),
	(103280, 109, '2015-03-15 00:59:50.000000', 'temperatura', 801.0000, 'ºC'),
	(103281, 109, '2015-03-15 00:59:51.000000', 'temperatura', 318.0000, 'ºC'),
	(103282, 109, '2015-03-15 00:59:52.000000', 'temperatura', 384.0000, 'ºC'),
	(103283, 109, '2015-03-15 00:59:53.000000', 'temperatura', 969.0000, 'ºC'),
	(103284, 109, '2015-03-15 00:59:54.000000', 'temperatura', 92.0000, 'ºC'),
	(103285, 109, '2015-03-15 00:59:55.000000', 'temperatura', 1156.0000, 'ºC'),
	(103286, 109, '2015-03-15 00:59:56.000000', 'temperatura', 701.0000, 'ºC'),
	(103287, 109, '2015-03-15 00:59:57.000000', 'temperatura', 39.0000, 'ºC'),
	(103288, 109, '2015-03-15 00:59:58.000000', 'temperatura', 494.0000, 'ºC'),
	(103289, 109, '2015-03-15 00:59:59.000000', 'temperatura', 1153.0000, 'ºC'),
	(103290, 109, '2015-03-15 01:00:00.000000', 'temperatura', 681.0000, 'ºC'),
	(103291, 109, '2015-03-15 01:00:01.000000', 'temperatura', 1150.0000, 'ºC'),
	(103292, 109, '2015-03-15 01:00:02.000000', 'temperatura', 104.0000, 'ºC'),
	(103293, 109, '2015-03-15 01:00:03.000000', 'temperatura', 673.0000, 'ºC'),
	(103294, 109, '2015-03-15 01:00:04.000000', 'temperatura', 655.0000, 'ºC'),
	(103295, 109, '2015-03-15 01:00:05.000000', 'temperatura', 54.0000, 'ºC'),
	(103296, 109, '2015-03-15 01:00:06.000000', 'temperatura', 706.0000, 'ºC'),
	(103297, 109, '2015-03-15 01:00:07.000000', 'temperatura', 968.0000, 'ºC'),
	(103298, 109, '2015-03-15 01:00:08.000000', 'temperatura', 324.0000, 'ºC'),
	(103299, 109, '2015-03-15 01:00:09.000000', 'temperatura', 1118.0000, 'ºC'),
	(103300, 109, '2015-03-15 01:00:10.000000', 'temperatura', 1016.0000, 'ºC'),
	(103301, 109, '2015-03-15 01:00:11.000000', 'temperatura', 528.0000, 'ºC'),
	(103302, 109, '2015-03-15 01:00:12.000000', 'temperatura', 792.0000, 'ºC'),
	(103303, 109, '2015-03-15 01:00:13.000000', 'temperatura', 1178.0000, 'ºC'),
	(103304, 109, '2015-03-15 01:00:14.000000', 'temperatura', 1115.0000, 'ºC'),
	(103305, 109, '2015-03-15 01:00:15.000000', 'temperatura', 842.0000, 'ºC'),
	(103306, 109, '2015-03-15 01:00:16.000000', 'temperatura', 864.0000, 'ºC'),
	(103307, 109, '2015-03-15 01:00:17.000000', 'temperatura', 593.0000, 'ºC'),
	(103308, 109, '2015-03-15 01:00:18.000000', 'temperatura', 376.0000, 'ºC'),
	(103309, 109, '2015-03-15 01:00:19.000000', 'temperatura', 99.0000, 'ºC'),
	(103310, 109, '2015-03-15 01:00:20.000000', 'temperatura', 568.0000, 'ºC'),
	(103311, 109, '2015-03-15 01:00:21.000000', 'temperatura', 145.0000, 'ºC'),
	(103312, 109, '2015-03-15 01:00:22.000000', 'temperatura', 223.0000, 'ºC'),
	(103313, 109, '2015-03-15 01:00:23.000000', 'temperatura', 678.0000, 'ºC'),
	(103314, 109, '2015-03-15 01:00:24.000000', 'temperatura', 320.0000, 'ºC'),
	(103315, 109, '2015-03-15 01:00:25.000000', 'temperatura', 770.0000, 'ºC'),
	(103316, 109, '2015-03-15 01:00:26.000000', 'temperatura', 488.0000, 'ºC'),
	(103317, 109, '2015-03-15 01:00:27.000000', 'temperatura', 129.0000, 'ºC'),
	(103318, 109, '2015-03-15 01:00:28.000000', 'temperatura', 384.0000, 'ºC'),
	(103319, 109, '2015-03-15 01:00:29.000000', 'temperatura', 332.0000, 'ºC'),
	(103320, 109, '2015-03-15 01:00:30.000000', 'temperatura', 511.0000, 'ºC'),
	(103321, 109, '2015-03-15 01:00:31.000000', 'temperatura', 358.0000, 'ºC'),
	(103322, 109, '2015-03-15 01:00:32.000000', 'temperatura', 256.0000, 'ºC'),
	(103323, 109, '2015-03-15 01:00:33.000000', 'temperatura', 208.0000, 'ºC'),
	(103324, 109, '2015-03-15 01:00:34.000000', 'temperatura', 272.0000, 'ºC'),
	(103325, 109, '2015-03-15 01:00:35.000000', 'temperatura', 737.0000, 'ºC'),
	(103326, 109, '2015-03-15 01:00:36.000000', 'temperatura', 468.0000, 'ºC'),
	(103327, 109, '2015-03-15 01:00:37.000000', 'temperatura', 132.0000, 'ºC'),
	(103328, 109, '2015-03-15 01:00:38.000000', 'temperatura', 457.0000, 'ºC'),
	(103329, 109, '2015-03-15 01:00:39.000000', 'temperatura', 688.0000, 'ºC'),
	(103330, 109, '2015-03-15 01:00:40.000000', 'temperatura', 871.0000, 'ºC'),
	(103331, 109, '2015-03-15 01:00:41.000000', 'temperatura', 1089.0000, 'ºC'),
	(103332, 109, '2015-03-15 01:00:42.000000', 'temperatura', 432.0000, 'ºC'),
	(103333, 109, '2015-03-15 01:00:43.000000', 'temperatura', 95.0000, 'ºC'),
	(103334, 109, '2015-03-15 01:00:44.000000', 'temperatura', 380.0000, 'ºC'),
	(103335, 109, '2015-03-15 01:00:45.000000', 'temperatura', 414.0000, 'ºC'),
	(103336, 109, '2015-03-15 01:00:46.000000', 'temperatura', 931.0000, 'ºC'),
	(103337, 109, '2015-03-15 01:00:47.000000', 'temperatura', 1014.0000, 'ºC'),
	(103338, 109, '2015-03-15 01:00:48.000000', 'temperatura', 1077.0000, 'ºC'),
	(103339, 109, '2015-03-15 01:00:49.000000', 'temperatura', 1145.0000, 'ºC'),
	(103340, 109, '2015-03-15 01:00:50.000000', 'temperatura', 95.0000, 'ºC'),
	(103341, 109, '2015-03-15 01:00:51.000000', 'temperatura', 639.0000, 'ºC'),
	(103342, 109, '2015-03-15 01:00:52.000000', 'temperatura', 513.0000, 'ºC'),
	(103343, 109, '2015-03-15 01:00:53.000000', 'temperatura', 645.0000, 'ºC'),
	(103344, 109, '2015-03-15 01:00:54.000000', 'temperatura', 490.0000, 'ºC'),
	(103345, 109, '2015-03-15 01:00:55.000000', 'temperatura', 513.0000, 'ºC'),
	(103346, 109, '2015-03-15 01:00:56.000000', 'temperatura', 1095.0000, 'ºC'),
	(103347, 109, '2015-03-15 01:00:57.000000', 'temperatura', 338.0000, 'ºC'),
	(103348, 109, '2015-03-15 01:00:58.000000', 'temperatura', 806.0000, 'ºC'),
	(103349, 109, '2015-03-15 01:00:59.000000', 'temperatura', 615.0000, 'ºC'),
	(103350, 109, '2015-03-15 01:01:00.000000', 'temperatura', 659.0000, 'ºC'),
	(103351, 109, '2015-03-15 01:01:01.000000', 'temperatura', 249.0000, 'ºC'),
	(103352, 109, '2015-03-15 01:01:02.000000', 'temperatura', 468.0000, 'ºC'),
	(103353, 109, '2015-03-15 01:01:03.000000', 'temperatura', 395.0000, 'ºC'),
	(103354, 109, '2015-03-15 01:01:04.000000', 'temperatura', 572.0000, 'ºC'),
	(103355, 109, '2015-03-15 01:01:05.000000', 'temperatura', 477.0000, 'ºC'),
	(103356, 109, '2015-03-15 01:01:06.000000', 'temperatura', 667.0000, 'ºC'),
	(103357, 109, '2015-03-15 01:01:07.000000', 'temperatura', 707.0000, 'ºC'),
	(103358, 109, '2015-03-15 01:01:08.000000', 'temperatura', 335.0000, 'ºC'),
	(103359, 109, '2015-03-15 01:01:09.000000', 'temperatura', 751.0000, 'ºC'),
	(103360, 109, '2015-03-15 01:01:10.000000', 'temperatura', 353.0000, 'ºC'),
	(103361, 109, '2015-03-15 01:01:11.000000', 'temperatura', 712.0000, 'ºC'),
	(103362, 109, '2015-03-15 01:01:12.000000', 'temperatura', 102.0000, 'ºC'),
	(103363, 109, '2015-03-15 01:01:13.000000', 'temperatura', 773.0000, 'ºC'),
	(103364, 109, '2015-03-15 01:01:14.000000', 'temperatura', 1160.0000, 'ºC'),
	(103365, 109, '2015-03-15 01:01:15.000000', 'temperatura', 1080.0000, 'ºC'),
	(103366, 109, '2015-03-15 01:01:16.000000', 'temperatura', 722.0000, 'ºC'),
	(103367, 109, '2015-03-15 01:01:17.000000', 'temperatura', 370.0000, 'ºC'),
	(103368, 109, '2015-03-15 01:01:18.000000', 'temperatura', 885.0000, 'ºC'),
	(103369, 109, '2015-03-15 01:01:19.000000', 'temperatura', 915.0000, 'ºC'),
	(103370, 109, '2015-03-15 01:01:20.000000', 'temperatura', 720.0000, 'ºC'),
	(103371, 109, '2015-03-15 01:01:21.000000', 'temperatura', 857.0000, 'ºC'),
	(103372, 109, '2015-03-15 01:01:22.000000', 'temperatura', 925.0000, 'ºC'),
	(103373, 109, '2015-03-15 01:01:23.000000', 'temperatura', 854.0000, 'ºC'),
	(103374, 109, '2015-03-15 01:01:24.000000', 'temperatura', 295.0000, 'ºC'),
	(103375, 109, '2015-03-15 01:01:25.000000', 'temperatura', 114.0000, 'ºC'),
	(103376, 109, '2015-03-15 01:01:26.000000', 'temperatura', 886.0000, 'ºC'),
	(103377, 109, '2015-03-15 01:01:27.000000', 'temperatura', 489.0000, 'ºC'),
	(103378, 109, '2015-03-15 01:01:28.000000', 'temperatura', 986.0000, 'ºC'),
	(103379, 109, '2015-03-15 01:01:29.000000', 'temperatura', 1065.0000, 'ºC'),
	(103380, 109, '2015-03-15 01:01:30.000000', 'temperatura', 1168.0000, 'ºC'),
	(103381, 109, '2015-03-15 01:01:31.000000', 'temperatura', 245.0000, 'ºC'),
	(103382, 109, '2015-03-15 01:01:32.000000', 'temperatura', 123.0000, 'ºC'),
	(103383, 109, '2015-03-15 01:01:33.000000', 'temperatura', 1079.0000, 'ºC'),
	(103384, 109, '2015-03-15 01:01:34.000000', 'temperatura', 225.0000, 'ºC'),
	(103385, 109, '2015-03-15 01:01:35.000000', 'temperatura', 290.0000, 'ºC'),
	(103386, 109, '2015-03-15 01:01:36.000000', 'temperatura', 776.0000, 'ºC'),
	(103387, 109, '2015-03-15 01:01:37.000000', 'temperatura', 611.0000, 'ºC'),
	(103388, 109, '2015-03-15 01:01:38.000000', 'temperatura', 725.0000, 'ºC'),
	(103389, 109, '2015-03-15 01:01:39.000000', 'temperatura', 593.0000, 'ºC'),
	(103390, 109, '2015-03-15 01:01:40.000000', 'temperatura', 791.0000, 'ºC'),
	(103391, 109, '2015-03-15 01:01:41.000000', 'temperatura', 978.0000, 'ºC'),
	(103392, 109, '2015-03-15 01:01:42.000000', 'temperatura', 115.0000, 'ºC'),
	(103393, 109, '2015-03-15 01:01:43.000000', 'temperatura', 43.0000, 'ºC'),
	(103394, 109, '2015-03-15 01:01:44.000000', 'temperatura', 1071.0000, 'ºC'),
	(103395, 109, '2015-03-15 01:01:45.000000', 'temperatura', 425.0000, 'ºC'),
	(103396, 109, '2015-03-15 01:01:46.000000', 'temperatura', 113.0000, 'ºC'),
	(103397, 109, '2015-03-15 01:01:47.000000', 'temperatura', 490.0000, 'ºC'),
	(103398, 109, '2015-03-15 01:01:48.000000', 'temperatura', 912.0000, 'ºC'),
	(103399, 109, '2015-03-15 01:01:49.000000', 'temperatura', 690.0000, 'ºC'),
	(103400, 109, '2015-03-15 01:01:50.000000', 'temperatura', 713.0000, 'ºC'),
	(103401, 109, '2015-03-15 01:01:51.000000', 'temperatura', 296.0000, 'ºC'),
	(103402, 109, '2015-03-15 01:01:52.000000', 'temperatura', 542.0000, 'ºC'),
	(103403, 109, '2015-03-15 01:01:53.000000', 'temperatura', 624.0000, 'ºC'),
	(103404, 109, '2015-03-15 01:01:54.000000', 'temperatura', 293.0000, 'ºC'),
	(103405, 109, '2015-03-15 01:01:55.000000', 'temperatura', 796.0000, 'ºC'),
	(103406, 109, '2015-03-15 01:01:56.000000', 'temperatura', 698.0000, 'ºC'),
	(103407, 109, '2015-03-15 01:01:57.000000', 'temperatura', 1104.0000, 'ºC'),
	(103408, 109, '2015-03-15 01:01:58.000000', 'temperatura', 1025.0000, 'ºC'),
	(103409, 109, '2015-03-15 01:01:59.000000', 'temperatura', 614.0000, 'ºC'),
	(103410, 109, '2015-03-15 01:02:00.000000', 'temperatura', 1194.0000, 'ºC'),
	(103411, 109, '2015-03-15 01:02:01.000000', 'temperatura', 531.0000, 'ºC'),
	(103412, 109, '2015-03-15 01:02:02.000000', 'temperatura', 274.0000, 'ºC'),
	(103413, 109, '2015-03-15 01:02:03.000000', 'temperatura', 974.0000, 'ºC'),
	(103414, 109, '2015-03-15 01:02:04.000000', 'temperatura', 452.0000, 'ºC'),
	(103415, 109, '2015-03-15 01:02:05.000000', 'temperatura', 538.0000, 'ºC'),
	(103416, 109, '2015-03-15 01:02:06.000000', 'temperatura', 136.0000, 'ºC'),
	(103417, 109, '2015-03-15 01:02:07.000000', 'temperatura', 266.0000, 'ºC'),
	(103418, 109, '2015-03-15 01:02:08.000000', 'temperatura', 920.0000, 'ºC'),
	(103419, 109, '2015-03-15 01:02:09.000000', 'temperatura', 203.0000, 'ºC'),
	(103420, 109, '2015-03-15 01:02:10.000000', 'temperatura', 655.0000, 'ºC'),
	(103421, 109, '2015-03-15 01:02:11.000000', 'temperatura', 269.0000, 'ºC'),
	(103422, 109, '2015-03-15 01:02:12.000000', 'temperatura', 580.0000, 'ºC'),
	(103423, 109, '2015-03-15 01:02:13.000000', 'temperatura', 893.0000, 'ºC'),
	(103424, 109, '2015-03-15 01:02:14.000000', 'temperatura', 324.0000, 'ºC'),
	(103425, 109, '2015-03-15 01:02:15.000000', 'temperatura', 142.0000, 'ºC'),
	(103426, 109, '2015-03-15 01:02:16.000000', 'temperatura', 939.0000, 'ºC'),
	(103427, 109, '2015-03-15 01:02:17.000000', 'temperatura', 668.0000, 'ºC'),
	(103428, 109, '2015-03-15 01:02:18.000000', 'temperatura', 526.0000, 'ºC'),
	(103429, 109, '2015-03-15 01:02:19.000000', 'temperatura', 624.0000, 'ºC'),
	(103430, 109, '2015-03-15 01:02:20.000000', 'temperatura', 342.0000, 'ºC'),
	(103431, 109, '2015-03-15 01:02:21.000000', 'temperatura', 1038.0000, 'ºC'),
	(103432, 109, '2015-03-15 01:02:22.000000', 'temperatura', 566.0000, 'ºC'),
	(103433, 109, '2015-03-15 01:02:23.000000', 'temperatura', 915.0000, 'ºC'),
	(103434, 109, '2015-03-15 01:02:24.000000', 'temperatura', 477.0000, 'ºC'),
	(103435, 109, '2015-03-15 01:02:25.000000', 'temperatura', 840.0000, 'ºC'),
	(103436, 109, '2015-03-15 01:02:26.000000', 'temperatura', 369.0000, 'ºC'),
	(103437, 109, '2015-03-15 01:02:27.000000', 'temperatura', 528.0000, 'ºC'),
	(103438, 109, '2015-03-15 01:02:28.000000', 'temperatura', 333.0000, 'ºC'),
	(103439, 109, '2015-03-15 01:02:29.000000', 'temperatura', 79.0000, 'ºC'),
	(103440, 109, '2015-03-15 01:02:30.000000', 'temperatura', 598.0000, 'ºC'),
	(103441, 109, '2015-03-15 01:02:31.000000', 'temperatura', 355.0000, 'ºC'),
	(103442, 109, '2015-03-15 01:02:32.000000', 'temperatura', 1180.0000, 'ºC'),
	(103443, 109, '2015-03-15 01:02:33.000000', 'temperatura', 34.0000, 'ºC'),
	(103444, 109, '2015-03-15 01:02:34.000000', 'temperatura', 232.0000, 'ºC'),
	(103445, 109, '2015-03-15 01:02:35.000000', 'temperatura', 1058.0000, 'ºC'),
	(103446, 109, '2015-03-15 01:02:36.000000', 'temperatura', 995.0000, 'ºC'),
	(103447, 109, '2015-03-15 01:02:37.000000', 'temperatura', 603.0000, 'ºC'),
	(103448, 109, '2015-03-15 01:02:38.000000', 'temperatura', 30.0000, 'ºC'),
	(103449, 109, '2015-03-15 01:02:39.000000', 'temperatura', 743.0000, 'ºC'),
	(103450, 109, '2015-03-15 01:02:40.000000', 'temperatura', 24.0000, 'ºC'),
	(103451, 109, '2015-03-15 01:02:41.000000', 'temperatura', 291.0000, 'ºC'),
	(103452, 109, '2015-03-15 01:02:42.000000', 'temperatura', 184.0000, 'ºC'),
	(103453, 109, '2015-03-15 01:02:43.000000', 'temperatura', 45.0000, 'ºC'),
	(103454, 109, '2015-03-15 01:02:44.000000', 'temperatura', 877.0000, 'ºC'),
	(103455, 109, '2015-03-15 01:02:45.000000', 'temperatura', 649.0000, 'ºC'),
	(103456, 109, '2015-03-15 01:02:46.000000', 'temperatura', 617.0000, 'ºC'),
	(103457, 109, '2015-03-15 01:02:47.000000', 'temperatura', 1136.0000, 'ºC'),
	(103458, 109, '2015-03-15 01:02:48.000000', 'temperatura', 229.0000, 'ºC'),
	(103459, 109, '2015-03-15 01:02:49.000000', 'temperatura', 136.0000, 'ºC'),
	(103460, 109, '2015-03-15 01:02:50.000000', 'temperatura', 1197.0000, 'ºC'),
	(103461, 109, '2015-03-15 01:02:51.000000', 'temperatura', 776.0000, 'ºC'),
	(103462, 109, '2015-03-15 01:02:52.000000', 'temperatura', 290.0000, 'ºC'),
	(103463, 109, '2015-03-15 01:02:53.000000', 'temperatura', 323.0000, 'ºC'),
	(103464, 109, '2015-03-15 01:02:54.000000', 'temperatura', 745.0000, 'ºC'),
	(103465, 109, '2015-03-15 01:02:55.000000', 'temperatura', 357.0000, 'ºC'),
	(103466, 109, '2015-03-15 01:02:56.000000', 'temperatura', 749.0000, 'ºC'),
	(103467, 109, '2015-03-15 01:02:57.000000', 'temperatura', 274.0000, 'ºC'),
	(103468, 109, '2015-03-15 01:02:58.000000', 'temperatura', 325.0000, 'ºC'),
	(103469, 109, '2015-03-15 01:02:59.000000', 'temperatura', 804.0000, 'ºC'),
	(103470, 109, '2015-03-15 01:03:00.000000', 'temperatura', 644.0000, 'ºC'),
	(103471, 109, '2015-03-15 01:03:01.000000', 'temperatura', 810.0000, 'ºC'),
	(103472, 109, '2015-03-15 01:03:02.000000', 'temperatura', 916.0000, 'ºC'),
	(103473, 109, '2015-03-15 01:03:03.000000', 'temperatura', 951.0000, 'ºC'),
	(103474, 109, '2015-03-15 01:03:04.000000', 'temperatura', 807.0000, 'ºC'),
	(103475, 109, '2015-03-15 01:03:05.000000', 'temperatura', 1185.0000, 'ºC'),
	(103476, 109, '2015-03-15 01:03:06.000000', 'temperatura', 1102.0000, 'ºC'),
	(103477, 109, '2015-03-15 01:03:07.000000', 'temperatura', 757.0000, 'ºC'),
	(103478, 109, '2015-03-15 01:03:08.000000', 'temperatura', 480.0000, 'ºC'),
	(103479, 109, '2015-03-15 01:03:09.000000', 'temperatura', 130.0000, 'ºC'),
	(103480, 109, '2015-03-15 01:03:10.000000', 'temperatura', 411.0000, 'ºC'),
	(103481, 109, '2015-03-15 01:03:11.000000', 'temperatura', 465.0000, 'ºC'),
	(103482, 109, '2015-03-15 01:03:12.000000', 'temperatura', 1092.0000, 'ºC'),
	(103483, 109, '2015-03-15 01:03:13.000000', 'temperatura', 466.0000, 'ºC'),
	(103484, 109, '2015-03-15 01:03:14.000000', 'temperatura', 254.0000, 'ºC'),
	(103485, 109, '2015-03-15 01:03:15.000000', 'temperatura', 1072.0000, 'ºC'),
	(103486, 109, '2015-03-15 01:03:16.000000', 'temperatura', 1001.0000, 'ºC'),
	(103487, 109, '2015-03-15 01:03:17.000000', 'temperatura', 588.0000, 'ºC'),
	(103488, 109, '2015-03-15 01:03:18.000000', 'temperatura', 1138.0000, 'ºC'),
	(103489, 109, '2015-03-15 01:03:19.000000', 'temperatura', 325.0000, 'ºC'),
	(103490, 109, '2015-03-15 01:03:20.000000', 'temperatura', 613.0000, 'ºC'),
	(103491, 109, '2015-03-15 01:03:21.000000', 'temperatura', 892.0000, 'ºC'),
	(103492, 109, '2015-03-15 01:03:22.000000', 'temperatura', 218.0000, 'ºC'),
	(103493, 109, '2015-03-15 01:03:23.000000', 'temperatura', 816.0000, 'ºC'),
	(103494, 109, '2015-03-15 01:03:24.000000', 'temperatura', 1027.0000, 'ºC'),
	(103495, 109, '2015-03-15 01:03:25.000000', 'temperatura', 285.0000, 'ºC'),
	(103496, 109, '2015-03-15 01:03:26.000000', 'temperatura', 746.0000, 'ºC'),
	(103497, 109, '2015-03-15 01:03:27.000000', 'temperatura', 477.0000, 'ºC'),
	(103498, 109, '2015-03-15 01:03:28.000000', 'temperatura', 147.0000, 'ºC'),
	(103499, 109, '2015-03-15 01:03:29.000000', 'temperatura', 503.0000, 'ºC'),
	(103500, 109, '2015-03-15 01:03:30.000000', 'temperatura', 874.0000, 'ºC'),
	(103501, 109, '2015-03-15 01:03:31.000000', 'temperatura', 460.0000, 'ºC'),
	(103502, 109, '2015-03-15 01:03:32.000000', 'temperatura', 882.0000, 'ºC'),
	(103503, 109, '2015-03-15 01:03:33.000000', 'temperatura', 629.0000, 'ºC'),
	(103504, 109, '2015-03-15 01:03:34.000000', 'temperatura', 501.0000, 'ºC'),
	(103505, 109, '2015-03-15 01:03:35.000000', 'temperatura', 618.0000, 'ºC'),
	(103506, 109, '2015-03-15 01:03:36.000000', 'temperatura', 388.0000, 'ºC'),
	(103507, 109, '2015-03-15 01:03:37.000000', 'temperatura', 88.0000, 'ºC'),
	(103508, 109, '2015-03-15 01:03:38.000000', 'temperatura', 474.0000, 'ºC'),
	(103509, 109, '2015-03-15 01:03:39.000000', 'temperatura', 906.0000, 'ºC'),
	(103510, 109, '2015-03-15 01:03:40.000000', 'temperatura', 710.0000, 'ºC'),
	(103511, 109, '2015-03-15 01:03:41.000000', 'temperatura', 833.0000, 'ºC'),
	(103512, 109, '2015-03-15 01:03:42.000000', 'temperatura', 836.0000, 'ºC'),
	(103513, 109, '2015-03-15 01:03:43.000000', 'temperatura', 481.0000, 'ºC'),
	(103514, 109, '2015-03-15 01:03:44.000000', 'temperatura', 1095.0000, 'ºC'),
	(103515, 109, '2015-03-15 01:03:45.000000', 'temperatura', 436.0000, 'ºC'),
	(103516, 109, '2015-03-15 01:03:46.000000', 'temperatura', 92.0000, 'ºC'),
	(103517, 109, '2015-03-15 01:03:47.000000', 'temperatura', 354.0000, 'ºC'),
	(103518, 109, '2015-03-15 01:03:48.000000', 'temperatura', 297.0000, 'ºC'),
	(103519, 109, '2015-03-15 01:03:49.000000', 'temperatura', 420.0000, 'ºC'),
	(103520, 109, '2015-03-15 01:03:50.000000', 'temperatura', 10.0000, 'ºC'),
	(103521, 109, '2015-03-15 01:03:51.000000', 'temperatura', 1192.0000, 'ºC'),
	(103522, 109, '2015-03-15 01:03:52.000000', 'temperatura', 1129.0000, 'ºC'),
	(103523, 109, '2015-03-15 01:03:53.000000', 'temperatura', 870.0000, 'ºC'),
	(103524, 109, '2015-03-15 01:03:54.000000', 'temperatura', 963.0000, 'ºC'),
	(103525, 109, '2015-03-15 01:03:55.000000', 'temperatura', 1007.0000, 'ºC'),
	(103526, 109, '2015-03-15 01:03:56.000000', 'temperatura', 946.0000, 'ºC'),
	(103527, 109, '2015-03-15 01:03:57.000000', 'temperatura', 509.0000, 'ºC'),
	(103528, 109, '2015-03-15 01:03:58.000000', 'temperatura', 907.0000, 'ºC'),
	(103529, 109, '2015-03-15 01:03:59.000000', 'temperatura', 609.0000, 'ºC'),
	(103530, 109, '2015-03-15 01:04:00.000000', 'temperatura', 323.0000, 'ºC'),
	(103531, 109, '2015-03-15 01:04:01.000000', 'temperatura', 988.0000, 'ºC'),
	(103532, 109, '2015-03-15 01:04:02.000000', 'temperatura', 371.0000, 'ºC'),
	(103533, 109, '2015-03-15 01:04:03.000000', 'temperatura', 91.0000, 'ºC'),
	(103534, 109, '2015-03-15 01:04:04.000000', 'temperatura', 542.0000, 'ºC'),
	(103535, 109, '2015-03-15 01:04:05.000000', 'temperatura', 37.0000, 'ºC'),
	(103536, 109, '2015-03-15 01:04:06.000000', 'temperatura', 959.0000, 'ºC'),
	(103537, 109, '2015-03-15 01:04:07.000000', 'temperatura', 1087.0000, 'ºC'),
	(103538, 109, '2015-03-15 01:04:08.000000', 'temperatura', 156.0000, 'ºC'),
	(103539, 109, '2015-03-15 01:04:09.000000', 'temperatura', 1120.0000, 'ºC'),
	(103540, 109, '2015-03-15 01:04:10.000000', 'temperatura', 335.0000, 'ºC'),
	(103541, 109, '2015-03-15 01:04:11.000000', 'temperatura', 713.0000, 'ºC'),
	(103542, 109, '2015-03-15 01:04:12.000000', 'temperatura', 162.0000, 'ºC'),
	(103543, 109, '2015-03-15 01:04:13.000000', 'temperatura', 1072.0000, 'ºC'),
	(103544, 109, '2015-03-15 01:04:14.000000', 'temperatura', 72.0000, 'ºC'),
	(103545, 109, '2015-03-15 01:04:15.000000', 'temperatura', 748.0000, 'ºC'),
	(103546, 109, '2015-03-15 01:04:16.000000', 'temperatura', 1121.0000, 'ºC'),
	(103547, 109, '2015-03-15 01:04:17.000000', 'temperatura', 965.0000, 'ºC'),
	(103548, 109, '2015-03-15 01:04:18.000000', 'temperatura', 260.0000, 'ºC'),
	(103549, 109, '2015-03-15 01:04:19.000000', 'temperatura', 806.0000, 'ºC'),
	(103550, 109, '2015-03-15 01:04:20.000000', 'temperatura', 849.0000, 'ºC'),
	(103551, 109, '2015-03-15 01:04:21.000000', 'temperatura', 628.0000, 'ºC'),
	(103552, 109, '2015-03-15 01:04:22.000000', 'temperatura', 595.0000, 'ºC'),
	(103553, 109, '2015-03-15 01:04:23.000000', 'temperatura', 1089.0000, 'ºC'),
	(103554, 109, '2015-03-15 01:04:24.000000', 'temperatura', 61.0000, 'ºC'),
	(103555, 109, '2015-03-15 01:04:25.000000', 'temperatura', 638.0000, 'ºC'),
	(103556, 109, '2015-03-15 01:04:26.000000', 'temperatura', 608.0000, 'ºC'),
	(103557, 109, '2015-03-15 01:04:27.000000', 'temperatura', 1128.0000, 'ºC'),
	(103558, 109, '2015-03-15 01:04:28.000000', 'temperatura', 217.0000, 'ºC'),
	(103559, 109, '2015-03-15 01:04:29.000000', 'temperatura', 99.0000, 'ºC'),
	(103560, 109, '2015-03-15 01:04:30.000000', 'temperatura', 1047.0000, 'ºC'),
	(103561, 109, '2015-03-15 01:04:31.000000', 'temperatura', 139.0000, 'ºC'),
	(103562, 109, '2015-03-15 01:04:32.000000', 'temperatura', 1153.0000, 'ºC'),
	(103563, 109, '2015-03-15 01:04:33.000000', 'temperatura', 548.0000, 'ºC'),
	(103564, 109, '2015-03-15 01:04:34.000000', 'temperatura', 483.0000, 'ºC'),
	(103565, 109, '2015-03-15 01:04:35.000000', 'temperatura', 771.0000, 'ºC'),
	(103566, 109, '2015-03-15 01:04:36.000000', 'temperatura', 5.0000, 'ºC'),
	(103567, 109, '2015-03-15 01:04:37.000000', 'temperatura', 115.0000, 'ºC'),
	(103568, 109, '2015-03-15 01:04:38.000000', 'temperatura', 559.0000, 'ºC'),
	(103569, 109, '2015-03-15 01:04:39.000000', 'temperatura', 49.0000, 'ºC'),
	(103570, 109, '2015-03-15 01:04:40.000000', 'temperatura', 972.0000, 'ºC'),
	(103571, 109, '2015-03-15 01:04:41.000000', 'temperatura', 1111.0000, 'ºC'),
	(103572, 109, '2015-03-15 01:04:42.000000', 'temperatura', 238.0000, 'ºC'),
	(103573, 109, '2015-03-15 01:04:43.000000', 'temperatura', 260.0000, 'ºC'),
	(103574, 109, '2015-03-15 01:04:44.000000', 'temperatura', 584.0000, 'ºC'),
	(103575, 109, '2015-03-15 01:04:45.000000', 'temperatura', 942.0000, 'ºC'),
	(103576, 109, '2015-03-15 01:04:46.000000', 'temperatura', 560.0000, 'ºC'),
	(103577, 109, '2015-03-15 01:04:47.000000', 'temperatura', 1174.0000, 'ºC'),
	(103578, 109, '2015-03-15 01:04:48.000000', 'temperatura', 589.0000, 'ºC'),
	(103579, 109, '2015-03-15 01:04:49.000000', 'temperatura', 624.0000, 'ºC'),
	(103580, 109, '2015-03-15 01:04:50.000000', 'temperatura', 153.0000, 'ºC'),
	(103581, 109, '2015-03-15 01:04:51.000000', 'temperatura', 95.0000, 'ºC'),
	(103582, 109, '2015-03-15 01:04:52.000000', 'temperatura', 15.0000, 'ºC'),
	(103583, 109, '2015-03-15 01:04:53.000000', 'temperatura', 991.0000, 'ºC'),
	(103584, 109, '2015-03-15 01:04:54.000000', 'temperatura', 109.0000, 'ºC'),
	(103585, 109, '2015-03-15 01:04:55.000000', 'temperatura', 1175.0000, 'ºC'),
	(103586, 109, '2015-03-15 01:04:56.000000', 'temperatura', 748.0000, 'ºC'),
	(103587, 109, '2015-03-15 01:04:57.000000', 'temperatura', 214.0000, 'ºC'),
	(103588, 109, '2015-03-15 01:04:58.000000', 'temperatura', 28.0000, 'ºC'),
	(103589, 109, '2015-03-15 01:04:59.000000', 'temperatura', 697.0000, 'ºC'),
	(103590, 109, '2015-03-15 01:05:00.000000', 'temperatura', 1001.0000, 'ºC'),
	(103591, 109, '2015-03-15 01:05:01.000000', 'temperatura', 516.0000, 'ºC'),
	(103592, 109, '2015-03-15 01:05:02.000000', 'temperatura', 779.0000, 'ºC'),
	(103593, 109, '2015-03-15 01:05:03.000000', 'temperatura', 1146.0000, 'ºC'),
	(103594, 109, '2015-03-15 01:05:04.000000', 'temperatura', 995.0000, 'ºC'),
	(103595, 109, '2015-03-15 01:05:05.000000', 'temperatura', 335.0000, 'ºC'),
	(103596, 109, '2015-03-15 01:05:06.000000', 'temperatura', 1094.0000, 'ºC'),
	(103597, 109, '2015-03-15 01:05:07.000000', 'temperatura', 862.0000, 'ºC'),
	(103598, 109, '2015-03-15 01:05:08.000000', 'temperatura', 1029.0000, 'ºC'),
	(103599, 109, '2015-03-15 01:05:09.000000', 'temperatura', 162.0000, 'ºC'),
	(103600, 109, '2015-03-15 01:05:10.000000', 'temperatura', 120.0000, 'ºC'),
	(103601, 109, '2015-03-15 01:05:11.000000', 'temperatura', 118.0000, 'ºC'),
	(103602, 109, '2015-03-15 01:05:12.000000', 'temperatura', 229.0000, 'ºC'),
	(103603, 109, '2015-03-15 01:05:13.000000', 'temperatura', 791.0000, 'ºC'),
	(103604, 109, '2015-03-15 01:05:14.000000', 'temperatura', 867.0000, 'ºC'),
	(103605, 109, '2015-03-15 01:05:15.000000', 'temperatura', 764.0000, 'ºC'),
	(103606, 109, '2015-03-15 01:05:16.000000', 'temperatura', 21.0000, 'ºC'),
	(103607, 109, '2015-03-15 01:05:17.000000', 'temperatura', 214.0000, 'ºC'),
	(103608, 109, '2015-03-15 01:05:18.000000', 'temperatura', 1007.0000, 'ºC'),
	(103609, 109, '2015-03-15 01:05:19.000000', 'temperatura', 791.0000, 'ºC'),
	(103610, 109, '2015-03-15 01:05:20.000000', 'temperatura', 937.0000, 'ºC'),
	(103611, 109, '2015-03-15 01:05:21.000000', 'temperatura', 1113.0000, 'ºC'),
	(103612, 109, '2015-03-15 01:05:22.000000', 'temperatura', 355.0000, 'ºC'),
	(103613, 109, '2015-03-15 01:05:23.000000', 'temperatura', 838.0000, 'ºC'),
	(103614, 109, '2015-03-15 01:05:24.000000', 'temperatura', 722.0000, 'ºC'),
	(103615, 109, '2015-03-15 01:05:25.000000', 'temperatura', 1097.0000, 'ºC'),
	(103616, 109, '2015-03-15 01:05:26.000000', 'temperatura', 920.0000, 'ºC'),
	(103617, 109, '2015-03-15 01:05:27.000000', 'temperatura', 110.0000, 'ºC'),
	(103618, 109, '2015-03-15 01:05:28.000000', 'temperatura', 189.0000, 'ºC'),
	(103619, 109, '2015-03-15 01:05:29.000000', 'temperatura', 616.0000, 'ºC'),
	(103620, 109, '2015-03-15 01:05:30.000000', 'temperatura', 114.0000, 'ºC'),
	(103621, 109, '2015-03-15 01:05:31.000000', 'temperatura', 1122.0000, 'ºC'),
	(103622, 109, '2015-03-15 01:05:32.000000', 'temperatura', 469.0000, 'ºC'),
	(103623, 109, '2015-03-15 01:05:33.000000', 'temperatura', 178.0000, 'ºC'),
	(103624, 109, '2015-03-15 01:05:34.000000', 'temperatura', 683.0000, 'ºC'),
	(103625, 109, '2015-03-15 01:05:35.000000', 'temperatura', 482.0000, 'ºC'),
	(103626, 109, '2015-03-15 01:05:36.000000', 'temperatura', 362.0000, 'ºC'),
	(103627, 109, '2015-03-15 01:05:37.000000', 'temperatura', 366.0000, 'ºC'),
	(103628, 109, '2015-03-15 01:05:38.000000', 'temperatura', 742.0000, 'ºC'),
	(103629, 109, '2015-03-15 01:05:39.000000', 'temperatura', 214.0000, 'ºC'),
	(103630, 109, '2015-03-15 01:05:40.000000', 'temperatura', 46.0000, 'ºC'),
	(103631, 109, '2015-03-15 01:05:41.000000', 'temperatura', 787.0000, 'ºC'),
	(103632, 109, '2015-03-15 01:05:42.000000', 'temperatura', 196.0000, 'ºC'),
	(103633, 109, '2015-03-15 01:05:43.000000', 'temperatura', 1019.0000, 'ºC'),
	(103634, 109, '2015-03-15 01:05:44.000000', 'temperatura', 907.0000, 'ºC'),
	(103635, 109, '2015-03-15 01:05:45.000000', 'temperatura', 280.0000, 'ºC'),
	(103636, 109, '2015-03-15 01:05:46.000000', 'temperatura', 1078.0000, 'ºC'),
	(103637, 109, '2015-03-15 01:05:47.000000', 'temperatura', 953.0000, 'ºC'),
	(103638, 109, '2015-03-15 01:05:48.000000', 'temperatura', 332.0000, 'ºC'),
	(103639, 109, '2015-03-15 01:05:49.000000', 'temperatura', 0.0000, 'ºC'),
	(103640, 109, '2015-03-15 01:05:50.000000', 'temperatura', 207.0000, 'ºC'),
	(103641, 109, '2015-03-15 01:05:51.000000', 'temperatura', 1032.0000, 'ºC'),
	(103642, 109, '2015-03-15 01:05:52.000000', 'temperatura', 940.0000, 'ºC'),
	(103643, 109, '2015-03-15 01:05:53.000000', 'temperatura', 405.0000, 'ºC'),
	(103644, 109, '2015-03-15 01:05:54.000000', 'temperatura', 405.0000, 'ºC'),
	(103645, 109, '2015-03-15 01:05:55.000000', 'temperatura', 812.0000, 'ºC'),
	(103646, 109, '2015-03-15 01:05:56.000000', 'temperatura', 443.0000, 'ºC'),
	(103647, 109, '2015-03-15 01:05:57.000000', 'temperatura', 983.0000, 'ºC'),
	(103648, 109, '2015-03-15 01:05:58.000000', 'temperatura', 1183.0000, 'ºC'),
	(103649, 109, '2015-03-15 01:05:59.000000', 'temperatura', 568.0000, 'ºC'),
	(103650, 109, '2015-03-15 01:06:00.000000', 'temperatura', 490.0000, 'ºC'),
	(103651, 109, '2015-03-15 01:06:01.000000', 'temperatura', 749.0000, 'ºC'),
	(103652, 109, '2015-03-15 01:06:02.000000', 'temperatura', 1073.0000, 'ºC'),
	(103653, 109, '2015-03-15 01:06:03.000000', 'temperatura', 721.0000, 'ºC'),
	(103654, 109, '2015-03-15 01:06:04.000000', 'temperatura', 388.0000, 'ºC'),
	(103655, 109, '2015-03-15 01:06:05.000000', 'temperatura', 974.0000, 'ºC'),
	(103656, 109, '2015-03-15 01:06:06.000000', 'temperatura', 107.0000, 'ºC'),
	(103657, 109, '2015-03-15 01:06:07.000000', 'temperatura', 13.0000, 'ºC'),
	(103658, 109, '2015-03-15 01:06:08.000000', 'temperatura', 945.0000, 'ºC'),
	(103659, 109, '2015-03-15 01:06:09.000000', 'temperatura', 1085.0000, 'ºC'),
	(103660, 109, '2015-03-15 01:06:10.000000', 'temperatura', 191.0000, 'ºC'),
	(103661, 109, '2015-03-15 01:06:11.000000', 'temperatura', 99.0000, 'ºC'),
	(103662, 109, '2015-03-15 01:06:12.000000', 'temperatura', 1124.0000, 'ºC'),
	(103663, 109, '2015-03-15 01:06:13.000000', 'temperatura', 521.0000, 'ºC'),
	(103664, 109, '2015-03-15 01:06:14.000000', 'temperatura', 437.0000, 'ºC'),
	(103665, 109, '2015-03-15 01:06:15.000000', 'temperatura', 620.0000, 'ºC'),
	(103666, 109, '2015-03-15 01:06:16.000000', 'temperatura', 588.0000, 'ºC'),
	(103667, 109, '2015-03-15 01:06:17.000000', 'temperatura', 1084.0000, 'ºC'),
	(103668, 109, '2015-03-15 01:06:18.000000', 'temperatura', 55.0000, 'ºC'),
	(103669, 109, '2015-03-15 01:06:19.000000', 'temperatura', 622.0000, 'ºC'),
	(103670, 109, '2015-03-15 01:06:20.000000', 'temperatura', 546.0000, 'ºC'),
	(103671, 109, '2015-03-15 01:06:21.000000', 'temperatura', 866.0000, 'ºC'),
	(103672, 109, '2015-03-15 01:06:22.000000', 'temperatura', 291.0000, 'ºC'),
	(103673, 109, '2015-03-15 01:06:23.000000', 'temperatura', 58.0000, 'ºC'),
	(103674, 109, '2015-03-15 01:06:24.000000', 'temperatura', 617.0000, 'ºC'),
	(103675, 109, '2015-03-15 01:06:25.000000', 'temperatura', 512.0000, 'ºC'),
	(103676, 109, '2015-03-15 01:06:26.000000', 'temperatura', 707.0000, 'ºC'),
	(103677, 109, '2015-03-15 01:06:27.000000', 'temperatura', 803.0000, 'ºC'),
	(103678, 109, '2015-03-15 01:06:28.000000', 'temperatura', 693.0000, 'ºC'),
	(103679, 109, '2015-03-15 01:06:29.000000', 'temperatura', 1058.0000, 'ºC'),
	(103680, 109, '2015-03-15 01:06:30.000000', 'temperatura', 811.0000, 'ºC'),
	(103681, 109, '2015-03-15 01:06:31.000000', 'temperatura', 883.0000, 'ºC'),
	(103682, 109, '2015-03-15 01:06:32.000000', 'temperatura', 782.0000, 'ºC'),
	(103683, 109, '2015-03-15 01:06:33.000000', 'temperatura', 62.0000, 'ºC'),
	(103684, 109, '2015-03-15 01:06:34.000000', 'temperatura', 364.0000, 'ºC'),
	(103685, 109, '2015-03-15 01:06:35.000000', 'temperatura', 436.0000, 'ºC'),
	(103686, 109, '2015-03-15 01:06:36.000000', 'temperatura', 1088.0000, 'ºC'),
	(103687, 109, '2015-03-15 01:06:37.000000', 'temperatura', 534.0000, 'ºC'),
	(103688, 109, '2015-03-15 01:06:38.000000', 'temperatura', 604.0000, 'ºC'),
	(103689, 109, '2015-03-15 01:06:39.000000', 'temperatura', 218.0000, 'ºC'),
	(103690, 109, '2015-03-15 01:06:40.000000', 'temperatura', 479.0000, 'ºC'),
	(103691, 109, '2015-03-15 01:06:41.000000', 'temperatura', 540.0000, 'ºC'),
	(103692, 109, '2015-03-15 01:06:42.000000', 'temperatura', 66.0000, 'ºC'),
	(103693, 109, '2015-03-15 01:06:43.000000', 'temperatura', 1111.0000, 'ºC'),
	(103694, 109, '2015-03-15 01:06:44.000000', 'temperatura', 555.0000, 'ºC'),
	(103695, 109, '2015-03-15 01:06:45.000000', 'temperatura', 643.0000, 'ºC'),
	(103696, 109, '2015-03-15 01:06:46.000000', 'temperatura', 349.0000, 'ºC'),
	(103697, 109, '2015-03-15 01:06:47.000000', 'temperatura', 1019.0000, 'ºC'),
	(103698, 109, '2015-03-15 01:06:48.000000', 'temperatura', 448.0000, 'ºC'),
	(103699, 109, '2015-03-15 01:06:49.000000', 'temperatura', 383.0000, 'ºC'),
	(103700, 109, '2015-03-15 01:06:50.000000', 'temperatura', 573.0000, 'ºC'),
	(103701, 109, '2015-03-15 01:06:51.000000', 'temperatura', 515.0000, 'ºC'),
	(103702, 109, '2015-03-15 01:06:52.000000', 'temperatura', 858.0000, 'ºC'),
	(103703, 109, '2015-03-15 01:06:53.000000', 'temperatura', 345.0000, 'ºC'),
	(103704, 109, '2015-03-15 01:06:54.000000', 'temperatura', 352.0000, 'ºC'),
	(103705, 109, '2015-03-15 01:06:55.000000', 'temperatura', 727.0000, 'ºC'),
	(103706, 109, '2015-03-15 01:06:56.000000', 'temperatura', 178.0000, 'ºC'),
	(103707, 109, '2015-03-15 01:06:57.000000', 'temperatura', 1109.0000, 'ºC'),
	(103708, 109, '2015-03-15 01:06:58.000000', 'temperatura', 212.0000, 'ºC'),
	(103709, 109, '2015-03-15 01:06:59.000000', 'temperatura', 133.0000, 'ºC'),
	(103710, 109, '2015-03-15 01:07:00.000000', 'temperatura', 30.0000, 'ºC'),
	(103711, 109, '2015-03-15 01:07:01.000000', 'temperatura', 951.0000, 'ºC'),
	(103712, 109, '2015-03-15 01:07:02.000000', 'temperatura', 1066.0000, 'ºC'),
	(103713, 109, '2015-03-15 01:07:03.000000', 'temperatura', 77.0000, 'ºC'),
	(103714, 109, '2015-03-15 01:07:04.000000', 'temperatura', 786.0000, 'ºC'),
	(103715, 109, '2015-03-15 01:07:05.000000', 'temperatura', 101.0000, 'ºC'),
	(103716, 109, '2015-03-15 01:07:06.000000', 'temperatura', 549.0000, 'ºC'),
	(103717, 109, '2015-03-15 01:07:07.000000', 'temperatura', 42.0000, 'ºC'),
	(103718, 109, '2015-03-15 01:07:08.000000', 'temperatura', 961.0000, 'ºC'),
	(103719, 109, '2015-03-15 01:07:09.000000', 'temperatura', 1083.0000, 'ºC'),
	(103720, 109, '2015-03-15 01:07:10.000000', 'temperatura', 131.0000, 'ºC'),
	(103721, 109, '2015-03-15 01:07:11.000000', 'temperatura', 1006.0000, 'ºC'),
	(103722, 109, '2015-03-15 01:07:12.000000', 'temperatura', 1039.0000, 'ºC'),
	(103723, 109, '2015-03-15 01:07:13.000000', 'temperatura', 977.0000, 'ºC'),
	(103724, 109, '2015-03-15 01:07:14.000000', 'temperatura', 570.0000, 'ºC'),
	(103725, 109, '2015-03-15 01:07:15.000000', 'temperatura', 1116.0000, 'ºC'),
	(103726, 109, '2015-03-15 01:07:16.000000', 'temperatura', 273.0000, 'ºC'),
	(103727, 109, '2015-03-15 01:07:17.000000', 'temperatura', 416.0000, 'ºC'),
	(103728, 109, '2015-03-15 01:07:18.000000', 'temperatura', 63.0000, 'ºC'),
	(103729, 109, '2015-03-15 01:07:19.000000', 'temperatura', 269.0000, 'ºC'),
	(103730, 109, '2015-03-15 01:07:20.000000', 'temperatura', 1155.0000, 'ºC'),
	(103731, 109, '2015-03-15 01:07:21.000000', 'temperatura', 168.0000, 'ºC'),
	(103732, 109, '2015-03-15 01:07:22.000000', 'temperatura', 976.0000, 'ºC'),
	(103733, 109, '2015-03-15 01:07:23.000000', 'temperatura', 777.0000, 'ºC'),
	(103734, 109, '2015-03-15 01:07:24.000000', 'temperatura', 957.0000, 'ºC'),
	(103735, 109, '2015-03-15 01:07:25.000000', 'temperatura', 53.0000, 'ºC'),
	(103736, 109, '2015-03-15 01:07:26.000000', 'temperatura', 994.0000, 'ºC'),
	(103737, 109, '2015-03-15 01:07:27.000000', 'temperatura', 12.0000, 'ºC'),
	(103738, 109, '2015-03-15 01:07:28.000000', 'temperatura', 678.0000, 'ºC'),
	(103739, 109, '2015-03-15 01:07:29.000000', 'temperatura', 955.0000, 'ºC'),
	(103740, 109, '2015-03-15 01:07:30.000000', 'temperatura', 342.0000, 'ºC'),
	(103741, 109, '2015-03-15 01:07:31.000000', 'temperatura', 44.0000, 'ºC'),
	(103742, 109, '2015-03-15 01:07:32.000000', 'temperatura', 397.0000, 'ºC'),
	(103743, 109, '2015-03-15 01:07:33.000000', 'temperatura', 651.0000, 'ºC'),
	(103744, 109, '2015-03-15 01:07:34.000000', 'temperatura', 866.0000, 'ºC'),
	(103745, 109, '2015-03-15 01:07:35.000000', 'temperatura', 1177.0000, 'ºC'),
	(103746, 109, '2015-03-15 01:07:36.000000', 'temperatura', 887.0000, 'ºC'),
	(103747, 109, '2015-03-15 01:07:37.000000', 'temperatura', 906.0000, 'ºC'),
	(103748, 109, '2015-03-15 01:07:38.000000', 'temperatura', 670.0000, 'ºC'),
	(103749, 109, '2015-03-15 01:07:39.000000', 'temperatura', 632.0000, 'ºC'),
	(103750, 109, '2015-03-15 01:07:40.000000', 'temperatura', 1152.0000, 'ºC'),
	(103751, 109, '2015-03-15 01:07:41.000000', 'temperatura', 264.0000, 'ºC'),
	(103752, 109, '2015-03-15 01:07:42.000000', 'temperatura', 264.0000, 'ºC'),
	(103753, 109, '2015-03-15 01:07:43.000000', 'temperatura', 528.0000, 'ºC'),
	(103754, 109, '2015-03-15 01:07:44.000000', 'temperatura', 647.0000, 'ºC'),
	(103755, 109, '2015-03-15 01:07:45.000000', 'temperatura', 452.0000, 'ºC'),
	(103756, 109, '2015-03-15 01:07:46.000000', 'temperatura', 319.0000, 'ºC'),
	(103757, 109, '2015-03-15 01:07:47.000000', 'temperatura', 241.0000, 'ºC'),
	(103758, 109, '2015-03-15 01:07:48.000000', 'temperatura', 247.0000, 'ºC'),
	(103759, 109, '2015-03-15 01:07:49.000000', 'temperatura', 514.0000, 'ºC'),
	(103760, 109, '2015-03-15 01:07:50.000000', 'temperatura', 629.0000, 'ºC'),
	(103761, 109, '2015-03-15 01:07:51.000000', 'temperatura', 404.0000, 'ºC'),
	(103762, 109, '2015-03-15 01:07:52.000000', 'temperatura', 134.0000, 'ºC'),
	(103763, 109, '2015-03-15 01:07:53.000000', 'temperatura', 656.0000, 'ºC'),
	(103764, 109, '2015-03-15 01:07:54.000000', 'temperatura', 480.0000, 'ºC'),
	(103765, 109, '2015-03-15 01:07:55.000000', 'temperatura', 431.0000, 'ºC'),
	(103766, 109, '2015-03-15 01:07:56.000000', 'temperatura', 717.0000, 'ºC'),
	(103767, 109, '2015-03-15 01:07:57.000000', 'temperatura', 1091.0000, 'ºC'),
	(103768, 109, '2015-03-15 01:07:58.000000', 'temperatura', 907.0000, 'ºC'),
	(103769, 109, '2015-03-15 01:07:59.000000', 'temperatura', 61.0000, 'ºC'),
	(103770, 109, '2015-03-15 01:08:00.000000', 'temperatura', 1187.0000, 'ºC'),
	(103771, 109, '2015-03-15 01:08:01.000000', 'temperatura', 950.0000, 'ºC'),
	(103772, 109, '2015-03-15 01:08:02.000000', 'temperatura', 1191.0000, 'ºC'),
	(103773, 109, '2015-03-15 01:08:03.000000', 'temperatura', 705.0000, 'ºC'),
	(103774, 109, '2015-03-15 01:08:04.000000', 'temperatura', 1152.0000, 'ºC'),
	(103775, 109, '2015-03-15 01:08:05.000000', 'temperatura', 44.0000, 'ºC'),
	(103776, 109, '2015-03-15 01:08:06.000000', 'temperatura', 365.0000, 'ºC'),
	(103777, 109, '2015-03-15 01:08:07.000000', 'temperatura', 495.0000, 'ºC'),
	(103778, 109, '2015-03-15 01:08:08.000000', 'temperatura', 182.0000, 'ºC'),
	(103779, 109, '2015-03-15 01:08:09.000000', 'temperatura', 624.0000, 'ºC'),
	(103780, 109, '2015-03-15 01:08:10.000000', 'temperatura', 172.0000, 'ºC'),
	(103781, 109, '2015-03-15 01:08:11.000000', 'temperatura', 192.0000, 'ºC'),
	(103782, 109, '2015-03-15 01:08:12.000000', 'temperatura', 444.0000, 'ºC'),
	(103783, 109, '2015-03-15 01:08:13.000000', 'temperatura', 446.0000, 'ºC'),
	(103784, 109, '2015-03-15 01:08:14.000000', 'temperatura', 897.0000, 'ºC'),
	(103785, 109, '2015-03-15 01:08:15.000000', 'temperatura', 748.0000, 'ºC'),
	(103786, 109, '2015-03-15 01:08:16.000000', 'temperatura', 1049.0000, 'ºC'),
	(103787, 109, '2015-03-15 01:08:17.000000', 'temperatura', 600.0000, 'ºC'),
	(103788, 109, '2015-03-15 01:08:18.000000', 'temperatura', 1054.0000, 'ºC'),
	(103789, 109, '2015-03-15 01:08:19.000000', 'temperatura', 1070.0000, 'ºC'),
	(103790, 109, '2015-03-15 01:08:20.000000', 'temperatura', 989.0000, 'ºC'),
	(103791, 109, '2015-03-15 01:08:21.000000', 'temperatura', 534.0000, 'ºC'),
	(103792, 109, '2015-03-15 01:08:22.000000', 'temperatura', 903.0000, 'ºC'),
	(103793, 109, '2015-03-15 01:08:23.000000', 'temperatura', 515.0000, 'ºC'),
	(103794, 109, '2015-03-15 01:08:24.000000', 'temperatura', 1066.0000, 'ºC'),
	(103795, 109, '2015-03-15 01:08:25.000000', 'temperatura', 185.0000, 'ºC'),
	(103796, 109, '2015-03-15 01:08:26.000000', 'temperatura', 130.0000, 'ºC'),
	(103797, 109, '2015-03-15 01:08:27.000000', 'temperatura', 92.0000, 'ºC'),
	(103798, 109, '2015-03-15 01:08:28.000000', 'temperatura', 73.0000, 'ºC'),
	(103799, 109, '2015-03-15 01:08:29.000000', 'temperatura', 88.0000, 'ºC'),
	(103800, 109, '2015-03-15 01:08:30.000000', 'temperatura', 224.0000, 'ºC'),
	(103801, 109, '2015-03-15 01:08:31.000000', 'temperatura', 855.0000, 'ºC'),
	(103802, 109, '2015-03-15 01:08:32.000000', 'temperatura', 4.0000, 'ºC'),
	(103803, 109, '2015-03-15 01:08:33.000000', 'temperatura', 1054.0000, 'ºC'),
	(103804, 109, '2015-03-15 01:08:34.000000', 'temperatura', 458.0000, 'ºC'),
	(103805, 109, '2015-03-15 01:08:35.000000', 'temperatura', 328.0000, 'ºC'),
	(103806, 109, '2015-03-15 01:08:36.000000', 'temperatura', 266.0000, 'ºC'),
	(103807, 109, '2015-03-15 01:08:37.000000', 'temperatura', 346.0000, 'ºC'),
	(103808, 109, '2015-03-15 01:08:38.000000', 'temperatura', 935.0000, 'ºC'),
	(103809, 109, '2015-03-15 01:08:39.000000', 'temperatura', 36.0000, 'ºC'),
	(103810, 109, '2015-03-15 01:08:40.000000', 'temperatura', 976.0000, 'ºC'),
	(103811, 109, '2015-03-15 01:08:41.000000', 'temperatura', 1173.0000, 'ºC'),
	(103812, 109, '2015-03-15 01:08:42.000000', 'temperatura', 538.0000, 'ºC'),
	(103813, 109, '2015-03-15 01:08:43.000000', 'temperatura', 372.0000, 'ºC'),
	(103814, 109, '2015-03-15 01:08:44.000000', 'temperatura', 247.0000, 'ºC'),
	(103815, 109, '2015-03-15 01:08:45.000000', 'temperatura', 118.0000, 'ºC'),
	(103816, 109, '2015-03-15 01:08:46.000000', 'temperatura', 1050.0000, 'ºC'),
	(103817, 109, '2015-03-15 01:08:47.000000', 'temperatura', 96.0000, 'ºC'),
	(103818, 109, '2015-03-15 01:08:48.000000', 'temperatura', 931.0000, 'ºC'),
	(103819, 109, '2015-03-15 01:08:49.000000', 'temperatura', 766.0000, 'ºC'),
	(103820, 109, '2015-03-15 01:08:50.000000', 'temperatura', 1038.0000, 'ºC'),
	(103821, 109, '2015-03-15 01:08:51.000000', 'temperatura', 493.0000, 'ºC'),
	(103822, 109, '2015-03-15 01:08:52.000000', 'temperatura', 552.0000, 'ºC'),
	(103823, 109, '2015-03-15 01:08:53.000000', 'temperatura', 81.0000, 'ºC'),
	(103824, 109, '2015-03-15 01:08:54.000000', 'temperatura', 1150.0000, 'ºC'),
	(103825, 109, '2015-03-15 01:08:55.000000', 'temperatura', 707.0000, 'ºC'),
	(103826, 109, '2015-03-15 01:08:56.000000', 'temperatura', 84.0000, 'ºC'),
	(103827, 109, '2015-03-15 01:08:57.000000', 'temperatura', 699.0000, 'ºC'),
	(103828, 109, '2015-03-15 01:08:58.000000', 'temperatura', 844.0000, 'ºC'),
	(103829, 109, '2015-03-15 01:08:59.000000', 'temperatura', 922.0000, 'ºC'),
	(103830, 109, '2015-03-15 01:09:00.000000', 'temperatura', 879.0000, 'ºC'),
	(103831, 109, '2015-03-15 01:09:01.000000', 'temperatura', 432.0000, 'ºC'),
	(103832, 109, '2015-03-15 01:09:02.000000', 'temperatura', 722.0000, 'ºC'),
	(103833, 109, '2015-03-15 01:09:03.000000', 'temperatura', 1117.0000, 'ºC'),
	(103834, 109, '2015-03-15 01:09:04.000000', 'temperatura', 1016.0000, 'ºC'),
	(103835, 109, '2015-03-15 01:09:05.000000', 'temperatura', 532.0000, 'ºC'),
	(103836, 109, '2015-03-15 01:09:06.000000', 'temperatura', 813.0000, 'ºC'),
	(103837, 109, '2015-03-15 01:09:07.000000', 'temperatura', 70.0000, 'ºC'),
	(103838, 109, '2015-03-15 01:09:08.000000', 'temperatura', 312.0000, 'ºC'),
	(103839, 109, '2015-03-15 01:09:09.000000', 'temperatura', 148.0000, 'ºC'),
	(103840, 109, '2015-03-15 01:09:10.000000', 'temperatura', 1007.0000, 'ºC'),
	(103841, 109, '2015-03-15 01:09:11.000000', 'temperatura', 990.0000, 'ºC'),
	(103842, 109, '2015-03-15 01:09:12.000000', 'temperatura', 731.0000, 'ºC'),
	(103843, 109, '2015-03-15 01:09:13.000000', 'temperatura', 686.0000, 'ºC'),
	(103844, 109, '2015-03-15 01:09:14.000000', 'temperatura', 35.0000, 'ºC'),
	(103845, 109, '2015-03-15 01:09:15.000000', 'temperatura', 519.0000, 'ºC'),
	(103846, 109, '2015-03-15 01:09:16.000000', 'temperatura', 89.0000, 'ºC'),
	(103847, 109, '2015-03-15 01:09:17.000000', 'temperatura', 90.0000, 'ºC'),
	(103848, 109, '2015-03-15 01:09:18.000000', 'temperatura', 184.0000, 'ºC'),
	(103849, 109, '2015-03-15 01:09:19.000000', 'temperatura', 650.0000, 'ºC'),
	(103850, 109, '2015-03-15 01:09:20.000000', 'temperatura', 300.0000, 'ºC'),
	(103851, 109, '2015-03-15 01:09:21.000000', 'temperatura', 747.0000, 'ºC'),
	(103852, 109, '2015-03-15 01:09:22.000000', 'temperatura', 439.0000, 'ºC'),
	(103853, 109, '2015-03-15 01:09:23.000000', 'temperatura', 1153.0000, 'ºC'),
	(103854, 109, '2015-03-15 01:09:24.000000', 'temperatura', 847.0000, 'ºC'),
	(103855, 109, '2015-03-15 01:09:25.000000', 'temperatura', 779.0000, 'ºC'),
	(103856, 109, '2015-03-15 01:09:26.000000', 'temperatura', 151.0000, 'ºC'),
	(103857, 109, '2015-03-15 01:09:27.000000', 'temperatura', 822.0000, 'ºC'),
	(103858, 109, '2015-03-15 01:09:28.000000', 'temperatura', 57.0000, 'ºC'),
	(103859, 109, '2015-03-15 01:09:29.000000', 'temperatura', 219.0000, 'ºC'),
	(103860, 109, '2015-03-15 01:09:30.000000', 'temperatura', 926.0000, 'ºC'),
	(103861, 109, '2015-03-15 01:09:31.000000', 'temperatura', 373.0000, 'ºC'),
	(103862, 109, '2015-03-15 01:09:32.000000', 'temperatura', 288.0000, 'ºC'),
	(103863, 109, '2015-03-15 01:09:33.000000', 'temperatura', 321.0000, 'ºC'),
	(103864, 109, '2015-03-15 01:09:34.000000', 'temperatura', 742.0000, 'ºC'),
	(103865, 109, '2015-03-15 01:09:35.000000', 'temperatura', 345.0000, 'ºC'),
	(103866, 109, '2015-03-15 01:09:36.000000', 'temperatura', 702.0000, 'ºC'),
	(103867, 109, '2015-03-15 01:09:37.000000', 'temperatura', 75.0000, 'ºC'),
	(103868, 109, '2015-03-15 01:09:38.000000', 'temperatura', 668.0000, 'ºC'),
	(103869, 109, '2015-03-15 01:09:39.000000', 'temperatura', 717.0000, 'ºC'),
	(103870, 109, '2015-03-15 01:09:40.000000', 'temperatura', 382.0000, 'ºC'),
	(103871, 109, '2015-03-15 01:09:41.000000', 'temperatura', 957.0000, 'ºC'),
	(103872, 109, '2015-03-15 01:09:42.000000', 'temperatura', 42.0000, 'ºC'),
	(103873, 109, '2015-03-15 01:09:43.000000', 'temperatura', 940.0000, 'ºC'),
	(103874, 109, '2015-03-15 01:09:44.000000', 'temperatura', 975.0000, 'ºC'),
	(103875, 109, '2015-03-15 01:09:45.000000', 'temperatura', 857.0000, 'ºC'),
	(103876, 109, '2015-03-15 01:09:46.000000', 'temperatura', 157.0000, 'ºC'),
	(103877, 109, '2015-03-15 01:09:47.000000', 'temperatura', 615.0000, 'ºC'),
	(103878, 109, '2015-03-15 01:09:48.000000', 'temperatura', 204.0000, 'ºC'),
	(103879, 109, '2015-03-15 01:09:49.000000', 'temperatura', 375.0000, 'ºC'),
	(103880, 109, '2015-03-15 01:09:50.000000', 'temperatura', 66.0000, 'ºC'),
	(103881, 109, '2015-03-15 01:09:51.000000', 'temperatura', 405.0000, 'ºC'),
	(103882, 109, '2015-03-15 01:09:52.000000', 'temperatura', 627.0000, 'ºC'),
	(103883, 109, '2015-03-15 01:09:53.000000', 'temperatura', 719.0000, 'ºC'),
	(103884, 109, '2015-03-15 01:09:54.000000', 'temperatura', 516.0000, 'ºC'),
	(103885, 109, '2015-03-15 01:09:55.000000', 'temperatura', 424.0000, 'ºC'),
	(103886, 109, '2015-03-15 01:09:56.000000', 'temperatura', 570.0000, 'ºC'),
	(103887, 109, '2015-03-15 01:09:57.000000', 'temperatura', 380.0000, 'ºC'),
	(103888, 109, '2015-03-15 01:09:58.000000', 'temperatura', 191.0000, 'ºC'),
	(103889, 109, '2015-03-15 01:09:59.000000', 'temperatura', 1015.0000, 'ºC'),
	(103890, 109, '2015-03-15 01:10:00.000000', 'temperatura', 903.0000, 'ºC'),
	(103891, 109, '2015-03-15 01:10:01.000000', 'temperatura', 269.0000, 'ºC'),
	(103892, 109, '2015-03-15 01:10:02.000000', 'temperatura', 1038.0000, 'ºC'),
	(103893, 109, '2015-03-15 01:10:03.000000', 'temperatura', 784.0000, 'ºC'),
	(103894, 109, '2015-03-15 01:10:04.000000', 'temperatura', 807.0000, 'ºC'),
	(103895, 109, '2015-03-15 01:10:05.000000', 'temperatura', 482.0000, 'ºC'),
	(103896, 109, '2015-03-15 01:10:06.000000', 'temperatura', 1190.0000, 'ºC'),
	(103897, 109, '2015-03-15 01:10:07.000000', 'temperatura', 906.0000, 'ºC'),
	(103898, 109, '2015-03-15 01:10:08.000000', 'temperatura', 957.0000, 'ºC'),
	(103899, 109, '2015-03-15 01:10:09.000000', 'temperatura', 871.0000, 'ºC'),
	(103900, 109, '2015-03-15 01:10:10.000000', 'temperatura', 283.0000, 'ºC'),
	(103901, 109, '2015-03-15 01:10:11.000000', 'temperatura', 1.0000, 'ºC'),
	(103902, 109, '2015-03-15 01:10:12.000000', 'temperatura', 359.0000, 'ºC'),
	(103903, 109, '2015-03-15 01:10:13.000000', 'temperatura', 591.0000, 'ºC'),
	(103904, 109, '2015-03-15 01:10:14.000000', 'temperatura', 680.0000, 'ºC'),
	(103905, 109, '2015-03-15 01:10:15.000000', 'temperatura', 429.0000, 'ºC'),
	(103906, 109, '2015-03-15 01:10:16.000000', 'temperatura', 102.0000, 'ºC'),
	(103907, 109, '2015-03-15 01:10:17.000000', 'temperatura', 425.0000, 'ºC'),
	(103908, 109, '2015-03-15 01:10:18.000000', 'temperatura', 619.0000, 'ºC'),
	(103909, 109, '2015-03-15 01:10:19.000000', 'temperatura', 623.0000, 'ºC'),
	(103910, 109, '2015-03-15 01:10:20.000000', 'temperatura', 55.0000, 'ºC'),
	(103911, 109, '2015-03-15 01:10:21.000000', 'temperatura', 810.0000, 'ºC'),
	(103912, 109, '2015-03-15 01:10:22.000000', 'temperatura', 284.0000, 'ºC'),
	(103913, 109, '2015-03-15 01:10:23.000000', 'temperatura', 189.0000, 'ºC'),
	(103914, 109, '2015-03-15 01:10:24.000000', 'temperatura', 94.0000, 'ºC'),
	(103915, 109, '2015-03-15 01:10:25.000000', 'temperatura', 1102.0000, 'ºC'),
	(103916, 109, '2015-03-15 01:10:26.000000', 'temperatura', 431.0000, 'ºC'),
	(103917, 109, '2015-03-15 01:10:27.000000', 'temperatura', 47.0000, 'ºC'),
	(103918, 109, '2015-03-15 01:10:28.000000', 'temperatura', 142.0000, 'ºC'),
	(103919, 109, '2015-03-15 01:10:29.000000', 'temperatura', 572.0000, 'ºC'),
	(103920, 109, '2015-03-15 01:10:30.000000', 'temperatura', 32.0000, 'ºC'),
	(103921, 109, '2015-03-15 01:10:31.000000', 'temperatura', 845.0000, 'ºC'),
	(103922, 109, '2015-03-15 01:10:32.000000', 'temperatura', 530.0000, 'ºC'),
	(103923, 109, '2015-03-15 01:10:33.000000', 'temperatura', 117.0000, 'ºC'),
	(103924, 109, '2015-03-15 01:10:34.000000', 'temperatura', 194.0000, 'ºC'),
	(103925, 109, '2015-03-15 01:10:35.000000', 'temperatura', 618.0000, 'ºC'),
	(103926, 109, '2015-03-15 01:10:36.000000', 'temperatura', 112.0000, 'ºC'),
	(103927, 109, '2015-03-15 01:10:37.000000', 'temperatura', 1103.0000, 'ºC'),
	(103928, 109, '2015-03-15 01:10:38.000000', 'temperatura', 381.0000, 'ºC'),
	(103929, 109, '2015-03-15 01:10:39.000000', 'temperatura', 996.0000, 'ºC'),
	(103930, 109, '2015-03-15 01:10:40.000000', 'temperatura', 238.0000, 'ºC'),
	(103931, 109, '2015-03-15 01:10:41.000000', 'temperatura', 600.0000, 'ºC'),
	(103932, 109, '2015-03-15 01:10:42.000000', 'temperatura', 1090.0000, 'ºC'),
	(103933, 109, '2015-03-15 01:10:43.000000', 'temperatura', 47.0000, 'ºC'),
	(103934, 109, '2015-03-15 01:10:44.000000', 'temperatura', 569.0000, 'ºC'),
	(103935, 109, '2015-03-15 01:10:45.000000', 'temperatura', 304.0000, 'ºC'),
	(103936, 109, '2015-03-15 01:10:46.000000', 'temperatura', 1011.0000, 'ºC'),
	(103937, 109, '2015-03-15 01:10:47.000000', 'temperatura', 546.0000, 'ºC'),
	(103938, 109, '2015-03-15 01:10:48.000000', 'temperatura', 897.0000, 'ºC'),
	(103939, 109, '2015-03-15 01:10:49.000000', 'temperatura', 446.0000, 'ºC'),
	(103940, 109, '2015-03-15 01:10:50.000000', 'temperatura', 742.0000, 'ºC'),
	(103941, 109, '2015-03-15 01:10:51.000000', 'temperatura', 1173.0000, 'ºC'),
	(103942, 109, '2015-03-15 01:10:52.000000', 'temperatura', 39.0000, 'ºC'),
	(103943, 109, '2015-03-15 01:10:53.000000', 'temperatura', 275.0000, 'ºC'),
	(103944, 109, '2015-03-15 01:10:54.000000', 'temperatura', 61.0000, 'ºC'),
	(103945, 109, '2015-03-15 01:10:55.000000', 'temperatura', 680.0000, 'ºC'),
	(103946, 109, '2015-03-15 01:10:56.000000', 'temperatura', 815.0000, 'ºC'),
	(103947, 109, '2015-03-15 01:10:57.000000', 'temperatura', 838.0000, 'ºC'),
	(103948, 109, '2015-03-15 01:10:58.000000', 'temperatura', 546.0000, 'ºC'),
	(103949, 109, '2015-03-15 01:10:59.000000', 'temperatura', 215.0000, 'ºC'),
	(103950, 109, '2015-03-15 01:11:00.000000', 'temperatura', 637.0000, 'ºC'),
	(103951, 109, '2015-03-15 01:11:01.000000', 'temperatura', 142.0000, 'ºC'),
	(103952, 109, '2015-03-15 01:11:02.000000', 'temperatura', 1.0000, 'ºC'),
	(103953, 109, '2015-03-15 01:11:03.000000', 'temperatura', 777.0000, 'ºC'),
	(103954, 109, '2015-03-15 01:11:04.000000', 'temperatura', 282.0000, 'ºC'),
	(103955, 109, '2015-03-15 01:11:05.000000', 'temperatura', 279.0000, 'ºC'),
	(103956, 109, '2015-03-15 01:11:06.000000', 'temperatura', 552.0000, 'ºC'),
	(103957, 109, '2015-03-15 01:11:07.000000', 'temperatura', 724.0000, 'ºC'),
	(103958, 109, '2015-03-15 01:11:08.000000', 'temperatura', 761.0000, 'ºC'),
	(103959, 109, '2015-03-15 01:11:09.000000', 'temperatura', 437.0000, 'ºC'),
	(103960, 109, '2015-03-15 01:11:10.000000', 'temperatura', 1100.0000, 'ºC'),
	(103961, 109, '2015-03-15 01:11:11.000000', 'temperatura', 591.0000, 'ºC'),
	(103962, 109, '2015-03-15 01:11:12.000000', 'temperatura', 854.0000, 'ºC'),
	(103963, 109, '2015-03-15 01:11:13.000000', 'temperatura', 97.0000, 'ºC'),
	(103964, 109, '2015-03-15 01:11:14.000000', 'temperatura', 324.0000, 'ºC'),
	(103965, 109, '2015-03-15 01:11:15.000000', 'temperatura', 129.0000, 'ºC'),
	(103966, 109, '2015-03-15 01:11:16.000000', 'temperatura', 875.0000, 'ºC'),
	(103967, 109, '2015-03-15 01:11:17.000000', 'temperatura', 386.0000, 'ºC'),
	(103968, 109, '2015-03-15 01:11:18.000000', 'temperatura', 506.0000, 'ºC'),
	(103969, 109, '2015-03-15 01:11:19.000000', 'temperatura', 172.0000, 'ºC'),
	(103970, 109, '2015-03-15 01:11:20.000000', 'temperatura', 542.0000, 'ºC'),
	(103971, 109, '2015-03-15 01:11:21.000000', 'temperatura', 997.0000, 'ºC'),
	(103972, 109, '2015-03-15 01:11:22.000000', 'temperatura', 960.0000, 'ºC'),
	(103973, 109, '2015-03-15 01:11:23.000000', 'temperatura', 610.0000, 'ºC'),
	(103974, 109, '2015-03-15 01:11:24.000000', 'temperatura', 169.0000, 'ºC'),
	(103975, 109, '2015-03-15 01:11:25.000000', 'temperatura', 216.0000, 'ºC'),
	(103976, 109, '2015-03-15 01:11:26.000000', 'temperatura', 573.0000, 'ºC'),
	(103977, 109, '2015-03-15 01:11:27.000000', 'temperatura', 1019.0000, 'ºC'),
	(103978, 109, '2015-03-15 01:11:28.000000', 'temperatura', 974.0000, 'ºC'),
	(103979, 109, '2015-03-15 01:11:29.000000', 'temperatura', 613.0000, 'ºC'),
	(103980, 109, '2015-03-15 01:11:30.000000', 'temperatura', 146.0000, 'ºC'),
	(103981, 109, '2015-03-15 01:11:31.000000', 'temperatura', 91.0000, 'ºC'),
	(103982, 109, '2015-03-15 01:11:32.000000', 'temperatura', 19.0000, 'ºC'),
	(103983, 109, '2015-03-15 01:11:33.000000', 'temperatura', 1022.0000, 'ºC'),
	(103984, 109, '2015-03-15 01:11:34.000000', 'temperatura', 252.0000, 'ºC'),
	(103985, 109, '2015-03-15 01:11:35.000000', 'temperatura', 597.0000, 'ºC'),
	(103986, 109, '2015-03-15 01:11:36.000000', 'temperatura', 1027.0000, 'ºC'),
	(103987, 109, '2015-03-15 01:11:37.000000', 'temperatura', 945.0000, 'ºC'),
	(103988, 109, '2015-03-15 01:11:38.000000', 'temperatura', 445.0000, 'ºC'),
	(103989, 109, '2015-03-15 01:11:39.000000', 'temperatura', 590.0000, 'ºC'),
	(103990, 109, '2015-03-15 01:11:40.000000', 'temperatura', 417.0000, 'ºC'),
	(103991, 109, '2015-03-15 01:11:41.000000', 'temperatura', 313.0000, 'ºC'),
	(103992, 109, '2015-03-15 01:11:42.000000', 'temperatura', 317.0000, 'ºC'),
	(103993, 109, '2015-03-15 01:11:43.000000', 'temperatura', 644.0000, 'ºC'),
	(103994, 109, '2015-03-15 01:11:44.000000', 'temperatura', 1071.0000, 'ºC'),
	(103995, 109, '2015-03-15 01:11:45.000000', 'temperatura', 1024.0000, 'ºC'),
	(103996, 109, '2015-03-15 01:11:46.000000', 'temperatura', 707.0000, 'ºC'),
	(103997, 109, '2015-03-15 01:11:47.000000', 'temperatura', 463.0000, 'ºC'),
	(103998, 109, '2015-03-15 01:11:48.000000', 'temperatura', 194.0000, 'ºC'),
	(103999, 109, '2015-03-15 01:11:49.000000', 'temperatura', 782.0000, 'ºC'),
	(104000, 109, '2015-03-15 01:11:50.000000', 'temperatura', 928.0000, 'ºC'),
	(104001, 109, '2015-03-15 01:11:51.000000', 'temperatura', 1095.0000, 'ºC'),
	(104002, 109, '2015-03-15 01:11:52.000000', 'temperatura', 290.0000, 'ºC'),
	(104003, 109, '2015-03-15 01:11:53.000000', 'temperatura', 565.0000, 'ºC'),
	(104004, 109, '2015-03-15 01:11:54.000000', 'temperatura', 756.0000, 'ºC'),
	(104005, 109, '2015-03-15 01:11:55.000000', 'temperatura', 887.0000, 'ºC'),
	(104006, 109, '2015-03-15 01:11:56.000000', 'temperatura', 966.0000, 'ºC'),
	(104007, 109, '2015-03-15 01:11:57.000000', 'temperatura', 971.0000, 'ºC'),
	(104008, 109, '2015-03-15 01:11:58.000000', 'temperatura', 758.0000, 'ºC'),
	(104009, 109, '2015-03-15 01:11:59.000000', 'temperatura', 877.0000, 'ºC'),
	(104010, 109, '2015-03-15 01:12:00.000000', 'temperatura', 909.0000, 'ºC'),
	(104011, 109, '2015-03-15 01:12:01.000000', 'temperatura', 718.0000, 'ºC'),
	(104012, 109, '2015-03-15 01:12:02.000000', 'temperatura', 861.0000, 'ºC'),
	(104013, 109, '2015-03-15 01:12:03.000000', 'temperatura', 953.0000, 'ºC'),
	(104014, 109, '2015-03-15 01:12:04.000000', 'temperatura', 983.0000, 'ºC'),
	(104015, 109, '2015-03-15 01:12:05.000000', 'temperatura', 856.0000, 'ºC'),
	(104016, 109, '2015-03-15 01:12:06.000000', 'temperatura', 130.0000, 'ºC'),
	(104017, 109, '2015-03-15 01:12:07.000000', 'temperatura', 485.0000, 'ºC'),
	(104018, 109, '2015-03-15 01:12:08.000000', 'temperatura', 834.0000, 'ºC'),
	(104019, 109, '2015-03-15 01:12:09.000000', 'temperatura', 317.0000, 'ºC'),
	(104020, 109, '2015-03-15 01:12:10.000000', 'temperatura', 281.0000, 'ºC'),
	(104021, 109, '2015-03-15 01:12:11.000000', 'temperatura', 454.0000, 'ºC'),
	(104022, 109, '2015-03-15 01:12:12.000000', 'temperatura', 230.0000, 'ºC'),
	(104023, 109, '2015-03-15 01:12:13.000000', 'temperatura', 987.0000, 'ºC'),
	(104024, 109, '2015-03-15 01:12:14.000000', 'temperatura', 644.0000, 'ºC'),
	(104025, 109, '2015-03-15 01:12:15.000000', 'temperatura', 262.0000, 'ºC'),
	(104026, 109, '2015-03-15 01:12:16.000000', 'temperatura', 579.0000, 'ºC'),
	(104027, 109, '2015-03-15 01:12:17.000000', 'temperatura', 909.0000, 'ºC'),
	(104028, 109, '2015-03-15 01:12:18.000000', 'temperatura', 408.0000, 'ºC'),
	(104029, 109, '2015-03-15 01:12:19.000000', 'temperatura', 513.0000, 'ºC'),
	(104030, 109, '2015-03-15 01:12:20.000000', 'temperatura', 142.0000, 'ºC'),
	(104031, 109, '2015-03-15 01:12:21.000000', 'temperatura', 372.0000, 'ºC'),
	(104032, 109, '2015-03-15 01:12:22.000000', 'temperatura', 232.0000, 'ºC'),
	(104033, 109, '2015-03-15 01:12:23.000000', 'temperatura', 47.0000, 'ºC'),
	(104034, 109, '2015-03-15 01:12:24.000000', 'temperatura', 737.0000, 'ºC'),
	(104035, 109, '2015-03-15 01:12:25.000000', 'temperatura', 1147.0000, 'ºC'),
	(104036, 109, '2015-03-15 01:12:26.000000', 'temperatura', 1125.0000, 'ºC'),
	(104037, 109, '2015-03-15 01:12:27.000000', 'temperatura', 983.0000, 'ºC'),
	(104038, 109, '2015-03-15 01:12:28.000000', 'temperatura', 341.0000, 'ºC'),
	(104039, 109, '2015-03-15 01:12:29.000000', 'temperatura', 1157.0000, 'ºC'),
	(104040, 109, '2015-03-15 01:12:30.000000', 'temperatura', 1162.0000, 'ºC'),
	(104041, 109, '2015-03-15 01:12:31.000000', 'temperatura', 1141.0000, 'ºC'),
	(104042, 109, '2015-03-15 01:12:32.000000', 'temperatura', 1019.0000, 'ºC'),
	(104043, 109, '2015-03-15 01:12:33.000000', 'temperatura', 472.0000, 'ºC'),
	(104044, 109, '2015-03-15 01:12:34.000000', 'temperatura', 503.0000, 'ºC'),
	(104045, 109, '2015-03-15 01:12:35.000000', 'temperatura', 1101.0000, 'ºC'),
	(104046, 109, '2015-03-15 01:12:36.000000', 'temperatura', 395.0000, 'ºC'),
	(104047, 109, '2015-03-15 01:12:37.000000', 'temperatura', 1075.0000, 'ºC'),
	(104048, 109, '2015-03-15 01:12:38.000000', 'temperatura', 589.0000, 'ºC'),
	(104049, 109, '2015-03-15 01:12:39.000000', 'temperatura', 920.0000, 'ºC'),
	(104050, 109, '2015-03-15 01:12:40.000000', 'temperatura', 433.0000, 'ºC'),
	(104051, 109, '2015-03-15 01:12:41.000000', 'temperatura', 606.0000, 'ºC'),
	(104052, 109, '2015-03-15 01:12:42.000000', 'temperatura', 530.0000, 'ºC'),
	(104053, 109, '2015-03-15 01:12:43.000000', 'temperatura', 833.0000, 'ºC'),
	(104054, 109, '2015-03-15 01:12:44.000000', 'temperatura', 174.0000, 'ºC'),
	(104055, 109, '2015-03-15 01:12:45.000000', 'temperatura', 775.0000, 'ºC'),
	(104056, 109, '2015-03-15 01:12:46.000000', 'temperatura', 951.0000, 'ºC'),
	(104057, 109, '2015-03-15 01:12:47.000000', 'temperatura', 32.0000, 'ºC'),
	(104058, 109, '2015-03-15 01:12:48.000000', 'temperatura', 906.0000, 'ºC'),
	(104059, 109, '2015-03-15 01:12:49.000000', 'temperatura', 834.0000, 'ºC'),
	(104060, 109, '2015-03-15 01:12:50.000000', 'temperatura', 255.0000, 'ºC'),
	(104061, 109, '2015-03-15 01:12:51.000000', 'temperatura', 1173.0000, 'ºC'),
	(104062, 109, '2015-03-15 01:12:52.000000', 'temperatura', 301.0000, 'ºC'),
	(104063, 109, '2015-03-15 01:12:53.000000', 'temperatura', 384.0000, 'ºC'),
	(104064, 109, '2015-03-15 01:12:54.000000', 'temperatura', 1020.0000, 'ºC'),
	(104065, 109, '2015-03-15 01:12:55.000000', 'temperatura', 348.0000, 'ºC'),
	(104066, 109, '2015-03-15 01:12:56.000000', 'temperatura', 1080.0000, 'ºC'),
	(104067, 109, '2015-03-15 01:12:57.000000', 'temperatura', 756.0000, 'ºC'),
	(104068, 109, '2015-03-15 01:12:58.000000', 'temperatura', 540.0000, 'ºC'),
	(104069, 109, '2015-03-15 01:12:59.000000', 'temperatura', 432.0000, 'ºC'),
	(104070, 109, '2015-03-15 01:13:00.000000', 'temperatura', 541.0000, 'ºC'),
	(104071, 109, '2015-03-15 01:13:01.000000', 'temperatura', 208.0000, 'ºC'),
	(104072, 109, '2015-03-15 01:13:02.000000', 'temperatura', 617.0000, 'ºC'),
	(104073, 109, '2015-03-15 01:13:03.000000', 'temperatura', 64.0000, 'ºC'),
	(104074, 109, '2015-03-15 01:13:04.000000', 'temperatura', 870.0000, 'ºC'),
	(104075, 109, '2015-03-15 01:13:05.000000', 'temperatura', 559.0000, 'ºC'),
	(104076, 109, '2015-03-15 01:13:06.000000', 'temperatura', 186.0000, 'ºC'),
	(104077, 109, '2015-03-15 01:13:07.000000', 'temperatura', 451.0000, 'ºC'),
	(104078, 109, '2015-03-15 01:13:08.000000', 'temperatura', 497.0000, 'ºC'),
	(104079, 109, '2015-03-15 01:13:09.000000', 'temperatura', 1134.0000, 'ºC'),
	(104080, 109, '2015-03-15 01:13:10.000000', 'temperatura', 577.0000, 'ºC'),
	(104081, 109, '2015-03-15 01:13:11.000000', 'temperatura', 686.0000, 'ºC'),
	(104082, 109, '2015-03-15 01:13:12.000000', 'temperatura', 499.0000, 'ºC'),
	(104083, 109, '2015-03-15 01:13:13.000000', 'temperatura', 438.0000, 'ºC'),
	(104084, 109, '2015-03-15 01:13:14.000000', 'temperatura', 695.0000, 'ºC'),
	(104085, 109, '2015-03-15 01:13:15.000000', 'temperatura', 960.0000, 'ºC'),
	(104086, 109, '2015-03-15 01:13:16.000000', 'temperatura', 314.0000, 'ºC'),
	(104087, 109, '2015-03-15 01:13:17.000000', 'temperatura', 1091.0000, 'ºC'),
	(104088, 109, '2015-03-15 01:13:18.000000', 'temperatura', 916.0000, 'ºC'),
	(104089, 109, '2015-03-15 01:13:19.000000', 'temperatura', 105.0000, 'ºC'),
	(104090, 109, '2015-03-15 01:13:20.000000', 'temperatura', 177.0000, 'ºC'),
	(104091, 109, '2015-03-15 01:13:21.000000', 'temperatura', 572.0000, 'ºC'),
	(104092, 109, '2015-03-15 01:13:22.000000', 'temperatura', 1128.0000, 'ºC'),
	(104093, 109, '2015-03-15 01:13:23.000000', 'temperatura', 327.0000, 'ºC'),
	(104094, 109, '2015-03-15 01:13:24.000000', 'temperatura', 649.0000, 'ºC'),
	(104095, 109, '2015-03-15 01:13:25.000000', 'temperatura', 1065.0000, 'ºC'),
	(104096, 109, '2015-03-15 01:13:26.000000', 'temperatura', 977.0000, 'ºC'),
	(104097, 109, '2015-03-15 01:13:27.000000', 'temperatura', 492.0000, 'ºC'),
	(104098, 109, '2015-03-15 01:13:28.000000', 'temperatura', 731.0000, 'ºC'),
	(104099, 109, '2015-03-15 01:13:29.000000', 'temperatura', 980.0000, 'ºC'),
	(104100, 109, '2015-03-15 01:13:30.000000', 'temperatura', 307.0000, 'ºC'),
	(104101, 109, '2015-03-15 01:13:31.000000', 'temperatura', 996.0000, 'ºC'),
	(104102, 109, '2015-03-15 01:13:32.000000', 'temperatura', 460.0000, 'ºC'),
	(104103, 109, '2015-03-15 01:13:33.000000', 'temperatura', 510.0000, 'ºC'),
	(104104, 109, '2015-03-15 01:13:34.000000', 'temperatura', 1173.0000, 'ºC'),
	(104105, 109, '2015-03-15 01:13:35.000000', 'temperatura', 734.0000, 'ºC'),
	(104106, 109, '2015-03-15 01:13:36.000000', 'temperatura', 152.0000, 'ºC'),
	(104107, 109, '2015-03-15 01:13:37.000000', 'temperatura', 959.0000, 'ºC'),
	(104108, 109, '2015-03-15 01:13:38.000000', 'temperatura', 737.0000, 'ºC'),
	(104109, 109, '2015-03-15 01:13:39.000000', 'temperatura', 810.0000, 'ºC'),
	(104110, 109, '2015-03-15 01:13:40.000000', 'temperatura', 641.0000, 'ºC'),
	(104111, 109, '2015-03-15 01:13:41.000000', 'temperatura', 776.0000, 'ºC'),
	(104112, 109, '2015-03-15 01:13:42.000000', 'temperatura', 758.0000, 'ºC'),
	(104113, 109, '2015-03-15 01:13:43.000000', 'temperatura', 261.0000, 'ºC'),
	(104114, 109, '2015-03-15 01:13:44.000000', 'temperatura', 233.0000, 'ºC'),
	(104115, 109, '2015-03-15 01:13:45.000000', 'temperatura', 381.0000, 'ºC'),
	(104116, 109, '2015-03-15 01:13:46.000000', 'temperatura', 9.0000, 'ºC'),
	(104117, 109, '2015-03-15 01:13:47.000000', 'temperatura', 101.0000, 'ºC'),
	(104118, 109, '2015-03-15 01:13:48.000000', 'temperatura', 477.0000, 'ºC'),
	(104119, 109, '2015-03-15 01:13:49.000000', 'temperatura', 882.0000, 'ºC'),
	(104120, 109, '2015-03-15 01:13:50.000000', 'temperatura', 581.0000, 'ºC'),
	(104121, 109, '2015-03-15 01:13:51.000000', 'temperatura', 258.0000, 'ºC'),
	(104122, 109, '2015-03-15 01:13:52.000000', 'temperatura', 749.0000, 'ºC'),
	(104123, 109, '2015-03-15 01:13:53.000000', 'temperatura', 571.0000, 'ºC'),
	(104124, 109, '2015-03-15 01:13:54.000000', 'temperatura', 610.0000, 'ºC'),
	(104125, 109, '2015-03-15 01:13:55.000000', 'temperatura', 135.0000, 'ºC'),
	(104126, 109, '2015-03-15 01:13:56.000000', 'temperatura', 44.0000, 'ºC'),
	(104127, 109, '2015-03-15 01:13:57.000000', 'temperatura', 1019.0000, 'ºC'),
	(104128, 109, '2015-03-15 01:13:58.000000', 'temperatura', 164.0000, 'ºC'),
	(104129, 109, '2015-03-15 01:13:59.000000', 'temperatura', 162.0000, 'ºC'),
	(104130, 109, '2015-03-15 01:14:00.000000', 'temperatura', 320.0000, 'ºC'),
	(104131, 109, '2015-03-15 01:14:01.000000', 'temperatura', 1114.0000, 'ºC'),
	(104132, 109, '2015-03-15 01:14:02.000000', 'temperatura', 1010.0000, 'ºC'),
	(104133, 109, '2015-03-15 01:14:03.000000', 'temperatura', 507.0000, 'ºC'),
	(104134, 109, '2015-03-15 01:14:04.000000', 'temperatura', 705.0000, 'ºC'),
	(104135, 109, '2015-03-15 01:14:05.000000', 'temperatura', 804.0000, 'ºC'),
	(104136, 109, '2015-03-15 01:14:06.000000', 'temperatura', 706.0000, 'ºC'),
	(104137, 109, '2015-03-15 01:14:07.000000', 'temperatura', 1119.0000, 'ºC'),
	(104138, 109, '2015-03-15 01:14:08.000000', 'temperatura', 1075.0000, 'ºC'),
	(104139, 109, '2015-03-15 01:14:09.000000', 'temperatura', 822.0000, 'ºC'),
	(104140, 109, '2015-03-15 01:14:10.000000', 'temperatura', 884.0000, 'ºC'),
	(104141, 109, '2015-03-15 01:14:11.000000', 'temperatura', 754.0000, 'ºC'),
	(104142, 109, '2015-03-15 01:14:12.000000', 'temperatura', 1117.0000, 'ºC'),
	(104143, 109, '2015-03-15 01:14:13.000000', 'temperatura', 926.0000, 'ºC'),
	(104144, 109, '2015-03-15 01:14:14.000000', 'temperatura', 79.0000, 'ºC'),
	(104145, 109, '2015-03-15 01:14:15.000000', 'temperatura', 16.0000, 'ºC'),
	(104146, 109, '2015-03-15 01:14:16.000000', 'temperatura', 1045.0000, 'ºC'),
	(104147, 109, '2015-03-15 01:14:17.000000', 'temperatura', 378.0000, 'ºC'),
	(104148, 109, '2015-03-15 01:14:18.000000', 'temperatura', 1153.0000, 'ºC'),
	(104149, 109, '2015-03-15 01:14:19.000000', 'temperatura', 1034.0000, 'ºC'),
	(104150, 109, '2015-03-15 01:14:20.000000', 'temperatura', 513.0000, 'ºC'),
	(104151, 109, '2015-03-15 01:14:21.000000', 'temperatura', 660.0000, 'ºC'),
	(104152, 109, '2015-03-15 01:14:22.000000', 'temperatura', 564.0000, 'ºC'),
	(104153, 109, '2015-03-15 01:14:23.000000', 'temperatura', 838.0000, 'ºC'),
	(104154, 109, '2015-03-15 01:14:24.000000', 'temperatura', 100.0000, 'ºC'),
	(104155, 109, '2015-03-15 01:14:25.000000', 'temperatura', 385.0000, 'ºC'),
	(104156, 109, '2015-03-15 01:14:26.000000', 'temperatura', 428.0000, 'ºC'),
	(104157, 109, '2015-03-15 01:14:27.000000', 'temperatura', 984.0000, 'ºC'),
	(104158, 109, '2015-03-15 01:14:28.000000', 'temperatura', 35.0000, 'ºC'),
	(104159, 109, '2015-03-15 01:14:29.000000', 'temperatura', 825.0000, 'ºC'),
	(104160, 109, '2015-03-15 01:14:30.000000', 'temperatura', 422.0000, 'ºC'),
	(104161, 109, '2015-03-15 01:14:31.000000', 'temperatura', 832.0000, 'ºC'),
	(104162, 109, '2015-03-15 01:14:32.000000', 'temperatura', 498.0000, 'ºC'),
	(104163, 109, '2015-03-15 01:14:33.000000', 'temperatura', 1193.0000, 'ºC'),
	(104164, 109, '2015-03-15 01:14:34.000000', 'temperatura', 871.0000, 'ºC'),
	(104165, 109, '2015-03-15 01:14:35.000000', 'temperatura', 777.0000, 'ºC'),
	(104166, 109, '2015-03-15 01:14:36.000000', 'temperatura', 72.0000, 'ºC'),
	(104167, 109, '2015-03-15 01:14:37.000000', 'temperatura', 431.0000, 'ºC'),
	(104168, 109, '2015-03-15 01:14:38.000000', 'temperatura', 740.0000, 'ºC'),
	(104169, 109, '2015-03-15 01:14:39.000000', 'temperatura', 6.0000, 'ºC'),
	(104170, 109, '2015-03-15 01:14:40.000000', 'temperatura', 212.0000, 'ºC'),
	(104171, 109, '2015-03-15 01:14:41.000000', 'temperatura', 1040.0000, 'ºC'),
	(104172, 109, '2015-03-15 01:14:42.000000', 'temperatura', 966.0000, 'ºC'),
	(104173, 109, '2015-03-15 01:14:43.000000', 'temperatura', 512.0000, 'ºC'),
	(104174, 109, '2015-03-15 01:14:44.000000', 'temperatura', 862.0000, 'ºC'),
	(104175, 109, '2015-03-15 01:14:45.000000', 'temperatura', 372.0000, 'ºC'),
	(104176, 109, '2015-03-15 01:14:46.000000', 'temperatura', 477.0000, 'ºC'),
	(104177, 109, '2015-03-15 01:14:47.000000', 'temperatura', 69.0000, 'ºC'),
	(104178, 109, '2015-03-15 01:14:48.000000', 'temperatura', 115.0000, 'ºC'),
	(104179, 109, '2015-03-15 01:14:49.000000', 'temperatura', 367.0000, 'ºC'),
	(104180, 109, '2015-03-15 01:14:50.000000', 'temperatura', 292.0000, 'ºC'),
	(104181, 109, '2015-03-15 01:14:51.000000', 'temperatura', 361.0000, 'ºC'),
	(104182, 109, '2015-03-15 01:14:52.000000', 'temperatura', 927.0000, 'ºC'),
	(104183, 109, '2015-03-15 01:14:53.000000', 'temperatura', 1153.0000, 'ºC'),
	(104184, 109, '2015-03-15 01:14:54.000000', 'temperatura', 586.0000, 'ºC'),
	(104185, 109, '2015-03-15 01:14:55.000000', 'temperatura', 671.0000, 'ºC'),
	(104186, 109, '2015-03-15 01:14:56.000000', 'temperatura', 397.0000, 'ºC'),
	(104187, 109, '2015-03-15 01:14:57.000000', 'temperatura', 1175.0000, 'ºC'),
	(104188, 109, '2015-03-15 01:14:58.000000', 'temperatura', 1082.0000, 'ºC'),
	(104189, 109, '2015-03-15 01:14:59.000000', 'temperatura', 686.0000, 'ºC'),
	(104190, 109, '2015-03-15 01:15:00.000000', 'temperatura', 184.0000, 'ºC'),
	(104191, 109, '2015-03-15 01:15:01.000000', 'temperatura', 64.0000, 'ºC'),
	(104192, 109, '2015-03-15 01:15:02.000000', 'temperatura', 969.0000, 'ºC'),
	(104193, 109, '2015-03-15 01:15:03.000000', 'temperatura', 1052.0000, 'ºC'),
	(104194, 109, '2015-03-15 01:15:04.000000', 'temperatura', 1152.0000, 'ºC'),
	(104195, 109, '2015-03-15 01:15:05.000000', 'temperatura', 207.0000, 'ºC'),
	(104196, 109, '2015-03-15 01:15:06.000000', 'temperatura', 1179.0000, 'ºC'),
	(104197, 109, '2015-03-15 01:15:07.000000', 'temperatura', 475.0000, 'ºC'),
	(104198, 109, '2015-03-15 01:15:08.000000', 'temperatura', 38.0000, 'ºC'),
	(104199, 109, '2015-03-15 01:15:09.000000', 'temperatura', 1164.0000, 'ºC'),
	(104200, 109, '2015-03-15 01:15:10.000000', 'temperatura', 908.0000, 'ºC'),
	(104201, 109, '2015-03-15 01:15:11.000000', 'temperatura', 1049.0000, 'ºC'),
	(104202, 109, '2015-03-15 01:15:12.000000', 'temperatura', 120.0000, 'ºC'),
	(104203, 109, '2015-03-15 01:15:13.000000', 'temperatura', 1055.0000, 'ºC'),
	(104204, 109, '2015-03-15 01:15:14.000000', 'temperatura', 115.0000, 'ºC'),
	(104205, 109, '2015-03-15 01:15:15.000000', 'temperatura', 1010.0000, 'ºC'),
	(104206, 109, '2015-03-15 01:15:16.000000', 'temperatura', 1107.0000, 'ºC'),
	(104207, 109, '2015-03-15 01:15:17.000000', 'temperatura', 104.0000, 'ºC'),
	(104208, 109, '2015-03-15 01:15:18.000000', 'temperatura', 798.0000, 'ºC'),
	(104209, 109, '2015-03-15 01:15:19.000000', 'temperatura', 80.0000, 'ºC'),
	(104210, 109, '2015-03-15 01:15:20.000000', 'temperatura', 404.0000, 'ºC'),
	(104211, 109, '2015-03-15 01:15:21.000000', 'temperatura', 583.0000, 'ºC'),
	(104212, 109, '2015-03-15 01:15:22.000000', 'temperatura', 504.0000, 'ºC'),
	(104213, 109, '2015-03-15 01:15:23.000000', 'temperatura', 772.0000, 'ºC'),
	(104214, 109, '2015-03-15 01:15:24.000000', 'temperatura', 1150.0000, 'ºC'),
	(104215, 109, '2015-03-15 01:15:25.000000', 'temperatura', 1031.0000, 'ºC'),
	(104216, 109, '2015-03-15 01:15:26.000000', 'temperatura', 506.0000, 'ºC'),
	(104217, 109, '2015-03-15 01:15:27.000000', 'temperatura', 640.0000, 'ºC'),
	(104218, 109, '2015-03-15 01:15:28.000000', 'temperatura', 482.0000, 'ºC'),
	(104219, 109, '2015-03-15 01:15:29.000000', 'temperatura', 489.0000, 'ºC'),
	(104220, 109, '2015-03-15 01:15:30.000000', 'temperatura', 999.0000, 'ºC'),
	(104221, 109, '2015-03-15 01:15:31.000000', 'temperatura', 1131.0000, 'ºC'),
	(104222, 109, '2015-03-15 01:15:32.000000', 'temperatura', 258.0000, 'ºC'),
	(104223, 109, '2015-03-15 01:15:33.000000', 'temperatura', 296.0000, 'ºC'),
	(104224, 109, '2015-03-15 01:15:34.000000', 'temperatura', 708.0000, 'ºC'),
	(104225, 109, '2015-03-15 01:15:35.000000', 'temperatura', 251.0000, 'ºC'),
	(104226, 109, '2015-03-15 01:15:36.000000', 'temperatura', 331.0000, 'ºC'),
	(104227, 109, '2015-03-15 01:15:37.000000', 'temperatura', 903.0000, 'ºC'),
	(104228, 109, '2015-03-15 01:15:38.000000', 'temperatura', 1122.0000, 'ºC'),
	(104229, 109, '2015-03-15 01:15:39.000000', 'temperatura', 504.0000, 'ºC'),
	(104230, 109, '2015-03-15 01:15:40.000000', 'temperatura', 353.0000, 'ºC'),
	(104231, 109, '2015-03-15 01:15:41.000000', 'temperatura', 253.0000, 'ºC'),
	(104232, 109, '2015-03-15 01:15:42.000000', 'temperatura', 207.0000, 'ºC'),
	(104233, 109, '2015-03-15 01:15:43.000000', 'temperatura', 277.0000, 'ºC'),
	(104234, 109, '2015-03-15 01:15:44.000000', 'temperatura', 763.0000, 'ºC'),
	(104235, 109, '2015-03-15 01:15:45.000000', 'temperatura', 584.0000, 'ºC'),
	(104236, 109, '2015-03-15 01:15:46.000000', 'temperatura', 632.0000, 'ºC'),
	(104237, 109, '2015-03-15 01:15:47.000000', 'temperatura', 209.0000, 'ºC'),
	(104238, 109, '2015-03-15 01:15:48.000000', 'temperatura', 349.0000, 'ºC'),
	(104239, 109, '2015-03-15 01:15:49.000000', 'temperatura', 1120.0000, 'ºC'),
	(104240, 109, '2015-03-15 01:15:50.000000', 'temperatura', 955.0000, 'ºC'),
	(104241, 109, '2015-03-15 01:15:51.000000', 'temperatura', 212.0000, 'ºC'),
	(104242, 109, '2015-03-15 01:15:52.000000', 'temperatura', 598.0000, 'ºC'),
	(104243, 109, '2015-03-15 01:15:53.000000', 'temperatura', 1152.0000, 'ºC'),
	(104244, 109, '2015-03-15 01:15:54.000000', 'temperatura', 367.0000, 'ºC'),
	(104245, 109, '2015-03-15 01:15:55.000000', 'temperatura', 781.0000, 'ºC'),
	(104246, 109, '2015-03-15 01:15:56.000000', 'temperatura', 405.0000, 'ºC'),
	(104247, 109, '2015-03-15 01:15:57.000000', 'temperatura', 882.0000, 'ºC'),
	(104248, 109, '2015-03-15 01:15:58.000000', 'temperatura', 795.0000, 'ºC'),
	(104249, 109, '2015-03-15 01:15:59.000000', 'temperatura', 131.0000, 'ºC'),
	(104250, 109, '2015-03-15 01:16:00.000000', 'temperatura', 670.0000, 'ºC'),
	(104251, 109, '2015-03-15 01:16:01.000000', 'temperatura', 555.0000, 'ºC'),
	(104252, 109, '2015-03-15 01:16:02.000000', 'temperatura', 768.0000, 'ºC'),
	(104253, 109, '2015-03-15 01:16:03.000000', 'temperatura', 973.0000, 'ºC'),
	(104254, 109, '2015-03-15 01:16:04.000000', 'temperatura', 163.0000, 'ºC'),
	(104255, 109, '2015-03-15 01:16:05.000000', 'temperatura', 298.0000, 'ºC'),
	(104256, 109, '2015-03-15 01:16:06.000000', 'temperatura', 999.0000, 'ºC'),
	(104257, 109, '2015-03-15 01:16:07.000000', 'temperatura', 502.0000, 'ºC'),
	(104258, 109, '2015-03-15 01:16:08.000000', 'temperatura', 712.0000, 'ºC'),
	(104259, 109, '2015-03-15 01:16:09.000000', 'temperatura', 856.0000, 'ºC'),
	(104260, 109, '2015-03-15 01:16:10.000000', 'temperatura', 945.0000, 'ºC'),
	(104261, 109, '2015-03-15 01:16:11.000000', 'temperatura', 957.0000, 'ºC'),
	(104262, 109, '2015-03-15 01:16:12.000000', 'temperatura', 749.0000, 'ºC'),
	(104263, 109, '2015-03-15 01:16:13.000000', 'temperatura', 876.0000, 'ºC'),
	(104264, 109, '2015-03-15 01:16:14.000000', 'temperatura', 935.0000, 'ºC'),
	(104265, 109, '2015-03-15 01:16:15.000000', 'temperatura', 847.0000, 'ºC'),
	(104266, 109, '2015-03-15 01:16:16.000000', 'temperatura', 228.0000, 'ºC'),
	(104267, 109, '2015-03-15 01:16:17.000000', 'temperatura', 1001.0000, 'ºC'),
	(104268, 109, '2015-03-15 01:16:18.000000', 'temperatura', 722.0000, 'ºC'),
	(104269, 109, '2015-03-15 01:16:19.000000', 'temperatura', 608.0000, 'ºC'),
	(104270, 109, '2015-03-15 01:16:20.000000', 'temperatura', 872.0000, 'ºC'),
	(104271, 109, '2015-03-15 01:16:21.000000', 'temperatura', 140.0000, 'ºC'),
	(104272, 109, '2015-03-15 01:16:22.000000', 'temperatura', 481.0000, 'ºC'),
	(104273, 109, '2015-03-15 01:16:23.000000', 'temperatura', 789.0000, 'ºC'),
	(104274, 109, '2015-03-15 01:16:24.000000', 'temperatura', 99.0000, 'ºC'),
	(104275, 109, '2015-03-15 01:16:25.000000', 'temperatura', 532.0000, 'ºC'),
	(104276, 109, '2015-03-15 01:16:26.000000', 'temperatura', 1161.0000, 'ºC'),
	(104277, 109, '2015-03-15 01:16:27.000000', 'temperatura', 610.0000, 'ºC'),
	(104278, 109, '2015-03-15 01:16:28.000000', 'temperatura', 766.0000, 'ºC'),
	(104279, 109, '2015-03-15 01:16:29.000000', 'temperatura', 801.0000, 'ºC'),
	(104280, 109, '2015-03-15 01:16:30.000000', 'temperatura', 509.0000, 'ºC'),
	(104281, 109, '2015-03-15 01:16:31.000000', 'temperatura', 140.0000, 'ºC'),
	(104282, 109, '2015-03-15 01:16:32.000000', 'temperatura', 374.0000, 'ºC'),
	(104283, 109, '2015-03-15 01:16:33.000000', 'temperatura', 253.0000, 'ºC'),
	(104284, 109, '2015-03-15 01:16:34.000000', 'temperatura', 141.0000, 'ºC'),
	(104285, 109, '2015-03-15 01:16:35.000000', 'temperatura', 1148.0000, 'ºC'),
	(104286, 109, '2015-03-15 01:16:36.000000', 'temperatura', 519.0000, 'ºC'),
	(104287, 109, '2015-03-15 01:16:37.000000', 'temperatura', 348.0000, 'ºC'),
	(104288, 109, '2015-03-15 01:16:38.000000', 'temperatura', 187.0000, 'ºC'),
	(104289, 109, '2015-03-15 01:16:39.000000', 'temperatura', 1090.0000, 'ºC'),
	(104290, 109, '2015-03-15 01:16:40.000000', 'temperatura', 88.0000, 'ºC'),
	(104291, 109, '2015-03-15 01:16:41.000000', 'temperatura', 772.0000, 'ºC'),
	(104292, 109, '2015-03-15 01:16:42.000000', 'temperatura', 1196.0000, 'ºC'),
	(104293, 109, '2015-03-15 01:16:43.000000', 'temperatura', 66.0000, 'ºC'),
	(104294, 109, '2015-03-15 01:16:44.000000', 'temperatura', 343.0000, 'ºC'),
	(104295, 109, '2015-03-15 01:16:45.000000', 'temperatura', 315.0000, 'ºC'),
	(104296, 109, '2015-03-15 01:16:46.000000', 'temperatura', 546.0000, 'ºC'),
	(104297, 109, '2015-03-15 01:16:47.000000', 'temperatura', 587.0000, 'ºC'),
	(104298, 109, '2015-03-15 01:16:48.000000', 'temperatura', 98.0000, 'ºC'),
	(104299, 109, '2015-03-15 01:16:49.000000', 'temperatura', 1130.0000, 'ºC'),
	(104300, 109, '2015-03-15 01:16:50.000000', 'temperatura', 556.0000, 'ºC'),
	(104301, 109, '2015-03-15 01:16:51.000000', 'temperatura', 591.0000, 'ºC'),
	(104302, 109, '2015-03-15 01:16:52.000000', 'temperatura', 88.0000, 'ºC'),
	(104303, 109, '2015-03-15 01:16:53.000000', 'temperatura', 1068.0000, 'ºC'),
	(104304, 109, '2015-03-15 01:16:54.000000', 'temperatura', 275.0000, 'ºC'),
	(104305, 109, '2015-03-15 01:16:55.000000', 'temperatura', 571.0000, 'ºC'),
	(104306, 109, '2015-03-15 01:16:56.000000', 'temperatura', 831.0000, 'ºC'),
	(104307, 109, '2015-03-15 01:16:57.000000', 'temperatura', 44.0000, 'ºC'),
	(104308, 109, '2015-03-15 01:16:58.000000', 'temperatura', 125.0000, 'ºC'),
	(104309, 109, '2015-03-15 01:16:59.000000', 'temperatura', 493.0000, 'ºC'),
	(104310, 109, '2015-03-15 01:17:00.000000', 'temperatura', 891.0000, 'ºC'),
	(104311, 109, '2015-03-15 01:17:01.000000', 'temperatura', 575.0000, 'ºC'),
	(104312, 109, '2015-03-15 01:17:02.000000', 'temperatura', 206.0000, 'ºC'),
	(104313, 109, '2015-03-15 01:17:03.000000', 'temperatura', 503.0000, 'ºC'),
	(104314, 109, '2015-03-15 01:17:04.000000', 'temperatura', 698.0000, 'ºC'),
	(104315, 109, '2015-03-15 01:17:05.000000', 'temperatura', 782.0000, 'ºC'),
	(104316, 109, '2015-03-15 01:17:06.000000', 'temperatura', 615.0000, 'ºC'),
	(104317, 109, '2015-03-15 01:17:07.000000', 'temperatura', 729.0000, 'ºC'),
	(104318, 109, '2015-03-15 01:17:08.000000', 'temperatura', 604.0000, 'ºC'),
	(104319, 109, '2015-03-15 01:17:09.000000', 'temperatura', 830.0000, 'ºC'),
	(104320, 109, '2015-03-15 01:17:10.000000', 'temperatura', 1139.0000, 'ºC'),
	(104321, 109, '2015-03-15 01:17:11.000000', 'temperatura', 805.0000, 'ºC'),
	(104322, 109, '2015-03-15 01:17:12.000000', 'temperatura', 609.0000, 'ºC'),
	(104323, 109, '2015-03-15 01:17:13.000000', 'temperatura', 632.0000, 'ºC'),
	(104324, 109, '2015-03-15 01:17:14.000000', 'temperatura', 131.0000, 'ºC'),
	(104325, 109, '2015-03-15 01:17:15.000000', 'temperatura', 1161.0000, 'ºC'),
	(104326, 109, '2015-03-15 01:17:16.000000', 'temperatura', 614.0000, 'ºC'),
	(104327, 109, '2015-03-15 01:17:17.000000', 'temperatura', 784.0000, 'ºC'),
	(104328, 109, '2015-03-15 01:17:18.000000', 'temperatura', 881.0000, 'ºC'),
	(104329, 109, '2015-03-15 01:17:19.000000', 'temperatura', 854.0000, 'ºC'),
	(104330, 109, '2015-03-15 01:17:20.000000', 'temperatura', 429.0000, 'ºC'),
	(104331, 109, '2015-03-15 01:17:21.000000', 'temperatura', 781.0000, 'ºC'),
	(104332, 109, '2015-03-15 01:17:22.000000', 'temperatura', 219.0000, 'ºC'),
	(104333, 109, '2015-03-15 01:17:23.000000', 'temperatura', 1153.0000, 'ºC'),
	(104334, 109, '2015-03-15 01:17:24.000000', 'temperatura', 309.0000, 'ºC'),
	(104335, 109, '2015-03-15 01:17:25.000000', 'temperatura', 487.0000, 'ºC'),
	(104336, 109, '2015-03-15 01:17:26.000000', 'temperatura', 309.0000, 'ºC'),
	(104337, 109, '2015-03-15 01:17:27.000000', 'temperatura', 82.0000, 'ºC'),
	(104338, 109, '2015-03-15 01:17:28.000000', 'temperatura', 685.0000, 'ºC'),
	(104339, 109, '2015-03-15 01:17:29.000000', 'temperatura', 780.0000, 'ºC'),
	(104340, 109, '2015-03-15 01:17:30.000000', 'temperatura', 644.0000, 'ºC'),
	(104341, 109, '2015-03-15 01:17:31.000000', 'temperatura', 881.0000, 'ºC'),
	(104342, 109, '2015-03-15 01:17:32.000000', 'temperatura', 74.0000, 'ºC'),
	(104343, 109, '2015-03-15 01:17:33.000000', 'temperatura', 129.0000, 'ºC'),
	(104344, 109, '2015-03-15 01:17:34.000000', 'temperatura', 423.0000, 'ºC'),
	(104345, 109, '2015-03-15 01:17:35.000000', 'temperatura', 527.0000, 'ºC'),
	(104346, 109, '2015-03-15 01:17:36.000000', 'temperatura', 167.0000, 'ºC'),
	(104347, 109, '2015-03-15 01:17:37.000000', 'temperatura', 454.0000, 'ºC'),
	(104348, 109, '2015-03-15 01:17:38.000000', 'temperatura', 572.0000, 'ºC'),
	(104349, 109, '2015-03-15 01:17:39.000000', 'temperatura', 297.0000, 'ºC'),
	(104350, 109, '2015-03-15 01:17:40.000000', 'temperatura', 970.0000, 'ºC'),
	(104351, 109, '2015-03-15 01:17:41.000000', 'temperatura', 360.0000, 'ºC'),
	(104352, 109, '2015-03-15 01:17:42.000000', 'temperatura', 89.0000, 'ºC'),
	(104353, 109, '2015-03-15 01:17:43.000000', 'temperatura', 568.0000, 'ºC'),
	(104354, 109, '2015-03-15 01:17:44.000000', 'temperatura', 173.0000, 'ºC'),
	(104355, 109, '2015-03-15 01:17:45.000000', 'temperatura', 359.0000, 'ºC'),
	(104356, 109, '2015-03-15 01:17:46.000000', 'temperatura', 80.0000, 'ºC'),
	(104357, 109, '2015-03-15 01:17:47.000000', 'temperatura', 520.0000, 'ºC'),
	(104358, 109, '2015-03-15 01:17:48.000000', 'temperatura', 1162.0000, 'ºC'),
	(104359, 109, '2015-03-15 01:17:49.000000', 'temperatura', 650.0000, 'ºC'),
	(104360, 109, '2015-03-15 01:17:50.000000', 'temperatura', 963.0000, 'ºC'),
	(104361, 109, '2015-03-15 01:17:51.000000', 'temperatura', 468.0000, 'ºC'),
	(104362, 109, '2015-03-15 01:17:52.000000', 'temperatura', 652.0000, 'ºC'),
	(104363, 109, '2015-03-15 01:17:53.000000', 'temperatura', 655.0000, 'ºC'),
	(104364, 109, '2015-03-15 01:17:54.000000', 'temperatura', 118.0000, 'ºC'),
	(104365, 109, '2015-03-15 01:17:55.000000', 'temperatura', 1027.0000, 'ºC'),
	(104366, 109, '2015-03-15 01:17:56.000000', 'temperatura', 1181.0000, 'ºC'),
	(104367, 109, '2015-03-15 01:17:57.000000', 'temperatura', 425.0000, 'ºC'),
	(104368, 109, '2015-03-15 01:17:58.000000', 'temperatura', 984.0000, 'ºC'),
	(104369, 109, '2015-03-15 01:17:59.000000', 'temperatura', 44.0000, 'ºC'),
	(104370, 109, '2015-03-15 01:18:00.000000', 'temperatura', 870.0000, 'ºC'),
	(104371, 109, '2015-03-15 01:18:01.000000', 'temperatura', 619.0000, 'ºC'),
	(104372, 109, '2015-03-15 01:18:02.000000', 'temperatura', 486.0000, 'ºC'),
	(104373, 109, '2015-03-15 01:18:03.000000', 'temperatura', 574.0000, 'ºC'),
	(104374, 109, '2015-03-15 01:18:04.000000', 'temperatura', 212.0000, 'ºC'),
	(104375, 109, '2015-03-15 01:18:05.000000', 'temperatura', 540.0000, 'ºC'),
	(104376, 109, '2015-03-15 01:18:06.000000', 'temperatura', 861.0000, 'ºC'),
	(104377, 109, '2015-03-15 01:18:07.000000', 'temperatura', 287.0000, 'ºC'),
	(104378, 109, '2015-03-15 01:18:08.000000', 'temperatura', 54.0000, 'ºC'),
	(104379, 109, '2015-03-15 01:18:09.000000', 'temperatura', 610.0000, 'ºC'),
	(104380, 109, '2015-03-15 01:18:10.000000', 'temperatura', 488.0000, 'ºC'),
	(104381, 109, '2015-03-15 01:18:11.000000', 'temperatura', 609.0000, 'ºC'),
	(104382, 109, '2015-03-15 01:18:12.000000', 'temperatura', 380.0000, 'ºC'),
	(104383, 109, '2015-03-15 01:18:13.000000', 'temperatura', 77.0000, 'ºC'),
	(104384, 109, '2015-03-15 01:18:14.000000', 'temperatura', 443.0000, 'ºC'),
	(104385, 109, '2015-03-15 01:18:15.000000', 'temperatura', 786.0000, 'ºC'),
	(104386, 109, '2015-03-15 01:18:16.000000', 'temperatura', 203.0000, 'ºC'),
	(104387, 109, '2015-03-15 01:18:17.000000', 'temperatura', 1056.0000, 'ºC'),
	(104388, 109, '2015-03-15 01:18:18.000000', 'temperatura', 1071.0000, 'ºC'),
	(104389, 109, '2015-03-15 01:18:19.000000', 'temperatura', 986.0000, 'ºC'),
	(104390, 109, '2015-03-15 01:18:20.000000', 'temperatura', 520.0000, 'ºC'),
	(104391, 109, '2015-03-15 01:18:21.000000', 'temperatura', 843.0000, 'ºC'),
	(104392, 109, '2015-03-15 01:18:22.000000', 'temperatura', 257.0000, 'ºC'),
	(104393, 109, '2015-03-15 01:18:23.000000', 'temperatura', 1153.0000, 'ºC'),
	(104394, 109, '2015-03-15 01:18:24.000000', 'temperatura', 196.0000, 'ºC'),
	(104395, 109, '2015-03-15 01:18:25.000000', 'temperatura', 1120.0000, 'ºC'),
	(104396, 109, '2015-03-15 01:18:26.000000', 'temperatura', 215.0000, 'ºC'),
	(104397, 109, '2015-03-15 01:18:27.000000', 'temperatura', 116.0000, 'ºC'),
	(104398, 109, '2015-03-15 01:18:28.000000', 'temperatura', 1134.0000, 'ºC'),
	(104399, 109, '2015-03-15 01:18:29.000000', 'temperatura', 522.0000, 'ºC'),
	(104400, 109, '2015-03-15 01:18:30.000000', 'temperatura', 411.0000, 'ºC'),
	(104401, 109, '2015-03-15 01:18:31.000000', 'temperatura', 488.0000, 'ºC'),
	(104402, 109, '2015-03-15 01:18:32.000000', 'temperatura', 6.0000, 'ºC'),
	(104403, 109, '2015-03-15 01:18:33.000000', 'temperatura', 966.0000, 'ºC'),
	(104404, 109, '2015-03-15 01:18:34.000000', 'temperatura', 14.0000, 'ºC'),
	(104405, 109, '2015-03-15 01:18:35.000000', 'temperatura', 772.0000, 'ºC'),
	(104406, 109, '2015-03-15 01:18:36.000000', 'temperatura', 217.0000, 'ºC'),
	(104407, 109, '2015-03-15 01:18:37.000000', 'temperatura', 1171.0000, 'ºC'),
	(104408, 109, '2015-03-15 01:18:38.000000', 'temperatura', 405.0000, 'ºC'),
	(104409, 109, '2015-03-15 01:18:39.000000', 'temperatura', 912.0000, 'ºC'),
	(104410, 109, '2015-03-15 01:18:40.000000', 'temperatura', 947.0000, 'ºC'),
	(104411, 109, '2015-03-15 01:18:41.000000', 'temperatura', 800.0000, 'ºC'),
	(104412, 109, '2015-03-15 01:18:42.000000', 'temperatura', 1159.0000, 'ºC'),
	(104413, 109, '2015-03-15 01:18:43.000000', 'temperatura', 994.0000, 'ºC'),
	(104414, 109, '2015-03-15 01:18:44.000000', 'temperatura', 294.0000, 'ºC'),
	(104415, 109, '2015-03-15 01:18:45.000000', 'temperatura', 889.0000, 'ºC'),
	(104416, 109, '2015-03-15 01:18:46.000000', 'temperatura', 1164.0000, 'ºC'),
	(104417, 109, '2015-03-15 01:18:47.000000', 'temperatura', 751.0000, 'ºC'),
	(104418, 109, '2015-03-15 01:18:48.000000', 'temperatura', 265.0000, 'ºC'),
	(104419, 109, '2015-03-15 01:18:49.000000', 'temperatura', 273.0000, 'ºC'),
	(104420, 109, '2015-03-15 01:18:50.000000', 'temperatura', 569.0000, 'ºC'),
	(104421, 109, '2015-03-15 01:18:51.000000', 'temperatura', 827.0000, 'ºC'),
	(104422, 109, '2015-03-15 01:18:52.000000', 'temperatura', 28.0000, 'ºC'),
	(104423, 109, '2015-03-15 01:18:53.000000', 'temperatura', 59.0000, 'ºC'),
	(104424, 109, '2015-03-15 01:18:54.000000', 'temperatura', 212.0000, 'ºC'),
	(104425, 109, '2015-03-15 01:18:55.000000', 'temperatura', 886.0000, 'ºC'),
	(104426, 109, '2015-03-15 01:18:56.000000', 'temperatura', 191.0000, 'ºC'),
	(104427, 109, '2015-03-15 01:18:57.000000', 'temperatura', 699.0000, 'ºC'),
	(104428, 109, '2015-03-15 01:18:58.000000', 'temperatura', 522.0000, 'ºC'),
	(104429, 109, '2015-03-15 01:18:59.000000', 'temperatura', 512.0000, 'ºC'),
	(104430, 109, '2015-03-15 01:19:00.000000', 'temperatura', 996.0000, 'ºC'),
	(104431, 109, '2015-03-15 01:19:01.000000', 'temperatura', 1045.0000, 'ºC'),
	(104432, 109, '2015-03-15 01:19:02.000000', 'temperatura', 1036.0000, 'ºC'),
	(104433, 109, '2015-03-15 01:19:03.000000', 'temperatura', 845.0000, 'ºC'),
	(104434, 109, '2015-03-15 01:19:04.000000', 'temperatura', 1119.0000, 'ºC'),
	(104435, 109, '2015-03-15 01:19:05.000000', 'temperatura', 659.0000, 'ºC'),
	(104436, 109, '2015-03-15 01:19:06.000000', 'temperatura', 1141.0000, 'ºC'),
	(104437, 109, '2015-03-15 01:19:07.000000', 'temperatura', 129.0000, 'ºC'),
	(104438, 109, '2015-03-15 01:19:08.000000', 'temperatura', 819.0000, 'ºC'),
	(104439, 109, '2015-03-15 01:19:09.000000', 'temperatura', 111.0000, 'ºC'),
	(104440, 109, '2015-03-15 01:19:10.000000', 'temperatura', 500.0000, 'ºC'),
	(104441, 109, '2015-03-15 01:19:11.000000', 'temperatura', 966.0000, 'ºC'),
	(104442, 109, '2015-03-15 01:19:12.000000', 'temperatura', 931.0000, 'ºC'),
	(104443, 109, '2015-03-15 01:19:13.000000', 'temperatura', 557.0000, 'ºC'),
	(104444, 109, '2015-03-15 01:19:14.000000', 'temperatura', 1191.0000, 'ºC'),
	(104445, 109, '2015-03-15 01:19:15.000000', 'temperatura', 685.0000, 'ºC'),
	(104446, 109, '2015-03-15 01:19:16.000000', 'temperatura', 1053.0000, 'ºC'),
	(104447, 109, '2015-03-15 01:19:17.000000', 'temperatura', 809.0000, 'ºC'),
	(104448, 109, '2015-03-15 01:19:18.000000', 'temperatura', 886.0000, 'ºC'),
	(104449, 109, '2015-03-15 01:19:19.000000', 'temperatura', 803.0000, 'ºC'),
	(104450, 109, '2015-03-15 01:19:20.000000', 'temperatura', 159.0000, 'ºC'),
	(104451, 109, '2015-03-15 01:19:21.000000', 'temperatura', 788.0000, 'ºC'),
	(104452, 109, '2015-03-15 01:19:22.000000', 'temperatura', 1062.0000, 'ºC'),
	(104453, 109, '2015-03-15 01:19:23.000000', 'temperatura', 545.0000, 'ºC'),
	(104454, 109, '2015-03-15 01:19:24.000000', 'temperatura', 739.0000, 'ºC'),
	(104455, 109, '2015-03-15 01:19:25.000000', 'temperatura', 863.0000, 'ºC'),
	(104456, 109, '2015-03-15 01:19:26.000000', 'temperatura', 899.0000, 'ºC'),
	(104457, 109, '2015-03-15 01:19:27.000000', 'temperatura', 706.0000, 'ºC'),
	(104458, 109, '2015-03-15 01:19:28.000000', 'temperatura', 834.0000, 'ºC'),
	(104459, 109, '2015-03-15 01:19:29.000000', 'temperatura', 851.0000, 'ºC'),
	(104460, 109, '2015-03-15 01:19:30.000000', 'temperatura', 555.0000, 'ºC'),
	(104461, 109, '2015-03-15 01:19:31.000000', 'temperatura', 224.0000, 'ºC'),
	(104462, 109, '2015-03-15 01:19:32.000000', 'temperatura', 653.0000, 'ºC'),
	(104463, 109, '2015-03-15 01:19:33.000000', 'temperatura', 195.0000, 'ºC'),
	(104464, 109, '2015-03-15 01:19:34.000000', 'temperatura', 218.0000, 'ºC'),
	(104465, 109, '2015-03-15 01:19:35.000000', 'temperatura', 502.0000, 'ºC'),
	(104466, 109, '2015-03-15 01:19:36.000000', 'temperatura', 660.0000, 'ºC'),
	(104467, 109, '2015-03-15 01:19:37.000000', 'temperatura', 592.0000, 'ºC'),
	(104468, 109, '2015-03-15 01:19:38.000000', 'temperatura', 983.0000, 'ºC'),
	(104469, 109, '2015-03-15 01:19:39.000000', 'temperatura', 737.0000, 'ºC'),
	(104470, 109, '2015-03-15 01:19:40.000000', 'temperatura', 738.0000, 'ºC'),
	(104471, 109, '2015-03-15 01:19:41.000000', 'temperatura', 279.0000, 'ºC'),
	(104472, 109, '2015-03-15 01:19:42.000000', 'temperatura', 380.0000, 'ºC'),
	(104473, 109, '2015-03-15 01:19:43.000000', 'temperatura', 1064.0000, 'ºC'),
	(104474, 109, '2015-03-15 01:19:44.000000', 'temperatura', 580.0000, 'ºC'),
	(104475, 109, '2015-03-15 01:19:45.000000', 'temperatura', 911.0000, 'ºC'),
	(104476, 109, '2015-03-15 01:19:46.000000', 'temperatura', 415.0000, 'ºC'),
	(104477, 109, '2015-03-15 01:19:47.000000', 'temperatura', 540.0000, 'ºC'),
	(104478, 109, '2015-03-15 01:19:48.000000', 'temperatura', 258.0000, 'ºC'),
	(104479, 109, '2015-03-15 01:19:49.000000', 'temperatura', 869.0000, 'ºC'),
	(104480, 109, '2015-03-15 01:19:50.000000', 'temperatura', 1171.0000, 'ºC'),
	(104481, 109, '2015-03-15 01:19:51.000000', 'temperatura', 847.0000, 'ºC'),
	(104482, 109, '2015-03-15 01:19:52.000000', 'temperatura', 726.0000, 'ºC'),
	(104483, 109, '2015-03-15 01:19:53.000000', 'temperatura', 1088.0000, 'ºC'),
	(104484, 109, '2015-03-15 01:19:54.000000', 'temperatura', 862.0000, 'ºC'),
	(104485, 109, '2015-03-15 01:19:55.000000', 'temperatura', 1046.0000, 'ºC'),
	(104486, 109, '2015-03-15 01:19:56.000000', 'temperatura', 245.0000, 'ºC'),
	(104487, 109, '2015-03-15 01:19:57.000000', 'temperatura', 490.0000, 'ºC'),
	(104488, 109, '2015-03-15 01:19:58.000000', 'temperatura', 512.0000, 'ºC'),
	(104489, 109, '2015-03-15 01:19:59.000000', 'temperatura', 1092.0000, 'ºC'),
	(104490, 109, '2015-03-15 01:20:00.000000', 'temperatura', 325.0000, 'ºC'),
	(104491, 109, '2015-03-15 01:20:01.000000', 'temperatura', 751.0000, 'ºC'),
	(104492, 109, '2015-03-15 01:20:02.000000', 'temperatura', 379.0000, 'ºC'),
	(104493, 109, '2015-03-15 01:20:03.000000', 'temperatura', 842.0000, 'ºC'),
	(104494, 109, '2015-03-15 01:20:04.000000', 'temperatura', 672.0000, 'ºC'),
	(104495, 109, '2015-03-15 01:20:05.000000', 'temperatura', 835.0000, 'ºC'),
	(104496, 109, '2015-03-15 01:20:06.000000', 'temperatura', 961.0000, 'ºC'),
	(104497, 109, '2015-03-15 01:20:07.000000', 'temperatura', 1101.0000, 'ºC'),
	(104498, 109, '2015-03-15 01:20:08.000000', 'temperatura', 221.0000, 'ºC'),
	(104499, 109, '2015-03-15 01:20:09.000000', 'temperatura', 203.0000, 'ºC'),
	(104500, 109, '2015-03-15 01:20:10.000000', 'temperatura', 351.0000, 'ºC'),
	(104501, 109, '2015-03-15 01:20:11.000000', 'temperatura', 1149.0000, 'ºC'),
	(104502, 109, '2015-03-15 01:20:12.000000', 'temperatura', 1090.0000, 'ºC'),
	(104503, 109, '2015-03-15 01:20:13.000000', 'temperatura', 806.0000, 'ºC'),
	(104504, 109, '2015-03-15 01:20:14.000000', 'temperatura', 760.0000, 'ºC'),
	(104505, 109, '2015-03-15 01:20:15.000000', 'temperatura', 184.0000, 'ºC'),
	(104506, 109, '2015-03-15 01:20:16.000000', 'temperatura', 1037.0000, 'ºC'),
	(104507, 109, '2015-03-15 01:20:17.000000', 'temperatura', 1036.0000, 'ºC'),
	(104508, 109, '2015-03-15 01:20:18.000000', 'temperatura', 870.0000, 'ºC'),
	(104509, 109, '2015-03-15 01:20:19.000000', 'temperatura', 44.0000, 'ºC'),
	(104510, 109, '2015-03-15 01:20:20.000000', 'temperatura', 7.0000, 'ºC'),
	(104511, 109, '2015-03-15 01:20:21.000000', 'temperatura', 1107.0000, 'ºC'),
	(104512, 109, '2015-03-15 01:20:22.000000', 'temperatura', 712.0000, 'ºC'),
	(104513, 109, '2015-03-15 01:20:23.000000', 'temperatura', 239.0000, 'ºC'),
	(104514, 109, '2015-03-15 01:20:24.000000', 'temperatura', 259.0000, 'ºC'),
	(104515, 109, '2015-03-15 01:20:25.000000', 'temperatura', 578.0000, 'ºC'),
	(104516, 109, '2015-03-15 01:20:26.000000', 'temperatura', 913.0000, 'ºC'),
	(104517, 109, '2015-03-15 01:20:27.000000', 'temperatura', 430.0000, 'ºC'),
	(104518, 109, '2015-03-15 01:20:28.000000', 'temperatura', 615.0000, 'ºC'),
	(104519, 109, '2015-03-15 01:20:29.000000', 'temperatura', 584.0000, 'ºC'),
	(104520, 109, '2015-03-15 01:20:30.000000', 'temperatura', 1077.0000, 'ºC'),
	(104521, 109, '2015-03-15 01:20:31.000000', 'temperatura', 34.0000, 'ºC'),
	(104522, 109, '2015-03-15 01:20:32.000000', 'temperatura', 536.0000, 'ºC'),
	(104523, 109, '2015-03-15 01:20:33.000000', 'temperatura', 182.0000, 'ºC'),
	(104524, 109, '2015-03-15 01:20:34.000000', 'temperatura', 502.0000, 'ºC'),
	(104525, 109, '2015-03-15 01:20:35.000000', 'temperatura', 763.0000, 'ºC'),
	(104526, 109, '2015-03-15 01:20:36.000000', 'temperatura', 1109.0000, 'ºC'),
	(104527, 109, '2015-03-15 01:20:37.000000', 'temperatura', 857.0000, 'ºC'),
	(104528, 109, '2015-03-15 01:20:38.000000', 'temperatura', 961.0000, 'ºC'),
	(104529, 109, '2015-03-15 01:20:39.000000', 'temperatura', 1032.0000, 'ºC'),
	(104530, 109, '2015-03-15 01:20:40.000000', 'temperatura', 1080.0000, 'ºC'),
	(104531, 109, '2015-03-15 01:20:41.000000', 'temperatura', 1103.0000, 'ºC'),
	(104532, 109, '2015-03-15 01:20:42.000000', 'temperatura', 1076.0000, 'ºC'),
	(104533, 109, '2015-03-15 01:20:43.000000', 'temperatura', 872.0000, 'ºC'),
	(104534, 109, '2015-03-15 01:20:44.000000', 'temperatura', 1131.0000, 'ºC'),
	(104535, 109, '2015-03-15 01:20:45.000000', 'temperatura', 641.0000, 'ºC'),
	(104536, 109, '2015-03-15 01:20:46.000000', 'temperatura', 1013.0000, 'ºC'),
	(104537, 109, '2015-03-15 01:20:47.000000', 'temperatura', 740.0000, 'ºC'),
	(104538, 109, '2015-03-15 01:20:48.000000', 'temperatura', 662.0000, 'ºC'),
	(104539, 109, '2015-03-15 01:20:49.000000', 'temperatura', 1090.0000, 'ºC'),
	(104540, 109, '2015-03-15 01:20:50.000000', 'temperatura', 1067.0000, 'ºC'),
	(104541, 109, '2015-03-15 01:20:51.000000', 'temperatura', 864.0000, 'ºC'),
	(104542, 109, '2015-03-15 01:20:52.000000', 'temperatura', 1120.0000, 'ºC'),
	(104543, 109, '2015-03-15 01:20:53.000000', 'temperatura', 610.0000, 'ºC'),
	(104544, 109, '2015-03-15 01:20:54.000000', 'temperatura', 890.0000, 'ºC'),
	(104545, 109, '2015-03-15 01:20:55.000000', 'temperatura', 219.0000, 'ºC'),
	(104546, 109, '2015-03-15 01:20:56.000000', 'temperatura', 826.0000, 'ºC'),
	(104547, 109, '2015-03-15 01:20:57.000000', 'temperatura', 1074.0000, 'ºC'),
	(104548, 109, '2015-03-15 01:20:58.000000', 'temperatura', 494.0000, 'ºC'),
	(104549, 109, '2015-03-15 01:20:59.000000', 'temperatura', 447.0000, 'ºC'),
	(104550, 109, '2015-03-15 01:21:00.000000', 'temperatura', 752.0000, 'ºC'),
	(104551, 109, '2015-03-15 01:21:01.000000', 'temperatura', 19.0000, 'ºC'),
	(104552, 109, '2015-03-15 01:21:02.000000', 'temperatura', 242.0000, 'ºC'),
	(104553, 109, '2015-03-15 01:21:03.000000', 'temperatura', 1153.0000, 'ºC'),
	(104554, 109, '2015-03-15 01:21:04.000000', 'temperatura', 239.0000, 'ºC'),
	(104555, 109, '2015-03-15 01:21:05.000000', 'temperatura', 137.0000, 'ºC'),
	(104556, 109, '2015-03-15 01:21:06.000000', 'temperatura', 1168.0000, 'ºC'),
	(104557, 109, '2015-03-15 01:21:07.000000', 'temperatura', 630.0000, 'ºC'),
	(104558, 109, '2015-03-15 01:21:08.000000', 'temperatura', 844.0000, 'ºC'),
	(104559, 109, '2015-03-15 01:21:09.000000', 'temperatura', 1133.0000, 'ºC'),
	(104560, 109, '2015-03-15 01:21:10.000000', 'temperatura', 733.0000, 'ºC'),
	(104561, 109, '2015-03-15 01:21:11.000000', 'temperatura', 268.0000, 'ºC'),
	(104562, 109, '2015-03-15 01:21:12.000000', 'temperatura', 338.0000, 'ºC'),
	(104563, 109, '2015-03-15 01:21:13.000000', 'temperatura', 890.0000, 'ºC'),
	(104564, 109, '2015-03-15 01:21:14.000000', 'temperatura', 1034.0000, 'ºC'),
	(104565, 109, '2015-03-15 01:21:15.000000', 'temperatura', 101.0000, 'ºC'),
	(104566, 109, '2015-03-15 01:21:16.000000', 'temperatura', 1002.0000, 'ºC'),
	(104567, 109, '2015-03-15 01:21:17.000000', 'temperatura', 1110.0000, 'ºC'),
	(104568, 109, '2015-03-15 01:21:18.000000', 'temperatura', 146.0000, 'ºC'),
	(104569, 109, '2015-03-15 01:21:19.000000', 'temperatura', 997.0000, 'ºC'),
	(104570, 109, '2015-03-15 01:21:20.000000', 'temperatura', 949.0000, 'ºC'),
	(104571, 109, '2015-03-15 01:21:21.000000', 'temperatura', 554.0000, 'ºC'),
	(104572, 109, '2015-03-15 01:21:22.000000', 'temperatura', 1125.0000, 'ºC'),
	(104573, 109, '2015-03-15 01:21:23.000000', 'temperatura', 362.0000, 'ºC'),
	(104574, 109, '2015-03-15 01:21:24.000000', 'temperatura', 837.0000, 'ºC'),
	(104575, 109, '2015-03-15 01:21:25.000000', 'temperatura', 700.0000, 'ºC'),
	(104576, 109, '2015-03-15 01:21:26.000000', 'temperatura', 990.0000, 'ºC'),
	(104577, 109, '2015-03-15 01:21:27.000000', 'temperatura', 449.0000, 'ºC'),
	(104578, 109, '2015-03-15 01:21:28.000000', 'temperatura', 477.0000, 'ºC'),
	(104579, 109, '2015-03-15 01:21:29.000000', 'temperatura', 1038.0000, 'ºC'),
	(104580, 109, '2015-03-15 01:21:30.000000', 'temperatura', 159.0000, 'ºC'),
	(104581, 109, '2015-03-15 01:21:31.000000', 'temperatura', 84.0000, 'ºC'),
	(104582, 109, '2015-03-15 01:21:32.000000', 'temperatura', 1140.0000, 'ºC'),
	(104583, 109, '2015-03-15 01:21:33.000000', 'temperatura', 651.0000, 'ºC'),
	(104584, 109, '2015-03-15 01:21:34.000000', 'temperatura', 1036.0000, 'ºC'),
	(104585, 109, '2015-03-15 01:21:35.000000', 'temperatura', 825.0000, 'ºC'),
	(104586, 109, '2015-03-15 01:21:36.000000', 'temperatura', 1018.0000, 'ºC'),
	(104587, 109, '2015-03-15 01:21:37.000000', 'temperatura', 215.0000, 'ºC'),
	(104588, 109, '2015-03-15 01:21:38.000000', 'temperatura', 421.0000, 'ºC'),
	(104589, 109, '2015-03-15 01:21:39.000000', 'temperatura', 260.0000, 'ºC'),
	(104590, 109, '2015-03-15 01:21:40.000000', 'temperatura', 40.0000, 'ºC'),
	(104591, 109, '2015-03-15 01:21:41.000000', 'temperatura', 621.0000, 'ºC'),
	(104592, 109, '2015-03-15 01:21:42.000000', 'temperatura', 586.0000, 'ºC'),
	(104593, 109, '2015-03-15 01:21:43.000000', 'temperatura', 1065.0000, 'ºC'),
	(104594, 109, '2015-03-15 01:21:44.000000', 'temperatura', 1167.0000, 'ºC'),
	(104595, 109, '2015-03-15 01:21:45.000000', 'temperatura', 240.0000, 'ºC'),
	(104596, 109, '2015-03-15 01:21:46.000000', 'temperatura', 101.0000, 'ºC'),
	(104597, 109, '2015-03-15 01:21:47.000000', 'temperatura', 983.0000, 'ºC'),
	(104598, 109, '2015-03-15 01:21:48.000000', 'temperatura', 1016.0000, 'ºC'),
	(104599, 109, '2015-03-15 01:21:49.000000', 'temperatura', 930.0000, 'ºC'),
	(104600, 109, '2015-03-15 01:21:50.000000', 'temperatura', 404.0000, 'ºC'),
	(104601, 109, '2015-03-15 01:21:51.000000', 'temperatura', 428.0000, 'ºC'),
	(104602, 109, '2015-03-15 01:21:52.000000', 'temperatura', 930.0000, 'ºC'),
	(104603, 109, '2015-03-15 01:21:53.000000', 'temperatura', 968.0000, 'ºC'),
	(104604, 109, '2015-03-15 01:21:54.000000', 'temperatura', 848.0000, 'ºC'),
	(104605, 109, '2015-03-15 01:21:55.000000', 'temperatura', 136.0000, 'ºC'),
	(104606, 109, '2015-03-15 01:21:56.000000', 'temperatura', 536.0000, 'ºC'),
	(104607, 109, '2015-03-15 01:21:57.000000', 'temperatura', 1071.0000, 'ºC'),
	(104608, 109, '2015-03-15 01:21:58.000000', 'temperatura', 151.0000, 'ºC'),
	(104609, 109, '2015-03-15 01:21:59.000000', 'temperatura', 1143.0000, 'ºC'),
	(104610, 109, '2015-03-15 01:22:00.000000', 'temperatura', 460.0000, 'ºC'),
	(104611, 109, '2015-03-15 01:22:01.000000', 'temperatura', 73.0000, 'ºC'),
	(104612, 109, '2015-03-15 01:22:02.000000', 'temperatura', 184.0000, 'ºC'),
	(104613, 109, '2015-03-15 01:22:03.000000', 'temperatura', 704.0000, 'ºC'),
	(104614, 109, '2015-03-15 01:22:04.000000', 'temperatura', 568.0000, 'ºC'),
	(104615, 109, '2015-03-15 01:22:05.000000', 'temperatura', 727.0000, 'ºC'),
	(104616, 109, '2015-03-15 01:22:06.000000', 'temperatura', 732.0000, 'ºC'),
	(104617, 109, '2015-03-15 01:22:07.000000', 'temperatura', 278.0000, 'ºC'),
	(104618, 109, '2015-03-15 01:22:08.000000', 'temperatura', 396.0000, 'ºC'),
	(104619, 109, '2015-03-15 01:22:09.000000', 'temperatura', 1145.0000, 'ºC'),
	(104620, 109, '2015-03-15 01:22:10.000000', 'temperatura', 938.0000, 'ºC'),
	(104621, 109, '2015-03-15 01:22:11.000000', 'temperatura', 56.0000, 'ºC'),
	(104622, 109, '2015-03-15 01:22:12.000000', 'temperatura', 1065.0000, 'ºC'),
	(104623, 109, '2015-03-15 01:22:13.000000', 'temperatura', 358.0000, 'ºC'),
	(104624, 109, '2015-03-15 01:22:14.000000', 'temperatura', 997.0000, 'ºC'),
	(104625, 109, '2015-03-15 01:22:15.000000', 'temperatura', 310.0000, 'ºC'),
	(104626, 109, '2015-03-15 01:22:16.000000', 'temperatura', 962.0000, 'ºC'),
	(104627, 109, '2015-03-15 01:22:17.000000', 'temperatura', 277.0000, 'ºC'),
	(104628, 109, '2015-03-15 01:22:18.000000', 'temperatura', 902.0000, 'ºC'),
	(104629, 109, '2015-03-15 01:22:19.000000', 'temperatura', 81.0000, 'ºC'),
	(104630, 109, '2015-03-15 01:22:20.000000', 'temperatura', 96.0000, 'ºC'),
	(104631, 109, '2015-03-15 01:22:21.000000', 'temperatura', 240.0000, 'ºC'),
	(104632, 109, '2015-03-15 01:22:22.000000', 'temperatura', 912.0000, 'ºC'),
	(104633, 109, '2015-03-15 01:22:23.000000', 'temperatura', 239.0000, 'ºC'),
	(104634, 109, '2015-03-15 01:22:24.000000', 'temperatura', 862.0000, 'ºC'),
	(104635, 109, '2015-03-15 01:22:25.000000', 'temperatura', 1191.0000, 'ºC'),
	(104636, 109, '2015-03-15 01:22:26.000000', 'temperatura', 969.0000, 'ºC'),
	(104637, 109, '2015-03-15 01:22:27.000000', 'temperatura', 72.0000, 'ºC'),
	(104638, 109, '2015-03-15 01:22:28.000000', 'temperatura', 1054.0000, 'ºC'),
	(104639, 109, '2015-03-15 01:22:29.000000', 'temperatura', 254.0000, 'ºC'),
	(104640, 109, '2015-03-15 01:22:30.000000', 'temperatura', 508.0000, 'ºC'),
	(104641, 109, '2015-03-15 01:22:31.000000', 'temperatura', 580.0000, 'ºC'),
	(104642, 109, '2015-03-15 01:22:32.000000', 'temperatura', 175.0000, 'ºC'),
	(104643, 109, '2015-03-15 01:22:33.000000', 'temperatura', 335.0000, 'ºC'),
	(104644, 109, '2015-03-15 01:22:34.000000', 'temperatura', 1150.0000, 'ºC'),
	(104645, 109, '2015-03-15 01:22:35.000000', 'temperatura', 1148.0000, 'ºC'),
	(104646, 109, '2015-03-15 01:22:36.000000', 'temperatura', 1091.0000, 'ºC'),
	(104647, 109, '2015-03-15 01:22:37.000000', 'temperatura', 812.0000, 'ºC'),
	(104648, 109, '2015-03-15 01:22:38.000000', 'temperatura', 787.0000, 'ºC'),
	(104649, 109, '2015-03-15 01:22:39.000000', 'temperatura', 300.0000, 'ºC'),
	(104650, 109, '2015-03-15 01:22:40.000000', 'temperatura', 340.0000, 'ºC'),
	(104651, 109, '2015-03-15 01:22:41.000000', 'temperatura', 800.0000, 'ºC'),
	(104652, 109, '2015-03-15 01:22:42.000000', 'temperatura', 580.0000, 'ºC'),
	(104653, 109, '2015-03-15 01:22:43.000000', 'temperatura', 499.0000, 'ºC'),
	(104654, 109, '2015-03-15 01:22:44.000000', 'temperatura', 758.0000, 'ºC'),
	(104655, 109, '2015-03-15 01:22:45.000000', 'temperatura', 1093.0000, 'ºC'),
	(104656, 109, '2015-03-15 01:22:46.000000', 'temperatura', 792.0000, 'ºC'),
	(104657, 109, '2015-03-15 01:22:47.000000', 'temperatura', 683.0000, 'ºC'),
	(104658, 109, '2015-03-15 01:22:48.000000', 'temperatura', 1037.0000, 'ºC'),
	(104659, 109, '2015-03-15 01:22:49.000000', 'temperatura', 736.0000, 'ºC'),
	(104660, 109, '2015-03-15 01:22:50.000000', 'temperatura', 570.0000, 'ºC'),
	(104661, 109, '2015-03-15 01:22:51.000000', 'temperatura', 644.0000, 'ºC'),
	(104662, 109, '2015-03-15 01:22:52.000000', 'temperatura', 310.0000, 'ºC'),
	(104663, 109, '2015-03-15 01:22:53.000000', 'temperatura', 817.0000, 'ºC'),
	(104664, 109, '2015-03-15 01:22:54.000000', 'temperatura', 754.0000, 'ºC'),
	(104665, 109, '2015-03-15 01:22:55.000000', 'temperatura', 123.0000, 'ºC'),
	(104666, 109, '2015-03-15 01:22:56.000000', 'temperatura', 753.0000, 'ºC'),
	(104667, 109, '2015-03-15 01:22:57.000000', 'temperatura', 996.0000, 'ºC'),
	(104668, 109, '2015-03-15 01:22:58.000000', 'temperatura', 323.0000, 'ºC'),
	(104669, 109, '2015-03-15 01:22:59.000000', 'temperatura', 1027.0000, 'ºC'),
	(104670, 109, '2015-03-15 01:23:00.000000', 'temperatura', 565.0000, 'ºC'),
	(104671, 109, '2015-03-15 01:23:01.000000', 'temperatura', 945.0000, 'ºC'),
	(104672, 109, '2015-03-15 01:23:02.000000', 'temperatura', 630.0000, 'ºC'),
	(104673, 109, '2015-03-15 01:23:03.000000', 'temperatura', 315.0000, 'ºC'),
	(104674, 109, '2015-03-15 01:23:04.000000', 'temperatura', 887.0000, 'ºC'),
	(104675, 109, '2015-03-15 01:23:05.000000', 'temperatura', 1091.0000, 'ºC'),
	(104676, 109, '2015-03-15 01:23:06.000000', 'temperatura', 395.0000, 'ºC'),
	(104677, 109, '2015-03-15 01:23:07.000000', 'temperatura', 1102.0000, 'ºC'),
	(104678, 109, '2015-03-15 01:23:08.000000', 'temperatura', 723.0000, 'ºC'),
	(104679, 109, '2015-03-15 01:23:09.000000', 'temperatura', 313.0000, 'ºC'),
	(104680, 109, '2015-03-15 01:23:10.000000', 'temperatura', 594.0000, 'ºC'),
	(104681, 109, '2015-03-15 01:23:11.000000', 'temperatura', 834.0000, 'ºC'),
	(104682, 109, '2015-03-15 01:23:12.000000', 'temperatura', 1186.0000, 'ºC'),
	(104683, 109, '2015-03-15 01:23:13.000000', 'temperatura', 1031.0000, 'ºC'),
	(104684, 109, '2015-03-15 01:23:14.000000', 'temperatura', 397.0000, 'ºC'),
	(104685, 109, '2015-03-15 01:23:15.000000', 'temperatura', 92.0000, 'ºC'),
	(104686, 109, '2015-03-15 01:23:16.000000', 'temperatura', 471.0000, 'ºC'),
	(104687, 109, '2015-03-15 01:23:17.000000', 'temperatura', 879.0000, 'ºC'),
	(104688, 109, '2015-03-15 01:23:18.000000', 'temperatura', 583.0000, 'ºC'),
	(104689, 109, '2015-03-15 01:23:19.000000', 'temperatura', 280.0000, 'ºC'),
	(104690, 109, '2015-03-15 01:23:20.000000', 'temperatura', 848.0000, 'ºC'),
	(104691, 109, '2015-03-15 01:23:21.000000', 'temperatura', 1002.0000, 'ºC'),
	(104692, 109, '2015-03-15 01:23:22.000000', 'temperatura', 67.0000, 'ºC'),
	(104693, 109, '2015-03-15 01:23:23.000000', 'temperatura', 928.0000, 'ºC'),
	(104694, 109, '2015-03-15 01:23:24.000000', 'temperatura', 840.0000, 'ºC'),
	(104695, 109, '2015-03-15 01:23:25.000000', 'temperatura', 216.0000, 'ºC'),
	(104696, 109, '2015-03-15 01:23:26.000000', 'temperatura', 960.0000, 'ºC'),
	(104697, 109, '2015-03-15 01:23:27.000000', 'temperatura', 555.0000, 'ºC'),
	(104698, 109, '2015-03-15 01:23:28.000000', 'temperatura', 1094.0000, 'ºC'),
	(104699, 109, '2015-03-15 01:23:29.000000', 'temperatura', 208.0000, 'ºC'),
	(104700, 109, '2015-03-15 01:23:30.000000', 'temperatura', 156.0000, 'ºC'),
	(104701, 109, '2015-03-15 01:23:31.000000', 'temperatura', 156.0000, 'ºC'),
	(104702, 109, '2015-03-15 01:23:32.000000', 'temperatura', 315.0000, 'ºC'),
	(104703, 109, '2015-03-15 01:23:33.000000', 'temperatura', 1107.0000, 'ºC'),
	(104704, 109, '2015-03-15 01:23:34.000000', 'temperatura', 988.0000, 'ºC'),
	(104705, 109, '2015-03-15 01:23:35.000000', 'temperatura', 421.0000, 'ºC'),
	(104706, 109, '2015-03-15 01:23:36.000000', 'temperatura', 342.0000, 'ºC'),
	(104707, 109, '2015-03-15 01:23:37.000000', 'temperatura', 449.0000, 'ºC'),
	(104708, 109, '2015-03-15 01:23:38.000000', 'temperatura', 16.0000, 'ºC'),
	(104709, 109, '2015-03-15 01:23:39.000000', 'temperatura', 1135.0000, 'ºC'),
	(104710, 109, '2015-03-15 01:23:40.000000', 'temperatura', 829.0000, 'ºC'),
	(104711, 109, '2015-03-15 01:23:41.000000', 'temperatura', 739.0000, 'ºC'),
	(104712, 109, '2015-03-15 01:23:42.000000', 'temperatura', 7.0000, 'ºC'),
	(104713, 109, '2015-03-15 01:23:43.000000', 'temperatura', 219.0000, 'ºC'),
	(104714, 109, '2015-03-15 01:23:44.000000', 'temperatura', 1073.0000, 'ºC'),
	(104715, 109, '2015-03-15 01:23:45.000000', 'temperatura', 1112.0000, 'ºC'),
	(104716, 109, '2015-03-15 01:23:46.000000', 'temperatura', 1138.0000, 'ºC'),
	(104717, 109, '2015-03-15 01:23:47.000000', 'temperatura', 1157.0000, 'ºC'),
	(104718, 109, '2015-03-15 01:23:48.000000', 'temperatura', 1171.0000, 'ºC'),
	(104719, 109, '2015-03-15 01:23:49.000000', 'temperatura', 1184.0000, 'ºC'),
	(104720, 109, '2015-03-15 01:23:50.000000', 'temperatura', 7.0000, 'ºC'),
	(104721, 109, '2015-03-15 01:23:51.000000', 'temperatura', 86.0000, 'ºC'),
	(104722, 109, '2015-03-15 01:23:52.000000', 'temperatura', 408.0000, 'ºC'),
	(104723, 109, '2015-03-15 01:23:53.000000', 'temperatura', 581.0000, 'ºC'),
	(104724, 109, '2015-03-15 01:23:54.000000', 'temperatura', 482.0000, 'ºC'),
	(104725, 109, '2015-03-15 01:23:55.000000', 'temperatura', 669.0000, 'ºC'),
	(104726, 109, '2015-03-15 01:23:56.000000', 'temperatura', 701.0000, 'ºC'),
	(104727, 109, '2015-03-15 01:23:57.000000', 'temperatura', 296.0000, 'ºC'),
	(104728, 109, '2015-03-15 01:23:58.000000', 'temperatura', 580.0000, 'ºC'),
	(104729, 109, '2015-03-15 01:23:59.000000', 'temperatura', 812.0000, 'ºC'),
	(104730, 109, '2015-03-15 01:24:00.000000', 'temperatura', 1120.0000, 'ºC'),
	(104731, 109, '2015-03-15 01:24:01.000000', 'temperatura', 762.0000, 'ºC'),
	(104732, 109, '2015-03-15 01:24:02.000000', 'temperatura', 454.0000, 'ºC'),
	(104733, 109, '2015-03-15 01:24:03.000000', 'temperatura', 1183.0000, 'ºC'),
	(104734, 109, '2015-03-15 01:24:04.000000', 'temperatura', 952.0000, 'ºC'),
	(104735, 109, '2015-03-15 01:24:05.000000', 'temperatura', 11.0000, 'ºC'),
	(104736, 109, '2015-03-15 01:24:06.000000', 'temperatura', 800.0000, 'ºC'),
	(104737, 109, '2015-03-15 01:24:07.000000', 'temperatura', 367.0000, 'ºC'),
	(104738, 109, '2015-03-15 01:24:08.000000', 'temperatura', 636.0000, 'ºC'),
	(104739, 109, '2015-03-15 01:24:09.000000', 'temperatura', 881.0000, 'ºC'),
	(104740, 109, '2015-03-15 01:24:10.000000', 'temperatura', 96.0000, 'ºC'),
	(104741, 109, '2015-03-15 01:24:11.000000', 'temperatura', 240.0000, 'ºC'),
	(104742, 109, '2015-03-15 01:24:12.000000', 'temperatura', 910.0000, 'ºC'),
	(104743, 109, '2015-03-15 01:24:13.000000', 'temperatura', 233.0000, 'ºC'),
	(104744, 109, '2015-03-15 01:24:14.000000', 'temperatura', 835.0000, 'ºC'),
	(104745, 109, '2015-03-15 01:24:15.000000', 'temperatura', 1074.0000, 'ºC'),
	(104746, 109, '2015-03-15 01:24:16.000000', 'temperatura', 468.0000, 'ºC'),
	(104747, 109, '2015-03-15 01:24:17.000000', 'temperatura', 317.0000, 'ºC'),
	(104748, 109, '2015-03-15 01:24:18.000000', 'temperatura', 183.0000, 'ºC'),
	(104749, 109, '2015-03-15 01:24:19.000000', 'temperatura', 1164.0000, 'ºC'),
	(104750, 109, '2015-03-15 01:24:20.000000', 'temperatura', 470.0000, 'ºC'),
	(104751, 109, '2015-03-15 01:24:21.000000', 'temperatura', 60.0000, 'ºC'),
	(104752, 109, '2015-03-15 01:24:22.000000', 'temperatura', 92.0000, 'ºC'),
	(104753, 109, '2015-03-15 01:24:23.000000', 'temperatura', 278.0000, 'ºC'),
	(104754, 109, '2015-03-15 01:24:24.000000', 'temperatura', 1113.0000, 'ºC'),
	(104755, 109, '2015-03-15 01:24:25.000000', 'temperatura', 1134.0000, 'ºC'),
	(104756, 109, '2015-03-15 01:24:26.000000', 'temperatura', 1130.0000, 'ºC'),
	(104757, 109, '2015-03-15 01:24:27.000000', 'temperatura', 1051.0000, 'ºC'),
	(104758, 109, '2015-03-15 01:24:28.000000', 'temperatura', 665.0000, 'ºC'),
	(104759, 109, '2015-03-15 01:24:29.000000', 'temperatura', 170.0000, 'ºC'),
	(104760, 109, '2015-03-15 01:24:30.000000', 'temperatura', 58.0000, 'ºC'),
	(104761, 109, '2015-03-15 01:24:31.000000', 'temperatura', 981.0000, 'ºC'),
	(104762, 109, '2015-03-15 01:24:32.000000', 'temperatura', 1131.0000, 'ºC'),
	(104763, 109, '2015-03-15 01:24:33.000000', 'temperatura', 313.0000, 'ºC'),
	(104764, 109, '2015-03-15 01:24:34.000000', 'temperatura', 571.0000, 'ºC'),
	(104765, 109, '2015-03-15 01:24:35.000000', 'temperatura', 718.0000, 'ºC'),
	(104766, 109, '2015-03-15 01:24:36.000000', 'temperatura', 676.0000, 'ºC'),
	(104767, 109, '2015-03-15 01:24:37.000000', 'temperatura', 26.0000, 'ºC'),
	(104768, 109, '2015-03-15 01:24:38.000000', 'temperatura', 504.0000, 'ºC'),
	(104769, 109, '2015-03-15 01:24:39.000000', 'temperatura', 41.0000, 'ºC'),
	(104770, 109, '2015-03-15 01:24:40.000000', 'temperatura', 1095.0000, 'ºC'),
	(104771, 109, '2015-03-15 01:24:41.000000', 'temperatura', 553.0000, 'ºC'),
	(104772, 109, '2015-03-15 01:24:42.000000', 'temperatura', 678.0000, 'ºC'),
	(104773, 109, '2015-03-15 01:24:43.000000', 'temperatura', 533.0000, 'ºC'),
	(104774, 109, '2015-03-15 01:24:44.000000', 'temperatura', 629.0000, 'ºC'),
	(104775, 109, '2015-03-15 01:24:45.000000', 'temperatura', 350.0000, 'ºC'),
	(104776, 109, '2015-03-15 01:24:46.000000', 'temperatura', 1063.0000, 'ºC'),
	(104777, 109, '2015-03-15 01:24:47.000000', 'temperatura', 666.0000, 'ºC'),
	(104778, 109, '2015-03-15 01:24:48.000000', 'temperatura', 140.0000, 'ºC'),
	(104779, 109, '2015-03-15 01:24:49.000000', 'temperatura', 1102.0000, 'ºC'),
	(104780, 109, '2015-03-15 01:24:50.000000', 'temperatura', 290.0000, 'ºC'),
	(104781, 109, '2015-03-15 01:24:51.000000', 'temperatura', 544.0000, 'ºC'),
	(104782, 109, '2015-03-15 01:24:52.000000', 'temperatura', 652.0000, 'ºC'),
	(104783, 109, '2015-03-15 01:24:53.000000', 'temperatura', 430.0000, 'ºC'),
	(104784, 109, '2015-03-15 01:24:54.000000', 'temperatura', 192.0000, 'ºC'),
	(104785, 109, '2015-03-15 01:24:55.000000', 'temperatura', 870.0000, 'ºC'),
	(104786, 109, '2015-03-15 01:24:56.000000', 'temperatura', 176.0000, 'ºC'),
	(104787, 109, '2015-03-15 01:24:57.000000', 'temperatura', 669.0000, 'ºC'),
	(104788, 109, '2015-03-15 01:24:58.000000', 'temperatura', 420.0000, 'ºC'),
	(104789, 109, '2015-03-15 01:24:59.000000', 'temperatura', 91.0000, 'ºC'),
	(104790, 109, '2015-03-15 01:25:00.000000', 'temperatura', 398.0000, 'ºC'),
	(104791, 109, '2015-03-15 01:25:01.000000', 'temperatura', 517.0000, 'ºC'),
	(104792, 109, '2015-03-15 01:25:02.000000', 'temperatura', 189.0000, 'ºC'),
	(104793, 109, '2015-03-15 01:25:03.000000', 'temperatura', 598.0000, 'ºC'),
	(104794, 109, '2015-03-15 01:25:04.000000', 'temperatura', 20.0000, 'ºC'),
	(104795, 109, '2015-03-15 01:25:05.000000', 'temperatura', 709.0000, 'ºC'),
	(104796, 109, '2015-03-15 01:25:06.000000', 'temperatura', 1083.0000, 'ºC'),
	(104797, 109, '2015-03-15 01:25:07.000000', 'temperatura', 891.0000, 'ºC'),
	(104798, 109, '2015-03-15 01:25:08.000000', 'temperatura', 5.0000, 'ºC'),
	(104799, 109, '2015-03-15 01:25:09.000000', 'temperatura', 955.0000, 'ºC'),
	(104800, 109, '2015-03-15 01:25:10.000000', 'temperatura', 1159.0000, 'ºC'),
	(104801, 109, '2015-03-15 01:25:11.000000', 'temperatura', 531.0000, 'ºC'),
	(104802, 109, '2015-03-15 01:25:12.000000', 'temperatura', 377.0000, 'ºC'),
	(104803, 109, '2015-03-15 01:25:13.000000', 'temperatura', 293.0000, 'ºC'),
	(104804, 109, '2015-03-15 01:25:14.000000', 'temperatura', 336.0000, 'ºC'),
	(104805, 109, '2015-03-15 01:25:15.000000', 'temperatura', 799.0000, 'ºC'),
	(104806, 109, '2015-03-15 01:25:16.000000', 'temperatura', 587.0000, 'ºC'),
	(104807, 109, '2015-03-15 01:25:17.000000', 'temperatura', 539.0000, 'ºC'),
	(104808, 109, '2015-03-15 01:25:18.000000', 'temperatura', 937.0000, 'ºC'),
	(104809, 109, '2015-03-15 01:25:19.000000', 'temperatura', 667.0000, 'ºC'),
	(104810, 109, '2015-03-15 01:25:20.000000', 'temperatura', 525.0000, 'ºC'),
	(104811, 109, '2015-03-15 01:25:21.000000', 'temperatura', 624.0000, 'ºC'),
	(104812, 109, '2015-03-15 01:25:22.000000', 'temperatura', 344.0000, 'ºC'),
	(104813, 109, '2015-03-15 01:25:23.000000', 'temperatura', 1049.0000, 'ºC'),
	(104814, 109, '2015-03-15 01:25:24.000000', 'temperatura', 616.0000, 'ºC'),
	(104815, 109, '2015-03-15 01:25:25.000000', 'temperatura', 1130.0000, 'ºC'),
	(104816, 109, '2015-03-15 01:25:26.000000', 'temperatura', 205.0000, 'ºC'),
	(104817, 109, '2015-03-15 01:25:27.000000', 'temperatura', 33.0000, 'ºC'),
	(104818, 109, '2015-03-15 01:25:28.000000', 'temperatura', 753.0000, 'ºC'),
	(104819, 109, '2015-03-15 01:25:29.000000', 'temperatura', 66.0000, 'ºC'),
	(104820, 109, '2015-03-15 01:25:30.000000', 'temperatura', 473.0000, 'ºC'),
	(104821, 109, '2015-03-15 01:25:31.000000', 'temperatura', 966.0000, 'ºC'),
	(104822, 109, '2015-03-15 01:25:32.000000', 'temperatura', 1012.0000, 'ºC'),
	(104823, 109, '2015-03-15 01:25:33.000000', 'temperatura', 962.0000, 'ºC'),
	(104824, 109, '2015-03-15 01:25:34.000000', 'temperatura', 576.0000, 'ºC'),
	(104825, 109, '2015-03-15 01:25:35.000000', 'temperatura', 1192.0000, 'ºC'),
	(104826, 109, '2015-03-15 01:25:36.000000', 'temperatura', 632.0000, 'ºC'),
	(104827, 109, '2015-03-15 01:25:37.000000', 'temperatura', 786.0000, 'ºC'),
	(104828, 109, '2015-03-15 01:25:38.000000', 'temperatura', 833.0000, 'ºC'),
	(104829, 109, '2015-03-15 01:25:39.000000', 'temperatura', 609.0000, 'ºC'),
	(104830, 109, '2015-03-15 01:25:40.000000', 'temperatura', 545.0000, 'ºC'),
	(104831, 109, '2015-03-15 01:25:41.000000', 'temperatura', 898.0000, 'ºC'),
	(104832, 109, '2015-03-15 01:25:42.000000', 'temperatura', 457.0000, 'ºC'),
	(104833, 109, '2015-03-15 01:25:43.000000', 'temperatura', 793.0000, 'ºC'),
	(104834, 109, '2015-03-15 01:25:44.000000', 'temperatura', 192.0000, 'ºC'),
	(104835, 109, '2015-03-15 01:25:45.000000', 'temperatura', 982.0000, 'ºC'),
	(104836, 109, '2015-03-15 01:25:46.000000', 'temperatura', 734.0000, 'ºC'),
	(104837, 109, '2015-03-15 01:25:47.000000', 'temperatura', 726.0000, 'ºC'),
	(104838, 109, '2015-03-15 01:25:48.000000', 'temperatura', 230.0000, 'ºC'),
	(104839, 109, '2015-03-15 01:25:49.000000', 'temperatura', 169.0000, 'ºC'),
	(104840, 109, '2015-03-15 01:25:50.000000', 'temperatura', 158.0000, 'ºC'),
	(104841, 109, '2015-03-15 01:25:51.000000', 'temperatura', 281.0000, 'ºC'),
	(104842, 109, '2015-03-15 01:25:52.000000', 'temperatura', 931.0000, 'ºC'),
	(104843, 109, '2015-03-15 01:25:53.000000', 'temperatura', 216.0000, 'ºC'),
	(104844, 109, '2015-03-15 01:25:54.000000', 'temperatura', 685.0000, 'ºC'),
	(104845, 109, '2015-03-15 01:25:55.000000', 'temperatura', 376.0000, 'ºC'),
	(104846, 109, '2015-03-15 01:25:56.000000', 'temperatura', 1028.0000, 'ºC'),
	(104847, 109, '2015-03-15 01:25:57.000000', 'temperatura', 413.0000, 'ºC'),
	(104848, 109, '2015-03-15 01:25:58.000000', 'temperatura', 182.0000, 'ºC'),
	(104849, 109, '2015-03-15 01:25:59.000000', 'temperatura', 868.0000, 'ºC'),
	(104850, 109, '2015-03-15 01:26:00.000000', 'temperatura', 198.0000, 'ºC'),
	(104851, 109, '2015-03-15 01:26:01.000000', 'temperatura', 786.0000, 'ºC'),
	(104852, 109, '2015-03-15 01:26:02.000000', 'temperatura', 937.0000, 'ºC'),
	(104853, 109, '2015-03-15 01:26:03.000000', 'temperatura', 1128.0000, 'ºC'),
	(104854, 109, '2015-03-15 01:26:04.000000', 'temperatura', 428.0000, 'ºC'),
	(104855, 109, '2015-03-15 01:26:05.000000', 'temperatura', 1156.0000, 'ºC'),
	(104856, 109, '2015-03-15 01:26:06.000000', 'temperatura', 897.0000, 'ºC'),
	(104857, 109, '2015-03-15 01:26:07.000000', 'temperatura', 1017.0000, 'ºC'),
	(104858, 109, '2015-03-15 01:26:08.000000', 'temperatura', 1193.0000, 'ºC'),
	(104859, 109, '2015-03-15 01:26:09.000000', 'temperatura', 516.0000, 'ºC'),
	(104860, 109, '2015-03-15 01:26:10.000000', 'temperatura', 202.0000, 'ºC'),
	(104861, 109, '2015-03-15 01:26:11.000000', 'temperatura', 662.0000, 'ºC'),
	(104862, 109, '2015-03-15 01:26:12.000000', 'temperatura', 302.0000, 'ºC'),
	(104863, 109, '2015-03-15 01:26:13.000000', 'temperatura', 728.0000, 'ºC'),
	(104864, 109, '2015-03-15 01:26:14.000000', 'temperatura', 333.0000, 'ºC'),
	(104865, 109, '2015-03-15 01:26:15.000000', 'temperatura', 684.0000, 'ºC'),
	(104866, 109, '2015-03-15 01:26:16.000000', 'temperatura', 19.0000, 'ºC'),
	(104867, 109, '2015-03-15 01:26:17.000000', 'temperatura', 443.0000, 'ºC'),
	(104868, 109, '2015-03-15 01:26:18.000000', 'temperatura', 960.0000, 'ºC'),
	(104869, 109, '2015-03-15 01:26:19.000000', 'temperatura', 1069.0000, 'ºC'),
	(104870, 109, '2015-03-15 01:26:20.000000', 'temperatura', 68.0000, 'ºC'),
	(104871, 109, '2015-03-15 01:26:21.000000', 'temperatura', 731.0000, 'ºC'),
	(104872, 109, '2015-03-15 01:26:22.000000', 'temperatura', 1054.0000, 'ºC'),
	(104873, 109, '2015-03-15 01:26:23.000000', 'temperatura', 677.0000, 'ºC'),
	(104874, 109, '2015-03-15 01:26:24.000000', 'temperatura', 223.0000, 'ºC'),
	(104875, 109, '2015-03-15 01:26:25.000000', 'temperatura', 286.0000, 'ºC'),
	(104876, 109, '2015-03-15 01:26:26.000000', 'temperatura', 761.0000, 'ºC'),
	(104877, 109, '2015-03-15 01:26:27.000000', 'temperatura', 548.0000, 'ºC'),
	(104878, 109, '2015-03-15 01:26:28.000000', 'temperatura', 457.0000, 'ºC'),
	(104879, 109, '2015-03-15 01:26:29.000000', 'temperatura', 641.0000, 'ºC'),
	(104880, 109, '2015-03-15 01:26:30.000000', 'temperatura', 636.0000, 'ºC'),
	(104881, 109, '2015-03-15 01:26:31.000000', 'temperatura', 55.0000, 'ºC'),
	(104882, 109, '2015-03-15 01:26:32.000000', 'temperatura', 767.0000, 'ºC'),
	(104883, 109, '2015-03-15 01:26:33.000000', 'temperatura', 72.0000, 'ºC'),
	(104884, 109, '2015-03-15 01:26:34.000000', 'temperatura', 458.0000, 'ºC'),
	(104885, 109, '2015-03-15 01:26:35.000000', 'temperatura', 877.0000, 'ºC'),
	(104886, 109, '2015-03-15 01:26:36.000000', 'temperatura', 610.0000, 'ºC'),
	(104887, 109, '2015-03-15 01:26:37.000000', 'temperatura', 420.0000, 'ºC'),
	(104888, 109, '2015-03-15 01:26:38.000000', 'temperatura', 270.0000, 'ºC'),
	(104889, 109, '2015-03-15 01:26:39.000000', 'temperatura', 92.0000, 'ºC'),
	(104890, 109, '2015-03-15 01:26:40.000000', 'temperatura', 850.0000, 'ºC'),
	(104891, 109, '2015-03-15 01:26:41.000000', 'temperatura', 376.0000, 'ºC'),
	(104892, 109, '2015-03-15 01:26:42.000000', 'temperatura', 528.0000, 'ºC'),
	(104893, 109, '2015-03-15 01:26:43.000000', 'temperatura', 314.0000, 'ºC'),
	(104894, 109, '2015-03-15 01:26:44.000000', 'temperatura', 1184.0000, 'ºC'),
	(104895, 109, '2015-03-15 01:26:45.000000', 'temperatura', 180.0000, 'ºC'),
	(104896, 109, '2015-03-15 01:26:46.000000', 'temperatura', 947.0000, 'ºC'),
	(104897, 109, '2015-03-15 01:26:47.000000', 'temperatura', 597.0000, 'ºC'),
	(104898, 109, '2015-03-15 01:26:48.000000', 'temperatura', 144.0000, 'ºC'),
	(104899, 109, '2015-03-15 01:26:49.000000', 'temperatura', 132.0000, 'ºC'),
	(104900, 109, '2015-03-15 01:26:50.000000', 'temperatura', 226.0000, 'ºC'),
	(104901, 109, '2015-03-15 01:26:51.000000', 'temperatura', 733.0000, 'ºC'),
	(104902, 109, '2015-03-15 01:26:52.000000', 'temperatura', 590.0000, 'ºC'),
	(104903, 109, '2015-03-15 01:26:53.000000', 'temperatura', 752.0000, 'ºC'),
	(104904, 109, '2015-03-15 01:26:54.000000', 'temperatura', 788.0000, 'ºC'),
	(104905, 109, '2015-03-15 01:26:55.000000', 'temperatura', 486.0000, 'ºC'),
	(104906, 109, '2015-03-15 01:26:56.000000', 'temperatura', 65.0000, 'ºC'),
	(104907, 109, '2015-03-15 01:26:57.000000', 'temperatura', 69.0000, 'ºC'),
	(104908, 109, '2015-03-15 01:26:58.000000', 'temperatura', 152.0000, 'ºC'),
	(104909, 109, '2015-03-15 01:26:59.000000', 'temperatura', 550.0000, 'ºC'),
	(104910, 109, '2015-03-15 01:27:00.000000', 'temperatura', 1096.0000, 'ºC'),
	(104911, 109, '2015-03-15 01:27:01.000000', 'temperatura', 232.0000, 'ºC'),
	(104912, 109, '2015-03-15 01:27:02.000000', 'temperatura', 272.0000, 'ºC'),
	(104913, 109, '2015-03-15 01:27:03.000000', 'temperatura', 666.0000, 'ºC'),
	(104914, 109, '2015-03-15 01:27:04.000000', 'temperatura', 111.0000, 'ºC'),
	(104915, 109, '2015-03-15 01:27:05.000000', 'temperatura', 961.0000, 'ºC'),
	(104916, 109, '2015-03-15 01:27:06.000000', 'temperatura', 871.0000, 'ºC'),
	(104917, 109, '2015-03-15 01:27:07.000000', 'temperatura', 273.0000, 'ºC'),
	(104918, 109, '2015-03-15 01:27:08.000000', 'temperatura', 1154.0000, 'ºC'),
	(104919, 109, '2015-03-15 01:27:09.000000', 'temperatura', 150.0000, 'ºC'),
	(104920, 109, '2015-03-15 01:27:10.000000', 'temperatura', 891.0000, 'ºC'),
	(104921, 109, '2015-03-15 01:27:11.000000', 'temperatura', 403.0000, 'ºC'),
	(104922, 109, '2015-03-15 01:27:12.000000', 'temperatura', 543.0000, 'ºC'),
	(104923, 109, '2015-03-15 01:27:13.000000', 'temperatura', 308.0000, 'ºC'),
	(104924, 109, '2015-03-15 01:27:14.000000', 'temperatura', 1113.0000, 'ºC'),
	(104925, 109, '2015-03-15 01:27:15.000000', 'temperatura', 1038.0000, 'ºC'),
	(104926, 109, '2015-03-15 01:27:16.000000', 'temperatura', 652.0000, 'ºC'),
	(104927, 109, '2015-03-15 01:27:17.000000', 'temperatura', 147.0000, 'ºC'),
	(104928, 109, '2015-03-15 01:27:18.000000', 'temperatura', 1180.0000, 'ºC'),
	(104929, 109, '2015-03-15 01:27:19.000000', 'temperatura', 659.0000, 'ºC'),
	(104930, 109, '2015-03-15 01:27:20.000000', 'temperatura', 957.0000, 'ºC'),
	(104931, 109, '2015-03-15 01:27:21.000000', 'temperatura', 410.0000, 'ºC'),
	(104932, 109, '2015-03-15 01:27:22.000000', 'temperatura', 376.0000, 'ºC'),
	(104933, 109, '2015-03-15 01:27:23.000000', 'temperatura', 651.0000, 'ºC'),
	(104934, 109, '2015-03-15 01:27:24.000000', 'temperatura', 927.0000, 'ºC'),
	(104935, 109, '2015-03-15 01:27:25.000000', 'temperatura', 283.0000, 'ºC'),
	(104936, 109, '2015-03-15 01:27:26.000000', 'temperatura', 1034.0000, 'ºC'),
	(104937, 109, '2015-03-15 01:27:27.000000', 'temperatura', 723.0000, 'ºC'),
	(104938, 109, '2015-03-15 01:27:28.000000', 'temperatura', 511.0000, 'ºC'),
	(104939, 109, '2015-03-15 01:27:29.000000', 'temperatura', 387.0000, 'ºC'),
	(104940, 109, '2015-03-15 01:27:30.000000', 'temperatura', 405.0000, 'ºC'),
	(104941, 109, '2015-03-15 01:27:31.000000', 'temperatura', 863.0000, 'ºC'),
	(104942, 109, '2015-03-15 01:27:32.000000', 'temperatura', 699.0000, 'ºC'),
	(104943, 109, '2015-03-15 01:27:33.000000', 'temperatura', 909.0000, 'ºC'),
	(104944, 109, '2015-03-15 01:27:34.000000', 'temperatura', 49.0000, 'ºC'),
	(104945, 109, '2015-03-15 01:27:35.000000', 'temperatura', 1117.0000, 'ºC'),
	(104946, 109, '2015-03-15 01:27:36.000000', 'temperatura', 638.0000, 'ºC'),
	(104947, 109, '2015-03-15 01:27:37.000000', 'temperatura', 1039.0000, 'ºC'),
	(104948, 109, '2015-03-15 01:27:38.000000', 'temperatura', 881.0000, 'ºC'),
	(104949, 109, '2015-03-15 01:27:39.000000', 'temperatura', 90.0000, 'ºC'),
	(104950, 109, '2015-03-15 01:27:40.000000', 'temperatura', 208.0000, 'ºC'),
	(104951, 109, '2015-03-15 01:27:41.000000', 'temperatura', 772.0000, 'ºC'),
	(104952, 109, '2015-03-15 01:27:42.000000', 'temperatura', 835.0000, 'ºC'),
	(104953, 109, '2015-03-15 01:27:43.000000', 'temperatura', 657.0000, 'ºC'),
	(104954, 109, '2015-03-15 01:27:44.000000', 'temperatura', 784.0000, 'ºC'),
	(104955, 109, '2015-03-15 01:27:45.000000', 'temperatura', 749.0000, 'ºC'),
	(104956, 109, '2015-03-15 01:27:46.000000', 'temperatura', 194.0000, 'ºC'),
	(104957, 109, '2015-03-15 01:27:47.000000', 'temperatura', 1125.0000, 'ºC'),
	(104958, 109, '2015-03-15 01:27:48.000000', 'temperatura', 241.0000, 'ºC'),
	(104959, 109, '2015-03-15 01:27:49.000000', 'temperatura', 230.0000, 'ºC'),
	(104960, 109, '2015-03-15 01:27:50.000000', 'temperatura', 428.0000, 'ºC'),
	(104961, 109, '2015-03-15 01:27:51.000000', 'temperatura', 250.0000, 'ºC'),
	(104962, 109, '2015-03-15 01:27:52.000000', 'temperatura', 1165.0000, 'ºC'),
	(104963, 109, '2015-03-15 01:27:53.000000', 'temperatura', 277.0000, 'ºC'),
	(104964, 109, '2015-03-15 01:27:54.000000', 'temperatura', 290.0000, 'ºC'),
	(104965, 109, '2015-03-15 01:27:55.000000', 'temperatura', 621.0000, 'ºC'),
	(104966, 109, '2015-03-15 01:27:56.000000', 'temperatura', 1033.0000, 'ºC'),
	(104967, 109, '2015-03-15 01:27:57.000000', 'temperatura', 902.0000, 'ºC'),
	(104968, 109, '2015-03-15 01:27:58.000000', 'temperatura', 214.0000, 'ºC'),
	(104969, 109, '2015-03-15 01:27:59.000000', 'temperatura', 765.0000, 'ºC'),
	(104970, 109, '2015-03-15 01:28:00.000000', 'temperatura', 783.0000, 'ºC'),
	(104971, 109, '2015-03-15 01:28:01.000000', 'temperatura', 418.0000, 'ºC'),
	(104972, 109, '2015-03-15 01:28:02.000000', 'temperatura', 944.0000, 'ºC'),
	(104973, 109, '2015-03-15 01:28:03.000000', 'temperatura', 1068.0000, 'ºC'),
	(104974, 109, '2015-03-15 01:28:04.000000', 'temperatura', 106.0000, 'ºC'),
	(104975, 109, '2015-03-15 01:28:05.000000', 'temperatura', 927.0000, 'ºC'),
	(104976, 109, '2015-03-15 01:28:06.000000', 'temperatura', 716.0000, 'ºC'),
	(104977, 109, '2015-03-15 01:28:07.000000', 'temperatura', 802.0000, 'ºC'),
	(104978, 109, '2015-03-15 01:28:08.000000', 'temperatura', 661.0000, 'ºC'),
	(104979, 109, '2015-03-15 01:28:09.000000', 'temperatura', 898.0000, 'ºC'),
	(104980, 109, '2015-03-15 01:28:10.000000', 'temperatura', 108.0000, 'ºC'),
	(104981, 109, '2015-03-15 01:28:11.000000', 'temperatura', 249.0000, 'ºC'),
	(104982, 109, '2015-03-15 01:28:12.000000', 'temperatura', 919.0000, 'ºC'),
	(104983, 109, '2015-03-15 01:28:13.000000', 'temperatura', 247.0000, 'ºC'),
	(104984, 109, '2015-03-15 01:28:14.000000', 'temperatura', 881.0000, 'ºC'),
	(104985, 109, '2015-03-15 01:28:15.000000', 'temperatura', 66.0000, 'ºC'),
	(104986, 109, '2015-03-15 01:28:16.000000', 'temperatura', 85.0000, 'ºC'),
	(104987, 109, '2015-03-15 01:28:17.000000', 'temperatura', 226.0000, 'ºC'),
	(104988, 109, '2015-03-15 01:28:18.000000', 'temperatura', 879.0000, 'ºC'),
	(104989, 109, '2015-03-15 01:28:19.000000', 'temperatura', 116.0000, 'ºC'),
	(104990, 109, '2015-03-15 01:28:20.000000', 'temperatura', 343.0000, 'ºC'),
	(104991, 109, '2015-03-15 01:28:21.000000', 'temperatura', 166.0000, 'ºC'),
	(104992, 109, '2015-03-15 01:28:22.000000', 'temperatura', 1003.0000, 'ºC'),
	(104993, 109, '2015-03-15 01:28:23.000000', 'temperatura', 918.0000, 'ºC'),
	(104994, 109, '2015-03-15 01:28:24.000000', 'temperatura', 379.0000, 'ºC'),
	(104995, 109, '2015-03-15 01:28:25.000000', 'temperatura', 344.0000, 'ºC'),
	(104996, 109, '2015-03-15 01:28:26.000000', 'temperatura', 583.0000, 'ºC'),
	(104997, 109, '2015-03-15 01:28:27.000000', 'temperatura', 682.0000, 'ºC'),
	(104998, 109, '2015-03-15 01:28:28.000000', 'temperatura', 462.0000, 'ºC'),
	(104999, 109, '2015-03-15 01:28:29.000000', 'temperatura', 263.0000, 'ºC'),
	(105000, 109, '2015-03-15 01:28:30.000000', 'temperatura', 1130.0000, 'ºC'),
	(105001, 109, '2015-03-15 01:28:31.000000', 'temperatura', 63.0000, 'ºC'),
	(105002, 109, '2015-03-15 01:28:32.000000', 'temperatura', 526.0000, 'ºC'),
	(105003, 109, '2015-03-15 01:28:33.000000', 'temperatura', 40.0000, 'ºC'),
	(105004, 109, '2015-03-15 01:28:34.000000', 'temperatura', 1023.0000, 'ºC'),
	(105005, 109, '2015-03-15 01:28:35.000000', 'temperatura', 196.0000, 'ºC'),
	(105006, 109, '2015-03-15 01:28:36.000000', 'temperatura', 309.0000, 'ºC'),
	(105007, 109, '2015-03-15 01:28:37.000000', 'temperatura', 961.0000, 'ºC'),
	(105008, 109, '2015-03-15 01:28:38.000000', 'temperatura', 278.0000, 'ºC'),
	(105009, 109, '2015-03-15 01:28:39.000000', 'temperatura', 905.0000, 'ºC'),
	(105010, 109, '2015-03-15 01:28:40.000000', 'temperatura', 92.0000, 'ºC'),
	(105011, 109, '2015-03-15 01:28:41.000000', 'temperatura', 147.0000, 'ºC'),
	(105012, 109, '2015-03-15 01:28:42.000000', 'temperatura', 458.0000, 'ºC'),
	(105013, 109, '2015-03-15 01:28:43.000000', 'temperatura', 649.0000, 'ºC'),
	(105014, 109, '2015-03-15 01:28:44.000000', 'temperatura', 672.0000, 'ºC'),
	(105015, 109, '2015-03-15 01:28:45.000000', 'temperatura', 213.0000, 'ºC'),
	(105016, 109, '2015-03-15 01:28:46.000000', 'temperatura', 251.0000, 'ºC'),
	(105017, 109, '2015-03-15 01:28:47.000000', 'temperatura', 616.0000, 'ºC'),
	(105018, 109, '2015-03-15 01:28:48.000000', 'temperatura', 1127.0000, 'ºC'),
	(105019, 109, '2015-03-15 01:28:49.000000', 'temperatura', 189.0000, 'ºC'),
	(105020, 109, '2015-03-15 01:28:50.000000', 'temperatura', 1163.0000, 'ºC'),
	(105021, 109, '2015-03-15 01:28:51.000000', 'temperatura', 450.0000, 'ºC'),
	(105022, 109, '2015-03-15 01:28:52.000000', 'temperatura', 1160.0000, 'ºC'),
	(105023, 109, '2015-03-15 01:28:53.000000', 'temperatura', 852.0000, 'ºC'),
	(105024, 109, '2015-03-15 01:28:54.000000', 'temperatura', 779.0000, 'ºC'),
	(105025, 109, '2015-03-15 01:28:55.000000', 'temperatura', 141.0000, 'ºC'),
	(105026, 109, '2015-03-15 01:28:56.000000', 'temperatura', 769.0000, 'ºC'),
	(105027, 109, '2015-03-15 01:28:57.000000', 'temperatura', 1023.0000, 'ºC'),
	(105028, 109, '2015-03-15 01:28:58.000000', 'temperatura', 408.0000, 'ºC'),
	(105029, 109, '2015-03-15 01:28:59.000000', 'temperatura', 170.0000, 'ºC'),
	(105030, 109, '2015-03-15 01:29:00.000000', 'temperatura', 828.0000, 'ºC'),
	(105031, 109, '2015-03-15 01:29:01.000000', 'temperatura', 32.0000, 'ºC'),
	(105032, 109, '2015-03-15 01:29:02.000000', 'temperatura', 75.0000, 'ºC'),
	(105033, 109, '2015-03-15 01:29:03.000000', 'temperatura', 282.0000, 'ºC'),
	(105034, 109, '2015-03-15 01:29:04.000000', 'temperatura', 1182.0000, 'ºC'),
	(105035, 109, '2015-03-15 01:29:05.000000', 'temperatura', 265.0000, 'ºC'),
	(105036, 109, '2015-03-15 01:29:06.000000', 'temperatura', 178.0000, 'ºC'),
	(105037, 109, '2015-03-15 01:29:07.000000', 'temperatura', 99.0000, 'ºC'),
	(105038, 109, '2015-03-15 01:29:08.000000', 'temperatura', 1159.0000, 'ºC'),
	(105039, 109, '2015-03-15 01:29:09.000000', 'temperatura', 698.0000, 'ºC'),
	(105040, 109, '2015-03-15 01:29:10.000000', 'temperatura', 14.0000, 'ºC'),
	(105041, 109, '2015-03-15 01:29:11.000000', 'temperatura', 375.0000, 'ºC'),
	(105042, 109, '2015-03-15 01:29:12.000000', 'temperatura', 634.0000, 'ºC'),
	(105043, 109, '2015-03-15 01:29:13.000000', 'temperatura', 845.0000, 'ºC'),
	(105044, 109, '2015-03-15 01:29:14.000000', 'temperatura', 1124.0000, 'ºC'),
	(105045, 109, '2015-03-15 01:29:15.000000', 'temperatura', 685.0000, 'ºC'),
	(105046, 109, '2015-03-15 01:29:16.000000', 'temperatura', 52.0000, 'ºC'),
	(105047, 109, '2015-03-15 01:29:17.000000', 'temperatura', 607.0000, 'ºC'),
	(105048, 109, '2015-03-15 01:29:18.000000', 'temperatura', 480.0000, 'ºC'),
	(105049, 109, '2015-03-15 01:29:19.000000', 'temperatura', 581.0000, 'ºC'),
	(105050, 109, '2015-03-15 01:29:20.000000', 'temperatura', 262.0000, 'ºC'),
	(105051, 109, '2015-03-15 01:29:21.000000', 'temperatura', 770.0000, 'ºC'),
	(105052, 109, '2015-03-15 01:29:22.000000', 'temperatura', 662.0000, 'ºC'),
	(105053, 109, '2015-03-15 01:29:23.000000', 'temperatura', 1001.0000, 'ºC'),
	(105054, 109, '2015-03-15 01:29:24.000000', 'temperatura', 621.0000, 'ºC'),
	(105055, 109, '2015-03-15 01:29:25.000000', 'temperatura', 100.0000, 'ºC'),
	(105056, 109, '2015-03-15 01:29:26.000000', 'temperatura', 1041.0000, 'ºC'),
	(105057, 109, '2015-03-15 01:29:27.000000', 'temperatura', 103.0000, 'ºC'),
	(105058, 109, '2015-03-15 01:29:28.000000', 'temperatura', 994.0000, 'ºC'),
	(105059, 109, '2015-03-15 01:29:29.000000', 'temperatura', 1059.0000, 'ºC'),
	(105060, 109, '2015-03-15 01:29:30.000000', 'temperatura', 1115.0000, 'ºC'),
	(105061, 109, '2015-03-15 01:29:31.000000', 'temperatura', 1197.0000, 'ºC'),
	(105062, 109, '2015-03-15 01:29:32.000000', 'temperatura', 242.0000, 'ºC'),
	(105063, 109, '2015-03-15 01:29:33.000000', 'temperatura', 18.0000, 'ºC'),
	(105064, 109, '2015-03-15 01:29:34.000000', 'temperatura', 567.0000, 'ºC'),
	(105065, 109, '2015-03-15 01:29:35.000000', 'temperatura', 379.0000, 'ºC'),
	(105066, 109, '2015-03-15 01:29:36.000000', 'temperatura', 196.0000, 'ºC'),
	(105067, 109, '2015-03-15 01:29:37.000000', 'temperatura', 1042.0000, 'ºC'),
	(105068, 109, '2015-03-15 01:29:38.000000', 'temperatura', 1023.0000, 'ºC'),
	(105069, 109, '2015-03-15 01:29:39.000000', 'temperatura', 791.0000, 'ºC'),
	(105070, 109, '2015-03-15 01:29:40.000000', 'temperatura', 884.0000, 'ºC'),
	(105071, 109, '2015-03-15 01:29:41.000000', 'temperatura', 849.0000, 'ºC'),
	(105072, 109, '2015-03-15 01:29:42.000000', 'temperatura', 395.0000, 'ºC'),
	(105073, 109, '2015-03-15 01:29:43.000000', 'temperatura', 627.0000, 'ºC'),
	(105074, 109, '2015-03-15 01:29:44.000000', 'temperatura', 749.0000, 'ºC'),
	(105075, 109, '2015-03-15 01:29:45.000000', 'temperatura', 665.0000, 'ºC'),
	(105076, 109, '2015-03-15 01:29:46.000000', 'temperatura', 1077.0000, 'ºC'),
	(105077, 109, '2015-03-15 01:29:47.000000', 'temperatura', 992.0000, 'ºC'),
	(105078, 109, '2015-03-15 01:29:48.000000', 'temperatura', 531.0000, 'ºC'),
	(105079, 109, '2015-03-15 01:29:49.000000', 'temperatura', 877.0000, 'ºC'),
	(105080, 109, '2015-03-15 01:29:50.000000', 'temperatura', 392.0000, 'ºC'),
	(105081, 109, '2015-03-15 01:29:51.000000', 'temperatura', 532.0000, 'ºC'),
	(105082, 109, '2015-03-15 01:29:52.000000', 'temperatura', 283.0000, 'ºC'),
	(105083, 109, '2015-03-15 01:29:53.000000', 'temperatura', 1019.0000, 'ºC'),
	(105084, 109, '2015-03-15 01:29:54.000000', 'temperatura', 647.0000, 'ºC'),
	(105085, 109, '2015-03-15 01:29:55.000000', 'temperatura', 177.0000, 'ºC'),
	(105086, 109, '2015-03-15 01:29:56.000000', 'temperatura', 147.0000, 'ºC'),
	(105087, 109, '2015-03-15 01:29:57.000000', 'temperatura', 201.0000, 'ºC'),
	(105088, 109, '2015-03-15 01:29:58.000000', 'temperatura', 568.0000, 'ºC'),
	(105089, 109, '2015-03-15 01:29:59.000000', 'temperatura', 1036.0000, 'ºC'),
	(105090, 109, '2015-03-15 01:30:00.000000', 'temperatura', 1078.0000, 'ºC'),
	(105091, 109, '2015-03-15 01:30:01.000000', 'temperatura', 1081.0000, 'ºC'),
	(105092, 109, '2015-03-15 01:30:02.000000', 'temperatura', 974.0000, 'ºC'),
	(105093, 109, '2015-03-15 01:30:03.000000', 'temperatura', 424.0000, 'ºC'),
	(105094, 109, '2015-03-15 01:30:04.000000', 'temperatura', 400.0000, 'ºC'),
	(105095, 109, '2015-03-15 01:30:05.000000', 'temperatura', 727.0000, 'ºC'),
	(105096, 109, '2015-03-15 01:30:06.000000', 'temperatura', 37.0000, 'ºC'),
	(105097, 109, '2015-03-15 01:30:07.000000', 'temperatura', 406.0000, 'ºC'),
	(105098, 109, '2015-03-15 01:30:08.000000', 'temperatura', 716.0000, 'ºC'),
	(105099, 109, '2015-03-15 01:30:09.000000', 'temperatura', 1165.0000, 'ºC'),
	(105100, 109, '2015-03-15 01:30:10.000000', 'temperatura', 75.0000, 'ºC'),
	(105101, 109, '2015-03-15 01:30:11.000000', 'temperatura', 483.0000, 'ºC'),
	(105102, 109, '2015-03-15 01:30:12.000000', 'temperatura', 989.0000, 'ºC'),
	(105103, 109, '2015-03-15 01:30:13.000000', 'temperatura', 1098.0000, 'ºC'),
	(105104, 109, '2015-03-15 01:30:14.000000', 'temperatura', 124.0000, 'ºC'),
	(105105, 109, '2015-03-15 01:30:15.000000', 'temperatura', 926.0000, 'ºC'),
	(105106, 109, '2015-03-15 01:30:16.000000', 'temperatura', 659.0000, 'ºC'),
	(105107, 109, '2015-03-15 01:30:17.000000', 'temperatura', 518.0000, 'ºC'),
	(105108, 109, '2015-03-15 01:30:18.000000', 'temperatura', 613.0000, 'ºC'),
	(105109, 109, '2015-03-15 01:30:19.000000', 'temperatura', 312.0000, 'ºC'),
	(105110, 109, '2015-03-15 01:30:20.000000', 'temperatura', 921.0000, 'ºC'),
	(105111, 109, '2015-03-15 01:30:21.000000', 'temperatura', 70.0000, 'ºC'),
	(105112, 109, '2015-03-15 01:30:22.000000', 'temperatura', 1187.0000, 'ºC'),
	(105113, 109, '2015-03-15 01:30:23.000000', 'temperatura', 928.0000, 'ºC'),
	(105114, 109, '2015-03-15 01:30:24.000000', 'temperatura', 1076.0000, 'ºC'),
	(105115, 109, '2015-03-15 01:30:25.000000', 'temperatura', 199.0000, 'ºC'),
	(105116, 109, '2015-03-15 01:30:26.000000', 'temperatura', 168.0000, 'ºC'),
	(105117, 109, '2015-03-15 01:30:27.000000', 'temperatura', 243.0000, 'ºC'),
	(105118, 109, '2015-03-15 01:30:28.000000', 'temperatura', 709.0000, 'ºC'),
	(105119, 109, '2015-03-15 01:30:29.000000', 'temperatura', 419.0000, 'ºC'),
	(105120, 109, '2015-03-15 01:30:30.000000', 'temperatura', 1169.0000, 'ºC'),
	(105121, 109, '2015-03-15 01:30:31.000000', 'temperatura', 987.0000, 'ºC'),
	(105122, 109, '2015-03-15 01:30:32.000000', 'temperatura', 230.0000, 'ºC'),
	(105123, 109, '2015-03-15 01:30:33.000000', 'temperatura', 588.0000, 'ºC'),
	(105124, 109, '2015-03-15 01:30:34.000000', 'temperatura', 1052.0000, 'ºC'),
	(105125, 109, '2015-03-15 01:30:35.000000', 'temperatura', 1095.0000, 'ºC'),
	(105126, 109, '2015-03-15 01:30:36.000000', 'temperatura', 1121.0000, 'ºC'),
	(105127, 109, '2015-03-15 01:30:37.000000', 'temperatura', 1119.0000, 'ºC'),
	(105128, 109, '2015-03-15 01:30:38.000000', 'temperatura', 1033.0000, 'ºC'),
	(105129, 109, '2015-03-15 01:30:39.000000', 'temperatura', 609.0000, 'ºC'),
	(105130, 109, '2015-03-15 01:30:40.000000', 'temperatura', 1145.0000, 'ºC'),
	(105131, 109, '2015-03-15 01:30:41.000000', 'temperatura', 297.0000, 'ºC'),
	(105132, 109, '2015-03-15 01:30:42.000000', 'temperatura', 453.0000, 'ºC'),
	(105133, 109, '2015-03-15 01:30:43.000000', 'temperatura', 174.0000, 'ºC'),
	(105134, 109, '2015-03-15 01:30:44.000000', 'temperatura', 713.0000, 'ºC'),
	(105135, 109, '2015-03-15 01:30:45.000000', 'temperatura', 641.0000, 'ºC'),
	(105136, 109, '2015-03-15 01:30:46.000000', 'temperatura', 1069.0000, 'ºC'),
	(105137, 109, '2015-03-15 01:30:47.000000', 'temperatura', 1020.0000, 'ºC'),
	(105138, 109, '2015-03-15 01:30:48.000000', 'temperatura', 694.0000, 'ºC'),
	(105139, 109, '2015-03-15 01:30:49.000000', 'temperatura', 412.0000, 'ºC'),
	(105140, 109, '2015-03-15 01:30:50.000000', 'temperatura', 1176.0000, 'ºC'),
	(105141, 109, '2015-03-15 01:30:51.000000', 'temperatura', 1047.0000, 'ºC'),
	(105142, 109, '2015-03-15 01:30:52.000000', 'temperatura', 506.0000, 'ºC'),
	(105143, 109, '2015-03-15 01:30:53.000000', 'temperatura', 591.0000, 'ºC'),
	(105144, 109, '2015-03-15 01:30:54.000000', 'temperatura', 238.0000, 'ºC'),
	(105145, 109, '2015-03-15 01:30:55.000000', 'temperatura', 616.0000, 'ºC'),
	(105146, 109, '2015-03-15 01:30:56.000000', 'temperatura', 1165.0000, 'ºC'),
	(105147, 109, '2015-03-15 01:30:57.000000', 'temperatura', 378.0000, 'ºC'),
	(105148, 109, '2015-03-15 01:30:58.000000', 'temperatura', 797.0000, 'ºC'),
	(105149, 109, '2015-03-15 01:30:59.000000', 'temperatura', 449.0000, 'ºC'),
	(105150, 109, '2015-03-15 01:31:00.000000', 'temperatura', 1057.0000, 'ºC'),
	(105151, 109, '2015-03-15 01:31:01.000000', 'temperatura', 336.0000, 'ºC'),
	(105152, 109, '2015-03-15 01:31:02.000000', 'temperatura', 912.0000, 'ºC'),
	(105153, 109, '2015-03-15 01:31:03.000000', 'temperatura', 1153.0000, 'ºC'),
	(105154, 109, '2015-03-15 01:31:04.000000', 'temperatura', 630.0000, 'ºC'),
	(105155, 109, '2015-03-15 01:31:05.000000', 'temperatura', 891.0000, 'ºC'),
	(105156, 109, '2015-03-15 01:31:06.000000', 'temperatura', 165.0000, 'ºC'),
	(105157, 109, '2015-03-15 01:31:07.000000', 'temperatura', 551.0000, 'ºC'),
	(105158, 109, '2015-03-15 01:31:08.000000', 'temperatura', 1060.0000, 'ºC'),
	(105159, 109, '2015-03-15 01:31:09.000000', 'temperatura', 47.0000, 'ºC'),
	(105160, 109, '2015-03-15 01:31:10.000000', 'temperatura', 656.0000, 'ºC'),
	(105161, 109, '2015-03-15 01:31:11.000000', 'temperatura', 739.0000, 'ºC'),
	(105162, 109, '2015-03-15 01:31:12.000000', 'temperatura', 530.0000, 'ºC'),
	(105163, 109, '2015-03-15 01:31:13.000000', 'temperatura', 433.0000, 'ºC'),
	(105164, 109, '2015-03-15 01:31:14.000000', 'temperatura', 573.0000, 'ºC'),
	(105165, 109, '2015-03-15 01:31:15.000000', 'temperatura', 368.0000, 'ºC'),
	(105166, 109, '2015-03-15 01:31:16.000000', 'temperatura', 123.0000, 'ºC'),
	(105167, 109, '2015-03-15 01:31:17.000000', 'temperatura', 710.0000, 'ºC'),
	(105168, 109, '2015-03-15 01:31:18.000000', 'temperatura', 782.0000, 'ºC'),
	(105169, 109, '2015-03-15 01:31:19.000000', 'temperatura', 581.0000, 'ºC'),
	(105170, 109, '2015-03-15 01:31:20.000000', 'temperatura', 561.0000, 'ºC'),
	(105171, 109, '2015-03-15 01:31:21.000000', 'temperatura', 1061.0000, 'ºC'),
	(105172, 109, '2015-03-15 01:31:22.000000', 'temperatura', 24.0000, 'ºC'),
	(105173, 109, '2015-03-15 01:31:23.000000', 'temperatura', 535.0000, 'ºC'),
	(105174, 109, '2015-03-15 01:31:24.000000', 'temperatura', 204.0000, 'ºC'),
	(105175, 109, '2015-03-15 01:31:25.000000', 'temperatura', 617.0000, 'ºC'),
	(105176, 109, '2015-03-15 01:31:26.000000', 'temperatura', 74.0000, 'ºC'),
	(105177, 109, '2015-03-15 01:31:27.000000', 'temperatura', 920.0000, 'ºC'),
	(105178, 109, '2015-03-15 01:31:28.000000', 'temperatura', 776.0000, 'ºC'),
	(105179, 109, '2015-03-15 01:31:29.000000', 'temperatura', 1120.0000, 'ºC'),
	(105180, 109, '2015-03-15 01:31:30.000000', 'temperatura', 876.0000, 'ºC'),
	(105181, 109, '2015-03-15 01:31:31.000000', 'temperatura', 1017.0000, 'ºC'),
	(105182, 109, '2015-03-15 01:31:32.000000', 'temperatura', 59.0000, 'ºC'),
	(105183, 109, '2015-03-15 01:31:33.000000', 'temperatura', 846.0000, 'ºC'),
	(105184, 109, '2015-03-15 01:31:34.000000', 'temperatura', 452.0000, 'ºC'),
	(105185, 109, '2015-03-15 01:31:35.000000', 'temperatura', 924.0000, 'ºC'),
	(105186, 109, '2015-03-15 01:31:36.000000', 'temperatura', 862.0000, 'ºC'),
	(105187, 109, '2015-03-15 01:31:37.000000', 'temperatura', 342.0000, 'ºC'),
	(105188, 109, '2015-03-15 01:31:38.000000', 'temperatura', 321.0000, 'ºC'),
	(105189, 109, '2015-03-15 01:31:39.000000', 'temperatura', 583.0000, 'ºC'),
	(105190, 109, '2015-03-15 01:31:40.000000', 'temperatura', 750.0000, 'ºC'),
	(105191, 109, '2015-03-15 01:31:41.000000', 'temperatura', 802.0000, 'ºC'),
	(105192, 109, '2015-03-15 01:31:42.000000', 'temperatura', 561.0000, 'ºC'),
	(105193, 109, '2015-03-15 01:31:43.000000', 'temperatura', 398.0000, 'ºC'),
	(105194, 109, '2015-03-15 01:31:44.000000', 'temperatura', 307.0000, 'ºC'),
	(105195, 109, '2015-03-15 01:31:45.000000', 'temperatura', 342.0000, 'ºC'),
	(105196, 109, '2015-03-15 01:31:46.000000', 'temperatura', 791.0000, 'ºC'),
	(105197, 109, '2015-03-15 01:31:47.000000', 'temperatura', 529.0000, 'ºC'),
	(105198, 109, '2015-03-15 01:31:48.000000', 'temperatura', 274.0000, 'ºC'),
	(105199, 109, '2015-03-15 01:31:49.000000', 'temperatura', 984.0000, 'ºC'),
	(105200, 109, '2015-03-15 01:31:50.000000', 'temperatura', 497.0000, 'ºC'),
	(105201, 109, '2015-03-15 01:31:51.000000', 'temperatura', 733.0000, 'ºC'),
	(105202, 109, '2015-03-15 01:31:52.000000', 'temperatura', 976.0000, 'ºC'),
	(105203, 109, '2015-03-15 01:31:53.000000', 'temperatura', 280.0000, 'ºC'),
	(105204, 109, '2015-03-15 01:31:54.000000', 'temperatura', 875.0000, 'ºC'),
	(105205, 109, '2015-03-15 01:31:55.000000', 'temperatura', 1133.0000, 'ºC'),
	(105206, 109, '2015-03-15 01:31:56.000000', 'temperatura', 643.0000, 'ºC'),
	(105207, 109, '2015-03-15 01:31:57.000000', 'temperatura', 1017.0000, 'ºC'),
	(105208, 109, '2015-03-15 01:31:58.000000', 'temperatura', 754.0000, 'ºC'),
	(105209, 109, '2015-03-15 01:31:59.000000', 'temperatura', 721.0000, 'ºC'),
	(105210, 109, '2015-03-15 01:32:00.000000', 'temperatura', 143.0000, 'ºC'),
	(105211, 109, '2015-03-15 01:32:01.000000', 'temperatura', 955.0000, 'ºC'),
	(105212, 109, '2015-03-15 01:32:02.000000', 'temperatura', 743.0000, 'ºC'),
	(105213, 109, '2015-03-15 01:32:03.000000', 'temperatura', 851.0000, 'ºC'),
	(105214, 109, '2015-03-15 01:32:04.000000', 'temperatura', 826.0000, 'ºC'),
	(105215, 109, '2015-03-15 01:32:05.000000', 'temperatura', 377.0000, 'ºC'),
	(105216, 109, '2015-03-15 01:32:06.000000', 'temperatura', 609.0000, 'ºC'),
	(105217, 109, '2015-03-15 01:32:07.000000', 'temperatura', 713.0000, 'ºC'),
	(105218, 109, '2015-03-15 01:32:08.000000', 'temperatura', 539.0000, 'ºC'),
	(105219, 109, '2015-03-15 01:32:09.000000', 'temperatura', 555.0000, 'ºC'),
	(105220, 109, '2015-03-15 01:32:10.000000', 'temperatura', 1162.0000, 'ºC'),
	(105221, 109, '2015-03-15 01:32:11.000000', 'temperatura', 542.0000, 'ºC'),
	(105222, 109, '2015-03-15 01:32:12.000000', 'temperatura', 426.0000, 'ºC'),
	(105223, 109, '2015-03-15 01:32:13.000000', 'temperatura', 505.0000, 'ºC'),
	(105224, 109, '2015-03-15 01:32:14.000000', 'temperatura', 45.0000, 'ºC'),
	(105225, 109, '2015-03-15 01:32:15.000000', 'temperatura', 1112.0000, 'ºC'),
	(105226, 109, '2015-03-15 01:32:16.000000', 'temperatura', 626.0000, 'ºC'),
	(105227, 109, '2015-03-15 01:32:17.000000', 'temperatura', 995.0000, 'ºC'),
	(105228, 109, '2015-03-15 01:32:18.000000', 'temperatura', 697.0000, 'ºC'),
	(105229, 109, '2015-03-15 01:32:19.000000', 'temperatura', 499.0000, 'ºC'),
	(105230, 109, '2015-03-15 01:32:20.000000', 'temperatura', 404.0000, 'ºC'),
	(105231, 109, '2015-03-15 01:32:21.000000', 'temperatura', 523.0000, 'ºC'),
	(105232, 109, '2015-03-15 01:32:22.000000', 'temperatura', 202.0000, 'ºC'),
	(105233, 109, '2015-03-15 01:32:23.000000', 'temperatura', 645.0000, 'ºC'),
	(105234, 109, '2015-03-15 01:32:24.000000', 'temperatura', 220.0000, 'ºC'),
	(105235, 109, '2015-03-15 01:32:25.000000', 'temperatura', 363.0000, 'ºC'),
	(105236, 109, '2015-03-15 01:32:26.000000', 'temperatura', 1156.0000, 'ºC'),
	(105237, 109, '2015-03-15 01:32:27.000000', 'temperatura', 1093.0000, 'ºC'),
	(105238, 109, '2015-03-15 01:32:28.000000', 'temperatura', 796.0000, 'ºC'),
	(105239, 109, '2015-03-15 01:32:29.000000', 'temperatura', 704.0000, 'ºC'),
	(105240, 109, '2015-03-15 01:32:30.000000', 'temperatura', 1130.0000, 'ºC'),
	(105241, 109, '2015-03-15 01:32:31.000000', 'temperatura', 1138.0000, 'ºC'),
	(105242, 109, '2015-03-15 01:32:32.000000', 'temperatura', 1100.0000, 'ºC'),
	(105243, 109, '2015-03-15 01:32:33.000000', 'temperatura', 888.0000, 'ºC'),
	(105244, 109, '2015-03-15 01:32:34.000000', 'temperatura', 1139.0000, 'ºC'),
	(105245, 109, '2015-03-15 01:32:35.000000', 'temperatura', 632.0000, 'ºC'),
	(105246, 109, '2015-03-15 01:32:36.000000', 'temperatura', 945.0000, 'ºC'),
	(105247, 109, '2015-03-15 01:32:37.000000', 'temperatura', 430.0000, 'ºC'),
	(105248, 109, '2015-03-15 01:32:38.000000', 'temperatura', 516.0000, 'ºC'),
	(105249, 109, '2015-03-15 01:32:39.000000', 'temperatura', 89.0000, 'ºC'),
	(105250, 109, '2015-03-15 01:32:40.000000', 'temperatura', 98.0000, 'ºC'),
	(105251, 109, '2015-03-15 01:32:41.000000', 'temperatura', 223.0000, 'ºC'),
	(105252, 109, '2015-03-15 01:32:42.000000', 'temperatura', 823.0000, 'ºC'),
	(105253, 109, '2015-03-15 01:32:43.000000', 'temperatura', 1045.0000, 'ºC'),
	(105254, 109, '2015-03-15 01:32:44.000000', 'temperatura', 358.0000, 'ºC'),
	(105255, 109, '2015-03-15 01:32:45.000000', 'temperatura', 1053.0000, 'ºC'),
	(105256, 109, '2015-03-15 01:32:46.000000', 'temperatura', 592.0000, 'ºC'),
	(105257, 109, '2015-03-15 01:32:47.000000', 'temperatura', 1001.0000, 'ºC'),
	(105258, 109, '2015-03-15 01:32:48.000000', 'temperatura', 829.0000, 'ºC'),
	(105259, 109, '2015-03-15 01:32:49.000000', 'temperatura', 1145.0000, 'ºC'),
	(105260, 109, '2015-03-15 01:32:50.000000', 'temperatura', 839.0000, 'ºC'),
	(105261, 109, '2015-03-15 01:32:51.000000', 'temperatura', 759.0000, 'ºC'),
	(105262, 109, '2015-03-15 01:32:52.000000', 'temperatura', 78.0000, 'ºC'),
	(105263, 109, '2015-03-15 01:32:53.000000', 'temperatura', 512.0000, 'ºC'),
	(105264, 109, '2015-03-15 01:32:54.000000', 'temperatura', 1128.0000, 'ºC'),
	(105265, 109, '2015-03-15 01:32:55.000000', 'temperatura', 503.0000, 'ºC'),
	(105266, 109, '2015-03-15 01:32:56.000000', 'temperatura', 331.0000, 'ºC'),
	(105267, 109, '2015-03-15 01:32:57.000000', 'temperatura', 149.0000, 'ºC'),
	(105268, 109, '2015-03-15 01:32:58.000000', 'temperatura', 951.0000, 'ºC'),
	(105269, 109, '2015-03-15 01:32:59.000000', 'temperatura', 709.0000, 'ºC'),
	(105270, 109, '2015-03-15 01:33:00.000000', 'temperatura', 694.0000, 'ºC'),
	(105271, 109, '2015-03-15 01:33:01.000000', 'temperatura', 144.0000, 'ºC'),
	(105272, 109, '2015-03-15 01:33:02.000000', 'temperatura', 1037.0000, 'ºC'),
	(105273, 109, '2015-03-15 01:33:03.000000', 'temperatura', 1156.0000, 'ºC'),
	(105274, 109, '2015-03-15 01:33:04.000000', 'temperatura', 267.0000, 'ºC'),
	(105275, 109, '2015-03-15 01:33:05.000000', 'temperatura', 269.0000, 'ºC'),
	(105276, 109, '2015-03-15 01:33:06.000000', 'temperatura', 545.0000, 'ºC'),
	(105277, 109, '2015-03-15 01:33:07.000000', 'temperatura', 716.0000, 'ºC'),
	(105278, 109, '2015-03-15 01:33:08.000000', 'temperatura', 747.0000, 'ºC'),
	(105279, 109, '2015-03-15 01:33:09.000000', 'temperatura', 388.0000, 'ºC'),
	(105280, 109, '2015-03-15 01:33:10.000000', 'temperatura', 898.0000, 'ºC'),
	(105281, 109, '2015-03-15 01:33:11.000000', 'temperatura', 927.0000, 'ºC'),
	(105282, 109, '2015-03-15 01:33:12.000000', 'temperatura', 740.0000, 'ºC'),
	(105283, 109, '2015-03-15 01:33:13.000000', 'temperatura', 919.0000, 'ºC'),
	(105284, 109, '2015-03-15 01:33:14.000000', 'temperatura', 1176.0000, 'ºC'),
	(105285, 109, '2015-03-15 01:33:15.000000', 'temperatura', 724.0000, 'ºC'),
	(105286, 109, '2015-03-15 01:33:16.000000', 'temperatura', 94.0000, 'ºC'),
	(105287, 109, '2015-03-15 01:33:17.000000', 'temperatura', 699.0000, 'ºC'),
	(105288, 109, '2015-03-15 01:33:18.000000', 'temperatura', 814.0000, 'ºC'),
	(105289, 109, '2015-03-15 01:33:19.000000', 'temperatura', 774.0000, 'ºC'),
	(105290, 109, '2015-03-15 01:33:20.000000', 'temperatura', 227.0000, 'ºC'),
	(105291, 109, '2015-03-15 01:33:21.000000', 'temperatura', 15.0000, 'ºC'),
	(105292, 109, '2015-03-15 01:33:22.000000', 'temperatura', 594.0000, 'ºC'),
	(105293, 109, '2015-03-15 01:33:23.000000', 'temperatura', 525.0000, 'ºC'),
	(105294, 109, '2015-03-15 01:33:24.000000', 'temperatura', 845.0000, 'ºC'),
	(105295, 109, '2015-03-15 01:33:25.000000', 'temperatura', 251.0000, 'ºC'),
	(105296, 109, '2015-03-15 01:33:26.000000', 'temperatura', 1120.0000, 'ºC'),
	(105297, 109, '2015-03-15 01:33:27.000000', 'temperatura', 46.0000, 'ºC'),
	(105298, 109, '2015-03-15 01:33:28.000000', 'temperatura', 471.0000, 'ºC'),
	(105299, 109, '2015-03-15 01:33:29.000000', 'temperatura', 1018.0000, 'ºC'),
	(105300, 109, '2015-03-15 01:33:30.000000', 'temperatura', 78.0000, 'ºC'),
	(105301, 109, '2015-03-15 01:33:31.000000', 'temperatura', 936.0000, 'ºC'),
	(105302, 109, '2015-03-15 01:33:32.000000', 'temperatura', 846.0000, 'ºC'),
	(105303, 109, '2015-03-15 01:33:33.000000', 'temperatura', 224.0000, 'ºC'),
	(105304, 109, '2015-03-15 01:33:34.000000', 'temperatura', 982.0000, 'ºC'),
	(105305, 109, '2015-03-15 01:33:35.000000', 'temperatura', 640.0000, 'ºC'),
	(105306, 109, '2015-03-15 01:33:36.000000', 'temperatura', 254.0000, 'ºC'),
	(105307, 109, '2015-03-15 01:33:37.000000', 'temperatura', 548.0000, 'ºC'),
	(105308, 109, '2015-03-15 01:33:38.000000', 'temperatura', 780.0000, 'ºC'),
	(105309, 109, '2015-03-15 01:33:39.000000', 'temperatura', 1057.0000, 'ºC'),
	(105310, 109, '2015-03-15 01:33:40.000000', 'temperatura', 545.0000, 'ºC'),
	(105311, 109, '2015-03-15 01:33:41.000000', 'temperatura', 753.0000, 'ºC'),
	(105312, 109, '2015-03-15 01:33:42.000000', 'temperatura', 931.0000, 'ºC'),
	(105313, 109, '2015-03-15 01:33:43.000000', 'temperatura', 1199.0000, 'ºC'),
	(105314, 109, '2015-03-15 01:33:44.000000', 'temperatura', 800.0000, 'ºC'),
	(105315, 109, '2015-03-15 01:33:45.000000', 'temperatura', 406.0000, 'ºC'),
	(105316, 109, '2015-03-15 01:33:46.000000', 'temperatura', 830.0000, 'ºC'),
	(105317, 109, '2015-03-15 01:33:47.000000', 'temperatura', 534.0000, 'ºC'),
	(105318, 109, '2015-03-15 01:33:48.000000', 'temperatura', 179.0000, 'ºC'),
	(105319, 109, '2015-03-15 01:33:49.000000', 'temperatura', 494.0000, 'ºC'),
	(105320, 109, '2015-03-15 01:33:50.000000', 'temperatura', 731.0000, 'ºC'),
	(105321, 109, '2015-03-15 01:33:51.000000', 'temperatura', 977.0000, 'ºC'),
	(105322, 109, '2015-03-15 01:33:52.000000', 'temperatura', 292.0000, 'ºC'),
	(105323, 109, '2015-03-15 01:33:53.000000', 'temperatura', 928.0000, 'ºC'),
	(105324, 109, '2015-03-15 01:33:54.000000', 'temperatura', 166.0000, 'ºC'),
	(105325, 109, '2015-03-15 01:33:55.000000', 'temperatura', 445.0000, 'ºC'),
	(105326, 109, '2015-03-15 01:33:56.000000', 'temperatura', 528.0000, 'ºC'),
	(105327, 109, '2015-03-15 01:33:57.000000', 'temperatura', 105.0000, 'ºC'),
	(105328, 109, '2015-03-15 01:33:58.000000', 'temperatura', 144.0000, 'ºC'),
	(105329, 109, '2015-03-15 01:33:59.000000', 'temperatura', 404.0000, 'ºC'),
	(105330, 109, '2015-03-15 01:34:00.000000', 'temperatura', 389.0000, 'ºC'),
	(105331, 109, '2015-03-15 01:34:01.000000', 'temperatura', 734.0000, 'ºC'),
	(105332, 109, '2015-03-15 01:34:02.000000', 'temperatura', 104.0000, 'ºC'),
	(105333, 109, '2015-03-15 01:34:03.000000', 'temperatura', 718.0000, 'ºC'),
	(105334, 109, '2015-03-15 01:34:04.000000', 'temperatura', 879.0000, 'ºC'),
	(105335, 109, '2015-03-15 01:34:05.000000', 'temperatura', 1040.0000, 'ºC'),
	(105336, 109, '2015-03-15 01:34:06.000000', 'temperatura', 164.0000, 'ºC'),
	(105337, 109, '2015-03-15 01:34:07.000000', 'temperatura', 99.0000, 'ºC'),
	(105338, 109, '2015-03-15 01:34:08.000000', 'temperatura', 3.0000, 'ºC'),
	(105339, 109, '2015-03-15 01:34:09.000000', 'temperatura', 920.0000, 'ºC'),
	(105340, 109, '2015-03-15 01:34:10.000000', 'temperatura', 992.0000, 'ºC'),
	(105341, 109, '2015-03-15 01:34:11.000000', 'temperatura', 1001.0000, 'ºC'),
	(105342, 109, '2015-03-15 01:34:12.000000', 'temperatura', 828.0000, 'ºC'),
	(105343, 109, '2015-03-15 01:34:13.000000', 'temperatura', 1140.0000, 'ºC'),
	(105344, 109, '2015-03-15 01:34:14.000000', 'temperatura', 815.0000, 'ºC'),
	(105345, 109, '2015-03-15 01:34:15.000000', 'temperatura', 656.0000, 'ºC'),
	(105346, 109, '2015-03-15 01:34:16.000000', 'temperatura', 837.0000, 'ºC'),
	(105347, 109, '2015-03-15 01:34:17.000000', 'temperatura', 1016.0000, 'ºC'),
	(105348, 109, '2015-03-15 01:34:18.000000', 'temperatura', 170.0000, 'ºC'),
	(105349, 109, '2015-03-15 01:34:19.000000', 'temperatura', 204.0000, 'ºC'),
	(105350, 109, '2015-03-15 01:34:20.000000', 'temperatura', 509.0000, 'ºC'),
	(105351, 109, '2015-03-15 01:34:21.000000', 'temperatura', 735.0000, 'ºC'),
	(105352, 109, '2015-03-15 01:34:22.000000', 'temperatura', 946.0000, 'ºC'),
	(105353, 109, '2015-03-15 01:34:23.000000', 'temperatura', 128.0000, 'ºC'),
	(105354, 109, '2015-03-15 01:34:24.000000', 'temperatura', 200.0000, 'ºC'),
	(105355, 109, '2015-03-15 01:34:25.000000', 'temperatura', 616.0000, 'ºC'),
	(105356, 109, '2015-03-15 01:34:26.000000', 'temperatura', 81.0000, 'ºC'),
	(105357, 109, '2015-03-15 01:34:27.000000', 'temperatura', 958.0000, 'ºC'),
	(105358, 109, '2015-03-15 01:34:28.000000', 'temperatura', 950.0000, 'ºC'),
	(105359, 109, '2015-03-15 01:34:29.000000', 'temperatura', 673.0000, 'ºC'),
	(105360, 109, '2015-03-15 01:34:30.000000', 'temperatura', 516.0000, 'ºC'),
	(105361, 109, '2015-03-15 01:34:31.000000', 'temperatura', 561.0000, 'ºC'),
	(105362, 109, '2015-03-15 01:34:32.000000', 'temperatura', 59.0000, 'ºC'),
	(105363, 109, '2015-03-15 01:34:33.000000', 'temperatura', 1011.0000, 'ºC'),
	(105364, 109, '2015-03-15 01:34:34.000000', 'temperatura', 81.0000, 'ºC'),
	(105365, 109, '2015-03-15 01:34:35.000000', 'temperatura', 970.0000, 'ºC'),
	(105366, 109, '2015-03-15 01:34:36.000000', 'temperatura', 1008.0000, 'ºC'),
	(105367, 109, '2015-03-15 01:34:37.000000', 'temperatura', 931.0000, 'ºC'),
	(105368, 109, '2015-03-15 01:34:38.000000', 'temperatura', 431.0000, 'ºC'),
	(105369, 109, '2015-03-15 01:34:39.000000', 'temperatura', 564.0000, 'ºC'),
	(105370, 109, '2015-03-15 01:34:40.000000', 'temperatura', 326.0000, 'ºC'),
	(105371, 109, '2015-03-15 01:34:41.000000', 'temperatura', 1138.0000, 'ºC'),
	(105372, 109, '2015-03-15 01:34:42.000000', 'temperatura', 1113.0000, 'ºC'),
	(105373, 109, '2015-03-15 01:34:43.000000', 'temperatura', 950.0000, 'ºC'),
	(105374, 109, '2015-03-15 01:34:44.000000', 'temperatura', 213.0000, 'ºC'),
	(105375, 109, '2015-03-15 01:34:45.000000', 'temperatura', 614.0000, 'ºC'),
	(105376, 109, '2015-03-15 01:34:46.000000', 'temperatura', 34.0000, 'ºC'),
	(105377, 109, '2015-03-15 01:34:47.000000', 'temperatura', 729.0000, 'ºC'),
	(105378, 109, '2015-03-15 01:34:48.000000', 'temperatura', 1140.0000, 'ºC'),
	(105379, 109, '2015-03-15 01:34:49.000000', 'temperatura', 1117.0000, 'ºC'),
	(105380, 109, '2015-03-15 01:34:50.000000', 'temperatura', 963.0000, 'ºC'),
	(105381, 109, '2015-03-15 01:34:51.000000', 'temperatura', 267.0000, 'ºC'),
	(105382, 109, '2015-03-15 01:34:52.000000', 'temperatura', 847.0000, 'ºC'),
	(105383, 109, '2015-03-15 01:34:53.000000', 'temperatura', 1034.0000, 'ºC'),
	(105384, 109, '2015-03-15 01:34:54.000000', 'temperatura', 228.0000, 'ºC'),
	(105385, 109, '2015-03-15 01:34:55.000000', 'temperatura', 438.0000, 'ºC'),
	(105386, 109, '2015-03-15 01:34:56.000000', 'temperatura', 305.0000, 'ºC'),
	(105387, 109, '2015-03-15 01:34:57.000000', 'temperatura', 214.0000, 'ºC'),
	(105388, 109, '2015-03-15 01:34:58.000000', 'temperatura', 156.0000, 'ºC'),
	(105389, 109, '2015-03-15 01:34:59.000000', 'temperatura', 139.0000, 'ºC'),
	(105390, 109, '2015-03-15 01:35:00.000000', 'temperatura', 225.0000, 'ºC'),
	(105391, 109, '2015-03-15 01:35:01.000000', 'temperatura', 709.0000, 'ºC'),
	(105392, 109, '2015-03-15 01:35:02.000000', 'temperatura', 470.0000, 'ºC'),
	(105393, 109, '2015-03-15 01:35:03.000000', 'temperatura', 224.0000, 'ºC'),
	(105394, 109, '2015-03-15 01:35:04.000000', 'temperatura', 910.0000, 'ºC'),
	(105395, 109, '2015-03-15 01:35:05.000000', 'temperatura', 280.0000, 'ºC'),
	(105396, 109, '2015-03-15 01:35:06.000000', 'temperatura', 1071.0000, 'ºC'),
	(105397, 109, '2015-03-15 01:35:07.000000', 'temperatura', 915.0000, 'ºC'),
	(105398, 109, '2015-03-15 01:35:08.000000', 'temperatura', 164.0000, 'ºC'),
	(105399, 109, '2015-03-15 01:35:09.000000', 'temperatura', 473.0000, 'ºC'),
	(105400, 109, '2015-03-15 01:35:10.000000', 'temperatura', 675.0000, 'ºC'),
	(105401, 109, '2015-03-15 01:35:11.000000', 'temperatura', 756.0000, 'ºC'),
	(105402, 109, '2015-03-15 01:35:12.000000', 'temperatura', 554.0000, 'ºC'),
	(105403, 109, '2015-03-15 01:35:13.000000', 'temperatura', 505.0000, 'ºC'),
	(105404, 109, '2015-03-15 01:35:14.000000', 'temperatura', 864.0000, 'ºC'),
	(105405, 109, '2015-03-15 01:35:15.000000', 'temperatura', 406.0000, 'ºC'),
	(105406, 109, '2015-03-15 01:35:16.000000', 'temperatura', 637.0000, 'ºC'),
	(105407, 109, '2015-03-15 01:35:17.000000', 'temperatura', 768.0000, 'ºC'),
	(105408, 109, '2015-03-15 01:35:18.000000', 'temperatura', 729.0000, 'ºC'),
	(105409, 109, '2015-03-15 01:35:19.000000', 'temperatura', 141.0000, 'ºC'),
	(105410, 109, '2015-03-15 01:35:20.000000', 'temperatura', 917.0000, 'ºC'),
	(105411, 109, '2015-03-15 01:35:21.000000', 'temperatura', 565.0000, 'ºC'),
	(105412, 109, '2015-03-15 01:35:22.000000', 'temperatura', 75.0000, 'ºC'),
	(105413, 109, '2015-03-15 01:35:23.000000', 'temperatura', 1080.0000, 'ºC'),
	(105414, 109, '2015-03-15 01:35:24.000000', 'temperatura', 374.0000, 'ºC'),
	(105415, 109, '2015-03-15 01:35:25.000000', 'temperatura', 1030.0000, 'ºC'),
	(105416, 109, '2015-03-15 01:35:26.000000', 'temperatura', 430.0000, 'ºC'),
	(105417, 109, '2015-03-15 01:35:27.000000', 'temperatura', 262.0000, 'ºC'),
	(105418, 109, '2015-03-15 01:35:28.000000', 'temperatura', 19.0000, 'ºC'),
	(105419, 109, '2015-03-15 01:35:29.000000', 'temperatura', 511.0000, 'ºC'),
	(105420, 109, '2015-03-15 01:35:30.000000', 'temperatura', 99.0000, 'ºC'),
	(105421, 109, '2015-03-15 01:35:31.000000', 'temperatura', 160.0000, 'ºC'),
	(105422, 109, '2015-03-15 01:35:32.000000', 'temperatura', 503.0000, 'ºC'),
	(105423, 109, '2015-03-15 01:35:33.000000', 'temperatura', 837.0000, 'ºC'),
	(105424, 109, '2015-03-15 01:35:34.000000', 'temperatura', 277.0000, 'ºC'),
	(105425, 109, '2015-03-15 01:35:35.000000', 'temperatura', 72.0000, 'ºC'),
	(105426, 109, '2015-03-15 01:35:36.000000', 'temperatura', 731.0000, 'ºC'),
	(105427, 109, '2015-03-15 01:35:37.000000', 'temperatura', 1038.0000, 'ºC'),
	(105428, 109, '2015-03-15 01:35:38.000000', 'temperatura', 598.0000, 'ºC'),
	(105429, 109, '2015-03-15 01:35:39.000000', 'temperatura', 1078.0000, 'ºC'),
	(105430, 109, '2015-03-15 01:35:40.000000', 'temperatura', 1194.0000, 'ºC'),
	(105431, 109, '2015-03-15 01:35:41.000000', 'temperatura', 337.0000, 'ºC'),
	(105432, 109, '2015-03-15 01:35:42.000000', 'temperatura', 505.0000, 'ºC'),
	(105433, 109, '2015-03-15 01:35:43.000000', 'temperatura', 315.0000, 'ºC'),
	(105434, 109, '2015-03-15 01:35:44.000000', 'temperatura', 62.0000, 'ºC'),
	(105435, 109, '2015-03-15 01:35:45.000000', 'temperatura', 562.0000, 'ºC'),
	(105436, 109, '2015-03-15 01:35:46.000000', 'temperatura', 225.0000, 'ºC'),
	(105437, 109, '2015-03-15 01:35:47.000000', 'temperatura', 640.0000, 'ºC'),
	(105438, 109, '2015-03-15 01:35:48.000000', 'temperatura', 125.0000, 'ºC'),
	(105439, 109, '2015-03-15 01:35:49.000000', 'temperatura', 1107.0000, 'ºC'),
	(105440, 109, '2015-03-15 01:35:50.000000', 'temperatura', 361.0000, 'ºC'),
	(105441, 109, '2015-03-15 01:35:51.000000', 'temperatura', 881.0000, 'ºC'),
	(105442, 109, '2015-03-15 01:35:52.000000', 'temperatura', 926.0000, 'ºC'),
	(105443, 109, '2015-03-15 01:35:53.000000', 'temperatura', 788.0000, 'ºC'),
	(105444, 109, '2015-03-15 01:35:54.000000', 'temperatura', 1160.0000, 'ºC'),
	(105445, 109, '2015-03-15 01:35:55.000000', 'temperatura', 1037.0000, 'ºC'),
	(105446, 109, '2015-03-15 01:35:56.000000', 'temperatura', 505.0000, 'ºC'),
	(105447, 109, '2015-03-15 01:35:57.000000', 'temperatura', 615.0000, 'ºC'),
	(105448, 109, '2015-03-15 01:35:58.000000', 'temperatura', 360.0000, 'ºC'),
	(105449, 109, '2015-03-15 01:35:59.000000', 'temperatura', 1158.0000, 'ºC'),
	(105450, 109, '2015-03-15 01:36:00.000000', 'temperatura', 1108.0000, 'ºC'),
	(105451, 109, '2015-03-15 01:36:01.000000', 'temperatura', 868.0000, 'ºC'),
	(105452, 109, '2015-03-15 01:36:02.000000', 'temperatura', 1015.0000, 'ºC'),
	(105453, 109, '2015-03-15 01:36:03.000000', 'temperatura', 74.0000, 'ºC'),
	(105454, 109, '2015-03-15 01:36:04.000000', 'temperatura', 925.0000, 'ºC'),
	(105455, 109, '2015-03-15 01:36:05.000000', 'temperatura', 801.0000, 'ºC'),
	(105456, 109, '2015-03-15 01:36:06.000000', 'temperatura', 34.0000, 'ºC'),
	(105457, 109, '2015-03-15 01:36:07.000000', 'temperatura', 164.0000, 'ºC'),
	(105458, 109, '2015-03-15 01:36:08.000000', 'temperatura', 720.0000, 'ºC'),
	(105459, 109, '2015-03-15 01:36:09.000000', 'temperatura', 708.0000, 'ºC'),
	(105460, 109, '2015-03-15 01:36:10.000000', 'temperatura', 182.0000, 'ºC'),
	(105461, 109, '2015-03-15 01:36:11.000000', 'temperatura', 1184.0000, 'ºC'),
	(105462, 109, '2015-03-15 01:36:12.000000', 'temperatura', 575.0000, 'ºC'),
	(105463, 109, '2015-03-15 01:36:13.000000', 'temperatura', 524.0000, 'ºC'),
	(105464, 109, '2015-03-15 01:36:14.000000', 'temperatura', 897.0000, 'ºC'),
	(105465, 109, '2015-03-15 01:36:15.000000', 'temperatura', 513.0000, 'ºC'),
	(105466, 109, '2015-03-15 01:36:16.000000', 'temperatura', 1076.0000, 'ºC'),
	(105467, 109, '2015-03-15 01:36:17.000000', 'temperatura', 238.0000, 'ºC'),
	(105468, 109, '2015-03-15 01:36:18.000000', 'temperatura', 364.0000, 'ºC'),
	(105469, 109, '2015-03-15 01:36:19.000000', 'temperatura', 1108.0000, 'ºC'),
	(105470, 109, '2015-03-15 01:36:20.000000', 'temperatura', 848.0000, 'ºC'),
	(105471, 109, '2015-03-15 01:36:21.000000', 'temperatura', 914.0000, 'ºC'),
	(105472, 109, '2015-03-15 01:36:22.000000', 'temperatura', 828.0000, 'ºC'),
	(105473, 109, '2015-03-15 01:36:23.000000', 'temperatura', 199.0000, 'ºC'),
	(105474, 109, '2015-03-15 01:36:24.000000', 'temperatura', 912.0000, 'ºC'),
	(105475, 109, '2015-03-15 01:36:25.000000', 'temperatura', 361.0000, 'ºC'),
	(105476, 109, '2015-03-15 01:36:26.000000', 'temperatura', 273.0000, 'ºC'),
	(105477, 109, '2015-03-15 01:36:27.000000', 'temperatura', 280.0000, 'ºC'),
	(105478, 109, '2015-03-15 01:36:28.000000', 'temperatura', 581.0000, 'ºC'),
	(105479, 109, '2015-03-15 01:36:29.000000', 'temperatura', 865.0000, 'ºC'),
	(105480, 109, '2015-03-15 01:36:30.000000', 'temperatura', 181.0000, 'ºC'),
	(105481, 109, '2015-03-15 01:36:31.000000', 'temperatura', 714.0000, 'ºC'),
	(105482, 109, '2015-03-15 01:36:32.000000', 'temperatura', 626.0000, 'ºC'),
	(105483, 109, '2015-03-15 01:36:33.000000', 'temperatura', 991.0000, 'ºC'),
	(105484, 109, '2015-03-15 01:36:34.000000', 'temperatura', 674.0000, 'ºC'),
	(105485, 109, '2015-03-15 01:36:35.000000', 'temperatura', 400.0000, 'ºC'),
	(105486, 109, '2015-03-15 01:36:36.000000', 'temperatura', 1180.0000, 'ºC'),
	(105487, 109, '2015-03-15 01:36:37.000000', 'temperatura', 1097.0000, 'ºC'),
	(105488, 109, '2015-03-15 01:36:38.000000', 'temperatura', 746.0000, 'ºC'),
	(105489, 109, '2015-03-15 01:36:39.000000', 'temperatura', 441.0000, 'ºC'),
	(105490, 109, '2015-03-15 01:36:40.000000', 'temperatura', 1166.0000, 'ºC'),
	(105491, 109, '2015-03-15 01:36:41.000000', 'temperatura', 906.0000, 'ºC'),
	(105492, 109, '2015-03-15 01:36:42.000000', 'temperatura', 1035.0000, 'ºC'),
	(105493, 109, '2015-03-15 01:36:43.000000', 'temperatura', 55.0000, 'ºC'),
	(105494, 109, '2015-03-15 01:36:44.000000', 'temperatura', 771.0000, 'ºC'),
	(105495, 109, '2015-03-15 01:36:45.000000', 'temperatura', 93.0000, 'ºC'),
	(105496, 109, '2015-03-15 01:36:46.000000', 'temperatura', 551.0000, 'ºC'),
	(105497, 109, '2015-03-15 01:36:47.000000', 'temperatura', 78.0000, 'ºC'),
	(105498, 109, '2015-03-15 01:36:48.000000', 'temperatura', 1136.0000, 'ºC'),
	(105499, 109, '2015-03-15 01:36:49.000000', 'temperatura', 645.0000, 'ºC'),
	(105500, 109, '2015-03-15 01:36:50.000000', 'temperatura', 1020.0000, 'ºC'),
	(105501, 109, '2015-03-15 01:36:51.000000', 'temperatura', 765.0000, 'ºC'),
	(105502, 109, '2015-03-15 01:36:52.000000', 'temperatura', 764.0000, 'ºC'),
	(105503, 109, '2015-03-15 01:36:53.000000', 'temperatura', 327.0000, 'ºC'),
	(105504, 109, '2015-03-15 01:36:54.000000', 'temperatura', 544.0000, 'ºC'),
	(105505, 109, '2015-03-15 01:36:55.000000', 'temperatura', 540.0000, 'ºC'),
	(105506, 109, '2015-03-15 01:36:56.000000', 'temperatura', 1066.0000, 'ºC'),
	(105507, 109, '2015-03-15 01:36:57.000000', 'temperatura', 112.0000, 'ºC'),
	(105508, 109, '2015-03-15 01:36:58.000000', 'temperatura', 961.0000, 'ºC'),
	(105509, 109, '2015-03-15 01:36:59.000000', 'temperatura', 872.0000, 'ºC'),
	(105510, 109, '2015-03-15 01:37:00.000000', 'temperatura', 275.0000, 'ºC'),
	(105511, 109, '2015-03-15 01:37:01.000000', 'temperatura', 1159.0000, 'ºC'),
	(105512, 109, '2015-03-15 01:37:02.000000', 'temperatura', 173.0000, 'ºC'),
	(105513, 109, '2015-03-15 01:37:03.000000', 'temperatura', 986.0000, 'ºC'),
	(105514, 109, '2015-03-15 01:37:04.000000', 'temperatura', 812.0000, 'ºC'),
	(105515, 109, '2015-03-15 01:37:05.000000', 'temperatura', 1103.0000, 'ºC'),
	(105516, 109, '2015-03-15 01:37:06.000000', 'temperatura', 680.0000, 'ºC'),
	(105517, 109, '2015-03-15 01:37:07.000000', 'temperatura', 90.0000, 'ºC'),
	(105518, 109, '2015-03-15 01:37:08.000000', 'temperatura', 810.0000, 'ºC'),
	(105519, 109, '2015-03-15 01:37:09.000000', 'temperatura', 180.0000, 'ºC'),
	(105520, 109, '2015-03-15 01:37:10.000000', 'temperatura', 873.0000, 'ºC'),
	(105521, 109, '2015-03-15 01:37:11.000000', 'temperatura', 226.0000, 'ºC'),
	(105522, 109, '2015-03-15 01:37:12.000000', 'temperatura', 910.0000, 'ºC'),
	(105523, 109, '2015-03-15 01:37:13.000000', 'temperatura', 272.0000, 'ºC'),
	(105524, 109, '2015-03-15 01:37:14.000000', 'temperatura', 1030.0000, 'ºC'),
	(105525, 109, '2015-03-15 01:37:15.000000', 'temperatura', 734.0000, 'ºC'),
	(105526, 109, '2015-03-15 01:37:16.000000', 'temperatura', 581.0000, 'ºC'),
	(105527, 109, '2015-03-15 01:37:17.000000', 'temperatura', 704.0000, 'ºC'),
	(105528, 109, '2015-03-15 01:37:18.000000', 'temperatura', 575.0000, 'ºC'),
	(105529, 109, '2015-03-15 01:37:19.000000', 'temperatura', 766.0000, 'ºC'),
	(105530, 109, '2015-03-15 01:37:20.000000', 'temperatura', 907.0000, 'ºC'),
	(105531, 109, '2015-03-15 01:37:21.000000', 'temperatura', 1035.0000, 'ºC'),
	(105532, 109, '2015-03-15 01:37:22.000000', 'temperatura', 54.0000, 'ºC'),
	(105533, 109, '2015-03-15 01:37:23.000000', 'temperatura', 765.0000, 'ºC'),
	(105534, 109, '2015-03-15 01:37:24.000000', 'temperatura', 65.0000, 'ºC'),
	(105535, 109, '2015-03-15 01:37:25.000000', 'temperatura', 430.0000, 'ºC'),
	(105536, 109, '2015-03-15 01:37:26.000000', 'temperatura', 756.0000, 'ºC'),
	(105537, 109, '2015-03-15 01:37:27.000000', 'temperatura', 91.0000, 'ºC'),
	(105538, 109, '2015-03-15 01:37:28.000000', 'temperatura', 588.0000, 'ºC'),
	(105539, 109, '2015-03-15 01:37:29.000000', 'temperatura', 266.0000, 'ºC'),
	(105540, 109, '2015-03-15 01:37:30.000000', 'temperatura', 767.0000, 'ºC'),
	(105541, 109, '2015-03-15 01:37:31.000000', 'temperatura', 638.0000, 'ºC'),
	(105542, 109, '2015-03-15 01:37:32.000000', 'temperatura', 889.0000, 'ºC'),
	(105543, 109, '2015-03-15 01:37:33.000000', 'temperatura', 133.0000, 'ºC'),
	(105544, 109, '2015-03-15 01:37:34.000000', 'temperatura', 397.0000, 'ºC'),
	(105545, 109, '2015-03-15 01:37:35.000000', 'temperatura', 386.0000, 'ºC'),
	(105546, 109, '2015-03-15 01:37:36.000000', 'temperatura', 740.0000, 'ºC'),
	(105547, 109, '2015-03-15 01:37:37.000000', 'temperatura', 143.0000, 'ºC'),
	(105548, 109, '2015-03-15 01:37:38.000000', 'temperatura', 896.0000, 'ºC'),
	(105549, 109, '2015-03-15 01:37:39.000000', 'temperatura', 449.0000, 'ºC'),
	(105550, 109, '2015-03-15 01:37:40.000000', 'temperatura', 760.0000, 'ºC'),
	(105551, 109, '2015-03-15 01:37:41.000000', 'temperatura', 53.0000, 'ºC'),
	(105552, 109, '2015-03-15 01:37:42.000000', 'temperatura', 385.0000, 'ºC'),
	(105553, 109, '2015-03-15 01:37:43.000000', 'temperatura', 568.0000, 'ºC'),
	(105554, 109, '2015-03-15 01:37:44.000000', 'temperatura', 483.0000, 'ºC'),
	(105555, 109, '2015-03-15 01:37:45.000000', 'temperatura', 714.0000, 'ºC'),
	(105556, 109, '2015-03-15 01:37:46.000000', 'temperatura', 919.0000, 'ºC'),
	(105557, 109, '2015-03-15 01:37:47.000000', 'temperatura', 56.0000, 'ºC'),
	(105558, 109, '2015-03-15 01:37:48.000000', 'temperatura', 1122.0000, 'ºC'),
	(105559, 109, '2015-03-15 01:37:49.000000', 'temperatura', 641.0000, 'ºC'),
	(105560, 109, '2015-03-15 01:37:50.000000', 'temperatura', 1042.0000, 'ºC'),
	(105561, 109, '2015-03-15 01:37:51.000000', 'temperatura', 888.0000, 'ºC'),
	(105562, 109, '2015-03-15 01:37:52.000000', 'temperatura', 112.0000, 'ºC'),
	(105563, 109, '2015-03-15 01:37:53.000000', 'temperatura', 296.0000, 'ºC'),
	(105564, 109, '2015-03-15 01:37:54.000000', 'temperatura', 1147.0000, 'ºC'),
	(105565, 109, '2015-03-15 01:37:55.000000', 'temperatura', 47.0000, 'ºC'),
	(105566, 109, '2015-03-15 01:37:56.000000', 'temperatura', 396.0000, 'ºC'),
	(105567, 109, '2015-03-15 01:37:57.000000', 'temperatura', 637.0000, 'ºC'),
	(105568, 109, '2015-03-15 01:37:58.000000', 'temperatura', 797.0000, 'ºC'),
	(105569, 109, '2015-03-15 01:37:59.000000', 'temperatura', 876.0000, 'ºC'),
	(105570, 109, '2015-03-15 01:38:00.000000', 'temperatura', 790.0000, 'ºC'),
	(105571, 109, '2015-03-15 01:38:01.000000', 'temperatura', 122.0000, 'ºC'),
	(105572, 109, '2015-03-15 01:38:02.000000', 'temperatura', 641.0000, 'ºC'),
	(105573, 109, '2015-03-15 01:38:03.000000', 'temperatura', 439.0000, 'ºC'),
	(105574, 109, '2015-03-15 01:38:04.000000', 'temperatura', 273.0000, 'ºC'),
	(105575, 109, '2015-03-15 01:38:05.000000', 'temperatura', 49.0000, 'ºC'),
	(105576, 109, '2015-03-15 01:38:06.000000', 'temperatura', 626.0000, 'ºC'),
	(105577, 109, '2015-03-15 01:38:07.000000', 'temperatura', 582.0000, 'ºC'),
	(105578, 109, '2015-03-15 01:38:08.000000', 'temperatura', 1032.0000, 'ºC'),
	(105579, 109, '2015-03-15 01:38:09.000000', 'temperatura', 1017.0000, 'ºC'),
	(105580, 109, '2015-03-15 01:38:10.000000', 'temperatura', 789.0000, 'ºC'),
	(105581, 109, '2015-03-15 01:38:11.000000', 'temperatura', 892.0000, 'ºC'),
	(105582, 109, '2015-03-15 01:38:12.000000', 'temperatura', 896.0000, 'ºC'),
	(105583, 109, '2015-03-15 01:38:13.000000', 'temperatura', 603.0000, 'ºC'),
	(105584, 109, '2015-03-15 01:38:14.000000', 'temperatura', 329.0000, 'ºC'),
	(105585, 109, '2015-03-15 01:38:15.000000', 'temperatura', 1038.0000, 'ºC'),
	(105586, 109, '2015-03-15 01:38:16.000000', 'temperatura', 601.0000, 'ºC'),
	(105587, 109, '2015-03-15 01:38:17.000000', 'temperatura', 1093.0000, 'ºC'),
	(105588, 109, '2015-03-15 01:38:18.000000', 'temperatura', 62.0000, 'ºC'),
	(105589, 109, '2015-03-15 01:38:19.000000', 'temperatura', 630.0000, 'ºC'),
	(105590, 109, '2015-03-15 01:38:20.000000', 'temperatura', 565.0000, 'ºC'),
	(105591, 109, '2015-03-15 01:38:21.000000', 'temperatura', 937.0000, 'ºC'),
	(105592, 109, '2015-03-15 01:38:22.000000', 'temperatura', 591.0000, 'ºC'),
	(105593, 109, '2015-03-15 01:38:23.000000', 'temperatura', 146.0000, 'ºC'),
	(105594, 109, '2015-03-15 01:38:24.000000', 'temperatura', 154.0000, 'ºC'),
	(105595, 109, '2015-03-15 01:38:25.000000', 'temperatura', 334.0000, 'ºC'),
	(105596, 109, '2015-03-15 01:38:26.000000', 'temperatura', 7.0000, 'ºC'),
	(105597, 109, '2015-03-15 01:38:27.000000', 'temperatura', 233.0000, 'ºC'),
	(105598, 109, '2015-03-15 01:38:28.000000', 'temperatura', 1143.0000, 'ºC'),
	(105599, 109, '2015-03-15 01:38:29.000000', 'temperatura', 220.0000, 'ºC'),
	(105600, 109, '2015-03-15 01:38:30.000000', 'temperatura', 71.0000, 'ºC'),
	(105601, 109, '2015-03-15 01:38:31.000000', 'temperatura', 896.0000, 'ºC'),
	(105602, 109, '2015-03-15 01:38:32.000000', 'temperatura', 667.0000, 'ºC'),
	(105603, 109, '2015-03-15 01:38:33.000000', 'temperatura', 646.0000, 'ºC'),
	(105604, 109, '2015-03-15 01:38:34.000000', 'temperatura', 30.0000, 'ºC'),
	(105605, 109, '2015-03-15 01:38:35.000000', 'temperatura', 612.0000, 'ºC'),
	(105606, 109, '2015-03-15 01:38:36.000000', 'temperatura', 570.0000, 'ºC'),
	(105607, 109, '2015-03-15 01:38:37.000000', 'temperatura', 1015.0000, 'ºC'),
	(105608, 109, '2015-03-15 01:38:38.000000', 'temperatura', 966.0000, 'ºC'),
	(105609, 109, '2015-03-15 01:38:39.000000', 'temperatura', 586.0000, 'ºC'),
	(105610, 109, '2015-03-15 01:38:40.000000', 'temperatura', 32.0000, 'ºC'),
	(105611, 109, '2015-03-15 01:38:41.000000', 'temperatura', 801.0000, 'ºC'),
	(105612, 109, '2015-03-15 01:38:42.000000', 'temperatura', 310.0000, 'ºC'),
	(105613, 109, '2015-03-15 01:38:43.000000', 'temperatura', 347.0000, 'ºC'),
	(105614, 109, '2015-03-15 01:38:44.000000', 'temperatura', 807.0000, 'ºC'),
	(105615, 109, '2015-03-15 01:38:45.000000', 'temperatura', 596.0000, 'ºC'),
	(105616, 109, '2015-03-15 01:38:46.000000', 'temperatura', 558.0000, 'ºC'),
	(105617, 109, '2015-03-15 01:38:47.000000', 'temperatura', 1001.0000, 'ºC'),
	(105618, 109, '2015-03-15 01:38:48.000000', 'temperatura', 934.0000, 'ºC'),
	(105619, 109, '2015-03-15 01:38:49.000000', 'temperatura', 466.0000, 'ºC'),
	(105620, 109, '2015-03-15 01:38:50.000000', 'temperatura', 727.0000, 'ºC'),
	(105621, 109, '2015-03-15 01:38:51.000000', 'temperatura', 1038.0000, 'ºC'),
	(105622, 109, '2015-03-15 01:38:52.000000', 'temperatura', 611.0000, 'ºC'),
	(105623, 109, '2015-03-15 01:38:53.000000', 'temperatura', 1141.0000, 'ºC'),
	(105624, 109, '2015-03-15 01:38:54.000000', 'temperatura', 274.0000, 'ºC'),
	(105625, 109, '2015-03-15 01:38:55.000000', 'temperatura', 346.0000, 'ºC'),
	(105626, 109, '2015-03-15 01:38:56.000000', 'temperatura', 907.0000, 'ºC'),
	(105627, 109, '2015-03-15 01:38:57.000000', 'temperatura', 1099.0000, 'ºC'),
	(105628, 109, '2015-03-15 01:38:58.000000', 'temperatura', 372.0000, 'ºC'),
	(105629, 109, '2015-03-15 01:38:59.000000', 'temperatura', 966.0000, 'ºC'),
	(105630, 109, '2015-03-15 01:39:00.000000', 'temperatura', 114.0000, 'ºC'),
	(105631, 109, '2015-03-15 01:39:01.000000', 'temperatura', 71.0000, 'ºC'),
	(105632, 109, '2015-03-15 01:39:02.000000', 'temperatura', 13.0000, 'ºC'),
	(105633, 109, '2015-03-15 01:39:03.000000', 'temperatura', 1052.0000, 'ºC'),
	(105634, 109, '2015-03-15 01:39:04.000000', 'temperatura', 421.0000, 'ºC'),
	(105635, 109, '2015-03-15 01:39:05.000000', 'temperatura', 153.0000, 'ºC'),
	(105636, 109, '2015-03-15 01:39:06.000000', 'temperatura', 699.0000, 'ºC'),
	(105637, 109, '2015-03-15 01:39:07.000000', 'temperatura', 638.0000, 'ºC'),
	(105638, 109, '2015-03-15 01:39:08.000000', 'temperatura', 1094.0000, 'ºC'),
	(105639, 109, '2015-03-15 01:39:09.000000', 'temperatura', 1158.0000, 'ºC'),
	(105640, 109, '2015-03-15 01:39:10.000000', 'temperatura', 106.0000, 'ºC'),
	(105641, 109, '2015-03-15 01:39:11.000000', 'temperatura', 657.0000, 'ºC'),
	(105642, 109, '2015-03-15 01:39:12.000000', 'temperatura', 569.0000, 'ºC'),
	(105643, 109, '2015-03-15 01:39:13.000000', 'temperatura', 875.0000, 'ºC'),
	(105644, 109, '2015-03-15 01:39:14.000000', 'temperatura', 269.0000, 'ºC'),
	(105645, 109, '2015-03-15 01:39:15.000000', 'temperatura', 1118.0000, 'ºC'),
	(105646, 109, '2015-03-15 01:39:16.000000', 'temperatura', 1186.0000, 'ºC'),
	(105647, 109, '2015-03-15 01:39:17.000000', 'temperatura', 178.0000, 'ºC'),
	(105648, 109, '2015-03-15 01:39:18.000000', 'temperatura', 929.0000, 'ºC'),
	(105649, 109, '2015-03-15 01:39:19.000000', 'temperatura', 512.0000, 'ºC'),
	(105650, 109, '2015-03-15 01:39:20.000000', 'temperatura', 975.0000, 'ºC'),
	(105651, 109, '2015-03-15 01:39:21.000000', 'temperatura', 939.0000, 'ºC'),
	(105652, 109, '2015-03-15 01:39:22.000000', 'temperatura', 571.0000, 'ºC'),
	(105653, 109, '2015-03-15 01:39:23.000000', 'temperatura', 39.0000, 'ºC'),
	(105654, 109, '2015-03-15 01:39:24.000000', 'temperatura', 881.0000, 'ºC'),
	(105655, 109, '2015-03-15 01:39:25.000000', 'temperatura', 687.0000, 'ºC'),
	(105656, 109, '2015-03-15 01:39:26.000000', 'temperatura', 794.0000, 'ºC'),
	(105657, 109, '2015-03-15 01:39:27.000000', 'temperatura', 708.0000, 'ºC'),
	(105658, 109, '2015-03-15 01:39:28.000000', 'temperatura', 1161.0000, 'ºC'),
	(105659, 109, '2015-03-15 01:39:29.000000', 'temperatura', 83.0000, 'ºC'),
	(105660, 109, '2015-03-15 01:39:30.000000', 'temperatura', 529.0000, 'ºC'),
	(105661, 109, '2015-03-15 01:39:31.000000', 'temperatura', 1196.0000, 'ºC'),
	(105662, 109, '2015-03-15 01:39:32.000000', 'temperatura', 795.0000, 'ºC'),
	(105663, 109, '2015-03-15 01:39:33.000000', 'temperatura', 386.0000, 'ºC'),
	(105664, 109, '2015-03-15 01:39:34.000000', 'temperatura', 747.0000, 'ºC'),
	(105665, 109, '2015-03-15 01:39:35.000000', 'temperatura', 177.0000, 'ºC'),
	(105666, 109, '2015-03-15 01:39:36.000000', 'temperatura', 1046.0000, 'ºC'),
	(105667, 109, '2015-03-15 01:39:37.000000', 'temperatura', 1099.0000, 'ºC'),
	(105668, 109, '2015-03-15 01:39:38.000000', 'temperatura', 1158.0000, 'ºC'),
	(105669, 109, '2015-03-15 01:39:39.000000', 'temperatura', 92.0000, 'ºC'),
	(105670, 109, '2015-03-15 01:39:40.000000', 'temperatura', 588.0000, 'ºC'),
	(105671, 109, '2015-03-15 01:39:41.000000', 'temperatura', 262.0000, 'ºC'),
	(105672, 110, '2015-03-15 00:00:00.000000', 'temperatura', 561.0000, 'ºC'),
	(105673, 110, '2015-03-15 00:00:01.000000', 'temperatura', 558.0000, 'ºC'),
	(105674, 110, '2015-03-15 00:00:02.000000', 'temperatura', 1107.0000, 'ºC'),
	(105675, 110, '2015-03-15 00:00:03.000000', 'temperatura', 259.0000, 'ºC'),
	(105676, 110, '2015-03-15 00:00:04.000000', 'temperatura', 378.0000, 'ºC'),
	(105677, 110, '2015-03-15 00:00:05.000000', 'temperatura', 1110.0000, 'ºC'),
	(105678, 110, '2015-03-15 00:00:06.000000', 'temperatura', 819.0000, 'ºC'),
	(105679, 110, '2015-03-15 00:00:07.000000', 'temperatura', 764.0000, 'ºC'),
	(105680, 110, '2015-03-15 00:00:08.000000', 'temperatura', 163.0000, 'ºC'),
	(105681, 110, '2015-03-15 00:00:09.000000', 'temperatura', 922.0000, 'ºC'),
	(105682, 110, '2015-03-15 00:00:10.000000', 'temperatura', 525.0000, 'ºC'),
	(105683, 110, '2015-03-15 00:00:11.000000', 'temperatura', 1057.0000, 'ºC'),
	(105684, 110, '2015-03-15 00:00:12.000000', 'temperatura', 112.0000, 'ºC'),
	(105685, 110, '2015-03-15 00:00:13.000000', 'temperatura', 990.0000, 'ºC'),
	(105686, 110, '2015-03-15 00:00:14.000000', 'temperatura', 1016.0000, 'ºC'),
	(105687, 110, '2015-03-15 00:00:15.000000', 'temperatura', 909.0000, 'ºC'),
	(105688, 110, '2015-03-15 00:00:16.000000', 'temperatura', 296.0000, 'ºC'),
	(105689, 110, '2015-03-15 00:00:17.000000', 'temperatura', 1154.0000, 'ºC'),
	(105690, 110, '2015-03-15 00:00:18.000000', 'temperatura', 85.0000, 'ºC'),
	(105691, 110, '2015-03-15 00:00:19.000000', 'temperatura', 562.0000, 'ºC'),
	(105692, 110, '2015-03-15 00:00:20.000000', 'temperatura', 156.0000, 'ºC'),
	(105693, 110, '2015-03-15 00:00:21.000000', 'temperatura', 293.0000, 'ºC'),
	(105694, 110, '2015-03-15 00:00:22.000000', 'temperatura', 997.0000, 'ºC'),
	(105695, 110, '2015-03-15 00:00:23.000000', 'temperatura', 508.0000, 'ºC'),
	(105696, 110, '2015-03-15 00:00:24.000000', 'temperatura', 747.0000, 'ºC'),
	(105697, 110, '2015-03-15 00:00:25.000000', 'temperatura', 1014.0000, 'ºC'),
	(105698, 110, '2015-03-15 00:00:26.000000', 'temperatura', 431.0000, 'ºC'),
	(105699, 110, '2015-03-15 00:00:27.000000', 'temperatura', 310.0000, 'ºC'),
	(105700, 110, '2015-03-15 00:00:28.000000', 'temperatura', 259.0000, 'ºC'),
	(105701, 110, '2015-03-15 00:00:29.000000', 'temperatura', 365.0000, 'ºC'),
	(105702, 110, '2015-03-15 00:00:30.000000', 'temperatura', 1048.0000, 'ºC'),
	(105703, 110, '2015-03-15 00:00:31.000000', 'temperatura', 545.0000, 'ºC'),
	(105704, 110, '2015-03-15 00:00:32.000000', 'temperatura', 784.0000, 'ºC'),
	(105705, 110, '2015-03-15 00:00:33.000000', 'temperatura', 1082.0000, 'ºC'),
	(105706, 110, '2015-03-15 00:00:34.000000', 'temperatura', 662.0000, 'ºC'),
	(105707, 110, '2015-03-15 00:00:35.000000', 'temperatura', 61.0000, 'ºC'),
	(105708, 110, '2015-03-15 00:00:36.000000', 'temperatura', 723.0000, 'ºC'),
	(105709, 110, '2015-03-15 00:00:37.000000', 'temperatura', 1030.0000, 'ºC'),
	(105710, 110, '2015-03-15 00:00:38.000000', 'temperatura', 582.0000, 'ºC'),
	(105711, 110, '2015-03-15 00:00:39.000000', 'temperatura', 1021.0000, 'ºC'),
	(105712, 110, '2015-03-15 00:00:40.000000', 'temperatura', 960.0000, 'ºC'),
	(105713, 110, '2015-03-15 00:00:41.000000', 'temperatura', 535.0000, 'ºC'),
	(105714, 110, '2015-03-15 00:00:42.000000', 'temperatura', 998.0000, 'ºC'),
	(105715, 110, '2015-03-15 00:00:43.000000', 'temperatura', 985.0000, 'ºC'),
	(105716, 110, '2015-03-15 00:00:44.000000', 'temperatura', 732.0000, 'ºC'),
	(105717, 110, '2015-03-15 00:00:45.000000', 'temperatura', 705.0000, 'ºC'),
	(105718, 110, '2015-03-15 00:00:46.000000', 'temperatura', 131.0000, 'ºC'),
	(105719, 110, '2015-03-15 00:00:47.000000', 'temperatura', 941.0000, 'ºC'),
	(105720, 110, '2015-03-15 00:00:48.000000', 'temperatura', 711.0000, 'ºC'),
	(105721, 110, '2015-03-15 00:00:49.000000', 'temperatura', 732.0000, 'ºC'),
	(105722, 110, '2015-03-15 00:00:50.000000', 'temperatura', 330.0000, 'ºC'),
	(105723, 110, '2015-03-15 00:00:51.000000', 'temperatura', 654.0000, 'ºC'),
	(105724, 110, '2015-03-15 00:00:52.000000', 'temperatura', 1079.0000, 'ºC'),
	(105725, 110, '2015-03-15 00:00:53.000000', 'temperatura', 1036.0000, 'ºC'),
	(105726, 110, '2015-03-15 00:00:54.000000', 'temperatura', 740.0000, 'ºC'),
	(105727, 110, '2015-03-15 00:00:55.000000', 'temperatura', 595.0000, 'ºC'),
	(105728, 110, '2015-03-15 00:00:56.000000', 'temperatura', 757.0000, 'ºC'),
	(105729, 110, '2015-03-15 00:00:57.000000', 'temperatura', 797.0000, 'ºC'),
	(105730, 110, '2015-03-15 00:00:58.000000', 'temperatura', 517.0000, 'ºC'),
	(105731, 110, '2015-03-15 00:00:59.000000', 'temperatura', 193.0000, 'ºC'),
	(105732, 110, '2015-03-15 00:01:00.000000', 'temperatura', 617.0000, 'ºC'),
	(105733, 110, '2015-03-15 00:01:01.000000', 'temperatura', 104.0000, 'ºC'),
	(105734, 110, '2015-03-15 00:01:02.000000', 'temperatura', 1071.0000, 'ºC'),
	(105735, 110, '2015-03-15 00:01:03.000000', 'temperatura', 243.0000, 'ºC'),
	(105736, 110, '2015-03-15 00:01:04.000000', 'temperatura', 401.0000, 'ºC'),
	(105737, 110, '2015-03-15 00:01:05.000000', 'temperatura', 77.0000, 'ºC'),
	(105738, 110, '2015-03-15 00:01:06.000000', 'temperatura', 383.0000, 'ºC'),
	(105739, 110, '2015-03-15 00:01:07.000000', 'temperatura', 486.0000, 'ºC'),
	(105740, 110, '2015-03-15 00:01:08.000000', 'temperatura', 82.0000, 'ºC'),
	(105741, 110, '2015-03-15 00:01:09.000000', 'temperatura', 153.0000, 'ºC'),
	(105742, 110, '2015-03-15 00:01:10.000000', 'temperatura', 517.0000, 'ºC'),
	(105743, 110, '2015-03-15 00:01:11.000000', 'temperatura', 927.0000, 'ºC'),
	(105744, 110, '2015-03-15 00:01:12.000000', 'temperatura', 687.0000, 'ºC'),
	(105745, 110, '2015-03-15 00:01:13.000000', 'temperatura', 652.0000, 'ºC'),
	(105746, 110, '2015-03-15 00:01:14.000000', 'temperatura', 2.0000, 'ºC'),
	(105747, 110, '2015-03-15 00:01:15.000000', 'temperatura', 452.0000, 'ºC'),
	(105748, 110, '2015-03-15 00:01:16.000000', 'temperatura', 1056.0000, 'ºC'),
	(105749, 110, '2015-03-15 00:01:17.000000', 'temperatura', 323.0000, 'ºC'),
	(105750, 110, '2015-03-15 00:01:18.000000', 'temperatura', 847.0000, 'ºC'),
	(105751, 110, '2015-03-15 00:01:19.000000', 'temperatura', 869.0000, 'ºC'),
	(105752, 110, '2015-03-15 00:01:20.000000', 'temperatura', 604.0000, 'ºC'),
	(105753, 110, '2015-03-15 00:01:21.000000', 'temperatura', 412.0000, 'ºC'),
	(105754, 110, '2015-03-15 00:01:22.000000', 'temperatura', 250.0000, 'ºC'),
	(105755, 110, '2015-03-15 00:01:23.000000', 'temperatura', 12.0000, 'ºC'),
	(105756, 110, '2015-03-15 00:01:24.000000', 'temperatura', 513.0000, 'ºC'),
	(105757, 110, '2015-03-15 00:01:25.000000', 'temperatura', 131.0000, 'ºC'),
	(105758, 110, '2015-03-15 00:01:26.000000', 'temperatura', 313.0000, 'ºC'),
	(105759, 110, '2015-03-15 00:01:27.000000', 'temperatura', 1174.0000, 'ºC'),
	(105760, 110, '2015-03-15 00:01:28.000000', 'temperatura', 130.0000, 'ºC'),
	(105761, 110, '2015-03-15 00:01:29.000000', 'temperatura', 728.0000, 'ºC'),
	(105762, 110, '2015-03-15 00:01:30.000000', 'temperatura', 851.0000, 'ºC'),
	(105763, 110, '2015-03-15 00:01:31.000000', 'temperatura', 871.0000, 'ºC'),
	(105764, 110, '2015-03-15 00:01:32.000000', 'temperatura', 604.0000, 'ºC'),
	(105765, 110, '2015-03-15 00:01:33.000000', 'temperatura', 405.0000, 'ºC'),
	(105766, 110, '2015-03-15 00:01:34.000000', 'temperatura', 215.0000, 'ºC'),
	(105767, 110, '2015-03-15 00:01:35.000000', 'temperatura', 1060.0000, 'ºC'),
	(105768, 110, '2015-03-15 00:01:36.000000', 'temperatura', 1054.0000, 'ºC'),
	(105769, 110, '2015-03-15 00:01:37.000000', 'temperatura', 890.0000, 'ºC'),
	(105770, 110, '2015-03-15 00:01:38.000000', 'temperatura', 91.0000, 'ºC'),
	(105771, 110, '2015-03-15 00:01:39.000000', 'temperatura', 187.0000, 'ºC'),
	(105772, 110, '2015-03-15 00:01:40.000000', 'temperatura', 659.0000, 'ºC'),
	(105773, 110, '2015-03-15 00:01:41.000000', 'temperatura', 335.0000, 'ºC'),
	(105774, 110, '2015-03-15 00:01:42.000000', 'temperatura', 897.0000, 'ºC'),
	(105775, 110, '2015-03-15 00:01:43.000000', 'temperatura', 1083.0000, 'ºC'),
	(105776, 110, '2015-03-15 00:01:44.000000', 'temperatura', 323.0000, 'ºC'),
	(105777, 110, '2015-03-15 00:01:45.000000', 'temperatura', 769.0000, 'ºC'),
	(105778, 110, '2015-03-15 00:01:46.000000', 'temperatura', 474.0000, 'ºC'),
	(105779, 110, '2015-03-15 00:01:47.000000', 'temperatura', 66.0000, 'ºC'),
	(105780, 110, '2015-03-15 00:01:48.000000', 'temperatura', 106.0000, 'ºC'),
	(105781, 110, '2015-03-15 00:01:49.000000', 'temperatura', 332.0000, 'ºC'),
	(105782, 110, '2015-03-15 00:01:50.000000', 'temperatura', 145.0000, 'ºC'),
	(105783, 110, '2015-03-15 00:01:51.000000', 'temperatura', 928.0000, 'ºC'),
	(105784, 110, '2015-03-15 00:01:52.000000', 'temperatura', 606.0000, 'ºC'),
	(105785, 110, '2015-03-15 00:01:53.000000', 'temperatura', 246.0000, 'ºC'),
	(105786, 110, '2015-03-15 00:01:54.000000', 'temperatura', 613.0000, 'ºC'),
	(105787, 110, '2015-03-15 00:01:55.000000', 'temperatura', 1126.0000, 'ºC'),
	(105788, 110, '2015-03-15 00:01:56.000000', 'temperatura', 190.0000, 'ºC'),
	(105789, 110, '2015-03-15 00:01:57.000000', 'temperatura', 1176.0000, 'ºC'),
	(105790, 110, '2015-03-15 00:01:58.000000', 'temperatura', 507.0000, 'ºC'),
	(105791, 110, '2015-03-15 00:01:59.000000', 'temperatura', 211.0000, 'ºC'),
	(105792, 110, '2015-03-15 00:02:00.000000', 'temperatura', 731.0000, 'ºC'),
	(105793, 110, '2015-03-15 00:02:01.000000', 'temperatura', 625.0000, 'ºC'),
	(105794, 110, '2015-03-15 00:02:02.000000', 'temperatura', 931.0000, 'ºC'),
	(105795, 110, '2015-03-15 00:02:03.000000', 'temperatura', 382.0000, 'ºC'),
	(105796, 110, '2015-03-15 00:02:04.000000', 'temperatura', 317.0000, 'ºC'),
	(105797, 110, '2015-03-15 00:02:05.000000', 'temperatura', 440.0000, 'ºC'),
	(105798, 110, '2015-03-15 00:02:06.000000', 'temperatura', 47.0000, 'ºC'),
	(105799, 110, '2015-03-15 00:02:07.000000', 'temperatura', 117.0000, 'ºC'),
	(105800, 110, '2015-03-15 00:02:08.000000', 'temperatura', 446.0000, 'ºC'),
	(105801, 110, '2015-03-15 00:02:09.000000', 'temperatura', 678.0000, 'ºC'),
	(105802, 110, '2015-03-15 00:02:10.000000', 'temperatura', 854.0000, 'ºC'),
	(105803, 110, '2015-03-15 00:02:11.000000', 'temperatura', 1034.0000, 'ºC'),
	(105804, 110, '2015-03-15 00:02:12.000000', 'temperatura', 210.0000, 'ºC'),
	(105805, 110, '2015-03-15 00:02:13.000000', 'temperatura', 349.0000, 'ºC'),
	(105806, 110, '2015-03-15 00:02:14.000000', 'temperatura', 1116.0000, 'ºC'),
	(105807, 110, '2015-03-15 00:02:15.000000', 'temperatura', 932.0000, 'ºC'),
	(105808, 110, '2015-03-15 00:02:16.000000', 'temperatura', 114.0000, 'ºC'),
	(105809, 110, '2015-03-15 00:02:17.000000', 'temperatura', 174.0000, 'ºC'),
	(105810, 110, '2015-03-15 00:02:18.000000', 'temperatura', 530.0000, 'ºC'),
	(105811, 110, '2015-03-15 00:02:19.000000', 'temperatura', 928.0000, 'ºC'),
	(105812, 110, '2015-03-15 00:02:20.000000', 'temperatura', 650.0000, 'ºC'),
	(105813, 110, '2015-03-15 00:02:21.000000', 'temperatura', 467.0000, 'ºC'),
	(105814, 110, '2015-03-15 00:02:22.000000', 'temperatura', 387.0000, 'ºC'),
	(105815, 110, '2015-03-15 00:02:23.000000', 'temperatura', 533.0000, 'ºC'),
	(105816, 110, '2015-03-15 00:02:24.000000', 'temperatura', 303.0000, 'ºC'),
	(105817, 110, '2015-03-15 00:02:25.000000', 'temperatura', 1118.0000, 'ºC'),
	(105818, 110, '2015-03-15 00:02:26.000000', 'temperatura', 1083.0000, 'ºC'),
	(105819, 110, '2015-03-15 00:02:27.000000', 'temperatura', 861.0000, 'ºC'),
	(105820, 110, '2015-03-15 00:02:28.000000', 'temperatura', 1056.0000, 'ºC'),
	(105821, 110, '2015-03-15 00:02:29.000000', 'temperatura', 297.0000, 'ºC'),
	(105822, 110, '2015-03-15 00:02:30.000000', 'temperatura', 717.0000, 'ºC'),
	(105823, 110, '2015-03-15 00:02:31.000000', 'temperatura', 296.0000, 'ºC'),
	(105824, 110, '2015-03-15 00:02:32.000000', 'temperatura', 530.0000, 'ºC'),
	(105825, 110, '2015-03-15 00:02:33.000000', 'temperatura', 561.0000, 'ºC'),
	(105826, 110, '2015-03-15 00:02:34.000000', 'temperatura', 15.0000, 'ºC'),
	(105827, 110, '2015-03-15 00:02:35.000000', 'temperatura', 792.0000, 'ºC'),
	(105828, 110, '2015-03-15 00:02:36.000000', 'temperatura', 315.0000, 'ºC'),
	(105829, 110, '2015-03-15 00:02:37.000000', 'temperatura', 400.0000, 'ºC'),
	(105830, 110, '2015-03-15 00:02:38.000000', 'temperatura', 1057.0000, 'ºC'),
	(105831, 110, '2015-03-15 00:02:39.000000', 'temperatura', 484.0000, 'ºC'),
	(105832, 110, '2015-03-15 00:02:40.000000', 'temperatura', 450.0000, 'ºC'),
	(105833, 110, '2015-03-15 00:02:41.000000', 'temperatura', 800.0000, 'ºC'),
	(105834, 110, '2015-03-15 00:02:42.000000', 'temperatura', 248.0000, 'ºC'),
	(105835, 110, '2015-03-15 00:02:43.000000', 'temperatura', 42.0000, 'ºC'),
	(105836, 110, '2015-03-15 00:02:44.000000', 'temperatura', 667.0000, 'ºC'),
	(105837, 110, '2015-03-15 00:02:45.000000', 'temperatura', 811.0000, 'ºC'),
	(105838, 110, '2015-03-15 00:02:46.000000', 'temperatura', 853.0000, 'ºC'),
	(105839, 110, '2015-03-15 00:02:47.000000', 'temperatura', 631.0000, 'ºC'),
	(105840, 110, '2015-03-15 00:02:48.000000', 'temperatura', 599.0000, 'ºC'),
	(105841, 110, '2015-03-15 00:02:49.000000', 'temperatura', 1100.0000, 'ºC'),
	(105842, 110, '2015-03-15 00:02:50.000000', 'temperatura', 106.0000, 'ºC'),
	(105843, 110, '2015-03-15 00:02:51.000000', 'temperatura', 830.0000, 'ºC'),
	(105844, 110, '2015-03-15 00:02:52.000000', 'temperatura', 233.0000, 'ºC'),
	(105845, 110, '2015-03-15 00:02:53.000000', 'temperatura', 1073.0000, 'ºC'),
	(105846, 110, '2015-03-15 00:02:54.000000', 'temperatura', 1069.0000, 'ºC'),
	(105847, 110, '2015-03-15 00:02:55.000000', 'temperatura', 927.0000, 'ºC'),
	(105848, 110, '2015-03-15 00:02:56.000000', 'temperatura', 229.0000, 'ºC'),
	(105849, 110, '2015-03-15 00:02:57.000000', 'temperatura', 763.0000, 'ºC'),
	(105850, 110, '2015-03-15 00:02:58.000000', 'temperatura', 728.0000, 'ºC'),
	(105851, 110, '2015-03-15 00:02:59.000000', 'temperatura', 154.0000, 'ºC'),
	(105852, 110, '2015-03-15 00:03:00.000000', 'temperatura', 983.0000, 'ºC'),
	(105853, 110, '2015-03-15 00:03:01.000000', 'temperatura', 856.0000, 'ºC'),
	(105854, 110, '2015-03-15 00:03:02.000000', 'temperatura', 130.0000, 'ºC'),
	(105855, 110, '2015-03-15 00:03:03.000000', 'temperatura', 482.0000, 'ºC'),
	(105856, 110, '2015-03-15 00:03:04.000000', 'temperatura', 820.0000, 'ºC'),
	(105857, 110, '2015-03-15 00:03:05.000000', 'temperatura', 255.0000, 'ºC'),
	(105858, 110, '2015-03-15 00:03:06.000000', 'temperatura', 16.0000, 'ºC'),
	(105859, 110, '2015-03-15 00:03:07.000000', 'temperatura', 513.0000, 'ºC'),
	(105860, 110, '2015-03-15 00:03:08.000000', 'temperatura', 121.0000, 'ºC'),
	(105861, 110, '2015-03-15 00:03:09.000000', 'temperatura', 265.0000, 'ºC'),
	(105862, 110, '2015-03-15 00:03:10.000000', 'temperatura', 961.0000, 'ºC'),
	(105863, 110, '2015-03-15 00:03:11.000000', 'temperatura', 411.0000, 'ºC'),
	(105864, 110, '2015-03-15 00:03:12.000000', 'temperatura', 375.0000, 'ºC'),
	(105865, 110, '2015-03-15 00:03:13.000000', 'temperatura', 641.0000, 'ºC'),
	(105866, 110, '2015-03-15 00:03:14.000000', 'temperatura', 880.0000, 'ºC'),
	(105867, 110, '2015-03-15 00:03:15.000000', 'temperatura', 78.0000, 'ºC'),
	(105868, 110, '2015-03-15 00:03:16.000000', 'temperatura', 151.0000, 'ºC'),
	(105869, 110, '2015-03-15 00:03:17.000000', 'temperatura', 523.0000, 'ºC'),
	(105870, 110, '2015-03-15 00:03:18.000000', 'temperatura', 960.0000, 'ºC'),
	(105871, 110, '2015-03-15 00:03:19.000000', 'temperatura', 832.0000, 'ºC'),
	(105872, 110, '2015-03-15 00:03:20.000000', 'temperatura', 80.0000, 'ºC'),
	(105873, 110, '2015-03-15 00:03:21.000000', 'temperatura', 304.0000, 'ºC'),
	(105874, 110, '2015-03-15 00:03:22.000000', 'temperatura', 81.0000, 'ºC'),
	(105875, 110, '2015-03-15 00:03:23.000000', 'temperatura', 695.0000, 'ºC'),
	(105876, 110, '2015-03-15 00:03:24.000000', 'temperatura', 833.0000, 'ºC'),
	(105877, 110, '2015-03-15 00:03:25.000000', 'temperatura', 878.0000, 'ºC'),
	(105878, 110, '2015-03-15 00:03:26.000000', 'temperatura', 691.0000, 'ºC'),
	(105879, 110, '2015-03-15 00:03:27.000000', 'temperatura', 821.0000, 'ºC'),
	(105880, 110, '2015-03-15 00:03:28.000000', 'temperatura', 834.0000, 'ºC'),
	(105881, 110, '2015-03-15 00:03:29.000000', 'temperatura', 509.0000, 'ºC'),
	(105882, 110, '2015-03-15 00:03:30.000000', 'temperatura', 42.0000, 'ºC'),
	(105883, 110, '2015-03-15 00:03:31.000000', 'temperatura', 1084.0000, 'ºC'),
	(105884, 110, '2015-03-15 00:03:32.000000', 'temperatura', 493.0000, 'ºC'),
	(105885, 110, '2015-03-15 00:03:33.000000', 'temperatura', 414.0000, 'ºC'),
	(105886, 110, '2015-03-15 00:03:34.000000', 'temperatura', 591.0000, 'ºC'),
	(105887, 110, '2015-03-15 00:03:35.000000', 'temperatura', 513.0000, 'ºC'),
	(105888, 110, '2015-03-15 00:03:36.000000', 'temperatura', 793.0000, 'ºC'),
	(105889, 110, '2015-03-15 00:03:37.000000', 'temperatura', 27.0000, 'ºC'),
	(105890, 110, '2015-03-15 00:03:38.000000', 'temperatura', 155.0000, 'ºC'),
	(105891, 110, '2015-03-15 00:03:39.000000', 'temperatura', 694.0000, 'ºC'),
	(105892, 110, '2015-03-15 00:03:40.000000', 'temperatura', 606.0000, 'ºC'),
	(105893, 110, '2015-03-15 00:03:41.000000', 'temperatura', 951.0000, 'ºC'),
	(105894, 110, '2015-03-15 00:03:42.000000', 'temperatura', 534.0000, 'ºC'),
	(105895, 110, '2015-03-15 00:03:43.000000', 'temperatura', 1019.0000, 'ºC'),
	(105896, 110, '2015-03-15 00:03:44.000000', 'temperatura', 1094.0000, 'ºC'),
	(105897, 110, '2015-03-15 00:03:45.000000', 'temperatura', 12.0000, 'ºC'),
	(105898, 110, '2015-03-15 00:03:46.000000', 'temperatura', 379.0000, 'ºC'),
	(105899, 110, '2015-03-15 00:03:47.000000', 'temperatura', 658.0000, 'ºC'),
	(105900, 110, '2015-03-15 00:03:48.000000', 'temperatura', 953.0000, 'ºC'),
	(105901, 110, '2015-03-15 00:03:49.000000', 'temperatura', 394.0000, 'ºC'),
	(105902, 110, '2015-03-15 00:03:50.000000', 'temperatura', 310.0000, 'ºC'),
	(105903, 110, '2015-03-15 00:03:51.000000', 'temperatura', 370.0000, 'ºC'),
	(105904, 110, '2015-03-15 00:03:52.000000', 'temperatura', 918.0000, 'ºC'),
	(105905, 110, '2015-03-15 00:03:53.000000', 'temperatura', 1081.0000, 'ºC'),
	(105906, 110, '2015-03-15 00:03:54.000000', 'temperatura', 253.0000, 'ºC'),
	(105907, 110, '2015-03-15 00:03:55.000000', 'temperatura', 420.0000, 'ºC'),
	(105908, 110, '2015-03-15 00:03:56.000000', 'temperatura', 143.0000, 'ºC'),
	(105909, 110, '2015-03-15 00:03:57.000000', 'temperatura', 656.0000, 'ºC'),
	(105910, 110, '2015-03-15 00:03:58.000000', 'temperatura', 452.0000, 'ºC'),
	(105911, 110, '2015-03-15 00:03:59.000000', 'temperatura', 291.0000, 'ºC'),
	(105912, 110, '2015-03-15 00:04:00.000000', 'temperatura', 99.0000, 'ºC'),
	(105913, 110, '2015-03-15 00:04:01.000000', 'temperatura', 825.0000, 'ºC'),
	(105914, 110, '2015-03-15 00:04:02.000000', 'temperatura', 229.0000, 'ºC'),
	(105915, 110, '2015-03-15 00:04:03.000000', 'temperatura', 1069.0000, 'ºC'),
	(105916, 110, '2015-03-15 00:04:04.000000', 'temperatura', 1058.0000, 'ºC'),
	(105917, 110, '2015-03-15 00:04:05.000000', 'temperatura', 884.0000, 'ºC'),
	(105918, 110, '2015-03-15 00:04:06.000000', 'temperatura', 46.0000, 'ºC'),
	(105919, 110, '2015-03-15 00:04:07.000000', 'temperatura', 1180.0000, 'ºC'),
	(105920, 110, '2015-03-15 00:04:08.000000', 'temperatura', 960.0000, 'ºC'),
	(105921, 110, '2015-03-15 00:04:09.000000', 'temperatura', 61.0000, 'ºC'),
	(105922, 110, '2015-03-15 00:04:10.000000', 'temperatura', 1026.0000, 'ºC'),
	(105923, 110, '2015-03-15 00:04:11.000000', 'temperatura', 148.0000, 'ºC'),
	(105924, 110, '2015-03-15 00:04:12.000000', 'temperatura', 61.0000, 'ºC'),
	(105925, 110, '2015-03-15 00:04:13.000000', 'temperatura', 1063.0000, 'ºC'),
	(105926, 110, '2015-03-15 00:04:14.000000', 'temperatura', 334.0000, 'ºC'),
	(105927, 110, '2015-03-15 00:04:15.000000', 'temperatura', 881.0000, 'ºC'),
	(105928, 110, '2015-03-15 00:04:16.000000', 'temperatura', 1001.0000, 'ºC'),
	(105929, 110, '2015-03-15 00:04:17.000000', 'temperatura', 1163.0000, 'ºC'),
	(105930, 110, '2015-03-15 00:04:18.000000', 'temperatura', 413.0000, 'ºC'),
	(105931, 110, '2015-03-15 00:04:19.000000', 'temperatura', 977.0000, 'ºC'),
	(105932, 110, '2015-03-15 00:04:20.000000', 'temperatura', 46.0000, 'ºC'),
	(105933, 110, '2015-03-15 00:04:21.000000', 'temperatura', 898.0000, 'ºC'),
	(105934, 110, '2015-03-15 00:04:22.000000', 'temperatura', 755.0000, 'ºC'),
	(105935, 110, '2015-03-15 00:04:23.000000', 'temperatura', 1081.0000, 'ºC'),
	(105936, 110, '2015-03-15 00:04:24.000000', 'temperatura', 741.0000, 'ºC'),
	(105937, 110, '2015-03-15 00:04:25.000000', 'temperatura', 463.0000, 'ºC'),
	(105938, 110, '2015-03-15 00:04:26.000000', 'temperatura', 92.0000, 'ºC'),
	(105939, 110, '2015-03-15 00:04:27.000000', 'temperatura', 271.0000, 'ºC'),
	(105940, 110, '2015-03-15 00:04:28.000000', 'temperatura', 1082.0000, 'ºC'),
	(105941, 110, '2015-03-15 00:04:29.000000', 'temperatura', 995.0000, 'ºC'),
	(105942, 110, '2015-03-15 00:04:30.000000', 'temperatura', 528.0000, 'ºC'),
	(105943, 110, '2015-03-15 00:04:31.000000', 'temperatura', 859.0000, 'ºC'),
	(105944, 110, '2015-03-15 00:04:32.000000', 'temperatura', 309.0000, 'ºC'),
	(105945, 110, '2015-03-15 00:04:33.000000', 'temperatura', 169.0000, 'ºC'),
	(105946, 110, '2015-03-15 00:04:34.000000', 'temperatura', 1118.0000, 'ºC'),
	(105947, 110, '2015-03-15 00:04:35.000000', 'temperatura', 286.0000, 'ºC'),
	(105948, 110, '2015-03-15 00:04:36.000000', 'temperatura', 476.0000, 'ºC'),
	(105949, 110, '2015-03-15 00:04:37.000000', 'temperatura', 320.0000, 'ºC'),
	(105950, 110, '2015-03-15 00:04:38.000000', 'temperatura', 173.0000, 'ºC'),
	(105951, 110, '2015-03-15 00:04:39.000000', 'temperatura', 1107.0000, 'ºC'),
	(105952, 110, '2015-03-15 00:04:40.000000', 'temperatura', 217.0000, 'ºC'),
	(105953, 110, '2015-03-15 00:04:41.000000', 'temperatura', 163.0000, 'ºC'),
	(105954, 110, '2015-03-15 00:04:42.000000', 'temperatura', 166.0000, 'ºC'),
	(105955, 110, '2015-03-15 00:04:43.000000', 'temperatura', 341.0000, 'ºC'),
	(105956, 110, '2015-03-15 00:04:44.000000', 'temperatura', 6.0000, 'ºC'),
	(105957, 110, '2015-03-15 00:04:45.000000', 'temperatura', 208.0000, 'ºC'),
	(105958, 110, '2015-03-15 00:04:46.000000', 'temperatura', 1022.0000, 'ºC'),
	(105959, 110, '2015-03-15 00:04:47.000000', 'temperatura', 888.0000, 'ºC'),
	(105960, 110, '2015-03-15 00:04:48.000000', 'temperatura', 175.0000, 'ºC'),
	(105961, 110, '2015-03-15 00:04:49.000000', 'temperatura', 610.0000, 'ºC'),
	(105962, 110, '2015-03-15 00:04:50.000000', 'temperatura', 127.0000, 'ºC'),
	(105963, 110, '2015-03-15 00:04:51.000000', 'temperatura', 6.0000, 'ºC'),
	(105964, 110, '2015-03-15 00:04:52.000000', 'temperatura', 847.0000, 'ºC'),
	(105965, 110, '2015-03-15 00:04:53.000000', 'temperatura', 621.0000, 'ºC'),
	(105966, 110, '2015-03-15 00:04:54.000000', 'temperatura', 561.0000, 'ºC'),
	(105967, 110, '2015-03-15 00:04:55.000000', 'temperatura', 944.0000, 'ºC'),
	(105968, 110, '2015-03-15 00:04:56.000000', 'temperatura', 635.0000, 'ºC'),
	(105969, 110, '2015-03-15 00:04:57.000000', 'temperatura', 347.0000, 'ºC'),
	(105970, 110, '2015-03-15 00:04:58.000000', 'temperatura', 1029.0000, 'ºC'),
	(105971, 110, '2015-03-15 00:04:59.000000', 'temperatura', 503.0000, 'ºC'),
	(105972, 110, '2015-03-15 00:05:00.000000', 'temperatura', 628.0000, 'ºC'),
	(105973, 110, '2015-03-15 00:05:01.000000', 'temperatura', 434.0000, 'ºC'),
	(105974, 110, '2015-03-15 00:05:02.000000', 'temperatura', 286.0000, 'ºC'),
	(105975, 110, '2015-03-15 00:05:03.000000', 'temperatura', 128.0000, 'ºC'),
	(105976, 110, '2015-03-15 00:05:04.000000', 'temperatura', 984.0000, 'ºC'),
	(105977, 110, '2015-03-15 00:05:05.000000', 'temperatura', 937.0000, 'ºC'),
	(105978, 110, '2015-03-15 00:05:06.000000', 'temperatura', 531.0000, 'ºC'),
	(105979, 110, '2015-03-15 00:05:07.000000', 'temperatura', 1047.0000, 'ºC'),
	(105980, 110, '2015-03-15 00:05:08.000000', 'temperatura', 43.0000, 'ºC'),
	(105981, 110, '2015-03-15 00:05:09.000000', 'temperatura', 675.0000, 'ºC'),
	(105982, 110, '2015-03-15 00:05:10.000000', 'temperatura', 846.0000, 'ºC'),
	(105983, 110, '2015-03-15 00:05:11.000000', 'temperatura', 1005.0000, 'ºC'),
	(105984, 110, '2015-03-15 00:05:12.000000', 'temperatura', 88.0000, 'ºC'),
	(105985, 110, '2015-03-15 00:05:13.000000', 'temperatura', 1026.0000, 'ºC'),
	(105986, 110, '2015-03-15 00:05:14.000000', 'temperatura', 68.0000, 'ºC'),
	(105987, 110, '2015-03-15 00:05:15.000000', 'temperatura', 861.0000, 'ºC'),
	(105988, 110, '2015-03-15 00:05:16.000000', 'temperatura', 503.0000, 'ºC'),
	(105989, 110, '2015-03-15 00:05:17.000000', 'temperatura', 1133.0000, 'ºC'),
	(105990, 110, '2015-03-15 00:05:18.000000', 'temperatura', 554.0000, 'ºC'),
	(105991, 110, '2015-03-15 00:05:19.000000', 'temperatura', 574.0000, 'ºC'),
	(105992, 110, '2015-03-15 00:05:20.000000', 'temperatura', 7.0000, 'ºC'),
	(105993, 110, '2015-03-15 00:05:21.000000', 'temperatura', 713.0000, 'ºC'),
	(105994, 110, '2015-03-15 00:05:22.000000', 'temperatura', 1147.0000, 'ºC'),
	(105995, 110, '2015-03-15 00:05:23.000000', 'temperatura', 1196.0000, 'ºC'),
	(105996, 110, '2015-03-15 00:05:24.000000', 'temperatura', 138.0000, 'ºC'),
	(105997, 110, '2015-03-15 00:05:25.000000', 'temperatura', 703.0000, 'ºC'),
	(105998, 110, '2015-03-15 00:05:26.000000', 'temperatura', 703.0000, 'ºC'),
	(105999, 110, '2015-03-15 00:05:27.000000', 'temperatura', 204.0000, 'ºC'),
	(106000, 110, '2015-03-15 00:05:28.000000', 'temperatura', 114.0000, 'ºC'),
	(106001, 110, '2015-03-15 00:05:29.000000', 'temperatura', 1158.0000, 'ºC'),
	(106002, 110, '2015-03-15 00:05:30.000000', 'temperatura', 648.0000, 'ºC'),
	(106003, 110, '2015-03-15 00:05:31.000000', 'temperatura', 968.0000, 'ºC'),
	(106004, 110, '2015-03-15 00:05:32.000000', 'temperatura', 497.0000, 'ºC'),
	(106005, 110, '2015-03-15 00:05:33.000000', 'temperatura', 779.0000, 'ºC'),
	(106006, 110, '2015-03-15 00:05:34.000000', 'temperatura', 4.0000, 'ºC'),
	(106007, 110, '2015-03-15 00:05:35.000000', 'temperatura', 85.0000, 'ºC'),
	(106008, 110, '2015-03-15 00:05:36.000000', 'temperatura', 412.0000, 'ºC'),
	(106009, 110, '2015-03-15 00:05:37.000000', 'temperatura', 604.0000, 'ºC'),
	(106010, 110, '2015-03-15 00:05:38.000000', 'temperatura', 588.0000, 'ºC'),
	(106011, 110, '2015-03-15 00:05:39.000000', 'temperatura', 1127.0000, 'ºC'),
	(106012, 110, '2015-03-15 00:05:40.000000', 'temperatura', 270.0000, 'ºC'),
	(106013, 110, '2015-03-15 00:05:41.000000', 'temperatura', 369.0000, 'ºC'),
	(106014, 110, '2015-03-15 00:05:42.000000', 'temperatura', 1037.0000, 'ºC'),
	(106015, 110, '2015-03-15 00:05:43.000000', 'temperatura', 477.0000, 'ºC'),
	(106016, 110, '2015-03-15 00:05:44.000000', 'temperatura', 474.0000, 'ºC'),
	(106017, 110, '2015-03-15 00:05:45.000000', 'temperatura', 940.0000, 'ºC'),
	(106018, 110, '2015-03-15 00:05:46.000000', 'temperatura', 881.0000, 'ºC'),
	(106019, 110, '2015-03-15 00:05:47.000000', 'temperatura', 384.0000, 'ºC'),
	(106020, 110, '2015-03-15 00:05:48.000000', 'temperatura', 476.0000, 'ºC'),
	(106021, 110, '2015-03-15 00:05:49.000000', 'temperatura', 29.0000, 'ºC'),
	(106022, 110, '2015-03-15 00:05:50.000000', 'temperatura', 1117.0000, 'ºC'),
	(106023, 110, '2015-03-15 00:05:51.000000', 'temperatura', 701.0000, 'ºC'),
	(106024, 110, '2015-03-15 00:05:52.000000', 'temperatura', 152.0000, 'ºC'),
	(106025, 110, '2015-03-15 00:05:53.000000', 'temperatura', 1056.0000, 'ºC'),
	(106026, 110, '2015-03-15 00:05:54.000000', 'temperatura', 27.0000, 'ºC'),
	(106027, 110, '2015-03-15 00:05:55.000000', 'temperatura', 568.0000, 'ºC'),
	(106028, 110, '2015-03-15 00:05:56.000000', 'temperatura', 358.0000, 'ºC'),
	(106029, 110, '2015-03-15 00:05:57.000000', 'temperatura', 87.0000, 'ºC'),
	(106030, 110, '2015-03-15 00:05:58.000000', 'temperatura', 563.0000, 'ºC'),
	(106031, 110, '2015-03-15 00:05:59.000000', 'temperatura', 153.0000, 'ºC'),
	(106032, 110, '2015-03-15 00:06:00.000000', 'temperatura', 278.0000, 'ºC'),
	(106033, 110, '2015-03-15 00:06:01.000000', 'temperatura', 932.0000, 'ºC'),
	(106034, 110, '2015-03-15 00:06:02.000000', 'temperatura', 224.0000, 'ºC'),
	(106035, 110, '2015-03-15 00:06:03.000000', 'temperatura', 726.0000, 'ºC'),
	(106036, 110, '2015-03-15 00:06:04.000000', 'temperatura', 557.0000, 'ºC'),
	(106037, 110, '2015-03-15 00:06:05.000000', 'temperatura', 610.0000, 'ºC'),
	(106038, 110, '2015-03-15 00:06:06.000000', 'temperatura', 177.0000, 'ºC'),
	(106039, 110, '2015-03-15 00:06:07.000000', 'temperatura', 258.0000, 'ºC'),
	(106040, 110, '2015-03-15 00:06:08.000000', 'temperatura', 759.0000, 'ºC'),
	(106041, 110, '2015-03-15 00:06:09.000000', 'temperatura', 619.0000, 'ºC'),
	(106042, 110, '2015-03-15 00:06:10.000000', 'temperatura', 820.0000, 'ºC'),
	(106043, 110, '2015-03-15 00:06:11.000000', 'temperatura', 1043.0000, 'ºC'),
	(106044, 110, '2015-03-15 00:06:12.000000', 'temperatura', 356.0000, 'ºC'),
	(106045, 110, '2015-03-15 00:06:13.000000', 'temperatura', 1051.0000, 'ºC'),
	(106046, 110, '2015-03-15 00:06:14.000000', 'temperatura', 589.0000, 'ºC'),
	(106047, 110, '2015-03-15 00:06:15.000000', 'temperatura', 990.0000, 'ºC'),
	(106048, 110, '2015-03-15 00:06:16.000000', 'temperatura', 787.0000, 'ºC'),
	(106049, 110, '2015-03-15 00:06:17.000000', 'temperatura', 962.0000, 'ºC'),
	(106050, 110, '2015-03-15 00:06:18.000000', 'temperatura', 50.0000, 'ºC'),
	(106051, 110, '2015-03-15 00:06:19.000000', 'temperatura', 967.0000, 'ºC'),
	(106052, 110, '2015-03-15 00:06:20.000000', 'temperatura', 1084.0000, 'ºC'),
	(106053, 110, '2015-03-15 00:06:21.000000', 'temperatura', 118.0000, 'ºC'),
	(106054, 110, '2015-03-15 00:06:22.000000', 'temperatura', 938.0000, 'ºC'),
	(106055, 110, '2015-03-15 00:06:23.000000', 'temperatura', 739.0000, 'ºC'),
	(106056, 110, '2015-03-15 00:06:24.000000', 'temperatura', 878.0000, 'ºC'),
	(106057, 110, '2015-03-15 00:06:25.000000', 'temperatura', 977.0000, 'ºC'),
	(106058, 110, '2015-03-15 00:06:26.000000', 'temperatura', 1050.0000, 'ºC'),
	(106059, 110, '2015-03-15 00:06:27.000000', 'temperatura', 1121.0000, 'ºC'),
	(106060, 110, '2015-03-15 00:06:28.000000', 'temperatura', 54.0000, 'ºC'),
	(106061, 110, '2015-03-15 00:06:29.000000', 'temperatura', 509.0000, 'ºC'),
	(106062, 110, '2015-03-15 00:06:30.000000', 'temperatura', 1182.0000, 'ºC'),
	(106063, 110, '2015-03-15 00:06:31.000000', 'temperatura', 784.0000, 'ºC'),
	(106064, 110, '2015-03-15 00:06:32.000000', 'temperatura', 376.0000, 'ºC'),
	(106065, 110, '2015-03-15 00:06:33.000000', 'temperatura', 728.0000, 'ºC'),
	(106066, 110, '2015-03-15 00:06:34.000000', 'temperatura', 113.0000, 'ºC'),
	(106067, 110, '2015-03-15 00:06:35.000000', 'temperatura', 782.0000, 'ºC'),
	(106068, 110, '2015-03-15 00:06:36.000000', 'temperatura', 1170.0000, 'ºC'),
	(106069, 110, '2015-03-15 00:06:37.000000', 'temperatura', 1107.0000, 'ºC'),
	(106070, 110, '2015-03-15 00:06:38.000000', 'temperatura', 824.0000, 'ºC'),
	(106071, 110, '2015-03-15 00:06:39.000000', 'temperatura', 800.0000, 'ºC'),
	(106072, 110, '2015-03-15 00:06:40.000000', 'temperatura', 329.0000, 'ºC'),
	(106073, 110, '2015-03-15 00:06:41.000000', 'temperatura', 444.0000, 'ºC'),
	(106074, 110, '2015-03-15 00:06:42.000000', 'temperatura', 32.0000, 'ºC'),
	(106075, 110, '2015-03-15 00:06:43.000000', 'temperatura', 31.0000, 'ºC'),
	(106076, 110, '2015-03-15 00:06:44.000000', 'temperatura', 58.0000, 'ºC'),
	(106077, 110, '2015-03-15 00:06:45.000000', 'temperatura', 200.0000, 'ºC'),
	(106078, 110, '2015-03-15 00:06:46.000000', 'temperatura', 824.0000, 'ºC'),
	(106079, 110, '2015-03-15 00:06:47.000000', 'temperatura', 1123.0000, 'ºC'),
	(106080, 110, '2015-03-15 00:06:48.000000', 'temperatura', 741.0000, 'ºC'),
	(106081, 110, '2015-03-15 00:06:49.000000', 'temperatura', 338.0000, 'ºC'),
	(106082, 110, '2015-03-15 00:06:50.000000', 'temperatura', 667.0000, 'ºC'),
	(106083, 110, '2015-03-15 00:06:51.000000', 'temperatura', 1120.0000, 'ºC'),
	(106084, 110, '2015-03-15 00:06:52.000000', 'temperatura', 1.0000, 'ºC'),
	(106085, 110, '2015-03-15 00:06:53.000000', 'temperatura', 246.0000, 'ºC'),
	(106086, 110, '2015-03-15 00:06:54.000000', 'temperatura', 28.0000, 'ºC'),
	(106087, 110, '2015-03-15 00:06:55.000000', 'temperatura', 602.0000, 'ºC'),
	(106088, 110, '2015-03-15 00:06:56.000000', 'temperatura', 525.0000, 'ºC'),
	(106089, 110, '2015-03-15 00:06:57.000000', 'temperatura', 820.0000, 'ºC'),
	(106090, 110, '2015-03-15 00:06:58.000000', 'temperatura', 127.0000, 'ºC'),
	(106091, 110, '2015-03-15 00:06:59.000000', 'temperatura', 576.0000, 'ºC'),
	(106092, 110, '2015-03-15 00:07:00.000000', 'temperatura', 99.0000, 'ºC'),
	(106093, 110, '2015-03-15 00:07:01.000000', 'temperatura', 1169.0000, 'ºC'),
	(106094, 110, '2015-03-15 00:07:02.000000', 'temperatura', 749.0000, 'ºC'),
	(106095, 110, '2015-03-15 00:07:03.000000', 'temperatura', 236.0000, 'ºC'),
	(106096, 110, '2015-03-15 00:07:04.000000', 'temperatura', 133.0000, 'ºC'),
	(106097, 110, '2015-03-15 00:07:05.000000', 'temperatura', 1158.0000, 'ºC'),
	(106098, 110, '2015-03-15 00:07:06.000000', 'temperatura', 590.0000, 'ºC'),
	(106099, 110, '2015-03-15 00:07:07.000000', 'temperatura', 678.0000, 'ºC'),
	(106100, 110, '2015-03-15 00:07:08.000000', 'temperatura', 419.0000, 'ºC'),
	(106101, 110, '2015-03-15 00:07:09.000000', 'temperatura', 61.0000, 'ºC'),
	(106102, 110, '2015-03-15 00:07:10.000000', 'temperatura', 250.0000, 'ºC'),
	(106103, 110, '2015-03-15 00:07:11.000000', 'temperatura', 1069.0000, 'ºC'),
	(106104, 110, '2015-03-15 00:07:12.000000', 'temperatura', 993.0000, 'ºC'),
	(106105, 110, '2015-03-15 00:07:13.000000', 'temperatura', 560.0000, 'ºC'),
	(106106, 110, '2015-03-15 00:07:14.000000', 'temperatura', 1022.0000, 'ºC'),
	(106107, 110, '2015-03-15 00:07:15.000000', 'temperatura', 1031.0000, 'ºC'),
	(106108, 110, '2015-03-15 00:07:16.000000', 'temperatura', 890.0000, 'ºC'),
	(106109, 110, '2015-03-15 00:07:17.000000', 'temperatura', 158.0000, 'ºC'),
	(106110, 110, '2015-03-15 00:07:18.000000', 'temperatura', 519.0000, 'ºC'),
	(106111, 110, '2015-03-15 00:07:19.000000', 'temperatura', 922.0000, 'ºC'),
	(106112, 110, '2015-03-15 00:07:20.000000', 'temperatura', 655.0000, 'ºC'),
	(106113, 110, '2015-03-15 00:07:21.000000', 'temperatura', 506.0000, 'ºC'),
	(106114, 110, '2015-03-15 00:07:22.000000', 'temperatura', 569.0000, 'ºC'),
	(106115, 110, '2015-03-15 00:07:23.000000', 'temperatura', 125.0000, 'ºC'),
	(106116, 110, '2015-03-15 00:07:24.000000', 'temperatura', 121.0000, 'ºC'),
	(106117, 110, '2015-03-15 00:07:25.000000', 'temperatura', 227.0000, 'ºC'),
	(106118, 110, '2015-03-15 00:07:26.000000', 'temperatura', 775.0000, 'ºC'),
	(106119, 110, '2015-03-15 00:07:27.000000', 'temperatura', 794.0000, 'ºC'),
	(106120, 110, '2015-03-15 00:07:28.000000', 'temperatura', 446.0000, 'ºC'),
	(106121, 110, '2015-03-15 00:07:29.000000', 'temperatura', 1048.0000, 'ºC'),
	(106122, 110, '2015-03-15 00:07:30.000000', 'temperatura', 301.0000, 'ºC'),
	(106123, 110, '2015-03-15 00:07:31.000000', 'temperatura', 762.0000, 'ºC'),
	(106124, 110, '2015-03-15 00:07:32.000000', 'temperatura', 510.0000, 'ºC'),
	(106125, 110, '2015-03-15 00:07:33.000000', 'temperatura', 262.0000, 'ºC'),
	(106126, 110, '2015-03-15 00:07:34.000000', 'temperatura', 979.0000, 'ºC'),
	(106127, 110, '2015-03-15 00:07:35.000000', 'temperatura', 512.0000, 'ºC'),
	(106128, 110, '2015-03-15 00:07:36.000000', 'temperatura', 824.0000, 'ºC'),
	(106129, 110, '2015-03-15 00:07:37.000000', 'temperatura', 182.0000, 'ºC'),
	(106130, 110, '2015-03-15 00:07:38.000000', 'temperatura', 838.0000, 'ºC'),
	(106131, 110, '2015-03-15 00:07:39.000000', 'temperatura', 46.0000, 'ºC'),
	(106132, 110, '2015-03-15 00:07:40.000000', 'temperatura', 117.0000, 'ºC'),
	(106133, 110, '2015-03-15 00:07:41.000000', 'temperatura', 446.0000, 'ºC'),
	(106134, 110, '2015-03-15 00:07:42.000000', 'temperatura', 680.0000, 'ºC'),
	(106135, 110, '2015-03-15 00:07:43.000000', 'temperatura', 861.0000, 'ºC'),
	(106136, 110, '2015-03-15 00:07:44.000000', 'temperatura', 1065.0000, 'ºC'),
	(106137, 110, '2015-03-15 00:07:45.000000', 'temperatura', 344.0000, 'ºC'),
	(106138, 110, '2015-03-15 00:07:46.000000', 'temperatura', 924.0000, 'ºC'),
	(106139, 110, '2015-03-15 00:07:47.000000', 'temperatura', 1189.0000, 'ºC'),
	(106140, 110, '2015-03-15 00:07:48.000000', 'temperatura', 773.0000, 'ºC'),
	(106141, 110, '2015-03-15 00:07:49.000000', 'temperatura', 298.0000, 'ºC'),
	(106142, 110, '2015-03-15 00:07:50.000000', 'temperatura', 372.0000, 'ºC'),
	(106143, 110, '2015-03-15 00:07:51.000000', 'temperatura', 965.0000, 'ºC'),
	(106144, 110, '2015-03-15 00:07:52.000000', 'temperatura', 111.0000, 'ºC'),
	(106145, 110, '2015-03-15 00:07:53.000000', 'temperatura', 60.0000, 'ºC'),
	(106146, 110, '2015-03-15 00:07:54.000000', 'temperatura', 1166.0000, 'ºC'),
	(106147, 110, '2015-03-15 00:07:55.000000', 'temperatura', 850.0000, 'ºC'),
	(106148, 110, '2015-03-15 00:07:56.000000', 'temperatura', 755.0000, 'ºC'),
	(106149, 110, '2015-03-15 00:07:57.000000', 'temperatura', 25.0000, 'ºC'),
	(106150, 110, '2015-03-15 00:07:58.000000', 'temperatura', 262.0000, 'ºC'),
	(106151, 110, '2015-03-15 00:07:59.000000', 'temperatura', 35.0000, 'ºC'),
	(106152, 110, '2015-03-15 00:08:00.000000', 'temperatura', 587.0000, 'ºC'),
	(106153, 110, '2015-03-15 00:08:01.000000', 'temperatura', 433.0000, 'ºC'),
	(106154, 110, '2015-03-15 00:08:02.000000', 'temperatura', 405.0000, 'ºC'),
	(106155, 110, '2015-03-15 00:08:03.000000', 'temperatura', 727.0000, 'ºC'),
	(106156, 110, '2015-03-15 00:08:04.000000', 'temperatura', 20.0000, 'ºC'),
	(106157, 110, '2015-03-15 00:08:05.000000', 'temperatura', 319.0000, 'ºC'),
	(106158, 110, '2015-03-15 00:08:06.000000', 'temperatura', 334.0000, 'ºC'),
	(106159, 110, '2015-03-15 00:08:07.000000', 'temperatura', 716.0000, 'ºC'),
	(106160, 110, '2015-03-15 00:08:08.000000', 'temperatura', 179.0000, 'ºC'),
	(106161, 110, '2015-03-15 00:08:09.000000', 'temperatura', 1147.0000, 'ºC'),
	(106162, 110, '2015-03-15 00:08:10.000000', 'temperatura', 399.0000, 'ºC'),
	(106163, 110, '2015-03-15 00:08:11.000000', 'temperatura', 953.0000, 'ºC'),
	(106164, 110, '2015-03-15 00:08:12.000000', 'temperatura', 1168.0000, 'ºC'),
	(106165, 110, '2015-03-15 00:08:13.000000', 'temperatura', 584.0000, 'ºC'),
	(106166, 110, '2015-03-15 00:08:14.000000', 'temperatura', 617.0000, 'ºC'),
	(106167, 110, '2015-03-15 00:08:15.000000', 'temperatura', 131.0000, 'ºC'),
	(106168, 110, '2015-03-15 00:08:16.000000', 'temperatura', 7.0000, 'ºC'),
	(106169, 110, '2015-03-15 00:08:17.000000', 'temperatura', 840.0000, 'ºC'),
	(106170, 110, '2015-03-15 00:08:18.000000', 'temperatura', 580.0000, 'ºC'),
	(106171, 110, '2015-03-15 00:08:19.000000', 'temperatura', 380.0000, 'ºC'),
	(106172, 110, '2015-03-15 00:08:20.000000', 'temperatura', 163.0000, 'ºC'),
	(106173, 110, '2015-03-15 00:08:21.000000', 'temperatura', 872.0000, 'ºC'),
	(106174, 110, '2015-03-15 00:08:22.000000', 'temperatura', 274.0000, 'ºC'),
	(106175, 110, '2015-03-15 00:08:23.000000', 'temperatura', 1152.0000, 'ºC'),
	(106176, 110, '2015-03-15 00:08:24.000000', 'temperatura', 139.0000, 'ºC'),
	(106177, 110, '2015-03-15 00:08:25.000000', 'temperatura', 840.0000, 'ºC'),
	(106178, 110, '2015-03-15 00:08:26.000000', 'temperatura', 183.0000, 'ºC'),
	(106179, 110, '2015-03-15 00:08:27.000000', 'temperatura', 796.0000, 'ºC'),
	(106180, 110, '2015-03-15 00:08:28.000000', 'temperatura', 1032.0000, 'ºC'),
	(106181, 110, '2015-03-15 00:08:29.000000', 'temperatura', 370.0000, 'ºC'),
	(106182, 110, '2015-03-15 00:08:30.000000', 'temperatura', 1157.0000, 'ºC'),
	(106183, 110, '2015-03-15 00:08:31.000000', 'temperatura', 1075.0000, 'ºC'),
	(106184, 110, '2015-03-15 00:08:32.000000', 'temperatura', 705.0000, 'ºC'),
	(106185, 110, '2015-03-15 00:08:33.000000', 'temperatura', 301.0000, 'ºC'),
	(106186, 110, '2015-03-15 00:08:34.000000', 'temperatura', 591.0000, 'ºC'),
	(106187, 110, '2015-03-15 00:08:35.000000', 'temperatura', 850.0000, 'ºC'),
	(106188, 110, '2015-03-15 00:08:36.000000', 'temperatura', 78.0000, 'ºC'),
	(106189, 110, '2015-03-15 00:08:37.000000', 'temperatura', 242.0000, 'ºC'),
	(106190, 110, '2015-03-15 00:08:38.000000', 'temperatura', 977.0000, 'ºC'),
	(106191, 110, '2015-03-15 00:08:39.000000', 'temperatura', 557.0000, 'ºC'),
	(106192, 110, '2015-03-15 00:08:40.000000', 'temperatura', 1057.0000, 'ºC'),
	(106193, 110, '2015-03-15 00:08:41.000000', 'temperatura', 14.0000, 'ºC'),
	(106194, 110, '2015-03-15 00:08:42.000000', 'temperatura', 498.0000, 'ºC'),
	(106195, 110, '2015-03-15 00:08:43.000000', 'temperatura', 50.0000, 'ºC'),
	(106196, 110, '2015-03-15 00:08:44.000000', 'temperatura', 1158.0000, 'ºC'),
	(106197, 110, '2015-03-15 00:08:45.000000', 'temperatura', 839.0000, 'ºC'),
	(106198, 110, '2015-03-15 00:08:46.000000', 'temperatura', 720.0000, 'ºC'),
	(106199, 110, '2015-03-15 00:08:47.000000', 'temperatura', 1085.0000, 'ºC'),
	(106200, 110, '2015-03-15 00:08:48.000000', 'temperatura', 863.0000, 'ºC'),
	(106201, 110, '2015-03-15 00:08:49.000000', 'temperatura', 1064.0000, 'ºC'),
	(106202, 110, '2015-03-15 00:08:50.000000', 'temperatura', 329.0000, 'ºC'),
	(106203, 110, '2015-03-15 00:08:51.000000', 'temperatura', 854.0000, 'ºC'),
	(106204, 110, '2015-03-15 00:08:52.000000', 'temperatura', 886.0000, 'ºC'),
	(106205, 110, '2015-03-15 00:08:53.000000', 'temperatura', 665.0000, 'ºC'),
	(106206, 110, '2015-03-15 00:08:54.000000', 'temperatura', 668.0000, 'ºC'),
	(106207, 110, '2015-03-15 00:08:55.000000', 'temperatura', 147.0000, 'ºC'),
	(106208, 110, '2015-03-15 00:08:56.000000', 'temperatura', 1131.0000, 'ºC'),
	(106209, 110, '2015-03-15 00:08:57.000000', 'temperatura', 413.0000, 'ºC'),
	(106210, 110, '2015-03-15 00:08:58.000000', 'temperatura', 1073.0000, 'ºC'),
	(106211, 110, '2015-03-15 00:08:59.000000', 'temperatura', 527.0000, 'ºC'),
	(106212, 110, '2015-03-15 00:09:00.000000', 'temperatura', 615.0000, 'ºC'),
	(106213, 110, '2015-03-15 00:09:01.000000', 'temperatura', 294.0000, 'ºC'),
	(106214, 110, '2015-03-15 00:09:02.000000', 'temperatura', 826.0000, 'ºC'),
	(106215, 110, '2015-03-15 00:09:03.000000', 'temperatura', 847.0000, 'ºC'),
	(106216, 110, '2015-03-15 00:09:04.000000', 'temperatura', 558.0000, 'ºC'),
	(106217, 110, '2015-03-15 00:09:05.000000', 'temperatura', 250.0000, 'ºC'),
	(106218, 110, '2015-03-15 00:09:06.000000', 'temperatura', 776.0000, 'ºC'),
	(106219, 110, '2015-03-15 00:09:07.000000', 'temperatura', 729.0000, 'ºC'),
	(106220, 110, '2015-03-15 00:09:08.000000', 'temperatura', 118.0000, 'ºC'),
	(106221, 110, '2015-03-15 00:09:09.000000', 'temperatura', 806.0000, 'ºC'),
	(106222, 110, '2015-03-15 00:09:10.000000', 'temperatura', 73.0000, 'ºC'),
	(106223, 110, '2015-03-15 00:09:11.000000', 'temperatura', 350.0000, 'ºC'),
	(106224, 110, '2015-03-15 00:09:12.000000', 'temperatura', 330.0000, 'ºC'),
	(106225, 110, '2015-03-15 00:09:13.000000', 'temperatura', 601.0000, 'ºC'),
	(106226, 110, '2015-03-15 00:09:14.000000', 'temperatura', 815.0000, 'ºC'),
	(106227, 110, '2015-03-15 00:09:15.000000', 'temperatura', 1073.0000, 'ºC'),
	(106228, 110, '2015-03-15 00:09:16.000000', 'temperatura', 520.0000, 'ºC'),
	(106229, 110, '2015-03-15 00:09:17.000000', 'temperatura', 580.0000, 'ºC'),
	(106230, 110, '2015-03-15 00:09:18.000000', 'temperatura', 141.0000, 'ºC'),
	(106231, 110, '2015-03-15 00:09:19.000000', 'temperatura', 167.0000, 'ºC'),
	(106232, 110, '2015-03-15 00:09:20.000000', 'temperatura', 410.0000, 'ºC'),
	(106233, 110, '2015-03-15 00:09:21.000000', 'temperatura', 352.0000, 'ºC'),
	(106234, 110, '2015-03-15 00:09:22.000000', 'temperatura', 530.0000, 'ºC'),
	(106235, 110, '2015-03-15 00:09:23.000000', 'temperatura', 394.0000, 'ºC'),
	(106236, 110, '2015-03-15 00:09:24.000000', 'temperatura', 382.0000, 'ºC'),
	(106237, 110, '2015-03-15 00:09:25.000000', 'temperatura', 726.0000, 'ºC'),
	(106238, 110, '2015-03-15 00:09:26.000000', 'temperatura', 88.0000, 'ºC'),
	(106239, 110, '2015-03-15 00:09:27.000000', 'temperatura', 659.0000, 'ºC'),
	(106240, 110, '2015-03-15 00:09:28.000000', 'temperatura', 632.0000, 'ºC'),
	(106241, 110, '2015-03-15 00:09:29.000000', 'temperatura', 1185.0000, 'ºC'),
	(106242, 110, '2015-03-15 00:09:30.000000', 'temperatura', 427.0000, 'ºC'),
	(106243, 110, '2015-03-15 00:09:31.000000', 'temperatura', 984.0000, 'ºC'),
	(106244, 110, '2015-03-15 00:09:32.000000', 'temperatura', 36.0000, 'ºC'),
	(106245, 110, '2015-03-15 00:09:33.000000', 'temperatura', 830.0000, 'ºC'),
	(106246, 110, '2015-03-15 00:09:34.000000', 'temperatura', 441.0000, 'ºC'),
	(106247, 110, '2015-03-15 00:09:35.000000', 'temperatura', 918.0000, 'ºC'),
	(106248, 110, '2015-03-15 00:09:36.000000', 'temperatura', 868.0000, 'ºC'),
	(106249, 110, '2015-03-15 00:09:37.000000', 'temperatura', 385.0000, 'ºC'),
	(106250, 110, '2015-03-15 00:09:38.000000', 'temperatura', 521.0000, 'ºC'),
	(106251, 110, '2015-03-15 00:09:39.000000', 'temperatura', 251.0000, 'ºC'),
	(106252, 110, '2015-03-15 00:09:40.000000', 'temperatura', 892.0000, 'ºC'),
	(106253, 110, '2015-03-15 00:09:41.000000', 'temperatura', 108.0000, 'ºC'),
	(106254, 110, '2015-03-15 00:09:42.000000', 'temperatura', 265.0000, 'ºC'),
	(106255, 110, '2015-03-15 00:09:43.000000', 'temperatura', 1003.0000, 'ºC'),
	(106256, 110, '2015-03-15 00:09:44.000000', 'temperatura', 617.0000, 'ºC'),
	(106257, 110, '2015-03-15 00:09:45.000000', 'temperatura', 79.0000, 'ºC'),
	(106258, 110, '2015-03-15 00:09:46.000000', 'temperatura', 942.0000, 'ºC'),
	(106259, 110, '2015-03-15 00:09:47.000000', 'temperatura', 877.0000, 'ºC'),
	(106260, 110, '2015-03-15 00:09:48.000000', 'temperatura', 356.0000, 'ºC'),
	(106261, 110, '2015-03-15 00:09:49.000000', 'temperatura', 350.0000, 'ºC'),
	(106262, 110, '2015-03-15 00:09:50.000000', 'temperatura', 685.0000, 'ºC'),
	(106263, 110, '2015-03-15 00:09:51.000000', 'temperatura', 1175.0000, 'ºC'),
	(106264, 110, '2015-03-15 00:09:52.000000', 'temperatura', 220.0000, 'ºC'),
	(106265, 110, '2015-03-15 00:09:53.000000', 'temperatura', 1177.0000, 'ºC'),
	(106266, 110, '2015-03-15 00:09:54.000000', 'temperatura', 423.0000, 'ºC'),
	(106267, 110, '2015-03-15 00:09:55.000000', 'temperatura', 985.0000, 'ºC'),
	(106268, 110, '2015-03-15 00:09:56.000000', 'temperatura', 57.0000, 'ºC'),
	(106269, 110, '2015-03-15 00:09:57.000000', 'temperatura', 930.0000, 'ºC'),
	(106270, 110, '2015-03-15 00:09:58.000000', 'temperatura', 878.0000, 'ºC'),
	(106271, 110, '2015-03-15 00:09:59.000000', 'temperatura', 404.0000, 'ºC'),
	(106272, 110, '2015-03-15 00:10:00.000000', 'temperatura', 583.0000, 'ºC'),
	(106273, 110, '2015-03-15 00:10:01.000000', 'temperatura', 504.0000, 'ºC'),
	(106274, 110, '2015-03-15 00:10:02.000000', 'temperatura', 773.0000, 'ºC'),
	(106275, 110, '2015-03-15 00:10:03.000000', 'temperatura', 1152.0000, 'ºC'),
	(106276, 110, '2015-03-15 00:10:04.000000', 'temperatura', 1041.0000, 'ºC'),
	(106277, 110, '2015-03-15 00:10:05.000000', 'temperatura', 551.0000, 'ºC'),
	(106278, 110, '2015-03-15 00:10:06.000000', 'temperatura', 833.0000, 'ºC'),
	(106279, 110, '2015-03-15 00:10:07.000000', 'temperatura', 113.0000, 'ºC'),
	(106280, 110, '2015-03-15 00:10:08.000000', 'temperatura', 467.0000, 'ºC'),
	(106281, 110, '2015-03-15 00:10:09.000000', 'temperatura', 796.0000, 'ºC'),
	(106282, 110, '2015-03-15 00:10:10.000000', 'temperatura', 179.0000, 'ºC'),
	(106283, 110, '2015-03-15 00:10:11.000000', 'temperatura', 908.0000, 'ºC'),
	(106284, 110, '2015-03-15 00:10:12.000000', 'temperatura', 401.0000, 'ºC'),
	(106285, 110, '2015-03-15 00:10:13.000000', 'temperatura', 484.0000, 'ºC'),
	(106286, 110, '2015-03-15 00:10:14.000000', 'temperatura', 17.0000, 'ºC'),
	(106287, 110, '2015-03-15 00:10:15.000000', 'temperatura', 1031.0000, 'ºC'),
	(106288, 110, '2015-03-15 00:10:16.000000', 'temperatura', 308.0000, 'ºC'),
	(106289, 110, '2015-03-15 00:10:17.000000', 'temperatura', 844.0000, 'ºC'),
	(106290, 110, '2015-03-15 00:10:18.000000', 'temperatura', 899.0000, 'ºC'),
	(106291, 110, '2015-03-15 00:10:19.000000', 'temperatura', 761.0000, 'ºC'),
	(106292, 110, '2015-03-15 00:10:20.000000', 'temperatura', 1109.0000, 'ºC'),
	(106293, 110, '2015-03-15 00:10:21.000000', 'temperatura', 862.0000, 'ºC'),
	(106294, 110, '2015-03-15 00:10:22.000000', 'temperatura', 984.0000, 'ºC'),
	(106295, 110, '2015-03-15 00:10:23.000000', 'temperatura', 1133.0000, 'ºC'),
	(106296, 110, '2015-03-15 00:10:24.000000', 'temperatura', 314.0000, 'ºC'),
	(106297, 110, '2015-03-15 00:10:25.000000', 'temperatura', 571.0000, 'ºC'),
	(106298, 110, '2015-03-15 00:10:26.000000', 'temperatura', 713.0000, 'ºC'),
	(106299, 110, '2015-03-15 00:10:27.000000', 'temperatura', 654.0000, 'ºC'),
	(106300, 110, '2015-03-15 00:10:28.000000', 'temperatura', 1130.0000, 'ºC'),
	(106301, 110, '2015-03-15 00:10:29.000000', 'temperatura', 91.0000, 'ºC'),
	(106302, 110, '2015-03-15 00:10:30.000000', 'temperatura', 662.0000, 'ºC'),
	(106303, 110, '2015-03-15 00:10:31.000000', 'temperatura', 640.0000, 'ºC'),
	(106304, 110, '2015-03-15 00:10:32.000000', 'temperatura', 15.0000, 'ºC'),
	(106305, 110, '2015-03-15 00:10:33.000000', 'temperatura', 553.0000, 'ºC'),
	(106306, 110, '2015-03-15 00:10:34.000000', 'temperatura', 321.0000, 'ºC'),
	(106307, 110, '2015-03-15 00:10:35.000000', 'temperatura', 1145.0000, 'ºC'),
	(106308, 110, '2015-03-15 00:10:36.000000', 'temperatura', 1166.0000, 'ºC'),
	(106309, 110, '2015-03-15 00:10:37.000000', 'temperatura', 1193.0000, 'ºC'),
	(106310, 110, '2015-03-15 00:10:38.000000', 'temperatura', 70.0000, 'ºC'),
	(106311, 110, '2015-03-15 00:10:39.000000', 'temperatura', 368.0000, 'ºC'),
	(106312, 110, '2015-03-15 00:10:40.000000', 'temperatura', 434.0000, 'ºC'),
	(106313, 110, '2015-03-15 00:10:41.000000', 'temperatura', 1065.0000, 'ºC'),
	(106314, 110, '2015-03-15 00:10:42.000000', 'temperatura', 423.0000, 'ºC'),
	(106315, 110, '2015-03-15 00:10:43.000000', 'temperatura', 123.0000, 'ºC'),
	(106316, 110, '2015-03-15 00:10:44.000000', 'temperatura', 545.0000, 'ºC'),
	(106317, 110, '2015-03-15 00:10:45.000000', 'temperatura', 1157.0000, 'ºC'),
	(106318, 110, '2015-03-15 00:10:46.000000', 'temperatura', 550.0000, 'ºC'),
	(106319, 110, '2015-03-15 00:10:47.000000', 'temperatura', 478.0000, 'ºC'),
	(106320, 110, '2015-03-15 00:10:48.000000', 'temperatura', 742.0000, 'ºC'),
	(106321, 110, '2015-03-15 00:10:49.000000', 'temperatura', 1075.0000, 'ºC'),
	(106322, 110, '2015-03-15 00:10:50.000000', 'temperatura', 750.0000, 'ºC'),
	(106323, 110, '2015-03-15 00:10:51.000000', 'temperatura', 527.0000, 'ºC'),
	(106324, 110, '2015-03-15 00:10:52.000000', 'temperatura', 385.0000, 'ºC'),
	(106325, 110, '2015-03-15 00:10:53.000000', 'temperatura', 342.0000, 'ºC'),
	(106326, 110, '2015-03-15 00:10:54.000000', 'temperatura', 559.0000, 'ºC'),
	(106327, 110, '2015-03-15 00:10:55.000000', 'temperatura', 567.0000, 'ºC'),
	(106328, 110, '2015-03-15 00:10:56.000000', 'temperatura', 1159.0000, 'ºC'),
	(106329, 110, '2015-03-15 00:10:57.000000', 'temperatura', 493.0000, 'ºC'),
	(106330, 110, '2015-03-15 00:10:58.000000', 'temperatura', 191.0000, 'ºC'),
	(106331, 110, '2015-03-15 00:10:59.000000', 'temperatura', 676.0000, 'ºC'),
	(106332, 110, '2015-03-15 00:11:00.000000', 'temperatura', 407.0000, 'ºC'),
	(106333, 110, '2015-03-15 00:11:01.000000', 'temperatura', 6.0000, 'ºC'),
	(106334, 110, '2015-03-15 00:11:02.000000', 'temperatura', 9.0000, 'ºC'),
	(106335, 110, '2015-03-15 00:11:03.000000', 'temperatura', 29.0000, 'ºC'),
	(106336, 110, '2015-03-15 00:11:04.000000', 'temperatura', 117.0000, 'ºC'),
	(106337, 110, '2015-03-15 00:11:05.000000', 'temperatura', 499.0000, 'ºC'),
	(106338, 110, '2015-03-15 00:11:06.000000', 'temperatura', 944.0000, 'ºC'),
	(106339, 110, '2015-03-15 00:11:07.000000', 'temperatura', 825.0000, 'ºC'),
	(106340, 110, '2015-03-15 00:11:08.000000', 'temperatura', 94.0000, 'ºC'),
	(106341, 110, '2015-03-15 00:11:09.000000', 'temperatura', 396.0000, 'ºC'),
	(106342, 110, '2015-03-15 00:11:10.000000', 'temperatura', 497.0000, 'ºC'),
	(106343, 110, '2015-03-15 00:11:11.000000', 'temperatura', 96.0000, 'ºC'),
	(106344, 110, '2015-03-15 00:11:12.000000', 'temperatura', 190.0000, 'ºC'),
	(106345, 110, '2015-03-15 00:11:13.000000', 'temperatura', 663.0000, 'ºC'),
	(106346, 110, '2015-03-15 00:11:14.000000', 'temperatura', 345.0000, 'ºC'),
	(106347, 110, '2015-03-15 00:11:15.000000', 'temperatura', 935.0000, 'ºC'),
	(106348, 110, '2015-03-15 00:11:16.000000', 'temperatura', 43.0000, 'ºC'),
	(106349, 110, '2015-03-15 00:11:17.000000', 'temperatura', 1011.0000, 'ºC'),
	(106350, 110, '2015-03-15 00:11:18.000000', 'temperatura', 127.0000, 'ºC'),
	(106351, 110, '2015-03-15 00:11:19.000000', 'temperatura', 1.0000, 'ºC'),
	(106352, 110, '2015-03-15 00:11:20.000000', 'temperatura', 826.0000, 'ºC'),
	(106353, 110, '2015-03-15 00:11:21.000000', 'temperatura', 526.0000, 'ºC'),
	(106354, 110, '2015-03-15 00:11:22.000000', 'temperatura', 152.0000, 'ºC'),
	(106355, 110, '2015-03-15 00:11:23.000000', 'temperatura', 384.0000, 'ºC'),
	(106356, 110, '2015-03-15 00:11:24.000000', 'temperatura', 264.0000, 'ºC'),
	(106357, 110, '2015-03-15 00:11:25.000000', 'temperatura', 170.0000, 'ºC'),
	(106358, 110, '2015-03-15 00:11:26.000000', 'temperatura', 59.0000, 'ºC'),
	(106359, 110, '2015-03-15 00:11:27.000000', 'temperatura', 986.0000, 'ºC'),
	(106360, 110, '2015-03-15 00:11:28.000000', 'temperatura', 1151.0000, 'ºC'),
	(106361, 110, '2015-03-15 00:11:29.000000', 'temperatura', 397.0000, 'ºC'),
	(106362, 110, '2015-03-15 00:11:30.000000', 'temperatura', 934.0000, 'ºC'),
	(106363, 110, '2015-03-15 00:11:31.000000', 'temperatura', 1078.0000, 'ºC'),
	(106364, 110, '2015-03-15 00:11:32.000000', 'temperatura', 187.0000, 'ºC'),
	(106365, 110, '2015-03-15 00:11:33.000000', 'temperatura', 105.0000, 'ºC'),
	(106366, 110, '2015-03-15 00:11:34.000000', 'temperatura', 1163.0000, 'ºC'),
	(106367, 110, '2015-03-15 00:11:35.000000', 'temperatura', 700.0000, 'ºC'),
	(106368, 110, '2015-03-15 00:11:36.000000', 'temperatura', 12.0000, 'ºC'),
	(106369, 110, '2015-03-15 00:11:37.000000', 'temperatura', 360.0000, 'ºC'),
	(106370, 110, '2015-03-15 00:11:38.000000', 'temperatura', 565.0000, 'ºC'),
	(106371, 110, '2015-03-15 00:11:39.000000', 'temperatura', 546.0000, 'ºC'),
	(106372, 110, '2015-03-15 00:11:40.000000', 'temperatura', 1036.0000, 'ºC'),
	(106373, 110, '2015-03-15 00:11:41.000000', 'temperatura', 1144.0000, 'ºC'),
	(106374, 110, '2015-03-15 00:11:42.000000', 'temperatura', 211.0000, 'ºC'),
	(106375, 110, '2015-03-15 00:11:43.000000', 'temperatura', 22.0000, 'ºC'),
	(106376, 110, '2015-03-15 00:11:44.000000', 'temperatura', 679.0000, 'ºC'),
	(106377, 110, '2015-03-15 00:11:45.000000', 'temperatura', 930.0000, 'ºC'),
	(106378, 110, '2015-03-15 00:11:46.000000', 'temperatura', 211.0000, 'ºC'),
	(106379, 110, '2015-03-15 00:11:47.000000', 'temperatura', 667.0000, 'ºC'),
	(106380, 110, '2015-03-15 00:11:48.000000', 'temperatura', 301.0000, 'ºC'),
	(106381, 110, '2015-03-15 00:11:49.000000', 'temperatura', 703.0000, 'ºC'),
	(106382, 110, '2015-03-15 00:11:50.000000', 'temperatura', 216.0000, 'ºC'),
	(106383, 110, '2015-03-15 00:11:51.000000', 'temperatura', 169.0000, 'ºC'),
	(106384, 110, '2015-03-15 00:11:52.000000', 'temperatura', 199.0000, 'ºC'),
	(106385, 110, '2015-03-15 00:11:53.000000', 'temperatura', 489.0000, 'ºC'),
	(106386, 110, '2015-03-15 00:11:54.000000', 'temperatura', 646.0000, 'ºC'),
	(106387, 110, '2015-03-15 00:11:55.000000', 'temperatura', 564.0000, 'ºC'),
	(106388, 110, '2015-03-15 00:11:56.000000', 'temperatura', 883.0000, 'ºC'),
	(106389, 110, '2015-03-15 00:11:57.000000', 'temperatura', 324.0000, 'ºC'),
	(106390, 110, '2015-03-15 00:11:58.000000', 'temperatura', 169.0000, 'ºC'),
	(106391, 110, '2015-03-15 00:11:59.000000', 'temperatura', 1075.0000, 'ºC'),
	(106392, 110, '2015-03-15 00:12:00.000000', 'temperatura', 70.0000, 'ºC'),
	(106393, 110, '2015-03-15 00:12:01.000000', 'temperatura', 726.0000, 'ºC'),
	(106394, 110, '2015-03-15 00:12:02.000000', 'temperatura', 1020.0000, 'ºC'),
	(106395, 110, '2015-03-15 00:12:03.000000', 'temperatura', 521.0000, 'ºC'),
	(106396, 110, '2015-03-15 00:12:04.000000', 'temperatura', 746.0000, 'ºC'),
	(106397, 110, '2015-03-15 00:12:05.000000', 'temperatura', 968.0000, 'ºC'),
	(106398, 110, '2015-03-15 00:12:06.000000', 'temperatura', 203.0000, 'ºC'),
	(106399, 110, '2015-03-15 00:12:07.000000', 'temperatura', 509.0000, 'ºC'),
	(106400, 110, '2015-03-15 00:12:08.000000', 'temperatura', 739.0000, 'ºC'),
	(106401, 110, '2015-03-15 00:12:09.000000', 'temperatura', 967.0000, 'ºC'),
	(106402, 110, '2015-03-15 00:12:10.000000', 'temperatura', 221.0000, 'ºC'),
	(106403, 110, '2015-03-15 00:12:11.000000', 'temperatura', 602.0000, 'ºC'),
	(106404, 110, '2015-03-15 00:12:12.000000', 'temperatura', 1147.0000, 'ºC'),
	(106405, 110, '2015-03-15 00:12:13.000000', 'temperatura', 331.0000, 'ºC'),
	(106406, 110, '2015-03-15 00:12:14.000000', 'temperatura', 614.0000, 'ºC'),
	(106407, 110, '2015-03-15 00:12:15.000000', 'temperatura', 879.0000, 'ºC'),
	(106408, 110, '2015-03-15 00:12:16.000000', 'temperatura', 152.0000, 'ºC'),
	(106409, 110, '2015-03-15 00:12:17.000000', 'temperatura', 525.0000, 'ºC'),
	(106410, 110, '2015-03-15 00:12:18.000000', 'temperatura', 971.0000, 'ºC'),
	(106411, 110, '2015-03-15 00:12:19.000000', 'temperatura', 877.0000, 'ºC'),
	(106412, 110, '2015-03-15 00:12:20.000000', 'temperatura', 274.0000, 'ºC'),
	(106413, 110, '2015-03-15 00:12:21.000000', 'temperatura', 1138.0000, 'ºC'),
	(106414, 110, '2015-03-15 00:12:22.000000', 'temperatura', 67.0000, 'ºC'),
	(106415, 110, '2015-03-15 00:12:23.000000', 'temperatura', 525.0000, 'ºC'),
	(106416, 110, '2015-03-15 00:12:24.000000', 'temperatura', 21.0000, 'ºC'),
	(106417, 110, '2015-03-15 00:12:25.000000', 'temperatura', 933.0000, 'ºC'),
	(106418, 110, '2015-03-15 00:12:26.000000', 'temperatura', 1003.0000, 'ºC'),
	(106419, 110, '2015-03-15 00:12:27.000000', 'temperatura', 1017.0000, 'ºC'),
	(106420, 110, '2015-03-15 00:12:28.000000', 'temperatura', 877.0000, 'ºC'),
	(106421, 110, '2015-03-15 00:12:29.000000', 'temperatura', 135.0000, 'ºC'),
	(106422, 110, '2015-03-15 00:12:30.000000', 'temperatura', 444.0000, 'ºC'),
	(106423, 110, '2015-03-15 00:12:31.000000', 'temperatura', 615.0000, 'ºC'),
	(106424, 110, '2015-03-15 00:12:32.000000', 'temperatura', 543.0000, 'ºC'),
	(106425, 110, '2015-03-15 00:12:33.000000', 'temperatura', 872.0000, 'ºC'),
	(106426, 110, '2015-03-15 00:12:34.000000', 'temperatura', 330.0000, 'ºC'),
	(106427, 110, '2015-03-15 00:12:35.000000', 'temperatura', 233.0000, 'ºC'),
	(106428, 110, '2015-03-15 00:12:36.000000', 'temperatura', 179.0000, 'ºC'),
	(106429, 110, '2015-03-15 00:12:37.000000', 'temperatura', 195.0000, 'ºC'),
	(106430, 110, '2015-03-15 00:12:38.000000', 'temperatura', 440.0000, 'ºC'),
	(106431, 110, '2015-03-15 00:12:39.000000', 'temperatura', 413.0000, 'ºC'),
	(106432, 110, '2015-03-15 00:12:40.000000', 'temperatura', 746.0000, 'ºC'),
	(106433, 110, '2015-03-15 00:12:41.000000', 'temperatura', 93.0000, 'ºC'),
	(106434, 110, '2015-03-15 00:12:42.000000', 'temperatura', 626.0000, 'ºC'),
	(106435, 110, '2015-03-15 00:12:43.000000', 'temperatura', 453.0000, 'ºC'),
	(106436, 110, '2015-03-15 00:12:44.000000', 'temperatura', 388.0000, 'ºC'),
	(106437, 110, '2015-03-15 00:12:45.000000', 'temperatura', 579.0000, 'ºC'),
	(106438, 110, '2015-03-15 00:12:46.000000', 'temperatura', 532.0000, 'ºC'),
	(106439, 110, '2015-03-15 00:12:47.000000', 'temperatura', 925.0000, 'ºC'),
	(106440, 110, '2015-03-15 00:12:48.000000', 'temperatura', 631.0000, 'ºC'),
	(106441, 110, '2015-03-15 00:12:49.000000', 'temperatura', 378.0000, 'ºC'),
	(106442, 110, '2015-03-15 00:12:50.000000', 'temperatura', 1197.0000, 'ºC'),
	(106443, 110, '2015-03-15 00:12:51.000000', 'temperatura', 52.0000, 'ºC'),
	(106444, 110, '2015-03-15 00:12:52.000000', 'temperatura', 271.0000, 'ºC'),
	(106445, 110, '2015-03-15 00:12:53.000000', 'temperatura', 1198.0000, 'ºC'),
	(106446, 110, '2015-03-15 00:12:54.000000', 'temperatura', 377.0000, 'ºC'),
	(106447, 110, '2015-03-15 00:12:55.000000', 'temperatura', 692.0000, 'ºC'),
	(106448, 110, '2015-03-15 00:12:56.000000', 'temperatura', 1129.0000, 'ºC'),
	(106449, 110, '2015-03-15 00:12:57.000000', 'temperatura', 1172.0000, 'ºC'),
	(106450, 110, '2015-03-15 00:12:58.000000', 'temperatura', 71.0000, 'ºC'),
	(106451, 110, '2015-03-15 00:12:59.000000', 'temperatura', 440.0000, 'ºC'),
	(106452, 110, '2015-03-15 00:13:00.000000', 'temperatura', 788.0000, 'ºC'),
	(106453, 110, '2015-03-15 00:13:01.000000', 'temperatura', 218.0000, 'ºC'),
	(106454, 110, '2015-03-15 00:13:02.000000', 'temperatura', 1129.0000, 'ºC'),
	(106455, 110, '2015-03-15 00:13:03.000000', 'temperatura', 189.0000, 'ºC'),
	(106456, 110, '2015-03-15 00:13:04.000000', 'temperatura', 1161.0000, 'ºC'),
	(106457, 110, '2015-03-15 00:13:05.000000', 'temperatura', 439.0000, 'ºC'),
	(106458, 110, '2015-03-15 00:13:06.000000', 'temperatura', 1111.0000, 'ºC'),
	(106459, 110, '2015-03-15 00:13:07.000000', 'temperatura', 639.0000, 'ºC'),
	(106460, 110, '2015-03-15 00:13:08.000000', 'temperatura', 1062.0000, 'ºC'),
	(106461, 110, '2015-03-15 00:13:09.000000', 'temperatura', 993.0000, 'ºC'),
	(106462, 110, '2015-03-15 00:13:10.000000', 'temperatura', 580.0000, 'ºC'),
	(106463, 110, '2015-03-15 00:13:11.000000', 'temperatura', 1120.0000, 'ºC'),
	(106464, 110, '2015-03-15 00:13:12.000000', 'temperatura', 262.0000, 'ºC'),
	(106465, 110, '2015-03-15 00:13:13.000000', 'temperatura', 352.0000, 'ºC'),
	(106466, 110, '2015-03-15 00:13:14.000000', 'temperatura', 974.0000, 'ºC'),
	(106467, 110, '2015-03-15 00:13:15.000000', 'temperatura', 213.0000, 'ºC'),
	(106468, 110, '2015-03-15 00:13:16.000000', 'temperatura', 545.0000, 'ºC'),
	(106469, 110, '2015-03-15 00:13:17.000000', 'temperatura', 886.0000, 'ºC'),
	(106470, 110, '2015-03-15 00:13:18.000000', 'temperatura', 395.0000, 'ºC'),
	(106471, 110, '2015-03-15 00:13:19.000000', 'temperatura', 516.0000, 'ºC'),
	(106472, 110, '2015-03-15 00:13:20.000000', 'temperatura', 197.0000, 'ºC'),
	(106473, 110, '2015-03-15 00:13:21.000000', 'temperatura', 637.0000, 'ºC'),
	(106474, 110, '2015-03-15 00:13:22.000000', 'temperatura', 197.0000, 'ºC'),
	(106475, 110, '2015-03-15 00:13:23.000000', 'temperatura', 271.0000, 'ºC'),
	(106476, 110, '2015-03-15 00:13:24.000000', 'temperatura', 766.0000, 'ºC'),
	(106477, 110, '2015-03-15 00:13:25.000000', 'temperatura', 618.0000, 'ºC'),
	(106478, 110, '2015-03-15 00:13:26.000000', 'temperatura', 793.0000, 'ºC'),
	(106479, 110, '2015-03-15 00:13:27.000000', 'temperatura', 910.0000, 'ºC'),
	(106480, 110, '2015-03-15 00:13:28.000000', 'temperatura', 974.0000, 'ºC'),
	(106481, 110, '2015-03-15 00:13:29.000000', 'temperatura', 938.0000, 'ºC'),
	(106482, 110, '2015-03-15 00:13:30.000000', 'temperatura', 567.0000, 'ºC'),
	(106483, 110, '2015-03-15 00:13:31.000000', 'temperatura', 24.0000, 'ºC'),
	(106484, 110, '2015-03-15 00:13:32.000000', 'temperatura', 818.0000, 'ºC'),
	(106485, 110, '2015-03-15 00:13:33.000000', 'temperatura', 420.0000, 'ºC'),
	(106486, 110, '2015-03-15 00:13:34.000000', 'temperatura', 845.0000, 'ºC'),
	(106487, 110, '2015-03-15 00:13:35.000000', 'temperatura', 566.0000, 'ºC'),
	(106488, 110, '2015-03-15 00:13:36.000000', 'temperatura', 295.0000, 'ºC'),
	(106489, 110, '2015-03-15 00:13:37.000000', 'temperatura', 976.0000, 'ºC'),
	(106490, 110, '2015-03-15 00:13:38.000000', 'temperatura', 397.0000, 'ºC'),
	(106491, 110, '2015-03-15 00:13:39.000000', 'temperatura', 259.0000, 'ºC'),
	(106492, 110, '2015-03-15 00:13:40.000000', 'temperatura', 104.0000, 'ºC'),
	(106493, 110, '2015-03-15 00:13:41.000000', 'temperatura', 944.0000, 'ºC'),
	(106494, 110, '2015-03-15 00:13:42.000000', 'temperatura', 809.0000, 'ºC'),
	(106495, 110, '2015-03-15 00:13:43.000000', 'temperatura', 13.0000, 'ºC'),
	(106496, 110, '2015-03-15 00:13:44.000000', 'temperatura', 37.0000, 'ºC'),
	(106497, 110, '2015-03-15 00:13:45.000000', 'temperatura', 149.0000, 'ºC'),
	(106498, 110, '2015-03-15 00:13:46.000000', 'temperatura', 632.0000, 'ºC'),
	(106499, 110, '2015-03-15 00:13:47.000000', 'temperatura', 313.0000, 'ºC'),
	(106500, 110, '2015-03-15 00:13:48.000000', 'temperatura', 871.0000, 'ºC'),
	(106501, 110, '2015-03-15 00:13:49.000000', 'temperatura', 1016.0000, 'ºC'),
	(106502, 110, '2015-03-15 00:13:50.000000', 'temperatura', 66.0000, 'ºC'),
	(106503, 110, '2015-03-15 00:13:51.000000', 'temperatura', 883.0000, 'ºC'),
	(106504, 110, '2015-03-15 00:13:52.000000', 'temperatura', 618.0000, 'ºC'),
	(106505, 110, '2015-03-15 00:13:53.000000', 'temperatura', 442.0000, 'ºC'),
	(106506, 110, '2015-03-15 00:13:54.000000', 'temperatura', 357.0000, 'ºC'),
	(106507, 110, '2015-03-15 00:13:55.000000', 'temperatura', 459.0000, 'ºC'),
	(106508, 110, '2015-03-15 00:13:56.000000', 'temperatura', 23.0000, 'ºC'),
	(106509, 110, '2015-03-15 00:13:57.000000', 'temperatura', 1139.0000, 'ºC'),
	(106510, 110, '2015-03-15 00:13:58.000000', 'temperatura', 827.0000, 'ºC'),
	(106511, 110, '2015-03-15 00:13:59.000000', 'temperatura', 719.0000, 'ºC'),
	(106512, 110, '2015-03-15 00:14:00.000000', 'temperatura', 1114.0000, 'ºC'),
	(106513, 110, '2015-03-15 00:14:01.000000', 'temperatura', 1015.0000, 'ºC'),
	(106514, 110, '2015-03-15 00:14:02.000000', 'temperatura', 534.0000, 'ºC'),
	(106515, 110, '2015-03-15 00:14:03.000000', 'temperatura', 823.0000, 'ºC'),
	(106516, 110, '2015-03-15 00:14:04.000000', 'temperatura', 115.0000, 'ºC'),
	(106517, 110, '2015-03-15 00:14:05.000000', 'temperatura', 504.0000, 'ºC'),
	(106518, 110, '2015-03-15 00:14:06.000000', 'temperatura', 978.0000, 'ºC'),
	(106519, 110, '2015-03-15 00:14:07.000000', 'temperatura', 978.0000, 'ºC'),
	(106520, 110, '2015-03-15 00:14:08.000000', 'temperatura', 755.0000, 'ºC'),
	(106521, 110, '2015-03-15 00:14:09.000000', 'temperatura', 844.0000, 'ºC'),
	(106522, 110, '2015-03-15 00:14:10.000000', 'temperatura', 753.0000, 'ºC'),
	(106523, 110, '2015-03-15 00:14:11.000000', 'temperatura', 34.0000, 'ºC'),
	(106524, 110, '2015-03-15 00:14:12.000000', 'temperatura', 313.0000, 'ºC'),
	(106525, 110, '2015-03-15 00:14:13.000000', 'temperatura', 263.0000, 'ºC'),
	(106526, 110, '2015-03-15 00:14:14.000000', 'temperatura', 375.0000, 'ºC'),
	(106527, 110, '2015-03-15 00:14:15.000000', 'temperatura', 1088.0000, 'ºC'),
	(106528, 110, '2015-03-15 00:14:16.000000', 'temperatura', 713.0000, 'ºC'),
	(106529, 110, '2015-03-15 00:14:17.000000', 'temperatura', 305.0000, 'ºC'),
	(106530, 110, '2015-03-15 00:14:18.000000', 'temperatura', 584.0000, 'ºC'),
	(106531, 110, '2015-03-15 00:14:19.000000', 'temperatura', 808.0000, 'ºC'),
	(106532, 110, '2015-03-15 00:14:20.000000', 'temperatura', 1086.0000, 'ºC'),
	(106533, 110, '2015-03-15 00:14:21.000000', 'temperatura', 609.0000, 'ºC'),
	(106534, 110, '2015-03-15 00:14:22.000000', 'temperatura', 987.0000, 'ºC'),
	(106535, 110, '2015-03-15 00:14:23.000000', 'temperatura', 710.0000, 'ºC'),
	(106536, 110, '2015-03-15 00:14:24.000000', 'temperatura', 586.0000, 'ºC'),
	(106537, 110, '2015-03-15 00:14:25.000000', 'temperatura', 803.0000, 'ºC'),
	(106538, 110, '2015-03-15 00:14:26.000000', 'temperatura', 1055.0000, 'ºC'),
	(106539, 110, '2015-03-15 00:14:27.000000', 'temperatura', 468.0000, 'ºC'),
	(106540, 110, '2015-03-15 00:14:28.000000', 'temperatura', 377.0000, 'ºC'),
	(106541, 110, '2015-03-15 00:14:29.000000', 'temperatura', 482.0000, 'ºC'),
	(106542, 110, '2015-03-15 00:14:30.000000', 'temperatura', 77.0000, 'ºC'),
	(106543, 110, '2015-03-15 00:14:31.000000', 'temperatura', 140.0000, 'ºC'),
	(106544, 110, '2015-03-15 00:14:32.000000', 'temperatura', 469.0000, 'ºC'),
	(106545, 110, '2015-03-15 00:14:33.000000', 'temperatura', 728.0000, 'ºC'),
	(106546, 110, '2015-03-15 00:14:34.000000', 'temperatura', 1031.0000, 'ºC'),
	(106547, 110, '2015-03-15 00:14:35.000000', 'temperatura', 573.0000, 'ºC'),
	(106548, 110, '2015-03-15 00:14:36.000000', 'temperatura', 970.0000, 'ºC'),
	(106549, 110, '2015-03-15 00:14:37.000000', 'temperatura', 734.0000, 'ºC'),
	(106550, 110, '2015-03-15 00:14:38.000000', 'temperatura', 758.0000, 'ºC'),
	(106551, 110, '2015-03-15 00:14:39.000000', 'temperatura', 389.0000, 'ºC'),
	(106552, 110, '2015-03-15 00:14:40.000000', 'temperatura', 871.0000, 'ºC'),
	(106553, 110, '2015-03-15 00:14:41.000000', 'temperatura', 788.0000, 'ºC'),
	(106554, 110, '2015-03-15 00:14:42.000000', 'temperatura', 130.0000, 'ºC'),
	(106555, 110, '2015-03-15 00:14:43.000000', 'temperatura', 685.0000, 'ºC'),
	(106556, 110, '2015-03-15 00:14:44.000000', 'temperatura', 636.0000, 'ºC'),
	(106557, 110, '2015-03-15 00:14:45.000000', 'temperatura', 1126.0000, 'ºC'),
	(106558, 110, '2015-03-15 00:14:46.000000', 'temperatura', 120.0000, 'ºC'),
	(106559, 110, '2015-03-15 00:14:47.000000', 'temperatura', 826.0000, 'ºC'),
	(106560, 110, '2015-03-15 00:14:48.000000', 'temperatura', 167.0000, 'ºC'),
	(106561, 110, '2015-03-15 00:14:49.000000', 'temperatura', 760.0000, 'ºC'),
	(106562, 110, '2015-03-15 00:14:50.000000', 'temperatura', 899.0000, 'ºC'),
	(106563, 110, '2015-03-15 00:14:51.000000', 'temperatura', 1017.0000, 'ºC'),
	(106564, 110, '2015-03-15 00:14:52.000000', 'temperatura', 1188.0000, 'ºC'),
	(106565, 110, '2015-03-15 00:14:53.000000', 'temperatura', 491.0000, 'ºC'),
	(106566, 110, '2015-03-15 00:14:54.000000', 'temperatura', 89.0000, 'ºC'),
	(106567, 110, '2015-03-15 00:14:55.000000', 'temperatura', 173.0000, 'ºC'),
	(106568, 110, '2015-03-15 00:14:56.000000', 'temperatura', 600.0000, 'ºC'),
	(106569, 110, '2015-03-15 00:14:57.000000', 'temperatura', 81.0000, 'ºC'),
	(106570, 110, '2015-03-15 00:14:58.000000', 'temperatura', 1005.0000, 'ºC'),
	(106571, 110, '2015-03-15 00:14:59.000000', 'temperatura', 1182.0000, 'ºC'),
	(106572, 110, '2015-03-15 00:15:00.000000', 'temperatura', 497.0000, 'ºC'),
	(106573, 110, '2015-03-15 00:15:01.000000', 'temperatura', 140.0000, 'ºC'),
	(106574, 110, '2015-03-15 00:15:02.000000', 'temperatura', 409.0000, 'ºC'),
	(106575, 110, '2015-03-15 00:15:03.000000', 'temperatura', 425.0000, 'ºC'),
	(106576, 110, '2015-03-15 00:15:04.000000', 'temperatura', 899.0000, 'ºC'),
	(106577, 110, '2015-03-15 00:15:05.000000', 'temperatura', 819.0000, 'ºC'),
	(106578, 110, '2015-03-15 00:15:06.000000', 'temperatura', 200.0000, 'ºC'),
	(106579, 110, '2015-03-15 00:15:07.000000', 'temperatura', 943.0000, 'ºC'),
	(106580, 110, '2015-03-15 00:15:08.000000', 'temperatura', 517.0000, 'ºC'),
	(106581, 110, '2015-03-15 00:15:09.000000', 'temperatura', 956.0000, 'ºC'),
	(106582, 110, '2015-03-15 00:15:10.000000', 'temperatura', 831.0000, 'ºC'),
	(106583, 110, '2015-03-15 00:15:11.000000', 'temperatura', 87.0000, 'ºC'),
	(106584, 110, '2015-03-15 00:15:12.000000', 'temperatura', 341.0000, 'ºC'),
	(106585, 110, '2015-03-15 00:15:13.000000', 'temperatura', 245.0000, 'ºC'),
	(106586, 110, '2015-03-15 00:15:14.000000', 'temperatura', 204.0000, 'ºC'),
	(106587, 110, '2015-03-15 00:15:15.000000', 'temperatura', 283.0000, 'ºC'),
	(106588, 110, '2015-03-15 00:15:16.000000', 'temperatura', 804.0000, 'ºC'),
	(106589, 110, '2015-03-15 00:15:17.000000', 'temperatura', 772.0000, 'ºC'),
	(106590, 110, '2015-03-15 00:15:18.000000', 'temperatura', 249.0000, 'ºC'),
	(106591, 110, '2015-03-15 00:15:19.000000', 'temperatura', 127.0000, 'ºC'),
	(106592, 110, '2015-03-15 00:15:20.000000', 'temperatura', 1092.0000, 'ºC'),
	(106593, 110, '2015-03-15 00:15:21.000000', 'temperatura', 277.0000, 'ºC'),
	(106594, 110, '2015-03-15 00:15:22.000000', 'temperatura', 511.0000, 'ºC'),
	(106595, 110, '2015-03-15 00:15:23.000000', 'temperatura', 522.0000, 'ºC'),
	(106596, 110, '2015-03-15 00:15:24.000000', 'temperatura', 1080.0000, 'ºC'),
	(106597, 110, '2015-03-15 00:15:25.000000', 'temperatura', 232.0000, 'ºC'),
	(106598, 110, '2015-03-15 00:15:26.000000', 'temperatura', 321.0000, 'ºC'),
	(106599, 110, '2015-03-15 00:15:27.000000', 'temperatura', 911.0000, 'ºC'),
	(106600, 110, '2015-03-15 00:15:28.000000', 'temperatura', 1194.0000, 'ºC'),
	(106601, 110, '2015-03-15 00:15:29.000000', 'temperatura', 835.0000, 'ºC'),
	(106602, 110, '2015-03-15 00:15:30.000000', 'temperatura', 592.0000, 'ºC'),
	(106603, 110, '2015-03-15 00:15:31.000000', 'temperatura', 457.0000, 'ºC'),
	(106604, 110, '2015-03-15 00:15:32.000000', 'temperatura', 510.0000, 'ºC'),
	(106605, 110, '2015-03-15 00:15:33.000000', 'temperatura', 1180.0000, 'ºC'),
	(106606, 110, '2015-03-15 00:15:34.000000', 'temperatura', 768.0000, 'ºC'),
	(106607, 110, '2015-03-15 00:15:35.000000', 'temperatura', 304.0000, 'ºC'),
	(106608, 110, '2015-03-15 00:15:36.000000', 'temperatura', 413.0000, 'ºC'),
	(106609, 110, '2015-03-15 00:15:37.000000', 'temperatura', 1154.0000, 'ºC'),
	(106610, 110, '2015-03-15 00:15:38.000000', 'temperatura', 933.0000, 'ºC'),
	(106611, 110, '2015-03-15 00:15:39.000000', 'temperatura', 4.0000, 'ºC'),
	(106612, 110, '2015-03-15 00:15:40.000000', 'temperatura', 821.0000, 'ºC'),
	(106613, 110, '2015-03-15 00:15:41.000000', 'temperatura', 494.0000, 'ºC'),
	(106614, 110, '2015-03-15 00:15:42.000000', 'temperatura', 5.0000, 'ºC'),
	(106615, 110, '2015-03-15 00:15:43.000000', 'temperatura', 945.0000, 'ºC'),
	(106616, 110, '2015-03-15 00:15:44.000000', 'temperatura', 1110.0000, 'ºC'),
	(106617, 110, '2015-03-15 00:15:45.000000', 'temperatura', 314.0000, 'ºC'),
	(106618, 110, '2015-03-15 00:15:46.000000', 'temperatura', 642.0000, 'ºC'),
	(106619, 110, '2015-03-15 00:15:47.000000', 'temperatura', 1069.0000, 'ºC'),
	(106620, 110, '2015-03-15 00:15:48.000000', 'temperatura', 1017.0000, 'ºC'),
	(106621, 110, '2015-03-15 00:15:49.000000', 'temperatura', 681.0000, 'ºC'),
	(106622, 110, '2015-03-15 00:15:50.000000', 'temperatura', 354.0000, 'ºC'),
	(106623, 110, '2015-03-15 00:15:51.000000', 'temperatura', 929.0000, 'ºC'),
	(106624, 110, '2015-03-15 00:15:52.000000', 'temperatura', 1182.0000, 'ºC'),
	(106625, 110, '2015-03-15 00:15:53.000000', 'temperatura', 725.0000, 'ºC'),
	(106626, 110, '2015-03-15 00:15:54.000000', 'temperatura', 80.0000, 'ºC'),
	(106627, 110, '2015-03-15 00:15:55.000000', 'temperatura', 625.0000, 'ºC'),
	(106628, 110, '2015-03-15 00:15:56.000000', 'temperatura', 483.0000, 'ºC'),
	(106629, 110, '2015-03-15 00:15:57.000000', 'temperatura', 542.0000, 'ºC'),
	(106630, 110, '2015-03-15 00:15:58.000000', 'temperatura', 62.0000, 'ºC'),
	(106631, 110, '2015-03-15 00:15:59.000000', 'temperatura', 1085.0000, 'ºC'),
	(106632, 110, '2015-03-15 00:16:00.000000', 'temperatura', 441.0000, 'ºC'),
	(106633, 110, '2015-03-15 00:16:01.000000', 'temperatura', 148.0000, 'ºC'),
	(106634, 110, '2015-03-15 00:16:02.000000', 'temperatura', 619.0000, 'ºC'),
	(106635, 110, '2015-03-15 00:16:03.000000', 'temperatura', 251.0000, 'ºC'),
	(106636, 110, '2015-03-15 00:16:04.000000', 'temperatura', 598.0000, 'ºC'),
	(106637, 110, '2015-03-15 00:16:05.000000', 'temperatura', 1036.0000, 'ºC'),
	(106638, 110, '2015-03-15 00:16:06.000000', 'temperatura', 989.0000, 'ºC'),
	(106639, 110, '2015-03-15 00:16:07.000000', 'temperatura', 637.0000, 'ºC'),
	(106640, 110, '2015-03-15 00:16:08.000000', 'temperatura', 219.0000, 'ºC'),
	(106641, 110, '2015-03-15 00:16:09.000000', 'temperatura', 384.0000, 'ºC'),
	(106642, 110, '2015-03-15 00:16:10.000000', 'temperatura', 63.0000, 'ºC'),
	(106643, 110, '2015-03-15 00:16:11.000000', 'temperatura', 365.0000, 'ºC'),
	(106644, 110, '2015-03-15 00:16:12.000000', 'temperatura', 436.0000, 'ºC'),
	(106645, 110, '2015-03-15 00:16:13.000000', 'temperatura', 1083.0000, 'ºC'),
	(106646, 110, '2015-03-15 00:16:14.000000', 'temperatura', 510.0000, 'ºC'),
	(106647, 110, '2015-03-15 00:16:15.000000', 'temperatura', 502.0000, 'ºC'),
	(106648, 110, '2015-03-15 00:16:16.000000', 'temperatura', 979.0000, 'ºC'),
	(106649, 110, '2015-03-15 00:16:17.000000', 'temperatura', 990.0000, 'ºC'),
	(106650, 110, '2015-03-15 00:16:18.000000', 'temperatura', 812.0000, 'ºC'),
	(106651, 110, '2015-03-15 00:16:19.000000', 'temperatura', 1092.0000, 'ºC'),
	(106652, 110, '2015-03-15 00:16:20.000000', 'temperatura', 626.0000, 'ºC'),
	(106653, 110, '2015-03-15 00:16:21.000000', 'temperatura', 1052.0000, 'ºC'),
	(106654, 110, '2015-03-15 00:16:22.000000', 'temperatura', 985.0000, 'ºC'),
	(106655, 110, '2015-03-15 00:16:23.000000', 'temperatura', 567.0000, 'ºC'),
	(106656, 110, '2015-03-15 00:16:24.000000', 'temperatura', 1081.0000, 'ºC'),
	(106657, 110, '2015-03-15 00:16:25.000000', 'temperatura', 106.0000, 'ºC'),
	(106658, 110, '2015-03-15 00:16:26.000000', 'temperatura', 887.0000, 'ºC'),
	(106659, 110, '2015-03-15 00:16:27.000000', 'temperatura', 518.0000, 'ºC'),
	(106660, 110, '2015-03-15 00:16:28.000000', 'temperatura', 1130.0000, 'ºC'),
	(106661, 110, '2015-03-15 00:16:29.000000', 'temperatura', 494.0000, 'ºC'),
	(106662, 110, '2015-03-15 00:16:30.000000', 'temperatura', 282.0000, 'ºC'),
	(106663, 110, '2015-03-15 00:16:31.000000', 'temperatura', 1126.0000, 'ºC'),
	(106664, 110, '2015-03-15 00:16:32.000000', 'temperatura', 1187.0000, 'ºC'),
	(106665, 110, '2015-03-15 00:16:33.000000', 'temperatura', 159.0000, 'ºC'),
	(106666, 110, '2015-03-15 00:16:34.000000', 'temperatura', 832.0000, 'ºC'),
	(106667, 110, '2015-03-15 00:16:35.000000', 'temperatura', 84.0000, 'ºC'),
	(106668, 110, '2015-03-15 00:16:36.000000', 'temperatura', 326.0000, 'ºC'),
	(106669, 110, '2015-03-15 00:16:37.000000', 'temperatura', 178.0000, 'ºC'),
	(106670, 110, '2015-03-15 00:16:38.000000', 'temperatura', 1114.0000, 'ºC'),
	(106671, 110, '2015-03-15 00:16:39.000000', 'temperatura', 233.0000, 'ºC'),
	(106672, 110, '2015-03-15 00:16:40.000000', 'temperatura', 226.0000, 'ºC'),
	(106673, 110, '2015-03-15 00:16:41.000000', 'temperatura', 429.0000, 'ºC'),
	(106674, 110, '2015-03-15 00:16:42.000000', 'temperatura', 269.0000, 'ºC'),
	(106675, 110, '2015-03-15 00:16:43.000000', 'temperatura', 57.0000, 'ºC'),
	(106676, 110, '2015-03-15 00:16:44.000000', 'temperatura', 681.0000, 'ºC'),
	(106677, 110, '2015-03-15 00:16:45.000000', 'temperatura', 832.0000, 'ºC'),
	(106678, 110, '2015-03-15 00:16:46.000000', 'temperatura', 920.0000, 'ºC'),
	(106679, 110, '2015-03-15 00:16:47.000000', 'temperatura', 902.0000, 'ºC'),
	(106680, 110, '2015-03-15 00:16:48.000000', 'temperatura', 552.0000, 'ºC'),
	(106681, 110, '2015-03-15 00:16:49.000000', 'temperatura', 56.0000, 'ºC'),
	(106682, 110, '2015-03-15 00:16:50.000000', 'temperatura', 1024.0000, 'ºC'),
	(106683, 110, '2015-03-15 00:16:51.000000', 'temperatura', 154.0000, 'ºC'),
	(106684, 110, '2015-03-15 00:16:52.000000', 'temperatura', 96.0000, 'ºC'),
	(106685, 110, '2015-03-15 00:16:53.000000', 'temperatura', 17.0000, 'ºC'),
	(106686, 110, '2015-03-15 00:16:54.000000', 'temperatura', 1000.0000, 'ºC'),
	(106687, 110, '2015-03-15 00:16:55.000000', 'temperatura', 148.0000, 'ºC'),
	(106688, 110, '2015-03-15 00:16:56.000000', 'temperatura', 139.0000, 'ºC'),
	(106689, 110, '2015-03-15 00:16:57.000000', 'temperatura', 253.0000, 'ºC'),
	(106690, 110, '2015-03-15 00:16:58.000000', 'temperatura', 849.0000, 'ºC'),
	(106691, 110, '2015-03-15 00:16:59.000000', 'temperatura', 1086.0000, 'ºC'),
	(106692, 110, '2015-03-15 00:17:00.000000', 'temperatura', 482.0000, 'ºC'),
	(106693, 110, '2015-03-15 00:17:01.000000', 'temperatura', 355.0000, 'ºC'),
	(106694, 110, '2015-03-15 00:17:02.000000', 'temperatura', 329.0000, 'ºC'),
	(106695, 110, '2015-03-15 00:17:03.000000', 'temperatura', 580.0000, 'ºC'),
	(106696, 110, '2015-03-15 00:17:04.000000', 'temperatura', 715.0000, 'ºC'),
	(106697, 110, '2015-03-15 00:17:05.000000', 'temperatura', 635.0000, 'ºC'),
	(106698, 110, '2015-03-15 00:17:06.000000', 'temperatura', 1028.0000, 'ºC'),
	(106699, 110, '2015-03-15 00:17:07.000000', 'temperatura', 837.0000, 'ºC'),
	(106700, 110, '2015-03-15 00:17:08.000000', 'temperatura', 1103.0000, 'ºC'),
	(106701, 110, '2015-03-15 00:17:09.000000', 'temperatura', 603.0000, 'ºC'),
	(106702, 110, '2015-03-15 00:17:10.000000', 'temperatura', 906.0000, 'ºC'),
	(106703, 110, '2015-03-15 00:17:11.000000', 'temperatura', 323.0000, 'ºC'),
	(106704, 110, '2015-03-15 00:17:12.000000', 'temperatura', 96.0000, 'ºC'),
	(106705, 110, '2015-03-15 00:17:13.000000', 'temperatura', 714.0000, 'ºC'),
	(106706, 110, '2015-03-15 00:17:14.000000', 'temperatura', 881.0000, 'ºC'),
	(106707, 110, '2015-03-15 00:17:15.000000', 'temperatura', 1063.0000, 'ºC'),
	(106708, 110, '2015-03-15 00:17:16.000000', 'temperatura', 272.0000, 'ºC'),
	(106709, 110, '2015-03-15 00:17:17.000000', 'temperatura', 574.0000, 'ºC'),
	(106710, 110, '2015-03-15 00:17:18.000000', 'temperatura', 852.0000, 'ºC'),
	(106711, 110, '2015-03-15 00:17:19.000000', 'temperatura', 141.0000, 'ºC'),
	(106712, 110, '2015-03-15 00:17:20.000000', 'temperatura', 549.0000, 'ºC'),
	(106713, 110, '2015-03-15 00:17:21.000000', 'temperatura', 1124.0000, 'ºC'),
	(106714, 110, '2015-03-15 00:17:22.000000', 'temperatura', 372.0000, 'ºC'),
	(106715, 110, '2015-03-15 00:17:23.000000', 'temperatura', 890.0000, 'ºC'),
	(106716, 110, '2015-03-15 00:17:24.000000', 'temperatura', 935.0000, 'ºC'),
	(106717, 110, '2015-03-15 00:17:25.000000', 'temperatura', 803.0000, 'ºC'),
	(106718, 110, '2015-03-15 00:17:26.000000', 'temperatura', 11.0000, 'ºC'),
	(106719, 110, '2015-03-15 00:17:27.000000', 'temperatura', 46.0000, 'ºC'),
	(106720, 110, '2015-03-15 00:17:28.000000', 'temperatura', 197.0000, 'ºC'),
	(106721, 110, '2015-03-15 00:17:29.000000', 'temperatura', 850.0000, 'ºC'),
	(106722, 110, '2015-03-15 00:17:30.000000', 'temperatura', 60.0000, 'ºC'),
	(106723, 110, '2015-03-15 00:17:31.000000', 'temperatura', 149.0000, 'ºC'),
	(106724, 110, '2015-03-15 00:17:32.000000', 'temperatura', 568.0000, 'ºC'),
	(106725, 110, '2015-03-15 00:17:33.000000', 'temperatura', 1191.0000, 'ºC'),
	(106726, 110, '2015-03-15 00:17:34.000000', 'temperatura', 651.0000, 'ºC'),
	(106727, 110, '2015-03-15 00:17:35.000000', 'temperatura', 883.0000, 'ºC'),
	(106728, 110, '2015-03-15 00:17:36.000000', 'temperatura', 61.0000, 'ºC'),
	(106729, 110, '2015-03-15 00:17:37.000000', 'temperatura', 57.0000, 'ºC'),
	(106730, 110, '2015-03-15 00:17:38.000000', 'temperatura', 103.0000, 'ºC'),
	(106731, 110, '2015-03-15 00:17:39.000000', 'temperatura', 347.0000, 'ºC'),
	(106732, 110, '2015-03-15 00:17:40.000000', 'temperatura', 223.0000, 'ºC'),
	(106733, 110, '2015-03-15 00:17:41.000000', 'temperatura', 76.0000, 'ºC'),
	(106734, 110, '2015-03-15 00:17:42.000000', 'temperatura', 913.0000, 'ºC'),
	(106735, 110, '2015-03-15 00:17:43.000000', 'temperatura', 736.0000, 'ºC'),
	(106736, 110, '2015-03-15 00:17:44.000000', 'temperatura', 941.0000, 'ºC'),
	(106737, 110, '2015-03-15 00:17:45.000000', 'temperatura', 96.0000, 'ºC'),
	(106738, 110, '2015-03-15 00:17:46.000000', 'temperatura', 59.0000, 'ºC'),
	(106739, 110, '2015-03-15 00:17:47.000000', 'temperatura', 8.0000, 'ºC'),
	(106740, 110, '2015-03-15 00:17:48.000000', 'temperatura', 1063.0000, 'ºC'),
	(106741, 110, '2015-03-15 00:17:49.000000', 'temperatura', 491.0000, 'ºC'),
	(106742, 110, '2015-03-15 00:17:50.000000', 'temperatura', 469.0000, 'ºC'),
	(106743, 110, '2015-03-15 00:17:51.000000', 'temperatura', 870.0000, 'ºC'),
	(106744, 110, '2015-03-15 00:17:52.000000', 'temperatura', 545.0000, 'ºC'),
	(106745, 110, '2015-03-15 00:17:53.000000', 'temperatura', 114.0000, 'ºC'),
	(106746, 110, '2015-03-15 00:17:54.000000', 'temperatura', 135.0000, 'ºC'),
	(106747, 110, '2015-03-15 00:17:55.000000', 'temperatura', 334.0000, 'ºC'),
	(106748, 110, '2015-03-15 00:17:56.000000', 'temperatura', 64.0000, 'ºC'),
	(106749, 110, '2015-03-15 00:17:57.000000', 'temperatura', 520.0000, 'ºC'),
	(106750, 110, '2015-03-15 00:17:58.000000', 'temperatura', 10.0000, 'ºC'),
	(106751, 110, '2015-03-15 00:17:59.000000', 'temperatura', 890.0000, 'ºC'),
	(106752, 110, '2015-03-15 00:18:00.000000', 'temperatura', 821.0000, 'ºC'),
	(106753, 110, '2015-03-15 00:18:01.000000', 'temperatura', 235.0000, 'ºC'),
	(106754, 110, '2015-03-15 00:18:02.000000', 'temperatura', 1111.0000, 'ºC'),
	(106755, 110, '2015-03-15 00:18:03.000000', 'temperatura', 52.0000, 'ºC'),
	(106756, 110, '2015-03-15 00:18:04.000000', 'temperatura', 526.0000, 'ºC'),
	(106757, 110, '2015-03-15 00:18:05.000000', 'temperatura', 75.0000, 'ºC'),
	(106758, 110, '2015-03-15 00:18:06.000000', 'temperatura', 1196.0000, 'ºC'),
	(106759, 110, '2015-03-15 00:18:07.000000', 'temperatura', 957.0000, 'ºC'),
	(106760, 110, '2015-03-15 00:18:08.000000', 'temperatura', 1195.0000, 'ºC'),
	(106761, 110, '2015-03-15 00:18:09.000000', 'temperatura', 708.0000, 'ºC'),
	(106762, 110, '2015-03-15 00:18:10.000000', 'temperatura', 1155.0000, 'ºC'),
	(106763, 110, '2015-03-15 00:18:11.000000', 'temperatura', 51.0000, 'ºC'),
	(106764, 110, '2015-03-15 00:18:12.000000', 'temperatura', 389.0000, 'ºC'),
	(106765, 110, '2015-03-15 00:18:13.000000', 'temperatura', 595.0000, 'ºC'),
	(106766, 110, '2015-03-15 00:18:14.000000', 'temperatura', 607.0000, 'ºC'),
	(106767, 110, '2015-03-15 00:18:15.000000', 'temperatura', 51.0000, 'ºC'),
	(106768, 110, '2015-03-15 00:18:16.000000', 'temperatura', 835.0000, 'ºC'),
	(106769, 110, '2015-03-15 00:18:17.000000', 'temperatura', 424.0000, 'ºC'),
	(106770, 110, '2015-03-15 00:18:18.000000', 'temperatura', 813.0000, 'ºC'),
	(106771, 110, '2015-03-15 00:18:19.000000', 'temperatura', 395.0000, 'ºC'),
	(106772, 110, '2015-03-15 00:18:20.000000', 'temperatura', 734.0000, 'ºC'),
	(106773, 110, '2015-03-15 00:18:21.000000', 'temperatura', 87.0000, 'ºC'),
	(106774, 110, '2015-03-15 00:18:22.000000', 'temperatura', 632.0000, 'ºC'),
	(106775, 110, '2015-03-15 00:18:23.000000', 'temperatura', 502.0000, 'ºC'),
	(106776, 110, '2015-03-15 00:18:24.000000', 'temperatura', 614.0000, 'ºC'),
	(106777, 110, '2015-03-15 00:18:25.000000', 'temperatura', 363.0000, 'ºC'),
	(106778, 110, '2015-03-15 00:18:26.000000', 'temperatura', 1172.0000, 'ºC'),
	(106779, 110, '2015-03-15 00:18:27.000000', 'temperatura', 1175.0000, 'ºC'),
	(106780, 110, '2015-03-15 00:18:28.000000', 'temperatura', 1159.0000, 'ºC'),
	(106781, 110, '2015-03-15 00:18:29.000000', 'temperatura', 1070.0000, 'ºC'),
	(106782, 110, '2015-03-15 00:18:30.000000', 'temperatura', 675.0000, 'ºC'),
	(106783, 110, '2015-03-15 00:18:31.000000', 'temperatura', 165.0000, 'ºC'),
	(106784, 110, '2015-03-15 00:18:32.000000', 'temperatura', 2.0000, 'ºC'),
	(106785, 110, '2015-03-15 00:18:33.000000', 'temperatura', 713.0000, 'ºC'),
	(106786, 110, '2015-03-15 00:18:34.000000', 'temperatura', 1159.0000, 'ºC'),
	(106787, 110, '2015-03-15 00:18:35.000000', 'temperatura', 56.0000, 'ºC'),
	(106788, 110, '2015-03-15 00:18:36.000000', 'temperatura', 402.0000, 'ºC'),
	(106789, 110, '2015-03-15 00:18:37.000000', 'temperatura', 646.0000, 'ºC'),
	(106790, 110, '2015-03-15 00:18:38.000000', 'temperatura', 825.0000, 'ºC'),
	(106791, 110, '2015-03-15 00:18:39.000000', 'temperatura', 986.0000, 'ºC'),
	(106792, 110, '2015-03-15 00:18:40.000000', 'temperatura', 54.0000, 'ºC'),
	(106793, 110, '2015-03-15 00:18:41.000000', 'temperatura', 914.0000, 'ºC'),
	(106794, 110, '2015-03-15 00:18:42.000000', 'temperatura', 807.0000, 'ºC'),
	(106795, 110, '2015-03-15 00:18:43.000000', 'temperatura', 94.0000, 'ºC'),
	(106796, 110, '2015-03-15 00:18:44.000000', 'temperatura', 448.0000, 'ºC'),
	(106797, 110, '2015-03-15 00:18:45.000000', 'temperatura', 759.0000, 'ºC'),
	(106798, 110, '2015-03-15 00:18:46.000000', 'temperatura', 53.0000, 'ºC'),
	(106799, 110, '2015-03-15 00:18:47.000000', 'temperatura', 390.0000, 'ºC'),
	(106800, 110, '2015-03-15 00:18:48.000000', 'temperatura', 588.0000, 'ºC'),
	(106801, 110, '2015-03-15 00:18:49.000000', 'temperatura', 573.0000, 'ºC'),
	(106802, 110, '2015-03-15 00:18:50.000000', 'temperatura', 1102.0000, 'ºC'),
	(106803, 110, '2015-03-15 00:18:51.000000', 'temperatura', 192.0000, 'ºC'),
	(106804, 110, '2015-03-15 00:18:52.000000', 'temperatura', 51.0000, 'ºC'),
	(106805, 110, '2015-03-15 00:18:53.000000', 'temperatura', 883.0000, 'ºC'),
	(106806, 110, '2015-03-15 00:18:54.000000', 'temperatura', 662.0000, 'ºC'),
	(106807, 110, '2015-03-15 00:18:55.000000', 'temperatura', 663.0000, 'ºC'),
	(106808, 110, '2015-03-15 00:18:56.000000', 'temperatura', 129.0000, 'ºC'),
	(106809, 110, '2015-03-15 00:18:57.000000', 'temperatura', 1054.0000, 'ºC'),
	(106810, 110, '2015-03-15 00:18:58.000000', 'temperatura', 86.0000, 'ºC'),
	(106811, 110, '2015-03-15 00:18:59.000000', 'temperatura', 869.0000, 'ºC'),
	(106812, 110, '2015-03-15 00:19:00.000000', 'temperatura', 485.0000, 'ºC'),
	(106813, 110, '2015-03-15 00:19:01.000000', 'temperatura', 1018.0000, 'ºC'),
	(106814, 110, '2015-03-15 00:19:02.000000', 'temperatura', 39.0000, 'ºC'),
	(106815, 110, '2015-03-15 00:19:03.000000', 'temperatura', 738.0000, 'ºC'),
	(106816, 110, '2015-03-15 00:19:04.000000', 'temperatura', 1176.0000, 'ºC'),
	(106817, 110, '2015-03-15 00:19:05.000000', 'temperatura', 65.0000, 'ºC'),
	(106818, 110, '2015-03-15 00:19:06.000000', 'temperatura', 400.0000, 'ºC'),
	(106819, 110, '2015-03-15 00:19:07.000000', 'temperatura', 604.0000, 'ºC'),
	(106820, 110, '2015-03-15 00:19:08.000000', 'temperatura', 621.0000, 'ºC'),
	(106821, 110, '2015-03-15 00:19:09.000000', 'temperatura', 92.0000, 'ºC'),
	(106822, 110, '2015-03-15 00:19:10.000000', 'temperatura', 996.0000, 'ºC'),
	(106823, 110, '2015-03-15 00:19:11.000000', 'temperatura', 1107.0000, 'ºC'),
	(106824, 110, '2015-03-15 00:19:12.000000', 'temperatura', 149.0000, 'ºC'),
	(106825, 110, '2015-03-15 00:19:13.000000', 'temperatura', 1022.0000, 'ºC'),
	(106826, 110, '2015-03-15 00:19:14.000000', 'temperatura', 1063.0000, 'ºC'),
	(106827, 110, '2015-03-15 00:19:15.000000', 'temperatura', 1050.0000, 'ºC'),
	(106828, 110, '2015-03-15 00:19:16.000000', 'temperatura', 864.0000, 'ºC'),
	(106829, 110, '2015-03-15 00:19:17.000000', 'temperatura', 1168.0000, 'ºC'),
	(106830, 110, '2015-03-15 00:19:18.000000', 'temperatura', 849.0000, 'ºC'),
	(106831, 110, '2015-03-15 00:19:19.000000', 'temperatura', 741.0000, 'ºC'),
	(106832, 110, '2015-03-15 00:19:20.000000', 'temperatura', 1160.0000, 'ºC'),
	(106833, 110, '2015-03-15 00:19:21.000000', 'temperatura', 1176.0000, 'ºC'),
	(106834, 110, '2015-03-15 00:19:22.000000', 'temperatura', 0.0000, 'ºC'),
	(106835, 110, '2015-03-15 00:19:23.000000', 'temperatura', 72.0000, 'ºC'),
	(106836, 110, '2015-03-15 00:19:24.000000', 'temperatura', 361.0000, 'ºC'),
	(106837, 110, '2015-03-15 00:19:25.000000', 'temperatura', 389.0000, 'ºC'),
	(106838, 110, '2015-03-15 00:19:26.000000', 'temperatura', 863.0000, 'ºC'),
	(106839, 110, '2015-03-15 00:19:27.000000', 'temperatura', 750.0000, 'ºC'),
	(106840, 110, '2015-03-15 00:19:28.000000', 'temperatura', 1161.0000, 'ºC'),
	(106841, 110, '2015-03-15 00:19:29.000000', 'temperatura', 1153.0000, 'ºC'),
	(106842, 110, '2015-03-15 00:19:30.000000', 'temperatura', 1085.0000, 'ºC'),
	(106843, 110, '2015-03-15 00:19:31.000000', 'temperatura', 766.0000, 'ºC'),
	(106844, 110, '2015-03-15 00:19:32.000000', 'temperatura', 575.0000, 'ºC'),
	(106845, 110, '2015-03-15 00:19:33.000000', 'temperatura', 579.0000, 'ºC'),
	(106846, 110, '2015-03-15 00:19:34.000000', 'temperatura', 1171.0000, 'ºC'),
	(106847, 110, '2015-03-15 00:19:35.000000', 'temperatura', 518.0000, 'ºC'),
	(106848, 110, '2015-03-15 00:19:36.000000', 'temperatura', 278.0000, 'ºC'),
	(106849, 110, '2015-03-15 00:19:37.000000', 'temperatura', 1035.0000, 'ºC'),
	(106850, 110, '2015-03-15 00:19:38.000000', 'temperatura', 743.0000, 'ºC'),
	(106851, 110, '2015-03-15 00:19:39.000000', 'temperatura', 612.0000, 'ºC'),
	(106852, 110, '2015-03-15 00:19:40.000000', 'temperatura', 829.0000, 'ºC'),
	(106853, 110, '2015-03-15 00:19:41.000000', 'temperatura', 1112.0000, 'ºC'),
	(106854, 110, '2015-03-15 00:19:42.000000', 'temperatura', 672.0000, 'ºC'),
	(106855, 110, '2015-03-15 00:19:43.000000', 'temperatura', 25.0000, 'ºC'),
	(106856, 110, '2015-03-15 00:19:44.000000', 'temperatura', 508.0000, 'ºC'),
	(106857, 110, '2015-03-15 00:19:45.000000', 'temperatura', 66.0000, 'ºC'),
	(106858, 110, '2015-03-15 00:19:46.000000', 'temperatura', 7.0000, 'ºC'),
	(106859, 110, '2015-03-15 00:19:47.000000', 'temperatura', 1036.0000, 'ºC'),
	(106860, 110, '2015-03-15 00:19:48.000000', 'temperatura', 362.0000, 'ºC'),
	(106861, 110, '2015-03-15 00:19:49.000000', 'temperatura', 1100.0000, 'ºC'),
	(106862, 110, '2015-03-15 00:19:50.000000', 'temperatura', 815.0000, 'ºC'),
	(106863, 110, '2015-03-15 00:19:51.000000', 'temperatura', 775.0000, 'ºC'),
	(106864, 110, '2015-03-15 00:19:52.000000', 'temperatura', 229.0000, 'ºC'),
	(106865, 110, '2015-03-15 00:19:53.000000', 'temperatura', 23.0000, 'ºC'),
	(106866, 110, '2015-03-15 00:19:54.000000', 'temperatura', 628.0000, 'ºC'),
	(106867, 110, '2015-03-15 00:19:55.000000', 'temperatura', 672.0000, 'ºC'),
	(106868, 110, '2015-03-15 00:19:56.000000', 'temperatura', 276.0000, 'ºC'),
	(106869, 110, '2015-03-15 00:19:57.000000', 'temperatura', 563.0000, 'ºC'),
	(106870, 110, '2015-03-15 00:19:58.000000', 'temperatura', 789.0000, 'ºC'),
	(106871, 110, '2015-03-15 00:19:59.000000', 'temperatura', 1055.0000, 'ºC'),
	(106872, 110, '2015-03-15 00:20:00.000000', 'temperatura', 510.0000, 'ºC'),
	(106873, 110, '2015-03-15 00:20:01.000000', 'temperatura', 584.0000, 'ºC'),
	(106874, 110, '2015-03-15 00:20:02.000000', 'temperatura', 191.0000, 'ºC'),
	(106875, 110, '2015-03-15 00:20:03.000000', 'temperatura', 405.0000, 'ºC'),
	(106876, 110, '2015-03-15 00:20:04.000000', 'temperatura', 251.0000, 'ºC'),
	(106877, 110, '2015-03-15 00:20:05.000000', 'temperatura', 40.0000, 'ºC'),
	(106878, 110, '2015-03-15 00:20:06.000000', 'temperatura', 647.0000, 'ºC'),
	(106879, 110, '2015-03-15 00:20:07.000000', 'temperatura', 718.0000, 'ºC'),
	(106880, 110, '2015-03-15 00:20:08.000000', 'temperatura', 447.0000, 'ºC'),
	(106881, 110, '2015-03-15 00:20:09.000000', 'temperatura', 81.0000, 'ºC'),
	(106882, 110, '2015-03-15 00:20:10.000000', 'temperatura', 265.0000, 'ºC'),
	(106883, 110, '2015-03-15 00:20:11.000000', 'temperatura', 1081.0000, 'ºC'),
	(106884, 110, '2015-03-15 00:20:12.000000', 'temperatura', 1013.0000, 'ºC'),
	(106885, 110, '2015-03-15 00:20:13.000000', 'temperatura', 622.0000, 'ºC'),
	(106886, 110, '2015-03-15 00:20:14.000000', 'temperatura', 73.0000, 'ºC'),
	(106887, 110, '2015-03-15 00:20:15.000000', 'temperatura', 898.0000, 'ºC'),
	(106888, 110, '2015-03-15 00:20:16.000000', 'temperatura', 670.0000, 'ºC'),
	(106889, 110, '2015-03-15 00:20:17.000000', 'temperatura', 657.0000, 'ºC'),
	(106890, 110, '2015-03-15 00:20:18.000000', 'temperatura', 74.0000, 'ºC'),
	(106891, 110, '2015-03-15 00:20:19.000000', 'temperatura', 800.0000, 'ºC'),
	(106892, 110, '2015-03-15 00:20:20.000000', 'temperatura', 180.0000, 'ºC'),
	(106893, 110, '2015-03-15 00:20:21.000000', 'temperatura', 901.0000, 'ºC'),
	(106894, 110, '2015-03-15 00:20:22.000000', 'temperatura', 364.0000, 'ºC'),
	(106895, 110, '2015-03-15 00:20:23.000000', 'temperatura', 317.0000, 'ºC'),
	(106896, 110, '2015-03-15 00:20:24.000000', 'temperatura', 492.0000, 'ºC'),
	(106897, 110, '2015-03-15 00:20:25.000000', 'temperatura', 313.0000, 'ºC'),
	(106898, 110, '2015-03-15 00:20:26.000000', 'temperatura', 87.0000, 'ºC'),
	(106899, 110, '2015-03-15 00:20:27.000000', 'temperatura', 698.0000, 'ºC'),
	(106900, 110, '2015-03-15 00:20:28.000000', 'temperatura', 830.0000, 'ºC'),
	(106901, 110, '2015-03-15 00:20:29.000000', 'temperatura', 856.0000, 'ºC'),
	(106902, 110, '2015-03-15 00:20:30.000000', 'temperatura', 592.0000, 'ºC'),
	(106903, 110, '2015-03-15 00:20:31.000000', 'temperatura', 393.0000, 'ºC'),
	(106904, 110, '2015-03-15 00:20:32.000000', 'temperatura', 187.0000, 'ºC'),
	(106905, 110, '2015-03-15 00:20:33.000000', 'temperatura', 956.0000, 'ºC'),
	(106906, 110, '2015-03-15 00:20:34.000000', 'temperatura', 621.0000, 'ºC'),
	(106907, 110, '2015-03-15 00:20:35.000000', 'temperatura', 238.0000, 'ºC'),
	(106908, 110, '2015-03-15 00:20:36.000000', 'temperatura', 526.0000, 'ºC'),
	(106909, 110, '2015-03-15 00:20:37.000000', 'temperatura', 715.0000, 'ºC'),
	(106910, 110, '2015-03-15 00:20:38.000000', 'temperatura', 799.0000, 'ºC'),
	(106911, 110, '2015-03-15 00:20:39.000000', 'temperatura', 652.0000, 'ºC'),
	(106912, 110, '2015-03-15 00:20:40.000000', 'temperatura', 863.0000, 'ºC'),
	(106913, 110, '2015-03-15 00:20:41.000000', 'temperatura', 1160.0000, 'ºC'),
	(106914, 110, '2015-03-15 00:20:42.000000', 'temperatura', 809.0000, 'ºC'),
	(106915, 110, '2015-03-15 00:20:43.000000', 'temperatura', 566.0000, 'ºC'),
	(106916, 110, '2015-03-15 00:20:44.000000', 'temperatura', 405.0000, 'ºC'),
	(106917, 110, '2015-03-15 00:20:45.000000', 'temperatura', 329.0000, 'ºC'),
	(106918, 110, '2015-03-15 00:20:46.000000', 'temperatura', 428.0000, 'ºC'),
	(106919, 110, '2015-03-15 00:20:47.000000', 'temperatura', 1153.0000, 'ºC'),
	(106920, 110, '2015-03-15 00:20:48.000000', 'temperatura', 881.0000, 'ºC'),
	(106921, 110, '2015-03-15 00:20:49.000000', 'temperatura', 949.0000, 'ºC'),
	(106922, 110, '2015-03-15 00:20:50.000000', 'temperatura', 900.0000, 'ºC'),
	(106923, 110, '2015-03-15 00:20:51.000000', 'temperatura', 454.0000, 'ºC'),
	(106924, 110, '2015-03-15 00:20:52.000000', 'temperatura', 769.0000, 'ºC'),
	(106925, 110, '2015-03-15 00:20:53.000000', 'temperatura', 84.0000, 'ºC'),
	(106926, 110, '2015-03-15 00:20:54.000000', 'temperatura', 514.0000, 'ºC'),
	(106927, 110, '2015-03-15 00:20:55.000000', 'temperatura', 1120.0000, 'ºC'),
	(106928, 110, '2015-03-15 00:20:56.000000', 'temperatura', 457.0000, 'ºC'),
	(106929, 110, '2015-03-15 00:20:57.000000', 'temperatura', 128.0000, 'ºC'),
	(106930, 110, '2015-03-15 00:20:58.000000', 'temperatura', 466.0000, 'ºC'),
	(106931, 110, '2015-03-15 00:20:59.000000', 'temperatura', 749.0000, 'ºC'),
	(106932, 110, '2015-03-15 00:21:00.000000', 'temperatura', 1148.0000, 'ºC'),
	(106933, 110, '2015-03-15 00:21:01.000000', 'temperatura', 1094.0000, 'ºC'),
	(106934, 110, '2015-03-15 00:21:02.000000', 'temperatura', 827.0000, 'ºC'),
	(106935, 110, '2015-03-15 00:21:03.000000', 'temperatura', 852.0000, 'ºC'),
	(106936, 110, '2015-03-15 00:21:04.000000', 'temperatura', 582.0000, 'ºC'),
	(106937, 110, '2015-03-15 00:21:05.000000', 'temperatura', 352.0000, 'ºC'),
	(106938, 110, '2015-03-15 00:21:06.000000', 'temperatura', 15.0000, 'ºC'),
	(106939, 110, '2015-03-15 00:21:07.000000', 'temperatura', 220.0000, 'ºC'),
	(106940, 110, '2015-03-15 00:21:08.000000', 'temperatura', 1056.0000, 'ºC'),
	(106941, 110, '2015-03-15 00:21:09.000000', 'temperatura', 1022.0000, 'ºC'),
	(106942, 110, '2015-03-15 00:21:10.000000', 'temperatura', 741.0000, 'ºC'),
	(106943, 110, '2015-03-15 00:21:11.000000', 'temperatura', 639.0000, 'ºC'),
	(106944, 110, '2015-03-15 00:21:12.000000', 'temperatura', 973.0000, 'ºC'),
	(106945, 110, '2015-03-15 00:21:13.000000', 'temperatura', 549.0000, 'ºC'),
	(106946, 110, '2015-03-15 00:21:14.000000', 'temperatura', 1026.0000, 'ºC'),
	(106947, 110, '2015-03-15 00:21:15.000000', 'temperatura', 1084.0000, 'ºC'),
	(106948, 110, '2015-03-15 00:21:16.000000', 'temperatura', 1142.0000, 'ºC'),
	(106949, 110, '2015-03-15 00:21:17.000000', 'temperatura', 61.0000, 'ºC'),
	(106950, 110, '2015-03-15 00:21:18.000000', 'temperatura', 477.0000, 'ºC'),
	(106951, 110, '2015-03-15 00:21:19.000000', 'temperatura', 1002.0000, 'ºC'),
	(106952, 110, '2015-03-15 00:21:20.000000', 'temperatura', 1179.0000, 'ºC'),
	(106953, 110, '2015-03-15 00:21:21.000000', 'temperatura', 492.0000, 'ºC'),
	(106954, 110, '2015-03-15 00:21:22.000000', 'temperatura', 122.0000, 'ºC'),
	(106955, 110, '2015-03-15 00:21:23.000000', 'temperatura', 335.0000, 'ºC'),
	(106956, 110, '2015-03-15 00:21:24.000000', 'temperatura', 109.0000, 'ºC'),
	(106957, 110, '2015-03-15 00:21:25.000000', 'temperatura', 742.0000, 'ºC'),
	(106958, 110, '2015-03-15 00:21:26.000000', 'temperatura', 983.0000, 'ºC'),
	(106959, 110, '2015-03-15 00:21:27.000000', 'temperatura', 289.0000, 'ºC'),
	(106960, 110, '2015-03-15 00:21:28.000000', 'temperatura', 897.0000, 'ºC'),
	(106961, 110, '2015-03-15 00:21:29.000000', 'temperatura', 20.0000, 'ºC'),
	(106962, 110, '2015-03-15 00:21:30.000000', 'temperatura', 1010.0000, 'ºC'),
	(106963, 110, '2015-03-15 00:21:31.000000', 'temperatura', 188.0000, 'ºC'),
	(106964, 110, '2015-03-15 00:21:32.000000', 'temperatura', 310.0000, 'ºC'),
	(106965, 110, '2015-03-15 00:21:33.000000', 'temperatura', 988.0000, 'ºC'),
	(106966, 110, '2015-03-15 00:21:34.000000', 'temperatura', 409.0000, 'ºC'),
	(106967, 110, '2015-03-15 00:21:35.000000', 'temperatura', 282.0000, 'ºC'),
	(106968, 110, '2015-03-15 00:21:36.000000', 'temperatura', 182.0000, 'ºC'),
	(106969, 110, '2015-03-15 00:21:37.000000', 'temperatura', 65.0000, 'ºC'),
	(106970, 110, '2015-03-15 00:21:38.000000', 'temperatura', 980.0000, 'ºC'),
	(106971, 110, '2015-03-15 00:21:39.000000', 'temperatura', 1105.0000, 'ºC'),
	(106972, 110, '2015-03-15 00:21:40.000000', 'temperatura', 185.0000, 'ºC'),
	(106973, 110, '2015-03-15 00:21:41.000000', 'temperatura', 9.0000, 'ºC'),
	(106974, 110, '2015-03-15 00:21:42.000000', 'temperatura', 693.0000, 'ºC'),
	(106975, 110, '2015-03-15 00:21:43.000000', 'temperatura', 1038.0000, 'ºC'),
	(106976, 110, '2015-03-15 00:21:44.000000', 'temperatura', 712.0000, 'ºC'),
	(106977, 110, '2015-03-15 00:21:45.000000', 'temperatura', 448.0000, 'ºC'),
	(106978, 110, '2015-03-15 00:21:46.000000', 'temperatura', 103.0000, 'ºC'),
	(106979, 110, '2015-03-15 00:21:47.000000', 'temperatura', 371.0000, 'ºC'),
	(106980, 110, '2015-03-15 00:21:48.000000', 'temperatura', 347.0000, 'ºC'),
	(106981, 110, '2015-03-15 00:21:49.000000', 'temperatura', 623.0000, 'ºC'),
	(106982, 110, '2015-03-15 00:21:50.000000', 'temperatura', 875.0000, 'ºC'),
	(106983, 110, '2015-03-15 00:21:51.000000', 'temperatura', 106.0000, 'ºC'),
	(106984, 110, '2015-03-15 00:21:52.000000', 'temperatura', 306.0000, 'ºC'),
	(106985, 110, '2015-03-15 00:21:53.000000', 'temperatura', 13.0000, 'ºC'),
	(106986, 110, '2015-03-15 00:21:54.000000', 'temperatura', 348.0000, 'ºC'),
	(106987, 110, '2015-03-15 00:21:55.000000', 'temperatura', 500.0000, 'ºC'),
	(106988, 110, '2015-03-15 00:21:56.000000', 'temperatura', 255.0000, 'ºC'),
	(106989, 110, '2015-03-15 00:21:57.000000', 'temperatura', 978.0000, 'ºC'),
	(106990, 110, '2015-03-15 00:21:58.000000', 'temperatura', 526.0000, 'ºC'),
	(106991, 110, '2015-03-15 00:21:59.000000', 'temperatura', 897.0000, 'ºC'),
	(106992, 110, '2015-03-15 00:22:00.000000', 'temperatura', 506.0000, 'ºC'),
	(106993, 110, '2015-03-15 00:22:01.000000', 'temperatura', 1041.0000, 'ºC'),
	(106994, 110, '2015-03-15 00:22:02.000000', 'temperatura', 87.0000, 'ºC'),
	(106995, 110, '2015-03-15 00:22:03.000000', 'temperatura', 911.0000, 'ºC'),
	(106996, 110, '2015-03-15 00:22:04.000000', 'temperatura', 696.0000, 'ºC'),
	(106997, 110, '2015-03-15 00:22:05.000000', 'temperatura', 748.0000, 'ºC'),
	(106998, 110, '2015-03-15 00:22:06.000000', 'temperatura', 450.0000, 'ºC'),
	(106999, 110, '2015-03-15 00:22:07.000000', 'temperatura', 9.0000, 'ºC'),
	(107000, 110, '2015-03-15 00:22:08.000000', 'temperatura', 1095.0000, 'ºC'),
	(107001, 110, '2015-03-15 00:22:09.000000', 'temperatura', 647.0000, 'ºC'),
	(107002, 110, '2015-03-15 00:22:10.000000', 'temperatura', 1151.0000, 'ºC'),
	(107003, 110, '2015-03-15 00:22:11.000000', 'temperatura', 213.0000, 'ºC'),
	(107004, 110, '2015-03-15 00:22:12.000000', 'temperatura', 13.0000, 'ºC'),
	(107005, 110, '2015-03-15 00:22:13.000000', 'temperatura', 629.0000, 'ºC'),
	(107006, 110, '2015-03-15 00:22:14.000000', 'temperatura', 705.0000, 'ºC'),
	(107007, 110, '2015-03-15 00:22:15.000000', 'temperatura', 440.0000, 'ºC'),
	(107008, 110, '2015-03-15 00:22:16.000000', 'temperatura', 84.0000, 'ºC'),
	(107009, 110, '2015-03-15 00:22:17.000000', 'temperatura', 301.0000, 'ºC'),
	(107010, 110, '2015-03-15 00:22:18.000000', 'temperatura', 55.0000, 'ºC'),
	(107011, 110, '2015-03-15 00:22:19.000000', 'temperatura', 573.0000, 'ºC'),
	(107012, 110, '2015-03-15 00:22:20.000000', 'temperatura', 298.0000, 'ºC'),
	(107013, 110, '2015-03-15 00:22:21.000000', 'temperatura', 974.0000, 'ºC'),
	(107014, 110, '2015-03-15 00:22:22.000000', 'temperatura', 375.0000, 'ºC'),
	(107015, 110, '2015-03-15 00:22:23.000000', 'temperatura', 152.0000, 'ºC'),
	(107016, 110, '2015-03-15 00:22:24.000000', 'temperatura', 836.0000, 'ºC'),
	(107017, 110, '2015-03-15 00:22:25.000000', 'temperatura', 123.0000, 'ºC'),
	(107018, 110, '2015-03-15 00:22:26.000000', 'temperatura', 509.0000, 'ºC'),
	(107019, 110, '2015-03-15 00:22:27.000000', 'temperatura', 977.0000, 'ºC'),
	(107020, 110, '2015-03-15 00:22:28.000000', 'temperatura', 959.0000, 'ºC'),
	(107021, 110, '2015-03-15 00:22:29.000000', 'temperatura', 664.0000, 'ºC'),
	(107022, 110, '2015-03-15 00:22:30.000000', 'temperatura', 446.0000, 'ºC'),
	(107023, 110, '2015-03-15 00:22:31.000000', 'temperatura', 235.0000, 'ºC'),
	(107024, 110, '2015-03-15 00:22:32.000000', 'temperatura', 1038.0000, 'ºC'),
	(107025, 110, '2015-03-15 00:22:33.000000', 'temperatura', 885.0000, 'ºC'),
	(107026, 110, '2015-03-15 00:22:34.000000', 'temperatura', 113.0000, 'ºC'),
	(107027, 110, '2015-03-15 00:22:35.000000', 'temperatura', 309.0000, 'ºC'),
	(107028, 110, '2015-03-15 00:22:36.000000', 'temperatura', 7.0000, 'ºC'),
	(107029, 110, '2015-03-15 00:22:37.000000', 'temperatura', 308.0000, 'ºC'),
	(107030, 110, '2015-03-15 00:22:38.000000', 'temperatura', 318.0000, 'ºC'),
	(107031, 110, '2015-03-15 00:22:39.000000', 'temperatura', 669.0000, 'ºC'),
	(107032, 110, '2015-03-15 00:22:40.000000', 'temperatura', 1189.0000, 'ºC'),
	(107033, 110, '2015-03-15 00:22:41.000000', 'temperatura', 340.0000, 'ºC'),
	(107034, 110, '2015-03-15 00:22:42.000000', 'temperatura', 532.0000, 'ºC'),
	(107035, 110, '2015-03-15 00:22:43.000000', 'temperatura', 442.0000, 'ºC'),
	(107036, 110, '2015-03-15 00:22:44.000000', 'temperatura', 616.0000, 'ºC'),
	(107037, 110, '2015-03-15 00:22:45.000000', 'temperatura', 551.0000, 'ºC'),
	(107038, 110, '2015-03-15 00:22:46.000000', 'temperatura', 911.0000, 'ºC'),
	(107039, 110, '2015-03-15 00:22:47.000000', 'temperatura', 499.0000, 'ºC'),
	(107040, 110, '2015-03-15 00:22:48.000000', 'temperatura', 966.0000, 'ºC'),
	(107041, 110, '2015-03-15 00:22:49.000000', 'temperatura', 932.0000, 'ºC'),
	(107042, 110, '2015-03-15 00:22:50.000000', 'temperatura', 563.0000, 'ºC'),
	(107043, 110, '2015-03-15 00:22:51.000000', 'temperatura', 17.0000, 'ºC'),
	(107044, 110, '2015-03-15 00:22:52.000000', 'temperatura', 800.0000, 'ºC'),
	(107045, 110, '2015-03-15 00:22:53.000000', 'temperatura', 348.0000, 'ºC'),
	(107046, 110, '2015-03-15 00:22:54.000000', 'temperatura', 539.0000, 'ºC'),
	(107047, 110, '2015-03-15 00:22:55.000000', 'temperatura', 454.0000, 'ºC'),
	(107048, 110, '2015-03-15 00:22:56.000000', 'temperatura', 652.0000, 'ºC'),
	(107049, 110, '2015-03-15 00:22:57.000000', 'temperatura', 699.0000, 'ºC'),
	(107050, 110, '2015-03-15 00:22:58.000000', 'temperatura', 341.0000, 'ºC'),
	(107051, 110, '2015-03-15 00:22:59.000000', 'temperatura', 809.0000, 'ºC'),
	(107052, 110, '2015-03-15 00:23:00.000000', 'temperatura', 621.0000, 'ºC'),
	(107053, 110, '2015-03-15 00:23:01.000000', 'temperatura', 679.0000, 'ºC'),
	(107054, 110, '2015-03-15 00:23:02.000000', 'temperatura', 331.0000, 'ºC'),
	(107055, 110, '2015-03-15 00:23:03.000000', 'temperatura', 820.0000, 'ºC'),
	(107056, 110, '2015-03-15 00:23:04.000000', 'temperatura', 709.0000, 'ºC'),
	(107057, 110, '2015-03-15 00:23:05.000000', 'temperatura', 1083.0000, 'ºC'),
	(107058, 110, '2015-03-15 00:23:06.000000', 'temperatura', 889.0000, 'ºC'),
	(107059, 110, '2015-03-15 00:23:07.000000', 'temperatura', 1196.0000, 'ºC'),
	(107060, 110, '2015-03-15 00:23:08.000000', 'temperatura', 913.0000, 'ºC'),
	(107061, 110, '2015-03-15 00:23:09.000000', 'temperatura', 979.0000, 'ºC'),
	(107062, 110, '2015-03-15 00:23:10.000000', 'temperatura', 954.0000, 'ºC'),
	(107063, 110, '2015-03-15 00:23:11.000000', 'temperatura', 635.0000, 'ºC'),
	(107064, 110, '2015-03-15 00:23:12.000000', 'temperatura', 314.0000, 'ºC'),
	(107065, 110, '2015-03-15 00:23:13.000000', 'temperatura', 866.0000, 'ºC'),
	(107066, 110, '2015-03-15 00:23:14.000000', 'temperatura', 990.0000, 'ºC'),
	(107067, 110, '2015-03-15 00:23:15.000000', 'temperatura', 1150.0000, 'ºC'),
	(107068, 110, '2015-03-15 00:23:16.000000', 'temperatura', 381.0000, 'ºC'),
	(107069, 110, '2015-03-15 00:23:17.000000', 'temperatura', 858.0000, 'ºC'),
	(107070, 110, '2015-03-15 00:23:18.000000', 'temperatura', 744.0000, 'ºC'),
	(107071, 110, '2015-03-15 00:23:19.000000', 'temperatura', 1147.0000, 'ºC'),
	(107072, 110, '2015-03-15 00:23:20.000000', 'temperatura', 1102.0000, 'ºC'),
	(107073, 110, '2015-03-15 00:23:21.000000', 'temperatura', 872.0000, 'ºC'),
	(107074, 110, '2015-03-15 00:23:22.000000', 'temperatura', 1056.0000, 'ºC'),
	(107075, 110, '2015-03-15 00:23:23.000000', 'temperatura', 261.0000, 'ºC'),
	(107076, 110, '2015-03-15 00:23:24.000000', 'temperatura', 541.0000, 'ºC'),
	(107077, 110, '2015-03-15 00:23:25.000000', 'temperatura', 720.0000, 'ºC'),
	(107078, 110, '2015-03-15 00:23:26.000000', 'temperatura', 780.0000, 'ºC'),
	(107079, 110, '2015-03-15 00:23:27.000000', 'temperatura', 540.0000, 'ºC'),
	(107080, 110, '2015-03-15 00:23:28.000000', 'temperatura', 361.0000, 'ºC'),
	(107081, 110, '2015-03-15 00:23:29.000000', 'temperatura', 187.0000, 'ºC'),
	(107082, 110, '2015-03-15 00:23:30.000000', 'temperatura', 1051.0000, 'ºC'),
	(107083, 110, '2015-03-15 00:23:31.000000', 'temperatura', 1093.0000, 'ºC'),
	(107084, 110, '2015-03-15 00:23:32.000000', 'temperatura', 1113.0000, 'ºC'),
	(107085, 110, '2015-03-15 00:23:33.000000', 'temperatura', 1086.0000, 'ºC'),
	(107086, 110, '2015-03-15 00:23:34.000000', 'temperatura', 891.0000, 'ºC'),
	(107087, 110, '2015-03-15 00:23:35.000000', 'temperatura', 1198.0000, 'ºC'),
	(107088, 110, '2015-03-15 00:23:36.000000', 'temperatura', 917.0000, 'ºC'),
	(107089, 110, '2015-03-15 00:23:37.000000', 'temperatura', 994.0000, 'ºC'),
	(107090, 110, '2015-03-15 00:23:38.000000', 'temperatura', 1019.0000, 'ºC'),
	(107091, 110, '2015-03-15 00:23:39.000000', 'temperatura', 911.0000, 'ºC'),
	(107092, 110, '2015-03-15 00:23:40.000000', 'temperatura', 299.0000, 'ºC'),
	(107093, 110, '2015-03-15 00:23:41.000000', 'temperatura', 1164.0000, 'ºC'),
	(107094, 110, '2015-03-15 00:23:42.000000', 'temperatura', 121.0000, 'ºC'),
	(107095, 110, '2015-03-15 00:23:43.000000', 'temperatura', 716.0000, 'ºC'),
	(107096, 110, '2015-03-15 00:23:44.000000', 'temperatura', 816.0000, 'ºC'),
	(107097, 110, '2015-03-15 00:23:45.000000', 'temperatura', 731.0000, 'ºC'),
	(107098, 110, '2015-03-15 00:23:46.000000', 'temperatura', 9.0000, 'ºC'),
	(107099, 110, '2015-03-15 00:23:47.000000', 'temperatura', 254.0000, 'ºC'),
	(107100, 110, '2015-03-15 00:23:48.000000', 'temperatura', 44.0000, 'ºC'),
	(107101, 110, '2015-03-15 00:23:49.000000', 'temperatura', 656.0000, 'ºC'),
	(107102, 110, '2015-03-15 00:23:50.000000', 'temperatura', 751.0000, 'ºC'),
	(107103, 110, '2015-03-15 00:23:51.000000', 'temperatura', 588.0000, 'ºC'),
	(107104, 110, '2015-03-15 00:23:52.000000', 'temperatura', 688.0000, 'ºC'),
	(107105, 110, '2015-03-15 00:23:53.000000', 'temperatura', 475.0000, 'ºC'),
	(107106, 110, '2015-03-15 00:23:54.000000', 'temperatura', 313.0000, 'ºC'),
	(107107, 110, '2015-03-15 00:23:55.000000', 'temperatura', 139.0000, 'ºC'),
	(107108, 110, '2015-03-15 00:23:56.000000', 'temperatura', 955.0000, 'ºC'),
	(107109, 110, '2015-03-15 00:23:57.000000', 'temperatura', 762.0000, 'ºC'),
	(107110, 110, '2015-03-15 00:23:58.000000', 'temperatura', 943.0000, 'ºC'),
	(107111, 110, '2015-03-15 00:23:59.000000', 'temperatura', 32.0000, 'ºC'),
	(107112, 110, '2015-03-15 00:24:00.000000', 'temperatura', 929.0000, 'ºC'),
	(107113, 110, '2015-03-15 00:24:01.000000', 'temperatura', 950.0000, 'ºC'),
	(107114, 110, '2015-03-15 00:24:02.000000', 'temperatura', 764.0000, 'ºC'),
	(107115, 110, '2015-03-15 00:24:03.000000', 'temperatura', 970.0000, 'ºC'),
	(107116, 110, '2015-03-15 00:24:04.000000', 'temperatura', 160.0000, 'ºC'),
	(107117, 110, '2015-03-15 00:24:05.000000', 'temperatura', 290.0000, 'ºC'),
	(107118, 110, '2015-03-15 00:24:06.000000', 'temperatura', 969.0000, 'ºC'),
	(107119, 110, '2015-03-15 00:24:07.000000', 'temperatura', 375.0000, 'ºC'),
	(107120, 110, '2015-03-15 00:24:08.000000', 'temperatura', 172.0000, 'ºC'),
	(107121, 110, '2015-03-15 00:24:09.000000', 'temperatura', 932.0000, 'ºC'),
	(107122, 110, '2015-03-15 00:24:10.000000', 'temperatura', 545.0000, 'ºC'),
	(107123, 110, '2015-03-15 00:24:11.000000', 'temperatura', 1130.0000, 'ºC'),
	(107124, 110, '2015-03-15 00:24:12.000000', 'temperatura', 417.0000, 'ºC'),
	(107125, 110, '2015-03-15 00:24:13.000000', 'temperatura', 1093.0000, 'ºC'),
	(107126, 110, '2015-03-15 00:24:14.000000', 'temperatura', 616.0000, 'ºC'),
	(107127, 110, '2015-03-15 00:24:15.000000', 'temperatura', 1000.0000, 'ºC'),
	(107128, 110, '2015-03-15 00:24:16.000000', 'temperatura', 755.0000, 'ºC'),
	(107129, 110, '2015-03-15 00:24:17.000000', 'temperatura', 772.0000, 'ºC'),
	(107130, 110, '2015-03-15 00:24:18.000000', 'temperatura', 399.0000, 'ºC'),
	(107131, 110, '2015-03-15 00:24:19.000000', 'temperatura', 879.0000, 'ºC'),
	(107132, 110, '2015-03-15 00:24:20.000000', 'temperatura', 799.0000, 'ºC'),
	(107133, 110, '2015-03-15 00:24:21.000000', 'temperatura', 157.0000, 'ºC'),
	(107134, 110, '2015-03-15 00:24:22.000000', 'temperatura', 790.0000, 'ºC'),
	(107135, 110, '2015-03-15 00:24:23.000000', 'temperatura', 1080.0000, 'ºC'),
	(107136, 110, '2015-03-15 00:24:24.000000', 'temperatura', 629.0000, 'ºC'),
	(107137, 110, '2015-03-15 00:24:25.000000', 'temperatura', 1104.0000, 'ºC'),
	(107138, 110, '2015-03-15 00:24:26.000000', 'temperatura', 35.0000, 'ºC'),
	(107139, 110, '2015-03-15 00:24:27.000000', 'temperatura', 464.0000, 'ºC'),
	(107140, 110, '2015-03-15 00:24:28.000000', 'temperatura', 1017.0000, 'ºC'),
	(107141, 110, '2015-03-15 00:24:29.000000', 'temperatura', 92.0000, 'ºC'),
	(107142, 110, '2015-03-15 00:24:30.000000', 'temperatura', 1011.0000, 'ºC'),
	(107143, 110, '2015-03-15 00:24:31.000000', 'temperatura', 1178.0000, 'ºC'),
	(107144, 110, '2015-03-15 00:24:32.000000', 'temperatura', 458.0000, 'ºC'),
	(107145, 110, '2015-03-15 00:24:33.000000', 'temperatura', 1155.0000, 'ºC'),
	(107146, 110, '2015-03-15 00:24:34.000000', 'temperatura', 802.0000, 'ºC'),
	(107147, 110, '2015-03-15 00:24:35.000000', 'temperatura', 547.0000, 'ºC'),
	(107148, 110, '2015-03-15 00:24:36.000000', 'temperatura', 328.0000, 'ºC'),
	(107149, 110, '2015-03-15 00:24:37.000000', 'temperatura', 0.0000, 'ºC'),
	(107150, 110, '2015-03-15 00:24:38.000000', 'temperatura', 215.0000, 'ºC'),
	(107151, 110, '2015-03-15 00:24:39.000000', 'temperatura', 1076.0000, 'ºC'),
	(107152, 110, '2015-03-15 00:24:40.000000', 'temperatura', 1134.0000, 'ºC'),
	(107153, 110, '2015-03-15 00:24:41.000000', 'temperatura', 43.0000, 'ºC'),
	(107154, 110, '2015-03-15 00:24:42.000000', 'temperatura', 414.0000, 'ºC'),
	(107155, 110, '2015-03-15 00:24:43.000000', 'temperatura', 740.0000, 'ºC'),
	(107156, 110, '2015-03-15 00:24:44.000000', 'temperatura', 58.0000, 'ºC'),
	(107157, 110, '2015-03-15 00:24:45.000000', 'temperatura', 471.0000, 'ºC'),
	(107158, 110, '2015-03-15 00:24:46.000000', 'temperatura', 983.0000, 'ºC'),
	(107159, 110, '2015-03-15 00:24:47.000000', 'temperatura', 1101.0000, 'ºC'),
	(107160, 110, '2015-03-15 00:24:48.000000', 'temperatura', 156.0000, 'ºC'),
	(107161, 110, '2015-03-15 00:24:49.000000', 'temperatura', 1076.0000, 'ºC'),
	(107162, 110, '2015-03-15 00:24:50.000000', 'temperatura', 115.0000, 'ºC'),
	(107163, 110, '2015-03-15 00:24:51.000000', 'temperatura', 948.0000, 'ºC'),
	(107164, 110, '2015-03-15 00:24:52.000000', 'temperatura', 796.0000, 'ºC'),
	(107165, 110, '2015-03-15 00:24:53.000000', 'temperatura', 1134.0000, 'ºC'),
	(107166, 110, '2015-03-15 00:24:54.000000', 'temperatura', 884.0000, 'ºC'),
	(107167, 110, '2015-03-15 00:24:55.000000', 'temperatura', 1019.0000, 'ºC'),
	(107168, 110, '2015-03-15 00:24:56.000000', 'temperatura', 41.0000, 'ºC'),
	(107169, 110, '2015-03-15 00:24:57.000000', 'temperatura', 751.0000, 'ºC'),
	(107170, 110, '2015-03-15 00:24:58.000000', 'temperatura', 33.0000, 'ºC'),
	(107171, 110, '2015-03-15 00:24:59.000000', 'temperatura', 313.0000, 'ºC'),
	(107172, 110, '2015-03-15 00:25:00.000000', 'temperatura', 266.0000, 'ºC'),
	(107173, 110, '2015-03-15 00:25:01.000000', 'temperatura', 391.0000, 'ºC'),
	(107174, 110, '2015-03-15 00:25:02.000000', 'temperatura', 1157.0000, 'ºC'),
	(107175, 110, '2015-03-15 00:25:03.000000', 'temperatura', 1014.0000, 'ºC'),
	(107176, 110, '2015-03-15 00:25:04.000000', 'temperatura', 400.0000, 'ºC'),
	(107177, 110, '2015-03-15 00:25:05.000000', 'temperatura', 158.0000, 'ºC'),
	(107178, 110, '2015-03-15 00:25:06.000000', 'temperatura', 792.0000, 'ºC'),
	(107179, 110, '2015-03-15 00:25:07.000000', 'temperatura', 1086.0000, 'ºC'),
	(107180, 110, '2015-03-15 00:25:08.000000', 'temperatura', 655.0000, 'ºC'),
	(107181, 110, '2015-03-15 00:25:09.000000', 'temperatura', 17.0000, 'ºC'),
	(107182, 110, '2015-03-15 00:25:10.000000', 'temperatura', 520.0000, 'ºC'),
	(107183, 110, '2015-03-15 00:25:11.000000', 'temperatura', 151.0000, 'ºC'),
	(107184, 110, '2015-03-15 00:25:12.000000', 'temperatura', 395.0000, 'ºC'),
	(107185, 110, '2015-03-15 00:25:13.000000', 'temperatura', 322.0000, 'ºC'),
	(107186, 110, '2015-03-15 00:25:14.000000', 'temperatura', 426.0000, 'ºC'),
	(107187, 110, '2015-03-15 00:25:15.000000', 'temperatura', 1165.0000, 'ºC'),
	(107188, 110, '2015-03-15 00:25:16.000000', 'temperatura', 948.0000, 'ºC'),
	(107189, 110, '2015-03-15 00:25:17.000000', 'temperatura', 43.0000, 'ºC'),
	(107190, 110, '2015-03-15 00:25:18.000000', 'temperatura', 973.0000, 'ºC'),
	(107191, 110, '2015-03-15 00:25:19.000000', 'temperatura', 1136.0000, 'ºC'),
	(107192, 110, '2015-03-15 00:25:20.000000', 'temperatura', 360.0000, 'ºC'),
	(107193, 110, '2015-03-15 00:25:21.000000', 'temperatura', 793.0000, 'ºC'),
	(107194, 110, '2015-03-15 00:25:22.000000', 'temperatura', 486.0000, 'ºC'),
	(107195, 110, '2015-03-15 00:25:23.000000', 'temperatura', 52.0000, 'ºC'),
	(107196, 110, '2015-03-15 00:25:24.000000', 'temperatura', 1.0000, 'ºC'),
	(107197, 110, '2015-03-15 00:25:25.000000', 'temperatura', 1049.0000, 'ºC'),
	(107198, 110, '2015-03-15 00:25:26.000000', 'temperatura', 443.0000, 'ºC'),
	(107199, 110, '2015-03-15 00:25:27.000000', 'temperatura', 270.0000, 'ºC'),
	(107200, 110, '2015-03-15 00:25:28.000000', 'temperatura', 20.0000, 'ºC'),
	(107201, 110, '2015-03-15 00:25:29.000000', 'temperatura', 492.0000, 'ºC'),
	(107202, 110, '2015-03-15 00:25:30.000000', 'temperatura', 0.0000, 'ºC'),
	(107203, 110, '2015-03-15 00:25:31.000000', 'temperatura', 924.0000, 'ºC'),
	(107204, 110, '2015-03-15 00:25:32.000000', 'temperatura', 1020.0000, 'ºC'),
	(107205, 110, '2015-03-15 00:25:33.000000', 'temperatura', 1131.0000, 'ºC'),
	(107206, 110, '2015-03-15 00:25:34.000000', 'temperatura', 193.0000, 'ºC'),
	(107207, 110, '2015-03-15 00:25:35.000000', 'temperatura', 1175.0000, 'ºC'),
	(107208, 110, '2015-03-15 00:25:36.000000', 'temperatura', 496.0000, 'ºC'),
	(107209, 110, '2015-03-15 00:25:37.000000', 'temperatura', 157.0000, 'ºC'),
	(107210, 110, '2015-03-15 00:25:38.000000', 'temperatura', 497.0000, 'ºC'),
	(107211, 110, '2015-03-15 00:25:39.000000', 'temperatura', 812.0000, 'ºC'),
	(107212, 110, '2015-03-15 00:25:40.000000', 'temperatura', 171.0000, 'ºC'),
	(107213, 110, '2015-03-15 00:25:41.000000', 'temperatura', 819.0000, 'ºC'),
	(107214, 110, '2015-03-15 00:25:42.000000', 'temperatura', 1184.0000, 'ºC'),
	(107215, 110, '2015-03-15 00:25:43.000000', 'temperatura', 1061.0000, 'ºC'),
	(107216, 110, '2015-03-15 00:25:44.000000', 'temperatura', 556.0000, 'ºC'),
	(107217, 110, '2015-03-15 00:25:45.000000', 'temperatura', 798.0000, 'ºC'),
	(107218, 110, '2015-03-15 00:25:46.000000', 'temperatura', 1120.0000, 'ºC'),
	(107219, 110, '2015-03-15 00:25:47.000000', 'temperatura', 808.0000, 'ºC'),
	(107220, 110, '2015-03-15 00:25:48.000000', 'temperatura', 682.0000, 'ºC'),
	(107221, 110, '2015-03-15 00:25:49.000000', 'temperatura', 985.0000, 'ºC'),
	(107222, 110, '2015-03-15 00:25:50.000000', 'temperatura', 478.0000, 'ºC'),
	(107223, 110, '2015-03-15 00:25:51.000000', 'temperatura', 637.0000, 'ºC'),
	(107224, 110, '2015-03-15 00:25:52.000000', 'temperatura', 552.0000, 'ºC'),
	(107225, 110, '2015-03-15 00:25:53.000000', 'temperatura', 850.0000, 'ºC'),
	(107226, 110, '2015-03-15 00:25:54.000000', 'temperatura', 194.0000, 'ºC'),
	(107227, 110, '2015-03-15 00:25:55.000000', 'temperatura', 821.0000, 'ºC'),
	(107228, 110, '2015-03-15 00:25:56.000000', 'temperatura', 1122.0000, 'ºC'),
	(107229, 110, '2015-03-15 00:25:57.000000', 'temperatura', 749.0000, 'ºC'),
	(107230, 110, '2015-03-15 00:25:58.000000', 'temperatura', 379.0000, 'ºC'),
	(107231, 110, '2015-03-15 00:25:59.000000', 'temperatura', 850.0000, 'ºC'),
	(107232, 110, '2015-03-15 00:26:00.000000', 'temperatura', 710.0000, 'ºC'),
	(107233, 110, '2015-03-15 00:26:01.000000', 'temperatura', 1004.0000, 'ºC'),
	(107234, 110, '2015-03-15 00:26:02.000000', 'temperatura', 488.0000, 'ºC'),
	(107235, 110, '2015-03-15 00:26:03.000000', 'temperatura', 628.0000, 'ºC'),
	(107236, 110, '2015-03-15 00:26:04.000000', 'temperatura', 476.0000, 'ºC'),
	(107237, 110, '2015-03-15 00:26:05.000000', 'temperatura', 497.0000, 'ºC'),
	(107238, 110, '2015-03-15 00:26:06.000000', 'temperatura', 1058.0000, 'ºC'),
	(107239, 110, '2015-03-15 00:26:07.000000', 'temperatura', 199.0000, 'ºC'),
	(107240, 110, '2015-03-15 00:26:08.000000', 'temperatura', 220.0000, 'ºC'),
	(107241, 110, '2015-03-15 00:26:09.000000', 'temperatura', 503.0000, 'ºC'),
	(107242, 110, '2015-03-15 00:26:10.000000', 'temperatura', 659.0000, 'ºC'),
	(107243, 110, '2015-03-15 00:26:11.000000', 'temperatura', 583.0000, 'ºC'),
	(107244, 110, '2015-03-15 00:26:12.000000', 'temperatura', 941.0000, 'ºC'),
	(107245, 110, '2015-03-15 00:26:13.000000', 'temperatura', 556.0000, 'ºC'),
	(107246, 110, '2015-03-15 00:26:14.000000', 'temperatura', 1159.0000, 'ºC'),
	(107247, 110, '2015-03-15 00:26:15.000000', 'temperatura', 524.0000, 'ºC'),
	(107248, 110, '2015-03-15 00:26:16.000000', 'temperatura', 346.0000, 'ºC'),
	(107249, 110, '2015-03-15 00:26:17.000000', 'temperatura', 158.0000, 'ºC'),
	(107250, 110, '2015-03-15 00:26:18.000000', 'temperatura', 950.0000, 'ºC'),
	(107251, 110, '2015-03-15 00:26:19.000000', 'temperatura', 680.0000, 'ºC'),
	(107252, 110, '2015-03-15 00:26:20.000000', 'temperatura', 550.0000, 'ºC'),
	(107253, 110, '2015-03-15 00:26:21.000000', 'temperatura', 709.0000, 'ºC'),
	(107254, 110, '2015-03-15 00:26:22.000000', 'temperatura', 695.0000, 'ºC'),
	(107255, 110, '2015-03-15 00:26:23.000000', 'temperatura', 148.0000, 'ºC'),
	(107256, 110, '2015-03-15 00:26:24.000000', 'temperatura', 1055.0000, 'ºC'),
	(107257, 110, '2015-03-15 00:26:25.000000', 'temperatura', 34.0000, 'ºC'),
	(107258, 110, '2015-03-15 00:26:26.000000', 'temperatura', 605.0000, 'ºC'),
	(107259, 110, '2015-03-15 00:26:27.000000', 'temperatura', 524.0000, 'ºC'),
	(107260, 110, '2015-03-15 00:26:28.000000', 'temperatura', 803.0000, 'ºC'),
	(107261, 110, '2015-03-15 00:26:29.000000', 'temperatura', 45.0000, 'ºC'),
	(107262, 110, '2015-03-15 00:26:30.000000', 'temperatura', 215.0000, 'ºC'),
	(107263, 110, '2015-03-15 00:26:31.000000', 'temperatura', 943.0000, 'ºC'),
	(107264, 110, '2015-03-15 00:26:32.000000', 'temperatura', 470.0000, 'ºC'),
	(107265, 110, '2015-03-15 00:26:33.000000', 'temperatura', 722.0000, 'ºC'),
	(107266, 110, '2015-03-15 00:26:34.000000', 'temperatura', 998.0000, 'ºC'),
	(107267, 110, '2015-03-15 00:26:35.000000', 'temperatura', 425.0000, 'ºC'),
	(107268, 110, '2015-03-15 00:26:36.000000', 'temperatura', 332.0000, 'ºC'),
	(107269, 110, '2015-03-15 00:26:37.000000', 'temperatura', 385.0000, 'ºC'),
	(107270, 110, '2015-03-15 00:26:38.000000', 'temperatura', 929.0000, 'ºC'),
	(107271, 110, '2015-03-15 00:26:39.000000', 'temperatura', 1090.0000, 'ºC'),
	(107272, 110, '2015-03-15 00:26:40.000000', 'temperatura', 263.0000, 'ºC'),
	(107273, 110, '2015-03-15 00:26:41.000000', 'temperatura', 444.0000, 'ºC'),
	(107274, 110, '2015-03-15 00:26:42.000000', 'temperatura', 235.0000, 'ºC'),
	(107275, 110, '2015-03-15 00:26:43.000000', 'temperatura', 1043.0000, 'ºC'),
	(107276, 110, '2015-03-15 00:26:44.000000', 'temperatura', 911.0000, 'ºC'),
	(107277, 110, '2015-03-15 00:26:45.000000', 'temperatura', 225.0000, 'ºC'),
	(107278, 110, '2015-03-15 00:26:46.000000', 'temperatura', 793.0000, 'ºC'),
	(107279, 110, '2015-03-15 00:26:47.000000', 'temperatura', 892.0000, 'ºC'),
	(107280, 110, '2015-03-15 00:26:48.000000', 'temperatura', 879.0000, 'ºC'),
	(107281, 110, '2015-03-15 00:26:49.000000', 'temperatura', 521.0000, 'ºC'),
	(107282, 110, '2015-03-15 00:26:50.000000', 'temperatura', 1169.0000, 'ºC'),
	(107283, 110, '2015-03-15 00:26:51.000000', 'temperatura', 682.0000, 'ºC'),
	(107284, 110, '2015-03-15 00:26:52.000000', 'temperatura', 1105.0000, 'ºC'),
	(107285, 110, '2015-03-15 00:26:53.000000', 'temperatura', 1076.0000, 'ºC'),
	(107286, 110, '2015-03-15 00:26:54.000000', 'temperatura', 869.0000, 'ºC'),
	(107287, 110, '2015-03-15 00:26:55.000000', 'temperatura', 1116.0000, 'ºC'),
	(107288, 110, '2015-03-15 00:26:56.000000', 'temperatura', 572.0000, 'ºC'),
	(107289, 110, '2015-03-15 00:26:57.000000', 'temperatura', 713.0000, 'ºC'),
	(107290, 110, '2015-03-15 00:26:58.000000', 'temperatura', 650.0000, 'ºC'),
	(107291, 110, '2015-03-15 00:26:59.000000', 'temperatura', 1113.0000, 'ºC'),
	(107292, 110, '2015-03-15 00:27:00.000000', 'temperatura', 15.0000, 'ºC'),
	(107293, 110, '2015-03-15 00:27:01.000000', 'temperatura', 335.0000, 'ºC'),
	(107294, 110, '2015-03-15 00:27:02.000000', 'temperatura', 433.0000, 'ºC'),
	(107295, 110, '2015-03-15 00:27:03.000000', 'temperatura', 1160.0000, 'ºC'),
	(107296, 110, '2015-03-15 00:27:04.000000', 'temperatura', 900.0000, 'ºC'),
	(107297, 110, '2015-03-15 00:27:05.000000', 'temperatura', 1023.0000, 'ºC'),
	(107298, 110, '2015-03-15 00:27:06.000000', 'temperatura', 13.0000, 'ºC'),
	(107299, 110, '2015-03-15 00:27:07.000000', 'temperatura', 598.0000, 'ºC'),
	(107300, 110, '2015-03-15 00:27:08.000000', 'temperatura', 549.0000, 'ºC'),
	(107301, 110, '2015-03-15 00:27:09.000000', 'temperatura', 955.0000, 'ºC'),
	(107302, 110, '2015-03-15 00:27:10.000000', 'temperatura', 727.0000, 'ºC'),
	(107303, 110, '2015-03-15 00:27:11.000000', 'temperatura', 769.0000, 'ºC'),
	(107304, 110, '2015-03-15 00:27:12.000000', 'temperatura', 467.0000, 'ºC'),
	(107305, 110, '2015-03-15 00:27:13.000000', 'temperatura', 29.0000, 'ºC'),
	(107306, 110, '2015-03-15 00:27:14.000000', 'temperatura', 1142.0000, 'ºC'),
	(107307, 110, '2015-03-15 00:27:15.000000', 'temperatura', 824.0000, 'ºC'),
	(107308, 110, '2015-03-15 00:27:16.000000', 'temperatura', 695.0000, 'ºC'),
	(107309, 110, '2015-03-15 00:27:17.000000', 'temperatura', 1004.0000, 'ºC'),
	(107310, 110, '2015-03-15 00:27:18.000000', 'temperatura', 535.0000, 'ºC'),
	(107311, 110, '2015-03-15 00:27:19.000000', 'temperatura', 862.0000, 'ºC'),
	(107312, 110, '2015-03-15 00:27:20.000000', 'temperatura', 305.0000, 'ºC'),
	(107313, 110, '2015-03-15 00:27:21.000000', 'temperatura', 139.0000, 'ºC'),
	(107314, 110, '2015-03-15 00:27:22.000000', 'temperatura', 983.0000, 'ºC'),
	(107315, 110, '2015-03-15 00:27:23.000000', 'temperatura', 898.0000, 'ºC'),
	(107316, 110, '2015-03-15 00:27:24.000000', 'temperatura', 339.0000, 'ºC'),
	(107317, 110, '2015-03-15 00:27:25.000000', 'temperatura', 204.0000, 'ºC'),
	(107318, 110, '2015-03-15 00:27:26.000000', 'temperatura', 4.0000, 'ºC'),
	(107319, 110, '2015-03-15 00:27:27.000000', 'temperatura', 606.0000, 'ºC'),
	(107320, 110, '2015-03-15 00:27:28.000000', 'temperatura', 620.0000, 'ºC'),
	(107321, 110, '2015-03-15 00:27:29.000000', 'temperatura', 82.0000, 'ºC'),
	(107322, 110, '2015-03-15 00:27:30.000000', 'temperatura', 951.0000, 'ºC'),
	(107323, 110, '2015-03-15 00:27:31.000000', 'temperatura', 908.0000, 'ºC'),
	(107324, 110, '2015-03-15 00:27:32.000000', 'temperatura', 490.0000, 'ºC'),
	(107325, 110, '2015-03-15 00:27:33.000000', 'temperatura', 926.0000, 'ºC'),
	(107326, 110, '2015-03-15 00:27:34.000000', 'temperatura', 759.0000, 'ºC'),
	(107327, 110, '2015-03-15 00:27:35.000000', 'temperatura', 1018.0000, 'ºC'),
	(107328, 110, '2015-03-15 00:27:36.000000', 'temperatura', 412.0000, 'ºC'),
	(107329, 110, '2015-03-15 00:27:37.000000', 'temperatura', 209.0000, 'ºC'),
	(107330, 110, '2015-03-15 00:27:38.000000', 'temperatura', 1010.0000, 'ºC'),
	(107331, 110, '2015-03-15 00:27:39.000000', 'temperatura', 824.0000, 'ºC'),
	(107332, 110, '2015-03-15 00:27:40.000000', 'temperatura', 1091.0000, 'ºC'),
	(107333, 110, '2015-03-15 00:27:41.000000', 'temperatura', 584.0000, 'ºC'),
	(107334, 110, '2015-03-15 00:27:42.000000', 'temperatura', 845.0000, 'ºC'),
	(107335, 110, '2015-03-15 00:27:43.000000', 'temperatura', 75.0000, 'ºC'),
	(107336, 110, '2015-03-15 00:27:44.000000', 'temperatura', 240.0000, 'ºC'),
	(107337, 110, '2015-03-15 00:27:45.000000', 'temperatura', 974.0000, 'ºC'),
	(107338, 110, '2015-03-15 00:27:46.000000', 'temperatura', 553.0000, 'ºC'),
	(107339, 110, '2015-03-15 00:27:47.000000', 'temperatura', 1041.0000, 'ºC'),
	(107340, 110, '2015-03-15 00:27:48.000000', 'temperatura', 1150.0000, 'ºC'),
	(107341, 110, '2015-03-15 00:27:49.000000', 'temperatura', 224.0000, 'ºC'),
	(107342, 110, '2015-03-15 00:27:50.000000', 'temperatura', 71.0000, 'ºC'),
	(107343, 110, '2015-03-15 00:27:51.000000', 'temperatura', 886.0000, 'ºC'),
	(107344, 110, '2015-03-15 00:27:52.000000', 'temperatura', 617.0000, 'ºC'),
	(107345, 110, '2015-03-15 00:27:53.000000', 'temperatura', 426.0000, 'ºC'),
	(107346, 110, '2015-03-15 00:27:54.000000', 'temperatura', 282.0000, 'ºC'),
	(107347, 110, '2015-03-15 00:27:55.000000', 'temperatura', 131.0000, 'ºC'),
	(107348, 110, '2015-03-15 00:27:56.000000', 'temperatura', 1009.0000, 'ºC'),
	(107349, 110, '2015-03-15 00:27:57.000000', 'temperatura', 1052.0000, 'ºC'),
	(107350, 110, '2015-03-15 00:27:58.000000', 'temperatura', 1033.0000, 'ºC'),
	(107351, 110, '2015-03-15 00:27:59.000000', 'temperatura', 811.0000, 'ºC'),
	(107352, 110, '2015-03-15 00:28:00.000000', 'temperatura', 957.0000, 'ºC'),
	(107353, 110, '2015-03-15 00:28:01.000000', 'temperatura', 1153.0000, 'ºC'),
	(107354, 110, '2015-03-15 00:28:02.000000', 'temperatura', 495.0000, 'ºC'),
	(107355, 110, '2015-03-15 00:28:03.000000', 'temperatura', 215.0000, 'ºC'),
	(107356, 110, '2015-03-15 00:28:04.000000', 'temperatura', 792.0000, 'ºC'),
	(107357, 110, '2015-03-15 00:28:05.000000', 'temperatura', 914.0000, 'ºC'),
	(107358, 110, '2015-03-15 00:28:06.000000', 'temperatura', 996.0000, 'ºC'),
	(107359, 110, '2015-03-15 00:28:07.000000', 'temperatura', 1037.0000, 'ºC'),
	(107360, 110, '2015-03-15 00:28:08.000000', 'temperatura', 999.0000, 'ºC'),
	(107361, 110, '2015-03-15 00:28:09.000000', 'temperatura', 683.0000, 'ºC'),
	(107362, 110, '2015-03-15 00:28:10.000000', 'temperatura', 419.0000, 'ºC'),
	(107363, 110, '2015-03-15 00:28:11.000000', 'temperatura', 48.0000, 'ºC'),
	(107364, 110, '2015-03-15 00:28:12.000000', 'temperatura', 184.0000, 'ºC'),
	(107365, 110, '2015-03-15 00:28:13.000000', 'temperatura', 775.0000, 'ºC'),
	(107366, 110, '2015-03-15 00:28:14.000000', 'temperatura', 922.0000, 'ºC'),
	(107367, 110, '2015-03-15 00:28:15.000000', 'temperatura', 1088.0000, 'ºC'),
	(107368, 110, '2015-03-15 00:28:16.000000', 'temperatura', 274.0000, 'ºC'),
	(107369, 110, '2015-03-15 00:28:17.000000', 'temperatura', 507.0000, 'ºC'),
	(107370, 110, '2015-03-15 00:28:18.000000', 'temperatura', 514.0000, 'ºC'),
	(107371, 110, '2015-03-15 00:28:19.000000', 'temperatura', 1050.0000, 'ºC'),
	(107372, 110, '2015-03-15 00:28:20.000000', 'temperatura', 106.0000, 'ºC'),
	(107373, 110, '2015-03-15 00:28:21.000000', 'temperatura', 981.0000, 'ºC'),
	(107374, 110, '2015-03-15 00:28:22.000000', 'temperatura', 987.0000, 'ºC'),
	(107375, 110, '2015-03-15 00:28:23.000000', 'temperatura', 793.0000, 'ºC'),
	(107376, 110, '2015-03-15 00:28:24.000000', 'temperatura', 1003.0000, 'ºC'),
	(107377, 110, '2015-03-15 00:28:25.000000', 'temperatura', 236.0000, 'ºC'),
	(107378, 110, '2015-03-15 00:28:26.000000', 'temperatura', 574.0000, 'ºC'),
	(107379, 110, '2015-03-15 00:28:27.000000', 'temperatura', 963.0000, 'ºC'),
	(107380, 110, '2015-03-15 00:28:28.000000', 'temperatura', 695.0000, 'ºC'),
	(107381, 110, '2015-03-15 00:28:29.000000', 'temperatura', 583.0000, 'ºC'),
	(107382, 110, '2015-03-15 00:28:30.000000', 'temperatura', 832.0000, 'ºC'),
	(107383, 110, '2015-03-15 00:28:31.000000', 'temperatura', 10.0000, 'ºC'),
	(107384, 110, '2015-03-15 00:28:32.000000', 'temperatura', 1154.0000, 'ºC'),
	(107385, 110, '2015-03-15 00:28:33.000000', 'temperatura', 942.0000, 'ºC'),
	(107386, 110, '2015-03-15 00:28:34.000000', 'temperatura', 47.0000, 'ºC'),
	(107387, 110, '2015-03-15 00:28:35.000000', 'temperatura', 1010.0000, 'ºC'),
	(107388, 110, '2015-03-15 00:28:36.000000', 'temperatura', 111.0000, 'ºC'),
	(107389, 110, '2015-03-15 00:28:37.000000', 'temperatura', 1123.0000, 'ºC'),
	(107390, 110, '2015-03-15 00:28:38.000000', 'temperatura', 486.0000, 'ºC'),
	(107391, 110, '2015-03-15 00:28:39.000000', 'temperatura', 259.0000, 'ºC'),
	(107392, 110, '2015-03-15 00:28:40.000000', 'temperatura', 1037.0000, 'ºC'),
	(107393, 110, '2015-03-15 00:28:41.000000', 'temperatura', 811.0000, 'ºC'),
	(107394, 110, '2015-03-15 00:28:42.000000', 'temperatura', 941.0000, 'ºC'),
	(107395, 110, '2015-03-15 00:28:43.000000', 'temperatura', 1076.0000, 'ºC'),
	(107396, 110, '2015-03-15 00:28:44.000000', 'temperatura', 155.0000, 'ºC'),
	(107397, 110, '2015-03-15 00:28:45.000000', 'temperatura', 1148.0000, 'ºC'),
	(107398, 110, '2015-03-15 00:28:46.000000', 'temperatura', 474.0000, 'ºC'),
	(107399, 110, '2015-03-15 00:28:47.000000', 'temperatura', 129.0000, 'ºC'),
	(107400, 110, '2015-03-15 00:28:48.000000', 'temperatura', 423.0000, 'ºC'),
	(107401, 110, '2015-03-15 00:28:49.000000', 'temperatura', 530.0000, 'ºC'),
	(107402, 110, '2015-03-15 00:28:50.000000', 'temperatura', 178.0000, 'ºC'),
	(107403, 110, '2015-03-15 00:28:51.000000', 'temperatura', 503.0000, 'ºC'),
	(107404, 110, '2015-03-15 00:28:52.000000', 'temperatura', 780.0000, 'ºC'),
	(107405, 110, '2015-03-15 00:28:53.000000', 'temperatura', 1191.0000, 'ºC'),
	(107406, 110, '2015-03-15 00:28:54.000000', 'temperatura', 18.0000, 'ºC'),
	(107407, 110, '2015-03-15 00:28:55.000000', 'temperatura', 115.0000, 'ºC'),
	(107408, 110, '2015-03-15 00:28:56.000000', 'temperatura', 523.0000, 'ºC'),
	(107409, 110, '2015-03-15 00:28:57.000000', 'temperatura', 1070.0000, 'ºC'),
	(107410, 110, '2015-03-15 00:28:58.000000', 'temperatura', 182.0000, 'ºC'),
	(107411, 110, '2015-03-15 00:28:59.000000', 'temperatura', 100.0000, 'ºC'),
	(107412, 110, '2015-03-15 00:29:00.000000', 'temperatura', 1154.0000, 'ºC'),
	(107413, 110, '2015-03-15 00:29:01.000000', 'temperatura', 672.0000, 'ºC'),
	(107414, 110, '2015-03-15 00:29:02.000000', 'temperatura', 1097.0000, 'ºC'),
	(107415, 110, '2015-03-15 00:29:03.000000', 'temperatura', 1069.0000, 'ºC'),
	(107416, 110, '2015-03-15 00:29:04.000000', 'temperatura', 857.0000, 'ºC'),
	(107417, 110, '2015-03-15 00:29:05.000000', 'temperatura', 1076.0000, 'ºC'),
	(107418, 110, '2015-03-15 00:29:06.000000', 'temperatura', 409.0000, 'ºC'),
	(107419, 110, '2015-03-15 00:29:07.000000', 'temperatura', 18.0000, 'ºC'),
	(107420, 110, '2015-03-15 00:29:08.000000', 'temperatura', 64.0000, 'ºC'),
	(107421, 110, '2015-03-15 00:29:09.000000', 'temperatura', 267.0000, 'ºC'),
	(107422, 110, '2015-03-15 00:29:10.000000', 'temperatura', 1145.0000, 'ºC'),
	(107423, 110, '2015-03-15 00:29:11.000000', 'temperatura', 122.0000, 'ºC'),
	(107424, 110, '2015-03-15 00:29:12.000000', 'temperatura', 778.0000, 'ºC'),
	(107425, 110, '2015-03-15 00:29:13.000000', 'temperatura', 1123.0000, 'ºC'),
	(107426, 110, '2015-03-15 00:29:14.000000', 'temperatura', 880.0000, 'ºC'),
	(107427, 110, '2015-03-15 00:29:15.000000', 'temperatura', 1034.0000, 'ºC'),
	(107428, 110, '2015-03-15 00:29:16.000000', 'temperatura', 130.0000, 'ºC'),
	(107429, 110, '2015-03-15 00:29:17.000000', 'temperatura', 1150.0000, 'ºC'),
	(107430, 110, '2015-03-15 00:29:18.000000', 'temperatura', 560.0000, 'ºC'),
	(107431, 110, '2015-03-15 00:29:19.000000', 'temperatura', 550.0000, 'ºC'),
	(107432, 110, '2015-03-15 00:29:20.000000', 'temperatura', 1070.0000, 'ºC'),
	(107433, 110, '2015-03-15 00:29:21.000000', 'temperatura', 100.0000, 'ºC'),
	(107434, 110, '2015-03-15 00:29:22.000000', 'temperatura', 891.0000, 'ºC'),
	(107435, 110, '2015-03-15 00:29:23.000000', 'temperatura', 556.0000, 'ºC'),
	(107436, 110, '2015-03-15 00:29:24.000000', 'temperatura', 106.0000, 'ºC'),
	(107437, 110, '2015-03-15 00:29:25.000000', 'temperatura', 61.0000, 'ºC'),
	(107438, 110, '2015-03-15 00:29:26.000000', 'temperatura', 1190.0000, 'ºC'),
	(107439, 110, '2015-03-15 00:29:27.000000', 'temperatura', 969.0000, 'ºC'),
	(107440, 110, '2015-03-15 00:29:28.000000', 'temperatura', 72.0000, 'ºC'),
	(107441, 110, '2015-03-15 00:29:29.000000', 'temperatura', 1057.0000, 'ºC'),
	(107442, 110, '2015-03-15 00:29:30.000000', 'temperatura', 267.0000, 'ºC'),
	(107443, 110, '2015-03-15 00:29:31.000000', 'temperatura', 563.0000, 'ºC'),
	(107444, 110, '2015-03-15 00:29:32.000000', 'temperatura', 818.0000, 'ºC'),
	(107445, 110, '2015-03-15 00:29:33.000000', 'temperatura', 1199.0000, 'ºC'),
	(107446, 110, '2015-03-15 00:29:34.000000', 'temperatura', 1142.0000, 'ºC'),
	(107447, 110, '2015-03-15 00:29:35.000000', 'temperatura', 914.0000, 'ºC'),
	(107448, 110, '2015-03-15 00:29:36.000000', 'temperatura', 1144.0000, 'ºC'),
	(107449, 110, '2015-03-15 00:29:37.000000', 'temperatura', 579.0000, 'ºC'),
	(107450, 110, '2015-03-15 00:29:38.000000', 'temperatura', 664.0000, 'ºC'),
	(107451, 110, '2015-03-15 00:29:39.000000', 'temperatura', 381.0000, 'ºC'),
	(107452, 110, '2015-03-15 00:29:40.000000', 'temperatura', 1115.0000, 'ºC'),
	(107453, 110, '2015-03-15 00:29:41.000000', 'temperatura', 831.0000, 'ºC'),
	(107454, 110, '2015-03-15 00:29:42.000000', 'temperatura', 811.0000, 'ºC'),
	(107455, 110, '2015-03-15 00:29:43.000000', 'temperatura', 362.0000, 'ºC'),
	(107456, 110, '2015-03-15 00:29:44.000000', 'temperatura', 579.0000, 'ºC'),
	(107457, 110, '2015-03-15 00:29:45.000000', 'temperatura', 610.0000, 'ºC'),
	(107458, 110, '2015-03-15 00:29:46.000000', 'temperatura', 112.0000, 'ºC'),
	(107459, 110, '2015-03-15 00:29:47.000000', 'temperatura', 1132.0000, 'ºC'),
	(107460, 110, '2015-03-15 00:29:48.000000', 'temperatura', 524.0000, 'ºC'),
	(107461, 110, '2015-03-15 00:29:49.000000', 'temperatura', 424.0000, 'ºC'),
	(107462, 110, '2015-03-15 00:29:50.000000', 'temperatura', 549.0000, 'ºC'),
	(107463, 110, '2015-03-15 00:29:51.000000', 'temperatura', 274.0000, 'ºC'),
	(107464, 110, '2015-03-15 00:29:52.000000', 'temperatura', 922.0000, 'ºC'),
	(107465, 110, '2015-03-15 00:29:53.000000', 'temperatura', 189.0000, 'ºC'),
	(107466, 110, '2015-03-15 00:29:54.000000', 'temperatura', 580.0000, 'ºC'),
	(107467, 110, '2015-03-15 00:29:55.000000', 'temperatura', 1132.0000, 'ºC'),
	(107468, 110, '2015-03-15 00:29:56.000000', 'temperatura', 323.0000, 'ºC'),
	(107469, 110, '2015-03-15 00:29:57.000000', 'temperatura', 620.0000, 'ºC'),
	(107470, 110, '2015-03-15 00:29:58.000000', 'temperatura', 932.0000, 'ºC'),
	(107471, 110, '2015-03-15 00:29:59.000000', 'temperatura', 400.0000, 'ºC'),
	(107472, 110, '2015-03-15 00:30:00.000000', 'temperatura', 403.0000, 'ºC'),
	(107473, 110, '2015-03-15 00:30:01.000000', 'temperatura', 817.0000, 'ºC'),
	(107474, 110, '2015-03-15 00:30:02.000000', 'temperatura', 476.0000, 'ºC'),
	(107475, 110, '2015-03-15 00:30:03.000000', 'temperatura', 1131.0000, 'ºC'),
	(107476, 110, '2015-03-15 00:30:04.000000', 'temperatura', 627.0000, 'ºC'),
	(107477, 110, '2015-03-15 00:30:05.000000', 'temperatura', 944.0000, 'ºC'),
	(107478, 110, '2015-03-15 00:30:06.000000', 'temperatura', 437.0000, 'ºC'),
	(107479, 110, '2015-03-15 00:30:07.000000', 'temperatura', 553.0000, 'ºC'),
	(107480, 110, '2015-03-15 00:30:08.000000', 'temperatura', 256.0000, 'ºC'),
	(107481, 110, '2015-03-15 00:30:09.000000', 'temperatura', 823.0000, 'ºC'),
	(107482, 110, '2015-03-15 00:30:10.000000', 'temperatura', 947.0000, 'ºC'),
	(107483, 110, '2015-03-15 00:30:11.000000', 'temperatura', 1064.0000, 'ºC'),
	(107484, 110, '2015-03-15 00:30:12.000000', 'temperatura', 82.0000, 'ºC'),
	(107485, 110, '2015-03-15 00:30:13.000000', 'temperatura', 819.0000, 'ºC'),
	(107486, 110, '2015-03-15 00:30:14.000000', 'temperatura', 248.0000, 'ºC'),
	(107487, 110, '2015-03-15 00:30:15.000000', 'temperatura', 1184.0000, 'ºC'),
	(107488, 110, '2015-03-15 00:30:16.000000', 'temperatura', 378.0000, 'ºC'),
	(107489, 110, '2015-03-15 00:30:17.000000', 'temperatura', 736.0000, 'ºC'),
	(107490, 110, '2015-03-15 00:30:18.000000', 'temperatura', 149.0000, 'ºC'),
	(107491, 110, '2015-03-15 00:30:19.000000', 'temperatura', 936.0000, 'ºC'),
	(107492, 110, '2015-03-15 00:30:20.000000', 'temperatura', 632.0000, 'ºC'),
	(107493, 110, '2015-03-15 00:30:21.000000', 'temperatura', 353.0000, 'ºC'),
	(107494, 110, '2015-03-15 00:30:22.000000', 'temperatura', 1069.0000, 'ºC'),
	(107495, 110, '2015-03-15 00:30:23.000000', 'temperatura', 689.0000, 'ºC'),
	(107496, 110, '2015-03-15 00:30:24.000000', 'temperatura', 237.0000, 'ºC'),
	(107497, 110, '2015-03-15 00:30:25.000000', 'temperatura', 319.0000, 'ºC'),
	(107498, 110, '2015-03-15 00:30:26.000000', 'temperatura', 884.0000, 'ºC'),
	(107499, 110, '2015-03-15 00:30:27.000000', 'temperatura', 1065.0000, 'ºC'),
	(107500, 110, '2015-03-15 00:30:28.000000', 'temperatura', 272.0000, 'ºC'),
	(107501, 110, '2015-03-15 00:30:29.000000', 'temperatura', 567.0000, 'ºC'),
	(107502, 110, '2015-03-15 00:30:30.000000', 'temperatura', 820.0000, 'ºC'),
	(107503, 110, '2015-03-15 00:30:31.000000', 'temperatura', 0.0000, 'ºC'),
	(107504, 110, '2015-03-15 00:30:32.000000', 'temperatura', 1140.0000, 'ºC'),
	(107505, 110, '2015-03-15 00:30:33.000000', 'temperatura', 900.0000, 'ºC'),
	(107506, 110, '2015-03-15 00:30:34.000000', 'temperatura', 1081.0000, 'ºC'),
	(107507, 110, '2015-03-15 00:30:35.000000', 'temperatura', 304.0000, 'ºC'),
	(107508, 110, '2015-03-15 00:30:36.000000', 'temperatura', 680.0000, 'ºC'),
	(107509, 110, '2015-03-15 00:30:37.000000', 'temperatura', 86.0000, 'ºC'),
	(107510, 110, '2015-03-15 00:30:38.000000', 'temperatura', 792.0000, 'ºC'),
	(107511, 110, '2015-03-15 00:30:39.000000', 'temperatura', 102.0000, 'ºC'),
	(107512, 110, '2015-03-15 00:30:40.000000', 'temperatura', 534.0000, 'ºC'),
	(107513, 110, '2015-03-15 00:30:41.000000', 'temperatura', 1164.0000, 'ºC'),
	(107514, 110, '2015-03-15 00:30:42.000000', 'temperatura', 621.0000, 'ºC'),
	(107515, 110, '2015-03-15 00:30:43.000000', 'temperatura', 812.0000, 'ºC'),
	(107516, 110, '2015-03-15 00:30:44.000000', 'temperatura', 998.0000, 'ºC'),
	(107517, 110, '2015-03-15 00:30:45.000000', 'temperatura', 154.0000, 'ºC'),
	(107518, 110, '2015-03-15 00:30:46.000000', 'temperatura', 178.0000, 'ºC'),
	(107519, 110, '2015-03-15 00:30:47.000000', 'temperatura', 427.0000, 'ºC'),
	(107520, 110, '2015-03-15 00:30:48.000000', 'temperatura', 402.0000, 'ºC'),
	(107521, 110, '2015-03-15 00:30:49.000000', 'temperatura', 731.0000, 'ºC'),
	(107522, 110, '2015-03-15 00:30:50.000000', 'temperatura', 49.0000, 'ºC'),
	(107523, 110, '2015-03-15 00:30:51.000000', 'temperatura', 451.0000, 'ºC'),
	(107524, 110, '2015-03-15 00:30:52.000000', 'temperatura', 910.0000, 'ºC'),
	(107525, 110, '2015-03-15 00:30:53.000000', 'temperatura', 796.0000, 'ºC'),
	(107526, 110, '2015-03-15 00:30:54.000000', 'temperatura', 52.0000, 'ºC'),
	(107527, 110, '2015-03-15 00:30:55.000000', 'temperatura', 274.0000, 'ºC'),
	(107528, 110, '2015-03-15 00:30:56.000000', 'temperatura', 13.0000, 'ºC'),
	(107529, 110, '2015-03-15 00:30:57.000000', 'temperatura', 445.0000, 'ºC'),
	(107530, 110, '2015-03-15 00:30:58.000000', 'temperatura', 983.0000, 'ºC'),
	(107531, 110, '2015-03-15 00:30:59.000000', 'temperatura', 1184.0000, 'ºC'),
	(107532, 110, '2015-03-15 00:31:00.000000', 'temperatura', 569.0000, 'ºC'),
	(107533, 110, '2015-03-15 00:31:01.000000', 'temperatura', 494.0000, 'ºC'),
	(107534, 110, '2015-03-15 00:31:02.000000', 'temperatura', 764.0000, 'ºC'),
	(107535, 110, '2015-03-15 00:31:03.000000', 'temperatura', 1136.0000, 'ºC'),
	(107536, 110, '2015-03-15 00:31:04.000000', 'temperatura', 991.0000, 'ºC'),
	(107537, 110, '2015-03-15 00:31:05.000000', 'temperatura', 348.0000, 'ºC'),
	(107538, 110, '2015-03-15 00:31:06.000000', 'temperatura', 1165.0000, 'ºC'),
	(107539, 110, '2015-03-15 00:31:07.000000', 'temperatura', 1182.0000, 'ºC'),
	(107540, 110, '2015-03-15 00:31:08.000000', 'temperatura', 15.0000, 'ºC'),
	(107541, 110, '2015-03-15 00:31:09.000000', 'temperatura', 130.0000, 'ºC'),
	(107542, 110, '2015-03-15 00:31:10.000000', 'temperatura', 607.0000, 'ºC'),
	(107543, 110, '2015-03-15 00:31:11.000000', 'temperatura', 244.0000, 'ºC'),
	(107544, 110, '2015-03-15 00:31:12.000000', 'temperatura', 602.0000, 'ºC'),
	(107545, 110, '2015-03-15 00:31:13.000000', 'temperatura', 1075.0000, 'ºC'),
	(107546, 110, '2015-03-15 00:31:14.000000', 'temperatura', 1171.0000, 'ºC'),
	(107547, 110, '2015-03-15 00:31:15.000000', 'temperatura', 229.0000, 'ºC'),
	(107548, 110, '2015-03-15 00:31:16.000000', 'temperatura', 33.0000, 'ºC'),
	(107549, 110, '2015-03-15 00:31:17.000000', 'temperatura', 680.0000, 'ºC'),
	(107550, 110, '2015-03-15 00:31:18.000000', 'temperatura', 901.0000, 'ºC'),
	(107551, 110, '2015-03-15 00:31:19.000000', 'temperatura', 66.0000, 'ºC'),
	(107552, 110, '2015-03-15 00:31:20.000000', 'temperatura', 27.0000, 'ºC'),
	(107553, 110, '2015-03-15 00:31:21.000000', 'temperatura', 1138.0000, 'ºC'),
	(107554, 110, '2015-03-15 00:31:22.000000', 'temperatura', 811.0000, 'ºC'),
	(107555, 110, '2015-03-15 00:31:23.000000', 'temperatura', 641.0000, 'ºC'),
	(107556, 110, '2015-03-15 00:31:24.000000', 'temperatura', 772.0000, 'ºC'),
	(107557, 110, '2015-03-15 00:31:25.000000', 'temperatura', 738.0000, 'ºC'),
	(107558, 110, '2015-03-15 00:31:26.000000', 'temperatura', 175.0000, 'ºC'),
	(107559, 110, '2015-03-15 00:31:27.000000', 'temperatura', 1063.0000, 'ºC'),
	(107560, 110, '2015-03-15 00:31:28.000000', 'temperatura', 1187.0000, 'ºC'),
	(107561, 110, '2015-03-15 00:31:29.000000', 'temperatura', 348.0000, 'ºC'),
	(107562, 110, '2015-03-15 00:31:30.000000', 'temperatura', 581.0000, 'ºC'),
	(107563, 110, '2015-03-15 00:31:31.000000', 'temperatura', 659.0000, 'ºC'),
	(107564, 110, '2015-03-15 00:31:32.000000', 'temperatura', 352.0000, 'ºC'),
	(107565, 110, '2015-03-15 00:31:33.000000', 'temperatura', 985.0000, 'ºC'),
	(107566, 110, '2015-03-15 00:31:34.000000', 'temperatura', 271.0000, 'ºC'),
	(107567, 110, '2015-03-15 00:31:35.000000', 'temperatura', 797.0000, 'ºC'),
	(107568, 110, '2015-03-15 00:31:36.000000', 'temperatura', 775.0000, 'ºC'),
	(107569, 110, '2015-03-15 00:31:37.000000', 'temperatura', 284.0000, 'ºC'),
	(107570, 110, '2015-03-15 00:31:38.000000', 'temperatura', 295.0000, 'ºC'),
	(107571, 110, '2015-03-15 00:31:39.000000', 'temperatura', 625.0000, 'ºC'),
	(107572, 110, '2015-03-15 00:31:40.000000', 'temperatura', 1040.0000, 'ºC'),
	(107573, 110, '2015-03-15 00:31:41.000000', 'temperatura', 927.0000, 'ºC'),
	(107574, 110, '2015-03-15 00:31:42.000000', 'temperatura', 315.0000, 'ºC'),
	(107575, 110, '2015-03-15 00:31:43.000000', 'temperatura', 1196.0000, 'ºC'),
	(107576, 110, '2015-03-15 00:31:44.000000', 'temperatura', 234.0000, 'ºC'),
	(107577, 110, '2015-03-15 00:31:45.000000', 'temperatura', 1183.0000, 'ºC'),
	(107578, 110, '2015-03-15 00:31:46.000000', 'temperatura', 412.0000, 'ºC'),
	(107579, 110, '2015-03-15 00:31:47.000000', 'temperatura', 914.0000, 'ºC'),
	(107580, 110, '2015-03-15 00:31:48.000000', 'temperatura', 934.0000, 'ºC'),
	(107581, 110, '2015-03-15 00:31:49.000000', 'temperatura', 727.0000, 'ºC'),
	(107582, 110, '2015-03-15 00:31:50.000000', 'temperatura', 836.0000, 'ºC'),
	(107583, 110, '2015-03-15 00:31:51.000000', 'temperatura', 798.0000, 'ºC'),
	(107584, 110, '2015-03-15 00:31:52.000000', 'temperatura', 284.0000, 'ºC'),
	(107585, 110, '2015-03-15 00:31:53.000000', 'temperatura', 226.0000, 'ºC'),
	(107586, 110, '2015-03-15 00:31:54.000000', 'temperatura', 278.0000, 'ºC'),
	(107587, 110, '2015-03-15 00:31:55.000000', 'temperatura', 713.0000, 'ºC'),
	(107588, 110, '2015-03-15 00:31:56.000000', 'temperatura', 332.0000, 'ºC'),
	(107589, 110, '2015-03-15 00:31:57.000000', 'temperatura', 720.0000, 'ºC'),
	(107590, 110, '2015-03-15 00:31:58.000000', 'temperatura', 207.0000, 'ºC'),
	(107591, 110, '2015-03-15 00:31:59.000000', 'temperatura', 75.0000, 'ºC'),
	(107592, 110, '2015-03-15 00:32:00.000000', 'temperatura', 953.0000, 'ºC'),
	(107593, 110, '2015-03-15 00:32:01.000000', 'temperatura', 941.0000, 'ºC'),
	(107594, 110, '2015-03-15 00:32:02.000000', 'temperatura', 645.0000, 'ºC'),
	(107595, 110, '2015-03-15 00:32:03.000000', 'temperatura', 405.0000, 'ºC'),
	(107596, 110, '2015-03-15 00:32:04.000000', 'temperatura', 89.0000, 'ºC'),
	(107597, 110, '2015-03-15 00:32:05.000000', 'temperatura', 430.0000, 'ºC'),
	(107598, 110, '2015-03-15 00:32:06.000000', 'temperatura', 684.0000, 'ºC'),
	(107599, 110, '2015-03-15 00:32:07.000000', 'temperatura', 931.0000, 'ºC'),
	(107600, 110, '2015-03-15 00:32:08.000000', 'temperatura', 204.0000, 'ºC'),
	(107601, 110, '2015-03-15 00:32:09.000000', 'temperatura', 628.0000, 'ºC'),
	(107602, 110, '2015-03-15 00:32:10.000000', 'temperatura', 129.0000, 'ºC'),
	(107603, 110, '2015-03-15 00:32:11.000000', 'temperatura', 1162.0000, 'ºC'),
	(107604, 110, '2015-03-15 00:32:12.000000', 'temperatura', 621.0000, 'ºC'),
	(107605, 110, '2015-03-15 00:32:13.000000', 'temperatura', 819.0000, 'ºC'),
	(107606, 110, '2015-03-15 00:32:14.000000', 'temperatura', 1034.0000, 'ºC'),
	(107607, 110, '2015-03-15 00:32:15.000000', 'temperatura', 314.0000, 'ºC'),
	(107608, 110, '2015-03-15 00:32:16.000000', 'temperatura', 868.0000, 'ºC'),
	(107609, 110, '2015-03-15 00:32:17.000000', 'temperatura', 1000.0000, 'ºC'),
	(107610, 110, '2015-03-15 00:32:18.000000', 'temperatura', 1193.0000, 'ºC'),
	(107611, 110, '2015-03-15 00:32:19.000000', 'temperatura', 569.0000, 'ºC'),
	(107612, 110, '2015-03-15 00:32:20.000000', 'temperatura', 466.0000, 'ºC'),
	(107613, 110, '2015-03-15 00:32:21.000000', 'temperatura', 623.0000, 'ºC'),
	(107614, 110, '2015-03-15 00:32:22.000000', 'temperatura', 517.0000, 'ºC'),
	(107615, 110, '2015-03-15 00:32:23.000000', 'temperatura', 715.0000, 'ºC'),
	(107616, 110, '2015-03-15 00:32:24.000000', 'temperatura', 825.0000, 'ºC'),
	(107617, 110, '2015-03-15 00:32:25.000000', 'temperatura', 782.0000, 'ºC'),
	(107618, 110, '2015-03-15 00:32:26.000000', 'temperatura', 236.0000, 'ºC'),
	(107619, 110, '2015-03-15 00:32:27.000000', 'temperatura', 35.0000, 'ºC'),
	(107620, 110, '2015-03-15 00:32:28.000000', 'temperatura', 665.0000, 'ºC'),
	(107621, 110, '2015-03-15 00:32:29.000000', 'temperatura', 820.0000, 'ºC'),
	(107622, 110, '2015-03-15 00:32:30.000000', 'temperatura', 905.0000, 'ºC'),
	(107623, 110, '2015-03-15 00:32:31.000000', 'temperatura', 865.0000, 'ºC'),
	(107624, 110, '2015-03-15 00:32:32.000000', 'temperatura', 410.0000, 'ºC'),
	(107625, 110, '2015-03-15 00:32:33.000000', 'temperatura', 655.0000, 'ºC'),
	(107626, 110, '2015-03-15 00:32:34.000000', 'temperatura', 849.0000, 'ºC'),
	(107627, 110, '2015-03-15 00:32:35.000000', 'temperatura', 1078.0000, 'ºC'),
	(107628, 110, '2015-03-15 00:32:36.000000', 'temperatura', 443.0000, 'ºC'),
	(107629, 110, '2015-03-15 00:32:37.000000', 'temperatura', 184.0000, 'ºC'),
	(107630, 110, '2015-03-15 00:32:38.000000', 'temperatura', 791.0000, 'ºC'),
	(107631, 110, '2015-03-15 00:32:39.000000', 'temperatura', 1004.0000, 'ºC'),
	(107632, 110, '2015-03-15 00:32:40.000000', 'temperatura', 248.0000, 'ºC'),
	(107633, 110, '2015-03-15 00:32:41.000000', 'temperatura', 628.0000, 'ºC'),
	(107634, 110, '2015-03-15 00:32:42.000000', 'temperatura', 1198.0000, 'ºC'),
	(107635, 110, '2015-03-15 00:32:43.000000', 'temperatura', 505.0000, 'ºC'),
	(107636, 110, '2015-03-15 00:32:44.000000', 'temperatura', 130.0000, 'ºC'),
	(107637, 110, '2015-03-15 00:32:45.000000', 'temperatura', 336.0000, 'ºC'),
	(107638, 110, '2015-03-15 00:32:46.000000', 'temperatura', 93.0000, 'ºC'),
	(107639, 110, '2015-03-15 00:32:47.000000', 'temperatura', 656.0000, 'ºC'),
	(107640, 110, '2015-03-15 00:32:48.000000', 'temperatura', 600.0000, 'ºC'),
	(107641, 110, '2015-03-15 00:32:49.000000', 'temperatura', 1035.0000, 'ºC'),
	(107642, 110, '2015-03-15 00:32:50.000000', 'temperatura', 976.0000, 'ºC'),
	(107643, 110, '2015-03-15 00:32:51.000000', 'temperatura', 573.0000, 'ºC'),
	(107644, 110, '2015-03-15 00:32:52.000000', 'temperatura', 1139.0000, 'ºC'),
	(107645, 110, '2015-03-15 00:32:53.000000', 'temperatura', 376.0000, 'ºC'),
	(107646, 110, '2015-03-15 00:32:54.000000', 'temperatura', 862.0000, 'ºC'),
	(107647, 110, '2015-03-15 00:32:55.000000', 'temperatura', 782.0000, 'ºC'),
	(107648, 110, '2015-03-15 00:32:56.000000', 'temperatura', 125.0000, 'ºC'),
	(107649, 110, '2015-03-15 00:32:57.000000', 'temperatura', 680.0000, 'ºC'),
	(107650, 110, '2015-03-15 00:32:58.000000', 'temperatura', 626.0000, 'ºC'),
	(107651, 110, '2015-03-15 00:32:59.000000', 'temperatura', 1091.0000, 'ºC'),
	(107652, 110, '2015-03-15 00:33:00.000000', 'temperatura', 1179.0000, 'ºC'),
	(107653, 110, '2015-03-15 00:33:01.000000', 'temperatura', 221.0000, 'ºC'),
	(107654, 110, '2015-03-15 00:33:02.000000', 'temperatura', 1167.0000, 'ºC'),
	(107655, 110, '2015-03-15 00:33:03.000000', 'temperatura', 375.0000, 'ºC'),
	(107656, 110, '2015-03-15 00:33:04.000000', 'temperatura', 773.0000, 'ºC'),
	(107657, 110, '2015-03-15 00:33:05.000000', 'temperatura', 339.0000, 'ºC'),
	(107658, 110, '2015-03-15 00:33:06.000000', 'temperatura', 579.0000, 'ºC'),
	(107659, 110, '2015-03-15 00:33:07.000000', 'temperatura', 678.0000, 'ºC'),
	(107660, 110, '2015-03-15 00:33:08.000000', 'temperatura', 453.0000, 'ºC'),
	(107661, 110, '2015-03-15 00:33:09.000000', 'temperatura', 230.0000, 'ºC'),
	(107662, 110, '2015-03-15 00:33:10.000000', 'temperatura', 994.0000, 'ºC'),
	(107663, 110, '2015-03-15 00:33:11.000000', 'temperatura', 680.0000, 'ºC'),
	(107664, 110, '2015-03-15 00:33:12.000000', 'temperatura', 420.0000, 'ºC'),
	(107665, 110, '2015-03-15 00:33:13.000000', 'temperatura', 58.0000, 'ºC'),
	(107666, 110, '2015-03-15 00:33:14.000000', 'temperatura', 233.0000, 'ºC'),
	(107667, 110, '2015-03-15 00:33:15.000000', 'temperatura', 991.0000, 'ºC'),
	(107668, 110, '2015-03-15 00:33:16.000000', 'temperatura', 655.0000, 'ºC'),
	(107669, 110, '2015-03-15 00:33:17.000000', 'temperatura', 303.0000, 'ºC'),
	(107670, 110, '2015-03-15 00:33:18.000000', 'temperatura', 749.0000, 'ºC'),
	(107671, 110, '2015-03-15 00:33:19.000000', 'temperatura', 439.0000, 'ºC'),
	(107672, 110, '2015-03-15 00:33:20.000000', 'temperatura', 1150.0000, 'ºC'),
	(107673, 110, '2015-03-15 00:33:21.000000', 'temperatura', 830.0000, 'ºC'),
	(107674, 110, '2015-03-15 00:33:22.000000', 'temperatura', 703.0000, 'ºC'),
	(107675, 110, '2015-03-15 00:33:23.000000', 'temperatura', 1023.0000, 'ºC'),
	(107676, 110, '2015-03-15 00:33:24.000000', 'temperatura', 607.0000, 'ºC'),
	(107677, 110, '2015-03-15 00:33:25.000000', 'temperatura', 1165.0000, 'ºC'),
	(107678, 110, '2015-03-15 00:33:26.000000', 'temperatura', 405.0000, 'ºC'),
	(107679, 110, '2015-03-15 00:33:27.000000', 'temperatura', 932.0000, 'ºC'),
	(107680, 110, '2015-03-15 00:33:28.000000', 'temperatura', 1044.0000, 'ºC'),
	(107681, 110, '2015-03-15 00:33:29.000000', 'temperatura', 23.0000, 'ºC'),
	(107682, 110, '2015-03-15 00:33:30.000000', 'temperatura', 586.0000, 'ºC'),
	(107683, 110, '2015-03-15 00:33:31.000000', 'temperatura', 462.0000, 'ºC'),
	(107684, 110, '2015-03-15 00:33:32.000000', 'temperatura', 550.0000, 'ºC'),
	(107685, 110, '2015-03-15 00:33:33.000000', 'temperatura', 168.0000, 'ºC'),
	(107686, 110, '2015-03-15 00:33:34.000000', 'temperatura', 388.0000, 'ºC'),
	(107687, 110, '2015-03-15 00:33:35.000000', 'temperatura', 236.0000, 'ºC'),
	(107688, 110, '2015-03-15 00:33:36.000000', 'temperatura', 15.0000, 'ºC'),
	(107689, 110, '2015-03-15 00:33:37.000000', 'temperatura', 571.0000, 'ºC'),
	(107690, 110, '2015-03-15 00:33:38.000000', 'temperatura', 409.0000, 'ºC'),
	(107691, 110, '2015-03-15 00:33:39.000000', 'temperatura', 333.0000, 'ºC'),
	(107692, 110, '2015-03-15 00:33:40.000000', 'temperatura', 439.0000, 'ºC'),
	(107693, 110, '2015-03-15 00:33:41.000000', 'temperatura', 1194.0000, 'ºC'),
	(107694, 110, '2015-03-15 00:33:42.000000', 'temperatura', 1056.0000, 'ºC'),
	(107695, 110, '2015-03-15 00:33:43.000000', 'temperatura', 498.0000, 'ºC'),
	(107696, 110, '2015-03-15 00:33:44.000000', 'temperatura', 522.0000, 'ºC'),
	(107697, 110, '2015-03-15 00:33:45.000000', 'temperatura', 1117.0000, 'ºC'),
	(107698, 110, '2015-03-15 00:33:46.000000', 'temperatura', 419.0000, 'ºC'),
	(107699, 110, '2015-03-15 00:33:47.000000', 'temperatura', 1144.0000, 'ºC'),
	(107700, 110, '2015-03-15 00:33:48.000000', 'temperatura', 864.0000, 'ºC'),
	(107701, 110, '2015-03-15 00:33:49.000000', 'temperatura', 890.0000, 'ºC'),
	(107702, 110, '2015-03-15 00:33:50.000000', 'temperatura', 657.0000, 'ºC'),
	(107703, 110, '2015-03-15 00:33:51.000000', 'temperatura', 617.0000, 'ºC'),
	(107704, 110, '2015-03-15 00:33:52.000000', 'temperatura', 1114.0000, 'ºC'),
	(107705, 110, '2015-03-15 00:33:53.000000', 'temperatura', 120.0000, 'ºC'),
	(107706, 110, '2015-03-15 00:33:54.000000', 'temperatura', 859.0000, 'ºC'),
	(107707, 110, '2015-03-15 00:33:55.000000', 'temperatura', 335.0000, 'ºC'),
	(107708, 110, '2015-03-15 00:33:56.000000', 'temperatura', 299.0000, 'ºC'),
	(107709, 110, '2015-03-15 00:33:57.000000', 'temperatura', 488.0000, 'ºC'),
	(107710, 110, '2015-03-15 00:33:58.000000', 'temperatura', 345.0000, 'ºC'),
	(107711, 110, '2015-03-15 00:33:59.000000', 'temperatura', 260.0000, 'ºC'),
	(107712, 110, '2015-03-15 00:34:00.000000', 'temperatura', 265.0000, 'ºC'),
	(107713, 110, '2015-03-15 00:34:01.000000', 'temperatura', 545.0000, 'ºC'),
	(107714, 110, '2015-03-15 00:34:02.000000', 'temperatura', 732.0000, 'ºC'),
	(107715, 110, '2015-03-15 00:34:03.000000', 'temperatura', 827.0000, 'ºC'),
	(107716, 110, '2015-03-15 00:34:04.000000', 'temperatura', 737.0000, 'ºC'),
	(107717, 110, '2015-03-15 00:34:05.000000', 'temperatura', 6.0000, 'ºC'),
	(107718, 110, '2015-03-15 00:34:06.000000', 'temperatura', 221.0000, 'ºC'),
	(107719, 110, '2015-03-15 00:34:07.000000', 'temperatura', 1085.0000, 'ºC'),
	(107720, 110, '2015-03-15 00:34:08.000000', 'temperatura', 1165.0000, 'ºC'),
	(107721, 110, '2015-03-15 00:34:09.000000', 'temperatura', 171.0000, 'ºC'),
	(107722, 110, '2015-03-15 00:34:10.000000', 'temperatura', 960.0000, 'ºC'),
	(107723, 110, '2015-03-15 00:34:11.000000', 'temperatura', 685.0000, 'ºC'),
	(107724, 110, '2015-03-15 00:34:12.000000', 'temperatura', 547.0000, 'ºC'),
	(107725, 110, '2015-03-15 00:34:13.000000', 'temperatura', 682.0000, 'ºC'),
	(107726, 110, '2015-03-15 00:34:14.000000', 'temperatura', 567.0000, 'ºC'),
	(107727, 110, '2015-03-15 00:34:15.000000', 'temperatura', 790.0000, 'ºC'),
	(107728, 110, '2015-03-15 00:34:16.000000', 'temperatura', 1051.0000, 'ºC'),
	(107729, 110, '2015-03-15 00:34:17.000000', 'temperatura', 485.0000, 'ºC'),
	(107730, 110, '2015-03-15 00:34:18.000000', 'temperatura', 472.0000, 'ºC'),
	(107731, 110, '2015-03-15 00:34:19.000000', 'temperatura', 906.0000, 'ºC'),
	(107732, 110, '2015-03-15 00:34:20.000000', 'temperatura', 716.0000, 'ºC'),
	(107733, 110, '2015-03-15 00:34:21.000000', 'temperatura', 860.0000, 'ºC'),
	(107734, 110, '2015-03-15 00:34:22.000000', 'temperatura', 953.0000, 'ºC'),
	(107735, 110, '2015-03-15 00:34:23.000000', 'temperatura', 987.0000, 'ºC'),
	(107736, 110, '2015-03-15 00:34:24.000000', 'temperatura', 877.0000, 'ºC'),
	(107737, 110, '2015-03-15 00:34:25.000000', 'temperatura', 224.0000, 'ºC'),
	(107738, 110, '2015-03-15 00:34:26.000000', 'temperatura', 890.0000, 'ºC'),
	(107739, 110, '2015-03-15 00:34:27.000000', 'temperatura', 176.0000, 'ºC'),
	(107740, 110, '2015-03-15 00:34:28.000000', 'temperatura', 611.0000, 'ºC'),
	(107741, 110, '2015-03-15 00:34:29.000000', 'temperatura', 130.0000, 'ºC'),
	(107742, 110, '2015-03-15 00:34:30.000000', 'temperatura', 15.0000, 'ºC'),
	(107743, 110, '2015-03-15 00:34:31.000000', 'temperatura', 886.0000, 'ºC'),
	(107744, 110, '2015-03-15 00:34:32.000000', 'temperatura', 784.0000, 'ºC'),
	(107745, 110, '2015-03-15 00:34:33.000000', 'temperatura', 63.0000, 'ºC'),
	(107746, 110, '2015-03-15 00:34:34.000000', 'temperatura', 364.0000, 'ºC'),
	(107747, 110, '2015-03-15 00:34:35.000000', 'temperatura', 431.0000, 'ºC'),
	(107748, 110, '2015-03-15 00:34:36.000000', 'temperatura', 1062.0000, 'ºC'),
	(107749, 110, '2015-03-15 00:34:37.000000', 'temperatura', 419.0000, 'ºC'),
	(107750, 110, '2015-03-15 00:34:38.000000', 'temperatura', 109.0000, 'ºC'),
	(107751, 110, '2015-03-15 00:34:39.000000', 'temperatura', 490.0000, 'ºC'),
	(107752, 110, '2015-03-15 00:34:40.000000', 'temperatura', 924.0000, 'ºC'),
	(107753, 110, '2015-03-15 00:34:41.000000', 'temperatura', 748.0000, 'ºC'),
	(107754, 110, '2015-03-15 00:34:42.000000', 'temperatura', 968.0000, 'ºC'),
	(107755, 110, '2015-03-15 00:34:43.000000', 'temperatura', 199.0000, 'ºC'),
	(107756, 110, '2015-03-15 00:34:44.000000', 'temperatura', 492.0000, 'ºC'),
	(107757, 110, '2015-03-15 00:34:45.000000', 'temperatura', 663.0000, 'ºC'),
	(107758, 110, '2015-03-15 00:34:46.000000', 'temperatura', 639.0000, 'ºC'),
	(107759, 110, '2015-03-15 00:34:47.000000', 'temperatura', 8.0000, 'ºC'),
	(107760, 110, '2015-03-15 00:34:48.000000', 'temperatura', 521.0000, 'ºC'),
	(107761, 110, '2015-03-15 00:34:49.000000', 'temperatura', 182.0000, 'ºC'),
	(107762, 110, '2015-03-15 00:34:50.000000', 'temperatura', 549.0000, 'ºC'),
	(107763, 110, '2015-03-15 00:34:51.000000', 'temperatura', 1000.0000, 'ºC'),
	(107764, 110, '2015-03-15 00:34:52.000000', 'temperatura', 953.0000, 'ºC'),
	(107765, 110, '2015-03-15 00:34:53.000000', 'temperatura', 566.0000, 'ºC'),
	(107766, 110, '2015-03-15 00:34:54.000000', 'temperatura', 1172.0000, 'ºC'),
	(107767, 110, '2015-03-15 00:34:55.000000', 'temperatura', 563.0000, 'ºC'),
	(107768, 110, '2015-03-15 00:34:56.000000', 'temperatura', 499.0000, 'ºC'),
	(107769, 110, '2015-03-15 00:34:57.000000', 'temperatura', 806.0000, 'ºC'),
	(107770, 110, '2015-03-15 00:34:58.000000', 'temperatura', 134.0000, 'ºC'),
	(107771, 110, '2015-03-15 00:34:59.000000', 'temperatura', 654.0000, 'ºC'),
	(107772, 110, '2015-03-15 00:35:00.000000', 'temperatura', 467.0000, 'ºC'),
	(107773, 110, '2015-03-15 00:35:01.000000', 'temperatura', 375.0000, 'ºC'),
	(107774, 110, '2015-03-15 00:35:02.000000', 'temperatura', 472.0000, 'ºC'),
	(107775, 110, '2015-03-15 00:35:03.000000', 'temperatura', 36.0000, 'ºC'),
	(107776, 110, '2015-03-15 00:35:04.000000', 'temperatura', 1167.0000, 'ºC'),
	(107777, 110, '2015-03-15 00:35:05.000000', 'temperatura', 925.0000, 'ºC'),
	(107778, 110, '2015-03-15 00:35:06.000000', 'temperatura', 1125.0000, 'ºC'),
	(107779, 110, '2015-03-15 00:35:07.000000', 'temperatura', 449.0000, 'ºC'),
	(107780, 110, '2015-03-15 00:35:08.000000', 'temperatura', 70.0000, 'ºC'),
	(107781, 110, '2015-03-15 00:35:09.000000', 'temperatura', 204.0000, 'ºC'),
	(107782, 110, '2015-03-15 00:35:10.000000', 'temperatura', 809.0000, 'ºC'),
	(107783, 110, '2015-03-15 00:35:11.000000', 'temperatura', 1036.0000, 'ºC'),
	(107784, 110, '2015-03-15 00:35:12.000000', 'temperatura', 351.0000, 'ºC'),
	(107785, 110, '2015-03-15 00:35:13.000000', 'temperatura', 1047.0000, 'ºC'),
	(107786, 110, '2015-03-15 00:35:14.000000', 'temperatura', 584.0000, 'ºC'),
	(107787, 110, '2015-03-15 00:35:15.000000', 'temperatura', 978.0000, 'ºC'),
	(107788, 110, '2015-03-15 00:35:16.000000', 'temperatura', 741.0000, 'ºC'),
	(107789, 110, '2015-03-15 00:35:17.000000', 'temperatura', 772.0000, 'ºC'),
	(107790, 110, '2015-03-15 00:35:18.000000', 'temperatura', 435.0000, 'ºC'),
	(107791, 110, '2015-03-15 00:35:19.000000', 'temperatura', 1060.0000, 'ºC'),
	(107792, 110, '2015-03-15 00:35:20.000000', 'temperatura', 397.0000, 'ºC'),
	(107793, 110, '2015-03-15 00:35:21.000000', 'temperatura', 5.0000, 'ºC'),
	(107794, 110, '2015-03-15 00:35:22.000000', 'temperatura', 35.0000, 'ºC'),
	(107795, 110, '2015-03-15 00:35:23.000000', 'temperatura', 159.0000, 'ºC'),
	(107796, 110, '2015-03-15 00:35:24.000000', 'temperatura', 692.0000, 'ºC'),
	(107797, 110, '2015-03-15 00:35:25.000000', 'temperatura', 583.0000, 'ºC'),
	(107798, 110, '2015-03-15 00:35:26.000000', 'temperatura', 841.0000, 'ºC'),
	(107799, 110, '2015-03-15 00:35:27.000000', 'temperatura', 54.0000, 'ºC'),
	(107800, 110, '2015-03-15 00:35:28.000000', 'temperatura', 147.0000, 'ºC'),
	(107801, 110, '2015-03-15 00:35:29.000000', 'temperatura', 575.0000, 'ºC'),
	(107802, 110, '2015-03-15 00:35:30.000000', 'temperatura', 33.0000, 'ºC'),
	(107803, 110, '2015-03-15 00:35:31.000000', 'temperatura', 841.0000, 'ºC'),
	(107804, 110, '2015-03-15 00:35:32.000000', 'temperatura', 508.0000, 'ºC'),
	(107805, 110, '2015-03-15 00:35:33.000000', 'temperatura', 17.0000, 'ºC'),
	(107806, 110, '2015-03-15 00:35:34.000000', 'temperatura', 960.0000, 'ºC'),
	(107807, 110, '2015-03-15 00:35:35.000000', 'temperatura', 1149.0000, 'ºC'),
	(107808, 110, '2015-03-15 00:35:36.000000', 'temperatura', 465.0000, 'ºC'),
	(107809, 110, '2015-03-15 00:35:37.000000', 'temperatura', 81.0000, 'ºC'),
	(107810, 110, '2015-03-15 00:35:38.000000', 'temperatura', 208.0000, 'ºC'),
	(107811, 110, '2015-03-15 00:35:39.000000', 'temperatura', 801.0000, 'ºC'),
	(107812, 110, '2015-03-15 00:35:40.000000', 'temperatura', 978.0000, 'ºC'),
	(107813, 110, '2015-03-15 00:35:41.000000', 'temperatura', 89.0000, 'ºC'),
	(107814, 110, '2015-03-15 00:35:42.000000', 'temperatura', 1110.0000, 'ºC'),
	(107815, 110, '2015-03-15 00:35:43.000000', 'temperatura', 484.0000, 'ºC'),
	(107816, 110, '2015-03-15 00:35:44.000000', 'temperatura', 293.0000, 'ºC'),
	(107817, 110, '2015-03-15 00:35:45.000000', 'temperatura', 10.0000, 'ºC'),
	(107818, 110, '2015-03-15 00:35:46.000000', 'temperatura', 373.0000, 'ºC'),
	(107819, 110, '2015-03-15 00:35:47.000000', 'temperatura', 635.0000, 'ºC'),
	(107820, 110, '2015-03-15 00:35:48.000000', 'temperatura', 857.0000, 'ºC'),
	(107821, 110, '2015-03-15 00:35:49.000000', 'temperatura', 1178.0000, 'ºC'),
	(107822, 110, '2015-03-15 00:35:50.000000', 'temperatura', 923.0000, 'ºC'),
	(107823, 110, '2015-03-15 00:35:51.000000', 'temperatura', 1078.0000, 'ºC'),
	(107824, 110, '2015-03-15 00:35:52.000000', 'temperatura', 224.0000, 'ºC'),
	(107825, 110, '2015-03-15 00:35:53.000000', 'temperatura', 287.0000, 'ºC'),
	(107826, 110, '2015-03-15 00:35:54.000000', 'temperatura', 763.0000, 'ºC'),
	(107827, 110, '2015-03-15 00:35:55.000000', 'temperatura', 555.0000, 'ºC'),
	(107828, 110, '2015-03-15 00:35:56.000000', 'temperatura', 484.0000, 'ºC'),
	(107829, 110, '2015-03-15 00:35:57.000000', 'temperatura', 757.0000, 'ºC'),
	(107830, 110, '2015-03-15 00:35:58.000000', 'temperatura', 1134.0000, 'ºC'),
	(107831, 110, '2015-03-15 00:35:59.000000', 'temperatura', 1001.0000, 'ºC'),
	(107832, 110, '2015-03-15 00:36:00.000000', 'temperatura', 401.0000, 'ºC'),
	(107833, 110, '2015-03-15 00:36:01.000000', 'temperatura', 205.0000, 'ºC'),
	(107834, 110, '2015-03-15 00:36:02.000000', 'temperatura', 1023.0000, 'ºC'),
	(107835, 110, '2015-03-15 00:36:03.000000', 'temperatura', 899.0000, 'ºC'),
	(107836, 110, '2015-03-15 00:36:04.000000', 'temperatura', 228.0000, 'ºC'),
	(107837, 110, '2015-03-15 00:36:05.000000', 'temperatura', 843.0000, 'ºC'),
	(107838, 110, '2015-03-15 00:36:06.000000', 'temperatura', 1130.0000, 'ºC'),
	(107839, 110, '2015-03-15 00:36:07.000000', 'temperatura', 723.0000, 'ºC'),
	(107840, 110, '2015-03-15 00:36:08.000000', 'temperatura', 227.0000, 'ºC'),
	(107841, 110, '2015-03-15 00:36:09.000000', 'temperatura', 165.0000, 'ºC'),
	(107842, 110, '2015-03-15 00:36:10.000000', 'temperatura', 145.0000, 'ºC'),
	(107843, 110, '2015-03-15 00:36:11.000000', 'temperatura', 229.0000, 'ºC'),
	(107844, 110, '2015-03-15 00:36:12.000000', 'temperatura', 710.0000, 'ºC'),
	(107845, 110, '2015-03-15 00:36:13.000000', 'temperatura', 463.0000, 'ºC'),
	(107846, 110, '2015-03-15 00:36:14.000000', 'temperatura', 187.0000, 'ºC'),
	(107847, 110, '2015-03-15 00:36:15.000000', 'temperatura', 746.0000, 'ºC'),
	(107848, 110, '2015-03-15 00:36:16.000000', 'temperatura', 770.0000, 'ºC'),
	(107849, 110, '2015-03-15 00:36:17.000000', 'temperatura', 413.0000, 'ºC'),
	(107850, 110, '2015-03-15 00:36:18.000000', 'temperatura', 954.0000, 'ºC'),
	(107851, 110, '2015-03-15 00:36:19.000000', 'temperatura', 1131.0000, 'ºC'),
	(107852, 110, '2015-03-15 00:36:20.000000', 'temperatura', 393.0000, 'ºC'),
	(107853, 110, '2015-03-15 00:36:21.000000', 'temperatura', 972.0000, 'ºC'),
	(107854, 110, '2015-03-15 00:36:22.000000', 'temperatura', 85.0000, 'ºC'),
	(107855, 110, '2015-03-15 00:36:23.000000', 'temperatura', 1106.0000, 'ºC'),
	(107856, 110, '2015-03-15 00:36:24.000000', 'temperatura', 475.0000, 'ºC'),
	(107857, 110, '2015-03-15 00:36:25.000000', 'temperatura', 260.0000, 'ºC'),
	(107858, 110, '2015-03-15 00:36:26.000000', 'temperatura', 1074.0000, 'ºC'),
	(107859, 110, '2015-03-15 00:36:27.000000', 'temperatura', 992.0000, 'ºC'),
	(107860, 110, '2015-03-15 00:36:28.000000', 'temperatura', 540.0000, 'ºC'),
	(107861, 110, '2015-03-15 00:36:29.000000', 'temperatura', 922.0000, 'ºC'),
	(107862, 110, '2015-03-15 00:36:30.000000', 'temperatura', 591.0000, 'ºC'),
	(107863, 110, '2015-03-15 00:36:31.000000', 'temperatura', 190.0000, 'ºC'),
	(107864, 110, '2015-03-15 00:36:32.000000', 'temperatura', 378.0000, 'ºC'),
	(107865, 110, '2015-03-15 00:36:33.000000', 'temperatura', 118.0000, 'ºC'),
	(107866, 110, '2015-03-15 00:36:34.000000', 'temperatura', 660.0000, 'ºC'),
	(107867, 110, '2015-03-15 00:36:35.000000', 'temperatura', 544.0000, 'ºC'),
	(107868, 110, '2015-03-15 00:36:36.000000', 'temperatura', 739.0000, 'ºC'),
	(107869, 110, '2015-03-15 00:36:37.000000', 'temperatura', 866.0000, 'ºC'),
	(107870, 110, '2015-03-15 00:36:38.000000', 'temperatura', 912.0000, 'ºC'),
	(107871, 110, '2015-03-15 00:36:39.000000', 'temperatura', 763.0000, 'ºC'),
	(107872, 110, '2015-03-15 00:36:40.000000', 'temperatura', 1081.0000, 'ºC'),
	(107873, 110, '2015-03-15 00:36:41.000000', 'temperatura', 716.0000, 'ºC'),
	(107874, 110, '2015-03-15 00:36:42.000000', 'temperatura', 335.0000, 'ºC'),
	(107875, 110, '2015-03-15 00:36:43.000000', 'temperatura', 729.0000, 'ºC'),
	(107876, 110, '2015-03-15 00:36:44.000000', 'temperatura', 241.0000, 'ºC'),
	(107877, 110, '2015-03-15 00:36:45.000000', 'temperatura', 219.0000, 'ºC'),
	(107878, 110, '2015-03-15 00:36:46.000000', 'temperatura', 372.0000, 'ºC'),
	(107879, 110, '2015-03-15 00:36:47.000000', 'temperatura', 6.0000, 'ºC'),
	(107880, 110, '2015-03-15 00:36:48.000000', 'temperatura', 111.0000, 'ºC'),
	(107881, 110, '2015-03-15 00:36:49.000000', 'temperatura', 538.0000, 'ºC'),
	(107882, 110, '2015-03-15 00:36:50.000000', 'temperatura', 1157.0000, 'ºC'),
	(107883, 110, '2015-03-15 00:36:51.000000', 'temperatura', 571.0000, 'ºC'),
	(107884, 110, '2015-03-15 00:36:52.000000', 'temperatura', 587.0000, 'ºC'),
	(107885, 110, '2015-03-15 00:36:53.000000', 'temperatura', 22.0000, 'ºC'),
	(107886, 110, '2015-03-15 00:36:54.000000', 'temperatura', 749.0000, 'ºC'),
	(107887, 110, '2015-03-15 00:36:55.000000', 'temperatura', 78.0000, 'ºC'),
	(107888, 110, '2015-03-15 00:36:56.000000', 'temperatura', 545.0000, 'ºC'),
	(107889, 110, '2015-03-15 00:36:57.000000', 'temperatura', 89.0000, 'ºC'),
	(107890, 110, '2015-03-15 00:36:58.000000', 'temperatura', 13.0000, 'ºC'),
	(107891, 110, '2015-03-15 00:36:59.000000', 'temperatura', 996.0000, 'ºC'),
	(107892, 110, '2015-03-15 00:37:00.000000', 'temperatura', 143.0000, 'ºC'),
	(107893, 110, '2015-03-15 00:37:01.000000', 'temperatura', 128.0000, 'ºC'),
	(107894, 110, '2015-03-15 00:37:02.000000', 'temperatura', 213.0000, 'ºC'),
	(107895, 110, '2015-03-15 00:37:03.000000', 'temperatura', 678.0000, 'ºC'),
	(107896, 110, '2015-03-15 00:37:04.000000', 'temperatura', 354.0000, 'ºC'),
	(107897, 110, '2015-03-15 00:37:05.000000', 'temperatura', 937.0000, 'ºC'),
	(107898, 110, '2015-03-15 00:37:06.000000', 'temperatura', 24.0000, 'ºC'),
	(107899, 110, '2015-03-15 00:37:07.000000', 'temperatura', 907.0000, 'ºC'),
	(107900, 110, '2015-03-15 00:37:08.000000', 'temperatura', 864.0000, 'ºC'),
	(107901, 110, '2015-03-15 00:37:09.000000', 'temperatura', 398.0000, 'ºC'),
	(107902, 110, '2015-03-15 00:37:10.000000', 'temperatura', 599.0000, 'ºC'),
	(107903, 110, '2015-03-15 00:37:11.000000', 'temperatura', 603.0000, 'ºC'),
	(107904, 110, '2015-03-15 00:37:12.000000', 'temperatura', 18.0000, 'ºC'),
	(107905, 110, '2015-03-15 00:37:13.000000', 'temperatura', 682.0000, 'ºC'),
	(107906, 110, '2015-03-15 00:37:14.000000', 'temperatura', 956.0000, 'ºC'),
	(107907, 110, '2015-03-15 00:37:15.000000', 'temperatura', 336.0000, 'ºC'),
	(107908, 110, '2015-03-15 00:37:16.000000', 'temperatura', 10.0000, 'ºC'),
	(107909, 110, '2015-03-15 00:37:17.000000', 'temperatura', 243.0000, 'ºC'),
	(107910, 110, '2015-03-15 00:37:18.000000', 'temperatura', 1186.0000, 'ºC'),
	(107911, 110, '2015-03-15 00:37:19.000000', 'temperatura', 403.0000, 'ºC'),
	(107912, 110, '2015-03-15 00:37:20.000000', 'temperatura', 858.0000, 'ºC'),
	(107913, 110, '2015-03-15 00:37:21.000000', 'temperatura', 678.0000, 'ºC'),
	(107914, 110, '2015-03-15 00:37:22.000000', 'temperatura', 820.0000, 'ºC'),
	(107915, 110, '2015-03-15 00:37:23.000000', 'temperatura', 865.0000, 'ºC'),
	(107916, 110, '2015-03-15 00:37:24.000000', 'temperatura', 665.0000, 'ºC'),
	(107917, 110, '2015-03-15 00:37:25.000000', 'temperatura', 730.0000, 'ºC'),
	(107918, 110, '2015-03-15 00:37:26.000000', 'temperatura', 457.0000, 'ºC'),
	(107919, 110, '2015-03-15 00:37:27.000000', 'temperatura', 94.0000, 'ºC'),
	(107920, 110, '2015-03-15 00:37:28.000000', 'temperatura', 301.0000, 'ºC'),
	(107921, 110, '2015-03-15 00:37:29.000000', 'temperatura', 23.0000, 'ºC'),
	(107922, 110, '2015-03-15 00:37:30.000000', 'temperatura', 411.0000, 'ºC'),
	(107923, 110, '2015-03-15 00:37:31.000000', 'temperatura', 787.0000, 'ºC'),
	(107924, 110, '2015-03-15 00:37:32.000000', 'temperatura', 305.0000, 'ºC'),
	(107925, 110, '2015-03-15 00:37:33.000000', 'temperatura', 361.0000, 'ºC'),
	(107926, 110, '2015-03-15 00:37:34.000000', 'temperatura', 893.0000, 'ºC'),
	(107927, 110, '2015-03-15 00:37:35.000000', 'temperatura', 982.0000, 'ºC'),
	(107928, 110, '2015-03-15 00:37:36.000000', 'temperatura', 1031.0000, 'ºC'),
	(107929, 110, '2015-03-15 00:37:37.000000', 'temperatura', 1012.0000, 'ºC'),
	(107930, 110, '2015-03-15 00:37:38.000000', 'temperatura', 764.0000, 'ºC'),
	(107931, 110, '2015-03-15 00:37:39.000000', 'temperatura', 787.0000, 'ºC'),
	(107932, 110, '2015-03-15 00:37:40.000000', 'temperatura', 443.0000, 'ºC'),
	(107933, 110, '2015-03-15 00:37:41.000000', 'temperatura', 1052.0000, 'ºC'),
	(107934, 110, '2015-03-15 00:37:42.000000', 'temperatura', 335.0000, 'ºC'),
	(107935, 110, '2015-03-15 00:37:43.000000', 'temperatura', 917.0000, 'ºC'),
	(107936, 110, '2015-03-15 00:37:44.000000', 'temperatura', 1180.0000, 'ºC'),
	(107937, 110, '2015-03-15 00:37:45.000000', 'temperatura', 752.0000, 'ºC'),
	(107938, 110, '2015-03-15 00:37:46.000000', 'temperatura', 220.0000, 'ºC'),
	(107939, 110, '2015-03-15 00:37:47.000000', 'temperatura', 46.0000, 'ºC'),
	(107940, 110, '2015-03-15 00:37:48.000000', 'temperatura', 770.0000, 'ºC'),
	(107941, 110, '2015-03-15 00:37:49.000000', 'temperatura', 112.0000, 'ºC'),
	(107942, 110, '2015-03-15 00:37:50.000000', 'temperatura', 652.0000, 'ºC'),
	(107943, 110, '2015-03-15 00:37:51.000000', 'temperatura', 523.0000, 'ºC'),
	(107944, 110, '2015-03-15 00:37:52.000000', 'temperatura', 661.0000, 'ºC'),
	(107945, 110, '2015-03-15 00:37:53.000000', 'temperatura', 537.0000, 'ºC'),
	(107946, 110, '2015-03-15 00:37:54.000000', 'temperatura', 700.0000, 'ºC'),
	(107947, 110, '2015-03-15 00:37:55.000000', 'temperatura', 689.0000, 'ºC'),
	(107948, 110, '2015-03-15 00:37:56.000000', 'temperatura', 147.0000, 'ºC'),
	(107949, 110, '2015-03-15 00:37:57.000000', 'temperatura', 1068.0000, 'ºC'),
	(107950, 110, '2015-03-15 00:37:58.000000', 'temperatura', 99.0000, 'ºC'),
	(107951, 110, '2015-03-15 00:37:59.000000', 'temperatura', 892.0000, 'ºC'),
	(107952, 110, '2015-03-15 00:38:00.000000', 'temperatura', 565.0000, 'ºC'),
	(107953, 110, '2015-03-15 00:38:01.000000', 'temperatura', 150.0000, 'ºC'),
	(107954, 110, '2015-03-15 00:38:02.000000', 'temperatura', 255.0000, 'ºC'),
	(107955, 110, '2015-03-15 00:38:03.000000', 'temperatura', 825.0000, 'ºC'),
	(107956, 110, '2015-03-15 00:38:04.000000', 'temperatura', 962.0000, 'ºC'),
	(107957, 110, '2015-03-15 00:38:05.000000', 'temperatura', 1133.0000, 'ºC'),
	(107958, 110, '2015-03-15 00:38:06.000000', 'temperatura', 381.0000, 'ºC'),
	(107959, 110, '2015-03-15 00:38:07.000000', 'temperatura', 907.0000, 'ºC'),
	(107960, 110, '2015-03-15 00:38:08.000000', 'temperatura', 994.0000, 'ºC'),
	(107961, 110, '2015-03-15 00:38:09.000000', 'temperatura', 1046.0000, 'ºC'),
	(107962, 110, '2015-03-15 00:38:10.000000', 'temperatura', 1050.0000, 'ºC'),
	(107963, 110, '2015-03-15 00:38:11.000000', 'temperatura', 913.0000, 'ºC'),
	(107964, 110, '2015-03-15 00:38:12.000000', 'temperatura', 216.0000, 'ºC'),
	(107965, 110, '2015-03-15 00:38:13.000000', 'temperatura', 742.0000, 'ºC'),
	(107966, 110, '2015-03-15 00:38:14.000000', 'temperatura', 663.0000, 'ºC'),
	(107967, 110, '2015-03-15 00:38:15.000000', 'temperatura', 1090.0000, 'ºC'),
	(107968, 110, '2015-03-15 00:38:16.000000', 'temperatura', 1062.0000, 'ºC'),
	(107969, 110, '2015-03-15 00:38:17.000000', 'temperatura', 840.0000, 'ºC'),
	(107970, 110, '2015-03-15 00:38:18.000000', 'temperatura', 1016.0000, 'ºC'),
	(107971, 110, '2015-03-15 00:38:19.000000', 'temperatura', 159.0000, 'ºC'),
	(107972, 110, '2015-03-15 00:38:20.000000', 'temperatura', 148.0000, 'ºC'),
	(107973, 110, '2015-03-15 00:38:21.000000', 'temperatura', 263.0000, 'ºC'),
	(107974, 110, '2015-03-15 00:38:22.000000', 'temperatura', 872.0000, 'ºC'),
	(107975, 110, '2015-03-15 00:38:23.000000', 'temperatura', 1172.0000, 'ºC'),
	(107976, 110, '2015-03-15 00:38:24.000000', 'temperatura', 842.0000, 'ºC'),
	(107977, 110, '2015-03-15 00:38:25.000000', 'temperatura', 698.0000, 'ºC'),
	(107978, 110, '2015-03-15 00:38:26.000000', 'temperatura', 961.0000, 'ºC'),
	(107979, 110, '2015-03-15 00:38:27.000000', 'temperatura', 313.0000, 'ºC'),
	(107980, 110, '2015-03-15 00:38:28.000000', 'temperatura', 1084.0000, 'ºC'),
	(107981, 110, '2015-03-15 00:38:29.000000', 'temperatura', 881.0000, 'ºC'),
	(107982, 110, '2015-03-15 00:38:30.000000', 'temperatura', 1153.0000, 'ºC'),
	(107983, 110, '2015-03-15 00:38:31.000000', 'temperatura', 721.0000, 'ºC'),
	(107984, 110, '2015-03-15 00:38:32.000000', 'temperatura', 147.0000, 'ºC'),
	(107985, 110, '2015-03-15 00:38:33.000000', 'temperatura', 975.0000, 'ºC'),
	(107986, 110, '2015-03-15 00:38:34.000000', 'temperatura', 832.0000, 'ºC'),
	(107987, 110, '2015-03-15 00:38:35.000000', 'temperatura', 34.0000, 'ºC'),
	(107988, 110, '2015-03-15 00:38:36.000000', 'temperatura', 76.0000, 'ºC'),
	(107989, 110, '2015-03-15 00:38:37.000000', 'temperatura', 280.0000, 'ºC'),
	(107990, 110, '2015-03-15 00:38:38.000000', 'temperatura', 1172.0000, 'ºC'),
	(107991, 110, '2015-03-15 00:38:39.000000', 'temperatura', 222.0000, 'ºC'),
	(107992, 110, '2015-03-15 00:38:40.000000', 'temperatura', 1193.0000, 'ºC'),
	(107993, 110, '2015-03-15 00:38:41.000000', 'temperatura', 502.0000, 'ºC'),
	(107994, 110, '2015-03-15 00:38:42.000000', 'temperatura', 129.0000, 'ºC'),
	(107995, 110, '2015-03-15 00:38:43.000000', 'temperatura', 339.0000, 'ºC'),
	(107996, 110, '2015-03-15 00:38:44.000000', 'temperatura', 108.0000, 'ºC'),
	(107997, 110, '2015-03-15 00:38:45.000000', 'temperatura', 723.0000, 'ºC'),
	(107998, 110, '2015-03-15 00:38:46.000000', 'temperatura', 891.0000, 'ºC'),
	(107999, 110, '2015-03-15 00:38:47.000000', 'temperatura', 1086.0000, 'ºC'),
	(108000, 110, '2015-03-15 00:38:48.000000', 'temperatura', 357.0000, 'ºC'),
	(108001, 110, '2015-03-15 00:38:49.000000', 'temperatura', 929.0000, 'ºC'),
	(108002, 110, '2015-03-15 00:38:50.000000', 'temperatura', 1175.0000, 'ºC'),
	(108003, 110, '2015-03-15 00:38:51.000000', 'temperatura', 690.0000, 'ºC'),
	(108004, 110, '2015-03-15 00:38:52.000000', 'temperatura', 1122.0000, 'ºC'),
	(108005, 110, '2015-03-15 00:38:53.000000', 'temperatura', 1143.0000, 'ºC'),
	(108006, 110, '2015-03-15 00:38:54.000000', 'temperatura', 1148.0000, 'ºC'),
	(108007, 110, '2015-03-15 00:38:55.000000', 'temperatura', 1114.0000, 'ºC'),
	(108008, 110, '2015-03-15 00:38:56.000000', 'temperatura', 923.0000, 'ºC'),
	(108009, 110, '2015-03-15 00:38:57.000000', 'temperatura', 77.0000, 'ºC'),
	(108010, 110, '2015-03-15 00:38:58.000000', 'temperatura', 15.0000, 'ºC'),
	(108011, 110, '2015-03-15 00:38:59.000000', 'temperatura', 1043.0000, 'ºC'),
	(108012, 110, '2015-03-15 00:39:00.000000', 'temperatura', 370.0000, 'ºC'),
	(108013, 110, '2015-03-15 00:39:01.000000', 'temperatura', 1122.0000, 'ºC'),
	(108014, 110, '2015-03-15 00:39:02.000000', 'temperatura', 900.0000, 'ºC'),
	(108015, 110, '2015-03-15 00:39:03.000000', 'temperatura', 1137.0000, 'ºC'),
	(108016, 110, '2015-03-15 00:39:04.000000', 'temperatura', 585.0000, 'ºC'),
	(108017, 110, '2015-03-15 00:39:05.000000', 'temperatura', 716.0000, 'ºC'),
	(108018, 110, '2015-03-15 00:39:06.000000', 'temperatura', 624.0000, 'ºC'),
	(108019, 110, '2015-03-15 00:39:07.000000', 'temperatura', 971.0000, 'ºC'),
	(108020, 110, '2015-03-15 00:39:08.000000', 'temperatura', 586.0000, 'ºC'),
	(108021, 110, '2015-03-15 00:39:09.000000', 'temperatura', 17.0000, 'ºC'),
	(108022, 110, '2015-03-15 00:39:10.000000', 'temperatura', 727.0000, 'ºC'),
	(108023, 110, '2015-03-15 00:39:11.000000', 'temperatura', 1183.0000, 'ºC'),
	(108024, 110, '2015-03-15 00:39:12.000000', 'temperatura', 134.0000, 'ºC'),
	(108025, 110, '2015-03-15 00:39:13.000000', 'temperatura', 723.0000, 'ºC'),
	(108026, 110, '2015-03-15 00:39:14.000000', 'temperatura', 815.0000, 'ºC'),
	(108027, 110, '2015-03-15 00:39:15.000000', 'temperatura', 707.0000, 'ºC'),
	(108028, 110, '2015-03-15 00:39:16.000000', 'temperatura', 1089.0000, 'ºC'),
	(108029, 110, '2015-03-15 00:39:17.000000', 'temperatura', 924.0000, 'ºC'),
	(108030, 110, '2015-03-15 00:39:18.000000', 'temperatura', 154.0000, 'ºC'),
	(108031, 110, '2015-03-15 00:39:19.000000', 'temperatura', 399.0000, 'ºC'),
	(108032, 110, '2015-03-15 00:39:20.000000', 'temperatura', 332.0000, 'ºC'),
	(108033, 110, '2015-03-15 00:39:21.000000', 'temperatura', 463.0000, 'ºC'),
	(108034, 110, '2015-03-15 00:39:22.000000', 'temperatura', 119.0000, 'ºC'),
	(108035, 110, '2015-03-15 00:39:23.000000', 'temperatura', 408.0000, 'ºC'),
	(108036, 110, '2015-03-15 00:39:24.000000', 'temperatura', 485.0000, 'ºC'),
	(108037, 110, '2015-03-15 00:39:25.000000', 'temperatura', 1.0000, 'ºC'),
	(108038, 110, '2015-03-15 00:39:26.000000', 'temperatura', 950.0000, 'ºC'),
	(108039, 110, '2015-03-15 00:39:27.000000', 'temperatura', 1149.0000, 'ºC'),
	(108040, 110, '2015-03-15 00:39:28.000000', 'temperatura', 492.0000, 'ºC'),
	(108041, 110, '2015-03-15 00:39:29.000000', 'temperatura', 216.0000, 'ºC'),
	(108042, 110, '2015-03-15 00:39:30.000000', 'temperatura', 806.0000, 'ºC'),
	(108043, 110, '2015-03-15 00:39:31.000000', 'temperatura', 981.0000, 'ºC'),
	(108044, 110, '2015-03-15 00:39:32.000000', 'temperatura', 88.0000, 'ºC'),
	(108045, 110, '2015-03-15 00:39:33.000000', 'temperatura', 1095.0000, 'ºC'),
	(108046, 110, '2015-03-15 00:39:34.000000', 'temperatura', 414.0000, 'ºC'),
	(108047, 110, '2015-03-15 00:39:35.000000', 'temperatura', 1187.0000, 'ºC'),
	(108048, 110, '2015-03-15 00:39:36.000000', 'temperatura', 1091.0000, 'ºC'),
	(108049, 110, '2015-03-15 00:39:37.000000', 'temperatura', 694.0000, 'ºC'),
	(108050, 110, '2015-03-15 00:39:38.000000', 'temperatura', 199.0000, 'ºC'),
	(108051, 110, '2015-03-15 00:39:39.000000', 'temperatura', 113.0000, 'ºC'),
	(108052, 110, '2015-03-15 00:39:40.000000', 'temperatura', 1170.0000, 'ºC'),
	(108053, 110, '2015-03-15 00:39:41.000000', 'temperatura', 712.0000, 'ºC'),
	(108054, 110, '2015-03-15 00:39:42.000000', 'temperatura', 52.0000, 'ºC'),
	(108055, 110, '2015-03-15 00:39:43.000000', 'temperatura', 521.0000, 'ºC'),
	(108056, 110, '2015-03-15 00:39:44.000000', 'temperatura', 50.0000, 'ºC'),
	(108057, 110, '2015-03-15 00:39:45.000000', 'temperatura', 1087.0000, 'ºC'),
	(108058, 110, '2015-03-15 00:39:46.000000', 'temperatura', 485.0000, 'ºC'),
	(108059, 110, '2015-03-15 00:39:47.000000', 'temperatura', 366.0000, 'ºC'),
	(108060, 110, '2015-03-15 00:39:48.000000', 'temperatura', 373.0000, 'ºC'),
	(108061, 110, '2015-03-15 00:39:49.000000', 'temperatura', 769.0000, 'ºC'),
	(108062, 110, '2015-03-15 00:39:50.000000', 'temperatura', 325.0000, 'ºC'),
	(108063, 110, '2015-03-15 00:39:51.000000', 'temperatura', 518.0000, 'ºC'),
	(108064, 110, '2015-03-15 00:39:52.000000', 'temperatura', 419.0000, 'ºC'),
	(108065, 110, '2015-03-15 00:39:53.000000', 'temperatura', 538.0000, 'ºC'),
	(108066, 110, '2015-03-15 00:39:54.000000', 'temperatura', 235.0000, 'ºC'),
	(108067, 110, '2015-03-15 00:39:55.000000', 'temperatura', 760.0000, 'ºC'),
	(108068, 110, '2015-03-15 00:39:56.000000', 'temperatura', 697.0000, 'ºC'),
	(108069, 110, '2015-03-15 00:39:57.000000', 'temperatura', 5.0000, 'ºC'),
	(108070, 110, '2015-03-15 00:39:58.000000', 'temperatura', 333.0000, 'ºC'),
	(108071, 110, '2015-03-15 00:39:59.000000', 'temperatura', 451.0000, 'ºC'),
	(108072, 110, '2015-03-15 00:40:00.000000', 'temperatura', 57.0000, 'ºC'),
	(108073, 110, '2015-03-15 00:40:01.000000', 'temperatura', 131.0000, 'ºC'),
	(108074, 110, '2015-03-15 00:40:02.000000', 'temperatura', 483.0000, 'ºC'),
	(108075, 110, '2015-03-15 00:40:03.000000', 'temperatura', 826.0000, 'ºC'),
	(108076, 110, '2015-03-15 00:40:04.000000', 'temperatura', 281.0000, 'ºC'),
	(108077, 110, '2015-03-15 00:40:05.000000', 'temperatura', 129.0000, 'ºC'),
	(108078, 110, '2015-03-15 00:40:06.000000', 'temperatura', 1000.0000, 'ºC'),
	(108079, 110, '2015-03-15 00:40:07.000000', 'temperatura', 1016.0000, 'ºC'),
	(108080, 110, '2015-03-15 00:40:08.000000', 'temperatura', 879.0000, 'ºC'),
	(108081, 110, '2015-03-15 00:40:09.000000', 'temperatura', 146.0000, 'ºC'),
	(108082, 110, '2015-03-15 00:40:10.000000', 'temperatura', 497.0000, 'ºC'),
	(108083, 110, '2015-03-15 00:40:11.000000', 'temperatura', 844.0000, 'ºC'),
	(108084, 110, '2015-03-15 00:40:12.000000', 'temperatura', 331.0000, 'ºC'),
	(108085, 110, '2015-03-15 00:40:13.000000', 'temperatura', 325.0000, 'ºC'),
	(108086, 110, '2015-03-15 00:40:14.000000', 'temperatura', 632.0000, 'ºC'),
	(108087, 110, '2015-03-15 00:40:15.000000', 'temperatura', 984.0000, 'ºC'),
	(108088, 110, '2015-03-15 00:40:16.000000', 'temperatura', 625.0000, 'ºC'),
	(108089, 110, '2015-03-15 00:40:17.000000', 'temperatura', 174.0000, 'ºC'),
	(108090, 110, '2015-03-15 00:40:18.000000', 'temperatura', 194.0000, 'ºC'),
	(108091, 110, '2015-03-15 00:40:19.000000', 'temperatura', 448.0000, 'ºC'),
	(108092, 110, '2015-03-15 00:40:20.000000', 'temperatura', 462.0000, 'ºC'),
	(108093, 110, '2015-03-15 00:40:21.000000', 'temperatura', 963.0000, 'ºC'),
	(108094, 110, '2015-03-15 00:40:22.000000', 'temperatura', 1031.0000, 'ºC'),
	(108095, 110, '2015-03-15 00:40:23.000000', 'temperatura', 1066.0000, 'ºC'),
	(108096, 110, '2015-03-15 00:40:24.000000', 'temperatura', 1037.0000, 'ºC'),
	(108097, 110, '2015-03-15 00:40:25.000000', 'temperatura', 789.0000, 'ºC'),
	(108098, 110, '2015-03-15 00:40:26.000000', 'temperatura', 834.0000, 'ºC'),
	(108099, 110, '2015-03-15 00:40:27.000000', 'temperatura', 601.0000, 'ºC'),
	(108100, 110, '2015-03-15 00:40:28.000000', 'temperatura', 507.0000, 'ºC'),
	(108101, 110, '2015-03-15 00:40:29.000000', 'temperatura', 731.0000, 'ºC'),
	(108102, 110, '2015-03-15 00:40:30.000000', 'temperatura', 933.0000, 'ºC'),
	(108103, 110, '2015-03-15 00:40:31.000000', 'temperatura', 73.0000, 'ºC'),
	(108104, 110, '2015-03-15 00:40:32.000000', 'temperatura', 1168.0000, 'ºC'),
	(108105, 110, '2015-03-15 00:40:33.000000', 'temperatura', 821.0000, 'ºC'),
	(108106, 110, '2015-03-15 00:40:34.000000', 'temperatura', 600.0000, 'ºC'),
	(108107, 110, '2015-03-15 00:40:35.000000', 'temperatura', 539.0000, 'ºC'),
	(108108, 110, '2015-03-15 00:40:36.000000', 'temperatura', 896.0000, 'ºC'),
	(108109, 110, '2015-03-15 00:40:37.000000', 'temperatura', 464.0000, 'ºC'),
	(108110, 110, '2015-03-15 00:40:38.000000', 'temperatura', 831.0000, 'ºC'),
	(108111, 110, '2015-03-15 00:40:39.000000', 'temperatura', 363.0000, 'ºC'),
	(108112, 110, '2015-03-15 00:40:40.000000', 'temperatura', 522.0000, 'ºC'),
	(108113, 110, '2015-03-15 00:40:41.000000', 'temperatura', 323.0000, 'ºC'),
	(108114, 110, '2015-03-15 00:40:42.000000', 'temperatura', 51.0000, 'ºC'),
	(108115, 110, '2015-03-15 00:40:43.000000', 'temperatura', 484.0000, 'ºC'),
	(108116, 110, '2015-03-15 00:40:44.000000', 'temperatura', 1069.0000, 'ºC'),
	(108117, 110, '2015-03-15 00:40:45.000000', 'temperatura', 293.0000, 'ºC'),
	(108118, 110, '2015-03-15 00:40:46.000000', 'temperatura', 658.0000, 'ºC'),
	(108119, 110, '2015-03-15 00:40:47.000000', 'temperatura', 10.0000, 'ºC'),
	(108120, 110, '2015-03-15 00:40:48.000000', 'temperatura', 480.0000, 'ºC'),
	(108121, 110, '2015-03-15 00:40:49.000000', 'temperatura', 1167.0000, 'ºC'),
	(108122, 110, '2015-03-15 00:40:50.000000', 'temperatura', 797.0000, 'ºC'),
	(108123, 110, '2015-03-15 00:40:51.000000', 'temperatura', 483.0000, 'ºC'),
	(108124, 110, '2015-03-15 00:40:52.000000', 'temperatura', 26.0000, 'ºC'),
	(108125, 110, '2015-03-15 00:40:53.000000', 'temperatura', 1079.0000, 'ºC'),
	(108126, 110, '2015-03-15 00:40:54.000000', 'temperatura', 521.0000, 'ºC'),
	(108127, 110, '2015-03-15 00:40:55.000000', 'temperatura', 565.0000, 'ºC'),
	(108128, 110, '2015-03-15 00:40:56.000000', 'temperatura', 66.0000, 'ºC'),
	(108129, 110, '2015-03-15 00:40:57.000000', 'temperatura', 1032.0000, 'ºC'),
	(108130, 110, '2015-03-15 00:40:58.000000', 'temperatura', 164.0000, 'ºC'),
	(108131, 110, '2015-03-15 00:40:59.000000', 'temperatura', 123.0000, 'ºC'),
	(108132, 110, '2015-03-15 00:41:00.000000', 'temperatura', 126.0000, 'ºC'),
	(108133, 110, '2015-03-15 00:41:01.000000', 'temperatura', 261.0000, 'ºC'),
	(108134, 110, '2015-03-15 00:41:02.000000', 'temperatura', 926.0000, 'ºC'),
	(108135, 110, '2015-03-15 00:41:03.000000', 'temperatura', 247.0000, 'ºC'),
	(108136, 110, '2015-03-15 00:41:04.000000', 'temperatura', 858.0000, 'ºC'),
	(108137, 110, '2015-03-15 00:41:05.000000', 'temperatura', 1148.0000, 'ºC'),
	(108138, 110, '2015-03-15 00:41:06.000000', 'temperatura', 770.0000, 'ºC'),
	(108139, 110, '2015-03-15 00:41:07.000000', 'temperatura', 403.0000, 'ºC'),
	(108140, 110, '2015-03-15 00:41:08.000000', 'temperatura', 907.0000, 'ºC'),
	(108141, 110, '2015-03-15 00:41:09.000000', 'temperatura', 928.0000, 'ºC'),
	(108142, 110, '2015-03-15 00:41:10.000000', 'temperatura', 719.0000, 'ºC'),
	(108143, 110, '2015-03-15 00:41:11.000000', 'temperatura', 813.0000, 'ºC'),
	(108144, 110, '2015-03-15 00:41:12.000000', 'temperatura', 706.0000, 'ºC'),
	(108145, 110, '2015-03-15 00:41:13.000000', 'temperatura', 1091.0000, 'ºC'),
	(108146, 110, '2015-03-15 00:41:14.000000', 'temperatura', 938.0000, 'ºC'),
	(108147, 110, '2015-03-15 00:41:15.000000', 'temperatura', 216.0000, 'ºC'),
	(108148, 110, '2015-03-15 00:41:16.000000', 'temperatura', 667.0000, 'ºC'),
	(108149, 110, '2015-03-15 00:41:17.000000', 'temperatura', 288.0000, 'ºC'),
	(108150, 110, '2015-03-15 00:41:18.000000', 'temperatura', 641.0000, 'ºC'),
	(108151, 110, '2015-03-15 00:41:19.000000', 'temperatura', 1139.0000, 'ºC'),
	(108152, 110, '2015-03-15 00:41:20.000000', 'temperatura', 176.0000, 'ºC'),
	(108153, 110, '2015-03-15 00:41:21.000000', 'temperatura', 1060.0000, 'ºC'),
	(108154, 110, '2015-03-15 00:41:22.000000', 'temperatura', 1175.0000, 'ºC'),
	(108155, 110, '2015-03-15 00:41:23.000000', 'temperatura', 295.0000, 'ºC'),
	(108156, 110, '2015-03-15 00:41:24.000000', 'temperatura', 351.0000, 'ºC'),
	(108157, 110, '2015-03-15 00:41:25.000000', 'temperatura', 871.0000, 'ºC'),
	(108158, 110, '2015-03-15 00:41:26.000000', 'temperatura', 904.0000, 'ºC'),
	(108159, 110, '2015-03-15 00:41:27.000000', 'temperatura', 705.0000, 'ºC'),
	(108160, 110, '2015-03-15 00:41:28.000000', 'temperatura', 812.0000, 'ºC'),
	(108161, 110, '2015-03-15 00:41:29.000000', 'temperatura', 749.0000, 'ºC'),
	(108162, 110, '2015-03-15 00:41:30.000000', 'temperatura', 107.0000, 'ºC'),
	(108163, 110, '2015-03-15 00:41:31.000000', 'temperatura', 690.0000, 'ºC'),
	(108164, 110, '2015-03-15 00:41:32.000000', 'temperatura', 727.0000, 'ºC'),
	(108165, 110, '2015-03-15 00:41:33.000000', 'temperatura', 368.0000, 'ºC'),
	(108166, 110, '2015-03-15 00:41:34.000000', 'temperatura', 861.0000, 'ºC'),
	(108167, 110, '2015-03-15 00:41:35.000000', 'temperatura', 799.0000, 'ºC'),
	(108168, 110, '2015-03-15 00:41:36.000000', 'temperatura', 214.0000, 'ºC'),
	(108169, 110, '2015-03-15 00:41:37.000000', 'temperatura', 1072.0000, 'ºC'),
	(108170, 110, '2015-03-15 00:41:38.000000', 'temperatura', 1119.0000, 'ºC'),
	(108171, 110, '2015-03-15 00:41:39.000000', 'temperatura', 1179.0000, 'ºC'),
	(108172, 110, '2015-03-15 00:41:40.000000', 'temperatura', 140.0000, 'ºC'),
	(108173, 110, '2015-03-15 00:41:41.000000', 'temperatura', 762.0000, 'ºC'),
	(108174, 110, '2015-03-15 00:41:42.000000', 'temperatura', 991.0000, 'ºC'),
	(108175, 110, '2015-03-15 00:41:43.000000', 'temperatura', 267.0000, 'ºC'),
	(108176, 110, '2015-03-15 00:41:44.000000', 'temperatura', 766.0000, 'ºC'),
	(108177, 110, '2015-03-15 00:41:45.000000', 'temperatura', 630.0000, 'ºC'),
	(108178, 110, '2015-03-15 00:41:46.000000', 'temperatura', 851.0000, 'ºC'),
	(108179, 110, '2015-03-15 00:41:47.000000', 'temperatura', 1165.0000, 'ºC'),
	(108180, 110, '2015-03-15 00:41:48.000000', 'temperatura', 872.0000, 'ºC'),
	(108181, 110, '2015-03-15 00:41:49.000000', 'temperatura', 865.0000, 'ºC'),
	(108182, 110, '2015-03-15 00:41:50.000000', 'temperatura', 511.0000, 'ºC'),
	(108183, 110, '2015-03-15 00:41:51.000000', 'temperatura', 1160.0000, 'ºC'),
	(108184, 110, '2015-03-15 00:41:52.000000', 'temperatura', 665.0000, 'ºC'),
	(108185, 110, '2015-03-15 00:41:53.000000', 'temperatura', 1049.0000, 'ºC'),
	(108186, 110, '2015-03-15 00:41:54.000000', 'temperatura', 851.0000, 'ºC'),
	(108187, 110, '2015-03-15 00:41:55.000000', 'temperatura', 1106.0000, 'ºC'),
	(108188, 110, '2015-03-15 00:41:56.000000', 'temperatura', 578.0000, 'ºC'),
	(108189, 110, '2015-03-15 00:41:57.000000', 'temperatura', 773.0000, 'ºC'),
	(108190, 110, '2015-03-15 00:41:58.000000', 'temperatura', 933.0000, 'ºC'),
	(108191, 110, '2015-03-15 00:41:59.000000', 'temperatura', 1144.0000, 'ºC'),
	(108192, 110, '2015-03-15 00:42:00.000000', 'temperatura', 523.0000, 'ºC'),
	(108193, 110, '2015-03-15 00:42:01.000000', 'temperatura', 382.0000, 'ºC'),
	(108194, 110, '2015-03-15 00:42:02.000000', 'temperatura', 341.0000, 'ºC'),
	(108195, 110, '2015-03-15 00:42:03.000000', 'temperatura', 560.0000, 'ºC'),
	(108196, 110, '2015-03-15 00:42:04.000000', 'temperatura', 580.0000, 'ºC'),
	(108197, 110, '2015-03-15 00:42:05.000000', 'temperatura', 18.0000, 'ºC'),
	(108198, 110, '2015-03-15 00:42:06.000000', 'temperatura', 752.0000, 'ºC'),
	(108199, 110, '2015-03-15 00:42:07.000000', 'temperatura', 107.0000, 'ºC'),
	(108200, 110, '2015-03-15 00:42:08.000000', 'temperatura', 678.0000, 'ºC'),
	(108201, 110, '2015-03-15 00:42:09.000000', 'temperatura', 670.0000, 'ºC'),
	(108202, 110, '2015-03-15 00:42:10.000000', 'temperatura', 115.0000, 'ºC'),
	(108203, 110, '2015-03-15 00:42:11.000000', 'temperatura', 965.0000, 'ºC'),
	(108204, 110, '2015-03-15 00:42:12.000000', 'temperatura', 880.0000, 'ºC'),
	(108205, 110, '2015-03-15 00:42:13.000000', 'temperatura', 305.0000, 'ºC'),
	(108206, 110, '2015-03-15 00:42:14.000000', 'temperatura', 87.0000, 'ºC'),
	(108207, 110, '2015-03-15 00:42:15.000000', 'temperatura', 719.0000, 'ºC'),
	(108208, 110, '2015-03-15 00:42:16.000000', 'temperatura', 934.0000, 'ºC'),
	(108209, 110, '2015-03-15 00:42:17.000000', 'temperatura', 115.0000, 'ºC'),
	(108210, 110, '2015-03-15 00:42:18.000000', 'temperatura', 173.0000, 'ºC'),
	(108211, 110, '2015-03-15 00:42:19.000000', 'temperatura', 521.0000, 'ºC'),
	(108212, 110, '2015-03-15 00:42:20.000000', 'temperatura', 885.0000, 'ºC'),
	(108213, 110, '2015-03-15 00:42:21.000000', 'temperatura', 461.0000, 'ºC'),
	(108214, 110, '2015-03-15 00:42:22.000000', 'temperatura', 854.0000, 'ºC'),
	(108215, 110, '2015-03-15 00:42:23.000000', 'temperatura', 486.0000, 'ºC'),
	(108216, 110, '2015-03-15 00:42:24.000000', 'temperatura', 1067.0000, 'ºC'),
	(108217, 110, '2015-03-15 00:42:25.000000', 'temperatura', 277.0000, 'ºC'),
	(108218, 110, '2015-03-15 00:42:26.000000', 'temperatura', 585.0000, 'ºC'),
	(108219, 110, '2015-03-15 00:42:27.000000', 'temperatura', 894.0000, 'ºC'),
	(108220, 110, '2015-03-15 00:42:28.000000', 'temperatura', 317.0000, 'ºC'),
	(108221, 110, '2015-03-15 00:42:29.000000', 'temperatura', 104.0000, 'ºC'),
	(108222, 110, '2015-03-15 00:42:30.000000', 'temperatura', 769.0000, 'ºC'),
	(108223, 110, '2015-03-15 00:42:31.000000', 'temperatura', 1135.0000, 'ºC'),
	(108224, 110, '2015-03-15 00:42:32.000000', 'temperatura', 967.0000, 'ºC'),
	(108225, 110, '2015-03-15 00:42:33.000000', 'temperatura', 232.0000, 'ºC'),
	(108226, 110, '2015-03-15 00:42:34.000000', 'temperatura', 657.0000, 'ºC'),
	(108227, 110, '2015-03-15 00:42:35.000000', 'temperatura', 189.0000, 'ºC'),
	(108228, 110, '2015-03-15 00:42:36.000000', 'temperatura', 174.0000, 'ºC'),
	(108229, 110, '2015-03-15 00:42:37.000000', 'temperatura', 305.0000, 'ºC'),
	(108230, 110, '2015-03-15 00:42:38.000000', 'temperatura', 1002.0000, 'ºC'),
	(108231, 110, '2015-03-15 00:42:39.000000', 'temperatura', 495.0000, 'ºC'),
	(108232, 110, '2015-03-15 00:42:40.000000', 'temperatura', 669.0000, 'ºC'),
	(108233, 110, '2015-03-15 00:42:41.000000', 'temperatura', 662.0000, 'ºC'),
	(108234, 110, '2015-03-15 00:42:42.000000', 'temperatura', 104.0000, 'ºC'),
	(108235, 110, '2015-03-15 00:42:43.000000', 'temperatura', 935.0000, 'ºC'),
	(108236, 110, '2015-03-15 00:42:44.000000', 'temperatura', 764.0000, 'ºC'),
	(108237, 110, '2015-03-15 00:42:45.000000', 'temperatura', 1014.0000, 'ºC'),
	(108238, 110, '2015-03-15 00:42:46.000000', 'temperatura', 377.0000, 'ºC'),
	(108239, 110, '2015-03-15 00:42:47.000000', 'temperatura', 45.0000, 'ºC'),
	(108240, 110, '2015-03-15 00:42:48.000000', 'temperatura', 295.0000, 'ºC'),
	(108241, 110, '2015-03-15 00:42:49.000000', 'temperatura', 139.0000, 'ºC'),
	(108242, 110, '2015-03-15 00:42:50.000000', 'temperatura', 1010.0000, 'ºC'),
	(108243, 110, '2015-03-15 00:42:51.000000', 'temperatura', 1032.0000, 'ºC'),
	(108244, 110, '2015-03-15 00:42:52.000000', 'temperatura', 934.0000, 'ºC'),
	(108245, 110, '2015-03-15 00:42:53.000000', 'temperatura', 372.0000, 'ºC'),
	(108246, 110, '2015-03-15 00:42:54.000000', 'temperatura', 260.0000, 'ºC'),
	(108247, 110, '2015-03-15 00:42:55.000000', 'temperatura', 186.0000, 'ºC'),
	(108248, 110, '2015-03-15 00:42:56.000000', 'temperatura', 148.0000, 'ºC'),
	(108249, 110, '2015-03-15 00:42:57.000000', 'temperatura', 185.0000, 'ºC'),
	(108250, 110, '2015-03-15 00:42:58.000000', 'temperatura', 479.0000, 'ºC'),
	(108251, 110, '2015-03-15 00:42:59.000000', 'temperatura', 639.0000, 'ºC'),
	(108252, 110, '2015-03-15 00:43:00.000000', 'temperatura', 562.0000, 'ºC'),
	(108253, 110, '2015-03-15 00:43:01.000000', 'temperatura', 891.0000, 'ºC'),
	(108254, 110, '2015-03-15 00:43:02.000000', 'temperatura', 370.0000, 'ºC'),
	(108255, 110, '2015-03-15 00:43:03.000000', 'temperatura', 376.0000, 'ºC'),
	(108256, 110, '2015-03-15 00:43:04.000000', 'temperatura', 773.0000, 'ºC'),
	(108257, 110, '2015-03-15 00:43:05.000000', 'temperatura', 336.0000, 'ºC'),
	(108258, 110, '2015-03-15 00:43:06.000000', 'temperatura', 560.0000, 'ºC'),
	(108259, 110, '2015-03-15 00:43:07.000000', 'temperatura', 593.0000, 'ºC'),
	(108260, 110, '2015-03-15 00:43:08.000000', 'temperatura', 86.0000, 'ºC'),
	(108261, 110, '2015-03-15 00:43:09.000000', 'temperatura', 1053.0000, 'ºC'),
	(108262, 110, '2015-03-15 00:43:10.000000', 'temperatura', 207.0000, 'ºC'),
	(108263, 110, '2015-03-15 00:43:11.000000', 'temperatura', 277.0000, 'ºC'),
	(108264, 110, '2015-03-15 00:43:12.000000', 'temperatura', 764.0000, 'ºC'),
	(108265, 110, '2015-03-15 00:43:13.000000', 'temperatura', 591.0000, 'ºC'),
	(108266, 110, '2015-03-15 00:43:14.000000', 'temperatura', 663.0000, 'ºC'),
	(108267, 110, '2015-03-15 00:43:15.000000', 'temperatura', 340.0000, 'ºC'),
	(108268, 110, '2015-03-15 00:43:16.000000', 'temperatura', 915.0000, 'ºC'),
	(108269, 110, '2015-03-15 00:43:17.000000', 'temperatura', 1154.0000, 'ºC'),
	(108270, 110, '2015-03-15 00:43:18.000000', 'temperatura', 625.0000, 'ºC'),
	(108271, 110, '2015-03-15 00:43:19.000000', 'temperatura', 865.0000, 'ºC'),
	(108272, 110, '2015-03-15 00:43:20.000000', 'temperatura', 48.0000, 'ºC'),
	(108273, 110, '2015-03-15 00:43:21.000000', 'temperatura', 45.0000, 'ºC'),
	(108274, 110, '2015-03-15 00:43:22.000000', 'temperatura', 83.0000, 'ºC'),
	(108275, 110, '2015-03-15 00:43:23.000000', 'temperatura', 281.0000, 'ºC'),
	(108276, 110, '2015-03-15 00:43:24.000000', 'temperatura', 1158.0000, 'ºC'),
	(108277, 110, '2015-03-15 00:43:25.000000', 'temperatura', 145.0000, 'ºC'),
	(108278, 110, '2015-03-15 00:43:26.000000', 'temperatura', 853.0000, 'ºC'),
	(108279, 110, '2015-03-15 00:43:27.000000', 'temperatura', 229.0000, 'ºC'),
	(108280, 110, '2015-03-15 00:43:28.000000', 'temperatura', 986.0000, 'ºC'),
	(108281, 110, '2015-03-15 00:43:29.000000', 'temperatura', 645.0000, 'ºC'),
	(108282, 110, '2015-03-15 00:43:30.000000', 'temperatura', 265.0000, 'ºC'),
	(108283, 110, '2015-03-15 00:43:31.000000', 'temperatura', 593.0000, 'ºC'),
	(108284, 110, '2015-03-15 00:43:32.000000', 'temperatura', 969.0000, 'ºC'),
	(108285, 110, '2015-03-15 00:43:33.000000', 'temperatura', 669.0000, 'ºC'),
	(108286, 110, '2015-03-15 00:43:34.000000', 'temperatura', 437.0000, 'ºC'),
	(108287, 110, '2015-03-15 00:43:35.000000', 'temperatura', 180.0000, 'ºC'),
	(108288, 110, '2015-03-15 00:43:36.000000', 'temperatura', 788.0000, 'ºC'),
	(108289, 110, '2015-03-15 00:43:37.000000', 'temperatura', 1000.0000, 'ºC'),
	(108290, 110, '2015-03-15 00:43:38.000000', 'temperatura', 239.0000, 'ºC'),
	(108291, 110, '2015-03-15 00:43:39.000000', 'temperatura', 595.0000, 'ºC'),
	(108292, 110, '2015-03-15 00:43:40.000000', 'temperatura', 1058.0000, 'ºC'),
	(108293, 110, '2015-03-15 00:43:41.000000', 'temperatura', 1106.0000, 'ºC'),
	(108294, 110, '2015-03-15 00:43:42.000000', 'temperatura', 1156.0000, 'ºC'),
	(108295, 110, '2015-03-15 00:43:43.000000', 'temperatura', 62.0000, 'ºC'),
	(108296, 110, '2015-03-15 00:43:44.000000', 'temperatura', 443.0000, 'ºC'),
	(108297, 110, '2015-03-15 00:43:45.000000', 'temperatura', 830.0000, 'ºC'),
	(108298, 110, '2015-03-15 00:43:46.000000', 'temperatura', 419.0000, 'ºC'),
	(108299, 110, '2015-03-15 00:43:47.000000', 'temperatura', 807.0000, 'ºC'),
	(108300, 110, '2015-03-15 00:43:48.000000', 'temperatura', 381.0000, 'ºC'),
	(108301, 110, '2015-03-15 00:43:49.000000', 'temperatura', 681.0000, 'ºC'),
	(108302, 110, '2015-03-15 00:43:50.000000', 'temperatura', 1062.0000, 'ºC'),
	(108303, 110, '2015-03-15 00:43:51.000000', 'temperatura', 869.0000, 'ºC'),
	(108304, 110, '2015-03-15 00:43:52.000000', 'temperatura', 1159.0000, 'ºC'),
	(108305, 110, '2015-03-15 00:43:53.000000', 'temperatura', 790.0000, 'ºC'),
	(108306, 110, '2015-03-15 00:43:54.000000', 'temperatura', 471.0000, 'ºC'),
	(108307, 110, '2015-03-15 00:43:55.000000', 'temperatura', 1188.0000, 'ºC'),
	(108308, 110, '2015-03-15 00:43:56.000000', 'temperatura', 926.0000, 'ºC'),
	(108309, 110, '2015-03-15 00:43:57.000000', 'temperatura', 1067.0000, 'ºC'),
	(108310, 110, '2015-03-15 00:43:58.000000', 'temperatura', 156.0000, 'ºC'),
	(108311, 110, '2015-03-15 00:43:59.000000', 'temperatura', 1180.0000, 'ºC'),
	(108312, 110, '2015-03-15 00:44:00.000000', 'temperatura', 633.0000, 'ºC'),
	(108313, 110, '2015-03-15 00:44:01.000000', 'temperatura', 825.0000, 'ºC'),
	(108314, 110, '2015-03-15 00:44:02.000000', 'temperatura', 1027.0000, 'ºC'),
	(108315, 110, '2015-03-15 00:44:03.000000', 'temperatura', 259.0000, 'ºC'),
	(108316, 110, '2015-03-15 00:44:04.000000', 'temperatura', 616.0000, 'ºC'),
	(108317, 110, '2015-03-15 00:44:05.000000', 'temperatura', 1103.0000, 'ºC'),
	(108318, 110, '2015-03-15 00:44:06.000000', 'temperatura', 69.0000, 'ºC'),
	(108319, 110, '2015-03-15 00:44:07.000000', 'temperatura', 634.0000, 'ºC'),
	(108320, 110, '2015-03-15 00:44:08.000000', 'temperatura', 564.0000, 'ºC'),
	(108321, 110, '2015-03-15 00:44:09.000000', 'temperatura', 919.0000, 'ºC'),
	(108322, 110, '2015-03-15 00:44:10.000000', 'temperatura', 503.0000, 'ºC'),
	(108323, 110, '2015-03-15 00:44:11.000000', 'temperatura', 958.0000, 'ºC'),
	(108324, 110, '2015-03-15 00:44:12.000000', 'temperatura', 881.0000, 'ºC'),
	(108325, 110, '2015-03-15 00:44:13.000000', 'temperatura', 331.0000, 'ºC'),
	(108326, 110, '2015-03-15 00:44:14.000000', 'temperatura', 212.0000, 'ºC'),
	(108327, 110, '2015-03-15 00:44:15.000000', 'temperatura', 70.0000, 'ºC'),
	(108328, 110, '2015-03-15 00:44:16.000000', 'temperatura', 912.0000, 'ºC'),
	(108329, 110, '2015-03-15 00:44:17.000000', 'temperatura', 751.0000, 'ºC'),
	(108330, 110, '2015-03-15 00:44:18.000000', 'temperatura', 1018.0000, 'ºC'),
	(108331, 110, '2015-03-15 00:44:19.000000', 'temperatura', 440.0000, 'ºC'),
	(108332, 110, '2015-03-15 00:44:20.000000', 'temperatura', 346.0000, 'ºC'),
	(108333, 110, '2015-03-15 00:44:21.000000', 'temperatura', 408.0000, 'ºC'),
	(108334, 110, '2015-03-15 00:44:22.000000', 'temperatura', 1005.0000, 'ºC'),
	(108335, 110, '2015-03-15 00:44:23.000000', 'temperatura', 202.0000, 'ºC'),
	(108336, 110, '2015-03-15 00:44:24.000000', 'temperatura', 396.0000, 'ºC'),
	(108337, 110, '2015-03-15 00:44:25.000000', 'temperatura', 174.0000, 'ºC'),
	(108338, 110, '2015-03-15 00:44:26.000000', 'temperatura', 884.0000, 'ºC'),
	(108339, 110, '2015-03-15 00:44:27.000000', 'temperatura', 296.0000, 'ºC'),
	(108340, 110, '2015-03-15 00:44:28.000000', 'temperatura', 30.0000, 'ºC'),
	(108341, 110, '2015-03-15 00:44:29.000000', 'temperatura', 464.0000, 'ºC'),
	(108342, 110, '2015-03-15 00:44:30.000000', 'temperatura', 1027.0000, 'ºC'),
	(108343, 110, '2015-03-15 00:44:31.000000', 'temperatura', 146.0000, 'ºC'),
	(108344, 110, '2015-03-15 00:44:32.000000', 'temperatura', 51.0000, 'ºC'),
	(108345, 110, '2015-03-15 00:44:33.000000', 'temperatura', 1016.0000, 'ºC'),
	(108346, 110, '2015-03-15 00:44:34.000000', 'temperatura', 126.0000, 'ºC'),
	(108347, 110, '2015-03-15 00:44:35.000000', 'temperatura', 1182.0000, 'ºC'),
	(108348, 110, '2015-03-15 00:44:36.000000', 'temperatura', 734.0000, 'ºC'),
	(108349, 110, '2015-03-15 00:44:37.000000', 'temperatura', 126.0000, 'ºC'),
	(108350, 110, '2015-03-15 00:44:38.000000', 'temperatura', 827.0000, 'ºC'),
	(108351, 110, '2015-03-15 00:44:39.000000', 'temperatura', 158.0000, 'ºC'),
	(108352, 110, '2015-03-15 00:44:40.000000', 'temperatura', 708.0000, 'ºC'),
	(108353, 110, '2015-03-15 00:44:41.000000', 'temperatura', 667.0000, 'ºC'),
	(108354, 110, '2015-03-15 00:44:42.000000', 'temperatura', 12.0000, 'ºC'),
	(108355, 110, '2015-03-15 00:44:43.000000', 'temperatura', 461.0000, 'ºC'),
	(108356, 110, '2015-03-15 00:44:44.000000', 'temperatura', 1069.0000, 'ºC'),
	(108357, 110, '2015-03-15 00:44:45.000000', 'temperatura', 361.0000, 'ºC'),
	(108358, 110, '2015-03-15 00:44:46.000000', 'temperatura', 1000.0000, 'ºC'),
	(108359, 110, '2015-03-15 00:44:47.000000', 'temperatura', 318.0000, 'ºC'),
	(108360, 110, '2015-03-15 00:44:48.000000', 'temperatura', 988.0000, 'ºC'),
	(108361, 110, '2015-03-15 00:44:49.000000', 'temperatura', 387.0000, 'ºC'),
	(108362, 110, '2015-03-15 00:44:50.000000', 'temperatura', 173.0000, 'ºC'),
	(108363, 110, '2015-03-15 00:44:51.000000', 'temperatura', 905.0000, 'ºC'),
	(108364, 110, '2015-03-15 00:44:52.000000', 'temperatura', 407.0000, 'ºC'),
	(108365, 110, '2015-03-15 00:44:53.000000', 'temperatura', 518.0000, 'ºC'),
	(108366, 110, '2015-03-15 00:44:54.000000', 'temperatura', 173.0000, 'ºC'),
	(108367, 110, '2015-03-15 00:44:55.000000', 'temperatura', 508.0000, 'ºC'),
	(108368, 110, '2015-03-15 00:44:56.000000', 'temperatura', 825.0000, 'ºC'),
	(108369, 110, '2015-03-15 00:44:57.000000', 'temperatura', 199.0000, 'ºC'),
	(108370, 110, '2015-03-15 00:44:58.000000', 'temperatura', 922.0000, 'ºC'),
	(108371, 110, '2015-03-15 00:44:59.000000', 'temperatura', 414.0000, 'ºC'),
	(108372, 110, '2015-03-15 00:45:00.000000', 'temperatura', 506.0000, 'ºC'),
	(108373, 110, '2015-03-15 00:45:01.000000', 'temperatura', 85.0000, 'ºC'),
	(108374, 110, '2015-03-15 00:45:02.000000', 'temperatura', 109.0000, 'ºC'),
	(108375, 110, '2015-03-15 00:45:03.000000', 'temperatura', 289.0000, 'ºC'),
	(108376, 110, '2015-03-15 00:45:04.000000', 'temperatura', 1119.0000, 'ºC'),
	(108377, 110, '2015-03-15 00:45:05.000000', 'temperatura', 1128.0000, 'ºC'),
	(108378, 110, '2015-03-15 00:45:06.000000', 'temperatura', 1085.0000, 'ºC'),
	(108379, 110, '2015-03-15 00:45:07.000000', 'temperatura', 843.0000, 'ºC'),
	(108380, 110, '2015-03-15 00:45:08.000000', 'temperatura', 958.0000, 'ºC'),
	(108381, 110, '2015-03-15 00:45:09.000000', 'temperatura', 1060.0000, 'ºC'),
	(108382, 110, '2015-03-15 00:45:10.000000', 'temperatura', 30.0000, 'ºC'),
	(108383, 110, '2015-03-15 00:45:11.000000', 'temperatura', 567.0000, 'ºC'),
	(108384, 110, '2015-03-15 00:45:12.000000', 'temperatura', 348.0000, 'ºC'),
	(108385, 110, '2015-03-15 00:45:13.000000', 'temperatura', 39.0000, 'ºC'),
	(108386, 110, '2015-03-15 00:45:14.000000', 'temperatura', 353.0000, 'ºC'),
	(108387, 110, '2015-03-15 00:45:15.000000', 'temperatura', 449.0000, 'ºC'),
	(108388, 110, '2015-03-15 00:45:16.000000', 'temperatura', 1186.0000, 'ºC'),
	(108389, 110, '2015-03-15 00:45:17.000000', 'temperatura', 985.0000, 'ºC'),
	(108390, 110, '2015-03-15 00:45:18.000000', 'temperatura', 167.0000, 'ºC'),
	(108391, 110, '2015-03-15 00:45:19.000000', 'temperatura', 279.0000, 'ºC'),
	(108392, 110, '2015-03-15 00:45:20.000000', 'temperatura', 897.0000, 'ºC'),
	(108393, 110, '2015-03-15 00:45:21.000000', 'temperatura', 47.0000, 'ºC'),
	(108394, 110, '2015-03-15 00:45:22.000000', 'temperatura', 1145.0000, 'ºC'),
	(108395, 110, '2015-03-15 00:45:23.000000', 'temperatura', 783.0000, 'ºC'),
	(108396, 110, '2015-03-15 00:45:24.000000', 'temperatura', 481.0000, 'ºC'),
	(108397, 110, '2015-03-15 00:45:25.000000', 'temperatura', 59.0000, 'ºC'),
	(108398, 110, '2015-03-15 00:45:26.000000', 'temperatura', 50.0000, 'ºC'),
	(108399, 110, '2015-03-15 00:45:27.000000', 'temperatura', 75.0000, 'ºC'),
	(108400, 110, '2015-03-15 00:45:28.000000', 'temperatura', 226.0000, 'ºC'),
	(108401, 110, '2015-03-15 00:45:29.000000', 'temperatura', 907.0000, 'ºC'),
	(108402, 110, '2015-03-15 00:45:30.000000', 'temperatura', 255.0000, 'ºC'),
	(108403, 110, '2015-03-15 00:45:31.000000', 'temperatura', 955.0000, 'ºC'),
	(108404, 110, '2015-03-15 00:45:32.000000', 'temperatura', 410.0000, 'ºC'),
	(108405, 110, '2015-03-15 00:45:33.000000', 'temperatura', 385.0000, 'ºC'),
	(108406, 110, '2015-03-15 00:45:34.000000', 'temperatura', 698.0000, 'ºC'),
	(108407, 110, '2015-03-15 00:45:35.000000', 'temperatura', 1134.0000, 'ºC'),
	(108408, 110, '2015-03-15 00:45:36.000000', 'temperatura', 1175.0000, 'ºC'),
	(108409, 110, '2015-03-15 00:45:37.000000', 'temperatura', 73.0000, 'ºC'),
	(108410, 110, '2015-03-15 00:45:38.000000', 'temperatura', 440.0000, 'ºC'),
	(108411, 110, '2015-03-15 00:45:39.000000', 'temperatura', 784.0000, 'ºC'),
	(108412, 110, '2015-03-15 00:45:40.000000', 'temperatura', 200.0000, 'ºC'),
	(108413, 110, '2015-03-15 00:45:41.000000', 'temperatura', 1049.0000, 'ºC'),
	(108414, 110, '2015-03-15 00:45:42.000000', 'temperatura', 1047.0000, 'ºC'),
	(108415, 110, '2015-03-15 00:45:43.000000', 'temperatura', 887.0000, 'ºC'),
	(108416, 110, '2015-03-15 00:45:44.000000', 'temperatura', 93.0000, 'ºC'),
	(108417, 110, '2015-03-15 00:45:45.000000', 'temperatura', 205.0000, 'ºC'),
	(108418, 110, '2015-03-15 00:45:46.000000', 'temperatura', 748.0000, 'ºC'),
	(108419, 110, '2015-03-15 00:45:47.000000', 'temperatura', 725.0000, 'ºC'),
	(108420, 110, '2015-03-15 00:45:48.000000', 'temperatura', 183.0000, 'ºC'),
	(108421, 110, '2015-03-15 00:45:49.000000', 'temperatura', 1139.0000, 'ºC'),
	(108422, 110, '2015-03-15 00:45:50.000000', 'temperatura', 346.0000, 'ºC'),
	(108423, 110, '2015-03-15 00:45:51.000000', 'temperatura', 714.0000, 'ºC'),
	(108424, 110, '2015-03-15 00:45:52.000000', 'temperatura', 133.0000, 'ºC'),
	(108425, 110, '2015-03-15 00:45:53.000000', 'temperatura', 922.0000, 'ºC'),
	(108426, 110, '2015-03-15 00:45:54.000000', 'temperatura', 611.0000, 'ºC'),
	(108427, 110, '2015-03-15 00:45:55.000000', 'temperatura', 288.0000, 'ºC'),
	(108428, 110, '2015-03-15 00:45:56.000000', 'temperatura', 810.0000, 'ºC'),
	(108429, 110, '2015-03-15 00:45:57.000000', 'temperatura', 788.0000, 'ºC'),
	(108430, 110, '2015-03-15 00:45:58.000000', 'temperatura', 307.0000, 'ºC'),
	(108431, 110, '2015-03-15 00:45:59.000000', 'temperatura', 374.0000, 'ºC'),
	(108432, 110, '2015-03-15 00:46:00.000000', 'temperatura', 947.0000, 'ºC'),
	(108433, 110, '2015-03-15 00:46:01.000000', 'temperatura', 14.0000, 'ºC'),
	(108434, 110, '2015-03-15 00:46:02.000000', 'temperatura', 831.0000, 'ºC'),
	(108435, 110, '2015-03-15 00:46:03.000000', 'temperatura', 511.0000, 'ºC'),
	(108436, 110, '2015-03-15 00:46:04.000000', 'temperatura', 64.0000, 'ºC'),
	(108437, 110, '2015-03-15 00:46:05.000000', 'temperatura', 1189.0000, 'ºC'),
	(108438, 110, '2015-03-15 00:46:06.000000', 'temperatura', 951.0000, 'ºC'),
	(108439, 110, '2015-03-15 00:46:07.000000', 'temperatura', 1190.0000, 'ºC'),
	(108440, 110, '2015-03-15 00:46:08.000000', 'temperatura', 698.0000, 'ºC'),
	(108441, 110, '2015-03-15 00:46:09.000000', 'temperatura', 1119.0000, 'ºC'),
	(108442, 110, '2015-03-15 00:46:10.000000', 'temperatura', 1102.0000, 'ºC'),
	(108443, 110, '2015-03-15 00:46:11.000000', 'temperatura', 953.0000, 'ºC'),
	(108444, 110, '2015-03-15 00:46:12.000000', 'temperatura', 258.0000, 'ºC'),
	(108445, 110, '2015-03-15 00:46:13.000000', 'temperatura', 834.0000, 'ºC'),
	(108446, 110, '2015-03-15 00:46:14.000000', 'temperatura', 996.0000, 'ºC'),
	(108447, 110, '2015-03-15 00:46:15.000000', 'temperatura', 76.0000, 'ºC'),
	(108448, 110, '2015-03-15 00:46:16.000000', 'temperatura', 995.0000, 'ºC'),
	(108449, 110, '2015-03-15 00:46:17.000000', 'temperatura', 1147.0000, 'ºC'),
	(108450, 110, '2015-03-15 00:46:18.000000', 'temperatura', 350.0000, 'ºC'),
	(108451, 110, '2015-03-15 00:46:19.000000', 'temperatura', 708.0000, 'ºC'),
	(108452, 110, '2015-03-15 00:46:20.000000', 'temperatura', 94.0000, 'ºC'),
	(108453, 110, '2015-03-15 00:46:21.000000', 'temperatura', 744.0000, 'ºC'),
	(108454, 110, '2015-03-15 00:46:22.000000', 'temperatura', 1039.0000, 'ºC'),
	(108455, 110, '2015-03-15 00:46:23.000000', 'temperatura', 565.0000, 'ºC'),
	(108456, 110, '2015-03-15 00:46:24.000000', 'temperatura', 907.0000, 'ºC'),
	(108457, 110, '2015-03-15 00:46:25.000000', 'temperatura', 441.0000, 'ºC'),
	(108458, 110, '2015-03-15 00:46:26.000000', 'temperatura', 684.0000, 'ºC'),
	(108459, 110, '2015-03-15 00:46:27.000000', 'temperatura', 897.0000, 'ºC'),
	(108460, 110, '2015-03-15 00:46:28.000000', 'temperatura', 35.0000, 'ºC'),
	(108461, 110, '2015-03-15 00:46:29.000000', 'temperatura', 1083.0000, 'ºC'),
	(108462, 110, '2015-03-15 00:46:30.000000', 'temperatura', 512.0000, 'ºC'),
	(108463, 110, '2015-03-15 00:46:31.000000', 'temperatura', 512.0000, 'ºC'),
	(108464, 110, '2015-03-15 00:46:32.000000', 'temperatura', 1022.0000, 'ºC'),
	(108465, 110, '2015-03-15 00:46:33.000000', 'temperatura', 1177.0000, 'ºC'),
	(108466, 110, '2015-03-15 00:46:34.000000', 'temperatura', 418.0000, 'ºC'),
	(108467, 110, '2015-03-15 00:46:35.000000', 'temperatura', 958.0000, 'ºC'),
	(108468, 110, '2015-03-15 00:46:36.000000', 'temperatura', 1138.0000, 'ºC'),
	(108469, 110, '2015-03-15 00:46:37.000000', 'temperatura', 418.0000, 'ºC'),
	(108470, 110, '2015-03-15 00:46:38.000000', 'temperatura', 1074.0000, 'ºC'),
	(108471, 110, '2015-03-15 00:46:39.000000', 'temperatura', 516.0000, 'ºC'),
	(108472, 110, '2015-03-15 00:46:40.000000', 'temperatura', 560.0000, 'ºC'),
	(108473, 110, '2015-03-15 00:46:41.000000', 'temperatura', 52.0000, 'ºC'),
	(108474, 110, '2015-03-15 00:46:42.000000', 'temperatura', 980.0000, 'ºC'),
	(108475, 110, '2015-03-15 00:46:43.000000', 'temperatura', 1144.0000, 'ºC'),
	(108476, 110, '2015-03-15 00:46:44.000000', 'temperatura', 380.0000, 'ºC'),
	(108477, 110, '2015-03-15 00:46:45.000000', 'temperatura', 871.0000, 'ºC'),
	(108478, 110, '2015-03-15 00:46:46.000000', 'temperatura', 814.0000, 'ºC'),
	(108479, 110, '2015-03-15 00:46:47.000000', 'temperatura', 257.0000, 'ºC'),
	(108480, 110, '2015-03-15 00:46:48.000000', 'temperatura', 46.0000, 'ºC'),
	(108481, 110, '2015-03-15 00:46:49.000000', 'temperatura', 656.0000, 'ºC'),
	(108482, 110, '2015-03-15 00:46:50.000000', 'temperatura', 745.0000, 'ºC'),
	(108483, 110, '2015-03-15 00:46:51.000000', 'temperatura', 558.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(108484, 110, '2015-03-15 00:46:52.000000', 'temperatura', 556.0000, 'ºC'),
	(108485, 110, '2015-03-15 00:46:53.000000', 'temperatura', 1106.0000, 'ºC'),
	(108486, 110, '2015-03-15 00:46:54.000000', 'temperatura', 260.0000, 'ºC'),
	(108487, 110, '2015-03-15 00:46:55.000000', 'temperatura', 385.0000, 'ºC'),
	(108488, 110, '2015-03-15 00:46:56.000000', 'temperatura', 1145.0000, 'ºC'),
	(108489, 110, '2015-03-15 00:46:57.000000', 'temperatura', 969.0000, 'ºC'),
	(108490, 110, '2015-03-15 00:46:58.000000', 'temperatura', 211.0000, 'ºC'),
	(108491, 110, '2015-03-15 00:46:59.000000', 'temperatura', 549.0000, 'ºC'),
	(108492, 110, '2015-03-15 00:47:00.000000', 'temperatura', 911.0000, 'ºC'),
	(108493, 110, '2015-03-15 00:47:01.000000', 'temperatura', 509.0000, 'ºC'),
	(108494, 110, '2015-03-15 00:47:02.000000', 'temperatura', 1014.0000, 'ºC'),
	(108495, 110, '2015-03-15 00:47:03.000000', 'temperatura', 1141.0000, 'ºC'),
	(108496, 110, '2015-03-15 00:47:04.000000', 'temperatura', 263.0000, 'ºC'),
	(108497, 110, '2015-03-15 00:47:05.000000', 'temperatura', 294.0000, 'ºC'),
	(108498, 110, '2015-03-15 00:47:06.000000', 'temperatura', 679.0000, 'ºC'),
	(108499, 110, '2015-03-15 00:47:07.000000', 'temperatura', 117.0000, 'ºC'),
	(108500, 110, '2015-03-15 00:47:08.000000', 'temperatura', 947.0000, 'ºC'),
	(108501, 110, '2015-03-15 00:47:09.000000', 'temperatura', 785.0000, 'ºC'),
	(108502, 110, '2015-03-15 00:47:10.000000', 'temperatura', 1083.0000, 'ºC'),
	(108503, 110, '2015-03-15 00:47:11.000000', 'temperatura', 662.0000, 'ºC'),
	(108504, 110, '2015-03-15 00:47:12.000000', 'temperatura', 63.0000, 'ºC'),
	(108505, 110, '2015-03-15 00:47:13.000000', 'temperatura', 728.0000, 'ºC'),
	(108506, 110, '2015-03-15 00:47:14.000000', 'temperatura', 1052.0000, 'ºC'),
	(108507, 110, '2015-03-15 00:47:15.000000', 'temperatura', 676.0000, 'ºC'),
	(108508, 110, '2015-03-15 00:47:16.000000', 'temperatura', 227.0000, 'ºC'),
	(108509, 110, '2015-03-15 00:47:17.000000', 'temperatura', 304.0000, 'ºC'),
	(108510, 110, '2015-03-15 00:47:18.000000', 'temperatura', 840.0000, 'ºC'),
	(108511, 110, '2015-03-15 00:47:19.000000', 'temperatura', 889.0000, 'ºC'),
	(108512, 110, '2015-03-15 00:47:20.000000', 'temperatura', 724.0000, 'ºC'),
	(108513, 110, '2015-03-15 00:47:21.000000', 'temperatura', 955.0000, 'ºC'),
	(108514, 110, '2015-03-15 00:47:22.000000', 'temperatura', 202.0000, 'ºC'),
	(108515, 110, '2015-03-15 00:47:23.000000', 'temperatura', 547.0000, 'ºC'),
	(108516, 110, '2015-03-15 00:47:24.000000', 'temperatura', 929.0000, 'ºC'),
	(108517, 110, '2015-03-15 00:47:25.000000', 'temperatura', 605.0000, 'ºC'),
	(108518, 110, '2015-03-15 00:47:26.000000', 'temperatura', 238.0000, 'ºC'),
	(108519, 110, '2015-03-15 00:47:27.000000', 'temperatura', 575.0000, 'ºC'),
	(108520, 110, '2015-03-15 00:47:28.000000', 'temperatura', 961.0000, 'ºC'),
	(108521, 110, '2015-03-15 00:47:29.000000', 'temperatura', 683.0000, 'ºC'),
	(108522, 110, '2015-03-15 00:47:30.000000', 'temperatura', 532.0000, 'ºC'),
	(108523, 110, '2015-03-15 00:47:31.000000', 'temperatura', 613.0000, 'ºC'),
	(108524, 110, '2015-03-15 00:47:32.000000', 'temperatura', 266.0000, 'ºC'),
	(108525, 110, '2015-03-15 00:47:33.000000', 'temperatura', 693.0000, 'ºC'),
	(108526, 110, '2015-03-15 00:47:34.000000', 'temperatura', 268.0000, 'ºC'),
	(108527, 110, '2015-03-15 00:47:35.000000', 'temperatura', 461.0000, 'ºC'),
	(108528, 110, '2015-03-15 00:47:36.000000', 'temperatura', 300.0000, 'ºC'),
	(108529, 110, '2015-03-15 00:47:37.000000', 'temperatura', 119.0000, 'ºC'),
	(108530, 110, '2015-03-15 00:47:38.000000', 'temperatura', 896.0000, 'ºC'),
	(108531, 110, '2015-03-15 00:47:39.000000', 'temperatura', 525.0000, 'ºC'),
	(108532, 110, '2015-03-15 00:47:40.000000', 'temperatura', 1136.0000, 'ºC'),
	(108533, 110, '2015-03-15 00:47:41.000000', 'temperatura', 504.0000, 'ºC'),
	(108534, 110, '2015-03-15 00:47:42.000000', 'temperatura', 312.0000, 'ºC'),
	(108535, 110, '2015-03-15 00:47:43.000000', 'temperatura', 51.0000, 'ºC'),
	(108536, 110, '2015-03-15 00:47:44.000000', 'temperatura', 518.0000, 'ºC'),
	(108537, 110, '2015-03-15 00:47:45.000000', 'temperatura', 40.0000, 'ºC'),
	(108538, 110, '2015-03-15 00:47:46.000000', 'temperatura', 1043.0000, 'ºC'),
	(108539, 110, '2015-03-15 00:47:47.000000', 'temperatura', 298.0000, 'ºC'),
	(108540, 110, '2015-03-15 00:47:48.000000', 'temperatura', 759.0000, 'ºC'),
	(108541, 110, '2015-03-15 00:47:49.000000', 'temperatura', 504.0000, 'ºC'),
	(108542, 110, '2015-03-15 00:47:50.000000', 'temperatura', 244.0000, 'ºC'),
	(108543, 110, '2015-03-15 00:47:51.000000', 'temperatura', 908.0000, 'ºC'),
	(108544, 110, '2015-03-15 00:47:52.000000', 'temperatura', 208.0000, 'ºC'),
	(108545, 110, '2015-03-15 00:47:53.000000', 'temperatura', 716.0000, 'ºC'),
	(108546, 110, '2015-03-15 00:47:54.000000', 'temperatura', 557.0000, 'ºC'),
	(108547, 110, '2015-03-15 00:47:55.000000', 'temperatura', 638.0000, 'ºC'),
	(108548, 110, '2015-03-15 00:47:56.000000', 'temperatura', 318.0000, 'ºC'),
	(108549, 110, '2015-03-15 00:47:57.000000', 'temperatura', 876.0000, 'ºC'),
	(108550, 110, '2015-03-15 00:47:58.000000', 'temperatura', 1028.0000, 'ºC'),
	(108551, 110, '2015-03-15 00:47:59.000000', 'temperatura', 114.0000, 'ºC'),
	(108552, 110, '2015-03-15 00:48:00.000000', 'temperatura', 1085.0000, 'ºC'),
	(108553, 110, '2015-03-15 00:48:01.000000', 'temperatura', 284.0000, 'ºC'),
	(108554, 110, '2015-03-15 00:48:02.000000', 'temperatura', 567.0000, 'ºC'),
	(108555, 110, '2015-03-15 00:48:03.000000', 'temperatura', 782.0000, 'ºC'),
	(108556, 110, '2015-03-15 00:48:04.000000', 'temperatura', 1008.0000, 'ºC'),
	(108557, 110, '2015-03-15 00:48:05.000000', 'temperatura', 295.0000, 'ºC'),
	(108558, 110, '2015-03-15 00:48:06.000000', 'temperatura', 852.0000, 'ºC'),
	(108559, 110, '2015-03-15 00:48:07.000000', 'temperatura', 977.0000, 'ºC'),
	(108560, 110, '2015-03-15 00:48:08.000000', 'temperatura', 1130.0000, 'ºC'),
	(108561, 110, '2015-03-15 00:48:09.000000', 'temperatura', 317.0000, 'ºC'),
	(108562, 110, '2015-03-15 00:48:10.000000', 'temperatura', 594.0000, 'ºC'),
	(108563, 110, '2015-03-15 00:48:11.000000', 'temperatura', 823.0000, 'ºC'),
	(108564, 110, '2015-03-15 00:48:12.000000', 'temperatura', 1133.0000, 'ºC'),
	(108565, 110, '2015-03-15 00:48:13.000000', 'temperatura', 797.0000, 'ºC'),
	(108566, 110, '2015-03-15 00:48:14.000000', 'temperatura', 586.0000, 'ºC'),
	(108567, 110, '2015-03-15 00:48:15.000000', 'temperatura', 539.0000, 'ºC'),
	(108568, 110, '2015-03-15 00:48:16.000000', 'temperatura', 936.0000, 'ºC'),
	(108569, 110, '2015-03-15 00:48:17.000000', 'temperatura', 663.0000, 'ºC'),
	(108570, 110, '2015-03-15 00:48:18.000000', 'temperatura', 509.0000, 'ºC'),
	(108571, 110, '2015-03-15 00:48:19.000000', 'temperatura', 556.0000, 'ºC'),
	(108572, 110, '2015-03-15 00:48:20.000000', 'temperatura', 55.0000, 'ºC'),
	(108573, 110, '2015-03-15 00:48:21.000000', 'temperatura', 1009.0000, 'ºC'),
	(108574, 110, '2015-03-15 00:48:22.000000', 'temperatura', 78.0000, 'ºC'),
	(108575, 110, '2015-03-15 00:48:23.000000', 'temperatura', 963.0000, 'ºC'),
	(108576, 110, '2015-03-15 00:48:24.000000', 'temperatura', 981.0000, 'ºC'),
	(108577, 110, '2015-03-15 00:48:25.000000', 'temperatura', 816.0000, 'ºC'),
	(108578, 110, '2015-03-15 00:48:26.000000', 'temperatura', 1137.0000, 'ºC'),
	(108579, 110, '2015-03-15 00:48:27.000000', 'temperatura', 837.0000, 'ºC'),
	(108580, 110, '2015-03-15 00:48:28.000000', 'temperatura', 777.0000, 'ºC'),
	(108581, 110, '2015-03-15 00:48:29.000000', 'temperatura', 172.0000, 'ºC'),
	(108582, 110, '2015-03-15 00:48:30.000000', 'temperatura', 929.0000, 'ºC'),
	(108583, 110, '2015-03-15 00:48:31.000000', 'temperatura', 532.0000, 'ºC'),
	(108584, 110, '2015-03-15 00:48:32.000000', 'temperatura', 1073.0000, 'ºC'),
	(108585, 110, '2015-03-15 00:48:33.000000', 'temperatura', 168.0000, 'ºC'),
	(108586, 110, '2015-03-15 00:48:34.000000', 'temperatura', 23.0000, 'ºC'),
	(108587, 110, '2015-03-15 00:48:35.000000', 'temperatura', 809.0000, 'ºC'),
	(108588, 110, '2015-03-15 00:48:36.000000', 'temperatura', 379.0000, 'ºC'),
	(108589, 110, '2015-03-15 00:48:37.000000', 'temperatura', 666.0000, 'ºC'),
	(108590, 110, '2015-03-15 00:48:38.000000', 'temperatura', 993.0000, 'ºC'),
	(108591, 110, '2015-03-15 00:48:39.000000', 'temperatura', 569.0000, 'ºC'),
	(108592, 110, '2015-03-15 00:48:40.000000', 'temperatura', 1068.0000, 'ºC'),
	(108593, 110, '2015-03-15 00:48:41.000000', 'temperatura', 33.0000, 'ºC'),
	(108594, 110, '2015-03-15 00:48:42.000000', 'temperatura', 561.0000, 'ºC'),
	(108595, 110, '2015-03-15 00:48:43.000000', 'temperatura', 307.0000, 'ºC'),
	(108596, 110, '2015-03-15 00:48:44.000000', 'temperatura', 1053.0000, 'ºC'),
	(108597, 110, '2015-03-15 00:48:45.000000', 'temperatura', 744.0000, 'ºC'),
	(108598, 110, '2015-03-15 00:48:46.000000', 'temperatura', 562.0000, 'ºC'),
	(108599, 110, '2015-03-15 00:48:47.000000', 'temperatura', 580.0000, 'ºC'),
	(108600, 110, '2015-03-15 00:48:48.000000', 'temperatura', 12.0000, 'ºC'),
	(108601, 110, '2015-03-15 00:48:49.000000', 'temperatura', 722.0000, 'ºC'),
	(108602, 110, '2015-03-15 00:48:50.000000', 'temperatura', 1176.0000, 'ºC'),
	(108603, 110, '2015-03-15 00:48:51.000000', 'temperatura', 113.0000, 'ºC'),
	(108604, 110, '2015-03-15 00:48:52.000000', 'temperatura', 638.0000, 'ºC'),
	(108605, 110, '2015-03-15 00:48:53.000000', 'temperatura', 451.0000, 'ºC'),
	(108606, 110, '2015-03-15 00:48:54.000000', 'temperatura', 340.0000, 'ºC'),
	(108607, 110, '2015-03-15 00:48:55.000000', 'temperatura', 348.0000, 'ºC'),
	(108608, 110, '2015-03-15 00:48:56.000000', 'temperatura', 721.0000, 'ºC'),
	(108609, 110, '2015-03-15 00:48:57.000000', 'temperatura', 161.0000, 'ºC'),
	(108610, 110, '2015-03-15 00:48:58.000000', 'temperatura', 1044.0000, 'ºC'),
	(108611, 110, '2015-03-15 00:48:59.000000', 'temperatura', 1136.0000, 'ºC'),
	(108612, 110, '2015-03-15 00:49:00.000000', 'temperatura', 147.0000, 'ºC'),
	(108613, 110, '2015-03-15 00:49:01.000000', 'temperatura', 931.0000, 'ºC'),
	(108614, 110, '2015-03-15 00:49:02.000000', 'temperatura', 613.0000, 'ºC'),
	(108615, 110, '2015-03-15 00:49:03.000000', 'temperatura', 271.0000, 'ºC'),
	(108616, 110, '2015-03-15 00:49:04.000000', 'temperatura', 717.0000, 'ºC'),
	(108617, 110, '2015-03-15 00:49:05.000000', 'temperatura', 372.0000, 'ºC'),
	(108618, 110, '2015-03-15 00:49:06.000000', 'temperatura', 910.0000, 'ºC'),
	(108619, 110, '2015-03-15 00:49:07.000000', 'temperatura', 1033.0000, 'ºC'),
	(108620, 110, '2015-03-15 00:49:08.000000', 'temperatura', 37.0000, 'ºC'),
	(108621, 110, '2015-03-15 00:49:09.000000', 'temperatura', 688.0000, 'ºC'),
	(108622, 110, '2015-03-15 00:49:10.000000', 'temperatura', 929.0000, 'ºC'),
	(108623, 110, '2015-03-15 00:49:11.000000', 'temperatura', 183.0000, 'ºC'),
	(108624, 110, '2015-03-15 00:49:12.000000', 'temperatura', 527.0000, 'ºC'),
	(108625, 110, '2015-03-15 00:49:13.000000', 'temperatura', 886.0000, 'ºC'),
	(108626, 110, '2015-03-15 00:49:14.000000', 'temperatura', 450.0000, 'ºC'),
	(108627, 110, '2015-03-15 00:49:15.000000', 'temperatura', 793.0000, 'ºC'),
	(108628, 110, '2015-03-15 00:49:16.000000', 'temperatura', 216.0000, 'ºC'),
	(108629, 110, '2015-03-15 00:49:17.000000', 'temperatura', 1100.0000, 'ºC'),
	(108630, 110, '2015-03-15 00:49:18.000000', 'temperatura', 54.0000, 'ºC'),
	(108631, 110, '2015-03-15 00:49:19.000000', 'temperatura', 572.0000, 'ºC'),
	(108632, 110, '2015-03-15 00:49:20.000000', 'temperatura', 297.0000, 'ºC'),
	(108633, 110, '2015-03-15 00:49:21.000000', 'temperatura', 968.0000, 'ºC'),
	(108634, 110, '2015-03-15 00:49:22.000000', 'temperatura', 352.0000, 'ºC'),
	(108635, 110, '2015-03-15 00:49:23.000000', 'temperatura', 57.0000, 'ºC'),
	(108636, 110, '2015-03-15 00:49:24.000000', 'temperatura', 430.0000, 'ºC'),
	(108637, 110, '2015-03-15 00:49:25.000000', 'temperatura', 777.0000, 'ºC'),
	(108638, 110, '2015-03-15 00:49:26.000000', 'temperatura', 194.0000, 'ºC'),
	(108639, 110, '2015-03-15 00:49:27.000000', 'temperatura', 1043.0000, 'ºC'),
	(108640, 110, '2015-03-15 00:49:28.000000', 'temperatura', 1034.0000, 'ºC'),
	(108641, 110, '2015-03-15 00:49:29.000000', 'temperatura', 839.0000, 'ºC'),
	(108642, 110, '2015-03-15 00:49:30.000000', 'temperatura', 1093.0000, 'ºC'),
	(108643, 110, '2015-03-15 00:49:31.000000', 'temperatura', 551.0000, 'ºC'),
	(108644, 110, '2015-03-15 00:49:32.000000', 'temperatura', 674.0000, 'ºC'),
	(108645, 110, '2015-03-15 00:49:33.000000', 'temperatura', 518.0000, 'ºC'),
	(108646, 110, '2015-03-15 00:49:34.000000', 'temperatura', 568.0000, 'ºC'),
	(108647, 110, '2015-03-15 00:49:35.000000', 'temperatura', 89.0000, 'ºC'),
	(108648, 110, '2015-03-15 00:49:36.000000', 'temperatura', 1141.0000, 'ºC'),
	(108649, 110, '2015-03-15 00:49:37.000000', 'temperatura', 637.0000, 'ºC'),
	(108650, 110, '2015-03-15 00:49:38.000000', 'temperatura', 965.0000, 'ºC'),
	(108651, 110, '2015-03-15 00:49:39.000000', 'temperatura', 514.0000, 'ºC'),
	(108652, 110, '2015-03-15 00:49:40.000000', 'temperatura', 875.0000, 'ºC'),
	(108653, 110, '2015-03-15 00:49:41.000000', 'temperatura', 431.0000, 'ºC'),
	(108654, 110, '2015-03-15 00:49:42.000000', 'temperatura', 734.0000, 'ºC'),
	(108655, 110, '2015-03-15 00:49:43.000000', 'temperatura', 1176.0000, 'ºC'),
	(108656, 110, '2015-03-15 00:49:44.000000', 'temperatura', 77.0000, 'ºC'),
	(108657, 110, '2015-03-15 00:49:45.000000', 'temperatura', 461.0000, 'ºC'),
	(108658, 110, '2015-03-15 00:49:46.000000', 'temperatura', 871.0000, 'ºC'),
	(108659, 110, '2015-03-15 00:49:47.000000', 'temperatura', 576.0000, 'ºC'),
	(108660, 110, '2015-03-15 00:49:48.000000', 'temperatura', 266.0000, 'ºC'),
	(108661, 110, '2015-03-15 00:49:49.000000', 'temperatura', 801.0000, 'ºC'),
	(108662, 110, '2015-03-15 00:49:50.000000', 'temperatura', 811.0000, 'ºC'),
	(108663, 110, '2015-03-15 00:49:51.000000', 'temperatura', 449.0000, 'ºC'),
	(108664, 110, '2015-03-15 00:49:52.000000', 'temperatura', 1015.0000, 'ºC'),
	(108665, 110, '2015-03-15 00:49:53.000000', 'temperatura', 127.0000, 'ºC'),
	(108666, 110, '2015-03-15 00:49:54.000000', 'temperatura', 1193.0000, 'ºC'),
	(108667, 110, '2015-03-15 00:49:55.000000', 'temperatura', 782.0000, 'ºC'),
	(108668, 110, '2015-03-15 00:49:56.000000', 'temperatura', 331.0000, 'ºC'),
	(108669, 110, '2015-03-15 00:49:57.000000', 'temperatura', 508.0000, 'ºC'),
	(108670, 110, '2015-03-15 00:49:58.000000', 'temperatura', 351.0000, 'ºC'),
	(108671, 110, '2015-03-15 00:49:59.000000', 'temperatura', 229.0000, 'ºC'),
	(108672, 110, '2015-03-15 00:50:00.000000', 'temperatura', 92.0000, 'ºC'),
	(108673, 110, '2015-03-15 00:50:01.000000', 'temperatura', 974.0000, 'ºC'),
	(108674, 110, '2015-03-15 00:50:02.000000', 'temperatura', 994.0000, 'ºC'),
	(108675, 110, '2015-03-15 00:50:03.000000', 'temperatura', 848.0000, 'ºC'),
	(108676, 110, '2015-03-15 00:50:04.000000', 'temperatura', 58.0000, 'ºC'),
	(108677, 110, '2015-03-15 00:50:05.000000', 'temperatura', 149.0000, 'ºC'),
	(108678, 110, '2015-03-15 00:50:06.000000', 'temperatura', 568.0000, 'ºC'),
	(108679, 110, '2015-03-15 00:50:07.000000', 'temperatura', 1196.0000, 'ºC'),
	(108680, 110, '2015-03-15 00:50:08.000000', 'temperatura', 676.0000, 'ºC'),
	(108681, 110, '2015-03-15 00:50:09.000000', 'temperatura', 993.0000, 'ºC'),
	(108682, 110, '2015-03-15 00:50:10.000000', 'temperatura', 537.0000, 'ºC'),
	(108683, 110, '2015-03-15 00:50:11.000000', 'temperatura', 906.0000, 'ºC'),
	(108684, 110, '2015-03-15 00:50:12.000000', 'temperatura', 521.0000, 'ºC'),
	(108685, 110, '2015-03-15 00:50:13.000000', 'temperatura', 1086.0000, 'ºC'),
	(108686, 110, '2015-03-15 00:50:14.000000', 'temperatura', 267.0000, 'ºC'),
	(108687, 110, '2015-03-15 00:50:15.000000', 'temperatura', 480.0000, 'ºC'),
	(108688, 110, '2015-03-15 00:50:16.000000', 'temperatura', 400.0000, 'ºC'),
	(108689, 110, '2015-03-15 00:50:17.000000', 'temperatura', 557.0000, 'ºC'),
	(108690, 110, '2015-03-15 00:50:18.000000', 'temperatura', 389.0000, 'ºC'),
	(108691, 110, '2015-03-15 00:50:19.000000', 'temperatura', 272.0000, 'ºC'),
	(108692, 110, '2015-03-15 00:50:20.000000', 'temperatura', 192.0000, 'ºC'),
	(108693, 110, '2015-03-15 00:50:21.000000', 'temperatura', 147.0000, 'ºC'),
	(108694, 110, '2015-03-15 00:50:22.000000', 'temperatura', 160.0000, 'ºC'),
	(108695, 110, '2015-03-15 00:50:23.000000', 'temperatura', 359.0000, 'ºC'),
	(108696, 110, '2015-03-15 00:50:24.000000', 'temperatura', 116.0000, 'ºC'),
	(108697, 110, '2015-03-15 00:50:25.000000', 'temperatura', 701.0000, 'ºC'),
	(108698, 110, '2015-03-15 00:50:26.000000', 'temperatura', 758.0000, 'ºC'),
	(108699, 110, '2015-03-15 00:50:27.000000', 'temperatura', 490.0000, 'ºC'),
	(108700, 110, '2015-03-15 00:50:28.000000', 'temperatura', 174.0000, 'ºC'),
	(108701, 110, '2015-03-15 00:50:29.000000', 'temperatura', 601.0000, 'ºC'),
	(108702, 110, '2015-03-15 00:50:30.000000', 'temperatura', 82.0000, 'ºC'),
	(108703, 110, '2015-03-15 00:50:31.000000', 'temperatura', 1011.0000, 'ºC'),
	(108704, 110, '2015-03-15 00:50:32.000000', 'temperatura', 6.0000, 'ºC'),
	(108705, 110, '2015-03-15 00:50:33.000000', 'temperatura', 599.0000, 'ºC'),
	(108706, 110, '2015-03-15 00:50:34.000000', 'temperatura', 578.0000, 'ºC'),
	(108707, 110, '2015-03-15 00:50:35.000000', 'temperatura', 1093.0000, 'ºC'),
	(108708, 110, '2015-03-15 00:50:36.000000', 'temperatura', 132.0000, 'ºC'),
	(108709, 110, '2015-03-15 00:50:37.000000', 'temperatura', 982.0000, 'ºC'),
	(108710, 110, '2015-03-15 00:50:38.000000', 'temperatura', 915.0000, 'ºC'),
	(108711, 110, '2015-03-15 00:50:39.000000', 'temperatura', 429.0000, 'ºC'),
	(108712, 110, '2015-03-15 00:50:40.000000', 'temperatura', 600.0000, 'ºC'),
	(108713, 110, '2015-03-15 00:50:41.000000', 'temperatura', 512.0000, 'ºC'),
	(108714, 110, '2015-03-15 00:50:42.000000', 'temperatura', 762.0000, 'ºC'),
	(108715, 110, '2015-03-15 00:50:43.000000', 'temperatura', 1073.0000, 'ºC'),
	(108716, 110, '2015-03-15 00:50:44.000000', 'temperatura', 681.0000, 'ºC'),
	(108717, 110, '2015-03-15 00:50:45.000000', 'temperatura', 187.0000, 'ºC'),
	(108718, 110, '2015-03-15 00:50:46.000000', 'temperatura', 92.0000, 'ºC'),
	(108719, 110, '2015-03-15 00:50:47.000000', 'temperatura', 1098.0000, 'ºC'),
	(108720, 110, '2015-03-15 00:50:48.000000', 'temperatura', 415.0000, 'ºC'),
	(108721, 110, '2015-03-15 00:50:49.000000', 'temperatura', 1181.0000, 'ºC'),
	(108722, 110, '2015-03-15 00:50:50.000000', 'temperatura', 1063.0000, 'ºC'),
	(108723, 110, '2015-03-15 00:50:51.000000', 'temperatura', 570.0000, 'ºC'),
	(108724, 110, '2015-03-15 00:50:52.000000', 'temperatura', 864.0000, 'ºC'),
	(108725, 110, '2015-03-15 00:50:53.000000', 'temperatura', 209.0000, 'ºC'),
	(108726, 110, '2015-03-15 00:50:54.000000', 'temperatura', 853.0000, 'ºC'),
	(108727, 110, '2015-03-15 00:50:55.000000', 'temperatura', 37.0000, 'ºC'),
	(108728, 110, '2015-03-15 00:50:56.000000', 'temperatura', 30.0000, 'ºC'),
	(108729, 110, '2015-03-15 00:50:57.000000', 'temperatura', 36.0000, 'ºC'),
	(108730, 110, '2015-03-15 00:50:58.000000', 'temperatura', 92.0000, 'ºC'),
	(108731, 110, '2015-03-15 00:50:59.000000', 'temperatura', 350.0000, 'ºC'),
	(108732, 110, '2015-03-15 00:51:00.000000', 'temperatura', 278.0000, 'ºC'),
	(108733, 110, '2015-03-15 00:51:01.000000', 'temperatura', 338.0000, 'ºC'),
	(108734, 110, '2015-03-15 00:51:02.000000', 'temperatura', 858.0000, 'ºC'),
	(108735, 110, '2015-03-15 00:51:03.000000', 'temperatura', 877.0000, 'ºC'),
	(108736, 110, '2015-03-15 00:51:04.000000', 'temperatura', 611.0000, 'ºC'),
	(108737, 110, '2015-03-15 00:51:05.000000', 'temperatura', 423.0000, 'ºC'),
	(108738, 110, '2015-03-15 00:51:06.000000', 'temperatura', 285.0000, 'ºC'),
	(108739, 110, '2015-03-15 00:51:07.000000', 'temperatura', 154.0000, 'ºC'),
	(108740, 110, '2015-03-15 00:51:08.000000', 'temperatura', 1115.0000, 'ºC'),
	(108741, 110, '2015-03-15 00:51:09.000000', 'temperatura', 314.0000, 'ºC'),
	(108742, 110, '2015-03-15 00:51:10.000000', 'temperatura', 624.0000, 'ºC'),
	(108743, 110, '2015-03-15 00:51:11.000000', 'temperatura', 982.0000, 'ºC'),
	(108744, 110, '2015-03-15 00:51:12.000000', 'temperatura', 635.0000, 'ºC'),
	(108745, 110, '2015-03-15 00:51:13.000000', 'temperatura', 233.0000, 'ºC'),
	(108746, 110, '2015-03-15 00:51:14.000000', 'temperatura', 457.0000, 'ºC'),
	(108747, 110, '2015-03-15 00:51:15.000000', 'temperatura', 390.0000, 'ºC'),
	(108748, 110, '2015-03-15 00:51:16.000000', 'temperatura', 578.0000, 'ºC'),
	(108749, 110, '2015-03-15 00:51:17.000000', 'temperatura', 519.0000, 'ºC'),
	(108750, 110, '2015-03-15 00:51:18.000000', 'temperatura', 865.0000, 'ºC'),
	(108751, 110, '2015-03-15 00:51:19.000000', 'temperatura', 365.0000, 'ºC'),
	(108752, 110, '2015-03-15 00:51:20.000000', 'temperatura', 431.0000, 'ºC'),
	(108753, 110, '2015-03-15 00:51:21.000000', 'temperatura', 1061.0000, 'ºC'),
	(108754, 110, '2015-03-15 00:51:22.000000', 'temperatura', 411.0000, 'ºC'),
	(108755, 110, '2015-03-15 00:51:23.000000', 'temperatura', 73.0000, 'ºC'),
	(108756, 110, '2015-03-15 00:51:24.000000', 'temperatura', 335.0000, 'ºC'),
	(108757, 110, '2015-03-15 00:51:25.000000', 'temperatura', 254.0000, 'ºC'),
	(108758, 110, '2015-03-15 00:51:26.000000', 'temperatura', 265.0000, 'ºC'),
	(108759, 110, '2015-03-15 00:51:27.000000', 'temperatura', 565.0000, 'ºC'),
	(108760, 110, '2015-03-15 00:51:28.000000', 'temperatura', 829.0000, 'ºC'),
	(108761, 110, '2015-03-15 00:51:29.000000', 'temperatura', 51.0000, 'ºC'),
	(108762, 110, '2015-03-15 00:51:30.000000', 'temperatura', 169.0000, 'ºC'),
	(108763, 110, '2015-03-15 00:51:31.000000', 'temperatura', 691.0000, 'ºC'),
	(108764, 110, '2015-03-15 00:51:32.000000', 'temperatura', 550.0000, 'ºC'),
	(108765, 110, '2015-03-15 00:51:33.000000', 'temperatura', 675.0000, 'ºC'),
	(108766, 110, '2015-03-15 00:51:34.000000', 'temperatura', 528.0000, 'ºC'),
	(108767, 110, '2015-03-15 00:51:35.000000', 'temperatura', 616.0000, 'ºC'),
	(108768, 110, '2015-03-15 00:51:36.000000', 'temperatura', 294.0000, 'ºC'),
	(108769, 110, '2015-03-15 00:51:37.000000', 'temperatura', 824.0000, 'ºC'),
	(108770, 110, '2015-03-15 00:51:38.000000', 'temperatura', 838.0000, 'ºC'),
	(108771, 110, '2015-03-15 00:51:39.000000', 'temperatura', 518.0000, 'ºC'),
	(108772, 110, '2015-03-15 00:51:40.000000', 'temperatura', 77.0000, 'ºC'),
	(108773, 110, '2015-03-15 00:51:41.000000', 'temperatura', 30.0000, 'ºC'),
	(108774, 110, '2015-03-15 00:51:42.000000', 'temperatura', 1122.0000, 'ºC'),
	(108775, 110, '2015-03-15 00:51:43.000000', 'temperatura', 721.0000, 'ºC'),
	(108776, 110, '2015-03-15 00:51:44.000000', 'temperatura', 240.0000, 'ºC'),
	(108777, 110, '2015-03-15 00:51:45.000000', 'temperatura', 238.0000, 'ºC'),
	(108778, 110, '2015-03-15 00:51:46.000000', 'temperatura', 469.0000, 'ºC'),
	(108779, 110, '2015-03-15 00:51:47.000000', 'temperatura', 434.0000, 'ºC'),
	(108780, 110, '2015-03-15 00:51:48.000000', 'temperatura', 761.0000, 'ºC'),
	(108781, 110, '2015-03-15 00:51:49.000000', 'temperatura', 105.0000, 'ºC'),
	(108782, 110, '2015-03-15 00:51:50.000000', 'temperatura', 643.0000, 'ºC'),
	(108783, 110, '2015-03-15 00:51:51.000000', 'temperatura', 500.0000, 'ºC'),
	(108784, 110, '2015-03-15 00:51:52.000000', 'temperatura', 573.0000, 'ºC'),
	(108785, 110, '2015-03-15 00:51:53.000000', 'temperatura', 165.0000, 'ºC'),
	(108786, 110, '2015-03-15 00:51:54.000000', 'temperatura', 307.0000, 'ºC'),
	(108787, 110, '2015-03-15 00:51:55.000000', 'temperatura', 1041.0000, 'ºC'),
	(108788, 110, '2015-03-15 00:51:56.000000', 'temperatura', 682.0000, 'ºC'),
	(108789, 110, '2015-03-15 00:51:57.000000', 'temperatura', 288.0000, 'ºC'),
	(108790, 110, '2015-03-15 00:51:58.000000', 'temperatura', 597.0000, 'ºC'),
	(108791, 110, '2015-03-15 00:51:59.000000', 'temperatura', 919.0000, 'ºC'),
	(108792, 110, '2015-03-15 00:52:00.000000', 'temperatura', 404.0000, 'ºC'),
	(108793, 110, '2015-03-15 00:52:01.000000', 'temperatura', 466.0000, 'ºC'),
	(108794, 110, '2015-03-15 00:52:02.000000', 'temperatura', 1116.0000, 'ºC'),
	(108795, 110, '2015-03-15 00:52:03.000000', 'temperatura', 582.0000, 'ºC'),
	(108796, 110, '2015-03-15 00:52:04.000000', 'temperatura', 765.0000, 'ºC'),
	(108797, 110, '2015-03-15 00:52:05.000000', 'temperatura', 878.0000, 'ºC'),
	(108798, 110, '2015-03-15 00:52:06.000000', 'temperatura', 897.0000, 'ºC'),
	(108799, 110, '2015-03-15 00:52:07.000000', 'temperatura', 650.0000, 'ºC'),
	(108800, 110, '2015-03-15 00:52:08.000000', 'temperatura', 562.0000, 'ºC'),
	(108801, 110, '2015-03-15 00:52:09.000000', 'temperatura', 858.0000, 'ºC'),
	(108802, 110, '2015-03-15 00:52:10.000000', 'temperatura', 203.0000, 'ºC'),
	(108803, 110, '2015-03-15 00:52:11.000000', 'temperatura', 844.0000, 'ºC'),
	(108804, 110, '2015-03-15 00:52:12.000000', 'temperatura', 9.0000, 'ºC'),
	(108805, 110, '2015-03-15 00:52:13.000000', 'temperatura', 1115.0000, 'ºC'),
	(108806, 110, '2015-03-15 00:52:14.000000', 'temperatura', 747.0000, 'ºC'),
	(108807, 110, '2015-03-15 00:52:15.000000', 'temperatura', 390.0000, 'ºC'),
	(108808, 110, '2015-03-15 00:52:16.000000', 'temperatura', 912.0000, 'ºC'),
	(108809, 110, '2015-03-15 00:52:17.000000', 'temperatura', 989.0000, 'ºC'),
	(108810, 110, '2015-03-15 00:52:18.000000', 'temperatura', 1010.0000, 'ºC'),
	(108811, 110, '2015-03-15 00:52:19.000000', 'temperatura', 884.0000, 'ºC'),
	(108812, 110, '2015-03-15 00:52:20.000000', 'temperatura', 189.0000, 'ºC'),
	(108813, 110, '2015-03-15 00:52:21.000000', 'temperatura', 693.0000, 'ºC'),
	(108814, 110, '2015-03-15 00:52:22.000000', 'temperatura', 497.0000, 'ºC'),
	(108815, 110, '2015-03-15 00:52:23.000000', 'temperatura', 410.0000, 'ºC'),
	(108816, 110, '2015-03-15 00:52:24.000000', 'temperatura', 558.0000, 'ºC'),
	(108817, 110, '2015-03-15 00:52:25.000000', 'temperatura', 361.0000, 'ºC'),
	(108818, 110, '2015-03-15 00:52:26.000000', 'temperatura', 132.0000, 'ºC'),
	(108819, 110, '2015-03-15 00:52:27.000000', 'temperatura', 777.0000, 'ºC'),
	(108820, 110, '2015-03-15 00:52:28.000000', 'temperatura', 1089.0000, 'ºC'),
	(108821, 110, '2015-03-15 00:52:29.000000', 'temperatura', 715.0000, 'ºC'),
	(108822, 110, '2015-03-15 00:52:30.000000', 'temperatura', 308.0000, 'ºC'),
	(108823, 110, '2015-03-15 00:52:31.000000', 'temperatura', 598.0000, 'ºC'),
	(108824, 110, '2015-03-15 00:52:32.000000', 'temperatura', 863.0000, 'ºC'),
	(108825, 110, '2015-03-15 00:52:33.000000', 'temperatura', 124.0000, 'ºC'),
	(108826, 110, '2015-03-15 00:52:34.000000', 'temperatura', 432.0000, 'ºC'),
	(108827, 110, '2015-03-15 00:52:35.000000', 'temperatura', 588.0000, 'ºC'),
	(108828, 110, '2015-03-15 00:52:36.000000', 'temperatura', 446.0000, 'ºC'),
	(108829, 110, '2015-03-15 00:52:37.000000', 'temperatura', 465.0000, 'ºC'),
	(108830, 110, '2015-03-15 00:52:38.000000', 'temperatura', 990.0000, 'ºC'),
	(108831, 110, '2015-03-15 00:52:39.000000', 'temperatura', 1153.0000, 'ºC'),
	(108832, 110, '2015-03-15 00:52:40.000000', 'temperatura', 396.0000, 'ºC'),
	(108833, 110, '2015-03-15 00:52:41.000000', 'temperatura', 923.0000, 'ºC'),
	(108834, 110, '2015-03-15 00:52:42.000000', 'temperatura', 1025.0000, 'ºC'),
	(108835, 110, '2015-03-15 00:52:43.000000', 'temperatura', 1157.0000, 'ºC'),
	(108836, 110, '2015-03-15 00:52:44.000000', 'temperatura', 310.0000, 'ºC'),
	(108837, 110, '2015-03-15 00:52:45.000000', 'temperatura', 482.0000, 'ºC'),
	(108838, 110, '2015-03-15 00:52:46.000000', 'temperatura', 279.0000, 'ºC'),
	(108839, 110, '2015-03-15 00:52:47.000000', 'temperatura', 1149.0000, 'ºC'),
	(108840, 110, '2015-03-15 00:52:48.000000', 'temperatura', 110.0000, 'ºC'),
	(108841, 110, '2015-03-15 00:52:49.000000', 'temperatura', 704.0000, 'ºC'),
	(108842, 110, '2015-03-15 00:52:50.000000', 'temperatura', 790.0000, 'ºC'),
	(108843, 110, '2015-03-15 00:52:51.000000', 'temperatura', 639.0000, 'ºC'),
	(108844, 110, '2015-03-15 00:52:52.000000', 'temperatura', 826.0000, 'ºC'),
	(108845, 110, '2015-03-15 00:52:53.000000', 'temperatura', 1012.0000, 'ºC'),
	(108846, 110, '2015-03-15 00:52:54.000000', 'temperatura', 185.0000, 'ºC'),
	(108847, 110, '2015-03-15 00:52:55.000000', 'temperatura', 289.0000, 'ºC'),
	(108848, 110, '2015-03-15 00:52:56.000000', 'temperatura', 888.0000, 'ºC'),
	(108849, 110, '2015-03-15 00:52:57.000000', 'temperatura', 1175.0000, 'ºC'),
	(108850, 110, '2015-03-15 00:52:58.000000', 'temperatura', 812.0000, 'ºC'),
	(108851, 110, '2015-03-15 00:52:59.000000', 'temperatura', 534.0000, 'ºC'),
	(108852, 110, '2015-03-15 00:53:00.000000', 'temperatura', 237.0000, 'ºC'),
	(108853, 110, '2015-03-15 00:53:01.000000', 'temperatura', 784.0000, 'ºC'),
	(108854, 110, '2015-03-15 00:53:02.000000', 'temperatura', 807.0000, 'ºC'),
	(108855, 110, '2015-03-15 00:53:03.000000', 'temperatura', 484.0000, 'ºC'),
	(108856, 110, '2015-03-15 00:53:04.000000', 'temperatura', 1.0000, 'ºC'),
	(108857, 110, '2015-03-15 00:53:05.000000', 'temperatura', 951.0000, 'ºC'),
	(108858, 110, '2015-03-15 00:53:06.000000', 'temperatura', 1152.0000, 'ºC'),
	(108859, 110, '2015-03-15 00:53:07.000000', 'temperatura', 509.0000, 'ºC'),
	(108860, 110, '2015-03-15 00:53:08.000000', 'temperatura', 289.0000, 'ºC'),
	(108861, 110, '2015-03-15 00:53:09.000000', 'temperatura', 1120.0000, 'ºC'),
	(108862, 110, '2015-03-15 00:53:10.000000', 'temperatura', 1131.0000, 'ºC'),
	(108863, 110, '2015-03-15 00:53:11.000000', 'temperatura', 1097.0000, 'ºC'),
	(108864, 110, '2015-03-15 00:53:12.000000', 'temperatura', 892.0000, 'ºC'),
	(108865, 110, '2015-03-15 00:53:13.000000', 'temperatura', 1168.0000, 'ºC'),
	(108866, 110, '2015-03-15 00:53:14.000000', 'temperatura', 764.0000, 'ºC'),
	(108867, 110, '2015-03-15 00:53:15.000000', 'temperatura', 318.0000, 'ºC'),
	(108868, 110, '2015-03-15 00:53:16.000000', 'temperatura', 497.0000, 'ºC'),
	(108869, 110, '2015-03-15 00:53:17.000000', 'temperatura', 334.0000, 'ºC'),
	(108870, 110, '2015-03-15 00:53:18.000000', 'temperatura', 178.0000, 'ºC'),
	(108871, 110, '2015-03-15 00:53:19.000000', 'temperatura', 1089.0000, 'ºC'),
	(108872, 110, '2015-03-15 00:53:20.000000', 'temperatura', 112.0000, 'ºC'),
	(108873, 110, '2015-03-15 00:53:21.000000', 'temperatura', 891.0000, 'ºC'),
	(108874, 110, '2015-03-15 00:53:22.000000', 'temperatura', 522.0000, 'ºC'),
	(108875, 110, '2015-03-15 00:53:23.000000', 'temperatura', 1138.0000, 'ºC'),
	(108876, 110, '2015-03-15 00:53:24.000000', 'temperatura', 524.0000, 'ºC'),
	(108877, 110, '2015-03-15 00:53:25.000000', 'temperatura', 404.0000, 'ºC'),
	(108878, 110, '2015-03-15 00:53:26.000000', 'temperatura', 451.0000, 'ºC'),
	(108879, 110, '2015-03-15 00:53:27.000000', 'temperatura', 1044.0000, 'ºC'),
	(108880, 110, '2015-03-15 00:53:28.000000', 'temperatura', 267.0000, 'ºC'),
	(108881, 110, '2015-03-15 00:53:29.000000', 'temperatura', 601.0000, 'ºC'),
	(108882, 110, '2015-03-15 00:53:30.000000', 'temperatura', 1007.0000, 'ºC'),
	(108883, 110, '2015-03-15 00:53:31.000000', 'temperatura', 834.0000, 'ºC'),
	(108884, 110, '2015-03-15 00:53:32.000000', 'temperatura', 1147.0000, 'ºC'),
	(108885, 110, '2015-03-15 00:53:33.000000', 'temperatura', 832.0000, 'ºC'),
	(108886, 110, '2015-03-15 00:53:34.000000', 'temperatura', 721.0000, 'ºC'),
	(108887, 110, '2015-03-15 00:53:35.000000', 'temperatura', 1111.0000, 'ºC'),
	(108888, 110, '2015-03-15 00:53:36.000000', 'temperatura', 991.0000, 'ºC'),
	(108889, 110, '2015-03-15 00:53:37.000000', 'temperatura', 424.0000, 'ºC'),
	(108890, 110, '2015-03-15 00:53:38.000000', 'temperatura', 347.0000, 'ºC'),
	(108891, 110, '2015-03-15 00:53:39.000000', 'temperatura', 464.0000, 'ºC'),
	(108892, 110, '2015-03-15 00:53:40.000000', 'temperatura', 79.0000, 'ºC'),
	(108893, 110, '2015-03-15 00:53:41.000000', 'temperatura', 204.0000, 'ºC'),
	(108894, 110, '2015-03-15 00:53:42.000000', 'temperatura', 785.0000, 'ºC'),
	(108895, 110, '2015-03-15 00:53:43.000000', 'temperatura', 911.0000, 'ºC'),
	(108896, 110, '2015-03-15 00:53:44.000000', 'temperatura', 1002.0000, 'ºC'),
	(108897, 110, '2015-03-15 00:53:45.000000', 'temperatura', 1075.0000, 'ºC'),
	(108898, 110, '2015-03-15 00:53:46.000000', 'temperatura', 1172.0000, 'ºC'),
	(108899, 110, '2015-03-15 00:53:47.000000', 'temperatura', 235.0000, 'ºC'),
	(108900, 110, '2015-03-15 00:53:48.000000', 'temperatura', 58.0000, 'ºC'),
	(108901, 110, '2015-03-15 00:53:49.000000', 'temperatura', 788.0000, 'ºC'),
	(108902, 110, '2015-03-15 00:53:50.000000', 'temperatura', 164.0000, 'ºC'),
	(108903, 110, '2015-03-15 00:53:51.000000', 'temperatura', 859.0000, 'ºC'),
	(108904, 110, '2015-03-15 00:53:52.000000', 'temperatura', 201.0000, 'ºC'),
	(108905, 110, '2015-03-15 00:53:53.000000', 'temperatura', 828.0000, 'ºC'),
	(108906, 110, '2015-03-15 00:53:54.000000', 'temperatura', 1139.0000, 'ºC'),
	(108907, 110, '2015-03-15 00:53:55.000000', 'temperatura', 812.0000, 'ºC'),
	(108908, 110, '2015-03-15 00:53:56.000000', 'temperatura', 645.0000, 'ºC'),
	(108909, 110, '2015-03-15 00:53:57.000000', 'temperatura', 786.0000, 'ºC'),
	(108910, 110, '2015-03-15 00:53:58.000000', 'temperatura', 798.0000, 'ºC'),
	(108911, 110, '2015-03-15 00:53:59.000000', 'temperatura', 432.0000, 'ºC'),
	(108912, 110, '2015-03-15 00:54:00.000000', 'temperatura', 965.0000, 'ºC'),
	(108913, 110, '2015-03-15 00:54:01.000000', 'temperatura', 1131.0000, 'ºC'),
	(108914, 110, '2015-03-15 00:54:02.000000', 'temperatura', 361.0000, 'ºC'),
	(108915, 110, '2015-03-15 00:54:03.000000', 'temperatura', 813.0000, 'ºC'),
	(108916, 110, '2015-03-15 00:54:04.000000', 'temperatura', 583.0000, 'ºC'),
	(108917, 110, '2015-03-15 00:54:05.000000', 'temperatura', 474.0000, 'ºC'),
	(108918, 110, '2015-03-15 00:54:06.000000', 'temperatura', 621.0000, 'ºC'),
	(108919, 110, '2015-03-15 00:54:07.000000', 'temperatura', 483.0000, 'ºC'),
	(108920, 110, '2015-03-15 00:54:08.000000', 'temperatura', 552.0000, 'ºC'),
	(108921, 110, '2015-03-15 00:54:09.000000', 'temperatura', 114.0000, 'ºC'),
	(108922, 110, '2015-03-15 00:54:10.000000', 'temperatura', 114.0000, 'ºC'),
	(108923, 110, '2015-03-15 00:54:11.000000', 'temperatura', 229.0000, 'ºC'),
	(108924, 110, '2015-03-15 00:54:12.000000', 'temperatura', 801.0000, 'ºC'),
	(108925, 110, '2015-03-15 00:54:13.000000', 'temperatura', 919.0000, 'ºC'),
	(108926, 110, '2015-03-15 00:54:14.000000', 'temperatura', 994.0000, 'ºC'),
	(108927, 110, '2015-03-15 00:54:15.000000', 'temperatura', 1015.0000, 'ºC'),
	(108928, 110, '2015-03-15 00:54:16.000000', 'temperatura', 891.0000, 'ºC'),
	(108929, 110, '2015-03-15 00:54:17.000000', 'temperatura', 212.0000, 'ºC'),
	(108930, 110, '2015-03-15 00:54:18.000000', 'temperatura', 787.0000, 'ºC'),
	(108931, 110, '2015-03-15 00:54:19.000000', 'temperatura', 901.0000, 'ºC'),
	(108932, 110, '2015-03-15 00:54:20.000000', 'temperatura', 943.0000, 'ºC'),
	(108933, 110, '2015-03-15 00:54:21.000000', 'temperatura', 811.0000, 'ºC'),
	(108934, 110, '2015-03-15 00:54:22.000000', 'temperatura', 27.0000, 'ºC'),
	(108935, 110, '2015-03-15 00:54:23.000000', 'temperatura', 102.0000, 'ºC'),
	(108936, 110, '2015-03-15 00:54:24.000000', 'temperatura', 428.0000, 'ºC'),
	(108937, 110, '2015-03-15 00:54:25.000000', 'temperatura', 637.0000, 'ºC'),
	(108938, 110, '2015-03-15 00:54:26.000000', 'temperatura', 699.0000, 'ºC'),
	(108939, 110, '2015-03-15 00:54:27.000000', 'temperatura', 387.0000, 'ºC'),
	(108940, 110, '2015-03-15 00:54:28.000000', 'temperatura', 1036.0000, 'ºC'),
	(108941, 110, '2015-03-15 00:54:29.000000', 'temperatura', 421.0000, 'ºC'),
	(108942, 110, '2015-03-15 00:54:30.000000', 'temperatura', 196.0000, 'ºC'),
	(108943, 110, '2015-03-15 00:54:31.000000', 'temperatura', 917.0000, 'ºC'),
	(108944, 110, '2015-03-15 00:54:32.000000', 'temperatura', 399.0000, 'ºC'),
	(108945, 110, '2015-03-15 00:54:33.000000', 'temperatura', 443.0000, 'ºC'),
	(108946, 110, '2015-03-15 00:54:34.000000', 'temperatura', 1019.0000, 'ºC'),
	(108947, 110, '2015-03-15 00:54:35.000000', 'temperatura', 167.0000, 'ºC'),
	(108948, 110, '2015-03-15 00:54:36.000000', 'temperatura', 179.0000, 'ºC'),
	(108949, 110, '2015-03-15 00:54:37.000000', 'temperatura', 394.0000, 'ºC'),
	(108950, 110, '2015-03-15 00:54:38.000000', 'temperatura', 233.0000, 'ºC'),
	(108951, 110, '2015-03-15 00:54:39.000000', 'temperatura', 1185.0000, 'ºC'),
	(108952, 110, '2015-03-15 00:54:40.000000', 'temperatura', 425.0000, 'ºC'),
	(108953, 110, '2015-03-15 00:54:41.000000', 'temperatura', 970.0000, 'ºC'),
	(108954, 110, '2015-03-15 00:54:42.000000', 'temperatura', 1174.0000, 'ºC'),
	(108955, 110, '2015-03-15 00:54:43.000000', 'temperatura', 563.0000, 'ºC'),
	(108956, 110, '2015-03-15 00:54:44.000000', 'temperatura', 492.0000, 'ºC'),
	(108957, 110, '2015-03-15 00:54:45.000000', 'temperatura', 774.0000, 'ºC'),
	(108958, 110, '2015-03-15 00:54:46.000000', 'temperatura', 1192.0000, 'ºC'),
	(108959, 110, '2015-03-15 00:54:47.000000', 'temperatura', 40.0000, 'ºC'),
	(108960, 110, '2015-03-15 00:54:48.000000', 'temperatura', 224.0000, 'ºC'),
	(108961, 110, '2015-03-15 00:54:49.000000', 'temperatura', 1002.0000, 'ºC'),
	(108962, 110, '2015-03-15 00:54:50.000000', 'temperatura', 736.0000, 'ºC'),
	(108963, 110, '2015-03-15 00:54:51.000000', 'temperatura', 674.0000, 'ºC'),
	(108964, 110, '2015-03-15 00:54:52.000000', 'temperatura', 1162.0000, 'ºC'),
	(108965, 110, '2015-03-15 00:54:53.000000', 'temperatura', 191.0000, 'ºC'),
	(108966, 110, '2015-03-15 00:54:54.000000', 'temperatura', 1067.0000, 'ºC'),
	(108967, 110, '2015-03-15 00:54:55.000000', 'temperatura', 1166.0000, 'ºC'),
	(108968, 110, '2015-03-15 00:54:56.000000', 'temperatura', 226.0000, 'ºC'),
	(108969, 110, '2015-03-15 00:54:57.000000', 'temperatura', 33.0000, 'ºC'),
	(108970, 110, '2015-03-15 00:54:58.000000', 'temperatura', 686.0000, 'ºC'),
	(108971, 110, '2015-03-15 00:54:59.000000', 'temperatura', 932.0000, 'ºC'),
	(108972, 110, '2015-03-15 00:55:00.000000', 'temperatura', 205.0000, 'ºC'),
	(108973, 110, '2015-03-15 00:55:01.000000', 'temperatura', 628.0000, 'ºC'),
	(108974, 110, '2015-03-15 00:55:02.000000', 'temperatura', 125.0000, 'ºC'),
	(108975, 110, '2015-03-15 00:55:03.000000', 'temperatura', 1142.0000, 'ºC'),
	(108976, 110, '2015-03-15 00:55:04.000000', 'temperatura', 534.0000, 'ºC'),
	(108977, 110, '2015-03-15 00:55:05.000000', 'temperatura', 447.0000, 'ºC'),
	(108978, 110, '2015-03-15 00:55:06.000000', 'temperatura', 634.0000, 'ºC'),
	(108979, 110, '2015-03-15 00:55:07.000000', 'temperatura', 627.0000, 'ºC'),
	(108980, 110, '2015-03-15 00:55:08.000000', 'temperatura', 37.0000, 'ºC'),
	(108981, 110, '2015-03-15 00:55:09.000000', 'temperatura', 701.0000, 'ºC'),
	(108982, 110, '2015-03-15 00:55:10.000000', 'temperatura', 996.0000, 'ºC'),
	(108983, 110, '2015-03-15 00:55:11.000000', 'temperatura', 477.0000, 'ºC'),
	(108984, 110, '2015-03-15 00:55:12.000000', 'temperatura', 600.0000, 'ºC'),
	(108985, 110, '2015-03-15 00:55:13.000000', 'temperatura', 366.0000, 'ºC'),
	(108986, 110, '2015-03-15 00:55:14.000000', 'temperatura', 32.0000, 'ºC'),
	(108987, 110, '2015-03-15 00:55:15.000000', 'temperatura', 261.0000, 'ºC'),
	(108988, 110, '2015-03-15 00:55:16.000000', 'temperatura', 9.0000, 'ºC'),
	(108989, 110, '2015-03-15 00:55:17.000000', 'temperatura', 465.0000, 'ºC'),
	(108990, 110, '2015-03-15 00:55:18.000000', 'temperatura', 1099.0000, 'ºC'),
	(108991, 110, '2015-03-15 00:55:19.000000', 'temperatura', 498.0000, 'ºC'),
	(108992, 110, '2015-03-15 00:55:20.000000', 'temperatura', 396.0000, 'ºC'),
	(108993, 110, '2015-03-15 00:55:21.000000', 'temperatura', 483.0000, 'ºC'),
	(108994, 110, '2015-03-15 00:55:22.000000', 'temperatura', 31.0000, 'ºC'),
	(108995, 110, '2015-03-15 00:55:23.000000', 'temperatura', 1105.0000, 'ºC'),
	(108996, 110, '2015-03-15 00:55:24.000000', 'temperatura', 632.0000, 'ºC'),
	(108997, 110, '2015-03-15 00:55:25.000000', 'temperatura', 1048.0000, 'ºC'),
	(108998, 110, '2015-03-15 00:55:26.000000', 'temperatura', 942.0000, 'ºC'),
	(108999, 110, '2015-03-15 00:55:27.000000', 'temperatura', 366.0000, 'ºC'),
	(109000, 110, '2015-03-15 00:55:28.000000', 'temperatura', 207.0000, 'ºC'),
	(109001, 110, '2015-03-15 00:55:29.000000', 'temperatura', 1136.0000, 'ºC'),
	(109002, 110, '2015-03-15 00:55:30.000000', 'temperatura', 260.0000, 'ºC'),
	(109003, 110, '2015-03-15 00:55:31.000000', 'temperatura', 292.0000, 'ºC'),
	(109004, 110, '2015-03-15 00:55:32.000000', 'temperatura', 682.0000, 'ºC'),
	(109005, 110, '2015-03-15 00:55:33.000000', 'temperatura', 132.0000, 'ºC'),
	(109006, 110, '2015-03-15 00:55:34.000000', 'temperatura', 1016.0000, 'ºC'),
	(109007, 110, '2015-03-15 00:55:35.000000', 'temperatura', 1083.0000, 'ºC'),
	(109008, 110, '2015-03-15 00:55:36.000000', 'temperatura', 1168.0000, 'ºC'),
	(109009, 110, '2015-03-15 00:55:37.000000', 'temperatura', 191.0000, 'ºC'),
	(109010, 110, '2015-03-15 00:55:38.000000', 'temperatura', 1050.0000, 'ºC'),
	(109011, 110, '2015-03-15 00:55:39.000000', 'temperatura', 1081.0000, 'ºC'),
	(109012, 110, '2015-03-15 00:55:40.000000', 'temperatura', 1054.0000, 'ºC'),
	(109013, 110, '2015-03-15 00:55:41.000000', 'temperatura', 826.0000, 'ºC'),
	(109014, 110, '2015-03-15 00:55:42.000000', 'temperatura', 969.0000, 'ºC'),
	(109015, 110, '2015-03-15 00:55:43.000000', 'temperatura', 1168.0000, 'ºC'),
	(109016, 110, '2015-03-15 00:55:44.000000', 'temperatura', 535.0000, 'ºC'),
	(109017, 110, '2015-03-15 00:55:45.000000', 'temperatura', 368.0000, 'ºC'),
	(109018, 110, '2015-03-15 00:55:46.000000', 'temperatura', 238.0000, 'ºC'),
	(109019, 110, '2015-03-15 00:55:47.000000', 'temperatura', 87.0000, 'ºC'),
	(109020, 110, '2015-03-15 00:55:48.000000', 'temperatura', 922.0000, 'ºC'),
	(109021, 110, '2015-03-15 00:55:49.000000', 'temperatura', 747.0000, 'ºC'),
	(109022, 110, '2015-03-15 00:55:50.000000', 'temperatura', 972.0000, 'ºC'),
	(109023, 110, '2015-03-15 00:55:51.000000', 'temperatura', 219.0000, 'ºC'),
	(109024, 110, '2015-03-15 00:55:52.000000', 'temperatura', 581.0000, 'ºC'),
	(109025, 110, '2015-03-15 00:55:53.000000', 'temperatura', 1046.0000, 'ºC'),
	(109026, 110, '2015-03-15 00:55:54.000000', 'temperatura', 1089.0000, 'ºC'),
	(109027, 110, '2015-03-15 00:55:55.000000', 'temperatura', 1108.0000, 'ºC'),
	(109028, 110, '2015-03-15 00:55:56.000000', 'temperatura', 1074.0000, 'ºC'),
	(109029, 110, '2015-03-15 00:55:57.000000', 'temperatura', 847.0000, 'ºC'),
	(109030, 110, '2015-03-15 00:55:58.000000', 'temperatura', 1012.0000, 'ºC'),
	(109031, 110, '2015-03-15 00:55:59.000000', 'temperatura', 121.0000, 'ºC'),
	(109032, 110, '2015-03-15 00:56:00.000000', 'temperatura', 1168.0000, 'ºC'),
	(109033, 110, '2015-03-15 00:56:01.000000', 'temperatura', 677.0000, 'ºC'),
	(109034, 110, '2015-03-15 00:56:02.000000', 'temperatura', 1084.0000, 'ºC'),
	(109035, 110, '2015-03-15 00:56:03.000000', 'temperatura', 987.0000, 'ºC'),
	(109036, 110, '2015-03-15 00:56:04.000000', 'temperatura', 483.0000, 'ºC'),
	(109037, 110, '2015-03-15 00:56:05.000000', 'temperatura', 657.0000, 'ºC'),
	(109038, 110, '2015-03-15 00:56:06.000000', 'temperatura', 634.0000, 'ºC'),
	(109039, 110, '2015-03-15 00:56:07.000000', 'temperatura', 0.0000, 'ºC'),
	(109040, 110, '2015-03-15 00:56:08.000000', 'temperatura', 497.0000, 'ºC'),
	(109041, 110, '2015-03-15 00:56:09.000000', 'temperatura', 88.0000, 'ºC'),
	(109042, 110, '2015-03-15 00:56:10.000000', 'temperatura', 148.0000, 'ºC'),
	(109043, 110, '2015-03-15 00:56:11.000000', 'temperatura', 477.0000, 'ºC'),
	(109044, 110, '2015-03-15 00:56:12.000000', 'temperatura', 742.0000, 'ºC'),
	(109045, 110, '2015-03-15 00:56:13.000000', 'temperatura', 1080.0000, 'ºC'),
	(109046, 110, '2015-03-15 00:56:14.000000', 'temperatura', 775.0000, 'ºC'),
	(109047, 110, '2015-03-15 00:56:15.000000', 'temperatura', 633.0000, 'ºC'),
	(109048, 110, '2015-03-15 00:56:16.000000', 'temperatura', 843.0000, 'ºC'),
	(109049, 110, '2015-03-15 00:56:17.000000', 'temperatura', 1114.0000, 'ºC'),
	(109050, 110, '2015-03-15 00:56:18.000000', 'temperatura', 641.0000, 'ºC'),
	(109051, 110, '2015-03-15 00:56:19.000000', 'temperatura', 1065.0000, 'ºC'),
	(109052, 110, '2015-03-15 00:56:20.000000', 'temperatura', 1002.0000, 'ºC'),
	(109053, 110, '2015-03-15 00:56:21.000000', 'temperatura', 615.0000, 'ºC'),
	(109054, 110, '2015-03-15 00:56:22.000000', 'temperatura', 68.0000, 'ºC'),
	(109055, 110, '2015-03-15 00:56:23.000000', 'temperatura', 897.0000, 'ºC'),
	(109056, 110, '2015-03-15 00:56:24.000000', 'temperatura', 682.0000, 'ºC'),
	(109057, 110, '2015-03-15 00:56:25.000000', 'temperatura', 718.0000, 'ºC'),
	(109058, 110, '2015-03-15 00:56:26.000000', 'temperatura', 343.0000, 'ºC'),
	(109059, 110, '2015-03-15 00:56:27.000000', 'temperatura', 765.0000, 'ºC'),
	(109060, 110, '2015-03-15 00:56:28.000000', 'temperatura', 394.0000, 'ºC'),
	(109061, 110, '2015-03-15 00:56:29.000000', 'temperatura', 875.0000, 'ºC'),
	(109062, 110, '2015-03-15 00:56:30.000000', 'temperatura', 796.0000, 'ºC'),
	(109063, 110, '2015-03-15 00:56:31.000000', 'temperatura', 156.0000, 'ºC'),
	(109064, 110, '2015-03-15 00:56:32.000000', 'temperatura', 790.0000, 'ºC'),
	(109065, 110, '2015-03-15 00:56:33.000000', 'temperatura', 1085.0000, 'ºC'),
	(109066, 110, '2015-03-15 00:56:34.000000', 'temperatura', 654.0000, 'ºC'),
	(109067, 110, '2015-03-15 00:56:35.000000', 'temperatura', 17.0000, 'ºC'),
	(109068, 110, '2015-03-15 00:56:36.000000', 'temperatura', 524.0000, 'ºC'),
	(109069, 110, '2015-03-15 00:56:37.000000', 'temperatura', 167.0000, 'ºC'),
	(109070, 110, '2015-03-15 00:56:38.000000', 'temperatura', 465.0000, 'ºC'),
	(109071, 110, '2015-03-15 00:56:39.000000', 'temperatura', 622.0000, 'ºC'),
	(109072, 110, '2015-03-15 00:56:40.000000', 'temperatura', 518.0000, 'ºC'),
	(109073, 110, '2015-03-15 00:56:41.000000', 'temperatura', 725.0000, 'ºC'),
	(109074, 110, '2015-03-15 00:56:42.000000', 'temperatura', 871.0000, 'ºC'),
	(109075, 110, '2015-03-15 00:56:43.000000', 'temperatura', 982.0000, 'ºC'),
	(109076, 110, '2015-03-15 00:56:44.000000', 'temperatura', 1097.0000, 'ºC'),
	(109077, 110, '2015-03-15 00:56:45.000000', 'temperatura', 138.0000, 'ºC'),
	(109078, 110, '2015-03-15 00:56:46.000000', 'temperatura', 1002.0000, 'ºC'),
	(109079, 110, '2015-03-15 00:56:47.000000', 'temperatura', 995.0000, 'ºC'),
	(109080, 110, '2015-03-15 00:56:48.000000', 'temperatura', 768.0000, 'ºC'),
	(109081, 110, '2015-03-15 00:56:49.000000', 'temperatura', 855.0000, 'ºC'),
	(109082, 110, '2015-03-15 00:56:50.000000', 'temperatura', 774.0000, 'ºC'),
	(109083, 110, '2015-03-15 00:56:51.000000', 'temperatura', 105.0000, 'ºC'),
	(109084, 110, '2015-03-15 00:56:52.000000', 'temperatura', 604.0000, 'ºC'),
	(109085, 110, '2015-03-15 00:56:53.000000', 'temperatura', 304.0000, 'ºC'),
	(109086, 110, '2015-03-15 00:56:54.000000', 'temperatura', 910.0000, 'ºC'),
	(109087, 110, '2015-03-15 00:56:55.000000', 'temperatura', 38.0000, 'ºC'),
	(109088, 110, '2015-03-15 00:56:56.000000', 'temperatura', 1060.0000, 'ºC'),
	(109089, 110, '2015-03-15 00:56:57.000000', 'temperatura', 385.0000, 'ºC'),
	(109090, 110, '2015-03-15 00:56:58.000000', 'temperatura', 1147.0000, 'ºC'),
	(109091, 110, '2015-03-15 00:56:59.000000', 'temperatura', 981.0000, 'ºC'),
	(109092, 110, '2015-03-15 00:57:00.000000', 'temperatura', 264.0000, 'ºC'),
	(109093, 110, '2015-03-15 00:57:01.000000', 'temperatura', 780.0000, 'ºC'),
	(109094, 110, '2015-03-15 00:57:02.000000', 'temperatura', 705.0000, 'ºC'),
	(109095, 110, '2015-03-15 00:57:03.000000', 'temperatura', 1187.0000, 'ºC'),
	(109096, 110, '2015-03-15 00:57:04.000000', 'temperatura', 220.0000, 'ºC'),
	(109097, 110, '2015-03-15 00:57:05.000000', 'temperatura', 1138.0000, 'ºC'),
	(109098, 110, '2015-03-15 00:57:06.000000', 'temperatura', 230.0000, 'ºC'),
	(109099, 110, '2015-03-15 00:57:07.000000', 'temperatura', 139.0000, 'ºC'),
	(109100, 110, '2015-03-15 00:57:08.000000', 'temperatura', 4.0000, 'ºC'),
	(109101, 110, '2015-03-15 00:57:09.000000', 'temperatura', 805.0000, 'ºC'),
	(109102, 110, '2015-03-15 00:57:10.000000', 'temperatura', 414.0000, 'ºC'),
	(109103, 110, '2015-03-15 00:57:11.000000', 'temperatura', 855.0000, 'ºC'),
	(109104, 110, '2015-03-15 00:57:12.000000', 'temperatura', 632.0000, 'ºC'),
	(109105, 110, '2015-03-15 00:57:13.000000', 'temperatura', 598.0000, 'ºC'),
	(109106, 110, '2015-03-15 00:57:14.000000', 'temperatura', 1094.0000, 'ºC'),
	(109107, 110, '2015-03-15 00:57:15.000000', 'temperatura', 77.0000, 'ºC'),
	(109108, 110, '2015-03-15 00:57:16.000000', 'temperatura', 701.0000, 'ºC'),
	(109109, 110, '2015-03-15 00:57:17.000000', 'temperatura', 877.0000, 'ºC'),
	(109110, 110, '2015-03-15 00:57:18.000000', 'temperatura', 1082.0000, 'ºC'),
	(109111, 110, '2015-03-15 00:57:19.000000', 'temperatura', 377.0000, 'ºC'),
	(109112, 110, '2015-03-15 00:57:20.000000', 'temperatura', 1042.0000, 'ºC'),
	(109113, 110, '2015-03-15 00:57:21.000000', 'temperatura', 480.0000, 'ºC'),
	(109114, 110, '2015-03-15 00:57:22.000000', 'temperatura', 472.0000, 'ºC'),
	(109115, 110, '2015-03-15 00:57:23.000000', 'temperatura', 922.0000, 'ºC'),
	(109116, 110, '2015-03-15 00:57:24.000000', 'temperatura', 794.0000, 'ºC'),
	(109117, 110, '2015-03-15 00:57:25.000000', 'temperatura', 5.0000, 'ºC'),
	(109118, 110, '2015-03-15 00:57:26.000000', 'temperatura', 45.0000, 'ºC'),
	(109119, 110, '2015-03-15 00:57:27.000000', 'temperatura', 208.0000, 'ºC'),
	(109120, 110, '2015-03-15 00:57:28.000000', 'temperatura', 905.0000, 'ºC'),
	(109121, 110, '2015-03-15 00:57:29.000000', 'temperatura', 304.0000, 'ºC'),
	(109122, 110, '2015-03-15 00:57:30.000000', 'temperatura', 4.0000, 'ºC'),
	(109123, 110, '2015-03-15 00:57:31.000000', 'temperatura', 308.0000, 'ºC'),
	(109124, 110, '2015-03-15 00:57:32.000000', 'temperatura', 331.0000, 'ºC'),
	(109125, 110, '2015-03-15 00:57:33.000000', 'temperatura', 728.0000, 'ºC'),
	(109126, 110, '2015-03-15 00:57:34.000000', 'temperatura', 249.0000, 'ºC'),
	(109127, 110, '2015-03-15 00:57:35.000000', 'temperatura', 261.0000, 'ºC'),
	(109128, 110, '2015-03-15 00:57:36.000000', 'temperatura', 561.0000, 'ºC'),
	(109129, 110, '2015-03-15 00:57:37.000000', 'temperatura', 821.0000, 'ºC'),
	(109130, 110, '2015-03-15 00:57:38.000000', 'temperatura', 22.0000, 'ºC'),
	(109131, 110, '2015-03-15 00:57:39.000000', 'temperatura', 46.0000, 'ºC'),
	(109132, 110, '2015-03-15 00:57:40.000000', 'temperatura', 166.0000, 'ºC'),
	(109133, 110, '2015-03-15 00:57:41.000000', 'temperatura', 694.0000, 'ºC'),
	(109134, 110, '2015-03-15 00:57:42.000000', 'temperatura', 570.0000, 'ºC'),
	(109135, 110, '2015-03-15 00:57:43.000000', 'temperatura', 769.0000, 'ºC'),
	(109136, 110, '2015-03-15 00:57:44.000000', 'temperatura', 937.0000, 'ºC'),
	(109137, 110, '2015-03-15 00:57:45.000000', 'temperatura', 1178.0000, 'ºC'),
	(109138, 110, '2015-03-15 00:57:46.000000', 'temperatura', 678.0000, 'ºC'),
	(109139, 110, '2015-03-15 00:57:47.000000', 'temperatura', 1059.0000, 'ºC'),
	(109140, 110, '2015-03-15 00:57:48.000000', 'temperatura', 860.0000, 'ºC'),
	(109141, 110, '2015-03-15 00:57:49.000000', 'temperatura', 1124.0000, 'ºC'),
	(109142, 110, '2015-03-15 00:57:50.000000', 'temperatura', 640.0000, 'ºC'),
	(109143, 110, '2015-03-15 00:57:51.000000', 'temperatura', 1030.0000, 'ºC'),
	(109144, 110, '2015-03-15 00:57:52.000000', 'temperatura', 832.0000, 'ºC'),
	(109145, 110, '2015-03-15 00:57:53.000000', 'temperatura', 1068.0000, 'ºC'),
	(109146, 110, '2015-03-15 00:57:54.000000', 'temperatura', 444.0000, 'ºC'),
	(109147, 110, '2015-03-15 00:57:55.000000', 'temperatura', 219.0000, 'ºC'),
	(109148, 110, '2015-03-15 00:57:56.000000', 'temperatura', 962.0000, 'ºC'),
	(109149, 110, '2015-03-15 00:57:57.000000', 'temperatura', 552.0000, 'ºC'),
	(109150, 110, '2015-03-15 00:57:58.000000', 'temperatura', 1078.0000, 'ºC'),
	(109151, 110, '2015-03-15 00:57:59.000000', 'temperatura', 132.0000, 'ºC'),
	(109152, 110, '2015-03-15 00:58:00.000000', 'temperatura', 1026.0000, 'ºC'),
	(109153, 110, '2015-03-15 00:58:01.000000', 'temperatura', 1136.0000, 'ºC'),
	(109154, 110, '2015-03-15 00:58:02.000000', 'temperatura', 200.0000, 'ºC'),
	(109155, 110, '2015-03-15 00:58:03.000000', 'temperatura', 1195.0000, 'ºC'),
	(109156, 110, '2015-03-15 00:58:04.000000', 'temperatura', 575.0000, 'ºC'),
	(109157, 110, '2015-03-15 00:58:05.000000', 'temperatura', 489.0000, 'ºC'),
	(109158, 110, '2015-03-15 00:58:06.000000', 'temperatura', 721.0000, 'ºC'),
	(109159, 110, '2015-03-15 00:58:07.000000', 'temperatura', 941.0000, 'ºC'),
	(109160, 110, '2015-03-15 00:58:08.000000', 'temperatura', 140.0000, 'ºC'),
	(109161, 110, '2015-03-15 00:58:09.000000', 'temperatura', 279.0000, 'ºC'),
	(109162, 110, '2015-03-15 00:58:10.000000', 'temperatura', 976.0000, 'ºC'),
	(109163, 110, '2015-03-15 00:58:11.000000', 'temperatura', 441.0000, 'ºC'),
	(109164, 110, '2015-03-15 00:58:12.000000', 'temperatura', 478.0000, 'ºC'),
	(109165, 110, '2015-03-15 00:58:13.000000', 'temperatura', 1069.0000, 'ºC'),
	(109166, 110, '2015-03-15 00:58:14.000000', 'temperatura', 312.0000, 'ºC'),
	(109167, 110, '2015-03-15 00:58:15.000000', 'temperatura', 754.0000, 'ºC'),
	(109168, 110, '2015-03-15 00:58:16.000000', 'temperatura', 434.0000, 'ºC'),
	(109169, 110, '2015-03-15 00:58:17.000000', 'temperatura', 1110.0000, 'ºC'),
	(109170, 110, '2015-03-15 00:58:18.000000', 'temperatura', 647.0000, 'ºC'),
	(109171, 110, '2015-03-15 00:58:19.000000', 'temperatura', 1107.0000, 'ºC'),
	(109172, 110, '2015-03-15 00:58:20.000000', 'temperatura', 1193.0000, 'ºC'),
	(109173, 110, '2015-03-15 00:58:21.000000', 'temperatura', 245.0000, 'ºC'),
	(109174, 110, '2015-03-15 00:58:22.000000', 'temperatura', 48.0000, 'ºC'),
	(109175, 110, '2015-03-15 00:58:23.000000', 'temperatura', 705.0000, 'ºC'),
	(109176, 110, '2015-03-15 00:58:24.000000', 'temperatura', 980.0000, 'ºC'),
	(109177, 110, '2015-03-15 00:58:25.000000', 'temperatura', 388.0000, 'ºC'),
	(109178, 110, '2015-03-15 00:58:26.000000', 'temperatura', 198.0000, 'ºC'),
	(109179, 110, '2015-03-15 00:58:27.000000', 'temperatura', 1025.0000, 'ºC'),
	(109180, 110, '2015-03-15 00:58:28.000000', 'temperatura', 935.0000, 'ºC'),
	(109181, 110, '2015-03-15 00:58:29.000000', 'temperatura', 398.0000, 'ºC'),
	(109182, 110, '2015-03-15 00:58:30.000000', 'temperatura', 386.0000, 'ºC'),
	(109183, 110, '2015-03-15 00:58:31.000000', 'temperatura', 736.0000, 'ºC'),
	(109184, 110, '2015-03-15 00:58:32.000000', 'temperatura', 121.0000, 'ºC'),
	(109185, 110, '2015-03-15 00:58:33.000000', 'temperatura', 799.0000, 'ºC'),
	(109186, 110, '2015-03-15 00:58:34.000000', 'temperatura', 32.0000, 'ºC'),
	(109187, 110, '2015-03-15 00:58:35.000000', 'temperatura', 162.0000, 'ºC'),
	(109188, 110, '2015-03-15 00:58:36.000000', 'temperatura', 718.0000, 'ºC'),
	(109189, 110, '2015-03-15 00:58:37.000000', 'temperatura', 702.0000, 'ºC'),
	(109190, 110, '2015-03-15 00:58:38.000000', 'temperatura', 159.0000, 'ºC'),
	(109191, 110, '2015-03-15 00:58:39.000000', 'temperatura', 1090.0000, 'ºC'),
	(109192, 110, '2015-03-15 00:58:40.000000', 'temperatura', 170.0000, 'ºC'),
	(109193, 110, '2015-03-15 00:58:41.000000', 'temperatura', 1183.0000, 'ºC'),
	(109194, 110, '2015-03-15 00:58:42.000000', 'temperatura', 603.0000, 'ºC'),
	(109195, 110, '2015-03-15 00:58:43.000000', 'temperatura', 668.0000, 'ºC'),
	(109196, 110, '2015-03-15 00:58:44.000000', 'temperatura', 332.0000, 'ºC'),
	(109197, 110, '2015-03-15 00:58:45.000000', 'temperatura', 857.0000, 'ºC'),
	(109198, 110, '2015-03-15 00:58:46.000000', 'temperatura', 889.0000, 'ºC'),
	(109199, 110, '2015-03-15 00:58:47.000000', 'temperatura', 675.0000, 'ºC'),
	(109200, 110, '2015-03-15 00:58:48.000000', 'temperatura', 708.0000, 'ºC'),
	(109201, 110, '2015-03-15 00:58:49.000000', 'temperatura', 316.0000, 'ºC'),
	(109202, 110, '2015-03-15 00:58:50.000000', 'temperatura', 655.0000, 'ºC'),
	(109203, 110, '2015-03-15 00:58:51.000000', 'temperatura', 1127.0000, 'ºC'),
	(109204, 110, '2015-03-15 00:58:52.000000', 'temperatura', 71.0000, 'ºC'),
	(109205, 110, '2015-03-15 00:58:53.000000', 'temperatura', 574.0000, 'ºC'),
	(109206, 110, '2015-03-15 00:58:54.000000', 'temperatura', 258.0000, 'ºC'),
	(109207, 110, '2015-03-15 00:58:55.000000', 'temperatura', 767.0000, 'ºC'),
	(109208, 110, '2015-03-15 00:58:56.000000', 'temperatura', 662.0000, 'ºC'),
	(109209, 110, '2015-03-15 00:58:57.000000', 'temperatura', 1011.0000, 'ºC'),
	(109210, 110, '2015-03-15 00:58:58.000000', 'temperatura', 668.0000, 'ºC'),
	(109211, 110, '2015-03-15 00:58:59.000000', 'temperatura', 310.0000, 'ºC'),
	(109212, 110, '2015-03-15 00:59:00.000000', 'temperatura', 745.0000, 'ºC'),
	(109213, 110, '2015-03-15 00:59:01.000000', 'temperatura', 394.0000, 'ºC'),
	(109214, 110, '2015-03-15 00:59:02.000000', 'temperatura', 935.0000, 'ºC'),
	(109215, 110, '2015-03-15 00:59:03.000000', 'temperatura', 1095.0000, 'ºC'),
	(109216, 110, '2015-03-15 00:59:04.000000', 'temperatura', 271.0000, 'ºC'),
	(109217, 110, '2015-03-15 00:59:05.000000', 'temperatura', 468.0000, 'ºC'),
	(109218, 110, '2015-03-15 00:59:06.000000', 'temperatura', 331.0000, 'ºC'),
	(109219, 110, '2015-03-15 00:59:07.000000', 'temperatura', 249.0000, 'ºC'),
	(109220, 110, '2015-03-15 00:59:08.000000', 'temperatura', 252.0000, 'ºC'),
	(109221, 110, '2015-03-15 00:59:09.000000', 'temperatura', 515.0000, 'ºC'),
	(109222, 110, '2015-03-15 00:59:10.000000', 'temperatura', 617.0000, 'ºC'),
	(109223, 110, '2015-03-15 00:59:11.000000', 'temperatura', 341.0000, 'ºC'),
	(109224, 110, '2015-03-15 00:59:12.000000', 'temperatura', 1057.0000, 'ºC'),
	(109225, 110, '2015-03-15 00:59:13.000000', 'temperatura', 662.0000, 'ºC'),
	(109226, 110, '2015-03-15 00:59:14.000000', 'temperatura', 137.0000, 'ºC'),
	(109227, 110, '2015-03-15 00:59:15.000000', 'temperatura', 1102.0000, 'ºC'),
	(109228, 110, '2015-03-15 00:59:16.000000', 'temperatura', 299.0000, 'ºC'),
	(109229, 110, '2015-03-15 00:59:17.000000', 'temperatura', 589.0000, 'ºC'),
	(109230, 110, '2015-03-15 00:59:18.000000', 'temperatura', 849.0000, 'ºC'),
	(109231, 110, '2015-03-15 00:59:19.000000', 'temperatura', 79.0000, 'ºC'),
	(109232, 110, '2015-03-15 00:59:20.000000', 'temperatura', 249.0000, 'ºC'),
	(109233, 110, '2015-03-15 00:59:21.000000', 'temperatura', 1006.0000, 'ºC'),
	(109234, 110, '2015-03-15 00:59:22.000000', 'temperatura', 686.0000, 'ºC'),
	(109235, 110, '2015-03-15 00:59:23.000000', 'temperatura', 413.0000, 'ºC'),
	(109236, 110, '2015-03-15 00:59:24.000000', 'temperatura', 7.0000, 'ºC'),
	(109237, 110, '2015-03-15 00:59:25.000000', 'temperatura', 1195.0000, 'ºC'),
	(109238, 110, '2015-03-15 00:59:26.000000', 'temperatura', 1154.0000, 'ºC'),
	(109239, 110, '2015-03-15 00:59:27.000000', 'temperatura', 988.0000, 'ºC'),
	(109240, 110, '2015-03-15 00:59:28.000000', 'temperatura', 278.0000, 'ºC'),
	(109241, 110, '2015-03-15 00:59:29.000000', 'temperatura', 825.0000, 'ºC'),
	(109242, 110, '2015-03-15 00:59:30.000000', 'temperatura', 892.0000, 'ºC'),
	(109243, 110, '2015-03-15 00:59:31.000000', 'temperatura', 784.0000, 'ºC'),
	(109244, 110, '2015-03-15 00:59:32.000000', 'temperatura', 47.0000, 'ºC'),
	(109245, 110, '2015-03-15 00:59:33.000000', 'temperatura', 283.0000, 'ºC'),
	(109246, 110, '2015-03-15 00:59:34.000000', 'temperatura', 73.0000, 'ºC'),
	(109247, 110, '2015-03-15 00:59:35.000000', 'temperatura', 716.0000, 'ºC'),
	(109248, 110, '2015-03-15 00:59:36.000000', 'temperatura', 962.0000, 'ºC'),
	(109249, 110, '2015-03-15 00:59:37.000000', 'temperatura', 261.0000, 'ºC'),
	(109250, 110, '2015-03-15 00:59:38.000000', 'temperatura', 822.0000, 'ºC'),
	(109251, 110, '2015-03-15 00:59:39.000000', 'temperatura', 926.0000, 'ºC'),
	(109252, 110, '2015-03-15 00:59:40.000000', 'temperatura', 966.0000, 'ºC'),
	(109253, 110, '2015-03-15 00:59:41.000000', 'temperatura', 853.0000, 'ºC'),
	(109254, 110, '2015-03-15 00:59:42.000000', 'temperatura', 167.0000, 'ºC'),
	(109255, 110, '2015-03-15 00:59:43.000000', 'temperatura', 678.0000, 'ºC'),
	(109256, 110, '2015-03-15 00:59:44.000000', 'temperatura', 488.0000, 'ºC'),
	(109257, 110, '2015-03-15 00:59:45.000000', 'temperatura', 407.0000, 'ºC'),
	(109258, 110, '2015-03-15 00:59:46.000000', 'temperatura', 570.0000, 'ºC'),
	(109259, 110, '2015-03-15 00:59:47.000000', 'temperatura', 430.0000, 'ºC'),
	(109260, 110, '2015-03-15 00:59:48.000000', 'temperatura', 440.0000, 'ºC'),
	(109261, 110, '2015-03-15 00:59:49.000000', 'temperatura', 909.0000, 'ºC'),
	(109262, 110, '2015-03-15 00:59:50.000000', 'temperatura', 829.0000, 'ºC'),
	(109263, 110, '2015-03-15 00:59:51.000000', 'temperatura', 217.0000, 'ºC'),
	(109264, 110, '2015-03-15 00:59:52.000000', 'temperatura', 1000.0000, 'ºC'),
	(109265, 110, '2015-03-15 00:59:53.000000', 'temperatura', 748.0000, 'ºC'),
	(109266, 110, '2015-03-15 00:59:54.000000', 'temperatura', 740.0000, 'ºC'),
	(109267, 110, '2015-03-15 00:59:55.000000', 'temperatura', 258.0000, 'ºC'),
	(109268, 110, '2015-03-15 00:59:56.000000', 'temperatura', 271.0000, 'ºC'),
	(109269, 110, '2015-03-15 00:59:57.000000', 'temperatura', 582.0000, 'ºC'),
	(109270, 110, '2015-03-15 00:59:58.000000', 'temperatura', 896.0000, 'ºC'),
	(109271, 110, '2015-03-15 00:59:59.000000', 'temperatura', 335.0000, 'ºC'),
	(109272, 110, '2015-03-15 01:00:00.000000', 'temperatura', 187.0000, 'ºC'),
	(109273, 110, '2015-03-15 01:00:01.000000', 'temperatura', 1129.0000, 'ºC'),
	(109274, 110, '2015-03-15 01:00:02.000000', 'temperatura', 286.0000, 'ºC'),
	(109275, 110, '2015-03-15 01:00:03.000000', 'temperatura', 442.0000, 'ºC'),
	(109276, 110, '2015-03-15 01:00:04.000000', 'temperatura', 154.0000, 'ºC'),
	(109277, 110, '2015-03-15 01:00:05.000000', 'temperatura', 645.0000, 'ºC'),
	(109278, 110, '2015-03-15 01:00:06.000000', 'temperatura', 361.0000, 'ºC'),
	(109279, 110, '2015-03-15 01:00:07.000000', 'temperatura', 1073.0000, 'ºC'),
	(109280, 110, '2015-03-15 01:00:08.000000', 'temperatura', 681.0000, 'ºC'),
	(109281, 110, '2015-03-15 01:00:09.000000', 'temperatura', 187.0000, 'ºC'),
	(109282, 110, '2015-03-15 01:00:10.000000', 'temperatura', 93.0000, 'ºC'),
	(109283, 110, '2015-03-15 01:00:11.000000', 'temperatura', 1104.0000, 'ºC'),
	(109284, 110, '2015-03-15 01:00:12.000000', 'temperatura', 442.0000, 'ºC'),
	(109285, 110, '2015-03-15 01:00:13.000000', 'temperatura', 97.0000, 'ºC'),
	(109286, 110, '2015-03-15 01:00:14.000000', 'temperatura', 361.0000, 'ºC'),
	(109287, 110, '2015-03-15 01:00:15.000000', 'temperatura', 313.0000, 'ºC'),
	(109288, 110, '2015-03-15 01:00:16.000000', 'temperatura', 485.0000, 'ºC'),
	(109289, 110, '2015-03-15 01:00:17.000000', 'temperatura', 284.0000, 'ºC'),
	(109290, 110, '2015-03-15 01:00:18.000000', 'temperatura', 1168.0000, 'ºC'),
	(109291, 110, '2015-03-15 01:00:19.000000', 'temperatura', 188.0000, 'ºC'),
	(109292, 110, '2015-03-15 01:00:20.000000', 'temperatura', 1036.0000, 'ºC'),
	(109293, 110, '2015-03-15 01:00:21.000000', 'temperatura', 1015.0000, 'ºC'),
	(109294, 110, '2015-03-15 01:00:22.000000', 'temperatura', 767.0000, 'ºC'),
	(109295, 110, '2015-03-15 01:00:23.000000', 'temperatura', 790.0000, 'ºC'),
	(109296, 110, '2015-03-15 01:00:24.000000', 'temperatura', 453.0000, 'ºC'),
	(109297, 110, '2015-03-15 01:00:25.000000', 'temperatura', 1093.0000, 'ºC'),
	(109298, 110, '2015-03-15 01:00:26.000000', 'temperatura', 506.0000, 'ºC'),
	(109299, 110, '2015-03-15 01:00:27.000000', 'temperatura', 452.0000, 'ºC'),
	(109300, 110, '2015-03-15 01:00:28.000000', 'temperatura', 742.0000, 'ºC'),
	(109301, 110, '2015-03-15 01:00:29.000000', 'temperatura', 1157.0000, 'ºC'),
	(109302, 110, '2015-03-15 01:00:30.000000', 'temperatura', 1158.0000, 'ºC'),
	(109303, 110, '2015-03-15 01:00:31.000000', 'temperatura', 1119.0000, 'ºC'),
	(109304, 110, '2015-03-15 01:00:32.000000', 'temperatura', 923.0000, 'ºC'),
	(109305, 110, '2015-03-15 01:00:33.000000', 'temperatura', 58.0000, 'ºC'),
	(109306, 110, '2015-03-15 01:00:34.000000', 'temperatura', 1121.0000, 'ºC'),
	(109307, 110, '2015-03-15 01:00:35.000000', 'temperatura', 631.0000, 'ºC'),
	(109308, 110, '2015-03-15 01:00:36.000000', 'temperatura', 995.0000, 'ºC'),
	(109309, 110, '2015-03-15 01:00:37.000000', 'temperatura', 679.0000, 'ºC'),
	(109310, 110, '2015-03-15 01:00:38.000000', 'temperatura', 412.0000, 'ºC'),
	(109311, 110, '2015-03-15 01:00:39.000000', 'temperatura', 24.0000, 'ºC'),
	(109312, 110, '2015-03-15 01:00:40.000000', 'temperatura', 85.0000, 'ºC'),
	(109313, 110, '2015-03-15 01:00:41.000000', 'temperatura', 352.0000, 'ºC'),
	(109314, 110, '2015-03-15 01:00:42.000000', 'temperatura', 304.0000, 'ºC'),
	(109315, 110, '2015-03-15 01:00:43.000000', 'temperatura', 467.0000, 'ºC'),
	(109316, 110, '2015-03-15 01:00:44.000000', 'temperatura', 224.0000, 'ºC'),
	(109317, 110, '2015-03-15 01:00:45.000000', 'temperatura', 918.0000, 'ºC'),
	(109318, 110, '2015-03-15 01:00:46.000000', 'temperatura', 318.0000, 'ºC'),
	(109319, 110, '2015-03-15 01:00:47.000000', 'temperatura', 36.0000, 'ºC'),
	(109320, 110, '2015-03-15 01:00:48.000000', 'temperatura', 428.0000, 'ºC'),
	(109321, 110, '2015-03-15 01:00:49.000000', 'temperatura', 831.0000, 'ºC'),
	(109322, 110, '2015-03-15 01:00:50.000000', 'temperatura', 472.0000, 'ºC'),
	(109323, 110, '2015-03-15 01:00:51.000000', 'temperatura', 1069.0000, 'ºC'),
	(109324, 110, '2015-03-15 01:00:52.000000', 'temperatura', 328.0000, 'ºC'),
	(109325, 110, '2015-03-15 01:00:53.000000', 'temperatura', 835.0000, 'ºC'),
	(109326, 110, '2015-03-15 01:00:54.000000', 'temperatura', 790.0000, 'ºC'),
	(109327, 110, '2015-03-15 01:00:55.000000', 'temperatura', 246.0000, 'ºC'),
	(109328, 110, '2015-03-15 01:00:56.000000', 'temperatura', 58.0000, 'ºC'),
	(109329, 110, '2015-03-15 01:00:57.000000', 'temperatura', 756.0000, 'ºC'),
	(109330, 110, '2015-03-15 01:00:58.000000', 'temperatura', 7.0000, 'ºC'),
	(109331, 110, '2015-03-15 01:00:59.000000', 'temperatura', 166.0000, 'ºC'),
	(109332, 110, '2015-03-15 01:01:00.000000', 'temperatura', 810.0000, 'ºC'),
	(109333, 110, '2015-03-15 01:01:01.000000', 'temperatura', 1151.0000, 'ºC'),
	(109334, 110, '2015-03-15 01:01:02.000000', 'temperatura', 926.0000, 'ºC'),
	(109335, 110, '2015-03-15 01:01:03.000000', 'temperatura', 1179.0000, 'ºC'),
	(109336, 110, '2015-03-15 01:01:04.000000', 'temperatura', 716.0000, 'ºC'),
	(109337, 110, '2015-03-15 01:01:05.000000', 'temperatura', 42.0000, 'ºC'),
	(109338, 110, '2015-03-15 01:01:06.000000', 'temperatura', 465.0000, 'ºC'),
	(109339, 110, '2015-03-15 01:01:07.000000', 'temperatura', 1000.0000, 'ºC'),
	(109340, 110, '2015-03-15 01:01:08.000000', 'temperatura', 4.0000, 'ºC'),
	(109341, 110, '2015-03-15 01:01:09.000000', 'temperatura', 623.0000, 'ºC'),
	(109342, 110, '2015-03-15 01:01:10.000000', 'temperatura', 700.0000, 'ºC'),
	(109343, 110, '2015-03-15 01:01:11.000000', 'temperatura', 434.0000, 'ºC'),
	(109344, 110, '2015-03-15 01:01:12.000000', 'temperatura', 69.0000, 'ºC'),
	(109345, 110, '2015-03-15 01:01:13.000000', 'temperatura', 245.0000, 'ºC'),
	(109346, 110, '2015-03-15 01:01:14.000000', 'temperatura', 1016.0000, 'ºC'),
	(109347, 110, '2015-03-15 01:01:15.000000', 'temperatura', 747.0000, 'ºC'),
	(109348, 110, '2015-03-15 01:01:16.000000', 'temperatura', 686.0000, 'ºC'),
	(109349, 110, '2015-03-15 01:01:17.000000', 'temperatura', 1190.0000, 'ºC'),
	(109350, 110, '2015-03-15 01:01:18.000000', 'temperatura', 293.0000, 'ºC'),
	(109351, 110, '2015-03-15 01:01:19.000000', 'temperatura', 295.0000, 'ºC'),
	(109352, 110, '2015-03-15 01:01:20.000000', 'temperatura', 596.0000, 'ºC'),
	(109353, 110, '2015-03-15 01:01:21.000000', 'temperatura', 897.0000, 'ºC'),
	(109354, 110, '2015-03-15 01:01:22.000000', 'temperatura', 298.0000, 'ºC'),
	(109355, 110, '2015-03-15 01:01:23.000000', 'temperatura', 1197.0000, 'ºC'),
	(109356, 110, '2015-03-15 01:01:24.000000', 'temperatura', 293.0000, 'ºC'),
	(109357, 110, '2015-03-15 01:01:25.000000', 'temperatura', 272.0000, 'ºC'),
	(109358, 110, '2015-03-15 01:01:26.000000', 'temperatura', 484.0000, 'ºC'),
	(109359, 110, '2015-03-15 01:01:27.000000', 'temperatura', 405.0000, 'ºC'),
	(109360, 110, '2015-03-15 01:01:28.000000', 'temperatura', 572.0000, 'ºC'),
	(109361, 110, '2015-03-15 01:01:29.000000', 'temperatura', 446.0000, 'ºC'),
	(109362, 110, '2015-03-15 01:01:30.000000', 'temperatura', 513.0000, 'ºC'),
	(109363, 110, '2015-03-15 01:01:31.000000', 'temperatura', 28.0000, 'ºC'),
	(109364, 110, '2015-03-15 01:01:32.000000', 'temperatura', 1002.0000, 'ºC'),
	(109365, 110, '2015-03-15 01:01:33.000000', 'temperatura', 126.0000, 'ºC'),
	(109366, 110, '2015-03-15 01:01:34.000000', 'temperatura', 27.0000, 'ºC'),
	(109367, 110, '2015-03-15 01:01:35.000000', 'temperatura', 955.0000, 'ºC'),
	(109368, 110, '2015-03-15 01:01:36.000000', 'temperatura', 1097.0000, 'ºC'),
	(109369, 110, '2015-03-15 01:01:37.000000', 'temperatura', 218.0000, 'ºC'),
	(109370, 110, '2015-03-15 01:01:38.000000', 'temperatura', 199.0000, 'ºC'),
	(109371, 110, '2015-03-15 01:01:39.000000', 'temperatura', 342.0000, 'ºC'),
	(109372, 110, '2015-03-15 01:01:40.000000', 'temperatura', 1114.0000, 'ºC'),
	(109373, 110, '2015-03-15 01:01:41.000000', 'temperatura', 945.0000, 'ºC'),
	(109374, 110, '2015-03-15 01:01:42.000000', 'temperatura', 184.0000, 'ºC'),
	(109375, 110, '2015-03-15 01:01:43.000000', 'temperatura', 485.0000, 'ºC'),
	(109376, 110, '2015-03-15 01:01:44.000000', 'temperatura', 674.0000, 'ºC'),
	(109377, 110, '2015-03-15 01:01:45.000000', 'temperatura', 714.0000, 'ºC'),
	(109378, 110, '2015-03-15 01:01:46.000000', 'temperatura', 350.0000, 'ºC'),
	(109379, 110, '2015-03-15 01:01:47.000000', 'temperatura', 810.0000, 'ºC'),
	(109380, 110, '2015-03-15 01:01:48.000000', 'temperatura', 597.0000, 'ºC'),
	(109381, 110, '2015-03-15 01:01:49.000000', 'temperatura', 557.0000, 'ºC'),
	(109382, 110, '2015-03-15 01:01:50.000000', 'temperatura', 996.0000, 'ºC'),
	(109383, 110, '2015-03-15 01:01:51.000000', 'temperatura', 910.0000, 'ºC'),
	(109384, 110, '2015-03-15 01:01:52.000000', 'temperatura', 362.0000, 'ºC'),
	(109385, 110, '2015-03-15 01:01:53.000000', 'temperatura', 281.0000, 'ºC'),
	(109386, 110, '2015-03-15 01:01:54.000000', 'temperatura', 321.0000, 'ºC'),
	(109387, 110, '2015-03-15 01:01:55.000000', 'temperatura', 759.0000, 'ºC'),
	(109388, 110, '2015-03-15 01:01:56.000000', 'temperatura', 435.0000, 'ºC'),
	(109389, 110, '2015-03-15 01:01:57.000000', 'temperatura', 1098.0000, 'ºC'),
	(109390, 110, '2015-03-15 01:01:58.000000', 'temperatura', 585.0000, 'ºC'),
	(109391, 110, '2015-03-15 01:01:59.000000', 'temperatura', 832.0000, 'ºC'),
	(109392, 110, '2015-03-15 01:02:00.000000', 'temperatura', 4.0000, 'ºC'),
	(109393, 110, '2015-03-15 01:02:01.000000', 'temperatura', 1124.0000, 'ºC'),
	(109394, 110, '2015-03-15 01:02:02.000000', 'temperatura', 810.0000, 'ºC'),
	(109395, 110, '2015-03-15 01:02:03.000000', 'temperatura', 679.0000, 'ºC'),
	(109396, 110, '2015-03-15 01:02:04.000000', 'temperatura', 966.0000, 'ºC'),
	(109397, 110, '2015-03-15 01:02:05.000000', 'temperatura', 392.0000, 'ºC'),
	(109398, 110, '2015-03-15 01:02:06.000000', 'temperatura', 263.0000, 'ºC'),
	(109399, 110, '2015-03-15 01:02:07.000000', 'temperatura', 141.0000, 'ºC'),
	(109400, 110, '2015-03-15 01:02:08.000000', 'temperatura', 1114.0000, 'ºC'),
	(109401, 110, '2015-03-15 01:02:09.000000', 'temperatura', 348.0000, 'ºC'),
	(109402, 110, '2015-03-15 01:02:10.000000', 'temperatura', 798.0000, 'ºC'),
	(109403, 110, '2015-03-15 01:02:11.000000', 'temperatura', 547.0000, 'ºC'),
	(109404, 110, '2015-03-15 01:02:12.000000', 'temperatura', 342.0000, 'ºC'),
	(109405, 110, '2015-03-15 01:02:13.000000', 'temperatura', 68.0000, 'ºC'),
	(109406, 110, '2015-03-15 01:02:14.000000', 'temperatura', 517.0000, 'ºC'),
	(109407, 110, '2015-03-15 01:02:15.000000', 'temperatura', 1181.0000, 'ºC'),
	(109408, 110, '2015-03-15 01:02:16.000000', 'temperatura', 753.0000, 'ºC'),
	(109409, 110, '2015-03-15 01:02:17.000000', 'temperatura', 223.0000, 'ºC'),
	(109410, 110, '2015-03-15 01:02:18.000000', 'temperatura', 55.0000, 'ºC'),
	(109411, 110, '2015-03-15 01:02:19.000000', 'temperatura', 808.0000, 'ºC'),
	(109412, 110, '2015-03-15 01:02:20.000000', 'temperatura', 275.0000, 'ºC'),
	(109413, 110, '2015-03-15 01:02:21.000000', 'temperatura', 151.0000, 'ºC'),
	(109414, 110, '2015-03-15 01:02:22.000000', 'temperatura', 1131.0000, 'ºC'),
	(109415, 110, '2015-03-15 01:02:23.000000', 'temperatura', 401.0000, 'ºC'),
	(109416, 110, '2015-03-15 01:02:24.000000', 'temperatura', 1013.0000, 'ºC'),
	(109417, 110, '2015-03-15 01:02:25.000000', 'temperatura', 261.0000, 'ºC'),
	(109418, 110, '2015-03-15 01:02:26.000000', 'temperatura', 668.0000, 'ºC'),
	(109419, 110, '2015-03-15 01:02:27.000000', 'temperatura', 157.0000, 'ºC'),
	(109420, 110, '2015-03-15 01:02:28.000000', 'temperatura', 1181.0000, 'ºC'),
	(109421, 110, '2015-03-15 01:02:29.000000', 'temperatura', 637.0000, 'ºC'),
	(109422, 110, '2015-03-15 01:02:30.000000', 'temperatura', 840.0000, 'ºC'),
	(109423, 110, '2015-03-15 01:02:31.000000', 'temperatura', 1090.0000, 'ºC'),
	(109424, 110, '2015-03-15 01:02:32.000000', 'temperatura', 532.0000, 'ºC'),
	(109425, 110, '2015-03-15 01:02:33.000000', 'temperatura', 588.0000, 'ºC'),
	(109426, 110, '2015-03-15 01:02:34.000000', 'temperatura', 145.0000, 'ºC'),
	(109427, 110, '2015-03-15 01:02:35.000000', 'temperatura', 162.0000, 'ºC'),
	(109428, 110, '2015-03-15 01:02:36.000000', 'temperatura', 376.0000, 'ºC'),
	(109429, 110, '2015-03-15 01:02:37.000000', 'temperatura', 195.0000, 'ºC'),
	(109430, 110, '2015-03-15 01:02:38.000000', 'temperatura', 1045.0000, 'ºC'),
	(109431, 110, '2015-03-15 01:02:39.000000', 'temperatura', 1043.0000, 'ºC'),
	(109432, 110, '2015-03-15 01:02:40.000000', 'temperatura', 878.0000, 'ºC'),
	(109433, 110, '2015-03-15 01:02:41.000000', 'temperatura', 64.0000, 'ºC'),
	(109434, 110, '2015-03-15 01:02:42.000000', 'temperatura', 88.0000, 'ºC'),
	(109435, 110, '2015-03-15 01:02:43.000000', 'temperatura', 245.0000, 'ºC'),
	(109436, 110, '2015-03-15 01:02:44.000000', 'temperatura', 963.0000, 'ºC'),
	(109437, 110, '2015-03-15 01:02:45.000000', 'temperatura', 482.0000, 'ºC'),
	(109438, 110, '2015-03-15 01:02:46.000000', 'temperatura', 719.0000, 'ºC'),
	(109439, 110, '2015-03-15 01:02:47.000000', 'temperatura', 952.0000, 'ºC'),
	(109440, 110, '2015-03-15 01:02:48.000000', 'temperatura', 204.0000, 'ºC'),
	(109441, 110, '2015-03-15 01:02:49.000000', 'temperatura', 563.0000, 'ºC'),
	(109442, 110, '2015-03-15 01:02:50.000000', 'temperatura', 1003.0000, 'ºC'),
	(109443, 110, '2015-03-15 01:02:51.000000', 'temperatura', 926.0000, 'ºC'),
	(109444, 110, '2015-03-15 01:02:52.000000', 'temperatura', 422.0000, 'ºC'),
	(109445, 110, '2015-03-15 01:02:53.000000', 'temperatura', 532.0000, 'ºC'),
	(109446, 110, '2015-03-15 01:02:54.000000', 'temperatura', 193.0000, 'ºC'),
	(109447, 110, '2015-03-15 01:02:55.000000', 'temperatura', 572.0000, 'ºC'),
	(109448, 110, '2015-03-15 01:02:56.000000', 'temperatura', 1082.0000, 'ºC'),
	(109449, 110, '2015-03-15 01:02:57.000000', 'temperatura', 95.0000, 'ºC'),
	(109450, 110, '2015-03-15 01:02:58.000000', 'temperatura', 829.0000, 'ºC'),
	(109451, 110, '2015-03-15 01:02:59.000000', 'temperatura', 258.0000, 'ºC'),
	(109452, 110, '2015-03-15 01:03:00.000000', 'temperatura', 6.0000, 'ºC'),
	(109453, 110, '2015-03-15 01:03:01.000000', 'temperatura', 454.0000, 'ºC'),
	(109454, 110, '2015-03-15 01:03:02.000000', 'temperatura', 1054.0000, 'ºC'),
	(109455, 110, '2015-03-15 01:03:03.000000', 'temperatura', 307.0000, 'ºC'),
	(109456, 110, '2015-03-15 01:03:04.000000', 'temperatura', 773.0000, 'ºC'),
	(109457, 110, '2015-03-15 01:03:05.000000', 'temperatura', 546.0000, 'ºC'),
	(109458, 110, '2015-03-15 01:03:06.000000', 'temperatura', 410.0000, 'ºC'),
	(109459, 110, '2015-03-15 01:03:07.000000', 'temperatura', 411.0000, 'ºC'),
	(109460, 110, '2015-03-15 01:03:08.000000', 'temperatura', 828.0000, 'ºC'),
	(109461, 110, '2015-03-15 01:03:09.000000', 'temperatura', 508.0000, 'ºC'),
	(109462, 110, '2015-03-15 01:03:10.000000', 'temperatura', 56.0000, 'ºC'),
	(109463, 110, '2015-03-15 01:03:11.000000', 'temperatura', 1157.0000, 'ºC'),
	(109464, 110, '2015-03-15 01:03:12.000000', 'temperatura', 818.0000, 'ºC'),
	(109465, 110, '2015-03-15 01:03:13.000000', 'temperatura', 619.0000, 'ºC'),
	(109466, 110, '2015-03-15 01:03:14.000000', 'temperatura', 641.0000, 'ºC'),
	(109467, 110, '2015-03-15 01:03:15.000000', 'temperatura', 147.0000, 'ºC'),
	(109468, 110, '2015-03-15 01:03:16.000000', 'temperatura', 15.0000, 'ºC'),
	(109469, 110, '2015-03-15 01:03:17.000000', 'temperatura', 835.0000, 'ºC'),
	(109470, 110, '2015-03-15 01:03:18.000000', 'temperatura', 529.0000, 'ºC'),
	(109471, 110, '2015-03-15 01:03:19.000000', 'temperatura', 142.0000, 'ºC'),
	(109472, 110, '2015-03-15 01:03:20.000000', 'temperatura', 323.0000, 'ºC'),
	(109473, 110, '2015-03-15 01:03:21.000000', 'temperatura', 1191.0000, 'ºC'),
	(109474, 110, '2015-03-15 01:03:22.000000', 'temperatura', 185.0000, 'ºC'),
	(109475, 110, '2015-03-15 01:03:23.000000', 'temperatura', 955.0000, 'ºC'),
	(109476, 110, '2015-03-15 01:03:24.000000', 'temperatura', 617.0000, 'ºC'),
	(109477, 110, '2015-03-15 01:03:25.000000', 'temperatura', 223.0000, 'ºC'),
	(109478, 110, '2015-03-15 01:03:26.000000', 'temperatura', 465.0000, 'ºC'),
	(109479, 110, '2015-03-15 01:03:27.000000', 'temperatura', 457.0000, 'ºC'),
	(109480, 110, '2015-03-15 01:03:28.000000', 'temperatura', 888.0000, 'ºC'),
	(109481, 110, '2015-03-15 01:03:29.000000', 'temperatura', 672.0000, 'ºC'),
	(109482, 110, '2015-03-15 01:03:30.000000', 'temperatura', 697.0000, 'ºC'),
	(109483, 110, '2015-03-15 01:03:31.000000', 'temperatura', 270.0000, 'ºC'),
	(109484, 110, '2015-03-15 01:03:32.000000', 'temperatura', 457.0000, 'ºC'),
	(109485, 110, '2015-03-15 01:03:33.000000', 'temperatura', 277.0000, 'ºC'),
	(109486, 110, '2015-03-15 01:03:34.000000', 'temperatura', 12.0000, 'ºC'),
	(109487, 110, '2015-03-15 01:03:35.000000', 'temperatura', 433.0000, 'ºC'),
	(109488, 110, '2015-03-15 01:03:36.000000', 'temperatura', 928.0000, 'ºC'),
	(109489, 110, '2015-03-15 01:03:37.000000', 'temperatura', 944.0000, 'ºC'),
	(109490, 110, '2015-03-15 01:03:38.000000', 'temperatura', 733.0000, 'ºC'),
	(109491, 110, '2015-03-15 01:03:39.000000', 'temperatura', 834.0000, 'ºC'),
	(109492, 110, '2015-03-15 01:03:40.000000', 'temperatura', 770.0000, 'ºC'),
	(109493, 110, '2015-03-15 01:03:41.000000', 'temperatura', 151.0000, 'ºC'),
	(109494, 110, '2015-03-15 01:03:42.000000', 'temperatura', 845.0000, 'ºC'),
	(109495, 110, '2015-03-15 01:03:43.000000', 'temperatura', 173.0000, 'ºC'),
	(109496, 110, '2015-03-15 01:03:44.000000', 'temperatura', 729.0000, 'ºC'),
	(109497, 110, '2015-03-15 01:03:45.000000', 'temperatura', 727.0000, 'ºC'),
	(109498, 110, '2015-03-15 01:03:46.000000', 'temperatura', 250.0000, 'ºC'),
	(109499, 110, '2015-03-15 01:03:47.000000', 'temperatura', 269.0000, 'ºC'),
	(109500, 110, '2015-03-15 01:03:48.000000', 'temperatura', 595.0000, 'ºC'),
	(109501, 110, '2015-03-15 01:03:49.000000', 'temperatura', 970.0000, 'ºC'),
	(109502, 110, '2015-03-15 01:03:50.000000', 'temperatura', 666.0000, 'ºC'),
	(109503, 110, '2015-03-15 01:03:51.000000', 'temperatura', 418.0000, 'ºC'),
	(109504, 110, '2015-03-15 01:03:52.000000', 'temperatura', 92.0000, 'ºC'),
	(109505, 110, '2015-03-15 01:03:53.000000', 'temperatura', 410.0000, 'ºC'),
	(109506, 110, '2015-03-15 01:03:54.000000', 'temperatura', 572.0000, 'ºC'),
	(109507, 110, '2015-03-15 01:03:55.000000', 'temperatura', 429.0000, 'ºC'),
	(109508, 110, '2015-03-15 01:03:56.000000', 'temperatura', 432.0000, 'ºC'),
	(109509, 110, '2015-03-15 01:03:57.000000', 'temperatura', 875.0000, 'ºC'),
	(109510, 110, '2015-03-15 01:03:58.000000', 'temperatura', 677.0000, 'ºC'),
	(109511, 110, '2015-03-15 01:03:59.000000', 'temperatura', 762.0000, 'ºC'),
	(109512, 110, '2015-03-15 01:04:00.000000', 'temperatura', 577.0000, 'ºC'),
	(109513, 110, '2015-03-15 01:04:01.000000', 'temperatura', 601.0000, 'ºC'),
	(109514, 110, '2015-03-15 01:04:02.000000', 'temperatura', 75.0000, 'ºC'),
	(109515, 110, '2015-03-15 01:04:03.000000', 'temperatura', 974.0000, 'ºC'),
	(109516, 110, '2015-03-15 01:04:04.000000', 'temperatura', 1044.0000, 'ºC'),
	(109517, 110, '2015-03-15 01:04:05.000000', 'temperatura', 1099.0000, 'ºC'),
	(109518, 110, '2015-03-15 01:04:06.000000', 'temperatura', 1163.0000, 'ºC'),
	(109519, 110, '2015-03-15 01:04:07.000000', 'temperatura', 120.0000, 'ºC'),
	(109520, 110, '2015-03-15 01:04:08.000000', 'temperatura', 711.0000, 'ºC'),
	(109521, 110, '2015-03-15 01:04:09.000000', 'temperatura', 795.0000, 'ºC'),
	(109522, 110, '2015-03-15 01:04:10.000000', 'temperatura', 642.0000, 'ºC'),
	(109523, 110, '2015-03-15 01:04:11.000000', 'temperatura', 827.0000, 'ºC'),
	(109524, 110, '2015-03-15 01:04:12.000000', 'temperatura', 1011.0000, 'ºC'),
	(109525, 110, '2015-03-15 01:04:13.000000', 'temperatura', 173.0000, 'ºC'),
	(109526, 110, '2015-03-15 01:04:14.000000', 'temperatura', 231.0000, 'ºC'),
	(109527, 110, '2015-03-15 01:04:15.000000', 'temperatura', 635.0000, 'ºC'),
	(109528, 110, '2015-03-15 01:04:16.000000', 'temperatura', 86.0000, 'ºC'),
	(109529, 110, '2015-03-15 01:04:17.000000', 'temperatura', 925.0000, 'ºC'),
	(109530, 110, '2015-03-15 01:04:18.000000', 'temperatura', 766.0000, 'ºC'),
	(109531, 110, '2015-03-15 01:04:19.000000', 'temperatura', 1055.0000, 'ºC'),
	(109532, 110, '2015-03-15 01:04:20.000000', 'temperatura', 580.0000, 'ºC'),
	(109533, 110, '2015-03-15 01:04:21.000000', 'temperatura', 936.0000, 'ºC'),
	(109534, 110, '2015-03-15 01:04:22.000000', 'temperatura', 539.0000, 'ºC'),
	(109535, 110, '2015-03-15 01:04:23.000000', 'temperatura', 1087.0000, 'ºC'),
	(109536, 110, '2015-03-15 01:04:24.000000', 'temperatura', 219.0000, 'ºC'),
	(109537, 110, '2015-03-15 01:04:25.000000', 'temperatura', 236.0000, 'ºC'),
	(109538, 110, '2015-03-15 01:04:26.000000', 'temperatura', 524.0000, 'ºC'),
	(109539, 110, '2015-03-15 01:04:27.000000', 'temperatura', 713.0000, 'ºC'),
	(109540, 110, '2015-03-15 01:04:28.000000', 'temperatura', 793.0000, 'ºC'),
	(109541, 110, '2015-03-15 01:04:29.000000', 'temperatura', 624.0000, 'ºC'),
	(109542, 110, '2015-03-15 01:04:30.000000', 'temperatura', 744.0000, 'ºC'),
	(109543, 110, '2015-03-15 01:04:31.000000', 'temperatura', 648.0000, 'ºC'),
	(109544, 110, '2015-03-15 01:04:32.000000', 'temperatura', 1009.0000, 'ºC'),
	(109545, 110, '2015-03-15 01:04:33.000000', 'temperatura', 703.0000, 'ºC'),
	(109546, 110, '2015-03-15 01:04:34.000000', 'temperatura', 487.0000, 'ºC'),
	(109547, 110, '2015-03-15 01:04:35.000000', 'temperatura', 327.0000, 'ºC'),
	(109548, 110, '2015-03-15 01:04:36.000000', 'temperatura', 176.0000, 'ºC'),
	(109549, 110, '2015-03-15 01:04:37.000000', 'temperatura', 1096.0000, 'ºC'),
	(109550, 110, '2015-03-15 01:04:38.000000', 'temperatura', 155.0000, 'ºC'),
	(109551, 110, '2015-03-15 01:04:39.000000', 'temperatura', 1086.0000, 'ºC'),
	(109552, 110, '2015-03-15 01:04:40.000000', 'temperatura', 166.0000, 'ºC'),
	(109553, 110, '2015-03-15 01:04:41.000000', 'temperatura', 1175.0000, 'ºC'),
	(109554, 110, '2015-03-15 01:04:42.000000', 'temperatura', 574.0000, 'ºC'),
	(109555, 110, '2015-03-15 01:04:43.000000', 'temperatura', 548.0000, 'ºC'),
	(109556, 110, '2015-03-15 01:04:44.000000', 'temperatura', 1017.0000, 'ºC'),
	(109557, 110, '2015-03-15 01:04:45.000000', 'temperatura', 1043.0000, 'ºC'),
	(109558, 110, '2015-03-15 01:04:46.000000', 'temperatura', 965.0000, 'ºC'),
	(109559, 110, '2015-03-15 01:04:47.000000', 'temperatura', 496.0000, 'ºC'),
	(109560, 110, '2015-03-15 01:04:48.000000', 'temperatura', 787.0000, 'ºC'),
	(109561, 110, '2015-03-15 01:04:49.000000', 'temperatura', 45.0000, 'ºC'),
	(109562, 110, '2015-03-15 01:04:50.000000', 'temperatura', 267.0000, 'ºC'),
	(109563, 110, '2015-03-15 01:04:51.000000', 'temperatura', 1198.0000, 'ºC'),
	(109564, 110, '2015-03-15 01:04:52.000000', 'temperatura', 391.0000, 'ºC'),
	(109565, 110, '2015-03-15 01:04:53.000000', 'temperatura', 759.0000, 'ºC'),
	(109566, 110, '2015-03-15 01:04:54.000000', 'temperatura', 226.0000, 'ºC'),
	(109567, 110, '2015-03-15 01:04:55.000000', 'temperatura', 51.0000, 'ºC'),
	(109568, 110, '2015-03-15 01:04:56.000000', 'temperatura', 780.0000, 'ºC'),
	(109569, 110, '2015-03-15 01:04:57.000000', 'temperatura', 147.0000, 'ºC'),
	(109570, 110, '2015-03-15 01:04:58.000000', 'temperatura', 796.0000, 'ºC'),
	(109571, 110, '2015-03-15 01:04:59.000000', 'temperatura', 1141.0000, 'ºC'),
	(109572, 110, '2015-03-15 01:05:00.000000', 'temperatura', 915.0000, 'ºC'),
	(109573, 110, '2015-03-15 01:05:01.000000', 'temperatura', 1154.0000, 'ºC'),
	(109574, 110, '2015-03-15 01:05:02.000000', 'temperatura', 624.0000, 'ºC'),
	(109575, 110, '2015-03-15 01:05:03.000000', 'temperatura', 861.0000, 'ºC'),
	(109576, 110, '2015-03-15 01:05:04.000000', 'temperatura', 32.0000, 'ºC'),
	(109577, 110, '2015-03-15 01:05:05.000000', 'temperatura', 1176.0000, 'ºC'),
	(109578, 110, '2015-03-15 01:05:06.000000', 'temperatura', 984.0000, 'ºC'),
	(109579, 110, '2015-03-15 01:05:07.000000', 'temperatura', 193.0000, 'ºC'),
	(109580, 110, '2015-03-15 01:05:08.000000', 'temperatura', 416.0000, 'ºC'),
	(109581, 110, '2015-03-15 01:05:09.000000', 'temperatura', 298.0000, 'ºC'),
	(109582, 110, '2015-03-15 01:05:10.000000', 'temperatura', 246.0000, 'ºC'),
	(109583, 110, '2015-03-15 01:05:11.000000', 'temperatura', 334.0000, 'ºC'),
	(109584, 110, '2015-03-15 01:05:12.000000', 'temperatura', 935.0000, 'ºC'),
	(109585, 110, '2015-03-15 01:05:13.000000', 'temperatura', 72.0000, 'ºC'),
	(109586, 110, '2015-03-15 01:05:14.000000', 'temperatura', 1156.0000, 'ºC'),
	(109587, 110, '2015-03-15 01:05:15.000000', 'temperatura', 765.0000, 'ºC'),
	(109588, 110, '2015-03-15 01:05:16.000000', 'temperatura', 359.0000, 'ºC'),
	(109589, 110, '2015-03-15 01:05:17.000000', 'temperatura', 698.0000, 'ºC'),
	(109590, 110, '2015-03-15 01:05:18.000000', 'temperatura', 14.0000, 'ºC'),
	(109591, 110, '2015-03-15 01:05:19.000000', 'temperatura', 376.0000, 'ºC'),
	(109592, 110, '2015-03-15 01:05:20.000000', 'temperatura', 641.0000, 'ºC'),
	(109593, 110, '2015-03-15 01:05:21.000000', 'temperatura', 876.0000, 'ºC'),
	(109594, 110, '2015-03-15 01:05:22.000000', 'temperatura', 59.0000, 'ºC'),
	(109595, 110, '2015-03-15 01:05:23.000000', 'temperatura', 65.0000, 'ºC'),
	(109596, 110, '2015-03-15 01:05:24.000000', 'temperatura', 150.0000, 'ºC'),
	(109597, 110, '2015-03-15 01:05:25.000000', 'temperatura', 556.0000, 'ºC'),
	(109598, 110, '2015-03-15 01:05:26.000000', 'temperatura', 1129.0000, 'ºC'),
	(109599, 110, '2015-03-15 01:05:27.000000', 'temperatura', 377.0000, 'ºC'),
	(109600, 110, '2015-03-15 01:05:28.000000', 'temperatura', 897.0000, 'ºC'),
	(109601, 110, '2015-03-15 01:05:29.000000', 'temperatura', 958.0000, 'ºC'),
	(109602, 110, '2015-03-15 01:05:30.000000', 'temperatura', 898.0000, 'ºC'),
	(109603, 110, '2015-03-15 01:05:31.000000', 'temperatura', 415.0000, 'ºC'),
	(109604, 110, '2015-03-15 01:05:32.000000', 'temperatura', 583.0000, 'ºC'),
	(109605, 110, '2015-03-15 01:05:33.000000', 'temperatura', 468.0000, 'ºC'),
	(109606, 110, '2015-03-15 01:05:34.000000', 'temperatura', 595.0000, 'ºC'),
	(109607, 110, '2015-03-15 01:05:35.000000', 'temperatura', 368.0000, 'ºC'),
	(109608, 110, '2015-03-15 01:05:36.000000', 'temperatura', 57.0000, 'ºC'),
	(109609, 110, '2015-03-15 01:05:37.000000', 'temperatura', 382.0000, 'ºC'),
	(109610, 110, '2015-03-15 01:05:38.000000', 'temperatura', 540.0000, 'ºC'),
	(109611, 110, '2015-03-15 01:05:39.000000', 'temperatura', 353.0000, 'ºC'),
	(109612, 110, '2015-03-15 01:05:40.000000', 'temperatura', 145.0000, 'ºC'),
	(109613, 110, '2015-03-15 01:05:41.000000', 'temperatura', 867.0000, 'ºC'),
	(109614, 110, '2015-03-15 01:05:42.000000', 'temperatura', 299.0000, 'ºC'),
	(109615, 110, '2015-03-15 01:05:43.000000', 'temperatura', 97.0000, 'ºC'),
	(109616, 110, '2015-03-15 01:05:44.000000', 'temperatura', 787.0000, 'ºC'),
	(109617, 110, '2015-03-15 01:05:45.000000', 'temperatura', 46.0000, 'ºC'),
	(109618, 110, '2015-03-15 01:05:46.000000', 'temperatura', 268.0000, 'ºC'),
	(109619, 110, '2015-03-15 01:05:47.000000', 'temperatura', 4.0000, 'ºC'),
	(109620, 110, '2015-03-15 01:05:48.000000', 'temperatura', 415.0000, 'ºC'),
	(109621, 110, '2015-03-15 01:05:49.000000', 'temperatura', 865.0000, 'ºC'),
	(109622, 110, '2015-03-15 01:05:50.000000', 'temperatura', 680.0000, 'ºC'),
	(109623, 110, '2015-03-15 01:05:51.000000', 'temperatura', 806.0000, 'ºC'),
	(109624, 110, '2015-03-15 01:05:52.000000', 'temperatura', 788.0000, 'ºC'),
	(109625, 110, '2015-03-15 01:05:53.000000', 'temperatura', 325.0000, 'ºC'),
	(109626, 110, '2015-03-15 01:05:54.000000', 'temperatura', 461.0000, 'ºC'),
	(109627, 110, '2015-03-15 01:05:55.000000', 'temperatura', 130.0000, 'ºC'),
	(109628, 110, '2015-03-15 01:05:56.000000', 'temperatura', 468.0000, 'ºC'),
	(109629, 110, '2015-03-15 01:05:57.000000', 'temperatura', 752.0000, 'ºC'),
	(109630, 110, '2015-03-15 01:05:58.000000', 'temperatura', 1156.0000, 'ºC'),
	(109631, 110, '2015-03-15 01:05:59.000000', 'temperatura', 1125.0000, 'ºC'),
	(109632, 110, '2015-03-15 01:06:00.000000', 'temperatura', 957.0000, 'ºC'),
	(109633, 110, '2015-03-15 01:06:01.000000', 'temperatura', 209.0000, 'ºC'),
	(109634, 110, '2015-03-15 01:06:02.000000', 'temperatura', 575.0000, 'ºC'),
	(109635, 110, '2015-03-15 01:06:03.000000', 'temperatura', 1048.0000, 'ºC'),
	(109636, 110, '2015-03-15 01:06:04.000000', 'temperatura', 1117.0000, 'ºC'),
	(109637, 110, '2015-03-15 01:06:05.000000', 'temperatura', 41.0000, 'ºC'),
	(109638, 110, '2015-03-15 01:06:06.000000', 'temperatura', 455.0000, 'ºC'),
	(109639, 110, '2015-03-15 01:06:07.000000', 'temperatura', 950.0000, 'ºC'),
	(109640, 110, '2015-03-15 01:06:08.000000', 'temperatura', 988.0000, 'ºC'),
	(109641, 110, '2015-03-15 01:06:09.000000', 'temperatura', 888.0000, 'ºC'),
	(109642, 110, '2015-03-15 01:06:10.000000', 'temperatura', 278.0000, 'ºC'),
	(109643, 110, '2015-03-15 01:06:11.000000', 'temperatura', 1125.0000, 'ºC'),
	(109644, 110, '2015-03-15 01:06:12.000000', 'temperatura', 1194.0000, 'ºC'),
	(109645, 110, '2015-03-15 01:06:13.000000', 'temperatura', 195.0000, 'ºC'),
	(109646, 110, '2015-03-15 01:06:14.000000', 'temperatura', 992.0000, 'ºC'),
	(109647, 110, '2015-03-15 01:06:15.000000', 'temperatura', 777.0000, 'ºC'),
	(109648, 110, '2015-03-15 01:06:16.000000', 'temperatura', 908.0000, 'ºC'),
	(109649, 110, '2015-03-15 01:06:17.000000', 'temperatura', 1011.0000, 'ºC'),
	(109650, 110, '2015-03-15 01:06:18.000000', 'temperatura', 1131.0000, 'ºC'),
	(109651, 110, '2015-03-15 01:06:19.000000', 'temperatura', 222.0000, 'ºC'),
	(109652, 110, '2015-03-15 01:06:20.000000', 'temperatura', 117.0000, 'ºC'),
	(109653, 110, '2015-03-15 01:06:21.000000', 'temperatura', 1121.0000, 'ºC'),
	(109654, 110, '2015-03-15 01:06:22.000000', 'temperatura', 453.0000, 'ºC'),
	(109655, 110, '2015-03-15 01:06:23.000000', 'temperatura', 103.0000, 'ºC'),
	(109656, 110, '2015-03-15 01:06:24.000000', 'temperatura', 357.0000, 'ºC'),
	(109657, 110, '2015-03-15 01:06:25.000000', 'temperatura', 275.0000, 'ºC'),
	(109658, 110, '2015-03-15 01:06:26.000000', 'temperatura', 305.0000, 'ºC'),
	(109659, 110, '2015-03-15 01:06:27.000000', 'temperatura', 702.0000, 'ºC'),
	(109660, 110, '2015-03-15 01:06:28.000000', 'temperatura', 195.0000, 'ºC'),
	(109661, 110, '2015-03-15 01:06:29.000000', 'temperatura', 71.0000, 'ºC'),
	(109662, 110, '2015-03-15 01:06:30.000000', 'temperatura', 968.0000, 'ºC'),
	(109663, 110, '2015-03-15 01:06:31.000000', 'temperatura', 1028.0000, 'ºC'),
	(109664, 110, '2015-03-15 01:06:32.000000', 'temperatura', 1038.0000, 'ºC'),
	(109665, 110, '2015-03-15 01:06:33.000000', 'temperatura', 904.0000, 'ºC'),
	(109666, 110, '2015-03-15 01:06:34.000000', 'temperatura', 210.0000, 'ºC'),
	(109667, 110, '2015-03-15 01:06:35.000000', 'temperatura', 735.0000, 'ºC'),
	(109668, 110, '2015-03-15 01:06:36.000000', 'temperatura', 647.0000, 'ºC'),
	(109669, 110, '2015-03-15 01:06:37.000000', 'temperatura', 1030.0000, 'ºC'),
	(109670, 110, '2015-03-15 01:06:38.000000', 'temperatura', 811.0000, 'ºC'),
	(109671, 110, '2015-03-15 01:06:39.000000', 'temperatura', 964.0000, 'ºC'),
	(109672, 110, '2015-03-15 01:06:40.000000', 'temperatura', 1189.0000, 'ºC'),
	(109673, 110, '2015-03-15 01:06:41.000000', 'temperatura', 653.0000, 'ºC'),
	(109674, 110, '2015-03-15 01:06:42.000000', 'temperatura', 898.0000, 'ºC'),
	(109675, 110, '2015-03-15 01:06:43.000000', 'temperatura', 133.0000, 'ºC'),
	(109676, 110, '2015-03-15 01:06:44.000000', 'temperatura', 369.0000, 'ºC'),
	(109677, 110, '2015-03-15 01:06:45.000000', 'temperatura', 246.0000, 'ºC'),
	(109678, 110, '2015-03-15 01:06:46.000000', 'temperatura', 124.0000, 'ºC'),
	(109679, 110, '2015-03-15 01:06:47.000000', 'temperatura', 1084.0000, 'ºC'),
	(109680, 110, '2015-03-15 01:06:48.000000', 'temperatura', 248.0000, 'ºC'),
	(109681, 110, '2015-03-15 01:06:49.000000', 'temperatura', 389.0000, 'ºC'),
	(109682, 110, '2015-03-15 01:06:50.000000', 'temperatura', 2.0000, 'ºC'),
	(109683, 110, '2015-03-15 01:06:51.000000', 'temperatura', 45.0000, 'ºC'),
	(109684, 110, '2015-03-15 01:06:52.000000', 'temperatura', 216.0000, 'ºC'),
	(109685, 110, '2015-03-15 01:06:53.000000', 'temperatura', 947.0000, 'ºC'),
	(109686, 110, '2015-03-15 01:06:54.000000', 'temperatura', 489.0000, 'ºC'),
	(109687, 110, '2015-03-15 01:06:55.000000', 'temperatura', 802.0000, 'ºC'),
	(109688, 110, '2015-03-15 01:06:56.000000', 'temperatura', 146.0000, 'ºC'),
	(109689, 110, '2015-03-15 01:06:57.000000', 'temperatura', 724.0000, 'ºC'),
	(109690, 110, '2015-03-15 01:06:58.000000', 'temperatura', 781.0000, 'ºC'),
	(109691, 110, '2015-03-15 01:06:59.000000', 'temperatura', 536.0000, 'ºC'),
	(109692, 110, '2015-03-15 01:07:00.000000', 'temperatura', 337.0000, 'ºC'),
	(109693, 110, '2015-03-15 01:07:01.000000', 'temperatura', 75.0000, 'ºC'),
	(109694, 110, '2015-03-15 01:07:02.000000', 'temperatura', 567.0000, 'ºC'),
	(109695, 110, '2015-03-15 01:07:03.000000', 'temperatura', 210.0000, 'ºC'),
	(109696, 110, '2015-03-15 01:07:04.000000', 'temperatura', 551.0000, 'ºC'),
	(109697, 110, '2015-03-15 01:07:05.000000', 'temperatura', 926.0000, 'ºC'),
	(109698, 110, '2015-03-15 01:07:06.000000', 'temperatura', 576.0000, 'ºC'),
	(109699, 110, '2015-03-15 01:07:07.000000', 'temperatura', 104.0000, 'ºC'),
	(109700, 110, '2015-03-15 01:07:08.000000', 'temperatura', 1191.0000, 'ºC'),
	(109701, 110, '2015-03-15 01:07:09.000000', 'temperatura', 844.0000, 'ºC'),
	(109702, 110, '2015-03-15 01:07:10.000000', 'temperatura', 647.0000, 'ºC'),
	(109703, 110, '2015-03-15 01:07:11.000000', 'temperatura', 704.0000, 'ºC'),
	(109704, 110, '2015-03-15 01:07:12.000000', 'temperatura', 381.0000, 'ºC'),
	(109705, 110, '2015-03-15 01:07:13.000000', 'temperatura', 993.0000, 'ºC'),
	(109706, 110, '2015-03-15 01:07:14.000000', 'temperatura', 221.0000, 'ºC'),
	(109707, 110, '2015-03-15 01:07:15.000000', 'temperatura', 528.0000, 'ºC'),
	(109708, 110, '2015-03-15 01:07:16.000000', 'temperatura', 779.0000, 'ºC'),
	(109709, 110, '2015-03-15 01:07:17.000000', 'temperatura', 1109.0000, 'ºC'),
	(109710, 110, '2015-03-15 01:07:18.000000', 'temperatura', 808.0000, 'ºC'),
	(109711, 110, '2015-03-15 01:07:19.000000', 'temperatura', 713.0000, 'ºC'),
	(109712, 110, '2015-03-15 01:07:20.000000', 'temperatura', 1141.0000, 'ºC'),
	(109713, 110, '2015-03-15 01:07:21.000000', 'temperatura', 1168.0000, 'ºC'),
	(109714, 110, '2015-03-15 01:07:22.000000', 'temperatura', 18.0000, 'ºC'),
	(109715, 110, '2015-03-15 01:07:23.000000', 'temperatura', 185.0000, 'ºC'),
	(109716, 110, '2015-03-15 01:07:24.000000', 'temperatura', 873.0000, 'ºC'),
	(109717, 110, '2015-03-15 01:07:25.000000', 'temperatura', 209.0000, 'ºC'),
	(109718, 110, '2015-03-15 01:07:26.000000', 'temperatura', 826.0000, 'ºC'),
	(109719, 110, '2015-03-15 01:07:27.000000', 'temperatura', 1104.0000, 'ºC'),
	(109720, 110, '2015-03-15 01:07:28.000000', 'temperatura', 641.0000, 'ºC'),
	(109721, 110, '2015-03-15 01:07:29.000000', 'temperatura', 1093.0000, 'ºC'),
	(109722, 110, '2015-03-15 01:07:30.000000', 'temperatura', 1145.0000, 'ºC'),
	(109723, 110, '2015-03-15 01:07:31.000000', 'temperatura', 47.0000, 'ºC'),
	(109724, 110, '2015-03-15 01:07:32.000000', 'temperatura', 398.0000, 'ºC'),
	(109725, 110, '2015-03-15 01:07:33.000000', 'temperatura', 652.0000, 'ºC'),
	(109726, 110, '2015-03-15 01:07:34.000000', 'temperatura', 864.0000, 'ºC'),
	(109727, 110, '2015-03-15 01:07:35.000000', 'temperatura', 1168.0000, 'ºC'),
	(109728, 110, '2015-03-15 01:07:36.000000', 'temperatura', 845.0000, 'ºC'),
	(109729, 110, '2015-03-15 01:07:37.000000', 'temperatura', 723.0000, 'ºC'),
	(109730, 110, '2015-03-15 01:07:38.000000', 'temperatura', 1079.0000, 'ºC'),
	(109731, 110, '2015-03-15 01:07:39.000000', 'temperatura', 826.0000, 'ºC'),
	(109732, 110, '2015-03-15 01:07:40.000000', 'temperatura', 896.0000, 'ºC'),
	(109733, 110, '2015-03-15 01:07:41.000000', 'temperatura', 801.0000, 'ºC'),
	(109734, 110, '2015-03-15 01:07:42.000000', 'temperatura', 116.0000, 'ºC'),
	(109735, 110, '2015-03-15 01:07:43.000000', 'temperatura', 578.0000, 'ºC'),
	(109736, 110, '2015-03-15 01:07:44.000000', 'temperatura', 141.0000, 'ºC'),
	(109737, 110, '2015-03-15 01:07:45.000000', 'temperatura', 174.0000, 'ºC'),
	(109738, 110, '2015-03-15 01:07:46.000000', 'temperatura', 449.0000, 'ºC'),
	(109739, 110, '2015-03-15 01:07:47.000000', 'temperatura', 521.0000, 'ºC'),
	(109740, 110, '2015-03-15 01:07:48.000000', 'temperatura', 59.0000, 'ºC'),
	(109741, 110, '2015-03-15 01:07:49.000000', 'temperatura', 1131.0000, 'ºC'),
	(109742, 110, '2015-03-15 01:07:50.000000', 'temperatura', 681.0000, 'ºC'),
	(109743, 110, '2015-03-15 01:07:51.000000', 'temperatura', 12.0000, 'ºC'),
	(109744, 110, '2015-03-15 01:07:52.000000', 'temperatura', 417.0000, 'ºC'),
	(109745, 110, '2015-03-15 01:07:53.000000', 'temperatura', 849.0000, 'ºC'),
	(109746, 110, '2015-03-15 01:07:54.000000', 'temperatura', 597.0000, 'ºC'),
	(109747, 110, '2015-03-15 01:07:55.000000', 'temperatura', 437.0000, 'ºC'),
	(109748, 110, '2015-03-15 01:07:56.000000', 'temperatura', 395.0000, 'ºC'),
	(109749, 110, '2015-03-15 01:07:57.000000', 'temperatura', 663.0000, 'ºC'),
	(109750, 110, '2015-03-15 01:07:58.000000', 'temperatura', 930.0000, 'ºC'),
	(109751, 110, '2015-03-15 01:07:59.000000', 'temperatura', 264.0000, 'ºC'),
	(109752, 110, '2015-03-15 01:08:00.000000', 'temperatura', 927.0000, 'ºC'),
	(109753, 110, '2015-03-15 01:08:01.000000', 'temperatura', 247.0000, 'ºC'),
	(109754, 110, '2015-03-15 01:08:02.000000', 'temperatura', 851.0000, 'ºC'),
	(109755, 110, '2015-03-15 01:08:03.000000', 'temperatura', 1118.0000, 'ºC'),
	(109756, 110, '2015-03-15 01:08:04.000000', 'temperatura', 636.0000, 'ºC'),
	(109757, 110, '2015-03-15 01:08:05.000000', 'temperatura', 1027.0000, 'ºC'),
	(109758, 110, '2015-03-15 01:08:06.000000', 'temperatura', 826.0000, 'ºC'),
	(109759, 110, '2015-03-15 01:08:07.000000', 'temperatura', 1052.0000, 'ºC'),
	(109760, 110, '2015-03-15 01:08:08.000000', 'temperatura', 381.0000, 'ºC'),
	(109761, 110, '2015-03-15 01:08:09.000000', 'temperatura', 1150.0000, 'ºC'),
	(109762, 110, '2015-03-15 01:08:10.000000', 'temperatura', 1008.0000, 'ºC'),
	(109763, 110, '2015-03-15 01:08:11.000000', 'temperatura', 389.0000, 'ºC'),
	(109764, 110, '2015-03-15 01:08:12.000000', 'temperatura', 122.0000, 'ºC'),
	(109765, 110, '2015-03-15 01:08:13.000000', 'temperatura', 644.0000, 'ºC'),
	(109766, 110, '2015-03-15 01:08:14.000000', 'temperatura', 454.0000, 'ºC'),
	(109767, 110, '2015-03-15 01:08:15.000000', 'temperatura', 341.0000, 'ºC'),
	(109768, 110, '2015-03-15 01:08:16.000000', 'temperatura', 340.0000, 'ºC'),
	(109769, 110, '2015-03-15 01:08:17.000000', 'temperatura', 680.0000, 'ºC'),
	(109770, 110, '2015-03-15 01:08:18.000000', 'temperatura', 1180.0000, 'ºC'),
	(109771, 110, '2015-03-15 01:08:19.000000', 'temperatura', 259.0000, 'ºC'),
	(109772, 110, '2015-03-15 01:08:20.000000', 'temperatura', 155.0000, 'ºC'),
	(109773, 110, '2015-03-15 01:08:21.000000', 'temperatura', 1199.0000, 'ºC'),
	(109774, 110, '2015-03-15 01:08:22.000000', 'temperatura', 729.0000, 'ºC'),
	(109775, 110, '2015-03-15 01:08:23.000000', 'temperatura', 50.0000, 'ºC'),
	(109776, 110, '2015-03-15 01:08:24.000000', 'temperatura', 465.0000, 'ºC'),
	(109777, 110, '2015-03-15 01:08:25.000000', 'temperatura', 976.0000, 'ºC'),
	(109778, 110, '2015-03-15 01:08:26.000000', 'temperatura', 1084.0000, 'ºC'),
	(109779, 110, '2015-03-15 01:08:27.000000', 'temperatura', 91.0000, 'ºC'),
	(109780, 110, '2015-03-15 01:08:28.000000', 'temperatura', 807.0000, 'ºC'),
	(109781, 110, '2015-03-15 01:08:29.000000', 'temperatura', 160.0000, 'ºC'),
	(109782, 110, '2015-03-15 01:08:30.000000', 'temperatura', 778.0000, 'ºC'),
	(109783, 110, '2015-03-15 01:08:31.000000', 'temperatura', 1013.0000, 'ºC'),
	(109784, 110, '2015-03-15 01:08:32.000000', 'temperatura', 333.0000, 'ºC'),
	(109785, 110, '2015-03-15 01:08:33.000000', 'temperatura', 1024.0000, 'ºC'),
	(109786, 110, '2015-03-15 01:08:34.000000', 'temperatura', 521.0000, 'ºC'),
	(109787, 110, '2015-03-15 01:08:35.000000', 'temperatura', 733.0000, 'ºC'),
	(109788, 110, '2015-03-15 01:08:36.000000', 'temperatura', 903.0000, 'ºC'),
	(109789, 110, '2015-03-15 01:08:37.000000', 'temperatura', 1118.0000, 'ºC'),
	(109790, 110, '2015-03-15 01:08:38.000000', 'temperatura', 482.0000, 'ºC'),
	(109791, 110, '2015-03-15 01:08:39.000000', 'temperatura', 256.0000, 'ºC'),
	(109792, 110, '2015-03-15 01:08:40.000000', 'temperatura', 1033.0000, 'ºC'),
	(109793, 110, '2015-03-15 01:08:41.000000', 'temperatura', 800.0000, 'ºC'),
	(109794, 110, '2015-03-15 01:08:42.000000', 'temperatura', 900.0000, 'ºC'),
	(109795, 110, '2015-03-15 01:08:43.000000', 'temperatura', 901.0000, 'ºC'),
	(109796, 110, '2015-03-15 01:08:44.000000', 'temperatura', 605.0000, 'ºC'),
	(109797, 110, '2015-03-15 01:08:45.000000', 'temperatura', 321.0000, 'ºC'),
	(109798, 110, '2015-03-15 01:08:46.000000', 'temperatura', 992.0000, 'ºC'),
	(109799, 110, '2015-03-15 01:08:47.000000', 'temperatura', 397.0000, 'ºC'),
	(109800, 110, '2015-03-15 01:08:48.000000', 'temperatura', 208.0000, 'ºC'),
	(109801, 110, '2015-03-15 01:08:49.000000', 'temperatura', 1050.0000, 'ºC'),
	(109802, 110, '2015-03-15 01:08:50.000000', 'temperatura', 1027.0000, 'ºC'),
	(109803, 110, '2015-03-15 01:08:51.000000', 'temperatura', 784.0000, 'ºC'),
	(109804, 110, '2015-03-15 01:08:52.000000', 'temperatura', 840.0000, 'ºC'),
	(109805, 110, '2015-03-15 01:08:53.000000', 'temperatura', 648.0000, 'ºC'),
	(109806, 110, '2015-03-15 01:08:54.000000', 'temperatura', 723.0000, 'ºC'),
	(109807, 110, '2015-03-15 01:08:55.000000', 'temperatura', 470.0000, 'ºC'),
	(109808, 110, '2015-03-15 01:08:56.000000', 'temperatura', 183.0000, 'ºC'),
	(109809, 110, '2015-03-15 01:08:57.000000', 'temperatura', 706.0000, 'ºC'),
	(109810, 110, '2015-03-15 01:08:58.000000', 'temperatura', 580.0000, 'ºC'),
	(109811, 110, '2015-03-15 01:08:59.000000', 'temperatura', 784.0000, 'ºC'),
	(109812, 110, '2015-03-15 01:09:00.000000', 'temperatura', 980.0000, 'ºC'),
	(109813, 110, '2015-03-15 01:09:01.000000', 'temperatura', 147.0000, 'ºC'),
	(109814, 110, '2015-03-15 01:09:02.000000', 'temperatura', 197.0000, 'ºC'),
	(109815, 110, '2015-03-15 01:09:03.000000', 'temperatura', 544.0000, 'ºC'),
	(109816, 110, '2015-03-15 01:09:04.000000', 'temperatura', 931.0000, 'ºC'),
	(109817, 110, '2015-03-15 01:09:05.000000', 'temperatura', 623.0000, 'ºC'),
	(109818, 110, '2015-03-15 01:09:06.000000', 'temperatura', 322.0000, 'ºC'),
	(109819, 110, '2015-03-15 01:09:07.000000', 'temperatura', 943.0000, 'ºC'),
	(109820, 110, '2015-03-15 01:09:08.000000', 'temperatura', 148.0000, 'ºC'),
	(109821, 110, '2015-03-15 01:09:09.000000', 'temperatura', 310.0000, 'ºC'),
	(109822, 110, '2015-03-15 01:09:10.000000', 'temperatura', 1109.0000, 'ºC'),
	(109823, 110, '2015-03-15 01:09:11.000000', 'temperatura', 1014.0000, 'ºC'),
	(109824, 110, '2015-03-15 01:09:12.000000', 'temperatura', 543.0000, 'ºC'),
	(109825, 110, '2015-03-15 01:09:13.000000', 'temperatura', 873.0000, 'ºC'),
	(109826, 110, '2015-03-15 01:09:14.000000', 'temperatura', 336.0000, 'ºC'),
	(109827, 110, '2015-03-15 01:09:15.000000', 'temperatura', 262.0000, 'ºC'),
	(109828, 110, '2015-03-15 01:09:16.000000', 'temperatura', 303.0000, 'ºC'),
	(109829, 110, '2015-03-15 01:09:17.000000', 'temperatura', 728.0000, 'ºC'),
	(109830, 110, '2015-03-15 01:09:18.000000', 'temperatura', 334.0000, 'ºC'),
	(109831, 110, '2015-03-15 01:09:19.000000', 'temperatura', 685.0000, 'ºC'),
	(109832, 110, '2015-03-15 01:09:20.000000', 'temperatura', 25.0000, 'ºC'),
	(109833, 110, '2015-03-15 01:09:21.000000', 'temperatura', 469.0000, 'ºC'),
	(109834, 110, '2015-03-15 01:09:22.000000', 'temperatura', 1072.0000, 'ºC'),
	(109835, 110, '2015-03-15 01:09:23.000000', 'temperatura', 351.0000, 'ºC'),
	(109836, 110, '2015-03-15 01:09:24.000000', 'temperatura', 940.0000, 'ºC'),
	(109837, 110, '2015-03-15 01:09:25.000000', 'temperatura', 50.0000, 'ºC'),
	(109838, 110, '2015-03-15 01:09:26.000000', 'temperatura', 1027.0000, 'ºC'),
	(109839, 110, '2015-03-15 01:09:27.000000', 'temperatura', 189.0000, 'ºC'),
	(109840, 110, '2015-03-15 01:09:28.000000', 'temperatura', 261.0000, 'ºC'),
	(109841, 110, '2015-03-15 01:09:29.000000', 'temperatura', 740.0000, 'ºC'),
	(109842, 110, '2015-03-15 01:09:30.000000', 'temperatura', 518.0000, 'ºC'),
	(109843, 110, '2015-03-15 01:09:31.000000', 'temperatura', 368.0000, 'ºC'),
	(109844, 110, '2015-03-15 01:09:32.000000', 'temperatura', 290.0000, 'ºC'),
	(109845, 110, '2015-03-15 01:09:33.000000', 'temperatura', 344.0000, 'ºC'),
	(109846, 110, '2015-03-15 01:09:34.000000', 'temperatura', 852.0000, 'ºC'),
	(109847, 110, '2015-03-15 01:09:35.000000', 'temperatura', 830.0000, 'ºC'),
	(109848, 110, '2015-03-15 01:09:36.000000', 'temperatura', 393.0000, 'ºC'),
	(109849, 110, '2015-03-15 01:09:37.000000', 'temperatura', 674.0000, 'ºC'),
	(109850, 110, '2015-03-15 01:09:38.000000', 'temperatura', 994.0000, 'ºC'),
	(109851, 110, '2015-03-15 01:09:39.000000', 'temperatura', 547.0000, 'ºC'),
	(109852, 110, '2015-03-15 01:09:40.000000', 'temperatura', 953.0000, 'ºC'),
	(109853, 110, '2015-03-15 01:09:41.000000', 'temperatura', 726.0000, 'ºC'),
	(109854, 110, '2015-03-15 01:09:42.000000', 'temperatura', 769.0000, 'ºC'),
	(109855, 110, '2015-03-15 01:09:43.000000', 'temperatura', 471.0000, 'ºC'),
	(109856, 110, '2015-03-15 01:09:44.000000', 'temperatura', 47.0000, 'ºC'),
	(109857, 110, '2015-03-15 01:09:45.000000', 'temperatura', 20.0000, 'ºC'),
	(109858, 110, '2015-03-15 01:09:46.000000', 'temperatura', 1163.0000, 'ºC'),
	(109859, 110, '2015-03-15 01:09:47.000000', 'temperatura', 955.0000, 'ºC'),
	(109860, 110, '2015-03-15 01:09:48.000000', 'temperatura', 85.0000, 'ºC'),
	(109861, 110, '2015-03-15 01:09:49.000000', 'temperatura', 1159.0000, 'ºC'),
	(109862, 110, '2015-03-15 01:09:50.000000', 'temperatura', 744.0000, 'ºC'),
	(109863, 110, '2015-03-15 01:09:51.000000', 'temperatura', 242.0000, 'ºC'),
	(109864, 110, '2015-03-15 01:09:52.000000', 'temperatura', 178.0000, 'ºC'),
	(109865, 110, '2015-03-15 01:09:53.000000', 'temperatura', 165.0000, 'ºC'),
	(109866, 110, '2015-03-15 01:09:54.000000', 'temperatura', 290.0000, 'ºC'),
	(109867, 110, '2015-03-15 01:09:55.000000', 'temperatura', 955.0000, 'ºC'),
	(109868, 110, '2015-03-15 01:09:56.000000', 'temperatura', 308.0000, 'ºC'),
	(109869, 110, '2015-03-15 01:09:57.000000', 'temperatura', 1075.0000, 'ºC'),
	(109870, 110, '2015-03-15 01:09:58.000000', 'temperatura', 852.0000, 'ºC'),
	(109871, 110, '2015-03-15 01:09:59.000000', 'temperatura', 1037.0000, 'ºC'),
	(109872, 110, '2015-03-15 01:10:00.000000', 'temperatura', 226.0000, 'ºC'),
	(109873, 110, '2015-03-15 01:10:01.000000', 'temperatura', 423.0000, 'ºC'),
	(109874, 110, '2015-03-15 01:10:02.000000', 'temperatura', 235.0000, 'ºC'),
	(109875, 110, '2015-03-15 01:10:03.000000', 'temperatura', 1106.0000, 'ºC'),
	(109876, 110, '2015-03-15 01:10:04.000000', 'temperatura', 27.0000, 'ºC'),
	(109877, 110, '2015-03-15 01:10:05.000000', 'temperatura', 417.0000, 'ºC'),
	(109878, 110, '2015-03-15 01:10:06.000000', 'temperatura', 806.0000, 'ºC'),
	(109879, 110, '2015-03-15 01:10:07.000000', 'temperatura', 380.0000, 'ºC'),
	(109880, 110, '2015-03-15 01:10:08.000000', 'temperatura', 682.0000, 'ºC'),
	(109881, 110, '2015-03-15 01:10:09.000000', 'temperatura', 1072.0000, 'ºC'),
	(109882, 110, '2015-03-15 01:10:10.000000', 'temperatura', 913.0000, 'ºC'),
	(109883, 110, '2015-03-15 01:10:11.000000', 'temperatura', 149.0000, 'ºC'),
	(109884, 110, '2015-03-15 01:10:12.000000', 'temperatura', 408.0000, 'ºC'),
	(109885, 110, '2015-03-15 01:10:13.000000', 'temperatura', 394.0000, 'ºC'),
	(109886, 110, '2015-03-15 01:10:14.000000', 'temperatura', 748.0000, 'ºC'),
	(109887, 110, '2015-03-15 01:10:15.000000', 'temperatura', 156.0000, 'ºC'),
	(109888, 110, '2015-03-15 01:10:16.000000', 'temperatura', 935.0000, 'ºC'),
	(109889, 110, '2015-03-15 01:10:17.000000', 'temperatura', 609.0000, 'ºC'),
	(109890, 110, '2015-03-15 01:10:18.000000', 'temperatura', 239.0000, 'ºC'),
	(109891, 110, '2015-03-15 01:10:19.000000', 'temperatura', 571.0000, 'ºC'),
	(109892, 110, '2015-03-15 01:10:20.000000', 'temperatura', 938.0000, 'ºC'),
	(109893, 110, '2015-03-15 01:10:21.000000', 'temperatura', 575.0000, 'ºC'),
	(109894, 110, '2015-03-15 01:10:22.000000', 'temperatura', 64.0000, 'ºC'),
	(109895, 110, '2015-03-15 01:10:23.000000', 'temperatura', 996.0000, 'ºC'),
	(109896, 110, '2015-03-15 01:10:24.000000', 'temperatura', 1188.0000, 'ºC'),
	(109897, 110, '2015-03-15 01:10:25.000000', 'temperatura', 554.0000, 'ºC'),
	(109898, 110, '2015-03-15 01:10:26.000000', 'temperatura', 405.0000, 'ºC'),
	(109899, 110, '2015-03-15 01:10:27.000000', 'temperatura', 363.0000, 'ºC'),
	(109900, 110, '2015-03-15 01:10:28.000000', 'temperatura', 602.0000, 'ºC'),
	(109901, 110, '2015-03-15 01:10:29.000000', 'temperatura', 721.0000, 'ºC'),
	(109902, 110, '2015-03-15 01:10:30.000000', 'temperatura', 598.0000, 'ºC'),
	(109903, 110, '2015-03-15 01:10:31.000000', 'temperatura', 829.0000, 'ºC'),
	(109904, 110, '2015-03-15 01:10:32.000000', 'temperatura', 1152.0000, 'ºC'),
	(109905, 110, '2015-03-15 01:10:33.000000', 'temperatura', 873.0000, 'ºC'),
	(109906, 110, '2015-03-15 01:10:34.000000', 'temperatura', 911.0000, 'ºC'),
	(109907, 110, '2015-03-15 01:10:35.000000', 'temperatura', 737.0000, 'ºC'),
	(109908, 110, '2015-03-15 01:10:36.000000', 'temperatura', 952.0000, 'ºC'),
	(109909, 110, '2015-03-15 01:10:37.000000', 'temperatura', 151.0000, 'ºC'),
	(109910, 110, '2015-03-15 01:10:38.000000', 'temperatura', 297.0000, 'ºC'),
	(109911, 110, '2015-03-15 01:10:39.000000', 'temperatura', 1034.0000, 'ºC'),
	(109912, 110, '2015-03-15 01:10:40.000000', 'temperatura', 677.0000, 'ºC'),
	(109913, 110, '2015-03-15 01:10:41.000000', 'temperatura', 285.0000, 'ºC'),
	(109914, 110, '2015-03-15 01:10:42.000000', 'temperatura', 594.0000, 'ºC'),
	(109915, 110, '2015-03-15 01:10:43.000000', 'temperatura', 914.0000, 'ºC'),
	(109916, 110, '2015-03-15 01:10:44.000000', 'temperatura', 389.0000, 'ºC'),
	(109917, 110, '2015-03-15 01:10:45.000000', 'temperatura', 406.0000, 'ºC'),
	(109918, 110, '2015-03-15 01:10:46.000000', 'temperatura', 863.0000, 'ºC'),
	(109919, 110, '2015-03-15 01:10:47.000000', 'temperatura', 696.0000, 'ºC'),
	(109920, 110, '2015-03-15 01:10:48.000000', 'temperatura', 891.0000, 'ºC'),
	(109921, 110, '2015-03-15 01:10:49.000000', 'temperatura', 1169.0000, 'ºC'),
	(109922, 110, '2015-03-15 01:10:50.000000', 'temperatura', 773.0000, 'ºC'),
	(109923, 110, '2015-03-15 01:10:51.000000', 'temperatura', 358.0000, 'ºC'),
	(109924, 110, '2015-03-15 01:10:52.000000', 'temperatura', 669.0000, 'ºC'),
	(109925, 110, '2015-03-15 01:10:53.000000', 'temperatura', 1075.0000, 'ºC'),
	(109926, 110, '2015-03-15 01:10:54.000000', 'temperatura', 965.0000, 'ºC'),
	(109927, 110, '2015-03-15 01:10:55.000000', 'temperatura', 402.0000, 'ºC'),
	(109928, 110, '2015-03-15 01:10:56.000000', 'temperatura', 317.0000, 'ºC'),
	(109929, 110, '2015-03-15 01:10:57.000000', 'temperatura', 379.0000, 'ºC'),
	(109930, 110, '2015-03-15 01:10:58.000000', 'temperatura', 945.0000, 'ºC'),
	(109931, 110, '2015-03-15 01:10:59.000000', 'temperatura', 1189.0000, 'ºC'),
	(109932, 110, '2015-03-15 01:11:00.000000', 'temperatura', 710.0000, 'ºC'),
	(109933, 110, '2015-03-15 01:11:01.000000', 'temperatura', 1184.0000, 'ºC'),
	(109934, 110, '2015-03-15 01:11:02.000000', 'temperatura', 190.0000, 'ºC'),
	(109935, 110, '2015-03-15 01:11:03.000000', 'temperatura', 997.0000, 'ºC'),
	(109936, 110, '2015-03-15 01:11:04.000000', 'temperatura', 817.0000, 'ºC'),
	(109937, 110, '2015-03-15 01:11:05.000000', 'temperatura', 1093.0000, 'ºC'),
	(109938, 110, '2015-03-15 01:11:06.000000', 'temperatura', 616.0000, 'ºC'),
	(109939, 110, '2015-03-15 01:11:07.000000', 'temperatura', 1003.0000, 'ºC'),
	(109940, 110, '2015-03-15 01:11:08.000000', 'temperatura', 767.0000, 'ºC'),
	(109941, 110, '2015-03-15 01:11:09.000000', 'temperatura', 825.0000, 'ºC'),
	(109942, 110, '2015-03-15 01:11:10.000000', 'temperatura', 626.0000, 'ºC'),
	(109943, 110, '2015-03-15 01:11:11.000000', 'temperatura', 653.0000, 'ºC'),
	(109944, 110, '2015-03-15 01:11:12.000000', 'temperatura', 191.0000, 'ºC'),
	(109945, 110, '2015-03-15 01:11:13.000000', 'temperatura', 194.0000, 'ºC'),
	(109946, 110, '2015-03-15 01:11:14.000000', 'temperatura', 397.0000, 'ºC'),
	(109947, 110, '2015-03-15 01:11:15.000000', 'temperatura', 203.0000, 'ºC'),
	(109948, 110, '2015-03-15 01:11:16.000000', 'temperatura', 1026.0000, 'ºC'),
	(109949, 110, '2015-03-15 01:11:17.000000', 'temperatura', 922.0000, 'ºC'),
	(109950, 110, '2015-03-15 01:11:18.000000', 'temperatura', 330.0000, 'ºC'),
	(109951, 110, '2015-03-15 01:11:19.000000', 'temperatura', 85.0000, 'ºC'),
	(109952, 110, '2015-03-15 01:11:20.000000', 'temperatura', 637.0000, 'ºC'),
	(109953, 110, '2015-03-15 01:11:21.000000', 'temperatura', 531.0000, 'ºC'),
	(109954, 110, '2015-03-15 01:11:22.000000', 'temperatura', 744.0000, 'ºC'),
	(109955, 110, '2015-03-15 01:11:23.000000', 'temperatura', 926.0000, 'ºC'),
	(109956, 110, '2015-03-15 01:11:24.000000', 'temperatura', 0.0000, 'ºC'),
	(109957, 110, '2015-03-15 01:11:25.000000', 'temperatura', 822.0000, 'ºC'),
	(109958, 110, '2015-03-15 01:11:26.000000', 'temperatura', 511.0000, 'ºC'),
	(109959, 110, '2015-03-15 01:11:27.000000', 'temperatura', 89.0000, 'ºC'),
	(109960, 110, '2015-03-15 01:11:28.000000', 'temperatura', 112.0000, 'ºC'),
	(109961, 110, '2015-03-15 01:11:29.000000', 'temperatura', 294.0000, 'ºC'),
	(109962, 110, '2015-03-15 01:11:30.000000', 'temperatura', 1135.0000, 'ºC'),
	(109963, 110, '2015-03-15 01:11:31.000000', 'temperatura', 1193.0000, 'ºC'),
	(109964, 110, '2015-03-15 01:11:32.000000', 'temperatura', 161.0000, 'ºC'),
	(109965, 110, '2015-03-15 01:11:33.000000', 'temperatura', 825.0000, 'ºC'),
	(109966, 110, '2015-03-15 01:11:34.000000', 'temperatura', 45.0000, 'ºC'),
	(109967, 110, '2015-03-15 01:11:35.000000', 'temperatura', 150.0000, 'ºC'),
	(109968, 110, '2015-03-15 01:11:36.000000', 'temperatura', 617.0000, 'ºC'),
	(109969, 110, '2015-03-15 01:11:37.000000', 'temperatura', 234.0000, 'ºC'),
	(109970, 110, '2015-03-15 01:11:38.000000', 'temperatura', 519.0000, 'ºC'),
	(109971, 110, '2015-03-15 01:11:39.000000', 'temperatura', 693.0000, 'ºC'),
	(109972, 110, '2015-03-15 01:11:40.000000', 'temperatura', 709.0000, 'ºC'),
	(109973, 110, '2015-03-15 01:11:41.000000', 'temperatura', 265.0000, 'ºC'),
	(109974, 110, '2015-03-15 01:11:42.000000', 'temperatura', 398.0000, 'ºC'),
	(109975, 110, '2015-03-15 01:11:43.000000', 'temperatura', 1198.0000, 'ºC'),
	(109976, 110, '2015-03-15 01:11:44.000000', 'temperatura', 1195.0000, 'ºC'),
	(109977, 110, '2015-03-15 01:11:45.000000', 'temperatura', 1184.0000, 'ºC'),
	(109978, 110, '2015-03-15 01:11:46.000000', 'temperatura', 1133.0000, 'ºC'),
	(109979, 110, '2015-03-15 01:11:47.000000', 'temperatura', 913.0000, 'ºC'),
	(109980, 110, '2015-03-15 01:11:48.000000', 'temperatura', 1168.0000, 'ºC'),
	(109981, 110, '2015-03-15 01:11:49.000000', 'temperatura', 702.0000, 'ºC'),
	(109982, 110, '2015-03-15 01:11:50.000000', 'temperatura', 4.0000, 'ºC'),
	(109983, 110, '2015-03-15 01:11:51.000000', 'temperatura', 317.0000, 'ºC'),
	(109984, 110, '2015-03-15 01:11:52.000000', 'temperatura', 371.0000, 'ºC'),
	(109985, 110, '2015-03-15 01:11:53.000000', 'temperatura', 907.0000, 'ºC'),
	(109986, 110, '2015-03-15 01:11:54.000000', 'temperatura', 1022.0000, 'ºC'),
	(109987, 110, '2015-03-15 01:11:55.000000', 'temperatura', 1191.0000, 'ºC'),
	(109988, 110, '2015-03-15 01:11:56.000000', 'temperatura', 487.0000, 'ºC'),
	(109989, 110, '2015-03-15 01:11:57.000000', 'temperatura', 62.0000, 'ºC'),
	(109990, 110, '2015-03-15 01:11:58.000000', 'temperatura', 50.0000, 'ºC'),
	(109991, 110, '2015-03-15 01:11:59.000000', 'temperatura', 67.0000, 'ºC'),
	(109992, 110, '2015-03-15 01:12:00.000000', 'temperatura', 183.0000, 'ºC'),
	(109993, 110, '2015-03-15 01:12:01.000000', 'temperatura', 716.0000, 'ºC'),
	(109994, 110, '2015-03-15 01:12:02.000000', 'temperatura', 633.0000, 'ºC'),
	(109995, 110, '2015-03-15 01:12:03.000000', 'temperatura', 1016.0000, 'ºC'),
	(109996, 110, '2015-03-15 01:12:04.000000', 'temperatura', 781.0000, 'ºC'),
	(109997, 110, '2015-03-15 01:12:05.000000', 'temperatura', 857.0000, 'ºC'),
	(109998, 110, '2015-03-15 01:12:06.000000', 'temperatura', 744.0000, 'ºC'),
	(109999, 110, '2015-03-15 01:12:07.000000', 'temperatura', 1150.0000, 'ºC'),
	(110000, 110, '2015-03-15 01:12:08.000000', 'temperatura', 1120.0000, 'ºC'),
	(110001, 110, '2015-03-15 01:12:09.000000', 'temperatura', 947.0000, 'ºC'),
	(110002, 110, '2015-03-15 01:12:10.000000', 'temperatura', 177.0000, 'ºC'),
	(110003, 110, '2015-03-15 01:12:11.000000', 'temperatura', 446.0000, 'ºC'),
	(110004, 110, '2015-03-15 01:12:12.000000', 'temperatura', 500.0000, 'ºC'),
	(110005, 110, '2015-03-15 01:12:13.000000', 'temperatura', 1161.0000, 'ºC'),
	(110006, 110, '2015-03-15 01:12:14.000000', 'temperatura', 707.0000, 'ºC'),
	(110007, 110, '2015-03-15 01:12:15.000000', 'temperatura', 52.0000, 'ºC'),
	(110008, 110, '2015-03-15 01:12:16.000000', 'temperatura', 541.0000, 'ºC'),
	(110009, 110, '2015-03-15 01:12:17.000000', 'temperatura', 146.0000, 'ºC'),
	(110010, 110, '2015-03-15 01:12:18.000000', 'temperatura', 310.0000, 'ºC'),
	(110011, 110, '2015-03-15 01:12:19.000000', 'temperatura', 1111.0000, 'ºC'),
	(110012, 110, '2015-03-15 01:12:20.000000', 'temperatura', 1026.0000, 'ºC'),
	(110013, 110, '2015-03-15 01:12:21.000000', 'temperatura', 599.0000, 'ºC'),
	(110014, 110, '2015-03-15 01:12:22.000000', 'temperatura', 1115.0000, 'ºC'),
	(110015, 110, '2015-03-15 01:12:23.000000', 'temperatura', 178.0000, 'ºC'),
	(110016, 110, '2015-03-15 01:12:24.000000', 'temperatura', 1146.0000, 'ºC'),
	(110017, 110, '2015-03-15 01:12:25.000000', 'temperatura', 398.0000, 'ºC'),
	(110018, 110, '2015-03-15 01:12:26.000000', 'temperatura', 952.0000, 'ºC'),
	(110019, 110, '2015-03-15 01:12:27.000000', 'temperatura', 1168.0000, 'ºC'),
	(110020, 110, '2015-03-15 01:12:28.000000', 'temperatura', 585.0000, 'ºC'),
	(110021, 110, '2015-03-15 01:12:29.000000', 'temperatura', 619.0000, 'ºC'),
	(110022, 110, '2015-03-15 01:12:30.000000', 'temperatura', 140.0000, 'ºC'),
	(110023, 110, '2015-03-15 01:12:31.000000', 'temperatura', 45.0000, 'ºC'),
	(110024, 110, '2015-03-15 01:12:32.000000', 'temperatura', 1007.0000, 'ºC'),
	(110025, 110, '2015-03-15 01:12:33.000000', 'temperatura', 98.0000, 'ºC'),
	(110026, 110, '2015-03-15 01:12:34.000000', 'temperatura', 1069.0000, 'ºC'),
	(110027, 110, '2015-03-15 01:12:35.000000', 'temperatura', 251.0000, 'ºC'),
	(110028, 110, '2015-03-15 01:12:36.000000', 'temperatura', 449.0000, 'ºC'),
	(110029, 110, '2015-03-15 01:12:37.000000', 'temperatura', 292.0000, 'ºC'),
	(110030, 110, '2015-03-15 01:12:38.000000', 'temperatura', 116.0000, 'ºC'),
	(110031, 110, '2015-03-15 01:12:39.000000', 'temperatura', 902.0000, 'ºC'),
	(110032, 110, '2015-03-15 01:12:40.000000', 'temperatura', 564.0000, 'ºC'),
	(110033, 110, '2015-03-15 01:12:41.000000', 'temperatura', 115.0000, 'ºC'),
	(110034, 110, '2015-03-15 01:12:42.000000', 'temperatura', 81.0000, 'ºC'),
	(110035, 110, '2015-03-15 01:12:43.000000', 'temperatura', 63.0000, 'ºC'),
	(110036, 110, '2015-03-15 01:12:44.000000', 'temperatura', 72.0000, 'ºC'),
	(110037, 110, '2015-03-15 01:12:45.000000', 'temperatura', 170.0000, 'ºC'),
	(110038, 110, '2015-03-15 01:12:46.000000', 'temperatura', 635.0000, 'ºC'),
	(110039, 110, '2015-03-15 01:12:47.000000', 'temperatura', 266.0000, 'ºC'),
	(110040, 110, '2015-03-15 01:12:48.000000', 'temperatura', 623.0000, 'ºC'),
	(110041, 110, '2015-03-15 01:12:49.000000', 'temperatura', 1121.0000, 'ºC'),
	(110042, 110, '2015-03-15 01:12:50.000000', 'temperatura', 134.0000, 'ºC'),
	(110043, 110, '2015-03-15 01:12:51.000000', 'temperatura', 910.0000, 'ºC'),
	(110044, 110, '2015-03-15 01:12:52.000000', 'temperatura', 549.0000, 'ºC'),
	(110045, 110, '2015-03-15 01:12:53.000000', 'temperatura', 15.0000, 'ºC'),
	(110046, 110, '2015-03-15 01:12:54.000000', 'temperatura', 827.0000, 'ºC'),
	(110047, 110, '2015-03-15 01:12:55.000000', 'temperatura', 492.0000, 'ºC'),
	(110048, 110, '2015-03-15 01:12:56.000000', 'temperatura', 1180.0000, 'ºC'),
	(110049, 110, '2015-03-15 01:12:57.000000', 'temperatura', 822.0000, 'ºC'),
	(110050, 110, '2015-03-15 01:12:58.000000', 'temperatura', 572.0000, 'ºC'),
	(110051, 110, '2015-03-15 01:12:59.000000', 'temperatura', 396.0000, 'ºC'),
	(110052, 110, '2015-03-15 01:13:00.000000', 'temperatura', 264.0000, 'ºC'),
	(110053, 110, '2015-03-15 01:13:01.000000', 'temperatura', 132.0000, 'ºC'),
	(110054, 110, '2015-03-15 01:13:02.000000', 'temperatura', 1068.0000, 'ºC'),
	(110055, 110, '2015-03-15 01:13:03.000000', 'temperatura', 144.0000, 'ºC'),
	(110056, 110, '2015-03-15 01:13:04.000000', 'temperatura', 1117.0000, 'ºC'),
	(110057, 110, '2015-03-15 01:13:05.000000', 'temperatura', 352.0000, 'ºC'),
	(110058, 110, '2015-03-15 01:13:06.000000', 'temperatura', 810.0000, 'ºC'),
	(110059, 110, '2015-03-15 01:13:07.000000', 'temperatura', 595.0000, 'ºC'),
	(110060, 110, '2015-03-15 01:13:08.000000', 'temperatura', 544.0000, 'ºC'),
	(110061, 110, '2015-03-15 01:13:09.000000', 'temperatura', 939.0000, 'ºC'),
	(110062, 110, '2015-03-15 01:13:10.000000', 'temperatura', 660.0000, 'ºC'),
	(110063, 110, '2015-03-15 01:13:11.000000', 'temperatura', 484.0000, 'ºC'),
	(110064, 110, '2015-03-15 01:13:12.000000', 'temperatura', 443.0000, 'ºC'),
	(110065, 110, '2015-03-15 01:13:13.000000', 'temperatura', 763.0000, 'ºC'),
	(110066, 110, '2015-03-15 01:13:14.000000', 'temperatura', 85.0000, 'ºC'),
	(110067, 110, '2015-03-15 01:13:15.000000', 'temperatura', 535.0000, 'ºC'),
	(110068, 110, '2015-03-15 01:13:16.000000', 'temperatura', 23.0000, 'ºC'),
	(110069, 110, '2015-03-15 01:13:17.000000', 'temperatura', 909.0000, 'ºC'),
	(110070, 110, '2015-03-15 01:13:18.000000', 'temperatura', 876.0000, 'ºC'),
	(110071, 110, '2015-03-15 01:13:19.000000', 'temperatura', 456.0000, 'ºC'),
	(110072, 110, '2015-03-15 01:13:20.000000', 'temperatura', 850.0000, 'ºC'),
	(110073, 110, '2015-03-15 01:13:21.000000', 'temperatura', 482.0000, 'ºC'),
	(110074, 110, '2015-03-15 01:13:22.000000', 'temperatura', 1063.0000, 'ºC'),
	(110075, 110, '2015-03-15 01:13:23.000000', 'temperatura', 267.0000, 'ºC'),
	(110076, 110, '2015-03-15 01:13:24.000000', 'temperatura', 548.0000, 'ºC'),
	(110077, 110, '2015-03-15 01:13:25.000000', 'temperatura', 739.0000, 'ºC'),
	(110078, 110, '2015-03-15 01:13:26.000000', 'temperatura', 851.0000, 'ºC'),
	(110079, 110, '2015-03-15 01:13:27.000000', 'temperatura', 837.0000, 'ºC'),
	(110080, 110, '2015-03-15 01:13:28.000000', 'temperatura', 433.0000, 'ºC'),
	(110081, 110, '2015-03-15 01:13:29.000000', 'temperatura', 855.0000, 'ºC'),
	(110082, 110, '2015-03-15 01:13:30.000000', 'temperatura', 575.0000, 'ºC'),
	(110083, 110, '2015-03-15 01:13:31.000000', 'temperatura', 313.0000, 'ºC'),
	(110084, 110, '2015-03-15 01:13:32.000000', 'temperatura', 1041.0000, 'ºC'),
	(110085, 110, '2015-03-15 01:13:33.000000', 'temperatura', 667.0000, 'ºC'),
	(110086, 110, '2015-03-15 01:13:34.000000', 'temperatura', 211.0000, 'ºC'),
	(110087, 110, '2015-03-15 01:13:35.000000', 'temperatura', 255.0000, 'ºC'),
	(110088, 110, '2015-03-15 01:13:36.000000', 'temperatura', 643.0000, 'ºC'),
	(110089, 110, '2015-03-15 01:13:37.000000', 'temperatura', 51.0000, 'ºC'),
	(110090, 110, '2015-03-15 01:13:38.000000', 'temperatura', 724.0000, 'ºC'),
	(110091, 110, '2015-03-15 01:13:39.000000', 'temperatura', 1068.0000, 'ºC'),
	(110092, 110, '2015-03-15 01:13:40.000000', 'temperatura', 769.0000, 'ºC'),
	(110093, 110, '2015-03-15 01:13:41.000000', 'temperatura', 642.0000, 'ºC'),
	(110094, 110, '2015-03-15 01:13:42.000000', 'temperatura', 902.0000, 'ºC'),
	(110095, 110, '2015-03-15 01:13:43.000000', 'temperatura', 184.0000, 'ºC'),
	(110096, 110, '2015-03-15 01:13:44.000000', 'temperatura', 617.0000, 'ºC'),
	(110097, 110, '2015-03-15 01:13:45.000000', 'temperatura', 132.0000, 'ºC'),
	(110098, 110, '2015-03-15 01:13:46.000000', 'temperatura', 8.0000, 'ºC'),
	(110099, 110, '2015-03-15 01:13:47.000000', 'temperatura', 846.0000, 'ºC'),
	(110100, 110, '2015-03-15 01:13:48.000000', 'temperatura', 607.0000, 'ºC'),
	(110101, 110, '2015-03-15 01:13:49.000000', 'temperatura', 499.0000, 'ºC'),
	(110102, 110, '2015-03-15 01:13:50.000000', 'temperatura', 672.0000, 'ºC'),
	(110103, 110, '2015-03-15 01:13:51.000000', 'temperatura', 665.0000, 'ºC'),
	(110104, 110, '2015-03-15 01:13:52.000000', 'temperatura', 110.0000, 'ºC'),
	(110105, 110, '2015-03-15 01:13:53.000000', 'temperatura', 957.0000, 'ºC'),
	(110106, 110, '2015-03-15 01:13:54.000000', 'temperatura', 853.0000, 'ºC'),
	(110107, 110, '2015-03-15 01:13:55.000000', 'temperatura', 197.0000, 'ºC'),
	(110108, 110, '2015-03-15 01:13:56.000000', 'temperatura', 826.0000, 'ºC'),
	(110109, 110, '2015-03-15 01:13:57.000000', 'temperatura', 1141.0000, 'ºC'),
	(110110, 110, '2015-03-15 01:13:58.000000', 'temperatura', 826.0000, 'ºC'),
	(110111, 110, '2015-03-15 01:13:59.000000', 'temperatura', 706.0000, 'ºC'),
	(110112, 110, '2015-03-15 01:14:00.000000', 'temperatura', 1053.0000, 'ºC'),
	(110113, 110, '2015-03-15 01:14:01.000000', 'temperatura', 749.0000, 'ºC'),
	(110114, 110, '2015-03-15 01:14:02.000000', 'temperatura', 585.0000, 'ºC'),
	(110115, 110, '2015-03-15 01:14:03.000000', 'temperatura', 678.0000, 'ºC'),
	(110116, 110, '2015-03-15 01:14:04.000000', 'temperatura', 437.0000, 'ºC'),
	(110117, 110, '2015-03-15 01:14:05.000000', 'temperatura', 151.0000, 'ºC'),
	(110118, 110, '2015-03-15 01:14:06.000000', 'temperatura', 645.0000, 'ºC'),
	(110119, 110, '2015-03-15 01:14:07.000000', 'temperatura', 373.0000, 'ºC'),
	(110120, 110, '2015-03-15 01:14:08.000000', 'temperatura', 1131.0000, 'ºC'),
	(110121, 110, '2015-03-15 01:14:09.000000', 'temperatura', 934.0000, 'ºC'),
	(110122, 110, '2015-03-15 01:14:10.000000', 'temperatura', 80.0000, 'ºC'),
	(110123, 110, '2015-03-15 01:14:11.000000', 'temperatura', 1198.0000, 'ºC'),
	(110124, 110, '2015-03-15 01:14:12.000000', 'temperatura', 951.0000, 'ºC'),
	(110125, 110, '2015-03-15 01:14:13.000000', 'temperatura', 1162.0000, 'ºC'),
	(110126, 110, '2015-03-15 01:14:14.000000', 'temperatura', 558.0000, 'ºC'),
	(110127, 110, '2015-03-15 01:14:15.000000', 'temperatura', 503.0000, 'ºC'),
	(110128, 110, '2015-03-15 01:14:16.000000', 'temperatura', 840.0000, 'ºC'),
	(110129, 110, '2015-03-15 01:14:17.000000', 'temperatura', 294.0000, 'ºC'),
	(110130, 110, '2015-03-15 01:14:18.000000', 'temperatura', 148.0000, 'ºC'),
	(110131, 110, '2015-03-15 01:14:19.000000', 'temperatura', 1058.0000, 'ºC'),
	(110132, 110, '2015-03-15 01:14:20.000000', 'temperatura', 47.0000, 'ºC'),
	(110133, 110, '2015-03-15 01:14:21.000000', 'temperatura', 663.0000, 'ºC'),
	(110134, 110, '2015-03-15 01:14:22.000000', 'temperatura', 773.0000, 'ºC'),
	(110135, 110, '2015-03-15 01:14:23.000000', 'temperatura', 678.0000, 'ºC'),
	(110136, 110, '2015-03-15 01:14:24.000000', 'temperatura', 1070.0000, 'ºC'),
	(110137, 110, '2015-03-15 01:14:25.000000', 'temperatura', 917.0000, 'ºC'),
	(110138, 110, '2015-03-15 01:14:26.000000', 'temperatura', 174.0000, 'ºC'),
	(110139, 110, '2015-03-15 01:14:27.000000', 'temperatura', 522.0000, 'ºC'),
	(110140, 110, '2015-03-15 01:14:28.000000', 'temperatura', 887.0000, 'ºC'),
	(110141, 110, '2015-03-15 01:14:29.000000', 'temperatura', 469.0000, 'ºC'),
	(110142, 110, '2015-03-15 01:14:30.000000', 'temperatura', 883.0000, 'ºC'),
	(110143, 110, '2015-03-15 01:14:31.000000', 'temperatura', 610.0000, 'ºC'),
	(110144, 110, '2015-03-15 01:14:32.000000', 'temperatura', 401.0000, 'ºC'),
	(110145, 110, '2015-03-15 01:14:33.000000', 'temperatura', 177.0000, 'ºC'),
	(110146, 110, '2015-03-15 01:14:34.000000', 'temperatura', 880.0000, 'ºC'),
	(110147, 110, '2015-03-15 01:14:35.000000', 'temperatura', 272.0000, 'ºC'),
	(110148, 110, '2015-03-15 01:14:36.000000', 'temperatura', 1118.0000, 'ºC'),
	(110149, 110, '2015-03-15 01:14:37.000000', 'temperatura', 1174.0000, 'ºC'),
	(110150, 110, '2015-03-15 01:14:38.000000', 'temperatura', 118.0000, 'ºC'),
	(110151, 110, '2015-03-15 01:14:39.000000', 'temperatura', 666.0000, 'ºC'),
	(110152, 110, '2015-03-15 01:14:40.000000', 'temperatura', 580.0000, 'ºC'),
	(110153, 110, '2015-03-15 01:14:41.000000', 'temperatura', 900.0000, 'ºC'),
	(110154, 110, '2015-03-15 01:14:42.000000', 'temperatura', 361.0000, 'ºC'),
	(110155, 110, '2015-03-15 01:14:43.000000', 'temperatura', 308.0000, 'ºC'),
	(110156, 110, '2015-03-15 01:14:44.000000', 'temperatura', 454.0000, 'ºC'),
	(110157, 110, '2015-03-15 01:14:45.000000', 'temperatura', 147.0000, 'ºC'),
	(110158, 110, '2015-03-15 01:14:46.000000', 'temperatura', 574.0000, 'ºC'),
	(110159, 110, '2015-03-15 01:14:47.000000', 'temperatura', 31.0000, 'ºC'),
	(110160, 110, '2015-03-15 01:14:48.000000', 'temperatura', 832.0000, 'ºC'),
	(110161, 110, '2015-03-15 01:14:49.000000', 'temperatura', 466.0000, 'ºC'),
	(110162, 110, '2015-03-15 01:14:50.000000', 'temperatura', 1035.0000, 'ºC'),
	(110163, 110, '2015-03-15 01:14:51.000000', 'temperatura', 178.0000, 'ºC'),
	(110164, 110, '2015-03-15 01:14:52.000000', 'temperatura', 184.0000, 'ºC'),
	(110165, 110, '2015-03-15 01:14:53.000000', 'temperatura', 388.0000, 'ºC'),
	(110166, 110, '2015-03-15 01:14:54.000000', 'temperatura', 189.0000, 'ºC'),
	(110167, 110, '2015-03-15 01:14:55.000000', 'temperatura', 981.0000, 'ºC'),
	(110168, 110, '2015-03-15 01:14:56.000000', 'temperatura', 737.0000, 'ºC'),
	(110169, 110, '2015-03-15 01:14:57.000000', 'temperatura', 742.0000, 'ºC'),
	(110170, 110, '2015-03-15 01:14:58.000000', 'temperatura', 299.0000, 'ºC'),
	(110171, 110, '2015-03-15 01:14:59.000000', 'temperatura', 469.0000, 'ºC'),
	(110172, 110, '2015-03-15 01:15:00.000000', 'temperatura', 251.0000, 'ºC'),
	(110173, 110, '2015-03-15 01:15:01.000000', 'temperatura', 1048.0000, 'ºC'),
	(110174, 110, '2015-03-15 01:15:02.000000', 'temperatura', 888.0000, 'ºC'),
	(110175, 110, '2015-03-15 01:15:03.000000', 'temperatura', 97.0000, 'ºC'),
	(110176, 110, '2015-03-15 01:15:04.000000', 'temperatura', 220.0000, 'ºC'),
	(110177, 110, '2015-03-15 01:15:05.000000', 'temperatura', 809.0000, 'ºC'),
	(110178, 110, '2015-03-15 01:15:06.000000', 'temperatura', 986.0000, 'ºC'),
	(110179, 110, '2015-03-15 01:15:07.000000', 'temperatura', 105.0000, 'ºC'),
	(110180, 110, '2015-03-15 01:15:08.000000', 'temperatura', 1166.0000, 'ºC'),
	(110181, 110, '2015-03-15 01:15:09.000000', 'temperatura', 717.0000, 'ºC'),
	(110182, 110, '2015-03-15 01:15:10.000000', 'temperatura', 85.0000, 'ºC'),
	(110183, 110, '2015-03-15 01:15:11.000000', 'temperatura', 677.0000, 'ºC'),
	(110184, 110, '2015-03-15 01:15:12.000000', 'temperatura', 731.0000, 'ºC'),
	(110185, 110, '2015-03-15 01:15:13.000000', 'temperatura', 422.0000, 'ºC'),
	(110186, 110, '2015-03-15 01:15:14.000000', 'temperatura', 1117.0000, 'ºC'),
	(110187, 110, '2015-03-15 01:15:15.000000', 'temperatura', 719.0000, 'ºC'),
	(110188, 110, '2015-03-15 01:15:16.000000', 'temperatura', 247.0000, 'ºC'),
	(110189, 110, '2015-03-15 01:15:17.000000', 'temperatura', 278.0000, 'ºC'),
	(110190, 110, '2015-03-15 01:15:18.000000', 'temperatura', 648.0000, 'ºC'),
	(110191, 110, '2015-03-15 01:15:19.000000', 'temperatura', 6.0000, 'ºC'),
	(110192, 110, '2015-03-15 01:15:20.000000', 'temperatura', 486.0000, 'ºC'),
	(110193, 110, '2015-03-15 01:15:21.000000', 'temperatura', 16.0000, 'ºC'),
	(110194, 110, '2015-03-15 01:15:22.000000', 'temperatura', 1019.0000, 'ºC'),
	(110195, 110, '2015-03-15 01:15:23.000000', 'temperatura', 248.0000, 'ºC'),
	(110196, 110, '2015-03-15 01:15:24.000000', 'temperatura', 582.0000, 'ºC'),
	(110197, 110, '2015-03-15 01:15:25.000000', 'temperatura', 968.0000, 'ºC'),
	(110198, 110, '2015-03-15 01:15:26.000000', 'temperatura', 696.0000, 'ºC'),
	(110199, 110, '2015-03-15 01:15:27.000000', 'temperatura', 575.0000, 'ºC'),
	(110200, 110, '2015-03-15 01:15:28.000000', 'temperatura', 786.0000, 'ºC'),
	(110201, 110, '2015-03-15 01:15:29.000000', 'temperatura', 1009.0000, 'ºC'),
	(110202, 110, '2015-03-15 01:15:30.000000', 'temperatura', 284.0000, 'ºC'),
	(110203, 110, '2015-03-15 01:15:31.000000', 'temperatura', 795.0000, 'ºC'),
	(110204, 110, '2015-03-15 01:15:32.000000', 'temperatura', 723.0000, 'ºC'),
	(110205, 110, '2015-03-15 01:15:33.000000', 'temperatura', 32.0000, 'ºC'),
	(110206, 110, '2015-03-15 01:15:34.000000', 'temperatura', 392.0000, 'ºC'),
	(110207, 110, '2015-03-15 01:15:35.000000', 'temperatura', 665.0000, 'ºC'),
	(110208, 110, '2015-03-15 01:15:36.000000', 'temperatura', 948.0000, 'ºC'),
	(110209, 110, '2015-03-15 01:15:37.000000', 'temperatura', 347.0000, 'ºC'),
	(110210, 110, '2015-03-15 01:15:38.000000', 'temperatura', 92.0000, 'ºC'),
	(110211, 110, '2015-03-15 01:15:39.000000', 'temperatura', 619.0000, 'ºC'),
	(110212, 110, '2015-03-15 01:15:40.000000', 'temperatura', 419.0000, 'ºC'),
	(110213, 110, '2015-03-15 01:15:41.000000', 'temperatura', 238.0000, 'ºC'),
	(110214, 110, '2015-03-15 01:15:42.000000', 'temperatura', 1133.0000, 'ºC'),
	(110215, 110, '2015-03-15 01:15:43.000000', 'temperatura', 154.0000, 'ºC'),
	(110216, 110, '2015-03-15 01:15:44.000000', 'temperatura', 971.0000, 'ºC'),
	(110217, 110, '2015-03-15 01:15:45.000000', 'temperatura', 795.0000, 'ºC'),
	(110218, 110, '2015-03-15 01:15:46.000000', 'temperatura', 1061.0000, 'ºC'),
	(110219, 110, '2015-03-15 01:15:47.000000', 'temperatura', 522.0000, 'ºC'),
	(110220, 110, '2015-03-15 01:15:48.000000', 'temperatura', 627.0000, 'ºC'),
	(110221, 110, '2015-03-15 01:15:49.000000', 'temperatura', 367.0000, 'ºC'),
	(110222, 110, '2015-03-15 01:15:50.000000', 'temperatura', 1156.0000, 'ºC'),
	(110223, 110, '2015-03-15 01:15:51.000000', 'temperatura', 1080.0000, 'ºC'),
	(110224, 110, '2015-03-15 01:15:52.000000', 'temperatura', 731.0000, 'ºC'),
	(110225, 110, '2015-03-15 01:15:53.000000', 'temperatura', 415.0000, 'ºC'),
	(110226, 110, '2015-03-15 01:15:54.000000', 'temperatura', 1084.0000, 'ºC'),
	(110227, 110, '2015-03-15 01:15:55.000000', 'temperatura', 574.0000, 'ºC'),
	(110228, 110, '2015-03-15 01:15:56.000000', 'temperatura', 820.0000, 'ºC'),
	(110229, 110, '2015-03-15 01:15:57.000000', 'temperatura', 1176.0000, 'ºC'),
	(110230, 110, '2015-03-15 01:15:58.000000', 'temperatura', 1022.0000, 'ºC'),
	(110231, 110, '2015-03-15 01:15:59.000000', 'temperatura', 384.0000, 'ºC'),
	(110232, 110, '2015-03-15 01:16:00.000000', 'temperatura', 53.0000, 'ºC'),
	(110233, 110, '2015-03-15 01:16:01.000000', 'temperatura', 313.0000, 'ºC'),
	(110234, 110, '2015-03-15 01:16:02.000000', 'temperatura', 206.0000, 'ºC'),
	(110235, 110, '2015-03-15 01:16:03.000000', 'temperatura', 91.0000, 'ºC'),
	(110236, 110, '2015-03-15 01:16:04.000000', 'temperatura', 1040.0000, 'ºC'),
	(110237, 110, '2015-03-15 01:16:05.000000', 'temperatura', 124.0000, 'ºC'),
	(110238, 110, '2015-03-15 01:16:06.000000', 'temperatura', 1103.0000, 'ºC'),
	(110239, 110, '2015-03-15 01:16:07.000000', 'temperatura', 343.0000, 'ºC'),
	(110240, 110, '2015-03-15 01:16:08.000000', 'temperatura', 808.0000, 'ºC'),
	(110241, 110, '2015-03-15 01:16:09.000000', 'temperatura', 610.0000, 'ºC'),
	(110242, 110, '2015-03-15 01:16:10.000000', 'temperatura', 626.0000, 'ºC'),
	(110243, 110, '2015-03-15 01:16:11.000000', 'temperatura', 102.0000, 'ºC'),
	(110244, 110, '2015-03-15 01:16:12.000000', 'temperatura', 1032.0000, 'ºC'),
	(110245, 110, '2015-03-15 01:16:13.000000', 'temperatura', 53.0000, 'ºC'),
	(110246, 110, '2015-03-15 01:16:14.000000', 'temperatura', 773.0000, 'ºC'),
	(110247, 110, '2015-03-15 01:16:15.000000', 'temperatura', 103.0000, 'ºC'),
	(110248, 110, '2015-03-15 01:16:16.000000', 'temperatura', 597.0000, 'ºC'),
	(110249, 110, '2015-03-15 01:16:17.000000', 'temperatura', 278.0000, 'ºC'),
	(110250, 110, '2015-03-15 01:16:18.000000', 'temperatura', 800.0000, 'ºC'),
	(110251, 110, '2015-03-15 01:16:19.000000', 'temperatura', 764.0000, 'ºC'),
	(110252, 110, '2015-03-15 01:16:20.000000', 'temperatura', 223.0000, 'ºC'),
	(110253, 110, '2015-03-15 01:16:21.000000', 'temperatura', 24.0000, 'ºC'),
	(110254, 110, '2015-03-15 01:16:22.000000', 'temperatura', 648.0000, 'ºC'),
	(110255, 110, '2015-03-15 01:16:23.000000', 'temperatura', 772.0000, 'ºC'),
	(110256, 110, '2015-03-15 01:16:24.000000', 'temperatura', 714.0000, 'ºC'),
	(110257, 110, '2015-03-15 01:16:25.000000', 'temperatura', 57.0000, 'ºC'),
	(110258, 110, '2015-03-15 01:16:26.000000', 'temperatura', 541.0000, 'ºC'),
	(110259, 110, '2015-03-15 01:16:27.000000', 'temperatura', 133.0000, 'ºC'),
	(110260, 110, '2015-03-15 01:16:28.000000', 'temperatura', 246.0000, 'ºC'),
	(110261, 110, '2015-03-15 01:16:29.000000', 'temperatura', 830.0000, 'ºC'),
	(110262, 110, '2015-03-15 01:16:30.000000', 'temperatura', 1014.0000, 'ºC'),
	(110263, 110, '2015-03-15 01:16:31.000000', 'temperatura', 181.0000, 'ºC'),
	(110264, 110, '2015-03-15 01:16:32.000000', 'temperatura', 261.0000, 'ºC'),
	(110265, 110, '2015-03-15 01:16:33.000000', 'temperatura', 765.0000, 'ºC'),
	(110266, 110, '2015-03-15 01:16:34.000000', 'temperatura', 640.0000, 'ºC'),
	(110267, 110, '2015-03-15 01:16:35.000000', 'temperatura', 905.0000, 'ºC'),
	(110268, 110, '2015-03-15 01:16:36.000000', 'temperatura', 205.0000, 'ºC'),
	(110269, 110, '2015-03-15 01:16:37.000000', 'temperatura', 710.0000, 'ºC'),
	(110270, 110, '2015-03-15 01:16:38.000000', 'temperatura', 535.0000, 'ºC'),
	(110271, 110, '2015-03-15 01:16:39.000000', 'temperatura', 547.0000, 'ºC'),
	(110272, 110, '2015-03-15 01:16:40.000000', 'temperatura', 1131.0000, 'ºC'),
	(110273, 110, '2015-03-15 01:16:41.000000', 'temperatura', 414.0000, 'ºC'),
	(110274, 110, '2015-03-15 01:16:42.000000', 'temperatura', 1077.0000, 'ºC'),
	(110275, 110, '2015-03-15 01:16:43.000000', 'temperatura', 542.0000, 'ºC'),
	(110276, 110, '2015-03-15 01:16:44.000000', 'temperatura', 682.0000, 'ºC'),
	(110277, 110, '2015-03-15 01:16:45.000000', 'temperatura', 584.0000, 'ºC'),
	(110278, 110, '2015-03-15 01:16:46.000000', 'temperatura', 873.0000, 'ºC'),
	(110279, 110, '2015-03-15 01:16:47.000000', 'temperatura', 213.0000, 'ºC'),
	(110280, 110, '2015-03-15 01:16:48.000000', 'temperatura', 847.0000, 'ºC'),
	(110281, 110, '2015-03-15 01:16:49.000000', 'temperatura', 1198.0000, 'ºC'),
	(110282, 110, '2015-03-15 01:16:50.000000', 'temperatura', 1051.0000, 'ºC'),
	(110283, 110, '2015-03-15 01:16:51.000000', 'temperatura', 458.0000, 'ºC'),
	(110284, 110, '2015-03-15 01:16:52.000000', 'temperatura', 338.0000, 'ºC'),
	(110285, 110, '2015-03-15 01:16:53.000000', 'temperatura', 318.0000, 'ºC'),
	(110286, 110, '2015-03-15 01:16:54.000000', 'temperatura', 576.0000, 'ºC'),
	(110287, 110, '2015-03-15 01:16:55.000000', 'temperatura', 726.0000, 'ºC'),
	(110288, 110, '2015-03-15 01:16:56.000000', 'temperatura', 704.0000, 'ºC'),
	(110289, 110, '2015-03-15 01:16:57.000000', 'temperatura', 143.0000, 'ºC'),
	(110290, 110, '2015-03-15 01:16:58.000000', 'temperatura', 1003.0000, 'ºC'),
	(110291, 110, '2015-03-15 01:16:59.000000', 'temperatura', 986.0000, 'ºC'),
	(110292, 110, '2015-03-15 01:17:00.000000', 'temperatura', 724.0000, 'ºC'),
	(110293, 110, '2015-03-15 01:17:01.000000', 'temperatura', 660.0000, 'ºC'),
	(110294, 110, '2015-03-15 01:17:02.000000', 'temperatura', 1127.0000, 'ºC'),
	(110295, 110, '2015-03-15 01:17:03.000000', 'temperatura', 59.0000, 'ºC'),
	(110296, 110, '2015-03-15 01:17:04.000000', 'temperatura', 512.0000, 'ºC'),
	(110297, 110, '2015-03-15 01:17:05.000000', 'temperatura', 1185.0000, 'ºC'),
	(110298, 110, '2015-03-15 01:17:06.000000', 'temperatura', 788.0000, 'ºC'),
	(110299, 110, '2015-03-15 01:17:07.000000', 'temperatura', 388.0000, 'ºC'),
	(110300, 110, '2015-03-15 01:17:08.000000', 'temperatura', 776.0000, 'ºC'),
	(110301, 110, '2015-03-15 01:17:09.000000', 'temperatura', 315.0000, 'ºC'),
	(110302, 110, '2015-03-15 01:17:10.000000', 'temperatura', 448.0000, 'ºC'),
	(110303, 110, '2015-03-15 01:17:11.000000', 'temperatura', 96.0000, 'ºC'),
	(110304, 110, '2015-03-15 01:17:12.000000', 'temperatura', 337.0000, 'ºC'),
	(110305, 110, '2015-03-15 01:17:13.000000', 'temperatura', 198.0000, 'ºC'),
	(110306, 110, '2015-03-15 01:17:14.000000', 'temperatura', 1179.0000, 'ºC'),
	(110307, 110, '2015-03-15 01:17:15.000000', 'temperatura', 502.0000, 'ºC'),
	(110308, 110, '2015-03-15 01:17:16.000000', 'temperatura', 173.0000, 'ºC'),
	(110309, 110, '2015-03-15 01:17:17.000000', 'temperatura', 561.0000, 'ºC'),
	(110310, 110, '2015-03-15 01:17:18.000000', 'temperatura', 1085.0000, 'ºC'),
	(110311, 110, '2015-03-15 01:17:19.000000', 'temperatura', 142.0000, 'ºC'),
	(110312, 110, '2015-03-15 01:17:20.000000', 'temperatura', 1057.0000, 'ºC'),
	(110313, 110, '2015-03-15 01:17:21.000000', 'temperatura', 61.0000, 'ºC'),
	(110314, 110, '2015-03-15 01:17:22.000000', 'temperatura', 731.0000, 'ºC'),
	(110315, 110, '2015-03-15 01:17:23.000000', 'temperatura', 1076.0000, 'ºC'),
	(110316, 110, '2015-03-15 01:17:24.000000', 'temperatura', 785.0000, 'ºC'),
	(110317, 110, '2015-03-15 01:17:25.000000', 'temperatura', 698.0000, 'ºC'),
	(110318, 110, '2015-03-15 01:17:26.000000', 'temperatura', 1134.0000, 'ºC'),
	(110319, 110, '2015-03-15 01:17:27.000000', 'temperatura', 1176.0000, 'ºC'),
	(110320, 110, '2015-03-15 01:17:28.000000', 'temperatura', 81.0000, 'ºC'),
	(110321, 110, '2015-03-15 01:17:29.000000', 'temperatura', 475.0000, 'ºC'),
	(110322, 110, '2015-03-15 01:17:30.000000', 'temperatura', 934.0000, 'ºC'),
	(110323, 110, '2015-03-15 01:17:31.000000', 'temperatura', 844.0000, 'ºC'),
	(110324, 110, '2015-03-15 01:17:32.000000', 'temperatura', 218.0000, 'ºC'),
	(110325, 110, '2015-03-15 01:17:33.000000', 'temperatura', 959.0000, 'ºC'),
	(110326, 110, '2015-03-15 01:17:34.000000', 'temperatura', 542.0000, 'ºC'),
	(110327, 110, '2015-03-15 01:17:35.000000', 'temperatura', 1035.0000, 'ºC'),
	(110328, 110, '2015-03-15 01:17:36.000000', 'temperatura', 1147.0000, 'ºC'),
	(110329, 110, '2015-03-15 01:17:37.000000', 'temperatura', 232.0000, 'ºC'),
	(110330, 110, '2015-03-15 01:17:38.000000', 'temperatura', 117.0000, 'ºC'),
	(110331, 110, '2015-03-15 01:17:39.000000', 'temperatura', 1093.0000, 'ºC'),
	(110332, 110, '2015-03-15 01:17:40.000000', 'temperatura', 311.0000, 'ºC'),
	(110333, 110, '2015-03-15 01:17:41.000000', 'temperatura', 678.0000, 'ºC'),
	(110334, 110, '2015-03-15 01:17:42.000000', 'temperatura', 58.0000, 'ºC'),
	(110335, 110, '2015-03-15 01:17:43.000000', 'temperatura', 655.0000, 'ºC'),
	(110336, 110, '2015-03-15 01:17:44.000000', 'temperatura', 702.0000, 'ºC'),
	(110337, 110, '2015-03-15 01:17:45.000000', 'temperatura', 346.0000, 'ºC'),
	(110338, 110, '2015-03-15 01:17:46.000000', 'temperatura', 823.0000, 'ºC'),
	(110339, 110, '2015-03-15 01:17:47.000000', 'temperatura', 680.0000, 'ºC'),
	(110340, 110, '2015-03-15 01:17:48.000000', 'temperatura', 931.0000, 'ºC'),
	(110341, 110, '2015-03-15 01:17:49.000000', 'temperatura', 214.0000, 'ºC'),
	(110342, 110, '2015-03-15 01:17:50.000000', 'temperatura', 678.0000, 'ºC'),
	(110343, 110, '2015-03-15 01:17:51.000000', 'temperatura', 349.0000, 'ºC'),
	(110344, 110, '2015-03-15 01:17:52.000000', 'temperatura', 913.0000, 'ºC'),
	(110345, 110, '2015-03-15 01:17:53.000000', 'temperatura', 1116.0000, 'ºC'),
	(110346, 110, '2015-03-15 01:17:54.000000', 'temperatura', 440.0000, 'ºC'),
	(110347, 110, '2015-03-15 01:17:55.000000', 'temperatura', 56.0000, 'ºC'),
	(110348, 110, '2015-03-15 01:17:56.000000', 'temperatura', 160.0000, 'ºC'),
	(110349, 110, '2015-03-15 01:17:57.000000', 'temperatura', 632.0000, 'ºC'),
	(110350, 110, '2015-03-15 01:17:58.000000', 'temperatura', 282.0000, 'ºC'),
	(110351, 110, '2015-03-15 01:17:59.000000', 'temperatura', 715.0000, 'ºC'),
	(110352, 110, '2015-03-15 01:18:00.000000', 'temperatura', 330.0000, 'ºC'),
	(110353, 110, '2015-03-15 01:18:01.000000', 'temperatura', 704.0000, 'ºC'),
	(110354, 110, '2015-03-15 01:18:02.000000', 'temperatura', 129.0000, 'ºC'),
	(110355, 110, '2015-03-15 01:18:03.000000', 'temperatura', 936.0000, 'ºC'),
	(110356, 110, '2015-03-15 01:18:04.000000', 'temperatura', 693.0000, 'ºC'),
	(110357, 110, '2015-03-15 01:18:05.000000', 'temperatura', 656.0000, 'ºC'),
	(110358, 110, '2015-03-15 01:18:06.000000', 'temperatura', 4.0000, 'ºC'),
	(110359, 110, '2015-03-15 01:18:07.000000', 'temperatura', 452.0000, 'ºC'),
	(110360, 110, '2015-03-15 01:18:08.000000', 'temperatura', 1049.0000, 'ºC'),
	(110361, 110, '2015-03-15 01:18:09.000000', 'temperatura', 287.0000, 'ºC'),
	(110362, 110, '2015-03-15 01:18:10.000000', 'temperatura', 689.0000, 'ºC'),
	(110363, 110, '2015-03-15 01:18:11.000000', 'temperatura', 187.0000, 'ºC'),
	(110364, 110, '2015-03-15 01:18:12.000000', 'temperatura', 66.0000, 'ºC'),
	(110365, 110, '2015-03-15 01:18:13.000000', 'temperatura', 971.0000, 'ºC'),
	(110366, 110, '2015-03-15 01:18:14.000000', 'temperatura', 1055.0000, 'ºC'),
	(110367, 110, '2015-03-15 01:18:15.000000', 'temperatura', 1165.0000, 'ºC'),
	(110368, 110, '2015-03-15 01:18:16.000000', 'temperatura', 260.0000, 'ºC'),
	(110369, 110, '2015-03-15 01:18:17.000000', 'temperatura', 206.0000, 'ºC'),
	(110370, 110, '2015-03-15 01:18:18.000000', 'temperatura', 250.0000, 'ºC'),
	(110371, 110, '2015-03-15 01:18:19.000000', 'temperatura', 632.0000, 'ºC'),
	(110372, 110, '2015-03-15 01:18:20.000000', 'temperatura', 9.0000, 'ºC'),
	(110373, 110, '2015-03-15 01:18:21.000000', 'temperatura', 550.0000, 'ºC'),
	(110374, 110, '2015-03-15 01:18:22.000000', 'temperatura', 324.0000, 'ºC'),
	(110375, 110, '2015-03-15 01:18:23.000000', 'temperatura', 1172.0000, 'ºC'),
	(110376, 110, '2015-03-15 01:18:24.000000', 'temperatura', 86.0000, 'ºC'),
	(110377, 110, '2015-03-15 01:18:25.000000', 'temperatura', 513.0000, 'ºC'),
	(110378, 110, '2015-03-15 01:18:26.000000', 'temperatura', 1111.0000, 'ºC'),
	(110379, 110, '2015-03-15 01:18:27.000000', 'temperatura', 415.0000, 'ºC'),
	(110380, 110, '2015-03-15 01:18:28.000000', 'temperatura', 1144.0000, 'ºC'),
	(110381, 110, '2015-03-15 01:18:29.000000', 'temperatura', 875.0000, 'ºC'),
	(110382, 110, '2015-03-15 01:18:30.000000', 'temperatura', 944.0000, 'ºC'),
	(110383, 110, '2015-03-15 01:18:31.000000', 'temperatura', 893.0000, 'ºC'),
	(110384, 110, '2015-03-15 01:18:32.000000', 'temperatura', 435.0000, 'ºC'),
	(110385, 110, '2015-03-15 01:18:33.000000', 'temperatura', 695.0000, 'ºC'),
	(110386, 110, '2015-03-15 01:18:34.000000', 'temperatura', 971.0000, 'ºC'),
	(110387, 110, '2015-03-15 01:18:35.000000', 'temperatura', 371.0000, 'ºC'),
	(110388, 110, '2015-03-15 01:18:36.000000', 'temperatura', 143.0000, 'ºC'),
	(110389, 110, '2015-03-15 01:18:37.000000', 'temperatura', 801.0000, 'ºC'),
	(110390, 110, '2015-03-15 01:18:38.000000', 'temperatura', 1179.0000, 'ºC'),
	(110391, 110, '2015-03-15 01:18:39.000000', 'temperatura', 1091.0000, 'ºC'),
	(110392, 110, '2015-03-15 01:18:40.000000', 'temperatura', 719.0000, 'ºC'),
	(110393, 110, '2015-03-15 01:18:41.000000', 'temperatura', 321.0000, 'ºC'),
	(110394, 110, '2015-03-15 01:18:42.000000', 'temperatura', 650.0000, 'ºC'),
	(110395, 110, '2015-03-15 01:18:43.000000', 'temperatura', 1089.0000, 'ºC'),
	(110396, 110, '2015-03-15 01:18:44.000000', 'temperatura', 1095.0000, 'ºC'),
	(110397, 110, '2015-03-15 01:18:45.000000', 'temperatura', 1007.0000, 'ºC'),
	(110398, 110, '2015-03-15 01:18:46.000000', 'temperatura', 552.0000, 'ºC'),
	(110399, 110, '2015-03-15 01:18:47.000000', 'temperatura', 937.0000, 'ºC'),
	(110400, 110, '2015-03-15 01:18:48.000000', 'temperatura', 632.0000, 'ºC'),
	(110401, 110, '2015-03-15 01:18:49.000000', 'temperatura', 348.0000, 'ºC'),
	(110402, 110, '2015-03-15 01:18:50.000000', 'temperatura', 1047.0000, 'ºC'),
	(110403, 110, '2015-03-15 01:18:51.000000', 'temperatura', 589.0000, 'ºC'),
	(110404, 110, '2015-03-15 01:18:52.000000', 'temperatura', 1005.0000, 'ºC'),
	(110405, 110, '2015-03-15 01:18:53.000000', 'temperatura', 858.0000, 'ºC'),
	(110406, 110, '2015-03-15 01:18:54.000000', 'temperatura', 74.0000, 'ºC'),
	(110407, 110, '2015-03-15 01:18:55.000000', 'temperatura', 197.0000, 'ºC'),
	(110408, 110, '2015-03-15 01:18:56.000000', 'temperatura', 765.0000, 'ºC'),
	(110409, 110, '2015-03-15 01:18:57.000000', 'temperatura', 833.0000, 'ºC'),
	(110410, 110, '2015-03-15 01:18:58.000000', 'temperatura', 671.0000, 'ºC'),
	(110411, 110, '2015-03-15 01:18:59.000000', 'temperatura', 858.0000, 'ºC'),
	(110412, 110, '2015-03-15 01:19:00.000000', 'temperatura', 1076.0000, 'ºC'),
	(110413, 110, '2015-03-15 01:19:01.000000', 'temperatura', 406.0000, 'ºC'),
	(110414, 110, '2015-03-15 01:19:02.000000', 'temperatura', 3.0000, 'ºC'),
	(110415, 110, '2015-03-15 01:19:03.000000', 'temperatura', 1196.0000, 'ºC'),
	(110416, 110, '2015-03-15 01:19:04.000000', 'temperatura', 1173.0000, 'ºC'),
	(110417, 110, '2015-03-15 01:19:05.000000', 'temperatura', 1078.0000, 'ºC'),
	(110418, 110, '2015-03-15 01:19:06.000000', 'temperatura', 669.0000, 'ºC'),
	(110419, 110, '2015-03-15 01:19:07.000000', 'temperatura', 114.0000, 'ºC'),
	(110420, 110, '2015-03-15 01:19:08.000000', 'temperatura', 964.0000, 'ºC'),
	(110421, 110, '2015-03-15 01:19:09.000000', 'temperatura', 875.0000, 'ºC'),
	(110422, 110, '2015-03-15 01:19:10.000000', 'temperatura', 287.0000, 'ºC'),
	(110423, 110, '2015-03-15 01:19:11.000000', 'temperatura', 11.0000, 'ºC'),
	(110424, 110, '2015-03-15 01:19:12.000000', 'temperatura', 393.0000, 'ºC'),
	(110425, 110, '2015-03-15 01:19:13.000000', 'temperatura', 733.0000, 'ºC'),
	(110426, 110, '2015-03-15 01:19:14.000000', 'temperatura', 86.0000, 'ºC'),
	(110427, 110, '2015-03-15 01:19:15.000000', 'temperatura', 634.0000, 'ºC'),
	(110428, 110, '2015-03-15 01:19:16.000000', 'temperatura', 509.0000, 'ºC'),
	(110429, 110, '2015-03-15 01:19:17.000000', 'temperatura', 645.0000, 'ºC'),
	(110430, 110, '2015-03-15 01:19:18.000000', 'temperatura', 497.0000, 'ºC'),
	(110431, 110, '2015-03-15 01:19:19.000000', 'temperatura', 553.0000, 'ºC'),
	(110432, 110, '2015-03-15 01:19:20.000000', 'temperatura', 74.0000, 'ºC'),
	(110433, 110, '2015-03-15 01:19:21.000000', 'temperatura', 1111.0000, 'ºC'),
	(110434, 110, '2015-03-15 01:19:22.000000', 'temperatura', 535.0000, 'ºC'),
	(110435, 110, '2015-03-15 01:19:23.000000', 'temperatura', 543.0000, 'ºC'),
	(110436, 110, '2015-03-15 01:19:24.000000', 'temperatura', 1108.0000, 'ºC'),
	(110437, 110, '2015-03-15 01:19:25.000000', 'temperatura', 312.0000, 'ºC'),
	(110438, 110, '2015-03-15 01:19:26.000000', 'temperatura', 636.0000, 'ºC'),
	(110439, 110, '2015-03-15 01:19:27.000000', 'temperatura', 1044.0000, 'ºC'),
	(110440, 110, '2015-03-15 01:19:28.000000', 'temperatura', 912.0000, 'ºC'),
	(110441, 110, '2015-03-15 01:19:29.000000', 'temperatura', 228.0000, 'ºC'),
	(110442, 110, '2015-03-15 01:19:30.000000', 'temperatura', 807.0000, 'ºC'),
	(110443, 110, '2015-03-15 01:19:31.000000', 'temperatura', 951.0000, 'ºC'),
	(110444, 110, '2015-03-15 01:19:32.000000', 'temperatura', 1134.0000, 'ºC'),
	(110445, 110, '2015-03-15 01:19:33.000000', 'temperatura', 419.0000, 'ºC'),
	(110446, 110, '2015-03-15 01:19:34.000000', 'temperatura', 1095.0000, 'ºC'),
	(110447, 110, '2015-03-15 01:19:35.000000', 'temperatura', 615.0000, 'ºC'),
	(110448, 110, '2015-03-15 01:19:36.000000', 'temperatura', 992.0000, 'ºC'),
	(110449, 110, '2015-03-15 01:19:37.000000', 'temperatura', 717.0000, 'ºC'),
	(110450, 110, '2015-03-15 01:19:38.000000', 'temperatura', 607.0000, 'ºC'),
	(110451, 110, '2015-03-15 01:19:39.000000', 'temperatura', 887.0000, 'ºC'),
	(110452, 110, '2015-03-15 01:19:40.000000', 'temperatura', 213.0000, 'ºC'),
	(110453, 110, '2015-03-15 01:19:41.000000', 'temperatura', 805.0000, 'ºC'),
	(110454, 110, '2015-03-15 01:19:42.000000', 'temperatura', 988.0000, 'ºC'),
	(110455, 110, '2015-03-15 01:19:43.000000', 'temperatura', 124.0000, 'ºC'),
	(110456, 110, '2015-03-15 01:19:44.000000', 'temperatura', 58.0000, 'ºC'),
	(110457, 110, '2015-03-15 01:19:45.000000', 'temperatura', 1117.0000, 'ºC'),
	(110458, 110, '2015-03-15 01:19:46.000000', 'temperatura', 613.0000, 'ºC'),
	(110459, 110, '2015-03-15 01:19:47.000000', 'temperatura', 913.0000, 'ºC'),
	(110460, 110, '2015-03-15 01:19:48.000000', 'temperatura', 326.0000, 'ºC'),
	(110461, 110, '2015-03-15 01:19:49.000000', 'temperatura', 94.0000, 'ºC'),
	(110462, 110, '2015-03-15 01:19:50.000000', 'temperatura', 692.0000, 'ºC'),
	(110463, 110, '2015-03-15 01:19:51.000000', 'temperatura', 779.0000, 'ºC'),
	(110464, 110, '2015-03-15 01:19:52.000000', 'temperatura', 620.0000, 'ºC'),
	(110465, 110, '2015-03-15 01:19:53.000000', 'temperatura', 764.0000, 'ºC'),
	(110466, 110, '2015-03-15 01:19:54.000000', 'temperatura', 760.0000, 'ºC'),
	(110467, 110, '2015-03-15 01:19:55.000000', 'temperatura', 309.0000, 'ºC'),
	(110468, 110, '2015-03-15 01:19:56.000000', 'temperatura', 463.0000, 'ºC'),
	(110469, 110, '2015-03-15 01:19:57.000000', 'temperatura', 189.0000, 'ºC'),
	(110470, 110, '2015-03-15 01:19:58.000000', 'temperatura', 758.0000, 'ºC'),
	(110471, 110, '2015-03-15 01:19:59.000000', 'temperatura', 824.0000, 'ºC'),
	(110472, 110, '2015-03-15 01:20:00.000000', 'temperatura', 648.0000, 'ºC'),
	(110473, 110, '2015-03-15 01:20:01.000000', 'temperatura', 766.0000, 'ºC'),
	(110474, 110, '2015-03-15 01:20:02.000000', 'temperatura', 685.0000, 'ºC'),
	(110475, 110, '2015-03-15 01:20:03.000000', 'temperatura', 1130.0000, 'ºC'),
	(110476, 110, '2015-03-15 01:20:04.000000', 'temperatura', 1193.0000, 'ºC'),
	(110477, 110, '2015-03-15 01:20:05.000000', 'temperatura', 178.0000, 'ºC'),
	(110478, 110, '2015-03-15 01:20:06.000000', 'temperatura', 912.0000, 'ºC'),
	(110479, 110, '2015-03-15 01:20:07.000000', 'temperatura', 423.0000, 'ºC'),
	(110480, 110, '2015-03-15 01:20:08.000000', 'temperatura', 583.0000, 'ºC'),
	(110481, 110, '2015-03-15 01:20:09.000000', 'temperatura', 445.0000, 'ºC'),
	(110482, 110, '2015-03-15 01:20:10.000000', 'temperatura', 477.0000, 'ºC'),
	(110483, 110, '2015-03-15 01:20:11.000000', 'temperatura', 1052.0000, 'ºC'),
	(110484, 110, '2015-03-15 01:20:12.000000', 'temperatura', 229.0000, 'ºC'),
	(110485, 110, '2015-03-15 01:20:13.000000', 'temperatura', 390.0000, 'ºC'),
	(110486, 110, '2015-03-15 01:20:14.000000', 'temperatura', 62.0000, 'ºC'),
	(110487, 110, '2015-03-15 01:20:15.000000', 'temperatura', 340.0000, 'ºC'),
	(110488, 110, '2015-03-15 01:20:16.000000', 'temperatura', 316.0000, 'ºC'),
	(110489, 110, '2015-03-15 01:20:17.000000', 'temperatura', 559.0000, 'ºC'),
	(110490, 110, '2015-03-15 01:20:18.000000', 'temperatura', 648.0000, 'ºC'),
	(110491, 110, '2015-03-15 01:20:19.000000', 'temperatura', 363.0000, 'ºC'),
	(110492, 110, '2015-03-15 01:20:20.000000', 'temperatura', 1070.0000, 'ºC'),
	(110493, 110, '2015-03-15 01:20:21.000000', 'temperatura', 663.0000, 'ºC'),
	(110494, 110, '2015-03-15 01:20:22.000000', 'temperatura', 106.0000, 'ºC'),
	(110495, 110, '2015-03-15 01:20:23.000000', 'temperatura', 942.0000, 'ºC'),
	(110496, 110, '2015-03-15 01:20:24.000000', 'temperatura', 790.0000, 'ºC'),
	(110497, 110, '2015-03-15 01:20:25.000000', 'temperatura', 1126.0000, 'ºC'),
	(110498, 110, '2015-03-15 01:20:26.000000', 'temperatura', 859.0000, 'ºC'),
	(110499, 110, '2015-03-15 01:20:27.000000', 'temperatura', 917.0000, 'ºC'),
	(110500, 110, '2015-03-15 01:20:28.000000', 'temperatura', 809.0000, 'ºC'),
	(110501, 110, '2015-03-15 01:20:29.000000', 'temperatura', 94.0000, 'ºC'),
	(110502, 110, '2015-03-15 01:20:30.000000', 'temperatura', 446.0000, 'ºC'),
	(110503, 110, '2015-03-15 01:20:31.000000', 'temperatura', 745.0000, 'ºC'),
	(110504, 110, '2015-03-15 01:20:32.000000', 'temperatura', 1190.0000, 'ºC'),
	(110505, 110, '2015-03-15 01:20:33.000000', 'temperatura', 116.0000, 'ºC'),
	(110506, 110, '2015-03-15 01:20:34.000000', 'temperatura', 609.0000, 'ºC'),
	(110507, 110, '2015-03-15 01:20:35.000000', 'temperatura', 297.0000, 'ºC'),
	(110508, 110, '2015-03-15 01:20:36.000000', 'temperatura', 857.0000, 'ºC'),
	(110509, 110, '2015-03-15 01:20:37.000000', 'temperatura', 997.0000, 'ºC'),
	(110510, 110, '2015-03-15 01:20:38.000000', 'temperatura', 16.0000, 'ºC'),
	(110511, 110, '2015-03-15 01:20:39.000000', 'temperatura', 686.0000, 'ºC'),
	(110512, 110, '2015-03-15 01:20:40.000000', 'temperatura', 986.0000, 'ºC'),
	(110513, 110, '2015-03-15 01:20:41.000000', 'temperatura', 470.0000, 'ºC'),
	(110514, 110, '2015-03-15 01:20:42.000000', 'temperatura', 593.0000, 'ºC'),
	(110515, 110, '2015-03-15 01:20:43.000000', 'temperatura', 355.0000, 'ºC'),
	(110516, 110, '2015-03-15 01:20:44.000000', 'temperatura', 1198.0000, 'ºC'),
	(110517, 110, '2015-03-15 01:20:45.000000', 'temperatura', 125.0000, 'ºC'),
	(110518, 110, '2015-03-15 01:20:46.000000', 'temperatura', 629.0000, 'ºC'),
	(110519, 110, '2015-03-15 01:20:47.000000', 'temperatura', 373.0000, 'ºC'),
	(110520, 110, '2015-03-15 01:20:48.000000', 'temperatura', 1179.0000, 'ºC'),
	(110521, 110, '2015-03-15 01:20:49.000000', 'temperatura', 1177.0000, 'ºC'),
	(110522, 110, '2015-03-15 01:20:50.000000', 'temperatura', 1148.0000, 'ºC'),
	(110523, 110, '2015-03-15 01:20:51.000000', 'temperatura', 1010.0000, 'ºC'),
	(110524, 110, '2015-03-15 01:20:52.000000', 'temperatura', 405.0000, 'ºC'),
	(110525, 110, '2015-03-15 01:20:53.000000', 'temperatura', 195.0000, 'ºC'),
	(110526, 110, '2015-03-15 01:20:54.000000', 'temperatura', 961.0000, 'ºC'),
	(110527, 110, '2015-03-15 01:20:55.000000', 'temperatura', 620.0000, 'ºC'),
	(110528, 110, '2015-03-15 01:20:56.000000', 'temperatura', 218.0000, 'ºC'),
	(110529, 110, '2015-03-15 01:20:57.000000', 'temperatura', 430.0000, 'ºC'),
	(110530, 110, '2015-03-15 01:20:58.000000', 'temperatura', 295.0000, 'ºC'),
	(110531, 110, '2015-03-15 01:20:59.000000', 'temperatura', 187.0000, 'ºC'),
	(110532, 110, '2015-03-15 01:21:00.000000', 'temperatura', 49.0000, 'ºC'),
	(110533, 110, '2015-03-15 01:21:01.000000', 'temperatura', 886.0000, 'ºC'),
	(110534, 110, '2015-03-15 01:21:02.000000', 'temperatura', 685.0000, 'ºC'),
	(110535, 110, '2015-03-15 01:21:03.000000', 'temperatura', 766.0000, 'ºC'),
	(110536, 110, '2015-03-15 01:21:04.000000', 'temperatura', 575.0000, 'ºC'),
	(110537, 110, '2015-03-15 01:21:05.000000', 'temperatura', 576.0000, 'ºC'),
	(110538, 110, '2015-03-15 01:21:06.000000', 'temperatura', 1156.0000, 'ºC'),
	(110539, 110, '2015-03-15 01:21:07.000000', 'temperatura', 454.0000, 'ºC'),
	(110540, 110, '2015-03-15 01:21:08.000000', 'temperatura', 2.0000, 'ºC'),
	(110541, 110, '2015-03-15 01:21:09.000000', 'temperatura', 1049.0000, 'ºC'),
	(110542, 110, '2015-03-15 01:21:10.000000', 'temperatura', 440.0000, 'ºC'),
	(110543, 110, '2015-03-15 01:21:11.000000', 'temperatura', 255.0000, 'ºC'),
	(110544, 110, '2015-03-15 01:21:12.000000', 'temperatura', 1152.0000, 'ºC'),
	(110545, 110, '2015-03-15 01:21:13.000000', 'temperatura', 197.0000, 'ºC'),
	(110546, 110, '2015-03-15 01:21:14.000000', 'temperatura', 1130.0000, 'ºC'),
	(110547, 111, '2015-03-15 00:00:00.000000', 'temperatura', 307.0000, 'ºC'),
	(110548, 111, '2015-03-15 00:00:01.000000', 'temperatura', 758.0000, 'ºC'),
	(110549, 111, '2015-03-15 00:00:02.000000', 'temperatura', 471.0000, 'ºC'),
	(110550, 111, '2015-03-15 00:00:03.000000', 'temperatura', 81.0000, 'ºC'),
	(110551, 111, '2015-03-15 00:00:04.000000', 'temperatura', 192.0000, 'ºC'),
	(110552, 111, '2015-03-15 00:00:05.000000', 'temperatura', 719.0000, 'ºC'),
	(110553, 111, '2015-03-15 00:00:06.000000', 'temperatura', 618.0000, 'ºC'),
	(110554, 111, '2015-03-15 00:00:07.000000', 'temperatura', 936.0000, 'ºC'),
	(110555, 111, '2015-03-15 00:00:08.000000', 'temperatura', 423.0000, 'ºC'),
	(110556, 111, '2015-03-15 00:00:09.000000', 'temperatura', 511.0000, 'ºC'),
	(110557, 111, '2015-03-15 00:00:10.000000', 'temperatura', 85.0000, 'ºC'),
	(110558, 111, '2015-03-15 00:00:11.000000', 'temperatura', 92.0000, 'ºC'),
	(110559, 111, '2015-03-15 00:00:12.000000', 'temperatura', 206.0000, 'ºC'),
	(110560, 111, '2015-03-15 00:00:13.000000', 'temperatura', 754.0000, 'ºC'),
	(110561, 111, '2015-03-15 00:00:14.000000', 'temperatura', 752.0000, 'ºC'),
	(110562, 111, '2015-03-15 00:00:15.000000', 'temperatura', 300.0000, 'ºC'),
	(110563, 111, '2015-03-15 00:00:16.000000', 'temperatura', 443.0000, 'ºC'),
	(110564, 111, '2015-03-15 00:00:17.000000', 'temperatura', 117.0000, 'ºC'),
	(110565, 111, '2015-03-15 00:00:18.000000', 'temperatura', 458.0000, 'ºC'),
	(110566, 111, '2015-03-15 00:00:19.000000', 'temperatura', 738.0000, 'ºC'),
	(110567, 111, '2015-03-15 00:00:20.000000', 'temperatura', 1116.0000, 'ºC'),
	(110568, 111, '2015-03-15 00:00:21.000000', 'temperatura', 967.0000, 'ºC'),
	(110569, 111, '2015-03-15 00:00:22.000000', 'temperatura', 286.0000, 'ºC'),
	(110570, 111, '2015-03-15 00:00:23.000000', 'temperatura', 930.0000, 'ºC'),
	(110571, 111, '2015-03-15 00:00:24.000000', 'temperatura', 192.0000, 'ºC'),
	(110572, 111, '2015-03-15 00:00:25.000000', 'temperatura', 569.0000, 'ºC'),
	(110573, 111, '2015-03-15 00:00:26.000000', 'temperatura', 1073.0000, 'ºC'),
	(110574, 111, '2015-03-15 00:00:27.000000', 'temperatura', 55.0000, 'ºC'),
	(110575, 111, '2015-03-15 00:00:28.000000', 'temperatura', 658.0000, 'ºC'),
	(110576, 111, '2015-03-15 00:00:29.000000', 'temperatura', 726.0000, 'ºC'),
	(110577, 111, '2015-03-15 00:00:30.000000', 'temperatura', 454.0000, 'ºC'),
	(110578, 111, '2015-03-15 00:00:31.000000', 'temperatura', 96.0000, 'ºC'),
	(110579, 111, '2015-03-15 00:00:32.000000', 'temperatura', 316.0000, 'ºC'),
	(110580, 111, '2015-03-15 00:00:33.000000', 'temperatura', 91.0000, 'ºC'),
	(110581, 111, '2015-03-15 00:00:34.000000', 'temperatura', 711.0000, 'ºC'),
	(110582, 111, '2015-03-15 00:00:35.000000', 'temperatura', 882.0000, 'ºC'),
	(110583, 111, '2015-03-15 00:00:36.000000', 'temperatura', 1077.0000, 'ºC'),
	(110584, 111, '2015-03-15 00:00:37.000000', 'temperatura', 340.0000, 'ºC'),
	(110585, 111, '2015-03-15 00:00:38.000000', 'temperatura', 869.0000, 'ºC'),
	(110586, 111, '2015-03-15 00:00:39.000000', 'temperatura', 924.0000, 'ºC'),
	(110587, 111, '2015-03-15 00:00:40.000000', 'temperatura', 816.0000, 'ºC'),
	(110588, 111, '2015-03-15 00:00:41.000000', 'temperatura', 107.0000, 'ºC'),
	(110589, 111, '2015-03-15 00:00:42.000000', 'temperatura', 489.0000, 'ºC'),
	(110590, 111, '2015-03-15 00:00:43.000000', 'temperatura', 924.0000, 'ºC'),
	(110591, 111, '2015-03-15 00:00:44.000000', 'temperatura', 755.0000, 'ºC'),
	(110592, 111, '2015-03-15 00:00:45.000000', 'temperatura', 1001.0000, 'ºC'),
	(110593, 111, '2015-03-15 00:00:46.000000', 'temperatura', 343.0000, 'ºC'),
	(110594, 111, '2015-03-15 00:00:47.000000', 'temperatura', 1109.0000, 'ºC'),
	(110595, 111, '2015-03-15 00:00:48.000000', 'temperatura', 920.0000, 'ºC'),
	(110596, 111, '2015-03-15 00:00:49.000000', 'temperatura', 71.0000, 'ºC'),
	(110597, 111, '2015-03-15 00:00:50.000000', 'temperatura', 1196.0000, 'ºC'),
	(110598, 111, '2015-03-15 00:00:51.000000', 'temperatura', 967.0000, 'ºC'),
	(110599, 111, '2015-03-15 00:00:52.000000', 'temperatura', 48.0000, 'ºC'),
	(110600, 111, '2015-03-15 00:00:53.000000', 'temperatura', 940.0000, 'ºC'),
	(110601, 111, '2015-03-15 00:00:54.000000', 'temperatura', 957.0000, 'ºC'),
	(110602, 111, '2015-03-15 00:00:55.000000', 'temperatura', 763.0000, 'ºC'),
	(110603, 111, '2015-03-15 00:00:56.000000', 'temperatura', 947.0000, 'ºC'),
	(110604, 111, '2015-03-15 00:00:57.000000', 'temperatura', 48.0000, 'ºC'),
	(110605, 111, '2015-03-15 00:00:58.000000', 'temperatura', 997.0000, 'ºC'),
	(110606, 111, '2015-03-15 00:00:59.000000', 'temperatura', 40.0000, 'ºC'),
	(110607, 111, '2015-03-15 00:01:00.000000', 'temperatura', 813.0000, 'ºC'),
	(110608, 111, '2015-03-15 00:01:01.000000', 'temperatura', 342.0000, 'ºC'),
	(110609, 111, '2015-03-15 00:01:02.000000', 'temperatura', 475.0000, 'ºC'),
	(110610, 111, '2015-03-15 00:01:03.000000', 'temperatura', 149.0000, 'ºC'),
	(110611, 111, '2015-03-15 00:01:04.000000', 'temperatura', 518.0000, 'ºC'),
	(110612, 111, '2015-03-15 00:01:05.000000', 'temperatura', 944.0000, 'ºC'),
	(110613, 111, '2015-03-15 00:01:06.000000', 'temperatura', 765.0000, 'ºC'),
	(110614, 111, '2015-03-15 00:01:07.000000', 'temperatura', 996.0000, 'ºC'),
	(110615, 111, '2015-03-15 00:01:08.000000', 'temperatura', 283.0000, 'ºC'),
	(110616, 111, '2015-03-15 00:01:09.000000', 'temperatura', 831.0000, 'ºC'),
	(110617, 111, '2015-03-15 00:01:10.000000', 'temperatura', 903.0000, 'ºC'),
	(110618, 111, '2015-03-15 00:01:11.000000', 'temperatura', 825.0000, 'ºC'),
	(110619, 111, '2015-03-15 00:01:12.000000', 'temperatura', 218.0000, 'ºC'),
	(110620, 111, '2015-03-15 00:01:13.000000', 'temperatura', 1012.0000, 'ºC'),
	(110621, 111, '2015-03-15 00:01:14.000000', 'temperatura', 809.0000, 'ºC'),
	(110622, 111, '2015-03-15 00:01:15.000000', 'temperatura', 1010.0000, 'ºC'),
	(110623, 111, '2015-03-15 00:01:16.000000', 'temperatura', 224.0000, 'ºC'),
	(110624, 111, '2015-03-15 00:01:17.000000', 'temperatura', 487.0000, 'ºC'),
	(110625, 111, '2015-03-15 00:01:18.000000', 'temperatura', 567.0000, 'ºC'),
	(110626, 111, '2015-03-15 00:01:19.000000', 'temperatura', 172.0000, 'ºC'),
	(110627, 111, '2015-03-15 00:01:20.000000', 'temperatura', 362.0000, 'ºC'),
	(110628, 111, '2015-03-15 00:01:21.000000', 'temperatura', 95.0000, 'ºC'),
	(110629, 111, '2015-03-15 00:01:22.000000', 'temperatura', 588.0000, 'ºC'),
	(110630, 111, '2015-03-15 00:01:23.000000', 'temperatura', 257.0000, 'ºC'),
	(110631, 111, '2015-03-15 00:01:24.000000', 'temperatura', 722.0000, 'ºC'),
	(110632, 111, '2015-03-15 00:01:25.000000', 'temperatura', 438.0000, 'ºC'),
	(110633, 111, '2015-03-15 00:01:26.000000', 'temperatura', 23.0000, 'ºC'),
	(110634, 111, '2015-03-15 00:01:27.000000', 'temperatura', 2.0000, 'ºC'),
	(110635, 111, '2015-03-15 00:01:28.000000', 'temperatura', 1141.0000, 'ºC'),
	(110636, 111, '2015-03-15 00:01:29.000000', 'temperatura', 901.0000, 'ºC'),
	(110637, 111, '2015-03-15 00:01:30.000000', 'temperatura', 1083.0000, 'ºC'),
	(110638, 111, '2015-03-15 00:01:31.000000', 'temperatura', 311.0000, 'ºC'),
	(110639, 111, '2015-03-15 00:01:32.000000', 'temperatura', 705.0000, 'ºC'),
	(110640, 111, '2015-03-15 00:01:33.000000', 'temperatura', 195.0000, 'ºC'),
	(110641, 111, '2015-03-15 00:01:34.000000', 'temperatura', 58.0000, 'ºC'),
	(110642, 111, '2015-03-15 00:01:35.000000', 'temperatura', 906.0000, 'ºC'),
	(110643, 111, '2015-03-15 00:01:36.000000', 'temperatura', 757.0000, 'ºC'),
	(110644, 111, '2015-03-15 00:01:37.000000', 'temperatura', 1068.0000, 'ºC'),
	(110645, 111, '2015-03-15 00:01:38.000000', 'temperatura', 670.0000, 'ºC'),
	(110646, 111, '2015-03-15 00:01:39.000000', 'temperatura', 145.0000, 'ºC'),
	(110647, 111, '2015-03-15 00:01:40.000000', 'temperatura', 1114.0000, 'ºC'),
	(110648, 111, '2015-03-15 00:01:41.000000', 'temperatura', 339.0000, 'ºC'),
	(110649, 111, '2015-03-15 00:01:42.000000', 'temperatura', 751.0000, 'ºC'),
	(110650, 111, '2015-03-15 00:01:43.000000', 'temperatura', 339.0000, 'ºC'),
	(110651, 111, '2015-03-15 00:01:44.000000', 'temperatura', 643.0000, 'ºC'),
	(110652, 111, '2015-03-15 00:01:45.000000', 'temperatura', 998.0000, 'ºC'),
	(110653, 111, '2015-03-15 00:01:46.000000', 'temperatura', 661.0000, 'ºC'),
	(110654, 111, '2015-03-15 00:01:47.000000', 'temperatura', 313.0000, 'ºC'),
	(110655, 111, '2015-03-15 00:01:48.000000', 'temperatura', 782.0000, 'ºC'),
	(110656, 111, '2015-03-15 00:01:49.000000', 'temperatura', 571.0000, 'ºC'),
	(110657, 111, '2015-03-15 00:01:50.000000', 'temperatura', 509.0000, 'ºC'),
	(110658, 111, '2015-03-15 00:01:51.000000', 'temperatura', 835.0000, 'ºC'),
	(110659, 111, '2015-03-15 00:01:52.000000', 'temperatura', 245.0000, 'ºC'),
	(110660, 111, '2015-03-15 00:01:53.000000', 'temperatura', 1124.0000, 'ºC'),
	(110661, 111, '2015-03-15 00:01:54.000000', 'temperatura', 85.0000, 'ºC'),
	(110662, 111, '2015-03-15 00:01:55.000000', 'temperatura', 651.0000, 'ºC'),
	(110663, 111, '2015-03-15 00:01:56.000000', 'temperatura', 602.0000, 'ºC'),
	(110664, 111, '2015-03-15 00:01:57.000000', 'temperatura', 1058.0000, 'ºC'),
	(110665, 111, '2015-03-15 00:01:58.000000', 'temperatura', 1082.0000, 'ºC'),
	(110666, 111, '2015-03-15 00:01:59.000000', 'temperatura', 1038.0000, 'ºC'),
	(110667, 111, '2015-03-15 00:02:00.000000', 'temperatura', 744.0000, 'ºC'),
	(110668, 111, '2015-03-15 00:02:01.000000', 'temperatura', 607.0000, 'ºC'),
	(110669, 111, '2015-03-15 00:02:02.000000', 'temperatura', 804.0000, 'ºC'),
	(110670, 111, '2015-03-15 00:02:03.000000', 'temperatura', 1000.0000, 'ºC'),
	(110671, 111, '2015-03-15 00:02:04.000000', 'temperatura', 187.0000, 'ºC'),
	(110672, 111, '2015-03-15 00:02:05.000000', 'temperatura', 336.0000, 'ºC'),
	(110673, 111, '2015-03-15 00:02:06.000000', 'temperatura', 1121.0000, 'ºC'),
	(110674, 111, '2015-03-15 00:02:07.000000', 'temperatura', 998.0000, 'ºC'),
	(110675, 111, '2015-03-15 00:02:08.000000', 'temperatura', 426.0000, 'ºC'),
	(110676, 111, '2015-03-15 00:02:09.000000', 'temperatura', 335.0000, 'ºC'),
	(110677, 111, '2015-03-15 00:02:10.000000', 'temperatura', 399.0000, 'ºC'),
	(110678, 111, '2015-03-15 00:02:11.000000', 'temperatura', 989.0000, 'ºC'),
	(110679, 111, '2015-03-15 00:02:12.000000', 'temperatura', 150.0000, 'ºC'),
	(110680, 111, '2015-03-15 00:02:13.000000', 'temperatura', 182.0000, 'ºC'),
	(110681, 111, '2015-03-15 00:02:14.000000', 'temperatura', 460.0000, 'ºC'),
	(110682, 111, '2015-03-15 00:02:15.000000', 'temperatura', 556.0000, 'ºC'),
	(110683, 111, '2015-03-15 00:02:16.000000', 'temperatura', 200.0000, 'ºC'),
	(110684, 111, '2015-03-15 00:02:17.000000', 'temperatura', 535.0000, 'ºC'),
	(110685, 111, '2015-03-15 00:02:18.000000', 'temperatura', 872.0000, 'ºC'),
	(110686, 111, '2015-03-15 00:02:19.000000', 'temperatura', 357.0000, 'ºC'),
	(110687, 111, '2015-03-15 00:02:20.000000', 'temperatura', 368.0000, 'ºC'),
	(110688, 111, '2015-03-15 00:02:21.000000', 'temperatura', 769.0000, 'ºC'),
	(110689, 111, '2015-03-15 00:02:22.000000', 'temperatura', 341.0000, 'ºC'),
	(110690, 111, '2015-03-15 00:02:23.000000', 'temperatura', 601.0000, 'ºC'),
	(110691, 111, '2015-03-15 00:02:24.000000', 'temperatura', 779.0000, 'ºC'),
	(110692, 111, '2015-03-15 00:02:25.000000', 'temperatura', 896.0000, 'ºC'),
	(110693, 111, '2015-03-15 00:02:26.000000', 'temperatura', 942.0000, 'ºC'),
	(110694, 111, '2015-03-15 00:02:27.000000', 'temperatura', 824.0000, 'ºC'),
	(110695, 111, '2015-03-15 00:02:28.000000', 'temperatura', 93.0000, 'ºC'),
	(110696, 111, '2015-03-15 00:02:29.000000', 'temperatura', 394.0000, 'ºC'),
	(110697, 111, '2015-03-15 00:02:30.000000', 'temperatura', 490.0000, 'ºC'),
	(110698, 111, '2015-03-15 00:02:31.000000', 'temperatura', 69.0000, 'ºC'),
	(110699, 111, '2015-03-15 00:02:32.000000', 'temperatura', 75.0000, 'ºC'),
	(110700, 111, '2015-03-15 00:02:33.000000', 'temperatura', 167.0000, 'ºC'),
	(110701, 111, '2015-03-15 00:02:34.000000', 'temperatura', 614.0000, 'ºC'),
	(110702, 111, '2015-03-15 00:02:35.000000', 'temperatura', 166.0000, 'ºC'),
	(110703, 111, '2015-03-15 00:02:36.000000', 'temperatura', 191.0000, 'ºC'),
	(110704, 111, '2015-03-15 00:02:37.000000', 'temperatura', 457.0000, 'ºC'),
	(110705, 111, '2015-03-15 00:02:38.000000', 'temperatura', 514.0000, 'ºC'),
	(110706, 111, '2015-03-15 00:02:39.000000', 'temperatura', 0.0000, 'ºC'),
	(110707, 111, '2015-03-15 00:02:40.000000', 'temperatura', 856.0000, 'ºC'),
	(110708, 111, '2015-03-15 00:02:41.000000', 'temperatura', 681.0000, 'ºC'),
	(110709, 111, '2015-03-15 00:02:42.000000', 'temperatura', 837.0000, 'ºC'),
	(110710, 111, '2015-03-15 00:02:43.000000', 'temperatura', 943.0000, 'ºC'),
	(110711, 111, '2015-03-15 00:02:44.000000', 'temperatura', 1006.0000, 'ºC'),
	(110712, 111, '2015-03-15 00:02:45.000000', 'temperatura', 1001.0000, 'ºC'),
	(110713, 111, '2015-03-15 00:02:46.000000', 'temperatura', 789.0000, 'ºC'),
	(110714, 111, '2015-03-15 00:02:47.000000', 'temperatura', 939.0000, 'ºC'),
	(110715, 111, '2015-03-15 00:02:48.000000', 'temperatura', 1132.0000, 'ºC'),
	(110716, 111, '2015-03-15 00:02:49.000000', 'temperatura', 442.0000, 'ºC'),
	(110717, 111, '2015-03-15 00:02:50.000000', 'temperatura', 14.0000, 'ºC'),
	(110718, 111, '2015-03-15 00:02:51.000000', 'temperatura', 1146.0000, 'ºC'),
	(110719, 111, '2015-03-15 00:02:52.000000', 'temperatura', 889.0000, 'ºC'),
	(110720, 111, '2015-03-15 00:02:53.000000', 'temperatura', 1008.0000, 'ºC'),
	(110721, 111, '2015-03-15 00:02:54.000000', 'temperatura', 1171.0000, 'ºC'),
	(110722, 111, '2015-03-15 00:02:55.000000', 'temperatura', 431.0000, 'ºC'),
	(110723, 111, '2015-03-15 00:02:56.000000', 'temperatura', 1042.0000, 'ºC'),
	(110724, 111, '2015-03-15 00:02:57.000000', 'temperatura', 318.0000, 'ºC'),
	(110725, 111, '2015-03-15 00:02:58.000000', 'temperatura', 864.0000, 'ºC'),
	(110726, 111, '2015-03-15 00:02:59.000000', 'temperatura', 965.0000, 'ºC'),
	(110727, 111, '2015-03-15 00:03:00.000000', 'temperatura', 1037.0000, 'ºC'),
	(110728, 111, '2015-03-15 00:03:01.000000', 'temperatura', 1088.0000, 'ºC'),
	(110729, 111, '2015-03-15 00:03:02.000000', 'temperatura', 1129.0000, 'ºC'),
	(110730, 111, '2015-03-15 00:03:03.000000', 'temperatura', 1183.0000, 'ºC'),
	(110731, 111, '2015-03-15 00:03:04.000000', 'temperatura', 128.0000, 'ºC'),
	(110732, 111, '2015-03-15 00:03:05.000000', 'temperatura', 691.0000, 'ºC'),
	(110733, 111, '2015-03-15 00:03:06.000000', 'temperatura', 670.0000, 'ºC'),
	(110734, 111, '2015-03-15 00:03:07.000000', 'temperatura', 80.0000, 'ºC'),
	(110735, 111, '2015-03-15 00:03:08.000000', 'temperatura', 792.0000, 'ºC'),
	(110736, 111, '2015-03-15 00:03:09.000000', 'temperatura', 118.0000, 'ºC'),
	(110737, 111, '2015-03-15 00:03:10.000000', 'temperatura', 614.0000, 'ºC'),
	(110738, 111, '2015-03-15 00:03:11.000000', 'temperatura', 317.0000, 'ºC'),
	(110739, 111, '2015-03-15 00:03:12.000000', 'temperatura', 943.0000, 'ºC'),
	(110740, 111, '2015-03-15 00:03:13.000000', 'temperatura', 164.0000, 'ºC'),
	(110741, 111, '2015-03-15 00:03:14.000000', 'temperatura', 394.0000, 'ºC'),
	(110742, 111, '2015-03-15 00:03:15.000000', 'temperatura', 277.0000, 'ºC'),
	(110743, 111, '2015-03-15 00:03:16.000000', 'temperatura', 206.0000, 'ºC'),
	(110744, 111, '2015-03-15 00:03:17.000000', 'temperatura', 196.0000, 'ºC'),
	(110745, 111, '2015-03-15 00:03:18.000000', 'temperatura', 364.0000, 'ºC'),
	(110746, 111, '2015-03-15 00:03:19.000000', 'temperatura', 32.0000, 'ºC'),
	(110747, 111, '2015-03-15 00:03:20.000000', 'temperatura', 268.0000, 'ºC'),
	(110748, 111, '2015-03-15 00:03:21.000000', 'temperatura', 44.0000, 'ºC'),
	(110749, 111, '2015-03-15 00:03:22.000000', 'temperatura', 618.0000, 'ºC'),
	(110750, 111, '2015-03-15 00:03:23.000000', 'temperatura', 557.0000, 'ºC'),
	(110751, 111, '2015-03-15 00:03:24.000000', 'temperatura', 930.0000, 'ºC'),
	(110752, 111, '2015-03-15 00:03:25.000000', 'temperatura', 583.0000, 'ºC'),
	(110753, 111, '2015-03-15 00:03:26.000000', 'temperatura', 123.0000, 'ºC'),
	(110754, 111, '2015-03-15 00:03:27.000000', 'temperatura', 69.0000, 'ºC'),
	(110755, 111, '2015-03-15 00:03:28.000000', 'temperatura', 1174.0000, 'ºC'),
	(110756, 111, '2015-03-15 00:03:29.000000', 'temperatura', 862.0000, 'ºC'),
	(110757, 111, '2015-03-15 00:03:30.000000', 'temperatura', 791.0000, 'ºC'),
	(110758, 111, '2015-03-15 00:03:31.000000', 'temperatura', 170.0000, 'ºC'),
	(110759, 111, '2015-03-15 00:03:32.000000', 'temperatura', 878.0000, 'ºC'),
	(110760, 111, '2015-03-15 00:03:33.000000', 'temperatura', 281.0000, 'ºC'),
	(110761, 111, '2015-03-15 00:03:34.000000', 'temperatura', 1169.0000, 'ºC'),
	(110762, 111, '2015-03-15 00:03:35.000000', 'temperatura', 205.0000, 'ºC'),
	(110763, 111, '2015-03-15 00:03:36.000000', 'temperatura', 1117.0000, 'ºC'),
	(110764, 111, '2015-03-15 00:03:37.000000', 'temperatura', 171.0000, 'ºC'),
	(110765, 111, '2015-03-15 00:03:38.000000', 'temperatura', 1105.0000, 'ºC'),
	(110766, 111, '2015-03-15 00:03:39.000000', 'temperatura', 212.0000, 'ºC'),
	(110767, 111, '2015-03-15 00:03:40.000000', 'temperatura', 145.0000, 'ºC'),
	(110768, 111, '2015-03-15 00:03:41.000000', 'temperatura', 89.0000, 'ºC'),
	(110769, 111, '2015-03-15 00:03:42.000000', 'temperatura', 11.0000, 'ºC'),
	(110770, 111, '2015-03-15 00:03:43.000000', 'temperatura', 987.0000, 'ºC'),
	(110771, 111, '2015-03-15 00:03:44.000000', 'temperatura', 104.0000, 'ºC'),
	(110772, 111, '2015-03-15 00:03:45.000000', 'temperatura', 1159.0000, 'ºC'),
	(110773, 111, '2015-03-15 00:03:46.000000', 'temperatura', 686.0000, 'ºC'),
	(110774, 111, '2015-03-15 00:03:47.000000', 'temperatura', 1150.0000, 'ºC'),
	(110775, 111, '2015-03-15 00:03:48.000000', 'temperatura', 95.0000, 'ºC'),
	(110776, 111, '2015-03-15 00:03:49.000000', 'temperatura', 623.0000, 'ºC'),
	(110777, 111, '2015-03-15 00:03:50.000000', 'temperatura', 430.0000, 'ºC'),
	(110778, 111, '2015-03-15 00:03:51.000000', 'temperatura', 281.0000, 'ºC'),
	(110779, 111, '2015-03-15 00:03:52.000000', 'temperatura', 117.0000, 'ºC'),
	(110780, 111, '2015-03-15 00:03:53.000000', 'temperatura', 941.0000, 'ºC'),
	(110781, 111, '2015-03-15 00:03:54.000000', 'temperatura', 756.0000, 'ºC'),
	(110782, 111, '2015-03-15 00:03:55.000000', 'temperatura', 959.0000, 'ºC'),
	(110783, 111, '2015-03-15 00:03:56.000000', 'temperatura', 127.0000, 'ºC'),
	(110784, 111, '2015-03-15 00:03:57.000000', 'temperatura', 157.0000, 'ºC'),
	(110785, 111, '2015-03-15 00:03:58.000000', 'temperatura', 407.0000, 'ºC'),
	(110786, 111, '2015-03-15 00:03:59.000000', 'temperatura', 363.0000, 'ºC'),
	(110787, 111, '2015-03-15 00:04:00.000000', 'temperatura', 594.0000, 'ºC'),
	(110788, 111, '2015-03-15 00:04:01.000000', 'temperatura', 682.0000, 'ºC'),
	(110789, 111, '2015-03-15 00:04:02.000000', 'temperatura', 429.0000, 'ºC'),
	(110790, 111, '2015-03-15 00:04:03.000000', 'temperatura', 98.0000, 'ºC'),
	(110791, 111, '2015-03-15 00:04:04.000000', 'temperatura', 402.0000, 'ºC'),
	(110792, 111, '2015-03-15 00:04:05.000000', 'temperatura', 519.0000, 'ºC'),
	(110793, 111, '2015-03-15 00:04:06.000000', 'temperatura', 190.0000, 'ºC'),
	(110794, 111, '2015-03-15 00:04:07.000000', 'temperatura', 593.0000, 'ºC'),
	(110795, 111, '2015-03-15 00:04:08.000000', 'temperatura', 1197.0000, 'ºC'),
	(110796, 111, '2015-03-15 00:04:09.000000', 'temperatura', 604.0000, 'ºC'),
	(110797, 111, '2015-03-15 00:04:10.000000', 'temperatura', 631.0000, 'ºC'),
	(110798, 111, '2015-03-15 00:04:11.000000', 'temperatura', 144.0000, 'ºC'),
	(110799, 111, '2015-03-15 00:04:12.000000', 'temperatura', 26.0000, 'ºC'),
	(110800, 111, '2015-03-15 00:04:13.000000', 'temperatura', 901.0000, 'ºC'),
	(110801, 111, '2015-03-15 00:04:14.000000', 'temperatura', 825.0000, 'ºC'),
	(110802, 111, '2015-03-15 00:04:15.000000', 'temperatura', 223.0000, 'ºC'),
	(110803, 111, '2015-03-15 00:04:16.000000', 'temperatura', 1042.0000, 'ºC'),
	(110804, 111, '2015-03-15 00:04:17.000000', 'temperatura', 940.0000, 'ºC'),
	(110805, 111, '2015-03-15 00:04:18.000000', 'temperatura', 377.0000, 'ºC'),
	(110806, 111, '2015-03-15 00:04:19.000000', 'temperatura', 264.0000, 'ºC'),
	(110807, 111, '2015-03-15 00:04:20.000000', 'temperatura', 189.0000, 'ºC'),
	(110808, 111, '2015-03-15 00:04:21.000000', 'temperatura', 153.0000, 'ºC'),
	(110809, 111, '2015-03-15 00:04:22.000000', 'temperatura', 199.0000, 'ºC'),
	(110810, 111, '2015-03-15 00:04:23.000000', 'temperatura', 535.0000, 'ºC'),
	(110811, 111, '2015-03-15 00:04:24.000000', 'temperatura', 879.0000, 'ºC'),
	(110812, 111, '2015-03-15 00:04:25.000000', 'temperatura', 392.0000, 'ºC'),
	(110813, 111, '2015-03-15 00:04:26.000000', 'temperatura', 521.0000, 'ºC'),
	(110814, 111, '2015-03-15 00:04:27.000000', 'temperatura', 231.0000, 'ºC'),
	(110815, 111, '2015-03-15 00:04:28.000000', 'temperatura', 793.0000, 'ºC'),
	(110816, 111, '2015-03-15 00:04:29.000000', 'temperatura', 871.0000, 'ºC'),
	(110817, 111, '2015-03-15 00:04:30.000000', 'temperatura', 776.0000, 'ºC'),
	(110818, 111, '2015-03-15 00:04:31.000000', 'temperatura', 69.0000, 'ºC'),
	(110819, 111, '2015-03-15 00:04:32.000000', 'temperatura', 416.0000, 'ºC'),
	(110820, 111, '2015-03-15 00:04:33.000000', 'temperatura', 674.0000, 'ºC'),
	(110821, 111, '2015-03-15 00:04:34.000000', 'temperatura', 922.0000, 'ºC'),
	(110822, 111, '2015-03-15 00:04:35.000000', 'temperatura', 190.0000, 'ºC'),
	(110823, 111, '2015-03-15 00:04:36.000000', 'temperatura', 582.0000, 'ºC'),
	(110824, 111, '2015-03-15 00:04:37.000000', 'temperatura', 1142.0000, 'ºC'),
	(110825, 111, '2015-03-15 00:04:38.000000', 'temperatura', 366.0000, 'ºC'),
	(110826, 111, '2015-03-15 00:04:39.000000', 'temperatura', 805.0000, 'ºC'),
	(110827, 111, '2015-03-15 00:04:40.000000', 'temperatura', 526.0000, 'ºC'),
	(110828, 111, '2015-03-15 00:04:41.000000', 'temperatura', 214.0000, 'ºC'),
	(110829, 111, '2015-03-15 00:04:42.000000', 'temperatura', 695.0000, 'ºC'),
	(110830, 111, '2015-03-15 00:04:43.000000', 'temperatura', 432.0000, 'ºC'),
	(110831, 111, '2015-03-15 00:04:44.000000', 'temperatura', 77.0000, 'ºC'),
	(110832, 111, '2015-03-15 00:04:45.000000', 'temperatura', 287.0000, 'ºC'),
	(110833, 111, '2015-03-15 00:04:46.000000', 'temperatura', 7.0000, 'ºC'),
	(110834, 111, '2015-03-15 00:04:47.000000', 'temperatura', 372.0000, 'ºC'),
	(110835, 111, '2015-03-15 00:04:48.000000', 'temperatura', 641.0000, 'ºC'),
	(110836, 111, '2015-03-15 00:04:49.000000', 'temperatura', 889.0000, 'ºC'),
	(110837, 111, '2015-03-15 00:04:50.000000', 'temperatura', 122.0000, 'ºC'),
	(110838, 111, '2015-03-15 00:04:51.000000', 'temperatura', 344.0000, 'ºC'),
	(110839, 111, '2015-03-15 00:04:52.000000', 'temperatura', 153.0000, 'ºC'),
	(110840, 111, '2015-03-15 00:04:53.000000', 'temperatura', 935.0000, 'ºC'),
	(110841, 111, '2015-03-15 00:04:54.000000', 'temperatura', 615.0000, 'ºC'),
	(110842, 111, '2015-03-15 00:04:55.000000', 'temperatura', 270.0000, 'ºC'),
	(110843, 111, '2015-03-15 00:04:56.000000', 'temperatura', 705.0000, 'ºC'),
	(110844, 111, '2015-03-15 00:04:57.000000', 'temperatura', 315.0000, 'ºC'),
	(110845, 111, '2015-03-15 00:04:58.000000', 'temperatura', 661.0000, 'ºC'),
	(110846, 111, '2015-03-15 00:04:59.000000', 'temperatura', 1159.0000, 'ºC'),
	(110847, 111, '2015-03-15 00:05:00.000000', 'temperatura', 213.0000, 'ºC'),
	(110848, 111, '2015-03-15 00:05:01.000000', 'temperatura', 1190.0000, 'ºC'),
	(110849, 111, '2015-03-15 00:05:02.000000', 'temperatura', 511.0000, 'ºC'),
	(110850, 111, '2015-03-15 00:05:03.000000', 'temperatura', 186.0000, 'ºC'),
	(110851, 111, '2015-03-15 00:05:04.000000', 'temperatura', 597.0000, 'ºC'),
	(110852, 111, '2015-03-15 00:05:05.000000', 'temperatura', 29.0000, 'ºC'),
	(110853, 111, '2015-03-15 00:05:06.000000', 'temperatura', 754.0000, 'ºC'),
	(110854, 111, '2015-03-15 00:05:07.000000', 'temperatura', 82.0000, 'ºC'),
	(110855, 111, '2015-03-15 00:05:08.000000', 'temperatura', 547.0000, 'ºC'),
	(110856, 111, '2015-03-15 00:05:09.000000', 'temperatura', 92.0000, 'ºC'),
	(110857, 111, '2015-03-15 00:05:10.000000', 'temperatura', 19.0000, 'ºC'),
	(110858, 111, '2015-03-15 00:05:11.000000', 'temperatura', 1020.0000, 'ºC'),
	(110859, 111, '2015-03-15 00:05:12.000000', 'temperatura', 242.0000, 'ºC'),
	(110860, 111, '2015-03-15 00:05:13.000000', 'temperatura', 550.0000, 'ºC'),
	(110861, 111, '2015-03-15 00:05:14.000000', 'temperatura', 826.0000, 'ºC'),
	(110862, 111, '2015-03-15 00:05:15.000000', 'temperatura', 81.0000, 'ºC'),
	(110863, 111, '2015-03-15 00:05:16.000000', 'temperatura', 327.0000, 'ºC'),
	(110864, 111, '2015-03-15 00:05:17.000000', 'temperatura', 190.0000, 'ºC'),
	(110865, 111, '2015-03-15 00:05:18.000000', 'temperatura', 1172.0000, 'ºC'),
	(110866, 111, '2015-03-15 00:05:19.000000', 'temperatura', 492.0000, 'ºC'),
	(110867, 111, '2015-03-15 00:05:20.000000', 'temperatura', 142.0000, 'ºC'),
	(110868, 111, '2015-03-15 00:05:21.000000', 'temperatura', 434.0000, 'ºC'),
	(110869, 111, '2015-03-15 00:05:22.000000', 'temperatura', 544.0000, 'ºC'),
	(110870, 111, '2015-03-15 00:05:23.000000', 'temperatura', 218.0000, 'ºC'),
	(110871, 111, '2015-03-15 00:05:24.000000', 'temperatura', 661.0000, 'ºC'),
	(110872, 111, '2015-03-15 00:05:25.000000', 'temperatura', 249.0000, 'ºC'),
	(110873, 111, '2015-03-15 00:05:26.000000', 'temperatura', 462.0000, 'ºC'),
	(110874, 111, '2015-03-15 00:05:27.000000', 'temperatura', 364.0000, 'ºC'),
	(110875, 111, '2015-03-15 00:05:28.000000', 'temperatura', 437.0000, 'ºC'),
	(110876, 111, '2015-03-15 00:05:29.000000', 'temperatura', 1091.0000, 'ºC'),
	(110877, 111, '2015-03-15 00:05:30.000000', 'temperatura', 546.0000, 'ºC'),
	(110878, 111, '2015-03-15 00:05:31.000000', 'temperatura', 656.0000, 'ºC'),
	(110879, 111, '2015-03-15 00:05:32.000000', 'temperatura', 443.0000, 'ºC'),
	(110880, 111, '2015-03-15 00:05:33.000000', 'temperatura', 246.0000, 'ºC'),
	(110881, 111, '2015-03-15 00:05:34.000000', 'temperatura', 1104.0000, 'ºC'),
	(110882, 111, '2015-03-15 00:05:35.000000', 'temperatura', 1180.0000, 'ºC'),
	(110883, 111, '2015-03-15 00:05:36.000000', 'temperatura', 189.0000, 'ºC'),
	(110884, 111, '2015-03-15 00:05:37.000000', 'temperatura', 1008.0000, 'ºC'),
	(110885, 111, '2015-03-15 00:05:38.000000', 'temperatura', 872.0000, 'ºC'),
	(110886, 111, '2015-03-15 00:05:39.000000', 'temperatura', 137.0000, 'ºC'),
	(110887, 111, '2015-03-15 00:05:40.000000', 'temperatura', 470.0000, 'ºC'),
	(110888, 111, '2015-03-15 00:05:41.000000', 'temperatura', 738.0000, 'ºC'),
	(110889, 111, '2015-03-15 00:05:42.000000', 'temperatura', 1080.0000, 'ºC'),
	(110890, 111, '2015-03-15 00:05:43.000000', 'temperatura', 788.0000, 'ºC'),
	(110891, 111, '2015-03-15 00:05:44.000000', 'temperatura', 702.0000, 'ºC'),
	(110892, 111, '2015-03-15 00:05:45.000000', 'temperatura', 1144.0000, 'ºC'),
	(110893, 111, '2015-03-15 00:05:46.000000', 'temperatura', 16.0000, 'ºC'),
	(110894, 111, '2015-03-15 00:05:47.000000', 'temperatura', 246.0000, 'ºC'),
	(110895, 111, '2015-03-15 00:05:48.000000', 'temperatura', 1186.0000, 'ºC'),
	(110896, 111, '2015-03-15 00:05:49.000000', 'temperatura', 390.0000, 'ºC'),
	(110897, 111, '2015-03-15 00:05:50.000000', 'temperatura', 795.0000, 'ºC'),
	(110898, 111, '2015-03-15 00:05:51.000000', 'temperatura', 404.0000, 'ºC'),
	(110899, 111, '2015-03-15 00:05:52.000000', 'temperatura', 836.0000, 'ºC'),
	(110900, 111, '2015-03-15 00:05:53.000000', 'temperatura', 568.0000, 'ºC'),
	(110901, 111, '2015-03-15 00:05:54.000000', 'temperatura', 333.0000, 'ºC'),
	(110902, 111, '2015-03-15 00:05:55.000000', 'temperatura', 1161.0000, 'ºC'),
	(110903, 111, '2015-03-15 00:05:56.000000', 'temperatura', 5.0000, 'ºC'),
	(110904, 111, '2015-03-15 00:05:57.000000', 'temperatura', 144.0000, 'ºC'),
	(110905, 111, '2015-03-15 00:05:58.000000', 'temperatura', 706.0000, 'ºC'),
	(110906, 111, '2015-03-15 00:05:59.000000', 'temperatura', 697.0000, 'ºC'),
	(110907, 111, '2015-03-15 00:06:00.000000', 'temperatura', 170.0000, 'ºC'),
	(110908, 111, '2015-03-15 00:06:01.000000', 'temperatura', 1157.0000, 'ºC'),
	(110909, 111, '2015-03-15 00:06:02.000000', 'temperatura', 475.0000, 'ºC'),
	(110910, 111, '2015-03-15 00:06:03.000000', 'temperatura', 106.0000, 'ºC'),
	(110911, 111, '2015-03-15 00:06:04.000000', 'temperatura', 307.0000, 'ºC'),
	(110912, 111, '2015-03-15 00:06:05.000000', 'temperatura', 14.0000, 'ºC'),
	(110913, 111, '2015-03-15 00:06:06.000000', 'temperatura', 352.0000, 'ºC'),
	(110914, 111, '2015-03-15 00:06:07.000000', 'temperatura', 520.0000, 'ºC'),
	(110915, 111, '2015-03-15 00:06:08.000000', 'temperatura', 342.0000, 'ºC'),
	(110916, 111, '2015-03-15 00:06:09.000000', 'temperatura', 151.0000, 'ºC'),
	(110917, 111, '2015-03-15 00:06:10.000000', 'temperatura', 932.0000, 'ºC'),
	(110918, 111, '2015-03-15 00:06:11.000000', 'temperatura', 604.0000, 'ºC'),
	(110919, 111, '2015-03-15 00:06:12.000000', 'temperatura', 225.0000, 'ºC'),
	(110920, 111, '2015-03-15 00:06:13.000000', 'temperatura', 513.0000, 'ºC'),
	(110921, 111, '2015-03-15 00:06:14.000000', 'temperatura', 691.0000, 'ºC'),
	(110922, 111, '2015-03-15 00:06:15.000000', 'temperatura', 718.0000, 'ºC'),
	(110923, 111, '2015-03-15 00:06:16.000000', 'temperatura', 318.0000, 'ºC'),
	(110924, 111, '2015-03-15 00:06:17.000000', 'temperatura', 636.0000, 'ºC'),
	(110925, 111, '2015-03-15 00:06:18.000000', 'temperatura', 1025.0000, 'ºC'),
	(110926, 111, '2015-03-15 00:06:19.000000', 'temperatura', 819.0000, 'ºC'),
	(110927, 111, '2015-03-15 00:06:20.000000', 'temperatura', 1018.0000, 'ºC'),
	(110928, 111, '2015-03-15 00:06:21.000000', 'temperatura', 236.0000, 'ºC'),
	(110929, 111, '2015-03-15 00:06:22.000000', 'temperatura', 525.0000, 'ºC'),
	(110930, 111, '2015-03-15 00:06:23.000000', 'temperatura', 720.0000, 'ºC'),
	(110931, 111, '2015-03-15 00:06:24.000000', 'temperatura', 823.0000, 'ºC'),
	(110932, 111, '2015-03-15 00:06:25.000000', 'temperatura', 755.0000, 'ºC'),
	(110933, 111, '2015-03-15 00:06:26.000000', 'temperatura', 106.0000, 'ºC'),
	(110934, 111, '2015-03-15 00:06:27.000000', 'temperatura', 668.0000, 'ºC'),
	(110935, 111, '2015-03-15 00:06:28.000000', 'temperatura', 622.0000, 'ºC'),
	(110936, 111, '2015-03-15 00:06:29.000000', 'temperatura', 1108.0000, 'ºC'),
	(110937, 111, '2015-03-15 00:06:30.000000', 'temperatura', 73.0000, 'ºC'),
	(110938, 111, '2015-03-15 00:06:31.000000', 'temperatura', 643.0000, 'ºC'),
	(110939, 111, '2015-03-15 00:06:32.000000', 'temperatura', 595.0000, 'ºC'),
	(110940, 111, '2015-03-15 00:06:33.000000', 'temperatura', 1048.0000, 'ºC'),
	(110941, 111, '2015-03-15 00:06:34.000000', 'temperatura', 1057.0000, 'ºC'),
	(110942, 111, '2015-03-15 00:06:35.000000', 'temperatura', 939.0000, 'ºC'),
	(110943, 111, '2015-03-15 00:06:36.000000', 'temperatura', 325.0000, 'ºC'),
	(110944, 111, '2015-03-15 00:06:37.000000', 'temperatura', 10.0000, 'ºC'),
	(110945, 111, '2015-03-15 00:06:38.000000', 'temperatura', 274.0000, 'ºC'),
	(110946, 111, '2015-03-15 00:06:39.000000', 'temperatura', 141.0000, 'ºC'),
	(110947, 111, '2015-03-15 00:06:40.000000', 'temperatura', 1085.0000, 'ºC'),
	(110948, 111, '2015-03-15 00:06:41.000000', 'temperatura', 203.0000, 'ºC'),
	(110949, 111, '2015-03-15 00:06:42.000000', 'temperatura', 160.0000, 'ºC'),
	(110950, 111, '2015-03-15 00:06:43.000000', 'temperatura', 190.0000, 'ºC'),
	(110951, 111, '2015-03-15 00:06:44.000000', 'temperatura', 473.0000, 'ºC'),
	(110952, 111, '2015-03-15 00:06:45.000000', 'temperatura', 593.0000, 'ºC'),
	(110953, 111, '2015-03-15 00:06:46.000000', 'temperatura', 348.0000, 'ºC'),
	(110954, 111, '2015-03-15 00:06:47.000000', 'temperatura', 1160.0000, 'ºC'),
	(110955, 111, '2015-03-15 00:06:48.000000', 'temperatura', 1159.0000, 'ºC'),
	(110956, 111, '2015-03-15 00:06:49.000000', 'temperatura', 1116.0000, 'ºC'),
	(110957, 111, '2015-03-15 00:06:50.000000', 'temperatura', 902.0000, 'ºC'),
	(110958, 111, '2015-03-15 00:06:51.000000', 'temperatura', 1163.0000, 'ºC'),
	(110959, 111, '2015-03-15 00:06:52.000000', 'temperatura', 711.0000, 'ºC'),
	(110960, 111, '2015-03-15 00:06:53.000000', 'temperatura', 64.0000, 'ºC'),
	(110961, 111, '2015-03-15 00:06:54.000000', 'temperatura', 591.0000, 'ºC'),
	(110962, 111, '2015-03-15 00:06:55.000000', 'temperatura', 360.0000, 'ºC'),
	(110963, 111, '2015-03-15 00:06:56.000000', 'temperatura', 28.0000, 'ºC'),
	(110964, 111, '2015-03-15 00:06:57.000000', 'temperatura', 261.0000, 'ºC'),
	(110965, 111, '2015-03-15 00:06:58.000000', 'temperatura', 20.0000, 'ºC'),
	(110966, 111, '2015-03-15 00:06:59.000000', 'temperatura', 518.0000, 'ºC'),
	(110967, 111, '2015-03-15 00:07:00.000000', 'temperatura', 133.0000, 'ºC'),
	(110968, 111, '2015-03-15 00:07:01.000000', 'temperatura', 308.0000, 'ºC'),
	(110969, 111, '2015-03-15 00:07:02.000000', 'temperatura', 1143.0000, 'ºC'),
	(110970, 111, '2015-03-15 00:07:03.000000', 'temperatura', 1190.0000, 'ºC'),
	(110971, 111, '2015-03-15 00:07:04.000000', 'temperatura', 124.0000, 'ºC'),
	(110972, 111, '2015-03-15 00:07:05.000000', 'temperatura', 650.0000, 'ºC'),
	(110973, 111, '2015-03-15 00:07:06.000000', 'temperatura', 478.0000, 'ºC'),
	(110974, 111, '2015-03-15 00:07:07.000000', 'temperatura', 442.0000, 'ºC'),
	(110975, 111, '2015-03-15 00:07:08.000000', 'temperatura', 775.0000, 'ºC'),
	(110976, 111, '2015-03-15 00:07:09.000000', 'temperatura', 149.0000, 'ºC'),
	(110977, 111, '2015-03-15 00:07:10.000000', 'temperatura', 820.0000, 'ºC'),
	(110978, 111, '2015-03-15 00:07:11.000000', 'temperatura', 53.0000, 'ºC'),
	(110979, 111, '2015-03-15 00:07:12.000000', 'temperatura', 207.0000, 'ºC'),
	(110980, 111, '2015-03-15 00:07:13.000000', 'temperatura', 878.0000, 'ºC'),
	(110981, 111, '2015-03-15 00:07:14.000000', 'temperatura', 168.0000, 'ºC'),
	(110982, 111, '2015-03-15 00:07:15.000000', 'temperatura', 607.0000, 'ºC'),
	(110983, 111, '2015-03-15 00:07:16.000000', 'temperatura', 130.0000, 'ºC'),
	(110984, 111, '2015-03-15 00:07:17.000000', 'temperatura', 28.0000, 'ºC'),
	(110985, 111, '2015-03-15 00:07:18.000000', 'temperatura', 953.0000, 'ºC'),
	(110986, 111, '2015-03-15 00:07:19.000000', 'temperatura', 1083.0000, 'ºC'),
	(110987, 111, '2015-03-15 00:07:20.000000', 'temperatura', 155.0000, 'ºC'),
	(110988, 111, '2015-03-15 00:07:21.000000', 'temperatura', 1127.0000, 'ºC'),
	(110989, 111, '2015-03-15 00:07:22.000000', 'temperatura', 368.0000, 'ºC'),
	(110990, 111, '2015-03-15 00:07:23.000000', 'temperatura', 861.0000, 'ºC'),
	(110991, 111, '2015-03-15 00:07:24.000000', 'temperatura', 803.0000, 'ºC'),
	(110992, 111, '2015-03-15 00:07:25.000000', 'temperatura', 232.0000, 'ºC'),
	(110993, 111, '2015-03-15 00:07:26.000000', 'temperatura', 1151.0000, 'ºC'),
	(110994, 111, '2015-03-15 00:07:27.000000', 'temperatura', 261.0000, 'ºC'),
	(110995, 111, '2015-03-15 00:07:28.000000', 'temperatura', 250.0000, 'ºC'),
	(110996, 111, '2015-03-15 00:07:29.000000', 'temperatura', 467.0000, 'ºC'),
	(110997, 111, '2015-03-15 00:07:30.000000', 'temperatura', 388.0000, 'ºC'),
	(110998, 111, '2015-03-15 00:07:31.000000', 'temperatura', 538.0000, 'ºC'),
	(110999, 111, '2015-03-15 00:07:32.000000', 'temperatura', 329.0000, 'ºC'),
	(111000, 111, '2015-03-15 00:07:33.000000', 'temperatura', 30.0000, 'ºC'),
	(111001, 111, '2015-03-15 00:07:34.000000', 'temperatura', 363.0000, 'ºC'),
	(111002, 111, '2015-03-15 00:07:35.000000', 'temperatura', 524.0000, 'ºC'),
	(111003, 111, '2015-03-15 00:07:36.000000', 'temperatura', 333.0000, 'ºC'),
	(111004, 111, '2015-03-15 00:07:37.000000', 'temperatura', 94.0000, 'ºC'),
	(111005, 111, '2015-03-15 00:07:38.000000', 'temperatura', 673.0000, 'ºC'),
	(111006, 111, '2015-03-15 00:07:39.000000', 'temperatura', 681.0000, 'ºC'),
	(111007, 111, '2015-03-15 00:07:40.000000', 'temperatura', 188.0000, 'ºC'),
	(111008, 111, '2015-03-15 00:07:41.000000', 'temperatura', 96.0000, 'ºC'),
	(111009, 111, '2015-03-15 00:07:42.000000', 'temperatura', 1119.0000, 'ºC'),
	(111010, 111, '2015-03-15 00:07:43.000000', 'temperatura', 506.0000, 'ºC'),
	(111011, 111, '2015-03-15 00:07:44.000000', 'temperatura', 372.0000, 'ºC'),
	(111012, 111, '2015-03-15 00:07:45.000000', 'temperatura', 345.0000, 'ºC'),
	(111013, 111, '2015-03-15 00:07:46.000000', 'temperatura', 610.0000, 'ºC'),
	(111014, 111, '2015-03-15 00:07:47.000000', 'temperatura', 814.0000, 'ºC'),
	(111015, 111, '2015-03-15 00:07:48.000000', 'temperatura', 1040.0000, 'ºC'),
	(111016, 111, '2015-03-15 00:07:49.000000', 'temperatura', 358.0000, 'ºC'),
	(111017, 111, '2015-03-15 00:07:50.000000', 'temperatura', 1071.0000, 'ºC'),
	(111018, 111, '2015-03-15 00:07:51.000000', 'temperatura', 681.0000, 'ºC'),
	(111019, 111, '2015-03-15 00:07:52.000000', 'temperatura', 193.0000, 'ºC'),
	(111020, 111, '2015-03-15 00:07:53.000000', 'temperatura', 123.0000, 'ºC'),
	(111021, 111, '2015-03-15 00:07:54.000000', 'temperatura', 37.0000, 'ºC'),
	(111022, 111, '2015-03-15 00:07:55.000000', 'temperatura', 1015.0000, 'ºC'),
	(111023, 111, '2015-03-15 00:07:56.000000', 'temperatura', 166.0000, 'ºC'),
	(111024, 111, '2015-03-15 00:07:57.000000', 'temperatura', 183.0000, 'ºC'),
	(111025, 111, '2015-03-15 00:07:58.000000', 'temperatura', 418.0000, 'ºC'),
	(111026, 111, '2015-03-15 00:07:59.000000', 'temperatura', 344.0000, 'ºC'),
	(111027, 111, '2015-03-15 00:08:00.000000', 'temperatura', 466.0000, 'ºC'),
	(111028, 111, '2015-03-15 00:08:01.000000', 'temperatura', 96.0000, 'ºC'),
	(111029, 111, '2015-03-15 00:08:02.000000', 'temperatura', 284.0000, 'ºC'),
	(111030, 111, '2015-03-15 00:08:03.000000', 'temperatura', 1134.0000, 'ºC'),
	(111031, 111, '2015-03-15 00:08:04.000000', 'temperatura', 15.0000, 'ºC'),
	(111032, 111, '2015-03-15 00:08:05.000000', 'temperatura', 276.0000, 'ºC'),
	(111033, 111, '2015-03-15 00:08:06.000000', 'temperatura', 137.0000, 'ºC'),
	(111034, 111, '2015-03-15 00:08:07.000000', 'temperatura', 1056.0000, 'ºC'),
	(111035, 111, '2015-03-15 00:08:08.000000', 'temperatura', 69.0000, 'ºC'),
	(111036, 111, '2015-03-15 00:08:09.000000', 'temperatura', 779.0000, 'ºC'),
	(111037, 111, '2015-03-15 00:08:10.000000', 'temperatura', 86.0000, 'ºC'),
	(111038, 111, '2015-03-15 00:08:11.000000', 'temperatura', 494.0000, 'ºC'),
	(111039, 111, '2015-03-15 00:08:12.000000', 'temperatura', 1014.0000, 'ºC'),
	(111040, 111, '2015-03-15 00:08:13.000000', 'temperatura', 1187.0000, 'ºC'),
	(111041, 111, '2015-03-15 00:08:14.000000', 'temperatura', 495.0000, 'ºC'),
	(111042, 111, '2015-03-15 00:08:15.000000', 'temperatura', 112.0000, 'ºC'),
	(111043, 111, '2015-03-15 00:08:16.000000', 'temperatura', 277.0000, 'ºC'),
	(111044, 111, '2015-03-15 00:08:17.000000', 'temperatura', 1048.0000, 'ºC'),
	(111045, 111, '2015-03-15 00:08:18.000000', 'temperatura', 809.0000, 'ºC'),
	(111046, 111, '2015-03-15 00:08:19.000000', 'temperatura', 904.0000, 'ºC'),
	(111047, 111, '2015-03-15 00:08:20.000000', 'temperatura', 891.0000, 'ºC'),
	(111048, 111, '2015-03-15 00:08:21.000000', 'temperatura', 545.0000, 'ºC'),
	(111049, 111, '2015-03-15 00:08:22.000000', 'temperatura', 52.0000, 'ºC'),
	(111050, 111, '2015-03-15 00:08:23.000000', 'temperatura', 1025.0000, 'ºC'),
	(111051, 111, '2015-03-15 00:08:24.000000', 'temperatura', 172.0000, 'ºC'),
	(111052, 111, '2015-03-15 00:08:25.000000', 'temperatura', 182.0000, 'ºC'),
	(111053, 111, '2015-03-15 00:08:26.000000', 'temperatura', 397.0000, 'ºC'),
	(111054, 111, '2015-03-15 00:08:27.000000', 'temperatura', 238.0000, 'ºC'),
	(111055, 111, '2015-03-15 00:08:28.000000', 'temperatura', 1198.0000, 'ºC'),
	(111056, 111, '2015-03-15 00:08:29.000000', 'temperatura', 480.0000, 'ºC'),
	(111057, 111, '2015-03-15 00:08:30.000000', 'temperatura', 4.0000, 'ºC'),
	(111058, 111, '2015-03-15 00:08:31.000000', 'temperatura', 980.0000, 'ºC'),
	(111059, 111, '2015-03-15 00:08:32.000000', 'temperatura', 90.0000, 'ºC'),
	(111060, 111, '2015-03-15 00:08:33.000000', 'temperatura', 1110.0000, 'ºC'),
	(111061, 111, '2015-03-15 00:08:34.000000', 'temperatura', 481.0000, 'ºC'),
	(111062, 111, '2015-03-15 00:08:35.000000', 'temperatura', 275.0000, 'ºC'),
	(111063, 111, '2015-03-15 00:08:36.000000', 'temperatura', 1134.0000, 'ºC'),
	(111064, 111, '2015-03-15 00:08:37.000000', 'temperatura', 45.0000, 'ºC'),
	(111065, 111, '2015-03-15 00:08:38.000000', 'temperatura', 423.0000, 'ºC'),
	(111066, 111, '2015-03-15 00:08:39.000000', 'temperatura', 780.0000, 'ºC'),
	(111067, 111, '2015-03-15 00:08:40.000000', 'temperatura', 232.0000, 'ºC'),
	(111068, 111, '2015-03-15 00:08:41.000000', 'temperatura', 21.0000, 'ºC'),
	(111069, 111, '2015-03-15 00:08:42.000000', 'temperatura', 608.0000, 'ºC'),
	(111070, 111, '2015-03-15 00:08:43.000000', 'temperatura', 579.0000, 'ºC'),
	(111071, 111, '2015-03-15 00:08:44.000000', 'temperatura', 1072.0000, 'ºC'),
	(111072, 111, '2015-03-15 00:08:45.000000', 'temperatura', 24.0000, 'ºC'),
	(111073, 111, '2015-03-15 00:08:46.000000', 'temperatura', 505.0000, 'ºC'),
	(111074, 111, '2015-03-15 00:08:47.000000', 'temperatura', 52.0000, 'ºC'),
	(111075, 111, '2015-03-15 00:08:48.000000', 'temperatura', 1144.0000, 'ºC'),
	(111076, 111, '2015-03-15 00:08:49.000000', 'temperatura', 768.0000, 'ºC'),
	(111077, 111, '2015-03-15 00:08:50.000000', 'temperatura', 405.0000, 'ºC'),
	(111078, 111, '2015-03-15 00:08:51.000000', 'temperatura', 924.0000, 'ºC'),
	(111079, 111, '2015-03-15 00:08:52.000000', 'temperatura', 1004.0000, 'ºC'),
	(111080, 111, '2015-03-15 00:08:53.000000', 'temperatura', 1049.0000, 'ºC'),
	(111081, 111, '2015-03-15 00:08:54.000000', 'temperatura', 1035.0000, 'ºC'),
	(111082, 111, '2015-03-15 00:08:55.000000', 'temperatura', 829.0000, 'ºC'),
	(111083, 111, '2015-03-15 00:08:56.000000', 'temperatura', 1040.0000, 'ºC'),
	(111084, 111, '2015-03-15 00:08:57.000000', 'temperatura', 312.0000, 'ºC'),
	(111085, 111, '2015-03-15 00:08:58.000000', 'temperatura', 842.0000, 'ºC'),
	(111086, 111, '2015-03-15 00:08:59.000000', 'temperatura', 875.0000, 'ºC'),
	(111087, 111, '2015-03-15 00:09:00.000000', 'temperatura', 648.0000, 'ºC'),
	(111088, 111, '2015-03-15 00:09:01.000000', 'temperatura', 614.0000, 'ºC'),
	(111089, 111, '2015-03-15 00:09:02.000000', 'temperatura', 1128.0000, 'ºC'),
	(111090, 111, '2015-03-15 00:09:03.000000', 'temperatura', 196.0000, 'ºC'),
	(111091, 111, '2015-03-15 00:09:04.000000', 'temperatura', 0.0000, 'ºC'),
	(111092, 111, '2015-03-15 00:09:05.000000', 'temperatura', 612.0000, 'ºC'),
	(111093, 111, '2015-03-15 00:09:06.000000', 'temperatura', 661.0000, 'ºC'),
	(111094, 111, '2015-03-15 00:09:07.000000', 'temperatura', 268.0000, 'ºC'),
	(111095, 111, '2015-03-15 00:09:08.000000', 'temperatura', 558.0000, 'ºC'),
	(111096, 111, '2015-03-15 00:09:09.000000', 'temperatura', 788.0000, 'ºC'),
	(111097, 111, '2015-03-15 00:09:10.000000', 'temperatura', 1066.0000, 'ºC'),
	(111098, 111, '2015-03-15 00:09:11.000000', 'temperatura', 565.0000, 'ºC'),
	(111099, 111, '2015-03-15 00:09:12.000000', 'temperatura', 827.0000, 'ºC'),
	(111100, 111, '2015-03-15 00:09:13.000000', 'temperatura', 40.0000, 'ºC'),
	(111101, 111, '2015-03-15 00:09:14.000000', 'temperatura', 120.0000, 'ºC'),
	(111102, 111, '2015-03-15 00:09:15.000000', 'temperatura', 480.0000, 'ºC'),
	(111103, 111, '2015-03-15 00:09:16.000000', 'temperatura', 842.0000, 'ºC'),
	(111104, 111, '2015-03-15 00:09:17.000000', 'temperatura', 369.0000, 'ºC'),
	(111105, 111, '2015-03-15 00:09:18.000000', 'temperatura', 518.0000, 'ºC'),
	(111106, 111, '2015-03-15 00:09:19.000000', 'temperatura', 285.0000, 'ºC'),
	(111107, 111, '2015-03-15 00:09:20.000000', 'temperatura', 1071.0000, 'ºC'),
	(111108, 111, '2015-03-15 00:09:21.000000', 'temperatura', 902.0000, 'ºC'),
	(111109, 111, '2015-03-15 00:09:22.000000', 'temperatura', 98.0000, 'ºC'),
	(111110, 111, '2015-03-15 00:09:23.000000', 'temperatura', 183.0000, 'ºC'),
	(111111, 111, '2015-03-15 00:09:24.000000', 'temperatura', 622.0000, 'ºC'),
	(111112, 111, '2015-03-15 00:09:25.000000', 'temperatura', 163.0000, 'ºC'),
	(111113, 111, '2015-03-15 00:09:26.000000', 'temperatura', 147.0000, 'ºC'),
	(111114, 111, '2015-03-15 00:09:27.000000', 'temperatura', 247.0000, 'ºC'),
	(111115, 111, '2015-03-15 00:09:28.000000', 'temperatura', 796.0000, 'ºC'),
	(111116, 111, '2015-03-15 00:09:29.000000', 'temperatura', 838.0000, 'ºC'),
	(111117, 111, '2015-03-15 00:09:30.000000', 'temperatura', 605.0000, 'ºC'),
	(111118, 111, '2015-03-15 00:09:31.000000', 'temperatura', 508.0000, 'ºC'),
	(111119, 111, '2015-03-15 00:09:32.000000', 'temperatura', 728.0000, 'ºC'),
	(111120, 111, '2015-03-15 00:09:33.000000', 'temperatura', 915.0000, 'ºC'),
	(111121, 111, '2015-03-15 00:09:34.000000', 'temperatura', 1192.0000, 'ºC'),
	(111122, 111, '2015-03-15 00:09:35.000000', 'temperatura', 815.0000, 'ºC'),
	(111123, 111, '2015-03-15 00:09:36.000000', 'temperatura', 498.0000, 'ºC'),
	(111124, 111, '2015-03-15 00:09:37.000000', 'temperatura', 46.0000, 'ºC'),
	(111125, 111, '2015-03-15 00:09:38.000000', 'temperatura', 1137.0000, 'ºC'),
	(111126, 111, '2015-03-15 00:09:39.000000', 'temperatura', 746.0000, 'ºC'),
	(111127, 111, '2015-03-15 00:09:40.000000', 'temperatura', 322.0000, 'ºC'),
	(111128, 111, '2015-03-15 00:09:41.000000', 'temperatura', 570.0000, 'ºC'),
	(111129, 111, '2015-03-15 00:09:42.000000', 'temperatura', 684.0000, 'ºC'),
	(111130, 111, '2015-03-15 00:09:43.000000', 'temperatura', 510.0000, 'ºC'),
	(111131, 111, '2015-03-15 00:09:44.000000', 'temperatura', 501.0000, 'ºC'),
	(111132, 111, '2015-03-15 00:09:45.000000', 'temperatura', 974.0000, 'ºC'),
	(111133, 111, '2015-03-15 00:09:46.000000', 'temperatura', 968.0000, 'ºC'),
	(111134, 111, '2015-03-15 00:09:47.000000', 'temperatura', 718.0000, 'ºC'),
	(111135, 111, '2015-03-15 00:09:48.000000', 'temperatura', 688.0000, 'ºC'),
	(111136, 111, '2015-03-15 00:09:49.000000', 'temperatura', 86.0000, 'ºC'),
	(111137, 111, '2015-03-15 00:09:50.000000', 'temperatura', 768.0000, 'ºC'),
	(111138, 111, '2015-03-15 00:09:51.000000', 'temperatura', 1180.0000, 'ºC'),
	(111139, 111, '2015-03-15 00:09:52.000000', 'temperatura', 1198.0000, 'ºC'),
	(111140, 111, '2015-03-15 00:09:53.000000', 'temperatura', 50.0000, 'ºC'),
	(111141, 111, '2015-03-15 00:09:54.000000', 'temperatura', 259.0000, 'ºC'),
	(111142, 111, '2015-03-15 00:09:55.000000', 'temperatura', 1142.0000, 'ºC'),
	(111143, 111, '2015-03-15 00:09:56.000000', 'temperatura', 135.0000, 'ºC'),
	(111144, 111, '2015-03-15 00:09:57.000000', 'temperatura', 850.0000, 'ºC'),
	(111145, 111, '2015-03-15 00:09:58.000000', 'temperatura', 244.0000, 'ºC'),
	(111146, 111, '2015-03-15 00:09:59.000000', 'temperatura', 1073.0000, 'ºC'),
	(111147, 111, '2015-03-15 00:10:00.000000', 'temperatura', 1031.0000, 'ºC'),
	(111148, 111, '2015-03-15 00:10:01.000000', 'temperatura', 738.0000, 'ºC'),
	(111149, 111, '2015-03-15 00:10:02.000000', 'temperatura', 599.0000, 'ºC'),
	(111150, 111, '2015-03-15 00:10:03.000000', 'temperatura', 781.0000, 'ºC'),
	(111151, 111, '2015-03-15 00:10:04.000000', 'temperatura', 908.0000, 'ºC'),
	(111152, 111, '2015-03-15 00:10:05.000000', 'temperatura', 999.0000, 'ºC'),
	(111153, 111, '2015-03-15 00:10:06.000000', 'temperatura', 1069.0000, 'ºC'),
	(111154, 111, '2015-03-15 00:10:07.000000', 'temperatura', 1148.0000, 'ºC'),
	(111155, 111, '2015-03-15 00:10:08.000000', 'temperatura', 134.0000, 'ºC'),
	(111156, 111, '2015-03-15 00:10:09.000000', 'temperatura', 826.0000, 'ºC'),
	(111157, 111, '2015-03-15 00:10:10.000000', 'temperatura', 131.0000, 'ºC'),
	(111158, 111, '2015-03-15 00:10:11.000000', 'temperatura', 576.0000, 'ºC'),
	(111159, 111, '2015-03-15 00:10:12.000000', 'temperatura', 88.0000, 'ºC'),
	(111160, 111, '2015-03-15 00:10:13.000000', 'temperatura', 1112.0000, 'ºC'),
	(111161, 111, '2015-03-15 00:10:14.000000', 'temperatura', 495.0000, 'ºC'),
	(111162, 111, '2015-03-15 00:10:15.000000', 'temperatura', 341.0000, 'ºC'),
	(111163, 111, '2015-03-15 00:10:16.000000', 'temperatura', 218.0000, 'ºC'),
	(111164, 111, '2015-03-15 00:10:17.000000', 'temperatura', 71.0000, 'ºC'),
	(111165, 111, '2015-03-15 00:10:18.000000', 'temperatura', 900.0000, 'ºC'),
	(111166, 111, '2015-03-15 00:10:19.000000', 'temperatura', 688.0000, 'ºC'),
	(111167, 111, '2015-03-15 00:10:20.000000', 'temperatura', 739.0000, 'ºC'),
	(111168, 111, '2015-03-15 00:10:21.000000', 'temperatura', 434.0000, 'ºC'),
	(111169, 111, '2015-03-15 00:10:22.000000', 'temperatura', 1154.0000, 'ºC'),
	(111170, 111, '2015-03-15 00:10:23.000000', 'temperatura', 867.0000, 'ºC'),
	(111171, 111, '2015-03-15 00:10:24.000000', 'temperatura', 873.0000, 'ºC'),
	(111172, 111, '2015-03-15 00:10:25.000000', 'temperatura', 565.0000, 'ºC'),
	(111173, 111, '2015-03-15 00:10:26.000000', 'temperatura', 207.0000, 'ºC'),
	(111174, 111, '2015-03-15 00:10:27.000000', 'temperatura', 539.0000, 'ºC'),
	(111175, 111, '2015-03-15 00:10:28.000000', 'temperatura', 875.0000, 'ºC'),
	(111176, 111, '2015-03-15 00:10:29.000000', 'temperatura', 357.0000, 'ºC'),
	(111177, 111, '2015-03-15 00:10:30.000000', 'temperatura', 363.0000, 'ºC'),
	(111178, 111, '2015-03-15 00:10:31.000000', 'temperatura', 743.0000, 'ºC'),
	(111179, 111, '2015-03-15 00:10:32.000000', 'temperatura', 226.0000, 'ºC'),
	(111180, 111, '2015-03-15 00:10:33.000000', 'temperatura', 100.0000, 'ºC'),
	(111181, 111, '2015-03-15 00:10:34.000000', 'temperatura', 1026.0000, 'ºC'),
	(111182, 111, '2015-03-15 00:10:35.000000', 'temperatura', 28.0000, 'ºC'),
	(111183, 111, '2015-03-15 00:10:36.000000', 'temperatura', 664.0000, 'ºC'),
	(111184, 111, '2015-03-15 00:10:37.000000', 'temperatura', 835.0000, 'ºC'),
	(111185, 111, '2015-03-15 00:10:38.000000', 'temperatura', 982.0000, 'ºC'),
	(111186, 111, '2015-03-15 00:10:39.000000', 'temperatura', 8.0000, 'ºC'),
	(111187, 111, '2015-03-15 00:10:40.000000', 'temperatura', 692.0000, 'ºC'),
	(111188, 111, '2015-03-15 00:10:41.000000', 'temperatura', 1038.0000, 'ºC'),
	(111189, 111, '2015-03-15 00:10:42.000000', 'temperatura', 715.0000, 'ºC'),
	(111190, 111, '2015-03-15 00:10:43.000000', 'temperatura', 462.0000, 'ºC'),
	(111191, 111, '2015-03-15 00:10:44.000000', 'temperatura', 164.0000, 'ºC'),
	(111192, 111, '2015-03-15 00:10:45.000000', 'temperatura', 636.0000, 'ºC'),
	(111193, 111, '2015-03-15 00:10:46.000000', 'temperatura', 286.0000, 'ºC'),
	(111194, 111, '2015-03-15 00:10:47.000000', 'temperatura', 723.0000, 'ºC'),
	(111195, 111, '2015-03-15 00:10:48.000000', 'temperatura', 359.0000, 'ºC'),
	(111196, 111, '2015-03-15 00:10:49.000000', 'temperatura', 824.0000, 'ºC'),
	(111197, 111, '2015-03-15 00:10:50.000000', 'temperatura', 646.0000, 'ºC'),
	(111198, 111, '2015-03-15 00:10:51.000000', 'temperatura', 759.0000, 'ºC'),
	(111199, 111, '2015-03-15 00:10:52.000000', 'temperatura', 656.0000, 'ºC'),
	(111200, 111, '2015-03-15 00:10:53.000000', 'temperatura', 1006.0000, 'ºC'),
	(111201, 111, '2015-03-15 00:10:54.000000', 'temperatura', 659.0000, 'ºC'),
	(111202, 111, '2015-03-15 00:10:55.000000', 'temperatura', 279.0000, 'ºC'),
	(111203, 111, '2015-03-15 00:10:56.000000', 'temperatura', 617.0000, 'ºC'),
	(111204, 111, '2015-03-15 00:10:57.000000', 'temperatura', 1050.0000, 'ºC'),
	(111205, 111, '2015-03-15 00:10:58.000000', 'temperatura', 998.0000, 'ºC'),
	(111206, 111, '2015-03-15 00:10:59.000000', 'temperatura', 640.0000, 'ºC'),
	(111207, 111, '2015-03-15 00:11:00.000000', 'temperatura', 207.0000, 'ºC'),
	(111208, 111, '2015-03-15 00:11:01.000000', 'temperatura', 315.0000, 'ºC'),
	(111209, 111, '2015-03-15 00:11:02.000000', 'temperatura', 953.0000, 'ºC'),
	(111210, 111, '2015-03-15 00:11:03.000000', 'temperatura', 223.0000, 'ºC'),
	(111211, 111, '2015-03-15 00:11:04.000000', 'temperatura', 658.0000, 'ºC'),
	(111212, 111, '2015-03-15 00:11:05.000000', 'temperatura', 219.0000, 'ºC'),
	(111213, 111, '2015-03-15 00:11:06.000000', 'temperatura', 321.0000, 'ºC'),
	(111214, 111, '2015-03-15 00:11:07.000000', 'temperatura', 950.0000, 'ºC'),
	(111215, 111, '2015-03-15 00:11:08.000000', 'temperatura', 189.0000, 'ºC'),
	(111216, 111, '2015-03-15 00:11:09.000000', 'temperatura', 493.0000, 'ºC'),
	(111217, 111, '2015-03-15 00:11:10.000000', 'temperatura', 699.0000, 'ºC'),
	(111218, 111, '2015-03-15 00:11:11.000000', 'temperatura', 816.0000, 'ºC'),
	(111219, 111, '2015-03-15 00:11:12.000000', 'temperatura', 783.0000, 'ºC'),
	(111220, 111, '2015-03-15 00:11:13.000000', 'temperatura', 269.0000, 'ºC'),
	(111221, 111, '2015-03-15 00:11:14.000000', 'temperatura', 195.0000, 'ºC'),
	(111222, 111, '2015-03-15 00:11:15.000000', 'temperatura', 171.0000, 'ºC'),
	(111223, 111, '2015-03-15 00:11:16.000000', 'temperatura', 268.0000, 'ºC'),
	(111224, 111, '2015-03-15 00:11:17.000000', 'temperatura', 828.0000, 'ºC'),
	(111225, 111, '2015-03-15 00:11:18.000000', 'temperatura', 936.0000, 'ºC'),
	(111226, 111, '2015-03-15 00:11:19.000000', 'temperatura', 997.0000, 'ºC'),
	(111227, 111, '2015-03-15 00:11:20.000000', 'temperatura', 978.0000, 'ºC'),
	(111228, 111, '2015-03-15 00:11:21.000000', 'temperatura', 699.0000, 'ºC'),
	(111229, 111, '2015-03-15 00:11:22.000000', 'temperatura', 562.0000, 'ºC'),
	(111230, 111, '2015-03-15 00:11:23.000000', 'temperatura', 713.0000, 'ºC'),
	(111231, 111, '2015-03-15 00:11:24.000000', 'temperatura', 679.0000, 'ºC'),
	(111232, 111, '2015-03-15 00:11:25.000000', 'temperatura', 56.0000, 'ºC'),
	(111233, 111, '2015-03-15 00:11:26.000000', 'temperatura', 643.0000, 'ºC'),
	(111234, 111, '2015-03-15 00:11:27.000000', 'temperatura', 649.0000, 'ºC'),
	(111235, 111, '2015-03-15 00:11:28.000000', 'temperatura', 117.0000, 'ºC'),
	(111236, 111, '2015-03-15 00:11:29.000000', 'temperatura', 1039.0000, 'ºC'),
	(111237, 111, '2015-03-15 00:11:30.000000', 'temperatura', 44.0000, 'ºC'),
	(111238, 111, '2015-03-15 00:11:31.000000', 'temperatura', 702.0000, 'ºC'),
	(111239, 111, '2015-03-15 00:11:32.000000', 'temperatura', 980.0000, 'ºC'),
	(111240, 111, '2015-03-15 00:11:33.000000', 'temperatura', 394.0000, 'ºC'),
	(111241, 111, '2015-03-15 00:11:34.000000', 'temperatura', 231.0000, 'ºC'),
	(111242, 111, '2015-03-15 00:11:35.000000', 'temperatura', 1173.0000, 'ºC'),
	(111243, 111, '2015-03-15 00:11:36.000000', 'temperatura', 371.0000, 'ºC'),
	(111244, 111, '2015-03-15 00:11:37.000000', 'temperatura', 739.0000, 'ºC'),
	(111245, 111, '2015-03-15 00:11:38.000000', 'temperatura', 181.0000, 'ºC'),
	(111246, 111, '2015-03-15 00:11:39.000000', 'temperatura', 1089.0000, 'ºC'),
	(111247, 111, '2015-03-15 00:11:40.000000', 'temperatura', 101.0000, 'ºC'),
	(111248, 111, '2015-03-15 00:11:41.000000', 'temperatura', 841.0000, 'ºC'),
	(111249, 111, '2015-03-15 00:11:42.000000', 'temperatura', 302.0000, 'ºC'),
	(111250, 111, '2015-03-15 00:11:43.000000', 'temperatura', 187.0000, 'ºC'),
	(111251, 111, '2015-03-15 00:11:44.000000', 'temperatura', 29.0000, 'ºC'),
	(111252, 111, '2015-03-15 00:11:45.000000', 'temperatura', 784.0000, 'ºC'),
	(111253, 111, '2015-03-15 00:11:46.000000', 'temperatura', 234.0000, 'ºC'),
	(111254, 111, '2015-03-15 00:11:47.000000', 'temperatura', 17.0000, 'ºC'),
	(111255, 111, '2015-03-15 00:11:48.000000', 'temperatura', 587.0000, 'ºC'),
	(111256, 111, '2015-03-15 00:11:49.000000', 'temperatura', 481.0000, 'ºC'),
	(111257, 111, '2015-03-15 00:11:50.000000', 'temperatura', 644.0000, 'ºC'),
	(111258, 111, '2015-03-15 00:11:51.000000', 'temperatura', 581.0000, 'ºC'),
	(111259, 111, '2015-03-15 00:11:52.000000', 'temperatura', 970.0000, 'ºC'),
	(111260, 111, '2015-03-15 00:11:53.000000', 'temperatura', 711.0000, 'ºC'),
	(111261, 111, '2015-03-15 00:11:54.000000', 'temperatura', 643.0000, 'ºC'),
	(111262, 111, '2015-03-15 00:11:55.000000', 'temperatura', 1083.0000, 'ºC'),
	(111263, 111, '2015-03-15 00:11:56.000000', 'temperatura', 1085.0000, 'ºC'),
	(111264, 111, '2015-03-15 00:11:57.000000', 'temperatura', 977.0000, 'ºC'),
	(111265, 111, '2015-03-15 00:11:58.000000', 'temperatura', 431.0000, 'ºC'),
	(111266, 111, '2015-03-15 00:11:59.000000', 'temperatura', 423.0000, 'ºC'),
	(111267, 111, '2015-03-15 00:12:00.000000', 'temperatura', 823.0000, 'ºC'),
	(111268, 111, '2015-03-15 00:12:01.000000', 'temperatura', 445.0000, 'ºC'),
	(111269, 111, '2015-03-15 00:12:02.000000', 'temperatura', 958.0000, 'ºC'),
	(111270, 111, '2015-03-15 00:12:03.000000', 'temperatura', 1056.0000, 'ºC'),
	(111271, 111, '2015-03-15 00:12:04.000000', 'temperatura', 7.0000, 'ºC'),
	(111272, 111, '2015-03-15 00:12:05.000000', 'temperatura', 465.0000, 'ºC'),
	(111273, 111, '2015-03-15 00:12:06.000000', 'temperatura', 1108.0000, 'ºC'),
	(111274, 111, '2015-03-15 00:12:07.000000', 'temperatura', 543.0000, 'ºC'),
	(111275, 111, '2015-03-15 00:12:08.000000', 'temperatura', 591.0000, 'ºC'),
	(111276, 111, '2015-03-15 00:12:09.000000', 'temperatura', 128.0000, 'ºC'),
	(111277, 111, '2015-03-15 00:12:10.000000', 'temperatura', 65.0000, 'ºC'),
	(111278, 111, '2015-03-15 00:12:11.000000', 'temperatura', 1144.0000, 'ºC'),
	(111279, 111, '2015-03-15 00:12:12.000000', 'temperatura', 724.0000, 'ºC'),
	(111280, 111, '2015-03-15 00:12:13.000000', 'temperatura', 191.0000, 'ºC'),
	(111281, 111, '2015-03-15 00:12:14.000000', 'temperatura', 1182.0000, 'ºC'),
	(111282, 111, '2015-03-15 00:12:15.000000', 'temperatura', 539.0000, 'ºC'),
	(111283, 111, '2015-03-15 00:12:16.000000', 'temperatura', 347.0000, 'ºC'),
	(111284, 111, '2015-03-15 00:12:17.000000', 'temperatura', 120.0000, 'ºC'),
	(111285, 111, '2015-03-15 00:12:18.000000', 'temperatura', 760.0000, 'ºC'),
	(111286, 111, '2015-03-15 00:12:19.000000', 'temperatura', 1040.0000, 'ºC'),
	(111287, 111, '2015-03-15 00:12:20.000000', 'temperatura', 518.0000, 'ºC'),
	(111288, 111, '2015-03-15 00:12:21.000000', 'temperatura', 674.0000, 'ºC'),
	(111289, 111, '2015-03-15 00:12:22.000000', 'temperatura', 615.0000, 'ºC'),
	(111290, 111, '2015-03-15 00:12:23.000000', 'temperatura', 1052.0000, 'ºC'),
	(111291, 111, '2015-03-15 00:12:24.000000', 'temperatura', 1016.0000, 'ºC'),
	(111292, 111, '2015-03-15 00:12:25.000000', 'temperatura', 724.0000, 'ºC'),
	(111293, 111, '2015-03-15 00:12:26.000000', 'temperatura', 574.0000, 'ºC'),
	(111294, 111, '2015-03-15 00:12:27.000000', 'temperatura', 697.0000, 'ºC'),
	(111295, 111, '2015-03-15 00:12:28.000000', 'temperatura', 565.0000, 'ºC'),
	(111296, 111, '2015-03-15 00:12:29.000000', 'temperatura', 735.0000, 'ºC'),
	(111297, 111, '2015-03-15 00:12:30.000000', 'temperatura', 780.0000, 'ºC'),
	(111298, 111, '2015-03-15 00:12:31.000000', 'temperatura', 497.0000, 'ºC'),
	(111299, 111, '2015-03-15 00:12:32.000000', 'temperatura', 144.0000, 'ºC'),
	(111300, 111, '2015-03-15 00:12:33.000000', 'temperatura', 429.0000, 'ºC'),
	(111301, 111, '2015-03-15 00:12:34.000000', 'temperatura', 515.0000, 'ºC'),
	(111302, 111, '2015-03-15 00:12:35.000000', 'temperatura', 87.0000, 'ºC'),
	(111303, 111, '2015-03-15 00:12:36.000000', 'temperatura', 90.0000, 'ºC'),
	(111304, 111, '2015-03-15 00:12:37.000000', 'temperatura', 189.0000, 'ºC'),
	(111305, 111, '2015-03-15 00:12:38.000000', 'temperatura', 677.0000, 'ºC'),
	(111306, 111, '2015-03-15 00:12:39.000000', 'temperatura', 419.0000, 'ºC'),
	(111307, 111, '2015-03-15 00:12:40.000000', 'temperatura', 63.0000, 'ºC'),
	(111308, 111, '2015-03-15 00:12:41.000000', 'temperatura', 258.0000, 'ºC'),
	(111309, 111, '2015-03-15 00:12:42.000000', 'temperatura', 1100.0000, 'ºC'),
	(111310, 111, '2015-03-15 00:12:43.000000', 'temperatura', 1129.0000, 'ºC'),
	(111311, 111, '2015-03-15 00:12:44.000000', 'temperatura', 1145.0000, 'ºC'),
	(111312, 111, '2015-03-15 00:12:45.000000', 'temperatura', 1140.0000, 'ºC'),
	(111313, 111, '2015-03-15 00:12:46.000000', 'temperatura', 1063.0000, 'ºC'),
	(111314, 111, '2015-03-15 00:12:47.000000', 'temperatura', 697.0000, 'ºC'),
	(111315, 111, '2015-03-15 00:12:48.000000', 'temperatura', 295.0000, 'ºC'),
	(111316, 111, '2015-03-15 00:12:49.000000', 'temperatura', 584.0000, 'ºC'),
	(111317, 111, '2015-03-15 00:12:50.000000', 'temperatura', 835.0000, 'ºC'),
	(111318, 111, '2015-03-15 00:12:51.000000', 'temperatura', 24.0000, 'ºC'),
	(111319, 111, '2015-03-15 00:12:52.000000', 'temperatura', 16.0000, 'ºC'),
	(111320, 111, '2015-03-15 00:12:53.000000', 'temperatura', 8.0000, 'ºC'),
	(111321, 111, '2015-03-15 00:12:54.000000', 'temperatura', 1192.0000, 'ºC'),
	(111322, 111, '2015-03-15 00:12:55.000000', 'temperatura', 1137.0000, 'ºC'),
	(111323, 111, '2015-03-15 00:12:56.000000', 'temperatura', 910.0000, 'ºC'),
	(111324, 111, '2015-03-15 00:12:57.000000', 'temperatura', 1140.0000, 'ºC'),
	(111325, 111, '2015-03-15 00:12:58.000000', 'temperatura', 570.0000, 'ºC'),
	(111326, 111, '2015-03-15 00:12:59.000000', 'temperatura', 629.0000, 'ºC'),
	(111327, 111, '2015-03-15 00:13:00.000000', 'temperatura', 238.0000, 'ºC'),
	(111328, 111, '2015-03-15 00:13:01.000000', 'temperatura', 502.0000, 'ºC'),
	(111329, 111, '2015-03-15 00:13:02.000000', 'temperatura', 598.0000, 'ºC'),
	(111330, 111, '2015-03-15 00:13:03.000000', 'temperatura', 282.0000, 'ºC'),
	(111331, 111, '2015-03-15 00:13:04.000000', 'temperatura', 818.0000, 'ºC'),
	(111332, 111, '2015-03-15 00:13:05.000000', 'temperatura', 845.0000, 'ºC'),
	(111333, 111, '2015-03-15 00:13:06.000000', 'temperatura', 571.0000, 'ºC'),
	(111334, 111, '2015-03-15 00:13:07.000000', 'temperatura', 323.0000, 'ºC'),
	(111335, 111, '2015-03-15 00:13:08.000000', 'temperatura', 1099.0000, 'ºC'),
	(111336, 111, '2015-03-15 00:13:09.000000', 'temperatura', 927.0000, 'ºC'),
	(111337, 111, '2015-03-15 00:13:10.000000', 'temperatura', 139.0000, 'ºC'),
	(111338, 111, '2015-03-15 00:13:11.000000', 'temperatura', 315.0000, 'ºC'),
	(111339, 111, '2015-03-15 00:13:12.000000', 'temperatura', 1157.0000, 'ºC'),
	(111340, 111, '2015-03-15 00:13:13.000000', 'temperatura', 41.0000, 'ºC'),
	(111341, 111, '2015-03-15 00:13:14.000000', 'temperatura', 334.0000, 'ºC'),
	(111342, 111, '2015-03-15 00:13:15.000000', 'temperatura', 347.0000, 'ºC'),
	(111343, 111, '2015-03-15 00:13:16.000000', 'temperatura', 736.0000, 'ºC'),
	(111344, 111, '2015-03-15 00:13:17.000000', 'temperatura', 239.0000, 'ºC'),
	(111345, 111, '2015-03-15 00:13:18.000000', 'temperatura', 185.0000, 'ºC'),
	(111346, 111, '2015-03-15 00:13:19.000000', 'temperatura', 211.0000, 'ºC'),
	(111347, 111, '2015-03-15 00:13:20.000000', 'temperatura', 500.0000, 'ºC'),
	(111348, 111, '2015-03-15 00:13:21.000000', 'temperatura', 669.0000, 'ºC'),
	(111349, 111, '2015-03-15 00:13:22.000000', 'temperatura', 642.0000, 'ºC'),
	(111350, 111, '2015-03-15 00:13:23.000000', 'temperatura', 7.0000, 'ºC'),
	(111351, 111, '2015-03-15 00:13:24.000000', 'temperatura', 507.0000, 'ºC'),
	(111352, 111, '2015-03-15 00:13:25.000000', 'temperatura', 116.0000, 'ºC'),
	(111353, 111, '2015-03-15 00:13:26.000000', 'temperatura', 259.0000, 'ºC'),
	(111354, 111, '2015-03-15 00:13:27.000000', 'temperatura', 949.0000, 'ºC'),
	(111355, 111, '2015-03-15 00:13:28.000000', 'temperatura', 365.0000, 'ºC'),
	(111356, 111, '2015-03-15 00:13:29.000000', 'temperatura', 182.0000, 'ºC'),
	(111357, 111, '2015-03-15 00:13:30.000000', 'temperatura', 1013.0000, 'ºC'),
	(111358, 111, '2015-03-15 00:13:31.000000', 'temperatura', 920.0000, 'ºC'),
	(111359, 111, '2015-03-15 00:13:32.000000', 'temperatura', 363.0000, 'ºC'),
	(111360, 111, '2015-03-15 00:13:33.000000', 'temperatura', 255.0000, 'ºC'),
	(111361, 111, '2015-03-15 00:13:34.000000', 'temperatura', 184.0000, 'ºC'),
	(111362, 111, '2015-03-15 00:13:35.000000', 'temperatura', 159.0000, 'ºC'),
	(111363, 111, '2015-03-15 00:13:36.000000', 'temperatura', 242.0000, 'ºC'),
	(111364, 111, '2015-03-15 00:13:37.000000', 'temperatura', 733.0000, 'ºC'),
	(111365, 111, '2015-03-15 00:13:38.000000', 'temperatura', 539.0000, 'ºC'),
	(111366, 111, '2015-03-15 00:13:39.000000', 'temperatura', 497.0000, 'ºC'),
	(111367, 111, '2015-03-15 00:13:40.000000', 'temperatura', 870.0000, 'ºC'),
	(111368, 111, '2015-03-15 00:13:41.000000', 'temperatura', 460.0000, 'ºC'),
	(111369, 111, '2015-03-15 00:13:42.000000', 'temperatura', 889.0000, 'ºC'),
	(111370, 111, '2015-03-15 00:13:43.000000', 'temperatura', 665.0000, 'ºC'),
	(111371, 111, '2015-03-15 00:13:44.000000', 'temperatura', 657.0000, 'ºC'),
	(111372, 111, '2015-03-15 00:13:45.000000', 'temperatura', 92.0000, 'ºC'),
	(111373, 111, '2015-03-15 00:13:46.000000', 'temperatura', 889.0000, 'ºC'),
	(111374, 111, '2015-03-15 00:13:47.000000', 'temperatura', 568.0000, 'ºC'),
	(111375, 111, '2015-03-15 00:13:48.000000', 'temperatura', 174.0000, 'ºC'),
	(111376, 111, '2015-03-15 00:13:49.000000', 'temperatura', 368.0000, 'ºC'),
	(111377, 111, '2015-03-15 00:13:50.000000', 'temperatura', 119.0000, 'ºC'),
	(111378, 111, '2015-03-15 00:13:51.000000', 'temperatura', 693.0000, 'ºC'),
	(111379, 111, '2015-03-15 00:13:52.000000', 'temperatura', 706.0000, 'ºC'),
	(111380, 111, '2015-03-15 00:13:53.000000', 'temperatura', 253.0000, 'ºC'),
	(111381, 111, '2015-03-15 00:13:54.000000', 'temperatura', 346.0000, 'ºC'),
	(111382, 111, '2015-03-15 00:13:55.000000', 'temperatura', 972.0000, 'ºC'),
	(111383, 111, '2015-03-15 00:13:56.000000', 'temperatura', 222.0000, 'ºC'),
	(111384, 111, '2015-03-15 00:13:57.000000', 'temperatura', 594.0000, 'ºC'),
	(111385, 111, '2015-03-15 00:13:58.000000', 'temperatura', 1106.0000, 'ºC'),
	(111386, 111, '2015-03-15 00:13:59.000000', 'temperatura', 150.0000, 'ºC'),
	(111387, 111, '2015-03-15 00:14:00.000000', 'temperatura', 1030.0000, 'ºC'),
	(111388, 111, '2015-03-15 00:14:01.000000', 'temperatura', 1101.0000, 'ºC'),
	(111389, 111, '2015-03-15 00:14:02.000000', 'temperatura', 15.0000, 'ºC'),
	(111390, 111, '2015-03-15 00:14:03.000000', 'temperatura', 375.0000, 'ºC'),
	(111391, 111, '2015-03-15 00:14:04.000000', 'temperatura', 628.0000, 'ºC'),
	(111392, 111, '2015-03-15 00:14:05.000000', 'temperatura', 816.0000, 'ºC'),
	(111393, 111, '2015-03-15 00:14:06.000000', 'temperatura', 995.0000, 'ºC'),
	(111394, 111, '2015-03-15 00:14:07.000000', 'temperatura', 128.0000, 'ºC'),
	(111395, 111, '2015-03-15 00:14:08.000000', 'temperatura', 54.0000, 'ºC'),
	(111396, 111, '2015-03-15 00:14:09.000000', 'temperatura', 1088.0000, 'ºC'),
	(111397, 111, '2015-03-15 00:14:10.000000', 'temperatura', 480.0000, 'ºC'),
	(111398, 111, '2015-03-15 00:14:11.000000', 'temperatura', 336.0000, 'ºC'),
	(111399, 111, '2015-03-15 00:14:12.000000', 'temperatura', 241.0000, 'ºC'),
	(111400, 111, '2015-03-15 00:14:13.000000', 'temperatura', 198.0000, 'ºC'),
	(111401, 111, '2015-03-15 00:14:14.000000', 'temperatura', 266.0000, 'ºC'),
	(111402, 111, '2015-03-15 00:14:15.000000', 'temperatura', 738.0000, 'ºC'),
	(111403, 111, '2015-03-15 00:14:16.000000', 'temperatura', 493.0000, 'ºC'),
	(111404, 111, '2015-03-15 00:14:17.000000', 'temperatura', 249.0000, 'ºC'),
	(111405, 111, '2015-03-15 00:14:18.000000', 'temperatura', 966.0000, 'ºC'),
	(111406, 111, '2015-03-15 00:14:19.000000', 'temperatura', 484.0000, 'ºC'),
	(111407, 111, '2015-03-15 00:14:20.000000', 'temperatura', 722.0000, 'ºC'),
	(111408, 111, '2015-03-15 00:14:21.000000', 'temperatura', 961.0000, 'ºC'),
	(111409, 111, '2015-03-15 00:14:22.000000', 'temperatura', 237.0000, 'ºC'),
	(111410, 111, '2015-03-15 00:14:23.000000', 'temperatura', 703.0000, 'ºC'),
	(111411, 111, '2015-03-15 00:14:24.000000', 'temperatura', 406.0000, 'ºC'),
	(111412, 111, '2015-03-15 00:14:25.000000', 'temperatura', 1119.0000, 'ºC'),
	(111413, 111, '2015-03-15 00:14:26.000000', 'temperatura', 778.0000, 'ºC'),
	(111414, 111, '2015-03-15 00:14:27.000000', 'temperatura', 535.0000, 'ºC'),
	(111415, 111, '2015-03-15 00:14:28.000000', 'temperatura', 339.0000, 'ºC'),
	(111416, 111, '2015-03-15 00:14:29.000000', 'temperatura', 93.0000, 'ºC'),
	(111417, 111, '2015-03-15 00:14:30.000000', 'temperatura', 647.0000, 'ºC'),
	(111418, 111, '2015-03-15 00:14:31.000000', 'temperatura', 559.0000, 'ºC'),
	(111419, 111, '2015-03-15 00:14:32.000000', 'temperatura', 853.0000, 'ºC'),
	(111420, 111, '2015-03-15 00:14:33.000000', 'temperatura', 189.0000, 'ºC'),
	(111421, 111, '2015-03-15 00:14:34.000000', 'temperatura', 787.0000, 'ºC'),
	(111422, 111, '2015-03-15 00:14:35.000000', 'temperatura', 969.0000, 'ºC'),
	(111423, 111, '2015-03-15 00:14:36.000000', 'temperatura', 82.0000, 'ºC'),
	(111424, 111, '2015-03-15 00:14:37.000000', 'temperatura', 1105.0000, 'ºC'),
	(111425, 111, '2015-03-15 00:14:38.000000', 'temperatura', 479.0000, 'ºC'),
	(111426, 111, '2015-03-15 00:14:39.000000', 'temperatura', 279.0000, 'ºC'),
	(111427, 111, '2015-03-15 00:14:40.000000', 'temperatura', 1161.0000, 'ºC'),
	(111428, 111, '2015-03-15 00:14:41.000000', 'temperatura', 169.0000, 'ºC'),
	(111429, 111, '2015-03-15 00:14:42.000000', 'temperatura', 961.0000, 'ºC'),
	(111430, 111, '2015-03-15 00:14:43.000000', 'temperatura', 699.0000, 'ºC'),
	(111431, 111, '2015-03-15 00:14:44.000000', 'temperatura', 611.0000, 'ºC'),
	(111432, 111, '2015-03-15 00:14:45.000000', 'temperatura', 958.0000, 'ºC'),
	(111433, 111, '2015-03-15 00:14:46.000000', 'temperatura', 557.0000, 'ºC'),
	(111434, 111, '2015-03-15 00:14:47.000000', 'temperatura', 1114.0000, 'ºC'),
	(111435, 111, '2015-03-15 00:14:48.000000', 'temperatura', 298.0000, 'ºC'),
	(111436, 111, '2015-03-15 00:14:49.000000', 'temperatura', 547.0000, 'ºC'),
	(111437, 111, '2015-03-15 00:14:50.000000', 'temperatura', 643.0000, 'ºC'),
	(111438, 111, '2015-03-15 00:14:51.000000', 'temperatura', 376.0000, 'ºC'),
	(111439, 111, '2015-03-15 00:14:52.000000', 'temperatura', 1151.0000, 'ºC'),
	(111440, 111, '2015-03-15 00:14:53.000000', 'temperatura', 1029.0000, 'ºC'),
	(111441, 111, '2015-03-15 00:14:54.000000', 'temperatura', 490.0000, 'ºC'),
	(111442, 111, '2015-03-15 00:14:55.000000', 'temperatura', 564.0000, 'ºC'),
	(111443, 111, '2015-03-15 00:14:56.000000', 'temperatura', 150.0000, 'ºC'),
	(111444, 111, '2015-03-15 00:14:57.000000', 'temperatura', 260.0000, 'ºC'),
	(111445, 111, '2015-03-15 00:14:58.000000', 'temperatura', 849.0000, 'ºC'),
	(111446, 111, '2015-03-15 00:14:59.000000', 'temperatura', 1065.0000, 'ºC'),
	(111447, 111, '2015-03-15 00:15:00.000000', 'temperatura', 380.0000, 'ºC'),
	(111448, 111, '2015-03-15 00:15:01.000000', 'temperatura', 1107.0000, 'ºC'),
	(111449, 111, '2015-03-15 00:15:02.000000', 'temperatura', 794.0000, 'ºC'),
	(111450, 111, '2015-03-15 00:15:03.000000', 'temperatura', 650.0000, 'ºC'),
	(111451, 111, '2015-03-15 00:15:04.000000', 'temperatura', 870.0000, 'ºC'),
	(111452, 111, '2015-03-15 00:15:05.000000', 'temperatura', 0.0000, 'ºC'),
	(111453, 111, '2015-03-15 00:15:06.000000', 'temperatura', 990.0000, 'ºC'),
	(111454, 111, '2015-03-15 00:15:07.000000', 'temperatura', 150.0000, 'ºC'),
	(111455, 111, '2015-03-15 00:15:08.000000', 'temperatura', 181.0000, 'ºC'),
	(111456, 111, '2015-03-15 00:15:09.000000', 'temperatura', 456.0000, 'ºC'),
	(111457, 111, '2015-03-15 00:15:10.000000', 'temperatura', 539.0000, 'ºC'),
	(111458, 111, '2015-03-15 00:15:11.000000', 'temperatura', 126.0000, 'ºC'),
	(111459, 111, '2015-03-15 00:15:12.000000', 'temperatura', 216.0000, 'ºC'),
	(111460, 111, '2015-03-15 00:15:13.000000', 'temperatura', 699.0000, 'ºC'),
	(111461, 111, '2015-03-15 00:15:14.000000', 'temperatura', 448.0000, 'ºC'),
	(111462, 111, '2015-03-15 00:15:15.000000', 'temperatura', 145.0000, 'ºC'),
	(111463, 111, '2015-03-15 00:15:16.000000', 'temperatura', 580.0000, 'ºC'),
	(111464, 111, '2015-03-15 00:15:17.000000', 'temperatura', 68.0000, 'ºC'),
	(111465, 111, '2015-03-15 00:15:18.000000', 'temperatura', 999.0000, 'ºC'),
	(111466, 111, '2015-03-15 00:15:19.000000', 'temperatura', 1192.0000, 'ºC'),
	(111467, 111, '2015-03-15 00:15:20.000000', 'temperatura', 562.0000, 'ºC'),
	(111468, 111, '2015-03-15 00:15:21.000000', 'temperatura', 435.0000, 'ºC'),
	(111469, 111, '2015-03-15 00:15:22.000000', 'temperatura', 488.0000, 'ºC'),
	(111470, 111, '2015-03-15 00:15:23.000000', 'temperatura', 1139.0000, 'ºC'),
	(111471, 111, '2015-03-15 00:15:24.000000', 'temperatura', 628.0000, 'ºC'),
	(111472, 111, '2015-03-15 00:15:25.000000', 'temperatura', 927.0000, 'ºC'),
	(111473, 111, '2015-03-15 00:15:26.000000', 'temperatura', 350.0000, 'ºC'),
	(111474, 111, '2015-03-15 00:15:27.000000', 'temperatura', 168.0000, 'ºC'),
	(111475, 111, '2015-03-15 00:15:28.000000', 'temperatura', 993.0000, 'ºC'),
	(111476, 111, '2015-03-15 00:15:29.000000', 'temperatura', 861.0000, 'ºC'),
	(111477, 111, '2015-03-15 00:15:30.000000', 'temperatura', 126.0000, 'ºC'),
	(111478, 111, '2015-03-15 00:15:31.000000', 'temperatura', 448.0000, 'ºC'),
	(111479, 111, '2015-03-15 00:15:32.000000', 'temperatura', 663.0000, 'ºC'),
	(111480, 111, '2015-03-15 00:15:33.000000', 'temperatura', 772.0000, 'ºC'),
	(111481, 111, '2015-03-15 00:15:34.000000', 'temperatura', 669.0000, 'ºC'),
	(111482, 111, '2015-03-15 00:15:35.000000', 'temperatura', 1031.0000, 'ºC'),
	(111483, 111, '2015-03-15 00:15:36.000000', 'temperatura', 748.0000, 'ºC'),
	(111484, 111, '2015-03-15 00:15:37.000000', 'temperatura', 649.0000, 'ºC'),
	(111485, 111, '2015-03-15 00:15:38.000000', 'temperatura', 999.0000, 'ºC'),
	(111486, 111, '2015-03-15 00:15:39.000000', 'temperatura', 651.0000, 'ºC'),
	(111487, 111, '2015-03-15 00:15:40.000000', 'temperatura', 256.0000, 'ºC'),
	(111488, 111, '2015-03-15 00:15:41.000000', 'temperatura', 528.0000, 'ºC'),
	(111489, 111, '2015-03-15 00:15:42.000000', 'temperatura', 675.0000, 'ºC'),
	(111490, 111, '2015-03-15 00:15:43.000000', 'temperatura', 588.0000, 'ºC'),
	(111491, 111, '2015-03-15 00:15:44.000000', 'temperatura', 918.0000, 'ºC'),
	(111492, 111, '2015-03-15 00:15:45.000000', 'temperatura', 425.0000, 'ºC'),
	(111493, 111, '2015-03-15 00:15:46.000000', 'temperatura', 571.0000, 'ºC'),
	(111494, 111, '2015-03-15 00:15:47.000000', 'temperatura', 380.0000, 'ºC'),
	(111495, 111, '2015-03-15 00:15:48.000000', 'temperatura', 188.0000, 'ºC'),
	(111496, 111, '2015-03-15 00:15:49.000000', 'temperatura', 1002.0000, 'ºC'),
	(111497, 111, '2015-03-15 00:15:50.000000', 'temperatura', 844.0000, 'ºC'),
	(111498, 111, '2015-03-15 00:15:51.000000', 'temperatura', 14.0000, 'ºC'),
	(111499, 111, '2015-03-15 00:15:52.000000', 'temperatura', 1140.0000, 'ºC'),
	(111500, 111, '2015-03-15 00:15:53.000000', 'temperatura', 857.0000, 'ºC'),
	(111501, 111, '2015-03-15 00:15:54.000000', 'temperatura', 868.0000, 'ºC'),
	(111502, 111, '2015-03-15 00:15:55.000000', 'temperatura', 569.0000, 'ºC'),
	(111503, 111, '2015-03-15 00:15:56.000000', 'temperatura', 242.0000, 'ºC'),
	(111504, 111, '2015-03-15 00:15:57.000000', 'temperatura', 702.0000, 'ºC'),
	(111505, 111, '2015-03-15 00:15:58.000000', 'temperatura', 384.0000, 'ºC'),
	(111506, 111, '2015-03-15 00:15:59.000000', 'temperatura', 1016.0000, 'ºC'),
	(111507, 111, '2015-03-15 00:16:00.000000', 'temperatura', 327.0000, 'ºC'),
	(111508, 111, '2015-03-15 00:16:01.000000', 'temperatura', 987.0000, 'ºC'),
	(111509, 111, '2015-03-15 00:16:02.000000', 'temperatura', 354.0000, 'ºC'),
	(111510, 111, '2015-03-15 00:16:03.000000', 'temperatura', 12.0000, 'ºC'),
	(111511, 111, '2015-03-15 00:16:04.000000', 'temperatura', 198.0000, 'ºC'),
	(111512, 111, '2015-03-15 00:16:05.000000', 'temperatura', 952.0000, 'ºC'),
	(111513, 111, '2015-03-15 00:16:06.000000', 'temperatura', 569.0000, 'ºC'),
	(111514, 111, '2015-03-15 00:16:07.000000', 'temperatura', 1190.0000, 'ºC'),
	(111515, 111, '2015-03-15 00:16:08.000000', 'temperatura', 644.0000, 'ºC'),
	(111516, 111, '2015-03-15 00:16:09.000000', 'temperatura', 847.0000, 'ºC'),
	(111517, 111, '2015-03-15 00:16:10.000000', 'temperatura', 1107.0000, 'ºC'),
	(111518, 111, '2015-03-15 00:16:11.000000', 'temperatura', 594.0000, 'ºC'),
	(111519, 111, '2015-03-15 00:16:12.000000', 'temperatura', 849.0000, 'ºC'),
	(111520, 111, '2015-03-15 00:16:13.000000', 'temperatura', 62.0000, 'ºC'),
	(111521, 111, '2015-03-15 00:16:14.000000', 'temperatura', 165.0000, 'ºC'),
	(111522, 111, '2015-03-15 00:16:15.000000', 'temperatura', 637.0000, 'ºC'),
	(111523, 111, '2015-03-15 00:16:16.000000', 'temperatura', 293.0000, 'ºC'),
	(111524, 111, '2015-03-15 00:16:17.000000', 'temperatura', 752.0000, 'ºC'),
	(111525, 111, '2015-03-15 00:16:18.000000', 'temperatura', 484.0000, 'ºC'),
	(111526, 111, '2015-03-15 00:16:19.000000', 'temperatura', 162.0000, 'ºC'),
	(111527, 111, '2015-03-15 00:16:20.000000', 'temperatura', 559.0000, 'ºC'),
	(111528, 111, '2015-03-15 00:16:21.000000', 'temperatura', 1112.0000, 'ºC'),
	(111529, 111, '2015-03-15 00:16:22.000000', 'temperatura', 282.0000, 'ºC'),
	(111530, 111, '2015-03-15 00:16:23.000000', 'temperatura', 476.0000, 'ºC'),
	(111531, 111, '2015-03-15 00:16:24.000000', 'temperatura', 333.0000, 'ºC'),
	(111532, 111, '2015-03-15 00:16:25.000000', 'temperatura', 238.0000, 'ºC'),
	(111533, 111, '2015-03-15 00:16:26.000000', 'temperatura', 193.0000, 'ºC'),
	(111534, 111, '2015-03-15 00:16:27.000000', 'temperatura', 251.0000, 'ºC'),
	(111535, 111, '2015-03-15 00:16:28.000000', 'temperatura', 677.0000, 'ºC'),
	(111536, 111, '2015-03-15 00:16:29.000000', 'temperatura', 233.0000, 'ºC'),
	(111537, 111, '2015-03-15 00:16:30.000000', 'temperatura', 335.0000, 'ºC'),
	(111538, 111, '2015-03-15 00:16:31.000000', 'temperatura', 975.0000, 'ºC'),
	(111539, 111, '2015-03-15 00:16:32.000000', 'temperatura', 272.0000, 'ºC'),
	(111540, 111, '2015-03-15 00:16:33.000000', 'temperatura', 836.0000, 'ºC'),
	(111541, 111, '2015-03-15 00:16:34.000000', 'temperatura', 966.0000, 'ºC'),
	(111542, 111, '2015-03-15 00:16:35.000000', 'temperatura', 1119.0000, 'ºC'),
	(111543, 111, '2015-03-15 00:16:36.000000', 'temperatura', 299.0000, 'ºC'),
	(111544, 111, '2015-03-15 00:16:37.000000', 'temperatura', 536.0000, 'ºC'),
	(111545, 111, '2015-03-15 00:16:38.000000', 'temperatura', 587.0000, 'ºC'),
	(111546, 111, '2015-03-15 00:16:39.000000', 'temperatura', 125.0000, 'ºC'),
	(111547, 111, '2015-03-15 00:16:40.000000', 'temperatura', 66.0000, 'ºC'),
	(111548, 111, '2015-03-15 00:16:41.000000', 'temperatura', 1154.0000, 'ºC'),
	(111549, 111, '2015-03-15 00:16:42.000000', 'temperatura', 773.0000, 'ºC'),
	(111550, 111, '2015-03-15 00:16:43.000000', 'temperatura', 405.0000, 'ºC'),
	(111551, 111, '2015-03-15 00:16:44.000000', 'temperatura', 904.0000, 'ºC'),
	(111552, 111, '2015-03-15 00:16:45.000000', 'temperatura', 906.0000, 'ºC'),
	(111553, 111, '2015-03-15 00:16:46.000000', 'temperatura', 620.0000, 'ºC'),
	(111554, 111, '2015-03-15 00:16:47.000000', 'temperatura', 380.0000, 'ºC'),
	(111555, 111, '2015-03-15 00:16:48.000000', 'temperatura', 42.0000, 'ºC'),
	(111556, 111, '2015-03-15 00:16:49.000000', 'temperatura', 269.0000, 'ºC'),
	(111557, 111, '2015-03-15 00:16:50.000000', 'temperatura', 19.0000, 'ºC'),
	(111558, 111, '2015-03-15 00:16:51.000000', 'temperatura', 490.0000, 'ºC'),
	(111559, 111, '2015-03-15 00:16:52.000000', 'temperatura', 1192.0000, 'ºC'),
	(111560, 111, '2015-03-15 00:16:53.000000', 'temperatura', 892.0000, 'ºC'),
	(111561, 111, '2015-03-15 00:16:54.000000', 'temperatura', 886.0000, 'ºC'),
	(111562, 111, '2015-03-15 00:16:55.000000', 'temperatura', 553.0000, 'ºC'),
	(111563, 111, '2015-03-15 00:16:56.000000', 'temperatura', 107.0000, 'ºC'),
	(111564, 111, '2015-03-15 00:16:57.000000', 'temperatura', 78.0000, 'ºC'),
	(111565, 111, '2015-03-15 00:16:58.000000', 'temperatura', 70.0000, 'ºC'),
	(111566, 111, '2015-03-15 00:16:59.000000', 'temperatura', 115.0000, 'ºC'),
	(111567, 111, '2015-03-15 00:17:00.000000', 'temperatura', 366.0000, 'ºC'),
	(111568, 111, '2015-03-15 00:17:01.000000', 'temperatura', 286.0000, 'ºC'),
	(111569, 111, '2015-03-15 00:17:02.000000', 'temperatura', 333.0000, 'ºC'),
	(111570, 111, '2015-03-15 00:17:03.000000', 'temperatura', 805.0000, 'ºC'),
	(111571, 111, '2015-03-15 00:17:04.000000', 'temperatura', 630.0000, 'ºC'),
	(111572, 111, '2015-03-15 00:17:05.000000', 'temperatura', 732.0000, 'ºC'),
	(111573, 111, '2015-03-15 00:17:06.000000', 'temperatura', 571.0000, 'ºC'),
	(111574, 111, '2015-03-15 00:17:07.000000', 'temperatura', 661.0000, 'ºC'),
	(111575, 111, '2015-03-15 00:17:08.000000', 'temperatura', 391.0000, 'ºC'),
	(111576, 111, '2015-03-15 00:17:09.000000', 'temperatura', 1171.0000, 'ºC'),
	(111577, 111, '2015-03-15 00:17:10.000000', 'temperatura', 1085.0000, 'ºC'),
	(111578, 111, '2015-03-15 00:17:11.000000', 'temperatura', 713.0000, 'ºC'),
	(111579, 111, '2015-03-15 00:17:12.000000', 'temperatura', 308.0000, 'ºC'),
	(111580, 111, '2015-03-15 00:17:13.000000', 'temperatura', 603.0000, 'ºC'),
	(111581, 111, '2015-03-15 00:17:14.000000', 'temperatura', 891.0000, 'ºC'),
	(111582, 111, '2015-03-15 00:17:15.000000', 'temperatura', 248.0000, 'ºC'),
	(111583, 111, '2015-03-15 00:17:16.000000', 'temperatura', 968.0000, 'ºC'),
	(111584, 111, '2015-03-15 00:17:17.000000', 'temperatura', 495.0000, 'ºC'),
	(111585, 111, '2015-03-15 00:17:18.000000', 'temperatura', 771.0000, 'ºC'),
	(111586, 111, '2015-03-15 00:17:19.000000', 'temperatura', 1169.0000, 'ºC'),
	(111587, 111, '2015-03-15 00:17:20.000000', 'temperatura', 1134.0000, 'ºC'),
	(111588, 111, '2015-03-15 00:17:21.000000', 'temperatura', 963.0000, 'ºC'),
	(111589, 111, '2015-03-15 00:17:22.000000', 'temperatura', 212.0000, 'ºC'),
	(111590, 111, '2015-03-15 00:17:23.000000', 'temperatura', 573.0000, 'ºC'),
	(111591, 111, '2015-03-15 00:17:24.000000', 'temperatura', 1028.0000, 'ºC'),
	(111592, 111, '2015-03-15 00:17:25.000000', 'temperatura', 1021.0000, 'ºC'),
	(111593, 111, '2015-03-15 00:17:26.000000', 'temperatura', 821.0000, 'ºC'),
	(111594, 111, '2015-03-15 00:17:27.000000', 'temperatura', 1046.0000, 'ºC'),
	(111595, 111, '2015-03-15 00:17:28.000000', 'temperatura', 364.0000, 'ºC'),
	(111596, 111, '2015-03-15 00:17:29.000000', 'temperatura', 1084.0000, 'ºC'),
	(111597, 111, '2015-03-15 00:17:30.000000', 'temperatura', 728.0000, 'ºC'),
	(111598, 111, '2015-03-15 00:17:31.000000', 'temperatura', 391.0000, 'ºC'),
	(111599, 111, '2015-03-15 00:17:32.000000', 'temperatura', 968.0000, 'ºC'),
	(111600, 111, '2015-03-15 00:17:33.000000', 'temperatura', 70.0000, 'ºC'),
	(111601, 111, '2015-03-15 00:17:34.000000', 'temperatura', 1045.0000, 'ºC'),
	(111602, 111, '2015-03-15 00:17:35.000000', 'temperatura', 214.0000, 'ºC'),
	(111603, 111, '2015-03-15 00:17:36.000000', 'temperatura', 339.0000, 'ºC'),
	(111604, 111, '2015-03-15 00:17:37.000000', 'temperatura', 1051.0000, 'ºC'),
	(111605, 111, '2015-03-15 00:17:38.000000', 'temperatura', 638.0000, 'ºC'),
	(111606, 111, '2015-03-15 00:17:39.000000', 'temperatura', 40.0000, 'ºC'),
	(111607, 111, '2015-03-15 00:17:40.000000', 'temperatura', 684.0000, 'ºC'),
	(111608, 111, '2015-03-15 00:17:41.000000', 'temperatura', 902.0000, 'ºC'),
	(111609, 111, '2015-03-15 00:17:42.000000', 'temperatura', 57.0000, 'ºC'),
	(111610, 111, '2015-03-15 00:17:43.000000', 'temperatura', 1180.0000, 'ºC'),
	(111611, 111, '2015-03-15 00:17:44.000000', 'temperatura', 929.0000, 'ºC'),
	(111612, 111, '2015-03-15 00:17:45.000000', 'temperatura', 1108.0000, 'ºC'),
	(111613, 111, '2015-03-15 00:17:46.000000', 'temperatura', 350.0000, 'ºC'),
	(111614, 111, '2015-03-15 00:17:47.000000', 'temperatura', 829.0000, 'ºC'),
	(111615, 111, '2015-03-15 00:17:48.000000', 'temperatura', 693.0000, 'ºC'),
	(111616, 111, '2015-03-15 00:17:49.000000', 'temperatura', 979.0000, 'ºC'),
	(111617, 111, '2015-03-15 00:17:50.000000', 'temperatura', 415.0000, 'ºC'),
	(111618, 111, '2015-03-15 00:17:51.000000', 'temperatura', 340.0000, 'ºC'),
	(111619, 111, '2015-03-15 00:17:52.000000', 'temperatura', 458.0000, 'ºC'),
	(111620, 111, '2015-03-15 00:17:53.000000', 'temperatura', 67.0000, 'ºC'),
	(111621, 111, '2015-03-15 00:17:54.000000', 'temperatura', 162.0000, 'ºC'),
	(111622, 111, '2015-03-15 00:17:55.000000', 'temperatura', 608.0000, 'ºC'),
	(111623, 111, '2015-03-15 00:17:56.000000', 'temperatura', 157.0000, 'ºC'),
	(111624, 111, '2015-03-15 00:17:57.000000', 'temperatura', 163.0000, 'ºC'),
	(111625, 111, '2015-03-15 00:17:58.000000', 'temperatura', 342.0000, 'ºC'),
	(111626, 111, '2015-03-15 00:17:59.000000', 'temperatura', 21.0000, 'ºC'),
	(111627, 111, '2015-03-15 00:18:00.000000', 'temperatura', 278.0000, 'ºC'),
	(111628, 111, '2015-03-15 00:18:01.000000', 'temperatura', 130.0000, 'ºC'),
	(111629, 111, '2015-03-15 00:18:02.000000', 'temperatura', 1017.0000, 'ºC'),
	(111630, 111, '2015-03-15 00:18:03.000000', 'temperatura', 1094.0000, 'ºC'),
	(111631, 111, '2015-03-15 00:18:04.000000', 'temperatura', 20.0000, 'ºC'),
	(111632, 111, '2015-03-15 00:18:05.000000', 'temperatura', 418.0000, 'ºC'),
	(111633, 111, '2015-03-15 00:18:06.000000', 'temperatura', 830.0000, 'ºC'),
	(111634, 111, '2015-03-15 00:18:07.000000', 'temperatura', 496.0000, 'ºC'),
	(111635, 111, '2015-03-15 00:18:08.000000', 'temperatura', 1191.0000, 'ºC'),
	(111636, 111, '2015-03-15 00:18:09.000000', 'temperatura', 870.0000, 'ºC'),
	(111637, 111, '2015-03-15 00:18:10.000000', 'temperatura', 775.0000, 'ºC'),
	(111638, 111, '2015-03-15 00:18:11.000000', 'temperatura', 66.0000, 'ºC'),
	(111639, 111, '2015-03-15 00:18:12.000000', 'temperatura', 406.0000, 'ºC'),
	(111640, 111, '2015-03-15 00:18:13.000000', 'temperatura', 630.0000, 'ºC'),
	(111641, 111, '2015-03-15 00:18:14.000000', 'temperatura', 736.0000, 'ºC'),
	(111642, 111, '2015-03-15 00:18:15.000000', 'temperatura', 589.0000, 'ºC'),
	(111643, 111, '2015-03-15 00:18:16.000000', 'temperatura', 740.0000, 'ºC'),
	(111644, 111, '2015-03-15 00:18:17.000000', 'temperatura', 730.0000, 'ºC'),
	(111645, 111, '2015-03-15 00:18:18.000000', 'temperatura', 232.0000, 'ºC'),
	(111646, 111, '2015-03-15 00:18:19.000000', 'temperatura', 171.0000, 'ºC'),
	(111647, 111, '2015-03-15 00:18:20.000000', 'temperatura', 158.0000, 'ºC'),
	(111648, 111, '2015-03-15 00:18:21.000000', 'temperatura', 280.0000, 'ºC'),
	(111649, 111, '2015-03-15 00:18:22.000000', 'temperatura', 926.0000, 'ºC'),
	(111650, 111, '2015-03-15 00:18:23.000000', 'temperatura', 190.0000, 'ºC'),
	(111651, 111, '2015-03-15 00:18:24.000000', 'temperatura', 574.0000, 'ºC'),
	(111652, 111, '2015-03-15 00:18:25.000000', 'temperatura', 1100.0000, 'ºC'),
	(111653, 111, '2015-03-15 00:18:26.000000', 'temperatura', 177.0000, 'ºC'),
	(111654, 111, '2015-03-15 00:18:27.000000', 'temperatura', 1188.0000, 'ºC'),
	(111655, 111, '2015-03-15 00:18:28.000000', 'temperatura', 607.0000, 'ºC'),
	(111656, 111, '2015-03-15 00:18:29.000000', 'temperatura', 671.0000, 'ºC'),
	(111657, 111, '2015-03-15 00:18:30.000000', 'temperatura', 337.0000, 'ºC'),
	(111658, 111, '2015-03-15 00:18:31.000000', 'temperatura', 869.0000, 'ºC'),
	(111659, 111, '2015-03-15 00:18:32.000000', 'temperatura', 938.0000, 'ºC'),
	(111660, 111, '2015-03-15 00:18:33.000000', 'temperatura', 881.0000, 'ºC'),
	(111661, 111, '2015-03-15 00:18:34.000000', 'temperatura', 394.0000, 'ºC'),
	(111662, 111, '2015-03-15 00:18:35.000000', 'temperatura', 525.0000, 'ºC'),
	(111663, 111, '2015-03-15 00:18:36.000000', 'temperatura', 243.0000, 'ºC'),
	(111664, 111, '2015-03-15 00:18:37.000000', 'temperatura', 842.0000, 'ºC'),
	(111665, 111, '2015-03-15 00:18:38.000000', 'temperatura', 1081.0000, 'ºC'),
	(111666, 111, '2015-03-15 00:18:39.000000', 'temperatura', 481.0000, 'ºC'),
	(111667, 111, '2015-03-15 00:18:40.000000', 'temperatura', 359.0000, 'ºC'),
	(111668, 111, '2015-03-15 00:18:41.000000', 'temperatura', 356.0000, 'ºC'),
	(111669, 111, '2015-03-15 00:18:42.000000', 'temperatura', 703.0000, 'ºC'),
	(111670, 111, '2015-03-15 00:18:43.000000', 'temperatura', 45.0000, 'ºC'),
	(111671, 111, '2015-03-15 00:18:44.000000', 'temperatura', 520.0000, 'ºC'),
	(111672, 111, '2015-03-15 00:18:45.000000', 'temperatura', 64.0000, 'ºC'),
	(111673, 111, '2015-03-15 00:18:46.000000', 'temperatura', 1161.0000, 'ºC'),
	(111674, 111, '2015-03-15 00:18:47.000000', 'temperatura', 813.0000, 'ºC'),
	(111675, 111, '2015-03-15 00:18:48.000000', 'temperatura', 582.0000, 'ºC'),
	(111676, 111, '2015-03-15 00:18:49.000000', 'temperatura', 472.0000, 'ºC'),
	(111677, 111, '2015-03-15 00:18:50.000000', 'temperatura', 613.0000, 'ºC'),
	(111678, 111, '2015-03-15 00:18:51.000000', 'temperatura', 452.0000, 'ºC'),
	(111679, 111, '2015-03-15 00:18:52.000000', 'temperatura', 420.0000, 'ºC'),
	(111680, 111, '2015-03-15 00:18:53.000000', 'temperatura', 744.0000, 'ºC'),
	(111681, 111, '2015-03-15 00:18:54.000000', 'temperatura', 62.0000, 'ºC'),
	(111682, 111, '2015-03-15 00:18:55.000000', 'temperatura', 476.0000, 'ºC'),
	(111683, 111, '2015-03-15 00:18:56.000000', 'temperatura', 995.0000, 'ºC'),
	(111684, 111, '2015-03-15 00:18:57.000000', 'temperatura', 1148.0000, 'ºC'),
	(111685, 111, '2015-03-15 00:18:58.000000', 'temperatura', 357.0000, 'ºC'),
	(111686, 111, '2015-03-15 00:18:59.000000', 'temperatura', 742.0000, 'ºC'),
	(111687, 111, '2015-03-15 00:19:00.000000', 'temperatura', 239.0000, 'ºC'),
	(111688, 111, '2015-03-15 00:19:01.000000', 'temperatura', 169.0000, 'ºC'),
	(111689, 111, '2015-03-15 00:19:02.000000', 'temperatura', 129.0000, 'ºC'),
	(111690, 111, '2015-03-15 00:19:03.000000', 'temperatura', 139.0000, 'ºC'),
	(111691, 111, '2015-03-15 00:19:04.000000', 'temperatura', 306.0000, 'ºC'),
	(111692, 111, '2015-03-15 00:19:05.000000', 'temperatura', 1116.0000, 'ºC'),
	(111693, 111, '2015-03-15 00:19:06.000000', 'temperatura', 1064.0000, 'ºC'),
	(111694, 111, '2015-03-15 00:19:07.000000', 'temperatura', 769.0000, 'ºC'),
	(111695, 111, '2015-03-15 00:19:08.000000', 'temperatura', 657.0000, 'ºC'),
	(111696, 111, '2015-03-15 00:19:09.000000', 'temperatura', 975.0000, 'ºC'),
	(111697, 111, '2015-03-15 00:19:10.000000', 'temperatura', 508.0000, 'ºC'),
	(111698, 111, '2015-03-15 00:19:11.000000', 'temperatura', 812.0000, 'ºC'),
	(111699, 111, '2015-03-15 00:19:12.000000', 'temperatura', 139.0000, 'ºC'),
	(111700, 111, '2015-03-15 00:19:13.000000', 'temperatura', 658.0000, 'ºC'),
	(111701, 111, '2015-03-15 00:19:14.000000', 'temperatura', 474.0000, 'ºC'),
	(111702, 111, '2015-03-15 00:19:15.000000', 'temperatura', 397.0000, 'ºC'),
	(111703, 111, '2015-03-15 00:19:16.000000', 'temperatura', 562.0000, 'ºC'),
	(111704, 111, '2015-03-15 00:19:17.000000', 'temperatura', 422.0000, 'ºC'),
	(111705, 111, '2015-03-15 00:19:18.000000', 'temperatura', 423.0000, 'ºC'),
	(111706, 111, '2015-03-15 00:19:19.000000', 'temperatura', 849.0000, 'ºC'),
	(111707, 111, '2015-03-15 00:19:20.000000', 'temperatura', 577.0000, 'ºC'),
	(111708, 111, '2015-03-15 00:19:21.000000', 'temperatura', 340.0000, 'ºC'),
	(111709, 111, '2015-03-15 00:19:22.000000', 'temperatura', 1170.0000, 'ºC'),
	(111710, 111, '2015-03-15 00:19:23.000000', 'temperatura', 28.0000, 'ºC'),
	(111711, 111, '2015-03-15 00:19:24.000000', 'temperatura', 230.0000, 'ºC'),
	(111712, 111, '2015-03-15 00:19:25.000000', 'temperatura', 1067.0000, 'ºC'),
	(111713, 111, '2015-03-15 00:19:26.000000', 'temperatura', 1046.0000, 'ºC'),
	(111714, 111, '2015-03-15 00:19:27.000000', 'temperatura', 829.0000, 'ºC'),
	(111715, 111, '2015-03-15 00:19:28.000000', 'temperatura', 1010.0000, 'ºC'),
	(111716, 111, '2015-03-15 00:19:29.000000', 'temperatura', 160.0000, 'ºC'),
	(111717, 111, '2015-03-15 00:19:30.000000', 'temperatura', 172.0000, 'ºC'),
	(111718, 111, '2015-03-15 00:19:31.000000', 'temperatura', 380.0000, 'ºC'),
	(111719, 111, '2015-03-15 00:19:32.000000', 'temperatura', 184.0000, 'ºC'),
	(111720, 111, '2015-03-15 00:19:33.000000', 'temperatura', 982.0000, 'ºC'),
	(111721, 111, '2015-03-15 00:19:34.000000', 'temperatura', 756.0000, 'ºC'),
	(111722, 111, '2015-03-15 00:19:35.000000', 'temperatura', 838.0000, 'ºC'),
	(111723, 111, '2015-03-15 00:19:36.000000', 'temperatura', 720.0000, 'ºC'),
	(111724, 111, '2015-03-15 00:19:37.000000', 'temperatura', 1088.0000, 'ºC'),
	(111725, 111, '2015-03-15 00:19:38.000000', 'temperatura', 878.0000, 'ºC'),
	(111726, 111, '2015-03-15 00:19:39.000000', 'temperatura', 1128.0000, 'ºC'),
	(111727, 111, '2015-03-15 00:19:40.000000', 'temperatura', 608.0000, 'ºC'),
	(111728, 111, '2015-03-15 00:19:41.000000', 'temperatura', 853.0000, 'ºC'),
	(111729, 111, '2015-03-15 00:19:42.000000', 'temperatura', 45.0000, 'ºC'),
	(111730, 111, '2015-03-15 00:19:43.000000', 'temperatura', 65.0000, 'ºC'),
	(111731, 111, '2015-03-15 00:19:44.000000', 'temperatura', 190.0000, 'ºC'),
	(111732, 111, '2015-03-15 00:19:45.000000', 'temperatura', 758.0000, 'ºC'),
	(111733, 111, '2015-03-15 00:19:46.000000', 'temperatura', 819.0000, 'ºC'),
	(111734, 111, '2015-03-15 00:19:47.000000', 'temperatura', 623.0000, 'ºC'),
	(111735, 111, '2015-03-15 00:19:48.000000', 'temperatura', 656.0000, 'ºC'),
	(111736, 111, '2015-03-15 00:19:49.000000', 'temperatura', 213.0000, 'ºC'),
	(111737, 111, '2015-03-15 00:19:50.000000', 'temperatura', 297.0000, 'ºC'),
	(111738, 111, '2015-03-15 00:19:51.000000', 'temperatura', 849.0000, 'ºC'),
	(111739, 111, '2015-03-15 00:19:52.000000', 'temperatura', 952.0000, 'ºC'),
	(111740, 111, '2015-03-15 00:19:53.000000', 'temperatura', 1013.0000, 'ºC'),
	(111741, 111, '2015-03-15 00:19:54.000000', 'temperatura', 1012.0000, 'ºC'),
	(111742, 111, '2015-03-15 00:19:55.000000', 'temperatura', 821.0000, 'ºC'),
	(111743, 111, '2015-03-15 00:19:56.000000', 'temperatura', 1070.0000, 'ºC'),
	(111744, 111, '2015-03-15 00:19:57.000000', 'temperatura', 486.0000, 'ºC'),
	(111745, 111, '2015-03-15 00:19:58.000000', 'temperatura', 421.0000, 'ºC'),
	(111746, 111, '2015-03-15 00:19:59.000000', 'temperatura', 648.0000, 'ºC'),
	(111747, 111, '2015-03-15 00:20:00.000000', 'temperatura', 779.0000, 'ºC'),
	(111748, 111, '2015-03-15 00:20:01.000000', 'temperatura', 748.0000, 'ºC'),
	(111749, 111, '2015-03-15 00:20:02.000000', 'temperatura', 207.0000, 'ºC'),
	(111750, 111, '2015-03-15 00:20:03.000000', 'temperatura', 1190.0000, 'ºC'),
	(111751, 111, '2015-03-15 00:20:04.000000', 'temperatura', 528.0000, 'ºC'),
	(111752, 111, '2015-03-15 00:20:05.000000', 'temperatura', 272.0000, 'ºC'),
	(111753, 111, '2015-03-15 00:20:06.000000', 'temperatura', 975.0000, 'ºC'),
	(111754, 111, '2015-03-15 00:20:07.000000', 'temperatura', 462.0000, 'ºC'),
	(111755, 111, '2015-03-15 00:20:08.000000', 'temperatura', 583.0000, 'ºC'),
	(111756, 111, '2015-03-15 00:20:09.000000', 'temperatura', 331.0000, 'ºC'),
	(111757, 111, '2015-03-15 00:20:10.000000', 'temperatura', 1106.0000, 'ºC'),
	(111758, 111, '2015-03-15 00:20:11.000000', 'temperatura', 939.0000, 'ºC'),
	(111759, 111, '2015-03-15 00:20:12.000000', 'temperatura', 175.0000, 'ºC'),
	(111760, 111, '2015-03-15 00:20:13.000000', 'temperatura', 458.0000, 'ºC'),
	(111761, 111, '2015-03-15 00:20:14.000000', 'temperatura', 566.0000, 'ºC'),
	(111762, 111, '2015-03-15 00:20:15.000000', 'temperatura', 259.0000, 'ºC'),
	(111763, 111, '2015-03-15 00:20:16.000000', 'temperatura', 796.0000, 'ºC'),
	(111764, 111, '2015-03-15 00:20:17.000000', 'temperatura', 802.0000, 'ºC'),
	(111765, 111, '2015-03-15 00:20:18.000000', 'temperatura', 422.0000, 'ºC'),
	(111766, 111, '2015-03-15 00:20:19.000000', 'temperatura', 908.0000, 'ºC'),
	(111767, 111, '2015-03-15 00:20:20.000000', 'temperatura', 871.0000, 'ºC'),
	(111768, 111, '2015-03-15 00:20:21.000000', 'temperatura', 433.0000, 'ºC'),
	(111769, 111, '2015-03-15 00:20:22.000000', 'temperatura', 753.0000, 'ºC'),
	(111770, 111, '2015-03-15 00:20:23.000000', 'temperatura', 68.0000, 'ºC'),
	(111771, 111, '2015-03-15 00:20:24.000000', 'temperatura', 478.0000, 'ºC'),
	(111772, 111, '2015-03-15 00:20:25.000000', 'temperatura', 990.0000, 'ºC'),
	(111773, 111, '2015-03-15 00:20:26.000000', 'temperatura', 1115.0000, 'ºC'),
	(111774, 111, '2015-03-15 00:20:27.000000', 'temperatura', 205.0000, 'ºC'),
	(111775, 111, '2015-03-15 00:20:28.000000', 'temperatura', 79.0000, 'ºC'),
	(111776, 111, '2015-03-15 00:20:29.000000', 'temperatura', 981.0000, 'ºC'),
	(111777, 111, '2015-03-15 00:20:30.000000', 'temperatura', 1071.0000, 'ºC'),
	(111778, 111, '2015-03-15 00:20:31.000000', 'temperatura', 11.0000, 'ºC'),
	(111779, 111, '2015-03-15 00:20:32.000000', 'temperatura', 443.0000, 'ºC'),
	(111780, 111, '2015-03-15 00:20:33.000000', 'temperatura', 983.0000, 'ºC'),
	(111781, 111, '2015-03-15 00:20:34.000000', 'temperatura', 1187.0000, 'ºC'),
	(111782, 111, '2015-03-15 00:20:35.000000', 'temperatura', 584.0000, 'ºC'),
	(111783, 111, '2015-03-15 00:20:36.000000', 'temperatura', 563.0000, 'ºC'),
	(111784, 111, '2015-03-15 00:20:37.000000', 'temperatura', 1060.0000, 'ºC'),
	(111785, 111, '2015-03-15 00:20:38.000000', 'temperatura', 14.0000, 'ºC'),
	(111786, 111, '2015-03-15 00:20:39.000000', 'temperatura', 489.0000, 'ºC'),
	(111787, 111, '2015-03-15 00:20:40.000000', 'temperatura', 3.0000, 'ºC'),
	(111788, 111, '2015-03-15 00:20:41.000000', 'temperatura', 949.0000, 'ºC'),
	(111789, 111, '2015-03-15 00:20:42.000000', 'temperatura', 1135.0000, 'ºC'),
	(111790, 111, '2015-03-15 00:20:43.000000', 'temperatura', 429.0000, 'ºC'),
	(111791, 111, '2015-03-15 00:20:44.000000', 'temperatura', 1142.0000, 'ºC'),
	(111792, 111, '2015-03-15 00:20:45.000000', 'temperatura', 821.0000, 'ºC'),
	(111793, 111, '2015-03-15 00:20:46.000000', 'temperatura', 682.0000, 'ºC'),
	(111794, 111, '2015-03-15 00:20:47.000000', 'temperatura', 947.0000, 'ºC'),
	(111795, 111, '2015-03-15 00:20:48.000000', 'temperatura', 290.0000, 'ºC'),
	(111796, 111, '2015-03-15 00:20:49.000000', 'temperatura', 1008.0000, 'ºC'),
	(111797, 111, '2015-03-15 00:20:50.000000', 'temperatura', 570.0000, 'ºC'),
	(111798, 111, '2015-03-15 00:20:51.000000', 'temperatura', 1026.0000, 'ºC'),
	(111799, 111, '2015-03-15 00:20:52.000000', 'temperatura', 1023.0000, 'ºC'),
	(111800, 111, '2015-03-15 00:20:53.000000', 'temperatura', 836.0000, 'ºC'),
	(111801, 111, '2015-03-15 00:20:54.000000', 'temperatura', 1111.0000, 'ºC'),
	(111802, 111, '2015-03-15 00:20:55.000000', 'temperatura', 649.0000, 'ºC'),
	(111803, 111, '2015-03-15 00:20:56.000000', 'temperatura', 1111.0000, 'ºC'),
	(111804, 111, '2015-03-15 00:20:57.000000', 'temperatura', 9.0000, 'ºC'),
	(111805, 111, '2015-03-15 00:20:58.000000', 'temperatura', 312.0000, 'ºC'),
	(111806, 111, '2015-03-15 00:20:59.000000', 'temperatura', 336.0000, 'ºC'),
	(111807, 111, '2015-03-15 00:21:00.000000', 'temperatura', 743.0000, 'ºC'),
	(111808, 111, '2015-03-15 00:21:01.000000', 'temperatura', 308.0000, 'ºC'),
	(111809, 111, '2015-03-15 00:21:02.000000', 'temperatura', 512.0000, 'ºC'),
	(111810, 111, '2015-03-15 00:21:03.000000', 'temperatura', 435.0000, 'ºC'),
	(111811, 111, '2015-03-15 00:21:04.000000', 'temperatura', 638.0000, 'ºC'),
	(111812, 111, '2015-03-15 00:21:05.000000', 'temperatura', 688.0000, 'ºC'),
	(111813, 111, '2015-03-15 00:21:06.000000', 'temperatura', 326.0000, 'ºC'),
	(111814, 111, '2015-03-15 00:21:07.000000', 'temperatura', 765.0000, 'ºC'),
	(111815, 111, '2015-03-15 00:21:08.000000', 'temperatura', 449.0000, 'ºC'),
	(111816, 111, '2015-03-15 00:21:09.000000', 'temperatura', 1151.0000, 'ºC'),
	(111817, 111, '2015-03-15 00:21:10.000000', 'temperatura', 810.0000, 'ºC'),
	(111818, 111, '2015-03-15 00:21:11.000000', 'temperatura', 595.0000, 'ºC'),
	(111819, 111, '2015-03-15 00:21:12.000000', 'temperatura', 547.0000, 'ºC'),
	(111820, 111, '2015-03-15 00:21:13.000000', 'temperatura', 950.0000, 'ºC'),
	(111821, 111, '2015-03-15 00:21:14.000000', 'temperatura', 709.0000, 'ºC'),
	(111822, 111, '2015-03-15 00:21:15.000000', 'temperatura', 697.0000, 'ºC'),
	(111823, 111, '2015-03-15 00:21:16.000000', 'temperatura', 159.0000, 'ºC'),
	(111824, 111, '2015-03-15 00:21:17.000000', 'temperatura', 1102.0000, 'ºC'),
	(111825, 111, '2015-03-15 00:21:18.000000', 'temperatura', 234.0000, 'ºC'),
	(111826, 111, '2015-03-15 00:21:19.000000', 'temperatura', 264.0000, 'ºC'),
	(111827, 111, '2015-03-15 00:21:20.000000', 'temperatura', 620.0000, 'ºC'),
	(111828, 111, '2015-03-15 00:21:21.000000', 'temperatura', 1107.0000, 'ºC'),
	(111829, 111, '2015-03-15 00:21:22.000000', 'temperatura', 75.0000, 'ºC'),
	(111830, 111, '2015-03-15 00:21:23.000000', 'temperatura', 654.0000, 'ºC'),
	(111831, 111, '2015-03-15 00:21:24.000000', 'temperatura', 648.0000, 'ºC'),
	(111832, 111, '2015-03-15 00:21:25.000000', 'temperatura', 78.0000, 'ºC'),
	(111833, 111, '2015-03-15 00:21:26.000000', 'temperatura', 847.0000, 'ºC'),
	(111834, 111, '2015-03-15 00:21:27.000000', 'temperatura', 402.0000, 'ºC'),
	(111835, 111, '2015-03-15 00:21:28.000000', 'temperatura', 670.0000, 'ºC'),
	(111836, 111, '2015-03-15 00:21:29.000000', 'temperatura', 944.0000, 'ºC'),
	(111837, 111, '2015-03-15 00:21:30.000000', 'temperatura', 311.0000, 'ºC'),
	(111838, 111, '2015-03-15 00:21:31.000000', 'temperatura', 1121.0000, 'ºC'),
	(111839, 111, '2015-03-15 00:21:32.000000', 'temperatura', 1073.0000, 'ºC'),
	(111840, 111, '2015-03-15 00:21:33.000000', 'temperatura', 804.0000, 'ºC'),
	(111841, 111, '2015-03-15 00:21:34.000000', 'temperatura', 801.0000, 'ºC'),
	(111842, 111, '2015-03-15 00:21:35.000000', 'temperatura', 393.0000, 'ºC'),
	(111843, 111, '2015-03-15 00:21:36.000000', 'temperatura', 761.0000, 'ºC'),
	(111844, 111, '2015-03-15 00:21:37.000000', 'temperatura', 230.0000, 'ºC'),
	(111845, 111, '2015-03-15 00:21:38.000000', 'temperatura', 65.0000, 'ºC'),
	(111846, 111, '2015-03-15 00:21:39.000000', 'temperatura', 837.0000, 'ºC'),
	(111847, 111, '2015-03-15 00:21:40.000000', 'temperatura', 391.0000, 'ºC'),
	(111848, 111, '2015-03-15 00:21:41.000000', 'temperatura', 643.0000, 'ºC'),
	(111849, 111, '2015-03-15 00:21:42.000000', 'temperatura', 841.0000, 'ºC'),
	(111850, 111, '2015-03-15 00:21:43.000000', 'temperatura', 1078.0000, 'ºC'),
	(111851, 111, '2015-03-15 00:21:44.000000', 'temperatura', 468.0000, 'ºC'),
	(111852, 111, '2015-03-15 00:21:45.000000', 'temperatura', 308.0000, 'ºC'),
	(111853, 111, '2015-03-15 00:21:46.000000', 'temperatura', 136.0000, 'ºC'),
	(111854, 111, '2015-03-15 00:21:47.000000', 'temperatura', 956.0000, 'ºC'),
	(111855, 111, '2015-03-15 00:21:48.000000', 'temperatura', 773.0000, 'ºC'),
	(111856, 111, '2015-03-15 00:21:49.000000', 'temperatura', 999.0000, 'ºC'),
	(111857, 111, '2015-03-15 00:21:50.000000', 'temperatura', 276.0000, 'ºC'),
	(111858, 111, '2015-03-15 00:21:51.000000', 'temperatura', 782.0000, 'ºC'),
	(111859, 111, '2015-03-15 00:21:52.000000', 'temperatura', 684.0000, 'ºC'),
	(111860, 111, '2015-03-15 00:21:53.000000', 'temperatura', 1076.0000, 'ºC'),
	(111861, 111, '2015-03-15 00:21:54.000000', 'temperatura', 926.0000, 'ºC'),
	(111862, 111, '2015-03-15 00:21:55.000000', 'temperatura', 205.0000, 'ºC'),
	(111863, 111, '2015-03-15 00:21:56.000000', 'temperatura', 644.0000, 'ºC'),
	(111864, 111, '2015-03-15 00:21:57.000000', 'temperatura', 208.0000, 'ºC'),
	(111865, 111, '2015-03-15 00:21:58.000000', 'temperatura', 309.0000, 'ºC'),
	(111866, 111, '2015-03-15 00:21:59.000000', 'temperatura', 921.0000, 'ºC'),
	(111867, 111, '2015-03-15 00:22:00.000000', 'temperatura', 77.0000, 'ºC'),
	(111868, 111, '2015-03-15 00:22:01.000000', 'temperatura', 22.0000, 'ºC'),
	(111869, 111, '2015-03-15 00:22:02.000000', 'temperatura', 1078.0000, 'ºC'),
	(111870, 111, '2015-03-15 00:22:03.000000', 'temperatura', 528.0000, 'ºC'),
	(111871, 111, '2015-03-15 00:22:04.000000', 'temperatura', 606.0000, 'ºC'),
	(111872, 111, '2015-03-15 00:22:05.000000', 'temperatura', 247.0000, 'ºC'),
	(111873, 111, '2015-03-15 00:22:06.000000', 'temperatura', 615.0000, 'ºC'),
	(111874, 111, '2015-03-15 00:22:07.000000', 'temperatura', 1135.0000, 'ºC'),
	(111875, 111, '2015-03-15 00:22:08.000000', 'temperatura', 232.0000, 'ºC'),
	(111876, 111, '2015-03-15 00:22:09.000000', 'temperatura', 153.0000, 'ºC'),
	(111877, 111, '2015-03-15 00:22:10.000000', 'temperatura', 70.0000, 'ºC'),
	(111878, 111, '2015-03-15 00:22:11.000000', 'temperatura', 1091.0000, 'ºC'),
	(111879, 111, '2015-03-15 00:22:12.000000', 'temperatura', 446.0000, 'ºC'),
	(111880, 111, '2015-03-15 00:22:13.000000', 'temperatura', 156.0000, 'ºC'),
	(111881, 111, '2015-03-15 00:22:14.000000', 'temperatura', 646.0000, 'ºC'),
	(111882, 111, '2015-03-15 00:22:15.000000', 'temperatura', 359.0000, 'ºC'),
	(111883, 111, '2015-03-15 00:22:16.000000', 'temperatura', 1060.0000, 'ºC'),
	(111884, 111, '2015-03-15 00:22:17.000000', 'temperatura', 621.0000, 'ºC'),
	(111885, 111, '2015-03-15 00:22:18.000000', 'temperatura', 1125.0000, 'ºC'),
	(111886, 111, '2015-03-15 00:22:19.000000', 'temperatura', 164.0000, 'ºC'),
	(111887, 111, '2015-03-15 00:22:20.000000', 'temperatura', 1046.0000, 'ºC'),
	(111888, 111, '2015-03-15 00:22:21.000000', 'temperatura', 1139.0000, 'ºC'),
	(111889, 111, '2015-03-15 00:22:22.000000', 'temperatura', 158.0000, 'ºC'),
	(111890, 111, '2015-03-15 00:22:23.000000', 'temperatura', 973.0000, 'ºC'),
	(111891, 111, '2015-03-15 00:22:24.000000', 'temperatura', 790.0000, 'ºC'),
	(111892, 111, '2015-03-15 00:22:25.000000', 'temperatura', 1033.0000, 'ºC'),
	(111893, 111, '2015-03-15 00:22:26.000000', 'temperatura', 395.0000, 'ºC'),
	(111894, 111, '2015-03-15 00:22:27.000000', 'temperatura', 77.0000, 'ºC'),
	(111895, 111, '2015-03-15 00:22:28.000000', 'temperatura', 399.0000, 'ºC'),
	(111896, 111, '2015-03-15 00:22:29.000000', 'temperatura', 564.0000, 'ºC'),
	(111897, 111, '2015-03-15 00:22:30.000000', 'temperatura', 424.0000, 'ºC'),
	(111898, 111, '2015-03-15 00:22:31.000000', 'temperatura', 430.0000, 'ºC'),
	(111899, 111, '2015-03-15 00:22:32.000000', 'temperatura', 877.0000, 'ºC'),
	(111900, 111, '2015-03-15 00:22:33.000000', 'temperatura', 697.0000, 'ºC'),
	(111901, 111, '2015-03-15 00:22:34.000000', 'temperatura', 852.0000, 'ºC'),
	(111902, 111, '2015-03-15 00:22:35.000000', 'temperatura', 971.0000, 'ºC'),
	(111903, 111, '2015-03-15 00:22:36.000000', 'temperatura', 1098.0000, 'ºC'),
	(111904, 111, '2015-03-15 00:22:37.000000', 'temperatura', 177.0000, 'ºC'),
	(111905, 111, '2015-03-15 00:22:38.000000', 'temperatura', 1194.0000, 'ºC'),
	(111906, 111, '2015-03-15 00:22:39.000000', 'temperatura', 638.0000, 'ºC'),
	(111907, 111, '2015-03-15 00:22:40.000000', 'temperatura', 811.0000, 'ºC'),
	(111908, 111, '2015-03-15 00:22:41.000000', 'temperatura', 939.0000, 'ºC'),
	(111909, 111, '2015-03-15 00:22:42.000000', 'temperatura', 1063.0000, 'ºC'),
	(111910, 111, '2015-03-15 00:22:43.000000', 'temperatura', 98.0000, 'ºC'),
	(111911, 111, '2015-03-15 00:22:44.000000', 'temperatura', 903.0000, 'ºC'),
	(111912, 111, '2015-03-15 00:22:45.000000', 'temperatura', 621.0000, 'ºC'),
	(111913, 111, '2015-03-15 00:22:46.000000', 'temperatura', 395.0000, 'ºC'),
	(111914, 111, '2015-03-15 00:22:47.000000', 'temperatura', 114.0000, 'ºC'),
	(111915, 111, '2015-03-15 00:22:48.000000', 'temperatura', 587.0000, 'ºC'),
	(111916, 111, '2015-03-15 00:22:49.000000', 'temperatura', 192.0000, 'ºC'),
	(111917, 111, '2015-03-15 00:22:50.000000', 'temperatura', 401.0000, 'ºC'),
	(111918, 111, '2015-03-15 00:22:51.000000', 'temperatura', 227.0000, 'ºC'),
	(111919, 111, '2015-03-15 00:22:52.000000', 'temperatura', 1134.0000, 'ºC'),
	(111920, 111, '2015-03-15 00:22:53.000000', 'temperatura', 188.0000, 'ºC'),
	(111921, 111, '2015-03-15 00:22:54.000000', 'temperatura', 1138.0000, 'ºC'),
	(111922, 111, '2015-03-15 00:22:55.000000', 'temperatura', 328.0000, 'ºC'),
	(111923, 111, '2015-03-15 00:22:56.000000', 'temperatura', 628.0000, 'ºC'),
	(111924, 111, '2015-03-15 00:22:57.000000', 'temperatura', 953.0000, 'ºC'),
	(111925, 111, '2015-03-15 00:22:58.000000', 'temperatura', 485.0000, 'ºC'),
	(111926, 111, '2015-03-15 00:22:59.000000', 'temperatura', 765.0000, 'ºC'),
	(111927, 111, '2015-03-15 00:23:00.000000', 'temperatura', 1171.0000, 'ºC'),
	(111928, 111, '2015-03-15 00:23:01.000000', 'temperatura', 1159.0000, 'ºC'),
	(111929, 111, '2015-03-15 00:23:02.000000', 'temperatura', 1081.0000, 'ºC'),
	(111930, 111, '2015-03-15 00:23:03.000000', 'temperatura', 731.0000, 'ºC'),
	(111931, 111, '2015-03-15 00:23:04.000000', 'temperatura', 413.0000, 'ºC'),
	(111932, 111, '2015-03-15 00:23:05.000000', 'temperatura', 1070.0000, 'ºC'),
	(111933, 111, '2015-03-15 00:23:06.000000', 'temperatura', 514.0000, 'ºC'),
	(111934, 111, '2015-03-15 00:23:07.000000', 'temperatura', 560.0000, 'ºC'),
	(111935, 111, '2015-03-15 00:23:08.000000', 'temperatura', 60.0000, 'ºC'),
	(111936, 111, '2015-03-15 00:23:09.000000', 'temperatura', 1019.0000, 'ºC'),
	(111937, 111, '2015-03-15 00:23:10.000000', 'temperatura', 114.0000, 'ºC'),
	(111938, 111, '2015-03-15 00:23:11.000000', 'temperatura', 1113.0000, 'ºC'),
	(111939, 111, '2015-03-15 00:23:12.000000', 'temperatura', 426.0000, 'ºC'),
	(111940, 111, '2015-03-15 00:23:13.000000', 'temperatura', 1192.0000, 'ºC'),
	(111941, 111, '2015-03-15 00:23:14.000000', 'temperatura', 1082.0000, 'ºC'),
	(111942, 111, '2015-03-15 00:23:15.000000', 'temperatura', 634.0000, 'ºC'),
	(111943, 111, '2015-03-15 00:23:16.000000', 'temperatura', 1124.0000, 'ºC'),
	(111944, 111, '2015-03-15 00:23:17.000000', 'temperatura', 119.0000, 'ºC'),
	(111945, 111, '2015-03-15 00:23:18.000000', 'temperatura', 823.0000, 'ºC'),
	(111946, 111, '2015-03-15 00:23:19.000000', 'temperatura', 158.0000, 'ºC'),
	(111947, 111, '2015-03-15 00:23:20.000000', 'temperatura', 722.0000, 'ºC'),
	(111948, 111, '2015-03-15 00:23:21.000000', 'temperatura', 736.0000, 'ºC'),
	(111949, 111, '2015-03-15 00:23:22.000000', 'temperatura', 316.0000, 'ºC'),
	(111950, 111, '2015-03-15 00:23:23.000000', 'temperatura', 571.0000, 'ºC'),
	(111951, 111, '2015-03-15 00:23:24.000000', 'temperatura', 708.0000, 'ºC'),
	(111952, 111, '2015-03-15 00:23:25.000000', 'temperatura', 628.0000, 'ºC'),
	(111953, 111, '2015-03-15 00:23:26.000000', 'temperatura', 1017.0000, 'ºC'),
	(111954, 111, '2015-03-15 00:23:27.000000', 'temperatura', 800.0000, 'ºC'),
	(111955, 111, '2015-03-15 00:23:28.000000', 'temperatura', 950.0000, 'ºC'),
	(111956, 111, '2015-03-15 00:23:29.000000', 'temperatura', 1152.0000, 'ºC'),
	(111957, 111, '2015-03-15 00:23:30.000000', 'temperatura', 511.0000, 'ºC'),
	(111958, 111, '2015-03-15 00:23:31.000000', 'temperatura', 300.0000, 'ºC'),
	(111959, 111, '2015-03-15 00:23:32.000000', 'temperatura', 1165.0000, 'ºC'),
	(111960, 111, '2015-03-15 00:23:33.000000', 'temperatura', 125.0000, 'ºC'),
	(111961, 111, '2015-03-15 00:23:34.000000', 'temperatura', 730.0000, 'ºC'),
	(111962, 111, '2015-03-15 00:23:35.000000', 'temperatura', 878.0000, 'ºC'),
	(111963, 111, '2015-03-15 00:23:36.000000', 'temperatura', 1000.0000, 'ºC'),
	(111964, 111, '2015-03-15 00:23:37.000000', 'temperatura', 1165.0000, 'ºC'),
	(111965, 111, '2015-03-15 00:23:38.000000', 'temperatura', 426.0000, 'ºC'),
	(111966, 111, '2015-03-15 00:23:39.000000', 'temperatura', 1036.0000, 'ºC'),
	(111967, 111, '2015-03-15 00:23:40.000000', 'temperatura', 300.0000, 'ºC'),
	(111968, 111, '2015-03-15 00:23:41.000000', 'temperatura', 795.0000, 'ºC'),
	(111969, 111, '2015-03-15 00:23:42.000000', 'temperatura', 674.0000, 'ºC'),
	(111970, 111, '2015-03-15 00:23:43.000000', 'temperatura', 987.0000, 'ºC'),
	(111971, 111, '2015-03-15 00:23:44.000000', 'temperatura', 512.0000, 'ºC'),
	(111972, 111, '2015-03-15 00:23:45.000000', 'temperatura', 801.0000, 'ºC'),
	(111973, 111, '2015-03-15 00:23:46.000000', 'temperatura', 71.0000, 'ºC'),
	(111974, 111, '2015-03-15 00:23:47.000000', 'temperatura', 350.0000, 'ºC'),
	(111975, 111, '2015-03-15 00:23:48.000000', 'temperatura', 337.0000, 'ºC'),
	(111976, 111, '2015-03-15 00:23:49.000000', 'temperatura', 634.0000, 'ºC'),
	(111977, 111, '2015-03-15 00:23:50.000000', 'temperatura', 963.0000, 'ºC'),
	(111978, 111, '2015-03-15 00:23:51.000000', 'temperatura', 513.0000, 'ºC'),
	(111979, 111, '2015-03-15 00:23:52.000000', 'temperatura', 877.0000, 'ºC'),
	(111980, 111, '2015-03-15 00:23:53.000000', 'temperatura', 446.0000, 'ºC'),
	(111981, 111, '2015-03-15 00:23:54.000000', 'temperatura', 798.0000, 'ºC'),
	(111982, 111, '2015-03-15 00:23:55.000000', 'temperatura', 254.0000, 'ºC'),
	(111983, 111, '2015-03-15 00:23:56.000000', 'temperatura', 74.0000, 'ºC'),
	(111984, 111, '2015-03-15 00:23:57.000000', 'temperatura', 810.0000, 'ºC'),
	(111985, 111, '2015-03-15 00:23:58.000000', 'temperatura', 230.0000, 'ºC'),
	(111986, 111, '2015-03-15 00:23:59.000000', 'temperatura', 1118.0000, 'ºC'),
	(111987, 111, '2015-03-15 00:24:00.000000', 'temperatura', 100.0000, 'ºC'),
	(111988, 111, '2015-03-15 00:24:01.000000', 'temperatura', 746.0000, 'ºC'),
	(111989, 111, '2015-03-15 00:24:02.000000', 'temperatura', 1032.0000, 'ºC'),
	(111990, 111, '2015-03-15 00:24:03.000000', 'temperatura', 524.0000, 'ºC'),
	(111991, 111, '2015-03-15 00:24:04.000000', 'temperatura', 721.0000, 'ºC'),
	(111992, 111, '2015-03-15 00:24:05.000000', 'temperatura', 837.0000, 'ºC'),
	(111993, 111, '2015-03-15 00:24:06.000000', 'temperatura', 820.0000, 'ºC'),
	(111994, 111, '2015-03-15 00:24:07.000000', 'temperatura', 391.0000, 'ºC'),
	(111995, 111, '2015-03-15 00:24:08.000000', 'temperatura', 694.0000, 'ºC'),
	(111996, 111, '2015-03-15 00:24:09.000000', 'temperatura', 1098.0000, 'ºC'),
	(111997, 111, '2015-03-15 00:24:10.000000', 'temperatura', 1008.0000, 'ºC'),
	(111998, 111, '2015-03-15 00:24:11.000000', 'temperatura', 546.0000, 'ºC'),
	(111999, 111, '2015-03-15 00:24:12.000000', 'temperatura', 907.0000, 'ºC'),
	(112000, 111, '2015-03-15 00:24:13.000000', 'temperatura', 499.0000, 'ºC'),
	(112001, 111, '2015-03-15 00:24:14.000000', 'temperatura', 973.0000, 'ºC'),
	(112002, 111, '2015-03-15 00:24:15.000000', 'temperatura', 971.0000, 'ºC'),
	(112003, 111, '2015-03-15 00:24:16.000000', 'temperatura', 733.0000, 'ºC'),
	(112004, 111, '2015-03-15 00:24:17.000000', 'temperatura', 755.0000, 'ºC'),
	(112005, 111, '2015-03-15 00:24:18.000000', 'temperatura', 377.0000, 'ºC'),
	(112006, 111, '2015-03-15 00:24:19.000000', 'temperatura', 818.0000, 'ºC'),
	(112007, 111, '2015-03-15 00:24:20.000000', 'temperatura', 560.0000, 'ºC'),
	(112008, 111, '2015-03-15 00:24:21.000000', 'temperatura', 348.0000, 'ºC'),
	(112009, 111, '2015-03-15 00:24:22.000000', 'temperatura', 61.0000, 'ºC'),
	(112010, 111, '2015-03-15 00:24:23.000000', 'temperatura', 460.0000, 'ºC'),
	(112011, 111, '2015-03-15 00:24:24.000000', 'temperatura', 917.0000, 'ºC'),
	(112012, 111, '2015-03-15 00:24:25.000000', 'temperatura', 806.0000, 'ºC'),
	(112013, 111, '2015-03-15 00:24:26.000000', 'temperatura', 82.0000, 'ºC'),
	(112014, 111, '2015-03-15 00:24:27.000000', 'temperatura', 389.0000, 'ºC'),
	(112015, 111, '2015-03-15 00:24:28.000000', 'temperatura', 502.0000, 'ºC'),
	(112016, 111, '2015-03-15 00:24:29.000000', 'temperatura', 143.0000, 'ºC'),
	(112017, 111, '2015-03-15 00:24:30.000000', 'temperatura', 408.0000, 'ºC'),
	(112018, 111, '2015-03-15 00:24:31.000000', 'temperatura', 414.0000, 'ºC'),
	(112019, 111, '2015-03-15 00:24:32.000000', 'temperatura', 844.0000, 'ºC'),
	(112020, 111, '2015-03-15 00:24:33.000000', 'temperatura', 579.0000, 'ºC'),
	(112021, 111, '2015-03-15 00:24:34.000000', 'temperatura', 366.0000, 'ºC'),
	(112022, 111, '2015-03-15 00:24:35.000000', 'temperatura', 91.0000, 'ºC'),
	(112023, 111, '2015-03-15 00:24:36.000000', 'temperatura', 557.0000, 'ºC'),
	(112024, 111, '2015-03-15 00:24:37.000000', 'temperatura', 114.0000, 'ºC'),
	(112025, 111, '2015-03-15 00:24:38.000000', 'temperatura', 101.0000, 'ºC'),
	(112026, 111, '2015-03-15 00:24:39.000000', 'temperatura', 161.0000, 'ºC'),
	(112027, 111, '2015-03-15 00:24:40.000000', 'temperatura', 502.0000, 'ºC'),
	(112028, 111, '2015-03-15 00:24:41.000000', 'temperatura', 830.0000, 'ºC'),
	(112029, 111, '2015-03-15 00:24:42.000000', 'temperatura', 242.0000, 'ºC'),
	(112030, 111, '2015-03-15 00:24:43.000000', 'temperatura', 1120.0000, 'ºC'),
	(112031, 111, '2015-03-15 00:24:44.000000', 'temperatura', 75.0000, 'ºC'),
	(112032, 111, '2015-03-15 00:24:45.000000', 'temperatura', 615.0000, 'ºC'),
	(112033, 111, '2015-03-15 00:24:46.000000', 'temperatura', 451.0000, 'ºC'),
	(112034, 111, '2015-03-15 00:24:47.000000', 'temperatura', 410.0000, 'ºC'),
	(112035, 111, '2015-03-15 00:24:48.000000', 'temperatura', 697.0000, 'ºC'),
	(112036, 111, '2015-03-15 00:24:49.000000', 'temperatura', 1056.0000, 'ºC'),
	(112037, 111, '2015-03-15 00:24:50.000000', 'temperatura', 789.0000, 'ºC'),
	(112038, 111, '2015-03-15 00:24:51.000000', 'temperatura', 777.0000, 'ºC'),
	(112039, 111, '2015-03-15 00:24:52.000000', 'temperatura', 320.0000, 'ºC'),
	(112040, 111, '2015-03-15 00:24:53.000000', 'temperatura', 468.0000, 'ºC'),
	(112041, 111, '2015-03-15 00:24:54.000000', 'temperatura', 180.0000, 'ºC'),
	(112042, 111, '2015-03-15 00:24:55.000000', 'temperatura', 696.0000, 'ºC'),
	(112043, 111, '2015-03-15 00:24:56.000000', 'temperatura', 543.0000, 'ºC'),
	(112044, 111, '2015-03-15 00:24:57.000000', 'temperatura', 628.0000, 'ºC'),
	(112045, 111, '2015-03-15 00:24:58.000000', 'temperatura', 312.0000, 'ºC'),
	(112046, 111, '2015-03-15 00:24:59.000000', 'temperatura', 876.0000, 'ºC'),
	(112047, 111, '2015-03-15 00:25:00.000000', 'temperatura', 1046.0000, 'ºC'),
	(112048, 111, '2015-03-15 00:25:01.000000', 'temperatura', 200.0000, 'ºC'),
	(112049, 111, '2015-03-15 00:25:02.000000', 'temperatura', 263.0000, 'ºC'),
	(112050, 111, '2015-03-15 00:25:03.000000', 'temperatura', 714.0000, 'ºC'),
	(112051, 111, '2015-03-15 00:25:04.000000', 'temperatura', 381.0000, 'ºC'),
	(112052, 111, '2015-03-15 00:25:05.000000', 'temperatura', 967.0000, 'ºC'),
	(112053, 111, '2015-03-15 00:25:06.000000', 'temperatura', 90.0000, 'ºC'),
	(112054, 111, '2015-03-15 00:25:07.000000', 'temperatura', 1150.0000, 'ºC'),
	(112055, 111, '2015-03-15 00:25:08.000000', 'temperatura', 679.0000, 'ºC'),
	(112056, 111, '2015-03-15 00:25:09.000000', 'temperatura', 1145.0000, 'ºC'),
	(112057, 111, '2015-03-15 00:25:10.000000', 'temperatura', 91.0000, 'ºC'),
	(112058, 111, '2015-03-15 00:25:11.000000', 'temperatura', 620.0000, 'ºC'),
	(112059, 111, '2015-03-15 00:25:12.000000', 'temperatura', 427.0000, 'ºC'),
	(112060, 111, '2015-03-15 00:25:13.000000', 'temperatura', 275.0000, 'ºC'),
	(112061, 111, '2015-03-15 00:25:14.000000', 'temperatura', 96.0000, 'ºC'),
	(112062, 111, '2015-03-15 00:25:15.000000', 'temperatura', 853.0000, 'ºC'),
	(112063, 111, '2015-03-15 00:25:16.000000', 'temperatura', 378.0000, 'ºC'),
	(112064, 111, '2015-03-15 00:25:17.000000', 'temperatura', 531.0000, 'ºC'),
	(112065, 111, '2015-03-15 00:25:18.000000', 'temperatura', 323.0000, 'ºC'),
	(112066, 111, '2015-03-15 00:25:19.000000', 'temperatura', 22.0000, 'ºC'),
	(112067, 111, '2015-03-15 00:25:20.000000', 'temperatura', 340.0000, 'ºC'),
	(112068, 111, '2015-03-15 00:25:21.000000', 'temperatura', 437.0000, 'ºC'),
	(112069, 111, '2015-03-15 00:25:22.000000', 'temperatura', 1164.0000, 'ºC'),
	(112070, 111, '2015-03-15 00:25:23.000000', 'temperatura', 909.0000, 'ºC'),
	(112071, 111, '2015-03-15 00:25:24.000000', 'temperatura', 1053.0000, 'ºC'),
	(112072, 111, '2015-03-15 00:25:25.000000', 'temperatura', 141.0000, 'ºC'),
	(112073, 111, '2015-03-15 00:25:26.000000', 'temperatura', 1145.0000, 'ºC'),
	(112074, 111, '2015-03-15 00:25:27.000000', 'temperatura', 501.0000, 'ºC'),
	(112075, 111, '2015-03-15 00:25:28.000000', 'temperatura', 271.0000, 'ºC'),
	(112076, 111, '2015-03-15 00:25:29.000000', 'temperatura', 1053.0000, 'ºC'),
	(112077, 111, '2015-03-15 00:25:30.000000', 'temperatura', 854.0000, 'ºC'),
	(112078, 111, '2015-03-15 00:25:31.000000', 'temperatura', 1110.0000, 'ºC'),
	(112079, 111, '2015-03-15 00:25:32.000000', 'temperatura', 590.0000, 'ºC'),
	(112080, 111, '2015-03-15 00:25:33.000000', 'temperatura', 820.0000, 'ºC'),
	(112081, 111, '2015-03-15 00:25:34.000000', 'temperatura', 1130.0000, 'ºC'),
	(112082, 111, '2015-03-15 00:25:35.000000', 'temperatura', 793.0000, 'ºC'),
	(112083, 111, '2015-03-15 00:25:36.000000', 'temperatura', 573.0000, 'ºC'),
	(112084, 111, '2015-03-15 00:25:37.000000', 'temperatura', 487.0000, 'ºC'),
	(112085, 111, '2015-03-15 00:25:38.000000', 'temperatura', 719.0000, 'ºC'),
	(112086, 111, '2015-03-15 00:25:39.000000', 'temperatura', 932.0000, 'ºC'),
	(112087, 111, '2015-03-15 00:25:40.000000', 'temperatura', 102.0000, 'ºC'),
	(112088, 111, '2015-03-15 00:25:41.000000', 'temperatura', 116.0000, 'ºC'),
	(112089, 111, '2015-03-15 00:25:42.000000', 'temperatura', 273.0000, 'ºC'),
	(112090, 111, '2015-03-15 00:25:43.000000', 'temperatura', 1019.0000, 'ºC'),
	(112091, 111, '2015-03-15 00:25:44.000000', 'temperatura', 675.0000, 'ºC'),
	(112092, 111, '2015-03-15 00:25:45.000000', 'temperatura', 321.0000, 'ºC'),
	(112093, 111, '2015-03-15 00:25:46.000000', 'temperatura', 780.0000, 'ºC'),
	(112094, 111, '2015-03-15 00:25:47.000000', 'temperatura', 539.0000, 'ºC'),
	(112095, 111, '2015-03-15 00:25:48.000000', 'temperatura', 354.0000, 'ºC'),
	(112096, 111, '2015-03-15 00:25:49.000000', 'temperatura', 155.0000, 'ºC'),
	(112097, 111, '2015-03-15 00:25:50.000000', 'temperatura', 912.0000, 'ºC'),
	(112098, 111, '2015-03-15 00:25:51.000000', 'temperatura', 497.0000, 'ºC'),
	(112099, 111, '2015-03-15 00:25:52.000000', 'temperatura', 948.0000, 'ºC'),
	(112100, 111, '2015-03-15 00:25:53.000000', 'temperatura', 852.0000, 'ºC'),
	(112101, 111, '2015-03-15 00:25:54.000000', 'temperatura', 214.0000, 'ºC'),
	(112102, 111, '2015-03-15 00:25:55.000000', 'temperatura', 916.0000, 'ºC'),
	(112103, 111, '2015-03-15 00:25:56.000000', 'temperatura', 340.0000, 'ºC'),
	(112104, 111, '2015-03-15 00:25:57.000000', 'temperatura', 149.0000, 'ºC'),
	(112105, 111, '2015-03-15 00:25:58.000000', 'temperatura', 929.0000, 'ºC'),
	(112106, 111, '2015-03-15 00:25:59.000000', 'temperatura', 596.0000, 'ºC'),
	(112107, 111, '2015-03-15 00:26:00.000000', 'temperatura', 193.0000, 'ºC'),
	(112108, 111, '2015-03-15 00:26:01.000000', 'temperatura', 379.0000, 'ºC'),
	(112109, 111, '2015-03-15 00:26:02.000000', 'temperatura', 117.0000, 'ºC'),
	(112110, 111, '2015-03-15 00:26:03.000000', 'temperatura', 648.0000, 'ºC'),
	(112111, 111, '2015-03-15 00:26:04.000000', 'temperatura', 489.0000, 'ºC'),
	(112112, 111, '2015-03-15 00:26:05.000000', 'temperatura', 504.0000, 'ºC'),
	(112113, 111, '2015-03-15 00:26:06.000000', 'temperatura', 1052.0000, 'ºC'),
	(112114, 111, '2015-03-15 00:26:07.000000', 'temperatura', 147.0000, 'ºC'),
	(112115, 111, '2015-03-15 00:26:08.000000', 'temperatura', 1180.0000, 'ºC'),
	(112116, 111, '2015-03-15 00:26:09.000000', 'temperatura', 659.0000, 'ºC'),
	(112117, 111, '2015-03-15 00:26:10.000000', 'temperatura', 957.0000, 'ºC'),
	(112118, 111, '2015-03-15 00:26:11.000000', 'temperatura', 407.0000, 'ºC'),
	(112119, 111, '2015-03-15 00:26:12.000000', 'temperatura', 363.0000, 'ºC'),
	(112120, 111, '2015-03-15 00:26:13.000000', 'temperatura', 597.0000, 'ºC'),
	(112121, 111, '2015-03-15 00:26:14.000000', 'temperatura', 694.0000, 'ºC'),
	(112122, 111, '2015-03-15 00:26:15.000000', 'temperatura', 483.0000, 'ºC'),
	(112123, 111, '2015-03-15 00:26:16.000000', 'temperatura', 330.0000, 'ºC'),
	(112124, 111, '2015-03-15 00:26:17.000000', 'temperatura', 203.0000, 'ºC'),
	(112125, 111, '2015-03-15 00:26:18.000000', 'temperatura', 26.0000, 'ºC'),
	(112126, 111, '2015-03-15 00:26:19.000000', 'temperatura', 720.0000, 'ºC'),
	(112127, 111, '2015-03-15 00:26:20.000000', 'temperatura', 1124.0000, 'ºC'),
	(112128, 111, '2015-03-15 00:26:21.000000', 'temperatura', 1061.0000, 'ºC'),
	(112129, 111, '2015-03-15 00:26:22.000000', 'temperatura', 733.0000, 'ºC'),
	(112130, 111, '2015-03-15 00:26:23.000000', 'temperatura', 483.0000, 'ºC'),
	(112131, 111, '2015-03-15 00:26:24.000000', 'temperatura', 216.0000, 'ºC'),
	(112132, 111, '2015-03-15 00:26:25.000000', 'temperatura', 833.0000, 'ºC'),
	(112133, 111, '2015-03-15 00:26:26.000000', 'temperatura', 1116.0000, 'ºC'),
	(112134, 111, '2015-03-15 00:26:27.000000', 'temperatura', 683.0000, 'ºC'),
	(112135, 111, '2015-03-15 00:26:28.000000', 'temperatura', 67.0000, 'ºC'),
	(112136, 111, '2015-03-15 00:26:29.000000', 'temperatura', 688.0000, 'ºC'),
	(112137, 111, '2015-03-15 00:26:30.000000', 'temperatura', 837.0000, 'ºC'),
	(112138, 111, '2015-03-15 00:26:31.000000', 'temperatura', 921.0000, 'ºC'),
	(112139, 111, '2015-03-15 00:26:32.000000', 'temperatura', 893.0000, 'ºC'),
	(112140, 111, '2015-03-15 00:26:33.000000', 'temperatura', 506.0000, 'ºC'),
	(112141, 111, '2015-03-15 00:26:34.000000', 'temperatura', 1051.0000, 'ºC'),
	(112142, 111, '2015-03-15 00:26:35.000000', 'temperatura', 138.0000, 'ºC'),
	(112143, 111, '2015-03-15 00:26:36.000000', 'temperatura', 1136.0000, 'ºC'),
	(112144, 111, '2015-03-15 00:26:37.000000', 'temperatura', 467.0000, 'ºC'),
	(112145, 111, '2015-03-15 00:26:38.000000', 'temperatura', 128.0000, 'ºC'),
	(112146, 111, '2015-03-15 00:26:39.000000', 'temperatura', 437.0000, 'ºC'),
	(112147, 111, '2015-03-15 00:26:40.000000', 'temperatura', 605.0000, 'ºC'),
	(112148, 111, '2015-03-15 00:26:41.000000', 'temperatura', 513.0000, 'ºC'),
	(112149, 111, '2015-03-15 00:26:42.000000', 'temperatura', 751.0000, 'ºC'),
	(112150, 111, '2015-03-15 00:26:43.000000', 'temperatura', 1016.0000, 'ºC'),
	(112151, 111, '2015-03-15 00:26:44.000000', 'temperatura', 428.0000, 'ºC'),
	(112152, 111, '2015-03-15 00:26:45.000000', 'temperatura', 293.0000, 'ºC'),
	(112153, 111, '2015-03-15 00:26:46.000000', 'temperatura', 182.0000, 'ºC'),
	(112154, 111, '2015-03-15 00:26:47.000000', 'temperatura', 29.0000, 'ºC'),
	(112155, 111, '2015-03-15 00:26:48.000000', 'temperatura', 801.0000, 'ºC'),
	(112156, 111, '2015-03-15 00:26:49.000000', 'temperatura', 317.0000, 'ºC'),
	(112157, 111, '2015-03-15 00:26:50.000000', 'temperatura', 382.0000, 'ºC'),
	(112158, 111, '2015-03-15 00:26:51.000000', 'temperatura', 958.0000, 'ºC'),
	(112159, 111, '2015-03-15 00:26:52.000000', 'temperatura', 48.0000, 'ºC'),
	(112160, 111, '2015-03-15 00:26:53.000000', 'temperatura', 966.0000, 'ºC'),
	(112161, 111, '2015-03-15 00:26:54.000000', 'temperatura', 1088.0000, 'ºC'),
	(112162, 111, '2015-03-15 00:26:55.000000', 'temperatura', 141.0000, 'ºC'),
	(112163, 111, '2015-03-15 00:26:56.000000', 'temperatura', 1041.0000, 'ºC'),
	(112164, 111, '2015-03-15 00:26:57.000000', 'temperatura', 1182.0000, 'ºC'),
	(112165, 111, '2015-03-15 00:26:58.000000', 'temperatura', 390.0000, 'ºC'),
	(112166, 111, '2015-03-15 00:26:59.000000', 'temperatura', 801.0000, 'ºC'),
	(112167, 111, '2015-03-15 00:27:00.000000', 'temperatura', 438.0000, 'ºC'),
	(112168, 111, '2015-03-15 00:27:01.000000', 'temperatura', 986.0000, 'ºC'),
	(112169, 111, '2015-03-15 00:27:02.000000', 'temperatura', 17.0000, 'ºC'),
	(112170, 111, '2015-03-15 00:27:03.000000', 'temperatura', 728.0000, 'ºC'),
	(112171, 111, '2015-03-15 00:27:04.000000', 'temperatura', 1190.0000, 'ºC'),
	(112172, 111, '2015-03-15 00:27:05.000000', 'temperatura', 168.0000, 'ºC'),
	(112173, 111, '2015-03-15 00:27:06.000000', 'temperatura', 867.0000, 'ºC'),
	(112174, 111, '2015-03-15 00:27:07.000000', 'temperatura', 234.0000, 'ºC'),
	(112175, 111, '2015-03-15 00:27:08.000000', 'temperatura', 967.0000, 'ºC'),
	(112176, 111, '2015-03-15 00:27:09.000000', 'temperatura', 534.0000, 'ºC'),
	(112177, 111, '2015-03-15 00:27:10.000000', 'temperatura', 972.0000, 'ºC'),
	(112178, 111, '2015-03-15 00:27:11.000000', 'temperatura', 858.0000, 'ºC'),
	(112179, 111, '2015-03-15 00:27:12.000000', 'temperatura', 173.0000, 'ºC'),
	(112180, 111, '2015-03-15 00:27:13.000000', 'temperatura', 690.0000, 'ºC'),
	(112181, 111, '2015-03-15 00:27:14.000000', 'temperatura', 535.0000, 'ºC'),
	(112182, 111, '2015-03-15 00:27:15.000000', 'temperatura', 603.0000, 'ºC'),
	(112183, 111, '2015-03-15 00:27:16.000000', 'temperatura', 212.0000, 'ºC'),
	(112184, 111, '2015-03-15 00:27:17.000000', 'temperatura', 450.0000, 'ºC'),
	(112185, 111, '2015-03-15 00:27:18.000000', 'temperatura', 415.0000, 'ºC'),
	(112186, 111, '2015-03-15 00:27:19.000000', 'temperatura', 726.0000, 'ºC'),
	(112187, 111, '2015-03-15 00:27:20.000000', 'temperatura', 1187.0000, 'ºC'),
	(112188, 111, '2015-03-15 00:27:21.000000', 'temperatura', 157.0000, 'ºC'),
	(112189, 111, '2015-03-15 00:27:22.000000', 'temperatura', 824.0000, 'ºC'),
	(112190, 111, '2015-03-15 00:27:23.000000', 'temperatura', 51.0000, 'ºC'),
	(112191, 111, '2015-03-15 00:27:24.000000', 'temperatura', 184.0000, 'ºC'),
	(112192, 111, '2015-03-15 00:27:25.000000', 'temperatura', 769.0000, 'ºC'),
	(112193, 111, '2015-03-15 00:27:26.000000', 'temperatura', 890.0000, 'ºC'),
	(112194, 111, '2015-03-15 00:27:27.000000', 'temperatura', 944.0000, 'ºC'),
	(112195, 111, '2015-03-15 00:27:28.000000', 'temperatura', 851.0000, 'ºC'),
	(112196, 111, '2015-03-15 00:27:29.000000', 'temperatura', 222.0000, 'ºC'),
	(112197, 111, '2015-03-15 00:27:30.000000', 'temperatura', 959.0000, 'ºC'),
	(112198, 111, '2015-03-15 00:27:31.000000', 'temperatura', 530.0000, 'ºC'),
	(112199, 111, '2015-03-15 00:27:32.000000', 'temperatura', 971.0000, 'ºC'),
	(112200, 111, '2015-03-15 00:27:33.000000', 'temperatura', 867.0000, 'ºC'),
	(112201, 111, '2015-03-15 00:27:34.000000', 'temperatura', 221.0000, 'ºC'),
	(112202, 111, '2015-03-15 00:27:35.000000', 'temperatura', 905.0000, 'ºC'),
	(112203, 111, '2015-03-15 00:27:36.000000', 'temperatura', 261.0000, 'ºC'),
	(112204, 111, '2015-03-15 00:27:37.000000', 'temperatura', 990.0000, 'ºC'),
	(112205, 111, '2015-03-15 00:27:38.000000', 'temperatura', 571.0000, 'ºC'),
	(112206, 111, '2015-03-15 00:27:39.000000', 'temperatura', 1083.0000, 'ºC'),
	(112207, 111, '2015-03-15 00:27:40.000000', 'temperatura', 104.0000, 'ºC'),
	(112208, 111, '2015-03-15 00:27:41.000000', 'temperatura', 869.0000, 'ºC'),
	(112209, 111, '2015-03-15 00:27:42.000000', 'temperatura', 434.0000, 'ºC'),
	(112210, 111, '2015-03-15 00:27:43.000000', 'temperatura', 766.0000, 'ºC'),
	(112211, 111, '2015-03-15 00:27:44.000000', 'temperatura', 127.0000, 'ºC'),
	(112212, 111, '2015-03-15 00:27:45.000000', 'temperatura', 739.0000, 'ºC'),
	(112213, 111, '2015-03-15 00:27:46.000000', 'temperatura', 915.0000, 'ºC'),
	(112214, 111, '2015-03-15 00:27:47.000000', 'temperatura', 1157.0000, 'ºC'),
	(112215, 111, '2015-03-15 00:27:48.000000', 'temperatura', 641.0000, 'ºC'),
	(112216, 111, '2015-03-15 00:27:49.000000', 'temperatura', 936.0000, 'ºC'),
	(112217, 111, '2015-03-15 00:27:50.000000', 'temperatura', 357.0000, 'ºC'),
	(112218, 111, '2015-03-15 00:27:51.000000', 'temperatura', 175.0000, 'ºC'),
	(112219, 111, '2015-03-15 00:27:52.000000', 'temperatura', 1007.0000, 'ºC'),
	(112220, 111, '2015-03-15 00:27:53.000000', 'temperatura', 910.0000, 'ºC'),
	(112221, 111, '2015-03-15 00:27:54.000000', 'temperatura', 328.0000, 'ºC'),
	(112222, 111, '2015-03-15 00:27:55.000000', 'temperatura', 109.0000, 'ºC'),
	(112223, 111, '2015-03-15 00:27:56.000000', 'temperatura', 765.0000, 'ºC'),
	(112224, 111, '2015-03-15 00:27:57.000000', 'temperatura', 1096.0000, 'ºC'),
	(112225, 111, '2015-03-15 00:27:58.000000', 'temperatura', 788.0000, 'ºC'),
	(112226, 111, '2015-03-15 00:27:59.000000', 'temperatura', 651.0000, 'ºC'),
	(112227, 111, '2015-03-15 00:28:00.000000', 'temperatura', 890.0000, 'ºC'),
	(112228, 111, '2015-03-15 00:28:01.000000', 'temperatura', 100.0000, 'ºC'),
	(112229, 111, '2015-03-15 00:28:02.000000', 'temperatura', 231.0000, 'ºC'),
	(112230, 111, '2015-03-15 00:28:03.000000', 'temperatura', 854.0000, 'ºC'),
	(112231, 111, '2015-03-15 00:28:04.000000', 'temperatura', 1178.0000, 'ºC'),
	(112232, 111, '2015-03-15 00:28:05.000000', 'temperatura', 928.0000, 'ºC'),
	(112233, 111, '2015-03-15 00:28:06.000000', 'temperatura', 1105.0000, 'ºC'),
	(112234, 111, '2015-03-15 00:28:07.000000', 'temperatura', 343.0000, 'ºC'),
	(112235, 111, '2015-03-15 00:28:08.000000', 'temperatura', 802.0000, 'ºC'),
	(112236, 111, '2015-03-15 00:28:09.000000', 'temperatura', 582.0000, 'ºC'),
	(112237, 111, '2015-03-15 00:28:10.000000', 'temperatura', 504.0000, 'ºC'),
	(112238, 111, '2015-03-15 00:28:11.000000', 'temperatura', 775.0000, 'ºC'),
	(112239, 111, '2015-03-15 00:28:12.000000', 'temperatura', 1164.0000, 'ºC'),
	(112240, 111, '2015-03-15 00:28:13.000000', 'temperatura', 1095.0000, 'ºC'),
	(112241, 111, '2015-03-15 00:28:14.000000', 'temperatura', 784.0000, 'ºC'),
	(112242, 111, '2015-03-15 00:28:15.000000', 'temperatura', 636.0000, 'ºC'),
	(112243, 111, '2015-03-15 00:28:16.000000', 'temperatura', 827.0000, 'ºC'),
	(112244, 111, '2015-03-15 00:28:17.000000', 'temperatura', 1030.0000, 'ºC'),
	(112245, 111, '2015-03-15 00:28:18.000000', 'temperatura', 266.0000, 'ºC'),
	(112246, 111, '2015-03-15 00:28:19.000000', 'temperatura', 643.0000, 'ºC'),
	(112247, 111, '2015-03-15 00:28:20.000000', 'temperatura', 17.0000, 'ºC'),
	(112248, 111, '2015-03-15 00:28:21.000000', 'temperatura', 557.0000, 'ºC'),
	(112249, 111, '2015-03-15 00:28:22.000000', 'temperatura', 334.0000, 'ºC'),
	(112250, 111, '2015-03-15 00:28:23.000000', 'temperatura', 1199.0000, 'ºC'),
	(112251, 111, '2015-03-15 00:28:24.000000', 'temperatura', 194.0000, 'ºC'),
	(112252, 111, '2015-03-15 00:28:25.000000', 'temperatura', 975.0000, 'ºC'),
	(112253, 111, '2015-03-15 00:28:26.000000', 'temperatura', 691.0000, 'ºC'),
	(112254, 111, '2015-03-15 00:28:27.000000', 'temperatura', 531.0000, 'ºC'),
	(112255, 111, '2015-03-15 00:28:28.000000', 'temperatura', 584.0000, 'ºC'),
	(112256, 111, '2015-03-15 00:28:29.000000', 'temperatura', 127.0000, 'ºC'),
	(112257, 111, '2015-03-15 00:28:30.000000', 'temperatura', 85.0000, 'ºC'),
	(112258, 111, '2015-03-15 00:28:31.000000', 'temperatura', 45.0000, 'ºC'),
	(112259, 111, '2015-03-15 00:28:32.000000', 'temperatura', 1168.0000, 'ºC'),
	(112260, 111, '2015-03-15 00:28:33.000000', 'temperatura', 907.0000, 'ºC'),
	(112261, 111, '2015-03-15 00:28:34.000000', 'temperatura', 1030.0000, 'ºC'),
	(112262, 111, '2015-03-15 00:28:35.000000', 'temperatura', 28.0000, 'ºC'),
	(112263, 111, '2015-03-15 00:28:36.000000', 'temperatura', 653.0000, 'ºC'),
	(112264, 111, '2015-03-15 00:28:37.000000', 'temperatura', 783.0000, 'ºC'),
	(112265, 111, '2015-03-15 00:28:38.000000', 'temperatura', 753.0000, 'ºC'),
	(112266, 111, '2015-03-15 00:28:39.000000', 'temperatura', 218.0000, 'ºC'),
	(112267, 111, '2015-03-15 00:28:40.000000', 'temperatura', 32.0000, 'ºC'),
	(112268, 111, '2015-03-15 00:28:41.000000', 'temperatura', 705.0000, 'ºC'),
	(112269, 111, '2015-03-15 00:28:42.000000', 'temperatura', 1032.0000, 'ºC'),
	(112270, 111, '2015-03-15 00:28:43.000000', 'temperatura', 646.0000, 'ºC'),
	(112271, 111, '2015-03-15 00:28:44.000000', 'temperatura', 133.0000, 'ºC'),
	(112272, 111, '2015-03-15 00:28:45.000000', 'temperatura', 1128.0000, 'ºC'),
	(112273, 111, '2015-03-15 00:28:46.000000', 'temperatura', 443.0000, 'ºC'),
	(112274, 111, '2015-03-15 00:28:47.000000', 'temperatura', 31.0000, 'ºC'),
	(112275, 111, '2015-03-15 00:28:48.000000', 'temperatura', 28.0000, 'ºC'),
	(112276, 111, '2015-03-15 00:28:49.000000', 'temperatura', 45.0000, 'ºC'),
	(112277, 111, '2015-03-15 00:28:50.000000', 'temperatura', 141.0000, 'ºC'),
	(112278, 111, '2015-03-15 00:28:51.000000', 'temperatura', 571.0000, 'ºC'),
	(112279, 111, '2015-03-15 00:28:52.000000', 'temperatura', 32.0000, 'ºC'),
	(112280, 111, '2015-03-15 00:28:53.000000', 'temperatura', 848.0000, 'ºC'),
	(112281, 111, '2015-03-15 00:28:54.000000', 'temperatura', 543.0000, 'ºC'),
	(112282, 111, '2015-03-15 00:28:55.000000', 'temperatura', 171.0000, 'ºC'),
	(112283, 111, '2015-03-15 00:28:56.000000', 'temperatura', 427.0000, 'ºC'),
	(112284, 111, '2015-03-15 00:28:57.000000', 'temperatura', 421.0000, 'ºC'),
	(112285, 111, '2015-03-15 00:28:58.000000', 'temperatura', 826.0000, 'ºC'),
	(112286, 111, '2015-03-15 00:28:59.000000', 'temperatura', 468.0000, 'ºC'),
	(112287, 111, '2015-03-15 00:29:00.000000', 'temperatura', 1061.0000, 'ºC'),
	(112288, 111, '2015-03-15 00:29:01.000000', 'temperatura', 300.0000, 'ºC'),
	(112289, 111, '2015-03-15 00:29:02.000000', 'temperatura', 721.0000, 'ºC'),
	(112290, 111, '2015-03-15 00:29:03.000000', 'temperatura', 304.0000, 'ºC'),
	(112291, 111, '2015-03-15 00:29:04.000000', 'temperatura', 560.0000, 'ºC'),
	(112292, 111, '2015-03-15 00:29:05.000000', 'temperatura', 685.0000, 'ºC'),
	(112293, 111, '2015-03-15 00:29:06.000000', 'temperatura', 546.0000, 'ºC'),
	(112294, 111, '2015-03-15 00:29:07.000000', 'temperatura', 677.0000, 'ºC'),
	(112295, 111, '2015-03-15 00:29:08.000000', 'temperatura', 547.0000, 'ºC'),
	(112296, 111, '2015-03-15 00:29:09.000000', 'temperatura', 705.0000, 'ºC'),
	(112297, 111, '2015-03-15 00:29:10.000000', 'temperatura', 686.0000, 'ºC'),
	(112298, 111, '2015-03-15 00:29:11.000000', 'temperatura', 114.0000, 'ºC'),
	(112299, 111, '2015-03-15 00:29:12.000000', 'temperatura', 914.0000, 'ºC'),
	(112300, 111, '2015-03-15 00:29:13.000000', 'temperatura', 626.0000, 'ºC'),
	(112301, 111, '2015-03-15 00:29:14.000000', 'temperatura', 391.0000, 'ºC'),
	(112302, 111, '2015-03-15 00:29:15.000000', 'temperatura', 74.0000, 'ºC'),
	(112303, 111, '2015-03-15 00:29:16.000000', 'temperatura', 401.0000, 'ºC'),
	(112304, 111, '2015-03-15 00:29:17.000000', 'temperatura', 582.0000, 'ºC'),
	(112305, 111, '2015-03-15 00:29:18.000000', 'temperatura', 507.0000, 'ºC'),
	(112306, 111, '2015-03-15 00:29:19.000000', 'temperatura', 790.0000, 'ºC'),
	(112307, 111, '2015-03-15 00:29:20.000000', 'temperatura', 28.0000, 'ºC'),
	(112308, 111, '2015-03-15 00:29:21.000000', 'temperatura', 171.0000, 'ºC'),
	(112309, 111, '2015-03-15 00:29:22.000000', 'temperatura', 773.0000, 'ºC'),
	(112310, 111, '2015-03-15 00:29:23.000000', 'temperatura', 950.0000, 'ºC'),
	(112311, 111, '2015-03-15 00:29:24.000000', 'temperatura', 31.0000, 'ºC'),
	(112312, 111, '2015-03-15 00:29:25.000000', 'temperatura', 909.0000, 'ºC'),
	(112313, 111, '2015-03-15 00:29:26.000000', 'temperatura', 850.0000, 'ºC'),
	(112314, 111, '2015-03-15 00:29:27.000000', 'temperatura', 325.0000, 'ºC'),
	(112315, 111, '2015-03-15 00:29:28.000000', 'temperatura', 274.0000, 'ºC'),
	(112316, 111, '2015-03-15 00:29:29.000000', 'temperatura', 395.0000, 'ºC'),
	(112317, 111, '2015-03-15 00:29:30.000000', 'temperatura', 1154.0000, 'ºC'),
	(112318, 111, '2015-03-15 00:29:31.000000', 'temperatura', 984.0000, 'ºC'),
	(112319, 111, '2015-03-15 00:29:32.000000', 'temperatura', 259.0000, 'ºC'),
	(112320, 111, '2015-03-15 00:29:33.000000', 'temperatura', 743.0000, 'ºC'),
	(112321, 111, '2015-03-15 00:29:34.000000', 'temperatura', 537.0000, 'ºC'),
	(112322, 111, '2015-03-15 00:29:35.000000', 'temperatura', 459.0000, 'ºC'),
	(112323, 111, '2015-03-15 00:29:36.000000', 'temperatura', 683.0000, 'ºC'),
	(112324, 111, '2015-03-15 00:29:37.000000', 'temperatura', 840.0000, 'ºC'),
	(112325, 111, '2015-03-15 00:29:38.000000', 'temperatura', 951.0000, 'ºC'),
	(112326, 111, '2015-03-15 00:29:39.000000', 'temperatura', 1037.0000, 'ºC'),
	(112327, 111, '2015-03-15 00:29:40.000000', 'temperatura', 1131.0000, 'ºC'),
	(112328, 111, '2015-03-15 00:29:41.000000', 'temperatura', 146.0000, 'ºC'),
	(112329, 111, '2015-03-15 00:29:42.000000', 'temperatura', 937.0000, 'ºC'),
	(112330, 111, '2015-03-15 00:29:43.000000', 'temperatura', 645.0000, 'ºC'),
	(112331, 111, '2015-03-15 00:29:44.000000', 'temperatura', 417.0000, 'ºC'),
	(112332, 111, '2015-03-15 00:29:45.000000', 'temperatura', 149.0000, 'ºC'),
	(112333, 111, '2015-03-15 00:29:46.000000', 'temperatura', 696.0000, 'ºC'),
	(112334, 111, '2015-03-15 00:29:47.000000', 'temperatura', 633.0000, 'ºC'),
	(112335, 111, '2015-03-15 00:29:48.000000', 'temperatura', 1075.0000, 'ºC'),
	(112336, 111, '2015-03-15 00:29:49.000000', 'temperatura', 1080.0000, 'ºC'),
	(112337, 111, '2015-03-15 00:29:50.000000', 'temperatura', 975.0000, 'ºC'),
	(112338, 111, '2015-03-15 00:29:51.000000', 'temperatura', 436.0000, 'ºC'),
	(112339, 111, '2015-03-15 00:29:52.000000', 'temperatura', 453.0000, 'ºC'),
	(112340, 111, '2015-03-15 00:29:53.000000', 'temperatura', 958.0000, 'ºC'),
	(112341, 111, '2015-03-15 00:29:54.000000', 'temperatura', 1032.0000, 'ºC'),
	(112342, 111, '2015-03-15 00:29:55.000000', 'temperatura', 1087.0000, 'ºC'),
	(112343, 111, '2015-03-15 00:29:56.000000', 'temperatura', 1139.0000, 'ºC'),
	(112344, 111, '2015-03-15 00:29:57.000000', 'temperatura', 35.0000, 'ºC'),
	(112345, 111, '2015-03-15 00:29:58.000000', 'temperatura', 360.0000, 'ºC'),
	(112346, 111, '2015-03-15 00:29:59.000000', 'temperatura', 493.0000, 'ºC'),
	(112347, 111, '2015-03-15 00:30:00.000000', 'temperatura', 188.0000, 'ºC'),
	(112348, 111, '2015-03-15 00:30:01.000000', 'temperatura', 662.0000, 'ºC'),
	(112349, 111, '2015-03-15 00:30:02.000000', 'temperatura', 347.0000, 'ºC'),
	(112350, 111, '2015-03-15 00:30:03.000000', 'temperatura', 948.0000, 'ºC'),
	(112351, 111, '2015-03-15 00:30:04.000000', 'temperatura', 100.0000, 'ºC'),
	(112352, 111, '2015-03-15 00:30:05.000000', 'temperatura', 58.0000, 'ºC'),
	(112353, 111, '2015-03-15 00:30:06.000000', 'temperatura', 1189.0000, 'ºC'),
	(112354, 111, '2015-03-15 00:30:07.000000', 'temperatura', 973.0000, 'ºC'),
	(112355, 111, '2015-03-15 00:30:08.000000', 'temperatura', 96.0000, 'ºC'),
	(112356, 111, '2015-03-15 00:30:09.000000', 'temperatura', 1162.0000, 'ºC'),
	(112357, 111, '2015-03-15 00:30:10.000000', 'temperatura', 722.0000, 'ºC'),
	(112358, 111, '2015-03-15 00:30:11.000000', 'temperatura', 124.0000, 'ºC'),
	(112359, 111, '2015-03-15 00:30:12.000000', 'temperatura', 853.0000, 'ºC'),
	(112360, 111, '2015-03-15 00:30:13.000000', 'temperatura', 296.0000, 'ºC'),
	(112361, 111, '2015-03-15 00:30:14.000000', 'temperatura', 120.0000, 'ºC'),
	(112362, 111, '2015-03-15 00:30:15.000000', 'temperatura', 913.0000, 'ºC'),
	(112363, 111, '2015-03-15 00:30:16.000000', 'temperatura', 607.0000, 'ºC'),
	(112364, 111, '2015-03-15 00:30:17.000000', 'temperatura', 296.0000, 'ºC'),
	(112365, 111, '2015-03-15 00:30:18.000000', 'temperatura', 860.0000, 'ºC'),
	(112366, 111, '2015-03-15 00:30:19.000000', 'temperatura', 1010.0000, 'ºC'),
	(112367, 111, '2015-03-15 00:30:20.000000', 'temperatura', 71.0000, 'ºC'),
	(112368, 111, '2015-03-15 00:30:21.000000', 'temperatura', 927.0000, 'ºC'),
	(112369, 111, '2015-03-15 00:30:22.000000', 'temperatura', 824.0000, 'ºC'),
	(112370, 111, '2015-03-15 00:30:23.000000', 'temperatura', 136.0000, 'ºC'),
	(112371, 111, '2015-03-15 00:30:24.000000', 'temperatura', 609.0000, 'ºC'),
	(112372, 111, '2015-03-15 00:30:25.000000', 'temperatura', 240.0000, 'ºC'),
	(112373, 111, '2015-03-15 00:30:26.000000', 'temperatura', 572.0000, 'ºC'),
	(112374, 111, '2015-03-15 00:30:27.000000', 'temperatura', 939.0000, 'ºC'),
	(112375, 111, '2015-03-15 00:30:28.000000', 'temperatura', 583.0000, 'ºC'),
	(112376, 111, '2015-03-15 00:30:29.000000', 'temperatura', 96.0000, 'ºC'),
	(112377, 111, '2015-03-15 00:30:30.000000', 'temperatura', 1132.0000, 'ºC'),
	(112378, 111, '2015-03-15 00:30:31.000000', 'temperatura', 572.0000, 'ºC'),
	(112379, 111, '2015-03-15 00:30:32.000000', 'temperatura', 665.0000, 'ºC'),
	(112380, 111, '2015-03-15 00:30:33.000000', 'temperatura', 409.0000, 'ºC'),
	(112381, 111, '2015-03-15 00:30:34.000000', 'temperatura', 52.0000, 'ºC'),
	(112382, 111, '2015-03-15 00:30:35.000000', 'temperatura', 232.0000, 'ºC'),
	(112383, 111, '2015-03-15 00:30:36.000000', 'temperatura', 1003.0000, 'ºC'),
	(112384, 111, '2015-03-15 00:30:37.000000', 'temperatura', 722.0000, 'ºC'),
	(112385, 111, '2015-03-15 00:30:38.000000', 'temperatura', 602.0000, 'ºC'),
	(112386, 111, '2015-03-15 00:30:39.000000', 'temperatura', 842.0000, 'ºC'),
	(112387, 111, '2015-03-15 00:30:40.000000', 'temperatura', 4.0000, 'ºC'),
	(112388, 111, '2015-03-15 00:30:41.000000', 'temperatura', 1098.0000, 'ºC'),
	(112389, 111, '2015-03-15 00:30:42.000000', 'temperatura', 676.0000, 'ºC'),
	(112390, 111, '2015-03-15 00:30:43.000000', 'temperatura', 86.0000, 'ºC'),
	(112391, 111, '2015-03-15 00:30:44.000000', 'temperatura', 802.0000, 'ºC'),
	(112392, 111, '2015-03-15 00:30:45.000000', 'temperatura', 154.0000, 'ºC'),
	(112393, 111, '2015-03-15 00:30:46.000000', 'temperatura', 763.0000, 'ºC'),
	(112394, 111, '2015-03-15 00:30:47.000000', 'temperatura', 952.0000, 'ºC'),
	(112395, 111, '2015-03-15 00:30:48.000000', 'temperatura', 74.0000, 'ºC'),
	(112396, 111, '2015-03-15 00:30:49.000000', 'temperatura', 1115.0000, 'ºC'),
	(112397, 111, '2015-03-15 00:30:50.000000', 'temperatura', 551.0000, 'ºC'),
	(112398, 111, '2015-03-15 00:30:51.000000', 'temperatura', 612.0000, 'ºC'),
	(112399, 111, '2015-03-15 00:30:52.000000', 'temperatura', 206.0000, 'ºC'),
	(112400, 111, '2015-03-15 00:30:53.000000', 'temperatura', 395.0000, 'ºC'),
	(112401, 111, '2015-03-15 00:30:54.000000', 'temperatura', 159.0000, 'ºC'),
	(112402, 111, '2015-03-15 00:30:55.000000', 'temperatura', 810.0000, 'ºC'),
	(112403, 111, '2015-03-15 00:30:56.000000', 'temperatura', 1173.0000, 'ºC'),
	(112404, 111, '2015-03-15 00:30:57.000000', 'temperatura', 1037.0000, 'ºC'),
	(112405, 111, '2015-03-15 00:30:58.000000', 'temperatura', 464.0000, 'ºC'),
	(112406, 111, '2015-03-15 00:30:59.000000', 'temperatura', 412.0000, 'ºC'),
	(112407, 111, '2015-03-15 00:31:00.000000', 'temperatura', 666.0000, 'ºC'),
	(112408, 111, '2015-03-15 00:31:01.000000', 'temperatura', 894.0000, 'ºC'),
	(112409, 111, '2015-03-15 00:31:02.000000', 'temperatura', 72.0000, 'ºC'),
	(112410, 111, '2015-03-15 00:31:03.000000', 'temperatura', 81.0000, 'ºC'),
	(112411, 111, '2015-03-15 00:31:04.000000', 'temperatura', 187.0000, 'ºC'),
	(112412, 111, '2015-03-15 00:31:05.000000', 'temperatura', 693.0000, 'ºC'),
	(112413, 111, '2015-03-15 00:31:06.000000', 'temperatura', 504.0000, 'ºC'),
	(112414, 111, '2015-03-15 00:31:07.000000', 'temperatura', 443.0000, 'ºC'),
	(112415, 111, '2015-03-15 00:31:08.000000', 'temperatura', 701.0000, 'ºC'),
	(112416, 111, '2015-03-15 00:31:09.000000', 'temperatura', 979.0000, 'ºC'),
	(112417, 111, '2015-03-15 00:31:10.000000', 'temperatura', 390.0000, 'ºC'),
	(112418, 111, '2015-03-15 00:31:11.000000', 'temperatura', 213.0000, 'ºC'),
	(112419, 111, '2015-03-15 00:31:12.000000', 'temperatura', 1098.0000, 'ºC'),
	(112420, 111, '2015-03-15 00:31:13.000000', 'temperatura', 52.0000, 'ºC'),
	(112421, 111, '2015-03-15 00:31:14.000000', 'temperatura', 567.0000, 'ºC'),
	(112422, 111, '2015-03-15 00:31:15.000000', 'temperatura', 280.0000, 'ºC'),
	(112423, 111, '2015-03-15 00:31:16.000000', 'temperatura', 898.0000, 'ºC'),
	(112424, 111, '2015-03-15 00:31:17.000000', 'temperatura', 49.0000, 'ºC'),
	(112425, 111, '2015-03-15 00:31:18.000000', 'temperatura', 1152.0000, 'ºC'),
	(112426, 111, '2015-03-15 00:31:19.000000', 'temperatura', 813.0000, 'ºC'),
	(112427, 111, '2015-03-15 00:31:20.000000', 'temperatura', 609.0000, 'ºC'),
	(112428, 111, '2015-03-15 00:31:21.000000', 'temperatura', 609.0000, 'ºC'),
	(112429, 111, '2015-03-15 00:31:22.000000', 'temperatura', 16.0000, 'ºC'),
	(112430, 111, '2015-03-15 00:31:23.000000', 'temperatura', 655.0000, 'ºC'),
	(112431, 111, '2015-03-15 00:31:24.000000', 'temperatura', 825.0000, 'ºC'),
	(112432, 111, '2015-03-15 00:31:25.000000', 'temperatura', 963.0000, 'ºC'),
	(112433, 111, '2015-03-15 00:31:26.000000', 'temperatura', 1139.0000, 'ºC'),
	(112434, 111, '2015-03-15 00:31:27.000000', 'temperatura', 405.0000, 'ºC'),
	(112435, 111, '2015-03-15 00:31:28.000000', 'temperatura', 1011.0000, 'ºC'),
	(112436, 111, '2015-03-15 00:31:29.000000', 'temperatura', 238.0000, 'ºC'),
	(112437, 111, '2015-03-15 00:31:30.000000', 'temperatura', 558.0000, 'ºC'),
	(112438, 111, '2015-03-15 00:31:31.000000', 'temperatura', 877.0000, 'ºC'),
	(112439, 111, '2015-03-15 00:31:32.000000', 'temperatura', 311.0000, 'ºC'),
	(112440, 111, '2015-03-15 00:31:33.000000', 'temperatura', 123.0000, 'ºC'),
	(112441, 111, '2015-03-15 00:31:34.000000', 'temperatura', 883.0000, 'ºC'),
	(112442, 111, '2015-03-15 00:31:35.000000', 'temperatura', 449.0000, 'ºC'),
	(112443, 111, '2015-03-15 00:31:36.000000', 'temperatura', 795.0000, 'ºC'),
	(112444, 111, '2015-03-15 00:31:37.000000', 'temperatura', 230.0000, 'ºC'),
	(112445, 111, '2015-03-15 00:31:38.000000', 'temperatura', 1163.0000, 'ºC'),
	(112446, 111, '2015-03-15 00:31:39.000000', 'temperatura', 326.0000, 'ºC'),
	(112447, 111, '2015-03-15 00:31:40.000000', 'temperatura', 541.0000, 'ºC'),
	(112448, 111, '2015-03-15 00:31:41.000000', 'temperatura', 527.0000, 'ºC'),
	(112449, 111, '2015-03-15 00:31:42.000000', 'temperatura', 1014.0000, 'ºC'),
	(112450, 111, '2015-03-15 00:31:43.000000', 'temperatura', 1089.0000, 'ºC'),
	(112451, 111, '2015-03-15 00:31:44.000000', 'temperatura', 3.0000, 'ºC'),
	(112452, 111, '2015-03-15 00:31:45.000000', 'temperatura', 350.0000, 'ºC'),
	(112453, 111, '2015-03-15 00:31:46.000000', 'temperatura', 541.0000, 'ºC'),
	(112454, 111, '2015-03-15 00:31:47.000000', 'temperatura', 456.0000, 'ºC'),
	(112455, 111, '2015-03-15 00:31:48.000000', 'temperatura', 658.0000, 'ºC'),
	(112456, 111, '2015-03-15 00:31:49.000000', 'temperatura', 722.0000, 'ºC'),
	(112457, 111, '2015-03-15 00:31:50.000000', 'temperatura', 438.0000, 'ºC'),
	(112458, 111, '2015-03-15 00:31:51.000000', 'temperatura', 24.0000, 'ºC'),
	(112459, 111, '2015-03-15 00:31:52.000000', 'temperatura', 5.0000, 'ºC'),
	(112460, 111, '2015-03-15 00:31:53.000000', 'temperatura', 1156.0000, 'ºC'),
	(112461, 111, '2015-03-15 00:31:54.000000', 'temperatura', 965.0000, 'ºC'),
	(112462, 111, '2015-03-15 00:31:55.000000', 'temperatura', 157.0000, 'ºC'),
	(112463, 111, '2015-03-15 00:31:56.000000', 'temperatura', 290.0000, 'ºC'),
	(112464, 111, '2015-03-15 00:31:57.000000', 'temperatura', 981.0000, 'ºC'),
	(112465, 111, '2015-03-15 00:31:58.000000', 'temperatura', 435.0000, 'ºC'),
	(112466, 111, '2015-03-15 00:31:59.000000', 'temperatura', 431.0000, 'ºC'),
	(112467, 111, '2015-03-15 00:32:00.000000', 'temperatura', 853.0000, 'ºC'),
	(112468, 111, '2015-03-15 00:32:01.000000', 'temperatura', 571.0000, 'ºC'),
	(112469, 111, '2015-03-15 00:32:02.000000', 'temperatura', 298.0000, 'ºC'),
	(112470, 111, '2015-03-15 00:32:03.000000', 'temperatura', 975.0000, 'ºC'),
	(112471, 111, '2015-03-15 00:32:04.000000', 'temperatura', 381.0000, 'ºC'),
	(112472, 111, '2015-03-15 00:32:05.000000', 'temperatura', 183.0000, 'ºC'),
	(112473, 111, '2015-03-15 00:32:06.000000', 'temperatura', 971.0000, 'ºC'),
	(112474, 111, '2015-03-15 00:32:07.000000', 'temperatura', 709.0000, 'ºC'),
	(112475, 111, '2015-03-15 00:32:08.000000', 'temperatura', 630.0000, 'ºC'),
	(112476, 111, '2015-03-15 00:32:09.000000', 'temperatura', 1024.0000, 'ºC'),
	(112477, 111, '2015-03-15 00:32:10.000000', 'temperatura', 832.0000, 'ºC'),
	(112478, 111, '2015-03-15 00:32:11.000000', 'temperatura', 1089.0000, 'ºC'),
	(112479, 111, '2015-03-15 00:32:12.000000', 'temperatura', 548.0000, 'ºC'),
	(112480, 111, '2015-03-15 00:32:13.000000', 'temperatura', 672.0000, 'ºC'),
	(112481, 111, '2015-03-15 00:32:14.000000', 'temperatura', 518.0000, 'ºC'),
	(112482, 111, '2015-03-15 00:32:15.000000', 'temperatura', 576.0000, 'ºC'),
	(112483, 111, '2015-03-15 00:32:16.000000', 'temperatura', 123.0000, 'ºC'),
	(112484, 111, '2015-03-15 00:32:17.000000', 'temperatura', 91.0000, 'ºC'),
	(112485, 111, '2015-03-15 00:32:18.000000', 'temperatura', 83.0000, 'ºC'),
	(112486, 111, '2015-03-15 00:32:19.000000', 'temperatura', 146.0000, 'ºC'),
	(112487, 111, '2015-03-15 00:32:20.000000', 'temperatura', 479.0000, 'ºC'),
	(112488, 111, '2015-03-15 00:32:21.000000', 'temperatura', 757.0000, 'ºC'),
	(112489, 111, '2015-03-15 00:32:22.000000', 'temperatura', 1149.0000, 'ºC'),
	(112490, 111, '2015-03-15 00:32:23.000000', 'temperatura', 1074.0000, 'ºC'),
	(112491, 111, '2015-03-15 00:32:24.000000', 'temperatura', 726.0000, 'ºC'),
	(112492, 111, '2015-03-15 00:32:25.000000', 'temperatura', 407.0000, 'ºC'),
	(112493, 111, '2015-03-15 00:32:26.000000', 'temperatura', 1059.0000, 'ºC'),
	(112494, 111, '2015-03-15 00:32:27.000000', 'temperatura', 474.0000, 'ºC'),
	(112495, 111, '2015-03-15 00:32:28.000000', 'temperatura', 391.0000, 'ºC'),
	(112496, 111, '2015-03-15 00:32:29.000000', 'temperatura', 536.0000, 'ºC'),
	(112497, 111, '2015-03-15 00:32:30.000000', 'temperatura', 307.0000, 'ºC'),
	(112498, 111, '2015-03-15 00:32:31.000000', 'temperatura', 1126.0000, 'ºC'),
	(112499, 111, '2015-03-15 00:32:32.000000', 'temperatura', 1109.0000, 'ºC'),
	(112500, 111, '2015-03-15 00:32:33.000000', 'temperatura', 967.0000, 'ºC'),
	(112501, 111, '2015-03-15 00:32:34.000000', 'temperatura', 311.0000, 'ºC'),
	(112502, 111, '2015-03-15 00:32:35.000000', 'temperatura', 1052.0000, 'ºC'),
	(112503, 111, '2015-03-15 00:32:36.000000', 'temperatura', 728.0000, 'ºC'),
	(112504, 111, '2015-03-15 00:32:37.000000', 'temperatura', 486.0000, 'ºC'),
	(112505, 111, '2015-03-15 00:32:38.000000', 'temperatura', 246.0000, 'ºC'),
	(112506, 111, '2015-03-15 00:32:39.000000', 'temperatura', 971.0000, 'ºC'),
	(112507, 111, '2015-03-15 00:32:40.000000', 'temperatura', 517.0000, 'ºC'),
	(112508, 111, '2015-03-15 00:32:41.000000', 'temperatura', 874.0000, 'ºC'),
	(112509, 111, '2015-03-15 00:32:42.000000', 'temperatura', 417.0000, 'ºC'),
	(112510, 111, '2015-03-15 00:32:43.000000', 'temperatura', 665.0000, 'ºC'),
	(112511, 111, '2015-03-15 00:32:44.000000', 'temperatura', 876.0000, 'ºC'),
	(112512, 111, '2015-03-15 00:32:45.000000', 'temperatura', 1185.0000, 'ºC'),
	(112513, 111, '2015-03-15 00:32:46.000000', 'temperatura', 899.0000, 'ºC'),
	(112514, 111, '2015-03-15 00:32:47.000000', 'temperatura', 938.0000, 'ºC'),
	(112515, 111, '2015-03-15 00:32:48.000000', 'temperatura', 795.0000, 'ºC'),
	(112516, 111, '2015-03-15 00:32:49.000000', 'temperatura', 1162.0000, 'ºC'),
	(112517, 111, '2015-03-15 00:32:50.000000', 'temperatura', 1023.0000, 'ºC'),
	(112518, 111, '2015-03-15 00:32:51.000000', 'temperatura', 433.0000, 'ºC'),
	(112519, 111, '2015-03-15 00:32:52.000000', 'temperatura', 294.0000, 'ºC'),
	(112520, 111, '2015-03-15 00:32:53.000000', 'temperatura', 173.0000, 'ºC'),
	(112521, 111, '2015-03-15 00:32:54.000000', 'temperatura', 1181.0000, 'ºC'),
	(112522, 111, '2015-03-15 00:32:55.000000', 'temperatura', 588.0000, 'ºC'),
	(112523, 111, '2015-03-15 00:32:56.000000', 'temperatura', 595.0000, 'ºC'),
	(112524, 111, '2015-03-15 00:32:57.000000', 'temperatura', 15.0000, 'ºC'),
	(112525, 111, '2015-03-15 00:32:58.000000', 'temperatura', 690.0000, 'ºC'),
	(112526, 111, '2015-03-15 00:32:59.000000', 'temperatura', 1007.0000, 'ºC'),
	(112527, 111, '2015-03-15 00:33:00.000000', 'temperatura', 564.0000, 'ºC'),
	(112528, 111, '2015-03-15 00:33:01.000000', 'temperatura', 998.0000, 'ºC'),
	(112529, 111, '2015-03-15 00:33:02.000000', 'temperatura', 901.0000, 'ºC'),
	(112530, 111, '2015-03-15 00:33:03.000000', 'temperatura', 311.0000, 'ºC'),
	(112531, 111, '2015-03-15 00:33:04.000000', 'temperatura', 54.0000, 'ºC'),
	(112532, 111, '2015-03-15 00:33:05.000000', 'temperatura', 536.0000, 'ºC'),
	(112533, 111, '2015-03-15 00:33:06.000000', 'temperatura', 120.0000, 'ºC'),
	(112534, 111, '2015-03-15 00:33:07.000000', 'temperatura', 190.0000, 'ºC'),
	(112535, 111, '2015-03-15 00:33:08.000000', 'temperatura', 591.0000, 'ºC'),
	(112536, 111, '2015-03-15 00:33:09.000000', 'temperatura', 1187.0000, 'ºC'),
	(112537, 111, '2015-03-15 00:33:10.000000', 'temperatura', 562.0000, 'ºC'),
	(112538, 111, '2015-03-15 00:33:11.000000', 'temperatura', 449.0000, 'ºC'),
	(112539, 111, '2015-03-15 00:33:12.000000', 'temperatura', 561.0000, 'ºC'),
	(112540, 111, '2015-03-15 00:33:13.000000', 'temperatura', 257.0000, 'ºC'),
	(112541, 111, '2015-03-15 00:33:14.000000', 'temperatura', 804.0000, 'ºC'),
	(112542, 111, '2015-03-15 00:33:15.000000', 'temperatura', 850.0000, 'ºC'),
	(112543, 111, '2015-03-15 00:33:16.000000', 'temperatura', 636.0000, 'ºC'),
	(112544, 111, '2015-03-15 00:33:17.000000', 'temperatura', 631.0000, 'ºC'),
	(112545, 111, '2015-03-15 00:33:18.000000', 'temperatura', 49.0000, 'ºC'),
	(112546, 111, '2015-03-15 00:33:19.000000', 'temperatura', 750.0000, 'ºC'),
	(112547, 111, '2015-03-15 00:33:20.000000', 'temperatura', 3.0000, 'ºC'),
	(112548, 111, '2015-03-15 00:33:21.000000', 'temperatura', 167.0000, 'ºC'),
	(112549, 111, '2015-03-15 00:33:22.000000', 'temperatura', 826.0000, 'ºC'),
	(112550, 111, '2015-03-15 00:33:23.000000', 'temperatura', 32.0000, 'ºC'),
	(112551, 111, '2015-03-15 00:33:24.000000', 'temperatura', 80.0000, 'ºC'),
	(112552, 111, '2015-03-15 00:33:25.000000', 'temperatura', 306.0000, 'ºC'),
	(112553, 111, '2015-03-15 00:33:26.000000', 'temperatura', 90.0000, 'ºC'),
	(112554, 111, '2015-03-15 00:33:27.000000', 'temperatura', 733.0000, 'ºC'),
	(112555, 111, '2015-03-15 00:33:28.000000', 'temperatura', 993.0000, 'ºC'),
	(112556, 111, '2015-03-15 00:33:29.000000', 'temperatura', 369.0000, 'ºC'),
	(112557, 111, '2015-03-15 00:33:30.000000', 'temperatura', 68.0000, 'ºC'),
	(112558, 111, '2015-03-15 00:33:31.000000', 'temperatura', 431.0000, 'ºC'),
	(112559, 111, '2015-03-15 00:33:32.000000', 'temperatura', 750.0000, 'ºC'),
	(112560, 111, '2015-03-15 00:33:33.000000', 'temperatura', 61.0000, 'ºC'),
	(112561, 111, '2015-03-15 00:33:34.000000', 'temperatura', 452.0000, 'ºC'),
	(112562, 111, '2015-03-15 00:33:35.000000', 'temperatura', 879.0000, 'ºC'),
	(112563, 111, '2015-03-15 00:33:36.000000', 'temperatura', 642.0000, 'ºC'),
	(112564, 111, '2015-03-15 00:33:37.000000', 'temperatura', 570.0000, 'ºC'),
	(112565, 111, '2015-03-15 00:33:38.000000', 'temperatura', 925.0000, 'ºC'),
	(112566, 111, '2015-03-15 00:33:39.000000', 'temperatura', 515.0000, 'ºC'),
	(112567, 111, '2015-03-15 00:33:40.000000', 'temperatura', 1000.0000, 'ºC'),
	(112568, 111, '2015-03-15 00:33:41.000000', 'temperatura', 1058.0000, 'ºC'),
	(112569, 111, '2015-03-15 00:33:42.000000', 'temperatura', 1088.0000, 'ºC'),
	(112570, 111, '2015-03-15 00:33:43.000000', 'temperatura', 1067.0000, 'ºC'),
	(112571, 111, '2015-03-15 00:33:44.000000', 'temperatura', 873.0000, 'ºC'),
	(112572, 111, '2015-03-15 00:33:45.000000', 'temperatura', 1166.0000, 'ºC'),
	(112573, 111, '2015-03-15 00:33:46.000000', 'temperatura', 809.0000, 'ºC'),
	(112574, 111, '2015-03-15 00:33:47.000000', 'temperatura', 548.0000, 'ºC'),
	(112575, 111, '2015-03-15 00:33:48.000000', 'temperatura', 313.0000, 'ºC'),
	(112576, 111, '2015-03-15 00:33:49.000000', 'temperatura', 1124.0000, 'ºC'),
	(112577, 111, '2015-03-15 00:33:50.000000', 'temperatura', 1080.0000, 'ºC'),
	(112578, 111, '2015-03-15 00:33:51.000000', 'temperatura', 828.0000, 'ºC'),
	(112579, 111, '2015-03-15 00:33:52.000000', 'temperatura', 901.0000, 'ºC'),
	(112580, 111, '2015-03-15 00:33:53.000000', 'temperatura', 821.0000, 'ºC'),
	(112581, 111, '2015-03-15 00:33:54.000000', 'temperatura', 202.0000, 'ºC'),
	(112582, 111, '2015-03-15 00:33:55.000000', 'temperatura', 947.0000, 'ºC'),
	(112583, 111, '2015-03-15 00:33:56.000000', 'temperatura', 530.0000, 'ºC'),
	(112584, 111, '2015-03-15 00:33:57.000000', 'temperatura', 1010.0000, 'ºC'),
	(112585, 111, '2015-03-15 00:33:58.000000', 'temperatura', 1059.0000, 'ºC'),
	(112586, 111, '2015-03-15 00:33:59.000000', 'temperatura', 1064.0000, 'ºC'),
	(112587, 111, '2015-03-15 00:34:00.000000', 'temperatura', 947.0000, 'ºC'),
	(112588, 111, '2015-03-15 00:34:01.000000', 'temperatura', 342.0000, 'ºC'),
	(112589, 111, '2015-03-15 00:34:02.000000', 'temperatura', 68.0000, 'ºC'),
	(112590, 111, '2015-03-15 00:34:03.000000', 'temperatura', 516.0000, 'ºC'),
	(112591, 111, '2015-03-15 00:34:04.000000', 'temperatura', 1177.0000, 'ºC'),
	(112592, 111, '2015-03-15 00:34:05.000000', 'temperatura', 738.0000, 'ºC'),
	(112593, 111, '2015-03-15 00:34:06.000000', 'temperatura', 157.0000, 'ºC'),
	(112594, 111, '2015-03-15 00:34:07.000000', 'temperatura', 973.0000, 'ºC'),
	(112595, 111, '2015-03-15 00:34:08.000000', 'temperatura', 792.0000, 'ºC'),
	(112596, 111, '2015-03-15 00:34:09.000000', 'temperatura', 1045.0000, 'ºC'),
	(112597, 111, '2015-03-15 00:34:10.000000', 'temperatura', 446.0000, 'ºC'),
	(112598, 111, '2015-03-15 00:34:11.000000', 'temperatura', 299.0000, 'ºC'),
	(112599, 111, '2015-03-15 00:34:12.000000', 'temperatura', 154.0000, 'ºC'),
	(112600, 111, '2015-03-15 00:34:13.000000', 'temperatura', 1076.0000, 'ºC'),
	(112601, 111, '2015-03-15 00:34:14.000000', 'temperatura', 119.0000, 'ºC'),
	(112602, 111, '2015-03-15 00:34:15.000000', 'temperatura', 968.0000, 'ºC'),
	(112603, 111, '2015-03-15 00:34:16.000000', 'temperatura', 882.0000, 'ºC'),
	(112604, 111, '2015-03-15 00:34:17.000000', 'temperatura', 307.0000, 'ºC'),
	(112605, 111, '2015-03-15 00:34:18.000000', 'temperatura', 89.0000, 'ºC'),
	(112606, 111, '2015-03-15 00:34:19.000000', 'temperatura', 726.0000, 'ºC'),
	(112607, 111, '2015-03-15 00:34:20.000000', 'temperatura', 963.0000, 'ºC'),
	(112608, 111, '2015-03-15 00:34:21.000000', 'temperatura', 237.0000, 'ºC'),
	(112609, 111, '2015-03-15 00:34:22.000000', 'temperatura', 696.0000, 'ºC'),
	(112610, 111, '2015-03-15 00:34:23.000000', 'temperatura', 368.0000, 'ºC'),
	(112611, 111, '2015-03-15 00:34:24.000000', 'temperatura', 956.0000, 'ºC'),
	(112612, 111, '2015-03-15 00:34:25.000000', 'temperatura', 75.0000, 'ºC'),
	(112613, 111, '2015-03-15 00:34:26.000000', 'temperatura', 1106.0000, 'ºC'),
	(112614, 111, '2015-03-15 00:34:27.000000', 'temperatura', 506.0000, 'ºC'),
	(112615, 111, '2015-03-15 00:34:28.000000', 'temperatura', 412.0000, 'ºC'),
	(112616, 111, '2015-03-15 00:34:29.000000', 'temperatura', 541.0000, 'ºC'),
	(112617, 111, '2015-03-15 00:34:30.000000', 'temperatura', 271.0000, 'ºC'),
	(112618, 111, '2015-03-15 00:34:31.000000', 'temperatura', 933.0000, 'ºC'),
	(112619, 111, '2015-03-15 00:34:32.000000', 'temperatura', 251.0000, 'ºC'),
	(112620, 111, '2015-03-15 00:34:33.000000', 'temperatura', 856.0000, 'ºC'),
	(112621, 111, '2015-03-15 00:34:34.000000', 'temperatura', 1129.0000, 'ºC'),
	(112622, 111, '2015-03-15 00:34:35.000000', 'temperatura', 679.0000, 'ºC'),
	(112623, 111, '2015-03-15 00:34:36.000000', 'temperatura', 8.0000, 'ºC'),
	(112624, 111, '2015-03-15 00:34:37.000000', 'temperatura', 401.0000, 'ºC'),
	(112625, 111, '2015-03-15 00:34:38.000000', 'temperatura', 783.0000, 'ºC'),
	(112626, 111, '2015-03-15 00:34:39.000000', 'temperatura', 312.0000, 'ºC'),
	(112627, 111, '2015-03-15 00:34:40.000000', 'temperatura', 413.0000, 'ºC'),
	(112628, 111, '2015-03-15 00:34:41.000000', 'temperatura', 1130.0000, 'ºC'),
	(112629, 111, '2015-03-15 00:34:42.000000', 'temperatura', 810.0000, 'ºC'),
	(112630, 111, '2015-03-15 00:34:43.000000', 'temperatura', 660.0000, 'ºC'),
	(112631, 111, '2015-03-15 00:34:44.000000', 'temperatura', 871.0000, 'ºC'),
	(112632, 111, '2015-03-15 00:34:45.000000', 'temperatura', 1177.0000, 'ºC'),
	(112633, 111, '2015-03-15 00:34:46.000000', 'temperatura', 870.0000, 'ºC'),
	(112634, 111, '2015-03-15 00:34:47.000000', 'temperatura', 820.0000, 'ºC'),
	(112635, 111, '2015-03-15 00:34:48.000000', 'temperatura', 292.0000, 'ºC'),
	(112636, 111, '2015-03-15 00:34:49.000000', 'temperatura', 198.0000, 'ºC'),
	(112637, 111, '2015-03-15 00:34:50.000000', 'temperatura', 116.0000, 'ºC'),
	(112638, 111, '2015-03-15 00:34:51.000000', 'temperatura', 1186.0000, 'ºC'),
	(112639, 111, '2015-03-15 00:34:52.000000', 'temperatura', 783.0000, 'ºC'),
	(112640, 111, '2015-03-15 00:34:53.000000', 'temperatura', 357.0000, 'ºC'),
	(112641, 111, '2015-03-15 00:34:54.000000', 'temperatura', 635.0000, 'ºC'),
	(112642, 111, '2015-03-15 00:34:55.000000', 'temperatura', 905.0000, 'ºC'),
	(112643, 111, '2015-03-15 00:34:56.000000', 'temperatura', 220.0000, 'ºC'),
	(112644, 111, '2015-03-15 00:34:57.000000', 'temperatura', 785.0000, 'ºC'),
	(112645, 111, '2015-03-15 00:34:58.000000', 'temperatura', 867.0000, 'ºC'),
	(112646, 111, '2015-03-15 00:34:59.000000', 'temperatura', 778.0000, 'ºC'),
	(112647, 111, '2015-03-15 00:35:00.000000', 'temperatura', 91.0000, 'ºC'),
	(112648, 111, '2015-03-15 00:35:01.000000', 'temperatura', 522.0000, 'ºC'),
	(112649, 111, '2015-03-15 00:35:02.000000', 'temperatura', 1139.0000, 'ºC'),
	(112650, 111, '2015-03-15 00:35:03.000000', 'temperatura', 528.0000, 'ºC'),
	(112651, 111, '2015-03-15 00:35:04.000000', 'temperatura', 423.0000, 'ºC'),
	(112652, 111, '2015-03-15 00:35:05.000000', 'temperatura', 530.0000, 'ºC'),
	(112653, 111, '2015-03-15 00:35:06.000000', 'temperatura', 183.0000, 'ºC'),
	(112654, 111, '2015-03-15 00:35:07.000000', 'temperatura', 525.0000, 'ºC'),
	(112655, 111, '2015-03-15 00:35:08.000000', 'temperatura', 876.0000, 'ºC'),
	(112656, 111, '2015-03-15 00:35:09.000000', 'temperatura', 407.0000, 'ºC'),
	(112657, 111, '2015-03-15 00:35:10.000000', 'temperatura', 608.0000, 'ºC'),
	(112658, 111, '2015-03-15 00:35:11.000000', 'temperatura', 619.0000, 'ºC'),
	(112659, 111, '2015-03-15 00:35:12.000000', 'temperatura', 71.0000, 'ºC'),
	(112660, 111, '2015-03-15 00:35:13.000000', 'temperatura', 901.0000, 'ºC'),
	(112661, 111, '2015-03-15 00:35:14.000000', 'temperatura', 689.0000, 'ºC'),
	(112662, 111, '2015-03-15 00:35:15.000000', 'temperatura', 744.0000, 'ºC'),
	(112663, 111, '2015-03-15 00:35:16.000000', 'temperatura', 454.0000, 'ºC'),
	(112664, 111, '2015-03-15 00:35:17.000000', 'temperatura', 38.0000, 'ºC'),
	(112665, 111, '2015-03-15 00:35:18.000000', 'temperatura', 28.0000, 'ºC'),
	(112666, 111, '2015-03-15 00:35:19.000000', 'temperatura', 26.0000, 'ºC'),
	(112667, 111, '2015-03-15 00:35:20.000000', 'temperatura', 46.0000, 'ºC'),
	(112668, 111, '2015-03-15 00:35:21.000000', 'temperatura', 155.0000, 'ºC'),
	(112669, 111, '2015-03-15 00:35:22.000000', 'temperatura', 637.0000, 'ºC'),
	(112670, 111, '2015-03-15 00:35:23.000000', 'temperatura', 321.0000, 'ºC'),
	(112671, 111, '2015-03-15 00:35:24.000000', 'temperatura', 892.0000, 'ºC'),
	(112672, 111, '2015-03-15 00:35:25.000000', 'temperatura', 1101.0000, 'ºC'),
	(112673, 111, '2015-03-15 00:35:26.000000', 'temperatura', 426.0000, 'ºC'),
	(112674, 111, '2015-03-15 00:35:27.000000', 'temperatura', 31.0000, 'ºC'),
	(112675, 111, '2015-03-15 00:35:28.000000', 'temperatura', 74.0000, 'ºC'),
	(112676, 111, '2015-03-15 00:35:29.000000', 'temperatura', 279.0000, 'ºC'),
	(112677, 111, '2015-03-15 00:35:30.000000', 'temperatura', 1174.0000, 'ºC'),
	(112678, 111, '2015-03-15 00:35:31.000000', 'temperatura', 235.0000, 'ºC'),
	(112679, 111, '2015-03-15 00:35:32.000000', 'temperatura', 52.0000, 'ºC'),
	(112680, 111, '2015-03-15 00:35:33.000000', 'temperatura', 755.0000, 'ºC'),
	(112681, 111, '2015-03-15 00:35:34.000000', 'temperatura', 19.0000, 'ºC'),
	(112682, 111, '2015-03-15 00:35:35.000000', 'temperatura', 230.0000, 'ºC'),
	(112683, 111, '2015-03-15 00:35:36.000000', 'temperatura', 1093.0000, 'ºC'),
	(112684, 111, '2015-03-15 00:35:37.000000', 'temperatura', 1175.0000, 'ºC'),
	(112685, 111, '2015-03-15 00:35:38.000000', 'temperatura', 198.0000, 'ºC'),
	(112686, 111, '2015-03-15 00:35:39.000000', 'temperatura', 1065.0000, 'ºC'),
	(112687, 111, '2015-03-15 00:35:40.000000', 'temperatura', 1130.0000, 'ºC'),
	(112688, 111, '2015-03-15 00:35:41.000000', 'temperatura', 56.0000, 'ºC'),
	(112689, 111, '2015-03-15 00:35:42.000000', 'temperatura', 491.0000, 'ºC'),
	(112690, 111, '2015-03-15 00:35:43.000000', 'temperatura', 1088.0000, 'ºC'),
	(112691, 111, '2015-03-15 00:35:44.000000', 'temperatura', 365.0000, 'ºC'),
	(112692, 111, '2015-03-15 00:35:45.000000', 'temperatura', 964.0000, 'ºC'),
	(112693, 111, '2015-03-15 00:35:46.000000', 'temperatura', 126.0000, 'ºC'),
	(112694, 111, '2015-03-15 00:35:47.000000', 'temperatura', 139.0000, 'ºC'),
	(112695, 111, '2015-03-15 00:35:48.000000', 'temperatura', 317.0000, 'ºC'),
	(112696, 111, '2015-03-15 00:35:49.000000', 'temperatura', 1166.0000, 'ºC'),
	(112697, 111, '2015-03-15 00:35:50.000000', 'temperatura', 82.0000, 'ºC'),
	(112698, 111, '2015-03-15 00:35:51.000000', 'temperatura', 512.0000, 'ºC'),
	(112699, 111, '2015-03-15 00:35:52.000000', 'temperatura', 1113.0000, 'ºC'),
	(112700, 111, '2015-03-15 00:35:53.000000', 'temperatura', 429.0000, 'ºC'),
	(112701, 111, '2015-03-15 00:35:54.000000', 'temperatura', 6.0000, 'ºC'),
	(112702, 111, '2015-03-15 00:35:55.000000', 'temperatura', 1146.0000, 'ºC'),
	(112703, 111, '2015-03-15 00:35:56.000000', 'temperatura', 910.0000, 'ºC'),
	(112704, 111, '2015-03-15 00:35:57.000000', 'temperatura', 1115.0000, 'ºC'),
	(112705, 111, '2015-03-15 00:35:58.000000', 'temperatura', 446.0000, 'ºC'),
	(112706, 111, '2015-03-15 00:35:59.000000', 'temperatura', 83.0000, 'ºC'),
	(112707, 111, '2015-03-15 00:36:00.000000', 'temperatura', 277.0000, 'ºC'),
	(112708, 111, '2015-03-15 00:36:01.000000', 'temperatura', 1139.0000, 'ºC'),
	(112709, 111, '2015-03-15 00:36:02.000000', 'temperatura', 63.0000, 'ºC'),
	(112710, 111, '2015-03-15 00:36:03.000000', 'temperatura', 497.0000, 'ºC'),
	(112711, 111, '2015-03-15 00:36:04.000000', 'temperatura', 1100.0000, 'ºC'),
	(112712, 111, '2015-03-15 00:36:05.000000', 'temperatura', 407.0000, 'ºC'),
	(112713, 111, '2015-03-15 00:36:06.000000', 'temperatura', 1137.0000, 'ºC'),
	(112714, 111, '2015-03-15 00:36:07.000000', 'temperatura', 865.0000, 'ºC'),
	(112715, 111, '2015-03-15 00:36:08.000000', 'temperatura', 915.0000, 'ºC'),
	(112716, 111, '2015-03-15 00:36:09.000000', 'temperatura', 780.0000, 'ºC'),
	(112717, 111, '2015-03-15 00:36:10.000000', 'temperatura', 1157.0000, 'ºC'),
	(112718, 111, '2015-03-15 00:36:11.000000', 'temperatura', 1044.0000, 'ºC'),
	(112719, 111, '2015-03-15 00:36:12.000000', 'temperatura', 551.0000, 'ºC'),
	(112720, 111, '2015-03-15 00:36:13.000000', 'temperatura', 821.0000, 'ºC'),
	(112721, 111, '2015-03-15 00:36:14.000000', 'temperatura', 52.0000, 'ºC'),
	(112722, 111, '2015-03-15 00:36:15.000000', 'temperatura', 200.0000, 'ºC'),
	(112723, 111, '2015-03-15 00:36:16.000000', 'temperatura', 846.0000, 'ºC'),
	(112724, 111, '2015-03-15 00:36:17.000000', 'temperatura', 27.0000, 'ºC'),
	(112725, 111, '2015-03-15 00:36:18.000000', 'temperatura', 1197.0000, 'ºC'),
	(112726, 111, '2015-03-15 00:36:19.000000', 'temperatura', 1106.0000, 'ºC'),
	(112727, 111, '2015-03-15 00:36:20.000000', 'temperatura', 741.0000, 'ºC'),
	(112728, 111, '2015-03-15 00:36:21.000000', 'temperatura', 387.0000, 'ºC'),
	(112729, 111, '2015-03-15 00:36:22.000000', 'temperatura', 913.0000, 'ºC'),
	(112730, 111, '2015-03-15 00:36:23.000000', 'temperatura', 1004.0000, 'ºC'),
	(112731, 111, '2015-03-15 00:36:24.000000', 'temperatura', 1083.0000, 'ºC'),
	(112732, 111, '2015-03-15 00:36:25.000000', 'temperatura', 4.0000, 'ºC'),
	(112733, 111, '2015-03-15 00:36:26.000000', 'temperatura', 369.0000, 'ºC'),
	(112734, 111, '2015-03-15 00:36:27.000000', 'temperatura', 633.0000, 'ºC'),
	(112735, 111, '2015-03-15 00:36:28.000000', 'temperatura', 859.0000, 'ºC'),
	(112736, 111, '2015-03-15 00:36:29.000000', 'temperatura', 1198.0000, 'ºC'),
	(112737, 111, '2015-03-15 00:36:30.000000', 'temperatura', 1014.0000, 'ºC'),
	(112738, 111, '2015-03-15 00:36:31.000000', 'temperatura', 275.0000, 'ºC'),
	(112739, 111, '2015-03-15 00:36:32.000000', 'temperatura', 734.0000, 'ºC'),
	(112740, 111, '2015-03-15 00:36:33.000000', 'temperatura', 446.0000, 'ºC'),
	(112741, 111, '2015-03-15 00:36:34.000000', 'temperatura', 30.0000, 'ºC'),
	(112742, 111, '2015-03-15 00:36:35.000000', 'temperatura', 11.0000, 'ºC'),
	(112743, 111, '2015-03-15 00:36:36.000000', 'temperatura', 1167.0000, 'ºC'),
	(112744, 111, '2015-03-15 00:36:37.000000', 'temperatura', 1001.0000, 'ºC'),
	(112745, 111, '2015-03-15 00:36:38.000000', 'temperatura', 305.0000, 'ºC'),
	(112746, 111, '2015-03-15 00:36:39.000000', 'temperatura', 921.0000, 'ºC'),
	(112747, 111, '2015-03-15 00:36:40.000000', 'temperatura', 92.0000, 'ºC'),
	(112748, 111, '2015-03-15 00:36:41.000000', 'temperatura', 99.0000, 'ºC'),
	(112749, 111, '2015-03-15 00:36:42.000000', 'temperatura', 218.0000, 'ºC'),
	(112750, 111, '2015-03-15 00:36:43.000000', 'temperatura', 793.0000, 'ºC'),
	(112751, 111, '2015-03-15 00:36:44.000000', 'temperatura', 914.0000, 'ºC'),
	(112752, 111, '2015-03-15 00:36:45.000000', 'temperatura', 988.0000, 'ºC'),
	(112753, 111, '2015-03-15 00:36:46.000000', 'temperatura', 1000.0000, 'ºC'),
	(112754, 111, '2015-03-15 00:36:47.000000', 'temperatura', 835.0000, 'ºC'),
	(112755, 111, '2015-03-15 00:36:48.000000', 'temperatura', 1177.0000, 'ºC'),
	(112756, 111, '2015-03-15 00:36:49.000000', 'temperatura', 982.0000, 'ºC'),
	(112757, 111, '2015-03-15 00:36:50.000000', 'temperatura', 178.0000, 'ºC'),
	(112758, 111, '2015-03-15 00:36:51.000000', 'temperatura', 343.0000, 'ºC'),
	(112759, 111, '2015-03-15 00:36:52.000000', 'temperatura', 1181.0000, 'ºC'),
	(112760, 111, '2015-03-15 00:36:53.000000', 'temperatura', 78.0000, 'ºC'),
	(112761, 111, '2015-03-15 00:36:54.000000', 'temperatura', 449.0000, 'ºC'),
	(112762, 111, '2015-03-15 00:36:55.000000', 'temperatura', 810.0000, 'ºC'),
	(112763, 111, '2015-03-15 00:36:56.000000', 'temperatura', 302.0000, 'ºC'),
	(112764, 111, '2015-03-15 00:36:57.000000', 'temperatura', 283.0000, 'ºC'),
	(112765, 111, '2015-03-15 00:36:58.000000', 'temperatura', 509.0000, 'ºC'),
	(112766, 111, '2015-03-15 00:36:59.000000', 'temperatura', 498.0000, 'ºC'),
	(112767, 111, '2015-03-15 00:37:00.000000', 'temperatura', 962.0000, 'ºC'),
	(112768, 111, '2015-03-15 00:37:01.000000', 'temperatura', 918.0000, 'ºC'),
	(112769, 111, '2015-03-15 00:37:02.000000', 'temperatura', 504.0000, 'ºC'),
	(112770, 111, '2015-03-15 00:37:03.000000', 'temperatura', 965.0000, 'ºC'),
	(112771, 111, '2015-03-15 00:37:04.000000', 'temperatura', 916.0000, 'ºC'),
	(112772, 111, '2015-03-15 00:37:05.000000', 'temperatura', 482.0000, 'ºC'),
	(112773, 111, '2015-03-15 00:37:06.000000', 'temperatura', 866.0000, 'ºC'),
	(112774, 111, '2015-03-15 00:37:07.000000', 'temperatura', 482.0000, 'ºC'),
	(112775, 111, '2015-03-15 00:37:08.000000', 'temperatura', 1012.0000, 'ºC'),
	(112776, 111, '2015-03-15 00:37:09.000000', 'temperatura', 13.0000, 'ºC'),
	(112777, 111, '2015-03-15 00:37:10.000000', 'temperatura', 633.0000, 'ºC'),
	(112778, 111, '2015-03-15 00:37:11.000000', 'temperatura', 725.0000, 'ºC'),
	(112779, 111, '2015-03-15 00:37:12.000000', 'temperatura', 527.0000, 'ºC'),
	(112780, 111, '2015-03-15 00:37:13.000000', 'temperatura', 462.0000, 'ºC'),
	(112781, 111, '2015-03-15 00:37:14.000000', 'temperatura', 726.0000, 'ºC'),
	(112782, 111, '2015-03-15 00:37:15.000000', 'temperatura', 1047.0000, 'ºC'),
	(112783, 111, '2015-03-15 00:37:16.000000', 'temperatura', 658.0000, 'ºC'),
	(112784, 111, '2015-03-15 00:37:17.000000', 'temperatura', 147.0000, 'ºC'),
	(112785, 111, '2015-03-15 00:37:18.000000', 'temperatura', 1163.0000, 'ºC'),
	(112786, 111, '2015-03-15 00:37:19.000000', 'temperatura', 573.0000, 'ºC'),
	(112787, 111, '2015-03-15 00:37:20.000000', 'temperatura', 575.0000, 'ºC'),
	(112788, 111, '2015-03-15 00:37:21.000000', 'temperatura', 1159.0000, 'ºC'),
	(112789, 111, '2015-03-15 00:37:22.000000', 'temperatura', 472.0000, 'ºC'),
	(112790, 111, '2015-03-15 00:37:23.000000', 'temperatura', 80.0000, 'ºC'),
	(112791, 111, '2015-03-15 00:37:24.000000', 'temperatura', 186.0000, 'ºC'),
	(112792, 111, '2015-03-15 00:37:25.000000', 'temperatura', 688.0000, 'ºC'),
	(112793, 111, '2015-03-15 00:37:26.000000', 'temperatura', 486.0000, 'ºC'),
	(112794, 111, '2015-03-15 00:37:27.000000', 'temperatura', 366.0000, 'ºC'),
	(112795, 111, '2015-03-15 00:37:28.000000', 'temperatura', 371.0000, 'ºC'),
	(112796, 111, '2015-03-15 00:37:29.000000', 'temperatura', 757.0000, 'ºC'),
	(112797, 111, '2015-03-15 00:37:30.000000', 'temperatura', 272.0000, 'ºC'),
	(112798, 111, '2015-03-15 00:37:31.000000', 'temperatura', 290.0000, 'ºC'),
	(112799, 111, '2015-03-15 00:37:32.000000', 'temperatura', 634.0000, 'ºC'),
	(112800, 111, '2015-03-15 00:37:33.000000', 'temperatura', 1099.0000, 'ºC'),
	(112801, 111, '2015-03-15 00:37:34.000000', 'temperatura', 1195.0000, 'ºC'),
	(112802, 111, '2015-03-15 00:37:35.000000', 'temperatura', 277.0000, 'ºC'),
	(112803, 111, '2015-03-15 00:37:36.000000', 'temperatura', 200.0000, 'ºC'),
	(112804, 111, '2015-03-15 00:37:37.000000', 'temperatura', 171.0000, 'ºC'),
	(112805, 111, '2015-03-15 00:37:38.000000', 'temperatura', 254.0000, 'ºC'),
	(112806, 111, '2015-03-15 00:37:39.000000', 'temperatura', 760.0000, 'ºC'),
	(112807, 111, '2015-03-15 00:37:40.000000', 'temperatura', 636.0000, 'ºC'),
	(112808, 111, '2015-03-15 00:37:41.000000', 'temperatura', 903.0000, 'ºC'),
	(112809, 111, '2015-03-15 00:37:42.000000', 'temperatura', 207.0000, 'ºC'),
	(112810, 111, '2015-03-15 00:37:43.000000', 'temperatura', 727.0000, 'ºC'),
	(112811, 111, '2015-03-15 00:37:44.000000', 'temperatura', 614.0000, 'ºC'),
	(112812, 111, '2015-03-15 00:37:45.000000', 'temperatura', 891.0000, 'ºC'),
	(112813, 111, '2015-03-15 00:37:46.000000', 'temperatura', 212.0000, 'ºC'),
	(112814, 111, '2015-03-15 00:37:47.000000', 'temperatura', 787.0000, 'ºC'),
	(112815, 111, '2015-03-15 00:37:48.000000', 'temperatura', 901.0000, 'ºC'),
	(112816, 111, '2015-03-15 00:37:49.000000', 'temperatura', 945.0000, 'ºC'),
	(112817, 111, '2015-03-15 00:37:50.000000', 'temperatura', 824.0000, 'ºC'),
	(112818, 111, '2015-03-15 00:37:51.000000', 'temperatura', 82.0000, 'ºC'),
	(112819, 111, '2015-03-15 00:37:52.000000', 'temperatura', 339.0000, 'ºC'),
	(112820, 111, '2015-03-15 00:37:53.000000', 'temperatura', 249.0000, 'ºC'),
	(112821, 111, '2015-03-15 00:37:54.000000', 'temperatura', 228.0000, 'ºC'),
	(112822, 111, '2015-03-15 00:37:55.000000', 'temperatura', 395.0000, 'ºC'),
	(112823, 111, '2015-03-15 00:37:56.000000', 'temperatura', 91.0000, 'ºC'),
	(112824, 111, '2015-03-15 00:37:57.000000', 'temperatura', 469.0000, 'ºC'),
	(112825, 111, '2015-03-15 00:37:58.000000', 'temperatura', 872.0000, 'ºC'),
	(112826, 111, '2015-03-15 00:37:59.000000', 'temperatura', 554.0000, 'ºC'),
	(112827, 111, '2015-03-15 00:38:00.000000', 'temperatura', 156.0000, 'ºC'),
	(112828, 111, '2015-03-15 00:38:01.000000', 'temperatura', 318.0000, 'ºC'),
	(112829, 111, '2015-03-15 00:38:02.000000', 'temperatura', 1121.0000, 'ºC'),
	(112830, 111, '2015-03-15 00:38:03.000000', 'temperatura', 1050.0000, 'ºC'),
	(112831, 111, '2015-03-15 00:38:04.000000', 'temperatura', 691.0000, 'ºC'),
	(112832, 111, '2015-03-15 00:38:05.000000', 'temperatura', 305.0000, 'ºC'),
	(112833, 111, '2015-03-15 00:38:06.000000', 'temperatura', 653.0000, 'ºC'),
	(112834, 111, '2015-03-15 00:38:07.000000', 'temperatura', 1149.0000, 'ºC'),
	(112835, 111, '2015-03-15 00:38:08.000000', 'temperatura', 186.0000, 'ºC'),
	(112836, 111, '2015-03-15 00:38:09.000000', 'temperatura', 1082.0000, 'ºC'),
	(112837, 111, '2015-03-15 00:38:10.000000', 'temperatura', 56.0000, 'ºC'),
	(112838, 111, '2015-03-15 00:38:11.000000', 'temperatura', 632.0000, 'ºC'),
	(112839, 111, '2015-03-15 00:38:12.000000', 'temperatura', 592.0000, 'ºC'),
	(112840, 111, '2015-03-15 00:38:13.000000', 'temperatura', 1063.0000, 'ºC'),
	(112841, 111, '2015-03-15 00:38:14.000000', 'temperatura', 1143.0000, 'ºC'),
	(112842, 111, '2015-03-15 00:38:15.000000', 'temperatura', 124.0000, 'ºC'),
	(112843, 111, '2015-03-15 00:38:16.000000', 'temperatura', 794.0000, 'ºC'),
	(112844, 111, '2015-03-15 00:38:17.000000', 'temperatura', 1196.0000, 'ºC'),
	(112845, 111, '2015-03-15 00:38:18.000000', 'temperatura', 0.0000, 'ºC'),
	(112846, 111, '2015-03-15 00:38:19.000000', 'temperatura', 11.0000, 'ºC'),
	(112847, 111, '2015-03-15 00:38:20.000000', 'temperatura', 57.0000, 'ºC'),
	(112848, 111, '2015-03-15 00:38:21.000000', 'temperatura', 250.0000, 'ºC'),
	(112849, 111, '2015-03-15 00:38:22.000000', 'temperatura', 1081.0000, 'ºC'),
	(112850, 111, '2015-03-15 00:38:23.000000', 'temperatura', 1056.0000, 'ºC'),
	(112851, 111, '2015-03-15 00:38:24.000000', 'temperatura', 837.0000, 'ºC'),
	(112852, 111, '2015-03-15 00:38:25.000000', 'temperatura', 1019.0000, 'ºC'),
	(112853, 111, '2015-03-15 00:38:26.000000', 'temperatura', 183.0000, 'ºC'),
	(112854, 111, '2015-03-15 00:38:27.000000', 'temperatura', 260.0000, 'ºC'),
	(112855, 111, '2015-03-15 00:38:28.000000', 'temperatura', 751.0000, 'ºC'),
	(112856, 111, '2015-03-15 00:38:29.000000', 'temperatura', 574.0000, 'ºC'),
	(112857, 111, '2015-03-15 00:38:30.000000', 'temperatura', 617.0000, 'ºC'),
	(112858, 111, '2015-03-15 00:38:31.000000', 'temperatura', 165.0000, 'ºC'),
	(112859, 111, '2015-03-15 00:38:32.000000', 'temperatura', 174.0000, 'ºC'),
	(112860, 111, '2015-03-15 00:38:33.000000', 'temperatura', 378.0000, 'ºC'),
	(112861, 111, '2015-03-15 00:38:34.000000', 'temperatura', 166.0000, 'ºC'),
	(112862, 111, '2015-03-15 00:38:35.000000', 'temperatura', 895.0000, 'ºC'),
	(112863, 111, '2015-03-15 00:38:36.000000', 'temperatura', 381.0000, 'ºC'),
	(112864, 111, '2015-03-15 00:38:37.000000', 'temperatura', 417.0000, 'ºC'),
	(112865, 111, '2015-03-15 00:38:38.000000', 'temperatura', 944.0000, 'ºC'),
	(112866, 111, '2015-03-15 00:38:39.000000', 'temperatura', 1070.0000, 'ºC'),
	(112867, 111, '2015-03-15 00:38:40.000000', 'temperatura', 117.0000, 'ºC'),
	(112868, 111, '2015-03-15 00:38:41.000000', 'temperatura', 978.0000, 'ºC'),
	(112869, 111, '2015-03-15 00:38:42.000000', 'temperatura', 940.0000, 'ºC'),
	(112870, 111, '2015-03-15 00:38:43.000000', 'temperatura', 564.0000, 'ºC'),
	(112871, 111, '2015-03-15 00:38:44.000000', 'temperatura', 1.0000, 'ºC'),
	(112872, 111, '2015-03-15 00:38:45.000000', 'temperatura', 712.0000, 'ºC'),
	(112873, 111, '2015-03-15 00:38:46.000000', 'temperatura', 1159.0000, 'ºC'),
	(112874, 111, '2015-03-15 00:38:47.000000', 'temperatura', 59.0000, 'ºC'),
	(112875, 111, '2015-03-15 00:38:48.000000', 'temperatura', 418.0000, 'ºC'),
	(112876, 111, '2015-03-15 00:38:49.000000', 'temperatura', 713.0000, 'ºC'),
	(112877, 111, '2015-03-15 00:38:50.000000', 'temperatura', 1111.0000, 'ºC'),
	(112878, 111, '2015-03-15 00:38:51.000000', 'temperatura', 1019.0000, 'ºC'),
	(112879, 111, '2015-03-15 00:38:52.000000', 'temperatura', 563.0000, 'ºC'),
	(112880, 111, '2015-03-15 00:38:53.000000', 'temperatura', 956.0000, 'ºC'),
	(112881, 111, '2015-03-15 00:38:54.000000', 'temperatura', 693.0000, 'ºC'),
	(112882, 111, '2015-03-15 00:38:55.000000', 'temperatura', 597.0000, 'ºC'),
	(112883, 111, '2015-03-15 00:38:56.000000', 'temperatura', 909.0000, 'ºC'),
	(112884, 111, '2015-03-15 00:38:57.000000', 'temperatura', 351.0000, 'ºC'),
	(112885, 111, '2015-03-15 00:38:58.000000', 'temperatura', 230.0000, 'ºC'),
	(112886, 111, '2015-03-15 00:38:59.000000', 'temperatura', 96.0000, 'ºC'),
	(112887, 111, '2015-03-15 00:39:00.000000', 'temperatura', 992.0000, 'ºC'),
	(112888, 111, '2015-03-15 00:39:01.000000', 'temperatura', 1073.0000, 'ºC'),
	(112889, 111, '2015-03-15 00:39:02.000000', 'temperatura', 1189.0000, 'ºC'),
	(112890, 111, '2015-03-15 00:39:03.000000', 'temperatura', 327.0000, 'ºC'),
	(112891, 111, '2015-03-15 00:39:04.000000', 'temperatura', 466.0000, 'ºC'),
	(112892, 111, '2015-03-15 00:39:05.000000', 'temperatura', 153.0000, 'ºC'),
	(112893, 111, '2015-03-15 00:39:06.000000', 'temperatura', 564.0000, 'ºC'),
	(112894, 111, '2015-03-15 00:39:07.000000', 'temperatura', 1165.0000, 'ºC'),
	(112895, 111, '2015-03-15 00:39:08.000000', 'temperatura', 531.0000, 'ºC'),
	(112896, 111, '2015-03-15 00:39:09.000000', 'temperatura', 362.0000, 'ºC'),
	(112897, 111, '2015-03-15 00:39:10.000000', 'temperatura', 218.0000, 'ºC'),
	(112898, 111, '2015-03-15 00:39:11.000000', 'temperatura', 4.0000, 'ºC'),
	(112899, 111, '2015-03-15 00:39:12.000000', 'temperatura', 565.0000, 'ºC'),
	(112900, 111, '2015-03-15 00:39:13.000000', 'temperatura', 412.0000, 'ºC'),
	(112901, 111, '2015-03-15 00:39:14.000000', 'temperatura', 369.0000, 'ºC'),
	(112902, 111, '2015-03-15 00:39:15.000000', 'temperatura', 606.0000, 'ºC'),
	(112903, 111, '2015-03-15 00:39:16.000000', 'temperatura', 726.0000, 'ºC'),
	(112904, 111, '2015-03-15 00:39:17.000000', 'temperatura', 611.0000, 'ºC'),
	(112905, 111, '2015-03-15 00:39:18.000000', 'temperatura', 880.0000, 'ºC'),
	(112906, 111, '2015-03-15 00:39:19.000000', 'temperatura', 167.0000, 'ºC'),
	(112907, 111, '2015-03-15 00:39:20.000000', 'temperatura', 593.0000, 'ºC'),
	(112908, 111, '2015-03-15 00:39:21.000000', 'temperatura', 68.0000, 'ºC'),
	(112909, 111, '2015-03-15 00:39:22.000000', 'temperatura', 959.0000, 'ºC'),
	(112910, 111, '2015-03-15 00:39:23.000000', 'temperatura', 992.0000, 'ºC'),
	(112911, 111, '2015-03-15 00:39:24.000000', 'temperatura', 886.0000, 'ºC'),
	(112912, 111, '2015-03-15 00:39:25.000000', 'temperatura', 252.0000, 'ºC'),
	(112913, 111, '2015-03-15 00:39:26.000000', 'temperatura', 1002.0000, 'ºC'),
	(112914, 111, '2015-03-15 00:39:27.000000', 'temperatura', 656.0000, 'ºC'),
	(112915, 111, '2015-03-15 00:39:28.000000', 'temperatura', 272.0000, 'ºC'),
	(112916, 111, '2015-03-15 00:39:29.000000', 'temperatura', 594.0000, 'ºC'),
	(112917, 111, '2015-03-15 00:39:30.000000', 'temperatura', 953.0000, 'ºC'),
	(112918, 111, '2015-03-15 00:39:31.000000', 'temperatura', 586.0000, 'ºC'),
	(112919, 111, '2015-03-15 00:39:32.000000', 'temperatura', 71.0000, 'ºC'),
	(112920, 111, '2015-03-15 00:39:33.000000', 'temperatura', 997.0000, 'ºC'),
	(112921, 111, '2015-03-15 00:39:34.000000', 'temperatura', 1174.0000, 'ºC'),
	(112922, 111, '2015-03-15 00:39:35.000000', 'temperatura', 480.0000, 'ºC'),
	(112923, 111, '2015-03-15 00:39:36.000000', 'temperatura', 77.0000, 'ºC'),
	(112924, 111, '2015-03-15 00:39:37.000000', 'temperatura', 146.0000, 'ºC'),
	(112925, 111, '2015-03-15 00:39:38.000000', 'temperatura', 498.0000, 'ºC'),
	(112926, 111, '2015-03-15 00:39:39.000000', 'temperatura', 852.0000, 'ºC'),
	(112927, 111, '2015-03-15 00:39:40.000000', 'temperatura', 366.0000, 'ºC'),
	(112928, 111, '2015-03-15 00:39:41.000000', 'temperatura', 477.0000, 'ºC'),
	(112929, 111, '2015-03-15 00:39:42.000000', 'temperatura', 86.0000, 'ºC'),
	(112930, 111, '2015-03-15 00:39:43.000000', 'temperatura', 199.0000, 'ºC'),
	(112931, 111, '2015-03-15 00:39:44.000000', 'temperatura', 736.0000, 'ºC'),
	(112932, 111, '2015-03-15 00:39:45.000000', 'temperatura', 685.0000, 'ºC'),
	(112933, 111, '2015-03-15 00:39:46.000000', 'temperatura', 16.0000, 'ºC'),
	(112934, 111, '2015-03-15 00:39:47.000000', 'temperatura', 428.0000, 'ºC'),
	(112935, 111, '2015-03-15 00:39:48.000000', 'temperatura', 891.0000, 'ºC'),
	(112936, 111, '2015-03-15 00:39:49.000000', 'temperatura', 772.0000, 'ºC'),
	(112937, 111, '2015-03-15 00:39:50.000000', 'temperatura', 1186.0000, 'ºC'),
	(112938, 111, '2015-03-15 00:39:51.000000', 'temperatura', 17.0000, 'ºC'),
	(112939, 111, '2015-03-15 00:39:52.000000', 'temperatura', 127.0000, 'ºC'),
	(112940, 111, '2015-03-15 00:39:53.000000', 'temperatura', 586.0000, 'ºC'),
	(112941, 111, '2015-03-15 00:39:54.000000', 'temperatura', 146.0000, 'ºC'),
	(112942, 111, '2015-03-15 00:39:55.000000', 'temperatura', 176.0000, 'ºC'),
	(112943, 111, '2015-03-15 00:39:56.000000', 'temperatura', 441.0000, 'ºC'),
	(112944, 111, '2015-03-15 00:39:57.000000', 'temperatura', 476.0000, 'ºC'),
	(112945, 111, '2015-03-15 00:39:58.000000', 'temperatura', 1060.0000, 'ºC'),
	(112946, 111, '2015-03-15 00:39:59.000000', 'temperatura', 272.0000, 'ºC'),
	(112947, 111, '2015-03-15 00:40:00.000000', 'temperatura', 579.0000, 'ºC'),
	(112948, 111, '2015-03-15 00:40:01.000000', 'temperatura', 880.0000, 'ºC'),
	(112949, 111, '2015-03-15 00:40:02.000000', 'temperatura', 264.0000, 'ºC'),
	(112950, 111, '2015-03-15 00:40:03.000000', 'temperatura', 1079.0000, 'ºC'),
	(112951, 111, '2015-03-15 00:40:04.000000', 'temperatura', 1005.0000, 'ºC'),
	(112952, 111, '2015-03-15 00:40:05.000000', 'temperatura', 587.0000, 'ºC'),
	(112953, 111, '2015-03-15 00:40:06.000000', 'temperatura', 1120.0000, 'ºC'),
	(112954, 111, '2015-03-15 00:40:07.000000', 'temperatura', 242.0000, 'ºC'),
	(112955, 111, '2015-03-15 00:40:08.000000', 'temperatura', 249.0000, 'ºC'),
	(112956, 111, '2015-03-15 00:40:09.000000', 'temperatura', 522.0000, 'ºC'),
	(112957, 111, '2015-03-15 00:40:10.000000', 'temperatura', 661.0000, 'ºC'),
	(112958, 111, '2015-03-15 00:40:11.000000', 'temperatura', 542.0000, 'ºC'),
	(112959, 111, '2015-03-15 00:40:12.000000', 'temperatura', 727.0000, 'ºC'),
	(112960, 111, '2015-03-15 00:40:13.000000', 'temperatura', 810.0000, 'ºC'),
	(112961, 111, '2015-03-15 00:40:14.000000', 'temperatura', 667.0000, 'ºC'),
	(112962, 111, '2015-03-15 00:40:15.000000', 'temperatura', 907.0000, 'ºC'),
	(112963, 111, '2015-03-15 00:40:16.000000', 'temperatura', 134.0000, 'ºC'),
	(112964, 111, '2015-03-15 00:40:17.000000', 'temperatura', 350.0000, 'ºC'),
	(112965, 111, '2015-03-15 00:40:18.000000', 'temperatura', 147.0000, 'ºC'),
	(112966, 111, '2015-03-15 00:40:19.000000', 'temperatura', 888.0000, 'ºC'),
	(112967, 111, '2015-03-15 00:40:20.000000', 'temperatura', 397.0000, 'ºC'),
	(112968, 111, '2015-03-15 00:40:21.000000', 'temperatura', 521.0000, 'ºC'),
	(112969, 111, '2015-03-15 00:40:22.000000', 'temperatura', 214.0000, 'ºC'),
	(112970, 111, '2015-03-15 00:40:23.000000', 'temperatura', 707.0000, 'ºC'),
	(112971, 111, '2015-03-15 00:40:24.000000', 'temperatura', 496.0000, 'ºC'),
	(112972, 111, '2015-03-15 00:40:25.000000', 'temperatura', 359.0000, 'ºC'),
	(112973, 111, '2015-03-15 00:40:26.000000', 'temperatura', 307.0000, 'ºC'),
	(112974, 111, '2015-03-15 00:40:27.000000', 'temperatura', 460.0000, 'ºC'),
	(112975, 111, '2015-03-15 00:40:28.000000', 'temperatura', 179.0000, 'ºC'),
	(112976, 111, '2015-03-15 00:40:29.000000', 'temperatura', 714.0000, 'ºC'),
	(112977, 111, '2015-03-15 00:40:30.000000', 'temperatura', 632.0000, 'ºC'),
	(112978, 111, '2015-03-15 00:40:31.000000', 'temperatura', 1022.0000, 'ºC'),
	(112979, 111, '2015-03-15 00:40:32.000000', 'temperatura', 814.0000, 'ºC'),
	(112980, 111, '2015-03-15 00:40:33.000000', 'temperatura', 1004.0000, 'ºC'),
	(112981, 111, '2015-03-15 00:40:34.000000', 'temperatura', 177.0000, 'ºC'),
	(112982, 111, '2015-03-15 00:40:35.000000', 'temperatura', 273.0000, 'ºC'),
	(112983, 111, '2015-03-15 00:40:36.000000', 'temperatura', 834.0000, 'ºC'),
	(112984, 111, '2015-03-15 00:40:37.000000', 'temperatura', 954.0000, 'ºC'),
	(112985, 111, '2015-03-15 00:40:38.000000', 'temperatura', 1066.0000, 'ºC'),
	(112986, 111, '2015-03-15 00:40:39.000000', 'temperatura', 71.0000, 'ºC'),
	(112987, 111, '2015-03-15 00:40:40.000000', 'temperatura', 756.0000, 'ºC'),
	(112988, 111, '2015-03-15 00:40:41.000000', 'temperatura', 1168.0000, 'ºC'),
	(112989, 111, '2015-03-15 00:40:42.000000', 'temperatura', 1171.0000, 'ºC'),
	(112990, 111, '2015-03-15 00:40:43.000000', 'temperatura', 1152.0000, 'ºC'),
	(112991, 111, '2015-03-15 00:40:44.000000', 'temperatura', 1049.0000, 'ºC'),
	(112992, 111, '2015-03-15 00:40:45.000000', 'temperatura', 588.0000, 'ºC'),
	(112993, 111, '2015-03-15 00:40:46.000000', 'temperatura', 993.0000, 'ºC'),
	(112994, 111, '2015-03-15 00:40:47.000000', 'temperatura', 800.0000, 'ºC'),
	(112995, 111, '2015-03-15 00:40:48.000000', 'temperatura', 1023.0000, 'ºC'),
	(112996, 111, '2015-03-15 00:40:49.000000', 'temperatura', 317.0000, 'ºC'),
	(112997, 111, '2015-03-15 00:40:50.000000', 'temperatura', 915.0000, 'ºC'),
	(112998, 111, '2015-03-15 00:40:51.000000', 'temperatura', 24.0000, 'ºC'),
	(112999, 111, '2015-03-15 00:40:52.000000', 'temperatura', 976.0000, 'ºC'),
	(113000, 111, '2015-03-15 00:40:53.000000', 'temperatura', 8.0000, 'ºC'),
	(113001, 111, '2015-03-15 00:40:54.000000', 'temperatura', 712.0000, 'ºC'),
	(113002, 111, '2015-03-15 00:40:55.000000', 'temperatura', 1139.0000, 'ºC'),
	(113003, 111, '2015-03-15 00:40:56.000000', 'temperatura', 1156.0000, 'ºC'),
	(113004, 111, '2015-03-15 00:40:57.000000', 'temperatura', 1166.0000, 'ºC'),
	(113005, 111, '2015-03-15 00:40:58.000000', 'temperatura', 1163.0000, 'ºC'),
	(113006, 111, '2015-03-15 00:40:59.000000', 'temperatura', 1118.0000, 'ºC'),
	(113007, 111, '2015-03-15 00:41:00.000000', 'temperatura', 902.0000, 'ºC'),
	(113008, 111, '2015-03-15 00:41:01.000000', 'temperatura', 1154.0000, 'ºC'),
	(113009, 111, '2015-03-15 00:41:02.000000', 'temperatura', 664.0000, 'ºC'),
	(113010, 111, '2015-03-15 00:41:03.000000', 'temperatura', 1058.0000, 'ºC'),
	(113011, 111, '2015-03-15 00:41:04.000000', 'temperatura', 898.0000, 'ºC'),
	(113012, 111, '2015-03-15 00:41:05.000000', 'temperatura', 119.0000, 'ºC'),
	(113013, 111, '2015-03-15 00:41:06.000000', 'temperatura', 300.0000, 'ºC'),
	(113014, 111, '2015-03-15 00:41:07.000000', 'temperatura', 1145.0000, 'ºC'),
	(113015, 111, '2015-03-15 00:41:08.000000', 'temperatura', 24.0000, 'ºC'),
	(113016, 111, '2015-03-15 00:41:09.000000', 'temperatura', 287.0000, 'ºC'),
	(113017, 111, '2015-03-15 00:41:10.000000', 'temperatura', 164.0000, 'ºC'),
	(113018, 111, '2015-03-15 00:41:11.000000', 'temperatura', 1160.0000, 'ºC'),
	(113019, 111, '2015-03-15 00:41:12.000000', 'temperatura', 508.0000, 'ºC'),
	(113020, 111, '2015-03-15 00:41:13.000000', 'temperatura', 259.0000, 'ºC'),
	(113021, 111, '2015-03-15 00:41:14.000000', 'temperatura', 973.0000, 'ºC'),
	(113022, 111, '2015-03-15 00:41:15.000000', 'temperatura', 488.0000, 'ºC'),
	(113023, 111, '2015-03-15 00:41:16.000000', 'temperatura', 720.0000, 'ºC'),
	(113024, 111, '2015-03-15 00:41:17.000000', 'temperatura', 936.0000, 'ºC'),
	(113025, 111, '2015-03-15 00:41:18.000000', 'temperatura', 120.0000, 'ºC'),
	(113026, 111, '2015-03-15 00:41:19.000000', 'temperatura', 192.0000, 'ºC'),
	(113027, 111, '2015-03-15 00:41:20.000000', 'temperatura', 601.0000, 'ºC'),
	(113028, 111, '2015-03-15 00:41:21.000000', 'temperatura', 30.0000, 'ºC'),
	(113029, 111, '2015-03-15 00:41:22.000000', 'temperatura', 748.0000, 'ºC'),
	(113030, 111, '2015-03-15 00:41:23.000000', 'temperatura', 48.0000, 'ºC'),
	(113031, 111, '2015-03-15 00:41:24.000000', 'temperatura', 399.0000, 'ºC'),
	(113032, 111, '2015-03-15 00:41:25.000000', 'temperatura', 652.0000, 'ºC'),
	(113033, 111, '2015-03-15 00:41:26.000000', 'temperatura', 861.0000, 'ºC'),
	(113034, 111, '2015-03-15 00:41:27.000000', 'temperatura', 1149.0000, 'ºC'),
	(113035, 111, '2015-03-15 00:41:28.000000', 'temperatura', 762.0000, 'ºC'),
	(113036, 111, '2015-03-15 00:41:29.000000', 'temperatura', 366.0000, 'ºC'),
	(113037, 111, '2015-03-15 00:41:30.000000', 'temperatura', 744.0000, 'ºC'),
	(113038, 111, '2015-03-15 00:41:31.000000', 'temperatura', 224.0000, 'ºC'),
	(113039, 111, '2015-03-15 00:41:32.000000', 'temperatura', 88.0000, 'ºC'),
	(113040, 111, '2015-03-15 00:41:33.000000', 'temperatura', 966.0000, 'ºC'),
	(113041, 111, '2015-03-15 00:41:34.000000', 'temperatura', 968.0000, 'ºC'),
	(113042, 111, '2015-03-15 00:41:35.000000', 'temperatura', 743.0000, 'ºC'),
	(113043, 111, '2015-03-15 00:41:36.000000', 'temperatura', 810.0000, 'ºC'),
	(113044, 111, '2015-03-15 00:41:37.000000', 'temperatura', 624.0000, 'ºC'),
	(113045, 111, '2015-03-15 00:41:38.000000', 'temperatura', 688.0000, 'ºC'),
	(113046, 111, '2015-03-15 00:41:39.000000', 'temperatura', 370.0000, 'ºC'),
	(113047, 111, '2015-03-15 00:41:40.000000', 'temperatura', 987.0000, 'ºC'),
	(113048, 111, '2015-03-15 00:41:41.000000', 'temperatura', 224.0000, 'ºC'),
	(113049, 111, '2015-03-15 00:41:42.000000', 'temperatura', 560.0000, 'ºC'),
	(113050, 111, '2015-03-15 00:41:43.000000', 'temperatura', 930.0000, 'ºC'),
	(113051, 111, '2015-03-15 00:41:44.000000', 'temperatura', 571.0000, 'ºC'),
	(113052, 111, '2015-03-15 00:41:45.000000', 'temperatura', 66.0000, 'ºC'),
	(113053, 111, '2015-03-15 00:41:46.000000', 'temperatura', 1018.0000, 'ºC'),
	(113054, 111, '2015-03-15 00:41:47.000000', 'temperatura', 94.0000, 'ºC'),
	(113055, 111, '2015-03-15 00:41:48.000000', 'temperatura', 1013.0000, 'ºC'),
	(113056, 111, '2015-03-15 00:41:49.000000', 'temperatura', 1183.0000, 'ºC'),
	(113057, 111, '2015-03-15 00:41:50.000000', 'temperatura', 479.0000, 'ºC'),
	(113058, 111, '2015-03-15 00:41:51.000000', 'temperatura', 44.0000, 'ºC'),
	(113059, 111, '2015-03-15 00:41:52.000000', 'temperatura', 1187.0000, 'ºC'),
	(113060, 111, '2015-03-15 00:41:53.000000', 'temperatura', 1000.0000, 'ºC'),
	(113061, 111, '2015-03-15 00:41:54.000000', 'temperatura', 241.0000, 'ºC'),
	(113062, 111, '2015-03-15 00:41:55.000000', 'temperatura', 604.0000, 'ºC'),
	(113063, 111, '2015-03-15 00:41:56.000000', 'temperatura', 1097.0000, 'ºC'),
	(113064, 111, '2015-03-15 00:41:57.000000', 'temperatura', 75.0000, 'ºC'),
	(113065, 111, '2015-03-15 00:41:58.000000', 'temperatura', 685.0000, 'ºC'),
	(113066, 111, '2015-03-15 00:41:59.000000', 'temperatura', 800.0000, 'ºC'),
	(113067, 111, '2015-03-15 00:42:00.000000', 'temperatura', 746.0000, 'ºC'),
	(113068, 111, '2015-03-15 00:42:01.000000', 'temperatura', 132.0000, 'ºC'),
	(113069, 111, '2015-03-15 00:42:02.000000', 'temperatura', 820.0000, 'ºC'),
	(113070, 111, '2015-03-15 00:42:03.000000', 'temperatura', 105.0000, 'ºC'),
	(113071, 111, '2015-03-15 00:42:04.000000', 'temperatura', 465.0000, 'ºC'),
	(113072, 111, '2015-03-15 00:42:05.000000', 'temperatura', 809.0000, 'ºC'),
	(113073, 111, '2015-03-15 00:42:06.000000', 'temperatura', 252.0000, 'ºC'),
	(113074, 111, '2015-03-15 00:42:07.000000', 'temperatura', 33.0000, 'ºC'),
	(113075, 111, '2015-03-15 00:42:08.000000', 'temperatura', 609.0000, 'ºC'),
	(113076, 111, '2015-03-15 00:42:09.000000', 'temperatura', 545.0000, 'ºC'),
	(113077, 111, '2015-03-15 00:42:10.000000', 'temperatura', 900.0000, 'ºC'),
	(113078, 111, '2015-03-15 00:42:11.000000', 'temperatura', 464.0000, 'ºC'),
	(113079, 111, '2015-03-15 00:42:12.000000', 'temperatura', 823.0000, 'ºC'),
	(113080, 111, '2015-03-15 00:42:13.000000', 'temperatura', 321.0000, 'ºC'),
	(113081, 111, '2015-03-15 00:42:14.000000', 'temperatura', 336.0000, 'ºC'),
	(113082, 111, '2015-03-15 00:42:15.000000', 'temperatura', 717.0000, 'ºC'),
	(113083, 111, '2015-03-15 00:42:16.000000', 'temperatura', 178.0000, 'ºC'),
	(113084, 111, '2015-03-15 00:42:17.000000', 'temperatura', 1140.0000, 'ºC'),
	(113085, 111, '2015-03-15 00:42:18.000000', 'temperatura', 367.0000, 'ºC'),
	(113086, 111, '2015-03-15 00:42:19.000000', 'temperatura', 814.0000, 'ºC'),
	(113087, 111, '2015-03-15 00:42:20.000000', 'temperatura', 569.0000, 'ºC'),
	(113088, 111, '2015-03-15 00:42:21.000000', 'temperatura', 403.0000, 'ºC'),
	(113089, 111, '2015-03-15 00:42:22.000000', 'temperatura', 311.0000, 'ºC'),
	(113090, 111, '2015-03-15 00:42:23.000000', 'temperatura', 347.0000, 'ºC'),
	(113091, 111, '2015-03-15 00:42:24.000000', 'temperatura', 802.0000, 'ºC'),
	(113092, 111, '2015-03-15 00:42:25.000000', 'temperatura', 571.0000, 'ºC'),
	(113093, 111, '2015-03-15 00:42:26.000000', 'temperatura', 449.0000, 'ºC'),
	(113094, 111, '2015-03-15 00:42:27.000000', 'temperatura', 530.0000, 'ºC'),
	(113095, 111, '2015-03-15 00:42:28.000000', 'temperatura', 105.0000, 'ºC'),
	(113096, 111, '2015-03-15 00:42:29.000000', 'temperatura', 135.0000, 'ºC'),
	(113097, 111, '2015-03-15 00:42:30.000000', 'temperatura', 362.0000, 'ºC'),
	(113098, 111, '2015-03-15 00:42:31.000000', 'temperatura', 206.0000, 'ºC'),
	(113099, 111, '2015-03-15 00:42:32.000000', 'temperatura', 1146.0000, 'ºC'),
	(113100, 111, '2015-03-15 00:42:33.000000', 'temperatura', 310.0000, 'ºC'),
	(113101, 111, '2015-03-15 00:42:34.000000', 'temperatura', 511.0000, 'ºC'),
	(113102, 111, '2015-03-15 00:42:35.000000', 'temperatura', 427.0000, 'ºC'),
	(113103, 111, '2015-03-15 00:42:36.000000', 'temperatura', 601.0000, 'ºC'),
	(113104, 111, '2015-03-15 00:42:37.000000', 'temperatura', 526.0000, 'ºC'),
	(113105, 111, '2015-03-15 00:42:38.000000', 'temperatura', 825.0000, 'ºC'),
	(113106, 111, '2015-03-15 00:42:39.000000', 'temperatura', 151.0000, 'ºC'),
	(113107, 111, '2015-03-15 00:42:40.000000', 'temperatura', 678.0000, 'ºC'),
	(113108, 111, '2015-03-15 00:42:41.000000', 'temperatura', 540.0000, 'ºC'),
	(113109, 111, '2015-03-15 00:42:42.000000', 'temperatura', 666.0000, 'ºC'),
	(113110, 111, '2015-03-15 00:42:43.000000', 'temperatura', 508.0000, 'ºC'),
	(113111, 111, '2015-03-15 00:42:44.000000', 'temperatura', 544.0000, 'ºC'),
	(113112, 111, '2015-03-15 00:42:45.000000', 'temperatura', 1196.0000, 'ºC'),
	(113113, 111, '2015-03-15 00:42:46.000000', 'temperatura', 749.0000, 'ºC'),
	(113114, 111, '2015-03-15 00:42:47.000000', 'temperatura', 157.0000, 'ºC'),
	(113115, 111, '2015-03-15 00:42:48.000000', 'temperatura', 939.0000, 'ºC'),
	(113116, 111, '2015-03-15 00:42:49.000000', 'temperatura', 623.0000, 'ºC'),
	(113117, 111, '2015-03-15 00:42:50.000000', 'temperatura', 299.0000, 'ºC'),
	(113118, 111, '2015-03-15 00:42:51.000000', 'temperatura', 827.0000, 'ºC'),
	(113119, 111, '2015-03-15 00:42:52.000000', 'temperatura', 837.0000, 'ºC'),
	(113120, 111, '2015-03-15 00:42:53.000000', 'temperatura', 505.0000, 'ºC'),
	(113121, 111, '2015-03-15 00:42:54.000000', 'temperatura', 13.0000, 'ºC'),
	(113122, 111, '2015-03-15 00:42:55.000000', 'temperatura', 952.0000, 'ºC'),
	(113123, 111, '2015-03-15 00:42:56.000000', 'temperatura', 1123.0000, 'ºC'),
	(113124, 111, '2015-03-15 00:42:57.000000', 'temperatura', 358.0000, 'ºC'),
	(113125, 111, '2015-03-15 00:42:58.000000', 'temperatura', 824.0000, 'ºC'),
	(113126, 111, '2015-03-15 00:42:59.000000', 'temperatura', 644.0000, 'ºC'),
	(113127, 111, '2015-03-15 00:43:00.000000', 'temperatura', 747.0000, 'ºC'),
	(113128, 111, '2015-03-15 00:43:01.000000', 'temperatura', 607.0000, 'ºC'),
	(113129, 111, '2015-03-15 00:43:02.000000', 'temperatura', 791.0000, 'ºC'),
	(113130, 111, '2015-03-15 00:43:03.000000', 'temperatura', 937.0000, 'ºC'),
	(113131, 111, '2015-03-15 00:43:04.000000', 'temperatura', 1111.0000, 'ºC'),
	(113132, 111, '2015-03-15 00:43:05.000000', 'temperatura', 345.0000, 'ºC'),
	(113133, 111, '2015-03-15 00:43:06.000000', 'temperatura', 793.0000, 'ºC'),
	(113134, 111, '2015-03-15 00:43:07.000000', 'temperatura', 529.0000, 'ºC'),
	(113135, 111, '2015-03-15 00:43:08.000000', 'temperatura', 268.0000, 'ºC'),
	(113136, 111, '2015-03-15 00:43:09.000000', 'temperatura', 953.0000, 'ºC'),
	(113137, 111, '2015-03-15 00:43:10.000000', 'temperatura', 363.0000, 'ºC'),
	(113138, 111, '2015-03-15 00:43:11.000000', 'temperatura', 157.0000, 'ºC'),
	(113139, 111, '2015-03-15 00:43:12.000000', 'temperatura', 894.0000, 'ºC'),
	(113140, 111, '2015-03-15 00:43:13.000000', 'temperatura', 400.0000, 'ºC'),
	(113141, 111, '2015-03-15 00:43:14.000000', 'temperatura', 517.0000, 'ºC'),
	(113142, 111, '2015-03-15 00:43:15.000000', 'temperatura', 185.0000, 'ºC'),
	(113143, 111, '2015-03-15 00:43:16.000000', 'temperatura', 578.0000, 'ºC'),
	(113144, 111, '2015-03-15 00:43:17.000000', 'temperatura', 1133.0000, 'ºC'),
	(113145, 111, '2015-03-15 00:43:18.000000', 'temperatura', 333.0000, 'ºC'),
	(113146, 111, '2015-03-15 00:43:19.000000', 'temperatura', 665.0000, 'ºC'),
	(113147, 111, '2015-03-15 00:43:20.000000', 'temperatura', 1126.0000, 'ºC'),
	(113148, 111, '2015-03-15 00:43:21.000000', 'temperatura', 36.0000, 'ºC'),
	(113149, 111, '2015-03-15 00:43:22.000000', 'temperatura', 401.0000, 'ºC'),
	(113150, 111, '2015-03-15 00:43:23.000000', 'temperatura', 699.0000, 'ºC'),
	(113151, 111, '2015-03-15 00:43:24.000000', 'temperatura', 1094.0000, 'ºC'),
	(113152, 111, '2015-03-15 00:43:25.000000', 'temperatura', 973.0000, 'ºC'),
	(113153, 111, '2015-03-15 00:43:26.000000', 'temperatura', 385.0000, 'ºC'),
	(113154, 111, '2015-03-15 00:43:27.000000', 'temperatura', 204.0000, 'ºC'),
	(113155, 111, '2015-03-15 00:43:28.000000', 'temperatura', 1065.0000, 'ºC'),
	(113156, 111, '2015-03-15 00:43:29.000000', 'temperatura', 1114.0000, 'ºC'),
	(113157, 111, '2015-03-15 00:43:30.000000', 'temperatura', 1178.0000, 'ºC'),
	(113158, 111, '2015-03-15 00:43:31.000000', 'temperatura', 146.0000, 'ºC'),
	(113159, 111, '2015-03-15 00:43:32.000000', 'temperatura', 796.0000, 'ºC'),
	(113160, 111, '2015-03-15 00:43:33.000000', 'temperatura', 1143.0000, 'ºC'),
	(113161, 111, '2015-03-15 00:43:34.000000', 'temperatura', 927.0000, 'ºC'),
	(113162, 111, '2015-03-15 00:43:35.000000', 'temperatura', 8.0000, 'ºC'),
	(113163, 111, '2015-03-15 00:43:36.000000', 'temperatura', 858.0000, 'ºC'),
	(113164, 111, '2015-03-15 00:43:37.000000', 'temperatura', 666.0000, 'ºC'),
	(113165, 111, '2015-03-15 00:43:38.000000', 'temperatura', 756.0000, 'ºC'),
	(113166, 111, '2015-03-15 00:43:39.000000', 'temperatura', 583.0000, 'ºC'),
	(113167, 111, '2015-03-15 00:43:40.000000', 'temperatura', 649.0000, 'ºC'),
	(113168, 111, '2015-03-15 00:43:41.000000', 'temperatura', 296.0000, 'ºC'),
	(113169, 111, '2015-03-15 00:43:42.000000', 'temperatura', 734.0000, 'ºC'),
	(113170, 111, '2015-03-15 00:43:43.000000', 'temperatura', 382.0000, 'ºC'),
	(113171, 111, '2015-03-15 00:43:44.000000', 'temperatura', 907.0000, 'ºC'),
	(113172, 111, '2015-03-15 00:43:45.000000', 'temperatura', 989.0000, 'ºC'),
	(113173, 111, '2015-03-15 00:43:46.000000', 'temperatura', 1024.0000, 'ºC'),
	(113174, 111, '2015-03-15 00:43:47.000000', 'temperatura', 953.0000, 'ºC'),
	(113175, 111, '2015-03-15 00:43:48.000000', 'temperatura', 496.0000, 'ºC'),
	(113176, 111, '2015-03-15 00:43:49.000000', 'temperatura', 819.0000, 'ºC'),
	(113177, 111, '2015-03-15 00:43:50.000000', 'temperatura', 207.0000, 'ºC'),
	(113178, 111, '2015-03-15 00:43:51.000000', 'temperatura', 979.0000, 'ºC'),
	(113179, 111, '2015-03-15 00:43:52.000000', 'temperatura', 676.0000, 'ºC'),
	(113180, 111, '2015-03-15 00:43:53.000000', 'temperatura', 443.0000, 'ºC'),
	(113181, 111, '2015-03-15 00:43:54.000000', 'temperatura', 188.0000, 'ºC'),
	(113182, 111, '2015-03-15 00:43:55.000000', 'temperatura', 812.0000, 'ºC'),
	(113183, 111, '2015-03-15 00:43:56.000000', 'temperatura', 1097.0000, 'ºC'),
	(113184, 111, '2015-03-15 00:43:57.000000', 'temperatura', 649.0000, 'ºC'),
	(113185, 111, '2015-03-15 00:43:58.000000', 'temperatura', 1154.0000, 'ºC'),
	(113186, 111, '2015-03-15 00:43:59.000000', 'temperatura', 223.0000, 'ºC'),
	(113187, 111, '2015-03-15 00:44:00.000000', 'temperatura', 55.0000, 'ºC'),
	(113188, 111, '2015-03-15 00:44:01.000000', 'temperatura', 805.0000, 'ºC'),
	(113189, 111, '2015-03-15 00:44:02.000000', 'temperatura', 261.0000, 'ºC'),
	(113190, 111, '2015-03-15 00:44:03.000000', 'temperatura', 91.0000, 'ºC'),
	(113191, 111, '2015-03-15 00:44:04.000000', 'temperatura', 874.0000, 'ºC'),
	(113192, 111, '2015-03-15 00:44:05.000000', 'temperatura', 496.0000, 'ºC'),
	(113193, 111, '2015-03-15 00:44:06.000000', 'temperatura', 1057.0000, 'ºC'),
	(113194, 111, '2015-03-15 00:44:07.000000', 'temperatura', 197.0000, 'ºC'),
	(113195, 111, '2015-03-15 00:44:08.000000', 'temperatura', 216.0000, 'ºC'),
	(113196, 111, '2015-03-15 00:44:09.000000', 'temperatura', 491.0000, 'ºC'),
	(113197, 111, '2015-03-15 00:44:10.000000', 'temperatura', 605.0000, 'ºC'),
	(113198, 111, '2015-03-15 00:44:11.000000', 'temperatura', 353.0000, 'ºC'),
	(113199, 111, '2015-03-15 00:44:12.000000', 'temperatura', 1150.0000, 'ºC'),
	(113200, 111, '2015-03-15 00:44:13.000000', 'temperatura', 1094.0000, 'ºC'),
	(113201, 111, '2015-03-15 00:44:14.000000', 'temperatura', 820.0000, 'ºC'),
	(113202, 111, '2015-03-15 00:44:15.000000', 'temperatura', 817.0000, 'ºC'),
	(113203, 111, '2015-03-15 00:44:16.000000', 'temperatura', 425.0000, 'ºC'),
	(113204, 111, '2015-03-15 00:44:17.000000', 'temperatura', 874.0000, 'ºC'),
	(113205, 111, '2015-03-15 00:44:18.000000', 'temperatura', 698.0000, 'ºC'),
	(113206, 111, '2015-03-15 00:44:19.000000', 'temperatura', 865.0000, 'ºC'),
	(113207, 111, '2015-03-15 00:44:20.000000', 'temperatura', 1035.0000, 'ºC'),
	(113208, 111, '2015-03-15 00:44:21.000000', 'temperatura', 180.0000, 'ºC'),
	(113209, 111, '2015-03-15 00:44:22.000000', 'temperatura', 193.0000, 'ºC'),
	(113210, 111, '2015-03-15 00:44:23.000000', 'temperatura', 429.0000, 'ºC'),
	(113211, 111, '2015-03-15 00:44:24.000000', 'temperatura', 365.0000, 'ºC'),
	(113212, 111, '2015-03-15 00:44:25.000000', 'temperatura', 538.0000, 'ºC'),
	(113213, 111, '2015-03-15 00:44:26.000000', 'temperatura', 397.0000, 'ºC'),
	(113214, 111, '2015-03-15 00:44:27.000000', 'temperatura', 369.0000, 'ºC'),
	(113215, 111, '2015-03-15 00:44:28.000000', 'temperatura', 656.0000, 'ºC'),
	(113216, 111, '2015-03-15 00:44:29.000000', 'temperatura', 974.0000, 'ºC'),
	(113217, 111, '2015-03-15 00:44:30.000000', 'temperatura', 504.0000, 'ºC'),
	(113218, 111, '2015-03-15 00:44:31.000000', 'temperatura', 796.0000, 'ºC'),
	(113219, 111, '2015-03-15 00:44:32.000000', 'temperatura', 69.0000, 'ºC'),
	(113220, 111, '2015-03-15 00:44:33.000000', 'temperatura', 356.0000, 'ºC'),
	(113221, 111, '2015-03-15 00:44:34.000000', 'temperatura', 375.0000, 'ºC'),
	(113222, 111, '2015-03-15 00:44:35.000000', 'temperatura', 809.0000, 'ºC'),
	(113223, 111, '2015-03-15 00:44:36.000000', 'temperatura', 520.0000, 'ºC'),
	(113224, 111, '2015-03-15 00:44:37.000000', 'temperatura', 175.0000, 'ºC'),
	(113225, 111, '2015-03-15 00:44:38.000000', 'temperatura', 514.0000, 'ºC'),
	(113226, 111, '2015-03-15 00:44:39.000000', 'temperatura', 847.0000, 'ºC'),
	(113227, 111, '2015-03-15 00:44:40.000000', 'temperatura', 294.0000, 'ºC'),
	(113228, 111, '2015-03-15 00:44:41.000000', 'temperatura', 127.0000, 'ºC'),
	(113229, 111, '2015-03-15 00:44:42.000000', 'temperatura', 956.0000, 'ºC'),
	(113230, 111, '2015-03-15 00:44:43.000000', 'temperatura', 797.0000, 'ºC'),
	(113231, 111, '2015-03-15 00:44:44.000000', 'temperatura', 1120.0000, 'ºC'),
	(113232, 111, '2015-03-15 00:44:45.000000', 'temperatura', 808.0000, 'ºC'),
	(113233, 111, '2015-03-15 00:44:46.000000', 'temperatura', 679.0000, 'ºC'),
	(113234, 111, '2015-03-15 00:44:47.000000', 'temperatura', 974.0000, 'ºC'),
	(113235, 111, '2015-03-15 00:44:48.000000', 'temperatura', 431.0000, 'ºC'),
	(113236, 111, '2015-03-15 00:44:49.000000', 'temperatura', 434.0000, 'ºC'),
	(113237, 111, '2015-03-15 00:44:50.000000', 'temperatura', 877.0000, 'ºC'),
	(113238, 111, '2015-03-15 00:44:51.000000', 'temperatura', 684.0000, 'ºC'),
	(113239, 111, '2015-03-15 00:44:52.000000', 'temperatura', 791.0000, 'ºC'),
	(113240, 111, '2015-03-15 00:44:53.000000', 'temperatura', 702.0000, 'ºC'),
	(113241, 111, '2015-03-15 00:44:54.000000', 'temperatura', 1137.0000, 'ºC'),
	(113242, 111, '2015-03-15 00:44:55.000000', 'temperatura', 1181.0000, 'ºC'),
	(113243, 111, '2015-03-15 00:44:56.000000', 'temperatura', 93.0000, 'ºC'),
	(113244, 111, '2015-03-15 00:44:57.000000', 'temperatura', 524.0000, 'ºC'),
	(113245, 111, '2015-03-15 00:44:58.000000', 'temperatura', 1139.0000, 'ºC'),
	(113246, 111, '2015-03-15 00:44:59.000000', 'temperatura', 527.0000, 'ºC'),
	(113247, 111, '2015-03-15 00:45:00.000000', 'temperatura', 416.0000, 'ºC'),
	(113248, 111, '2015-03-15 00:45:01.000000', 'temperatura', 500.0000, 'ºC'),
	(113249, 111, '2015-03-15 00:45:02.000000', 'temperatura', 53.0000, 'ºC'),
	(113250, 111, '2015-03-15 00:45:03.000000', 'temperatura', 1164.0000, 'ºC'),
	(113251, 111, '2015-03-15 00:45:04.000000', 'temperatura', 863.0000, 'ºC'),
	(113252, 111, '2015-03-15 00:45:05.000000', 'temperatura', 823.0000, 'ºC'),
	(113253, 111, '2015-03-15 00:45:06.000000', 'temperatura', 329.0000, 'ºC'),
	(113254, 111, '2015-03-15 00:45:07.000000', 'temperatura', 373.0000, 'ºC'),
	(113255, 111, '2015-03-15 00:45:08.000000', 'temperatura', 878.0000, 'ºC'),
	(113256, 111, '2015-03-15 00:45:09.000000', 'temperatura', 874.0000, 'ºC'),
	(113257, 111, '2015-03-15 00:45:10.000000', 'temperatura', 535.0000, 'ºC'),
	(113258, 111, '2015-03-15 00:45:11.000000', 'temperatura', 56.0000, 'ºC'),
	(113259, 111, '2015-03-15 00:45:12.000000', 'temperatura', 1072.0000, 'ºC'),
	(113260, 111, '2015-03-15 00:45:13.000000', 'temperatura', 395.0000, 'ºC'),
	(113261, 111, '2015-03-15 00:45:14.000000', 'temperatura', 1160.0000, 'ºC'),
	(113262, 111, '2015-03-15 00:45:15.000000', 'temperatura', 1015.0000, 'ºC'),
	(113263, 111, '2015-03-15 00:45:16.000000', 'temperatura', 396.0000, 'ºC'),
	(113264, 111, '2015-03-15 00:45:17.000000', 'temperatura', 136.0000, 'ºC'),
	(113265, 111, '2015-03-15 00:45:18.000000', 'temperatura', 694.0000, 'ºC'),
	(113266, 111, '2015-03-15 00:45:19.000000', 'temperatura', 659.0000, 'ºC'),
	(113267, 111, '2015-03-15 00:45:20.000000', 'temperatura', 14.0000, 'ºC'),
	(113268, 111, '2015-03-15 00:45:21.000000', 'temperatura', 496.0000, 'ºC'),
	(113269, 111, '2015-03-15 00:45:22.000000', 'temperatura', 35.0000, 'ºC'),
	(113270, 111, '2015-03-15 00:45:23.000000', 'temperatura', 1091.0000, 'ºC'),
	(113271, 111, '2015-03-15 00:45:24.000000', 'temperatura', 548.0000, 'ºC'),
	(113272, 111, '2015-03-15 00:45:25.000000', 'temperatura', 669.0000, 'ºC'),
	(113273, 111, '2015-03-15 00:45:26.000000', 'temperatura', 501.0000, 'ºC'),
	(113274, 111, '2015-03-15 00:45:27.000000', 'temperatura', 497.0000, 'ºC'),
	(113275, 111, '2015-03-15 00:45:28.000000', 'temperatura', 984.0000, 'ºC'),
	(113276, 111, '2015-03-15 00:45:29.000000', 'temperatura', 1030.0000, 'ºC'),
	(113277, 111, '2015-03-15 00:45:30.000000', 'temperatura', 999.0000, 'ºC'),
	(113278, 111, '2015-03-15 00:45:31.000000', 'temperatura', 703.0000, 'ºC'),
	(113279, 111, '2015-03-15 00:45:32.000000', 'temperatura', 520.0000, 'ºC'),
	(113280, 111, '2015-03-15 00:45:33.000000', 'temperatura', 492.0000, 'ºC'),
	(113281, 111, '2015-03-15 00:45:34.000000', 'temperatura', 902.0000, 'ºC'),
	(113282, 111, '2015-03-15 00:45:35.000000', 'temperatura', 631.0000, 'ºC'),
	(113283, 111, '2015-03-15 00:45:36.000000', 'temperatura', 452.0000, 'ºC'),
	(113284, 111, '2015-03-15 00:45:37.000000', 'temperatura', 368.0000, 'ºC'),
	(113285, 111, '2015-03-15 00:45:38.000000', 'temperatura', 485.0000, 'ºC'),
	(113286, 111, '2015-03-15 00:45:39.000000', 'temperatura', 122.0000, 'ºC'),
	(113287, 111, '2015-03-15 00:45:40.000000', 'temperatura', 354.0000, 'ºC'),
	(113288, 111, '2015-03-15 00:45:41.000000', 'temperatura', 206.0000, 'ºC'),
	(113289, 111, '2015-03-15 00:45:42.000000', 'temperatura', 1169.0000, 'ºC'),
	(113290, 111, '2015-03-15 00:45:43.000000', 'temperatura', 427.0000, 'ºC'),
	(113291, 111, '2015-03-15 00:45:44.000000', 'temperatura', 1029.0000, 'ºC'),
	(113292, 111, '2015-03-15 00:45:45.000000', 'temperatura', 263.0000, 'ºC'),
	(113293, 111, '2015-03-15 00:45:46.000000', 'temperatura', 627.0000, 'ºC'),
	(113294, 111, '2015-03-15 00:45:47.000000', 'temperatura', 1149.0000, 'ºC'),
	(113295, 111, '2015-03-15 00:45:48.000000', 'temperatura', 263.0000, 'ºC'),
	(113296, 111, '2015-03-15 00:45:49.000000', 'temperatura', 269.0000, 'ºC'),
	(113297, 111, '2015-03-15 00:45:50.000000', 'temperatura', 557.0000, 'ºC'),
	(113298, 111, '2015-03-15 00:45:51.000000', 'temperatura', 780.0000, 'ºC'),
	(113299, 111, '2015-03-15 00:45:52.000000', 'temperatura', 1027.0000, 'ºC'),
	(113300, 111, '2015-03-15 00:45:53.000000', 'temperatura', 394.0000, 'ºC'),
	(113301, 111, '2015-03-15 00:45:54.000000', 'temperatura', 92.0000, 'ºC'),
	(113302, 111, '2015-03-15 00:45:55.000000', 'temperatura', 479.0000, 'ºC'),
	(113303, 111, '2015-03-15 00:45:56.000000', 'temperatura', 917.0000, 'ºC'),
	(113304, 111, '2015-03-15 00:45:57.000000', 'temperatura', 751.0000, 'ºC'),
	(113305, 111, '2015-03-15 00:45:58.000000', 'temperatura', 1005.0000, 'ºC'),
	(113306, 111, '2015-03-15 00:45:59.000000', 'temperatura', 372.0000, 'ºC'),
	(113307, 111, '2015-03-15 00:46:00.000000', 'temperatura', 45.0000, 'ºC'),
	(113308, 111, '2015-03-15 00:46:01.000000', 'temperatura', 309.0000, 'ºC'),
	(113309, 111, '2015-03-15 00:46:02.000000', 'temperatura', 209.0000, 'ºC'),
	(113310, 111, '2015-03-15 00:46:03.000000', 'temperatura', 119.0000, 'ºC'),
	(113311, 111, '2015-03-15 00:46:04.000000', 'temperatura', 1170.0000, 'ºC'),
	(113312, 111, '2015-03-15 00:46:05.000000', 'temperatura', 695.0000, 'ºC'),
	(113313, 111, '2015-03-15 00:46:06.000000', 'temperatura', 1162.0000, 'ºC'),
	(113314, 111, '2015-03-15 00:46:07.000000', 'temperatura', 128.0000, 'ºC'),
	(113315, 111, '2015-03-15 00:46:08.000000', 'temperatura', 752.0000, 'ºC'),
	(113316, 111, '2015-03-15 00:46:09.000000', 'temperatura', 978.0000, 'ºC'),
	(113317, 111, '2015-03-15 00:46:10.000000', 'temperatura', 233.0000, 'ºC'),
	(113318, 111, '2015-03-15 00:46:11.000000', 'temperatura', 633.0000, 'ºC'),
	(113319, 111, '2015-03-15 00:46:12.000000', 'temperatura', 65.0000, 'ºC'),
	(113320, 111, '2015-03-15 00:46:13.000000', 'temperatura', 825.0000, 'ºC'),
	(113321, 111, '2015-03-15 00:46:14.000000', 'temperatura', 333.0000, 'ºC'),
	(113322, 111, '2015-03-15 00:46:15.000000', 'temperatura', 391.0000, 'ºC'),
	(113323, 111, '2015-03-15 00:46:16.000000', 'temperatura', 954.0000, 'ºC'),
	(113324, 111, '2015-03-15 00:46:17.000000', 'temperatura', 0.0000, 'ºC'),
	(113325, 111, '2015-03-15 00:46:18.000000', 'temperatura', 736.0000, 'ºC'),
	(113326, 111, '2015-03-15 00:46:19.000000', 'temperatura', 83.0000, 'ºC'),
	(113327, 111, '2015-03-15 00:46:20.000000', 'temperatura', 605.0000, 'ºC'),
	(113328, 111, '2015-03-15 00:46:21.000000', 'temperatura', 379.0000, 'ºC'),
	(113329, 111, '2015-03-15 00:46:22.000000', 'temperatura', 81.0000, 'ºC'),
	(113330, 111, '2015-03-15 00:46:23.000000', 'temperatura', 467.0000, 'ºC'),
	(113331, 111, '2015-03-15 00:46:24.000000', 'temperatura', 893.0000, 'ºC'),
	(113332, 111, '2015-03-15 00:46:25.000000', 'temperatura', 664.0000, 'ºC'),
	(113333, 111, '2015-03-15 00:46:26.000000', 'temperatura', 643.0000, 'ºC'),
	(113334, 111, '2015-03-15 00:46:27.000000', 'temperatura', 25.0000, 'ºC'),
	(113335, 111, '2015-03-15 00:46:28.000000', 'temperatura', 593.0000, 'ºC'),
	(113336, 111, '2015-03-15 00:46:29.000000', 'temperatura', 494.0000, 'ºC'),
	(113337, 111, '2015-03-15 00:46:30.000000', 'temperatura', 689.0000, 'ºC'),
	(113338, 111, '2015-03-15 00:46:31.000000', 'temperatura', 765.0000, 'ºC'),
	(113339, 111, '2015-03-15 00:46:32.000000', 'temperatura', 558.0000, 'ºC'),
	(113340, 111, '2015-03-15 00:46:33.000000', 'temperatura', 497.0000, 'ºC'),
	(113341, 111, '2015-03-15 00:46:34.000000', 'temperatura', 810.0000, 'ºC'),
	(113342, 111, '2015-03-15 00:46:35.000000', 'temperatura', 159.0000, 'ºC'),
	(113343, 111, '2015-03-15 00:46:36.000000', 'temperatura', 766.0000, 'ºC'),
	(113344, 111, '2015-03-15 00:46:37.000000', 'temperatura', 952.0000, 'ºC'),
	(113345, 111, '2015-03-15 00:46:38.000000', 'temperatura', 64.0000, 'ºC'),
	(113346, 111, '2015-03-15 00:46:39.000000', 'temperatura', 1066.0000, 'ºC'),
	(113347, 111, '2015-03-15 00:46:40.000000', 'temperatura', 338.0000, 'ºC'),
	(113348, 111, '2015-03-15 00:46:41.000000', 'temperatura', 892.0000, 'ºC'),
	(113349, 111, '2015-03-15 00:46:42.000000', 'temperatura', 1046.0000, 'ºC'),
	(113350, 111, '2015-03-15 00:46:43.000000', 'temperatura', 156.0000, 'ºC'),
	(113351, 111, '2015-03-15 00:46:44.000000', 'temperatura', 43.0000, 'ºC'),
	(113352, 111, '2015-03-15 00:46:45.000000', 'temperatura', 948.0000, 'ºC'),
	(113353, 111, '2015-03-15 00:46:46.000000', 'temperatura', 1010.0000, 'ºC'),
	(113354, 111, '2015-03-15 00:46:47.000000', 'temperatura', 1009.0000, 'ºC'),
	(113355, 111, '2015-03-15 00:46:48.000000', 'temperatura', 813.0000, 'ºC'),
	(113356, 111, '2015-03-15 00:46:49.000000', 'temperatura', 1040.0000, 'ºC'),
	(113357, 111, '2015-03-15 00:46:50.000000', 'temperatura', 362.0000, 'ºC'),
	(113358, 111, '2015-03-15 00:46:51.000000', 'temperatura', 1090.0000, 'ºC'),
	(113359, 111, '2015-03-15 00:46:52.000000', 'temperatura', 766.0000, 'ºC'),
	(113360, 111, '2015-03-15 00:46:53.000000', 'temperatura', 558.0000, 'ºC'),
	(113361, 111, '2015-03-15 00:46:54.000000', 'temperatura', 492.0000, 'ºC'),
	(113362, 111, '2015-03-15 00:46:55.000000', 'temperatura', 787.0000, 'ºC'),
	(113363, 111, '2015-03-15 00:46:56.000000', 'temperatura', 61.0000, 'ºC'),
	(113364, 111, '2015-03-15 00:46:57.000000', 'temperatura', 344.0000, 'ºC'),
	(113365, 111, '2015-03-15 00:46:58.000000', 'temperatura', 335.0000, 'ºC'),
	(113366, 111, '2015-03-15 00:46:59.000000', 'temperatura', 646.0000, 'ºC'),
	(113367, 111, '2015-03-15 00:47:00.000000', 'temperatura', 1027.0000, 'ºC'),
	(113368, 111, '2015-03-15 00:47:01.000000', 'temperatura', 795.0000, 'ºC'),
	(113369, 111, '2015-03-15 00:47:02.000000', 'temperatura', 896.0000, 'ºC'),
	(113370, 111, '2015-03-15 00:47:03.000000', 'temperatura', 895.0000, 'ºC'),
	(113371, 111, '2015-03-15 00:47:04.000000', 'temperatura', 587.0000, 'ºC'),
	(113372, 111, '2015-03-15 00:47:05.000000', 'temperatura', 249.0000, 'ºC'),
	(113373, 111, '2015-03-15 00:47:06.000000', 'temperatura', 684.0000, 'ºC'),
	(113374, 111, '2015-03-15 00:47:07.000000', 'temperatura', 277.0000, 'ºC'),
	(113375, 111, '2015-03-15 00:47:08.000000', 'temperatura', 531.0000, 'ºC'),
	(113376, 111, '2015-03-15 00:47:09.000000', 'temperatura', 624.0000, 'ºC'),
	(113377, 111, '2015-03-15 00:47:10.000000', 'temperatura', 330.0000, 'ºC'),
	(113378, 111, '2015-03-15 00:47:11.000000', 'temperatura', 977.0000, 'ºC'),
	(113379, 111, '2015-03-15 00:47:12.000000', 'temperatura', 296.0000, 'ºC'),
	(113380, 111, '2015-03-15 00:47:13.000000', 'temperatura', 950.0000, 'ºC'),
	(113381, 111, '2015-03-15 00:47:14.000000', 'temperatura', 261.0000, 'ºC'),
	(113382, 111, '2015-03-15 00:47:15.000000', 'temperatura', 857.0000, 'ºC'),
	(113383, 111, '2015-03-15 00:47:16.000000', 'temperatura', 1102.0000, 'ºC'),
	(113384, 111, '2015-03-15 00:47:17.000000', 'temperatura', 540.0000, 'ºC'),
	(113385, 111, '2015-03-15 00:47:18.000000', 'temperatura', 594.0000, 'ºC'),
	(113386, 111, '2015-03-15 00:47:19.000000', 'temperatura', 152.0000, 'ºC'),
	(113387, 111, '2015-03-15 00:47:20.000000', 'temperatura', 176.0000, 'ºC'),
	(113388, 111, '2015-03-15 00:47:21.000000', 'temperatura', 427.0000, 'ºC'),
	(113389, 111, '2015-03-15 00:47:22.000000', 'temperatura', 408.0000, 'ºC'),
	(113390, 111, '2015-03-15 00:47:23.000000', 'temperatura', 759.0000, 'ºC'),
	(113391, 111, '2015-03-15 00:47:24.000000', 'temperatura', 173.0000, 'ºC'),
	(113392, 111, '2015-03-15 00:47:25.000000', 'temperatura', 986.0000, 'ºC'),
	(113393, 111, '2015-03-15 00:47:26.000000', 'temperatura', 812.0000, 'ºC'),
	(113394, 111, '2015-03-15 00:47:27.000000', 'temperatura', 1104.0000, 'ºC'),
	(113395, 111, '2015-03-15 00:47:28.000000', 'temperatura', 685.0000, 'ºC'),
	(113396, 111, '2015-03-15 00:47:29.000000', 'temperatura', 111.0000, 'ºC'),
	(113397, 111, '2015-03-15 00:47:30.000000', 'temperatura', 900.0000, 'ºC'),
	(113398, 111, '2015-03-15 00:47:31.000000', 'temperatura', 568.0000, 'ºC'),
	(113399, 111, '2015-03-15 00:47:32.000000', 'temperatura', 142.0000, 'ºC'),
	(113400, 111, '2015-03-15 00:47:33.000000', 'temperatura', 207.0000, 'ºC'),
	(113401, 111, '2015-03-15 00:47:34.000000', 'temperatura', 608.0000, 'ºC'),
	(113402, 111, '2015-03-15 00:47:35.000000', 'temperatura', 19.0000, 'ºC'),
	(113403, 111, '2015-03-15 00:47:36.000000', 'temperatura', 673.0000, 'ºC'),
	(113404, 111, '2015-03-15 00:47:37.000000', 'temperatura', 906.0000, 'ºC'),
	(113405, 111, '2015-03-15 00:47:38.000000', 'temperatura', 114.0000, 'ºC'),
	(113406, 111, '2015-03-15 00:47:39.000000', 'temperatura', 254.0000, 'ºC'),
	(113407, 111, '2015-03-15 00:47:40.000000', 'temperatura', 925.0000, 'ºC'),
	(113408, 111, '2015-03-15 00:47:41.000000', 'temperatura', 264.0000, 'ºC'),
	(113409, 111, '2015-03-15 00:47:42.000000', 'temperatura', 946.0000, 'ºC'),
	(113410, 111, '2015-03-15 00:47:43.000000', 'temperatura', 340.0000, 'ºC'),
	(113411, 111, '2015-03-15 00:47:44.000000', 'temperatura', 62.0000, 'ºC'),
	(113412, 111, '2015-03-15 00:47:45.000000', 'temperatura', 491.0000, 'ºC'),
	(113413, 111, '2015-03-15 00:47:46.000000', 'temperatura', 1070.0000, 'ºC'),
	(113414, 111, '2015-03-15 00:47:47.000000', 'temperatura', 277.0000, 'ºC'),
	(113415, 111, '2015-03-15 00:47:48.000000', 'temperatura', 576.0000, 'ºC'),
	(113416, 111, '2015-03-15 00:47:49.000000', 'temperatura', 847.0000, 'ºC'),
	(113417, 111, '2015-03-15 00:47:50.000000', 'temperatura', 110.0000, 'ºC'),
	(113418, 111, '2015-03-15 00:47:51.000000', 'temperatura', 407.0000, 'ºC'),
	(113419, 111, '2015-03-15 00:47:52.000000', 'temperatura', 509.0000, 'ºC'),
	(113420, 111, '2015-03-15 00:47:53.000000', 'temperatura', 121.0000, 'ºC'),
	(113421, 111, '2015-03-15 00:47:54.000000', 'temperatura', 280.0000, 'ºC'),
	(113422, 111, '2015-03-15 00:47:55.000000', 'temperatura', 1037.0000, 'ºC'),
	(113423, 111, '2015-03-15 00:47:56.000000', 'temperatura', 745.0000, 'ºC'),
	(113424, 111, '2015-03-15 00:47:57.000000', 'temperatura', 617.0000, 'ºC'),
	(113425, 111, '2015-03-15 00:47:58.000000', 'temperatura', 847.0000, 'ºC'),
	(113426, 111, '2015-03-15 00:47:59.000000', 'temperatura', 1188.0000, 'ºC'),
	(113427, 111, '2015-03-15 00:48:00.000000', 'temperatura', 998.0000, 'ºC'),
	(113428, 111, '2015-03-15 00:48:01.000000', 'temperatura', 226.0000, 'ºC'),
	(113429, 111, '2015-03-15 00:48:02.000000', 'temperatura', 536.0000, 'ºC'),
	(113430, 111, '2015-03-15 00:48:03.000000', 'temperatura', 803.0000, 'ºC'),
	(113431, 111, '2015-03-15 00:48:04.000000', 'temperatura', 10.0000, 'ºC'),
	(113432, 111, '2015-03-15 00:48:05.000000', 'temperatura', 38.0000, 'ºC'),
	(113433, 111, '2015-03-15 00:48:06.000000', 'temperatura', 161.0000, 'ºC'),
	(113434, 111, '2015-03-15 00:48:07.000000', 'temperatura', 693.0000, 'ºC'),
	(113435, 111, '2015-03-15 00:48:08.000000', 'temperatura', 583.0000, 'ºC'),
	(113436, 111, '2015-03-15 00:48:09.000000', 'temperatura', 835.0000, 'ºC'),
	(113437, 111, '2015-03-15 00:48:10.000000', 'temperatura', 25.0000, 'ºC'),
	(113438, 111, '2015-03-15 00:48:11.000000', 'temperatura', 22.0000, 'ºC'),
	(113439, 111, '2015-03-15 00:48:12.000000', 'temperatura', 37.0000, 'ºC'),
	(113440, 111, '2015-03-15 00:48:13.000000', 'temperatura', 117.0000, 'ºC'),
	(113441, 111, '2015-03-15 00:48:14.000000', 'temperatura', 476.0000, 'ºC'),
	(113442, 111, '2015-03-15 00:48:15.000000', 'temperatura', 831.0000, 'ºC'),
	(113443, 111, '2015-03-15 00:48:16.000000', 'temperatura', 327.0000, 'ºC'),
	(113444, 111, '2015-03-15 00:48:17.000000', 'temperatura', 344.0000, 'ºC'),
	(113445, 111, '2015-03-15 00:48:18.000000', 'temperatura', 736.0000, 'ºC'),
	(113446, 111, '2015-03-15 00:48:19.000000', 'temperatura', 252.0000, 'ºC'),
	(113447, 111, '2015-03-15 00:48:20.000000', 'temperatura', 249.0000, 'ºC'),
	(113448, 111, '2015-03-15 00:48:21.000000', 'temperatura', 492.0000, 'ºC'),
	(113449, 111, '2015-03-15 00:48:22.000000', 'temperatura', 512.0000, 'ºC'),
	(113450, 111, '2015-03-15 00:48:23.000000', 'temperatura', 1084.0000, 'ºC'),
	(113451, 111, '2015-03-15 00:48:24.000000', 'temperatura', 286.0000, 'ºC'),
	(113452, 111, '2015-03-15 00:48:25.000000', 'temperatura', 579.0000, 'ºC'),
	(113453, 111, '2015-03-15 00:48:26.000000', 'temperatura', 839.0000, 'ºC'),
	(113454, 111, '2015-03-15 00:48:27.000000', 'temperatura', 55.0000, 'ºC'),
	(113455, 111, '2015-03-15 00:48:28.000000', 'temperatura', 161.0000, 'ºC'),
	(113456, 111, '2015-03-15 00:48:29.000000', 'temperatura', 639.0000, 'ºC'),
	(113457, 111, '2015-03-15 00:48:30.000000', 'temperatura', 314.0000, 'ºC'),
	(113458, 111, '2015-03-15 00:48:31.000000', 'temperatura', 851.0000, 'ºC'),
	(113459, 111, '2015-03-15 00:48:32.000000', 'temperatura', 917.0000, 'ºC'),
	(113460, 111, '2015-03-15 00:48:33.000000', 'temperatura', 830.0000, 'ºC'),
	(113461, 111, '2015-03-15 00:48:34.000000', 'temperatura', 201.0000, 'ºC'),
	(113462, 111, '2015-03-15 00:48:35.000000', 'temperatura', 915.0000, 'ºC'),
	(113463, 111, '2015-03-15 00:48:36.000000', 'temperatura', 371.0000, 'ºC'),
	(113464, 111, '2015-03-15 00:48:37.000000', 'temperatura', 311.0000, 'ºC'),
	(113465, 111, '2015-03-15 00:48:38.000000', 'temperatura', 444.0000, 'ºC'),
	(113466, 111, '2015-03-15 00:48:39.000000', 'temperatura', 85.0000, 'ºC'),
	(113467, 111, '2015-03-15 00:48:40.000000', 'temperatura', 296.0000, 'ºC'),
	(113468, 111, '2015-03-15 00:48:41.000000', 'temperatura', 24.0000, 'ºC'),
	(113469, 111, '2015-03-15 00:48:42.000000', 'temperatura', 434.0000, 'ºC'),
	(113470, 111, '2015-03-15 00:48:43.000000', 'temperatura', 899.0000, 'ºC'),
	(113471, 111, '2015-03-15 00:48:44.000000', 'temperatura', 791.0000, 'ºC'),
	(113472, 111, '2015-03-15 00:48:45.000000', 'temperatura', 58.0000, 'ºC'),
	(113473, 111, '2015-03-15 00:48:46.000000', 'temperatura', 320.0000, 'ºC'),
	(113474, 111, '2015-03-15 00:48:47.000000', 'temperatura', 226.0000, 'ºC'),
	(113475, 111, '2015-03-15 00:48:48.000000', 'temperatura', 169.0000, 'ºC'),
	(113476, 111, '2015-03-15 00:48:49.000000', 'temperatura', 167.0000, 'ºC'),
	(113477, 111, '2015-03-15 00:48:50.000000', 'temperatura', 331.0000, 'ºC'),
	(113478, 111, '2015-03-15 00:48:51.000000', 'temperatura', 1154.0000, 'ºC'),
	(113479, 111, '2015-03-15 00:48:52.000000', 'temperatura', 1175.0000, 'ºC'),
	(113480, 111, '2015-03-15 00:48:53.000000', 'temperatura', 15.0000, 'ºC'),
	(113481, 111, '2015-03-15 00:48:54.000000', 'temperatura', 150.0000, 'ºC'),
	(113482, 111, '2015-03-15 00:48:55.000000', 'temperatura', 704.0000, 'ºC'),
	(113483, 111, '2015-03-15 00:48:56.000000', 'temperatura', 670.0000, 'ºC'),
	(113484, 111, '2015-03-15 00:48:57.000000', 'temperatura', 42.0000, 'ºC'),
	(113485, 111, '2015-03-15 00:48:58.000000', 'temperatura', 598.0000, 'ºC'),
	(113486, 111, '2015-03-15 00:48:59.000000', 'temperatura', 463.0000, 'ºC'),
	(113487, 111, '2015-03-15 00:49:00.000000', 'temperatura', 523.0000, 'ºC'),
	(113488, 111, '2015-03-15 00:49:01.000000', 'temperatura', 28.0000, 'ºC'),
	(113489, 111, '2015-03-15 00:49:02.000000', 'temperatura', 969.0000, 'ºC'),
	(113490, 111, '2015-03-15 00:49:03.000000', 'temperatura', 1163.0000, 'ºC'),
	(113491, 111, '2015-03-15 00:49:04.000000', 'temperatura', 506.0000, 'ºC'),
	(113492, 111, '2015-03-15 00:49:05.000000', 'temperatura', 244.0000, 'ºC'),
	(113493, 111, '2015-03-15 00:49:06.000000', 'temperatura', 904.0000, 'ºC'),
	(113494, 111, '2015-03-15 00:49:07.000000', 'temperatura', 186.0000, 'ºC'),
	(113495, 111, '2015-03-15 00:49:08.000000', 'temperatura', 618.0000, 'ºC'),
	(113496, 111, '2015-03-15 00:49:09.000000', 'temperatura', 133.0000, 'ºC'),
	(113497, 111, '2015-03-15 00:49:10.000000', 'temperatura', 13.0000, 'ºC'),
	(113498, 111, '2015-03-15 00:49:11.000000', 'temperatura', 865.0000, 'ºC'),
	(113499, 111, '2015-03-15 00:49:12.000000', 'temperatura', 688.0000, 'ºC'),
	(113500, 111, '2015-03-15 00:49:13.000000', 'temperatura', 844.0000, 'ºC'),
	(113501, 111, '2015-03-15 00:49:14.000000', 'temperatura', 956.0000, 'ºC'),
	(113502, 111, '2015-03-15 00:49:15.000000', 'temperatura', 1047.0000, 'ºC'),
	(113503, 111, '2015-03-15 00:49:16.000000', 'temperatura', 1169.0000, 'ºC'),
	(113504, 111, '2015-03-15 00:49:17.000000', 'temperatura', 306.0000, 'ºC'),
	(113505, 111, '2015-03-15 00:49:18.000000', 'temperatura', 422.0000, 'ºC'),
	(113506, 111, '2015-03-15 00:49:19.000000', 'temperatura', 1195.0000, 'ºC'),
	(113507, 111, '2015-03-15 00:49:20.000000', 'temperatura', 1107.0000, 'ºC'),
	(113508, 111, '2015-03-15 00:49:21.000000', 'temperatura', 753.0000, 'ºC'),
	(113509, 111, '2015-03-15 00:49:22.000000', 'temperatura', 441.0000, 'ºC'),
	(113510, 111, '2015-03-15 00:49:23.000000', 'temperatura', 1149.0000, 'ºC'),
	(113511, 111, '2015-03-15 00:49:24.000000', 'temperatura', 820.0000, 'ºC'),
	(113512, 111, '2015-03-15 00:49:25.000000', 'temperatura', 655.0000, 'ºC'),
	(113513, 111, '2015-03-15 00:49:26.000000', 'temperatura', 817.0000, 'ºC'),
	(113514, 111, '2015-03-15 00:49:27.000000', 'temperatura', 918.0000, 'ºC'),
	(113515, 111, '2015-03-15 00:49:28.000000', 'temperatura', 941.0000, 'ºC'),
	(113516, 111, '2015-03-15 00:49:29.000000', 'temperatura', 752.0000, 'ºC'),
	(113517, 111, '2015-03-15 00:49:30.000000', 'temperatura', 935.0000, 'ºC'),
	(113518, 111, '2015-03-15 00:49:31.000000', 'temperatura', 22.0000, 'ºC'),
	(113519, 111, '2015-03-15 00:49:32.000000', 'temperatura', 906.0000, 'ºC'),
	(113520, 111, '2015-03-15 00:49:33.000000', 'temperatura', 863.0000, 'ºC'),
	(113521, 111, '2015-03-15 00:49:34.000000', 'temperatura', 400.0000, 'ºC'),
	(113522, 111, '2015-03-15 00:49:35.000000', 'temperatura', 610.0000, 'ºC'),
	(113523, 111, '2015-03-15 00:49:36.000000', 'temperatura', 651.0000, 'ºC'),
	(113524, 111, '2015-03-15 00:49:37.000000', 'temperatura', 227.0000, 'ºC'),
	(113525, 111, '2015-03-15 00:49:38.000000', 'temperatura', 382.0000, 'ºC'),
	(113526, 111, '2015-03-15 00:49:39.000000', 'temperatura', 28.0000, 'ºC'),
	(113527, 111, '2015-03-15 00:49:40.000000', 'temperatura', 196.0000, 'ºC'),
	(113528, 111, '2015-03-15 00:49:41.000000', 'temperatura', 894.0000, 'ºC'),
	(113529, 111, '2015-03-15 00:49:42.000000', 'temperatura', 285.0000, 'ºC'),
	(113530, 111, '2015-03-15 00:49:43.000000', 'temperatura', 1143.0000, 'ºC'),
	(113531, 111, '2015-03-15 00:49:44.000000', 'temperatura', 62.0000, 'ºC'),
	(113532, 111, '2015-03-15 00:49:45.000000', 'temperatura', 479.0000, 'ºC'),
	(113533, 111, '2015-03-15 00:49:46.000000', 'temperatura', 1011.0000, 'ºC'),
	(113534, 111, '2015-03-15 00:49:47.000000', 'temperatura', 17.0000, 'ºC'),
	(113535, 111, '2015-03-15 00:49:48.000000', 'temperatura', 655.0000, 'ºC'),
	(113536, 111, '2015-03-15 00:49:49.000000', 'temperatura', 825.0000, 'ºC'),
	(113537, 111, '2015-03-15 00:49:50.000000', 'temperatura', 959.0000, 'ºC'),
	(113538, 111, '2015-03-15 00:49:51.000000', 'temperatura', 1122.0000, 'ºC'),
	(113539, 111, '2015-03-15 00:49:52.000000', 'temperatura', 331.0000, 'ºC'),
	(113540, 111, '2015-03-15 00:49:53.000000', 'temperatura', 690.0000, 'ºC'),
	(113541, 111, '2015-03-15 00:49:54.000000', 'temperatura', 59.0000, 'ºC'),
	(113542, 111, '2015-03-15 00:49:55.000000', 'temperatura', 623.0000, 'ºC'),
	(113543, 111, '2015-03-15 00:49:56.000000', 'temperatura', 541.0000, 'ºC'),
	(113544, 111, '2015-03-15 00:49:57.000000', 'temperatura', 837.0000, 'ºC'),
	(113545, 111, '2015-03-15 00:49:58.000000', 'temperatura', 160.0000, 'ºC'),
	(113546, 111, '2015-03-15 00:49:59.000000', 'temperatura', 689.0000, 'ºC'),
	(113547, 111, '2015-03-15 00:50:00.000000', 'temperatura', 567.0000, 'ºC'),
	(113548, 111, '2015-03-15 00:50:01.000000', 'temperatura', 769.0000, 'ºC'),
	(113549, 111, '2015-03-15 00:50:02.000000', 'temperatura', 942.0000, 'ºC'),
	(113550, 111, '2015-03-15 00:50:03.000000', 'temperatura', 4.0000, 'ºC'),
	(113551, 111, '2015-03-15 00:50:04.000000', 'temperatura', 795.0000, 'ºC'),
	(113552, 111, '2015-03-15 00:50:05.000000', 'temperatura', 366.0000, 'ºC'),
	(113553, 111, '2015-03-15 00:50:06.000000', 'temperatura', 642.0000, 'ºC'),
	(113554, 111, '2015-03-15 00:50:07.000000', 'temperatura', 915.0000, 'ºC'),
	(113555, 111, '2015-03-15 00:50:08.000000', 'temperatura', 251.0000, 'ºC'),
	(113556, 111, '2015-03-15 00:50:09.000000', 'temperatura', 907.0000, 'ºC'),
	(113557, 111, '2015-03-15 00:50:10.000000', 'temperatura', 183.0000, 'ºC'),
	(113558, 111, '2015-03-15 00:50:11.000000', 'temperatura', 597.0000, 'ºC'),
	(113559, 111, '2015-03-15 00:50:12.000000', 'temperatura', 34.0000, 'ºC'),
	(113560, 111, '2015-03-15 00:50:13.000000', 'temperatura', 780.0000, 'ºC'),
	(113561, 111, '2015-03-15 00:50:14.000000', 'temperatura', 199.0000, 'ºC'),
	(113562, 111, '2015-03-15 00:50:15.000000', 'temperatura', 1056.0000, 'ºC'),
	(113563, 111, '2015-03-15 00:50:16.000000', 'temperatura', 1084.0000, 'ºC'),
	(113564, 111, '2015-03-15 00:50:17.000000', 'temperatura', 1053.0000, 'ºC'),
	(113565, 111, '2015-03-15 00:50:18.000000', 'temperatura', 813.0000, 'ºC'),
	(113566, 111, '2015-03-15 00:50:19.000000', 'temperatura', 906.0000, 'ºC'),
	(113567, 111, '2015-03-15 00:50:20.000000', 'temperatura', 893.0000, 'ºC'),
	(113568, 111, '2015-03-15 00:50:21.000000', 'temperatura', 546.0000, 'ºC'),
	(113569, 111, '2015-03-15 00:50:22.000000', 'temperatura', 51.0000, 'ºC'),
	(113570, 111, '2015-03-15 00:50:23.000000', 'temperatura', 1019.0000, 'ºC'),
	(113571, 111, '2015-03-15 00:50:24.000000', 'temperatura', 141.0000, 'ºC'),
	(113572, 111, '2015-03-15 00:50:25.000000', 'temperatura', 51.0000, 'ºC'),
	(113573, 111, '2015-03-15 00:50:26.000000', 'temperatura', 1030.0000, 'ºC'),
	(113574, 111, '2015-03-15 00:50:27.000000', 'temperatura', 198.0000, 'ºC'),
	(113575, 111, '2015-03-15 00:50:28.000000', 'temperatura', 301.0000, 'ºC'),
	(113576, 111, '2015-03-15 00:50:29.000000', 'temperatura', 912.0000, 'ºC'),
	(113577, 111, '2015-03-15 00:50:30.000000', 'temperatura', 59.0000, 'ºC'),
	(113578, 111, '2015-03-15 00:50:31.000000', 'temperatura', 1158.0000, 'ºC'),
	(113579, 111, '2015-03-15 00:50:32.000000', 'temperatura', 812.0000, 'ºC'),
	(113580, 111, '2015-03-15 00:50:33.000000', 'temperatura', 589.0000, 'ºC'),
	(113581, 111, '2015-03-15 00:50:34.000000', 'temperatura', 507.0000, 'ºC'),
	(113582, 111, '2015-03-15 00:50:35.000000', 'temperatura', 771.0000, 'ºC'),
	(113583, 111, '2015-03-15 00:50:36.000000', 'temperatura', 1133.0000, 'ºC'),
	(113584, 111, '2015-03-15 00:50:37.000000', 'temperatura', 952.0000, 'ºC'),
	(113585, 111, '2015-03-15 00:50:38.000000', 'temperatura', 162.0000, 'ºC'),
	(113586, 111, '2015-03-15 00:50:39.000000', 'temperatura', 353.0000, 'ºC'),
	(113587, 111, '2015-03-15 00:50:40.000000', 'temperatura', 79.0000, 'ºC'),
	(113588, 111, '2015-03-15 00:50:41.000000', 'temperatura', 539.0000, 'ºC'),
	(113589, 111, '2015-03-15 00:50:42.000000', 'temperatura', 56.0000, 'ºC'),
	(113590, 111, '2015-03-15 00:50:43.000000', 'temperatura', 1064.0000, 'ºC'),
	(113591, 111, '2015-03-15 00:50:44.000000', 'temperatura', 354.0000, 'ºC'),
	(113592, 111, '2015-03-15 00:50:45.000000', 'temperatura', 977.0000, 'ºC'),
	(113593, 111, '2015-03-15 00:50:46.000000', 'temperatura', 223.0000, 'ºC'),
	(113594, 111, '2015-03-15 00:50:47.000000', 'temperatura', 583.0000, 'ºC'),
	(113595, 111, '2015-03-15 00:50:48.000000', 'temperatura', 1049.0000, 'ºC'),
	(113596, 111, '2015-03-15 00:50:49.000000', 'temperatura', 1095.0000, 'ºC'),
	(113597, 111, '2015-03-15 00:50:50.000000', 'temperatura', 1129.0000, 'ºC'),
	(113598, 111, '2015-03-15 00:50:51.000000', 'temperatura', 1159.0000, 'ºC'),
	(113599, 111, '2015-03-15 00:50:52.000000', 'temperatura', 11.0000, 'ºC'),
	(113600, 111, '2015-03-15 00:50:53.000000', 'temperatura', 178.0000, 'ºC'),
	(113601, 111, '2015-03-15 00:50:54.000000', 'temperatura', 855.0000, 'ºC'),
	(113602, 111, '2015-03-15 00:50:55.000000', 'temperatura', 144.0000, 'ºC'),
	(113603, 111, '2015-03-15 00:50:56.000000', 'temperatura', 554.0000, 'ºC'),
	(113604, 111, '2015-03-15 00:50:57.000000', 'temperatura', 1138.0000, 'ºC'),
	(113605, 111, '2015-03-15 00:50:58.000000', 'temperatura', 430.0000, 'ºC'),
	(113606, 111, '2015-03-15 00:50:59.000000', 'temperatura', 1136.0000, 'ºC'),
	(113607, 111, '2015-03-15 00:51:00.000000', 'temperatura', 792.0000, 'ºC'),
	(113608, 111, '2015-03-15 00:51:01.000000', 'temperatura', 553.0000, 'ºC'),
	(113609, 111, '2015-03-15 00:51:02.000000', 'temperatura', 388.0000, 'ºC'),
	(113610, 111, '2015-03-15 00:51:03.000000', 'temperatura', 282.0000, 'ºC'),
	(113611, 111, '2015-03-15 00:51:04.000000', 'temperatura', 246.0000, 'ºC'),
	(113612, 111, '2015-03-15 00:51:05.000000', 'temperatura', 383.0000, 'ºC'),
	(113613, 111, '2015-03-15 00:51:06.000000', 'temperatura', 1181.0000, 'ºC'),
	(113614, 111, '2015-03-15 00:51:07.000000', 'temperatura', 1154.0000, 'ºC'),
	(113615, 111, '2015-03-15 00:51:08.000000', 'temperatura', 1026.0000, 'ºC'),
	(113616, 111, '2015-03-15 00:51:09.000000', 'temperatura', 470.0000, 'ºC'),
	(113617, 111, '2015-03-15 00:51:10.000000', 'temperatura', 474.0000, 'ºC'),
	(113618, 111, '2015-03-15 00:51:11.000000', 'temperatura', 957.0000, 'ºC'),
	(113619, 111, '2015-03-15 00:51:12.000000', 'temperatura', 967.0000, 'ºC'),
	(113620, 111, '2015-03-15 00:51:13.000000', 'temperatura', 764.0000, 'ºC'),
	(113621, 111, '2015-03-15 00:51:14.000000', 'temperatura', 918.0000, 'ºC'),
	(113622, 111, '2015-03-15 00:51:15.000000', 'temperatura', 1099.0000, 'ºC'),
	(113623, 111, '2015-03-15 00:51:16.000000', 'temperatura', 342.0000, 'ºC'),
	(113624, 111, '2015-03-15 00:51:17.000000', 'temperatura', 815.0000, 'ºC'),
	(113625, 111, '2015-03-15 00:51:18.000000', 'temperatura', 648.0000, 'ºC'),
	(113626, 111, '2015-03-15 00:51:19.000000', 'temperatura', 796.0000, 'ºC'),
	(113627, 111, '2015-03-15 00:51:20.000000', 'temperatura', 836.0000, 'ºC'),
	(113628, 111, '2015-03-15 00:51:21.000000', 'temperatura', 591.0000, 'ºC'),
	(113629, 111, '2015-03-15 00:51:22.000000', 'temperatura', 449.0000, 'ºC'),
	(113630, 111, '2015-03-15 00:51:23.000000', 'temperatura', 471.0000, 'ºC'),
	(113631, 111, '2015-03-15 00:51:24.000000', 'temperatura', 1008.0000, 'ºC'),
	(113632, 111, '2015-03-15 00:51:25.000000', 'temperatura', 29.0000, 'ºC'),
	(113633, 111, '2015-03-15 00:51:26.000000', 'temperatura', 722.0000, 'ºC'),
	(113634, 111, '2015-03-15 00:51:27.000000', 'temperatura', 1122.0000, 'ºC'),
	(113635, 111, '2015-03-15 00:51:28.000000', 'temperatura', 1046.0000, 'ºC'),
	(113636, 111, '2015-03-15 00:51:29.000000', 'temperatura', 663.0000, 'ºC'),
	(113637, 111, '2015-03-15 00:51:30.000000', 'temperatura', 178.0000, 'ºC'),
	(113638, 111, '2015-03-15 00:51:31.000000', 'temperatura', 101.0000, 'ºC'),
	(113639, 111, '2015-03-15 00:51:32.000000', 'temperatura', 1170.0000, 'ºC'),
	(113640, 111, '2015-03-15 00:51:33.000000', 'temperatura', 750.0000, 'ºC'),
	(113641, 111, '2015-03-15 00:51:34.000000', 'temperatura', 240.0000, 'ºC'),
	(113642, 111, '2015-03-15 00:51:35.000000', 'temperatura', 151.0000, 'ºC'),
	(113643, 111, '2015-03-15 00:51:36.000000', 'temperatura', 35.0000, 'ºC'),
	(113644, 111, '2015-03-15 00:51:37.000000', 'temperatura', 923.0000, 'ºC'),
	(113645, 111, '2015-03-15 00:51:38.000000', 'temperatura', 911.0000, 'ºC'),
	(113646, 111, '2015-03-15 00:51:39.000000', 'temperatura', 588.0000, 'ºC'),
	(113647, 111, '2015-03-15 00:51:40.000000', 'temperatura', 206.0000, 'ºC'),
	(113648, 111, '2015-03-15 00:51:41.000000', 'temperatura', 466.0000, 'ºC'),
	(113649, 111, '2015-03-15 00:51:42.000000', 'temperatura', 511.0000, 'ºC'),
	(113650, 111, '2015-03-15 00:51:43.000000', 'temperatura', 1161.0000, 'ºC'),
	(113651, 111, '2015-03-15 00:51:44.000000', 'temperatura', 670.0000, 'ºC'),
	(113652, 111, '2015-03-15 00:51:45.000000', 'temperatura', 1067.0000, 'ºC'),
	(113653, 111, '2015-03-15 00:51:46.000000', 'temperatura', 925.0000, 'ºC'),
	(113654, 111, '2015-03-15 00:51:47.000000', 'temperatura', 224.0000, 'ºC'),
	(113655, 111, '2015-03-15 00:51:48.000000', 'temperatura', 746.0000, 'ºC'),
	(113656, 111, '2015-03-15 00:51:49.000000', 'temperatura', 658.0000, 'ºC'),
	(113657, 111, '2015-03-15 00:51:50.000000', 'temperatura', 1055.0000, 'ºC'),
	(113658, 111, '2015-03-15 00:51:51.000000', 'temperatura', 901.0000, 'ºC'),
	(113659, 111, '2015-03-15 00:51:52.000000', 'temperatura', 140.0000, 'ºC'),
	(113660, 111, '2015-03-15 00:51:53.000000', 'temperatura', 398.0000, 'ºC'),
	(113661, 111, '2015-03-15 00:51:54.000000', 'temperatura', 369.0000, 'ºC'),
	(113662, 111, '2015-03-15 00:51:55.000000', 'temperatura', 653.0000, 'ºC'),
	(113663, 111, '2015-03-15 00:51:56.000000', 'temperatura', 959.0000, 'ºC'),
	(113664, 111, '2015-03-15 00:51:57.000000', 'temperatura', 434.0000, 'ºC'),
	(113665, 111, '2015-03-15 00:51:58.000000', 'temperatura', 494.0000, 'ºC'),
	(113666, 111, '2015-03-15 00:51:59.000000', 'temperatura', 1169.0000, 'ºC'),
	(113667, 111, '2015-03-15 00:52:00.000000', 'temperatura', 762.0000, 'ºC'),
	(113668, 111, '2015-03-15 00:52:01.000000', 'temperatura', 306.0000, 'ºC'),
	(113669, 111, '2015-03-15 00:52:02.000000', 'temperatura', 443.0000, 'ºC'),
	(113670, 111, '2015-03-15 00:52:03.000000', 'temperatura', 99.0000, 'ºC'),
	(113671, 111, '2015-03-15 00:52:04.000000', 'temperatura', 367.0000, 'ºC'),
	(113672, 111, '2015-03-15 00:52:05.000000', 'temperatura', 336.0000, 'ºC'),
	(113673, 111, '2015-03-15 00:52:06.000000', 'temperatura', 582.0000, 'ºC'),
	(113674, 111, '2015-03-15 00:52:07.000000', 'temperatura', 703.0000, 'ºC'),
	(113675, 111, '2015-03-15 00:52:08.000000', 'temperatura', 568.0000, 'ºC'),
	(113676, 111, '2015-03-15 00:52:09.000000', 'temperatura', 731.0000, 'ºC'),
	(113677, 111, '2015-03-15 00:52:10.000000', 'temperatura', 754.0000, 'ºC'),
	(113678, 111, '2015-03-15 00:52:11.000000', 'temperatura', 374.0000, 'ºC'),
	(113679, 111, '2015-03-15 00:52:12.000000', 'temperatura', 812.0000, 'ºC'),
	(113680, 111, '2015-03-15 00:52:13.000000', 'temperatura', 537.0000, 'ºC'),
	(113681, 111, '2015-03-15 00:52:14.000000', 'temperatura', 251.0000, 'ºC'),
	(113682, 111, '2015-03-15 00:52:15.000000', 'temperatura', 842.0000, 'ºC'),
	(113683, 111, '2015-03-15 00:52:16.000000', 'temperatura', 1057.0000, 'ºC'),
	(113684, 111, '2015-03-15 00:52:17.000000', 'temperatura', 359.0000, 'ºC'),
	(113685, 111, '2015-03-15 00:52:18.000000', 'temperatura', 1027.0000, 'ºC'),
	(113686, 111, '2015-03-15 00:52:19.000000', 'temperatura', 458.0000, 'ºC'),
	(113687, 111, '2015-03-15 00:52:20.000000', 'temperatura', 407.0000, 'ºC'),
	(113688, 111, '2015-03-15 00:52:21.000000', 'temperatura', 665.0000, 'ºC'),
	(113689, 111, '2015-03-15 00:52:22.000000', 'temperatura', 903.0000, 'ºC'),
	(113690, 111, '2015-03-15 00:52:23.000000', 'temperatura', 120.0000, 'ºC'),
	(113691, 111, '2015-03-15 00:52:24.000000', 'temperatura', 291.0000, 'ºC'),
	(113692, 111, '2015-03-15 00:52:25.000000', 'temperatura', 1095.0000, 'ºC'),
	(113693, 111, '2015-03-15 00:52:26.000000', 'temperatura', 1002.0000, 'ºC'),
	(113694, 111, '2015-03-15 00:52:27.000000', 'temperatura', 525.0000, 'ºC'),
	(113695, 111, '2015-03-15 00:52:28.000000', 'temperatura', 821.0000, 'ºC'),
	(113696, 111, '2015-03-15 00:52:29.000000', 'temperatura', 128.0000, 'ºC'),
	(113697, 111, '2015-03-15 00:52:30.000000', 'temperatura', 579.0000, 'ºC'),
	(113698, 111, '2015-03-15 00:52:31.000000', 'temperatura', 114.0000, 'ºC'),
	(113699, 111, '2015-03-15 00:52:32.000000', 'temperatura', 30.0000, 'ºC'),
	(113700, 111, '2015-03-15 00:52:33.000000', 'temperatura', 1009.0000, 'ºC'),
	(113701, 111, '2015-03-15 00:52:34.000000', 'temperatura', 157.0000, 'ºC'),
	(113702, 111, '2015-03-15 00:52:35.000000', 'temperatura', 157.0000, 'ºC'),
	(113703, 111, '2015-03-15 00:52:36.000000', 'temperatura', 316.0000, 'ºC'),
	(113704, 111, '2015-03-15 00:52:37.000000', 'temperatura', 1107.0000, 'ºC'),
	(113705, 111, '2015-03-15 00:52:38.000000', 'temperatura', 989.0000, 'ºC'),
	(113706, 111, '2015-03-15 00:52:39.000000', 'temperatura', 424.0000, 'ºC'),
	(113707, 111, '2015-03-15 00:52:40.000000', 'temperatura', 352.0000, 'ºC'),
	(113708, 111, '2015-03-15 00:52:41.000000', 'temperatura', 491.0000, 'ºC'),
	(113709, 111, '2015-03-15 00:52:42.000000', 'temperatura', 198.0000, 'ºC'),
	(113710, 111, '2015-03-15 00:52:43.000000', 'temperatura', 716.0000, 'ºC'),
	(113711, 111, '2015-03-15 00:52:44.000000', 'temperatura', 589.0000, 'ºC'),
	(113712, 111, '2015-03-15 00:52:45.000000', 'temperatura', 795.0000, 'ºC'),
	(113713, 111, '2015-03-15 00:52:46.000000', 'temperatura', 1011.0000, 'ºC'),
	(113714, 111, '2015-03-15 00:52:47.000000', 'temperatura', 270.0000, 'ºC'),
	(113715, 111, '2015-03-15 00:52:48.000000', 'temperatura', 718.0000, 'ºC'),
	(113716, 111, '2015-03-15 00:52:49.000000', 'temperatura', 381.0000, 'ºC'),
	(113717, 111, '2015-03-15 00:52:50.000000', 'temperatura', 953.0000, 'ºC'),
	(113718, 111, '2015-03-15 00:52:51.000000', 'temperatura', 20.0000, 'ºC'),
	(113719, 111, '2015-03-15 00:52:52.000000', 'temperatura', 844.0000, 'ºC'),
	(113720, 111, '2015-03-15 00:52:53.000000', 'temperatura', 560.0000, 'ºC'),
	(113721, 111, '2015-03-15 00:52:54.000000', 'temperatura', 266.0000, 'ºC'),
	(113722, 111, '2015-03-15 00:52:55.000000', 'temperatura', 854.0000, 'ºC'),
	(113723, 111, '2015-03-15 00:52:56.000000', 'temperatura', 1071.0000, 'ºC'),
	(113724, 111, '2015-03-15 00:52:57.000000', 'temperatura', 393.0000, 'ºC'),
	(113725, 111, '2015-03-15 00:52:58.000000', 'temperatura', 1152.0000, 'ºC'),
	(113726, 111, '2015-03-15 00:52:59.000000', 'temperatura', 982.0000, 'ºC'),
	(113727, 111, '2015-03-15 00:53:00.000000', 'temperatura', 255.0000, 'ºC'),
	(113728, 111, '2015-03-15 00:53:01.000000', 'temperatura', 727.0000, 'ºC'),
	(113729, 111, '2015-03-15 00:53:02.000000', 'temperatura', 473.0000, 'ºC'),
	(113730, 111, '2015-03-15 00:53:03.000000', 'temperatura', 183.0000, 'ºC'),
	(113731, 111, '2015-03-15 00:53:04.000000', 'temperatura', 697.0000, 'ºC'),
	(113732, 111, '2015-03-15 00:53:05.000000', 'temperatura', 535.0000, 'ºC'),
	(113733, 111, '2015-03-15 00:53:06.000000', 'temperatura', 587.0000, 'ºC'),
	(113734, 111, '2015-03-15 00:53:07.000000', 'temperatura', 130.0000, 'ºC'),
	(113735, 111, '2015-03-15 00:53:08.000000', 'temperatura', 87.0000, 'ºC'),
	(113736, 111, '2015-03-15 00:53:09.000000', 'temperatura', 49.0000, 'ºC'),
	(113737, 111, '2015-03-15 00:53:10.000000', 'temperatura', 1183.0000, 'ºC'),
	(113738, 111, '2015-03-15 00:53:11.000000', 'temperatura', 969.0000, 'ºC'),
	(113739, 111, '2015-03-15 00:53:12.000000', 'temperatura', 98.0000, 'ºC'),
	(113740, 111, '2015-03-15 00:53:13.000000', 'temperatura', 1182.0000, 'ºC'),
	(113741, 111, '2015-03-15 00:53:14.000000', 'temperatura', 817.0000, 'ºC'),
	(113742, 111, '2015-03-15 00:53:15.000000', 'temperatura', 541.0000, 'ºC'),
	(113743, 111, '2015-03-15 00:53:16.000000', 'temperatura', 254.0000, 'ºC'),
	(113744, 111, '2015-03-15 00:53:17.000000', 'temperatura', 849.0000, 'ºC'),
	(113745, 111, '2015-03-15 00:53:18.000000', 'temperatura', 1080.0000, 'ºC'),
	(113746, 111, '2015-03-15 00:53:19.000000', 'temperatura', 456.0000, 'ºC'),
	(113747, 111, '2015-03-15 00:53:20.000000', 'temperatura', 240.0000, 'ºC'),
	(113748, 111, '2015-03-15 00:53:21.000000', 'temperatura', 1033.0000, 'ºC'),
	(113749, 111, '2015-03-15 00:53:22.000000', 'temperatura', 845.0000, 'ºC'),
	(113750, 111, '2015-03-15 00:53:23.000000', 'temperatura', 1127.0000, 'ºC'),
	(113751, 111, '2015-03-15 00:53:24.000000', 'temperatura', 701.0000, 'ºC'),
	(113752, 111, '2015-03-15 00:53:25.000000', 'temperatura', 126.0000, 'ºC'),
	(113753, 111, '2015-03-15 00:53:26.000000', 'temperatura', 926.0000, 'ºC'),
	(113754, 111, '2015-03-15 00:53:27.000000', 'temperatura', 653.0000, 'ºC'),
	(113755, 111, '2015-03-15 00:53:28.000000', 'temperatura', 488.0000, 'ºC'),
	(113756, 111, '2015-03-15 00:53:29.000000', 'temperatura', 482.0000, 'ºC'),
	(113757, 111, '2015-03-15 00:53:30.000000', 'temperatura', 946.0000, 'ºC'),
	(113758, 111, '2015-03-15 00:53:31.000000', 'temperatura', 883.0000, 'ºC'),
	(113759, 111, '2015-03-15 00:53:32.000000', 'temperatura', 377.0000, 'ºC'),
	(113760, 111, '2015-03-15 00:53:33.000000', 'temperatura', 436.0000, 'ºC'),
	(113761, 111, '2015-03-15 00:53:34.000000', 'temperatura', 1052.0000, 'ºC'),
	(113762, 111, '2015-03-15 00:53:35.000000', 'temperatura', 351.0000, 'ºC'),
	(113763, 111, '2015-03-15 00:53:36.000000', 'temperatura', 1000.0000, 'ºC'),
	(113764, 111, '2015-03-15 00:53:37.000000', 'temperatura', 347.0000, 'ºC'),
	(113765, 111, '2015-03-15 00:53:38.000000', 'temperatura', 1138.0000, 'ºC'),
	(113766, 111, '2015-03-15 00:53:39.000000', 'temperatura', 1047.0000, 'ºC'),
	(113767, 111, '2015-03-15 00:53:40.000000', 'temperatura', 622.0000, 'ºC'),
	(113768, 111, '2015-03-15 00:53:41.000000', 'temperatura', 1168.0000, 'ºC'),
	(113769, 111, '2015-03-15 00:53:42.000000', 'temperatura', 376.0000, 'ºC'),
	(113770, 111, '2015-03-15 00:53:43.000000', 'temperatura', 778.0000, 'ºC'),
	(113771, 111, '2015-03-15 00:53:44.000000', 'temperatura', 361.0000, 'ºC'),
	(113772, 111, '2015-03-15 00:53:45.000000', 'temperatura', 673.0000, 'ºC'),
	(113773, 111, '2015-03-15 00:53:46.000000', 'temperatura', 1080.0000, 'ºC'),
	(113774, 111, '2015-03-15 00:53:47.000000', 'temperatura', 982.0000, 'ºC'),
	(113775, 111, '2015-03-15 00:53:48.000000', 'temperatura', 472.0000, 'ºC'),
	(113776, 111, '2015-03-15 00:53:49.000000', 'temperatura', 616.0000, 'ºC'),
	(113777, 111, '2015-03-15 00:53:50.000000', 'temperatura', 462.0000, 'ºC'),
	(113778, 111, '2015-03-15 00:53:51.000000', 'temperatura', 463.0000, 'ºC'),
	(113779, 111, '2015-03-15 00:53:52.000000', 'temperatura', 930.0000, 'ºC'),
	(113780, 111, '2015-03-15 00:53:53.000000', 'temperatura', 860.0000, 'ºC'),
	(113781, 111, '2015-03-15 00:53:54.000000', 'temperatura', 312.0000, 'ºC'),
	(113782, 111, '2015-03-15 00:53:55.000000', 'temperatura', 178.0000, 'ºC'),
	(113783, 111, '2015-03-15 00:53:56.000000', 'temperatura', 1156.0000, 'ºC'),
	(113784, 111, '2015-03-15 00:53:57.000000', 'temperatura', 445.0000, 'ºC'),
	(113785, 111, '2015-03-15 00:53:58.000000', 'temperatura', 1156.0000, 'ºC'),
	(113786, 111, '2015-03-15 00:53:59.000000', 'temperatura', 849.0000, 'ºC'),
	(113787, 111, '2015-03-15 00:54:00.000000', 'temperatura', 776.0000, 'ºC'),
	(113788, 111, '2015-03-15 00:54:01.000000', 'temperatura', 135.0000, 'ºC'),
	(113789, 111, '2015-03-15 00:54:02.000000', 'temperatura', 745.0000, 'ºC'),
	(113790, 111, '2015-03-15 00:54:03.000000', 'temperatura', 920.0000, 'ºC'),
	(113791, 111, '2015-03-15 00:54:04.000000', 'temperatura', 1165.0000, 'ºC'),
	(113792, 111, '2015-03-15 00:54:05.000000', 'temperatura', 665.0000, 'ºC'),
	(113793, 111, '2015-03-15 00:54:06.000000', 'temperatura', 1031.0000, 'ºC'),
	(113794, 111, '2015-03-15 00:54:07.000000', 'temperatura', 761.0000, 'ºC'),
	(113795, 111, '2015-03-15 00:54:08.000000', 'temperatura', 711.0000, 'ºC'),
	(113796, 111, '2015-03-15 00:54:09.000000', 'temperatura', 73.0000, 'ºC'),
	(113797, 111, '2015-03-15 00:54:10.000000', 'temperatura', 634.0000, 'ºC'),
	(113798, 111, '2015-03-15 00:54:11.000000', 'temperatura', 550.0000, 'ºC'),
	(113799, 111, '2015-03-15 00:54:12.000000', 'temperatura', 850.0000, 'ºC'),
	(113800, 111, '2015-03-15 00:54:13.000000', 'temperatura', 200.0000, 'ºC'),
	(113801, 111, '2015-03-15 00:54:14.000000', 'temperatura', 852.0000, 'ºC'),
	(113802, 111, '2015-03-15 00:54:15.000000', 'temperatura', 61.0000, 'ºC'),
	(113803, 111, '2015-03-15 00:54:16.000000', 'temperatura', 148.0000, 'ºC'),
	(113804, 111, '2015-03-15 00:54:17.000000', 'temperatura', 557.0000, 'ºC'),
	(113805, 111, '2015-03-15 00:54:18.000000', 'temperatura', 1140.0000, 'ºC'),
	(113806, 111, '2015-03-15 00:54:19.000000', 'temperatura', 432.0000, 'ºC'),
	(113807, 111, '2015-03-15 00:54:20.000000', 'temperatura', 1142.0000, 'ºC'),
	(113808, 111, '2015-03-15 00:54:21.000000', 'temperatura', 811.0000, 'ºC'),
	(113809, 111, '2015-03-15 00:54:22.000000', 'temperatura', 633.0000, 'ºC'),
	(113810, 111, '2015-03-15 00:54:23.000000', 'temperatura', 731.0000, 'ºC'),
	(113811, 111, '2015-03-15 00:54:24.000000', 'temperatura', 555.0000, 'ºC'),
	(113812, 111, '2015-03-15 00:54:25.000000', 'temperatura', 585.0000, 'ºC'),
	(113813, 111, '2015-03-15 00:54:26.000000', 'temperatura', 61.0000, 'ºC'),
	(113814, 111, '2015-03-15 00:54:27.000000', 'temperatura', 950.0000, 'ºC'),
	(113815, 111, '2015-03-15 00:54:28.000000', 'temperatura', 968.0000, 'ºC'),
	(113816, 111, '2015-03-15 00:54:29.000000', 'temperatura', 788.0000, 'ºC'),
	(113817, 111, '2015-03-15 00:54:30.000000', 'temperatura', 1038.0000, 'ºC'),
	(113818, 111, '2015-03-15 00:54:31.000000', 'temperatura', 425.0000, 'ºC'),
	(113819, 111, '2015-03-15 00:54:32.000000', 'temperatura', 212.0000, 'ºC'),
	(113820, 111, '2015-03-15 00:54:33.000000', 'temperatura', 986.0000, 'ºC'),
	(113821, 111, '2015-03-15 00:54:34.000000', 'temperatura', 695.0000, 'ºC'),
	(113822, 111, '2015-03-15 00:54:35.000000', 'temperatura', 516.0000, 'ºC'),
	(113823, 111, '2015-03-15 00:54:36.000000', 'temperatura', 498.0000, 'ºC'),
	(113824, 111, '2015-03-15 00:54:37.000000', 'temperatura', 940.0000, 'ºC'),
	(113825, 111, '2015-03-15 00:54:38.000000', 'temperatura', 809.0000, 'ºC'),
	(113826, 111, '2015-03-15 00:54:39.000000', 'temperatura', 24.0000, 'ºC'),
	(113827, 111, '2015-03-15 00:54:40.000000', 'temperatura', 94.0000, 'ºC'),
	(113828, 111, '2015-03-15 00:54:41.000000', 'temperatura', 400.0000, 'ºC'),
	(113829, 111, '2015-03-15 00:54:42.000000', 'temperatura', 516.0000, 'ºC'),
	(113830, 111, '2015-03-15 00:54:43.000000', 'temperatura', 182.0000, 'ºC'),
	(113831, 111, '2015-03-15 00:54:44.000000', 'temperatura', 564.0000, 'ºC'),
	(113832, 111, '2015-03-15 00:54:45.000000', 'temperatura', 1072.0000, 'ºC'),
	(113833, 111, '2015-03-15 00:54:46.000000', 'temperatura', 71.0000, 'ºC'),
	(113834, 111, '2015-03-15 00:54:47.000000', 'temperatura', 739.0000, 'ºC'),
	(113835, 111, '2015-03-15 00:54:48.000000', 'temperatura', 1080.0000, 'ºC'),
	(113836, 111, '2015-03-15 00:54:49.000000', 'temperatura', 786.0000, 'ºC'),
	(113837, 111, '2015-03-15 00:54:50.000000', 'temperatura', 692.0000, 'ºC'),
	(113838, 111, '2015-03-15 00:54:51.000000', 'temperatura', 1099.0000, 'ºC'),
	(113839, 111, '2015-03-15 00:54:52.000000', 'temperatura', 1022.0000, 'ºC'),
	(113840, 111, '2015-03-15 00:54:53.000000', 'temperatura', 615.0000, 'ºC'),
	(113841, 111, '2015-03-15 00:54:54.000000', 'temperatura', 6.0000, 'ºC'),
	(113842, 111, '2015-03-15 00:54:55.000000', 'temperatura', 586.0000, 'ºC'),
	(113843, 111, '2015-03-15 00:54:56.000000', 'temperatura', 514.0000, 'ºC'),
	(113844, 111, '2015-03-15 00:54:57.000000', 'temperatura', 811.0000, 'ºC'),
	(113845, 111, '2015-03-15 00:54:58.000000', 'temperatura', 113.0000, 'ºC'),
	(113846, 111, '2015-03-15 00:54:59.000000', 'temperatura', 534.0000, 'ºC'),
	(113847, 111, '2015-03-15 00:55:00.000000', 'temperatura', 1130.0000, 'ºC'),
	(113848, 111, '2015-03-15 00:55:01.000000', 'temperatura', 447.0000, 'ºC'),
	(113849, 111, '2015-03-15 00:55:02.000000', 'temperatura', 49.0000, 'ºC'),
	(113850, 111, '2015-03-15 00:55:03.000000', 'temperatura', 103.0000, 'ºC'),
	(113851, 111, '2015-03-15 00:55:04.000000', 'temperatura', 369.0000, 'ºC'),
	(113852, 111, '2015-03-15 00:55:05.000000', 'temperatura', 336.0000, 'ºC'),
	(113853, 111, '2015-03-15 00:55:06.000000', 'temperatura', 575.0000, 'ºC'),
	(113854, 111, '2015-03-15 00:55:07.000000', 'temperatura', 667.0000, 'ºC'),
	(113855, 111, '2015-03-15 00:55:08.000000', 'temperatura', 410.0000, 'ºC'),
	(113856, 111, '2015-03-15 00:55:09.000000', 'temperatura', 50.0000, 'ºC'),
	(113857, 111, '2015-03-15 00:55:10.000000', 'temperatura', 218.0000, 'ºC'),
	(113858, 111, '2015-03-15 00:55:11.000000', 'temperatura', 944.0000, 'ºC'),
	(113859, 111, '2015-03-15 00:55:12.000000', 'temperatura', 463.0000, 'ºC'),
	(113860, 111, '2015-03-15 00:55:13.000000', 'temperatura', 685.0000, 'ºC'),
	(113861, 111, '2015-03-15 00:55:14.000000', 'temperatura', 837.0000, 'ºC'),
	(113862, 111, '2015-03-15 00:55:15.000000', 'temperatura', 929.0000, 'ºC'),
	(113863, 111, '2015-03-15 00:55:16.000000', 'temperatura', 937.0000, 'ºC'),
	(113864, 111, '2015-03-15 00:55:17.000000', 'temperatura', 697.0000, 'ºC'),
	(113865, 111, '2015-03-15 00:55:18.000000', 'temperatura', 675.0000, 'ºC'),
	(113866, 111, '2015-03-15 00:55:19.000000', 'temperatura', 85.0000, 'ºC'),
	(113867, 111, '2015-03-15 00:55:20.000000', 'temperatura', 801.0000, 'ºC'),
	(113868, 111, '2015-03-15 00:55:21.000000', 'temperatura', 148.0000, 'ºC'),
	(113869, 111, '2015-03-15 00:55:22.000000', 'temperatura', 740.0000, 'ºC'),
	(113870, 111, '2015-03-15 00:55:23.000000', 'temperatura', 856.0000, 'ºC'),
	(113871, 111, '2015-03-15 00:55:24.000000', 'temperatura', 861.0000, 'ºC'),
	(113872, 111, '2015-03-15 00:55:25.000000', 'temperatura', 536.0000, 'ºC'),
	(113873, 111, '2015-03-15 00:55:26.000000', 'temperatura', 96.0000, 'ºC'),
	(113874, 111, '2015-03-15 00:55:27.000000', 'temperatura', 74.0000, 'ºC'),
	(113875, 111, '2015-03-15 00:55:28.000000', 'temperatura', 83.0000, 'ºC'),
	(113876, 111, '2015-03-15 00:55:29.000000', 'temperatura', 194.0000, 'ºC'),
	(113877, 111, '2015-03-15 00:55:30.000000', 'temperatura', 720.0000, 'ºC'),
	(113878, 111, '2015-03-15 00:55:31.000000', 'temperatura', 621.0000, 'ºC'),
	(113879, 111, '2015-03-15 00:55:32.000000', 'temperatura', 942.0000, 'ºC'),
	(113880, 111, '2015-03-15 00:55:33.000000', 'temperatura', 450.0000, 'ºC'),
	(113881, 111, '2015-03-15 00:55:34.000000', 'temperatura', 625.0000, 'ºC'),
	(113882, 111, '2015-03-15 00:55:35.000000', 'temperatura', 573.0000, 'ºC'),
	(113883, 111, '2015-03-15 00:55:36.000000', 'temperatura', 990.0000, 'ºC'),
	(113884, 111, '2015-03-15 00:55:37.000000', 'temperatura', 834.0000, 'ºC'),
	(113885, 111, '2015-03-15 00:55:38.000000', 'temperatura', 1199.0000, 'ºC'),
	(113886, 111, '2015-03-15 00:55:39.000000', 'temperatura', 1094.0000, 'ºC'),
	(113887, 111, '2015-03-15 00:55:40.000000', 'temperatura', 672.0000, 'ºC'),
	(113888, 111, '2015-03-15 00:55:41.000000', 'temperatura', 80.0000, 'ºC'),
	(113889, 111, '2015-03-15 00:55:42.000000', 'temperatura', 783.0000, 'ºC'),
	(113890, 111, '2015-03-15 00:55:43.000000', 'temperatura', 76.0000, 'ºC'),
	(113891, 111, '2015-03-15 00:55:44.000000', 'temperatura', 431.0000, 'ºC'),
	(113892, 111, '2015-03-15 00:55:45.000000', 'temperatura', 726.0000, 'ºC'),
	(113893, 111, '2015-03-15 00:55:46.000000', 'temperatura', 1138.0000, 'ºC'),
	(113894, 111, '2015-03-15 00:55:47.000000', 'temperatura', 1114.0000, 'ºC'),
	(113895, 111, '2015-03-15 00:55:48.000000', 'temperatura', 957.0000, 'ºC'),
	(113896, 111, '2015-03-15 00:55:49.000000', 'temperatura', 245.0000, 'ºC'),
	(113897, 111, '2015-03-15 00:55:50.000000', 'temperatura', 751.0000, 'ºC'),
	(113898, 111, '2015-03-15 00:55:51.000000', 'temperatura', 621.0000, 'ºC'),
	(113899, 111, '2015-03-15 00:55:52.000000', 'temperatura', 855.0000, 'ºC'),
	(113900, 111, '2015-03-15 00:55:53.000000', 'temperatura', 11.0000, 'ºC'),
	(113901, 111, '2015-03-15 00:55:54.000000', 'temperatura', 1090.0000, 'ºC'),
	(113902, 111, '2015-03-15 00:55:55.000000', 'temperatura', 617.0000, 'ºC'),
	(113903, 111, '2015-03-15 00:55:56.000000', 'temperatura', 1017.0000, 'ºC'),
	(113904, 111, '2015-03-15 00:55:57.000000', 'temperatura', 834.0000, 'ºC'),
	(113905, 111, '2015-03-15 00:55:58.000000', 'temperatura', 1119.0000, 'ºC'),
	(113906, 111, '2015-03-15 00:55:59.000000', 'temperatura', 692.0000, 'ºC'),
	(113907, 111, '2015-03-15 00:56:00.000000', 'temperatura', 105.0000, 'ºC'),
	(113908, 111, '2015-03-15 00:56:01.000000', 'temperatura', 850.0000, 'ºC'),
	(113909, 111, '2015-03-15 00:56:02.000000', 'temperatura', 335.0000, 'ºC'),
	(113910, 111, '2015-03-15 00:56:03.000000', 'temperatura', 324.0000, 'ºC'),
	(113911, 111, '2015-03-15 00:56:04.000000', 'temperatura', 615.0000, 'ºC'),
	(113912, 111, '2015-03-15 00:56:05.000000', 'temperatura', 905.0000, 'ºC'),
	(113913, 111, '2015-03-15 00:56:06.000000', 'temperatura', 279.0000, 'ºC'),
	(113914, 111, '2015-03-15 00:56:07.000000', 'temperatura', 1081.0000, 'ºC'),
	(113915, 111, '2015-03-15 00:56:08.000000', 'temperatura', 971.0000, 'ºC'),
	(113916, 111, '2015-03-15 00:56:09.000000', 'temperatura', 410.0000, 'ºC'),
	(113917, 111, '2015-03-15 00:56:10.000000', 'temperatura', 339.0000, 'ºC'),
	(113918, 111, '2015-03-15 00:56:11.000000', 'temperatura', 465.0000, 'ºC'),
	(113919, 111, '2015-03-15 00:56:12.000000', 'temperatura', 106.0000, 'ºC'),
	(113920, 111, '2015-03-15 00:56:13.000000', 'temperatura', 339.0000, 'ºC'),
	(113921, 111, '2015-03-15 00:56:14.000000', 'temperatura', 178.0000, 'ºC'),
	(113922, 111, '2015-03-15 00:56:15.000000', 'temperatura', 1070.0000, 'ºC'),
	(113923, 111, '2015-03-15 00:56:16.000000', 'temperatura', 20.0000, 'ºC'),
	(113924, 111, '2015-03-15 00:56:17.000000', 'temperatura', 489.0000, 'ºC'),
	(113925, 111, '2015-03-15 00:56:18.000000', 'temperatura', 1185.0000, 'ºC'),
	(113926, 111, '2015-03-15 00:56:19.000000', 'temperatura', 860.0000, 'ºC'),
	(113927, 111, '2015-03-15 00:56:20.000000', 'temperatura', 745.0000, 'ºC'),
	(113928, 111, '2015-03-15 00:56:21.000000', 'temperatura', 1145.0000, 'ºC'),
	(113929, 111, '2015-03-15 00:56:22.000000', 'temperatura', 1090.0000, 'ºC'),
	(113930, 111, '2015-03-15 00:56:23.000000', 'temperatura', 818.0000, 'ºC'),
	(113931, 111, '2015-03-15 00:56:24.000000', 'temperatura', 819.0000, 'ºC'),
	(113932, 111, '2015-03-15 00:56:25.000000', 'temperatura', 442.0000, 'ºC'),
	(113933, 111, '2015-03-15 00:56:26.000000', 'temperatura', 953.0000, 'ºC'),
	(113934, 111, '2015-03-15 00:56:27.000000', 'temperatura', 1038.0000, 'ºC'),
	(113935, 111, '2015-03-15 00:56:28.000000', 'temperatura', 1133.0000, 'ºC'),
	(113936, 111, '2015-03-15 00:56:29.000000', 'temperatura', 152.0000, 'ºC'),
	(113937, 111, '2015-03-15 00:56:30.000000', 'temperatura', 960.0000, 'ºC'),
	(113938, 111, '2015-03-15 00:56:31.000000', 'temperatura', 746.0000, 'ºC'),
	(113939, 111, '2015-03-15 00:56:32.000000', 'temperatura', 851.0000, 'ºC'),
	(113940, 111, '2015-03-15 00:56:33.000000', 'temperatura', 817.0000, 'ºC'),
	(113941, 111, '2015-03-15 00:56:34.000000', 'temperatura', 332.0000, 'ºC'),
	(113942, 111, '2015-03-15 00:56:35.000000', 'temperatura', 409.0000, 'ºC'),
	(113943, 111, '2015-03-15 00:56:36.000000', 'temperatura', 1051.0000, 'ºC'),
	(113944, 111, '2015-03-15 00:56:37.000000', 'temperatura', 427.0000, 'ºC'),
	(113945, 111, '2015-03-15 00:56:38.000000', 'temperatura', 182.0000, 'ºC'),
	(113946, 111, '2015-03-15 00:56:39.000000', 'temperatura', 828.0000, 'ºC'),
	(113947, 111, '2015-03-15 00:56:40.000000', 'temperatura', 1197.0000, 'ºC'),
	(113948, 111, '2015-03-15 00:56:41.000000', 'temperatura', 1102.0000, 'ºC'),
	(113949, 111, '2015-03-15 00:56:42.000000', 'temperatura', 720.0000, 'ºC'),
	(113950, 111, '2015-03-15 00:56:43.000000', 'temperatura', 292.0000, 'ºC'),
	(113951, 111, '2015-03-15 00:56:44.000000', 'temperatura', 501.0000, 'ºC'),
	(113952, 111, '2015-03-15 00:56:45.000000', 'temperatura', 432.0000, 'ºC'),
	(113953, 111, '2015-03-15 00:56:46.000000', 'temperatura', 654.0000, 'ºC'),
	(113954, 111, '2015-03-15 00:56:47.000000', 'temperatura', 776.0000, 'ºC'),
	(113955, 111, '2015-03-15 00:56:48.000000', 'temperatura', 720.0000, 'ºC'),
	(113956, 111, '2015-03-15 00:56:49.000000', 'temperatura', 73.0000, 'ºC'),
	(113957, 111, '2015-03-15 00:56:50.000000', 'temperatura', 606.0000, 'ºC'),
	(113958, 111, '2015-03-15 00:56:51.000000', 'temperatura', 411.0000, 'ºC'),
	(113959, 111, '2015-03-15 00:56:52.000000', 'temperatura', 236.0000, 'ºC'),
	(113960, 111, '2015-03-15 00:56:53.000000', 'temperatura', 1148.0000, 'ºC'),
	(113961, 111, '2015-03-15 00:56:54.000000', 'temperatura', 234.0000, 'ºC'),
	(113962, 111, '2015-03-15 00:56:55.000000', 'temperatura', 126.0000, 'ºC'),
	(113963, 111, '2015-03-15 00:56:56.000000', 'temperatura', 1130.0000, 'ºC'),
	(113964, 111, '2015-03-15 00:56:57.000000', 'temperatura', 471.0000, 'ºC'),
	(113965, 111, '2015-03-15 00:56:58.000000', 'temperatura', 166.0000, 'ºC'),
	(113966, 111, '2015-03-15 00:56:59.000000', 'temperatura', 618.0000, 'ºC'),
	(113967, 111, '2015-03-15 00:57:00.000000', 'temperatura', 193.0000, 'ºC'),
	(113968, 111, '2015-03-15 00:57:01.000000', 'temperatura', 310.0000, 'ºC'),
	(113969, 111, '2015-03-15 00:57:02.000000', 'temperatura', 972.0000, 'ºC'),
	(113970, 111, '2015-03-15 00:57:03.000000', 'temperatura', 329.0000, 'ºC'),
	(113971, 111, '2015-03-15 00:57:04.000000', 'temperatura', 1131.0000, 'ºC'),
	(113972, 111, '2015-03-15 00:57:05.000000', 'temperatura', 1067.0000, 'ºC'),
	(113973, 111, '2015-03-15 00:57:06.000000', 'temperatura', 742.0000, 'ºC'),
	(113974, 111, '2015-03-15 00:57:07.000000', 'temperatura', 512.0000, 'ºC'),
	(113975, 111, '2015-03-15 00:57:08.000000', 'temperatura', 333.0000, 'ºC'),
	(113976, 111, '2015-03-15 00:57:09.000000', 'temperatura', 128.0000, 'ºC'),
	(113977, 111, '2015-03-15 00:57:10.000000', 'temperatura', 843.0000, 'ºC'),
	(113978, 111, '2015-03-15 00:57:11.000000', 'temperatura', 231.0000, 'ºC'),
	(113979, 111, '2015-03-15 00:57:12.000000', 'temperatura', 1026.0000, 'ºC'),
	(113980, 111, '2015-03-15 00:57:13.000000', 'temperatura', 836.0000, 'ºC'),
	(113981, 111, '2015-03-15 00:57:14.000000', 'temperatura', 1106.0000, 'ºC'),
	(113982, 111, '2015-03-15 00:57:15.000000', 'temperatura', 619.0000, 'ºC'),
	(113983, 111, '2015-03-15 00:57:16.000000', 'temperatura', 981.0000, 'ºC'),
	(113984, 111, '2015-03-15 00:57:17.000000', 'temperatura', 646.0000, 'ºC'),
	(113985, 111, '2015-03-15 00:57:18.000000', 'temperatura', 289.0000, 'ºC'),
	(113986, 111, '2015-03-15 00:57:19.000000', 'temperatura', 709.0000, 'ºC'),
	(113987, 111, '2015-03-15 00:57:20.000000', 'temperatura', 276.0000, 'ºC'),
	(113988, 111, '2015-03-15 00:57:21.000000', 'temperatura', 454.0000, 'ºC'),
	(113989, 111, '2015-03-15 00:57:22.000000', 'temperatura', 242.0000, 'ºC'),
	(113990, 111, '2015-03-15 00:57:23.000000', 'temperatura', 1050.0000, 'ºC'),
	(113991, 111, '2015-03-15 00:57:24.000000', 'temperatura', 923.0000, 'ºC'),
	(113992, 111, '2015-03-15 00:57:25.000000', 'temperatura', 265.0000, 'ºC'),
	(113993, 111, '2015-03-15 00:57:26.000000', 'temperatura', 956.0000, 'ºC'),
	(113994, 111, '2015-03-15 00:57:27.000000', 'temperatura', 386.0000, 'ºC'),
	(113995, 111, '2015-03-15 00:57:28.000000', 'temperatura', 263.0000, 'ºC'),
	(113996, 111, '2015-03-15 00:57:29.000000', 'temperatura', 158.0000, 'ºC'),
	(113997, 111, '2015-03-15 00:57:30.000000', 'temperatura', 1199.0000, 'ºC'),
	(113998, 111, '2015-03-15 00:57:31.000000', 'temperatura', 724.0000, 'ºC'),
	(113999, 111, '2015-03-15 00:57:32.000000', 'temperatura', 25.0000, 'ºC'),
	(114000, 111, '2015-03-15 00:57:33.000000', 'temperatura', 351.0000, 'ºC'),
	(114001, 111, '2015-03-15 00:57:34.000000', 'temperatura', 481.0000, 'ºC'),
	(114002, 111, '2015-03-15 00:57:35.000000', 'temperatura', 152.0000, 'ºC'),
	(114003, 111, '2015-03-15 00:57:36.000000', 'temperatura', 518.0000, 'ºC'),
	(114004, 111, '2015-03-15 00:57:37.000000', 'temperatura', 936.0000, 'ºC'),
	(114005, 111, '2015-03-15 00:57:38.000000', 'temperatura', 724.0000, 'ºC'),
	(114006, 111, '2015-03-15 00:57:39.000000', 'temperatura', 813.0000, 'ºC'),
	(114007, 111, '2015-03-15 00:57:40.000000', 'temperatura', 692.0000, 'ºC'),
	(114008, 111, '2015-03-15 00:57:41.000000', 'temperatura', 1023.0000, 'ºC'),
	(114009, 111, '2015-03-15 00:57:42.000000', 'temperatura', 638.0000, 'ºC'),
	(114010, 111, '2015-03-15 00:57:43.000000', 'temperatura', 121.0000, 'ºC'),
	(114011, 111, '2015-03-15 00:57:44.000000', 'temperatura', 1094.0000, 'ºC'),
	(114012, 111, '2015-03-15 00:57:45.000000', 'temperatura', 305.0000, 'ºC'),
	(114013, 111, '2015-03-15 00:57:46.000000', 'temperatura', 643.0000, 'ºC'),
	(114014, 111, '2015-03-15 00:57:47.000000', 'temperatura', 1103.0000, 'ºC'),
	(114015, 111, '2015-03-15 00:57:48.000000', 'temperatura', 1185.0000, 'ºC'),
	(114016, 111, '2015-03-15 00:57:49.000000', 'temperatura', 218.0000, 'ºC'),
	(114017, 111, '2015-03-15 00:57:50.000000', 'temperatura', 1136.0000, 'ºC'),
	(114018, 111, '2015-03-15 00:57:51.000000', 'temperatura', 228.0000, 'ºC'),
	(114019, 111, '2015-03-15 00:57:52.000000', 'temperatura', 130.0000, 'ºC'),
	(114020, 111, '2015-03-15 00:57:53.000000', 'temperatura', 1165.0000, 'ºC'),
	(114021, 111, '2015-03-15 00:57:54.000000', 'temperatura', 639.0000, 'ºC'),
	(114022, 111, '2015-03-15 00:57:55.000000', 'temperatura', 898.0000, 'ºC'),
	(114023, 111, '2015-03-15 00:57:56.000000', 'temperatura', 174.0000, 'ºC'),
	(114024, 111, '2015-03-15 00:57:57.000000', 'temperatura', 575.0000, 'ºC'),
	(114025, 111, '2015-03-15 00:57:58.000000', 'temperatura', 1154.0000, 'ºC'),
	(114026, 111, '2015-03-15 00:57:59.000000', 'temperatura', 445.0000, 'ºC'),
	(114027, 111, '2015-03-15 00:58:00.000000', 'temperatura', 1162.0000, 'ºC'),
	(114028, 111, '2015-03-15 00:58:01.000000', 'temperatura', 879.0000, 'ºC'),
	(114029, 111, '2015-03-15 00:58:02.000000', 'temperatura', 907.0000, 'ºC'),
	(114030, 111, '2015-03-15 00:58:03.000000', 'temperatura', 701.0000, 'ºC'),
	(114031, 111, '2015-03-15 00:58:04.000000', 'temperatura', 783.0000, 'ºC'),
	(114032, 111, '2015-03-15 00:58:05.000000', 'temperatura', 614.0000, 'ºC'),
	(114033, 111, '2015-03-15 00:58:06.000000', 'temperatura', 720.0000, 'ºC'),
	(114034, 111, '2015-03-15 00:58:07.000000', 'temperatura', 558.0000, 'ºC'),
	(114035, 111, '2015-03-15 00:58:08.000000', 'temperatura', 629.0000, 'ºC'),
	(114036, 111, '2015-03-15 00:58:09.000000', 'temperatura', 275.0000, 'ºC'),
	(114037, 111, '2015-03-15 00:58:10.000000', 'temperatura', 687.0000, 'ºC'),
	(114038, 111, '2015-03-15 00:58:11.000000', 'temperatura', 211.0000, 'ºC'),
	(114039, 111, '2015-03-15 00:58:12.000000', 'temperatura', 195.0000, 'ºC'),
	(114040, 111, '2015-03-15 00:58:13.000000', 'temperatura', 344.0000, 'ºC'),
	(114041, 111, '2015-03-15 00:58:14.000000', 'temperatura', 1133.0000, 'ºC'),
	(114042, 111, '2015-03-15 00:58:15.000000', 'temperatura', 1034.0000, 'ºC'),
	(114043, 111, '2015-03-15 00:58:16.000000', 'temperatura', 570.0000, 'ºC'),
	(114044, 111, '2015-03-15 00:58:17.000000', 'temperatura', 952.0000, 'ºC'),
	(114045, 111, '2015-03-15 00:58:18.000000', 'temperatura', 647.0000, 'ºC'),
	(114046, 111, '2015-03-15 00:58:19.000000', 'temperatura', 382.0000, 'ºC'),
	(114047, 111, '2015-03-15 00:58:20.000000', 'temperatura', 1170.0000, 'ºC'),
	(114048, 111, '2015-03-15 00:58:21.000000', 'temperatura', 1106.0000, 'ºC'),
	(114049, 111, '2015-03-15 00:58:22.000000', 'temperatura', 818.0000, 'ºC'),
	(114050, 111, '2015-03-15 00:58:23.000000', 'temperatura', 771.0000, 'ºC'),
	(114051, 111, '2015-03-15 00:58:24.000000', 'temperatura', 205.0000, 'ºC'),
	(114052, 111, '2015-03-15 00:58:25.000000', 'temperatura', 1109.0000, 'ºC'),
	(114053, 111, '2015-03-15 00:58:26.000000', 'temperatura', 132.0000, 'ºC'),
	(114054, 111, '2015-03-15 00:58:27.000000', 'temperatura', 933.0000, 'ºC'),
	(114055, 111, '2015-03-15 00:58:28.000000', 'temperatura', 670.0000, 'ºC'),
	(114056, 111, '2015-03-15 00:58:29.000000', 'temperatura', 552.0000, 'ºC'),
	(114057, 111, '2015-03-15 00:58:30.000000', 'temperatura', 748.0000, 'ºC'),
	(114058, 111, '2015-03-15 00:58:31.000000', 'temperatura', 888.0000, 'ºC'),
	(114059, 111, '2015-03-15 00:58:32.000000', 'temperatura', 993.0000, 'ºC'),
	(114060, 111, '2015-03-15 00:58:33.000000', 'temperatura', 1104.0000, 'ºC'),
	(114061, 111, '2015-03-15 00:58:34.000000', 'temperatura', 140.0000, 'ºC'),
	(114062, 111, '2015-03-15 00:58:35.000000', 'temperatura', 988.0000, 'ºC'),
	(114063, 111, '2015-03-15 00:58:36.000000', 'temperatura', 922.0000, 'ºC'),
	(114064, 111, '2015-03-15 00:58:37.000000', 'temperatura', 446.0000, 'ºC'),
	(114065, 111, '2015-03-15 00:58:38.000000', 'temperatura', 665.0000, 'ºC'),
	(114066, 111, '2015-03-15 00:58:39.000000', 'temperatura', 788.0000, 'ºC'),
	(114067, 111, '2015-03-15 00:58:40.000000', 'temperatura', 743.0000, 'ºC'),
	(114068, 111, '2015-03-15 00:58:41.000000', 'temperatura', 154.0000, 'ºC'),
	(114069, 111, '2015-03-15 00:58:42.000000', 'temperatura', 941.0000, 'ºC'),
	(114070, 111, '2015-03-15 00:58:43.000000', 'temperatura', 645.0000, 'ºC'),
	(114071, 111, '2015-03-15 00:58:44.000000', 'temperatura', 400.0000, 'ºC'),
	(114072, 111, '2015-03-15 00:58:45.000000', 'temperatura', 68.0000, 'ºC'),
	(114073, 111, '2015-03-15 00:58:46.000000', 'temperatura', 339.0000, 'ºC'),
	(114074, 111, '2015-03-15 00:58:47.000000', 'temperatura', 292.0000, 'ºC'),
	(114075, 111, '2015-03-15 00:58:48.000000', 'temperatura', 444.0000, 'ºC'),
	(114076, 111, '2015-03-15 00:58:49.000000', 'temperatura', 145.0000, 'ºC'),
	(114077, 111, '2015-03-15 00:58:50.000000', 'temperatura', 592.0000, 'ºC'),
	(114078, 111, '2015-03-15 00:58:51.000000', 'temperatura', 128.0000, 'ºC'),
	(114079, 111, '2015-03-15 00:58:52.000000', 'temperatura', 62.0000, 'ºC'),
	(114080, 111, '2015-03-15 00:58:53.000000', 'temperatura', 1127.0000, 'ºC'),
	(114081, 111, '2015-03-15 00:58:54.000000', 'temperatura', 649.0000, 'ºC'),
	(114082, 111, '2015-03-15 00:58:55.000000', 'temperatura', 1067.0000, 'ºC'),
	(114083, 111, '2015-03-15 00:58:56.000000', 'temperatura', 986.0000, 'ºC'),
	(114084, 111, '2015-03-15 00:58:57.000000', 'temperatura', 531.0000, 'ºC'),
	(114085, 111, '2015-03-15 00:58:58.000000', 'temperatura', 896.0000, 'ºC'),
	(114086, 111, '2015-03-15 00:58:59.000000', 'temperatura', 489.0000, 'ºC'),
	(114087, 111, '2015-03-15 00:59:00.000000', 'temperatura', 957.0000, 'ºC'),
	(114088, 111, '2015-03-15 00:59:01.000000', 'temperatura', 919.0000, 'ºC'),
	(114089, 111, '2015-03-15 00:59:02.000000', 'temperatura', 524.0000, 'ºC'),
	(114090, 111, '2015-03-15 00:59:03.000000', 'temperatura', 1063.0000, 'ºC'),
	(114091, 111, '2015-03-15 00:59:04.000000', 'temperatura', 142.0000, 'ºC'),
	(114092, 111, '2015-03-15 00:59:05.000000', 'temperatura', 1123.0000, 'ºC'),
	(114093, 111, '2015-03-15 00:59:06.000000', 'temperatura', 389.0000, 'ºC'),
	(114094, 111, '2015-03-15 00:59:07.000000', 'temperatura', 975.0000, 'ºC'),
	(114095, 111, '2015-03-15 00:59:08.000000', 'temperatura', 109.0000, 'ºC'),
	(114096, 111, '2015-03-15 00:59:09.000000', 'temperatura', 21.0000, 'ºC'),
	(114097, 111, '2015-03-15 00:59:10.000000', 'temperatura', 979.0000, 'ºC'),
	(114098, 111, '2015-03-15 00:59:11.000000', 'temperatura', 32.0000, 'ºC'),
	(114099, 111, '2015-03-15 00:59:12.000000', 'temperatura', 826.0000, 'ºC'),
	(114100, 111, '2015-03-15 00:59:13.000000', 'temperatura', 432.0000, 'ºC'),
	(114101, 111, '2015-03-15 00:59:14.000000', 'temperatura', 881.0000, 'ºC'),
	(114102, 111, '2015-03-15 00:59:15.000000', 'temperatura', 712.0000, 'ºC'),
	(114103, 111, '2015-03-15 00:59:16.000000', 'temperatura', 915.0000, 'ºC'),
	(114104, 111, '2015-03-15 00:59:17.000000', 'temperatura', 41.0000, 'ºC'),
	(114105, 111, '2015-03-15 00:59:18.000000', 'temperatura', 1061.0000, 'ºC'),
	(114106, 111, '2015-03-15 00:59:19.000000', 'temperatura', 384.0000, 'ºC'),
	(114107, 111, '2015-03-15 00:59:20.000000', 'temperatura', 1135.0000, 'ºC'),
	(114108, 111, '2015-03-15 00:59:21.000000', 'temperatura', 922.0000, 'ºC'),
	(114109, 111, '2015-03-15 00:59:22.000000', 'temperatura', 8.0000, 'ºC'),
	(114110, 111, '2015-03-15 00:59:23.000000', 'temperatura', 874.0000, 'ºC'),
	(114111, 111, '2015-03-15 00:59:24.000000', 'temperatura', 745.0000, 'ºC'),
	(114112, 111, '2015-03-15 00:59:25.000000', 'temperatura', 1107.0000, 'ºC'),
	(114113, 111, '2015-03-15 00:59:26.000000', 'temperatura', 897.0000, 'ºC'),
	(114114, 111, '2015-03-15 00:59:27.000000', 'temperatura', 1166.0000, 'ºC'),
	(114115, 111, '2015-03-15 00:59:28.000000', 'temperatura', 739.0000, 'ºC'),
	(114116, 111, '2015-03-15 00:59:29.000000', 'temperatura', 200.0000, 'ºC'),
	(114117, 111, '2015-03-15 00:59:30.000000', 'temperatura', 1181.0000, 'ºC'),
	(114118, 111, '2015-03-15 00:59:31.000000', 'temperatura', 505.0000, 'ºC'),
	(114119, 111, '2015-03-15 00:59:32.000000', 'temperatura', 185.0000, 'ºC'),
	(114120, 111, '2015-03-15 00:59:33.000000', 'temperatura', 610.0000, 'ºC'),
	(114121, 111, '2015-03-15 00:59:34.000000', 'temperatura', 93.0000, 'ºC'),
	(114122, 111, '2015-03-15 00:59:35.000000', 'temperatura', 1037.0000, 'ºC'),
	(114123, 111, '2015-03-15 00:59:36.000000', 'temperatura', 108.0000, 'ºC'),
	(114124, 111, '2015-03-15 00:59:37.000000', 'temperatura', 1029.0000, 'ºC'),
	(114125, 111, '2015-03-15 00:59:38.000000', 'temperatura', 23.0000, 'ºC'),
	(114126, 111, '2015-03-15 00:59:39.000000', 'temperatura', 627.0000, 'ºC'),
	(114127, 111, '2015-03-15 00:59:40.000000', 'temperatura', 668.0000, 'ºC'),
	(114128, 111, '2015-03-15 00:59:41.000000', 'temperatura', 257.0000, 'ºC'),
	(114129, 111, '2015-03-15 00:59:42.000000', 'temperatura', 482.0000, 'ºC'),
	(114130, 111, '2015-03-15 00:59:43.000000', 'temperatura', 440.0000, 'ºC'),
	(114131, 111, '2015-03-15 00:59:44.000000', 'temperatura', 753.0000, 'ºC'),
	(114132, 111, '2015-03-15 00:59:45.000000', 'temperatura', 45.0000, 'ºC'),
	(114133, 111, '2015-03-15 00:59:46.000000', 'temperatura', 367.0000, 'ºC'),
	(114134, 111, '2015-03-15 00:59:47.000000', 'temperatura', 501.0000, 'ºC'),
	(114135, 111, '2015-03-15 00:59:48.000000', 'temperatura', 203.0000, 'ºC'),
	(114136, 111, '2015-03-15 00:59:49.000000', 'temperatura', 712.0000, 'ºC'),
	(114137, 111, '2015-03-15 00:59:50.000000', 'temperatura', 553.0000, 'ºC'),
	(114138, 111, '2015-03-15 00:59:51.000000', 'temperatura', 630.0000, 'ºC'),
	(114139, 111, '2015-03-15 00:59:52.000000', 'temperatura', 292.0000, 'ºC'),
	(114140, 111, '2015-03-15 00:59:53.000000', 'temperatura', 769.0000, 'ºC'),
	(114141, 111, '2015-03-15 00:59:54.000000', 'temperatura', 568.0000, 'ºC'),
	(114142, 111, '2015-03-15 00:59:55.000000', 'temperatura', 536.0000, 'ºC'),
	(114143, 111, '2015-03-15 00:59:56.000000', 'temperatura', 975.0000, 'ºC'),
	(114144, 111, '2015-03-15 00:59:57.000000', 'temperatura', 866.0000, 'ºC'),
	(114145, 111, '2015-03-15 00:59:58.000000', 'temperatura', 207.0000, 'ºC'),
	(114146, 111, '2015-03-15 00:59:59.000000', 'temperatura', 839.0000, 'ºC'),
	(114147, 111, '2015-03-15 01:00:00.000000', 'temperatura', 1174.0000, 'ºC'),
	(114148, 111, '2015-03-15 01:00:01.000000', 'temperatura', 955.0000, 'ºC'),
	(114149, 111, '2015-03-15 01:00:02.000000', 'temperatura', 53.0000, 'ºC'),
	(114150, 111, '2015-03-15 01:00:03.000000', 'temperatura', 998.0000, 'ºC'),
	(114151, 111, '2015-03-15 01:00:04.000000', 'temperatura', 33.0000, 'ºC'),
	(114152, 111, '2015-03-15 01:00:05.000000', 'temperatura', 771.0000, 'ºC'),
	(114153, 111, '2015-03-15 01:00:06.000000', 'temperatura', 157.0000, 'ºC'),
	(114154, 111, '2015-03-15 01:00:07.000000', 'temperatura', 872.0000, 'ºC'),
	(114155, 111, '2015-03-15 01:00:08.000000', 'temperatura', 290.0000, 'ºC'),
	(114156, 111, '2015-03-15 01:00:09.000000', 'temperatura', 34.0000, 'ºC'),
	(114157, 111, '2015-03-15 01:00:10.000000', 'temperatura', 501.0000, 'ºC'),
	(114158, 111, '2015-03-15 01:00:11.000000', 'temperatura', 5.0000, 'ºC'),
	(114159, 111, '2015-03-15 01:00:12.000000', 'temperatura', 922.0000, 'ºC'),
	(114160, 111, '2015-03-15 01:00:13.000000', 'temperatura', 996.0000, 'ºC'),
	(114161, 111, '2015-03-15 01:00:14.000000', 'temperatura', 1012.0000, 'ºC'),
	(114162, 111, '2015-03-15 01:00:15.000000', 'temperatura', 872.0000, 'ºC'),
	(114163, 111, '2015-03-15 01:00:16.000000', 'temperatura', 128.0000, 'ºC'),
	(114164, 111, '2015-03-15 01:00:17.000000', 'temperatura', 422.0000, 'ºC'),
	(114165, 111, '2015-03-15 01:00:18.000000', 'temperatura', 526.0000, 'ºC'),
	(114166, 111, '2015-03-15 01:00:19.000000', 'temperatura', 163.0000, 'ºC'),
	(114167, 111, '2015-03-15 01:00:20.000000', 'temperatura', 440.0000, 'ºC'),
	(114168, 111, '2015-03-15 01:00:21.000000', 'temperatura', 512.0000, 'ºC'),
	(114169, 111, '2015-03-15 01:00:22.000000', 'temperatura', 39.0000, 'ºC'),
	(114170, 111, '2015-03-15 01:00:23.000000', 'temperatura', 1059.0000, 'ºC'),
	(114171, 111, '2015-03-15 01:00:24.000000', 'temperatura', 377.0000, 'ºC'),
	(114172, 111, '2015-03-15 01:00:25.000000', 'temperatura', 1111.0000, 'ºC'),
	(114173, 111, '2015-03-15 01:00:26.000000', 'temperatura', 822.0000, 'ºC'),
	(114174, 111, '2015-03-15 01:00:27.000000', 'temperatura', 780.0000, 'ºC'),
	(114175, 111, '2015-03-15 01:00:28.000000', 'temperatura', 235.0000, 'ºC'),
	(114176, 111, '2015-03-15 01:00:29.000000', 'temperatura', 33.0000, 'ºC'),
	(114177, 111, '2015-03-15 01:00:30.000000', 'temperatura', 662.0000, 'ºC'),
	(114178, 111, '2015-03-15 01:00:31.000000', 'temperatura', 813.0000, 'ºC'),
	(114179, 111, '2015-03-15 01:00:32.000000', 'temperatura', 878.0000, 'ºC'),
	(114180, 111, '2015-03-15 01:00:33.000000', 'temperatura', 752.0000, 'ºC'),
	(114181, 111, '2015-03-15 01:00:34.000000', 'temperatura', 1128.0000, 'ºC'),
	(114182, 111, '2015-03-15 01:00:35.000000', 'temperatura', 981.0000, 'ºC'),
	(114183, 111, '2015-03-15 01:00:36.000000', 'temperatura', 324.0000, 'ºC'),
	(114184, 111, '2015-03-15 01:00:37.000000', 'temperatura', 1076.0000, 'ºC'),
	(114185, 111, '2015-03-15 01:00:38.000000', 'temperatura', 809.0000, 'ºC'),
	(114186, 111, '2015-03-15 01:00:39.000000', 'temperatura', 816.0000, 'ºC'),
	(114187, 111, '2015-03-15 01:00:40.000000', 'temperatura', 454.0000, 'ºC'),
	(114188, 111, '2015-03-15 01:00:41.000000', 'temperatura', 1025.0000, 'ºC'),
	(114189, 111, '2015-03-15 01:00:42.000000', 'temperatura', 162.0000, 'ºC'),
	(114190, 111, '2015-03-15 01:00:43.000000', 'temperatura', 136.0000, 'ºC'),
	(114191, 111, '2015-03-15 01:00:44.000000', 'temperatura', 195.0000, 'ºC'),
	(114192, 111, '2015-03-15 01:00:45.000000', 'temperatura', 569.0000, 'ºC'),
	(114193, 111, '2015-03-15 01:00:46.000000', 'temperatura', 1059.0000, 'ºC'),
	(114194, 111, '2015-03-15 01:00:47.000000', 'temperatura', 1188.0000, 'ºC'),
	(114195, 111, '2015-03-15 01:00:48.000000', 'temperatura', 365.0000, 'ºC'),
	(114196, 112, '2015-03-15 00:00:00.000000', 'temperatura', 1001.0000, 'ºC'),
	(114197, 112, '2015-03-15 00:00:01.000000', 'temperatura', 630.0000, 'ºC'),
	(114198, 112, '2015-03-15 00:00:02.000000', 'temperatura', 149.0000, 'ºC'),
	(114199, 112, '2015-03-15 00:00:03.000000', 'temperatura', 53.0000, 'ºC'),
	(114200, 112, '2015-03-15 00:00:04.000000', 'temperatura', 1021.0000, 'ºC'),
	(114201, 112, '2015-03-15 00:00:05.000000', 'temperatura', 144.0000, 'ºC'),
	(114202, 112, '2015-03-15 00:00:06.000000', 'temperatura', 58.0000, 'ºC'),
	(114203, 112, '2015-03-15 00:00:07.000000', 'temperatura', 1057.0000, 'ºC'),
	(114204, 112, '2015-03-15 00:00:08.000000', 'temperatura', 313.0000, 'ºC'),
	(114205, 112, '2015-03-15 00:00:09.000000', 'temperatura', 793.0000, 'ºC'),
	(114206, 112, '2015-03-15 00:00:10.000000', 'temperatura', 628.0000, 'ºC'),
	(114207, 112, '2015-03-15 00:00:11.000000', 'temperatura', 763.0000, 'ºC'),
	(114208, 112, '2015-03-15 00:00:12.000000', 'temperatura', 728.0000, 'ºC'),
	(114209, 112, '2015-03-15 00:00:13.000000', 'temperatura', 155.0000, 'ºC'),
	(114210, 112, '2015-03-15 00:00:14.000000', 'temperatura', 989.0000, 'ºC'),
	(114211, 112, '2015-03-15 00:00:15.000000', 'temperatura', 882.0000, 'ºC'),
	(114212, 112, '2015-03-15 00:00:16.000000', 'temperatura', 245.0000, 'ºC'),
	(114213, 112, '2015-03-15 00:00:17.000000', 'temperatura', 977.0000, 'ºC'),
	(114214, 112, '2015-03-15 00:00:18.000000', 'temperatura', 551.0000, 'ºC'),
	(114215, 112, '2015-03-15 00:00:19.000000', 'temperatura', 1024.0000, 'ºC'),
	(114216, 112, '2015-03-15 00:00:20.000000', 'temperatura', 1066.0000, 'ºC'),
	(114217, 112, '2015-03-15 00:00:21.000000', 'temperatura', 1060.0000, 'ºC'),
	(114218, 112, '2015-03-15 00:00:22.000000', 'temperatura', 901.0000, 'ºC'),
	(114219, 112, '2015-03-15 00:00:23.000000', 'temperatura', 126.0000, 'ºC'),
	(114220, 112, '2015-03-15 00:00:24.000000', 'temperatura', 327.0000, 'ºC'),
	(114221, 112, '2015-03-15 00:00:25.000000', 'temperatura', 59.0000, 'ºC'),
	(114222, 112, '2015-03-15 00:00:26.000000', 'temperatura', 513.0000, 'ºC'),
	(114223, 112, '2015-03-15 00:00:27.000000', 'temperatura', 1190.0000, 'ºC'),
	(114224, 112, '2015-03-15 00:00:28.000000', 'temperatura', 809.0000, 'ºC'),
	(114225, 112, '2015-03-15 00:00:29.000000', 'temperatura', 477.0000, 'ºC'),
	(114226, 112, '2015-03-15 00:00:30.000000', 'temperatura', 1159.0000, 'ºC'),
	(114227, 112, '2015-03-15 00:00:31.000000', 'temperatura', 766.0000, 'ºC'),
	(114228, 112, '2015-03-15 00:00:32.000000', 'temperatura', 350.0000, 'ºC'),
	(114229, 112, '2015-03-15 00:00:33.000000', 'temperatura', 654.0000, 'ºC'),
	(114230, 112, '2015-03-15 00:00:34.000000', 'temperatura', 1022.0000, 'ºC'),
	(114231, 112, '2015-03-15 00:00:35.000000', 'temperatura', 749.0000, 'ºC'),
	(114232, 112, '2015-03-15 00:00:36.000000', 'temperatura', 677.0000, 'ºC'),
	(114233, 112, '2015-03-15 00:00:37.000000', 'temperatura', 1138.0000, 'ºC'),
	(114234, 112, '2015-03-15 00:00:38.000000', 'temperatura', 59.0000, 'ºC'),
	(114235, 112, '2015-03-15 00:00:39.000000', 'temperatura', 481.0000, 'ºC'),
	(114236, 112, '2015-03-15 00:00:40.000000', 'temperatura', 1031.0000, 'ºC'),
	(114237, 112, '2015-03-15 00:00:41.000000', 'temperatura', 113.0000, 'ºC'),
	(114238, 112, '2015-03-15 00:00:42.000000', 'temperatura', 1070.0000, 'ºC'),
	(114239, 112, '2015-03-15 00:00:43.000000', 'temperatura', 211.0000, 'ºC'),
	(114240, 112, '2015-03-15 00:00:44.000000', 'temperatura', 248.0000, 'ºC'),
	(114241, 112, '2015-03-15 00:00:45.000000', 'temperatura', 606.0000, 'ºC'),
	(114242, 112, '2015-03-15 00:00:46.000000', 'temperatura', 1087.0000, 'ºC'),
	(114243, 112, '2015-03-15 00:00:47.000000', 'temperatura', 19.0000, 'ºC'),
	(114244, 112, '2015-03-15 00:00:48.000000', 'temperatura', 433.0000, 'ºC'),
	(114245, 112, '2015-03-15 00:00:49.000000', 'temperatura', 908.0000, 'ºC'),
	(114246, 112, '2015-03-15 00:00:50.000000', 'temperatura', 842.0000, 'ºC'),
	(114247, 112, '2015-03-15 00:00:51.000000', 'temperatura', 284.0000, 'ºC'),
	(114248, 112, '2015-03-15 00:00:52.000000', 'temperatura', 98.0000, 'ºC'),
	(114249, 112, '2015-03-15 00:00:53.000000', 'temperatura', 838.0000, 'ºC'),
	(114250, 112, '2015-03-15 00:00:54.000000', 'temperatura', 295.0000, 'ºC'),
	(114251, 112, '2015-03-15 00:00:55.000000', 'temperatura', 163.0000, 'ºC'),
	(114252, 112, '2015-03-15 00:00:56.000000', 'temperatura', 1130.0000, 'ºC'),
	(114253, 112, '2015-03-15 00:00:57.000000', 'temperatura', 360.0000, 'ºC'),
	(114254, 112, '2015-03-15 00:00:58.000000', 'temperatura', 811.0000, 'ºC'),
	(114255, 112, '2015-03-15 00:00:59.000000', 'temperatura', 575.0000, 'ºC'),
	(114256, 112, '2015-03-15 00:01:00.000000', 'temperatura', 445.0000, 'ºC'),
	(114257, 112, '2015-03-15 00:01:01.000000', 'temperatura', 498.0000, 'ºC'),
	(114258, 112, '2015-03-15 00:01:02.000000', 'temperatura', 1158.0000, 'ºC'),
	(114259, 112, '2015-03-15 00:01:03.000000', 'temperatura', 694.0000, 'ºC'),
	(114260, 112, '2015-03-15 00:01:04.000000', 'temperatura', 1197.0000, 'ºC'),
	(114261, 112, '2015-03-15 00:01:05.000000', 'temperatura', 302.0000, 'ºC'),
	(114262, 112, '2015-03-15 00:01:06.000000', 'temperatura', 321.0000, 'ºC'),
	(114263, 112, '2015-03-15 00:01:07.000000', 'temperatura', 698.0000, 'ºC'),
	(114264, 112, '2015-03-15 00:01:08.000000', 'temperatura', 128.0000, 'ºC'),
	(114265, 112, '2015-03-15 00:01:09.000000', 'temperatura', 946.0000, 'ºC'),
	(114266, 112, '2015-03-15 00:01:10.000000', 'temperatura', 747.0000, 'ºC'),
	(114267, 112, '2015-03-15 00:01:11.000000', 'temperatura', 896.0000, 'ºC'),
	(114268, 112, '2015-03-15 00:01:12.000000', 'temperatura', 1041.0000, 'ºC'),
	(114269, 112, '2015-03-15 00:01:13.000000', 'temperatura', 118.0000, 'ºC'),
	(114270, 112, '2015-03-15 00:01:14.000000', 'temperatura', 1067.0000, 'ºC'),
	(114271, 112, '2015-03-15 00:01:15.000000', 'temperatura', 182.0000, 'ºC'),
	(114272, 112, '2015-03-15 00:01:16.000000', 'temperatura', 110.0000, 'ºC'),
	(114273, 112, '2015-03-15 00:01:17.000000', 'temperatura', 5.0000, 'ºC'),
	(114274, 112, '2015-03-15 00:01:18.000000', 'temperatura', 893.0000, 'ºC'),
	(114275, 112, '2015-03-15 00:01:19.000000', 'temperatura', 851.0000, 'ºC'),
	(114276, 112, '2015-03-15 00:01:20.000000', 'temperatura', 376.0000, 'ºC'),
	(114277, 112, '2015-03-15 00:01:21.000000', 'temperatura', 529.0000, 'ºC'),
	(114278, 112, '2015-03-15 00:01:22.000000', 'temperatura', 316.0000, 'ºC'),
	(114279, 112, '2015-03-15 00:01:23.000000', 'temperatura', 1193.0000, 'ºC'),
	(114280, 112, '2015-03-15 00:01:24.000000', 'temperatura', 219.0000, 'ºC'),
	(114281, 112, '2015-03-15 00:01:25.000000', 'temperatura', 1116.0000, 'ºC'),
	(114282, 112, '2015-03-15 00:01:26.000000', 'temperatura', 123.0000, 'ºC'),
	(114283, 112, '2015-03-15 00:01:27.000000', 'temperatura', 866.0000, 'ºC'),
	(114284, 112, '2015-03-15 00:01:28.000000', 'temperatura', 365.0000, 'ºC'),
	(114285, 112, '2015-03-15 00:01:29.000000', 'temperatura', 425.0000, 'ºC'),
	(114286, 112, '2015-03-15 00:01:30.000000', 'temperatura', 1032.0000, 'ºC'),
	(114287, 112, '2015-03-15 00:01:31.000000', 'temperatura', 285.0000, 'ºC'),
	(114288, 112, '2015-03-15 00:01:32.000000', 'temperatura', 728.0000, 'ºC'),
	(114289, 112, '2015-03-15 00:01:33.000000', 'temperatura', 388.0000, 'ºC'),
	(114290, 112, '2015-03-15 00:01:34.000000', 'temperatura', 954.0000, 'ºC'),
	(114291, 112, '2015-03-15 00:01:35.000000', 'temperatura', 9.0000, 'ºC'),
	(114292, 112, '2015-03-15 00:01:36.000000', 'temperatura', 783.0000, 'ºC'),
	(114293, 112, '2015-03-15 00:01:37.000000', 'temperatura', 286.0000, 'ºC'),
	(114294, 112, '2015-03-15 00:01:38.000000', 'temperatura', 284.0000, 'ºC'),
	(114295, 112, '2015-03-15 00:01:39.000000', 'temperatura', 562.0000, 'ºC'),
	(114296, 112, '2015-03-15 00:01:40.000000', 'temperatura', 757.0000, 'ºC'),
	(114297, 112, '2015-03-15 00:01:41.000000', 'temperatura', 902.0000, 'ºC'),
	(114298, 112, '2015-03-15 00:01:42.000000', 'temperatura', 1039.0000, 'ºC'),
	(114299, 112, '2015-03-15 00:01:43.000000', 'temperatura', 88.0000, 'ºC'),
	(114300, 112, '2015-03-15 00:01:44.000000', 'temperatura', 923.0000, 'ºC'),
	(114301, 112, '2015-03-15 00:01:45.000000', 'temperatura', 754.0000, 'ºC'),
	(114302, 112, '2015-03-15 00:01:46.000000', 'temperatura', 1002.0000, 'ºC'),
	(114303, 112, '2015-03-15 00:01:47.000000', 'temperatura', 347.0000, 'ºC'),
	(114304, 112, '2015-03-15 00:01:48.000000', 'temperatura', 1128.0000, 'ºC'),
	(114305, 112, '2015-03-15 00:01:49.000000', 'temperatura', 1003.0000, 'ºC'),
	(114306, 112, '2015-03-15 00:01:50.000000', 'temperatura', 428.0000, 'ºC'),
	(114307, 112, '2015-03-15 00:01:51.000000', 'temperatura', 335.0000, 'ºC'),
	(114308, 112, '2015-03-15 00:01:52.000000', 'temperatura', 388.0000, 'ºC'),
	(114309, 112, '2015-03-15 00:01:53.000000', 'temperatura', 937.0000, 'ºC'),
	(114310, 112, '2015-03-15 00:01:54.000000', 'temperatura', 1120.0000, 'ºC'),
	(114311, 112, '2015-03-15 00:01:55.000000', 'temperatura', 391.0000, 'ºC'),
	(114312, 112, '2015-03-15 00:01:56.000000', 'temperatura', 995.0000, 'ºC'),
	(114313, 112, '2015-03-15 00:01:57.000000', 'temperatura', 205.0000, 'ºC'),
	(114314, 112, '2015-03-15 00:01:58.000000', 'temperatura', 437.0000, 'ºC'),
	(114315, 112, '2015-03-15 00:01:59.000000', 'temperatura', 371.0000, 'ºC'),
	(114316, 112, '2015-03-15 00:02:00.000000', 'temperatura', 546.0000, 'ºC'),
	(114317, 112, '2015-03-15 00:02:01.000000', 'temperatura', 416.0000, 'ºC'),
	(114318, 112, '2015-03-15 00:02:02.000000', 'temperatura', 442.0000, 'ºC'),
	(114319, 112, '2015-03-15 00:02:03.000000', 'temperatura', 963.0000, 'ºC'),
	(114320, 112, '2015-03-15 00:02:04.000000', 'temperatura', 1090.0000, 'ºC'),
	(114321, 112, '2015-03-15 00:02:05.000000', 'temperatura', 160.0000, 'ºC'),
	(114322, 112, '2015-03-15 00:02:06.000000', 'temperatura', 1131.0000, 'ºC'),
	(114323, 112, '2015-03-15 00:02:07.000000', 'temperatura', 375.0000, 'ºC'),
	(114324, 112, '2015-03-15 00:02:08.000000', 'temperatura', 884.0000, 'ºC'),
	(114325, 112, '2015-03-15 00:02:09.000000', 'temperatura', 894.0000, 'ºC'),
	(114326, 112, '2015-03-15 00:02:10.000000', 'temperatura', 618.0000, 'ºC'),
	(114327, 112, '2015-03-15 00:02:11.000000', 'temperatura', 408.0000, 'ºC'),
	(114328, 112, '2015-03-15 00:02:12.000000', 'temperatura', 187.0000, 'ºC'),
	(114329, 112, '2015-03-15 00:02:13.000000', 'temperatura', 910.0000, 'ºC'),
	(114330, 112, '2015-03-15 00:02:14.000000', 'temperatura', 390.0000, 'ºC'),
	(114331, 112, '2015-03-15 00:02:15.000000', 'temperatura', 422.0000, 'ºC'),
	(114332, 112, '2015-03-15 00:02:16.000000', 'temperatura', 939.0000, 'ºC'),
	(114333, 112, '2015-03-15 00:02:17.000000', 'temperatura', 1032.0000, 'ºC'),
	(114334, 112, '2015-03-15 00:02:18.000000', 'temperatura', 1141.0000, 'ºC'),
	(114335, 112, '2015-03-15 00:02:19.000000', 'temperatura', 209.0000, 'ºC'),
	(114336, 112, '2015-03-15 00:02:20.000000', 'temperatura', 24.0000, 'ºC'),
	(114337, 112, '2015-03-15 00:02:21.000000', 'temperatura', 691.0000, 'ºC'),
	(114338, 112, '2015-03-15 00:02:22.000000', 'temperatura', 985.0000, 'ºC'),
	(114339, 112, '2015-03-15 00:02:23.000000', 'temperatura', 453.0000, 'ºC'),
	(114340, 112, '2015-03-15 00:02:24.000000', 'temperatura', 509.0000, 'ºC'),
	(114341, 112, '2015-03-15 00:02:25.000000', 'temperatura', 1187.0000, 'ºC'),
	(114342, 112, '2015-03-15 00:02:26.000000', 'temperatura', 809.0000, 'ºC'),
	(114343, 112, '2015-03-15 00:02:27.000000', 'temperatura', 484.0000, 'ºC'),
	(114344, 112, '2015-03-15 00:02:28.000000', 'temperatura', 1193.0000, 'ºC'),
	(114345, 112, '2015-03-15 00:02:29.000000', 'temperatura', 915.0000, 'ºC'),
	(114346, 112, '2015-03-15 00:02:30.000000', 'temperatura', 997.0000, 'ºC'),
	(114347, 112, '2015-03-15 00:02:31.000000', 'temperatura', 1038.0000, 'ºC'),
	(114348, 112, '2015-03-15 00:02:32.000000', 'temperatura', 999.0000, 'ºC'),
	(114349, 112, '2015-03-15 00:02:33.000000', 'temperatura', 681.0000, 'ºC'),
	(114350, 112, '2015-03-15 00:02:34.000000', 'temperatura', 411.0000, 'ºC'),
	(114351, 112, '2015-03-15 00:02:35.000000', 'temperatura', 12.0000, 'ºC'),
	(114352, 112, '2015-03-15 00:02:36.000000', 'temperatura', 28.0000, 'ºC'),
	(114353, 112, '2015-03-15 00:02:37.000000', 'temperatura', 103.0000, 'ºC'),
	(114354, 112, '2015-03-15 00:02:38.000000', 'temperatura', 433.0000, 'ºC'),
	(114355, 112, '2015-03-15 00:02:39.000000', 'temperatura', 656.0000, 'ºC'),
	(114356, 112, '2015-03-15 00:02:40.000000', 'temperatura', 780.0000, 'ºC'),
	(114357, 112, '2015-03-15 00:02:41.000000', 'temperatura', 733.0000, 'ºC'),
	(114358, 112, '2015-03-15 00:02:42.000000', 'temperatura', 127.0000, 'ºC'),
	(114359, 112, '2015-03-15 00:02:43.000000', 'temperatura', 835.0000, 'ºC'),
	(114360, 112, '2015-03-15 00:02:44.000000', 'temperatura', 195.0000, 'ºC'),
	(114361, 112, '2015-03-15 00:02:45.000000', 'temperatura', 870.0000, 'ºC'),
	(114362, 112, '2015-03-15 00:02:46.000000', 'temperatura', 167.0000, 'ºC'),
	(114363, 112, '2015-03-15 00:02:47.000000', 'temperatura', 623.0000, 'ºC'),
	(114364, 112, '2015-03-15 00:02:48.000000', 'temperatura', 215.0000, 'ºC'),
	(114365, 112, '2015-03-15 00:02:49.000000', 'temperatura', 406.0000, 'ºC'),
	(114366, 112, '2015-03-15 00:02:50.000000', 'temperatura', 185.0000, 'ºC'),
	(114367, 112, '2015-03-15 00:02:51.000000', 'temperatura', 909.0000, 'ºC'),
	(114368, 112, '2015-03-15 00:02:52.000000', 'temperatura', 388.0000, 'ºC'),
	(114369, 112, '2015-03-15 00:02:53.000000', 'temperatura', 416.0000, 'ºC'),
	(114370, 112, '2015-03-15 00:02:54.000000', 'temperatura', 915.0000, 'ºC'),
	(114371, 112, '2015-03-15 00:02:55.000000', 'temperatura', 926.0000, 'ºC'),
	(114372, 112, '2015-03-15 00:02:56.000000', 'temperatura', 688.0000, 'ºC'),
	(114373, 112, '2015-03-15 00:02:57.000000', 'temperatura', 663.0000, 'ºC'),
	(114374, 112, '2015-03-15 00:02:58.000000', 'temperatura', 52.0000, 'ºC'),
	(114375, 112, '2015-03-15 00:02:59.000000', 'temperatura', 671.0000, 'ºC'),
	(114376, 112, '2015-03-15 00:03:00.000000', 'temperatura', 801.0000, 'ºC'),
	(114377, 112, '2015-03-15 00:03:01.000000', 'temperatura', 791.0000, 'ºC'),
	(114378, 112, '2015-03-15 00:03:02.000000', 'temperatura', 351.0000, 'ºC'),
	(114379, 112, '2015-03-15 00:03:03.000000', 'temperatura', 583.0000, 'ºC'),
	(114380, 112, '2015-03-15 00:03:04.000000', 'temperatura', 662.0000, 'ºC'),
	(114381, 112, '2015-03-15 00:03:05.000000', 'temperatura', 362.0000, 'ºC'),
	(114382, 112, '2015-03-15 00:03:06.000000', 'temperatura', 1026.0000, 'ºC'),
	(114383, 112, '2015-03-15 00:03:07.000000', 'temperatura', 442.0000, 'ºC'),
	(114384, 112, '2015-03-15 00:03:08.000000', 'temperatura', 335.0000, 'ºC'),
	(114385, 112, '2015-03-15 00:03:09.000000', 'temperatura', 347.0000, 'ºC'),
	(114386, 112, '2015-03-15 00:03:10.000000', 'temperatura', 730.0000, 'ºC'),
	(114387, 112, '2015-03-15 00:03:11.000000', 'temperatura', 211.0000, 'ºC'),
	(114388, 112, '2015-03-15 00:03:12.000000', 'temperatura', 65.0000, 'ºC'),
	(114389, 112, '2015-03-15 00:03:13.000000', 'temperatura', 892.0000, 'ºC'),
	(114390, 112, '2015-03-15 00:03:14.000000', 'temperatura', 665.0000, 'ºC'),
	(114391, 112, '2015-03-15 00:03:15.000000', 'temperatura', 649.0000, 'ºC'),
	(114392, 112, '2015-03-15 00:03:16.000000', 'temperatura', 49.0000, 'ºC'),
	(114393, 112, '2015-03-15 00:03:17.000000', 'temperatura', 701.0000, 'ºC'),
	(114394, 112, '2015-03-15 00:03:18.000000', 'temperatura', 958.0000, 'ºC'),
	(114395, 112, '2015-03-15 00:03:19.000000', 'temperatura', 286.0000, 'ºC'),
	(114396, 112, '2015-03-15 00:03:20.000000', 'temperatura', 959.0000, 'ºC'),
	(114397, 112, '2015-03-15 00:03:21.000000', 'temperatura', 335.0000, 'ºC'),
	(114398, 112, '2015-03-15 00:03:22.000000', 'temperatura', 1.0000, 'ºC'),
	(114399, 112, '2015-03-15 00:03:23.000000', 'temperatura', 199.0000, 'ºC'),
	(114400, 112, '2015-03-15 00:03:24.000000', 'temperatura', 994.0000, 'ºC'),
	(114401, 112, '2015-03-15 00:03:25.000000', 'temperatura', 773.0000, 'ºC'),
	(114402, 112, '2015-03-15 00:03:26.000000', 'temperatura', 882.0000, 'ºC'),
	(114403, 112, '2015-03-15 00:03:27.000000', 'temperatura', 893.0000, 'ºC'),
	(114404, 112, '2015-03-15 00:03:28.000000', 'temperatura', 620.0000, 'ºC'),
	(114405, 112, '2015-03-15 00:03:29.000000', 'temperatura', 419.0000, 'ºC'),
	(114406, 112, '2015-03-15 00:03:30.000000', 'temperatura', 236.0000, 'ºC'),
	(114407, 112, '2015-03-15 00:03:31.000000', 'temperatura', 1124.0000, 'ºC'),
	(114408, 112, '2015-03-15 00:03:32.000000', 'temperatura', 113.0000, 'ºC'),
	(114409, 112, '2015-03-15 00:03:33.000000', 'temperatura', 791.0000, 'ºC'),
	(114410, 112, '2015-03-15 00:03:34.000000', 'temperatura', 20.0000, 'ºC'),
	(114411, 112, '2015-03-15 00:03:35.000000', 'temperatura', 126.0000, 'ºC'),
	(114412, 112, '2015-03-15 00:03:36.000000', 'temperatura', 570.0000, 'ºC'),
	(114413, 112, '2015-03-15 00:03:37.000000', 'temperatura', 73.0000, 'ºC'),
	(114414, 112, '2015-03-15 00:03:38.000000', 'temperatura', 1053.0000, 'ºC'),
	(114415, 112, '2015-03-15 00:03:39.000000', 'temperatura', 250.0000, 'ºC'),
	(114416, 112, '2015-03-15 00:03:40.000000', 'temperatura', 491.0000, 'ºC'),
	(114417, 112, '2015-03-15 00:03:41.000000', 'temperatura', 507.0000, 'ºC'),
	(114418, 112, '2015-03-15 00:03:42.000000', 'temperatura', 1061.0000, 'ºC'),
	(114419, 112, '2015-03-15 00:03:43.000000', 'temperatura', 186.0000, 'ºC'),
	(114420, 112, '2015-03-15 00:03:44.000000', 'temperatura', 146.0000, 'ºC'),
	(114421, 112, '2015-03-15 00:03:45.000000', 'temperatura', 171.0000, 'ºC'),
	(114422, 112, '2015-03-15 00:03:46.000000', 'temperatura', 420.0000, 'ºC'),
	(114423, 112, '2015-03-15 00:03:47.000000', 'temperatura', 387.0000, 'ºC'),
	(114424, 112, '2015-03-15 00:03:48.000000', 'temperatura', 677.0000, 'ºC'),
	(114425, 112, '2015-03-15 00:03:49.000000', 'temperatura', 1025.0000, 'ºC'),
	(114426, 112, '2015-03-15 00:03:50.000000', 'temperatura', 693.0000, 'ºC'),
	(114427, 112, '2015-03-15 00:03:51.000000', 'temperatura', 390.0000, 'ºC'),
	(114428, 112, '2015-03-15 00:03:52.000000', 'temperatura', 1074.0000, 'ºC'),
	(114429, 112, '2015-03-15 00:03:53.000000', 'temperatura', 598.0000, 'ºC'),
	(114430, 112, '2015-03-15 00:03:54.000000', 'temperatura', 968.0000, 'ºC'),
	(114431, 112, '2015-03-15 00:03:55.000000', 'temperatura', 647.0000, 'ºC'),
	(114432, 112, '2015-03-15 00:03:56.000000', 'temperatura', 333.0000, 'ºC'),
	(114433, 112, '2015-03-15 00:03:57.000000', 'temperatura', 922.0000, 'ºC'),
	(114434, 112, '2015-03-15 00:03:58.000000', 'temperatura', 12.0000, 'ºC'),
	(114435, 112, '2015-03-15 00:03:59.000000', 'temperatura', 897.0000, 'ºC'),
	(114436, 112, '2015-03-15 00:04:00.000000', 'temperatura', 848.0000, 'ºC'),
	(114437, 112, '2015-03-15 00:04:01.000000', 'temperatura', 350.0000, 'ºC'),
	(114438, 112, '2015-03-15 00:04:02.000000', 'temperatura', 406.0000, 'ºC'),
	(114439, 112, '2015-03-15 00:04:03.000000', 'temperatura', 982.0000, 'ºC'),
	(114440, 112, '2015-03-15 00:04:04.000000', 'temperatura', 90.0000, 'ºC'),
	(114441, 112, '2015-03-15 00:04:05.000000', 'temperatura', 1107.0000, 'ºC'),
	(114442, 112, '2015-03-15 00:04:06.000000', 'temperatura', 467.0000, 'ºC'),
	(114443, 112, '2015-03-15 00:04:07.000000', 'temperatura', 211.0000, 'ºC'),
	(114444, 112, '2015-03-15 00:04:08.000000', 'temperatura', 855.0000, 'ºC'),
	(114445, 112, '2015-03-15 00:04:09.000000', 'temperatura', 44.0000, 'ºC'),
	(114446, 112, '2015-03-15 00:04:10.000000', 'temperatura', 55.0000, 'ºC'),
	(114447, 112, '2015-03-15 00:04:11.000000', 'temperatura', 144.0000, 'ºC'),
	(114448, 112, '2015-03-15 00:04:12.000000', 'temperatura', 557.0000, 'ºC'),
	(114449, 112, '2015-03-15 00:04:13.000000', 'temperatura', 1153.0000, 'ºC'),
	(114450, 112, '2015-03-15 00:04:14.000000', 'temperatura', 494.0000, 'ºC'),
	(114451, 112, '2015-03-15 00:04:15.000000', 'temperatura', 210.0000, 'ºC'),
	(114452, 112, '2015-03-15 00:04:16.000000', 'temperatura', 770.0000, 'ºC'),
	(114453, 112, '2015-03-15 00:04:17.000000', 'temperatura', 819.0000, 'ºC'),
	(114454, 112, '2015-03-15 00:04:18.000000', 'temperatura', 587.0000, 'ºC'),
	(114455, 112, '2015-03-15 00:04:19.000000', 'temperatura', 477.0000, 'ºC'),
	(114456, 112, '2015-03-15 00:04:20.000000', 'temperatura', 627.0000, 'ºC'),
	(114457, 112, '2015-03-15 00:04:21.000000', 'temperatura', 504.0000, 'ºC'),
	(114458, 112, '2015-03-15 00:04:22.000000', 'temperatura', 640.0000, 'ºC'),
	(114459, 112, '2015-03-15 00:04:23.000000', 'temperatura', 487.0000, 'ºC'),
	(114460, 112, '2015-03-15 00:04:24.000000', 'temperatura', 517.0000, 'ºC'),
	(114461, 112, '2015-03-15 00:04:25.000000', 'temperatura', 1126.0000, 'ºC'),
	(114462, 112, '2015-03-15 00:04:26.000000', 'temperatura', 477.0000, 'ºC'),
	(114463, 112, '2015-03-15 00:04:27.000000', 'temperatura', 209.0000, 'ºC'),
	(114464, 112, '2015-03-15 00:04:28.000000', 'temperatura', 812.0000, 'ºC'),
	(114465, 112, '2015-03-15 00:04:29.000000', 'temperatura', 1037.0000, 'ºC'),
	(114466, 112, '2015-03-15 00:04:30.000000', 'temperatura', 348.0000, 'ºC'),
	(114467, 112, '2015-03-15 00:04:31.000000', 'temperatura', 1029.0000, 'ºC'),
	(114468, 112, '2015-03-15 00:04:32.000000', 'temperatura', 503.0000, 'ºC'),
	(114469, 112, '2015-03-15 00:04:33.000000', 'temperatura', 626.0000, 'ºC'),
	(114470, 112, '2015-03-15 00:04:34.000000', 'temperatura', 422.0000, 'ºC'),
	(114471, 112, '2015-03-15 00:04:35.000000', 'temperatura', 233.0000, 'ºC'),
	(114472, 112, '2015-03-15 00:04:36.000000', 'temperatura', 1098.0000, 'ºC'),
	(114473, 112, '2015-03-15 00:04:37.000000', 'temperatura', 1193.0000, 'ºC'),
	(114474, 112, '2015-03-15 00:04:38.000000', 'temperatura', 272.0000, 'ºC'),
	(114475, 112, '2015-03-15 00:04:39.000000', 'temperatura', 179.0000, 'ºC'),
	(114476, 112, '2015-03-15 00:04:40.000000', 'temperatura', 83.0000, 'ºC'),
	(114477, 112, '2015-03-15 00:04:41.000000', 'temperatura', 1076.0000, 'ºC'),
	(114478, 112, '2015-03-15 00:04:42.000000', 'temperatura', 331.0000, 'ºC'),
	(114479, 112, '2015-03-15 00:04:43.000000', 'temperatura', 829.0000, 'ºC'),
	(114480, 112, '2015-03-15 00:04:44.000000', 'temperatura', 752.0000, 'ºC'),
	(114481, 112, '2015-03-15 00:04:45.000000', 'temperatura', 72.0000, 'ºC'),
	(114482, 112, '2015-03-15 00:04:46.000000', 'temperatura', 505.0000, 'ºC'),
	(114483, 112, '2015-03-15 00:04:47.000000', 'temperatura', 1109.0000, 'ºC'),
	(114484, 112, '2015-03-15 00:04:48.000000', 'temperatura', 432.0000, 'ºC'),
	(114485, 112, '2015-03-15 00:04:49.000000', 'temperatura', 34.0000, 'ºC'),
	(114486, 112, '2015-03-15 00:04:50.000000', 'temperatura', 75.0000, 'ºC'),
	(114487, 112, '2015-03-15 00:04:51.000000', 'temperatura', 272.0000, 'ºC'),
	(114488, 112, '2015-03-15 00:04:52.000000', 'temperatura', 1135.0000, 'ºC'),
	(114489, 112, '2015-03-15 00:04:53.000000', 'temperatura', 60.0000, 'ºC'),
	(114490, 112, '2015-03-15 00:04:54.000000', 'temperatura', 497.0000, 'ºC'),
	(114491, 112, '2015-03-15 00:04:55.000000', 'temperatura', 1105.0000, 'ºC'),
	(114492, 112, '2015-03-15 00:04:56.000000', 'temperatura', 434.0000, 'ºC'),
	(114493, 112, '2015-03-15 00:04:57.000000', 'temperatura', 58.0000, 'ºC'),
	(114494, 112, '2015-03-15 00:04:58.000000', 'temperatura', 185.0000, 'ºC'),
	(114495, 112, '2015-03-15 00:04:59.000000', 'temperatura', 754.0000, 'ºC'),
	(114496, 112, '2015-03-15 00:05:00.000000', 'temperatura', 817.0000, 'ºC'),
	(114497, 112, '2015-03-15 00:05:01.000000', 'temperatura', 620.0000, 'ºC'),
	(114498, 112, '2015-03-15 00:05:02.000000', 'temperatura', 652.0000, 'ºC'),
	(114499, 112, '2015-03-15 00:05:03.000000', 'temperatura', 200.0000, 'ºC'),
	(114500, 112, '2015-03-15 00:05:04.000000', 'temperatura', 246.0000, 'ºC'),
	(114501, 112, '2015-03-15 00:05:05.000000', 'temperatura', 629.0000, 'ºC'),
	(114502, 112, '2015-03-15 00:05:06.000000', 'temperatura', 6.0000, 'ºC'),
	(114503, 112, '2015-03-15 00:05:07.000000', 'temperatura', 543.0000, 'ºC'),
	(114504, 112, '2015-03-15 00:05:08.000000', 'temperatura', 300.0000, 'ºC'),
	(114505, 112, '2015-03-15 00:05:09.000000', 'temperatura', 1072.0000, 'ºC'),
	(114506, 112, '2015-03-15 00:05:10.000000', 'temperatura', 860.0000, 'ºC'),
	(114507, 112, '2015-03-15 00:05:11.000000', 'temperatura', 1084.0000, 'ºC'),
	(114508, 112, '2015-03-15 00:05:12.000000', 'temperatura', 440.0000, 'ºC'),
	(114509, 112, '2015-03-15 00:05:13.000000', 'temperatura', 151.0000, 'ºC'),
	(114510, 112, '2015-03-15 00:05:14.000000', 'temperatura', 633.0000, 'ºC'),
	(114511, 112, '2015-03-15 00:05:15.000000', 'temperatura', 314.0000, 'ºC'),
	(114512, 112, '2015-03-15 00:05:16.000000', 'temperatura', 872.0000, 'ºC'),
	(114513, 112, '2015-03-15 00:05:17.000000', 'temperatura', 1018.0000, 'ºC'),
	(114514, 112, '2015-03-15 00:05:18.000000', 'temperatura', 74.0000, 'ºC'),
	(114515, 112, '2015-03-15 00:05:19.000000', 'temperatura', 915.0000, 'ºC'),
	(114516, 112, '2015-03-15 00:05:20.000000', 'temperatura', 756.0000, 'ºC'),
	(114517, 112, '2015-03-15 00:05:21.000000', 'temperatura', 1035.0000, 'ºC'),
	(114518, 112, '2015-03-15 00:05:22.000000', 'temperatura', 508.0000, 'ºC'),
	(114519, 112, '2015-03-15 00:05:23.000000', 'temperatura', 636.0000, 'ºC'),
	(114520, 112, '2015-03-15 00:05:24.000000', 'temperatura', 457.0000, 'ºC'),
	(114521, 112, '2015-03-15 00:05:25.000000', 'temperatura', 377.0000, 'ºC'),
	(114522, 112, '2015-03-15 00:05:26.000000', 'temperatura', 513.0000, 'ºC'),
	(114523, 112, '2015-03-15 00:05:27.000000', 'temperatura', 234.0000, 'ºC'),
	(114524, 112, '2015-03-15 00:05:28.000000', 'temperatura', 832.0000, 'ºC'),
	(114525, 112, '2015-03-15 00:05:29.000000', 'temperatura', 1057.0000, 'ºC'),
	(114526, 112, '2015-03-15 00:05:30.000000', 'temperatura', 392.0000, 'ºC'),
	(114527, 112, '2015-03-15 00:05:31.000000', 'temperatura', 1189.0000, 'ºC'),
	(114528, 112, '2015-03-15 00:05:32.000000', 'temperatura', 1171.0000, 'ºC'),
	(114529, 112, '2015-03-15 00:05:33.000000', 'temperatura', 1088.0000, 'ºC'),
	(114530, 112, '2015-03-15 00:05:34.000000', 'temperatura', 727.0000, 'ºC'),
	(114531, 112, '2015-03-15 00:05:35.000000', 'temperatura', 370.0000, 'ºC'),
	(114532, 112, '2015-03-15 00:05:36.000000', 'temperatura', 871.0000, 'ºC'),
	(114533, 112, '2015-03-15 00:05:37.000000', 'temperatura', 846.0000, 'ºC'),
	(114534, 112, '2015-03-15 00:05:38.000000', 'temperatura', 417.0000, 'ºC'),
	(114535, 112, '2015-03-15 00:05:39.000000', 'temperatura', 748.0000, 'ºC'),
	(114536, 112, '2015-03-15 00:05:40.000000', 'temperatura', 90.0000, 'ºC'),
	(114537, 112, '2015-03-15 00:05:41.000000', 'temperatura', 606.0000, 'ºC'),
	(114538, 112, '2015-03-15 00:05:42.000000', 'temperatura', 361.0000, 'ºC'),
	(114539, 112, '2015-03-15 00:05:43.000000', 'temperatura', 1186.0000, 'ºC'),
	(114540, 112, '2015-03-15 00:05:44.000000', 'temperatura', 47.0000, 'ºC'),
	(114541, 112, '2015-03-15 00:05:45.000000', 'temperatura', 278.0000, 'ºC'),
	(114542, 112, '2015-03-15 00:05:46.000000', 'temperatura', 49.0000, 'ºC'),
	(114543, 112, '2015-03-15 00:05:47.000000', 'temperatura', 612.0000, 'ºC'),
	(114544, 112, '2015-03-15 00:05:48.000000', 'temperatura', 514.0000, 'ºC'),
	(114545, 112, '2015-03-15 00:05:49.000000', 'temperatura', 735.0000, 'ºC'),
	(114546, 112, '2015-03-15 00:05:50.000000', 'temperatura', 932.0000, 'ºC'),
	(114547, 112, '2015-03-15 00:05:51.000000', 'temperatura', 58.0000, 'ºC'),
	(114548, 112, '2015-03-15 00:05:52.000000', 'temperatura', 1091.0000, 'ºC'),
	(114549, 112, '2015-03-15 00:05:53.000000', 'temperatura', 484.0000, 'ºC'),
	(114550, 112, '2015-03-15 00:05:54.000000', 'temperatura', 348.0000, 'ºC'),
	(114551, 112, '2015-03-15 00:05:55.000000', 'temperatura', 287.0000, 'ºC'),
	(114552, 112, '2015-03-15 00:05:56.000000', 'temperatura', 394.0000, 'ºC'),
	(114553, 112, '2015-03-15 00:05:57.000000', 'temperatura', 1107.0000, 'ºC'),
	(114554, 112, '2015-03-15 00:05:58.000000', 'temperatura', 755.0000, 'ºC'),
	(114555, 112, '2015-03-15 00:05:59.000000', 'temperatura', 456.0000, 'ºC'),
	(114556, 112, '2015-03-15 00:06:00.000000', 'temperatura', 13.0000, 'ºC'),
	(114557, 112, '2015-03-15 00:06:01.000000', 'temperatura', 1099.0000, 'ºC'),
	(114558, 112, '2015-03-15 00:06:02.000000', 'temperatura', 657.0000, 'ºC'),
	(114559, 112, '2015-03-15 00:06:03.000000', 'temperatura', 1186.0000, 'ºC'),
	(114560, 112, '2015-03-15 00:06:04.000000', 'temperatura', 361.0000, 'ºC'),
	(114561, 112, '2015-03-15 00:06:05.000000', 'temperatura', 647.0000, 'ºC'),
	(114562, 112, '2015-03-15 00:06:06.000000', 'temperatura', 951.0000, 'ºC'),
	(114563, 112, '2015-03-15 00:06:07.000000', 'temperatura', 416.0000, 'ºC'),
	(114564, 112, '2015-03-15 00:06:08.000000', 'temperatura', 425.0000, 'ºC'),
	(114565, 112, '2015-03-15 00:06:09.000000', 'temperatura', 880.0000, 'ºC'),
	(114566, 112, '2015-03-15 00:06:10.000000', 'temperatura', 726.0000, 'ºC'),
	(114567, 112, '2015-03-15 00:06:11.000000', 'temperatura', 989.0000, 'ºC'),
	(114568, 112, '2015-03-15 00:06:12.000000', 'temperatura', 367.0000, 'ºC'),
	(114569, 112, '2015-03-15 00:06:13.000000', 'temperatura', 68.0000, 'ºC'),
	(114570, 112, '2015-03-15 00:06:14.000000', 'temperatura', 440.0000, 'ºC'),
	(114571, 112, '2015-03-15 00:06:15.000000', 'temperatura', 796.0000, 'ºC'),
	(114572, 112, '2015-03-15 00:06:16.000000', 'temperatura', 261.0000, 'ºC'),
	(114573, 112, '2015-03-15 00:06:17.000000', 'temperatura', 116.0000, 'ºC'),
	(114574, 112, '2015-03-15 00:06:18.000000', 'temperatura', 1000.0000, 'ºC'),
	(114575, 112, '2015-03-15 00:06:19.000000', 'temperatura', 1051.0000, 'ºC'),
	(114576, 112, '2015-03-15 00:06:20.000000', 'temperatura', 1055.0000, 'ºC'),
	(114577, 112, '2015-03-15 00:06:21.000000', 'temperatura', 923.0000, 'ºC'),
	(114578, 112, '2015-03-15 00:06:22.000000', 'temperatura', 251.0000, 'ºC'),
	(114579, 112, '2015-03-15 00:06:23.000000', 'temperatura', 887.0000, 'ºC'),
	(114580, 112, '2015-03-15 00:06:24.000000', 'temperatura', 81.0000, 'ºC'),
	(114581, 112, '2015-03-15 00:06:25.000000', 'temperatura', 146.0000, 'ºC'),
	(114582, 112, '2015-03-15 00:06:26.000000', 'temperatura', 486.0000, 'ºC'),
	(114583, 112, '2015-03-15 00:06:27.000000', 'temperatura', 794.0000, 'ºC'),
	(114584, 112, '2015-03-15 00:06:28.000000', 'temperatura', 113.0000, 'ºC'),
	(114585, 112, '2015-03-15 00:06:29.000000', 'temperatura', 583.0000, 'ºC'),
	(114586, 112, '2015-03-15 00:06:30.000000', 'temperatura', 175.0000, 'ºC'),
	(114587, 112, '2015-03-15 00:06:31.000000', 'temperatura', 326.0000, 'ºC'),
	(114588, 112, '2015-03-15 00:06:32.000000', 'temperatura', 1104.0000, 'ºC'),
	(114589, 112, '2015-03-15 00:06:33.000000', 'temperatura', 946.0000, 'ºC'),
	(114590, 112, '2015-03-15 00:06:34.000000', 'temperatura', 217.0000, 'ºC'),
	(114591, 112, '2015-03-15 00:06:35.000000', 'temperatura', 650.0000, 'ºC'),
	(114592, 112, '2015-03-15 00:06:36.000000', 'temperatura', 197.0000, 'ºC'),
	(114593, 112, '2015-03-15 00:06:37.000000', 'temperatura', 234.0000, 'ºC'),
	(114594, 112, '2015-03-15 00:06:38.000000', 'temperatura', 583.0000, 'ºC'),
	(114595, 112, '2015-03-15 00:06:39.000000', 'temperatura', 1011.0000, 'ºC'),
	(114596, 112, '2015-03-15 00:06:40.000000', 'temperatura', 907.0000, 'ºC'),
	(114597, 112, '2015-03-15 00:06:41.000000', 'temperatura', 305.0000, 'ºC'),
	(114598, 112, '2015-03-15 00:06:42.000000', 'temperatura', 2.0000, 'ºC'),
	(114599, 112, '2015-03-15 00:06:43.000000', 'temperatura', 296.0000, 'ºC'),
	(114600, 112, '2015-03-15 00:06:44.000000', 'temperatura', 274.0000, 'ºC'),
	(114601, 112, '2015-03-15 00:06:45.000000', 'temperatura', 481.0000, 'ºC'),
	(114602, 112, '2015-03-15 00:06:46.000000', 'temperatura', 385.0000, 'ºC'),
	(114603, 112, '2015-03-15 00:06:47.000000', 'temperatura', 483.0000, 'ºC'),
	(114604, 112, '2015-03-15 00:06:48.000000', 'temperatura', 60.0000, 'ºC'),
	(114605, 112, '2015-03-15 00:06:49.000000', 'temperatura', 52.0000, 'ºC'),
	(114606, 112, '2015-03-15 00:06:50.000000', 'temperatura', 80.0000, 'ºC'),
	(114607, 112, '2015-03-15 00:06:51.000000', 'temperatura', 244.0000, 'ºC'),
	(114608, 112, '2015-03-15 00:06:52.000000', 'temperatura', 980.0000, 'ºC'),
	(114609, 112, '2015-03-15 00:06:53.000000', 'temperatura', 571.0000, 'ºC'),
	(114610, 112, '2015-03-15 00:06:54.000000', 'temperatura', 1113.0000, 'ºC'),
	(114611, 112, '2015-03-15 00:06:55.000000', 'temperatura', 255.0000, 'ºC'),
	(114612, 112, '2015-03-15 00:06:56.000000', 'temperatura', 336.0000, 'ºC'),
	(114613, 112, '2015-03-15 00:06:57.000000', 'temperatura', 913.0000, 'ºC'),
	(114614, 112, '2015-03-15 00:06:58.000000', 'temperatura', 1160.0000, 'ºC'),
	(114615, 112, '2015-03-15 00:06:59.000000', 'temperatura', 660.0000, 'ºC'),
	(114616, 112, '2015-03-15 00:07:00.000000', 'temperatura', 1022.0000, 'ºC'),
	(114617, 112, '2015-03-15 00:07:01.000000', 'temperatura', 728.0000, 'ºC'),
	(114618, 112, '2015-03-15 00:07:02.000000', 'temperatura', 577.0000, 'ºC'),
	(114619, 112, '2015-03-15 00:07:03.000000', 'temperatura', 702.0000, 'ºC'),
	(114620, 112, '2015-03-15 00:07:04.000000', 'temperatura', 579.0000, 'ºC'),
	(114621, 112, '2015-03-15 00:07:05.000000', 'temperatura', 789.0000, 'ºC'),
	(114622, 112, '2015-03-15 00:07:06.000000', 'temperatura', 1007.0000, 'ºC'),
	(114623, 112, '2015-03-15 00:07:07.000000', 'temperatura', 272.0000, 'ºC'),
	(114624, 112, '2015-03-15 00:07:08.000000', 'temperatura', 736.0000, 'ºC'),
	(114625, 112, '2015-03-15 00:07:09.000000', 'temperatura', 467.0000, 'ºC'),
	(114626, 112, '2015-03-15 00:07:10.000000', 'temperatura', 128.0000, 'ºC'),
	(114627, 112, '2015-03-15 00:07:11.000000', 'temperatura', 438.0000, 'ºC'),
	(114628, 112, '2015-03-15 00:07:12.000000', 'temperatura', 608.0000, 'ºC'),
	(114629, 112, '2015-03-15 00:07:13.000000', 'temperatura', 526.0000, 'ºC'),
	(114630, 112, '2015-03-15 00:07:14.000000', 'temperatura', 807.0000, 'ºC'),
	(114631, 112, '2015-03-15 00:07:15.000000', 'temperatura', 55.0000, 'ºC'),
	(114632, 112, '2015-03-15 00:07:16.000000', 'temperatura', 256.0000, 'ºC'),
	(114633, 112, '2015-03-15 00:07:17.000000', 'temperatura', 1114.0000, 'ºC'),
	(114634, 112, '2015-03-15 00:07:18.000000', 'temperatura', 5.0000, 'ºC'),
	(114635, 112, '2015-03-15 00:07:19.000000', 'temperatura', 282.0000, 'ºC'),
	(114636, 112, '2015-03-15 00:07:20.000000', 'temperatura', 195.0000, 'ºC'),
	(114637, 112, '2015-03-15 00:07:21.000000', 'temperatura', 128.0000, 'ºC'),
	(114638, 112, '2015-03-15 00:07:22.000000', 'temperatura', 58.0000, 'ºC'),
	(114639, 112, '2015-03-15 00:07:23.000000', 'temperatura', 1106.0000, 'ºC'),
	(114640, 112, '2015-03-15 00:07:24.000000', 'temperatura', 556.0000, 'ºC'),
	(114641, 112, '2015-03-15 00:07:25.000000', 'temperatura', 663.0000, 'ºC'),
	(114642, 112, '2015-03-15 00:07:26.000000', 'temperatura', 449.0000, 'ºC'),
	(114643, 112, '2015-03-15 00:07:27.000000', 'temperatura', 254.0000, 'ºC'),
	(114644, 112, '2015-03-15 00:07:28.000000', 'temperatura', 1125.0000, 'ºC'),
	(114645, 112, '2015-03-15 00:07:29.000000', 'temperatura', 63.0000, 'ºC'),
	(114646, 112, '2015-03-15 00:07:30.000000', 'temperatura', 542.0000, 'ºC'),
	(114647, 112, '2015-03-15 00:07:31.000000', 'temperatura', 120.0000, 'ºC'),
	(114648, 112, '2015-03-15 00:07:32.000000', 'temperatura', 174.0000, 'ºC'),
	(114649, 112, '2015-03-15 00:07:33.000000', 'temperatura', 512.0000, 'ºC'),
	(114650, 112, '2015-03-15 00:07:34.000000', 'temperatura', 838.0000, 'ºC'),
	(114651, 112, '2015-03-15 00:07:35.000000', 'temperatura', 252.0000, 'ºC'),
	(114652, 112, '2015-03-15 00:07:36.000000', 'temperatura', 1150.0000, 'ºC'),
	(114653, 112, '2015-03-15 00:07:37.000000', 'temperatura', 193.0000, 'ºC'),
	(114654, 112, '2015-03-15 00:07:38.000000', 'temperatura', 1114.0000, 'ºC'),
	(114655, 112, '2015-03-15 00:07:39.000000', 'temperatura', 191.0000, 'ºC'),
	(114656, 112, '2015-03-15 00:07:40.000000', 'temperatura', 15.0000, 'ºC'),
	(114657, 112, '2015-03-15 00:07:41.000000', 'temperatura', 704.0000, 'ºC'),
	(114658, 112, '2015-03-15 00:07:42.000000', 'temperatura', 1075.0000, 'ºC'),
	(114659, 112, '2015-03-15 00:07:43.000000', 'temperatura', 864.0000, 'ºC'),
	(114660, 112, '2015-03-15 00:07:44.000000', 'temperatura', 1096.0000, 'ºC'),
	(114661, 112, '2015-03-15 00:07:45.000000', 'temperatura', 489.0000, 'ºC'),
	(114662, 112, '2015-03-15 00:07:46.000000', 'temperatura', 354.0000, 'ºC'),
	(114663, 112, '2015-03-15 00:07:47.000000', 'temperatura', 307.0000, 'ºC'),
	(114664, 112, '2015-03-15 00:07:48.000000', 'temperatura', 474.0000, 'ºC'),
	(114665, 112, '2015-03-15 00:07:49.000000', 'temperatura', 249.0000, 'ºC'),
	(114666, 112, '2015-03-15 00:07:50.000000', 'temperatura', 1022.0000, 'ºC'),
	(114667, 112, '2015-03-15 00:07:51.000000', 'temperatura', 763.0000, 'ºC'),
	(114668, 112, '2015-03-15 00:07:52.000000', 'temperatura', 749.0000, 'ºC'),
	(114669, 112, '2015-03-15 00:07:53.000000', 'temperatura', 255.0000, 'ºC'),
	(114670, 112, '2015-03-15 00:07:54.000000', 'temperatura', 232.0000, 'ºC'),
	(114671, 112, '2015-03-15 00:07:55.000000', 'temperatura', 393.0000, 'ºC'),
	(114672, 112, '2015-03-15 00:07:56.000000', 'temperatura', 70.0000, 'ºC'),
	(114673, 112, '2015-03-15 00:07:57.000000', 'temperatura', 370.0000, 'ºC'),
	(114674, 112, '2015-03-15 00:07:58.000000', 'temperatura', 443.0000, 'ºC'),
	(114675, 112, '2015-03-15 00:07:59.000000', 'temperatura', 1103.0000, 'ºC'),
	(114676, 112, '2015-03-15 00:08:00.000000', 'temperatura', 588.0000, 'ºC'),
	(114677, 112, '2015-03-15 00:08:01.000000', 'temperatura', 833.0000, 'ºC'),
	(114678, 112, '2015-03-15 00:08:02.000000', 'temperatura', 1198.0000, 'ºC'),
	(114679, 112, '2015-03-15 00:08:03.000000', 'temperatura', 1095.0000, 'ºC'),
	(114680, 112, '2015-03-15 00:08:04.000000', 'temperatura', 679.0000, 'ºC'),
	(114681, 112, '2015-03-15 00:08:05.000000', 'temperatura', 111.0000, 'ºC'),
	(114682, 112, '2015-03-15 00:08:06.000000', 'temperatura', 920.0000, 'ºC'),
	(114683, 112, '2015-03-15 00:08:07.000000', 'temperatura', 666.0000, 'ºC'),
	(114684, 112, '2015-03-15 00:08:08.000000', 'temperatura', 571.0000, 'ºC'),
	(114685, 112, '2015-03-15 00:08:09.000000', 'temperatura', 856.0000, 'ºC'),
	(114686, 112, '2015-03-15 00:08:10.000000', 'temperatura', 167.0000, 'ºC'),
	(114687, 112, '2015-03-15 00:08:11.000000', 'temperatura', 670.0000, 'ºC'),
	(114688, 112, '2015-03-15 00:08:12.000000', 'temperatura', 447.0000, 'ºC'),
	(114689, 112, '2015-03-15 00:08:13.000000', 'temperatura', 225.0000, 'ºC'),
	(114690, 112, '2015-03-15 00:08:14.000000', 'temperatura', 984.0000, 'ºC'),
	(114691, 112, '2015-03-15 00:08:15.000000', 'temperatura', 648.0000, 'ºC'),
	(114692, 112, '2015-03-15 00:08:16.000000', 'temperatura', 286.0000, 'ºC'),
	(114693, 112, '2015-03-15 00:08:17.000000', 'temperatura', 688.0000, 'ºC'),
	(114694, 112, '2015-03-15 00:08:18.000000', 'temperatura', 182.0000, 'ºC'),
	(114695, 112, '2015-03-15 00:08:19.000000', 'temperatura', 49.0000, 'ºC'),
	(114696, 112, '2015-03-15 00:08:20.000000', 'temperatura', 896.0000, 'ºC'),
	(114697, 112, '2015-03-15 00:08:21.000000', 'temperatura', 735.0000, 'ºC'),
	(114698, 112, '2015-03-15 00:08:22.000000', 'temperatura', 986.0000, 'ºC'),
	(114699, 112, '2015-03-15 00:08:23.000000', 'temperatura', 326.0000, 'ºC'),
	(114700, 112, '2015-03-15 00:08:24.000000', 'temperatura', 1074.0000, 'ºC'),
	(114701, 112, '2015-03-15 00:08:25.000000', 'temperatura', 792.0000, 'ºC'),
	(114702, 112, '2015-03-15 00:08:26.000000', 'temperatura', 737.0000, 'ºC'),
	(114703, 112, '2015-03-15 00:08:27.000000', 'temperatura', 111.0000, 'ºC'),
	(114704, 112, '2015-03-15 00:08:28.000000', 'temperatura', 746.0000, 'ºC'),
	(114705, 112, '2015-03-15 00:08:29.000000', 'temperatura', 995.0000, 'ºC'),
	(114706, 112, '2015-03-15 00:08:30.000000', 'temperatura', 339.0000, 'ºC'),
	(114707, 112, '2015-03-15 00:08:31.000000', 'temperatura', 1110.0000, 'ºC'),
	(114708, 112, '2015-03-15 00:08:32.000000', 'temperatura', 932.0000, 'ºC'),
	(114709, 112, '2015-03-15 00:08:33.000000', 'temperatura', 131.0000, 'ºC'),
	(114710, 112, '2015-03-15 00:08:34.000000', 'temperatura', 260.0000, 'ºC'),
	(114711, 112, '2015-03-15 00:08:35.000000', 'temperatura', 907.0000, 'ºC'),
	(114712, 112, '2015-03-15 00:08:36.000000', 'temperatura', 157.0000, 'ºC'),
	(114713, 112, '2015-03-15 00:08:37.000000', 'temperatura', 465.0000, 'ºC'),
	(114714, 112, '2015-03-15 00:08:38.000000', 'temperatura', 654.0000, 'ºC'),
	(114715, 112, '2015-03-15 00:08:39.000000', 'temperatura', 674.0000, 'ºC'),
	(114716, 112, '2015-03-15 00:08:40.000000', 'temperatura', 210.0000, 'ºC'),
	(114717, 112, '2015-03-15 00:08:41.000000', 'temperatura', 226.0000, 'ºC'),
	(114718, 112, '2015-03-15 00:08:42.000000', 'temperatura', 503.0000, 'ºC'),
	(114719, 112, '2015-03-15 00:08:43.000000', 'temperatura', 638.0000, 'ºC'),
	(114720, 112, '2015-03-15 00:08:44.000000', 'temperatura', 480.0000, 'ºC'),
	(114721, 112, '2015-03-15 00:08:45.000000', 'temperatura', 489.0000, 'ºC'),
	(114722, 112, '2015-03-15 00:08:46.000000', 'temperatura', 1002.0000, 'ºC'),
	(114723, 112, '2015-03-15 00:08:47.000000', 'temperatura', 1146.0000, 'ºC'),
	(114724, 112, '2015-03-15 00:08:48.000000', 'temperatura', 325.0000, 'ºC'),
	(114725, 112, '2015-03-15 00:08:49.000000', 'temperatura', 585.0000, 'ºC'),
	(114726, 112, '2015-03-15 00:08:50.000000', 'temperatura', 753.0000, 'ºC'),
	(114727, 112, '2015-03-15 00:08:51.000000', 'temperatura', 811.0000, 'ºC'),
	(114728, 112, '2015-03-15 00:08:52.000000', 'temperatura', 595.0000, 'ºC'),
	(114729, 112, '2015-03-15 00:08:53.000000', 'temperatura', 541.0000, 'ºC'),
	(114730, 112, '2015-03-15 00:08:54.000000', 'temperatura', 921.0000, 'ºC'),
	(114731, 112, '2015-03-15 00:08:55.000000', 'temperatura', 585.0000, 'ºC'),
	(114732, 112, '2015-03-15 00:08:56.000000', 'temperatura', 161.0000, 'ºC'),
	(114733, 112, '2015-03-15 00:08:57.000000', 'temperatura', 250.0000, 'ºC'),
	(114734, 112, '2015-03-15 00:08:58.000000', 'temperatura', 770.0000, 'ºC'),
	(114735, 112, '2015-03-15 00:08:59.000000', 'temperatura', 699.0000, 'ºC'),
	(114736, 112, '2015-03-15 00:09:00.000000', 'temperatura', 1184.0000, 'ºC'),
	(114737, 112, '2015-03-15 00:09:01.000000', 'temperatura', 226.0000, 'ºC'),
	(114738, 112, '2015-03-15 00:09:02.000000', 'temperatura', 1176.0000, 'ºC'),
	(114739, 112, '2015-03-15 00:09:03.000000', 'temperatura', 404.0000, 'ºC'),
	(114740, 112, '2015-03-15 00:09:04.000000', 'temperatura', 894.0000, 'ºC'),
	(114741, 112, '2015-03-15 00:09:05.000000', 'temperatura', 857.0000, 'ºC'),
	(114742, 112, '2015-03-15 00:09:06.000000', 'temperatura', 404.0000, 'ºC'),
	(114743, 112, '2015-03-15 00:09:07.000000', 'temperatura', 649.0000, 'ºC'),
	(114744, 112, '2015-03-15 00:09:08.000000', 'temperatura', 835.0000, 'ºC'),
	(114745, 112, '2015-03-15 00:09:09.000000', 'temperatura', 1028.0000, 'ºC'),
	(114746, 112, '2015-03-15 00:09:10.000000', 'temperatura', 235.0000, 'ºC'),
	(114747, 112, '2015-03-15 00:09:11.000000', 'temperatura', 494.0000, 'ºC'),
	(114748, 112, '2015-03-15 00:09:12.000000', 'temperatura', 563.0000, 'ºC'),
	(114749, 112, '2015-03-15 00:09:13.000000', 'temperatura', 133.0000, 'ºC'),
	(114750, 112, '2015-03-15 00:09:14.000000', 'temperatura', 175.0000, 'ºC'),
	(114751, 112, '2015-03-15 00:09:15.000000', 'temperatura', 480.0000, 'ºC'),
	(114752, 112, '2015-03-15 00:09:16.000000', 'temperatura', 674.0000, 'ºC'),
	(114753, 112, '2015-03-15 00:09:17.000000', 'temperatura', 732.0000, 'ºC'),
	(114754, 112, '2015-03-15 00:09:18.000000', 'temperatura', 438.0000, 'ºC'),
	(114755, 112, '2015-03-15 00:09:19.000000', 'temperatura', 1192.0000, 'ºC'),
	(114756, 112, '2015-03-15 00:09:20.000000', 'temperatura', 1049.0000, 'ºC'),
	(114757, 112, '2015-03-15 00:09:21.000000', 'temperatura', 468.0000, 'ºC'),
	(114758, 112, '2015-03-15 00:09:22.000000', 'temperatura', 396.0000, 'ºC'),
	(114759, 112, '2015-03-15 00:09:23.000000', 'temperatura', 576.0000, 'ºC'),
	(114760, 112, '2015-03-15 00:09:24.000000', 'temperatura', 490.0000, 'ºC'),
	(114761, 112, '2015-03-15 00:09:25.000000', 'temperatura', 724.0000, 'ºC'),
	(114762, 112, '2015-03-15 00:09:26.000000', 'temperatura', 950.0000, 'ºC'),
	(114763, 112, '2015-03-15 00:09:27.000000', 'temperatura', 178.0000, 'ºC'),
	(114764, 112, '2015-03-15 00:09:28.000000', 'temperatura', 439.0000, 'ºC'),
	(114765, 112, '2015-03-15 00:09:29.000000', 'temperatura', 463.0000, 'ºC'),
	(114766, 112, '2015-03-15 00:09:30.000000', 'temperatura', 999.0000, 'ºC'),
	(114767, 112, '2015-03-15 00:09:31.000000', 'temperatura', 4.0000, 'ºC'),
	(114768, 112, '2015-03-15 00:09:32.000000', 'temperatura', 627.0000, 'ºC'),
	(114769, 112, '2015-03-15 00:09:33.000000', 'temperatura', 720.0000, 'ºC'),
	(114770, 112, '2015-03-15 00:09:34.000000', 'temperatura', 522.0000, 'ºC'),
	(114771, 112, '2015-03-15 00:09:35.000000', 'temperatura', 451.0000, 'ºC'),
	(114772, 112, '2015-03-15 00:09:36.000000', 'temperatura', 687.0000, 'ºC'),
	(114773, 112, '2015-03-15 00:09:37.000000', 'temperatura', 882.0000, 'ºC'),
	(114774, 112, '2015-03-15 00:09:38.000000', 'temperatura', 1151.0000, 'ºC'),
	(114775, 112, '2015-03-15 00:09:39.000000', 'temperatura', 708.0000, 'ºC'),
	(114776, 112, '2015-03-15 00:09:40.000000', 'temperatura', 86.0000, 'ºC'),
	(114777, 112, '2015-03-15 00:09:41.000000', 'temperatura', 710.0000, 'ºC'),
	(114778, 112, '2015-03-15 00:09:42.000000', 'temperatura', 890.0000, 'ºC'),
	(114779, 112, '2015-03-15 00:09:43.000000', 'temperatura', 1122.0000, 'ºC'),
	(114780, 112, '2015-03-15 00:09:44.000000', 'temperatura', 540.0000, 'ºC'),
	(114781, 112, '2015-03-15 00:09:45.000000', 'temperatura', 535.0000, 'ºC'),
	(114782, 112, '2015-03-15 00:09:46.000000', 'temperatura', 1056.0000, 'ºC'),
	(114783, 112, '2015-03-15 00:09:47.000000', 'temperatura', 74.0000, 'ºC'),
	(114784, 112, '2015-03-15 00:09:48.000000', 'temperatura', 804.0000, 'ºC'),
	(114785, 112, '2015-03-15 00:09:49.000000', 'temperatura', 200.0000, 'ºC'),
	(114786, 112, '2015-03-15 00:09:50.000000', 'temperatura', 986.0000, 'ºC'),
	(114787, 112, '2015-03-15 00:09:51.000000', 'temperatura', 733.0000, 'ºC'),
	(114788, 112, '2015-03-15 00:09:52.000000', 'temperatura', 706.0000, 'ºC'),
	(114789, 112, '2015-03-15 00:09:53.000000', 'temperatura', 133.0000, 'ºC'),
	(114790, 112, '2015-03-15 00:09:54.000000', 'temperatura', 945.0000, 'ºC'),
	(114791, 112, '2015-03-15 00:09:55.000000', 'temperatura', 727.0000, 'ºC'),
	(114792, 112, '2015-03-15 00:09:56.000000', 'temperatura', 799.0000, 'ºC'),
	(114793, 112, '2015-03-15 00:09:57.000000', 'temperatura', 617.0000, 'ºC'),
	(114794, 112, '2015-03-15 00:09:58.000000', 'temperatura', 688.0000, 'ºC'),
	(114795, 112, '2015-03-15 00:09:59.000000', 'temperatura', 391.0000, 'ºC'),
	(114796, 112, '2015-03-15 00:10:00.000000', 'temperatura', 1091.0000, 'ºC'),
	(114797, 112, '2015-03-15 00:10:01.000000', 'temperatura', 681.0000, 'ºC'),
	(114798, 112, '2015-03-15 00:10:02.000000', 'temperatura', 135.0000, 'ºC'),
	(114799, 112, '2015-03-15 00:10:03.000000', 'temperatura', 1031.0000, 'ºC'),
	(114800, 112, '2015-03-15 00:10:04.000000', 'temperatura', 1152.0000, 'ºC'),
	(114801, 112, '2015-03-15 00:10:05.000000', 'temperatura', 266.0000, 'ºC'),
	(114802, 112, '2015-03-15 00:10:06.000000', 'temperatura', 273.0000, 'ºC'),
	(114803, 112, '2015-03-15 00:10:07.000000', 'temperatura', 568.0000, 'ºC'),
	(114804, 112, '2015-03-15 00:10:08.000000', 'temperatura', 822.0000, 'ºC'),
	(114805, 112, '2015-03-15 00:10:09.000000', 'temperatura', 8.0000, 'ºC'),
	(114806, 112, '2015-03-15 00:10:10.000000', 'temperatura', 1172.0000, 'ºC'),
	(114807, 112, '2015-03-15 00:10:11.000000', 'temperatura', 1035.0000, 'ºC'),
	(114808, 112, '2015-03-15 00:10:12.000000', 'temperatura', 463.0000, 'ºC'),
	(114809, 112, '2015-03-15 00:10:13.000000', 'temperatura', 410.0000, 'ºC'),
	(114810, 112, '2015-03-15 00:10:14.000000', 'temperatura', 663.0000, 'ºC'),
	(114811, 112, '2015-03-15 00:10:15.000000', 'temperatura', 884.0000, 'ºC'),
	(114812, 112, '2015-03-15 00:10:16.000000', 'temperatura', 32.0000, 'ºC'),
	(114813, 112, '2015-03-15 00:10:17.000000', 'temperatura', 1110.0000, 'ºC'),
	(114814, 112, '2015-03-15 00:10:18.000000', 'temperatura', 654.0000, 'ºC'),
	(114815, 112, '2015-03-15 00:10:19.000000', 'temperatura', 1138.0000, 'ºC'),
	(114816, 112, '2015-03-15 00:10:20.000000', 'temperatura', 131.0000, 'ºC'),
	(114817, 112, '2015-03-15 00:10:21.000000', 'temperatura', 843.0000, 'ºC'),
	(114818, 112, '2015-03-15 00:10:22.000000', 'temperatura', 220.0000, 'ºC'),
	(114819, 112, '2015-03-15 00:10:23.000000', 'temperatura', 971.0000, 'ºC'),
	(114820, 112, '2015-03-15 00:10:24.000000', 'temperatura', 597.0000, 'ºC'),
	(114821, 112, '2015-03-15 00:10:25.000000', 'temperatura', 72.0000, 'ºC'),
	(114822, 112, '2015-03-15 00:10:26.000000', 'temperatura', 972.0000, 'ºC'),
	(114823, 112, '2015-03-15 00:10:27.000000', 'temperatura', 1041.0000, 'ºC'),
	(114824, 112, '2015-03-15 00:10:28.000000', 'temperatura', 1092.0000, 'ºC'),
	(114825, 112, '2015-03-15 00:10:29.000000', 'temperatura', 1135.0000, 'ºC'),
	(114826, 112, '2015-03-15 00:10:30.000000', 'temperatura', 3.0000, 'ºC'),
	(114827, 112, '2015-03-15 00:10:31.000000', 'temperatura', 207.0000, 'ºC'),
	(114828, 112, '2015-03-15 00:10:32.000000', 'temperatura', 1028.0000, 'ºC'),
	(114829, 112, '2015-03-15 00:10:33.000000', 'temperatura', 918.0000, 'ºC'),
	(114830, 112, '2015-03-15 00:10:34.000000', 'temperatura', 307.0000, 'ºC'),
	(114831, 112, '2015-03-15 00:10:35.000000', 'temperatura', 1180.0000, 'ºC'),
	(114832, 112, '2015-03-15 00:10:36.000000', 'temperatura', 181.0000, 'ºC'),
	(114833, 112, '2015-03-15 00:10:37.000000', 'temperatura', 964.0000, 'ºC'),
	(114834, 112, '2015-03-15 00:10:38.000000', 'temperatura', 678.0000, 'ºC'),
	(114835, 112, '2015-03-15 00:10:39.000000', 'temperatura', 498.0000, 'ºC'),
	(114836, 112, '2015-03-15 00:10:40.000000', 'temperatura', 459.0000, 'ºC'),
	(114837, 112, '2015-03-15 00:10:41.000000', 'temperatura', 800.0000, 'ºC'),
	(114838, 112, '2015-03-15 00:10:42.000000', 'temperatura', 224.0000, 'ºC'),
	(114839, 112, '2015-03-15 00:10:43.000000', 'temperatura', 1118.0000, 'ºC'),
	(114840, 112, '2015-03-15 00:10:44.000000', 'temperatura', 122.0000, 'ºC'),
	(114841, 112, '2015-03-15 00:10:45.000000', 'temperatura', 854.0000, 'ºC'),
	(114842, 112, '2015-03-15 00:10:46.000000', 'temperatura', 305.0000, 'ºC'),
	(114843, 112, '2015-03-15 00:10:47.000000', 'temperatura', 163.0000, 'ºC'),
	(114844, 112, '2015-03-15 00:10:48.000000', 'temperatura', 1101.0000, 'ºC'),
	(114845, 112, '2015-03-15 00:10:49.000000', 'temperatura', 217.0000, 'ºC'),
	(114846, 112, '2015-03-15 00:10:50.000000', 'temperatura', 181.0000, 'ºC'),
	(114847, 112, '2015-03-15 00:10:51.000000', 'temperatura', 256.0000, 'ºC'),
	(114848, 112, '2015-03-15 00:10:52.000000', 'temperatura', 737.0000, 'ºC'),
	(114849, 112, '2015-03-15 00:10:53.000000', 'temperatura', 517.0000, 'ºC'),
	(114850, 112, '2015-03-15 00:10:54.000000', 'temperatura', 375.0000, 'ºC'),
	(114851, 112, '2015-03-15 00:10:55.000000', 'temperatura', 326.0000, 'ºC'),
	(114852, 112, '2015-03-15 00:10:56.000000', 'temperatura', 505.0000, 'ºC'),
	(114853, 112, '2015-03-15 00:10:57.000000', 'temperatura', 347.0000, 'ºC'),
	(114854, 112, '2015-03-15 00:10:58.000000', 'temperatura', 220.0000, 'ºC'),
	(114855, 112, '2015-03-15 00:10:59.000000', 'temperatura', 60.0000, 'ºC'),
	(114856, 112, '2015-03-15 00:11:00.000000', 'temperatura', 839.0000, 'ºC'),
	(114857, 112, '2015-03-15 00:11:01.000000', 'temperatura', 415.0000, 'ºC'),
	(114858, 112, '2015-03-15 00:11:02.000000', 'temperatura', 760.0000, 'ºC'),
	(114859, 112, '2015-03-15 00:11:03.000000', 'temperatura', 154.0000, 'ºC'),
	(114860, 112, '2015-03-15 00:11:04.000000', 'temperatura', 889.0000, 'ºC'),
	(114861, 112, '2015-03-15 00:11:05.000000', 'temperatura', 387.0000, 'ºC'),
	(114862, 112, '2015-03-15 00:11:06.000000', 'temperatura', 468.0000, 'ºC'),
	(114863, 112, '2015-03-15 00:11:07.000000', 'temperatura', 1180.0000, 'ºC'),
	(114864, 112, '2015-03-15 00:11:08.000000', 'temperatura', 897.0000, 'ºC'),
	(114865, 112, '2015-03-15 00:11:09.000000', 'temperatura', 943.0000, 'ºC'),
	(114866, 112, '2015-03-15 00:11:10.000000', 'temperatura', 826.0000, 'ºC'),
	(114867, 112, '2015-03-15 00:11:11.000000', 'temperatura', 103.0000, 'ºC'),
	(114868, 112, '2015-03-15 00:11:12.000000', 'temperatura', 436.0000, 'ºC'),
	(114869, 112, '2015-03-15 00:11:13.000000', 'temperatura', 671.0000, 'ºC'),
	(114870, 112, '2015-03-15 00:11:14.000000', 'temperatura', 850.0000, 'ºC'),
	(114871, 112, '2015-03-15 00:11:15.000000', 'temperatura', 1035.0000, 'ºC'),
	(114872, 112, '2015-03-15 00:11:16.000000', 'temperatura', 225.0000, 'ºC'),
	(114873, 112, '2015-03-15 00:11:17.000000', 'temperatura', 421.0000, 'ºC'),
	(114874, 112, '2015-03-15 00:11:18.000000', 'temperatura', 231.0000, 'ºC'),
	(114875, 112, '2015-03-15 00:11:19.000000', 'temperatura', 1092.0000, 'ºC'),
	(114876, 112, '2015-03-15 00:11:20.000000', 'temperatura', 1166.0000, 'ºC'),
	(114877, 112, '2015-03-15 00:11:21.000000', 'temperatura', 157.0000, 'ºC'),
	(114878, 112, '2015-03-15 00:11:22.000000', 'temperatura', 886.0000, 'ºC'),
	(114879, 112, '2015-03-15 00:11:23.000000', 'temperatura', 358.0000, 'ºC'),
	(114880, 112, '2015-03-15 00:11:24.000000', 'temperatura', 335.0000, 'ºC'),
	(114881, 112, '2015-03-15 00:11:25.000000', 'temperatura', 602.0000, 'ºC'),
	(114882, 112, '2015-03-15 00:11:26.000000', 'temperatura', 805.0000, 'ºC'),
	(114883, 112, '2015-03-15 00:11:27.000000', 'temperatura', 1020.0000, 'ºC'),
	(114884, 112, '2015-03-15 00:11:28.000000', 'temperatura', 285.0000, 'ºC'),
	(114885, 112, '2015-03-15 00:11:29.000000', 'temperatura', 763.0000, 'ºC'),
	(114886, 112, '2015-03-15 00:11:30.000000', 'temperatura', 564.0000, 'ºC'),
	(114887, 112, '2015-03-15 00:11:31.000000', 'temperatura', 531.0000, 'ºC'),
	(114888, 112, '2015-03-15 00:11:32.000000', 'temperatura', 962.0000, 'ºC'),
	(114889, 112, '2015-03-15 00:11:33.000000', 'temperatura', 820.0000, 'ºC'),
	(114890, 112, '2015-03-15 00:11:34.000000', 'temperatura', 14.0000, 'ºC'),
	(114891, 112, '2015-03-15 00:11:35.000000', 'temperatura', 10.0000, 'ºC'),
	(114892, 112, '2015-03-15 00:11:36.000000', 'temperatura', 10.0000, 'ºC'),
	(114893, 112, '2015-03-15 00:11:37.000000', 'temperatura', 19.0000, 'ºC'),
	(114894, 112, '2015-03-15 00:11:38.000000', 'temperatura', 68.0000, 'ºC'),
	(114895, 112, '2015-03-15 00:11:39.000000', 'temperatura', 280.0000, 'ºC'),
	(114896, 112, '2015-03-15 00:11:40.000000', 'temperatura', 0.0000, 'ºC'),
	(114897, 112, '2015-03-15 00:11:41.000000', 'temperatura', 359.0000, 'ºC'),
	(114898, 112, '2015-03-15 00:11:42.000000', 'temperatura', 596.0000, 'ºC'),
	(114899, 112, '2015-03-15 00:11:43.000000', 'temperatura', 702.0000, 'ºC'),
	(114900, 112, '2015-03-15 00:11:44.000000', 'temperatura', 522.0000, 'ºC'),
	(114901, 112, '2015-03-15 00:11:45.000000', 'temperatura', 506.0000, 'ºC'),
	(114902, 112, '2015-03-15 00:11:46.000000', 'temperatura', 966.0000, 'ºC'),
	(114903, 112, '2015-03-15 00:11:47.000000', 'temperatura', 909.0000, 'ºC'),
	(114904, 112, '2015-03-15 00:11:48.000000', 'temperatura', 449.0000, 'ºC'),
	(114905, 112, '2015-03-15 00:11:49.000000', 'temperatura', 721.0000, 'ºC'),
	(114906, 112, '2015-03-15 00:11:50.000000', 'temperatura', 1055.0000, 'ºC'),
	(114907, 112, '2015-03-15 00:11:51.000000', 'temperatura', 714.0000, 'ºC'),
	(114908, 112, '2015-03-15 00:11:52.000000', 'temperatura', 406.0000, 'ºC'),
	(114909, 112, '2015-03-15 00:11:53.000000', 'temperatura', 1087.0000, 'ºC'),
	(114910, 112, '2015-03-15 00:11:54.000000', 'temperatura', 618.0000, 'ºC'),
	(114911, 112, '2015-03-15 00:11:55.000000', 'temperatura', 1031.0000, 'ºC'),
	(114912, 112, '2015-03-15 00:11:56.000000', 'temperatura', 901.0000, 'ºC'),
	(114913, 112, '2015-03-15 00:11:57.000000', 'temperatura', 213.0000, 'ºC'),
	(114914, 112, '2015-03-15 00:11:58.000000', 'temperatura', 763.0000, 'ºC'),
	(114915, 112, '2015-03-15 00:11:59.000000', 'temperatura', 774.0000, 'ºC'),
	(114916, 112, '2015-03-15 00:12:00.000000', 'temperatura', 384.0000, 'ºC'),
	(114917, 112, '2015-03-15 00:12:01.000000', 'temperatura', 796.0000, 'ºC'),
	(114918, 112, '2015-03-15 00:12:02.000000', 'temperatura', 430.0000, 'ºC'),
	(114919, 112, '2015-03-15 00:12:03.000000', 'temperatura', 964.0000, 'ºC'),
	(114920, 112, '2015-03-15 00:12:04.000000', 'temperatura', 1129.0000, 'ºC'),
	(114921, 112, '2015-03-15 00:12:05.000000', 'temperatura', 352.0000, 'ºC'),
	(114922, 112, '2015-03-15 00:12:06.000000', 'temperatura', 776.0000, 'ºC'),
	(114923, 112, '2015-03-15 00:12:07.000000', 'temperatura', 425.0000, 'ºC'),
	(114924, 112, '2015-03-15 00:12:08.000000', 'temperatura', 998.0000, 'ºC'),
	(114925, 112, '2015-03-15 00:12:09.000000', 'temperatura', 117.0000, 'ºC'),
	(114926, 112, '2015-03-15 00:12:10.000000', 'temperatura', 1188.0000, 'ºC'),
	(114927, 112, '2015-03-15 00:12:11.000000', 'temperatura', 790.0000, 'ºC'),
	(114928, 112, '2015-03-15 00:12:12.000000', 'temperatura', 387.0000, 'ºC'),
	(114929, 112, '2015-03-15 00:12:13.000000', 'temperatura', 767.0000, 'ºC'),
	(114930, 112, '2015-03-15 00:12:14.000000', 'temperatura', 272.0000, 'ºC'),
	(114931, 112, '2015-03-15 00:12:15.000000', 'temperatura', 260.0000, 'ºC'),
	(114932, 112, '2015-03-15 00:12:16.000000', 'temperatura', 485.0000, 'ºC'),
	(114933, 112, '2015-03-15 00:12:17.000000', 'temperatura', 445.0000, 'ºC'),
	(114934, 112, '2015-03-15 00:12:18.000000', 'temperatura', 771.0000, 'ºC'),
	(114935, 112, '2015-03-15 00:12:19.000000', 'temperatura', 118.0000, 'ºC'),
	(114936, 112, '2015-03-15 00:12:20.000000', 'temperatura', 681.0000, 'ºC'),
	(114937, 112, '2015-03-15 00:12:21.000000', 'temperatura', 649.0000, 'ºC'),
	(114938, 112, '2015-03-15 00:12:22.000000', 'temperatura', 4.0000, 'ºC'),
	(114939, 112, '2015-03-15 00:12:23.000000', 'temperatura', 473.0000, 'ºC'),
	(114940, 112, '2015-03-15 00:12:24.000000', 'temperatura', 1154.0000, 'ºC'),
	(114941, 112, '2015-03-15 00:12:25.000000', 'temperatura', 749.0000, 'ºC'),
	(114942, 112, '2015-03-15 00:12:26.000000', 'temperatura', 286.0000, 'ºC'),
	(114943, 112, '2015-03-15 00:12:27.000000', 'temperatura', 381.0000, 'ºC'),
	(114944, 112, '2015-03-15 00:12:28.000000', 'temperatura', 1049.0000, 'ºC'),
	(114945, 112, '2015-03-15 00:12:29.000000', 'temperatura', 504.0000, 'ºC'),
	(114946, 112, '2015-03-15 00:12:30.000000', 'temperatura', 572.0000, 'ºC'),
	(114947, 112, '2015-03-15 00:12:31.000000', 'temperatura', 149.0000, 'ºC'),
	(114948, 112, '2015-03-15 00:12:32.000000', 'temperatura', 229.0000, 'ºC'),
	(114949, 112, '2015-03-15 00:12:33.000000', 'temperatura', 699.0000, 'ºC'),
	(114950, 112, '2015-03-15 00:12:34.000000', 'temperatura', 407.0000, 'ºC'),
	(114951, 112, '2015-03-15 00:12:35.000000', 'temperatura', 1138.0000, 'ºC'),
	(114952, 112, '2015-03-15 00:12:36.000000', 'temperatura', 870.0000, 'ºC'),
	(114953, 112, '2015-03-15 00:12:37.000000', 'temperatura', 936.0000, 'ºC'),
	(114954, 112, '2015-03-15 00:12:38.000000', 'temperatura', 871.0000, 'ºC'),
	(114955, 112, '2015-03-15 00:12:39.000000', 'temperatura', 347.0000, 'ºC'),
	(114956, 112, '2015-03-15 00:12:40.000000', 'temperatura', 321.0000, 'ºC'),
	(114957, 112, '2015-03-15 00:12:41.000000', 'temperatura', 567.0000, 'ºC'),
	(114958, 112, '2015-03-15 00:12:42.000000', 'temperatura', 673.0000, 'ºC'),
	(114959, 112, '2015-03-15 00:12:43.000000', 'temperatura', 462.0000, 'ºC'),
	(114960, 112, '2015-03-15 00:12:44.000000', 'temperatura', 292.0000, 'ºC'),
	(114961, 112, '2015-03-15 00:12:45.000000', 'temperatura', 74.0000, 'ºC'),
	(114962, 112, '2015-03-15 00:12:46.000000', 'temperatura', 693.0000, 'ºC'),
	(114963, 112, '2015-03-15 00:12:47.000000', 'temperatura', 846.0000, 'ºC'),
	(114964, 112, '2015-03-15 00:12:48.000000', 'temperatura', 952.0000, 'ºC'),
	(114965, 112, '2015-03-15 00:12:49.000000', 'temperatura', 1022.0000, 'ºC'),
	(114966, 112, '2015-03-15 00:12:50.000000', 'temperatura', 1053.0000, 'ºC'),
	(114967, 112, '2015-03-15 00:12:51.000000', 'temperatura', 1001.0000, 'ºC'),
	(114968, 112, '2015-03-15 00:12:52.000000', 'temperatura', 645.0000, 'ºC'),
	(114969, 112, '2015-03-15 00:12:53.000000', 'temperatura', 225.0000, 'ºC'),
	(114970, 112, '2015-03-15 00:12:54.000000', 'temperatura', 389.0000, 'ºC'),
	(114971, 112, '2015-03-15 00:12:55.000000', 'temperatura', 72.0000, 'ºC'),
	(114972, 112, '2015-03-15 00:12:56.000000', 'temperatura', 392.0000, 'ºC'),
	(114973, 112, '2015-03-15 00:12:57.000000', 'temperatura', 544.0000, 'ºC'),
	(114974, 112, '2015-03-15 00:12:58.000000', 'temperatura', 347.0000, 'ºC'),
	(114975, 112, '2015-03-15 00:12:59.000000', 'temperatura', 102.0000, 'ºC'),
	(114976, 112, '2015-03-15 00:13:00.000000', 'temperatura', 668.0000, 'ºC'),
	(114977, 112, '2015-03-15 00:13:01.000000', 'temperatura', 634.0000, 'ºC'),
	(114978, 112, '2015-03-15 00:13:02.000000', 'temperatura', 1169.0000, 'ºC'),
	(114979, 112, '2015-03-15 00:13:03.000000', 'temperatura', 341.0000, 'ºC'),
	(114980, 112, '2015-03-15 00:13:04.000000', 'temperatura', 599.0000, 'ºC'),
	(114981, 112, '2015-03-15 00:13:05.000000', 'temperatura', 771.0000, 'ºC'),
	(114982, 112, '2015-03-15 00:13:06.000000', 'temperatura', 861.0000, 'ºC'),
	(114983, 112, '2015-03-15 00:13:07.000000', 'temperatura', 790.0000, 'ºC'),
	(114984, 112, '2015-03-15 00:13:08.000000', 'temperatura', 168.0000, 'ºC'),
	(114985, 112, '2015-03-15 00:13:09.000000', 'temperatura', 870.0000, 'ºC'),
	(114986, 112, '2015-03-15 00:13:10.000000', 'temperatura', 246.0000, 'ºC'),
	(114987, 112, '2015-03-15 00:13:11.000000', 'temperatura', 1020.0000, 'ºC'),
	(114988, 112, '2015-03-15 00:13:12.000000', 'temperatura', 765.0000, 'ºC'),
	(114989, 112, '2015-03-15 00:13:13.000000', 'temperatura', 764.0000, 'ºC'),
	(114990, 112, '2015-03-15 00:13:14.000000', 'temperatura', 327.0000, 'ºC'),
	(114991, 112, '2015-03-15 00:13:15.000000', 'temperatura', 545.0000, 'ºC'),
	(114992, 112, '2015-03-15 00:13:16.000000', 'temperatura', 542.0000, 'ºC'),
	(114993, 112, '2015-03-15 00:13:17.000000', 'temperatura', 1075.0000, 'ºC'),
	(114994, 112, '2015-03-15 00:13:18.000000', 'temperatura', 150.0000, 'ºC'),
	(114995, 112, '2015-03-15 00:13:19.000000', 'temperatura', 1127.0000, 'ºC'),
	(114996, 112, '2015-03-15 00:13:20.000000', 'temperatura', 383.0000, 'ºC'),
	(114997, 112, '2015-03-15 00:13:21.000000', 'temperatura', 934.0000, 'ºC'),
	(114998, 112, '2015-03-15 00:13:22.000000', 'temperatura', 1123.0000, 'ºC'),
	(114999, 112, '2015-03-15 00:13:23.000000', 'temperatura', 412.0000, 'ºC'),
	(115000, 112, '2015-03-15 00:13:24.000000', 'temperatura', 1093.0000, 'ºC'),
	(115001, 112, '2015-03-15 00:13:25.000000', 'temperatura', 629.0000, 'ºC'),
	(115002, 112, '2015-03-15 00:13:26.000000', 'temperatura', 1065.0000, 'ºC'),
	(115003, 112, '2015-03-15 00:13:27.000000', 'temperatura', 1039.0000, 'ºC'),
	(115004, 112, '2015-03-15 00:13:28.000000', 'temperatura', 803.0000, 'ºC'),
	(115005, 112, '2015-03-15 00:13:29.000000', 'temperatura', 897.0000, 'ºC'),
	(115006, 112, '2015-03-15 00:13:30.000000', 'temperatura', 876.0000, 'ºC'),
	(115007, 112, '2015-03-15 00:13:31.000000', 'temperatura', 489.0000, 'ºC'),
	(115008, 112, '2015-03-15 00:13:32.000000', 'temperatura', 1019.0000, 'ºC'),
	(115009, 112, '2015-03-15 00:13:33.000000', 'temperatura', 29.0000, 'ºC'),
	(115010, 112, '2015-03-15 00:13:34.000000', 'temperatura', 687.0000, 'ºC'),
	(115011, 112, '2015-03-15 00:13:35.000000', 'temperatura', 950.0000, 'ºC'),
	(115012, 112, '2015-03-15 00:13:36.000000', 'temperatura', 289.0000, 'ºC'),
	(115013, 112, '2015-03-15 00:13:37.000000', 'temperatura', 994.0000, 'ºC'),
	(115014, 112, '2015-03-15 00:13:38.000000', 'temperatura', 503.0000, 'ºC'),
	(115015, 112, '2015-03-15 00:13:39.000000', 'temperatura', 735.0000, 'ºC'),
	(115016, 112, '2015-03-15 00:13:40.000000', 'temperatura', 967.0000, 'ºC'),
	(115017, 112, '2015-03-15 00:13:41.000000', 'temperatura', 231.0000, 'ºC'),
	(115018, 112, '2015-03-15 00:13:42.000000', 'temperatura', 652.0000, 'ºC'),
	(115019, 112, '2015-03-15 00:13:43.000000', 'temperatura', 168.0000, 'ºC'),
	(115020, 112, '2015-03-15 00:13:44.000000', 'temperatura', 85.0000, 'ºC'),
	(115021, 112, '2015-03-15 00:13:45.000000', 'temperatura', 1121.0000, 'ºC'),
	(115022, 112, '2015-03-15 00:13:46.000000', 'temperatura', 553.0000, 'ºC'),
	(115023, 112, '2015-03-15 00:13:47.000000', 'temperatura', 600.0000, 'ºC'),
	(115024, 112, '2015-03-15 00:13:48.000000', 'temperatura', 144.0000, 'ºC'),
	(115025, 112, '2015-03-15 00:13:49.000000', 'temperatura', 119.0000, 'ºC'),
	(115026, 112, '2015-03-15 00:13:50.000000', 'temperatura', 162.0000, 'ºC'),
	(115027, 112, '2015-03-15 00:13:51.000000', 'temperatura', 455.0000, 'ºC'),
	(115028, 112, '2015-03-15 00:13:52.000000', 'temperatura', 588.0000, 'ºC'),
	(115029, 112, '2015-03-15 00:13:53.000000', 'temperatura', 378.0000, 'ºC'),
	(115030, 112, '2015-03-15 00:13:54.000000', 'temperatura', 124.0000, 'ºC'),
	(115031, 112, '2015-03-15 00:13:55.000000', 'temperatura', 687.0000, 'ºC'),
	(115032, 112, '2015-03-15 00:13:56.000000', 'temperatura', 664.0000, 'ºC'),
	(115033, 112, '2015-03-15 00:13:57.000000', 'temperatura', 58.0000, 'ºC'),
	(115034, 112, '2015-03-15 00:13:58.000000', 'temperatura', 701.0000, 'ºC'),
	(115035, 112, '2015-03-15 00:13:59.000000', 'temperatura', 929.0000, 'ºC'),
	(115036, 112, '2015-03-15 00:14:00.000000', 'temperatura', 145.0000, 'ºC'),
	(115037, 112, '2015-03-15 00:14:01.000000', 'temperatura', 338.0000, 'ºC'),
	(115038, 112, '2015-03-15 00:14:02.000000', 'temperatura', 56.0000, 'ºC'),
	(115039, 112, '2015-03-15 00:14:03.000000', 'temperatura', 467.0000, 'ºC'),
	(115040, 112, '2015-03-15 00:14:04.000000', 'temperatura', 965.0000, 'ºC'),
	(115041, 112, '2015-03-15 00:14:05.000000', 'temperatura', 1026.0000, 'ºC'),
	(115042, 112, '2015-03-15 00:14:06.000000', 'temperatura', 1036.0000, 'ºC'),
	(115043, 112, '2015-03-15 00:14:07.000000', 'temperatura', 904.0000, 'ºC'),
	(115044, 112, '2015-03-15 00:14:08.000000', 'temperatura', 211.0000, 'ºC'),
	(115045, 112, '2015-03-15 00:14:09.000000', 'temperatura', 743.0000, 'ºC'),
	(115046, 112, '2015-03-15 00:14:10.000000', 'temperatura', 683.0000, 'ºC'),
	(115047, 112, '2015-03-15 00:14:11.000000', 'temperatura', 1185.0000, 'ºC'),
	(115048, 112, '2015-03-15 00:14:12.000000', 'temperatura', 279.0000, 'ºC'),
	(115049, 112, '2015-03-15 00:14:13.000000', 'temperatura', 238.0000, 'ºC'),
	(115050, 112, '2015-03-15 00:14:14.000000', 'temperatura', 355.0000, 'ºC'),
	(115051, 112, '2015-03-15 00:14:15.000000', 'temperatura', 1060.0000, 'ºC'),
	(115052, 112, '2015-03-15 00:14:16.000000', 'temperatura', 637.0000, 'ºC'),
	(115053, 112, '2015-03-15 00:14:17.000000', 'temperatura', 5.0000, 'ºC'),
	(115054, 112, '2015-03-15 00:14:18.000000', 'temperatura', 513.0000, 'ºC'),
	(115055, 112, '2015-03-15 00:14:19.000000', 'temperatura', 153.0000, 'ºC'),
	(115056, 112, '2015-03-15 00:14:20.000000', 'temperatura', 423.0000, 'ºC'),
	(115057, 112, '2015-03-15 00:14:21.000000', 'temperatura', 460.0000, 'ºC'),
	(115058, 112, '2015-03-15 00:14:22.000000', 'temperatura', 1030.0000, 'ºC'),
	(115059, 112, '2015-03-15 00:14:23.000000', 'temperatura', 170.0000, 'ºC'),
	(115060, 112, '2015-03-15 00:14:24.000000', 'temperatura', 161.0000, 'ºC'),
	(115061, 112, '2015-03-15 00:14:25.000000', 'temperatura', 294.0000, 'ºC'),
	(115062, 112, '2015-03-15 00:14:26.000000', 'temperatura', 991.0000, 'ºC'),
	(115063, 112, '2015-03-15 00:14:27.000000', 'temperatura', 470.0000, 'ºC'),
	(115064, 112, '2015-03-15 00:14:28.000000', 'temperatura', 577.0000, 'ºC'),
	(115065, 112, '2015-03-15 00:14:29.000000', 'temperatura', 278.0000, 'ºC'),
	(115066, 112, '2015-03-15 00:14:30.000000', 'temperatura', 859.0000, 'ºC'),
	(115067, 112, '2015-03-15 00:14:31.000000', 'temperatura', 1060.0000, 'ºC'),
	(115068, 112, '2015-03-15 00:14:32.000000', 'temperatura', 323.0000, 'ºC'),
	(115069, 112, '2015-03-15 00:14:33.000000', 'temperatura', 837.0000, 'ºC'),
	(115070, 112, '2015-03-15 00:14:34.000000', 'temperatura', 817.0000, 'ºC'),
	(115071, 112, '2015-03-15 00:14:35.000000', 'temperatura', 376.0000, 'ºC'),
	(115072, 112, '2015-03-15 00:14:36.000000', 'temperatura', 626.0000, 'ºC'),
	(115073, 112, '2015-03-15 00:14:37.000000', 'temperatura', 804.0000, 'ºC'),
	(115074, 112, '2015-03-15 00:14:38.000000', 'temperatura', 941.0000, 'ºC'),
	(115075, 112, '2015-03-15 00:14:39.000000', 'temperatura', 1092.0000, 'ºC'),
	(115076, 112, '2015-03-15 00:14:40.000000', 'temperatura', 241.0000, 'ºC'),
	(115077, 112, '2015-03-15 00:14:41.000000', 'temperatura', 327.0000, 'ºC'),
	(115078, 112, '2015-03-15 00:14:42.000000', 'temperatura', 915.0000, 'ºC'),
	(115079, 112, '2015-03-15 00:14:43.000000', 'temperatura', 1194.0000, 'ºC'),
	(115080, 112, '2015-03-15 00:14:44.000000', 'temperatura', 827.0000, 'ºC'),
	(115081, 112, '2015-03-15 00:14:45.000000', 'temperatura', 552.0000, 'ºC'),
	(115082, 112, '2015-03-15 00:14:46.000000', 'temperatura', 280.0000, 'ºC'),
	(115083, 112, '2015-03-15 00:14:47.000000', 'temperatura', 944.0000, 'ºC'),
	(115084, 112, '2015-03-15 00:14:48.000000', 'temperatura', 280.0000, 'ºC'),
	(115085, 112, '2015-03-15 00:14:49.000000', 'temperatura', 970.0000, 'ºC'),
	(115086, 112, '2015-03-15 00:14:50.000000', 'temperatura', 412.0000, 'ºC'),
	(115087, 112, '2015-03-15 00:14:51.000000', 'temperatura', 348.0000, 'ºC'),
	(115088, 112, '2015-03-15 00:14:52.000000', 'temperatura', 503.0000, 'ºC'),
	(115089, 112, '2015-03-15 00:14:53.000000', 'temperatura', 274.0000, 'ºC'),
	(115090, 112, '2015-03-15 00:14:54.000000', 'temperatura', 1059.0000, 'ºC'),
	(115091, 112, '2015-03-15 00:14:55.000000', 'temperatura', 876.0000, 'ºC'),
	(115092, 112, '2015-03-15 00:14:56.000000', 'temperatura', 3.0000, 'ºC'),
	(115093, 112, '2015-03-15 00:14:57.000000', 'temperatura', 988.0000, 'ºC'),
	(115094, 112, '2015-03-15 00:14:58.000000', 'temperatura', 129.0000, 'ºC'),
	(115095, 112, '2015-03-15 00:14:59.000000', 'temperatura', 84.0000, 'ºC'),
	(115096, 112, '2015-03-15 00:15:00.000000', 'temperatura', 31.0000, 'ºC'),
	(115097, 112, '2015-03-15 00:15:01.000000', 'temperatura', 1103.0000, 'ºC'),
	(115098, 112, '2015-03-15 00:15:02.000000', 'temperatura', 625.0000, 'ºC'),
	(115099, 112, '2015-03-15 00:15:03.000000', 'temperatura', 1017.0000, 'ºC'),
	(115100, 112, '2015-03-15 00:15:04.000000', 'temperatura', 811.0000, 'ºC'),
	(115101, 112, '2015-03-15 00:15:05.000000', 'temperatura', 1005.0000, 'ºC'),
	(115102, 112, '2015-03-15 00:15:06.000000', 'temperatura', 191.0000, 'ºC'),
	(115103, 112, '2015-03-15 00:15:07.000000', 'temperatura', 342.0000, 'ºC'),
	(115104, 112, '2015-03-15 00:15:08.000000', 'temperatura', 1138.0000, 'ºC'),
	(115105, 112, '2015-03-15 00:15:09.000000', 'temperatura', 1064.0000, 'ºC'),
	(115106, 112, '2015-03-15 00:15:10.000000', 'temperatura', 706.0000, 'ºC'),
	(115107, 112, '2015-03-15 00:15:11.000000', 'temperatura', 340.0000, 'ºC'),
	(115108, 112, '2015-03-15 00:15:12.000000', 'temperatura', 783.0000, 'ºC'),
	(115109, 112, '2015-03-15 00:15:13.000000', 'temperatura', 494.0000, 'ºC'),
	(115110, 112, '2015-03-15 00:15:14.000000', 'temperatura', 120.0000, 'ºC'),
	(115111, 112, '2015-03-15 00:15:15.000000', 'temperatura', 321.0000, 'ºC'),
	(115112, 112, '2015-03-15 00:15:16.000000', 'temperatura', 43.0000, 'ºC'),
	(115113, 112, '2015-03-15 00:15:17.000000', 'temperatura', 452.0000, 'ºC'),
	(115114, 112, '2015-03-15 00:15:18.000000', 'temperatura', 931.0000, 'ºC'),
	(115115, 112, '2015-03-15 00:15:19.000000', 'temperatura', 901.0000, 'ºC'),
	(115116, 112, '2015-03-15 00:15:20.000000', 'temperatura', 512.0000, 'ºC'),
	(115117, 112, '2015-03-15 00:15:21.000000', 'temperatura', 1057.0000, 'ºC'),
	(115118, 112, '2015-03-15 00:15:22.000000', 'temperatura', 149.0000, 'ºC'),
	(115119, 112, '2015-03-15 00:15:23.000000', 'temperatura', 1177.0000, 'ºC'),
	(115120, 112, '2015-03-15 00:15:24.000000', 'temperatura', 636.0000, 'ºC'),
	(115121, 112, '2015-03-15 00:15:25.000000', 'temperatura', 850.0000, 'ºC'),
	(115122, 112, '2015-03-15 00:15:26.000000', 'temperatura', 1143.0000, 'ºC'),
	(115123, 112, '2015-03-15 00:15:27.000000', 'temperatura', 767.0000, 'ºC'),
	(115124, 112, '2015-03-15 00:15:28.000000', 'temperatura', 406.0000, 'ºC'),
	(115125, 112, '2015-03-15 00:15:29.000000', 'temperatura', 927.0000, 'ºC'),
	(115126, 112, '2015-03-15 00:15:30.000000', 'temperatura', 1021.0000, 'ºC'),
	(115127, 112, '2015-03-15 00:15:31.000000', 'temperatura', 1122.0000, 'ºC'),
	(115128, 112, '2015-03-15 00:15:32.000000', 'temperatura', 148.0000, 'ºC'),
	(115129, 112, '2015-03-15 00:15:33.000000', 'temperatura', 973.0000, 'ºC'),
	(115130, 112, '2015-03-15 00:15:34.000000', 'temperatura', 822.0000, 'ºC'),
	(115131, 112, '2015-03-15 00:15:35.000000', 'temperatura', 1193.0000, 'ºC'),
	(115132, 112, '2015-03-15 00:15:36.000000', 'temperatura', 1097.0000, 'ºC'),
	(115133, 112, '2015-03-15 00:15:37.000000', 'temperatura', 708.0000, 'ºC'),
	(115134, 112, '2015-03-15 00:15:38.000000', 'temperatura', 251.0000, 'ºC'),
	(115135, 112, '2015-03-15 00:15:39.000000', 'temperatura', 330.0000, 'ºC'),
	(115136, 112, '2015-03-15 00:15:40.000000', 'temperatura', 898.0000, 'ºC'),
	(115137, 112, '2015-03-15 00:15:41.000000', 'temperatura', 1102.0000, 'ºC'),
	(115138, 112, '2015-03-15 00:15:42.000000', 'temperatura', 416.0000, 'ºC'),
	(115139, 112, '2015-03-15 00:15:43.000000', 'temperatura', 1173.0000, 'ºC'),
	(115140, 112, '2015-03-15 00:15:44.000000', 'temperatura', 1019.0000, 'ºC'),
	(115141, 112, '2015-03-15 00:15:45.000000', 'temperatura', 377.0000, 'ºC'),
	(115142, 112, '2015-03-15 00:15:46.000000', 'temperatura', 30.0000, 'ºC'),
	(115143, 112, '2015-03-15 00:15:47.000000', 'temperatura', 216.0000, 'ºC'),
	(115144, 112, '2015-03-15 00:15:48.000000', 'temperatura', 993.0000, 'ºC'),
	(115145, 112, '2015-03-15 00:15:49.000000', 'temperatura', 715.0000, 'ºC'),
	(115146, 112, '2015-03-15 00:15:50.000000', 'temperatura', 597.0000, 'ºC'),
	(115147, 112, '2015-03-15 00:15:51.000000', 'temperatura', 842.0000, 'ºC'),
	(115148, 112, '2015-03-15 00:15:52.000000', 'temperatura', 21.0000, 'ºC'),
	(115149, 112, '2015-03-15 00:15:53.000000', 'temperatura', 1177.0000, 'ºC'),
	(115150, 112, '2015-03-15 00:15:54.000000', 'temperatura', 1023.0000, 'ºC'),
	(115151, 112, '2015-03-15 00:15:55.000000', 'temperatura', 386.0000, 'ºC'),
	(115152, 112, '2015-03-15 00:15:56.000000', 'temperatura', 62.0000, 'ºC'),
	(115153, 112, '2015-03-15 00:15:57.000000', 'temperatura', 350.0000, 'ºC'),
	(115154, 112, '2015-03-15 00:15:58.000000', 'temperatura', 365.0000, 'ºC'),
	(115155, 112, '2015-03-15 00:15:59.000000', 'temperatura', 777.0000, 'ºC'),
	(115156, 112, '2015-03-15 00:16:00.000000', 'temperatura', 391.0000, 'ºC'),
	(115157, 112, '2015-03-15 00:16:01.000000', 'temperatura', 825.0000, 'ºC'),
	(115158, 112, '2015-03-15 00:16:02.000000', 'temperatura', 552.0000, 'ºC'),
	(115159, 112, '2015-03-15 00:16:03.000000', 'temperatura', 285.0000, 'ºC'),
	(115160, 112, '2015-03-15 00:16:04.000000', 'temperatura', 969.0000, 'ºC'),
	(115161, 112, '2015-03-15 00:16:05.000000', 'temperatura', 393.0000, 'ºC'),
	(115162, 112, '2015-03-15 00:16:06.000000', 'temperatura', 255.0000, 'ºC'),
	(115163, 112, '2015-03-15 00:16:07.000000', 'temperatura', 98.0000, 'ºC'),
	(115164, 112, '2015-03-15 00:16:08.000000', 'temperatura', 924.0000, 'ºC'),
	(115165, 112, '2015-03-15 00:16:09.000000', 'temperatura', 729.0000, 'ºC'),
	(115166, 112, '2015-03-15 00:16:10.000000', 'temperatura', 871.0000, 'ºC'),
	(115167, 112, '2015-03-15 00:16:11.000000', 'temperatura', 969.0000, 'ºC'),
	(115168, 112, '2015-03-15 00:16:12.000000', 'temperatura', 1033.0000, 'ºC'),
	(115169, 112, '2015-03-15 00:16:13.000000', 'temperatura', 1059.0000, 'ºC'),
	(115170, 112, '2015-03-15 00:16:14.000000', 'temperatura', 995.0000, 'ºC'),
	(115171, 112, '2015-03-15 00:16:15.000000', 'temperatura', 598.0000, 'ºC'),
	(115172, 112, '2015-03-15 00:16:16.000000', 'temperatura', 8.0000, 'ºC'),
	(115173, 112, '2015-03-15 00:16:17.000000', 'temperatura', 644.0000, 'ºC'),
	(115174, 112, '2015-03-15 00:16:18.000000', 'temperatura', 799.0000, 'ºC'),
	(115175, 112, '2015-03-15 00:16:19.000000', 'temperatura', 863.0000, 'ºC'),
	(115176, 112, '2015-03-15 00:16:20.000000', 'temperatura', 717.0000, 'ºC'),
	(115177, 112, '2015-03-15 00:16:21.000000', 'temperatura', 996.0000, 'ºC'),
	(115178, 112, '2015-03-15 00:16:22.000000', 'temperatura', 430.0000, 'ºC'),
	(115179, 112, '2015-03-15 00:16:23.000000', 'temperatura', 361.0000, 'ºC'),
	(115180, 112, '2015-03-15 00:16:24.000000', 'temperatura', 515.0000, 'ºC'),
	(115181, 112, '2015-03-15 00:16:25.000000', 'temperatura', 294.0000, 'ºC'),
	(115182, 112, '2015-03-15 00:16:26.000000', 'temperatura', 1127.0000, 'ºC'),
	(115183, 112, '2015-03-15 00:16:27.000000', 'temperatura', 1151.0000, 'ºC'),
	(115184, 112, '2015-03-15 00:16:28.000000', 'temperatura', 1174.0000, 'ºC'),
	(115185, 112, '2015-03-15 00:16:29.000000', 'temperatura', 18.0000, 'ºC'),
	(115186, 112, '2015-03-15 00:16:30.000000', 'temperatura', 171.0000, 'ºC'),
	(115187, 112, '2015-03-15 00:16:31.000000', 'temperatura', 799.0000, 'ºC'),
	(115188, 112, '2015-03-15 00:16:32.000000', 'temperatura', 1082.0000, 'ºC'),
	(115189, 112, '2015-03-15 00:16:33.000000', 'temperatura', 615.0000, 'ºC'),
	(115190, 112, '2015-03-15 00:16:34.000000', 'temperatura', 1030.0000, 'ºC'),
	(115191, 112, '2015-03-15 00:16:35.000000', 'temperatura', 907.0000, 'ºC'),
	(115192, 112, '2015-03-15 00:16:36.000000', 'temperatura', 242.0000, 'ºC'),
	(115193, 112, '2015-03-15 00:16:37.000000', 'temperatura', 893.0000, 'ºC'),
	(115194, 112, '2015-03-15 00:16:38.000000', 'temperatura', 137.0000, 'ºC'),
	(115195, 112, '2015-03-15 00:16:39.000000', 'temperatura', 408.0000, 'ºC'),
	(115196, 112, '2015-03-15 00:16:40.000000', 'temperatura', 429.0000, 'ºC'),
	(115197, 112, '2015-03-15 00:16:41.000000', 'temperatura', 921.0000, 'ºC'),
	(115198, 112, '2015-03-15 00:16:42.000000', 'temperatura', 921.0000, 'ºC'),
	(115199, 112, '2015-03-15 00:16:43.000000', 'temperatura', 641.0000, 'ºC'),
	(115200, 112, '2015-03-15 00:16:44.000000', 'temperatura', 441.0000, 'ºC'),
	(115201, 112, '2015-03-15 00:16:45.000000', 'temperatura', 282.0000, 'ºC'),
	(115202, 112, '2015-03-15 00:16:46.000000', 'temperatura', 91.0000, 'ºC'),
	(115203, 112, '2015-03-15 00:16:47.000000', 'temperatura', 806.0000, 'ºC'),
	(115204, 112, '2015-03-15 00:16:48.000000', 'temperatura', 159.0000, 'ºC'),
	(115205, 112, '2015-03-15 00:16:49.000000', 'temperatura', 778.0000, 'ºC'),
	(115206, 112, '2015-03-15 00:16:50.000000', 'temperatura', 1014.0000, 'ºC'),
	(115207, 112, '2015-03-15 00:16:51.000000', 'temperatura', 334.0000, 'ºC'),
	(115208, 112, '2015-03-15 00:16:52.000000', 'temperatura', 1030.0000, 'ºC'),
	(115209, 112, '2015-03-15 00:16:53.000000', 'temperatura', 550.0000, 'ºC'),
	(115210, 112, '2015-03-15 00:16:54.000000', 'temperatura', 860.0000, 'ºC'),
	(115211, 112, '2015-03-15 00:16:55.000000', 'temperatura', 252.0000, 'ºC'),
	(115212, 112, '2015-03-15 00:16:56.000000', 'temperatura', 1078.0000, 'ºC'),
	(115213, 112, '2015-03-15 00:16:57.000000', 'temperatura', 1037.0000, 'ºC'),
	(115214, 112, '2015-03-15 00:16:58.000000', 'temperatura', 751.0000, 'ºC'),
	(115215, 112, '2015-03-15 00:16:59.000000', 'temperatura', 643.0000, 'ºC'),
	(115216, 112, '2015-03-15 00:17:00.000000', 'temperatura', 961.0000, 'ºC'),
	(115217, 112, '2015-03-15 00:17:01.000000', 'temperatura', 479.0000, 'ºC'),
	(115218, 112, '2015-03-15 00:17:02.000000', 'temperatura', 711.0000, 'ºC'),
	(115219, 112, '2015-03-15 00:17:03.000000', 'temperatura', 918.0000, 'ºC'),
	(115220, 112, '2015-03-15 00:17:04.000000', 'temperatura', 58.0000, 'ºC'),
	(115221, 112, '2015-03-15 00:17:05.000000', 'temperatura', 1135.0000, 'ºC'),
	(115222, 112, '2015-03-15 00:17:06.000000', 'temperatura', 703.0000, 'ºC'),
	(115223, 112, '2015-03-15 00:17:07.000000', 'temperatura', 111.0000, 'ºC'),
	(115224, 112, '2015-03-15 00:17:08.000000', 'temperatura', 844.0000, 'ºC'),
	(115225, 112, '2015-03-15 00:17:09.000000', 'temperatura', 290.0000, 'ºC'),
	(115226, 112, '2015-03-15 00:17:10.000000', 'temperatura', 117.0000, 'ºC'),
	(115227, 112, '2015-03-15 00:17:11.000000', 'temperatura', 917.0000, 'ºC'),
	(115228, 112, '2015-03-15 00:17:12.000000', 'temperatura', 632.0000, 'ºC'),
	(115229, 112, '2015-03-15 00:17:13.000000', 'temperatura', 411.0000, 'ºC'),
	(115230, 112, '2015-03-15 00:17:14.000000', 'temperatura', 158.0000, 'ºC'),
	(115231, 112, '2015-03-15 00:17:15.000000', 'temperatura', 759.0000, 'ºC'),
	(115232, 112, '2015-03-15 00:17:16.000000', 'temperatura', 920.0000, 'ºC'),
	(115233, 112, '2015-03-15 00:17:17.000000', 'temperatura', 1123.0000, 'ºC'),
	(115234, 112, '2015-03-15 00:17:18.000000', 'temperatura', 454.0000, 'ºC'),
	(115235, 112, '2015-03-15 00:17:19.000000', 'temperatura', 105.0000, 'ºC'),
	(115236, 112, '2015-03-15 00:17:20.000000', 'temperatura', 361.0000, 'ºC'),
	(115237, 112, '2015-03-15 00:17:21.000000', 'temperatura', 293.0000, 'ºC'),
	(115238, 112, '2015-03-15 00:17:22.000000', 'temperatura', 382.0000, 'ºC'),
	(115239, 112, '2015-03-15 00:17:23.000000', 'temperatura', 1030.0000, 'ºC'),
	(115240, 112, '2015-03-15 00:17:24.000000', 'temperatura', 406.0000, 'ºC'),
	(115241, 112, '2015-03-15 00:17:25.000000', 'temperatura', 139.0000, 'ºC'),
	(115242, 112, '2015-03-15 00:17:26.000000', 'temperatura', 680.0000, 'ºC'),
	(115243, 112, '2015-03-15 00:17:27.000000', 'temperatura', 583.0000, 'ºC'),
	(115244, 112, '2015-03-15 00:17:28.000000', 'temperatura', 876.0000, 'ºC'),
	(115245, 112, '2015-03-15 00:17:29.000000', 'temperatura', 229.0000, 'ºC'),
	(115246, 112, '2015-03-15 00:17:30.000000', 'temperatura', 920.0000, 'ºC'),
	(115247, 112, '2015-03-15 00:17:31.000000', 'temperatura', 313.0000, 'ºC'),
	(115248, 112, '2015-03-15 00:17:32.000000', 'temperatura', 5.0000, 'ºC'),
	(115249, 112, '2015-03-15 00:17:33.000000', 'temperatura', 288.0000, 'ºC'),
	(115250, 112, '2015-03-15 00:17:34.000000', 'temperatura', 226.0000, 'ºC'),
	(115251, 112, '2015-03-15 00:17:35.000000', 'temperatura', 266.0000, 'ºC'),
	(115252, 112, '2015-03-15 00:17:36.000000', 'temperatura', 653.0000, 'ºC'),
	(115253, 112, '2015-03-15 00:17:37.000000', 'temperatura', 66.0000, 'ºC'),
	(115254, 112, '2015-03-15 00:17:38.000000', 'temperatura', 773.0000, 'ºC'),
	(115255, 112, '2015-03-15 00:17:39.000000', 'temperatura', 67.0000, 'ºC'),
	(115256, 112, '2015-03-15 00:17:40.000000', 'temperatura', 417.0000, 'ºC'),
	(115257, 112, '2015-03-15 00:17:41.000000', 'temperatura', 685.0000, 'ºC'),
	(115258, 112, '2015-03-15 00:17:42.000000', 'temperatura', 972.0000, 'ºC'),
	(115259, 112, '2015-03-15 00:17:43.000000', 'temperatura', 408.0000, 'ºC'),
	(115260, 112, '2015-03-15 00:17:44.000000', 'temperatura', 323.0000, 'ºC'),
	(115261, 112, '2015-03-15 00:17:45.000000', 'temperatura', 390.0000, 'ºC'),
	(115262, 112, '2015-03-15 00:17:46.000000', 'temperatura', 984.0000, 'ºC'),
	(115263, 112, '2015-03-15 00:17:47.000000', 'temperatura', 152.0000, 'ºC'),
	(115264, 112, '2015-03-15 00:17:48.000000', 'temperatura', 205.0000, 'ºC'),
	(115265, 112, '2015-03-15 00:17:49.000000', 'temperatura', 572.0000, 'ºC'),
	(115266, 112, '2015-03-15 00:17:50.000000', 'temperatura', 1043.0000, 'ºC'),
	(115267, 112, '2015-03-15 00:17:51.000000', 'temperatura', 1100.0000, 'ºC'),
	(115268, 112, '2015-03-15 00:17:52.000000', 'temperatura', 1173.0000, 'ºC'),
	(115269, 112, '2015-03-15 00:17:53.000000', 'temperatura', 165.0000, 'ºC'),
	(115270, 112, '2015-03-15 00:17:54.000000', 'temperatura', 908.0000, 'ºC'),
	(115271, 112, '2015-03-15 00:17:55.000000', 'temperatura', 445.0000, 'ºC'),
	(115272, 112, '2015-03-15 00:17:56.000000', 'temperatura', 702.0000, 'ºC'),
	(115273, 112, '2015-03-15 00:17:57.000000', 'temperatura', 975.0000, 'ºC'),
	(115274, 112, '2015-03-15 00:17:58.000000', 'temperatura', 370.0000, 'ºC'),
	(115275, 112, '2015-03-15 00:17:59.000000', 'temperatura', 124.0000, 'ºC'),
	(115276, 112, '2015-03-15 00:18:00.000000', 'temperatura', 712.0000, 'ºC'),
	(115277, 112, '2015-03-15 00:18:01.000000', 'temperatura', 787.0000, 'ºC'),
	(115278, 112, '2015-03-15 00:18:02.000000', 'temperatura', 599.0000, 'ºC'),
	(115279, 112, '2015-03-15 00:18:03.000000', 'temperatura', 636.0000, 'ºC'),
	(115280, 112, '2015-03-15 00:18:04.000000', 'temperatura', 184.0000, 'ºC'),
	(115281, 112, '2015-03-15 00:18:05.000000', 'temperatura', 211.0000, 'ºC'),
	(115282, 112, '2015-03-15 00:18:06.000000', 'temperatura', 505.0000, 'ºC'),
	(115283, 112, '2015-03-15 00:18:07.000000', 'temperatura', 690.0000, 'ºC'),
	(115284, 112, '2015-03-15 00:18:08.000000', 'temperatura', 737.0000, 'ºC'),
	(115285, 112, '2015-03-15 00:18:09.000000', 'temperatura', 413.0000, 'ºC'),
	(115286, 112, '2015-03-15 00:18:10.000000', 'temperatura', 1058.0000, 'ºC'),
	(115287, 112, '2015-03-15 00:18:11.000000', 'temperatura', 450.0000, 'ºC'),
	(115288, 112, '2015-03-15 00:18:12.000000', 'temperatura', 278.0000, 'ºC'),
	(115289, 112, '2015-03-15 00:18:13.000000', 'temperatura', 41.0000, 'ºC'),
	(115290, 112, '2015-03-15 00:18:14.000000', 'temperatura', 569.0000, 'ºC'),
	(115291, 112, '2015-03-15 00:18:15.000000', 'temperatura', 325.0000, 'ºC'),
	(115292, 112, '2015-03-15 00:18:16.000000', 'temperatura', 1119.0000, 'ºC'),
	(115293, 112, '2015-03-15 00:18:17.000000', 'temperatura', 1019.0000, 'ºC'),
	(115294, 112, '2015-03-15 00:18:18.000000', 'temperatura', 537.0000, 'ºC'),
	(115295, 112, '2015-03-15 00:18:19.000000', 'temperatura', 831.0000, 'ºC'),
	(115296, 112, '2015-03-15 00:18:20.000000', 'temperatura', 144.0000, 'ºC'),
	(115297, 112, '2015-03-15 00:18:21.000000', 'temperatura', 627.0000, 'ºC'),
	(115298, 112, '2015-03-15 00:18:22.000000', 'temperatura', 304.0000, 'ºC'),
	(115299, 112, '2015-03-15 00:18:23.000000', 'temperatura', 840.0000, 'ºC'),
	(115300, 112, '2015-03-15 00:18:24.000000', 'temperatura', 890.0000, 'ºC'),
	(115301, 112, '2015-03-15 00:18:25.000000', 'temperatura', 727.0000, 'ºC'),
	(115302, 112, '2015-03-15 00:18:26.000000', 'temperatura', 969.0000, 'ºC'),
	(115303, 112, '2015-03-15 00:18:27.000000', 'temperatura', 262.0000, 'ºC'),
	(115304, 112, '2015-03-15 00:18:28.000000', 'temperatura', 804.0000, 'ºC'),
	(115305, 112, '2015-03-15 00:18:29.000000', 'temperatura', 837.0000, 'ºC'),
	(115306, 112, '2015-03-15 00:18:30.000000', 'temperatura', 571.0000, 'ºC'),
	(115307, 112, '2015-03-15 00:18:31.000000', 'temperatura', 345.0000, 'ºC'),
	(115308, 112, '2015-03-15 00:18:32.000000', 'temperatura', 13.0000, 'ºC'),
	(115309, 112, '2015-03-15 00:18:33.000000', 'temperatura', 232.0000, 'ºC'),
	(115310, 112, '2015-03-15 00:18:34.000000', 'temperatura', 1120.0000, 'ºC'),
	(115311, 112, '2015-03-15 00:18:35.000000', 'temperatura', 105.0000, 'ºC'),
	(115312, 112, '2015-03-15 00:18:36.000000', 'temperatura', 766.0000, 'ºC'),
	(115313, 112, '2015-03-15 00:18:37.000000', 'temperatura', 1114.0000, 'ºC'),
	(115314, 112, '2015-03-15 00:18:38.000000', 'temperatura', 873.0000, 'ºC'),
	(115315, 112, '2015-03-15 00:18:39.000000', 'temperatura', 1023.0000, 'ºC'),
	(115316, 112, '2015-03-15 00:18:40.000000', 'temperatura', 95.0000, 'ºC'),
	(115317, 112, '2015-03-15 00:18:41.000000', 'temperatura', 1007.0000, 'ºC'),
	(115318, 112, '2015-03-15 00:18:42.000000', 'temperatura', 1152.0000, 'ºC'),
	(115319, 112, '2015-03-15 00:18:43.000000', 'temperatura', 338.0000, 'ºC'),
	(115320, 112, '2015-03-15 00:18:44.000000', 'temperatura', 634.0000, 'ºC'),
	(115321, 112, '2015-03-15 00:18:45.000000', 'temperatura', 957.0000, 'ºC'),
	(115322, 112, '2015-03-15 00:18:46.000000', 'temperatura', 484.0000, 'ºC'),
	(115323, 112, '2015-03-15 00:18:47.000000', 'temperatura', 749.0000, 'ºC'),
	(115324, 112, '2015-03-15 00:18:48.000000', 'temperatura', 1095.0000, 'ºC'),
	(115325, 112, '2015-03-15 00:18:49.000000', 'temperatura', 829.0000, 'ºC'),
	(115326, 112, '2015-03-15 00:18:50.000000', 'temperatura', 861.0000, 'ºC'),
	(115327, 112, '2015-03-15 00:18:51.000000', 'temperatura', 618.0000, 'ºC'),
	(115328, 112, '2015-03-15 00:18:52.000000', 'temperatura', 508.0000, 'ºC'),
	(115329, 112, '2015-03-15 00:18:53.000000', 'temperatura', 685.0000, 'ºC'),
	(115330, 112, '2015-03-15 00:18:54.000000', 'temperatura', 701.0000, 'ºC'),
	(115331, 112, '2015-03-15 00:18:55.000000', 'temperatura', 249.0000, 'ºC'),
	(115332, 112, '2015-03-15 00:18:56.000000', 'temperatura', 346.0000, 'ºC'),
	(115333, 112, '2015-03-15 00:18:57.000000', 'temperatura', 982.0000, 'ºC'),
	(115334, 112, '2015-03-15 00:18:58.000000', 'temperatura', 272.0000, 'ºC'),
	(115335, 112, '2015-03-15 00:18:59.000000', 'temperatura', 816.0000, 'ºC'),
	(115336, 112, '2015-03-15 00:19:00.000000', 'temperatura', 862.0000, 'ºC'),
	(115337, 112, '2015-03-15 00:19:01.000000', 'temperatura', 665.0000, 'ºC'),
	(115338, 112, '2015-03-15 00:19:02.000000', 'temperatura', 738.0000, 'ºC'),
	(115339, 112, '2015-03-15 00:19:03.000000', 'temperatura', 498.0000, 'ºC'),
	(115340, 112, '2015-03-15 00:19:04.000000', 'temperatura', 274.0000, 'ºC'),
	(115341, 112, '2015-03-15 00:19:05.000000', 'temperatura', 1075.0000, 'ºC'),
	(115342, 112, '2015-03-15 00:19:06.000000', 'temperatura', 956.0000, 'ºC'),
	(115343, 112, '2015-03-15 00:19:07.000000', 'temperatura', 355.0000, 'ºC'),
	(115344, 112, '2015-03-15 00:19:08.000000', 'temperatura', 105.0000, 'ºC'),
	(115345, 112, '2015-03-15 00:19:09.000000', 'temperatura', 664.0000, 'ºC'),
	(115346, 112, '2015-03-15 00:19:10.000000', 'temperatura', 603.0000, 'ºC'),
	(115347, 112, '2015-03-15 00:19:11.000000', 'temperatura', 1024.0000, 'ºC'),
	(115348, 112, '2015-03-15 00:19:12.000000', 'temperatura', 912.0000, 'ºC'),
	(115349, 112, '2015-03-15 00:19:13.000000', 'temperatura', 288.0000, 'ºC'),
	(115350, 112, '2015-03-15 00:19:14.000000', 'temperatura', 1103.0000, 'ºC'),
	(115351, 112, '2015-03-15 00:19:15.000000', 'temperatura', 1052.0000, 'ºC'),
	(115352, 112, '2015-03-15 00:19:16.000000', 'temperatura', 751.0000, 'ºC'),
	(115353, 112, '2015-03-15 00:19:17.000000', 'temperatura', 600.0000, 'ºC'),
	(115354, 112, '2015-03-15 00:19:18.000000', 'temperatura', 748.0000, 'ºC'),
	(115355, 112, '2015-03-15 00:19:19.000000', 'temperatura', 741.0000, 'ºC'),
	(115356, 112, '2015-03-15 00:19:20.000000', 'temperatura', 261.0000, 'ºC'),
	(115357, 112, '2015-03-15 00:19:21.000000', 'temperatura', 283.0000, 'ºC'),
	(115358, 112, '2015-03-15 00:19:22.000000', 'temperatura', 633.0000, 'ºC'),
	(115359, 112, '2015-03-15 00:19:23.000000', 'temperatura', 1117.0000, 'ºC'),
	(115360, 112, '2015-03-15 00:19:24.000000', 'temperatura', 86.0000, 'ºC'),
	(115361, 112, '2015-03-15 00:19:25.000000', 'temperatura', 679.0000, 'ºC'),
	(115362, 112, '2015-03-15 00:19:26.000000', 'temperatura', 736.0000, 'ºC'),
	(115363, 112, '2015-03-15 00:19:27.000000', 'temperatura', 446.0000, 'ºC'),
	(115364, 112, '2015-03-15 00:19:28.000000', 'temperatura', 20.0000, 'ºC'),
	(115365, 112, '2015-03-15 00:19:29.000000', 'temperatura', 1163.0000, 'ºC'),
	(115366, 112, '2015-03-15 00:19:30.000000', 'temperatura', 958.0000, 'ºC'),
	(115367, 112, '2015-03-15 00:19:31.000000', 'temperatura', 100.0000, 'ºC'),
	(115368, 112, '2015-03-15 00:19:32.000000', 'temperatura', 27.0000, 'ºC'),
	(115369, 112, '2015-03-15 00:19:33.000000', 'temperatura', 1034.0000, 'ºC'),
	(115370, 112, '2015-03-15 00:19:34.000000', 'temperatura', 289.0000, 'ºC'),
	(115371, 112, '2015-03-15 00:19:35.000000', 'temperatura', 744.0000, 'ºC'),
	(115372, 112, '2015-03-15 00:19:36.000000', 'temperatura', 452.0000, 'ºC'),
	(115373, 112, '2015-03-15 00:19:37.000000', 'temperatura', 31.0000, 'ºC'),
	(115374, 112, '2015-03-15 00:19:38.000000', 'temperatura', 1197.0000, 'ºC'),
	(115375, 112, '2015-03-15 00:19:39.000000', 'temperatura', 1092.0000, 'ºC'),
	(115376, 112, '2015-03-15 00:19:40.000000', 'temperatura', 669.0000, 'ºC'),
	(115377, 112, '2015-03-15 00:19:41.000000', 'temperatura', 69.0000, 'ºC'),
	(115378, 112, '2015-03-15 00:19:42.000000', 'temperatura', 739.0000, 'ºC'),
	(115379, 112, '2015-03-15 00:19:43.000000', 'temperatura', 1088.0000, 'ºC'),
	(115380, 112, '2015-03-15 00:19:44.000000', 'temperatura', 825.0000, 'ºC'),
	(115381, 112, '2015-03-15 00:19:45.000000', 'temperatura', 861.0000, 'ºC'),
	(115382, 112, '2015-03-15 00:19:46.000000', 'temperatura', 629.0000, 'ºC'),
	(115383, 112, '2015-03-15 00:19:47.000000', 'temperatura', 565.0000, 'ºC'),
	(115384, 112, '2015-03-15 00:19:48.000000', 'temperatura', 938.0000, 'ºC'),
	(115385, 112, '2015-03-15 00:19:49.000000', 'temperatura', 594.0000, 'ºC'),
	(115386, 112, '2015-03-15 00:19:50.000000', 'temperatura', 157.0000, 'ºC'),
	(115387, 112, '2015-03-15 00:19:51.000000', 'temperatura', 204.0000, 'ºC'),
	(115388, 112, '2015-03-15 00:19:52.000000', 'temperatura', 551.0000, 'ºC'),
	(115389, 112, '2015-03-15 00:19:53.000000', 'temperatura', 942.0000, 'ºC'),
	(115390, 112, '2015-03-15 00:19:54.000000', 'temperatura', 658.0000, 'ºC'),
	(115391, 112, '2015-03-15 00:19:55.000000', 'temperatura', 466.0000, 'ºC'),
	(115392, 112, '2015-03-15 00:19:56.000000', 'temperatura', 357.0000, 'ºC'),
	(115393, 112, '2015-03-15 00:19:57.000000', 'temperatura', 386.0000, 'ºC'),
	(115394, 112, '2015-03-15 00:19:58.000000', 'temperatura', 859.0000, 'ºC'),
	(115395, 112, '2015-03-15 00:19:59.000000', 'temperatura', 736.0000, 'ºC'),
	(115396, 112, '2015-03-15 00:20:00.000000', 'temperatura', 1105.0000, 'ºC'),
	(115397, 112, '2015-03-15 00:20:01.000000', 'temperatura', 915.0000, 'ºC'),
	(115398, 112, '2015-03-15 00:20:02.000000', 'temperatura', 63.0000, 'ºC'),
	(115399, 112, '2015-03-15 00:20:03.000000', 'temperatura', 1172.0000, 'ºC'),
	(115400, 112, '2015-03-15 00:20:04.000000', 'temperatura', 869.0000, 'ºC'),
	(115401, 112, '2015-03-15 00:20:05.000000', 'temperatura', 831.0000, 'ºC'),
	(115402, 112, '2015-03-15 00:20:06.000000', 'temperatura', 348.0000, 'ºC'),
	(115403, 112, '2015-03-15 00:20:07.000000', 'temperatura', 449.0000, 'ºC'),
	(115404, 112, '2015-03-15 00:20:08.000000', 'temperatura', 2.0000, 'ºC'),
	(115405, 112, '2015-03-15 00:20:09.000000', 'temperatura', 1063.0000, 'ºC'),
	(115406, 112, '2015-03-15 00:20:10.000000', 'temperatura', 507.0000, 'ºC'),
	(115407, 112, '2015-03-15 00:20:11.000000', 'temperatura', 549.0000, 'ºC'),
	(115408, 112, '2015-03-15 00:20:12.000000', 'temperatura', 26.0000, 'ºC'),
	(115409, 112, '2015-03-15 00:20:13.000000', 'temperatura', 881.0000, 'ºC'),
	(115410, 112, '2015-03-15 00:20:14.000000', 'temperatura', 729.0000, 'ºC'),
	(115411, 112, '2015-03-15 00:20:15.000000', 'temperatura', 1003.0000, 'ºC'),
	(115412, 112, '2015-03-15 00:20:16.000000', 'temperatura', 428.0000, 'ºC'),
	(115413, 112, '2015-03-15 00:20:17.000000', 'temperatura', 333.0000, 'ºC'),
	(115414, 112, '2015-03-15 00:20:18.000000', 'temperatura', 379.0000, 'ºC'),
	(115415, 112, '2015-03-15 00:20:19.000000', 'temperatura', 896.0000, 'ºC'),
	(115416, 112, '2015-03-15 00:20:20.000000', 'temperatura', 946.0000, 'ºC'),
	(115417, 112, '2015-03-15 00:20:21.000000', 'temperatura', 842.0000, 'ºC'),
	(115418, 112, '2015-03-15 00:20:22.000000', 'temperatura', 174.0000, 'ºC'),
	(115419, 112, '2015-03-15 00:20:23.000000', 'temperatura', 743.0000, 'ºC'),
	(115420, 112, '2015-03-15 00:20:24.000000', 'temperatura', 796.0000, 'ºC'),
	(115421, 112, '2015-03-15 00:20:25.000000', 'temperatura', 549.0000, 'ºC'),
	(115422, 112, '2015-03-15 00:20:26.000000', 'temperatura', 356.0000, 'ºC'),
	(115423, 112, '2015-03-15 00:20:27.000000', 'temperatura', 136.0000, 'ºC'),
	(115424, 112, '2015-03-15 00:20:28.000000', 'temperatura', 810.0000, 'ºC'),
	(115425, 112, '2015-03-15 00:20:29.000000', 'temperatura', 42.0000, 'ºC'),
	(115426, 112, '2015-03-15 00:20:30.000000', 'temperatura', 183.0000, 'ºC'),
	(115427, 112, '2015-03-15 00:20:31.000000', 'temperatura', 788.0000, 'ºC'),
	(115428, 112, '2015-03-15 00:20:32.000000', 'temperatura', 993.0000, 'ºC'),
	(115429, 112, '2015-03-15 00:20:33.000000', 'temperatura', 202.0000, 'ºC'),
	(115430, 112, '2015-03-15 00:20:34.000000', 'temperatura', 430.0000, 'ºC'),
	(115431, 112, '2015-03-15 00:20:35.000000', 'temperatura', 343.0000, 'ºC'),
	(115432, 112, '2015-03-15 00:20:36.000000', 'temperatura', 429.0000, 'ºC'),
	(115433, 112, '2015-03-15 00:20:37.000000', 'temperatura', 1115.0000, 'ºC'),
	(115434, 112, '2015-03-15 00:20:38.000000', 'temperatura', 688.0000, 'ºC'),
	(115435, 112, '2015-03-15 00:20:39.000000', 'temperatura', 94.0000, 'ºC'),
	(115436, 112, '2015-03-15 00:20:40.000000', 'temperatura', 809.0000, 'ºC'),
	(115437, 112, '2015-03-15 00:20:41.000000', 'temperatura', 161.0000, 'ºC'),
	(115438, 112, '2015-03-15 00:20:42.000000', 'temperatura', 779.0000, 'ºC'),
	(115439, 112, '2015-03-15 00:20:43.000000', 'temperatura', 1011.0000, 'ºC'),
	(115440, 112, '2015-03-15 00:20:44.000000', 'temperatura', 320.0000, 'ºC'),
	(115441, 112, '2015-03-15 00:20:45.000000', 'temperatura', 967.0000, 'ºC'),
	(115442, 112, '2015-03-15 00:20:46.000000', 'temperatura', 274.0000, 'ºC'),
	(115443, 112, '2015-03-15 00:20:47.000000', 'temperatura', 870.0000, 'ºC'),
	(115444, 112, '2015-03-15 00:20:48.000000', 'temperatura', 1130.0000, 'ºC'),
	(115445, 112, '2015-03-15 00:20:49.000000', 'temperatura', 641.0000, 'ºC'),
	(115446, 112, '2015-03-15 00:20:50.000000', 'temperatura', 1013.0000, 'ºC'),
	(115447, 112, '2015-03-15 00:20:51.000000', 'temperatura', 742.0000, 'ºC'),
	(115448, 112, '2015-03-15 00:20:52.000000', 'temperatura', 673.0000, 'ºC'),
	(115449, 112, '2015-03-15 00:20:53.000000', 'temperatura', 1141.0000, 'ºC'),
	(115450, 112, '2015-03-15 00:20:54.000000', 'temperatura', 86.0000, 'ºC'),
	(115451, 112, '2015-03-15 00:20:55.000000', 'temperatura', 608.0000, 'ºC'),
	(115452, 112, '2015-03-15 00:20:56.000000', 'temperatura', 380.0000, 'ºC'),
	(115453, 112, '2015-03-15 00:20:57.000000', 'temperatura', 78.0000, 'ºC'),
	(115454, 112, '2015-03-15 00:20:58.000000', 'temperatura', 451.0000, 'ºC'),
	(115455, 112, '2015-03-15 00:20:59.000000', 'temperatura', 821.0000, 'ºC'),
	(115456, 112, '2015-03-15 00:21:00.000000', 'temperatura', 354.0000, 'ºC'),
	(115457, 112, '2015-03-15 00:21:01.000000', 'temperatura', 505.0000, 'ºC'),
	(115458, 112, '2015-03-15 00:21:02.000000', 'temperatura', 264.0000, 'ºC'),
	(115459, 112, '2015-03-15 00:21:03.000000', 'temperatura', 1005.0000, 'ºC'),
	(115460, 112, '2015-03-15 00:21:04.000000', 'temperatura', 636.0000, 'ºC'),
	(115461, 112, '2015-03-15 00:21:05.000000', 'temperatura', 165.0000, 'ºC'),
	(115462, 112, '2015-03-15 00:21:06.000000', 'temperatura', 117.0000, 'ºC'),
	(115463, 112, '2015-03-15 00:21:07.000000', 'temperatura', 90.0000, 'ºC'),
	(115464, 112, '2015-03-15 00:21:08.000000', 'temperatura', 100.0000, 'ºC'),
	(115465, 112, '2015-03-15 00:21:09.000000', 'temperatura', 229.0000, 'ºC'),
	(115466, 112, '2015-03-15 00:21:10.000000', 'temperatura', 845.0000, 'ºC'),
	(115467, 112, '2015-03-15 00:21:11.000000', 'temperatura', 1140.0000, 'ºC'),
	(115468, 112, '2015-03-15 00:21:12.000000', 'temperatura', 767.0000, 'ºC'),
	(115469, 112, '2015-03-15 00:21:13.000000', 'temperatura', 414.0000, 'ºC'),
	(115470, 112, '2015-03-15 00:21:14.000000', 'temperatura', 971.0000, 'ºC'),
	(115471, 112, '2015-03-15 00:21:15.000000', 'temperatura', 12.0000, 'ºC'),
	(115472, 112, '2015-03-15 00:21:16.000000', 'temperatura', 746.0000, 'ºC'),
	(115473, 112, '2015-03-15 00:21:17.000000', 'temperatura', 97.0000, 'ºC'),
	(115474, 112, '2015-03-15 00:21:18.000000', 'temperatura', 645.0000, 'ºC'),
	(115475, 112, '2015-03-15 00:21:19.000000', 'temperatura', 538.0000, 'ºC'),
	(115476, 112, '2015-03-15 00:21:20.000000', 'temperatura', 752.0000, 'ºC'),
	(115477, 112, '2015-03-15 00:21:21.000000', 'temperatura', 947.0000, 'ºC'),
	(115478, 112, '2015-03-15 00:21:22.000000', 'temperatura', 79.0000, 'ºC'),
	(115479, 112, '2015-03-15 00:21:23.000000', 'temperatura', 1153.0000, 'ºC'),
	(115480, 112, '2015-03-15 00:21:24.000000', 'temperatura', 732.0000, 'ºC'),
	(115481, 112, '2015-03-15 00:21:25.000000', 'temperatura', 201.0000, 'ºC'),
	(115482, 112, '2015-03-15 00:21:26.000000', 'temperatura', 8.0000, 'ºC'),
	(115483, 112, '2015-03-15 00:21:27.000000', 'temperatura', 639.0000, 'ºC'),
	(115484, 112, '2015-03-15 00:21:28.000000', 'temperatura', 772.0000, 'ºC'),
	(115485, 112, '2015-03-15 00:21:29.000000', 'temperatura', 744.0000, 'ºC'),
	(115486, 112, '2015-03-15 00:21:30.000000', 'temperatura', 204.0000, 'ºC'),
	(115487, 112, '2015-03-15 00:21:31.000000', 'temperatura', 1187.0000, 'ºC'),
	(115488, 112, '2015-03-15 00:21:32.000000', 'temperatura', 525.0000, 'ºC'),
	(115489, 112, '2015-03-15 00:21:33.000000', 'temperatura', 265.0000, 'ºC'),
	(115490, 112, '2015-03-15 00:21:34.000000', 'temperatura', 951.0000, 'ºC'),
	(115491, 112, '2015-03-15 00:21:35.000000', 'temperatura', 358.0000, 'ºC'),
	(115492, 112, '2015-03-15 00:21:36.000000', 'temperatura', 137.0000, 'ºC'),
	(115493, 112, '2015-03-15 00:21:37.000000', 'temperatura', 813.0000, 'ºC'),
	(115494, 112, '2015-03-15 00:21:38.000000', 'temperatura', 56.0000, 'ºC'),
	(115495, 112, '2015-03-15 00:21:39.000000', 'temperatura', 239.0000, 'ºC'),
	(115496, 112, '2015-03-15 00:21:40.000000', 'temperatura', 1027.0000, 'ºC'),
	(115497, 112, '2015-03-15 00:21:41.000000', 'temperatura', 818.0000, 'ºC'),
	(115498, 112, '2015-03-15 00:21:42.000000', 'temperatura', 1009.0000, 'ºC'),
	(115499, 112, '2015-03-15 00:21:43.000000', 'temperatura', 192.0000, 'ºC'),
	(115500, 112, '2015-03-15 00:21:44.000000', 'temperatura', 333.0000, 'ºC'),
	(115501, 112, '2015-03-15 00:21:45.000000', 'temperatura', 1090.0000, 'ºC'),
	(115502, 112, '2015-03-15 00:21:46.000000', 'temperatura', 852.0000, 'ºC'),
	(115503, 112, '2015-03-15 00:21:47.000000', 'temperatura', 992.0000, 'ºC'),
	(115504, 112, '2015-03-15 00:21:48.000000', 'temperatura', 2.0000, 'ºC'),
	(115505, 112, '2015-03-15 00:21:49.000000', 'temperatura', 635.0000, 'ºC'),
	(115506, 112, '2015-03-15 00:21:50.000000', 'temperatura', 771.0000, 'ºC'),
	(115507, 112, '2015-03-15 00:21:51.000000', 'temperatura', 751.0000, 'ºC'),
	(115508, 112, '2015-03-15 00:21:52.000000', 'temperatura', 242.0000, 'ºC'),
	(115509, 112, '2015-03-15 00:21:53.000000', 'temperatura', 158.0000, 'ºC'),
	(115510, 112, '2015-03-15 00:21:54.000000', 'temperatura', 62.0000, 'ºC'),
	(115511, 112, '2015-03-15 00:21:55.000000', 'temperatura', 1039.0000, 'ºC'),
	(115512, 112, '2015-03-15 00:21:56.000000', 'temperatura', 211.0000, 'ºC'),
	(115513, 112, '2015-03-15 00:21:57.000000', 'temperatura', 336.0000, 'ºC'),
	(115514, 112, '2015-03-15 00:21:58.000000', 'temperatura', 1046.0000, 'ºC'),
	(115515, 112, '2015-03-15 00:21:59.000000', 'temperatura', 625.0000, 'ºC'),
	(115516, 112, '2015-03-15 00:22:00.000000', 'temperatura', 1187.0000, 'ºC'),
	(115517, 112, '2015-03-15 00:22:01.000000', 'temperatura', 462.0000, 'ºC'),
	(115518, 112, '2015-03-15 00:22:02.000000', 'temperatura', 1148.0000, 'ºC'),
	(115519, 112, '2015-03-15 00:22:03.000000', 'temperatura', 753.0000, 'ºC'),
	(115520, 112, '2015-03-15 00:22:04.000000', 'temperatura', 324.0000, 'ºC'),
	(115521, 112, '2015-03-15 00:22:05.000000', 'temperatura', 561.0000, 'ºC'),
	(115522, 112, '2015-03-15 00:22:06.000000', 'temperatura', 634.0000, 'ºC'),
	(115523, 112, '2015-03-15 00:22:07.000000', 'temperatura', 286.0000, 'ºC'),
	(115524, 112, '2015-03-15 00:22:08.000000', 'temperatura', 728.0000, 'ºC'),
	(115525, 112, '2015-03-15 00:22:09.000000', 'temperatura', 384.0000, 'ºC'),
	(115526, 112, '2015-03-15 00:22:10.000000', 'temperatura', 937.0000, 'ºC'),
	(115527, 112, '2015-03-15 00:22:11.000000', 'temperatura', 1134.0000, 'ºC'),
	(115528, 112, '2015-03-15 00:22:12.000000', 'temperatura', 459.0000, 'ºC'),
	(115529, 112, '2015-03-15 00:22:13.000000', 'temperatura', 95.0000, 'ºC'),
	(115530, 112, '2015-03-15 00:22:14.000000', 'temperatura', 295.0000, 'ºC'),
	(115531, 112, '2015-03-15 00:22:15.000000', 'temperatura', 1194.0000, 'ºC'),
	(115532, 112, '2015-03-15 00:22:16.000000', 'temperatura', 283.0000, 'ºC'),
	(115533, 112, '2015-03-15 00:22:17.000000', 'temperatura', 234.0000, 'ºC'),
	(115534, 112, '2015-03-15 00:22:18.000000', 'temperatura', 322.0000, 'ºC'),
	(115535, 112, '2015-03-15 00:22:19.000000', 'temperatura', 909.0000, 'ºC'),
	(115536, 112, '2015-03-15 00:22:20.000000', 'temperatura', 1180.0000, 'ºC'),
	(115537, 112, '2015-03-15 00:22:21.000000', 'temperatura', 772.0000, 'ºC'),
	(115538, 112, '2015-03-15 00:22:22.000000', 'temperatura', 322.0000, 'ºC'),
	(115539, 112, '2015-03-15 00:22:23.000000', 'temperatura', 496.0000, 'ºC'),
	(115540, 112, '2015-03-15 00:22:24.000000', 'temperatura', 311.0000, 'ºC'),
	(115541, 112, '2015-03-15 00:22:25.000000', 'temperatura', 70.0000, 'ºC'),
	(115542, 112, '2015-03-15 00:22:26.000000', 'temperatura', 616.0000, 'ºC'),
	(115543, 112, '2015-03-15 00:22:27.000000', 'temperatura', 473.0000, 'ºC'),
	(115544, 112, '2015-03-15 00:22:28.000000', 'temperatura', 516.0000, 'ºC'),
	(115545, 112, '2015-03-15 00:22:29.000000', 'temperatura', 1160.0000, 'ºC'),
	(115546, 112, '2015-03-15 00:22:30.000000', 'temperatura', 653.0000, 'ºC'),
	(115547, 112, '2015-03-15 00:22:31.000000', 'temperatura', 988.0000, 'ºC'),
	(115548, 112, '2015-03-15 00:22:32.000000', 'temperatura', 579.0000, 'ºC'),
	(115549, 112, '2015-03-15 00:22:33.000000', 'temperatura', 1134.0000, 'ºC'),
	(115550, 112, '2015-03-15 00:22:34.000000', 'temperatura', 331.0000, 'ºC'),
	(115551, 112, '2015-03-15 00:22:35.000000', 'temperatura', 654.0000, 'ºC'),
	(115552, 112, '2015-03-15 00:22:36.000000', 'temperatura', 1079.0000, 'ºC'),
	(115553, 112, '2015-03-15 00:22:37.000000', 'temperatura', 1033.0000, 'ºC'),
	(115554, 112, '2015-03-15 00:22:38.000000', 'temperatura', 729.0000, 'ºC'),
	(115555, 112, '2015-03-15 00:22:39.000000', 'temperatura', 545.0000, 'ºC'),
	(115556, 112, '2015-03-15 00:22:40.000000', 'temperatura', 538.0000, 'ºC'),
	(115557, 112, '2015-03-15 00:22:41.000000', 'temperatura', 1055.0000, 'ºC'),
	(115558, 112, '2015-03-15 00:22:42.000000', 'temperatura', 60.0000, 'ºC'),
	(115559, 112, '2015-03-15 00:22:43.000000', 'temperatura', 739.0000, 'ºC'),
	(115560, 112, '2015-03-15 00:22:44.000000', 'temperatura', 1112.0000, 'ºC'),
	(115561, 112, '2015-03-15 00:22:45.000000', 'temperatura', 946.0000, 'ºC'),
	(115562, 112, '2015-03-15 00:22:46.000000', 'temperatura', 193.0000, 'ºC'),
	(115563, 112, '2015-03-15 00:22:47.000000', 'temperatura', 527.0000, 'ºC'),
	(115564, 112, '2015-03-15 00:22:48.000000', 'temperatura', 859.0000, 'ºC'),
	(115565, 112, '2015-03-15 00:22:49.000000', 'temperatura', 314.0000, 'ºC'),
	(115566, 112, '2015-03-15 00:22:50.000000', 'temperatura', 195.0000, 'ºC'),
	(115567, 112, '2015-03-15 00:22:51.000000', 'temperatura', 32.0000, 'ºC'),
	(115568, 112, '2015-03-15 00:22:52.000000', 'temperatura', 777.0000, 'ºC'),
	(115569, 112, '2015-03-15 00:22:53.000000', 'temperatura', 190.0000, 'ºC'),
	(115570, 112, '2015-03-15 00:22:54.000000', 'temperatura', 1017.0000, 'ºC'),
	(115571, 112, '2015-03-15 00:22:55.000000', 'temperatura', 918.0000, 'ºC'),
	(115572, 112, '2015-03-15 00:22:56.000000', 'temperatura', 340.0000, 'ºC'),
	(115573, 112, '2015-03-15 00:22:57.000000', 'temperatura', 146.0000, 'ºC'),
	(115574, 112, '2015-03-15 00:22:58.000000', 'temperatura', 909.0000, 'ºC'),
	(115575, 112, '2015-03-15 00:22:59.000000', 'temperatura', 510.0000, 'ºC'),
	(115576, 112, '2015-03-15 00:23:00.000000', 'temperatura', 1020.0000, 'ºC'),
	(115577, 112, '2015-03-15 00:23:01.000000', 'temperatura', 1174.0000, 'ºC'),
	(115578, 112, '2015-03-15 00:23:02.000000', 'temperatura', 409.0000, 'ºC'),
	(115579, 112, '2015-03-15 00:23:03.000000', 'temperatura', 922.0000, 'ºC'),
	(115580, 112, '2015-03-15 00:23:04.000000', 'temperatura', 985.0000, 'ºC'),
	(115581, 112, '2015-03-15 00:23:05.000000', 'temperatura', 959.0000, 'ºC'),
	(115582, 112, '2015-03-15 00:23:06.000000', 'temperatura', 643.0000, 'ºC'),
	(115583, 112, '2015-03-15 00:23:07.000000', 'temperatura', 336.0000, 'ºC'),
	(115584, 112, '2015-03-15 00:23:08.000000', 'temperatura', 951.0000, 'ºC'),
	(115585, 112, '2015-03-15 00:23:09.000000', 'temperatura', 149.0000, 'ºC'),
	(115586, 112, '2015-03-15 00:23:10.000000', 'temperatura', 292.0000, 'ºC'),
	(115587, 112, '2015-03-15 00:23:11.000000', 'temperatura', 1013.0000, 'ºC'),
	(115588, 112, '2015-03-15 00:23:12.000000', 'temperatura', 589.0000, 'ºC'),
	(115589, 112, '2015-03-15 00:23:13.000000', 'temperatura', 1105.0000, 'ºC'),
	(115590, 112, '2015-03-15 00:23:14.000000', 'temperatura', 162.0000, 'ºC'),
	(115591, 112, '2015-03-15 00:23:15.000000', 'temperatura', 1094.0000, 'ºC'),
	(115592, 112, '2015-03-15 00:23:16.000000', 'temperatura', 186.0000, 'ºC'),
	(115593, 112, '2015-03-15 00:23:17.000000', 'temperatura', 46.0000, 'ºC'),
	(115594, 112, '2015-03-15 00:23:18.000000', 'temperatura', 874.0000, 'ºC'),
	(115595, 112, '2015-03-15 00:23:19.000000', 'temperatura', 634.0000, 'ºC'),
	(115596, 112, '2015-03-15 00:23:20.000000', 'temperatura', 548.0000, 'ºC'),
	(115597, 112, '2015-03-15 00:23:21.000000', 'temperatura', 838.0000, 'ºC'),
	(115598, 112, '2015-03-15 00:23:22.000000', 'temperatura', 145.0000, 'ºC'),
	(115599, 112, '2015-03-15 00:23:23.000000', 'temperatura', 614.0000, 'ºC'),
	(115600, 112, '2015-03-15 00:23:24.000000', 'temperatura', 234.0000, 'ºC'),
	(115601, 112, '2015-03-15 00:23:25.000000', 'temperatura', 527.0000, 'ºC'),
	(115602, 112, '2015-03-15 00:23:26.000000', 'temperatura', 735.0000, 'ºC'),
	(115603, 112, '2015-03-15 00:23:27.000000', 'temperatura', 893.0000, 'ºC'),
	(115604, 112, '2015-03-15 00:23:28.000000', 'temperatura', 1063.0000, 'ºC'),
	(115605, 112, '2015-03-15 00:23:29.000000', 'temperatura', 237.0000, 'ºC'),
	(115606, 112, '2015-03-15 00:23:30.000000', 'temperatura', 396.0000, 'ºC'),
	(115607, 112, '2015-03-15 00:23:31.000000', 'temperatura', 70.0000, 'ºC'),
	(115608, 112, '2015-03-15 00:23:32.000000', 'temperatura', 362.0000, 'ºC'),
	(115609, 112, '2015-03-15 00:23:33.000000', 'temperatura', 401.0000, 'ºC'),
	(115610, 112, '2015-03-15 00:23:34.000000', 'temperatura', 920.0000, 'ºC'),
	(115611, 112, '2015-03-15 00:23:35.000000', 'temperatura', 996.0000, 'ºC'),
	(115612, 112, '2015-03-15 00:23:36.000000', 'temperatura', 1023.0000, 'ºC'),
	(115613, 112, '2015-03-15 00:23:37.000000', 'temperatura', 926.0000, 'ºC'),
	(115614, 112, '2015-03-15 00:23:38.000000', 'temperatura', 363.0000, 'ºC'),
	(115615, 112, '2015-03-15 00:23:39.000000', 'temperatura', 238.0000, 'ºC'),
	(115616, 112, '2015-03-15 00:23:40.000000', 'temperatura', 98.0000, 'ºC'),
	(115617, 112, '2015-03-15 00:23:41.000000', 'temperatura', 980.0000, 'ºC'),
	(115618, 112, '2015-03-15 00:23:42.000000', 'temperatura', 1006.0000, 'ºC'),
	(115619, 112, '2015-03-15 00:23:43.000000', 'temperatura', 889.0000, 'ºC'),
	(115620, 112, '2015-03-15 00:23:44.000000', 'temperatura', 227.0000, 'ºC'),
	(115621, 112, '2015-03-15 00:23:45.000000', 'temperatura', 869.0000, 'ºC'),
	(115622, 112, '2015-03-15 00:23:46.000000', 'temperatura', 66.0000, 'ºC'),
	(115623, 112, '2015-03-15 00:23:47.000000', 'temperatura', 121.0000, 'ºC'),
	(115624, 112, '2015-03-15 00:23:48.000000', 'temperatura', 408.0000, 'ºC'),
	(115625, 112, '2015-03-15 00:23:49.000000', 'temperatura', 480.0000, 'ºC'),
	(115626, 112, '2015-03-15 00:23:50.000000', 'temperatura', 1174.0000, 'ºC'),
	(115627, 112, '2015-03-15 00:23:51.000000', 'temperatura', 833.0000, 'ºC'),
	(115628, 112, '2015-03-15 00:23:52.000000', 'temperatura', 641.0000, 'ºC'),
	(115629, 112, '2015-03-15 00:23:53.000000', 'temperatura', 707.0000, 'ºC'),
	(115630, 112, '2015-03-15 00:23:54.000000', 'temperatura', 414.0000, 'ºC'),
	(115631, 112, '2015-03-15 00:23:55.000000', 'temperatura', 1150.0000, 'ºC'),
	(115632, 112, '2015-03-15 00:23:56.000000', 'temperatura', 910.0000, 'ºC'),
	(115633, 112, '2015-03-15 00:23:57.000000', 'temperatura', 1097.0000, 'ºC'),
	(115634, 112, '2015-03-15 00:23:58.000000', 'temperatura', 358.0000, 'ºC'),
	(115635, 112, '2015-03-15 00:23:59.000000', 'temperatura', 899.0000, 'ºC'),
	(115636, 112, '2015-03-15 00:24:00.000000', 'temperatura', 1019.0000, 'ºC'),
	(115637, 112, '2015-03-15 00:24:01.000000', 'temperatura', 1.0000, 'ºC'),
	(115638, 112, '2015-03-15 00:24:02.000000', 'temperatura', 550.0000, 'ºC'),
	(115639, 112, '2015-03-15 00:24:03.000000', 'temperatura', 345.0000, 'ºC'),
	(115640, 112, '2015-03-15 00:24:04.000000', 'temperatura', 75.0000, 'ºC'),
	(115641, 112, '2015-03-15 00:24:05.000000', 'temperatura', 543.0000, 'ºC'),
	(115642, 112, '2015-03-15 00:24:06.000000', 'temperatura', 90.0000, 'ºC'),
	(115643, 112, '2015-03-15 00:24:07.000000', 'temperatura', 23.0000, 'ºC'),
	(115644, 112, '2015-03-15 00:24:08.000000', 'temperatura', 1044.0000, 'ºC'),
	(115645, 112, '2015-03-15 00:24:09.000000', 'temperatura', 351.0000, 'ºC'),
	(115646, 112, '2015-03-15 00:24:10.000000', 'temperatura', 1026.0000, 'ºC'),
	(115647, 112, '2015-03-15 00:24:11.000000', 'temperatura', 475.0000, 'ºC'),
	(115648, 112, '2015-03-15 00:24:12.000000', 'temperatura', 497.0000, 'ºC'),
	(115649, 112, '2015-03-15 00:24:13.000000', 'temperatura', 1062.0000, 'ºC'),
	(115650, 112, '2015-03-15 00:24:14.000000', 'temperatura', 221.0000, 'ºC'),
	(115651, 112, '2015-03-15 00:24:15.000000', 'temperatura', 316.0000, 'ºC'),
	(115652, 112, '2015-03-15 00:24:16.000000', 'temperatura', 920.0000, 'ºC'),
	(115653, 112, '2015-03-15 00:24:17.000000', 'temperatura', 51.0000, 'ºC'),
	(115654, 112, '2015-03-15 00:24:18.000000', 'temperatura', 1095.0000, 'ºC'),
	(115655, 112, '2015-03-15 00:24:19.000000', 'temperatura', 524.0000, 'ºC'),
	(115656, 112, '2015-03-15 00:24:20.000000', 'temperatura', 534.0000, 'ºC'),
	(115657, 112, '2015-03-15 00:24:21.000000', 'temperatura', 1100.0000, 'ºC'),
	(115658, 112, '2015-03-15 00:24:22.000000', 'temperatura', 296.0000, 'ºC'),
	(115659, 112, '2015-03-15 00:24:23.000000', 'temperatura', 583.0000, 'ºC'),
	(115660, 112, '2015-03-15 00:24:24.000000', 'temperatura', 829.0000, 'ºC'),
	(115661, 112, '2015-03-15 00:24:25.000000', 'temperatura', 1193.0000, 'ºC'),
	(115662, 112, '2015-03-15 00:24:26.000000', 'temperatura', 1081.0000, 'ºC'),
	(115663, 112, '2015-03-15 00:24:27.000000', 'temperatura', 624.0000, 'ºC'),
	(115664, 112, '2015-03-15 00:24:28.000000', 'temperatura', 1077.0000, 'ºC'),
	(115665, 112, '2015-03-15 00:24:29.000000', 'temperatura', 1116.0000, 'ºC'),
	(115666, 112, '2015-03-15 00:24:30.000000', 'temperatura', 1150.0000, 'ºC'),
	(115667, 112, '2015-03-15 00:24:31.000000', 'temperatura', 1.0000, 'ºC'),
	(115668, 112, '2015-03-15 00:24:32.000000', 'temperatura', 155.0000, 'ºC'),
	(115669, 112, '2015-03-15 00:24:33.000000', 'temperatura', 771.0000, 'ºC'),
	(115670, 112, '2015-03-15 00:24:34.000000', 'temperatura', 994.0000, 'ºC'),
	(115671, 112, '2015-03-15 00:24:35.000000', 'temperatura', 255.0000, 'ºC'),
	(115672, 112, '2015-03-15 00:24:36.000000', 'temperatura', 693.0000, 'ºC'),
	(115673, 112, '2015-03-15 00:24:37.000000', 'temperatura', 299.0000, 'ºC'),
	(115674, 112, '2015-03-15 00:24:38.000000', 'temperatura', 619.0000, 'ºC'),
	(115675, 112, '2015-03-15 00:24:39.000000', 'temperatura', 999.0000, 'ºC'),
	(115676, 112, '2015-03-15 00:24:40.000000', 'temperatura', 738.0000, 'ºC'),
	(115677, 112, '2015-03-15 00:24:41.000000', 'temperatura', 693.0000, 'ºC'),
	(115678, 112, '2015-03-15 00:24:42.000000', 'temperatura', 50.0000, 'ºC'),
	(115679, 112, '2015-03-15 00:24:43.000000', 'temperatura', 574.0000, 'ºC'),
	(115680, 112, '2015-03-15 00:24:44.000000', 'temperatura', 320.0000, 'ºC'),
	(115681, 112, '2015-03-15 00:24:45.000000', 'temperatura', 1076.0000, 'ºC'),
	(115682, 112, '2015-03-15 00:24:46.000000', 'temperatura', 823.0000, 'ºC'),
	(115683, 112, '2015-03-15 00:24:47.000000', 'temperatura', 886.0000, 'ºC'),
	(115684, 112, '2015-03-15 00:24:48.000000', 'temperatura', 761.0000, 'ºC'),
	(115685, 112, '2015-03-15 00:24:49.000000', 'temperatura', 1149.0000, 'ºC'),
	(115686, 112, '2015-03-15 00:24:50.000000', 'temperatura', 1062.0000, 'ºC'),
	(115687, 112, '2015-03-15 00:24:51.000000', 'temperatura', 665.0000, 'ºC'),
	(115688, 112, '2015-03-15 00:24:52.000000', 'temperatura', 139.0000, 'ºC'),
	(115689, 112, '2015-03-15 00:24:53.000000', 'temperatura', 1100.0000, 'ºC'),
	(115690, 112, '2015-03-15 00:24:54.000000', 'temperatura', 283.0000, 'ºC'),
	(115691, 112, '2015-03-15 00:24:55.000000', 'temperatura', 517.0000, 'ºC'),
	(115692, 112, '2015-03-15 00:24:56.000000', 'temperatura', 536.0000, 'ºC'),
	(115693, 112, '2015-03-15 00:24:57.000000', 'temperatura', 1128.0000, 'ºC'),
	(115694, 112, '2015-03-15 00:24:58.000000', 'temperatura', 435.0000, 'ºC'),
	(115695, 112, '2015-03-15 00:24:59.000000', 'temperatura', 1192.0000, 'ºC'),
	(115696, 112, '2015-03-15 00:25:00.000000', 'temperatura', 1054.0000, 'ºC'),
	(115697, 112, '2015-03-15 00:25:01.000000', 'temperatura', 497.0000, 'ºC'),
	(115698, 112, '2015-03-15 00:25:02.000000', 'temperatura', 521.0000, 'ºC'),
	(115699, 112, '2015-03-15 00:25:03.000000', 'temperatura', 1115.0000, 'ºC'),
	(115700, 112, '2015-03-15 00:25:04.000000', 'temperatura', 414.0000, 'ºC'),
	(115701, 112, '2015-03-15 00:25:05.000000', 'temperatura', 1123.0000, 'ºC'),
	(115702, 112, '2015-03-15 00:25:06.000000', 'temperatura', 774.0000, 'ºC'),
	(115703, 112, '2015-03-15 00:25:07.000000', 'temperatura', 500.0000, 'ºC'),
	(115704, 112, '2015-03-15 00:25:08.000000', 'temperatura', 180.0000, 'ºC'),
	(115705, 112, '2015-03-15 00:25:09.000000', 'temperatura', 600.0000, 'ºC'),
	(115706, 112, '2015-03-15 00:25:10.000000', 'temperatura', 61.0000, 'ºC'),
	(115707, 112, '2015-03-15 00:25:11.000000', 'temperatura', 904.0000, 'ºC'),
	(115708, 112, '2015-03-15 00:25:12.000000', 'temperatura', 736.0000, 'ºC'),
	(115709, 112, '2015-03-15 00:25:13.000000', 'temperatura', 972.0000, 'ºC'),
	(115710, 112, '2015-03-15 00:25:14.000000', 'temperatura', 249.0000, 'ºC'),
	(115711, 112, '2015-03-15 00:25:15.000000', 'temperatura', 732.0000, 'ºC'),
	(115712, 112, '2015-03-15 00:25:16.000000', 'temperatura', 511.0000, 'ºC'),
	(115713, 112, '2015-03-15 00:25:17.000000', 'temperatura', 361.0000, 'ºC'),
	(115714, 112, '2015-03-15 00:25:18.000000', 'temperatura', 270.0000, 'ºC'),
	(115715, 112, '2015-03-15 00:25:19.000000', 'temperatura', 271.0000, 'ºC'),
	(115716, 112, '2015-03-15 00:25:20.000000', 'temperatura', 543.0000, 'ºC'),
	(115717, 112, '2015-03-15 00:25:21.000000', 'temperatura', 701.0000, 'ºC'),
	(115718, 112, '2015-03-15 00:25:22.000000', 'temperatura', 680.0000, 'ºC'),
	(115719, 112, '2015-03-15 00:25:23.000000', 'temperatura', 97.0000, 'ºC'),
	(115720, 112, '2015-03-15 00:25:24.000000', 'temperatura', 845.0000, 'ºC'),
	(115721, 112, '2015-03-15 00:25:25.000000', 'temperatura', 335.0000, 'ºC'),
	(115722, 112, '2015-03-15 00:25:26.000000', 'temperatura', 339.0000, 'ºC'),
	(115723, 112, '2015-03-15 00:25:27.000000', 'temperatura', 692.0000, 'ºC'),
	(115724, 112, '2015-03-15 00:25:28.000000', 'temperatura', 43.0000, 'ºC'),
	(115725, 112, '2015-03-15 00:25:29.000000', 'temperatura', 539.0000, 'ºC'),
	(115726, 112, '2015-03-15 00:25:30.000000', 'temperatura', 167.0000, 'ºC'),
	(115727, 112, '2015-03-15 00:25:31.000000', 'temperatura', 419.0000, 'ºC'),
	(115728, 112, '2015-03-15 00:25:32.000000', 'temperatura', 394.0000, 'ºC'),
	(115729, 112, '2015-03-15 00:25:33.000000', 'temperatura', 715.0000, 'ºC'),
	(115730, 112, '2015-03-15 00:25:34.000000', 'temperatura', 1194.0000, 'ºC'),
	(115731, 112, '2015-03-15 00:25:35.000000', 'temperatura', 226.0000, 'ºC'),
	(115732, 112, '2015-03-15 00:25:36.000000', 'temperatura', 1147.0000, 'ºC'),
	(115733, 112, '2015-03-15 00:25:37.000000', 'temperatura', 260.0000, 'ºC'),
	(115734, 112, '2015-03-15 00:25:38.000000', 'temperatura', 256.0000, 'ºC'),
	(115735, 112, '2015-03-15 00:25:39.000000', 'temperatura', 501.0000, 'ºC'),
	(115736, 112, '2015-03-15 00:25:40.000000', 'temperatura', 539.0000, 'ºC'),
	(115737, 112, '2015-03-15 00:25:41.000000', 'temperatura', 1190.0000, 'ºC'),
	(115738, 112, '2015-03-15 00:25:42.000000', 'temperatura', 736.0000, 'ºC'),
	(115739, 112, '2015-03-15 00:25:43.000000', 'temperatura', 112.0000, 'ºC'),
	(115740, 112, '2015-03-15 00:25:44.000000', 'temperatura', 750.0000, 'ºC'),
	(115741, 112, '2015-03-15 00:25:45.000000', 'temperatura', 1015.0000, 'ºC'),
	(115742, 112, '2015-03-15 00:25:46.000000', 'temperatura', 428.0000, 'ºC'),
	(115743, 112, '2015-03-15 00:25:47.000000', 'temperatura', 292.0000, 'ºC'),
	(115744, 112, '2015-03-15 00:25:48.000000', 'temperatura', 177.0000, 'ºC'),
	(115745, 112, '2015-03-15 00:25:49.000000', 'temperatura', 12.0000, 'ºC'),
	(115746, 112, '2015-03-15 00:25:50.000000', 'temperatura', 728.0000, 'ºC'),
	(115747, 112, '2015-03-15 00:25:51.000000', 'temperatura', 3.0000, 'ºC'),
	(115748, 112, '2015-03-15 00:25:52.000000', 'temperatura', 233.0000, 'ºC'),
	(115749, 112, '2015-03-15 00:25:53.000000', 'temperatura', 1155.0000, 'ºC'),
	(115750, 112, '2015-03-15 00:25:54.000000', 'temperatura', 278.0000, 'ºC'),
	(115751, 112, '2015-03-15 00:25:55.000000', 'temperatura', 327.0000, 'ºC'),
	(115752, 112, '2015-03-15 00:25:56.000000', 'temperatura', 800.0000, 'ºC'),
	(115753, 112, '2015-03-15 00:25:57.000000', 'temperatura', 618.0000, 'ºC'),
	(115754, 112, '2015-03-15 00:25:58.000000', 'temperatura', 691.0000, 'ºC'),
	(115755, 112, '2015-03-15 00:25:59.000000', 'temperatura', 402.0000, 'ºC'),
	(115756, 112, '2015-03-15 00:26:00.000000', 'temperatura', 1138.0000, 'ºC'),
	(115757, 112, '2015-03-15 00:26:01.000000', 'temperatura', 884.0000, 'ºC'),
	(115758, 112, '2015-03-15 00:26:02.000000', 'temperatura', 1007.0000, 'ºC'),
	(115759, 112, '2015-03-15 00:26:03.000000', 'temperatura', 1183.0000, 'ºC'),
	(115760, 112, '2015-03-15 00:26:04.000000', 'temperatura', 494.0000, 'ºC'),
	(115761, 112, '2015-03-15 00:26:05.000000', 'temperatura', 122.0000, 'ºC'),
	(115762, 112, '2015-03-15 00:26:06.000000', 'temperatura', 328.0000, 'ºC'),
	(115763, 112, '2015-03-15 00:26:07.000000', 'temperatura', 74.0000, 'ºC'),
	(115764, 112, '2015-03-15 00:26:08.000000', 'temperatura', 587.0000, 'ºC'),
	(115765, 112, '2015-03-15 00:26:09.000000', 'temperatura', 313.0000, 'ºC'),
	(115766, 112, '2015-03-15 00:26:10.000000', 'temperatura', 1005.0000, 'ºC'),
	(115767, 112, '2015-03-15 00:26:11.000000', 'temperatura', 486.0000, 'ºC'),
	(115768, 112, '2015-03-15 00:26:12.000000', 'temperatura', 614.0000, 'ºC'),
	(115769, 112, '2015-03-15 00:26:13.000000', 'temperatura', 415.0000, 'ºC'),
	(115770, 112, '2015-03-15 00:26:14.000000', 'temperatura', 233.0000, 'ºC'),
	(115771, 112, '2015-03-15 00:26:15.000000', 'temperatura', 1121.0000, 'ºC'),
	(115772, 112, '2015-03-15 00:26:16.000000', 'temperatura', 104.0000, 'ºC'),
	(115773, 112, '2015-03-15 00:26:17.000000', 'temperatura', 758.0000, 'ºC'),
	(115774, 112, '2015-03-15 00:26:18.000000', 'temperatura', 1081.0000, 'ºC'),
	(115775, 112, '2015-03-15 00:26:19.000000', 'temperatura', 731.0000, 'ºC'),
	(115776, 112, '2015-03-15 00:26:20.000000', 'temperatura', 413.0000, 'ºC'),
	(115777, 112, '2015-03-15 00:26:21.000000', 'temperatura', 1072.0000, 'ºC'),
	(115778, 112, '2015-03-15 00:26:22.000000', 'temperatura', 522.0000, 'ºC'),
	(115779, 112, '2015-03-15 00:26:23.000000', 'temperatura', 594.0000, 'ºC'),
	(115780, 112, '2015-03-15 00:26:24.000000', 'temperatura', 206.0000, 'ºC'),
	(115781, 112, '2015-03-15 00:26:25.000000', 'temperatura', 446.0000, 'ºC'),
	(115782, 112, '2015-03-15 00:26:26.000000', 'temperatura', 414.0000, 'ºC'),
	(115783, 112, '2015-03-15 00:26:27.000000', 'temperatura', 733.0000, 'ºC'),
	(115784, 112, '2015-03-15 00:26:28.000000', 'temperatura', 23.0000, 'ºC'),
	(115785, 112, '2015-03-15 00:26:29.000000', 'temperatura', 315.0000, 'ºC'),
	(115786, 112, '2015-03-15 00:26:30.000000', 'temperatura', 307.0000, 'ºC'),
	(115787, 112, '2015-03-15 00:26:31.000000', 'temperatura', 590.0000, 'ºC'),
	(115788, 112, '2015-03-15 00:26:32.000000', 'temperatura', 831.0000, 'ºC'),
	(115789, 112, '2015-03-15 00:26:33.000000', 'temperatura', 1183.0000, 'ºC'),
	(115790, 112, '2015-03-15 00:26:34.000000', 'temperatura', 1025.0000, 'ºC'),
	(115791, 112, '2015-03-15 00:26:35.000000', 'temperatura', 377.0000, 'ºC'),
	(115792, 112, '2015-03-15 00:26:36.000000', 'temperatura', 9.0000, 'ºC'),
	(115793, 112, '2015-03-15 00:26:37.000000', 'temperatura', 114.0000, 'ºC'),
	(115794, 112, '2015-03-15 00:26:38.000000', 'temperatura', 543.0000, 'ºC'),
	(115795, 112, '2015-03-15 00:26:39.000000', 'temperatura', 1173.0000, 'ºC'),
	(115796, 112, '2015-03-15 00:26:40.000000', 'temperatura', 636.0000, 'ºC'),
	(115797, 112, '2015-03-15 00:26:41.000000', 'temperatura', 861.0000, 'ºC'),
	(115798, 112, '2015-03-15 00:26:42.000000', 'temperatura', 1197.0000, 'ºC'),
	(115799, 112, '2015-03-15 00:26:43.000000', 'temperatura', 1002.0000, 'ºC'),
	(115800, 112, '2015-03-15 00:26:44.000000', 'temperatura', 219.0000, 'ºC'),
	(115801, 112, '2015-03-15 00:26:45.000000', 'temperatura', 492.0000, 'ºC'),
	(115802, 112, '2015-03-15 00:26:46.000000', 'temperatura', 602.0000, 'ºC'),
	(115803, 112, '2015-03-15 00:26:47.000000', 'temperatura', 336.0000, 'ºC'),
	(115804, 112, '2015-03-15 00:26:48.000000', 'temperatura', 1073.0000, 'ºC'),
	(115805, 112, '2015-03-15 00:26:49.000000', 'temperatura', 759.0000, 'ºC'),
	(115806, 112, '2015-03-15 00:26:50.000000', 'temperatura', 577.0000, 'ºC'),
	(115807, 112, '2015-03-15 00:26:51.000000', 'temperatura', 609.0000, 'ºC'),
	(115808, 112, '2015-03-15 00:26:52.000000', 'temperatura', 112.0000, 'ºC'),
	(115809, 112, '2015-03-15 00:26:53.000000', 'temperatura', 1133.0000, 'ºC'),
	(115810, 112, '2015-03-15 00:26:54.000000', 'temperatura', 533.0000, 'ºC'),
	(115811, 112, '2015-03-15 00:26:55.000000', 'temperatura', 463.0000, 'ºC'),
	(115812, 112, '2015-03-15 00:26:56.000000', 'temperatura', 719.0000, 'ºC'),
	(115813, 112, '2015-03-15 00:26:57.000000', 'temperatura', 1004.0000, 'ºC'),
	(115814, 112, '2015-03-15 00:26:58.000000', 'temperatura', 463.0000, 'ºC'),
	(115815, 112, '2015-03-15 00:26:59.000000', 'temperatura', 505.0000, 'ºC'),
	(115816, 112, '2015-03-15 00:27:00.000000', 'temperatura', 1137.0000, 'ºC'),
	(115817, 112, '2015-03-15 00:27:01.000000', 'temperatura', 572.0000, 'ºC'),
	(115818, 112, '2015-03-15 00:27:02.000000', 'temperatura', 647.0000, 'ºC'),
	(115819, 112, '2015-03-15 00:27:03.000000', 'temperatura', 322.0000, 'ºC'),
	(115820, 112, '2015-03-15 00:27:04.000000', 'temperatura', 867.0000, 'ºC'),
	(115821, 112, '2015-03-15 00:27:05.000000', 'temperatura', 971.0000, 'ºC'),
	(115822, 112, '2015-03-15 00:27:06.000000', 'temperatura', 1052.0000, 'ºC'),
	(115823, 112, '2015-03-15 00:27:07.000000', 'temperatura', 1151.0000, 'ºC'),
	(115824, 112, '2015-03-15 00:27:08.000000', 'temperatura', 196.0000, 'ºC'),
	(115825, 112, '2015-03-15 00:27:09.000000', 'temperatura', 1131.0000, 'ºC'),
	(115826, 112, '2015-03-15 00:27:10.000000', 'temperatura', 266.0000, 'ºC'),
	(115827, 112, '2015-03-15 00:27:11.000000', 'temperatura', 338.0000, 'ºC'),
	(115828, 112, '2015-03-15 00:27:12.000000', 'temperatura', 893.0000, 'ºC'),
	(115829, 112, '2015-03-15 00:27:13.000000', 'temperatura', 1052.0000, 'ºC'),
	(115830, 112, '2015-03-15 00:27:14.000000', 'temperatura', 180.0000, 'ºC'),
	(115831, 112, '2015-03-15 00:27:15.000000', 'temperatura', 143.0000, 'ºC'),
	(115832, 112, '2015-03-15 00:27:16.000000', 'temperatura', 177.0000, 'ºC'),
	(115833, 112, '2015-03-15 00:27:17.000000', 'temperatura', 458.0000, 'ºC'),
	(115834, 112, '2015-03-15 00:27:18.000000', 'temperatura', 559.0000, 'ºC'),
	(115835, 112, '2015-03-15 00:27:19.000000', 'temperatura', 220.0000, 'ºC'),
	(115836, 112, '2015-03-15 00:27:20.000000', 'temperatura', 623.0000, 'ºC'),
	(115837, 112, '2015-03-15 00:27:21.000000', 'temperatura', 57.0000, 'ºC'),
	(115838, 112, '2015-03-15 00:27:22.000000', 'temperatura', 816.0000, 'ºC'),
	(115839, 112, '2015-03-15 00:27:23.000000', 'temperatura', 309.0000, 'ºC'),
	(115840, 112, '2015-03-15 00:27:24.000000', 'temperatura', 299.0000, 'ºC'),
	(115841, 112, '2015-03-15 00:27:25.000000', 'temperatura', 568.0000, 'ºC'),
	(115842, 112, '2015-03-15 00:27:26.000000', 'temperatura', 743.0000, 'ºC'),
	(115843, 112, '2015-03-15 00:27:27.000000', 'temperatura', 812.0000, 'ºC'),
	(115844, 112, '2015-03-15 00:27:28.000000', 'temperatura', 633.0000, 'ºC'),
	(115845, 112, '2015-03-15 00:27:29.000000', 'temperatura', 729.0000, 'ºC'),
	(115846, 112, '2015-03-15 00:27:30.000000', 'temperatura', 547.0000, 'ºC'),
	(115847, 112, '2015-03-15 00:27:31.000000', 'temperatura', 546.0000, 'ºC'),
	(115848, 112, '2015-03-15 00:27:32.000000', 'temperatura', 1092.0000, 'ºC'),
	(115849, 112, '2015-03-15 00:27:33.000000', 'temperatura', 220.0000, 'ºC'),
	(115850, 112, '2015-03-15 00:27:34.000000', 'temperatura', 224.0000, 'ºC'),
	(115851, 112, '2015-03-15 00:27:35.000000', 'temperatura', 461.0000, 'ºC'),
	(115852, 112, '2015-03-15 00:27:36.000000', 'temperatura', 432.0000, 'ºC'),
	(115853, 112, '2015-03-15 00:27:37.000000', 'temperatura', 780.0000, 'ºC'),
	(115854, 112, '2015-03-15 00:27:38.000000', 'temperatura', 205.0000, 'ºC'),
	(115855, 112, '2015-03-15 00:27:39.000000', 'temperatura', 1083.0000, 'ºC'),
	(115856, 112, '2015-03-15 00:27:40.000000', 'temperatura', 3.0000, 'ºC'),
	(115857, 112, '2015-03-15 00:27:41.000000', 'temperatura', 365.0000, 'ºC'),
	(115858, 112, '2015-03-15 00:27:42.000000', 'temperatura', 618.0000, 'ºC'),
	(115859, 112, '2015-03-15 00:27:43.000000', 'temperatura', 796.0000, 'ºC'),
	(115860, 112, '2015-03-15 00:27:44.000000', 'temperatura', 927.0000, 'ºC'),
	(115861, 112, '2015-03-15 00:27:45.000000', 'temperatura', 1047.0000, 'ºC'),
	(115862, 112, '2015-03-15 00:27:46.000000', 'temperatura', 55.0000, 'ºC'),
	(115863, 112, '2015-03-15 00:27:47.000000', 'temperatura', 736.0000, 'ºC'),
	(115864, 112, '2015-03-15 00:27:48.000000', 'temperatura', 1112.0000, 'ºC'),
	(115865, 112, '2015-03-15 00:27:49.000000', 'temperatura', 955.0000, 'ºC'),
	(115866, 112, '2015-03-15 00:27:50.000000', 'temperatura', 238.0000, 'ºC'),
	(115867, 112, '2015-03-15 00:27:51.000000', 'temperatura', 726.0000, 'ºC'),
	(115868, 112, '2015-03-15 00:27:52.000000', 'temperatura', 518.0000, 'ºC'),
	(115869, 112, '2015-03-15 00:27:53.000000', 'temperatura', 412.0000, 'ºC'),
	(115870, 112, '2015-03-15 00:27:54.000000', 'temperatura', 506.0000, 'ºC'),
	(115871, 112, '2015-03-15 00:27:55.000000', 'temperatura', 96.0000, 'ºC'),
	(115872, 112, '2015-03-15 00:27:56.000000', 'temperatura', 161.0000, 'ºC'),
	(115873, 112, '2015-03-15 00:27:57.000000', 'temperatura', 518.0000, 'ºC'),
	(115874, 112, '2015-03-15 00:27:58.000000', 'temperatura', 907.0000, 'ºC'),
	(115875, 112, '2015-03-15 00:27:59.000000', 'temperatura', 581.0000, 'ºC'),
	(115876, 112, '2015-03-15 00:28:00.000000', 'temperatura', 185.0000, 'ºC'),
	(115877, 112, '2015-03-15 00:28:01.000000', 'temperatura', 383.0000, 'ºC'),
	(115878, 112, '2015-03-15 00:28:02.000000', 'temperatura', 158.0000, 'ºC'),
	(115879, 112, '2015-03-15 00:28:03.000000', 'temperatura', 845.0000, 'ºC'),
	(115880, 112, '2015-03-15 00:28:04.000000', 'temperatura', 149.0000, 'ºC'),
	(115881, 112, '2015-03-15 00:28:05.000000', 'temperatura', 613.0000, 'ºC'),
	(115882, 112, '2015-03-15 00:28:06.000000', 'temperatura', 219.0000, 'ºC'),
	(115883, 112, '2015-03-15 00:28:07.000000', 'temperatura', 455.0000, 'ºC'),
	(115884, 112, '2015-03-15 00:28:08.000000', 'temperatura', 420.0000, 'ºC'),
	(115885, 112, '2015-03-15 00:28:09.000000', 'temperatura', 732.0000, 'ºC'),
	(115886, 112, '2015-03-15 00:28:10.000000', 'temperatura', 4.0000, 'ºC'),
	(115887, 112, '2015-03-15 00:28:11.000000', 'temperatura', 225.0000, 'ºC'),
	(115888, 112, '2015-03-15 00:28:12.000000', 'temperatura', 1113.0000, 'ºC'),
	(115889, 112, '2015-03-15 00:28:13.000000', 'temperatura', 91.0000, 'ºC'),
	(115890, 112, '2015-03-15 00:28:14.000000', 'temperatura', 717.0000, 'ºC'),
	(115891, 112, '2015-03-15 00:28:15.000000', 'temperatura', 913.0000, 'ºC'),
	(115892, 112, '2015-03-15 00:28:16.000000', 'temperatura', 13.0000, 'ºC'),
	(115893, 112, '2015-03-15 00:28:17.000000', 'temperatura', 925.0000, 'ºC'),
	(115894, 112, '2015-03-15 00:28:18.000000', 'temperatura', 988.0000, 'ºC'),
	(115895, 112, '2015-03-15 00:28:19.000000', 'temperatura', 967.0000, 'ºC'),
	(115896, 112, '2015-03-15 00:28:20.000000', 'temperatura', 670.0000, 'ºC'),
	(115897, 112, '2015-03-15 00:28:21.000000', 'temperatura', 451.0000, 'ºC'),
	(115898, 112, '2015-03-15 00:28:22.000000', 'temperatura', 246.0000, 'ºC'),
	(115899, 112, '2015-03-15 00:28:23.000000', 'temperatura', 1078.0000, 'ºC'),
	(115900, 112, '2015-03-15 00:28:24.000000', 'temperatura', 1053.0000, 'ºC'),
	(115901, 112, '2015-03-15 00:28:25.000000', 'temperatura', 830.0000, 'ºC'),
	(115902, 112, '2015-03-15 00:28:26.000000', 'temperatura', 991.0000, 'ºC'),
	(115903, 112, '2015-03-15 00:28:27.000000', 'temperatura', 66.0000, 'ºC'),
	(115904, 112, '2015-03-15 00:28:28.000000', 'temperatura', 960.0000, 'ºC'),
	(115905, 112, '2015-03-15 00:28:29.000000', 'temperatura', 999.0000, 'ºC'),
	(115906, 112, '2015-03-15 00:28:30.000000', 'temperatura', 917.0000, 'ºC'),
	(115907, 112, '2015-03-15 00:28:31.000000', 'temperatura', 389.0000, 'ºC'),
	(115908, 112, '2015-03-15 00:28:32.000000', 'temperatura', 392.0000, 'ºC'),
	(115909, 112, '2015-03-15 00:28:33.000000', 'temperatura', 795.0000, 'ºC'),
	(115910, 112, '2015-03-15 00:28:34.000000', 'temperatura', 401.0000, 'ºC'),
	(115911, 112, '2015-03-15 00:28:35.000000', 'temperatura', 820.0000, 'ºC'),
	(115912, 112, '2015-03-15 00:28:36.000000', 'temperatura', 499.0000, 'ºC'),
	(115913, 112, '2015-03-15 00:28:37.000000', 'temperatura', 34.0000, 'ºC'),
	(115914, 112, '2015-03-15 00:28:38.000000', 'temperatura', 1072.0000, 'ºC'),
	(115915, 112, '2015-03-15 00:28:39.000000', 'temperatura', 460.0000, 'ºC'),
	(115916, 112, '2015-03-15 00:28:40.000000', 'temperatura', 282.0000, 'ºC'),
	(115917, 112, '2015-03-15 00:28:41.000000', 'temperatura', 33.0000, 'ºC'),
	(115918, 112, '2015-03-15 00:28:42.000000', 'temperatura', 521.0000, 'ºC'),
	(115919, 112, '2015-03-15 00:28:43.000000', 'temperatura', 103.0000, 'ºC'),
	(115920, 112, '2015-03-15 00:28:44.000000', 'temperatura', 154.0000, 'ºC'),
	(115921, 112, '2015-03-15 00:28:45.000000', 'temperatura', 461.0000, 'ºC'),
	(115922, 112, '2015-03-15 00:28:46.000000', 'temperatura', 643.0000, 'ºC'),
	(115923, 112, '2015-03-15 00:28:47.000000', 'temperatura', 634.0000, 'ºC'),
	(115924, 112, '2015-03-15 00:28:48.000000', 'temperatura', 43.0000, 'ºC'),
	(115925, 112, '2015-03-15 00:28:49.000000', 'temperatura', 710.0000, 'ºC'),
	(115926, 112, '2015-03-15 00:28:50.000000', 'temperatura', 1024.0000, 'ºC'),
	(115927, 112, '2015-03-15 00:28:51.000000', 'temperatura', 588.0000, 'ºC'),
	(115928, 112, '2015-03-15 00:28:52.000000', 'temperatura', 1070.0000, 'ºC'),
	(115929, 112, '2015-03-15 00:28:53.000000', 'temperatura', 1185.0000, 'ºC'),
	(115930, 112, '2015-03-15 00:28:54.000000', 'temperatura', 317.0000, 'ºC'),
	(115931, 112, '2015-03-15 00:28:55.000000', 'temperatura', 431.0000, 'ºC'),
	(115932, 112, '2015-03-15 00:28:56.000000', 'temperatura', 4.0000, 'ºC'),
	(115933, 112, '2015-03-15 00:28:57.000000', 'temperatura', 1129.0000, 'ºC'),
	(115934, 112, '2015-03-15 00:28:58.000000', 'temperatura', 832.0000, 'ºC'),
	(115935, 112, '2015-03-15 00:28:59.000000', 'temperatura', 772.0000, 'ºC'),
	(115936, 112, '2015-03-15 00:29:00.000000', 'temperatura', 165.0000, 'ºC'),
	(115937, 112, '2015-03-15 00:29:01.000000', 'temperatura', 910.0000, 'ºC'),
	(115938, 112, '2015-03-15 00:29:02.000000', 'temperatura', 454.0000, 'ºC'),
	(115939, 112, '2015-03-15 00:29:03.000000', 'temperatura', 740.0000, 'ºC'),
	(115940, 112, '2015-03-15 00:29:04.000000', 'temperatura', 1139.0000, 'ºC'),
	(115941, 112, '2015-03-15 00:29:05.000000', 'temperatura', 1075.0000, 'ºC'),
	(115942, 112, '2015-03-15 00:29:06.000000', 'temperatura', 758.0000, 'ºC'),
	(115943, 112, '2015-03-15 00:29:07.000000', 'temperatura', 566.0000, 'ºC'),
	(115944, 112, '2015-03-15 00:29:08.000000', 'temperatura', 558.0000, 'ºC'),
	(115945, 112, '2015-03-15 00:29:09.000000', 'temperatura', 1092.0000, 'ºC'),
	(115946, 112, '2015-03-15 00:29:10.000000', 'temperatura', 188.0000, 'ºC'),
	(115947, 112, '2015-03-15 00:29:11.000000', 'temperatura', 63.0000, 'ºC'),
	(115948, 112, '2015-03-15 00:29:12.000000', 'temperatura', 950.0000, 'ºC'),
	(115949, 112, '2015-03-15 00:29:13.000000', 'temperatura', 964.0000, 'ºC'),
	(115950, 112, '2015-03-15 00:29:14.000000', 'temperatura', 770.0000, 'ºC'),
	(115951, 112, '2015-03-15 00:29:15.000000', 'temperatura', 960.0000, 'ºC'),
	(115952, 112, '2015-03-15 00:29:16.000000', 'temperatura', 88.0000, 'ºC'),
	(115953, 112, '2015-03-15 00:29:17.000000', 'temperatura', 1160.0000, 'ºC'),
	(115954, 112, '2015-03-15 00:29:18.000000', 'temperatura', 738.0000, 'ºC'),
	(115955, 112, '2015-03-15 00:29:19.000000', 'temperatura', 210.0000, 'ºC'),
	(115956, 112, '2015-03-15 00:29:20.000000', 'temperatura', 35.0000, 'ºC'),
	(115957, 112, '2015-03-15 00:29:21.000000', 'temperatura', 745.0000, 'ºC'),
	(115958, 112, '2015-03-15 00:29:22.000000', 'temperatura', 23.0000, 'ºC'),
	(115959, 112, '2015-03-15 00:29:23.000000', 'temperatura', 281.0000, 'ºC'),
	(115960, 112, '2015-03-15 00:29:24.000000', 'temperatura', 135.0000, 'ºC'),
	(115961, 112, '2015-03-15 00:29:25.000000', 'temperatura', 1031.0000, 'ºC'),
	(115962, 112, '2015-03-15 00:29:26.000000', 'temperatura', 1152.0000, 'ºC'),
	(115963, 112, '2015-03-15 00:29:27.000000', 'temperatura', 269.0000, 'ºC'),
	(115964, 112, '2015-03-15 00:29:28.000000', 'temperatura', 287.0000, 'ºC'),
	(115965, 112, '2015-03-15 00:29:29.000000', 'temperatura', 630.0000, 'ºC'),
	(115966, 112, '2015-03-15 00:29:30.000000', 'temperatura', 1091.0000, 'ºC'),
	(115967, 112, '2015-03-15 00:29:31.000000', 'temperatura', 1163.0000, 'ºC'),
	(115968, 112, '2015-03-15 00:29:32.000000', 'temperatura', 143.0000, 'ºC'),
	(115969, 112, '2015-03-15 00:29:33.000000', 'temperatura', 826.0000, 'ºC'),
	(115970, 112, '2015-03-15 00:29:34.000000', 'temperatura', 100.0000, 'ºC'),
	(115971, 112, '2015-03-15 00:29:35.000000', 'temperatura', 425.0000, 'ºC'),
	(115972, 112, '2015-03-15 00:29:36.000000', 'temperatura', 624.0000, 'ºC'),
	(115973, 112, '2015-03-15 00:29:37.000000', 'temperatura', 645.0000, 'ºC'),
	(115974, 112, '2015-03-15 00:29:38.000000', 'temperatura', 153.0000, 'ºC'),
	(115975, 112, '2015-03-15 00:29:39.000000', 'temperatura', 30.0000, 'ºC'),
	(115976, 112, '2015-03-15 00:29:40.000000', 'temperatura', 893.0000, 'ºC'),
	(115977, 112, '2015-03-15 00:29:41.000000', 'temperatura', 776.0000, 'ºC'),
	(115978, 112, '2015-03-15 00:29:42.000000', 'temperatura', 1.0000, 'ºC'),
	(115979, 112, '2015-03-15 00:29:43.000000', 'temperatura', 76.0000, 'ºC'),
	(115980, 112, '2015-03-15 00:29:44.000000', 'temperatura', 380.0000, 'ºC'),
	(115981, 112, '2015-03-15 00:29:45.000000', 'temperatura', 472.0000, 'ºC'),
	(115982, 112, '2015-03-15 00:29:46.000000', 'temperatura', 18.0000, 'ºC'),
	(115983, 112, '2015-03-15 00:29:47.000000', 'temperatura', 1076.0000, 'ºC'),
	(115984, 112, '2015-03-15 00:29:48.000000', 'temperatura', 527.0000, 'ºC'),
	(115985, 112, '2015-03-15 00:29:49.000000', 'temperatura', 607.0000, 'ºC'),
	(115986, 112, '2015-03-15 00:29:50.000000', 'temperatura', 254.0000, 'ºC'),
	(115987, 112, '2015-03-15 00:29:51.000000', 'temperatura', 649.0000, 'ºC'),
	(115988, 112, '2015-03-15 00:29:52.000000', 'temperatura', 83.0000, 'ºC'),
	(115989, 112, '2015-03-15 00:29:53.000000', 'temperatura', 869.0000, 'ºC'),
	(115990, 112, '2015-03-15 00:29:54.000000', 'temperatura', 495.0000, 'ºC'),
	(115991, 112, '2015-03-15 00:29:55.000000', 'temperatura', 1069.0000, 'ºC'),
	(115992, 112, '2015-03-15 00:29:56.000000', 'temperatura', 261.0000, 'ºC'),
	(115993, 112, '2015-03-15 00:29:57.000000', 'temperatura', 500.0000, 'ºC'),
	(115994, 112, '2015-03-15 00:29:58.000000', 'temperatura', 515.0000, 'ºC'),
	(115995, 112, '2015-03-15 00:29:59.000000', 'temperatura', 1076.0000, 'ºC'),
	(115996, 112, '2015-03-15 00:30:00.000000', 'temperatura', 234.0000, 'ºC'),
	(115997, 112, '2015-03-15 00:30:01.000000', 'temperatura', 344.0000, 'ºC'),
	(115998, 112, '2015-03-15 00:30:02.000000', 'temperatura', 1019.0000, 'ºC'),
	(115999, 112, '2015-03-15 00:30:03.000000', 'temperatura', 462.0000, 'ºC'),
	(116000, 112, '2015-03-15 00:30:04.000000', 'temperatura', 453.0000, 'ºC'),
	(116001, 112, '2015-03-15 00:30:05.000000', 'temperatura', 881.0000, 'ºC'),
	(116002, 112, '2015-03-15 00:30:06.000000', 'temperatura', 647.0000, 'ºC'),
	(116003, 112, '2015-03-15 00:30:07.000000', 'temperatura', 591.0000, 'ºC'),
	(116004, 112, '2015-03-15 00:30:08.000000', 'temperatura', 1014.0000, 'ºC'),
	(116005, 112, '2015-03-15 00:30:09.000000', 'temperatura', 897.0000, 'ºC'),
	(116006, 112, '2015-03-15 00:30:10.000000', 'temperatura', 246.0000, 'ºC'),
	(116007, 112, '2015-03-15 00:30:11.000000', 'temperatura', 936.0000, 'ºC'),
	(116008, 112, '2015-03-15 00:30:12.000000', 'temperatura', 346.0000, 'ºC'),
	(116009, 112, '2015-03-15 00:30:13.000000', 'temperatura', 119.0000, 'ºC'),
	(116010, 112, '2015-03-15 00:30:14.000000', 'temperatura', 760.0000, 'ºC'),
	(116011, 112, '2015-03-15 00:30:15.000000', 'temperatura', 1043.0000, 'ºC'),
	(116012, 112, '2015-03-15 00:30:16.000000', 'temperatura', 536.0000, 'ºC'),
	(116013, 112, '2015-03-15 00:30:17.000000', 'temperatura', 750.0000, 'ºC'),
	(116014, 112, '2015-03-15 00:30:18.000000', 'temperatura', 944.0000, 'ºC'),
	(116015, 112, '2015-03-15 00:30:19.000000', 'temperatura', 71.0000, 'ºC'),
	(116016, 112, '2015-03-15 00:30:20.000000', 'temperatura', 1121.0000, 'ºC'),
	(116017, 112, '2015-03-15 00:30:21.000000', 'temperatura', 593.0000, 'ºC'),
	(116018, 112, '2015-03-15 00:30:22.000000', 'temperatura', 805.0000, 'ºC'),
	(116019, 112, '2015-03-15 00:30:23.000000', 'temperatura', 1044.0000, 'ºC'),
	(116020, 112, '2015-03-15 00:30:24.000000', 'temperatura', 407.0000, 'ºC'),
	(116021, 112, '2015-03-15 00:30:25.000000', 'temperatura', 104.0000, 'ºC'),
	(116022, 112, '2015-03-15 00:30:26.000000', 'temperatura', 498.0000, 'ºC'),
	(116023, 112, '2015-03-15 00:30:27.000000', 'temperatura', 981.0000, 'ºC'),
	(116024, 112, '2015-03-15 00:30:28.000000', 'temperatura', 1010.0000, 'ºC'),
	(116025, 112, '2015-03-15 00:30:29.000000', 'temperatura', 909.0000, 'ºC'),
	(116026, 112, '2015-03-15 00:30:30.000000', 'temperatura', 316.0000, 'ºC'),
	(116027, 112, '2015-03-15 00:30:31.000000', 'temperatura', 52.0000, 'ºC'),
	(116028, 112, '2015-03-15 00:30:32.000000', 'temperatura', 514.0000, 'ºC'),
	(116029, 112, '2015-03-15 00:30:33.000000', 'temperatura', 13.0000, 'ºC'),
	(116030, 112, '2015-03-15 00:30:34.000000', 'temperatura', 926.0000, 'ºC'),
	(116031, 112, '2015-03-15 00:30:35.000000', 'temperatura', 990.0000, 'ºC'),
	(116032, 112, '2015-03-15 00:30:36.000000', 'temperatura', 973.0000, 'ºC'),
	(116033, 112, '2015-03-15 00:30:37.000000', 'temperatura', 695.0000, 'ºC'),
	(116034, 112, '2015-03-15 00:30:38.000000', 'temperatura', 555.0000, 'ºC'),
	(116035, 112, '2015-03-15 00:30:39.000000', 'temperatura', 692.0000, 'ºC'),
	(116036, 112, '2015-03-15 00:30:40.000000', 'temperatura', 596.0000, 'ºC'),
	(116037, 112, '2015-03-15 00:30:41.000000', 'temperatura', 903.0000, 'ºC'),
	(116038, 112, '2015-03-15 00:30:42.000000', 'temperatura', 327.0000, 'ºC'),
	(116039, 112, '2015-03-15 00:30:43.000000', 'temperatura', 127.0000, 'ºC'),
	(116040, 112, '2015-03-15 00:30:44.000000', 'temperatura', 855.0000, 'ºC'),
	(116041, 112, '2015-03-15 00:30:45.000000', 'temperatura', 295.0000, 'ºC'),
	(116042, 112, '2015-03-15 00:30:46.000000', 'temperatura', 112.0000, 'ºC'),
	(116043, 112, '2015-03-15 00:30:47.000000', 'temperatura', 872.0000, 'ºC'),
	(116044, 112, '2015-03-15 00:30:48.000000', 'temperatura', 426.0000, 'ºC'),
	(116045, 112, '2015-03-15 00:30:49.000000', 'temperatura', 714.0000, 'ºC'),
	(116046, 112, '2015-03-15 00:30:50.000000', 'temperatura', 1094.0000, 'ºC'),
	(116047, 112, '2015-03-15 00:30:51.000000', 'temperatura', 928.0000, 'ºC'),
	(116048, 112, '2015-03-15 00:30:52.000000', 'temperatura', 160.0000, 'ºC'),
	(116049, 112, '2015-03-15 00:30:53.000000', 'temperatura', 416.0000, 'ºC'),
	(116050, 112, '2015-03-15 00:30:54.000000', 'temperatura', 402.0000, 'ºC'),
	(116051, 112, '2015-03-15 00:30:55.000000', 'temperatura', 760.0000, 'ºC'),
	(116052, 112, '2015-03-15 00:30:56.000000', 'temperatura', 194.0000, 'ºC'),
	(116053, 112, '2015-03-15 00:30:57.000000', 'temperatura', 1092.0000, 'ºC'),
	(116054, 112, '2015-03-15 00:30:58.000000', 'temperatura', 78.0000, 'ºC'),
	(116055, 112, '2015-03-15 00:30:59.000000', 'temperatura', 713.0000, 'ºC'),
	(116056, 112, '2015-03-15 00:31:00.000000', 'temperatura', 932.0000, 'ºC'),
	(116057, 112, '2015-03-15 00:31:01.000000', 'temperatura', 124.0000, 'ºC'),
	(116058, 112, '2015-03-15 00:31:02.000000', 'temperatura', 221.0000, 'ºC'),
	(116059, 112, '2015-03-15 00:31:03.000000', 'temperatura', 736.0000, 'ºC'),
	(116060, 112, '2015-03-15 00:31:04.000000', 'temperatura', 616.0000, 'ºC'),
	(116061, 112, '2015-03-15 00:31:05.000000', 'temperatura', 871.0000, 'ºC'),
	(116062, 112, '2015-03-15 00:31:06.000000', 'temperatura', 110.0000, 'ºC'),
	(116063, 112, '2015-03-15 00:31:07.000000', 'temperatura', 336.0000, 'ºC'),
	(116064, 112, '2015-03-15 00:31:08.000000', 'temperatura', 152.0000, 'ºC'),
	(116065, 112, '2015-03-15 00:31:09.000000', 'temperatura', 953.0000, 'ºC'),
	(116066, 112, '2015-03-15 00:31:10.000000', 'temperatura', 708.0000, 'ºC'),
	(116067, 112, '2015-03-15 00:31:11.000000', 'temperatura', 683.0000, 'ºC'),
	(116068, 112, '2015-03-15 00:31:12.000000', 'temperatura', 89.0000, 'ºC'),
	(116069, 112, '2015-03-15 00:31:13.000000', 'temperatura', 799.0000, 'ºC'),
	(116070, 112, '2015-03-15 00:31:14.000000', 'temperatura', 128.0000, 'ºC'),
	(116071, 112, '2015-03-15 00:31:15.000000', 'temperatura', 644.0000, 'ºC'),
	(116072, 112, '2015-03-15 00:31:16.000000', 'temperatura', 434.0000, 'ºC'),
	(116073, 112, '2015-03-15 00:31:17.000000', 'temperatura', 240.0000, 'ºC'),
	(116074, 112, '2015-03-15 00:31:18.000000', 'temperatura', 1097.0000, 'ºC'),
	(116075, 112, '2015-03-15 00:31:19.000000', 'temperatura', 1164.0000, 'ºC'),
	(116076, 112, '2015-03-15 00:31:20.000000', 'temperatura', 133.0000, 'ºC'),
	(116077, 112, '2015-03-15 00:31:21.000000', 'temperatura', 771.0000, 'ºC'),
	(116078, 112, '2015-03-15 00:31:22.000000', 'temperatura', 1058.0000, 'ºC'),
	(116079, 112, '2015-03-15 00:31:23.000000', 'temperatura', 576.0000, 'ºC'),
	(116080, 112, '2015-03-15 00:31:24.000000', 'temperatura', 908.0000, 'ºC'),
	(116081, 112, '2015-03-15 00:31:25.000000', 'temperatura', 414.0000, 'ºC'),
	(116082, 112, '2015-03-15 00:31:26.000000', 'temperatura', 543.0000, 'ºC'),
	(116083, 112, '2015-03-15 00:31:27.000000', 'temperatura', 275.0000, 'ºC'),
	(116084, 112, '2015-03-15 00:31:28.000000', 'temperatura', 947.0000, 'ºC'),
	(116085, 112, '2015-03-15 00:31:29.000000', 'temperatura', 310.0000, 'ºC'),
	(116086, 112, '2015-03-15 00:31:30.000000', 'temperatura', 1108.0000, 'ºC'),
	(116087, 112, '2015-03-15 00:31:31.000000', 'temperatura', 1012.0000, 'ºC'),
	(116088, 112, '2015-03-15 00:31:32.000000', 'temperatura', 535.0000, 'ºC'),
	(116089, 112, '2015-03-15 00:31:33.000000', 'temperatura', 842.0000, 'ºC'),
	(116090, 112, '2015-03-15 00:31:34.000000', 'temperatura', 203.0000, 'ºC'),
	(116091, 112, '2015-03-15 00:31:35.000000', 'temperatura', 892.0000, 'ºC'),
	(116092, 112, '2015-03-15 00:31:36.000000', 'temperatura', 252.0000, 'ºC'),
	(116093, 112, '2015-03-15 00:31:37.000000', 'temperatura', 985.0000, 'ºC'),
	(116094, 112, '2015-03-15 00:31:38.000000', 'temperatura', 567.0000, 'ºC'),
	(116095, 112, '2015-03-15 00:31:39.000000', 'temperatura', 1081.0000, 'ºC'),
	(116096, 112, '2015-03-15 00:31:40.000000', 'temperatura', 105.0000, 'ºC'),
	(116097, 112, '2015-03-15 00:31:41.000000', 'temperatura', 882.0000, 'ºC'),
	(116098, 112, '2015-03-15 00:31:42.000000', 'temperatura', 496.0000, 'ºC'),
	(116099, 112, '2015-03-15 00:31:43.000000', 'temperatura', 1034.0000, 'ºC'),
	(116100, 112, '2015-03-15 00:31:44.000000', 'temperatura', 82.0000, 'ºC'),
	(116101, 112, '2015-03-15 00:31:45.000000', 'temperatura', 908.0000, 'ºC'),
	(116102, 112, '2015-03-15 00:31:46.000000', 'temperatura', 695.0000, 'ºC'),
	(116103, 112, '2015-03-15 00:31:47.000000', 'temperatura', 750.0000, 'ºC'),
	(116104, 112, '2015-03-15 00:31:48.000000', 'temperatura', 468.0000, 'ºC'),
	(116105, 112, '2015-03-15 00:31:49.000000', 'temperatura', 89.0000, 'ºC'),
	(116106, 112, '2015-03-15 00:31:50.000000', 'temperatura', 243.0000, 'ºC'),
	(116107, 112, '2015-03-15 00:31:51.000000', 'temperatura', 948.0000, 'ºC'),
	(116108, 112, '2015-03-15 00:31:52.000000', 'temperatura', 413.0000, 'ºC'),
	(116109, 112, '2015-03-15 00:31:53.000000', 'temperatura', 419.0000, 'ºC'),
	(116110, 112, '2015-03-15 00:31:54.000000', 'temperatura', 857.0000, 'ºC'),
	(116111, 112, '2015-03-15 00:31:55.000000', 'temperatura', 630.0000, 'ºC'),
	(116112, 112, '2015-03-15 00:31:56.000000', 'temperatura', 580.0000, 'ºC'),
	(116113, 112, '2015-03-15 00:31:57.000000', 'temperatura', 1010.0000, 'ºC'),
	(116114, 112, '2015-03-15 00:31:58.000000', 'temperatura', 910.0000, 'ºC'),
	(116115, 112, '2015-03-15 00:31:59.000000', 'temperatura', 321.0000, 'ºC'),
	(116116, 112, '2015-03-15 00:32:00.000000', 'temperatura', 77.0000, 'ºC'),
	(116117, 112, '2015-03-15 00:32:01.000000', 'temperatura', 620.0000, 'ºC'),
	(116118, 112, '2015-03-15 00:32:02.000000', 'temperatura', 471.0000, 'ºC'),
	(116119, 112, '2015-03-15 00:32:03.000000', 'temperatura', 497.0000, 'ºC'),
	(116120, 112, '2015-03-15 00:32:04.000000', 'temperatura', 1070.0000, 'ºC'),
	(116121, 112, '2015-03-15 00:32:05.000000', 'temperatura', 259.0000, 'ºC'),
	(116122, 112, '2015-03-15 00:32:06.000000', 'temperatura', 488.0000, 'ºC'),
	(116123, 112, '2015-03-15 00:32:07.000000', 'temperatura', 462.0000, 'ºC'),
	(116124, 112, '2015-03-15 00:32:08.000000', 'temperatura', 845.0000, 'ºC'),
	(116125, 112, '2015-03-15 00:32:09.000000', 'temperatura', 443.0000, 'ºC'),
	(116126, 112, '2015-03-15 00:32:10.000000', 'temperatura', 878.0000, 'ºC'),
	(116127, 112, '2015-03-15 00:32:11.000000', 'temperatura', 663.0000, 'ºC'),
	(116128, 112, '2015-03-15 00:32:12.000000', 'temperatura', 681.0000, 'ºC'),
	(116129, 112, '2015-03-15 00:32:13.000000', 'temperatura', 215.0000, 'ºC'),
	(116130, 112, '2015-03-15 00:32:14.000000', 'temperatura', 234.0000, 'ºC'),
	(116131, 112, '2015-03-15 00:32:15.000000', 'temperatura', 526.0000, 'ºC'),
	(116132, 112, '2015-03-15 00:32:16.000000', 'temperatura', 730.0000, 'ºC'),
	(116133, 112, '2015-03-15 00:32:17.000000', 'temperatura', 870.0000, 'ºC'),
	(116134, 112, '2015-03-15 00:32:18.000000', 'temperatura', 960.0000, 'ºC'),
	(116135, 112, '2015-03-15 00:32:19.000000', 'temperatura', 992.0000, 'ºC'),
	(116136, 112, '2015-03-15 00:32:20.000000', 'temperatura', 880.0000, 'ºC'),
	(116137, 112, '2015-03-15 00:32:21.000000', 'temperatura', 223.0000, 'ºC'),
	(116138, 112, '2015-03-15 00:32:22.000000', 'temperatura', 879.0000, 'ºC'),
	(116139, 112, '2015-03-15 00:32:23.000000', 'temperatura', 123.0000, 'ºC'),
	(116140, 112, '2015-03-15 00:32:24.000000', 'temperatura', 380.0000, 'ºC'),
	(116141, 112, '2015-03-15 00:32:25.000000', 'temperatura', 331.0000, 'ºC'),
	(116142, 112, '2015-03-15 00:32:26.000000', 'temperatura', 517.0000, 'ºC'),
	(116143, 112, '2015-03-15 00:32:27.000000', 'temperatura', 394.0000, 'ºC'),
	(116144, 112, '2015-03-15 00:32:28.000000', 'temperatura', 416.0000, 'ºC'),
	(116145, 112, '2015-03-15 00:32:29.000000', 'temperatura', 900.0000, 'ºC'),
	(116146, 112, '2015-03-15 00:32:30.000000', 'temperatura', 853.0000, 'ºC'),
	(116147, 112, '2015-03-15 00:32:31.000000', 'temperatura', 364.0000, 'ºC'),
	(116148, 112, '2015-03-15 00:32:32.000000', 'temperatura', 461.0000, 'ºC'),
	(116149, 112, '2015-03-15 00:32:33.000000', 'temperatura', 13.0000, 'ºC'),
	(116150, 112, '2015-03-15 00:32:34.000000', 'temperatura', 1083.0000, 'ºC'),
	(116151, 112, '2015-03-15 00:32:35.000000', 'temperatura', 577.0000, 'ºC'),
	(116152, 112, '2015-03-15 00:32:36.000000', 'temperatura', 835.0000, 'ºC'),
	(116153, 112, '2015-03-15 00:32:37.000000', 'temperatura', 44.0000, 'ºC'),
	(116154, 112, '2015-03-15 00:32:38.000000', 'temperatura', 117.0000, 'ºC'),
	(116155, 112, '2015-03-15 00:32:39.000000', 'temperatura', 454.0000, 'ºC'),
	(116156, 112, '2015-03-15 00:32:40.000000', 'temperatura', 721.0000, 'ºC'),
	(116157, 112, '2015-03-15 00:32:41.000000', 'temperatura', 1040.0000, 'ºC'),
	(116158, 112, '2015-03-15 00:32:42.000000', 'temperatura', 639.0000, 'ºC'),
	(116159, 112, '2015-03-15 00:32:43.000000', 'temperatura', 75.0000, 'ºC'),
	(116160, 112, '2015-03-15 00:32:44.000000', 'temperatura', 859.0000, 'ºC'),
	(116161, 112, '2015-03-15 00:32:45.000000', 'temperatura', 470.0000, 'ºC'),
	(116162, 112, '2015-03-15 00:32:46.000000', 'temperatura', 973.0000, 'ºC'),
	(116163, 112, '2015-03-15 00:32:47.000000', 'temperatura', 1056.0000, 'ºC'),
	(116164, 112, '2015-03-15 00:32:48.000000', 'temperatura', 1161.0000, 'ºC'),
	(116165, 112, '2015-03-15 00:32:49.000000', 'temperatura', 238.0000, 'ºC'),
	(116166, 112, '2015-03-15 00:32:50.000000', 'temperatura', 106.0000, 'ºC'),
	(116167, 112, '2015-03-15 00:32:51.000000', 'temperatura', 1016.0000, 'ºC'),
	(116168, 112, '2015-03-15 00:32:52.000000', 'temperatura', 1165.0000, 'ºC'),
	(116169, 112, '2015-03-15 00:32:53.000000', 'temperatura', 378.0000, 'ºC'),
	(116170, 112, '2015-03-15 00:32:54.000000', 'temperatura', 794.0000, 'ºC'),
	(116171, 112, '2015-03-15 00:32:55.000000', 'temperatura', 438.0000, 'ºC'),
	(116172, 112, '2015-03-15 00:32:56.000000', 'temperatura', 1009.0000, 'ºC'),
	(116173, 112, '2015-03-15 00:32:57.000000', 'temperatura', 132.0000, 'ºC'),
	(116174, 112, '2015-03-15 00:32:58.000000', 'temperatura', 32.0000, 'ºC'),
	(116175, 112, '2015-03-15 00:32:59.000000', 'temperatura', 966.0000, 'ºC'),
	(116176, 112, '2015-03-15 00:33:00.000000', 'temperatura', 1133.0000, 'ºC'),
	(116177, 112, '2015-03-15 00:33:01.000000', 'temperatura', 368.0000, 'ºC'),
	(116178, 112, '2015-03-15 00:33:02.000000', 'temperatura', 841.0000, 'ºC'),
	(116179, 112, '2015-03-15 00:33:03.000000', 'temperatura', 701.0000, 'ºC'),
	(116180, 112, '2015-03-15 00:33:04.000000', 'temperatura', 985.0000, 'ºC'),
	(116181, 112, '2015-03-15 00:33:05.000000', 'temperatura', 422.0000, 'ºC'),
	(116182, 112, '2015-03-15 00:33:06.000000', 'temperatura', 355.0000, 'ºC'),
	(116183, 112, '2015-03-15 00:33:07.000000', 'temperatura', 508.0000, 'ºC'),
	(116184, 112, '2015-03-15 00:33:08.000000', 'temperatura', 275.0000, 'ºC'),
	(116185, 112, '2015-03-15 00:33:09.000000', 'temperatura', 1054.0000, 'ºC'),
	(116186, 112, '2015-03-15 00:33:10.000000', 'temperatura', 846.0000, 'ºC'),
	(116187, 112, '2015-03-15 00:33:11.000000', 'temperatura', 1068.0000, 'ºC'),
	(116188, 112, '2015-03-15 00:33:12.000000', 'temperatura', 402.0000, 'ºC'),
	(116189, 112, '2015-03-15 00:33:13.000000', 'temperatura', 8.0000, 'ºC'),
	(116190, 112, '2015-03-15 00:33:14.000000', 'temperatura', 35.0000, 'ºC'),
	(116191, 112, '2015-03-15 00:33:15.000000', 'temperatura', 152.0000, 'ºC'),
	(116192, 112, '2015-03-15 00:33:16.000000', 'temperatura', 656.0000, 'ºC'),
	(116193, 112, '2015-03-15 00:33:17.000000', 'temperatura', 425.0000, 'ºC'),
	(116194, 112, '2015-03-15 00:33:18.000000', 'temperatura', 156.0000, 'ºC'),
	(116195, 112, '2015-03-15 00:33:19.000000', 'temperatura', 705.0000, 'ºC'),
	(116196, 112, '2015-03-15 00:33:20.000000', 'temperatura', 657.0000, 'ºC'),
	(116197, 112, '2015-03-15 00:33:21.000000', 'temperatura', 1171.0000, 'ºC'),
	(116198, 112, '2015-03-15 00:33:22.000000', 'temperatura', 283.0000, 'ºC'),
	(116199, 112, '2015-03-15 00:33:23.000000', 'temperatura', 304.0000, 'ºC'),
	(116200, 112, '2015-03-15 00:33:24.000000', 'temperatura', 671.0000, 'ºC'),
	(116201, 112, '2015-03-15 00:33:25.000000', 'temperatura', 46.0000, 'ºC'),
	(116202, 112, '2015-03-15 00:33:26.000000', 'temperatura', 614.0000, 'ºC'),
	(116203, 112, '2015-03-15 00:33:27.000000', 'temperatura', 535.0000, 'ºC'),
	(116204, 112, '2015-03-15 00:33:28.000000', 'temperatura', 832.0000, 'ºC'),
	(116205, 112, '2015-03-15 00:33:29.000000', 'temperatura', 158.0000, 'ºC'),
	(116206, 112, '2015-03-15 00:33:30.000000', 'temperatura', 693.0000, 'ºC'),
	(116207, 112, '2015-03-15 00:33:31.000000', 'temperatura', 592.0000, 'ºC'),
	(116208, 112, '2015-03-15 00:33:32.000000', 'temperatura', 880.0000, 'ºC'),
	(116209, 112, '2015-03-15 00:33:33.000000', 'temperatura', 224.0000, 'ºC'),
	(116210, 112, '2015-03-15 00:33:34.000000', 'temperatura', 880.0000, 'ºC'),
	(116211, 112, '2015-03-15 00:33:35.000000', 'temperatura', 132.0000, 'ºC'),
	(116212, 112, '2015-03-15 00:33:36.000000', 'temperatura', 417.0000, 'ºC'),
	(116213, 112, '2015-03-15 00:33:37.000000', 'temperatura', 492.0000, 'ºC'),
	(116214, 112, '2015-03-15 00:33:38.000000', 'temperatura', 7.0000, 'ºC'),
	(116215, 112, '2015-03-15 00:33:39.000000', 'temperatura', 959.0000, 'ºC'),
	(116216, 112, '2015-03-15 00:33:40.000000', 'temperatura', 1176.0000, 'ºC'),
	(116217, 112, '2015-03-15 00:33:41.000000', 'temperatura', 601.0000, 'ºC'),
	(116218, 112, '2015-03-15 00:33:42.000000', 'temperatura', 680.0000, 'ºC'),
	(116219, 112, '2015-03-15 00:33:43.000000', 'temperatura', 398.0000, 'ºC'),
	(116220, 112, '2015-03-15 00:33:44.000000', 'temperatura', 1150.0000, 'ºC'),
	(116221, 112, '2015-03-15 00:33:45.000000', 'temperatura', 955.0000, 'ºC'),
	(116222, 112, '2015-03-15 00:33:46.000000', 'temperatura', 127.0000, 'ºC'),
	(116223, 112, '2015-03-15 00:33:47.000000', 'temperatura', 171.0000, 'ºC'),
	(116224, 112, '2015-03-15 00:33:48.000000', 'temperatura', 473.0000, 'ºC'),
	(116225, 112, '2015-03-15 00:33:49.000000', 'temperatura', 653.0000, 'ºC'),
	(116226, 112, '2015-03-15 00:33:50.000000', 'temperatura', 647.0000, 'ºC'),
	(116227, 112, '2015-03-15 00:33:51.000000', 'temperatura', 78.0000, 'ºC'),
	(116228, 112, '2015-03-15 00:33:52.000000', 'temperatura', 848.0000, 'ºC'),
	(116229, 112, '2015-03-15 00:33:53.000000', 'temperatura', 407.0000, 'ºC'),
	(116230, 112, '2015-03-15 00:33:54.000000', 'temperatura', 690.0000, 'ºC'),
	(116231, 112, '2015-03-15 00:33:55.000000', 'temperatura', 1029.0000, 'ºC'),
	(116232, 112, '2015-03-15 00:33:56.000000', 'temperatura', 678.0000, 'ºC'),
	(116233, 112, '2015-03-15 00:33:57.000000', 'temperatura', 303.0000, 'ºC'),
	(116234, 112, '2015-03-15 00:33:58.000000', 'temperatura', 682.0000, 'ºC'),
	(116235, 112, '2015-03-15 00:33:59.000000', 'temperatura', 102.0000, 'ºC'),
	(116236, 112, '2015-03-15 00:34:00.000000', 'temperatura', 864.0000, 'ºC'),
	(116237, 112, '2015-03-15 00:34:01.000000', 'temperatura', 413.0000, 'ºC'),
	(116238, 112, '2015-03-15 00:34:02.000000', 'temperatura', 673.0000, 'ºC'),
	(116239, 112, '2015-03-15 00:34:03.000000', 'temperatura', 926.0000, 'ºC'),
	(116240, 112, '2015-03-15 00:34:04.000000', 'temperatura', 212.0000, 'ºC'),
	(116241, 112, '2015-03-15 00:34:05.000000', 'temperatura', 684.0000, 'ºC'),
	(116242, 112, '2015-03-15 00:34:06.000000', 'temperatura', 385.0000, 'ºC'),
	(116243, 112, '2015-03-15 00:34:07.000000', 'temperatura', 1073.0000, 'ºC'),
	(116244, 112, '2015-03-15 00:34:08.000000', 'temperatura', 609.0000, 'ºC'),
	(116245, 112, '2015-03-15 00:34:09.000000', 'temperatura', 1028.0000, 'ºC'),
	(116246, 112, '2015-03-15 00:34:10.000000', 'temperatura', 915.0000, 'ºC'),
	(116247, 112, '2015-03-15 00:34:11.000000', 'temperatura', 288.0000, 'ºC'),
	(116248, 112, '2015-03-15 00:34:12.000000', 'temperatura', 1099.0000, 'ºC'),
	(116249, 112, '2015-03-15 00:34:13.000000', 'temperatura', 1030.0000, 'ºC'),
	(116250, 112, '2015-03-15 00:34:14.000000', 'temperatura', 654.0000, 'ºC'),
	(116251, 112, '2015-03-15 00:34:15.000000', 'temperatura', 179.0000, 'ºC'),
	(116252, 112, '2015-03-15 00:34:16.000000', 'temperatura', 133.0000, 'ºC'),
	(116253, 112, '2015-03-15 00:34:17.000000', 'temperatura', 130.0000, 'ºC'),
	(116254, 112, '2015-03-15 00:34:18.000000', 'temperatura', 252.0000, 'ºC'),
	(116255, 112, '2015-03-15 00:34:19.000000', 'temperatura', 871.0000, 'ºC'),
	(116256, 112, '2015-03-15 00:34:20.000000', 'temperatura', 1198.0000, 'ºC'),
	(116257, 112, '2015-03-15 00:34:21.000000', 'temperatura', 980.0000, 'ºC'),
	(116258, 112, '2015-03-15 00:34:22.000000', 'temperatura', 104.0000, 'ºC'),
	(116259, 112, '2015-03-15 00:34:23.000000', 'temperatura', 1183.0000, 'ºC'),
	(116260, 112, '2015-03-15 00:34:24.000000', 'temperatura', 804.0000, 'ºC'),
	(116261, 112, '2015-03-15 00:34:25.000000', 'temperatura', 469.0000, 'ºC'),
	(116262, 112, '2015-03-15 00:34:26.000000', 'temperatura', 1134.0000, 'ºC'),
	(116263, 112, '2015-03-15 00:34:27.000000', 'temperatura', 664.0000, 'ºC'),
	(116264, 112, '2015-03-15 00:34:28.000000', 'temperatura', 1120.0000, 'ºC'),
	(116265, 112, '2015-03-15 00:34:29.000000', 'temperatura', 7.0000, 'ºC'),
	(116266, 112, '2015-03-15 00:34:30.000000', 'temperatura', 277.0000, 'ºC'),
	(116267, 112, '2015-03-15 00:34:31.000000', 'temperatura', 163.0000, 'ºC'),
	(116268, 112, '2015-03-15 00:34:32.000000', 'temperatura', 1183.0000, 'ºC'),
	(116269, 112, '2015-03-15 00:34:33.000000', 'temperatura', 629.0000, 'ºC'),
	(116270, 112, '2015-03-15 00:34:34.000000', 'temperatura', 795.0000, 'ºC'),
	(116271, 112, '2015-03-15 00:34:35.000000', 'temperatura', 889.0000, 'ºC'),
	(116272, 112, '2015-03-15 00:34:36.000000', 'temperatura', 860.0000, 'ºC'),
	(116273, 112, '2015-03-15 00:34:37.000000', 'temperatura', 435.0000, 'ºC'),
	(116274, 112, '2015-03-15 00:34:38.000000', 'temperatura', 796.0000, 'ºC'),
	(116275, 112, '2015-03-15 00:34:39.000000', 'temperatura', 273.0000, 'ºC'),
	(116276, 112, '2015-03-15 00:34:40.000000', 'temperatura', 178.0000, 'ºC'),
	(116277, 112, '2015-03-15 00:34:41.000000', 'temperatura', 70.0000, 'ºC'),
	(116278, 112, '2015-03-15 00:34:42.000000', 'temperatura', 1018.0000, 'ºC'),
	(116279, 112, '2015-03-15 00:34:43.000000', 'temperatura', 79.0000, 'ºC'),
	(116280, 112, '2015-03-15 00:34:44.000000', 'temperatura', 944.0000, 'ºC'),
	(116281, 112, '2015-03-15 00:34:45.000000', 'temperatura', 881.0000, 'ºC'),
	(116282, 112, '2015-03-15 00:34:46.000000', 'temperatura', 374.0000, 'ºC'),
	(116283, 112, '2015-03-15 00:34:47.000000', 'temperatura', 429.0000, 'ºC'),
	(116284, 112, '2015-03-15 00:34:48.000000', 'temperatura', 1021.0000, 'ºC'),
	(116285, 112, '2015-03-15 00:34:49.000000', 'temperatura', 218.0000, 'ºC'),
	(116286, 112, '2015-03-15 00:34:50.000000', 'temperatura', 431.0000, 'ºC'),
	(116287, 112, '2015-03-15 00:34:51.000000', 'temperatura', 299.0000, 'ºC'),
	(116288, 112, '2015-03-15 00:34:52.000000', 'temperatura', 203.0000, 'ºC'),
	(116289, 112, '2015-03-15 00:34:53.000000', 'temperatura', 119.0000, 'ºC'),
	(116290, 112, '2015-03-15 00:34:54.000000', 'temperatura', 1185.0000, 'ºC'),
	(116291, 112, '2015-03-15 00:34:55.000000', 'temperatura', 769.0000, 'ºC'),
	(116292, 112, '2015-03-15 00:34:56.000000', 'temperatura', 292.0000, 'ºC'),
	(116293, 112, '2015-03-15 00:34:57.000000', 'temperatura', 354.0000, 'ºC'),
	(116294, 112, '2015-03-15 00:34:58.000000', 'temperatura', 892.0000, 'ºC'),
	(116295, 112, '2015-03-15 00:34:59.000000', 'temperatura', 999.0000, 'ºC'),
	(116296, 112, '2015-03-15 00:35:00.000000', 'temperatura', 1119.0000, 'ºC'),
	(116297, 112, '2015-03-15 00:35:01.000000', 'temperatura', 199.0000, 'ºC'),
	(116298, 112, '2015-03-15 00:35:02.000000', 'temperatura', 40.0000, 'ºC'),
	(116299, 112, '2015-03-15 00:35:03.000000', 'temperatura', 802.0000, 'ºC'),
	(116300, 112, '2015-03-15 00:35:04.000000', 'temperatura', 290.0000, 'ºC'),
	(116301, 112, '2015-03-15 00:35:05.000000', 'temperatura', 247.0000, 'ºC'),
	(116302, 112, '2015-03-15 00:35:06.000000', 'temperatura', 363.0000, 'ºC'),
	(116303, 112, '2015-03-15 00:35:07.000000', 'temperatura', 1076.0000, 'ºC'),
	(116304, 112, '2015-03-15 00:35:08.000000', 'temperatura', 689.0000, 'ºC'),
	(116305, 112, '2015-03-15 00:35:09.000000', 'temperatura', 221.0000, 'ºC'),
	(116306, 112, '2015-03-15 00:35:10.000000', 'temperatura', 235.0000, 'ºC'),
	(116307, 112, '2015-03-15 00:35:11.000000', 'temperatura', 514.0000, 'ºC'),
	(116308, 112, '2015-03-15 00:35:12.000000', 'temperatura', 666.0000, 'ºC'),
	(116309, 112, '2015-03-15 00:35:13.000000', 'temperatura', 589.0000, 'ºC'),
	(116310, 112, '2015-03-15 00:35:14.000000', 'temperatura', 946.0000, 'ºC'),
	(116311, 112, '2015-03-15 00:35:15.000000', 'temperatura', 562.0000, 'ºC'),
	(116312, 112, '2015-03-15 00:35:16.000000', 'temperatura', 1175.0000, 'ºC'),
	(116313, 112, '2015-03-15 00:35:17.000000', 'temperatura', 589.0000, 'ºC'),
	(116314, 112, '2015-03-15 00:35:18.000000', 'temperatura', 622.0000, 'ºC'),
	(116315, 112, '2015-03-15 00:35:19.000000', 'temperatura', 142.0000, 'ºC'),
	(116316, 112, '2015-03-15 00:35:20.000000', 'temperatura', 43.0000, 'ºC'),
	(116317, 112, '2015-03-15 00:35:21.000000', 'temperatura', 993.0000, 'ºC'),
	(116318, 112, '2015-03-15 00:35:22.000000', 'temperatura', 34.0000, 'ºC'),
	(116319, 112, '2015-03-15 00:35:23.000000', 'temperatura', 793.0000, 'ºC'),
	(116320, 112, '2015-03-15 00:35:24.000000', 'temperatura', 262.0000, 'ºC'),
	(116321, 112, '2015-03-15 00:35:25.000000', 'temperatura', 133.0000, 'ºC'),
	(116322, 112, '2015-03-15 00:35:26.000000', 'temperatura', 1078.0000, 'ºC'),
	(116323, 112, '2015-03-15 00:35:27.000000', 'temperatura', 193.0000, 'ºC'),
	(116324, 112, '2015-03-15 00:35:28.000000', 'temperatura', 132.0000, 'ºC'),
	(116325, 112, '2015-03-15 00:35:29.000000', 'temperatura', 79.0000, 'ºC'),
	(116326, 112, '2015-03-15 00:35:30.000000', 'temperatura', 3.0000, 'ºC'),
	(116327, 112, '2015-03-15 00:35:31.000000', 'temperatura', 976.0000, 'ºC'),
	(116328, 112, '2015-03-15 00:35:32.000000', 'temperatura', 71.0000, 'ºC'),
	(116329, 112, '2015-03-15 00:35:33.000000', 'temperatura', 1027.0000, 'ºC'),
	(116330, 112, '2015-03-15 00:35:34.000000', 'temperatura', 125.0000, 'ºC'),
	(116331, 112, '2015-03-15 00:35:35.000000', 'temperatura', 1142.0000, 'ºC'),
	(116332, 112, '2015-03-15 00:35:36.000000', 'temperatura', 538.0000, 'ºC'),
	(116333, 112, '2015-03-15 00:35:37.000000', 'temperatura', 461.0000, 'ºC'),
	(116334, 112, '2015-03-15 00:35:38.000000', 'temperatura', 695.0000, 'ºC'),
	(116335, 112, '2015-03-15 00:35:39.000000', 'temperatura', 891.0000, 'ºC'),
	(116336, 112, '2015-03-15 00:35:40.000000', 'temperatura', 1170.0000, 'ºC'),
	(116337, 112, '2015-03-15 00:35:41.000000', 'temperatura', 778.0000, 'ºC'),
	(116338, 112, '2015-03-15 00:35:42.000000', 'temperatura', 381.0000, 'ºC'),
	(116339, 112, '2015-03-15 00:35:43.000000', 'temperatura', 770.0000, 'ºC'),
	(116340, 112, '2015-03-15 00:35:44.000000', 'temperatura', 310.0000, 'ºC'),
	(116341, 112, '2015-03-15 00:35:45.000000', 'temperatura', 441.0000, 'ºC'),
	(116342, 112, '2015-03-15 00:35:46.000000', 'temperatura', 73.0000, 'ºC'),
	(116343, 112, '2015-03-15 00:35:47.000000', 'temperatura', 244.0000, 'ºC'),
	(116344, 112, '2015-03-15 00:35:48.000000', 'temperatura', 1000.0000, 'ºC'),
	(116345, 112, '2015-03-15 00:35:49.000000', 'temperatura', 669.0000, 'ºC'),
	(116346, 112, '2015-03-15 00:35:50.000000', 'temperatura', 345.0000, 'ºC'),
	(116347, 112, '2015-03-15 00:35:51.000000', 'temperatura', 920.0000, 'ºC'),
	(116348, 112, '2015-03-15 00:35:52.000000', 'temperatura', 1165.0000, 'ºC'),
	(116349, 112, '2015-03-15 00:35:53.000000', 'temperatura', 667.0000, 'ºC'),
	(116350, 112, '2015-03-15 00:35:54.000000', 'temperatura', 1040.0000, 'ºC'),
	(116351, 112, '2015-03-15 00:35:55.000000', 'temperatura', 800.0000, 'ºC'),
	(116352, 112, '2015-03-15 00:35:56.000000', 'temperatura', 882.0000, 'ºC'),
	(116353, 112, '2015-03-15 00:35:57.000000', 'temperatura', 807.0000, 'ºC'),
	(116354, 112, '2015-03-15 00:35:58.000000', 'temperatura', 193.0000, 'ºC'),
	(116355, 112, '2015-03-15 00:35:59.000000', 'temperatura', 943.0000, 'ºC'),
	(116356, 112, '2015-03-15 00:36:00.000000', 'temperatura', 536.0000, 'ºC'),
	(116357, 112, '2015-03-15 00:36:01.000000', 'temperatura', 1053.0000, 'ºC'),
	(116358, 112, '2015-03-15 00:36:02.000000', 'temperatura', 57.0000, 'ºC'),
	(116359, 112, '2015-03-15 00:36:03.000000', 'temperatura', 724.0000, 'ºC'),
	(116360, 112, '2015-03-15 00:36:04.000000', 'temperatura', 1052.0000, 'ºC'),
	(116361, 112, '2015-03-15 00:36:05.000000', 'temperatura', 688.0000, 'ºC'),
	(116362, 112, '2015-03-15 00:36:06.000000', 'temperatura', 285.0000, 'ºC'),
	(116363, 112, '2015-03-15 00:36:07.000000', 'temperatura', 561.0000, 'ºC'),
	(116364, 112, '2015-03-15 00:36:08.000000', 'temperatura', 749.0000, 'ºC'),
	(116365, 112, '2015-03-15 00:36:09.000000', 'temperatura', 863.0000, 'ºC'),
	(116366, 112, '2015-03-15 00:36:10.000000', 'temperatura', 869.0000, 'ºC'),
	(116367, 112, '2015-03-15 00:36:11.000000', 'temperatura', 557.0000, 'ºC'),
	(116368, 112, '2015-03-15 00:36:12.000000', 'temperatura', 177.0000, 'ºC'),
	(116369, 112, '2015-03-15 00:36:13.000000', 'temperatura', 414.0000, 'ºC'),
	(116370, 112, '2015-03-15 00:36:14.000000', 'temperatura', 339.0000, 'ºC'),
	(116371, 112, '2015-03-15 00:36:15.000000', 'temperatura', 455.0000, 'ºC'),
	(116372, 112, '2015-03-15 00:36:16.000000', 'temperatura', 60.0000, 'ºC'),
	(116373, 112, '2015-03-15 00:36:17.000000', 'temperatura', 135.0000, 'ºC'),
	(116374, 112, '2015-03-15 00:36:18.000000', 'temperatura', 493.0000, 'ºC'),
	(116375, 112, '2015-03-15 00:36:19.000000', 'temperatura', 863.0000, 'ºC'),
	(116376, 112, '2015-03-15 00:36:20.000000', 'temperatura', 437.0000, 'ºC'),
	(116377, 112, '2015-03-15 00:36:21.000000', 'temperatura', 797.0000, 'ºC'),
	(116378, 112, '2015-03-15 00:36:22.000000', 'temperatura', 275.0000, 'ºC'),
	(116379, 112, '2015-03-15 00:36:23.000000', 'temperatura', 182.0000, 'ºC'),
	(116380, 112, '2015-03-15 00:36:24.000000', 'temperatura', 85.0000, 'ºC'),
	(116381, 112, '2015-03-15 00:36:25.000000', 'temperatura', 1080.0000, 'ºC'),
	(116382, 112, '2015-03-15 00:36:26.000000', 'temperatura', 346.0000, 'ºC'),
	(116383, 112, '2015-03-15 00:36:27.000000', 'temperatura', 891.0000, 'ºC'),
	(116384, 112, '2015-03-15 00:36:28.000000', 'temperatura', 1017.0000, 'ºC'),
	(116385, 112, '2015-03-15 00:36:29.000000', 'temperatura', 14.0000, 'ºC'),
	(116386, 112, '2015-03-15 00:36:30.000000', 'temperatura', 616.0000, 'ºC'),
	(116387, 112, '2015-03-15 00:36:31.000000', 'temperatura', 642.0000, 'ºC'),
	(116388, 112, '2015-03-15 00:36:32.000000', 'temperatura', 162.0000, 'ºC'),
	(116389, 112, '2015-03-15 00:36:33.000000', 'temperatura', 83.0000, 'ºC'),
	(116390, 112, '2015-03-15 00:36:34.000000', 'temperatura', 1132.0000, 'ºC'),
	(116391, 112, '2015-03-15 00:36:35.000000', 'temperatura', 611.0000, 'ºC'),
	(116392, 112, '2015-03-15 00:36:36.000000', 'temperatura', 859.0000, 'ºC'),
	(116393, 112, '2015-03-15 00:36:37.000000', 'temperatura', 62.0000, 'ºC'),
	(116394, 112, '2015-03-15 00:36:38.000000', 'temperatura', 133.0000, 'ºC'),
	(116395, 112, '2015-03-15 00:36:39.000000', 'temperatura', 481.0000, 'ºC'),
	(116396, 112, '2015-03-15 00:36:40.000000', 'temperatura', 807.0000, 'ºC'),
	(116397, 112, '2015-03-15 00:36:41.000000', 'temperatura', 193.0000, 'ºC'),
	(116398, 112, '2015-03-15 00:36:42.000000', 'temperatura', 943.0000, 'ºC'),
	(116399, 112, '2015-03-15 00:36:43.000000', 'temperatura', 536.0000, 'ºC'),
	(116400, 112, '2015-03-15 00:36:44.000000', 'temperatura', 1053.0000, 'ºC'),
	(116401, 112, '2015-03-15 00:36:45.000000', 'temperatura', 55.0000, 'ºC'),
	(116402, 112, '2015-03-15 00:36:46.000000', 'temperatura', 719.0000, 'ºC'),
	(116403, 112, '2015-03-15 00:36:47.000000', 'temperatura', 1029.0000, 'ºC'),
	(116404, 112, '2015-03-15 00:36:48.000000', 'temperatura', 588.0000, 'ºC'),
	(116405, 112, '2015-03-15 00:36:49.000000', 'temperatura', 1053.0000, 'ºC'),
	(116406, 112, '2015-03-15 00:36:50.000000', 'temperatura', 1104.0000, 'ºC'),
	(116407, 112, '2015-03-15 00:36:51.000000', 'temperatura', 1159.0000, 'ºC'),
	(116408, 112, '2015-03-15 00:36:52.000000', 'temperatura', 85.0000, 'ºC'),
	(116409, 112, '2015-03-15 00:36:53.000000', 'temperatura', 546.0000, 'ºC'),
	(116410, 112, '2015-03-15 00:36:54.000000', 'temperatura', 78.0000, 'ºC'),
	(116411, 112, '2015-03-15 00:36:55.000000', 'temperatura', 1151.0000, 'ºC'),
	(116412, 112, '2015-03-15 00:36:56.000000', 'temperatura', 720.0000, 'ºC'),
	(116413, 112, '2015-03-15 00:36:57.000000', 'temperatura', 151.0000, 'ºC'),
	(116414, 112, '2015-03-15 00:36:58.000000', 'temperatura', 994.0000, 'ºC'),
	(116415, 112, '2015-03-15 00:36:59.000000', 'temperatura', 919.0000, 'ºC'),
	(116416, 112, '2015-03-15 00:37:00.000000', 'temperatura', 412.0000, 'ºC'),
	(116417, 112, '2015-03-15 00:37:01.000000', 'temperatura', 503.0000, 'ºC'),
	(116418, 112, '2015-03-15 00:37:02.000000', 'temperatura', 81.0000, 'ºC'),
	(116419, 112, '2015-03-15 00:37:03.000000', 'temperatura', 95.0000, 'ºC'),
	(116420, 112, '2015-03-15 00:37:04.000000', 'temperatura', 234.0000, 'ºC'),
	(116421, 112, '2015-03-15 00:37:05.000000', 'temperatura', 884.0000, 'ºC'),
	(116422, 112, '2015-03-15 00:37:06.000000', 'temperatura', 120.0000, 'ºC'),
	(116423, 112, '2015-03-15 00:37:07.000000', 'temperatura', 350.0000, 'ºC'),
	(116424, 112, '2015-03-15 00:37:08.000000', 'temperatura', 188.0000, 'ºC'),
	(116425, 112, '2015-03-15 00:37:09.000000', 'temperatura', 1089.0000, 'ºC'),
	(116426, 112, '2015-03-15 00:37:10.000000', 'temperatura', 84.0000, 'ºC'),
	(116427, 112, '2015-03-15 00:37:11.000000', 'temperatura', 755.0000, 'ºC'),
	(116428, 112, '2015-03-15 00:37:12.000000', 'temperatura', 1120.0000, 'ºC'),
	(116429, 112, '2015-03-15 00:37:13.000000', 'temperatura', 938.0000, 'ºC'),
	(116430, 112, '2015-03-15 00:37:14.000000', 'temperatura', 130.0000, 'ºC'),
	(116431, 112, '2015-03-15 00:37:15.000000', 'temperatura', 237.0000, 'ºC'),
	(116432, 112, '2015-03-15 00:37:16.000000', 'temperatura', 794.0000, 'ºC'),
	(116433, 112, '2015-03-15 00:37:17.000000', 'temperatura', 862.0000, 'ºC'),
	(116434, 112, '2015-03-15 00:37:18.000000', 'temperatura', 725.0000, 'ºC'),
	(116435, 112, '2015-03-15 00:37:19.000000', 'temperatura', 1043.0000, 'ºC'),
	(116436, 112, '2015-03-15 00:37:20.000000', 'temperatura', 640.0000, 'ºC'),
	(116437, 112, '2015-03-15 00:37:21.000000', 'temperatura', 71.0000, 'ºC'),
	(116438, 112, '2015-03-15 00:37:22.000000', 'temperatura', 836.0000, 'ºC'),
	(116439, 112, '2015-03-15 00:37:23.000000', 'temperatura', 366.0000, 'ºC'),
	(116440, 112, '2015-03-15 00:37:24.000000', 'temperatura', 525.0000, 'ºC'),
	(116441, 112, '2015-03-15 00:37:25.000000', 'temperatura', 327.0000, 'ºC'),
	(116442, 112, '2015-03-15 00:37:26.000000', 'temperatura', 59.0000, 'ºC'),
	(116443, 112, '2015-03-15 00:37:27.000000', 'temperatura', 513.0000, 'ºC'),
	(116444, 112, '2015-03-15 00:37:28.000000', 'temperatura', 1191.0000, 'ºC'),
	(116445, 112, '2015-03-15 00:37:29.000000', 'temperatura', 817.0000, 'ºC'),
	(116446, 112, '2015-03-15 00:37:30.000000', 'temperatura', 511.0000, 'ºC'),
	(116447, 112, '2015-03-15 00:37:31.000000', 'temperatura', 105.0000, 'ºC'),
	(116448, 112, '2015-03-15 00:37:32.000000', 'temperatura', 193.0000, 'ºC'),
	(116449, 112, '2015-03-15 00:37:33.000000', 'temperatura', 652.0000, 'ºC'),
	(116450, 112, '2015-03-15 00:37:34.000000', 'temperatura', 280.0000, 'ºC'),
	(116451, 112, '2015-03-15 00:37:35.000000', 'temperatura', 643.0000, 'ºC'),
	(116452, 112, '2015-03-15 00:37:36.000000', 'temperatura', 1177.0000, 'ºC'),
	(116453, 112, '2015-03-15 00:37:37.000000', 'temperatura', 358.0000, 'ºC'),
	(116454, 112, '2015-03-15 00:37:38.000000', 'temperatura', 659.0000, 'ºC'),
	(116455, 112, '2015-03-15 00:37:39.000000', 'temperatura', 1021.0000, 'ºC'),
	(116456, 112, '2015-03-15 00:37:40.000000', 'temperatura', 727.0000, 'ºC'),
	(116457, 112, '2015-03-15 00:37:41.000000', 'temperatura', 572.0000, 'ºC'),
	(116458, 112, '2015-03-15 00:37:42.000000', 'temperatura', 681.0000, 'ºC'),
	(116459, 112, '2015-03-15 00:37:43.000000', 'temperatura', 489.0000, 'ºC'),
	(116460, 112, '2015-03-15 00:37:44.000000', 'temperatura', 404.0000, 'ºC'),
	(116461, 112, '2015-03-15 00:37:45.000000', 'temperatura', 554.0000, 'ºC'),
	(116462, 112, '2015-03-15 00:37:46.000000', 'temperatura', 359.0000, 'ºC'),
	(116463, 112, '2015-03-15 00:37:47.000000', 'temperatura', 132.0000, 'ºC'),
	(116464, 112, '2015-03-15 00:37:48.000000', 'temperatura', 785.0000, 'ºC'),
	(116465, 112, '2015-03-15 00:37:49.000000', 'temperatura', 1129.0000, 'ºC'),
	(116466, 112, '2015-03-15 00:37:50.000000', 'temperatura', 889.0000, 'ºC'),
	(116467, 112, '2015-03-15 00:37:51.000000', 'temperatura', 1059.0000, 'ºC'),
	(116468, 112, '2015-03-15 00:37:52.000000', 'temperatura', 231.0000, 'ºC'),
	(116469, 112, '2015-03-15 00:37:53.000000', 'temperatura', 376.0000, 'ºC'),
	(116470, 112, '2015-03-15 00:37:54.000000', 'temperatura', 1187.0000, 'ºC'),
	(116471, 112, '2015-03-15 00:37:55.000000', 'temperatura', 9.0000, 'ºC'),
	(116472, 112, '2015-03-15 00:37:56.000000', 'temperatura', 83.0000, 'ºC'),
	(116473, 112, '2015-03-15 00:37:57.000000', 'temperatura', 391.0000, 'ºC'),
	(116474, 112, '2015-03-15 00:37:58.000000', 'temperatura', 506.0000, 'ºC'),
	(116475, 112, '2015-03-15 00:37:59.000000', 'temperatura', 158.0000, 'ºC'),
	(116476, 112, '2015-03-15 00:38:00.000000', 'temperatura', 471.0000, 'ºC'),
	(116477, 112, '2015-03-15 00:38:01.000000', 'temperatura', 683.0000, 'ºC'),
	(116478, 112, '2015-03-15 00:38:02.000000', 'temperatura', 801.0000, 'ºC'),
	(116479, 112, '2015-03-15 00:38:03.000000', 'temperatura', 759.0000, 'ºC'),
	(116480, 112, '2015-03-15 00:38:04.000000', 'temperatura', 192.0000, 'ºC'),
	(116481, 112, '2015-03-15 00:38:05.000000', 'temperatura', 1082.0000, 'ºC'),
	(116482, 112, '2015-03-15 00:38:06.000000', 'temperatura', 36.0000, 'ºC'),
	(116483, 112, '2015-03-15 00:38:07.000000', 'temperatura', 535.0000, 'ºC'),
	(116484, 112, '2015-03-15 00:38:08.000000', 'temperatura', 169.0000, 'ºC'),
	(116485, 112, '2015-03-15 00:38:09.000000', 'temperatura', 437.0000, 'ºC'),
	(116486, 112, '2015-03-15 00:38:10.000000', 'temperatura', 480.0000, 'ºC'),
	(116487, 112, '2015-03-15 00:38:11.000000', 'temperatura', 1090.0000, 'ºC'),
	(116488, 112, '2015-03-15 00:38:12.000000', 'temperatura', 412.0000, 'ºC'),
	(116489, 112, '2015-03-15 00:38:13.000000', 'temperatura', 1189.0000, 'ºC'),
	(116490, 112, '2015-03-15 00:38:14.000000', 'temperatura', 1110.0000, 'ºC'),
	(116491, 112, '2015-03-15 00:38:15.000000', 'temperatura', 784.0000, 'ºC'),
	(116492, 112, '2015-03-15 00:38:16.000000', 'temperatura', 592.0000, 'ºC'),
	(116493, 112, '2015-03-15 00:38:17.000000', 'temperatura', 605.0000, 'ºC'),
	(116494, 112, '2015-03-15 00:38:18.000000', 'temperatura', 53.0000, 'ºC'),
	(116495, 112, '2015-03-15 00:38:19.000000', 'temperatura', 848.0000, 'ºC'),
	(116496, 112, '2015-03-15 00:38:20.000000', 'temperatura', 482.0000, 'ºC'),
	(116497, 112, '2015-03-15 00:38:21.000000', 'temperatura', 1066.0000, 'ºC'),
	(116498, 112, '2015-03-15 00:38:22.000000', 'temperatura', 285.0000, 'ºC'),
	(116499, 112, '2015-03-15 00:38:23.000000', 'temperatura', 627.0000, 'ºC'),
	(116500, 112, '2015-03-15 00:38:24.000000', 'temperatura', 1082.0000, 'ºC'),
	(116501, 112, '2015-03-15 00:38:25.000000', 'temperatura', 1127.0000, 'ºC'),
	(116502, 112, '2015-03-15 00:38:26.000000', 'temperatura', 1189.0000, 'ºC'),
	(116503, 112, '2015-03-15 00:38:27.000000', 'temperatura', 166.0000, 'ºC'),
	(116504, 112, '2015-03-15 00:38:28.000000', 'temperatura', 865.0000, 'ºC'),
	(116505, 112, '2015-03-15 00:38:29.000000', 'temperatura', 225.0000, 'ºC'),
	(116506, 112, '2015-03-15 00:38:30.000000', 'temperatura', 930.0000, 'ºC'),
	(116507, 112, '2015-03-15 00:38:31.000000', 'temperatura', 376.0000, 'ºC'),
	(116508, 112, '2015-03-15 00:38:32.000000', 'temperatura', 292.0000, 'ºC'),
	(116509, 112, '2015-03-15 00:38:33.000000', 'temperatura', 332.0000, 'ºC'),
	(116510, 112, '2015-03-15 00:38:34.000000', 'temperatura', 785.0000, 'ºC'),
	(116511, 112, '2015-03-15 00:38:35.000000', 'temperatura', 530.0000, 'ºC'),
	(116512, 112, '2015-03-15 00:38:36.000000', 'temperatura', 294.0000, 'ºC'),
	(116513, 112, '2015-03-15 00:38:37.000000', 'temperatura', 1079.0000, 'ºC'),
	(116514, 112, '2015-03-15 00:38:38.000000', 'temperatura', 915.0000, 'ºC'),
	(116515, 112, '2015-03-15 00:38:39.000000', 'temperatura', 139.0000, 'ºC'),
	(116516, 112, '2015-03-15 00:38:40.000000', 'temperatura', 349.0000, 'ºC'),
	(116517, 112, '2015-03-15 00:38:41.000000', 'temperatura', 130.0000, 'ºC'),
	(116518, 112, '2015-03-15 00:38:42.000000', 'temperatura', 801.0000, 'ºC'),
	(116519, 112, '2015-03-15 00:38:43.000000', 'temperatura', 17.0000, 'ºC'),
	(116520, 112, '2015-03-15 00:38:44.000000', 'temperatura', 82.0000, 'ºC'),
	(116521, 112, '2015-03-15 00:38:45.000000', 'temperatura', 359.0000, 'ºC'),
	(116522, 112, '2015-03-15 00:38:46.000000', 'temperatura', 350.0000, 'ºC'),
	(116523, 112, '2015-03-15 00:38:47.000000', 'temperatura', 672.0000, 'ºC'),
	(116524, 112, '2015-03-15 00:38:48.000000', 'temperatura', 1111.0000, 'ºC'),
	(116525, 112, '2015-03-15 00:38:49.000000', 'temperatura', 1138.0000, 'ºC'),
	(116526, 112, '2015-03-15 00:38:50.000000', 'temperatura', 1159.0000, 'ºC'),
	(116527, 112, '2015-03-15 00:38:51.000000', 'temperatura', 1180.0000, 'ºC'),
	(116528, 112, '2015-03-15 00:38:52.000000', 'temperatura', 27.0000, 'ºC'),
	(116529, 112, '2015-03-15 00:38:53.000000', 'temperatura', 192.0000, 'ºC'),
	(116530, 112, '2015-03-15 00:38:54.000000', 'temperatura', 880.0000, 'ºC'),
	(116531, 112, '2015-03-15 00:38:55.000000', 'temperatura', 226.0000, 'ºC'),
	(116532, 112, '2015-03-15 00:38:56.000000', 'temperatura', 890.0000, 'ºC'),
	(116533, 112, '2015-03-15 00:38:57.000000', 'temperatura', 174.0000, 'ºC'),
	(116534, 112, '2015-03-15 00:38:58.000000', 'temperatura', 600.0000, 'ºC'),
	(116535, 112, '2015-03-15 00:38:59.000000', 'temperatura', 79.0000, 'ºC'),
	(116536, 112, '2015-03-15 00:39:00.000000', 'temperatura', 994.0000, 'ºC'),
	(116537, 112, '2015-03-15 00:39:01.000000', 'temperatura', 1135.0000, 'ºC'),
	(116538, 112, '2015-03-15 00:39:02.000000', 'temperatura', 292.0000, 'ºC'),
	(116539, 112, '2015-03-15 00:39:03.000000', 'temperatura', 455.0000, 'ºC'),
	(116540, 112, '2015-03-15 00:39:04.000000', 'temperatura', 199.0000, 'ºC'),
	(116541, 112, '2015-03-15 00:39:05.000000', 'temperatura', 829.0000, 'ºC'),
	(116542, 112, '2015-03-15 00:39:06.000000', 'temperatura', 1151.0000, 'ºC'),
	(116543, 112, '2015-03-15 00:39:07.000000', 'temperatura', 870.0000, 'ºC'),
	(116544, 112, '2015-03-15 00:39:08.000000', 'temperatura', 896.0000, 'ºC'),
	(116545, 112, '2015-03-15 00:39:09.000000', 'temperatura', 670.0000, 'ºC'),
	(116546, 112, '2015-03-15 00:39:10.000000', 'temperatura', 663.0000, 'ºC'),
	(116547, 112, '2015-03-15 00:39:11.000000', 'temperatura', 104.0000, 'ºC'),
	(116548, 112, '2015-03-15 00:39:12.000000', 'temperatura', 933.0000, 'ºC'),
	(116549, 112, '2015-03-15 00:39:13.000000', 'temperatura', 752.0000, 'ºC'),
	(116550, 112, '2015-03-15 00:39:14.000000', 'temperatura', 963.0000, 'ºC'),
	(116551, 112, '2015-03-15 00:39:15.000000', 'temperatura', 159.0000, 'ºC'),
	(116552, 112, '2015-03-15 00:39:16.000000', 'temperatura', 307.0000, 'ºC'),
	(116553, 112, '2015-03-15 00:39:17.000000', 'temperatura', 1057.0000, 'ºC'),
	(116554, 112, '2015-03-15 00:39:18.000000', 'temperatura', 766.0000, 'ºC'),
	(116555, 112, '2015-03-15 00:39:19.000000', 'temperatura', 660.0000, 'ºC'),
	(116556, 112, '2015-03-15 00:39:20.000000', 'temperatura', 1002.0000, 'ºC'),
	(116557, 112, '2015-03-15 00:39:21.000000', 'temperatura', 630.0000, 'ºC'),
	(116558, 112, '2015-03-15 00:39:22.000000', 'temperatura', 143.0000, 'ºC'),
	(116559, 112, '2015-03-15 00:39:23.000000', 'temperatura', 26.0000, 'ºC'),
	(116560, 112, '2015-03-15 00:39:24.000000', 'temperatura', 903.0000, 'ºC'),
	(116561, 112, '2015-03-15 00:39:25.000000', 'temperatura', 837.0000, 'ºC'),
	(116562, 112, '2015-03-15 00:39:26.000000', 'temperatura', 278.0000, 'ºC'),
	(116563, 112, '2015-03-15 00:39:27.000000', 'temperatura', 79.0000, 'ºC'),
	(116564, 112, '2015-03-15 00:39:28.000000', 'temperatura', 761.0000, 'ºC'),
	(116565, 112, '2015-03-15 00:39:29.000000', 'temperatura', 1170.0000, 'ºC'),
	(116566, 112, '2015-03-15 00:39:30.000000', 'temperatura', 1167.0000, 'ºC'),
	(116567, 112, '2015-03-15 00:39:31.000000', 'temperatura', 1124.0000, 'ºC'),
	(116568, 112, '2015-03-15 00:39:32.000000', 'temperatura', 921.0000, 'ºC'),
	(116569, 112, '2015-03-15 00:39:33.000000', 'temperatura', 34.0000, 'ºC'),
	(116570, 112, '2015-03-15 00:39:34.000000', 'temperatura', 1005.0000, 'ºC'),
	(116571, 112, '2015-03-15 00:39:35.000000', 'temperatura', 125.0000, 'ºC'),
	(116572, 112, '2015-03-15 00:39:36.000000', 'temperatura', 12.0000, 'ºC'),
	(116573, 112, '2015-03-15 00:39:37.000000', 'temperatura', 884.0000, 'ºC'),
	(116574, 112, '2015-03-15 00:39:38.000000', 'temperatura', 783.0000, 'ºC'),
	(116575, 112, '2015-03-15 00:39:39.000000', 'temperatura', 67.0000, 'ºC'),
	(116576, 112, '2015-03-15 00:39:40.000000', 'temperatura', 384.0000, 'ºC'),
	(116577, 112, '2015-03-15 00:39:41.000000', 'temperatura', 520.0000, 'ºC'),
	(116578, 112, '2015-03-15 00:39:42.000000', 'temperatura', 250.0000, 'ºC'),
	(116579, 112, '2015-03-15 00:39:43.000000', 'temperatura', 888.0000, 'ºC'),
	(116580, 112, '2015-03-15 00:39:44.000000', 'temperatura', 90.0000, 'ºC'),
	(116581, 112, '2015-03-15 00:39:45.000000', 'temperatura', 189.0000, 'ºC'),
	(116582, 112, '2015-03-15 00:39:46.000000', 'temperatura', 676.0000, 'ºC'),
	(116583, 112, '2015-03-15 00:39:47.000000', 'temperatura', 412.0000, 'ºC'),
	(116584, 112, '2015-03-15 00:39:48.000000', 'temperatura', 34.0000, 'ºC'),
	(116585, 112, '2015-03-15 00:39:49.000000', 'temperatura', 135.0000, 'ºC'),
	(116586, 112, '2015-03-15 00:39:50.000000', 'temperatura', 573.0000, 'ºC'),
	(116587, 112, '2015-03-15 00:39:51.000000', 'temperatura', 62.0000, 'ºC'),
	(116588, 112, '2015-03-15 00:39:52.000000', 'temperatura', 991.0000, 'ºC'),
	(116589, 112, '2015-03-15 00:39:53.000000', 'temperatura', 1170.0000, 'ºC'),
	(116590, 112, '2015-03-15 00:39:54.000000', 'temperatura', 475.0000, 'ºC'),
	(116591, 112, '2015-03-15 00:39:55.000000', 'temperatura', 65.0000, 'ºC'),
	(116592, 112, '2015-03-15 00:39:56.000000', 'temperatura', 104.0000, 'ºC'),
	(116593, 112, '2015-03-15 00:39:57.000000', 'temperatura', 322.0000, 'ºC'),
	(116594, 112, '2015-03-15 00:39:58.000000', 'temperatura', 99.0000, 'ºC'),
	(116595, 112, '2015-03-15 00:39:59.000000', 'temperatura', 731.0000, 'ºC'),
	(116596, 112, '2015-03-15 00:40:00.000000', 'temperatura', 956.0000, 'ºC'),
	(116597, 112, '2015-03-15 00:40:01.000000', 'temperatura', 191.0000, 'ºC'),
	(116598, 112, '2015-03-15 00:40:02.000000', 'temperatura', 486.0000, 'ºC'),
	(116599, 112, '2015-03-15 00:40:03.000000', 'temperatura', 655.0000, 'ºC'),
	(116600, 112, '2015-03-15 00:40:04.000000', 'temperatura', 621.0000, 'ºC'),
	(116601, 112, '2015-03-15 00:40:05.000000', 'temperatura', 1138.0000, 'ºC'),
	(116602, 112, '2015-03-15 00:40:06.000000', 'temperatura', 228.0000, 'ºC'),
	(116603, 112, '2015-03-15 00:40:07.000000', 'temperatura', 126.0000, 'ºC'),
	(116604, 112, '2015-03-15 00:40:08.000000', 'temperatura', 1145.0000, 'ºC'),
	(116605, 112, '2015-03-15 00:40:09.000000', 'temperatura', 548.0000, 'ºC'),
	(116606, 112, '2015-03-15 00:40:10.000000', 'temperatura', 508.0000, 'ºC'),
	(116607, 112, '2015-03-15 00:40:11.000000', 'temperatura', 896.0000, 'ºC'),
	(116608, 112, '2015-03-15 00:40:12.000000', 'temperatura', 555.0000, 'ºC'),
	(116609, 112, '2015-03-15 00:40:13.000000', 'temperatura', 87.0000, 'ºC'),
	(116610, 112, '2015-03-15 00:40:14.000000', 'temperatura', 1170.0000, 'ºC'),
	(116611, 112, '2015-03-15 00:40:15.000000', 'temperatura', 788.0000, 'ºC'),
	(116612, 112, '2015-03-15 00:40:16.000000', 'temperatura', 434.0000, 'ºC'),
	(116613, 112, '2015-03-15 00:40:17.000000', 'temperatura', 1006.0000, 'ºC'),
	(116614, 112, '2015-03-15 00:40:18.000000', 'temperatura', 130.0000, 'ºC'),
	(116615, 112, '2015-03-15 00:40:19.000000', 'temperatura', 30.0000, 'ºC'),
	(116616, 112, '2015-03-15 00:40:20.000000', 'temperatura', 962.0000, 'ºC'),
	(116617, 112, '2015-03-15 00:40:21.000000', 'temperatura', 1119.0000, 'ºC'),
	(116618, 112, '2015-03-15 00:40:22.000000', 'temperatura', 309.0000, 'ºC'),
	(116619, 112, '2015-03-15 00:40:23.000000', 'temperatura', 588.0000, 'ºC'),
	(116620, 112, '2015-03-15 00:40:24.000000', 'temperatura', 813.0000, 'ºC'),
	(116621, 112, '2015-03-15 00:40:25.000000', 'temperatura', 1101.0000, 'ºC'),
	(116622, 112, '2015-03-15 00:40:26.000000', 'temperatura', 666.0000, 'ºC'),
	(116623, 112, '2015-03-15 00:40:27.000000', 'temperatura', 30.0000, 'ºC'),
	(116624, 112, '2015-03-15 00:40:28.000000', 'temperatura', 551.0000, 'ºC'),
	(116625, 112, '2015-03-15 00:40:29.000000', 'temperatura', 265.0000, 'ºC'),
	(116626, 112, '2015-03-15 00:40:30.000000', 'temperatura', 871.0000, 'ºC'),
	(116627, 112, '2015-03-15 00:40:31.000000', 'temperatura', 1162.0000, 'ºC'),
	(116628, 112, '2015-03-15 00:40:32.000000', 'temperatura', 798.0000, 'ºC'),
	(116629, 112, '2015-03-15 00:40:33.000000', 'temperatura', 503.0000, 'ºC'),
	(116630, 112, '2015-03-15 00:40:34.000000', 'temperatura', 122.0000, 'ºC'),
	(116631, 112, '2015-03-15 00:40:35.000000', 'temperatura', 301.0000, 'ºC'),
	(116632, 112, '2015-03-15 00:40:36.000000', 'temperatura', 1140.0000, 'ºC'),
	(116633, 112, '2015-03-15 00:40:37.000000', 'temperatura', 1199.0000, 'ºC'),
	(116634, 112, '2015-03-15 00:40:38.000000', 'temperatura', 176.0000, 'ºC'),
	(116635, 112, '2015-03-15 00:40:39.000000', 'temperatura', 882.0000, 'ºC'),
	(116636, 112, '2015-03-15 00:40:40.000000', 'temperatura', 281.0000, 'ºC'),
	(116637, 112, '2015-03-15 00:40:41.000000', 'temperatura', 1159.0000, 'ºC'),
	(116638, 112, '2015-03-15 00:40:42.000000', 'temperatura', 155.0000, 'ºC'),
	(116639, 112, '2015-03-15 00:40:43.000000', 'temperatura', 896.0000, 'ºC'),
	(116640, 112, '2015-03-15 00:40:44.000000', 'temperatura', 417.0000, 'ºC'),
	(116641, 112, '2015-03-15 00:40:45.000000', 'temperatura', 597.0000, 'ºC'),
	(116642, 112, '2015-03-15 00:40:46.000000', 'temperatura', 534.0000, 'ºC'),
	(116643, 112, '2015-03-15 00:40:47.000000', 'temperatura', 880.0000, 'ºC'),
	(116644, 112, '2015-03-15 00:40:48.000000', 'temperatura', 397.0000, 'ºC'),
	(116645, 112, '2015-03-15 00:40:49.000000', 'temperatura', 545.0000, 'ºC'),
	(116646, 112, '2015-03-15 00:40:50.000000', 'temperatura', 334.0000, 'ºC'),
	(116647, 112, '2015-03-15 00:40:51.000000', 'temperatura', 35.0000, 'ºC'),
	(116648, 112, '2015-03-15 00:40:52.000000', 'temperatura', 376.0000, 'ºC'),
	(116649, 112, '2015-03-15 00:40:53.000000', 'temperatura', 574.0000, 'ºC'),
	(116650, 112, '2015-03-15 00:40:54.000000', 'temperatura', 544.0000, 'ºC'),
	(116651, 112, '2015-03-15 00:40:55.000000', 'temperatura', 999.0000, 'ºC'),
	(116652, 112, '2015-03-15 00:40:56.000000', 'temperatura', 961.0000, 'ºC'),
	(116653, 112, '2015-03-15 00:40:57.000000', 'temperatura', 612.0000, 'ºC'),
	(116654, 112, '2015-03-15 00:40:58.000000', 'temperatura', 174.0000, 'ºC'),
	(116655, 112, '2015-03-15 00:40:59.000000', 'temperatura', 236.0000, 'ºC'),
	(116656, 112, '2015-03-15 00:41:00.000000', 'temperatura', 659.0000, 'ºC'),
	(116657, 112, '2015-03-15 00:41:01.000000', 'temperatura', 185.0000, 'ºC'),
	(116658, 112, '2015-03-15 00:41:02.000000', 'temperatura', 151.0000, 'ºC'),
	(116659, 112, '2015-03-15 00:41:03.000000', 'temperatura', 198.0000, 'ºC'),
	(116660, 112, '2015-03-15 00:41:04.000000', 'temperatura', 538.0000, 'ºC'),
	(116661, 112, '2015-03-15 00:41:05.000000', 'temperatura', 897.0000, 'ºC'),
	(116662, 112, '2015-03-15 00:41:06.000000', 'temperatura', 472.0000, 'ºC'),
	(116663, 112, '2015-03-15 00:41:07.000000', 'temperatura', 869.0000, 'ºC'),
	(116664, 112, '2015-03-15 00:41:08.000000', 'temperatura', 531.0000, 'ºC'),
	(116665, 112, '2015-03-15 00:41:09.000000', 'temperatura', 49.0000, 'ºC'),
	(116666, 112, '2015-03-15 00:41:10.000000', 'temperatura', 1051.0000, 'ºC'),
	(116667, 112, '2015-03-15 00:41:11.000000', 'temperatura', 309.0000, 'ºC'),
	(116668, 112, '2015-03-15 00:41:12.000000', 'temperatura', 794.0000, 'ºC'),
	(116669, 112, '2015-03-15 00:41:13.000000', 'temperatura', 644.0000, 'ºC'),
	(116670, 112, '2015-03-15 00:41:14.000000', 'temperatura', 836.0000, 'ºC'),
	(116671, 112, '2015-03-15 00:41:15.000000', 'temperatura', 1050.0000, 'ºC'),
	(116672, 112, '2015-03-15 00:41:16.000000', 'temperatura', 342.0000, 'ºC'),
	(116673, 112, '2015-03-15 00:41:17.000000', 'temperatura', 960.0000, 'ºC'),
	(116674, 112, '2015-03-15 00:41:18.000000', 'temperatura', 175.0000, 'ºC'),
	(116675, 112, '2015-03-15 00:41:19.000000', 'temperatura', 395.0000, 'ºC'),
	(116676, 112, '2015-03-15 00:41:20.000000', 'temperatura', 252.0000, 'ºC'),
	(116677, 112, '2015-03-15 00:41:21.000000', 'temperatura', 76.0000, 'ºC'),
	(116678, 112, '2015-03-15 00:41:22.000000', 'temperatura', 823.0000, 'ºC'),
	(116679, 112, '2015-03-15 00:41:23.000000', 'temperatura', 289.0000, 'ºC'),
	(116680, 112, '2015-03-15 00:41:24.000000', 'temperatura', 177.0000, 'ºC'),
	(116681, 112, '2015-03-15 00:41:25.000000', 'temperatura', 19.0000, 'ºC'),
	(116682, 112, '2015-03-15 00:41:26.000000', 'temperatura', 762.0000, 'ºC'),
	(116683, 112, '2015-03-15 00:41:27.000000', 'temperatura', 152.0000, 'ºC'),
	(116684, 112, '2015-03-15 00:41:28.000000', 'temperatura', 878.0000, 'ºC'),
	(116685, 112, '2015-03-15 00:41:29.000000', 'temperatura', 334.0000, 'ºC'),
	(116686, 112, '2015-03-15 00:41:30.000000', 'temperatura', 237.0000, 'ºC'),
	(116687, 112, '2015-03-15 00:41:31.000000', 'temperatura', 182.0000, 'ºC'),
	(116688, 112, '2015-03-15 00:41:32.000000', 'temperatura', 200.0000, 'ºC'),
	(116689, 112, '2015-03-15 00:41:33.000000', 'temperatura', 453.0000, 'ºC'),
	(116690, 112, '2015-03-15 00:41:34.000000', 'temperatura', 466.0000, 'ºC'),
	(116691, 112, '2015-03-15 00:41:35.000000', 'temperatura', 973.0000, 'ºC'),
	(116692, 112, '2015-03-15 00:41:36.000000', 'temperatura', 1068.0000, 'ºC'),
	(116693, 112, '2015-03-15 00:41:37.000000', 'temperatura', 21.0000, 'ºC'),
	(116694, 112, '2015-03-15 00:41:38.000000', 'temperatura', 502.0000, 'ºC'),
	(116695, 112, '2015-03-15 00:41:39.000000', 'temperatura', 48.0000, 'ºC'),
	(116696, 112, '2015-03-15 00:41:40.000000', 'temperatura', 1134.0000, 'ºC'),
	(116697, 112, '2015-03-15 00:41:41.000000', 'temperatura', 727.0000, 'ºC'),
	(116698, 112, '2015-03-15 00:41:42.000000', 'temperatura', 232.0000, 'ºC'),
	(116699, 112, '2015-03-15 00:41:43.000000', 'temperatura', 181.0000, 'ºC'),
	(116700, 112, '2015-03-15 00:41:44.000000', 'temperatura', 209.0000, 'ºC'),
	(116701, 112, '2015-03-15 00:41:45.000000', 'temperatura', 503.0000, 'ºC'),
	(116702, 112, '2015-03-15 00:41:46.000000', 'temperatura', 688.0000, 'ºC'),
	(116703, 112, '2015-03-15 00:41:47.000000', 'temperatura', 731.0000, 'ºC'),
	(116704, 112, '2015-03-15 00:41:48.000000', 'temperatura', 392.0000, 'ºC'),
	(116705, 112, '2015-03-15 00:41:49.000000', 'temperatura', 968.0000, 'ºC'),
	(116706, 112, '2015-03-15 00:41:50.000000', 'temperatura', 62.0000, 'ºC'),
	(116707, 112, '2015-03-15 00:41:51.000000', 'temperatura', 1009.0000, 'ºC'),
	(116708, 112, '2015-03-15 00:41:52.000000', 'temperatura', 57.0000, 'ºC'),
	(116709, 112, '2015-03-15 00:41:53.000000', 'temperatura', 861.0000, 'ºC'),
	(116710, 112, '2015-03-15 00:41:54.000000', 'temperatura', 532.0000, 'ºC'),
	(116711, 112, '2015-03-15 00:41:55.000000', 'temperatura', 80.0000, 'ºC'),
	(116712, 112, '2015-03-15 00:41:56.000000', 'temperatura', 2.0000, 'ºC'),
	(116713, 112, '2015-03-15 00:41:57.000000', 'temperatura', 973.0000, 'ºC'),
	(116714, 112, '2015-03-15 00:41:58.000000', 'temperatura', 57.0000, 'ºC'),
	(116715, 112, '2015-03-15 00:41:59.000000', 'temperatura', 968.0000, 'ºC'),
	(116716, 112, '2015-03-15 00:42:00.000000', 'temperatura', 1069.0000, 'ºC'),
	(116717, 112, '2015-03-15 00:42:01.000000', 'temperatura', 43.0000, 'ºC'),
	(116718, 112, '2015-03-15 00:42:02.000000', 'temperatura', 607.0000, 'ºC'),
	(116719, 112, '2015-03-15 00:42:03.000000', 'temperatura', 506.0000, 'ºC'),
	(116720, 112, '2015-03-15 00:42:04.000000', 'temperatura', 710.0000, 'ºC'),
	(116721, 112, '2015-03-15 00:42:05.000000', 'temperatura', 832.0000, 'ºC'),
	(116722, 112, '2015-03-15 00:42:06.000000', 'temperatura', 830.0000, 'ºC'),
	(116723, 112, '2015-03-15 00:42:07.000000', 'temperatura', 455.0000, 'ºC'),
	(116724, 112, '2015-03-15 00:42:08.000000', 'temperatura', 987.0000, 'ºC'),
	(116725, 112, '2015-03-15 00:42:09.000000', 'temperatura', 1167.0000, 'ºC'),
	(116726, 112, '2015-03-15 00:42:10.000000', 'temperatura', 478.0000, 'ºC'),
	(116727, 112, '2015-03-15 00:42:11.000000', 'temperatura', 89.0000, 'ºC'),
	(116728, 112, '2015-03-15 00:42:12.000000', 'temperatura', 213.0000, 'ºC'),
	(116729, 112, '2015-03-15 00:42:13.000000', 'temperatura', 797.0000, 'ºC'),
	(116730, 112, '2015-03-15 00:42:14.000000', 'temperatura', 948.0000, 'ºC'),
	(116731, 112, '2015-03-15 00:42:15.000000', 'temperatura', 1150.0000, 'ºC'),
	(116732, 112, '2015-03-15 00:42:16.000000', 'temperatura', 506.0000, 'ºC'),
	(116733, 112, '2015-03-15 00:42:17.000000', 'temperatura', 281.0000, 'ºC'),
	(116734, 112, '2015-03-15 00:42:18.000000', 'temperatura', 1089.0000, 'ºC'),
	(116735, 112, '2015-03-15 00:42:19.000000', 'temperatura', 1000.0000, 'ºC'),
	(116736, 112, '2015-03-15 00:42:20.000000', 'temperatura', 534.0000, 'ºC'),
	(116737, 112, '2015-03-15 00:42:21.000000', 'temperatura', 872.0000, 'ºC'),
	(116738, 112, '2015-03-15 00:42:22.000000', 'temperatura', 358.0000, 'ºC'),
	(116739, 112, '2015-03-15 00:42:23.000000', 'temperatura', 375.0000, 'ºC'),
	(116740, 112, '2015-03-15 00:42:24.000000', 'temperatura', 799.0000, 'ºC'),
	(116741, 112, '2015-03-15 00:42:25.000000', 'temperatura', 473.0000, 'ºC'),
	(116742, 112, '2015-03-15 00:42:26.000000', 'temperatura', 1168.0000, 'ºC'),
	(116743, 112, '2015-03-15 00:42:27.000000', 'temperatura', 820.0000, 'ºC'),
	(116744, 112, '2015-03-15 00:42:28.000000', 'temperatura', 599.0000, 'ºC'),
	(116745, 112, '2015-03-15 00:42:29.000000', 'temperatura', 534.0000, 'ºC'),
	(116746, 112, '2015-03-15 00:42:30.000000', 'temperatura', 872.0000, 'ºC'),
	(116747, 112, '2015-03-15 00:42:31.000000', 'temperatura', 358.0000, 'ºC'),
	(116748, 112, '2015-03-15 00:42:32.000000', 'temperatura', 377.0000, 'ºC'),
	(116749, 112, '2015-03-15 00:42:33.000000', 'temperatura', 813.0000, 'ºC'),
	(116750, 112, '2015-03-15 00:42:34.000000', 'temperatura', 532.0000, 'ºC'),
	(116751, 112, '2015-03-15 00:42:35.000000', 'temperatura', 221.0000, 'ºC'),
	(116752, 112, '2015-03-15 00:42:36.000000', 'temperatura', 709.0000, 'ºC'),
	(116753, 112, '2015-03-15 00:42:37.000000', 'temperatura', 484.0000, 'ºC'),
	(116754, 112, '2015-03-15 00:42:38.000000', 'temperatura', 291.0000, 'ºC'),
	(116755, 112, '2015-03-15 00:42:39.000000', 'temperatura', 5.0000, 'ºC'),
	(116756, 112, '2015-03-15 00:42:40.000000', 'temperatura', 351.0000, 'ºC'),
	(116757, 112, '2015-03-15 00:42:41.000000', 'temperatura', 542.0000, 'ºC'),
	(116758, 112, '2015-03-15 00:42:42.000000', 'temperatura', 456.0000, 'ºC'),
	(116759, 112, '2015-03-15 00:42:43.000000', 'temperatura', 655.0000, 'ºC'),
	(116760, 112, '2015-03-15 00:42:44.000000', 'temperatura', 707.0000, 'ºC'),
	(116761, 112, '2015-03-15 00:42:45.000000', 'temperatura', 371.0000, 'ºC'),
	(116762, 112, '2015-03-15 00:42:46.000000', 'temperatura', 933.0000, 'ºC'),
	(116763, 112, '2015-03-15 00:42:47.000000', 'temperatura', 1155.0000, 'ºC'),
	(116764, 112, '2015-03-15 00:42:48.000000', 'temperatura', 574.0000, 'ºC'),
	(116765, 112, '2015-03-15 00:42:49.000000', 'temperatura', 606.0000, 'ºC'),
	(116766, 112, '2015-03-15 00:42:50.000000', 'temperatura', 110.0000, 'ºC'),
	(116767, 112, '2015-03-15 00:42:51.000000', 'temperatura', 1132.0000, 'ºC'),
	(116768, 112, '2015-03-15 00:42:52.000000', 'temperatura', 532.0000, 'ºC'),
	(116769, 112, '2015-03-15 00:42:53.000000', 'temperatura', 462.0000, 'ºC'),
	(116770, 112, '2015-03-15 00:42:54.000000', 'temperatura', 714.0000, 'ºC'),
	(116771, 112, '2015-03-15 00:42:55.000000', 'temperatura', 987.0000, 'ºC'),
	(116772, 112, '2015-03-15 00:42:56.000000', 'temperatura', 391.0000, 'ºC'),
	(116773, 112, '2015-03-15 00:42:57.000000', 'temperatura', 197.0000, 'ºC'),
	(116774, 112, '2015-03-15 00:42:58.000000', 'temperatura', 1011.0000, 'ºC'),
	(116775, 112, '2015-03-15 00:42:59.000000', 'temperatura', 866.0000, 'ºC'),
	(116776, 112, '2015-03-15 00:43:00.000000', 'temperatura', 98.0000, 'ºC'),
	(116777, 112, '2015-03-15 00:43:01.000000', 'temperatura', 290.0000, 'ºC'),
	(116778, 112, '2015-03-15 00:43:02.000000', 'temperatura', 1156.0000, 'ºC'),
	(116779, 112, '2015-03-15 00:43:03.000000', 'temperatura', 111.0000, 'ºC'),
	(116780, 112, '2015-03-15 00:43:04.000000', 'temperatura', 690.0000, 'ºC'),
	(116781, 112, '2015-03-15 00:43:05.000000', 'temperatura', 716.0000, 'ºC'),
	(116782, 112, '2015-03-15 00:43:06.000000', 'temperatura', 311.0000, 'ºC'),
	(116783, 112, '2015-03-15 00:43:07.000000', 'temperatura', 609.0000, 'ºC'),
	(116784, 112, '2015-03-15 00:43:08.000000', 'temperatura', 909.0000, 'ºC'),
	(116785, 112, '2015-03-15 00:43:09.000000', 'temperatura', 322.0000, 'ºC'),
	(116786, 112, '2015-03-15 00:43:10.000000', 'temperatura', 81.0000, 'ºC'),
	(116787, 112, '2015-03-15 00:43:11.000000', 'temperatura', 642.0000, 'ºC'),
	(116788, 112, '2015-03-15 00:43:12.000000', 'temperatura', 566.0000, 'ºC'),
	(116789, 112, '2015-03-15 00:43:13.000000', 'temperatura', 903.0000, 'ºC'),
	(116790, 112, '2015-03-15 00:43:14.000000', 'temperatura', 420.0000, 'ºC'),
	(116791, 112, '2015-03-15 00:43:15.000000', 'temperatura', 591.0000, 'ºC'),
	(116792, 112, '2015-03-15 00:43:16.000000', 'temperatura', 495.0000, 'ºC'),
	(116793, 112, '2015-03-15 00:43:17.000000', 'temperatura', 702.0000, 'ºC'),
	(116794, 112, '2015-03-15 00:43:18.000000', 'temperatura', 827.0000, 'ºC'),
	(116795, 112, '2015-03-15 00:43:19.000000', 'temperatura', 828.0000, 'ºC'),
	(116796, 112, '2015-03-15 00:43:20.000000', 'temperatura', 461.0000, 'ºC'),
	(116797, 112, '2015-03-15 00:43:21.000000', 'temperatura', 1020.0000, 'ºC'),
	(116798, 112, '2015-03-15 00:43:22.000000', 'temperatura', 120.0000, 'ºC'),
	(116799, 112, '2015-03-15 00:43:23.000000', 'temperatura', 1139.0000, 'ºC'),
	(116800, 112, '2015-03-15 00:43:24.000000', 'temperatura', 535.0000, 'ºC'),
	(116801, 112, '2015-03-15 00:43:25.000000', 'temperatura', 459.0000, 'ºC'),
	(116802, 112, '2015-03-15 00:43:26.000000', 'temperatura', 692.0000, 'ºC'),
	(116803, 112, '2015-03-15 00:43:27.000000', 'temperatura', 884.0000, 'ºC'),
	(116804, 112, '2015-03-15 00:43:28.000000', 'temperatura', 1142.0000, 'ºC'),
	(116805, 112, '2015-03-15 00:43:29.000000', 'temperatura', 658.0000, 'ºC'),
	(116806, 112, '2015-03-15 00:43:30.000000', 'temperatura', 1064.0000, 'ºC'),
	(116807, 112, '2015-03-15 00:43:31.000000', 'temperatura', 948.0000, 'ºC'),
	(116808, 112, '2015-03-15 00:43:32.000000', 'temperatura', 350.0000, 'ºC'),
	(116809, 112, '2015-03-15 00:43:33.000000', 'temperatura', 104.0000, 'ºC'),
	(116810, 112, '2015-03-15 00:43:34.000000', 'temperatura', 671.0000, 'ºC'),
	(116811, 112, '2015-03-15 00:43:35.000000', 'temperatura', 645.0000, 'ºC'),
	(116812, 112, '2015-03-15 00:43:36.000000', 'temperatura', 12.0000, 'ºC'),
	(116813, 112, '2015-03-15 00:43:37.000000', 'temperatura', 524.0000, 'ºC'),
	(116814, 112, '2015-03-15 00:43:38.000000', 'temperatura', 185.0000, 'ºC'),
	(116815, 112, '2015-03-15 00:43:39.000000', 'temperatura', 553.0000, 'ºC'),
	(116816, 112, '2015-03-15 00:43:40.000000', 'temperatura', 1010.0000, 'ºC'),
	(116817, 112, '2015-03-15 00:43:41.000000', 'temperatura', 993.0000, 'ºC'),
	(116818, 112, '2015-03-15 00:43:42.000000', 'temperatura', 733.0000, 'ºC'),
	(116819, 112, '2015-03-15 00:43:43.000000', 'temperatura', 689.0000, 'ºC'),
	(116820, 112, '2015-03-15 00:43:44.000000', 'temperatura', 46.0000, 'ºC'),
	(116821, 112, '2015-03-15 00:43:45.000000', 'temperatura', 564.0000, 'ºC'),
	(116822, 112, '2015-03-15 00:43:46.000000', 'temperatura', 283.0000, 'ºC'),
	(116823, 112, '2015-03-15 00:43:47.000000', 'temperatura', 922.0000, 'ºC'),
	(116824, 112, '2015-03-15 00:43:48.000000', 'temperatura', 163.0000, 'ºC'),
	(116825, 112, '2015-03-15 00:43:49.000000', 'temperatura', 448.0000, 'ºC'),
	(116826, 112, '2015-03-15 00:43:50.000000', 'temperatura', 550.0000, 'ºC'),
	(116827, 112, '2015-03-15 00:43:51.000000', 'temperatura', 209.0000, 'ºC'),
	(116828, 112, '2015-03-15 00:43:52.000000', 'temperatura', 594.0000, 'ºC'),
	(116829, 112, '2015-03-15 00:43:53.000000', 'temperatura', 1142.0000, 'ºC'),
	(116830, 112, '2015-03-15 00:43:54.000000', 'temperatura', 330.0000, 'ºC'),
	(116831, 112, '2015-03-15 00:43:55.000000', 'temperatura', 626.0000, 'ºC'),
	(116832, 112, '2015-03-15 00:43:56.000000', 'temperatura', 938.0000, 'ºC'),
	(116833, 112, '2015-03-15 00:43:57.000000', 'temperatura', 414.0000, 'ºC'),
	(116834, 112, '2015-03-15 00:43:58.000000', 'temperatura', 455.0000, 'ºC'),
	(116835, 112, '2015-03-15 00:43:59.000000', 'temperatura', 1036.0000, 'ºC'),
	(116836, 112, '2015-03-15 00:44:00.000000', 'temperatura', 215.0000, 'ºC'),
	(116837, 112, '2015-03-15 00:44:01.000000', 'temperatura', 366.0000, 'ºC'),
	(116838, 112, '2015-03-15 00:44:02.000000', 'temperatura', 1187.0000, 'ºC'),
	(116839, 112, '2015-03-15 00:44:03.000000', 'temperatura', 35.0000, 'ºC'),
	(116840, 112, '2015-03-15 00:44:04.000000', 'temperatura', 218.0000, 'ºC'),
	(116841, 112, '2015-03-15 00:44:05.000000', 'temperatura', 982.0000, 'ºC'),
	(116842, 112, '2015-03-15 00:44:06.000000', 'temperatura', 660.0000, 'ºC'),
	(116843, 112, '2015-03-15 00:44:07.000000', 'temperatura', 352.0000, 'ºC'),
	(116844, 112, '2015-03-15 00:44:08.000000', 'temperatura', 979.0000, 'ºC'),
	(116845, 112, '2015-03-15 00:44:09.000000', 'temperatura', 242.0000, 'ºC'),
	(116846, 112, '2015-03-15 00:44:10.000000', 'temperatura', 675.0000, 'ºC'),
	(116847, 112, '2015-03-15 00:44:11.000000', 'temperatura', 247.0000, 'ºC'),
	(116848, 112, '2015-03-15 00:44:12.000000', 'temperatura', 413.0000, 'ºC'),
	(116849, 112, '2015-03-15 00:44:13.000000', 'temperatura', 122.0000, 'ºC'),
	(116850, 112, '2015-03-15 00:44:14.000000', 'temperatura', 571.0000, 'ºC'),
	(116851, 112, '2015-03-15 00:44:15.000000', 'temperatura', 91.0000, 'ºC'),
	(116852, 112, '2015-03-15 00:44:16.000000', 'temperatura', 1141.0000, 'ºC'),
	(116853, 112, '2015-03-15 00:44:17.000000', 'temperatura', 635.0000, 'ºC'),
	(116854, 112, '2015-03-15 00:44:18.000000', 'temperatura', 950.0000, 'ºC'),
	(116855, 112, '2015-03-15 00:44:19.000000', 'temperatura', 446.0000, 'ºC'),
	(116856, 112, '2015-03-15 00:44:20.000000', 'temperatura', 582.0000, 'ºC'),
	(116857, 112, '2015-03-15 00:44:21.000000', 'temperatura', 371.0000, 'ºC'),
	(116858, 112, '2015-03-15 00:44:22.000000', 'temperatura', 110.0000, 'ºC'),
	(116859, 112, '2015-03-15 00:44:23.000000', 'temperatura', 637.0000, 'ºC'),
	(116860, 112, '2015-03-15 00:44:24.000000', 'temperatura', 454.0000, 'ºC'),
	(116861, 112, '2015-03-15 00:44:25.000000', 'temperatura', 359.0000, 'ºC'),
	(116862, 112, '2015-03-15 00:44:26.000000', 'temperatura', 437.0000, 'ºC'),
	(116863, 112, '2015-03-15 00:44:27.000000', 'temperatura', 1105.0000, 'ºC'),
	(116864, 112, '2015-03-15 00:44:28.000000', 'temperatura', 616.0000, 'ºC'),
	(116865, 112, '2015-03-15 00:44:29.000000', 'temperatura', 965.0000, 'ºC'),
	(116866, 112, '2015-03-15 00:44:30.000000', 'temperatura', 578.0000, 'ºC'),
	(116867, 112, '2015-03-15 00:44:31.000000', 'temperatura', 1194.0000, 'ºC'),
	(116868, 112, '2015-03-15 00:44:32.000000', 'temperatura', 639.0000, 'ºC'),
	(116869, 112, '2015-03-15 00:44:33.000000', 'temperatura', 813.0000, 'ºC'),
	(116870, 112, '2015-03-15 00:44:34.000000', 'temperatura', 948.0000, 'ºC'),
	(116871, 112, '2015-03-15 00:44:35.000000', 'temperatura', 1103.0000, 'ºC'),
	(116872, 112, '2015-03-15 00:44:36.000000', 'temperatura', 269.0000, 'ºC'),
	(116873, 112, '2015-03-15 00:44:37.000000', 'temperatura', 438.0000, 'ºC'),
	(116874, 112, '2015-03-15 00:44:38.000000', 'temperatura', 182.0000, 'ºC'),
	(116875, 112, '2015-03-15 00:44:39.000000', 'temperatura', 799.0000, 'ºC'),
	(116876, 112, '2015-03-15 00:44:40.000000', 'temperatura', 1046.0000, 'ºC'),
	(116877, 112, '2015-03-15 00:44:41.000000', 'temperatura', 436.0000, 'ºC'),
	(116878, 112, '2015-03-15 00:44:42.000000', 'temperatura', 242.0000, 'ºC'),
	(116879, 112, '2015-03-15 00:44:43.000000', 'temperatura', 1104.0000, 'ºC'),
	(116880, 112, '2015-03-15 00:44:44.000000', 'temperatura', 1194.0000, 'ºC'),
	(116881, 112, '2015-03-15 00:44:45.000000', 'temperatura', 259.0000, 'ºC'),
	(116882, 112, '2015-03-15 00:44:46.000000', 'temperatura', 114.0000, 'ºC'),
	(116883, 112, '2015-03-15 00:44:47.000000', 'temperatura', 992.0000, 'ºC'),
	(116884, 112, '2015-03-15 00:44:48.000000', 'temperatura', 1018.0000, 'ºC'),
	(116885, 112, '2015-03-15 00:44:49.000000', 'temperatura', 914.0000, 'ºC'),
	(116886, 112, '2015-03-15 00:44:50.000000', 'temperatura', 317.0000, 'ºC'),
	(116887, 112, '2015-03-15 00:44:51.000000', 'temperatura', 46.0000, 'ºC'),
	(116888, 112, '2015-03-15 00:44:52.000000', 'temperatura', 476.0000, 'ºC'),
	(116889, 112, '2015-03-15 00:44:53.000000', 'temperatura', 1045.0000, 'ºC'),
	(116890, 112, '2015-03-15 00:44:54.000000', 'temperatura', 199.0000, 'ºC'),
	(116891, 112, '2015-03-15 00:44:55.000000', 'temperatura', 258.0000, 'ºC'),
	(116892, 112, '2015-03-15 00:44:56.000000', 'temperatura', 694.0000, 'ºC'),
	(116893, 112, '2015-03-15 00:44:57.000000', 'temperatura', 296.0000, 'ºC'),
	(116894, 112, '2015-03-15 00:44:58.000000', 'temperatura', 598.0000, 'ºC'),
	(116895, 112, '2015-03-15 00:44:59.000000', 'temperatura', 903.0000, 'ºC'),
	(116896, 112, '2015-03-15 00:45:00.000000', 'temperatura', 324.0000, 'ºC'),
	(116897, 112, '2015-03-15 00:45:01.000000', 'temperatura', 108.0000, 'ºC'),
	(116898, 112, '2015-03-15 00:45:02.000000', 'temperatura', 771.0000, 'ºC'),
	(116899, 112, '2015-03-15 00:45:03.000000', 'temperatura', 1129.0000, 'ºC'),
	(116900, 112, '2015-03-15 00:45:04.000000', 'temperatura', 932.0000, 'ºC'),
	(116901, 112, '2015-03-15 00:45:05.000000', 'temperatura', 75.0000, 'ºC'),
	(116902, 112, '2015-03-15 00:45:06.000000', 'temperatura', 1181.0000, 'ºC'),
	(116903, 112, '2015-03-15 00:45:07.000000', 'temperatura', 878.0000, 'ºC'),
	(116904, 112, '2015-03-15 00:45:08.000000', 'temperatura', 846.0000, 'ºC'),
	(116905, 112, '2015-03-15 00:45:09.000000', 'temperatura', 400.0000, 'ºC'),
	(116906, 112, '2015-03-15 00:45:10.000000', 'temperatura', 662.0000, 'ºC'),
	(116907, 112, '2015-03-15 00:45:11.000000', 'temperatura', 909.0000, 'ºC'),
	(116908, 112, '2015-03-15 00:45:12.000000', 'temperatura', 162.0000, 'ºC'),
	(116909, 112, '2015-03-15 00:45:13.000000', 'temperatura', 483.0000, 'ºC'),
	(116910, 112, '2015-03-15 00:45:14.000000', 'temperatura', 727.0000, 'ºC'),
	(116911, 112, '2015-03-15 00:45:15.000000', 'temperatura', 988.0000, 'ºC'),
	(116912, 112, '2015-03-15 00:45:16.000000', 'temperatura', 361.0000, 'ºC'),
	(116913, 112, '2015-03-15 00:45:17.000000', 'temperatura', 42.0000, 'ºC'),
	(116914, 112, '2015-03-15 00:45:18.000000', 'temperatura', 328.0000, 'ºC'),
	(116915, 112, '2015-03-15 00:45:19.000000', 'temperatura', 313.0000, 'ºC'),
	(116916, 112, '2015-03-15 00:45:20.000000', 'temperatura', 581.0000, 'ºC'),
	(116917, 112, '2015-03-15 00:45:21.000000', 'temperatura', 768.0000, 'ºC'),
	(116918, 112, '2015-03-15 00:45:22.000000', 'temperatura', 899.0000, 'ºC'),
	(116919, 112, '2015-03-15 00:45:23.000000', 'temperatura', 989.0000, 'ºC'),
	(116920, 112, '2015-03-15 00:45:24.000000', 'temperatura', 1050.0000, 'ºC'),
	(116921, 112, '2015-03-15 00:45:25.000000', 'temperatura', 1082.0000, 'ºC'),
	(116922, 112, '2015-03-15 00:45:26.000000', 'temperatura', 1063.0000, 'ºC'),
	(116923, 112, '2015-03-15 00:45:27.000000', 'temperatura', 868.0000, 'ºC'),
	(116924, 112, '2015-03-15 00:45:28.000000', 'temperatura', 1151.0000, 'ºC'),
	(116925, 112, '2015-03-15 00:45:29.000000', 'temperatura', 752.0000, 'ºC'),
	(116926, 112, '2015-03-15 00:45:30.000000', 'temperatura', 306.0000, 'ºC'),
	(116927, 112, '2015-03-15 00:45:31.000000', 'temperatura', 476.0000, 'ºC'),
	(116928, 112, '2015-03-15 00:45:32.000000', 'temperatura', 264.0000, 'ºC'),
	(116929, 112, '2015-03-15 00:45:33.000000', 'temperatura', 1092.0000, 'ºC'),
	(116930, 112, '2015-03-15 00:45:34.000000', 'temperatura', 1068.0000, 'ºC'),
	(116931, 112, '2015-03-15 00:45:35.000000', 'temperatura', 864.0000, 'ºC'),
	(116932, 112, '2015-03-15 00:45:36.000000', 'temperatura', 1115.0000, 'ºC'),
	(116933, 112, '2015-03-15 00:45:37.000000', 'temperatura', 585.0000, 'ºC'),
	(116934, 112, '2015-03-15 00:45:38.000000', 'temperatura', 779.0000, 'ºC'),
	(116935, 112, '2015-03-15 00:45:39.000000', 'temperatura', 942.0000, 'ºC'),
	(116936, 112, '2015-03-15 00:45:40.000000', 'temperatura', 1172.0000, 'ºC'),
	(116937, 112, '2015-03-15 00:45:41.000000', 'temperatura', 636.0000, 'ºC'),
	(116938, 112, '2015-03-15 00:45:42.000000', 'temperatura', 864.0000, 'ºC'),
	(116939, 112, '2015-03-15 00:45:43.000000', 'temperatura', 12.0000, 'ºC'),
	(116940, 112, '2015-03-15 00:45:44.000000', 'temperatura', 1069.0000, 'ºC'),
	(116941, 112, '2015-03-15 00:45:45.000000', 'temperatura', 508.0000, 'ºC'),
	(116942, 112, '2015-03-15 00:45:46.000000', 'temperatura', 537.0000, 'ºC'),
	(116943, 112, '2015-03-15 00:45:47.000000', 'temperatura', 1158.0000, 'ºC'),
	(116944, 112, '2015-03-15 00:45:48.000000', 'temperatura', 580.0000, 'ºC'),
	(116945, 112, '2015-03-15 00:45:49.000000', 'temperatura', 629.0000, 'ºC'),
	(116946, 112, '2015-03-15 00:45:50.000000', 'temperatura', 203.0000, 'ºC'),
	(116947, 112, '2015-03-15 00:45:51.000000', 'temperatura', 328.0000, 'ºC'),
	(116948, 112, '2015-03-15 00:45:52.000000', 'temperatura', 1032.0000, 'ºC'),
	(116949, 112, '2015-03-15 00:45:53.000000', 'temperatura', 576.0000, 'ºC'),
	(116950, 112, '2015-03-15 00:45:54.000000', 'temperatura', 984.0000, 'ºC'),
	(116951, 112, '2015-03-15 00:45:55.000000', 'temperatura', 795.0000, 'ºC'),
	(116952, 112, '2015-03-15 00:45:56.000000', 'temperatura', 1024.0000, 'ºC'),
	(116953, 112, '2015-03-15 00:45:57.000000', 'temperatura', 333.0000, 'ºC'),
	(116954, 112, '2015-03-15 00:45:58.000000', 'temperatura', 997.0000, 'ºC'),
	(116955, 112, '2015-03-15 00:45:59.000000', 'temperatura', 383.0000, 'ºC'),
	(116956, 112, '2015-03-15 00:46:00.000000', 'temperatura', 124.0000, 'ºC'),
	(116957, 112, '2015-03-15 00:46:01.000000', 'temperatura', 674.0000, 'ºC'),
	(116958, 112, '2015-03-15 00:46:02.000000', 'temperatura', 596.0000, 'ºC'),
	(116959, 112, '2015-03-15 00:46:03.000000', 'temperatura', 958.0000, 'ºC'),
	(116960, 112, '2015-03-15 00:46:04.000000', 'temperatura', 602.0000, 'ºC'),
	(116961, 112, '2015-03-15 00:46:05.000000', 'temperatura', 139.0000, 'ºC'),
	(116962, 112, '2015-03-15 00:46:06.000000', 'temperatura', 90.0000, 'ºC'),
	(116963, 112, '2015-03-15 00:46:07.000000', 'temperatura', 31.0000, 'ºC'),
	(116964, 112, '2015-03-15 00:46:08.000000', 'temperatura', 1086.0000, 'ºC'),
	(116965, 112, '2015-03-15 00:46:09.000000', 'temperatura', 538.0000, 'ºC'),
	(116966, 112, '2015-03-15 00:46:10.000000', 'temperatura', 632.0000, 'ºC'),
	(116967, 112, '2015-03-15 00:46:11.000000', 'temperatura', 345.0000, 'ºC'),
	(116968, 112, '2015-03-15 00:46:12.000000', 'temperatura', 1032.0000, 'ºC'),
	(116969, 112, '2015-03-15 00:46:13.000000', 'temperatura', 525.0000, 'ºC'),
	(116970, 112, '2015-03-15 00:46:14.000000', 'temperatura', 731.0000, 'ºC'),
	(116971, 112, '2015-03-15 00:46:15.000000', 'temperatura', 881.0000, 'ºC'),
	(116972, 112, '2015-03-15 00:46:16.000000', 'temperatura', 1011.0000, 'ºC'),
	(116973, 112, '2015-03-15 00:46:17.000000', 'temperatura', 12.0000, 'ºC'),
	(116974, 112, '2015-03-15 00:46:18.000000', 'temperatura', 626.0000, 'ºC'),
	(116975, 112, '2015-03-15 00:46:19.000000', 'temperatura', 696.0000, 'ºC'),
	(116976, 112, '2015-03-15 00:46:20.000000', 'temperatura', 400.0000, 'ºC'),
	(116977, 112, '2015-03-15 00:46:21.000000', 'temperatura', 1116.0000, 'ºC'),
	(116978, 112, '2015-03-15 00:46:22.000000', 'temperatura', 780.0000, 'ºC'),
	(116979, 112, '2015-03-15 00:46:23.000000', 'temperatura', 553.0000, 'ºC'),
	(116980, 112, '2015-03-15 00:46:24.000000', 'temperatura', 427.0000, 'ºC'),
	(116981, 112, '2015-03-15 00:46:25.000000', 'temperatura', 474.0000, 'ºC'),
	(116982, 112, '2015-03-15 00:46:26.000000', 'temperatura', 1091.0000, 'ºC'),
	(116983, 112, '2015-03-15 00:46:27.000000', 'temperatura', 432.0000, 'ºC'),
	(116984, 112, '2015-03-15 00:46:28.000000', 'temperatura', 86.0000, 'ºC'),
	(116985, 112, '2015-03-15 00:46:29.000000', 'temperatura', 336.0000, 'ºC'),
	(116986, 112, '2015-03-15 00:46:30.000000', 'temperatura', 223.0000, 'ºC'),
	(116987, 112, '2015-03-15 00:46:31.000000', 'temperatura', 109.0000, 'ºC'),
	(116988, 112, '2015-03-15 00:46:32.000000', 'temperatura', 1075.0000, 'ºC'),
	(116989, 112, '2015-03-15 00:46:33.000000', 'temperatura', 247.0000, 'ºC'),
	(116990, 112, '2015-03-15 00:46:34.000000', 'temperatura', 411.0000, 'ºC'),
	(116991, 112, '2015-03-15 00:46:35.000000', 'temperatura', 113.0000, 'ºC'),
	(116992, 112, '2015-03-15 00:46:36.000000', 'temperatura', 536.0000, 'ºC'),
	(116993, 112, '2015-03-15 00:46:37.000000', 'temperatura', 1138.0000, 'ºC'),
	(116994, 112, '2015-03-15 00:46:38.000000', 'temperatura', 485.0000, 'ºC'),
	(116995, 112, '2015-03-15 00:46:39.000000', 'temperatura', 211.0000, 'ºC'),
	(116996, 112, '2015-03-15 00:46:40.000000', 'temperatura', 800.0000, 'ºC'),
	(116997, 112, '2015-03-15 00:46:41.000000', 'temperatura', 966.0000, 'ºC'),
	(116998, 112, '2015-03-15 00:46:42.000000', 'temperatura', 32.0000, 'ºC'),
	(116999, 112, '2015-03-15 00:46:43.000000', 'temperatura', 864.0000, 'ºC'),
	(117000, 112, '2015-03-15 00:46:44.000000', 'temperatura', 624.0000, 'ºC'),
	(117001, 112, '2015-03-15 00:46:45.000000', 'temperatura', 528.0000, 'ºC'),
	(117002, 112, '2015-03-15 00:46:46.000000', 'temperatura', 768.0000, 'ºC'),
	(117003, 112, '2015-03-15 00:46:47.000000', 'temperatura', 1056.0000, 'ºC'),
	(117004, 112, '2015-03-15 00:46:48.000000', 'temperatura', 578.0000, 'ºC'),
	(117005, 112, '2015-03-15 00:46:49.000000', 'temperatura', 923.0000, 'ºC'),
	(117006, 112, '2015-03-15 00:46:50.000000', 'temperatura', 482.0000, 'ºC'),
	(117007, 112, '2015-03-15 00:46:51.000000', 'temperatura', 842.0000, 'ºC'),
	(117008, 112, '2015-03-15 00:46:52.000000', 'temperatura', 362.0000, 'ºC'),
	(117009, 112, '2015-03-15 00:46:53.000000', 'temperatura', 487.0000, 'ºC'),
	(117010, 112, '2015-03-15 00:46:54.000000', 'temperatura', 148.0000, 'ºC'),
	(117011, 112, '2015-03-15 00:46:55.000000', 'temperatura', 478.0000, 'ºC'),
	(117012, 112, '2015-03-15 00:46:56.000000', 'temperatura', 749.0000, 'ºC'),
	(117013, 112, '2015-03-15 00:46:57.000000', 'temperatura', 1113.0000, 'ºC'),
	(117014, 112, '2015-03-15 00:46:58.000000', 'temperatura', 916.0000, 'ºC'),
	(117015, 112, '2015-03-15 00:46:59.000000', 'temperatura', 40.0000, 'ºC'),
	(117016, 112, '2015-03-15 00:47:00.000000', 'temperatura', 1054.0000, 'ºC'),
	(117017, 112, '2015-03-15 00:47:01.000000', 'temperatura', 351.0000, 'ºC'),
	(117018, 112, '2015-03-15 00:47:02.000000', 'temperatura', 994.0000, 'ºC'),
	(117019, 112, '2015-03-15 00:47:03.000000', 'temperatura', 318.0000, 'ºC'),
	(117020, 112, '2015-03-15 00:47:04.000000', 'temperatura', 1009.0000, 'ºC'),
	(117021, 112, '2015-03-15 00:47:05.000000', 'temperatura', 489.0000, 'ºC'),
	(117022, 112, '2015-03-15 00:47:06.000000', 'temperatura', 620.0000, 'ºC'),
	(117023, 112, '2015-03-15 00:47:07.000000', 'temperatura', 433.0000, 'ºC'),
	(117024, 112, '2015-03-15 00:47:08.000000', 'temperatura', 304.0000, 'ºC'),
	(117025, 112, '2015-03-15 00:47:09.000000', 'temperatura', 222.0000, 'ºC'),
	(117026, 112, '2015-03-15 00:47:10.000000', 'temperatura', 200.0000, 'ºC'),
	(117027, 112, '2015-03-15 00:47:11.000000', 'temperatura', 333.0000, 'ºC'),
	(117028, 112, '2015-03-15 00:47:12.000000', 'temperatura', 1065.0000, 'ºC'),
	(117029, 112, '2015-03-15 00:47:13.000000', 'temperatura', 728.0000, 'ºC'),
	(117030, 112, '2015-03-15 00:47:14.000000', 'temperatura', 443.0000, 'ºC'),
	(117031, 112, '2015-03-15 00:47:15.000000', 'temperatura', 33.0000, 'ºC'),
	(117032, 112, '2015-03-15 00:47:16.000000', 'temperatura', 35.0000, 'ºC'),
	(117033, 112, '2015-03-15 00:47:17.000000', 'temperatura', 77.0000, 'ºC'),
	(117034, 112, '2015-03-15 00:47:18.000000', 'temperatura', 280.0000, 'ºC'),
	(117035, 112, '2015-03-15 00:47:19.000000', 'temperatura', 1170.0000, 'ºC'),
	(117036, 112, '2015-03-15 00:47:20.000000', 'temperatura', 212.0000, 'ºC'),
	(117037, 112, '2015-03-15 00:47:21.000000', 'temperatura', 1151.0000, 'ºC'),
	(117038, 112, '2015-03-15 00:47:22.000000', 'temperatura', 317.0000, 'ºC'),
	(117039, 112, '2015-03-15 00:47:23.000000', 'temperatura', 533.0000, 'ºC'),
	(117040, 112, '2015-03-15 00:47:24.000000', 'temperatura', 517.0000, 'ºC'),
	(117041, 112, '2015-03-15 00:47:25.000000', 'temperatura', 984.0000, 'ºC'),
	(117042, 112, '2015-03-15 00:47:26.000000', 'temperatura', 971.0000, 'ºC'),
	(117043, 112, '2015-03-15 00:47:27.000000', 'temperatura', 702.0000, 'ºC'),
	(117044, 112, '2015-03-15 00:47:28.000000', 'temperatura', 597.0000, 'ºC'),
	(117045, 112, '2015-03-15 00:47:29.000000', 'temperatura', 881.0000, 'ºC'),
	(117046, 112, '2015-03-15 00:47:30.000000', 'temperatura', 216.0000, 'ºC'),
	(117047, 112, '2015-03-15 00:47:31.000000', 'temperatura', 834.0000, 'ºC'),
	(117048, 112, '2015-03-15 00:47:32.000000', 'temperatura', 1124.0000, 'ºC'),
	(117049, 112, '2015-03-15 00:47:33.000000', 'temperatura', 718.0000, 'ºC'),
	(117050, 112, '2015-03-15 00:47:34.000000', 'temperatura', 219.0000, 'ºC'),
	(117051, 112, '2015-03-15 00:47:35.000000', 'temperatura', 141.0000, 'ºC'),
	(117052, 112, '2015-03-15 00:47:36.000000', 'temperatura', 49.0000, 'ºC'),
	(117053, 112, '2015-03-15 00:47:37.000000', 'temperatura', 1024.0000, 'ºC'),
	(117054, 112, '2015-03-15 00:47:38.000000', 'temperatura', 174.0000, 'ºC'),
	(117055, 112, '2015-03-15 00:47:39.000000', 'temperatura', 198.0000, 'ºC'),
	(117056, 112, '2015-03-15 00:47:40.000000', 'temperatura', 469.0000, 'ºC'),
	(117057, 112, '2015-03-15 00:47:41.000000', 'temperatura', 553.0000, 'ºC'),
	(117058, 112, '2015-03-15 00:47:42.000000', 'temperatura', 156.0000, 'ºC'),
	(117059, 112, '2015-03-15 00:47:43.000000', 'temperatura', 322.0000, 'ºC'),
	(117060, 112, '2015-03-15 00:47:44.000000', 'temperatura', 1143.0000, 'ºC'),
	(117061, 112, '2015-03-15 00:47:45.000000', 'temperatura', 1149.0000, 'ºC'),
	(117062, 112, '2015-03-15 00:47:46.000000', 'temperatura', 1116.0000, 'ºC'),
	(117063, 112, '2015-03-15 00:47:47.000000', 'temperatura', 935.0000, 'ºC'),
	(117064, 112, '2015-03-15 00:47:48.000000', 'temperatura', 125.0000, 'ºC'),
	(117065, 112, '2015-03-15 00:47:49.000000', 'temperatura', 224.0000, 'ºC'),
	(117066, 112, '2015-03-15 00:47:50.000000', 'temperatura', 743.0000, 'ºC'),
	(117067, 112, '2015-03-15 00:47:51.000000', 'temperatura', 642.0000, 'ºC'),
	(117068, 112, '2015-03-15 00:47:52.000000', 'temperatura', 983.0000, 'ºC'),
	(117069, 112, '2015-03-15 00:47:53.000000', 'temperatura', 590.0000, 'ºC'),
	(117070, 112, '2015-03-15 00:47:54.000000', 'temperatura', 0.0000, 'ºC'),
	(117071, 112, '2015-03-15 00:47:55.000000', 'temperatura', 631.0000, 'ºC'),
	(117072, 112, '2015-03-15 00:47:56.000000', 'temperatura', 756.0000, 'ºC'),
	(117073, 112, '2015-03-15 00:47:57.000000', 'temperatura', 685.0000, 'ºC'),
	(117074, 112, '2015-03-15 00:47:58.000000', 'temperatura', 1160.0000, 'ºC'),
	(117075, 112, '2015-03-15 00:47:59.000000', 'temperatura', 146.0000, 'ºC'),
	(117076, 112, '2015-03-15 00:48:00.000000', 'temperatura', 852.0000, 'ºC'),
	(117077, 112, '2015-03-15 00:48:01.000000', 'temperatura', 219.0000, 'ºC'),
	(117078, 112, '2015-03-15 00:48:02.000000', 'temperatura', 942.0000, 'ºC'),
	(117079, 112, '2015-03-15 00:48:03.000000', 'temperatura', 453.0000, 'ºC'),
	(117080, 112, '2015-03-15 00:48:04.000000', 'temperatura', 640.0000, 'ºC'),
	(117081, 112, '2015-03-15 00:48:05.000000', 'temperatura', 642.0000, 'ºC'),
	(117082, 112, '2015-03-15 00:48:06.000000', 'temperatura', 88.0000, 'ºC'),
	(117083, 112, '2015-03-15 00:48:07.000000', 'temperatura', 915.0000, 'ºC'),
	(117084, 112, '2015-03-15 00:48:08.000000', 'temperatura', 713.0000, 'ºC'),
	(117085, 112, '2015-03-15 00:48:09.000000', 'temperatura', 821.0000, 'ºC'),
	(117086, 112, '2015-03-15 00:48:10.000000', 'temperatura', 767.0000, 'ºC'),
	(117087, 112, '2015-03-15 00:48:11.000000', 'temperatura', 171.0000, 'ºC'),
	(117088, 112, '2015-03-15 00:48:12.000000', 'temperatura', 956.0000, 'ºC'),
	(117089, 112, '2015-03-15 00:48:13.000000', 'temperatura', 665.0000, 'ºC'),
	(117090, 112, '2015-03-15 00:48:14.000000', 'temperatura', 460.0000, 'ºC'),
	(117091, 112, '2015-03-15 00:48:15.000000', 'temperatura', 304.0000, 'ºC'),
	(117092, 112, '2015-03-15 00:48:16.000000', 'temperatura', 142.0000, 'ºC'),
	(117093, 112, '2015-03-15 00:48:17.000000', 'temperatura', 999.0000, 'ºC'),
	(117094, 112, '2015-03-15 00:48:18.000000', 'temperatura', 968.0000, 'ºC'),
	(117095, 112, '2015-03-15 00:48:19.000000', 'temperatura', 643.0000, 'ºC'),
	(117096, 112, '2015-03-15 00:48:20.000000', 'temperatura', 311.0000, 'ºC'),
	(117097, 112, '2015-03-15 00:48:21.000000', 'temperatura', 829.0000, 'ºC'),
	(117098, 112, '2015-03-15 00:48:22.000000', 'temperatura', 812.0000, 'ºC'),
	(117099, 112, '2015-03-15 00:48:23.000000', 'temperatura', 375.0000, 'ºC'),
	(117100, 112, '2015-03-15 00:48:24.000000', 'temperatura', 638.0000, 'ºC'),
	(117101, 112, '2015-03-15 00:48:25.000000', 'temperatura', 867.0000, 'ºC'),
	(117102, 112, '2015-03-15 00:48:26.000000', 'temperatura', 21.0000, 'ºC'),
	(117103, 112, '2015-03-15 00:48:27.000000', 'temperatura', 1106.0000, 'ºC'),
	(117104, 112, '2015-03-15 00:48:28.000000', 'temperatura', 666.0000, 'ºC'),
	(117105, 112, '2015-03-15 00:48:29.000000', 'temperatura', 14.0000, 'ºC'),
	(117106, 112, '2015-03-15 00:48:30.000000', 'temperatura', 471.0000, 'ºC'),
	(117107, 112, '2015-03-15 00:48:31.000000', 'temperatura', 1113.0000, 'ºC'),
	(117108, 112, '2015-03-15 00:48:32.000000', 'temperatura', 552.0000, 'ºC'),
	(117109, 112, '2015-03-15 00:48:33.000000', 'temperatura', 621.0000, 'ºC'),
	(117110, 112, '2015-03-15 00:48:34.000000', 'temperatura', 249.0000, 'ºC'),
	(117111, 112, '2015-03-15 00:48:35.000000', 'temperatura', 582.0000, 'ºC'),
	(117112, 112, '2015-03-15 00:48:36.000000', 'temperatura', 963.0000, 'ºC'),
	(117113, 112, '2015-03-15 00:48:37.000000', 'temperatura', 672.0000, 'ºC'),
	(117114, 112, '2015-03-15 00:48:38.000000', 'temperatura', 469.0000, 'ºC'),
	(117115, 112, '2015-03-15 00:48:39.000000', 'temperatura', 330.0000, 'ºC'),
	(117116, 112, '2015-03-15 00:48:40.000000', 'temperatura', 245.0000, 'ºC'),
	(117117, 112, '2015-03-15 00:48:41.000000', 'temperatura', 234.0000, 'ºC'),
	(117118, 112, '2015-03-15 00:48:42.000000', 'temperatura', 434.0000, 'ºC'),
	(117119, 112, '2015-03-15 00:48:43.000000', 'temperatura', 271.0000, 'ºC'),
	(117120, 112, '2015-03-15 00:48:44.000000', 'temperatura', 51.0000, 'ºC'),
	(117121, 112, '2015-03-15 00:48:45.000000', 'temperatura', 644.0000, 'ºC'),
	(117122, 112, '2015-03-15 00:48:46.000000', 'temperatura', 669.0000, 'ºC'),
	(117123, 112, '2015-03-15 00:48:47.000000', 'temperatura', 214.0000, 'ºC'),
	(117124, 112, '2015-03-15 00:48:48.000000', 'temperatura', 262.0000, 'ºC'),
	(117125, 112, '2015-03-15 00:48:49.000000', 'temperatura', 668.0000, 'ºC'),
	(117126, 112, '2015-03-15 00:48:50.000000', 'temperatura', 155.0000, 'ºC'),
	(117127, 112, '2015-03-15 00:48:51.000000', 'temperatura', 1173.0000, 'ºC'),
	(117128, 112, '2015-03-15 00:48:52.000000', 'temperatura', 599.0000, 'ºC'),
	(117129, 112, '2015-03-15 00:48:53.000000', 'temperatura', 678.0000, 'ºC'),
	(117130, 112, '2015-03-15 00:48:54.000000', 'temperatura', 391.0000, 'ºC'),
	(117131, 112, '2015-03-15 00:48:55.000000', 'temperatura', 1123.0000, 'ºC'),
	(117132, 112, '2015-03-15 00:48:56.000000', 'temperatura', 843.0000, 'ºC'),
	(117133, 112, '2015-03-15 00:48:57.000000', 'temperatura', 847.0000, 'ºC'),
	(117134, 112, '2015-03-15 00:48:58.000000', 'temperatura', 507.0000, 'ºC'),
	(117135, 112, '2015-03-15 00:48:59.000000', 'temperatura', 1195.0000, 'ºC'),
	(117136, 112, '2015-03-15 00:49:00.000000', 'temperatura', 854.0000, 'ºC'),
	(117137, 112, '2015-03-15 00:49:01.000000', 'temperatura', 686.0000, 'ºC'),
	(117138, 112, '2015-03-15 00:49:02.000000', 'temperatura', 868.0000, 'ºC'),
	(117139, 112, '2015-03-15 00:49:03.000000', 'temperatura', 1082.0000, 'ºC'),
	(117140, 112, '2015-03-15 00:49:04.000000', 'temperatura', 405.0000, 'ºC'),
	(117141, 112, '2015-03-15 00:49:05.000000', 'temperatura', 1180.0000, 'ºC'),
	(117142, 112, '2015-03-15 00:49:06.000000', 'temperatura', 1085.0000, 'ºC'),
	(117143, 112, '2015-03-15 00:49:07.000000', 'temperatura', 687.0000, 'ºC'),
	(117144, 112, '2015-03-15 00:49:08.000000', 'temperatura', 182.0000, 'ºC'),
	(117145, 112, '2015-03-15 00:49:09.000000', 'temperatura', 47.0000, 'ºC'),
	(117146, 112, '2015-03-15 00:49:10.000000', 'temperatura', 890.0000, 'ºC'),
	(117147, 112, '2015-03-15 00:49:11.000000', 'temperatura', 708.0000, 'ºC'),
	(117148, 112, '2015-03-15 00:49:12.000000', 'temperatura', 873.0000, 'ºC'),
	(117149, 112, '2015-03-15 00:49:13.000000', 'temperatura', 1040.0000, 'ºC'),
	(117150, 112, '2015-03-15 00:49:14.000000', 'temperatura', 182.0000, 'ºC'),
	(117151, 112, '2015-03-15 00:49:15.000000', 'temperatura', 188.0000, 'ºC'),
	(117152, 112, '2015-03-15 00:49:16.000000', 'temperatura', 398.0000, 'ºC'),
	(117153, 112, '2015-03-15 00:49:17.000000', 'temperatura', 223.0000, 'ºC'),
	(117154, 112, '2015-03-15 00:49:18.000000', 'temperatura', 1124.0000, 'ºC'),
	(117155, 112, '2015-03-15 00:49:19.000000', 'temperatura', 152.0000, 'ºC'),
	(117156, 112, '2015-03-15 00:49:20.000000', 'temperatura', 987.0000, 'ºC'),
	(117157, 112, '2015-03-15 00:49:21.000000', 'temperatura', 881.0000, 'ºC'),
	(117158, 112, '2015-03-15 00:49:22.000000', 'temperatura', 242.0000, 'ºC'),
	(117159, 112, '2015-03-15 00:49:23.000000', 'temperatura', 968.0000, 'ºC'),
	(117160, 112, '2015-03-15 00:49:24.000000', 'temperatura', 516.0000, 'ºC'),
	(117161, 112, '2015-03-15 00:49:25.000000', 'temperatura', 877.0000, 'ºC'),
	(117162, 112, '2015-03-15 00:49:26.000000', 'temperatura', 436.0000, 'ºC'),
	(117163, 112, '2015-03-15 00:49:27.000000', 'temperatura', 750.0000, 'ºC'),
	(117164, 112, '2015-03-15 00:49:28.000000', 'temperatura', 41.0000, 'ºC'),
	(117165, 112, '2015-03-15 00:49:29.000000', 'temperatura', 354.0000, 'ºC'),
	(117166, 112, '2015-03-15 00:49:30.000000', 'temperatura', 451.0000, 'ºC'),
	(117167, 112, '2015-03-15 00:49:31.000000', 'temperatura', 1194.0000, 'ºC'),
	(117168, 112, '2015-03-15 00:49:32.000000', 'temperatura', 1017.0000, 'ºC'),
	(117169, 112, '2015-03-15 00:49:33.000000', 'temperatura', 301.0000, 'ºC'),
	(117170, 112, '2015-03-15 00:49:34.000000', 'temperatura', 858.0000, 'ºC'),
	(117171, 112, '2015-03-15 00:49:35.000000', 'temperatura', 985.0000, 'ºC'),
	(117172, 112, '2015-03-15 00:49:36.000000', 'temperatura', 1154.0000, 'ºC'),
	(117173, 112, '2015-03-15 00:49:37.000000', 'temperatura', 414.0000, 'ºC'),
	(117174, 112, '2015-03-15 00:49:38.000000', 'temperatura', 1011.0000, 'ºC'),
	(117175, 112, '2015-03-15 00:49:39.000000', 'temperatura', 211.0000, 'ºC'),
	(117176, 112, '2015-03-15 00:49:40.000000', 'temperatura', 423.0000, 'ºC'),
	(117177, 112, '2015-03-15 00:49:41.000000', 'temperatura', 284.0000, 'ºC'),
	(117178, 112, '2015-03-15 00:49:42.000000', 'temperatura', 148.0000, 'ºC'),
	(117179, 112, '2015-03-15 00:49:43.000000', 'temperatura', 1092.0000, 'ºC'),
	(117180, 112, '2015-03-15 00:49:44.000000', 'temperatura', 216.0000, 'ºC'),
	(117181, 112, '2015-03-15 00:49:45.000000', 'temperatura', 204.0000, 'ºC'),
	(117182, 112, '2015-03-15 00:49:46.000000', 'temperatura', 372.0000, 'ºC'),
	(117183, 112, '2015-03-15 00:49:47.000000', 'temperatura', 49.0000, 'ºC'),
	(117184, 112, '2015-03-15 00:49:48.000000', 'temperatura', 331.0000, 'ºC'),
	(117185, 112, '2015-03-15 00:49:49.000000', 'temperatura', 306.0000, 'ºC'),
	(117186, 112, '2015-03-15 00:49:50.000000', 'temperatura', 540.0000, 'ºC'),
	(117187, 112, '2015-03-15 00:49:51.000000', 'temperatura', 582.0000, 'ºC'),
	(117188, 112, '2015-03-15 00:49:52.000000', 'temperatura', 90.0000, 'ºC'),
	(117189, 112, '2015-03-15 00:49:53.000000', 'temperatura', 1103.0000, 'ºC'),
	(117190, 112, '2015-03-15 00:49:54.000000', 'temperatura', 447.0000, 'ºC'),
	(117191, 112, '2015-03-15 00:49:55.000000', 'temperatura', 125.0000, 'ºC'),
	(117192, 112, '2015-03-15 00:49:56.000000', 'temperatura', 486.0000, 'ºC'),
	(117193, 112, '2015-03-15 00:49:57.000000', 'temperatura', 855.0000, 'ºC'),
	(117194, 112, '2015-03-15 00:49:58.000000', 'temperatura', 417.0000, 'ºC'),
	(117195, 112, '2015-03-15 00:49:59.000000', 'temperatura', 722.0000, 'ºC'),
	(117196, 112, '2015-03-15 00:50:00.000000', 'temperatura', 1160.0000, 'ºC'),
	(117197, 112, '2015-03-15 00:50:01.000000', 'temperatura', 32.0000, 'ºC'),
	(117198, 112, '2015-03-15 00:50:02.000000', 'temperatura', 283.0000, 'ºC'),
	(117199, 112, '2015-03-15 00:50:03.000000', 'temperatura', 117.0000, 'ºC'),
	(117200, 112, '2015-03-15 00:50:04.000000', 'temperatura', 938.0000, 'ºC'),
	(117201, 112, '2015-03-15 00:50:05.000000', 'temperatura', 737.0000, 'ºC'),
	(117202, 112, '2015-03-15 00:50:06.000000', 'temperatura', 874.0000, 'ºC'),
	(117203, 112, '2015-03-15 00:50:07.000000', 'temperatura', 958.0000, 'ºC'),
	(117204, 112, '2015-03-15 00:50:08.000000', 'temperatura', 969.0000, 'ºC'),
	(117205, 112, '2015-03-15 00:50:09.000000', 'temperatura', 771.0000, 'ºC'),
	(117206, 112, '2015-03-15 00:50:10.000000', 'temperatura', 947.0000, 'ºC'),
	(117207, 112, '2015-03-15 00:50:11.000000', 'temperatura', 26.0000, 'ºC'),
	(117208, 112, '2015-03-15 00:50:12.000000', 'temperatura', 887.0000, 'ºC'),
	(117209, 112, '2015-03-15 00:50:13.000000', 'temperatura', 760.0000, 'ºC'),
	(117210, 112, '2015-03-15 00:50:14.000000', 'temperatura', 1138.0000, 'ºC'),
	(117211, 112, '2015-03-15 00:50:15.000000', 'temperatura', 1013.0000, 'ºC'),
	(117212, 112, '2015-03-15 00:50:16.000000', 'temperatura', 449.0000, 'ºC'),
	(117213, 112, '2015-03-15 00:50:17.000000', 'temperatura', 407.0000, 'ºC'),
	(117214, 112, '2015-03-15 00:50:18.000000', 'temperatura', 690.0000, 'ºC'),
	(117215, 112, '2015-03-15 00:50:19.000000', 'temperatura', 1029.0000, 'ºC'),
	(117216, 112, '2015-03-15 00:50:20.000000', 'temperatura', 675.0000, 'ºC'),
	(117217, 112, '2015-03-15 00:50:21.000000', 'temperatura', 288.0000, 'ºC'),
	(117218, 112, '2015-03-15 00:50:22.000000', 'temperatura', 616.0000, 'ºC'),
	(117219, 112, '2015-03-15 00:50:23.000000', 'temperatura', 1018.0000, 'ºC'),
	(117220, 112, '2015-03-15 00:50:24.000000', 'temperatura', 843.0000, 'ºC'),
	(117221, 112, '2015-03-15 00:50:25.000000', 'temperatura', 1162.0000, 'ºC'),
	(117222, 112, '2015-03-15 00:50:26.000000', 'temperatura', 882.0000, 'ºC'),
	(117223, 112, '2015-03-15 00:50:27.000000', 'temperatura', 924.0000, 'ºC'),
	(117224, 112, '2015-03-15 00:50:28.000000', 'temperatura', 773.0000, 'ºC'),
	(117225, 112, '2015-03-15 00:50:29.000000', 'temperatura', 1092.0000, 'ºC'),
	(117226, 112, '2015-03-15 00:50:30.000000', 'temperatura', 745.0000, 'ºC'),
	(117227, 112, '2015-03-15 00:50:31.000000', 'temperatura', 446.0000, 'ºC'),
	(117228, 112, '2015-03-15 00:50:32.000000', 'temperatura', 1198.0000, 'ºC'),
	(117229, 112, '2015-03-15 00:50:33.000000', 'temperatura', 1054.0000, 'ºC'),
	(117230, 112, '2015-03-15 00:50:34.000000', 'temperatura', 474.0000, 'ºC'),
	(117231, 112, '2015-03-15 00:50:35.000000', 'temperatura', 410.0000, 'ºC'),
	(117232, 112, '2015-03-15 00:50:36.000000', 'temperatura', 630.0000, 'ºC'),
	(117233, 112, '2015-03-15 00:50:37.000000', 'temperatura', 719.0000, 'ºC'),
	(117234, 112, '2015-03-15 00:50:38.000000', 'temperatura', 506.0000, 'ºC'),
	(117235, 112, '2015-03-15 00:50:39.000000', 'temperatura', 372.0000, 'ºC'),
	(117236, 112, '2015-03-15 00:50:40.000000', 'temperatura', 343.0000, 'ºC'),
	(117237, 112, '2015-03-15 00:50:41.000000', 'temperatura', 600.0000, 'ºC'),
	(117238, 112, '2015-03-15 00:50:42.000000', 'temperatura', 771.0000, 'ºC'),
	(117239, 112, '2015-03-15 00:50:43.000000', 'temperatura', 855.0000, 'ºC'),
	(117240, 112, '2015-03-15 00:50:44.000000', 'temperatura', 764.0000, 'ºC'),
	(117241, 112, '2015-03-15 00:50:45.000000', 'temperatura', 56.0000, 'ºC'),
	(117242, 112, '2015-03-15 00:50:46.000000', 'temperatura', 388.0000, 'ºC'),
	(117243, 112, '2015-03-15 00:50:47.000000', 'temperatura', 571.0000, 'ºC'),
	(117244, 112, '2015-03-15 00:50:48.000000', 'temperatura', 491.0000, 'ºC'),
	(117245, 112, '2015-03-15 00:50:49.000000', 'temperatura', 743.0000, 'ºC'),
	(117246, 112, '2015-03-15 00:50:50.000000', 'temperatura', 1045.0000, 'ºC'),
	(117247, 112, '2015-03-15 00:50:51.000000', 'temperatura', 593.0000, 'ºC'),
	(117248, 112, '2015-03-15 00:50:52.000000', 'temperatura', 1032.0000, 'ºC'),
	(117249, 112, '2015-03-15 00:50:53.000000', 'temperatura', 983.0000, 'ºC'),
	(117250, 112, '2015-03-15 00:50:54.000000', 'temperatura', 617.0000, 'ºC'),
	(117251, 112, '2015-03-15 00:50:55.000000', 'temperatura', 137.0000, 'ºC'),
	(117252, 112, '2015-03-15 00:50:56.000000', 'temperatura', 34.0000, 'ºC'),
	(117253, 112, '2015-03-15 00:50:57.000000', 'temperatura', 960.0000, 'ºC'),
	(117254, 112, '2015-03-15 00:50:58.000000', 'temperatura', 1100.0000, 'ºC'),
	(117255, 112, '2015-03-15 00:50:59.000000', 'temperatura', 221.0000, 'ºC'),
	(117256, 112, '2015-03-15 00:51:00.000000', 'temperatura', 206.0000, 'ºC'),
	(117257, 112, '2015-03-15 00:51:01.000000', 'temperatura', 365.0000, 'ºC'),
	(117258, 112, '2015-03-15 00:51:02.000000', 'temperatura', 7.0000, 'ºC'),
	(117259, 112, '2015-03-15 00:51:03.000000', 'temperatura', 141.0000, 'ºC'),
	(117260, 112, '2015-03-15 00:51:04.000000', 'temperatura', 686.0000, 'ºC'),
	(117261, 112, '2015-03-15 00:51:05.000000', 'temperatura', 609.0000, 'ºC'),
	(117262, 112, '2015-03-15 00:51:06.000000', 'temperatura', 985.0000, 'ºC'),
	(117263, 112, '2015-03-15 00:51:07.000000', 'temperatura', 699.0000, 'ºC'),
	(117264, 112, '2015-03-15 00:51:08.000000', 'temperatura', 542.0000, 'ºC'),
	(117265, 112, '2015-03-15 00:51:09.000000', 'temperatura', 613.0000, 'ºC'),
	(117266, 112, '2015-03-15 00:51:10.000000', 'temperatura', 239.0000, 'ºC'),
	(117267, 112, '2015-03-15 00:51:11.000000', 'temperatura', 555.0000, 'ºC'),
	(117268, 112, '2015-03-15 00:51:12.000000', 'temperatura', 859.0000, 'ºC'),
	(117269, 112, '2015-03-15 00:51:13.000000', 'temperatura', 232.0000, 'ºC'),
	(117270, 112, '2015-03-15 00:51:14.000000', 'temperatura', 984.0000, 'ºC'),
	(117271, 112, '2015-03-15 00:51:15.000000', 'temperatura', 623.0000, 'ºC'),
	(117272, 112, '2015-03-15 00:51:16.000000', 'temperatura', 166.0000, 'ºC'),
	(117273, 112, '2015-03-15 00:51:17.000000', 'temperatura', 160.0000, 'ºC'),
	(117274, 112, '2015-03-15 00:51:18.000000', 'temperatura', 302.0000, 'ºC'),
	(117275, 112, '2015-03-15 00:51:19.000000', 'temperatura', 1031.0000, 'ºC'),
	(117276, 112, '2015-03-15 00:51:20.000000', 'temperatura', 649.0000, 'ºC'),
	(117277, 112, '2015-03-15 00:51:21.000000', 'temperatura', 152.0000, 'ºC'),
	(117278, 112, '2015-03-15 00:51:22.000000', 'temperatura', 16.0000, 'ºC'),
	(117279, 112, '2015-03-15 00:51:23.000000', 'temperatura', 824.0000, 'ºC'),
	(117280, 112, '2015-03-15 00:51:24.000000', 'temperatura', 471.0000, 'ºC'),
	(117281, 112, '2015-03-15 00:51:25.000000', 'temperatura', 1083.0000, 'ºC'),
	(117282, 112, '2015-03-15 00:51:26.000000', 'temperatura', 401.0000, 'ºC'),
	(117283, 112, '2015-03-15 00:51:27.000000', 'temperatura', 1160.0000, 'ºC'),
	(117284, 112, '2015-03-15 00:51:28.000000', 'temperatura', 997.0000, 'ºC'),
	(117285, 112, '2015-03-15 00:51:29.000000', 'temperatura', 304.0000, 'ºC'),
	(117286, 112, '2015-03-15 00:51:30.000000', 'temperatura', 931.0000, 'ºC'),
	(117287, 112, '2015-03-15 00:51:31.000000', 'temperatura', 145.0000, 'ºC'),
	(117288, 112, '2015-03-15 00:51:32.000000', 'temperatura', 329.0000, 'ºC'),
	(117289, 112, '2015-03-15 00:51:33.000000', 'temperatura', 13.0000, 'ºC'),
	(117290, 112, '2015-03-15 00:51:34.000000', 'temperatura', 278.0000, 'ºC'),
	(117291, 112, '2015-03-15 00:51:35.000000', 'temperatura', 151.0000, 'ºC'),
	(117292, 112, '2015-03-15 00:51:36.000000', 'temperatura', 1120.0000, 'ºC'),
	(117293, 112, '2015-03-15 00:51:37.000000', 'temperatura', 350.0000, 'ºC'),
	(117294, 112, '2015-03-15 00:51:38.000000', 'temperatura', 788.0000, 'ºC'),
	(117295, 112, '2015-03-15 00:51:39.000000', 'temperatura', 491.0000, 'ºC'),
	(117296, 112, '2015-03-15 00:51:40.000000', 'temperatura', 91.0000, 'ºC'),
	(117297, 112, '2015-03-15 00:51:41.000000', 'temperatura', 185.0000, 'ºC'),
	(117298, 112, '2015-03-15 00:51:42.000000', 'temperatura', 649.0000, 'ºC'),
	(117299, 112, '2015-03-15 00:51:43.000000', 'temperatura', 293.0000, 'ºC'),
	(117300, 112, '2015-03-15 00:51:44.000000', 'temperatura', 717.0000, 'ºC'),
	(117301, 112, '2015-03-15 00:51:45.000000', 'temperatura', 308.0000, 'ºC'),
	(117302, 112, '2015-03-15 00:51:46.000000', 'temperatura', 591.0000, 'ºC'),
	(117303, 112, '2015-03-15 00:51:47.000000', 'temperatura', 830.0000, 'ºC'),
	(117304, 112, '2015-03-15 00:51:48.000000', 'temperatura', 1177.0000, 'ºC'),
	(117305, 112, '2015-03-15 00:51:49.000000', 'temperatura', 996.0000, 'ºC'),
	(117306, 112, '2015-03-15 00:51:50.000000', 'temperatura', 249.0000, 'ºC'),
	(117307, 112, '2015-03-15 00:51:51.000000', 'temperatura', 657.0000, 'ºC'),
	(117308, 112, '2015-03-15 00:51:52.000000', 'temperatura', 141.0000, 'ºC'),
	(117309, 112, '2015-03-15 00:51:53.000000', 'temperatura', 1131.0000, 'ºC'),
	(117310, 112, '2015-03-15 00:51:54.000000', 'temperatura', 435.0000, 'ºC'),
	(117311, 112, '2015-03-15 00:51:55.000000', 'temperatura', 1180.0000, 'ºC'),
	(117312, 112, '2015-03-15 00:51:56.000000', 'temperatura', 996.0000, 'ºC'),
	(117313, 112, '2015-03-15 00:51:57.000000', 'temperatura', 241.0000, 'ºC'),
	(117314, 112, '2015-03-15 00:51:58.000000', 'temperatura', 619.0000, 'ºC'),
	(117315, 112, '2015-03-15 00:51:59.000000', 'temperatura', 1170.0000, 'ºC'),
	(117316, 112, '2015-03-15 00:52:00.000000', 'temperatura', 394.0000, 'ºC'),
	(117317, 112, '2015-03-15 00:52:01.000000', 'temperatura', 859.0000, 'ºC'),
	(117318, 112, '2015-03-15 00:52:02.000000', 'temperatura', 717.0000, 'ºC'),
	(117319, 112, '2015-03-15 00:52:03.000000', 'temperatura', 1005.0000, 'ºC'),
	(117320, 112, '2015-03-15 00:52:04.000000', 'temperatura', 477.0000, 'ºC'),
	(117321, 112, '2015-03-15 00:52:05.000000', 'temperatura', 569.0000, 'ºC'),
	(117322, 112, '2015-03-15 00:52:06.000000', 'temperatura', 217.0000, 'ºC'),
	(117323, 112, '2015-03-15 00:52:07.000000', 'temperatura', 577.0000, 'ºC'),
	(117324, 112, '2015-03-15 00:52:08.000000', 'temperatura', 1034.0000, 'ºC'),
	(117325, 112, '2015-03-15 00:52:09.000000', 'temperatura', 1042.0000, 'ºC'),
	(117326, 112, '2015-03-15 00:52:10.000000', 'temperatura', 905.0000, 'ºC'),
	(117327, 112, '2015-03-15 00:52:11.000000', 'temperatura', 202.0000, 'ºC'),
	(117328, 112, '2015-03-15 00:52:12.000000', 'temperatura', 693.0000, 'ºC'),
	(117329, 112, '2015-03-15 00:52:13.000000', 'temperatura', 461.0000, 'ºC'),
	(117330, 112, '2015-03-15 00:52:14.000000', 'temperatura', 227.0000, 'ºC'),
	(117331, 112, '2015-03-15 00:52:15.000000', 'temperatura', 950.0000, 'ºC'),
	(117332, 112, '2015-03-15 00:52:16.000000', 'temperatura', 471.0000, 'ºC'),
	(117333, 112, '2015-03-15 00:52:17.000000', 'temperatura', 705.0000, 'ºC'),
	(117334, 112, '2015-03-15 00:52:18.000000', 'temperatura', 913.0000, 'ºC'),
	(117335, 112, '2015-03-15 00:52:19.000000', 'temperatura', 49.0000, 'ºC'),
	(117336, 112, '2015-03-15 00:52:20.000000', 'temperatura', 1109.0000, 'ºC'),
	(117337, 112, '2015-03-15 00:52:21.000000', 'temperatura', 598.0000, 'ºC'),
	(117338, 112, '2015-03-15 00:52:22.000000', 'temperatura', 863.0000, 'ºC'),
	(117339, 112, '2015-03-15 00:52:23.000000', 'temperatura', 120.0000, 'ºC'),
	(117340, 112, '2015-03-15 00:52:24.000000', 'temperatura', 413.0000, 'ºC'),
	(117341, 112, '2015-03-15 00:52:25.000000', 'temperatura', 505.0000, 'ºC'),
	(117342, 112, '2015-03-15 00:52:26.000000', 'temperatura', 85.0000, 'ºC'),
	(117343, 112, '2015-03-15 00:52:27.000000', 'temperatura', 111.0000, 'ºC'),
	(117344, 112, '2015-03-15 00:52:28.000000', 'temperatura', 299.0000, 'ºC'),
	(117345, 112, '2015-03-15 00:52:29.000000', 'temperatura', 1165.0000, 'ºC'),
	(117346, 112, '2015-03-15 00:52:30.000000', 'temperatura', 126.0000, 'ºC'),
	(117347, 112, '2015-03-15 00:52:31.000000', 'temperatura', 737.0000, 'ºC'),
	(117348, 112, '2015-03-15 00:52:32.000000', 'temperatura', 909.0000, 'ºC'),
	(117349, 112, '2015-03-15 00:52:33.000000', 'temperatura', 1132.0000, 'ºC'),
	(117350, 112, '2015-03-15 00:52:34.000000', 'temperatura', 535.0000, 'ºC'),
	(117351, 112, '2015-03-15 00:52:35.000000', 'temperatura', 479.0000, 'ºC'),
	(117352, 112, '2015-03-15 00:52:36.000000', 'temperatura', 790.0000, 'ºC'),
	(117353, 112, '2015-03-15 00:52:37.000000', 'temperatura', 115.0000, 'ºC'),
	(117354, 112, '2015-03-15 00:52:38.000000', 'temperatura', 606.0000, 'ºC'),
	(117355, 112, '2015-03-15 00:52:39.000000', 'temperatura', 285.0000, 'ºC'),
	(117356, 112, '2015-03-15 00:52:40.000000', 'temperatura', 809.0000, 'ºC'),
	(117357, 112, '2015-03-15 00:52:41.000000', 'temperatura', 790.0000, 'ºC'),
	(117358, 112, '2015-03-15 00:52:42.000000', 'temperatura', 324.0000, 'ºC'),
	(117359, 112, '2015-03-15 00:52:43.000000', 'temperatura', 448.0000, 'ºC'),
	(117360, 112, '2015-03-15 00:52:44.000000', 'temperatura', 70.0000, 'ºC'),
	(117361, 112, '2015-03-15 00:52:45.000000', 'temperatura', 206.0000, 'ºC'),
	(117362, 112, '2015-03-15 00:52:46.000000', 'temperatura', 821.0000, 'ºC'),
	(117363, 112, '2015-03-15 00:52:47.000000', 'temperatura', 1087.0000, 'ºC'),
	(117364, 112, '2015-03-15 00:52:48.000000', 'temperatura', 575.0000, 'ºC'),
	(117365, 112, '2015-03-15 00:52:49.000000', 'temperatura', 811.0000, 'ºC'),
	(117366, 112, '2015-03-15 00:52:50.000000', 'temperatura', 1134.0000, 'ºC'),
	(117367, 112, '2015-03-15 00:52:51.000000', 'temperatura', 835.0000, 'ºC'),
	(117368, 112, '2015-03-15 00:52:52.000000', 'temperatura', 776.0000, 'ºC'),
	(117369, 112, '2015-03-15 00:52:53.000000', 'temperatura', 175.0000, 'ºC'),
	(117370, 112, '2015-03-15 00:52:54.000000', 'temperatura', 947.0000, 'ºC'),
	(117371, 112, '2015-03-15 00:52:55.000000', 'temperatura', 609.0000, 'ºC'),
	(117372, 112, '2015-03-15 00:52:56.000000', 'temperatura', 205.0000, 'ºC'),
	(117373, 112, '2015-03-15 00:52:57.000000', 'temperatura', 401.0000, 'ºC'),
	(117374, 112, '2015-03-15 00:52:58.000000', 'temperatura', 187.0000, 'ºC'),
	(117375, 112, '2015-03-15 00:52:59.000000', 'temperatura', 935.0000, 'ºC'),
	(117376, 112, '2015-03-15 00:53:00.000000', 'temperatura', 515.0000, 'ºC'),
	(117377, 112, '2015-03-15 00:53:01.000000', 'temperatura', 971.0000, 'ºC'),
	(117378, 112, '2015-03-15 00:53:02.000000', 'temperatura', 908.0000, 'ºC'),
	(117379, 112, '2015-03-15 00:53:03.000000', 'temperatura', 428.0000, 'ºC'),
	(117380, 112, '2015-03-15 00:53:04.000000', 'temperatura', 617.0000, 'ºC'),
	(117381, 112, '2015-03-15 00:53:05.000000', 'temperatura', 600.0000, 'ºC'),
	(117382, 112, '2015-03-15 00:53:06.000000', 'temperatura', 1152.0000, 'ºC'),
	(117383, 112, '2015-03-15 00:53:07.000000', 'temperatura', 361.0000, 'ºC'),
	(117384, 112, '2015-03-15 00:53:08.000000', 'temperatura', 747.0000, 'ºC'),
	(117385, 112, '2015-03-15 00:53:09.000000', 'temperatura', 255.0000, 'ºC'),
	(117386, 112, '2015-03-15 00:53:10.000000', 'temperatura', 234.0000, 'ºC'),
	(117387, 112, '2015-03-15 00:53:11.000000', 'temperatura', 403.0000, 'ºC'),
	(117388, 112, '2015-03-15 00:53:12.000000', 'temperatura', 116.0000, 'ºC'),
	(117389, 112, '2015-03-15 00:53:13.000000', 'temperatura', 570.0000, 'ºC'),
	(117390, 112, '2015-03-15 00:53:14.000000', 'temperatura', 104.0000, 'ºC'),
	(117391, 112, '2015-03-15 00:53:15.000000', 'temperatura', 9.0000, 'ºC'),
	(117392, 112, '2015-03-15 00:53:16.000000', 'temperatura', 934.0000, 'ºC'),
	(117393, 112, '2015-03-15 00:53:17.000000', 'temperatura', 1044.0000, 'ºC'),
	(117394, 112, '2015-03-15 00:53:18.000000', 'temperatura', 19.0000, 'ºC'),
	(117395, 112, '2015-03-15 00:53:19.000000', 'temperatura', 563.0000, 'ºC'),
	(117396, 112, '2015-03-15 00:53:20.000000', 'temperatura', 360.0000, 'ºC'),
	(117397, 112, '2015-03-15 00:53:21.000000', 'temperatura', 109.0000, 'ºC'),
	(117398, 112, '2015-03-15 00:53:22.000000', 'temperatura', 665.0000, 'ºC'),
	(117399, 112, '2015-03-15 00:53:23.000000', 'temperatura', 600.0000, 'ºC'),
	(117400, 112, '2015-03-15 00:53:24.000000', 'temperatura', 1004.0000, 'ºC'),
	(117401, 112, '2015-03-15 00:53:25.000000', 'temperatura', 823.0000, 'ºC'),
	(117402, 112, '2015-03-15 00:53:26.000000', 'temperatura', 1102.0000, 'ºC'),
	(117403, 112, '2015-03-15 00:53:27.000000', 'temperatura', 642.0000, 'ºC'),
	(117404, 112, '2015-03-15 00:53:28.000000', 'temperatura', 1106.0000, 'ºC'),
	(117405, 112, '2015-03-15 00:53:29.000000', 'temperatura', 2.0000, 'ºC'),
	(117406, 112, '2015-03-15 00:53:30.000000', 'temperatura', 292.0000, 'ºC'),
	(117407, 112, '2015-03-15 00:53:31.000000', 'temperatura', 256.0000, 'ºC'),
	(117408, 112, '2015-03-15 00:53:32.000000', 'temperatura', 404.0000, 'ºC'),
	(117409, 112, '2015-03-15 00:53:33.000000', 'temperatura', 53.0000, 'ºC'),
	(117410, 112, '2015-03-15 00:53:34.000000', 'temperatura', 253.0000, 'ºC'),
	(117411, 112, '2015-03-15 00:53:35.000000', 'temperatura', 1109.0000, 'ºC'),
	(117412, 112, '2015-03-15 00:53:36.000000', 'temperatura', 1184.0000, 'ºC'),
	(117413, 112, '2015-03-15 00:53:37.000000', 'temperatura', 194.0000, 'ºC'),
	(117414, 112, '2015-03-15 00:53:38.000000', 'temperatura', 1017.0000, 'ºC'),
	(117415, 112, '2015-03-15 00:53:39.000000', 'temperatura', 903.0000, 'ºC'),
	(117416, 112, '2015-03-15 00:53:40.000000', 'temperatura', 267.0000, 'ºC'),
	(117417, 112, '2015-03-15 00:53:41.000000', 'temperatura', 1024.0000, 'ºC'),
	(117418, 112, '2015-03-15 00:53:42.000000', 'temperatura', 721.0000, 'ºC'),
	(117419, 112, '2015-03-15 00:53:43.000000', 'temperatura', 532.0000, 'ºC'),
	(117420, 112, '2015-03-15 00:53:44.000000', 'temperatura', 498.0000, 'ºC'),
	(117421, 112, '2015-03-15 00:53:45.000000', 'temperatura', 895.0000, 'ºC'),
	(117422, 112, '2015-03-15 00:53:46.000000', 'temperatura', 583.0000, 'ºC'),
	(117423, 112, '2015-03-15 00:53:47.000000', 'temperatura', 229.0000, 'ºC'),
	(117424, 112, '2015-03-15 00:53:48.000000', 'temperatura', 596.0000, 'ºC'),
	(117425, 112, '2015-03-15 00:53:49.000000', 'temperatura', 1095.0000, 'ºC'),
	(117426, 112, '2015-03-15 00:53:50.000000', 'temperatura', 85.0000, 'ºC'),
	(117427, 112, '2015-03-15 00:53:51.000000', 'temperatura', 743.0000, 'ºC'),
	(117428, 112, '2015-03-15 00:53:52.000000', 'temperatura', 1061.0000, 'ºC'),
	(117429, 112, '2015-03-15 00:53:53.000000', 'temperatura', 675.0000, 'ºC'),
	(117430, 112, '2015-03-15 00:53:54.000000', 'temperatura', 194.0000, 'ºC'),
	(117431, 112, '2015-03-15 00:53:55.000000', 'temperatura', 145.0000, 'ºC'),
	(117432, 112, '2015-03-15 00:53:56.000000', 'temperatura', 143.0000, 'ºC'),
	(117433, 112, '2015-03-15 00:53:57.000000', 'temperatura', 282.0000, 'ºC'),
	(117434, 112, '2015-03-15 00:53:58.000000', 'temperatura', 981.0000, 'ºC'),
	(117435, 112, '2015-03-15 00:53:59.000000', 'temperatura', 459.0000, 'ºC'),
	(117436, 112, '2015-03-15 00:54:00.000000', 'temperatura', 554.0000, 'ºC'),
	(117437, 112, '2015-03-15 00:54:01.000000', 'temperatura', 194.0000, 'ºC'),
	(117438, 112, '2015-03-15 00:54:02.000000', 'temperatura', 506.0000, 'ºC'),
	(117439, 112, '2015-03-15 00:54:03.000000', 'temperatura', 749.0000, 'ºC'),
	(117440, 112, '2015-03-15 00:54:04.000000', 'temperatura', 1029.0000, 'ºC'),
	(117441, 112, '2015-03-15 00:54:05.000000', 'temperatura', 497.0000, 'ºC'),
	(117442, 112, '2015-03-15 00:54:06.000000', 'temperatura', 601.0000, 'ºC'),
	(117443, 112, '2015-03-15 00:54:07.000000', 'temperatura', 312.0000, 'ºC'),
	(117444, 112, '2015-03-15 00:54:08.000000', 'temperatura', 960.0000, 'ºC'),
	(117445, 112, '2015-03-15 00:54:09.000000', 'temperatura', 261.0000, 'ºC'),
	(117446, 112, '2015-03-15 00:54:10.000000', 'temperatura', 828.0000, 'ºC'),
	(117447, 112, '2015-03-15 00:54:11.000000', 'temperatura', 956.0000, 'ºC'),
	(117448, 112, '2015-03-15 00:54:12.000000', 'temperatura', 1099.0000, 'ºC'),
	(117449, 112, '2015-03-15 00:54:13.000000', 'temperatura', 224.0000, 'ºC'),
	(117450, 112, '2015-03-15 00:54:14.000000', 'temperatura', 226.0000, 'ºC'),
	(117451, 112, '2015-03-15 00:54:15.000000', 'temperatura', 457.0000, 'ºC'),
	(117452, 112, '2015-03-15 00:54:16.000000', 'temperatura', 410.0000, 'ºC'),
	(117453, 112, '2015-03-15 00:54:17.000000', 'temperatura', 676.0000, 'ºC'),
	(117454, 112, '2015-03-15 00:54:18.000000', 'temperatura', 954.0000, 'ºC'),
	(117455, 112, '2015-03-15 00:54:19.000000', 'temperatura', 341.0000, 'ºC'),
	(117456, 112, '2015-03-15 00:54:20.000000', 'temperatura', 42.0000, 'ºC'),
	(117457, 112, '2015-03-15 00:54:21.000000', 'temperatura', 387.0000, 'ºC'),
	(117458, 112, '2015-03-15 00:54:22.000000', 'temperatura', 608.0000, 'ºC'),
	(117459, 112, '2015-03-15 00:54:23.000000', 'temperatura', 683.0000, 'ºC'),
	(117460, 112, '2015-03-15 00:54:24.000000', 'temperatura', 392.0000, 'ºC'),
	(117461, 112, '2015-03-15 00:54:25.000000', 'temperatura', 1112.0000, 'ºC'),
	(117462, 112, '2015-03-15 00:54:26.000000', 'temperatura', 782.0000, 'ºC'),
	(117463, 112, '2015-03-15 00:54:27.000000', 'temperatura', 576.0000, 'ºC'),
	(117464, 112, '2015-03-15 00:54:28.000000', 'temperatura', 534.0000, 'ºC'),
	(117465, 112, '2015-03-15 00:54:29.000000', 'temperatura', 940.0000, 'ºC'),
	(117466, 112, '2015-03-15 00:54:30.000000', 'temperatura', 702.0000, 'ºC'),
	(117467, 112, '2015-03-15 00:54:31.000000', 'temperatura', 691.0000, 'ºC'),
	(117468, 112, '2015-03-15 00:54:32.000000', 'temperatura', 147.0000, 'ºC'),
	(117469, 112, '2015-03-15 00:54:33.000000', 'temperatura', 1064.0000, 'ºC'),
	(117470, 112, '2015-03-15 00:54:34.000000', 'temperatura', 79.0000, 'ºC'),
	(117471, 112, '2015-03-15 00:54:35.000000', 'temperatura', 804.0000, 'ºC'),
	(117472, 112, '2015-03-15 00:54:36.000000', 'temperatura', 181.0000, 'ºC'),
	(117473, 112, '2015-03-15 00:54:37.000000', 'temperatura', 897.0000, 'ºC'),
	(117474, 112, '2015-03-15 00:54:38.000000', 'temperatura', 342.0000, 'ºC'),
	(117475, 112, '2015-03-15 00:54:39.000000', 'temperatura', 217.0000, 'ºC'),
	(117476, 112, '2015-03-15 00:54:40.000000', 'temperatura', 60.0000, 'ºC'),
	(117477, 112, '2015-03-15 00:54:41.000000', 'temperatura', 850.0000, 'ºC'),
	(117478, 112, '2015-03-15 00:54:42.000000', 'temperatura', 471.0000, 'ºC'),
	(117479, 112, '2015-03-15 00:54:43.000000', 'temperatura', 1004.0000, 'ºC'),
	(117480, 112, '2015-03-15 00:54:44.000000', 'temperatura', 7.0000, 'ºC'),
	(117481, 112, '2015-03-15 00:54:45.000000', 'temperatura', 624.0000, 'ºC'),
	(117482, 112, '2015-03-15 00:54:46.000000', 'temperatura', 700.0000, 'ºC'),
	(117483, 112, '2015-03-15 00:54:47.000000', 'temperatura', 430.0000, 'ºC'),
	(117484, 112, '2015-03-15 00:54:48.000000', 'temperatura', 48.0000, 'ºC'),
	(117485, 112, '2015-03-15 00:54:49.000000', 'temperatura', 152.0000, 'ºC'),
	(117486, 112, '2015-03-15 00:54:50.000000', 'temperatura', 615.0000, 'ºC'),
	(117487, 112, '2015-03-15 00:54:51.000000', 'temperatura', 221.0000, 'ºC'),
	(117488, 112, '2015-03-15 00:54:52.000000', 'temperatura', 461.0000, 'ºC'),
	(117489, 112, '2015-03-15 00:54:53.000000', 'temperatura', 442.0000, 'ºC'),
	(117490, 112, '2015-03-15 00:54:54.000000', 'temperatura', 828.0000, 'ºC'),
	(117491, 112, '2015-03-15 00:54:55.000000', 'temperatura', 415.0000, 'ºC'),
	(117492, 112, '2015-03-15 00:54:56.000000', 'temperatura', 790.0000, 'ºC'),
	(117493, 112, '2015-03-15 00:54:57.000000', 'temperatura', 308.0000, 'ºC'),
	(117494, 112, '2015-03-15 00:54:58.000000', 'temperatura', 367.0000, 'ºC'),
	(117495, 112, '2015-03-15 00:54:59.000000', 'temperatura', 913.0000, 'ºC'),
	(117496, 112, '2015-03-15 00:55:00.000000', 'temperatura', 1066.0000, 'ºC'),
	(117497, 112, '2015-03-15 00:55:01.000000', 'temperatura', 190.0000, 'ºC'),
	(117498, 112, '2015-03-15 00:55:02.000000', 'temperatura', 155.0000, 'ºC'),
	(117499, 112, '2015-03-15 00:55:03.000000', 'temperatura', 204.0000, 'ºC'),
	(117500, 112, '2015-03-15 00:55:04.000000', 'temperatura', 554.0000, 'ºC'),
	(117501, 112, '2015-03-15 00:55:05.000000', 'temperatura', 959.0000, 'ºC'),
	(117502, 112, '2015-03-15 00:55:06.000000', 'temperatura', 734.0000, 'ºC'),
	(117503, 112, '2015-03-15 00:55:07.000000', 'temperatura', 793.0000, 'ºC'),
	(117504, 112, '2015-03-15 00:55:08.000000', 'temperatura', 563.0000, 'ºC'),
	(117505, 112, '2015-03-15 00:55:09.000000', 'temperatura', 439.0000, 'ºC'),
	(117506, 112, '2015-03-15 00:55:10.000000', 'temperatura', 504.0000, 'ºC'),
	(117507, 112, '2015-03-15 00:55:11.000000', 'temperatura', 6.0000, 'ºC'),
	(117508, 112, '2015-03-15 00:55:12.000000', 'temperatura', 917.0000, 'ºC'),
	(117509, 112, '2015-03-15 00:55:13.000000', 'temperatura', 967.0000, 'ºC'),
	(117510, 112, '2015-03-15 00:55:14.000000', 'temperatura', 885.0000, 'ºC'),
	(117511, 112, '2015-03-15 00:55:15.000000', 'temperatura', 326.0000, 'ºC'),
	(117512, 112, '2015-03-15 00:55:16.000000', 'temperatura', 176.0000, 'ºC'),
	(117513, 112, '2015-03-15 00:55:17.000000', 'temperatura', 1100.0000, 'ºC'),
	(117514, 112, '2015-03-15 00:55:18.000000', 'temperatura', 174.0000, 'ºC'),
	(117515, 112, '2015-03-15 00:55:19.000000', 'temperatura', 1170.0000, 'ºC'),
	(117516, 112, '2015-03-15 00:55:20.000000', 'temperatura', 527.0000, 'ºC'),
	(117517, 112, '2015-03-15 00:55:21.000000', 'temperatura', 328.0000, 'ºC'),
	(117518, 112, '2015-03-15 00:55:22.000000', 'temperatura', 59.0000, 'ºC'),
	(117519, 112, '2015-03-15 00:55:23.000000', 'temperatura', 513.0000, 'ºC'),
	(117520, 112, '2015-03-15 00:55:24.000000', 'temperatura', 1187.0000, 'ºC'),
	(117521, 112, '2015-03-15 00:55:25.000000', 'temperatura', 797.0000, 'ºC'),
	(117522, 112, '2015-03-15 00:55:26.000000', 'temperatura', 423.0000, 'ºC'),
	(117523, 112, '2015-03-15 00:55:27.000000', 'temperatura', 927.0000, 'ºC'),
	(117524, 112, '2015-03-15 00:55:28.000000', 'temperatura', 964.0000, 'ºC'),
	(117525, 112, '2015-03-15 00:55:29.000000', 'temperatura', 838.0000, 'ºC'),
	(117526, 112, '2015-03-15 00:55:30.000000', 'temperatura', 102.0000, 'ºC'),
	(117527, 112, '2015-03-15 00:55:31.000000', 'temperatura', 394.0000, 'ºC'),
	(117528, 112, '2015-03-15 00:55:32.000000', 'temperatura', 466.0000, 'ºC'),
	(117529, 112, '2015-03-15 00:55:33.000000', 'temperatura', 1150.0000, 'ºC'),
	(117530, 112, '2015-03-15 00:55:34.000000', 'temperatura', 749.0000, 'ºC'),
	(117531, 112, '2015-03-15 00:55:35.000000', 'temperatura', 297.0000, 'ºC'),
	(117532, 112, '2015-03-15 00:55:36.000000', 'temperatura', 439.0000, 'ºC'),
	(117533, 112, '2015-03-15 00:55:37.000000', 'temperatura', 105.0000, 'ºC'),
	(117534, 112, '2015-03-15 00:55:38.000000', 'temperatura', 406.0000, 'ºC'),
	(117535, 112, '2015-03-15 00:55:39.000000', 'temperatura', 517.0000, 'ºC'),
	(117536, 112, '2015-03-15 00:55:40.000000', 'temperatura', 167.0000, 'ºC'),
	(117537, 112, '2015-03-15 00:55:41.000000', 'temperatura', 486.0000, 'ºC'),
	(117538, 112, '2015-03-15 00:55:42.000000', 'temperatura', 730.0000, 'ºC'),
	(117539, 112, '2015-03-15 00:55:43.000000', 'temperatura', 990.0000, 'ºC'),
	(117540, 112, '2015-03-15 00:55:44.000000', 'temperatura', 362.0000, 'ºC'),
	(117541, 112, '2015-03-15 00:55:45.000000', 'temperatura', 39.0000, 'ºC'),
	(117542, 112, '2015-03-15 00:55:46.000000', 'temperatura', 311.0000, 'ºC'),
	(117543, 112, '2015-03-15 00:55:47.000000', 'temperatura', 236.0000, 'ºC'),
	(117544, 112, '2015-03-15 00:55:48.000000', 'temperatura', 251.0000, 'ºC'),
	(117545, 112, '2015-03-15 00:55:49.000000', 'temperatura', 545.0000, 'ºC'),
	(117546, 112, '2015-03-15 00:55:50.000000', 'temperatura', 774.0000, 'ºC'),
	(117547, 112, '2015-03-15 00:55:51.000000', 'temperatura', 1037.0000, 'ºC'),
	(117548, 112, '2015-03-15 00:55:52.000000', 'temperatura', 462.0000, 'ºC'),
	(117549, 112, '2015-03-15 00:55:53.000000', 'temperatura', 398.0000, 'ºC'),
	(117550, 112, '2015-03-15 00:55:54.000000', 'temperatura', 604.0000, 'ºC'),
	(117551, 112, '2015-03-15 00:55:55.000000', 'temperatura', 628.0000, 'ºC'),
	(117552, 112, '2015-03-15 00:55:56.000000', 'temperatura', 128.0000, 'ºC'),
	(117553, 112, '2015-03-15 00:55:57.000000', 'temperatura', 1155.0000, 'ºC'),
	(117554, 112, '2015-03-15 00:55:58.000000', 'temperatura', 591.0000, 'ºC'),
	(117555, 112, '2015-03-15 00:55:59.000000', 'temperatura', 690.0000, 'ºC'),
	(117556, 112, '2015-03-15 00:56:00.000000', 'temperatura', 478.0000, 'ºC'),
	(117557, 112, '2015-03-15 00:56:01.000000', 'temperatura', 323.0000, 'ºC'),
	(117558, 112, '2015-03-15 00:56:02.000000', 'temperatura', 180.0000, 'ºC'),
	(117559, 112, '2015-03-15 00:56:03.000000', 'temperatura', 1133.0000, 'ºC'),
	(117560, 112, '2015-03-15 00:56:04.000000', 'temperatura', 325.0000, 'ºC'),
	(117561, 112, '2015-03-15 00:56:05.000000', 'temperatura', 625.0000, 'ºC'),
	(117562, 112, '2015-03-15 00:56:06.000000', 'temperatura', 950.0000, 'ºC'),
	(117563, 112, '2015-03-15 00:56:07.000000', 'temperatura', 478.0000, 'ºC'),
	(117564, 112, '2015-03-15 00:56:08.000000', 'temperatura', 740.0000, 'ºC'),
	(117565, 112, '2015-03-15 00:56:09.000000', 'temperatura', 1066.0000, 'ºC'),
	(117566, 112, '2015-03-15 00:56:10.000000', 'temperatura', 711.0000, 'ºC'),
	(117567, 112, '2015-03-15 00:56:11.000000', 'temperatura', 359.0000, 'ºC'),
	(117568, 112, '2015-03-15 00:56:12.000000', 'temperatura', 860.0000, 'ºC'),
	(117569, 112, '2015-03-15 00:56:13.000000', 'temperatura', 826.0000, 'ºC'),
	(117570, 112, '2015-03-15 00:56:14.000000', 'temperatura', 350.0000, 'ºC'),
	(117571, 112, '2015-03-15 00:56:15.000000', 'temperatura', 470.0000, 'ºC'),
	(117572, 112, '2015-03-15 00:56:16.000000', 'temperatura', 103.0000, 'ºC'),
	(117573, 112, '2015-03-15 00:56:17.000000', 'temperatura', 304.0000, 'ºC'),
	(117574, 112, '2015-03-15 00:56:18.000000', 'temperatura', 11.0000, 'ºC'),
	(117575, 112, '2015-03-15 00:56:19.000000', 'temperatura', 345.0000, 'ºC'),
	(117576, 112, '2015-03-15 00:56:20.000000', 'temperatura', 493.0000, 'ºC'),
	(117577, 112, '2015-03-15 00:56:21.000000', 'temperatura', 230.0000, 'ºC'),
	(117578, 112, '2015-03-15 00:56:22.000000', 'temperatura', 870.0000, 'ºC'),
	(117579, 112, '2015-03-15 00:56:23.000000', 'temperatura', 63.0000, 'ºC'),
	(117580, 112, '2015-03-15 00:56:24.000000', 'temperatura', 106.0000, 'ºC'),
	(117581, 112, '2015-03-15 00:56:25.000000', 'temperatura', 339.0000, 'ºC'),
	(117582, 112, '2015-03-15 00:56:26.000000', 'temperatura', 178.0000, 'ºC'),
	(117583, 112, '2015-03-15 00:56:27.000000', 'temperatura', 1073.0000, 'ºC'),
	(117584, 112, '2015-03-15 00:56:28.000000', 'temperatura', 31.0000, 'ºC'),
	(117585, 112, '2015-03-15 00:56:29.000000', 'temperatura', 535.0000, 'ºC'),
	(117586, 112, '2015-03-15 00:56:30.000000', 'temperatura', 186.0000, 'ºC'),
	(117587, 112, '2015-03-15 00:56:31.000000', 'temperatura', 522.0000, 'ºC'),
	(117588, 112, '2015-03-15 00:56:32.000000', 'temperatura', 855.0000, 'ºC'),
	(117589, 112, '2015-03-15 00:56:33.000000', 'temperatura', 308.0000, 'ºC'),
	(117590, 112, '2015-03-15 00:56:34.000000', 'temperatura', 174.0000, 'ºC'),
	(117591, 112, '2015-03-15 00:56:35.000000', 'temperatura', 1149.0000, 'ºC'),
	(117592, 112, '2015-03-15 00:56:36.000000', 'temperatura', 421.0000, 'ºC'),
	(117593, 112, '2015-03-15 00:56:37.000000', 'temperatura', 1062.0000, 'ºC'),
	(117594, 112, '2015-03-15 00:56:38.000000', 'temperatura', 444.0000, 'ºC'),
	(117595, 112, '2015-03-15 00:56:39.000000', 'temperatura', 237.0000, 'ºC'),
	(117596, 112, '2015-03-15 00:56:40.000000', 'temperatura', 1055.0000, 'ºC'),
	(117597, 112, '2015-03-15 00:56:41.000000', 'temperatura', 961.0000, 'ºC'),
	(117598, 112, '2015-03-15 00:56:42.000000', 'temperatura', 443.0000, 'ºC'),
	(117599, 112, '2015-03-15 00:56:43.000000', 'temperatura', 534.0000, 'ºC'),
	(117600, 112, '2015-03-15 00:56:44.000000', 'temperatura', 138.0000, 'ºC'),
	(117601, 112, '2015-03-15 00:56:45.000000', 'temperatura', 290.0000, 'ºC'),
	(117602, 112, '2015-03-15 00:56:46.000000', 'temperatura', 1038.0000, 'ºC'),
	(117603, 112, '2015-03-15 00:56:47.000000', 'temperatura', 721.0000, 'ºC'),
	(117604, 112, '2015-03-15 00:56:48.000000', 'temperatura', 492.0000, 'ºC'),
	(117605, 112, '2015-03-15 00:56:49.000000', 'temperatura', 297.0000, 'ºC'),
	(117606, 112, '2015-03-15 00:56:50.000000', 'temperatura', 10.0000, 'ºC'),
	(117607, 112, '2015-03-15 00:56:51.000000', 'temperatura', 358.0000, 'ºC'),
	(117608, 112, '2015-03-15 00:56:52.000000', 'temperatura', 563.0000, 'ºC'),
	(117609, 112, '2015-03-15 00:56:53.000000', 'temperatura', 541.0000, 'ºC'),
	(117610, 112, '2015-03-15 00:56:54.000000', 'temperatura', 1015.0000, 'ºC'),
	(117611, 112, '2015-03-15 00:56:55.000000', 'temperatura', 1052.0000, 'ºC'),
	(117612, 112, '2015-03-15 00:56:56.000000', 'temperatura', 1015.0000, 'ºC'),
	(117613, 112, '2015-03-15 00:56:57.000000', 'temperatura', 719.0000, 'ºC'),
	(117614, 112, '2015-03-15 00:56:58.000000', 'temperatura', 552.0000, 'ºC'),
	(117615, 112, '2015-03-15 00:56:59.000000', 'temperatura', 602.0000, 'ºC'),
	(117616, 112, '2015-03-15 00:57:00.000000', 'temperatura', 155.0000, 'ºC'),
	(117617, 112, '2015-03-15 00:57:01.000000', 'temperatura', 168.0000, 'ºC'),
	(117618, 112, '2015-03-15 00:57:02.000000', 'temperatura', 378.0000, 'ºC'),
	(117619, 112, '2015-03-15 00:57:03.000000', 'temperatura', 184.0000, 'ºC'),
	(117620, 112, '2015-03-15 00:57:04.000000', 'temperatura', 988.0000, 'ºC'),
	(117621, 112, '2015-03-15 00:57:05.000000', 'temperatura', 787.0000, 'ºC'),
	(117622, 112, '2015-03-15 00:57:06.000000', 'temperatura', 971.0000, 'ºC'),
	(117623, 112, '2015-03-15 00:57:07.000000', 'temperatura', 96.0000, 'ºC'),
	(117624, 112, '2015-03-15 00:57:08.000000', 'temperatura', 1167.0000, 'ºC'),
	(117625, 112, '2015-03-15 00:57:09.000000', 'temperatura', 747.0000, 'ºC'),
	(117626, 112, '2015-03-15 00:57:10.000000', 'temperatura', 233.0000, 'ºC'),
	(117627, 112, '2015-03-15 00:57:11.000000', 'temperatura', 127.0000, 'ºC'),
	(117628, 112, '2015-03-15 00:57:12.000000', 'temperatura', 1134.0000, 'ºC'),
	(117629, 112, '2015-03-15 00:57:13.000000', 'temperatura', 492.0000, 'ºC'),
	(117630, 112, '2015-03-15 00:57:14.000000', 'temperatura', 258.0000, 'ºC'),
	(117631, 112, '2015-03-15 00:57:15.000000', 'temperatura', 1016.0000, 'ºC'),
	(117632, 112, '2015-03-15 00:57:16.000000', 'temperatura', 705.0000, 'ºC'),
	(117633, 112, '2015-03-15 00:57:17.000000', 'temperatura', 476.0000, 'ºC'),
	(117634, 112, '2015-03-15 00:57:18.000000', 'temperatura', 266.0000, 'ºC'),
	(117635, 112, '2015-03-15 00:57:19.000000', 'temperatura', 1105.0000, 'ºC'),
	(117636, 112, '2015-03-15 00:57:20.000000', 'temperatura', 1125.0000, 'ºC'),
	(117637, 112, '2015-03-15 00:57:21.000000', 'temperatura', 1113.0000, 'ºC'),
	(117638, 112, '2015-03-15 00:57:22.000000', 'temperatura', 987.0000, 'ºC'),
	(117639, 112, '2015-03-15 00:57:23.000000', 'temperatura', 399.0000, 'ºC'),
	(117640, 112, '2015-03-15 00:57:24.000000', 'temperatura', 234.0000, 'ºC'),
	(117641, 112, '2015-03-15 00:57:25.000000', 'temperatura', 1172.0000, 'ºC'),
	(117642, 112, '2015-03-15 00:57:26.000000', 'temperatura', 359.0000, 'ºC'),
	(117643, 112, '2015-03-15 00:57:27.000000', 'temperatura', 679.0000, 'ºC'),
	(117644, 112, '2015-03-15 00:57:28.000000', 'temperatura', 1118.0000, 'ºC'),
	(117645, 112, '2015-03-15 00:57:29.000000', 'temperatura', 1155.0000, 'ºC'),
	(117646, 112, '2015-03-15 00:57:30.000000', 'temperatura', 20.0000, 'ºC'),
	(117647, 112, '2015-03-15 00:57:31.000000', 'temperatura', 235.0000, 'ºC'),
	(117648, 112, '2015-03-15 00:57:32.000000', 'temperatura', 1115.0000, 'ºC'),
	(117649, 112, '2015-03-15 00:57:33.000000', 'temperatura', 71.0000, 'ºC'),
	(117650, 112, '2015-03-15 00:57:34.000000', 'temperatura', 611.0000, 'ºC'),
	(117651, 112, '2015-03-15 00:57:35.000000', 'temperatura', 442.0000, 'ºC'),
	(117652, 112, '2015-03-15 00:57:36.000000', 'temperatura', 376.0000, 'ºC'),
	(117653, 112, '2015-03-15 00:57:37.000000', 'temperatura', 555.0000, 'ºC'),
	(117654, 112, '2015-03-15 00:57:38.000000', 'temperatura', 449.0000, 'ºC'),
	(117655, 112, '2015-03-15 00:57:39.000000', 'temperatura', 582.0000, 'ºC'),
	(117656, 112, '2015-03-15 00:57:40.000000', 'temperatura', 362.0000, 'ºC'),
	(117657, 112, '2015-03-15 00:57:41.000000', 'temperatura', 62.0000, 'ºC'),
	(117658, 112, '2015-03-15 00:57:42.000000', 'temperatura', 428.0000, 'ºC'),
	(117659, 112, '2015-03-15 00:57:43.000000', 'temperatura', 753.0000, 'ºC'),
	(117660, 112, '2015-03-15 00:57:44.000000', 'temperatura', 82.0000, 'ºC'),
	(117661, 112, '2015-03-15 00:57:45.000000', 'temperatura', 550.0000, 'ºC'),
	(117662, 112, '2015-03-15 00:57:46.000000', 'temperatura', 103.0000, 'ºC'),
	(117663, 112, '2015-03-15 00:57:47.000000', 'temperatura', 69.0000, 'ºC'),
	(117664, 112, '2015-03-15 00:57:48.000000', 'temperatura', 35.0000, 'ºC'),
	(117665, 112, '2015-03-15 00:57:49.000000', 'temperatura', 1169.0000, 'ºC'),
	(117666, 112, '2015-03-15 00:57:50.000000', 'temperatura', 939.0000, 'ºC'),
	(117667, 112, '2015-03-15 00:57:51.000000', 'temperatura', 1189.0000, 'ºC'),
	(117668, 112, '2015-03-15 00:57:52.000000', 'temperatura', 729.0000, 'ºC'),
	(117669, 112, '2015-03-15 00:57:53.000000', 'temperatura', 80.0000, 'ºC'),
	(117670, 112, '2015-03-15 00:57:54.000000', 'temperatura', 612.0000, 'ºC'),
	(117671, 112, '2015-03-15 00:57:55.000000', 'temperatura', 420.0000, 'ºC'),
	(117672, 112, '2015-03-15 00:57:56.000000', 'temperatura', 263.0000, 'ºC'),
	(117673, 112, '2015-03-15 00:57:57.000000', 'temperatura', 57.0000, 'ºC'),
	(117674, 112, '2015-03-15 00:57:58.000000', 'temperatura', 695.0000, 'ºC'),
	(117675, 112, '2015-03-15 00:57:59.000000', 'temperatura', 907.0000, 'ºC'),
	(117676, 112, '2015-03-15 00:58:00.000000', 'temperatura', 52.0000, 'ºC'),
	(117677, 112, '2015-03-15 00:58:01.000000', 'temperatura', 1136.0000, 'ºC'),
	(117678, 112, '2015-03-15 00:58:02.000000', 'temperatura', 725.0000, 'ºC'),
	(117679, 112, '2015-03-15 00:58:03.000000', 'temperatura', 219.0000, 'ºC'),
	(117680, 112, '2015-03-15 00:58:04.000000', 'temperatura', 121.0000, 'ºC'),
	(117681, 112, '2015-03-15 00:58:05.000000', 'temperatura', 1149.0000, 'ºC'),
	(117682, 112, '2015-03-15 00:58:06.000000', 'temperatura', 580.0000, 'ºC'),
	(117683, 112, '2015-03-15 00:58:07.000000', 'temperatura', 655.0000, 'ºC'),
	(117684, 112, '2015-03-15 00:58:08.000000', 'temperatura', 336.0000, 'ºC'),
	(117685, 112, '2015-03-15 00:58:09.000000', 'temperatura', 915.0000, 'ºC'),
	(117686, 112, '2015-03-15 00:58:10.000000', 'temperatura', 1166.0000, 'ºC'),
	(117687, 112, '2015-03-15 00:58:11.000000', 'temperatura', 686.0000, 'ºC'),
	(117688, 112, '2015-03-15 00:58:12.000000', 'temperatura', 1133.0000, 'ºC'),
	(117689, 112, '2015-03-15 00:58:13.000000', 'temperatura', 7.0000, 'ºC'),
	(117690, 112, '2015-03-15 00:58:14.000000', 'temperatura', 235.0000, 'ºC'),
	(117691, 112, '2015-03-15 00:58:15.000000', 'temperatura', 1156.0000, 'ºC'),
	(117692, 112, '2015-03-15 00:58:16.000000', 'temperatura', 276.0000, 'ºC'),
	(117693, 112, '2015-03-15 00:58:17.000000', 'temperatura', 313.0000, 'ºC'),
	(117694, 112, '2015-03-15 00:58:18.000000', 'temperatura', 736.0000, 'ºC'),
	(117695, 112, '2015-03-15 00:58:19.000000', 'temperatura', 342.0000, 'ºC'),
	(117696, 112, '2015-03-15 00:58:20.000000', 'temperatura', 702.0000, 'ºC'),
	(117697, 112, '2015-03-15 00:58:21.000000', 'temperatura', 83.0000, 'ºC'),
	(117698, 112, '2015-03-15 00:58:22.000000', 'temperatura', 711.0000, 'ºC'),
	(117699, 112, '2015-03-15 00:58:23.000000', 'temperatura', 906.0000, 'ºC'),
	(117700, 112, '2015-03-15 00:58:24.000000', 'temperatura', 1197.0000, 'ºC'),
	(117701, 112, '2015-03-15 00:58:25.000000', 'temperatura', 869.0000, 'ºC'),
	(117702, 112, '2015-03-15 00:58:26.000000', 'temperatura', 755.0000, 'ºC'),
	(117703, 112, '2015-03-15 00:58:27.000000', 'temperatura', 1166.0000, 'ºC'),
	(117704, 112, '2015-03-15 00:58:28.000000', 'temperatura', 1167.0000, 'ºC'),
	(117705, 112, '2015-03-15 00:58:29.000000', 'temperatura', 1139.0000, 'ºC'),
	(117706, 112, '2015-03-15 00:58:30.000000', 'temperatura', 994.0000, 'ºC'),
	(117707, 112, '2015-03-15 00:58:31.000000', 'temperatura', 352.0000, 'ºC'),
	(117708, 112, '2015-03-15 00:58:32.000000', 'temperatura', 1180.0000, 'ºC'),
	(117709, 112, '2015-03-15 00:58:33.000000', 'temperatura', 45.0000, 'ºC'),
	(117710, 112, '2015-03-15 00:58:34.000000', 'temperatura', 287.0000, 'ºC'),
	(117711, 112, '2015-03-15 00:58:35.000000', 'temperatura', 99.0000, 'ºC'),
	(117712, 112, '2015-03-15 00:58:36.000000', 'temperatura', 833.0000, 'ºC'),
	(117713, 112, '2015-03-15 00:58:37.000000', 'temperatura', 268.0000, 'ºC'),
	(117714, 112, '2015-03-15 00:58:38.000000', 'temperatura', 41.0000, 'ºC'),
	(117715, 112, '2015-03-15 00:58:39.000000', 'temperatura', 602.0000, 'ºC'),
	(117716, 112, '2015-03-15 00:58:40.000000', 'temperatura', 489.0000, 'ºC'),
	(117717, 112, '2015-03-15 00:58:41.000000', 'temperatura', 637.0000, 'ºC'),
	(117718, 112, '2015-03-15 00:58:42.000000', 'temperatura', 522.0000, 'ºC'),
	(117719, 112, '2015-03-15 00:58:43.000000', 'temperatura', 697.0000, 'ºC'),
	(117720, 112, '2015-03-15 00:58:44.000000', 'temperatura', 721.0000, 'ºC'),
	(117721, 112, '2015-03-15 00:58:45.000000', 'temperatura', 316.0000, 'ºC'),
	(117722, 112, '2015-03-15 00:58:46.000000', 'temperatura', 616.0000, 'ºC'),
	(117723, 112, '2015-03-15 00:58:47.000000', 'temperatura', 932.0000, 'ºC'),
	(117724, 112, '2015-03-15 00:58:48.000000', 'temperatura', 413.0000, 'ºC'),
	(117725, 112, '2015-03-15 00:58:49.000000', 'temperatura', 471.0000, 'ºC'),
	(117726, 112, '2015-03-15 00:58:50.000000', 'temperatura', 1114.0000, 'ºC'),
	(117727, 112, '2015-03-15 00:58:51.000000', 'temperatura', 559.0000, 'ºC'),
	(117728, 112, '2015-03-15 00:58:52.000000', 'temperatura', 652.0000, 'ºC'),
	(117729, 112, '2015-03-15 00:58:53.000000', 'temperatura', 384.0000, 'ºC'),
	(117730, 112, '2015-03-15 00:58:54.000000', 'temperatura', 1164.0000, 'ºC'),
	(117731, 112, '2015-03-15 00:58:55.000000', 'temperatura', 1067.0000, 'ºC'),
	(117732, 112, '2015-03-15 00:58:56.000000', 'temperatura', 645.0000, 'ºC'),
	(117733, 112, '2015-03-15 00:58:57.000000', 'temperatura', 25.0000, 'ºC'),
	(117734, 112, '2015-03-15 00:58:58.000000', 'temperatura', 590.0000, 'ºC'),
	(117735, 112, '2015-03-15 00:58:59.000000', 'temperatura', 474.0000, 'ºC'),
	(117736, 112, '2015-03-15 00:59:00.000000', 'temperatura', 604.0000, 'ºC'),
	(117737, 112, '2015-03-15 00:59:01.000000', 'temperatura', 395.0000, 'ºC'),
	(117738, 112, '2015-03-15 00:59:02.000000', 'temperatura', 165.0000, 'ºC'),
	(117739, 112, '2015-03-15 00:59:03.000000', 'temperatura', 842.0000, 'ºC'),
	(117740, 112, '2015-03-15 00:59:04.000000', 'temperatura', 114.0000, 'ºC'),
	(117741, 112, '2015-03-15 00:59:05.000000', 'temperatura', 446.0000, 'ºC'),
	(117742, 112, '2015-03-15 00:59:06.000000', 'temperatura', 686.0000, 'ºC'),
	(117743, 112, '2015-03-15 00:59:07.000000', 'temperatura', 893.0000, 'ºC'),
	(117744, 112, '2015-03-15 00:59:08.000000', 'temperatura', 7.0000, 'ºC'),
	(117745, 112, '2015-03-15 00:59:09.000000', 'temperatura', 957.0000, 'ºC'),
	(117746, 112, '2015-03-15 00:59:10.000000', 'temperatura', 1163.0000, 'ºC'),
	(117747, 112, '2015-03-15 00:59:11.000000', 'temperatura', 544.0000, 'ºC'),
	(117748, 112, '2015-03-15 00:59:12.000000', 'temperatura', 433.0000, 'ºC'),
	(117749, 112, '2015-03-15 00:59:13.000000', 'temperatura', 535.0000, 'ºC'),
	(117750, 112, '2015-03-15 00:59:14.000000', 'temperatura', 174.0000, 'ºC'),
	(117751, 112, '2015-03-15 00:59:15.000000', 'temperatura', 464.0000, 'ºC'),
	(117752, 112, '2015-03-15 00:59:16.000000', 'temperatura', 601.0000, 'ºC'),
	(117753, 112, '2015-03-15 00:59:17.000000', 'temperatura', 414.0000, 'ºC'),
	(117754, 112, '2015-03-15 00:59:18.000000', 'temperatura', 267.0000, 'ºC'),
	(117755, 112, '2015-03-15 00:59:19.000000', 'temperatura', 93.0000, 'ºC'),
	(117756, 112, '2015-03-15 00:59:20.000000', 'temperatura', 864.0000, 'ºC'),
	(117757, 112, '2015-03-15 00:59:21.000000', 'temperatura', 441.0000, 'ºC'),
	(117758, 112, '2015-03-15 00:59:22.000000', 'temperatura', 816.0000, 'ºC'),
	(117759, 112, '2015-03-15 00:59:23.000000', 'temperatura', 357.0000, 'ºC'),
	(117760, 112, '2015-03-15 00:59:24.000000', 'temperatura', 538.0000, 'ºC'),
	(117761, 112, '2015-03-15 00:59:25.000000', 'temperatura', 420.0000, 'ºC'),
	(117762, 112, '2015-03-15 00:59:26.000000', 'temperatura', 487.0000, 'ºC'),
	(117763, 112, '2015-03-15 00:59:27.000000', 'temperatura', 1173.0000, 'ºC'),
	(117764, 112, '2015-03-15 00:59:28.000000', 'temperatura', 805.0000, 'ºC'),
	(117765, 112, '2015-03-15 00:59:29.000000', 'temperatura', 505.0000, 'ºC'),
	(117766, 112, '2015-03-15 00:59:30.000000', 'temperatura', 113.0000, 'ºC'),
	(117767, 112, '2015-03-15 00:59:31.000000', 'temperatura', 248.0000, 'ºC'),
	(117768, 112, '2015-03-15 00:59:32.000000', 'temperatura', 901.0000, 'ºC'),
	(117769, 112, '2015-03-15 00:59:33.000000', 'temperatura', 162.0000, 'ºC'),
	(117770, 112, '2015-03-15 00:59:34.000000', 'temperatura', 508.0000, 'ºC'),
	(117771, 112, '2015-03-15 00:59:35.000000', 'temperatura', 854.0000, 'ºC'),
	(117772, 112, '2015-03-15 00:59:36.000000', 'temperatura', 345.0000, 'ºC'),
	(117773, 112, '2015-03-15 00:59:37.000000', 'temperatura', 367.0000, 'ºC'),
	(117774, 112, '2015-03-15 00:59:38.000000', 'temperatura', 797.0000, 'ºC'),
	(117775, 112, '2015-03-15 00:59:39.000000', 'temperatura', 487.0000, 'ºC'),
	(117776, 112, '2015-03-15 00:59:40.000000', 'temperatura', 45.0000, 'ºC'),
	(117777, 112, '2015-03-15 00:59:41.000000', 'temperatura', 1164.0000, 'ºC'),
	(117778, 112, '2015-03-15 00:59:42.000000', 'temperatura', 886.0000, 'ºC'),
	(117779, 112, '2015-03-15 00:59:43.000000', 'temperatura', 938.0000, 'ºC'),
	(117780, 112, '2015-03-15 00:59:44.000000', 'temperatura', 834.0000, 'ºC'),
	(117781, 112, '2015-03-15 00:59:45.000000', 'temperatura', 157.0000, 'ºC'),
	(117782, 112, '2015-03-15 00:59:46.000000', 'temperatura', 681.0000, 'ºC'),
	(117783, 112, '2015-03-15 00:59:47.000000', 'temperatura', 537.0000, 'ºC'),
	(117784, 112, '2015-03-15 00:59:48.000000', 'temperatura', 642.0000, 'ºC'),
	(117785, 112, '2015-03-15 00:59:49.000000', 'temperatura', 398.0000, 'ºC'),
	(117786, 112, '2015-03-15 00:59:50.000000', 'temperatura', 67.0000, 'ºC'),
	(117787, 112, '2015-03-15 00:59:51.000000', 'temperatura', 340.0000, 'ºC'),
	(117788, 112, '2015-03-15 00:59:52.000000', 'temperatura', 298.0000, 'ºC'),
	(117789, 112, '2015-03-15 00:59:53.000000', 'temperatura', 471.0000, 'ºC'),
	(117790, 112, '2015-03-15 00:59:54.000000', 'temperatura', 260.0000, 'ºC'),
	(117791, 112, '2015-03-15 00:59:55.000000', 'temperatura', 1089.0000, 'ºC'),
	(117792, 112, '2015-03-15 00:59:56.000000', 'temperatura', 1064.0000, 'ºC'),
	(117793, 112, '2015-03-15 00:59:57.000000', 'temperatura', 854.0000, 'ºC'),
	(117794, 112, '2015-03-15 00:59:58.000000', 'temperatura', 1078.0000, 'ºC'),
	(117795, 112, '2015-03-15 00:59:59.000000', 'temperatura', 429.0000, 'ºC'),
	(117796, 112, '2015-03-15 01:00:00.000000', 'temperatura', 112.0000, 'ºC'),
	(117797, 112, '2015-03-15 01:00:01.000000', 'temperatura', 471.0000, 'ºC'),
	(117798, 112, '2015-03-15 01:00:02.000000', 'temperatura', 822.0000, 'ºC'),
	(117799, 112, '2015-03-15 01:00:03.000000', 'temperatura', 295.0000, 'ºC'),
	(117800, 112, '2015-03-15 01:00:04.000000', 'temperatura', 212.0000, 'ºC'),
	(117801, 112, '2015-03-15 01:00:05.000000', 'temperatura', 174.0000, 'ºC'),
	(117802, 112, '2015-03-15 01:00:06.000000', 'temperatura', 234.0000, 'ºC'),
	(117803, 112, '2015-03-15 01:00:07.000000', 'temperatura', 649.0000, 'ºC'),
	(117804, 112, '2015-03-15 01:00:08.000000', 'temperatura', 143.0000, 'ºC'),
	(117805, 112, '2015-03-15 01:00:09.000000', 'temperatura', 1167.0000, 'ºC'),
	(117806, 112, '2015-03-15 01:00:10.000000', 'temperatura', 607.0000, 'ºC'),
	(117807, 112, '2015-03-15 01:00:11.000000', 'temperatura', 736.0000, 'ºC'),
	(117808, 112, '2015-03-15 01:00:12.000000', 'temperatura', 658.0000, 'ºC'),
	(117809, 112, '2015-03-15 01:00:13.000000', 'temperatura', 1083.0000, 'ºC'),
	(117810, 112, '2015-03-15 01:00:14.000000', 'temperatura', 1042.0000, 'ºC'),
	(117811, 112, '2015-03-15 01:00:15.000000', 'temperatura', 763.0000, 'ºC'),
	(117812, 112, '2015-03-15 01:00:16.000000', 'temperatura', 686.0000, 'ºC'),
	(117813, 112, '2015-03-15 01:00:17.000000', 'temperatura', 1144.0000, 'ºC'),
	(117814, 112, '2015-03-15 01:00:18.000000', 'temperatura', 63.0000, 'ºC'),
	(117815, 112, '2015-03-15 01:00:19.000000', 'temperatura', 483.0000, 'ºC'),
	(117816, 112, '2015-03-15 01:00:20.000000', 'temperatura', 1026.0000, 'ºC'),
	(117817, 112, '2015-03-15 01:00:21.000000', 'temperatura', 83.0000, 'ºC'),
	(117818, 112, '2015-03-15 01:00:22.000000', 'temperatura', 935.0000, 'ºC'),
	(117819, 112, '2015-03-15 01:00:23.000000', 'temperatura', 826.0000, 'ºC'),
	(117820, 112, '2015-03-15 01:00:24.000000', 'temperatura', 128.0000, 'ºC'),
	(117821, 112, '2015-03-15 01:00:25.000000', 'temperatura', 562.0000, 'ºC'),
	(117822, 112, '2015-03-15 01:00:26.000000', 'temperatura', 26.0000, 'ºC'),
	(117823, 112, '2015-03-15 01:00:27.000000', 'temperatura', 845.0000, 'ºC'),
	(117824, 112, '2015-03-15 01:00:28.000000', 'temperatura', 546.0000, 'ºC'),
	(117825, 112, '2015-03-15 01:00:29.000000', 'temperatura', 197.0000, 'ºC'),
	(117826, 112, '2015-03-15 01:00:30.000000', 'temperatura', 546.0000, 'ºC'),
	(117827, 112, '2015-03-15 01:00:31.000000', 'temperatura', 940.0000, 'ºC'),
	(117828, 112, '2015-03-15 01:00:32.000000', 'temperatura', 664.0000, 'ºC'),
	(117829, 112, '2015-03-15 01:00:33.000000', 'temperatura', 500.0000, 'ºC'),
	(117830, 112, '2015-03-15 01:00:34.000000', 'temperatura', 506.0000, 'ºC'),
	(117831, 112, '2015-03-15 01:00:35.000000', 'temperatura', 1033.0000, 'ºC'),
	(117832, 112, '2015-03-15 01:00:36.000000', 'temperatura', 48.0000, 'ºC'),
	(117833, 112, '2015-03-15 01:00:37.000000', 'temperatura', 739.0000, 'ºC'),
	(117834, 112, '2015-03-15 01:00:38.000000', 'temperatura', 1155.0000, 'ºC'),
	(117835, 112, '2015-03-15 01:00:39.000000', 'temperatura', 1155.0000, 'ºC'),
	(117836, 112, '2015-03-15 01:00:40.000000', 'temperatura', 1114.0000, 'ºC'),
	(117837, 112, '2015-03-15 01:00:41.000000', 'temperatura', 903.0000, 'ºC'),
	(117838, 112, '2015-03-15 01:00:42.000000', 'temperatura', 1174.0000, 'ºC'),
	(117839, 112, '2015-03-15 01:00:43.000000', 'temperatura', 762.0000, 'ºC'),
	(117840, 112, '2015-03-15 01:00:44.000000', 'temperatura', 288.0000, 'ºC'),
	(117841, 112, '2015-03-15 01:00:45.000000', 'temperatura', 356.0000, 'ºC'),
	(117842, 112, '2015-03-15 01:00:46.000000', 'temperatura', 914.0000, 'ºC'),
	(117843, 112, '2015-03-15 01:00:47.000000', 'temperatura', 1104.0000, 'ºC'),
	(117844, 112, '2015-03-15 01:00:48.000000', 'temperatura', 378.0000, 'ºC'),
	(117845, 112, '2015-03-15 01:00:49.000000', 'temperatura', 979.0000, 'ºC'),
	(117846, 112, '2015-03-15 01:00:50.000000', 'temperatura', 162.0000, 'ºC'),
	(117847, 112, '2015-03-15 01:00:51.000000', 'temperatura', 271.0000, 'ºC'),
	(117848, 112, '2015-03-15 01:00:52.000000', 'temperatura', 873.0000, 'ºC'),
	(117849, 112, '2015-03-15 01:00:53.000000', 'temperatura', 1151.0000, 'ºC'),
	(117850, 112, '2015-03-15 01:00:54.000000', 'temperatura', 735.0000, 'ºC'),
	(117851, 112, '2015-03-15 01:00:55.000000', 'temperatura', 224.0000, 'ºC'),
	(117852, 112, '2015-03-15 01:00:56.000000', 'temperatura', 115.0000, 'ºC'),
	(117853, 112, '2015-03-15 01:00:57.000000', 'temperatura', 1104.0000, 'ºC'),
	(117854, 112, '2015-03-15 01:00:58.000000', 'temperatura', 374.0000, 'ºC'),
	(117855, 112, '2015-03-15 01:00:59.000000', 'temperatura', 959.0000, 'ºC'),
	(117856, 112, '2015-03-15 01:01:00.000000', 'temperatura', 72.0000, 'ºC'),
	(117857, 112, '2015-03-15 01:01:01.000000', 'temperatura', 1084.0000, 'ºC'),
	(117858, 112, '2015-03-15 01:01:02.000000', 'temperatura', 405.0000, 'ºC'),
	(117859, 112, '2015-03-15 01:01:03.000000', 'temperatura', 1172.0000, 'ºC'),
	(117860, 112, '2015-03-15 01:01:04.000000', 'temperatura', 1046.0000, 'ºC'),
	(117861, 112, '2015-03-15 01:01:05.000000', 'temperatura', 514.0000, 'ºC'),
	(117862, 112, '2015-03-15 01:01:06.000000', 'temperatura', 635.0000, 'ºC'),
	(117863, 112, '2015-03-15 01:01:07.000000', 'temperatura', 431.0000, 'ºC'),
	(117864, 112, '2015-03-15 01:01:08.000000', 'temperatura', 253.0000, 'ºC'),
	(117865, 112, '2015-03-15 01:01:09.000000', 'temperatura', 1170.0000, 'ºC'),
	(117866, 112, '2015-03-15 01:01:10.000000', 'temperatura', 292.0000, 'ºC'),
	(117867, 112, '2015-03-15 01:01:11.000000', 'temperatura', 353.0000, 'ºC'),
	(117868, 112, '2015-03-15 01:01:12.000000', 'temperatura', 887.0000, 'ºC'),
	(117869, 112, '2015-03-15 01:01:13.000000', 'temperatura', 977.0000, 'ºC'),
	(117870, 112, '2015-03-15 01:01:14.000000', 'temperatura', 1023.0000, 'ºC'),
	(117871, 112, '2015-03-15 01:01:15.000000', 'temperatura', 985.0000, 'ºC'),
	(117872, 112, '2015-03-15 01:01:16.000000', 'temperatura', 659.0000, 'ºC'),
	(117873, 112, '2015-03-15 01:01:17.000000', 'temperatura', 339.0000, 'ºC'),
	(117874, 112, '2015-03-15 01:01:18.000000', 'temperatura', 917.0000, 'ºC'),
	(117875, 112, '2015-03-15 01:01:19.000000', 'temperatura', 1168.0000, 'ºC'),
	(117876, 112, '2015-03-15 01:01:20.000000', 'temperatura', 690.0000, 'ºC'),
	(117877, 112, '2015-03-15 01:01:21.000000', 'temperatura', 1148.0000, 'ºC'),
	(117878, 112, '2015-03-15 01:01:22.000000', 'temperatura', 71.0000, 'ºC'),
	(117879, 112, '2015-03-15 01:01:23.000000', 'temperatura', 512.0000, 'ºC'),
	(117880, 112, '2015-03-15 01:01:24.000000', 'temperatura', 1146.0000, 'ºC'),
	(117881, 112, '2015-03-15 01:01:25.000000', 'temperatura', 595.0000, 'ºC'),
	(117882, 112, '2015-03-15 01:01:26.000000', 'temperatura', 736.0000, 'ºC'),
	(117883, 112, '2015-03-15 01:01:27.000000', 'temperatura', 695.0000, 'ºC'),
	(117884, 112, '2015-03-15 01:01:28.000000', 'temperatura', 71.0000, 'ºC'),
	(117885, 112, '2015-03-15 01:01:29.000000', 'temperatura', 667.0000, 'ºC'),
	(117886, 112, '2015-03-15 01:01:30.000000', 'temperatura', 724.0000, 'ºC'),
	(117887, 112, '2015-03-15 01:01:31.000000', 'temperatura', 418.0000, 'ºC'),
	(117888, 112, '2015-03-15 01:01:32.000000', 'temperatura', 1119.0000, 'ºC'),
	(117889, 112, '2015-03-15 01:01:33.000000', 'temperatura', 741.0000, 'ºC'),
	(117890, 112, '2015-03-15 01:01:34.000000', 'temperatura', 351.0000, 'ºC'),
	(117891, 112, '2015-03-15 01:01:35.000000', 'temperatura', 731.0000, 'ºC'),
	(117892, 112, '2015-03-15 01:01:36.000000', 'temperatura', 203.0000, 'ºC'),
	(117893, 112, '2015-03-15 01:01:37.000000', 'temperatura', 23.0000, 'ºC'),
	(117894, 112, '2015-03-15 01:01:38.000000', 'temperatura', 706.0000, 'ºC'),
	(117895, 112, '2015-03-15 01:01:39.000000', 'temperatura', 1062.0000, 'ºC'),
	(117896, 112, '2015-03-15 01:01:40.000000', 'temperatura', 792.0000, 'ºC'),
	(117897, 112, '2015-03-15 01:01:41.000000', 'temperatura', 775.0000, 'ºC'),
	(117898, 112, '2015-03-15 01:01:42.000000', 'temperatura', 298.0000, 'ºC'),
	(117899, 112, '2015-03-15 01:01:43.000000', 'temperatura', 364.0000, 'ºC'),
	(117900, 112, '2015-03-15 01:01:44.000000', 'temperatura', 929.0000, 'ºC'),
	(117901, 112, '2015-03-15 01:01:45.000000', 'temperatura', 1153.0000, 'ºC'),
	(117902, 112, '2015-03-15 01:01:46.000000', 'temperatura', 580.0000, 'ºC'),
	(117903, 112, '2015-03-15 01:01:47.000000', 'temperatura', 640.0000, 'ºC'),
	(117904, 112, '2015-03-15 01:01:48.000000', 'temperatura', 261.0000, 'ºC'),
	(117905, 112, '2015-03-15 01:01:49.000000', 'temperatura', 587.0000, 'ºC'),
	(117906, 112, '2015-03-15 01:01:50.000000', 'temperatura', 952.0000, 'ºC'),
	(117907, 112, '2015-03-15 01:01:51.000000', 'temperatura', 598.0000, 'ºC'),
	(117908, 112, '2015-03-15 01:01:52.000000', 'temperatura', 134.0000, 'ºC'),
	(117909, 112, '2015-03-15 01:01:53.000000', 'temperatura', 79.0000, 'ºC'),
	(117910, 112, '2015-03-15 01:01:54.000000', 'temperatura', 1192.0000, 'ºC'),
	(117911, 112, '2015-03-15 01:01:55.000000', 'temperatura', 923.0000, 'ºC'),
	(117912, 112, '2015-03-15 01:01:56.000000', 'temperatura', 1041.0000, 'ºC'),
	(117913, 112, '2015-03-15 01:01:57.000000', 'temperatura', 35.0000, 'ºC'),
	(117914, 112, '2015-03-15 01:01:58.000000', 'temperatura', 651.0000, 'ºC'),
	(117915, 112, '2015-03-15 01:01:59.000000', 'temperatura', 754.0000, 'ºC'),
	(117916, 112, '2015-03-15 01:02:00.000000', 'temperatura', 614.0000, 'ºC'),
	(117917, 112, '2015-03-15 01:02:01.000000', 'temperatura', 811.0000, 'ºC'),
	(117918, 112, '2015-03-15 01:02:02.000000', 'temperatura', 1011.0000, 'ºC'),
	(117919, 112, '2015-03-15 01:02:03.000000', 'temperatura', 222.0000, 'ºC'),
	(117920, 112, '2015-03-15 01:02:04.000000', 'temperatura', 479.0000, 'ºC'),
	(117921, 112, '2015-03-15 01:02:05.000000', 'temperatura', 531.0000, 'ºC'),
	(117922, 112, '2015-03-15 01:02:06.000000', 'temperatura', 16.0000, 'ºC'),
	(117923, 112, '2015-03-15 01:02:07.000000', 'temperatura', 889.0000, 'ºC'),
	(117924, 112, '2015-03-15 01:02:08.000000', 'temperatura', 797.0000, 'ºC'),
	(117925, 112, '2015-03-15 01:02:09.000000', 'temperatura', 117.0000, 'ºC'),
	(117926, 112, '2015-03-15 01:02:10.000000', 'temperatura', 595.0000, 'ºC'),
	(117927, 112, '2015-03-15 01:02:11.000000', 'temperatura', 225.0000, 'ºC'),
	(117928, 112, '2015-03-15 01:02:12.000000', 'temperatura', 541.0000, 'ºC'),
	(117929, 112, '2015-03-15 01:02:13.000000', 'temperatura', 830.0000, 'ºC'),
	(117930, 112, '2015-03-15 01:02:14.000000', 'temperatura', 128.0000, 'ºC'),
	(117931, 112, '2015-03-15 01:02:15.000000', 'temperatura', 548.0000, 'ºC'),
	(117932, 112, '2015-03-15 01:02:16.000000', 'temperatura', 1160.0000, 'ºC'),
	(117933, 112, '2015-03-15 01:02:17.000000', 'temperatura', 555.0000, 'ºC'),
	(117934, 112, '2015-03-15 01:02:18.000000', 'temperatura', 495.0000, 'ºC'),
	(117935, 112, '2015-03-15 01:02:19.000000', 'temperatura', 809.0000, 'ºC'),
	(117936, 112, '2015-03-15 01:02:20.000000', 'temperatura', 163.0000, 'ºC'),
	(117937, 112, '2015-03-15 01:02:21.000000', 'temperatura', 787.0000, 'ºC'),
	(117938, 112, '2015-03-15 01:02:22.000000', 'temperatura', 1049.0000, 'ºC'),
	(117939, 112, '2015-03-15 01:02:23.000000', 'temperatura', 482.0000, 'ºC'),
	(117940, 112, '2015-03-15 01:02:24.000000', 'temperatura', 464.0000, 'ºC'),
	(117941, 112, '2015-03-15 01:02:25.000000', 'temperatura', 874.0000, 'ºC'),
	(117942, 112, '2015-03-15 01:02:26.000000', 'temperatura', 579.0000, 'ºC'),
	(117943, 112, '2015-03-15 01:02:27.000000', 'temperatura', 272.0000, 'ºC'),
	(117944, 112, '2015-03-15 01:02:28.000000', 'temperatura', 826.0000, 'ºC'),
	(117945, 112, '2015-03-15 01:02:29.000000', 'temperatura', 913.0000, 'ºC'),
	(117946, 112, '2015-03-15 01:02:30.000000', 'temperatura', 887.0000, 'ºC'),
	(117947, 112, '2015-03-15 01:02:31.000000', 'temperatura', 499.0000, 'ºC'),
	(117948, 112, '2015-03-15 01:02:32.000000', 'temperatura', 1033.0000, 'ºC'),
	(117949, 112, '2015-03-15 01:02:33.000000', 'temperatura', 69.0000, 'ºC'),
	(117950, 112, '2015-03-15 01:02:34.000000', 'temperatura', 846.0000, 'ºC'),
	(117951, 112, '2015-03-15 01:02:35.000000', 'temperatura', 422.0000, 'ºC'),
	(117952, 112, '2015-03-15 01:02:36.000000', 'temperatura', 772.0000, 'ºC'),
	(117953, 112, '2015-03-15 01:02:37.000000', 'temperatura', 195.0000, 'ºC'),
	(117954, 112, '2015-03-15 01:02:38.000000', 'temperatura', 1060.0000, 'ºC'),
	(117955, 112, '2015-03-15 01:02:39.000000', 'temperatura', 1117.0000, 'ºC'),
	(117956, 112, '2015-03-15 01:02:40.000000', 'temperatura', 4.0000, 'ºC'),
	(117957, 112, '2015-03-15 01:02:41.000000', 'temperatura', 270.0000, 'ºC'),
	(117958, 112, '2015-03-15 01:02:42.000000', 'temperatura', 138.0000, 'ºC'),
	(117959, 112, '2015-03-15 01:02:43.000000', 'temperatura', 1079.0000, 'ºC'),
	(117960, 112, '2015-03-15 01:02:44.000000', 'temperatura', 182.0000, 'ºC'),
	(117961, 112, '2015-03-15 01:02:45.000000', 'temperatura', 73.0000, 'ºC'),
	(117962, 112, '2015-03-15 01:02:46.000000', 'temperatura', 1021.0000, 'ºC'),
	(117963, 112, '2015-03-15 01:02:47.000000', 'temperatura', 88.0000, 'ºC'),
	(117964, 112, '2015-03-15 01:02:48.000000', 'temperatura', 975.0000, 'ºC'),
	(117965, 112, '2015-03-15 01:02:49.000000', 'temperatura', 1013.0000, 'ºC'),
	(117966, 112, '2015-03-15 01:02:50.000000', 'temperatura', 939.0000, 'ºC'),
	(117967, 112, '2015-03-15 01:02:51.000000', 'temperatura', 459.0000, 'ºC'),
	(117968, 112, '2015-03-15 01:02:52.000000', 'temperatura', 677.0000, 'ºC'),
	(117969, 112, '2015-03-15 01:02:53.000000', 'temperatura', 807.0000, 'ºC'),
	(117970, 112, '2015-03-15 01:02:54.000000', 'temperatura', 806.0000, 'ºC'),
	(117971, 112, '2015-03-15 01:02:55.000000', 'temperatura', 410.0000, 'ºC'),
	(117972, 112, '2015-03-15 01:02:56.000000', 'temperatura', 831.0000, 'ºC'),
	(117973, 112, '2015-03-15 01:02:57.000000', 'temperatura', 528.0000, 'ºC'),
	(117974, 112, '2015-03-15 01:02:58.000000', 'temperatura', 144.0000, 'ºC'),
	(117975, 112, '2015-03-15 01:02:59.000000', 'temperatura', 340.0000, 'ºC'),
	(117976, 112, '2015-03-15 01:03:00.000000', 'temperatura', 65.0000, 'ºC'),
	(117977, 112, '2015-03-15 01:03:01.000000', 'temperatura', 508.0000, 'ºC'),
	(117978, 112, '2015-03-15 01:03:02.000000', 'temperatura', 1146.0000, 'ºC'),
	(117979, 112, '2015-03-15 01:03:03.000000', 'temperatura', 604.0000, 'ºC'),
	(117980, 112, '2015-03-15 01:03:04.000000', 'temperatura', 782.0000, 'ºC'),
	(117981, 112, '2015-03-15 01:03:05.000000', 'temperatura', 901.0000, 'ºC'),
	(117982, 112, '2015-03-15 01:03:06.000000', 'temperatura', 958.0000, 'ºC'),
	(117983, 112, '2015-03-15 01:03:07.000000', 'temperatura', 888.0000, 'ºC'),
	(117984, 112, '2015-03-15 01:03:08.000000', 'temperatura', 365.0000, 'ºC'),
	(117985, 112, '2015-03-15 01:03:09.000000', 'temperatura', 362.0000, 'ºC'),
	(117986, 112, '2015-03-15 01:03:10.000000', 'temperatura', 717.0000, 'ºC'),
	(117987, 112, '2015-03-15 01:03:11.000000', 'temperatura', 98.0000, 'ºC'),
	(117988, 112, '2015-03-15 01:03:12.000000', 'temperatura', 742.0000, 'ºC'),
	(117989, 112, '2015-03-15 01:03:13.000000', 'temperatura', 1015.0000, 'ºC'),
	(117990, 112, '2015-03-15 01:03:14.000000', 'temperatura', 450.0000, 'ºC'),
	(117991, 112, '2015-03-15 01:03:15.000000', 'temperatura', 405.0000, 'ºC'),
	(117992, 112, '2015-03-15 01:03:16.000000', 'temperatura', 677.0000, 'ºC'),
	(117993, 112, '2015-03-15 01:03:17.000000', 'temperatura', 972.0000, 'ºC'),
	(117994, 112, '2015-03-15 01:03:18.000000', 'temperatura', 426.0000, 'ºC'),
	(117995, 112, '2015-03-15 01:03:19.000000', 'temperatura', 416.0000, 'ºC'),
	(117996, 112, '2015-03-15 01:03:20.000000', 'temperatura', 802.0000, 'ºC'),
	(117997, 112, '2015-03-15 01:03:21.000000', 'temperatura', 363.0000, 'ºC'),
	(117998, 112, '2015-03-15 01:03:22.000000', 'temperatura', 611.0000, 'ºC'),
	(117999, 112, '2015-03-15 01:03:23.000000', 'temperatura', 765.0000, 'ºC'),
	(118000, 112, '2015-03-15 01:03:24.000000', 'temperatura', 793.0000, 'ºC'),
	(118001, 112, '2015-03-15 01:03:25.000000', 'temperatura', 469.0000, 'ºC'),
	(118002, 112, '2015-03-15 01:03:26.000000', 'temperatura', 1169.0000, 'ºC'),
	(118003, 112, '2015-03-15 01:03:27.000000', 'temperatura', 839.0000, 'ºC'),
	(118004, 112, '2015-03-15 01:03:28.000000', 'temperatura', 688.0000, 'ºC'),
	(118005, 112, '2015-03-15 01:03:29.000000', 'temperatura', 923.0000, 'ºC'),
	(118006, 112, '2015-03-15 01:03:30.000000', 'temperatura', 152.0000, 'ºC'),
	(118007, 112, '2015-03-15 01:03:31.000000', 'temperatura', 390.0000, 'ºC'),
	(118008, 112, '2015-03-15 01:03:32.000000', 'temperatura', 296.0000, 'ºC'),
	(118009, 112, '2015-03-15 01:03:33.000000', 'temperatura', 310.0000, 'ºC'),
	(118010, 112, '2015-03-15 01:03:34.000000', 'temperatura', 662.0000, 'ºC'),
	(118011, 112, '2015-03-15 01:03:35.000000', 'temperatura', 1181.0000, 'ºC'),
	(118012, 112, '2015-03-15 01:03:36.000000', 'temperatura', 318.0000, 'ºC'),
	(118013, 112, '2015-03-15 01:03:37.000000', 'temperatura', 449.0000, 'ºC'),
	(118014, 112, '2015-03-15 01:03:38.000000', 'temperatura', 92.0000, 'ºC'),
	(118015, 112, '2015-03-15 01:03:39.000000', 'temperatura', 313.0000, 'ºC'),
	(118016, 112, '2015-03-15 01:03:40.000000', 'temperatura', 91.0000, 'ºC'),
	(118017, 112, '2015-03-15 01:03:41.000000', 'temperatura', 716.0000, 'ºC'),
	(118018, 112, '2015-03-15 01:03:42.000000', 'temperatura', 908.0000, 'ºC'),
	(118019, 112, '2015-03-15 01:03:43.000000', 'temperatura', 1190.0000, 'ºC'),
	(118020, 112, '2015-03-15 01:03:44.000000', 'temperatura', 827.0000, 'ºC'),
	(118021, 112, '2015-03-15 01:03:45.000000', 'temperatura', 565.0000, 'ºC'),
	(118022, 112, '2015-03-15 01:03:46.000000', 'temperatura', 343.0000, 'ºC'),
	(118023, 112, '2015-03-15 01:03:47.000000', 'temperatura', 23.0000, 'ºC'),
	(118024, 112, '2015-03-15 01:03:48.000000', 'temperatura', 285.0000, 'ºC'),
	(118025, 112, '2015-03-15 01:03:49.000000', 'temperatura', 159.0000, 'ºC'),
	(118026, 112, '2015-03-15 01:03:50.000000', 'temperatura', 1138.0000, 'ºC'),
	(118027, 112, '2015-03-15 01:03:51.000000', 'temperatura', 416.0000, 'ºC'),
	(118028, 112, '2015-03-15 01:03:52.000000', 'temperatura', 1064.0000, 'ºC'),
	(118029, 112, '2015-03-15 01:03:53.000000', 'temperatura', 471.0000, 'ºC'),
	(118030, 112, '2015-03-15 01:03:54.000000', 'temperatura', 367.0000, 'ºC'),
	(118031, 112, '2015-03-15 01:03:55.000000', 'temperatura', 421.0000, 'ºC'),
	(118032, 112, '2015-03-15 01:03:56.000000', 'temperatura', 1004.0000, 'ºC'),
	(118033, 112, '2015-03-15 01:03:57.000000', 'temperatura', 157.0000, 'ºC'),
	(118034, 112, '2015-03-15 01:03:58.000000', 'temperatura', 175.0000, 'ºC'),
	(118035, 112, '2015-03-15 01:03:59.000000', 'temperatura', 405.0000, 'ºC'),
	(118036, 112, '2015-03-15 01:04:00.000000', 'temperatura', 301.0000, 'ºC'),
	(118037, 112, '2015-03-15 01:04:01.000000', 'temperatura', 288.0000, 'ºC'),
	(118038, 112, '2015-03-15 01:04:02.000000', 'temperatura', 538.0000, 'ºC'),
	(118039, 112, '2015-03-15 01:04:03.000000', 'temperatura', 625.0000, 'ºC'),
	(118040, 112, '2015-03-15 01:04:04.000000', 'temperatura', 315.0000, 'ºC'),
	(118041, 112, '2015-03-15 01:04:05.000000', 'temperatura', 899.0000, 'ºC'),
	(118042, 112, '2015-03-15 01:04:06.000000', 'temperatura', 1150.0000, 'ºC'),
	(118043, 112, '2015-03-15 01:04:07.000000', 'temperatura', 652.0000, 'ºC'),
	(118044, 112, '2015-03-15 01:04:08.000000', 'temperatura', 1012.0000, 'ºC'),
	(118045, 112, '2015-03-15 01:04:09.000000', 'temperatura', 706.0000, 'ºC'),
	(118046, 112, '2015-03-15 01:04:10.000000', 'temperatura', 494.0000, 'ºC'),
	(118047, 112, '2015-03-15 01:04:11.000000', 'temperatura', 350.0000, 'ºC'),
	(118048, 112, '2015-03-15 01:04:12.000000', 'temperatura', 272.0000, 'ºC'),
	(118049, 112, '2015-03-15 01:04:13.000000', 'temperatura', 309.0000, 'ºC'),
	(118050, 112, '2015-03-15 01:04:14.000000', 'temperatura', 729.0000, 'ºC'),
	(118051, 112, '2015-03-15 01:04:15.000000', 'temperatura', 321.0000, 'ºC'),
	(118052, 112, '2015-03-15 01:04:16.000000', 'temperatura', 615.0000, 'ºC'),
	(118053, 112, '2015-03-15 01:04:17.000000', 'temperatura', 914.0000, 'ºC'),
	(118054, 112, '2015-03-15 01:04:18.000000', 'temperatura', 326.0000, 'ºC'),
	(118055, 112, '2015-03-15 01:04:19.000000', 'temperatura', 86.0000, 'ºC'),
	(118056, 112, '2015-03-15 01:04:20.000000', 'temperatura', 656.0000, 'ºC'),
	(118057, 112, '2015-03-15 01:04:21.000000', 'temperatura', 621.0000, 'ºC'),
	(118058, 112, '2015-03-15 01:04:22.000000', 'temperatura', 1138.0000, 'ºC'),
	(118059, 112, '2015-03-15 01:04:23.000000', 'temperatura', 228.0000, 'ºC'),
	(118060, 112, '2015-03-15 01:04:24.000000', 'temperatura', 125.0000, 'ºC'),
	(118061, 112, '2015-03-15 01:04:25.000000', 'temperatura', 1142.0000, 'ºC'),
	(118062, 112, '2015-03-15 01:04:26.000000', 'temperatura', 535.0000, 'ºC'),
	(118063, 112, '2015-03-15 01:04:27.000000', 'temperatura', 449.0000, 'ºC'),
	(118064, 112, '2015-03-15 01:04:28.000000', 'temperatura', 641.0000, 'ºC'),
	(118065, 112, '2015-03-15 01:04:29.000000', 'temperatura', 658.0000, 'ºC'),
	(118066, 112, '2015-03-15 01:04:30.000000', 'temperatura', 168.0000, 'ºC'),
	(118067, 112, '2015-03-15 01:04:31.000000', 'temperatura', 65.0000, 'ºC'),
	(118068, 112, '2015-03-15 01:04:32.000000', 'temperatura', 1021.0000, 'ºC'),
	(118069, 112, '2015-03-15 01:04:33.000000', 'temperatura', 111.0000, 'ºC'),
	(118070, 112, '2015-03-15 01:04:34.000000', 'temperatura', 1091.0000, 'ºC'),
	(118071, 112, '2015-03-15 01:04:35.000000', 'temperatura', 325.0000, 'ºC'),
	(118072, 112, '2015-03-15 01:04:36.000000', 'temperatura', 754.0000, 'ºC'),
	(118073, 112, '2015-03-15 01:04:37.000000', 'temperatura', 392.0000, 'ºC'),
	(118074, 112, '2015-03-15 01:04:38.000000', 'temperatura', 901.0000, 'ºC'),
	(118075, 112, '2015-03-15 01:04:39.000000', 'temperatura', 928.0000, 'ºC'),
	(118076, 112, '2015-03-15 01:04:40.000000', 'temperatura', 740.0000, 'ºC'),
	(118077, 112, '2015-03-15 01:04:41.000000', 'temperatura', 914.0000, 'ºC'),
	(118078, 112, '2015-03-15 01:04:42.000000', 'temperatura', 1151.0000, 'ºC'),
	(118079, 112, '2015-03-15 01:04:43.000000', 'temperatura', 613.0000, 'ºC'),
	(118080, 112, '2015-03-15 01:04:44.000000', 'temperatura', 814.0000, 'ºC'),
	(118081, 112, '2015-03-15 01:04:45.000000', 'temperatura', 1032.0000, 'ºC'),
	(118082, 112, '2015-03-15 01:04:46.000000', 'temperatura', 319.0000, 'ºC'),
	(118083, 112, '2015-03-15 01:04:47.000000', 'temperatura', 899.0000, 'ºC'),
	(118084, 112, '2015-03-15 01:04:48.000000', 'temperatura', 1137.0000, 'ºC'),
	(118085, 112, '2015-03-15 01:04:49.000000', 'temperatura', 590.0000, 'ºC'),
	(118086, 112, '2015-03-15 01:04:50.000000', 'temperatura', 740.0000, 'ºC'),
	(118087, 112, '2015-03-15 01:04:51.000000', 'temperatura', 731.0000, 'ºC'),
	(118088, 112, '2015-03-15 01:04:52.000000', 'temperatura', 235.0000, 'ºC'),
	(118089, 112, '2015-03-15 01:04:53.000000', 'temperatura', 181.0000, 'ºC'),
	(118090, 112, '2015-03-15 01:04:54.000000', 'temperatura', 199.0000, 'ºC'),
	(118091, 112, '2015-03-15 01:04:55.000000', 'temperatura', 455.0000, 'ºC'),
	(118092, 112, '2015-03-15 01:04:56.000000', 'temperatura', 479.0000, 'ºC'),
	(118093, 112, '2015-03-15 01:04:57.000000', 'temperatura', 1032.0000, 'ºC'),
	(118094, 112, '2015-03-15 01:04:58.000000', 'temperatura', 121.0000, 'ºC'),
	(118095, 112, '2015-03-15 01:04:59.000000', 'temperatura', 1109.0000, 'ºC'),
	(118096, 112, '2015-03-15 01:05:00.000000', 'temperatura', 384.0000, 'ºC'),
	(118097, 112, '2015-03-15 01:05:01.000000', 'temperatura', 991.0000, 'ºC'),
	(118098, 112, '2015-03-15 01:05:02.000000', 'temperatura', 206.0000, 'ºC'),
	(118099, 112, '2015-03-15 01:05:03.000000', 'temperatura', 457.0000, 'ºC'),
	(118100, 112, '2015-03-15 01:05:04.000000', 'temperatura', 469.0000, 'ºC'),
	(118101, 112, '2015-03-15 01:05:05.000000', 'temperatura', 972.0000, 'ºC'),
	(118102, 112, '2015-03-15 01:05:06.000000', 'temperatura', 1056.0000, 'ºC'),
	(118103, 112, '2015-03-15 01:05:07.000000', 'temperatura', 1162.0000, 'ºC'),
	(118104, 112, '2015-03-15 01:05:08.000000', 'temperatura', 245.0000, 'ºC'),
	(118105, 112, '2015-03-15 01:05:09.000000', 'temperatura', 139.0000, 'ºC'),
	(118106, 112, '2015-03-15 01:05:10.000000', 'temperatura', 1162.0000, 'ºC'),
	(118107, 112, '2015-03-15 01:05:11.000000', 'temperatura', 591.0000, 'ºC'),
	(118108, 112, '2015-03-15 01:05:12.000000', 'temperatura', 672.0000, 'ºC'),
	(118109, 112, '2015-03-15 01:05:13.000000', 'temperatura', 386.0000, 'ºC'),
	(118110, 112, '2015-03-15 01:05:14.000000', 'temperatura', 1117.0000, 'ºC'),
	(118111, 112, '2015-03-15 01:05:15.000000', 'temperatura', 825.0000, 'ºC'),
	(118112, 112, '2015-03-15 01:05:16.000000', 'temperatura', 775.0000, 'ºC'),
	(118113, 112, '2015-03-15 01:05:17.000000', 'temperatura', 201.0000, 'ºC'),
	(118114, 112, '2015-03-15 01:05:18.000000', 'temperatura', 1080.0000, 'ºC'),
	(118115, 112, '2015-03-15 01:05:19.000000', 'temperatura', 1198.0000, 'ºC'),
	(118116, 112, '2015-03-15 01:05:20.000000', 'temperatura', 350.0000, 'ºC'),
	(118117, 112, '2015-03-15 01:05:21.000000', 'temperatura', 558.0000, 'ºC'),
	(118118, 112, '2015-03-15 01:05:22.000000', 'temperatura', 540.0000, 'ºC'),
	(118119, 112, '2015-03-15 01:05:23.000000', 'temperatura', 1027.0000, 'ºC'),
	(118120, 112, '2015-03-15 01:05:24.000000', 'temperatura', 1115.0000, 'ºC'),
	(118121, 112, '2015-03-15 01:05:25.000000', 'temperatura', 94.0000, 'ºC'),
	(118122, 112, '2015-03-15 01:05:26.000000', 'temperatura', 726.0000, 'ºC'),
	(118123, 112, '2015-03-15 01:05:27.000000', 'temperatura', 946.0000, 'ºC'),
	(118124, 112, '2015-03-15 01:05:28.000000', 'temperatura', 156.0000, 'ºC'),
	(118125, 112, '2015-03-15 01:05:29.000000', 'temperatura', 339.0000, 'ºC'),
	(118126, 112, '2015-03-15 01:05:30.000000', 'temperatura', 30.0000, 'ºC'),
	(118127, 112, '2015-03-15 01:05:31.000000', 'temperatura', 334.0000, 'ºC'),
	(118128, 112, '2015-03-15 01:05:32.000000', 'temperatura', 381.0000, 'ºC'),
	(118129, 112, '2015-03-15 01:05:33.000000', 'temperatura', 903.0000, 'ºC'),
	(118130, 112, '2015-03-15 01:05:34.000000', 'temperatura', 971.0000, 'ºC'),
	(118131, 112, '2015-03-15 01:05:35.000000', 'temperatura', 946.0000, 'ºC'),
	(118132, 112, '2015-03-15 01:05:36.000000', 'temperatura', 620.0000, 'ºC'),
	(118133, 112, '2015-03-15 01:05:37.000000', 'temperatura', 261.0000, 'ºC'),
	(118134, 112, '2015-03-15 01:05:38.000000', 'temperatura', 647.0000, 'ºC'),
	(118135, 112, '2015-03-15 01:05:39.000000', 'temperatura', 54.0000, 'ºC'),
	(118136, 112, '2015-03-15 01:05:40.000000', 'temperatura', 726.0000, 'ºC'),
	(118137, 112, '2015-03-15 01:05:41.000000', 'temperatura', 1070.0000, 'ºC'),
	(118138, 112, '2015-03-15 01:05:42.000000', 'temperatura', 772.0000, 'ºC'),
	(118139, 112, '2015-03-15 01:05:43.000000', 'temperatura', 650.0000, 'ºC'),
	(118140, 112, '2015-03-15 01:05:44.000000', 'temperatura', 936.0000, 'ºC'),
	(118141, 112, '2015-03-15 01:05:45.000000', 'temperatura', 331.0000, 'ºC'),
	(118142, 112, '2015-03-15 01:05:46.000000', 'temperatura', 45.0000, 'ºC'),
	(118143, 112, '2015-03-15 01:05:47.000000', 'temperatura', 435.0000, 'ºC'),
	(118144, 112, '2015-03-15 01:05:48.000000', 'temperatura', 841.0000, 'ºC'),
	(118145, 112, '2015-03-15 01:05:49.000000', 'temperatura', 500.0000, 'ºC'),
	(118146, 112, '2015-03-15 01:05:50.000000', 'temperatura', 1177.0000, 'ºC'),
	(118147, 112, '2015-03-15 01:05:51.000000', 'temperatura', 787.0000, 'ºC'),
	(118148, 112, '2015-03-15 01:05:52.000000', 'temperatura', 406.0000, 'ºC'),
	(118149, 112, '2015-03-15 01:05:53.000000', 'temperatura', 866.0000, 'ºC'),
	(118150, 112, '2015-03-15 01:05:54.000000', 'temperatura', 712.0000, 'ºC'),
	(118151, 112, '2015-03-15 01:05:55.000000', 'temperatura', 965.0000, 'ºC'),
	(118152, 112, '2015-03-15 01:05:56.000000', 'temperatura', 288.0000, 'ºC'),
	(118153, 112, '2015-03-15 01:05:57.000000', 'temperatura', 946.0000, 'ºC'),
	(118154, 112, '2015-03-15 01:05:58.000000', 'temperatura', 267.0000, 'ºC'),
	(118155, 112, '2015-03-15 01:05:59.000000', 'temperatura', 895.0000, 'ºC'),
	(118156, 112, '2015-03-15 01:06:00.000000', 'temperatura', 76.0000, 'ºC'),
	(118157, 112, '2015-03-15 01:06:01.000000', 'temperatura', 96.0000, 'ºC'),
	(118158, 112, '2015-03-15 01:06:02.000000', 'temperatura', 251.0000, 'ºC'),
	(118159, 112, '2015-03-15 01:06:03.000000', 'temperatura', 968.0000, 'ºC'),
	(118160, 112, '2015-03-15 01:06:04.000000', 'temperatura', 488.0000, 'ºC'),
	(118161, 112, '2015-03-15 01:06:05.000000', 'temperatura', 734.0000, 'ºC'),
	(118162, 112, '2015-03-15 01:06:06.000000', 'temperatura', 1010.0000, 'ºC'),
	(118163, 112, '2015-03-15 01:06:07.000000', 'temperatura', 448.0000, 'ºC'),
	(118164, 112, '2015-03-15 01:06:08.000000', 'temperatura', 408.0000, 'ºC'),
	(118165, 112, '2015-03-15 01:06:09.000000', 'temperatura', 698.0000, 'ºC'),
	(118166, 112, '2015-03-15 01:06:10.000000', 'temperatura', 1067.0000, 'ºC'),
	(118167, 112, '2015-03-15 01:06:11.000000', 'temperatura', 842.0000, 'ºC'),
	(118168, 112, '2015-03-15 01:06:12.000000', 'temperatura', 1011.0000, 'ºC'),
	(118169, 112, '2015-03-15 01:06:13.000000', 'temperatura', 126.0000, 'ºC'),
	(118170, 112, '2015-03-15 01:06:14.000000', 'temperatura', 0.0000, 'ºC'),
	(118171, 112, '2015-03-15 01:06:15.000000', 'temperatura', 821.0000, 'ºC'),
	(118172, 112, '2015-03-15 01:06:16.000000', 'temperatura', 504.0000, 'ºC'),
	(118173, 112, '2015-03-15 01:06:17.000000', 'temperatura', 61.0000, 'ºC'),
	(118174, 112, '2015-03-15 01:06:18.000000', 'temperatura', 1192.0000, 'ºC'),
	(118175, 112, '2015-03-15 01:06:19.000000', 'temperatura', 976.0000, 'ºC'),
	(118176, 112, '2015-03-15 01:06:20.000000', 'temperatura', 107.0000, 'ºC'),
	(118177, 112, '2015-03-15 01:06:21.000000', 'temperatura', 7.0000, 'ºC'),
	(118178, 112, '2015-03-15 01:06:22.000000', 'temperatura', 912.0000, 'ºC'),
	(118179, 112, '2015-03-15 01:06:23.000000', 'temperatura', 941.0000, 'ºC'),
	(118180, 112, '2015-03-15 01:06:24.000000', 'temperatura', 769.0000, 'ºC'),
	(118181, 112, '2015-03-15 01:06:25.000000', 'temperatura', 1025.0000, 'ºC'),
	(118182, 112, '2015-03-15 01:06:26.000000', 'temperatura', 417.0000, 'ºC'),
	(118183, 112, '2015-03-15 01:06:27.000000', 'temperatura', 210.0000, 'ºC'),
	(118184, 112, '2015-03-15 01:06:28.000000', 'temperatura', 999.0000, 'ºC'),
	(118185, 112, '2015-03-15 01:06:29.000000', 'temperatura', 766.0000, 'ºC'),
	(118186, 112, '2015-03-15 01:06:30.000000', 'temperatura', 835.0000, 'ºC'),
	(118187, 112, '2015-03-15 01:06:31.000000', 'temperatura', 675.0000, 'ºC'),
	(118188, 112, '2015-03-15 01:06:32.000000', 'temperatura', 872.0000, 'ºC'),
	(118189, 112, '2015-03-15 01:06:33.000000', 'temperatura', 1136.0000, 'ºC'),
	(118190, 112, '2015-03-15 01:06:34.000000', 'temperatura', 664.0000, 'ºC'),
	(118191, 112, '2015-03-15 01:06:35.000000', 'temperatura', 1112.0000, 'ºC'),
	(118192, 112, '2015-03-15 01:06:36.000000', 'temperatura', 1170.0000, 'ºC'),
	(118193, 112, '2015-03-15 01:06:37.000000', 'temperatura', 113.0000, 'ºC'),
	(118194, 112, '2015-03-15 01:06:38.000000', 'temperatura', 656.0000, 'ºC'),
	(118195, 112, '2015-03-15 01:06:39.000000', 'temperatura', 543.0000, 'ºC'),
	(118196, 112, '2015-03-15 01:06:40.000000', 'temperatura', 747.0000, 'ºC'),
	(118197, 112, '2015-03-15 01:06:41.000000', 'temperatura', 907.0000, 'ºC'),
	(118198, 112, '2015-03-15 01:06:42.000000', 'temperatura', 1093.0000, 'ºC'),
	(118199, 112, '2015-03-15 01:06:43.000000', 'temperatura', 345.0000, 'ºC'),
	(118200, 112, '2015-03-15 01:06:44.000000', 'temperatura', 849.0000, 'ºC'),
	(118201, 112, '2015-03-15 01:06:45.000000', 'temperatura', 807.0000, 'ºC'),
	(118202, 112, '2015-03-15 01:06:46.000000', 'temperatura', 290.0000, 'ºC'),
	(118203, 112, '2015-03-15 01:06:47.000000', 'temperatura', 228.0000, 'ºC'),
	(118204, 112, '2015-03-15 01:06:48.000000', 'temperatura', 271.0000, 'ºC'),
	(118205, 112, '2015-03-15 01:06:49.000000', 'temperatura', 670.0000, 'ºC'),
	(118206, 112, '2015-03-15 01:06:50.000000', 'temperatura', 141.0000, 'ºC'),
	(118207, 112, '2015-03-15 01:06:51.000000', 'temperatura', 1092.0000, 'ºC'),
	(118208, 112, '2015-03-15 01:06:52.000000', 'temperatura', 239.0000, 'ºC'),
	(118209, 112, '2015-03-15 01:06:53.000000', 'temperatura', 318.0000, 'ºC'),
	(118210, 112, '2015-03-15 01:06:54.000000', 'temperatura', 876.0000, 'ºC'),
	(118211, 112, '2015-03-15 01:06:55.000000', 'temperatura', 1025.0000, 'ºC'),
	(118212, 112, '2015-03-15 01:06:56.000000', 'temperatura', 100.0000, 'ºC'),
	(118213, 112, '2015-03-15 01:06:57.000000', 'temperatura', 1023.0000, 'ºC'),
	(118214, 112, '2015-03-15 01:06:58.000000', 'temperatura', 16.0000, 'ºC'),
	(118215, 112, '2015-03-15 01:06:59.000000', 'temperatura', 610.0000, 'ºC'),
	(118216, 112, '2015-03-15 01:07:00.000000', 'temperatura', 604.0000, 'ºC'),
	(118217, 112, '2015-03-15 01:07:01.000000', 'temperatura', 1191.0000, 'ºC'),
	(118218, 112, '2015-03-15 01:07:02.000000', 'temperatura', 544.0000, 'ºC'),
	(118219, 112, '2015-03-15 01:07:03.000000', 'temperatura', 347.0000, 'ºC'),
	(118220, 112, '2015-03-15 01:07:04.000000', 'temperatura', 104.0000, 'ºC'),
	(118221, 112, '2015-03-15 01:07:05.000000', 'temperatura', 678.0000, 'ºC'),
	(118222, 112, '2015-03-15 01:07:06.000000', 'temperatura', 678.0000, 'ºC'),
	(118223, 112, '2015-03-15 01:07:07.000000', 'temperatura', 159.0000, 'ºC'),
	(118224, 112, '2015-03-15 01:07:08.000000', 'temperatura', 1160.0000, 'ºC'),
	(118225, 112, '2015-03-15 01:07:09.000000', 'temperatura', 525.0000, 'ºC'),
	(118226, 112, '2015-03-15 01:07:10.000000', 'temperatura', 346.0000, 'ºC'),
	(118227, 112, '2015-03-15 01:07:11.000000', 'temperatura', 153.0000, 'ºC'),
	(118228, 112, '2015-03-15 01:07:12.000000', 'temperatura', 927.0000, 'ºC'),
	(118229, 112, '2015-03-15 01:07:13.000000', 'temperatura', 577.0000, 'ºC'),
	(118230, 112, '2015-03-15 01:07:14.000000', 'temperatura', 103.0000, 'ºC'),
	(118231, 112, '2015-03-15 01:07:15.000000', 'temperatura', 1187.0000, 'ºC'),
	(118232, 112, '2015-03-15 01:07:16.000000', 'temperatura', 828.0000, 'ºC'),
	(118233, 112, '2015-03-15 01:07:17.000000', 'temperatura', 577.0000, 'ºC'),
	(118234, 112, '2015-03-15 01:07:18.000000', 'temperatura', 400.0000, 'ºC'),
	(118235, 112, '2015-03-15 01:07:19.000000', 'temperatura', 272.0000, 'ºC'),
	(118236, 112, '2015-03-15 01:07:20.000000', 'temperatura', 161.0000, 'ºC'),
	(118237, 112, '2015-03-15 01:07:21.000000', 'temperatura', 1188.0000, 'ºC'),
	(118238, 112, '2015-03-15 01:07:22.000000', 'temperatura', 658.0000, 'ºC'),
	(118239, 112, '2015-03-15 01:07:23.000000', 'temperatura', 926.0000, 'ºC'),
	(118240, 112, '2015-03-15 01:07:24.000000', 'temperatura', 258.0000, 'ºC'),
	(118241, 112, '2015-03-15 01:07:25.000000', 'temperatura', 911.0000, 'ºC'),
	(118242, 112, '2015-03-15 01:07:26.000000', 'temperatura', 181.0000, 'ºC'),
	(118243, 112, '2015-03-15 01:07:27.000000', 'temperatura', 574.0000, 'ºC'),
	(118244, 112, '2015-03-15 01:07:28.000000', 'temperatura', 1127.0000, 'ºC'),
	(118245, 112, '2015-03-15 01:07:29.000000', 'temperatura', 314.0000, 'ºC'),
	(118246, 112, '2015-03-15 01:07:30.000000', 'temperatura', 587.0000, 'ºC'),
	(118247, 112, '2015-03-15 01:07:31.000000', 'temperatura', 796.0000, 'ºC'),
	(118248, 112, '2015-03-15 01:07:32.000000', 'temperatura', 1020.0000, 'ºC'),
	(118249, 112, '2015-03-15 01:07:33.000000', 'temperatura', 313.0000, 'ºC'),
	(118250, 112, '2015-03-15 01:07:34.000000', 'temperatura', 903.0000, 'ºC'),
	(118251, 112, '2015-03-15 01:07:35.000000', 'temperatura', 1178.0000, 'ºC'),
	(118252, 112, '2015-03-15 01:07:36.000000', 'temperatura', 783.0000, 'ºC'),
	(118253, 112, '2015-03-15 01:07:37.000000', 'temperatura', 380.0000, 'ºC'),
	(118254, 112, '2015-03-15 01:07:38.000000', 'temperatura', 750.0000, 'ºC'),
	(118255, 112, '2015-03-15 01:07:39.000000', 'temperatura', 212.0000, 'ºC'),
	(118256, 112, '2015-03-15 01:07:40.000000', 'temperatura', 10.0000, 'ºC'),
	(118257, 112, '2015-03-15 01:07:41.000000', 'temperatura', 614.0000, 'ºC'),
	(118258, 112, '2015-03-15 01:07:42.000000', 'temperatura', 643.0000, 'ºC'),
	(118259, 112, '2015-03-15 01:07:43.000000', 'temperatura', 171.0000, 'ºC'),
	(118260, 112, '2015-03-15 01:07:44.000000', 'temperatura', 126.0000, 'ºC'),
	(118261, 112, '2015-03-15 01:07:45.000000', 'temperatura', 117.0000, 'ºC'),
	(118262, 112, '2015-03-15 01:07:46.000000', 'temperatura', 210.0000, 'ºC'),
	(118263, 112, '2015-03-15 01:07:47.000000', 'temperatura', 699.0000, 'ºC'),
	(118264, 112, '2015-03-15 01:07:48.000000', 'temperatura', 464.0000, 'ºC'),
	(118265, 112, '2015-03-15 01:07:49.000000', 'temperatura', 226.0000, 'ºC'),
	(118266, 112, '2015-03-15 01:07:50.000000', 'temperatura', 936.0000, 'ºC'),
	(118267, 112, '2015-03-15 01:07:51.000000', 'temperatura', 402.0000, 'ºC'),
	(118268, 112, '2015-03-15 01:07:52.000000', 'temperatura', 405.0000, 'ºC'),
	(118269, 112, '2015-03-15 01:07:53.000000', 'temperatura', 820.0000, 'ºC'),
	(118270, 112, '2015-03-15 01:07:54.000000', 'temperatura', 485.0000, 'ºC'),
	(118271, 112, '2015-03-15 01:07:55.000000', 'temperatura', 1164.0000, 'ºC'),
	(118272, 112, '2015-03-15 01:07:56.000000', 'temperatura', 765.0000, 'ºC'),
	(118273, 112, '2015-03-15 01:07:57.000000', 'temperatura', 336.0000, 'ºC'),
	(118274, 112, '2015-03-15 01:07:58.000000', 'temperatura', 585.0000, 'ºC'),
	(118275, 112, '2015-03-15 01:07:59.000000', 'temperatura', 716.0000, 'ºC'),
	(118276, 112, '2015-03-15 01:08:00.000000', 'temperatura', 626.0000, 'ºC'),
	(118277, 112, '2015-03-15 01:08:01.000000', 'temperatura', 984.0000, 'ºC'),
	(118278, 112, '2015-03-15 01:08:02.000000', 'temperatura', 643.0000, 'ºC'),
	(118279, 112, '2015-03-15 01:08:03.000000', 'temperatura', 260.0000, 'ºC'),
	(118280, 112, '2015-03-15 01:08:04.000000', 'temperatura', 575.0000, 'ºC'),
	(118281, 112, '2015-03-15 01:08:05.000000', 'temperatura', 894.0000, 'ºC'),
	(118282, 112, '2015-03-15 01:08:06.000000', 'temperatura', 345.0000, 'ºC'),
	(118283, 112, '2015-03-15 01:08:07.000000', 'temperatura', 246.0000, 'ºC'),
	(118284, 112, '2015-03-15 01:08:08.000000', 'temperatura', 194.0000, 'ºC'),
	(118285, 112, '2015-03-15 01:08:09.000000', 'temperatura', 231.0000, 'ºC'),
	(118286, 112, '2015-03-15 01:08:10.000000', 'temperatura', 573.0000, 'ºC'),
	(118287, 112, '2015-03-15 01:08:11.000000', 'temperatura', 973.0000, 'ºC'),
	(118288, 112, '2015-03-15 01:08:12.000000', 'temperatura', 746.0000, 'ºC'),
	(118289, 112, '2015-03-15 01:08:13.000000', 'temperatura', 812.0000, 'ºC'),
	(118290, 112, '2015-03-15 01:08:14.000000', 'temperatura', 621.0000, 'ºC'),
	(118291, 112, '2015-03-15 01:08:15.000000', 'temperatura', 672.0000, 'ºC'),
	(118292, 112, '2015-03-15 01:08:16.000000', 'temperatura', 297.0000, 'ºC'),
	(118293, 112, '2015-03-15 01:08:17.000000', 'temperatura', 668.0000, 'ºC'),
	(118294, 112, '2015-03-15 01:08:18.000000', 'temperatura', 52.0000, 'ºC'),
	(118295, 112, '2015-03-15 01:08:19.000000', 'temperatura', 656.0000, 'ºC'),
	(118296, 112, '2015-03-15 01:08:20.000000', 'temperatura', 726.0000, 'ºC'),
	(118297, 112, '2015-03-15 01:08:21.000000', 'temperatura', 461.0000, 'ºC'),
	(118298, 112, '2015-03-15 01:08:22.000000', 'temperatura', 128.0000, 'ºC'),
	(118299, 112, '2015-03-15 01:08:23.000000', 'temperatura', 458.0000, 'ºC'),
	(118300, 112, '2015-03-15 01:08:24.000000', 'temperatura', 704.0000, 'ºC'),
	(118301, 112, '2015-03-15 01:08:25.000000', 'temperatura', 949.0000, 'ºC'),
	(118302, 112, '2015-03-15 01:08:26.000000', 'temperatura', 232.0000, 'ºC'),
	(118303, 112, '2015-03-15 01:08:27.000000', 'temperatura', 716.0000, 'ºC'),
	(118304, 112, '2015-03-15 01:08:28.000000', 'temperatura', 481.0000, 'ºC'),
	(118305, 112, '2015-03-15 01:08:29.000000', 'temperatura', 260.0000, 'ºC'),
	(118306, 112, '2015-03-15 01:08:30.000000', 'temperatura', 1055.0000, 'ºC'),
	(118307, 112, '2015-03-15 01:08:31.000000', 'temperatura', 897.0000, 'ºC'),
	(118308, 112, '2015-03-15 01:08:32.000000', 'temperatura', 119.0000, 'ºC'),
	(118309, 112, '2015-03-15 01:08:33.000000', 'temperatura', 307.0000, 'ºC'),
	(118310, 112, '2015-03-15 01:08:34.000000', 'temperatura', 1179.0000, 'ºC'),
	(118311, 112, '2015-03-15 01:08:35.000000', 'temperatura', 175.0000, 'ºC'),
	(118312, 112, '2015-03-15 01:08:36.000000', 'temperatura', 938.0000, 'ºC'),
	(118313, 112, '2015-03-15 01:08:37.000000', 'temperatura', 564.0000, 'ºC'),
	(118314, 112, '2015-03-15 01:08:38.000000', 'temperatura', 7.0000, 'ºC'),
	(118315, 112, '2015-03-15 01:08:39.000000', 'temperatura', 745.0000, 'ºC'),
	(118316, 112, '2015-03-15 01:08:40.000000', 'temperatura', 102.0000, 'ºC'),
	(118317, 112, '2015-03-15 01:08:41.000000', 'temperatura', 678.0000, 'ºC'),
	(118318, 112, '2015-03-15 01:08:42.000000', 'temperatura', 683.0000, 'ºC'),
	(118319, 112, '2015-03-15 01:08:43.000000', 'temperatura', 182.0000, 'ºC'),
	(118320, 112, '2015-03-15 01:08:44.000000', 'temperatura', 62.0000, 'ºC'),
	(118321, 112, '2015-03-15 01:08:45.000000', 'temperatura', 966.0000, 'ºC'),
	(118322, 112, '2015-03-15 01:08:46.000000', 'temperatura', 1041.0000, 'ºC'),
	(118323, 112, '2015-03-15 01:08:47.000000', 'temperatura', 1109.0000, 'ºC'),
	(118324, 112, '2015-03-15 01:08:48.000000', 'temperatura', 23.0000, 'ºC'),
	(118325, 112, '2015-03-15 01:08:49.000000', 'temperatura', 389.0000, 'ºC'),
	(118326, 112, '2015-03-15 01:08:50.000000', 'temperatura', 674.0000, 'ºC'),
	(118327, 112, '2015-03-15 01:08:51.000000', 'temperatura', 1004.0000, 'ºC'),
	(118328, 112, '2015-03-15 01:08:52.000000', 'temperatura', 599.0000, 'ºC'),
	(118329, 112, '2015-03-15 01:08:53.000000', 'temperatura', 1183.0000, 'ºC'),
	(118330, 112, '2015-03-15 01:08:54.000000', 'temperatura', 517.0000, 'ºC'),
	(118331, 112, '2015-03-15 01:08:55.000000', 'temperatura', 239.0000, 'ºC'),
	(118332, 112, '2015-03-15 01:08:56.000000', 'temperatura', 843.0000, 'ºC'),
	(118333, 112, '2015-03-15 01:08:57.000000', 'temperatura', 1098.0000, 'ºC'),
	(118334, 112, '2015-03-15 01:08:58.000000', 'temperatura', 561.0000, 'ºC'),
	(118335, 112, '2015-03-15 01:08:59.000000', 'temperatura', 712.0000, 'ºC'),
	(118336, 112, '2015-03-15 01:09:00.000000', 'temperatura', 676.0000, 'ºC'),
	(118337, 112, '2015-03-15 01:09:01.000000', 'temperatura', 47.0000, 'ºC'),
	(118338, 112, '2015-03-15 01:09:02.000000', 'temperatura', 605.0000, 'ºC'),
	(118339, 112, '2015-03-15 01:09:03.000000', 'temperatura', 487.0000, 'ºC'),
	(118340, 112, '2015-03-15 01:09:04.000000', 'temperatura', 620.0000, 'ºC'),
	(118341, 112, '2015-03-15 01:09:05.000000', 'temperatura', 441.0000, 'ºC'),
	(118342, 112, '2015-03-15 01:09:06.000000', 'temperatura', 344.0000, 'ºC'),
	(118343, 112, '2015-03-15 01:09:07.000000', 'temperatura', 396.0000, 'ºC'),
	(118344, 112, '2015-03-15 01:09:08.000000', 'temperatura', 949.0000, 'ºC'),
	(118345, 112, '2015-03-15 01:09:09.000000', 'temperatura', 1160.0000, 'ºC'),
	(118346, 112, '2015-03-15 01:09:10.000000', 'temperatura', 551.0000, 'ºC'),
	(118347, 112, '2015-03-15 01:09:11.000000', 'temperatura', 478.0000, 'ºC'),
	(118348, 112, '2015-03-15 01:09:12.000000', 'temperatura', 737.0000, 'ºC'),
	(118349, 112, '2015-03-15 01:09:13.000000', 'temperatura', 1052.0000, 'ºC'),
	(118350, 112, '2015-03-15 01:09:14.000000', 'temperatura', 650.0000, 'ºC'),
	(118351, 112, '2015-03-15 01:09:15.000000', 'temperatura', 93.0000, 'ºC'),
	(118352, 112, '2015-03-15 01:09:16.000000', 'temperatura', 915.0000, 'ºC'),
	(118353, 112, '2015-03-15 01:09:17.000000', 'temperatura', 698.0000, 'ºC'),
	(118354, 112, '2015-03-15 01:09:18.000000', 'temperatura', 744.0000, 'ºC'),
	(118355, 112, '2015-03-15 01:09:19.000000', 'temperatura', 427.0000, 'ºC'),
	(118356, 112, '2015-03-15 01:09:20.000000', 'temperatura', 1102.0000, 'ºC'),
	(118357, 112, '2015-03-15 01:09:21.000000', 'temperatura', 629.0000, 'ºC'),
	(118358, 112, '2015-03-15 01:09:22.000000', 'temperatura', 1042.0000, 'ºC'),
	(118359, 112, '2015-03-15 01:09:23.000000', 'temperatura', 922.0000, 'ºC'),
	(118360, 112, '2015-03-15 01:09:24.000000', 'temperatura', 284.0000, 'ºC'),
	(118361, 112, '2015-03-15 01:09:25.000000', 'temperatura', 1056.0000, 'ºC'),
	(118362, 112, '2015-03-15 01:09:26.000000', 'temperatura', 828.0000, 'ºC'),
	(118363, 112, '2015-03-15 01:09:27.000000', 'temperatura', 973.0000, 'ºC'),
	(118364, 112, '2015-03-15 01:09:28.000000', 'temperatura', 1183.0000, 'ºC'),
	(118365, 112, '2015-03-15 01:09:29.000000', 'temperatura', 595.0000, 'ºC'),
	(118366, 112, '2015-03-15 01:09:30.000000', 'temperatura', 627.0000, 'ºC'),
	(118367, 112, '2015-03-15 01:09:31.000000', 'temperatura', 150.0000, 'ºC'),
	(118368, 112, '2015-03-15 01:09:32.000000', 'temperatura', 70.0000, 'ºC'),
	(118369, 112, '2015-03-15 01:09:33.000000', 'temperatura', 1101.0000, 'ºC'),
	(118370, 112, '2015-03-15 01:09:34.000000', 'temperatura', 494.0000, 'ºC'),
	(118371, 112, '2015-03-15 01:09:35.000000', 'temperatura', 370.0000, 'ºC'),
	(118372, 112, '2015-03-15 01:09:36.000000', 'temperatura', 367.0000, 'ºC'),
	(118373, 112, '2015-03-15 01:09:37.000000', 'temperatura', 727.0000, 'ºC'),
	(118374, 112, '2015-03-15 01:09:38.000000', 'temperatura', 133.0000, 'ºC'),
	(118375, 112, '2015-03-15 01:09:39.000000', 'temperatura', 885.0000, 'ºC'),
	(118376, 112, '2015-03-15 01:09:40.000000', 'temperatura', 425.0000, 'ºC'),
	(118377, 112, '2015-03-15 01:09:41.000000', 'temperatura', 670.0000, 'ºC'),
	(118378, 112, '2015-03-15 01:09:42.000000', 'temperatura', 878.0000, 'ºC'),
	(118379, 112, '2015-03-15 01:09:43.000000', 'temperatura', 1181.0000, 'ºC'),
	(118380, 112, '2015-03-15 01:09:44.000000', 'temperatura', 871.0000, 'ºC'),
	(118381, 112, '2015-03-15 01:09:45.000000', 'temperatura', 812.0000, 'ºC'),
	(118382, 112, '2015-03-15 01:09:46.000000', 'temperatura', 247.0000, 'ºC'),
	(118383, 112, '2015-03-15 01:09:47.000000', 'temperatura', 1199.0000, 'ºC'),
	(118384, 112, '2015-03-15 01:09:48.000000', 'temperatura', 457.0000, 'ºC'),
	(118385, 112, '2015-03-15 01:09:49.000000', 'temperatura', 1087.0000, 'ºC'),
	(118386, 112, '2015-03-15 01:09:50.000000', 'temperatura', 464.0000, 'ºC'),
	(118387, 112, '2015-03-15 01:09:51.000000', 'temperatura', 258.0000, 'ºC'),
	(118388, 112, '2015-03-15 01:09:52.000000', 'temperatura', 1101.0000, 'ºC'),
	(118389, 112, '2015-03-15 01:09:53.000000', 'temperatura', 1132.0000, 'ºC'),
	(118390, 112, '2015-03-15 01:09:54.000000', 'temperatura', 1155.0000, 'ºC'),
	(118391, 112, '2015-03-15 01:09:55.000000', 'temperatura', 1181.0000, 'ºC'),
	(118392, 112, '2015-03-15 01:09:56.000000', 'temperatura', 41.0000, 'ºC'),
	(118393, 112, '2015-03-15 01:09:57.000000', 'temperatura', 263.0000, 'ºC'),
	(118394, 112, '2015-03-15 01:09:58.000000', 'temperatura', 1194.0000, 'ºC'),
	(118395, 112, '2015-03-15 01:09:59.000000', 'temperatura', 380.0000, 'ºC'),
	(118396, 112, '2015-03-15 01:10:00.000000', 'temperatura', 716.0000, 'ºC'),
	(118397, 112, '2015-03-15 01:10:01.000000', 'temperatura', 44.0000, 'ºC'),
	(118398, 112, '2015-03-15 01:10:02.000000', 'temperatura', 471.0000, 'ºC'),
	(118399, 112, '2015-03-15 01:10:03.000000', 'temperatura', 1022.0000, 'ºC'),
	(118400, 112, '2015-03-15 01:10:04.000000', 'temperatura', 100.0000, 'ºC'),
	(118401, 112, '2015-03-15 01:10:05.000000', 'temperatura', 1034.0000, 'ºC'),
	(118402, 112, '2015-03-15 01:10:06.000000', 'temperatura', 70.0000, 'ºC'),
	(118403, 112, '2015-03-15 01:10:07.000000', 'temperatura', 847.0000, 'ºC'),
	(118404, 112, '2015-03-15 01:10:08.000000', 'temperatura', 426.0000, 'ºC'),
	(118405, 112, '2015-03-15 01:10:09.000000', 'temperatura', 790.0000, 'ºC'),
	(118406, 112, '2015-03-15 01:10:10.000000', 'temperatura', 272.0000, 'ºC'),
	(118407, 112, '2015-03-15 01:10:11.000000', 'temperatura', 192.0000, 'ºC'),
	(118408, 112, '2015-03-15 01:10:12.000000', 'temperatura', 144.0000, 'ºC'),
	(118409, 112, '2015-03-15 01:10:13.000000', 'temperatura', 143.0000, 'ºC'),
	(118410, 112, '2015-03-15 01:10:14.000000', 'temperatura', 286.0000, 'ºC'),
	(118411, 112, '2015-03-15 01:10:15.000000', 'temperatura', 1001.0000, 'ºC'),
	(118412, 112, '2015-03-15 01:10:16.000000', 'temperatura', 545.0000, 'ºC'),
	(118413, 112, '2015-03-15 01:10:17.000000', 'temperatura', 926.0000, 'ºC'),
	(118414, 112, '2015-03-15 01:10:18.000000', 'temperatura', 594.0000, 'ºC'),
	(118415, 112, '2015-03-15 01:10:19.000000', 'temperatura', 194.0000, 'ºC'),
	(118416, 112, '2015-03-15 01:10:20.000000', 'temperatura', 387.0000, 'ºC'),
	(118417, 112, '2015-03-15 01:10:21.000000', 'temperatura', 153.0000, 'ºC'),
	(118418, 112, '2015-03-15 01:10:22.000000', 'temperatura', 806.0000, 'ºC'),
	(118419, 112, '2015-03-15 01:10:23.000000', 'temperatura', 1170.0000, 'ºC'),
	(118420, 112, '2015-03-15 01:10:24.000000', 'temperatura', 1031.0000, 'ºC'),
	(118421, 112, '2015-03-15 01:10:25.000000', 'temperatura', 447.0000, 'ºC'),
	(118422, 112, '2015-03-15 01:10:26.000000', 'temperatura', 342.0000, 'ºC'),
	(118423, 112, '2015-03-15 01:10:27.000000', 'temperatura', 368.0000, 'ºC'),
	(118424, 112, '2015-03-15 01:10:28.000000', 'temperatura', 817.0000, 'ºC'),
	(118425, 112, '2015-03-15 01:10:29.000000', 'temperatura', 580.0000, 'ºC'),
	(118426, 112, '2015-03-15 01:10:30.000000', 'temperatura', 449.0000, 'ºC'),
	(118427, 112, '2015-03-15 01:10:31.000000', 'temperatura', 504.0000, 'ºC'),
	(118428, 112, '2015-03-15 01:10:32.000000', 'temperatura', 1175.0000, 'ºC'),
	(118429, 112, '2015-03-15 01:10:33.000000', 'temperatura', 764.0000, 'ºC'),
	(118430, 112, '2015-03-15 01:10:34.000000', 'temperatura', 295.0000, 'ºC'),
	(118431, 112, '2015-03-15 01:10:35.000000', 'temperatura', 385.0000, 'ºC'),
	(118432, 112, '2015-03-15 01:10:36.000000', 'temperatura', 1041.0000, 'ºC'),
	(118433, 112, '2015-03-15 01:10:37.000000', 'temperatura', 449.0000, 'ºC'),
	(118434, 112, '2015-03-15 01:10:38.000000', 'temperatura', 325.0000, 'ºC'),
	(118435, 112, '2015-03-15 01:10:39.000000', 'temperatura', 275.0000, 'ºC'),
	(118436, 112, '2015-03-15 01:10:40.000000', 'temperatura', 401.0000, 'ºC'),
	(118437, 112, '2015-03-15 01:10:41.000000', 'temperatura', 1183.0000, 'ºC'),
	(118438, 112, '2015-03-15 01:10:42.000000', 'temperatura', 1112.0000, 'ºC'),
	(118439, 112, '2015-03-15 01:10:43.000000', 'temperatura', 812.0000, 'ºC'),
	(118440, 112, '2015-03-15 01:10:44.000000', 'temperatura', 724.0000, 'ºC'),
	(118441, 112, '2015-03-15 01:10:45.000000', 'temperatura', 1183.0000, 'ºC'),
	(118442, 112, '2015-03-15 01:10:46.000000', 'temperatura', 145.0000, 'ºC'),
	(118443, 112, '2015-03-15 01:10:47.000000', 'temperatura', 774.0000, 'ºC'),
	(118444, 112, '2015-03-15 01:10:48.000000', 'temperatura', 1038.0000, 'ºC'),
	(118445, 112, '2015-03-15 01:10:49.000000', 'temperatura', 466.0000, 'ºC'),
	(118446, 112, '2015-03-15 01:10:50.000000', 'temperatura', 419.0000, 'ºC'),
	(118447, 112, '2015-03-15 01:10:51.000000', 'temperatura', 697.0000, 'ºC'),
	(118448, 112, '2015-03-15 01:10:52.000000', 'temperatura', 1030.0000, 'ºC'),
	(118449, 112, '2015-03-15 01:10:53.000000', 'temperatura', 659.0000, 'ºC'),
	(118450, 112, '2015-03-15 01:10:54.000000', 'temperatura', 205.0000, 'ºC'),
	(118451, 112, '2015-03-15 01:10:55.000000', 'temperatura', 249.0000, 'ºC'),
	(118452, 112, '2015-03-15 01:10:56.000000', 'temperatura', 631.0000, 'ºC'),
	(118453, 112, '2015-03-15 01:10:57.000000', 'temperatura', 9.0000, 'ºC'),
	(118454, 112, '2015-03-15 01:10:58.000000', 'temperatura', 553.0000, 'ºC'),
	(118455, 112, '2015-03-15 01:10:59.000000', 'temperatura', 335.0000, 'ºC'),
	(118456, 112, '2015-03-15 01:11:00.000000', 'temperatura', 20.0000, 'ºC'),
	(118457, 112, '2015-03-15 01:11:01.000000', 'temperatura', 296.0000, 'ºC'),
	(118458, 112, '2015-03-15 01:11:02.000000', 'temperatura', 219.0000, 'ºC'),
	(118459, 112, '2015-03-15 01:11:03.000000', 'temperatura', 207.0000, 'ºC'),
	(118460, 112, '2015-03-15 01:11:04.000000', 'temperatura', 379.0000, 'ºC'),
	(118461, 112, '2015-03-15 01:11:05.000000', 'temperatura', 77.0000, 'ºC'),
	(118462, 112, '2015-03-15 01:11:06.000000', 'temperatura', 445.0000, 'ºC'),
	(118463, 112, '2015-03-15 01:11:07.000000', 'temperatura', 795.0000, 'ºC'),
	(118464, 112, '2015-03-15 01:11:08.000000', 'temperatura', 241.0000, 'ºC'),
	(118465, 112, '2015-03-15 01:11:09.000000', 'temperatura', 19.0000, 'ºC'),
	(118466, 112, '2015-03-15 01:11:10.000000', 'temperatura', 575.0000, 'ºC'),
	(118467, 112, '2015-03-15 01:11:11.000000', 'temperatura', 416.0000, 'ºC'),
	(118468, 112, '2015-03-15 01:11:12.000000', 'temperatura', 355.0000, 'ºC'),
	(118469, 112, '2015-03-15 01:11:13.000000', 'temperatura', 529.0000, 'ºC'),
	(118470, 112, '2015-03-15 01:11:14.000000', 'temperatura', 380.0000, 'ºC'),
	(118471, 112, '2015-03-15 01:11:15.000000', 'temperatura', 312.0000, 'ºC'),
	(118472, 112, '2015-03-15 01:11:16.000000', 'temperatura', 421.0000, 'ºC'),
	(118473, 112, '2015-03-15 01:11:17.000000', 'temperatura', 1171.0000, 'ºC'),
	(118474, 112, '2015-03-15 01:11:18.000000', 'temperatura', 990.0000, 'ºC'),
	(118475, 112, '2015-03-15 01:11:19.000000', 'temperatura', 238.0000, 'ºC'),
	(118476, 112, '2015-03-15 01:11:20.000000', 'temperatura', 620.0000, 'ºC'),
	(118477, 112, '2015-03-15 01:11:21.000000', 'temperatura', 1187.0000, 'ºC'),
	(118478, 112, '2015-03-15 01:11:22.000000', 'temperatura', 477.0000, 'ºC'),
	(118479, 112, '2015-03-15 01:11:23.000000', 'temperatura', 25.0000, 'ºC'),
	(118480, 112, '2015-03-15 01:11:24.000000', 'temperatura', 1094.0000, 'ºC'),
	(118481, 112, '2015-03-15 01:11:25.000000', 'temperatura', 593.0000, 'ºC'),
	(118482, 112, '2015-03-15 01:11:26.000000', 'temperatura', 886.0000, 'ºC'),
	(118483, 112, '2015-03-15 01:11:27.000000', 'temperatura', 251.0000, 'ºC'),
	(118484, 112, '2015-03-15 01:11:28.000000', 'temperatura', 997.0000, 'ºC'),
	(118485, 112, '2015-03-15 01:11:29.000000', 'temperatura', 635.0000, 'ºC'),
	(118486, 112, '2015-03-15 01:11:30.000000', 'temperatura', 182.0000, 'ºC'),
	(118487, 112, '2015-03-15 01:11:31.000000', 'temperatura', 205.0000, 'ºC'),
	(118488, 112, '2015-03-15 01:11:32.000000', 'temperatura', 482.0000, 'ºC'),
	(118489, 112, '2015-03-15 01:11:33.000000', 'temperatura', 593.0000, 'ºC'),
	(118490, 112, '2015-03-15 01:11:34.000000', 'temperatura', 320.0000, 'ºC'),
	(118491, 112, '2015-03-15 01:11:35.000000', 'temperatura', 1022.0000, 'ºC'),
	(118492, 112, '2015-03-15 01:11:36.000000', 'temperatura', 551.0000, 'ºC'),
	(118493, 112, '2015-03-15 01:11:37.000000', 'temperatura', 891.0000, 'ºC'),
	(118494, 112, '2015-03-15 01:11:38.000000', 'temperatura', 402.0000, 'ºC'),
	(118495, 112, '2015-03-15 01:11:39.000000', 'temperatura', 536.0000, 'ºC'),
	(118496, 112, '2015-03-15 01:11:40.000000', 'temperatura', 273.0000, 'ºC'),
	(118497, 112, '2015-03-15 01:11:41.000000', 'temperatura', 960.0000, 'ºC'),
	(118498, 112, '2015-03-15 01:11:42.000000', 'temperatura', 382.0000, 'ºC'),
	(118499, 112, '2015-03-15 01:11:43.000000', 'temperatura', 229.0000, 'ºC'),
	(118500, 112, '2015-03-15 01:11:44.000000', 'temperatura', 0.0000, 'ºC'),
	(118501, 112, '2015-03-15 01:11:45.000000', 'temperatura', 514.0000, 'ºC'),
	(118502, 112, '2015-03-15 01:11:46.000000', 'temperatura', 169.0000, 'ºC'),
	(118503, 112, '2015-03-15 01:11:47.000000', 'temperatura', 502.0000, 'ºC'),
	(118504, 112, '2015-03-15 01:11:48.000000', 'temperatura', 806.0000, 'ºC'),
	(118505, 112, '2015-03-15 01:11:49.000000', 'temperatura', 126.0000, 'ºC'),
	(118506, 112, '2015-03-15 01:11:50.000000', 'temperatura', 610.0000, 'ºC'),
	(118507, 112, '2015-03-15 01:11:51.000000', 'temperatura', 275.0000, 'ºC'),
	(118508, 112, '2015-03-15 01:11:52.000000', 'temperatura', 745.0000, 'ºC'),
	(118509, 112, '2015-03-15 01:11:53.000000', 'temperatura', 498.0000, 'ºC'),
	(118510, 112, '2015-03-15 01:11:54.000000', 'temperatura', 259.0000, 'ºC'),
	(118511, 112, '2015-03-15 01:11:55.000000', 'temperatura', 999.0000, 'ºC'),
	(118512, 112, '2015-03-15 01:11:56.000000', 'temperatura', 621.0000, 'ºC'),
	(118513, 112, '2015-03-15 01:11:57.000000', 'temperatura', 106.0000, 'ºC'),
	(118514, 112, '2015-03-15 01:11:58.000000', 'temperatura', 1070.0000, 'ºC'),
	(118515, 112, '2015-03-15 01:11:59.000000', 'temperatura', 233.0000, 'ºC'),
	(118516, 112, '2015-03-15 01:12:00.000000', 'temperatura', 355.0000, 'ºC'),
	(118517, 112, '2015-03-15 01:12:01.000000', 'temperatura', 1077.0000, 'ºC'),
	(118518, 112, '2015-03-15 01:12:02.000000', 'temperatura', 721.0000, 'ºC'),
	(118519, 112, '2015-03-15 01:12:03.000000', 'temperatura', 373.0000, 'ºC'),
	(118520, 112, '2015-03-15 01:12:04.000000', 'temperatura', 903.0000, 'ºC'),
	(118521, 112, '2015-03-15 01:12:05.000000', 'temperatura', 998.0000, 'ºC'),
	(118522, 112, '2015-03-15 01:12:06.000000', 'temperatura', 1082.0000, 'ºC'),
	(118523, 112, '2015-03-15 01:12:07.000000', 'temperatura', 17.0000, 'ºC'),
	(118524, 112, '2015-03-15 01:12:08.000000', 'temperatura', 436.0000, 'ºC'),
	(118525, 112, '2015-03-15 01:12:09.000000', 'temperatura', 933.0000, 'ºC'),
	(118526, 112, '2015-03-15 01:12:10.000000', 'temperatura', 957.0000, 'ºC'),
	(118527, 112, '2015-03-15 01:12:11.000000', 'temperatura', 785.0000, 'ºC'),
	(118528, 112, '2015-03-15 01:12:12.000000', 'temperatura', 1056.0000, 'ºC'),
	(118529, 112, '2015-03-15 01:12:13.000000', 'temperatura', 523.0000, 'ºC'),
	(118530, 112, '2015-03-15 01:12:14.000000', 'temperatura', 649.0000, 'ºC'),
	(118531, 112, '2015-03-15 01:12:15.000000', 'temperatura', 474.0000, 'ºC'),
	(118532, 112, '2015-03-15 01:12:16.000000', 'temperatura', 427.0000, 'ºC'),
	(118533, 112, '2015-03-15 01:12:17.000000', 'temperatura', 713.0000, 'ºC'),
	(118534, 112, '2015-03-15 01:12:18.000000', 'temperatura', 1084.0000, 'ºC'),
	(118535, 112, '2015-03-15 01:12:19.000000', 'temperatura', 882.0000, 'ºC'),
	(118536, 112, '2015-03-15 01:12:20.000000', 'temperatura', 1159.0000, 'ºC'),
	(118537, 112, '2015-03-15 01:12:21.000000', 'temperatura', 750.0000, 'ºC'),
	(118538, 112, '2015-03-15 01:12:22.000000', 'temperatura', 272.0000, 'ºC'),
	(118539, 112, '2015-03-15 01:12:23.000000', 'temperatura', 312.0000, 'ºC'),
	(118540, 112, '2015-03-15 01:12:24.000000', 'temperatura', 745.0000, 'ºC'),
	(118541, 112, '2015-03-15 01:12:25.000000', 'temperatura', 388.0000, 'ºC'),
	(118542, 112, '2015-03-15 01:12:26.000000', 'temperatura', 908.0000, 'ºC'),
	(118543, 112, '2015-03-15 01:12:27.000000', 'temperatura', 973.0000, 'ºC'),
	(118544, 112, '2015-03-15 01:12:28.000000', 'temperatura', 943.0000, 'ºC'),
	(118545, 112, '2015-03-15 01:12:29.000000', 'temperatura', 596.0000, 'ºC'),
	(118546, 112, '2015-03-15 01:12:30.000000', 'temperatura', 150.0000, 'ºC'),
	(118547, 112, '2015-03-15 01:12:31.000000', 'temperatura', 163.0000, 'ºC'),
	(118548, 112, '2015-03-15 01:12:32.000000', 'temperatura', 366.0000, 'ºC'),
	(118549, 112, '2015-03-15 01:12:33.000000', 'temperatura', 141.0000, 'ºC'),
	(118550, 112, '2015-03-15 01:12:34.000000', 'temperatura', 808.0000, 'ºC'),
	(118551, 112, '2015-03-15 01:12:35.000000', 'temperatura', 17.0000, 'ºC'),
	(118552, 112, '2015-03-15 01:12:36.000000', 'temperatura', 64.0000, 'ºC'),
	(118553, 112, '2015-03-15 01:12:37.000000', 'temperatura', 267.0000, 'ºC'),
	(118554, 112, '2015-03-15 01:12:38.000000', 'temperatura', 1146.0000, 'ºC'),
	(118555, 112, '2015-03-15 01:12:39.000000', 'temperatura', 126.0000, 'ºC'),
	(118556, 112, '2015-03-15 01:12:40.000000', 'temperatura', 796.0000, 'ºC'),
	(118557, 112, '2015-03-15 01:12:41.000000', 'temperatura', 1199.0000, 'ºC'),
	(118558, 112, '2015-03-15 01:12:42.000000', 'temperatura', 9.0000, 'ºC'),
	(118559, 112, '2015-03-15 01:12:43.000000', 'temperatura', 50.0000, 'ºC'),
	(118560, 112, '2015-03-15 01:12:44.000000', 'temperatura', 221.0000, 'ºC'),
	(118561, 112, '2015-03-15 01:12:45.000000', 'temperatura', 958.0000, 'ºC'),
	(118562, 112, '2015-03-15 01:12:46.000000', 'temperatura', 527.0000, 'ºC'),
	(118563, 112, '2015-03-15 01:12:47.000000', 'temperatura', 959.0000, 'ºC'),
	(118564, 112, '2015-03-15 01:12:48.000000', 'temperatura', 816.0000, 'ºC'),
	(118565, 112, '2015-03-15 01:12:49.000000', 'temperatura', 6.0000, 'ºC'),
	(118566, 112, '2015-03-15 01:12:50.000000', 'temperatura', 1179.0000, 'ºC'),
	(118567, 112, '2015-03-15 01:12:51.000000', 'temperatura', 1079.0000, 'ºC'),
	(118568, 112, '2015-03-15 01:12:52.000000', 'temperatura', 656.0000, 'ºC'),
	(118569, 112, '2015-03-15 01:12:53.000000', 'temperatura', 47.0000, 'ºC'),
	(118570, 112, '2015-03-15 01:12:54.000000', 'temperatura', 667.0000, 'ºC'),
	(118571, 112, '2015-03-15 01:12:55.000000', 'temperatura', 795.0000, 'ºC'),
	(118572, 112, '2015-03-15 01:12:56.000000', 'temperatura', 774.0000, 'ºC'),
	(118573, 112, '2015-03-15 01:12:57.000000', 'temperatura', 283.0000, 'ºC'),
	(118574, 112, '2015-03-15 01:12:58.000000', 'temperatura', 296.0000, 'ºC'),
	(118575, 112, '2015-03-15 01:12:59.000000', 'temperatura', 632.0000, 'ºC'),
	(118576, 112, '2015-03-15 01:13:00.000000', 'temperatura', 1070.0000, 'ºC'),
	(118577, 112, '2015-03-15 01:13:01.000000', 'temperatura', 1054.0000, 'ºC'),
	(118578, 112, '2015-03-15 01:13:02.000000', 'temperatura', 863.0000, 'ºC'),
	(118579, 112, '2015-03-15 01:13:03.000000', 'temperatura', 1154.0000, 'ºC'),
	(118580, 112, '2015-03-15 01:13:04.000000', 'temperatura', 780.0000, 'ºC'),
	(118581, 112, '2015-03-15 01:13:05.000000', 'temperatura', 438.0000, 'ºC'),
	(118582, 112, '2015-03-15 01:13:06.000000', 'temperatura', 1051.0000, 'ºC'),
	(118583, 112, '2015-03-15 01:13:07.000000', 'temperatura', 342.0000, 'ºC'),
	(118584, 112, '2015-03-15 01:13:08.000000', 'temperatura', 957.0000, 'ºC'),
	(118585, 112, '2015-03-15 01:13:09.000000', 'temperatura', 161.0000, 'ºC'),
	(118586, 112, '2015-03-15 01:13:10.000000', 'temperatura', 334.0000, 'ºC'),
	(118587, 112, '2015-03-15 01:13:11.000000', 'temperatura', 1189.0000, 'ºC'),
	(118588, 112, '2015-03-15 01:13:12.000000', 'temperatura', 143.0000, 'ºC'),
	(118589, 112, '2015-03-15 01:13:13.000000', 'temperatura', 749.0000, 'ºC'),
	(118590, 112, '2015-03-15 01:13:14.000000', 'temperatura', 914.0000, 'ºC'),
	(118591, 112, '2015-03-15 01:13:15.000000', 'temperatura', 1126.0000, 'ºC'),
	(118592, 112, '2015-03-15 01:13:16.000000', 'temperatura', 488.0000, 'ºC'),
	(118593, 112, '2015-03-15 01:13:17.000000', 'temperatura', 260.0000, 'ºC'),
	(118594, 112, '2015-03-15 01:13:18.000000', 'temperatura', 1039.0000, 'ºC'),
	(118595, 112, '2015-03-15 01:13:19.000000', 'temperatura', 815.0000, 'ºC'),
	(118596, 112, '2015-03-15 01:13:20.000000', 'temperatura', 958.0000, 'ºC'),
	(118597, 112, '2015-03-15 01:13:21.000000', 'temperatura', 1146.0000, 'ºC'),
	(118598, 112, '2015-03-15 01:13:22.000000', 'temperatura', 457.0000, 'ºC'),
	(118599, 112, '2015-03-15 01:13:23.000000', 'temperatura', 47.0000, 'ºC'),
	(118600, 112, '2015-03-15 01:13:24.000000', 'temperatura', 67.0000, 'ºC'),
	(118601, 112, '2015-03-15 01:13:25.000000', 'temperatura', 191.0000, 'ºC'),
	(118602, 112, '2015-03-15 01:13:26.000000', 'temperatura', 756.0000, 'ºC'),
	(118603, 112, '2015-03-15 01:13:27.000000', 'temperatura', 805.0000, 'ºC'),
	(118604, 112, '2015-03-15 01:13:28.000000', 'temperatura', 561.0000, 'ºC'),
	(118605, 112, '2015-03-15 01:13:29.000000', 'temperatura', 390.0000, 'ºC'),
	(118606, 112, '2015-03-15 01:13:30.000000', 'temperatura', 268.0000, 'ºC'),
	(118607, 112, '2015-03-15 01:13:31.000000', 'temperatura', 169.0000, 'ºC'),
	(118608, 112, '2015-03-15 01:13:32.000000', 'temperatura', 41.0000, 'ºC'),
	(118609, 112, '2015-03-15 01:13:33.000000', 'temperatura', 898.0000, 'ºC'),
	(118610, 112, '2015-03-15 01:13:34.000000', 'temperatura', 770.0000, 'ºC'),
	(118611, 112, '2015-03-15 01:13:35.000000', 'temperatura', 1155.0000, 'ºC'),
	(118612, 112, '2015-03-15 01:13:36.000000', 'temperatura', 1067.0000, 'ºC'),
	(118613, 112, '2015-03-15 01:13:37.000000', 'temperatura', 671.0000, 'ºC'),
	(118614, 112, '2015-03-15 01:13:38.000000', 'temperatura', 151.0000, 'ºC'),
	(118615, 112, '2015-03-15 01:13:39.000000', 'temperatura', 1146.0000, 'ºC'),
	(118616, 112, '2015-03-15 01:13:40.000000', 'temperatura', 477.0000, 'ºC'),
	(118617, 112, '2015-03-15 01:13:41.000000', 'temperatura', 149.0000, 'ºC'),
	(118618, 112, '2015-03-15 01:13:42.000000', 'temperatura', 512.0000, 'ºC'),
	(118619, 112, '2015-03-15 01:13:43.000000', 'temperatura', 913.0000, 'ºC'),
	(118620, 112, '2015-03-15 01:13:44.000000', 'temperatura', 629.0000, 'ºC'),
	(118621, 112, '2015-03-15 01:13:45.000000', 'temperatura', 409.0000, 'ºC'),
	(118622, 112, '2015-03-15 01:13:46.000000', 'temperatura', 159.0000, 'ºC'),
	(118623, 112, '2015-03-15 01:13:47.000000', 'temperatura', 769.0000, 'ºC'),
	(118624, 112, '2015-03-15 01:13:48.000000', 'temperatura', 967.0000, 'ºC'),
	(118625, 112, '2015-03-15 01:13:49.000000', 'temperatura', 129.0000, 'ºC'),
	(118626, 112, '2015-03-15 01:13:50.000000', 'temperatura', 145.0000, 'ºC'),
	(118627, 112, '2015-03-15 01:13:51.000000', 'temperatura', 340.0000, 'ºC'),
	(118628, 112, '2015-03-15 01:13:52.000000', 'temperatura', 65.0000, 'ºC'),
	(118629, 112, '2015-03-15 01:13:53.000000', 'temperatura', 504.0000, 'ºC'),
	(118630, 112, '2015-03-15 01:13:54.000000', 'temperatura', 1126.0000, 'ºC'),
	(118631, 112, '2015-03-15 01:13:55.000000', 'temperatura', 518.0000, 'ºC'),
	(118632, 112, '2015-03-15 01:13:56.000000', 'temperatura', 414.0000, 'ºC'),
	(118633, 112, '2015-03-15 01:13:57.000000', 'temperatura', 516.0000, 'ºC'),
	(118634, 112, '2015-03-15 01:13:58.000000', 'temperatura', 137.0000, 'ºC'),
	(118635, 112, '2015-03-15 01:13:59.000000', 'temperatura', 338.0000, 'ºC'),
	(118636, 112, '2015-03-15 01:14:00.000000', 'temperatura', 81.0000, 'ºC'),
	(118637, 112, '2015-03-15 01:14:01.000000', 'temperatura', 590.0000, 'ºC'),
	(118638, 112, '2015-03-15 01:14:02.000000', 'temperatura', 309.0000, 'ºC'),
	(118639, 112, '2015-03-15 01:14:03.000000', 'temperatura', 976.0000, 'ºC'),
	(118640, 112, '2015-03-15 01:14:04.000000', 'temperatura', 352.0000, 'ºC'),
	(118641, 112, '2015-03-15 01:14:05.000000', 'temperatura', 34.0000, 'ºC'),
	(118642, 112, '2015-03-15 01:14:06.000000', 'temperatura', 312.0000, 'ºC'),
	(118643, 112, '2015-03-15 01:14:07.000000', 'temperatura', 260.0000, 'ºC'),
	(118644, 112, '2015-03-15 01:14:08.000000', 'temperatura', 365.0000, 'ºC'),
	(118645, 112, '2015-03-15 01:14:09.000000', 'temperatura', 1045.0000, 'ºC'),
	(118646, 112, '2015-03-15 01:14:10.000000', 'temperatura', 529.0000, 'ºC'),
	(118647, 112, '2015-03-15 01:14:11.000000', 'temperatura', 713.0000, 'ºC'),
	(118648, 112, '2015-03-15 01:14:12.000000', 'temperatura', 776.0000, 'ºC'),
	(118649, 112, '2015-03-15 01:14:13.000000', 'temperatura', 544.0000, 'ºC'),
	(118650, 112, '2015-03-15 01:14:14.000000', 'temperatura', 392.0000, 'ºC'),
	(118651, 112, '2015-03-15 01:14:15.000000', 'temperatura', 327.0000, 'ºC'),
	(118652, 112, '2015-03-15 01:14:16.000000', 'temperatura', 460.0000, 'ºC'),
	(118653, 112, '2015-03-15 01:14:17.000000', 'temperatura', 120.0000, 'ºC'),
	(118654, 112, '2015-03-15 01:14:18.000000', 'temperatura', 418.0000, 'ºC'),
	(118655, 112, '2015-03-15 01:14:19.000000', 'temperatura', 534.0000, 'ºC'),
	(118656, 112, '2015-03-15 01:14:20.000000', 'temperatura', 215.0000, 'ºC'),
	(118657, 112, '2015-03-15 01:14:21.000000', 'temperatura', 674.0000, 'ºC'),
	(118658, 112, '2015-03-15 01:14:22.000000', 'temperatura', 324.0000, 'ºC'),
	(118659, 112, '2015-03-15 01:14:23.000000', 'temperatura', 799.0000, 'ºC'),
	(118660, 112, '2015-03-15 01:14:24.000000', 'temperatura', 625.0000, 'ºC'),
	(118661, 112, '2015-03-15 01:14:25.000000', 'temperatura', 729.0000, 'ºC'),
	(118662, 112, '2015-03-15 01:14:26.000000', 'temperatura', 571.0000, 'ºC'),
	(118663, 112, '2015-03-15 01:14:27.000000', 'temperatura', 668.0000, 'ºC'),
	(118664, 112, '2015-03-15 01:14:28.000000', 'temperatura', 425.0000, 'ºC'),
	(118665, 112, '2015-03-15 01:14:29.000000', 'temperatura', 123.0000, 'ºC'),
	(118666, 112, '2015-03-15 01:14:30.000000', 'temperatura', 541.0000, 'ºC'),
	(118667, 112, '2015-03-15 01:14:31.000000', 'temperatura', 1135.0000, 'ºC'),
	(118668, 112, '2015-03-15 01:14:32.000000', 'temperatura', 455.0000, 'ºC'),
	(118669, 112, '2015-03-15 01:14:33.000000', 'temperatura', 71.0000, 'ºC'),
	(118670, 112, '2015-03-15 01:14:34.000000', 'temperatura', 190.0000, 'ºC'),
	(118671, 112, '2015-03-15 01:14:35.000000', 'temperatura', 737.0000, 'ºC'),
	(118672, 112, '2015-03-15 01:14:36.000000', 'temperatura', 716.0000, 'ºC'),
	(118673, 112, '2015-03-15 01:14:37.000000', 'temperatura', 170.0000, 'ºC'),
	(118674, 112, '2015-03-15 01:14:38.000000', 'temperatura', 1104.0000, 'ºC'),
	(118675, 112, '2015-03-15 01:14:39.000000', 'temperatura', 207.0000, 'ºC'),
	(118676, 112, '2015-03-15 01:14:40.000000', 'temperatura', 125.0000, 'ºC'),
	(118677, 112, '2015-03-15 01:14:41.000000', 'temperatura', 6.0000, 'ºC'),
	(118678, 112, '2015-03-15 01:14:42.000000', 'temperatura', 856.0000, 'ºC'),
	(118679, 112, '2015-03-15 01:14:43.000000', 'temperatura', 660.0000, 'ºC'),
	(118680, 112, '2015-03-15 01:14:44.000000', 'temperatura', 734.0000, 'ºC'),
	(118681, 112, '2015-03-15 01:14:45.000000', 'temperatura', 491.0000, 'ºC'),
	(118682, 112, '2015-03-15 01:14:46.000000', 'temperatura', 251.0000, 'ºC'),
	(118683, 112, '2015-03-15 01:14:47.000000', 'temperatura', 985.0000, 'ºC'),
	(118684, 112, '2015-03-15 01:14:48.000000', 'temperatura', 571.0000, 'ºC'),
	(118685, 112, '2015-03-15 01:14:49.000000', 'temperatura', 1100.0000, 'ºC'),
	(118686, 112, '2015-03-15 01:14:50.000000', 'temperatura', 189.0000, 'ºC'),
	(118687, 112, '2015-03-15 01:14:51.000000', 'temperatura', 45.0000, 'ºC'),
	(118688, 112, '2015-03-15 01:14:52.000000', 'temperatura', 860.0000, 'ºC'),
	(118689, 112, '2015-03-15 01:14:53.000000', 'temperatura', 563.0000, 'ºC'),
	(118690, 112, '2015-03-15 01:14:54.000000', 'temperatura', 236.0000, 'ºC'),
	(118691, 112, '2015-03-15 01:14:55.000000', 'temperatura', 690.0000, 'ºC'),
	(118692, 112, '2015-03-15 01:14:56.000000', 'temperatura', 344.0000, 'ºC'),
	(118693, 112, '2015-03-15 01:14:57.000000', 'temperatura', 851.0000, 'ºC'),
	(118694, 112, '2015-03-15 01:14:58.000000', 'temperatura', 825.0000, 'ºC'),
	(118695, 112, '2015-03-15 01:14:59.000000', 'temperatura', 371.0000, 'ºC'),
	(118696, 112, '2015-03-15 01:15:00.000000', 'temperatura', 581.0000, 'ºC'),
	(118697, 112, '2015-03-15 01:15:01.000000', 'temperatura', 594.0000, 'ºC'),
	(118698, 112, '2015-03-15 01:15:02.000000', 'temperatura', 26.0000, 'ºC'),
	(118699, 112, '2015-03-15 01:15:03.000000', 'temperatura', 747.0000, 'ºC'),
	(118700, 112, '2015-03-15 01:15:04.000000', 'temperatura', 58.0000, 'ºC'),
	(118701, 112, '2015-03-15 01:15:05.000000', 'temperatura', 450.0000, 'ºC'),
	(118702, 112, '2015-03-15 01:15:06.000000', 'temperatura', 876.0000, 'ºC'),
	(118703, 112, '2015-03-15 01:15:07.000000', 'temperatura', 631.0000, 'ºC'),
	(118704, 112, '2015-03-15 01:15:08.000000', 'temperatura', 529.0000, 'ºC'),
	(118705, 112, '2015-03-15 01:15:09.000000', 'temperatura', 752.0000, 'ºC'),
	(118706, 112, '2015-03-15 01:15:10.000000', 'temperatura', 975.0000, 'ºC'),
	(118707, 112, '2015-03-15 01:15:11.000000', 'temperatura', 218.0000, 'ºC'),
	(118708, 112, '2015-03-15 01:15:12.000000', 'temperatura', 566.0000, 'ºC'),
	(118709, 112, '2015-03-15 01:15:13.000000', 'temperatura', 976.0000, 'ºC'),
	(118710, 112, '2015-03-15 01:15:14.000000', 'temperatura', 782.0000, 'ºC'),
	(118711, 112, '2015-03-15 01:15:15.000000', 'temperatura', 981.0000, 'ºC'),
	(118712, 112, '2015-03-15 01:15:16.000000', 'temperatura', 162.0000, 'ºC'),
	(118713, 112, '2015-03-15 01:15:17.000000', 'temperatura', 267.0000, 'ºC'),
	(118714, 112, '2015-03-15 01:15:18.000000', 'temperatura', 848.0000, 'ºC'),
	(118715, 112, '2015-03-15 01:15:19.000000', 'temperatura', 1042.0000, 'ºC'),
	(118716, 112, '2015-03-15 01:15:20.000000', 'temperatura', 263.0000, 'ºC'),
	(118717, 112, '2015-03-15 01:15:21.000000', 'temperatura', 593.0000, 'ºC'),
	(118718, 112, '2015-03-15 01:15:22.000000', 'temperatura', 974.0000, 'ºC'),
	(118719, 112, '2015-03-15 01:15:23.000000', 'temperatura', 690.0000, 'ºC'),
	(118720, 112, '2015-03-15 01:15:24.000000', 'temperatura', 532.0000, 'ºC'),
	(118721, 112, '2015-03-15 01:15:25.000000', 'temperatura', 589.0000, 'ºC'),
	(118722, 112, '2015-03-15 01:15:26.000000', 'temperatura', 151.0000, 'ºC'),
	(118723, 112, '2015-03-15 01:15:27.000000', 'temperatura', 189.0000, 'ºC'),
	(118724, 112, '2015-03-15 01:15:28.000000', 'temperatura', 491.0000, 'ºC'),
	(118725, 112, '2015-03-15 01:15:29.000000', 'temperatura', 688.0000, 'ºC'),
	(118726, 112, '2015-03-15 01:15:30.000000', 'temperatura', 767.0000, 'ºC'),
	(118727, 112, '2015-03-15 01:15:31.000000', 'temperatura', 572.0000, 'ºC'),
	(118728, 112, '2015-03-15 01:15:32.000000', 'temperatura', 561.0000, 'ºC'),
	(118729, 112, '2015-03-15 01:15:33.000000', 'temperatura', 1087.0000, 'ºC'),
	(118730, 112, '2015-03-15 01:15:34.000000', 'temperatura', 156.0000, 'ºC'),
	(118731, 112, '2015-03-15 01:15:35.000000', 'temperatura', 1117.0000, 'ºC'),
	(118732, 112, '2015-03-15 01:15:36.000000', 'temperatura', 316.0000, 'ºC'),
	(118733, 112, '2015-03-15 01:15:37.000000', 'temperatura', 633.0000, 'ºC'),
	(118734, 112, '2015-03-15 01:15:38.000000', 'temperatura', 1016.0000, 'ºC'),
	(118735, 112, '2015-03-15 01:15:39.000000', 'temperatura', 780.0000, 'ºC'),
	(118736, 112, '2015-03-15 01:15:40.000000', 'temperatura', 853.0000, 'ºC'),
	(118737, 112, '2015-03-15 01:15:41.000000', 'temperatura', 724.0000, 'ºC'),
	(118738, 112, '2015-03-15 01:15:42.000000', 'temperatura', 1063.0000, 'ºC'),
	(118739, 112, '2015-03-15 01:15:43.000000', 'temperatura', 744.0000, 'ºC'),
	(118740, 112, '2015-03-15 01:15:44.000000', 'temperatura', 529.0000, 'ºC'),
	(118741, 112, '2015-03-15 01:15:45.000000', 'temperatura', 415.0000, 'ºC'),
	(118742, 112, '2015-03-15 01:15:46.000000', 'temperatura', 488.0000, 'ºC'),
	(118743, 112, '2015-03-15 01:15:47.000000', 'temperatura', 1197.0000, 'ºC'),
	(118744, 112, '2015-03-15 01:15:48.000000', 'temperatura', 922.0000, 'ºC'),
	(118745, 112, '2015-03-15 01:15:49.000000', 'temperatura', 1020.0000, 'ºC'),
	(118746, 112, '2015-03-15 01:15:50.000000', 'temperatura', 1134.0000, 'ºC'),
	(118747, 112, '2015-03-15 01:15:51.000000', 'temperatura', 209.0000, 'ºC'),
	(118748, 112, '2015-03-15 01:15:52.000000', 'temperatura', 46.0000, 'ºC'),
	(118749, 112, '2015-03-15 01:15:53.000000', 'temperatura', 804.0000, 'ºC'),
	(118750, 112, '2015-03-15 01:15:54.000000', 'temperatura', 279.0000, 'ºC'),
	(118751, 112, '2015-03-15 01:15:55.000000', 'temperatura', 186.0000, 'ºC'),
	(118752, 112, '2015-03-15 01:15:56.000000', 'temperatura', 95.0000, 'ºC'),
	(118753, 112, '2015-03-15 01:15:57.000000', 'temperatura', 1116.0000, 'ºC'),
	(118754, 112, '2015-03-15 01:15:58.000000', 'temperatura', 496.0000, 'ºC'),
	(118755, 112, '2015-03-15 01:15:59.000000', 'temperatura', 331.0000, 'ºC'),
	(118756, 112, '2015-03-15 01:16:00.000000', 'temperatura', 167.0000, 'ºC'),
	(118757, 112, '2015-03-15 01:16:01.000000', 'temperatura', 1042.0000, 'ºC'),
	(118758, 112, '2015-03-15 01:16:02.000000', 'temperatura', 1109.0000, 'ºC'),
	(118759, 112, '2015-03-15 01:16:03.000000', 'temperatura', 21.0000, 'ºC'),
	(118760, 112, '2015-03-15 01:16:04.000000', 'temperatura', 379.0000, 'ºC'),
	(118761, 112, '2015-03-15 01:16:05.000000', 'temperatura', 633.0000, 'ºC'),
	(118762, 112, '2015-03-15 01:16:06.000000', 'temperatura', 827.0000, 'ºC'),
	(118763, 112, '2015-03-15 01:16:07.000000', 'temperatura', 1039.0000, 'ºC'),
	(118764, 112, '2015-03-15 01:16:08.000000', 'temperatura', 313.0000, 'ºC'),
	(118765, 112, '2015-03-15 01:16:09.000000', 'temperatura', 849.0000, 'ºC'),
	(118766, 112, '2015-03-15 01:16:10.000000', 'temperatura', 906.0000, 'ºC'),
	(118767, 112, '2015-03-15 01:16:11.000000', 'temperatura', 783.0000, 'ºC'),
	(118768, 112, '2015-03-15 01:16:12.000000', 'temperatura', 1198.0000, 'ºC'),
	(118769, 112, '2015-03-15 01:16:13.000000', 'temperatura', 40.0000, 'ºC'),
	(118770, 112, '2015-03-15 01:16:14.000000', 'temperatura', 209.0000, 'ºC'),
	(118771, 112, '2015-03-15 01:16:15.000000', 'temperatura', 927.0000, 'ºC'),
	(118772, 112, '2015-03-15 01:16:16.000000', 'temperatura', 405.0000, 'ºC'),
	(118773, 112, '2015-03-15 01:16:17.000000', 'temperatura', 445.0000, 'ºC'),
	(118774, 112, '2015-03-15 01:16:18.000000', 'temperatura', 1010.0000, 'ºC'),
	(118775, 112, '2015-03-15 01:16:19.000000', 'temperatura', 118.0000, 'ºC'),
	(118776, 112, '2015-03-15 01:16:20.000000', 'temperatura', 1158.0000, 'ºC'),
	(118777, 112, '2015-03-15 01:16:21.000000', 'temperatura', 637.0000, 'ºC'),
	(118778, 112, '2015-03-15 01:16:22.000000', 'temperatura', 911.0000, 'ºC'),
	(118779, 112, '2015-03-15 01:16:23.000000', 'temperatura', 244.0000, 'ºC'),
	(118780, 112, '2015-03-15 01:16:24.000000', 'temperatura', 890.0000, 'ºC'),
	(118781, 112, '2015-03-15 01:16:25.000000', 'temperatura', 116.0000, 'ºC'),
	(118782, 112, '2015-03-15 01:16:26.000000', 'temperatura', 311.0000, 'ºC'),
	(118783, 112, '2015-03-15 01:16:27.000000', 'temperatura', 6.0000, 'ºC'),
	(118784, 112, '2015-03-15 01:16:28.000000', 'temperatura', 299.0000, 'ºC'),
	(118785, 112, '2015-03-15 01:16:29.000000', 'temperatura', 279.0000, 'ºC'),
	(118786, 112, '2015-03-15 01:16:30.000000', 'temperatura', 498.0000, 'ºC'),
	(118787, 112, '2015-03-15 01:16:31.000000', 'temperatura', 454.0000, 'ºC'),
	(118788, 112, '2015-03-15 01:16:32.000000', 'temperatura', 777.0000, 'ºC'),
	(118789, 112, '2015-03-15 01:16:33.000000', 'temperatura', 124.0000, 'ºC'),
	(118790, 112, '2015-03-15 01:16:34.000000', 'temperatura', 690.0000, 'ºC'),
	(118791, 112, '2015-03-15 01:16:35.000000', 'temperatura', 678.0000, 'ºC'),
	(118792, 112, '2015-03-15 01:16:36.000000', 'temperatura', 121.0000, 'ºC'),
	(118793, 112, '2015-03-15 01:16:37.000000', 'temperatura', 969.0000, 'ºC'),
	(118794, 112, '2015-03-15 01:16:38.000000', 'temperatura', 883.0000, 'ºC'),
	(118795, 112, '2015-03-15 01:16:39.000000', 'temperatura', 311.0000, 'ºC'),
	(118796, 112, '2015-03-15 01:16:40.000000', 'temperatura', 106.0000, 'ºC'),
	(118797, 112, '2015-03-15 01:16:41.000000', 'temperatura', 797.0000, 'ºC'),
	(118798, 112, '2015-03-15 01:16:42.000000', 'temperatura', 65.0000, 'ºC'),
	(118799, 112, '2015-03-15 01:16:43.000000', 'temperatura', 338.0000, 'ºC'),
	(118800, 112, '2015-03-15 01:16:44.000000', 'temperatura', 296.0000, 'ºC'),
	(118801, 112, '2015-03-15 01:16:45.000000', 'temperatura', 463.0000, 'ºC'),
	(118802, 112, '2015-03-15 01:16:46.000000', 'temperatura', 231.0000, 'ºC'),
	(118803, 112, '2015-03-15 01:16:47.000000', 'temperatura', 965.0000, 'ºC'),
	(118804, 112, '2015-03-15 01:16:48.000000', 'temperatura', 534.0000, 'ºC'),
	(118805, 112, '2015-03-15 01:16:49.000000', 'temperatura', 976.0000, 'ºC'),
	(118806, 112, '2015-03-15 01:16:50.000000', 'temperatura', 877.0000, 'ºC'),
	(118807, 112, '2015-03-15 01:16:51.000000', 'temperatura', 257.0000, 'ºC'),
	(118808, 112, '2015-03-15 01:16:52.000000', 'temperatura', 1056.0000, 'ºC'),
	(118809, 112, '2015-03-15 01:16:53.000000', 'temperatura', 907.0000, 'ºC'),
	(118810, 112, '2015-03-15 01:16:54.000000', 'temperatura', 169.0000, 'ºC'),
	(118811, 112, '2015-03-15 01:16:55.000000', 'temperatura', 524.0000, 'ºC'),
	(118812, 112, '2015-03-15 01:16:56.000000', 'temperatura', 915.0000, 'ºC'),
	(118813, 112, '2015-03-15 01:16:57.000000', 'temperatura', 604.0000, 'ºC'),
	(118814, 112, '2015-03-15 01:16:58.000000', 'temperatura', 276.0000, 'ºC'),
	(118815, 112, '2015-03-15 01:16:59.000000', 'temperatura', 768.0000, 'ºC'),
	(118816, 112, '2015-03-15 01:17:00.000000', 'temperatura', 611.0000, 'ºC'),
	(118817, 112, '2015-03-15 01:17:01.000000', 'temperatura', 751.0000, 'ºC'),
	(118818, 112, '2015-03-15 01:17:02.000000', 'temperatura', 724.0000, 'ºC'),
	(118819, 112, '2015-03-15 01:17:03.000000', 'temperatura', 168.0000, 'ºC'),
	(118820, 112, '2015-03-15 01:17:04.000000', 'temperatura', 1068.0000, 'ºC'),
	(118821, 112, '2015-03-15 01:17:05.000000', 'temperatura', 37.0000, 'ºC'),
	(118822, 112, '2015-03-15 01:17:06.000000', 'temperatura', 580.0000, 'ºC'),
	(118823, 112, '2015-03-15 01:17:07.000000', 'temperatura', 389.0000, 'ºC'),
	(118824, 112, '2015-03-15 01:17:08.000000', 'temperatura', 208.0000, 'ºC'),
	(118825, 112, '2015-03-15 01:17:09.000000', 'temperatura', 1074.0000, 'ºC'),
	(118826, 112, '2015-03-15 01:17:10.000000', 'temperatura', 1146.0000, 'ºC'),
	(118827, 112, '2015-03-15 01:17:11.000000', 'temperatura', 107.0000, 'ºC'),
	(118828, 112, '2015-03-15 01:17:12.000000', 'temperatura', 696.0000, 'ºC'),
	(118829, 112, '2015-03-15 01:17:13.000000', 'temperatura', 762.0000, 'ºC'),
	(118830, 112, '2015-03-15 01:17:14.000000', 'temperatura', 520.0000, 'ºC'),
	(118831, 112, '2015-03-15 01:17:15.000000', 'temperatura', 316.0000, 'ºC'),
	(118832, 112, '2015-03-15 01:17:16.000000', 'temperatura', 19.0000, 'ºC'),
	(118833, 112, '2015-03-15 01:17:17.000000', 'temperatura', 348.0000, 'ºC'),
	(118834, 112, '2015-03-15 01:17:18.000000', 'temperatura', 482.0000, 'ºC'),
	(118835, 112, '2015-03-15 01:17:19.000000', 'temperatura', 170.0000, 'ºC'),
	(118836, 112, '2015-03-15 01:17:20.000000', 'temperatura', 601.0000, 'ºC'),
	(118837, 112, '2015-03-15 01:17:21.000000', 'temperatura', 97.0000, 'ºC'),
	(118838, 112, '2015-03-15 01:17:22.000000', 'temperatura', 1081.0000, 'ºC'),
	(118839, 112, '2015-03-15 01:17:23.000000', 'temperatura', 317.0000, 'ºC'),
	(118840, 112, '2015-03-15 01:17:24.000000', 'temperatura', 740.0000, 'ºC'),
	(118841, 112, '2015-03-15 01:17:25.000000', 'temperatura', 349.0000, 'ºC'),
	(118842, 112, '2015-03-15 01:17:26.000000', 'temperatura', 725.0000, 'ºC'),
	(118843, 112, '2015-03-15 01:17:27.000000', 'temperatura', 181.0000, 'ºC'),
	(118844, 108, '2015-04-01 00:00:00.000000', 'temperatura', 304.0000, 'ºC'),
	(118845, 108, '2015-04-01 00:00:01.000000', 'temperatura', 534.0000, 'ºC'),
	(118846, 108, '2015-04-01 00:00:02.000000', 'temperatura', 558.0000, 'ºC'),
	(118847, 108, '2015-04-01 00:00:03.000000', 'temperatura', 1186.0000, 'ºC'),
	(118848, 108, '2015-04-01 00:00:04.000000', 'temperatura', 660.0000, 'ºC'),
	(118849, 108, '2015-04-01 00:00:05.000000', 'temperatura', 939.0000, 'ºC'),
	(118850, 108, '2015-04-01 00:00:06.000000', 'temperatura', 319.0000, 'ºC'),
	(118851, 108, '2015-04-01 00:00:07.000000', 'temperatura', 1177.0000, 'ºC'),
	(118852, 108, '2015-04-01 00:00:08.000000', 'temperatura', 127.0000, 'ºC'),
	(118853, 108, '2015-04-01 00:00:09.000000', 'temperatura', 704.0000, 'ºC'),
	(118854, 108, '2015-04-01 00:00:10.000000', 'temperatura', 742.0000, 'ºC'),
	(118855, 108, '2015-04-01 00:00:11.000000', 'temperatura', 398.0000, 'ºC'),
	(118856, 108, '2015-04-01 00:00:12.000000', 'temperatura', 964.0000, 'ºC'),
	(118857, 108, '2015-04-01 00:00:13.000000', 'temperatura', 24.0000, 'ºC'),
	(118858, 108, '2015-04-01 00:00:14.000000', 'temperatura', 832.0000, 'ºC'),
	(118859, 108, '2015-04-01 00:00:15.000000', 'temperatura', 489.0000, 'ºC'),
	(118860, 108, '2015-04-01 00:00:16.000000', 'temperatura', 1150.0000, 'ºC'),
	(118861, 108, '2015-04-01 00:00:17.000000', 'temperatura', 682.0000, 'ºC'),
	(118862, 108, '2015-04-01 00:00:18.000000', 'temperatura', 1162.0000, 'ºC'),
	(118863, 108, '2015-04-01 00:00:19.000000', 'temperatura', 162.0000, 'ºC'),
	(118864, 108, '2015-04-01 00:00:20.000000', 'temperatura', 925.0000, 'ºC'),
	(118865, 108, '2015-04-01 00:00:21.000000', 'temperatura', 539.0000, 'ºC'),
	(118866, 108, '2015-04-01 00:00:22.000000', 'temperatura', 1120.0000, 'ºC'),
	(118867, 108, '2015-04-01 00:00:23.000000', 'temperatura', 385.0000, 'ºC'),
	(118868, 108, '2015-04-01 00:00:24.000000', 'temperatura', 964.0000, 'ºC'),
	(118869, 108, '2015-04-01 00:00:25.000000', 'temperatura', 65.0000, 'ºC'),
	(118870, 108, '2015-04-01 00:00:26.000000', 'temperatura', 1034.0000, 'ºC'),
	(118871, 108, '2015-04-01 00:00:27.000000', 'temperatura', 177.0000, 'ºC'),
	(118872, 108, '2015-04-01 00:00:28.000000', 'temperatura', 183.0000, 'ºC'),
	(118873, 108, '2015-04-01 00:00:29.000000', 'temperatura', 385.0000, 'ºC'),
	(118874, 108, '2015-04-01 00:00:30.000000', 'temperatura', 176.0000, 'ºC'),
	(118875, 108, '2015-04-01 00:00:31.000000', 'temperatura', 927.0000, 'ºC'),
	(118876, 108, '2015-04-01 00:00:32.000000', 'temperatura', 506.0000, 'ºC'),
	(118877, 108, '2015-04-01 00:00:33.000000', 'temperatura', 951.0000, 'ºC'),
	(118878, 108, '2015-04-01 00:00:34.000000', 'temperatura', 837.0000, 'ºC'),
	(118879, 108, '2015-04-01 00:00:35.000000', 'temperatura', 133.0000, 'ºC'),
	(118880, 108, '2015-04-01 00:00:36.000000', 'temperatura', 556.0000, 'ºC'),
	(118881, 108, '2015-04-01 00:00:37.000000', 'temperatura', 1179.0000, 'ºC'),
	(118882, 108, '2015-04-01 00:00:38.000000', 'temperatura', 626.0000, 'ºC'),
	(118883, 108, '2015-04-01 00:00:39.000000', 'temperatura', 797.0000, 'ºC'),
	(118884, 108, '2015-04-01 00:00:40.000000', 'temperatura', 905.0000, 'ºC'),
	(118885, 108, '2015-04-01 00:00:41.000000', 'temperatura', 934.0000, 'ºC'),
	(118886, 108, '2015-04-01 00:00:42.000000', 'temperatura', 758.0000, 'ºC'),
	(118887, 108, '2015-04-01 00:00:43.000000', 'temperatura', 987.0000, 'ºC'),
	(118888, 108, '2015-04-01 00:00:44.000000', 'temperatura', 264.0000, 'ºC'),
	(118889, 108, '2015-04-01 00:00:45.000000', 'temperatura', 756.0000, 'ºC'),
	(118890, 108, '2015-04-01 00:00:46.000000', 'temperatura', 591.0000, 'ºC'),
	(118891, 108, '2015-04-01 00:00:47.000000', 'temperatura', 686.0000, 'ºC'),
	(118892, 108, '2015-04-01 00:00:48.000000', 'temperatura', 459.0000, 'ºC'),
	(118893, 108, '2015-04-01 00:00:49.000000', 'temperatura', 238.0000, 'ºC'),
	(118894, 108, '2015-04-01 00:00:50.000000', 'temperatura', 1014.0000, 'ºC'),
	(118895, 108, '2015-04-01 00:00:51.000000', 'temperatura', 754.0000, 'ºC'),
	(118896, 108, '2015-04-01 00:00:52.000000', 'temperatura', 731.0000, 'ºC'),
	(118897, 108, '2015-04-01 00:00:53.000000', 'temperatura', 193.0000, 'ºC'),
	(118898, 108, '2015-04-01 00:00:54.000000', 'temperatura', 1172.0000, 'ºC'),
	(118899, 108, '2015-04-01 00:00:55.000000', 'temperatura', 482.0000, 'ºC'),
	(118900, 108, '2015-04-01 00:00:56.000000', 'temperatura', 93.0000, 'ºC'),
	(118901, 108, '2015-04-01 00:00:57.000000', 'temperatura', 220.0000, 'ºC'),
	(118902, 108, '2015-04-01 00:00:58.000000', 'temperatura', 821.0000, 'ºC'),
	(118903, 108, '2015-04-01 00:00:59.000000', 'temperatura', 1048.0000, 'ºC'),
	(118904, 108, '2015-04-01 00:01:00.000000', 'temperatura', 376.0000, 'ºC'),
	(118905, 108, '2015-04-01 00:01:01.000000', 'temperatura', 1138.0000, 'ºC'),
	(118906, 108, '2015-04-01 00:01:02.000000', 'temperatura', 962.0000, 'ºC'),
	(118907, 108, '2015-04-01 00:01:03.000000', 'temperatura', 194.0000, 'ºC'),
	(118908, 108, '2015-04-01 00:01:04.000000', 'temperatura', 486.0000, 'ºC'),
	(118909, 108, '2015-04-01 00:01:05.000000', 'temperatura', 650.0000, 'ºC'),
	(118910, 108, '2015-04-01 00:01:06.000000', 'temperatura', 589.0000, 'ºC'),
	(118911, 108, '2015-04-01 00:01:07.000000', 'temperatura', 999.0000, 'ºC'),
	(118912, 108, '2015-04-01 00:01:08.000000', 'temperatura', 826.0000, 'ºC'),
	(118913, 108, '2015-04-01 00:01:09.000000', 'temperatura', 1133.0000, 'ºC'),
	(118914, 108, '2015-04-01 00:01:10.000000', 'temperatura', 790.0000, 'ºC'),
	(118915, 108, '2015-04-01 00:01:11.000000', 'temperatura', 552.0000, 'ºC'),
	(118916, 108, '2015-04-01 00:01:12.000000', 'temperatura', 389.0000, 'ºC'),
	(118917, 108, '2015-04-01 00:01:13.000000', 'temperatura', 290.0000, 'ºC'),
	(118918, 108, '2015-04-01 00:01:14.000000', 'temperatura', 285.0000, 'ºC'),
	(118919, 108, '2015-04-01 00:01:15.000000', 'temperatura', 554.0000, 'ºC'),
	(118920, 108, '2015-04-01 00:01:16.000000', 'temperatura', 716.0000, 'ºC'),
	(118921, 108, '2015-04-01 00:01:17.000000', 'temperatura', 716.0000, 'ºC'),
	(118922, 108, '2015-04-01 00:01:18.000000', 'temperatura', 235.0000, 'ºC'),
	(118923, 108, '2015-04-01 00:01:19.000000', 'temperatura', 229.0000, 'ºC'),
	(118924, 108, '2015-04-01 00:01:20.000000', 'temperatura', 437.0000, 'ºC'),
	(118925, 108, '2015-04-01 00:01:21.000000', 'temperatura', 301.0000, 'ºC'),
	(118926, 108, '2015-04-01 00:01:22.000000', 'temperatura', 193.0000, 'ºC'),
	(118927, 108, '2015-04-01 00:01:23.000000', 'temperatura', 64.0000, 'ºC'),
	(118928, 108, '2015-04-01 00:01:24.000000', 'temperatura', 940.0000, 'ºC'),
	(118929, 108, '2015-04-01 00:01:25.000000', 'temperatura', 909.0000, 'ºC'),
	(118930, 108, '2015-04-01 00:01:26.000000', 'temperatura', 524.0000, 'ºC'),
	(118931, 108, '2015-04-01 00:01:27.000000', 'temperatura', 1093.0000, 'ºC'),
	(118932, 108, '2015-04-01 00:01:28.000000', 'temperatura', 295.0000, 'ºC'),
	(118933, 108, '2015-04-01 00:01:29.000000', 'temperatura', 596.0000, 'ºC'),
	(118934, 108, '2015-04-01 00:01:30.000000', 'temperatura', 895.0000, 'ºC'),
	(118935, 108, '2015-04-01 00:01:31.000000', 'temperatura', 286.0000, 'ºC'),
	(118936, 108, '2015-04-01 00:01:32.000000', 'temperatura', 1147.0000, 'ºC'),
	(118937, 108, '2015-04-01 00:01:33.000000', 'temperatura', 78.0000, 'ºC'),
	(118938, 108, '2015-04-01 00:01:34.000000', 'temperatura', 549.0000, 'ºC'),
	(118939, 108, '2015-04-01 00:01:35.000000', 'temperatura', 111.0000, 'ºC'),
	(118940, 108, '2015-04-01 00:01:36.000000', 'temperatura', 109.0000, 'ºC'),
	(118941, 108, '2015-04-01 00:01:37.000000', 'temperatura', 212.0000, 'ºC'),
	(118942, 108, '2015-04-01 00:01:38.000000', 'temperatura', 732.0000, 'ºC'),
	(118943, 108, '2015-04-01 00:01:39.000000', 'temperatura', 627.0000, 'ºC'),
	(118944, 108, '2015-04-01 00:01:40.000000', 'temperatura', 938.0000, 'ºC'),
	(118945, 108, '2015-04-01 00:01:41.000000', 'temperatura', 411.0000, 'ºC'),
	(118946, 108, '2015-04-01 00:01:42.000000', 'temperatura', 441.0000, 'ºC'),
	(118947, 108, '2015-04-01 00:01:43.000000', 'temperatura', 970.0000, 'ºC'),
	(118948, 108, '2015-04-01 00:01:44.000000', 'temperatura', 1131.0000, 'ºC'),
	(118949, 108, '2015-04-01 00:01:45.000000', 'temperatura', 344.0000, 'ºC'),
	(118950, 108, '2015-04-01 00:01:46.000000', 'temperatura', 726.0000, 'ºC'),
	(118951, 108, '2015-04-01 00:01:47.000000', 'temperatura', 199.0000, 'ºC'),
	(118952, 108, '2015-04-01 00:01:48.000000', 'temperatura', 19.0000, 'ºC'),
	(118953, 108, '2015-04-01 00:01:49.000000', 'temperatura', 697.0000, 'ºC'),
	(118954, 108, '2015-04-01 00:01:50.000000', 'temperatura', 1030.0000, 'ºC'),
	(118955, 108, '2015-04-01 00:01:51.000000', 'temperatura', 658.0000, 'ºC'),
	(118956, 108, '2015-04-01 00:01:52.000000', 'temperatura', 201.0000, 'ºC'),
	(118957, 108, '2015-04-01 00:01:53.000000', 'temperatura', 233.0000, 'ºC'),
	(118958, 108, '2015-04-01 00:01:54.000000', 'temperatura', 562.0000, 'ºC'),
	(118959, 108, '2015-04-01 00:01:55.000000', 'temperatura', 913.0000, 'ºC'),
	(118960, 108, '2015-04-01 00:01:56.000000', 'temperatura', 478.0000, 'ºC'),
	(118961, 108, '2015-04-01 00:01:57.000000', 'temperatura', 852.0000, 'ºC'),
	(118962, 108, '2015-04-01 00:01:58.000000', 'temperatura', 428.0000, 'ºC'),
	(118963, 108, '2015-04-01 00:01:59.000000', 'temperatura', 783.0000, 'ºC'),
	(118964, 108, '2015-04-01 00:02:00.000000', 'temperatura', 234.0000, 'ºC'),
	(118965, 108, '2015-04-01 00:02:01.000000', 'temperatura', 18.0000, 'ºC'),
	(118966, 108, '2015-04-01 00:02:02.000000', 'temperatura', 590.0000, 'ºC'),
	(118967, 108, '2015-04-01 00:02:03.000000', 'temperatura', 495.0000, 'ºC'),
	(118968, 108, '2015-04-01 00:02:04.000000', 'temperatura', 707.0000, 'ºC'),
	(118969, 108, '2015-04-01 00:02:05.000000', 'temperatura', 852.0000, 'ºC'),
	(118970, 108, '2015-04-01 00:02:06.000000', 'temperatura', 939.0000, 'ºC'),
	(118971, 108, '2015-04-01 00:02:07.000000', 'temperatura', 939.0000, 'ºC'),
	(118972, 108, '2015-04-01 00:02:08.000000', 'temperatura', 680.0000, 'ºC'),
	(118973, 108, '2015-04-01 00:02:09.000000', 'temperatura', 583.0000, 'ºC'),
	(118974, 108, '2015-04-01 00:02:10.000000', 'temperatura', 877.0000, 'ºC'),
	(118975, 108, '2015-04-01 00:02:11.000000', 'temperatura', 234.0000, 'ºC'),
	(118976, 108, '2015-04-01 00:02:12.000000', 'temperatura', 939.0000, 'ºC'),
	(118977, 108, '2015-04-01 00:02:13.000000', 'temperatura', 396.0000, 'ºC'),
	(118978, 108, '2015-04-01 00:02:14.000000', 'temperatura', 364.0000, 'ºC'),
	(118979, 108, '2015-04-01 00:02:15.000000', 'temperatura', 631.0000, 'ºC'),
	(118980, 108, '2015-04-01 00:02:16.000000', 'temperatura', 866.0000, 'ºC'),
	(118981, 108, '2015-04-01 00:02:17.000000', 'temperatura', 34.0000, 'ºC'),
	(118982, 108, '2015-04-01 00:02:18.000000', 'temperatura', 1175.0000, 'ºC'),
	(118983, 108, '2015-04-01 00:02:19.000000', 'temperatura', 972.0000, 'ºC'),
	(118984, 108, '2015-04-01 00:02:20.000000', 'temperatura', 135.0000, 'ºC'),
	(118985, 108, '2015-04-01 00:02:21.000000', 'temperatura', 162.0000, 'ºC'),
	(118986, 108, '2015-04-01 00:02:22.000000', 'temperatura', 404.0000, 'ºC'),
	(118987, 108, '2015-04-01 00:02:23.000000', 'temperatura', 335.0000, 'ºC'),
	(118988, 108, '2015-04-01 00:02:24.000000', 'temperatura', 463.0000, 'ºC'),
	(118989, 108, '2015-04-01 00:02:25.000000', 'temperatura', 112.0000, 'ºC'),
	(118990, 108, '2015-04-01 00:02:26.000000', 'temperatura', 371.0000, 'ºC'),
	(118991, 108, '2015-04-01 00:02:27.000000', 'temperatura', 321.0000, 'ºC'),
	(118992, 108, '2015-04-01 00:02:28.000000', 'temperatura', 493.0000, 'ºC'),
	(118993, 108, '2015-04-01 00:02:29.000000', 'temperatura', 300.0000, 'ºC'),
	(118994, 108, '2015-04-01 00:02:30.000000', 'temperatura', 22.0000, 'ºC'),
	(118995, 108, '2015-04-01 00:02:31.000000', 'temperatura', 410.0000, 'ºC'),
	(118996, 108, '2015-04-01 00:02:32.000000', 'temperatura', 784.0000, 'ºC'),
	(118997, 108, '2015-04-01 00:02:33.000000', 'temperatura', 291.0000, 'ºC'),
	(118998, 108, '2015-04-01 00:02:34.000000', 'temperatura', 305.0000, 'ºC'),
	(118999, 108, '2015-04-01 00:02:35.000000', 'temperatura', 651.0000, 'ºC'),
	(119000, 108, '2015-04-01 00:02:36.000000', 'temperatura', 1143.0000, 'ºC'),
	(119001, 108, '2015-04-01 00:02:37.000000', 'temperatura', 160.0000, 'ºC'),
	(119002, 108, '2015-04-01 00:02:38.000000', 'temperatura', 971.0000, 'ºC'),
	(119003, 108, '2015-04-01 00:02:39.000000', 'temperatura', 775.0000, 'ºC'),
	(119004, 108, '2015-04-01 00:02:40.000000', 'temperatura', 963.0000, 'ºC'),
	(119005, 108, '2015-04-01 00:02:41.000000', 'temperatura', 90.0000, 'ºC'),
	(119006, 108, '2015-04-01 00:02:42.000000', 'temperatura', 1160.0000, 'ºC'),
	(119007, 108, '2015-04-01 00:02:43.000000', 'temperatura', 732.0000, 'ºC'),
	(119008, 108, '2015-04-01 00:02:44.000000', 'temperatura', 180.0000, 'ºC'),
	(119009, 108, '2015-04-01 00:02:45.000000', 'temperatura', 1103.0000, 'ºC'),
	(119010, 108, '2015-04-01 00:02:46.000000', 'temperatura', 177.0000, 'ºC'),
	(119011, 108, '2015-04-01 00:02:47.000000', 'temperatura', 1177.0000, 'ºC'),
	(119012, 108, '2015-04-01 00:02:48.000000', 'temperatura', 556.0000, 'ºC'),
	(119013, 108, '2015-04-01 00:02:49.000000', 'temperatura', 447.0000, 'ºC'),
	(119014, 108, '2015-04-01 00:02:50.000000', 'temperatura', 570.0000, 'ºC'),
	(119015, 108, '2015-04-01 00:02:51.000000', 'temperatura', 310.0000, 'ºC'),
	(119016, 108, '2015-04-01 00:02:52.000000', 'temperatura', 1039.0000, 'ºC'),
	(119017, 108, '2015-04-01 00:02:53.000000', 'temperatura', 668.0000, 'ºC'),
	(119018, 108, '2015-04-01 00:02:54.000000', 'temperatura', 221.0000, 'ºC'),
	(119019, 108, '2015-04-01 00:02:55.000000', 'temperatura', 303.0000, 'ºC'),
	(119020, 108, '2015-04-01 00:02:56.000000', 'temperatura', 852.0000, 'ºC'),
	(119021, 108, '2015-04-01 00:02:57.000000', 'temperatura', 954.0000, 'ºC'),
	(119022, 108, '2015-04-01 00:02:58.000000', 'temperatura', 1011.0000, 'ºC'),
	(119023, 108, '2015-04-01 00:02:59.000000', 'temperatura', 994.0000, 'ºC'),
	(119024, 108, '2015-04-01 00:03:00.000000', 'temperatura', 738.0000, 'ºC'),
	(119025, 108, '2015-04-01 00:03:01.000000', 'temperatura', 706.0000, 'ºC'),
	(119026, 108, '2015-04-01 00:03:02.000000', 'temperatura', 120.0000, 'ºC'),
	(119027, 108, '2015-04-01 00:03:03.000000', 'temperatura', 883.0000, 'ºC'),
	(119028, 108, '2015-04-01 00:03:04.000000', 'temperatura', 452.0000, 'ºC'),
	(119029, 108, '2015-04-01 00:03:05.000000', 'temperatura', 815.0000, 'ºC'),
	(119030, 108, '2015-04-01 00:03:06.000000', 'temperatura', 318.0000, 'ºC'),
	(119031, 108, '2015-04-01 00:03:07.000000', 'temperatura', 347.0000, 'ºC'),
	(119032, 108, '2015-04-01 00:03:08.000000', 'temperatura', 779.0000, 'ºC'),
	(119033, 108, '2015-04-01 00:03:09.000000', 'temperatura', 455.0000, 'ºC'),
	(119034, 108, '2015-04-01 00:03:10.000000', 'temperatura', 1138.0000, 'ºC'),
	(119035, 108, '2015-04-01 00:03:11.000000', 'temperatura', 725.0000, 'ºC'),
	(119036, 108, '2015-04-01 00:03:12.000000', 'temperatura', 214.0000, 'ºC'),
	(119037, 108, '2015-04-01 00:03:13.000000', 'temperatura', 95.0000, 'ºC'),
	(119038, 108, '2015-04-01 00:03:14.000000', 'temperatura', 1034.0000, 'ºC'),
	(119039, 108, '2015-04-01 00:03:15.000000', 'temperatura', 84.0000, 'ºC'),
	(119040, 108, '2015-04-01 00:03:16.000000', 'temperatura', 917.0000, 'ºC'),
	(119041, 108, '2015-04-01 00:03:17.000000', 'temperatura', 737.0000, 'ºC'),
	(119042, 108, '2015-04-01 00:03:18.000000', 'temperatura', 932.0000, 'ºC'),
	(119043, 108, '2015-04-01 00:03:19.000000', 'temperatura', 50.0000, 'ºC'),
	(119044, 108, '2015-04-01 00:03:20.000000', 'temperatura', 1054.0000, 'ºC'),
	(119045, 108, '2015-04-01 00:03:21.000000', 'temperatura', 323.0000, 'ºC'),
	(119046, 108, '2015-04-01 00:03:22.000000', 'temperatura', 851.0000, 'ºC'),
	(119047, 108, '2015-04-01 00:03:23.000000', 'temperatura', 889.0000, 'ºC'),
	(119048, 108, '2015-04-01 00:03:24.000000', 'temperatura', 690.0000, 'ºC'),
	(119049, 108, '2015-04-01 00:03:25.000000', 'temperatura', 782.0000, 'ºC'),
	(119050, 108, '2015-04-01 00:03:26.000000', 'temperatura', 644.0000, 'ºC'),
	(119051, 108, '2015-04-01 00:03:27.000000', 'temperatura', 874.0000, 'ºC'),
	(119052, 108, '2015-04-01 00:03:28.000000', 'temperatura', 37.0000, 'ºC'),
	(119053, 108, '2015-04-01 00:03:29.000000', 'temperatura', 1165.0000, 'ºC'),
	(119054, 108, '2015-04-01 00:03:30.000000', 'temperatura', 915.0000, 'ºC'),
	(119055, 108, '2015-04-01 00:03:31.000000', 'temperatura', 1079.0000, 'ºC'),
	(119056, 108, '2015-04-01 00:03:32.000000', 'temperatura', 252.0000, 'ºC'),
	(119057, 108, '2015-04-01 00:03:33.000000', 'temperatura', 421.0000, 'ºC'),
	(119058, 108, '2015-04-01 00:03:34.000000', 'temperatura', 152.0000, 'ºC'),
	(119059, 108, '2015-04-01 00:03:35.000000', 'temperatura', 696.0000, 'ºC'),
	(119060, 108, '2015-04-01 00:03:36.000000', 'temperatura', 626.0000, 'ºC'),
	(119061, 108, '2015-04-01 00:03:37.000000', 'temperatura', 1041.0000, 'ºC'),
	(119062, 108, '2015-04-01 00:03:38.000000', 'temperatura', 926.0000, 'ºC'),
	(119063, 108, '2015-04-01 00:03:39.000000', 'temperatura', 309.0000, 'ºC'),
	(119064, 108, '2015-04-01 00:03:40.000000', 'temperatura', 1169.0000, 'ºC'),
	(119065, 108, '2015-04-01 00:03:41.000000', 'temperatura', 116.0000, 'ºC'),
	(119066, 108, '2015-04-01 00:03:42.000000', 'temperatura', 674.0000, 'ºC'),
	(119067, 108, '2015-04-01 00:03:43.000000', 'temperatura', 623.0000, 'ºC'),
	(119068, 108, '2015-04-01 00:03:44.000000', 'temperatura', 1092.0000, 'ºC'),
	(119069, 108, '2015-04-01 00:03:45.000000', 'temperatura', 1195.0000, 'ºC'),
	(119070, 108, '2015-04-01 00:03:46.000000', 'temperatura', 296.0000, 'ºC'),
	(119071, 108, '2015-04-01 00:03:47.000000', 'temperatura', 296.0000, 'ºC'),
	(119072, 108, '2015-04-01 00:03:48.000000', 'temperatura', 594.0000, 'ºC'),
	(119073, 108, '2015-04-01 00:03:49.000000', 'temperatura', 883.0000, 'ºC'),
	(119074, 108, '2015-04-01 00:03:50.000000', 'temperatura', 231.0000, 'ºC'),
	(119075, 108, '2015-04-01 00:03:51.000000', 'temperatura', 906.0000, 'ºC'),
	(119076, 108, '2015-04-01 00:03:52.000000', 'temperatura', 238.0000, 'ºC'),
	(119077, 108, '2015-04-01 00:03:53.000000', 'temperatura', 872.0000, 'ºC'),
	(119078, 108, '2015-04-01 00:03:54.000000', 'temperatura', 49.0000, 'ºC'),
	(119079, 108, '2015-04-01 00:03:55.000000', 'temperatura', 27.0000, 'ºC'),
	(119080, 108, '2015-04-01 00:03:56.000000', 'temperatura', 1188.0000, 'ºC'),
	(119081, 108, '2015-04-01 00:03:57.000000', 'temperatura', 1062.0000, 'ºC'),
	(119082, 108, '2015-04-01 00:03:58.000000', 'temperatura', 545.0000, 'ºC'),
	(119083, 108, '2015-04-01 00:03:59.000000', 'temperatura', 738.0000, 'ºC'),
	(119084, 108, '2015-04-01 00:04:00.000000', 'temperatura', 856.0000, 'ºC'),
	(119085, 108, '2015-04-01 00:04:01.000000', 'temperatura', 866.0000, 'ºC'),
	(119086, 108, '2015-04-01 00:04:02.000000', 'temperatura', 564.0000, 'ºC'),
	(119087, 108, '2015-04-01 00:04:03.000000', 'temperatura', 220.0000, 'ºC'),
	(119088, 108, '2015-04-01 00:04:04.000000', 'temperatura', 612.0000, 'ºC'),
	(119089, 108, '2015-04-01 00:04:05.000000', 'temperatura', 1198.0000, 'ºC'),
	(119090, 108, '2015-04-01 00:04:06.000000', 'temperatura', 554.0000, 'ºC'),
	(119091, 108, '2015-04-01 00:04:07.000000', 'temperatura', 375.0000, 'ºC'),
	(119092, 108, '2015-04-01 00:04:08.000000', 'temperatura', 216.0000, 'ºC'),
	(119093, 108, '2015-04-01 00:04:09.000000', 'temperatura', 1157.0000, 'ºC'),
	(119094, 108, '2015-04-01 00:04:10.000000', 'temperatura', 334.0000, 'ºC'),
	(119095, 108, '2015-04-01 00:04:11.000000', 'temperatura', 602.0000, 'ºC'),
	(119096, 108, '2015-04-01 00:04:12.000000', 'temperatura', 807.0000, 'ºC'),
	(119097, 108, '2015-04-01 00:04:13.000000', 'temperatura', 1032.0000, 'ºC'),
	(119098, 108, '2015-04-01 00:04:14.000000', 'temperatura', 339.0000, 'ºC'),
	(119099, 108, '2015-04-01 00:04:15.000000', 'temperatura', 998.0000, 'ºC'),
	(119100, 108, '2015-04-01 00:04:16.000000', 'temperatura', 373.0000, 'ºC'),
	(119101, 108, '2015-04-01 00:04:17.000000', 'temperatura', 74.0000, 'ºC'),
	(119102, 108, '2015-04-01 00:04:18.000000', 'temperatura', 451.0000, 'ºC'),
	(119103, 108, '2015-04-01 00:04:19.000000', 'temperatura', 831.0000, 'ºC'),
	(119104, 108, '2015-04-01 00:04:20.000000', 'temperatura', 404.0000, 'ºC'),
	(119105, 108, '2015-04-01 00:04:21.000000', 'temperatura', 729.0000, 'ºC'),
	(119106, 108, '2015-04-01 00:04:22.000000', 'temperatura', 33.0000, 'ºC'),
	(119107, 108, '2015-04-01 00:04:23.000000', 'temperatura', 379.0000, 'ºC'),
	(119108, 108, '2015-04-01 00:04:24.000000', 'temperatura', 597.0000, 'ºC'),
	(119109, 108, '2015-04-01 00:04:25.000000', 'temperatura', 649.0000, 'ºC'),
	(119110, 108, '2015-04-01 00:04:26.000000', 'temperatura', 252.0000, 'ºC'),
	(119111, 108, '2015-04-01 00:04:27.000000', 'temperatura', 514.0000, 'ºC'),
	(119112, 108, '2015-04-01 00:04:28.000000', 'temperatura', 617.0000, 'ºC'),
	(119113, 108, '2015-04-01 00:04:29.000000', 'temperatura', 342.0000, 'ºC'),
	(119114, 108, '2015-04-01 00:04:30.000000', 'temperatura', 1057.0000, 'ºC'),
	(119115, 108, '2015-04-01 00:04:31.000000', 'temperatura', 663.0000, 'ºC'),
	(119116, 108, '2015-04-01 00:04:32.000000', 'temperatura', 144.0000, 'ºC'),
	(119117, 108, '2015-04-01 00:04:33.000000', 'temperatura', 1133.0000, 'ºC'),
	(119118, 108, '2015-04-01 00:04:34.000000', 'temperatura', 432.0000, 'ºC'),
	(119119, 108, '2015-04-01 00:04:35.000000', 'temperatura', 1162.0000, 'ºC'),
	(119120, 108, '2015-04-01 00:04:36.000000', 'temperatura', 912.0000, 'ºC'),
	(119121, 108, '2015-04-01 00:04:37.000000', 'temperatura', 1077.0000, 'ºC'),
	(119122, 108, '2015-04-01 00:04:38.000000', 'temperatura', 248.0000, 'ºC'),
	(119123, 108, '2015-04-01 00:04:39.000000', 'temperatura', 412.0000, 'ºC'),
	(119124, 108, '2015-04-01 00:04:40.000000', 'temperatura', 115.0000, 'ºC'),
	(119125, 108, '2015-04-01 00:04:41.000000', 'temperatura', 540.0000, 'ºC'),
	(119126, 108, '2015-04-01 00:04:42.000000', 'temperatura', 1155.0000, 'ºC'),
	(119127, 108, '2015-04-01 00:04:43.000000', 'temperatura', 554.0000, 'ºC'),
	(119128, 108, '2015-04-01 00:04:44.000000', 'temperatura', 506.0000, 'ºC'),
	(119129, 108, '2015-04-01 00:04:45.000000', 'temperatura', 870.0000, 'ºC'),
	(119130, 108, '2015-04-01 00:04:46.000000', 'temperatura', 432.0000, 'ºC'),
	(119131, 108, '2015-04-01 00:04:47.000000', 'temperatura', 749.0000, 'ºC'),
	(119132, 108, '2015-04-01 00:04:48.000000', 'temperatura', 51.0000, 'ºC'),
	(119133, 108, '2015-04-01 00:04:49.000000', 'temperatura', 406.0000, 'ºC'),
	(119134, 108, '2015-04-01 00:04:50.000000', 'temperatura', 680.0000, 'ºC'),
	(119135, 108, '2015-04-01 00:04:51.000000', 'temperatura', 981.0000, 'ºC'),
	(119136, 108, '2015-04-01 00:04:52.000000', 'temperatura', 466.0000, 'ºC'),
	(119137, 108, '2015-04-01 00:04:53.000000', 'temperatura', 586.0000, 'ºC'),
	(119138, 108, '2015-04-01 00:04:54.000000', 'temperatura', 334.0000, 'ºC'),
	(119139, 108, '2015-04-01 00:04:55.000000', 'temperatura', 1111.0000, 'ºC'),
	(119140, 108, '2015-04-01 00:04:56.000000', 'temperatura', 954.0000, 'ºC'),
	(119141, 108, '2015-04-01 00:04:57.000000', 'temperatura', 236.0000, 'ºC'),
	(119142, 108, '2015-04-01 00:04:58.000000', 'temperatura', 722.0000, 'ºC'),
	(119143, 108, '2015-04-01 00:04:59.000000', 'temperatura', 500.0000, 'ºC'),
	(119144, 108, '2015-04-01 00:05:00.000000', 'temperatura', 333.0000, 'ºC'),
	(119145, 108, '2015-04-01 00:05:01.000000', 'temperatura', 168.0000, 'ºC'),
	(119146, 108, '2015-04-01 00:05:02.000000', 'temperatura', 1040.0000, 'ºC'),
	(119147, 108, '2015-04-01 00:05:03.000000', 'temperatura', 1098.0000, 'ºC'),
	(119148, 108, '2015-04-01 00:05:04.000000', 'temperatura', 1171.0000, 'ºC'),
	(119149, 108, '2015-04-01 00:05:05.000000', 'temperatura', 161.0000, 'ºC'),
	(119150, 108, '2015-04-01 00:05:06.000000', 'temperatura', 890.0000, 'ºC'),
	(119151, 108, '2015-04-01 00:05:07.000000', 'temperatura', 370.0000, 'ºC'),
	(119152, 108, '2015-04-01 00:05:08.000000', 'temperatura', 381.0000, 'ºC'),
	(119153, 108, '2015-04-01 00:05:09.000000', 'temperatura', 793.0000, 'ºC'),
	(119154, 108, '2015-04-01 00:05:10.000000', 'temperatura', 426.0000, 'ºC'),
	(119155, 108, '2015-04-01 00:05:11.000000', 'temperatura', 948.0000, 'ºC'),
	(119156, 108, '2015-04-01 00:05:12.000000', 'temperatura', 1064.0000, 'ºC'),
	(119157, 108, '2015-04-01 00:05:13.000000', 'temperatura', 76.0000, 'ºC'),
	(119158, 108, '2015-04-01 00:05:14.000000', 'temperatura', 791.0000, 'ºC'),
	(119159, 108, '2015-04-01 00:05:15.000000', 'temperatura', 125.0000, 'ºC'),
	(119160, 108, '2015-04-01 00:05:16.000000', 'temperatura', 655.0000, 'ºC'),
	(119161, 108, '2015-04-01 00:05:17.000000', 'temperatura', 497.0000, 'ºC'),
	(119162, 108, '2015-04-01 00:05:18.000000', 'temperatura', 523.0000, 'ºC'),
	(119163, 108, '2015-04-01 00:05:19.000000', 'temperatura', 1124.0000, 'ºC'),
	(119164, 108, '2015-04-01 00:05:20.000000', 'temperatura', 451.0000, 'ºC'),
	(119165, 108, '2015-04-01 00:05:21.000000', 'temperatura', 86.0000, 'ºC'),
	(119166, 108, '2015-04-01 00:05:22.000000', 'temperatura', 274.0000, 'ºC'),
	(119167, 108, '2015-04-01 00:05:23.000000', 'temperatura', 1115.0000, 'ºC'),
	(119168, 108, '2015-04-01 00:05:24.000000', 'temperatura', 1153.0000, 'ºC'),
	(119169, 108, '2015-04-01 00:05:25.000000', 'temperatura', 20.0000, 'ºC'),
	(119170, 108, '2015-04-01 00:05:26.000000', 'temperatura', 241.0000, 'ºC'),
	(119171, 108, '2015-04-01 00:05:27.000000', 'temperatura', 1146.0000, 'ºC'),
	(119172, 108, '2015-04-01 00:05:28.000000', 'temperatura', 206.0000, 'ºC'),
	(119173, 108, '2015-04-01 00:05:29.000000', 'temperatura', 1192.0000, 'ºC'),
	(119174, 108, '2015-04-01 00:05:30.000000', 'temperatura', 545.0000, 'ºC'),
	(119175, 108, '2015-04-01 00:05:31.000000', 'temperatura', 347.0000, 'ºC'),
	(119176, 108, '2015-04-01 00:05:32.000000', 'temperatura', 103.0000, 'ºC'),
	(119177, 108, '2015-04-01 00:05:33.000000', 'temperatura', 674.0000, 'ºC'),
	(119178, 108, '2015-04-01 00:05:34.000000', 'temperatura', 663.0000, 'ºC'),
	(119179, 108, '2015-04-01 00:05:35.000000', 'temperatura', 91.0000, 'ºC'),
	(119180, 108, '2015-04-01 00:05:36.000000', 'temperatura', 869.0000, 'ºC'),
	(119181, 108, '2015-04-01 00:05:37.000000', 'temperatura', 473.0000, 'ºC'),
	(119182, 108, '2015-04-01 00:05:38.000000', 'temperatura', 957.0000, 'ºC'),
	(119183, 108, '2015-04-01 00:05:39.000000', 'temperatura', 965.0000, 'ºC'),
	(119184, 108, '2015-04-01 00:05:40.000000', 'temperatura', 757.0000, 'ºC'),
	(119185, 108, '2015-04-01 00:05:41.000000', 'temperatura', 889.0000, 'ºC'),
	(119186, 108, '2015-04-01 00:05:42.000000', 'temperatura', 973.0000, 'ºC'),
	(119187, 108, '2015-04-01 00:05:43.000000', 'temperatura', 1000.0000, 'ºC'),
	(119188, 108, '2015-04-01 00:05:44.000000', 'temperatura', 881.0000, 'ºC'),
	(119189, 108, '2015-04-01 00:05:45.000000', 'temperatura', 206.0000, 'ºC'),
	(119190, 108, '2015-04-01 00:05:46.000000', 'temperatura', 788.0000, 'ºC'),
	(119191, 108, '2015-04-01 00:05:47.000000', 'temperatura', 923.0000, 'ºC'),
	(119192, 108, '2015-04-01 00:05:48.000000', 'temperatura', 1051.0000, 'ºC'),
	(119193, 108, '2015-04-01 00:05:49.000000', 'temperatura', 87.0000, 'ºC'),
	(119194, 108, '2015-04-01 00:05:50.000000', 'temperatura', 883.0000, 'ºC'),
	(119195, 108, '2015-04-01 00:05:51.000000', 'temperatura', 553.0000, 'ºC'),
	(119196, 108, '2015-04-01 00:05:52.000000', 'temperatura', 119.0000, 'ºC'),
	(119197, 108, '2015-04-01 00:05:53.000000', 'temperatura', 134.0000, 'ºC'),
	(119198, 108, '2015-04-01 00:05:54.000000', 'temperatura', 316.0000, 'ºC'),
	(119199, 108, '2015-04-01 00:05:55.000000', 'temperatura', 1176.0000, 'ºC'),
	(119200, 108, '2015-04-01 00:05:56.000000', 'temperatura', 132.0000, 'ºC'),
	(119201, 108, '2015-04-01 00:05:57.000000', 'temperatura', 734.0000, 'ºC'),
	(119202, 108, '2015-04-01 00:05:58.000000', 'temperatura', 876.0000, 'ºC'),
	(119203, 108, '2015-04-01 00:05:59.000000', 'temperatura', 976.0000, 'ºC'),
	(119204, 108, '2015-04-01 00:06:00.000000', 'temperatura', 1053.0000, 'ºC'),
	(119205, 108, '2015-04-01 00:06:01.000000', 'temperatura', 1139.0000, 'ºC'),
	(119206, 108, '2015-04-01 00:06:02.000000', 'temperatura', 138.0000, 'ºC'),
	(119207, 108, '2015-04-01 00:06:03.000000', 'temperatura', 870.0000, 'ºC'),
	(119208, 108, '2015-04-01 00:06:04.000000', 'temperatura', 338.0000, 'ºC'),
	(119209, 108, '2015-04-01 00:06:05.000000', 'temperatura', 280.0000, 'ºC'),
	(119210, 108, '2015-04-01 00:06:06.000000', 'temperatura', 385.0000, 'ºC'),
	(119211, 108, '2015-04-01 00:06:07.000000', 'temperatura', 1088.0000, 'ºC'),
	(119212, 108, '2015-04-01 00:06:08.000000', 'temperatura', 685.0000, 'ºC'),
	(119213, 108, '2015-04-01 00:06:09.000000', 'temperatura', 161.0000, 'ºC'),
	(119214, 108, '2015-04-01 00:06:10.000000', 'temperatura', 1149.0000, 'ºC'),
	(119215, 108, '2015-04-01 00:06:11.000000', 'temperatura', 463.0000, 'ºC'),
	(119216, 108, '2015-04-01 00:06:12.000000', 'temperatura', 70.0000, 'ºC'),
	(119217, 108, '2015-04-01 00:06:13.000000', 'temperatura', 159.0000, 'ºC'),
	(119218, 108, '2015-04-01 00:06:14.000000', 'temperatura', 585.0000, 'ºC'),
	(119219, 108, '2015-04-01 00:06:15.000000', 'temperatura', 51.0000, 'ºC'),
	(119220, 108, '2015-04-01 00:06:16.000000', 'temperatura', 898.0000, 'ºC'),
	(119221, 108, '2015-04-01 00:06:17.000000', 'temperatura', 737.0000, 'ºC'),
	(119222, 108, '2015-04-01 00:06:18.000000', 'temperatura', 993.0000, 'ºC'),
	(119223, 108, '2015-04-01 00:06:19.000000', 'temperatura', 355.0000, 'ºC'),
	(119224, 108, '2015-04-01 00:06:20.000000', 'temperatura', 1195.0000, 'ºC'),
	(119225, 108, '2015-04-01 00:06:21.000000', 'temperatura', 111.0000, 'ºC'),
	(119226, 108, '2015-04-01 00:06:22.000000', 'temperatura', 571.0000, 'ºC'),
	(119227, 108, '2015-04-01 00:06:23.000000', 'temperatura', 121.0000, 'ºC'),
	(119228, 108, '2015-04-01 00:06:24.000000', 'temperatura', 95.0000, 'ºC'),
	(119229, 108, '2015-04-01 00:06:25.000000', 'temperatura', 111.0000, 'ºC'),
	(119230, 108, '2015-04-01 00:06:26.000000', 'temperatura', 270.0000, 'ºC'),
	(119231, 108, '2015-04-01 00:06:27.000000', 'temperatura', 1018.0000, 'ºC'),
	(119232, 108, '2015-04-01 00:06:28.000000', 'temperatura', 679.0000, 'ºC'),
	(119233, 108, '2015-04-01 00:06:29.000000', 'temperatura', 343.0000, 'ºC'),
	(119234, 108, '2015-04-01 00:06:30.000000', 'temperatura', 877.0000, 'ºC'),
	(119235, 108, '2015-04-01 00:06:31.000000', 'temperatura', 959.0000, 'ºC'),
	(119236, 108, '2015-04-01 00:06:32.000000', 'temperatura', 964.0000, 'ºC'),
	(119237, 108, '2015-04-01 00:06:33.000000', 'temperatura', 743.0000, 'ºC'),
	(119238, 108, '2015-04-01 00:06:34.000000', 'temperatura', 822.0000, 'ºC'),
	(119239, 108, '2015-04-01 00:06:35.000000', 'temperatura', 680.0000, 'ºC'),
	(119240, 108, '2015-04-01 00:06:36.000000', 'temperatura', 938.0000, 'ºC'),
	(119241, 108, '2015-04-01 00:06:37.000000', 'temperatura', 250.0000, 'ºC'),
	(119242, 108, '2015-04-01 00:06:38.000000', 'temperatura', 837.0000, 'ºC'),
	(119243, 108, '2015-04-01 00:06:39.000000', 'temperatura', 1033.0000, 'ºC'),
	(119244, 108, '2015-04-01 00:06:40.000000', 'temperatura', 255.0000, 'ºC'),
	(119245, 108, '2015-04-01 00:06:41.000000', 'temperatura', 578.0000, 'ºC'),
	(119246, 108, '2015-04-01 00:06:42.000000', 'temperatura', 923.0000, 'ºC'),
	(119247, 108, '2015-04-01 00:06:43.000000', 'temperatura', 482.0000, 'ºC'),
	(119248, 108, '2015-04-01 00:06:44.000000', 'temperatura', 844.0000, 'ºC'),
	(119249, 108, '2015-04-01 00:06:45.000000', 'temperatura', 373.0000, 'ºC'),
	(119250, 108, '2015-04-01 00:06:46.000000', 'temperatura', 531.0000, 'ºC'),
	(119251, 108, '2015-04-01 00:06:47.000000', 'temperatura', 340.0000, 'ºC'),
	(119252, 108, '2015-04-01 00:06:48.000000', 'temperatura', 108.0000, 'ºC'),
	(119253, 108, '2015-04-01 00:06:49.000000', 'temperatura', 718.0000, 'ºC'),
	(119254, 108, '2015-04-01 00:06:50.000000', 'temperatura', 869.0000, 'ºC'),
	(119255, 108, '2015-04-01 00:06:51.000000', 'temperatura', 990.0000, 'ºC'),
	(119256, 108, '2015-04-01 00:06:52.000000', 'temperatura', 1142.0000, 'ºC'),
	(119257, 108, '2015-04-01 00:06:53.000000', 'temperatura', 342.0000, 'ºC'),
	(119258, 108, '2015-04-01 00:06:54.000000', 'temperatura', 686.0000, 'ºC'),
	(119259, 108, '2015-04-01 00:06:55.000000', 'temperatura', 2.0000, 'ºC'),
	(119260, 108, '2015-04-01 00:06:56.000000', 'temperatura', 354.0000, 'ºC'),
	(119261, 108, '2015-04-01 00:06:57.000000', 'temperatura', 563.0000, 'ºC'),
	(119262, 108, '2015-04-01 00:06:58.000000', 'temperatura', 556.0000, 'ºC'),
	(119263, 108, '2015-04-01 00:06:59.000000', 'temperatura', 1092.0000, 'ºC'),
	(119264, 108, '2015-04-01 00:07:00.000000', 'temperatura', 189.0000, 'ºC'),
	(119265, 108, '2015-04-01 00:07:01.000000', 'temperatura', 73.0000, 'ºC'),
	(119266, 108, '2015-04-01 00:07:02.000000', 'temperatura', 996.0000, 'ºC'),
	(119267, 108, '2015-04-01 00:07:03.000000', 'temperatura', 1163.0000, 'ºC'),
	(119268, 108, '2015-04-01 00:07:04.000000', 'temperatura', 428.0000, 'ºC'),
	(119269, 108, '2015-04-01 00:07:05.000000', 'temperatura', 1052.0000, 'ºC'),
	(119270, 108, '2015-04-01 00:07:06.000000', 'temperatura', 376.0000, 'ºC'),
	(119271, 108, '2015-04-01 00:07:07.000000', 'temperatura', 1125.0000, 'ºC'),
	(119272, 108, '2015-04-01 00:07:08.000000', 'temperatura', 898.0000, 'ºC'),
	(119273, 108, '2015-04-01 00:07:09.000000', 'temperatura', 1114.0000, 'ºC'),
	(119274, 108, '2015-04-01 00:07:10.000000', 'temperatura', 477.0000, 'ºC'),
	(119275, 108, '2015-04-01 00:07:11.000000', 'temperatura', 244.0000, 'ºC'),
	(119276, 108, '2015-04-01 00:07:12.000000', 'temperatura', 991.0000, 'ºC'),
	(119277, 108, '2015-04-01 00:07:13.000000', 'temperatura', 623.0000, 'ºC'),
	(119278, 108, '2015-04-01 00:07:14.000000', 'temperatura', 144.0000, 'ºC'),
	(119279, 108, '2015-04-01 00:07:15.000000', 'temperatura', 48.0000, 'ºC'),
	(119280, 108, '2015-04-01 00:07:16.000000', 'temperatura', 1011.0000, 'ºC'),
	(119281, 108, '2015-04-01 00:07:17.000000', 'temperatura', 110.0000, 'ºC'),
	(119282, 108, '2015-04-01 00:07:18.000000', 'temperatura', 1117.0000, 'ºC'),
	(119283, 108, '2015-04-01 00:07:19.000000', 'temperatura', 456.0000, 'ºC'),
	(119284, 108, '2015-04-01 00:07:20.000000', 'temperatura', 129.0000, 'ºC'),
	(119285, 108, '2015-04-01 00:07:21.000000', 'temperatura', 478.0000, 'ºC'),
	(119286, 108, '2015-04-01 00:07:22.000000', 'temperatura', 803.0000, 'ºC'),
	(119287, 108, '2015-04-01 00:07:23.000000', 'temperatura', 182.0000, 'ºC'),
	(119288, 108, '2015-04-01 00:07:24.000000', 'temperatura', 903.0000, 'ºC'),
	(119289, 108, '2015-04-01 00:07:25.000000', 'temperatura', 370.0000, 'ºC'),
	(119290, 108, '2015-04-01 00:07:26.000000', 'temperatura', 338.0000, 'ºC'),
	(119291, 108, '2015-04-01 00:07:27.000000', 'temperatura', 583.0000, 'ºC'),
	(119292, 108, '2015-04-01 00:07:28.000000', 'temperatura', 703.0000, 'ºC'),
	(119293, 108, '2015-04-01 00:07:29.000000', 'temperatura', 564.0000, 'ºC'),
	(119294, 108, '2015-04-01 00:07:30.000000', 'temperatura', 710.0000, 'ºC'),
	(119295, 108, '2015-04-01 00:07:31.000000', 'temperatura', 661.0000, 'ºC'),
	(119296, 108, '2015-04-01 00:07:32.000000', 'temperatura', 1173.0000, 'ºC'),
	(119297, 108, '2015-04-01 00:07:33.000000', 'temperatura', 284.0000, 'ºC'),
	(119298, 108, '2015-04-01 00:07:34.000000', 'temperatura', 299.0000, 'ºC'),
	(119299, 108, '2015-04-01 00:07:35.000000', 'temperatura', 646.0000, 'ºC'),
	(119300, 108, '2015-04-01 00:07:36.000000', 'temperatura', 1133.0000, 'ºC'),
	(119301, 108, '2015-04-01 00:07:37.000000', 'temperatura', 128.0000, 'ºC'),
	(119302, 108, '2015-04-01 00:07:38.000000', 'temperatura', 839.0000, 'ºC'),
	(119303, 108, '2015-04-01 00:07:39.000000', 'temperatura', 214.0000, 'ºC'),
	(119304, 108, '2015-04-01 00:07:40.000000', 'temperatura', 955.0000, 'ºC'),
	(119305, 108, '2015-04-01 00:07:41.000000', 'temperatura', 531.0000, 'ºC'),
	(119306, 108, '2015-04-01 00:07:42.000000', 'temperatura', 992.0000, 'ºC'),
	(119307, 108, '2015-04-01 00:07:43.000000', 'temperatura', 967.0000, 'ºC'),
	(119308, 108, '2015-04-01 00:07:44.000000', 'temperatura', 657.0000, 'ºC'),
	(119309, 108, '2015-04-01 00:07:45.000000', 'temperatura', 388.0000, 'ºC'),
	(119310, 108, '2015-04-01 00:07:46.000000', 'temperatura', 1168.0000, 'ºC'),
	(119311, 108, '2015-04-01 00:07:47.000000', 'temperatura', 1077.0000, 'ºC'),
	(119312, 108, '2015-04-01 00:07:48.000000', 'temperatura', 679.0000, 'ºC'),
	(119313, 108, '2015-04-01 00:07:49.000000', 'temperatura', 167.0000, 'ºC'),
	(119314, 108, '2015-04-01 00:07:50.000000', 'temperatura', 1196.0000, 'ºC'),
	(119315, 108, '2015-04-01 00:07:51.000000', 'temperatura', 682.0000, 'ºC'),
	(119316, 108, '2015-04-01 00:07:52.000000', 'temperatura', 1020.0000, 'ºC'),
	(119317, 108, '2015-04-01 00:07:53.000000', 'temperatura', 656.0000, 'ºC'),
	(119318, 108, '2015-04-01 00:07:54.000000', 'temperatura', 220.0000, 'ºC'),
	(119319, 108, '2015-04-01 00:07:55.000000', 'temperatura', 332.0000, 'ºC'),
	(119320, 108, '2015-04-01 00:07:56.000000', 'temperatura', 1000.0000, 'ºC'),
	(119321, 108, '2015-04-01 00:07:57.000000', 'temperatura', 406.0000, 'ºC'),
	(119322, 108, '2015-04-01 00:07:58.000000', 'temperatura', 229.0000, 'ºC'),
	(119323, 108, '2015-04-01 00:07:59.000000', 'temperatura', 1130.0000, 'ºC'),
	(119324, 108, '2015-04-01 00:08:00.000000', 'temperatura', 163.0000, 'ºC'),
	(119325, 108, '2015-04-01 00:08:01.000000', 'temperatura', 1024.0000, 'ºC'),
	(119326, 108, '2015-04-01 00:08:02.000000', 'temperatura', 1034.0000, 'ºC'),
	(119327, 108, '2015-04-01 00:08:03.000000', 'temperatura', 898.0000, 'ºC'),
	(119328, 108, '2015-04-01 00:08:04.000000', 'temperatura', 190.0000, 'ºC'),
	(119329, 108, '2015-04-01 00:08:05.000000', 'temperatura', 653.0000, 'ºC'),
	(119330, 108, '2015-04-01 00:08:06.000000', 'temperatura', 299.0000, 'ºC'),
	(119331, 108, '2015-04-01 00:08:07.000000', 'temperatura', 733.0000, 'ºC'),
	(119332, 108, '2015-04-01 00:08:08.000000', 'temperatura', 370.0000, 'ºC'),
	(119333, 108, '2015-04-01 00:08:09.000000', 'temperatura', 850.0000, 'ºC'),
	(119334, 108, '2015-04-01 00:08:10.000000', 'temperatura', 743.0000, 'ºC'),
	(119335, 108, '2015-04-01 00:08:11.000000', 'temperatura', 1166.0000, 'ºC'),
	(119336, 108, '2015-04-01 00:08:12.000000', 'temperatura', 2.0000, 'ºC'),
	(119337, 108, '2015-04-01 00:08:13.000000', 'temperatura', 111.0000, 'ºC'),
	(119338, 108, '2015-04-01 00:08:14.000000', 'temperatura', 550.0000, 'ºC'),
	(119339, 108, '2015-04-01 00:08:15.000000', 'temperatura', 17.0000, 'ºC'),
	(119340, 108, '2015-04-01 00:08:16.000000', 'temperatura', 837.0000, 'ºC'),
	(119341, 108, '2015-04-01 00:08:17.000000', 'temperatura', 534.0000, 'ºC'),
	(119342, 108, '2015-04-01 00:08:18.000000', 'temperatura', 158.0000, 'ºC'),
	(119343, 108, '2015-04-01 00:08:19.000000', 'temperatura', 388.0000, 'ºC'),
	(119344, 108, '2015-04-01 00:08:20.000000', 'temperatura', 266.0000, 'ºC'),
	(119345, 108, '2015-04-01 00:08:21.000000', 'temperatura', 170.0000, 'ºC'),
	(119346, 108, '2015-04-01 00:08:22.000000', 'temperatura', 49.0000, 'ºC'),
	(119347, 108, '2015-04-01 00:08:23.000000', 'temperatura', 937.0000, 'ºC'),
	(119348, 108, '2015-04-01 00:08:24.000000', 'temperatura', 940.0000, 'ºC'),
	(119349, 108, '2015-04-01 00:08:25.000000', 'temperatura', 690.0000, 'ºC'),
	(119350, 108, '2015-04-01 00:08:26.000000', 'temperatura', 629.0000, 'ºC'),
	(119351, 108, '2015-04-01 00:08:27.000000', 'temperatura', 1077.0000, 'ºC'),
	(119352, 108, '2015-04-01 00:08:28.000000', 'temperatura', 1096.0000, 'ºC'),
	(119353, 108, '2015-04-01 00:08:29.000000', 'temperatura', 1052.0000, 'ºC'),
	(119354, 108, '2015-04-01 00:08:30.000000', 'temperatura', 770.0000, 'ºC'),
	(119355, 108, '2015-04-01 00:08:31.000000', 'temperatura', 695.0000, 'ºC'),
	(119356, 108, '2015-04-01 00:08:32.000000', 'temperatura', 1165.0000, 'ºC'),
	(119357, 108, '2015-04-01 00:08:33.000000', 'temperatura', 140.0000, 'ºC'),
	(119358, 108, '2015-04-01 00:08:34.000000', 'temperatura', 808.0000, 'ºC'),
	(119359, 108, '2015-04-01 00:08:35.000000', 'temperatura', 19.0000, 'ºC'),
	(119360, 108, '2015-04-01 00:08:36.000000', 'temperatura', 72.0000, 'ºC'),
	(119361, 108, '2015-04-01 00:08:37.000000', 'temperatura', 305.0000, 'ºC'),
	(119362, 108, '2015-04-01 00:08:38.000000', 'temperatura', 110.0000, 'ºC'),
	(119363, 108, '2015-04-01 00:08:39.000000', 'temperatura', 834.0000, 'ºC'),
	(119364, 108, '2015-04-01 00:08:40.000000', 'temperatura', 241.0000, 'ºC'),
	(119365, 108, '2015-04-01 00:08:41.000000', 'temperatura', 1103.0000, 'ºC'),
	(119366, 108, '2015-04-01 00:08:42.000000', 'temperatura', 1194.0000, 'ºC'),
	(119367, 108, '2015-04-01 00:08:43.000000', 'temperatura', 260.0000, 'ºC'),
	(119368, 108, '2015-04-01 00:08:44.000000', 'temperatura', 118.0000, 'ºC'),
	(119369, 108, '2015-04-01 00:08:45.000000', 'temperatura', 1013.0000, 'ºC'),
	(119370, 108, '2015-04-01 00:08:46.000000', 'temperatura', 1110.0000, 'ºC'),
	(119371, 108, '2015-04-01 00:08:47.000000', 'temperatura', 110.0000, 'ºC'),
	(119372, 108, '2015-04-01 00:08:48.000000', 'temperatura', 820.0000, 'ºC'),
	(119373, 108, '2015-04-01 00:08:49.000000', 'temperatura', 171.0000, 'ºC'),
	(119374, 108, '2015-04-01 00:08:50.000000', 'temperatura', 794.0000, 'ºC'),
	(119375, 108, '2015-04-01 00:08:51.000000', 'temperatura', 1059.0000, 'ºC'),
	(119376, 108, '2015-04-01 00:08:52.000000', 'temperatura', 512.0000, 'ºC'),
	(119377, 108, '2015-04-01 00:08:53.000000', 'temperatura', 586.0000, 'ºC'),
	(119378, 108, '2015-04-01 00:08:54.000000', 'temperatura', 195.0000, 'ºC'),
	(119379, 108, '2015-04-01 00:08:55.000000', 'temperatura', 418.0000, 'ºC'),
	(119380, 108, '2015-04-01 00:08:56.000000', 'temperatura', 305.0000, 'ºC'),
	(119381, 108, '2015-04-01 00:08:57.000000', 'temperatura', 271.0000, 'ºC'),
	(119382, 108, '2015-04-01 00:08:58.000000', 'temperatura', 442.0000, 'ºC'),
	(119383, 108, '2015-04-01 00:08:59.000000', 'temperatura', 196.0000, 'ºC'),
	(119384, 108, '2015-04-01 00:09:00.000000', 'temperatura', 854.0000, 'ºC'),
	(119385, 108, '2015-04-01 00:09:01.000000', 'temperatura', 85.0000, 'ºC'),
	(119386, 108, '2015-04-01 00:09:02.000000', 'temperatura', 263.0000, 'ºC'),
	(119387, 108, '2015-04-01 00:09:03.000000', 'temperatura', 1060.0000, 'ºC'),
	(119388, 108, '2015-04-01 00:09:04.000000', 'temperatura', 913.0000, 'ºC'),
	(119389, 108, '2015-04-01 00:09:05.000000', 'temperatura', 186.0000, 'ºC'),
	(119390, 108, '2015-04-01 00:09:06.000000', 'temperatura', 590.0000, 'ºC'),
	(119391, 108, '2015-04-01 00:09:07.000000', 'temperatura', 1191.0000, 'ºC'),
	(119392, 108, '2015-04-01 00:09:08.000000', 'temperatura', 586.0000, 'ºC'),
	(119393, 108, '2015-04-01 00:09:09.000000', 'temperatura', 557.0000, 'ºC'),
	(119394, 108, '2015-04-01 00:09:10.000000', 'temperatura', 1028.0000, 'ºC'),
	(119395, 108, '2015-04-01 00:09:11.000000', 'temperatura', 1070.0000, 'ºC'),
	(119396, 108, '2015-04-01 00:09:12.000000', 'temperatura', 1068.0000, 'ºC'),
	(119397, 108, '2015-04-01 00:09:13.000000', 'temperatura', 931.0000, 'ºC'),
	(119398, 108, '2015-04-01 00:09:14.000000', 'temperatura', 249.0000, 'ºC'),
	(119399, 108, '2015-04-01 00:09:15.000000', 'temperatura', 854.0000, 'ºC'),
	(119400, 108, '2015-04-01 00:09:16.000000', 'temperatura', 1124.0000, 'ºC'),
	(119401, 108, '2015-04-01 00:09:17.000000', 'temperatura', 656.0000, 'ºC'),
	(119402, 108, '2015-04-01 00:09:18.000000', 'temperatura', 1110.0000, 'ºC'),
	(119403, 108, '2015-04-01 00:09:19.000000', 'temperatura', 1183.0000, 'ºC'),
	(119404, 108, '2015-04-01 00:09:20.000000', 'temperatura', 184.0000, 'ºC'),
	(119405, 108, '2015-04-01 00:09:21.000000', 'temperatura', 971.0000, 'ºC'),
	(119406, 108, '2015-04-01 00:09:22.000000', 'temperatura', 704.0000, 'ºC'),
	(119407, 108, '2015-04-01 00:09:23.000000', 'temperatura', 607.0000, 'ºC'),
	(119408, 108, '2015-04-01 00:09:24.000000', 'temperatura', 922.0000, 'ºC'),
	(119409, 108, '2015-04-01 00:09:25.000000', 'temperatura', 391.0000, 'ºC'),
	(119410, 108, '2015-04-01 00:09:26.000000', 'temperatura', 390.0000, 'ºC'),
	(119411, 108, '2015-04-01 00:09:27.000000', 'temperatura', 776.0000, 'ºC'),
	(119412, 108, '2015-04-01 00:09:28.000000', 'temperatura', 312.0000, 'ºC'),
	(119413, 108, '2015-04-01 00:09:29.000000', 'temperatura', 433.0000, 'ºC'),
	(119414, 108, '2015-04-01 00:09:30.000000', 'temperatura', 28.0000, 'ºC'),
	(119415, 108, '2015-04-01 00:09:31.000000', 'temperatura', 43.0000, 'ºC'),
	(119416, 108, '2015-04-01 00:09:32.000000', 'temperatura', 129.0000, 'ºC'),
	(119417, 108, '2015-04-01 00:09:33.000000', 'temperatura', 517.0000, 'ºC'),
	(119418, 108, '2015-04-01 00:09:34.000000', 'temperatura', 998.0000, 'ºC'),
	(119419, 108, '2015-04-01 00:09:35.000000', 'temperatura', 1042.0000, 'ºC'),
	(119420, 108, '2015-04-01 00:09:36.000000', 'temperatura', 1015.0000, 'ºC'),
	(119421, 108, '2015-04-01 00:09:37.000000', 'temperatura', 752.0000, 'ºC'),
	(119422, 108, '2015-04-01 00:09:38.000000', 'temperatura', 713.0000, 'ºC'),
	(119423, 108, '2015-04-01 00:09:39.000000', 'temperatura', 111.0000, 'ºC'),
	(119424, 108, '2015-04-01 00:09:40.000000', 'temperatura', 814.0000, 'ºC'),
	(119425, 108, '2015-04-01 00:09:41.000000', 'temperatura', 139.0000, 'ºC'),
	(119426, 108, '2015-04-01 00:09:42.000000', 'temperatura', 654.0000, 'ºC'),
	(119427, 108, '2015-04-01 00:09:43.000000', 'temperatura', 452.0000, 'ºC'),
	(119428, 108, '2015-04-01 00:09:44.000000', 'temperatura', 298.0000, 'ºC'),
	(119429, 108, '2015-04-01 00:09:45.000000', 'temperatura', 135.0000, 'ºC'),
	(119430, 108, '2015-04-01 00:09:46.000000', 'temperatura', 983.0000, 'ºC'),
	(119431, 108, '2015-04-01 00:09:47.000000', 'temperatura', 908.0000, 'ºC'),
	(119432, 108, '2015-04-01 00:09:48.000000', 'temperatura', 393.0000, 'ºC'),
	(119433, 108, '2015-04-01 00:09:49.000000', 'temperatura', 440.0000, 'ºC'),
	(119434, 108, '2015-04-01 00:09:50.000000', 'temperatura', 1022.0000, 'ºC'),
	(119435, 108, '2015-04-01 00:09:51.000000', 'temperatura', 193.0000, 'ºC'),
	(119436, 108, '2015-04-01 00:09:52.000000', 'temperatura', 296.0000, 'ºC'),
	(119437, 108, '2015-04-01 00:09:53.000000', 'temperatura', 905.0000, 'ºC'),
	(119438, 108, '2015-04-01 00:09:54.000000', 'temperatura', 35.0000, 'ºC'),
	(119439, 108, '2015-04-01 00:09:55.000000', 'temperatura', 1063.0000, 'ºC'),
	(119440, 108, '2015-04-01 00:09:56.000000', 'temperatura', 408.0000, 'ºC'),
	(119441, 108, '2015-04-01 00:09:57.000000', 'temperatura', 51.0000, 'ºC'),
	(119442, 108, '2015-04-01 00:09:58.000000', 'temperatura', 234.0000, 'ºC'),
	(119443, 108, '2015-04-01 00:09:59.000000', 'temperatura', 1017.0000, 'ºC'),
	(119444, 108, '2015-04-01 00:10:00.000000', 'temperatura', 784.0000, 'ºC'),
	(119445, 108, '2015-04-01 00:10:01.000000', 'temperatura', 868.0000, 'ºC'),
	(119446, 108, '2015-04-01 00:10:02.000000', 'temperatura', 788.0000, 'ºC'),
	(119447, 108, '2015-04-01 00:10:03.000000', 'temperatura', 137.0000, 'ºC'),
	(119448, 108, '2015-04-01 00:10:04.000000', 'temperatura', 723.0000, 'ºC'),
	(119449, 108, '2015-04-01 00:10:05.000000', 'temperatura', 805.0000, 'ºC'),
	(119450, 108, '2015-04-01 00:10:06.000000', 'temperatura', 654.0000, 'ºC'),
	(119451, 108, '2015-04-01 00:10:07.000000', 'temperatura', 857.0000, 'ºC'),
	(119452, 108, '2015-04-01 00:10:08.000000', 'temperatura', 1122.0000, 'ºC'),
	(119453, 108, '2015-04-01 00:10:09.000000', 'temperatura', 642.0000, 'ºC'),
	(119454, 108, '2015-04-01 00:10:10.000000', 'temperatura', 1043.0000, 'ºC'),
	(119455, 108, '2015-04-01 00:10:11.000000', 'temperatura', 889.0000, 'ºC'),
	(119456, 108, '2015-04-01 00:10:12.000000', 'temperatura', 117.0000, 'ºC'),
	(119457, 108, '2015-04-01 00:10:13.000000', 'temperatura', 317.0000, 'ºC'),
	(119458, 108, '2015-04-01 00:10:14.000000', 'temperatura', 37.0000, 'ºC'),
	(119459, 108, '2015-04-01 00:10:15.000000', 'temperatura', 434.0000, 'ºC'),
	(119460, 108, '2015-04-01 00:10:16.000000', 'temperatura', 859.0000, 'ºC'),
	(119461, 108, '2015-04-01 00:10:17.000000', 'temperatura', 594.0000, 'ºC'),
	(119462, 108, '2015-04-01 00:10:18.000000', 'temperatura', 392.0000, 'ºC'),
	(119463, 108, '2015-04-01 00:10:19.000000', 'temperatura', 181.0000, 'ºC'),
	(119464, 108, '2015-04-01 00:10:20.000000', 'temperatura', 929.0000, 'ºC'),
	(119465, 108, '2015-04-01 00:10:21.000000', 'temperatura', 503.0000, 'ºC'),
	(119466, 108, '2015-04-01 00:10:22.000000', 'temperatura', 927.0000, 'ºC'),
	(119467, 108, '2015-04-01 00:10:23.000000', 'temperatura', 728.0000, 'ºC'),
	(119468, 108, '2015-04-01 00:10:24.000000', 'temperatura', 859.0000, 'ºC'),
	(119469, 108, '2015-04-01 00:10:25.000000', 'temperatura', 910.0000, 'ºC'),
	(119470, 108, '2015-04-01 00:10:26.000000', 'temperatura', 775.0000, 'ºC'),
	(119471, 108, '2015-04-01 00:10:27.000000', 'temperatura', 1144.0000, 'ºC'),
	(119472, 108, '2015-04-01 00:10:28.000000', 'temperatura', 997.0000, 'ºC'),
	(119473, 108, '2015-04-01 00:10:29.000000', 'temperatura', 354.0000, 'ºC'),
	(119474, 108, '2015-04-01 00:10:30.000000', 'temperatura', 1181.0000, 'ºC'),
	(119475, 108, '2015-04-01 00:10:31.000000', 'temperatura', 41.0000, 'ºC'),
	(119476, 108, '2015-04-01 00:10:32.000000', 'temperatura', 263.0000, 'ºC'),
	(119477, 108, '2015-04-01 00:10:33.000000', 'temperatura', 1192.0000, 'ºC'),
	(119478, 108, '2015-04-01 00:10:34.000000', 'temperatura', 372.0000, 'ºC'),
	(119479, 108, '2015-04-01 00:10:35.000000', 'temperatura', 684.0000, 'ºC'),
	(119480, 108, '2015-04-01 00:10:36.000000', 'temperatura', 1103.0000, 'ºC'),
	(119481, 108, '2015-04-01 00:10:37.000000', 'temperatura', 1066.0000, 'ºC'),
	(119482, 108, '2015-04-01 00:10:38.000000', 'temperatura', 821.0000, 'ºC'),
	(119483, 108, '2015-04-01 00:10:39.000000', 'temperatura', 906.0000, 'ºC'),
	(119484, 108, '2015-04-01 00:10:40.000000', 'temperatura', 870.0000, 'ºC'),
	(119485, 108, '2015-04-01 00:10:41.000000', 'temperatura', 430.0000, 'ºC'),
	(119486, 108, '2015-04-01 00:10:42.000000', 'temperatura', 742.0000, 'ºC'),
	(119487, 108, '2015-04-01 00:10:43.000000', 'temperatura', 21.0000, 'ºC'),
	(119488, 108, '2015-04-01 00:10:44.000000', 'temperatura', 279.0000, 'ºC'),
	(119489, 108, '2015-04-01 00:10:45.000000', 'temperatura', 134.0000, 'ºC'),
	(119490, 108, '2015-04-01 00:10:46.000000', 'temperatura', 1032.0000, 'ºC'),
	(119491, 108, '2015-04-01 00:10:47.000000', 'temperatura', 1158.0000, 'ºC'),
	(119492, 108, '2015-04-01 00:10:48.000000', 'temperatura', 295.0000, 'ºC'),
	(119493, 108, '2015-04-01 00:10:49.000000', 'temperatura', 404.0000, 'ºC'),
	(119494, 108, '2015-04-01 00:10:50.000000', 'temperatura', 1132.0000, 'ºC'),
	(119495, 108, '2015-04-01 00:10:51.000000', 'temperatura', 850.0000, 'ºC'),
	(119496, 108, '2015-04-01 00:10:52.000000', 'temperatura', 856.0000, 'ºC'),
	(119497, 108, '2015-04-01 00:10:53.000000', 'temperatura', 529.0000, 'ºC'),
	(119498, 108, '2015-04-01 00:10:54.000000', 'temperatura', 76.0000, 'ºC'),
	(119499, 108, '2015-04-01 00:10:55.000000', 'temperatura', 1196.0000, 'ºC'),
	(119500, 108, '2015-04-01 00:10:56.000000', 'temperatura', 953.0000, 'ºC'),
	(119501, 108, '2015-04-01 00:10:57.000000', 'temperatura', 1176.0000, 'ºC'),
	(119502, 108, '2015-04-01 00:10:58.000000', 'temperatura', 622.0000, 'ºC'),
	(119503, 108, '2015-04-01 00:10:59.000000', 'temperatura', 782.0000, 'ºC'),
	(119504, 108, '2015-04-01 00:11:00.000000', 'temperatura', 846.0000, 'ºC'),
	(119505, 108, '2015-04-01 00:11:01.000000', 'temperatura', 684.0000, 'ºC'),
	(119506, 108, '2015-04-01 00:11:02.000000', 'temperatura', 881.0000, 'ºC'),
	(119507, 108, '2015-04-01 00:11:03.000000', 'temperatura', 1153.0000, 'ºC'),
	(119508, 108, '2015-04-01 00:11:04.000000', 'temperatura', 723.0000, 'ºC'),
	(119509, 108, '2015-04-01 00:11:05.000000', 'temperatura', 158.0000, 'ºC'),
	(119510, 108, '2015-04-01 00:11:06.000000', 'temperatura', 1020.0000, 'ºC'),
	(119511, 108, '2015-04-01 00:11:07.000000', 'temperatura', 1028.0000, 'ºC'),
	(119512, 108, '2015-04-01 00:11:08.000000', 'temperatura', 882.0000, 'ºC'),
	(119513, 108, '2015-04-01 00:11:09.000000', 'temperatura', 124.0000, 'ºC'),
	(119514, 108, '2015-04-01 00:11:10.000000', 'temperatura', 374.0000, 'ºC'),
	(119515, 108, '2015-04-01 00:11:11.000000', 'temperatura', 298.0000, 'ºC'),
	(119516, 108, '2015-04-01 00:11:12.000000', 'temperatura', 368.0000, 'ºC'),
	(119517, 108, '2015-04-01 00:11:13.000000', 'temperatura', 947.0000, 'ºC'),
	(119518, 108, '2015-04-01 00:11:14.000000', 'temperatura', 32.0000, 'ºC'),
	(119519, 108, '2015-04-01 00:11:15.000000', 'temperatura', 918.0000, 'ºC'),
	(119520, 108, '2015-04-01 00:11:16.000000', 'temperatura', 894.0000, 'ºC'),
	(119521, 108, '2015-04-01 00:11:17.000000', 'temperatura', 517.0000, 'ºC'),
	(119522, 108, '2015-04-01 00:11:18.000000', 'temperatura', 1104.0000, 'ºC'),
	(119523, 108, '2015-04-01 00:11:19.000000', 'temperatura', 372.0000, 'ºC'),
	(119524, 108, '2015-04-01 00:11:20.000000', 'temperatura', 945.0000, 'ºC'),
	(119525, 108, '2015-04-01 00:11:21.000000', 'temperatura', 9.0000, 'ºC'),
	(119526, 108, '2015-04-01 00:11:22.000000', 'temperatura', 813.0000, 'ºC'),
	(119527, 108, '2015-04-01 00:11:23.000000', 'temperatura', 435.0000, 'ºC'),
	(119528, 108, '2015-04-01 00:11:24.000000', 'temperatura', 940.0000, 'ºC'),
	(119529, 108, '2015-04-01 00:11:25.000000', 'temperatura', 996.0000, 'ºC'),
	(119530, 108, '2015-04-01 00:11:26.000000', 'temperatura', 958.0000, 'ºC'),
	(119531, 108, '2015-04-01 00:11:27.000000', 'temperatura', 603.0000, 'ºC'),
	(119532, 108, '2015-04-01 00:11:28.000000', 'temperatura', 141.0000, 'ºC'),
	(119533, 108, '2015-04-01 00:11:29.000000', 'temperatura', 96.0000, 'ºC'),
	(119534, 108, '2015-04-01 00:11:30.000000', 'temperatura', 58.0000, 'ºC'),
	(119535, 108, '2015-04-01 00:11:31.000000', 'temperatura', 5.0000, 'ºC'),
	(119536, 108, '2015-04-01 00:11:32.000000', 'temperatura', 1049.0000, 'ºC'),
	(119537, 108, '2015-04-01 00:11:33.000000', 'temperatura', 430.0000, 'ºC'),
	(119538, 108, '2015-04-01 00:11:34.000000', 'temperatura', 203.0000, 'ºC'),
	(119539, 108, '2015-04-01 00:11:35.000000', 'temperatura', 925.0000, 'ºC'),
	(119540, 108, '2015-04-01 00:11:36.000000', 'temperatura', 418.0000, 'ºC'),
	(119541, 108, '2015-04-01 00:11:37.000000', 'temperatura', 516.0000, 'ºC'),
	(119542, 108, '2015-04-01 00:11:38.000000', 'temperatura', 124.0000, 'ºC'),
	(119543, 108, '2015-04-01 00:11:39.000000', 'temperatura', 276.0000, 'ºC'),
	(119544, 108, '2015-04-01 00:11:40.000000', 'temperatura', 1005.0000, 'ºC'),
	(119545, 108, '2015-04-01 00:11:41.000000', 'temperatura', 600.0000, 'ºC'),
	(119546, 108, '2015-04-01 00:11:42.000000', 'temperatura', 1187.0000, 'ºC'),
	(119547, 108, '2015-04-01 00:11:43.000000', 'temperatura', 533.0000, 'ºC'),
	(119548, 108, '2015-04-01 00:11:44.000000', 'temperatura', 306.0000, 'ºC'),
	(119549, 108, '2015-04-01 00:11:45.000000', 'temperatura', 1131.0000, 'ºC'),
	(119550, 108, '2015-04-01 00:11:46.000000', 'temperatura', 1138.0000, 'ºC'),
	(119551, 108, '2015-04-01 00:11:47.000000', 'temperatura', 1096.0000, 'ºC'),
	(119552, 108, '2015-04-01 00:11:48.000000', 'temperatura', 869.0000, 'ºC'),
	(119553, 108, '2015-04-01 00:11:49.000000', 'temperatura', 1055.0000, 'ºC'),
	(119554, 108, '2015-04-01 00:11:50.000000', 'temperatura', 267.0000, 'ºC'),
	(119555, 108, '2015-04-01 00:11:51.000000', 'temperatura', 574.0000, 'ºC'),
	(119556, 108, '2015-04-01 00:11:52.000000', 'temperatura', 867.0000, 'ºC'),
	(119557, 108, '2015-04-01 00:11:53.000000', 'temperatura', 216.0000, 'ºC'),
	(119558, 108, '2015-04-01 00:11:54.000000', 'temperatura', 878.0000, 'ºC'),
	(119559, 108, '2015-04-01 00:11:55.000000', 'temperatura', 144.0000, 'ºC'),
	(119560, 108, '2015-04-01 00:11:56.000000', 'temperatura', 487.0000, 'ºC'),
	(119561, 108, '2015-04-01 00:11:57.000000', 'temperatura', 802.0000, 'ºC'),
	(119562, 108, '2015-04-01 00:11:58.000000', 'temperatura', 150.0000, 'ºC'),
	(119563, 108, '2015-04-01 00:11:59.000000', 'temperatura', 746.0000, 'ºC'),
	(119564, 108, '2015-04-01 00:12:00.000000', 'temperatura', 879.0000, 'ºC'),
	(119565, 108, '2015-04-01 00:12:01.000000', 'temperatura', 957.0000, 'ºC'),
	(119566, 108, '2015-04-01 00:12:02.000000', 'temperatura', 947.0000, 'ºC'),
	(119567, 108, '2015-04-01 00:12:03.000000', 'temperatura', 666.0000, 'ºC'),
	(119568, 108, '2015-04-01 00:12:04.000000', 'temperatura', 488.0000, 'ºC'),
	(119569, 108, '2015-04-01 00:12:05.000000', 'temperatura', 442.0000, 'ºC'),
	(119570, 108, '2015-04-01 00:12:06.000000', 'temperatura', 749.0000, 'ºC'),
	(119571, 108, '2015-04-01 00:12:07.000000', 'temperatura', 17.0000, 'ºC'),
	(119572, 108, '2015-04-01 00:12:08.000000', 'temperatura', 239.0000, 'ºC'),
	(119573, 108, '2015-04-01 00:12:09.000000', 'temperatura', 1145.0000, 'ºC'),
	(119574, 108, '2015-04-01 00:12:10.000000', 'temperatura', 208.0000, 'ºC'),
	(119575, 108, '2015-04-01 00:12:11.000000', 'temperatura', 7.0000, 'ºC'),
	(119576, 108, '2015-04-01 00:12:12.000000', 'temperatura', 612.0000, 'ºC'),
	(119577, 108, '2015-04-01 00:12:13.000000', 'temperatura', 637.0000, 'ºC'),
	(119578, 108, '2015-04-01 00:12:14.000000', 'temperatura', 151.0000, 'ºC'),
	(119579, 108, '2015-04-01 00:12:15.000000', 'temperatura', 46.0000, 'ºC'),
	(119580, 108, '2015-04-01 00:12:16.000000', 'temperatura', 975.0000, 'ºC'),
	(119581, 108, '2015-04-01 00:12:17.000000', 'temperatura', 1137.0000, 'ºC'),
	(119582, 108, '2015-04-01 00:12:18.000000', 'temperatura', 363.0000, 'ºC'),
	(119583, 108, '2015-04-01 00:12:19.000000', 'temperatura', 804.0000, 'ºC'),
	(119584, 108, '2015-04-01 00:12:20.000000', 'temperatura', 529.0000, 'ºC'),
	(119585, 108, '2015-04-01 00:12:21.000000', 'temperatura', 236.0000, 'ºC'),
	(119586, 108, '2015-04-01 00:12:22.000000', 'temperatura', 794.0000, 'ºC'),
	(119587, 108, '2015-04-01 00:12:23.000000', 'temperatura', 864.0000, 'ºC'),
	(119588, 108, '2015-04-01 00:12:24.000000', 'temperatura', 735.0000, 'ºC'),
	(119589, 108, '2015-04-01 00:12:25.000000', 'temperatura', 1085.0000, 'ºC'),
	(119590, 108, '2015-04-01 00:12:26.000000', 'temperatura', 821.0000, 'ºC'),
	(119591, 108, '2015-04-01 00:12:27.000000', 'temperatura', 851.0000, 'ºC'),
	(119592, 108, '2015-04-01 00:12:28.000000', 'temperatura', 590.0000, 'ºC'),
	(119593, 108, '2015-04-01 00:12:29.000000', 'temperatura', 399.0000, 'ºC'),
	(119594, 108, '2015-04-01 00:12:30.000000', 'temperatura', 226.0000, 'ºC'),
	(119595, 108, '2015-04-01 00:12:31.000000', 'temperatura', 1133.0000, 'ºC'),
	(119596, 108, '2015-04-01 00:12:32.000000', 'temperatura', 189.0000, 'ºC'),
	(119597, 108, '2015-04-01 00:12:33.000000', 'temperatura', 1145.0000, 'ºC'),
	(119598, 108, '2015-04-01 00:12:34.000000', 'temperatura', 360.0000, 'ºC'),
	(119599, 108, '2015-04-01 00:12:35.000000', 'temperatura', 766.0000, 'ºC'),
	(119600, 108, '2015-04-01 00:12:36.000000', 'temperatura', 348.0000, 'ºC'),
	(119601, 108, '2015-04-01 00:12:37.000000', 'temperatura', 646.0000, 'ºC'),
	(119602, 108, '2015-04-01 00:12:38.000000', 'temperatura', 983.0000, 'ºC'),
	(119603, 108, '2015-04-01 00:12:39.000000', 'temperatura', 578.0000, 'ºC'),
	(119604, 108, '2015-04-01 00:12:40.000000', 'temperatura', 1140.0000, 'ºC'),
	(119605, 108, '2015-04-01 00:12:41.000000', 'temperatura', 369.0000, 'ºC'),
	(119606, 108, '2015-04-01 00:12:42.000000', 'temperatura', 824.0000, 'ºC'),
	(119607, 108, '2015-04-01 00:12:43.000000', 'temperatura', 615.0000, 'ºC'),
	(119608, 108, '2015-04-01 00:12:44.000000', 'temperatura', 602.0000, 'ºC'),
	(119609, 108, '2015-04-01 00:12:45.000000', 'temperatura', 1166.0000, 'ºC'),
	(119610, 108, '2015-04-01 00:12:46.000000', 'temperatura', 426.0000, 'ºC'),
	(119611, 108, '2015-04-01 00:12:47.000000', 'temperatura', 1029.0000, 'ºC'),
	(119612, 108, '2015-04-01 00:12:48.000000', 'temperatura', 271.0000, 'ºC'),
	(119613, 108, '2015-04-01 00:12:49.000000', 'temperatura', 668.0000, 'ºC'),
	(119614, 108, '2015-04-01 00:12:50.000000', 'temperatura', 128.0000, 'ºC'),
	(119615, 108, '2015-04-01 00:12:51.000000', 'temperatura', 1036.0000, 'ºC'),
	(119616, 108, '2015-04-01 00:12:52.000000', 'temperatura', 1198.0000, 'ºC'),
	(119617, 108, '2015-04-01 00:12:53.000000', 'temperatura', 483.0000, 'ºC'),
	(119618, 108, '2015-04-01 00:12:54.000000', 'temperatura', 22.0000, 'ºC'),
	(119619, 108, '2015-04-01 00:12:55.000000', 'temperatura', 1061.0000, 'ºC'),
	(119620, 108, '2015-04-01 00:12:56.000000', 'temperatura', 440.0000, 'ºC'),
	(119621, 108, '2015-04-01 00:12:57.000000', 'temperatura', 215.0000, 'ºC'),
	(119622, 108, '2015-04-01 00:12:58.000000', 'temperatura', 958.0000, 'ºC'),
	(119623, 108, '2015-04-01 00:12:59.000000', 'temperatura', 545.0000, 'ºC'),
	(119624, 108, '2015-04-01 00:13:00.000000', 'temperatura', 1052.0000, 'ºC'),
	(119625, 108, '2015-04-01 00:13:01.000000', 'temperatura', 24.0000, 'ºC'),
	(119626, 108, '2015-04-01 00:13:02.000000', 'temperatura', 567.0000, 'ºC'),
	(119627, 108, '2015-04-01 00:13:03.000000', 'temperatura', 361.0000, 'ºC'),
	(119628, 108, '2015-04-01 00:13:04.000000', 'temperatura', 104.0000, 'ºC'),
	(119629, 108, '2015-04-01 00:13:05.000000', 'temperatura', 639.0000, 'ºC'),
	(119630, 108, '2015-04-01 00:13:06.000000', 'temperatura', 483.0000, 'ºC'),
	(119631, 108, '2015-04-01 00:13:07.000000', 'temperatura', 499.0000, 'ºC'),
	(119632, 108, '2015-04-01 00:13:08.000000', 'temperatura', 1047.0000, 'ºC'),
	(119633, 108, '2015-04-01 00:13:09.000000', 'temperatura', 138.0000, 'ºC'),
	(119634, 108, '2015-04-01 00:13:10.000000', 'temperatura', 1148.0000, 'ºC'),
	(119635, 108, '2015-04-01 00:13:11.000000', 'temperatura', 527.0000, 'ºC'),
	(119636, 108, '2015-04-01 00:13:12.000000', 'temperatura', 393.0000, 'ºC'),
	(119637, 108, '2015-04-01 00:13:13.000000', 'temperatura', 382.0000, 'ºC'),
	(119638, 108, '2015-04-01 00:13:14.000000', 'temperatura', 731.0000, 'ºC'),
	(119639, 108, '2015-04-01 00:13:15.000000', 'temperatura', 111.0000, 'ºC'),
	(119640, 108, '2015-04-01 00:13:16.000000', 'temperatura', 760.0000, 'ºC'),
	(119641, 108, '2015-04-01 00:13:17.000000', 'temperatura', 1071.0000, 'ºC'),
	(119642, 108, '2015-04-01 00:13:18.000000', 'temperatura', 674.0000, 'ºC'),
	(119643, 108, '2015-04-01 00:13:19.000000', 'temperatura', 157.0000, 'ºC'),
	(119644, 108, '2015-04-01 00:13:20.000000', 'temperatura', 1164.0000, 'ºC'),
	(119645, 108, '2015-04-01 00:13:21.000000', 'temperatura', 547.0000, 'ºC'),
	(119646, 108, '2015-04-01 00:13:22.000000', 'temperatura', 447.0000, 'ºC'),
	(119647, 108, '2015-04-01 00:13:23.000000', 'temperatura', 593.0000, 'ºC'),
	(119648, 108, '2015-04-01 00:13:24.000000', 'temperatura', 424.0000, 'ºC'),
	(119649, 108, '2015-04-01 00:13:25.000000', 'temperatura', 341.0000, 'ºC'),
	(119650, 108, '2015-04-01 00:13:26.000000', 'temperatura', 436.0000, 'ºC'),
	(119651, 108, '2015-04-01 00:13:27.000000', 'temperatura', 1155.0000, 'ºC'),
	(119652, 108, '2015-04-01 00:13:28.000000', 'temperatura', 866.0000, 'ºC'),
	(119653, 108, '2015-04-01 00:13:29.000000', 'temperatura', 869.0000, 'ºC'),
	(119654, 108, '2015-04-01 00:13:30.000000', 'temperatura', 547.0000, 'ºC'),
	(119655, 108, '2015-04-01 00:13:31.000000', 'temperatura', 129.0000, 'ºC'),
	(119656, 108, '2015-04-01 00:13:32.000000', 'temperatura', 203.0000, 'ºC'),
	(119657, 108, '2015-04-01 00:13:33.000000', 'temperatura', 630.0000, 'ºC'),
	(119658, 108, '2015-04-01 00:13:34.000000', 'temperatura', 141.0000, 'ºC'),
	(119659, 108, '2015-04-01 00:13:35.000000', 'temperatura', 16.0000, 'ºC'),
	(119660, 108, '2015-04-01 00:13:36.000000', 'temperatura', 855.0000, 'ºC'),
	(119661, 108, '2015-04-01 00:13:37.000000', 'temperatura', 630.0000, 'ºC'),
	(119662, 108, '2015-04-01 00:13:38.000000', 'temperatura', 584.0000, 'ºC'),
	(119663, 108, '2015-04-01 00:13:39.000000', 'temperatura', 1030.0000, 'ºC'),
	(119664, 108, '2015-04-01 00:13:40.000000', 'temperatura', 1000.0000, 'ºC'),
	(119665, 108, '2015-04-01 00:13:41.000000', 'temperatura', 712.0000, 'ºC'),
	(119666, 108, '2015-04-01 00:13:42.000000', 'temperatura', 557.0000, 'ºC'),
	(119667, 108, '2015-04-01 00:13:43.000000', 'temperatura', 653.0000, 'ºC'),
	(119668, 108, '2015-04-01 00:13:44.000000', 'temperatura', 393.0000, 'ºC'),
	(119669, 108, '2015-04-01 00:13:45.000000', 'temperatura', 5.0000, 'ºC'),
	(119670, 108, '2015-04-01 00:13:46.000000', 'temperatura', 49.0000, 'ºC'),
	(119671, 108, '2015-04-01 00:13:47.000000', 'temperatura', 232.0000, 'ºC'),
	(119672, 108, '2015-04-01 00:13:48.000000', 'temperatura', 1010.0000, 'ºC'),
	(119673, 108, '2015-04-01 00:13:49.000000', 'temperatura', 755.0000, 'ºC'),
	(119674, 108, '2015-04-01 00:13:50.000000', 'temperatura', 745.0000, 'ºC'),
	(119675, 108, '2015-04-01 00:13:51.000000', 'temperatura', 263.0000, 'ºC'),
	(119676, 108, '2015-04-01 00:13:52.000000', 'temperatura', 277.0000, 'ºC'),
	(119677, 108, '2015-04-01 00:13:53.000000', 'temperatura', 600.0000, 'ºC'),
	(119678, 108, '2015-04-01 00:13:54.000000', 'temperatura', 969.0000, 'ºC'),
	(119679, 108, '2015-04-01 00:13:55.000000', 'temperatura', 645.0000, 'ºC'),
	(119680, 108, '2015-04-01 00:13:56.000000', 'temperatura', 318.0000, 'ºC'),
	(119681, 108, '2015-04-01 00:13:57.000000', 'temperatura', 854.0000, 'ºC'),
	(119682, 108, '2015-04-01 00:13:58.000000', 'temperatura', 917.0000, 'ºC'),
	(119683, 108, '2015-04-01 00:13:59.000000', 'temperatura', 823.0000, 'ºC'),
	(119684, 108, '2015-04-01 00:14:00.000000', 'temperatura', 166.0000, 'ºC'),
	(119685, 108, '2015-04-01 00:14:01.000000', 'temperatura', 761.0000, 'ºC'),
	(119686, 108, '2015-04-01 00:14:02.000000', 'temperatura', 909.0000, 'ºC'),
	(119687, 108, '2015-04-01 00:14:03.000000', 'temperatura', 1060.0000, 'ºC'),
	(119688, 108, '2015-04-01 00:14:04.000000', 'temperatura', 175.0000, 'ºC'),
	(119689, 108, '2015-04-01 00:14:05.000000', 'temperatura', 95.0000, 'ºC'),
	(119690, 108, '2015-04-01 00:14:06.000000', 'temperatura', 1149.0000, 'ºC'),
	(119691, 108, '2015-04-01 00:14:07.000000', 'temperatura', 662.0000, 'ºC'),
	(119692, 108, '2015-04-01 00:14:08.000000', 'temperatura', 1063.0000, 'ºC'),
	(119693, 108, '2015-04-01 00:14:09.000000', 'temperatura', 928.0000, 'ºC'),
	(119694, 108, '2015-04-01 00:14:10.000000', 'temperatura', 254.0000, 'ºC'),
	(119695, 108, '2015-04-01 00:14:11.000000', 'temperatura', 885.0000, 'ºC'),
	(119696, 108, '2015-04-01 00:14:12.000000', 'temperatura', 63.0000, 'ºC'),
	(119697, 108, '2015-04-01 00:14:13.000000', 'temperatura', 59.0000, 'ºC'),
	(119698, 108, '2015-04-01 00:14:14.000000', 'temperatura', 109.0000, 'ºC'),
	(119699, 108, '2015-04-01 00:14:15.000000', 'temperatura', 369.0000, 'ºC'),
	(119700, 108, '2015-04-01 00:14:16.000000', 'temperatura', 316.0000, 'ºC'),
	(119701, 108, '2015-04-01 00:14:17.000000', 'temperatura', 475.0000, 'ºC'),
	(119702, 108, '2015-04-01 00:14:18.000000', 'temperatura', 229.0000, 'ºC'),
	(119703, 108, '2015-04-01 00:14:19.000000', 'temperatura', 918.0000, 'ºC'),
	(119704, 108, '2015-04-01 00:14:20.000000', 'temperatura', 304.0000, 'ºC'),
	(119705, 108, '2015-04-01 00:14:21.000000', 'temperatura', 1166.0000, 'ºC'),
	(119706, 108, '2015-04-01 00:14:22.000000', 'temperatura', 118.0000, 'ºC'),
	(119707, 108, '2015-04-01 00:14:23.000000', 'temperatura', 695.0000, 'ºC'),
	(119708, 108, '2015-04-01 00:14:24.000000', 'temperatura', 721.0000, 'ºC'),
	(119709, 108, '2015-04-01 00:14:25.000000', 'temperatura', 321.0000, 'ºC'),
	(119710, 108, '2015-04-01 00:14:26.000000', 'temperatura', 642.0000, 'ºC'),
	(119711, 108, '2015-04-01 00:14:27.000000', 'temperatura', 1046.0000, 'ºC'),
	(119712, 108, '2015-04-01 00:14:28.000000', 'temperatura', 905.0000, 'ºC'),
	(119713, 108, '2015-04-01 00:14:29.000000', 'temperatura', 189.0000, 'ºC'),
	(119714, 108, '2015-04-01 00:14:30.000000', 'temperatura', 631.0000, 'ºC'),
	(119715, 108, '2015-04-01 00:14:31.000000', 'temperatura', 187.0000, 'ºC'),
	(119716, 108, '2015-04-01 00:14:32.000000', 'temperatura', 245.0000, 'ºC'),
	(119717, 108, '2015-04-01 00:14:33.000000', 'temperatura', 663.0000, 'ºC'),
	(119718, 108, '2015-04-01 00:14:34.000000', 'temperatura', 181.0000, 'ºC'),
	(119719, 108, '2015-04-01 00:14:35.000000', 'temperatura', 115.0000, 'ºC'),
	(119720, 108, '2015-04-01 00:14:36.000000', 'temperatura', 32.0000, 'ºC'),
	(119721, 108, '2015-04-01 00:14:37.000000', 'temperatura', 1015.0000, 'ºC'),
	(119722, 108, '2015-04-01 00:14:38.000000', 'temperatura', 181.0000, 'ºC'),
	(119723, 108, '2015-04-01 00:14:39.000000', 'temperatura', 262.0000, 'ºC'),
	(119724, 108, '2015-04-01 00:14:40.000000', 'temperatura', 765.0000, 'ºC'),
	(119725, 108, '2015-04-01 00:14:41.000000', 'temperatura', 642.0000, 'ºC'),
	(119726, 108, '2015-04-01 00:14:42.000000', 'temperatura', 913.0000, 'ºC'),
	(119727, 108, '2015-04-01 00:14:43.000000', 'temperatura', 240.0000, 'ºC'),
	(119728, 108, '2015-04-01 00:14:44.000000', 'temperatura', 864.0000, 'ºC'),
	(119729, 108, '2015-04-01 00:14:45.000000', 'temperatura', 1199.0000, 'ºC'),
	(119730, 108, '2015-04-01 00:14:46.000000', 'temperatura', 1002.0000, 'ºC'),
	(119731, 108, '2015-04-01 00:14:47.000000', 'temperatura', 216.0000, 'ºC'),
	(119732, 108, '2015-04-01 00:14:48.000000', 'temperatura', 473.0000, 'ºC'),
	(119733, 108, '2015-04-01 00:14:49.000000', 'temperatura', 518.0000, 'ºC'),
	(119734, 108, '2015-04-01 00:14:50.000000', 'temperatura', 1173.0000, 'ºC'),
	(119735, 108, '2015-04-01 00:14:51.000000', 'temperatura', 711.0000, 'ºC'),
	(119736, 108, '2015-04-01 00:14:52.000000', 'temperatura', 35.0000, 'ºC'),
	(119737, 108, '2015-04-01 00:14:53.000000', 'temperatura', 444.0000, 'ºC'),
	(119738, 108, '2015-04-01 00:14:54.000000', 'temperatura', 915.0000, 'ºC'),
	(119739, 108, '2015-04-01 00:14:55.000000', 'temperatura', 843.0000, 'ºC'),
	(119740, 108, '2015-04-01 00:14:56.000000', 'temperatura', 269.0000, 'ºC'),
	(119741, 108, '2015-04-01 00:14:57.000000', 'temperatura', 18.0000, 'ºC'),
	(119742, 108, '2015-04-01 00:14:58.000000', 'temperatura', 483.0000, 'ºC'),
	(119743, 108, '2015-04-01 00:14:59.000000', 'temperatura', 1163.0000, 'ºC'),
	(119744, 108, '2015-04-01 00:15:00.000000', 'temperatura', 767.0000, 'ºC'),
	(119745, 108, '2015-04-01 00:15:01.000000', 'temperatura', 346.0000, 'ºC'),
	(119746, 108, '2015-04-01 00:15:02.000000', 'temperatura', 629.0000, 'ºC'),
	(119747, 108, '2015-04-01 00:15:03.000000', 'temperatura', 907.0000, 'ºC'),
	(119748, 108, '2015-04-01 00:15:04.000000', 'temperatura', 251.0000, 'ºC'),
	(119749, 108, '2015-04-01 00:15:05.000000', 'temperatura', 932.0000, 'ºC'),
	(119750, 108, '2015-04-01 00:15:06.000000', 'temperatura', 310.0000, 'ºC'),
	(119751, 108, '2015-04-01 00:15:07.000000', 'temperatura', 1155.0000, 'ºC'),
	(119752, 108, '2015-04-01 00:15:08.000000', 'temperatura', 43.0000, 'ºC'),
	(119753, 108, '2015-04-01 00:15:09.000000', 'temperatura', 350.0000, 'ºC'),
	(119754, 108, '2015-04-01 00:15:10.000000', 'temperatura', 423.0000, 'ºC'),
	(119755, 108, '2015-04-01 00:15:11.000000', 'temperatura', 1067.0000, 'ºC'),
	(119756, 108, '2015-04-01 00:15:12.000000', 'temperatura', 463.0000, 'ºC'),
	(119757, 108, '2015-04-01 00:15:13.000000', 'temperatura', 317.0000, 'ºC'),
	(119758, 108, '2015-04-01 00:15:14.000000', 'temperatura', 194.0000, 'ºC'),
	(119759, 108, '2015-04-01 00:15:15.000000', 'temperatura', 21.0000, 'ºC'),
	(119760, 108, '2015-04-01 00:15:16.000000', 'temperatura', 724.0000, 'ºC'),
	(119761, 108, '2015-04-01 00:15:17.000000', 'temperatura', 1159.0000, 'ºC'),
	(119762, 108, '2015-04-01 00:15:18.000000', 'temperatura', 21.0000, 'ºC'),
	(119763, 108, '2015-04-01 00:15:19.000000', 'temperatura', 231.0000, 'ºC'),
	(119764, 108, '2015-04-01 00:15:20.000000', 'temperatura', 1090.0000, 'ºC'),
	(119765, 108, '2015-04-01 00:15:21.000000', 'temperatura', 1159.0000, 'ºC'),
	(119766, 108, '2015-04-01 00:15:22.000000', 'temperatura', 124.0000, 'ºC'),
	(119767, 108, '2015-04-01 00:15:23.000000', 'temperatura', 743.0000, 'ºC'),
	(119768, 108, '2015-04-01 00:15:24.000000', 'temperatura', 944.0000, 'ºC'),
	(119769, 108, '2015-04-01 00:15:25.000000', 'temperatura', 93.0000, 'ºC'),
	(119770, 108, '2015-04-01 00:15:26.000000', 'temperatura', 31.0000, 'ºC'),
	(119771, 108, '2015-04-01 00:15:27.000000', 'temperatura', 1077.0000, 'ºC'),
	(119772, 108, '2015-04-01 00:15:28.000000', 'temperatura', 493.0000, 'ºC'),
	(119773, 108, '2015-04-01 00:15:29.000000', 'temperatura', 434.0000, 'ºC'),
	(119774, 108, '2015-04-01 00:15:30.000000', 'temperatura', 693.0000, 'ºC'),
	(119775, 108, '2015-04-01 00:15:31.000000', 'temperatura', 964.0000, 'ºC'),
	(119776, 108, '2015-04-01 00:15:32.000000', 'temperatura', 340.0000, 'ºC'),
	(119777, 108, '2015-04-01 00:15:33.000000', 'temperatura', 9.0000, 'ºC'),
	(119778, 108, '2015-04-01 00:15:34.000000', 'temperatura', 223.0000, 'ºC'),
	(119779, 108, '2015-04-01 00:15:35.000000', 'temperatura', 1092.0000, 'ºC'),
	(119780, 108, '2015-04-01 00:15:36.000000', 'temperatura', 1191.0000, 'ºC'),
	(119781, 108, '2015-04-01 00:15:37.000000', 'temperatura', 277.0000, 'ºC'),
	(119782, 108, '2015-04-01 00:15:38.000000', 'temperatura', 215.0000, 'ºC'),
	(119783, 108, '2015-04-01 00:15:39.000000', 'temperatura', 242.0000, 'ºC'),
	(119784, 108, '2015-04-01 00:15:40.000000', 'temperatura', 568.0000, 'ºC'),
	(119785, 108, '2015-04-01 00:15:41.000000', 'temperatura', 913.0000, 'ºC'),
	(119786, 108, '2015-04-01 00:15:42.000000', 'temperatura', 460.0000, 'ºC'),
	(119787, 108, '2015-04-01 00:15:43.000000', 'temperatura', 763.0000, 'ºC'),
	(119788, 108, '2015-04-01 00:15:44.000000', 'temperatura', 35.0000, 'ºC'),
	(119789, 108, '2015-04-01 00:15:45.000000', 'temperatura', 287.0000, 'ºC'),
	(119790, 108, '2015-04-01 00:15:46.000000', 'temperatura', 129.0000, 'ºC'),
	(119791, 108, '2015-04-01 00:15:47.000000', 'temperatura', 987.0000, 'ºC'),
	(119792, 108, '2015-04-01 00:15:48.000000', 'temperatura', 947.0000, 'ºC'),
	(119793, 108, '2015-04-01 00:15:49.000000', 'temperatura', 574.0000, 'ºC'),
	(119794, 108, '2015-04-01 00:15:50.000000', 'temperatura', 31.0000, 'ºC'),
	(119795, 108, '2015-04-01 00:15:51.000000', 'temperatura', 831.0000, 'ºC'),
	(119796, 108, '2015-04-01 00:15:52.000000', 'temperatura', 464.0000, 'ºC'),
	(119797, 108, '2015-04-01 00:15:53.000000', 'temperatura', 1029.0000, 'ºC'),
	(119798, 108, '2015-04-01 00:15:54.000000', 'temperatura', 151.0000, 'ºC'),
	(119799, 108, '2015-04-01 00:15:55.000000', 'temperatura', 70.0000, 'ºC'),
	(119800, 108, '2015-04-01 00:15:56.000000', 'temperatura', 1096.0000, 'ºC'),
	(119801, 108, '2015-04-01 00:15:57.000000', 'temperatura', 470.0000, 'ºC'),
	(119802, 108, '2015-04-01 00:15:58.000000', 'temperatura', 262.0000, 'ºC'),
	(119803, 108, '2015-04-01 00:15:59.000000', 'temperatura', 1102.0000, 'ºC'),
	(119804, 108, '2015-04-01 00:16:00.000000', 'temperatura', 1125.0000, 'ºC'),
	(119805, 108, '2015-04-01 00:16:01.000000', 'temperatura', 1120.0000, 'ºC'),
	(119806, 108, '2015-04-01 00:16:02.000000', 'temperatura', 1024.0000, 'ºC'),
	(119807, 108, '2015-04-01 00:16:03.000000', 'temperatura', 561.0000, 'ºC'),
	(119808, 108, '2015-04-01 00:16:04.000000', 'temperatura', 934.0000, 'ºC'),
	(119809, 108, '2015-04-01 00:16:05.000000', 'temperatura', 589.0000, 'ºC'),
	(119810, 108, '2015-04-01 00:16:06.000000', 'temperatura', 140.0000, 'ºC'),
	(119811, 108, '2015-04-01 00:16:07.000000', 'temperatura', 136.0000, 'ºC'),
	(119812, 108, '2015-04-01 00:16:08.000000', 'temperatura', 259.0000, 'ºC'),
	(119813, 108, '2015-04-01 00:16:09.000000', 'temperatura', 886.0000, 'ºC'),
	(119814, 108, '2015-04-01 00:16:10.000000', 'temperatura', 55.0000, 'ºC'),
	(119815, 108, '2015-04-01 00:16:11.000000', 'temperatura', 19.0000, 'ºC'),
	(119816, 108, '2015-04-01 00:16:12.000000', 'temperatura', 1131.0000, 'ºC'),
	(119817, 108, '2015-04-01 00:16:13.000000', 'temperatura', 797.0000, 'ºC'),
	(119818, 108, '2015-04-01 00:16:14.000000', 'temperatura', 593.0000, 'ºC'),
	(119819, 108, '2015-04-01 00:16:15.000000', 'temperatura', 573.0000, 'ºC'),
	(119820, 108, '2015-04-01 00:16:16.000000', 'temperatura', 1087.0000, 'ºC'),
	(119821, 108, '2015-04-01 00:16:17.000000', 'temperatura', 116.0000, 'ºC'),
	(119822, 108, '2015-04-01 00:16:18.000000', 'temperatura', 918.0000, 'ºC'),
	(119823, 108, '2015-04-01 00:16:19.000000', 'temperatura', 646.0000, 'ºC'),
	(119824, 108, '2015-04-01 00:16:20.000000', 'temperatura', 475.0000, 'ºC'),
	(119825, 108, '2015-04-01 00:16:21.000000', 'temperatura', 436.0000, 'ºC'),
	(119826, 108, '2015-04-01 00:16:22.000000', 'temperatura', 757.0000, 'ºC'),
	(119827, 108, '2015-04-01 00:16:23.000000', 'temperatura', 78.0000, 'ºC'),
	(119828, 108, '2015-04-01 00:16:24.000000', 'temperatura', 519.0000, 'ºC'),
	(119829, 108, '2015-04-01 00:16:25.000000', 'temperatura', 1160.0000, 'ºC'),
	(119830, 108, '2015-04-01 00:16:26.000000', 'temperatura', 645.0000, 'ºC'),
	(119831, 108, '2015-04-01 00:16:27.000000', 'temperatura', 943.0000, 'ºC'),
	(119832, 108, '2015-04-01 00:16:28.000000', 'temperatura', 383.0000, 'ºC'),
	(119833, 108, '2015-04-01 00:16:29.000000', 'temperatura', 285.0000, 'ºC'),
	(119834, 108, '2015-04-01 00:16:30.000000', 'temperatura', 276.0000, 'ºC'),
	(119835, 108, '2015-04-01 00:16:31.000000', 'temperatura', 525.0000, 'ºC'),
	(119836, 108, '2015-04-01 00:16:32.000000', 'temperatura', 598.0000, 'ºC'),
	(119837, 108, '2015-04-01 00:16:33.000000', 'temperatura', 216.0000, 'ºC'),
	(119838, 108, '2015-04-01 00:16:34.000000', 'temperatura', 487.0000, 'ºC'),
	(119839, 108, '2015-04-01 00:16:35.000000', 'temperatura', 587.0000, 'ºC'),
	(119840, 108, '2015-04-01 00:16:36.000000', 'temperatura', 276.0000, 'ºC'),
	(119841, 108, '2015-04-01 00:16:37.000000', 'temperatura', 818.0000, 'ºC'),
	(119842, 108, '2015-04-01 00:16:38.000000', 'temperatura', 861.0000, 'ºC'),
	(119843, 108, '2015-04-01 00:16:39.000000', 'temperatura', 655.0000, 'ºC'),
	(119844, 108, '2015-04-01 00:16:40.000000', 'temperatura', 690.0000, 'ºC'),
	(119845, 108, '2015-04-01 00:16:41.000000', 'temperatura', 284.0000, 'ºC'),
	(119846, 108, '2015-04-01 00:16:42.000000', 'temperatura', 554.0000, 'ºC'),
	(119847, 108, '2015-04-01 00:16:43.000000', 'temperatura', 718.0000, 'ºC'),
	(119848, 108, '2015-04-01 00:16:44.000000', 'temperatura', 726.0000, 'ºC'),
	(119849, 108, '2015-04-01 00:16:45.000000', 'temperatura', 279.0000, 'ºC'),
	(119850, 108, '2015-04-01 00:16:46.000000', 'temperatura', 417.0000, 'ºC'),
	(119851, 108, '2015-04-01 00:16:47.000000', 'temperatura', 49.0000, 'ºC'),
	(119852, 108, '2015-04-01 00:16:48.000000', 'temperatura', 196.0000, 'ºC'),
	(119853, 108, '2015-04-01 00:16:49.000000', 'temperatura', 830.0000, 'ºC'),
	(119854, 108, '2015-04-01 00:16:50.000000', 'temperatura', 1164.0000, 'ºC'),
	(119855, 108, '2015-04-01 00:16:51.000000', 'temperatura', 929.0000, 'ºC'),
	(119856, 108, '2015-04-01 00:16:52.000000', 'temperatura', 1156.0000, 'ºC'),
	(119857, 108, '2015-04-01 00:16:53.000000', 'temperatura', 594.0000, 'ºC'),
	(119858, 108, '2015-04-01 00:16:54.000000', 'temperatura', 700.0000, 'ºC'),
	(119859, 108, '2015-04-01 00:16:55.000000', 'temperatura', 518.0000, 'ºC'),
	(119860, 108, '2015-04-01 00:16:56.000000', 'temperatura', 491.0000, 'ºC'),
	(119861, 108, '2015-04-01 00:16:57.000000', 'temperatura', 903.0000, 'ºC'),
	(119862, 108, '2015-04-01 00:16:58.000000', 'temperatura', 643.0000, 'ºC'),
	(119863, 108, '2015-04-01 00:16:59.000000', 'temperatura', 504.0000, 'ºC'),
	(119864, 108, '2015-04-01 00:17:00.000000', 'temperatura', 593.0000, 'ºC'),
	(119865, 108, '2015-04-01 00:17:01.000000', 'temperatura', 252.0000, 'ºC'),
	(119866, 108, '2015-04-01 00:17:02.000000', 'temperatura', 681.0000, 'ºC'),
	(119867, 108, '2015-04-01 00:17:03.000000', 'temperatura', 249.0000, 'ºC'),
	(119868, 108, '2015-04-01 00:17:04.000000', 'temperatura', 406.0000, 'ºC'),
	(119869, 108, '2015-04-01 00:17:05.000000', 'temperatura', 80.0000, 'ºC'),
	(119870, 108, '2015-04-01 00:17:06.000000', 'temperatura', 382.0000, 'ºC'),
	(119871, 108, '2015-04-01 00:17:07.000000', 'temperatura', 473.0000, 'ºC'),
	(119872, 108, '2015-04-01 00:17:08.000000', 'temperatura', 19.0000, 'ºC'),
	(119873, 108, '2015-04-01 00:17:09.000000', 'temperatura', 1077.0000, 'ºC'),
	(119874, 108, '2015-04-01 00:17:10.000000', 'temperatura', 527.0000, 'ºC'),
	(119875, 108, '2015-04-01 00:17:11.000000', 'temperatura', 605.0000, 'ºC'),
	(119876, 108, '2015-04-01 00:17:12.000000', 'temperatura', 243.0000, 'ºC'),
	(119877, 108, '2015-04-01 00:17:13.000000', 'temperatura', 604.0000, 'ºC'),
	(119878, 108, '2015-04-01 00:17:14.000000', 'temperatura', 1088.0000, 'ºC'),
	(119879, 108, '2015-04-01 00:17:15.000000', 'temperatura', 31.0000, 'ºC'),
	(119880, 108, '2015-04-01 00:17:16.000000', 'temperatura', 492.0000, 'ºC'),
	(119881, 108, '2015-04-01 00:17:17.000000', 'temperatura', 1168.0000, 'ºC'),
	(119882, 108, '2015-04-01 00:17:18.000000', 'temperatura', 764.0000, 'ºC'),
	(119883, 108, '2015-04-01 00:17:19.000000', 'temperatura', 315.0000, 'ºC'),
	(119884, 108, '2015-04-01 00:17:20.000000', 'temperatura', 482.0000, 'ºC'),
	(119885, 108, '2015-04-01 00:17:21.000000', 'temperatura', 268.0000, 'ºC'),
	(119886, 108, '2015-04-01 00:17:22.000000', 'temperatura', 1094.0000, 'ºC'),
	(119887, 108, '2015-04-01 00:17:23.000000', 'temperatura', 1065.0000, 'ºC'),
	(119888, 108, '2015-04-01 00:17:24.000000', 'temperatura', 843.0000, 'ºC'),
	(119889, 108, '2015-04-01 00:17:25.000000', 'temperatura', 1020.0000, 'ºC'),
	(119890, 108, '2015-04-01 00:17:26.000000', 'temperatura', 171.0000, 'ºC'),
	(119891, 108, '2015-04-01 00:17:27.000000', 'temperatura', 198.0000, 'ºC'),
	(119892, 108, '2015-04-01 00:17:28.000000', 'temperatura', 475.0000, 'ºC'),
	(119893, 108, '2015-04-01 00:17:29.000000', 'temperatura', 584.0000, 'ºC'),
	(119894, 108, '2015-04-01 00:17:30.000000', 'temperatura', 296.0000, 'ºC'),
	(119895, 108, '2015-04-01 00:17:31.000000', 'temperatura', 927.0000, 'ºC'),
	(119896, 108, '2015-04-01 00:17:32.000000', 'temperatura', 149.0000, 'ºC'),
	(119897, 108, '2015-04-01 00:17:33.000000', 'temperatura', 364.0000, 'ºC'),
	(119898, 108, '2015-04-01 00:17:34.000000', 'temperatura', 174.0000, 'ºC'),
	(119899, 108, '2015-04-01 00:17:35.000000', 'temperatura', 976.0000, 'ºC'),
	(119900, 108, '2015-04-01 00:17:36.000000', 'temperatura', 760.0000, 'ºC'),
	(119901, 108, '2015-04-01 00:17:37.000000', 'temperatura', 873.0000, 'ºC'),
	(119902, 108, '2015-04-01 00:17:38.000000', 'temperatura', 887.0000, 'ºC'),
	(119903, 108, '2015-04-01 00:17:39.000000', 'temperatura', 615.0000, 'ºC'),
	(119904, 108, '2015-04-01 00:17:40.000000', 'temperatura', 415.0000, 'ºC'),
	(119905, 108, '2015-04-01 00:17:41.000000', 'temperatura', 229.0000, 'ºC'),
	(119906, 108, '2015-04-01 00:17:42.000000', 'temperatura', 1100.0000, 'ºC'),
	(119907, 108, '2015-04-01 00:17:43.000000', 'temperatura', 13.0000, 'ºC'),
	(119908, 108, '2015-04-01 00:17:44.000000', 'temperatura', 366.0000, 'ºC'),
	(119909, 108, '2015-04-01 00:17:45.000000', 'temperatura', 593.0000, 'ºC'),
	(119910, 108, '2015-04-01 00:17:46.000000', 'temperatura', 667.0000, 'ºC'),
	(119911, 108, '2015-04-01 00:17:47.000000', 'temperatura', 355.0000, 'ºC'),
	(119912, 108, '2015-04-01 00:17:48.000000', 'temperatura', 976.0000, 'ºC'),
	(119913, 108, '2015-04-01 00:17:49.000000', 'temperatura', 214.0000, 'ºC'),
	(119914, 108, '2015-04-01 00:17:50.000000', 'temperatura', 543.0000, 'ºC'),
	(119915, 108, '2015-04-01 00:17:51.000000', 'temperatura', 875.0000, 'ºC'),
	(119916, 108, '2015-04-01 00:17:52.000000', 'temperatura', 345.0000, 'ºC'),
	(119917, 108, '2015-04-01 00:17:53.000000', 'temperatura', 299.0000, 'ºC'),
	(119918, 108, '2015-04-01 00:17:54.000000', 'temperatura', 463.0000, 'ºC'),
	(119919, 108, '2015-04-01 00:17:55.000000', 'temperatura', 218.0000, 'ºC'),
	(119920, 108, '2015-04-01 00:17:56.000000', 'temperatura', 901.0000, 'ºC'),
	(119921, 108, '2015-04-01 00:17:57.000000', 'temperatura', 253.0000, 'ºC'),
	(119922, 108, '2015-04-01 00:17:58.000000', 'temperatura', 963.0000, 'ºC'),
	(119923, 108, '2015-04-01 00:17:59.000000', 'temperatura', 456.0000, 'ºC'),
	(119924, 108, '2015-04-01 00:18:00.000000', 'temperatura', 592.0000, 'ºC'),
	(119925, 108, '2015-04-01 00:18:01.000000', 'temperatura', 391.0000, 'ºC'),
	(119926, 108, '2015-04-01 00:18:02.000000', 'temperatura', 182.0000, 'ºC'),
	(119927, 108, '2015-04-01 00:18:03.000000', 'temperatura', 935.0000, 'ºC'),
	(119928, 108, '2015-04-01 00:18:04.000000', 'temperatura', 529.0000, 'ºC'),
	(119929, 108, '2015-04-01 00:18:05.000000', 'temperatura', 1040.0000, 'ºC'),
	(119930, 108, '2015-04-01 00:18:06.000000', 'temperatura', 14.0000, 'ºC'),
	(119931, 108, '2015-04-01 00:18:07.000000', 'temperatura', 551.0000, 'ºC'),
	(119932, 108, '2015-04-01 00:18:08.000000', 'temperatura', 313.0000, 'ºC'),
	(119933, 108, '2015-04-01 00:18:09.000000', 'temperatura', 1115.0000, 'ºC'),
	(119934, 108, '2015-04-01 00:18:10.000000', 'temperatura', 1034.0000, 'ºC'),
	(119935, 108, '2015-04-01 00:18:11.000000', 'temperatura', 625.0000, 'ºC'),
	(119936, 108, '2015-04-01 00:18:12.000000', 'temperatura', 26.0000, 'ºC'),
	(119937, 108, '2015-04-01 00:18:13.000000', 'temperatura', 654.0000, 'ºC'),
	(119938, 108, '2015-04-01 00:18:14.000000', 'temperatura', 794.0000, 'ºC'),
	(119939, 108, '2015-04-01 00:18:15.000000', 'temperatura', 806.0000, 'ºC'),
	(119940, 108, '2015-04-01 00:18:16.000000', 'temperatura', 451.0000, 'ºC'),
	(119941, 108, '2015-04-01 00:18:17.000000', 'temperatura', 1039.0000, 'ºC'),
	(119942, 108, '2015-04-01 00:18:18.000000', 'temperatura', 239.0000, 'ºC'),
	(119943, 108, '2015-04-01 00:18:19.000000', 'temperatura', 479.0000, 'ºC'),
	(119944, 108, '2015-04-01 00:18:20.000000', 'temperatura', 479.0000, 'ºC'),
	(119945, 108, '2015-04-01 00:18:21.000000', 'temperatura', 959.0000, 'ºC'),
	(119946, 108, '2015-04-01 00:18:22.000000', 'temperatura', 959.0000, 'ºC'),
	(119947, 108, '2015-04-01 00:18:23.000000', 'temperatura', 717.0000, 'ºC'),
	(119948, 108, '2015-04-01 00:18:24.000000', 'temperatura', 711.0000, 'ºC'),
	(119949, 108, '2015-04-01 00:18:25.000000', 'temperatura', 201.0000, 'ºC'),
	(119950, 108, '2015-04-01 00:18:26.000000', 'temperatura', 74.0000, 'ºC'),
	(119951, 108, '2015-04-01 00:18:27.000000', 'temperatura', 969.0000, 'ºC'),
	(119952, 108, '2015-04-01 00:18:28.000000', 'temperatura', 1022.0000, 'ºC'),
	(119953, 108, '2015-04-01 00:18:29.000000', 'temperatura', 1005.0000, 'ºC'),
	(119954, 108, '2015-04-01 00:18:30.000000', 'temperatura', 758.0000, 'ºC'),
	(119955, 108, '2015-04-01 00:18:31.000000', 'temperatura', 778.0000, 'ºC'),
	(119956, 108, '2015-04-01 00:18:32.000000', 'temperatura', 415.0000, 'ºC'),
	(119957, 108, '2015-04-01 00:18:33.000000', 'temperatura', 943.0000, 'ºC'),
	(119958, 108, '2015-04-01 00:18:34.000000', 'temperatura', 1070.0000, 'ºC'),
	(119959, 108, '2015-04-01 00:18:35.000000', 'temperatura', 121.0000, 'ºC'),
	(119960, 108, '2015-04-01 00:18:36.000000', 'temperatura', 995.0000, 'ºC'),
	(119961, 108, '2015-04-01 00:18:37.000000', 'temperatura', 1014.0000, 'ºC'),
	(119962, 108, '2015-04-01 00:18:38.000000', 'temperatura', 884.0000, 'ºC'),
	(119963, 108, '2015-04-01 00:18:39.000000', 'temperatura', 179.0000, 'ºC'),
	(119964, 108, '2015-04-01 00:18:40.000000', 'temperatura', 644.0000, 'ºC'),
	(119965, 108, '2015-04-01 00:18:41.000000', 'temperatura', 283.0000, 'ºC'),
	(119966, 108, '2015-04-01 00:18:42.000000', 'temperatura', 684.0000, 'ºC'),
	(119967, 108, '2015-04-01 00:18:43.000000', 'temperatura', 173.0000, 'ºC'),
	(119968, 108, '2015-04-01 00:18:44.000000', 'temperatura', 11.0000, 'ºC'),
	(119969, 108, '2015-04-01 00:18:45.000000', 'temperatura', 738.0000, 'ºC'),
	(119970, 108, '2015-04-01 00:18:46.000000', 'temperatura', 56.0000, 'ºC'),
	(119971, 108, '2015-04-01 00:18:47.000000', 'temperatura', 467.0000, 'ºC'),
	(119972, 108, '2015-04-01 00:18:48.000000', 'temperatura', 968.0000, 'ºC'),
	(119973, 108, '2015-04-01 00:18:49.000000', 'temperatura', 1039.0000, 'ºC'),
	(119974, 108, '2015-04-01 00:18:50.000000', 'temperatura', 1092.0000, 'ºC'),
	(119975, 108, '2015-04-01 00:18:51.000000', 'temperatura', 1142.0000, 'ºC'),
	(119976, 108, '2015-04-01 00:18:52.000000', 'temperatura', 37.0000, 'ºC'),
	(119977, 108, '2015-04-01 00:18:53.000000', 'temperatura', 360.0000, 'ºC'),
	(119978, 108, '2015-04-01 00:18:54.000000', 'temperatura', 488.0000, 'ºC'),
	(119979, 108, '2015-04-01 00:18:55.000000', 'temperatura', 162.0000, 'ºC'),
	(119980, 108, '2015-04-01 00:18:56.000000', 'temperatura', 547.0000, 'ºC'),
	(119981, 108, '2015-04-01 00:18:57.000000', 'temperatura', 1048.0000, 'ºC'),
	(119982, 108, '2015-04-01 00:18:58.000000', 'temperatura', 1.0000, 'ºC'),
	(119983, 108, '2015-04-01 00:18:59.000000', 'temperatura', 461.0000, 'ºC'),
	(119984, 108, '2015-04-01 00:19:00.000000', 'temperatura', 1101.0000, 'ºC'),
	(119985, 108, '2015-04-01 00:19:01.000000', 'temperatura', 521.0000, 'ºC'),
	(119986, 108, '2015-04-01 00:19:02.000000', 'temperatura', 505.0000, 'ºC'),
	(119987, 108, '2015-04-01 00:19:03.000000', 'temperatura', 963.0000, 'ºC'),
	(119988, 108, '2015-04-01 00:19:04.000000', 'temperatura', 902.0000, 'ºC'),
	(119989, 108, '2015-04-01 00:19:05.000000', 'temperatura', 419.0000, 'ºC'),
	(119990, 108, '2015-04-01 00:19:06.000000', 'temperatura', 591.0000, 'ºC'),
	(119991, 108, '2015-04-01 00:19:07.000000', 'temperatura', 497.0000, 'ºC'),
	(119992, 108, '2015-04-01 00:19:08.000000', 'temperatura', 715.0000, 'ºC'),
	(119993, 108, '2015-04-01 00:19:09.000000', 'temperatura', 884.0000, 'ºC'),
	(119994, 108, '2015-04-01 00:19:10.000000', 'temperatura', 1074.0000, 'ºC'),
	(119995, 108, '2015-04-01 00:19:11.000000', 'temperatura', 321.0000, 'ºC'),
	(119996, 108, '2015-04-01 00:19:12.000000', 'temperatura', 783.0000, 'ºC'),
	(119997, 108, '2015-04-01 00:19:13.000000', 'temperatura', 553.0000, 'ºC'),
	(119998, 108, '2015-04-01 00:19:14.000000', 'temperatura', 415.0000, 'ºC'),
	(119999, 108, '2015-04-01 00:19:15.000000', 'temperatura', 416.0000, 'ºC'),
	(120000, 108, '2015-04-01 00:19:16.000000', 'temperatura', 837.0000, 'ºC'),
	(120001, 108, '2015-04-01 00:19:17.000000', 'temperatura', 538.0000, 'ºC'),
	(120002, 108, '2015-04-01 00:19:18.000000', 'temperatura', 179.0000, 'ºC'),
	(120003, 108, '2015-04-01 00:19:19.000000', 'temperatura', 481.0000, 'ºC'),
	(120004, 108, '2015-04-01 00:19:20.000000', 'temperatura', 669.0000, 'ºC'),
	(120005, 108, '2015-04-01 00:19:21.000000', 'temperatura', 702.0000, 'ºC'),
	(120006, 108, '2015-04-01 00:19:22.000000', 'temperatura', 304.0000, 'ºC'),
	(120007, 108, '2015-04-01 00:19:23.000000', 'temperatura', 616.0000, 'ºC'),
	(120008, 108, '2015-04-01 00:19:24.000000', 'temperatura', 968.0000, 'ºC'),
	(120009, 108, '2015-04-01 00:19:25.000000', 'temperatura', 592.0000, 'ºC'),
	(120010, 108, '2015-04-01 00:19:26.000000', 'temperatura', 57.0000, 'ºC'),
	(120011, 108, '2015-04-01 00:19:27.000000', 'temperatura', 910.0000, 'ºC'),
	(120012, 108, '2015-04-01 00:19:28.000000', 'temperatura', 779.0000, 'ºC'),
	(120013, 108, '2015-04-01 00:19:29.000000', 'temperatura', 1167.0000, 'ºC'),
	(120014, 108, '2015-04-01 00:19:30.000000', 'temperatura', 1096.0000, 'ºC'),
	(120015, 108, '2015-04-01 00:19:31.000000', 'temperatura', 781.0000, 'ºC'),
	(120016, 108, '2015-04-01 00:19:32.000000', 'temperatura', 618.0000, 'ºC'),
	(120017, 108, '2015-04-01 00:19:33.000000', 'temperatura', 746.0000, 'ºC'),
	(120018, 108, '2015-04-01 00:19:34.000000', 'temperatura', 676.0000, 'ºC'),
	(120019, 108, '2015-04-01 00:19:35.000000', 'temperatura', 1145.0000, 'ºC'),
	(120020, 108, '2015-04-01 00:19:36.000000', 'temperatura', 97.0000, 'ºC'),
	(120021, 108, '2015-04-01 00:19:37.000000', 'temperatura', 651.0000, 'ºC'),
	(120022, 108, '2015-04-01 00:19:38.000000', 'temperatura', 562.0000, 'ºC'),
	(120023, 108, '2015-04-01 00:19:39.000000', 'temperatura', 861.0000, 'ºC'),
	(120024, 108, '2015-04-01 00:19:40.000000', 'temperatura', 217.0000, 'ºC'),
	(120025, 108, '2015-04-01 00:19:41.000000', 'temperatura', 903.0000, 'ºC'),
	(120026, 108, '2015-04-01 00:19:42.000000', 'temperatura', 264.0000, 'ºC'),
	(120027, 108, '2015-04-01 00:19:43.000000', 'temperatura', 1013.0000, 'ºC'),
	(120028, 108, '2015-04-01 00:19:44.000000', 'temperatura', 674.0000, 'ºC'),
	(120029, 108, '2015-04-01 00:19:45.000000', 'temperatura', 329.0000, 'ºC'),
	(120030, 108, '2015-04-01 00:19:46.000000', 'temperatura', 825.0000, 'ºC'),
	(120031, 108, '2015-04-01 00:19:47.000000', 'temperatura', 737.0000, 'ºC'),
	(120032, 108, '2015-04-01 00:19:48.000000', 'temperatura', 12.0000, 'ºC'),
	(120033, 108, '2015-04-01 00:19:49.000000', 'temperatura', 247.0000, 'ºC'),
	(120034, 108, '2015-04-01 00:19:50.000000', 'temperatura', 3.0000, 'ºC'),
	(120035, 108, '2015-04-01 00:19:51.000000', 'temperatura', 471.0000, 'ºC'),
	(120036, 108, '2015-04-01 00:19:52.000000', 'temperatura', 1149.0000, 'ºC'),
	(120037, 108, '2015-04-01 00:19:53.000000', 'temperatura', 730.0000, 'ºC'),
	(120038, 108, '2015-04-01 00:19:54.000000', 'temperatura', 205.0000, 'ºC'),
	(120039, 108, '2015-04-01 00:19:55.000000', 'temperatura', 35.0000, 'ºC'),
	(120040, 108, '2015-04-01 00:19:56.000000', 'temperatura', 759.0000, 'ºC'),
	(120041, 108, '2015-04-01 00:19:57.000000', 'temperatura', 90.0000, 'ºC'),
	(120042, 108, '2015-04-01 00:19:58.000000', 'temperatura', 575.0000, 'ºC'),
	(120043, 108, '2015-04-01 00:19:59.000000', 'temperatura', 205.0000, 'ºC'),
	(120044, 108, '2015-04-01 00:20:00.000000', 'temperatura', 502.0000, 'ºC'),
	(120045, 108, '2015-04-01 00:20:01.000000', 'temperatura', 694.0000, 'ºC'),
	(120046, 108, '2015-04-01 00:20:02.000000', 'temperatura', 765.0000, 'ºC'),
	(120047, 108, '2015-04-01 00:20:03.000000', 'temperatura', 545.0000, 'ºC'),
	(120048, 108, '2015-04-01 00:20:04.000000', 'temperatura', 431.0000, 'ºC'),
	(120049, 108, '2015-04-01 00:20:05.000000', 'temperatura', 519.0000, 'ºC'),
	(120050, 108, '2015-04-01 00:20:06.000000', 'temperatura', 102.0000, 'ºC'),
	(120051, 108, '2015-04-01 00:20:07.000000', 'temperatura', 154.0000, 'ºC'),
	(120052, 108, '2015-04-01 00:20:08.000000', 'temperatura', 463.0000, 'ºC'),
	(120053, 108, '2015-04-01 00:20:09.000000', 'temperatura', 655.0000, 'ºC'),
	(120054, 108, '2015-04-01 00:20:10.000000', 'temperatura', 686.0000, 'ºC'),
	(120055, 108, '2015-04-01 00:20:11.000000', 'temperatura', 265.0000, 'ºC'),
	(120056, 108, '2015-04-01 00:20:12.000000', 'temperatura', 469.0000, 'ºC'),
	(120057, 108, '2015-04-01 00:20:13.000000', 'temperatura', 351.0000, 'ºC'),
	(120058, 108, '2015-04-01 00:20:14.000000', 'temperatura', 347.0000, 'ºC'),
	(120059, 108, '2015-04-01 00:20:15.000000', 'temperatura', 685.0000, 'ºC'),
	(120060, 108, '2015-04-01 00:20:16.000000', 'temperatura', 1183.0000, 'ºC'),
	(120061, 108, '2015-04-01 00:20:17.000000', 'temperatura', 260.0000, 'ºC'),
	(120062, 108, '2015-04-01 00:20:18.000000', 'temperatura', 153.0000, 'ºC'),
	(120063, 108, '2015-04-01 00:20:19.000000', 'temperatura', 1186.0000, 'ºC'),
	(120064, 108, '2015-04-01 00:20:20.000000', 'temperatura', 672.0000, 'ºC'),
	(120065, 108, '2015-04-01 00:20:21.000000', 'temperatura', 1002.0000, 'ºC'),
	(120066, 108, '2015-04-01 00:20:22.000000', 'temperatura', 593.0000, 'ºC'),
	(120067, 108, '2015-04-01 00:20:23.000000', 'temperatura', 1160.0000, 'ºC'),
	(120068, 108, '2015-04-01 00:20:24.000000', 'temperatura', 421.0000, 'ºC'),
	(120069, 108, '2015-04-01 00:20:25.000000', 'temperatura', 1028.0000, 'ºC'),
	(120070, 108, '2015-04-01 00:20:26.000000', 'temperatura', 277.0000, 'ºC'),
	(120071, 108, '2015-04-01 00:20:27.000000', 'temperatura', 699.0000, 'ºC'),
	(120072, 108, '2015-04-01 00:20:28.000000', 'temperatura', 266.0000, 'ºC'),
	(120073, 108, '2015-04-01 00:20:29.000000', 'temperatura', 433.0000, 'ºC'),
	(120074, 108, '2015-04-01 00:20:30.000000', 'temperatura', 169.0000, 'ºC'),
	(120075, 108, '2015-04-01 00:20:31.000000', 'temperatura', 744.0000, 'ºC'),
	(120076, 108, '2015-04-01 00:20:32.000000', 'temperatura', 813.0000, 'ºC'),
	(120077, 108, '2015-04-01 00:20:33.000000', 'temperatura', 636.0000, 'ºC'),
	(120078, 108, '2015-04-01 00:20:34.000000', 'temperatura', 741.0000, 'ºC'),
	(120079, 108, '2015-04-01 00:20:35.000000', 'temperatura', 598.0000, 'ºC'),
	(120080, 108, '2015-04-01 00:20:36.000000', 'temperatura', 767.0000, 'ºC'),
	(120081, 108, '2015-04-01 00:20:37.000000', 'temperatura', 842.0000, 'ºC'),
	(120082, 108, '2015-04-01 00:20:38.000000', 'temperatura', 711.0000, 'ºC'),
	(120083, 108, '2015-04-01 00:20:39.000000', 'temperatura', 1027.0000, 'ºC'),
	(120084, 108, '2015-04-01 00:20:40.000000', 'temperatura', 603.0000, 'ºC'),
	(120085, 108, '2015-04-01 00:20:41.000000', 'temperatura', 1133.0000, 'ºC'),
	(120086, 108, '2015-04-01 00:20:42.000000', 'temperatura', 259.0000, 'ºC'),
	(120087, 108, '2015-04-01 00:20:43.000000', 'temperatura', 297.0000, 'ºC'),
	(120088, 108, '2015-04-01 00:20:44.000000', 'temperatura', 706.0000, 'ºC'),
	(120089, 108, '2015-04-01 00:20:45.000000', 'temperatura', 241.0000, 'ºC'),
	(120090, 108, '2015-04-01 00:20:46.000000', 'temperatura', 285.0000, 'ºC'),
	(120091, 108, '2015-04-01 00:20:47.000000', 'temperatura', 705.0000, 'ºC'),
	(120092, 108, '2015-04-01 00:20:48.000000', 'temperatura', 269.0000, 'ºC'),
	(120093, 108, '2015-04-01 00:20:49.000000', 'temperatura', 432.0000, 'ºC'),
	(120094, 108, '2015-04-01 00:20:50.000000', 'temperatura', 152.0000, 'ºC'),
	(120095, 108, '2015-04-01 00:20:51.000000', 'temperatura', 666.0000, 'ºC'),
	(120096, 108, '2015-04-01 00:20:52.000000', 'temperatura', 475.0000, 'ºC'),
	(120097, 108, '2015-04-01 00:20:53.000000', 'temperatura', 375.0000, 'ºC'),
	(120098, 108, '2015-04-01 00:20:54.000000', 'temperatura', 450.0000, 'ºC'),
	(120099, 108, '2015-04-01 00:20:55.000000', 'temperatura', 1127.0000, 'ºC'),
	(120100, 108, '2015-04-01 00:20:56.000000', 'temperatura', 684.0000, 'ºC'),
	(120101, 108, '2015-04-01 00:20:57.000000', 'temperatura', 39.0000, 'ºC'),
	(120102, 108, '2015-04-01 00:20:58.000000', 'temperatura', 544.0000, 'ºC'),
	(120103, 108, '2015-04-01 00:20:59.000000', 'temperatura', 206.0000, 'ºC'),
	(120104, 108, '2015-04-01 00:21:00.000000', 'temperatura', 595.0000, 'ºC'),
	(120105, 108, '2015-04-01 00:21:01.000000', 'temperatura', 1159.0000, 'ºC'),
	(120106, 108, '2015-04-01 00:21:02.000000', 'temperatura', 412.0000, 'ºC'),
	(120107, 108, '2015-04-01 00:21:03.000000', 'temperatura', 981.0000, 'ºC'),
	(120108, 108, '2015-04-01 00:21:04.000000', 'temperatura', 72.0000, 'ºC'),
	(120109, 108, '2015-04-01 00:21:05.000000', 'temperatura', 1017.0000, 'ºC'),
	(120110, 108, '2015-04-01 00:21:06.000000', 'temperatura', 71.0000, 'ºC'),
	(120111, 108, '2015-04-01 00:21:07.000000', 'temperatura', 903.0000, 'ºC'),
	(120112, 108, '2015-04-01 00:21:08.000000', 'temperatura', 703.0000, 'ºC'),
	(120113, 108, '2015-04-01 00:21:09.000000', 'temperatura', 807.0000, 'ºC'),
	(120114, 108, '2015-04-01 00:21:10.000000', 'temperatura', 728.0000, 'ºC'),
	(120115, 108, '2015-04-01 00:21:11.000000', 'temperatura', 16.0000, 'ºC'),
	(120116, 108, '2015-04-01 00:21:12.000000', 'temperatura', 300.0000, 'ºC'),
	(120117, 108, '2015-04-01 00:21:13.000000', 'temperatura', 251.0000, 'ºC'),
	(120118, 108, '2015-04-01 00:21:14.000000', 'temperatura', 357.0000, 'ºC'),
	(120119, 108, '2015-04-01 00:21:15.000000', 'temperatura', 1033.0000, 'ºC'),
	(120120, 108, '2015-04-01 00:21:16.000000', 'temperatura', 493.0000, 'ºC'),
	(120121, 108, '2015-04-01 00:21:17.000000', 'temperatura', 568.0000, 'ºC'),
	(120122, 108, '2015-04-01 00:21:18.000000', 'temperatura', 163.0000, 'ºC'),
	(120123, 108, '2015-04-01 00:21:19.000000', 'temperatura', 309.0000, 'ºC'),
	(120124, 108, '2015-04-01 00:21:20.000000', 'temperatura', 1057.0000, 'ºC'),
	(120125, 108, '2015-04-01 00:21:21.000000', 'temperatura', 758.0000, 'ºC'),
	(120126, 108, '2015-04-01 00:21:22.000000', 'temperatura', 620.0000, 'ºC'),
	(120127, 108, '2015-04-01 00:21:23.000000', 'temperatura', 828.0000, 'ºC'),
	(120128, 108, '2015-04-01 00:21:24.000000', 'temperatura', 1079.0000, 'ºC'),
	(120129, 108, '2015-04-01 00:21:25.000000', 'temperatura', 514.0000, 'ºC'),
	(120130, 108, '2015-04-01 00:21:26.000000', 'temperatura', 531.0000, 'ºC'),
	(120131, 108, '2015-04-01 00:21:27.000000', 'temperatura', 1115.0000, 'ºC'),
	(120132, 108, '2015-04-01 00:21:28.000000', 'temperatura', 380.0000, 'ºC'),
	(120133, 108, '2015-04-01 00:21:29.000000', 'temperatura', 958.0000, 'ºC'),
	(120134, 108, '2015-04-01 00:21:30.000000', 'temperatura', 49.0000, 'ºC'),
	(120135, 108, '2015-04-01 00:21:31.000000', 'temperatura', 973.0000, 'ºC'),
	(120136, 108, '2015-04-01 00:21:32.000000', 'temperatura', 1120.0000, 'ºC'),
	(120137, 108, '2015-04-01 00:21:33.000000', 'temperatura', 278.0000, 'ºC'),
	(120138, 108, '2015-04-01 00:21:34.000000', 'temperatura', 433.0000, 'ºC'),
	(120139, 108, '2015-04-01 00:21:35.000000', 'temperatura', 131.0000, 'ºC'),
	(120140, 108, '2015-04-01 00:21:36.000000', 'temperatura', 557.0000, 'ºC'),
	(120141, 108, '2015-04-01 00:21:37.000000', 'temperatura', 1192.0000, 'ºC'),
	(120142, 108, '2015-04-01 00:21:38.000000', 'temperatura', 691.0000, 'ºC'),
	(120143, 108, '2015-04-01 00:21:39.000000', 'temperatura', 1077.0000, 'ºC'),
	(120144, 108, '2015-04-01 00:21:40.000000', 'temperatura', 914.0000, 'ºC'),
	(120145, 108, '2015-04-01 00:21:41.000000', 'temperatura', 139.0000, 'ºC'),
	(120146, 108, '2015-04-01 00:21:42.000000', 'temperatura', 352.0000, 'ºC'),
	(120147, 108, '2015-04-01 00:21:43.000000', 'temperatura', 143.0000, 'ºC'),
	(120148, 108, '2015-04-01 00:21:44.000000', 'temperatura', 859.0000, 'ºC'),
	(120149, 108, '2015-04-01 00:21:45.000000', 'temperatura', 267.0000, 'ºC'),
	(120150, 108, '2015-04-01 00:21:46.000000', 'temperatura', 1158.0000, 'ºC'),
	(120151, 108, '2015-04-01 00:21:47.000000', 'temperatura', 188.0000, 'ºC'),
	(120152, 108, '2015-04-01 00:21:48.000000', 'temperatura', 1068.0000, 'ºC'),
	(120153, 108, '2015-04-01 00:21:49.000000', 'temperatura', 1177.0000, 'ºC'),
	(120154, 108, '2015-04-01 00:21:50.000000', 'temperatura', 281.0000, 'ºC'),
	(120155, 108, '2015-04-01 00:21:51.000000', 'temperatura', 273.0000, 'ºC'),
	(120156, 108, '2015-04-01 00:21:52.000000', 'temperatura', 525.0000, 'ºC'),
	(120157, 108, '2015-04-01 00:21:53.000000', 'temperatura', 605.0000, 'ºC'),
	(120158, 108, '2015-04-01 00:21:54.000000', 'temperatura', 252.0000, 'ºC'),
	(120159, 108, '2015-04-01 00:21:55.000000', 'temperatura', 645.0000, 'ºC'),
	(120160, 108, '2015-04-01 00:21:56.000000', 'temperatura', 69.0000, 'ºC'),
	(120161, 108, '2015-04-01 00:21:57.000000', 'temperatura', 809.0000, 'ºC'),
	(120162, 108, '2015-04-01 00:21:58.000000', 'temperatura', 239.0000, 'ºC'),
	(120163, 108, '2015-04-01 00:21:59.000000', 'temperatura', 1168.0000, 'ºC'),
	(120164, 108, '2015-04-01 00:22:00.000000', 'temperatura', 325.0000, 'ºC'),
	(120165, 108, '2015-04-01 00:22:01.000000', 'temperatura', 520.0000, 'ºC'),
	(120166, 108, '2015-04-01 00:22:02.000000', 'temperatura', 428.0000, 'ºC'),
	(120167, 108, '2015-04-01 00:22:03.000000', 'temperatura', 578.0000, 'ºC'),
	(120168, 108, '2015-04-01 00:22:04.000000', 'temperatura', 407.0000, 'ºC'),
	(120169, 108, '2015-04-01 00:22:05.000000', 'temperatura', 300.0000, 'ºC'),
	(120170, 108, '2015-04-01 00:22:06.000000', 'temperatura', 280.0000, 'ºC'),
	(120171, 108, '2015-04-01 00:22:07.000000', 'temperatura', 503.0000, 'ºC'),
	(120172, 108, '2015-04-01 00:22:08.000000', 'temperatura', 473.0000, 'ºC'),
	(120173, 108, '2015-04-01 00:22:09.000000', 'temperatura', 858.0000, 'ºC'),
	(120174, 108, '2015-04-01 00:22:10.000000', 'temperatura', 471.0000, 'ºC'),
	(120175, 108, '2015-04-01 00:22:11.000000', 'temperatura', 983.0000, 'ºC'),
	(120176, 108, '2015-04-01 00:22:12.000000', 'temperatura', 1101.0000, 'ºC'),
	(120177, 108, '2015-04-01 00:22:13.000000', 'temperatura', 156.0000, 'ºC'),
	(120178, 108, '2015-04-01 00:22:14.000000', 'temperatura', 1078.0000, 'ºC'),
	(120179, 108, '2015-04-01 00:22:15.000000', 'temperatura', 123.0000, 'ºC'),
	(120180, 108, '2015-04-01 00:22:16.000000', 'temperatura', 982.0000, 'ºC'),
	(120181, 108, '2015-04-01 00:22:17.000000', 'temperatura', 943.0000, 'ºC'),
	(120182, 108, '2015-04-01 00:22:18.000000', 'temperatura', 568.0000, 'ºC'),
	(120183, 108, '2015-04-01 00:22:19.000000', 'temperatura', 9.0000, 'ºC'),
	(120184, 108, '2015-04-01 00:22:20.000000', 'temperatura', 745.0000, 'ºC'),
	(120185, 108, '2015-04-01 00:22:21.000000', 'temperatura', 98.0000, 'ºC'),
	(120186, 108, '2015-04-01 00:22:22.000000', 'temperatura', 655.0000, 'ºC'),
	(120187, 108, '2015-04-01 00:22:23.000000', 'temperatura', 583.0000, 'ºC'),
	(120188, 108, '2015-04-01 00:22:24.000000', 'temperatura', 949.0000, 'ºC'),
	(120189, 108, '2015-04-01 00:22:25.000000', 'temperatura', 597.0000, 'ºC'),
	(120190, 108, '2015-04-01 00:22:26.000000', 'temperatura', 140.0000, 'ºC'),
	(120191, 108, '2015-04-01 00:22:27.000000', 'temperatura', 109.0000, 'ºC'),
	(120192, 108, '2015-04-01 00:22:28.000000', 'temperatura', 126.0000, 'ºC'),
	(120193, 108, '2015-04-01 00:22:29.000000', 'temperatura', 303.0000, 'ºC'),
	(120194, 108, '2015-04-01 00:22:30.000000', 'temperatura', 1136.0000, 'ºC'),
	(120195, 108, '2015-04-01 00:22:31.000000', 'temperatura', 1171.0000, 'ºC'),
	(120196, 108, '2015-04-01 00:22:32.000000', 'temperatura', 47.0000, 'ºC'),
	(120197, 108, '2015-04-01 00:22:33.000000', 'temperatura', 324.0000, 'ºC'),
	(120198, 108, '2015-04-01 00:22:34.000000', 'temperatura', 281.0000, 'ºC'),
	(120199, 108, '2015-04-01 00:22:35.000000', 'temperatura', 433.0000, 'ºC'),
	(120200, 108, '2015-04-01 00:22:36.000000', 'temperatura', 124.0000, 'ºC'),
	(120201, 108, '2015-04-01 00:22:37.000000', 'temperatura', 519.0000, 'ºC'),
	(120202, 108, '2015-04-01 00:22:38.000000', 'temperatura', 1026.0000, 'ºC'),
	(120203, 108, '2015-04-01 00:22:39.000000', 'temperatura', 1173.0000, 'ºC'),
	(120204, 108, '2015-04-01 00:22:40.000000', 'temperatura', 386.0000, 'ºC'),
	(120205, 108, '2015-04-01 00:22:41.000000', 'temperatura', 813.0000, 'ºC'),
	(120206, 108, '2015-04-01 00:22:42.000000', 'temperatura', 506.0000, 'ºC'),
	(120207, 108, '2015-04-01 00:22:43.000000', 'temperatura', 92.0000, 'ºC'),
	(120208, 108, '2015-04-01 00:22:44.000000', 'temperatura', 145.0000, 'ºC'),
	(120209, 108, '2015-04-01 00:22:45.000000', 'temperatura', 446.0000, 'ºC'),
	(120210, 108, '2015-04-01 00:22:46.000000', 'temperatura', 597.0000, 'ºC'),
	(120211, 108, '2015-04-01 00:22:47.000000', 'temperatura', 449.0000, 'ºC'),
	(120212, 108, '2015-04-01 00:22:48.000000', 'temperatura', 455.0000, 'ºC'),
	(120213, 108, '2015-04-01 00:22:49.000000', 'temperatura', 929.0000, 'ºC'),
	(120214, 108, '2015-04-01 00:22:50.000000', 'temperatura', 880.0000, 'ºC'),
	(120215, 108, '2015-04-01 00:22:51.000000', 'temperatura', 413.0000, 'ºC'),
	(120216, 108, '2015-04-01 00:22:52.000000', 'temperatura', 625.0000, 'ºC'),
	(120217, 108, '2015-04-01 00:22:53.000000', 'temperatura', 689.0000, 'ºC'),
	(120218, 108, '2015-04-01 00:22:54.000000', 'temperatura', 367.0000, 'ºC'),
	(120219, 108, '2015-04-01 00:22:55.000000', 'temperatura', 970.0000, 'ºC'),
	(120220, 108, '2015-04-01 00:22:56.000000', 'temperatura', 149.0000, 'ºC'),
	(120221, 108, '2015-04-01 00:22:57.000000', 'temperatura', 237.0000, 'ºC'),
	(120222, 108, '2015-04-01 00:22:58.000000', 'temperatura', 739.0000, 'ºC'),
	(120223, 108, '2015-04-01 00:22:59.000000', 'temperatura', 583.0000, 'ºC'),
	(120224, 108, '2015-04-01 00:23:00.000000', 'temperatura', 699.0000, 'ºC'),
	(120225, 108, '2015-04-01 00:23:01.000000', 'temperatura', 547.0000, 'ºC'),
	(120226, 108, '2015-04-01 00:23:02.000000', 'temperatura', 639.0000, 'ºC'),
	(120227, 108, '2015-04-01 00:23:03.000000', 'temperatura', 353.0000, 'ºC'),
	(120228, 108, '2015-04-01 00:23:04.000000', 'temperatura', 1050.0000, 'ºC'),
	(120229, 108, '2015-04-01 00:23:05.000000', 'temperatura', 591.0000, 'ºC'),
	(120230, 108, '2015-04-01 00:23:06.000000', 'temperatura', 1007.0000, 'ºC'),
	(120231, 108, '2015-04-01 00:23:07.000000', 'temperatura', 860.0000, 'ºC'),
	(120232, 108, '2015-04-01 00:23:08.000000', 'temperatura', 79.0000, 'ºC'),
	(120233, 108, '2015-04-01 00:23:09.000000', 'temperatura', 215.0000, 'ºC'),
	(120234, 108, '2015-04-01 00:23:10.000000', 'temperatura', 838.0000, 'ºC'),
	(120235, 108, '2015-04-01 00:23:11.000000', 'temperatura', 1147.0000, 'ºC'),
	(120236, 108, '2015-04-01 00:23:12.000000', 'temperatura', 819.0000, 'ºC'),
	(120237, 108, '2015-04-01 00:23:13.000000', 'temperatura', 656.0000, 'ºC'),
	(120238, 108, '2015-04-01 00:23:14.000000', 'temperatura', 825.0000, 'ºC'),
	(120239, 108, '2015-04-01 00:23:15.000000', 'temperatura', 959.0000, 'ºC'),
	(120240, 108, '2015-04-01 00:23:16.000000', 'temperatura', 1117.0000, 'ºC'),
	(120241, 108, '2015-04-01 00:23:17.000000', 'temperatura', 310.0000, 'ºC'),
	(120242, 108, '2015-04-01 00:23:18.000000', 'temperatura', 598.0000, 'ºC'),
	(120243, 108, '2015-04-01 00:23:19.000000', 'temperatura', 860.0000, 'ºC'),
	(120244, 108, '2015-04-01 00:23:20.000000', 'temperatura', 107.0000, 'ºC'),
	(120245, 108, '2015-04-01 00:23:21.000000', 'temperatura', 356.0000, 'ºC'),
	(120246, 108, '2015-04-01 00:23:22.000000', 'temperatura', 257.0000, 'ºC'),
	(120247, 108, '2015-04-01 00:23:23.000000', 'temperatura', 221.0000, 'ºC'),
	(120248, 108, '2015-04-01 00:23:24.000000', 'temperatura', 332.0000, 'ºC'),
	(120249, 108, '2015-04-01 00:23:25.000000', 'temperatura', 997.0000, 'ºC'),
	(120250, 108, '2015-04-01 00:23:26.000000', 'temperatura', 390.0000, 'ºC'),
	(120251, 108, '2015-04-01 00:23:27.000000', 'temperatura', 159.0000, 'ºC'),
	(120252, 108, '2015-04-01 00:23:28.000000', 'temperatura', 828.0000, 'ºC'),
	(120253, 108, '2015-04-01 00:23:29.000000', 'temperatura', 62.0000, 'ºC'),
	(120254, 108, '2015-04-01 00:23:30.000000', 'temperatura', 225.0000, 'ºC'),
	(120255, 108, '2015-04-01 00:23:31.000000', 'temperatura', 942.0000, 'ºC'),
	(120256, 108, '2015-04-01 00:23:32.000000', 'temperatura', 436.0000, 'ºC'),
	(120257, 108, '2015-04-01 00:23:33.000000', 'temperatura', 553.0000, 'ºC'),
	(120258, 108, '2015-04-01 00:23:34.000000', 'temperatura', 259.0000, 'ºC'),
	(120259, 108, '2015-04-01 00:23:35.000000', 'temperatura', 836.0000, 'ºC'),
	(120260, 108, '2015-04-01 00:23:36.000000', 'temperatura', 1002.0000, 'ºC'),
	(120261, 108, '2015-04-01 00:23:37.000000', 'temperatura', 103.0000, 'ºC'),
	(120262, 108, '2015-04-01 00:23:38.000000', 'temperatura', 1108.0000, 'ºC'),
	(120263, 108, '2015-04-01 00:23:39.000000', 'temperatura', 432.0000, 'ºC'),
	(120264, 108, '2015-04-01 00:23:40.000000', 'temperatura', 37.0000, 'ºC'),
	(120265, 108, '2015-04-01 00:23:41.000000', 'temperatura', 91.0000, 'ºC'),
	(120266, 108, '2015-04-01 00:23:42.000000', 'temperatura', 343.0000, 'ºC'),
	(120267, 108, '2015-04-01 00:23:43.000000', 'temperatura', 242.0000, 'ºC'),
	(120268, 108, '2015-04-01 00:23:44.000000', 'temperatura', 182.0000, 'ºC'),
	(120269, 108, '2015-04-01 00:23:45.000000', 'temperatura', 184.0000, 'ºC'),
	(120270, 108, '2015-04-01 00:23:46.000000', 'temperatura', 375.0000, 'ºC'),
	(120271, 108, '2015-04-01 00:23:47.000000', 'temperatura', 123.0000, 'ºC'),
	(120272, 108, '2015-04-01 00:23:48.000000', 'temperatura', 692.0000, 'ºC'),
	(120273, 108, '2015-04-01 00:23:49.000000', 'temperatura', 692.0000, 'ºC'),
	(120274, 108, '2015-04-01 00:23:50.000000', 'temperatura', 184.0000, 'ºC'),
	(120275, 108, '2015-04-01 00:23:51.000000', 'temperatura', 46.0000, 'ºC'),
	(120276, 108, '2015-04-01 00:23:52.000000', 'temperatura', 875.0000, 'ºC'),
	(120277, 108, '2015-04-01 00:23:53.000000', 'temperatura', 640.0000, 'ºC'),
	(120278, 108, '2015-04-01 00:23:54.000000', 'temperatura', 573.0000, 'ºC'),
	(120279, 108, '2015-04-01 00:23:55.000000', 'temperatura', 946.0000, 'ºC'),
	(120280, 108, '2015-04-01 00:23:56.000000', 'temperatura', 613.0000, 'ºC'),
	(120281, 108, '2015-04-01 00:23:57.000000', 'temperatura', 227.0000, 'ºC'),
	(120282, 108, '2015-04-01 00:23:58.000000', 'temperatura', 498.0000, 'ºC'),
	(120283, 108, '2015-04-01 00:23:59.000000', 'temperatura', 609.0000, 'ºC'),
	(120284, 108, '2015-04-01 00:24:00.000000', 'temperatura', 353.0000, 'ºC'),
	(120285, 108, '2015-04-01 00:24:01.000000', 'temperatura', 1137.0000, 'ºC'),
	(120286, 108, '2015-04-01 00:24:02.000000', 'temperatura', 1027.0000, 'ºC'),
	(120287, 108, '2015-04-01 00:24:03.000000', 'temperatura', 525.0000, 'ºC'),
	(120288, 108, '2015-04-01 00:24:04.000000', 'temperatura', 745.0000, 'ºC'),
	(120289, 108, '2015-04-01 00:24:05.000000', 'temperatura', 948.0000, 'ºC'),
	(120290, 108, '2015-04-01 00:24:06.000000', 'temperatura', 106.0000, 'ºC'),
	(120291, 108, '2015-04-01 00:24:07.000000', 'temperatura', 87.0000, 'ºC'),
	(120292, 108, '2015-04-01 00:24:08.000000', 'temperatura', 118.0000, 'ºC'),
	(120293, 108, '2015-04-01 00:24:09.000000', 'temperatura', 330.0000, 'ºC'),
	(120294, 108, '2015-04-01 00:24:10.000000', 'temperatura', 94.0000, 'ºC'),
	(120295, 108, '2015-04-01 00:24:11.000000', 'temperatura', 683.0000, 'ºC'),
	(120296, 108, '2015-04-01 00:24:12.000000', 'temperatura', 731.0000, 'ºC'),
	(120297, 108, '2015-04-01 00:24:13.000000', 'temperatura', 406.0000, 'ºC'),
	(120298, 108, '2015-04-01 00:24:14.000000', 'temperatura', 1038.0000, 'ºC'),
	(120299, 108, '2015-04-01 00:24:15.000000', 'temperatura', 374.0000, 'ºC'),
	(120300, 108, '2015-04-01 00:24:16.000000', 'temperatura', 1158.0000, 'ºC'),
	(120301, 108, '2015-04-01 00:24:17.000000', 'temperatura', 1067.0000, 'ºC'),
	(120302, 108, '2015-04-01 00:24:18.000000', 'temperatura', 660.0000, 'ºC'),
	(120303, 108, '2015-04-01 00:24:19.000000', 'temperatura', 100.0000, 'ºC'),
	(120304, 108, '2015-04-01 00:24:20.000000', 'temperatura', 923.0000, 'ºC'),
	(120305, 108, '2015-04-01 00:24:21.000000', 'temperatura', 712.0000, 'ºC'),
	(120306, 108, '2015-04-01 00:24:22.000000', 'temperatura', 795.0000, 'ºC'),
	(120307, 108, '2015-04-01 00:24:23.000000', 'temperatura', 637.0000, 'ºC'),
	(120308, 108, '2015-04-01 00:24:24.000000', 'temperatura', 803.0000, 'ºC'),
	(120309, 108, '2015-04-01 00:24:25.000000', 'temperatura', 903.0000, 'ºC'),
	(120310, 108, '2015-04-01 00:24:26.000000', 'temperatura', 906.0000, 'ºC'),
	(120311, 108, '2015-04-01 00:24:27.000000', 'temperatura', 622.0000, 'ºC'),
	(120312, 108, '2015-04-01 00:24:28.000000', 'temperatura', 394.0000, 'ºC'),
	(120313, 108, '2015-04-01 00:24:29.000000', 'temperatura', 104.0000, 'ºC'),
	(120314, 108, '2015-04-01 00:24:30.000000', 'temperatura', 538.0000, 'ºC'),
	(120315, 108, '2015-04-01 00:24:31.000000', 'temperatura', 1177.0000, 'ºC'),
	(120316, 108, '2015-04-01 00:24:32.000000', 'temperatura', 672.0000, 'ºC'),
	(120317, 108, '2015-04-01 00:24:33.000000', 'temperatura', 1031.0000, 'ºC'),
	(120318, 108, '2015-04-01 00:24:34.000000', 'temperatura', 739.0000, 'ºC'),
	(120319, 108, '2015-04-01 00:24:35.000000', 'temperatura', 604.0000, 'ºC'),
	(120320, 108, '2015-04-01 00:24:36.000000', 'temperatura', 801.0000, 'ºC'),
	(120321, 108, '2015-04-01 00:24:37.000000', 'temperatura', 993.0000, 'ºC'),
	(120322, 108, '2015-04-01 00:24:38.000000', 'temperatura', 165.0000, 'ºC'),
	(120323, 108, '2015-04-01 00:24:39.000000', 'temperatura', 246.0000, 'ºC'),
	(120324, 108, '2015-04-01 00:24:40.000000', 'temperatura', 733.0000, 'ºC'),
	(120325, 108, '2015-04-01 00:24:41.000000', 'temperatura', 531.0000, 'ºC'),
	(120326, 108, '2015-04-01 00:24:42.000000', 'temperatura', 455.0000, 'ºC'),
	(120327, 108, '2015-04-01 00:24:43.000000', 'temperatura', 684.0000, 'ºC'),
	(120328, 108, '2015-04-01 00:24:44.000000', 'temperatura', 856.0000, 'ºC'),
	(120329, 108, '2015-04-01 00:24:45.000000', 'temperatura', 1027.0000, 'ºC'),
	(120330, 108, '2015-04-01 00:24:46.000000', 'temperatura', 167.0000, 'ºC'),
	(120331, 108, '2015-04-01 00:24:47.000000', 'temperatura', 154.0000, 'ºC'),
	(120332, 108, '2015-04-01 00:24:48.000000', 'temperatura', 269.0000, 'ºC'),
	(120333, 108, '2015-04-01 00:24:49.000000', 'temperatura', 886.0000, 'ºC'),
	(120334, 108, '2015-04-01 00:24:50.000000', 'temperatura', 21.0000, 'ºC'),
	(120335, 108, '2015-04-01 00:24:51.000000', 'temperatura', 1049.0000, 'ºC'),
	(120336, 108, '2015-04-01 00:24:52.000000', 'temperatura', 381.0000, 'ºC'),
	(120337, 108, '2015-04-01 00:24:53.000000', 'temperatura', 1160.0000, 'ºC'),
	(120338, 108, '2015-04-01 00:24:54.000000', 'temperatura', 1058.0000, 'ºC'),
	(120339, 108, '2015-04-01 00:24:55.000000', 'temperatura', 610.0000, 'ºC'),
	(120340, 108, '2015-04-01 00:24:56.000000', 'temperatura', 1077.0000, 'ºC'),
	(120341, 108, '2015-04-01 00:24:57.000000', 'temperatura', 1155.0000, 'ºC'),
	(120342, 108, '2015-04-01 00:24:58.000000', 'temperatura', 143.0000, 'ºC'),
	(120343, 108, '2015-04-01 00:24:59.000000', 'temperatura', 853.0000, 'ºC'),
	(120344, 108, '2015-04-01 00:25:00.000000', 'temperatura', 236.0000, 'ºC'),
	(120345, 108, '2015-04-01 00:25:01.000000', 'temperatura', 1019.0000, 'ºC'),
	(120346, 108, '2015-04-01 00:25:02.000000', 'temperatura', 791.0000, 'ºC'),
	(120347, 108, '2015-04-01 00:25:03.000000', 'temperatura', 898.0000, 'ºC'),
	(120348, 108, '2015-04-01 00:25:04.000000', 'temperatura', 915.0000, 'ºC'),
	(120349, 108, '2015-04-01 00:25:05.000000', 'temperatura', 683.0000, 'ºC'),
	(120350, 108, '2015-04-01 00:25:06.000000', 'temperatura', 669.0000, 'ºC'),
	(120351, 108, '2015-04-01 00:25:07.000000', 'temperatura', 98.0000, 'ºC'),
	(120352, 108, '2015-04-01 00:25:08.000000', 'temperatura', 884.0000, 'ºC'),
	(120353, 108, '2015-04-01 00:25:09.000000', 'temperatura', 524.0000, 'ºC'),
	(120354, 108, '2015-04-01 00:25:10.000000', 'temperatura', 1169.0000, 'ºC'),
	(120355, 108, '2015-04-01 00:25:11.000000', 'temperatura', 675.0000, 'ºC'),
	(120356, 108, '2015-04-01 00:25:12.000000', 'temperatura', 1066.0000, 'ºC'),
	(120357, 108, '2015-04-01 00:25:13.000000', 'temperatura', 908.0000, 'ºC'),
	(120358, 108, '2015-04-01 00:25:14.000000', 'temperatura', 141.0000, 'ºC'),
	(120359, 108, '2015-04-01 00:25:15.000000', 'temperatura', 380.0000, 'ºC'),
	(120360, 108, '2015-04-01 00:25:16.000000', 'temperatura', 280.0000, 'ºC'),
	(120361, 108, '2015-04-01 00:25:17.000000', 'temperatura', 261.0000, 'ºC'),
	(120362, 108, '2015-04-01 00:25:18.000000', 'temperatura', 463.0000, 'ºC'),
	(120363, 108, '2015-04-01 00:25:19.000000', 'temperatura', 335.0000, 'ºC'),
	(120364, 108, '2015-04-01 00:25:20.000000', 'temperatura', 288.0000, 'ºC'),
	(120365, 108, '2015-04-01 00:25:21.000000', 'temperatura', 432.0000, 'ºC'),
	(120366, 108, '2015-04-01 00:25:22.000000', 'temperatura', 99.0000, 'ºC'),
	(120367, 108, '2015-04-01 00:25:23.000000', 'temperatura', 399.0000, 'ºC'),
	(120368, 108, '2015-04-01 00:25:24.000000', 'temperatura', 499.0000, 'ºC'),
	(120369, 108, '2015-04-01 00:25:25.000000', 'temperatura', 99.0000, 'ºC'),
	(120370, 108, '2015-04-01 00:25:26.000000', 'temperatura', 199.0000, 'ºC'),
	(120371, 108, '2015-04-01 00:25:27.000000', 'temperatura', 696.0000, 'ºC'),
	(120372, 108, '2015-04-01 00:25:28.000000', 'temperatura', 485.0000, 'ºC'),
	(120373, 108, '2015-04-01 00:25:29.000000', 'temperatura', 339.0000, 'ºC'),
	(120374, 108, '2015-04-01 00:25:30.000000', 'temperatura', 239.0000, 'ºC'),
	(120375, 108, '2015-04-01 00:25:31.000000', 'temperatura', 177.0000, 'ºC'),
	(120376, 108, '2015-04-01 00:25:32.000000', 'temperatura', 172.0000, 'ºC'),
	(120377, 108, '2015-04-01 00:25:33.000000', 'temperatura', 327.0000, 'ºC'),
	(120378, 108, '2015-04-01 00:25:34.000000', 'temperatura', 1119.0000, 'ºC'),
	(120379, 108, '2015-04-01 00:25:35.000000', 'temperatura', 1015.0000, 'ºC'),
	(120380, 108, '2015-04-01 00:25:36.000000', 'temperatura', 521.0000, 'ºC'),
	(120381, 108, '2015-04-01 00:25:37.000000', 'temperatura', 758.0000, 'ºC'),
	(120382, 108, '2015-04-01 00:25:38.000000', 'temperatura', 1027.0000, 'ºC'),
	(120383, 108, '2015-04-01 00:25:39.000000', 'temperatura', 463.0000, 'ºC'),
	(120384, 108, '2015-04-01 00:25:40.000000', 'temperatura', 434.0000, 'ºC'),
	(120385, 108, '2015-04-01 00:25:41.000000', 'temperatura', 780.0000, 'ºC'),
	(120386, 108, '2015-04-01 00:25:42.000000', 'temperatura', 199.0000, 'ºC'),
	(120387, 108, '2015-04-01 00:25:43.000000', 'temperatura', 1055.0000, 'ºC'),
	(120388, 108, '2015-04-01 00:25:44.000000', 'temperatura', 1079.0000, 'ºC'),
	(120389, 108, '2015-04-01 00:25:45.000000', 'temperatura', 1032.0000, 'ºC'),
	(120390, 108, '2015-04-01 00:25:46.000000', 'temperatura', 723.0000, 'ºC'),
	(120391, 108, '2015-04-01 00:25:47.000000', 'temperatura', 518.0000, 'ºC'),
	(120392, 108, '2015-04-01 00:25:48.000000', 'temperatura', 421.0000, 'ºC'),
	(120393, 108, '2015-04-01 00:25:49.000000', 'temperatura', 554.0000, 'ºC'),
	(120394, 108, '2015-04-01 00:25:50.000000', 'temperatura', 306.0000, 'ºC'),
	(120395, 108, '2015-04-01 00:25:51.000000', 'temperatura', 1068.0000, 'ºC'),
	(120396, 108, '2015-04-01 00:25:52.000000', 'temperatura', 821.0000, 'ºC'),
	(120397, 108, '2015-04-01 00:25:53.000000', 'temperatura', 904.0000, 'ºC'),
	(120398, 108, '2015-04-01 00:25:54.000000', 'temperatura', 856.0000, 'ºC'),
	(120399, 108, '2015-04-01 00:25:55.000000', 'temperatura', 369.0000, 'ºC'),
	(120400, 108, '2015-04-01 00:25:56.000000', 'temperatura', 477.0000, 'ºC'),
	(120401, 108, '2015-04-01 00:25:57.000000', 'temperatura', 77.0000, 'ºC'),
	(120402, 108, '2015-04-01 00:25:58.000000', 'temperatura', 157.0000, 'ºC'),
	(120403, 108, '2015-04-01 00:25:59.000000', 'temperatura', 554.0000, 'ºC'),
	(120404, 108, '2015-04-01 00:26:00.000000', 'temperatura', 1098.0000, 'ºC'),
	(120405, 108, '2015-04-01 00:26:01.000000', 'temperatura', 229.0000, 'ºC'),
	(120406, 108, '2015-04-01 00:26:02.000000', 'temperatura', 251.0000, 'ºC'),
	(120407, 108, '2015-04-01 00:26:03.000000', 'temperatura', 569.0000, 'ºC'),
	(120408, 108, '2015-04-01 00:26:04.000000', 'temperatura', 894.0000, 'ºC'),
	(120409, 108, '2015-04-01 00:26:05.000000', 'temperatura', 363.0000, 'ºC'),
	(120410, 108, '2015-04-01 00:26:06.000000', 'temperatura', 334.0000, 'ºC'),
	(120411, 108, '2015-04-01 00:26:07.000000', 'temperatura', 581.0000, 'ºC'),
	(120412, 108, '2015-04-01 00:26:08.000000', 'temperatura', 703.0000, 'ºC'),
	(120413, 108, '2015-04-01 00:26:09.000000', 'temperatura', 574.0000, 'ºC'),
	(120414, 108, '2015-04-01 00:26:10.000000', 'temperatura', 761.0000, 'ºC'),
	(120415, 108, '2015-04-01 00:26:11.000000', 'temperatura', 882.0000, 'ºC'),
	(120416, 108, '2015-04-01 00:26:12.000000', 'temperatura', 928.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(120417, 108, '2015-04-01 00:26:13.000000', 'temperatura', 795.0000, 'ºC'),
	(120418, 108, '2015-04-01 00:26:14.000000', 'temperatura', 1189.0000, 'ºC'),
	(120419, 108, '2015-04-01 00:26:15.000000', 'temperatura', 1164.0000, 'ºC'),
	(120420, 108, '2015-04-01 00:26:16.000000', 'temperatura', 1053.0000, 'ºC'),
	(120421, 108, '2015-04-01 00:26:17.000000', 'temperatura', 573.0000, 'ºC'),
	(120422, 108, '2015-04-01 00:26:18.000000', 'temperatura', 907.0000, 'ºC'),
	(120423, 108, '2015-04-01 00:26:19.000000', 'temperatura', 414.0000, 'ºC'),
	(120424, 108, '2015-04-01 00:26:20.000000', 'temperatura', 552.0000, 'ºC'),
	(120425, 108, '2015-04-01 00:26:21.000000', 'temperatura', 318.0000, 'ºC'),
	(120426, 108, '2015-04-01 00:26:22.000000', 'temperatura', 1133.0000, 'ºC'),
	(120427, 108, '2015-04-01 00:26:23.000000', 'temperatura', 1111.0000, 'ºC'),
	(120428, 108, '2015-04-01 00:26:24.000000', 'temperatura', 957.0000, 'ºC'),
	(120429, 108, '2015-04-01 00:26:25.000000', 'temperatura', 252.0000, 'ºC'),
	(120430, 108, '2015-04-01 00:26:26.000000', 'temperatura', 790.0000, 'ºC'),
	(120431, 108, '2015-04-01 00:26:27.000000', 'temperatura', 794.0000, 'ºC'),
	(120432, 108, '2015-04-01 00:26:28.000000', 'temperatura', 402.0000, 'ºC'),
	(120433, 108, '2015-04-01 00:26:29.000000', 'temperatura', 827.0000, 'ºC'),
	(120434, 108, '2015-04-01 00:26:30.000000', 'temperatura', 530.0000, 'ºC'),
	(120435, 108, '2015-04-01 00:26:31.000000', 'temperatura', 168.0000, 'ºC'),
	(120436, 108, '2015-04-01 00:26:32.000000', 'temperatura', 452.0000, 'ºC'),
	(120437, 108, '2015-04-01 00:26:33.000000', 'temperatura', 558.0000, 'ºC'),
	(120438, 108, '2015-04-01 00:26:34.000000', 'temperatura', 235.0000, 'ºC'),
	(120439, 108, '2015-04-01 00:26:35.000000', 'temperatura', 699.0000, 'ºC'),
	(120440, 108, '2015-04-01 00:26:36.000000', 'temperatura', 390.0000, 'ºC'),
	(120441, 108, '2015-04-01 00:26:37.000000', 'temperatura', 1054.0000, 'ºC'),
	(120442, 108, '2015-04-01 00:26:38.000000', 'temperatura', 501.0000, 'ºC'),
	(120443, 108, '2015-04-01 00:26:39.000000', 'temperatura', 542.0000, 'ºC'),
	(120444, 108, '2015-04-01 00:26:40.000000', 'temperatura', 10.0000, 'ºC'),
	(120445, 108, '2015-04-01 00:26:41.000000', 'temperatura', 822.0000, 'ºC'),
	(120446, 108, '2015-04-01 00:26:42.000000', 'temperatura', 480.0000, 'ºC'),
	(120447, 108, '2015-04-01 00:26:43.000000', 'temperatura', 1136.0000, 'ºC'),
	(120448, 108, '2015-04-01 00:26:44.000000', 'temperatura', 642.0000, 'ºC'),
	(120449, 108, '2015-04-01 00:26:45.000000', 'temperatura', 1000.0000, 'ºC'),
	(120450, 108, '2015-04-01 00:26:46.000000', 'temperatura', 677.0000, 'ºC'),
	(120451, 108, '2015-04-01 00:26:47.000000', 'temperatura', 384.0000, 'ºC'),
	(120452, 108, '2015-04-01 00:26:48.000000', 'temperatura', 1092.0000, 'ºC'),
	(120453, 108, '2015-04-01 00:26:49.000000', 'temperatura', 705.0000, 'ºC'),
	(120454, 108, '2015-04-01 00:26:50.000000', 'temperatura', 250.0000, 'ºC'),
	(120455, 108, '2015-04-01 00:26:51.000000', 'temperatura', 336.0000, 'ºC'),
	(120456, 108, '2015-04-01 00:26:52.000000', 'temperatura', 932.0000, 'ºC'),
	(120457, 108, '2015-04-01 00:26:53.000000', 'temperatura', 51.0000, 'ºC'),
	(120458, 108, '2015-04-01 00:26:54.000000', 'temperatura', 1059.0000, 'ºC'),
	(120459, 108, '2015-04-01 00:26:55.000000', 'temperatura', 343.0000, 'ºC'),
	(120460, 108, '2015-04-01 00:26:56.000000', 'temperatura', 939.0000, 'ºC'),
	(120461, 108, '2015-04-01 00:26:57.000000', 'temperatura', 67.0000, 'ºC'),
	(120462, 108, '2015-04-01 00:26:58.000000', 'temperatura', 1119.0000, 'ºC'),
	(120463, 108, '2015-04-01 00:26:59.000000', 'temperatura', 594.0000, 'ºC'),
	(120464, 108, '2015-04-01 00:27:00.000000', 'temperatura', 813.0000, 'ºC'),
	(120465, 108, '2015-04-01 00:27:01.000000', 'temperatura', 1085.0000, 'ºC'),
	(120466, 108, '2015-04-01 00:27:02.000000', 'temperatura', 587.0000, 'ºC'),
	(120467, 108, '2015-04-01 00:27:03.000000', 'temperatura', 877.0000, 'ºC'),
	(120468, 108, '2015-04-01 00:27:04.000000', 'temperatura', 228.0000, 'ºC'),
	(120469, 108, '2015-04-01 00:27:05.000000', 'temperatura', 909.0000, 'ºC'),
	(120470, 108, '2015-04-01 00:27:06.000000', 'temperatura', 260.0000, 'ºC'),
	(120471, 108, '2015-04-01 00:27:07.000000', 'temperatura', 973.0000, 'ºC'),
	(120472, 108, '2015-04-01 00:27:08.000000', 'temperatura', 485.0000, 'ºC'),
	(120473, 108, '2015-04-01 00:27:09.000000', 'temperatura', 708.0000, 'ºC'),
	(120474, 108, '2015-04-01 00:27:10.000000', 'temperatura', 887.0000, 'ºC'),
	(120475, 108, '2015-04-01 00:27:11.000000', 'temperatura', 1110.0000, 'ºC'),
	(120476, 108, '2015-04-01 00:27:12.000000', 'temperatura', 489.0000, 'ºC'),
	(120477, 108, '2015-04-01 00:27:13.000000', 'temperatura', 318.0000, 'ºC'),
	(120478, 108, '2015-04-01 00:27:14.000000', 'temperatura', 122.0000, 'ºC'),
	(120479, 108, '2015-04-01 00:27:15.000000', 'temperatura', 857.0000, 'ºC'),
	(120480, 108, '2015-04-01 00:27:16.000000', 'temperatura', 318.0000, 'ºC'),
	(120481, 108, '2015-04-01 00:27:17.000000', 'temperatura', 222.0000, 'ºC'),
	(120482, 108, '2015-04-01 00:27:18.000000', 'temperatura', 154.0000, 'ºC'),
	(120483, 108, '2015-04-01 00:27:19.000000', 'temperatura', 105.0000, 'ºC'),
	(120484, 108, '2015-04-01 00:27:20.000000', 'temperatura', 66.0000, 'ºC'),
	(120485, 108, '2015-04-01 00:27:21.000000', 'temperatura', 12.0000, 'ºC'),
	(120486, 108, '2015-04-01 00:27:22.000000', 'temperatura', 1064.0000, 'ºC'),
	(120487, 108, '2015-04-01 00:27:23.000000', 'temperatura', 485.0000, 'ºC'),
	(120488, 108, '2015-04-01 00:27:24.000000', 'temperatura', 434.0000, 'ºC'),
	(120489, 108, '2015-04-01 00:27:25.000000', 'temperatura', 716.0000, 'ºC'),
	(120490, 108, '2015-04-01 00:27:26.000000', 'temperatura', 1077.0000, 'ºC'),
	(120491, 108, '2015-04-01 00:27:27.000000', 'temperatura', 838.0000, 'ºC'),
	(120492, 108, '2015-04-01 00:27:28.000000', 'temperatura', 959.0000, 'ºC'),
	(120493, 108, '2015-04-01 00:27:29.000000', 'temperatura', 1082.0000, 'ºC'),
	(120494, 108, '2015-04-01 00:27:30.000000', 'temperatura', 134.0000, 'ºC'),
	(120495, 108, '2015-04-01 00:27:31.000000', 'temperatura', 1026.0000, 'ºC'),
	(120496, 108, '2015-04-01 00:27:32.000000', 'temperatura', 1128.0000, 'ºC'),
	(120497, 108, '2015-04-01 00:27:33.000000', 'temperatura', 162.0000, 'ºC'),
	(120498, 108, '2015-04-01 00:27:34.000000', 'temperatura', 1025.0000, 'ºC'),
	(120499, 108, '2015-04-01 00:27:35.000000', 'temperatura', 1042.0000, 'ºC'),
	(120500, 108, '2015-04-01 00:27:36.000000', 'temperatura', 934.0000, 'ºC'),
	(120501, 108, '2015-04-01 00:27:37.000000', 'temperatura', 346.0000, 'ºC'),
	(120502, 108, '2015-04-01 00:27:38.000000', 'temperatura', 128.0000, 'ºC'),
	(120503, 108, '2015-04-01 00:27:39.000000', 'temperatura', 801.0000, 'ºC'),
	(120504, 108, '2015-04-01 00:27:40.000000', 'temperatura', 21.0000, 'ºC'),
	(120505, 108, '2015-04-01 00:27:41.000000', 'temperatura', 102.0000, 'ºC'),
	(120506, 108, '2015-04-01 00:27:42.000000', 'temperatura', 450.0000, 'ºC'),
	(120507, 108, '2015-04-01 00:27:43.000000', 'temperatura', 741.0000, 'ºC'),
	(120508, 108, '2015-04-01 00:27:44.000000', 'temperatura', 1159.0000, 'ºC'),
	(120509, 108, '2015-04-01 00:27:45.000000', 'temperatura', 1171.0000, 'ºC'),
	(120510, 108, '2015-04-01 00:27:46.000000', 'temperatura', 1178.0000, 'ºC'),
	(120511, 108, '2015-04-01 00:27:47.000000', 'temperatura', 1179.0000, 'ºC'),
	(120512, 108, '2015-04-01 00:27:48.000000', 'temperatura', 1163.0000, 'ºC'),
	(120513, 108, '2015-04-01 00:27:49.000000', 'temperatura', 1076.0000, 'ºC'),
	(120514, 108, '2015-04-01 00:27:50.000000', 'temperatura', 691.0000, 'ºC'),
	(120515, 108, '2015-04-01 00:27:51.000000', 'temperatura', 229.0000, 'ºC'),
	(120516, 108, '2015-04-01 00:27:52.000000', 'temperatura', 273.0000, 'ºC'),
	(120517, 108, '2015-04-01 00:27:53.000000', 'temperatura', 678.0000, 'ºC'),
	(120518, 108, '2015-04-01 00:27:54.000000', 'temperatura', 170.0000, 'ºC'),
	(120519, 108, '2015-04-01 00:27:55.000000', 'temperatura', 19.0000, 'ºC'),
	(120520, 108, '2015-04-01 00:27:56.000000', 'temperatura', 785.0000, 'ºC'),
	(120521, 108, '2015-04-01 00:27:57.000000', 'temperatura', 267.0000, 'ºC'),
	(120522, 108, '2015-04-01 00:27:58.000000', 'temperatura', 182.0000, 'ºC'),
	(120523, 108, '2015-04-01 00:27:59.000000', 'temperatura', 111.0000, 'ºC'),
	(120524, 108, '2015-04-01 00:28:00.000000', 'temperatura', 6.0000, 'ºC'),
	(120525, 108, '2015-04-01 00:28:01.000000', 'temperatura', 899.0000, 'ºC'),
	(120526, 108, '2015-04-01 00:28:02.000000', 'temperatura', 879.0000, 'ºC'),
	(120527, 108, '2015-04-01 00:28:03.000000', 'temperatura', 498.0000, 'ºC'),
	(120528, 108, '2015-04-01 00:28:04.000000', 'temperatura', 1052.0000, 'ºC'),
	(120529, 108, '2015-04-01 00:28:05.000000', 'temperatura', 166.0000, 'ºC'),
	(120530, 108, '2015-04-01 00:28:06.000000', 'temperatura', 74.0000, 'ºC'),
	(120531, 108, '2015-04-01 00:28:07.000000', 'temperatura', 1072.0000, 'ºC'),
	(120532, 108, '2015-04-01 00:28:08.000000', 'temperatura', 339.0000, 'ºC'),
	(120533, 108, '2015-04-01 00:28:09.000000', 'temperatura', 880.0000, 'ºC'),
	(120534, 108, '2015-04-01 00:28:10.000000', 'temperatura', 984.0000, 'ºC'),
	(120535, 108, '2015-04-01 00:28:11.000000', 'temperatura', 1079.0000, 'ºC'),
	(120536, 108, '2015-04-01 00:28:12.000000', 'temperatura', 43.0000, 'ºC'),
	(120537, 108, '2015-04-01 00:28:13.000000', 'temperatura', 580.0000, 'ºC'),
	(120538, 108, '2015-04-01 00:28:14.000000', 'temperatura', 371.0000, 'ºC'),
	(120539, 108, '2015-04-01 00:28:15.000000', 'temperatura', 116.0000, 'ºC'),
	(120540, 108, '2015-04-01 00:28:16.000000', 'temperatura', 665.0000, 'ºC'),
	(120541, 108, '2015-04-01 00:28:17.000000', 'temperatura', 580.0000, 'ºC'),
	(120542, 108, '2015-04-01 00:28:18.000000', 'temperatura', 903.0000, 'ºC'),
	(120543, 108, '2015-04-01 00:28:19.000000', 'temperatura', 376.0000, 'ºC'),
	(120544, 108, '2015-04-01 00:28:20.000000', 'temperatura', 372.0000, 'ºC'),
	(120545, 108, '2015-04-01 00:28:21.000000', 'temperatura', 734.0000, 'ºC'),
	(120546, 108, '2015-04-01 00:28:22.000000', 'temperatura', 152.0000, 'ºC'),
	(120547, 108, '2015-04-01 00:28:23.000000', 'temperatura', 961.0000, 'ºC'),
	(120548, 108, '2015-04-01 00:28:24.000000', 'temperatura', 750.0000, 'ºC'),
	(120549, 108, '2015-04-01 00:28:25.000000', 'temperatura', 868.0000, 'ºC'),
	(120550, 108, '2015-04-01 00:28:26.000000', 'temperatura', 890.0000, 'ºC'),
	(120551, 108, '2015-04-01 00:28:27.000000', 'temperatura', 647.0000, 'ºC'),
	(120552, 108, '2015-04-01 00:28:28.000000', 'temperatura', 565.0000, 'ºC'),
	(120553, 108, '2015-04-01 00:28:29.000000', 'temperatura', 883.0000, 'ºC'),
	(120554, 108, '2015-04-01 00:28:30.000000', 'temperatura', 321.0000, 'ºC'),
	(120555, 108, '2015-04-01 00:28:31.000000', 'temperatura', 156.0000, 'ºC'),
	(120556, 108, '2015-04-01 00:28:32.000000', 'temperatura', 1019.0000, 'ºC'),
	(120557, 108, '2015-04-01 00:28:33.000000', 'temperatura', 1027.0000, 'ºC'),
	(120558, 108, '2015-04-01 00:28:34.000000', 'temperatura', 878.0000, 'ºC'),
	(120559, 108, '2015-04-01 00:28:35.000000', 'temperatura', 108.0000, 'ºC'),
	(120560, 108, '2015-04-01 00:28:36.000000', 'temperatura', 307.0000, 'ºC'),
	(120561, 108, '2015-04-01 00:28:37.000000', 'temperatura', 10.0000, 'ºC'),
	(120562, 108, '2015-04-01 00:28:38.000000', 'temperatura', 331.0000, 'ºC'),
	(120563, 108, '2015-04-01 00:28:39.000000', 'temperatura', 424.0000, 'ºC'),
	(120564, 108, '2015-04-01 00:28:40.000000', 'temperatura', 1130.0000, 'ºC'),
	(120565, 108, '2015-04-01 00:28:41.000000', 'temperatura', 778.0000, 'ºC'),
	(120566, 108, '2015-04-01 00:28:42.000000', 'temperatura', 500.0000, 'ºC'),
	(120567, 108, '2015-04-01 00:28:43.000000', 'temperatura', 166.0000, 'ºC'),
	(120568, 108, '2015-04-01 00:28:44.000000', 'temperatura', 531.0000, 'ºC'),
	(120569, 108, '2015-04-01 00:28:45.000000', 'temperatura', 956.0000, 'ºC'),
	(120570, 108, '2015-04-01 00:28:46.000000', 'temperatura', 787.0000, 'ºC'),
	(120571, 108, '2015-04-01 00:28:47.000000', 'temperatura', 1067.0000, 'ºC'),
	(120572, 108, '2015-04-01 00:28:48.000000', 'temperatura', 574.0000, 'ºC'),
	(120573, 108, '2015-04-01 00:28:49.000000', 'temperatura', 871.0000, 'ºC'),
	(120574, 108, '2015-04-01 00:28:50.000000', 'temperatura', 231.0000, 'ºC'),
	(120575, 108, '2015-04-01 00:28:51.000000', 'temperatura', 945.0000, 'ºC'),
	(120576, 108, '2015-04-01 00:28:52.000000', 'temperatura', 433.0000, 'ºC'),
	(120577, 108, '2015-04-01 00:28:53.000000', 'temperatura', 529.0000, 'ºC'),
	(120578, 108, '2015-04-01 00:28:54.000000', 'temperatura', 149.0000, 'ºC'),
	(120579, 108, '2015-04-01 00:28:55.000000', 'temperatura', 357.0000, 'ºC'),
	(120580, 108, '2015-04-01 00:28:56.000000', 'temperatura', 139.0000, 'ºC'),
	(120581, 108, '2015-04-01 00:28:57.000000', 'temperatura', 826.0000, 'ºC'),
	(120582, 108, '2015-04-01 00:28:58.000000', 'temperatura', 112.0000, 'ºC'),
	(120583, 108, '2015-04-01 00:28:59.000000', 'temperatura', 481.0000, 'ºC'),
	(120584, 108, '2015-04-01 00:29:00.000000', 'temperatura', 871.0000, 'ºC'),
	(120585, 108, '2015-04-01 00:29:01.000000', 'temperatura', 514.0000, 'ºC'),
	(120586, 108, '2015-04-01 00:29:02.000000', 'temperatura', 1155.0000, 'ºC'),
	(120587, 108, '2015-04-01 00:29:03.000000', 'temperatura', 634.0000, 'ºC'),
	(120588, 108, '2015-04-01 00:29:04.000000', 'temperatura', 905.0000, 'ºC'),
	(120589, 108, '2015-04-01 00:29:05.000000', 'temperatura', 224.0000, 'ºC'),
	(120590, 108, '2015-04-01 00:29:06.000000', 'temperatura', 808.0000, 'ºC'),
	(120591, 108, '2015-04-01 00:29:07.000000', 'temperatura', 965.0000, 'ºC'),
	(120592, 108, '2015-04-01 00:29:08.000000', 'temperatura', 2.0000, 'ºC'),
	(120593, 108, '2015-04-01 00:29:09.000000', 'temperatura', 714.0000, 'ºC'),
	(120594, 108, '2015-04-01 00:29:10.000000', 'temperatura', 1167.0000, 'ºC'),
	(120595, 108, '2015-04-01 00:29:11.000000', 'temperatura', 91.0000, 'ºC'),
	(120596, 108, '2015-04-01 00:29:12.000000', 'temperatura', 557.0000, 'ºC'),
	(120597, 108, '2015-04-01 00:29:13.000000', 'temperatura', 110.0000, 'ºC'),
	(120598, 108, '2015-04-01 00:29:14.000000', 'temperatura', 79.0000, 'ºC'),
	(120599, 108, '2015-04-01 00:29:15.000000', 'temperatura', 67.0000, 'ºC'),
	(120600, 108, '2015-04-01 00:29:16.000000', 'temperatura', 97.0000, 'ºC'),
	(120601, 108, '2015-04-01 00:29:17.000000', 'temperatura', 284.0000, 'ºC'),
	(120602, 108, '2015-04-01 00:29:18.000000', 'temperatura', 1132.0000, 'ºC'),
	(120603, 108, '2015-04-01 00:29:19.000000', 'temperatura', 7.0000, 'ºC'),
	(120604, 108, '2015-04-01 00:29:20.000000', 'temperatura', 242.0000, 'ºC'),
	(120605, 108, '2015-04-01 00:29:21.000000', 'temperatura', 1186.0000, 'ºC'),
	(120606, 108, '2015-04-01 00:29:22.000000', 'temperatura', 407.0000, 'ºC'),
	(120607, 108, '2015-04-01 00:29:23.000000', 'temperatura', 878.0000, 'ºC'),
	(120608, 108, '2015-04-01 00:29:24.000000', 'temperatura', 768.0000, 'ºC'),
	(120609, 108, '2015-04-01 00:29:25.000000', 'temperatura', 6.0000, 'ºC'),
	(120610, 108, '2015-04-01 00:29:26.000000', 'temperatura', 128.0000, 'ºC'),
	(120611, 108, '2015-04-01 00:29:27.000000', 'temperatura', 622.0000, 'ºC'),
	(120612, 108, '2015-04-01 00:29:28.000000', 'temperatura', 325.0000, 'ºC'),
	(120613, 108, '2015-04-01 00:29:29.000000', 'temperatura', 962.0000, 'ºC'),
	(120614, 108, '2015-04-01 00:29:30.000000', 'temperatura', 233.0000, 'ºC'),
	(120615, 108, '2015-04-01 00:29:31.000000', 'temperatura', 681.0000, 'ºC'),
	(120616, 108, '2015-04-01 00:29:32.000000', 'temperatura', 305.0000, 'ºC'),
	(120617, 108, '2015-04-01 00:29:33.000000', 'temperatura', 682.0000, 'ºC'),
	(120618, 108, '2015-04-01 00:29:34.000000', 'temperatura', 96.0000, 'ºC'),
	(120619, 108, '2015-04-01 00:29:35.000000', 'temperatura', 835.0000, 'ºC'),
	(120620, 108, '2015-04-01 00:29:36.000000', 'temperatura', 287.0000, 'ºC'),
	(120621, 108, '2015-04-01 00:29:37.000000', 'temperatura', 130.0000, 'ºC'),
	(120622, 108, '2015-04-01 00:29:38.000000', 'temperatura', 992.0000, 'ºC'),
	(120623, 108, '2015-04-01 00:29:39.000000', 'temperatura', 968.0000, 'ºC'),
	(120624, 108, '2015-04-01 00:29:40.000000', 'temperatura', 667.0000, 'ºC'),
	(120625, 108, '2015-04-01 00:29:41.000000', 'temperatura', 429.0000, 'ºC'),
	(120626, 108, '2015-04-01 00:29:42.000000', 'temperatura', 143.0000, 'ºC'),
	(120627, 108, '2015-04-01 00:29:43.000000', 'temperatura', 632.0000, 'ºC'),
	(120628, 108, '2015-04-01 00:29:44.000000', 'temperatura', 330.0000, 'ºC'),
	(120629, 108, '2015-04-01 00:29:45.000000', 'temperatura', 954.0000, 'ºC'),
	(120630, 108, '2015-04-01 00:29:46.000000', 'temperatura', 179.0000, 'ºC'),
	(120631, 108, '2015-04-01 00:29:47.000000', 'temperatura', 437.0000, 'ºC'),
	(120632, 108, '2015-04-01 00:29:48.000000', 'temperatura', 447.0000, 'ºC'),
	(120633, 108, '2015-04-01 00:29:49.000000', 'temperatura', 923.0000, 'ºC'),
	(120634, 108, '2015-04-01 00:29:50.000000', 'temperatura', 878.0000, 'ºC'),
	(120635, 108, '2015-04-01 00:29:51.000000', 'temperatura', 418.0000, 'ºC'),
	(120636, 108, '2015-04-01 00:29:52.000000', 'temperatura', 657.0000, 'ºC'),
	(120637, 108, '2015-04-01 00:29:53.000000', 'temperatura', 830.0000, 'ºC'),
	(120638, 108, '2015-04-01 00:29:54.000000', 'temperatura', 981.0000, 'ºC'),
	(120639, 108, '2015-04-01 00:29:55.000000', 'temperatura', 15.0000, 'ºC'),
	(120640, 108, '2015-04-01 00:29:56.000000', 'temperatura', 732.0000, 'ºC'),
	(120641, 108, '2015-04-01 00:29:57.000000', 'temperatura', 14.0000, 'ºC'),
	(120642, 108, '2015-04-01 00:29:58.000000', 'temperatura', 277.0000, 'ºC'),
	(120643, 108, '2015-04-01 00:29:59.000000', 'temperatura', 144.0000, 'ºC'),
	(120644, 108, '2015-04-01 00:30:00.000000', 'temperatura', 1088.0000, 'ºC'),
	(120645, 108, '2015-04-01 00:30:01.000000', 'temperatura', 207.0000, 'ºC'),
	(120646, 108, '2015-04-01 00:30:02.000000', 'temperatura', 172.0000, 'ºC'),
	(120647, 108, '2015-04-01 00:30:03.000000', 'temperatura', 242.0000, 'ºC'),
	(120648, 108, '2015-04-01 00:30:04.000000', 'temperatura', 692.0000, 'ºC'),
	(120649, 108, '2015-04-01 00:30:05.000000', 'temperatura', 335.0000, 'ºC'),
	(120650, 108, '2015-04-01 00:30:06.000000', 'temperatura', 800.0000, 'ºC'),
	(120651, 108, '2015-04-01 00:30:07.000000', 'temperatura', 595.0000, 'ºC'),
	(120652, 108, '2015-04-01 00:30:08.000000', 'temperatura', 577.0000, 'ºC'),
	(120653, 108, '2015-04-01 00:30:09.000000', 'temperatura', 1101.0000, 'ºC'),
	(120654, 108, '2015-04-01 00:30:10.000000', 'temperatura', 173.0000, 'ºC'),
	(120655, 108, '2015-04-01 00:30:11.000000', 'temperatura', 1162.0000, 'ºC'),
	(120656, 108, '2015-04-01 00:30:12.000000', 'temperatura', 491.0000, 'ºC'),
	(120657, 108, '2015-04-01 00:30:13.000000', 'temperatura', 171.0000, 'ºC'),
	(120658, 108, '2015-04-01 00:30:14.000000', 'temperatura', 580.0000, 'ºC'),
	(120659, 108, '2015-04-01 00:30:15.000000', 'temperatura', 1189.0000, 'ºC'),
	(120660, 108, '2015-04-01 00:30:16.000000', 'temperatura', 605.0000, 'ºC'),
	(120661, 108, '2015-04-01 00:30:17.000000', 'temperatura', 660.0000, 'ºC'),
	(120662, 108, '2015-04-01 00:30:18.000000', 'temperatura', 285.0000, 'ºC'),
	(120663, 108, '2015-04-01 00:30:19.000000', 'temperatura', 645.0000, 'ºC'),
	(120664, 108, '2015-04-01 00:30:20.000000', 'temperatura', 1172.0000, 'ºC'),
	(120665, 108, '2015-04-01 00:30:21.000000', 'temperatura', 323.0000, 'ºC'),
	(120666, 108, '2015-04-01 00:30:22.000000', 'temperatura', 502.0000, 'ºC'),
	(120667, 108, '2015-04-01 00:30:23.000000', 'temperatura', 339.0000, 'ºC'),
	(120668, 108, '2015-04-01 00:30:24.000000', 'temperatura', 192.0000, 'ºC'),
	(120669, 108, '2015-04-01 00:30:25.000000', 'temperatura', 1144.0000, 'ºC'),
	(120670, 108, '2015-04-01 00:30:26.000000', 'temperatura', 345.0000, 'ºC'),
	(120671, 108, '2015-04-01 00:30:27.000000', 'temperatura', 692.0000, 'ºC'),
	(120672, 108, '2015-04-01 00:30:28.000000', 'temperatura', 26.0000, 'ºC'),
	(120673, 108, '2015-04-01 00:30:29.000000', 'temperatura', 455.0000, 'ºC'),
	(120674, 108, '2015-04-01 00:30:30.000000', 'temperatura', 999.0000, 'ºC'),
	(120675, 108, '2015-04-01 00:30:31.000000', 'temperatura', 29.0000, 'ºC'),
	(120676, 108, '2015-04-01 00:30:32.000000', 'temperatura', 749.0000, 'ºC'),
	(120677, 108, '2015-04-01 00:30:33.000000', 'temperatura', 57.0000, 'ºC'),
	(120678, 108, '2015-04-01 00:30:34.000000', 'temperatura', 437.0000, 'ºC'),
	(120679, 108, '2015-04-01 00:30:35.000000', 'temperatura', 818.0000, 'ºC'),
	(120680, 108, '2015-04-01 00:30:36.000000', 'temperatura', 378.0000, 'ºC'),
	(120681, 108, '2015-04-01 00:30:37.000000', 'temperatura', 638.0000, 'ºC'),
	(120682, 108, '2015-04-01 00:30:38.000000', 'temperatura', 857.0000, 'ºC'),
	(120683, 108, '2015-04-01 00:30:39.000000', 'temperatura', 1172.0000, 'ºC'),
	(120684, 108, '2015-04-01 00:30:40.000000', 'temperatura', 888.0000, 'ºC'),
	(120685, 108, '2015-04-01 00:30:41.000000', 'temperatura', 924.0000, 'ºC'),
	(120686, 108, '2015-04-01 00:30:42.000000', 'temperatura', 756.0000, 'ºC'),
	(120687, 108, '2015-04-01 00:30:43.000000', 'temperatura', 1008.0000, 'ºC'),
	(120688, 108, '2015-04-01 00:30:44.000000', 'temperatura', 373.0000, 'ºC'),
	(120689, 108, '2015-04-01 00:30:45.000000', 'temperatura', 41.0000, 'ºC'),
	(120690, 108, '2015-04-01 00:30:46.000000', 'temperatura', 287.0000, 'ºC'),
	(120691, 108, '2015-04-01 00:30:47.000000', 'temperatura', 114.0000, 'ºC'),
	(120692, 108, '2015-04-01 00:30:48.000000', 'temperatura', 907.0000, 'ºC'),
	(120693, 108, '2015-04-01 00:30:49.000000', 'temperatura', 596.0000, 'ºC'),
	(120694, 108, '2015-04-01 00:30:50.000000', 'temperatura', 258.0000, 'ºC'),
	(120695, 108, '2015-04-01 00:30:51.000000', 'temperatura', 704.0000, 'ºC'),
	(120696, 108, '2015-04-01 00:30:52.000000', 'temperatura', 347.0000, 'ºC'),
	(120697, 108, '2015-04-01 00:30:53.000000', 'temperatura', 823.0000, 'ºC'),
	(120698, 108, '2015-04-01 00:30:54.000000', 'temperatura', 675.0000, 'ºC'),
	(120699, 108, '2015-04-01 00:30:55.000000', 'temperatura', 904.0000, 'ºC'),
	(120700, 108, '2015-04-01 00:30:56.000000', 'temperatura', 97.0000, 'ºC'),
	(120701, 108, '2015-04-01 00:30:57.000000', 'temperatura', 175.0000, 'ºC'),
	(120702, 108, '2015-04-01 00:30:58.000000', 'temperatura', 585.0000, 'ºC'),
	(120703, 108, '2015-04-01 00:30:59.000000', 'temperatura', 1.0000, 'ºC'),
	(120704, 108, '2015-04-01 00:31:00.000000', 'temperatura', 651.0000, 'ºC'),
	(120705, 108, '2015-04-01 00:31:01.000000', 'temperatura', 851.0000, 'ºC'),
	(120706, 108, '2015-04-01 00:31:02.000000', 'temperatura', 1102.0000, 'ºC'),
	(120707, 108, '2015-04-01 00:31:03.000000', 'temperatura', 557.0000, 'ºC'),
	(120708, 108, '2015-04-01 00:31:04.000000', 'temperatura', 682.0000, 'ºC'),
	(120709, 108, '2015-04-01 00:31:05.000000', 'temperatura', 537.0000, 'ºC'),
	(120710, 108, '2015-04-01 00:31:06.000000', 'temperatura', 640.0000, 'ºC'),
	(120711, 108, '2015-04-01 00:31:07.000000', 'temperatura', 391.0000, 'ºC'),
	(120712, 108, '2015-04-01 00:31:08.000000', 'temperatura', 37.0000, 'ºC'),
	(120713, 108, '2015-04-01 00:31:09.000000', 'temperatura', 209.0000, 'ºC'),
	(120714, 108, '2015-04-01 00:31:10.000000', 'temperatura', 936.0000, 'ºC'),
	(120715, 108, '2015-04-01 00:31:11.000000', 'temperatura', 455.0000, 'ºC'),
	(120716, 108, '2015-04-01 00:31:12.000000', 'temperatura', 665.0000, 'ºC'),
	(120717, 108, '2015-04-01 00:31:13.000000', 'temperatura', 761.0000, 'ºC'),
	(120718, 108, '2015-04-01 00:31:14.000000', 'temperatura', 610.0000, 'ºC'),
	(120719, 108, '2015-04-01 00:31:15.000000', 'temperatura', 766.0000, 'ºC'),
	(120720, 108, '2015-04-01 00:31:16.000000', 'temperatura', 804.0000, 'ºC'),
	(120721, 108, '2015-04-01 00:31:17.000000', 'temperatura', 520.0000, 'ºC'),
	(120722, 108, '2015-04-01 00:31:18.000000', 'temperatura', 187.0000, 'ºC'),
	(120723, 108, '2015-04-01 00:31:19.000000', 'temperatura', 578.0000, 'ºC'),
	(120724, 108, '2015-04-01 00:31:20.000000', 'temperatura', 1128.0000, 'ºC'),
	(120725, 108, '2015-04-01 00:31:21.000000', 'temperatura', 308.0000, 'ºC'),
	(120726, 108, '2015-04-01 00:31:22.000000', 'temperatura', 556.0000, 'ºC'),
	(120727, 108, '2015-04-01 00:31:23.000000', 'temperatura', 658.0000, 'ºC'),
	(120728, 108, '2015-04-01 00:31:24.000000', 'temperatura', 420.0000, 'ºC'),
	(120729, 108, '2015-04-01 00:31:25.000000', 'temperatura', 129.0000, 'ºC'),
	(120730, 108, '2015-04-01 00:31:26.000000', 'temperatura', 585.0000, 'ºC'),
	(120731, 108, '2015-04-01 00:31:27.000000', 'temperatura', 140.0000, 'ºC'),
	(120732, 108, '2015-04-01 00:31:28.000000', 'temperatura', 143.0000, 'ºC'),
	(120733, 108, '2015-04-01 00:31:29.000000', 'temperatura', 297.0000, 'ºC'),
	(120734, 108, '2015-04-01 00:31:30.000000', 'temperatura', 1058.0000, 'ºC'),
	(120735, 108, '2015-04-01 00:31:31.000000', 'temperatura', 797.0000, 'ºC'),
	(120736, 108, '2015-04-01 00:31:32.000000', 'temperatura', 813.0000, 'ºC'),
	(120737, 108, '2015-04-01 00:31:33.000000', 'temperatura', 476.0000, 'ºC'),
	(120738, 108, '2015-04-01 00:31:34.000000', 'temperatura', 1140.0000, 'ºC'),
	(120739, 108, '2015-04-01 00:31:35.000000', 'temperatura', 672.0000, 'ºC'),
	(120740, 108, '2015-04-01 00:31:36.000000', 'temperatura', 1139.0000, 'ºC'),
	(120741, 108, '2015-04-01 00:31:37.000000', 'temperatura', 81.0000, 'ºC'),
	(120742, 108, '2015-04-01 00:31:38.000000', 'temperatura', 590.0000, 'ºC'),
	(120743, 108, '2015-04-01 00:31:39.000000', 'temperatura', 305.0000, 'ºC'),
	(120744, 108, '2015-04-01 00:31:40.000000', 'temperatura', 956.0000, 'ºC'),
	(120745, 108, '2015-04-01 00:31:41.000000', 'temperatura', 264.0000, 'ºC'),
	(120746, 108, '2015-04-01 00:31:42.000000', 'temperatura', 853.0000, 'ºC'),
	(120747, 108, '2015-04-01 00:31:43.000000', 'temperatura', 1076.0000, 'ºC'),
	(120748, 108, '2015-04-01 00:31:44.000000', 'temperatura', 418.0000, 'ºC'),
	(120749, 108, '2015-04-01 00:31:45.000000', 'temperatura', 65.0000, 'ºC'),
	(120750, 108, '2015-04-01 00:31:46.000000', 'temperatura', 273.0000, 'ºC'),
	(120751, 108, '2015-04-01 00:31:47.000000', 'temperatura', 1167.0000, 'ºC'),
	(120752, 108, '2015-04-01 00:31:48.000000', 'temperatura', 217.0000, 'ºC'),
	(120753, 108, '2015-04-01 00:31:49.000000', 'temperatura', 1187.0000, 'ºC'),
	(120754, 108, '2015-04-01 00:31:50.000000', 'temperatura', 484.0000, 'ºC'),
	(120755, 108, '2015-04-01 00:31:51.000000', 'temperatura', 60.0000, 'ºC'),
	(120756, 108, '2015-04-01 00:31:52.000000', 'temperatura', 48.0000, 'ºC'),
	(120757, 108, '2015-04-01 00:31:53.000000', 'temperatura', 60.0000, 'ºC'),
	(120758, 108, '2015-04-01 00:31:54.000000', 'temperatura', 155.0000, 'ºC'),
	(120759, 108, '2015-04-01 00:31:55.000000', 'temperatura', 598.0000, 'ºC'),
	(120760, 108, '2015-04-01 00:31:56.000000', 'temperatura', 126.0000, 'ºC'),
	(120761, 108, '2015-04-01 00:31:57.000000', 'temperatura', 37.0000, 'ºC'),
	(120762, 108, '2015-04-01 00:31:58.000000', 'temperatura', 1007.0000, 'ºC'),
	(120763, 108, '2015-04-01 00:31:59.000000', 'temperatura', 124.0000, 'ºC'),
	(120764, 108, '2015-04-01 00:32:00.000000', 'temperatura', 1198.0000, 'ºC'),
	(120765, 108, '2015-04-01 00:32:01.000000', 'temperatura', 821.0000, 'ºC'),
	(120766, 108, '2015-04-01 00:32:02.000000', 'temperatura', 509.0000, 'ºC'),
	(120767, 108, '2015-04-01 00:32:03.000000', 'temperatura', 85.0000, 'ºC'),
	(120768, 108, '2015-04-01 00:32:04.000000', 'temperatura', 97.0000, 'ºC'),
	(120769, 108, '2015-04-01 00:32:05.000000', 'temperatura', 229.0000, 'ºC'),
	(120770, 108, '2015-04-01 00:32:06.000000', 'temperatura', 857.0000, 'ºC'),
	(120771, 108, '2015-04-01 00:32:07.000000', 'temperatura', 1198.0000, 'ºC'),
	(120772, 108, '2015-04-01 00:32:08.000000', 'temperatura', 1019.0000, 'ºC'),
	(120773, 108, '2015-04-01 00:32:09.000000', 'temperatura', 302.0000, 'ºC'),
	(120774, 108, '2015-04-01 00:32:10.000000', 'temperatura', 852.0000, 'ºC'),
	(120775, 108, '2015-04-01 00:32:11.000000', 'temperatura', 954.0000, 'ºC'),
	(120776, 108, '2015-04-01 00:32:12.000000', 'temperatura', 1014.0000, 'ºC'),
	(120777, 108, '2015-04-01 00:32:13.000000', 'temperatura', 1010.0000, 'ºC'),
	(120778, 108, '2015-04-01 00:32:14.000000', 'temperatura', 808.0000, 'ºC'),
	(120779, 108, '2015-04-01 00:32:15.000000', 'temperatura', 1010.0000, 'ºC'),
	(120780, 108, '2015-04-01 00:32:16.000000', 'temperatura', 227.0000, 'ºC'),
	(120781, 108, '2015-04-01 00:32:17.000000', 'temperatura', 506.0000, 'ºC'),
	(120782, 108, '2015-04-01 00:32:18.000000', 'temperatura', 649.0000, 'ºC'),
	(120783, 108, '2015-04-01 00:32:19.000000', 'temperatura', 526.0000, 'ºC'),
	(120784, 108, '2015-04-01 00:32:20.000000', 'temperatura', 685.0000, 'ºC'),
	(120785, 108, '2015-04-01 00:32:21.000000', 'temperatura', 648.0000, 'ºC'),
	(120786, 108, '2015-04-01 00:32:22.000000', 'temperatura', 1186.0000, 'ºC'),
	(120787, 108, '2015-04-01 00:32:23.000000', 'temperatura', 387.0000, 'ºC'),
	(120788, 108, '2015-04-01 00:32:24.000000', 'temperatura', 778.0000, 'ºC'),
	(120789, 108, '2015-04-01 00:32:25.000000', 'temperatura', 330.0000, 'ºC'),
	(120790, 108, '2015-04-01 00:32:26.000000', 'temperatura', 517.0000, 'ºC'),
	(120791, 108, '2015-04-01 00:32:27.000000', 'temperatura', 394.0000, 'ºC'),
	(120792, 108, '2015-04-01 00:32:28.000000', 'temperatura', 421.0000, 'ºC'),
	(120793, 108, '2015-04-01 00:32:29.000000', 'temperatura', 924.0000, 'ºC'),
	(120794, 108, '2015-04-01 00:32:30.000000', 'temperatura', 956.0000, 'ºC'),
	(120795, 108, '2015-04-01 00:32:31.000000', 'temperatura', 810.0000, 'ºC'),
	(120796, 108, '2015-04-01 00:32:32.000000', 'temperatura', 1184.0000, 'ºC'),
	(120797, 108, '2015-04-01 00:32:33.000000', 'temperatura', 1087.0000, 'ºC'),
	(120798, 108, '2015-04-01 00:32:34.000000', 'temperatura', 685.0000, 'ºC'),
	(120799, 108, '2015-04-01 00:32:35.000000', 'temperatura', 166.0000, 'ºC'),
	(120800, 108, '2015-04-01 00:32:36.000000', 'temperatura', 1174.0000, 'ºC'),
	(120801, 108, '2015-04-01 00:32:37.000000', 'temperatura', 575.0000, 'ºC'),
	(120802, 108, '2015-04-01 00:32:38.000000', 'temperatura', 550.0000, 'ºC'),
	(120803, 108, '2015-04-01 00:32:39.000000', 'temperatura', 1028.0000, 'ºC'),
	(120804, 108, '2015-04-01 00:32:40.000000', 'temperatura', 1090.0000, 'ºC'),
	(120805, 108, '2015-04-01 00:32:41.000000', 'temperatura', 1165.0000, 'ºC'),
	(120806, 108, '2015-04-01 00:32:42.000000', 'temperatura', 155.0000, 'ºC'),
	(120807, 108, '2015-04-01 00:32:43.000000', 'temperatura', 882.0000, 'ºC'),
	(120808, 108, '2015-04-01 00:32:44.000000', 'temperatura', 344.0000, 'ºC'),
	(120809, 108, '2015-04-01 00:32:45.000000', 'temperatura', 276.0000, 'ºC'),
	(120810, 108, '2015-04-01 00:32:46.000000', 'temperatura', 347.0000, 'ºC'),
	(120811, 108, '2015-04-01 00:32:47.000000', 'temperatura', 908.0000, 'ºC'),
	(120812, 108, '2015-04-01 00:32:48.000000', 'temperatura', 1099.0000, 'ºC'),
	(120813, 108, '2015-04-01 00:32:49.000000', 'temperatura', 373.0000, 'ºC'),
	(120814, 108, '2015-04-01 00:32:50.000000', 'temperatura', 967.0000, 'ºC'),
	(120815, 108, '2015-04-01 00:32:51.000000', 'temperatura', 115.0000, 'ºC'),
	(120816, 108, '2015-04-01 00:32:52.000000', 'temperatura', 77.0000, 'ºC'),
	(120817, 108, '2015-04-01 00:32:53.000000', 'temperatura', 38.0000, 'ºC'),
	(120818, 108, '2015-04-01 00:32:54.000000', 'temperatura', 1161.0000, 'ºC'),
	(120819, 108, '2015-04-01 00:32:55.000000', 'temperatura', 890.0000, 'ºC'),
	(120820, 108, '2015-04-01 00:32:56.000000', 'temperatura', 968.0000, 'ºC'),
	(120821, 108, '2015-04-01 00:32:57.000000', 'temperatura', 970.0000, 'ºC'),
	(120822, 108, '2015-04-01 00:32:58.000000', 'temperatura', 746.0000, 'ºC'),
	(120823, 108, '2015-04-01 00:32:59.000000', 'temperatura', 820.0000, 'ºC'),
	(120824, 108, '2015-04-01 00:33:00.000000', 'temperatura', 664.0000, 'ºC'),
	(120825, 108, '2015-04-01 00:33:01.000000', 'temperatura', 858.0000, 'ºC'),
	(120826, 108, '2015-04-01 00:33:02.000000', 'temperatura', 1100.0000, 'ºC'),
	(120827, 108, '2015-04-01 00:33:03.000000', 'temperatura', 524.0000, 'ºC'),
	(120828, 108, '2015-04-01 00:33:04.000000', 'temperatura', 524.0000, 'ºC'),
	(120829, 108, '2015-04-01 00:33:05.000000', 'temperatura', 1048.0000, 'ºC'),
	(120830, 108, '2015-04-01 00:33:06.000000', 'temperatura', 69.0000, 'ºC'),
	(120831, 108, '2015-04-01 00:33:07.000000', 'temperatura', 800.0000, 'ºC'),
	(120832, 108, '2015-04-01 00:33:08.000000', 'temperatura', 193.0000, 'ºC'),
	(120833, 108, '2015-04-01 00:33:09.000000', 'temperatura', 965.0000, 'ºC'),
	(120834, 108, '2015-04-01 00:33:10.000000', 'temperatura', 648.0000, 'ºC'),
	(120835, 108, '2015-04-01 00:33:11.000000', 'temperatura', 344.0000, 'ºC'),
	(120836, 108, '2015-04-01 00:33:12.000000', 'temperatura', 977.0000, 'ºC'),
	(120837, 108, '2015-04-01 00:33:13.000000', 'temperatura', 253.0000, 'ºC'),
	(120838, 108, '2015-04-01 00:33:14.000000', 'temperatura', 736.0000, 'ºC'),
	(120839, 108, '2015-04-01 00:33:15.000000', 'temperatura', 521.0000, 'ºC'),
	(120840, 108, '2015-04-01 00:33:16.000000', 'temperatura', 397.0000, 'ºC'),
	(120841, 108, '2015-04-01 00:33:17.000000', 'temperatura', 421.0000, 'ºC'),
	(120842, 108, '2015-04-01 00:33:18.000000', 'temperatura', 917.0000, 'ºC'),
	(120843, 108, '2015-04-01 00:33:19.000000', 'temperatura', 922.0000, 'ºC'),
	(120844, 108, '2015-04-01 00:33:20.000000', 'temperatura', 657.0000, 'ºC'),
	(120845, 108, '2015-04-01 00:33:21.000000', 'temperatura', 522.0000, 'ºC'),
	(120846, 108, '2015-04-01 00:33:22.000000', 'temperatura', 641.0000, 'ºC'),
	(120847, 108, '2015-04-01 00:33:23.000000', 'temperatura', 436.0000, 'ºC'),
	(120848, 108, '2015-04-01 00:33:24.000000', 'temperatura', 259.0000, 'ºC'),
	(120849, 108, '2015-04-01 00:33:25.000000', 'temperatura', 1189.0000, 'ºC'),
	(120850, 108, '2015-04-01 00:33:26.000000', 'temperatura', 368.0000, 'ºC'),
	(120851, 108, '2015-04-01 00:33:27.000000', 'temperatura', 672.0000, 'ºC'),
	(120852, 108, '2015-04-01 00:33:28.000000', 'temperatura', 1059.0000, 'ºC'),
	(120853, 108, '2015-04-01 00:33:29.000000', 'temperatura', 879.0000, 'ºC'),
	(120854, 108, '2015-04-01 00:33:30.000000', 'temperatura', 19.0000, 'ºC'),
	(120855, 108, '2015-04-01 00:33:31.000000', 'temperatura', 1056.0000, 'ºC'),
	(120856, 108, '2015-04-01 00:33:32.000000', 'temperatura', 424.0000, 'ºC'),
	(120857, 108, '2015-04-01 00:33:33.000000', 'temperatura', 153.0000, 'ºC'),
	(120858, 108, '2015-04-01 00:33:34.000000', 'temperatura', 693.0000, 'ºC'),
	(120859, 108, '2015-04-01 00:33:35.000000', 'temperatura', 607.0000, 'ºC'),
	(120860, 108, '2015-04-01 00:33:36.000000', 'temperatura', 958.0000, 'ºC'),
	(120861, 108, '2015-04-01 00:33:37.000000', 'temperatura', 568.0000, 'ºC'),
	(120862, 108, '2015-04-01 00:33:38.000000', 'temperatura', 1167.0000, 'ºC'),
	(120863, 108, '2015-04-01 00:33:39.000000', 'temperatura', 530.0000, 'ºC'),
	(120864, 108, '2015-04-01 00:33:40.000000', 'temperatura', 349.0000, 'ºC'),
	(120865, 108, '2015-04-01 00:33:41.000000', 'temperatura', 157.0000, 'ºC'),
	(120866, 108, '2015-04-01 00:33:42.000000', 'temperatura', 938.0000, 'ºC'),
	(120867, 108, '2015-04-01 00:33:43.000000', 'temperatura', 621.0000, 'ºC'),
	(120868, 108, '2015-04-01 00:33:44.000000', 'temperatura', 290.0000, 'ºC'),
	(120869, 108, '2015-04-01 00:33:45.000000', 'temperatura', 787.0000, 'ºC'),
	(120870, 108, '2015-04-01 00:33:46.000000', 'temperatura', 666.0000, 'ºC'),
	(120871, 108, '2015-04-01 00:33:47.000000', 'temperatura', 970.0000, 'ºC'),
	(120872, 108, '2015-04-01 00:33:48.000000', 'temperatura', 452.0000, 'ºC'),
	(120873, 108, '2015-04-01 00:33:49.000000', 'temperatura', 551.0000, 'ºC'),
	(120874, 108, '2015-04-01 00:33:50.000000', 'temperatura', 200.0000, 'ºC'),
	(120875, 108, '2015-04-01 00:33:51.000000', 'temperatura', 546.0000, 'ºC'),
	(120876, 108, '2015-04-01 00:33:52.000000', 'temperatura', 930.0000, 'ºC'),
	(120877, 108, '2015-04-01 00:33:53.000000', 'temperatura', 615.0000, 'ºC'),
	(120878, 108, '2015-04-01 00:33:54.000000', 'temperatura', 285.0000, 'ºC'),
	(120879, 108, '2015-04-01 00:33:55.000000', 'temperatura', 782.0000, 'ºC'),
	(120880, 108, '2015-04-01 00:33:56.000000', 'temperatura', 653.0000, 'ºC'),
	(120881, 108, '2015-04-01 00:33:57.000000', 'temperatura', 922.0000, 'ºC'),
	(120882, 108, '2015-04-01 00:33:58.000000', 'temperatura', 249.0000, 'ºC'),
	(120883, 108, '2015-04-01 00:33:59.000000', 'temperatura', 878.0000, 'ºC'),
	(120884, 108, '2015-04-01 00:34:00.000000', 'temperatura', 47.0000, 'ºC'),
	(120885, 108, '2015-04-01 00:34:01.000000', 'temperatura', 1199.0000, 'ºC'),
	(120886, 108, '2015-04-01 00:34:02.000000', 'temperatura', 1054.0000, 'ºC'),
	(120887, 108, '2015-04-01 00:34:03.000000', 'temperatura', 475.0000, 'ºC'),
	(120888, 108, '2015-04-01 00:34:04.000000', 'temperatura', 412.0000, 'ºC'),
	(120889, 108, '2015-04-01 00:34:05.000000', 'temperatura', 637.0000, 'ºC'),
	(120890, 108, '2015-04-01 00:34:06.000000', 'temperatura', 747.0000, 'ºC'),
	(120891, 108, '2015-04-01 00:34:07.000000', 'temperatura', 627.0000, 'ºC'),
	(120892, 108, '2015-04-01 00:34:08.000000', 'temperatura', 895.0000, 'ºC'),
	(120893, 108, '2015-04-01 00:34:09.000000', 'temperatura', 194.0000, 'ºC'),
	(120894, 108, '2015-04-01 00:34:10.000000', 'temperatura', 683.0000, 'ºC'),
	(120895, 108, '2015-04-01 00:34:11.000000', 'temperatura', 436.0000, 'ºC'),
	(120896, 108, '2015-04-01 00:34:12.000000', 'temperatura', 131.0000, 'ºC'),
	(120897, 108, '2015-04-01 00:34:13.000000', 'temperatura', 546.0000, 'ºC'),
	(120898, 108, '2015-04-01 00:34:14.000000', 'temperatura', 1140.0000, 'ºC'),
	(120899, 108, '2015-04-01 00:34:15.000000', 'temperatura', 461.0000, 'ºC'),
	(120900, 108, '2015-04-01 00:34:16.000000', 'temperatura', 86.0000, 'ºC'),
	(120901, 108, '2015-04-01 00:34:17.000000', 'temperatura', 248.0000, 'ºC'),
	(120902, 108, '2015-04-01 00:34:18.000000', 'temperatura', 980.0000, 'ºC'),
	(120903, 108, '2015-04-01 00:34:19.000000', 'temperatura', 559.0000, 'ºC'),
	(120904, 108, '2015-04-01 00:34:20.000000', 'temperatura', 1054.0000, 'ºC'),
	(120905, 108, '2015-04-01 00:34:21.000000', 'temperatura', 1192.0000, 'ºC'),
	(120906, 108, '2015-04-01 00:34:22.000000', 'temperatura', 402.0000, 'ºC'),
	(120907, 108, '2015-04-01 00:34:23.000000', 'temperatura', 833.0000, 'ºC'),
	(120908, 108, '2015-04-01 00:34:24.000000', 'temperatura', 560.0000, 'ºC'),
	(120909, 108, '2015-04-01 00:34:25.000000', 'temperatura', 299.0000, 'ºC'),
	(120910, 108, '2015-04-01 00:34:26.000000', 'temperatura', 1019.0000, 'ºC'),
	(120911, 108, '2015-04-01 00:34:27.000000', 'temperatura', 598.0000, 'ºC'),
	(120912, 108, '2015-04-01 00:34:28.000000', 'temperatura', 1131.0000, 'ºC'),
	(120913, 108, '2015-04-01 00:34:29.000000', 'temperatura', 262.0000, 'ºC'),
	(120914, 108, '2015-04-01 00:34:30.000000', 'temperatura', 317.0000, 'ºC'),
	(120915, 108, '2015-04-01 00:34:31.000000', 'temperatura', 801.0000, 'ºC'),
	(120916, 108, '2015-04-01 00:34:32.000000', 'temperatura', 653.0000, 'ºC'),
	(120917, 108, '2015-04-01 00:34:33.000000', 'temperatura', 861.0000, 'ºC'),
	(120918, 108, '2015-04-01 00:34:34.000000', 'temperatura', 1150.0000, 'ºC'),
	(120919, 108, '2015-04-01 00:34:35.000000', 'temperatura', 765.0000, 'ºC'),
	(120920, 108, '2015-04-01 00:34:36.000000', 'temperatura', 378.0000, 'ºC'),
	(120921, 108, '2015-04-01 00:34:37.000000', 'temperatura', 795.0000, 'ºC'),
	(120922, 108, '2015-04-01 00:34:38.000000', 'temperatura', 443.0000, 'ºC'),
	(120923, 108, '2015-04-01 00:34:39.000000', 'temperatura', 1027.0000, 'ºC'),
	(120924, 108, '2015-04-01 00:34:40.000000', 'temperatura', 210.0000, 'ºC'),
	(120925, 108, '2015-04-01 00:34:41.000000', 'temperatura', 368.0000, 'ºC'),
	(120926, 108, '2015-04-01 00:34:42.000000', 'temperatura', 9.0000, 'ºC'),
	(120927, 108, '2015-04-01 00:34:43.000000', 'temperatura', 144.0000, 'ºC'),
	(120928, 108, '2015-04-01 00:34:44.000000', 'temperatura', 694.0000, 'ºC'),
	(120929, 108, '2015-04-01 00:34:45.000000', 'temperatura', 637.0000, 'ºC'),
	(120930, 108, '2015-04-01 00:34:46.000000', 'temperatura', 1104.0000, 'ºC'),
	(120931, 108, '2015-04-01 00:34:47.000000', 'temperatura', 9.0000, 'ºC'),
	(120932, 108, '2015-04-01 00:34:48.000000', 'temperatura', 336.0000, 'ºC'),
	(120933, 108, '2015-04-01 00:34:49.000000', 'temperatura', 452.0000, 'ºC'),
	(120934, 108, '2015-04-01 00:34:50.000000', 'temperatura', 50.0000, 'ºC'),
	(120935, 108, '2015-04-01 00:34:51.000000', 'temperatura', 98.0000, 'ºC'),
	(120936, 108, '2015-04-01 00:34:52.000000', 'temperatura', 339.0000, 'ºC'),
	(120937, 108, '2015-04-01 00:34:53.000000', 'temperatura', 203.0000, 'ºC'),
	(120938, 108, '2015-04-01 00:34:54.000000', 'temperatura', 1196.0000, 'ºC'),
	(120939, 108, '2015-04-01 00:34:55.000000', 'temperatura', 572.0000, 'ºC'),
	(120940, 108, '2015-04-01 00:34:56.000000', 'temperatura', 474.0000, 'ºC'),
	(120941, 108, '2015-04-01 00:34:57.000000', 'temperatura', 655.0000, 'ºC'),
	(120942, 108, '2015-04-01 00:34:58.000000', 'temperatura', 652.0000, 'ºC'),
	(120943, 108, '2015-04-01 00:34:59.000000', 'temperatura', 94.0000, 'ºC'),
	(120944, 108, '2015-04-01 00:35:00.000000', 'temperatura', 915.0000, 'ºC'),
	(120945, 108, '2015-04-01 00:35:01.000000', 'temperatura', 695.0000, 'ºC'),
	(120946, 108, '2015-04-01 00:35:02.000000', 'temperatura', 731.0000, 'ºC'),
	(120947, 108, '2015-04-01 00:35:03.000000', 'temperatura', 370.0000, 'ºC'),
	(120948, 108, '2015-04-01 00:35:04.000000', 'temperatura', 856.0000, 'ºC'),
	(120949, 108, '2015-04-01 00:35:05.000000', 'temperatura', 773.0000, 'ºC'),
	(120950, 108, '2015-04-01 00:35:06.000000', 'temperatura', 98.0000, 'ºC'),
	(120951, 108, '2015-04-01 00:35:07.000000', 'temperatura', 571.0000, 'ºC'),
	(120952, 108, '2015-04-01 00:35:08.000000', 'temperatura', 163.0000, 'ºC'),
	(120953, 108, '2015-04-01 00:35:09.000000', 'temperatura', 300.0000, 'ºC'),
	(120954, 108, '2015-04-01 00:35:10.000000', 'temperatura', 1011.0000, 'ºC'),
	(120955, 108, '2015-04-01 00:35:11.000000', 'temperatura', 557.0000, 'ºC'),
	(120956, 108, '2015-04-01 00:35:12.000000', 'temperatura', 950.0000, 'ºC'),
	(120957, 108, '2015-04-01 00:35:13.000000', 'temperatura', 681.0000, 'ºC'),
	(120958, 108, '2015-04-01 00:35:14.000000', 'temperatura', 555.0000, 'ºC'),
	(120959, 108, '2015-04-01 00:35:15.000000', 'temperatura', 735.0000, 'ºC'),
	(120960, 108, '2015-04-01 00:35:16.000000', 'temperatura', 807.0000, 'ºC'),
	(120961, 108, '2015-04-01 00:35:17.000000', 'temperatura', 633.0000, 'ºC'),
	(120962, 108, '2015-04-01 00:35:18.000000', 'temperatura', 744.0000, 'ºC'),
	(120963, 108, '2015-04-01 00:35:19.000000', 'temperatura', 620.0000, 'ºC'),
	(120964, 108, '2015-04-01 00:35:20.000000', 'temperatura', 871.0000, 'ºC'),
	(120965, 108, '2015-04-01 00:35:21.000000', 'temperatura', 95.0000, 'ºC'),
	(120966, 108, '2015-04-01 00:35:22.000000', 'temperatura', 264.0000, 'ºC'),
	(120967, 108, '2015-04-01 00:35:23.000000', 'temperatura', 1034.0000, 'ºC'),
	(120968, 108, '2015-04-01 00:35:24.000000', 'temperatura', 778.0000, 'ºC'),
	(120969, 108, '2015-04-01 00:35:25.000000', 'temperatura', 789.0000, 'ºC'),
	(120970, 108, '2015-04-01 00:35:26.000000', 'temperatura', 411.0000, 'ºC'),
	(120971, 108, '2015-04-01 00:35:27.000000', 'temperatura', 887.0000, 'ºC'),
	(120972, 108, '2015-04-01 00:35:28.000000', 'temperatura', 806.0000, 'ºC'),
	(120973, 108, '2015-04-01 00:35:29.000000', 'temperatura', 166.0000, 'ºC'),
	(120974, 108, '2015-04-01 00:35:30.000000', 'temperatura', 815.0000, 'ºC'),
	(120975, 108, '2015-04-01 00:35:31.000000', 'temperatura', 1175.0000, 'ºC'),
	(120976, 108, '2015-04-01 00:35:32.000000', 'temperatura', 1030.0000, 'ºC'),
	(120977, 108, '2015-04-01 00:35:33.000000', 'temperatura', 426.0000, 'ºC'),
	(120978, 108, '2015-04-01 00:35:34.000000', 'temperatura', 240.0000, 'ºC'),
	(120979, 108, '2015-04-01 00:35:35.000000', 'temperatura', 1122.0000, 'ºC'),
	(120980, 108, '2015-04-01 00:35:36.000000', 'temperatura', 91.0000, 'ºC'),
	(120981, 108, '2015-04-01 00:35:37.000000', 'temperatura', 689.0000, 'ºC'),
	(120982, 108, '2015-04-01 00:35:38.000000', 'temperatura', 771.0000, 'ºC'),
	(120983, 108, '2015-04-01 00:35:39.000000', 'temperatura', 590.0000, 'ºC'),
	(120984, 108, '2015-04-01 00:35:40.000000', 'temperatura', 636.0000, 'ºC'),
	(120985, 108, '2015-04-01 00:35:41.000000', 'temperatura', 213.0000, 'ºC'),
	(120986, 108, '2015-04-01 00:35:42.000000', 'temperatura', 355.0000, 'ºC'),
	(120987, 108, '2015-04-01 00:35:43.000000', 'temperatura', 1137.0000, 'ºC'),
	(120988, 108, '2015-04-01 00:35:44.000000', 'temperatura', 1021.0000, 'ºC'),
	(120989, 108, '2015-04-01 00:35:45.000000', 'temperatura', 496.0000, 'ºC'),
	(120990, 108, '2015-04-01 00:35:46.000000', 'temperatura', 616.0000, 'ºC'),
	(120991, 108, '2015-04-01 00:35:47.000000', 'temperatura', 393.0000, 'ºC'),
	(120992, 108, '2015-04-01 00:35:48.000000', 'temperatura', 116.0000, 'ºC'),
	(120993, 108, '2015-04-01 00:35:49.000000', 'temperatura', 603.0000, 'ºC'),
	(120994, 108, '2015-04-01 00:35:50.000000', 'temperatura', 267.0000, 'ºC'),
	(120995, 108, '2015-04-01 00:35:51.000000', 'temperatura', 726.0000, 'ºC'),
	(120996, 108, '2015-04-01 00:35:52.000000', 'temperatura', 430.0000, 'ºC'),
	(120997, 108, '2015-04-01 00:35:53.000000', 'temperatura', 1174.0000, 'ºC'),
	(120998, 108, '2015-04-01 00:35:54.000000', 'temperatura', 981.0000, 'ºC'),
	(120999, 108, '2015-04-01 00:35:55.000000', 'temperatura', 183.0000, 'ºC'),
	(121000, 108, '2015-04-01 00:35:56.000000', 'temperatura', 372.0000, 'ºC'),
	(121001, 108, '2015-04-01 00:35:57.000000', 'temperatura', 112.0000, 'ºC'),
	(121002, 108, '2015-04-01 00:35:58.000000', 'temperatura', 646.0000, 'ºC'),
	(121003, 108, '2015-04-01 00:35:59.000000', 'temperatura', 495.0000, 'ºC'),
	(121004, 108, '2015-04-01 00:36:00.000000', 'temperatura', 535.0000, 'ºC'),
	(121005, 108, '2015-04-01 00:36:01.000000', 'temperatura', 1191.0000, 'ºC'),
	(121006, 108, '2015-04-01 00:36:02.000000', 'temperatura', 749.0000, 'ºC'),
	(121007, 108, '2015-04-01 00:36:03.000000', 'temperatura', 173.0000, 'ºC'),
	(121008, 108, '2015-04-01 00:36:04.000000', 'temperatura', 1020.0000, 'ºC'),
	(121009, 108, '2015-04-01 00:36:05.000000', 'temperatura', 980.0000, 'ºC'),
	(121010, 108, '2015-04-01 00:36:06.000000', 'temperatura', 642.0000, 'ºC'),
	(121011, 108, '2015-04-01 00:36:07.000000', 'temperatura', 269.0000, 'ºC'),
	(121012, 108, '2015-04-01 00:36:08.000000', 'temperatura', 621.0000, 'ºC'),
	(121013, 108, '2015-04-01 00:36:09.000000', 'temperatura', 1098.0000, 'ºC'),
	(121014, 108, '2015-04-01 00:36:10.000000', 'temperatura', 28.0000, 'ºC'),
	(121015, 108, '2015-04-01 00:36:11.000000', 'temperatura', 444.0000, 'ºC'),
	(121016, 108, '2015-04-01 00:36:12.000000', 'temperatura', 940.0000, 'ºC'),
	(121017, 108, '2015-04-01 00:36:13.000000', 'temperatura', 966.0000, 'ºC'),
	(121018, 108, '2015-04-01 00:36:14.000000', 'temperatura', 813.0000, 'ºC'),
	(121019, 108, '2015-04-01 00:36:15.000000', 'temperatura', 1167.0000, 'ºC'),
	(121020, 108, '2015-04-01 00:36:16.000000', 'temperatura', 997.0000, 'ºC'),
	(121021, 108, '2015-04-01 00:36:17.000000', 'temperatura', 284.0000, 'ºC'),
	(121022, 108, '2015-04-01 00:36:18.000000', 'temperatura', 829.0000, 'ºC'),
	(121023, 108, '2015-04-01 00:36:19.000000', 'temperatura', 896.0000, 'ºC'),
	(121024, 108, '2015-04-01 00:36:20.000000', 'temperatura', 791.0000, 'ºC'),
	(121025, 108, '2015-04-01 00:36:21.000000', 'temperatura', 66.0000, 'ºC'),
	(121026, 108, '2015-04-01 00:36:22.000000', 'temperatura', 360.0000, 'ºC'),
	(121027, 108, '2015-04-01 00:36:23.000000', 'temperatura', 401.0000, 'ºC'),
	(121028, 108, '2015-04-01 00:36:24.000000', 'temperatura', 928.0000, 'ºC'),
	(121029, 108, '2015-04-01 00:36:25.000000', 'temperatura', 1037.0000, 'ºC'),
	(121030, 108, '2015-04-01 00:36:26.000000', 'temperatura', 1.0000, 'ºC'),
	(121031, 108, '2015-04-01 00:36:27.000000', 'temperatura', 494.0000, 'ºC'),
	(121032, 108, '2015-04-01 00:36:28.000000', 'temperatura', 69.0000, 'ºC'),
	(121033, 108, '2015-04-01 00:36:29.000000', 'temperatura', 63.0000, 'ºC'),
	(121034, 108, '2015-04-01 00:36:30.000000', 'temperatura', 109.0000, 'ºC'),
	(121035, 108, '2015-04-01 00:36:31.000000', 'temperatura', 357.0000, 'ºC'),
	(121036, 108, '2015-04-01 00:36:32.000000', 'temperatura', 258.0000, 'ºC'),
	(121037, 108, '2015-04-01 00:36:33.000000', 'temperatura', 220.0000, 'ºC'),
	(121038, 108, '2015-04-01 00:36:34.000000', 'temperatura', 324.0000, 'ºC'),
	(121039, 108, '2015-04-01 00:36:35.000000', 'temperatura', 962.0000, 'ºC'),
	(121040, 108, '2015-04-01 00:36:36.000000', 'temperatura', 240.0000, 'ºC'),
	(121041, 108, '2015-04-01 00:36:37.000000', 'temperatura', 713.0000, 'ºC'),
	(121042, 108, '2015-04-01 00:36:38.000000', 'temperatura', 445.0000, 'ºC'),
	(121043, 108, '2015-04-01 00:36:39.000000', 'temperatura', 88.0000, 'ºC'),
	(121044, 108, '2015-04-01 00:36:40.000000', 'temperatura', 306.0000, 'ºC'),
	(121045, 108, '2015-04-01 00:36:41.000000', 'temperatura', 66.0000, 'ºC'),
	(121046, 108, '2015-04-01 00:36:42.000000', 'temperatura', 614.0000, 'ºC'),
	(121047, 108, '2015-04-01 00:36:43.000000', 'temperatura', 472.0000, 'ºC'),
	(121048, 108, '2015-04-01 00:36:44.000000', 'temperatura', 516.0000, 'ºC'),
	(121049, 108, '2015-04-01 00:36:45.000000', 'temperatura', 1168.0000, 'ºC'),
	(121050, 108, '2015-04-01 00:36:46.000000', 'temperatura', 689.0000, 'ºC'),
	(121051, 108, '2015-04-01 00:36:47.000000', 'temperatura', 1144.0000, 'ºC'),
	(121052, 108, '2015-04-01 00:36:48.000000', 'temperatura', 54.0000, 'ºC'),
	(121053, 108, '2015-04-01 00:36:49.000000', 'temperatura', 437.0000, 'ºC'),
	(121054, 108, '2015-04-01 00:36:50.000000', 'temperatura', 825.0000, 'ºC'),
	(121055, 108, '2015-04-01 00:36:51.000000', 'temperatura', 412.0000, 'ºC'),
	(121056, 108, '2015-04-01 00:36:52.000000', 'temperatura', 788.0000, 'ºC'),
	(121057, 108, '2015-04-01 00:36:53.000000', 'temperatura', 302.0000, 'ºC'),
	(121058, 108, '2015-04-01 00:36:54.000000', 'temperatura', 349.0000, 'ºC'),
	(121059, 108, '2015-04-01 00:36:55.000000', 'temperatura', 839.0000, 'ºC'),
	(121060, 108, '2015-04-01 00:36:56.000000', 'temperatura', 749.0000, 'ºC'),
	(121061, 108, '2015-04-01 00:36:57.000000', 'temperatura', 30.0000, 'ºC'),
	(121062, 108, '2015-04-01 00:36:58.000000', 'temperatura', 301.0000, 'ºC'),
	(121063, 108, '2015-04-01 00:36:59.000000', 'temperatura', 215.0000, 'ºC'),
	(121064, 108, '2015-04-01 00:37:00.000000', 'temperatura', 174.0000, 'ºC'),
	(121065, 108, '2015-04-01 00:37:01.000000', 'temperatura', 224.0000, 'ºC'),
	(121066, 108, '2015-04-01 00:37:02.000000', 'temperatura', 599.0000, 'ºC'),
	(121067, 108, '2015-04-01 00:37:03.000000', 'temperatura', 1125.0000, 'ºC'),
	(121068, 108, '2015-04-01 00:37:04.000000', 'temperatura', 229.0000, 'ºC'),
	(121069, 108, '2015-04-01 00:37:05.000000', 'temperatura', 171.0000, 'ºC'),
	(121070, 108, '2015-04-01 00:37:06.000000', 'temperatura', 166.0000, 'ºC'),
	(121071, 108, '2015-04-01 00:37:07.000000', 'temperatura', 317.0000, 'ºC'),
	(121072, 108, '2015-04-01 00:37:08.000000', 'temperatura', 1089.0000, 'ºC'),
	(121073, 108, '2015-04-01 00:37:09.000000', 'temperatura', 895.0000, 'ºC'),
	(121074, 108, '2015-04-01 00:37:10.000000', 'temperatura', 9.0000, 'ºC'),
	(121075, 108, '2015-04-01 00:37:11.000000', 'temperatura', 959.0000, 'ºC'),
	(121076, 108, '2015-04-01 00:37:12.000000', 'temperatura', 1169.0000, 'ºC'),
	(121077, 108, '2015-04-01 00:37:13.000000', 'temperatura', 570.0000, 'ºC'),
	(121078, 108, '2015-04-01 00:37:14.000000', 'temperatura', 544.0000, 'ºC'),
	(121079, 108, '2015-04-01 00:37:15.000000', 'temperatura', 1009.0000, 'ºC'),
	(121080, 108, '2015-04-01 00:37:16.000000', 'temperatura', 1016.0000, 'ºC'),
	(121081, 108, '2015-04-01 00:37:17.000000', 'temperatura', 850.0000, 'ºC'),
	(121082, 108, '2015-04-01 00:37:18.000000', 'temperatura', 4.0000, 'ºC'),
	(121083, 108, '2015-04-01 00:37:19.000000', 'temperatura', 1072.0000, 'ºC'),
	(121084, 108, '2015-04-01 00:37:20.000000', 'temperatura', 546.0000, 'ºC'),
	(121085, 108, '2015-04-01 00:37:21.000000', 'temperatura', 714.0000, 'ºC'),
	(121086, 108, '2015-04-01 00:37:22.000000', 'temperatura', 734.0000, 'ºC'),
	(121087, 108, '2015-04-01 00:37:23.000000', 'temperatura', 327.0000, 'ºC'),
	(121088, 108, '2015-04-01 00:37:24.000000', 'temperatura', 633.0000, 'ºC'),
	(121089, 108, '2015-04-01 00:37:25.000000', 'temperatura', 984.0000, 'ºC'),
	(121090, 108, '2015-04-01 00:37:26.000000', 'temperatura', 624.0000, 'ºC'),
	(121091, 108, '2015-04-01 00:37:27.000000', 'temperatura', 166.0000, 'ºC'),
	(121092, 108, '2015-04-01 00:37:28.000000', 'temperatura', 159.0000, 'ºC'),
	(121093, 108, '2015-04-01 00:37:29.000000', 'temperatura', 296.0000, 'ºC'),
	(121094, 108, '2015-04-01 00:37:30.000000', 'temperatura', 1004.0000, 'ºC'),
	(121095, 108, '2015-04-01 00:37:31.000000', 'temperatura', 533.0000, 'ºC'),
	(121096, 108, '2015-04-01 00:37:32.000000', 'temperatura', 854.0000, 'ºC'),
	(121097, 108, '2015-04-01 00:37:33.000000', 'temperatura', 271.0000, 'ºC'),
	(121098, 108, '2015-04-01 00:37:34.000000', 'temperatura', 1193.0000, 'ºC'),
	(121099, 108, '2015-04-01 00:37:35.000000', 'temperatura', 355.0000, 'ºC'),
	(121100, 108, '2015-04-01 00:37:36.000000', 'temperatura', 595.0000, 'ºC'),
	(121101, 108, '2015-04-01 00:37:37.000000', 'temperatura', 711.0000, 'ºC'),
	(121102, 108, '2015-04-01 00:37:38.000000', 'temperatura', 569.0000, 'ºC'),
	(121103, 108, '2015-04-01 00:37:39.000000', 'temperatura', 711.0000, 'ºC'),
	(121104, 108, '2015-04-01 00:37:40.000000', 'temperatura', 652.0000, 'ºC'),
	(121105, 108, '2015-04-01 00:37:41.000000', 'temperatura', 1127.0000, 'ºC'),
	(121106, 108, '2015-04-01 00:37:42.000000', 'temperatura', 78.0000, 'ºC'),
	(121107, 108, '2015-04-01 00:37:43.000000', 'temperatura', 609.0000, 'ºC'),
	(121108, 108, '2015-04-01 00:37:44.000000', 'temperatura', 413.0000, 'ºC'),
	(121109, 108, '2015-04-01 00:37:45.000000', 'temperatura', 238.0000, 'ºC'),
	(121110, 108, '2015-04-01 00:37:46.000000', 'temperatura', 1152.0000, 'ºC'),
	(121111, 108, '2015-04-01 00:37:47.000000', 'temperatura', 244.0000, 'ºC'),
	(121112, 108, '2015-04-01 00:37:48.000000', 'temperatura', 166.0000, 'ºC'),
	(121113, 108, '2015-04-01 00:37:49.000000', 'temperatura', 99.0000, 'ºC'),
	(121114, 108, '2015-04-01 00:37:50.000000', 'temperatura', 1196.0000, 'ºC'),
	(121115, 108, '2015-04-01 00:37:51.000000', 'temperatura', 884.0000, 'ºC'),
	(121116, 108, '2015-04-01 00:37:52.000000', 'temperatura', 831.0000, 'ºC'),
	(121117, 108, '2015-04-01 00:37:53.000000', 'temperatura', 304.0000, 'ºC'),
	(121118, 108, '2015-04-01 00:37:54.000000', 'temperatura', 228.0000, 'ºC'),
	(121119, 108, '2015-04-01 00:37:55.000000', 'temperatura', 230.0000, 'ºC'),
	(121120, 108, '2015-04-01 00:37:56.000000', 'temperatura', 466.0000, 'ºC'),
	(121121, 108, '2015-04-01 00:37:57.000000', 'temperatura', 442.0000, 'ºC'),
	(121122, 108, '2015-04-01 00:37:58.000000', 'temperatura', 810.0000, 'ºC'),
	(121123, 108, '2015-04-01 00:37:59.000000', 'temperatura', 324.0000, 'ºC'),
	(121124, 108, '2015-04-01 00:38:00.000000', 'temperatura', 393.0000, 'ºC'),
	(121125, 108, '2015-04-01 00:38:01.000000', 'temperatura', 992.0000, 'ºC'),
	(121126, 108, '2015-04-01 00:38:02.000000', 'temperatura', 181.0000, 'ºC'),
	(121127, 108, '2015-04-01 00:38:03.000000', 'temperatura', 330.0000, 'ºC'),
	(121128, 108, '2015-04-01 00:38:04.000000', 'temperatura', 1106.0000, 'ºC'),
	(121129, 108, '2015-04-01 00:38:05.000000', 'temperatura', 942.0000, 'ºC'),
	(121130, 108, '2015-04-01 00:38:06.000000', 'temperatura', 192.0000, 'ºC'),
	(121131, 108, '2015-04-01 00:38:07.000000', 'temperatura', 534.0000, 'ºC'),
	(121132, 108, '2015-04-01 00:38:08.000000', 'temperatura', 896.0000, 'ºC'),
	(121133, 108, '2015-04-01 00:38:09.000000', 'temperatura', 479.0000, 'ºC'),
	(121134, 108, '2015-04-01 00:38:10.000000', 'temperatura', 905.0000, 'ºC'),
	(121135, 108, '2015-04-01 00:38:11.000000', 'temperatura', 688.0000, 'ºC'),
	(121136, 108, '2015-04-01 00:38:12.000000', 'temperatura', 727.0000, 'ºC'),
	(121137, 108, '2015-04-01 00:38:13.000000', 'temperatura', 373.0000, 'ºC'),
	(121138, 108, '2015-04-01 00:38:14.000000', 'temperatura', 882.0000, 'ºC'),
	(121139, 108, '2015-04-01 00:38:15.000000', 'temperatura', 894.0000, 'ºC'),
	(121140, 108, '2015-04-01 00:38:16.000000', 'temperatura', 623.0000, 'ºC'),
	(121141, 108, '2015-04-01 00:38:17.000000', 'temperatura', 432.0000, 'ºC'),
	(121142, 108, '2015-04-01 00:38:18.000000', 'temperatura', 293.0000, 'ºC'),
	(121143, 108, '2015-04-01 00:38:19.000000', 'temperatura', 169.0000, 'ºC'),
	(121144, 108, '2015-04-01 00:38:20.000000', 'temperatura', 1167.0000, 'ºC'),
	(121145, 108, '2015-04-01 00:38:21.000000', 'temperatura', 530.0000, 'ºC'),
	(121146, 108, '2015-04-01 00:38:22.000000', 'temperatura', 350.0000, 'ºC'),
	(121147, 108, '2015-04-01 00:38:23.000000', 'temperatura', 159.0000, 'ºC'),
	(121148, 108, '2015-04-01 00:38:24.000000', 'temperatura', 945.0000, 'ºC'),
	(121149, 108, '2015-04-01 00:38:25.000000', 'temperatura', 647.0000, 'ºC'),
	(121150, 108, '2015-04-01 00:38:26.000000', 'temperatura', 403.0000, 'ºC'),
	(121151, 108, '2015-04-01 00:38:27.000000', 'temperatura', 73.0000, 'ºC'),
	(121152, 108, '2015-04-01 00:38:28.000000', 'temperatura', 355.0000, 'ºC'),
	(121153, 108, '2015-04-01 00:38:29.000000', 'temperatura', 359.0000, 'ºC'),
	(121154, 108, '2015-04-01 00:38:30.000000', 'temperatura', 730.0000, 'ºC'),
	(121155, 108, '2015-04-01 00:38:31.000000', 'temperatura', 172.0000, 'ºC'),
	(121156, 108, '2015-04-01 00:38:32.000000', 'temperatura', 1070.0000, 'ºC'),
	(121157, 108, '2015-04-01 00:38:33.000000', 'temperatura', 37.0000, 'ºC'),
	(121158, 108, '2015-04-01 00:38:34.000000', 'temperatura', 576.0000, 'ºC'),
	(121159, 108, '2015-04-01 00:38:35.000000', 'temperatura', 368.0000, 'ºC'),
	(121160, 108, '2015-04-01 00:38:36.000000', 'temperatura', 114.0000, 'ºC'),
	(121161, 108, '2015-04-01 00:38:37.000000', 'temperatura', 667.0000, 'ºC'),
	(121162, 108, '2015-04-01 00:38:38.000000', 'temperatura', 594.0000, 'ºC'),
	(121163, 108, '2015-04-01 00:38:39.000000', 'temperatura', 968.0000, 'ºC'),
	(121164, 108, '2015-04-01 00:38:40.000000', 'temperatura', 661.0000, 'ºC'),
	(121165, 108, '2015-04-01 00:38:41.000000', 'temperatura', 398.0000, 'ºC'),
	(121166, 108, '2015-04-01 00:38:42.000000', 'temperatura', 10.0000, 'ºC'),
	(121167, 108, '2015-04-01 00:38:43.000000', 'temperatura', 57.0000, 'ºC'),
	(121168, 108, '2015-04-01 00:38:44.000000', 'temperatura', 255.0000, 'ºC'),
	(121169, 108, '2015-04-01 00:38:45.000000', 'temperatura', 1104.0000, 'ºC'),
	(121170, 108, '2015-04-01 00:38:46.000000', 'temperatura', 1154.0000, 'ºC'),
	(121171, 108, '2015-04-01 00:38:47.000000', 'temperatura', 58.0000, 'ºC'),
	(121172, 108, '2015-04-01 00:38:48.000000', 'temperatura', 431.0000, 'ºC'),
	(121173, 108, '2015-04-01 00:38:49.000000', 'temperatura', 779.0000, 'ºC'),
	(121174, 108, '2015-04-01 00:38:50.000000', 'temperatura', 204.0000, 'ºC'),
	(121175, 108, '2015-04-01 00:38:51.000000', 'temperatura', 1082.0000, 'ºC'),
	(121176, 108, '2015-04-01 00:38:52.000000', 'temperatura', 1198.0000, 'ºC'),
	(121177, 108, '2015-04-01 00:38:53.000000', 'temperatura', 347.0000, 'ºC'),
	(121178, 108, '2015-04-01 00:38:54.000000', 'temperatura', 542.0000, 'ºC'),
	(121179, 108, '2015-04-01 00:38:55.000000', 'temperatura', 467.0000, 'ºC'),
	(121180, 108, '2015-04-01 00:38:56.000000', 'temperatura', 712.0000, 'ºC'),
	(121181, 108, '2015-04-01 00:38:57.000000', 'temperatura', 960.0000, 'ºC'),
	(121182, 108, '2015-04-01 00:38:58.000000', 'temperatura', 264.0000, 'ºC'),
	(121183, 108, '2015-04-01 00:38:59.000000', 'temperatura', 839.0000, 'ºC'),
	(121184, 108, '2015-04-01 00:39:00.000000', 'temperatura', 1004.0000, 'ºC'),
	(121185, 108, '2015-04-01 00:39:01.000000', 'temperatura', 104.0000, 'ºC'),
	(121186, 108, '2015-04-01 00:39:02.000000', 'temperatura', 1110.0000, 'ºC'),
	(121187, 108, '2015-04-01 00:39:03.000000', 'temperatura', 437.0000, 'ºC'),
	(121188, 108, '2015-04-01 00:39:04.000000', 'temperatura', 55.0000, 'ºC'),
	(121189, 108, '2015-04-01 00:39:05.000000', 'temperatura', 164.0000, 'ºC'),
	(121190, 108, '2015-04-01 00:39:06.000000', 'temperatura', 658.0000, 'ºC'),
	(121191, 108, '2015-04-01 00:39:07.000000', 'temperatura', 397.0000, 'ºC'),
	(121192, 108, '2015-04-01 00:39:08.000000', 'temperatura', 12.0000, 'ºC'),
	(121193, 108, '2015-04-01 00:39:09.000000', 'temperatura', 69.0000, 'ºC'),
	(121194, 108, '2015-04-01 00:39:10.000000', 'temperatura', 310.0000, 'ºC'),
	(121195, 108, '2015-04-01 00:39:11.000000', 'temperatura', 144.0000, 'ºC'),
	(121196, 108, '2015-04-01 00:39:12.000000', 'temperatura', 988.0000, 'ºC'),
	(121197, 108, '2015-04-01 00:39:13.000000', 'temperatura', 911.0000, 'ºC'),
	(121198, 108, '2015-04-01 00:39:14.000000', 'temperatura', 389.0000, 'ºC'),
	(121199, 108, '2015-04-01 00:39:15.000000', 'temperatura', 414.0000, 'ºC'),
	(121200, 108, '2015-04-01 00:39:16.000000', 'temperatura', 903.0000, 'ºC'),
	(121201, 108, '2015-04-01 00:39:17.000000', 'temperatura', 876.0000, 'ºC'),
	(121202, 108, '2015-04-01 00:39:18.000000', 'temperatura', 469.0000, 'ºC'),
	(121203, 108, '2015-04-01 00:39:19.000000', 'temperatura', 916.0000, 'ºC'),
	(121204, 108, '2015-04-01 00:39:20.000000', 'temperatura', 777.0000, 'ºC'),
	(121205, 108, '2015-04-01 00:39:21.000000', 'temperatura', 1136.0000, 'ºC'),
	(121206, 108, '2015-04-01 00:39:22.000000', 'temperatura', 951.0000, 'ºC'),
	(121207, 108, '2015-04-01 00:39:23.000000', 'temperatura', 148.0000, 'ºC'),
	(121208, 108, '2015-04-01 00:39:24.000000', 'temperatura', 285.0000, 'ºC'),
	(121209, 108, '2015-04-01 00:39:25.000000', 'temperatura', 983.0000, 'ºC'),
	(121210, 108, '2015-04-01 00:39:26.000000', 'temperatura', 461.0000, 'ºC'),
	(121211, 108, '2015-04-01 00:39:27.000000', 'temperatura', 555.0000, 'ºC'),
	(121212, 108, '2015-04-01 00:39:28.000000', 'temperatura', 195.0000, 'ºC'),
	(121213, 108, '2015-04-01 00:39:29.000000', 'temperatura', 509.0000, 'ºC'),
	(121214, 108, '2015-04-01 00:39:30.000000', 'temperatura', 760.0000, 'ºC'),
	(121215, 108, '2015-04-01 00:39:31.000000', 'temperatura', 1072.0000, 'ºC'),
	(121216, 108, '2015-04-01 00:39:32.000000', 'temperatura', 684.0000, 'ºC'),
	(121217, 108, '2015-04-01 00:39:33.000000', 'temperatura', 202.0000, 'ºC'),
	(121218, 108, '2015-04-01 00:39:34.000000', 'temperatura', 158.0000, 'ºC'),
	(121219, 108, '2015-04-01 00:39:35.000000', 'temperatura', 187.0000, 'ºC'),
	(121220, 108, '2015-04-01 00:39:36.000000', 'temperatura', 461.0000, 'ºC'),
	(121221, 108, '2015-04-01 00:39:37.000000', 'temperatura', 546.0000, 'ºC'),
	(121222, 108, '2015-04-01 00:39:38.000000', 'temperatura', 145.0000, 'ºC'),
	(121223, 108, '2015-04-01 00:39:39.000000', 'temperatura', 287.0000, 'ºC'),
	(121224, 108, '2015-04-01 00:39:40.000000', 'temperatura', 1003.0000, 'ºC'),
	(121225, 108, '2015-04-01 00:39:41.000000', 'temperatura', 554.0000, 'ºC'),
	(121226, 108, '2015-04-01 00:39:42.000000', 'temperatura', 960.0000, 'ºC'),
	(121227, 108, '2015-04-01 00:39:43.000000', 'temperatura', 739.0000, 'ºC'),
	(121228, 108, '2015-04-01 00:39:44.000000', 'temperatura', 814.0000, 'ºC'),
	(121229, 108, '2015-04-01 00:39:45.000000', 'temperatura', 655.0000, 'ºC'),
	(121230, 108, '2015-04-01 00:39:46.000000', 'temperatura', 833.0000, 'ºC'),
	(121231, 108, '2015-04-01 00:39:47.000000', 'temperatura', 1002.0000, 'ºC'),
	(121232, 108, '2015-04-01 00:39:48.000000', 'temperatura', 113.0000, 'ºC'),
	(121233, 108, '2015-04-01 00:39:49.000000', 'temperatura', 1156.0000, 'ºC'),
	(121234, 108, '2015-04-01 00:39:50.000000', 'temperatura', 644.0000, 'ºC'),
	(121235, 108, '2015-04-01 00:39:51.000000', 'temperatura', 952.0000, 'ºC'),
	(121236, 108, '2015-04-01 00:39:52.000000', 'temperatura', 429.0000, 'ºC'),
	(121237, 108, '2015-04-01 00:39:53.000000', 'temperatura', 489.0000, 'ºC'),
	(121238, 108, '2015-04-01 00:39:54.000000', 'temperatura', 1159.0000, 'ºC'),
	(121239, 108, '2015-04-01 00:39:55.000000', 'temperatura', 729.0000, 'ºC'),
	(121240, 108, '2015-04-01 00:39:56.000000', 'temperatura', 168.0000, 'ºC'),
	(121241, 108, '2015-04-01 00:39:57.000000', 'temperatura', 1055.0000, 'ºC'),
	(121242, 108, '2015-04-01 00:39:58.000000', 'temperatura', 1171.0000, 'ºC'),
	(121243, 108, '2015-04-01 00:39:59.000000', 'temperatura', 290.0000, 'ºC'),
	(121244, 108, '2015-04-01 00:40:00.000000', 'temperatura', 337.0000, 'ºC'),
	(121245, 108, '2015-04-01 00:40:01.000000', 'temperatura', 815.0000, 'ºC'),
	(121246, 108, '2015-04-01 00:40:02.000000', 'temperatura', 665.0000, 'ºC'),
	(121247, 108, '2015-04-01 00:40:03.000000', 'temperatura', 879.0000, 'ºC'),
	(121248, 108, '2015-04-01 00:40:04.000000', 'temperatura', 2.0000, 'ºC'),
	(121249, 108, '2015-04-01 00:40:05.000000', 'temperatura', 973.0000, 'ºC'),
	(121250, 108, '2015-04-01 00:40:06.000000', 'temperatura', 60.0000, 'ºC'),
	(121251, 108, '2015-04-01 00:40:07.000000', 'temperatura', 980.0000, 'ºC'),
	(121252, 108, '2015-04-01 00:40:08.000000', 'temperatura', 1120.0000, 'ºC'),
	(121253, 108, '2015-04-01 00:40:09.000000', 'temperatura', 262.0000, 'ºC'),
	(121254, 108, '2015-04-01 00:40:10.000000', 'temperatura', 351.0000, 'ºC'),
	(121255, 108, '2015-04-01 00:40:11.000000', 'temperatura', 971.0000, 'ºC'),
	(121256, 108, '2015-04-01 00:40:12.000000', 'temperatura', 199.0000, 'ºC'),
	(121257, 108, '2015-04-01 00:40:13.000000', 'temperatura', 485.0000, 'ºC'),
	(121258, 108, '2015-04-01 00:40:14.000000', 'temperatura', 627.0000, 'ºC'),
	(121259, 108, '2015-04-01 00:40:15.000000', 'temperatura', 480.0000, 'ºC'),
	(121260, 108, '2015-04-01 00:40:16.000000', 'temperatura', 520.0000, 'ºC'),
	(121261, 108, '2015-04-01 00:40:17.000000', 'temperatura', 1162.0000, 'ºC'),
	(121262, 108, '2015-04-01 00:40:18.000000', 'temperatura', 649.0000, 'ºC'),
	(121263, 108, '2015-04-01 00:40:19.000000', 'temperatura', 961.0000, 'ºC'),
	(121264, 108, '2015-04-01 00:40:20.000000', 'temperatura', 457.0000, 'ºC'),
	(121265, 108, '2015-04-01 00:40:21.000000', 'temperatura', 603.0000, 'ºC'),
	(121266, 108, '2015-04-01 00:40:22.000000', 'temperatura', 444.0000, 'ºC'),
	(121267, 108, '2015-04-01 00:40:23.000000', 'temperatura', 413.0000, 'ºC'),
	(121268, 108, '2015-04-01 00:40:24.000000', 'temperatura', 731.0000, 'ºC'),
	(121269, 108, '2015-04-01 00:40:25.000000', 'temperatura', 17.0000, 'ºC'),
	(121270, 108, '2015-04-01 00:40:26.000000', 'temperatura', 295.0000, 'ºC'),
	(121271, 108, '2015-04-01 00:40:27.000000', 'temperatura', 223.0000, 'ºC'),
	(121272, 108, '2015-04-01 00:40:28.000000', 'temperatura', 232.0000, 'ºC'),
	(121273, 108, '2015-04-01 00:40:29.000000', 'temperatura', 489.0000, 'ºC'),
	(121274, 108, '2015-04-01 00:40:30.000000', 'temperatura', 550.0000, 'ºC'),
	(121275, 108, '2015-04-01 00:40:31.000000', 'temperatura', 85.0000, 'ºC'),
	(121276, 108, '2015-04-01 00:40:32.000000', 'temperatura', 1174.0000, 'ºC'),
	(121277, 108, '2015-04-01 00:40:33.000000', 'temperatura', 814.0000, 'ºC'),
	(121278, 108, '2015-04-01 00:40:34.000000', 'temperatura', 550.0000, 'ºC'),
	(121279, 108, '2015-04-01 00:40:35.000000', 'temperatura', 309.0000, 'ºC'),
	(121280, 108, '2015-04-01 00:40:36.000000', 'temperatura', 1094.0000, 'ºC'),
	(121281, 108, '2015-04-01 00:40:37.000000', 'temperatura', 944.0000, 'ºC'),
	(121282, 108, '2015-04-01 00:40:38.000000', 'temperatura', 237.0000, 'ºC'),
	(121283, 108, '2015-04-01 00:40:39.000000', 'temperatura', 753.0000, 'ºC'),
	(121284, 108, '2015-04-01 00:40:40.000000', 'temperatura', 657.0000, 'ºC'),
	(121285, 108, '2015-04-01 00:40:41.000000', 'temperatura', 1028.0000, 'ºC'),
	(121286, 108, '2015-04-01 00:40:42.000000', 'temperatura', 766.0000, 'ºC'),
	(121287, 108, '2015-04-01 00:40:43.000000', 'temperatura', 746.0000, 'ºC'),
	(121288, 108, '2015-04-01 00:40:44.000000', 'temperatura', 236.0000, 'ºC'),
	(121289, 108, '2015-04-01 00:40:45.000000', 'temperatura', 140.0000, 'ºC'),
	(121290, 108, '2015-04-01 00:40:46.000000', 'temperatura', 1192.0000, 'ºC'),
	(121291, 108, '2015-04-01 00:40:47.000000', 'temperatura', 743.0000, 'ºC'),
	(121292, 108, '2015-04-01 00:40:48.000000', 'temperatura', 140.0000, 'ºC'),
	(121293, 108, '2015-04-01 00:40:49.000000', 'temperatura', 869.0000, 'ºC'),
	(121294, 108, '2015-04-01 00:40:50.000000', 'temperatura', 325.0000, 'ºC'),
	(121295, 108, '2015-04-01 00:40:51.000000', 'temperatura', 219.0000, 'ºC'),
	(121296, 108, '2015-04-01 00:40:52.000000', 'temperatura', 122.0000, 'ºC'),
	(121297, 108, '2015-04-01 00:40:53.000000', 'temperatura', 1152.0000, 'ºC'),
	(121298, 108, '2015-04-01 00:40:54.000000', 'temperatura', 595.0000, 'ºC'),
	(121299, 108, '2015-04-01 00:40:55.000000', 'temperatura', 719.0000, 'ºC'),
	(121300, 108, '2015-04-01 00:40:56.000000', 'temperatura', 610.0000, 'ºC'),
	(121301, 108, '2015-04-01 00:40:57.000000', 'temperatura', 894.0000, 'ºC'),
	(121302, 108, '2015-04-01 00:40:58.000000', 'temperatura', 242.0000, 'ºC'),
	(121303, 108, '2015-04-01 00:40:59.000000', 'temperatura', 928.0000, 'ºC'),
	(121304, 108, '2015-04-01 00:41:00.000000', 'temperatura', 314.0000, 'ºC'),
	(121305, 108, '2015-04-01 00:41:01.000000', 'temperatura', 1189.0000, 'ºC'),
	(121306, 108, '2015-04-01 00:41:02.000000', 'temperatura', 200.0000, 'ºC'),
	(121307, 108, '2015-04-01 00:41:03.000000', 'temperatura', 1037.0000, 'ºC'),
	(121308, 108, '2015-04-01 00:41:04.000000', 'temperatura', 983.0000, 'ºC'),
	(121309, 108, '2015-04-01 00:41:05.000000', 'temperatura', 604.0000, 'ºC'),
	(121310, 108, '2015-04-01 00:41:06.000000', 'temperatura', 74.0000, 'ºC'),
	(121311, 108, '2015-04-01 00:41:07.000000', 'temperatura', 958.0000, 'ºC'),
	(121312, 108, '2015-04-01 00:41:08.000000', 'temperatura', 968.0000, 'ºC'),
	(121313, 108, '2015-04-01 00:41:09.000000', 'temperatura', 765.0000, 'ºC'),
	(121314, 108, '2015-04-01 00:41:10.000000', 'temperatura', 920.0000, 'ºC'),
	(121315, 108, '2015-04-01 00:41:11.000000', 'temperatura', 1109.0000, 'ºC'),
	(121316, 108, '2015-04-01 00:41:12.000000', 'temperatura', 385.0000, 'ºC'),
	(121317, 108, '2015-04-01 00:41:13.000000', 'temperatura', 998.0000, 'ºC'),
	(121318, 108, '2015-04-01 00:41:14.000000', 'temperatura', 238.0000, 'ºC'),
	(121319, 108, '2015-04-01 00:41:15.000000', 'temperatura', 593.0000, 'ºC'),
	(121320, 108, '2015-04-01 00:41:16.000000', 'temperatura', 1053.0000, 'ºC'),
	(121321, 108, '2015-04-01 00:41:17.000000', 'temperatura', 1087.0000, 'ºC'),
	(121322, 108, '2015-04-01 00:41:18.000000', 'temperatura', 1077.0000, 'ºC'),
	(121323, 108, '2015-04-01 00:41:19.000000', 'temperatura', 924.0000, 'ºC'),
	(121324, 108, '2015-04-01 00:41:20.000000', 'temperatura', 188.0000, 'ºC'),
	(121325, 108, '2015-04-01 00:41:21.000000', 'temperatura', 569.0000, 'ºC'),
	(121326, 108, '2015-04-01 00:41:22.000000', 'temperatura', 1083.0000, 'ºC'),
	(121327, 108, '2015-04-01 00:41:23.000000', 'temperatura', 107.0000, 'ºC'),
	(121328, 108, '2015-04-01 00:41:24.000000', 'temperatura', 888.0000, 'ºC'),
	(121329, 108, '2015-04-01 00:41:25.000000', 'temperatura', 518.0000, 'ºC'),
	(121330, 108, '2015-04-01 00:41:26.000000', 'temperatura', 1129.0000, 'ºC'),
	(121331, 108, '2015-04-01 00:41:27.000000', 'temperatura', 490.0000, 'ºC'),
	(121332, 108, '2015-04-01 00:41:28.000000', 'temperatura', 264.0000, 'ºC'),
	(121333, 108, '2015-04-01 00:41:29.000000', 'temperatura', 1050.0000, 'ºC'),
	(121334, 108, '2015-04-01 00:41:30.000000', 'temperatura', 858.0000, 'ºC'),
	(121335, 108, '2015-04-01 00:41:31.000000', 'temperatura', 1141.0000, 'ºC'),
	(121336, 108, '2015-04-01 00:41:32.000000', 'temperatura', 731.0000, 'ºC'),
	(121337, 108, '2015-04-01 00:41:33.000000', 'temperatura', 235.0000, 'ºC'),
	(121338, 108, '2015-04-01 00:41:34.000000', 'temperatura', 179.0000, 'ºC'),
	(121339, 108, '2015-04-01 00:41:35.000000', 'temperatura', 193.0000, 'ºC'),
	(121340, 108, '2015-04-01 00:41:36.000000', 'temperatura', 428.0000, 'ºC'),
	(121341, 108, '2015-04-01 00:41:37.000000', 'temperatura', 362.0000, 'ºC'),
	(121342, 108, '2015-04-01 00:41:38.000000', 'temperatura', 525.0000, 'ºC'),
	(121343, 108, '2015-04-01 00:41:39.000000', 'temperatura', 341.0000, 'ºC'),
	(121344, 108, '2015-04-01 00:41:40.000000', 'temperatura', 129.0000, 'ºC'),
	(121345, 108, '2015-04-01 00:41:41.000000', 'temperatura', 822.0000, 'ºC'),
	(121346, 108, '2015-04-01 00:41:42.000000', 'temperatura', 123.0000, 'ºC'),
	(121347, 108, '2015-04-01 00:41:43.000000', 'temperatura', 551.0000, 'ºC'),
	(121348, 108, '2015-04-01 00:41:44.000000', 'temperatura', 1188.0000, 'ºC'),
	(121349, 108, '2015-04-01 00:41:45.000000', 'temperatura', 685.0000, 'ºC'),
	(121350, 108, '2015-04-01 00:41:46.000000', 'temperatura', 1063.0000, 'ºC'),
	(121351, 108, '2015-04-01 00:41:47.000000', 'temperatura', 860.0000, 'ºC'),
	(121352, 108, '2015-04-01 00:41:48.000000', 'temperatura', 1111.0000, 'ºC'),
	(121353, 108, '2015-04-01 00:41:49.000000', 'temperatura', 577.0000, 'ºC'),
	(121354, 108, '2015-04-01 00:41:50.000000', 'temperatura', 752.0000, 'ºC'),
	(121355, 108, '2015-04-01 00:41:51.000000', 'temperatura', 831.0000, 'ºC'),
	(121356, 108, '2015-04-01 00:41:52.000000', 'temperatura', 700.0000, 'ºC'),
	(121357, 108, '2015-04-01 00:41:53.000000', 'temperatura', 1006.0000, 'ºC'),
	(121358, 108, '2015-04-01 00:41:54.000000', 'temperatura', 531.0000, 'ºC'),
	(121359, 108, '2015-04-01 00:41:55.000000', 'temperatura', 835.0000, 'ºC'),
	(121360, 108, '2015-04-01 00:41:56.000000', 'temperatura', 185.0000, 'ºC'),
	(121361, 108, '2015-04-01 00:41:57.000000', 'temperatura', 819.0000, 'ºC'),
	(121362, 108, '2015-04-01 00:41:58.000000', 'temperatura', 1142.0000, 'ºC'),
	(121363, 108, '2015-04-01 00:41:59.000000', 'temperatura', 853.0000, 'ºC'),
	(121364, 108, '2015-04-01 00:42:00.000000', 'temperatura', 841.0000, 'ºC'),
	(121365, 108, '2015-04-01 00:42:01.000000', 'temperatura', 446.0000, 'ºC'),
	(121366, 108, '2015-04-01 00:42:02.000000', 'temperatura', 908.0000, 'ºC'),
	(121367, 108, '2015-04-01 00:42:03.000000', 'temperatura', 800.0000, 'ºC'),
	(121368, 108, '2015-04-01 00:42:04.000000', 'temperatura', 79.0000, 'ºC'),
	(121369, 108, '2015-04-01 00:42:05.000000', 'temperatura', 393.0000, 'ºC'),
	(121370, 108, '2015-04-01 00:42:06.000000', 'temperatura', 529.0000, 'ºC'),
	(121371, 108, '2015-04-01 00:42:07.000000', 'temperatura', 267.0000, 'ºC'),
	(121372, 108, '2015-04-01 00:42:08.000000', 'temperatura', 949.0000, 'ºC'),
	(121373, 108, '2015-04-01 00:42:09.000000', 'temperatura', 345.0000, 'ºC'),
	(121374, 108, '2015-04-01 00:42:10.000000', 'temperatura', 76.0000, 'ºC'),
	(121375, 108, '2015-04-01 00:42:11.000000', 'temperatura', 546.0000, 'ºC'),
	(121376, 108, '2015-04-01 00:42:12.000000', 'temperatura', 102.0000, 'ºC'),
	(121377, 108, '2015-04-01 00:42:13.000000', 'temperatura', 73.0000, 'ºC'),
	(121378, 108, '2015-04-01 00:42:14.000000', 'temperatura', 61.0000, 'ºC'),
	(121379, 108, '2015-04-01 00:42:15.000000', 'temperatura', 84.0000, 'ºC'),
	(121380, 108, '2015-04-01 00:42:16.000000', 'temperatura', 238.0000, 'ºC'),
	(121381, 108, '2015-04-01 00:42:17.000000', 'temperatura', 938.0000, 'ºC'),
	(121382, 108, '2015-04-01 00:42:18.000000', 'temperatura', 379.0000, 'ºC'),
	(121383, 108, '2015-04-01 00:42:19.000000', 'temperatura', 278.0000, 'ºC'),
	(121384, 108, '2015-04-01 00:42:20.000000', 'temperatura', 256.0000, 'ºC'),
	(121385, 108, '2015-04-01 00:42:21.000000', 'temperatura', 445.0000, 'ºC'),
	(121386, 108, '2015-04-01 00:42:22.000000', 'temperatura', 257.0000, 'ºC'),
	(121387, 108, '2015-04-01 00:42:23.000000', 'temperatura', 1152.0000, 'ºC'),
	(121388, 108, '2015-04-01 00:42:24.000000', 'temperatura', 188.0000, 'ºC'),
	(121389, 108, '2015-04-01 00:42:25.000000', 'temperatura', 1084.0000, 'ºC'),
	(121390, 108, '2015-04-01 00:42:26.000000', 'temperatura', 58.0000, 'ºC'),
	(121391, 108, '2015-04-01 00:42:27.000000', 'temperatura', 639.0000, 'ºC'),
	(121392, 108, '2015-04-01 00:42:28.000000', 'temperatura', 623.0000, 'ºC'),
	(121393, 108, '2015-04-01 00:42:29.000000', 'temperatura', 1196.0000, 'ºC'),
	(121394, 108, '2015-04-01 00:42:30.000000', 'temperatura', 514.0000, 'ºC'),
	(121395, 108, '2015-04-01 00:42:31.000000', 'temperatura', 181.0000, 'ºC'),
	(121396, 108, '2015-04-01 00:42:32.000000', 'temperatura', 563.0000, 'ºC'),
	(121397, 108, '2015-04-01 00:42:33.000000', 'temperatura', 1074.0000, 'ºC'),
	(121398, 108, '2015-04-01 00:42:34.000000', 'temperatura', 82.0000, 'ºC'),
	(121399, 108, '2015-04-01 00:42:35.000000', 'temperatura', 789.0000, 'ºC'),
	(121400, 108, '2015-04-01 00:42:36.000000', 'temperatura', 98.0000, 'ºC'),
	(121401, 108, '2015-04-01 00:42:37.000000', 'temperatura', 524.0000, 'ºC'),
	(121402, 108, '2015-04-01 00:42:38.000000', 'temperatura', 1127.0000, 'ºC'),
	(121403, 108, '2015-04-01 00:42:39.000000', 'temperatura', 461.0000, 'ºC'),
	(121404, 108, '2015-04-01 00:42:40.000000', 'temperatura', 126.0000, 'ºC'),
	(121405, 108, '2015-04-01 00:42:41.000000', 'temperatura', 449.0000, 'ºC'),
	(121406, 108, '2015-04-01 00:42:42.000000', 'temperatura', 668.0000, 'ºC'),
	(121407, 108, '2015-04-01 00:42:43.000000', 'temperatura', 793.0000, 'ºC'),
	(121408, 108, '2015-04-01 00:42:44.000000', 'temperatura', 762.0000, 'ºC'),
	(121409, 108, '2015-04-01 00:42:45.000000', 'temperatura', 233.0000, 'ºC'),
	(121410, 108, '2015-04-01 00:42:46.000000', 'temperatura', 77.0000, 'ºC'),
	(121411, 108, '2015-04-01 00:42:47.000000', 'temperatura', 886.0000, 'ºC'),
	(121412, 108, '2015-04-01 00:42:48.000000', 'temperatura', 600.0000, 'ºC'),
	(121413, 108, '2015-04-01 00:42:49.000000', 'temperatura', 342.0000, 'ºC'),
	(121414, 108, '2015-04-01 00:42:50.000000', 'temperatura', 1110.0000, 'ºC'),
	(121415, 108, '2015-04-01 00:42:51.000000', 'temperatura', 924.0000, 'ºC'),
	(121416, 108, '2015-04-01 00:42:52.000000', 'temperatura', 90.0000, 'ºC'),
	(121417, 108, '2015-04-01 00:42:53.000000', 'temperatura', 78.0000, 'ºC'),
	(121418, 108, '2015-04-01 00:42:54.000000', 'temperatura', 119.0000, 'ºC'),
	(121419, 108, '2015-04-01 00:42:55.000000', 'temperatura', 365.0000, 'ºC'),
	(121420, 108, '2015-04-01 00:42:56.000000', 'temperatura', 267.0000, 'ºC'),
	(121421, 108, '2015-04-01 00:42:57.000000', 'temperatura', 239.0000, 'ºC'),
	(121422, 108, '2015-04-01 00:42:58.000000', 'temperatura', 395.0000, 'ºC'),
	(121423, 108, '2015-04-01 00:42:59.000000', 'temperatura', 60.0000, 'ºC'),
	(121424, 108, '2015-04-01 00:43:00.000000', 'temperatura', 315.0000, 'ºC'),
	(121425, 108, '2015-04-01 00:43:01.000000', 'temperatura', 196.0000, 'ºC'),
	(121426, 108, '2015-04-01 00:43:02.000000', 'temperatura', 33.0000, 'ºC'),
	(121427, 108, '2015-04-01 00:43:03.000000', 'temperatura', 780.0000, 'ºC'),
	(121428, 108, '2015-04-01 00:43:04.000000', 'temperatura', 202.0000, 'ºC'),
	(121429, 108, '2015-04-01 00:43:05.000000', 'temperatura', 1070.0000, 'ºC'),
	(121430, 108, '2015-04-01 00:43:06.000000', 'temperatura', 1142.0000, 'ºC'),
	(121431, 108, '2015-04-01 00:43:07.000000', 'temperatura', 102.0000, 'ºC'),
	(121432, 108, '2015-04-01 00:43:08.000000', 'temperatura', 687.0000, 'ºC'),
	(121433, 108, '2015-04-01 00:43:09.000000', 'temperatura', 726.0000, 'ºC'),
	(121434, 108, '2015-04-01 00:43:10.000000', 'temperatura', 370.0000, 'ºC'),
	(121435, 108, '2015-04-01 00:43:11.000000', 'temperatura', 871.0000, 'ºC'),
	(121436, 108, '2015-04-01 00:43:12.000000', 'temperatura', 849.0000, 'ºC'),
	(121437, 108, '2015-04-01 00:43:13.000000', 'temperatura', 430.0000, 'ºC'),
	(121438, 108, '2015-04-01 00:43:14.000000', 'temperatura', 803.0000, 'ºC'),
	(121439, 108, '2015-04-01 00:43:15.000000', 'temperatura', 325.0000, 'ºC'),
	(121440, 108, '2015-04-01 00:43:16.000000', 'temperatura', 419.0000, 'ºC'),
	(121441, 108, '2015-04-01 00:43:17.000000', 'temperatura', 1121.0000, 'ºC'),
	(121442, 108, '2015-04-01 00:43:18.000000', 'temperatura', 748.0000, 'ºC'),
	(121443, 108, '2015-04-01 00:43:19.000000', 'temperatura', 377.0000, 'ºC'),
	(121444, 108, '2015-04-01 00:43:20.000000', 'temperatura', 840.0000, 'ºC'),
	(121445, 108, '2015-04-01 00:43:21.000000', 'temperatura', 672.0000, 'ºC'),
	(121446, 108, '2015-04-01 00:43:22.000000', 'temperatura', 837.0000, 'ºC'),
	(121447, 108, '2015-04-01 00:43:23.000000', 'temperatura', 973.0000, 'ºC'),
	(121448, 108, '2015-04-01 00:43:24.000000', 'temperatura', 1153.0000, 'ºC'),
	(121449, 108, '2015-04-01 00:43:25.000000', 'temperatura', 448.0000, 'ºC'),
	(121450, 108, '2015-04-01 00:43:26.000000', 'temperatura', 1181.0000, 'ºC'),
	(121451, 108, '2015-04-01 00:43:27.000000', 'temperatura', 961.0000, 'ºC'),
	(121452, 108, '2015-04-01 00:43:28.000000', 'temperatura', 62.0000, 'ºC'),
	(121453, 108, '2015-04-01 00:43:29.000000', 'temperatura', 1030.0000, 'ºC'),
	(121454, 108, '2015-04-01 00:43:30.000000', 'temperatura', 163.0000, 'ºC'),
	(121455, 108, '2015-04-01 00:43:31.000000', 'temperatura', 124.0000, 'ºC'),
	(121456, 108, '2015-04-01 00:43:32.000000', 'temperatura', 132.0000, 'ºC'),
	(121457, 108, '2015-04-01 00:43:33.000000', 'temperatura', 289.0000, 'ºC'),
	(121458, 108, '2015-04-01 00:43:34.000000', 'temperatura', 1048.0000, 'ºC'),
	(121459, 108, '2015-04-01 00:43:35.000000', 'temperatura', 774.0000, 'ºC'),
	(121460, 108, '2015-04-01 00:43:36.000000', 'temperatura', 728.0000, 'ºC'),
	(121461, 108, '2015-04-01 00:43:37.000000', 'temperatura', 118.0000, 'ºC'),
	(121462, 108, '2015-04-01 00:43:38.000000', 'temperatura', 808.0000, 'ºC'),
	(121463, 108, '2015-04-01 00:43:39.000000', 'temperatura', 85.0000, 'ºC'),
	(121464, 108, '2015-04-01 00:43:40.000000', 'temperatura', 400.0000, 'ºC'),
	(121465, 108, '2015-04-01 00:43:41.000000', 'temperatura', 545.0000, 'ºC'),
	(121466, 108, '2015-04-01 00:43:42.000000', 'temperatura', 327.0000, 'ºC'),
	(121467, 108, '2015-04-01 00:43:43.000000', 'temperatura', 0.0000, 'ºC'),
	(121468, 108, '2015-04-01 00:43:44.000000', 'temperatura', 221.0000, 'ºC'),
	(121469, 108, '2015-04-01 00:43:45.000000', 'temperatura', 1106.0000, 'ºC'),
	(121470, 108, '2015-04-01 00:43:46.000000', 'temperatura', 66.0000, 'ºC'),
	(121471, 108, '2015-04-01 00:43:47.000000', 'temperatura', 614.0000, 'ºC'),
	(121472, 108, '2015-04-01 00:43:48.000000', 'temperatura', 473.0000, 'ºC'),
	(121473, 108, '2015-04-01 00:43:49.000000', 'temperatura', 521.0000, 'ºC'),
	(121474, 108, '2015-04-01 00:43:50.000000', 'temperatura', 1187.0000, 'ºC'),
	(121475, 108, '2015-04-01 00:43:51.000000', 'temperatura', 772.0000, 'ºC'),
	(121476, 108, '2015-04-01 00:43:52.000000', 'temperatura', 300.0000, 'ºC'),
	(121477, 108, '2015-04-01 00:43:53.000000', 'temperatura', 385.0000, 'ºC'),
	(121478, 108, '2015-04-01 00:43:54.000000', 'temperatura', 1026.0000, 'ºC'),
	(121479, 108, '2015-04-01 00:43:55.000000', 'temperatura', 376.0000, 'ºC'),
	(121480, 108, '2015-04-01 00:43:56.000000', 'temperatura', 0.0000, 'ºC'),
	(121481, 108, '2015-04-01 00:43:57.000000', 'temperatura', 75.0000, 'ºC'),
	(121482, 108, '2015-04-01 00:43:58.000000', 'temperatura', 374.0000, 'ºC'),
	(121483, 108, '2015-04-01 00:43:59.000000', 'temperatura', 446.0000, 'ºC'),
	(121484, 108, '2015-04-01 00:44:00.000000', 'temperatura', 1107.0000, 'ºC'),
	(121485, 108, '2015-04-01 00:44:01.000000', 'temperatura', 600.0000, 'ºC'),
	(121486, 108, '2015-04-01 00:44:02.000000', 'temperatura', 877.0000, 'ºC'),
	(121487, 108, '2015-04-01 00:44:03.000000', 'temperatura', 187.0000, 'ºC'),
	(121488, 108, '2015-04-01 00:44:04.000000', 'temperatura', 704.0000, 'ºC'),
	(121489, 108, '2015-04-01 00:44:05.000000', 'temperatura', 560.0000, 'ºC'),
	(121490, 108, '2015-04-01 00:44:06.000000', 'temperatura', 688.0000, 'ºC'),
	(121491, 108, '2015-04-01 00:44:07.000000', 'temperatura', 559.0000, 'ºC'),
	(121492, 108, '2015-04-01 00:44:08.000000', 'temperatura', 732.0000, 'ºC'),
	(121493, 108, '2015-04-01 00:44:09.000000', 'temperatura', 783.0000, 'ºC'),
	(121494, 108, '2015-04-01 00:44:10.000000', 'temperatura', 522.0000, 'ºC'),
	(121495, 108, '2015-04-01 00:44:11.000000', 'temperatura', 259.0000, 'ºC'),
	(121496, 108, '2015-04-01 00:44:12.000000', 'temperatura', 930.0000, 'ºC'),
	(121497, 108, '2015-04-01 00:44:13.000000', 'temperatura', 274.0000, 'ºC'),
	(121498, 108, '2015-04-01 00:44:14.000000', 'temperatura', 982.0000, 'ºC'),
	(121499, 108, '2015-04-01 00:44:15.000000', 'temperatura', 486.0000, 'ºC'),
	(121500, 108, '2015-04-01 00:44:16.000000', 'temperatura', 686.0000, 'ºC'),
	(121501, 108, '2015-04-01 00:44:17.000000', 'temperatura', 772.0000, 'ºC'),
	(121502, 108, '2015-04-01 00:44:18.000000', 'temperatura', 600.0000, 'ºC'),
	(121503, 108, '2015-04-01 00:44:19.000000', 'temperatura', 688.0000, 'ºC'),
	(121504, 108, '2015-04-01 00:44:20.000000', 'temperatura', 441.0000, 'ºC'),
	(121505, 108, '2015-04-01 00:44:21.000000', 'temperatura', 140.0000, 'ºC'),
	(121506, 108, '2015-04-01 00:44:22.000000', 'temperatura', 579.0000, 'ºC'),
	(121507, 108, '2015-04-01 00:44:23.000000', 'temperatura', 75.0000, 'ºC'),
	(121508, 108, '2015-04-01 00:44:24.000000', 'temperatura', 1039.0000, 'ºC'),
	(121509, 108, '2015-04-01 00:44:25.000000', 'temperatura', 170.0000, 'ºC'),
	(121510, 108, '2015-04-01 00:44:26.000000', 'temperatura', 135.0000, 'ºC'),
	(121511, 108, '2015-04-01 00:44:27.000000', 'temperatura', 165.0000, 'ºC'),
	(121512, 108, '2015-04-01 00:44:28.000000', 'temperatura', 418.0000, 'ºC'),
	(121513, 108, '2015-04-01 00:44:29.000000', 'temperatura', 397.0000, 'ºC'),
	(121514, 108, '2015-04-01 00:44:30.000000', 'temperatura', 731.0000, 'ºC'),
	(121515, 108, '2015-04-01 00:44:31.000000', 'temperatura', 66.0000, 'ºC'),
	(121516, 108, '2015-04-01 00:44:32.000000', 'temperatura', 535.0000, 'ºC'),
	(121517, 108, '2015-04-01 00:44:33.000000', 'temperatura', 80.0000, 'ºC'),
	(121518, 108, '2015-04-01 00:44:34.000000', 'temperatura', 1194.0000, 'ºC'),
	(121519, 108, '2015-04-01 00:44:35.000000', 'temperatura', 931.0000, 'ºC'),
	(121520, 108, '2015-04-01 00:44:36.000000', 'temperatura', 1072.0000, 'ºC'),
	(121521, 108, '2015-04-01 00:44:37.000000', 'temperatura', 168.0000, 'ºC'),
	(121522, 108, '2015-04-01 00:44:38.000000', 'temperatura', 24.0000, 'ºC'),
	(121523, 108, '2015-04-01 00:44:39.000000', 'temperatura', 817.0000, 'ºC'),
	(121524, 108, '2015-04-01 00:44:40.000000', 'temperatura', 414.0000, 'ºC'),
	(121525, 108, '2015-04-01 00:44:41.000000', 'temperatura', 818.0000, 'ºC'),
	(121526, 108, '2015-04-01 00:44:42.000000', 'temperatura', 450.0000, 'ºC'),
	(121527, 108, '2015-04-01 00:44:43.000000', 'temperatura', 996.0000, 'ºC'),
	(121528, 108, '2015-04-01 00:44:44.000000', 'temperatura', 29.0000, 'ºC'),
	(121529, 108, '2015-04-01 00:44:45.000000', 'temperatura', 756.0000, 'ºC'),
	(121530, 108, '2015-04-01 00:44:46.000000', 'temperatura', 97.0000, 'ºC'),
	(121531, 108, '2015-04-01 00:44:47.000000', 'temperatura', 617.0000, 'ºC'),
	(121532, 108, '2015-04-01 00:44:48.000000', 'temperatura', 394.0000, 'ºC'),
	(121533, 108, '2015-04-01 00:44:49.000000', 'temperatura', 121.0000, 'ºC'),
	(121534, 108, '2015-04-01 00:44:50.000000', 'temperatura', 623.0000, 'ºC'),
	(121535, 108, '2015-04-01 00:44:51.000000', 'temperatura', 352.0000, 'ºC'),
	(121536, 108, '2015-04-01 00:44:52.000000', 'temperatura', 1092.0000, 'ºC'),
	(121537, 108, '2015-04-01 00:44:53.000000', 'temperatura', 806.0000, 'ºC'),
	(121538, 108, '2015-04-01 00:44:54.000000', 'temperatura', 753.0000, 'ºC'),
	(121539, 108, '2015-04-01 00:44:55.000000', 'temperatura', 146.0000, 'ºC'),
	(121540, 108, '2015-04-01 00:44:56.000000', 'temperatura', 874.0000, 'ºC'),
	(121541, 108, '2015-04-01 00:44:57.000000', 'temperatura', 332.0000, 'ºC'),
	(121542, 108, '2015-04-01 00:44:58.000000', 'temperatura', 237.0000, 'ºC'),
	(121543, 108, '2015-04-01 00:44:59.000000', 'temperatura', 191.0000, 'ºC'),
	(121544, 108, '2015-04-01 00:45:00.000000', 'temperatura', 244.0000, 'ºC'),
	(121545, 108, '2015-04-01 00:45:01.000000', 'temperatura', 647.0000, 'ºC'),
	(121546, 108, '2015-04-01 00:45:02.000000', 'temperatura', 103.0000, 'ºC'),
	(121547, 108, '2015-04-01 00:45:03.000000', 'temperatura', 976.0000, 'ºC'),
	(121548, 108, '2015-04-01 00:45:04.000000', 'temperatura', 973.0000, 'ºC'),
	(121549, 108, '2015-04-01 00:45:05.000000', 'temperatura', 736.0000, 'ºC'),
	(121550, 108, '2015-04-01 00:45:06.000000', 'temperatura', 760.0000, 'ºC'),
	(121551, 108, '2015-04-01 00:45:07.000000', 'temperatura', 394.0000, 'ºC'),
	(121552, 108, '2015-04-01 00:45:08.000000', 'temperatura', 892.0000, 'ºC'),
	(121553, 108, '2015-04-01 00:45:09.000000', 'temperatura', 875.0000, 'ºC'),
	(121554, 108, '2015-04-01 00:45:10.000000', 'temperatura', 503.0000, 'ºC'),
	(121555, 108, '2015-04-01 00:45:11.000000', 'temperatura', 1088.0000, 'ºC'),
	(121556, 108, '2015-04-01 00:45:12.000000', 'temperatura', 331.0000, 'ºC'),
	(121557, 108, '2015-04-01 00:45:13.000000', 'temperatura', 791.0000, 'ºC'),
	(121558, 108, '2015-04-01 00:45:14.000000', 'temperatura', 563.0000, 'ºC'),
	(121559, 108, '2015-04-01 00:45:15.000000', 'temperatura', 444.0000, 'ºC'),
	(121560, 108, '2015-04-01 00:45:16.000000', 'temperatura', 531.0000, 'ºC'),
	(121561, 108, '2015-04-01 00:45:17.000000', 'temperatura', 124.0000, 'ºC'),
	(121562, 108, '2015-04-01 00:45:18.000000', 'temperatura', 226.0000, 'ºC'),
	(121563, 108, '2015-04-01 00:45:19.000000', 'temperatura', 761.0000, 'ºC'),
	(121564, 108, '2015-04-01 00:45:20.000000', 'temperatura', 728.0000, 'ºC'),
	(121565, 108, '2015-04-01 00:45:21.000000', 'temperatura', 155.0000, 'ºC'),
	(121566, 108, '2015-04-01 00:45:22.000000', 'temperatura', 992.0000, 'ºC'),
	(121567, 108, '2015-04-01 00:45:23.000000', 'temperatura', 896.0000, 'ºC'),
	(121568, 108, '2015-04-01 00:45:24.000000', 'temperatura', 304.0000, 'ºC'),
	(121569, 108, '2015-04-01 00:45:25.000000', 'temperatura', 32.0000, 'ºC'),
	(121570, 108, '2015-04-01 00:45:26.000000', 'temperatura', 449.0000, 'ºC'),
	(121571, 108, '2015-04-01 00:45:27.000000', 'temperatura', 948.0000, 'ºC'),
	(121572, 108, '2015-04-01 00:45:28.000000', 'temperatura', 994.0000, 'ºC'),
	(121573, 108, '2015-04-01 00:45:29.000000', 'temperatura', 926.0000, 'ºC'),
	(121574, 108, '2015-04-01 00:45:30.000000', 'temperatura', 447.0000, 'ºC'),
	(121575, 108, '2015-04-01 00:45:31.000000', 'temperatura', 660.0000, 'ºC'),
	(121576, 108, '2015-04-01 00:45:32.000000', 'temperatura', 757.0000, 'ºC'),
	(121577, 108, '2015-04-01 00:45:33.000000', 'temperatura', 605.0000, 'ºC'),
	(121578, 108, '2015-04-01 00:45:34.000000', 'temperatura', 757.0000, 'ºC'),
	(121579, 108, '2015-04-01 00:45:35.000000', 'temperatura', 768.0000, 'ºC'),
	(121580, 108, '2015-04-01 00:45:36.000000', 'temperatura', 372.0000, 'ºC'),
	(121581, 108, '2015-04-01 00:45:37.000000', 'temperatura', 754.0000, 'ºC'),
	(121582, 108, '2015-04-01 00:45:38.000000', 'temperatura', 257.0000, 'ºC'),
	(121583, 108, '2015-04-01 00:45:39.000000', 'temperatura', 221.0000, 'ºC'),
	(121584, 108, '2015-04-01 00:45:40.000000', 'temperatura', 335.0000, 'ºC'),
	(121585, 108, '2015-04-01 00:45:41.000000', 'temperatura', 1013.0000, 'ºC'),
	(121586, 108, '2015-04-01 00:45:42.000000', 'temperatura', 462.0000, 'ºC'),
	(121587, 108, '2015-04-01 00:45:43.000000', 'temperatura', 471.0000, 'ºC'),
	(121588, 108, '2015-04-01 00:45:44.000000', 'temperatura', 969.0000, 'ºC'),
	(121589, 108, '2015-04-01 00:45:45.000000', 'temperatura', 1031.0000, 'ºC'),
	(121590, 108, '2015-04-01 00:45:46.000000', 'temperatura', 1051.0000, 'ºC'),
	(121591, 108, '2015-04-01 00:45:47.000000', 'temperatura', 960.0000, 'ºC'),
	(121592, 108, '2015-04-01 00:45:48.000000', 'temperatura', 449.0000, 'ºC'),
	(121593, 108, '2015-04-01 00:45:49.000000', 'temperatura', 566.0000, 'ºC'),
	(121594, 108, '2015-04-01 00:45:50.000000', 'temperatura', 281.0000, 'ºC'),
	(121595, 108, '2015-04-01 00:45:51.000000', 'temperatura', 909.0000, 'ºC'),
	(121596, 108, '2015-04-01 00:45:52.000000', 'temperatura', 102.0000, 'ºC'),
	(121597, 108, '2015-04-01 00:45:53.000000', 'temperatura', 184.0000, 'ºC'),
	(121598, 108, '2015-04-01 00:45:54.000000', 'temperatura', 612.0000, 'ºC'),
	(121599, 108, '2015-04-01 00:45:55.000000', 'temperatura', 111.0000, 'ºC'),
	(121600, 108, '2015-04-01 00:45:56.000000', 'temperatura', 1120.0000, 'ºC'),
	(121601, 108, '2015-04-01 00:45:57.000000', 'temperatura', 465.0000, 'ºC'),
	(121602, 108, '2015-04-01 00:45:58.000000', 'temperatura', 169.0000, 'ºC'),
	(121603, 108, '2015-04-01 00:45:59.000000', 'temperatura', 647.0000, 'ºC'),
	(121604, 108, '2015-04-01 00:46:00.000000', 'temperatura', 330.0000, 'ºC'),
	(121605, 108, '2015-04-01 00:46:01.000000', 'temperatura', 909.0000, 'ºC'),
	(121606, 108, '2015-04-01 00:46:02.000000', 'temperatura', 1156.0000, 'ºC'),
	(121607, 108, '2015-04-01 00:46:03.000000', 'temperatura', 653.0000, 'ºC'),
	(121608, 108, '2015-04-01 00:46:04.000000', 'temperatura', 996.0000, 'ºC'),
	(121609, 108, '2015-04-01 00:46:05.000000', 'temperatura', 622.0000, 'ºC'),
	(121610, 108, '2015-04-01 00:46:06.000000', 'temperatura', 121.0000, 'ºC'),
	(121611, 108, '2015-04-01 00:46:07.000000', 'temperatura', 1141.0000, 'ºC'),
	(121612, 108, '2015-04-01 00:46:08.000000', 'temperatura', 543.0000, 'ºC'),
	(121613, 108, '2015-04-01 00:46:09.000000', 'temperatura', 490.0000, 'ºC'),
	(121614, 108, '2015-04-01 00:46:10.000000', 'temperatura', 825.0000, 'ºC'),
	(121615, 108, '2015-04-01 00:46:11.000000', 'temperatura', 253.0000, 'ºC'),
	(121616, 108, '2015-04-01 00:46:12.000000', 'temperatura', 1193.0000, 'ºC'),
	(121617, 108, '2015-04-01 00:46:13.000000', 'temperatura', 404.0000, 'ºC'),
	(121618, 108, '2015-04-01 00:46:14.000000', 'temperatura', 843.0000, 'ºC'),
	(121619, 108, '2015-04-01 00:46:15.000000', 'temperatura', 605.0000, 'ºC'),
	(121620, 108, '2015-04-01 00:46:16.000000', 'temperatura', 493.0000, 'ºC'),
	(121621, 108, '2015-04-01 00:46:17.000000', 'temperatura', 654.0000, 'ºC'),
	(121622, 108, '2015-04-01 00:46:18.000000', 'temperatura', 589.0000, 'ºC'),
	(121623, 108, '2015-04-01 00:46:19.000000', 'temperatura', 983.0000, 'ºC'),
	(121624, 108, '2015-04-01 00:46:20.000000', 'temperatura', 751.0000, 'ºC'),
	(121625, 108, '2015-04-01 00:46:21.000000', 'temperatura', 805.0000, 'ºC'),
	(121626, 108, '2015-04-01 00:46:22.000000', 'temperatura', 571.0000, 'ºC'),
	(121627, 108, '2015-04-01 00:46:23.000000', 'temperatura', 441.0000, 'ºC'),
	(121628, 108, '2015-04-01 00:46:24.000000', 'temperatura', 495.0000, 'ºC'),
	(121629, 108, '2015-04-01 00:46:25.000000', 'temperatura', 1151.0000, 'ºC'),
	(121630, 108, '2015-04-01 00:46:26.000000', 'temperatura', 672.0000, 'ºC'),
	(121631, 108, '2015-04-01 00:46:27.000000', 'temperatura', 1106.0000, 'ºC'),
	(121632, 108, '2015-04-01 00:46:28.000000', 'temperatura', 1113.0000, 'ºC'),
	(121633, 108, '2015-04-01 00:46:29.000000', 'temperatura', 1049.0000, 'ºC'),
	(121634, 108, '2015-04-01 00:46:30.000000', 'temperatura', 707.0000, 'ºC'),
	(121635, 108, '2015-04-01 00:46:31.000000', 'temperatura', 389.0000, 'ºC'),
	(121636, 108, '2015-04-01 00:46:32.000000', 'temperatura', 1025.0000, 'ºC'),
	(121637, 108, '2015-04-01 00:46:33.000000', 'temperatura', 358.0000, 'ºC'),
	(121638, 108, '2015-04-01 00:46:34.000000', 'temperatura', 1113.0000, 'ºC'),
	(121639, 108, '2015-04-01 00:46:35.000000', 'temperatura', 894.0000, 'ºC'),
	(121640, 108, '2015-04-01 00:46:36.000000', 'temperatura', 1130.0000, 'ºC'),
	(121641, 108, '2015-04-01 00:46:37.000000', 'temperatura', 570.0000, 'ºC'),
	(121642, 108, '2015-04-01 00:46:38.000000', 'temperatura', 662.0000, 'ºC'),
	(121643, 108, '2015-04-01 00:46:39.000000', 'temperatura', 398.0000, 'ºC'),
	(121644, 108, '2015-04-01 00:46:40.000000', 'temperatura', 3.0000, 'ºC'),
	(121645, 108, '2015-04-01 00:46:41.000000', 'temperatura', 24.0000, 'ºC'),
	(121646, 108, '2015-04-01 00:46:42.000000', 'temperatura', 113.0000, 'ºC'),
	(121647, 108, '2015-04-01 00:46:43.000000', 'temperatura', 492.0000, 'ºC'),
	(121648, 108, '2015-04-01 00:46:44.000000', 'temperatura', 920.0000, 'ºC'),
	(121649, 108, '2015-04-01 00:46:45.000000', 'temperatura', 726.0000, 'ºC'),
	(121650, 108, '2015-04-01 00:46:46.000000', 'temperatura', 872.0000, 'ºC'),
	(121651, 108, '2015-04-01 00:46:47.000000', 'temperatura', 983.0000, 'ºC'),
	(121652, 108, '2015-04-01 00:46:48.000000', 'temperatura', 1096.0000, 'ºC'),
	(121653, 108, '2015-04-01 00:46:49.000000', 'temperatura', 135.0000, 'ºC'),
	(121654, 108, '2015-04-01 00:46:50.000000', 'temperatura', 986.0000, 'ºC'),
	(121655, 108, '2015-04-01 00:46:51.000000', 'temperatura', 927.0000, 'ºC'),
	(121656, 108, '2015-04-01 00:46:52.000000', 'temperatura', 477.0000, 'ºC'),
	(121657, 108, '2015-04-01 00:46:53.000000', 'temperatura', 805.0000, 'ºC'),
	(121658, 108, '2015-04-01 00:46:54.000000', 'temperatura', 193.0000, 'ºC'),
	(121659, 108, '2015-04-01 00:46:55.000000', 'temperatura', 950.0000, 'ºC'),
	(121660, 108, '2015-04-01 00:46:56.000000', 'temperatura', 572.0000, 'ºC'),
	(121661, 108, '2015-04-01 00:46:57.000000', 'temperatura', 11.0000, 'ºC'),
	(121662, 108, '2015-04-01 00:46:58.000000', 'temperatura', 738.0000, 'ºC'),
	(121663, 108, '2015-04-01 00:46:59.000000', 'temperatura', 59.0000, 'ºC'),
	(121664, 108, '2015-04-01 00:47:00.000000', 'temperatura', 479.0000, 'ºC'),
	(121665, 108, '2015-04-01 00:47:01.000000', 'temperatura', 1021.0000, 'ºC'),
	(121666, 108, '2015-04-01 00:47:02.000000', 'temperatura', 67.0000, 'ºC'),
	(121667, 108, '2015-04-01 00:47:03.000000', 'temperatura', 873.0000, 'ºC'),
	(121668, 108, '2015-04-01 00:47:04.000000', 'temperatura', 565.0000, 'ºC'),
	(121669, 108, '2015-04-01 00:47:05.000000', 'temperatura', 205.0000, 'ºC'),
	(121670, 108, '2015-04-01 00:47:06.000000', 'temperatura', 531.0000, 'ºC'),
	(121671, 108, '2015-04-01 00:47:07.000000', 'temperatura', 841.0000, 'ºC'),
	(121672, 108, '2015-04-01 00:47:08.000000', 'temperatura', 212.0000, 'ºC'),
	(121673, 108, '2015-04-01 00:47:09.000000', 'temperatura', 936.0000, 'ºC'),
	(121674, 108, '2015-04-01 00:47:10.000000', 'temperatura', 447.0000, 'ºC'),
	(121675, 108, '2015-04-01 00:47:11.000000', 'temperatura', 628.0000, 'ºC'),
	(121676, 108, '2015-04-01 00:47:12.000000', 'temperatura', 600.0000, 'ºC'),
	(121677, 108, '2015-04-01 00:47:13.000000', 'temperatura', 1117.0000, 'ºC'),
	(121678, 108, '2015-04-01 00:47:14.000000', 'temperatura', 184.0000, 'ºC'),
	(121679, 108, '2015-04-01 00:47:15.000000', 'temperatura', 1171.0000, 'ºC'),
	(121680, 108, '2015-04-01 00:47:16.000000', 'temperatura', 501.0000, 'ºC'),
	(121681, 108, '2015-04-01 00:47:17.000000', 'temperatura', 194.0000, 'ºC'),
	(121682, 108, '2015-04-01 00:47:18.000000', 'temperatura', 668.0000, 'ºC'),
	(121683, 108, '2015-04-01 00:47:19.000000', 'temperatura', 357.0000, 'ºC'),
	(121684, 108, '2015-04-01 00:47:20.000000', 'temperatura', 981.0000, 'ºC'),
	(121685, 108, '2015-04-01 00:47:21.000000', 'temperatura', 235.0000, 'ºC'),
	(121686, 108, '2015-04-01 00:47:22.000000', 'temperatura', 633.0000, 'ºC'),
	(121687, 108, '2015-04-01 00:47:23.000000', 'temperatura', 60.0000, 'ºC'),
	(121688, 108, '2015-04-01 00:47:24.000000', 'temperatura', 804.0000, 'ºC'),
	(121689, 108, '2015-04-01 00:47:25.000000', 'temperatura', 237.0000, 'ºC'),
	(121690, 108, '2015-04-01 00:47:26.000000', 'temperatura', 1175.0000, 'ºC'),
	(121691, 108, '2015-04-01 00:47:27.000000', 'temperatura', 363.0000, 'ºC'),
	(121692, 108, '2015-04-01 00:47:28.000000', 'temperatura', 690.0000, 'ºC'),
	(121693, 108, '2015-04-01 00:47:29.000000', 'temperatura', 1164.0000, 'ºC'),
	(121694, 108, '2015-04-01 00:47:30.000000', 'temperatura', 151.0000, 'ºC'),
	(121695, 108, '2015-04-01 00:47:31.000000', 'temperatura', 862.0000, 'ºC'),
	(121696, 108, '2015-04-01 00:47:32.000000', 'temperatura', 258.0000, 'ºC'),
	(121697, 108, '2015-04-01 00:47:33.000000', 'temperatura', 1104.0000, 'ºC'),
	(121698, 108, '2015-04-01 00:47:34.000000', 'temperatura', 1146.0000, 'ºC'),
	(121699, 108, '2015-04-01 00:47:35.000000', 'temperatura', 21.0000, 'ºC'),
	(121700, 108, '2015-04-01 00:47:36.000000', 'temperatura', 266.0000, 'ºC'),
	(121701, 108, '2015-04-01 00:47:37.000000', 'temperatura', 67.0000, 'ºC'),
	(121702, 108, '2015-04-01 00:47:38.000000', 'temperatura', 738.0000, 'ºC'),
	(121703, 108, '2015-04-01 00:47:39.000000', 'temperatura', 1088.0000, 'ºC'),
	(121704, 108, '2015-04-01 00:47:40.000000', 'temperatura', 827.0000, 'ºC'),
	(121705, 108, '2015-04-01 00:47:41.000000', 'temperatura', 871.0000, 'ºC'),
	(121706, 108, '2015-04-01 00:47:42.000000', 'temperatura', 674.0000, 'ºC'),
	(121707, 108, '2015-04-01 00:47:43.000000', 'temperatura', 759.0000, 'ºC'),
	(121708, 108, '2015-04-01 00:47:44.000000', 'temperatura', 571.0000, 'ºC'),
	(121709, 108, '2015-04-01 00:47:45.000000', 'temperatura', 579.0000, 'ºC'),
	(121710, 108, '2015-04-01 00:47:46.000000', 'temperatura', 1185.0000, 'ºC'),
	(121711, 108, '2015-04-01 00:47:47.000000', 'temperatura', 588.0000, 'ºC'),
	(121712, 108, '2015-04-01 00:47:48.000000', 'temperatura', 585.0000, 'ºC'),
	(121713, 108, '2015-04-01 00:47:49.000000', 'temperatura', 1163.0000, 'ºC'),
	(121714, 108, '2015-04-01 00:47:50.000000', 'temperatura', 458.0000, 'ºC'),
	(121715, 108, '2015-04-01 00:47:51.000000', 'temperatura', 2.0000, 'ºC'),
	(121716, 108, '2015-04-01 00:47:52.000000', 'temperatura', 1035.0000, 'ºC'),
	(121717, 108, '2015-04-01 00:47:53.000000', 'temperatura', 370.0000, 'ºC'),
	(121718, 108, '2015-04-01 00:47:54.000000', 'temperatura', 1145.0000, 'ºC'),
	(121719, 108, '2015-04-01 00:47:55.000000', 'temperatura', 1015.0000, 'ºC'),
	(121720, 108, '2015-04-01 00:47:56.000000', 'temperatura', 442.0000, 'ºC'),
	(121721, 108, '2015-04-01 00:47:57.000000', 'temperatura', 364.0000, 'ºC'),
	(121722, 108, '2015-04-01 00:47:58.000000', 'temperatura', 497.0000, 'ºC'),
	(121723, 108, '2015-04-01 00:47:59.000000', 'temperatura', 192.0000, 'ºC'),
	(121724, 108, '2015-04-01 00:48:00.000000', 'temperatura', 669.0000, 'ºC'),
	(121725, 108, '2015-04-01 00:48:01.000000', 'temperatura', 372.0000, 'ºC'),
	(121726, 108, '2015-04-01 00:48:02.000000', 'temperatura', 1050.0000, 'ºC'),
	(121727, 108, '2015-04-01 00:48:03.000000', 'temperatura', 536.0000, 'ºC'),
	(121728, 108, '2015-04-01 00:48:04.000000', 'temperatura', 731.0000, 'ºC'),
	(121729, 108, '2015-04-01 00:48:05.000000', 'temperatura', 848.0000, 'ºC'),
	(121730, 108, '2015-04-01 00:48:06.000000', 'temperatura', 845.0000, 'ºC'),
	(121731, 108, '2015-04-01 00:48:07.000000', 'temperatura', 483.0000, 'ºC'),
	(121732, 108, '2015-04-01 00:48:08.000000', 'temperatura', 1081.0000, 'ºC'),
	(121733, 108, '2015-04-01 00:48:09.000000', 'temperatura', 357.0000, 'ºC'),
	(121734, 108, '2015-04-01 00:48:10.000000', 'temperatura', 941.0000, 'ºC'),
	(121735, 108, '2015-04-01 00:48:11.000000', 'temperatura', 35.0000, 'ºC'),
	(121736, 108, '2015-04-01 00:48:12.000000', 'temperatura', 951.0000, 'ºC'),
	(121737, 108, '2015-04-01 00:48:13.000000', 'temperatura', 1053.0000, 'ºC'),
	(121738, 108, '2015-04-01 00:48:14.000000', 'temperatura', 13.0000, 'ºC'),
	(121739, 108, '2015-04-01 00:48:15.000000', 'temperatura', 505.0000, 'ºC'),
	(121740, 108, '2015-04-01 00:48:16.000000', 'temperatura', 88.0000, 'ºC'),
	(121741, 108, '2015-04-01 00:48:17.000000', 'temperatura', 126.0000, 'ºC'),
	(121742, 108, '2015-04-01 00:48:18.000000', 'temperatura', 366.0000, 'ºC'),
	(121743, 108, '2015-04-01 00:48:19.000000', 'temperatura', 250.0000, 'ºC'),
	(121744, 108, '2015-04-01 00:48:20.000000', 'temperatura', 156.0000, 'ºC'),
	(121745, 108, '2015-04-01 00:48:21.000000', 'temperatura', 28.0000, 'ºC'),
	(121746, 108, '2015-04-01 00:48:22.000000', 'temperatura', 872.0000, 'ºC'),
	(121747, 108, '2015-04-01 00:48:23.000000', 'temperatura', 679.0000, 'ºC'),
	(121748, 108, '2015-04-01 00:48:24.000000', 'temperatura', 779.0000, 'ºC'),
	(121749, 108, '2015-04-01 00:48:25.000000', 'temperatura', 657.0000, 'ºC'),
	(121750, 108, '2015-04-01 00:48:26.000000', 'temperatura', 948.0000, 'ºC'),
	(121751, 108, '2015-04-01 00:48:27.000000', 'temperatura', 372.0000, 'ºC'),
	(121752, 108, '2015-04-01 00:48:28.000000', 'temperatura', 215.0000, 'ºC'),
	(121753, 108, '2015-04-01 00:48:29.000000', 'temperatura', 1161.0000, 'ºC'),
	(121754, 108, '2015-04-01 00:48:30.000000', 'temperatura', 358.0000, 'ºC'),
	(121755, 108, '2015-04-01 00:48:31.000000', 'temperatura', 711.0000, 'ºC'),
	(121756, 108, '2015-04-01 00:48:32.000000', 'temperatura', 78.0000, 'ºC'),
	(121757, 108, '2015-04-01 00:48:33.000000', 'temperatura', 659.0000, 'ºC'),
	(121758, 108, '2015-04-01 00:48:34.000000', 'temperatura', 663.0000, 'ºC'),
	(121759, 108, '2015-04-01 00:48:35.000000', 'temperatura', 137.0000, 'ºC'),
	(121760, 108, '2015-04-01 00:48:36.000000', 'temperatura', 1096.0000, 'ºC'),
	(121761, 108, '2015-04-01 00:48:37.000000', 'temperatura', 270.0000, 'ºC'),
	(121762, 108, '2015-04-01 00:48:38.000000', 'temperatura', 464.0000, 'ºC'),
	(121763, 108, '2015-04-01 00:48:39.000000', 'temperatura', 309.0000, 'ºC'),
	(121764, 108, '2015-04-01 00:48:40.000000', 'temperatura', 152.0000, 'ºC'),
	(121765, 108, '2015-04-01 00:48:41.000000', 'temperatura', 1034.0000, 'ºC'),
	(121766, 108, '2015-04-01 00:48:42.000000', 'temperatura', 1114.0000, 'ºC'),
	(121767, 108, '2015-04-01 00:48:43.000000', 'temperatura', 71.0000, 'ºC'),
	(121768, 108, '2015-04-01 00:48:44.000000', 'temperatura', 611.0000, 'ºC'),
	(121769, 108, '2015-04-01 00:48:45.000000', 'temperatura', 444.0000, 'ºC'),
	(121770, 108, '2015-04-01 00:48:46.000000', 'temperatura', 386.0000, 'ºC'),
	(121771, 108, '2015-04-01 00:48:47.000000', 'temperatura', 601.0000, 'ºC'),
	(121772, 108, '2015-04-01 00:48:48.000000', 'temperatura', 647.0000, 'ºC'),
	(121773, 108, '2015-04-01 00:48:49.000000', 'temperatura', 234.0000, 'ºC'),
	(121774, 108, '2015-04-01 00:48:50.000000', 'temperatura', 428.0000, 'ºC'),
	(121775, 108, '2015-04-01 00:48:51.000000', 'temperatura', 238.0000, 'ºC'),
	(121776, 108, '2015-04-01 00:48:52.000000', 'temperatura', 1105.0000, 'ºC'),
	(121777, 108, '2015-04-01 00:48:53.000000', 'temperatura', 14.0000, 'ºC'),
	(121778, 108, '2015-04-01 00:48:54.000000', 'temperatura', 353.0000, 'ºC'),
	(121779, 108, '2015-04-01 00:48:55.000000', 'temperatura', 525.0000, 'ºC'),
	(121780, 108, '2015-04-01 00:48:56.000000', 'temperatura', 367.0000, 'ºC'),
	(121781, 108, '2015-04-01 00:48:57.000000', 'temperatura', 262.0000, 'ºC'),
	(121782, 108, '2015-04-01 00:48:58.000000', 'temperatura', 207.0000, 'ºC'),
	(121783, 108, '2015-04-01 00:48:59.000000', 'temperatura', 251.0000, 'ºC'),
	(121784, 108, '2015-04-01 00:49:00.000000', 'temperatura', 636.0000, 'ºC'),
	(121785, 108, '2015-04-01 00:49:01.000000', 'temperatura', 25.0000, 'ºC'),
	(121786, 108, '2015-04-01 00:49:02.000000', 'temperatura', 620.0000, 'ºC'),
	(121787, 108, '2015-04-01 00:49:03.000000', 'temperatura', 623.0000, 'ºC'),
	(121788, 108, '2015-04-01 00:49:04.000000', 'temperatura', 55.0000, 'ºC'),
	(121789, 108, '2015-04-01 00:49:05.000000', 'temperatura', 809.0000, 'ºC'),
	(121790, 108, '2015-04-01 00:49:06.000000', 'temperatura', 280.0000, 'ºC'),
	(121791, 108, '2015-04-01 00:49:07.000000', 'temperatura', 172.0000, 'ºC'),
	(121792, 108, '2015-04-01 00:49:08.000000', 'temperatura', 19.0000, 'ºC'),
	(121793, 108, '2015-04-01 00:49:09.000000', 'temperatura', 783.0000, 'ºC'),
	(121794, 108, '2015-04-01 00:49:10.000000', 'temperatura', 257.0000, 'ºC'),
	(121795, 108, '2015-04-01 00:49:11.000000', 'temperatura', 135.0000, 'ºC'),
	(121796, 108, '2015-04-01 00:49:12.000000', 'temperatura', 1104.0000, 'ºC'),
	(121797, 108, '2015-04-01 00:49:13.000000', 'temperatura', 318.0000, 'ºC'),
	(121798, 108, '2015-04-01 00:49:14.000000', 'temperatura', 678.0000, 'ºC'),
	(121799, 108, '2015-04-01 00:49:15.000000', 'temperatura', 38.0000, 'ºC'),
	(121800, 108, '2015-04-01 00:49:16.000000', 'temperatura', 556.0000, 'ºC'),
	(121801, 108, '2015-04-01 00:49:17.000000', 'temperatura', 266.0000, 'ºC'),
	(121802, 108, '2015-04-01 00:49:18.000000', 'temperatura', 863.0000, 'ºC'),
	(121803, 108, '2015-04-01 00:49:19.000000', 'temperatura', 1117.0000, 'ºC'),
	(121804, 108, '2015-04-01 00:49:20.000000', 'temperatura', 597.0000, 'ºC'),
	(121805, 108, '2015-04-01 00:49:21.000000', 'temperatura', 836.0000, 'ºC'),
	(121806, 108, '2015-04-01 00:49:22.000000', 'temperatura', 1190.0000, 'ºC'),
	(121807, 108, '2015-04-01 00:49:23.000000', 'temperatura', 1039.0000, 'ºC'),
	(121808, 108, '2015-04-01 00:49:24.000000', 'temperatura', 428.0000, 'ºC'),
	(121809, 108, '2015-04-01 00:49:25.000000', 'temperatura', 224.0000, 'ºC'),
	(121810, 108, '2015-04-01 00:49:26.000000', 'temperatura', 1036.0000, 'ºC'),
	(121811, 108, '2015-04-01 00:49:27.000000', 'temperatura', 908.0000, 'ºC'),
	(121812, 108, '2015-04-01 00:49:28.000000', 'temperatura', 231.0000, 'ºC'),
	(121813, 108, '2015-04-01 00:49:29.000000', 'temperatura', 834.0000, 'ºC'),
	(121814, 108, '2015-04-01 00:49:30.000000', 'temperatura', 1078.0000, 'ºC'),
	(121815, 108, '2015-04-01 00:49:31.000000', 'temperatura', 488.0000, 'ºC'),
	(121816, 108, '2015-04-01 00:49:32.000000', 'temperatura', 406.0000, 'ºC'),
	(121817, 108, '2015-04-01 00:49:33.000000', 'temperatura', 565.0000, 'ºC'),
	(121818, 108, '2015-04-01 00:49:34.000000', 'temperatura', 409.0000, 'ºC'),
	(121819, 108, '2015-04-01 00:49:35.000000', 'temperatura', 351.0000, 'ºC'),
	(121820, 108, '2015-04-01 00:49:36.000000', 'temperatura', 527.0000, 'ºC'),
	(121821, 108, '2015-04-01 00:49:37.000000', 'temperatura', 384.0000, 'ºC'),
	(121822, 108, '2015-04-01 00:49:38.000000', 'temperatura', 338.0000, 'ºC'),
	(121823, 108, '2015-04-01 00:49:39.000000', 'temperatura', 540.0000, 'ºC'),
	(121824, 108, '2015-04-01 00:49:40.000000', 'temperatura', 487.0000, 'ºC'),
	(121825, 108, '2015-04-01 00:49:41.000000', 'temperatura', 813.0000, 'ºC'),
	(121826, 108, '2015-04-01 00:49:42.000000', 'temperatura', 204.0000, 'ºC'),
	(121827, 108, '2015-04-01 00:49:43.000000', 'temperatura', 983.0000, 'ºC'),
	(121828, 108, '2015-04-01 00:49:44.000000', 'temperatura', 702.0000, 'ºC'),
	(121829, 108, '2015-04-01 00:49:45.000000', 'temperatura', 561.0000, 'ºC'),
	(121830, 108, '2015-04-01 00:49:46.000000', 'temperatura', 702.0000, 'ºC'),
	(121831, 108, '2015-04-01 00:49:47.000000', 'temperatura', 627.0000, 'ºC'),
	(121832, 108, '2015-04-01 00:49:48.000000', 'temperatura', 1031.0000, 'ºC'),
	(121833, 108, '2015-04-01 00:49:49.000000', 'temperatura', 873.0000, 'ºC'),
	(121834, 108, '2015-04-01 00:49:50.000000', 'temperatura', 72.0000, 'ºC'),
	(121835, 108, '2015-04-01 00:49:51.000000', 'temperatura', 140.0000, 'ºC'),
	(121836, 108, '2015-04-01 00:49:52.000000', 'temperatura', 485.0000, 'ºC'),
	(121837, 108, '2015-04-01 00:49:53.000000', 'temperatura', 806.0000, 'ºC'),
	(121838, 108, '2015-04-01 00:49:54.000000', 'temperatura', 175.0000, 'ºC'),
	(121839, 108, '2015-04-01 00:49:55.000000', 'temperatura', 857.0000, 'ºC'),
	(121840, 108, '2015-04-01 00:49:56.000000', 'temperatura', 160.0000, 'ºC'),
	(121841, 108, '2015-04-01 00:49:57.000000', 'temperatura', 632.0000, 'ºC'),
	(121842, 108, '2015-04-01 00:49:58.000000', 'temperatura', 280.0000, 'ºC'),
	(121843, 108, '2015-04-01 00:49:59.000000', 'temperatura', 703.0000, 'ºC'),
	(121844, 108, '2015-04-01 00:50:00.000000', 'temperatura', 274.0000, 'ºC'),
	(121845, 108, '2015-04-01 00:50:01.000000', 'temperatura', 464.0000, 'ºC'),
	(121846, 108, '2015-04-01 00:50:02.000000', 'temperatura', 298.0000, 'ºC'),
	(121847, 108, '2015-04-01 00:50:03.000000', 'temperatura', 100.0000, 'ºC'),
	(121848, 108, '2015-04-01 00:50:04.000000', 'temperatura', 805.0000, 'ºC'),
	(121849, 108, '2015-04-01 00:50:05.000000', 'temperatura', 124.0000, 'ºC'),
	(121850, 108, '2015-04-01 00:50:06.000000', 'temperatura', 608.0000, 'ºC'),
	(121851, 108, '2015-04-01 00:50:07.000000', 'temperatura', 267.0000, 'ºC'),
	(121852, 108, '2015-04-01 00:50:08.000000', 'temperatura', 711.0000, 'ºC'),
	(121853, 108, '2015-04-01 00:50:09.000000', 'temperatura', 357.0000, 'ºC'),
	(121854, 108, '2015-04-01 00:50:10.000000', 'temperatura', 852.0000, 'ºC'),
	(121855, 108, '2015-04-01 00:50:11.000000', 'temperatura', 787.0000, 'ºC'),
	(121856, 108, '2015-04-01 00:50:12.000000', 'temperatura', 183.0000, 'ºC'),
	(121857, 108, '2015-04-01 00:50:13.000000', 'temperatura', 953.0000, 'ºC'),
	(121858, 108, '2015-04-01 00:50:14.000000', 'temperatura', 617.0000, 'ºC'),
	(121859, 108, '2015-04-01 00:50:15.000000', 'temperatura', 224.0000, 'ºC'),
	(121860, 108, '2015-04-01 00:50:16.000000', 'temperatura', 471.0000, 'ºC'),
	(121861, 108, '2015-04-01 00:50:17.000000', 'temperatura', 485.0000, 'ºC'),
	(121862, 108, '2015-04-01 00:50:18.000000', 'temperatura', 1010.0000, 'ºC'),
	(121863, 108, '2015-04-01 00:50:19.000000', 'temperatura', 1197.0000, 'ºC'),
	(121864, 108, '2015-04-01 00:50:20.000000', 'temperatura', 555.0000, 'ºC'),
	(121865, 108, '2015-04-01 00:50:21.000000', 'temperatura', 383.0000, 'ºC'),
	(121866, 108, '2015-04-01 00:50:22.000000', 'temperatura', 250.0000, 'ºC'),
	(121867, 108, '2015-04-01 00:50:23.000000', 'temperatura', 103.0000, 'ºC'),
	(121868, 108, '2015-04-01 00:50:24.000000', 'temperatura', 964.0000, 'ºC'),
	(121869, 108, '2015-04-01 00:50:25.000000', 'temperatura', 914.0000, 'ºC'),
	(121870, 108, '2015-04-01 00:50:26.000000', 'temperatura', 478.0000, 'ºC'),
	(121871, 108, '2015-04-01 00:50:27.000000', 'temperatura', 847.0000, 'ºC'),
	(121872, 108, '2015-04-01 00:50:28.000000', 'temperatura', 402.0000, 'ºC'),
	(121873, 108, '2015-04-01 00:50:29.000000', 'temperatura', 671.0000, 'ºC'),
	(121874, 108, '2015-04-01 00:50:30.000000', 'temperatura', 948.0000, 'ºC'),
	(121875, 108, '2015-04-01 00:50:31.000000', 'temperatura', 327.0000, 'ºC'),
	(121876, 108, '2015-04-01 00:50:32.000000', 'temperatura', 1194.0000, 'ºC'),
	(121877, 108, '2015-04-01 00:50:33.000000', 'temperatura', 188.0000, 'ºC'),
	(121878, 108, '2015-04-01 00:50:34.000000', 'temperatura', 959.0000, 'ºC'),
	(121879, 108, '2015-04-01 00:50:35.000000', 'temperatura', 633.0000, 'ºC'),
	(121880, 108, '2015-04-01 00:50:36.000000', 'temperatura', 288.0000, 'ºC'),
	(121881, 108, '2015-04-01 00:50:37.000000', 'temperatura', 740.0000, 'ºC'),
	(121882, 108, '2015-04-01 00:50:38.000000', 'temperatura', 436.0000, 'ºC'),
	(121883, 108, '2015-04-01 00:50:39.000000', 'temperatura', 1160.0000, 'ºC'),
	(121884, 108, '2015-04-01 00:50:40.000000', 'temperatura', 893.0000, 'ºC'),
	(121885, 108, '2015-04-01 00:50:41.000000', 'temperatura', 986.0000, 'ºC'),
	(121886, 108, '2015-04-01 00:50:42.000000', 'temperatura', 1053.0000, 'ºC'),
	(121887, 108, '2015-04-01 00:50:43.000000', 'temperatura', 1107.0000, 'ºC'),
	(121888, 108, '2015-04-01 00:50:44.000000', 'temperatura', 1177.0000, 'ºC'),
	(121889, 108, '2015-04-01 00:50:45.000000', 'temperatura', 162.0000, 'ºC'),
	(121890, 108, '2015-04-01 00:50:46.000000', 'temperatura', 880.0000, 'ºC'),
	(121891, 108, '2015-04-01 00:50:47.000000', 'temperatura', 315.0000, 'ºC'),
	(121892, 108, '2015-04-01 00:50:48.000000', 'temperatura', 137.0000, 'ºC'),
	(121893, 108, '2015-04-01 00:50:49.000000', 'temperatura', 940.0000, 'ºC'),
	(121894, 108, '2015-04-01 00:50:50.000000', 'temperatura', 688.0000, 'ºC'),
	(121895, 108, '2015-04-01 00:50:51.000000', 'temperatura', 619.0000, 'ºC'),
	(121896, 108, '2015-04-01 00:50:52.000000', 'temperatura', 1034.0000, 'ºC'),
	(121897, 108, '2015-04-01 00:50:53.000000', 'temperatura', 915.0000, 'ºC'),
	(121898, 108, '2015-04-01 00:50:54.000000', 'temperatura', 272.0000, 'ºC'),
	(121899, 108, '2015-04-01 00:50:55.000000', 'temperatura', 1016.0000, 'ºC'),
	(121900, 108, '2015-04-01 00:50:56.000000', 'temperatura', 664.0000, 'ºC'),
	(121901, 108, '2015-04-01 00:50:57.000000', 'temperatura', 271.0000, 'ºC'),
	(121902, 108, '2015-04-01 00:50:58.000000', 'temperatura', 564.0000, 'ºC'),
	(121903, 108, '2015-04-01 00:50:59.000000', 'temperatura', 810.0000, 'ºC'),
	(121904, 108, '2015-04-01 00:51:00.000000', 'temperatura', 1156.0000, 'ºC'),
	(121905, 108, '2015-04-01 00:51:01.000000', 'temperatura', 952.0000, 'ºC'),
	(121906, 108, '2015-04-01 00:51:02.000000', 'temperatura', 94.0000, 'ºC'),
	(121907, 108, '2015-04-01 00:51:03.000000', 'temperatura', 12.0000, 'ºC'),
	(121908, 108, '2015-04-01 00:51:04.000000', 'temperatura', 981.0000, 'ºC'),
	(121909, 108, '2015-04-01 00:51:05.000000', 'temperatura', 67.0000, 'ºC'),
	(121910, 108, '2015-04-01 00:51:06.000000', 'temperatura', 991.0000, 'ºC'),
	(121911, 108, '2015-04-01 00:51:07.000000', 'temperatura', 1158.0000, 'ºC'),
	(121912, 108, '2015-04-01 00:51:08.000000', 'temperatura', 417.0000, 'ºC'),
	(121913, 108, '2015-04-01 00:51:09.000000', 'temperatura', 1011.0000, 'ºC'),
	(121914, 108, '2015-04-01 00:51:10.000000', 'temperatura', 204.0000, 'ºC'),
	(121915, 108, '2015-04-01 00:51:11.000000', 'temperatura', 388.0000, 'ºC'),
	(121916, 108, '2015-04-01 00:51:12.000000', 'temperatura', 130.0000, 'ºC'),
	(121917, 108, '2015-04-01 00:51:13.000000', 'temperatura', 687.0000, 'ºC'),
	(121918, 108, '2015-04-01 00:51:14.000000', 'temperatura', 645.0000, 'ºC'),
	(121919, 108, '2015-04-01 00:51:15.000000', 'temperatura', 1166.0000, 'ºC'),
	(121920, 108, '2015-04-01 00:51:16.000000', 'temperatura', 292.0000, 'ºC'),
	(121921, 108, '2015-04-01 00:51:17.000000', 'temperatura', 365.0000, 'ºC'),
	(121922, 108, '2015-04-01 00:51:18.000000', 'temperatura', 949.0000, 'ºC'),
	(121923, 108, '2015-04-01 00:51:19.000000', 'temperatura', 52.0000, 'ºC'),
	(121924, 108, '2015-04-01 00:51:20.000000', 'temperatura', 1013.0000, 'ºC'),
	(121925, 108, '2015-04-01 00:51:21.000000', 'temperatura', 110.0000, 'ºC'),
	(121926, 108, '2015-04-01 00:51:22.000000', 'temperatura', 1113.0000, 'ºC'),
	(121927, 108, '2015-04-01 00:51:23.000000', 'temperatura', 433.0000, 'ºC'),
	(121928, 108, '2015-04-01 00:51:24.000000', 'temperatura', 28.0000, 'ºC'),
	(121929, 108, '2015-04-01 00:51:25.000000', 'temperatura', 41.0000, 'ºC'),
	(121930, 108, '2015-04-01 00:51:26.000000', 'temperatura', 123.0000, 'ºC'),
	(121931, 108, '2015-04-01 00:51:27.000000', 'temperatura', 493.0000, 'ºC'),
	(121932, 108, '2015-04-01 00:51:28.000000', 'temperatura', 897.0000, 'ºC'),
	(121933, 108, '2015-04-01 00:51:29.000000', 'temperatura', 606.0000, 'ºC'),
	(121934, 108, '2015-04-01 00:51:30.000000', 'temperatura', 338.0000, 'ºC'),
	(121935, 108, '2015-04-01 00:51:31.000000', 'temperatura', 1071.0000, 'ºC'),
	(121936, 108, '2015-04-01 00:51:32.000000', 'temperatura', 744.0000, 'ºC'),
	(121937, 108, '2015-04-01 00:51:33.000000', 'temperatura', 506.0000, 'ºC'),
	(121938, 108, '2015-04-01 00:51:34.000000', 'temperatura', 297.0000, 'ºC'),
	(121939, 108, '2015-04-01 00:51:35.000000', 'temperatura', 1170.0000, 'ºC'),
	(121940, 108, '2015-04-01 00:51:36.000000', 'temperatura', 160.0000, 'ºC'),
	(121941, 108, '2015-04-01 00:51:37.000000', 'temperatura', 888.0000, 'ºC'),
	(121942, 108, '2015-04-01 00:51:38.000000', 'temperatura', 363.0000, 'ºC'),
	(121943, 108, '2015-04-01 00:51:39.000000', 'temperatura', 351.0000, 'ºC'),
	(121944, 108, '2015-04-01 00:51:40.000000', 'temperatura', 667.0000, 'ºC'),
	(121945, 108, '2015-04-01 00:51:41.000000', 'temperatura', 1083.0000, 'ºC'),
	(121946, 108, '2015-04-01 00:51:42.000000', 'temperatura', 1016.0000, 'ºC'),
	(121947, 108, '2015-04-01 00:51:43.000000', 'temperatura', 629.0000, 'ºC'),
	(121948, 108, '2015-04-01 00:51:44.000000', 'temperatura', 99.0000, 'ºC'),
	(121949, 108, '2015-04-01 00:51:45.000000', 'temperatura', 1006.0000, 'ºC'),
	(121950, 108, '2015-04-01 00:51:46.000000', 'temperatura', 1136.0000, 'ºC'),
	(121951, 108, '2015-04-01 00:51:47.000000', 'temperatura', 261.0000, 'ºC'),
	(121952, 108, '2015-04-01 00:51:48.000000', 'temperatura', 297.0000, 'ºC'),
	(121953, 108, '2015-04-01 00:51:49.000000', 'temperatura', 703.0000, 'ºC'),
	(121954, 108, '2015-04-01 00:51:50.000000', 'temperatura', 225.0000, 'ºC'),
	(121955, 108, '2015-04-01 00:51:51.000000', 'temperatura', 215.0000, 'ºC'),
	(121956, 108, '2015-04-01 00:51:52.000000', 'temperatura', 400.0000, 'ºC'),
	(121957, 108, '2015-04-01 00:51:53.000000', 'temperatura', 155.0000, 'ºC'),
	(121958, 108, '2015-04-01 00:51:54.000000', 'temperatura', 775.0000, 'ºC'),
	(121959, 108, '2015-04-01 00:51:55.000000', 'temperatura', 1014.0000, 'ºC'),
	(121960, 108, '2015-04-01 00:51:56.000000', 'temperatura', 342.0000, 'ºC'),
	(121961, 108, '2015-04-01 00:51:57.000000', 'temperatura', 1071.0000, 'ºC'),
	(121962, 108, '2015-04-01 00:51:58.000000', 'temperatura', 729.0000, 'ºC'),
	(121963, 108, '2015-04-01 00:51:59.000000', 'temperatura', 432.0000, 'ºC'),
	(121964, 108, '2015-04-01 00:52:00.000000', 'temperatura', 1173.0000, 'ºC'),
	(121965, 108, '2015-04-01 00:52:01.000000', 'temperatura', 969.0000, 'ºC'),
	(121966, 108, '2015-04-01 00:52:02.000000', 'temperatura', 128.0000, 'ºC'),
	(121967, 108, '2015-04-01 00:52:03.000000', 'temperatura', 133.0000, 'ºC'),
	(121968, 108, '2015-04-01 00:52:04.000000', 'temperatura', 283.0000, 'ºC'),
	(121969, 108, '2015-04-01 00:52:05.000000', 'temperatura', 1017.0000, 'ºC'),
	(121970, 108, '2015-04-01 00:52:06.000000', 'temperatura', 635.0000, 'ºC'),
	(121971, 108, '2015-04-01 00:52:07.000000', 'temperatura', 123.0000, 'ºC'),
	(121972, 108, '2015-04-01 00:52:08.000000', 'temperatura', 1112.0000, 'ºC'),
	(121973, 108, '2015-04-01 00:52:09.000000', 'temperatura', 393.0000, 'ºC'),
	(121974, 108, '2015-04-01 00:52:10.000000', 'temperatura', 1030.0000, 'ºC'),
	(121975, 108, '2015-04-01 00:52:11.000000', 'temperatura', 371.0000, 'ºC'),
	(121976, 108, '2015-04-01 00:52:12.000000', 'temperatura', 1163.0000, 'ºC'),
	(121977, 108, '2015-04-01 00:52:13.000000', 'temperatura', 1106.0000, 'ºC'),
	(121978, 108, '2015-04-01 00:52:14.000000', 'temperatura', 840.0000, 'ºC'),
	(121979, 108, '2015-04-01 00:52:15.000000', 'temperatura', 882.0000, 'ºC'),
	(121980, 108, '2015-04-01 00:52:16.000000', 'temperatura', 692.0000, 'ºC'),
	(121981, 108, '2015-04-01 00:52:17.000000', 'temperatura', 815.0000, 'ºC'),
	(121982, 108, '2015-04-01 00:52:18.000000', 'temperatura', 796.0000, 'ºC'),
	(121983, 108, '2015-04-01 00:52:19.000000', 'temperatura', 339.0000, 'ºC'),
	(121984, 108, '2015-04-01 00:52:20.000000', 'temperatura', 508.0000, 'ºC'),
	(121985, 108, '2015-04-01 00:52:21.000000', 'temperatura', 321.0000, 'ºC'),
	(121986, 108, '2015-04-01 00:52:22.000000', 'temperatura', 80.0000, 'ºC'),
	(121987, 108, '2015-04-01 00:52:23.000000', 'temperatura', 641.0000, 'ºC'),
	(121988, 108, '2015-04-01 00:52:24.000000', 'temperatura', 563.0000, 'ºC'),
	(121989, 108, '2015-04-01 00:52:25.000000', 'temperatura', 894.0000, 'ºC'),
	(121990, 108, '2015-04-01 00:52:26.000000', 'temperatura', 383.0000, 'ºC'),
	(121991, 108, '2015-04-01 00:52:27.000000', 'temperatura', 433.0000, 'ºC'),
	(121992, 108, '2015-04-01 00:52:28.000000', 'temperatura', 1016.0000, 'ºC'),
	(121993, 108, '2015-04-01 00:52:29.000000', 'temperatura', 181.0000, 'ºC'),
	(121994, 108, '2015-04-01 00:52:30.000000', 'temperatura', 257.0000, 'ºC'),
	(121995, 108, '2015-04-01 00:52:31.000000', 'temperatura', 743.0000, 'ºC'),
	(121996, 108, '2015-04-01 00:52:32.000000', 'temperatura', 546.0000, 'ºC'),
	(121997, 108, '2015-04-01 00:52:33.000000', 'temperatura', 499.0000, 'ºC'),
	(121998, 108, '2015-04-01 00:52:34.000000', 'temperatura', 859.0000, 'ºC'),
	(121999, 108, '2015-04-01 00:52:35.000000', 'temperatura', 399.0000, 'ºC'),
	(122000, 108, '2015-04-01 00:52:36.000000', 'temperatura', 620.0000, 'ºC'),
	(122001, 108, '2015-04-01 00:52:37.000000', 'temperatura', 702.0000, 'ºC'),
	(122002, 108, '2015-04-01 00:52:38.000000', 'temperatura', 451.0000, 'ºC'),
	(122003, 108, '2015-04-01 00:52:39.000000', 'temperatura', 149.0000, 'ºC'),
	(122004, 108, '2015-04-01 00:52:40.000000', 'temperatura', 593.0000, 'ºC'),
	(122005, 108, '2015-04-01 00:52:41.000000', 'temperatura', 118.0000, 'ºC'),
	(122006, 108, '2015-04-01 00:52:42.000000', 'temperatura', 14.0000, 'ºC'),
	(122007, 108, '2015-04-01 00:52:43.000000', 'temperatura', 913.0000, 'ºC'),
	(122008, 108, '2015-04-01 00:52:44.000000', 'temperatura', 927.0000, 'ºC'),
	(122009, 108, '2015-04-01 00:52:45.000000', 'temperatura', 695.0000, 'ºC'),
	(122010, 108, '2015-04-01 00:52:46.000000', 'temperatura', 693.0000, 'ºC'),
	(122011, 108, '2015-04-01 00:52:47.000000', 'temperatura', 180.0000, 'ºC'),
	(122012, 108, '2015-04-01 00:52:48.000000', 'temperatura', 20.0000, 'ºC'),
	(122013, 108, '2015-04-01 00:52:49.000000', 'temperatura', 764.0000, 'ºC'),
	(122014, 108, '2015-04-01 00:52:50.000000', 'temperatura', 160.0000, 'ºC'),
	(122015, 108, '2015-04-01 00:52:51.000000', 'temperatura', 909.0000, 'ºC'),
	(122016, 108, '2015-04-01 00:52:52.000000', 'temperatura', 465.0000, 'ºC'),
	(122017, 108, '2015-04-01 00:52:53.000000', 'temperatura', 798.0000, 'ºC'),
	(122018, 108, '2015-04-01 00:52:54.000000', 'temperatura', 198.0000, 'ºC'),
	(122019, 108, '2015-04-01 00:52:55.000000', 'temperatura', 994.0000, 'ºC'),
	(122020, 108, '2015-04-01 00:52:56.000000', 'temperatura', 778.0000, 'ºC'),
	(122021, 108, '2015-04-01 00:52:57.000000', 'temperatura', 909.0000, 'ºC'),
	(122022, 108, '2015-04-01 00:52:58.000000', 'temperatura', 1011.0000, 'ºC'),
	(122023, 108, '2015-04-01 00:52:59.000000', 'temperatura', 1130.0000, 'ºC'),
	(122024, 108, '2015-04-01 00:53:00.000000', 'temperatura', 218.0000, 'ºC'),
	(122025, 108, '2015-04-01 00:53:01.000000', 'temperatura', 99.0000, 'ºC'),
	(122026, 108, '2015-04-01 00:53:02.000000', 'temperatura', 1042.0000, 'ºC'),
	(122027, 108, '2015-04-01 00:53:03.000000', 'temperatura', 112.0000, 'ºC'),
	(122028, 108, '2015-04-01 00:53:04.000000', 'temperatura', 1034.0000, 'ºC'),
	(122029, 108, '2015-04-01 00:53:05.000000', 'temperatura', 36.0000, 'ºC'),
	(122030, 108, '2015-04-01 00:53:06.000000', 'temperatura', 678.0000, 'ºC'),
	(122031, 108, '2015-04-01 00:53:07.000000', 'temperatura', 884.0000, 'ºC'),
	(122032, 108, '2015-04-01 00:53:08.000000', 'temperatura', 1187.0000, 'ºC'),
	(122033, 108, '2015-04-01 00:53:09.000000', 'temperatura', 884.0000, 'ºC'),
	(122034, 108, '2015-04-01 00:53:10.000000', 'temperatura', 858.0000, 'ºC'),
	(122035, 108, '2015-04-01 00:53:11.000000', 'temperatura', 439.0000, 'ºC'),
	(122036, 108, '2015-04-01 00:53:12.000000', 'temperatura', 823.0000, 'ºC'),
	(122037, 108, '2015-04-01 00:53:13.000000', 'temperatura', 396.0000, 'ºC'),
	(122038, 108, '2015-04-01 00:53:14.000000', 'temperatura', 713.0000, 'ºC'),
	(122039, 108, '2015-04-01 00:53:15.000000', 'temperatura', 1179.0000, 'ºC'),
	(122040, 108, '2015-04-01 00:53:16.000000', 'temperatura', 154.0000, 'ºC'),
	(122041, 108, '2015-04-01 00:53:17.000000', 'temperatura', 835.0000, 'ºC'),
	(122042, 108, '2015-04-01 00:53:18.000000', 'temperatura', 112.0000, 'ºC'),
	(122043, 108, '2015-04-01 00:53:19.000000', 'temperatura', 456.0000, 'ºC'),
	(122044, 108, '2015-04-01 00:53:20.000000', 'temperatura', 743.0000, 'ºC'),
	(122045, 108, '2015-04-01 00:53:21.000000', 'temperatura', 1149.0000, 'ºC'),
	(122046, 108, '2015-04-01 00:53:22.000000', 'temperatura', 1115.0000, 'ºC'),
	(122047, 108, '2015-04-01 00:53:23.000000', 'temperatura', 930.0000, 'ºC'),
	(122048, 108, '2015-04-01 00:53:24.000000', 'temperatura', 105.0000, 'ºC'),
	(122049, 108, '2015-04-01 00:53:25.000000', 'temperatura', 134.0000, 'ºC'),
	(122050, 108, '2015-04-01 00:53:26.000000', 'temperatura', 357.0000, 'ºC'),
	(122051, 108, '2015-04-01 00:53:27.000000', 'temperatura', 184.0000, 'ºC'),
	(122052, 108, '2015-04-01 00:53:28.000000', 'temperatura', 1049.0000, 'ºC'),
	(122053, 108, '2015-04-01 00:53:29.000000', 'temperatura', 1095.0000, 'ºC'),
	(122054, 108, '2015-04-01 00:53:30.000000', 'temperatura', 1127.0000, 'ºC'),
	(122055, 108, '2015-04-01 00:53:31.000000', 'temperatura', 1151.0000, 'ºC'),
	(122056, 108, '2015-04-01 00:53:32.000000', 'temperatura', 1175.0000, 'ºC'),
	(122057, 108, '2015-04-01 00:53:33.000000', 'temperatura', 20.0000, 'ºC'),
	(122058, 108, '2015-04-01 00:53:34.000000', 'temperatura', 177.0000, 'ºC'),
	(122059, 108, '2015-04-01 00:53:35.000000', 'temperatura', 827.0000, 'ºC'),
	(122060, 108, '2015-04-01 00:53:36.000000', 'temperatura', 3.0000, 'ºC'),
	(122061, 108, '2015-04-01 00:53:37.000000', 'temperatura', 1135.0000, 'ºC'),
	(122062, 108, '2015-04-01 00:53:38.000000', 'temperatura', 866.0000, 'ºC'),
	(122063, 108, '2015-04-01 00:53:39.000000', 'temperatura', 927.0000, 'ºC'),
	(122064, 108, '2015-04-01 00:53:40.000000', 'temperatura', 839.0000, 'ºC'),
	(122065, 108, '2015-04-01 00:53:41.000000', 'temperatura', 211.0000, 'ºC'),
	(122066, 108, '2015-04-01 00:53:42.000000', 'temperatura', 942.0000, 'ºC'),
	(122067, 108, '2015-04-01 00:53:43.000000', 'temperatura', 475.0000, 'ºC'),
	(122068, 108, '2015-04-01 00:53:44.000000', 'temperatura', 749.0000, 'ºC'),
	(122069, 108, '2015-04-01 00:53:45.000000', 'temperatura', 1123.0000, 'ºC'),
	(122070, 108, '2015-04-01 00:53:46.000000', 'temperatura', 968.0000, 'ºC'),
	(122071, 108, '2015-04-01 00:53:47.000000', 'temperatura', 272.0000, 'ºC'),
	(122072, 108, '2015-04-01 00:53:48.000000', 'temperatura', 854.0000, 'ºC'),
	(122073, 108, '2015-04-01 00:53:49.000000', 'temperatura', 1057.0000, 'ºC'),
	(122074, 108, '2015-04-01 00:53:50.000000', 'temperatura', 323.0000, 'ºC'),
	(122075, 108, '2015-04-01 00:53:51.000000', 'temperatura', 843.0000, 'ºC'),
	(122076, 108, '2015-04-01 00:53:52.000000', 'temperatura', 847.0000, 'ºC'),
	(122077, 108, '2015-04-01 00:53:53.000000', 'temperatura', 509.0000, 'ºC'),
	(122078, 108, '2015-04-01 00:53:54.000000', 'temperatura', 2.0000, 'ºC'),
	(122079, 108, '2015-04-01 00:53:55.000000', 'temperatura', 883.0000, 'ºC'),
	(122080, 108, '2015-04-01 00:53:56.000000', 'temperatura', 809.0000, 'ºC'),
	(122081, 108, '2015-04-01 00:53:57.000000', 'temperatura', 197.0000, 'ºC'),
	(122082, 108, '2015-04-01 00:53:58.000000', 'temperatura', 960.0000, 'ºC'),
	(122083, 108, '2015-04-01 00:53:59.000000', 'temperatura', 607.0000, 'ºC'),
	(122084, 108, '2015-04-01 00:54:00.000000', 'temperatura', 156.0000, 'ºC'),
	(122085, 108, '2015-04-01 00:54:01.000000', 'temperatura', 160.0000, 'ºC'),
	(122086, 108, '2015-04-01 00:54:02.000000', 'temperatura', 334.0000, 'ºC'),
	(122087, 108, '2015-04-01 00:54:03.000000', 'temperatura', 1190.0000, 'ºC'),
	(122088, 108, '2015-04-01 00:54:04.000000', 'temperatura', 150.0000, 'ºC'),
	(122089, 108, '2015-04-01 00:54:05.000000', 'temperatura', 779.0000, 'ºC'),
	(122090, 108, '2015-04-01 00:54:06.000000', 'temperatura', 1046.0000, 'ºC'),
	(122091, 108, '2015-04-01 00:54:07.000000', 'temperatura', 494.0000, 'ºC'),
	(122092, 108, '2015-04-01 00:54:08.000000', 'temperatura', 534.0000, 'ºC'),
	(122093, 108, '2015-04-01 00:54:09.000000', 'temperatura', 1187.0000, 'ºC'),
	(122094, 108, '2015-04-01 00:54:10.000000', 'temperatura', 733.0000, 'ºC'),
	(122095, 108, '2015-04-01 00:54:11.000000', 'temperatura', 103.0000, 'ºC'),
	(122096, 108, '2015-04-01 00:54:12.000000', 'temperatura', 719.0000, 'ºC'),
	(122097, 108, '2015-04-01 00:54:13.000000', 'temperatura', 886.0000, 'ºC'),
	(122098, 108, '2015-04-01 00:54:14.000000', 'temperatura', 1074.0000, 'ºC'),
	(122099, 108, '2015-04-01 00:54:15.000000', 'temperatura', 312.0000, 'ºC'),
	(122100, 108, '2015-04-01 00:54:16.000000', 'temperatura', 740.0000, 'ºC'),
	(122101, 108, '2015-04-01 00:54:17.000000', 'temperatura', 364.0000, 'ºC'),
	(122102, 108, '2015-04-01 00:54:18.000000', 'temperatura', 801.0000, 'ºC'),
	(122103, 108, '2015-04-01 00:54:19.000000', 'temperatura', 513.0000, 'ºC'),
	(122104, 108, '2015-04-01 00:54:20.000000', 'temperatura', 162.0000, 'ºC'),
	(122105, 108, '2015-04-01 00:54:21.000000', 'temperatura', 472.0000, 'ºC'),
	(122106, 108, '2015-04-01 00:54:22.000000', 'temperatura', 673.0000, 'ºC'),
	(122107, 108, '2015-04-01 00:54:23.000000', 'temperatura', 749.0000, 'ºC'),
	(122108, 108, '2015-04-01 00:54:24.000000', 'temperatura', 526.0000, 'ºC'),
	(122109, 108, '2015-04-01 00:54:25.000000', 'temperatura', 383.0000, 'ºC'),
	(122110, 108, '2015-04-01 00:54:26.000000', 'temperatura', 340.0000, 'ºC'),
	(122111, 108, '2015-04-01 00:54:27.000000', 'temperatura', 552.0000, 'ºC'),
	(122112, 108, '2015-04-01 00:54:28.000000', 'temperatura', 541.0000, 'ºC'),
	(122113, 108, '2015-04-01 00:54:29.000000', 'temperatura', 1049.0000, 'ºC'),
	(122114, 108, '2015-04-01 00:54:30.000000', 'temperatura', 20.0000, 'ºC'),
	(122115, 108, '2015-04-01 00:54:31.000000', 'temperatura', 556.0000, 'ºC'),
	(122116, 108, '2015-04-01 00:54:32.000000', 'temperatura', 320.0000, 'ºC'),
	(122117, 108, '2015-04-01 00:54:33.000000', 'temperatura', 1132.0000, 'ºC'),
	(122118, 108, '2015-04-01 00:54:34.000000', 'temperatura', 1099.0000, 'ºC'),
	(122119, 108, '2015-04-01 00:54:35.000000', 'temperatura', 902.0000, 'ºC'),
	(122120, 108, '2015-04-01 00:54:36.000000', 'temperatura', 11.0000, 'ºC'),
	(122121, 108, '2015-04-01 00:54:37.000000', 'temperatura', 951.0000, 'ºC'),
	(122122, 108, '2015-04-01 00:54:38.000000', 'temperatura', 1123.0000, 'ºC'),
	(122123, 108, '2015-04-01 00:54:39.000000', 'temperatura', 364.0000, 'ºC'),
	(122124, 108, '2015-04-01 00:54:40.000000', 'temperatura', 848.0000, 'ºC'),
	(122125, 108, '2015-04-01 00:54:41.000000', 'temperatura', 750.0000, 'ºC'),
	(122126, 108, '2015-04-01 00:54:42.000000', 'temperatura', 5.0000, 'ºC'),
	(122127, 108, '2015-04-01 00:54:43.000000', 'temperatura', 176.0000, 'ºC'),
	(122128, 108, '2015-04-01 00:54:44.000000', 'temperatura', 868.0000, 'ºC'),
	(122129, 108, '2015-04-01 00:54:45.000000', 'temperatura', 210.0000, 'ºC'),
	(122130, 108, '2015-04-01 00:54:46.000000', 'temperatura', 846.0000, 'ºC'),
	(122131, 108, '2015-04-01 00:54:47.000000', 'temperatura', 1.0000, 'ºC'),
	(122132, 108, '2015-04-01 00:54:48.000000', 'temperatura', 1068.0000, 'ºC'),
	(122133, 108, '2015-04-01 00:54:49.000000', 'temperatura', 536.0000, 'ºC'),
	(122134, 108, '2015-04-01 00:54:50.000000', 'temperatura', 678.0000, 'ºC'),
	(122135, 108, '2015-04-01 00:54:51.000000', 'temperatura', 580.0000, 'ºC'),
	(122136, 108, '2015-04-01 00:54:52.000000', 'temperatura', 868.0000, 'ºC'),
	(122137, 108, '2015-04-01 00:54:53.000000', 'temperatura', 200.0000, 'ºC'),
	(122138, 108, '2015-04-01 00:54:54.000000', 'temperatura', 798.0000, 'ºC'),
	(122139, 108, '2015-04-01 00:54:55.000000', 'temperatura', 989.0000, 'ºC'),
	(122140, 108, '2015-04-01 00:54:56.000000', 'temperatura', 154.0000, 'ºC'),
	(122141, 108, '2015-04-01 00:54:57.000000', 'temperatura', 203.0000, 'ºC'),
	(122142, 108, '2015-04-01 00:54:58.000000', 'temperatura', 551.0000, 'ºC'),
	(122143, 108, '2015-04-01 00:54:59.000000', 'temperatura', 949.0000, 'ºC'),
	(122144, 108, '2015-04-01 00:55:00.000000', 'temperatura', 690.0000, 'ºC'),
	(122145, 108, '2015-04-01 00:55:01.000000', 'temperatura', 606.0000, 'ºC'),
	(122146, 108, '2015-04-01 00:55:02.000000', 'temperatura', 959.0000, 'ºC'),
	(122147, 108, '2015-04-01 00:55:03.000000', 'temperatura', 577.0000, 'ºC'),
	(122148, 108, '2015-04-01 00:55:04.000000', 'temperatura', 8.0000, 'ºC'),
	(122149, 108, '2015-04-01 00:55:05.000000', 'temperatura', 710.0000, 'ºC'),
	(122150, 108, '2015-04-01 00:55:06.000000', 'temperatura', 1125.0000, 'ºC'),
	(122151, 108, '2015-04-01 00:55:07.000000', 'temperatura', 1098.0000, 'ºC'),
	(122152, 108, '2015-04-01 00:55:08.000000', 'temperatura', 913.0000, 'ºC'),
	(122153, 108, '2015-04-01 00:55:09.000000', 'temperatura', 73.0000, 'ºC'),
	(122154, 108, '2015-04-01 00:55:10.000000', 'temperatura', 26.0000, 'ºC'),
	(122155, 108, '2015-04-01 00:55:11.000000', 'temperatura', 1113.0000, 'ºC'),
	(122156, 108, '2015-04-01 00:55:12.000000', 'temperatura', 685.0000, 'ºC'),
	(122157, 108, '2015-04-01 00:55:13.000000', 'temperatura', 88.0000, 'ºC'),
	(122158, 108, '2015-04-01 00:55:14.000000', 'temperatura', 785.0000, 'ºC'),
	(122159, 108, '2015-04-01 00:55:15.000000', 'temperatura', 61.0000, 'ºC'),
	(122160, 108, '2015-04-01 00:55:16.000000', 'temperatura', 351.0000, 'ºC'),
	(122161, 108, '2015-04-01 00:55:17.000000', 'temperatura', 374.0000, 'ºC'),
	(122162, 108, '2015-04-01 00:55:18.000000', 'temperatura', 815.0000, 'ºC'),
	(122163, 108, '2015-04-01 00:55:19.000000', 'temperatura', 556.0000, 'ºC'),
	(122164, 108, '2015-04-01 00:55:20.000000', 'temperatura', 336.0000, 'ºC'),
	(122165, 108, '2015-04-01 00:55:21.000000', 'temperatura', 11.0000, 'ºC'),
	(122166, 108, '2015-04-01 00:55:22.000000', 'temperatura', 249.0000, 'ºC'),
	(122167, 108, '2015-04-01 00:55:23.000000', 'temperatura', 10.0000, 'ºC'),
	(122168, 108, '2015-04-01 00:55:24.000000', 'temperatura', 506.0000, 'ºC'),
	(122169, 108, '2015-04-01 00:55:25.000000', 'temperatura', 101.0000, 'ºC'),
	(122170, 108, '2015-04-01 00:55:26.000000', 'temperatura', 185.0000, 'ºC'),
	(122171, 108, '2015-04-01 00:55:27.000000', 'temperatura', 622.0000, 'ºC'),
	(122172, 108, '2015-04-01 00:55:28.000000', 'temperatura', 155.0000, 'ºC'),
	(122173, 108, '2015-04-01 00:55:29.000000', 'temperatura', 109.0000, 'ºC'),
	(122174, 108, '2015-04-01 00:55:30.000000', 'temperatura', 82.0000, 'ºC'),
	(122175, 108, '2015-04-01 00:55:31.000000', 'temperatura', 84.0000, 'ºC'),
	(122176, 108, '2015-04-01 00:55:32.000000', 'temperatura', 174.0000, 'ºC'),
	(122177, 108, '2015-04-01 00:55:33.000000', 'temperatura', 621.0000, 'ºC'),
	(122178, 108, '2015-04-01 00:55:34.000000', 'temperatura', 180.0000, 'ºC'),
	(122179, 108, '2015-04-01 00:55:35.000000', 'temperatura', 239.0000, 'ºC'),
	(122180, 108, '2015-04-01 00:55:36.000000', 'temperatura', 654.0000, 'ºC'),
	(122181, 108, '2015-04-01 00:55:37.000000', 'temperatura', 153.0000, 'ºC'),
	(122182, 108, '2015-04-01 00:55:38.000000', 'temperatura', 4.0000, 'ºC'),
	(122183, 108, '2015-04-01 00:55:39.000000', 'temperatura', 764.0000, 'ºC'),
	(122184, 108, '2015-04-01 00:55:40.000000', 'temperatura', 206.0000, 'ºC'),
	(122185, 108, '2015-04-01 00:55:41.000000', 'temperatura', 1140.0000, 'ºC'),
	(122186, 108, '2015-04-01 00:55:42.000000', 'temperatura', 281.0000, 'ºC'),
	(122187, 108, '2015-04-01 00:55:43.000000', 'temperatura', 387.0000, 'ºC'),
	(122188, 108, '2015-04-01 00:55:44.000000', 'temperatura', 1090.0000, 'ºC'),
	(122189, 108, '2015-04-01 00:55:45.000000', 'temperatura', 691.0000, 'ºC'),
	(122190, 108, '2015-04-01 00:55:46.000000', 'temperatura', 185.0000, 'ºC'),
	(122191, 108, '2015-04-01 00:55:47.000000', 'temperatura', 53.0000, 'ºC'),
	(122192, 108, '2015-04-01 00:55:48.000000', 'temperatura', 911.0000, 'ºC'),
	(122193, 108, '2015-04-01 00:55:49.000000', 'temperatura', 795.0000, 'ºC'),
	(122194, 108, '2015-04-01 00:55:50.000000', 'temperatura', 42.0000, 'ºC'),
	(122195, 108, '2015-04-01 00:55:51.000000', 'temperatura', 228.0000, 'ºC'),
	(122196, 108, '2015-04-01 00:55:52.000000', 'temperatura', 1014.0000, 'ºC'),
	(122197, 108, '2015-04-01 00:55:53.000000', 'temperatura', 785.0000, 'ºC'),
	(122198, 108, '2015-04-01 00:55:54.000000', 'temperatura', 886.0000, 'ºC'),
	(122199, 108, '2015-04-01 00:55:55.000000', 'temperatura', 875.0000, 'ºC'),
	(122200, 108, '2015-04-01 00:55:56.000000', 'temperatura', 517.0000, 'ºC'),
	(122201, 108, '2015-04-01 00:55:57.000000', 'temperatura', 1159.0000, 'ºC'),
	(122202, 108, '2015-04-01 00:55:58.000000', 'temperatura', 644.0000, 'ºC'),
	(122203, 108, '2015-04-01 00:55:59.000000', 'temperatura', 943.0000, 'ºC'),
	(122204, 108, '2015-04-01 00:56:00.000000', 'temperatura', 384.0000, 'ºC'),
	(122205, 108, '2015-04-01 00:56:01.000000', 'temperatura', 294.0000, 'ºC'),
	(122206, 108, '2015-04-01 00:56:02.000000', 'temperatura', 316.0000, 'ºC'),
	(122207, 108, '2015-04-01 00:56:03.000000', 'temperatura', 699.0000, 'ºC'),
	(122208, 108, '2015-04-01 00:56:04.000000', 'temperatura', 148.0000, 'ºC'),
	(122209, 108, '2015-04-01 00:56:05.000000', 'temperatura', 1043.0000, 'ºC'),
	(122210, 108, '2015-04-01 00:56:06.000000', 'temperatura', 1173.0000, 'ºC'),
	(122211, 108, '2015-04-01 00:56:07.000000', 'temperatura', 336.0000, 'ºC'),
	(122212, 108, '2015-04-01 00:56:08.000000', 'temperatura', 562.0000, 'ºC'),
	(122213, 108, '2015-04-01 00:56:09.000000', 'temperatura', 604.0000, 'ºC'),
	(122214, 108, '2015-04-01 00:56:10.000000', 'temperatura', 132.0000, 'ºC'),
	(122215, 108, '2015-04-01 00:56:11.000000', 'temperatura', 49.0000, 'ºC'),
	(122216, 108, '2015-04-01 00:56:12.000000', 'temperatura', 1049.0000, 'ºC'),
	(122217, 108, '2015-04-01 00:56:13.000000', 'temperatura', 298.0000, 'ºC'),
	(122218, 108, '2015-04-01 00:56:14.000000', 'temperatura', 746.0000, 'ºC'),
	(122219, 108, '2015-04-01 00:56:15.000000', 'temperatura', 436.0000, 'ºC'),
	(122220, 108, '2015-04-01 00:56:16.000000', 'temperatura', 1142.0000, 'ºC'),
	(122221, 108, '2015-04-01 00:56:17.000000', 'temperatura', 801.0000, 'ºC'),
	(122222, 108, '2015-04-01 00:56:18.000000', 'temperatura', 581.0000, 'ºC'),
	(122223, 108, '2015-04-01 00:56:19.000000', 'temperatura', 504.0000, 'ºC'),
	(122224, 108, '2015-04-01 00:56:20.000000', 'temperatura', 774.0000, 'ºC'),
	(122225, 108, '2015-04-01 00:56:21.000000', 'temperatura', 1161.0000, 'ºC'),
	(122226, 108, '2015-04-01 00:56:22.000000', 'temperatura', 1084.0000, 'ºC'),
	(122227, 108, '2015-04-01 00:56:23.000000', 'temperatura', 737.0000, 'ºC'),
	(122228, 108, '2015-04-01 00:56:24.000000', 'temperatura', 433.0000, 'ºC'),
	(122229, 108, '2015-04-01 00:56:25.000000', 'temperatura', 1153.0000, 'ºC'),
	(122230, 108, '2015-04-01 00:56:26.000000', 'temperatura', 869.0000, 'ºC'),
	(122231, 108, '2015-04-01 00:56:27.000000', 'temperatura', 886.0000, 'ºC'),
	(122232, 108, '2015-04-01 00:56:28.000000', 'temperatura', 625.0000, 'ºC'),
	(122233, 108, '2015-04-01 00:56:29.000000', 'temperatura', 466.0000, 'ºC'),
	(122234, 108, '2015-04-01 00:56:30.000000', 'temperatura', 456.0000, 'ºC'),
	(122235, 108, '2015-04-01 00:56:31.000000', 'temperatura', 882.0000, 'ºC'),
	(122236, 108, '2015-04-01 00:56:32.000000', 'temperatura', 641.0000, 'ºC'),
	(122237, 108, '2015-04-01 00:56:33.000000', 'temperatura', 560.0000, 'ºC'),
	(122238, 108, '2015-04-01 00:56:34.000000', 'temperatura', 880.0000, 'ºC'),
	(122239, 108, '2015-04-01 00:56:35.000000', 'temperatura', 317.0000, 'ºC'),
	(122240, 108, '2015-04-01 00:56:36.000000', 'temperatura', 147.0000, 'ºC'),
	(122241, 108, '2015-04-01 00:56:37.000000', 'temperatura', 984.0000, 'ºC'),
	(122242, 108, '2015-04-01 00:56:38.000000', 'temperatura', 882.0000, 'ºC'),
	(122243, 108, '2015-04-01 00:56:39.000000', 'temperatura', 257.0000, 'ºC'),
	(122244, 108, '2015-04-01 00:56:40.000000', 'temperatura', 1039.0000, 'ºC'),
	(122245, 108, '2015-04-01 00:56:41.000000', 'temperatura', 825.0000, 'ºC'),
	(122246, 108, '2015-04-01 00:56:42.000000', 'temperatura', 1007.0000, 'ºC'),
	(122247, 108, '2015-04-01 00:56:43.000000', 'temperatura', 163.0000, 'ºC'),
	(122248, 108, '2015-04-01 00:56:44.000000', 'temperatura', 193.0000, 'ºC'),
	(122249, 108, '2015-04-01 00:56:45.000000', 'temperatura', 476.0000, 'ºC'),
	(122250, 108, '2015-04-01 00:56:46.000000', 'temperatura', 604.0000, 'ºC'),
	(122251, 108, '2015-04-01 00:56:47.000000', 'temperatura', 391.0000, 'ºC'),
	(122252, 108, '2015-04-01 00:56:48.000000', 'temperatura', 144.0000, 'ºC'),
	(122253, 108, '2015-04-01 00:56:49.000000', 'temperatura', 748.0000, 'ºC'),
	(122254, 108, '2015-04-01 00:56:50.000000', 'temperatura', 910.0000, 'ºC'),
	(122255, 108, '2015-04-01 00:56:51.000000', 'temperatura', 1105.0000, 'ºC'),
	(122256, 108, '2015-04-01 00:56:52.000000', 'temperatura', 397.0000, 'ºC'),
	(122257, 108, '2015-04-01 00:56:53.000000', 'temperatura', 1070.0000, 'ºC'),
	(122258, 108, '2015-04-01 00:56:54.000000', 'temperatura', 559.0000, 'ºC'),
	(122259, 108, '2015-04-01 00:56:55.000000', 'temperatura', 784.0000, 'ºC'),
	(122260, 108, '2015-04-01 00:56:56.000000', 'temperatura', 1047.0000, 'ºC'),
	(122261, 108, '2015-04-01 00:56:57.000000', 'temperatura', 480.0000, 'ºC'),
	(122262, 108, '2015-04-01 00:56:58.000000', 'temperatura', 461.0000, 'ºC'),
	(122263, 108, '2015-04-01 00:56:59.000000', 'temperatura', 866.0000, 'ºC'),
	(122264, 108, '2015-04-01 00:57:00.000000', 'temperatura', 549.0000, 'ºC'),
	(122265, 108, '2015-04-01 00:57:01.000000', 'temperatura', 147.0000, 'ºC'),
	(122266, 108, '2015-04-01 00:57:02.000000', 'temperatura', 287.0000, 'ºC'),
	(122267, 108, '2015-04-01 00:57:03.000000', 'temperatura', 997.0000, 'ºC'),
	(122268, 108, '2015-04-01 00:57:04.000000', 'temperatura', 522.0000, 'ºC'),
	(122269, 108, '2015-04-01 00:57:05.000000', 'temperatura', 820.0000, 'ºC'),
	(122270, 108, '2015-04-01 00:57:06.000000', 'temperatura', 136.0000, 'ºC'),
	(122271, 108, '2015-04-01 00:57:07.000000', 'temperatura', 618.0000, 'ºC'),
	(122272, 108, '2015-04-01 00:57:08.000000', 'temperatura', 284.0000, 'ºC'),
	(122273, 108, '2015-04-01 00:57:09.000000', 'temperatura', 768.0000, 'ºC'),
	(122274, 108, '2015-04-01 00:57:10.000000', 'temperatura', 587.0000, 'ºC'),
	(122275, 108, '2015-04-01 00:57:11.000000', 'temperatura', 632.0000, 'ºC'),
	(122276, 108, '2015-04-01 00:57:12.000000', 'temperatura', 200.0000, 'ºC'),
	(122277, 108, '2015-04-01 00:57:13.000000', 'temperatura', 305.0000, 'ºC'),
	(122278, 108, '2015-04-01 00:57:14.000000', 'temperatura', 925.0000, 'ºC'),
	(122279, 108, '2015-04-01 00:57:15.000000', 'temperatura', 110.0000, 'ºC'),
	(122280, 108, '2015-04-01 00:57:16.000000', 'temperatura', 176.0000, 'ºC'),
	(122281, 108, '2015-04-01 00:57:17.000000', 'temperatura', 552.0000, 'ºC'),
	(122282, 108, '2015-04-01 00:57:18.000000', 'temperatura', 1031.0000, 'ºC'),
	(122283, 108, '2015-04-01 00:57:19.000000', 'temperatura', 1100.0000, 'ºC'),
	(122284, 108, '2015-04-01 00:57:20.000000', 'temperatura', 7.0000, 'ºC'),
	(122285, 108, '2015-04-01 00:57:21.000000', 'temperatura', 337.0000, 'ºC'),
	(122286, 108, '2015-04-01 00:57:22.000000', 'temperatura', 463.0000, 'ºC'),
	(122287, 108, '2015-04-01 00:57:23.000000', 'temperatura', 106.0000, 'ºC'),
	(122288, 108, '2015-04-01 00:57:24.000000', 'temperatura', 342.0000, 'ºC'),
	(122289, 108, '2015-04-01 00:57:25.000000', 'temperatura', 193.0000, 'ºC'),
	(122290, 108, '2015-04-01 00:57:26.000000', 'temperatura', 1140.0000, 'ºC'),
	(122291, 108, '2015-04-01 00:57:27.000000', 'temperatura', 320.0000, 'ºC'),
	(122292, 108, '2015-04-01 00:57:28.000000', 'temperatura', 579.0000, 'ºC'),
	(122293, 108, '2015-04-01 00:57:29.000000', 'temperatura', 739.0000, 'ºC'),
	(122294, 108, '2015-04-01 00:57:30.000000', 'temperatura', 756.0000, 'ºC'),
	(122295, 108, '2015-04-01 00:57:31.000000', 'temperatura', 364.0000, 'ºC'),
	(122296, 108, '2015-04-01 00:57:32.000000', 'temperatura', 754.0000, 'ºC'),
	(122297, 108, '2015-04-01 00:57:33.000000', 'temperatura', 278.0000, 'ºC'),
	(122298, 108, '2015-04-01 00:57:34.000000', 'temperatura', 328.0000, 'ºC'),
	(122299, 108, '2015-04-01 00:57:35.000000', 'temperatura', 805.0000, 'ºC'),
	(122300, 108, '2015-04-01 00:57:36.000000', 'temperatura', 642.0000, 'ºC'),
	(122301, 108, '2015-04-01 00:57:37.000000', 'temperatura', 798.0000, 'ºC'),
	(122302, 108, '2015-04-01 00:57:38.000000', 'temperatura', 861.0000, 'ºC'),
	(122303, 108, '2015-04-01 00:57:39.000000', 'temperatura', 713.0000, 'ºC'),
	(122304, 108, '2015-04-01 00:57:40.000000', 'temperatura', 983.0000, 'ºC'),
	(122305, 108, '2015-04-01 00:57:41.000000', 'temperatura', 377.0000, 'ºC'),
	(122306, 108, '2015-04-01 00:57:42.000000', 'temperatura', 135.0000, 'ºC'),
	(122307, 108, '2015-04-01 00:57:43.000000', 'temperatura', 743.0000, 'ºC'),
	(122308, 108, '2015-04-01 00:57:44.000000', 'temperatura', 913.0000, 'ºC'),
	(122309, 108, '2015-04-01 00:57:45.000000', 'temperatura', 1135.0000, 'ºC'),
	(122310, 108, '2015-04-01 00:57:46.000000', 'temperatura', 539.0000, 'ºC'),
	(122311, 108, '2015-04-01 00:57:47.000000', 'temperatura', 490.0000, 'ºC'),
	(122312, 108, '2015-04-01 00:57:48.000000', 'temperatura', 832.0000, 'ºC'),
	(122313, 108, '2015-04-01 00:57:49.000000', 'temperatura', 293.0000, 'ºC'),
	(122314, 108, '2015-04-01 00:57:50.000000', 'temperatura', 169.0000, 'ºC'),
	(122315, 108, '2015-04-01 00:57:51.000000', 'temperatura', 1165.0000, 'ºC'),
	(122316, 108, '2015-04-01 00:57:52.000000', 'temperatura', 519.0000, 'ºC'),
	(122317, 108, '2015-04-01 00:57:53.000000', 'temperatura', 299.0000, 'ºC'),
	(122318, 108, '2015-04-01 00:57:54.000000', 'temperatura', 1138.0000, 'ºC'),
	(122319, 108, '2015-04-01 00:57:55.000000', 'temperatura', 1195.0000, 'ºC'),
	(122320, 108, '2015-04-01 00:57:56.000000', 'temperatura', 163.0000, 'ºC'),
	(122321, 108, '2015-04-01 00:57:57.000000', 'temperatura', 829.0000, 'ºC'),
	(122322, 108, '2015-04-01 00:57:58.000000', 'temperatura', 56.0000, 'ºC'),
	(122323, 108, '2015-04-01 00:57:59.000000', 'temperatura', 193.0000, 'ºC'),
	(122324, 108, '2015-04-01 00:58:00.000000', 'temperatura', 797.0000, 'ºC'),
	(122325, 108, '2015-04-01 00:58:01.000000', 'temperatura', 1006.0000, 'ºC'),
	(122326, 108, '2015-04-01 00:58:02.000000', 'temperatura', 238.0000, 'ºC'),
	(122327, 108, '2015-04-01 00:58:03.000000', 'temperatura', 576.0000, 'ºC'),
	(122328, 108, '2015-04-01 00:58:04.000000', 'temperatura', 965.0000, 'ºC'),
	(122329, 108, '2015-04-01 00:58:05.000000', 'temperatura', 699.0000, 'ºC'),
	(122330, 108, '2015-04-01 00:58:06.000000', 'temperatura', 601.0000, 'ºC'),
	(122331, 108, '2015-04-01 00:58:07.000000', 'temperatura', 907.0000, 'ºC'),
	(122332, 108, '2015-04-01 00:58:08.000000', 'temperatura', 333.0000, 'ºC'),
	(122333, 108, '2015-04-01 00:58:09.000000', 'temperatura', 145.0000, 'ºC'),
	(122334, 108, '2015-04-01 00:58:10.000000', 'temperatura', 927.0000, 'ºC'),
	(122335, 108, '2015-04-01 00:58:11.000000', 'temperatura', 601.0000, 'ºC'),
	(122336, 108, '2015-04-01 00:58:12.000000', 'temperatura', 224.0000, 'ºC'),
	(122337, 108, '2015-04-01 00:58:13.000000', 'temperatura', 515.0000, 'ºC'),
	(122338, 108, '2015-04-01 00:58:14.000000', 'temperatura', 707.0000, 'ºC'),
	(122339, 108, '2015-04-01 00:58:15.000000', 'temperatura', 790.0000, 'ºC'),
	(122340, 108, '2015-04-01 00:58:16.000000', 'temperatura', 627.0000, 'ºC'),
	(122341, 108, '2015-04-01 00:58:17.000000', 'temperatura', 767.0000, 'ºC'),
	(122342, 108, '2015-04-01 00:58:18.000000', 'temperatura', 754.0000, 'ºC'),
	(122343, 108, '2015-04-01 00:58:19.000000', 'temperatura', 269.0000, 'ºC'),
	(122344, 108, '2015-04-01 00:58:20.000000', 'temperatura', 283.0000, 'ºC'),
	(122345, 108, '2015-04-01 00:58:21.000000', 'temperatura', 607.0000, 'ºC'),
	(122346, 108, '2015-04-01 00:58:22.000000', 'temperatura', 990.0000, 'ºC'),
	(122347, 108, '2015-04-01 00:58:23.000000', 'temperatura', 727.0000, 'ºC'),
	(122348, 108, '2015-04-01 00:58:24.000000', 'temperatura', 666.0000, 'ºC'),
	(122349, 108, '2015-04-01 00:58:25.000000', 'temperatura', 1150.0000, 'ºC'),
	(122350, 108, '2015-04-01 00:58:26.000000', 'temperatura', 153.0000, 'ºC'),
	(122351, 108, '2015-04-01 00:58:27.000000', 'temperatura', 914.0000, 'ºC'),
	(122352, 108, '2015-04-01 00:58:28.000000', 'temperatura', 511.0000, 'ºC'),
	(122353, 108, '2015-04-01 00:58:29.000000', 'temperatura', 1014.0000, 'ºC'),
	(122354, 108, '2015-04-01 00:58:30.000000', 'temperatura', 1136.0000, 'ºC'),
	(122355, 108, '2015-04-01 00:58:31.000000', 'temperatura', 241.0000, 'ºC'),
	(122356, 108, '2015-04-01 00:58:32.000000', 'temperatura', 195.0000, 'ºC'),
	(122357, 108, '2015-04-01 00:58:33.000000', 'temperatura', 254.0000, 'ºC'),
	(122358, 108, '2015-04-01 00:58:34.000000', 'temperatura', 686.0000, 'ºC'),
	(122359, 108, '2015-04-01 00:58:35.000000', 'temperatura', 267.0000, 'ºC'),
	(122360, 108, '2015-04-01 00:58:36.000000', 'temperatura', 478.0000, 'ºC'),
	(122361, 108, '2015-04-01 00:58:37.000000', 'temperatura', 391.0000, 'ºC'),
	(122362, 108, '2015-04-01 00:58:38.000000', 'temperatura', 519.0000, 'ºC'),
	(122363, 108, '2015-04-01 00:58:39.000000', 'temperatura', 224.0000, 'ºC'),
	(122364, 108, '2015-04-01 00:58:40.000000', 'temperatura', 762.0000, 'ºC'),
	(122365, 108, '2015-04-01 00:58:41.000000', 'temperatura', 741.0000, 'ºC'),
	(122366, 108, '2015-04-01 00:58:42.000000', 'temperatura', 220.0000, 'ºC'),
	(122367, 108, '2015-04-01 00:58:43.000000', 'temperatura', 76.0000, 'ºC'),
	(122368, 108, '2015-04-01 00:58:44.000000', 'temperatura', 922.0000, 'ºC'),
	(122369, 108, '2015-04-01 00:58:45.000000', 'temperatura', 783.0000, 'ºC'),
	(122370, 108, '2015-04-01 00:58:46.000000', 'temperatura', 1149.0000, 'ºC'),
	(122371, 108, '2015-04-01 00:58:47.000000', 'temperatura', 997.0000, 'ºC'),
	(122372, 108, '2015-04-01 00:58:48.000000', 'temperatura', 336.0000, 'ºC'),
	(122373, 108, '2015-04-01 00:58:49.000000', 'temperatura', 1090.0000, 'ºC'),
	(122374, 108, '2015-04-01 00:58:50.000000', 'temperatura', 844.0000, 'ºC'),
	(122375, 108, '2015-04-01 00:58:51.000000', 'temperatura', 951.0000, 'ºC'),
	(122376, 108, '2015-04-01 00:58:52.000000', 'temperatura', 1023.0000, 'ºC'),
	(122377, 108, '2015-04-01 00:58:53.000000', 'temperatura', 1064.0000, 'ºC'),
	(122378, 108, '2015-04-01 00:58:54.000000', 'temperatura', 1049.0000, 'ºC'),
	(122379, 108, '2015-04-01 00:58:55.000000', 'temperatura', 855.0000, 'ºC'),
	(122380, 108, '2015-04-01 00:58:56.000000', 'temperatura', 1130.0000, 'ºC'),
	(122381, 108, '2015-04-01 00:58:57.000000', 'temperatura', 685.0000, 'ºC'),
	(122382, 108, '2015-04-01 00:58:58.000000', 'temperatura', 33.0000, 'ºC'),
	(122383, 108, '2015-04-01 00:58:59.000000', 'temperatura', 512.0000, 'ºC'),
	(122384, 108, '2015-04-01 00:59:00.000000', 'temperatura', 63.0000, 'ºC'),
	(122385, 108, '2015-04-01 00:59:01.000000', 'temperatura', 1178.0000, 'ºC'),
	(122386, 108, '2015-04-01 00:59:02.000000', 'temperatura', 903.0000, 'ºC'),
	(122387, 108, '2015-04-01 00:59:03.000000', 'temperatura', 981.0000, 'ºC'),
	(122388, 108, '2015-04-01 00:59:04.000000', 'temperatura', 997.0000, 'ºC'),
	(122389, 108, '2015-04-01 00:59:05.000000', 'temperatura', 841.0000, 'ºC'),
	(122390, 108, '2015-04-01 00:59:06.000000', 'temperatura', 17.0000, 'ºC'),
	(122391, 108, '2015-04-01 00:59:07.000000', 'temperatura', 1161.0000, 'ºC'),
	(122392, 108, '2015-04-01 00:59:08.000000', 'temperatura', 953.0000, 'ºC'),
	(122393, 108, '2015-04-01 00:59:09.000000', 'temperatura', 84.0000, 'ºC'),
	(122394, 108, '2015-04-01 00:59:10.000000', 'temperatura', 1160.0000, 'ºC'),
	(122395, 108, '2015-04-01 00:59:11.000000', 'temperatura', 749.0000, 'ºC'),
	(122396, 108, '2015-04-01 00:59:12.000000', 'temperatura', 264.0000, 'ºC'),
	(122397, 108, '2015-04-01 00:59:13.000000', 'temperatura', 275.0000, 'ºC'),
	(122398, 108, '2015-04-01 00:59:14.000000', 'temperatura', 581.0000, 'ºC'),
	(122399, 108, '2015-04-01 00:59:15.000000', 'temperatura', 884.0000, 'ºC'),
	(122400, 108, '2015-04-01 00:59:16.000000', 'temperatura', 276.0000, 'ºC'),
	(122401, 108, '2015-04-01 00:59:17.000000', 'temperatura', 1130.0000, 'ºC'),
	(122402, 108, '2015-04-01 00:59:18.000000', 'temperatura', 23.0000, 'ºC'),
	(122403, 108, '2015-04-01 00:59:19.000000', 'temperatura', 324.0000, 'ºC'),
	(122404, 108, '2015-04-01 00:59:20.000000', 'temperatura', 354.0000, 'ºC'),
	(122405, 108, '2015-04-01 00:59:21.000000', 'temperatura', 797.0000, 'ºC'),
	(122406, 108, '2015-04-01 00:59:22.000000', 'temperatura', 523.0000, 'ºC'),
	(122407, 108, '2015-04-01 00:59:23.000000', 'temperatura', 224.0000, 'ºC'),
	(122408, 108, '2015-04-01 00:59:24.000000', 'temperatura', 750.0000, 'ºC'),
	(122409, 108, '2015-04-01 00:59:25.000000', 'temperatura', 680.0000, 'ºC'),
	(122410, 108, '2015-04-01 00:59:26.000000', 'temperatura', 1152.0000, 'ºC'),
	(122411, 108, '2015-04-01 00:59:27.000000', 'temperatura', 121.0000, 'ºC'),
	(122412, 108, '2015-04-01 00:59:28.000000', 'temperatura', 748.0000, 'ºC'),
	(122413, 108, '2015-04-01 00:59:29.000000', 'temperatura', 980.0000, 'ºC'),
	(122414, 108, '2015-04-01 00:59:30.000000', 'temperatura', 254.0000, 'ºC'),
	(122415, 108, '2015-04-01 00:59:31.000000', 'temperatura', 733.0000, 'ºC'),
	(122416, 108, '2015-04-01 00:59:32.000000', 'temperatura', 502.0000, 'ºC'),
	(122417, 108, '2015-04-01 00:59:33.000000', 'temperatura', 314.0000, 'ºC'),
	(122418, 108, '2015-04-01 00:59:34.000000', 'temperatura', 62.0000, 'ºC'),
	(122419, 108, '2015-04-01 00:59:35.000000', 'temperatura', 567.0000, 'ºC'),
	(122420, 108, '2015-04-01 00:59:36.000000', 'temperatura', 252.0000, 'ºC'),
	(122421, 108, '2015-04-01 00:59:37.000000', 'temperatura', 758.0000, 'ºC'),
	(122422, 108, '2015-04-01 00:59:38.000000', 'temperatura', 637.0000, 'ºC'),
	(122423, 108, '2015-04-01 00:59:39.000000', 'temperatura', 911.0000, 'ºC'),
	(122424, 108, '2015-04-01 00:59:40.000000', 'temperatura', 243.0000, 'ºC'),
	(122425, 108, '2015-04-01 00:59:41.000000', 'temperatura', 882.0000, 'ºC'),
	(122426, 108, '2015-04-01 00:59:42.000000', 'temperatura', 81.0000, 'ºC'),
	(122427, 108, '2015-04-01 00:59:43.000000', 'temperatura', 161.0000, 'ºC'),
	(122428, 108, '2015-04-01 00:59:44.000000', 'temperatura', 562.0000, 'ºC'),
	(122429, 108, '2015-04-01 00:59:45.000000', 'temperatura', 1128.0000, 'ºC'),
	(122430, 108, '2015-04-01 00:59:46.000000', 'temperatura', 356.0000, 'ºC'),
	(122431, 108, '2015-04-01 00:59:47.000000', 'temperatura', 793.0000, 'ºC'),
	(122432, 108, '2015-04-01 00:59:48.000000', 'temperatura', 499.0000, 'ºC'),
	(122433, 108, '2015-04-01 00:59:49.000000', 'temperatura', 119.0000, 'ºC'),
	(122434, 108, '2015-04-01 00:59:50.000000', 'temperatura', 295.0000, 'ºC'),
	(122435, 108, '2015-04-01 00:59:51.000000', 'temperatura', 1120.0000, 'ºC'),
	(122436, 108, '2015-04-01 00:59:52.000000', 'temperatura', 1114.0000, 'ºC'),
	(122437, 108, '2015-04-01 00:59:53.000000', 'temperatura', 1012.0000, 'ºC'),
	(122438, 108, '2015-04-01 00:59:54.000000', 'temperatura', 516.0000, 'ºC'),
	(122439, 108, '2015-04-01 00:59:55.000000', 'temperatura', 747.0000, 'ºC'),
	(122440, 108, '2015-04-01 00:59:56.000000', 'temperatura', 985.0000, 'ºC'),
	(122441, 108, '2015-04-01 00:59:57.000000', 'temperatura', 285.0000, 'ºC'),
	(122442, 108, '2015-04-01 00:59:58.000000', 'temperatura', 870.0000, 'ºC'),
	(122443, 108, '2015-04-01 00:59:59.000000', 'temperatura', 1098.0000, 'ºC'),
	(122444, 108, '2015-04-01 01:00:00.000000', 'temperatura', 481.0000, 'ºC'),
	(122445, 108, '2015-04-01 01:00:01.000000', 'temperatura', 308.0000, 'ºC'),
	(122446, 108, '2015-04-01 01:00:02.000000', 'temperatura', 100.0000, 'ºC'),
	(122447, 108, '2015-04-01 01:00:03.000000', 'temperatura', 775.0000, 'ºC'),
	(122448, 108, '2015-04-01 01:00:04.000000', 'temperatura', 1178.0000, 'ºC'),
	(122449, 108, '2015-04-01 01:00:05.000000', 'temperatura', 1165.0000, 'ºC'),
	(122450, 108, '2015-04-01 01:00:06.000000', 'temperatura', 1089.0000, 'ºC'),
	(122451, 108, '2015-04-01 01:00:07.000000', 'temperatura', 752.0000, 'ºC'),
	(122452, 108, '2015-04-01 01:00:08.000000', 'temperatura', 494.0000, 'ºC'),
	(122453, 108, '2015-04-01 01:00:09.000000', 'temperatura', 213.0000, 'ºC'),
	(122454, 108, '2015-04-01 01:00:10.000000', 'temperatura', 783.0000, 'ºC'),
	(122455, 108, '2015-04-01 01:00:11.000000', 'temperatura', 876.0000, 'ºC'),
	(122456, 108, '2015-04-01 01:00:12.000000', 'temperatura', 832.0000, 'ºC'),
	(122457, 108, '2015-04-01 01:00:13.000000', 'temperatura', 335.0000, 'ºC'),
	(122458, 108, '2015-04-01 01:00:14.000000', 'temperatura', 378.0000, 'ºC'),
	(122459, 108, '2015-04-01 01:00:15.000000', 'temperatura', 884.0000, 'ºC'),
	(122460, 108, '2015-04-01 01:00:16.000000', 'temperatura', 887.0000, 'ºC'),
	(122461, 108, '2015-04-01 01:00:17.000000', 'temperatura', 585.0000, 'ºC'),
	(122462, 108, '2015-04-01 01:00:18.000000', 'temperatura', 265.0000, 'ºC'),
	(122463, 108, '2015-04-01 01:00:19.000000', 'temperatura', 771.0000, 'ºC'),
	(122464, 108, '2015-04-01 01:00:20.000000', 'temperatura', 659.0000, 'ºC'),
	(122465, 108, '2015-04-01 01:00:21.000000', 'temperatura', 985.0000, 'ºC'),
	(122466, 108, '2015-04-01 01:00:22.000000', 'temperatura', 546.0000, 'ºC'),
	(122467, 108, '2015-04-01 01:00:23.000000', 'temperatura', 978.0000, 'ºC'),
	(122468, 108, '2015-04-01 01:00:24.000000', 'temperatura', 850.0000, 'ºC'),
	(122469, 108, '2015-04-01 01:00:25.000000', 'temperatura', 119.0000, 'ºC'),
	(122470, 108, '2015-04-01 01:00:26.000000', 'temperatura', 443.0000, 'ºC'),
	(122471, 108, '2015-04-01 01:00:27.000000', 'temperatura', 658.0000, 'ºC'),
	(122472, 108, '2015-04-01 01:00:28.000000', 'temperatura', 762.0000, 'ºC'),
	(122473, 108, '2015-04-01 01:00:29.000000', 'temperatura', 636.0000, 'ºC'),
	(122474, 108, '2015-04-01 01:00:30.000000', 'temperatura', 894.0000, 'ºC'),
	(122475, 108, '2015-04-01 01:00:31.000000', 'temperatura', 164.0000, 'ºC'),
	(122476, 108, '2015-04-01 01:00:32.000000', 'temperatura', 539.0000, 'ºC'),
	(122477, 108, '2015-04-01 01:00:33.000000', 'temperatura', 1004.0000, 'ºC'),
	(122478, 108, '2015-04-01 01:00:34.000000', 'temperatura', 1003.0000, 'ºC'),
	(122479, 108, '2015-04-01 01:00:35.000000', 'temperatura', 802.0000, 'ºC'),
	(122480, 108, '2015-04-01 01:00:36.000000', 'temperatura', 1002.0000, 'ºC'),
	(122481, 108, '2015-04-01 01:00:37.000000', 'temperatura', 206.0000, 'ºC'),
	(122482, 108, '2015-04-01 01:00:38.000000', 'temperatura', 424.0000, 'ºC'),
	(122483, 108, '2015-04-01 01:00:39.000000', 'temperatura', 304.0000, 'ºC'),
	(122484, 108, '2015-04-01 01:00:40.000000', 'temperatura', 248.0000, 'ºC'),
	(122485, 108, '2015-04-01 01:00:41.000000', 'temperatura', 329.0000, 'ºC'),
	(122486, 108, '2015-04-01 01:00:42.000000', 'temperatura', 902.0000, 'ºC'),
	(122487, 108, '2015-04-01 01:00:43.000000', 'temperatura', 1121.0000, 'ºC'),
	(122488, 108, '2015-04-01 01:00:44.000000', 'temperatura', 502.0000, 'ºC'),
	(122489, 108, '2015-04-01 01:00:45.000000', 'temperatura', 347.0000, 'ºC'),
	(122490, 108, '2015-04-01 01:00:46.000000', 'temperatura', 228.0000, 'ºC'),
	(122491, 108, '2015-04-01 01:00:47.000000', 'temperatura', 99.0000, 'ºC'),
	(122492, 108, '2015-04-01 01:00:48.000000', 'temperatura', 1011.0000, 'ºC'),
	(122493, 108, '2015-04-01 01:00:49.000000', 'temperatura', 1158.0000, 'ºC'),
	(122494, 108, '2015-04-01 01:00:50.000000', 'temperatura', 360.0000, 'ºC'),
	(122495, 108, '2015-04-01 01:00:51.000000', 'temperatura', 726.0000, 'ºC'),
	(122496, 108, '2015-04-01 01:00:52.000000', 'temperatura', 150.0000, 'ºC'),
	(122497, 108, '2015-04-01 01:00:53.000000', 'temperatura', 975.0000, 'ºC'),
	(122498, 108, '2015-04-01 01:00:54.000000', 'temperatura', 822.0000, 'ºC'),
	(122499, 108, '2015-04-01 01:00:55.000000', 'temperatura', 1189.0000, 'ºC'),
	(122500, 108, '2015-04-01 01:00:56.000000', 'temperatura', 1076.0000, 'ºC'),
	(122501, 108, '2015-04-01 01:00:57.000000', 'temperatura', 616.0000, 'ºC'),
	(122502, 108, '2015-04-01 01:00:58.000000', 'temperatura', 1053.0000, 'ºC'),
	(122503, 108, '2015-04-01 01:00:59.000000', 'temperatura', 1017.0000, 'ºC'),
	(122504, 108, '2015-04-01 01:01:00.000000', 'temperatura', 727.0000, 'ºC'),
	(122505, 108, '2015-04-01 01:01:01.000000', 'temperatura', 584.0000, 'ºC'),
	(122506, 108, '2015-04-01 01:01:02.000000', 'temperatura', 741.0000, 'ºC'),
	(122507, 108, '2015-04-01 01:01:03.000000', 'temperatura', 753.0000, 'ºC'),
	(122508, 108, '2015-04-01 01:01:04.000000', 'temperatura', 343.0000, 'ºC'),
	(122509, 108, '2015-04-01 01:01:05.000000', 'temperatura', 657.0000, 'ºC'),
	(122510, 108, '2015-04-01 01:01:06.000000', 'temperatura', 1055.0000, 'ºC'),
	(122511, 108, '2015-04-01 01:01:07.000000', 'temperatura', 906.0000, 'ºC'),
	(122512, 108, '2015-04-01 01:01:08.000000', 'temperatura', 165.0000, 'ºC'),
	(122513, 108, '2015-04-01 01:01:09.000000', 'temperatura', 508.0000, 'ºC'),
	(122514, 108, '2015-04-01 01:01:10.000000', 'temperatura', 845.0000, 'ºC'),
	(122515, 108, '2015-04-01 01:01:11.000000', 'temperatura', 300.0000, 'ºC'),
	(122516, 108, '2015-04-01 01:01:12.000000', 'temperatura', 165.0000, 'ºC'),
	(122517, 108, '2015-04-01 01:01:13.000000', 'temperatura', 1127.0000, 'ºC'),
	(122518, 108, '2015-04-01 01:01:14.000000', 'temperatura', 339.0000, 'ºC'),
	(122519, 108, '2015-04-01 01:01:15.000000', 'temperatura', 715.0000, 'ºC'),
	(122520, 108, '2015-04-01 01:01:16.000000', 'temperatura', 159.0000, 'ºC'),
	(122521, 108, '2015-04-01 01:01:17.000000', 'temperatura', 1050.0000, 'ºC'),
	(122522, 108, '2015-04-01 01:01:18.000000', 'temperatura', 1174.0000, 'ºC'),
	(122523, 108, '2015-04-01 01:01:19.000000', 'temperatura', 321.0000, 'ºC'),
	(122524, 108, '2015-04-01 01:01:20.000000', 'temperatura', 483.0000, 'ºC'),
	(122525, 108, '2015-04-01 01:01:21.000000', 'temperatura', 255.0000, 'ºC'),
	(122526, 108, '2015-04-01 01:01:22.000000', 'temperatura', 1023.0000, 'ºC'),
	(122527, 108, '2015-04-01 01:01:23.000000', 'temperatura', 750.0000, 'ºC'),
	(122528, 108, '2015-04-01 01:01:24.000000', 'temperatura', 683.0000, 'ºC'),
	(122529, 108, '2015-04-01 01:01:25.000000', 'temperatura', 1167.0000, 'ºC'),
	(122530, 108, '2015-04-01 01:01:26.000000', 'temperatura', 186.0000, 'ºC'),
	(122531, 108, '2015-04-01 01:01:27.000000', 'temperatura', 1028.0000, 'ºC'),
	(122532, 108, '2015-04-01 01:01:28.000000', 'temperatura', 981.0000, 'ºC'),
	(122533, 108, '2015-04-01 01:01:29.000000', 'temperatura', 624.0000, 'ºC'),
	(122534, 108, '2015-04-01 01:01:30.000000', 'temperatura', 176.0000, 'ºC'),
	(122535, 108, '2015-04-01 01:01:31.000000', 'temperatura', 211.0000, 'ºC'),
	(122536, 108, '2015-04-01 01:01:32.000000', 'temperatura', 526.0000, 'ºC'),
	(122537, 108, '2015-04-01 01:01:33.000000', 'temperatura', 798.0000, 'ºC'),
	(122538, 108, '2015-04-01 01:01:34.000000', 'temperatura', 13.0000, 'ºC'),
	(122539, 108, '2015-04-01 01:01:35.000000', 'temperatura', 69.0000, 'ºC'),
	(122540, 108, '2015-04-01 01:01:36.000000', 'temperatura', 309.0000, 'ºC'),
	(122541, 108, '2015-04-01 01:01:37.000000', 'temperatura', 139.0000, 'ºC'),
	(122542, 108, '2015-04-01 01:01:38.000000', 'temperatura', 967.0000, 'ºC'),
	(122543, 108, '2015-04-01 01:01:39.000000', 'temperatura', 818.0000, 'ºC'),
	(122544, 108, '2015-04-01 01:01:40.000000', 'temperatura', 1189.0000, 'ºC'),
	(122545, 108, '2015-04-01 01:01:41.000000', 'temperatura', 1092.0000, 'ºC'),
	(122546, 108, '2015-04-01 01:01:42.000000', 'temperatura', 694.0000, 'ºC'),
	(122547, 108, '2015-04-01 01:01:43.000000', 'temperatura', 193.0000, 'ºC'),
	(122548, 108, '2015-04-01 01:01:44.000000', 'temperatura', 85.0000, 'ºC'),
	(122549, 108, '2015-04-01 01:01:45.000000', 'temperatura', 1045.0000, 'ºC'),
	(122550, 108, '2015-04-01 01:01:46.000000', 'temperatura', 169.0000, 'ºC'),
	(122551, 108, '2015-04-01 01:01:47.000000', 'temperatura', 113.0000, 'ºC'),
	(122552, 108, '2015-04-01 01:01:48.000000', 'temperatura', 56.0000, 'ºC'),
	(122553, 108, '2015-04-01 01:01:49.000000', 'temperatura', 1144.0000, 'ºC'),
	(122554, 108, '2015-04-01 01:01:50.000000', 'temperatura', 753.0000, 'ºC'),
	(122555, 108, '2015-04-01 01:01:51.000000', 'temperatura', 332.0000, 'ºC'),
	(122556, 108, '2015-04-01 01:01:52.000000', 'temperatura', 601.0000, 'ºC'),
	(122557, 108, '2015-04-01 01:01:53.000000', 'temperatura', 810.0000, 'ºC'),
	(122558, 108, '2015-04-01 01:01:54.000000', 'temperatura', 1046.0000, 'ºC'),
	(122559, 108, '2015-04-01 01:01:55.000000', 'temperatura', 401.0000, 'ºC'),
	(122560, 108, '2015-04-01 01:01:56.000000', 'temperatura', 66.0000, 'ºC'),
	(122561, 108, '2015-04-01 01:01:57.000000', 'temperatura', 329.0000, 'ºC'),
	(122562, 108, '2015-04-01 01:01:58.000000', 'temperatura', 246.0000, 'ºC'),
	(122563, 108, '2015-04-01 01:01:59.000000', 'temperatura', 244.0000, 'ºC'),
	(122564, 108, '2015-04-01 01:02:00.000000', 'temperatura', 485.0000, 'ºC'),
	(122565, 108, '2015-04-01 01:02:01.000000', 'temperatura', 491.0000, 'ºC'),
	(122566, 108, '2015-04-01 01:02:02.000000', 'temperatura', 1000.0000, 'ºC'),
	(122567, 108, '2015-04-01 01:02:03.000000', 'temperatura', 1128.0000, 'ºC'),
	(122568, 108, '2015-04-01 01:02:04.000000', 'temperatura', 240.0000, 'ºC'),
	(122569, 108, '2015-04-01 01:02:05.000000', 'temperatura', 218.0000, 'ºC'),
	(122570, 108, '2015-04-01 01:02:06.000000', 'temperatura', 370.0000, 'ºC'),
	(122571, 108, '2015-04-01 01:02:07.000000', 'temperatura', 1198.0000, 'ºC'),
	(122572, 108, '2015-04-01 01:02:08.000000', 'temperatura', 78.0000, 'ºC'),
	(122573, 108, '2015-04-01 01:02:09.000000', 'temperatura', 399.0000, 'ºC'),
	(122574, 108, '2015-04-01 01:02:10.000000', 'temperatura', 559.0000, 'ºC'),
	(122575, 108, '2015-04-01 01:02:11.000000', 'temperatura', 401.0000, 'ºC'),
	(122576, 108, '2015-04-01 01:02:12.000000', 'temperatura', 327.0000, 'ºC'),
	(122577, 108, '2015-04-01 01:02:13.000000', 'temperatura', 432.0000, 'ºC'),
	(122578, 108, '2015-04-01 01:02:14.000000', 'temperatura', 1179.0000, 'ºC'),
	(122579, 108, '2015-04-01 01:02:15.000000', 'temperatura', 1000.0000, 'ºC'),
	(122580, 108, '2015-04-01 01:02:16.000000', 'temperatura', 262.0000, 'ºC'),
	(122581, 108, '2015-04-01 01:02:17.000000', 'temperatura', 710.0000, 'ºC'),
	(122582, 108, '2015-04-01 01:02:18.000000', 'temperatura', 365.0000, 'ºC'),
	(122583, 108, '2015-04-01 01:02:19.000000', 'temperatura', 896.0000, 'ºC'),
	(122584, 108, '2015-04-01 01:02:20.000000', 'temperatura', 987.0000, 'ºC'),
	(122585, 108, '2015-04-01 01:02:21.000000', 'temperatura', 1048.0000, 'ºC'),
	(122586, 108, '2015-04-01 01:02:22.000000', 'temperatura', 1079.0000, 'ºC'),
	(122587, 108, '2015-04-01 01:02:23.000000', 'temperatura', 1050.0000, 'ºC'),
	(122588, 108, '2015-04-01 01:02:24.000000', 'temperatura', 812.0000, 'ºC'),
	(122589, 108, '2015-04-01 01:02:25.000000', 'temperatura', 913.0000, 'ºC'),
	(122590, 108, '2015-04-01 01:02:26.000000', 'temperatura', 929.0000, 'ºC'),
	(122591, 108, '2015-04-01 01:02:27.000000', 'temperatura', 706.0000, 'ºC'),
	(122592, 108, '2015-04-01 01:02:28.000000', 'temperatura', 746.0000, 'ºC'),
	(122593, 108, '2015-04-01 01:02:29.000000', 'temperatura', 410.0000, 'ºC'),
	(122594, 108, '2015-04-01 01:02:30.000000', 'temperatura', 1015.0000, 'ºC'),
	(122595, 108, '2015-04-01 01:02:31.000000', 'temperatura', 244.0000, 'ºC'),
	(122596, 108, '2015-04-01 01:02:32.000000', 'temperatura', 577.0000, 'ºC'),
	(122597, 108, '2015-04-01 01:02:33.000000', 'temperatura', 951.0000, 'ºC'),
	(122598, 108, '2015-04-01 01:02:34.000000', 'temperatura', 627.0000, 'ºC'),
	(122599, 108, '2015-04-01 01:02:35.000000', 'temperatura', 281.0000, 'ºC'),
	(122600, 108, '2015-04-01 01:02:36.000000', 'temperatura', 725.0000, 'ºC'),
	(122601, 108, '2015-04-01 01:02:37.000000', 'temperatura', 383.0000, 'ºC'),
	(122602, 108, '2015-04-01 01:02:38.000000', 'temperatura', 942.0000, 'ºC'),
	(122603, 108, '2015-04-01 01:02:39.000000', 'temperatura', 1159.0000, 'ºC'),
	(122604, 108, '2015-04-01 01:02:40.000000', 'temperatura', 569.0000, 'ºC'),
	(122605, 108, '2015-04-01 01:02:41.000000', 'temperatura', 567.0000, 'ºC'),
	(122606, 108, '2015-04-01 01:02:42.000000', 'temperatura', 1132.0000, 'ºC'),
	(122607, 108, '2015-04-01 01:02:43.000000', 'temperatura', 356.0000, 'ºC'),
	(122608, 108, '2015-04-01 01:02:44.000000', 'temperatura', 787.0000, 'ºC'),
	(122609, 108, '2015-04-01 01:02:45.000000', 'temperatura', 466.0000, 'ºC'),
	(122610, 108, '2015-04-01 01:02:46.000000', 'temperatura', 1170.0000, 'ºC'),
	(122611, 108, '2015-04-01 01:02:47.000000', 'temperatura', 853.0000, 'ºC'),
	(122612, 108, '2015-04-01 01:02:48.000000', 'temperatura', 755.0000, 'ºC'),
	(122613, 108, '2015-04-01 01:02:49.000000', 'temperatura', 15.0000, 'ºC'),
	(122614, 108, '2015-04-01 01:02:50.000000', 'temperatura', 213.0000, 'ºC'),
	(122615, 108, '2015-04-01 01:02:51.000000', 'temperatura', 1019.0000, 'ºC'),
	(122616, 108, '2015-04-01 01:02:52.000000', 'temperatura', 857.0000, 'ºC'),
	(122617, 108, '2015-04-01 01:02:53.000000', 'temperatura', 28.0000, 'ºC'),
	(122618, 108, '2015-04-01 01:02:54.000000', 'temperatura', 1171.0000, 'ºC'),
	(122619, 108, '2015-04-01 01:02:55.000000', 'temperatura', 971.0000, 'ºC'),
	(122620, 108, '2015-04-01 01:02:56.000000', 'temperatura', 143.0000, 'ºC'),
	(122621, 108, '2015-04-01 01:02:57.000000', 'temperatura', 203.0000, 'ºC'),
	(122622, 108, '2015-04-01 01:02:58.000000', 'temperatura', 588.0000, 'ºC'),
	(122623, 108, '2015-04-01 01:02:59.000000', 'temperatura', 1129.0000, 'ºC'),
	(122624, 108, '2015-04-01 01:03:00.000000', 'temperatura', 281.0000, 'ºC'),
	(122625, 108, '2015-04-01 01:03:01.000000', 'temperatura', 421.0000, 'ºC'),
	(122626, 108, '2015-04-01 01:03:02.000000', 'temperatura', 63.0000, 'ºC'),
	(122627, 108, '2015-04-01 01:03:03.000000', 'temperatura', 252.0000, 'ºC'),
	(122628, 108, '2015-04-01 01:03:04.000000', 'temperatura', 1070.0000, 'ºC'),
	(122629, 108, '2015-04-01 01:03:05.000000', 'temperatura', 994.0000, 'ºC'),
	(122630, 108, '2015-04-01 01:03:06.000000', 'temperatura', 563.0000, 'ºC'),
	(122631, 108, '2015-04-01 01:03:07.000000', 'temperatura', 1031.0000, 'ºC'),
	(122632, 108, '2015-04-01 01:03:08.000000', 'temperatura', 1069.0000, 'ºC'),
	(122633, 108, '2015-04-01 01:03:09.000000', 'temperatura', 1052.0000, 'ºC'),
	(122634, 108, '2015-04-01 01:03:10.000000', 'temperatura', 851.0000, 'ºC'),
	(122635, 108, '2015-04-01 01:03:11.000000', 'temperatura', 1102.0000, 'ºC'),
	(122636, 108, '2015-04-01 01:03:12.000000', 'temperatura', 557.0000, 'ºC'),
	(122637, 108, '2015-04-01 01:03:13.000000', 'temperatura', 680.0000, 'ºC'),
	(122638, 108, '2015-04-01 01:03:14.000000', 'temperatura', 528.0000, 'ºC'),
	(122639, 108, '2015-04-01 01:03:15.000000', 'temperatura', 602.0000, 'ºC'),
	(122640, 108, '2015-04-01 01:03:16.000000', 'temperatura', 225.0000, 'ºC'),
	(122641, 108, '2015-04-01 01:03:17.000000', 'temperatura', 520.0000, 'ºC'),
	(122642, 108, '2015-04-01 01:03:18.000000', 'temperatura', 725.0000, 'ºC'),
	(122643, 108, '2015-04-01 01:03:19.000000', 'temperatura', 868.0000, 'ºC'),
	(122644, 108, '2015-04-01 01:03:20.000000', 'temperatura', 963.0000, 'ºC'),
	(122645, 108, '2015-04-01 01:03:21.000000', 'temperatura', 1012.0000, 'ºC'),
	(122646, 108, '2015-04-01 01:03:22.000000', 'temperatura', 972.0000, 'ºC'),
	(122647, 108, '2015-04-01 01:03:23.000000', 'temperatura', 624.0000, 'ºC'),
	(122648, 108, '2015-04-01 01:03:24.000000', 'temperatura', 204.0000, 'ºC'),
	(122649, 108, '2015-04-01 01:03:25.000000', 'temperatura', 348.0000, 'ºC'),
	(122650, 108, '2015-04-01 01:03:26.000000', 'temperatura', 1130.0000, 'ºC'),
	(122651, 108, '2015-04-01 01:03:27.000000', 'temperatura', 1006.0000, 'ºC'),
	(122652, 108, '2015-04-01 01:03:28.000000', 'temperatura', 442.0000, 'ºC'),
	(122653, 108, '2015-04-01 01:03:29.000000', 'temperatura', 390.0000, 'ºC'),
	(122654, 108, '2015-04-01 01:03:30.000000', 'temperatura', 627.0000, 'ºC'),
	(122655, 108, '2015-04-01 01:03:31.000000', 'temperatura', 763.0000, 'ºC'),
	(122656, 108, '2015-04-01 01:03:32.000000', 'temperatura', 736.0000, 'ºC'),
	(122657, 108, '2015-04-01 01:03:33.000000', 'temperatura', 191.0000, 'ºC'),
	(122658, 108, '2015-04-01 01:03:34.000000', 'temperatura', 1149.0000, 'ºC'),
	(122659, 108, '2015-04-01 01:03:35.000000', 'temperatura', 374.0000, 'ºC'),
	(122660, 108, '2015-04-01 01:03:36.000000', 'temperatura', 820.0000, 'ºC'),
	(122661, 108, '2015-04-01 01:03:37.000000', 'temperatura', 581.0000, 'ºC'),
	(122662, 108, '2015-04-01 01:03:38.000000', 'temperatura', 445.0000, 'ºC'),
	(122663, 108, '2015-04-01 01:03:39.000000', 'temperatura', 480.0000, 'ºC'),
	(122664, 108, '2015-04-01 01:03:40.000000', 'temperatura', 1069.0000, 'ºC'),
	(122665, 108, '2015-04-01 01:03:41.000000', 'temperatura', 305.0000, 'ºC'),
	(122666, 108, '2015-04-01 01:03:42.000000', 'temperatura', 717.0000, 'ºC'),
	(122667, 108, '2015-04-01 01:03:43.000000', 'temperatura', 273.0000, 'ºC'),
	(122668, 108, '2015-04-01 01:03:44.000000', 'temperatura', 411.0000, 'ºC'),
	(122669, 108, '2015-04-01 01:03:45.000000', 'temperatura', 39.0000, 'ºC'),
	(122670, 108, '2015-04-01 01:03:46.000000', 'temperatura', 160.0000, 'ºC'),
	(122671, 108, '2015-04-01 01:03:47.000000', 'temperatura', 687.0000, 'ºC'),
	(122672, 108, '2015-04-01 01:03:48.000000', 'temperatura', 553.0000, 'ºC'),
	(122673, 108, '2015-04-01 01:03:49.000000', 'temperatura', 704.0000, 'ºC'),
	(122674, 108, '2015-04-01 01:03:50.000000', 'temperatura', 662.0000, 'ºC'),
	(122675, 108, '2015-04-01 01:03:51.000000', 'temperatura', 1197.0000, 'ºC'),
	(122676, 108, '2015-04-01 01:03:52.000000', 'temperatura', 400.0000, 'ºC'),
	(122677, 108, '2015-04-01 01:03:53.000000', 'temperatura', 810.0000, 'ºC'),
	(122678, 108, '2015-04-01 01:03:54.000000', 'temperatura', 450.0000, 'ºC'),
	(122679, 108, '2015-04-01 01:03:55.000000', 'temperatura', 1020.0000, 'ºC'),
	(122680, 108, '2015-04-01 01:03:56.000000', 'temperatura', 152.0000, 'ºC'),
	(122681, 108, '2015-04-01 01:03:57.000000', 'temperatura', 101.0000, 'ºC'),
	(122682, 108, '2015-04-01 01:03:58.000000', 'temperatura', 49.0000, 'ºC'),
	(122683, 108, '2015-04-01 01:03:59.000000', 'temperatura', 1142.0000, 'ºC'),
	(122684, 108, '2015-04-01 01:04:00.000000', 'temperatura', 762.0000, 'ºC'),
	(122685, 108, '2015-04-01 01:04:01.000000', 'temperatura', 387.0000, 'ºC'),
	(122686, 108, '2015-04-01 01:04:02.000000', 'temperatura', 851.0000, 'ºC'),
	(122687, 108, '2015-04-01 01:04:03.000000', 'temperatura', 692.0000, 'ºC'),
	(122688, 108, '2015-04-01 01:04:04.000000', 'temperatura', 906.0000, 'ºC'),
	(122689, 108, '2015-04-01 01:04:05.000000', 'temperatura', 56.0000, 'ºC'),
	(122690, 108, '2015-04-01 01:04:06.000000', 'temperatura', 1162.0000, 'ºC'),
	(122691, 108, '2015-04-01 01:04:07.000000', 'temperatura', 841.0000, 'ºC'),
	(122692, 108, '2015-04-01 01:04:08.000000', 'temperatura', 720.0000, 'ºC'),
	(122693, 108, '2015-04-01 01:04:09.000000', 'temperatura', 1077.0000, 'ºC'),
	(122694, 108, '2015-04-01 01:04:10.000000', 'temperatura', 827.0000, 'ºC'),
	(122695, 108, '2015-04-01 01:04:11.000000', 'temperatura', 904.0000, 'ºC'),
	(122696, 108, '2015-04-01 01:04:12.000000', 'temperatura', 841.0000, 'ºC'),
	(122697, 108, '2015-04-01 01:04:13.000000', 'temperatura', 292.0000, 'ºC'),
	(122698, 108, '2015-04-01 01:04:14.000000', 'temperatura', 139.0000, 'ºC'),
	(122699, 108, '2015-04-01 01:04:15.000000', 'temperatura', 1017.0000, 'ºC'),
	(122700, 108, '2015-04-01 01:04:16.000000', 'temperatura', 1069.0000, 'ºC'),
	(122701, 108, '2015-04-01 01:04:17.000000', 'temperatura', 1094.0000, 'ºC'),
	(122702, 108, '2015-04-01 01:04:18.000000', 'temperatura', 1064.0000, 'ºC'),
	(122703, 108, '2015-04-01 01:04:19.000000', 'temperatura', 837.0000, 'ºC'),
	(122704, 108, '2015-04-01 01:04:20.000000', 'temperatura', 993.0000, 'ºC'),
	(122705, 108, '2015-04-01 01:04:21.000000', 'temperatura', 56.0000, 'ºC'),
	(122706, 108, '2015-04-01 01:04:22.000000', 'temperatura', 903.0000, 'ºC'),
	(122707, 108, '2015-04-01 01:04:23.000000', 'temperatura', 746.0000, 'ºC'),
	(122708, 108, '2015-04-01 01:04:24.000000', 'temperatura', 1021.0000, 'ºC'),
	(122709, 108, '2015-04-01 01:04:25.000000', 'temperatura', 469.0000, 'ºC'),
	(122710, 108, '2015-04-01 01:04:26.000000', 'temperatura', 480.0000, 'ºC'),
	(122711, 108, '2015-04-01 01:04:27.000000', 'temperatura', 994.0000, 'ºC'),
	(122712, 108, '2015-04-01 01:04:28.000000', 'temperatura', 1129.0000, 'ºC'),
	(122713, 108, '2015-04-01 01:04:29.000000', 'temperatura', 265.0000, 'ºC'),
	(122714, 108, '2015-04-01 01:04:30.000000', 'temperatura', 337.0000, 'ºC'),
	(122715, 108, '2015-04-01 01:04:31.000000', 'temperatura', 891.0000, 'ºC'),
	(122716, 108, '2015-04-01 01:04:32.000000', 'temperatura', 1046.0000, 'ºC'),
	(122717, 108, '2015-04-01 01:04:33.000000', 'temperatura', 159.0000, 'ºC'),
	(122718, 108, '2015-04-01 01:04:34.000000', 'temperatura', 54.0000, 'ºC'),
	(122719, 108, '2015-04-01 01:04:35.000000', 'temperatura', 994.0000, 'ºC'),
	(122720, 108, '2015-04-01 01:04:36.000000', 'temperatura', 8.0000, 'ºC'),
	(122721, 108, '2015-04-01 01:04:37.000000', 'temperatura', 659.0000, 'ºC'),
	(122722, 108, '2015-04-01 01:04:38.000000', 'temperatura', 871.0000, 'ºC'),
	(122723, 108, '2015-04-01 01:04:39.000000', 'temperatura', 1178.0000, 'ºC'),
	(122724, 108, '2015-04-01 01:04:40.000000', 'temperatura', 880.0000, 'ºC'),
	(122725, 108, '2015-04-01 01:04:41.000000', 'temperatura', 864.0000, 'ºC'),
	(122726, 108, '2015-04-01 01:04:42.000000', 'temperatura', 481.0000, 'ºC'),
	(122727, 108, '2015-04-01 01:04:43.000000', 'temperatura', 1013.0000, 'ºC'),
	(122728, 108, '2015-04-01 01:04:44.000000', 'temperatura', 25.0000, 'ºC'),
	(122729, 108, '2015-04-01 01:04:45.000000', 'temperatura', 686.0000, 'ºC'),
	(122730, 108, '2015-04-01 01:04:46.000000', 'temperatura', 954.0000, 'ºC'),
	(122731, 108, '2015-04-01 01:04:47.000000', 'temperatura', 314.0000, 'ºC'),
	(122732, 108, '2015-04-01 01:04:48.000000', 'temperatura', 1109.0000, 'ºC'),
	(122733, 108, '2015-04-01 01:04:49.000000', 'temperatura', 1001.0000, 'ºC'),
	(122734, 108, '2015-04-01 01:04:50.000000', 'temperatura', 478.0000, 'ºC'),
	(122735, 108, '2015-04-01 01:04:51.000000', 'temperatura', 590.0000, 'ºC'),
	(122736, 108, '2015-04-01 01:04:52.000000', 'temperatura', 314.0000, 'ºC'),
	(122737, 108, '2015-04-01 01:04:53.000000', 'temperatura', 1001.0000, 'ºC'),
	(122738, 108, '2015-04-01 01:04:54.000000', 'temperatura', 466.0000, 'ºC'),
	(122739, 108, '2015-04-01 01:04:55.000000', 'temperatura', 526.0000, 'ºC'),
	(122740, 108, '2015-04-01 01:04:56.000000', 'temperatura', 32.0000, 'ºC'),
	(122741, 108, '2015-04-01 01:04:57.000000', 'temperatura', 983.0000, 'ºC'),
	(122742, 108, '2015-04-01 01:04:58.000000', 'temperatura', 18.0000, 'ºC'),
	(122743, 108, '2015-04-01 01:04:59.000000', 'temperatura', 744.0000, 'ºC'),
	(122744, 108, '2015-04-01 01:05:00.000000', 'temperatura', 63.0000, 'ºC'),
	(122745, 108, '2015-04-01 01:05:01.000000', 'temperatura', 487.0000, 'ºC'),
	(122746, 108, '2015-04-01 01:05:02.000000', 'temperatura', 1046.0000, 'ºC'),
	(122747, 108, '2015-04-01 01:05:03.000000', 'temperatura', 170.0000, 'ºC'),
	(122748, 108, '2015-04-01 01:05:04.000000', 'temperatura', 110.0000, 'ºC'),
	(122749, 108, '2015-04-01 01:05:05.000000', 'temperatura', 42.0000, 'ºC'),
	(122750, 108, '2015-04-01 01:05:06.000000', 'temperatura', 1079.0000, 'ºC'),
	(122751, 108, '2015-04-01 01:05:07.000000', 'temperatura', 472.0000, 'ºC'),
	(122752, 108, '2015-04-01 01:05:08.000000', 'temperatura', 323.0000, 'ºC'),
	(122753, 108, '2015-04-01 01:05:09.000000', 'temperatura', 200.0000, 'ºC'),
	(122754, 108, '2015-04-01 01:05:10.000000', 'temperatura', 31.0000, 'ºC'),
	(122755, 108, '2015-04-01 01:05:11.000000', 'temperatura', 754.0000, 'ºC'),
	(122756, 108, '2015-04-01 01:05:12.000000', 'temperatura', 77.0000, 'ºC'),
	(122757, 108, '2015-04-01 01:05:13.000000', 'temperatura', 526.0000, 'ºC'),
	(122758, 108, '2015-04-01 01:05:14.000000', 'temperatura', 1196.0000, 'ºC'),
	(122759, 108, '2015-04-01 01:05:15.000000', 'temperatura', 806.0000, 'ºC'),
	(122760, 108, '2015-04-01 01:05:16.000000', 'temperatura', 442.0000, 'ºC'),
	(122761, 108, '2015-04-01 01:05:17.000000', 'temperatura', 993.0000, 'ºC'),
	(122762, 108, '2015-04-01 01:05:18.000000', 'temperatura', 38.0000, 'ºC'),
	(122763, 108, '2015-04-01 01:05:19.000000', 'temperatura', 811.0000, 'ºC'),
	(122764, 108, '2015-04-01 01:05:20.000000', 'temperatura', 344.0000, 'ºC'),
	(122765, 108, '2015-04-01 01:05:21.000000', 'temperatura', 488.0000, 'ºC'),
	(122766, 108, '2015-04-01 01:05:22.000000', 'temperatura', 207.0000, 'ºC'),
	(122767, 108, '2015-04-01 01:05:23.000000', 'temperatura', 771.0000, 'ºC'),
	(122768, 108, '2015-04-01 01:05:24.000000', 'temperatura', 835.0000, 'ºC'),
	(122769, 108, '2015-04-01 01:05:25.000000', 'temperatura', 665.0000, 'ºC'),
	(122770, 108, '2015-04-01 01:05:26.000000', 'temperatura', 817.0000, 'ºC'),
	(122771, 108, '2015-04-01 01:05:27.000000', 'temperatura', 892.0000, 'ºC'),
	(122772, 108, '2015-04-01 01:05:28.000000', 'temperatura', 809.0000, 'ºC'),
	(122773, 108, '2015-04-01 01:05:29.000000', 'temperatura', 169.0000, 'ºC'),
	(122774, 108, '2015-04-01 01:05:30.000000', 'temperatura', 819.0000, 'ºC'),
	(122775, 108, '2015-04-01 01:05:31.000000', 'temperatura', 1190.0000, 'ºC'),
	(122776, 108, '2015-04-01 01:05:32.000000', 'temperatura', 1092.0000, 'ºC'),
	(122777, 108, '2015-04-01 01:05:33.000000', 'temperatura', 692.0000, 'ºC'),
	(122778, 108, '2015-04-01 01:05:34.000000', 'temperatura', 183.0000, 'ºC'),
	(122779, 108, '2015-04-01 01:05:35.000000', 'temperatura', 42.0000, 'ºC'),
	(122780, 108, '2015-04-01 01:05:36.000000', 'temperatura', 861.0000, 'ºC'),
	(122781, 108, '2015-04-01 01:05:37.000000', 'temperatura', 577.0000, 'ºC'),
	(122782, 108, '2015-04-01 01:05:38.000000', 'temperatura', 303.0000, 'ºC'),
	(122783, 108, '2015-04-01 01:05:39.000000', 'temperatura', 985.0000, 'ºC'),
	(122784, 108, '2015-04-01 01:05:40.000000', 'temperatura', 416.0000, 'ºC'),
	(122785, 108, '2015-04-01 01:05:41.000000', 'temperatura', 324.0000, 'ºC'),
	(122786, 108, '2015-04-01 01:05:42.000000', 'temperatura', 375.0000, 'ºC'),
	(122787, 108, '2015-04-01 01:05:43.000000', 'temperatura', 903.0000, 'ºC'),
	(122788, 108, '2015-04-01 01:05:44.000000', 'temperatura', 989.0000, 'ºC'),
	(122789, 108, '2015-04-01 01:05:45.000000', 'temperatura', 1037.0000, 'ºC'),
	(122790, 108, '2015-04-01 01:05:46.000000', 'temperatura', 1020.0000, 'ºC'),
	(122791, 108, '2015-04-01 01:05:47.000000', 'temperatura', 788.0000, 'ºC'),
	(122792, 108, '2015-04-01 01:05:48.000000', 'temperatura', 880.0000, 'ºC'),
	(122793, 108, '2015-04-01 01:05:49.000000', 'temperatura', 839.0000, 'ºC'),
	(122794, 108, '2015-04-01 01:05:50.000000', 'temperatura', 353.0000, 'ºC'),
	(122795, 108, '2015-04-01 01:05:51.000000', 'temperatura', 451.0000, 'ºC'),
	(122796, 108, '2015-04-01 01:05:52.000000', 'temperatura', 1196.0000, 'ºC'),
	(122797, 108, '2015-04-01 01:05:53.000000', 'temperatura', 1027.0000, 'ºC'),
	(122798, 108, '2015-04-01 01:05:54.000000', 'temperatura', 347.0000, 'ºC'),
	(122799, 108, '2015-04-01 01:05:55.000000', 'temperatura', 1053.0000, 'ºC'),
	(122800, 108, '2015-04-01 01:05:56.000000', 'temperatura', 627.0000, 'ºC'),
	(122801, 108, '2015-04-01 01:05:57.000000', 'temperatura', 1176.0000, 'ºC'),
	(122802, 108, '2015-04-01 01:05:58.000000', 'temperatura', 400.0000, 'ºC'),
	(122803, 108, '2015-04-01 01:05:59.000000', 'temperatura', 871.0000, 'ºC'),
	(122804, 108, '2015-04-01 01:06:00.000000', 'temperatura', 757.0000, 'ºC'),
	(122805, 108, '2015-04-01 01:06:01.000000', 'temperatura', 1173.0000, 'ºC'),
	(122806, 108, '2015-04-01 01:06:02.000000', 'temperatura', 1193.0000, 'ºC'),
	(122807, 108, '2015-04-01 01:06:03.000000', 'temperatura', 46.0000, 'ºC'),
	(122808, 108, '2015-04-01 01:06:04.000000', 'temperatura', 252.0000, 'ºC'),
	(122809, 108, '2015-04-01 01:06:05.000000', 'temperatura', 1125.0000, 'ºC'),
	(122810, 108, '2015-04-01 01:06:06.000000', 'temperatura', 66.0000, 'ºC'),
	(122811, 108, '2015-04-01 01:06:07.000000', 'temperatura', 556.0000, 'ºC'),
	(122812, 108, '2015-04-01 01:06:08.000000', 'temperatura', 185.0000, 'ºC'),
	(122813, 108, '2015-04-01 01:06:09.000000', 'temperatura', 456.0000, 'ºC'),
	(122814, 108, '2015-04-01 01:06:10.000000', 'temperatura', 527.0000, 'ºC'),
	(122815, 108, '2015-04-01 01:06:11.000000', 'temperatura', 68.0000, 'ºC'),
	(122816, 108, '2015-04-01 01:06:12.000000', 'temperatura', 1157.0000, 'ºC'),
	(122817, 108, '2015-04-01 01:06:13.000000', 'temperatura', 782.0000, 'ºC'),
	(122818, 108, '2015-04-01 01:06:14.000000', 'temperatura', 438.0000, 'ºC'),
	(122819, 108, '2015-04-01 01:06:15.000000', 'temperatura', 1046.0000, 'ºC'),
	(122820, 108, '2015-04-01 01:06:16.000000', 'temperatura', 318.0000, 'ºC'),
	(122821, 108, '2015-04-01 01:06:17.000000', 'temperatura', 853.0000, 'ºC'),
	(122822, 108, '2015-04-01 01:06:18.000000', 'temperatura', 909.0000, 'ºC'),
	(122823, 108, '2015-04-01 01:06:19.000000', 'temperatura', 786.0000, 'ºC'),
	(122824, 108, '2015-04-01 01:06:20.000000', 'temperatura', 4.0000, 'ºC'),
	(122825, 108, '2015-04-01 01:06:21.000000', 'temperatura', 61.0000, 'ºC'),
	(122826, 108, '2015-04-01 01:06:22.000000', 'temperatura', 296.0000, 'ºC'),
	(122827, 108, '2015-04-01 01:06:23.000000', 'temperatura', 96.0000, 'ºC'),
	(122828, 108, '2015-04-01 01:06:24.000000', 'temperatura', 793.0000, 'ºC'),
	(122829, 108, '2015-04-01 01:06:25.000000', 'temperatura', 77.0000, 'ºC'),
	(122830, 108, '2015-04-01 01:06:26.000000', 'temperatura', 409.0000, 'ºC'),
	(122831, 108, '2015-04-01 01:06:27.000000', 'temperatura', 612.0000, 'ºC'),
	(122832, 108, '2015-04-01 01:06:28.000000', 'temperatura', 636.0000, 'ºC'),
	(122833, 108, '2015-04-01 01:06:29.000000', 'temperatura', 142.0000, 'ºC'),
	(122834, 108, '2015-04-01 01:06:30.000000', 'temperatura', 3.0000, 'ºC'),
	(122835, 108, '2015-04-01 01:06:31.000000', 'temperatura', 788.0000, 'ºC'),
	(122836, 108, '2015-04-01 01:06:32.000000', 'temperatura', 331.0000, 'ºC'),
	(122837, 108, '2015-04-01 01:06:33.000000', 'temperatura', 493.0000, 'ºC'),
	(122838, 108, '2015-04-01 01:06:34.000000', 'temperatura', 274.0000, 'ºC'),
	(122839, 108, '2015-04-01 01:06:35.000000', 'temperatura', 1092.0000, 'ºC'),
	(122840, 108, '2015-04-01 01:06:36.000000', 'temperatura', 1037.0000, 'ºC'),
	(122841, 108, '2015-04-01 01:06:37.000000', 'temperatura', 710.0000, 'ºC'),
	(122842, 108, '2015-04-01 01:06:38.000000', 'temperatura', 439.0000, 'ºC'),
	(122843, 108, '2015-04-01 01:06:39.000000', 'temperatura', 65.0000, 'ºC'),
	(122844, 108, '2015-04-01 01:06:40.000000', 'temperatura', 208.0000, 'ºC'),
	(122845, 108, '2015-04-01 01:06:41.000000', 'temperatura', 846.0000, 'ºC'),
	(122846, 108, '2015-04-01 01:06:42.000000', 'temperatura', 5.0000, 'ºC'),
	(122847, 108, '2015-04-01 01:06:43.000000', 'temperatura', 1088.0000, 'ºC'),
	(122848, 108, '2015-04-01 01:06:44.000000', 'temperatura', 624.0000, 'ºC'),
	(122849, 108, '2015-04-01 01:06:45.000000', 'temperatura', 1058.0000, 'ºC'),
	(122850, 108, '2015-04-01 01:06:46.000000', 'temperatura', 1018.0000, 'ºC'),
	(122851, 108, '2015-04-01 01:06:47.000000', 'temperatura', 715.0000, 'ºC'),
	(122852, 108, '2015-04-01 01:06:48.000000', 'temperatura', 522.0000, 'ºC'),
	(122853, 108, '2015-04-01 01:06:49.000000', 'temperatura', 468.0000, 'ºC'),
	(122854, 108, '2015-04-01 01:06:50.000000', 'temperatura', 773.0000, 'ºC'),
	(122855, 108, '2015-04-01 01:06:51.000000', 'temperatura', 62.0000, 'ºC'),
	(122856, 108, '2015-04-01 01:06:52.000000', 'temperatura', 389.0000, 'ºC'),
	(122857, 108, '2015-04-01 01:06:53.000000', 'temperatura', 562.0000, 'ºC'),
	(122858, 108, '2015-04-01 01:06:54.000000', 'temperatura', 443.0000, 'ºC'),
	(122859, 108, '2015-04-01 01:06:55.000000', 'temperatura', 531.0000, 'ºC'),
	(122860, 108, '2015-04-01 01:06:56.000000', 'temperatura', 126.0000, 'ºC'),
	(122861, 108, '2015-04-01 01:06:57.000000', 'temperatura', 235.0000, 'ºC'),
	(122862, 108, '2015-04-01 01:06:58.000000', 'temperatura', 801.0000, 'ºC'),
	(122863, 108, '2015-04-01 01:06:59.000000', 'temperatura', 898.0000, 'ºC'),
	(122864, 108, '2015-04-01 01:07:00.000000', 'temperatura', 888.0000, 'ºC'),
	(122865, 108, '2015-04-01 01:07:01.000000', 'temperatura', 548.0000, 'ºC'),
	(122866, 108, '2015-04-01 01:07:02.000000', 'temperatura', 76.0000, 'ºC'),
	(122867, 108, '2015-04-01 01:07:03.000000', 'temperatura', 1138.0000, 'ºC'),
	(122868, 108, '2015-04-01 01:07:04.000000', 'temperatura', 663.0000, 'ºC'),
	(122869, 108, '2015-04-01 01:07:05.000000', 'temperatura', 1098.0000, 'ºC'),
	(122870, 108, '2015-04-01 01:07:06.000000', 'temperatura', 1104.0000, 'ºC'),
	(122871, 108, '2015-04-01 01:07:07.000000', 'temperatura', 1024.0000, 'ºC'),
	(122872, 108, '2015-04-01 01:07:08.000000', 'temperatura', 611.0000, 'ºC'),
	(122873, 108, '2015-04-01 01:07:09.000000', 'temperatura', 1183.0000, 'ºC'),
	(122874, 108, '2015-04-01 01:07:10.000000', 'temperatura', 483.0000, 'ºC'),
	(122875, 108, '2015-04-01 01:07:11.000000', 'temperatura', 65.0000, 'ºC'),
	(122876, 108, '2015-04-01 01:07:12.000000', 'temperatura', 77.0000, 'ºC'),
	(122877, 108, '2015-04-01 01:07:13.000000', 'temperatura', 192.0000, 'ºC'),
	(122878, 108, '2015-04-01 01:07:14.000000', 'temperatura', 728.0000, 'ºC'),
	(122879, 108, '2015-04-01 01:07:15.000000', 'temperatura', 666.0000, 'ºC'),
	(122880, 108, '2015-04-01 01:07:16.000000', 'temperatura', 1145.0000, 'ºC'),
	(122881, 108, '2015-04-01 01:07:17.000000', 'temperatura', 127.0000, 'ºC'),
	(122882, 108, '2015-04-01 01:07:18.000000', 'temperatura', 800.0000, 'ºC'),
	(122883, 108, '2015-04-01 01:07:19.000000', 'temperatura', 21.0000, 'ºC'),
	(122884, 108, '2015-04-01 01:07:20.000000', 'temperatura', 105.0000, 'ºC'),
	(122885, 108, '2015-04-01 01:07:21.000000', 'temperatura', 464.0000, 'ºC'),
	(122886, 108, '2015-04-01 01:07:22.000000', 'temperatura', 804.0000, 'ºC'),
	(122887, 108, '2015-04-01 01:07:23.000000', 'temperatura', 228.0000, 'ºC'),
	(122888, 108, '2015-04-01 01:07:24.000000', 'temperatura', 1128.0000, 'ºC'),
	(122889, 108, '2015-04-01 01:07:25.000000', 'temperatura', 155.0000, 'ºC'),
	(122890, 108, '2015-04-01 01:07:26.000000', 'temperatura', 995.0000, 'ºC'),
	(122891, 108, '2015-04-01 01:07:27.000000', 'temperatura', 908.0000, 'ºC'),
	(122892, 108, '2015-04-01 01:07:28.000000', 'temperatura', 358.0000, 'ºC'),
	(122893, 108, '2015-04-01 01:07:29.000000', 'temperatura', 267.0000, 'ºC'),
	(122894, 108, '2015-04-01 01:07:30.000000', 'temperatura', 260.0000, 'ºC'),
	(122895, 108, '2015-04-01 01:07:31.000000', 'temperatura', 499.0000, 'ºC'),
	(122896, 108, '2015-04-01 01:07:32.000000', 'temperatura', 517.0000, 'ºC'),
	(122897, 108, '2015-04-01 01:07:33.000000', 'temperatura', 1086.0000, 'ºC'),
	(122898, 108, '2015-04-01 01:07:34.000000', 'temperatura', 283.0000, 'ºC'),
	(122899, 108, '2015-04-01 01:07:35.000000', 'temperatura', 554.0000, 'ºC'),
	(122900, 108, '2015-04-01 01:07:36.000000', 'temperatura', 722.0000, 'ºC'),
	(122901, 108, '2015-04-01 01:07:37.000000', 'temperatura', 751.0000, 'ºC'),
	(122902, 108, '2015-04-01 01:07:38.000000', 'temperatura', 388.0000, 'ºC'),
	(122903, 108, '2015-04-01 01:07:39.000000', 'temperatura', 887.0000, 'ºC'),
	(122904, 108, '2015-04-01 01:07:40.000000', 'temperatura', 872.0000, 'ºC'),
	(122905, 108, '2015-04-01 01:07:41.000000', 'temperatura', 498.0000, 'ºC'),
	(122906, 108, '2015-04-01 01:07:42.000000', 'temperatura', 1078.0000, 'ºC'),
	(122907, 108, '2015-04-01 01:07:43.000000', 'temperatura', 293.0000, 'ºC'),
	(122908, 108, '2015-04-01 01:07:44.000000', 'temperatura', 632.0000, 'ºC'),
	(122909, 108, '2015-04-01 01:07:45.000000', 'temperatura', 1081.0000, 'ºC'),
	(122910, 108, '2015-04-01 01:07:46.000000', 'temperatura', 1109.0000, 'ºC'),
	(122911, 108, '2015-04-01 01:07:47.000000', 'temperatura', 1104.0000, 'ºC'),
	(122912, 108, '2015-04-01 01:07:48.000000', 'temperatura', 992.0000, 'ºC'),
	(122913, 108, '2015-04-01 01:07:49.000000', 'temperatura', 450.0000, 'ºC'),
	(122914, 108, '2015-04-01 01:07:50.000000', 'temperatura', 475.0000, 'ºC'),
	(122915, 108, '2015-04-01 01:07:51.000000', 'temperatura', 1027.0000, 'ºC'),
	(122916, 108, '2015-04-01 01:07:52.000000', 'temperatura', 108.0000, 'ºC'),
	(122917, 108, '2015-04-01 01:07:53.000000', 'temperatura', 1060.0000, 'ºC'),
	(122918, 108, '2015-04-01 01:07:54.000000', 'temperatura', 177.0000, 'ºC'),
	(122919, 108, '2015-04-01 01:07:55.000000', 'temperatura', 104.0000, 'ºC'),
	(122920, 108, '2015-04-01 01:07:56.000000', 'temperatura', 1191.0000, 'ºC'),
	(122921, 108, '2015-04-01 01:07:57.000000', 'temperatura', 841.0000, 'ºC'),
	(122922, 108, '2015-04-01 01:07:58.000000', 'temperatura', 634.0000, 'ºC'),
	(122923, 108, '2015-04-01 01:07:59.000000', 'temperatura', 649.0000, 'ºC'),
	(122924, 108, '2015-04-01 01:08:00.000000', 'temperatura', 143.0000, 'ºC'),
	(122925, 108, '2015-04-01 01:08:01.000000', 'temperatura', 1167.0000, 'ºC'),
	(122926, 108, '2015-04-01 01:08:02.000000', 'temperatura', 606.0000, 'ºC'),
	(122927, 108, '2015-04-01 01:08:03.000000', 'temperatura', 732.0000, 'ºC'),
	(122928, 108, '2015-04-01 01:08:04.000000', 'temperatura', 639.0000, 'ºC'),
	(122929, 108, '2015-04-01 01:08:05.000000', 'temperatura', 1002.0000, 'ºC'),
	(122930, 108, '2015-04-01 01:08:06.000000', 'temperatura', 694.0000, 'ºC'),
	(122931, 108, '2015-04-01 01:08:07.000000', 'temperatura', 462.0000, 'ºC'),
	(122932, 108, '2015-04-01 01:08:08.000000', 'temperatura', 231.0000, 'ºC'),
	(122933, 108, '2015-04-01 01:08:09.000000', 'temperatura', 969.0000, 'ºC'),
	(122934, 108, '2015-04-01 01:08:10.000000', 'temperatura', 551.0000, 'ºC'),
	(122935, 108, '2015-04-01 01:08:11.000000', 'temperatura', 1048.0000, 'ºC'),
	(122936, 108, '2015-04-01 01:08:12.000000', 'temperatura', 1190.0000, 'ºC'),
	(122937, 108, '2015-04-01 01:08:13.000000', 'temperatura', 406.0000, 'ºC'),
	(122938, 108, '2015-04-01 01:08:14.000000', 'temperatura', 860.0000, 'ºC'),
	(122939, 108, '2015-04-01 01:08:15.000000', 'temperatura', 682.0000, 'ºC'),
	(122940, 108, '2015-04-01 01:08:16.000000', 'temperatura', 832.0000, 'ºC'),
	(122941, 108, '2015-04-01 01:08:17.000000', 'temperatura', 915.0000, 'ºC'),
	(122942, 108, '2015-04-01 01:08:18.000000', 'temperatura', 879.0000, 'ºC'),
	(122943, 108, '2015-04-01 01:08:19.000000', 'temperatura', 451.0000, 'ºC'),
	(122944, 108, '2015-04-01 01:08:20.000000', 'temperatura', 817.0000, 'ºC'),
	(122945, 108, '2015-04-01 01:08:21.000000', 'temperatura', 335.0000, 'ºC'),
	(122946, 108, '2015-04-01 01:08:22.000000', 'temperatura', 422.0000, 'ºC'),
	(122947, 108, '2015-04-01 01:08:23.000000', 'temperatura', 1107.0000, 'ºC'),
	(122948, 108, '2015-04-01 01:08:24.000000', 'temperatura', 670.0000, 'ºC'),
	(122949, 108, '2015-04-01 01:08:25.000000', 'temperatura', 28.0000, 'ºC'),
	(122950, 108, '2015-04-01 01:08:26.000000', 'temperatura', 529.0000, 'ºC'),
	(122951, 108, '2015-04-01 01:08:27.000000', 'temperatura', 163.0000, 'ºC'),
	(122952, 108, '2015-04-01 01:08:28.000000', 'temperatura', 429.0000, 'ºC'),
	(122953, 108, '2015-04-01 01:08:29.000000', 'temperatura', 457.0000, 'ºC'),
	(122954, 108, '2015-04-01 01:08:30.000000', 'temperatura', 998.0000, 'ºC'),
	(122955, 108, '2015-04-01 01:08:31.000000', 'temperatura', 20.0000, 'ºC'),
	(122956, 108, '2015-04-01 01:08:32.000000', 'temperatura', 708.0000, 'ºC'),
	(122957, 108, '2015-04-01 01:08:33.000000', 'temperatura', 1077.0000, 'ºC'),
	(122958, 108, '2015-04-01 01:08:34.000000', 'temperatura', 863.0000, 'ºC'),
	(122959, 108, '2015-04-01 01:08:35.000000', 'temperatura', 1086.0000, 'ºC'),
	(122960, 108, '2015-04-01 01:08:36.000000', 'temperatura', 443.0000, 'ºC'),
	(122961, 108, '2015-04-01 01:08:37.000000', 'temperatura', 154.0000, 'ºC'),
	(122962, 108, '2015-04-01 01:08:38.000000', 'temperatura', 642.0000, 'ºC'),
	(122963, 108, '2015-04-01 01:08:39.000000', 'temperatura', 347.0000, 'ºC'),
	(122964, 108, '2015-04-01 01:08:40.000000', 'temperatura', 1011.0000, 'ºC'),
	(122965, 108, '2015-04-01 01:08:41.000000', 'temperatura', 416.0000, 'ºC'),
	(122966, 108, '2015-04-01 01:08:42.000000', 'temperatura', 248.0000, 'ºC'),
	(122967, 108, '2015-04-01 01:08:43.000000', 'temperatura', 1190.0000, 'ºC'),
	(122968, 108, '2015-04-01 01:08:44.000000', 'temperatura', 408.0000, 'ºC'),
	(122969, 108, '2015-04-01 01:08:45.000000', 'temperatura', 869.0000, 'ºC'),
	(122970, 108, '2015-04-01 01:08:46.000000', 'temperatura', 723.0000, 'ºC'),
	(122971, 108, '2015-04-01 01:08:47.000000', 'temperatura', 1008.0000, 'ºC'),
	(122972, 108, '2015-04-01 01:08:48.000000', 'temperatura', 471.0000, 'ºC'),
	(122973, 108, '2015-04-01 01:08:49.000000', 'temperatura', 534.0000, 'ºC'),
	(122974, 108, '2015-04-01 01:08:50.000000', 'temperatura', 55.0000, 'ºC'),
	(122975, 108, '2015-04-01 01:08:51.000000', 'temperatura', 1075.0000, 'ºC'),
	(122976, 108, '2015-04-01 01:08:52.000000', 'temperatura', 411.0000, 'ºC'),
	(122977, 108, '2015-04-01 01:08:53.000000', 'temperatura', 30.0000, 'ºC'),
	(122978, 108, '2015-04-01 01:08:54.000000', 'temperatura', 118.0000, 'ºC'),
	(122979, 108, '2015-04-01 01:08:55.000000', 'temperatura', 499.0000, 'ºC'),
	(122980, 108, '2015-04-01 01:08:56.000000', 'temperatura', 942.0000, 'ºC'),
	(122981, 108, '2015-04-01 01:08:57.000000', 'temperatura', 814.0000, 'ºC'),
	(122982, 108, '2015-04-01 01:08:58.000000', 'temperatura', 43.0000, 'ºC'),
	(122983, 108, '2015-04-01 01:08:59.000000', 'temperatura', 176.0000, 'ºC'),
	(122984, 108, '2015-04-01 01:09:00.000000', 'temperatura', 751.0000, 'ºC'),
	(122985, 108, '2015-04-01 01:09:01.000000', 'temperatura', 828.0000, 'ºC'),
	(122986, 108, '2015-04-01 01:09:02.000000', 'temperatura', 689.0000, 'ºC'),
	(122987, 108, '2015-04-01 01:09:03.000000', 'temperatura', 959.0000, 'ºC'),
	(122988, 108, '2015-04-01 01:09:04.000000', 'temperatura', 331.0000, 'ºC'),
	(122989, 108, '2015-04-01 01:09:05.000000', 'temperatura', 1177.0000, 'ºC'),
	(122990, 108, '2015-04-01 01:09:06.000000', 'temperatura', 92.0000, 'ºC'),
	(122991, 108, '2015-04-01 01:09:07.000000', 'temperatura', 528.0000, 'ºC'),
	(122992, 108, '2015-04-01 01:09:08.000000', 'temperatura', 1166.0000, 'ºC'),
	(122993, 108, '2015-04-01 01:09:09.000000', 'temperatura', 646.0000, 'ºC'),
	(122994, 108, '2015-04-01 01:09:10.000000', 'temperatura', 933.0000, 'ºC'),
	(122995, 108, '2015-04-01 01:09:11.000000', 'temperatura', 326.0000, 'ºC'),
	(122996, 108, '2015-04-01 01:09:12.000000', 'temperatura', 32.0000, 'ºC'),
	(122997, 108, '2015-04-01 01:09:13.000000', 'temperatura', 383.0000, 'ºC'),
	(122998, 108, '2015-04-01 01:09:14.000000', 'temperatura', 621.0000, 'ºC'),
	(122999, 108, '2015-04-01 01:09:15.000000', 'temperatura', 754.0000, 'ºC'),
	(123000, 108, '2015-04-01 01:09:16.000000', 'temperatura', 708.0000, 'ºC'),
	(123001, 108, '2015-04-01 01:09:17.000000', 'temperatura', 79.0000, 'ºC'),
	(123002, 108, '2015-04-01 01:09:18.000000', 'temperatura', 669.0000, 'ºC'),
	(123003, 108, '2015-04-01 01:09:19.000000', 'temperatura', 712.0000, 'ºC'),
	(123004, 108, '2015-04-01 01:09:20.000000', 'temperatura', 351.0000, 'ºC'),
	(123005, 108, '2015-04-01 01:09:21.000000', 'temperatura', 821.0000, 'ºC'),
	(123006, 108, '2015-04-01 01:09:22.000000', 'temperatura', 654.0000, 'ºC'),
	(123007, 108, '2015-04-01 01:09:23.000000', 'temperatura', 805.0000, 'ºC'),
	(123008, 108, '2015-04-01 01:09:24.000000', 'temperatura', 863.0000, 'ºC'),
	(123009, 108, '2015-04-01 01:09:25.000000', 'temperatura', 700.0000, 'ºC'),
	(123010, 108, '2015-04-01 01:09:26.000000', 'temperatura', 911.0000, 'ºC'),
	(123011, 108, '2015-04-01 01:09:27.000000', 'temperatura', 57.0000, 'ºC'),
	(123012, 108, '2015-04-01 01:09:28.000000', 'temperatura', 1150.0000, 'ºC'),
	(123013, 108, '2015-04-01 01:09:29.000000', 'temperatura', 782.0000, 'ºC'),
	(123014, 108, '2015-04-01 01:09:30.000000', 'temperatura', 458.0000, 'ºC'),
	(123015, 108, '2015-04-01 01:09:31.000000', 'temperatura', 1147.0000, 'ºC'),
	(123016, 108, '2015-04-01 01:09:32.000000', 'temperatura', 762.0000, 'ºC'),
	(123017, 108, '2015-04-01 01:09:33.000000', 'temperatura', 370.0000, 'ºC'),
	(123018, 108, '2015-04-01 01:09:34.000000', 'temperatura', 763.0000, 'ºC'),
	(123019, 108, '2015-04-01 01:09:35.000000', 'temperatura', 308.0000, 'ºC'),
	(123020, 108, '2015-04-01 01:09:36.000000', 'temperatura', 448.0000, 'ºC'),
	(123021, 108, '2015-04-01 01:09:37.000000', 'temperatura', 119.0000, 'ºC'),
	(123022, 108, '2015-04-01 01:09:38.000000', 'temperatura', 449.0000, 'ºC'),
	(123023, 108, '2015-04-01 01:09:39.000000', 'temperatura', 689.0000, 'ºC'),
	(123024, 108, '2015-04-01 01:09:40.000000', 'temperatura', 899.0000, 'ºC'),
	(123025, 108, '2015-04-01 01:09:41.000000', 'temperatura', 28.0000, 'ºC'),
	(123026, 108, '2015-04-01 01:09:42.000000', 'temperatura', 1045.0000, 'ºC'),
	(123027, 108, '2015-04-01 01:09:43.000000', 'temperatura', 342.0000, 'ºC'),
	(123028, 108, '2015-04-01 01:09:44.000000', 'temperatura', 974.0000, 'ºC'),
	(123029, 108, '2015-04-01 01:09:45.000000', 'temperatura', 246.0000, 'ºC'),
	(123030, 108, '2015-04-01 01:09:46.000000', 'temperatura', 709.0000, 'ºC'),
	(123031, 108, '2015-04-01 01:09:47.000000', 'temperatura', 407.0000, 'ºC'),
	(123032, 108, '2015-04-01 01:09:48.000000', 'temperatura', 1110.0000, 'ºC'),
	(123033, 108, '2015-04-01 01:09:49.000000', 'temperatura', 726.0000, 'ºC'),
	(123034, 108, '2015-04-01 01:09:50.000000', 'temperatura', 303.0000, 'ºC'),
	(123035, 108, '2015-04-01 01:09:51.000000', 'temperatura', 536.0000, 'ºC'),
	(123036, 108, '2015-04-01 01:09:52.000000', 'temperatura', 571.0000, 'ºC'),
	(123037, 108, '2015-04-01 01:09:53.000000', 'temperatura', 46.0000, 'ºC'),
	(123038, 108, '2015-04-01 01:09:54.000000', 'temperatura', 920.0000, 'ºC'),
	(123039, 108, '2015-04-01 01:09:55.000000', 'temperatura', 861.0000, 'ºC'),
	(123040, 108, '2015-04-01 01:09:56.000000', 'temperatura', 344.0000, 'ºC'),
	(123041, 108, '2015-04-01 01:09:57.000000', 'temperatura', 340.0000, 'ºC'),
	(123042, 108, '2015-04-01 01:09:58.000000', 'temperatura', 666.0000, 'ºC'),
	(123043, 108, '2015-04-01 01:09:59.000000', 'temperatura', 1113.0000, 'ºC'),
	(123044, 108, '2015-04-01 01:10:00.000000', 'temperatura', 1165.0000, 'ºC'),
	(123045, 108, '2015-04-01 01:10:01.000000', 'temperatura', 87.0000, 'ºC'),
	(123046, 108, '2015-04-01 01:10:02.000000', 'temperatura', 540.0000, 'ºC'),
	(123047, 108, '2015-04-01 01:10:03.000000', 'temperatura', 40.0000, 'ºC'),
	(123048, 108, '2015-04-01 01:10:04.000000', 'temperatura', 981.0000, 'ºC'),
	(123049, 108, '2015-04-01 01:10:05.000000', 'temperatura', 1184.0000, 'ºC'),
	(123050, 108, '2015-04-01 01:10:06.000000', 'temperatura', 578.0000, 'ºC'),
	(123051, 108, '2015-04-01 01:10:07.000000', 'temperatura', 538.0000, 'ºC'),
	(123052, 108, '2015-04-01 01:10:08.000000', 'temperatura', 957.0000, 'ºC'),
	(123053, 108, '2015-04-01 01:10:09.000000', 'temperatura', 771.0000, 'ºC'),
	(123054, 108, '2015-04-01 01:10:10.000000', 'temperatura', 984.0000, 'ºC'),
	(123055, 108, '2015-04-01 01:10:11.000000', 'temperatura', 209.0000, 'ºC'),
	(123056, 108, '2015-04-01 01:10:12.000000', 'temperatura', 495.0000, 'ºC'),
	(123057, 108, '2015-04-01 01:10:13.000000', 'temperatura', 647.0000, 'ºC'),
	(123058, 108, '2015-04-01 01:10:14.000000', 'temperatura', 549.0000, 'ºC'),
	(123059, 108, '2015-04-01 01:10:15.000000', 'temperatura', 804.0000, 'ºC'),
	(123060, 108, '2015-04-01 01:10:16.000000', 'temperatura', 1176.0000, 'ºC'),
	(123061, 108, '2015-04-01 01:10:17.000000', 'temperatura', 1066.0000, 'ºC'),
	(123062, 108, '2015-04-01 01:10:18.000000', 'temperatura', 605.0000, 'ºC'),
	(123063, 108, '2015-04-01 01:10:19.000000', 'temperatura', 1026.0000, 'ºC'),
	(123064, 108, '2015-04-01 01:10:20.000000', 'temperatura', 917.0000, 'ºC'),
	(123065, 108, '2015-04-01 01:10:21.000000', 'temperatura', 308.0000, 'ºC'),
	(123066, 108, '2015-04-01 01:10:22.000000', 'temperatura', 1189.0000, 'ºC'),
	(123067, 108, '2015-04-01 01:10:23.000000', 'temperatura', 223.0000, 'ºC'),
	(123068, 108, '2015-04-01 01:10:24.000000', 'temperatura', 1148.0000, 'ºC'),
	(123069, 108, '2015-04-01 01:10:25.000000', 'temperatura', 271.0000, 'ºC'),
	(123070, 108, '2015-04-01 01:10:26.000000', 'temperatura', 313.0000, 'ºC'),
	(123071, 108, '2015-04-01 01:10:27.000000', 'temperatura', 753.0000, 'ºC'),
	(123072, 108, '2015-04-01 01:10:28.000000', 'temperatura', 425.0000, 'ºC'),
	(123073, 108, '2015-04-01 01:10:29.000000', 'temperatura', 1066.0000, 'ºC'),
	(123074, 108, '2015-04-01 01:10:30.000000', 'temperatura', 454.0000, 'ºC'),
	(123075, 108, '2015-04-01 01:10:31.000000', 'temperatura', 276.0000, 'ºC'),
	(123076, 108, '2015-04-01 01:10:32.000000', 'temperatura', 17.0000, 'ºC'),
	(123077, 108, '2015-04-01 01:10:33.000000', 'temperatura', 459.0000, 'ºC'),
	(123078, 108, '2015-04-01 01:10:34.000000', 'temperatura', 1044.0000, 'ºC'),
	(123079, 108, '2015-04-01 01:10:35.000000', 'temperatura', 241.0000, 'ºC'),
	(123080, 108, '2015-04-01 01:10:36.000000', 'temperatura', 477.0000, 'ºC'),
	(123081, 108, '2015-04-01 01:10:37.000000', 'temperatura', 461.0000, 'ºC'),
	(123082, 108, '2015-04-01 01:10:38.000000', 'temperatura', 876.0000, 'ºC'),
	(123083, 108, '2015-04-01 01:10:39.000000', 'temperatura', 598.0000, 'ºC'),
	(123084, 108, '2015-04-01 01:10:40.000000', 'temperatura', 361.0000, 'ºC'),
	(123085, 108, '2015-04-01 01:10:41.000000', 'temperatura', 10.0000, 'ºC'),
	(123086, 108, '2015-04-01 01:10:42.000000', 'temperatura', 170.0000, 'ºC'),
	(123087, 108, '2015-04-01 01:10:43.000000', 'temperatura', 818.0000, 'ºC'),
	(123088, 108, '2015-04-01 01:10:44.000000', 'temperatura', 1180.0000, 'ºC'),
	(123089, 108, '2015-04-01 01:10:45.000000', 'temperatura', 1046.0000, 'ºC'),
	(123090, 108, '2015-04-01 01:10:46.000000', 'temperatura', 493.0000, 'ºC'),
	(123091, 108, '2015-04-01 01:10:47.000000', 'temperatura', 525.0000, 'ºC'),
	(123092, 108, '2015-04-01 01:10:48.000000', 'temperatura', 1147.0000, 'ºC'),
	(123093, 108, '2015-04-01 01:10:49.000000', 'temperatura', 562.0000, 'ºC'),
	(123094, 108, '2015-04-01 01:10:50.000000', 'temperatura', 570.0000, 'ºC'),
	(123095, 108, '2015-04-01 01:10:51.000000', 'temperatura', 1165.0000, 'ºC'),
	(123096, 108, '2015-04-01 01:10:52.000000', 'temperatura', 514.0000, 'ºC'),
	(123097, 108, '2015-04-01 01:10:53.000000', 'temperatura', 276.0000, 'ºC'),
	(123098, 108, '2015-04-01 01:10:54.000000', 'temperatura', 1037.0000, 'ºC'),
	(123099, 108, '2015-04-01 01:10:55.000000', 'temperatura', 757.0000, 'ºC'),
	(123100, 108, '2015-04-01 01:10:56.000000', 'temperatura', 676.0000, 'ºC'),
	(123101, 108, '2015-04-01 01:10:57.000000', 'temperatura', 1111.0000, 'ºC'),
	(123102, 108, '2015-04-01 01:10:58.000000', 'temperatura', 1127.0000, 'ºC'),
	(123103, 108, '2015-04-01 01:10:59.000000', 'temperatura', 1100.0000, 'ºC'),
	(123104, 108, '2015-04-01 01:11:00.000000', 'temperatura', 921.0000, 'ºC'),
	(123105, 108, '2015-04-01 01:11:01.000000', 'temperatura', 104.0000, 'ºC'),
	(123106, 108, '2015-04-01 01:11:02.000000', 'temperatura', 159.0000, 'ºC'),
	(123107, 108, '2015-04-01 01:11:03.000000', 'temperatura', 482.0000, 'ºC'),
	(123108, 108, '2015-04-01 01:11:04.000000', 'temperatura', 733.0000, 'ºC'),
	(123109, 108, '2015-04-01 01:11:05.000000', 'temperatura', 1019.0000, 'ºC'),
	(123110, 108, '2015-04-01 01:11:06.000000', 'temperatura', 496.0000, 'ºC'),
	(123111, 108, '2015-04-01 01:11:07.000000', 'temperatura', 625.0000, 'ºC'),
	(123112, 108, '2015-04-01 01:11:08.000000', 'temperatura', 435.0000, 'ºC'),
	(123113, 108, '2015-04-01 01:11:09.000000', 'temperatura', 302.0000, 'ºC'),
	(123114, 108, '2015-04-01 01:11:10.000000', 'temperatura', 206.0000, 'ºC'),
	(123115, 108, '2015-04-01 01:11:11.000000', 'temperatura', 126.0000, 'ºC'),
	(123116, 108, '2015-04-01 01:11:12.000000', 'temperatura', 12.0000, 'ºC'),
	(123117, 108, '2015-04-01 01:11:13.000000', 'temperatura', 880.0000, 'ºC'),
	(123118, 108, '2015-04-01 01:11:14.000000', 'temperatura', 765.0000, 'ºC'),
	(123119, 108, '2015-04-01 01:11:15.000000', 'temperatura', 1188.0000, 'ºC'),
	(123120, 108, '2015-04-01 01:11:16.000000', 'temperatura', 45.0000, 'ºC'),
	(123121, 108, '2015-04-01 01:11:17.000000', 'temperatura', 260.0000, 'ºC'),
	(123122, 108, '2015-04-01 01:11:18.000000', 'temperatura', 1164.0000, 'ºC'),
	(123123, 108, '2015-04-01 01:11:19.000000', 'temperatura', 243.0000, 'ºC'),
	(123124, 108, '2015-04-01 01:11:20.000000', 'temperatura', 123.0000, 'ºC'),
	(123125, 108, '2015-04-01 01:11:21.000000', 'temperatura', 1086.0000, 'ºC'),
	(123126, 108, '2015-04-01 01:11:22.000000', 'temperatura', 260.0000, 'ºC'),
	(123127, 108, '2015-04-01 01:11:23.000000', 'temperatura', 444.0000, 'ºC'),
	(123128, 108, '2015-04-01 01:11:24.000000', 'temperatura', 239.0000, 'ºC'),
	(123129, 108, '2015-04-01 01:11:25.000000', 'temperatura', 1065.0000, 'ºC'),
	(123130, 108, '2015-04-01 01:11:26.000000', 'temperatura', 1010.0000, 'ºC'),
	(123131, 108, '2015-04-01 01:11:27.000000', 'temperatura', 655.0000, 'ºC'),
	(123132, 108, '2015-04-01 01:11:28.000000', 'temperatura', 243.0000, 'ºC'),
	(123133, 108, '2015-04-01 01:11:29.000000', 'temperatura', 454.0000, 'ºC'),
	(123134, 108, '2015-04-01 01:11:30.000000', 'temperatura', 339.0000, 'ºC'),
	(123135, 108, '2015-04-01 01:11:31.000000', 'temperatura', 336.0000, 'ºC'),
	(123136, 108, '2015-04-01 01:11:32.000000', 'temperatura', 662.0000, 'ºC'),
	(123137, 108, '2015-04-01 01:11:33.000000', 'temperatura', 1102.0000, 'ºC'),
	(123138, 108, '2015-04-01 01:11:34.000000', 'temperatura', 1123.0000, 'ºC'),
	(123139, 108, '2015-04-01 01:11:35.000000', 'temperatura', 1110.0000, 'ºC'),
	(123140, 108, '2015-04-01 01:11:36.000000', 'temperatura', 984.0000, 'ºC'),
	(123141, 108, '2015-04-01 01:11:37.000000', 'temperatura', 388.0000, 'ºC'),
	(123142, 108, '2015-04-01 01:11:38.000000', 'temperatura', 191.0000, 'ºC'),
	(123143, 108, '2015-04-01 01:11:39.000000', 'temperatura', 989.0000, 'ºC'),
	(123144, 108, '2015-04-01 01:11:40.000000', 'temperatura', 773.0000, 'ºC'),
	(123145, 108, '2015-04-01 01:11:41.000000', 'temperatura', 897.0000, 'ºC'),
	(123146, 108, '2015-04-01 01:11:42.000000', 'temperatura', 969.0000, 'ºC'),
	(123147, 108, '2015-04-01 01:11:43.000000', 'temperatura', 953.0000, 'ºC'),
	(123148, 108, '2015-04-01 01:11:44.000000', 'temperatura', 658.0000, 'ºC'),
	(123149, 108, '2015-04-01 01:11:45.000000', 'temperatura', 431.0000, 'ºC'),
	(123150, 108, '2015-04-01 01:11:46.000000', 'temperatura', 182.0000, 'ºC'),
	(123151, 108, '2015-04-01 01:11:47.000000', 'temperatura', 820.0000, 'ºC'),
	(123152, 108, '2015-04-01 01:11:48.000000', 'temperatura', 1151.0000, 'ºC'),
	(123153, 108, '2015-04-01 01:11:49.000000', 'temperatura', 897.0000, 'ºC'),
	(123154, 108, '2015-04-01 01:11:50.000000', 'temperatura', 1033.0000, 'ºC'),
	(123155, 108, '2015-04-01 01:11:51.000000', 'temperatura', 76.0000, 'ºC'),
	(123156, 108, '2015-04-01 01:11:52.000000', 'temperatura', 879.0000, 'ºC'),
	(123157, 108, '2015-04-01 01:11:53.000000', 'temperatura', 568.0000, 'ºC'),
	(123158, 108, '2015-04-01 01:11:54.000000', 'temperatura', 205.0000, 'ºC'),
	(123159, 108, '2015-04-01 01:11:55.000000', 'temperatura', 521.0000, 'ºC'),
	(123160, 108, '2015-04-01 01:11:56.000000', 'temperatura', 789.0000, 'ºC'),
	(123161, 108, '2015-04-01 01:11:57.000000', 'temperatura', 1184.0000, 'ºC'),
	(123162, 108, '2015-04-01 01:11:58.000000', 'temperatura', 1152.0000, 'ºC'),
	(123163, 108, '2015-04-01 01:11:59.000000', 'temperatura', 1010.0000, 'ºC'),
	(123164, 108, '2015-04-01 01:12:00.000000', 'temperatura', 393.0000, 'ºC'),
	(123165, 108, '2015-04-01 01:12:01.000000', 'temperatura', 137.0000, 'ºC'),
	(123166, 108, '2015-04-01 01:12:02.000000', 'temperatura', 706.0000, 'ºC'),
	(123167, 108, '2015-04-01 01:12:03.000000', 'temperatura', 721.0000, 'ºC'),
	(123168, 108, '2015-04-01 01:12:04.000000', 'temperatura', 285.0000, 'ºC'),
	(123169, 108, '2015-04-01 01:12:05.000000', 'temperatura', 465.0000, 'ºC'),
	(123170, 108, '2015-04-01 01:12:06.000000', 'temperatura', 270.0000, 'ºC'),
	(123171, 108, '2015-04-01 01:12:07.000000', 'temperatura', 1157.0000, 'ºC'),
	(123172, 108, '2015-04-01 01:12:08.000000', 'temperatura', 172.0000, 'ºC'),
	(123173, 108, '2015-04-01 01:12:09.000000', 'temperatura', 991.0000, 'ºC'),
	(123174, 108, '2015-04-01 01:12:10.000000', 'temperatura', 841.0000, 'ºC'),
	(123175, 108, '2015-04-01 01:12:11.000000', 'temperatura', 29.0000, 'ºC'),
	(123176, 108, '2015-04-01 01:12:12.000000', 'temperatura', 26.0000, 'ºC'),
	(123177, 108, '2015-04-01 01:12:13.000000', 'temperatura', 43.0000, 'ºC'),
	(123178, 108, '2015-04-01 01:12:14.000000', 'temperatura', 136.0000, 'ºC'),
	(123179, 108, '2015-04-01 01:12:15.000000', 'temperatura', 552.0000, 'ºC'),
	(123180, 108, '2015-04-01 01:12:16.000000', 'temperatura', 1153.0000, 'ºC'),
	(123181, 108, '2015-04-01 01:12:17.000000', 'temperatura', 509.0000, 'ºC'),
	(123182, 108, '2015-04-01 01:12:18.000000', 'temperatura', 287.0000, 'ºC'),
	(123183, 108, '2015-04-01 01:12:19.000000', 'temperatura', 1106.0000, 'ºC'),
	(123184, 108, '2015-04-01 01:12:20.000000', 'temperatura', 1072.0000, 'ºC'),
	(123185, 108, '2015-04-01 01:12:21.000000', 'temperatura', 843.0000, 'ºC'),
	(123186, 108, '2015-04-01 01:12:22.000000', 'temperatura', 999.0000, 'ºC'),
	(123187, 108, '2015-04-01 01:12:23.000000', 'temperatura', 65.0000, 'ºC'),
	(123188, 108, '2015-04-01 01:12:24.000000', 'temperatura', 929.0000, 'ºC'),
	(123189, 108, '2015-04-01 01:12:25.000000', 'temperatura', 850.0000, 'ºC'),
	(123190, 108, '2015-04-01 01:12:26.000000', 'temperatura', 263.0000, 'ºC'),
	(123191, 108, '2015-04-01 01:12:27.000000', 'temperatura', 1164.0000, 'ºC'),
	(123192, 108, '2015-04-01 01:12:28.000000', 'temperatura', 235.0000, 'ºC'),
	(123193, 108, '2015-04-01 01:12:29.000000', 'temperatura', 81.0000, 'ºC'),
	(123194, 108, '2015-04-01 01:12:30.000000', 'temperatura', 903.0000, 'ºC'),
	(123195, 108, '2015-04-01 01:12:31.000000', 'temperatura', 669.0000, 'ºC'),
	(123196, 108, '2015-04-01 01:12:32.000000', 'temperatura', 640.0000, 'ºC'),
	(123197, 108, '2015-04-01 01:12:33.000000', 'temperatura', 1191.0000, 'ºC'),
	(123198, 108, '2015-04-01 01:12:34.000000', 'temperatura', 438.0000, 'ºC'),
	(123199, 108, '2015-04-01 01:12:35.000000', 'temperatura', 1017.0000, 'ºC'),
	(123200, 108, '2015-04-01 01:12:36.000000', 'temperatura', 170.0000, 'ºC'),
	(123201, 108, '2015-04-01 01:12:37.000000', 'temperatura', 201.0000, 'ºC'),
	(123202, 108, '2015-04-01 01:12:38.000000', 'temperatura', 495.0000, 'ºC'),
	(123203, 108, '2015-04-01 01:12:39.000000', 'temperatura', 674.0000, 'ºC'),
	(123204, 108, '2015-04-01 01:12:40.000000', 'temperatura', 684.0000, 'ºC'),
	(123205, 108, '2015-04-01 01:12:41.000000', 'temperatura', 197.0000, 'ºC'),
	(123206, 108, '2015-04-01 01:12:42.000000', 'temperatura', 135.0000, 'ºC'),
	(123207, 108, '2015-04-01 01:12:43.000000', 'temperatura', 83.0000, 'ºC'),
	(123208, 108, '2015-04-01 01:12:44.000000', 'temperatura', 10.0000, 'ºC'),
	(123209, 108, '2015-04-01 01:12:45.000000', 'temperatura', 1001.0000, 'ºC'),
	(123210, 108, '2015-04-01 01:12:46.000000', 'temperatura', 177.0000, 'ºC'),
	(123211, 108, '2015-04-01 01:12:47.000000', 'temperatura', 282.0000, 'ºC'),
	(123212, 108, '2015-04-01 01:12:48.000000', 'temperatura', 882.0000, 'ºC'),
	(123213, 108, '2015-04-01 01:12:49.000000', 'temperatura', 1162.0000, 'ºC'),
	(123214, 108, '2015-04-01 01:12:50.000000', 'temperatura', 764.0000, 'ºC'),
	(123215, 108, '2015-04-01 01:12:51.000000', 'temperatura', 336.0000, 'ºC'),
	(123216, 108, '2015-04-01 01:12:52.000000', 'temperatura', 590.0000, 'ºC'),
	(123217, 108, '2015-04-01 01:12:53.000000', 'temperatura', 739.0000, 'ºC'),
	(123218, 108, '2015-04-01 01:12:54.000000', 'temperatura', 728.0000, 'ºC'),
	(123219, 108, '2015-04-01 01:12:55.000000', 'temperatura', 223.0000, 'ºC'),
	(123220, 108, '2015-04-01 01:12:56.000000', 'temperatura', 133.0000, 'ºC'),
	(123221, 108, '2015-04-01 01:12:57.000000', 'temperatura', 1195.0000, 'ºC'),
	(123222, 108, '2015-04-01 01:12:58.000000', 'temperatura', 779.0000, 'ºC'),
	(123223, 108, '2015-04-01 01:12:59.000000', 'temperatura', 308.0000, 'ºC'),
	(123224, 108, '2015-04-01 01:13:00.000000', 'temperatura', 403.0000, 'ºC'),
	(123225, 108, '2015-04-01 01:13:01.000000', 'temperatura', 1094.0000, 'ºC'),
	(123226, 108, '2015-04-01 01:13:02.000000', 'temperatura', 658.0000, 'ºC'),
	(123227, 108, '2015-04-01 01:13:03.000000', 'temperatura', 12.0000, 'ºC'),
	(123228, 108, '2015-04-01 01:13:04.000000', 'temperatura', 485.0000, 'ºC'),
	(123229, 108, '2015-04-01 01:13:05.000000', 'temperatura', 1188.0000, 'ºC'),
	(123230, 108, '2015-04-01 01:13:06.000000', 'temperatura', 886.0000, 'ºC'),
	(123231, 108, '2015-04-01 01:13:07.000000', 'temperatura', 867.0000, 'ºC'),
	(123232, 108, '2015-04-01 01:13:08.000000', 'temperatura', 479.0000, 'ºC'),
	(123233, 108, '2015-04-01 01:13:09.000000', 'temperatura', 991.0000, 'ºC'),
	(123234, 108, '2015-04-01 01:13:10.000000', 'temperatura', 1122.0000, 'ºC'),
	(123235, 108, '2015-04-01 01:13:11.000000', 'temperatura', 237.0000, 'ºC'),
	(123236, 108, '2015-04-01 01:13:12.000000', 'temperatura', 217.0000, 'ºC'),
	(123237, 108, '2015-04-01 01:13:13.000000', 'temperatura', 378.0000, 'ºC'),
	(123238, 108, '2015-04-01 01:13:14.000000', 'temperatura', 37.0000, 'ºC'),
	(123239, 108, '2015-04-01 01:13:15.000000', 'temperatura', 253.0000, 'ºC'),
	(123240, 108, '2015-04-01 01:13:16.000000', 'temperatura', 1156.0000, 'ºC'),
	(123241, 108, '2015-04-01 01:13:17.000000', 'temperatura', 219.0000, 'ºC'),
	(123242, 108, '2015-04-01 01:13:18.000000', 'temperatura', 29.0000, 'ºC'),
	(123243, 108, '2015-04-01 01:13:19.000000', 'temperatura', 689.0000, 'ºC'),
	(123244, 108, '2015-04-01 01:13:20.000000', 'temperatura', 957.0000, 'ºC'),
	(123245, 108, '2015-04-01 01:13:21.000000', 'temperatura', 318.0000, 'ºC'),
	(123246, 108, '2015-04-01 01:13:22.000000', 'temperatura', 1121.0000, 'ºC'),
	(123247, 108, '2015-04-01 01:13:23.000000', 'temperatura', 1049.0000, 'ºC'),
	(123248, 108, '2015-04-01 01:13:24.000000', 'temperatura', 683.0000, 'ºC'),
	(123249, 108, '2015-04-01 01:13:25.000000', 'temperatura', 271.0000, 'ºC'),
	(123250, 108, '2015-04-01 01:13:26.000000', 'temperatura', 504.0000, 'ºC'),
	(123251, 108, '2015-04-01 01:13:27.000000', 'temperatura', 507.0000, 'ºC'),
	(123252, 108, '2015-04-01 01:13:28.000000', 'temperatura', 1026.0000, 'ºC'),
	(123253, 108, '2015-04-01 01:13:29.000000', 'temperatura', 9.0000, 'ºC'),
	(123254, 108, '2015-04-01 01:13:30.000000', 'temperatura', 568.0000, 'ºC'),
	(123255, 108, '2015-04-01 01:13:31.000000', 'temperatura', 412.0000, 'ºC'),
	(123256, 108, '2015-04-01 01:13:32.000000', 'temperatura', 358.0000, 'ºC'),
	(123257, 108, '2015-04-01 01:13:33.000000', 'temperatura', 553.0000, 'ºC'),
	(123258, 108, '2015-04-01 01:13:34.000000', 'temperatura', 491.0000, 'ºC'),
	(123259, 108, '2015-04-01 01:13:35.000000', 'temperatura', 795.0000, 'ºC'),
	(123260, 108, '2015-04-01 01:13:36.000000', 'temperatura', 105.0000, 'ºC'),
	(123261, 108, '2015-04-01 01:13:37.000000', 'temperatura', 539.0000, 'ºC'),
	(123262, 108, '2015-04-01 01:13:38.000000', 'temperatura', 1181.0000, 'ºC'),
	(123263, 108, '2015-04-01 01:13:39.000000', 'temperatura', 689.0000, 'ºC'),
	(123264, 108, '2015-04-01 01:13:40.000000', 'temperatura', 1104.0000, 'ºC'),
	(123265, 108, '2015-04-01 01:13:41.000000', 'temperatura', 1053.0000, 'ºC'),
	(123266, 108, '2015-04-01 01:13:42.000000', 'temperatura', 755.0000, 'ºC'),
	(123267, 108, '2015-04-01 01:13:43.000000', 'temperatura', 615.0000, 'ºC'),
	(123268, 108, '2015-04-01 01:13:44.000000', 'temperatura', 810.0000, 'ºC'),
	(123269, 108, '2015-04-01 01:13:45.000000', 'temperatura', 1006.0000, 'ºC'),
	(123270, 108, '2015-04-01 01:13:46.000000', 'temperatura', 202.0000, 'ºC'),
	(123271, 108, '2015-04-01 01:13:47.000000', 'temperatura', 391.0000, 'ºC'),
	(123272, 108, '2015-04-01 01:13:48.000000', 'temperatura', 148.0000, 'ºC'),
	(123273, 108, '2015-04-01 01:13:49.000000', 'temperatura', 770.0000, 'ºC'),
	(123274, 108, '2015-04-01 01:13:50.000000', 'temperatura', 1005.0000, 'ºC'),
	(123275, 108, '2015-04-01 01:13:51.000000', 'temperatura', 315.0000, 'ºC'),
	(123276, 108, '2015-04-01 01:13:52.000000', 'temperatura', 963.0000, 'ºC'),
	(123277, 108, '2015-04-01 01:13:53.000000', 'temperatura', 270.0000, 'ºC'),
	(123278, 108, '2015-04-01 01:13:54.000000', 'temperatura', 860.0000, 'ºC'),
	(123279, 108, '2015-04-01 01:13:55.000000', 'temperatura', 1093.0000, 'ºC'),
	(123280, 108, '2015-04-01 01:13:56.000000', 'temperatura', 482.0000, 'ºC'),
	(123281, 108, '2015-04-01 01:13:57.000000', 'temperatura', 334.0000, 'ºC'),
	(123282, 108, '2015-04-01 01:13:58.000000', 'temperatura', 223.0000, 'ºC'),
	(123283, 108, '2015-04-01 01:13:59.000000', 'temperatura', 114.0000, 'ºC'),
	(123284, 108, '2015-04-01 01:14:00.000000', 'temperatura', 1103.0000, 'ºC'),
	(123285, 108, '2015-04-01 01:14:01.000000', 'temperatura', 372.0000, 'ºC'),
	(123286, 108, '2015-04-01 01:14:02.000000', 'temperatura', 952.0000, 'ºC'),
	(123287, 108, '2015-04-01 01:14:03.000000', 'temperatura', 44.0000, 'ºC'),
	(123288, 108, '2015-04-01 01:14:04.000000', 'temperatura', 966.0000, 'ºC'),
	(123289, 108, '2015-04-01 01:14:05.000000', 'temperatura', 1098.0000, 'ºC'),
	(123290, 108, '2015-04-01 01:14:06.000000', 'temperatura', 192.0000, 'ºC'),
	(123291, 108, '2015-04-01 01:14:07.000000', 'temperatura', 67.0000, 'ºC'),
	(123292, 108, '2015-04-01 01:14:08.000000', 'temperatura', 961.0000, 'ºC'),
	(123293, 108, '2015-04-01 01:14:09.000000', 'temperatura', 1003.0000, 'ºC'),
	(123294, 108, '2015-04-01 01:14:10.000000', 'temperatura', 935.0000, 'ºC'),
	(123295, 108, '2015-04-01 01:14:11.000000', 'temperatura', 464.0000, 'ºC'),
	(123296, 108, '2015-04-01 01:14:12.000000', 'temperatura', 716.0000, 'ºC'),
	(123297, 108, '2015-04-01 01:14:13.000000', 'temperatura', 988.0000, 'ºC'),
	(123298, 108, '2015-04-01 01:14:14.000000', 'temperatura', 392.0000, 'ºC'),
	(123299, 108, '2015-04-01 01:14:15.000000', 'temperatura', 197.0000, 'ºC'),
	(123300, 108, '2015-04-01 01:14:16.000000', 'temperatura', 1009.0000, 'ºC'),
	(123301, 108, '2015-04-01 01:14:17.000000', 'temperatura', 854.0000, 'ºC'),
	(123302, 108, '2015-04-01 01:14:18.000000', 'temperatura', 42.0000, 'ºC'),
	(123303, 108, '2015-04-01 01:14:19.000000', 'temperatura', 52.0000, 'ºC'),
	(123304, 108, '2015-04-01 01:14:20.000000', 'temperatura', 134.0000, 'ºC'),
	(123305, 108, '2015-04-01 01:14:21.000000', 'temperatura', 512.0000, 'ºC'),
	(123306, 108, '2015-04-01 01:14:22.000000', 'temperatura', 961.0000, 'ºC'),
	(123307, 108, '2015-04-01 01:14:23.000000', 'temperatura', 868.0000, 'ºC'),
	(123308, 108, '2015-04-01 01:14:24.000000', 'temperatura', 258.0000, 'ºC'),
	(123309, 108, '2015-04-01 01:14:25.000000', 'temperatura', 1086.0000, 'ºC'),
	(123310, 108, '2015-04-01 01:14:26.000000', 'temperatura', 1057.0000, 'ºC'),
	(123311, 108, '2015-04-01 01:14:27.000000', 'temperatura', 826.0000, 'ºC'),
	(123312, 108, '2015-04-01 01:14:28.000000', 'temperatura', 962.0000, 'ºC'),
	(123313, 108, '2015-04-01 01:14:29.000000', 'temperatura', 1133.0000, 'ºC'),
	(123314, 108, '2015-04-01 01:14:30.000000', 'temperatura', 378.0000, 'ºC'),
	(123315, 108, '2015-04-01 01:14:31.000000', 'temperatura', 891.0000, 'ºC'),
	(123316, 108, '2015-04-01 01:14:32.000000', 'temperatura', 921.0000, 'ºC'),
	(123317, 108, '2015-04-01 01:14:33.000000', 'temperatura', 734.0000, 'ºC'),
	(123318, 108, '2015-04-01 01:14:34.000000', 'temperatura', 907.0000, 'ºC'),
	(123319, 108, '2015-04-01 01:14:35.000000', 'temperatura', 1133.0000, 'ºC'),
	(123320, 108, '2015-04-01 01:14:36.000000', 'temperatura', 546.0000, 'ºC'),
	(123321, 108, '2015-04-01 01:14:37.000000', 'temperatura', 531.0000, 'ºC'),
	(123322, 108, '2015-04-01 01:14:38.000000', 'temperatura', 1015.0000, 'ºC'),
	(123323, 108, '2015-04-01 01:14:39.000000', 'temperatura', 1086.0000, 'ºC'),
	(123324, 108, '2015-04-01 01:14:40.000000', 'temperatura', 1183.0000, 'ºC'),
	(123325, 108, '2015-04-01 01:14:41.000000', 'temperatura', 258.0000, 'ºC'),
	(123326, 108, '2015-04-01 01:14:42.000000', 'temperatura', 142.0000, 'ºC'),
	(123327, 108, '2015-04-01 01:14:43.000000', 'temperatura', 1135.0000, 'ºC'),
	(123328, 108, '2015-04-01 01:14:44.000000', 'temperatura', 450.0000, 'ºC'),
	(123329, 108, '2015-04-01 01:14:45.000000', 'temperatura', 45.0000, 'ºC'),
	(123330, 108, '2015-04-01 01:14:46.000000', 'temperatura', 76.0000, 'ºC'),
	(123331, 108, '2015-04-01 01:14:47.000000', 'temperatura', 246.0000, 'ºC'),
	(123332, 108, '2015-04-01 01:14:48.000000', 'temperatura', 1004.0000, 'ºC'),
	(123333, 108, '2015-04-01 01:14:49.000000', 'temperatura', 681.0000, 'ºC'),
	(123334, 108, '2015-04-01 01:14:50.000000', 'temperatura', 395.0000, 'ºC'),
	(123335, 108, '2015-04-01 01:14:51.000000', 'temperatura', 1132.0000, 'ºC'),
	(123336, 108, '2015-04-01 01:14:52.000000', 'temperatura', 873.0000, 'ºC'),
	(123337, 108, '2015-04-01 01:14:53.000000', 'temperatura', 972.0000, 'ºC'),
	(123338, 108, '2015-04-01 01:14:54.000000', 'temperatura', 1040.0000, 'ºC'),
	(123339, 108, '2015-04-01 01:14:55.000000', 'temperatura', 1084.0000, 'ºC'),
	(123340, 108, '2015-04-01 01:14:56.000000', 'temperatura', 1099.0000, 'ºC'),
	(123341, 108, '2015-04-01 01:14:57.000000', 'temperatura', 1046.0000, 'ºC'),
	(123342, 108, '2015-04-01 01:14:58.000000', 'temperatura', 733.0000, 'ºC'),
	(123343, 108, '2015-04-01 01:14:59.000000', 'temperatura', 527.0000, 'ºC'),
	(123344, 108, '2015-04-01 01:15:00.000000', 'temperatura', 437.0000, 'ºC'),
	(123345, 108, '2015-04-01 01:15:01.000000', 'temperatura', 604.0000, 'ºC'),
	(123346, 108, '2015-04-01 01:15:02.000000', 'temperatura', 510.0000, 'ºC'),
	(123347, 108, '2015-04-01 01:15:03.000000', 'temperatura', 740.0000, 'ºC'),
	(123348, 108, '2015-04-01 01:15:04.000000', 'temperatura', 968.0000, 'ºC'),
	(123349, 108, '2015-04-01 01:15:05.000000', 'temperatura', 222.0000, 'ºC'),
	(123350, 108, '2015-04-01 01:15:06.000000', 'temperatura', 607.0000, 'ºC'),
	(123351, 108, '2015-04-01 01:15:07.000000', 'temperatura', 1168.0000, 'ºC'),
	(123352, 108, '2015-04-01 01:15:08.000000', 'temperatura', 421.0000, 'ºC'),
	(123353, 108, '2015-04-01 01:15:09.000000', 'temperatura', 1000.0000, 'ºC'),
	(123354, 108, '2015-04-01 01:15:10.000000', 'temperatura', 138.0000, 'ºC'),
	(123355, 108, '2015-04-01 01:15:11.000000', 'temperatura', 89.0000, 'ºC'),
	(123356, 108, '2015-04-01 01:15:12.000000', 'temperatura', 32.0000, 'ºC'),
	(123357, 108, '2015-04-01 01:15:13.000000', 'temperatura', 1092.0000, 'ºC'),
	(123358, 108, '2015-04-01 01:15:14.000000', 'temperatura', 566.0000, 'ºC'),
	(123359, 108, '2015-04-01 01:15:15.000000', 'temperatura', 756.0000, 'ºC'),
	(123360, 108, '2015-04-01 01:15:16.000000', 'temperatura', 880.0000, 'ºC'),
	(123361, 108, '2015-04-01 01:15:17.000000', 'temperatura', 932.0000, 'ºC'),
	(123362, 108, '2015-04-01 01:15:18.000000', 'temperatura', 820.0000, 'ºC'),
	(123363, 108, '2015-04-01 01:15:19.000000', 'temperatura', 104.0000, 'ºC'),
	(123364, 108, '2015-04-01 01:15:20.000000', 'temperatura', 460.0000, 'ºC'),
	(123365, 108, '2015-04-01 01:15:21.000000', 'temperatura', 790.0000, 'ºC'),
	(123366, 108, '2015-04-01 01:15:22.000000', 'temperatura', 169.0000, 'ºC'),
	(123367, 108, '2015-04-01 01:15:23.000000', 'temperatura', 875.0000, 'ºC'),
	(123368, 108, '2015-04-01 01:15:24.000000', 'temperatura', 269.0000, 'ºC'),
	(123369, 108, '2015-04-01 01:15:25.000000', 'temperatura', 1121.0000, 'ºC'),
	(123370, 108, '2015-04-01 01:15:26.000000', 'temperatura', 1197.0000, 'ºC'),
	(123371, 108, '2015-04-01 01:15:27.000000', 'temperatura', 221.0000, 'ºC'),
	(123372, 108, '2015-04-01 01:15:28.000000', 'temperatura', 1118.0000, 'ºC'),
	(123373, 108, '2015-04-01 01:15:29.000000', 'temperatura', 128.0000, 'ºC'),
	(123374, 108, '2015-04-01 01:15:30.000000', 'temperatura', 884.0000, 'ºC'),
	(123375, 108, '2015-04-01 01:15:31.000000', 'temperatura', 438.0000, 'ºC'),
	(123376, 108, '2015-04-01 01:15:32.000000', 'temperatura', 739.0000, 'ºC'),
	(123377, 108, '2015-04-01 01:15:33.000000', 'temperatura', 1182.0000, 'ºC'),
	(123378, 108, '2015-04-01 01:15:34.000000', 'temperatura', 91.0000, 'ºC'),
	(123379, 108, '2015-04-01 01:15:35.000000', 'temperatura', 509.0000, 'ºC'),
	(123380, 108, '2015-04-01 01:15:36.000000', 'temperatura', 1075.0000, 'ºC'),
	(123381, 108, '2015-04-01 01:15:37.000000', 'temperatura', 248.0000, 'ºC'),
	(123382, 108, '2015-04-01 01:15:38.000000', 'temperatura', 416.0000, 'ºC'),
	(123383, 108, '2015-04-01 01:15:39.000000', 'temperatura', 135.0000, 'ºC'),
	(123384, 108, '2015-04-01 01:15:40.000000', 'temperatura', 629.0000, 'ºC'),
	(123385, 108, '2015-04-01 01:15:41.000000', 'temperatura', 341.0000, 'ºC'),
	(123386, 108, '2015-04-01 01:15:42.000000', 'temperatura', 1019.0000, 'ºC'),
	(123387, 108, '2015-04-01 01:15:43.000000', 'temperatura', 472.0000, 'ºC'),
	(123388, 108, '2015-04-01 01:15:44.000000', 'temperatura', 501.0000, 'ºC'),
	(123389, 108, '2015-04-01 01:15:45.000000', 'temperatura', 1093.0000, 'ºC'),
	(123390, 108, '2015-04-01 01:15:46.000000', 'temperatura', 361.0000, 'ºC'),
	(123391, 108, '2015-04-01 01:15:47.000000', 'temperatura', 926.0000, 'ºC'),
	(123392, 108, '2015-04-01 01:15:48.000000', 'temperatura', 1147.0000, 'ºC'),
	(123393, 108, '2015-04-01 01:15:49.000000', 'temperatura', 556.0000, 'ºC'),
	(123394, 108, '2015-04-01 01:15:50.000000', 'temperatura', 541.0000, 'ºC'),
	(123395, 108, '2015-04-01 01:15:51.000000', 'temperatura', 1039.0000, 'ºC'),
	(123396, 108, '2015-04-01 01:15:52.000000', 'temperatura', 1171.0000, 'ºC'),
	(123397, 108, '2015-04-01 01:15:53.000000', 'temperatura', 339.0000, 'ºC'),
	(123398, 108, '2015-04-01 01:15:54.000000', 'temperatura', 581.0000, 'ºC'),
	(123399, 108, '2015-04-01 01:15:55.000000', 'temperatura', 688.0000, 'ºC'),
	(123400, 108, '2015-04-01 01:15:56.000000', 'temperatura', 500.0000, 'ºC'),
	(123401, 108, '2015-04-01 01:15:57.000000', 'temperatura', 434.0000, 'ºC'),
	(123402, 108, '2015-04-01 01:15:58.000000', 'temperatura', 670.0000, 'ºC'),
	(123403, 108, '2015-04-01 01:15:59.000000', 'temperatura', 849.0000, 'ºC'),
	(123404, 108, '2015-04-01 01:16:00.000000', 'temperatura', 1038.0000, 'ºC'),
	(123405, 108, '2015-04-01 01:16:01.000000', 'temperatura', 240.0000, 'ºC'),
	(123406, 108, '2015-04-01 01:16:02.000000', 'temperatura', 489.0000, 'ºC'),
	(123407, 108, '2015-04-01 01:16:03.000000', 'temperatura', 524.0000, 'ºC'),
	(123408, 108, '2015-04-01 01:16:04.000000', 'temperatura', 1153.0000, 'ºC'),
	(123409, 108, '2015-04-01 01:16:05.000000', 'temperatura', 593.0000, 'ºC'),
	(123410, 108, '2015-04-01 01:16:06.000000', 'temperatura', 708.0000, 'ºC'),
	(123411, 108, '2015-04-01 01:16:07.000000', 'temperatura', 560.0000, 'ºC'),
	(123412, 108, '2015-04-01 01:16:08.000000', 'temperatura', 676.0000, 'ºC'),
	(123413, 108, '2015-04-01 01:16:09.000000', 'temperatura', 499.0000, 'ºC'),
	(123414, 108, '2015-04-01 01:16:10.000000', 'temperatura', 471.0000, 'ºC'),
	(123415, 108, '2015-04-01 01:16:11.000000', 'temperatura', 856.0000, 'ºC'),
	(123416, 108, '2015-04-01 01:16:12.000000', 'temperatura', 467.0000, 'ºC'),
	(123417, 108, '2015-04-01 01:16:13.000000', 'temperatura', 969.0000, 'ºC'),
	(123418, 108, '2015-04-01 01:16:14.000000', 'temperatura', 1046.0000, 'ºC'),
	(123419, 108, '2015-04-01 01:16:15.000000', 'temperatura', 1123.0000, 'ºC'),
	(123420, 108, '2015-04-01 01:16:16.000000', 'temperatura', 75.0000, 'ºC'),
	(123421, 108, '2015-04-01 01:16:17.000000', 'temperatura', 608.0000, 'ºC'),
	(123422, 108, '2015-04-01 01:16:18.000000', 'temperatura', 413.0000, 'ºC'),
	(123423, 108, '2015-04-01 01:16:19.000000', 'temperatura', 245.0000, 'ºC'),
	(123424, 108, '2015-04-01 01:16:20.000000', 'temperatura', 1184.0000, 'ºC'),
	(123425, 108, '2015-04-01 01:16:21.000000', 'temperatura', 388.0000, 'ºC'),
	(123426, 108, '2015-04-01 01:16:22.000000', 'temperatura', 789.0000, 'ºC'),
	(123427, 108, '2015-04-01 01:16:23.000000', 'temperatura', 380.0000, 'ºC'),
	(123428, 108, '2015-04-01 01:16:24.000000', 'temperatura', 734.0000, 'ºC'),
	(123429, 108, '2015-04-01 01:16:25.000000', 'temperatura', 130.0000, 'ºC'),
	(123430, 108, '2015-04-01 01:16:26.000000', 'temperatura', 849.0000, 'ºC'),
	(123431, 108, '2015-04-01 01:16:27.000000', 'temperatura', 255.0000, 'ºC'),
	(123432, 108, '2015-04-01 01:16:28.000000', 'temperatura', 1129.0000, 'ºC'),
	(123433, 108, '2015-04-01 01:16:29.000000', 'temperatura', 79.0000, 'ºC'),
	(123434, 108, '2015-04-01 01:16:30.000000', 'temperatura', 610.0000, 'ºC'),
	(123435, 108, '2015-04-01 01:16:31.000000', 'temperatura', 412.0000, 'ºC'),
	(123436, 108, '2015-04-01 01:16:32.000000', 'temperatura', 229.0000, 'ºC'),
	(123437, 108, '2015-04-01 01:16:33.000000', 'temperatura', 1112.0000, 'ºC'),
	(123438, 108, '2015-04-01 01:16:34.000000', 'temperatura', 73.0000, 'ºC'),
	(123439, 108, '2015-04-01 01:16:35.000000', 'temperatura', 628.0000, 'ºC'),
	(123440, 108, '2015-04-01 01:16:36.000000', 'temperatura', 522.0000, 'ºC'),
	(123441, 108, '2015-04-01 01:16:37.000000', 'temperatura', 728.0000, 'ºC'),
	(123442, 108, '2015-04-01 01:16:38.000000', 'temperatura', 873.0000, 'ºC'),
	(123443, 108, '2015-04-01 01:16:39.000000', 'temperatura', 983.0000, 'ºC'),
	(123444, 108, '2015-04-01 01:16:40.000000', 'temperatura', 1095.0000, 'ºC'),
	(123445, 108, '2015-04-01 01:16:41.000000', 'temperatura', 127.0000, 'ºC'),
	(123446, 108, '2015-04-01 01:16:42.000000', 'temperatura', 950.0000, 'ºC'),
	(123447, 108, '2015-04-01 01:16:43.000000', 'temperatura', 768.0000, 'ºC'),
	(123448, 108, '2015-04-01 01:16:44.000000', 'temperatura', 993.0000, 'ºC'),
	(123449, 108, '2015-04-01 01:16:45.000000', 'temperatura', 259.0000, 'ºC'),
	(123450, 108, '2015-04-01 01:16:46.000000', 'temperatura', 718.0000, 'ºC'),
	(123451, 108, '2015-04-01 01:16:47.000000', 'temperatura', 412.0000, 'ºC'),
	(123452, 108, '2015-04-01 01:16:48.000000', 'temperatura', 1108.0000, 'ºC'),
	(123453, 108, '2015-04-01 01:16:49.000000', 'temperatura', 704.0000, 'ºC'),
	(123454, 108, '2015-04-01 01:16:50.000000', 'temperatura', 199.0000, 'ºC'),
	(123455, 108, '2015-04-01 01:16:51.000000', 'temperatura', 80.0000, 'ºC'),
	(123456, 108, '2015-04-01 01:16:52.000000', 'temperatura', 1005.0000, 'ºC'),
	(123457, 108, '2015-04-01 01:16:53.000000', 'temperatura', 1186.0000, 'ºC'),
	(123458, 108, '2015-04-01 01:16:54.000000', 'temperatura', 515.0000, 'ºC'),
	(123459, 108, '2015-04-01 01:16:55.000000', 'temperatura', 216.0000, 'ºC'),
	(123460, 108, '2015-04-01 01:16:56.000000', 'temperatura', 736.0000, 'ºC'),
	(123461, 108, '2015-04-01 01:16:57.000000', 'temperatura', 634.0000, 'ºC'),
	(123462, 108, '2015-04-01 01:16:58.000000', 'temperatura', 963.0000, 'ºC'),
	(123463, 108, '2015-04-01 01:16:59.000000', 'temperatura', 513.0000, 'ºC'),
	(123464, 108, '2015-04-01 01:17:00.000000', 'temperatura', 874.0000, 'ºC'),
	(123465, 108, '2015-04-01 01:17:01.000000', 'temperatura', 434.0000, 'ºC'),
	(123466, 108, '2015-04-01 01:17:02.000000', 'temperatura', 750.0000, 'ºC'),
	(123467, 108, '2015-04-01 01:17:03.000000', 'temperatura', 46.0000, 'ºC'),
	(123468, 108, '2015-04-01 01:17:04.000000', 'temperatura', 382.0000, 'ºC'),
	(123469, 108, '2015-04-01 01:17:05.000000', 'temperatura', 574.0000, 'ºC'),
	(123470, 108, '2015-04-01 01:17:06.000000', 'temperatura', 522.0000, 'ºC'),
	(123471, 108, '2015-04-01 01:17:07.000000', 'temperatura', 891.0000, 'ºC'),
	(123472, 108, '2015-04-01 01:17:08.000000', 'temperatura', 488.0000, 'ºC'),
	(123473, 108, '2015-04-01 01:17:09.000000', 'temperatura', 967.0000, 'ºC'),
	(123474, 108, '2015-04-01 01:17:10.000000', 'temperatura', 974.0000, 'ºC'),
	(123475, 108, '2015-04-01 01:17:11.000000', 'temperatura', 768.0000, 'ºC'),
	(123476, 108, '2015-04-01 01:17:12.000000', 'temperatura', 919.0000, 'ºC'),
	(123477, 108, '2015-04-01 01:17:13.000000', 'temperatura', 1090.0000, 'ºC'),
	(123478, 108, '2015-04-01 01:17:14.000000', 'temperatura', 296.0000, 'ºC'),
	(123479, 108, '2015-04-01 01:17:15.000000', 'temperatura', 610.0000, 'ºC'),
	(123480, 108, '2015-04-01 01:17:16.000000', 'temperatura', 960.0000, 'ºC'),
	(123481, 108, '2015-04-01 01:17:17.000000', 'temperatura', 572.0000, 'ºC'),
	(123482, 108, '2015-04-01 01:17:18.000000', 'temperatura', 1182.0000, 'ºC'),
	(123483, 108, '2015-04-01 01:17:19.000000', 'temperatura', 594.0000, 'ºC'),
	(123484, 108, '2015-04-01 01:17:20.000000', 'temperatura', 624.0000, 'ºC'),
	(123485, 108, '2015-04-01 01:17:21.000000', 'temperatura', 141.0000, 'ºC'),
	(123486, 108, '2015-04-01 01:17:22.000000', 'temperatura', 30.0000, 'ºC'),
	(123487, 108, '2015-04-01 01:17:23.000000', 'temperatura', 929.0000, 'ºC'),
	(123488, 108, '2015-04-01 01:17:24.000000', 'temperatura', 954.0000, 'ºC'),
	(123489, 108, '2015-04-01 01:17:25.000000', 'temperatura', 786.0000, 'ºC'),
	(123490, 108, '2015-04-01 01:17:26.000000', 'temperatura', 1067.0000, 'ºC'),
	(123491, 108, '2015-04-01 01:17:27.000000', 'temperatura', 577.0000, 'ºC'),
	(123492, 108, '2015-04-01 01:17:28.000000', 'temperatura', 885.0000, 'ºC'),
	(123493, 108, '2015-04-01 01:17:29.000000', 'temperatura', 294.0000, 'ºC'),
	(123494, 108, '2015-04-01 01:17:30.000000', 'temperatura', 17.0000, 'ºC'),
	(123495, 108, '2015-04-01 01:17:31.000000', 'temperatura', 404.0000, 'ºC'),
	(123496, 108, '2015-04-01 01:17:32.000000', 'temperatura', 767.0000, 'ºC'),
	(123497, 108, '2015-04-01 01:17:33.000000', 'temperatura', 225.0000, 'ºC'),
	(123498, 108, '2015-04-01 01:17:34.000000', 'temperatura', 23.0000, 'ºC'),
	(123499, 108, '2015-04-01 01:17:35.000000', 'temperatura', 643.0000, 'ºC'),
	(123500, 108, '2015-04-01 01:17:36.000000', 'temperatura', 745.0000, 'ºC'),
	(123501, 108, '2015-04-01 01:17:37.000000', 'temperatura', 598.0000, 'ºC'),
	(123502, 108, '2015-04-01 01:17:38.000000', 'temperatura', 754.0000, 'ºC'),
	(123503, 108, '2015-04-01 01:17:39.000000', 'temperatura', 775.0000, 'ºC'),
	(123504, 108, '2015-04-01 01:17:40.000000', 'temperatura', 415.0000, 'ºC'),
	(123505, 108, '2015-04-01 01:17:41.000000', 'temperatura', 951.0000, 'ºC'),
	(123506, 108, '2015-04-01 01:17:42.000000', 'temperatura', 1111.0000, 'ºC'),
	(123507, 108, '2015-04-01 01:17:43.000000', 'temperatura', 302.0000, 'ºC'),
	(123508, 108, '2015-04-01 01:17:44.000000', 'temperatura', 577.0000, 'ºC'),
	(123509, 108, '2015-04-01 01:17:45.000000', 'temperatura', 778.0000, 'ºC'),
	(123510, 108, '2015-04-01 01:17:46.000000', 'temperatura', 961.0000, 'ºC'),
	(123511, 108, '2015-04-01 01:17:47.000000', 'temperatura', 72.0000, 'ºC'),
	(123512, 108, '2015-04-01 01:17:48.000000', 'temperatura', 1075.0000, 'ºC'),
	(123513, 108, '2015-04-01 01:17:49.000000', 'temperatura', 363.0000, 'ºC'),
	(123514, 108, '2015-04-01 01:17:50.000000', 'temperatura', 989.0000, 'ºC'),
	(123515, 108, '2015-04-01 01:17:51.000000', 'temperatura', 256.0000, 'ºC'),
	(123516, 108, '2015-04-01 01:17:52.000000', 'temperatura', 716.0000, 'ºC'),
	(123517, 108, '2015-04-01 01:17:53.000000', 'temperatura', 411.0000, 'ºC'),
	(123518, 108, '2015-04-01 01:17:54.000000', 'temperatura', 1108.0000, 'ºC'),
	(123519, 108, '2015-04-01 01:17:55.000000', 'temperatura', 705.0000, 'ºC'),
	(123520, 108, '2015-04-01 01:17:56.000000', 'temperatura', 203.0000, 'ºC'),
	(123521, 108, '2015-04-01 01:17:57.000000', 'temperatura', 101.0000, 'ºC'),
	(123522, 108, '2015-04-01 01:17:58.000000', 'temperatura', 1096.0000, 'ºC'),
	(123523, 108, '2015-04-01 01:17:59.000000', 'temperatura', 379.0000, 'ºC'),
	(123524, 108, '2015-04-01 01:18:00.000000', 'temperatura', 1007.0000, 'ºC'),
	(123525, 108, '2015-04-01 01:18:01.000000', 'temperatura', 298.0000, 'ºC'),
	(123526, 108, '2015-04-01 01:18:02.000000', 'temperatura', 870.0000, 'ºC'),
	(123527, 108, '2015-04-01 01:18:03.000000', 'temperatura', 1056.0000, 'ºC'),
	(123528, 108, '2015-04-01 01:18:04.000000', 'temperatura', 269.0000, 'ºC'),
	(123529, 108, '2015-04-01 01:18:05.000000', 'temperatura', 578.0000, 'ºC'),
	(123530, 108, '2015-04-01 01:18:06.000000', 'temperatura', 882.0000, 'ºC'),
	(123531, 108, '2015-04-01 01:18:07.000000', 'temperatura', 277.0000, 'ºC'),
	(123532, 108, '2015-04-01 01:18:08.000000', 'temperatura', 1141.0000, 'ºC'),
	(123533, 108, '2015-04-01 01:18:09.000000', 'temperatura', 75.0000, 'ºC'),
	(123534, 108, '2015-04-01 01:18:10.000000', 'temperatura', 552.0000, 'ºC'),
	(123535, 108, '2015-04-01 01:18:11.000000', 'temperatura', 134.0000, 'ºC'),
	(123536, 108, '2015-04-01 01:18:12.000000', 'temperatura', 214.0000, 'ºC'),
	(123537, 108, '2015-04-01 01:18:13.000000', 'temperatura', 670.0000, 'ºC'),
	(123538, 108, '2015-04-01 01:18:14.000000', 'temperatura', 309.0000, 'ºC'),
	(123539, 108, '2015-04-01 01:18:15.000000', 'temperatura', 735.0000, 'ºC'),
	(123540, 108, '2015-04-01 01:18:16.000000', 'temperatura', 348.0000, 'ºC'),
	(123541, 108, '2015-04-01 01:18:17.000000', 'temperatura', 734.0000, 'ºC'),
	(123542, 108, '2015-04-01 01:18:18.000000', 'temperatura', 229.0000, 'ºC'),
	(123543, 108, '2015-04-01 01:18:19.000000', 'temperatura', 141.0000, 'ºC'),
	(123544, 108, '2015-04-01 01:18:20.000000', 'temperatura', 21.0000, 'ºC'),
	(123545, 108, '2015-04-01 01:18:21.000000', 'temperatura', 881.0000, 'ºC'),
	(123546, 108, '2015-04-01 01:18:22.000000', 'temperatura', 745.0000, 'ºC'),
	(123547, 108, '2015-04-01 01:18:23.000000', 'temperatura', 1079.0000, 'ºC'),
	(123548, 108, '2015-04-01 01:18:24.000000', 'temperatura', 762.0000, 'ºC'),
	(123549, 108, '2015-04-01 01:18:25.000000', 'temperatura', 573.0000, 'ºC'),
	(123550, 108, '2015-04-01 01:18:26.000000', 'temperatura', 579.0000, 'ºC'),
	(123551, 108, '2015-04-01 01:18:27.000000', 'temperatura', 1177.0000, 'ºC'),
	(123552, 108, '2015-04-01 01:18:28.000000', 'temperatura', 548.0000, 'ºC'),
	(123553, 108, '2015-04-01 01:18:29.000000', 'temperatura', 411.0000, 'ºC'),
	(123554, 108, '2015-04-01 01:18:30.000000', 'temperatura', 410.0000, 'ºC'),
	(123555, 108, '2015-04-01 01:18:31.000000', 'temperatura', 817.0000, 'ºC'),
	(123556, 108, '2015-04-01 01:18:32.000000', 'temperatura', 457.0000, 'ºC'),
	(123557, 108, '2015-04-01 01:18:33.000000', 'temperatura', 1034.0000, 'ºC'),
	(123558, 108, '2015-04-01 01:18:34.000000', 'temperatura', 198.0000, 'ºC'),
	(123559, 108, '2015-04-01 01:18:35.000000', 'temperatura', 291.0000, 'ºC'),
	(123560, 108, '2015-04-01 01:18:36.000000', 'temperatura', 859.0000, 'ºC'),
	(123561, 108, '2015-04-01 01:18:37.000000', 'temperatura', 1025.0000, 'ºC'),
	(123562, 108, '2015-04-01 01:18:38.000000', 'temperatura', 149.0000, 'ºC'),
	(123563, 108, '2015-04-01 01:18:39.000000', 'temperatura', 70.0000, 'ºC'),
	(123564, 108, '2015-04-01 01:18:40.000000', 'temperatura', 1103.0000, 'ºC'),
	(123565, 108, '2015-04-01 01:18:41.000000', 'temperatura', 507.0000, 'ºC'),
	(123566, 108, '2015-04-01 01:18:42.000000', 'temperatura', 424.0000, 'ºC'),
	(123567, 108, '2015-04-01 01:18:43.000000', 'temperatura', 600.0000, 'ºC'),
	(123568, 108, '2015-04-01 01:18:44.000000', 'temperatura', 529.0000, 'ºC'),
	(123569, 108, '2015-04-01 01:18:45.000000', 'temperatura', 843.0000, 'ºC'),
	(123570, 108, '2015-04-01 01:18:46.000000', 'temperatura', 232.0000, 'ºC'),
	(123571, 108, '2015-04-01 01:18:47.000000', 'temperatura', 1028.0000, 'ºC'),
	(123572, 108, '2015-04-01 01:18:48.000000', 'temperatura', 848.0000, 'ºC'),
	(123573, 108, '2015-04-01 01:18:49.000000', 'temperatura', 1155.0000, 'ºC'),
	(123574, 108, '2015-04-01 01:18:50.000000', 'temperatura', 831.0000, 'ºC'),
	(123575, 108, '2015-04-01 01:18:51.000000', 'temperatura', 691.0000, 'ºC'),
	(123576, 108, '2015-04-01 01:18:52.000000', 'temperatura', 964.0000, 'ºC'),
	(123577, 108, '2015-04-01 01:18:53.000000', 'temperatura', 345.0000, 'ºC'),
	(123578, 108, '2015-04-01 01:18:54.000000', 'temperatura', 35.0000, 'ºC'),
	(123579, 108, '2015-04-01 01:18:55.000000', 'temperatura', 342.0000, 'ºC'),
	(123580, 108, '2015-04-01 01:18:56.000000', 'temperatura', 403.0000, 'ºC'),
	(123581, 108, '2015-04-01 01:18:57.000000', 'temperatura', 992.0000, 'ºC'),
	(123582, 108, '2015-04-01 01:18:58.000000', 'temperatura', 150.0000, 'ºC'),
	(123583, 108, '2015-04-01 01:18:59.000000', 'temperatura', 174.0000, 'ºC'),
	(123584, 108, '2015-04-01 01:19:00.000000', 'temperatura', 422.0000, 'ºC'),
	(123585, 108, '2015-04-01 01:19:01.000000', 'temperatura', 386.0000, 'ºC'),
	(123586, 108, '2015-04-01 01:19:02.000000', 'temperatura', 667.0000, 'ºC'),
	(123587, 108, '2015-04-01 01:19:03.000000', 'temperatura', 975.0000, 'ºC'),
	(123588, 108, '2015-04-01 01:19:04.000000', 'temperatura', 477.0000, 'ºC'),
	(123589, 108, '2015-04-01 01:19:05.000000', 'temperatura', 658.0000, 'ºC'),
	(123590, 108, '2015-04-01 01:19:06.000000', 'temperatura', 662.0000, 'ºC'),
	(123591, 108, '2015-04-01 01:19:07.000000', 'temperatura', 136.0000, 'ºC'),
	(123592, 108, '2015-04-01 01:19:08.000000', 'temperatura', 1093.0000, 'ºC'),
	(123593, 108, '2015-04-01 01:19:09.000000', 'temperatura', 260.0000, 'ºC'),
	(123594, 108, '2015-04-01 01:19:10.000000', 'temperatura', 421.0000, 'ºC'),
	(123595, 108, '2015-04-01 01:19:11.000000', 'temperatura', 125.0000, 'ºC'),
	(123596, 108, '2015-04-01 01:19:12.000000', 'temperatura', 563.0000, 'ºC'),
	(123597, 108, '2015-04-01 01:19:13.000000', 'temperatura', 40.0000, 'ºC'),
	(123598, 108, '2015-04-01 01:19:14.000000', 'temperatura', 911.0000, 'ºC'),
	(123599, 108, '2015-04-01 01:19:15.000000', 'temperatura', 837.0000, 'ºC'),
	(123600, 108, '2015-04-01 01:19:16.000000', 'temperatura', 250.0000, 'ºC'),
	(123601, 108, '2015-04-01 01:19:17.000000', 'temperatura', 1142.0000, 'ºC'),
	(123602, 108, '2015-04-01 01:19:18.000000', 'temperatura', 158.0000, 'ºC'),
	(123603, 108, '2015-04-01 01:19:19.000000', 'temperatura', 967.0000, 'ºC'),
	(123604, 108, '2015-04-01 01:19:20.000000', 'temperatura', 762.0000, 'ºC'),
	(123605, 108, '2015-04-01 01:19:21.000000', 'temperatura', 908.0000, 'ºC'),
	(123606, 108, '2015-04-01 01:19:22.000000', 'temperatura', 1056.0000, 'ºC'),
	(123607, 108, '2015-04-01 01:19:23.000000', 'temperatura', 158.0000, 'ºC'),
	(123608, 108, '2015-04-01 01:19:24.000000', 'temperatura', 20.0000, 'ºC'),
	(123609, 108, '2015-04-01 01:19:25.000000', 'temperatura', 826.0000, 'ºC'),
	(123610, 108, '2015-04-01 01:19:26.000000', 'temperatura', 471.0000, 'ºC'),
	(123611, 108, '2015-04-01 01:19:27.000000', 'temperatura', 1079.0000, 'ºC'),
	(123612, 108, '2015-04-01 01:19:28.000000', 'temperatura', 382.0000, 'ºC'),
	(123613, 108, '2015-04-01 01:19:29.000000', 'temperatura', 1075.0000, 'ºC'),
	(123614, 108, '2015-04-01 01:19:30.000000', 'temperatura', 628.0000, 'ºC'),
	(123615, 108, '2015-04-01 01:19:31.000000', 'temperatura', 1116.0000, 'ºC'),
	(123616, 108, '2015-04-01 01:19:32.000000', 'temperatura', 97.0000, 'ºC'),
	(123617, 108, '2015-04-01 01:19:33.000000', 'temperatura', 739.0000, 'ºC'),
	(123618, 108, '2015-04-01 01:19:34.000000', 'temperatura', 1001.0000, 'ºC'),
	(123619, 108, '2015-04-01 01:19:35.000000', 'temperatura', 392.0000, 'ºC'),
	(123620, 108, '2015-04-01 01:19:36.000000', 'temperatura', 155.0000, 'ºC'),
	(123621, 108, '2015-04-01 01:19:37.000000', 'temperatura', 800.0000, 'ºC'),
	(123622, 108, '2015-04-01 01:19:38.000000', 'temperatura', 1134.0000, 'ºC'),
	(123623, 108, '2015-04-01 01:19:39.000000', 'temperatura', 870.0000, 'ºC'),
	(123624, 108, '2015-04-01 01:19:40.000000', 'temperatura', 950.0000, 'ºC'),
	(123625, 108, '2015-04-01 01:19:41.000000', 'temperatura', 940.0000, 'ºC'),
	(123626, 108, '2015-04-01 01:19:42.000000', 'temperatura', 652.0000, 'ºC'),
	(123627, 108, '2015-04-01 01:19:43.000000', 'temperatura', 442.0000, 'ºC'),
	(123628, 108, '2015-04-01 01:19:44.000000', 'temperatura', 251.0000, 'ºC'),
	(123629, 108, '2015-04-01 01:19:45.000000', 'temperatura', 1130.0000, 'ºC'),
	(123630, 108, '2015-04-01 01:19:46.000000', 'temperatura', 97.0000, 'ºC'),
	(123631, 108, '2015-04-01 01:19:47.000000', 'temperatura', 697.0000, 'ºC'),
	(123632, 108, '2015-04-01 01:19:48.000000', 'temperatura', 792.0000, 'ºC'),
	(123633, 108, '2015-04-01 01:19:49.000000', 'temperatura', 670.0000, 'ºC'),
	(123634, 108, '2015-04-01 01:19:50.000000', 'temperatura', 976.0000, 'ºC'),
	(123635, 108, '2015-04-01 01:19:51.000000', 'temperatura', 468.0000, 'ºC'),
	(123636, 108, '2015-04-01 01:19:52.000000', 'temperatura', 613.0000, 'ºC'),
	(123637, 108, '2015-04-01 01:19:53.000000', 'temperatura', 461.0000, 'ºC'),
	(123638, 108, '2015-04-01 01:19:54.000000', 'temperatura', 467.0000, 'ºC'),
	(123639, 108, '2015-04-01 01:19:55.000000', 'temperatura', 951.0000, 'ºC'),
	(123640, 108, '2015-04-01 01:19:56.000000', 'temperatura', 954.0000, 'ºC'),
	(123641, 108, '2015-04-01 01:19:57.000000', 'temperatura', 719.0000, 'ºC'),
	(123642, 108, '2015-04-01 01:19:58.000000', 'temperatura', 735.0000, 'ºC'),
	(123643, 108, '2015-04-01 01:19:59.000000', 'temperatura', 316.0000, 'ºC'),
	(123644, 108, '2015-04-01 01:20:00.000000', 'temperatura', 575.0000, 'ºC'),
	(123645, 108, '2015-04-01 01:20:01.000000', 'temperatura', 729.0000, 'ºC'),
	(123646, 108, '2015-04-01 01:20:02.000000', 'temperatura', 721.0000, 'ºC'),
	(123647, 108, '2015-04-01 01:20:03.000000', 'temperatura', 218.0000, 'ºC'),
	(123648, 108, '2015-04-01 01:20:04.000000', 'temperatura', 128.0000, 'ºC'),
	(123649, 108, '2015-04-01 01:20:05.000000', 'temperatura', 1185.0000, 'ºC'),
	(123650, 108, '2015-04-01 01:20:06.000000', 'temperatura', 744.0000, 'ºC'),
	(123651, 108, '2015-04-01 01:20:07.000000', 'temperatura', 165.0000, 'ºC'),
	(123652, 108, '2015-04-01 01:20:08.000000', 'temperatura', 995.0000, 'ºC'),
	(123653, 108, '2015-04-01 01:20:09.000000', 'temperatura', 877.0000, 'ºC'),
	(123654, 108, '2015-04-01 01:20:10.000000', 'temperatura', 202.0000, 'ºC'),
	(123655, 108, '2015-04-01 01:20:11.000000', 'temperatura', 780.0000, 'ºC'),
	(123656, 108, '2015-04-01 01:20:12.000000', 'temperatura', 894.0000, 'ºC'),
	(123657, 108, '2015-04-01 01:20:13.000000', 'temperatura', 932.0000, 'ºC'),
	(123658, 108, '2015-04-01 01:20:14.000000', 'temperatura', 778.0000, 'ºC'),
	(123659, 108, '2015-04-01 01:20:15.000000', 'temperatura', 1093.0000, 'ºC'),
	(123660, 108, '2015-04-01 01:20:16.000000', 'temperatura', 732.0000, 'ºC'),
	(123661, 108, '2015-04-01 01:20:17.000000', 'temperatura', 382.0000, 'ºC'),
	(123662, 108, '2015-04-01 01:20:18.000000', 'temperatura', 912.0000, 'ºC'),
	(123663, 108, '2015-04-01 01:20:19.000000', 'temperatura', 1018.0000, 'ºC'),
	(123664, 108, '2015-04-01 01:20:20.000000', 'temperatura', 1154.0000, 'ºC'),
	(123665, 108, '2015-04-01 01:20:21.000000', 'temperatura', 316.0000, 'ºC'),
	(123666, 108, '2015-04-01 01:20:22.000000', 'temperatura', 517.0000, 'ºC'),
	(123667, 108, '2015-04-01 01:20:23.000000', 'temperatura', 437.0000, 'ºC'),
	(123668, 108, '2015-04-01 01:20:24.000000', 'temperatura', 634.0000, 'ºC'),
	(123669, 108, '2015-04-01 01:20:25.000000', 'temperatura', 661.0000, 'ºC'),
	(123670, 108, '2015-04-01 01:20:26.000000', 'temperatura', 205.0000, 'ºC'),
	(123671, 108, '2015-04-01 01:20:27.000000', 'temperatura', 239.0000, 'ºC'),
	(123672, 108, '2015-04-01 01:20:28.000000', 'temperatura', 583.0000, 'ºC'),
	(123673, 108, '2015-04-01 01:20:29.000000', 'temperatura', 999.0000, 'ºC'),
	(123674, 108, '2015-04-01 01:20:30.000000', 'temperatura', 847.0000, 'ºC'),
	(123675, 108, '2015-04-01 01:20:31.000000', 'temperatura', 37.0000, 'ºC'),
	(123676, 108, '2015-04-01 01:20:32.000000', 'temperatura', 46.0000, 'ºC'),
	(123677, 108, '2015-04-01 01:20:33.000000', 'temperatura', 121.0000, 'ºC'),
	(123678, 108, '2015-04-01 01:20:34.000000', 'temperatura', 465.0000, 'ºC'),
	(123679, 108, '2015-04-01 01:20:35.000000', 'temperatura', 762.0000, 'ºC'),
	(123680, 108, '2015-04-01 01:20:36.000000', 'temperatura', 17.0000, 'ºC'),
	(123681, 108, '2015-04-01 01:20:37.000000', 'temperatura', 200.0000, 'ºC'),
	(123682, 108, '2015-04-01 01:20:38.000000', 'temperatura', 948.0000, 'ºC'),
	(123683, 108, '2015-04-01 01:20:39.000000', 'temperatura', 541.0000, 'ºC'),
	(123684, 108, '2015-04-01 01:20:40.000000', 'temperatura', 1063.0000, 'ºC'),
	(123685, 108, '2015-04-01 01:20:41.000000', 'temperatura', 92.0000, 'ºC'),
	(123686, 108, '2015-04-01 01:20:42.000000', 'temperatura', 871.0000, 'ºC'),
	(123687, 108, '2015-04-01 01:20:43.000000', 'temperatura', 480.0000, 'ºC'),
	(123688, 108, '2015-04-01 01:20:44.000000', 'temperatura', 989.0000, 'ºC'),
	(123689, 108, '2015-04-01 01:20:45.000000', 'temperatura', 1104.0000, 'ºC'),
	(123690, 108, '2015-04-01 01:20:46.000000', 'temperatura', 154.0000, 'ºC'),
	(123691, 108, '2015-04-01 01:20:47.000000', 'temperatura', 1057.0000, 'ºC'),
	(123692, 108, '2015-04-01 01:20:48.000000', 'temperatura', 25.0000, 'ºC'),
	(123693, 108, '2015-04-01 01:20:49.000000', 'temperatura', 555.0000, 'ºC'),
	(123694, 108, '2015-04-01 01:20:50.000000', 'temperatura', 301.0000, 'ºC'),
	(123695, 108, '2015-04-01 01:20:51.000000', 'temperatura', 1040.0000, 'ºC'),
	(123696, 108, '2015-04-01 01:20:52.000000', 'temperatura', 696.0000, 'ºC'),
	(123697, 108, '2015-04-01 01:20:53.000000', 'temperatura', 360.0000, 'ºC'),
	(123698, 108, '2015-04-01 01:20:54.000000', 'temperatura', 914.0000, 'ºC'),
	(123699, 108, '2015-04-01 01:20:55.000000', 'temperatura', 1089.0000, 'ºC'),
	(123700, 108, '2015-04-01 01:20:56.000000', 'temperatura', 305.0000, 'ºC'),
	(123701, 108, '2015-04-01 01:20:57.000000', 'temperatura', 658.0000, 'ºC'),
	(123702, 108, '2015-04-01 01:20:58.000000', 'temperatura', 1176.0000, 'ºC'),
	(123703, 108, '2015-04-01 01:20:59.000000', 'temperatura', 306.0000, 'ºC'),
	(123704, 108, '2015-04-01 01:21:00.000000', 'temperatura', 402.0000, 'ºC'),
	(123705, 108, '2015-04-01 01:21:01.000000', 'temperatura', 1094.0000, 'ºC'),
	(123706, 108, '2015-04-01 01:21:02.000000', 'temperatura', 663.0000, 'ºC'),
	(123707, 108, '2015-04-01 01:21:03.000000', 'temperatura', 32.0000, 'ºC'),
	(123708, 108, '2015-04-01 01:21:04.000000', 'temperatura', 574.0000, 'ºC'),
	(123709, 108, '2015-04-01 01:21:05.000000', 'temperatura', 372.0000, 'ºC'),
	(123710, 108, '2015-04-01 01:21:06.000000', 'temperatura', 142.0000, 'ºC'),
	(123711, 108, '2015-04-01 01:21:07.000000', 'temperatura', 791.0000, 'ºC'),
	(123712, 108, '2015-04-01 01:21:08.000000', 'temperatura', 1132.0000, 'ºC'),
	(123713, 108, '2015-04-01 01:21:09.000000', 'temperatura', 886.0000, 'ºC'),
	(123714, 108, '2015-04-01 01:21:10.000000', 'temperatura', 1036.0000, 'ºC'),
	(123715, 108, '2015-04-01 01:21:11.000000', 'temperatura', 120.0000, 'ºC'),
	(123716, 108, '2015-04-01 01:21:12.000000', 'temperatura', 1094.0000, 'ºC'),
	(123717, 108, '2015-04-01 01:21:13.000000', 'temperatura', 311.0000, 'ºC'),
	(123718, 108, '2015-04-01 01:21:14.000000', 'temperatura', 672.0000, 'ºC'),
	(123719, 108, '2015-04-01 01:21:15.000000', 'temperatura', 29.0000, 'ºC'),
	(123720, 108, '2015-04-01 01:21:16.000000', 'temperatura', 530.0000, 'ºC'),
	(123721, 108, '2015-04-01 01:21:17.000000', 'temperatura', 163.0000, 'ºC'),
	(123722, 108, '2015-04-01 01:21:18.000000', 'temperatura', 427.0000, 'ºC'),
	(123723, 108, '2015-04-01 01:21:19.000000', 'temperatura', 446.0000, 'ºC'),
	(123724, 108, '2015-04-01 01:21:20.000000', 'temperatura', 950.0000, 'ºC'),
	(123725, 108, '2015-04-01 01:21:21.000000', 'temperatura', 1014.0000, 'ºC'),
	(123726, 108, '2015-04-01 01:21:22.000000', 'temperatura', 1017.0000, 'ºC'),
	(123727, 108, '2015-04-01 01:21:23.000000', 'temperatura', 847.0000, 'ºC'),
	(123728, 108, '2015-04-01 01:21:24.000000', 'temperatura', 1181.0000, 'ºC'),
	(123729, 108, '2015-04-01 01:21:25.000000', 'temperatura', 966.0000, 'ºC'),
	(123730, 108, '2015-04-01 01:21:26.000000', 'temperatura', 89.0000, 'ºC'),
	(123731, 108, '2015-04-01 01:21:27.000000', 'temperatura', 1146.0000, 'ºC'),
	(123732, 108, '2015-04-01 01:21:28.000000', 'temperatura', 664.0000, 'ºC'),
	(123733, 108, '2015-04-01 01:21:29.000000', 'temperatura', 1084.0000, 'ºC'),
	(123734, 108, '2015-04-01 01:21:30.000000', 'temperatura', 1028.0000, 'ºC'),
	(123735, 108, '2015-04-01 01:21:31.000000', 'temperatura', 690.0000, 'ºC'),
	(123736, 108, '2015-04-01 01:21:32.000000', 'temperatura', 363.0000, 'ºC'),
	(123737, 108, '2015-04-01 01:21:33.000000', 'temperatura', 949.0000, 'ºC'),
	(123738, 108, '2015-04-01 01:21:34.000000', 'temperatura', 55.0000, 'ºC'),
	(123739, 108, '2015-04-01 01:21:35.000000', 'temperatura', 1027.0000, 'ºC'),
	(123740, 108, '2015-04-01 01:21:36.000000', 'temperatura', 173.0000, 'ºC'),
	(123741, 108, '2015-04-01 01:21:37.000000', 'temperatura', 182.0000, 'ºC'),
	(123742, 108, '2015-04-01 01:21:38.000000', 'temperatura', 391.0000, 'ºC'),
	(123743, 108, '2015-04-01 01:21:39.000000', 'temperatura', 209.0000, 'ºC'),
	(123744, 108, '2015-04-01 01:21:40.000000', 'temperatura', 1072.0000, 'ºC'),
	(123745, 108, '2015-04-01 01:21:41.000000', 'temperatura', 1137.0000, 'ºC'),
	(123746, 108, '2015-04-01 01:21:42.000000', 'temperatura', 67.0000, 'ºC'),
	(123747, 108, '2015-04-01 01:21:43.000000', 'temperatura', 524.0000, 'ºC'),
	(123748, 108, '2015-04-01 01:21:44.000000', 'temperatura', 20.0000, 'ºC'),
	(123749, 108, '2015-04-01 01:21:45.000000', 'temperatura', 930.0000, 'ºC'),
	(123750, 108, '2015-04-01 01:21:46.000000', 'temperatura', 991.0000, 'ºC'),
	(123751, 108, '2015-04-01 01:21:47.000000', 'temperatura', 963.0000, 'ºC'),
	(123752, 108, '2015-04-01 01:21:48.000000', 'temperatura', 644.0000, 'ºC'),
	(123753, 108, '2015-04-01 01:21:49.000000', 'temperatura', 333.0000, 'ºC'),
	(123754, 108, '2015-04-01 01:21:50.000000', 'temperatura', 933.0000, 'ºC'),
	(123755, 108, '2015-04-01 01:21:51.000000', 'temperatura', 65.0000, 'ºC'),
	(123756, 108, '2015-04-01 01:21:52.000000', 'temperatura', 1126.0000, 'ºC'),
	(123757, 108, '2015-04-01 01:21:53.000000', 'temperatura', 636.0000, 'ºC'),
	(123758, 108, '2015-04-01 01:21:54.000000', 'temperatura', 1003.0000, 'ºC'),
	(123759, 108, '2015-04-01 01:21:55.000000', 'temperatura', 706.0000, 'ºC'),
	(123760, 108, '2015-04-01 01:21:56.000000', 'temperatura', 524.0000, 'ºC'),
	(123761, 108, '2015-04-01 01:21:57.000000', 'temperatura', 503.0000, 'ºC'),
	(123762, 108, '2015-04-01 01:21:58.000000', 'temperatura', 943.0000, 'ºC'),
	(123763, 108, '2015-04-01 01:21:59.000000', 'temperatura', 807.0000, 'ºC'),
	(123764, 108, '2015-04-01 01:22:00.000000', 'temperatura', 6.0000, 'ºC'),
	(123765, 108, '2015-04-01 01:22:01.000000', 'temperatura', 11.0000, 'ºC'),
	(123766, 108, '2015-04-01 01:22:02.000000', 'temperatura', 37.0000, 'ºC'),
	(123767, 108, '2015-04-01 01:22:03.000000', 'temperatura', 152.0000, 'ºC'),
	(123768, 108, '2015-04-01 01:22:04.000000', 'temperatura', 649.0000, 'ºC'),
	(123769, 108, '2015-04-01 01:22:05.000000', 'temperatura', 391.0000, 'ºC'),
	(123770, 108, '2015-04-01 01:22:06.000000', 'temperatura', 10.0000, 'ºC'),
	(123771, 108, '2015-04-01 01:22:07.000000', 'temperatura', 74.0000, 'ºC'),
	(123772, 108, '2015-04-01 01:22:08.000000', 'temperatura', 342.0000, 'ºC'),
	(123773, 108, '2015-04-01 01:22:09.000000', 'temperatura', 289.0000, 'ºC'),
	(123774, 108, '2015-04-01 01:22:10.000000', 'temperatura', 419.0000, 'ºC'),
	(123775, 108, '2015-04-01 01:22:11.000000', 'temperatura', 29.0000, 'ºC'),
	(123776, 108, '2015-04-01 01:22:12.000000', 'temperatura', 89.0000, 'ºC'),
	(123777, 108, '2015-04-01 01:22:13.000000', 'temperatura', 357.0000, 'ºC'),
	(123778, 108, '2015-04-01 01:22:14.000000', 'temperatura', 320.0000, 'ºC'),
	(123779, 108, '2015-04-01 01:22:15.000000', 'temperatura', 527.0000, 'ºC'),
	(123780, 108, '2015-04-01 01:22:16.000000', 'temperatura', 479.0000, 'ºC'),
	(123781, 108, '2015-04-01 01:22:17.000000', 'temperatura', 812.0000, 'ºC'),
	(123782, 108, '2015-04-01 01:22:18.000000', 'temperatura', 225.0000, 'ºC'),
	(123783, 108, '2015-04-01 01:22:19.000000', 'temperatura', 1091.0000, 'ºC'),
	(123784, 108, '2015-04-01 01:22:20.000000', 'temperatura', 1178.0000, 'ºC'),
	(123785, 108, '2015-04-01 01:22:21.000000', 'temperatura', 217.0000, 'ºC'),
	(123786, 108, '2015-04-01 01:22:22.000000', 'temperatura', 1154.0000, 'ºC'),
	(123787, 108, '2015-04-01 01:22:23.000000', 'temperatura', 320.0000, 'ºC'),
	(123788, 108, '2015-04-01 01:22:24.000000', 'temperatura', 536.0000, 'ºC'),
	(123789, 108, '2015-04-01 01:22:25.000000', 'temperatura', 520.0000, 'ºC'),
	(123790, 108, '2015-04-01 01:22:26.000000', 'temperatura', 995.0000, 'ºC'),
	(123791, 108, '2015-04-01 01:22:27.000000', 'temperatura', 1016.0000, 'ºC'),
	(123792, 108, '2015-04-01 01:22:28.000000', 'temperatura', 895.0000, 'ºC'),
	(123793, 108, '2015-04-01 01:22:29.000000', 'temperatura', 227.0000, 'ºC'),
	(123794, 108, '2015-04-01 01:22:30.000000', 'temperatura', 853.0000, 'ºC'),
	(123795, 108, '2015-04-01 01:22:31.000000', 'temperatura', 1181.0000, 'ºC'),
	(123796, 108, '2015-04-01 01:22:32.000000', 'temperatura', 948.0000, 'ºC'),
	(123797, 108, '2015-04-01 01:22:33.000000', 'temperatura', 1196.0000, 'ºC'),
	(123798, 108, '2015-04-01 01:22:34.000000', 'temperatura', 737.0000, 'ºC'),
	(123799, 108, '2015-04-01 01:22:35.000000', 'temperatura', 99.0000, 'ºC'),
	(123800, 108, '2015-04-01 01:22:36.000000', 'temperatura', 686.0000, 'ºC'),
	(123801, 108, '2015-04-01 01:22:37.000000', 'temperatura', 731.0000, 'ºC'),
	(123802, 108, '2015-04-01 01:22:38.000000', 'temperatura', 398.0000, 'ºC'),
	(123803, 108, '2015-04-01 01:22:39.000000', 'temperatura', 997.0000, 'ºC'),
	(123804, 108, '2015-04-01 01:22:40.000000', 'temperatura', 191.0000, 'ºC'),
	(123805, 108, '2015-04-01 01:22:41.000000', 'temperatura', 365.0000, 'ºC'),
	(123806, 108, '2015-04-01 01:22:42.000000', 'temperatura', 51.0000, 'ºC'),
	(123807, 108, '2015-04-01 01:22:43.000000', 'temperatura', 363.0000, 'ºC'),
	(123808, 108, '2015-04-01 01:22:44.000000', 'temperatura', 462.0000, 'ºC'),
	(123809, 108, '2015-04-01 01:22:45.000000', 'temperatura', 19.0000, 'ºC'),
	(123810, 108, '2015-04-01 01:22:46.000000', 'temperatura', 1111.0000, 'ºC'),
	(123811, 108, '2015-04-01 01:22:47.000000', 'temperatura', 700.0000, 'ºC'),
	(123812, 108, '2015-04-01 01:22:48.000000', 'temperatura', 168.0000, 'ºC'),
	(123813, 108, '2015-04-01 01:22:49.000000', 'temperatura', 1141.0000, 'ºC'),
	(123814, 108, '2015-04-01 01:22:50.000000', 'temperatura', 400.0000, 'ºC'),
	(123815, 108, '2015-04-01 01:22:51.000000', 'temperatura', 976.0000, 'ºC'),
	(123816, 108, '2015-04-01 01:22:52.000000', 'temperatura', 81.0000, 'ºC'),
	(123817, 108, '2015-04-01 01:22:53.000000', 'temperatura', 1079.0000, 'ºC'),
	(123818, 108, '2015-04-01 01:22:54.000000', 'temperatura', 350.0000, 'ºC'),
	(123819, 108, '2015-04-01 01:22:55.000000', 'temperatura', 916.0000, 'ºC'),
	(123820, 108, '2015-04-01 01:22:56.000000', 'temperatura', 1129.0000, 'ºC'),
	(123821, 108, '2015-04-01 01:22:57.000000', 'temperatura', 498.0000, 'ºC'),
	(123822, 108, '2015-04-01 01:22:58.000000', 'temperatura', 305.0000, 'ºC'),
	(123823, 108, '2015-04-01 01:22:59.000000', 'temperatura', 31.0000, 'ºC'),
	(123824, 108, '2015-04-01 01:23:00.000000', 'temperatura', 441.0000, 'ºC'),
	(123825, 108, '2015-04-01 01:23:01.000000', 'temperatura', 910.0000, 'ºC'),
	(123826, 108, '2015-04-01 01:23:02.000000', 'temperatura', 831.0000, 'ºC'),
	(123827, 108, '2015-04-01 01:23:03.000000', 'temperatura', 222.0000, 'ºC'),
	(123828, 108, '2015-04-01 01:23:04.000000', 'temperatura', 1020.0000, 'ºC'),
	(123829, 108, '2015-04-01 01:23:05.000000', 'temperatura', 833.0000, 'ºC'),
	(123830, 108, '2015-04-01 01:23:06.000000', 'temperatura', 1104.0000, 'ºC'),
	(123831, 108, '2015-04-01 01:23:07.000000', 'temperatura', 623.0000, 'ºC'),
	(123832, 108, '2015-04-01 01:23:08.000000', 'temperatura', 1005.0000, 'ºC'),
	(123833, 108, '2015-04-01 01:23:09.000000', 'temperatura', 756.0000, 'ºC'),
	(123834, 108, '2015-04-01 01:23:10.000000', 'temperatura', 765.0000, 'ºC'),
	(123835, 108, '2015-04-01 01:23:11.000000', 'temperatura', 358.0000, 'ºC'),
	(123836, 108, '2015-04-01 01:23:12.000000', 'temperatura', 696.0000, 'ºC'),
	(123837, 108, '2015-04-01 01:23:13.000000', 'temperatura', 8.0000, 'ºC'),
	(123838, 108, '2015-04-01 01:23:14.000000', 'temperatura', 351.0000, 'ºC'),
	(123839, 108, '2015-04-01 01:23:15.000000', 'temperatura', 531.0000, 'ºC'),
	(123840, 108, '2015-04-01 01:23:16.000000', 'temperatura', 403.0000, 'ºC'),
	(123841, 108, '2015-04-01 01:23:17.000000', 'temperatura', 424.0000, 'ºC'),
	(123842, 108, '2015-04-01 01:23:18.000000', 'temperatura', 911.0000, 'ºC'),
	(123843, 108, '2015-04-01 01:23:19.000000', 'temperatura', 883.0000, 'ºC'),
	(123844, 108, '2015-04-01 01:23:20.000000', 'temperatura', 485.0000, 'ºC'),
	(123845, 108, '2015-04-01 01:23:21.000000', 'temperatura', 973.0000, 'ºC'),
	(123846, 108, '2015-04-01 01:23:22.000000', 'temperatura', 1012.0000, 'ºC'),
	(123847, 108, '2015-04-01 01:23:23.000000', 'temperatura', 940.0000, 'ºC'),
	(123848, 108, '2015-04-01 01:23:24.000000', 'temperatura', 464.0000, 'ºC'),
	(123849, 108, '2015-04-01 01:23:25.000000', 'temperatura', 700.0000, 'ºC'),
	(123850, 108, '2015-04-01 01:23:26.000000', 'temperatura', 910.0000, 'ºC'),
	(123851, 108, '2015-04-01 01:23:27.000000', 'temperatura', 50.0000, 'ºC'),
	(123852, 108, '2015-04-01 01:23:28.000000', 'temperatura', 1120.0000, 'ºC'),
	(123853, 108, '2015-04-01 01:23:29.000000', 'temperatura', 649.0000, 'ºC'),
	(123854, 108, '2015-04-01 01:23:30.000000', 'temperatura', 1086.0000, 'ºC'),
	(123855, 108, '2015-04-01 01:23:31.000000', 'temperatura', 1086.0000, 'ºC'),
	(123856, 108, '2015-04-01 01:23:32.000000', 'temperatura', 971.0000, 'ºC'),
	(123857, 108, '2015-04-01 01:23:33.000000', 'temperatura', 397.0000, 'ºC'),
	(123858, 108, '2015-04-01 01:23:34.000000', 'temperatura', 274.0000, 'ºC'),
	(123859, 108, '2015-04-01 01:23:35.000000', 'temperatura', 178.0000, 'ºC'),
	(123860, 108, '2015-04-01 01:23:36.000000', 'temperatura', 69.0000, 'ºC'),
	(123861, 108, '2015-04-01 01:23:37.000000', 'temperatura', 1011.0000, 'ºC'),
	(123862, 108, '2015-04-01 01:23:38.000000', 'temperatura', 47.0000, 'ºC'),
	(123863, 108, '2015-04-01 01:23:39.000000', 'temperatura', 804.0000, 'ºC'),
	(123864, 108, '2015-04-01 01:23:40.000000', 'temperatura', 278.0000, 'ºC'),
	(123865, 108, '2015-04-01 01:23:41.000000', 'temperatura', 179.0000, 'ºC'),
	(123866, 108, '2015-04-01 01:23:42.000000', 'temperatura', 61.0000, 'ºC'),
	(123867, 108, '2015-04-01 01:23:43.000000', 'temperatura', 970.0000, 'ºC'),
	(123868, 108, '2015-04-01 01:23:44.000000', 'temperatura', 1065.0000, 'ºC'),
	(123869, 108, '2015-04-01 01:23:45.000000', 'temperatura', 16.0000, 'ºC'),
	(123870, 108, '2015-04-01 01:23:46.000000', 'temperatura', 486.0000, 'ºC'),
	(123871, 108, '2015-04-01 01:23:47.000000', 'temperatura', 1184.0000, 'ºC'),
	(123872, 108, '2015-04-01 01:23:48.000000', 'temperatura', 861.0000, 'ºC'),
	(123873, 108, '2015-04-01 01:23:49.000000', 'temperatura', 754.0000, 'ºC'),
	(123874, 108, '2015-04-01 01:23:50.000000', 'temperatura', 1187.0000, 'ºC'),
	(123875, 108, '2015-04-01 01:23:51.000000', 'temperatura', 73.0000, 'ºC'),
	(123876, 108, '2015-04-01 01:23:52.000000', 'temperatura', 403.0000, 'ºC'),
	(123877, 108, '2015-04-01 01:23:53.000000', 'temperatura', 600.0000, 'ºC'),
	(123878, 108, '2015-04-01 01:23:54.000000', 'temperatura', 589.0000, 'ºC'),
	(123879, 108, '2015-04-01 01:23:55.000000', 'temperatura', 1146.0000, 'ºC'),
	(123880, 108, '2015-04-01 01:23:56.000000', 'temperatura', 364.0000, 'ºC'),
	(123881, 108, '2015-04-01 01:23:57.000000', 'temperatura', 782.0000, 'ºC'),
	(123882, 108, '2015-04-01 01:23:58.000000', 'temperatura', 419.0000, 'ºC'),
	(123883, 108, '2015-04-01 01:23:59.000000', 'temperatura', 948.0000, 'ºC'),
	(123884, 108, '2015-04-01 01:24:00.000000', 'temperatura', 1083.0000, 'ºC'),
	(123885, 108, '2015-04-01 01:24:01.000000', 'temperatura', 174.0000, 'ºC'),
	(123886, 108, '2015-04-01 01:24:02.000000', 'temperatura', 22.0000, 'ºC'),
	(123887, 108, '2015-04-01 01:24:03.000000', 'temperatura', 789.0000, 'ºC'),
	(123888, 108, '2015-04-01 01:24:04.000000', 'temperatura', 280.0000, 'ºC'),
	(123889, 108, '2015-04-01 01:24:05.000000', 'temperatura', 232.0000, 'ºC'),
	(123890, 108, '2015-04-01 01:24:06.000000', 'temperatura', 322.0000, 'ºC'),
	(123891, 108, '2015-04-01 01:24:07.000000', 'temperatura', 913.0000, 'ºC'),
	(123892, 108, '2015-04-01 01:24:08.000000', 'temperatura', 1198.0000, 'ºC'),
	(123893, 108, '2015-04-01 01:24:09.000000', 'temperatura', 852.0000, 'ºC'),
	(123894, 108, '2015-04-01 01:24:10.000000', 'temperatura', 669.0000, 'ºC'),
	(123895, 108, '2015-04-01 01:24:11.000000', 'temperatura', 787.0000, 'ºC'),
	(123896, 108, '2015-04-01 01:24:12.000000', 'temperatura', 728.0000, 'ºC'),
	(123897, 108, '2015-04-01 01:24:13.000000', 'temperatura', 81.0000, 'ºC'),
	(123898, 108, '2015-04-01 01:24:14.000000', 'temperatura', 620.0000, 'ºC'),
	(123899, 108, '2015-04-01 01:24:15.000000', 'temperatura', 460.0000, 'ºC'),
	(123900, 108, '2015-04-01 01:24:16.000000', 'temperatura', 439.0000, 'ºC'),
	(123901, 108, '2015-04-01 01:24:17.000000', 'temperatura', 815.0000, 'ºC'),
	(123902, 108, '2015-04-01 01:24:18.000000', 'temperatura', 360.0000, 'ºC'),
	(123903, 108, '2015-04-01 01:24:19.000000', 'temperatura', 556.0000, 'ºC'),
	(123904, 108, '2015-04-01 01:24:20.000000', 'temperatura', 501.0000, 'ºC'),
	(123905, 108, '2015-04-01 01:24:21.000000', 'temperatura', 837.0000, 'ºC'),
	(123906, 108, '2015-04-01 01:24:22.000000', 'temperatura', 282.0000, 'ºC'),
	(123907, 108, '2015-04-01 01:24:23.000000', 'temperatura', 100.0000, 'ºC'),
	(123908, 108, '2015-04-01 01:24:24.000000', 'temperatura', 855.0000, 'ºC'),
	(123909, 108, '2015-04-01 01:24:25.000000', 'temperatura', 374.0000, 'ºC'),
	(123910, 108, '2015-04-01 01:24:26.000000', 'temperatura', 507.0000, 'ºC'),
	(123911, 108, '2015-04-01 01:24:27.000000', 'temperatura', 214.0000, 'ºC'),
	(123912, 108, '2015-04-01 01:24:28.000000', 'temperatura', 748.0000, 'ºC'),
	(123913, 108, '2015-04-01 01:24:29.000000', 'temperatura', 701.0000, 'ºC'),
	(123914, 108, '2015-04-01 01:24:30.000000', 'temperatura', 58.0000, 'ºC'),
	(123915, 108, '2015-04-01 01:24:31.000000', 'temperatura', 589.0000, 'ºC'),
	(123916, 108, '2015-04-01 01:24:32.000000', 'temperatura', 373.0000, 'ºC'),
	(123917, 108, '2015-04-01 01:24:33.000000', 'temperatura', 97.0000, 'ºC'),
	(123918, 108, '2015-04-01 01:24:34.000000', 'temperatura', 568.0000, 'ºC'),
	(123919, 108, '2015-04-01 01:24:35.000000', 'temperatura', 150.0000, 'ºC'),
	(123920, 108, '2015-04-01 01:24:36.000000', 'temperatura', 245.0000, 'ºC'),
	(123921, 108, '2015-04-01 01:24:37.000000', 'temperatura', 775.0000, 'ºC'),
	(123922, 108, '2015-04-01 01:24:38.000000', 'temperatura', 741.0000, 'ºC'),
	(123923, 108, '2015-04-01 01:24:39.000000', 'temperatura', 180.0000, 'ºC'),
	(123924, 108, '2015-04-01 01:24:40.000000', 'temperatura', 1077.0000, 'ºC'),
	(123925, 108, '2015-04-01 01:24:41.000000', 'temperatura', 45.0000, 'ºC'),
	(123926, 108, '2015-04-01 01:24:42.000000', 'temperatura', 594.0000, 'ºC'),
	(123927, 108, '2015-04-01 01:24:43.000000', 'temperatura', 437.0000, 'ºC'),
	(123928, 108, '2015-04-01 01:24:44.000000', 'temperatura', 401.0000, 'ºC'),
	(123929, 108, '2015-04-01 01:24:45.000000', 'temperatura', 698.0000, 'ºC'),
	(123930, 108, '2015-04-01 01:24:46.000000', 'temperatura', 1085.0000, 'ºC'),
	(123931, 108, '2015-04-01 01:24:47.000000', 'temperatura', 934.0000, 'ºC'),
	(123932, 108, '2015-04-01 01:24:48.000000', 'temperatura', 214.0000, 'ºC'),
	(123933, 108, '2015-04-01 01:24:49.000000', 'temperatura', 667.0000, 'ºC'),
	(123934, 108, '2015-04-01 01:24:50.000000', 'temperatura', 293.0000, 'ºC'),
	(123935, 108, '2015-04-01 01:24:51.000000', 'temperatura', 667.0000, 'ºC'),
	(123936, 108, '2015-04-01 01:24:52.000000', 'temperatura', 54.0000, 'ºC'),
	(123937, 108, '2015-04-01 01:24:53.000000', 'temperatura', 673.0000, 'ºC'),
	(123938, 108, '2015-04-01 01:24:54.000000', 'temperatura', 801.0000, 'ºC'),
	(123939, 108, '2015-04-01 01:24:55.000000', 'temperatura', 786.0000, 'ºC'),
	(123940, 108, '2015-04-01 01:24:56.000000', 'temperatura', 326.0000, 'ºC'),
	(123941, 108, '2015-04-01 01:24:57.000000', 'temperatura', 475.0000, 'ºC'),
	(123942, 108, '2015-04-01 01:24:58.000000', 'temperatura', 197.0000, 'ºC'),
	(123943, 108, '2015-04-01 01:24:59.000000', 'temperatura', 760.0000, 'ºC'),
	(123944, 108, '2015-04-01 01:25:00.000000', 'temperatura', 812.0000, 'ºC'),
	(123945, 108, '2015-04-01 01:25:01.000000', 'temperatura', 578.0000, 'ºC'),
	(123946, 108, '2015-04-01 01:25:02.000000', 'temperatura', 455.0000, 'ºC'),
	(123947, 108, '2015-04-01 01:25:03.000000', 'temperatura', 541.0000, 'ºC'),
	(123948, 108, '2015-04-01 01:25:04.000000', 'temperatura', 139.0000, 'ºC'),
	(123949, 108, '2015-04-01 01:25:05.000000', 'temperatura', 275.0000, 'ºC'),
	(123950, 108, '2015-04-01 01:25:06.000000', 'temperatura', 959.0000, 'ºC'),
	(123951, 108, '2015-04-01 01:25:07.000000', 'temperatura', 368.0000, 'ºC'),
	(123952, 108, '2015-04-01 01:25:08.000000', 'temperatura', 163.0000, 'ºC'),
	(123953, 108, '2015-04-01 01:25:09.000000', 'temperatura', 912.0000, 'ºC'),
	(123954, 108, '2015-04-01 01:25:10.000000', 'temperatura', 473.0000, 'ºC'),
	(123955, 108, '2015-04-01 01:25:11.000000', 'temperatura', 827.0000, 'ºC'),
	(123956, 108, '2015-04-01 01:25:12.000000', 'temperatura', 318.0000, 'ºC'),
	(123957, 108, '2015-04-01 01:25:13.000000', 'temperatura', 311.0000, 'ºC'),
	(123958, 108, '2015-04-01 01:25:14.000000', 'temperatura', 601.0000, 'ºC'),
	(123959, 108, '2015-04-01 01:25:15.000000', 'temperatura', 871.0000, 'ºC'),
	(123960, 108, '2015-04-01 01:25:16.000000', 'temperatura', 155.0000, 'ºC'),
	(123961, 108, '2015-04-01 01:25:17.000000', 'temperatura', 562.0000, 'ºC'),
	(123962, 108, '2015-04-01 01:25:18.000000', 'temperatura', 1147.0000, 'ºC'),
	(123963, 108, '2015-04-01 01:25:19.000000', 'temperatura', 447.0000, 'ºC'),
	(123964, 108, '2015-04-01 01:25:20.000000', 'temperatura', 1196.0000, 'ºC'),
	(123965, 108, '2015-04-01 01:25:21.000000', 'temperatura', 1038.0000, 'ºC'),
	(123966, 108, '2015-04-01 01:25:22.000000', 'temperatura', 403.0000, 'ºC'),
	(123967, 108, '2015-04-01 01:25:23.000000', 'temperatura', 103.0000, 'ºC'),
	(123968, 108, '2015-04-01 01:25:24.000000', 'temperatura', 507.0000, 'ºC'),
	(123969, 108, '2015-04-01 01:25:25.000000', 'temperatura', 1027.0000, 'ºC'),
	(123970, 108, '2015-04-01 01:25:26.000000', 'temperatura', 15.0000, 'ºC'),
	(123971, 108, '2015-04-01 01:25:27.000000', 'temperatura', 595.0000, 'ºC'),
	(123972, 108, '2015-04-01 01:25:28.000000', 'temperatura', 528.0000, 'ºC'),
	(123973, 108, '2015-04-01 01:25:29.000000', 'temperatura', 856.0000, 'ºC'),
	(123974, 108, '2015-04-01 01:25:30.000000', 'temperatura', 298.0000, 'ºC'),
	(123975, 108, '2015-04-01 01:25:31.000000', 'temperatura', 124.0000, 'ºC'),
	(123976, 108, '2015-04-01 01:25:32.000000', 'temperatura', 924.0000, 'ºC'),
	(123977, 108, '2015-04-01 01:25:33.000000', 'temperatura', 648.0000, 'ºC'),
	(123978, 108, '2015-04-01 01:25:34.000000', 'temperatura', 470.0000, 'ºC'),
	(123979, 108, '2015-04-01 01:25:35.000000', 'temperatura', 405.0000, 'ºC'),
	(123980, 108, '2015-04-01 01:25:36.000000', 'temperatura', 617.0000, 'ºC'),
	(123981, 108, '2015-04-01 01:25:37.000000', 'temperatura', 671.0000, 'ºC'),
	(123982, 108, '2015-04-01 01:25:38.000000', 'temperatura', 302.0000, 'ºC'),
	(123983, 108, '2015-04-01 01:25:39.000000', 'temperatura', 697.0000, 'ºC'),
	(123984, 108, '2015-04-01 01:25:40.000000', 'temperatura', 181.0000, 'ºC'),
	(123985, 108, '2015-04-01 01:25:41.000000', 'temperatura', 16.0000, 'ºC'),
	(123986, 108, '2015-04-01 01:25:42.000000', 'temperatura', 736.0000, 'ºC'),
	(123987, 108, '2015-04-01 01:25:43.000000', 'temperatura', 33.0000, 'ºC'),
	(123988, 108, '2015-04-01 01:25:44.000000', 'temperatura', 356.0000, 'ºC'),
	(123989, 108, '2015-04-01 01:25:45.000000', 'temperatura', 481.0000, 'ºC'),
	(123990, 108, '2015-04-01 01:25:46.000000', 'temperatura', 139.0000, 'ºC'),
	(123991, 108, '2015-04-01 01:25:47.000000', 'temperatura', 453.0000, 'ºC'),
	(123992, 108, '2015-04-01 01:25:48.000000', 'temperatura', 648.0000, 'ºC'),
	(123993, 108, '2015-04-01 01:25:49.000000', 'temperatura', 679.0000, 'ºC'),
	(123994, 108, '2015-04-01 01:25:50.000000', 'temperatura', 255.0000, 'ºC'),
	(123995, 108, '2015-04-01 01:25:51.000000', 'temperatura', 436.0000, 'ºC'),
	(123996, 108, '2015-04-01 01:25:52.000000', 'temperatura', 218.0000, 'ºC'),
	(123997, 108, '2015-04-01 01:25:53.000000', 'temperatura', 983.0000, 'ºC'),
	(123998, 108, '2015-04-01 01:25:54.000000', 'temperatura', 659.0000, 'ºC'),
	(123999, 108, '2015-04-01 01:25:55.000000', 'temperatura', 346.0000, 'ºC'),
	(124000, 108, '2015-04-01 01:25:56.000000', 'temperatura', 955.0000, 'ºC'),
	(124001, 108, '2015-04-01 01:25:57.000000', 'temperatura', 139.0000, 'ºC'),
	(124002, 108, '2015-04-01 01:25:58.000000', 'temperatura', 230.0000, 'ºC'),
	(124003, 108, '2015-04-01 01:25:59.000000', 'temperatura', 733.0000, 'ºC'),
	(124004, 108, '2015-04-01 01:26:00.000000', 'temperatura', 577.0000, 'ºC'),
	(124005, 108, '2015-04-01 01:26:01.000000', 'temperatura', 685.0000, 'ºC'),
	(124006, 108, '2015-04-01 01:26:02.000000', 'temperatura', 496.0000, 'ºC'),
	(124007, 108, '2015-04-01 01:26:03.000000', 'temperatura', 426.0000, 'ºC'),
	(124008, 108, '2015-04-01 01:26:04.000000', 'temperatura', 643.0000, 'ºC'),
	(124009, 108, '2015-04-01 01:26:05.000000', 'temperatura', 737.0000, 'ºC'),
	(124010, 108, '2015-04-01 01:26:06.000000', 'temperatura', 555.0000, 'ºC'),
	(124011, 108, '2015-04-01 01:26:07.000000', 'temperatura', 567.0000, 'ºC'),
	(124012, 108, '2015-04-01 01:26:08.000000', 'temperatura', 1168.0000, 'ºC'),
	(124013, 108, '2015-04-01 01:26:09.000000', 'temperatura', 538.0000, 'ºC'),
	(124014, 108, '2015-04-01 01:26:10.000000', 'temperatura', 389.0000, 'ºC'),
	(124015, 108, '2015-04-01 01:26:11.000000', 'temperatura', 333.0000, 'ºC'),
	(124016, 108, '2015-04-01 01:26:12.000000', 'temperatura', 497.0000, 'ºC'),
	(124017, 108, '2015-04-01 01:26:13.000000', 'temperatura', 286.0000, 'ºC'),
	(124018, 108, '2015-04-01 01:26:14.000000', 'temperatura', 1139.0000, 'ºC'),
	(124019, 108, '2015-04-01 01:26:15.000000', 'temperatura', 39.0000, 'ºC'),
	(124020, 108, '2015-04-01 01:26:16.000000', 'temperatura', 380.0000, 'ºC'),
	(124021, 108, '2015-04-01 01:26:17.000000', 'temperatura', 580.0000, 'ºC'),
	(124022, 108, '2015-04-01 01:26:18.000000', 'temperatura', 564.0000, 'ºC'),
	(124023, 108, '2015-04-01 01:26:19.000000', 'temperatura', 1078.0000, 'ºC'),
	(124024, 108, '2015-04-01 01:26:20.000000', 'temperatura', 99.0000, 'ºC'),
	(124025, 108, '2015-04-01 01:26:21.000000', 'temperatura', 863.0000, 'ºC'),
	(124026, 108, '2015-04-01 01:26:22.000000', 'temperatura', 419.0000, 'ºC'),
	(124027, 108, '2015-04-01 01:26:23.000000', 'temperatura', 707.0000, 'ºC'),
	(124028, 108, '2015-04-01 01:26:24.000000', 'temperatura', 1077.0000, 'ºC'),
	(124029, 108, '2015-04-01 01:26:25.000000', 'temperatura', 866.0000, 'ºC'),
	(124030, 108, '2015-04-01 01:26:26.000000', 'temperatura', 1100.0000, 'ºC'),
	(124031, 108, '2015-04-01 01:26:27.000000', 'temperatura', 504.0000, 'ºC'),
	(124032, 108, '2015-04-01 01:26:28.000000', 'temperatura', 417.0000, 'ºC'),
	(124033, 108, '2015-04-01 01:26:29.000000', 'temperatura', 577.0000, 'ºC'),
	(124034, 108, '2015-04-01 01:26:30.000000', 'temperatura', 431.0000, 'ºC'),
	(124035, 108, '2015-04-01 01:26:31.000000', 'temperatura', 425.0000, 'ºC'),
	(124036, 108, '2015-04-01 01:26:32.000000', 'temperatura', 835.0000, 'ºC'),
	(124037, 108, '2015-04-01 01:26:33.000000', 'temperatura', 498.0000, 'ºC'),
	(124038, 108, '2015-04-01 01:26:34.000000', 'temperatura', 1188.0000, 'ºC'),
	(124039, 108, '2015-04-01 01:26:35.000000', 'temperatura', 846.0000, 'ºC'),
	(124040, 108, '2015-04-01 01:26:36.000000', 'temperatura', 668.0000, 'ºC'),
	(124041, 108, '2015-04-01 01:26:37.000000', 'temperatura', 802.0000, 'ºC'),
	(124042, 108, '2015-04-01 01:26:38.000000', 'temperatura', 805.0000, 'ºC'),
	(124043, 108, '2015-04-01 01:26:39.000000', 'temperatura', 419.0000, 'ºC'),
	(124044, 108, '2015-04-01 01:26:40.000000', 'temperatura', 879.0000, 'ºC'),
	(124045, 108, '2015-04-01 01:26:41.000000', 'temperatura', 742.0000, 'ºC'),
	(124046, 108, '2015-04-01 01:26:42.000000', 'temperatura', 1071.0000, 'ºC'),
	(124047, 108, '2015-04-01 01:26:43.000000', 'temperatura', 729.0000, 'ºC'),
	(124048, 108, '2015-04-01 01:26:44.000000', 'temperatura', 432.0000, 'ºC'),
	(124049, 108, '2015-04-01 01:26:45.000000', 'temperatura', 1173.0000, 'ºC'),
	(124050, 108, '2015-04-01 01:26:46.000000', 'temperatura', 970.0000, 'ºC'),
	(124051, 108, '2015-04-01 01:26:47.000000', 'temperatura', 133.0000, 'ºC'),
	(124052, 108, '2015-04-01 01:26:48.000000', 'temperatura', 156.0000, 'ºC'),
	(124053, 108, '2015-04-01 01:26:49.000000', 'temperatura', 379.0000, 'ºC'),
	(124054, 108, '2015-04-01 01:26:50.000000', 'temperatura', 228.0000, 'ºC'),
	(124055, 108, '2015-04-01 01:26:51.000000', 'temperatura', 6.0000, 'ºC'),
	(124056, 108, '2015-04-01 01:26:52.000000', 'temperatura', 544.0000, 'ºC'),
	(124057, 108, '2015-04-01 01:26:53.000000', 'temperatura', 303.0000, 'ºC'),
	(124058, 108, '2015-04-01 01:26:54.000000', 'temperatura', 1084.0000, 'ºC'),
	(124059, 108, '2015-04-01 01:26:55.000000', 'temperatura', 912.0000, 'ºC'),
	(124060, 108, '2015-04-01 01:26:56.000000', 'temperatura', 108.0000, 'ºC'),
	(124061, 108, '2015-04-01 01:26:57.000000', 'temperatura', 204.0000, 'ºC'),
	(124062, 108, '2015-04-01 01:26:58.000000', 'temperatura', 699.0000, 'ºC'),
	(124063, 108, '2015-04-01 01:26:59.000000', 'temperatura', 480.0000, 'ºC'),
	(124064, 108, '2015-04-01 01:27:00.000000', 'temperatura', 305.0000, 'ºC'),
	(124065, 108, '2015-04-01 01:27:01.000000', 'temperatura', 84.0000, 'ºC'),
	(124066, 108, '2015-04-01 01:27:02.000000', 'temperatura', 706.0000, 'ºC'),
	(124067, 108, '2015-04-01 01:27:03.000000', 'temperatura', 880.0000, 'ºC'),
	(124068, 108, '2015-04-01 01:27:04.000000', 'temperatura', 1081.0000, 'ºC'),
	(124069, 108, '2015-04-01 01:27:05.000000', 'temperatura', 367.0000, 'ºC'),
	(124070, 108, '2015-04-01 01:27:06.000000', 'temperatura', 992.0000, 'ºC'),
	(124071, 108, '2015-04-01 01:27:07.000000', 'temperatura', 258.0000, 'ºC'),
	(124072, 108, '2015-04-01 01:27:08.000000', 'temperatura', 715.0000, 'ºC'),
	(124073, 108, '2015-04-01 01:27:09.000000', 'temperatura', 404.0000, 'ºC'),
	(124074, 108, '2015-04-01 01:27:10.000000', 'temperatura', 1073.0000, 'ºC'),
	(124075, 108, '2015-04-01 01:27:11.000000', 'temperatura', 556.0000, 'ºC'),
	(124076, 108, '2015-04-01 01:27:12.000000', 'temperatura', 758.0000, 'ºC'),
	(124077, 108, '2015-04-01 01:27:13.000000', 'temperatura', 925.0000, 'ºC'),
	(124078, 108, '2015-04-01 01:27:14.000000', 'temperatura', 1152.0000, 'ºC'),
	(124079, 108, '2015-04-01 01:27:15.000000', 'temperatura', 585.0000, 'ºC'),
	(124080, 108, '2015-04-01 01:27:16.000000', 'temperatura', 667.0000, 'ºC'),
	(124081, 108, '2015-04-01 01:27:17.000000', 'temperatura', 384.0000, 'ºC'),
	(124082, 108, '2015-04-01 01:27:18.000000', 'temperatura', 1117.0000, 'ºC'),
	(124083, 108, '2015-04-01 01:27:19.000000', 'temperatura', 833.0000, 'ºC'),
	(124084, 108, '2015-04-01 01:27:20.000000', 'temperatura', 814.0000, 'ºC'),
	(124085, 108, '2015-04-01 01:27:21.000000', 'temperatura', 371.0000, 'ºC'),
	(124086, 108, '2015-04-01 01:27:22.000000', 'temperatura', 615.0000, 'ºC'),
	(124087, 108, '2015-04-01 01:27:23.000000', 'temperatura', 763.0000, 'ºC'),
	(124088, 108, '2015-04-01 01:27:24.000000', 'temperatura', 768.0000, 'ºC'),
	(124089, 108, '2015-04-01 01:27:25.000000', 'temperatura', 354.0000, 'ºC'),
	(124090, 108, '2015-04-01 01:27:26.000000', 'temperatura', 666.0000, 'ºC'),
	(124091, 108, '2015-04-01 01:27:27.000000', 'temperatura', 1068.0000, 'ºC'),
	(124092, 108, '2015-04-01 01:27:28.000000', 'temperatura', 945.0000, 'ºC'),
	(124093, 108, '2015-04-01 01:27:29.000000', 'temperatura', 319.0000, 'ºC'),
	(124094, 108, '2015-04-01 01:27:30.000000', 'temperatura', 1159.0000, 'ºC'),
	(124095, 108, '2015-04-01 01:27:31.000000', 'temperatura', 40.0000, 'ºC'),
	(124096, 108, '2015-04-01 01:27:32.000000', 'temperatura', 325.0000, 'ºC'),
	(124097, 108, '2015-04-01 01:27:33.000000', 'temperatura', 303.0000, 'ºC'),
	(124098, 108, '2015-04-01 01:27:34.000000', 'temperatura', 540.0000, 'ºC'),
	(124099, 108, '2015-04-01 01:27:35.000000', 'temperatura', 594.0000, 'ºC'),
	(124100, 108, '2015-04-01 01:27:36.000000', 'temperatura', 148.0000, 'ºC'),
	(124101, 108, '2015-04-01 01:27:37.000000', 'temperatura', 160.0000, 'ºC'),
	(124102, 108, '2015-04-01 01:27:38.000000', 'temperatura', 355.0000, 'ºC'),
	(124103, 108, '2015-04-01 01:27:39.000000', 'temperatura', 98.0000, 'ºC'),
	(124104, 108, '2015-04-01 01:27:40.000000', 'temperatura', 624.0000, 'ºC'),
	(124105, 108, '2015-04-01 01:27:41.000000', 'temperatura', 427.0000, 'ºC'),
	(124106, 108, '2015-04-01 01:27:42.000000', 'temperatura', 263.0000, 'ºC'),
	(124107, 108, '2015-04-01 01:27:43.000000', 'temperatura', 35.0000, 'ºC'),
	(124108, 108, '2015-04-01 01:27:44.000000', 'temperatura', 585.0000, 'ºC'),
	(124109, 108, '2015-04-01 01:27:45.000000', 'temperatura', 421.0000, 'ºC'),
	(124110, 108, '2015-04-01 01:27:46.000000', 'temperatura', 351.0000, 'ºC'),
	(124111, 108, '2015-04-01 01:27:47.000000', 'temperatura', 494.0000, 'ºC'),
	(124112, 108, '2015-04-01 01:27:48.000000', 'temperatura', 218.0000, 'ºC'),
	(124113, 108, '2015-04-01 01:27:49.000000', 'temperatura', 808.0000, 'ºC'),
	(124114, 108, '2015-04-01 01:27:50.000000', 'temperatura', 986.0000, 'ºC'),
	(124115, 108, '2015-04-01 01:27:51.000000', 'temperatura', 108.0000, 'ºC'),
	(124116, 108, '2015-04-01 01:27:52.000000', 'temperatura', 1183.0000, 'ºC'),
	(124117, 108, '2015-04-01 01:27:53.000000', 'temperatura', 791.0000, 'ºC'),
	(124118, 108, '2015-04-01 01:27:54.000000', 'temperatura', 404.0000, 'ºC'),
	(124119, 108, '2015-04-01 01:27:55.000000', 'temperatura', 850.0000, 'ºC'),
	(124120, 108, '2015-04-01 01:27:56.000000', 'temperatura', 637.0000, 'ºC'),
	(124121, 108, '2015-04-01 01:27:57.000000', 'temperatura', 637.0000, 'ºC'),
	(124122, 108, '2015-04-01 01:27:58.000000', 'temperatura', 75.0000, 'ºC'),
	(124123, 108, '2015-04-01 01:27:59.000000', 'temperatura', 862.0000, 'ºC'),
	(124124, 108, '2015-04-01 01:28:00.000000', 'temperatura', 488.0000, 'ºC'),
	(124125, 108, '2015-04-01 01:28:01.000000', 'temperatura', 1054.0000, 'ºC'),
	(124126, 108, '2015-04-01 01:28:02.000000', 'temperatura', 205.0000, 'ºC'),
	(124127, 108, '2015-04-01 01:28:03.000000', 'temperatura', 264.0000, 'ºC'),
	(124128, 108, '2015-04-01 01:28:04.000000', 'temperatura', 704.0000, 'ºC'),
	(124129, 108, '2015-04-01 01:28:05.000000', 'temperatura', 332.0000, 'ºC'),
	(124130, 108, '2015-04-01 01:28:06.000000', 'temperatura', 745.0000, 'ºC'),
	(124131, 108, '2015-04-01 01:28:07.000000', 'temperatura', 333.0000, 'ºC'),
	(124132, 108, '2015-04-01 01:28:08.000000', 'temperatura', 628.0000, 'ºC'),
	(124133, 108, '2015-04-01 01:28:09.000000', 'temperatura', 943.0000, 'ºC'),
	(124134, 108, '2015-04-01 01:28:10.000000', 'temperatura', 432.0000, 'ºC'),
	(124135, 108, '2015-04-01 01:28:11.000000', 'temperatura', 529.0000, 'ºC'),
	(124136, 108, '2015-04-01 01:28:12.000000', 'temperatura', 150.0000, 'ºC'),
	(124137, 108, '2015-04-01 01:28:13.000000', 'temperatura', 364.0000, 'ºC'),
	(124138, 108, '2015-04-01 01:28:14.000000', 'temperatura', 172.0000, 'ºC'),
	(124139, 108, '2015-04-01 01:28:15.000000', 'temperatura', 969.0000, 'ºC'),
	(124140, 108, '2015-04-01 01:28:16.000000', 'temperatura', 729.0000, 'ºC'),
	(124141, 108, '2015-04-01 01:28:17.000000', 'temperatura', 739.0000, 'ºC'),
	(124142, 108, '2015-04-01 01:28:18.000000', 'temperatura', 306.0000, 'ºC'),
	(124143, 108, '2015-04-01 01:28:19.000000', 'temperatura', 514.0000, 'ºC'),
	(124144, 108, '2015-04-01 01:28:20.000000', 'temperatura', 455.0000, 'ºC'),
	(124145, 108, '2015-04-01 01:28:21.000000', 'temperatura', 732.0000, 'ºC'),
	(124146, 108, '2015-04-01 01:28:22.000000', 'temperatura', 1094.0000, 'ºC'),
	(124147, 108, '2015-04-01 01:28:23.000000', 'temperatura', 877.0000, 'ºC'),
	(124148, 108, '2015-04-01 01:28:24.000000', 'temperatura', 1101.0000, 'ºC'),
	(124149, 108, '2015-04-01 01:28:25.000000', 'temperatura', 476.0000, 'ºC'),
	(124150, 108, '2015-04-01 01:28:26.000000', 'temperatura', 277.0000, 'ºC'),
	(124151, 108, '2015-04-01 01:28:27.000000', 'temperatura', 1159.0000, 'ºC'),
	(124152, 108, '2015-04-01 01:28:28.000000', 'temperatura', 162.0000, 'ºC'),
	(124153, 108, '2015-04-01 01:28:29.000000', 'temperatura', 934.0000, 'ºC'),
	(124154, 108, '2015-04-01 01:28:30.000000', 'temperatura', 584.0000, 'ºC'),
	(124155, 108, '2015-04-01 01:28:31.000000', 'temperatura', 119.0000, 'ºC'),
	(124156, 108, '2015-04-01 01:28:32.000000', 'temperatura', 44.0000, 'ºC'),
	(124157, 108, '2015-04-01 01:28:33.000000', 'temperatura', 1062.0000, 'ºC'),
	(124158, 108, '2015-04-01 01:28:34.000000', 'temperatura', 380.0000, 'ºC'),
	(124159, 108, '2015-04-01 01:28:35.000000', 'temperatura', 1114.0000, 'ºC'),
	(124160, 108, '2015-04-01 01:28:36.000000', 'temperatura', 829.0000, 'ºC'),
	(124161, 108, '2015-04-01 01:28:37.000000', 'temperatura', 803.0000, 'ºC'),
	(124162, 108, '2015-04-01 01:28:38.000000', 'temperatura', 330.0000, 'ºC'),
	(124163, 108, '2015-04-01 01:28:39.000000', 'temperatura', 441.0000, 'ºC'),
	(124164, 108, '2015-04-01 01:28:40.000000', 'temperatura', 14.0000, 'ºC'),
	(124165, 108, '2015-04-01 01:28:41.000000', 'temperatura', 1149.0000, 'ºC'),
	(124166, 108, '2015-04-01 01:28:42.000000', 'temperatura', 902.0000, 'ºC'),
	(124167, 108, '2015-04-01 01:28:43.000000', 'temperatura', 1066.0000, 'ºC'),
	(124168, 108, '2015-04-01 01:28:44.000000', 'temperatura', 222.0000, 'ºC'),
	(124169, 108, '2015-04-01 01:28:45.000000', 'temperatura', 314.0000, 'ºC'),
	(124170, 108, '2015-04-01 01:28:46.000000', 'temperatura', 905.0000, 'ºC'),
	(124171, 108, '2015-04-01 01:28:47.000000', 'temperatura', 1182.0000, 'ºC'),
	(124172, 108, '2015-04-01 01:28:48.000000', 'temperatura', 796.0000, 'ºC'),
	(124173, 108, '2015-04-01 01:28:49.000000', 'temperatura', 433.0000, 'ºC'),
	(124174, 108, '2015-04-01 01:28:50.000000', 'temperatura', 978.0000, 'ºC'),
	(124175, 108, '2015-04-01 01:28:51.000000', 'temperatura', 1191.0000, 'ºC'),
	(124176, 108, '2015-04-01 01:28:52.000000', 'temperatura', 623.0000, 'ºC'),
	(124177, 108, '2015-04-01 01:28:53.000000', 'temperatura', 741.0000, 'ºC'),
	(124178, 108, '2015-04-01 01:28:54.000000', 'temperatura', 637.0000, 'ºC'),
	(124179, 108, '2015-04-01 01:28:55.000000', 'temperatura', 961.0000, 'ºC'),
	(124180, 108, '2015-04-01 01:28:56.000000', 'temperatura', 494.0000, 'ºC'),
	(124181, 108, '2015-04-01 01:28:57.000000', 'temperatura', 787.0000, 'ºC'),
	(124182, 108, '2015-04-01 01:28:58.000000', 'temperatura', 55.0000, 'ºC'),
	(124183, 108, '2015-04-01 01:28:59.000000', 'temperatura', 314.0000, 'ºC'),
	(124184, 108, '2015-04-01 01:29:00.000000', 'temperatura', 207.0000, 'ºC'),
	(124185, 108, '2015-04-01 01:29:01.000000', 'temperatura', 94.0000, 'ºC'),
	(124186, 108, '2015-04-01 01:29:02.000000', 'temperatura', 1048.0000, 'ºC'),
	(124187, 108, '2015-04-01 01:29:03.000000', 'temperatura', 159.0000, 'ºC'),
	(124188, 108, '2015-04-01 01:29:04.000000', 'temperatura', 51.0000, 'ºC'),
	(124189, 108, '2015-04-01 01:29:05.000000', 'temperatura', 980.0000, 'ºC'),
	(124190, 108, '2015-04-01 01:29:06.000000', 'temperatura', 1146.0000, 'ºC'),
	(124191, 108, '2015-04-01 01:29:07.000000', 'temperatura', 391.0000, 'ºC'),
	(124192, 108, '2015-04-01 01:29:08.000000', 'temperatura', 918.0000, 'ºC'),
	(124193, 108, '2015-04-01 01:29:09.000000', 'temperatura', 1015.0000, 'ºC'),
	(124194, 108, '2015-04-01 01:29:10.000000', 'temperatura', 1125.0000, 'ºC'),
	(124195, 108, '2015-04-01 01:29:11.000000', 'temperatura', 177.0000, 'ºC'),
	(124196, 108, '2015-04-01 01:29:12.000000', 'temperatura', 1114.0000, 'ºC'),
	(124197, 108, '2015-04-01 01:29:13.000000', 'temperatura', 237.0000, 'ºC'),
	(124198, 108, '2015-04-01 01:29:14.000000', 'temperatura', 246.0000, 'ºC'),
	(124199, 108, '2015-04-01 01:29:15.000000', 'temperatura', 519.0000, 'ºC'),
	(124200, 108, '2015-04-01 01:29:16.000000', 'temperatura', 659.0000, 'ºC'),
	(124201, 108, '2015-04-01 01:29:17.000000', 'temperatura', 538.0000, 'ºC'),
	(124202, 108, '2015-04-01 01:29:18.000000', 'temperatura', 712.0000, 'ºC'),
	(124203, 108, '2015-04-01 01:29:19.000000', 'temperatura', 746.0000, 'ºC'),
	(124204, 108, '2015-04-01 01:29:20.000000', 'temperatura', 396.0000, 'ºC'),
	(124205, 108, '2015-04-01 01:29:21.000000', 'temperatura', 942.0000, 'ºC'),
	(124206, 108, '2015-04-01 01:29:22.000000', 'temperatura', 1125.0000, 'ºC'),
	(124207, 108, '2015-04-01 01:29:23.000000', 'temperatura', 396.0000, 'ºC'),
	(124208, 108, '2015-04-01 01:29:24.000000', 'temperatura', 1005.0000, 'ºC'),
	(124209, 108, '2015-04-01 01:29:25.000000', 'temperatura', 241.0000, 'ºC'),
	(124210, 108, '2015-04-01 01:29:26.000000', 'temperatura', 588.0000, 'ºC'),
	(124211, 108, '2015-04-01 01:29:27.000000', 'temperatura', 1019.0000, 'ºC'),
	(124212, 108, '2015-04-01 01:29:28.000000', 'temperatura', 930.0000, 'ºC'),
	(124213, 108, '2015-04-01 01:29:29.000000', 'temperatura', 396.0000, 'ºC'),
	(124214, 108, '2015-04-01 01:29:30.000000', 'temperatura', 390.0000, 'ºC'),
	(124215, 108, '2015-04-01 01:29:31.000000', 'temperatura', 760.0000, 'ºC'),
	(124216, 108, '2015-04-01 01:29:32.000000', 'temperatura', 232.0000, 'ºC'),
	(124217, 108, '2015-04-01 01:29:33.000000', 'temperatura', 79.0000, 'ºC'),
	(124218, 108, '2015-04-01 01:29:34.000000', 'temperatura', 901.0000, 'ºC'),
	(124219, 108, '2015-04-01 01:29:35.000000', 'temperatura', 667.0000, 'ºC'),
	(124220, 108, '2015-04-01 01:29:36.000000', 'temperatura', 632.0000, 'ºC'),
	(124221, 108, '2015-04-01 01:29:37.000000', 'temperatura', 1162.0000, 'ºC'),
	(124222, 108, '2015-04-01 01:29:38.000000', 'temperatura', 312.0000, 'ºC'),
	(124223, 108, '2015-04-01 01:29:39.000000', 'temperatura', 475.0000, 'ºC'),
	(124224, 108, '2015-04-01 01:29:40.000000', 'temperatura', 238.0000, 'ºC'),
	(124225, 108, '2015-04-01 01:29:41.000000', 'temperatura', 967.0000, 'ºC'),
	(124226, 108, '2015-04-01 01:29:42.000000', 'temperatura', 521.0000, 'ºC'),
	(124227, 108, '2015-04-01 01:29:43.000000', 'temperatura', 903.0000, 'ºC'),
	(124228, 108, '2015-04-01 01:29:44.000000', 'temperatura', 552.0000, 'ºC'),
	(124229, 108, '2015-04-01 01:29:45.000000', 'temperatura', 55.0000, 'ºC'),
	(124230, 108, '2015-04-01 01:29:46.000000', 'temperatura', 1017.0000, 'ºC'),
	(124231, 108, '2015-04-01 01:29:47.000000', 'temperatura', 121.0000, 'ºC'),
	(124232, 108, '2015-04-01 01:29:48.000000', 'temperatura', 1153.0000, 'ºC'),
	(124233, 108, '2015-04-01 01:29:49.000000', 'temperatura', 606.0000, 'ºC'),
	(124234, 108, '2015-04-01 01:29:50.000000', 'temperatura', 768.0000, 'ºC'),
	(124235, 108, '2015-04-01 01:29:51.000000', 'temperatura', 823.0000, 'ºC'),
	(124236, 108, '2015-04-01 01:29:52.000000', 'temperatura', 610.0000, 'ºC'),
	(124237, 108, '2015-04-01 01:29:53.000000', 'temperatura', 584.0000, 'ºC'),
	(124238, 108, '2015-04-01 01:29:54.000000', 'temperatura', 1092.0000, 'ºC'),
	(124239, 108, '2015-04-01 01:29:55.000000', 'temperatura', 106.0000, 'ºC'),
	(124240, 108, '2015-04-01 01:29:56.000000', 'temperatura', 855.0000, 'ºC'),
	(124241, 108, '2015-04-01 01:29:57.000000', 'temperatura', 357.0000, 'ºC'),
	(124242, 108, '2015-04-01 01:29:58.000000', 'temperatura', 420.0000, 'ºC'),
	(124243, 108, '2015-04-01 01:29:59.000000', 'temperatura', 1029.0000, 'ºC'),
	(124244, 108, '2015-04-01 01:30:00.000000', 'temperatura', 288.0000, 'ºC'),
	(124245, 108, '2015-04-01 01:30:01.000000', 'temperatura', 753.0000, 'ºC'),
	(124246, 108, '2015-04-01 01:30:02.000000', 'temperatura', 500.0000, 'ºC'),
	(124247, 108, '2015-04-01 01:30:03.000000', 'temperatura', 241.0000, 'ºC'),
	(124248, 108, '2015-04-01 01:30:04.000000', 'temperatura', 908.0000, 'ºC'),
	(124249, 108, '2015-04-01 01:30:05.000000', 'temperatura', 217.0000, 'ºC'),
	(124250, 108, '2015-04-01 01:30:06.000000', 'temperatura', 761.0000, 'ºC'),
	(124251, 108, '2015-04-01 01:30:07.000000', 'temperatura', 754.0000, 'ºC'),
	(124252, 108, '2015-04-01 01:30:08.000000', 'temperatura', 288.0000, 'ºC'),
	(124253, 108, '2015-04-01 01:30:09.000000', 'temperatura', 380.0000, 'ºC'),
	(124254, 108, '2015-04-01 01:30:10.000000', 'temperatura', 1034.0000, 'ºC'),
	(124255, 108, '2015-04-01 01:30:11.000000', 'temperatura', 431.0000, 'ºC'),
	(124256, 108, '2015-04-01 01:30:12.000000', 'temperatura', 252.0000, 'ºC'),
	(124257, 108, '2015-04-01 01:30:13.000000', 'temperatura', 1168.0000, 'ºC'),
	(124258, 108, '2015-04-01 01:30:14.000000', 'temperatura', 287.0000, 'ºC'),
	(124259, 108, '2015-04-01 01:30:15.000000', 'temperatura', 328.0000, 'ºC'),
	(124260, 108, '2015-04-01 01:30:16.000000', 'temperatura', 783.0000, 'ºC'),
	(124261, 108, '2015-04-01 01:30:17.000000', 'temperatura', 530.0000, 'ºC'),
	(124262, 108, '2015-04-01 01:30:18.000000', 'temperatura', 303.0000, 'ºC'),
	(124263, 108, '2015-04-01 01:30:19.000000', 'temperatura', 1125.0000, 'ºC'),
	(124264, 108, '2015-04-01 01:30:20.000000', 'temperatura', 1116.0000, 'ºC'),
	(124265, 108, '2015-04-01 01:30:21.000000', 'temperatura', 1006.0000, 'ºC'),
	(124266, 108, '2015-04-01 01:30:22.000000', 'temperatura', 483.0000, 'ºC'),
	(124267, 108, '2015-04-01 01:30:23.000000', 'temperatura', 596.0000, 'ºC'),
	(124268, 108, '2015-04-01 01:30:24.000000', 'temperatura', 333.0000, 'ºC'),
	(124269, 108, '2015-04-01 01:30:25.000000', 'temperatura', 1075.0000, 'ºC'),
	(124270, 108, '2015-04-01 01:30:26.000000', 'temperatura', 777.0000, 'ºC'),
	(124271, 108, '2015-04-01 01:30:27.000000', 'temperatura', 661.0000, 'ºC'),
	(124272, 108, '2015-04-01 01:30:28.000000', 'temperatura', 975.0000, 'ºC'),
	(124273, 108, '2015-04-01 01:30:29.000000', 'temperatura', 490.0000, 'ºC'),
	(124274, 108, '2015-04-01 01:30:30.000000', 'temperatura', 727.0000, 'ºC'),
	(124275, 108, '2015-04-01 01:30:31.000000', 'temperatura', 967.0000, 'ºC'),
	(124276, 108, '2015-04-01 01:30:32.000000', 'temperatura', 252.0000, 'ºC'),
	(124277, 108, '2015-04-01 01:30:33.000000', 'temperatura', 761.0000, 'ºC'),
	(124278, 108, '2015-04-01 01:30:34.000000', 'temperatura', 650.0000, 'ºC'),
	(124279, 108, '2015-04-01 01:30:35.000000', 'temperatura', 966.0000, 'ºC'),
	(124280, 108, '2015-04-01 01:30:36.000000', 'temperatura', 480.0000, 'ºC'),
	(124281, 108, '2015-04-01 01:30:37.000000', 'temperatura', 703.0000, 'ºC'),
	(124282, 108, '2015-04-01 01:30:38.000000', 'temperatura', 875.0000, 'ºC'),
	(124283, 108, '2015-04-01 01:30:39.000000', 'temperatura', 1065.0000, 'ºC'),
	(124284, 108, '2015-04-01 01:30:40.000000', 'temperatura', 304.0000, 'ºC'),
	(124285, 108, '2015-04-01 01:30:41.000000', 'temperatura', 723.0000, 'ºC'),
	(124286, 108, '2015-04-01 01:30:42.000000', 'temperatura', 303.0000, 'ºC'),
	(124287, 108, '2015-04-01 01:30:43.000000', 'temperatura', 549.0000, 'ºC'),
	(124288, 108, '2015-04-01 01:30:44.000000', 'temperatura', 633.0000, 'ºC'),
	(124289, 108, '2015-04-01 01:30:45.000000', 'temperatura', 321.0000, 'ºC'),
	(124290, 108, '2015-04-01 01:30:46.000000', 'temperatura', 907.0000, 'ºC'),
	(124291, 108, '2015-04-01 01:30:47.000000', 'temperatura', 1171.0000, 'ºC'),
	(124292, 108, '2015-04-01 01:30:48.000000', 'temperatura', 737.0000, 'ºC'),
	(124293, 108, '2015-04-01 01:30:49.000000', 'temperatura', 170.0000, 'ºC'),
	(124294, 108, '2015-04-01 01:30:50.000000', 'temperatura', 1040.0000, 'ºC'),
	(124295, 108, '2015-04-01 01:30:51.000000', 'temperatura', 1093.0000, 'ºC'),
	(124296, 108, '2015-04-01 01:30:52.000000', 'temperatura', 1142.0000, 'ºC'),
	(124297, 108, '2015-04-01 01:30:53.000000', 'temperatura', 32.0000, 'ºC'),
	(124298, 108, '2015-04-01 01:30:54.000000', 'temperatura', 337.0000, 'ºC'),
	(124299, 108, '2015-04-01 01:30:55.000000', 'temperatura', 387.0000, 'ºC'),
	(124300, 108, '2015-04-01 01:30:56.000000', 'temperatura', 924.0000, 'ºC'),
	(124301, 108, '2015-04-01 01:30:57.000000', 'temperatura', 1060.0000, 'ºC'),
	(124302, 108, '2015-04-01 01:30:58.000000', 'temperatura', 128.0000, 'ºC'),
	(124303, 108, '2015-04-01 01:30:59.000000', 'temperatura', 1061.0000, 'ºC'),
	(124304, 108, '2015-04-01 01:31:00.000000', 'temperatura', 120.0000, 'ºC'),
	(124305, 108, '2015-04-01 01:31:01.000000', 'temperatura', 1019.0000, 'ºC'),
	(124306, 108, '2015-04-01 01:31:02.000000', 'temperatura', 1135.0000, 'ºC'),
	(124307, 108, '2015-04-01 01:31:03.000000', 'temperatura', 220.0000, 'ºC'),
	(124308, 108, '2015-04-01 01:31:04.000000', 'temperatura', 94.0000, 'ºC'),
	(124309, 108, '2015-04-01 01:31:05.000000', 'temperatura', 1009.0000, 'ºC'),
	(124310, 108, '2015-04-01 01:31:06.000000', 'temperatura', 1164.0000, 'ºC'),
	(124311, 108, '2015-04-01 01:31:07.000000', 'temperatura', 396.0000, 'ºC'),
	(124312, 108, '2015-04-01 01:31:08.000000', 'temperatura', 888.0000, 'ºC'),
	(124313, 108, '2015-04-01 01:31:09.000000', 'temperatura', 852.0000, 'ºC'),
	(124314, 108, '2015-04-01 01:31:10.000000', 'temperatura', 395.0000, 'ºC'),
	(124315, 108, '2015-04-01 01:31:11.000000', 'temperatura', 622.0000, 'ºC'),
	(124316, 108, '2015-04-01 01:31:12.000000', 'temperatura', 724.0000, 'ºC'),
	(124317, 108, '2015-04-01 01:31:13.000000', 'temperatura', 554.0000, 'ºC'),
	(124318, 108, '2015-04-01 01:31:14.000000', 'temperatura', 600.0000, 'ºC'),
	(124319, 108, '2015-04-01 01:31:15.000000', 'temperatura', 138.0000, 'ºC'),
	(124320, 108, '2015-04-01 01:31:16.000000', 'temperatura', 89.0000, 'ºC'),
	(124321, 108, '2015-04-01 01:31:17.000000', 'temperatura', 31.0000, 'ºC'),
	(124322, 108, '2015-04-01 01:31:18.000000', 'temperatura', 1088.0000, 'ºC'),
	(124323, 108, '2015-04-01 01:31:19.000000', 'temperatura', 550.0000, 'ºC'),
	(124324, 108, '2015-04-01 01:31:20.000000', 'temperatura', 687.0000, 'ºC'),
	(124325, 108, '2015-04-01 01:31:21.000000', 'temperatura', 586.0000, 'ºC'),
	(124326, 108, '2015-04-01 01:31:22.000000', 'temperatura', 867.0000, 'ºC'),
	(124327, 108, '2015-04-01 01:31:23.000000', 'temperatura', 180.0000, 'ºC'),
	(124328, 108, '2015-04-01 01:31:24.000000', 'temperatura', 698.0000, 'ºC'),
	(124329, 108, '2015-04-01 01:31:25.000000', 'temperatura', 553.0000, 'ºC'),
	(124330, 108, '2015-04-01 01:31:26.000000', 'temperatura', 668.0000, 'ºC'),
	(124331, 108, '2015-04-01 01:31:27.000000', 'temperatura', 482.0000, 'ºC'),
	(124332, 108, '2015-04-01 01:31:28.000000', 'temperatura', 409.0000, 'ºC'),
	(124333, 108, '2015-04-01 01:31:29.000000', 'temperatura', 599.0000, 'ºC'),
	(124334, 108, '2015-04-01 01:31:30.000000', 'temperatura', 569.0000, 'ºC'),
	(124335, 108, '2015-04-01 01:31:31.000000', 'temperatura', 1049.0000, 'ºC'),
	(124336, 108, '2015-04-01 01:31:32.000000', 'temperatura', 1137.0000, 'ºC'),
	(124337, 108, '2015-04-01 01:31:33.000000', 'temperatura', 140.0000, 'ºC'),
	(124338, 108, '2015-04-01 01:31:34.000000', 'temperatura', 890.0000, 'ºC'),
	(124339, 108, '2015-04-01 01:31:35.000000', 'temperatura', 429.0000, 'ºC'),
	(124340, 108, '2015-04-01 01:31:36.000000', 'temperatura', 674.0000, 'ºC'),
	(124341, 108, '2015-04-01 01:31:37.000000', 'temperatura', 886.0000, 'ºC'),
	(124342, 108, '2015-04-01 01:31:38.000000', 'temperatura', 7.0000, 'ºC'),
	(124343, 108, '2015-04-01 01:31:39.000000', 'temperatura', 976.0000, 'ºC'),
	(124344, 108, '2015-04-01 01:31:40.000000', 'temperatura', 61.0000, 'ºC'),
	(124345, 108, '2015-04-01 01:31:41.000000', 'temperatura', 979.0000, 'ºC'),
	(124346, 108, '2015-04-01 01:31:42.000000', 'temperatura', 1110.0000, 'ºC'),
	(124347, 108, '2015-04-01 01:31:43.000000', 'temperatura', 214.0000, 'ºC'),
	(124348, 108, '2015-04-01 01:31:44.000000', 'temperatura', 142.0000, 'ºC'),
	(124349, 108, '2015-04-01 01:31:45.000000', 'temperatura', 66.0000, 'ºC'),
	(124350, 108, '2015-04-01 01:31:46.000000', 'temperatura', 1107.0000, 'ºC'),
	(124351, 108, '2015-04-01 01:31:47.000000', 'temperatura', 538.0000, 'ºC'),
	(124352, 108, '2015-04-01 01:31:48.000000', 'temperatura', 570.0000, 'ºC'),
	(124353, 108, '2015-04-01 01:31:49.000000', 'temperatura', 36.0000, 'ºC'),
	(124354, 108, '2015-04-01 01:31:50.000000', 'temperatura', 871.0000, 'ºC'),
	(124355, 108, '2015-04-01 01:31:51.000000', 'temperatura', 646.0000, 'ºC'),
	(124356, 108, '2015-04-01 01:31:52.000000', 'temperatura', 616.0000, 'ºC'),
	(124357, 108, '2015-04-01 01:31:53.000000', 'temperatura', 1146.0000, 'ºC'),
	(124358, 108, '2015-04-01 01:31:54.000000', 'temperatura', 281.0000, 'ºC'),
	(124359, 108, '2015-04-01 01:31:55.000000', 'temperatura', 367.0000, 'ºC'),
	(124360, 108, '2015-04-01 01:31:56.000000', 'temperatura', 995.0000, 'ºC'),
	(124361, 108, '2015-04-01 01:31:57.000000', 'temperatura', 272.0000, 'ºC'),
	(124362, 108, '2015-04-01 01:31:58.000000', 'temperatura', 774.0000, 'ºC'),
	(124363, 108, '2015-04-01 01:31:59.000000', 'temperatura', 658.0000, 'ºC'),
	(124364, 108, '2015-04-01 01:32:00.000000', 'temperatura', 968.0000, 'ºC'),
	(124365, 108, '2015-04-01 01:32:01.000000', 'temperatura', 466.0000, 'ºC'),
	(124366, 108, '2015-04-01 01:32:02.000000', 'temperatura', 625.0000, 'ºC'),
	(124367, 108, '2015-04-01 01:32:03.000000', 'temperatura', 527.0000, 'ºC'),
	(124368, 108, '2015-04-01 01:32:04.000000', 'temperatura', 760.0000, 'ºC'),
	(124369, 108, '2015-04-01 01:32:05.000000', 'temperatura', 1021.0000, 'ºC'),
	(124370, 108, '2015-04-01 01:32:06.000000', 'temperatura', 426.0000, 'ºC'),
	(124371, 108, '2015-04-01 01:32:07.000000', 'temperatura', 269.0000, 'ºC'),
	(124372, 108, '2015-04-01 01:32:08.000000', 'temperatura', 65.0000, 'ºC'),
	(124373, 108, '2015-04-01 01:32:09.000000', 'temperatura', 718.0000, 'ºC'),
	(124374, 108, '2015-04-01 01:32:10.000000', 'temperatura', 995.0000, 'ºC'),
	(124375, 108, '2015-04-01 01:32:11.000000', 'temperatura', 421.0000, 'ºC'),
	(124376, 108, '2015-04-01 01:32:12.000000', 'temperatura', 323.0000, 'ºC'),
	(124377, 108, '2015-04-01 01:32:13.000000', 'temperatura', 351.0000, 'ºC'),
	(124378, 108, '2015-04-01 01:32:14.000000', 'temperatura', 785.0000, 'ºC'),
	(124379, 108, '2015-04-01 01:32:15.000000', 'temperatura', 474.0000, 'ºC'),
	(124380, 108, '2015-04-01 01:32:16.000000', 'temperatura', 16.0000, 'ºC'),
	(124381, 108, '2015-04-01 01:32:17.000000', 'temperatura', 1059.0000, 'ºC'),
	(124382, 108, '2015-04-01 01:32:18.000000', 'temperatura', 448.0000, 'ºC'),
	(124383, 108, '2015-04-01 01:32:19.000000', 'temperatura', 262.0000, 'ºC'),
	(124384, 108, '2015-04-01 01:32:20.000000', 'temperatura', 1166.0000, 'ºC'),
	(124385, 108, '2015-04-01 01:32:21.000000', 'temperatura', 243.0000, 'ºC'),
	(124386, 108, '2015-04-01 01:32:22.000000', 'temperatura', 121.0000, 'ºC'),
	(124387, 108, '2015-04-01 01:32:23.000000', 'temperatura', 1075.0000, 'ºC'),
	(124388, 108, '2015-04-01 01:32:24.000000', 'temperatura', 212.0000, 'ºC'),
	(124389, 108, '2015-04-01 01:32:25.000000', 'temperatura', 236.0000, 'ºC'),
	(124390, 108, '2015-04-01 01:32:26.000000', 'temperatura', 546.0000, 'ºC'),
	(124391, 108, '2015-04-01 01:32:27.000000', 'temperatura', 823.0000, 'ºC'),
	(124392, 108, '2015-04-01 01:32:28.000000', 'temperatura', 75.0000, 'ºC'),
	(124393, 108, '2015-04-01 01:32:29.000000', 'temperatura', 307.0000, 'ºC'),
	(124394, 108, '2015-04-01 01:32:30.000000', 'temperatura', 112.0000, 'ºC'),
	(124395, 108, '2015-04-01 01:32:31.000000', 'temperatura', 840.0000, 'ºC'),
	(124396, 108, '2015-04-01 01:32:32.000000', 'temperatura', 265.0000, 'ºC'),
	(124397, 108, '2015-04-01 01:32:33.000000', 'temperatura', 3.0000, 'ºC'),
	(124398, 108, '2015-04-01 01:32:34.000000', 'temperatura', 420.0000, 'ºC'),
	(124399, 108, '2015-04-01 01:32:35.000000', 'temperatura', 893.0000, 'ºC'),
	(124400, 108, '2015-04-01 01:32:36.000000', 'temperatura', 805.0000, 'ºC'),
	(124401, 108, '2015-04-01 01:32:37.000000', 'temperatura', 148.0000, 'ºC'),
	(124402, 108, '2015-04-01 01:32:38.000000', 'temperatura', 723.0000, 'ºC'),
	(124403, 108, '2015-04-01 01:32:39.000000', 'temperatura', 773.0000, 'ºC'),
	(124404, 108, '2015-04-01 01:32:40.000000', 'temperatura', 498.0000, 'ºC'),
	(124405, 108, '2015-04-01 01:32:41.000000', 'temperatura', 169.0000, 'ºC'),
	(124406, 108, '2015-04-01 01:32:42.000000', 'temperatura', 554.0000, 'ºC'),
	(124407, 108, '2015-04-01 01:32:43.000000', 'temperatura', 1063.0000, 'ºC'),
	(124408, 108, '2015-04-01 01:32:44.000000', 'temperatura', 54.0000, 'ºC'),
	(124409, 108, '2015-04-01 01:32:45.000000', 'temperatura', 681.0000, 'ºC'),
	(124410, 108, '2015-04-01 01:32:46.000000', 'temperatura', 844.0000, 'ºC'),
	(124411, 108, '2015-04-01 01:32:47.000000', 'temperatura', 978.0000, 'ºC'),
	(124412, 108, '2015-04-01 01:32:48.000000', 'temperatura', 1156.0000, 'ºC'),
	(124413, 108, '2015-04-01 01:32:49.000000', 'temperatura', 449.0000, 'ºC'),
	(124414, 108, '2015-04-01 01:32:50.000000', 'temperatura', 1176.0000, 'ºC'),
	(124415, 108, '2015-04-01 01:32:51.000000', 'temperatura', 935.0000, 'ºC'),
	(124416, 108, '2015-04-01 01:32:52.000000', 'temperatura', 1147.0000, 'ºC'),
	(124417, 108, '2015-04-01 01:32:53.000000', 'temperatura', 529.0000, 'ºC'),
	(124418, 108, '2015-04-01 01:32:54.000000', 'temperatura', 404.0000, 'ºC'),
	(124419, 108, '2015-04-01 01:32:55.000000', 'temperatura', 433.0000, 'ºC'),
	(124420, 108, '2015-04-01 01:32:56.000000', 'temperatura', 957.0000, 'ºC'),
	(124421, 108, '2015-04-01 01:32:57.000000', 'temperatura', 1083.0000, 'ºC'),
	(124422, 108, '2015-04-01 01:32:58.000000', 'temperatura', 145.0000, 'ºC'),
	(124423, 108, '2015-04-01 01:32:59.000000', 'temperatura', 1078.0000, 'ºC'),
	(124424, 108, '2015-04-01 01:33:00.000000', 'temperatura', 157.0000, 'ºC'),
	(124425, 108, '2015-04-01 01:33:01.000000', 'temperatura', 1149.0000, 'ºC'),
	(124426, 108, '2015-04-01 01:33:02.000000', 'temperatura', 475.0000, 'ºC'),
	(124427, 108, '2015-04-01 01:33:03.000000', 'temperatura', 129.0000, 'ºC'),
	(124428, 108, '2015-04-01 01:33:04.000000', 'temperatura', 420.0000, 'ºC'),
	(124429, 108, '2015-04-01 01:33:05.000000', 'temperatura', 514.0000, 'ºC'),
	(124430, 108, '2015-04-01 01:33:06.000000', 'temperatura', 110.0000, 'ºC'),
	(124431, 108, '2015-04-01 01:33:07.000000', 'temperatura', 207.0000, 'ºC'),
	(124432, 108, '2015-04-01 01:33:08.000000', 'temperatura', 707.0000, 'ºC'),
	(124433, 108, '2015-04-01 01:33:09.000000', 'temperatura', 512.0000, 'ºC'),
	(124434, 108, '2015-04-01 01:33:10.000000', 'temperatura', 443.0000, 'ºC'),
	(124435, 108, '2015-04-01 01:33:11.000000', 'temperatura', 678.0000, 'ºC'),
	(124436, 108, '2015-04-01 01:33:12.000000', 'temperatura', 862.0000, 'ºC'),
	(124437, 108, '2015-04-01 01:33:13.000000', 'temperatura', 1078.0000, 'ºC'),
	(124438, 108, '2015-04-01 01:33:14.000000', 'temperatura', 404.0000, 'ºC'),
	(124439, 108, '2015-04-01 01:33:15.000000', 'temperatura', 1185.0000, 'ºC'),
	(124440, 108, '2015-04-01 01:33:16.000000', 'temperatura', 1115.0000, 'ºC'),
	(124441, 108, '2015-04-01 01:33:17.000000', 'temperatura', 821.0000, 'ºC'),
	(124442, 108, '2015-04-01 01:33:18.000000', 'temperatura', 759.0000, 'ºC'),
	(124443, 108, '2015-04-01 01:33:19.000000', 'temperatura', 135.0000, 'ºC'),
	(124444, 108, '2015-04-01 01:33:20.000000', 'temperatura', 798.0000, 'ºC'),
	(124445, 108, '2015-04-01 01:33:21.000000', 'temperatura', 1184.0000, 'ºC'),
	(124446, 108, '2015-04-01 01:33:22.000000', 'temperatura', 1129.0000, 'ºC'),
	(124447, 108, '2015-04-01 01:33:23.000000', 'temperatura', 892.0000, 'ºC'),
	(124448, 108, '2015-04-01 01:33:24.000000', 'temperatura', 1072.0000, 'ºC'),
	(124449, 108, '2015-04-01 01:33:25.000000', 'temperatura', 284.0000, 'ºC'),
	(124450, 108, '2015-04-01 01:33:26.000000', 'temperatura', 607.0000, 'ºC'),
	(124451, 108, '2015-04-01 01:33:27.000000', 'temperatura', 984.0000, 'ºC'),
	(124452, 108, '2015-04-01 01:33:28.000000', 'temperatura', 700.0000, 'ºC'),
	(124453, 108, '2015-04-01 01:33:29.000000', 'temperatura', 546.0000, 'ºC'),
	(124454, 108, '2015-04-01 01:33:30.000000', 'temperatura', 631.0000, 'ºC'),
	(124455, 108, '2015-04-01 01:33:31.000000', 'temperatura', 319.0000, 'ºC'),
	(124456, 108, '2015-04-01 01:33:32.000000', 'temperatura', 900.0000, 'ºC'),
	(124457, 108, '2015-04-01 01:33:33.000000', 'temperatura', 1147.0000, 'ºC'),
	(124458, 108, '2015-04-01 01:33:34.000000', 'temperatura', 633.0000, 'ºC'),
	(124459, 108, '2015-04-01 01:33:35.000000', 'temperatura', 925.0000, 'ºC'),
	(124460, 108, '2015-04-01 01:33:36.000000', 'temperatura', 326.0000, 'ºC'),
	(124461, 108, '2015-04-01 01:33:37.000000', 'temperatura', 54.0000, 'ºC'),
	(124462, 108, '2015-04-01 01:33:38.000000', 'temperatura', 494.0000, 'ºC'),
	(124463, 108, '2015-04-01 01:33:39.000000', 'temperatura', 1109.0000, 'ºC'),
	(124464, 108, '2015-04-01 01:33:40.000000', 'temperatura', 465.0000, 'ºC'),
	(124465, 108, '2015-04-01 01:33:41.000000', 'temperatura', 195.0000, 'ºC'),
	(124466, 108, '2015-04-01 01:33:42.000000', 'temperatura', 782.0000, 'ºC'),
	(124467, 108, '2015-04-01 01:33:43.000000', 'temperatura', 926.0000, 'ºC'),
	(124468, 108, '2015-04-01 01:33:44.000000', 'temperatura', 1084.0000, 'ºC'),
	(124469, 108, '2015-04-01 01:33:45.000000', 'temperatura', 241.0000, 'ºC'),
	(124470, 108, '2015-04-01 01:33:46.000000', 'temperatura', 355.0000, 'ºC'),
	(124471, 108, '2015-04-01 01:33:47.000000', 'temperatura', 1053.0000, 'ºC'),
	(124472, 108, '2015-04-01 01:33:48.000000', 'temperatura', 599.0000, 'ºC'),
	(124473, 108, '2015-04-01 01:33:49.000000', 'temperatura', 1036.0000, 'ºC'),
	(124474, 108, '2015-04-01 01:33:50.000000', 'temperatura', 984.0000, 'ºC'),
	(124475, 108, '2015-04-01 01:33:51.000000', 'temperatura', 611.0000, 'ºC'),
	(124476, 108, '2015-04-01 01:33:52.000000', 'temperatura', 104.0000, 'ºC'),
	(124477, 108, '2015-04-01 01:33:53.000000', 'temperatura', 1086.0000, 'ºC'),
	(124478, 108, '2015-04-01 01:33:54.000000', 'temperatura', 321.0000, 'ºC'),
	(124479, 108, '2015-04-01 01:33:55.000000', 'temperatura', 748.0000, 'ºC'),
	(124480, 108, '2015-04-01 01:33:56.000000', 'temperatura', 378.0000, 'ºC'),
	(124481, 108, '2015-04-01 01:33:57.000000', 'temperatura', 848.0000, 'ºC'),
	(124482, 108, '2015-04-01 01:33:58.000000', 'temperatura', 703.0000, 'ºC'),
	(124483, 108, '2015-04-01 01:33:59.000000', 'temperatura', 974.0000, 'ºC'),
	(124484, 108, '2015-04-01 01:34:00.000000', 'temperatura', 359.0000, 'ºC'),
	(124485, 108, '2015-04-01 01:34:01.000000', 'temperatura', 74.0000, 'ºC'),
	(124486, 108, '2015-04-01 01:34:02.000000', 'temperatura', 494.0000, 'ºC'),
	(124487, 108, '2015-04-01 01:34:03.000000', 'temperatura', 1050.0000, 'ºC'),
	(124488, 108, '2015-04-01 01:34:04.000000', 'temperatura', 165.0000, 'ºC'),
	(124489, 108, '2015-04-01 01:34:05.000000', 'temperatura', 78.0000, 'ºC'),
	(124490, 108, '2015-04-01 01:34:06.000000', 'temperatura', 1097.0000, 'ºC'),
	(124491, 108, '2015-04-01 01:34:07.000000', 'temperatura', 448.0000, 'ºC'),
	(124492, 108, '2015-04-01 01:34:08.000000', 'temperatura', 152.0000, 'ºC'),
	(124493, 108, '2015-04-01 01:34:09.000000', 'temperatura', 617.0000, 'ºC'),
	(124494, 108, '2015-04-01 01:34:10.000000', 'temperatura', 230.0000, 'ºC'),
	(124495, 108, '2015-04-01 01:34:11.000000', 'temperatura', 499.0000, 'ºC'),
	(124496, 108, '2015-04-01 01:34:12.000000', 'temperatura', 606.0000, 'ºC'),
	(124497, 108, '2015-04-01 01:34:13.000000', 'temperatura', 331.0000, 'ºC'),
	(124498, 108, '2015-04-01 01:34:14.000000', 'temperatura', 1039.0000, 'ºC'),
	(124499, 108, '2015-04-01 01:34:15.000000', 'temperatura', 601.0000, 'ºC'),
	(124500, 108, '2015-04-01 01:34:16.000000', 'temperatura', 1088.0000, 'ºC'),
	(124501, 108, '2015-04-01 01:34:17.000000', 'temperatura', 40.0000, 'ºC'),
	(124502, 108, '2015-04-01 01:34:18.000000', 'temperatura', 536.0000, 'ºC'),
	(124503, 108, '2015-04-01 01:34:19.000000', 'temperatura', 161.0000, 'ºC'),
	(124504, 108, '2015-04-01 01:34:20.000000', 'temperatura', 398.0000, 'ºC'),
	(124505, 108, '2015-04-01 01:34:21.000000', 'temperatura', 308.0000, 'ºC'),
	(124506, 108, '2015-04-01 01:34:22.000000', 'temperatura', 344.0000, 'ºC'),
	(124507, 108, '2015-04-01 01:34:23.000000', 'temperatura', 798.0000, 'ºC'),
	(124508, 108, '2015-04-01 01:34:24.000000', 'temperatura', 559.0000, 'ºC'),
	(124509, 108, '2015-04-01 01:34:25.000000', 'temperatura', 403.0000, 'ºC'),
	(124510, 108, '2015-04-01 01:34:26.000000', 'temperatura', 336.0000, 'ºC'),
	(124511, 108, '2015-04-01 01:34:27.000000', 'temperatura', 472.0000, 'ºC'),
	(124512, 108, '2015-04-01 01:34:28.000000', 'temperatura', 152.0000, 'ºC'),
	(124513, 108, '2015-04-01 01:34:29.000000', 'temperatura', 545.0000, 'ºC'),
	(124514, 108, '2015-04-01 01:34:30.000000', 'temperatura', 1068.0000, 'ºC'),
	(124515, 108, '2015-04-01 01:34:31.000000', 'temperatura', 106.0000, 'ºC'),
	(124516, 108, '2015-04-01 01:34:32.000000', 'temperatura', 926.0000, 'ºC'),
	(124517, 108, '2015-04-01 01:34:33.000000', 'temperatura', 713.0000, 'ºC'),
	(124518, 108, '2015-04-01 01:34:34.000000', 'temperatura', 787.0000, 'ºC'),
	(124519, 108, '2015-04-01 01:34:35.000000', 'temperatura', 597.0000, 'ºC'),
	(124520, 108, '2015-04-01 01:34:36.000000', 'temperatura', 624.0000, 'ºC'),
	(124521, 108, '2015-04-01 01:34:37.000000', 'temperatura', 131.0000, 'ºC'),
	(124522, 108, '2015-04-01 01:34:38.000000', 'temperatura', 1183.0000, 'ºC'),
	(124523, 108, '2015-04-01 01:34:39.000000', 'temperatura', 723.0000, 'ºC'),
	(124524, 108, '2015-04-01 01:34:40.000000', 'temperatura', 68.0000, 'ºC'),
	(124525, 108, '2015-04-01 01:34:41.000000', 'temperatura', 570.0000, 'ºC'),
	(124526, 108, '2015-04-01 01:34:42.000000', 'temperatura', 249.0000, 'ºC'),
	(124527, 108, '2015-04-01 01:34:43.000000', 'temperatura', 732.0000, 'ºC'),
	(124528, 108, '2015-04-01 01:34:44.000000', 'temperatura', 516.0000, 'ºC'),
	(124529, 108, '2015-04-01 01:34:45.000000', 'temperatura', 383.0000, 'ºC'),
	(124530, 108, '2015-04-01 01:34:46.000000', 'temperatura', 366.0000, 'ºC'),
	(124531, 108, '2015-04-01 01:34:47.000000', 'temperatura', 682.0000, 'ºC'),
	(124532, 108, '2015-04-01 01:34:48.000000', 'temperatura', 1114.0000, 'ºC'),
	(124533, 108, '2015-04-01 01:34:49.000000', 'temperatura', 1125.0000, 'ºC'),
	(124534, 108, '2015-04-01 01:34:50.000000', 'temperatura', 1083.0000, 'ºC'),
	(124535, 108, '2015-04-01 01:34:51.000000', 'temperatura', 840.0000, 'ºC'),
	(124536, 108, '2015-04-01 01:34:52.000000', 'temperatura', 951.0000, 'ºC'),
	(124537, 108, '2015-04-01 01:34:53.000000', 'temperatura', 1034.0000, 'ºC'),
	(124538, 108, '2015-04-01 01:34:54.000000', 'temperatura', 1120.0000, 'ºC'),
	(124539, 108, '2015-04-01 01:34:55.000000', 'temperatura', 99.0000, 'ºC'),
	(124540, 108, '2015-04-01 01:34:56.000000', 'temperatura', 734.0000, 'ºC'),
	(124541, 108, '2015-04-01 01:34:57.000000', 'temperatura', 974.0000, 'ºC'),
	(124542, 108, '2015-04-01 01:34:58.000000', 'temperatura', 268.0000, 'ºC'),
	(124543, 108, '2015-04-01 01:34:59.000000', 'temperatura', 819.0000, 'ºC'),
	(124544, 108, '2015-04-01 01:35:00.000000', 'temperatura', 889.0000, 'ºC'),
	(124545, 108, '2015-04-01 01:35:01.000000', 'temperatura', 792.0000, 'ºC'),
	(124546, 108, '2015-04-01 01:35:02.000000', 'temperatura', 92.0000, 'ºC'),
	(124547, 108, '2015-04-01 01:35:03.000000', 'temperatura', 485.0000, 'ºC'),
	(124548, 108, '2015-04-01 01:35:04.000000', 'temperatura', 949.0000, 'ºC'),
	(124549, 108, '2015-04-01 01:35:05.000000', 'temperatura', 891.0000, 'ºC'),
	(124550, 108, '2015-04-01 01:35:06.000000', 'temperatura', 406.0000, 'ºC'),
	(124551, 108, '2015-04-01 01:35:07.000000', 'temperatura', 561.0000, 'ºC'),
	(124552, 108, '2015-04-01 01:35:08.000000', 'temperatura', 387.0000, 'ºC'),
	(124553, 108, '2015-04-01 01:35:09.000000', 'temperatura', 252.0000, 'ºC'),
	(124554, 108, '2015-04-01 01:35:10.000000', 'temperatura', 102.0000, 'ºC'),
	(124555, 108, '2015-04-01 01:35:11.000000', 'temperatura', 951.0000, 'ºC'),
	(124556, 108, '2015-04-01 01:35:12.000000', 'temperatura', 849.0000, 'ºC'),
	(124557, 108, '2015-04-01 01:35:13.000000', 'temperatura', 193.0000, 'ºC'),
	(124558, 108, '2015-04-01 01:35:14.000000', 'temperatura', 820.0000, 'ºC'),
	(124559, 108, '2015-04-01 01:35:15.000000', 'temperatura', 1120.0000, 'ºC'),
	(124560, 108, '2015-04-01 01:35:16.000000', 'temperatura', 741.0000, 'ºC'),
	(124561, 108, '2015-04-01 01:35:17.000000', 'temperatura', 345.0000, 'ºC'),
	(124562, 108, '2015-04-01 01:35:18.000000', 'temperatura', 704.0000, 'ºC'),
	(124563, 108, '2015-04-01 01:35:19.000000', 'temperatura', 86.0000, 'ºC'),
	(124564, 108, '2015-04-01 01:35:20.000000', 'temperatura', 718.0000, 'ºC'),
	(124565, 108, '2015-04-01 01:35:21.000000', 'temperatura', 932.0000, 'ºC'),
	(124566, 108, '2015-04-01 01:35:22.000000', 'temperatura', 107.0000, 'ºC'),
	(124567, 108, '2015-04-01 01:35:23.000000', 'temperatura', 137.0000, 'ºC'),
	(124568, 108, '2015-04-01 01:35:24.000000', 'temperatura', 368.0000, 'ºC'),
	(124569, 108, '2015-04-01 01:35:25.000000', 'temperatura', 228.0000, 'ºC'),
	(124570, 108, '2015-04-01 01:35:26.000000', 'temperatura', 37.0000, 'ºC'),
	(124571, 108, '2015-04-01 01:35:27.000000', 'temperatura', 702.0000, 'ºC'),
	(124572, 108, '2015-04-01 01:35:28.000000', 'temperatura', 1000.0000, 'ºC'),
	(124573, 108, '2015-04-01 01:35:29.000000', 'temperatura', 492.0000, 'ºC'),
	(124574, 108, '2015-04-01 01:35:30.000000', 'temperatura', 662.0000, 'ºC'),
	(124575, 108, '2015-04-01 01:35:31.000000', 'temperatura', 635.0000, 'ºC'),
	(124576, 108, '2015-04-01 01:35:32.000000', 'temperatura', 1189.0000, 'ºC'),
	(124577, 108, '2015-04-01 01:35:33.000000', 'temperatura', 442.0000, 'ºC'),
	(124578, 108, '2015-04-01 01:35:34.000000', 'temperatura', 1044.0000, 'ºC'),
	(124579, 108, '2015-04-01 01:35:35.000000', 'temperatura', 292.0000, 'ºC'),
	(124580, 108, '2015-04-01 01:35:36.000000', 'temperatura', 728.0000, 'ºC'),
	(124581, 108, '2015-04-01 01:35:37.000000', 'temperatura', 366.0000, 'ºC'),
	(124582, 108, '2015-04-01 01:35:38.000000', 'temperatura', 845.0000, 'ºC'),
	(124583, 108, '2015-04-01 01:35:39.000000', 'temperatura', 729.0000, 'ºC'),
	(124584, 108, '2015-04-01 01:35:40.000000', 'temperatura', 1109.0000, 'ºC'),
	(124585, 108, '2015-04-01 01:35:41.000000', 'temperatura', 960.0000, 'ºC'),
	(124586, 108, '2015-04-01 01:35:42.000000', 'temperatura', 274.0000, 'ºC'),
	(124587, 108, '2015-04-01 01:35:43.000000', 'temperatura', 890.0000, 'ºC'),
	(124588, 108, '2015-04-01 01:35:44.000000', 'temperatura', 27.0000, 'ºC'),
	(124589, 108, '2015-04-01 01:35:45.000000', 'temperatura', 1068.0000, 'ºC'),
	(124590, 108, '2015-04-01 01:35:46.000000', 'temperatura', 457.0000, 'ºC'),
	(124591, 108, '2015-04-01 01:35:47.000000', 'temperatura', 281.0000, 'ºC'),
	(124592, 108, '2015-04-01 01:35:48.000000', 'temperatura', 35.0000, 'ºC'),
	(124593, 108, '2015-04-01 01:35:49.000000', 'temperatura', 535.0000, 'ºC'),
	(124594, 108, '2015-04-01 01:35:50.000000', 'temperatura', 168.0000, 'ºC'),
	(124595, 108, '2015-04-01 01:35:51.000000', 'temperatura', 436.0000, 'ºC'),
	(124596, 108, '2015-04-01 01:35:52.000000', 'temperatura', 477.0000, 'ºC'),
	(124597, 108, '2015-04-01 01:35:53.000000', 'temperatura', 1076.0000, 'ºC'),
	(124598, 108, '2015-04-01 01:35:54.000000', 'temperatura', 352.0000, 'ºC'),
	(124599, 108, '2015-04-01 01:35:55.000000', 'temperatura', 930.0000, 'ºC'),
	(124600, 108, '2015-04-01 01:35:56.000000', 'temperatura', 1194.0000, 'ºC'),
	(124601, 108, '2015-04-01 01:35:57.000000', 'temperatura', 781.0000, 'ºC'),
	(124602, 108, '2015-04-01 01:35:58.000000', 'temperatura', 324.0000, 'ºC'),
	(124603, 108, '2015-04-01 01:35:59.000000', 'temperatura', 479.0000, 'ºC'),
	(124604, 108, '2015-04-01 01:36:00.000000', 'temperatura', 222.0000, 'ºC'),
	(124605, 108, '2015-04-01 01:36:01.000000', 'temperatura', 875.0000, 'ºC'),
	(124606, 108, '2015-04-01 01:36:02.000000', 'temperatura', 109.0000, 'ºC'),
	(124607, 108, '2015-04-01 01:36:03.000000', 'temperatura', 319.0000, 'ºC'),
	(124608, 108, '2015-04-01 01:36:04.000000', 'temperatura', 68.0000, 'ºC'),
	(124609, 108, '2015-04-01 01:36:05.000000', 'temperatura', 583.0000, 'ºC'),
	(124610, 108, '2015-04-01 01:36:06.000000', 'temperatura', 314.0000, 'ºC'),
	(124611, 108, '2015-04-01 01:36:07.000000', 'temperatura', 1022.0000, 'ºC'),
	(124612, 108, '2015-04-01 01:36:08.000000', 'temperatura', 566.0000, 'ºC'),
	(124613, 108, '2015-04-01 01:36:09.000000', 'temperatura', 964.0000, 'ºC'),
	(124614, 108, '2015-04-01 01:36:10.000000', 'temperatura', 726.0000, 'ºC'),
	(124615, 108, '2015-04-01 01:36:11.000000', 'temperatura', 735.0000, 'ºC'),
	(124616, 108, '2015-04-01 01:36:12.000000', 'temperatura', 299.0000, 'ºC'),
	(124617, 108, '2015-04-01 01:36:13.000000', 'temperatura', 491.0000, 'ºC'),
	(124618, 108, '2015-04-01 01:36:14.000000', 'temperatura', 357.0000, 'ºC'),
	(124619, 108, '2015-04-01 01:36:15.000000', 'temperatura', 311.0000, 'ºC'),
	(124620, 108, '2015-04-01 01:36:16.000000', 'temperatura', 488.0000, 'ºC'),
	(124621, 108, '2015-04-01 01:36:17.000000', 'temperatura', 304.0000, 'ºC'),
	(124622, 108, '2015-04-01 01:36:18.000000', 'temperatura', 59.0000, 'ºC'),
	(124623, 108, '2015-04-01 01:36:19.000000', 'temperatura', 583.0000, 'ºC'),
	(124624, 108, '2015-04-01 01:36:20.000000', 'temperatura', 336.0000, 'ºC'),
	(124625, 108, '2015-04-01 01:36:21.000000', 'temperatura', 1134.0000, 'ºC'),
	(124626, 108, '2015-04-01 01:36:22.000000', 'temperatura', 1062.0000, 'ºC'),
	(124627, 108, '2015-04-01 01:36:23.000000', 'temperatura', 709.0000, 'ºC'),
	(124628, 108, '2015-04-01 01:36:24.000000', 'temperatura', 360.0000, 'ºC'),
	(124629, 108, '2015-04-01 01:36:25.000000', 'temperatura', 871.0000, 'ºC'),
	(124630, 108, '2015-04-01 01:36:26.000000', 'temperatura', 877.0000, 'ºC'),
	(124631, 108, '2015-04-01 01:36:27.000000', 'temperatura', 573.0000, 'ºC'),
	(124632, 108, '2015-04-01 01:36:28.000000', 'temperatura', 232.0000, 'ºC'),
	(124633, 108, '2015-04-01 01:36:29.000000', 'temperatura', 643.0000, 'ºC'),
	(124634, 108, '2015-04-01 01:36:30.000000', 'temperatura', 121.0000, 'ºC'),
	(124635, 108, '2015-04-01 01:36:31.000000', 'temperatura', 1074.0000, 'ºC'),
	(124636, 108, '2015-04-01 01:36:32.000000', 'temperatura', 209.0000, 'ºC'),
	(124637, 108, '2015-04-01 01:36:33.000000', 'temperatura', 221.0000, 'ºC'),
	(124638, 108, '2015-04-01 01:36:34.000000', 'temperatura', 480.0000, 'ºC'),
	(124639, 108, '2015-04-01 01:36:35.000000', 'temperatura', 537.0000, 'ºC'),
	(124640, 108, '2015-04-01 01:36:36.000000', 'temperatura', 48.0000, 'ºC'),
	(124641, 108, '2015-04-01 01:36:37.000000', 'temperatura', 1026.0000, 'ºC'),
	(124642, 108, '2015-04-01 01:36:38.000000', 'temperatura', 189.0000, 'ºC'),
	(124643, 108, '2015-04-01 01:36:39.000000', 'temperatura', 268.0000, 'ºC'),
	(124644, 108, '2015-04-01 01:36:40.000000', 'temperatura', 772.0000, 'ºC'),
	(124645, 108, '2015-04-01 01:36:41.000000', 'temperatura', 657.0000, 'ºC'),
	(124646, 108, '2015-04-01 01:36:42.000000', 'temperatura', 969.0000, 'ºC'),
	(124647, 108, '2015-04-01 01:36:43.000000', 'temperatura', 474.0000, 'ºC'),
	(124648, 108, '2015-04-01 01:36:44.000000', 'temperatura', 666.0000, 'ºC'),
	(124649, 108, '2015-04-01 01:36:45.000000', 'temperatura', 706.0000, 'ºC'),
	(124650, 108, '2015-04-01 01:36:46.000000', 'temperatura', 334.0000, 'ºC'),
	(124651, 108, '2015-04-01 01:36:47.000000', 'temperatura', 753.0000, 'ºC'),
	(124652, 108, '2015-04-01 01:36:48.000000', 'temperatura', 362.0000, 'ºC'),
	(124653, 108, '2015-04-01 01:36:49.000000', 'temperatura', 754.0000, 'ºC'),
	(124654, 108, '2015-04-01 01:36:50.000000', 'temperatura', 281.0000, 'ºC'),
	(124655, 108, '2015-04-01 01:36:51.000000', 'temperatura', 346.0000, 'ºC'),
	(124656, 108, '2015-04-01 01:36:52.000000', 'temperatura', 885.0000, 'ºC'),
	(124657, 108, '2015-04-01 01:36:53.000000', 'temperatura', 988.0000, 'ºC'),
	(124658, 108, '2015-04-01 01:36:54.000000', 'temperatura', 1087.0000, 'ºC'),
	(124659, 108, '2015-04-01 01:36:55.000000', 'temperatura', 69.0000, 'ºC'),
	(124660, 108, '2015-04-01 01:36:56.000000', 'temperatura', 687.0000, 'ºC'),
	(124661, 108, '2015-04-01 01:36:57.000000', 'temperatura', 829.0000, 'ºC'),
	(124662, 108, '2015-04-01 01:36:58.000000', 'temperatura', 885.0000, 'ºC'),
	(124663, 108, '2015-04-01 01:36:59.000000', 'temperatura', 739.0000, 'ºC'),
	(124664, 108, '2015-04-01 01:37:00.000000', 'temperatura', 1040.0000, 'ºC'),
	(124665, 108, '2015-04-01 01:37:01.000000', 'temperatura', 585.0000, 'ºC'),
	(124666, 108, '2015-04-01 01:37:02.000000', 'temperatura', 1005.0000, 'ºC'),
	(124667, 108, '2015-04-01 01:37:03.000000', 'temperatura', 871.0000, 'ºC'),
	(124668, 109, '2015-04-01 00:00:00.000000', 'temperatura', 483.0000, 'ºC'),
	(124669, 109, '2015-04-01 00:00:01.000000', 'temperatura', 798.0000, 'ºC'),
	(124670, 109, '2015-04-01 00:00:02.000000', 'temperatura', 144.0000, 'ºC'),
	(124671, 109, '2015-04-01 00:00:03.000000', 'temperatura', 724.0000, 'ºC'),
	(124672, 109, '2015-04-01 00:00:04.000000', 'temperatura', 788.0000, 'ºC'),
	(124673, 109, '2015-04-01 00:00:05.000000', 'temperatura', 571.0000, 'ºC'),
	(124674, 109, '2015-04-01 00:00:06.000000', 'temperatura', 489.0000, 'ºC'),
	(124675, 109, '2015-04-01 00:00:07.000000', 'temperatura', 733.0000, 'ºC'),
	(124676, 109, '2015-04-01 00:00:08.000000', 'temperatura', 999.0000, 'ºC'),
	(124677, 109, '2015-04-01 00:00:09.000000', 'temperatura', 397.0000, 'ºC'),
	(124678, 109, '2015-04-01 00:00:10.000000', 'temperatura', 187.0000, 'ºC'),
	(124679, 109, '2015-04-01 00:00:11.000000', 'temperatura', 945.0000, 'ºC'),
	(124680, 109, '2015-04-01 00:00:12.000000', 'temperatura', 565.0000, 'ºC'),
	(124681, 109, '2015-04-01 00:00:13.000000', 'temperatura', 1189.0000, 'ºC'),
	(124682, 109, '2015-04-01 00:00:14.000000', 'temperatura', 651.0000, 'ºC'),
	(124683, 109, '2015-04-01 00:00:15.000000', 'temperatura', 890.0000, 'ºC'),
	(124684, 109, '2015-04-01 00:00:16.000000', 'temperatura', 98.0000, 'ºC'),
	(124685, 109, '2015-04-01 00:00:17.000000', 'temperatura', 217.0000, 'ºC'),
	(124686, 109, '2015-04-01 00:00:18.000000', 'temperatura', 795.0000, 'ºC'),
	(124687, 109, '2015-04-01 00:00:19.000000', 'temperatura', 924.0000, 'ºC'),
	(124688, 109, '2015-04-01 00:00:20.000000', 'temperatura', 1036.0000, 'ºC'),
	(124689, 109, '2015-04-01 00:00:21.000000', 'temperatura', 8.0000, 'ºC'),
	(124690, 109, '2015-04-01 00:00:22.000000', 'temperatura', 533.0000, 'ºC'),
	(124691, 109, '2015-04-01 00:00:23.000000', 'temperatura', 242.0000, 'ºC'),
	(124692, 109, '2015-04-01 00:00:24.000000', 'temperatura', 813.0000, 'ºC'),
	(124693, 109, '2015-04-01 00:00:25.000000', 'temperatura', 937.0000, 'ºC'),
	(124694, 109, '2015-04-01 00:00:26.000000', 'temperatura', 1046.0000, 'ºC'),
	(124695, 109, '2015-04-01 00:00:27.000000', 'temperatura', 19.0000, 'ºC'),
	(124696, 109, '2015-04-01 00:00:28.000000', 'temperatura', 560.0000, 'ºC'),
	(124697, 109, '2015-04-01 00:00:29.000000', 'temperatura', 343.0000, 'ºC'),
	(124698, 109, '2015-04-01 00:00:30.000000', 'temperatura', 35.0000, 'ºC'),
	(124699, 109, '2015-04-01 00:00:31.000000', 'temperatura', 346.0000, 'ºC'),
	(124700, 109, '2015-04-01 00:00:32.000000', 'temperatura', 425.0000, 'ºC'),
	(124701, 109, '2015-04-01 00:00:33.000000', 'temperatura', 1088.0000, 'ºC'),
	(124702, 109, '2015-04-01 00:00:34.000000', 'temperatura', 568.0000, 'ºC'),
	(124703, 109, '2015-04-01 00:00:35.000000', 'temperatura', 774.0000, 'ºC'),
	(124704, 109, '2015-04-01 00:00:36.000000', 'temperatura', 965.0000, 'ºC'),
	(124705, 109, '2015-04-01 00:00:37.000000', 'temperatura', 105.0000, 'ºC'),
	(124706, 109, '2015-04-01 00:00:38.000000', 'temperatura', 31.0000, 'ºC'),
	(124707, 109, '2015-04-01 00:00:39.000000', 'temperatura', 1041.0000, 'ºC'),
	(124708, 109, '2015-04-01 00:00:40.000000', 'temperatura', 313.0000, 'ºC'),
	(124709, 109, '2015-04-01 00:00:41.000000', 'temperatura', 844.0000, 'ºC'),
	(124710, 109, '2015-04-01 00:00:42.000000', 'temperatura', 878.0000, 'ºC'),
	(124711, 109, '2015-04-01 00:00:43.000000', 'temperatura', 659.0000, 'ºC'),
	(124712, 109, '2015-04-01 00:00:44.000000', 'temperatura', 663.0000, 'ºC'),
	(124713, 109, '2015-04-01 00:00:45.000000', 'temperatura', 138.0000, 'ºC'),
	(124714, 109, '2015-04-01 00:00:46.000000', 'temperatura', 1101.0000, 'ºC'),
	(124715, 109, '2015-04-01 00:00:47.000000', 'temperatura', 291.0000, 'ºC'),
	(124716, 109, '2015-04-01 00:00:48.000000', 'temperatura', 551.0000, 'ºC'),
	(124717, 109, '2015-04-01 00:00:49.000000', 'temperatura', 684.0000, 'ºC'),
	(124718, 109, '2015-04-01 00:00:50.000000', 'temperatura', 566.0000, 'ºC'),
	(124719, 109, '2015-04-01 00:00:51.000000', 'temperatura', 779.0000, 'ºC'),
	(124720, 109, '2015-04-01 00:00:52.000000', 'temperatura', 997.0000, 'ºC'),
	(124721, 109, '2015-04-01 00:00:53.000000', 'temperatura', 250.0000, 'ºC'),
	(124722, 109, '2015-04-01 00:00:54.000000', 'temperatura', 658.0000, 'ºC'),
	(124723, 109, '2015-04-01 00:00:55.000000', 'temperatura', 143.0000, 'ºC'),
	(124724, 109, '2015-04-01 00:00:56.000000', 'temperatura', 1141.0000, 'ºC'),
	(124725, 109, '2015-04-01 00:00:57.000000', 'temperatura', 476.0000, 'ºC'),
	(124726, 109, '2015-04-01 00:00:58.000000', 'temperatura', 159.0000, 'ºC'),
	(124727, 109, '2015-04-01 00:00:59.000000', 'temperatura', 565.0000, 'ºC'),
	(124728, 109, '2015-04-01 00:01:00.000000', 'temperatura', 1148.0000, 'ºC'),
	(124729, 109, '2015-04-01 00:01:01.000000', 'temperatura', 448.0000, 'ºC'),
	(124730, 109, '2015-04-01 00:01:02.000000', 'temperatura', 1195.0000, 'ºC'),
	(124731, 109, '2015-04-01 00:01:03.000000', 'temperatura', 1032.0000, 'ºC'),
	(124732, 109, '2015-04-01 00:01:04.000000', 'temperatura', 376.0000, 'ºC'),
	(124733, 109, '2015-04-01 00:01:05.000000', 'temperatura', 1185.0000, 'ºC'),
	(124734, 109, '2015-04-01 00:01:06.000000', 'temperatura', 1197.0000, 'ºC'),
	(124735, 109, '2015-04-01 00:01:07.000000', 'temperatura', 30.0000, 'ºC'),
	(124736, 109, '2015-04-01 00:01:08.000000', 'temperatura', 159.0000, 'ºC'),
	(124737, 109, '2015-04-01 00:01:09.000000', 'temperatura', 707.0000, 'ºC'),
	(124738, 109, '2015-04-01 00:01:10.000000', 'temperatura', 658.0000, 'ºC'),
	(124739, 109, '2015-04-01 00:01:11.000000', 'temperatura', 1168.0000, 'ºC'),
	(124740, 109, '2015-04-01 00:01:12.000000', 'temperatura', 267.0000, 'ºC'),
	(124741, 109, '2015-04-01 00:01:13.000000', 'temperatura', 231.0000, 'ºC'),
	(124742, 109, '2015-04-01 00:01:14.000000', 'temperatura', 355.0000, 'ºC'),
	(124743, 109, '2015-04-01 00:01:15.000000', 'temperatura', 1084.0000, 'ºC'),
	(124744, 109, '2015-04-01 00:01:16.000000', 'temperatura', 754.0000, 'ºC'),
	(124745, 109, '2015-04-01 00:01:17.000000', 'temperatura', 519.0000, 'ºC'),
	(124746, 109, '2015-04-01 00:01:18.000000', 'temperatura', 333.0000, 'ºC'),
	(124747, 109, '2015-04-01 00:01:19.000000', 'temperatura', 110.0000, 'ºC'),
	(124748, 109, '2015-04-01 00:01:20.000000', 'temperatura', 750.0000, 'ºC'),
	(124749, 109, '2015-04-01 00:01:21.000000', 'temperatura', 1020.0000, 'ºC'),
	(124750, 109, '2015-04-01 00:01:22.000000', 'temperatura', 453.0000, 'ºC'),
	(124751, 109, '2015-04-01 00:01:23.000000', 'temperatura', 403.0000, 'ºC'),
	(124752, 109, '2015-04-01 00:01:24.000000', 'temperatura', 659.0000, 'ºC'),
	(124753, 109, '2015-04-01 00:01:25.000000', 'temperatura', 887.0000, 'ºC'),
	(124754, 109, '2015-04-01 00:01:26.000000', 'temperatura', 57.0000, 'ºC'),
	(124755, 109, '2015-04-01 00:01:27.000000', 'temperatura', 27.0000, 'ºC'),
	(124756, 109, '2015-04-01 00:01:28.000000', 'temperatura', 1162.0000, 'ºC'),
	(124757, 109, '2015-04-01 00:01:29.000000', 'temperatura', 930.0000, 'ºC'),
	(124758, 109, '2015-04-01 00:01:30.000000', 'temperatura', 1166.0000, 'ºC'),
	(124759, 109, '2015-04-01 00:01:31.000000', 'temperatura', 640.0000, 'ºC'),
	(124760, 109, '2015-04-01 00:01:32.000000', 'temperatura', 901.0000, 'ºC'),
	(124761, 109, '2015-04-01 00:01:33.000000', 'temperatura', 185.0000, 'ºC'),
	(124762, 109, '2015-04-01 00:01:34.000000', 'temperatura', 622.0000, 'ºC'),
	(124763, 109, '2015-04-01 00:01:35.000000', 'temperatura', 155.0000, 'ºC'),
	(124764, 109, '2015-04-01 00:01:36.000000', 'temperatura', 112.0000, 'ºC'),
	(124765, 109, '2015-04-01 00:01:37.000000', 'temperatura', 95.0000, 'ºC'),
	(124766, 109, '2015-04-01 00:01:38.000000', 'temperatura', 141.0000, 'ºC'),
	(124767, 109, '2015-04-01 00:01:39.000000', 'temperatura', 420.0000, 'ºC'),
	(124768, 109, '2015-04-01 00:01:40.000000', 'temperatura', 475.0000, 'ºC'),
	(124769, 109, '2015-04-01 00:01:41.000000', 'temperatura', 1117.0000, 'ºC'),
	(124770, 109, '2015-04-01 00:01:42.000000', 'temperatura', 560.0000, 'ºC'),
	(124771, 109, '2015-04-01 00:01:43.000000', 'temperatura', 650.0000, 'ºC'),
	(124772, 109, '2015-04-01 00:01:44.000000', 'temperatura', 369.0000, 'ºC'),
	(124773, 109, '2015-04-01 00:01:45.000000', 'temperatura', 1094.0000, 'ºC'),
	(124774, 109, '2015-04-01 00:01:46.000000', 'temperatura', 767.0000, 'ºC'),
	(124775, 109, '2015-04-01 00:01:47.000000', 'temperatura', 554.0000, 'ºC'),
	(124776, 109, '2015-04-01 00:01:48.000000', 'temperatura', 467.0000, 'ºC'),
	(124777, 109, '2015-04-01 00:01:49.000000', 'temperatura', 675.0000, 'ºC'),
	(124778, 109, '2015-04-01 00:01:50.000000', 'temperatura', 772.0000, 'ºC'),
	(124779, 109, '2015-04-01 00:01:51.000000', 'temperatura', 639.0000, 'ºC'),
	(124780, 109, '2015-04-01 00:01:52.000000', 'temperatura', 877.0000, 'ºC'),
	(124781, 109, '2015-04-01 00:01:53.000000', 'temperatura', 71.0000, 'ºC'),
	(124782, 109, '2015-04-01 00:01:54.000000', 'temperatura', 125.0000, 'ºC'),
	(124783, 109, '2015-04-01 00:01:55.000000', 'temperatura', 409.0000, 'ºC'),
	(124784, 109, '2015-04-01 00:01:56.000000', 'temperatura', 473.0000, 'ºC'),
	(124785, 109, '2015-04-01 00:01:57.000000', 'temperatura', 1139.0000, 'ºC'),
	(124786, 109, '2015-04-01 00:01:58.000000', 'temperatura', 675.0000, 'ºC'),
	(124787, 109, '2015-04-01 00:01:59.000000', 'temperatura', 1158.0000, 'ºC'),
	(124788, 109, '2015-04-01 00:02:00.000000', 'temperatura', 165.0000, 'ºC'),
	(124789, 109, '2015-04-01 00:02:01.000000', 'temperatura', 954.0000, 'ºC'),
	(124790, 109, '2015-04-01 00:02:02.000000', 'temperatura', 674.0000, 'ºC'),
	(124791, 109, '2015-04-01 00:02:03.000000', 'temperatura', 509.0000, 'ºC'),
	(124792, 109, '2015-04-01 00:02:04.000000', 'temperatura', 524.0000, 'ºC'),
	(124793, 109, '2015-04-01 00:02:05.000000', 'temperatura', 1092.0000, 'ºC'),
	(124794, 109, '2015-04-01 00:02:06.000000', 'temperatura', 288.0000, 'ºC'),
	(124795, 109, '2015-04-01 00:02:07.000000', 'temperatura', 566.0000, 'ºC'),
	(124796, 109, '2015-04-01 00:02:08.000000', 'temperatura', 767.0000, 'ºC'),
	(124797, 109, '2015-04-01 00:02:09.000000', 'temperatura', 938.0000, 'ºC'),
	(124798, 109, '2015-04-01 00:02:10.000000', 'temperatura', 1187.0000, 'ºC'),
	(124799, 109, '2015-04-01 00:02:11.000000', 'temperatura', 725.0000, 'ºC'),
	(124800, 109, '2015-04-01 00:02:12.000000', 'temperatura', 61.0000, 'ºC'),
	(124801, 109, '2015-04-01 00:02:13.000000', 'temperatura', 532.0000, 'ºC'),
	(124802, 109, '2015-04-01 00:02:14.000000', 'temperatura', 76.0000, 'ºC'),
	(124803, 109, '2015-04-01 00:02:15.000000', 'temperatura', 1184.0000, 'ºC'),
	(124804, 109, '2015-04-01 00:02:16.000000', 'temperatura', 893.0000, 'ºC'),
	(124805, 109, '2015-04-01 00:02:17.000000', 'temperatura', 916.0000, 'ºC'),
	(124806, 109, '2015-04-01 00:02:18.000000', 'temperatura', 699.0000, 'ºC'),
	(124807, 109, '2015-04-01 00:02:19.000000', 'temperatura', 748.0000, 'ºC'),
	(124808, 109, '2015-04-01 00:02:20.000000', 'temperatura', 445.0000, 'ºC'),
	(124809, 109, '2015-04-01 00:02:21.000000', 'temperatura', 1182.0000, 'ºC'),
	(124810, 109, '2015-04-01 00:02:22.000000', 'temperatura', 975.0000, 'ºC'),
	(124811, 109, '2015-04-01 00:02:23.000000', 'temperatura', 128.0000, 'ºC'),
	(124812, 109, '2015-04-01 00:02:24.000000', 'temperatura', 115.0000, 'ºC'),
	(124813, 109, '2015-04-01 00:02:25.000000', 'temperatura', 193.0000, 'ºC'),
	(124814, 109, '2015-04-01 00:02:26.000000', 'temperatura', 620.0000, 'ºC'),
	(124815, 109, '2015-04-01 00:02:27.000000', 'temperatura', 123.0000, 'ºC'),
	(124816, 109, '2015-04-01 00:02:28.000000', 'temperatura', 1156.0000, 'ºC'),
	(124817, 109, '2015-04-01 00:02:29.000000', 'temperatura', 609.0000, 'ºC'),
	(124818, 109, '2015-04-01 00:02:30.000000', 'temperatura', 780.0000, 'ºC'),
	(124819, 109, '2015-04-01 00:02:31.000000', 'temperatura', 871.0000, 'ºC'),
	(124820, 109, '2015-04-01 00:02:32.000000', 'temperatura', 816.0000, 'ºC'),
	(124821, 109, '2015-04-01 00:02:33.000000', 'temperatura', 270.0000, 'ºC'),
	(124822, 109, '2015-04-01 00:02:34.000000', 'temperatura', 101.0000, 'ºC'),
	(124823, 109, '2015-04-01 00:02:35.000000', 'temperatura', 895.0000, 'ºC'),
	(124824, 109, '2015-04-01 00:02:36.000000', 'temperatura', 574.0000, 'ºC'),
	(124825, 109, '2015-04-01 00:02:37.000000', 'temperatura', 185.0000, 'ºC'),
	(124826, 109, '2015-04-01 00:02:38.000000', 'temperatura', 405.0000, 'ºC'),
	(124827, 109, '2015-04-01 00:02:39.000000', 'temperatura', 268.0000, 'ºC'),
	(124828, 109, '2015-04-01 00:02:40.000000', 'temperatura', 127.0000, 'ºC'),
	(124829, 109, '2015-04-01 00:02:41.000000', 'temperatura', 1030.0000, 'ºC'),
	(124830, 109, '2015-04-01 00:02:42.000000', 'temperatura', 1171.0000, 'ºC'),
	(124831, 109, '2015-04-01 00:02:43.000000', 'temperatura', 365.0000, 'ºC'),
	(124832, 109, '2015-04-01 00:02:44.000000', 'temperatura', 714.0000, 'ºC'),
	(124833, 109, '2015-04-01 00:02:45.000000', 'temperatura', 75.0000, 'ºC'),
	(124834, 109, '2015-04-01 00:02:46.000000', 'temperatura', 633.0000, 'ºC'),
	(124835, 109, '2015-04-01 00:02:47.000000', 'temperatura', 542.0000, 'ºC'),
	(124836, 109, '2015-04-01 00:02:48.000000', 'temperatura', 810.0000, 'ºC'),
	(124837, 109, '2015-04-01 00:02:49.000000', 'temperatura', 24.0000, 'ºC'),
	(124838, 109, '2015-04-01 00:02:50.000000', 'temperatura', 89.0000, 'ºC'),
	(124839, 109, '2015-04-01 00:02:51.000000', 'temperatura', 376.0000, 'ºC'),
	(124840, 109, '2015-04-01 00:02:52.000000', 'temperatura', 415.0000, 'ºC'),
	(124841, 109, '2015-04-01 00:02:53.000000', 'temperatura', 945.0000, 'ºC'),
	(124842, 109, '2015-04-01 00:02:54.000000', 'temperatura', 1081.0000, 'ºC'),
	(124843, 109, '2015-04-01 00:02:55.000000', 'temperatura', 173.0000, 'ºC'),
	(124844, 109, '2015-04-01 00:02:56.000000', 'temperatura', 20.0000, 'ºC'),
	(124845, 109, '2015-04-01 00:02:57.000000', 'temperatura', 781.0000, 'ºC'),
	(124846, 109, '2015-04-01 00:02:58.000000', 'temperatura', 245.0000, 'ºC'),
	(124847, 109, '2015-04-01 00:02:59.000000', 'temperatura', 82.0000, 'ºC'),
	(124848, 109, '2015-04-01 00:03:00.000000', 'temperatura', 875.0000, 'ºC'),
	(124849, 109, '2015-04-01 00:03:01.000000', 'temperatura', 530.0000, 'ºC'),
	(124850, 109, '2015-04-01 00:03:02.000000', 'temperatura', 27.0000, 'ºC'),
	(124851, 109, '2015-04-01 00:03:03.000000', 'temperatura', 946.0000, 'ºC'),
	(124852, 109, '2015-04-01 00:03:04.000000', 'temperatura', 1046.0000, 'ºC'),
	(124853, 109, '2015-04-01 00:03:05.000000', 'temperatura', 1196.0000, 'ºC'),
	(124854, 109, '2015-04-01 00:03:06.000000', 'temperatura', 442.0000, 'ºC'),
	(124855, 109, '2015-04-01 00:03:07.000000', 'temperatura', 1024.0000, 'ºC'),
	(124856, 109, '2015-04-01 00:03:08.000000', 'temperatura', 193.0000, 'ºC'),
	(124857, 109, '2015-04-01 00:03:09.000000', 'temperatura', 293.0000, 'ºC'),
	(124858, 109, '2015-04-01 00:03:10.000000', 'temperatura', 889.0000, 'ºC'),
	(124859, 109, '2015-04-01 00:03:11.000000', 'temperatura', 1164.0000, 'ºC'),
	(124860, 109, '2015-04-01 00:03:12.000000', 'temperatura', 752.0000, 'ºC'),
	(124861, 109, '2015-04-01 00:03:13.000000', 'temperatura', 270.0000, 'ºC'),
	(124862, 109, '2015-04-01 00:03:14.000000', 'temperatura', 297.0000, 'ºC'),
	(124863, 109, '2015-04-01 00:03:15.000000', 'temperatura', 672.0000, 'ºC'),
	(124864, 109, '2015-04-01 00:03:16.000000', 'temperatura', 72.0000, 'ºC'),
	(124865, 109, '2015-04-01 00:03:17.000000', 'temperatura', 743.0000, 'ºC'),
	(124866, 109, '2015-04-01 00:03:18.000000', 'temperatura', 1102.0000, 'ºC'),
	(124867, 109, '2015-04-01 00:03:19.000000', 'temperatura', 879.0000, 'ºC'),
	(124868, 109, '2015-04-01 00:03:20.000000', 'temperatura', 1091.0000, 'ºC'),
	(124869, 109, '2015-04-01 00:03:21.000000', 'temperatura', 416.0000, 'ºC'),
	(124870, 109, '2015-04-01 00:03:22.000000', 'temperatura', 10.0000, 'ºC'),
	(124871, 109, '2015-04-01 00:03:23.000000', 'temperatura', 0.0000, 'ºC'),
	(124872, 109, '2015-04-01 00:03:24.000000', 'temperatura', 1171.0000, 'ºC'),
	(124873, 109, '2015-04-01 00:03:25.000000', 'temperatura', 1056.0000, 'ºC'),
	(124874, 109, '2015-04-01 00:03:26.000000', 'temperatura', 568.0000, 'ºC'),
	(124875, 109, '2015-04-01 00:03:27.000000', 'temperatura', 870.0000, 'ºC'),
	(124876, 109, '2015-04-01 00:03:28.000000', 'temperatura', 250.0000, 'ºC'),
	(124877, 109, '2015-04-01 00:03:29.000000', 'temperatura', 1038.0000, 'ºC'),
	(124878, 109, '2015-04-01 00:03:30.000000', 'temperatura', 840.0000, 'ºC'),
	(124879, 109, '2015-04-01 00:03:31.000000', 'temperatura', 1089.0000, 'ºC'),
	(124880, 109, '2015-04-01 00:03:32.000000', 'temperatura', 526.0000, 'ºC'),
	(124881, 109, '2015-04-01 00:03:33.000000', 'temperatura', 562.0000, 'ºC'),
	(124882, 109, '2015-04-01 00:03:34.000000', 'temperatura', 33.0000, 'ºC'),
	(124883, 109, '2015-04-01 00:03:35.000000', 'temperatura', 881.0000, 'ºC'),
	(124884, 109, '2015-04-01 00:03:36.000000', 'temperatura', 705.0000, 'ºC'),
	(124885, 109, '2015-04-01 00:03:37.000000', 'temperatura', 883.0000, 'ºC'),
	(124886, 109, '2015-04-01 00:03:38.000000', 'temperatura', 1101.0000, 'ºC'),
	(124887, 109, '2015-04-01 00:03:39.000000', 'temperatura', 457.0000, 'ºC'),
	(124888, 109, '2015-04-01 00:03:40.000000', 'temperatura', 180.0000, 'ºC'),
	(124889, 109, '2015-04-01 00:03:41.000000', 'temperatura', 732.0000, 'ºC'),
	(124890, 109, '2015-04-01 00:03:42.000000', 'temperatura', 719.0000, 'ºC'),
	(124891, 109, '2015-04-01 00:03:43.000000', 'temperatura', 200.0000, 'ºC'),
	(124892, 109, '2015-04-01 00:03:44.000000', 'temperatura', 42.0000, 'ºC'),
	(124893, 109, '2015-04-01 00:03:45.000000', 'temperatura', 810.0000, 'ºC'),
	(124894, 109, '2015-04-01 00:03:46.000000', 'temperatura', 328.0000, 'ºC'),
	(124895, 109, '2015-04-01 00:03:47.000000', 'temperatura', 407.0000, 'ºC'),
	(124896, 109, '2015-04-01 00:03:48.000000', 'temperatura', 1053.0000, 'ºC'),
	(124897, 109, '2015-04-01 00:03:49.000000', 'temperatura', 446.0000, 'ºC'),
	(124898, 109, '2015-04-01 00:03:50.000000', 'temperatura', 272.0000, 'ºC'),
	(124899, 109, '2015-04-01 00:03:51.000000', 'temperatura', 20.0000, 'ºC'),
	(124900, 109, '2015-04-01 00:03:52.000000', 'temperatura', 485.0000, 'ºC'),
	(124901, 109, '2015-04-01 00:03:53.000000', 'temperatura', 1167.0000, 'ºC'),
	(124902, 109, '2015-04-01 00:03:54.000000', 'temperatura', 782.0000, 'ºC'),
	(124903, 109, '2015-04-01 00:03:55.000000', 'temperatura', 406.0000, 'ºC'),
	(124904, 109, '2015-04-01 00:03:56.000000', 'temperatura', 888.0000, 'ºC'),
	(124905, 109, '2015-04-01 00:03:57.000000', 'temperatura', 819.0000, 'ºC'),
	(124906, 109, '2015-04-01 00:03:58.000000', 'temperatura', 234.0000, 'ºC'),
	(124907, 109, '2015-04-01 00:03:59.000000', 'temperatura', 1111.0000, 'ºC'),
	(124908, 109, '2015-04-01 00:04:00.000000', 'temperatura', 54.0000, 'ºC'),
	(124909, 109, '2015-04-01 00:04:01.000000', 'temperatura', 537.0000, 'ºC'),
	(124910, 109, '2015-04-01 00:04:02.000000', 'temperatura', 123.0000, 'ºC'),
	(124911, 109, '2015-04-01 00:04:03.000000', 'temperatura', 206.0000, 'ºC'),
	(124912, 109, '2015-04-01 00:04:04.000000', 'temperatura', 660.0000, 'ºC'),
	(124913, 109, '2015-04-01 00:04:05.000000', 'temperatura', 283.0000, 'ºC'),
	(124914, 109, '2015-04-01 00:04:06.000000', 'temperatura', 634.0000, 'ºC'),
	(124915, 109, '2015-04-01 00:04:07.000000', 'temperatura', 1122.0000, 'ºC'),
	(124916, 109, '2015-04-01 00:04:08.000000', 'temperatura', 108.0000, 'ºC'),
	(124917, 109, '2015-04-01 00:04:09.000000', 'temperatura', 777.0000, 'ºC'),
	(124918, 109, '2015-04-01 00:04:10.000000', 'temperatura', 1159.0000, 'ºC'),
	(124919, 109, '2015-04-01 00:04:11.000000', 'temperatura', 1066.0000, 'ºC'),
	(124920, 109, '2015-04-01 00:04:12.000000', 'temperatura', 654.0000, 'ºC'),
	(124921, 109, '2015-04-01 00:04:13.000000', 'temperatura', 72.0000, 'ºC'),
	(124922, 109, '2015-04-01 00:04:14.000000', 'temperatura', 798.0000, 'ºC'),
	(124923, 109, '2015-04-01 00:04:15.000000', 'temperatura', 174.0000, 'ºC'),
	(124924, 109, '2015-04-01 00:04:16.000000', 'temperatura', 878.0000, 'ºC'),
	(124925, 109, '2015-04-01 00:04:17.000000', 'temperatura', 270.0000, 'ºC'),
	(124926, 109, '2015-04-01 00:04:18.000000', 'temperatura', 1113.0000, 'ºC'),
	(124927, 109, '2015-04-01 00:04:19.000000', 'temperatura', 1157.0000, 'ºC'),
	(124928, 109, '2015-04-01 00:04:20.000000', 'temperatura', 45.0000, 'ºC'),
	(124929, 109, '2015-04-01 00:04:21.000000', 'temperatura', 354.0000, 'ºC'),
	(124930, 109, '2015-04-01 00:04:22.000000', 'temperatura', 436.0000, 'ºC'),
	(124931, 109, '2015-04-01 00:04:23.000000', 'temperatura', 1120.0000, 'ºC'),
	(124932, 109, '2015-04-01 00:04:24.000000', 'temperatura', 692.0000, 'ºC'),
	(124933, 109, '2015-04-01 00:04:25.000000', 'temperatura', 101.0000, 'ºC'),
	(124934, 109, '2015-04-01 00:04:26.000000', 'temperatura', 828.0000, 'ºC'),
	(124935, 109, '2015-04-01 00:04:27.000000', 'temperatura', 239.0000, 'ºC'),
	(124936, 109, '2015-04-01 00:04:28.000000', 'temperatura', 1109.0000, 'ºC'),
	(124937, 109, '2015-04-01 00:04:29.000000', 'temperatura', 31.0000, 'ºC'),
	(124938, 109, '2015-04-01 00:04:30.000000', 'temperatura', 429.0000, 'ºC'),
	(124939, 109, '2015-04-01 00:04:31.000000', 'temperatura', 850.0000, 'ºC'),
	(124940, 109, '2015-04-01 00:04:32.000000', 'temperatura', 565.0000, 'ºC'),
	(124941, 109, '2015-04-01 00:04:33.000000', 'temperatura', 275.0000, 'ºC'),
	(124942, 109, '2015-04-01 00:04:34.000000', 'temperatura', 882.0000, 'ºC'),
	(124943, 109, '2015-04-01 00:04:35.000000', 'temperatura', 1184.0000, 'ºC'),
	(124944, 109, '2015-04-01 00:04:36.000000', 'temperatura', 874.0000, 'ºC'),
	(124945, 109, '2015-04-01 00:04:37.000000', 'temperatura', 820.0000, 'ºC'),
	(124946, 109, '2015-04-01 00:04:38.000000', 'temperatura', 279.0000, 'ºC'),
	(124947, 109, '2015-04-01 00:04:39.000000', 'temperatura', 135.0000, 'ºC'),
	(124948, 109, '2015-04-01 00:04:40.000000', 'temperatura', 1040.0000, 'ºC'),
	(124949, 109, '2015-04-01 00:04:41.000000', 'temperatura', 1196.0000, 'ºC'),
	(124950, 109, '2015-04-01 00:04:42.000000', 'temperatura', 461.0000, 'ºC'),
	(124951, 109, '2015-04-01 00:04:43.000000', 'temperatura', 1114.0000, 'ºC'),
	(124952, 109, '2015-04-01 00:04:44.000000', 'temperatura', 590.0000, 'ºC'),
	(124953, 109, '2015-04-01 00:04:45.000000', 'temperatura', 809.0000, 'ºC'),
	(124954, 109, '2015-04-01 00:04:46.000000', 'temperatura', 1076.0000, 'ºC'),
	(124955, 109, '2015-04-01 00:04:47.000000', 'temperatura', 555.0000, 'ºC'),
	(124956, 109, '2015-04-01 00:04:48.000000', 'temperatura', 744.0000, 'ºC'),
	(124957, 109, '2015-04-01 00:04:49.000000', 'temperatura', 857.0000, 'ºC'),
	(124958, 109, '2015-04-01 00:04:50.000000', 'temperatura', 854.0000, 'ºC'),
	(124959, 109, '2015-04-01 00:04:51.000000', 'temperatura', 497.0000, 'ºC'),
	(124960, 109, '2015-04-01 00:04:52.000000', 'temperatura', 1126.0000, 'ºC'),
	(124961, 109, '2015-04-01 00:04:53.000000', 'temperatura', 539.0000, 'ºC'),
	(124962, 109, '2015-04-01 00:04:54.000000', 'temperatura', 517.0000, 'ºC'),
	(124963, 109, '2015-04-01 00:04:55.000000', 'temperatura', 970.0000, 'ºC'),
	(124964, 109, '2015-04-01 00:04:56.000000', 'temperatura', 897.0000, 'ºC'),
	(124965, 109, '2015-04-01 00:04:57.000000', 'temperatura', 376.0000, 'ºC'),
	(124966, 109, '2015-04-01 00:04:58.000000', 'temperatura', 389.0000, 'ºC'),
	(124967, 109, '2015-04-01 00:04:59.000000', 'temperatura', 819.0000, 'ºC'),
	(124968, 109, '2015-04-01 00:05:00.000000', 'temperatura', 529.0000, 'ºC'),
	(124969, 109, '2015-04-01 00:05:01.000000', 'temperatura', 188.0000, 'ºC'),
	(124970, 109, '2015-04-01 00:05:02.000000', 'temperatura', 552.0000, 'ºC'),
	(124971, 109, '2015-04-01 00:05:03.000000', 'temperatura', 997.0000, 'ºC'),
	(124972, 109, '2015-04-01 00:05:04.000000', 'temperatura', 928.0000, 'ºC'),
	(124973, 109, '2015-04-01 00:05:05.000000', 'temperatura', 449.0000, 'ºC'),
	(124974, 109, '2015-04-01 00:05:06.000000', 'temperatura', 665.0000, 'ºC'),
	(124975, 109, '2015-04-01 00:05:07.000000', 'temperatura', 776.0000, 'ºC'),
	(124976, 109, '2015-04-01 00:05:08.000000', 'temperatura', 685.0000, 'ºC'),
	(124977, 109, '2015-04-01 00:05:09.000000', 'temperatura', 1099.0000, 'ºC'),
	(124978, 109, '2015-04-01 00:05:10.000000', 'temperatura', 1039.0000, 'ºC'),
	(124979, 109, '2015-04-01 00:05:11.000000', 'temperatura', 698.0000, 'ºC'),
	(124980, 109, '2015-04-01 00:05:12.000000', 'temperatura', 372.0000, 'ºC'),
	(124981, 109, '2015-04-01 00:05:13.000000', 'temperatura', 970.0000, 'ºC'),
	(124982, 109, '2015-04-01 00:05:14.000000', 'temperatura', 133.0000, 'ºC'),
	(124983, 109, '2015-04-01 00:05:15.000000', 'temperatura', 157.0000, 'ºC'),
	(124984, 109, '2015-04-01 00:05:16.000000', 'temperatura', 385.0000, 'ºC'),
	(124985, 109, '2015-04-01 00:05:17.000000', 'temperatura', 256.0000, 'ºC'),
	(124986, 109, '2015-04-01 00:05:18.000000', 'temperatura', 127.0000, 'ºC'),
	(124987, 109, '2015-04-01 00:05:19.000000', 'temperatura', 1065.0000, 'ºC'),
	(124988, 109, '2015-04-01 00:05:20.000000', 'temperatura', 144.0000, 'ºC'),
	(124989, 109, '2015-04-01 00:05:21.000000', 'temperatura', 1126.0000, 'ºC'),
	(124990, 109, '2015-04-01 00:05:22.000000', 'temperatura', 401.0000, 'ºC'),
	(124991, 109, '2015-04-01 00:05:23.000000', 'temperatura', 1024.0000, 'ºC'),
	(124992, 109, '2015-04-01 00:05:24.000000', 'temperatura', 320.0000, 'ºC'),
	(124993, 109, '2015-04-01 00:05:25.000000', 'temperatura', 926.0000, 'ºC'),
	(124994, 109, '2015-04-01 00:05:26.000000', 'temperatura', 72.0000, 'ºC'),
	(124995, 109, '2015-04-01 00:05:27.000000', 'temperatura', 1184.0000, 'ºC'),
	(124996, 109, '2015-04-01 00:05:28.000000', 'temperatura', 904.0000, 'ºC'),
	(124997, 109, '2015-04-01 00:05:29.000000', 'temperatura', 968.0000, 'ºC'),
	(124998, 109, '2015-04-01 00:05:30.000000', 'temperatura', 931.0000, 'ºC'),
	(124999, 109, '2015-04-01 00:05:31.000000', 'temperatura', 548.0000, 'ºC'),
	(125000, 109, '2015-04-01 00:05:32.000000', 'temperatura', 1149.0000, 'ºC'),
	(125001, 109, '2015-04-01 00:05:33.000000', 'temperatura', 502.0000, 'ºC'),
	(125002, 109, '2015-04-01 00:05:34.000000', 'temperatura', 264.0000, 'ºC'),
	(125003, 109, '2015-04-01 00:05:35.000000', 'temperatura', 1014.0000, 'ºC'),
	(125004, 109, '2015-04-01 00:05:36.000000', 'temperatura', 679.0000, 'ºC'),
	(125005, 109, '2015-04-01 00:05:37.000000', 'temperatura', 351.0000, 'ºC'),
	(125006, 109, '2015-04-01 00:05:38.000000', 'temperatura', 921.0000, 'ºC'),
	(125007, 109, '2015-04-01 00:05:39.000000', 'temperatura', 1152.0000, 'ºC'),
	(125008, 109, '2015-04-01 00:05:40.000000', 'temperatura', 599.0000, 'ºC'),
	(125009, 109, '2015-04-01 00:05:41.000000', 'temperatura', 740.0000, 'ºC'),
	(125010, 109, '2015-04-01 00:05:42.000000', 'temperatura', 702.0000, 'ºC'),
	(125011, 109, '2015-04-01 00:05:43.000000', 'temperatura', 89.0000, 'ºC'),
	(125012, 109, '2015-04-01 00:05:44.000000', 'temperatura', 740.0000, 'ºC'),
	(125013, 109, '2015-04-01 00:05:45.000000', 'temperatura', 1036.0000, 'ºC'),
	(125014, 109, '2015-04-01 00:05:46.000000', 'temperatura', 557.0000, 'ºC'),
	(125015, 109, '2015-04-01 00:05:47.000000', 'temperatura', 880.0000, 'ºC'),
	(125016, 109, '2015-04-01 00:05:48.000000', 'temperatura', 328.0000, 'ºC'),
	(125017, 109, '2015-04-01 00:05:49.000000', 'temperatura', 202.0000, 'ºC'),
	(125018, 109, '2015-04-01 00:05:50.000000', 'temperatura', 27.0000, 'ºC'),
	(125019, 109, '2015-04-01 00:05:51.000000', 'temperatura', 728.0000, 'ºC'),
	(125020, 109, '2015-04-01 00:05:52.000000', 'temperatura', 1161.0000, 'ºC'),
	(125021, 109, '2015-04-01 00:05:53.000000', 'temperatura', 19.0000, 'ºC'),
	(125022, 109, '2015-04-01 00:05:54.000000', 'temperatura', 215.0000, 'ºC'),
	(125023, 109, '2015-04-01 00:05:55.000000', 'temperatura', 1017.0000, 'ºC'),
	(125024, 109, '2015-04-01 00:05:56.000000', 'temperatura', 843.0000, 'ºC'),
	(125025, 109, '2015-04-01 00:05:57.000000', 'temperatura', 1162.0000, 'ºC'),
	(125026, 109, '2015-04-01 00:05:58.000000', 'temperatura', 884.0000, 'ºC'),
	(125027, 109, '2015-04-01 00:05:59.000000', 'temperatura', 931.0000, 'ºC'),
	(125028, 109, '2015-04-01 00:06:00.000000', 'temperatura', 806.0000, 'ºC'),
	(125029, 109, '2015-04-01 00:06:01.000000', 'temperatura', 37.0000, 'ºC'),
	(125030, 109, '2015-04-01 00:06:02.000000', 'temperatura', 166.0000, 'ºC'),
	(125031, 109, '2015-04-01 00:06:03.000000', 'temperatura', 719.0000, 'ºC'),
	(125032, 109, '2015-04-01 00:06:04.000000', 'temperatura', 697.0000, 'ºC'),
	(125033, 109, '2015-04-01 00:06:05.000000', 'temperatura', 131.0000, 'ºC'),
	(125034, 109, '2015-04-01 00:06:06.000000', 'temperatura', 965.0000, 'ºC'),
	(125035, 109, '2015-04-01 00:06:07.000000', 'temperatura', 831.0000, 'ºC'),
	(125036, 109, '2015-04-01 00:06:08.000000', 'temperatura', 61.0000, 'ºC'),
	(125037, 109, '2015-04-01 00:06:09.000000', 'temperatura', 210.0000, 'ºC'),
	(125038, 109, '2015-04-01 00:06:10.000000', 'temperatura', 871.0000, 'ºC'),
	(125039, 109, '2015-04-01 00:06:11.000000', 'temperatura', 122.0000, 'ºC'),
	(125040, 109, '2015-04-01 00:06:12.000000', 'temperatura', 401.0000, 'ºC'),
	(125041, 109, '2015-04-01 00:06:13.000000', 'temperatura', 437.0000, 'ºC'),
	(125042, 109, '2015-04-01 00:06:14.000000', 'temperatura', 982.0000, 'ºC'),
	(125043, 109, '2015-04-01 00:06:15.000000', 'temperatura', 0.0000, 'ºC'),
	(125044, 109, '2015-04-01 00:06:16.000000', 'temperatura', 654.0000, 'ºC'),
	(125045, 109, '2015-04-01 00:06:17.000000', 'temperatura', 869.0000, 'ºC'),
	(125046, 109, '2015-04-01 00:06:18.000000', 'temperatura', 1185.0000, 'ºC'),
	(125047, 109, '2015-04-01 00:06:19.000000', 'temperatura', 916.0000, 'ºC'),
	(125048, 109, '2015-04-01 00:06:20.000000', 'temperatura', 1029.0000, 'ºC'),
	(125049, 109, '2015-04-01 00:06:21.000000', 'temperatura', 1195.0000, 'ºC'),
	(125050, 109, '2015-04-01 00:06:22.000000', 'temperatura', 488.0000, 'ºC'),
	(125051, 109, '2015-04-01 00:06:23.000000', 'temperatura', 55.0000, 'ºC'),
	(125052, 109, '2015-04-01 00:06:24.000000', 'temperatura', 12.0000, 'ºC'),
	(125053, 109, '2015-04-01 00:06:25.000000', 'temperatura', 1098.0000, 'ºC'),
	(125054, 109, '2015-04-01 00:06:26.000000', 'temperatura', 651.0000, 'ºC'),
	(125055, 109, '2015-04-01 00:06:27.000000', 'temperatura', 1164.0000, 'ºC'),
	(125056, 109, '2015-04-01 00:06:28.000000', 'temperatura', 267.0000, 'ºC'),
	(125057, 109, '2015-04-01 00:06:29.000000', 'temperatura', 245.0000, 'ºC'),
	(125058, 109, '2015-04-01 00:06:30.000000', 'temperatura', 423.0000, 'ºC'),
	(125059, 109, '2015-04-01 00:06:31.000000', 'temperatura', 180.0000, 'ºC'),
	(125060, 109, '2015-04-01 00:06:32.000000', 'temperatura', 833.0000, 'ºC'),
	(125061, 109, '2015-04-01 00:06:33.000000', 'temperatura', 25.0000, 'ºC'),
	(125062, 109, '2015-04-01 00:06:34.000000', 'temperatura', 28.0000, 'ºC'),
	(125063, 109, '2015-04-01 00:06:35.000000', 'temperatura', 64.0000, 'ºC'),
	(125064, 109, '2015-04-01 00:06:36.000000', 'temperatura', 236.0000, 'ºC'),
	(125065, 109, '2015-04-01 00:06:37.000000', 'temperatura', 987.0000, 'ºC'),
	(125066, 109, '2015-04-01 00:06:38.000000', 'temperatura', 629.0000, 'ºC'),
	(125067, 109, '2015-04-01 00:06:39.000000', 'temperatura', 186.0000, 'ºC'),
	(125068, 109, '2015-04-01 00:06:40.000000', 'temperatura', 241.0000, 'ºC'),
	(125069, 109, '2015-04-01 00:06:41.000000', 'temperatura', 647.0000, 'ºC'),
	(125070, 109, '2015-04-01 00:06:42.000000', 'temperatura', 114.0000, 'ºC'),
	(125071, 109, '2015-04-01 00:06:43.000000', 'temperatura', 1030.0000, 'ºC'),
	(125072, 109, '2015-04-01 00:06:44.000000', 'temperatura', 6.0000, 'ºC'),
	(125073, 109, '2015-04-01 00:06:45.000000', 'temperatura', 542.0000, 'ºC'),
	(125074, 109, '2015-04-01 00:06:46.000000', 'temperatura', 294.0000, 'ºC'),
	(125075, 109, '2015-04-01 00:06:47.000000', 'temperatura', 1044.0000, 'ºC'),
	(125076, 109, '2015-04-01 00:06:48.000000', 'temperatura', 739.0000, 'ºC'),
	(125077, 109, '2015-04-01 00:06:49.000000', 'temperatura', 564.0000, 'ºC'),
	(125078, 109, '2015-04-01 00:06:50.000000', 'temperatura', 605.0000, 'ºC'),
	(125079, 109, '2015-04-01 00:06:51.000000', 'temperatura', 130.0000, 'ºC'),
	(125080, 109, '2015-04-01 00:06:52.000000', 'temperatura', 38.0000, 'ºC'),
	(125081, 109, '2015-04-01 00:06:53.000000', 'temperatura', 1000.0000, 'ºC'),
	(125082, 109, '2015-04-01 00:06:54.000000', 'temperatura', 86.0000, 'ºC'),
	(125083, 109, '2015-04-01 00:06:55.000000', 'temperatura', 1032.0000, 'ºC'),
	(125084, 109, '2015-04-01 00:06:56.000000', 'temperatura', 100.0000, 'ºC'),
	(125085, 109, '2015-04-01 00:06:57.000000', 'temperatura', 1008.0000, 'ºC'),
	(125086, 109, '2015-04-01 00:06:58.000000', 'temperatura', 1137.0000, 'ºC'),
	(125087, 109, '2015-04-01 00:06:59.000000', 'temperatura', 262.0000, 'ºC'),
	(125088, 109, '2015-04-01 00:07:00.000000', 'temperatura', 301.0000, 'ºC'),
	(125089, 109, '2015-04-01 00:07:01.000000', 'temperatura', 720.0000, 'ºC'),
	(125090, 109, '2015-04-01 00:07:02.000000', 'temperatura', 298.0000, 'ºC'),
	(125091, 109, '2015-04-01 00:07:03.000000', 'temperatura', 530.0000, 'ºC'),
	(125092, 109, '2015-04-01 00:07:04.000000', 'temperatura', 554.0000, 'ºC'),
	(125093, 109, '2015-04-01 00:07:05.000000', 'temperatura', 1183.0000, 'ºC'),
	(125094, 109, '2015-04-01 00:07:06.000000', 'temperatura', 651.0000, 'ºC'),
	(125095, 109, '2015-04-01 00:07:07.000000', 'temperatura', 910.0000, 'ºC'),
	(125096, 109, '2015-04-01 00:07:08.000000', 'temperatura', 195.0000, 'ºC'),
	(125097, 109, '2015-04-01 00:07:09.000000', 'temperatura', 647.0000, 'ºC'),
	(125098, 109, '2015-04-01 00:07:10.000000', 'temperatura', 248.0000, 'ºC'),
	(125099, 109, '2015-04-01 00:07:11.000000', 'temperatura', 500.0000, 'ºC'),
	(125100, 109, '2015-04-01 00:07:12.000000', 'temperatura', 557.0000, 'ºC'),
	(125101, 109, '2015-04-01 00:07:13.000000', 'temperatura', 84.0000, 'ºC'),
	(125102, 109, '2015-04-01 00:07:14.000000', 'temperatura', 1150.0000, 'ºC'),
	(125103, 109, '2015-04-01 00:07:15.000000', 'temperatura', 699.0000, 'ºC'),
	(125104, 109, '2015-04-01 00:07:16.000000', 'temperatura', 44.0000, 'ºC'),
	(125105, 109, '2015-04-01 00:07:17.000000', 'temperatura', 525.0000, 'ºC'),
	(125106, 109, '2015-04-01 00:07:18.000000', 'temperatura', 92.0000, 'ºC'),
	(125107, 109, '2015-04-01 00:07:19.000000', 'temperatura', 87.0000, 'ºC'),
	(125108, 109, '2015-04-01 00:07:20.000000', 'temperatura', 159.0000, 'ºC'),
	(125109, 109, '2015-04-01 00:07:21.000000', 'temperatura', 535.0000, 'ºC'),
	(125110, 109, '2015-04-01 00:07:22.000000', 'temperatura', 999.0000, 'ºC'),
	(125111, 109, '2015-04-01 00:07:23.000000', 'temperatura', 988.0000, 'ºC'),
	(125112, 109, '2015-04-01 00:07:24.000000', 'temperatura', 744.0000, 'ºC'),
	(125113, 109, '2015-04-01 00:07:25.000000', 'temperatura', 757.0000, 'ºC'),
	(125114, 109, '2015-04-01 00:07:26.000000', 'temperatura', 352.0000, 'ºC'),
	(125115, 109, '2015-04-01 00:07:27.000000', 'temperatura', 689.0000, 'ºC'),
	(125116, 109, '2015-04-01 00:07:28.000000', 'temperatura', 1189.0000, 'ºC'),
	(125117, 109, '2015-04-01 00:07:29.000000', 'temperatura', 279.0000, 'ºC'),
	(125118, 109, '2015-04-01 00:07:30.000000', 'temperatura', 230.0000, 'ºC'),
	(125119, 109, '2015-04-01 00:07:31.000000', 'temperatura', 313.0000, 'ºC'),
	(125120, 109, '2015-04-01 00:07:32.000000', 'temperatura', 876.0000, 'ºC'),
	(125121, 109, '2015-04-01 00:07:33.000000', 'temperatura', 1040.0000, 'ºC'),
	(125122, 109, '2015-04-01 00:07:34.000000', 'temperatura', 171.0000, 'ºC'),
	(125123, 109, '2015-04-01 00:07:35.000000', 'temperatura', 139.0000, 'ºC'),
	(125124, 109, '2015-04-01 00:07:36.000000', 'temperatura', 182.0000, 'ºC'),
	(125125, 109, '2015-04-01 00:07:37.000000', 'temperatura', 491.0000, 'ºC'),
	(125126, 109, '2015-04-01 00:07:38.000000', 'temperatura', 712.0000, 'ºC'),
	(125127, 109, '2015-04-01 00:07:39.000000', 'temperatura', 889.0000, 'ºC'),
	(125128, 109, '2015-04-01 00:07:40.000000', 'temperatura', 1106.0000, 'ºC'),
	(125129, 109, '2015-04-01 00:07:41.000000', 'temperatura', 464.0000, 'ºC'),
	(125130, 109, '2015-04-01 00:07:42.000000', 'temperatura', 202.0000, 'ºC'),
	(125131, 109, '2015-04-01 00:07:43.000000', 'temperatura', 821.0000, 'ºC'),
	(125132, 109, '2015-04-01 00:07:44.000000', 'temperatura', 1099.0000, 'ºC'),
	(125133, 109, '2015-04-01 00:07:45.000000', 'temperatura', 634.0000, 'ºC'),
	(125134, 109, '2015-04-01 00:07:46.000000', 'temperatura', 1072.0000, 'ºC'),
	(125135, 109, '2015-04-01 00:07:47.000000', 'temperatura', 1060.0000, 'ºC'),
	(125136, 109, '2015-04-01 00:07:48.000000', 'temperatura', 884.0000, 'ºC'),
	(125137, 109, '2015-04-01 00:07:49.000000', 'temperatura', 39.0000, 'ºC'),
	(125138, 109, '2015-04-01 00:07:50.000000', 'temperatura', 1145.0000, 'ºC'),
	(125139, 109, '2015-04-01 00:07:51.000000', 'temperatura', 807.0000, 'ºC'),
	(125140, 109, '2015-04-01 00:07:52.000000', 'temperatura', 603.0000, 'ºC'),
	(125141, 109, '2015-04-01 00:07:53.000000', 'temperatura', 593.0000, 'ºC'),
	(125142, 109, '2015-04-01 00:07:54.000000', 'temperatura', 1158.0000, 'ºC'),
	(125143, 109, '2015-04-01 00:07:55.000000', 'temperatura', 411.0000, 'ºC'),
	(125144, 109, '2015-04-01 00:07:56.000000', 'temperatura', 980.0000, 'ºC'),
	(125145, 109, '2015-04-01 00:07:57.000000', 'temperatura', 69.0000, 'ºC'),
	(125146, 109, '2015-04-01 00:07:58.000000', 'temperatura', 1003.0000, 'ºC'),
	(125147, 109, '2015-04-01 00:07:59.000000', 'temperatura', 12.0000, 'ºC'),
	(125148, 109, '2015-04-01 00:08:00.000000', 'temperatura', 649.0000, 'ºC'),
	(125149, 109, '2015-04-01 00:08:01.000000', 'temperatura', 809.0000, 'ºC'),
	(125150, 109, '2015-04-01 00:08:02.000000', 'temperatura', 901.0000, 'ºC'),
	(125151, 109, '2015-04-01 00:08:03.000000', 'temperatura', 877.0000, 'ºC'),
	(125152, 109, '2015-04-01 00:08:04.000000', 'temperatura', 481.0000, 'ºC'),
	(125153, 109, '2015-04-01 00:08:05.000000', 'temperatura', 975.0000, 'ºC'),
	(125154, 109, '2015-04-01 00:08:06.000000', 'temperatura', 1034.0000, 'ºC'),
	(125155, 109, '2015-04-01 00:08:07.000000', 'temperatura', 1043.0000, 'ºC'),
	(125156, 109, '2015-04-01 00:08:08.000000', 'temperatura', 915.0000, 'ºC'),
	(125157, 109, '2015-04-01 00:08:09.000000', 'temperatura', 245.0000, 'ºC'),
	(125158, 109, '2015-04-01 00:08:10.000000', 'temperatura', 883.0000, 'ºC'),
	(125159, 109, '2015-04-01 00:08:11.000000', 'temperatura', 81.0000, 'ºC'),
	(125160, 109, '2015-04-01 00:08:12.000000', 'temperatura', 155.0000, 'ºC'),
	(125161, 109, '2015-04-01 00:08:13.000000', 'temperatura', 532.0000, 'ºC'),
	(125162, 109, '2015-04-01 00:08:14.000000', 'temperatura', 994.0000, 'ºC'),
	(125163, 109, '2015-04-01 00:08:15.000000', 'temperatura', 975.0000, 'ºC'),
	(125164, 109, '2015-04-01 00:08:16.000000', 'temperatura', 696.0000, 'ºC'),
	(125165, 109, '2015-04-01 00:08:17.000000', 'temperatura', 555.0000, 'ºC'),
	(125166, 109, '2015-04-01 00:08:18.000000', 'temperatura', 687.0000, 'ºC'),
	(125167, 109, '2015-04-01 00:08:19.000000', 'temperatura', 570.0000, 'ºC'),
	(125168, 109, '2015-04-01 00:08:20.000000', 'temperatura', 791.0000, 'ºC'),
	(125169, 109, '2015-04-01 00:08:21.000000', 'temperatura', 1046.0000, 'ºC'),
	(125170, 109, '2015-04-01 00:08:22.000000', 'temperatura', 455.0000, 'ºC'),
	(125171, 109, '2015-04-01 00:08:23.000000', 'temperatura', 340.0000, 'ºC'),
	(125172, 109, '2015-04-01 00:08:24.000000', 'temperatura', 336.0000, 'ºC'),
	(125173, 109, '2015-04-01 00:08:25.000000', 'temperatura', 658.0000, 'ºC'),
	(125174, 109, '2015-04-01 00:08:26.000000', 'temperatura', 1082.0000, 'ºC'),
	(125175, 109, '2015-04-01 00:08:27.000000', 'temperatura', 1036.0000, 'ºC'),
	(125176, 109, '2015-04-01 00:08:28.000000', 'temperatura', 735.0000, 'ºC'),
	(125177, 109, '2015-04-01 00:08:29.000000', 'temperatura', 569.0000, 'ºC'),
	(125178, 109, '2015-04-01 00:08:30.000000', 'temperatura', 638.0000, 'ºC'),
	(125179, 109, '2015-04-01 00:08:31.000000', 'temperatura', 284.0000, 'ºC'),
	(125180, 109, '2015-04-01 00:08:32.000000', 'temperatura', 706.0000, 'ºC'),
	(125181, 109, '2015-04-01 00:08:33.000000', 'temperatura', 278.0000, 'ºC'),
	(125182, 109, '2015-04-01 00:08:34.000000', 'temperatura', 473.0000, 'ºC'),
	(125183, 109, '2015-04-01 00:08:35.000000', 'temperatura', 331.0000, 'ºC'),
	(125184, 109, '2015-04-01 00:08:36.000000', 'temperatura', 238.0000, 'ºC'),
	(125185, 109, '2015-04-01 00:08:37.000000', 'temperatura', 196.0000, 'ºC'),
	(125186, 109, '2015-04-01 00:08:38.000000', 'temperatura', 267.0000, 'ºC'),
	(125187, 109, '2015-04-01 00:08:39.000000', 'temperatura', 749.0000, 'ºC'),
	(125188, 109, '2015-04-01 00:08:40.000000', 'temperatura', 542.0000, 'ºC'),
	(125189, 109, '2015-04-01 00:08:41.000000', 'temperatura', 465.0000, 'ºC'),
	(125190, 109, '2015-04-01 00:08:42.000000', 'temperatura', 700.0000, 'ºC'),
	(125191, 109, '2015-04-01 00:08:43.000000', 'temperatura', 903.0000, 'ºC'),
	(125192, 109, '2015-04-01 00:08:44.000000', 'temperatura', 19.0000, 'ºC'),
	(125193, 109, '2015-04-01 00:08:45.000000', 'temperatura', 983.0000, 'ºC'),
	(125194, 109, '2015-04-01 00:08:46.000000', 'temperatura', 59.0000, 'ºC'),
	(125195, 109, '2015-04-01 00:08:47.000000', 'temperatura', 949.0000, 'ºC'),
	(125196, 109, '2015-04-01 00:08:48.000000', 'temperatura', 968.0000, 'ºC'),
	(125197, 109, '2015-04-01 00:08:49.000000', 'temperatura', 791.0000, 'ºC'),
	(125198, 109, '2015-04-01 00:08:50.000000', 'temperatura', 1053.0000, 'ºC'),
	(125199, 109, '2015-04-01 00:08:51.000000', 'temperatura', 490.0000, 'ºC'),
	(125200, 109, '2015-04-01 00:08:52.000000', 'temperatura', 495.0000, 'ºC'),
	(125201, 109, '2015-04-01 00:08:53.000000', 'temperatura', 1005.0000, 'ºC'),
	(125202, 109, '2015-04-01 00:08:54.000000', 'temperatura', 1140.0000, 'ºC'),
	(125203, 109, '2015-04-01 00:08:55.000000', 'temperatura', 284.0000, 'ºC'),
	(125204, 109, '2015-04-01 00:08:56.000000', 'temperatura', 400.0000, 'ºC'),
	(125205, 109, '2015-04-01 00:08:57.000000', 'temperatura', 1149.0000, 'ºC'),
	(125206, 109, '2015-04-01 00:08:58.000000', 'temperatura', 947.0000, 'ºC'),
	(125207, 109, '2015-04-01 00:08:59.000000', 'temperatura', 88.0000, 'ºC'),
	(125208, 109, '2015-04-01 00:09:00.000000', 'temperatura', 1199.0000, 'ºC'),
	(125209, 109, '2015-04-01 00:09:01.000000', 'temperatura', 930.0000, 'ºC'),
	(125210, 109, '2015-04-01 00:09:02.000000', 'temperatura', 1054.0000, 'ºC'),
	(125211, 109, '2015-04-01 00:09:03.000000', 'temperatura', 80.0000, 'ºC'),
	(125212, 109, '2015-04-01 00:09:04.000000', 'temperatura', 841.0000, 'ºC'),
	(125213, 109, '2015-04-01 00:09:05.000000', 'temperatura', 363.0000, 'ºC'),
	(125214, 109, '2015-04-01 00:09:06.000000', 'temperatura', 492.0000, 'ºC'),
	(125215, 109, '2015-04-01 00:09:07.000000', 'temperatura', 173.0000, 'ºC'),
	(125216, 109, '2015-04-01 00:09:08.000000', 'temperatura', 591.0000, 'ºC'),
	(125217, 109, '2015-04-01 00:09:09.000000', 'temperatura', 34.0000, 'ºC'),
	(125218, 109, '2015-04-01 00:09:10.000000', 'temperatura', 796.0000, 'ºC'),
	(125219, 109, '2015-04-01 00:09:11.000000', 'temperatura', 281.0000, 'ºC'),
	(125220, 109, '2015-04-01 00:09:12.000000', 'temperatura', 217.0000, 'ºC'),
	(125221, 109, '2015-04-01 00:09:13.000000', 'temperatura', 244.0000, 'ºC'),
	(125222, 109, '2015-04-01 00:09:14.000000', 'temperatura', 568.0000, 'ºC'),
	(125223, 109, '2015-04-01 00:09:15.000000', 'temperatura', 907.0000, 'ºC'),
	(125224, 109, '2015-04-01 00:09:16.000000', 'temperatura', 435.0000, 'ºC'),
	(125225, 109, '2015-04-01 00:09:17.000000', 'temperatura', 652.0000, 'ºC'),
	(125226, 109, '2015-04-01 00:09:18.000000', 'temperatura', 755.0000, 'ºC'),
	(125227, 109, '2015-04-01 00:09:19.000000', 'temperatura', 620.0000, 'ºC'),
	(125228, 109, '2015-04-01 00:09:20.000000', 'temperatura', 834.0000, 'ºC'),
	(125229, 109, '2015-04-01 00:09:21.000000', 'temperatura', 1113.0000, 'ºC'),
	(125230, 109, '2015-04-01 00:09:22.000000', 'temperatura', 661.0000, 'ºC'),
	(125231, 109, '2015-04-01 00:09:23.000000', 'temperatura', 1168.0000, 'ºC'),
	(125232, 109, '2015-04-01 00:09:24.000000', 'temperatura', 259.0000, 'ºC'),
	(125233, 109, '2015-04-01 00:09:25.000000', 'temperatura', 190.0000, 'ºC'),
	(125234, 109, '2015-04-01 00:09:26.000000', 'temperatura', 172.0000, 'ºC'),
	(125235, 109, '2015-04-01 00:09:27.000000', 'temperatura', 292.0000, 'ºC'),
	(125236, 109, '2015-04-01 00:09:28.000000', 'temperatura', 943.0000, 'ºC'),
	(125237, 109, '2015-04-01 00:09:29.000000', 'temperatura', 241.0000, 'ºC'),
	(125238, 109, '2015-04-01 00:09:30.000000', 'temperatura', 776.0000, 'ºC'),
	(125239, 109, '2015-04-01 00:09:31.000000', 'temperatura', 756.0000, 'ºC'),
	(125240, 109, '2015-04-01 00:09:32.000000', 'temperatura', 253.0000, 'ºC'),
	(125241, 109, '2015-04-01 00:09:33.000000', 'temperatura', 197.0000, 'ºC'),
	(125242, 109, '2015-04-01 00:09:34.000000', 'temperatura', 229.0000, 'ºC'),
	(125243, 109, '2015-04-01 00:09:35.000000', 'temperatura', 551.0000, 'ºC'),
	(125244, 109, '2015-04-01 00:09:36.000000', 'temperatura', 872.0000, 'ºC'),
	(125245, 109, '2015-04-01 00:09:37.000000', 'temperatura', 305.0000, 'ºC'),
	(125246, 109, '2015-04-01 00:09:38.000000', 'temperatura', 112.0000, 'ºC'),
	(125247, 109, '2015-04-01 00:09:39.000000', 'temperatura', 842.0000, 'ºC'),
	(125248, 109, '2015-04-01 00:09:40.000000', 'temperatura', 277.0000, 'ºC'),
	(125249, 109, '2015-04-01 00:09:41.000000', 'temperatura', 60.0000, 'ºC'),
	(125250, 109, '2015-04-01 00:09:42.000000', 'temperatura', 668.0000, 'ºC'),
	(125251, 109, '2015-04-01 00:09:43.000000', 'temperatura', 760.0000, 'ºC'),
	(125252, 109, '2015-04-01 00:09:44.000000', 'temperatura', 596.0000, 'ºC'),
	(125253, 109, '2015-04-01 00:09:45.000000', 'temperatura', 701.0000, 'ºC'),
	(125254, 109, '2015-04-01 00:09:46.000000', 'temperatura', 516.0000, 'ºC'),
	(125255, 109, '2015-04-01 00:09:47.000000', 'temperatura', 477.0000, 'ºC'),
	(125256, 109, '2015-04-01 00:09:48.000000', 'temperatura', 841.0000, 'ºC'),
	(125257, 109, '2015-04-01 00:09:49.000000', 'temperatura', 372.0000, 'ºC'),
	(125258, 109, '2015-04-01 00:09:50.000000', 'temperatura', 538.0000, 'ºC'),
	(125259, 109, '2015-04-01 00:09:51.000000', 'temperatura', 376.0000, 'ºC'),
	(125260, 109, '2015-04-01 00:09:52.000000', 'temperatura', 265.0000, 'ºC'),
	(125261, 109, '2015-04-01 00:09:53.000000', 'temperatura', 198.0000, 'ºC'),
	(125262, 109, '2015-04-01 00:09:54.000000', 'temperatura', 196.0000, 'ºC'),
	(125263, 109, '2015-04-01 00:09:55.000000', 'temperatura', 387.0000, 'ºC'),
	(125264, 109, '2015-04-01 00:09:56.000000', 'temperatura', 145.0000, 'ºC'),
	(125265, 109, '2015-04-01 00:09:57.000000', 'temperatura', 765.0000, 'ºC'),
	(125266, 109, '2015-04-01 00:09:58.000000', 'temperatura', 990.0000, 'ºC'),
	(125267, 109, '2015-04-01 00:09:59.000000', 'temperatura', 255.0000, 'ºC'),
	(125268, 109, '2015-04-01 00:10:00.000000', 'temperatura', 708.0000, 'ºC'),
	(125269, 109, '2015-04-01 00:10:01.000000', 'temperatura', 373.0000, 'ºC'),
	(125270, 109, '2015-04-01 00:10:02.000000', 'temperatura', 943.0000, 'ºC'),
	(125271, 109, '2015-04-01 00:10:03.000000', 'temperatura', 1197.0000, 'ºC'),
	(125272, 109, '2015-04-01 00:10:04.000000', 'temperatura', 758.0000, 'ºC'),
	(125273, 109, '2015-04-01 00:10:05.000000', 'temperatura', 197.0000, 'ºC'),
	(125274, 109, '2015-04-01 00:10:06.000000', 'temperatura', 1112.0000, 'ºC'),
	(125275, 109, '2015-04-01 00:10:07.000000', 'temperatura', 171.0000, 'ºC'),
	(125276, 109, '2015-04-01 00:10:08.000000', 'temperatura', 1119.0000, 'ºC'),
	(125277, 109, '2015-04-01 00:10:09.000000', 'temperatura', 281.0000, 'ºC'),
	(125278, 109, '2015-04-01 00:10:10.000000', 'temperatura', 448.0000, 'ºC'),
	(125279, 109, '2015-04-01 00:10:11.000000', 'temperatura', 199.0000, 'ºC'),
	(125280, 109, '2015-04-01 00:10:12.000000', 'temperatura', 850.0000, 'ºC'),
	(125281, 109, '2015-04-01 00:10:13.000000', 'temperatura', 56.0000, 'ºC'),
	(125282, 109, '2015-04-01 00:10:14.000000', 'temperatura', 128.0000, 'ºC'),
	(125283, 109, '2015-04-01 00:10:15.000000', 'temperatura', 474.0000, 'ºC'),
	(125284, 109, '2015-04-01 00:10:16.000000', 'temperatura', 788.0000, 'ºC'),
	(125285, 109, '2015-04-01 00:10:17.000000', 'temperatura', 115.0000, 'ºC'),
	(125286, 109, '2015-04-01 00:10:18.000000', 'temperatura', 614.0000, 'ºC'),
	(125287, 109, '2015-04-01 00:10:19.000000', 'temperatura', 325.0000, 'ºC'),
	(125288, 109, '2015-04-01 00:10:20.000000', 'temperatura', 981.0000, 'ºC'),
	(125289, 109, '2015-04-01 00:10:21.000000', 'temperatura', 333.0000, 'ºC'),
	(125290, 109, '2015-04-01 00:10:22.000000', 'temperatura', 1122.0000, 'ºC'),
	(125291, 109, '2015-04-01 00:10:23.000000', 'temperatura', 1013.0000, 'ºC'),
	(125292, 109, '2015-04-01 00:10:24.000000', 'temperatura', 500.0000, 'ºC'),
	(125293, 109, '2015-04-01 00:10:25.000000', 'temperatura', 661.0000, 'ºC'),
	(125294, 109, '2015-04-01 00:10:26.000000', 'temperatura', 607.0000, 'ºC'),
	(125295, 109, '2015-04-01 00:10:27.000000', 'temperatura', 1052.0000, 'ºC'),
	(125296, 109, '2015-04-01 00:10:28.000000', 'temperatura', 1037.0000, 'ºC'),
	(125297, 109, '2015-04-01 00:10:29.000000', 'temperatura', 830.0000, 'ºC'),
	(125298, 109, '2015-04-01 00:10:30.000000', 'temperatura', 1040.0000, 'ºC'),
	(125299, 109, '2015-04-01 00:10:31.000000', 'temperatura', 313.0000, 'ºC'),
	(125300, 109, '2015-04-01 00:10:32.000000', 'temperatura', 842.0000, 'ºC'),
	(125301, 109, '2015-04-01 00:10:33.000000', 'temperatura', 874.0000, 'ºC'),
	(125302, 109, '2015-04-01 00:10:34.000000', 'temperatura', 646.0000, 'ºC'),
	(125303, 109, '2015-04-01 00:10:35.000000', 'temperatura', 605.0000, 'ºC'),
	(125304, 109, '2015-04-01 00:10:36.000000', 'temperatura', 1090.0000, 'ºC'),
	(125305, 109, '2015-04-01 00:10:37.000000', 'temperatura', 34.0000, 'ºC'),
	(125306, 109, '2015-04-01 00:10:38.000000', 'temperatura', 502.0000, 'ºC'),
	(125307, 109, '2015-04-01 00:10:39.000000', 'temperatura', 9.0000, 'ºC'),
	(125308, 109, '2015-04-01 00:10:40.000000', 'temperatura', 938.0000, 'ºC'),
	(125309, 109, '2015-04-01 00:10:41.000000', 'temperatura', 1065.0000, 'ºC'),
	(125310, 109, '2015-04-01 00:10:42.000000', 'temperatura', 111.0000, 'ºC'),
	(125311, 109, '2015-04-01 00:10:43.000000', 'temperatura', 960.0000, 'ºC'),
	(125312, 109, '2015-04-01 00:10:44.000000', 'temperatura', 866.0000, 'ºC'),
	(125313, 109, '2015-04-01 00:10:45.000000', 'temperatura', 254.0000, 'ºC'),
	(125314, 109, '2015-04-01 00:10:46.000000', 'temperatura', 1070.0000, 'ºC'),
	(125315, 109, '2015-04-01 00:10:47.000000', 'temperatura', 988.0000, 'ºC'),
	(125316, 109, '2015-04-01 00:10:48.000000', 'temperatura', 530.0000, 'ºC'),
	(125317, 109, '2015-04-01 00:10:49.000000', 'temperatura', 889.0000, 'ºC'),
	(125318, 109, '2015-04-01 00:10:50.000000', 'temperatura', 454.0000, 'ºC'),
	(125319, 109, '2015-04-01 00:10:51.000000', 'temperatura', 806.0000, 'ºC'),
	(125320, 109, '2015-04-01 00:10:52.000000', 'temperatura', 266.0000, 'ºC'),
	(125321, 109, '2015-04-01 00:10:53.000000', 'temperatura', 113.0000, 'ºC'),
	(125322, 109, '2015-04-01 00:10:54.000000', 'temperatura', 969.0000, 'ºC'),
	(125323, 109, '2015-04-01 00:10:55.000000', 'temperatura', 905.0000, 'ºC'),
	(125324, 109, '2015-04-01 00:10:56.000000', 'temperatura', 418.0000, 'ºC'),
	(125325, 109, '2015-04-01 00:10:57.000000', 'temperatura', 577.0000, 'ºC'),
	(125326, 109, '2015-04-01 00:10:58.000000', 'temperatura', 429.0000, 'ºC'),
	(125327, 109, '2015-04-01 00:10:59.000000', 'temperatura', 418.0000, 'ºC'),
	(125328, 109, '2015-04-01 00:11:00.000000', 'temperatura', 800.0000, 'ºC'),
	(125329, 109, '2015-04-01 00:11:01.000000', 'temperatura', 347.0000, 'ºC'),
	(125330, 109, '2015-04-01 00:11:02.000000', 'temperatura', 537.0000, 'ºC'),
	(125331, 109, '2015-04-01 00:11:03.000000', 'temperatura', 444.0000, 'ºC'),
	(125332, 109, '2015-04-01 00:11:04.000000', 'temperatura', 608.0000, 'ºC'),
	(125333, 109, '2015-04-01 00:11:05.000000', 'temperatura', 509.0000, 'ºC'),
	(125334, 109, '2015-04-01 00:11:06.000000', 'temperatura', 721.0000, 'ºC'),
	(125335, 109, '2015-04-01 00:11:07.000000', 'temperatura', 878.0000, 'ºC'),
	(125336, 109, '2015-04-01 00:11:08.000000', 'temperatura', 1028.0000, 'ºC'),
	(125337, 109, '2015-04-01 00:11:09.000000', 'temperatura', 105.0000, 'ºC'),
	(125338, 109, '2015-04-01 00:11:10.000000', 'temperatura', 1044.0000, 'ºC'),
	(125339, 109, '2015-04-01 00:11:11.000000', 'temperatura', 105.0000, 'ºC'),
	(125340, 109, '2015-04-01 00:11:12.000000', 'temperatura', 991.0000, 'ºC'),
	(125341, 109, '2015-04-01 00:11:13.000000', 'temperatura', 1044.0000, 'ºC'),
	(125342, 109, '2015-04-01 00:11:14.000000', 'temperatura', 1045.0000, 'ºC'),
	(125343, 109, '2015-04-01 00:11:15.000000', 'temperatura', 894.0000, 'ºC'),
	(125344, 109, '2015-04-01 00:11:16.000000', 'temperatura', 136.0000, 'ºC'),
	(125345, 109, '2015-04-01 00:11:17.000000', 'temperatura', 397.0000, 'ºC'),
	(125346, 109, '2015-04-01 00:11:18.000000', 'temperatura', 377.0000, 'ºC'),
	(125347, 109, '2015-04-01 00:11:19.000000', 'temperatura', 695.0000, 'ºC'),
	(125348, 109, '2015-04-01 00:11:20.000000', 'temperatura', 1146.0000, 'ºC'),
	(125349, 109, '2015-04-01 00:11:21.000000', 'temperatura', 46.0000, 'ºC'),
	(125350, 109, '2015-04-01 00:11:22.000000', 'temperatura', 392.0000, 'ºC'),
	(125351, 109, '2015-04-01 00:11:23.000000', 'temperatura', 624.0000, 'ºC'),
	(125352, 109, '2015-04-01 00:11:24.000000', 'temperatura', 744.0000, 'ºC'),
	(125353, 109, '2015-04-01 00:11:25.000000', 'temperatura', 649.0000, 'ºC'),
	(125354, 109, '2015-04-01 00:11:26.000000', 'temperatura', 1015.0000, 'ºC'),
	(125355, 109, '2015-04-01 00:11:27.000000', 'temperatura', 726.0000, 'ºC'),
	(125356, 109, '2015-04-01 00:11:28.000000', 'temperatura', 587.0000, 'ºC'),
	(125357, 109, '2015-04-01 00:11:29.000000', 'temperatura', 755.0000, 'ºC'),
	(125358, 109, '2015-04-01 00:11:30.000000', 'temperatura', 816.0000, 'ºC'),
	(125359, 109, '2015-04-01 00:11:31.000000', 'temperatura', 617.0000, 'ºC'),
	(125360, 109, '2015-04-01 00:11:32.000000', 'temperatura', 638.0000, 'ºC'),
	(125361, 109, '2015-04-01 00:11:33.000000', 'temperatura', 139.0000, 'ºC'),
	(125362, 109, '2015-04-01 00:11:34.000000', 'temperatura', 1180.0000, 'ºC'),
	(125363, 109, '2015-04-01 00:11:35.000000', 'temperatura', 682.0000, 'ºC'),
	(125364, 109, '2015-04-01 00:11:36.000000', 'temperatura', 1074.0000, 'ºC'),
	(125365, 109, '2015-04-01 00:11:37.000000', 'temperatura', 923.0000, 'ºC'),
	(125366, 109, '2015-04-01 00:11:38.000000', 'temperatura', 193.0000, 'ºC'),
	(125367, 109, '2015-04-01 00:11:39.000000', 'temperatura', 598.0000, 'ºC'),
	(125368, 109, '2015-04-01 00:11:40.000000', 'temperatura', 10.0000, 'ºC'),
	(125369, 109, '2015-04-01 00:11:41.000000', 'temperatura', 658.0000, 'ºC'),
	(125370, 109, '2015-04-01 00:11:42.000000', 'temperatura', 858.0000, 'ºC'),
	(125371, 109, '2015-04-01 00:11:43.000000', 'temperatura', 1119.0000, 'ºC'),
	(125372, 109, '2015-04-01 00:11:44.000000', 'temperatura', 619.0000, 'ºC'),
	(125373, 109, '2015-04-01 00:11:45.000000', 'temperatura', 940.0000, 'ºC'),
	(125374, 109, '2015-04-01 00:11:46.000000', 'temperatura', 445.0000, 'ºC'),
	(125375, 109, '2015-04-01 00:11:47.000000', 'temperatura', 604.0000, 'ºC'),
	(125376, 109, '2015-04-01 00:11:48.000000', 'temperatura', 486.0000, 'ºC'),
	(125377, 109, '2015-04-01 00:11:49.000000', 'temperatura', 617.0000, 'ºC'),
	(125378, 109, '2015-04-01 00:11:50.000000', 'temperatura', 428.0000, 'ºC'),
	(125379, 109, '2015-04-01 00:11:51.000000', 'temperatura', 288.0000, 'ºC'),
	(125380, 109, '2015-04-01 00:11:52.000000', 'temperatura', 158.0000, 'ºC'),
	(125381, 109, '2015-04-01 00:11:53.000000', 'temperatura', 1127.0000, 'ºC'),
	(125382, 109, '2015-04-01 00:11:54.000000', 'temperatura', 361.0000, 'ºC'),
	(125383, 109, '2015-04-01 00:11:55.000000', 'temperatura', 825.0000, 'ºC'),
	(125384, 109, '2015-04-01 00:11:56.000000', 'temperatura', 644.0000, 'ºC'),
	(125385, 109, '2015-04-01 00:11:57.000000', 'temperatura', 744.0000, 'ºC'),
	(125386, 109, '2015-04-01 00:11:58.000000', 'temperatura', 587.0000, 'ºC'),
	(125387, 109, '2015-04-01 00:11:59.000000', 'temperatura', 706.0000, 'ºC'),
	(125388, 109, '2015-04-01 00:12:00.000000', 'temperatura', 567.0000, 'ºC'),
	(125389, 109, '2015-04-01 00:12:01.000000', 'temperatura', 718.0000, 'ºC'),
	(125390, 109, '2015-04-01 00:12:02.000000', 'temperatura', 688.0000, 'ºC'),
	(125391, 109, '2015-04-01 00:12:03.000000', 'temperatura', 88.0000, 'ºC'),
	(125392, 109, '2015-04-01 00:12:04.000000', 'temperatura', 776.0000, 'ºC'),
	(125393, 109, '2015-04-01 00:12:05.000000', 'temperatura', 17.0000, 'ºC'),
	(125394, 109, '2015-04-01 00:12:06.000000', 'temperatura', 158.0000, 'ºC'),
	(125395, 109, '2015-04-01 00:12:07.000000', 'temperatura', 739.0000, 'ºC'),
	(125396, 109, '2015-04-01 00:12:08.000000', 'temperatura', 822.0000, 'ºC'),
	(125397, 109, '2015-04-01 00:12:09.000000', 'temperatura', 693.0000, 'ºC'),
	(125398, 109, '2015-04-01 00:12:10.000000', 'temperatura', 998.0000, 'ºC'),
	(125399, 109, '2015-04-01 00:12:11.000000', 'temperatura', 513.0000, 'ºC'),
	(125400, 109, '2015-04-01 00:12:12.000000', 'temperatura', 772.0000, 'ºC'),
	(125401, 109, '2015-04-01 00:12:13.000000', 'temperatura', 1122.0000, 'ºC'),
	(125402, 109, '2015-04-01 00:12:14.000000', 'temperatura', 894.0000, 'ºC'),
	(125403, 109, '2015-04-01 00:12:15.000000', 'temperatura', 1102.0000, 'ºC'),
	(125404, 109, '2015-04-01 00:12:16.000000', 'temperatura', 432.0000, 'ºC'),
	(125405, 109, '2015-04-01 00:12:17.000000', 'temperatura', 51.0000, 'ºC'),
	(125406, 109, '2015-04-01 00:12:18.000000', 'temperatura', 162.0000, 'ºC'),
	(125407, 109, '2015-04-01 00:12:19.000000', 'temperatura', 656.0000, 'ºC'),
	(125408, 109, '2015-04-01 00:12:20.000000', 'temperatura', 393.0000, 'ºC'),
	(125409, 109, '2015-04-01 00:12:21.000000', 'temperatura', 1199.0000, 'ºC'),
	(125410, 109, '2015-04-01 00:12:22.000000', 'temperatura', 18.0000, 'ºC'),
	(125411, 109, '2015-04-01 00:12:23.000000', 'temperatura', 93.0000, 'ºC'),
	(125412, 109, '2015-04-01 00:12:24.000000', 'temperatura', 409.0000, 'ºC'),
	(125413, 109, '2015-04-01 00:12:25.000000', 'temperatura', 570.0000, 'ºC'),
	(125414, 109, '2015-04-01 00:12:26.000000', 'temperatura', 422.0000, 'ºC'),
	(125415, 109, '2015-04-01 00:12:27.000000', 'temperatura', 402.0000, 'ºC'),
	(125416, 109, '2015-04-01 00:12:28.000000', 'temperatura', 743.0000, 'ºC'),
	(125417, 109, '2015-04-01 00:12:29.000000', 'temperatura', 109.0000, 'ºC'),
	(125418, 109, '2015-04-01 00:12:30.000000', 'temperatura', 715.0000, 'ºC'),
	(125419, 109, '2015-04-01 00:12:31.000000', 'temperatura', 851.0000, 'ºC'),
	(125420, 109, '2015-04-01 00:12:32.000000', 'temperatura', 909.0000, 'ºC'),
	(125421, 109, '2015-04-01 00:12:33.000000', 'temperatura', 792.0000, 'ºC'),
	(125422, 109, '2015-04-01 00:12:34.000000', 'temperatura', 35.0000, 'ºC'),
	(125423, 109, '2015-04-01 00:12:35.000000', 'temperatura', 200.0000, 'ºC'),
	(125424, 109, '2015-04-01 00:12:36.000000', 'temperatura', 896.0000, 'ºC'),
	(125425, 109, '2015-04-01 00:12:37.000000', 'temperatura', 278.0000, 'ºC'),
	(125426, 109, '2015-04-01 00:12:38.000000', 'temperatura', 1103.0000, 'ºC'),
	(125427, 109, '2015-04-01 00:12:39.000000', 'temperatura', 1082.0000, 'ºC'),
	(125428, 109, '2015-04-01 00:12:40.000000', 'temperatura', 901.0000, 'ºC'),
	(125429, 109, '2015-04-01 00:12:41.000000', 'temperatura', 61.0000, 'ºC'),
	(125430, 109, '2015-04-01 00:12:42.000000', 'temperatura', 1.0000, 'ºC'),
	(125431, 109, '2015-04-01 00:12:43.000000', 'temperatura', 1024.0000, 'ºC'),
	(125432, 109, '2015-04-01 00:12:44.000000', 'temperatura', 315.0000, 'ºC'),
	(125433, 109, '2015-04-01 00:12:45.000000', 'temperatura', 905.0000, 'ºC'),
	(125434, 109, '2015-04-01 00:12:46.000000', 'temperatura', 1182.0000, 'ºC'),
	(125435, 109, '2015-04-01 00:12:47.000000', 'temperatura', 795.0000, 'ºC'),
	(125436, 109, '2015-04-01 00:12:48.000000', 'temperatura', 430.0000, 'ºC'),
	(125437, 109, '2015-04-01 00:12:49.000000', 'temperatura', 965.0000, 'ºC'),
	(125438, 109, '2015-04-01 00:12:50.000000', 'temperatura', 1137.0000, 'ºC'),
	(125439, 109, '2015-04-01 00:12:51.000000', 'temperatura', 388.0000, 'ºC'),
	(125440, 109, '2015-04-01 00:12:52.000000', 'temperatura', 930.0000, 'ºC'),
	(125441, 109, '2015-04-01 00:12:53.000000', 'temperatura', 1087.0000, 'ºC'),
	(125442, 109, '2015-04-01 00:12:54.000000', 'temperatura', 247.0000, 'ºC'),
	(125443, 109, '2015-04-01 00:12:55.000000', 'temperatura', 373.0000, 'ºC'),
	(125444, 109, '2015-04-01 00:12:56.000000', 'temperatura', 1126.0000, 'ºC'),
	(125445, 109, '2015-04-01 00:12:57.000000', 'temperatura', 909.0000, 'ºC'),
	(125446, 109, '2015-04-01 00:12:58.000000', 'temperatura', 1167.0000, 'ºC'),
	(125447, 109, '2015-04-01 00:12:59.000000', 'temperatura', 709.0000, 'ºC'),
	(125448, 109, '2015-04-01 00:13:00.000000', 'temperatura', 46.0000, 'ºC'),
	(125449, 109, '2015-04-01 00:13:01.000000', 'temperatura', 501.0000, 'ºC'),
	(125450, 109, '2015-04-01 00:13:02.000000', 'temperatura', 1167.0000, 'ºC'),
	(125451, 109, '2015-04-01 00:13:03.000000', 'temperatura', 735.0000, 'ºC'),
	(125452, 109, '2015-04-01 00:13:04.000000', 'temperatura', 176.0000, 'ºC'),
	(125453, 109, '2015-04-01 00:13:05.000000', 'temperatura', 1072.0000, 'ºC'),
	(125454, 109, '2015-04-01 00:13:06.000000', 'temperatura', 33.0000, 'ºC'),
	(125455, 109, '2015-04-01 00:13:07.000000', 'temperatura', 552.0000, 'ºC'),
	(125456, 109, '2015-04-01 00:13:08.000000', 'temperatura', 259.0000, 'ºC'),
	(125457, 109, '2015-04-01 00:13:09.000000', 'temperatura', 839.0000, 'ºC'),
	(125458, 109, '2015-04-01 00:13:10.000000', 'temperatura', 1019.0000, 'ºC'),
	(125459, 109, '2015-04-01 00:13:11.000000', 'temperatura', 179.0000, 'ºC'),
	(125460, 109, '2015-04-01 00:13:12.000000', 'temperatura', 238.0000, 'ºC'),
	(125461, 109, '2015-04-01 00:13:13.000000', 'temperatura', 652.0000, 'ºC'),
	(125462, 109, '2015-04-01 00:13:14.000000', 'temperatura', 148.0000, 'ºC'),
	(125463, 109, '2015-04-01 00:13:15.000000', 'temperatura', 1183.0000, 'ºC'),
	(125464, 109, '2015-04-01 00:13:16.000000', 'temperatura', 671.0000, 'ºC'),
	(125465, 109, '2015-04-01 00:13:17.000000', 'temperatura', 1006.0000, 'ºC'),
	(125466, 109, '2015-04-01 00:13:18.000000', 'temperatura', 617.0000, 'ºC'),
	(125467, 109, '2015-04-01 00:13:19.000000', 'temperatura', 67.0000, 'ºC'),
	(125468, 109, '2015-04-01 00:13:20.000000', 'temperatura', 887.0000, 'ºC'),
	(125469, 109, '2015-04-01 00:13:21.000000', 'temperatura', 634.0000, 'ºC'),
	(125470, 109, '2015-04-01 00:13:22.000000', 'temperatura', 508.0000, 'ºC'),
	(125471, 109, '2015-04-01 00:13:23.000000', 'temperatura', 640.0000, 'ºC'),
	(125472, 109, '2015-04-01 00:13:24.000000', 'temperatura', 477.0000, 'ºC'),
	(125473, 109, '2015-04-01 00:13:25.000000', 'temperatura', 465.0000, 'ºC'),
	(125474, 109, '2015-04-01 00:13:26.000000', 'temperatura', 896.0000, 'ºC'),
	(125475, 109, '2015-04-01 00:13:27.000000', 'temperatura', 686.0000, 'ºC'),
	(125476, 109, '2015-04-01 00:13:28.000000', 'temperatura', 741.0000, 'ºC'),
	(125477, 109, '2015-04-01 00:13:29.000000', 'temperatura', 447.0000, 'ºC'),
	(125478, 109, '2015-04-01 00:13:30.000000', 'temperatura', 15.0000, 'ºC'),
	(125479, 109, '2015-04-01 00:13:31.000000', 'temperatura', 1133.0000, 'ºC'),
	(125480, 109, '2015-04-01 00:13:32.000000', 'temperatura', 823.0000, 'ºC'),
	(125481, 109, '2015-04-01 00:13:33.000000', 'temperatura', 714.0000, 'ºC'),
	(125482, 109, '2015-04-01 00:13:34.000000', 'temperatura', 1101.0000, 'ºC'),
	(125483, 109, '2015-04-01 00:13:35.000000', 'temperatura', 962.0000, 'ºC'),
	(125484, 109, '2015-04-01 00:13:36.000000', 'temperatura', 310.0000, 'ºC'),
	(125485, 109, '2015-04-01 00:13:37.000000', 'temperatura', 1064.0000, 'ºC'),
	(125486, 109, '2015-04-01 00:13:38.000000', 'temperatura', 789.0000, 'ºC'),
	(125487, 109, '2015-04-01 00:13:39.000000', 'temperatura', 756.0000, 'ºC'),
	(125488, 109, '2015-04-01 00:13:40.000000', 'temperatura', 213.0000, 'ºC'),
	(125489, 109, '2015-04-01 00:13:41.000000', 'temperatura', 1198.0000, 'ºC'),
	(125490, 109, '2015-04-01 00:13:42.000000', 'temperatura', 550.0000, 'ºC'),
	(125491, 109, '2015-04-01 00:13:43.000000', 'temperatura', 357.0000, 'ºC'),
	(125492, 109, '2015-04-01 00:13:44.000000', 'temperatura', 135.0000, 'ºC'),
	(125493, 109, '2015-04-01 00:13:45.000000', 'temperatura', 804.0000, 'ºC'),
	(125494, 109, '2015-04-01 00:13:46.000000', 'temperatura', 17.0000, 'ºC'),
	(125495, 109, '2015-04-01 00:13:47.000000', 'temperatura', 74.0000, 'ºC'),
	(125496, 109, '2015-04-01 00:13:48.000000', 'temperatura', 319.0000, 'ºC'),
	(125497, 109, '2015-04-01 00:13:49.000000', 'temperatura', 175.0000, 'ºC'),
	(125498, 109, '2015-04-01 00:13:50.000000', 'temperatura', 1116.0000, 'ºC'),
	(125499, 109, '2015-04-01 00:13:51.000000', 'temperatura', 255.0000, 'ºC'),
	(125500, 109, '2015-04-01 00:13:52.000000', 'temperatura', 328.0000, 'ºC'),
	(125501, 109, '2015-04-01 00:13:53.000000', 'temperatura', 878.0000, 'ºC'),
	(125502, 109, '2015-04-01 00:13:54.000000', 'temperatura', 1003.0000, 'ºC'),
	(125503, 109, '2015-04-01 00:13:55.000000', 'temperatura', 1185.0000, 'ºC'),
	(125504, 109, '2015-04-01 00:13:56.000000', 'temperatura', 515.0000, 'ºC'),
	(125505, 109, '2015-04-01 00:13:57.000000', 'temperatura', 221.0000, 'ºC'),
	(125506, 109, '2015-04-01 00:13:58.000000', 'temperatura', 758.0000, 'ºC'),
	(125507, 109, '2015-04-01 00:13:59.000000', 'temperatura', 731.0000, 'ºC'),
	(125508, 109, '2015-04-01 00:14:00.000000', 'temperatura', 181.0000, 'ºC'),
	(125509, 109, '2015-04-01 00:14:01.000000', 'temperatura', 1111.0000, 'ºC'),
	(125510, 109, '2015-04-01 00:14:02.000000', 'temperatura', 212.0000, 'ºC'),
	(125511, 109, '2015-04-01 00:14:03.000000', 'temperatura', 128.0000, 'ºC'),
	(125512, 109, '2015-04-01 00:14:04.000000', 'temperatura', 5.0000, 'ºC'),
	(125513, 109, '2015-04-01 00:14:05.000000', 'temperatura', 842.0000, 'ºC'),
	(125514, 109, '2015-04-01 00:14:06.000000', 'temperatura', 596.0000, 'ºC'),
	(125515, 109, '2015-04-01 00:14:07.000000', 'temperatura', 453.0000, 'ºC'),
	(125516, 109, '2015-04-01 00:14:08.000000', 'temperatura', 478.0000, 'ºC'),
	(125517, 109, '2015-04-01 00:14:09.000000', 'temperatura', 1030.0000, 'ºC'),
	(125518, 109, '2015-04-01 00:14:10.000000', 'temperatura', 120.0000, 'ºC'),
	(125519, 109, '2015-04-01 00:14:11.000000', 'temperatura', 1107.0000, 'ºC'),
	(125520, 109, '2015-04-01 00:14:12.000000', 'temperatura', 377.0000, 'ºC'),
	(125521, 109, '2015-04-01 00:14:13.000000', 'temperatura', 964.0000, 'ºC'),
	(125522, 109, '2015-04-01 00:14:14.000000', 'temperatura', 90.0000, 'ºC'),
	(125523, 109, '2015-04-01 00:14:15.000000', 'temperatura', 1160.0000, 'ºC'),
	(125524, 109, '2015-04-01 00:14:16.000000', 'temperatura', 729.0000, 'ºC'),
	(125525, 109, '2015-04-01 00:14:17.000000', 'temperatura', 164.0000, 'ºC'),
	(125526, 109, '2015-04-01 00:14:18.000000', 'temperatura', 1035.0000, 'ºC'),
	(125527, 109, '2015-04-01 00:14:19.000000', 'temperatura', 1082.0000, 'ºC'),
	(125528, 109, '2015-04-01 00:14:20.000000', 'temperatura', 1107.0000, 'ºC'),
	(125529, 109, '2015-04-01 00:14:21.000000', 'temperatura', 1090.0000, 'ºC'),
	(125530, 109, '2015-04-01 00:14:22.000000', 'temperatura', 927.0000, 'ºC'),
	(125531, 109, '2015-04-01 00:14:23.000000', 'temperatura', 169.0000, 'ºC'),
	(125532, 109, '2015-04-01 00:14:24.000000', 'temperatura', 462.0000, 'ºC'),
	(125533, 109, '2015-04-01 00:14:25.000000', 'temperatura', 605.0000, 'ºC'),
	(125534, 109, '2015-04-01 00:14:26.000000', 'temperatura', 441.0000, 'ºC'),
	(125535, 109, '2015-04-01 00:14:27.000000', 'temperatura', 389.0000, 'ºC'),
	(125536, 109, '2015-04-01 00:14:28.000000', 'temperatura', 624.0000, 'ºC'),
	(125537, 109, '2015-04-01 00:14:29.000000', 'temperatura', 751.0000, 'ºC'),
	(125538, 109, '2015-04-01 00:14:30.000000', 'temperatura', 684.0000, 'ºC'),
	(125539, 109, '2015-04-01 00:14:31.000000', 'temperatura', 1168.0000, 'ºC'),
	(125540, 109, '2015-04-01 00:14:32.000000', 'temperatura', 187.0000, 'ºC'),
	(125541, 109, '2015-04-01 00:14:33.000000', 'temperatura', 1034.0000, 'ºC'),
	(125542, 109, '2015-04-01 00:14:34.000000', 'temperatura', 1008.0000, 'ºC'),
	(125543, 109, '2015-04-01 00:14:35.000000', 'temperatura', 740.0000, 'ºC'),
	(125544, 109, '2015-04-01 00:14:36.000000', 'temperatura', 674.0000, 'ºC'),
	(125545, 109, '2015-04-01 00:14:37.000000', 'temperatura', 1154.0000, 'ºC'),
	(125546, 109, '2015-04-01 00:14:38.000000', 'temperatura', 145.0000, 'ºC'),
	(125547, 109, '2015-04-01 00:14:39.000000', 'temperatura', 864.0000, 'ºC'),
	(125548, 109, '2015-04-01 00:14:40.000000', 'temperatura', 288.0000, 'ºC'),
	(125549, 109, '2015-04-01 00:14:41.000000', 'temperatura', 47.0000, 'ºC'),
	(125550, 109, '2015-04-01 00:14:42.000000', 'temperatura', 572.0000, 'ºC'),
	(125551, 109, '2015-04-01 00:14:43.000000', 'temperatura', 318.0000, 'ºC'),
	(125552, 109, '2015-04-01 00:14:44.000000', 'temperatura', 1074.0000, 'ºC'),
	(125553, 109, '2015-04-01 00:14:45.000000', 'temperatura', 817.0000, 'ºC'),
	(125554, 109, '2015-04-01 00:14:46.000000', 'temperatura', 862.0000, 'ºC'),
	(125555, 109, '2015-04-01 00:14:47.000000', 'temperatura', 661.0000, 'ºC'),
	(125556, 109, '2015-04-01 00:14:48.000000', 'temperatura', 721.0000, 'ºC'),
	(125557, 109, '2015-04-01 00:14:49.000000', 'temperatura', 421.0000, 'ºC'),
	(125558, 109, '2015-04-01 00:14:50.000000', 'temperatura', 1144.0000, 'ºC'),
	(125559, 109, '2015-04-01 00:14:51.000000', 'temperatura', 855.0000, 'ºC'),
	(125560, 109, '2015-04-01 00:14:52.000000', 'temperatura', 846.0000, 'ºC'),
	(125561, 109, '2015-04-01 00:14:53.000000', 'temperatura', 465.0000, 'ºC'),
	(125562, 109, '2015-04-01 00:14:54.000000', 'temperatura', 988.0000, 'ºC'),
	(125563, 109, '2015-04-01 00:14:55.000000', 'temperatura', 1146.0000, 'ºC'),
	(125564, 109, '2015-04-01 00:14:56.000000', 'temperatura', 364.0000, 'ºC'),
	(125565, 109, '2015-04-01 00:14:57.000000', 'temperatura', 784.0000, 'ºC'),
	(125566, 109, '2015-04-01 00:14:58.000000', 'temperatura', 430.0000, 'ºC'),
	(125567, 109, '2015-04-01 00:14:59.000000', 'temperatura', 997.0000, 'ºC'),
	(125568, 109, '2015-04-01 00:15:00.000000', 'temperatura', 96.0000, 'ºC'),
	(125569, 109, '2015-04-01 00:15:01.000000', 'temperatura', 1090.0000, 'ºC'),
	(125570, 109, '2015-04-01 00:15:02.000000', 'temperatura', 364.0000, 'ºC'),
	(125571, 109, '2015-04-01 00:15:03.000000', 'temperatura', 949.0000, 'ºC'),
	(125572, 109, '2015-04-01 00:15:04.000000', 'temperatura', 52.0000, 'ºC'),
	(125573, 109, '2015-04-01 00:15:05.000000', 'temperatura', 1014.0000, 'ºC'),
	(125574, 109, '2015-04-01 00:15:06.000000', 'temperatura', 116.0000, 'ºC'),
	(125575, 109, '2015-04-01 00:15:07.000000', 'temperatura', 1138.0000, 'ºC'),
	(125576, 109, '2015-04-01 00:15:08.000000', 'temperatura', 540.0000, 'ºC'),
	(125577, 109, '2015-04-01 00:15:09.000000', 'temperatura', 490.0000, 'ºC'),
	(125578, 109, '2015-04-01 00:15:10.000000', 'temperatura', 828.0000, 'ºC'),
	(125579, 109, '2015-04-01 00:15:11.000000', 'temperatura', 272.0000, 'ºC'),
	(125580, 109, '2015-04-01 00:15:12.000000', 'temperatura', 77.0000, 'ºC'),
	(125581, 109, '2015-04-01 00:15:13.000000', 'temperatura', 768.0000, 'ºC'),
	(125582, 109, '2015-04-01 00:15:14.000000', 'temperatura', 9.0000, 'ºC'),
	(125583, 109, '2015-04-01 00:15:15.000000', 'temperatura', 143.0000, 'ºC'),
	(125584, 109, '2015-04-01 00:15:16.000000', 'temperatura', 687.0000, 'ºC'),
	(125585, 109, '2015-04-01 00:15:17.000000', 'temperatura', 607.0000, 'ºC'),
	(125586, 109, '2015-04-01 00:15:18.000000', 'temperatura', 973.0000, 'ºC'),
	(125587, 109, '2015-04-01 00:15:19.000000', 'temperatura', 647.0000, 'ºC'),
	(125588, 109, '2015-04-01 00:15:20.000000', 'temperatura', 316.0000, 'ºC'),
	(125589, 109, '2015-04-01 00:15:21.000000', 'temperatura', 840.0000, 'ºC'),
	(125590, 109, '2015-04-01 00:15:22.000000', 'temperatura', 853.0000, 'ºC'),
	(125591, 109, '2015-04-01 00:15:23.000000', 'temperatura', 543.0000, 'ºC'),
	(125592, 109, '2015-04-01 00:15:24.000000', 'temperatura', 158.0000, 'ºC'),
	(125593, 109, '2015-04-01 00:15:25.000000', 'temperatura', 363.0000, 'ºC'),
	(125594, 109, '2015-04-01 00:15:26.000000', 'temperatura', 141.0000, 'ºC'),
	(125595, 109, '2015-04-01 00:15:27.000000', 'temperatura', 817.0000, 'ºC'),
	(125596, 109, '2015-04-01 00:15:28.000000', 'temperatura', 62.0000, 'ºC'),
	(125597, 109, '2015-04-01 00:15:29.000000', 'temperatura', 258.0000, 'ºC'),
	(125598, 109, '2015-04-01 00:15:30.000000', 'temperatura', 1107.0000, 'ºC'),
	(125599, 109, '2015-04-01 00:15:31.000000', 'temperatura', 1161.0000, 'ºC'),
	(125600, 109, '2015-04-01 00:15:32.000000', 'temperatura', 83.0000, 'ºC'),
	(125601, 109, '2015-04-01 00:15:33.000000', 'temperatura', 533.0000, 'ºC'),
	(125602, 109, '2015-04-01 00:15:34.000000', 'temperatura', 18.0000, 'ºC'),
	(125603, 109, '2015-04-01 00:15:35.000000', 'temperatura', 890.0000, 'ºC'),
	(125604, 109, '2015-04-01 00:15:36.000000', 'temperatura', 796.0000, 'ºC'),
	(125605, 109, '2015-04-01 00:15:37.000000', 'temperatura', 112.0000, 'ºC'),
	(125606, 109, '2015-04-01 00:15:38.000000', 'temperatura', 571.0000, 'ºC'),
	(125607, 109, '2015-04-01 00:15:39.000000', 'temperatura', 120.0000, 'ºC'),
	(125608, 109, '2015-04-01 00:15:40.000000', 'temperatura', 87.0000, 'ºC'),
	(125609, 109, '2015-04-01 00:15:41.000000', 'temperatura', 76.0000, 'ºC'),
	(125610, 109, '2015-04-01 00:15:42.000000', 'temperatura', 119.0000, 'ºC'),
	(125611, 109, '2015-04-01 00:15:43.000000', 'temperatura', 367.0000, 'ºC'),
	(125612, 109, '2015-04-01 00:15:44.000000', 'temperatura', 280.0000, 'ºC'),
	(125613, 109, '2015-04-01 00:15:45.000000', 'temperatura', 298.0000, 'ºC'),
	(125614, 109, '2015-04-01 00:15:46.000000', 'temperatura', 652.0000, 'ºC'),
	(125615, 109, '2015-04-01 00:15:47.000000', 'temperatura', 1168.0000, 'ºC'),
	(125616, 109, '2015-04-01 00:15:48.000000', 'temperatura', 282.0000, 'ºC'),
	(125617, 109, '2015-04-01 00:15:49.000000', 'temperatura', 308.0000, 'ºC'),
	(125618, 109, '2015-04-01 00:15:50.000000', 'temperatura', 696.0000, 'ºC'),
	(125619, 109, '2015-04-01 00:15:51.000000', 'temperatura', 154.0000, 'ºC'),
	(125620, 109, '2015-04-01 00:15:52.000000', 'temperatura', 1082.0000, 'ºC'),
	(125621, 109, '2015-04-01 00:15:53.000000', 'temperatura', 151.0000, 'ºC'),
	(125622, 109, '2015-04-01 00:15:54.000000', 'temperatura', 1109.0000, 'ºC'),
	(125623, 109, '2015-04-01 00:15:55.000000', 'temperatura', 294.0000, 'ºC'),
	(125624, 109, '2015-04-01 00:15:56.000000', 'temperatura', 542.0000, 'ºC'),
	(125625, 109, '2015-04-01 00:15:57.000000', 'temperatura', 630.0000, 'ºC'),
	(125626, 109, '2015-04-01 00:15:58.000000', 'temperatura', 324.0000, 'ºC'),
	(125627, 109, '2015-04-01 00:15:59.000000', 'temperatura', 931.0000, 'ºC'),
	(125628, 109, '2015-04-01 00:16:00.000000', 'temperatura', 81.0000, 'ºC'),
	(125629, 109, '2015-04-01 00:16:01.000000', 'temperatura', 15.0000, 'ºC'),
	(125630, 109, '2015-04-01 00:16:02.000000', 'temperatura', 1034.0000, 'ºC'),
	(125631, 109, '2015-04-01 00:16:03.000000', 'temperatura', 323.0000, 'ºC'),
	(125632, 109, '2015-04-01 00:16:04.000000', 'temperatura', 913.0000, 'ºC'),
	(125633, 109, '2015-04-01 00:16:05.000000', 'temperatura', 1196.0000, 'ºC'),
	(125634, 109, '2015-04-01 00:16:06.000000', 'temperatura', 841.0000, 'ºC'),
	(125635, 109, '2015-04-01 00:16:07.000000', 'temperatura', 617.0000, 'ºC'),
	(125636, 109, '2015-04-01 00:16:08.000000', 'temperatura', 562.0000, 'ºC'),
	(125637, 109, '2015-04-01 00:16:09.000000', 'temperatura', 961.0000, 'ºC'),
	(125638, 109, '2015-04-01 00:16:10.000000', 'temperatura', 717.0000, 'ºC'),
	(125639, 109, '2015-04-01 00:16:11.000000', 'temperatura', 706.0000, 'ºC'),
	(125640, 109, '2015-04-01 00:16:12.000000', 'temperatura', 176.0000, 'ºC'),
	(125641, 109, '2015-04-01 00:16:13.000000', 'temperatura', 1165.0000, 'ºC'),
	(125642, 109, '2015-04-01 00:16:14.000000', 'temperatura', 497.0000, 'ºC'),
	(125643, 109, '2015-04-01 00:16:15.000000', 'temperatura', 191.0000, 'ºC'),
	(125644, 109, '2015-04-01 00:16:16.000000', 'temperatura', 665.0000, 'ºC'),
	(125645, 109, '2015-04-01 00:16:17.000000', 'temperatura', 353.0000, 'ºC'),
	(125646, 109, '2015-04-01 00:16:18.000000', 'temperatura', 971.0000, 'ºC'),
	(125647, 109, '2015-04-01 00:16:19.000000', 'temperatura', 195.0000, 'ºC'),
	(125648, 109, '2015-04-01 00:16:20.000000', 'temperatura', 461.0000, 'ºC'),
	(125649, 109, '2015-04-01 00:16:21.000000', 'temperatura', 521.0000, 'ºC'),
	(125650, 109, '2015-04-01 00:16:22.000000', 'temperatura', 24.0000, 'ºC'),
	(125651, 109, '2015-04-01 00:16:23.000000', 'temperatura', 955.0000, 'ºC'),
	(125652, 109, '2015-04-01 00:16:24.000000', 'temperatura', 1106.0000, 'ºC'),
	(125653, 109, '2015-04-01 00:16:25.000000', 'temperatura', 264.0000, 'ºC'),
	(125654, 109, '2015-04-01 00:16:26.000000', 'temperatura', 404.0000, 'ºC'),
	(125655, 109, '2015-04-01 00:16:27.000000', 'temperatura', 29.0000, 'ºC'),
	(125656, 109, '2015-04-01 00:16:28.000000', 'temperatura', 132.0000, 'ºC'),
	(125657, 109, '2015-04-01 00:16:29.000000', 'temperatura', 573.0000, 'ºC'),
	(125658, 109, '2015-04-01 00:16:30.000000', 'temperatura', 69.0000, 'ºC'),
	(125659, 109, '2015-04-01 00:16:31.000000', 'temperatura', 1026.0000, 'ºC'),
	(125660, 109, '2015-04-01 00:16:32.000000', 'temperatura', 126.0000, 'ºC'),
	(125661, 109, '2015-04-01 00:16:33.000000', 'temperatura', 1153.0000, 'ºC'),
	(125662, 109, '2015-04-01 00:16:34.000000', 'temperatura', 586.0000, 'ºC'),
	(125663, 109, '2015-04-01 00:16:35.000000', 'temperatura', 671.0000, 'ºC'),
	(125664, 109, '2015-04-01 00:16:36.000000', 'temperatura', 397.0000, 'ºC'),
	(125665, 109, '2015-04-01 00:16:37.000000', 'temperatura', 1174.0000, 'ºC'),
	(125666, 109, '2015-04-01 00:16:38.000000', 'temperatura', 1081.0000, 'ºC'),
	(125667, 109, '2015-04-01 00:16:39.000000', 'temperatura', 680.0000, 'ºC'),
	(125668, 109, '2015-04-01 00:16:40.000000', 'temperatura', 159.0000, 'ºC'),
	(125669, 109, '2015-04-01 00:16:41.000000', 'temperatura', 1156.0000, 'ºC'),
	(125670, 109, '2015-04-01 00:16:42.000000', 'temperatura', 505.0000, 'ºC'),
	(125671, 109, '2015-04-01 00:16:43.000000', 'temperatura', 257.0000, 'ºC'),
	(125672, 109, '2015-04-01 00:16:44.000000', 'temperatura', 968.0000, 'ºC'),
	(125673, 109, '2015-04-01 00:16:45.000000', 'temperatura', 471.0000, 'ºC'),
	(125674, 109, '2015-04-01 00:16:46.000000', 'temperatura', 653.0000, 'ºC'),
	(125675, 109, '2015-04-01 00:16:47.000000', 'temperatura', 652.0000, 'ºC'),
	(125676, 109, '2015-04-01 00:16:48.000000', 'temperatura', 100.0000, 'ºC'),
	(125677, 109, '2015-04-01 00:16:49.000000', 'temperatura', 947.0000, 'ºC'),
	(125678, 109, '2015-04-01 00:16:50.000000', 'temperatura', 832.0000, 'ºC'),
	(125679, 109, '2015-04-01 00:16:51.000000', 'temperatura', 123.0000, 'ºC'),
	(125680, 109, '2015-04-01 00:16:52.000000', 'temperatura', 516.0000, 'ºC'),
	(125681, 109, '2015-04-01 00:16:53.000000', 'temperatura', 1015.0000, 'ºC'),
	(125682, 109, '2015-04-01 00:16:54.000000', 'temperatura', 1124.0000, 'ºC'),
	(125683, 109, '2015-04-01 00:16:55.000000', 'temperatura', 178.0000, 'ºC'),
	(125684, 109, '2015-04-01 00:16:56.000000', 'temperatura', 1117.0000, 'ºC'),
	(125685, 109, '2015-04-01 00:16:57.000000', 'temperatura', 252.0000, 'ºC'),
	(125686, 109, '2015-04-01 00:16:58.000000', 'temperatura', 309.0000, 'ºC'),
	(125687, 109, '2015-04-01 00:16:59.000000', 'temperatura', 789.0000, 'ºC'),
	(125688, 109, '2015-04-01 00:17:00.000000', 'temperatura', 619.0000, 'ºC'),
	(125689, 109, '2015-04-01 00:17:01.000000', 'temperatura', 730.0000, 'ºC'),
	(125690, 109, '2015-04-01 00:17:02.000000', 'temperatura', 592.0000, 'ºC'),
	(125691, 109, '2015-04-01 00:17:03.000000', 'temperatura', 771.0000, 'ºC'),
	(125692, 109, '2015-04-01 00:17:04.000000', 'temperatura', 878.0000, 'ºC'),
	(125693, 109, '2015-04-01 00:17:05.000000', 'temperatura', 878.0000, 'ºC'),
	(125694, 109, '2015-04-01 00:17:06.000000', 'temperatura', 556.0000, 'ºC'),
	(125695, 109, '2015-04-01 00:17:07.000000', 'temperatura', 147.0000, 'ºC'),
	(125696, 109, '2015-04-01 00:17:08.000000', 'temperatura', 266.0000, 'ºC'),
	(125697, 109, '2015-04-01 00:17:09.000000', 'temperatura', 891.0000, 'ºC'),
	(125698, 109, '2015-04-01 00:17:10.000000', 'temperatura', 58.0000, 'ºC'),
	(125699, 109, '2015-04-01 00:17:11.000000', 'temperatura', 18.0000, 'ºC'),
	(125700, 109, '2015-04-01 00:17:12.000000', 'temperatura', 1115.0000, 'ºC'),
	(125701, 109, '2015-04-01 00:17:13.000000', 'temperatura', 721.0000, 'ºC'),
	(125702, 109, '2015-04-01 00:17:14.000000', 'temperatura', 259.0000, 'ºC'),
	(125703, 109, '2015-04-01 00:17:15.000000', 'temperatura', 335.0000, 'ºC'),
	(125704, 109, '2015-04-01 00:17:16.000000', 'temperatura', 899.0000, 'ºC'),
	(125705, 109, '2015-04-01 00:17:17.000000', 'temperatura', 1091.0000, 'ºC'),
	(125706, 109, '2015-04-01 00:17:18.000000', 'temperatura', 357.0000, 'ºC'),
	(125707, 109, '2015-04-01 00:17:19.000000', 'temperatura', 914.0000, 'ºC'),
	(125708, 109, '2015-04-01 00:17:20.000000', 'temperatura', 1098.0000, 'ºC'),
	(125709, 109, '2015-04-01 00:17:21.000000', 'temperatura', 348.0000, 'ºC'),
	(125710, 109, '2015-04-01 00:17:22.000000', 'temperatura', 848.0000, 'ºC'),
	(125711, 109, '2015-04-01 00:17:23.000000', 'temperatura', 798.0000, 'ºC'),
	(125712, 109, '2015-04-01 00:17:24.000000', 'temperatura', 245.0000, 'ºC'),
	(125713, 109, '2015-04-01 00:17:25.000000', 'temperatura', 33.0000, 'ºC'),
	(125714, 109, '2015-04-01 00:17:26.000000', 'temperatura', 632.0000, 'ºC'),
	(125715, 109, '2015-04-01 00:17:27.000000', 'temperatura', 658.0000, 'ºC'),
	(125716, 109, '2015-04-01 00:17:28.000000', 'temperatura', 195.0000, 'ºC'),
	(125717, 109, '2015-04-01 00:17:29.000000', 'temperatura', 202.0000, 'ºC'),
	(125718, 109, '2015-04-01 00:17:30.000000', 'temperatura', 427.0000, 'ºC'),
	(125719, 109, '2015-04-01 00:17:31.000000', 'temperatura', 328.0000, 'ºC'),
	(125720, 109, '2015-04-01 00:17:32.000000', 'temperatura', 360.0000, 'ºC'),
	(125721, 109, '2015-04-01 00:17:33.000000', 'temperatura', 816.0000, 'ºC'),
	(125722, 109, '2015-04-01 00:17:34.000000', 'temperatura', 603.0000, 'ºC'),
	(125723, 109, '2015-04-01 00:17:35.000000', 'temperatura', 564.0000, 'ºC'),
	(125724, 109, '2015-04-01 00:17:36.000000', 'temperatura', 1014.0000, 'ºC'),
	(125725, 109, '2015-04-01 00:17:37.000000', 'temperatura', 979.0000, 'ºC'),
	(125726, 109, '2015-04-01 00:17:38.000000', 'temperatura', 655.0000, 'ºC'),
	(125727, 109, '2015-04-01 00:17:39.000000', 'temperatura', 336.0000, 'ºC'),
	(125728, 109, '2015-04-01 00:17:40.000000', 'temperatura', 914.0000, 'ºC'),
	(125729, 109, '2015-04-01 00:17:41.000000', 'temperatura', 1165.0000, 'ºC'),
	(125730, 109, '2015-04-01 00:17:42.000000', 'temperatura', 682.0000, 'ºC'),
	(125731, 109, '2015-04-01 00:17:43.000000', 'temperatura', 1116.0000, 'ºC'),
	(125732, 109, '2015-04-01 00:17:44.000000', 'temperatura', 1136.0000, 'ºC'),
	(125733, 109, '2015-04-01 00:17:45.000000', 'temperatura', 1133.0000, 'ºC'),
	(125734, 109, '2015-04-01 00:17:46.000000', 'temperatura', 1056.0000, 'ºC'),
	(125735, 109, '2015-04-01 00:17:47.000000', 'temperatura', 680.0000, 'ºC'),
	(125736, 109, '2015-04-01 00:17:48.000000', 'temperatura', 235.0000, 'ºC'),
	(125737, 109, '2015-04-01 00:17:49.000000', 'temperatura', 334.0000, 'ºC'),
	(125738, 109, '2015-04-01 00:17:50.000000', 'temperatura', 967.0000, 'ºC'),
	(125739, 109, '2015-04-01 00:17:51.000000', 'temperatura', 233.0000, 'ºC'),
	(125740, 109, '2015-04-01 00:17:52.000000', 'temperatura', 663.0000, 'ºC'),
	(125741, 109, '2015-04-01 00:17:53.000000', 'temperatura', 218.0000, 'ºC'),
	(125742, 109, '2015-04-01 00:17:54.000000', 'temperatura', 301.0000, 'ºC'),
	(125743, 109, '2015-04-01 00:17:55.000000', 'temperatura', 853.0000, 'ºC'),
	(125744, 109, '2015-04-01 00:17:56.000000', 'temperatura', 962.0000, 'ºC'),
	(125745, 109, '2015-04-01 00:17:57.000000', 'temperatura', 1051.0000, 'ºC'),
	(125746, 109, '2015-04-01 00:17:58.000000', 'temperatura', 1168.0000, 'ºC'),
	(125747, 109, '2015-04-01 00:17:59.000000', 'temperatura', 290.0000, 'ºC'),
	(125748, 109, '2015-04-01 00:18:00.000000', 'temperatura', 344.0000, 'ºC'),
	(125749, 109, '2015-04-01 00:18:01.000000', 'temperatura', 851.0000, 'ºC'),
	(125750, 109, '2015-04-01 00:18:02.000000', 'temperatura', 824.0000, 'ºC'),
	(125751, 109, '2015-04-01 00:18:03.000000', 'temperatura', 368.0000, 'ºC'),
	(125752, 109, '2015-04-01 00:18:04.000000', 'temperatura', 569.0000, 'ºC'),
	(125753, 109, '2015-04-01 00:18:05.000000', 'temperatura', 539.0000, 'ºC'),
	(125754, 109, '2015-04-01 00:18:06.000000', 'temperatura', 992.0000, 'ºC'),
	(125755, 109, '2015-04-01 00:18:07.000000', 'temperatura', 942.0000, 'ºC'),
	(125756, 109, '2015-04-01 00:18:08.000000', 'temperatura', 532.0000, 'ºC'),
	(125757, 109, '2015-04-01 00:18:09.000000', 'temperatura', 1038.0000, 'ºC'),
	(125758, 109, '2015-04-01 00:18:10.000000', 'temperatura', 1194.0000, 'ºC'),
	(125759, 109, '2015-04-01 00:18:11.000000', 'temperatura', 457.0000, 'ºC'),
	(125760, 109, '2015-04-01 00:18:12.000000', 'temperatura', 1104.0000, 'ºC'),
	(125761, 109, '2015-04-01 00:18:13.000000', 'temperatura', 547.0000, 'ºC'),
	(125762, 109, '2015-04-01 00:18:14.000000', 'temperatura', 624.0000, 'ºC'),
	(125763, 109, '2015-04-01 00:18:15.000000', 'temperatura', 281.0000, 'ºC'),
	(125764, 109, '2015-04-01 00:18:16.000000', 'temperatura', 734.0000, 'ºC'),
	(125765, 109, '2015-04-01 00:18:17.000000', 'temperatura', 427.0000, 'ºC'),
	(125766, 109, '2015-04-01 00:18:18.000000', 'temperatura', 1134.0000, 'ºC'),
	(125767, 109, '2015-04-01 00:18:19.000000', 'temperatura', 789.0000, 'ºC'),
	(125768, 109, '2015-04-01 00:18:20.000000', 'temperatura', 543.0000, 'ºC'),
	(125769, 109, '2015-04-01 00:18:21.000000', 'temperatura', 348.0000, 'ºC'),
	(125770, 109, '2015-04-01 00:18:22.000000', 'temperatura', 113.0000, 'ºC'),
	(125771, 109, '2015-04-01 00:18:23.000000', 'temperatura', 720.0000, 'ºC'),
	(125772, 109, '2015-04-01 00:18:24.000000', 'temperatura', 863.0000, 'ºC'),
	(125773, 109, '2015-04-01 00:18:25.000000', 'temperatura', 956.0000, 'ºC'),
	(125774, 109, '2015-04-01 00:18:26.000000', 'temperatura', 991.0000, 'ºC'),
	(125775, 109, '2015-04-01 00:18:27.000000', 'temperatura', 889.0000, 'ºC'),
	(125776, 109, '2015-04-01 00:18:28.000000', 'temperatura', 273.0000, 'ºC'),
	(125777, 109, '2015-04-01 00:18:29.000000', 'temperatura', 1097.0000, 'ºC'),
	(125778, 109, '2015-04-01 00:18:30.000000', 'temperatura', 1068.0000, 'ºC'),
	(125779, 109, '2015-04-01 00:18:31.000000', 'temperatura', 850.0000, 'ºC'),
	(125780, 109, '2015-04-01 00:18:32.000000', 'temperatura', 1044.0000, 'ºC'),
	(125781, 109, '2015-04-01 00:18:33.000000', 'temperatura', 270.0000, 'ºC'),
	(125782, 109, '2015-04-01 00:18:34.000000', 'temperatura', 621.0000, 'ºC'),
	(125783, 109, '2015-04-01 00:18:35.000000', 'temperatura', 1095.0000, 'ºC'),
	(125784, 109, '2015-04-01 00:18:36.000000', 'temperatura', 12.0000, 'ºC'),
	(125785, 109, '2015-04-01 00:18:37.000000', 'temperatura', 374.0000, 'ºC'),
	(125786, 109, '2015-04-01 00:18:38.000000', 'temperatura', 637.0000, 'ºC'),
	(125787, 109, '2015-04-01 00:18:39.000000', 'temperatura', 861.0000, 'ºC'),
	(125788, 109, '2015-04-01 00:18:40.000000', 'temperatura', 1197.0000, 'ºC'),
	(125789, 109, '2015-04-01 00:18:41.000000', 'temperatura', 1003.0000, 'ºC'),
	(125790, 109, '2015-04-01 00:18:42.000000', 'temperatura', 225.0000, 'ºC'),
	(125791, 109, '2015-04-01 00:18:43.000000', 'temperatura', 514.0000, 'ºC'),
	(125792, 109, '2015-04-01 00:18:44.000000', 'temperatura', 694.0000, 'ºC'),
	(125793, 109, '2015-04-01 00:18:45.000000', 'temperatura', 732.0000, 'ºC'),
	(125794, 109, '2015-04-01 00:18:46.000000', 'temperatura', 378.0000, 'ºC'),
	(125795, 109, '2015-04-01 00:18:47.000000', 'temperatura', 892.0000, 'ºC'),
	(125796, 109, '2015-04-01 00:18:48.000000', 'temperatura', 929.0000, 'ºC'),
	(125797, 109, '2015-04-01 00:18:49.000000', 'temperatura', 768.0000, 'ºC'),
	(125798, 109, '2015-04-01 00:18:50.000000', 'temperatura', 1055.0000, 'ºC'),
	(125799, 109, '2015-04-01 00:18:51.000000', 'temperatura', 569.0000, 'ºC'),
	(125800, 109, '2015-04-01 00:18:52.000000', 'temperatura', 882.0000, 'ºC'),
	(125801, 109, '2015-04-01 00:18:53.000000', 'temperatura', 305.0000, 'ºC'),
	(125802, 109, '2015-04-01 00:18:54.000000', 'temperatura', 78.0000, 'ºC'),
	(125803, 109, '2015-04-01 00:18:55.000000', 'temperatura', 676.0000, 'ºC'),
	(125804, 109, '2015-04-01 00:18:56.000000', 'temperatura', 747.0000, 'ºC'),
	(125805, 109, '2015-04-01 00:18:57.000000', 'temperatura', 507.0000, 'ºC'),
	(125806, 109, '2015-04-01 00:18:58.000000', 'temperatura', 296.0000, 'ºC'),
	(125807, 109, '2015-04-01 00:18:59.000000', 'temperatura', 1158.0000, 'ºC'),
	(125808, 109, '2015-04-01 00:19:00.000000', 'temperatura', 101.0000, 'ºC'),
	(125809, 109, '2015-04-01 00:19:01.000000', 'temperatura', 632.0000, 'ºC'),
	(125810, 109, '2015-04-01 00:19:02.000000', 'temperatura', 459.0000, 'ºC'),
	(125811, 109, '2015-04-01 00:19:03.000000', 'temperatura', 399.0000, 'ºC'),
	(125812, 109, '2015-04-01 00:19:04.000000', 'temperatura', 618.0000, 'ºC'),
	(125813, 109, '2015-04-01 00:19:05.000000', 'temperatura', 693.0000, 'ºC'),
	(125814, 109, '2015-04-01 00:19:06.000000', 'temperatura', 413.0000, 'ºC'),
	(125815, 109, '2015-04-01 00:19:07.000000', 'temperatura', 1187.0000, 'ºC'),
	(125816, 109, '2015-04-01 00:19:08.000000', 'temperatura', 1096.0000, 'ºC'),
	(125817, 109, '2015-04-01 00:19:09.000000', 'temperatura', 720.0000, 'ºC'),
	(125818, 109, '2015-04-01 00:19:10.000000', 'temperatura', 313.0000, 'ºC'),
	(125819, 109, '2015-04-01 00:19:11.000000', 'temperatura', 605.0000, 'ºC'),
	(125820, 109, '2015-04-01 00:19:12.000000', 'temperatura', 888.0000, 'ºC'),
	(125821, 109, '2015-04-01 00:19:13.000000', 'temperatura', 223.0000, 'ºC'),
	(125822, 109, '2015-04-01 00:19:14.000000', 'temperatura', 853.0000, 'ºC'),
	(125823, 109, '2015-04-01 00:19:15.000000', 'temperatura', 1197.0000, 'ºC'),
	(125824, 109, '2015-04-01 00:19:16.000000', 'temperatura', 1027.0000, 'ºC'),
	(125825, 109, '2015-04-01 00:19:17.000000', 'temperatura', 345.0000, 'ºC'),
	(125826, 109, '2015-04-01 00:19:18.000000', 'temperatura', 1042.0000, 'ºC'),
	(125827, 109, '2015-04-01 00:19:19.000000', 'temperatura', 578.0000, 'ºC'),
	(125828, 109, '2015-04-01 00:19:20.000000', 'temperatura', 964.0000, 'ºC'),
	(125829, 109, '2015-04-01 00:19:21.000000', 'temperatura', 687.0000, 'ºC'),
	(125830, 109, '2015-04-01 00:19:22.000000', 'temperatura', 541.0000, 'ºC'),
	(125831, 109, '2015-04-01 00:19:23.000000', 'temperatura', 645.0000, 'ºC'),
	(125832, 109, '2015-04-01 00:19:24.000000', 'temperatura', 403.0000, 'ºC'),
	(125833, 109, '2015-04-01 00:19:25.000000', 'temperatura', 80.0000, 'ºC'),
	(125834, 109, '2015-04-01 00:19:26.000000', 'temperatura', 391.0000, 'ºC'),
	(125835, 109, '2015-04-01 00:19:27.000000', 'temperatura', 517.0000, 'ºC'),
	(125836, 109, '2015-04-01 00:19:28.000000', 'temperatura', 214.0000, 'ºC'),
	(125837, 109, '2015-04-01 00:19:29.000000', 'temperatura', 716.0000, 'ºC'),
	(125838, 109, '2015-04-01 00:19:30.000000', 'temperatura', 541.0000, 'ºC'),
	(125839, 109, '2015-04-01 00:19:31.000000', 'temperatura', 555.0000, 'ºC'),
	(125840, 109, '2015-04-01 00:19:32.000000', 'temperatura', 1154.0000, 'ºC'),
	(125841, 109, '2015-04-01 00:19:33.000000', 'temperatura', 505.0000, 'ºC'),
	(125842, 109, '2015-04-01 00:19:34.000000', 'temperatura', 265.0000, 'ºC'),
	(125843, 109, '2015-04-01 00:19:35.000000', 'temperatura', 1010.0000, 'ºC'),
	(125844, 109, '2015-04-01 00:19:36.000000', 'temperatura', 655.0000, 'ºC'),
	(125845, 109, '2015-04-01 00:19:37.000000', 'temperatura', 244.0000, 'ºC'),
	(125846, 109, '2015-04-01 00:19:38.000000', 'temperatura', 458.0000, 'ºC'),
	(125847, 109, '2015-04-01 00:19:39.000000', 'temperatura', 358.0000, 'ºC'),
	(125848, 109, '2015-04-01 00:19:40.000000', 'temperatura', 414.0000, 'ºC'),
	(125849, 109, '2015-04-01 00:19:41.000000', 'temperatura', 998.0000, 'ºC'),
	(125850, 109, '2015-04-01 00:19:42.000000', 'temperatura', 150.0000, 'ºC'),
	(125851, 109, '2015-04-01 00:19:43.000000', 'temperatura', 154.0000, 'ºC'),
	(125852, 109, '2015-04-01 00:19:44.000000', 'temperatura', 319.0000, 'ºC'),
	(125853, 109, '2015-04-01 00:19:45.000000', 'temperatura', 1137.0000, 'ºC'),
	(125854, 109, '2015-04-01 00:19:46.000000', 'temperatura', 1127.0000, 'ºC'),
	(125855, 109, '2015-04-01 00:19:47.000000', 'temperatura', 1026.0000, 'ºC'),
	(125856, 109, '2015-04-01 00:19:48.000000', 'temperatura', 547.0000, 'ºC'),
	(125857, 109, '2015-04-01 00:19:49.000000', 'temperatura', 857.0000, 'ºC'),
	(125858, 109, '2015-04-01 00:19:50.000000', 'temperatura', 246.0000, 'ºC'),
	(125859, 109, '2015-04-01 00:19:51.000000', 'temperatura', 1058.0000, 'ºC'),
	(125860, 109, '2015-04-01 00:19:52.000000', 'temperatura', 953.0000, 'ºC'),
	(125861, 109, '2015-04-01 00:19:53.000000', 'temperatura', 391.0000, 'ºC'),
	(125862, 109, '2015-04-01 00:19:54.000000', 'temperatura', 297.0000, 'ºC'),
	(125863, 109, '2015-04-01 00:19:55.000000', 'temperatura', 314.0000, 'ºC'),
	(125864, 109, '2015-04-01 00:19:56.000000', 'temperatura', 679.0000, 'ºC'),
	(125865, 109, '2015-04-01 00:19:57.000000', 'temperatura', 53.0000, 'ºC'),
	(125866, 109, '2015-04-01 00:19:58.000000', 'temperatura', 629.0000, 'ºC'),
	(125867, 109, '2015-04-01 00:19:59.000000', 'temperatura', 586.0000, 'ºC'),
	(125868, 109, '2015-04-01 00:20:00.000000', 'temperatura', 1043.0000, 'ºC'),
	(125869, 109, '2015-04-01 00:20:01.000000', 'temperatura', 1057.0000, 'ºC'),
	(125870, 109, '2015-04-01 00:20:02.000000', 'temperatura', 958.0000, 'ºC'),
	(125871, 109, '2015-04-01 00:20:03.000000', 'temperatura', 420.0000, 'ºC'),
	(125872, 109, '2015-04-01 00:20:04.000000', 'temperatura', 427.0000, 'ºC'),
	(125873, 109, '2015-04-01 00:20:05.000000', 'temperatura', 873.0000, 'ºC'),
	(125874, 109, '2015-04-01 00:20:06.000000', 'temperatura', 685.0000, 'ºC'),
	(125875, 109, '2015-04-01 00:20:07.000000', 'temperatura', 808.0000, 'ºC'),
	(125876, 109, '2015-04-01 00:20:08.000000', 'temperatura', 785.0000, 'ºC'),
	(125877, 109, '2015-04-01 00:20:09.000000', 'temperatura', 300.0000, 'ºC'),
	(125878, 109, '2015-04-01 00:20:10.000000', 'temperatura', 347.0000, 'ºC'),
	(125879, 109, '2015-04-01 00:20:11.000000', 'temperatura', 836.0000, 'ºC'),
	(125880, 109, '2015-04-01 00:20:12.000000', 'temperatura', 739.0000, 'ºC'),
	(125881, 109, '2015-04-01 00:20:13.000000', 'temperatura', 1187.0000, 'ºC'),
	(125882, 109, '2015-04-01 00:20:14.000000', 'temperatura', 120.0000, 'ºC'),
	(125883, 109, '2015-04-01 00:20:15.000000', 'temperatura', 639.0000, 'ºC'),
	(125884, 109, '2015-04-01 00:20:16.000000', 'temperatura', 437.0000, 'ºC'),
	(125885, 109, '2015-04-01 00:20:17.000000', 'temperatura', 268.0000, 'ºC'),
	(125886, 109, '2015-04-01 00:20:18.000000', 'temperatura', 31.0000, 'ºC'),
	(125887, 109, '2015-04-01 00:20:19.000000', 'temperatura', 550.0000, 'ºC'),
	(125888, 109, '2015-04-01 00:20:20.000000', 'temperatura', 258.0000, 'ºC'),
	(125889, 109, '2015-04-01 00:20:21.000000', 'temperatura', 841.0000, 'ºC'),
	(125890, 109, '2015-04-01 00:20:22.000000', 'temperatura', 1031.0000, 'ºC'),
	(125891, 109, '2015-04-01 00:20:23.000000', 'temperatura', 232.0000, 'ºC'),
	(125892, 109, '2015-04-01 00:20:24.000000', 'temperatura', 466.0000, 'ºC'),
	(125893, 109, '2015-04-01 00:20:25.000000', 'temperatura', 436.0000, 'ºC'),
	(125894, 109, '2015-04-01 00:20:26.000000', 'temperatura', 782.0000, 'ºC'),
	(125895, 109, '2015-04-01 00:20:27.000000', 'temperatura', 203.0000, 'ºC'),
	(125896, 109, '2015-04-01 00:20:28.000000', 'temperatura', 1071.0000, 'ºC'),
	(125897, 109, '2015-04-01 00:20:29.000000', 'temperatura', 1145.0000, 'ºC'),
	(125898, 109, '2015-04-01 00:20:30.000000', 'temperatura', 111.0000, 'ºC'),
	(125899, 109, '2015-04-01 00:20:31.000000', 'temperatura', 722.0000, 'ºC'),
	(125900, 109, '2015-04-01 00:20:32.000000', 'temperatura', 876.0000, 'ºC'),
	(125901, 109, '2015-04-01 00:20:33.000000', 'temperatura', 1014.0000, 'ºC'),
	(125902, 109, '2015-04-01 00:20:34.000000', 'temperatura', 45.0000, 'ºC'),
	(125903, 109, '2015-04-01 00:20:35.000000', 'temperatura', 783.0000, 'ºC'),
	(125904, 109, '2015-04-01 00:20:36.000000', 'temperatura', 179.0000, 'ºC'),
	(125905, 109, '2015-04-01 00:20:37.000000', 'temperatura', 947.0000, 'ºC'),
	(125906, 109, '2015-04-01 00:20:38.000000', 'temperatura', 599.0000, 'ºC'),
	(125907, 109, '2015-04-01 00:20:39.000000', 'temperatura', 156.0000, 'ºC'),
	(125908, 109, '2015-04-01 00:20:40.000000', 'temperatura', 180.0000, 'ºC'),
	(125909, 109, '2015-04-01 00:20:41.000000', 'temperatura', 436.0000, 'ºC'),
	(125910, 109, '2015-04-01 00:20:42.000000', 'temperatura', 438.0000, 'ºC'),
	(125911, 109, '2015-04-01 00:20:43.000000', 'temperatura', 881.0000, 'ºC'),
	(125912, 109, '2015-04-01 00:20:44.000000', 'temperatura', 695.0000, 'ºC'),
	(125913, 109, '2015-04-01 00:20:45.000000', 'temperatura', 830.0000, 'ºC'),
	(125914, 109, '2015-04-01 00:20:46.000000', 'temperatura', 866.0000, 'ºC'),
	(125915, 109, '2015-04-01 00:20:47.000000', 'temperatura', 642.0000, 'ºC'),
	(125916, 109, '2015-04-01 00:20:48.000000', 'temperatura', 611.0000, 'ºC'),
	(125917, 109, '2015-04-01 00:20:49.000000', 'temperatura', 1128.0000, 'ºC'),
	(125918, 109, '2015-04-01 00:20:50.000000', 'temperatura', 208.0000, 'ºC'),
	(125919, 109, '2015-04-01 00:20:51.000000', 'temperatura', 57.0000, 'ºC'),
	(125920, 109, '2015-04-01 00:20:52.000000', 'temperatura', 860.0000, 'ºC'),
	(125921, 109, '2015-04-01 00:20:53.000000', 'temperatura', 532.0000, 'ºC'),
	(125922, 109, '2015-04-01 00:20:54.000000', 'temperatura', 78.0000, 'ºC'),
	(125923, 109, '2015-04-01 00:20:55.000000', 'temperatura', 1196.0000, 'ºC'),
	(125924, 109, '2015-04-01 00:20:56.000000', 'temperatura', 944.0000, 'ºC'),
	(125925, 109, '2015-04-01 00:20:57.000000', 'temperatura', 1135.0000, 'ºC'),
	(125926, 109, '2015-04-01 00:20:58.000000', 'temperatura', 444.0000, 'ºC'),
	(125927, 109, '2015-04-01 00:20:59.000000', 'temperatura', 14.0000, 'ºC'),
	(125928, 109, '2015-04-01 00:21:00.000000', 'temperatura', 1140.0000, 'ºC'),
	(125929, 109, '2015-04-01 00:21:01.000000', 'temperatura', 858.0000, 'ºC'),
	(125930, 109, '2015-04-01 00:21:02.000000', 'temperatura', 870.0000, 'ºC'),
	(125931, 109, '2015-04-01 00:21:03.000000', 'temperatura', 577.0000, 'ºC'),
	(125932, 109, '2015-04-01 00:21:04.000000', 'temperatura', 275.0000, 'ºC'),
	(125933, 109, '2015-04-01 00:21:05.000000', 'temperatura', 846.0000, 'ºC'),
	(125934, 109, '2015-04-01 00:21:06.000000', 'temperatura', 1003.0000, 'ºC'),
	(125935, 109, '2015-04-01 00:21:07.000000', 'temperatura', 80.0000, 'ºC'),
	(125936, 109, '2015-04-01 00:21:08.000000', 'temperatura', 992.0000, 'ºC'),
	(125937, 109, '2015-04-01 00:21:09.000000', 'temperatura', 1118.0000, 'ºC'),
	(125938, 109, '2015-04-01 00:21:10.000000', 'temperatura', 216.0000, 'ºC'),
	(125939, 109, '2015-04-01 00:21:11.000000', 'temperatura', 125.0000, 'ºC'),
	(125940, 109, '2015-04-01 00:21:12.000000', 'temperatura', 1177.0000, 'ºC'),
	(125941, 109, '2015-04-01 00:21:13.000000', 'temperatura', 712.0000, 'ºC'),
	(125942, 109, '2015-04-01 00:21:14.000000', 'temperatura', 27.0000, 'ºC'),
	(125943, 109, '2015-04-01 00:21:15.000000', 'temperatura', 402.0000, 'ºC'),
	(125944, 109, '2015-04-01 00:21:16.000000', 'temperatura', 729.0000, 'ºC'),
	(125945, 109, '2015-04-01 00:21:17.000000', 'temperatura', 38.0000, 'ºC'),
	(125946, 109, '2015-04-01 00:21:18.000000', 'temperatura', 404.0000, 'ºC'),
	(125947, 109, '2015-04-01 00:21:19.000000', 'temperatura', 706.0000, 'ºC'),
	(125948, 109, '2015-04-01 00:21:20.000000', 'temperatura', 1118.0000, 'ºC'),
	(125949, 109, '2015-04-01 00:21:21.000000', 'temperatura', 1072.0000, 'ºC'),
	(125950, 109, '2015-04-01 00:21:22.000000', 'temperatura', 809.0000, 'ºC'),
	(125951, 109, '2015-04-01 00:21:23.000000', 'temperatura', 830.0000, 'ºC'),
	(125952, 109, '2015-04-01 00:21:24.000000', 'temperatura', 522.0000, 'ºC'),
	(125953, 109, '2015-04-01 00:21:25.000000', 'temperatura', 122.0000, 'ºC'),
	(125954, 109, '2015-04-01 00:21:26.000000', 'temperatura', 245.0000, 'ºC'),
	(125955, 109, '2015-04-01 00:21:27.000000', 'temperatura', 860.0000, 'ºC'),
	(125956, 109, '2015-04-01 00:21:28.000000', 'temperatura', 1165.0000, 'ºC'),
	(125957, 109, '2015-04-01 00:21:29.000000', 'temperatura', 845.0000, 'ºC'),
	(125958, 109, '2015-04-01 00:21:30.000000', 'temperatura', 729.0000, 'ºC'),
	(125959, 109, '2015-04-01 00:21:31.000000', 'temperatura', 1111.0000, 'ºC'),
	(125960, 109, '2015-04-01 00:21:32.000000', 'temperatura', 970.0000, 'ºC'),
	(125961, 109, '2015-04-01 00:21:33.000000', 'temperatura', 315.0000, 'ºC'),
	(125962, 109, '2015-04-01 00:21:34.000000', 'temperatura', 1066.0000, 'ºC'),
	(125963, 109, '2015-04-01 00:21:35.000000', 'temperatura', 788.0000, 'ºC'),
	(125964, 109, '2015-04-01 00:21:36.000000', 'temperatura', 742.0000, 'ºC'),
	(125965, 109, '2015-04-01 00:21:37.000000', 'temperatura', 144.0000, 'ºC'),
	(125966, 109, '2015-04-01 00:21:38.000000', 'temperatura', 895.0000, 'ºC'),
	(125967, 109, '2015-04-01 00:21:39.000000', 'temperatura', 446.0000, 'ºC'),
	(125968, 109, '2015-04-01 00:21:40.000000', 'temperatura', 742.0000, 'ºC'),
	(125969, 109, '2015-04-01 00:21:41.000000', 'temperatura', 1176.0000, 'ºC'),
	(125970, 109, '2015-04-01 00:21:42.000000', 'temperatura', 52.0000, 'ºC'),
	(125971, 109, '2015-04-01 00:21:43.000000', 'temperatura', 332.0000, 'ºC'),
	(125972, 109, '2015-04-01 00:21:44.000000', 'temperatura', 306.0000, 'ºC'),
	(125973, 109, '2015-04-01 00:21:45.000000', 'temperatura', 535.0000, 'ºC'),
	(125974, 109, '2015-04-01 00:21:46.000000', 'temperatura', 556.0000, 'ºC'),
	(125975, 109, '2015-04-01 00:21:47.000000', 'temperatura', 1175.0000, 'ºC'),
	(125976, 109, '2015-04-01 00:21:48.000000', 'temperatura', 609.0000, 'ºC'),
	(125977, 109, '2015-04-01 00:21:49.000000', 'temperatura', 721.0000, 'ºC'),
	(125978, 109, '2015-04-01 00:21:50.000000', 'temperatura', 577.0000, 'ºC'),
	(125979, 109, '2015-04-01 00:21:51.000000', 'temperatura', 724.0000, 'ºC'),
	(125980, 109, '2015-04-01 00:21:52.000000', 'temperatura', 691.0000, 'ºC'),
	(125981, 109, '2015-04-01 00:21:53.000000', 'temperatura', 80.0000, 'ºC'),
	(125982, 109, '2015-04-01 00:21:54.000000', 'temperatura', 728.0000, 'ºC'),
	(125983, 109, '2015-04-01 00:21:55.000000', 'temperatura', 1002.0000, 'ºC'),
	(125984, 109, '2015-04-01 00:21:56.000000', 'temperatura', 427.0000, 'ºC'),
	(125985, 109, '2015-04-01 00:21:57.000000', 'temperatura', 329.0000, 'ºC'),
	(125986, 109, '2015-04-01 00:21:58.000000', 'temperatura', 365.0000, 'ºC'),
	(125987, 109, '2015-04-01 00:21:59.000000', 'temperatura', 840.0000, 'ºC'),
	(125988, 109, '2015-04-01 00:22:00.000000', 'temperatura', 705.0000, 'ºC'),
	(125989, 109, '2015-04-01 00:22:01.000000', 'temperatura', 1004.0000, 'ºC'),
	(125990, 109, '2015-04-01 00:22:02.000000', 'temperatura', 506.0000, 'ºC'),
	(125991, 109, '2015-04-01 00:22:03.000000', 'temperatura', 718.0000, 'ºC'),
	(125992, 109, '2015-04-01 00:22:04.000000', 'temperatura', 874.0000, 'ºC'),
	(125993, 109, '2015-04-01 00:22:05.000000', 'temperatura', 1016.0000, 'ºC'),
	(125994, 109, '2015-04-01 00:22:06.000000', 'temperatura', 58.0000, 'ºC'),
	(125995, 109, '2015-04-01 00:22:07.000000', 'temperatura', 841.0000, 'ºC'),
	(125996, 109, '2015-04-01 00:22:08.000000', 'temperatura', 431.0000, 'ºC'),
	(125997, 109, '2015-04-01 00:22:09.000000', 'temperatura', 835.0000, 'ºC'),
	(125998, 109, '2015-04-01 00:22:10.000000', 'temperatura', 482.0000, 'ºC'),
	(125999, 109, '2015-04-01 00:22:11.000000', 'temperatura', 1105.0000, 'ºC'),
	(126000, 109, '2015-04-01 00:22:12.000000', 'temperatura', 478.0000, 'ºC'),
	(126001, 109, '2015-04-01 00:22:13.000000', 'temperatura', 279.0000, 'ºC'),
	(126002, 109, '2015-04-01 00:22:14.000000', 'temperatura', 1159.0000, 'ºC'),
	(126003, 109, '2015-04-01 00:22:15.000000', 'temperatura', 159.0000, 'ºC'),
	(126004, 109, '2015-04-01 00:22:16.000000', 'temperatura', 917.0000, 'ºC'),
	(126005, 109, '2015-04-01 00:22:17.000000', 'temperatura', 511.0000, 'ºC'),
	(126006, 109, '2015-04-01 00:22:18.000000', 'temperatura', 1002.0000, 'ºC'),
	(126007, 109, '2015-04-01 00:22:19.000000', 'temperatura', 1078.0000, 'ºC'),
	(126008, 109, '2015-04-01 00:22:20.000000', 'temperatura', 1187.0000, 'ºC'),
	(126009, 109, '2015-04-01 00:22:21.000000', 'temperatura', 299.0000, 'ºC'),
	(126010, 109, '2015-04-01 00:22:22.000000', 'temperatura', 334.0000, 'ºC'),
	(126011, 109, '2015-04-01 00:22:23.000000', 'temperatura', 772.0000, 'ºC'),
	(126012, 109, '2015-04-01 00:22:24.000000', 'temperatura', 461.0000, 'ºC'),
	(126013, 109, '2015-04-01 00:22:25.000000', 'temperatura', 1190.0000, 'ºC'),
	(126014, 109, '2015-04-01 00:22:26.000000', 'temperatura', 968.0000, 'ºC'),
	(126015, 109, '2015-04-01 00:22:27.000000', 'temperatura', 68.0000, 'ºC'),
	(126016, 109, '2015-04-01 00:22:28.000000', 'temperatura', 1037.0000, 'ºC'),
	(126017, 109, '2015-04-01 00:22:29.000000', 'temperatura', 184.0000, 'ºC'),
	(126018, 109, '2015-04-01 00:22:30.000000', 'temperatura', 206.0000, 'ºC'),
	(126019, 109, '2015-04-01 00:22:31.000000', 'temperatura', 480.0000, 'ºC'),
	(126020, 109, '2015-04-01 00:22:32.000000', 'temperatura', 581.0000, 'ºC'),
	(126021, 109, '2015-04-01 00:22:33.000000', 'temperatura', 267.0000, 'ºC'),
	(126022, 109, '2015-04-01 00:22:34.000000', 'temperatura', 793.0000, 'ºC'),
	(126023, 109, '2015-04-01 00:22:35.000000', 'temperatura', 765.0000, 'ºC'),
	(126024, 109, '2015-04-01 00:22:36.000000', 'temperatura', 246.0000, 'ºC'),
	(126025, 109, '2015-04-01 00:22:37.000000', 'temperatura', 137.0000, 'ºC'),
	(126026, 109, '2015-04-01 00:22:38.000000', 'temperatura', 1146.0000, 'ºC'),
	(126027, 109, '2015-04-01 00:22:39.000000', 'temperatura', 520.0000, 'ºC'),
	(126028, 109, '2015-04-01 00:22:40.000000', 'temperatura', 363.0000, 'ºC'),
	(126029, 109, '2015-04-01 00:22:41.000000', 'temperatura', 254.0000, 'ºC'),
	(126030, 109, '2015-04-01 00:22:42.000000', 'temperatura', 183.0000, 'ºC'),
	(126031, 109, '2015-04-01 00:22:43.000000', 'temperatura', 154.0000, 'ºC'),
	(126032, 109, '2015-04-01 00:22:44.000000', 'temperatura', 221.0000, 'ºC'),
	(126033, 109, '2015-04-01 00:22:45.000000', 'temperatura', 644.0000, 'ºC'),
	(126034, 109, '2015-04-01 00:22:46.000000', 'temperatura', 157.0000, 'ºC'),
	(126035, 109, '2015-04-01 00:22:47.000000', 'temperatura', 54.0000, 'ºC'),
	(126036, 109, '2015-04-01 00:22:48.000000', 'temperatura', 1000.0000, 'ºC'),
	(126037, 109, '2015-04-01 00:22:49.000000', 'temperatura', 39.0000, 'ºC'),
	(126038, 109, '2015-04-01 00:22:50.000000', 'temperatura', 796.0000, 'ºC'),
	(126039, 109, '2015-04-01 00:22:51.000000', 'temperatura', 261.0000, 'ºC'),
	(126040, 109, '2015-04-01 00:22:52.000000', 'temperatura', 120.0000, 'ºC'),
	(126041, 109, '2015-04-01 00:22:53.000000', 'temperatura', 1018.0000, 'ºC'),
	(126042, 109, '2015-04-01 00:22:54.000000', 'temperatura', 1130.0000, 'ºC'),
	(126043, 109, '2015-04-01 00:22:55.000000', 'temperatura', 197.0000, 'ºC'),
	(126044, 109, '2015-04-01 00:22:56.000000', 'temperatura', 1195.0000, 'ºC'),
	(126045, 109, '2015-04-01 00:22:57.000000', 'temperatura', 585.0000, 'ºC'),
	(126046, 109, '2015-04-01 00:22:58.000000', 'temperatura', 539.0000, 'ºC'),
	(126047, 109, '2015-04-01 00:22:59.000000', 'temperatura', 940.0000, 'ºC'),
	(126048, 109, '2015-04-01 00:23:00.000000', 'temperatura', 683.0000, 'ºC'),
	(126049, 109, '2015-04-01 00:23:01.000000', 'temperatura', 595.0000, 'ºC'),
	(126050, 109, '2015-04-01 00:23:02.000000', 'temperatura', 926.0000, 'ºC'),
	(126051, 109, '2015-04-01 00:23:03.000000', 'temperatura', 445.0000, 'ºC'),
	(126052, 109, '2015-04-01 00:23:04.000000', 'temperatura', 649.0000, 'ºC'),
	(126053, 109, '2015-04-01 00:23:05.000000', 'temperatura', 710.0000, 'ºC'),
	(126054, 109, '2015-04-01 00:23:06.000000', 'temperatura', 403.0000, 'ºC'),
	(126055, 109, '2015-04-01 00:23:07.000000', 'temperatura', 1088.0000, 'ºC'),
	(126056, 109, '2015-04-01 00:23:08.000000', 'temperatura', 629.0000, 'ºC'),
	(126057, 109, '2015-04-01 00:23:09.000000', 'temperatura', 1081.0000, 'ºC'),
	(126058, 109, '2015-04-01 00:23:10.000000', 'temperatura', 1121.0000, 'ºC'),
	(126059, 109, '2015-04-01 00:23:11.000000', 'temperatura', 1162.0000, 'ºC'),
	(126060, 109, '2015-04-01 00:23:12.000000', 'temperatura', 46.0000, 'ºC'),
	(126061, 109, '2015-04-01 00:23:13.000000', 'temperatura', 347.0000, 'ºC'),
	(126062, 109, '2015-04-01 00:23:14.000000', 'temperatura', 396.0000, 'ºC'),
	(126063, 109, '2015-04-01 00:23:15.000000', 'temperatura', 939.0000, 'ºC'),
	(126064, 109, '2015-04-01 00:23:16.000000', 'temperatura', 1108.0000, 'ºC'),
	(126065, 109, '2015-04-01 00:23:17.000000', 'temperatura', 322.0000, 'ºC'),
	(126066, 109, '2015-04-01 00:23:18.000000', 'temperatura', 687.0000, 'ºC'),
	(126067, 109, '2015-04-01 00:23:19.000000', 'temperatura', 69.0000, 'ºC'),
	(126068, 109, '2015-04-01 00:23:20.000000', 'temperatura', 687.0000, 'ºC'),
	(126069, 109, '2015-04-01 00:23:21.000000', 'temperatura', 825.0000, 'ºC'),
	(126070, 109, '2015-04-01 00:23:22.000000', 'temperatura', 867.0000, 'ºC'),
	(126071, 109, '2015-04-01 00:23:23.000000', 'temperatura', 659.0000, 'ºC'),
	(126072, 109, '2015-04-01 00:23:24.000000', 'temperatura', 697.0000, 'ºC'),
	(126073, 109, '2015-04-01 00:23:25.000000', 'temperatura', 307.0000, 'ºC'),
	(126074, 109, '2015-04-01 00:23:26.000000', 'temperatura', 644.0000, 'ºC'),
	(126075, 109, '2015-04-01 00:23:27.000000', 'temperatura', 1098.0000, 'ºC'),
	(126076, 109, '2015-04-01 00:23:28.000000', 'temperatura', 1161.0000, 'ºC'),
	(126077, 109, '2015-04-01 00:23:29.000000', 'temperatura', 110.0000, 'ºC'),
	(126078, 109, '2015-04-01 00:23:30.000000', 'temperatura', 670.0000, 'ºC'),
	(126079, 109, '2015-04-01 00:23:31.000000', 'temperatura', 617.0000, 'ºC'),
	(126080, 109, '2015-04-01 00:23:32.000000', 'temperatura', 1077.0000, 'ºC'),
	(126081, 109, '2015-04-01 00:23:33.000000', 'temperatura', 1136.0000, 'ºC'),
	(126082, 109, '2015-04-01 00:23:34.000000', 'temperatura', 50.0000, 'ºC'),
	(126083, 109, '2015-04-01 00:23:35.000000', 'temperatura', 439.0000, 'ºC'),
	(126084, 109, '2015-04-01 00:23:36.000000', 'temperatura', 849.0000, 'ºC'),
	(126085, 109, '2015-04-01 00:23:37.000000', 'temperatura', 527.0000, 'ºC'),
	(126086, 109, '2015-04-01 00:23:38.000000', 'temperatura', 90.0000, 'ºC'),
	(126087, 109, '2015-04-01 00:23:39.000000', 'temperatura', 67.0000, 'ºC'),
	(126088, 109, '2015-04-01 00:23:40.000000', 'temperatura', 68.0000, 'ºC'),
	(126089, 109, '2015-04-01 00:23:41.000000', 'temperatura', 138.0000, 'ºC'),
	(126090, 109, '2015-04-01 00:23:42.000000', 'temperatura', 485.0000, 'ºC'),
	(126091, 109, '2015-04-01 00:23:43.000000', 'temperatura', 814.0000, 'ºC'),
	(126092, 109, '2015-04-01 00:23:44.000000', 'temperatura', 214.0000, 'ºC'),
	(126093, 109, '2015-04-01 00:23:45.000000', 'temperatura', 1030.0000, 'ºC'),
	(126094, 109, '2015-04-01 00:23:46.000000', 'temperatura', 906.0000, 'ºC'),
	(126095, 109, '2015-04-01 00:23:47.000000', 'temperatura', 243.0000, 'ºC'),
	(126096, 109, '2015-04-01 00:23:48.000000', 'temperatura', 899.0000, 'ºC'),
	(126097, 109, '2015-04-01 00:23:49.000000', 'temperatura', 163.0000, 'ºC'),
	(126098, 109, '2015-04-01 00:23:50.000000', 'temperatura', 519.0000, 'ºC'),
	(126099, 109, '2015-04-01 00:23:51.000000', 'temperatura', 905.0000, 'ºC'),
	(126100, 109, '2015-04-01 00:23:52.000000', 'temperatura', 570.0000, 'ºC'),
	(126101, 109, '2015-04-01 00:23:53.000000', 'temperatura', 134.0000, 'ºC'),
	(126102, 109, '2015-04-01 00:23:54.000000', 'temperatura', 162.0000, 'ºC'),
	(126103, 109, '2015-04-01 00:23:55.000000', 'temperatura', 408.0000, 'ºC'),
	(126104, 109, '2015-04-01 00:23:56.000000', 'temperatura', 356.0000, 'ºC'),
	(126105, 109, '2015-04-01 00:23:57.000000', 'temperatura', 554.0000, 'ºC'),
	(126106, 109, '2015-04-01 00:23:58.000000', 'temperatura', 503.0000, 'ºC'),
	(126107, 109, '2015-04-01 00:23:59.000000', 'temperatura', 856.0000, 'ºC'),
	(126108, 109, '2015-04-01 00:24:00.000000', 'temperatura', 369.0000, 'ºC'),
	(126109, 109, '2015-04-01 00:24:01.000000', 'temperatura', 478.0000, 'ºC'),
	(126110, 109, '2015-04-01 00:24:02.000000', 'temperatura', 82.0000, 'ºC'),
	(126111, 109, '2015-04-01 00:24:03.000000', 'temperatura', 177.0000, 'ºC'),
	(126112, 109, '2015-04-01 00:24:04.000000', 'temperatura', 638.0000, 'ºC'),
	(126113, 109, '2015-04-01 00:24:05.000000', 'temperatura', 261.0000, 'ºC'),
	(126114, 109, '2015-04-01 00:24:06.000000', 'temperatura', 591.0000, 'ºC'),
	(126115, 109, '2015-04-01 00:24:07.000000', 'temperatura', 974.0000, 'ºC'),
	(126116, 109, '2015-04-01 00:24:08.000000', 'temperatura', 698.0000, 'ºC'),
	(126117, 109, '2015-04-01 00:24:09.000000', 'temperatura', 566.0000, 'ºC'),
	(126118, 109, '2015-04-01 00:24:10.000000', 'temperatura', 737.0000, 'ºC'),
	(126119, 109, '2015-04-01 00:24:11.000000', 'temperatura', 788.0000, 'ºC'),
	(126120, 109, '2015-04-01 00:24:12.000000', 'temperatura', 529.0000, 'ºC'),
	(126121, 109, '2015-04-01 00:24:13.000000', 'temperatura', 284.0000, 'ºC'),
	(126122, 109, '2015-04-01 00:24:14.000000', 'temperatura', 1031.0000, 'ºC'),
	(126123, 109, '2015-04-01 00:24:15.000000', 'temperatura', 705.0000, 'ºC'),
	(126124, 109, '2015-04-01 00:24:16.000000', 'temperatura', 430.0000, 'ºC'),
	(126125, 109, '2015-04-01 00:24:17.000000', 'temperatura', 39.0000, 'ºC'),
	(126126, 109, '2015-04-01 00:24:18.000000', 'temperatura', 103.0000, 'ºC'),
	(126127, 109, '2015-04-01 00:24:19.000000', 'temperatura', 398.0000, 'ºC'),
	(126128, 109, '2015-04-01 00:24:20.000000', 'temperatura', 481.0000, 'ºC'),
	(126129, 109, '2015-04-01 00:24:21.000000', 'temperatura', 13.0000, 'ºC'),
	(126130, 109, '2015-04-01 00:24:22.000000', 'temperatura', 1023.0000, 'ºC'),
	(126131, 109, '2015-04-01 00:24:23.000000', 'temperatura', 275.0000, 'ºC'),
	(126132, 109, '2015-04-01 00:24:24.000000', 'temperatura', 705.0000, 'ºC'),
	(126133, 109, '2015-04-01 00:24:25.000000', 'temperatura', 303.0000, 'ºC'),
	(126134, 109, '2015-04-01 00:24:26.000000', 'temperatura', 599.0000, 'ºC'),
	(126135, 109, '2015-04-01 00:24:27.000000', 'temperatura', 885.0000, 'ºC'),
	(126136, 109, '2015-04-01 00:24:28.000000', 'temperatura', 231.0000, 'ºC'),
	(126137, 109, '2015-04-01 00:24:29.000000', 'temperatura', 901.0000, 'ºC'),
	(126138, 109, '2015-04-01 00:24:30.000000', 'temperatura', 211.0000, 'ºC'),
	(126139, 109, '2015-04-01 00:24:31.000000', 'temperatura', 754.0000, 'ºC'),
	(126140, 109, '2015-04-01 00:24:32.000000', 'temperatura', 736.0000, 'ºC'),
	(126141, 109, '2015-04-01 00:24:33.000000', 'temperatura', 218.0000, 'ºC'),
	(126142, 109, '2015-04-01 00:24:34.000000', 'temperatura', 84.0000, 'ºC'),
	(126143, 109, '2015-04-01 00:24:35.000000', 'temperatura', 964.0000, 'ºC'),
	(126144, 109, '2015-04-01 00:24:36.000000', 'temperatura', 971.0000, 'ºC'),
	(126145, 109, '2015-04-01 00:24:37.000000', 'temperatura', 761.0000, 'ºC'),
	(126146, 109, '2015-04-01 00:24:38.000000', 'temperatura', 895.0000, 'ºC'),
	(126147, 109, '2015-04-01 00:24:39.000000', 'temperatura', 992.0000, 'ºC'),
	(126148, 109, '2015-04-01 00:24:40.000000', 'temperatura', 1074.0000, 'ºC'),
	(126149, 109, '2015-04-01 00:24:41.000000', 'temperatura', 1197.0000, 'ºC'),
	(126150, 109, '2015-04-01 00:24:42.000000', 'temperatura', 364.0000, 'ºC'),
	(126151, 109, '2015-04-01 00:24:43.000000', 'temperatura', 627.0000, 'ºC'),
	(126152, 109, '2015-04-01 00:24:44.000000', 'temperatura', 847.0000, 'ºC'),
	(126153, 109, '2015-04-01 00:24:45.000000', 'temperatura', 1151.0000, 'ºC'),
	(126154, 109, '2015-04-01 00:24:46.000000', 'temperatura', 815.0000, 'ºC'),
	(126155, 109, '2015-04-01 00:24:47.000000', 'temperatura', 625.0000, 'ºC'),
	(126156, 109, '2015-04-01 00:24:48.000000', 'temperatura', 678.0000, 'ºC'),
	(126157, 109, '2015-04-01 00:24:49.000000', 'temperatura', 318.0000, 'ºC'),
	(126158, 109, '2015-04-01 00:24:50.000000', 'temperatura', 755.0000, 'ºC'),
	(126159, 109, '2015-04-01 00:24:51.000000', 'temperatura', 422.0000, 'ºC'),
	(126160, 109, '2015-04-01 00:24:52.000000', 'temperatura', 1045.0000, 'ºC'),
	(126161, 109, '2015-04-01 00:24:53.000000', 'temperatura', 362.0000, 'ºC'),
	(126162, 109, '2015-04-01 00:24:54.000000', 'temperatura', 1072.0000, 'ºC'),
	(126163, 109, '2015-04-01 00:24:55.000000', 'temperatura', 677.0000, 'ºC'),
	(126164, 109, '2015-04-01 00:24:56.000000', 'temperatura', 170.0000, 'ºC'),
	(126165, 109, '2015-04-01 00:24:57.000000', 'temperatura', 17.0000, 'ºC'),
	(126166, 109, '2015-04-01 00:24:58.000000', 'temperatura', 776.0000, 'ºC'),
	(126167, 109, '2015-04-01 00:24:59.000000', 'temperatura', 229.0000, 'ºC'),
	(126168, 109, '2015-04-01 00:25:00.000000', 'temperatura', 17.0000, 'ºC'),
	(126169, 109, '2015-04-01 00:25:01.000000', 'temperatura', 601.0000, 'ºC'),
	(126170, 109, '2015-04-01 00:25:02.000000', 'temperatura', 552.0000, 'ºC'),
	(126171, 109, '2015-04-01 00:25:03.000000', 'temperatura', 957.0000, 'ºC'),
	(126172, 109, '2015-04-01 00:25:04.000000', 'temperatura', 730.0000, 'ºC'),
	(126173, 109, '2015-04-01 00:25:05.000000', 'temperatura', 780.0000, 'ºC'),
	(126174, 109, '2015-04-01 00:25:06.000000', 'temperatura', 512.0000, 'ºC'),
	(126175, 109, '2015-04-01 00:25:07.000000', 'temperatura', 218.0000, 'ºC'),
	(126176, 109, '2015-04-01 00:25:08.000000', 'temperatura', 757.0000, 'ºC'),
	(126177, 109, '2015-04-01 00:25:09.000000', 'temperatura', 731.0000, 'ºC'),
	(126178, 109, '2015-04-01 00:25:10.000000', 'temperatura', 186.0000, 'ºC'),
	(126179, 109, '2015-04-01 00:25:11.000000', 'temperatura', 1136.0000, 'ºC'),
	(126180, 109, '2015-04-01 00:25:12.000000', 'temperatura', 323.0000, 'ºC'),
	(126181, 109, '2015-04-01 00:25:13.000000', 'temperatura', 606.0000, 'ºC'),
	(126182, 109, '2015-04-01 00:25:14.000000', 'temperatura', 862.0000, 'ºC'),
	(126183, 109, '2015-04-01 00:25:15.000000', 'temperatura', 94.0000, 'ºC'),
	(126184, 109, '2015-04-01 00:25:16.000000', 'temperatura', 282.0000, 'ºC'),
	(126185, 109, '2015-04-01 00:25:17.000000', 'temperatura', 1131.0000, 'ºC'),
	(126186, 109, '2015-04-01 00:25:18.000000', 'temperatura', 7.0000, 'ºC'),
	(126187, 109, '2015-04-01 00:25:19.000000', 'temperatura', 242.0000, 'ºC'),
	(126188, 109, '2015-04-01 00:25:20.000000', 'temperatura', 1189.0000, 'ºC'),
	(126189, 109, '2015-04-01 00:25:21.000000', 'temperatura', 422.0000, 'ºC'),
	(126190, 109, '2015-04-01 00:25:22.000000', 'temperatura', 941.0000, 'ºC'),
	(126191, 109, '2015-04-01 00:25:23.000000', 'temperatura', 1040.0000, 'ºC'),
	(126192, 109, '2015-04-01 00:25:24.000000', 'temperatura', 1176.0000, 'ºC'),
	(126193, 109, '2015-04-01 00:25:25.000000', 'temperatura', 364.0000, 'ºC'),
	(126194, 109, '2015-04-01 00:25:26.000000', 'temperatura', 690.0000, 'ºC'),
	(126195, 109, '2015-04-01 00:25:27.000000', 'temperatura', 1159.0000, 'ºC'),
	(126196, 109, '2015-04-01 00:25:28.000000', 'temperatura', 127.0000, 'ºC'),
	(126197, 109, '2015-04-01 00:25:29.000000', 'temperatura', 756.0000, 'ºC'),
	(126198, 109, '2015-04-01 00:25:30.000000', 'temperatura', 1000.0000, 'ºC'),
	(126199, 109, '2015-04-01 00:25:31.000000', 'temperatura', 333.0000, 'ºC'),
	(126200, 109, '2015-04-01 00:25:32.000000', 'temperatura', 1067.0000, 'ºC'),
	(126201, 109, '2015-04-01 00:25:33.000000', 'temperatura', 734.0000, 'ºC'),
	(126202, 109, '2015-04-01 00:25:34.000000', 'temperatura', 469.0000, 'ºC'),
	(126203, 109, '2015-04-01 00:25:35.000000', 'temperatura', 146.0000, 'ºC'),
	(126204, 109, '2015-04-01 00:25:36.000000', 'temperatura', 522.0000, 'ºC'),
	(126205, 109, '2015-04-01 00:25:37.000000', 'temperatura', 972.0000, 'ºC'),
	(126206, 109, '2015-04-01 00:25:38.000000', 'temperatura', 894.0000, 'ºC'),
	(126207, 109, '2015-04-01 00:25:39.000000', 'temperatura', 354.0000, 'ºC'),
	(126208, 109, '2015-04-01 00:25:40.000000', 'temperatura', 288.0000, 'ºC'),
	(126209, 109, '2015-04-01 00:25:41.000000', 'temperatura', 378.0000, 'ºC'),
	(126210, 109, '2015-04-01 00:25:42.000000', 'temperatura', 1029.0000, 'ºC'),
	(126211, 109, '2015-04-01 00:25:43.000000', 'temperatura', 411.0000, 'ºC'),
	(126212, 109, '2015-04-01 00:25:44.000000', 'temperatura', 167.0000, 'ºC'),
	(126213, 109, '2015-04-01 00:25:45.000000', 'temperatura', 804.0000, 'ºC'),
	(126214, 109, '2015-04-01 00:25:46.000000', 'temperatura', 1121.0000, 'ºC'),
	(126215, 109, '2015-04-01 00:25:47.000000', 'temperatura', 792.0000, 'ºC'),
	(126216, 109, '2015-04-01 00:25:48.000000', 'temperatura', 598.0000, 'ºC'),
	(126217, 109, '2015-04-01 00:25:49.000000', 'temperatura', 615.0000, 'ºC'),
	(126218, 109, '2015-04-01 00:25:50.000000', 'temperatura', 82.0000, 'ºC'),
	(126219, 109, '2015-04-01 00:25:51.000000', 'temperatura', 965.0000, 'ºC'),
	(126220, 109, '2015-04-01 00:25:52.000000', 'temperatura', 977.0000, 'ºC'),
	(126221, 109, '2015-04-01 00:25:53.000000', 'temperatura', 793.0000, 'ºC'),
	(126222, 109, '2015-04-01 00:25:54.000000', 'temperatura', 1034.0000, 'ºC'),
	(126223, 109, '2015-04-01 00:25:55.000000', 'temperatura', 391.0000, 'ºC'),
	(126224, 109, '2015-04-01 00:25:56.000000', 'temperatura', 55.0000, 'ºC'),
	(126225, 109, '2015-04-01 00:25:57.000000', 'temperatura', 300.0000, 'ºC'),
	(126226, 109, '2015-04-01 00:25:58.000000', 'temperatura', 137.0000, 'ºC'),
	(126227, 109, '2015-04-01 00:25:59.000000', 'temperatura', 984.0000, 'ºC'),
	(126228, 109, '2015-04-01 00:26:00.000000', 'temperatura', 910.0000, 'ºC'),
	(126229, 109, '2015-04-01 00:26:01.000000', 'temperatura', 399.0000, 'ºC'),
	(126230, 109, '2015-04-01 00:26:02.000000', 'temperatura', 467.0000, 'ºC'),
	(126231, 109, '2015-04-01 00:26:03.000000', 'temperatura', 1138.0000, 'ºC'),
	(126232, 109, '2015-04-01 00:26:04.000000', 'temperatura', 689.0000, 'ºC'),
	(126233, 109, '2015-04-01 00:26:05.000000', 'temperatura', 30.0000, 'ºC'),
	(126234, 109, '2015-04-01 00:26:06.000000', 'temperatura', 485.0000, 'ºC'),
	(126235, 109, '2015-04-01 00:26:07.000000', 'temperatura', 1137.0000, 'ºC'),
	(126236, 109, '2015-04-01 00:26:08.000000', 'temperatura', 630.0000, 'ºC'),
	(126237, 109, '2015-04-01 00:26:09.000000', 'temperatura', 939.0000, 'ºC'),
	(126238, 109, '2015-04-01 00:26:10.000000', 'temperatura', 407.0000, 'ºC'),
	(126239, 109, '2015-04-01 00:26:11.000000', 'temperatura', 418.0000, 'ºC'),
	(126240, 109, '2015-04-01 00:26:12.000000', 'temperatura', 869.0000, 'ºC'),
	(126241, 109, '2015-04-01 00:26:13.000000', 'temperatura', 690.0000, 'ºC'),
	(126242, 109, '2015-04-01 00:26:14.000000', 'temperatura', 846.0000, 'ºC'),
	(126243, 109, '2015-04-01 00:26:15.000000', 'temperatura', 960.0000, 'ºC'),
	(126244, 109, '2015-04-01 00:26:16.000000', 'temperatura', 1061.0000, 'ºC'),
	(126245, 109, '2015-04-01 00:26:17.000000', 'temperatura', 26.0000, 'ºC'),
	(126246, 109, '2015-04-01 00:26:18.000000', 'temperatura', 547.0000, 'ºC'),
	(126247, 109, '2015-04-01 00:26:19.000000', 'temperatura', 260.0000, 'ºC'),
	(126248, 109, '2015-04-01 00:26:20.000000', 'temperatura', 859.0000, 'ºC'),
	(126249, 109, '2015-04-01 00:26:21.000000', 'temperatura', 1114.0000, 'ºC'),
	(126250, 109, '2015-04-01 00:26:22.000000', 'temperatura', 592.0000, 'ºC'),
	(126251, 109, '2015-04-01 00:26:23.000000', 'temperatura', 820.0000, 'ºC'),
	(126252, 109, '2015-04-01 00:26:24.000000', 'temperatura', 1125.0000, 'ºC'),
	(126253, 109, '2015-04-01 00:26:25.000000', 'temperatura', 767.0000, 'ºC'),
	(126254, 109, '2015-04-01 00:26:26.000000', 'temperatura', 458.0000, 'ºC'),
	(126255, 109, '2015-04-01 00:26:27.000000', 'temperatura', 1189.0000, 'ºC'),
	(126256, 109, '2015-04-01 00:26:28.000000', 'temperatura', 973.0000, 'ºC'),
	(126257, 109, '2015-04-01 00:26:29.000000', 'temperatura', 96.0000, 'ºC'),
	(126258, 109, '2015-04-01 00:26:30.000000', 'temperatura', 1165.0000, 'ºC'),
	(126259, 109, '2015-04-01 00:26:31.000000', 'temperatura', 735.0000, 'ºC'),
	(126260, 109, '2015-04-01 00:26:32.000000', 'temperatura', 180.0000, 'ºC'),
	(126261, 109, '2015-04-01 00:26:33.000000', 'temperatura', 1097.0000, 'ºC'),
	(126262, 109, '2015-04-01 00:26:34.000000', 'temperatura', 146.0000, 'ºC'),
	(126263, 109, '2015-04-01 00:26:35.000000', 'temperatura', 1039.0000, 'ºC'),
	(126264, 109, '2015-04-01 00:26:36.000000', 'temperatura', 1159.0000, 'ºC'),
	(126265, 109, '2015-04-01 00:26:37.000000', 'temperatura', 277.0000, 'ºC'),
	(126266, 109, '2015-04-01 00:26:38.000000', 'temperatura', 310.0000, 'ºC'),
	(126267, 109, '2015-04-01 00:26:39.000000', 'temperatura', 720.0000, 'ºC'),
	(126268, 109, '2015-04-01 00:26:40.000000', 'temperatura', 269.0000, 'ºC'),
	(126269, 109, '2015-04-01 00:26:41.000000', 'temperatura', 384.0000, 'ºC'),
	(126270, 109, '2015-04-01 00:26:42.000000', 'temperatura', 1115.0000, 'ºC'),
	(126271, 109, '2015-04-01 00:26:43.000000', 'temperatura', 823.0000, 'ºC'),
	(126272, 109, '2015-04-01 00:26:44.000000', 'temperatura', 769.0000, 'ºC'),
	(126273, 109, '2015-04-01 00:26:45.000000', 'temperatura', 178.0000, 'ºC'),
	(126274, 109, '2015-04-01 00:26:46.000000', 'temperatura', 982.0000, 'ºC'),
	(126275, 109, '2015-04-01 00:26:47.000000', 'temperatura', 777.0000, 'ºC'),
	(126276, 109, '2015-04-01 00:26:48.000000', 'temperatura', 940.0000, 'ºC'),
	(126277, 109, '2015-04-01 00:26:49.000000', 'temperatura', 1171.0000, 'ºC'),
	(126278, 109, '2015-04-01 00:26:50.000000', 'temperatura', 634.0000, 'ºC'),
	(126279, 109, '2015-04-01 00:26:51.000000', 'temperatura', 857.0000, 'ºC'),
	(126280, 109, '2015-04-01 00:26:52.000000', 'temperatura', 1185.0000, 'ºC'),
	(126281, 109, '2015-04-01 00:26:53.000000', 'temperatura', 953.0000, 'ºC'),
	(126282, 109, '2015-04-01 00:26:54.000000', 'temperatura', 10.0000, 'ºC'),
	(126283, 109, '2015-04-01 00:26:55.000000', 'temperatura', 791.0000, 'ºC'),
	(126284, 109, '2015-04-01 00:26:56.000000', 'temperatura', 327.0000, 'ºC'),
	(126285, 109, '2015-04-01 00:26:57.000000', 'temperatura', 462.0000, 'ºC'),
	(126286, 109, '2015-04-01 00:26:58.000000', 'temperatura', 130.0000, 'ºC'),
	(126287, 109, '2015-04-01 00:26:59.000000', 'temperatura', 462.0000, 'ºC'),
	(126288, 109, '2015-04-01 00:27:00.000000', 'temperatura', 724.0000, 'ºC'),
	(126289, 109, '2015-04-01 00:27:01.000000', 'temperatura', 1032.0000, 'ºC'),
	(126290, 109, '2015-04-01 00:27:02.000000', 'temperatura', 591.0000, 'ºC'),
	(126291, 109, '2015-04-01 00:27:03.000000', 'temperatura', 1060.0000, 'ºC'),
	(126292, 109, '2015-04-01 00:27:04.000000', 'temperatura', 1126.0000, 'ºC'),
	(126293, 109, '2015-04-01 00:27:05.000000', 'temperatura', 50.0000, 'ºC'),
	(126294, 109, '2015-04-01 00:27:06.000000', 'temperatura', 474.0000, 'ºC'),
	(126295, 109, '2015-04-01 00:27:07.000000', 'temperatura', 1019.0000, 'ºC'),
	(126296, 109, '2015-04-01 00:27:08.000000', 'temperatura', 72.0000, 'ºC'),
	(126297, 109, '2015-04-01 00:27:09.000000', 'temperatura', 906.0000, 'ºC'),
	(126298, 109, '2015-04-01 00:27:10.000000', 'temperatura', 712.0000, 'ºC'),
	(126299, 109, '2015-04-01 00:27:11.000000', 'temperatura', 845.0000, 'ºC'),
	(126300, 109, '2015-04-01 00:27:12.000000', 'temperatura', 888.0000, 'ºC'),
	(126301, 109, '2015-04-01 00:27:13.000000', 'temperatura', 706.0000, 'ºC'),
	(126302, 109, '2015-04-01 00:27:14.000000', 'temperatura', 868.0000, 'ºC'),
	(126303, 109, '2015-04-01 00:27:15.000000', 'temperatura', 1020.0000, 'ºC'),
	(126304, 109, '2015-04-01 00:27:16.000000', 'temperatura', 97.0000, 'ºC'),
	(126305, 109, '2015-04-01 00:27:17.000000', 'temperatura', 1024.0000, 'ºC'),
	(126306, 109, '2015-04-01 00:27:18.000000', 'temperatura', 31.0000, 'ºC'),
	(126307, 109, '2015-04-01 00:27:19.000000', 'temperatura', 683.0000, 'ºC'),
	(126308, 109, '2015-04-01 00:27:20.000000', 'temperatura', 924.0000, 'ºC'),
	(126309, 109, '2015-04-01 00:27:21.000000', 'temperatura', 172.0000, 'ºC'),
	(126310, 109, '2015-04-01 00:27:22.000000', 'temperatura', 486.0000, 'ºC'),
	(126311, 109, '2015-04-01 00:27:23.000000', 'temperatura', 716.0000, 'ºC'),
	(126312, 109, '2015-04-01 00:27:24.000000', 'temperatura', 923.0000, 'ºC'),
	(126313, 109, '2015-04-01 00:27:25.000000', 'temperatura', 68.0000, 'ºC'),
	(126314, 109, '2015-04-01 00:27:26.000000', 'temperatura', 1172.0000, 'ºC'),
	(126315, 109, '2015-04-01 00:27:27.000000', 'temperatura', 855.0000, 'ºC'),
	(126316, 109, '2015-04-01 00:27:28.000000', 'temperatura', 762.0000, 'ºC'),
	(126317, 109, '2015-04-01 00:27:29.000000', 'temperatura', 44.0000, 'ºC'),
	(126318, 109, '2015-04-01 00:27:30.000000', 'temperatura', 335.0000, 'ºC'),
	(126319, 109, '2015-04-01 00:27:31.000000', 'temperatura', 344.0000, 'ºC'),
	(126320, 109, '2015-04-01 00:27:32.000000', 'temperatura', 716.0000, 'ºC'),
	(126321, 109, '2015-04-01 00:27:33.000000', 'temperatura', 148.0000, 'ºC'),
	(126322, 109, '2015-04-01 00:27:34.000000', 'temperatura', 993.0000, 'ºC'),
	(126323, 109, '2015-04-01 00:27:35.000000', 'temperatura', 919.0000, 'ºC'),
	(126324, 109, '2015-04-01 00:27:36.000000', 'temperatura', 420.0000, 'ºC'),
	(126325, 109, '2015-04-01 00:27:37.000000', 'temperatura', 541.0000, 'ºC'),
	(126326, 109, '2015-04-01 00:27:38.000000', 'temperatura', 245.0000, 'ºC'),
	(126327, 109, '2015-04-01 00:27:39.000000', 'temperatura', 802.0000, 'ºC'),
	(126328, 109, '2015-04-01 00:27:40.000000', 'temperatura', 876.0000, 'ºC'),
	(126329, 109, '2015-04-01 00:27:41.000000', 'temperatura', 776.0000, 'ºC'),
	(126330, 109, '2015-04-01 00:27:42.000000', 'temperatura', 50.0000, 'ºC'),
	(126331, 109, '2015-04-01 00:27:43.000000', 'temperatura', 323.0000, 'ºC'),
	(126332, 109, '2015-04-01 00:27:44.000000', 'temperatura', 265.0000, 'ºC'),
	(126333, 109, '2015-04-01 00:27:45.000000', 'temperatura', 355.0000, 'ºC'),
	(126334, 109, '2015-04-01 00:27:46.000000', 'temperatura', 984.0000, 'ºC'),
	(126335, 109, '2015-04-01 00:27:47.000000', 'temperatura', 254.0000, 'ºC'),
	(126336, 109, '2015-04-01 00:27:48.000000', 'temperatura', 721.0000, 'ºC'),
	(126337, 109, '2015-04-01 00:27:49.000000', 'temperatura', 440.0000, 'ºC'),
	(126338, 109, '2015-04-01 00:27:50.000000', 'temperatura', 39.0000, 'ºC'),
	(126339, 109, '2015-04-01 00:27:51.000000', 'temperatura', 75.0000, 'ºC'),
	(126340, 109, '2015-04-01 00:27:52.000000', 'temperatura', 259.0000, 'ºC'),
	(126341, 109, '2015-04-01 00:27:53.000000', 'temperatura', 1070.0000, 'ºC'),
	(126342, 109, '2015-04-01 00:27:54.000000', 'temperatura', 972.0000, 'ºC'),
	(126343, 109, '2015-04-01 00:27:55.000000', 'temperatura', 450.0000, 'ºC'),
	(126344, 109, '2015-04-01 00:27:56.000000', 'temperatura', 536.0000, 'ºC'),
	(126345, 109, '2015-04-01 00:27:57.000000', 'temperatura', 131.0000, 'ºC'),
	(126346, 109, '2015-04-01 00:27:58.000000', 'temperatura', 249.0000, 'ºC'),
	(126347, 109, '2015-04-01 00:27:59.000000', 'temperatura', 850.0000, 'ºC'),
	(126348, 109, '2015-04-01 00:28:00.000000', 'temperatura', 1105.0000, 'ºC'),
	(126349, 109, '2015-04-01 00:28:01.000000', 'temperatura', 573.0000, 'ºC'),
	(126350, 109, '2015-04-01 00:28:02.000000', 'temperatura', 752.0000, 'ºC'),
	(126351, 109, '2015-04-01 00:28:03.000000', 'temperatura', 843.0000, 'ºC'),
	(126352, 109, '2015-04-01 00:28:04.000000', 'temperatura', 759.0000, 'ºC'),
	(126353, 109, '2015-04-01 00:28:05.000000', 'temperatura', 67.0000, 'ºC'),
	(126354, 109, '2015-04-01 00:28:06.000000', 'temperatura', 460.0000, 'ºC'),
	(126355, 109, '2015-04-01 00:28:07.000000', 'temperatura', 896.0000, 'ºC'),
	(126356, 109, '2015-04-01 00:28:08.000000', 'temperatura', 703.0000, 'ºC'),
	(126357, 109, '2015-04-01 00:28:09.000000', 'temperatura', 828.0000, 'ºC'),
	(126358, 109, '2015-04-01 00:28:10.000000', 'temperatura', 832.0000, 'ºC'),
	(126359, 109, '2015-04-01 00:28:11.000000', 'temperatura', 476.0000, 'ºC'),
	(126360, 109, '2015-04-01 00:28:12.000000', 'temperatura', 1083.0000, 'ºC'),
	(126361, 109, '2015-04-01 00:28:13.000000', 'temperatura', 388.0000, 'ºC'),
	(126362, 109, '2015-04-01 00:28:14.000000', 'temperatura', 1093.0000, 'ºC'),
	(126363, 109, '2015-04-01 00:28:15.000000', 'temperatura', 701.0000, 'ºC'),
	(126364, 109, '2015-04-01 00:28:16.000000', 'temperatura', 226.0000, 'ºC'),
	(126365, 109, '2015-04-01 00:28:17.000000', 'temperatura', 229.0000, 'ºC'),
	(126366, 109, '2015-04-01 00:28:18.000000', 'temperatura', 466.0000, 'ºC'),
	(126367, 109, '2015-04-01 00:28:19.000000', 'temperatura', 443.0000, 'ºC'),
	(126368, 109, '2015-04-01 00:28:20.000000', 'temperatura', 818.0000, 'ºC'),
	(126369, 109, '2015-04-01 00:28:21.000000', 'temperatura', 363.0000, 'ºC'),
	(126370, 109, '2015-04-01 00:28:22.000000', 'temperatura', 560.0000, 'ºC'),
	(126371, 109, '2015-04-01 00:28:23.000000', 'temperatura', 510.0000, 'ºC'),
	(126372, 109, '2015-04-01 00:28:24.000000', 'temperatura', 871.0000, 'ºC'),
	(126373, 109, '2015-04-01 00:28:25.000000', 'temperatura', 426.0000, 'ºC'),
	(126374, 109, '2015-04-01 00:28:26.000000', 'temperatura', 717.0000, 'ºC'),
	(126375, 109, '2015-04-01 00:28:27.000000', 'temperatura', 1108.0000, 'ºC'),
	(126376, 109, '2015-04-01 00:28:28.000000', 'temperatura', 991.0000, 'ºC'),
	(126377, 109, '2015-04-01 00:28:29.000000', 'temperatura', 429.0000, 'ºC'),
	(126378, 109, '2015-04-01 00:28:30.000000', 'temperatura', 375.0000, 'ºC'),
	(126379, 109, '2015-04-01 00:28:31.000000', 'temperatura', 586.0000, 'ºC'),
	(126380, 109, '2015-04-01 00:28:32.000000', 'temperatura', 606.0000, 'ºC'),
	(126381, 109, '2015-04-01 00:28:33.000000', 'temperatura', 73.0000, 'ºC'),
	(126382, 109, '2015-04-01 00:28:34.000000', 'temperatura', 949.0000, 'ºC'),
	(126383, 109, '2015-04-01 00:28:35.000000', 'temperatura', 924.0000, 'ºC'),
	(126384, 109, '2015-04-01 00:28:36.000000', 'temperatura', 576.0000, 'ºC'),
	(126385, 109, '2015-04-01 00:28:37.000000', 'temperatura', 107.0000, 'ºC'),
	(126386, 109, '2015-04-01 00:28:38.000000', 'temperatura', 9.0000, 'ºC'),
	(126387, 109, '2015-04-01 00:28:39.000000', 'temperatura', 924.0000, 'ºC'),
	(126388, 109, '2015-04-01 00:28:40.000000', 'temperatura', 994.0000, 'ºC'),
	(126389, 109, '2015-04-01 00:28:41.000000', 'temperatura', 1000.0000, 'ºC'),
	(126390, 109, '2015-04-01 00:28:42.000000', 'temperatura', 817.0000, 'ºC'),
	(126391, 109, '2015-04-01 00:28:43.000000', 'temperatura', 1086.0000, 'ºC'),
	(126392, 109, '2015-04-01 00:28:44.000000', 'temperatura', 581.0000, 'ºC'),
	(126393, 109, '2015-04-01 00:28:45.000000', 'temperatura', 844.0000, 'ºC'),
	(126394, 109, '2015-04-01 00:28:46.000000', 'temperatura', 80.0000, 'ºC'),
	(126395, 109, '2015-04-01 00:28:47.000000', 'temperatura', 268.0000, 'ºC'),
	(126396, 109, '2015-04-01 00:28:48.000000', 'temperatura', 1102.0000, 'ºC'),
	(126397, 109, '2015-04-01 00:28:49.000000', 'temperatura', 1104.0000, 'ºC'),
	(126398, 109, '2015-04-01 00:28:50.000000', 'temperatura', 1013.0000, 'ºC'),
	(126399, 109, '2015-04-01 00:28:51.000000', 'temperatura', 557.0000, 'ºC'),
	(126400, 109, '2015-04-01 00:28:52.000000', 'temperatura', 947.0000, 'ºC'),
	(126401, 109, '2015-04-01 00:28:53.000000', 'temperatura', 662.0000, 'ºC'),
	(126402, 109, '2015-04-01 00:28:54.000000', 'temperatura', 472.0000, 'ºC'),
	(126403, 109, '2015-04-01 00:28:55.000000', 'temperatura', 374.0000, 'ºC'),
	(126404, 109, '2015-04-01 00:28:56.000000', 'temperatura', 452.0000, 'ºC'),
	(126405, 109, '2015-04-01 00:28:57.000000', 'temperatura', 1141.0000, 'ºC'),
	(126406, 109, '2015-04-01 00:28:58.000000', 'temperatura', 748.0000, 'ºC'),
	(126407, 109, '2015-04-01 00:28:59.000000', 'temperatura', 317.0000, 'ºC'),
	(126408, 109, '2015-04-01 00:29:00.000000', 'temperatura', 542.0000, 'ºC'),
	(126409, 109, '2015-04-01 00:29:01.000000', 'temperatura', 558.0000, 'ºC'),
	(126410, 109, '2015-04-01 00:29:02.000000', 'temperatura', 1167.0000, 'ºC'),
	(126411, 109, '2015-04-01 00:29:03.000000', 'temperatura', 559.0000, 'ºC'),
	(126412, 109, '2015-04-01 00:29:04.000000', 'temperatura', 495.0000, 'ºC'),
	(126413, 109, '2015-04-01 00:29:05.000000', 'temperatura', 798.0000, 'ºC'),
	(126414, 109, '2015-04-01 00:29:06.000000', 'temperatura', 105.0000, 'ºC'),
	(126415, 109, '2015-04-01 00:29:07.000000', 'temperatura', 531.0000, 'ºC'),
	(126416, 109, '2015-04-01 00:29:08.000000', 'temperatura', 1140.0000, 'ºC'),
	(126417, 109, '2015-04-01 00:29:09.000000', 'temperatura', 509.0000, 'ºC'),
	(126418, 109, '2015-04-01 00:29:10.000000', 'temperatura', 327.0000, 'ºC'),
	(126419, 109, '2015-04-01 00:29:11.000000', 'temperatura', 107.0000, 'ºC'),
	(126420, 109, '2015-04-01 00:29:12.000000', 'temperatura', 755.0000, 'ºC'),
	(126421, 109, '2015-04-01 00:29:13.000000', 'temperatura', 1056.0000, 'ºC'),
	(126422, 109, '2015-04-01 00:29:14.000000', 'temperatura', 614.0000, 'ºC'),
	(126423, 109, '2015-04-01 00:29:15.000000', 'temperatura', 1105.0000, 'ºC'),
	(126424, 109, '2015-04-01 00:29:16.000000', 'temperatura', 81.0000, 'ºC'),
	(126425, 109, '2015-04-01 00:29:17.000000', 'temperatura', 690.0000, 'ºC'),
	(126426, 109, '2015-04-01 00:29:18.000000', 'temperatura', 810.0000, 'ºC'),
	(126427, 109, '2015-04-01 00:29:19.000000', 'temperatura', 780.0000, 'ºC'),
	(126428, 109, '2015-04-01 00:29:20.000000', 'temperatura', 272.0000, 'ºC'),
	(126429, 109, '2015-04-01 00:29:21.000000', 'temperatura', 218.0000, 'ºC'),
	(126430, 109, '2015-04-01 00:29:22.000000', 'temperatura', 274.0000, 'ºC'),
	(126431, 109, '2015-04-01 00:29:23.000000', 'temperatura', 718.0000, 'ºC'),
	(126432, 109, '2015-04-01 00:29:24.000000', 'temperatura', 369.0000, 'ºC'),
	(126433, 109, '2015-04-01 00:29:25.000000', 'temperatura', 892.0000, 'ºC'),
	(126434, 109, '2015-04-01 00:29:26.000000', 'temperatura', 952.0000, 'ºC'),
	(126435, 109, '2015-04-01 00:29:27.000000', 'temperatura', 885.0000, 'ºC'),
	(126436, 109, '2015-04-01 00:29:28.000000', 'temperatura', 370.0000, 'ºC'),
	(126437, 109, '2015-04-01 00:29:29.000000', 'temperatura', 394.0000, 'ºC'),
	(126438, 109, '2015-04-01 00:29:30.000000', 'temperatura', 859.0000, 'ºC'),
	(126439, 109, '2015-04-01 00:29:31.000000', 'temperatura', 717.0000, 'ºC'),
	(126440, 109, '2015-04-01 00:29:32.000000', 'temperatura', 1008.0000, 'ºC'),
	(126441, 109, '2015-04-01 00:29:33.000000', 'temperatura', 489.0000, 'ºC'),
	(126442, 109, '2015-04-01 00:29:34.000000', 'temperatura', 622.0000, 'ºC'),
	(126443, 109, '2015-04-01 00:29:35.000000', 'temperatura', 444.0000, 'ºC'),
	(126444, 109, '2015-04-01 00:29:36.000000', 'temperatura', 352.0000, 'ºC'),
	(126445, 109, '2015-04-01 00:29:37.000000', 'temperatura', 431.0000, 'ºC'),
	(126446, 109, '2015-04-01 00:29:38.000000', 'temperatura', 1100.0000, 'ºC'),
	(126447, 109, '2015-04-01 00:29:39.000000', 'temperatura', 605.0000, 'ºC'),
	(126448, 109, '2015-04-01 00:29:40.000000', 'temperatura', 928.0000, 'ºC'),
	(126449, 109, '2015-04-01 00:29:41.000000', 'temperatura', 427.0000, 'ºC'),
	(126450, 109, '2015-04-01 00:29:42.000000', 'temperatura', 548.0000, 'ºC'),
	(126451, 109, '2015-04-01 00:29:43.000000', 'temperatura', 261.0000, 'ºC'),
	(126452, 109, '2015-04-01 00:29:44.000000', 'temperatura', 862.0000, 'ºC'),
	(126453, 109, '2015-04-01 00:29:45.000000', 'temperatura', 1126.0000, 'ºC'),
	(126454, 109, '2015-04-01 00:29:46.000000', 'temperatura', 645.0000, 'ºC'),
	(126455, 109, '2015-04-01 00:29:47.000000', 'temperatura', 1050.0000, 'ºC'),
	(126456, 109, '2015-04-01 00:29:48.000000', 'temperatura', 913.0000, 'ºC'),
	(126457, 109, '2015-04-01 00:29:49.000000', 'temperatura', 215.0000, 'ºC'),
	(126458, 109, '2015-04-01 00:29:50.000000', 'temperatura', 738.0000, 'ºC'),
	(126459, 109, '2015-04-01 00:29:51.000000', 'temperatura', 643.0000, 'ºC'),
	(126460, 109, '2015-04-01 00:29:52.000000', 'temperatura', 1003.0000, 'ºC'),
	(126461, 109, '2015-04-01 00:29:53.000000', 'temperatura', 689.0000, 'ºC'),
	(126462, 109, '2015-04-01 00:29:54.000000', 'temperatura', 433.0000, 'ºC'),
	(126463, 109, '2015-04-01 00:29:55.000000', 'temperatura', 98.0000, 'ºC'),
	(126464, 109, '2015-04-01 00:29:56.000000', 'temperatura', 392.0000, 'ºC'),
	(126465, 109, '2015-04-01 00:29:57.000000', 'temperatura', 467.0000, 'ºC'),
	(126466, 109, '2015-04-01 00:29:58.000000', 'temperatura', 1161.0000, 'ºC'),
	(126467, 109, '2015-04-01 00:29:59.000000', 'temperatura', 804.0000, 'ºC'),
	(126468, 109, '2015-04-01 00:30:00.000000', 'temperatura', 537.0000, 'ºC'),
	(126469, 109, '2015-04-01 00:30:01.000000', 'temperatura', 272.0000, 'ºC'),
	(126470, 109, '2015-04-01 00:30:02.000000', 'temperatura', 951.0000, 'ºC'),
	(126471, 109, '2015-04-01 00:30:03.000000', 'temperatura', 338.0000, 'ºC'),
	(126472, 109, '2015-04-01 00:30:04.000000', 'temperatura', 40.0000, 'ºC'),
	(126473, 109, '2015-04-01 00:30:05.000000', 'temperatura', 385.0000, 'ºC'),
	(126474, 109, '2015-04-01 00:30:06.000000', 'temperatura', 604.0000, 'ºC'),
	(126475, 109, '2015-04-01 00:30:07.000000', 'temperatura', 667.0000, 'ºC'),
	(126476, 109, '2015-04-01 00:30:08.000000', 'temperatura', 324.0000, 'ºC'),
	(126477, 109, '2015-04-01 00:30:09.000000', 'temperatura', 819.0000, 'ºC'),
	(126478, 109, '2015-04-01 00:30:10.000000', 'temperatura', 723.0000, 'ºC'),
	(126479, 109, '2015-04-01 00:30:11.000000', 'temperatura', 1161.0000, 'ºC'),
	(126480, 109, '2015-04-01 00:30:12.000000', 'temperatura', 35.0000, 'ºC'),
	(126481, 109, '2015-04-01 00:30:13.000000', 'temperatura', 292.0000, 'ºC'),
	(126482, 109, '2015-04-01 00:30:14.000000', 'temperatura', 156.0000, 'ºC'),
	(126483, 109, '2015-04-01 00:30:15.000000', 'temperatura', 1103.0000, 'ºC'),
	(126484, 109, '2015-04-01 00:30:16.000000', 'temperatura', 249.0000, 'ºC'),
	(126485, 109, '2015-04-01 00:30:17.000000', 'temperatura', 334.0000, 'ºC'),
	(126486, 109, '2015-04-01 00:30:18.000000', 'temperatura', 927.0000, 'ºC'),
	(126487, 109, '2015-04-01 00:30:19.000000', 'temperatura', 30.0000, 'ºC'),
	(126488, 109, '2015-04-01 00:30:20.000000', 'temperatura', 971.0000, 'ºC'),
	(126489, 109, '2015-04-01 00:30:21.000000', 'temperatura', 1165.0000, 'ºC'),
	(126490, 109, '2015-04-01 00:30:22.000000', 'temperatura', 512.0000, 'ºC'),
	(126491, 109, '2015-04-01 00:30:23.000000', 'temperatura', 266.0000, 'ºC'),
	(126492, 109, '2015-04-01 00:30:24.000000', 'temperatura', 993.0000, 'ºC'),
	(126493, 109, '2015-04-01 00:30:25.000000', 'temperatura', 567.0000, 'ºC'),
	(126494, 109, '2015-04-01 00:30:26.000000', 'temperatura', 1058.0000, 'ºC'),
	(126495, 109, '2015-04-01 00:30:27.000000', 'temperatura', 1189.0000, 'ºC'),
	(126496, 109, '2015-04-01 00:30:28.000000', 'temperatura', 370.0000, 'ºC'),
	(126497, 109, '2015-04-01 00:30:29.000000', 'temperatura', 683.0000, 'ºC'),
	(126498, 109, '2015-04-01 00:30:30.000000', 'temperatura', 1108.0000, 'ºC'),
	(126499, 109, '2015-04-01 00:30:31.000000', 'temperatura', 1090.0000, 'ºC'),
	(126500, 109, '2015-04-01 00:30:32.000000', 'temperatura', 927.0000, 'ºC'),
	(126501, 109, '2015-04-01 00:30:33.000000', 'temperatura', 166.0000, 'ºC'),
	(126502, 109, '2015-04-01 00:30:34.000000', 'temperatura', 447.0000, 'ºC'),
	(126503, 109, '2015-04-01 00:30:35.000000', 'temperatura', 540.0000, 'ºC'),
	(126504, 109, '2015-04-01 00:30:36.000000', 'temperatura', 160.0000, 'ºC'),
	(126505, 109, '2015-04-01 00:30:37.000000', 'temperatura', 380.0000, 'ºC'),
	(126506, 109, '2015-04-01 00:30:38.000000', 'temperatura', 220.0000, 'ºC'),
	(126507, 109, '2015-04-01 00:30:39.000000', 'temperatura', 1159.0000, 'ºC'),
	(126508, 109, '2015-04-01 00:30:40.000000', 'temperatura', 335.0000, 'ºC'),
	(126509, 109, '2015-04-01 00:30:41.000000', 'temperatura', 599.0000, 'ºC'),
	(126510, 109, '2015-04-01 00:30:42.000000', 'temperatura', 791.0000, 'ºC'),
	(126511, 109, '2015-04-01 00:30:43.000000', 'temperatura', 959.0000, 'ºC'),
	(126512, 109, '2015-04-01 00:30:44.000000', 'temperatura', 23.0000, 'ºC'),
	(126513, 109, '2015-04-01 00:30:45.000000', 'temperatura', 838.0000, 'ºC'),
	(126514, 109, '2015-04-01 00:30:46.000000', 'temperatura', 522.0000, 'ºC'),
	(126515, 109, '2015-04-01 00:30:47.000000', 'temperatura', 96.0000, 'ºC'),
	(126516, 109, '2015-04-01 00:30:48.000000', 'temperatura', 112.0000, 'ºC'),
	(126517, 109, '2015-04-01 00:30:49.000000', 'temperatura', 276.0000, 'ºC'),
	(126518, 109, '2015-04-01 00:30:50.000000', 'temperatura', 1045.0000, 'ºC'),
	(126519, 109, '2015-04-01 00:30:51.000000', 'temperatura', 794.0000, 'ºC'),
	(126520, 109, '2015-04-01 00:30:52.000000', 'temperatura', 838.0000, 'ºC'),
	(126521, 109, '2015-04-01 00:30:53.000000', 'temperatura', 609.0000, 'ºC'),
	(126522, 109, '2015-04-01 00:30:54.000000', 'temperatura', 532.0000, 'ºC'),
	(126523, 109, '2015-04-01 00:30:55.000000', 'temperatura', 831.0000, 'ºC'),
	(126524, 109, '2015-04-01 00:30:56.000000', 'temperatura', 161.0000, 'ºC'),
	(126525, 109, '2015-04-01 00:30:57.000000', 'temperatura', 711.0000, 'ºC'),
	(126526, 109, '2015-04-01 00:30:58.000000', 'temperatura', 673.0000, 'ºC'),
	(126527, 109, '2015-04-01 00:30:59.000000', 'temperatura', 31.0000, 'ºC'),
	(126528, 109, '2015-04-01 00:31:00.000000', 'temperatura', 539.0000, 'ºC'),
	(126529, 109, '2015-04-01 00:31:01.000000', 'temperatura', 204.0000, 'ºC'),
	(126530, 109, '2015-04-01 00:31:02.000000', 'temperatura', 600.0000, 'ºC'),
	(126531, 109, '2015-04-01 00:31:03.000000', 'temperatura', 1191.0000, 'ºC'),
	(126532, 109, '2015-04-01 00:31:04.000000', 'temperatura', 554.0000, 'ºC'),
	(126533, 109, '2015-04-01 00:31:05.000000', 'temperatura', 398.0000, 'ºC'),
	(126534, 109, '2015-04-01 00:31:06.000000', 'temperatura', 329.0000, 'ºC'),
	(126535, 109, '2015-04-01 00:31:07.000000', 'temperatura', 453.0000, 'ºC'),
	(126536, 109, '2015-04-01 00:31:08.000000', 'temperatura', 78.0000, 'ºC'),
	(126537, 109, '2015-04-01 00:31:09.000000', 'temperatura', 232.0000, 'ºC'),
	(126538, 109, '2015-04-01 00:31:10.000000', 'temperatura', 925.0000, 'ºC'),
	(126539, 109, '2015-04-01 00:31:11.000000', 'temperatura', 332.0000, 'ºC'),
	(126540, 109, '2015-04-01 00:31:12.000000', 'temperatura', 85.0000, 'ºC'),
	(126541, 109, '2015-04-01 00:31:13.000000', 'temperatura', 627.0000, 'ºC'),
	(126542, 109, '2015-04-01 00:31:14.000000', 'temperatura', 481.0000, 'ºC'),
	(126543, 109, '2015-04-01 00:31:15.000000', 'temperatura', 527.0000, 'ºC'),
	(126544, 109, '2015-04-01 00:31:16.000000', 'temperatura', 1189.0000, 'ºC'),
	(126545, 109, '2015-04-01 00:31:17.000000', 'temperatura', 768.0000, 'ºC'),
	(126546, 109, '2015-04-01 00:31:18.000000', 'temperatura', 270.0000, 'ºC'),
	(126547, 109, '2015-04-01 00:31:19.000000', 'temperatura', 248.0000, 'ºC'),
	(126548, 109, '2015-04-01 00:31:20.000000', 'temperatura', 431.0000, 'ºC'),
	(126549, 109, '2015-04-01 00:31:21.000000', 'temperatura', 211.0000, 'ºC'),
	(126550, 109, '2015-04-01 00:31:22.000000', 'temperatura', 962.0000, 'ºC'),
	(126551, 109, '2015-04-01 00:31:23.000000', 'temperatura', 577.0000, 'ºC'),
	(126552, 109, '2015-04-01 00:31:24.000000', 'temperatura', 1198.0000, 'ºC'),
	(126553, 109, '2015-04-01 00:31:25.000000', 'temperatura', 662.0000, 'ºC'),
	(126554, 109, '2015-04-01 00:31:26.000000', 'temperatura', 914.0000, 'ºC'),
	(126555, 109, '2015-04-01 00:31:27.000000', 'temperatura', 187.0000, 'ºC'),
	(126556, 109, '2015-04-01 00:31:28.000000', 'temperatura', 594.0000, 'ºC'),
	(126557, 109, '2015-04-01 00:31:29.000000', 'temperatura', 9.0000, 'ºC'),
	(126558, 109, '2015-04-01 00:31:30.000000', 'temperatura', 662.0000, 'ºC'),
	(126559, 109, '2015-04-01 00:31:31.000000', 'temperatura', 883.0000, 'ºC'),
	(126560, 109, '2015-04-01 00:31:32.000000', 'temperatura', 31.0000, 'ºC'),
	(126561, 109, '2015-04-01 00:31:33.000000', 'temperatura', 1105.0000, 'ºC'),
	(126562, 109, '2015-04-01 00:31:34.000000', 'temperatura', 632.0000, 'ºC'),
	(126563, 109, '2015-04-01 00:31:35.000000', 'temperatura', 1045.0000, 'ºC'),
	(126564, 109, '2015-04-01 00:31:36.000000', 'temperatura', 931.0000, 'ºC'),
	(126565, 109, '2015-04-01 00:31:37.000000', 'temperatura', 319.0000, 'ºC'),
	(126566, 109, '2015-04-01 00:31:38.000000', 'temperatura', 2.0000, 'ºC'),
	(126567, 109, '2015-04-01 00:31:39.000000', 'temperatura', 253.0000, 'ºC'),
	(126568, 109, '2015-04-01 00:31:40.000000', 'temperatura', 60.0000, 'ºC'),
	(126569, 109, '2015-04-01 00:31:41.000000', 'temperatura', 741.0000, 'ºC'),
	(126570, 109, '2015-04-01 00:31:42.000000', 'temperatura', 1124.0000, 'ºC'),
	(126571, 109, '2015-04-01 00:31:43.000000', 'temperatura', 1001.0000, 'ºC'),
	(126572, 109, '2015-04-01 00:31:44.000000', 'temperatura', 430.0000, 'ºC'),
	(126573, 109, '2015-04-01 00:31:45.000000', 'temperatura', 350.0000, 'ºC'),
	(126574, 109, '2015-04-01 00:31:46.000000', 'temperatura', 462.0000, 'ºC'),
	(126575, 109, '2015-04-01 00:31:47.000000', 'temperatura', 57.0000, 'ºC'),
	(126576, 109, '2015-04-01 00:31:48.000000', 'temperatura', 101.0000, 'ºC'),
	(126577, 109, '2015-04-01 00:31:49.000000', 'temperatura', 335.0000, 'ºC'),
	(126578, 109, '2015-04-01 00:31:50.000000', 'temperatura', 171.0000, 'ºC'),
	(126579, 109, '2015-04-01 00:31:51.000000', 'temperatura', 1049.0000, 'ºC'),
	(126580, 109, '2015-04-01 00:31:52.000000', 'temperatura', 1136.0000, 'ºC'),
	(126581, 109, '2015-04-01 00:31:53.000000', 'temperatura', 132.0000, 'ºC'),
	(126582, 109, '2015-04-01 00:31:54.000000', 'temperatura', 853.0000, 'ºC'),
	(126583, 109, '2015-04-01 00:31:55.000000', 'temperatura', 271.0000, 'ºC'),
	(126584, 109, '2015-04-01 00:31:56.000000', 'temperatura', 1194.0000, 'ºC'),
	(126585, 109, '2015-04-01 00:31:57.000000', 'temperatura', 358.0000, 'ºC'),
	(126586, 109, '2015-04-01 00:31:58.000000', 'temperatura', 607.0000, 'ºC'),
	(126587, 109, '2015-04-01 00:31:59.000000', 'temperatura', 763.0000, 'ºC'),
	(126588, 109, '2015-04-01 00:32:00.000000', 'temperatura', 795.0000, 'ºC'),
	(126589, 109, '2015-04-01 00:32:01.000000', 'temperatura', 485.0000, 'ºC'),
	(126590, 109, '2015-04-01 00:32:02.000000', 'temperatura', 39.0000, 'ºC'),
	(126591, 109, '2015-04-01 00:32:03.000000', 'temperatura', 1144.0000, 'ºC'),
	(126592, 109, '2015-04-01 00:32:04.000000', 'temperatura', 802.0000, 'ºC'),
	(126593, 109, '2015-04-01 00:32:05.000000', 'temperatura', 577.0000, 'ºC'),
	(126594, 109, '2015-04-01 00:32:06.000000', 'temperatura', 478.0000, 'ºC'),
	(126595, 109, '2015-04-01 00:32:07.000000', 'temperatura', 663.0000, 'ºC'),
	(126596, 109, '2015-04-01 00:32:08.000000', 'temperatura', 682.0000, 'ºC'),
	(126597, 109, '2015-04-01 00:32:09.000000', 'temperatura', 220.0000, 'ºC'),
	(126598, 109, '2015-04-01 00:32:10.000000', 'temperatura', 253.0000, 'ºC'),
	(126599, 109, '2015-04-01 00:32:11.000000', 'temperatura', 605.0000, 'ºC'),
	(126600, 109, '2015-04-01 00:32:12.000000', 'temperatura', 1068.0000, 'ºC'),
	(126601, 109, '2015-04-01 00:32:13.000000', 'temperatura', 1125.0000, 'ºC'),
	(126602, 109, '2015-04-01 00:32:14.000000', 'temperatura', 20.0000, 'ºC'),
	(126603, 109, '2015-04-01 00:32:15.000000', 'temperatura', 328.0000, 'ºC'),
	(126604, 109, '2015-04-01 00:32:16.000000', 'temperatura', 381.0000, 'ºC'),
	(126605, 109, '2015-04-01 00:32:17.000000', 'temperatura', 920.0000, 'ºC'),
	(126606, 109, '2015-04-01 00:32:18.000000', 'temperatura', 1057.0000, 'ºC'),
	(126607, 109, '2015-04-01 00:32:19.000000', 'temperatura', 127.0000, 'ºC'),
	(126608, 109, '2015-04-01 00:32:20.000000', 'temperatura', 1063.0000, 'ºC'),
	(126609, 109, '2015-04-01 00:32:21.000000', 'temperatura', 135.0000, 'ºC'),
	(126610, 109, '2015-04-01 00:32:22.000000', 'temperatura', 1086.0000, 'ºC'),
	(126611, 109, '2015-04-01 00:32:23.000000', 'temperatura', 227.0000, 'ºC'),
	(126612, 109, '2015-04-01 00:32:24.000000', 'temperatura', 278.0000, 'ºC'),
	(126613, 109, '2015-04-01 00:32:25.000000', 'temperatura', 708.0000, 'ºC'),
	(126614, 109, '2015-04-01 00:32:26.000000', 'temperatura', 308.0000, 'ºC'),
	(126615, 109, '2015-04-01 00:32:27.000000', 'temperatura', 618.0000, 'ºC'),
	(126616, 109, '2015-04-01 00:32:28.000000', 'temperatura', 963.0000, 'ºC'),
	(126617, 109, '2015-04-01 00:32:29.000000', 'temperatura', 563.0000, 'ºC'),
	(126618, 109, '2015-04-01 00:32:30.000000', 'temperatura', 1124.0000, 'ºC'),
	(126619, 109, '2015-04-01 00:32:31.000000', 'temperatura', 335.0000, 'ºC'),
	(126620, 109, '2015-04-01 00:32:32.000000', 'temperatura', 701.0000, 'ºC'),
	(126621, 109, '2015-04-01 00:32:33.000000', 'temperatura', 101.0000, 'ºC'),
	(126622, 109, '2015-04-01 00:32:34.000000', 'temperatura', 805.0000, 'ºC'),
	(126623, 109, '2015-04-01 00:32:35.000000', 'temperatura', 120.0000, 'ºC'),
	(126624, 109, '2015-04-01 00:32:36.000000', 'temperatura', 585.0000, 'ºC'),
	(126625, 109, '2015-04-01 00:32:37.000000', 'temperatura', 164.0000, 'ºC'),
	(126626, 109, '2015-04-01 00:32:38.000000', 'temperatura', 268.0000, 'ºC'),
	(126627, 109, '2015-04-01 00:32:39.000000', 'temperatura', 848.0000, 'ºC'),
	(126628, 109, '2015-04-01 00:32:40.000000', 'temperatura', 1036.0000, 'ºC'),
	(126629, 109, '2015-04-01 00:32:41.000000', 'temperatura', 236.0000, 'ºC'),
	(126630, 109, '2015-04-01 00:32:42.000000', 'temperatura', 471.0000, 'ºC'),
	(126631, 109, '2015-04-01 00:32:43.000000', 'temperatura', 451.0000, 'ºC'),
	(126632, 109, '2015-04-01 00:32:44.000000', 'temperatura', 841.0000, 'ºC'),
	(126633, 109, '2015-04-01 00:32:45.000000', 'temperatura', 452.0000, 'ºC'),
	(126634, 109, '2015-04-01 00:32:46.000000', 'temperatura', 940.0000, 'ºC'),
	(126635, 109, '2015-04-01 00:32:47.000000', 'temperatura', 942.0000, 'ºC'),
	(126636, 109, '2015-04-01 00:32:48.000000', 'temperatura', 690.0000, 'ºC'),
	(126637, 109, '2015-04-01 00:32:49.000000', 'temperatura', 627.0000, 'ºC'),
	(126638, 109, '2015-04-01 00:32:50.000000', 'temperatura', 1066.0000, 'ºC'),
	(126639, 109, '2015-04-01 00:32:51.000000', 'temperatura', 1048.0000, 'ºC'),
	(126640, 109, '2015-04-01 00:32:52.000000', 'temperatura', 843.0000, 'ºC'),
	(126641, 109, '2015-04-01 00:32:53.000000', 'temperatura', 1073.0000, 'ºC'),
	(126642, 109, '2015-04-01 00:32:54.000000', 'temperatura', 436.0000, 'ºC'),
	(126643, 109, '2015-04-01 00:32:55.000000', 'temperatura', 160.0000, 'ºC'),
	(126644, 109, '2015-04-01 00:32:56.000000', 'temperatura', 692.0000, 'ºC'),
	(126645, 109, '2015-04-01 00:32:57.000000', 'temperatura', 582.0000, 'ºC'),
	(126646, 109, '2015-04-01 00:32:58.000000', 'temperatura', 836.0000, 'ºC'),
	(126647, 109, '2015-04-01 00:32:59.000000', 'temperatura', 33.0000, 'ºC'),
	(126648, 109, '2015-04-01 00:33:00.000000', 'temperatura', 57.0000, 'ºC'),
	(126649, 109, '2015-04-01 00:33:01.000000', 'temperatura', 186.0000, 'ºC'),
	(126650, 109, '2015-04-01 00:33:02.000000', 'temperatura', 762.0000, 'ºC'),
	(126651, 109, '2015-04-01 00:33:03.000000', 'temperatura', 849.0000, 'ºC'),
	(126652, 109, '2015-04-01 00:33:04.000000', 'temperatura', 762.0000, 'ºC'),
	(126653, 109, '2015-04-01 00:33:05.000000', 'temperatura', 64.0000, 'ºC'),
	(126654, 109, '2015-04-01 00:33:06.000000', 'temperatura', 432.0000, 'ºC'),
	(126655, 109, '2015-04-01 00:33:07.000000', 'temperatura', 770.0000, 'ºC'),
	(126656, 109, '2015-04-01 00:33:08.000000', 'temperatura', 155.0000, 'ºC'),
	(126657, 109, '2015-04-01 00:33:09.000000', 'temperatura', 865.0000, 'ºC'),
	(126658, 109, '2015-04-01 00:33:10.000000', 'temperatura', 260.0000, 'ºC'),
	(126659, 109, '2015-04-01 00:33:11.000000', 'temperatura', 1107.0000, 'ºC'),
	(126660, 109, '2015-04-01 00:33:12.000000', 'temperatura', 1154.0000, 'ºC'),
	(126661, 109, '2015-04-01 00:33:13.000000', 'temperatura', 49.0000, 'ºC'),
	(126662, 109, '2015-04-01 00:33:14.000000', 'temperatura', 385.0000, 'ºC'),
	(126663, 109, '2015-04-01 00:33:15.000000', 'temperatura', 578.0000, 'ºC'),
	(126664, 109, '2015-04-01 00:33:16.000000', 'temperatura', 535.0000, 'ºC'),
	(126665, 109, '2015-04-01 00:33:17.000000', 'temperatura', 941.0000, 'ºC'),
	(126666, 109, '2015-04-01 00:33:18.000000', 'temperatura', 703.0000, 'ºC'),
	(126667, 109, '2015-04-01 00:33:19.000000', 'temperatura', 692.0000, 'ºC'),
	(126668, 109, '2015-04-01 00:33:20.000000', 'temperatura', 150.0000, 'ºC'),
	(126669, 109, '2015-04-01 00:33:21.000000', 'temperatura', 1074.0000, 'ºC'),
	(126670, 109, '2015-04-01 00:33:22.000000', 'temperatura', 120.0000, 'ºC'),
	(126671, 109, '2015-04-01 00:33:23.000000', 'temperatura', 977.0000, 'ºC'),
	(126672, 109, '2015-04-01 00:33:24.000000', 'temperatura', 929.0000, 'ºC'),
	(126673, 109, '2015-04-01 00:33:25.000000', 'temperatura', 513.0000, 'ºC'),
	(126674, 109, '2015-04-01 00:33:26.000000', 'temperatura', 977.0000, 'ºC'),
	(126675, 109, '2015-04-01 00:33:27.000000', 'temperatura', 947.0000, 'ºC'),
	(126676, 109, '2015-04-01 00:33:28.000000', 'temperatura', 603.0000, 'ºC'),
	(126677, 109, '2015-04-01 00:33:29.000000', 'temperatura', 177.0000, 'ºC'),
	(126678, 109, '2015-04-01 00:33:30.000000', 'temperatura', 278.0000, 'ºC'),
	(126679, 109, '2015-04-01 00:33:31.000000', 'temperatura', 857.0000, 'ºC'),
	(126680, 109, '2015-04-01 00:33:32.000000', 'temperatura', 1052.0000, 'ºC'),
	(126681, 109, '2015-04-01 00:33:33.000000', 'temperatura', 288.0000, 'ºC'),
	(126682, 109, '2015-04-01 00:33:34.000000', 'temperatura', 685.0000, 'ºC'),
	(126683, 109, '2015-04-01 00:33:35.000000', 'temperatura', 160.0000, 'ºC'),
	(126684, 109, '2015-04-01 00:33:36.000000', 'temperatura', 1147.0000, 'ºC'),
	(126685, 109, '2015-04-01 00:33:37.000000', 'temperatura', 455.0000, 'ºC'),
	(126686, 109, '2015-04-01 00:33:38.000000', 'temperatura', 34.0000, 'ºC'),
	(126687, 109, '2015-04-01 00:33:39.000000', 'temperatura', 5.0000, 'ºC'),
	(126688, 109, '2015-04-01 00:33:40.000000', 'temperatura', 1123.0000, 'ºC'),
	(126689, 109, '2015-04-01 00:33:41.000000', 'temperatura', 801.0000, 'ºC'),
	(126690, 109, '2015-04-01 00:33:42.000000', 'temperatura', 637.0000, 'ºC'),
	(126691, 109, '2015-04-01 00:33:43.000000', 'temperatura', 781.0000, 'ºC'),
	(126692, 109, '2015-04-01 00:33:44.000000', 'temperatura', 797.0000, 'ºC'),
	(126693, 109, '2015-04-01 00:33:45.000000', 'temperatura', 442.0000, 'ºC'),
	(126694, 109, '2015-04-01 00:33:46.000000', 'temperatura', 1019.0000, 'ºC'),
	(126695, 109, '2015-04-01 00:33:47.000000', 'temperatura', 168.0000, 'ºC'),
	(126696, 109, '2015-04-01 00:33:48.000000', 'temperatura', 183.0000, 'ºC'),
	(126697, 109, '2015-04-01 00:33:49.000000', 'temperatura', 414.0000, 'ºC'),
	(126698, 109, '2015-04-01 00:33:50.000000', 'temperatura', 322.0000, 'ºC'),
	(126699, 109, '2015-04-01 00:33:51.000000', 'temperatura', 366.0000, 'ºC'),
	(126700, 109, '2015-04-01 00:33:52.000000', 'temperatura', 866.0000, 'ºC'),
	(126701, 109, '2015-04-01 00:33:53.000000', 'temperatura', 831.0000, 'ºC'),
	(126702, 109, '2015-04-01 00:33:54.000000', 'temperatura', 360.0000, 'ºC'),
	(126703, 109, '2015-04-01 00:33:55.000000', 'temperatura', 507.0000, 'ºC'),
	(126704, 109, '2015-04-01 00:33:56.000000', 'temperatura', 256.0000, 'ºC'),
	(126705, 109, '2015-04-01 00:33:57.000000', 'temperatura', 960.0000, 'ºC'),
	(126706, 109, '2015-04-01 00:33:58.000000', 'temperatura', 431.0000, 'ºC'),
	(126707, 109, '2015-04-01 00:33:59.000000', 'temperatura', 478.0000, 'ºC'),
	(126708, 109, '2015-04-01 00:34:00.000000', 'temperatura', 1096.0000, 'ºC'),
	(126709, 109, '2015-04-01 00:34:01.000000', 'temperatura', 446.0000, 'ºC'),
	(126710, 109, '2015-04-01 00:34:02.000000', 'temperatura', 144.0000, 'ºC'),
	(126711, 109, '2015-04-01 00:34:03.000000', 'temperatura', 583.0000, 'ºC'),
	(126712, 109, '2015-04-01 00:34:04.000000', 'temperatura', 82.0000, 'ºC'),
	(126713, 109, '2015-04-01 00:34:05.000000', 'temperatura', 1061.0000, 'ºC'),
	(126714, 109, '2015-04-01 00:34:06.000000', 'temperatura', 259.0000, 'ºC'),
	(126715, 109, '2015-04-01 00:34:07.000000', 'temperatura', 515.0000, 'ºC'),
	(126716, 109, '2015-04-01 00:34:08.000000', 'temperatura', 599.0000, 'ºC'),
	(126717, 109, '2015-04-01 00:34:09.000000', 'temperatura', 248.0000, 'ºC'),
	(126718, 109, '2015-04-01 00:34:10.000000', 'temperatura', 646.0000, 'ºC'),
	(126719, 109, '2015-04-01 00:34:11.000000', 'temperatura', 87.0000, 'ºC'),
	(126720, 109, '2015-04-01 00:34:12.000000', 'temperatura', 899.0000, 'ºC'),
	(126721, 109, '2015-04-01 00:34:13.000000', 'temperatura', 631.0000, 'ºC'),
	(126722, 109, '2015-04-01 00:34:14.000000', 'temperatura', 458.0000, 'ºC'),
	(126723, 109, '2015-04-01 00:34:15.000000', 'temperatura', 398.0000, 'ºC'),
	(126724, 109, '2015-04-01 00:34:16.000000', 'temperatura', 616.0000, 'ºC'),
	(126725, 109, '2015-04-01 00:34:17.000000', 'temperatura', 689.0000, 'ºC'),
	(126726, 109, '2015-04-01 00:34:18.000000', 'temperatura', 395.0000, 'ºC'),
	(126727, 109, '2015-04-01 00:34:19.000000', 'temperatura', 1107.0000, 'ºC'),
	(126728, 109, '2015-04-01 00:34:20.000000', 'temperatura', 753.0000, 'ºC'),
	(126729, 109, '2015-04-01 00:34:21.000000', 'temperatura', 445.0000, 'ºC'),
	(126730, 109, '2015-04-01 00:34:22.000000', 'temperatura', 1166.0000, 'ºC'),
	(126731, 109, '2015-04-01 00:34:23.000000', 'temperatura', 895.0000, 'ºC'),
	(126732, 109, '2015-04-01 00:34:24.000000', 'temperatura', 977.0000, 'ºC'),
	(126733, 109, '2015-04-01 00:34:25.000000', 'temperatura', 1000.0000, 'ºC'),
	(126734, 109, '2015-04-01 00:34:26.000000', 'temperatura', 872.0000, 'ºC'),
	(126735, 109, '2015-04-01 00:34:27.000000', 'temperatura', 159.0000, 'ºC'),
	(126736, 109, '2015-04-01 00:34:28.000000', 'temperatura', 581.0000, 'ºC'),
	(126737, 109, '2015-04-01 00:34:29.000000', 'temperatura', 30.0000, 'ºC'),
	(126738, 109, '2015-04-01 00:34:30.000000', 'temperatura', 804.0000, 'ºC'),
	(126739, 109, '2015-04-01 00:34:31.000000', 'temperatura', 332.0000, 'ºC'),
	(126740, 109, '2015-04-01 00:34:32.000000', 'temperatura', 450.0000, 'ºC'),
	(126741, 109, '2015-04-01 00:34:33.000000', 'temperatura', 54.0000, 'ºC'),
	(126742, 109, '2015-04-01 00:34:34.000000', 'temperatura', 118.0000, 'ºC'),
	(126743, 109, '2015-04-01 00:34:35.000000', 'temperatura', 430.0000, 'ºC'),
	(126744, 109, '2015-04-01 00:34:36.000000', 'temperatura', 596.0000, 'ºC'),
	(126745, 109, '2015-04-01 00:34:37.000000', 'temperatura', 489.0000, 'ºC'),
	(126746, 109, '2015-04-01 00:34:38.000000', 'temperatura', 660.0000, 'ºC'),
	(126747, 109, '2015-04-01 00:34:39.000000', 'temperatura', 632.0000, 'ºC'),
	(126748, 109, '2015-04-01 00:34:40.000000', 'temperatura', 1180.0000, 'ºC'),
	(126749, 109, '2015-04-01 00:34:41.000000', 'temperatura', 404.0000, 'ºC'),
	(126750, 109, '2015-04-01 00:34:42.000000', 'temperatura', 882.0000, 'ºC'),
	(126751, 109, '2015-04-01 00:34:43.000000', 'temperatura', 799.0000, 'ºC'),
	(126752, 109, '2015-04-01 00:34:44.000000', 'temperatura', 150.0000, 'ºC'),
	(126753, 109, '2015-04-01 00:34:45.000000', 'temperatura', 752.0000, 'ºC'),
	(126754, 109, '2015-04-01 00:34:46.000000', 'temperatura', 912.0000, 'ºC'),
	(126755, 109, '2015-04-01 00:34:47.000000', 'temperatura', 1104.0000, 'ºC'),
	(126756, 109, '2015-04-01 00:34:48.000000', 'temperatura', 384.0000, 'ºC'),
	(126757, 109, '2015-04-01 00:34:49.000000', 'temperatura', 1007.0000, 'ºC'),
	(126758, 109, '2015-04-01 00:34:50.000000', 'temperatura', 284.0000, 'ºC'),
	(126759, 109, '2015-04-01 00:34:51.000000', 'temperatura', 801.0000, 'ºC'),
	(126760, 109, '2015-04-01 00:34:52.000000', 'temperatura', 753.0000, 'ºC'),
	(126761, 109, '2015-04-01 00:34:53.000000', 'temperatura', 161.0000, 'ºC'),
	(126762, 109, '2015-04-01 00:34:54.000000', 'temperatura', 950.0000, 'ºC'),
	(126763, 109, '2015-04-01 00:34:55.000000', 'temperatura', 664.0000, 'ºC'),
	(126764, 109, '2015-04-01 00:34:56.000000', 'temperatura', 471.0000, 'ºC'),
	(126765, 109, '2015-04-01 00:34:57.000000', 'temperatura', 364.0000, 'ºC'),
	(126766, 109, '2015-04-01 00:34:58.000000', 'temperatura', 407.0000, 'ºC'),
	(126767, 109, '2015-04-01 00:34:59.000000', 'temperatura', 944.0000, 'ºC'),
	(126768, 109, '2015-04-01 00:35:00.000000', 'temperatura', 1101.0000, 'ºC'),
	(126769, 109, '2015-04-01 00:35:01.000000', 'temperatura', 272.0000, 'ºC'),
	(126770, 109, '2015-04-01 00:35:02.000000', 'temperatura', 457.0000, 'ºC'),
	(126771, 109, '2015-04-01 00:35:03.000000', 'temperatura', 271.0000, 'ºC'),
	(126772, 109, '2015-04-01 00:35:04.000000', 'temperatura', 1182.0000, 'ºC'),
	(126773, 109, '2015-04-01 00:35:05.000000', 'temperatura', 298.0000, 'ºC'),
	(126774, 109, '2015-04-01 00:35:06.000000', 'temperatura', 345.0000, 'ºC'),
	(126775, 109, '2015-04-01 00:35:07.000000', 'temperatura', 831.0000, 'ºC'),
	(126776, 109, '2015-04-01 00:35:08.000000', 'temperatura', 723.0000, 'ºC'),
	(126777, 109, '2015-04-01 00:35:09.000000', 'temperatura', 1119.0000, 'ºC'),
	(126778, 109, '2015-04-01 00:35:10.000000', 'temperatura', 1030.0000, 'ºC'),
	(126779, 109, '2015-04-01 00:35:11.000000', 'temperatura', 590.0000, 'ºC'),
	(126780, 109, '2015-04-01 00:35:12.000000', 'temperatura', 1063.0000, 'ºC'),
	(126781, 109, '2015-04-01 00:35:13.000000', 'temperatura', 1144.0000, 'ºC'),
	(126782, 109, '2015-04-01 00:35:14.000000', 'temperatura', 133.0000, 'ºC'),
	(126783, 109, '2015-04-01 00:35:15.000000', 'temperatura', 831.0000, 'ºC'),
	(126784, 109, '2015-04-01 00:35:16.000000', 'temperatura', 156.0000, 'ºC'),
	(126785, 109, '2015-04-01 00:35:17.000000', 'temperatura', 690.0000, 'ºC'),
	(126786, 109, '2015-04-01 00:35:18.000000', 'temperatura', 583.0000, 'ºC'),
	(126787, 109, '2015-04-01 00:35:19.000000', 'temperatura', 843.0000, 'ºC'),
	(126788, 109, '2015-04-01 00:35:20.000000', 'temperatura', 66.0000, 'ºC'),
	(126789, 109, '2015-04-01 00:35:21.000000', 'temperatura', 204.0000, 'ºC'),
	(126790, 109, '2015-04-01 00:35:22.000000', 'temperatura', 821.0000, 'ºC'),
	(126791, 109, '2015-04-01 00:35:23.000000', 'temperatura', 1094.0000, 'ºC'),
	(126792, 109, '2015-04-01 00:35:24.000000', 'temperatura', 608.0000, 'ºC'),
	(126793, 109, '2015-04-01 00:35:25.000000', 'temperatura', 959.0000, 'ºC'),
	(126794, 109, '2015-04-01 00:35:26.000000', 'temperatura', 570.0000, 'ºC'),
	(126795, 109, '2015-04-01 00:35:27.000000', 'temperatura', 1174.0000, 'ºC'),
	(126796, 109, '2015-04-01 00:35:28.000000', 'temperatura', 560.0000, 'ºC'),
	(126797, 109, '2015-04-01 00:35:29.000000', 'temperatura', 479.0000, 'ºC'),
	(126798, 109, '2015-04-01 00:35:30.000000', 'temperatura', 715.0000, 'ºC'),
	(126799, 109, '2015-04-01 00:35:31.000000', 'temperatura', 940.0000, 'ºC'),
	(126800, 109, '2015-04-01 00:35:32.000000', 'temperatura', 156.0000, 'ºC'),
	(126801, 109, '2015-04-01 00:35:33.000000', 'temperatura', 357.0000, 'ºC'),
	(126802, 109, '2015-04-01 00:35:34.000000', 'temperatura', 121.0000, 'ºC'),
	(126803, 109, '2015-04-01 00:35:35.000000', 'temperatura', 735.0000, 'ºC'),
	(126804, 109, '2015-04-01 00:35:36.000000', 'temperatura', 910.0000, 'ºC'),
	(126805, 109, '2015-04-01 00:35:37.000000', 'temperatura', 1144.0000, 'ºC'),
	(126806, 109, '2015-04-01 00:35:38.000000', 'temperatura', 594.0000, 'ºC'),
	(126807, 109, '2015-04-01 00:35:39.000000', 'temperatura', 738.0000, 'ºC'),
	(126808, 109, '2015-04-01 00:35:40.000000', 'temperatura', 708.0000, 'ºC'),
	(126809, 109, '2015-04-01 00:35:41.000000', 'temperatura', 125.0000, 'ºC'),
	(126810, 109, '2015-04-01 00:35:42.000000', 'temperatura', 904.0000, 'ºC'),
	(126811, 109, '2015-04-01 00:35:43.000000', 'temperatura', 546.0000, 'ºC'),
	(126812, 109, '2015-04-01 00:35:44.000000', 'temperatura', 16.0000, 'ºC'),
	(126813, 109, '2015-04-01 00:35:45.000000', 'temperatura', 845.0000, 'ºC'),
	(126814, 109, '2015-04-01 00:35:46.000000', 'temperatura', 576.0000, 'ºC'),
	(126815, 109, '2015-04-01 00:35:47.000000', 'temperatura', 347.0000, 'ºC'),
	(126816, 109, '2015-04-01 00:35:48.000000', 'temperatura', 5.0000, 'ºC'),
	(126817, 109, '2015-04-01 00:35:49.000000', 'temperatura', 184.0000, 'ºC'),
	(126818, 109, '2015-04-01 00:35:50.000000', 'temperatura', 906.0000, 'ºC'),
	(126819, 109, '2015-04-01 00:35:51.000000', 'temperatura', 381.0000, 'ºC'),
	(126820, 109, '2015-04-01 00:35:52.000000', 'temperatura', 385.0000, 'ºC'),
	(126821, 109, '2015-04-01 00:35:53.000000', 'temperatura', 783.0000, 'ºC'),
	(126822, 109, '2015-04-01 00:35:54.000000', 'temperatura', 362.0000, 'ºC'),
	(126823, 109, '2015-04-01 00:35:55.000000', 'temperatura', 660.0000, 'ºC'),
	(126824, 109, '2015-04-01 00:35:56.000000', 'temperatura', 1014.0000, 'ºC'),
	(126825, 109, '2015-04-01 00:35:57.000000', 'temperatura', 693.0000, 'ºC'),
	(126826, 109, '2015-04-01 00:35:58.000000', 'temperatura', 421.0000, 'ºC'),
	(126827, 109, '2015-04-01 00:35:59.000000', 'temperatura', 27.0000, 'ºC'),
	(126828, 109, '2015-04-01 00:36:00.000000', 'temperatura', 74.0000, 'ºC'),
	(126829, 109, '2015-04-01 00:36:01.000000', 'temperatura', 290.0000, 'ºC'),
	(126830, 109, '2015-04-01 00:36:02.000000', 'temperatura', 29.0000, 'ºC'),
	(126831, 109, '2015-04-01 00:36:03.000000', 'temperatura', 473.0000, 'ºC'),
	(126832, 109, '2015-04-01 00:36:04.000000', 'temperatura', 1080.0000, 'ºC'),
	(126833, 109, '2015-04-01 00:36:05.000000', 'temperatura', 382.0000, 'ºC'),
	(126834, 109, '2015-04-01 00:36:06.000000', 'temperatura', 1069.0000, 'ºC'),
	(126835, 109, '2015-04-01 00:36:07.000000', 'temperatura', 599.0000, 'ºC'),
	(126836, 109, '2015-04-01 00:36:08.000000', 'temperatura', 990.0000, 'ºC'),
	(126837, 109, '2015-04-01 00:36:09.000000', 'temperatura', 753.0000, 'ºC'),
	(126838, 109, '2015-04-01 00:36:10.000000', 'temperatura', 794.0000, 'ºC'),
	(126839, 109, '2015-04-01 00:36:11.000000', 'temperatura', 510.0000, 'ºC'),
	(126840, 109, '2015-04-01 00:36:12.000000', 'temperatura', 172.0000, 'ºC'),
	(126841, 109, '2015-04-01 00:36:13.000000', 'temperatura', 531.0000, 'ºC'),
	(126842, 109, '2015-04-01 00:36:14.000000', 'temperatura', 938.0000, 'ºC'),
	(126843, 109, '2015-04-01 00:36:15.000000', 'temperatura', 697.0000, 'ºC'),
	(126844, 109, '2015-04-01 00:36:16.000000', 'temperatura', 670.0000, 'ºC'),
	(126845, 109, '2015-04-01 00:36:17.000000', 'temperatura', 63.0000, 'ºC'),
	(126846, 109, '2015-04-01 00:36:18.000000', 'temperatura', 703.0000, 'ºC'),
	(126847, 109, '2015-04-01 00:36:19.000000', 'temperatura', 927.0000, 'ºC'),
	(126848, 109, '2015-04-01 00:36:20.000000', 'temperatura', 125.0000, 'ºC'),
	(126849, 109, '2015-04-01 00:36:21.000000', 'temperatura', 247.0000, 'ºC'),
	(126850, 109, '2015-04-01 00:36:22.000000', 'temperatura', 860.0000, 'ºC'),
	(126851, 109, '2015-04-01 00:36:23.000000', 'temperatura', 1161.0000, 'ºC'),
	(126852, 109, '2015-04-01 00:36:24.000000', 'temperatura', 824.0000, 'ºC'),
	(126853, 109, '2015-04-01 00:36:25.000000', 'temperatura', 637.0000, 'ºC'),
	(126854, 109, '2015-04-01 00:36:26.000000', 'temperatura', 716.0000, 'ºC'),
	(126855, 109, '2015-04-01 00:36:27.000000', 'temperatura', 467.0000, 'ºC'),
	(126856, 109, '2015-04-01 00:36:28.000000', 'temperatura', 190.0000, 'ºC'),
	(126857, 109, '2015-04-01 00:36:29.000000', 'temperatura', 749.0000, 'ºC'),
	(126858, 109, '2015-04-01 00:36:30.000000', 'temperatura', 776.0000, 'ºC'),
	(126859, 109, '2015-04-01 00:36:31.000000', 'temperatura', 431.0000, 'ºC'),
	(126860, 109, '2015-04-01 00:36:32.000000', 'temperatura', 1029.0000, 'ºC'),
	(126861, 109, '2015-04-01 00:36:33.000000', 'temperatura', 253.0000, 'ºC'),
	(126862, 109, '2015-04-01 00:36:34.000000', 'temperatura', 579.0000, 'ºC'),
	(126863, 109, '2015-04-01 00:36:35.000000', 'temperatura', 937.0000, 'ºC'),
	(126864, 109, '2015-04-01 00:36:36.000000', 'temperatura', 549.0000, 'ºC'),
	(126865, 109, '2015-04-01 00:36:37.000000', 'temperatura', 1134.0000, 'ºC'),
	(126866, 109, '2015-04-01 00:36:38.000000', 'temperatura', 421.0000, 'ºC'),
	(126867, 109, '2015-04-01 00:36:39.000000', 'temperatura', 1107.0000, 'ºC'),
	(126868, 109, '2015-04-01 00:36:40.000000', 'temperatura', 669.0000, 'ºC'),
	(126869, 109, '2015-04-01 00:36:41.000000', 'temperatura', 28.0000, 'ºC'),
	(126870, 109, '2015-04-01 00:36:42.000000', 'temperatura', 531.0000, 'ºC'),
	(126871, 109, '2015-04-01 00:36:43.000000', 'temperatura', 171.0000, 'ºC'),
	(126872, 109, '2015-04-01 00:36:44.000000', 'temperatura', 464.0000, 'ºC'),
	(126873, 109, '2015-04-01 00:36:45.000000', 'temperatura', 606.0000, 'ºC'),
	(126874, 109, '2015-04-01 00:36:46.000000', 'temperatura', 439.0000, 'ºC'),
	(126875, 109, '2015-04-01 00:36:47.000000', 'temperatura', 379.0000, 'ºC'),
	(126876, 109, '2015-04-01 00:36:48.000000', 'temperatura', 576.0000, 'ºC'),
	(126877, 109, '2015-04-01 00:36:49.000000', 'temperatura', 545.0000, 'ºC'),
	(126878, 109, '2015-04-01 00:36:50.000000', 'temperatura', 999.0000, 'ºC'),
	(126879, 109, '2015-04-01 00:36:51.000000', 'temperatura', 958.0000, 'ºC'),
	(126880, 109, '2015-04-01 00:36:52.000000', 'temperatura', 592.0000, 'ºC'),
	(126881, 109, '2015-04-01 00:36:53.000000', 'temperatura', 90.0000, 'ºC'),
	(126882, 109, '2015-04-01 00:36:54.000000', 'temperatura', 1073.0000, 'ºC'),
	(126883, 109, '2015-04-01 00:36:55.000000', 'temperatura', 294.0000, 'ºC'),
	(126884, 109, '2015-04-01 00:36:56.000000', 'temperatura', 654.0000, 'ºC'),
	(126885, 109, '2015-04-01 00:36:57.000000', 'temperatura', 1188.0000, 'ºC'),
	(126886, 109, '2015-04-01 00:36:58.000000', 'temperatura', 379.0000, 'ºC'),
	(126887, 109, '2015-04-01 00:36:59.000000', 'temperatura', 732.0000, 'ºC'),
	(126888, 109, '2015-04-01 00:37:00.000000', 'temperatura', 122.0000, 'ºC'),
	(126889, 109, '2015-04-01 00:37:01.000000', 'temperatura', 816.0000, 'ºC'),
	(126890, 109, '2015-04-01 00:37:02.000000', 'temperatura', 114.0000, 'ºC'),
	(126891, 109, '2015-04-01 00:37:03.000000', 'temperatura', 523.0000, 'ºC'),
	(126892, 109, '2015-04-01 00:37:04.000000', 'temperatura', 1072.0000, 'ºC'),
	(126893, 109, '2015-04-01 00:37:05.000000', 'temperatura', 192.0000, 'ºC'),
	(126894, 109, '2015-04-01 00:37:06.000000', 'temperatura', 143.0000, 'ºC'),
	(126895, 109, '2015-04-01 00:37:07.000000', 'temperatura', 141.0000, 'ºC'),
	(126896, 109, '2015-04-01 00:37:08.000000', 'temperatura', 275.0000, 'ºC'),
	(126897, 109, '2015-04-01 00:37:09.000000', 'temperatura', 952.0000, 'ºC'),
	(126898, 109, '2015-04-01 00:37:10.000000', 'temperatura', 336.0000, 'ºC'),
	(126899, 109, '2015-04-01 00:37:11.000000', 'temperatura', 23.0000, 'ºC'),
	(126900, 109, '2015-04-01 00:37:12.000000', 'temperatura', 308.0000, 'ºC'),
	(126901, 109, '2015-04-01 00:37:13.000000', 'temperatura', 274.0000, 'ºC'),
	(126902, 109, '2015-04-01 00:37:14.000000', 'temperatura', 445.0000, 'ºC'),
	(126903, 109, '2015-04-01 00:37:15.000000', 'temperatura', 204.0000, 'ºC'),
	(126904, 109, '2015-04-01 00:37:16.000000', 'temperatura', 886.0000, 'ºC'),
	(126905, 109, '2015-04-01 00:37:17.000000', 'temperatura', 218.0000, 'ºC'),
	(126906, 109, '2015-04-01 00:37:18.000000', 'temperatura', 832.0000, 'ºC'),
	(126907, 109, '2015-04-01 00:37:19.000000', 'temperatura', 1108.0000, 'ºC'),
	(126908, 109, '2015-04-01 00:37:20.000000', 'temperatura', 646.0000, 'ºC'),
	(126909, 109, '2015-04-01 00:37:21.000000', 'temperatura', 1104.0000, 'ºC'),
	(126910, 109, '2015-04-01 00:37:22.000000', 'temperatura', 1181.0000, 'ºC'),
	(126911, 109, '2015-04-01 00:37:23.000000', 'temperatura', 195.0000, 'ºC'),
	(126912, 109, '2015-04-01 00:37:24.000000', 'temperatura', 1033.0000, 'ºC'),
	(126913, 109, '2015-04-01 00:37:25.000000', 'temperatura', 979.0000, 'ºC'),
	(126914, 109, '2015-04-01 00:37:26.000000', 'temperatura', 598.0000, 'ºC'),
	(126915, 109, '2015-04-01 00:37:27.000000', 'temperatura', 51.0000, 'ºC'),
	(126916, 109, '2015-04-01 00:37:28.000000', 'temperatura', 862.0000, 'ºC'),
	(126917, 109, '2015-04-01 00:37:29.000000', 'temperatura', 559.0000, 'ºC'),
	(126918, 109, '2015-04-01 00:37:30.000000', 'temperatura', 211.0000, 'ºC'),
	(126919, 109, '2015-04-01 00:37:31.000000', 'temperatura', 577.0000, 'ºC'),
	(126920, 109, '2015-04-01 00:37:32.000000', 'temperatura', 1051.0000, 'ºC'),
	(126921, 109, '2015-04-01 00:37:33.000000', 'temperatura', 1126.0000, 'ºC'),
	(126922, 109, '2015-04-01 00:37:34.000000', 'temperatura', 78.0000, 'ºC'),
	(126923, 109, '2015-04-01 00:37:35.000000', 'temperatura', 613.0000, 'ºC'),
	(126924, 109, '2015-04-01 00:37:36.000000', 'temperatura', 432.0000, 'ºC'),
	(126925, 109, '2015-04-01 00:37:37.000000', 'temperatura', 321.0000, 'ºC'),
	(126926, 109, '2015-04-01 00:37:38.000000', 'temperatura', 310.0000, 'ºC'),
	(126927, 109, '2015-04-01 00:37:39.000000', 'temperatura', 586.0000, 'ºC'),
	(126928, 109, '2015-04-01 00:37:40.000000', 'temperatura', 800.0000, 'ºC'),
	(126929, 109, '2015-04-01 00:37:41.000000', 'temperatura', 1043.0000, 'ºC'),
	(126930, 109, '2015-04-01 00:37:42.000000', 'temperatura', 414.0000, 'ºC'),
	(126931, 109, '2015-04-01 00:37:43.000000', 'temperatura', 142.0000, 'ºC'),
	(126932, 109, '2015-04-01 00:37:44.000000', 'temperatura', 668.0000, 'ºC'),
	(126933, 109, '2015-04-01 00:37:45.000000', 'temperatura', 517.0000, 'ºC'),
	(126934, 109, '2015-04-01 00:37:46.000000', 'temperatura', 580.0000, 'ºC'),
	(126935, 109, '2015-04-01 00:37:47.000000', 'temperatura', 148.0000, 'ºC'),
	(126936, 109, '2015-04-01 00:37:48.000000', 'temperatura', 201.0000, 'ºC'),
	(126937, 109, '2015-04-01 00:37:49.000000', 'temperatura', 561.0000, 'ºC'),
	(126938, 109, '2015-04-01 00:37:50.000000', 'temperatura', 1003.0000, 'ºC'),
	(126939, 109, '2015-04-01 00:37:51.000000', 'temperatura', 934.0000, 'ºC'),
	(126940, 109, '2015-04-01 00:37:52.000000', 'temperatura', 462.0000, 'ºC'),
	(126941, 109, '2015-04-01 00:37:53.000000', 'temperatura', 709.0000, 'ºC'),
	(126942, 109, '2015-04-01 00:37:54.000000', 'temperatura', 960.0000, 'ºC'),
	(126943, 109, '2015-04-01 00:37:55.000000', 'temperatura', 273.0000, 'ºC'),
	(126944, 109, '2015-04-01 00:37:56.000000', 'temperatura', 884.0000, 'ºC'),
	(126945, 109, '2015-04-01 00:37:57.000000', 'temperatura', 0.0000, 'ºC'),
	(126946, 109, '2015-04-01 00:37:58.000000', 'temperatura', 952.0000, 'ºC'),
	(126947, 109, '2015-04-01 00:37:59.000000', 'temperatura', 1160.0000, 'ºC'),
	(126948, 109, '2015-04-01 00:38:00.000000', 'temperatura', 544.0000, 'ºC'),
	(126949, 109, '2015-04-01 00:38:01.000000', 'temperatura', 441.0000, 'ºC'),
	(126950, 109, '2015-04-01 00:38:02.000000', 'temperatura', 573.0000, 'ºC'),
	(126951, 109, '2015-04-01 00:38:03.000000', 'temperatura', 344.0000, 'ºC'),
	(126952, 109, '2015-04-01 00:38:04.000000', 'temperatura', 1199.0000, 'ºC'),
	(126953, 109, '2015-04-01 00:38:05.000000', 'temperatura', 166.0000, 'ºC'),
	(126954, 109, '2015-04-01 00:38:06.000000', 'temperatura', 833.0000, 'ºC'),
	(126955, 109, '2015-04-01 00:38:07.000000', 'temperatura', 69.0000, 'ºC'),
	(126956, 109, '2015-04-01 00:38:08.000000', 'temperatura', 246.0000, 'ºC'),
	(126957, 109, '2015-04-01 00:38:09.000000', 'temperatura', 1023.0000, 'ºC'),
	(126958, 109, '2015-04-01 00:38:10.000000', 'temperatura', 778.0000, 'ºC'),
	(126959, 109, '2015-04-01 00:38:11.000000', 'temperatura', 821.0000, 'ºC'),
	(126960, 109, '2015-04-01 00:38:12.000000', 'temperatura', 573.0000, 'ºC'),
	(126961, 109, '2015-04-01 00:38:13.000000', 'temperatura', 401.0000, 'ºC'),
	(126962, 109, '2015-04-01 00:38:14.000000', 'temperatura', 287.0000, 'ºC'),
	(126963, 109, '2015-04-01 00:38:15.000000', 'temperatura', 233.0000, 'ºC'),
	(126964, 109, '2015-04-01 00:38:16.000000', 'temperatura', 305.0000, 'ºC'),
	(126965, 109, '2015-04-01 00:38:17.000000', 'temperatura', 827.0000, 'ºC'),
	(126966, 109, '2015-04-01 00:38:18.000000', 'temperatura', 821.0000, 'ºC'),
	(126967, 109, '2015-04-01 00:38:19.000000', 'temperatura', 423.0000, 'ºC'),
	(126968, 109, '2015-04-01 00:38:20.000000', 'temperatura', 851.0000, 'ºC'),
	(126969, 109, '2015-04-01 00:38:21.000000', 'temperatura', 589.0000, 'ºC'),
	(126970, 109, '2015-04-01 00:38:22.000000', 'temperatura', 391.0000, 'ºC'),
	(126971, 109, '2015-04-01 00:38:23.000000', 'temperatura', 187.0000, 'ºC'),
	(126972, 109, '2015-04-01 00:38:24.000000', 'temperatura', 966.0000, 'ºC'),
	(126973, 109, '2015-04-01 00:38:25.000000', 'temperatura', 666.0000, 'ºC'),
	(126974, 109, '2015-04-01 00:38:26.000000', 'temperatura', 436.0000, 'ºC'),
	(126975, 109, '2015-04-01 00:38:27.000000', 'temperatura', 181.0000, 'ºC'),
	(126976, 109, '2015-04-01 00:38:28.000000', 'temperatura', 796.0000, 'ºC'),
	(126977, 109, '2015-04-01 00:38:29.000000', 'temperatura', 1040.0000, 'ºC'),
	(126978, 109, '2015-04-01 00:38:30.000000', 'temperatura', 412.0000, 'ºC'),
	(126979, 109, '2015-04-01 00:38:31.000000', 'temperatura', 142.0000, 'ºC'),
	(126980, 109, '2015-04-01 00:38:32.000000', 'temperatura', 674.0000, 'ºC'),
	(126981, 109, '2015-04-01 00:38:33.000000', 'temperatura', 544.0000, 'ºC'),
	(126982, 109, '2015-04-01 00:38:34.000000', 'temperatura', 698.0000, 'ºC'),
	(126983, 109, '2015-04-01 00:38:35.000000', 'temperatura', 659.0000, 'ºC'),
	(126984, 109, '2015-04-01 00:38:36.000000', 'temperatura', 3.0000, 'ºC'),
	(126985, 109, '2015-04-01 00:38:37.000000', 'temperatura', 436.0000, 'ºC'),
	(126986, 109, '2015-04-01 00:38:38.000000', 'temperatura', 973.0000, 'ºC'),
	(126987, 109, '2015-04-01 00:38:39.000000', 'temperatura', 1159.0000, 'ºC'),
	(126988, 109, '2015-04-01 00:38:40.000000', 'temperatura', 474.0000, 'ºC'),
	(126989, 109, '2015-04-01 00:38:41.000000', 'temperatura', 96.0000, 'ºC'),
	(126990, 109, '2015-04-01 00:38:42.000000', 'temperatura', 257.0000, 'ºC'),
	(126991, 109, '2015-04-01 00:38:43.000000', 'temperatura', 997.0000, 'ºC'),
	(126992, 109, '2015-04-01 00:38:44.000000', 'temperatura', 617.0000, 'ºC'),
	(126993, 109, '2015-04-01 00:38:45.000000', 'temperatura', 92.0000, 'ºC'),
	(126994, 109, '2015-04-01 00:38:46.000000', 'temperatura', 1011.0000, 'ºC'),
	(126995, 109, '2015-04-01 00:38:47.000000', 'temperatura', 1179.0000, 'ºC'),
	(126996, 109, '2015-04-01 00:38:48.000000', 'temperatura', 464.0000, 'ºC'),
	(126997, 109, '2015-04-01 00:38:49.000000', 'temperatura', 1180.0000, 'ºC'),
	(126998, 109, '2015-04-01 00:38:50.000000', 'temperatura', 912.0000, 'ºC'),
	(126999, 109, '2015-04-01 00:38:51.000000', 'temperatura', 1018.0000, 'ºC'),
	(127000, 109, '2015-04-01 00:38:52.000000', 'temperatura', 1154.0000, 'ºC'),
	(127001, 109, '2015-04-01 00:38:53.000000', 'temperatura', 317.0000, 'ºC'),
	(127002, 109, '2015-04-01 00:38:54.000000', 'temperatura', 525.0000, 'ºC'),
	(127003, 109, '2015-04-01 00:38:55.000000', 'temperatura', 473.0000, 'ºC'),
	(127004, 109, '2015-04-01 00:38:56.000000', 'temperatura', 790.0000, 'ºC'),
	(127005, 109, '2015-04-01 00:38:57.000000', 'temperatura', 130.0000, 'ºC'),
	(127006, 109, '2015-04-01 00:38:58.000000', 'temperatura', 684.0000, 'ºC'),
	(127007, 109, '2015-04-01 00:38:59.000000', 'temperatura', 630.0000, 'ºC'),
	(127008, 109, '2015-04-01 00:39:00.000000', 'temperatura', 1097.0000, 'ºC'),
	(127009, 109, '2015-04-01 00:39:01.000000', 'temperatura', 1196.0000, 'ºC'),
	(127010, 109, '2015-04-01 00:39:02.000000', 'temperatura', 287.0000, 'ºC'),
	(127011, 109, '2015-04-01 00:39:03.000000', 'temperatura', 251.0000, 'ºC'),
	(127012, 109, '2015-04-01 00:39:04.000000', 'temperatura', 395.0000, 'ºC'),
	(127013, 109, '2015-04-01 00:39:05.000000', 'temperatura', 22.0000, 'ºC'),
	(127014, 109, '2015-04-01 00:39:06.000000', 'temperatura', 125.0000, 'ºC'),
	(127015, 109, '2015-04-01 00:39:07.000000', 'temperatura', 558.0000, 'ºC'),
	(127016, 109, '2015-04-01 00:39:08.000000', 'temperatura', 17.0000, 'ºC'),
	(127017, 109, '2015-04-01 00:39:09.000000', 'temperatura', 810.0000, 'ºC'),
	(127018, 109, '2015-04-01 00:39:10.000000', 'temperatura', 402.0000, 'ºC'),
	(127019, 109, '2015-04-01 00:39:11.000000', 'temperatura', 781.0000, 'ºC'),
	(127020, 109, '2015-04-01 00:39:12.000000', 'temperatura', 299.0000, 'ºC'),
	(127021, 109, '2015-04-01 00:39:13.000000', 'temperatura', 352.0000, 'ºC'),
	(127022, 109, '2015-04-01 00:39:14.000000', 'temperatura', 864.0000, 'ºC'),
	(127023, 109, '2015-04-01 00:39:15.000000', 'temperatura', 864.0000, 'ºC'),
	(127024, 109, '2015-04-01 00:39:16.000000', 'temperatura', 527.0000, 'ºC'),
	(127025, 109, '2015-04-01 00:39:17.000000', 'temperatura', 45.0000, 'ºC'),
	(127026, 109, '2015-04-01 00:39:18.000000', 'temperatura', 1045.0000, 'ºC'),
	(127027, 109, '2015-04-01 00:39:19.000000', 'temperatura', 288.0000, 'ºC'),
	(127028, 109, '2015-04-01 00:39:20.000000', 'temperatura', 707.0000, 'ºC'),
	(127029, 109, '2015-04-01 00:39:21.000000', 'temperatura', 271.0000, 'ºC'),
	(127030, 109, '2015-04-01 00:39:22.000000', 'temperatura', 433.0000, 'ºC'),
	(127031, 109, '2015-04-01 00:39:23.000000', 'temperatura', 154.0000, 'ºC'),
	(127032, 109, '2015-04-01 00:39:24.000000', 'temperatura', 669.0000, 'ºC'),
	(127033, 109, '2015-04-01 00:39:25.000000', 'temperatura', 486.0000, 'ºC'),
	(127034, 109, '2015-04-01 00:39:26.000000', 'temperatura', 423.0000, 'ºC'),
	(127035, 109, '2015-04-01 00:39:27.000000', 'temperatura', 657.0000, 'ºC'),
	(127036, 109, '2015-04-01 00:39:28.000000', 'temperatura', 816.0000, 'ºC'),
	(127037, 109, '2015-04-01 00:39:29.000000', 'temperatura', 911.0000, 'ºC'),
	(127038, 109, '2015-04-01 00:39:30.000000', 'temperatura', 907.0000, 'ºC'),
	(127039, 109, '2015-04-01 00:39:31.000000', 'temperatura', 602.0000, 'ºC'),
	(127040, 109, '2015-04-01 00:39:32.000000', 'temperatura', 290.0000, 'ºC'),
	(127041, 109, '2015-04-01 00:39:33.000000', 'temperatura', 844.0000, 'ºC'),
	(127042, 109, '2015-04-01 00:39:34.000000', 'temperatura', 950.0000, 'ºC'),
	(127043, 109, '2015-04-01 00:39:35.000000', 'temperatura', 1020.0000, 'ºC'),
	(127044, 109, '2015-04-01 00:39:36.000000', 'temperatura', 1049.0000, 'ºC'),
	(127045, 109, '2015-04-01 00:39:37.000000', 'temperatura', 987.0000, 'ºC'),
	(127046, 109, '2015-04-01 00:39:38.000000', 'temperatura', 586.0000, 'ºC'),
	(127047, 109, '2015-04-01 00:39:39.000000', 'temperatura', 1173.0000, 'ºC'),
	(127048, 109, '2015-04-01 00:39:40.000000', 'temperatura', 505.0000, 'ºC'),
	(127049, 109, '2015-04-01 00:39:41.000000', 'temperatura', 208.0000, 'ºC'),
	(127050, 109, '2015-04-01 00:39:42.000000', 'temperatura', 725.0000, 'ºC'),
	(127051, 109, '2015-04-01 00:39:43.000000', 'temperatura', 603.0000, 'ºC'),
	(127052, 109, '2015-04-01 00:39:44.000000', 'temperatura', 839.0000, 'ºC'),
	(127053, 109, '2015-04-01 00:39:45.000000', 'temperatura', 1185.0000, 'ºC'),
	(127054, 109, '2015-04-01 00:39:46.000000', 'temperatura', 1011.0000, 'ºC'),
	(127055, 109, '2015-04-01 00:39:47.000000', 'temperatura', 299.0000, 'ºC'),
	(127056, 109, '2015-04-01 00:39:48.000000', 'temperatura', 863.0000, 'ºC'),
	(127057, 109, '2015-04-01 00:39:49.000000', 'temperatura', 1019.0000, 'ºC'),
	(127058, 109, '2015-04-01 00:39:50.000000', 'temperatura', 104.0000, 'ºC'),
	(127059, 109, '2015-04-01 00:39:51.000000', 'temperatura', 1065.0000, 'ºC'),
	(127060, 109, '2015-04-01 00:39:52.000000', 'temperatura', 216.0000, 'ºC'),
	(127061, 109, '2015-04-01 00:39:53.000000', 'temperatura', 282.0000, 'ºC'),
	(127062, 109, '2015-04-01 00:39:54.000000', 'temperatura', 762.0000, 'ºC'),
	(127063, 109, '2015-04-01 00:39:55.000000', 'temperatura', 566.0000, 'ºC'),
	(127064, 109, '2015-04-01 00:39:56.000000', 'temperatura', 545.0000, 'ºC'),
	(127065, 109, '2015-04-01 00:39:57.000000', 'temperatura', 1028.0000, 'ºC'),
	(127066, 109, '2015-04-01 00:39:58.000000', 'temperatura', 1107.0000, 'ºC'),
	(127067, 109, '2015-04-01 00:39:59.000000', 'temperatura', 49.0000, 'ºC'),
	(127068, 109, '2015-04-01 00:40:00.000000', 'temperatura', 523.0000, 'ºC'),
	(127069, 109, '2015-04-01 00:40:01.000000', 'temperatura', 72.0000, 'ºC'),
	(127070, 109, '2015-04-01 00:40:02.000000', 'temperatura', 1189.0000, 'ºC'),
	(127071, 109, '2015-04-01 00:40:03.000000', 'temperatura', 930.0000, 'ºC'),
	(127072, 109, '2015-04-01 00:40:04.000000', 'temperatura', 1082.0000, 'ºC'),
	(127073, 109, '2015-04-01 00:40:05.000000', 'temperatura', 222.0000, 'ºC'),
	(127074, 109, '2015-04-01 00:40:06.000000', 'temperatura', 266.0000, 'ºC'),
	(127075, 109, '2015-04-01 00:40:07.000000', 'temperatura', 664.0000, 'ºC'),
	(127076, 109, '2015-04-01 00:40:08.000000', 'temperatura', 121.0000, 'ºC'),
	(127077, 109, '2015-04-01 00:40:09.000000', 'temperatura', 1014.0000, 'ºC'),
	(127078, 109, '2015-04-01 00:40:10.000000', 'temperatura', 1108.0000, 'ºC'),
	(127079, 109, '2015-04-01 00:40:11.000000', 'temperatura', 99.0000, 'ºC'),
	(127080, 109, '2015-04-01 00:40:12.000000', 'temperatura', 771.0000, 'ºC'),
	(127081, 109, '2015-04-01 00:40:13.000000', 'temperatura', 1157.0000, 'ºC'),
	(127082, 109, '2015-04-01 00:40:14.000000', 'temperatura', 1073.0000, 'ºC'),
	(127083, 109, '2015-04-01 00:40:15.000000', 'temperatura', 696.0000, 'ºC'),
	(127084, 109, '2015-04-01 00:40:16.000000', 'temperatura', 259.0000, 'ºC'),
	(127085, 109, '2015-04-01 00:40:17.000000', 'temperatura', 409.0000, 'ºC'),
	(127086, 109, '2015-04-01 00:40:18.000000', 'temperatura', 69.0000, 'ºC'),
	(127087, 109, '2015-04-01 00:40:19.000000', 'temperatura', 317.0000, 'ºC'),
	(127088, 109, '2015-04-01 00:40:20.000000', 'temperatura', 180.0000, 'ºC'),
	(127089, 109, '2015-04-01 00:40:21.000000', 'temperatura', 1151.0000, 'ºC'),
	(127090, 109, '2015-04-01 00:40:22.000000', 'temperatura', 412.0000, 'ºC'),
	(127091, 109, '2015-04-01 00:40:23.000000', 'temperatura', 1010.0000, 'ºC'),
	(127092, 109, '2015-04-01 00:40:24.000000', 'temperatura', 213.0000, 'ºC'),
	(127093, 109, '2015-04-01 00:40:25.000000', 'temperatura', 437.0000, 'ºC'),
	(127094, 109, '2015-04-01 00:40:26.000000', 'temperatura', 344.0000, 'ºC'),
	(127095, 109, '2015-04-01 00:40:27.000000', 'temperatura', 411.0000, 'ºC'),
	(127096, 109, '2015-04-01 00:40:28.000000', 'temperatura', 1024.0000, 'ºC'),
	(127097, 109, '2015-04-01 00:40:29.000000', 'temperatura', 288.0000, 'ºC'),
	(127098, 109, '2015-04-01 00:40:30.000000', 'temperatura', 768.0000, 'ºC'),
	(127099, 109, '2015-04-01 00:40:31.000000', 'temperatura', 575.0000, 'ºC'),
	(127100, 109, '2015-04-01 00:40:32.000000', 'temperatura', 573.0000, 'ºC'),
	(127101, 109, '2015-04-01 00:40:33.000000', 'temperatura', 1140.0000, 'ºC'),
	(127102, 109, '2015-04-01 00:40:34.000000', 'temperatura', 380.0000, 'ºC'),
	(127103, 109, '2015-04-01 00:40:35.000000', 'temperatura', 881.0000, 'ºC'),
	(127104, 109, '2015-04-01 00:40:36.000000', 'temperatura', 866.0000, 'ºC'),
	(127105, 109, '2015-04-01 00:40:37.000000', 'temperatura', 489.0000, 'ºC'),
	(127106, 109, '2015-04-01 00:40:38.000000', 'temperatura', 1048.0000, 'ºC'),
	(127107, 109, '2015-04-01 00:40:39.000000', 'temperatura', 171.0000, 'ºC'),
	(127108, 109, '2015-04-01 00:40:40.000000', 'temperatura', 113.0000, 'ºC'),
	(127109, 109, '2015-04-01 00:40:41.000000', 'temperatura', 50.0000, 'ºC'),
	(127110, 109, '2015-04-01 00:40:42.000000', 'temperatura', 1114.0000, 'ºC'),
	(127111, 109, '2015-04-01 00:40:43.000000', 'temperatura', 622.0000, 'ºC'),
	(127112, 109, '2015-04-01 00:40:44.000000', 'temperatura', 967.0000, 'ºC'),
	(127113, 109, '2015-04-01 00:40:45.000000', 'temperatura', 568.0000, 'ºC'),
	(127114, 109, '2015-04-01 00:40:46.000000', 'temperatura', 1141.0000, 'ºC'),
	(127115, 109, '2015-04-01 00:40:47.000000', 'temperatura', 399.0000, 'ºC'),
	(127116, 109, '2015-04-01 00:40:48.000000', 'temperatura', 974.0000, 'ºC'),
	(127117, 109, '2015-04-01 00:40:49.000000', 'temperatura', 75.0000, 'ºC'),
	(127118, 109, '2015-04-01 00:40:50.000000', 'temperatura', 1053.0000, 'ºC'),
	(127119, 109, '2015-04-01 00:40:51.000000', 'temperatura', 238.0000, 'ºC'),
	(127120, 109, '2015-04-01 00:40:52.000000', 'temperatura', 434.0000, 'ºC'),
	(127121, 109, '2015-04-01 00:40:53.000000', 'temperatura', 257.0000, 'ºC'),
	(127122, 109, '2015-04-01 00:40:54.000000', 'temperatura', 1182.0000, 'ºC'),
	(127123, 109, '2015-04-01 00:40:55.000000', 'temperatura', 340.0000, 'ºC'),
	(127124, 109, '2015-04-01 00:40:56.000000', 'temperatura', 555.0000, 'ºC'),
	(127125, 109, '2015-04-01 00:40:57.000000', 'temperatura', 556.0000, 'ºC'),
	(127126, 109, '2015-04-01 00:40:58.000000', 'temperatura', 1113.0000, 'ºC'),
	(127127, 109, '2015-04-01 00:40:59.000000', 'temperatura', 299.0000, 'ºC'),
	(127128, 109, '2015-04-01 00:41:00.000000', 'temperatura', 556.0000, 'ºC'),
	(127129, 109, '2015-04-01 00:41:01.000000', 'temperatura', 684.0000, 'ºC'),
	(127130, 109, '2015-04-01 00:41:02.000000', 'temperatura', 551.0000, 'ºC'),
	(127131, 109, '2015-04-01 00:41:03.000000', 'temperatura', 706.0000, 'ºC'),
	(127132, 109, '2015-04-01 00:41:04.000000', 'temperatura', 675.0000, 'ºC'),
	(127133, 109, '2015-04-01 00:41:05.000000', 'temperatura', 59.0000, 'ºC'),
	(127134, 109, '2015-04-01 00:41:06.000000', 'temperatura', 669.0000, 'ºC'),
	(127135, 109, '2015-04-01 00:41:07.000000', 'temperatura', 767.0000, 'ºC'),
	(127136, 109, '2015-04-01 00:41:08.000000', 'temperatura', 632.0000, 'ºC'),
	(127137, 109, '2015-04-01 00:41:09.000000', 'temperatura', 857.0000, 'ºC'),
	(127138, 109, '2015-04-01 00:41:10.000000', 'temperatura', 1191.0000, 'ºC'),
	(127139, 109, '2015-04-01 00:41:11.000000', 'temperatura', 982.0000, 'ºC'),
	(127140, 109, '2015-04-01 00:41:12.000000', 'temperatura', 139.0000, 'ºC'),
	(127141, 109, '2015-04-01 00:41:13.000000', 'temperatura', 149.0000, 'ºC'),
	(127142, 109, '2015-04-01 00:41:14.000000', 'temperatura', 329.0000, 'ºC'),
	(127143, 109, '2015-04-01 00:41:15.000000', 'temperatura', 1199.0000, 'ºC'),
	(127144, 109, '2015-04-01 00:41:16.000000', 'temperatura', 207.0000, 'ºC'),
	(127145, 109, '2015-04-01 00:41:17.000000', 'temperatura', 1041.0000, 'ºC'),
	(127146, 109, '2015-04-01 00:41:18.000000', 'temperatura', 984.0000, 'ºC'),
	(127147, 109, '2015-04-01 00:41:19.000000', 'temperatura', 597.0000, 'ºC'),
	(127148, 109, '2015-04-01 00:41:20.000000', 'temperatura', 32.0000, 'ºC'),
	(127149, 109, '2015-04-01 00:41:21.000000', 'temperatura', 771.0000, 'ºC'),
	(127150, 109, '2015-04-01 00:41:22.000000', 'temperatura', 157.0000, 'ºC'),
	(127151, 109, '2015-04-01 00:41:23.000000', 'temperatura', 876.0000, 'ºC'),
	(127152, 109, '2015-04-01 00:41:24.000000', 'temperatura', 307.0000, 'ºC'),
	(127153, 109, '2015-04-01 00:41:25.000000', 'temperatura', 110.0000, 'ºC'),
	(127154, 109, '2015-04-01 00:41:26.000000', 'temperatura', 828.0000, 'ºC'),
	(127155, 109, '2015-04-01 00:41:27.000000', 'temperatura', 210.0000, 'ºC'),
	(127156, 109, '2015-04-01 00:41:28.000000', 'temperatura', 966.0000, 'ºC'),
	(127157, 109, '2015-04-01 00:41:29.000000', 'temperatura', 601.0000, 'ºC'),
	(127158, 109, '2015-04-01 00:41:30.000000', 'temperatura', 106.0000, 'ºC'),
	(127159, 109, '2015-04-01 00:41:31.000000', 'temperatura', 1130.0000, 'ºC'),
	(127160, 109, '2015-04-01 00:41:32.000000', 'temperatura', 529.0000, 'ºC'),
	(127161, 109, '2015-04-01 00:41:33.000000', 'temperatura', 459.0000, 'ºC'),
	(127162, 109, '2015-04-01 00:41:34.000000', 'temperatura', 708.0000, 'ºC'),
	(127163, 109, '2015-04-01 00:41:35.000000', 'temperatura', 964.0000, 'ºC'),
	(127164, 109, '2015-04-01 00:41:36.000000', 'temperatura', 297.0000, 'ºC'),
	(127165, 109, '2015-04-01 00:41:37.000000', 'temperatura', 992.0000, 'ºC'),
	(127166, 109, '2015-04-01 00:41:38.000000', 'temperatura', 471.0000, 'ºC'),
	(127167, 109, '2015-04-01 00:41:39.000000', 'temperatura', 577.0000, 'ºC'),
	(127168, 109, '2015-04-01 00:41:40.000000', 'temperatura', 275.0000, 'ºC'),
	(127169, 109, '2015-04-01 00:41:41.000000', 'temperatura', 845.0000, 'ºC'),
	(127170, 109, '2015-04-01 00:41:42.000000', 'temperatura', 1001.0000, 'ºC'),
	(127171, 109, '2015-04-01 00:41:43.000000', 'temperatura', 70.0000, 'ºC'),
	(127172, 109, '2015-04-01 00:41:44.000000', 'temperatura', 947.0000, 'ºC'),
	(127173, 109, '2015-04-01 00:41:45.000000', 'temperatura', 925.0000, 'ºC'),
	(127174, 109, '2015-04-01 00:41:46.000000', 'temperatura', 586.0000, 'ºC'),
	(127175, 109, '2015-04-01 00:41:47.000000', 'temperatura', 153.0000, 'ºC'),
	(127176, 109, '2015-04-01 00:41:48.000000', 'temperatura', 209.0000, 'ºC'),
	(127177, 109, '2015-04-01 00:41:49.000000', 'temperatura', 586.0000, 'ºC'),
	(127178, 109, '2015-04-01 00:41:50.000000', 'temperatura', 1104.0000, 'ºC'),
	(127179, 109, '2015-04-01 00:41:51.000000', 'temperatura', 163.0000, 'ºC'),
	(127180, 109, '2015-04-01 00:41:52.000000', 'temperatura', 1103.0000, 'ºC'),
	(127181, 109, '2015-04-01 00:41:53.000000', 'temperatura', 228.0000, 'ºC'),
	(127182, 109, '2015-04-01 00:41:54.000000', 'temperatura', 229.0000, 'ºC'),
	(127183, 109, '2015-04-01 00:41:55.000000', 'temperatura', 461.0000, 'ºC'),
	(127184, 109, '2015-04-01 00:41:56.000000', 'temperatura', 421.0000, 'ºC'),
	(127185, 109, '2015-04-01 00:41:57.000000', 'temperatura', 722.0000, 'ºC'),
	(127186, 109, '2015-04-01 00:41:58.000000', 'temperatura', 1146.0000, 'ºC'),
	(127187, 109, '2015-04-01 00:41:59.000000', 'temperatura', 1164.0000, 'ºC'),
	(127188, 109, '2015-04-01 00:42:00.000000', 'temperatura', 1185.0000, 'ºC'),
	(127189, 109, '2015-04-01 00:42:01.000000', 'temperatura', 32.0000, 'ºC'),
	(127190, 109, '2015-04-01 00:42:02.000000', 'temperatura', 204.0000, 'ºC'),
	(127191, 109, '2015-04-01 00:42:03.000000', 'temperatura', 926.0000, 'ºC'),
	(127192, 109, '2015-04-01 00:42:04.000000', 'temperatura', 418.0000, 'ºC'),
	(127193, 109, '2015-04-01 00:42:05.000000', 'temperatura', 513.0000, 'ºC'),
	(127194, 109, '2015-04-01 00:42:06.000000', 'temperatura', 109.0000, 'ºC'),
	(127195, 109, '2015-04-01 00:42:07.000000', 'temperatura', 210.0000, 'ºC'),
	(127196, 109, '2015-04-01 00:42:08.000000', 'temperatura', 723.0000, 'ºC'),
	(127197, 109, '2015-04-01 00:42:09.000000', 'temperatura', 585.0000, 'ºC'),
	(127198, 109, '2015-04-01 00:42:10.000000', 'temperatura', 755.0000, 'ºC'),
	(127199, 109, '2015-04-01 00:42:11.000000', 'temperatura', 823.0000, 'ºC'),
	(127200, 109, '2015-04-01 00:42:12.000000', 'temperatura', 651.0000, 'ºC'),
	(127201, 109, '2015-04-01 00:42:13.000000', 'temperatura', 786.0000, 'ºC'),
	(127202, 109, '2015-04-01 00:42:14.000000', 'temperatura', 776.0000, 'ºC'),
	(127203, 109, '2015-04-01 00:42:15.000000', 'temperatura', 323.0000, 'ºC'),
	(127204, 109, '2015-04-01 00:42:16.000000', 'temperatura', 487.0000, 'ºC'),
	(127205, 109, '2015-04-01 00:42:17.000000', 'temperatura', 268.0000, 'ºC'),
	(127206, 109, '2015-04-01 00:42:18.000000', 'temperatura', 1078.0000, 'ºC'),
	(127207, 109, '2015-04-01 00:42:19.000000', 'temperatura', 989.0000, 'ºC'),
	(127208, 109, '2015-04-01 00:42:20.000000', 'temperatura', 509.0000, 'ºC'),
	(127209, 109, '2015-04-01 00:42:21.000000', 'temperatura', 781.0000, 'ºC'),
	(127210, 109, '2015-04-01 00:42:22.000000', 'temperatura', 1176.0000, 'ºC'),
	(127211, 109, '2015-04-01 00:42:23.000000', 'temperatura', 1139.0000, 'ºC'),
	(127212, 109, '2015-04-01 00:42:24.000000', 'temperatura', 966.0000, 'ºC'),
	(127213, 109, '2015-04-01 00:42:25.000000', 'temperatura', 212.0000, 'ºC'),
	(127214, 109, '2015-04-01 00:42:26.000000', 'temperatura', 565.0000, 'ºC'),
	(127215, 109, '2015-04-01 00:42:27.000000', 'temperatura', 989.0000, 'ºC'),
	(127216, 109, '2015-04-01 00:42:28.000000', 'temperatura', 849.0000, 'ºC'),
	(127217, 109, '2015-04-01 00:42:29.000000', 'temperatura', 81.0000, 'ºC'),
	(127218, 109, '2015-04-01 00:42:30.000000', 'temperatura', 255.0000, 'ºC'),
	(127219, 109, '2015-04-01 00:42:31.000000', 'temperatura', 1036.0000, 'ºC'),
	(127220, 109, '2015-04-01 00:42:32.000000', 'temperatura', 814.0000, 'ºC'),
	(127221, 109, '2015-04-01 00:42:33.000000', 'temperatura', 964.0000, 'ºC'),
	(127222, 109, '2015-04-01 00:42:34.000000', 'temperatura', 1176.0000, 'ºC'),
	(127223, 109, '2015-04-01 00:42:35.000000', 'temperatura', 590.0000, 'ºC'),
	(127224, 109, '2015-04-01 00:42:36.000000', 'temperatura', 624.0000, 'ºC'),
	(127225, 109, '2015-04-01 00:42:37.000000', 'temperatura', 151.0000, 'ºC'),
	(127226, 109, '2015-04-01 00:42:38.000000', 'temperatura', 81.0000, 'ºC'),
	(127227, 109, '2015-04-01 00:42:39.000000', 'temperatura', 1155.0000, 'ºC'),
	(127228, 109, '2015-04-01 00:42:40.000000', 'temperatura', 732.0000, 'ºC'),
	(127229, 109, '2015-04-01 00:42:41.000000', 'temperatura', 195.0000, 'ºC'),
	(127230, 109, '2015-04-01 00:42:42.000000', 'temperatura', 1180.0000, 'ºC'),
	(127231, 109, '2015-04-01 00:42:43.000000', 'temperatura', 517.0000, 'ºC'),
	(127232, 109, '2015-04-01 00:42:44.000000', 'temperatura', 245.0000, 'ºC'),
	(127233, 109, '2015-04-01 00:42:45.000000', 'temperatura', 876.0000, 'ºC'),
	(127234, 109, '2015-04-01 00:42:46.000000', 'temperatura', 42.0000, 'ºC'),
	(127235, 109, '2015-04-01 00:42:47.000000', 'temperatura', 1185.0000, 'ºC'),
	(127236, 109, '2015-04-01 00:42:48.000000', 'temperatura', 999.0000, 'ºC'),
	(127237, 109, '2015-04-01 00:42:49.000000', 'temperatura', 241.0000, 'ºC'),
	(127238, 109, '2015-04-01 00:42:50.000000', 'temperatura', 609.0000, 'ºC'),
	(127239, 109, '2015-04-01 00:42:51.000000', 'temperatura', 1120.0000, 'ºC'),
	(127240, 109, '2015-04-01 00:42:52.000000', 'temperatura', 174.0000, 'ºC'),
	(127241, 109, '2015-04-01 00:42:53.000000', 'temperatura', 1109.0000, 'ºC'),
	(127242, 109, '2015-04-01 00:42:54.000000', 'temperatura', 227.0000, 'ºC'),
	(127243, 109, '2015-04-01 00:42:55.000000', 'temperatura', 206.0000, 'ºC'),
	(127244, 109, '2015-04-01 00:42:56.000000', 'temperatura', 348.0000, 'ºC'),
	(127245, 109, '2015-04-01 00:42:57.000000', 'temperatura', 1125.0000, 'ºC'),
	(127246, 109, '2015-04-01 00:42:58.000000', 'temperatura', 979.0000, 'ºC'),
	(127247, 109, '2015-04-01 00:42:59.000000', 'temperatura', 323.0000, 'ºC'),
	(127248, 109, '2015-04-01 00:43:00.000000', 'temperatura', 1080.0000, 'ºC'),
	(127249, 109, '2015-04-01 00:43:01.000000', 'temperatura', 829.0000, 'ºC'),
	(127250, 109, '2015-04-01 00:43:02.000000', 'temperatura', 905.0000, 'ºC'),
	(127251, 109, '2015-04-01 00:43:03.000000', 'temperatura', 839.0000, 'ºC'),
	(127252, 109, '2015-04-01 00:43:04.000000', 'temperatura', 282.0000, 'ºC'),
	(127253, 109, '2015-04-01 00:43:05.000000', 'temperatura', 92.0000, 'ºC'),
	(127254, 109, '2015-04-01 00:43:06.000000', 'temperatura', 815.0000, 'ºC'),
	(127255, 109, '2015-04-01 00:43:07.000000', 'temperatura', 200.0000, 'ºC'),
	(127256, 109, '2015-04-01 00:43:08.000000', 'temperatura', 956.0000, 'ºC'),
	(127257, 109, '2015-04-01 00:43:09.000000', 'temperatura', 579.0000, 'ºC'),
	(127258, 109, '2015-04-01 00:43:10.000000', 'temperatura', 28.0000, 'ºC'),
	(127259, 109, '2015-04-01 00:43:11.000000', 'temperatura', 804.0000, 'ºC'),
	(127260, 109, '2015-04-01 00:43:12.000000', 'temperatura', 337.0000, 'ºC'),
	(127261, 109, '2015-04-01 00:43:13.000000', 'temperatura', 474.0000, 'ºC'),
	(127262, 109, '2015-04-01 00:43:14.000000', 'temperatura', 158.0000, 'ºC'),
	(127263, 109, '2015-04-01 00:43:15.000000', 'temperatura', 568.0000, 'ºC'),
	(127264, 109, '2015-04-01 00:43:16.000000', 'temperatura', 1167.0000, 'ºC'),
	(127265, 109, '2015-04-01 00:43:17.000000', 'temperatura', 533.0000, 'ºC'),
	(127266, 109, '2015-04-01 00:43:18.000000', 'temperatura', 365.0000, 'ºC'),
	(127267, 109, '2015-04-01 00:43:19.000000', 'temperatura', 224.0000, 'ºC'),
	(127268, 109, '2015-04-01 00:43:20.000000', 'temperatura', 25.0000, 'ºC'),
	(127269, 109, '2015-04-01 00:43:21.000000', 'temperatura', 654.0000, 'ºC'),
	(127270, 109, '2015-04-01 00:43:22.000000', 'temperatura', 795.0000, 'ºC'),
	(127271, 109, '2015-04-01 00:43:23.000000', 'temperatura', 814.0000, 'ºC'),
	(127272, 109, '2015-04-01 00:43:24.000000', 'temperatura', 485.0000, 'ºC'),
	(127273, 109, '2015-04-01 00:43:25.000000', 'temperatura', 1186.0000, 'ºC'),
	(127274, 109, '2015-04-01 00:43:26.000000', 'temperatura', 874.0000, 'ºC'),
	(127275, 109, '2015-04-01 00:43:27.000000', 'temperatura', 812.0000, 'ºC'),
	(127276, 109, '2015-04-01 00:43:28.000000', 'temperatura', 240.0000, 'ºC'),
	(127277, 109, '2015-04-01 00:43:29.000000', 'temperatura', 1164.0000, 'ºC'),
	(127278, 109, '2015-04-01 00:43:30.000000', 'temperatura', 299.0000, 'ºC'),
	(127279, 109, '2015-04-01 00:43:31.000000', 'temperatura', 406.0000, 'ºC'),
	(127280, 109, '2015-04-01 00:43:32.000000', 'temperatura', 1132.0000, 'ºC'),
	(127281, 109, '2015-04-01 00:43:33.000000', 'temperatura', 843.0000, 'ºC'),
	(127282, 109, '2015-04-01 00:43:34.000000', 'temperatura', 821.0000, 'ºC'),
	(127283, 109, '2015-04-01 00:43:35.000000', 'temperatura', 376.0000, 'ºC'),
	(127284, 109, '2015-04-01 00:43:36.000000', 'temperatura', 617.0000, 'ºC'),
	(127285, 109, '2015-04-01 00:43:37.000000', 'temperatura', 757.0000, 'ºC'),
	(127286, 109, '2015-04-01 00:43:38.000000', 'temperatura', 737.0000, 'ºC'),
	(127287, 109, '2015-04-01 00:43:39.000000', 'temperatura', 212.0000, 'ºC'),
	(127288, 109, '2015-04-01 00:43:40.000000', 'temperatura', 50.0000, 'ºC'),
	(127289, 109, '2015-04-01 00:43:41.000000', 'temperatura', 815.0000, 'ºC'),
	(127290, 109, '2015-04-01 00:43:42.000000', 'temperatura', 326.0000, 'ºC'),
	(127291, 109, '2015-04-01 00:43:43.000000', 'temperatura', 386.0000, 'ºC'),
	(127292, 109, '2015-04-01 00:43:44.000000', 'temperatura', 953.0000, 'ºC'),
	(127293, 109, '2015-04-01 00:43:45.000000', 'temperatura', 7.0000, 'ºC'),
	(127294, 109, '2015-04-01 00:43:46.000000', 'temperatura', 777.0000, 'ºC'),
	(127295, 109, '2015-04-01 00:43:47.000000', 'temperatura', 264.0000, 'ºC'),
	(127296, 109, '2015-04-01 00:43:48.000000', 'temperatura', 188.0000, 'ºC'),
	(127297, 109, '2015-04-01 00:43:49.000000', 'temperatura', 150.0000, 'ºC'),
	(127298, 109, '2015-04-01 00:43:50.000000', 'temperatura', 187.0000, 'ºC'),
	(127299, 109, '2015-04-01 00:43:51.000000', 'temperatura', 484.0000, 'ºC'),
	(127300, 109, '2015-04-01 00:43:52.000000', 'temperatura', 659.0000, 'ºC'),
	(127301, 109, '2015-04-01 00:43:53.000000', 'temperatura', 645.0000, 'ºC'),
	(127302, 109, '2015-04-01 00:43:54.000000', 'temperatura', 46.0000, 'ºC'),
	(127303, 109, '2015-04-01 00:43:55.000000', 'temperatura', 698.0000, 'ºC'),
	(127304, 109, '2015-04-01 00:43:56.000000', 'temperatura', 953.0000, 'ºC'),
	(127305, 109, '2015-04-01 00:43:57.000000', 'temperatura', 269.0000, 'ºC'),
	(127306, 109, '2015-04-01 00:43:58.000000', 'temperatura', 887.0000, 'ºC'),
	(127307, 109, '2015-04-01 00:43:59.000000', 'temperatura', 28.0000, 'ºC'),
	(127308, 109, '2015-04-01 00:44:00.000000', 'temperatura', 1081.0000, 'ºC'),
	(127309, 109, '2015-04-01 00:44:01.000000', 'temperatura', 521.0000, 'ºC'),
	(127310, 109, '2015-04-01 00:44:02.000000', 'temperatura', 561.0000, 'ºC'),
	(127311, 109, '2015-04-01 00:44:03.000000', 'temperatura', 45.0000, 'ºC'),
	(127312, 109, '2015-04-01 00:44:04.000000', 'temperatura', 942.0000, 'ºC'),
	(127313, 109, '2015-04-01 00:44:05.000000', 'temperatura', 977.0000, 'ºC'),
	(127314, 109, '2015-04-01 00:44:06.000000', 'temperatura', 858.0000, 'ºC'),
	(127315, 109, '2015-04-01 00:44:07.000000', 'temperatura', 158.0000, 'ºC'),
	(127316, 109, '2015-04-01 00:44:08.000000', 'temperatura', 616.0000, 'ºC'),
	(127317, 109, '2015-04-01 00:44:09.000000', 'temperatura', 208.0000, 'ºC'),
	(127318, 109, '2015-04-01 00:44:10.000000', 'temperatura', 393.0000, 'ºC'),
	(127319, 109, '2015-04-01 00:44:11.000000', 'temperatura', 143.0000, 'ºC'),
	(127320, 109, '2015-04-01 00:44:12.000000', 'temperatura', 734.0000, 'ºC'),
	(127321, 109, '2015-04-01 00:44:13.000000', 'temperatura', 843.0000, 'ºC'),
	(127322, 109, '2015-04-01 00:44:14.000000', 'temperatura', 813.0000, 'ºC'),
	(127323, 109, '2015-04-01 00:44:15.000000', 'temperatura', 338.0000, 'ºC'),
	(127324, 109, '2015-04-01 00:44:16.000000', 'temperatura', 452.0000, 'ºC'),
	(127325, 109, '2015-04-01 00:44:17.000000', 'temperatura', 43.0000, 'ºC'),
	(127326, 109, '2015-04-01 00:44:18.000000', 'temperatura', 63.0000, 'ºC'),
	(127327, 109, '2015-04-01 00:44:19.000000', 'temperatura', 186.0000, 'ºC'),
	(127328, 109, '2015-04-01 00:44:20.000000', 'temperatura', 742.0000, 'ºC'),
	(127329, 109, '2015-04-01 00:44:21.000000', 'temperatura', 750.0000, 'ºC'),
	(127330, 109, '2015-04-01 00:44:22.000000', 'temperatura', 327.0000, 'ºC'),
	(127331, 109, '2015-04-01 00:44:23.000000', 'temperatura', 585.0000, 'ºC'),
	(127332, 109, '2015-04-01 00:44:24.000000', 'temperatura', 745.0000, 'ºC'),
	(127333, 109, '2015-04-01 00:44:25.000000', 'temperatura', 771.0000, 'ºC'),
	(127334, 109, '2015-04-01 00:44:26.000000', 'temperatura', 419.0000, 'ºC'),
	(127335, 109, '2015-04-01 00:44:27.000000', 'temperatura', 982.0000, 'ºC'),
	(127336, 109, '2015-04-01 00:44:28.000000', 'temperatura', 53.0000, 'ºC'),
	(127337, 109, '2015-04-01 00:44:29.000000', 'temperatura', 918.0000, 'ºC'),
	(127338, 109, '2015-04-01 00:44:30.000000', 'temperatura', 835.0000, 'ºC'),
	(127339, 109, '2015-04-01 00:44:31.000000', 'temperatura', 221.0000, 'ºC'),
	(127340, 109, '2015-04-01 00:44:32.000000', 'temperatura', 999.0000, 'ºC'),
	(127341, 109, '2015-04-01 00:44:33.000000', 'temperatura', 732.0000, 'ºC'),
	(127342, 109, '2015-04-01 00:44:34.000000', 'temperatura', 663.0000, 'ºC'),
	(127343, 109, '2015-04-01 00:44:35.000000', 'temperatura', 1122.0000, 'ºC'),
	(127344, 109, '2015-04-01 00:44:36.000000', 'temperatura', 21.0000, 'ºC'),
	(127345, 109, '2015-04-01 00:44:37.000000', 'temperatura', 340.0000, 'ºC'),
	(127346, 109, '2015-04-01 00:44:38.000000', 'temperatura', 436.0000, 'ºC'),
	(127347, 109, '2015-04-01 00:44:39.000000', 'temperatura', 1163.0000, 'ºC'),
	(127348, 109, '2015-04-01 00:44:40.000000', 'temperatura', 907.0000, 'ºC'),
	(127349, 109, '2015-04-01 00:44:41.000000', 'temperatura', 1046.0000, 'ºC'),
	(127350, 109, '2015-04-01 00:44:42.000000', 'temperatura', 107.0000, 'ºC'),
	(127351, 109, '2015-04-01 00:44:43.000000', 'temperatura', 1001.0000, 'ºC'),
	(127352, 109, '2015-04-01 00:44:44.000000', 'temperatura', 1084.0000, 'ºC'),
	(127353, 109, '2015-04-01 00:44:45.000000', 'temperatura', 17.0000, 'ºC'),
	(127354, 109, '2015-04-01 00:44:46.000000', 'temperatura', 435.0000, 'ºC'),
	(127355, 109, '2015-04-01 00:44:47.000000', 'temperatura', 925.0000, 'ºC'),
	(127356, 109, '2015-04-01 00:44:48.000000', 'temperatura', 918.0000, 'ºC'),
	(127357, 109, '2015-04-01 00:44:49.000000', 'temperatura', 615.0000, 'ºC'),
	(127358, 109, '2015-04-01 00:44:50.000000', 'temperatura', 322.0000, 'ºC'),
	(127359, 109, '2015-04-01 00:44:51.000000', 'temperatura', 967.0000, 'ºC'),
	(127360, 109, '2015-04-01 00:44:52.000000', 'temperatura', 269.0000, 'ºC'),
	(127361, 109, '2015-04-01 00:44:53.000000', 'temperatura', 842.0000, 'ºC'),
	(127362, 109, '2015-04-01 00:44:54.000000', 'temperatura', 1006.0000, 'ºC'),
	(127363, 109, '2015-04-01 00:44:55.000000', 'temperatura', 103.0000, 'ºC'),
	(127364, 109, '2015-04-01 00:44:56.000000', 'temperatura', 1100.0000, 'ºC'),
	(127365, 109, '2015-04-01 00:44:57.000000', 'temperatura', 391.0000, 'ºC'),
	(127366, 109, '2015-04-01 00:44:58.000000', 'temperatura', 1055.0000, 'ºC'),
	(127367, 109, '2015-04-01 00:44:59.000000', 'temperatura', 503.0000, 'ºC'),
	(127368, 109, '2015-04-01 00:45:00.000000', 'temperatura', 549.0000, 'ºC'),
	(127369, 109, '2015-04-01 00:45:01.000000', 'temperatura', 36.0000, 'ºC'),
	(127370, 109, '2015-04-01 00:45:02.000000', 'temperatura', 933.0000, 'ºC'),
	(127371, 109, '2015-04-01 00:45:03.000000', 'temperatura', 959.0000, 'ºC'),
	(127372, 109, '2015-04-01 00:45:04.000000', 'temperatura', 794.0000, 'ºC'),
	(127373, 109, '2015-04-01 00:45:05.000000', 'temperatura', 1097.0000, 'ºC'),
	(127374, 109, '2015-04-01 00:45:06.000000', 'temperatura', 701.0000, 'ºC'),
	(127375, 109, '2015-04-01 00:45:07.000000', 'temperatura', 214.0000, 'ºC'),
	(127376, 109, '2015-04-01 00:45:08.000000', 'temperatura', 167.0000, 'ºC'),
	(127377, 109, '2015-04-01 00:45:09.000000', 'temperatura', 195.0000, 'ºC'),
	(127378, 109, '2015-04-01 00:45:10.000000', 'temperatura', 474.0000, 'ºC'),
	(127379, 109, '2015-04-01 00:45:11.000000', 'temperatura', 587.0000, 'ºC'),
	(127380, 109, '2015-04-01 00:45:12.000000', 'temperatura', 311.0000, 'ºC'),
	(127381, 109, '2015-04-01 00:45:13.000000', 'temperatura', 997.0000, 'ºC'),
	(127382, 109, '2015-04-01 00:45:14.000000', 'temperatura', 453.0000, 'ºC'),
	(127383, 109, '2015-04-01 00:45:15.000000', 'temperatura', 472.0000, 'ºC'),
	(127384, 109, '2015-04-01 00:45:16.000000', 'temperatura', 1001.0000, 'ºC'),
	(127385, 109, '2015-04-01 00:45:17.000000', 'temperatura', 1189.0000, 'ºC'),
	(127386, 109, '2015-04-01 00:45:18.000000', 'temperatura', 544.0000, 'ºC'),
	(127387, 109, '2015-04-01 00:45:19.000000', 'temperatura', 351.0000, 'ºC'),
	(127388, 109, '2015-04-01 00:45:20.000000', 'temperatura', 125.0000, 'ºC'),
	(127389, 109, '2015-04-01 00:45:21.000000', 'temperatura', 775.0000, 'ºC'),
	(127390, 109, '2015-04-01 00:45:22.000000', 'temperatura', 1097.0000, 'ºC'),
	(127391, 109, '2015-04-01 00:45:23.000000', 'temperatura', 763.0000, 'ºC'),
	(127392, 109, '2015-04-01 00:45:24.000000', 'temperatura', 523.0000, 'ºC'),
	(127393, 109, '2015-04-01 00:45:25.000000', 'temperatura', 325.0000, 'ºC'),
	(127394, 109, '2015-04-01 00:45:26.000000', 'temperatura', 58.0000, 'ºC'),
	(127395, 109, '2015-04-01 00:45:27.000000', 'temperatura', 517.0000, 'ºC'),
	(127396, 109, '2015-04-01 00:45:28.000000', 'temperatura', 9.0000, 'ºC'),
	(127397, 109, '2015-04-01 00:45:29.000000', 'temperatura', 895.0000, 'ºC'),
	(127398, 109, '2015-04-01 00:45:30.000000', 'temperatura', 849.0000, 'ºC'),
	(127399, 109, '2015-04-01 00:45:31.000000', 'temperatura', 362.0000, 'ºC'),
	(127400, 109, '2015-04-01 00:45:32.000000', 'temperatura', 462.0000, 'ºC'),
	(127401, 109, '2015-04-01 00:45:33.000000', 'temperatura', 27.0000, 'ºC'),
	(127402, 109, '2015-04-01 00:45:34.000000', 'temperatura', 1146.0000, 'ºC'),
	(127403, 109, '2015-04-01 00:45:35.000000', 'temperatura', 851.0000, 'ºC'),
	(127404, 109, '2015-04-01 00:45:36.000000', 'temperatura', 819.0000, 'ºC'),
	(127405, 109, '2015-04-01 00:45:37.000000', 'temperatura', 339.0000, 'ºC'),
	(127406, 109, '2015-04-01 00:45:38.000000', 'temperatura', 442.0000, 'ºC'),
	(127407, 109, '2015-04-01 00:45:39.000000', 'temperatura', 1192.0000, 'ºC'),
	(127408, 109, '2015-04-01 00:45:40.000000', 'temperatura', 1034.0000, 'ºC'),
	(127409, 109, '2015-04-01 00:45:41.000000', 'temperatura', 397.0000, 'ºC'),
	(127410, 109, '2015-04-01 00:45:42.000000', 'temperatura', 80.0000, 'ºC'),
	(127411, 109, '2015-04-01 00:45:43.000000', 'temperatura', 411.0000, 'ºC'),
	(127412, 109, '2015-04-01 00:45:44.000000', 'temperatura', 616.0000, 'ºC'),
	(127413, 109, '2015-04-01 00:45:45.000000', 'temperatura', 646.0000, 'ºC'),
	(127414, 109, '2015-04-01 00:45:46.000000', 'temperatura', 184.0000, 'ºC'),
	(127415, 109, '2015-04-01 00:45:47.000000', 'temperatura', 180.0000, 'ºC'),
	(127416, 109, '2015-04-01 00:45:48.000000', 'temperatura', 351.0000, 'ºC'),
	(127417, 109, '2015-04-01 00:45:49.000000', 'temperatura', 15.0000, 'ºC'),
	(127418, 109, '2015-04-01 00:45:50.000000', 'temperatura', 223.0000, 'ºC'),
	(127419, 109, '2015-04-01 00:45:51.000000', 'temperatura', 1069.0000, 'ºC'),
	(127420, 109, '2015-04-01 00:45:52.000000', 'temperatura', 1079.0000, 'ºC'),
	(127421, 109, '2015-04-01 00:45:53.000000', 'temperatura', 986.0000, 'ºC'),
	(127422, 109, '2015-04-01 00:45:54.000000', 'temperatura', 493.0000, 'ºC'),
	(127423, 109, '2015-04-01 00:45:55.000000', 'temperatura', 706.0000, 'ºC'),
	(127424, 109, '2015-04-01 00:45:56.000000', 'temperatura', 855.0000, 'ºC'),
	(127425, 109, '2015-04-01 00:45:57.000000', 'temperatura', 956.0000, 'ºC'),
	(127426, 109, '2015-04-01 00:45:58.000000', 'temperatura', 1017.0000, 'ºC'),
	(127427, 109, '2015-04-01 00:45:59.000000', 'temperatura', 1019.0000, 'ºC'),
	(127428, 109, '2015-04-01 00:46:00.000000', 'temperatura', 841.0000, 'ºC'),
	(127429, 109, '2015-04-01 00:46:01.000000', 'temperatura', 1151.0000, 'ºC'),
	(127430, 109, '2015-04-01 00:46:02.000000', 'temperatura', 832.0000, 'ºC'),
	(127431, 109, '2015-04-01 00:46:03.000000', 'temperatura', 708.0000, 'ºC'),
	(127432, 109, '2015-04-01 00:46:04.000000', 'temperatura', 1045.0000, 'ºC'),
	(127433, 109, '2015-04-01 00:46:05.000000', 'temperatura', 701.0000, 'ºC'),
	(127434, 109, '2015-04-01 00:46:06.000000', 'temperatura', 372.0000, 'ºC'),
	(127435, 109, '2015-04-01 00:46:07.000000', 'temperatura', 958.0000, 'ºC'),
	(127436, 109, '2015-04-01 00:46:08.000000', 'temperatura', 75.0000, 'ºC'),
	(127437, 109, '2015-04-01 00:46:09.000000', 'temperatura', 1100.0000, 'ºC'),
	(127438, 109, '2015-04-01 00:46:10.000000', 'temperatura', 474.0000, 'ºC'),
	(127439, 109, '2015-04-01 00:46:11.000000', 'temperatura', 272.0000, 'ºC'),
	(127440, 109, '2015-04-01 00:46:12.000000', 'temperatura', 1139.0000, 'ºC'),
	(127441, 109, '2015-04-01 00:46:13.000000', 'temperatura', 77.0000, 'ºC'),
	(127442, 109, '2015-04-01 00:46:14.000000', 'temperatura', 572.0000, 'ºC'),
	(127443, 109, '2015-04-01 00:46:15.000000', 'temperatura', 228.0000, 'ºC'),
	(127444, 109, '2015-04-01 00:46:16.000000', 'temperatura', 625.0000, 'ºC'),
	(127445, 109, '2015-04-01 00:46:17.000000', 'temperatura', 40.0000, 'ºC'),
	(127446, 109, '2015-04-01 00:46:18.000000', 'temperatura', 726.0000, 'ºC'),
	(127447, 109, '2015-04-01 00:46:19.000000', 'temperatura', 1109.0000, 'ºC'),
	(127448, 109, '2015-04-01 00:46:20.000000', 'temperatura', 969.0000, 'ºC'),
	(127449, 109, '2015-04-01 00:46:21.000000', 'temperatura', 317.0000, 'ºC'),
	(127450, 109, '2015-04-01 00:46:22.000000', 'temperatura', 1079.0000, 'ºC'),
	(127451, 109, '2015-04-01 00:46:23.000000', 'temperatura', 843.0000, 'ºC'),
	(127452, 109, '2015-04-01 00:46:24.000000', 'temperatura', 979.0000, 'ºC'),
	(127453, 109, '2015-04-01 00:46:25.000000', 'temperatura', 1167.0000, 'ºC'),
	(127454, 109, '2015-04-01 00:46:26.000000', 'temperatura', 497.0000, 'ºC'),
	(127455, 109, '2015-04-01 00:46:27.000000', 'temperatura', 185.0000, 'ºC'),
	(127456, 109, '2015-04-01 00:46:28.000000', 'temperatura', 636.0000, 'ºC'),
	(127457, 109, '2015-04-01 00:46:29.000000', 'temperatura', 225.0000, 'ºC'),
	(127458, 109, '2015-04-01 00:46:30.000000', 'temperatura', 419.0000, 'ºC'),
	(127459, 109, '2015-04-01 00:46:31.000000', 'temperatura', 220.0000, 'ºC'),
	(127460, 109, '2015-04-01 00:46:32.000000', 'temperatura', 1041.0000, 'ºC'),
	(127461, 109, '2015-04-01 00:46:33.000000', 'temperatura', 947.0000, 'ºC'),
	(127462, 109, '2015-04-01 00:46:34.000000', 'temperatura', 414.0000, 'ºC'),
	(127463, 109, '2015-04-01 00:46:35.000000', 'temperatura', 430.0000, 'ºC'),
	(127464, 109, '2015-04-01 00:46:36.000000', 'temperatura', 909.0000, 'ºC'),
	(127465, 109, '2015-04-01 00:46:37.000000', 'temperatura', 853.0000, 'ºC'),
	(127466, 109, '2015-04-01 00:46:38.000000', 'temperatura', 340.0000, 'ºC'),
	(127467, 109, '2015-04-01 00:46:39.000000', 'temperatura', 342.0000, 'ºC'),
	(127468, 109, '2015-04-01 00:46:40.000000', 'temperatura', 689.0000, 'ºC'),
	(127469, 109, '2015-04-01 00:46:41.000000', 'temperatura', 22.0000, 'ºC'),
	(127470, 109, '2015-04-01 00:46:42.000000', 'temperatura', 443.0000, 'ºC'),
	(127471, 109, '2015-04-01 00:46:43.000000', 'temperatura', 950.0000, 'ºC'),
	(127472, 109, '2015-04-01 00:46:44.000000', 'temperatura', 1021.0000, 'ºC'),
	(127473, 109, '2015-04-01 00:46:45.000000', 'temperatura', 1057.0000, 'ºC'),
	(127474, 109, '2015-04-01 00:46:46.000000', 'temperatura', 1021.0000, 'ºC'),
	(127475, 109, '2015-04-01 00:46:47.000000', 'temperatura', 733.0000, 'ºC'),
	(127476, 109, '2015-04-01 00:46:48.000000', 'temperatura', 603.0000, 'ºC'),
	(127477, 109, '2015-04-01 00:46:49.000000', 'temperatura', 819.0000, 'ºC'),
	(127478, 109, '2015-04-01 00:46:50.000000', 'temperatura', 1084.0000, 'ºC'),
	(127479, 109, '2015-04-01 00:46:51.000000', 'temperatura', 564.0000, 'ºC'),
	(127480, 109, '2015-04-01 00:46:52.000000', 'temperatura', 768.0000, 'ºC'),
	(127481, 109, '2015-04-01 00:46:53.000000', 'temperatura', 949.0000, 'ºC'),
	(127482, 109, '2015-04-01 00:46:54.000000', 'temperatura', 41.0000, 'ºC'),
	(127483, 109, '2015-04-01 00:46:55.000000', 'temperatura', 959.0000, 'ºC'),
	(127484, 109, '2015-04-01 00:46:56.000000', 'temperatura', 1074.0000, 'ºC'),
	(127485, 109, '2015-04-01 00:46:57.000000', 'temperatura', 92.0000, 'ºC'),
	(127486, 109, '2015-04-01 00:46:58.000000', 'temperatura', 840.0000, 'ºC'),
	(127487, 109, '2015-04-01 00:46:59.000000', 'temperatura', 322.0000, 'ºC'),
	(127488, 109, '2015-04-01 00:47:00.000000', 'temperatura', 292.0000, 'ºC'),
	(127489, 109, '2015-04-01 00:47:01.000000', 'temperatura', 493.0000, 'ºC'),
	(127490, 109, '2015-04-01 00:47:02.000000', 'temperatura', 390.0000, 'ºC'),
	(127491, 109, '2015-04-01 00:47:03.000000', 'temperatura', 472.0000, 'ºC'),
	(127492, 109, '2015-04-01 00:47:04.000000', 'temperatura', 1192.0000, 'ºC'),
	(127493, 109, '2015-04-01 00:47:05.000000', 'temperatura', 942.0000, 'ºC'),
	(127494, 109, '2015-04-01 00:47:06.000000', 'temperatura', 1134.0000, 'ºC'),
	(127495, 109, '2015-04-01 00:47:07.000000', 'temperatura', 445.0000, 'ºC'),
	(127496, 109, '2015-04-01 00:47:08.000000', 'temperatura', 24.0000, 'ºC'),
	(127497, 109, '2015-04-01 00:47:09.000000', 'temperatura', 1184.0000, 'ºC'),
	(127498, 109, '2015-04-01 00:47:10.000000', 'temperatura', 1047.0000, 'ºC'),
	(127499, 109, '2015-04-01 00:47:11.000000', 'temperatura', 487.0000, 'ºC'),
	(127500, 109, '2015-04-01 00:47:12.000000', 'temperatura', 493.0000, 'ºC'),
	(127501, 109, '2015-04-01 00:47:13.000000', 'temperatura', 1003.0000, 'ºC'),
	(127502, 109, '2015-04-01 00:47:14.000000', 'temperatura', 1137.0000, 'ºC'),
	(127503, 109, '2015-04-01 00:47:15.000000', 'temperatura', 275.0000, 'ºC'),
	(127504, 109, '2015-04-01 00:47:16.000000', 'temperatura', 365.0000, 'ºC'),
	(127505, 109, '2015-04-01 00:47:17.000000', 'temperatura', 1002.0000, 'ºC'),
	(127506, 109, '2015-04-01 00:47:18.000000', 'temperatura', 317.0000, 'ºC'),
	(127507, 109, '2015-04-01 00:47:19.000000', 'temperatura', 977.0000, 'ºC'),
	(127508, 109, '2015-04-01 00:47:20.000000', 'temperatura', 336.0000, 'ºC'),
	(127509, 109, '2015-04-01 00:47:21.000000', 'temperatura', 1149.0000, 'ºC'),
	(127510, 109, '2015-04-01 00:47:22.000000', 'temperatura', 1136.0000, 'ºC'),
	(127511, 109, '2015-04-01 00:47:23.000000', 'temperatura', 1033.0000, 'ºC'),
	(127512, 109, '2015-04-01 00:47:24.000000', 'temperatura', 559.0000, 'ºC'),
	(127513, 109, '2015-04-01 00:47:25.000000', 'temperatura', 897.0000, 'ºC'),
	(127514, 109, '2015-04-01 00:47:26.000000', 'temperatura', 406.0000, 'ºC'),
	(127515, 109, '2015-04-01 00:47:27.000000', 'temperatura', 541.0000, 'ºC'),
	(127516, 109, '2015-04-01 00:47:28.000000', 'temperatura', 287.0000, 'ºC'),
	(127517, 109, '2015-04-01 00:47:29.000000', 'temperatura', 1011.0000, 'ºC'),
	(127518, 109, '2015-04-01 00:47:30.000000', 'temperatura', 598.0000, 'ºC'),
	(127519, 109, '2015-04-01 00:47:31.000000', 'temperatura', 1154.0000, 'ºC'),
	(127520, 109, '2015-04-01 00:47:32.000000', 'temperatura', 378.0000, 'ºC'),
	(127521, 109, '2015-04-01 00:47:33.000000', 'temperatura', 828.0000, 'ºC'),
	(127522, 109, '2015-04-01 00:47:34.000000', 'temperatura', 605.0000, 'ºC'),
	(127523, 109, '2015-04-01 00:47:35.000000', 'temperatura', 544.0000, 'ºC'),
	(127524, 109, '2015-04-01 00:47:36.000000', 'temperatura', 905.0000, 'ºC'),
	(127525, 109, '2015-04-01 00:47:37.000000', 'temperatura', 494.0000, 'ºC'),
	(127526, 109, '2015-04-01 00:47:38.000000', 'temperatura', 956.0000, 'ºC'),
	(127527, 109, '2015-04-01 00:47:39.000000', 'temperatura', 897.0000, 'ºC'),
	(127528, 109, '2015-04-01 00:47:40.000000', 'temperatura', 418.0000, 'ºC'),
	(127529, 109, '2015-04-01 00:47:41.000000', 'temperatura', 599.0000, 'ºC'),
	(127530, 109, '2015-04-01 00:47:42.000000', 'temperatura', 540.0000, 'ºC'),
	(127531, 109, '2015-04-01 00:47:43.000000', 'temperatura', 906.0000, 'ºC'),
	(127532, 109, '2015-04-01 00:47:44.000000', 'temperatura', 509.0000, 'ºC'),
	(127533, 109, '2015-04-01 00:47:45.000000', 'temperatura', 1026.0000, 'ºC'),
	(127534, 109, '2015-04-01 00:47:46.000000', 'temperatura', 5.0000, 'ºC'),
	(127535, 109, '2015-04-01 00:47:47.000000', 'temperatura', 547.0000, 'ºC'),
	(127536, 109, '2015-04-01 00:47:48.000000', 'temperatura', 319.0000, 'ºC'),
	(127537, 109, '2015-04-01 00:47:49.000000', 'temperatura', 1156.0000, 'ºC'),
	(127538, 109, '2015-04-01 00:47:50.000000', 'temperatura', 23.0000, 'ºC'),
	(127539, 109, '2015-04-01 00:47:51.000000', 'temperatura', 247.0000, 'ºC'),
	(127540, 109, '2015-04-01 00:47:52.000000', 'temperatura', 1169.0000, 'ºC'),
	(127541, 109, '2015-04-01 00:47:53.000000', 'temperatura', 302.0000, 'ºC'),
	(127542, 109, '2015-04-01 00:47:54.000000', 'temperatura', 404.0000, 'ºC'),
	(127543, 109, '2015-04-01 00:47:55.000000', 'temperatura', 1115.0000, 'ºC'),
	(127544, 109, '2015-04-01 00:47:56.000000', 'temperatura', 762.0000, 'ºC'),
	(127545, 109, '2015-04-01 00:47:57.000000', 'temperatura', 466.0000, 'ºC'),
	(127546, 109, '2015-04-01 00:47:58.000000', 'temperatura', 47.0000, 'ºC'),
	(127547, 109, '2015-04-01 00:47:59.000000', 'temperatura', 35.0000, 'ºC'),
	(127548, 109, '2015-04-01 00:48:00.000000', 'temperatura', 35.0000, 'ºC'),
	(127549, 109, '2015-04-01 00:48:01.000000', 'temperatura', 71.0000, 'ºC'),
	(127550, 109, '2015-04-01 00:48:02.000000', 'temperatura', 252.0000, 'ºC'),
	(127551, 109, '2015-04-01 00:48:03.000000', 'temperatura', 1046.0000, 'ºC'),
	(127552, 109, '2015-04-01 00:48:04.000000', 'temperatura', 876.0000, 'ºC'),
	(127553, 109, '2015-04-01 00:48:05.000000', 'temperatura', 41.0000, 'ºC'),
	(127554, 109, '2015-04-01 00:48:06.000000', 'temperatura', 1177.0000, 'ºC'),
	(127555, 109, '2015-04-01 00:48:07.000000', 'temperatura', 962.0000, 'ºC'),
	(127556, 109, '2015-04-01 00:48:08.000000', 'temperatura', 79.0000, 'ºC'),
	(127557, 109, '2015-04-01 00:48:09.000000', 'temperatura', 1111.0000, 'ºC'),
	(127558, 109, '2015-04-01 00:48:10.000000', 'temperatura', 520.0000, 'ºC'),
	(127559, 109, '2015-04-01 00:48:11.000000', 'temperatura', 465.0000, 'ºC'),
	(127560, 109, '2015-04-01 00:48:12.000000', 'temperatura', 766.0000, 'ºC'),
	(127561, 109, '2015-04-01 00:48:13.000000', 'temperatura', 34.0000, 'ºC'),
	(127562, 109, '2015-04-01 00:48:14.000000', 'temperatura', 273.0000, 'ºC'),
	(127563, 109, '2015-04-01 00:48:15.000000', 'temperatura', 64.0000, 'ºC'),
	(127564, 109, '2015-04-01 00:48:16.000000', 'temperatura', 701.0000, 'ºC'),
	(127565, 109, '2015-04-01 00:48:17.000000', 'temperatura', 916.0000, 'ºC'),
	(127566, 109, '2015-04-01 00:48:18.000000', 'temperatura', 74.0000, 'ºC'),
	(127567, 109, '2015-04-01 00:48:19.000000', 'temperatura', 24.0000, 'ºC'),
	(127568, 109, '2015-04-01 00:48:20.000000', 'temperatura', 1096.0000, 'ºC'),
	(127569, 109, '2015-04-01 00:48:21.000000', 'temperatura', 612.0000, 'ºC'),
	(127570, 109, '2015-04-01 00:48:22.000000', 'temperatura', 971.0000, 'ºC'),
	(127571, 109, '2015-04-01 00:48:23.000000', 'temperatura', 618.0000, 'ºC'),
	(127572, 109, '2015-04-01 00:48:24.000000', 'temperatura', 177.0000, 'ºC'),
	(127573, 109, '2015-04-01 00:48:25.000000', 'temperatura', 233.0000, 'ºC'),
	(127574, 109, '2015-04-01 00:48:26.000000', 'temperatura', 633.0000, 'ºC'),
	(127575, 109, '2015-04-01 00:48:27.000000', 'temperatura', 69.0000, 'ºC'),
	(127576, 109, '2015-04-01 00:48:28.000000', 'temperatura', 844.0000, 'ºC'),
	(127577, 109, '2015-04-01 00:48:29.000000', 'temperatura', 413.0000, 'ºC'),
	(127578, 109, '2015-04-01 00:48:30.000000', 'temperatura', 733.0000, 'ºC'),
	(127579, 109, '2015-04-01 00:48:31.000000', 'temperatura', 29.0000, 'ºC'),
	(127580, 109, '2015-04-01 00:48:32.000000', 'temperatura', 346.0000, 'ºC'),
	(127581, 109, '2015-04-01 00:48:33.000000', 'temperatura', 444.0000, 'ºC'),
	(127582, 109, '2015-04-01 00:48:34.000000', 'temperatura', 1181.0000, 'ºC'),
	(127583, 109, '2015-04-01 00:48:35.000000', 'temperatura', 976.0000, 'ºC'),
	(127584, 109, '2015-04-01 00:48:36.000000', 'temperatura', 135.0000, 'ºC'),
	(127585, 109, '2015-04-01 00:48:37.000000', 'temperatura', 147.0000, 'ºC'),
	(127586, 109, '2015-04-01 00:48:38.000000', 'temperatura', 331.0000, 'ºC'),
	(127587, 109, '2015-04-01 00:48:39.000000', 'temperatura', 14.0000, 'ºC'),
	(127588, 109, '2015-04-01 00:48:40.000000', 'temperatura', 277.0000, 'ºC'),
	(127589, 109, '2015-04-01 00:48:41.000000', 'temperatura', 146.0000, 'ºC'),
	(127590, 109, '2015-04-01 00:48:42.000000', 'temperatura', 1097.0000, 'ºC'),
	(127591, 109, '2015-04-01 00:48:43.000000', 'temperatura', 250.0000, 'ºC'),
	(127592, 109, '2015-04-01 00:48:44.000000', 'temperatura', 357.0000, 'ºC'),
	(127593, 109, '2015-04-01 00:48:45.000000', 'temperatura', 1034.0000, 'ºC'),
	(127594, 109, '2015-04-01 00:48:46.000000', 'temperatura', 503.0000, 'ºC'),
	(127595, 109, '2015-04-01 00:48:47.000000', 'temperatura', 612.0000, 'ºC'),
	(127596, 109, '2015-04-01 00:48:48.000000', 'temperatura', 351.0000, 'ºC'),
	(127597, 109, '2015-04-01 00:48:49.000000', 'temperatura', 1118.0000, 'ºC'),
	(127598, 109, '2015-04-01 00:48:50.000000', 'temperatura', 938.0000, 'ºC'),
	(127599, 109, '2015-04-01 00:48:51.000000', 'temperatura', 138.0000, 'ºC'),
	(127600, 109, '2015-04-01 00:48:52.000000', 'temperatura', 275.0000, 'ºC'),
	(127601, 109, '2015-04-01 00:48:53.000000', 'temperatura', 962.0000, 'ºC'),
	(127602, 109, '2015-04-01 00:48:54.000000', 'temperatura', 385.0000, 'ºC'),
	(127603, 109, '2015-04-01 00:48:55.000000', 'temperatura', 238.0000, 'ºC'),
	(127604, 109, '2015-04-01 00:48:56.000000', 'temperatura', 38.0000, 'ºC'),
	(127605, 109, '2015-04-01 00:48:57.000000', 'temperatura', 677.0000, 'ºC'),
	(127606, 109, '2015-04-01 00:48:58.000000', 'temperatura', 872.0000, 'ºC'),
	(127607, 109, '2015-04-01 00:48:59.000000', 'temperatura', 1127.0000, 'ºC'),
	(127608, 109, '2015-04-01 00:49:00.000000', 'temperatura', 621.0000, 'ºC'),
	(127609, 109, '2015-04-01 00:49:01.000000', 'temperatura', 923.0000, 'ºC'),
	(127610, 109, '2015-04-01 00:49:02.000000', 'temperatura', 352.0000, 'ºC'),
	(127611, 109, '2015-04-01 00:49:03.000000', 'temperatura', 192.0000, 'ºC'),
	(127612, 109, '2015-04-01 00:49:04.000000', 'temperatura', 1104.0000, 'ºC'),
	(127613, 109, '2015-04-01 00:49:05.000000', 'temperatura', 147.0000, 'ºC'),
	(127614, 109, '2015-04-01 00:49:06.000000', 'temperatura', 1022.0000, 'ºC'),
	(127615, 109, '2015-04-01 00:49:07.000000', 'temperatura', 1071.0000, 'ºC'),
	(127616, 109, '2015-04-01 00:49:08.000000', 'temperatura', 1089.0000, 'ºC'),
	(127617, 109, '2015-04-01 00:49:09.000000', 'temperatura', 1031.0000, 'ºC'),
	(127618, 109, '2015-04-01 00:49:10.000000', 'temperatura', 687.0000, 'ºC'),
	(127619, 109, '2015-04-01 00:49:11.000000', 'temperatura', 346.0000, 'ºC'),
	(127620, 109, '2015-04-01 00:49:12.000000', 'temperatura', 869.0000, 'ºC'),
	(127621, 109, '2015-04-01 00:49:13.000000', 'temperatura', 907.0000, 'ºC'),
	(127622, 109, '2015-04-01 00:49:14.000000', 'temperatura', 730.0000, 'ºC'),
	(127623, 109, '2015-04-01 00:49:15.000000', 'temperatura', 928.0000, 'ºC'),
	(127624, 109, '2015-04-01 00:49:16.000000', 'temperatura', 49.0000, 'ºC'),
	(127625, 109, '2015-04-01 00:49:17.000000', 'temperatura', 1065.0000, 'ºC'),
	(127626, 109, '2015-04-01 00:49:18.000000', 'temperatura', 376.0000, 'ºC'),
	(127627, 109, '2015-04-01 00:49:19.000000', 'temperatura', 1085.0000, 'ºC'),
	(127628, 109, '2015-04-01 00:49:20.000000', 'temperatura', 698.0000, 'ºC'),
	(127629, 109, '2015-04-01 00:49:21.000000', 'temperatura', 236.0000, 'ºC'),
	(127630, 109, '2015-04-01 00:49:22.000000', 'temperatura', 285.0000, 'ºC'),
	(127631, 109, '2015-04-01 00:49:23.000000', 'temperatura', 717.0000, 'ºC'),
	(127632, 109, '2015-04-01 00:49:24.000000', 'temperatura', 334.0000, 'ºC'),
	(127633, 109, '2015-04-01 00:49:25.000000', 'temperatura', 716.0000, 'ºC'),
	(127634, 109, '2015-04-01 00:49:26.000000', 'temperatura', 180.0000, 'ºC'),
	(127635, 109, '2015-04-01 00:49:27.000000', 'temperatura', 1150.0000, 'ºC'),
	(127636, 109, '2015-04-01 00:49:28.000000', 'temperatura', 414.0000, 'ºC'),
	(127637, 109, '2015-04-01 00:49:29.000000', 'temperatura', 1019.0000, 'ºC'),
	(127638, 109, '2015-04-01 00:49:30.000000', 'temperatura', 253.0000, 'ºC'),
	(127639, 109, '2015-04-01 00:49:31.000000', 'temperatura', 608.0000, 'ºC'),
	(127640, 109, '2015-04-01 00:49:32.000000', 'temperatura', 1084.0000, 'ºC'),
	(127641, 109, '2015-04-01 00:49:33.000000', 'temperatura', 1196.0000, 'ºC'),
	(127642, 109, '2015-04-01 00:49:34.000000', 'temperatura', 326.0000, 'ºC'),
	(127643, 109, '2015-04-01 00:49:35.000000', 'temperatura', 444.0000, 'ºC'),
	(127644, 109, '2015-04-01 00:49:36.000000', 'temperatura', 43.0000, 'ºC'),
	(127645, 109, '2015-04-01 00:49:37.000000', 'temperatura', 84.0000, 'ºC'),
	(127646, 109, '2015-04-01 00:49:38.000000', 'temperatura', 290.0000, 'ºC'),
	(127647, 109, '2015-04-01 00:49:39.000000', 'temperatura', 1198.0000, 'ºC'),
	(127648, 109, '2015-04-01 00:49:40.000000', 'temperatura', 321.0000, 'ºC'),
	(127649, 109, '2015-04-01 00:49:41.000000', 'temperatura', 411.0000, 'ºC'),
	(127650, 109, '2015-04-01 00:49:42.000000', 'temperatura', 1093.0000, 'ºC'),
	(127651, 109, '2015-04-01 00:49:43.000000', 'temperatura', 633.0000, 'ºC'),
	(127652, 109, '2015-04-01 00:49:44.000000', 'temperatura', 1086.0000, 'ºC'),
	(127653, 109, '2015-04-01 00:49:45.000000', 'temperatura', 1131.0000, 'ºC'),
	(127654, 109, '2015-04-01 00:49:46.000000', 'temperatura', 1197.0000, 'ºC'),
	(127655, 109, '2015-04-01 00:49:47.000000', 'temperatura', 192.0000, 'ºC'),
	(127656, 109, '2015-04-01 00:49:48.000000', 'temperatura', 970.0000, 'ºC'),
	(127657, 109, '2015-04-01 00:49:49.000000', 'temperatura', 677.0000, 'ºC'),
	(127658, 109, '2015-04-01 00:49:50.000000', 'temperatura', 473.0000, 'ºC'),
	(127659, 109, '2015-04-01 00:49:51.000000', 'temperatura', 335.0000, 'ºC'),
	(127660, 109, '2015-04-01 00:49:52.000000', 'temperatura', 255.0000, 'ºC'),
	(127661, 109, '2015-04-01 00:49:53.000000', 'temperatura', 270.0000, 'ºC'),
	(127662, 109, '2015-04-01 00:49:54.000000', 'temperatura', 585.0000, 'ºC'),
	(127663, 109, '2015-04-01 00:49:55.000000', 'temperatura', 916.0000, 'ºC'),
	(127664, 109, '2015-04-01 00:49:56.000000', 'temperatura', 427.0000, 'ºC'),
	(127665, 109, '2015-04-01 00:49:57.000000', 'temperatura', 588.0000, 'ºC'),
	(127666, 109, '2015-04-01 00:49:58.000000', 'temperatura', 458.0000, 'ºC'),
	(127667, 109, '2015-04-01 00:49:59.000000', 'temperatura', 527.0000, 'ºC'),
	(127668, 109, '2015-04-01 00:50:00.000000', 'temperatura', 62.0000, 'ºC'),
	(127669, 109, '2015-04-01 00:50:01.000000', 'temperatura', 1127.0000, 'ºC'),
	(127670, 109, '2015-04-01 00:50:02.000000', 'temperatura', 651.0000, 'ºC'),
	(127671, 109, '2015-04-01 00:50:03.000000', 'temperatura', 1077.0000, 'ºC'),
	(127672, 109, '2015-04-01 00:50:04.000000', 'temperatura', 1029.0000, 'ºC'),
	(127673, 109, '2015-04-01 00:50:05.000000', 'temperatura', 716.0000, 'ºC'),
	(127674, 109, '2015-04-01 00:50:06.000000', 'temperatura', 492.0000, 'ºC'),
	(127675, 109, '2015-04-01 00:50:07.000000', 'temperatura', 314.0000, 'ºC'),
	(127676, 109, '2015-04-01 00:50:08.000000', 'temperatura', 95.0000, 'ºC'),
	(127677, 109, '2015-04-01 00:50:09.000000', 'temperatura', 732.0000, 'ºC'),
	(127678, 109, '2015-04-01 00:50:10.000000', 'temperatura', 975.0000, 'ºC'),
	(127679, 109, '2015-04-01 00:50:11.000000', 'temperatura', 280.0000, 'ºC'),
	(127680, 109, '2015-04-01 00:50:12.000000', 'temperatura', 874.0000, 'ºC'),
	(127681, 109, '2015-04-01 00:50:13.000000', 'temperatura', 1133.0000, 'ºC'),
	(127682, 109, '2015-04-01 00:50:14.000000', 'temperatura', 641.0000, 'ºC'),
	(127683, 109, '2015-04-01 00:50:15.000000', 'temperatura', 1009.0000, 'ºC'),
	(127684, 109, '2015-04-01 00:50:16.000000', 'temperatura', 720.0000, 'ºC'),
	(127685, 109, '2015-04-01 00:50:17.000000', 'temperatura', 576.0000, 'ºC'),
	(127686, 109, '2015-04-01 00:50:18.000000', 'temperatura', 721.0000, 'ºC'),
	(127687, 109, '2015-04-01 00:50:19.000000', 'temperatura', 676.0000, 'ºC'),
	(127688, 109, '2015-04-01 00:50:20.000000', 'temperatura', 19.0000, 'ºC'),
	(127689, 109, '2015-04-01 00:50:21.000000', 'temperatura', 465.0000, 'ºC'),
	(127690, 109, '2015-04-01 00:50:22.000000', 'temperatura', 1071.0000, 'ºC'),
	(127691, 109, '2015-04-01 00:50:23.000000', 'temperatura', 359.0000, 'ºC'),
	(127692, 109, '2015-04-01 00:50:24.000000', 'temperatura', 984.0000, 'ºC'),
	(127693, 109, '2015-04-01 00:50:25.000000', 'temperatura', 244.0000, 'ºC'),
	(127694, 109, '2015-04-01 00:50:26.000000', 'temperatura', 670.0000, 'ºC'),
	(127695, 109, '2015-04-01 00:50:27.000000', 'temperatura', 215.0000, 'ºC'),
	(127696, 109, '2015-04-01 00:50:28.000000', 'temperatura', 269.0000, 'ºC'),
	(127697, 109, '2015-04-01 00:50:29.000000', 'temperatura', 697.0000, 'ºC'),
	(127698, 109, '2015-04-01 00:50:30.000000', 'temperatura', 280.0000, 'ºC'),
	(127699, 109, '2015-04-01 00:50:31.000000', 'temperatura', 508.0000, 'ºC'),
	(127700, 109, '2015-04-01 00:50:32.000000', 'temperatura', 503.0000, 'ºC'),
	(127701, 109, '2015-04-01 00:50:33.000000', 'temperatura', 989.0000, 'ºC'),
	(127702, 109, '2015-04-01 00:50:34.000000', 'temperatura', 1038.0000, 'ºC'),
	(127703, 109, '2015-04-01 00:50:35.000000', 'temperatura', 1025.0000, 'ºC'),
	(127704, 109, '2015-04-01 00:50:36.000000', 'temperatura', 811.0000, 'ºC'),
	(127705, 109, '2015-04-01 00:50:37.000000', 'temperatura', 981.0000, 'ºC'),
	(127706, 109, '2015-04-01 00:50:38.000000', 'temperatura', 72.0000, 'ºC'),
	(127707, 109, '2015-04-01 00:50:39.000000', 'temperatura', 1016.0000, 'ºC'),
	(127708, 109, '2015-04-01 00:50:40.000000', 'temperatura', 64.0000, 'ºC'),
	(127709, 109, '2015-04-01 00:50:41.000000', 'temperatura', 876.0000, 'ºC'),
	(127710, 109, '2015-04-01 00:50:42.000000', 'temperatura', 585.0000, 'ºC'),
	(127711, 109, '2015-04-01 00:50:43.000000', 'temperatura', 299.0000, 'ºC'),
	(127712, 109, '2015-04-01 00:50:44.000000', 'temperatura', 940.0000, 'ºC'),
	(127713, 109, '2015-04-01 00:50:45.000000', 'temperatura', 202.0000, 'ºC'),
	(127714, 109, '2015-04-01 00:50:46.000000', 'temperatura', 593.0000, 'ºC'),
	(127715, 109, '2015-04-01 00:50:47.000000', 'temperatura', 1159.0000, 'ºC'),
	(127716, 109, '2015-04-01 00:50:48.000000', 'temperatura', 417.0000, 'ºC'),
	(127717, 109, '2015-04-01 00:50:49.000000', 'temperatura', 1008.0000, 'ºC'),
	(127718, 109, '2015-04-01 00:50:50.000000', 'temperatura', 191.0000, 'ºC'),
	(127719, 109, '2015-04-01 00:50:51.000000', 'temperatura', 332.0000, 'ºC'),
	(127720, 109, '2015-04-01 00:50:52.000000', 'temperatura', 1085.0000, 'ºC'),
	(127721, 109, '2015-04-01 00:50:53.000000', 'temperatura', 831.0000, 'ºC'),
	(127722, 109, '2015-04-01 00:50:54.000000', 'temperatura', 899.0000, 'ºC'),
	(127723, 109, '2015-04-01 00:50:55.000000', 'temperatura', 805.0000, 'ºC'),
	(127724, 109, '2015-04-01 00:50:56.000000', 'temperatura', 128.0000, 'ºC'),
	(127725, 109, '2015-04-01 00:50:57.000000', 'temperatura', 627.0000, 'ºC'),
	(127726, 109, '2015-04-01 00:50:58.000000', 'temperatura', 348.0000, 'ºC'),
	(127727, 109, '2015-04-01 00:50:59.000000', 'temperatura', 1063.0000, 'ºC'),
	(127728, 109, '2015-04-01 00:51:00.000000', 'temperatura', 670.0000, 'ºC'),
	(127729, 109, '2015-04-01 00:51:01.000000', 'temperatura', 163.0000, 'ºC'),
	(127730, 109, '2015-04-01 00:51:02.000000', 'temperatura', 6.0000, 'ºC'),
	(127731, 109, '2015-04-01 00:51:03.000000', 'temperatura', 739.0000, 'ºC'),
	(127732, 109, '2015-04-01 00:51:04.000000', 'temperatura', 77.0000, 'ºC'),
	(127733, 109, '2015-04-01 00:51:05.000000', 'temperatura', 571.0000, 'ºC'),
	(127734, 109, '2015-04-01 00:51:06.000000', 'temperatura', 224.0000, 'ºC'),
	(127735, 109, '2015-04-01 00:51:07.000000', 'temperatura', 608.0000, 'ºC'),
	(127736, 109, '2015-04-01 00:51:08.000000', 'temperatura', 1168.0000, 'ºC'),
	(127737, 109, '2015-04-01 00:51:09.000000', 'temperatura', 415.0000, 'ºC'),
	(127738, 109, '2015-04-01 00:51:10.000000', 'temperatura', 971.0000, 'ºC'),
	(127739, 109, '2015-04-01 00:51:11.000000', 'temperatura', 13.0000, 'ºC'),
	(127740, 109, '2015-04-01 00:51:12.000000', 'temperatura', 753.0000, 'ºC'),
	(127741, 109, '2015-04-01 00:51:13.000000', 'temperatura', 124.0000, 'ºC'),
	(127742, 109, '2015-04-01 00:51:14.000000', 'temperatura', 763.0000, 'ºC'),
	(127743, 109, '2015-04-01 00:51:15.000000', 'temperatura', 1042.0000, 'ºC'),
	(127744, 109, '2015-04-01 00:51:16.000000', 'temperatura', 523.0000, 'ºC'),
	(127745, 109, '2015-04-01 00:51:17.000000', 'temperatura', 689.0000, 'ºC'),
	(127746, 109, '2015-04-01 00:51:18.000000', 'temperatura', 675.0000, 'ºC'),
	(127747, 109, '2015-04-01 00:51:19.000000', 'temperatura', 110.0000, 'ºC'),
	(127748, 109, '2015-04-01 00:51:20.000000', 'temperatura', 924.0000, 'ºC'),
	(127749, 109, '2015-04-01 00:51:21.000000', 'temperatura', 693.0000, 'ºC'),
	(127750, 109, '2015-04-01 00:51:22.000000', 'temperatura', 691.0000, 'ºC'),
	(127751, 109, '2015-04-01 00:51:23.000000', 'temperatura', 179.0000, 'ºC'),
	(127752, 109, '2015-04-01 00:51:24.000000', 'temperatura', 23.0000, 'ºC'),
	(127753, 109, '2015-04-01 00:51:25.000000', 'temperatura', 777.0000, 'ºC'),
	(127754, 109, '2015-04-01 00:51:26.000000', 'temperatura', 217.0000, 'ºC'),
	(127755, 109, '2015-04-01 00:51:27.000000', 'temperatura', 1156.0000, 'ºC'),
	(127756, 109, '2015-04-01 00:51:28.000000', 'temperatura', 328.0000, 'ºC'),
	(127757, 109, '2015-04-01 00:51:29.000000', 'temperatura', 571.0000, 'ºC'),
	(127758, 109, '2015-04-01 00:51:30.000000', 'temperatura', 674.0000, 'ºC'),
	(127759, 109, '2015-04-01 00:51:31.000000', 'temperatura', 456.0000, 'ºC'),
	(127760, 109, '2015-04-01 00:51:32.000000', 'temperatura', 259.0000, 'ºC'),
	(127761, 109, '2015-04-01 00:51:33.000000', 'temperatura', 1127.0000, 'ºC'),
	(127762, 109, '2015-04-01 00:51:34.000000', 'temperatura', 60.0000, 'ºC'),
	(127763, 109, '2015-04-01 00:51:35.000000', 'temperatura', 517.0000, 'ºC'),
	(127764, 109, '2015-04-01 00:51:36.000000', 'temperatura', 8.0000, 'ºC'),
	(127765, 109, '2015-04-01 00:51:37.000000', 'temperatura', 887.0000, 'ºC'),
	(127766, 109, '2015-04-01 00:51:38.000000', 'temperatura', 813.0000, 'ºC'),
	(127767, 109, '2015-04-01 00:51:39.000000', 'temperatura', 205.0000, 'ºC'),
	(127768, 109, '2015-04-01 00:51:40.000000', 'temperatura', 985.0000, 'ºC'),
	(127769, 109, '2015-04-01 00:51:41.000000', 'temperatura', 713.0000, 'ºC'),
	(127770, 109, '2015-04-01 00:51:42.000000', 'temperatura', 609.0000, 'ºC'),
	(127771, 109, '2015-04-01 00:51:43.000000', 'temperatura', 907.0000, 'ºC'),
	(127772, 109, '2015-04-01 00:51:44.000000', 'temperatura', 308.0000, 'ºC'),
	(127773, 109, '2015-04-01 00:51:45.000000', 'temperatura', 19.0000, 'ºC'),
	(127774, 109, '2015-04-01 00:51:46.000000', 'temperatura', 371.0000, 'ºC'),
	(127775, 109, '2015-04-01 00:51:47.000000', 'temperatura', 598.0000, 'ºC'),
	(127776, 109, '2015-04-01 00:51:48.000000', 'temperatura', 680.0000, 'ºC'),
	(127777, 109, '2015-04-01 00:51:49.000000', 'temperatura', 405.0000, 'ºC'),
	(127778, 109, '2015-04-01 00:51:50.000000', 'temperatura', 1186.0000, 'ºC'),
	(127779, 109, '2015-04-01 00:51:51.000000', 'temperatura', 1114.0000, 'ºC'),
	(127780, 109, '2015-04-01 00:51:52.000000', 'temperatura', 816.0000, 'ºC'),
	(127781, 109, '2015-04-01 00:51:53.000000', 'temperatura', 735.0000, 'ºC'),
	(127782, 109, '2015-04-01 00:51:54.000000', 'temperatura', 27.0000, 'ºC'),
	(127783, 109, '2015-04-01 00:51:55.000000', 'temperatura', 333.0000, 'ºC'),
	(127784, 109, '2015-04-01 00:51:56.000000', 'temperatura', 385.0000, 'ºC'),
	(127785, 109, '2015-04-01 00:51:57.000000', 'temperatura', 926.0000, 'ºC'),
	(127786, 109, '2015-04-01 00:51:58.000000', 'temperatura', 1075.0000, 'ºC'),
	(127787, 109, '2015-04-01 00:51:59.000000', 'temperatura', 196.0000, 'ºC'),
	(127788, 109, '2015-04-01 00:52:00.000000', 'temperatura', 159.0000, 'ºC'),
	(127789, 109, '2015-04-01 00:52:01.000000', 'temperatura', 204.0000, 'ºC'),
	(127790, 109, '2015-04-01 00:52:02.000000', 'temperatura', 545.0000, 'ºC'),
	(127791, 109, '2015-04-01 00:52:03.000000', 'temperatura', 913.0000, 'ºC'),
	(127792, 109, '2015-04-01 00:52:04.000000', 'temperatura', 532.0000, 'ºC'),
	(127793, 109, '2015-04-01 00:52:05.000000', 'temperatura', 1122.0000, 'ºC'),
	(127794, 109, '2015-04-01 00:52:06.000000', 'temperatura', 414.0000, 'ºC'),
	(127795, 109, '2015-04-01 00:52:07.000000', 'temperatura', 1104.0000, 'ºC'),
	(127796, 109, '2015-04-01 00:52:08.000000', 'temperatura', 677.0000, 'ºC'),
	(127797, 109, '2015-04-01 00:52:09.000000', 'temperatura', 75.0000, 'ºC'),
	(127798, 109, '2015-04-01 00:52:10.000000', 'temperatura', 742.0000, 'ºC'),
	(127799, 109, '2015-04-01 00:52:11.000000', 'temperatura', 1088.0000, 'ºC'),
	(127800, 109, '2015-04-01 00:52:12.000000', 'temperatura', 815.0000, 'ºC'),
	(127801, 109, '2015-04-01 00:52:13.000000', 'temperatura', 811.0000, 'ºC'),
	(127802, 109, '2015-04-01 00:52:14.000000', 'temperatura', 411.0000, 'ºC'),
	(127803, 109, '2015-04-01 00:52:15.000000', 'temperatura', 820.0000, 'ºC'),
	(127804, 109, '2015-04-01 00:52:16.000000', 'temperatura', 471.0000, 'ºC'),
	(127805, 109, '2015-04-01 00:52:17.000000', 'temperatura', 1092.0000, 'ºC'),
	(127806, 109, '2015-04-01 00:52:18.000000', 'temperatura', 451.0000, 'ºC'),
	(127807, 109, '2015-04-01 00:52:19.000000', 'temperatura', 177.0000, 'ºC'),
	(127808, 109, '2015-04-01 00:52:20.000000', 'temperatura', 732.0000, 'ºC'),
	(127809, 109, '2015-04-01 00:52:21.000000', 'temperatura', 730.0000, 'ºC'),
	(127810, 109, '2015-04-01 00:52:22.000000', 'temperatura', 255.0000, 'ºC'),
	(127811, 109, '2015-04-01 00:52:23.000000', 'temperatura', 287.0000, 'ºC'),
	(127812, 109, '2015-04-01 00:52:24.000000', 'temperatura', 669.0000, 'ºC'),
	(127813, 109, '2015-04-01 00:52:25.000000', 'temperatura', 83.0000, 'ºC'),
	(127814, 109, '2015-04-01 00:52:26.000000', 'temperatura', 810.0000, 'ºC'),
	(127815, 109, '2015-04-01 00:52:27.000000', 'temperatura', 201.0000, 'ºC'),
	(127816, 109, '2015-04-01 00:52:28.000000', 'temperatura', 975.0000, 'ºC'),
	(127817, 109, '2015-04-01 00:52:29.000000', 'temperatura', 673.0000, 'ºC'),
	(127818, 109, '2015-04-01 00:52:30.000000', 'temperatura', 442.0000, 'ºC'),
	(127819, 109, '2015-04-01 00:52:31.000000', 'temperatura', 190.0000, 'ºC'),
	(127820, 109, '2015-04-01 00:52:32.000000', 'temperatura', 826.0000, 'ºC'),
	(127821, 109, '2015-04-01 00:52:33.000000', 'temperatura', 1161.0000, 'ºC'),
	(127822, 109, '2015-04-01 00:52:34.000000', 'temperatura', 926.0000, 'ºC'),
	(127823, 109, '2015-04-01 00:52:35.000000', 'temperatura', 1150.0000, 'ºC'),
	(127824, 109, '2015-04-01 00:52:36.000000', 'temperatura', 570.0000, 'ºC'),
	(127825, 109, '2015-04-01 00:52:37.000000', 'temperatura', 602.0000, 'ºC'),
	(127826, 109, '2015-04-01 00:52:38.000000', 'temperatura', 101.0000, 'ºC'),
	(127827, 109, '2015-04-01 00:52:39.000000', 'temperatura', 1098.0000, 'ºC'),
	(127828, 109, '2015-04-01 00:52:40.000000', 'temperatura', 386.0000, 'ºC'),
	(127829, 109, '2015-04-01 00:52:41.000000', 'temperatura', 1039.0000, 'ºC'),
	(127830, 109, '2015-04-01 00:52:42.000000', 'temperatura', 435.0000, 'ºC'),
	(127831, 109, '2015-04-01 00:52:43.000000', 'temperatura', 262.0000, 'ºC'),
	(127832, 109, '2015-04-01 00:52:44.000000', 'temperatura', 3.0000, 'ºC'),
	(127833, 109, '2015-04-01 00:52:45.000000', 'temperatura', 430.0000, 'ºC'),
	(127834, 109, '2015-04-01 00:52:46.000000', 'temperatura', 942.0000, 'ºC'),
	(127835, 109, '2015-04-01 00:52:47.000000', 'temperatura', 1022.0000, 'ºC'),
	(127836, 109, '2015-04-01 00:52:48.000000', 'temperatura', 1084.0000, 'ºC'),
	(127837, 109, '2015-04-01 00:52:49.000000', 'temperatura', 1155.0000, 'ºC'),
	(127838, 109, '2015-04-01 00:52:50.000000', 'temperatura', 122.0000, 'ºC'),
	(127839, 109, '2015-04-01 00:52:51.000000', 'temperatura', 745.0000, 'ºC'),
	(127840, 109, '2015-04-01 00:52:52.000000', 'temperatura', 959.0000, 'ºC'),
	(127841, 109, '2015-04-01 00:52:53.000000', 'temperatura', 162.0000, 'ºC'),
	(127842, 109, '2015-04-01 00:52:54.000000', 'temperatura', 331.0000, 'ºC'),
	(127843, 109, '2015-04-01 00:52:55.000000', 'temperatura', 1171.0000, 'ºC'),
	(127844, 109, '2015-04-01 00:52:56.000000', 'temperatura', 64.0000, 'ºC'),
	(127845, 109, '2015-04-01 00:52:57.000000', 'temperatura', 407.0000, 'ºC'),
	(127846, 109, '2015-04-01 00:52:58.000000', 'temperatura', 642.0000, 'ºC'),
	(127847, 109, '2015-04-01 00:52:59.000000', 'temperatura', 791.0000, 'ºC'),
	(127848, 109, '2015-04-01 00:53:00.000000', 'temperatura', 829.0000, 'ºC'),
	(127849, 109, '2015-04-01 00:53:01.000000', 'temperatura', 574.0000, 'ºC'),
	(127850, 109, '2015-04-01 00:53:02.000000', 'temperatura', 383.0000, 'ºC'),
	(127851, 109, '2015-04-01 00:53:03.000000', 'temperatura', 191.0000, 'ºC'),
	(127852, 109, '2015-04-01 00:53:04.000000', 'temperatura', 1009.0000, 'ºC'),
	(127853, 109, '2015-04-01 00:53:05.000000', 'temperatura', 871.0000, 'ºC'),
	(127854, 109, '2015-04-01 00:53:06.000000', 'temperatura', 127.0000, 'ºC'),
	(127855, 109, '2015-04-01 00:53:07.000000', 'temperatura', 426.0000, 'ºC'),
	(127856, 109, '2015-04-01 00:53:08.000000', 'temperatura', 548.0000, 'ºC'),
	(127857, 109, '2015-04-01 00:53:09.000000', 'temperatura', 263.0000, 'ºC'),
	(127858, 109, '2015-04-01 00:53:10.000000', 'temperatura', 870.0000, 'ºC'),
	(127859, 109, '2015-04-01 00:53:11.000000', 'temperatura', 1161.0000, 'ºC'),
	(127860, 109, '2015-04-01 00:53:12.000000', 'temperatura', 795.0000, 'ºC'),
	(127861, 109, '2015-04-01 00:53:13.000000', 'temperatura', 492.0000, 'ºC'),
	(127862, 109, '2015-04-01 00:53:14.000000', 'temperatura', 75.0000, 'ºC'),
	(127863, 109, '2015-04-01 00:53:15.000000', 'temperatura', 102.0000, 'ºC'),
	(127864, 109, '2015-04-01 00:53:16.000000', 'temperatura', 286.0000, 'ºC'),
	(127865, 109, '2015-04-01 00:53:17.000000', 'temperatura', 1124.0000, 'ºC'),
	(127866, 109, '2015-04-01 00:53:18.000000', 'temperatura', 1163.0000, 'ºC'),
	(127867, 109, '2015-04-01 00:53:19.000000', 'temperatura', 42.0000, 'ºC'),
	(127868, 109, '2015-04-01 00:53:20.000000', 'temperatura', 322.0000, 'ºC'),
	(127869, 109, '2015-04-01 00:53:21.000000', 'temperatura', 285.0000, 'ºC'),
	(127870, 109, '2015-04-01 00:53:22.000000', 'temperatura', 460.0000, 'ºC'),
	(127871, 109, '2015-04-01 00:53:23.000000', 'temperatura', 245.0000, 'ºC'),
	(127872, 109, '2015-04-01 00:53:24.000000', 'temperatura', 1044.0000, 'ºC'),
	(127873, 109, '2015-04-01 00:53:25.000000', 'temperatura', 884.0000, 'ºC'),
	(127874, 109, '2015-04-01 00:53:26.000000', 'temperatura', 92.0000, 'ºC'),
	(127875, 109, '2015-04-01 00:53:27.000000', 'temperatura', 207.0000, 'ºC'),
	(127876, 109, '2015-04-01 00:53:28.000000', 'temperatura', 759.0000, 'ºC'),
	(127877, 109, '2015-04-01 00:53:29.000000', 'temperatura', 775.0000, 'ºC'),
	(127878, 109, '2015-04-01 00:53:30.000000', 'temperatura', 398.0000, 'ºC'),
	(127879, 109, '2015-04-01 00:53:31.000000', 'temperatura', 864.0000, 'ºC'),
	(127880, 109, '2015-04-01 00:53:32.000000', 'temperatura', 728.0000, 'ºC'),
	(127881, 109, '2015-04-01 00:53:33.000000', 'temperatura', 1047.0000, 'ºC'),
	(127882, 109, '2015-04-01 00:53:34.000000', 'temperatura', 652.0000, 'ºC'),
	(127883, 109, '2015-04-01 00:53:35.000000', 'temperatura', 122.0000, 'ºC'),
	(127884, 109, '2015-04-01 00:53:36.000000', 'temperatura', 1052.0000, 'ºC'),
	(127885, 109, '2015-04-01 00:53:37.000000', 'temperatura', 97.0000, 'ºC'),
	(127886, 109, '2015-04-01 00:53:38.000000', 'temperatura', 926.0000, 'ºC'),
	(127887, 109, '2015-04-01 00:53:39.000000', 'temperatura', 742.0000, 'ºC'),
	(127888, 109, '2015-04-01 00:53:40.000000', 'temperatura', 931.0000, 'ºC'),
	(127889, 109, '2015-04-01 00:53:41.000000', 'temperatura', 31.0000, 'ºC'),
	(127890, 109, '2015-04-01 00:53:42.000000', 'temperatura', 961.0000, 'ºC'),
	(127891, 109, '2015-04-01 00:53:43.000000', 'temperatura', 1112.0000, 'ºC'),
	(127892, 109, '2015-04-01 00:53:44.000000', 'temperatura', 278.0000, 'ºC'),
	(127893, 109, '2015-04-01 00:53:45.000000', 'temperatura', 455.0000, 'ºC'),
	(127894, 109, '2015-04-01 00:53:46.000000', 'temperatura', 241.0000, 'ºC'),
	(127895, 109, '2015-04-01 00:53:47.000000', 'temperatura', 1040.0000, 'ºC'),
	(127896, 109, '2015-04-01 00:53:48.000000', 'temperatura', 876.0000, 'ºC'),
	(127897, 109, '2015-04-01 00:53:49.000000', 'temperatura', 63.0000, 'ºC'),
	(127898, 109, '2015-04-01 00:53:50.000000', 'temperatura', 88.0000, 'ºC'),
	(127899, 109, '2015-04-01 00:53:51.000000', 'temperatura', 251.0000, 'ºC'),
	(127900, 109, '2015-04-01 00:53:52.000000', 'temperatura', 992.0000, 'ºC'),
	(127901, 109, '2015-04-01 00:53:53.000000', 'temperatura', 606.0000, 'ºC'),
	(127902, 109, '2015-04-01 00:53:54.000000', 'temperatura', 56.0000, 'ºC'),
	(127903, 109, '2015-04-01 00:53:55.000000', 'temperatura', 864.0000, 'ºC'),
	(127904, 109, '2015-04-01 00:53:56.000000', 'temperatura', 549.0000, 'ºC'),
	(127905, 109, '2015-04-01 00:53:57.000000', 'temperatura', 155.0000, 'ºC'),
	(127906, 109, '2015-04-01 00:53:58.000000', 'temperatura', 329.0000, 'ºC'),
	(127907, 109, '2015-04-01 00:53:59.000000', 'temperatura', 1182.0000, 'ºC'),
	(127908, 109, '2015-04-01 00:54:00.000000', 'temperatura', 123.0000, 'ºC'),
	(127909, 109, '2015-04-01 00:54:01.000000', 'temperatura', 667.0000, 'ºC'),
	(127910, 109, '2015-04-01 00:54:02.000000', 'temperatura', 569.0000, 'ºC'),
	(127911, 109, '2015-04-01 00:54:03.000000', 'temperatura', 842.0000, 'ºC'),
	(127912, 109, '2015-04-01 00:54:04.000000', 'temperatura', 103.0000, 'ºC'),
	(127913, 109, '2015-04-01 00:54:05.000000', 'temperatura', 391.0000, 'ºC'),
	(127914, 109, '2015-04-01 00:54:06.000000', 'temperatura', 446.0000, 'ºC'),
	(127915, 109, '2015-04-01 00:54:07.000000', 'temperatura', 1056.0000, 'ºC'),
	(127916, 109, '2015-04-01 00:54:08.000000', 'temperatura', 343.0000, 'ºC'),
	(127917, 109, '2015-04-01 00:54:09.000000', 'temperatura', 947.0000, 'ºC'),
	(127918, 109, '2015-04-01 00:54:10.000000', 'temperatura', 108.0000, 'ºC'),
	(127919, 109, '2015-04-01 00:54:11.000000', 'temperatura', 99.0000, 'ºC'),
	(127920, 109, '2015-04-01 00:54:12.000000', 'temperatura', 173.0000, 'ºC'),
	(127921, 109, '2015-04-01 00:54:13.000000', 'temperatura', 569.0000, 'ºC'),
	(127922, 109, '2015-04-01 00:54:14.000000', 'temperatura', 1124.0000, 'ºC'),
	(127923, 109, '2015-04-01 00:54:15.000000', 'temperatura', 312.0000, 'ºC'),
	(127924, 109, '2015-04-01 00:54:16.000000', 'temperatura', 592.0000, 'ºC'),
	(127925, 109, '2015-04-01 00:54:17.000000', 'temperatura', 825.0000, 'ºC'),
	(127926, 109, '2015-04-01 00:54:18.000000', 'temperatura', 1147.0000, 'ºC'),
	(127927, 109, '2015-04-01 00:54:19.000000', 'temperatura', 863.0000, 'ºC'),
	(127928, 109, '2015-04-01 00:54:20.000000', 'temperatura', 872.0000, 'ºC'),
	(127929, 109, '2015-04-01 00:54:21.000000', 'temperatura', 574.0000, 'ºC'),
	(127930, 109, '2015-04-01 00:54:22.000000', 'temperatura', 254.0000, 'ºC'),
	(127931, 109, '2015-04-01 00:54:23.000000', 'temperatura', 746.0000, 'ºC'),
	(127932, 109, '2015-04-01 00:54:24.000000', 'temperatura', 571.0000, 'ºC'),
	(127933, 109, '2015-04-01 00:54:25.000000', 'temperatura', 619.0000, 'ºC'),
	(127934, 109, '2015-04-01 00:54:26.000000', 'temperatura', 179.0000, 'ºC'),
	(127935, 109, '2015-04-01 00:54:27.000000', 'temperatura', 242.0000, 'ºC'),
	(127936, 109, '2015-04-01 00:54:28.000000', 'temperatura', 670.0000, 'ºC'),
	(127937, 109, '2015-04-01 00:54:29.000000', 'temperatura', 228.0000, 'ºC'),
	(127938, 109, '2015-04-01 00:54:30.000000', 'temperatura', 329.0000, 'ºC'),
	(127939, 109, '2015-04-01 00:54:31.000000', 'temperatura', 961.0000, 'ºC'),
	(127940, 109, '2015-04-01 00:54:32.000000', 'temperatura', 220.0000, 'ºC'),
	(127941, 109, '2015-04-01 00:54:33.000000', 'temperatura', 615.0000, 'ºC'),
	(127942, 109, '2015-04-01 00:54:34.000000', 'temperatura', 17.0000, 'ºC'),
	(127943, 109, '2015-04-01 00:54:35.000000', 'temperatura', 642.0000, 'ºC'),
	(127944, 109, '2015-04-01 00:54:36.000000', 'temperatura', 759.0000, 'ºC'),
	(127945, 109, '2015-04-01 00:54:37.000000', 'temperatura', 671.0000, 'ºC'),
	(127946, 109, '2015-04-01 00:54:38.000000', 'temperatura', 1075.0000, 'ºC'),
	(127947, 109, '2015-04-01 00:54:39.000000', 'temperatura', 965.0000, 'ºC'),
	(127948, 109, '2015-04-01 00:54:40.000000', 'temperatura', 398.0000, 'ºC'),
	(127949, 109, '2015-04-01 00:54:41.000000', 'temperatura', 299.0000, 'ºC'),
	(127950, 109, '2015-04-01 00:54:42.000000', 'temperatura', 299.0000, 'ºC'),
	(127951, 109, '2015-04-01 00:54:43.000000', 'temperatura', 599.0000, 'ºC'),
	(127952, 109, '2015-04-01 00:54:44.000000', 'temperatura', 899.0000, 'ºC'),
	(127953, 109, '2015-04-01 00:54:45.000000', 'temperatura', 298.0000, 'ºC'),
	(127954, 109, '2015-04-01 00:54:46.000000', 'temperatura', 1195.0000, 'ºC'),
	(127955, 109, '2015-04-01 00:54:47.000000', 'temperatura', 282.0000, 'ºC'),
	(127956, 109, '2015-04-01 00:54:48.000000', 'temperatura', 223.0000, 'ºC'),
	(127957, 109, '2015-04-01 00:54:49.000000', 'temperatura', 271.0000, 'ºC'),
	(127958, 109, '2015-04-01 00:54:50.000000', 'temperatura', 684.0000, 'ºC'),
	(127959, 109, '2015-04-01 00:54:51.000000', 'temperatura', 211.0000, 'ºC'),
	(127960, 109, '2015-04-01 00:54:52.000000', 'temperatura', 200.0000, 'ºC'),
	(127961, 109, '2015-04-01 00:54:53.000000', 'temperatura', 370.0000, 'ºC'),
	(127962, 109, '2015-04-01 00:54:54.000000', 'temperatura', 51.0000, 'ºC'),
	(127963, 109, '2015-04-01 00:54:55.000000', 'temperatura', 345.0000, 'ºC'),
	(127964, 109, '2015-04-01 00:54:56.000000', 'temperatura', 371.0000, 'ºC'),
	(127965, 109, '2015-04-01 00:54:57.000000', 'temperatura', 820.0000, 'ºC'),
	(127966, 109, '2015-04-01 00:54:58.000000', 'temperatura', 589.0000, 'ºC'),
	(127967, 109, '2015-04-01 00:54:59.000000', 'temperatura', 486.0000, 'ºC'),
	(127968, 109, '2015-04-01 00:55:00.000000', 'temperatura', 664.0000, 'ºC'),
	(127969, 109, '2015-04-01 00:55:01.000000', 'temperatura', 660.0000, 'ºC'),
	(127970, 109, '2015-04-01 00:55:02.000000', 'temperatura', 110.0000, 'ºC'),
	(127971, 109, '2015-04-01 00:55:03.000000', 'temperatura', 968.0000, 'ºC'),
	(127972, 109, '2015-04-01 00:55:04.000000', 'temperatura', 914.0000, 'ºC'),
	(127973, 109, '2015-04-01 00:55:05.000000', 'temperatura', 465.0000, 'ºC'),
	(127974, 109, '2015-04-01 00:55:06.000000', 'temperatura', 782.0000, 'ºC'),
	(127975, 109, '2015-04-01 00:55:07.000000', 'temperatura', 115.0000, 'ºC'),
	(127976, 109, '2015-04-01 00:55:08.000000', 'temperatura', 632.0000, 'ºC'),
	(127977, 109, '2015-04-01 00:55:09.000000', 'temperatura', 413.0000, 'ºC'),
	(127978, 109, '2015-04-01 00:55:10.000000', 'temperatura', 169.0000, 'ºC'),
	(127979, 109, '2015-04-01 00:55:11.000000', 'temperatura', 808.0000, 'ºC'),
	(127980, 109, '2015-04-01 00:55:12.000000', 'temperatura', 1135.0000, 'ºC'),
	(127981, 109, '2015-04-01 00:55:13.000000', 'temperatura', 851.0000, 'ºC'),
	(127982, 109, '2015-04-01 00:55:14.000000', 'temperatura', 850.0000, 'ºC'),
	(127983, 109, '2015-04-01 00:55:15.000000', 'temperatura', 498.0000, 'ºC'),
	(127984, 109, '2015-04-01 00:55:16.000000', 'temperatura', 1139.0000, 'ºC'),
	(127985, 109, '2015-04-01 00:55:17.000000', 'temperatura', 602.0000, 'ºC'),
	(127986, 109, '2015-04-01 00:55:18.000000', 'temperatura', 792.0000, 'ºC'),
	(127987, 109, '2015-04-01 00:55:19.000000', 'temperatura', 957.0000, 'ºC'),
	(127988, 109, '2015-04-01 00:55:20.000000', 'temperatura', 8.0000, 'ºC'),
	(127989, 109, '2015-04-01 00:55:21.000000', 'temperatura', 772.0000, 'ºC'),
	(127990, 109, '2015-04-01 00:55:22.000000', 'temperatura', 235.0000, 'ºC'),
	(127991, 109, '2015-04-01 00:55:23.000000', 'temperatura', 59.0000, 'ºC'),
	(127992, 109, '2015-04-01 00:55:24.000000', 'temperatura', 790.0000, 'ºC'),
	(127993, 109, '2015-04-01 00:55:25.000000', 'temperatura', 175.0000, 'ºC'),
	(127994, 109, '2015-04-01 00:55:26.000000', 'temperatura', 906.0000, 'ºC'),
	(127995, 109, '2015-04-01 00:55:27.000000', 'temperatura', 406.0000, 'ºC'),
	(127996, 109, '2015-04-01 00:55:28.000000', 'temperatura', 511.0000, 'ºC'),
	(127997, 109, '2015-04-01 00:55:29.000000', 'temperatura', 136.0000, 'ºC'),
	(127998, 109, '2015-04-01 00:55:30.000000', 'temperatura', 351.0000, 'ºC'),
	(127999, 109, '2015-04-01 00:55:31.000000', 'temperatura', 145.0000, 'ºC'),
	(128000, 109, '2015-04-01 00:55:32.000000', 'temperatura', 874.0000, 'ºC'),
	(128001, 109, '2015-04-01 00:55:33.000000', 'temperatura', 335.0000, 'ºC'),
	(128002, 109, '2015-04-01 00:55:34.000000', 'temperatura', 255.0000, 'ºC'),
	(128003, 109, '2015-04-01 00:55:35.000000', 'temperatura', 268.0000, 'ºC'),
	(128004, 109, '2015-04-01 00:55:36.000000', 'temperatura', 577.0000, 'ºC'),
	(128005, 109, '2015-04-01 00:55:37.000000', 'temperatura', 881.0000, 'ºC'),
	(128006, 109, '2015-04-01 00:55:38.000000', 'temperatura', 275.0000, 'ºC'),
	(128007, 109, '2015-04-01 00:55:39.000000', 'temperatura', 1133.0000, 'ºC'),
	(128008, 109, '2015-04-01 00:55:40.000000', 'temperatura', 42.0000, 'ºC'),
	(128009, 109, '2015-04-01 00:55:41.000000', 'temperatura', 410.0000, 'ºC'),
	(128010, 109, '2015-04-01 00:55:42.000000', 'temperatura', 725.0000, 'ºC'),
	(128011, 109, '2015-04-01 00:55:43.000000', 'temperatura', 1195.0000, 'ºC'),
	(128012, 109, '2015-04-01 00:55:44.000000', 'temperatura', 202.0000, 'ºC'),
	(128013, 109, '2015-04-01 00:55:45.000000', 'temperatura', 1023.0000, 'ºC'),
	(128014, 109, '2015-04-01 00:55:46.000000', 'temperatura', 910.0000, 'ºC'),
	(128015, 109, '2015-04-01 00:55:47.000000', 'temperatura', 280.0000, 'ºC'),
	(128016, 110, '2015-04-01 00:00:00.000000', 'temperatura', 920.0000, 'ºC'),
	(128017, 110, '2015-04-01 00:00:01.000000', 'temperatura', 185.0000, 'ºC'),
	(128018, 110, '2015-04-01 00:00:02.000000', 'temperatura', 567.0000, 'ºC'),
	(128019, 110, '2015-04-01 00:00:03.000000', 'temperatura', 1079.0000, 'ºC'),
	(128020, 110, '2015-04-01 00:00:04.000000', 'temperatura', 96.0000, 'ºC'),
	(128021, 110, '2015-04-01 00:00:05.000000', 'temperatura', 843.0000, 'ºC'),
	(128022, 110, '2015-04-01 00:00:06.000000', 'temperatura', 327.0000, 'ºC'),
	(128023, 110, '2015-04-01 00:00:07.000000', 'temperatura', 306.0000, 'ºC'),
	(128024, 110, '2015-04-01 00:00:08.000000', 'temperatura', 549.0000, 'ºC'),
	(128025, 110, '2015-04-01 00:00:09.000000', 'temperatura', 627.0000, 'ºC'),
	(128026, 110, '2015-04-01 00:00:10.000000', 'temperatura', 288.0000, 'ºC'),
	(128027, 110, '2015-04-01 00:00:11.000000', 'temperatura', 761.0000, 'ºC'),
	(128028, 110, '2015-04-01 00:00:12.000000', 'temperatura', 540.0000, 'ºC'),
	(128029, 110, '2015-04-01 00:00:13.000000', 'temperatura', 418.0000, 'ºC'),
	(128030, 110, '2015-04-01 00:00:14.000000', 'temperatura', 472.0000, 'ºC'),
	(128031, 110, '2015-04-01 00:00:15.000000', 'temperatura', 1105.0000, 'ºC'),
	(128032, 110, '2015-04-01 00:00:16.000000', 'temperatura', 510.0000, 'ºC'),
	(128033, 110, '2015-04-01 00:00:17.000000', 'temperatura', 437.0000, 'ºC'),
	(128034, 110, '2015-04-01 00:00:18.000000', 'temperatura', 654.0000, 'ºC'),
	(128035, 110, '2015-04-01 00:00:19.000000', 'temperatura', 760.0000, 'ºC'),
	(128036, 110, '2015-04-01 00:00:20.000000', 'temperatura', 638.0000, 'ºC'),
	(128037, 110, '2015-04-01 00:00:21.000000', 'temperatura', 909.0000, 'ºC'),
	(128038, 110, '2015-04-01 00:00:22.000000', 'temperatura', 234.0000, 'ºC'),
	(128039, 110, '2015-04-01 00:00:23.000000', 'temperatura', 842.0000, 'ºC'),
	(128040, 110, '2015-04-01 00:00:24.000000', 'temperatura', 1109.0000, 'ºC'),
	(128041, 110, '2015-04-01 00:00:25.000000', 'temperatura', 618.0000, 'ºC'),
	(128042, 110, '2015-04-01 00:00:26.000000', 'temperatura', 967.0000, 'ºC'),
	(128043, 110, '2015-04-01 00:00:27.000000', 'temperatura', 578.0000, 'ºC'),
	(128044, 110, '2015-04-01 00:00:28.000000', 'temperatura', 1191.0000, 'ºC'),
	(128045, 110, '2015-04-01 00:00:29.000000', 'temperatura', 622.0000, 'ºC'),
	(128046, 110, '2015-04-01 00:00:30.000000', 'temperatura', 738.0000, 'ºC'),
	(128047, 110, '2015-04-01 00:00:31.000000', 'temperatura', 623.0000, 'ºC'),
	(128048, 110, '2015-04-01 00:00:32.000000', 'temperatura', 901.0000, 'ºC'),
	(128049, 110, '2015-04-01 00:00:33.000000', 'temperatura', 237.0000, 'ºC'),
	(128050, 110, '2015-04-01 00:00:34.000000', 'temperatura', 881.0000, 'ºC'),
	(128051, 110, '2015-04-01 00:00:35.000000', 'temperatura', 97.0000, 'ºC'),
	(128052, 110, '2015-04-01 00:00:36.000000', 'temperatura', 243.0000, 'ºC'),
	(128053, 110, '2015-04-01 00:00:37.000000', 'temperatura', 925.0000, 'ºC'),
	(128054, 110, '2015-04-01 00:00:38.000000', 'temperatura', 295.0000, 'ºC'),
	(128055, 110, '2015-04-01 00:00:39.000000', 'temperatura', 1101.0000, 'ºC'),
	(128056, 110, '2015-04-01 00:00:40.000000', 'temperatura', 1020.0000, 'ºC'),
	(128057, 110, '2015-04-01 00:00:41.000000', 'temperatura', 600.0000, 'ºC'),
	(128058, 110, '2015-04-01 00:00:42.000000', 'temperatura', 1138.0000, 'ºC'),
	(128059, 110, '2015-04-01 00:00:43.000000', 'temperatura', 291.0000, 'ºC'),
	(128060, 110, '2015-04-01 00:00:44.000000', 'temperatura', 440.0000, 'ºC'),
	(128061, 110, '2015-04-01 00:00:45.000000', 'temperatura', 130.0000, 'ºC'),
	(128062, 110, '2015-04-01 00:00:46.000000', 'temperatura', 529.0000, 'ºC'),
	(128063, 110, '2015-04-01 00:00:47.000000', 'temperatura', 1058.0000, 'ºC'),
	(128064, 110, '2015-04-01 00:00:48.000000', 'temperatura', 101.0000, 'ºC'),
	(128065, 110, '2015-04-01 00:00:49.000000', 'temperatura', 932.0000, 'ºC'),
	(128066, 110, '2015-04-01 00:00:50.000000', 'temperatura', 756.0000, 'ºC'),
	(128067, 110, '2015-04-01 00:00:51.000000', 'temperatura', 987.0000, 'ºC'),
	(128068, 110, '2015-04-01 00:00:52.000000', 'temperatura', 265.0000, 'ºC'),
	(128069, 110, '2015-04-01 00:00:53.000000', 'temperatura', 765.0000, 'ºC'),
	(128070, 110, '2015-04-01 00:00:54.000000', 'temperatura', 632.0000, 'ºC'),
	(128071, 110, '2015-04-01 00:00:55.000000', 'temperatura', 863.0000, 'ºC'),
	(128072, 110, '2015-04-01 00:00:56.000000', 'temperatura', 19.0000, 'ºC'),
	(128073, 110, '2015-04-01 00:00:57.000000', 'temperatura', 1108.0000, 'ºC'),
	(128074, 110, '2015-04-01 00:00:58.000000', 'temperatura', 684.0000, 'ºC'),
	(128075, 110, '2015-04-01 00:00:59.000000', 'temperatura', 95.0000, 'ºC'),
	(128076, 110, '2015-04-01 00:01:00.000000', 'temperatura', 825.0000, 'ºC'),
	(128077, 110, '2015-04-01 00:01:01.000000', 'temperatura', 241.0000, 'ºC'),
	(128078, 110, '2015-04-01 00:01:02.000000', 'temperatura', 1131.0000, 'ºC'),
	(128079, 110, '2015-04-01 00:01:03.000000', 'temperatura', 132.0000, 'ºC'),
	(128080, 110, '2015-04-01 00:01:04.000000', 'temperatura', 865.0000, 'ºC'),
	(128081, 110, '2015-04-01 00:01:05.000000', 'temperatura', 332.0000, 'ºC'),
	(128082, 110, '2015-04-01 00:01:06.000000', 'temperatura', 266.0000, 'ºC'),
	(128083, 110, '2015-04-01 00:01:07.000000', 'temperatura', 333.0000, 'ºC'),
	(128084, 110, '2015-04-01 00:01:08.000000', 'temperatura', 869.0000, 'ºC'),
	(128085, 110, '2015-04-01 00:01:09.000000', 'temperatura', 945.0000, 'ºC'),
	(128086, 110, '2015-04-01 00:01:10.000000', 'temperatura', 920.0000, 'ºC'),
	(128087, 110, '2015-04-01 00:01:11.000000', 'temperatura', 566.0000, 'ºC'),
	(128088, 110, '2015-04-01 00:01:12.000000', 'temperatura', 71.0000, 'ºC'),
	(128089, 110, '2015-04-01 00:01:13.000000', 'temperatura', 1055.0000, 'ºC'),
	(128090, 110, '2015-04-01 00:01:14.000000', 'temperatura', 262.0000, 'ºC'),
	(128091, 110, '2015-04-01 00:01:15.000000', 'temperatura', 548.0000, 'ºC'),
	(128092, 110, '2015-04-01 00:01:16.000000', 'temperatura', 755.0000, 'ºC'),
	(128093, 110, '2015-04-01 00:01:17.000000', 'temperatura', 929.0000, 'ºC'),
	(128094, 110, '2015-04-01 00:01:18.000000', 'temperatura', 1180.0000, 'ºC'),
	(128095, 110, '2015-04-01 00:01:19.000000', 'temperatura', 716.0000, 'ºC'),
	(128096, 110, '2015-04-01 00:01:20.000000', 'temperatura', 37.0000, 'ºC'),
	(128097, 110, '2015-04-01 00:01:21.000000', 'temperatura', 441.0000, 'ºC'),
	(128098, 110, '2015-04-01 00:01:22.000000', 'temperatura', 893.0000, 'ºC'),
	(128099, 110, '2015-04-01 00:01:23.000000', 'temperatura', 741.0000, 'ºC'),
	(128100, 110, '2015-04-01 00:01:24.000000', 'temperatura', 1030.0000, 'ºC'),
	(128101, 110, '2015-04-01 00:01:25.000000', 'temperatura', 524.0000, 'ºC'),
	(128102, 110, '2015-04-01 00:01:26.000000', 'temperatura', 733.0000, 'ºC'),
	(128103, 110, '2015-04-01 00:01:27.000000', 'temperatura', 891.0000, 'ºC'),
	(128104, 110, '2015-04-01 00:01:28.000000', 'temperatura', 1058.0000, 'ºC'),
	(128105, 110, '2015-04-01 00:01:29.000000', 'temperatura', 217.0000, 'ºC'),
	(128106, 110, '2015-04-01 00:01:30.000000', 'temperatura', 311.0000, 'ºC'),
	(128107, 110, '2015-04-01 00:01:31.000000', 'temperatura', 906.0000, 'ºC'),
	(128108, 110, '2015-04-01 00:01:32.000000', 'temperatura', 1195.0000, 'ºC'),
	(128109, 110, '2015-04-01 00:01:33.000000', 'temperatura', 861.0000, 'ºC'),
	(128110, 110, '2015-04-01 00:01:34.000000', 'temperatura', 717.0000, 'ºC'),
	(128111, 110, '2015-04-01 00:01:35.000000', 'temperatura', 1003.0000, 'ºC'),
	(128112, 110, '2015-04-01 00:01:36.000000', 'temperatura', 465.0000, 'ºC'),
	(128113, 110, '2015-04-01 00:01:37.000000', 'temperatura', 516.0000, 'ºC'),
	(128114, 110, '2015-04-01 00:01:38.000000', 'temperatura', 1185.0000, 'ºC'),
	(128115, 110, '2015-04-01 00:01:39.000000', 'temperatura', 779.0000, 'ºC'),
	(128116, 110, '2015-04-01 00:01:40.000000', 'temperatura', 339.0000, 'ºC'),
	(128117, 110, '2015-04-01 00:01:41.000000', 'temperatura', 557.0000, 'ºC'),
	(128118, 110, '2015-04-01 00:01:42.000000', 'temperatura', 572.0000, 'ºC'),
	(128119, 110, '2015-04-01 00:01:43.000000', 'temperatura', 1187.0000, 'ºC'),
	(128120, 110, '2015-04-01 00:01:44.000000', 'temperatura', 622.0000, 'ºC'),
	(128121, 110, '2015-04-01 00:01:45.000000', 'temperatura', 747.0000, 'ºC'),
	(128122, 110, '2015-04-01 00:01:46.000000', 'temperatura', 672.0000, 'ºC'),
	(128123, 110, '2015-04-01 00:01:47.000000', 'temperatura', 1117.0000, 'ºC'),
	(128124, 110, '2015-04-01 00:01:48.000000', 'temperatura', 1171.0000, 'ºC'),
	(128125, 110, '2015-04-01 00:01:49.000000', 'temperatura', 103.0000, 'ºC'),
	(128126, 110, '2015-04-01 00:01:50.000000', 'temperatura', 605.0000, 'ºC'),
	(128127, 110, '2015-04-01 00:01:51.000000', 'temperatura', 314.0000, 'ºC'),
	(128128, 110, '2015-04-01 00:01:52.000000', 'temperatura', 957.0000, 'ºC'),
	(128129, 110, '2015-04-01 00:01:53.000000', 'temperatura', 243.0000, 'ºC'),
	(128130, 110, '2015-04-01 00:01:54.000000', 'temperatura', 746.0000, 'ºC'),
	(128131, 110, '2015-04-01 00:01:55.000000', 'temperatura', 602.0000, 'ºC'),
	(128132, 110, '2015-04-01 00:01:56.000000', 'temperatura', 772.0000, 'ºC'),
	(128133, 110, '2015-04-01 00:01:57.000000', 'temperatura', 856.0000, 'ºC'),
	(128134, 110, '2015-04-01 00:01:58.000000', 'temperatura', 763.0000, 'ºC'),
	(128135, 110, '2015-04-01 00:01:59.000000', 'temperatura', 47.0000, 'ºC'),
	(128136, 110, '2015-04-01 00:02:00.000000', 'temperatura', 345.0000, 'ºC'),
	(128137, 110, '2015-04-01 00:02:01.000000', 'temperatura', 387.0000, 'ºC'),
	(128138, 110, '2015-04-01 00:02:02.000000', 'temperatura', 901.0000, 'ºC'),
	(128139, 110, '2015-04-01 00:02:03.000000', 'temperatura', 944.0000, 'ºC'),
	(128140, 110, '2015-04-01 00:02:04.000000', 'temperatura', 818.0000, 'ºC'),
	(128141, 110, '2015-04-01 00:02:05.000000', 'temperatura', 59.0000, 'ºC'),
	(128142, 110, '2015-04-01 00:02:06.000000', 'temperatura', 239.0000, 'ºC'),
	(128143, 110, '2015-04-01 00:02:07.000000', 'temperatura', 1020.0000, 'ºC'),
	(128144, 110, '2015-04-01 00:02:08.000000', 'temperatura', 783.0000, 'ºC'),
	(128145, 110, '2015-04-01 00:02:09.000000', 'temperatura', 856.0000, 'ºC'),
	(128146, 110, '2015-04-01 00:02:10.000000', 'temperatura', 730.0000, 'ºC'),
	(128147, 110, '2015-04-01 00:02:11.000000', 'temperatura', 1084.0000, 'ºC'),
	(128148, 110, '2015-04-01 00:02:12.000000', 'temperatura', 829.0000, 'ºC'),
	(128149, 110, '2015-04-01 00:02:13.000000', 'temperatura', 896.0000, 'ºC'),
	(128150, 110, '2015-04-01 00:02:14.000000', 'temperatura', 792.0000, 'ºC'),
	(128151, 110, '2015-04-01 00:02:15.000000', 'temperatura', 71.0000, 'ºC'),
	(128152, 110, '2015-04-01 00:02:16.000000', 'temperatura', 383.0000, 'ºC'),
	(128153, 110, '2015-04-01 00:02:17.000000', 'temperatura', 499.0000, 'ºC'),
	(128154, 110, '2015-04-01 00:02:18.000000', 'temperatura', 148.0000, 'ºC'),
	(128155, 110, '2015-04-01 00:02:19.000000', 'temperatura', 445.0000, 'ºC'),
	(128156, 110, '2015-04-01 00:02:20.000000', 'temperatura', 580.0000, 'ºC'),
	(128157, 110, '2015-04-01 00:02:21.000000', 'temperatura', 366.0000, 'ºC'),
	(128158, 110, '2015-04-01 00:02:22.000000', 'temperatura', 89.0000, 'ºC'),
	(128159, 110, '2015-04-01 00:02:23.000000', 'temperatura', 548.0000, 'ºC'),
	(128160, 110, '2015-04-01 00:02:24.000000', 'temperatura', 76.0000, 'ºC'),
	(128161, 110, '2015-04-01 00:02:25.000000', 'temperatura', 1134.0000, 'ºC'),
	(128162, 110, '2015-04-01 00:02:26.000000', 'temperatura', 643.0000, 'ºC'),
	(128163, 110, '2015-04-01 00:02:27.000000', 'temperatura', 1012.0000, 'ºC'),
	(128164, 110, '2015-04-01 00:02:28.000000', 'temperatura', 734.0000, 'ºC'),
	(128165, 110, '2015-04-01 00:02:29.000000', 'temperatura', 633.0000, 'ºC'),
	(128166, 110, '2015-04-01 00:02:30.000000', 'temperatura', 964.0000, 'ºC'),
	(128167, 110, '2015-04-01 00:02:31.000000', 'temperatura', 523.0000, 'ºC'),
	(128168, 110, '2015-04-01 00:02:32.000000', 'temperatura', 924.0000, 'ºC'),
	(128169, 110, '2015-04-01 00:02:33.000000', 'temperatura', 651.0000, 'ºC'),
	(128170, 110, '2015-04-01 00:02:34.000000', 'temperatura', 484.0000, 'ºC'),
	(128171, 110, '2015-04-01 00:02:35.000000', 'temperatura', 468.0000, 'ºC'),
	(128172, 110, '2015-04-01 00:02:36.000000', 'temperatura', 888.0000, 'ºC'),
	(128173, 110, '2015-04-01 00:02:37.000000', 'temperatura', 637.0000, 'ºC'),
	(128174, 110, '2015-04-01 00:02:38.000000', 'temperatura', 520.0000, 'ºC'),
	(128175, 110, '2015-04-01 00:02:39.000000', 'temperatura', 692.0000, 'ºC'),
	(128176, 110, '2015-04-01 00:02:40.000000', 'temperatura', 700.0000, 'ºC'),
	(128177, 110, '2015-04-01 00:02:41.000000', 'temperatura', 226.0000, 'ºC'),
	(128178, 110, '2015-04-01 00:02:42.000000', 'temperatura', 228.0000, 'ºC'),
	(128179, 110, '2015-04-01 00:02:43.000000', 'temperatura', 464.0000, 'ºC'),
	(128180, 110, '2015-04-01 00:02:44.000000', 'temperatura', 436.0000, 'ºC'),
	(128181, 110, '2015-04-01 00:02:45.000000', 'temperatura', 790.0000, 'ºC'),
	(128182, 110, '2015-04-01 00:02:46.000000', 'temperatura', 240.0000, 'ºC'),
	(128183, 110, '2015-04-01 00:02:47.000000', 'temperatura', 30.0000, 'ºC'),
	(128184, 110, '2015-04-01 00:02:48.000000', 'temperatura', 630.0000, 'ºC'),
	(128185, 110, '2015-04-01 00:02:49.000000', 'temperatura', 663.0000, 'ºC'),
	(128186, 110, '2015-04-01 00:02:50.000000', 'temperatura', 223.0000, 'ºC'),
	(128187, 110, '2015-04-01 00:02:51.000000', 'temperatura', 328.0000, 'ºC'),
	(128188, 110, '2015-04-01 00:02:52.000000', 'temperatura', 973.0000, 'ºC'),
	(128189, 110, '2015-04-01 00:02:53.000000', 'temperatura', 279.0000, 'ºC'),
	(128190, 110, '2015-04-01 00:02:54.000000', 'temperatura', 879.0000, 'ºC'),
	(128191, 110, '2015-04-01 00:02:55.000000', 'temperatura', 1155.0000, 'ºC'),
	(128192, 110, '2015-04-01 00:02:56.000000', 'temperatura', 742.0000, 'ºC'),
	(128193, 110, '2015-04-01 00:02:57.000000', 'temperatura', 244.0000, 'ºC'),
	(128194, 110, '2015-04-01 00:02:58.000000', 'temperatura', 196.0000, 'ºC'),
	(128195, 110, '2015-04-01 00:02:59.000000', 'temperatura', 249.0000, 'ºC'),
	(128196, 110, '2015-04-01 00:03:00.000000', 'temperatura', 655.0000, 'ºC'),
	(128197, 110, '2015-04-01 00:03:01.000000', 'temperatura', 130.0000, 'ºC'),
	(128198, 110, '2015-04-01 00:03:02.000000', 'temperatura', 1083.0000, 'ºC'),
	(128199, 110, '2015-04-01 00:03:03.000000', 'temperatura', 228.0000, 'ºC'),
	(128200, 110, '2015-04-01 00:03:04.000000', 'temperatura', 291.0000, 'ºC'),
	(128201, 110, '2015-04-01 00:03:05.000000', 'temperatura', 773.0000, 'ºC'),
	(128202, 110, '2015-04-01 00:03:06.000000', 'temperatura', 592.0000, 'ºC'),
	(128203, 110, '2015-04-01 00:03:07.000000', 'temperatura', 643.0000, 'ºC'),
	(128204, 110, '2015-04-01 00:03:08.000000', 'temperatura', 237.0000, 'ºC'),
	(128205, 110, '2015-04-01 00:03:09.000000', 'temperatura', 456.0000, 'ºC'),
	(128206, 110, '2015-04-01 00:03:10.000000', 'temperatura', 370.0000, 'ºC'),
	(128207, 110, '2015-04-01 00:03:11.000000', 'temperatura', 484.0000, 'ºC'),
	(128208, 110, '2015-04-01 00:03:12.000000', 'temperatura', 108.0000, 'ºC'),
	(128209, 110, '2015-04-01 00:03:13.000000', 'temperatura', 289.0000, 'ºC'),
	(128210, 110, '2015-04-01 00:03:14.000000', 'temperatura', 1121.0000, 'ºC'),
	(128211, 110, '2015-04-01 00:03:15.000000', 'temperatura', 1139.0000, 'ºC'),
	(128212, 110, '2015-04-01 00:03:16.000000', 'temperatura', 1134.0000, 'ºC'),
	(128213, 110, '2015-04-01 00:03:17.000000', 'temperatura', 1052.0000, 'ºC'),
	(128214, 110, '2015-04-01 00:03:18.000000', 'temperatura', 657.0000, 'ºC'),
	(128215, 110, '2015-04-01 00:03:19.000000', 'temperatura', 130.0000, 'ºC'),
	(128216, 110, '2015-04-01 00:03:20.000000', 'temperatura', 1081.0000, 'ºC'),
	(128217, 110, '2015-04-01 00:03:21.000000', 'temperatura', 217.0000, 'ºC'),
	(128218, 110, '2015-04-01 00:03:22.000000', 'temperatura', 240.0000, 'ºC'),
	(128219, 110, '2015-04-01 00:03:23.000000', 'temperatura', 548.0000, 'ºC'),
	(128220, 110, '2015-04-01 00:03:24.000000', 'temperatura', 824.0000, 'ºC'),
	(128221, 110, '2015-04-01 00:03:25.000000', 'temperatura', 74.0000, 'ºC'),
	(128222, 110, '2015-04-01 00:03:26.000000', 'temperatura', 299.0000, 'ºC'),
	(128223, 110, '2015-04-01 00:03:27.000000', 'temperatura', 76.0000, 'ºC'),
	(128224, 110, '2015-04-01 00:03:28.000000', 'temperatura', 681.0000, 'ºC'),
	(128225, 110, '2015-04-01 00:03:29.000000', 'temperatura', 779.0000, 'ºC'),
	(128226, 110, '2015-04-01 00:03:30.000000', 'temperatura', 650.0000, 'ºC'),
	(128227, 110, '2015-04-01 00:03:31.000000', 'temperatura', 915.0000, 'ºC'),
	(128228, 110, '2015-04-01 00:03:32.000000', 'temperatura', 225.0000, 'ºC'),
	(128229, 110, '2015-04-01 00:03:33.000000', 'temperatura', 783.0000, 'ºC'),
	(128230, 110, '2015-04-01 00:03:34.000000', 'temperatura', 838.0000, 'ºC'),
	(128231, 110, '2015-04-01 00:03:35.000000', 'temperatura', 643.0000, 'ºC'),
	(128232, 110, '2015-04-01 00:03:36.000000', 'temperatura', 702.0000, 'ºC'),
	(128233, 110, '2015-04-01 00:03:37.000000', 'temperatura', 380.0000, 'ºC'),
	(128234, 110, '2015-04-01 00:03:38.000000', 'temperatura', 996.0000, 'ºC'),
	(128235, 110, '2015-04-01 00:03:39.000000', 'temperatura', 238.0000, 'ºC'),
	(128236, 110, '2015-04-01 00:03:40.000000', 'temperatura', 603.0000, 'ºC'),
	(128237, 110, '2015-04-01 00:03:41.000000', 'temperatura', 1101.0000, 'ºC'),
	(128238, 110, '2015-04-01 00:03:42.000000', 'temperatura', 99.0000, 'ºC'),
	(128239, 110, '2015-04-01 00:03:43.000000', 'temperatura', 789.0000, 'ºC'),
	(128240, 110, '2015-04-01 00:03:44.000000', 'temperatura', 52.0000, 'ºC'),
	(128241, 110, '2015-04-01 00:03:45.000000', 'temperatura', 290.0000, 'ºC'),
	(128242, 110, '2015-04-01 00:03:46.000000', 'temperatura', 97.0000, 'ºC'),
	(128243, 110, '2015-04-01 00:03:47.000000', 'temperatura', 817.0000, 'ºC'),
	(128244, 110, '2015-04-01 00:03:48.000000', 'temperatura', 192.0000, 'ºC'),
	(128245, 110, '2015-04-01 00:03:49.000000', 'temperatura', 908.0000, 'ºC'),
	(128246, 110, '2015-04-01 00:03:50.000000', 'temperatura', 367.0000, 'ºC'),
	(128247, 110, '2015-04-01 00:03:51.000000', 'temperatura', 309.0000, 'ºC'),
	(128248, 110, '2015-04-01 00:03:52.000000', 'temperatura', 444.0000, 'ºC'),
	(128249, 110, '2015-04-01 00:03:53.000000', 'temperatura', 97.0000, 'ºC'),
	(128250, 110, '2015-04-01 00:03:54.000000', 'temperatura', 350.0000, 'ºC'),
	(128251, 110, '2015-04-01 00:03:55.000000', 'temperatura', 263.0000, 'ºC'),
	(128252, 110, '2015-04-01 00:03:56.000000', 'temperatura', 263.0000, 'ºC'),
	(128253, 110, '2015-04-01 00:03:57.000000', 'temperatura', 528.0000, 'ºC'),
	(128254, 110, '2015-04-01 00:03:58.000000', 'temperatura', 652.0000, 'ºC'),
	(128255, 110, '2015-04-01 00:03:59.000000', 'temperatura', 477.0000, 'ºC'),
	(128256, 110, '2015-04-01 00:04:00.000000', 'temperatura', 429.0000, 'ºC'),
	(128257, 110, '2015-04-01 00:04:01.000000', 'temperatura', 713.0000, 'ºC'),
	(128258, 110, '2015-04-01 00:04:02.000000', 'temperatura', 1081.0000, 'ºC'),
	(128259, 110, '2015-04-01 00:04:03.000000', 'temperatura', 866.0000, 'ºC'),
	(128260, 110, '2015-04-01 00:04:04.000000', 'temperatura', 1085.0000, 'ºC'),
	(128261, 110, '2015-04-01 00:04:05.000000', 'temperatura', 430.0000, 'ºC'),
	(128262, 110, '2015-04-01 00:04:06.000000', 'temperatura', 94.0000, 'ºC'),
	(128263, 110, '2015-04-01 00:04:07.000000', 'temperatura', 382.0000, 'ºC'),
	(128264, 110, '2015-04-01 00:04:08.000000', 'temperatura', 427.0000, 'ºC'),
	(128265, 110, '2015-04-01 00:04:09.000000', 'temperatura', 991.0000, 'ºC'),
	(128266, 110, '2015-04-01 00:04:10.000000', 'temperatura', 76.0000, 'ºC'),
	(128267, 110, '2015-04-01 00:04:11.000000', 'temperatura', 1005.0000, 'ºC'),
	(128268, 110, '2015-04-01 00:04:12.000000', 'temperatura', 1199.0000, 'ºC'),
	(128269, 110, '2015-04-01 00:04:13.000000', 'temperatura', 581.0000, 'ºC'),
	(128270, 110, '2015-04-01 00:04:14.000000', 'temperatura', 508.0000, 'ºC'),
	(128271, 110, '2015-04-01 00:04:15.000000', 'temperatura', 795.0000, 'ºC'),
	(128272, 110, '2015-04-01 00:04:16.000000', 'temperatura', 54.0000, 'ºC'),
	(128273, 110, '2015-04-01 00:04:17.000000', 'temperatura', 286.0000, 'ºC'),
	(128274, 110, '2015-04-01 00:04:18.000000', 'temperatura', 67.0000, 'ºC'),
	(128275, 110, '2015-04-01 00:04:19.000000', 'temperatura', 677.0000, 'ºC'),
	(128276, 110, '2015-04-01 00:04:20.000000', 'temperatura', 784.0000, 'ºC'),
	(128277, 110, '2015-04-01 00:04:21.000000', 'temperatura', 691.0000, 'ºC'),
	(128278, 110, '2015-04-01 00:04:22.000000', 'temperatura', 1102.0000, 'ºC'),
	(128279, 110, '2015-04-01 00:04:23.000000', 'temperatura', 1039.0000, 'ºC'),
	(128280, 110, '2015-04-01 00:04:24.000000', 'temperatura', 689.0000, 'ºC'),
	(128281, 110, '2015-04-01 00:04:25.000000', 'temperatura', 328.0000, 'ºC'),
	(128282, 110, '2015-04-01 00:04:26.000000', 'temperatura', 772.0000, 'ºC'),
	(128283, 110, '2015-04-01 00:04:27.000000', 'temperatura', 480.0000, 'ºC'),
	(128284, 110, '2015-04-01 00:04:28.000000', 'temperatura', 82.0000, 'ºC'),
	(128285, 110, '2015-04-01 00:04:29.000000', 'temperatura', 171.0000, 'ºC'),
	(128286, 110, '2015-04-01 00:04:30.000000', 'temperatura', 609.0000, 'ºC'),
	(128287, 110, '2015-04-01 00:04:31.000000', 'temperatura', 131.0000, 'ºC'),
	(128288, 110, '2015-04-01 00:04:32.000000', 'temperatura', 32.0000, 'ºC'),
	(128289, 110, '2015-04-01 00:04:33.000000', 'temperatura', 965.0000, 'ºC'),
	(128290, 110, '2015-04-01 00:04:34.000000', 'temperatura', 1128.0000, 'ºC'),
	(128291, 110, '2015-04-01 00:04:35.000000', 'temperatura', 348.0000, 'ºC'),
	(128292, 110, '2015-04-01 00:04:36.000000', 'temperatura', 755.0000, 'ºC'),
	(128293, 110, '2015-04-01 00:04:37.000000', 'temperatura', 332.0000, 'ºC'),
	(128294, 110, '2015-04-01 00:04:38.000000', 'temperatura', 597.0000, 'ºC'),
	(128295, 110, '2015-04-01 00:04:39.000000', 'temperatura', 791.0000, 'ºC'),
	(128296, 110, '2015-04-01 00:04:40.000000', 'temperatura', 961.0000, 'ºC'),
	(128297, 110, '2015-04-01 00:04:41.000000', 'temperatura', 34.0000, 'ºC'),
	(128298, 110, '2015-04-01 00:04:42.000000', 'temperatura', 887.0000, 'ºC'),
	(128299, 110, '2015-04-01 00:04:43.000000', 'temperatura', 732.0000, 'ºC'),
	(128300, 110, '2015-04-01 00:04:44.000000', 'temperatura', 1001.0000, 'ºC'),
	(128301, 110, '2015-04-01 00:04:45.000000', 'temperatura', 408.0000, 'ºC'),
	(128302, 110, '2015-04-01 00:04:46.000000', 'temperatura', 237.0000, 'ºC'),
	(128303, 110, '2015-04-01 00:04:47.000000', 'temperatura', 1164.0000, 'ºC'),
	(128304, 110, '2015-04-01 00:04:48.000000', 'temperatura', 309.0000, 'ºC'),
	(128305, 110, '2015-04-01 00:04:49.000000', 'temperatura', 453.0000, 'ºC'),
	(128306, 110, '2015-04-01 00:04:50.000000', 'temperatura', 137.0000, 'ºC'),
	(128307, 110, '2015-04-01 00:04:51.000000', 'temperatura', 526.0000, 'ºC'),
	(128308, 110, '2015-04-01 00:04:52.000000', 'temperatura', 1020.0000, 'ºC'),
	(128309, 110, '2015-04-01 00:04:53.000000', 'temperatura', 1124.0000, 'ºC'),
	(128310, 110, '2015-04-01 00:04:54.000000', 'temperatura', 161.0000, 'ºC'),
	(128311, 110, '2015-04-01 00:04:55.000000', 'temperatura', 1034.0000, 'ºC'),
	(128312, 110, '2015-04-01 00:04:56.000000', 'temperatura', 1085.0000, 'ºC'),
	(128313, 110, '2015-04-01 00:04:57.000000', 'temperatura', 1125.0000, 'ºC'),
	(128314, 110, '2015-04-01 00:04:58.000000', 'temperatura', 1170.0000, 'ºC'),
	(128315, 110, '2015-04-01 00:04:59.000000', 'temperatura', 75.0000, 'ºC'),
	(128316, 110, '2015-04-01 00:05:00.000000', 'temperatura', 465.0000, 'ºC'),
	(128317, 110, '2015-04-01 00:05:01.000000', 'temperatura', 901.0000, 'ºC'),
	(128318, 110, '2015-04-01 00:05:02.000000', 'temperatura', 709.0000, 'ºC'),
	(128319, 110, '2015-04-01 00:05:03.000000', 'temperatura', 844.0000, 'ºC'),
	(128320, 110, '2015-04-01 00:05:04.000000', 'temperatura', 892.0000, 'ºC'),
	(128321, 110, '2015-04-01 00:05:05.000000', 'temperatura', 729.0000, 'ºC'),
	(128322, 110, '2015-04-01 00:05:06.000000', 'temperatura', 972.0000, 'ºC'),
	(128323, 110, '2015-04-01 00:05:07.000000', 'temperatura', 271.0000, 'ºC'),
	(128324, 110, '2015-04-01 00:05:08.000000', 'temperatura', 842.0000, 'ºC'),
	(128325, 110, '2015-04-01 00:05:09.000000', 'temperatura', 995.0000, 'ºC'),
	(128326, 110, '2015-04-01 00:05:10.000000', 'temperatura', 51.0000, 'ºC'),
	(128327, 110, '2015-04-01 00:05:11.000000', 'temperatura', 872.0000, 'ºC'),
	(128328, 110, '2015-04-01 00:05:12.000000', 'temperatura', 605.0000, 'ºC'),
	(128329, 110, '2015-04-01 00:05:13.000000', 'temperatura', 409.0000, 'ºC'),
	(128330, 110, '2015-04-01 00:05:14.000000', 'temperatura', 232.0000, 'ºC'),
	(128331, 110, '2015-04-01 00:05:15.000000', 'temperatura', 1132.0000, 'ºC'),
	(128332, 110, '2015-04-01 00:05:16.000000', 'temperatura', 167.0000, 'ºC'),
	(128333, 110, '2015-04-01 00:05:17.000000', 'temperatura', 1038.0000, 'ºC'),
	(128334, 110, '2015-04-01 00:05:18.000000', 'temperatura', 1090.0000, 'ºC'),
	(128335, 110, '2015-04-01 00:05:19.000000', 'temperatura', 1135.0000, 'ºC'),
	(128336, 110, '2015-04-01 00:05:20.000000', 'temperatura', 6.0000, 'ºC'),
	(128337, 110, '2015-04-01 00:05:21.000000', 'temperatura', 224.0000, 'ºC'),
	(128338, 110, '2015-04-01 00:05:22.000000', 'temperatura', 1104.0000, 'ºC'),
	(128339, 110, '2015-04-01 00:05:23.000000', 'temperatura', 50.0000, 'ºC'),
	(128340, 110, '2015-04-01 00:05:24.000000', 'temperatura', 538.0000, 'ºC'),
	(128341, 110, '2015-04-01 00:05:25.000000', 'temperatura', 142.0000, 'ºC'),
	(128342, 110, '2015-04-01 00:05:26.000000', 'temperatura', 294.0000, 'ºC'),
	(128343, 110, '2015-04-01 00:05:27.000000', 'temperatura', 1044.0000, 'ºC'),
	(128344, 110, '2015-04-01 00:05:28.000000', 'temperatura', 741.0000, 'ºC'),
	(128345, 110, '2015-04-01 00:05:29.000000', 'temperatura', 573.0000, 'ºC'),
	(128346, 110, '2015-04-01 00:05:30.000000', 'temperatura', 644.0000, 'ºC'),
	(128347, 110, '2015-04-01 00:05:31.000000', 'temperatura', 299.0000, 'ºC'),
	(128348, 110, '2015-04-01 00:05:32.000000', 'temperatura', 766.0000, 'ºC'),
	(128349, 110, '2015-04-01 00:05:33.000000', 'temperatura', 530.0000, 'ºC'),
	(128350, 110, '2015-04-01 00:05:34.000000', 'temperatura', 356.0000, 'ºC'),
	(128351, 110, '2015-04-01 00:05:35.000000', 'temperatura', 189.0000, 'ºC'),
	(128352, 110, '2015-04-01 00:05:36.000000', 'temperatura', 1080.0000, 'ºC'),
	(128353, 110, '2015-04-01 00:05:37.000000', 'temperatura', 30.0000, 'ºC'),
	(128354, 110, '2015-04-01 00:05:38.000000', 'temperatura', 513.0000, 'ºC'),
	(128355, 110, '2015-04-01 00:05:39.000000', 'temperatura', 77.0000, 'ºC'),
	(128356, 110, '2015-04-01 00:05:40.000000', 'temperatura', 44.0000, 'ºC'),
	(128357, 110, '2015-04-01 00:05:41.000000', 'temperatura', 1190.0000, 'ºC'),
	(128358, 110, '2015-04-01 00:05:42.000000', 'temperatura', 1017.0000, 'ºC'),
	(128359, 110, '2015-04-01 00:05:43.000000', 'temperatura', 316.0000, 'ºC'),
	(128360, 110, '2015-04-01 00:05:44.000000', 'temperatura', 931.0000, 'ºC'),
	(128361, 110, '2015-04-01 00:05:45.000000', 'temperatura', 106.0000, 'ºC'),
	(128362, 110, '2015-04-01 00:05:46.000000', 'temperatura', 138.0000, 'ºC'),
	(128363, 110, '2015-04-01 00:05:47.000000', 'temperatura', 371.0000, 'ºC'),
	(128364, 110, '2015-04-01 00:05:48.000000', 'temperatura', 242.0000, 'ºC'),
	(128365, 110, '2015-04-01 00:05:49.000000', 'temperatura', 96.0000, 'ºC'),
	(128366, 110, '2015-04-01 00:05:50.000000', 'temperatura', 956.0000, 'ºC'),
	(128367, 110, '2015-04-01 00:05:51.000000', 'temperatura', 893.0000, 'ºC'),
	(128368, 110, '2015-04-01 00:05:52.000000', 'temperatura', 396.0000, 'ºC'),
	(128369, 110, '2015-04-01 00:05:53.000000', 'temperatura', 501.0000, 'ºC'),
	(128370, 110, '2015-04-01 00:05:54.000000', 'temperatura', 117.0000, 'ºC'),
	(128371, 110, '2015-04-01 00:05:55.000000', 'temperatura', 281.0000, 'ºC'),
	(128372, 110, '2015-04-01 00:05:56.000000', 'temperatura', 1058.0000, 'ºC'),
	(128373, 110, '2015-04-01 00:05:57.000000', 'temperatura', 846.0000, 'ºC'),
	(128374, 110, '2015-04-01 00:05:58.000000', 'temperatura', 1057.0000, 'ºC'),
	(128375, 110, '2015-04-01 00:05:59.000000', 'temperatura', 347.0000, 'ºC'),
	(128376, 110, '2015-04-01 00:06:00.000000', 'temperatura', 963.0000, 'ºC'),
	(128377, 110, '2015-04-01 00:06:01.000000', 'temperatura', 174.0000, 'ºC'),
	(128378, 110, '2015-04-01 00:06:02.000000', 'temperatura', 384.0000, 'ºC'),
	(128379, 110, '2015-04-01 00:06:03.000000', 'temperatura', 196.0000, 'ºC'),
	(128380, 110, '2015-04-01 00:06:04.000000', 'temperatura', 1031.0000, 'ºC'),
	(128381, 110, '2015-04-01 00:06:05.000000', 'temperatura', 967.0000, 'ºC'),
	(128382, 110, '2015-04-01 00:06:06.000000', 'temperatura', 544.0000, 'ºC'),
	(128383, 110, '2015-04-01 00:06:07.000000', 'temperatura', 1016.0000, 'ºC'),
	(128384, 110, '2015-04-01 00:06:08.000000', 'temperatura', 1052.0000, 'ºC'),
	(128385, 110, '2015-04-01 00:06:09.000000', 'temperatura', 1012.0000, 'ºC'),
	(128386, 110, '2015-04-01 00:06:10.000000', 'temperatura', 702.0000, 'ºC'),
	(128387, 110, '2015-04-01 00:06:11.000000', 'temperatura', 476.0000, 'ºC'),
	(128388, 110, '2015-04-01 00:06:12.000000', 'temperatura', 273.0000, 'ºC'),
	(128389, 110, '2015-04-01 00:06:13.000000', 'temperatura', 1139.0000, 'ºC'),
	(128390, 110, '2015-04-01 00:06:14.000000', 'temperatura', 76.0000, 'ºC'),
	(128391, 110, '2015-04-01 00:06:15.000000', 'temperatura', 564.0000, 'ºC'),
	(128392, 110, '2015-04-01 00:06:16.000000', 'temperatura', 193.0000, 'ºC'),
	(128393, 110, '2015-04-01 00:06:17.000000', 'temperatura', 473.0000, 'ºC'),
	(128394, 110, '2015-04-01 00:06:18.000000', 'temperatura', 587.0000, 'ºC'),
	(128395, 110, '2015-04-01 00:06:19.000000', 'temperatura', 315.0000, 'ºC'),
	(128396, 110, '2015-04-01 00:06:20.000000', 'temperatura', 1015.0000, 'ºC'),
	(128397, 110, '2015-04-01 00:06:21.000000', 'temperatura', 531.0000, 'ºC'),
	(128398, 110, '2015-04-01 00:06:22.000000', 'temperatura', 812.0000, 'ºC'),
	(128399, 110, '2015-04-01 00:06:23.000000', 'temperatura', 65.0000, 'ºC'),
	(128400, 110, '2015-04-01 00:06:24.000000', 'temperatura', 292.0000, 'ºC'),
	(128401, 110, '2015-04-01 00:06:25.000000', 'temperatura', 64.0000, 'ºC'),
	(128402, 110, '2015-04-01 00:06:26.000000', 'temperatura', 646.0000, 'ºC'),
	(128403, 110, '2015-04-01 00:06:27.000000', 'temperatura', 638.0000, 'ºC'),
	(128404, 110, '2015-04-01 00:06:28.000000', 'temperatura', 54.0000, 'ºC'),
	(128405, 110, '2015-04-01 00:06:29.000000', 'temperatura', 756.0000, 'ºC'),
	(128406, 110, '2015-04-01 00:06:30.000000', 'temperatura', 16.0000, 'ºC'),
	(128407, 110, '2015-04-01 00:06:31.000000', 'temperatura', 215.0000, 'ºC'),
	(128408, 110, '2015-04-01 00:06:32.000000', 'temperatura', 1026.0000, 'ºC'),
	(128409, 110, '2015-04-01 00:06:33.000000', 'temperatura', 886.0000, 'ºC'),
	(128410, 110, '2015-04-01 00:06:34.000000', 'temperatura', 151.0000, 'ºC'),
	(128411, 110, '2015-04-01 00:06:35.000000', 'temperatura', 500.0000, 'ºC'),
	(128412, 110, '2015-04-01 00:06:36.000000', 'temperatura', 846.0000, 'ºC'),
	(128413, 110, '2015-04-01 00:06:37.000000', 'temperatura', 332.0000, 'ºC'),
	(128414, 110, '2015-04-01 00:06:38.000000', 'temperatura', 320.0000, 'ºC'),
	(128415, 110, '2015-04-01 00:06:39.000000', 'temperatura', 606.0000, 'ºC'),
	(128416, 110, '2015-04-01 00:06:40.000000', 'temperatura', 871.0000, 'ºC'),
	(128417, 110, '2015-04-01 00:06:41.000000', 'temperatura', 138.0000, 'ºC'),
	(128418, 110, '2015-04-01 00:06:42.000000', 'temperatura', 478.0000, 'ºC'),
	(128419, 110, '2015-04-01 00:06:43.000000', 'temperatura', 778.0000, 'ºC'),
	(128420, 110, '2015-04-01 00:06:44.000000', 'temperatura', 54.0000, 'ºC'),
	(128421, 110, '2015-04-01 00:06:45.000000', 'temperatura', 335.0000, 'ºC'),
	(128422, 110, '2015-04-01 00:06:46.000000', 'temperatura', 316.0000, 'ºC'),
	(128423, 110, '2015-04-01 00:06:47.000000', 'temperatura', 576.0000, 'ºC'),
	(128424, 110, '2015-04-01 00:06:48.000000', 'temperatura', 732.0000, 'ºC'),
	(128425, 110, '2015-04-01 00:06:49.000000', 'temperatura', 731.0000, 'ºC'),
	(128426, 110, '2015-04-01 00:06:50.000000', 'temperatura', 261.0000, 'ºC'),
	(128427, 110, '2015-04-01 00:06:51.000000', 'temperatura', 313.0000, 'ºC'),
	(128428, 110, '2015-04-01 00:06:52.000000', 'temperatura', 782.0000, 'ºC'),
	(128429, 110, '2015-04-01 00:06:53.000000', 'temperatura', 570.0000, 'ºC'),
	(128430, 110, '2015-04-01 00:06:54.000000', 'temperatura', 507.0000, 'ºC'),
	(128431, 110, '2015-04-01 00:06:55.000000', 'temperatura', 826.0000, 'ºC'),
	(128432, 110, '2015-04-01 00:06:56.000000', 'temperatura', 210.0000, 'ºC'),
	(128433, 110, '2015-04-01 00:06:57.000000', 'temperatura', 970.0000, 'ºC'),
	(128434, 110, '2015-04-01 00:06:58.000000', 'temperatura', 622.0000, 'ºC'),
	(128435, 110, '2015-04-01 00:06:59.000000', 'temperatura', 199.0000, 'ºC'),
	(128436, 110, '2015-04-01 00:07:00.000000', 'temperatura', 329.0000, 'ºC'),
	(128437, 110, '2015-04-01 00:07:01.000000', 'temperatura', 1048.0000, 'ºC'),
	(128438, 110, '2015-04-01 00:07:02.000000', 'temperatura', 653.0000, 'ºC'),
	(128439, 110, '2015-04-01 00:07:03.000000', 'temperatura', 123.0000, 'ºC'),
	(128440, 110, '2015-04-01 00:07:04.000000', 'temperatura', 1055.0000, 'ºC'),
	(128441, 110, '2015-04-01 00:07:05.000000', 'temperatura', 108.0000, 'ºC'),
	(128442, 110, '2015-04-01 00:07:06.000000', 'temperatura', 975.0000, 'ºC'),
	(128443, 110, '2015-04-01 00:07:07.000000', 'temperatura', 951.0000, 'ºC'),
	(128444, 110, '2015-04-01 00:07:08.000000', 'temperatura', 633.0000, 'ºC'),
	(128445, 110, '2015-04-01 00:07:09.000000', 'temperatura', 309.0000, 'ºC'),
	(128446, 110, '2015-04-01 00:07:10.000000', 'temperatura', 848.0000, 'ºC'),
	(128447, 110, '2015-04-01 00:07:11.000000', 'temperatura', 914.0000, 'ºC'),
	(128448, 110, '2015-04-01 00:07:12.000000', 'temperatura', 827.0000, 'ºC'),
	(128449, 110, '2015-04-01 00:07:13.000000', 'temperatura', 194.0000, 'ºC'),
	(128450, 110, '2015-04-01 00:07:14.000000', 'temperatura', 889.0000, 'ºC'),
	(128451, 110, '2015-04-01 00:07:15.000000', 'temperatura', 265.0000, 'ºC'),
	(128452, 110, '2015-04-01 00:07:16.000000', 'temperatura', 1056.0000, 'ºC'),
	(128453, 110, '2015-04-01 00:07:17.000000', 'temperatura', 885.0000, 'ºC'),
	(128454, 110, '2015-04-01 00:07:18.000000', 'temperatura', 60.0000, 'ºC'),
	(128455, 110, '2015-04-01 00:07:19.000000', 'temperatura', 44.0000, 'ºC'),
	(128456, 110, '2015-04-01 00:07:20.000000', 'temperatura', 43.0000, 'ºC'),
	(128457, 110, '2015-04-01 00:07:21.000000', 'temperatura', 80.0000, 'ºC'),
	(128458, 110, '2015-04-01 00:07:22.000000', 'temperatura', 275.0000, 'ºC'),
	(128459, 110, '2015-04-01 00:07:23.000000', 'temperatura', 1133.0000, 'ºC'),
	(128460, 110, '2015-04-01 00:07:24.000000', 'temperatura', 43.0000, 'ºC'),
	(128461, 110, '2015-04-01 00:07:25.000000', 'temperatura', 413.0000, 'ºC'),
	(128462, 110, '2015-04-01 00:07:26.000000', 'temperatura', 739.0000, 'ºC'),
	(128463, 110, '2015-04-01 00:07:27.000000', 'temperatura', 54.0000, 'ºC'),
	(128464, 110, '2015-04-01 00:07:28.000000', 'temperatura', 457.0000, 'ºC'),
	(128465, 110, '2015-04-01 00:07:29.000000', 'temperatura', 921.0000, 'ºC'),
	(128466, 110, '2015-04-01 00:07:30.000000', 'temperatura', 835.0000, 'ºC'),
	(128467, 110, '2015-04-01 00:07:31.000000', 'temperatura', 215.0000, 'ºC'),
	(128468, 110, '2015-04-01 00:07:32.000000', 'temperatura', 967.0000, 'ºC'),
	(128469, 110, '2015-04-01 00:07:33.000000', 'temperatura', 590.0000, 'ºC'),
	(128470, 110, '2015-04-01 00:07:34.000000', 'temperatura', 53.0000, 'ºC'),
	(128471, 110, '2015-04-01 00:07:35.000000', 'temperatura', 893.0000, 'ºC'),
	(128472, 110, '2015-04-01 00:07:36.000000', 'temperatura', 705.0000, 'ºC'),
	(128473, 110, '2015-04-01 00:07:37.000000', 'temperatura', 849.0000, 'ºC'),
	(128474, 110, '2015-04-01 00:07:38.000000', 'temperatura', 931.0000, 'ºC'),
	(128475, 110, '2015-04-01 00:07:39.000000', 'temperatura', 907.0000, 'ºC'),
	(128476, 110, '2015-04-01 00:07:40.000000', 'temperatura', 544.0000, 'ºC'),
	(128477, 110, '2015-04-01 00:07:41.000000', 'temperatura', 1198.0000, 'ºC'),
	(128478, 110, '2015-04-01 00:07:42.000000', 'temperatura', 757.0000, 'ºC'),
	(128479, 110, '2015-04-01 00:07:43.000000', 'temperatura', 194.0000, 'ºC'),
	(128480, 110, '2015-04-01 00:07:44.000000', 'temperatura', 1099.0000, 'ºC'),
	(128481, 110, '2015-04-01 00:07:45.000000', 'temperatura', 114.0000, 'ºC'),
	(128482, 110, '2015-04-01 00:07:46.000000', 'temperatura', 873.0000, 'ºC'),
	(128483, 110, '2015-04-01 00:07:47.000000', 'temperatura', 422.0000, 'ºC'),
	(128484, 110, '2015-04-01 00:07:48.000000', 'temperatura', 692.0000, 'ºC'),
	(128485, 110, '2015-04-01 00:07:49.000000', 'temperatura', 996.0000, 'ºC'),
	(128486, 110, '2015-04-01 00:07:50.000000', 'temperatura', 505.0000, 'ºC'),
	(128487, 110, '2015-04-01 00:07:51.000000', 'temperatura', 736.0000, 'ºC'),
	(128488, 110, '2015-04-01 00:07:52.000000', 'temperatura', 966.0000, 'ºC'),
	(128489, 110, '2015-04-01 00:07:53.000000', 'temperatura', 221.0000, 'ºC'),
	(128490, 110, '2015-04-01 00:07:54.000000', 'temperatura', 610.0000, 'ºC'),
	(128491, 110, '2015-04-01 00:07:55.000000', 'temperatura', 1186.0000, 'ºC'),
	(128492, 110, '2015-04-01 00:07:56.000000', 'temperatura', 501.0000, 'ºC'),
	(128493, 110, '2015-04-01 00:07:57.000000', 'temperatura', 149.0000, 'ºC'),
	(128494, 110, '2015-04-01 00:07:58.000000', 'temperatura', 441.0000, 'ºC'),
	(128495, 110, '2015-04-01 00:07:59.000000', 'temperatura', 559.0000, 'ºC'),
	(128496, 110, '2015-04-01 00:08:00.000000', 'temperatura', 273.0000, 'ºC'),
	(128497, 110, '2015-04-01 00:08:01.000000', 'temperatura', 888.0000, 'ºC'),
	(128498, 110, '2015-04-01 00:08:02.000000', 'temperatura', 23.0000, 'ºC'),
	(128499, 110, '2015-04-01 00:08:03.000000', 'temperatura', 1052.0000, 'ºC'),
	(128500, 110, '2015-04-01 00:08:04.000000', 'temperatura', 391.0000, 'ºC'),
	(128501, 110, '2015-04-01 00:08:05.000000', 'temperatura', 1198.0000, 'ºC'),
	(128502, 110, '2015-04-01 00:08:06.000000', 'temperatura', 18.0000, 'ºC'),
	(128503, 110, '2015-04-01 00:08:07.000000', 'temperatura', 96.0000, 'ºC'),
	(128504, 110, '2015-04-01 00:08:08.000000', 'temperatura', 428.0000, 'ºC'),
	(128505, 110, '2015-04-01 00:08:09.000000', 'temperatura', 652.0000, 'ºC'),
	(128506, 110, '2015-04-01 00:08:10.000000', 'temperatura', 776.0000, 'ºC'),
	(128507, 110, '2015-04-01 00:08:11.000000', 'temperatura', 725.0000, 'ºC'),
	(128508, 110, '2015-04-01 00:08:12.000000', 'temperatura', 95.0000, 'ºC'),
	(128509, 110, '2015-04-01 00:08:13.000000', 'temperatura', 704.0000, 'ºC'),
	(128510, 110, '2015-04-01 00:08:14.000000', 'temperatura', 832.0000, 'ºC'),
	(128511, 110, '2015-04-01 00:08:15.000000', 'temperatura', 850.0000, 'ºC'),
	(128512, 110, '2015-04-01 00:08:16.000000', 'temperatura', 556.0000, 'ºC'),
	(128513, 110, '2015-04-01 00:08:17.000000', 'temperatura', 231.0000, 'ºC'),
	(128514, 110, '2015-04-01 00:08:18.000000', 'temperatura', 688.0000, 'ºC'),
	(128515, 110, '2015-04-01 00:08:19.000000', 'temperatura', 346.0000, 'ºC'),
	(128516, 110, '2015-04-01 00:08:20.000000', 'temperatura', 865.0000, 'ºC'),
	(128517, 110, '2015-04-01 00:08:21.000000', 'temperatura', 889.0000, 'ºC'),
	(128518, 110, '2015-04-01 00:08:22.000000', 'temperatura', 649.0000, 'ºC'),
	(128519, 110, '2015-04-01 00:08:23.000000', 'temperatura', 580.0000, 'ºC'),
	(128520, 110, '2015-04-01 00:08:24.000000', 'temperatura', 952.0000, 'ºC'),
	(128521, 110, '2015-04-01 00:08:25.000000', 'temperatura', 621.0000, 'ºC'),
	(128522, 110, '2015-04-01 00:08:26.000000', 'temperatura', 250.0000, 'ºC'),
	(128523, 110, '2015-04-01 00:08:27.000000', 'temperatura', 587.0000, 'ºC'),
	(128524, 110, '2015-04-01 00:08:28.000000', 'temperatura', 984.0000, 'ºC'),
	(128525, 110, '2015-04-01 00:08:29.000000', 'temperatura', 760.0000, 'ºC'),
	(128526, 110, '2015-04-01 00:08:30.000000', 'temperatura', 848.0000, 'ºC'),
	(128527, 110, '2015-04-01 00:08:31.000000', 'temperatura', 760.0000, 'ºC'),
	(128528, 110, '2015-04-01 00:08:32.000000', 'temperatura', 57.0000, 'ºC'),
	(128529, 110, '2015-04-01 00:08:33.000000', 'temperatura', 408.0000, 'ºC'),
	(128530, 110, '2015-04-01 00:08:34.000000', 'temperatura', 667.0000, 'ºC'),
	(128531, 110, '2015-04-01 00:08:35.000000', 'temperatura', 913.0000, 'ºC'),
	(128532, 110, '2015-04-01 00:08:36.000000', 'temperatura', 163.0000, 'ºC'),
	(128533, 110, '2015-04-01 00:08:37.000000', 'temperatura', 477.0000, 'ºC'),
	(128534, 110, '2015-04-01 00:08:38.000000', 'temperatura', 697.0000, 'ºC'),
	(128535, 110, '2015-04-01 00:08:39.000000', 'temperatura', 853.0000, 'ºC'),
	(128536, 110, '2015-04-01 00:08:40.000000', 'temperatura', 975.0000, 'ºC'),
	(128537, 110, '2015-04-01 00:08:41.000000', 'temperatura', 1118.0000, 'ºC'),
	(128538, 110, '2015-04-01 00:08:42.000000', 'temperatura', 265.0000, 'ºC'),
	(128539, 110, '2015-04-01 00:08:43.000000', 'temperatura', 370.0000, 'ºC'),
	(128540, 110, '2015-04-01 00:08:44.000000', 'temperatura', 1055.0000, 'ºC'),
	(128541, 110, '2015-04-01 00:08:45.000000', 'temperatura', 564.0000, 'ºC'),
	(128542, 110, '2015-04-01 00:08:46.000000', 'temperatura', 859.0000, 'ºC'),
	(128543, 110, '2015-04-01 00:08:47.000000', 'temperatura', 204.0000, 'ºC'),
	(128544, 110, '2015-04-01 00:08:48.000000', 'temperatura', 840.0000, 'ºC'),
	(128545, 110, '2015-04-01 00:08:49.000000', 'temperatura', 1191.0000, 'ºC'),
	(128546, 110, '2015-04-01 00:08:50.000000', 'temperatura', 1034.0000, 'ºC'),
	(128547, 110, '2015-04-01 00:08:51.000000', 'temperatura', 400.0000, 'ºC'),
	(128548, 110, '2015-04-01 00:08:52.000000', 'temperatura', 95.0000, 'ºC'),
	(128549, 110, '2015-04-01 00:08:53.000000', 'temperatura', 479.0000, 'ºC'),
	(128550, 110, '2015-04-01 00:08:54.000000', 'temperatura', 908.0000, 'ºC'),
	(128551, 110, '2015-04-01 00:08:55.000000', 'temperatura', 704.0000, 'ºC'),
	(128552, 110, '2015-04-01 00:08:56.000000', 'temperatura', 797.0000, 'ºC'),
	(128553, 110, '2015-04-01 00:08:57.000000', 'temperatura', 673.0000, 'ºC'),
	(128554, 110, '2015-04-01 00:08:58.000000', 'temperatura', 974.0000, 'ºC'),
	(128555, 110, '2015-04-01 00:08:59.000000', 'temperatura', 453.0000, 'ºC'),
	(128556, 110, '2015-04-01 00:09:00.000000', 'temperatura', 544.0000, 'ºC'),
	(128557, 110, '2015-04-01 00:09:01.000000', 'temperatura', 162.0000, 'ºC'),
	(128558, 110, '2015-04-01 00:09:02.000000', 'temperatura', 376.0000, 'ºC'),
	(128559, 110, '2015-04-01 00:09:03.000000', 'temperatura', 196.0000, 'ºC'),
	(128560, 110, '2015-04-01 00:09:04.000000', 'temperatura', 1052.0000, 'ºC'),
	(128561, 110, '2015-04-01 00:09:05.000000', 'temperatura', 1071.0000, 'ºC'),
	(128562, 110, '2015-04-01 00:09:06.000000', 'temperatura', 1003.0000, 'ºC'),
	(128563, 110, '2015-04-01 00:09:07.000000', 'temperatura', 599.0000, 'ºC'),
	(128564, 110, '2015-04-01 00:09:08.000000', 'temperatura', 1188.0000, 'ºC'),
	(128565, 110, '2015-04-01 00:09:09.000000', 'temperatura', 543.0000, 'ºC'),
	(128566, 110, '2015-04-01 00:09:10.000000', 'temperatura', 350.0000, 'ºC'),
	(128567, 110, '2015-04-01 00:09:11.000000', 'temperatura', 121.0000, 'ºC'),
	(128568, 110, '2015-04-01 00:09:12.000000', 'temperatura', 758.0000, 'ºC'),
	(128569, 110, '2015-04-01 00:09:13.000000', 'temperatura', 1025.0000, 'ºC'),
	(128570, 110, '2015-04-01 00:09:14.000000', 'temperatura', 454.0000, 'ºC'),
	(128571, 110, '2015-04-01 00:09:15.000000', 'temperatura', 394.0000, 'ºC'),
	(128572, 110, '2015-04-01 00:09:16.000000', 'temperatura', 609.0000, 'ºC'),
	(128573, 110, '2015-04-01 00:09:17.000000', 'temperatura', 662.0000, 'ºC'),
	(128574, 110, '2015-04-01 00:09:18.000000', 'temperatura', 283.0000, 'ºC'),
	(128575, 110, '2015-04-01 00:09:19.000000', 'temperatura', 631.0000, 'ºC'),
	(128576, 110, '2015-04-01 00:09:20.000000', 'temperatura', 1105.0000, 'ºC'),
	(128577, 110, '2015-04-01 00:09:21.000000', 'temperatura', 33.0000, 'ºC'),
	(128578, 110, '2015-04-01 00:09:22.000000', 'temperatura', 452.0000, 'ºC'),
	(128579, 110, '2015-04-01 00:09:23.000000', 'temperatura', 961.0000, 'ºC'),
	(128580, 110, '2015-04-01 00:09:24.000000', 'temperatura', 1051.0000, 'ºC'),
	(128581, 110, '2015-04-01 00:09:25.000000', 'temperatura', 1169.0000, 'ºC'),
	(128582, 110, '2015-04-01 00:09:26.000000', 'temperatura', 296.0000, 'ºC'),
	(128583, 110, '2015-04-01 00:09:27.000000', 'temperatura', 371.0000, 'ºC'),
	(128584, 110, '2015-04-01 00:09:28.000000', 'temperatura', 967.0000, 'ºC'),
	(128585, 110, '2015-04-01 00:09:29.000000', 'temperatura', 123.0000, 'ºC'),
	(128586, 110, '2015-04-01 00:09:30.000000', 'temperatura', 113.0000, 'ºC'),
	(128587, 110, '2015-04-01 00:09:31.000000', 'temperatura', 198.0000, 'ºC'),
	(128588, 110, '2015-04-01 00:09:32.000000', 'temperatura', 650.0000, 'ºC'),
	(128589, 110, '2015-04-01 00:09:33.000000', 'temperatura', 259.0000, 'ºC'),
	(128590, 110, '2015-04-01 00:09:34.000000', 'temperatura', 546.0000, 'ºC'),
	(128591, 110, '2015-04-01 00:09:35.000000', 'temperatura', 754.0000, 'ºC'),
	(128592, 110, '2015-04-01 00:09:36.000000', 'temperatura', 933.0000, 'ºC'),
	(128593, 110, '2015-04-01 00:09:37.000000', 'temperatura', 3.0000, 'ºC'),
	(128594, 110, '2015-04-01 00:09:38.000000', 'temperatura', 817.0000, 'ºC'),
	(128595, 110, '2015-04-01 00:09:39.000000', 'temperatura', 474.0000, 'ºC'),
	(128596, 110, '2015-04-01 00:09:40.000000', 'temperatura', 1121.0000, 'ºC'),
	(128597, 110, '2015-04-01 00:09:41.000000', 'temperatura', 583.0000, 'ºC'),
	(128598, 110, '2015-04-01 00:09:42.000000', 'temperatura', 751.0000, 'ºC'),
	(128599, 110, '2015-04-01 00:09:43.000000', 'temperatura', 809.0000, 'ºC'),
	(128600, 110, '2015-04-01 00:09:44.000000', 'temperatura', 593.0000, 'ºC'),
	(128601, 110, '2015-04-01 00:09:45.000000', 'temperatura', 536.0000, 'ºC'),
	(128602, 110, '2015-04-01 00:09:46.000000', 'temperatura', 901.0000, 'ºC'),
	(128603, 110, '2015-04-01 00:09:47.000000', 'temperatura', 500.0000, 'ºC'),
	(128604, 110, '2015-04-01 00:09:48.000000', 'temperatura', 995.0000, 'ºC'),
	(128605, 110, '2015-04-01 00:09:49.000000', 'temperatura', 1078.0000, 'ºC'),
	(128606, 110, '2015-04-01 00:09:50.000000', 'temperatura', 3.0000, 'ºC'),
	(128607, 110, '2015-04-01 00:09:51.000000', 'temperatura', 383.0000, 'ºC'),
	(128608, 110, '2015-04-01 00:09:52.000000', 'temperatura', 708.0000, 'ºC'),
	(128609, 110, '2015-04-01 00:09:53.000000', 'temperatura', 1191.0000, 'ºC'),
	(128610, 110, '2015-04-01 00:09:54.000000', 'temperatura', 229.0000, 'ºC'),
	(128611, 110, '2015-04-01 00:09:55.000000', 'temperatura', 1174.0000, 'ºC'),
	(128612, 110, '2015-04-01 00:09:56.000000', 'temperatura', 382.0000, 'ºC'),
	(128613, 110, '2015-04-01 00:09:57.000000', 'temperatura', 789.0000, 'ºC'),
	(128614, 110, '2015-04-01 00:09:58.000000', 'temperatura', 398.0000, 'ºC'),
	(128615, 110, '2015-04-01 00:09:59.000000', 'temperatura', 825.0000, 'ºC'),
	(128616, 110, '2015-04-01 00:10:00.000000', 'temperatura', 530.0000, 'ºC'),
	(128617, 110, '2015-04-01 00:10:01.000000', 'temperatura', 176.0000, 'ºC'),
	(128618, 110, '2015-04-01 00:10:02.000000', 'temperatura', 489.0000, 'ºC'),
	(128619, 110, '2015-04-01 00:10:03.000000', 'temperatura', 721.0000, 'ºC'),
	(128620, 110, '2015-04-01 00:10:04.000000', 'temperatura', 935.0000, 'ºC'),
	(128621, 110, '2015-04-01 00:10:05.000000', 'temperatura', 113.0000, 'ºC'),
	(128622, 110, '2015-04-01 00:10:06.000000', 'temperatura', 161.0000, 'ºC'),
	(128623, 110, '2015-04-01 00:10:07.000000', 'temperatura', 467.0000, 'ºC'),
	(128624, 110, '2015-04-01 00:10:08.000000', 'temperatura', 652.0000, 'ºC'),
	(128625, 110, '2015-04-01 00:10:09.000000', 'temperatura', 660.0000, 'ºC'),
	(128626, 110, '2015-04-01 00:10:10.000000', 'temperatura', 146.0000, 'ºC'),
	(128627, 110, '2015-04-01 00:10:11.000000', 'temperatura', 1147.0000, 'ºC'),
	(128628, 110, '2015-04-01 00:10:12.000000', 'temperatura', 500.0000, 'ºC'),
	(128629, 110, '2015-04-01 00:10:13.000000', 'temperatura', 258.0000, 'ºC'),
	(128630, 110, '2015-04-01 00:10:14.000000', 'temperatura', 992.0000, 'ºC'),
	(128631, 110, '2015-04-01 00:10:15.000000', 'temperatura', 587.0000, 'ºC'),
	(128632, 110, '2015-04-01 00:10:16.000000', 'temperatura', 1157.0000, 'ºC'),
	(128633, 110, '2015-04-01 00:10:17.000000', 'temperatura', 425.0000, 'ºC'),
	(128634, 110, '2015-04-01 00:10:18.000000', 'temperatura', 1053.0000, 'ºC'),
	(128635, 110, '2015-04-01 00:10:19.000000', 'temperatura', 392.0000, 'ºC'),
	(128636, 110, '2015-04-01 00:10:20.000000', 'temperatura', 3.0000, 'ºC'),
	(128637, 110, '2015-04-01 00:10:21.000000', 'temperatura', 38.0000, 'ºC'),
	(128638, 110, '2015-04-01 00:10:22.000000', 'temperatura', 180.0000, 'ºC'),
	(128639, 110, '2015-04-01 00:10:23.000000', 'temperatura', 788.0000, 'ºC'),
	(128640, 110, '2015-04-01 00:10:24.000000', 'temperatura', 1001.0000, 'ºC'),
	(128641, 110, '2015-04-01 00:10:25.000000', 'temperatura', 243.0000, 'ºC'),
	(128642, 110, '2015-04-01 00:10:26.000000', 'temperatura', 611.0000, 'ºC'),
	(128643, 110, '2015-04-01 00:10:27.000000', 'temperatura', 1125.0000, 'ºC'),
	(128644, 110, '2015-04-01 00:10:28.000000', 'temperatura', 195.0000, 'ºC'),
	(128645, 110, '2015-04-01 00:10:29.000000', 'temperatura', 0.0000, 'ºC'),
	(128646, 110, '2015-04-01 00:10:30.000000', 'temperatura', 617.0000, 'ºC'),
	(128647, 110, '2015-04-01 00:10:31.000000', 'temperatura', 685.0000, 'ºC'),
	(128648, 110, '2015-04-01 00:10:32.000000', 'temperatura', 373.0000, 'ºC'),
	(128649, 110, '2015-04-01 00:10:33.000000', 'temperatura', 1010.0000, 'ºC'),
	(128650, 110, '2015-04-01 00:10:34.000000', 'temperatura', 333.0000, 'ºC'),
	(128651, 110, '2015-04-01 00:10:35.000000', 'temperatura', 1033.0000, 'ºC'),
	(128652, 110, '2015-04-01 00:10:36.000000', 'temperatura', 569.0000, 'ºC'),
	(128653, 110, '2015-04-01 00:10:37.000000', 'temperatura', 945.0000, 'ºC'),
	(128654, 110, '2015-04-01 00:10:38.000000', 'temperatura', 619.0000, 'ºC'),
	(128655, 110, '2015-04-01 00:10:39.000000', 'temperatura', 262.0000, 'ºC'),
	(128656, 110, '2015-04-01 00:10:40.000000', 'temperatura', 651.0000, 'ºC'),
	(128657, 110, '2015-04-01 00:10:41.000000', 'temperatura', 69.0000, 'ºC'),
	(128658, 110, '2015-04-01 00:10:42.000000', 'temperatura', 792.0000, 'ºC'),
	(128659, 110, '2015-04-01 00:10:43.000000', 'temperatura', 153.0000, 'ºC'),
	(128660, 110, '2015-04-01 00:10:44.000000', 'temperatura', 789.0000, 'ºC'),
	(128661, 110, '2015-04-01 00:10:45.000000', 'temperatura', 1088.0000, 'ºC'),
	(128662, 110, '2015-04-01 00:10:46.000000', 'temperatura', 673.0000, 'ºC'),
	(128663, 110, '2015-04-01 00:10:47.000000', 'temperatura', 101.0000, 'ºC'),
	(128664, 110, '2015-04-01 00:10:48.000000', 'temperatura', 886.0000, 'ºC'),
	(128665, 110, '2015-04-01 00:10:49.000000', 'temperatura', 527.0000, 'ºC'),
	(128666, 110, '2015-04-01 00:10:50.000000', 'temperatura', 1180.0000, 'ºC'),
	(128667, 110, '2015-04-01 00:10:51.000000', 'temperatura', 719.0000, 'ºC'),
	(128668, 110, '2015-04-01 00:10:52.000000', 'temperatura', 53.0000, 'ºC'),
	(128669, 110, '2015-04-01 00:10:53.000000', 'temperatura', 510.0000, 'ºC'),
	(128670, 110, '2015-04-01 00:10:54.000000', 'temperatura', 1192.0000, 'ºC'),
	(128671, 110, '2015-04-01 00:10:55.000000', 'temperatura', 832.0000, 'ºC'),
	(128672, 110, '2015-04-01 00:10:56.000000', 'temperatura', 582.0000, 'ºC'),
	(128673, 110, '2015-04-01 00:10:57.000000', 'temperatura', 415.0000, 'ºC'),
	(128674, 110, '2015-04-01 00:10:58.000000', 'temperatura', 332.0000, 'ºC'),
	(128675, 110, '2015-04-01 00:10:59.000000', 'temperatura', 413.0000, 'ºC'),
	(128676, 110, '2015-04-01 00:11:00.000000', 'temperatura', 1072.0000, 'ºC'),
	(128677, 110, '2015-04-01 00:11:01.000000', 'temperatura', 519.0000, 'ºC'),
	(128678, 110, '2015-04-01 00:11:02.000000', 'temperatura', 582.0000, 'ºC'),
	(128679, 110, '2015-04-01 00:11:03.000000', 'temperatura', 152.0000, 'ºC'),
	(128680, 110, '2015-04-01 00:11:04.000000', 'temperatura', 216.0000, 'ºC'),
	(128681, 110, '2015-04-01 00:11:05.000000', 'temperatura', 622.0000, 'ºC'),
	(128682, 110, '2015-04-01 00:11:06.000000', 'temperatura', 62.0000, 'ºC'),
	(128683, 110, '2015-04-01 00:11:07.000000', 'temperatura', 846.0000, 'ºC'),
	(128684, 110, '2015-04-01 00:11:08.000000', 'temperatura', 443.0000, 'ºC'),
	(128685, 110, '2015-04-01 00:11:09.000000', 'temperatura', 877.0000, 'ºC'),
	(128686, 110, '2015-04-01 00:11:10.000000', 'temperatura', 656.0000, 'ºC'),
	(128687, 110, '2015-04-01 00:11:11.000000', 'temperatura', 651.0000, 'ºC'),
	(128688, 110, '2015-04-01 00:11:12.000000', 'temperatura', 89.0000, 'ºC'),
	(128689, 110, '2015-04-01 00:11:13.000000', 'temperatura', 891.0000, 'ºC'),
	(128690, 110, '2015-04-01 00:11:14.000000', 'temperatura', 590.0000, 'ºC'),
	(128691, 110, '2015-04-01 00:11:15.000000', 'temperatura', 274.0000, 'ºC'),
	(128692, 110, '2015-04-01 00:11:16.000000', 'temperatura', 804.0000, 'ºC'),
	(128693, 110, '2015-04-01 00:11:17.000000', 'temperatura', 799.0000, 'ºC'),
	(128694, 110, '2015-04-01 00:11:18.000000', 'temperatura', 382.0000, 'ºC'),
	(128695, 110, '2015-04-01 00:11:19.000000', 'temperatura', 714.0000, 'ºC'),
	(128696, 110, '2015-04-01 00:11:20.000000', 'temperatura', 26.0000, 'ºC'),
	(128697, 110, '2015-04-01 00:11:21.000000', 'temperatura', 387.0000, 'ºC'),
	(128698, 110, '2015-04-01 00:11:22.000000', 'temperatura', 657.0000, 'ºC'),
	(128699, 110, '2015-04-01 00:11:23.000000', 'temperatura', 924.0000, 'ºC'),
	(128700, 110, '2015-04-01 00:11:24.000000', 'temperatura', 248.0000, 'ºC'),
	(128701, 110, '2015-04-01 00:11:25.000000', 'temperatura', 872.0000, 'ºC'),
	(128702, 110, '2015-04-01 00:11:26.000000', 'temperatura', 15.0000, 'ºC'),
	(128703, 110, '2015-04-01 00:11:27.000000', 'temperatura', 1062.0000, 'ºC'),
	(128704, 110, '2015-04-01 00:11:28.000000', 'temperatura', 462.0000, 'ºC'),
	(128705, 110, '2015-04-01 00:11:29.000000', 'temperatura', 326.0000, 'ºC'),
	(128706, 110, '2015-04-01 00:11:30.000000', 'temperatura', 244.0000, 'ºC'),
	(128707, 110, '2015-04-01 00:11:31.000000', 'temperatura', 243.0000, 'ºC'),
	(128708, 110, '2015-04-01 00:11:32.000000', 'temperatura', 484.0000, 'ºC'),
	(128709, 110, '2015-04-01 00:11:33.000000', 'temperatura', 490.0000, 'ºC'),
	(128710, 110, '2015-04-01 00:11:34.000000', 'temperatura', 999.0000, 'ºC'),
	(128711, 110, '2015-04-01 00:11:35.000000', 'temperatura', 1127.0000, 'ºC'),
	(128712, 110, '2015-04-01 00:11:36.000000', 'temperatura', 238.0000, 'ºC'),
	(128713, 110, '2015-04-01 00:11:37.000000', 'temperatura', 211.0000, 'ºC'),
	(128714, 110, '2015-04-01 00:11:38.000000', 'temperatura', 342.0000, 'ºC'),
	(128715, 110, '2015-04-01 00:11:39.000000', 'temperatura', 1074.0000, 'ºC'),
	(128716, 110, '2015-04-01 00:11:40.000000', 'temperatura', 747.0000, 'ºC'),
	(128717, 110, '2015-04-01 00:11:41.000000', 'temperatura', 513.0000, 'ºC'),
	(128718, 110, '2015-04-01 00:11:42.000000', 'temperatura', 325.0000, 'ºC'),
	(128719, 110, '2015-04-01 00:11:43.000000', 'temperatura', 84.0000, 'ºC'),
	(128720, 110, '2015-04-01 00:11:44.000000', 'temperatura', 647.0000, 'ºC'),
	(128721, 110, '2015-04-01 00:11:45.000000', 'temperatura', 583.0000, 'ºC'),
	(128722, 110, '2015-04-01 00:11:46.000000', 'temperatura', 973.0000, 'ºC'),
	(128723, 110, '2015-04-01 00:11:47.000000', 'temperatura', 718.0000, 'ºC'),
	(128724, 110, '2015-04-01 00:11:48.000000', 'temperatura', 673.0000, 'ºC'),
	(128725, 110, '2015-04-01 00:11:49.000000', 'temperatura', 10.0000, 'ºC'),
	(128726, 110, '2015-04-01 00:11:50.000000', 'temperatura', 433.0000, 'ºC'),
	(128727, 110, '2015-04-01 00:11:51.000000', 'temperatura', 935.0000, 'ºC'),
	(128728, 110, '2015-04-01 00:11:52.000000', 'temperatura', 976.0000, 'ºC'),
	(128729, 110, '2015-04-01 00:11:53.000000', 'temperatura', 876.0000, 'ºC'),
	(128730, 110, '2015-04-01 00:11:54.000000', 'temperatura', 253.0000, 'ºC'),
	(128731, 110, '2015-04-01 00:11:55.000000', 'temperatura', 1038.0000, 'ºC'),
	(128732, 110, '2015-04-01 00:11:56.000000', 'temperatura', 829.0000, 'ºC'),
	(128733, 110, '2015-04-01 00:11:57.000000', 'temperatura', 1033.0000, 'ºC'),
	(128734, 110, '2015-04-01 00:11:58.000000', 'temperatura', 279.0000, 'ºC'),
	(128735, 110, '2015-04-01 00:11:59.000000', 'temperatura', 697.0000, 'ºC'),
	(128736, 110, '2015-04-01 00:12:00.000000', 'temperatura', 249.0000, 'ºC'),
	(128737, 110, '2015-04-01 00:12:01.000000', 'temperatura', 354.0000, 'ºC'),
	(128738, 110, '2015-04-01 00:12:02.000000', 'temperatura', 1023.0000, 'ºC'),
	(128739, 110, '2015-04-01 00:12:03.000000', 'temperatura', 453.0000, 'ºC'),
	(128740, 110, '2015-04-01 00:12:04.000000', 'temperatura', 399.0000, 'ºC'),
	(128741, 110, '2015-04-01 00:12:05.000000', 'temperatura', 633.0000, 'ºC'),
	(128742, 110, '2015-04-01 00:12:06.000000', 'temperatura', 770.0000, 'ºC'),
	(128743, 110, '2015-04-01 00:12:07.000000', 'temperatura', 752.0000, 'ºC'),
	(128744, 110, '2015-04-01 00:12:08.000000', 'temperatura', 251.0000, 'ºC'),
	(128745, 110, '2015-04-01 00:12:09.000000', 'temperatura', 197.0000, 'ºC'),
	(128746, 110, '2015-04-01 00:12:10.000000', 'temperatura', 235.0000, 'ºC'),
	(128747, 110, '2015-04-01 00:12:11.000000', 'temperatura', 585.0000, 'ºC'),
	(128748, 110, '2015-04-01 00:12:12.000000', 'temperatura', 1021.0000, 'ºC'),
	(128749, 110, '2015-04-01 00:12:13.000000', 'temperatura', 951.0000, 'ºC'),
	(128750, 110, '2015-04-01 00:12:14.000000', 'temperatura', 490.0000, 'ºC'),
	(128751, 110, '2015-04-01 00:12:15.000000', 'temperatura', 799.0000, 'ºC'),
	(128752, 110, '2015-04-01 00:12:16.000000', 'temperatura', 125.0000, 'ºC'),
	(128753, 110, '2015-04-01 00:12:17.000000', 'temperatura', 629.0000, 'ºC'),
	(128754, 110, '2015-04-01 00:12:18.000000', 'temperatura', 372.0000, 'ºC'),
	(128755, 110, '2015-04-01 00:12:19.000000', 'temperatura', 1173.0000, 'ºC'),
	(128756, 110, '2015-04-01 00:12:20.000000', 'temperatura', 1149.0000, 'ºC'),
	(128757, 110, '2015-04-01 00:12:21.000000', 'temperatura', 1025.0000, 'ºC'),
	(128758, 110, '2015-04-01 00:12:22.000000', 'temperatura', 481.0000, 'ºC'),
	(128759, 110, '2015-04-01 00:12:23.000000', 'temperatura', 528.0000, 'ºC'),
	(128760, 110, '2015-04-01 00:12:24.000000', 'temperatura', 1198.0000, 'ºC'),
	(128761, 110, '2015-04-01 00:12:25.000000', 'temperatura', 808.0000, 'ºC'),
	(128762, 110, '2015-04-01 00:12:26.000000', 'temperatura', 446.0000, 'ºC'),
	(128763, 110, '2015-04-01 00:12:27.000000', 'temperatura', 1006.0000, 'ºC'),
	(128764, 110, '2015-04-01 00:12:28.000000', 'temperatura', 93.0000, 'ºC'),
	(128765, 110, '2015-04-01 00:12:29.000000', 'temperatura', 1046.0000, 'ºC'),
	(128766, 110, '2015-04-01 00:12:30.000000', 'temperatura', 153.0000, 'ºC'),
	(128767, 110, '2015-04-01 00:12:31.000000', 'temperatura', 26.0000, 'ºC'),
	(128768, 110, '2015-04-01 00:12:32.000000', 'temperatura', 873.0000, 'ºC'),
	(128769, 110, '2015-04-01 00:12:33.000000', 'temperatura', 687.0000, 'ºC'),
	(128770, 110, '2015-04-01 00:12:34.000000', 'temperatura', 817.0000, 'ºC'),
	(128771, 110, '2015-04-01 00:12:35.000000', 'temperatura', 823.0000, 'ºC'),
	(128772, 110, '2015-04-01 00:12:36.000000', 'temperatura', 465.0000, 'ºC'),
	(128773, 110, '2015-04-01 00:12:37.000000', 'temperatura', 1058.0000, 'ºC'),
	(128774, 110, '2015-04-01 00:12:38.000000', 'temperatura', 295.0000, 'ºC'),
	(128775, 110, '2015-04-01 00:12:39.000000', 'temperatura', 703.0000, 'ºC'),
	(128776, 110, '2015-04-01 00:12:40.000000', 'temperatura', 228.0000, 'ºC'),
	(128777, 110, '2015-04-01 00:12:41.000000', 'temperatura', 233.0000, 'ºC'),
	(128778, 110, '2015-04-01 00:12:42.000000', 'temperatura', 481.0000, 'ºC'),
	(128779, 110, '2015-04-01 00:12:43.000000', 'temperatura', 509.0000, 'ºC'),
	(128780, 110, '2015-04-01 00:12:44.000000', 'temperatura', 1099.0000, 'ºC'),
	(128781, 110, '2015-04-01 00:12:45.000000', 'temperatura', 370.0000, 'ºC'),
	(128782, 110, '2015-04-01 00:12:46.000000', 'temperatura', 954.0000, 'ºC'),
	(128783, 110, '2015-04-01 00:12:47.000000', 'temperatura', 62.0000, 'ºC'),
	(128784, 110, '2015-04-01 00:12:48.000000', 'temperatura', 1048.0000, 'ºC'),
	(128785, 110, '2015-04-01 00:12:49.000000', 'temperatura', 253.0000, 'ºC'),
	(128786, 110, '2015-04-01 00:12:50.000000', 'temperatura', 523.0000, 'ºC'),
	(128787, 110, '2015-04-01 00:12:51.000000', 'temperatura', 655.0000, 'ºC'),
	(128788, 110, '2015-04-01 00:12:52.000000', 'temperatura', 509.0000, 'ºC'),
	(128789, 110, '2015-04-01 00:12:53.000000', 'temperatura', 578.0000, 'ºC'),
	(128790, 110, '2015-04-01 00:12:54.000000', 'temperatura', 166.0000, 'ºC'),
	(128791, 110, '2015-04-01 00:12:55.000000', 'temperatura', 296.0000, 'ºC'),
	(128792, 110, '2015-04-01 00:12:56.000000', 'temperatura', 983.0000, 'ºC'),
	(128793, 110, '2015-04-01 00:12:57.000000', 'temperatura', 425.0000, 'ºC'),
	(128794, 110, '2015-04-01 00:12:58.000000', 'temperatura', 379.0000, 'ºC'),
	(128795, 110, '2015-04-01 00:12:59.000000', 'temperatura', 621.0000, 'ºC'),
	(128796, 110, '2015-04-01 00:13:00.000000', 'temperatura', 765.0000, 'ºC'),
	(128797, 110, '2015-04-01 00:13:01.000000', 'temperatura', 766.0000, 'ºC'),
	(128798, 110, '2015-04-01 00:13:02.000000', 'temperatura', 335.0000, 'ºC'),
	(128799, 110, '2015-04-01 00:13:03.000000', 'temperatura', 579.0000, 'ºC'),
	(128800, 110, '2015-04-01 00:13:04.000000', 'temperatura', 689.0000, 'ºC'),
	(128801, 110, '2015-04-01 00:13:05.000000', 'temperatura', 507.0000, 'ºC'),
	(128802, 110, '2015-04-01 00:13:06.000000', 'temperatura', 471.0000, 'ºC'),
	(128803, 110, '2015-04-01 00:13:07.000000', 'temperatura', 834.0000, 'ºC'),
	(128804, 110, '2015-04-01 00:13:08.000000', 'temperatura', 358.0000, 'ºC'),
	(128805, 110, '2015-04-01 00:13:09.000000', 'temperatura', 486.0000, 'ºC'),
	(128806, 110, '2015-04-01 00:13:10.000000', 'temperatura', 157.0000, 'ºC'),
	(128807, 110, '2015-04-01 00:13:11.000000', 'temperatura', 529.0000, 'ºC'),
	(128808, 110, '2015-04-01 00:13:12.000000', 'temperatura', 975.0000, 'ºC'),
	(128809, 110, '2015-04-01 00:13:13.000000', 'temperatura', 887.0000, 'ºC'),
	(128810, 110, '2015-04-01 00:13:14.000000', 'temperatura', 312.0000, 'ºC'),
	(128811, 110, '2015-04-01 00:13:15.000000', 'temperatura', 100.0000, 'ºC'),
	(128812, 110, '2015-04-01 00:13:16.000000', 'temperatura', 763.0000, 'ºC'),
	(128813, 110, '2015-04-01 00:13:17.000000', 'temperatura', 1117.0000, 'ºC'),
	(128814, 110, '2015-04-01 00:13:18.000000', 'temperatura', 895.0000, 'ºC'),
	(128815, 110, '2015-04-01 00:13:19.000000', 'temperatura', 1125.0000, 'ºC'),
	(128816, 110, '2015-04-01 00:13:20.000000', 'temperatura', 539.0000, 'ºC'),
	(128817, 110, '2015-04-01 00:13:21.000000', 'temperatura', 522.0000, 'ºC'),
	(128818, 110, '2015-04-01 00:13:22.000000', 'temperatura', 994.0000, 'ºC'),
	(128819, 110, '2015-04-01 00:13:23.000000', 'temperatura', 1002.0000, 'ºC'),
	(128820, 110, '2015-04-01 00:13:24.000000', 'temperatura', 830.0000, 'ºC'),
	(128821, 110, '2015-04-01 00:13:25.000000', 'temperatura', 1145.0000, 'ºC'),
	(128822, 110, '2015-04-01 00:13:26.000000', 'temperatura', 836.0000, 'ºC'),
	(128823, 110, '2015-04-01 00:13:27.000000', 'temperatura', 745.0000, 'ºC'),
	(128824, 110, '2015-04-01 00:13:28.000000', 'temperatura', 19.0000, 'ºC'),
	(128825, 110, '2015-04-01 00:13:29.000000', 'temperatura', 260.0000, 'ºC'),
	(128826, 110, '2015-04-01 00:13:30.000000', 'temperatura', 43.0000, 'ºC'),
	(128827, 110, '2015-04-01 00:13:31.000000', 'temperatura', 637.0000, 'ºC'),
	(128828, 110, '2015-04-01 00:13:32.000000', 'temperatura', 657.0000, 'ºC'),
	(128829, 110, '2015-04-01 00:13:33.000000', 'temperatura', 172.0000, 'ºC'),
	(128830, 110, '2015-04-01 00:13:34.000000', 'temperatura', 89.0000, 'ºC'),
	(128831, 110, '2015-04-01 00:13:35.000000', 'temperatura', 1131.0000, 'ºC'),
	(128832, 110, '2015-04-01 00:13:36.000000', 'temperatura', 586.0000, 'ºC'),
	(128833, 110, '2015-04-01 00:13:37.000000', 'temperatura', 741.0000, 'ºC'),
	(128834, 110, '2015-04-01 00:13:38.000000', 'temperatura', 747.0000, 'ºC'),
	(128835, 110, '2015-04-01 00:13:39.000000', 'temperatura', 311.0000, 'ºC'),
	(128836, 110, '2015-04-01 00:13:40.000000', 'temperatura', 516.0000, 'ºC'),
	(128837, 110, '2015-04-01 00:13:41.000000', 'temperatura', 449.0000, 'ºC'),
	(128838, 110, '2015-04-01 00:13:42.000000', 'temperatura', 695.0000, 'ºC'),
	(128839, 110, '2015-04-01 00:13:43.000000', 'temperatura', 928.0000, 'ºC'),
	(128840, 110, '2015-04-01 00:13:44.000000', 'temperatura', 157.0000, 'ºC'),
	(128841, 110, '2015-04-01 00:13:45.000000', 'temperatura', 402.0000, 'ºC'),
	(128842, 110, '2015-04-01 00:13:46.000000', 'temperatura', 338.0000, 'ºC'),
	(128843, 110, '2015-04-01 00:13:47.000000', 'temperatura', 484.0000, 'ºC'),
	(128844, 110, '2015-04-01 00:13:48.000000', 'temperatura', 205.0000, 'ºC'),
	(128845, 110, '2015-04-01 00:13:49.000000', 'temperatura', 776.0000, 'ºC'),
	(128846, 110, '2015-04-01 00:13:50.000000', 'temperatura', 866.0000, 'ºC'),
	(128847, 110, '2015-04-01 00:13:51.000000', 'temperatura', 800.0000, 'ºC'),
	(128848, 110, '2015-04-01 00:13:52.000000', 'temperatura', 205.0000, 'ºC'),
	(128849, 110, '2015-04-01 00:13:53.000000', 'temperatura', 1027.0000, 'ºC'),
	(128850, 110, '2015-04-01 00:13:54.000000', 'temperatura', 918.0000, 'ºC'),
	(128851, 110, '2015-04-01 00:13:55.000000', 'temperatura', 309.0000, 'ºC'),
	(128852, 110, '2015-04-01 00:13:56.000000', 'temperatura', 1191.0000, 'ºC'),
	(128853, 110, '2015-04-01 00:13:57.000000', 'temperatura', 228.0000, 'ºC'),
	(128854, 110, '2015-04-01 00:13:58.000000', 'temperatura', 1168.0000, 'ºC'),
	(128855, 110, '2015-04-01 00:13:59.000000', 'temperatura', 357.0000, 'ºC'),
	(128856, 110, '2015-04-01 00:14:00.000000', 'temperatura', 681.0000, 'ºC'),
	(128857, 110, '2015-04-01 00:14:01.000000', 'temperatura', 1136.0000, 'ºC'),
	(128858, 110, '2015-04-01 00:14:02.000000', 'temperatura', 38.0000, 'ºC'),
	(128859, 110, '2015-04-01 00:14:03.000000', 'temperatura', 380.0000, 'ºC'),
	(128860, 110, '2015-04-01 00:14:04.000000', 'temperatura', 588.0000, 'ºC'),
	(128861, 110, '2015-04-01 00:14:05.000000', 'temperatura', 601.0000, 'ºC'),
	(128862, 110, '2015-04-01 00:14:06.000000', 'temperatura', 43.0000, 'ºC'),
	(128863, 110, '2015-04-01 00:14:07.000000', 'temperatura', 809.0000, 'ºC'),
	(128864, 110, '2015-04-01 00:14:08.000000', 'temperatura', 319.0000, 'ºC'),
	(128865, 110, '2015-04-01 00:14:09.000000', 'temperatura', 369.0000, 'ºC'),
	(128866, 110, '2015-04-01 00:14:10.000000', 'temperatura', 889.0000, 'ºC'),
	(128867, 110, '2015-04-01 00:14:11.000000', 'temperatura', 938.0000, 'ºC'),
	(128868, 110, '2015-04-01 00:14:12.000000', 'temperatura', 821.0000, 'ºC'),
	(128869, 110, '2015-04-01 00:14:13.000000', 'temperatura', 93.0000, 'ºC'),
	(128870, 110, '2015-04-01 00:14:14.000000', 'temperatura', 404.0000, 'ºC'),
	(128871, 110, '2015-04-01 00:14:15.000000', 'temperatura', 539.0000, 'ºC'),
	(128872, 110, '2015-04-01 00:14:16.000000', 'temperatura', 284.0000, 'ºC'),
	(128873, 110, '2015-04-01 00:14:17.000000', 'temperatura', 1003.0000, 'ºC'),
	(128874, 110, '2015-04-01 00:14:18.000000', 'temperatura', 564.0000, 'ºC'),
	(128875, 110, '2015-04-01 00:14:19.000000', 'temperatura', 1010.0000, 'ºC'),
	(128876, 110, '2015-04-01 00:14:20.000000', 'temperatura', 961.0000, 'ºC'),
	(128877, 110, '2015-04-01 00:14:21.000000', 'temperatura', 575.0000, 'ºC'),
	(128878, 110, '2015-04-01 00:14:22.000000', 'temperatura', 1190.0000, 'ºC'),
	(128879, 110, '2015-04-01 00:14:23.000000', 'temperatura', 627.0000, 'ºC'),
	(128880, 110, '2015-04-01 00:14:24.000000', 'temperatura', 767.0000, 'ºC'),
	(128881, 110, '2015-04-01 00:14:25.000000', 'temperatura', 754.0000, 'ºC'),
	(128882, 110, '2015-04-01 00:14:26.000000', 'temperatura', 269.0000, 'ºC'),
	(128883, 110, '2015-04-01 00:14:27.000000', 'temperatura', 284.0000, 'ºC'),
	(128884, 110, '2015-04-01 00:14:28.000000', 'temperatura', 613.0000, 'ºC'),
	(128885, 110, '2015-04-01 00:14:29.000000', 'temperatura', 1014.0000, 'ºC'),
	(128886, 110, '2015-04-01 00:14:30.000000', 'temperatura', 830.0000, 'ºC'),
	(128887, 110, '2015-04-01 00:14:31.000000', 'temperatura', 1109.0000, 'ºC'),
	(128888, 110, '2015-04-01 00:14:32.000000', 'temperatura', 657.0000, 'ºC'),
	(128889, 110, '2015-04-01 00:14:33.000000', 'temperatura', 1159.0000, 'ºC'),
	(128890, 110, '2015-04-01 00:14:34.000000', 'temperatura', 221.0000, 'ºC'),
	(128891, 110, '2015-04-01 00:14:35.000000', 'temperatura', 32.0000, 'ºC'),
	(128892, 110, '2015-04-01 00:14:36.000000', 'temperatura', 698.0000, 'ºC'),
	(128893, 110, '2015-04-01 00:14:37.000000', 'temperatura', 992.0000, 'ºC'),
	(128894, 110, '2015-04-01 00:14:38.000000', 'temperatura', 468.0000, 'ºC'),
	(128895, 110, '2015-04-01 00:14:39.000000', 'temperatura', 564.0000, 'ºC'),
	(128896, 110, '2015-04-01 00:14:40.000000', 'temperatura', 218.0000, 'ºC'),
	(128897, 110, '2015-04-01 00:14:41.000000', 'temperatura', 597.0000, 'ºC'),
	(128898, 110, '2015-04-01 00:14:42.000000', 'temperatura', 1132.0000, 'ºC'),
	(128899, 110, '2015-04-01 00:14:43.000000', 'temperatura', 271.0000, 'ºC'),
	(128900, 110, '2015-04-01 00:14:44.000000', 'temperatura', 359.0000, 'ºC'),
	(128901, 110, '2015-04-01 00:14:45.000000', 'temperatura', 981.0000, 'ºC'),
	(128902, 110, '2015-04-01 00:14:46.000000', 'temperatura', 228.0000, 'ºC'),
	(128903, 110, '2015-04-01 00:14:47.000000', 'temperatura', 599.0000, 'ºC'),
	(128904, 110, '2015-04-01 00:14:48.000000', 'temperatura', 1110.0000, 'ºC'),
	(128905, 110, '2015-04-01 00:14:49.000000', 'temperatura', 152.0000, 'ºC'),
	(128906, 110, '2015-04-01 00:14:50.000000', 'temperatura', 1033.0000, 'ºC'),
	(128907, 110, '2015-04-01 00:14:51.000000', 'temperatura', 1107.0000, 'ºC'),
	(128908, 110, '2015-04-01 00:14:52.000000', 'temperatura', 37.0000, 'ºC'),
	(128909, 110, '2015-04-01 00:14:53.000000', 'temperatura', 466.0000, 'ºC'),
	(128910, 110, '2015-04-01 00:14:54.000000', 'temperatura', 1020.0000, 'ºC'),
	(128911, 110, '2015-04-01 00:14:55.000000', 'temperatura', 103.0000, 'ºC'),
	(128912, 110, '2015-04-01 00:14:56.000000', 'temperatura', 1054.0000, 'ºC'),
	(128913, 110, '2015-04-01 00:14:57.000000', 'temperatura', 162.0000, 'ºC'),
	(128914, 110, '2015-04-01 00:14:58.000000', 'temperatura', 46.0000, 'ºC'),
	(128915, 110, '2015-04-01 00:14:59.000000', 'temperatura', 948.0000, 'ºC'),
	(128916, 110, '2015-04-01 00:15:00.000000', 'temperatura', 1002.0000, 'ºC'),
	(128917, 110, '2015-04-01 00:15:01.000000', 'temperatura', 966.0000, 'ºC'),
	(128918, 110, '2015-04-01 00:15:02.000000', 'temperatura', 625.0000, 'ºC'),
	(128919, 110, '2015-04-01 00:15:03.000000', 'temperatura', 226.0000, 'ºC'),
	(128920, 110, '2015-04-01 00:15:04.000000', 'temperatura', 455.0000, 'ºC'),
	(128921, 110, '2015-04-01 00:15:05.000000', 'temperatura', 396.0000, 'ºC'),
	(128922, 110, '2015-04-01 00:15:06.000000', 'temperatura', 618.0000, 'ºC'),
	(128923, 110, '2015-04-01 00:15:07.000000', 'temperatura', 703.0000, 'ºC'),
	(128924, 110, '2015-04-01 00:15:08.000000', 'temperatura', 463.0000, 'ºC'),
	(128925, 110, '2015-04-01 00:15:09.000000', 'temperatura', 203.0000, 'ºC'),
	(128926, 110, '2015-04-01 00:15:10.000000', 'temperatura', 828.0000, 'ºC'),
	(128927, 110, '2015-04-01 00:15:11.000000', 'temperatura', 1130.0000, 'ºC'),
	(128928, 110, '2015-04-01 00:15:12.000000', 'temperatura', 767.0000, 'ºC'),
	(128929, 110, '2015-04-01 00:15:13.000000', 'temperatura', 447.0000, 'ºC'),
	(128930, 110, '2015-04-01 00:15:14.000000', 'temperatura', 1135.0000, 'ºC'),
	(128931, 110, '2015-04-01 00:15:15.000000', 'temperatura', 733.0000, 'ºC'),
	(128932, 110, '2015-04-01 00:15:16.000000', 'temperatura', 261.0000, 'ºC'),
	(128933, 110, '2015-04-01 00:15:17.000000', 'temperatura', 306.0000, 'ºC'),
	(128934, 110, '2015-04-01 00:15:18.000000', 'temperatura', 747.0000, 'ºC'),
	(128935, 110, '2015-04-01 00:15:19.000000', 'temperatura', 420.0000, 'ºC'),
	(128936, 110, '2015-04-01 00:15:20.000000', 'temperatura', 1057.0000, 'ºC'),
	(128937, 110, '2015-04-01 00:15:21.000000', 'temperatura', 427.0000, 'ºC'),
	(128938, 110, '2015-04-01 00:15:22.000000', 'temperatura', 165.0000, 'ºC'),
	(128939, 110, '2015-04-01 00:15:23.000000', 'temperatura', 743.0000, 'ºC'),
	(128940, 110, '2015-04-01 00:15:24.000000', 'temperatura', 820.0000, 'ºC'),
	(128941, 110, '2015-04-01 00:15:25.000000', 'temperatura', 673.0000, 'ºC'),
	(128942, 110, '2015-04-01 00:15:26.000000', 'temperatura', 907.0000, 'ºC'),
	(128943, 110, '2015-04-01 00:15:27.000000', 'temperatura', 115.0000, 'ºC'),
	(128944, 110, '2015-04-01 00:15:28.000000', 'temperatura', 254.0000, 'ºC'),
	(128945, 110, '2015-04-01 00:15:29.000000', 'temperatura', 927.0000, 'ºC'),
	(128946, 110, '2015-04-01 00:15:30.000000', 'temperatura', 271.0000, 'ºC'),
	(128947, 110, '2015-04-01 00:15:31.000000', 'temperatura', 978.0000, 'ºC'),
	(128948, 110, '2015-04-01 00:15:32.000000', 'temperatura', 474.0000, 'ºC'),
	(128949, 110, '2015-04-01 00:15:33.000000', 'temperatura', 639.0000, 'ºC'),
	(128950, 110, '2015-04-01 00:15:34.000000', 'temperatura', 571.0000, 'ºC'),
	(128951, 110, '2015-04-01 00:15:35.000000', 'temperatura', 941.0000, 'ºC'),
	(128952, 110, '2015-04-01 00:15:36.000000', 'temperatura', 589.0000, 'ºC'),
	(128953, 110, '2015-04-01 00:15:37.000000', 'temperatura', 126.0000, 'ºC'),
	(128954, 110, '2015-04-01 00:15:38.000000', 'temperatura', 63.0000, 'ºC'),
	(128955, 110, '2015-04-01 00:15:39.000000', 'temperatura', 1138.0000, 'ºC'),
	(128956, 110, '2015-04-01 00:15:40.000000', 'temperatura', 703.0000, 'ºC'),
	(128957, 110, '2015-04-01 00:15:41.000000', 'temperatura', 99.0000, 'ºC'),
	(128958, 110, '2015-04-01 00:15:42.000000', 'temperatura', 789.0000, 'ºC'),
	(128959, 110, '2015-04-01 00:15:43.000000', 'temperatura', 46.0000, 'ºC'),
	(128960, 110, '2015-04-01 00:15:44.000000', 'temperatura', 265.0000, 'ºC'),
	(128961, 110, '2015-04-01 00:15:45.000000', 'temperatura', 1189.0000, 'ºC'),
	(128962, 110, '2015-04-01 00:15:46.000000', 'temperatura', 349.0000, 'ºC'),
	(128963, 110, '2015-04-01 00:15:47.000000', 'temperatura', 577.0000, 'ºC'),
	(128964, 110, '2015-04-01 00:15:48.000000', 'temperatura', 639.0000, 'ºC'),
	(128965, 110, '2015-04-01 00:15:49.000000', 'temperatura', 263.0000, 'ºC'),
	(128966, 110, '2015-04-01 00:15:50.000000', 'temperatura', 601.0000, 'ºC'),
	(128967, 110, '2015-04-01 00:15:51.000000', 'temperatura', 1014.0000, 'ºC'),
	(128968, 110, '2015-04-01 00:15:52.000000', 'temperatura', 870.0000, 'ºC'),
	(128969, 110, '2015-04-01 00:15:53.000000', 'temperatura', 107.0000, 'ºC'),
	(128970, 110, '2015-04-01 00:15:54.000000', 'temperatura', 324.0000, 'ºC'),
	(128971, 110, '2015-04-01 00:15:55.000000', 'temperatura', 103.0000, 'ºC'),
	(128972, 110, '2015-04-01 00:15:56.000000', 'temperatura', 740.0000, 'ºC'),
	(128973, 110, '2015-04-01 00:15:57.000000', 'temperatura', 994.0000, 'ºC'),
	(128974, 110, '2015-04-01 00:15:58.000000', 'temperatura', 350.0000, 'ºC'),
	(128975, 110, '2015-04-01 00:15:59.000000', 'temperatura', 1166.0000, 'ºC'),
	(128976, 110, '2015-04-01 00:16:00.000000', 'temperatura', 1183.0000, 'ºC'),
	(128977, 110, '2015-04-01 00:16:01.000000', 'temperatura', 19.0000, 'ºC'),
	(128978, 110, '2015-04-01 00:16:02.000000', 'temperatura', 143.0000, 'ºC'),
	(128979, 110, '2015-04-01 00:16:03.000000', 'temperatura', 662.0000, 'ºC'),
	(128980, 110, '2015-04-01 00:16:04.000000', 'temperatura', 478.0000, 'ºC'),
	(128981, 110, '2015-04-01 00:16:05.000000', 'temperatura', 406.0000, 'ºC'),
	(128982, 110, '2015-04-01 00:16:06.000000', 'temperatura', 596.0000, 'ºC'),
	(128983, 110, '2015-04-01 00:16:07.000000', 'temperatura', 563.0000, 'ºC'),
	(128984, 110, '2015-04-01 00:16:08.000000', 'temperatura', 1029.0000, 'ºC'),
	(128985, 110, '2015-04-01 00:16:09.000000', 'temperatura', 1056.0000, 'ºC'),
	(128986, 110, '2015-04-01 00:16:10.000000', 'temperatura', 991.0000, 'ºC'),
	(128987, 110, '2015-04-01 00:16:11.000000', 'temperatura', 589.0000, 'ºC'),
	(128988, 110, '2015-04-01 00:16:12.000000', 'temperatura', 1172.0000, 'ºC'),
	(128989, 110, '2015-04-01 00:16:13.000000', 'temperatura', 492.0000, 'ºC'),
	(128990, 110, '2015-04-01 00:16:14.000000', 'temperatura', 146.0000, 'ºC'),
	(128991, 110, '2015-04-01 00:16:15.000000', 'temperatura', 452.0000, 'ºC'),
	(128992, 110, '2015-04-01 00:16:16.000000', 'temperatura', 625.0000, 'ºC'),
	(128993, 110, '2015-04-01 00:16:17.000000', 'temperatura', 569.0000, 'ºC'),
	(128994, 110, '2015-04-01 00:16:18.000000', 'temperatura', 971.0000, 'ºC'),
	(128995, 110, '2015-04-01 00:16:19.000000', 'temperatura', 750.0000, 'ºC'),
	(128996, 110, '2015-04-01 00:16:20.000000', 'temperatura', 837.0000, 'ºC'),
	(128997, 110, '2015-04-01 00:16:21.000000', 'temperatura', 735.0000, 'ºC'),
	(128998, 110, '2015-04-01 00:16:22.000000', 'temperatura', 1164.0000, 'ºC'),
	(128999, 110, '2015-04-01 00:16:23.000000', 'temperatura', 15.0000, 'ºC'),
	(129000, 110, '2015-04-01 00:16:24.000000', 'temperatura', 183.0000, 'ºC'),
	(129001, 110, '2015-04-01 00:16:25.000000', 'temperatura', 871.0000, 'ºC'),
	(129002, 110, '2015-04-01 00:16:26.000000', 'temperatura', 206.0000, 'ºC'),
	(129003, 110, '2015-04-01 00:16:27.000000', 'temperatura', 819.0000, 'ºC'),
	(129004, 110, '2015-04-01 00:16:28.000000', 'temperatura', 1075.0000, 'ºC'),
	(129005, 110, '2015-04-01 00:16:29.000000', 'temperatura', 518.0000, 'ºC'),
	(129006, 110, '2015-04-01 00:16:30.000000', 'temperatura', 568.0000, 'ºC'),
	(129007, 110, '2015-04-01 00:16:31.000000', 'temperatura', 87.0000, 'ºC'),
	(129008, 110, '2015-04-01 00:16:32.000000', 'temperatura', 1131.0000, 'ºC'),
	(129009, 110, '2015-04-01 00:16:33.000000', 'temperatura', 593.0000, 'ºC'),
	(129010, 110, '2015-04-01 00:16:34.000000', 'temperatura', 774.0000, 'ºC'),
	(129011, 110, '2015-04-01 00:16:35.000000', 'temperatura', 891.0000, 'ºC'),
	(129012, 110, '2015-04-01 00:16:36.000000', 'temperatura', 933.0000, 'ºC'),
	(129013, 110, '2015-04-01 00:16:37.000000', 'temperatura', 791.0000, 'ºC'),
	(129014, 110, '2015-04-01 00:16:38.000000', 'temperatura', 1157.0000, 'ºC'),
	(129015, 110, '2015-04-01 00:16:39.000000', 'temperatura', 1012.0000, 'ºC'),
	(129016, 110, '2015-04-01 00:16:40.000000', 'temperatura', 389.0000, 'ºC'),
	(129017, 110, '2015-04-01 00:16:41.000000', 'temperatura', 110.0000, 'ºC'),
	(129018, 110, '2015-04-01 00:16:42.000000', 'temperatura', 585.0000, 'ºC'),
	(129019, 110, '2015-04-01 00:16:43.000000', 'temperatura', 194.0000, 'ºC'),
	(129020, 110, '2015-04-01 00:16:44.000000', 'temperatura', 416.0000, 'ºC'),
	(129021, 110, '2015-04-01 00:16:45.000000', 'temperatura', 299.0000, 'ºC'),
	(129022, 110, '2015-04-01 00:16:46.000000', 'temperatura', 249.0000, 'ºC'),
	(129023, 110, '2015-04-01 00:16:47.000000', 'temperatura', 346.0000, 'ºC'),
	(129024, 110, '2015-04-01 00:16:48.000000', 'temperatura', 983.0000, 'ºC'),
	(129025, 110, '2015-04-01 00:16:49.000000', 'temperatura', 280.0000, 'ºC'),
	(129026, 110, '2015-04-01 00:16:50.000000', 'temperatura', 850.0000, 'ºC'),
	(129027, 110, '2015-04-01 00:16:51.000000', 'temperatura', 1010.0000, 'ºC'),
	(129028, 110, '2015-04-01 00:16:52.000000', 'temperatura', 100.0000, 'ºC'),
	(129029, 110, '2015-04-01 00:16:53.000000', 'temperatura', 1069.0000, 'ºC'),
	(129030, 110, '2015-04-01 00:16:54.000000', 'temperatura', 249.0000, 'ºC'),
	(129031, 110, '2015-04-01 00:16:55.000000', 'temperatura', 438.0000, 'ºC'),
	(129032, 110, '2015-04-01 00:16:56.000000', 'temperatura', 241.0000, 'ºC'),
	(129033, 110, '2015-04-01 00:16:57.000000', 'temperatura', 1094.0000, 'ºC'),
	(129034, 110, '2015-04-01 00:16:58.000000', 'temperatura', 1148.0000, 'ºC'),
	(129035, 110, '2015-04-01 00:16:59.000000', 'temperatura', 58.0000, 'ºC'),
	(129036, 110, '2015-04-01 00:17:00.000000', 'temperatura', 447.0000, 'ºC'),
	(129037, 110, '2015-04-01 00:17:01.000000', 'temperatura', 863.0000, 'ºC'),
	(129038, 110, '2015-04-01 00:17:02.000000', 'temperatura', 572.0000, 'ºC'),
	(129039, 110, '2015-04-01 00:17:03.000000', 'temperatura', 273.0000, 'ºC'),
	(129040, 110, '2015-04-01 00:17:04.000000', 'temperatura', 850.0000, 'ºC'),
	(129041, 110, '2015-04-01 00:17:05.000000', 'temperatura', 1031.0000, 'ºC'),
	(129042, 110, '2015-04-01 00:17:06.000000', 'temperatura', 207.0000, 'ºC'),
	(129043, 110, '2015-04-01 00:17:07.000000', 'temperatura', 340.0000, 'ºC'),
	(129044, 110, '2015-04-01 00:17:08.000000', 'temperatura', 1081.0000, 'ºC'),
	(129045, 110, '2015-04-01 00:17:09.000000', 'temperatura', 784.0000, 'ºC'),
	(129046, 110, '2015-04-01 00:17:10.000000', 'temperatura', 679.0000, 'ºC'),
	(129047, 110, '2015-04-01 00:17:11.000000', 'temperatura', 1042.0000, 'ºC'),
	(129048, 110, '2015-04-01 00:17:12.000000', 'temperatura', 773.0000, 'ºC'),
	(129049, 110, '2015-04-01 00:17:13.000000', 'temperatura', 739.0000, 'ºC'),
	(129050, 110, '2015-04-01 00:17:14.000000', 'temperatura', 178.0000, 'ºC'),
	(129051, 110, '2015-04-01 00:17:15.000000', 'temperatura', 1072.0000, 'ºC'),
	(129052, 110, '2015-04-01 00:17:16.000000', 'temperatura', 29.0000, 'ºC'),
	(129053, 110, '2015-04-01 00:17:17.000000', 'temperatura', 527.0000, 'ºC'),
	(129054, 110, '2015-04-01 00:17:18.000000', 'temperatura', 148.0000, 'ºC'),
	(129055, 110, '2015-04-01 00:17:19.000000', 'temperatura', 360.0000, 'ºC'),
	(129056, 110, '2015-04-01 00:17:20.000000', 'temperatura', 158.0000, 'ºC'),
	(129057, 110, '2015-04-01 00:17:21.000000', 'temperatura', 909.0000, 'ºC'),
	(129058, 110, '2015-04-01 00:17:22.000000', 'temperatura', 473.0000, 'ºC'),
	(129059, 110, '2015-04-01 00:17:23.000000', 'temperatura', 836.0000, 'ºC'),
	(129060, 110, '2015-04-01 00:17:24.000000', 'temperatura', 365.0000, 'ºC'),
	(129061, 110, '2015-04-01 00:17:25.000000', 'temperatura', 515.0000, 'ºC'),
	(129062, 110, '2015-04-01 00:17:26.000000', 'temperatura', 281.0000, 'ºC'),
	(129063, 110, '2015-04-01 00:17:27.000000', 'temperatura', 1062.0000, 'ºC'),
	(129064, 110, '2015-04-01 00:17:28.000000', 'temperatura', 867.0000, 'ºC'),
	(129065, 110, '2015-04-01 00:17:29.000000', 'temperatura', 1147.0000, 'ºC'),
	(129066, 110, '2015-04-01 00:17:30.000000', 'temperatura', 737.0000, 'ºC'),
	(129067, 110, '2015-04-01 00:17:31.000000', 'temperatura', 243.0000, 'ºC'),
	(129068, 110, '2015-04-01 00:17:32.000000', 'temperatura', 203.0000, 'ºC'),
	(129069, 110, '2015-04-01 00:17:33.000000', 'temperatura', 288.0000, 'ºC'),
	(129070, 110, '2015-04-01 00:17:34.000000', 'temperatura', 831.0000, 'ºC'),
	(129071, 110, '2015-04-01 00:17:35.000000', 'temperatura', 894.0000, 'ºC'),
	(129072, 110, '2015-04-01 00:17:36.000000', 'temperatura', 776.0000, 'ºC'),
	(129073, 110, '2015-04-01 00:17:37.000000', 'temperatura', 1196.0000, 'ºC'),
	(129074, 110, '2015-04-01 00:17:38.000000', 'temperatura', 56.0000, 'ºC'),
	(129075, 110, '2015-04-01 00:17:39.000000', 'temperatura', 290.0000, 'ºC'),
	(129076, 110, '2015-04-01 00:17:40.000000', 'temperatura', 85.0000, 'ºC'),
	(129077, 110, '2015-04-01 00:17:41.000000', 'temperatura', 754.0000, 'ºC'),
	(129078, 110, '2015-04-01 00:17:42.000000', 'temperatura', 1118.0000, 'ºC'),
	(129079, 110, '2015-04-01 00:17:43.000000', 'temperatura', 926.0000, 'ºC'),
	(129080, 110, '2015-04-01 00:17:44.000000', 'temperatura', 77.0000, 'ºC'),
	(129081, 110, '2015-04-01 00:17:45.000000', 'temperatura', 9.0000, 'ºC'),
	(129082, 110, '2015-04-01 00:17:46.000000', 'temperatura', 1015.0000, 'ºC'),
	(129083, 110, '2015-04-01 00:17:47.000000', 'temperatura', 248.0000, 'ºC'),
	(129084, 110, '2015-04-01 00:17:48.000000', 'temperatura', 596.0000, 'ºC'),
	(129085, 110, '2015-04-01 00:17:49.000000', 'temperatura', 1036.0000, 'ºC'),
	(129086, 110, '2015-04-01 00:17:50.000000', 'temperatura', 993.0000, 'ºC'),
	(129087, 110, '2015-04-01 00:17:51.000000', 'temperatura', 658.0000, 'ºC'),
	(129088, 110, '2015-04-01 00:17:52.000000', 'temperatura', 309.0000, 'ºC'),
	(129089, 110, '2015-04-01 00:17:53.000000', 'temperatura', 774.0000, 'ºC'),
	(129090, 110, '2015-04-01 00:17:54.000000', 'temperatura', 545.0000, 'ºC'),
	(129091, 110, '2015-04-01 00:17:55.000000', 'temperatura', 400.0000, 'ºC'),
	(129092, 110, '2015-04-01 00:17:56.000000', 'temperatura', 368.0000, 'ºC'),
	(129093, 110, '2015-04-01 00:17:57.000000', 'temperatura', 642.0000, 'ºC'),
	(129094, 110, '2015-04-01 00:17:58.000000', 'temperatura', 903.0000, 'ºC'),
	(129095, 110, '2015-04-01 00:17:59.000000', 'temperatura', 191.0000, 'ºC'),
	(129096, 110, '2015-04-01 00:18:00.000000', 'temperatura', 644.0000, 'ºC'),
	(129097, 110, '2015-04-01 00:18:01.000000', 'temperatura', 250.0000, 'ºC'),
	(129098, 110, '2015-04-01 00:18:02.000000', 'temperatura', 519.0000, 'ºC'),
	(129099, 110, '2015-04-01 00:18:03.000000', 'temperatura', 647.0000, 'ºC'),
	(129100, 110, '2015-04-01 00:18:04.000000', 'temperatura', 476.0000, 'ºC'),
	(129101, 110, '2015-04-01 00:18:05.000000', 'temperatura', 440.0000, 'ºC'),
	(129102, 110, '2015-04-01 00:18:06.000000', 'temperatura', 772.0000, 'ºC'),
	(129103, 110, '2015-04-01 00:18:07.000000', 'temperatura', 140.0000, 'ºC'),
	(129104, 110, '2015-04-01 00:18:08.000000', 'temperatura', 786.0000, 'ºC'),
	(129105, 110, '2015-04-01 00:18:09.000000', 'temperatura', 1108.0000, 'ºC'),
	(129106, 110, '2015-04-01 00:18:10.000000', 'temperatura', 783.0000, 'ºC'),
	(129107, 110, '2015-04-01 00:18:11.000000', 'temperatura', 593.0000, 'ºC'),
	(129108, 110, '2015-04-01 00:18:12.000000', 'temperatura', 614.0000, 'ºC'),
	(129109, 110, '2015-04-01 00:18:13.000000', 'temperatura', 94.0000, 'ºC'),
	(129110, 110, '2015-04-01 00:18:14.000000', 'temperatura', 1029.0000, 'ºC'),
	(129111, 110, '2015-04-01 00:18:15.000000', 'temperatura', 64.0000, 'ºC'),
	(129112, 110, '2015-04-01 00:18:16.000000', 'temperatura', 833.0000, 'ºC'),
	(129113, 110, '2015-04-01 00:18:17.000000', 'temperatura', 372.0000, 'ºC'),
	(129114, 110, '2015-04-01 00:18:18.000000', 'temperatura', 564.0000, 'ºC'),
	(129115, 110, '2015-04-01 00:18:19.000000', 'temperatura', 502.0000, 'ºC'),
	(129116, 110, '2015-04-01 00:18:20.000000', 'temperatura', 820.0000, 'ºC'),
	(129117, 110, '2015-04-01 00:18:21.000000', 'temperatura', 195.0000, 'ºC'),
	(129118, 110, '2015-04-01 00:18:22.000000', 'temperatura', 916.0000, 'ºC'),
	(129119, 110, '2015-04-01 00:18:23.000000', 'temperatura', 395.0000, 'ºC'),
	(129120, 110, '2015-04-01 00:18:24.000000', 'temperatura', 425.0000, 'ºC'),
	(129121, 110, '2015-04-01 00:18:25.000000', 'temperatura', 943.0000, 'ºC'),
	(129122, 110, '2015-04-01 00:18:26.000000', 'temperatura', 1039.0000, 'ºC'),
	(129123, 110, '2015-04-01 00:18:27.000000', 'temperatura', 1168.0000, 'ºC'),
	(129124, 110, '2015-04-01 00:18:28.000000', 'temperatura', 325.0000, 'ºC'),
	(129125, 110, '2015-04-01 00:18:29.000000', 'temperatura', 520.0000, 'ºC'),
	(129126, 110, '2015-04-01 00:18:30.000000', 'temperatura', 426.0000, 'ºC'),
	(129127, 110, '2015-04-01 00:18:31.000000', 'temperatura', 571.0000, 'ºC'),
	(129128, 110, '2015-04-01 00:18:32.000000', 'temperatura', 376.0000, 'ºC'),
	(129129, 110, '2015-04-01 00:18:33.000000', 'temperatura', 169.0000, 'ºC'),
	(129130, 110, '2015-04-01 00:18:34.000000', 'temperatura', 917.0000, 'ºC'),
	(129131, 110, '2015-04-01 00:18:35.000000', 'temperatura', 480.0000, 'ºC'),
	(129132, 110, '2015-04-01 00:18:36.000000', 'temperatura', 848.0000, 'ºC'),
	(129133, 110, '2015-04-01 00:18:37.000000', 'temperatura', 403.0000, 'ºC'),
	(129134, 110, '2015-04-01 00:18:38.000000', 'temperatura', 669.0000, 'ºC'),
	(129135, 110, '2015-04-01 00:18:39.000000', 'temperatura', 936.0000, 'ºC'),
	(129136, 110, '2015-04-01 00:18:40.000000', 'temperatura', 274.0000, 'ºC'),
	(129137, 110, '2015-04-01 00:18:41.000000', 'temperatura', 965.0000, 'ºC'),
	(129138, 110, '2015-04-01 00:18:42.000000', 'temperatura', 401.0000, 'ºC'),
	(129139, 110, '2015-04-01 00:18:43.000000', 'temperatura', 311.0000, 'ºC'),
	(129140, 110, '2015-04-01 00:18:44.000000', 'temperatura', 351.0000, 'ºC'),
	(129141, 110, '2015-04-01 00:18:45.000000', 'temperatura', 826.0000, 'ºC'),
	(129142, 110, '2015-04-01 00:18:46.000000', 'temperatura', 674.0000, 'ºC'),
	(129143, 110, '2015-04-01 00:18:47.000000', 'temperatura', 895.0000, 'ºC'),
	(129144, 110, '2015-04-01 00:18:48.000000', 'temperatura', 54.0000, 'ºC'),
	(129145, 110, '2015-04-01 00:18:49.000000', 'temperatura', 1183.0000, 'ºC'),
	(129146, 110, '2015-04-01 00:18:50.000000', 'temperatura', 954.0000, 'ºC'),
	(129147, 110, '2015-04-01 00:18:51.000000', 'temperatura', 24.0000, 'ºC'),
	(129148, 110, '2015-04-01 00:18:52.000000', 'temperatura', 857.0000, 'ºC'),
	(129149, 110, '2015-04-01 00:18:53.000000', 'temperatura', 612.0000, 'ºC'),
	(129150, 110, '2015-04-01 00:18:54.000000', 'temperatura', 489.0000, 'ºC'),
	(129151, 110, '2015-04-01 00:18:55.000000', 'temperatura', 610.0000, 'ºC'),
	(129152, 110, '2015-04-01 00:18:56.000000', 'temperatura', 383.0000, 'ºC'),
	(129153, 110, '2015-04-01 00:18:57.000000', 'temperatura', 84.0000, 'ºC'),
	(129154, 110, '2015-04-01 00:18:58.000000', 'temperatura', 474.0000, 'ºC'),
	(129155, 110, '2015-04-01 00:18:59.000000', 'temperatura', 919.0000, 'ºC'),
	(129156, 110, '2015-04-01 00:19:00.000000', 'temperatura', 773.0000, 'ºC'),
	(129157, 110, '2015-04-01 00:19:01.000000', 'temperatura', 1109.0000, 'ºC'),
	(129158, 110, '2015-04-01 00:19:02.000000', 'temperatura', 825.0000, 'ºC'),
	(129159, 110, '2015-04-01 00:19:03.000000', 'temperatura', 800.0000, 'ºC'),
	(129160, 110, '2015-04-01 00:19:04.000000', 'temperatura', 325.0000, 'ºC'),
	(129161, 110, '2015-04-01 00:19:05.000000', 'temperatura', 425.0000, 'ºC'),
	(129162, 110, '2015-04-01 00:19:06.000000', 'temperatura', 1151.0000, 'ºC'),
	(129163, 110, '2015-04-01 00:19:07.000000', 'temperatura', 880.0000, 'ºC'),
	(129164, 110, '2015-04-01 00:19:08.000000', 'temperatura', 948.0000, 'ºC'),
	(129165, 110, '2015-04-01 00:19:09.000000', 'temperatura', 902.0000, 'ºC'),
	(129166, 110, '2015-04-01 00:19:10.000000', 'temperatura', 464.0000, 'ºC'),
	(129167, 110, '2015-04-01 00:19:11.000000', 'temperatura', 817.0000, 'ºC'),
	(129168, 110, '2015-04-01 00:19:12.000000', 'temperatura', 294.0000, 'ºC'),
	(129169, 110, '2015-04-01 00:19:13.000000', 'temperatura', 220.0000, 'ºC'),
	(129170, 110, '2015-04-01 00:19:14.000000', 'temperatura', 216.0000, 'ºC'),
	(129171, 110, '2015-04-01 00:19:15.000000', 'temperatura', 422.0000, 'ºC'),
	(129172, 110, '2015-04-01 00:19:16.000000', 'temperatura', 260.0000, 'ºC'),
	(129173, 110, '2015-04-01 00:19:17.000000', 'temperatura', 37.0000, 'ºC'),
	(129174, 110, '2015-04-01 00:19:18.000000', 'temperatura', 605.0000, 'ºC'),
	(129175, 110, '2015-04-01 00:19:19.000000', 'temperatura', 514.0000, 'ºC'),
	(129176, 110, '2015-04-01 00:19:20.000000', 'temperatura', 756.0000, 'ºC'),
	(129177, 110, '2015-04-01 00:19:21.000000', 'temperatura', 1038.0000, 'ºC'),
	(129178, 110, '2015-04-01 00:19:22.000000', 'temperatura', 524.0000, 'ºC'),
	(129179, 110, '2015-04-01 00:19:23.000000', 'temperatura', 705.0000, 'ºC'),
	(129180, 110, '2015-04-01 00:19:24.000000', 'temperatura', 752.0000, 'ºC'),
	(129181, 110, '2015-04-01 00:19:25.000000', 'temperatura', 447.0000, 'ºC'),
	(129182, 110, '2015-04-01 00:19:26.000000', 'temperatura', 1179.0000, 'ºC'),
	(129183, 110, '2015-04-01 00:19:27.000000', 'temperatura', 954.0000, 'ºC'),
	(129184, 110, '2015-04-01 00:19:28.000000', 'temperatura', 35.0000, 'ºC'),
	(129185, 110, '2015-04-01 00:19:29.000000', 'temperatura', 915.0000, 'ºC'),
	(129186, 110, '2015-04-01 00:19:30.000000', 'temperatura', 868.0000, 'ºC'),
	(129187, 110, '2015-04-01 00:19:31.000000', 'temperatura', 398.0000, 'ºC'),
	(129188, 110, '2015-04-01 00:19:32.000000', 'temperatura', 586.0000, 'ºC'),
	(129189, 110, '2015-04-01 00:19:33.000000', 'temperatura', 534.0000, 'ºC'),
	(129190, 110, '2015-04-01 00:19:34.000000', 'temperatura', 913.0000, 'ºC'),
	(129191, 110, '2015-04-01 00:19:35.000000', 'temperatura', 564.0000, 'ºC'),
	(129192, 110, '2015-04-01 00:19:36.000000', 'temperatura', 84.0000, 'ºC'),
	(129193, 110, '2015-04-01 00:19:37.000000', 'temperatura', 1125.0000, 'ºC'),
	(129194, 110, '2015-04-01 00:19:38.000000', 'temperatura', 575.0000, 'ºC'),
	(129195, 110, '2015-04-01 00:19:39.000000', 'temperatura', 701.0000, 'ºC'),
	(129196, 110, '2015-04-01 00:19:40.000000', 'temperatura', 579.0000, 'ºC'),
	(129197, 110, '2015-04-01 00:19:41.000000', 'temperatura', 792.0000, 'ºC'),
	(129198, 110, '2015-04-01 00:19:42.000000', 'temperatura', 1023.0000, 'ºC'),
	(129199, 110, '2015-04-01 00:19:43.000000', 'temperatura', 341.0000, 'ºC'),
	(129200, 110, '2015-04-01 00:19:44.000000', 'temperatura', 1038.0000, 'ºC'),
	(129201, 110, '2015-04-01 00:19:45.000000', 'temperatura', 565.0000, 'ºC'),
	(129202, 110, '2015-04-01 00:19:46.000000', 'temperatura', 913.0000, 'ºC'),
	(129203, 110, '2015-04-01 00:19:47.000000', 'temperatura', 471.0000, 'ºC'),
	(129204, 110, '2015-04-01 00:19:48.000000', 'temperatura', 816.0000, 'ºC'),
	(129205, 110, '2015-04-01 00:19:49.000000', 'temperatura', 268.0000, 'ºC'),
	(129206, 110, '2015-04-01 00:19:50.000000', 'temperatura', 90.0000, 'ºC'),
	(129207, 110, '2015-04-01 00:19:51.000000', 'temperatura', 849.0000, 'ºC'),
	(129208, 110, '2015-04-01 00:19:52.000000', 'temperatura', 375.0000, 'ºC'),
	(129209, 110, '2015-04-01 00:19:53.000000', 'temperatura', 526.0000, 'ºC'),
	(129210, 110, '2015-04-01 00:19:54.000000', 'temperatura', 309.0000, 'ºC'),
	(129211, 110, '2015-04-01 00:19:55.000000', 'temperatura', 1164.0000, 'ºC'),
	(129212, 110, '2015-04-01 00:19:56.000000', 'temperatura', 96.0000, 'ºC'),
	(129213, 110, '2015-04-01 00:19:57.000000', 'temperatura', 588.0000, 'ºC'),
	(129214, 110, '2015-04-01 00:19:58.000000', 'temperatura', 252.0000, 'ºC'),
	(129215, 110, '2015-04-01 00:19:59.000000', 'temperatura', 696.0000, 'ºC'),
	(129216, 110, '2015-04-01 00:20:00.000000', 'temperatura', 326.0000, 'ºC'),
	(129217, 110, '2015-04-01 00:20:01.000000', 'temperatura', 742.0000, 'ºC'),
	(129218, 110, '2015-04-01 00:20:02.000000', 'temperatura', 331.0000, 'ºC'),
	(129219, 110, '2015-04-01 00:20:03.000000', 'temperatura', 631.0000, 'ºC'),
	(129220, 110, '2015-04-01 00:20:04.000000', 'temperatura', 961.0000, 'ºC'),
	(129221, 110, '2015-04-01 00:20:05.000000', 'temperatura', 514.0000, 'ºC'),
	(129222, 110, '2015-04-01 00:20:06.000000', 'temperatura', 888.0000, 'ºC'),
	(129223, 110, '2015-04-01 00:20:07.000000', 'temperatura', 497.0000, 'ºC'),
	(129224, 110, '2015-04-01 00:20:08.000000', 'temperatura', 1022.0000, 'ºC'),
	(129225, 110, '2015-04-01 00:20:09.000000', 'temperatura', 20.0000, 'ºC'),
	(129226, 110, '2015-04-01 00:20:10.000000', 'temperatura', 636.0000, 'ºC'),
	(129227, 110, '2015-04-01 00:20:11.000000', 'temperatura', 719.0000, 'ºC'),
	(129228, 110, '2015-04-01 00:20:12.000000', 'temperatura', 486.0000, 'ºC'),
	(129229, 110, '2015-04-01 00:20:13.000000', 'temperatura', 273.0000, 'ºC'),
	(129230, 110, '2015-04-01 00:20:14.000000', 'temperatura', 1109.0000, 'ºC'),
	(129231, 110, '2015-04-01 00:20:15.000000', 'temperatura', 1124.0000, 'ºC'),
	(129232, 110, '2015-04-01 00:20:16.000000', 'temperatura', 1097.0000, 'ºC'),
	(129233, 110, '2015-04-01 00:20:17.000000', 'temperatura', 911.0000, 'ºC'),
	(129234, 110, '2015-04-01 00:20:18.000000', 'temperatura', 64.0000, 'ºC'),
	(129235, 110, '2015-04-01 00:20:19.000000', 'temperatura', 1188.0000, 'ºC'),
	(129236, 110, '2015-04-01 00:20:20.000000', 'temperatura', 949.0000, 'ºC'),
	(129237, 110, '2015-04-01 00:20:21.000000', 'temperatura', 1180.0000, 'ºC'),
	(129238, 110, '2015-04-01 00:20:22.000000', 'temperatura', 654.0000, 'ºC'),
	(129239, 110, '2015-04-01 00:20:23.000000', 'temperatura', 931.0000, 'ºC'),
	(129240, 110, '2015-04-01 00:20:24.000000', 'temperatura', 294.0000, 'ºC'),
	(129241, 110, '2015-04-01 00:20:25.000000', 'temperatura', 1076.0000, 'ºC'),
	(129242, 110, '2015-04-01 00:20:26.000000', 'temperatura', 900.0000, 'ºC'),
	(129243, 110, '2015-04-01 00:20:27.000000', 'temperatura', 70.0000, 'ºC'),
	(129244, 110, '2015-04-01 00:20:28.000000', 'temperatura', 52.0000, 'ºC'),
	(129245, 110, '2015-04-01 00:20:29.000000', 'temperatura', 50.0000, 'ºC'),
	(129246, 110, '2015-04-01 00:20:30.000000', 'temperatura', 94.0000, 'ºC'),
	(129247, 110, '2015-04-01 00:20:31.000000', 'temperatura', 320.0000, 'ºC'),
	(129248, 110, '2015-04-01 00:20:32.000000', 'temperatura', 120.0000, 'ºC'),
	(129249, 110, '2015-04-01 00:20:33.000000', 'temperatura', 840.0000, 'ºC'),
	(129250, 110, '2015-04-01 00:20:34.000000', 'temperatura', 241.0000, 'ºC'),
	(129251, 110, '2015-04-01 00:20:35.000000', 'temperatura', 1083.0000, 'ºC'),
	(129252, 110, '2015-04-01 00:20:36.000000', 'temperatura', 1095.0000, 'ºC'),
	(129253, 110, '2015-04-01 00:20:37.000000', 'temperatura', 1027.0000, 'ºC'),
	(129254, 110, '2015-04-01 00:20:38.000000', 'temperatura', 648.0000, 'ºC'),
	(129255, 110, '2015-04-01 00:20:39.000000', 'temperatura', 160.0000, 'ºC'),
	(129256, 110, '2015-04-01 00:20:40.000000', 'temperatura', 55.0000, 'ºC'),
	(129257, 110, '2015-04-01 00:20:41.000000', 'temperatura', 997.0000, 'ºC'),
	(129258, 110, '2015-04-01 00:20:42.000000', 'temperatura', 20.0000, 'ºC'),
	(129259, 110, '2015-04-01 00:20:43.000000', 'temperatura', 709.0000, 'ºC'),
	(129260, 110, '2015-04-01 00:20:44.000000', 'temperatura', 1084.0000, 'ºC'),
	(129261, 110, '2015-04-01 00:20:45.000000', 'temperatura', 896.0000, 'ºC'),
	(129262, 110, '2015-04-01 00:20:46.000000', 'temperatura', 29.0000, 'ºC'),
	(129263, 110, '2015-04-01 00:20:47.000000', 'temperatura', 1059.0000, 'ºC'),
	(129264, 110, '2015-04-01 00:20:48.000000', 'temperatura', 405.0000, 'ºC'),
	(129265, 110, '2015-04-01 00:20:49.000000', 'temperatura', 50.0000, 'ºC'),
	(129266, 110, '2015-04-01 00:20:50.000000', 'temperatura', 237.0000, 'ºC'),
	(129267, 110, '2015-04-01 00:20:51.000000', 'temperatura', 1035.0000, 'ºC'),
	(129268, 110, '2015-04-01 00:20:52.000000', 'temperatura', 864.0000, 'ºC'),
	(129269, 110, '2015-04-01 00:20:53.000000', 'temperatura', 15.0000, 'ºC'),
	(129270, 110, '2015-04-01 00:20:54.000000', 'temperatura', 1083.0000, 'ºC'),
	(129271, 110, '2015-04-01 00:20:55.000000', 'temperatura', 572.0000, 'ºC'),
	(129272, 110, '2015-04-01 00:20:56.000000', 'temperatura', 810.0000, 'ºC'),
	(129273, 110, '2015-04-01 00:20:57.000000', 'temperatura', 1136.0000, 'ºC'),
	(129274, 110, '2015-04-01 00:20:58.000000', 'temperatura', 848.0000, 'ºC'),
	(129275, 110, '2015-04-01 00:20:59.000000', 'temperatura', 833.0000, 'ºC'),
	(129276, 110, '2015-04-01 00:21:00.000000', 'temperatura', 424.0000, 'ºC'),
	(129277, 110, '2015-04-01 00:21:01.000000', 'temperatura', 819.0000, 'ºC'),
	(129278, 110, '2015-04-01 00:21:02.000000', 'temperatura', 425.0000, 'ºC'),
	(129279, 110, '2015-04-01 00:21:03.000000', 'temperatura', 866.0000, 'ºC'),
	(129280, 110, '2015-04-01 00:21:04.000000', 'temperatura', 658.0000, 'ºC'),
	(129281, 110, '2015-04-01 00:21:05.000000', 'temperatura', 693.0000, 'ºC'),
	(129282, 110, '2015-04-01 00:21:06.000000', 'temperatura', 292.0000, 'ºC'),
	(129283, 110, '2015-04-01 00:21:07.000000', 'temperatura', 579.0000, 'ºC'),
	(129284, 110, '2015-04-01 00:21:08.000000', 'temperatura', 821.0000, 'ºC'),
	(129285, 110, '2015-04-01 00:21:09.000000', 'temperatura', 1166.0000, 'ºC'),
	(129286, 110, '2015-04-01 00:21:10.000000', 'temperatura', 971.0000, 'ºC'),
	(129287, 110, '2015-04-01 00:21:11.000000', 'temperatura', 156.0000, 'ºC'),
	(129288, 110, '2015-04-01 00:21:12.000000', 'temperatura', 269.0000, 'ºC'),
	(129289, 110, '2015-04-01 00:21:13.000000', 'temperatura', 879.0000, 'ºC'),
	(129290, 110, '2015-04-01 00:21:14.000000', 'temperatura', 1185.0000, 'ºC'),
	(129291, 110, '2015-04-01 00:21:15.000000', 'temperatura', 890.0000, 'ºC'),
	(129292, 110, '2015-04-01 00:21:16.000000', 'temperatura', 895.0000, 'ºC'),
	(129293, 110, '2015-04-01 00:21:17.000000', 'temperatura', 606.0000, 'ºC'),
	(129294, 110, '2015-04-01 00:21:18.000000', 'temperatura', 346.0000, 'ºC'),
	(129295, 110, '2015-04-01 00:21:19.000000', 'temperatura', 1110.0000, 'ºC'),
	(129296, 110, '2015-04-01 00:21:20.000000', 'temperatura', 915.0000, 'ºC'),
	(129297, 110, '2015-04-01 00:21:21.000000', 'temperatura', 45.0000, 'ºC'),
	(129298, 110, '2015-04-01 00:21:22.000000', 'temperatura', 1080.0000, 'ºC'),
	(129299, 110, '2015-04-01 00:21:23.000000', 'temperatura', 464.0000, 'ºC'),
	(129300, 110, '2015-04-01 00:21:24.000000', 'temperatura', 280.0000, 'ºC'),
	(129301, 110, '2015-04-01 00:21:25.000000', 'temperatura', 11.0000, 'ºC'),
	(129302, 110, '2015-04-01 00:21:26.000000', 'temperatura', 415.0000, 'ºC'),
	(129303, 110, '2015-04-01 00:21:27.000000', 'temperatura', 843.0000, 'ºC'),
	(129304, 110, '2015-04-01 00:21:28.000000', 'temperatura', 569.0000, 'ºC'),
	(129305, 110, '2015-04-01 00:21:29.000000', 'temperatura', 318.0000, 'ºC'),
	(129306, 110, '2015-04-01 00:21:30.000000', 'temperatura', 1083.0000, 'ºC'),
	(129307, 110, '2015-04-01 00:21:31.000000', 'temperatura', 861.0000, 'ºC'),
	(129308, 110, '2015-04-01 00:21:32.000000', 'temperatura', 1055.0000, 'ºC'),
	(129309, 110, '2015-04-01 00:21:33.000000', 'temperatura', 292.0000, 'ºC'),
	(129310, 110, '2015-04-01 00:21:34.000000', 'temperatura', 698.0000, 'ºC'),
	(129311, 110, '2015-04-01 00:21:35.000000', 'temperatura', 216.0000, 'ºC'),
	(129312, 110, '2015-04-01 00:21:36.000000', 'temperatura', 183.0000, 'ºC'),
	(129313, 110, '2015-04-01 00:21:37.000000', 'temperatura', 269.0000, 'ºC'),
	(129314, 110, '2015-04-01 00:21:38.000000', 'temperatura', 797.0000, 'ºC'),
	(129315, 110, '2015-04-01 00:21:39.000000', 'temperatura', 778.0000, 'ºC'),
	(129316, 110, '2015-04-01 00:21:40.000000', 'temperatura', 301.0000, 'ºC'),
	(129317, 110, '2015-04-01 00:21:41.000000', 'temperatura', 370.0000, 'ºC'),
	(129318, 110, '2015-04-01 00:21:42.000000', 'temperatura', 948.0000, 'ºC'),
	(129319, 110, '2015-04-01 00:21:43.000000', 'temperatura', 31.0000, 'ºC'),
	(129320, 110, '2015-04-01 00:21:44.000000', 'temperatura', 910.0000, 'ºC'),
	(129321, 110, '2015-04-01 00:21:45.000000', 'temperatura', 859.0000, 'ºC'),
	(129322, 110, '2015-04-01 00:21:46.000000', 'temperatura', 366.0000, 'ºC'),
	(129323, 110, '2015-04-01 00:21:47.000000', 'temperatura', 455.0000, 'ºC'),
	(129324, 110, '2015-04-01 00:21:48.000000', 'temperatura', 1174.0000, 'ºC'),
	(129325, 110, '2015-04-01 00:21:49.000000', 'temperatura', 906.0000, 'ºC'),
	(129326, 110, '2015-04-01 00:21:50.000000', 'temperatura', 1010.0000, 'ºC'),
	(129327, 110, '2015-04-01 00:21:51.000000', 'temperatura', 1134.0000, 'ºC'),
	(129328, 110, '2015-04-01 00:21:52.000000', 'temperatura', 239.0000, 'ºC'),
	(129329, 110, '2015-04-01 00:21:53.000000', 'temperatura', 192.0000, 'ºC'),
	(129330, 110, '2015-04-01 00:21:54.000000', 'temperatura', 244.0000, 'ºC'),
	(129331, 110, '2015-04-01 00:21:55.000000', 'temperatura', 645.0000, 'ºC'),
	(129332, 110, '2015-04-01 00:21:56.000000', 'temperatura', 92.0000, 'ºC'),
	(129333, 110, '2015-04-01 00:21:57.000000', 'temperatura', 928.0000, 'ºC'),
	(129334, 110, '2015-04-01 00:21:58.000000', 'temperatura', 762.0000, 'ºC'),
	(129335, 110, '2015-04-01 00:21:59.000000', 'temperatura', 1028.0000, 'ºC'),
	(129336, 110, '2015-04-01 00:22:00.000000', 'temperatura', 454.0000, 'ºC'),
	(129337, 110, '2015-04-01 00:22:01.000000', 'temperatura', 387.0000, 'ºC'),
	(129338, 110, '2015-04-01 00:22:02.000000', 'temperatura', 575.0000, 'ºC'),
	(129339, 110, '2015-04-01 00:22:03.000000', 'temperatura', 513.0000, 'ºC'),
	(129340, 110, '2015-04-01 00:22:04.000000', 'temperatura', 839.0000, 'ºC'),
	(129341, 110, '2015-04-01 00:22:05.000000', 'temperatura', 257.0000, 'ºC'),
	(129342, 110, '2015-04-01 00:22:06.000000', 'temperatura', 1167.0000, 'ºC'),
	(129343, 110, '2015-04-01 00:22:07.000000', 'temperatura', 265.0000, 'ºC'),
	(129344, 110, '2015-04-01 00:22:08.000000', 'temperatura', 227.0000, 'ºC'),
	(129345, 110, '2015-04-01 00:22:09.000000', 'temperatura', 339.0000, 'ºC'),
	(129346, 110, '2015-04-01 00:22:10.000000', 'temperatura', 1014.0000, 'ºC'),
	(129347, 110, '2015-04-01 00:22:11.000000', 'temperatura', 454.0000, 'ºC'),
	(129348, 110, '2015-04-01 00:22:12.000000', 'temperatura', 429.0000, 'ºC'),
	(129349, 110, '2015-04-01 00:22:13.000000', 'temperatura', 783.0000, 'ºC'),
	(129350, 110, '2015-04-01 00:22:14.000000', 'temperatura', 229.0000, 'ºC'),
	(129351, 110, '2015-04-01 00:22:15.000000', 'temperatura', 1196.0000, 'ºC'),
	(129352, 110, '2015-04-01 00:22:16.000000', 'temperatura', 494.0000, 'ºC'),
	(129353, 110, '2015-04-01 00:22:17.000000', 'temperatura', 83.0000, 'ºC'),
	(129354, 110, '2015-04-01 00:22:18.000000', 'temperatura', 134.0000, 'ºC'),
	(129355, 110, '2015-04-01 00:22:19.000000', 'temperatura', 420.0000, 'ºC'),
	(129356, 110, '2015-04-01 00:22:20.000000', 'temperatura', 500.0000, 'ºC'),
	(129357, 110, '2015-04-01 00:22:21.000000', 'temperatura', 38.0000, 'ºC'),
	(129358, 110, '2015-04-01 00:22:22.000000', 'temperatura', 1092.0000, 'ºC'),
	(129359, 110, '2015-04-01 00:22:23.000000', 'temperatura', 548.0000, 'ºC'),
	(129360, 110, '2015-04-01 00:22:24.000000', 'temperatura', 662.0000, 'ºC'),
	(129361, 110, '2015-04-01 00:22:25.000000', 'temperatura', 469.0000, 'ºC'),
	(129362, 110, '2015-04-01 00:22:26.000000', 'temperatura', 357.0000, 'ºC'),
	(129363, 110, '2015-04-01 00:22:27.000000', 'temperatura', 381.0000, 'ºC'),
	(129364, 110, '2015-04-01 00:22:28.000000', 'temperatura', 832.0000, 'ºC'),
	(129365, 110, '2015-04-01 00:22:29.000000', 'temperatura', 619.0000, 'ºC'),
	(129366, 110, '2015-04-01 00:22:30.000000', 'temperatura', 599.0000, 'ºC'),
	(129367, 110, '2015-04-01 00:22:31.000000', 'temperatura', 1137.0000, 'ºC'),
	(129368, 110, '2015-04-01 00:22:32.000000', 'temperatura', 290.0000, 'ºC'),
	(129369, 110, '2015-04-01 00:22:33.000000', 'temperatura', 438.0000, 'ºC'),
	(129370, 110, '2015-04-01 00:22:34.000000', 'temperatura', 120.0000, 'ºC'),
	(129371, 110, '2015-04-01 00:22:35.000000', 'temperatura', 488.0000, 'ºC'),
	(129372, 110, '2015-04-01 00:22:36.000000', 'temperatura', 880.0000, 'ºC'),
	(129373, 110, '2015-04-01 00:22:37.000000', 'temperatura', 537.0000, 'ºC'),
	(129374, 110, '2015-04-01 00:22:38.000000', 'temperatura', 47.0000, 'ºC'),
	(129375, 110, '2015-04-01 00:22:39.000000', 'temperatura', 1024.0000, 'ºC'),
	(129376, 110, '2015-04-01 00:22:40.000000', 'temperatura', 180.0000, 'ºC'),
	(129377, 110, '2015-04-01 00:22:41.000000', 'temperatura', 227.0000, 'ºC'),
	(129378, 110, '2015-04-01 00:22:42.000000', 'temperatura', 596.0000, 'ºC'),
	(129379, 110, '2015-04-01 00:22:43.000000', 'temperatura', 1099.0000, 'ºC'),
	(129380, 110, '2015-04-01 00:22:44.000000', 'temperatura', 110.0000, 'ºC'),
	(129381, 110, '2015-04-01 00:22:45.000000', 'temperatura', 851.0000, 'ºC'),
	(129382, 110, '2015-04-01 00:22:46.000000', 'temperatura', 325.0000, 'ºC'),
	(129383, 110, '2015-04-01 00:22:47.000000', 'temperatura', 273.0000, 'ºC'),
	(129384, 110, '2015-04-01 00:22:48.000000', 'temperatura', 390.0000, 'ºC'),
	(129385, 110, '2015-04-01 00:22:49.000000', 'temperatura', 1130.0000, 'ºC'),
	(129386, 110, '2015-04-01 00:22:50.000000', 'temperatura', 884.0000, 'ºC'),
	(129387, 110, '2015-04-01 00:22:51.000000', 'temperatura', 1027.0000, 'ºC'),
	(129388, 110, '2015-04-01 00:22:52.000000', 'temperatura', 86.0000, 'ºC'),
	(129389, 110, '2015-04-01 00:22:53.000000', 'temperatura', 950.0000, 'ºC'),
	(129390, 110, '2015-04-01 00:22:54.000000', 'temperatura', 892.0000, 'ºC'),
	(129391, 110, '2015-04-01 00:22:55.000000', 'temperatura', 412.0000, 'ºC'),
	(129392, 110, '2015-04-01 00:22:56.000000', 'temperatura', 583.0000, 'ºC'),
	(129393, 110, '2015-04-01 00:22:57.000000', 'temperatura', 482.0000, 'ºC'),
	(129394, 110, '2015-04-01 00:22:58.000000', 'temperatura', 658.0000, 'ºC'),
	(129395, 110, '2015-04-01 00:22:59.000000', 'temperatura', 648.0000, 'ºC'),
	(129396, 110, '2015-04-01 00:23:00.000000', 'temperatura', 64.0000, 'ºC'),
	(129397, 110, '2015-04-01 00:23:01.000000', 'temperatura', 779.0000, 'ºC'),
	(129398, 110, '2015-04-01 00:23:02.000000', 'temperatura', 102.0000, 'ºC'),
	(129399, 110, '2015-04-01 00:23:03.000000', 'temperatura', 573.0000, 'ºC'),
	(129400, 110, '2015-04-01 00:23:04.000000', 'temperatura', 160.0000, 'ºC'),
	(129401, 110, '2015-04-01 00:23:05.000000', 'temperatura', 282.0000, 'ºC'),
	(129402, 110, '2015-04-01 00:23:06.000000', 'temperatura', 930.0000, 'ºC'),
	(129403, 110, '2015-04-01 00:23:07.000000', 'temperatura', 203.0000, 'ºC'),
	(129404, 110, '2015-04-01 00:23:08.000000', 'temperatura', 627.0000, 'ºC'),
	(129405, 110, '2015-04-01 00:23:09.000000', 'temperatura', 126.0000, 'ºC'),
	(129406, 110, '2015-04-01 00:23:10.000000', 'temperatura', 1148.0000, 'ºC'),
	(129407, 110, '2015-04-01 00:23:11.000000', 'temperatura', 562.0000, 'ºC'),
	(129408, 110, '2015-04-01 00:23:12.000000', 'temperatura', 567.0000, 'ºC'),
	(129409, 110, '2015-04-01 00:23:13.000000', 'temperatura', 1151.0000, 'ºC'),
	(129410, 110, '2015-04-01 00:23:14.000000', 'temperatura', 453.0000, 'ºC'),
	(129411, 110, '2015-04-01 00:23:15.000000', 'temperatura', 13.0000, 'ºC'),
	(129412, 110, '2015-04-01 00:23:16.000000', 'temperatura', 1107.0000, 'ºC'),
	(129413, 110, '2015-04-01 00:23:17.000000', 'temperatura', 698.0000, 'ºC'),
	(129414, 110, '2015-04-01 00:23:18.000000', 'temperatura', 169.0000, 'ºC'),
	(129415, 110, '2015-04-01 00:23:19.000000', 'temperatura', 1149.0000, 'ºC'),
	(129416, 110, '2015-04-01 00:23:20.000000', 'temperatura', 440.0000, 'ºC'),
	(129417, 110, '2015-04-01 00:23:21.000000', 'temperatura', 1154.0000, 'ºC'),
	(129418, 110, '2015-04-01 00:23:22.000000', 'temperatura', 852.0000, 'ºC'),
	(129419, 110, '2015-04-01 00:23:23.000000', 'temperatura', 797.0000, 'ºC'),
	(129420, 110, '2015-04-01 00:23:24.000000', 'temperatura', 229.0000, 'ºC'),
	(129421, 110, '2015-04-01 00:23:25.000000', 'temperatura', 1156.0000, 'ºC'),
	(129422, 110, '2015-04-01 00:23:26.000000', 'temperatura', 292.0000, 'ºC'),
	(129423, 110, '2015-04-01 00:23:27.000000', 'temperatura', 395.0000, 'ºC'),
	(129424, 110, '2015-04-01 00:23:28.000000', 'temperatura', 1097.0000, 'ºC'),
	(129425, 110, '2015-04-01 00:23:29.000000', 'temperatura', 699.0000, 'ºC'),
	(129426, 110, '2015-04-01 00:23:30.000000', 'temperatura', 207.0000, 'ºC'),
	(129427, 110, '2015-04-01 00:23:31.000000', 'temperatura', 138.0000, 'ºC'),
	(129428, 110, '2015-04-01 00:23:32.000000', 'temperatura', 67.0000, 'ºC'),
	(129429, 110, '2015-04-01 00:23:33.000000', 'temperatura', 1125.0000, 'ºC'),
	(129430, 110, '2015-04-01 00:23:34.000000', 'temperatura', 624.0000, 'ºC'),
	(129431, 110, '2015-04-01 00:23:35.000000', 'temperatura', 946.0000, 'ºC'),
	(129432, 110, '2015-04-01 00:23:36.000000', 'temperatura', 457.0000, 'ºC'),
	(129433, 110, '2015-04-01 00:23:37.000000', 'temperatura', 650.0000, 'ºC'),
	(129434, 110, '2015-04-01 00:23:38.000000', 'temperatura', 678.0000, 'ºC'),
	(129435, 110, '2015-04-01 00:23:39.000000', 'temperatura', 239.0000, 'ºC'),
	(129436, 110, '2015-04-01 00:23:40.000000', 'temperatura', 361.0000, 'ºC'),
	(129437, 110, '2015-04-01 00:23:41.000000', 'temperatura', 1088.0000, 'ºC'),
	(129438, 110, '2015-04-01 00:23:42.000000', 'temperatura', 757.0000, 'ºC'),
	(129439, 110, '2015-04-01 00:23:43.000000', 'temperatura', 525.0000, 'ºC'),
	(129440, 110, '2015-04-01 00:23:44.000000', 'temperatura', 351.0000, 'ºC'),
	(129441, 110, '2015-04-01 00:23:45.000000', 'temperatura', 181.0000, 'ºC'),
	(129442, 110, '2015-04-01 00:23:46.000000', 'temperatura', 1053.0000, 'ºC'),
	(129443, 110, '2015-04-01 00:23:47.000000', 'temperatura', 1123.0000, 'ºC'),
	(129444, 110, '2015-04-01 00:23:48.000000', 'temperatura', 56.0000, 'ºC'),
	(129445, 110, '2015-04-01 00:23:49.000000', 'temperatura', 513.0000, 'ºC'),
	(129446, 110, '2015-04-01 00:23:50.000000', 'temperatura', 1195.0000, 'ºC'),
	(129447, 110, '2015-04-01 00:23:51.000000', 'temperatura', 836.0000, 'ºC'),
	(129448, 110, '2015-04-01 00:23:52.000000', 'temperatura', 598.0000, 'ºC'),
	(129449, 110, '2015-04-01 00:23:53.000000', 'temperatura', 481.0000, 'ºC'),
	(129450, 110, '2015-04-01 00:23:54.000000', 'temperatura', 611.0000, 'ºC'),
	(129451, 110, '2015-04-01 00:23:55.000000', 'temperatura', 414.0000, 'ºC'),
	(129452, 110, '2015-04-01 00:23:56.000000', 'temperatura', 238.0000, 'ºC'),
	(129453, 110, '2015-04-01 00:23:57.000000', 'temperatura', 1149.0000, 'ºC'),
	(129454, 110, '2015-04-01 00:23:58.000000', 'temperatura', 232.0000, 'ºC'),
	(129455, 110, '2015-04-01 00:23:59.000000', 'temperatura', 114.0000, 'ºC'),
	(129456, 110, '2015-04-01 00:24:00.000000', 'temperatura', 1073.0000, 'ºC'),
	(129457, 110, '2015-04-01 00:24:01.000000', 'temperatura', 224.0000, 'ºC'),
	(129458, 110, '2015-04-01 00:24:02.000000', 'temperatura', 300.0000, 'ºC'),
	(129459, 110, '2015-04-01 00:24:03.000000', 'temperatura', 829.0000, 'ºC'),
	(129460, 110, '2015-04-01 00:24:04.000000', 'temperatura', 845.0000, 'ºC'),
	(129461, 110, '2015-04-01 00:24:05.000000', 'temperatura', 538.0000, 'ºC'),
	(129462, 110, '2015-04-01 00:24:06.000000', 'temperatura', 157.0000, 'ºC'),
	(129463, 110, '2015-04-01 00:24:07.000000', 'temperatura', 370.0000, 'ºC'),
	(129464, 110, '2015-04-01 00:24:08.000000', 'temperatura', 182.0000, 'ºC'),
	(129465, 110, '2015-04-01 00:24:09.000000', 'temperatura', 998.0000, 'ºC'),
	(129466, 110, '2015-04-01 00:24:10.000000', 'temperatura', 847.0000, 'ºC'),
	(129467, 110, '2015-04-01 00:24:11.000000', 'temperatura', 41.0000, 'ºC'),
	(129468, 110, '2015-04-01 00:24:12.000000', 'temperatura', 65.0000, 'ºC'),
	(129469, 110, '2015-04-01 00:24:13.000000', 'temperatura', 203.0000, 'ºC'),
	(129470, 110, '2015-04-01 00:24:14.000000', 'temperatura', 818.0000, 'ºC'),
	(129471, 110, '2015-04-01 00:24:15.000000', 'temperatura', 1082.0000, 'ºC'),
	(129472, 110, '2015-04-01 00:24:16.000000', 'temperatura', 556.0000, 'ºC'),
	(129473, 110, '2015-04-01 00:24:17.000000', 'temperatura', 737.0000, 'ºC'),
	(129474, 110, '2015-04-01 00:24:18.000000', 'temperatura', 816.0000, 'ºC'),
	(129475, 110, '2015-04-01 00:24:19.000000', 'temperatura', 669.0000, 'ºC'),
	(129476, 110, '2015-04-01 00:24:20.000000', 'temperatura', 899.0000, 'ºC'),
	(129477, 110, '2015-04-01 00:24:21.000000', 'temperatura', 89.0000, 'ºC'),
	(129478, 110, '2015-04-01 00:24:22.000000', 'temperatura', 149.0000, 'ºC'),
	(129479, 110, '2015-04-01 00:24:23.000000', 'temperatura', 477.0000, 'ºC'),
	(129480, 110, '2015-04-01 00:24:24.000000', 'temperatura', 738.0000, 'ºC'),
	(129481, 110, '2015-04-01 00:24:25.000000', 'temperatura', 1062.0000, 'ºC'),
	(129482, 110, '2015-04-01 00:24:26.000000', 'temperatura', 694.0000, 'ºC'),
	(129483, 110, '2015-04-01 00:24:27.000000', 'temperatura', 284.0000, 'ºC'),
	(129484, 110, '2015-04-01 00:24:28.000000', 'temperatura', 541.0000, 'ºC'),
	(129485, 110, '2015-04-01 00:24:29.000000', 'temperatura', 653.0000, 'ºC'),
	(129486, 110, '2015-04-01 00:24:30.000000', 'temperatura', 442.0000, 'ºC'),
	(129487, 110, '2015-04-01 00:24:31.000000', 'temperatura', 252.0000, 'ºC'),
	(129488, 110, '2015-04-01 00:24:32.000000', 'temperatura', 1135.0000, 'ºC'),
	(129489, 110, '2015-04-01 00:24:33.000000', 'temperatura', 119.0000, 'ºC'),
	(129490, 110, '2015-04-01 00:24:34.000000', 'temperatura', 791.0000, 'ºC'),
	(129491, 110, '2015-04-01 00:24:35.000000', 'temperatura', 1198.0000, 'ºC'),
	(129492, 110, '2015-04-01 00:24:36.000000', 'temperatura', 17.0000, 'ºC'),
	(129493, 110, '2015-04-01 00:24:37.000000', 'temperatura', 92.0000, 'ºC'),
	(129494, 110, '2015-04-01 00:24:38.000000', 'temperatura', 410.0000, 'ºC'),
	(129495, 110, '2015-04-01 00:24:39.000000', 'temperatura', 572.0000, 'ºC'),
	(129496, 110, '2015-04-01 00:24:40.000000', 'temperatura', 432.0000, 'ºC'),
	(129497, 110, '2015-04-01 00:24:41.000000', 'temperatura', 445.0000, 'ºC'),
	(129498, 110, '2015-04-01 00:24:42.000000', 'temperatura', 929.0000, 'ºC'),
	(129499, 110, '2015-04-01 00:24:43.000000', 'temperatura', 910.0000, 'ºC'),
	(129500, 110, '2015-04-01 00:24:44.000000', 'temperatura', 565.0000, 'ºC'),
	(129501, 110, '2015-04-01 00:24:45.000000', 'temperatura', 95.0000, 'ºC'),
	(129502, 110, '2015-04-01 00:24:46.000000', 'temperatura', 1180.0000, 'ºC'),
	(129503, 110, '2015-04-01 00:24:47.000000', 'temperatura', 816.0000, 'ºC'),
	(129504, 110, '2015-04-01 00:24:48.000000', 'temperatura', 540.0000, 'ºC'),
	(129505, 110, '2015-04-01 00:24:49.000000', 'temperatura', 253.0000, 'ºC'),
	(129506, 110, '2015-04-01 00:24:50.000000', 'temperatura', 847.0000, 'ºC'),
	(129507, 110, '2015-04-01 00:24:51.000000', 'temperatura', 1074.0000, 'ºC'),
	(129508, 110, '2015-04-01 00:24:52.000000', 'temperatura', 430.0000, 'ºC'),
	(129509, 110, '2015-04-01 00:24:53.000000', 'temperatura', 130.0000, 'ºC'),
	(129510, 110, '2015-04-01 00:24:54.000000', 'temperatura', 560.0000, 'ºC'),
	(129511, 110, '2015-04-01 00:24:55.000000', 'temperatura', 12.0000, 'ºC'),
	(129512, 110, '2015-04-01 00:24:56.000000', 'temperatura', 780.0000, 'ºC'),
	(129513, 110, '2015-04-01 00:24:57.000000', 'temperatura', 266.0000, 'ºC'),
	(129514, 110, '2015-04-01 00:24:58.000000', 'temperatura', 187.0000, 'ºC'),
	(129515, 110, '2015-04-01 00:24:59.000000', 'temperatura', 141.0000, 'ºC'),
	(129516, 110, '2015-04-01 00:25:00.000000', 'temperatura', 141.0000, 'ºC'),
	(129517, 110, '2015-04-01 00:25:01.000000', 'temperatura', 284.0000, 'ºC'),
	(129518, 110, '2015-04-01 00:25:02.000000', 'temperatura', 999.0000, 'ºC'),
	(129519, 110, '2015-04-01 00:25:03.000000', 'temperatura', 544.0000, 'ºC'),
	(129520, 110, '2015-04-01 00:25:04.000000', 'temperatura', 924.0000, 'ºC'),
	(129521, 110, '2015-04-01 00:25:05.000000', 'temperatura', 587.0000, 'ºC'),
	(129522, 110, '2015-04-01 00:25:06.000000', 'temperatura', 162.0000, 'ºC'),
	(129523, 110, '2015-04-01 00:25:07.000000', 'temperatura', 251.0000, 'ºC'),
	(129524, 110, '2015-04-01 00:25:08.000000', 'temperatura', 771.0000, 'ºC'),
	(129525, 110, '2015-04-01 00:25:09.000000', 'temperatura', 703.0000, 'ºC'),
	(129526, 110, '2015-04-01 00:25:10.000000', 'temperatura', 2.0000, 'ºC'),
	(129527, 110, '2015-04-01 00:25:11.000000', 'temperatura', 302.0000, 'ºC'),
	(129528, 110, '2015-04-01 00:25:12.000000', 'temperatura', 304.0000, 'ºC'),
	(129529, 110, '2015-04-01 00:25:13.000000', 'temperatura', 613.0000, 'ºC'),
	(129530, 110, '2015-04-01 00:25:14.000000', 'temperatura', 955.0000, 'ºC'),
	(129531, 110, '2015-04-01 00:25:15.000000', 'temperatura', 536.0000, 'ºC'),
	(129532, 110, '2015-04-01 00:25:16.000000', 'temperatura', 1016.0000, 'ºC'),
	(129533, 110, '2015-04-01 00:25:17.000000', 'temperatura', 1073.0000, 'ºC'),
	(129534, 110, '2015-04-01 00:25:18.000000', 'temperatura', 1117.0000, 'ºC'),
	(129535, 110, '2015-04-01 00:25:19.000000', 'temperatura', 1167.0000, 'ºC'),
	(129536, 110, '2015-04-01 00:25:20.000000', 'temperatura', 86.0000, 'ºC'),
	(129537, 110, '2015-04-01 00:25:21.000000', 'temperatura', 528.0000, 'ºC'),
	(129538, 110, '2015-04-01 00:25:22.000000', 'temperatura', 1181.0000, 'ºC'),
	(129539, 110, '2015-04-01 00:25:23.000000', 'temperatura', 722.0000, 'ºC'),
	(129540, 110, '2015-04-01 00:25:24.000000', 'temperatura', 70.0000, 'ºC'),
	(129541, 110, '2015-04-01 00:25:25.000000', 'temperatura', 583.0000, 'ºC'),
	(129542, 110, '2015-04-01 00:25:26.000000', 'temperatura', 305.0000, 'ºC'),
	(129543, 110, '2015-04-01 00:25:27.000000', 'temperatura', 977.0000, 'ºC'),
	(129544, 110, '2015-04-01 00:25:28.000000', 'temperatura', 370.0000, 'ºC'),
	(129545, 110, '2015-04-01 00:25:29.000000', 'temperatura', 119.0000, 'ºC'),
	(129546, 110, '2015-04-01 00:25:30.000000', 'temperatura', 684.0000, 'ºC'),
	(129547, 110, '2015-04-01 00:25:31.000000', 'temperatura', 665.0000, 'ºC'),
	(129548, 110, '2015-04-01 00:25:32.000000', 'temperatura', 72.0000, 'ºC'),
	(129549, 110, '2015-04-01 00:25:33.000000', 'temperatura', 766.0000, 'ºC'),
	(129550, 110, '2015-04-01 00:25:34.000000', 'temperatura', 13.0000, 'ºC'),
	(129551, 110, '2015-04-01 00:25:35.000000', 'temperatura', 169.0000, 'ºC'),
	(129552, 110, '2015-04-01 00:25:36.000000', 'temperatura', 808.0000, 'ºC'),
	(129553, 110, '2015-04-01 00:25:37.000000', 'temperatura', 1130.0000, 'ºC'),
	(129554, 110, '2015-04-01 00:25:38.000000', 'temperatura', 829.0000, 'ºC'),
	(129555, 110, '2015-04-01 00:25:39.000000', 'temperatura', 756.0000, 'ºC'),
	(129556, 110, '2015-04-01 00:25:40.000000', 'temperatura', 92.0000, 'ºC'),
	(129557, 110, '2015-04-01 00:25:41.000000', 'temperatura', 594.0000, 'ºC'),
	(129558, 110, '2015-04-01 00:25:42.000000', 'temperatura', 294.0000, 'ºC'),
	(129559, 110, '2015-04-01 00:25:43.000000', 'temperatura', 887.0000, 'ºC'),
	(129560, 110, '2015-04-01 00:25:44.000000', 'temperatura', 1154.0000, 'ºC'),
	(129561, 110, '2015-04-01 00:25:45.000000', 'temperatura', 708.0000, 'ºC'),
	(129562, 110, '2015-04-01 00:25:46.000000', 'temperatura', 82.0000, 'ºC'),
	(129563, 110, '2015-04-01 00:25:47.000000', 'temperatura', 684.0000, 'ºC'),
	(129564, 110, '2015-04-01 00:25:48.000000', 'temperatura', 777.0000, 'ºC'),
	(129565, 110, '2015-04-01 00:25:49.000000', 'temperatura', 632.0000, 'ºC'),
	(129566, 110, '2015-04-01 00:25:50.000000', 'temperatura', 829.0000, 'ºC'),
	(129567, 110, '2015-04-01 00:25:51.000000', 'temperatura', 1051.0000, 'ºC'),
	(129568, 110, '2015-04-01 00:25:52.000000', 'temperatura', 367.0000, 'ºC'),
	(129569, 110, '2015-04-01 00:25:53.000000', 'temperatura', 1084.0000, 'ºC'),
	(129570, 110, '2015-04-01 00:25:54.000000', 'temperatura', 720.0000, 'ºC'),
	(129571, 110, '2015-04-01 00:25:55.000000', 'temperatura', 349.0000, 'ºC'),
	(129572, 110, '2015-04-01 00:25:56.000000', 'temperatura', 786.0000, 'ºC'),
	(129573, 110, '2015-04-01 00:25:57.000000', 'temperatura', 483.0000, 'ºC'),
	(129574, 110, '2015-04-01 00:25:58.000000', 'temperatura', 56.0000, 'ºC'),
	(129575, 110, '2015-04-01 00:25:59.000000', 'temperatura', 32.0000, 'ºC'),
	(129576, 110, '2015-04-01 00:26:00.000000', 'temperatura', 1195.0000, 'ºC'),
	(129577, 110, '2015-04-01 00:26:01.000000', 'temperatura', 1076.0000, 'ºC'),
	(129578, 110, '2015-04-01 00:26:02.000000', 'temperatura', 598.0000, 'ºC'),
	(129579, 110, '2015-04-01 00:26:03.000000', 'temperatura', 961.0000, 'ºC'),
	(129580, 110, '2015-04-01 00:26:04.000000', 'temperatura', 612.0000, 'ºC'),
	(129581, 110, '2015-04-01 00:26:05.000000', 'temperatura', 177.0000, 'ºC'),
	(129582, 110, '2015-04-01 00:26:06.000000', 'temperatura', 248.0000, 'ºC'),
	(129583, 110, '2015-04-01 00:26:07.000000', 'temperatura', 710.0000, 'ºC'),
	(129584, 110, '2015-04-01 00:26:08.000000', 'temperatura', 409.0000, 'ºC'),
	(129585, 110, '2015-04-01 00:26:09.000000', 'temperatura', 1113.0000, 'ºC'),
	(129586, 110, '2015-04-01 00:26:10.000000', 'temperatura', 741.0000, 'ºC'),
	(129587, 110, '2015-04-01 00:26:11.000000', 'temperatura', 367.0000, 'ºC'),
	(129588, 110, '2015-04-01 00:26:12.000000', 'temperatura', 810.0000, 'ºC'),
	(129589, 110, '2015-04-01 00:26:13.000000', 'temperatura', 549.0000, 'ºC'),
	(129590, 110, '2015-04-01 00:26:14.000000', 'temperatura', 315.0000, 'ºC'),
	(129591, 110, '2015-04-01 00:26:15.000000', 'temperatura', 1128.0000, 'ºC'),
	(129592, 110, '2015-04-01 00:26:16.000000', 'temperatura', 1098.0000, 'ºC'),
	(129593, 110, '2015-04-01 00:26:17.000000', 'temperatura', 905.0000, 'ºC'),
	(129594, 110, '2015-04-01 00:26:18.000000', 'temperatura', 32.0000, 'ºC'),
	(129595, 110, '2015-04-01 00:26:19.000000', 'temperatura', 1045.0000, 'ºC'),
	(129596, 110, '2015-04-01 00:26:20.000000', 'temperatura', 331.0000, 'ºC'),
	(129597, 110, '2015-04-01 00:26:21.000000', 'temperatura', 921.0000, 'ºC'),
	(129598, 110, '2015-04-01 00:26:22.000000', 'temperatura', 13.0000, 'ºC'),
	(129599, 110, '2015-04-01 00:26:23.000000', 'temperatura', 901.0000, 'ºC'),
	(129600, 110, '2015-04-01 00:26:24.000000', 'temperatura', 866.0000, 'ºC'),
	(129601, 110, '2015-04-01 00:26:25.000000', 'temperatura', 427.0000, 'ºC'),
	(129602, 110, '2015-04-01 00:26:26.000000', 'temperatura', 738.0000, 'ºC'),
	(129603, 110, '2015-04-01 00:26:27.000000', 'temperatura', 10.0000, 'ºC'),
	(129604, 110, '2015-04-01 00:26:28.000000', 'temperatura', 237.0000, 'ºC'),
	(129605, 110, '2015-04-01 00:26:29.000000', 'temperatura', 1153.0000, 'ºC'),
	(129606, 110, '2015-04-01 00:26:30.000000', 'temperatura', 255.0000, 'ºC'),
	(129607, 110, '2015-04-01 00:26:31.000000', 'temperatura', 219.0000, 'ºC'),
	(129608, 110, '2015-04-01 00:26:32.000000', 'temperatura', 329.0000, 'ºC'),
	(129609, 110, '2015-04-01 00:26:33.000000', 'temperatura', 988.0000, 'ºC'),
	(129610, 110, '2015-04-01 00:26:34.000000', 'temperatura', 354.0000, 'ºC'),
	(129611, 110, '2015-04-01 00:26:35.000000', 'temperatura', 4.0000, 'ºC'),
	(129612, 110, '2015-04-01 00:26:36.000000', 'temperatura', 162.0000, 'ºC'),
	(129613, 110, '2015-04-01 00:26:37.000000', 'temperatura', 797.0000, 'ºC'),
	(129614, 110, '2015-04-01 00:26:38.000000', 'temperatura', 1098.0000, 'ºC'),
	(129615, 110, '2015-04-01 00:26:39.000000', 'temperatura', 700.0000, 'ºC'),
	(129616, 110, '2015-04-01 00:26:40.000000', 'temperatura', 206.0000, 'ºC'),
	(129617, 110, '2015-04-01 00:26:41.000000', 'temperatura', 129.0000, 'ºC'),
	(129618, 110, '2015-04-01 00:26:42.000000', 'temperatura', 30.0000, 'ºC'),
	(129619, 110, '2015-04-01 00:26:43.000000', 'temperatura', 963.0000, 'ºC'),
	(129620, 110, '2015-04-01 00:26:44.000000', 'temperatura', 1126.0000, 'ºC'),
	(129621, 110, '2015-04-01 00:26:45.000000', 'temperatura', 343.0000, 'ºC'),
	(129622, 110, '2015-04-01 00:26:46.000000', 'temperatura', 735.0000, 'ºC'),
	(129623, 110, '2015-04-01 00:26:47.000000', 'temperatura', 248.0000, 'ºC'),
	(129624, 110, '2015-04-01 00:26:48.000000', 'temperatura', 233.0000, 'ºC'),
	(129625, 110, '2015-04-01 00:26:49.000000', 'temperatura', 424.0000, 'ºC'),
	(129626, 110, '2015-04-01 00:26:50.000000', 'temperatura', 219.0000, 'ºC'),
	(129627, 110, '2015-04-01 00:26:51.000000', 'temperatura', 1026.0000, 'ºC'),
	(129628, 110, '2015-04-01 00:26:52.000000', 'temperatura', 874.0000, 'ºC'),
	(129629, 110, '2015-04-01 00:26:53.000000', 'temperatura', 91.0000, 'ºC'),
	(129630, 110, '2015-04-01 00:26:54.000000', 'temperatura', 235.0000, 'ºC'),
	(129631, 110, '2015-04-01 00:26:55.000000', 'temperatura', 904.0000, 'ºC'),
	(129632, 110, '2015-04-01 00:26:56.000000', 'temperatura', 213.0000, 'ºC'),
	(129633, 110, '2015-04-01 00:26:57.000000', 'temperatura', 755.0000, 'ºC'),
	(129634, 110, '2015-04-01 00:26:58.000000', 'temperatura', 736.0000, 'ºC'),
	(129635, 110, '2015-04-01 00:26:59.000000', 'temperatura', 214.0000, 'ºC'),
	(129636, 110, '2015-04-01 00:27:00.000000', 'temperatura', 63.0000, 'ºC'),
	(129637, 110, '2015-04-01 00:27:01.000000', 'temperatura', 874.0000, 'ºC'),
	(129638, 110, '2015-04-01 00:27:02.000000', 'temperatura', 580.0000, 'ºC'),
	(129639, 110, '2015-04-01 00:27:03.000000', 'temperatura', 278.0000, 'ºC'),
	(129640, 110, '2015-04-01 00:27:04.000000', 'temperatura', 852.0000, 'ºC'),
	(129641, 110, '2015-04-01 00:27:05.000000', 'temperatura', 1028.0000, 'ºC'),
	(129642, 110, '2015-04-01 00:27:06.000000', 'temperatura', 183.0000, 'ºC'),
	(129643, 110, '2015-04-01 00:27:07.000000', 'temperatura', 233.0000, 'ºC'),
	(129644, 110, '2015-04-01 00:27:08.000000', 'temperatura', 614.0000, 'ºC'),
	(129645, 110, '2015-04-01 00:27:09.000000', 'temperatura', 1172.0000, 'ºC'),
	(129646, 110, '2015-04-01 00:27:10.000000', 'temperatura', 418.0000, 'ºC'),
	(129647, 110, '2015-04-01 00:27:11.000000', 'temperatura', 976.0000, 'ºC'),
	(129648, 110, '2015-04-01 00:27:12.000000', 'temperatura', 26.0000, 'ºC'),
	(129649, 110, '2015-04-01 00:27:13.000000', 'temperatura', 801.0000, 'ºC'),
	(129650, 110, '2015-04-01 00:27:14.000000', 'temperatura', 327.0000, 'ºC'),
	(129651, 110, '2015-04-01 00:27:15.000000', 'temperatura', 436.0000, 'ºC'),
	(129652, 110, '2015-04-01 00:27:16.000000', 'temperatura', 1196.0000, 'ºC'),
	(129653, 110, '2015-04-01 00:27:17.000000', 'temperatura', 1072.0000, 'ºC'),
	(129654, 110, '2015-04-01 00:27:18.000000', 'temperatura', 576.0000, 'ºC'),
	(129655, 110, '2015-04-01 00:27:19.000000', 'temperatura', 862.0000, 'ºC'),
	(129656, 110, '2015-04-01 00:27:20.000000', 'temperatura', 184.0000, 'ºC'),
	(129657, 110, '2015-04-01 00:27:21.000000', 'temperatura', 735.0000, 'ºC'),
	(129658, 110, '2015-04-01 00:27:22.000000', 'temperatura', 725.0000, 'ºC'),
	(129659, 110, '2015-04-01 00:27:23.000000', 'temperatura', 217.0000, 'ºC'),
	(129660, 110, '2015-04-01 00:27:24.000000', 'temperatura', 111.0000, 'ºC'),
	(129661, 110, '2015-04-01 00:27:25.000000', 'temperatura', 1106.0000, 'ºC'),
	(129662, 110, '2015-04-01 00:27:26.000000', 'temperatura', 398.0000, 'ºC'),
	(129663, 110, '2015-04-01 00:27:27.000000', 'temperatura', 1071.0000, 'ºC'),
	(129664, 110, '2015-04-01 00:27:28.000000', 'temperatura', 561.0000, 'ºC'),
	(129665, 110, '2015-04-01 00:27:29.000000', 'temperatura', 793.0000, 'ºC'),
	(129666, 110, '2015-04-01 00:27:30.000000', 'temperatura', 1084.0000, 'ºC'),
	(129667, 110, '2015-04-01 00:27:31.000000', 'temperatura', 642.0000, 'ºC'),
	(129668, 110, '2015-04-01 00:27:32.000000', 'temperatura', 1160.0000, 'ºC'),
	(129669, 110, '2015-04-01 00:27:33.000000', 'temperatura', 271.0000, 'ºC'),
	(129670, 110, '2015-04-01 00:27:34.000000', 'temperatura', 277.0000, 'ºC'),
	(129671, 110, '2015-04-01 00:27:35.000000', 'temperatura', 574.0000, 'ºC'),
	(129672, 110, '2015-04-01 00:27:36.000000', 'temperatura', 837.0000, 'ºC'),
	(129673, 110, '2015-04-01 00:27:37.000000', 'temperatura', 66.0000, 'ºC'),
	(129674, 110, '2015-04-01 00:27:38.000000', 'temperatura', 217.0000, 'ºC'),
	(129675, 110, '2015-04-01 00:27:39.000000', 'temperatura', 887.0000, 'ºC'),
	(129676, 110, '2015-04-01 00:27:40.000000', 'temperatura', 187.0000, 'ºC'),
	(129677, 110, '2015-04-01 00:27:41.000000', 'temperatura', 672.0000, 'ºC'),
	(129678, 110, '2015-04-01 00:27:42.000000', 'temperatura', 402.0000, 'ºC'),
	(129679, 110, '2015-04-01 00:27:43.000000', 'temperatura', 1195.0000, 'ºC'),
	(129680, 110, '2015-04-01 00:27:44.000000', 'temperatura', 1170.0000, 'ºC'),
	(129681, 110, '2015-04-01 00:27:45.000000', 'temperatura', 1065.0000, 'ºC'),
	(129682, 110, '2015-04-01 00:27:46.000000', 'temperatura', 613.0000, 'ºC'),
	(129683, 110, '2015-04-01 00:27:47.000000', 'temperatura', 1072.0000, 'ºC'),
	(129684, 110, '2015-04-01 00:27:48.000000', 'temperatura', 1124.0000, 'ºC'),
	(129685, 110, '2015-04-01 00:27:49.000000', 'temperatura', 1.0000, 'ºC'),
	(129686, 110, '2015-04-01 00:27:50.000000', 'temperatura', 235.0000, 'ºC'),
	(129687, 110, '2015-04-01 00:27:51.000000', 'temperatura', 1171.0000, 'ºC'),
	(129688, 110, '2015-04-01 00:27:52.000000', 'temperatura', 351.0000, 'ºC'),
	(129689, 110, '2015-04-01 00:27:53.000000', 'temperatura', 644.0000, 'ºC'),
	(129690, 110, '2015-04-01 00:27:54.000000', 'temperatura', 968.0000, 'ºC'),
	(129691, 110, '2015-04-01 00:27:55.000000', 'temperatura', 506.0000, 'ºC'),
	(129692, 110, '2015-04-01 00:27:56.000000', 'temperatura', 827.0000, 'ºC'),
	(129693, 110, '2015-04-01 00:27:57.000000', 'temperatura', 220.0000, 'ºC'),
	(129694, 110, '2015-04-01 00:27:58.000000', 'temperatura', 1018.0000, 'ºC'),
	(129695, 110, '2015-04-01 00:27:59.000000', 'temperatura', 830.0000, 'ºC'),
	(129696, 110, '2015-04-01 00:28:00.000000', 'temperatura', 1097.0000, 'ºC'),
	(129697, 110, '2015-04-01 00:28:01.000000', 'temperatura', 595.0000, 'ºC'),
	(129698, 110, '2015-04-01 00:28:02.000000', 'temperatura', 887.0000, 'ºC'),
	(129699, 110, '2015-04-01 00:28:03.000000', 'temperatura', 248.0000, 'ºC'),
	(129700, 110, '2015-04-01 00:28:04.000000', 'temperatura', 979.0000, 'ºC'),
	(129701, 110, '2015-04-01 00:28:05.000000', 'temperatura', 553.0000, 'ºC'),
	(129702, 110, '2015-04-01 00:28:06.000000', 'temperatura', 1026.0000, 'ºC'),
	(129703, 110, '2015-04-01 00:28:07.000000', 'temperatura', 1074.0000, 'ºC'),
	(129704, 110, '2015-04-01 00:28:08.000000', 'temperatura', 1092.0000, 'ºC'),
	(129705, 110, '2015-04-01 00:28:09.000000', 'temperatura', 1037.0000, 'ºC'),
	(129706, 110, '2015-04-01 00:28:10.000000', 'temperatura', 712.0000, 'ºC'),
	(129707, 110, '2015-04-01 00:28:11.000000', 'temperatura', 449.0000, 'ºC'),
	(129708, 110, '2015-04-01 00:28:12.000000', 'temperatura', 107.0000, 'ºC'),
	(129709, 110, '2015-04-01 00:28:13.000000', 'temperatura', 390.0000, 'ºC'),
	(129710, 110, '2015-04-01 00:28:14.000000', 'temperatura', 429.0000, 'ºC'),
	(129711, 110, '2015-04-01 00:28:15.000000', 'temperatura', 977.0000, 'ºC'),
	(129712, 110, '2015-04-01 00:28:16.000000', 'temperatura', 1199.0000, 'ºC'),
	(129713, 110, '2015-04-01 00:28:17.000000', 'temperatura', 666.0000, 'ºC'),
	(129714, 110, '2015-04-01 00:28:18.000000', 'temperatura', 930.0000, 'ºC'),
	(129715, 110, '2015-04-01 00:28:19.000000', 'temperatura', 255.0000, 'ºC'),
	(129716, 110, '2015-04-01 00:28:20.000000', 'temperatura', 885.0000, 'ºC'),
	(129717, 110, '2015-04-01 00:28:21.000000', 'temperatura', 61.0000, 'ºC'),
	(129718, 110, '2015-04-01 00:28:22.000000', 'temperatura', 51.0000, 'ºC'),
	(129719, 110, '2015-04-01 00:28:23.000000', 'temperatura', 72.0000, 'ºC'),
	(129720, 110, '2015-04-01 00:28:24.000000', 'temperatura', 209.0000, 'ºC'),
	(129721, 110, '2015-04-01 00:28:25.000000', 'temperatura', 827.0000, 'ºC'),
	(129722, 110, '2015-04-01 00:28:26.000000', 'temperatura', 1108.0000, 'ºC'),
	(129723, 110, '2015-04-01 00:28:27.000000', 'temperatura', 661.0000, 'ºC'),
	(129724, 110, '2015-04-01 00:28:28.000000', 'temperatura', 1182.0000, 'ºC'),
	(129725, 110, '2015-04-01 00:28:29.000000', 'temperatura', 328.0000, 'ºC'),
	(129726, 110, '2015-04-01 00:28:30.000000', 'temperatura', 494.0000, 'ºC'),
	(129727, 110, '2015-04-01 00:28:31.000000', 'temperatura', 285.0000, 'ºC'),
	(129728, 110, '2015-04-01 00:28:32.000000', 'temperatura', 1145.0000, 'ºC'),
	(129729, 110, '2015-04-01 00:28:33.000000', 'temperatura', 72.0000, 'ºC'),
	(129730, 110, '2015-04-01 00:28:34.000000', 'temperatura', 522.0000, 'ºC'),
	(129731, 110, '2015-04-01 00:28:35.000000', 'temperatura', 1196.0000, 'ºC'),
	(129732, 110, '2015-04-01 00:28:36.000000', 'temperatura', 816.0000, 'ºC'),
	(129733, 110, '2015-04-01 00:28:37.000000', 'temperatura', 491.0000, 'ºC'),
	(129734, 110, '2015-04-01 00:28:38.000000', 'temperatura', 8.0000, 'ºC'),
	(129735, 110, '2015-04-01 00:28:39.000000', 'temperatura', 969.0000, 'ºC'),
	(129736, 110, '2015-04-01 00:28:40.000000', 'temperatura', 20.0000, 'ºC'),
	(129737, 110, '2015-04-01 00:28:41.000000', 'temperatura', 795.0000, 'ºC'),
	(129738, 110, '2015-04-01 00:28:42.000000', 'temperatura', 315.0000, 'ºC'),
	(129739, 110, '2015-04-01 00:28:43.000000', 'temperatura', 389.0000, 'ºC'),
	(129740, 110, '2015-04-01 00:28:44.000000', 'temperatura', 1002.0000, 'ºC'),
	(129741, 110, '2015-04-01 00:28:45.000000', 'temperatura', 244.0000, 'ºC'),
	(129742, 110, '2015-04-01 00:28:46.000000', 'temperatura', 615.0000, 'ºC'),
	(129743, 110, '2015-04-01 00:28:47.000000', 'temperatura', 1144.0000, 'ºC'),
	(129744, 110, '2015-04-01 00:28:48.000000', 'temperatura', 273.0000, 'ºC'),
	(129745, 110, '2015-04-01 00:28:49.000000', 'temperatura', 335.0000, 'ºC'),
	(129746, 110, '2015-04-01 00:28:50.000000', 'temperatura', 857.0000, 'ºC'),
	(129747, 110, '2015-04-01 00:28:51.000000', 'temperatura', 878.0000, 'ºC'),
	(129748, 110, '2015-04-01 00:28:52.000000', 'temperatura', 621.0000, 'ºC'),
	(129749, 110, '2015-04-01 00:28:53.000000', 'temperatura', 471.0000, 'ºC'),
	(129750, 110, '2015-04-01 00:28:54.000000', 'temperatura', 491.0000, 'ºC'),
	(129751, 110, '2015-04-01 00:28:55.000000', 'temperatura', 1043.0000, 'ºC'),
	(129752, 110, '2015-04-01 00:28:56.000000', 'temperatura', 144.0000, 'ºC'),
	(129753, 110, '2015-04-01 00:28:57.000000', 'temperatura', 1191.0000, 'ºC'),
	(129754, 110, '2015-04-01 00:28:58.000000', 'temperatura', 725.0000, 'ºC'),
	(129755, 110, '2015-04-01 00:28:59.000000', 'temperatura', 52.0000, 'ºC'),
	(129756, 110, '2015-04-01 00:29:00.000000', 'temperatura', 483.0000, 'ºC'),
	(129757, 110, '2015-04-01 00:29:01.000000', 'temperatura', 1062.0000, 'ºC'),
	(129758, 110, '2015-04-01 00:29:02.000000', 'temperatura', 262.0000, 'ºC'),
	(129759, 110, '2015-04-01 00:29:03.000000', 'temperatura', 523.0000, 'ºC'),
	(129760, 110, '2015-04-01 00:29:04.000000', 'temperatura', 629.0000, 'ºC'),
	(129761, 110, '2015-04-01 00:29:05.000000', 'temperatura', 379.0000, 'ºC'),
	(129762, 110, '2015-04-01 00:29:06.000000', 'temperatura', 8.0000, 'ºC'),
	(129763, 110, '2015-04-01 00:29:07.000000', 'temperatura', 104.0000, 'ºC'),
	(129764, 110, '2015-04-01 00:29:08.000000', 'temperatura', 496.0000, 'ºC'),
	(129765, 110, '2015-04-01 00:29:09.000000', 'temperatura', 968.0000, 'ºC'),
	(129766, 110, '2015-04-01 00:29:10.000000', 'temperatura', 955.0000, 'ºC'),
	(129767, 110, '2015-04-01 00:29:11.000000', 'temperatura', 669.0000, 'ºC'),
	(129768, 110, '2015-04-01 00:29:12.000000', 'temperatura', 481.0000, 'ºC'),
	(129769, 110, '2015-04-01 00:29:13.000000', 'temperatura', 399.0000, 'ºC'),
	(129770, 110, '2015-04-01 00:29:14.000000', 'temperatura', 551.0000, 'ºC'),
	(129771, 110, '2015-04-01 00:29:15.000000', 'temperatura', 360.0000, 'ºC'),
	(129772, 110, '2015-04-01 00:29:16.000000', 'temperatura', 147.0000, 'ºC'),
	(129773, 110, '2015-04-01 00:29:17.000000', 'temperatura', 857.0000, 'ºC'),
	(129774, 110, '2015-04-01 00:29:18.000000', 'temperatura', 244.0000, 'ºC'),
	(129775, 110, '2015-04-01 00:29:19.000000', 'temperatura', 1050.0000, 'ºC'),
	(129776, 110, '2015-04-01 00:29:20.000000', 'temperatura', 920.0000, 'ºC'),
	(129777, 110, '2015-04-01 00:29:21.000000', 'temperatura', 247.0000, 'ºC'),
	(129778, 110, '2015-04-01 00:29:22.000000', 'temperatura', 878.0000, 'ºC'),
	(129779, 110, '2015-04-01 00:29:23.000000', 'temperatura', 47.0000, 'ºC'),
	(129780, 110, '2015-04-01 00:29:24.000000', 'temperatura', 5.0000, 'ºC'),
	(129781, 110, '2015-04-01 00:29:25.000000', 'temperatura', 1081.0000, 'ºC'),
	(129782, 110, '2015-04-01 00:29:26.000000', 'temperatura', 594.0000, 'ºC'),
	(129783, 110, '2015-04-01 00:29:27.000000', 'temperatura', 925.0000, 'ºC'),
	(129784, 110, '2015-04-01 00:29:28.000000', 'temperatura', 446.0000, 'ºC'),
	(129785, 110, '2015-04-01 00:29:29.000000', 'temperatura', 655.0000, 'ºC'),
	(129786, 110, '2015-04-01 00:29:30.000000', 'temperatura', 736.0000, 'ºC'),
	(129787, 110, '2015-04-01 00:29:31.000000', 'temperatura', 517.0000, 'ºC'),
	(129788, 110, '2015-04-01 00:29:32.000000', 'temperatura', 378.0000, 'ºC'),
	(129789, 110, '2015-04-01 00:29:33.000000', 'temperatura', 339.0000, 'ºC'),
	(129790, 110, '2015-04-01 00:29:34.000000', 'temperatura', 561.0000, 'ºC'),
	(129791, 110, '2015-04-01 00:29:35.000000', 'temperatura', 588.0000, 'ºC'),
	(129792, 110, '2015-04-01 00:29:36.000000', 'temperatura', 57.0000, 'ºC'),
	(129793, 110, '2015-04-01 00:29:37.000000', 'temperatura', 923.0000, 'ºC'),
	(129794, 110, '2015-04-01 00:29:38.000000', 'temperatura', 846.0000, 'ºC'),
	(129795, 110, '2015-04-01 00:29:39.000000', 'temperatura', 260.0000, 'ºC'),
	(129796, 110, '2015-04-01 00:29:40.000000', 'temperatura', 1161.0000, 'ºC'),
	(129797, 110, '2015-04-01 00:29:41.000000', 'temperatura', 225.0000, 'ºC'),
	(129798, 110, '2015-04-01 00:29:42.000000', 'temperatura', 42.0000, 'ºC'),
	(129799, 110, '2015-04-01 00:29:43.000000', 'temperatura', 738.0000, 'ºC'),
	(129800, 110, '2015-04-01 00:29:44.000000', 'temperatura', 1163.0000, 'ºC'),
	(129801, 110, '2015-04-01 00:29:45.000000', 'temperatura', 4.0000, 'ºC'),
	(129802, 110, '2015-04-01 00:29:46.000000', 'temperatura', 128.0000, 'ºC'),
	(129803, 110, '2015-04-01 00:29:47.000000', 'temperatura', 629.0000, 'ºC'),
	(129804, 110, '2015-04-01 00:29:48.000000', 'temperatura', 364.0000, 'ºC'),
	(129805, 110, '2015-04-01 00:29:49.000000', 'temperatura', 1133.0000, 'ºC'),
	(129806, 110, '2015-04-01 00:29:50.000000', 'temperatura', 972.0000, 'ºC'),
	(129807, 110, '2015-04-01 00:29:51.000000', 'temperatura', 262.0000, 'ºC'),
	(129808, 110, '2015-04-01 00:29:52.000000', 'temperatura', 793.0000, 'ºC'),
	(129809, 110, '2015-04-01 00:29:53.000000', 'temperatura', 782.0000, 'ºC'),
	(129810, 110, '2015-04-01 00:29:54.000000', 'temperatura', 331.0000, 'ºC'),
	(129811, 110, '2015-04-01 00:29:55.000000', 'temperatura', 509.0000, 'ºC'),
	(129812, 110, '2015-04-01 00:29:56.000000', 'temperatura', 351.0000, 'ºC'),
	(129813, 110, '2015-04-01 00:29:57.000000', 'temperatura', 231.0000, 'ºC'),
	(129814, 110, '2015-04-01 00:29:58.000000', 'temperatura', 100.0000, 'ºC'),
	(129815, 110, '2015-04-01 00:29:59.000000', 'temperatura', 1008.0000, 'ºC'),
	(129816, 110, '2015-04-01 00:30:00.000000', 'temperatura', 1142.0000, 'ºC'),
	(129817, 110, '2015-04-01 00:30:01.000000', 'temperatura', 284.0000, 'ºC'),
	(129818, 110, '2015-04-01 00:30:02.000000', 'temperatura', 394.0000, 'ºC'),
	(129819, 110, '2015-04-01 00:30:03.000000', 'temperatura', 1122.0000, 'ºC'),
	(129820, 110, '2015-04-01 00:30:04.000000', 'temperatura', 825.0000, 'ºC'),
	(129821, 110, '2015-04-01 00:30:05.000000', 'temperatura', 760.0000, 'ºC'),
	(129822, 110, '2015-04-01 00:30:06.000000', 'temperatura', 128.0000, 'ºC'),
	(129823, 110, '2015-04-01 00:30:07.000000', 'temperatura', 759.0000, 'ºC'),
	(129824, 110, '2015-04-01 00:30:08.000000', 'temperatura', 1010.0000, 'ºC'),
	(129825, 110, '2015-04-01 00:30:09.000000', 'temperatura', 375.0000, 'ºC'),
	(129826, 110, '2015-04-01 00:30:10.000000', 'temperatura', 43.0000, 'ºC'),
	(129827, 110, '2015-04-01 00:30:11.000000', 'temperatura', 293.0000, 'ºC'),
	(129828, 110, '2015-04-01 00:30:12.000000', 'temperatura', 137.0000, 'ºC'),
	(129829, 110, '2015-04-01 00:30:13.000000', 'temperatura', 1007.0000, 'ºC'),
	(129830, 110, '2015-04-01 00:30:14.000000', 'temperatura', 1022.0000, 'ºC'),
	(129831, 110, '2015-04-01 00:30:15.000000', 'temperatura', 889.0000, 'ºC'),
	(129832, 110, '2015-04-01 00:30:16.000000', 'temperatura', 182.0000, 'ºC'),
	(129833, 110, '2015-04-01 00:30:17.000000', 'temperatura', 643.0000, 'ºC'),
	(129834, 110, '2015-04-01 00:30:18.000000', 'temperatura', 270.0000, 'ºC'),
	(129835, 110, '2015-04-01 00:30:19.000000', 'temperatura', 623.0000, 'ºC'),
	(129836, 110, '2015-04-01 00:30:20.000000', 'temperatura', 1102.0000, 'ºC'),
	(129837, 110, '2015-04-01 00:30:21.000000', 'temperatura', 43.0000, 'ºC'),
	(129838, 110, '2015-04-01 00:30:22.000000', 'temperatura', 508.0000, 'ºC'),
	(129839, 110, '2015-04-01 00:30:23.000000', 'temperatura', 12.0000, 'ºC'),
	(129840, 110, '2015-04-01 00:30:24.000000', 'temperatura', 937.0000, 'ºC'),
	(129841, 110, '2015-04-01 00:30:25.000000', 'temperatura', 1051.0000, 'ºC'),
	(129842, 110, '2015-04-01 00:30:26.000000', 'temperatura', 45.0000, 'ºC'),
	(129843, 110, '2015-04-01 00:30:27.000000', 'temperatura', 672.0000, 'ºC'),
	(129844, 110, '2015-04-01 00:30:28.000000', 'temperatura', 826.0000, 'ºC'),
	(129845, 110, '2015-04-01 00:30:29.000000', 'temperatura', 912.0000, 'ºC'),
	(129846, 110, '2015-04-01 00:30:30.000000', 'temperatura', 885.0000, 'ºC'),
	(129847, 110, '2015-04-01 00:30:31.000000', 'temperatura', 489.0000, 'ºC'),
	(129848, 110, '2015-04-01 00:30:32.000000', 'temperatura', 990.0000, 'ºC'),
	(129849, 110, '2015-04-01 00:30:33.000000', 'temperatura', 1082.0000, 'ºC'),
	(129850, 110, '2015-04-01 00:30:34.000000', 'temperatura', 41.0000, 'ºC'),
	(129851, 110, '2015-04-01 00:30:35.000000', 'temperatura', 561.0000, 'ºC'),
	(129852, 110, '2015-04-01 00:30:36.000000', 'temperatura', 282.0000, 'ºC'),
	(129853, 110, '2015-04-01 00:30:37.000000', 'temperatura', 928.0000, 'ºC'),
	(129854, 110, '2015-04-01 00:30:38.000000', 'temperatura', 196.0000, 'ºC'),
	(129855, 110, '2015-04-01 00:30:39.000000', 'temperatura', 595.0000, 'ºC'),
	(129856, 110, '2015-04-01 00:30:40.000000', 'temperatura', 1186.0000, 'ºC'),
	(129857, 110, '2015-04-01 00:30:41.000000', 'temperatura', 547.0000, 'ºC'),
	(129858, 110, '2015-04-01 00:30:42.000000', 'temperatura', 376.0000, 'ºC'),
	(129859, 110, '2015-04-01 00:30:43.000000', 'temperatura', 241.0000, 'ºC'),
	(129860, 110, '2015-04-01 00:30:44.000000', 'temperatura', 78.0000, 'ºC'),
	(129861, 110, '2015-04-01 00:30:45.000000', 'temperatura', 865.0000, 'ºC'),
	(129862, 110, '2015-04-01 00:30:46.000000', 'temperatura', 492.0000, 'ºC'),
	(129863, 110, '2015-04-01 00:30:47.000000', 'temperatura', 1065.0000, 'ºC'),
	(129864, 110, '2015-04-01 00:30:48.000000', 'temperatura', 250.0000, 'ºC'),
	(129865, 110, '2015-04-01 00:30:49.000000', 'temperatura', 457.0000, 'ºC'),
	(129866, 110, '2015-04-01 00:30:50.000000', 'temperatura', 332.0000, 'ºC'),
	(129867, 110, '2015-04-01 00:30:51.000000', 'temperatura', 293.0000, 'ºC'),
	(129868, 110, '2015-04-01 00:30:52.000000', 'temperatura', 469.0000, 'ºC'),
	(129869, 110, '2015-04-01 00:30:53.000000', 'temperatura', 264.0000, 'ºC'),
	(129870, 110, '2015-04-01 00:30:54.000000', 'temperatura', 1117.0000, 'ºC'),
	(129871, 110, '2015-04-01 00:30:55.000000', 'temperatura', 1190.0000, 'ºC'),
	(129872, 110, '2015-04-01 00:30:56.000000', 'temperatura', 202.0000, 'ºC'),
	(129873, 110, '2015-04-01 00:30:57.000000', 'temperatura', 1040.0000, 'ºC'),
	(129874, 110, '2015-04-01 00:30:58.000000', 'temperatura', 996.0000, 'ºC'),
	(129875, 110, '2015-04-01 00:30:59.000000', 'temperatura', 661.0000, 'ºC'),
	(129876, 110, '2015-04-01 00:31:00.000000', 'temperatura', 315.0000, 'ºC'),
	(129877, 110, '2015-04-01 00:31:01.000000', 'temperatura', 795.0000, 'ºC'),
	(129878, 110, '2015-04-01 00:31:02.000000', 'temperatura', 629.0000, 'ºC'),
	(129879, 110, '2015-04-01 00:31:03.000000', 'temperatura', 760.0000, 'ºC'),
	(129880, 110, '2015-04-01 00:31:04.000000', 'temperatura', 713.0000, 'ºC'),
	(129881, 110, '2015-04-01 00:31:05.000000', 'temperatura', 87.0000, 'ºC'),
	(129882, 110, '2015-04-01 00:31:06.000000', 'temperatura', 695.0000, 'ºC'),
	(129883, 110, '2015-04-01 00:31:07.000000', 'temperatura', 816.0000, 'ºC'),
	(129884, 110, '2015-04-01 00:31:08.000000', 'temperatura', 793.0000, 'ºC'),
	(129885, 110, '2015-04-01 00:31:09.000000', 'temperatura', 318.0000, 'ºC'),
	(129886, 110, '2015-04-01 00:31:10.000000', 'temperatura', 413.0000, 'ºC'),
	(129887, 110, '2015-04-01 00:31:11.000000', 'temperatura', 1109.0000, 'ºC'),
	(129888, 110, '2015-04-01 00:31:12.000000', 'temperatura', 709.0000, 'ºC'),
	(129889, 110, '2015-04-01 00:31:13.000000', 'temperatura', 219.0000, 'ºC'),
	(129890, 110, '2015-04-01 00:31:14.000000', 'temperatura', 167.0000, 'ºC'),
	(129891, 110, '2015-04-01 00:31:15.000000', 'temperatura', 179.0000, 'ºC'),
	(129892, 110, '2015-04-01 00:31:16.000000', 'temperatura', 395.0000, 'ºC'),
	(129893, 110, '2015-04-01 00:31:17.000000', 'temperatura', 236.0000, 'ºC'),
	(129894, 110, '2015-04-01 00:31:18.000000', 'temperatura', 1198.0000, 'ºC'),
	(129895, 110, '2015-04-01 00:31:19.000000', 'temperatura', 481.0000, 'ºC'),
	(129896, 110, '2015-04-01 00:31:20.000000', 'temperatura', 13.0000, 'ºC'),
	(129897, 110, '2015-04-01 00:31:21.000000', 'temperatura', 1021.0000, 'ºC'),
	(129898, 110, '2015-04-01 00:31:22.000000', 'temperatura', 267.0000, 'ºC'),
	(129899, 110, '2015-04-01 00:31:23.000000', 'temperatura', 671.0000, 'ºC'),
	(129900, 110, '2015-04-01 00:31:24.000000', 'temperatura', 156.0000, 'ºC'),
	(129901, 110, '2015-04-01 00:31:25.000000', 'temperatura', 1166.0000, 'ºC'),
	(129902, 110, '2015-04-01 00:31:26.000000', 'temperatura', 561.0000, 'ºC'),
	(129903, 110, '2015-04-01 00:31:27.000000', 'temperatura', 511.0000, 'ºC'),
	(129904, 110, '2015-04-01 00:31:28.000000', 'temperatura', 871.0000, 'ºC'),
	(129905, 110, '2015-04-01 00:31:29.000000', 'temperatura', 422.0000, 'ºC'),
	(129906, 110, '2015-04-01 00:31:30.000000', 'temperatura', 700.0000, 'ºC'),
	(129907, 110, '2015-04-01 00:31:31.000000', 'temperatura', 1033.0000, 'ºC'),
	(129908, 110, '2015-04-01 00:31:32.000000', 'temperatura', 665.0000, 'ºC'),
	(129909, 110, '2015-04-01 00:31:33.000000', 'temperatura', 225.0000, 'ºC'),
	(129910, 110, '2015-04-01 00:31:34.000000', 'temperatura', 332.0000, 'ºC'),
	(129911, 110, '2015-04-01 00:31:35.000000', 'temperatura', 986.0000, 'ºC'),
	(129912, 110, '2015-04-01 00:31:36.000000', 'temperatura', 336.0000, 'ºC'),
	(129913, 110, '2015-04-01 00:31:37.000000', 'temperatura', 1120.0000, 'ºC'),
	(129914, 110, '2015-04-01 00:31:38.000000', 'temperatura', 991.0000, 'ºC'),
	(129915, 110, '2015-04-01 00:31:39.000000', 'temperatura', 399.0000, 'ºC'),
	(129916, 110, '2015-04-01 00:31:40.000000', 'temperatura', 219.0000, 'ºC'),
	(129917, 110, '2015-04-01 00:31:41.000000', 'temperatura', 1101.0000, 'ºC'),
	(129918, 110, '2015-04-01 00:31:42.000000', 'temperatura', 49.0000, 'ºC'),
	(129919, 110, '2015-04-01 00:31:43.000000', 'temperatura', 542.0000, 'ºC'),
	(129920, 110, '2015-04-01 00:31:44.000000', 'temperatura', 161.0000, 'ºC'),
	(129921, 110, '2015-04-01 00:31:45.000000', 'temperatura', 383.0000, 'ºC'),
	(129922, 110, '2015-04-01 00:31:46.000000', 'temperatura', 231.0000, 'ºC'),
	(129923, 110, '2015-04-01 00:31:47.000000', 'temperatura', 9.0000, 'ºC'),
	(129924, 110, '2015-04-01 00:31:48.000000', 'temperatura', 549.0000, 'ºC'),
	(129925, 110, '2015-04-01 00:31:49.000000', 'temperatura', 322.0000, 'ºC'),
	(129926, 110, '2015-04-01 00:31:50.000000', 'temperatura', 1161.0000, 'ºC'),
	(129927, 110, '2015-04-01 00:31:51.000000', 'temperatura', 41.0000, 'ºC'),
	(129928, 110, '2015-04-01 00:31:52.000000', 'temperatura', 322.0000, 'ºC'),
	(129929, 110, '2015-04-01 00:31:53.000000', 'temperatura', 286.0000, 'ºC'),
	(129930, 110, '2015-04-01 00:31:54.000000', 'temperatura', 466.0000, 'ºC'),
	(129931, 110, '2015-04-01 00:31:55.000000', 'temperatura', 273.0000, 'ºC'),
	(129932, 110, '2015-04-01 00:31:56.000000', 'temperatura', 1168.0000, 'ºC'),
	(129933, 110, '2015-04-01 00:31:57.000000', 'temperatura', 219.0000, 'ºC'),
	(129934, 110, '2015-04-01 00:31:58.000000', 'temperatura', 1193.0000, 'ºC'),
	(129935, 110, '2015-04-01 00:31:59.000000', 'temperatura', 506.0000, 'ºC'),
	(129936, 110, '2015-04-01 00:32:00.000000', 'temperatura', 155.0000, 'ºC'),
	(129937, 110, '2015-04-01 00:32:01.000000', 'temperatura', 456.0000, 'ºC'),
	(129938, 110, '2015-04-01 00:32:02.000000', 'temperatura', 616.0000, 'ºC'),
	(129939, 110, '2015-04-01 00:32:03.000000', 'temperatura', 512.0000, 'ºC'),
	(129940, 110, '2015-04-01 00:32:04.000000', 'temperatura', 712.0000, 'ºC'),
	(129941, 110, '2015-04-01 00:32:05.000000', 'temperatura', 824.0000, 'ºC'),
	(129942, 110, '2015-04-01 00:32:06.000000', 'temperatura', 786.0000, 'ºC'),
	(129943, 110, '2015-04-01 00:32:07.000000', 'temperatura', 258.0000, 'ºC'),
	(129944, 110, '2015-04-01 00:32:08.000000', 'temperatura', 134.0000, 'ºC'),
	(129945, 110, '2015-04-01 00:32:09.000000', 'temperatura', 1095.0000, 'ºC'),
	(129946, 110, '2015-04-01 00:32:10.000000', 'temperatura', 273.0000, 'ºC'),
	(129947, 110, '2015-04-01 00:32:11.000000', 'temperatura', 481.0000, 'ºC'),
	(129948, 110, '2015-04-01 00:32:12.000000', 'temperatura', 385.0000, 'ºC'),
	(129949, 110, '2015-04-01 00:32:13.000000', 'temperatura', 483.0000, 'ºC'),
	(129950, 110, '2015-04-01 00:32:14.000000', 'temperatura', 62.0000, 'ºC'),
	(129951, 110, '2015-04-01 00:32:15.000000', 'temperatura', 63.0000, 'ºC'),
	(129952, 110, '2015-04-01 00:32:16.000000', 'temperatura', 127.0000, 'ºC'),
	(129953, 110, '2015-04-01 00:32:17.000000', 'temperatura', 448.0000, 'ºC'),
	(129954, 110, '2015-04-01 00:32:18.000000', 'temperatura', 658.0000, 'ºC'),
	(129955, 110, '2015-04-01 00:32:19.000000', 'temperatura', 746.0000, 'ºC'),
	(129956, 110, '2015-04-01 00:32:20.000000', 'temperatura', 556.0000, 'ºC'),
	(129957, 110, '2015-04-01 00:32:21.000000', 'temperatura', 543.0000, 'ºC'),
	(129958, 110, '2015-04-01 00:32:22.000000', 'temperatura', 1047.0000, 'ºC'),
	(129959, 110, '2015-04-01 00:32:23.000000', 'temperatura', 8.0000, 'ºC'),
	(129960, 110, '2015-04-01 00:32:24.000000', 'temperatura', 500.0000, 'ºC'),
	(129961, 110, '2015-04-01 00:32:25.000000', 'temperatura', 75.0000, 'ºC'),
	(129962, 110, '2015-04-01 00:32:26.000000', 'temperatura', 77.0000, 'ºC'),
	(129963, 110, '2015-04-01 00:32:27.000000', 'temperatura', 161.0000, 'ºC'),
	(129964, 110, '2015-04-01 00:32:28.000000', 'temperatura', 572.0000, 'ºC'),
	(129965, 110, '2015-04-01 00:32:29.000000', 'temperatura', 1179.0000, 'ºC'),
	(129966, 110, '2015-04-01 00:32:30.000000', 'temperatura', 580.0000, 'ºC'),
	(129967, 110, '2015-04-01 00:32:31.000000', 'temperatura', 561.0000, 'ºC'),
	(129968, 110, '2015-04-01 00:32:32.000000', 'temperatura', 1068.0000, 'ºC'),
	(129969, 110, '2015-04-01 00:32:33.000000', 'temperatura', 58.0000, 'ºC'),
	(129970, 110, '2015-04-01 00:32:34.000000', 'temperatura', 688.0000, 'ºC'),
	(129971, 110, '2015-04-01 00:32:35.000000', 'temperatura', 864.0000, 'ºC'),
	(129972, 110, '2015-04-01 00:32:36.000000', 'temperatura', 1055.0000, 'ºC'),
	(129973, 110, '2015-04-01 00:32:37.000000', 'temperatura', 285.0000, 'ºC'),
	(129974, 110, '2015-04-01 00:32:38.000000', 'temperatura', 662.0000, 'ºC'),
	(129975, 110, '2015-04-01 00:32:39.000000', 'temperatura', 55.0000, 'ºC'),
	(129976, 110, '2015-04-01 00:32:40.000000', 'temperatura', 688.0000, 'ºC'),
	(129977, 110, '2015-04-01 00:32:41.000000', 'temperatura', 876.0000, 'ºC'),
	(129978, 110, '2015-04-01 00:32:42.000000', 'temperatura', 1118.0000, 'ºC'),
	(129979, 110, '2015-04-01 00:32:43.000000', 'temperatura', 564.0000, 'ºC'),
	(129980, 110, '2015-04-01 00:32:44.000000', 'temperatura', 663.0000, 'ºC'),
	(129981, 110, '2015-04-01 00:32:45.000000', 'temperatura', 425.0000, 'ºC'),
	(129982, 110, '2015-04-01 00:32:46.000000', 'temperatura', 138.0000, 'ºC'),
	(129983, 110, '2015-04-01 00:32:47.000000', 'temperatura', 614.0000, 'ºC'),
	(129984, 110, '2015-04-01 00:32:48.000000', 'temperatura', 258.0000, 'ºC'),
	(129985, 110, '2015-04-01 00:32:49.000000', 'temperatura', 647.0000, 'ºC'),
	(129986, 110, '2015-04-01 00:32:50.000000', 'temperatura', 64.0000, 'ºC'),
	(129987, 110, '2015-04-01 00:32:51.000000', 'temperatura', 778.0000, 'ºC'),
	(129988, 110, '2015-04-01 00:32:52.000000', 'temperatura', 98.0000, 'ºC'),
	(129989, 110, '2015-04-01 00:32:53.000000', 'temperatura', 558.0000, 'ºC'),
	(129990, 110, '2015-04-01 00:32:54.000000', 'temperatura', 95.0000, 'ºC'),
	(129991, 110, '2015-04-01 00:32:55.000000', 'temperatura', 2.0000, 'ºC'),
	(129992, 110, '2015-04-01 00:32:56.000000', 'temperatura', 926.0000, 'ºC'),
	(129993, 110, '2015-04-01 00:32:57.000000', 'temperatura', 1026.0000, 'ºC'),
	(129994, 110, '2015-04-01 00:32:58.000000', 'temperatura', 1151.0000, 'ºC'),
	(129995, 110, '2015-04-01 00:32:59.000000', 'temperatura', 277.0000, 'ºC'),
	(129996, 110, '2015-04-01 00:33:00.000000', 'temperatura', 331.0000, 'ºC'),
	(129997, 110, '2015-04-01 00:33:01.000000', 'temperatura', 827.0000, 'ºC'),
	(129998, 110, '2015-04-01 00:33:02.000000', 'temperatura', 741.0000, 'ºC'),
	(129999, 110, '2015-04-01 00:33:03.000000', 'temperatura', 25.0000, 'ºC'),
	(130000, 110, '2015-04-01 00:33:04.000000', 'temperatura', 303.0000, 'ºC'),
	(130001, 110, '2015-04-01 00:33:05.000000', 'temperatura', 240.0000, 'ºC'),
	(130002, 110, '2015-04-01 00:33:06.000000', 'temperatura', 290.0000, 'ºC'),
	(130003, 110, '2015-04-01 00:33:07.000000', 'temperatura', 730.0000, 'ºC'),
	(130004, 110, '2015-04-01 00:33:08.000000', 'temperatura', 382.0000, 'ºC'),
	(130005, 110, '2015-04-01 00:33:09.000000', 'temperatura', 919.0000, 'ºC'),
	(130006, 110, '2015-04-01 00:33:10.000000', 'temperatura', 1051.0000, 'ºC'),
	(130007, 110, '2015-04-01 00:33:11.000000', 'temperatura', 99.0000, 'ºC'),
	(130008, 110, '2015-04-01 00:33:12.000000', 'temperatura', 944.0000, 'ºC'),
	(130009, 110, '2015-04-01 00:33:13.000000', 'temperatura', 820.0000, 'ºC'),
	(130010, 110, '2015-04-01 00:33:14.000000', 'temperatura', 70.0000, 'ºC'),
	(130011, 110, '2015-04-01 00:33:15.000000', 'temperatura', 290.0000, 'ºC'),
	(130012, 110, '2015-04-01 00:33:16.000000', 'temperatura', 41.0000, 'ºC'),
	(130013, 110, '2015-04-01 00:33:17.000000', 'temperatura', 534.0000, 'ºC'),
	(130014, 110, '2015-04-01 00:33:18.000000', 'temperatura', 149.0000, 'ºC'),
	(130015, 110, '2015-04-01 00:33:19.000000', 'temperatura', 342.0000, 'ºC'),
	(130016, 110, '2015-04-01 00:33:20.000000', 'temperatura', 63.0000, 'ºC'),
	(130017, 110, '2015-04-01 00:33:21.000000', 'temperatura', 492.0000, 'ºC'),
	(130018, 110, '2015-04-01 00:33:22.000000', 'temperatura', 1070.0000, 'ºC'),
	(130019, 110, '2015-04-01 00:33:23.000000', 'temperatura', 273.0000, 'ºC'),
	(130020, 110, '2015-04-01 00:33:24.000000', 'temperatura', 557.0000, 'ºC'),
	(130021, 110, '2015-04-01 00:33:25.000000', 'temperatura', 765.0000, 'ºC'),
	(130022, 110, '2015-04-01 00:33:26.000000', 'temperatura', 955.0000, 'ºC'),
	(130023, 110, '2015-04-01 00:33:27.000000', 'temperatura', 79.0000, 'ºC'),
	(130024, 110, '2015-04-01 00:33:28.000000', 'temperatura', 1132.0000, 'ºC'),
	(130025, 110, '2015-04-01 00:33:29.000000', 'temperatura', 623.0000, 'ºC'),
	(130026, 110, '2015-04-01 00:33:30.000000', 'temperatura', 918.0000, 'ºC'),
	(130027, 110, '2015-04-01 00:33:31.000000', 'temperatura', 323.0000, 'ºC'),
	(130028, 110, '2015-04-01 00:33:32.000000', 'temperatura', 61.0000, 'ºC'),
	(130029, 110, '2015-04-01 00:33:33.000000', 'temperatura', 536.0000, 'ºC'),
	(130030, 110, '2015-04-01 00:33:34.000000', 'temperatura', 97.0000, 'ºC'),
	(130031, 110, '2015-04-01 00:33:35.000000', 'temperatura', 78.0000, 'ºC'),
	(130032, 110, '2015-04-01 00:33:36.000000', 'temperatura', 101.0000, 'ºC'),
	(130033, 110, '2015-04-01 00:33:37.000000', 'temperatura', 272.0000, 'ºC'),
	(130034, 110, '2015-04-01 00:33:38.000000', 'temperatura', 1055.0000, 'ºC'),
	(130035, 110, '2015-04-01 00:33:39.000000', 'temperatura', 859.0000, 'ºC'),
	(130036, 110, '2015-04-01 00:33:40.000000', 'temperatura', 1130.0000, 'ºC'),
	(130037, 110, '2015-04-01 00:33:41.000000', 'temperatura', 676.0000, 'ºC'),
	(130038, 110, '2015-04-01 00:33:42.000000', 'temperatura', 1189.0000, 'ºC'),
	(130039, 110, '2015-04-01 00:33:43.000000', 'temperatura', 317.0000, 'ºC'),
	(130040, 110, '2015-04-01 00:33:44.000000', 'temperatura', 418.0000, 'ºC'),
	(130041, 110, '2015-04-01 00:33:45.000000', 'temperatura', 1140.0000, 'ºC'),
	(130042, 110, '2015-04-01 00:33:46.000000', 'temperatura', 849.0000, 'ºC'),
	(130043, 110, '2015-04-01 00:33:47.000000', 'temperatura', 823.0000, 'ºC'),
	(130044, 110, '2015-04-01 00:33:48.000000', 'temperatura', 370.0000, 'ºC'),
	(130045, 110, '2015-04-01 00:33:49.000000', 'temperatura', 581.0000, 'ºC'),
	(130046, 110, '2015-04-01 00:33:50.000000', 'temperatura', 593.0000, 'ºC'),
	(130047, 110, '2015-04-01 00:33:51.000000', 'temperatura', 26.0000, 'ºC'),
	(130048, 110, '2015-04-01 00:33:52.000000', 'temperatura', 751.0000, 'ºC'),
	(130049, 110, '2015-04-01 00:33:53.000000', 'temperatura', 76.0000, 'ºC'),
	(130050, 110, '2015-04-01 00:33:54.000000', 'temperatura', 528.0000, 'ºC'),
	(130051, 110, '2015-04-01 00:33:55.000000', 'temperatura', 11.0000, 'ºC'),
	(130052, 110, '2015-04-01 00:33:56.000000', 'temperatura', 872.0000, 'ºC'),
	(130053, 110, '2015-04-01 00:33:57.000000', 'temperatura', 729.0000, 'ºC'),
	(130054, 110, '2015-04-01 00:33:58.000000', 'temperatura', 1030.0000, 'ºC'),
	(130055, 110, '2015-04-01 00:33:59.000000', 'temperatura', 563.0000, 'ºC'),
	(130056, 110, '2015-04-01 00:34:00.000000', 'temperatura', 925.0000, 'ºC'),
	(130057, 110, '2015-04-01 00:34:01.000000', 'temperatura', 536.0000, 'ºC'),
	(130058, 110, '2015-04-01 00:34:02.000000', 'temperatura', 1105.0000, 'ºC'),
	(130059, 110, '2015-04-01 00:34:03.000000', 'temperatura', 319.0000, 'ºC'),
	(130060, 110, '2015-04-01 00:34:04.000000', 'temperatura', 681.0000, 'ºC'),
	(130061, 110, '2015-04-01 00:34:05.000000', 'temperatura', 47.0000, 'ºC'),
	(130062, 110, '2015-04-01 00:34:06.000000', 'temperatura', 595.0000, 'ºC'),
	(130063, 110, '2015-04-01 00:34:07.000000', 'temperatura', 434.0000, 'ºC'),
	(130064, 110, '2015-04-01 00:34:08.000000', 'temperatura', 383.0000, 'ºC'),
	(130065, 110, '2015-04-01 00:34:09.000000', 'temperatura', 615.0000, 'ºC'),
	(130066, 110, '2015-04-01 00:34:10.000000', 'temperatura', 725.0000, 'ºC'),
	(130067, 110, '2015-04-01 00:34:11.000000', 'temperatura', 581.0000, 'ºC'),
	(130068, 110, '2015-04-01 00:34:12.000000', 'temperatura', 730.0000, 'ºC'),
	(130069, 110, '2015-04-01 00:34:13.000000', 'temperatura', 707.0000, 'ºC'),
	(130070, 110, '2015-04-01 00:34:14.000000', 'temperatura', 148.0000, 'ºC'),
	(130071, 110, '2015-04-01 00:34:15.000000', 'temperatura', 1017.0000, 'ºC'),
	(130072, 110, '2015-04-01 00:34:16.000000', 'temperatura', 1043.0000, 'ºC'),
	(130073, 110, '2015-04-01 00:34:17.000000', 'temperatura', 964.0000, 'ºC'),
	(130074, 110, '2015-04-01 00:34:18.000000', 'temperatura', 492.0000, 'ºC'),
	(130075, 110, '2015-04-01 00:34:19.000000', 'temperatura', 767.0000, 'ºC'),
	(130076, 110, '2015-04-01 00:34:20.000000', 'temperatura', 1158.0000, 'ºC'),
	(130077, 110, '2015-04-01 00:34:21.000000', 'temperatura', 1093.0000, 'ºC'),
	(130078, 110, '2015-04-01 00:34:22.000000', 'temperatura', 788.0000, 'ºC'),
	(130079, 110, '2015-04-01 00:34:23.000000', 'temperatura', 665.0000, 'ºC'),
	(130080, 110, '2015-04-01 00:34:24.000000', 'temperatura', 960.0000, 'ºC'),
	(130081, 110, '2015-04-01 00:34:25.000000', 'temperatura', 405.0000, 'ºC'),
	(130082, 110, '2015-04-01 00:34:26.000000', 'temperatura', 345.0000, 'ºC'),
	(130083, 110, '2015-04-01 00:34:27.000000', 'temperatura', 509.0000, 'ºC'),
	(130084, 110, '2015-04-01 00:34:28.000000', 'temperatura', 313.0000, 'ºC'),
	(130085, 110, '2015-04-01 00:34:29.000000', 'temperatura', 37.0000, 'ºC'),
	(130086, 110, '2015-04-01 00:34:30.000000', 'temperatura', 446.0000, 'ºC'),
	(130087, 110, '2015-04-01 00:34:31.000000', 'temperatura', 922.0000, 'ºC'),
	(130088, 110, '2015-04-01 00:34:32.000000', 'temperatura', 873.0000, 'ºC'),
	(130089, 110, '2015-04-01 00:34:33.000000', 'temperatura', 397.0000, 'ºC'),
	(130090, 110, '2015-04-01 00:34:34.000000', 'temperatura', 569.0000, 'ºC'),
	(130091, 110, '2015-04-01 00:34:35.000000', 'temperatura', 455.0000, 'ºC'),
	(130092, 110, '2015-04-01 00:34:36.000000', 'temperatura', 567.0000, 'ºC'),
	(130093, 110, '2015-04-01 00:34:37.000000', 'temperatura', 273.0000, 'ºC'),
	(130094, 110, '2015-04-01 00:34:38.000000', 'temperatura', 862.0000, 'ºC'),
	(130095, 110, '2015-04-01 00:34:39.000000', 'temperatura', 1090.0000, 'ºC'),
	(130096, 110, '2015-04-01 00:34:40.000000', 'temperatura', 467.0000, 'ºC'),
	(130097, 110, '2015-04-01 00:34:41.000000', 'temperatura', 267.0000, 'ºC'),
	(130098, 110, '2015-04-01 00:34:42.000000', 'temperatura', 1133.0000, 'ºC'),
	(130099, 110, '2015-04-01 00:34:43.000000', 'temperatura', 62.0000, 'ºC'),
	(130100, 110, '2015-04-01 00:34:44.000000', 'temperatura', 515.0000, 'ºC'),
	(130101, 110, '2015-04-01 00:34:45.000000', 'temperatura', 1188.0000, 'ºC'),
	(130102, 110, '2015-04-01 00:34:46.000000', 'temperatura', 795.0000, 'ºC'),
	(130103, 110, '2015-04-01 00:34:47.000000', 'temperatura', 412.0000, 'ºC'),
	(130104, 110, '2015-04-01 00:34:48.000000', 'temperatura', 876.0000, 'ºC'),
	(130105, 110, '2015-04-01 00:34:49.000000', 'temperatura', 746.0000, 'ºC'),
	(130106, 110, '2015-04-01 00:34:50.000000', 'temperatura', 1101.0000, 'ºC'),
	(130107, 110, '2015-04-01 00:34:51.000000', 'temperatura', 866.0000, 'ºC'),
	(130108, 110, '2015-04-01 00:34:52.000000', 'temperatura', 1028.0000, 'ºC'),
	(130109, 110, '2015-04-01 00:34:53.000000', 'temperatura', 144.0000, 'ºC'),
	(130110, 110, '2015-04-01 00:34:54.000000', 'temperatura', 38.0000, 'ºC'),
	(130111, 110, '2015-04-01 00:34:55.000000', 'temperatura', 956.0000, 'ºC'),
	(130112, 110, '2015-04-01 00:34:56.000000', 'temperatura', 1069.0000, 'ºC'),
	(130113, 110, '2015-04-01 00:34:57.000000', 'temperatura', 76.0000, 'ºC'),
	(130114, 110, '2015-04-01 00:34:58.000000', 'temperatura', 773.0000, 'ºC'),
	(130115, 110, '2015-04-01 00:34:59.000000', 'temperatura', 37.0000, 'ºC'),
	(130116, 110, '2015-04-01 00:35:00.000000', 'temperatura', 266.0000, 'ºC'),
	(130117, 110, '2015-04-01 00:35:01.000000', 'temperatura', 20.0000, 'ºC'),
	(130118, 110, '2015-04-01 00:35:02.000000', 'temperatura', 504.0000, 'ºC'),
	(130119, 110, '2015-04-01 00:35:03.000000', 'temperatura', 59.0000, 'ºC'),
	(130120, 110, '2015-04-01 00:35:04.000000', 'temperatura', 1182.0000, 'ºC'),
	(130121, 110, '2015-04-01 00:35:05.000000', 'temperatura', 935.0000, 'ºC'),
	(130122, 110, '2015-04-01 00:35:06.000000', 'temperatura', 1128.0000, 'ºC'),
	(130123, 110, '2015-04-01 00:35:07.000000', 'temperatura', 436.0000, 'ºC'),
	(130124, 110, '2015-04-01 00:35:08.000000', 'temperatura', 1196.0000, 'ºC'),
	(130125, 110, '2015-04-01 00:35:09.000000', 'temperatura', 1075.0000, 'ºC'),
	(130126, 110, '2015-04-01 00:35:10.000000', 'temperatura', 587.0000, 'ºC'),
	(130127, 110, '2015-04-01 00:35:11.000000', 'temperatura', 909.0000, 'ºC'),
	(130128, 110, '2015-04-01 00:35:12.000000', 'temperatura', 383.0000, 'ºC'),
	(130129, 110, '2015-04-01 00:35:13.000000', 'temperatura', 390.0000, 'ºC'),
	(130130, 110, '2015-04-01 00:35:14.000000', 'temperatura', 802.0000, 'ºC'),
	(130131, 110, '2015-04-01 00:35:15.000000', 'temperatura', 439.0000, 'ºC'),
	(130132, 110, '2015-04-01 00:35:16.000000', 'temperatura', 990.0000, 'ºC'),
	(130133, 110, '2015-04-01 00:35:17.000000', 'temperatura', 34.0000, 'ºC'),
	(130134, 110, '2015-04-01 00:35:18.000000', 'temperatura', 802.0000, 'ºC'),
	(130135, 110, '2015-04-01 00:35:19.000000', 'temperatura', 308.0000, 'ºC'),
	(130136, 110, '2015-04-01 00:35:20.000000', 'temperatura', 335.0000, 'ºC'),
	(130137, 110, '2015-04-01 00:35:21.000000', 'temperatura', 749.0000, 'ºC'),
	(130138, 110, '2015-04-01 00:35:22.000000', 'temperatura', 342.0000, 'ºC'),
	(130139, 110, '2015-04-01 00:35:23.000000', 'temperatura', 662.0000, 'ºC'),
	(130140, 110, '2015-04-01 00:35:24.000000', 'temperatura', 1085.0000, 'ºC'),
	(130141, 110, '2015-04-01 00:35:25.000000', 'temperatura', 1040.0000, 'ºC'),
	(130142, 110, '2015-04-01 00:35:26.000000', 'temperatura', 746.0000, 'ºC'),
	(130143, 110, '2015-04-01 00:35:27.000000', 'temperatura', 609.0000, 'ºC'),
	(130144, 110, '2015-04-01 00:35:28.000000', 'temperatura', 807.0000, 'ºC'),
	(130145, 110, '2015-04-01 00:35:29.000000', 'temperatura', 1010.0000, 'ºC'),
	(130146, 110, '2015-04-01 00:35:30.000000', 'temperatura', 231.0000, 'ºC'),
	(130147, 110, '2015-04-01 00:35:31.000000', 'temperatura', 524.0000, 'ºC'),
	(130148, 110, '2015-04-01 00:35:32.000000', 'temperatura', 726.0000, 'ºC'),
	(130149, 110, '2015-04-01 00:35:33.000000', 'temperatura', 861.0000, 'ºC'),
	(130150, 110, '2015-04-01 00:35:34.000000', 'temperatura', 926.0000, 'ºC'),
	(130151, 110, '2015-04-01 00:35:35.000000', 'temperatura', 850.0000, 'ºC'),
	(130152, 110, '2015-04-01 00:35:36.000000', 'temperatura', 269.0000, 'ºC'),
	(130153, 110, '2015-04-01 00:35:37.000000', 'temperatura', 1197.0000, 'ºC'),
	(130154, 110, '2015-04-01 00:35:38.000000', 'temperatura', 378.0000, 'ºC'),
	(130155, 110, '2015-04-01 00:35:39.000000', 'temperatura', 700.0000, 'ºC'),
	(130156, 110, '2015-04-01 00:35:40.000000', 'temperatura', 1164.0000, 'ºC'),
	(130157, 110, '2015-04-01 00:35:41.000000', 'temperatura', 124.0000, 'ºC'),
	(130158, 110, '2015-04-01 00:35:42.000000', 'temperatura', 727.0000, 'ºC'),
	(130159, 110, '2015-04-01 00:35:43.000000', 'temperatura', 864.0000, 'ºC'),
	(130160, 110, '2015-04-01 00:35:44.000000', 'temperatura', 941.0000, 'ºC'),
	(130161, 110, '2015-04-01 00:35:45.000000', 'temperatura', 913.0000, 'ºC'),
	(130162, 110, '2015-04-01 00:35:46.000000', 'temperatura', 542.0000, 'ºC'),
	(130163, 110, '2015-04-01 00:35:47.000000', 'temperatura', 1173.0000, 'ºC'),
	(130164, 110, '2015-04-01 00:35:48.000000', 'temperatura', 638.0000, 'ºC'),
	(130165, 110, '2015-04-01 00:35:49.000000', 'temperatura', 873.0000, 'ºC'),
	(130166, 110, '2015-04-01 00:35:50.000000', 'temperatura', 53.0000, 'ºC'),
	(130167, 110, '2015-04-01 00:35:51.000000', 'temperatura', 43.0000, 'ºC'),
	(130168, 110, '2015-04-01 00:35:52.000000', 'temperatura', 58.0000, 'ºC'),
	(130169, 110, '2015-04-01 00:35:53.000000', 'temperatura', 162.0000, 'ºC'),
	(130170, 110, '2015-04-01 00:35:54.000000', 'temperatura', 638.0000, 'ºC'),
	(130171, 110, '2015-04-01 00:35:55.000000', 'temperatura', 304.0000, 'ºC'),
	(130172, 110, '2015-04-01 00:35:56.000000', 'temperatura', 806.0000, 'ºC'),
	(130173, 110, '2015-04-01 00:35:57.000000', 'temperatura', 717.0000, 'ºC'),
	(130174, 110, '2015-04-01 00:35:58.000000', 'temperatura', 1170.0000, 'ºC'),
	(130175, 110, '2015-04-01 00:35:59.000000', 'temperatura', 97.0000, 'ºC'),
	(130176, 110, '2015-04-01 00:36:00.000000', 'temperatura', 574.0000, 'ºC'),
	(130177, 110, '2015-04-01 00:36:01.000000', 'temperatura', 183.0000, 'ºC'),
	(130178, 110, '2015-04-01 00:36:02.000000', 'temperatura', 393.0000, 'ºC'),
	(130179, 110, '2015-04-01 00:36:03.000000', 'temperatura', 216.0000, 'ºC'),
	(130180, 110, '2015-04-01 00:36:04.000000', 'temperatura', 1100.0000, 'ºC'),
	(130181, 110, '2015-04-01 00:36:05.000000', 'temperatura', 54.0000, 'ºC'),
	(130182, 110, '2015-04-01 00:36:06.000000', 'temperatura', 570.0000, 'ºC'),
	(130183, 110, '2015-04-01 00:36:07.000000', 'temperatura', 287.0000, 'ºC'),
	(130184, 110, '2015-04-01 00:36:08.000000', 'temperatura', 928.0000, 'ºC'),
	(130185, 110, '2015-04-01 00:36:09.000000', 'temperatura', 179.0000, 'ºC'),
	(130186, 110, '2015-04-01 00:36:10.000000', 'temperatura', 511.0000, 'ºC'),
	(130187, 110, '2015-04-01 00:36:11.000000', 'temperatura', 817.0000, 'ºC'),
	(130188, 110, '2015-04-01 00:36:12.000000', 'temperatura', 156.0000, 'ºC'),
	(130189, 110, '2015-04-01 00:36:13.000000', 'temperatura', 726.0000, 'ºC'),
	(130190, 110, '2015-04-01 00:36:14.000000', 'temperatura', 763.0000, 'ºC'),
	(130191, 110, '2015-04-01 00:36:15.000000', 'temperatura', 438.0000, 'ºC'),
	(130192, 110, '2015-04-01 00:36:16.000000', 'temperatura', 1103.0000, 'ºC'),
	(130193, 110, '2015-04-01 00:36:17.000000', 'temperatura', 603.0000, 'ºC'),
	(130194, 110, '2015-04-01 00:36:18.000000', 'temperatura', 903.0000, 'ºC'),
	(130195, 110, '2015-04-01 00:36:19.000000', 'temperatura', 306.0000, 'ºC'),
	(130196, 110, '2015-04-01 00:36:20.000000', 'temperatura', 24.0000, 'ºC'),
	(130197, 110, '2015-04-01 00:36:21.000000', 'temperatura', 400.0000, 'ºC'),
	(130198, 110, '2015-04-01 00:36:22.000000', 'temperatura', 731.0000, 'ºC'),
	(130199, 110, '2015-04-01 00:36:23.000000', 'temperatura', 55.0000, 'ºC'),
	(130200, 110, '2015-04-01 00:36:24.000000', 'temperatura', 483.0000, 'ºC'),
	(130201, 110, '2015-04-01 00:36:25.000000', 'temperatura', 1050.0000, 'ºC'),
	(130202, 110, '2015-04-01 00:36:26.000000', 'temperatura', 203.0000, 'ºC'),
	(130203, 110, '2015-04-01 00:36:27.000000', 'temperatura', 265.0000, 'ºC'),
	(130204, 110, '2015-04-01 00:36:28.000000', 'temperatura', 715.0000, 'ºC'),
	(130205, 110, '2015-04-01 00:36:29.000000', 'temperatura', 382.0000, 'ºC'),
	(130206, 110, '2015-04-01 00:36:30.000000', 'temperatura', 965.0000, 'ºC'),
	(130207, 110, '2015-04-01 00:36:31.000000', 'temperatura', 78.0000, 'ºC'),
	(130208, 110, '2015-04-01 00:36:32.000000', 'temperatura', 1096.0000, 'ºC'),
	(130209, 110, '2015-04-01 00:36:33.000000', 'temperatura', 446.0000, 'ºC'),
	(130210, 110, '2015-04-01 00:36:34.000000', 'temperatura', 142.0000, 'ºC'),
	(130211, 110, '2015-04-01 00:36:35.000000', 'temperatura', 572.0000, 'ºC'),
	(130212, 110, '2015-04-01 00:36:36.000000', 'temperatura', 35.0000, 'ºC'),
	(130213, 110, '2015-04-01 00:36:37.000000', 'temperatura', 861.0000, 'ºC'),
	(130214, 110, '2015-04-01 00:36:38.000000', 'temperatura', 600.0000, 'ºC'),
	(130215, 110, '2015-04-01 00:36:39.000000', 'temperatura', 416.0000, 'ºC'),
	(130216, 110, '2015-04-01 00:36:40.000000', 'temperatura', 283.0000, 'ºC'),
	(130217, 110, '2015-04-01 00:36:41.000000', 'temperatura', 166.0000, 'ºC'),
	(130218, 110, '2015-04-01 00:36:42.000000', 'temperatura', 1183.0000, 'ºC'),
	(130219, 110, '2015-04-01 00:36:43.000000', 'temperatura', 615.0000, 'ºC'),
	(130220, 110, '2015-04-01 00:36:44.000000', 'temperatura', 727.0000, 'ºC'),
	(130221, 110, '2015-04-01 00:36:45.000000', 'temperatura', 593.0000, 'ºC'),
	(130222, 110, '2015-04-01 00:36:46.000000', 'temperatura', 782.0000, 'ºC'),
	(130223, 110, '2015-04-01 00:36:47.000000', 'temperatura', 930.0000, 'ºC'),
	(130224, 110, '2015-04-01 00:36:48.000000', 'temperatura', 1108.0000, 'ºC'),
	(130225, 110, '2015-04-01 00:36:49.000000', 'temperatura', 350.0000, 'ºC'),
	(130226, 110, '2015-04-01 00:36:50.000000', 'temperatura', 826.0000, 'ºC'),
	(130227, 110, '2015-04-01 00:36:51.000000', 'temperatura', 679.0000, 'ºC'),
	(130228, 110, '2015-04-01 00:36:52.000000', 'temperatura', 917.0000, 'ºC'),
	(130229, 110, '2015-04-01 00:36:53.000000', 'temperatura', 151.0000, 'ºC'),
	(130230, 110, '2015-04-01 00:36:54.000000', 'temperatura', 403.0000, 'ºC'),
	(130231, 110, '2015-04-01 00:36:55.000000', 'temperatura', 364.0000, 'ºC'),
	(130232, 110, '2015-04-01 00:36:56.000000', 'temperatura', 612.0000, 'ºC'),
	(130233, 110, '2015-04-01 00:36:57.000000', 'temperatura', 768.0000, 'ºC'),
	(130234, 110, '2015-04-01 00:36:58.000000', 'temperatura', 805.0000, 'ºC'),
	(130235, 110, '2015-04-01 00:36:59.000000', 'temperatura', 519.0000, 'ºC'),
	(130236, 110, '2015-04-01 00:37:00.000000', 'temperatura', 184.0000, 'ºC'),
	(130237, 110, '2015-04-01 00:37:01.000000', 'temperatura', 562.0000, 'ºC'),
	(130238, 110, '2015-04-01 00:37:02.000000', 'temperatura', 1058.0000, 'ºC'),
	(130239, 110, '2015-04-01 00:37:03.000000', 'temperatura', 7.0000, 'ºC'),
	(130240, 110, '2015-04-01 00:37:04.000000', 'temperatura', 459.0000, 'ºC'),
	(130241, 110, '2015-04-01 00:37:05.000000', 'temperatura', 1074.0000, 'ºC'),
	(130242, 110, '2015-04-01 00:37:06.000000', 'temperatura', 393.0000, 'ºC'),
	(130243, 110, '2015-04-01 00:37:07.000000', 'temperatura', 1146.0000, 'ºC'),
	(130244, 110, '2015-04-01 00:37:08.000000', 'temperatura', 949.0000, 'ºC'),
	(130245, 110, '2015-04-01 00:37:09.000000', 'temperatura', 109.0000, 'ºC'),
	(130246, 110, '2015-04-01 00:37:10.000000', 'temperatura', 99.0000, 'ºC'),
	(130247, 110, '2015-04-01 00:37:11.000000', 'temperatura', 170.0000, 'ºC'),
	(130248, 110, '2015-04-01 00:37:12.000000', 'temperatura', 551.0000, 'ºC'),
	(130249, 110, '2015-04-01 00:37:13.000000', 'temperatura', 1047.0000, 'ºC'),
	(130250, 110, '2015-04-01 00:37:14.000000', 'temperatura', 1183.0000, 'ºC'),
	(130251, 110, '2015-04-01 00:37:15.000000', 'temperatura', 373.0000, 'ºC'),
	(130252, 110, '2015-04-01 00:37:16.000000', 'temperatura', 718.0000, 'ºC'),
	(130253, 110, '2015-04-01 00:37:17.000000', 'temperatura', 72.0000, 'ºC'),
	(130254, 110, '2015-04-01 00:37:18.000000', 'temperatura', 606.0000, 'ºC'),
	(130255, 110, '2015-04-01 00:37:19.000000', 'temperatura', 415.0000, 'ºC'),
	(130256, 110, '2015-04-01 00:37:20.000000', 'temperatura', 258.0000, 'ºC'),
	(130257, 110, '2015-04-01 00:37:21.000000', 'temperatura', 46.0000, 'ºC'),
	(130258, 110, '2015-04-01 00:37:22.000000', 'temperatura', 655.0000, 'ºC'),
	(130259, 110, '2015-04-01 00:37:23.000000', 'temperatura', 738.0000, 'ºC'),
	(130260, 110, '2015-04-01 00:37:24.000000', 'temperatura', 527.0000, 'ºC'),
	(130261, 110, '2015-04-01 00:37:25.000000', 'temperatura', 423.0000, 'ºC'),
	(130262, 110, '2015-04-01 00:37:26.000000', 'temperatura', 531.0000, 'ºC'),
	(130263, 110, '2015-04-01 00:37:27.000000', 'temperatura', 186.0000, 'ºC'),
	(130264, 110, '2015-04-01 00:37:28.000000', 'temperatura', 540.0000, 'ºC'),
	(130265, 110, '2015-04-01 00:37:29.000000', 'temperatura', 941.0000, 'ºC'),
	(130266, 110, '2015-04-01 00:37:30.000000', 'temperatura', 687.0000, 'ºC'),
	(130267, 110, '2015-04-01 00:37:31.000000', 'temperatura', 613.0000, 'ºC'),
	(130268, 110, '2015-04-01 00:37:32.000000', 'temperatura', 1005.0000, 'ºC'),
	(130269, 110, '2015-04-01 00:37:33.000000', 'temperatura', 786.0000, 'ºC'),
	(130270, 110, '2015-04-01 00:37:34.000000', 'temperatura', 916.0000, 'ºC'),
	(130271, 110, '2015-04-01 00:37:35.000000', 'temperatura', 1022.0000, 'ºC'),
	(130272, 110, '2015-04-01 00:37:36.000000', 'temperatura', 1163.0000, 'ºC'),
	(130273, 110, '2015-04-01 00:37:37.000000', 'temperatura', 348.0000, 'ºC'),
	(130274, 110, '2015-04-01 00:37:38.000000', 'temperatura', 652.0000, 'ºC'),
	(130275, 110, '2015-04-01 00:37:39.000000', 'temperatura', 1015.0000, 'ºC'),
	(130276, 110, '2015-04-01 00:37:40.000000', 'temperatura', 723.0000, 'ºC'),
	(130277, 110, '2015-04-01 00:37:41.000000', 'temperatura', 567.0000, 'ºC'),
	(130278, 110, '2015-04-01 00:37:42.000000', 'temperatura', 669.0000, 'ºC'),
	(130279, 110, '2015-04-01 00:37:43.000000', 'temperatura', 445.0000, 'ºC'),
	(130280, 110, '2015-04-01 00:37:44.000000', 'temperatura', 219.0000, 'ºC'),
	(130281, 110, '2015-04-01 00:37:45.000000', 'temperatura', 961.0000, 'ºC'),
	(130282, 110, '2015-04-01 00:37:46.000000', 'temperatura', 546.0000, 'ºC'),
	(130283, 110, '2015-04-01 00:37:47.000000', 'temperatura', 1051.0000, 'ºC'),
	(130284, 110, '2015-04-01 00:37:48.000000', 'temperatura', 14.0000, 'ºC'),
	(130285, 110, '2015-04-01 00:37:49.000000', 'temperatura', 518.0000, 'ºC'),
	(130286, 110, '2015-04-01 00:37:50.000000', 'temperatura', 148.0000, 'ºC'),
	(130287, 110, '2015-04-01 00:37:51.000000', 'temperatura', 389.0000, 'ºC'),
	(130288, 110, '2015-04-01 00:37:52.000000', 'temperatura', 301.0000, 'ºC'),
	(130289, 110, '2015-04-01 00:37:53.000000', 'temperatura', 339.0000, 'ºC'),
	(130290, 110, '2015-04-01 00:37:54.000000', 'temperatura', 793.0000, 'ºC'),
	(130291, 110, '2015-04-01 00:37:55.000000', 'temperatura', 546.0000, 'ºC'),
	(130292, 110, '2015-04-01 00:37:56.000000', 'temperatura', 352.0000, 'ºC'),
	(130293, 110, '2015-04-01 00:37:57.000000', 'temperatura', 122.0000, 'ºC'),
	(130294, 110, '2015-04-01 00:37:58.000000', 'temperatura', 757.0000, 'ºC'),
	(130295, 110, '2015-04-01 00:37:59.000000', 'temperatura', 1017.0000, 'ºC'),
	(130296, 110, '2015-04-01 00:38:00.000000', 'temperatura', 417.0000, 'ºC'),
	(130297, 110, '2015-04-01 00:38:01.000000', 'temperatura', 232.0000, 'ºC'),
	(130298, 110, '2015-04-01 00:38:02.000000', 'temperatura', 1109.0000, 'ºC'),
	(130299, 110, '2015-04-01 00:38:03.000000', 'temperatura', 52.0000, 'ºC'),
	(130300, 110, '2015-04-01 00:38:04.000000', 'temperatura', 532.0000, 'ºC'),
	(130301, 110, '2015-04-01 00:38:05.000000', 'temperatura', 107.0000, 'ºC'),
	(130302, 110, '2015-04-01 00:38:06.000000', 'temperatura', 137.0000, 'ºC'),
	(130303, 110, '2015-04-01 00:38:07.000000', 'temperatura', 367.0000, 'ºC'),
	(130304, 110, '2015-04-01 00:38:08.000000', 'temperatura', 221.0000, 'ºC'),
	(130305, 110, '2015-04-01 00:38:09.000000', 'temperatura', 7.0000, 'ºC'),
	(130306, 110, '2015-04-01 00:38:10.000000', 'temperatura', 571.0000, 'ºC'),
	(130307, 110, '2015-04-01 00:38:11.000000', 'temperatura', 436.0000, 'ºC'),
	(130308, 110, '2015-04-01 00:38:12.000000', 'temperatura', 468.0000, 'ºC'),
	(130309, 110, '2015-04-01 00:38:13.000000', 'temperatura', 1031.0000, 'ºC'),
	(130310, 110, '2015-04-01 00:38:14.000000', 'temperatura', 153.0000, 'ºC'),
	(130311, 110, '2015-04-01 00:38:15.000000', 'temperatura', 72.0000, 'ºC'),
	(130312, 110, '2015-04-01 00:38:16.000000', 'temperatura', 1100.0000, 'ºC'),
	(130313, 110, '2015-04-01 00:38:17.000000', 'temperatura', 485.0000, 'ºC'),
	(130314, 110, '2015-04-01 00:38:18.000000', 'temperatura', 326.0000, 'ºC'),
	(130315, 110, '2015-04-01 00:38:19.000000', 'temperatura', 177.0000, 'ºC'),
	(130316, 110, '2015-04-01 00:38:20.000000', 'temperatura', 1105.0000, 'ºC'),
	(130317, 110, '2015-04-01 00:38:21.000000', 'temperatura', 195.0000, 'ºC'),
	(130318, 110, '2015-04-01 00:38:22.000000', 'temperatura', 62.0000, 'ºC'),
	(130319, 110, '2015-04-01 00:38:23.000000', 'temperatura', 925.0000, 'ºC'),
	(130320, 110, '2015-04-01 00:38:24.000000', 'temperatura', 841.0000, 'ºC'),
	(130321, 110, '2015-04-01 00:38:25.000000', 'temperatura', 229.0000, 'ºC'),
	(130322, 110, '2015-04-01 00:38:26.000000', 'temperatura', 1024.0000, 'ºC'),
	(130323, 110, '2015-04-01 00:38:27.000000', 'temperatura', 831.0000, 'ºC'),
	(130324, 110, '2015-04-01 00:38:28.000000', 'temperatura', 1083.0000, 'ºC'),
	(130325, 110, '2015-04-01 00:38:29.000000', 'temperatura', 525.0000, 'ºC'),
	(130326, 110, '2015-04-01 00:38:30.000000', 'temperatura', 575.0000, 'ºC'),
	(130327, 110, '2015-04-01 00:38:31.000000', 'temperatura', 99.0000, 'ºC'),
	(130328, 110, '2015-04-01 00:38:32.000000', 'temperatura', 1173.0000, 'ºC'),
	(130329, 110, '2015-04-01 00:38:33.000000', 'temperatura', 767.0000, 'ºC'),
	(130330, 110, '2015-04-01 00:38:34.000000', 'temperatura', 317.0000, 'ºC'),
	(130331, 110, '2015-04-01 00:38:35.000000', 'temperatura', 483.0000, 'ºC'),
	(130332, 110, '2015-04-01 00:38:36.000000', 'temperatura', 264.0000, 'ºC'),
	(130333, 110, '2015-04-01 00:38:37.000000', 'temperatura', 1071.0000, 'ºC'),
	(130334, 110, '2015-04-01 00:38:38.000000', 'temperatura', 964.0000, 'ºC'),
	(130335, 110, '2015-04-01 00:38:39.000000', 'temperatura', 406.0000, 'ºC'),
	(130336, 110, '2015-04-01 00:38:40.000000', 'temperatura', 340.0000, 'ºC'),
	(130337, 110, '2015-04-01 00:38:41.000000', 'temperatura', 481.0000, 'ºC'),
	(130338, 110, '2015-04-01 00:38:42.000000', 'temperatura', 188.0000, 'ºC'),
	(130339, 110, '2015-04-01 00:38:43.000000', 'temperatura', 696.0000, 'ºC'),
	(130340, 110, '2015-04-01 00:38:44.000000', 'temperatura', 519.0000, 'ºC'),
	(130341, 110, '2015-04-01 00:38:45.000000', 'temperatura', 505.0000, 'ºC'),
	(130342, 110, '2015-04-01 00:38:46.000000', 'temperatura', 971.0000, 'ºC'),
	(130343, 110, '2015-04-01 00:38:47.000000', 'temperatura', 938.0000, 'ºC'),
	(130344, 110, '2015-04-01 00:38:48.000000', 'temperatura', 577.0000, 'ºC'),
	(130345, 110, '2015-04-01 00:38:49.000000', 'temperatura', 72.0000, 'ºC'),
	(130346, 110, '2015-04-01 00:38:50.000000', 'temperatura', 1029.0000, 'ºC'),
	(130347, 110, '2015-04-01 00:38:51.000000', 'temperatura', 130.0000, 'ºC'),
	(130348, 110, '2015-04-01 00:38:52.000000', 'temperatura', 1162.0000, 'ºC'),
	(130349, 110, '2015-04-01 00:38:53.000000', 'temperatura', 620.0000, 'ºC'),
	(130350, 110, '2015-04-01 00:38:54.000000', 'temperatura', 816.0000, 'ºC'),
	(130351, 110, '2015-04-01 00:38:55.000000', 'temperatura', 1018.0000, 'ºC'),
	(130352, 110, '2015-04-01 00:38:56.000000', 'temperatura', 245.0000, 'ºC'),
	(130353, 110, '2015-04-01 00:38:57.000000', 'temperatura', 571.0000, 'ºC'),
	(130354, 110, '2015-04-01 00:38:58.000000', 'temperatura', 922.0000, 'ºC'),
	(130355, 110, '2015-04-01 00:38:59.000000', 'temperatura', 496.0000, 'ºC'),
	(130356, 110, '2015-04-01 00:39:00.000000', 'temperatura', 916.0000, 'ºC'),
	(130357, 110, '2015-04-01 00:39:01.000000', 'temperatura', 691.0000, 'ºC'),
	(130358, 110, '2015-04-01 00:39:02.000000', 'temperatura', 709.0000, 'ºC'),
	(130359, 110, '2015-04-01 00:39:03.000000', 'temperatura', 274.0000, 'ºC'),
	(130360, 110, '2015-04-01 00:39:04.000000', 'temperatura', 441.0000, 'ºC'),
	(130361, 110, '2015-04-01 00:39:05.000000', 'temperatura', 183.0000, 'ºC'),
	(130362, 110, '2015-04-01 00:39:06.000000', 'temperatura', 793.0000, 'ºC'),
	(130363, 110, '2015-04-01 00:39:07.000000', 'temperatura', 1015.0000, 'ºC'),
	(130364, 110, '2015-04-01 00:39:08.000000', 'temperatura', 297.0000, 'ºC'),
	(130365, 110, '2015-04-01 00:39:09.000000', 'temperatura', 840.0000, 'ºC'),
	(130366, 110, '2015-04-01 00:39:10.000000', 'temperatura', 909.0000, 'ºC'),
	(130367, 110, '2015-04-01 00:39:11.000000', 'temperatura', 828.0000, 'ºC'),
	(130368, 110, '2015-04-01 00:39:12.000000', 'temperatura', 214.0000, 'ºC'),
	(130369, 110, '2015-04-01 00:39:13.000000', 'temperatura', 986.0000, 'ºC'),
	(130370, 110, '2015-04-01 00:39:14.000000', 'temperatura', 690.0000, 'ºC'),
	(130371, 110, '2015-04-01 00:39:15.000000', 'temperatura', 490.0000, 'ºC'),
	(130372, 110, '2015-04-01 00:39:16.000000', 'temperatura', 381.0000, 'ºC'),
	(130373, 110, '2015-04-01 00:39:17.000000', 'temperatura', 436.0000, 'ºC'),
	(130374, 110, '2015-04-01 00:39:18.000000', 'temperatura', 1036.0000, 'ºC'),
	(130375, 110, '2015-04-01 00:39:19.000000', 'temperatura', 275.0000, 'ºC'),
	(130376, 110, '2015-04-01 00:39:20.000000', 'temperatura', 668.0000, 'ºC'),
	(130377, 110, '2015-04-01 00:39:21.000000', 'temperatura', 113.0000, 'ºC'),
	(130378, 110, '2015-04-01 00:39:22.000000', 'temperatura', 964.0000, 'ºC'),
	(130379, 110, '2015-04-01 00:39:23.000000', 'temperatura', 881.0000, 'ºC'),
	(130380, 110, '2015-04-01 00:39:24.000000', 'temperatura', 314.0000, 'ºC'),
	(130381, 110, '2015-04-01 00:39:25.000000', 'temperatura', 125.0000, 'ºC'),
	(130382, 110, '2015-04-01 00:39:26.000000', 'temperatura', 885.0000, 'ºC'),
	(130383, 110, '2015-04-01 00:39:27.000000', 'temperatura', 450.0000, 'ºC'),
	(130384, 110, '2015-04-01 00:39:28.000000', 'temperatura', 796.0000, 'ºC'),
	(130385, 110, '2015-04-01 00:39:29.000000', 'temperatura', 231.0000, 'ºC'),
	(130386, 110, '2015-04-01 00:39:30.000000', 'temperatura', 1168.0000, 'ºC'),
	(130387, 110, '2015-04-01 00:39:31.000000', 'temperatura', 349.0000, 'ºC'),
	(130388, 110, '2015-04-01 00:39:32.000000', 'temperatura', 639.0000, 'ºC'),
	(130389, 110, '2015-04-01 00:39:33.000000', 'temperatura', 949.0000, 'ºC'),
	(130390, 110, '2015-04-01 00:39:34.000000', 'temperatura', 427.0000, 'ºC'),
	(130391, 110, '2015-04-01 00:39:35.000000', 'temperatura', 488.0000, 'ºC'),
	(130392, 110, '2015-04-01 00:39:36.000000', 'temperatura', 1160.0000, 'ºC'),
	(130393, 110, '2015-04-01 00:39:37.000000', 'temperatura', 736.0000, 'ºC'),
	(130394, 110, '2015-04-01 00:39:38.000000', 'temperatura', 203.0000, 'ºC'),
	(130395, 110, '2015-04-01 00:39:39.000000', 'temperatura', 6.0000, 'ºC'),
	(130396, 110, '2015-04-01 00:39:40.000000', 'temperatura', 623.0000, 'ºC'),
	(130397, 110, '2015-04-01 00:39:41.000000', 'temperatura', 697.0000, 'ºC'),
	(130398, 110, '2015-04-01 00:39:42.000000', 'temperatura', 416.0000, 'ºC'),
	(130399, 110, '2015-04-01 00:39:43.000000', 'temperatura', 1188.0000, 'ºC'),
	(130400, 110, '2015-04-01 00:39:44.000000', 'temperatura', 1095.0000, 'ºC'),
	(130401, 110, '2015-04-01 00:39:45.000000', 'temperatura', 709.0000, 'ºC'),
	(130402, 110, '2015-04-01 00:39:46.000000', 'temperatura', 260.0000, 'ºC'),
	(130403, 110, '2015-04-01 00:39:47.000000', 'temperatura', 374.0000, 'ºC'),
	(130404, 110, '2015-04-01 00:39:48.000000', 'temperatura', 1092.0000, 'ºC'),
	(130405, 110, '2015-04-01 00:39:49.000000', 'temperatura', 738.0000, 'ºC'),
	(130406, 110, '2015-04-01 00:39:50.000000', 'temperatura', 414.0000, 'ºC'),
	(130407, 110, '2015-04-01 00:39:51.000000', 'temperatura', 1057.0000, 'ºC'),
	(130408, 110, '2015-04-01 00:39:52.000000', 'temperatura', 444.0000, 'ºC'),
	(130409, 110, '2015-04-01 00:39:53.000000', 'temperatura', 248.0000, 'ºC'),
	(130410, 110, '2015-04-01 00:39:54.000000', 'temperatura', 1111.0000, 'ºC'),
	(130411, 110, '2015-04-01 00:39:55.000000', 'temperatura', 10.0000, 'ºC'),
	(130412, 110, '2015-04-01 00:39:56.000000', 'temperatura', 316.0000, 'ºC'),
	(130413, 110, '2015-04-01 00:39:57.000000', 'temperatura', 353.0000, 'ºC'),
	(130414, 110, '2015-04-01 00:39:58.000000', 'temperatura', 818.0000, 'ºC'),
	(130415, 110, '2015-04-01 00:39:59.000000', 'temperatura', 631.0000, 'ºC'),
	(130416, 110, '2015-04-01 00:40:00.000000', 'temperatura', 702.0000, 'ºC'),
	(130417, 110, '2015-04-01 00:40:01.000000', 'temperatura', 419.0000, 'ºC'),
	(130418, 110, '2015-04-01 00:40:02.000000', 'temperatura', 1187.0000, 'ºC'),
	(130419, 110, '2015-04-01 00:40:03.000000', 'temperatura', 1081.0000, 'ºC'),
	(130420, 110, '2015-04-01 00:40:04.000000', 'temperatura', 642.0000, 'ºC'),
	(130421, 110, '2015-04-01 00:40:05.000000', 'temperatura', 1168.0000, 'ºC'),
	(130422, 110, '2015-04-01 00:40:06.000000', 'temperatura', 313.0000, 'ºC'),
	(130423, 110, '2015-04-01 00:40:07.000000', 'temperatura', 462.0000, 'ºC'),
	(130424, 110, '2015-04-01 00:40:08.000000', 'temperatura', 173.0000, 'ºC'),
	(130425, 110, '2015-04-01 00:40:09.000000', 'temperatura', 680.0000, 'ºC'),
	(130426, 110, '2015-04-01 00:40:10.000000', 'temperatura', 480.0000, 'ºC'),
	(130427, 110, '2015-04-01 00:40:11.000000', 'temperatura', 361.0000, 'ºC'),
	(130428, 110, '2015-04-01 00:40:12.000000', 'temperatura', 366.0000, 'ºC'),
	(130429, 110, '2015-04-01 00:40:13.000000', 'temperatura', 747.0000, 'ºC'),
	(130430, 110, '2015-04-01 00:40:14.000000', 'temperatura', 239.0000, 'ºC'),
	(130431, 110, '2015-04-01 00:40:15.000000', 'temperatura', 154.0000, 'ºC'),
	(130432, 110, '2015-04-01 00:40:16.000000', 'temperatura', 53.0000, 'ºC'),
	(130433, 110, '2015-04-01 00:40:17.000000', 'temperatura', 1005.0000, 'ºC'),
	(130434, 110, '2015-04-01 00:40:18.000000', 'temperatura', 65.0000, 'ºC'),
	(130435, 110, '2015-04-01 00:40:19.000000', 'temperatura', 913.0000, 'ºC'),
	(130436, 110, '2015-04-01 00:40:20.000000', 'temperatura', 769.0000, 'ºC'),
	(130437, 110, '2015-04-01 00:40:21.000000', 'temperatura', 1106.0000, 'ºC'),
	(130438, 110, '2015-04-01 00:40:22.000000', 'temperatura', 826.0000, 'ºC'),
	(130439, 110, '2015-04-01 00:40:23.000000', 'temperatura', 810.0000, 'ºC'),
	(130440, 110, '2015-04-01 00:40:24.000000', 'temperatura', 372.0000, 'ºC'),
	(130441, 110, '2015-04-01 00:40:25.000000', 'temperatura', 630.0000, 'ºC'),
	(130442, 110, '2015-04-01 00:40:26.000000', 'temperatura', 835.0000, 'ºC'),
	(130443, 110, '2015-04-01 00:40:27.000000', 'temperatura', 1086.0000, 'ºC'),
	(130444, 110, '2015-04-01 00:40:28.000000', 'temperatura', 526.0000, 'ºC'),
	(130445, 110, '2015-04-01 00:40:29.000000', 'temperatura', 572.0000, 'ºC'),
	(130446, 110, '2015-04-01 00:40:30.000000', 'temperatura', 82.0000, 'ºC'),
	(130447, 110, '2015-04-01 00:40:31.000000', 'temperatura', 1094.0000, 'ºC'),
	(130448, 110, '2015-04-01 00:40:32.000000', 'temperatura', 424.0000, 'ºC'),
	(130449, 110, '2015-04-01 00:40:33.000000', 'temperatura', 40.0000, 'ºC'),
	(130450, 110, '2015-04-01 00:40:34.000000', 'temperatura', 129.0000, 'ºC'),
	(130451, 110, '2015-04-01 00:40:35.000000', 'temperatura', 523.0000, 'ºC'),
	(130452, 110, '2015-04-01 00:40:36.000000', 'temperatura', 1031.0000, 'ºC'),
	(130453, 110, '2015-04-01 00:40:37.000000', 'temperatura', 1184.0000, 'ºC'),
	(130454, 110, '2015-04-01 00:40:38.000000', 'temperatura', 428.0000, 'ºC'),
	(130455, 110, '2015-04-01 00:40:39.000000', 'temperatura', 988.0000, 'ºC'),
	(130456, 110, '2015-04-01 00:40:40.000000', 'temperatura', 56.0000, 'ºC'),
	(130457, 110, '2015-04-01 00:40:41.000000', 'temperatura', 917.0000, 'ºC'),
	(130458, 110, '2015-04-01 00:40:42.000000', 'temperatura', 819.0000, 'ºC'),
	(130459, 110, '2015-04-01 00:40:43.000000', 'temperatura', 142.0000, 'ºC'),
	(130460, 110, '2015-04-01 00:40:44.000000', 'temperatura', 656.0000, 'ºC'),
	(130461, 110, '2015-04-01 00:40:45.000000', 'temperatura', 455.0000, 'ºC'),
	(130462, 110, '2015-04-01 00:40:46.000000', 'temperatura', 307.0000, 'ºC'),
	(130463, 110, '2015-04-01 00:40:47.000000', 'temperatura', 169.0000, 'ºC'),
	(130464, 110, '2015-04-01 00:40:48.000000', 'temperatura', 1125.0000, 'ºC'),
	(130465, 110, '2015-04-01 00:40:49.000000', 'temperatura', 317.0000, 'ºC'),
	(130466, 110, '2015-04-01 00:40:50.000000', 'temperatura', 612.0000, 'ºC'),
	(130467, 110, '2015-04-01 00:40:51.000000', 'temperatura', 909.0000, 'ºC'),
	(130468, 110, '2015-04-01 00:40:52.000000', 'temperatura', 310.0000, 'ºC'),
	(130469, 110, '2015-04-01 00:40:53.000000', 'temperatura', 25.0000, 'ºC'),
	(130470, 110, '2015-04-01 00:40:54.000000', 'temperatura', 396.0000, 'ºC'),
	(130471, 110, '2015-04-01 00:40:55.000000', 'temperatura', 703.0000, 'ºC'),
	(130472, 110, '2015-04-01 00:40:56.000000', 'temperatura', 1128.0000, 'ºC'),
	(130473, 110, '2015-04-01 00:40:57.000000', 'temperatura', 1131.0000, 'ºC'),
	(130474, 110, '2015-04-01 00:40:58.000000', 'temperatura', 1073.0000, 'ºC'),
	(130475, 110, '2015-04-01 00:40:59.000000', 'temperatura', 773.0000, 'ºC'),
	(130476, 110, '2015-04-01 00:41:00.000000', 'temperatura', 645.0000, 'ºC'),
	(130477, 110, '2015-04-01 00:41:01.000000', 'temperatura', 905.0000, 'ºC'),
	(130478, 110, '2015-04-01 00:41:02.000000', 'temperatura', 191.0000, 'ºC'),
	(130479, 110, '2015-04-01 00:41:03.000000', 'temperatura', 643.0000, 'ºC'),
	(130480, 110, '2015-04-01 00:41:04.000000', 'temperatura', 242.0000, 'ºC'),
	(130481, 110, '2015-04-01 00:41:05.000000', 'temperatura', 479.0000, 'ºC'),
	(130482, 110, '2015-04-01 00:41:06.000000', 'temperatura', 472.0000, 'ºC'),
	(130483, 110, '2015-04-01 00:41:07.000000', 'temperatura', 924.0000, 'ºC'),
	(130484, 110, '2015-04-01 00:41:08.000000', 'temperatura', 803.0000, 'ºC'),
	(130485, 110, '2015-04-01 00:41:09.000000', 'temperatura', 44.0000, 'ºC'),
	(130486, 110, '2015-04-01 00:41:10.000000', 'temperatura', 213.0000, 'ºC'),
	(130487, 110, '2015-04-01 00:41:11.000000', 'temperatura', 934.0000, 'ºC'),
	(130488, 110, '2015-04-01 00:41:12.000000', 'temperatura', 432.0000, 'ºC'),
	(130489, 110, '2015-04-01 00:41:13.000000', 'temperatura', 557.0000, 'ºC'),
	(130490, 110, '2015-04-01 00:41:14.000000', 'temperatura', 289.0000, 'ºC'),
	(130491, 110, '2015-04-01 00:41:15.000000', 'temperatura', 977.0000, 'ºC'),
	(130492, 110, '2015-04-01 00:41:16.000000', 'temperatura', 416.0000, 'ºC'),
	(130493, 110, '2015-04-01 00:41:17.000000', 'temperatura', 352.0000, 'ºC'),
	(130494, 110, '2015-04-01 00:41:18.000000', 'temperatura', 513.0000, 'ºC'),
	(130495, 110, '2015-04-01 00:41:19.000000', 'temperatura', 309.0000, 'ºC'),
	(130496, 110, '2015-04-01 00:41:20.000000', 'temperatura', 6.0000, 'ºC'),
	(130497, 110, '2015-04-01 00:41:21.000000', 'temperatura', 303.0000, 'ºC'),
	(130498, 110, '2015-04-01 00:41:22.000000', 'temperatura', 297.0000, 'ºC'),
	(130499, 110, '2015-04-01 00:41:23.000000', 'temperatura', 578.0000, 'ºC'),
	(130500, 110, '2015-04-01 00:41:24.000000', 'temperatura', 798.0000, 'ºC'),
	(130501, 110, '2015-04-01 00:41:25.000000', 'temperatura', 1057.0000, 'ºC'),
	(130502, 110, '2015-04-01 00:41:26.000000', 'temperatura', 491.0000, 'ºC'),
	(130503, 110, '2015-04-01 00:41:27.000000', 'temperatura', 486.0000, 'ºC'),
	(130504, 110, '2015-04-01 00:41:28.000000', 'temperatura', 957.0000, 'ºC'),
	(130505, 110, '2015-04-01 00:41:29.000000', 'temperatura', 928.0000, 'ºC'),
	(130506, 110, '2015-04-01 00:41:30.000000', 'temperatura', 568.0000, 'ºC'),
	(130507, 110, '2015-04-01 00:41:31.000000', 'temperatura', 58.0000, 'ºC'),
	(130508, 110, '2015-04-01 00:41:32.000000', 'temperatura', 984.0000, 'ºC'),
	(130509, 110, '2015-04-01 00:41:33.000000', 'temperatura', 1148.0000, 'ºC'),
	(130510, 110, '2015-04-01 00:41:34.000000', 'temperatura', 389.0000, 'ºC'),
	(130511, 110, '2015-04-01 00:41:35.000000', 'temperatura', 903.0000, 'ºC'),
	(130512, 110, '2015-04-01 00:41:36.000000', 'temperatura', 946.0000, 'ºC'),
	(130513, 110, '2015-04-01 00:41:37.000000', 'temperatura', 822.0000, 'ºC'),
	(130514, 110, '2015-04-01 00:41:38.000000', 'temperatura', 74.0000, 'ºC'),
	(130515, 110, '2015-04-01 00:41:39.000000', 'temperatura', 302.0000, 'ºC'),
	(130516, 110, '2015-04-01 00:41:40.000000', 'temperatura', 88.0000, 'ºC'),
	(130517, 110, '2015-04-01 00:41:41.000000', 'temperatura', 736.0000, 'ºC'),
	(130518, 110, '2015-04-01 00:41:42.000000', 'temperatura', 1015.0000, 'ºC'),
	(130519, 110, '2015-04-01 00:41:43.000000', 'temperatura', 468.0000, 'ºC'),
	(130520, 110, '2015-04-01 00:41:44.000000', 'temperatura', 497.0000, 'ºC'),
	(130521, 110, '2015-04-01 00:41:45.000000', 'temperatura', 1082.0000, 'ºC'),
	(130522, 110, '2015-04-01 00:41:46.000000', 'temperatura', 317.0000, 'ºC'),
	(130523, 110, '2015-04-01 00:41:47.000000', 'temperatura', 741.0000, 'ºC'),
	(130524, 110, '2015-04-01 00:41:48.000000', 'temperatura', 352.0000, 'ºC'),
	(130525, 110, '2015-04-01 00:41:49.000000', 'temperatura', 741.0000, 'ºC'),
	(130526, 110, '2015-04-01 00:41:50.000000', 'temperatura', 246.0000, 'ºC'),
	(130527, 110, '2015-04-01 00:41:51.000000', 'temperatura', 210.0000, 'ºC'),
	(130528, 110, '2015-04-01 00:41:52.000000', 'temperatura', 310.0000, 'ºC'),
	(130529, 110, '2015-04-01 00:41:53.000000', 'temperatura', 923.0000, 'ºC'),
	(130530, 110, '2015-04-01 00:41:54.000000', 'temperatura', 85.0000, 'ºC'),
	(130531, 110, '2015-04-01 00:41:55.000000', 'temperatura', 58.0000, 'ºC'),
	(130532, 110, '2015-04-01 00:41:56.000000', 'temperatura', 35.0000, 'ºC'),
	(130533, 110, '2015-04-01 00:41:57.000000', 'temperatura', 0.0000, 'ºC'),
	(130534, 110, '2015-04-01 00:41:58.000000', 'temperatura', 1098.0000, 'ºC'),
	(130535, 110, '2015-04-01 00:41:59.000000', 'temperatura', 688.0000, 'ºC'),
	(130536, 110, '2015-04-01 00:42:00.000000', 'temperatura', 149.0000, 'ºC'),
	(130537, 110, '2015-04-01 00:42:01.000000', 'temperatura', 1079.0000, 'ºC'),
	(130538, 110, '2015-04-01 00:42:02.000000', 'temperatura', 151.0000, 'ºC'),
	(130539, 110, '2015-04-01 00:42:03.000000', 'temperatura', 1116.0000, 'ºC'),
	(130540, 110, '2015-04-01 00:42:04.000000', 'temperatura', 328.0000, 'ºC'),
	(130541, 110, '2015-04-01 00:42:05.000000', 'temperatura', 694.0000, 'ºC'),
	(130542, 110, '2015-04-01 00:42:06.000000', 'temperatura', 86.0000, 'ºC'),
	(130543, 110, '2015-04-01 00:42:07.000000', 'temperatura', 750.0000, 'ºC'),
	(130544, 110, '2015-04-01 00:42:08.000000', 'temperatura', 1091.0000, 'ºC'),
	(130545, 110, '2015-04-01 00:42:09.000000', 'temperatura', 808.0000, 'ºC'),
	(130546, 110, '2015-04-01 00:42:10.000000', 'temperatura', 764.0000, 'ºC'),
	(130547, 110, '2015-04-01 00:42:11.000000', 'temperatura', 199.0000, 'ºC'),
	(130548, 110, '2015-04-01 00:42:12.000000', 'temperatura', 1104.0000, 'ºC'),
	(130549, 110, '2015-04-01 00:42:13.000000', 'temperatura', 123.0000, 'ºC'),
	(130550, 110, '2015-04-01 00:42:14.000000', 'temperatura', 903.0000, 'ºC'),
	(130551, 110, '2015-04-01 00:42:15.000000', 'temperatura', 545.0000, 'ºC'),
	(130552, 110, '2015-04-01 00:42:16.000000', 'temperatura', 19.0000, 'ºC'),
	(130553, 110, '2015-04-01 00:42:17.000000', 'temperatura', 860.0000, 'ºC'),
	(130554, 110, '2015-04-01 00:42:18.000000', 'temperatura', 643.0000, 'ºC'),
	(130555, 110, '2015-04-01 00:42:19.000000', 'temperatura', 637.0000, 'ºC'),
	(130556, 110, '2015-04-01 00:42:20.000000', 'temperatura', 56.0000, 'ºC'),
	(130557, 110, '2015-04-01 00:42:21.000000', 'temperatura', 771.0000, 'ºC'),
	(130558, 110, '2015-04-01 00:42:22.000000', 'temperatura', 86.0000, 'ºC'),
	(130559, 110, '2015-04-01 00:42:23.000000', 'temperatura', 516.0000, 'ºC'),
	(130560, 110, '2015-04-01 00:42:24.000000', 'temperatura', 1122.0000, 'ºC'),
	(130561, 110, '2015-04-01 00:42:25.000000', 'temperatura', 462.0000, 'ºC'),
	(130562, 110, '2015-04-01 00:42:26.000000', 'temperatura', 145.0000, 'ºC'),
	(130563, 110, '2015-04-01 00:42:27.000000', 'temperatura', 540.0000, 'ºC'),
	(130564, 110, '2015-04-01 00:42:28.000000', 'temperatura', 1065.0000, 'ºC'),
	(130565, 110, '2015-04-01 00:42:29.000000', 'temperatura', 106.0000, 'ºC'),
	(130566, 110, '2015-04-01 00:42:30.000000', 'temperatura', 936.0000, 'ºC'),
	(130567, 110, '2015-04-01 00:42:31.000000', 'temperatura', 763.0000, 'ºC'),
	(130568, 110, '2015-04-01 00:42:32.000000', 'temperatura', 1008.0000, 'ºC'),
	(130569, 110, '2015-04-01 00:42:33.000000', 'temperatura', 352.0000, 'ºC'),
	(130570, 110, '2015-04-01 00:42:34.000000', 'temperatura', 1134.0000, 'ºC'),
	(130571, 110, '2015-04-01 00:42:35.000000', 'temperatura', 1017.0000, 'ºC'),
	(130572, 110, '2015-04-01 00:42:36.000000', 'temperatura', 485.0000, 'ºC'),
	(130573, 110, '2015-04-01 00:42:37.000000', 'temperatura', 571.0000, 'ºC'),
	(130574, 110, '2015-04-01 00:42:38.000000', 'temperatura', 203.0000, 'ºC'),
	(130575, 110, '2015-04-01 00:42:39.000000', 'temperatura', 500.0000, 'ºC'),
	(130576, 110, '2015-04-01 00:42:40.000000', 'temperatura', 695.0000, 'ºC'),
	(130577, 110, '2015-04-01 00:42:41.000000', 'temperatura', 772.0000, 'ºC'),
	(130578, 110, '2015-04-01 00:42:42.000000', 'temperatura', 578.0000, 'ºC'),
	(130579, 110, '2015-04-01 00:42:43.000000', 'temperatura', 574.0000, 'ºC'),
	(130580, 110, '2015-04-01 00:42:44.000000', 'temperatura', 1137.0000, 'ºC'),
	(130581, 110, '2015-04-01 00:42:45.000000', 'temperatura', 364.0000, 'ºC'),
	(130582, 110, '2015-04-01 00:42:46.000000', 'temperatura', 808.0000, 'ºC'),
	(130583, 110, '2015-04-01 00:42:47.000000', 'temperatura', 549.0000, 'ºC'),
	(130584, 110, '2015-04-01 00:42:48.000000', 'temperatura', 323.0000, 'ºC'),
	(130585, 110, '2015-04-01 00:42:49.000000', 'temperatura', 1166.0000, 'ºC'),
	(130586, 110, '2015-04-01 00:42:50.000000', 'temperatura', 64.0000, 'ºC'),
	(130587, 110, '2015-04-01 00:42:51.000000', 'temperatura', 420.0000, 'ºC'),
	(130588, 110, '2015-04-01 00:42:52.000000', 'temperatura', 708.0000, 'ºC'),
	(130589, 110, '2015-04-01 00:42:53.000000', 'temperatura', 1080.0000, 'ºC'),
	(130590, 110, '2015-04-01 00:42:54.000000', 'temperatura', 877.0000, 'ºC'),
	(130591, 110, '2015-04-01 00:42:55.000000', 'temperatura', 1148.0000, 'ºC'),
	(130592, 110, '2015-04-01 00:42:56.000000', 'temperatura', 708.0000, 'ºC'),
	(130593, 110, '2015-04-01 00:42:57.000000', 'temperatura', 98.0000, 'ºC'),
	(130594, 110, '2015-04-01 00:42:58.000000', 'temperatura', 764.0000, 'ºC'),
	(130595, 110, '2015-04-01 00:42:59.000000', 'temperatura', 1129.0000, 'ºC'),
	(130596, 110, '2015-04-01 00:43:00.000000', 'temperatura', 953.0000, 'ºC'),
	(130597, 110, '2015-04-01 00:43:01.000000', 'temperatura', 177.0000, 'ºC'),
	(130598, 110, '2015-04-01 00:43:02.000000', 'temperatura', 427.0000, 'ºC'),
	(130599, 110, '2015-04-01 00:43:03.000000', 'temperatura', 403.0000, 'ºC'),
	(130600, 110, '2015-04-01 00:43:04.000000', 'temperatura', 736.0000, 'ºC'),
	(130601, 110, '2015-04-01 00:43:05.000000', 'temperatura', 70.0000, 'ºC'),
	(130602, 110, '2015-04-01 00:43:06.000000', 'temperatura', 542.0000, 'ºC'),
	(130603, 110, '2015-04-01 00:43:07.000000', 'temperatura', 101.0000, 'ºC'),
	(130604, 110, '2015-04-01 00:43:08.000000', 'temperatura', 80.0000, 'ºC'),
	(130605, 110, '2015-04-01 00:43:09.000000', 'temperatura', 97.0000, 'ºC'),
	(130606, 110, '2015-04-01 00:43:10.000000', 'temperatura', 244.0000, 'ºC'),
	(130607, 110, '2015-04-01 00:43:11.000000', 'temperatura', 932.0000, 'ºC'),
	(130608, 110, '2015-04-01 00:43:12.000000', 'temperatura', 329.0000, 'ºC'),
	(130609, 110, '2015-04-01 00:43:13.000000', 'temperatura', 50.0000, 'ºC'),
	(130610, 110, '2015-04-01 00:43:14.000000', 'temperatura', 461.0000, 'ºC'),
	(130611, 110, '2015-04-01 00:43:15.000000', 'temperatura', 956.0000, 'ºC'),
	(130612, 110, '2015-04-01 00:43:16.000000', 'temperatura', 998.0000, 'ºC'),
	(130613, 110, '2015-04-01 00:43:17.000000', 'temperatura', 924.0000, 'ºC'),
	(130614, 110, '2015-04-01 00:43:18.000000', 'temperatura', 425.0000, 'ºC'),
	(130615, 110, '2015-04-01 00:43:19.000000', 'temperatura', 552.0000, 'ºC'),
	(130616, 110, '2015-04-01 00:43:20.000000', 'temperatura', 288.0000, 'ºC'),
	(130617, 110, '2015-04-01 00:43:21.000000', 'temperatura', 985.0000, 'ºC'),
	(130618, 110, '2015-04-01 00:43:22.000000', 'temperatura', 459.0000, 'ºC'),
	(130619, 110, '2015-04-01 00:43:23.000000', 'temperatura', 542.0000, 'ºC'),
	(130620, 110, '2015-04-01 00:43:24.000000', 'temperatura', 132.0000, 'ºC'),
	(130621, 110, '2015-04-01 00:43:25.000000', 'temperatura', 237.0000, 'ºC'),
	(130622, 110, '2015-04-01 00:43:26.000000', 'temperatura', 788.0000, 'ºC'),
	(130623, 110, '2015-04-01 00:43:27.000000', 'temperatura', 830.0000, 'ºC'),
	(130624, 110, '2015-04-01 00:43:28.000000', 'temperatura', 585.0000, 'ºC'),
	(130625, 110, '2015-04-01 00:43:29.000000', 'temperatura', 436.0000, 'ºC'),
	(130626, 110, '2015-04-01 00:43:30.000000', 'temperatura', 425.0000, 'ºC'),
	(130627, 110, '2015-04-01 00:43:31.000000', 'temperatura', 817.0000, 'ºC'),
	(130628, 110, '2015-04-01 00:43:32.000000', 'temperatura', 411.0000, 'ºC'),
	(130629, 110, '2015-04-01 00:43:33.000000', 'temperatura', 806.0000, 'ºC'),
	(130630, 110, '2015-04-01 00:43:34.000000', 'temperatura', 395.0000, 'ºC'),
	(130631, 110, '2015-04-01 00:43:35.000000', 'temperatura', 758.0000, 'ºC'),
	(130632, 110, '2015-04-01 00:43:36.000000', 'temperatura', 205.0000, 'ºC'),
	(130633, 110, '2015-04-01 00:43:37.000000', 'temperatura', 1150.0000, 'ºC'),
	(130634, 110, '2015-04-01 00:43:38.000000', 'temperatura', 339.0000, 'ºC'),
	(130635, 110, '2015-04-01 00:43:39.000000', 'temperatura', 642.0000, 'ºC'),
	(130636, 110, '2015-04-01 00:43:40.000000', 'temperatura', 996.0000, 'ºC'),
	(130637, 110, '2015-04-01 00:43:41.000000', 'temperatura', 654.0000, 'ºC'),
	(130638, 110, '2015-04-01 00:43:42.000000', 'temperatura', 282.0000, 'ºC'),
	(130639, 110, '2015-04-01 00:43:43.000000', 'temperatura', 649.0000, 'ºC'),
	(130640, 110, '2015-04-01 00:43:44.000000', 'temperatura', 1199.0000, 'ºC'),
	(130641, 110, '2015-04-01 00:43:45.000000', 'temperatura', 450.0000, 'ºC'),
	(130642, 110, '2015-04-01 00:43:46.000000', 'temperatura', 1053.0000, 'ºC'),
	(130643, 110, '2015-04-01 00:43:47.000000', 'temperatura', 314.0000, 'ºC'),
	(130644, 110, '2015-04-01 00:43:48.000000', 'temperatura', 811.0000, 'ºC'),
	(130645, 110, '2015-04-01 00:43:49.000000', 'temperatura', 714.0000, 'ºC'),
	(130646, 110, '2015-04-01 00:43:50.000000', 'temperatura', 1138.0000, 'ºC'),
	(130647, 110, '2015-04-01 00:43:51.000000', 'temperatura', 1148.0000, 'ºC'),
	(130648, 110, '2015-04-01 00:43:52.000000', 'temperatura', 1126.0000, 'ºC'),
	(130649, 110, '2015-04-01 00:43:53.000000', 'temperatura', 989.0000, 'ºC'),
	(130650, 110, '2015-04-01 00:43:54.000000', 'temperatura', 365.0000, 'ºC'),
	(130651, 110, '2015-04-01 00:43:55.000000', 'temperatura', 57.0000, 'ºC'),
	(130652, 110, '2015-04-01 00:43:56.000000', 'temperatura', 394.0000, 'ºC'),
	(130653, 110, '2015-04-01 00:43:57.000000', 'temperatura', 598.0000, 'ºC'),
	(130654, 110, '2015-04-01 00:43:58.000000', 'temperatura', 609.0000, 'ºC'),
	(130655, 110, '2015-04-01 00:43:59.000000', 'temperatura', 50.0000, 'ºC'),
	(130656, 110, '2015-04-01 00:44:00.000000', 'temperatura', 825.0000, 'ºC'),
	(130657, 110, '2015-04-01 00:44:01.000000', 'temperatura', 377.0000, 'ºC'),
	(130658, 110, '2015-04-01 00:44:02.000000', 'temperatura', 608.0000, 'ºC'),
	(130659, 110, '2015-04-01 00:44:03.000000', 'temperatura', 711.0000, 'ºC'),
	(130660, 110, '2015-04-01 00:44:04.000000', 'temperatura', 529.0000, 'ºC'),
	(130661, 110, '2015-04-01 00:44:05.000000', 'temperatura', 515.0000, 'ºC'),
	(130662, 110, '2015-04-01 00:44:06.000000', 'temperatura', 988.0000, 'ºC'),
	(130663, 110, '2015-04-01 00:44:07.000000', 'temperatura', 994.0000, 'ºC'),
	(130664, 110, '2015-04-01 00:44:08.000000', 'temperatura', 807.0000, 'ºC'),
	(130665, 110, '2015-04-01 00:44:09.000000', 'temperatura', 1056.0000, 'ºC'),
	(130666, 110, '2015-04-01 00:44:10.000000', 'temperatura', 457.0000, 'ºC'),
	(130667, 110, '2015-04-01 00:44:11.000000', 'temperatura', 318.0000, 'ºC'),
	(130668, 110, '2015-04-01 00:44:12.000000', 'temperatura', 221.0000, 'ºC'),
	(130669, 110, '2015-04-01 00:44:13.000000', 'temperatura', 152.0000, 'ºC'),
	(130670, 110, '2015-04-01 00:44:14.000000', 'temperatura', 96.0000, 'ºC'),
	(130671, 110, '2015-04-01 00:44:15.000000', 'temperatura', 23.0000, 'ºC'),
	(130672, 110, '2015-04-01 00:44:16.000000', 'temperatura', 1028.0000, 'ºC'),
	(130673, 110, '2015-04-01 00:44:17.000000', 'temperatura', 273.0000, 'ºC'),
	(130674, 110, '2015-04-01 00:44:18.000000', 'temperatura', 682.0000, 'ºC'),
	(130675, 110, '2015-04-01 00:44:19.000000', 'temperatura', 192.0000, 'ºC'),
	(130676, 110, '2015-04-01 00:44:20.000000', 'temperatura', 112.0000, 'ºC'),
	(130677, 110, '2015-04-01 00:44:21.000000', 'temperatura', 1185.0000, 'ºC'),
	(130678, 110, '2015-04-01 00:44:22.000000', 'temperatura', 789.0000, 'ºC'),
	(130679, 110, '2015-04-01 00:44:23.000000', 'temperatura', 391.0000, 'ºC'),
	(130680, 110, '2015-04-01 00:44:24.000000', 'temperatura', 788.0000, 'ºC'),
	(130681, 110, '2015-04-01 00:44:25.000000', 'temperatura', 369.0000, 'ºC'),
	(130682, 110, '2015-04-01 00:44:26.000000', 'temperatura', 679.0000, 'ºC'),
	(130683, 110, '2015-04-01 00:44:27.000000', 'temperatura', 1089.0000, 'ºC'),
	(130684, 110, '2015-04-01 00:44:28.000000', 'temperatura', 1010.0000, 'ºC'),
	(130685, 110, '2015-04-01 00:44:29.000000', 'temperatura', 581.0000, 'ºC'),
	(130686, 110, '2015-04-01 00:44:30.000000', 'temperatura', 1078.0000, 'ºC'),
	(130687, 110, '2015-04-01 00:44:31.000000', 'temperatura', 45.0000, 'ºC'),
	(130688, 110, '2015-04-01 00:44:32.000000', 'temperatura', 593.0000, 'ºC'),
	(130689, 110, '2015-04-01 00:44:33.000000', 'temperatura', 429.0000, 'ºC'),
	(130690, 110, '2015-04-01 00:44:34.000000', 'temperatura', 366.0000, 'ºC'),
	(130691, 110, '2015-04-01 00:44:35.000000', 'temperatura', 545.0000, 'ºC'),
	(130692, 110, '2015-04-01 00:44:36.000000', 'temperatura', 426.0000, 'ºC'),
	(130693, 110, '2015-04-01 00:44:37.000000', 'temperatura', 496.0000, 'ºC'),
	(130694, 110, '2015-04-01 00:44:38.000000', 'temperatura', 2.0000, 'ºC'),
	(130695, 110, '2015-04-01 00:44:39.000000', 'temperatura', 925.0000, 'ºC'),
	(130696, 110, '2015-04-01 00:44:40.000000', 'temperatura', 1017.0000, 'ºC'),
	(130697, 110, '2015-04-01 00:44:41.000000', 'temperatura', 1110.0000, 'ºC'),
	(130698, 110, '2015-04-01 00:44:42.000000', 'temperatura', 101.0000, 'ºC'),
	(130699, 110, '2015-04-01 00:44:43.000000', 'temperatura', 776.0000, 'ºC'),
	(130700, 110, '2015-04-01 00:44:44.000000', 'temperatura', 1175.0000, 'ºC'),
	(130701, 110, '2015-04-01 00:44:45.000000', 'temperatura', 1150.0000, 'ºC'),
	(130702, 110, '2015-04-01 00:44:46.000000', 'temperatura', 1023.0000, 'ºC'),
	(130703, 110, '2015-04-01 00:44:47.000000', 'temperatura', 468.0000, 'ºC'),
	(130704, 110, '2015-04-01 00:44:48.000000', 'temperatura', 470.0000, 'ºC'),
	(130705, 110, '2015-04-01 00:44:49.000000', 'temperatura', 947.0000, 'ºC'),
	(130706, 110, '2015-04-01 00:44:50.000000', 'temperatura', 925.0000, 'ºC'),
	(130707, 110, '2015-04-01 00:44:51.000000', 'temperatura', 585.0000, 'ºC'),
	(130708, 110, '2015-04-01 00:44:52.000000', 'temperatura', 151.0000, 'ºC'),
	(130709, 110, '2015-04-01 00:44:53.000000', 'temperatura', 200.0000, 'ºC'),
	(130710, 110, '2015-04-01 00:44:54.000000', 'temperatura', 549.0000, 'ºC'),
	(130711, 110, '2015-04-01 00:44:55.000000', 'temperatura', 946.0000, 'ºC'),
	(130712, 110, '2015-04-01 00:44:56.000000', 'temperatura', 683.0000, 'ºC'),
	(130713, 110, '2015-04-01 00:44:57.000000', 'temperatura', 578.0000, 'ºC'),
	(130714, 110, '2015-04-01 00:44:58.000000', 'temperatura', 842.0000, 'ºC'),
	(130715, 110, '2015-04-01 00:44:59.000000', 'temperatura', 75.0000, 'ºC'),
	(130716, 110, '2015-04-01 00:45:00.000000', 'temperatura', 250.0000, 'ºC'),
	(130717, 110, '2015-04-01 00:45:01.000000', 'temperatura', 1026.0000, 'ºC'),
	(130718, 110, '2015-04-01 00:45:02.000000', 'temperatura', 778.0000, 'ºC'),
	(130719, 110, '2015-04-01 00:45:03.000000', 'temperatura', 815.0000, 'ºC'),
	(130720, 110, '2015-04-01 00:45:04.000000', 'temperatura', 540.0000, 'ºC'),
	(130721, 110, '2015-04-01 00:45:05.000000', 'temperatura', 254.0000, 'ºC'),
	(130722, 110, '2015-04-01 00:45:06.000000', 'temperatura', 854.0000, 'ºC'),
	(130723, 110, '2015-04-01 00:45:07.000000', 'temperatura', 1106.0000, 'ºC'),
	(130724, 110, '2015-04-01 00:45:08.000000', 'temperatura', 569.0000, 'ºC'),
	(130725, 110, '2015-04-01 00:45:09.000000', 'temperatura', 728.0000, 'ºC'),
	(130726, 110, '2015-04-01 00:45:10.000000', 'temperatura', 731.0000, 'ºC'),
	(130727, 110, '2015-04-01 00:45:11.000000', 'temperatura', 274.0000, 'ºC'),
	(130728, 110, '2015-04-01 00:45:12.000000', 'temperatura', 379.0000, 'ºC'),
	(130729, 110, '2015-04-01 00:45:13.000000', 'temperatura', 1070.0000, 'ºC'),
	(130730, 110, '2015-04-01 00:45:14.000000', 'temperatura', 615.0000, 'ºC'),
	(130731, 110, '2015-04-01 00:45:15.000000', 'temperatura', 1064.0000, 'ºC'),
	(130732, 110, '2015-04-01 00:45:16.000000', 'temperatura', 1075.0000, 'ºC'),
	(130733, 110, '2015-04-01 00:45:17.000000', 'temperatura', 986.0000, 'ºC'),
	(130734, 110, '2015-04-01 00:45:18.000000', 'temperatura', 503.0000, 'ºC'),
	(130735, 110, '2015-04-01 00:45:19.000000', 'temperatura', 759.0000, 'ºC'),
	(130736, 110, '2015-04-01 00:45:20.000000', 'temperatura', 1087.0000, 'ºC'),
	(130737, 110, '2015-04-01 00:45:21.000000', 'temperatura', 756.0000, 'ºC'),
	(130738, 110, '2015-04-01 00:45:22.000000', 'temperatura', 523.0000, 'ºC'),
	(130739, 110, '2015-04-01 00:45:23.000000', 'temperatura', 344.0000, 'ºC'),
	(130740, 110, '2015-04-01 00:45:24.000000', 'temperatura', 155.0000, 'ºC'),
	(130741, 110, '2015-04-01 00:45:25.000000', 'temperatura', 940.0000, 'ºC'),
	(130742, 110, '2015-04-01 00:45:26.000000', 'temperatura', 638.0000, 'ºC'),
	(130743, 110, '2015-04-01 00:45:27.000000', 'temperatura', 371.0000, 'ºC'),
	(130744, 110, '2015-04-01 00:45:28.000000', 'temperatura', 1141.0000, 'ºC'),
	(130745, 110, '2015-04-01 00:45:29.000000', 'temperatura', 993.0000, 'ºC'),
	(130746, 110, '2015-04-01 00:45:30.000000', 'temperatura', 340.0000, 'ºC'),
	(130747, 110, '2015-04-01 00:45:31.000000', 'temperatura', 1124.0000, 'ºC'),
	(130748, 110, '2015-04-01 00:45:32.000000', 'temperatura', 999.0000, 'ºC'),
	(130749, 110, '2015-04-01 00:45:33.000000', 'temperatura', 424.0000, 'ºC'),
	(130750, 110, '2015-04-01 00:45:34.000000', 'temperatura', 323.0000, 'ºC'),
	(130751, 110, '2015-04-01 00:45:35.000000', 'temperatura', 342.0000, 'ºC'),
	(130752, 110, '2015-04-01 00:45:36.000000', 'temperatura', 744.0000, 'ºC'),
	(130753, 110, '2015-04-01 00:45:37.000000', 'temperatura', 293.0000, 'ºC'),
	(130754, 110, '2015-04-01 00:45:38.000000', 'temperatura', 432.0000, 'ºC'),
	(130755, 110, '2015-04-01 00:45:39.000000', 'temperatura', 82.0000, 'ºC'),
	(130756, 110, '2015-04-01 00:45:40.000000', 'temperatura', 316.0000, 'ºC'),
	(130757, 110, '2015-04-01 00:45:41.000000', 'temperatura', 135.0000, 'ºC'),
	(130758, 110, '2015-04-01 00:45:42.000000', 'temperatura', 928.0000, 'ºC'),
	(130759, 110, '2015-04-01 00:45:43.000000', 'temperatura', 633.0000, 'ºC'),
	(130760, 110, '2015-04-01 00:45:44.000000', 'temperatura', 381.0000, 'ºC'),
	(130761, 110, '2015-04-01 00:45:45.000000', 'temperatura', 9.0000, 'ºC'),
	(130762, 110, '2015-04-01 00:45:46.000000', 'temperatura', 100.0000, 'ºC'),
	(130763, 110, '2015-04-01 00:45:47.000000', 'temperatura', 476.0000, 'ºC'),
	(130764, 110, '2015-04-01 00:45:48.000000', 'temperatura', 881.0000, 'ºC'),
	(130765, 110, '2015-04-01 00:45:49.000000', 'temperatura', 578.0000, 'ºC'),
	(130766, 110, '2015-04-01 00:45:50.000000', 'temperatura', 246.0000, 'ºC'),
	(130767, 110, '2015-04-01 00:45:51.000000', 'temperatura', 699.0000, 'ºC'),
	(130768, 110, '2015-04-01 00:45:52.000000', 'temperatura', 355.0000, 'ºC'),
	(130769, 110, '2015-04-01 00:45:53.000000', 'temperatura', 877.0000, 'ºC'),
	(130770, 110, '2015-04-01 00:45:54.000000', 'temperatura', 923.0000, 'ºC'),
	(130771, 110, '2015-04-01 00:45:55.000000', 'temperatura', 784.0000, 'ºC'),
	(130772, 110, '2015-04-01 00:45:56.000000', 'temperatura', 1150.0000, 'ºC'),
	(130773, 110, '2015-04-01 00:45:57.000000', 'temperatura', 1002.0000, 'ºC'),
	(130774, 110, '2015-04-01 00:45:58.000000', 'temperatura', 357.0000, 'ºC'),
	(130775, 110, '2015-04-01 00:45:59.000000', 'temperatura', 1180.0000, 'ºC'),
	(130776, 110, '2015-04-01 00:46:00.000000', 'temperatura', 31.0000, 'ºC'),
	(130777, 110, '2015-04-01 00:46:01.000000', 'temperatura', 215.0000, 'ºC'),
	(130778, 110, '2015-04-01 00:46:02.000000', 'temperatura', 982.0000, 'ºC'),
	(130779, 110, '2015-04-01 00:46:03.000000', 'temperatura', 666.0000, 'ºC'),
	(130780, 110, '2015-04-01 00:46:04.000000', 'temperatura', 385.0000, 'ºC'),
	(130781, 110, '2015-04-01 00:46:05.000000', 'temperatura', 1127.0000, 'ºC'),
	(130782, 110, '2015-04-01 00:46:06.000000', 'temperatura', 883.0000, 'ºC'),
	(130783, 110, '2015-04-01 00:46:07.000000', 'temperatura', 1031.0000, 'ºC'),
	(130784, 110, '2015-04-01 00:46:08.000000', 'temperatura', 109.0000, 'ºC'),
	(130785, 110, '2015-04-01 00:46:09.000000', 'temperatura', 1051.0000, 'ºC'),
	(130786, 110, '2015-04-01 00:46:10.000000', 'temperatura', 130.0000, 'ºC'),
	(130787, 110, '2015-04-01 00:46:11.000000', 'temperatura', 1095.0000, 'ºC'),
	(130788, 110, '2015-04-01 00:46:12.000000', 'temperatura', 288.0000, 'ºC'),
	(130789, 110, '2015-04-01 00:46:13.000000', 'temperatura', 556.0000, 'ºC'),
	(130790, 110, '2015-04-01 00:46:14.000000', 'temperatura', 715.0000, 'ºC'),
	(130791, 110, '2015-04-01 00:46:15.000000', 'temperatura', 708.0000, 'ºC'),
	(130792, 110, '2015-04-01 00:46:16.000000', 'temperatura', 194.0000, 'ºC'),
	(130793, 110, '2015-04-01 00:46:17.000000', 'temperatura', 47.0000, 'ºC'),
	(130794, 110, '2015-04-01 00:46:18.000000', 'temperatura', 853.0000, 'ºC'),
	(130795, 110, '2015-04-01 00:46:19.000000', 'temperatura', 525.0000, 'ºC'),
	(130796, 110, '2015-04-01 00:46:20.000000', 'temperatura', 66.0000, 'ºC'),
	(130797, 110, '2015-04-01 00:46:21.000000', 'temperatura', 1156.0000, 'ºC'),
	(130798, 110, '2015-04-01 00:46:22.000000', 'temperatura', 781.0000, 'ºC'),
	(130799, 110, '2015-04-01 00:46:23.000000', 'temperatura', 440.0000, 'ºC'),
	(130800, 110, '2015-04-01 00:46:24.000000', 'temperatura', 1055.0000, 'ºC'),
	(130801, 110, '2015-04-01 00:46:25.000000', 'temperatura', 355.0000, 'ºC'),
	(130802, 110, '2015-04-01 00:46:26.000000', 'temperatura', 1013.0000, 'ºC'),
	(130803, 110, '2015-04-01 00:46:27.000000', 'temperatura', 400.0000, 'ºC'),
	(130804, 110, '2015-04-01 00:46:28.000000', 'temperatura', 160.0000, 'ºC'),
	(130805, 110, '2015-04-01 00:46:29.000000', 'temperatura', 799.0000, 'ºC'),
	(130806, 110, '2015-04-01 00:46:30.000000', 'temperatura', 1119.0000, 'ºC'),
	(130807, 110, '2015-04-01 00:46:31.000000', 'temperatura', 796.0000, 'ºC'),
	(130808, 110, '2015-04-01 00:46:32.000000', 'temperatura', 624.0000, 'ºC'),
	(130809, 110, '2015-04-01 00:46:33.000000', 'temperatura', 734.0000, 'ºC'),
	(130810, 110, '2015-04-01 00:46:34.000000', 'temperatura', 597.0000, 'ºC'),
	(130811, 110, '2015-04-01 00:46:35.000000', 'temperatura', 786.0000, 'ºC'),
	(130812, 110, '2015-04-01 00:46:36.000000', 'temperatura', 938.0000, 'ºC'),
	(130813, 110, '2015-04-01 00:46:37.000000', 'temperatura', 1131.0000, 'ºC'),
	(130814, 110, '2015-04-01 00:46:38.000000', 'temperatura', 443.0000, 'ºC'),
	(130815, 110, '2015-04-01 00:46:39.000000', 'temperatura', 21.0000, 'ºC'),
	(130816, 110, '2015-04-01 00:46:40.000000', 'temperatura', 1178.0000, 'ºC'),
	(130817, 110, '2015-04-01 00:46:41.000000', 'temperatura', 1026.0000, 'ºC'),
	(130818, 110, '2015-04-01 00:46:42.000000', 'temperatura', 398.0000, 'ºC'),
	(130819, 110, '2015-04-01 00:46:43.000000', 'temperatura', 112.0000, 'ºC'),
	(130820, 110, '2015-04-01 00:46:44.000000', 'temperatura', 565.0000, 'ºC'),
	(130821, 110, '2015-04-01 00:46:45.000000', 'temperatura', 92.0000, 'ºC'),
	(130822, 110, '2015-04-01 00:46:46.000000', 'temperatura', 1165.0000, 'ºC'),
	(130823, 110, '2015-04-01 00:46:47.000000', 'temperatura', 750.0000, 'ºC'),
	(130824, 110, '2015-04-01 00:46:48.000000', 'temperatura', 255.0000, 'ºC'),
	(130825, 110, '2015-04-01 00:46:49.000000', 'temperatura', 226.0000, 'ºC'),
	(130826, 110, '2015-04-01 00:46:50.000000', 'temperatura', 364.0000, 'ºC'),
	(130827, 110, '2015-04-01 00:46:51.000000', 'temperatura', 1143.0000, 'ºC'),
	(130828, 110, '2015-04-01 00:46:52.000000', 'temperatura', 1023.0000, 'ºC'),
	(130829, 110, '2015-04-01 00:46:53.000000', 'temperatura', 488.0000, 'ºC'),
	(130830, 110, '2015-04-01 00:46:54.000000', 'temperatura', 571.0000, 'ºC'),
	(130831, 110, '2015-04-01 00:46:55.000000', 'temperatura', 192.0000, 'ºC'),
	(130832, 110, '2015-04-01 00:46:56.000000', 'temperatura', 447.0000, 'ºC'),
	(130833, 110, '2015-04-01 00:46:57.000000', 'temperatura', 460.0000, 'ºC'),
	(130834, 110, '2015-04-01 00:46:58.000000', 'temperatura', 959.0000, 'ºC'),
	(130835, 110, '2015-04-01 00:46:59.000000', 'temperatura', 1016.0000, 'ºC'),
	(130836, 110, '2015-04-01 00:47:00.000000', 'temperatura', 1005.0000, 'ºC'),
	(130837, 110, '2015-04-01 00:47:01.000000', 'temperatura', 775.0000, 'ºC'),
	(130838, 110, '2015-04-01 00:47:02.000000', 'temperatura', 861.0000, 'ºC'),
	(130839, 110, '2015-04-01 00:47:03.000000', 'temperatura', 782.0000, 'ºC'),
	(130840, 110, '2015-04-01 00:47:04.000000', 'temperatura', 128.0000, 'ºC'),
	(130841, 110, '2015-04-01 00:47:05.000000', 'temperatura', 694.0000, 'ºC'),
	(130842, 110, '2015-04-01 00:47:06.000000', 'temperatura', 687.0000, 'ºC'),
	(130843, 110, '2015-04-01 00:47:07.000000', 'temperatura', 155.0000, 'ºC'),
	(130844, 110, '2015-04-01 00:47:08.000000', 'temperatura', 1113.0000, 'ºC'),
	(130845, 110, '2015-04-01 00:47:09.000000', 'temperatura', 300.0000, 'ºC'),
	(130846, 110, '2015-04-01 00:47:10.000000', 'temperatura', 561.0000, 'ºC'),
	(130847, 110, '2015-04-01 00:47:11.000000', 'temperatura', 708.0000, 'ºC'),
	(130848, 110, '2015-04-01 00:47:12.000000', 'temperatura', 657.0000, 'ºC'),
	(130849, 110, '2015-04-01 00:47:13.000000', 'temperatura', 1161.0000, 'ºC'),
	(130850, 110, '2015-04-01 00:47:14.000000', 'temperatura', 233.0000, 'ºC'),
	(130851, 110, '2015-04-01 00:47:15.000000', 'temperatura', 84.0000, 'ºC'),
	(130852, 110, '2015-04-01 00:47:16.000000', 'temperatura', 921.0000, 'ºC'),
	(130853, 110, '2015-04-01 00:47:17.000000', 'temperatura', 752.0000, 'ºC'),
	(130854, 110, '2015-04-01 00:47:18.000000', 'temperatura', 997.0000, 'ºC'),
	(130855, 110, '2015-04-01 00:47:19.000000', 'temperatura', 332.0000, 'ºC'),
	(130856, 110, '2015-04-01 00:47:20.000000', 'temperatura', 1068.0000, 'ºC'),
	(130857, 110, '2015-04-01 00:47:21.000000', 'temperatura', 743.0000, 'ºC'),
	(130858, 110, '2015-04-01 00:47:22.000000', 'temperatura', 512.0000, 'ºC'),
	(130859, 110, '2015-04-01 00:47:23.000000', 'temperatura', 333.0000, 'ºC'),
	(130860, 110, '2015-04-01 00:47:24.000000', 'temperatura', 128.0000, 'ºC'),
	(130861, 110, '2015-04-01 00:47:25.000000', 'temperatura', 841.0000, 'ºC'),
	(130862, 110, '2015-04-01 00:47:26.000000', 'temperatura', 222.0000, 'ºC'),
	(130863, 110, '2015-04-01 00:47:27.000000', 'temperatura', 988.0000, 'ºC'),
	(130864, 110, '2015-04-01 00:47:28.000000', 'temperatura', 676.0000, 'ºC'),
	(130865, 110, '2015-04-01 00:47:29.000000', 'temperatura', 414.0000, 'ºC'),
	(130866, 110, '2015-04-01 00:47:30.000000', 'temperatura', 42.0000, 'ºC'),
	(130867, 110, '2015-04-01 00:47:31.000000', 'temperatura', 171.0000, 'ºC'),
	(130868, 110, '2015-04-01 00:47:32.000000', 'temperatura', 730.0000, 'ºC'),
	(130869, 110, '2015-04-01 00:47:33.000000', 'temperatura', 735.0000, 'ºC'),
	(130870, 110, '2015-04-01 00:47:34.000000', 'temperatura', 286.0000, 'ºC'),
	(130871, 110, '2015-04-01 00:47:35.000000', 'temperatura', 426.0000, 'ºC'),
	(130872, 110, '2015-04-01 00:47:36.000000', 'temperatura', 73.0000, 'ºC'),
	(130873, 110, '2015-04-01 00:47:37.000000', 'temperatura', 288.0000, 'ºC'),
	(130874, 110, '2015-04-01 00:47:38.000000', 'temperatura', 22.0000, 'ºC'),
	(130875, 110, '2015-04-01 00:47:39.000000', 'temperatura', 446.0000, 'ºC'),
	(130876, 110, '2015-04-01 00:47:40.000000', 'temperatura', 964.0000, 'ºC'),
	(130877, 110, '2015-04-01 00:47:41.000000', 'temperatura', 1082.0000, 'ºC'),
	(130878, 110, '2015-04-01 00:47:42.000000', 'temperatura', 118.0000, 'ºC'),
	(130879, 110, '2015-04-01 00:47:43.000000', 'temperatura', 946.0000, 'ºC'),
	(130880, 110, '2015-04-01 00:47:44.000000', 'temperatura', 775.0000, 'ºC'),
	(130881, 110, '2015-04-01 00:47:45.000000', 'temperatura', 1037.0000, 'ºC'),
	(130882, 110, '2015-04-01 00:47:46.000000', 'temperatura', 462.0000, 'ºC'),
	(130883, 110, '2015-04-01 00:47:47.000000', 'temperatura', 398.0000, 'ºC'),
	(130884, 110, '2015-04-01 00:47:48.000000', 'temperatura', 603.0000, 'ºC'),
	(130885, 110, '2015-04-01 00:47:49.000000', 'temperatura', 624.0000, 'ºC'),
	(130886, 110, '2015-04-01 00:47:50.000000', 'temperatura', 111.0000, 'ºC'),
	(130887, 110, '2015-04-01 00:47:51.000000', 'temperatura', 1081.0000, 'ºC'),
	(130888, 110, '2015-04-01 00:47:52.000000', 'temperatura', 276.0000, 'ºC'),
	(130889, 110, '2015-04-01 00:47:53.000000', 'temperatura', 534.0000, 'ºC'),
	(130890, 110, '2015-04-01 00:47:54.000000', 'temperatura', 645.0000, 'ºC'),
	(130891, 110, '2015-04-01 00:47:55.000000', 'temperatura', 421.0000, 'ºC'),
	(130892, 110, '2015-04-01 00:47:56.000000', 'temperatura', 171.0000, 'ºC'),
	(130893, 110, '2015-04-01 00:47:57.000000', 'temperatura', 792.0000, 'ºC'),
	(130894, 110, '2015-04-01 00:47:58.000000', 'temperatura', 1050.0000, 'ºC'),
	(130895, 110, '2015-04-01 00:47:59.000000', 'temperatura', 475.0000, 'ºC'),
	(130896, 110, '2015-04-01 00:48:00.000000', 'temperatura', 423.0000, 'ºC'),
	(130897, 110, '2015-04-01 00:48:01.000000', 'temperatura', 694.0000, 'ºC'),
	(130898, 110, '2015-04-01 00:48:02.000000', 'temperatura', 998.0000, 'ºC'),
	(130899, 110, '2015-04-01 00:48:03.000000', 'temperatura', 508.0000, 'ºC'),
	(130900, 110, '2015-04-01 00:48:04.000000', 'temperatura', 747.0000, 'ºC'),
	(130901, 110, '2015-04-01 00:48:05.000000', 'temperatura', 1014.0000, 'ºC'),
	(130902, 110, '2015-04-01 00:48:06.000000', 'temperatura', 427.0000, 'ºC'),
	(130903, 110, '2015-04-01 00:48:07.000000', 'temperatura', 294.0000, 'ºC'),
	(130904, 110, '2015-04-01 00:48:08.000000', 'temperatura', 188.0000, 'ºC'),
	(130905, 110, '2015-04-01 00:48:09.000000', 'temperatura', 61.0000, 'ºC'),
	(130906, 110, '2015-04-01 00:48:10.000000', 'temperatura', 941.0000, 'ºC'),
	(130907, 110, '2015-04-01 00:48:11.000000', 'temperatura', 924.0000, 'ºC'),
	(130908, 110, '2015-04-01 00:48:12.000000', 'temperatura', 597.0000, 'ºC'),
	(130909, 110, '2015-04-01 00:48:13.000000', 'temperatura', 211.0000, 'ºC'),
	(130910, 110, '2015-04-01 00:48:14.000000', 'temperatura', 467.0000, 'ºC'),
	(130911, 110, '2015-04-01 00:48:15.000000', 'temperatura', 501.0000, 'ºC'),
	(130912, 110, '2015-04-01 00:48:16.000000', 'temperatura', 1105.0000, 'ºC'),
	(130913, 110, '2015-04-01 00:48:17.000000', 'temperatura', 424.0000, 'ºC'),
	(130914, 110, '2015-04-01 00:48:18.000000', 'temperatura', 2.0000, 'ºC'),
	(130915, 110, '2015-04-01 00:48:19.000000', 'temperatura', 1142.0000, 'ºC'),
	(130916, 110, '2015-04-01 00:48:20.000000', 'temperatura', 904.0000, 'ºC'),
	(130917, 110, '2015-04-01 00:48:21.000000', 'temperatura', 1094.0000, 'ºC'),
	(130918, 110, '2015-04-01 00:48:22.000000', 'temperatura', 357.0000, 'ºC'),
	(130919, 110, '2015-04-01 00:48:23.000000', 'temperatura', 906.0000, 'ºC'),
	(130920, 110, '2015-04-01 00:48:24.000000', 'temperatura', 1058.0000, 'ºC'),
	(130921, 110, '2015-04-01 00:48:25.000000', 'temperatura', 172.0000, 'ºC'),
	(130922, 110, '2015-04-01 00:48:26.000000', 'temperatura', 88.0000, 'ºC'),
	(130923, 110, '2015-04-01 00:48:27.000000', 'temperatura', 1124.0000, 'ºC'),
	(130924, 110, '2015-04-01 00:48:28.000000', 'temperatura', 555.0000, 'ºC'),
	(130925, 110, '2015-04-01 00:48:29.000000', 'temperatura', 606.0000, 'ºC'),
	(130926, 110, '2015-04-01 00:48:30.000000', 'temperatura', 165.0000, 'ºC'),
	(130927, 110, '2015-04-01 00:48:31.000000', 'temperatura', 208.0000, 'ºC'),
	(130928, 110, '2015-04-01 00:48:32.000000', 'temperatura', 543.0000, 'ºC'),
	(130929, 110, '2015-04-01 00:48:33.000000', 'temperatura', 893.0000, 'ºC'),
	(130930, 110, '2015-04-01 00:48:34.000000', 'temperatura', 435.0000, 'ºC'),
	(130931, 110, '2015-04-01 00:48:35.000000', 'temperatura', 697.0000, 'ºC'),
	(130932, 110, '2015-04-01 00:48:36.000000', 'temperatura', 983.0000, 'ºC'),
	(130933, 110, '2015-04-01 00:48:37.000000', 'temperatura', 422.0000, 'ºC'),
	(130934, 110, '2015-04-01 00:48:38.000000', 'temperatura', 363.0000, 'ºC'),
	(130935, 110, '2015-04-01 00:48:39.000000', 'temperatura', 550.0000, 'ºC'),
	(130936, 110, '2015-04-01 00:48:40.000000', 'temperatura', 461.0000, 'ºC'),
	(130937, 110, '2015-04-01 00:48:41.000000', 'temperatura', 655.0000, 'ºC'),
	(130938, 110, '2015-04-01 00:48:42.000000', 'temperatura', 692.0000, 'ºC'),
	(130939, 110, '2015-04-01 00:48:43.000000', 'temperatura', 298.0000, 'ºC'),
	(130940, 110, '2015-04-01 00:48:44.000000', 'temperatura', 612.0000, 'ºC'),
	(130941, 110, '2015-04-01 00:48:45.000000', 'temperatura', 969.0000, 'ºC'),
	(130942, 110, '2015-04-01 00:48:46.000000', 'temperatura', 610.0000, 'ºC'),
	(130943, 110, '2015-04-01 00:48:47.000000', 'temperatura', 142.0000, 'ºC'),
	(130944, 110, '2015-04-01 00:48:48.000000', 'temperatura', 79.0000, 'ºC'),
	(130945, 110, '2015-04-01 00:48:49.000000', 'temperatura', 1171.0000, 'ºC'),
	(130946, 110, '2015-04-01 00:48:50.000000', 'temperatura', 818.0000, 'ºC'),
	(130947, 110, '2015-04-01 00:48:51.000000', 'temperatura', 579.0000, 'ºC'),
	(130948, 110, '2015-04-01 00:48:52.000000', 'temperatura', 442.0000, 'ºC'),
	(130949, 110, '2015-04-01 00:48:53.000000', 'temperatura', 471.0000, 'ºC'),
	(130950, 110, '2015-04-01 00:48:54.000000', 'temperatura', 1031.0000, 'ºC'),
	(130951, 110, '2015-04-01 00:48:55.000000', 'temperatura', 143.0000, 'ºC'),
	(130952, 110, '2015-04-01 00:48:56.000000', 'temperatura', 20.0000, 'ºC'),
	(130953, 110, '2015-04-01 00:48:57.000000', 'temperatura', 874.0000, 'ºC'),
	(130954, 110, '2015-04-01 00:48:58.000000', 'temperatura', 708.0000, 'ºC'),
	(130955, 110, '2015-04-01 00:48:59.000000', 'temperatura', 920.0000, 'ºC'),
	(130956, 110, '2015-04-01 00:49:00.000000', 'temperatura', 77.0000, 'ºC'),
	(130957, 110, '2015-04-01 00:49:01.000000', 'temperatura', 24.0000, 'ºC'),
	(130958, 110, '2015-04-01 00:49:02.000000', 'temperatura', 1090.0000, 'ºC'),
	(130959, 110, '2015-04-01 00:49:03.000000', 'temperatura', 580.0000, 'ºC'),
	(130960, 110, '2015-04-01 00:49:04.000000', 'temperatura', 831.0000, 'ºC'),
	(130961, 110, '2015-04-01 00:49:05.000000', 'temperatura', 15.0000, 'ºC'),
	(130962, 110, '2015-04-01 00:49:06.000000', 'temperatura', 1182.0000, 'ºC'),
	(130963, 110, '2015-04-01 00:49:07.000000', 'temperatura', 1067.0000, 'ºC'),
	(130964, 110, '2015-04-01 00:49:08.000000', 'temperatura', 590.0000, 'ºC'),
	(130965, 110, '2015-04-01 00:49:09.000000', 'temperatura', 947.0000, 'ºC'),
	(130966, 110, '2015-04-01 00:49:10.000000', 'temperatura', 567.0000, 'ºC'),
	(130967, 110, '2015-04-01 00:49:11.000000', 'temperatura', 1192.0000, 'ºC'),
	(130968, 110, '2015-04-01 00:49:12.000000', 'temperatura', 661.0000, 'ºC'),
	(130969, 110, '2015-04-01 00:49:13.000000', 'temperatura', 931.0000, 'ºC'),
	(130970, 110, '2015-04-01 00:49:14.000000', 'temperatura', 273.0000, 'ºC'),
	(130971, 110, '2015-04-01 00:49:15.000000', 'temperatura', 971.0000, 'ºC'),
	(130972, 110, '2015-04-01 00:49:16.000000', 'temperatura', 438.0000, 'ºC'),
	(130973, 110, '2015-04-01 00:49:17.000000', 'temperatura', 479.0000, 'ºC'),
	(130974, 110, '2015-04-01 00:49:18.000000', 'temperatura', 1078.0000, 'ºC'),
	(130975, 110, '2015-04-01 00:49:19.000000', 'temperatura', 354.0000, 'ºC'),
	(130976, 110, '2015-04-01 00:49:20.000000', 'temperatura', 937.0000, 'ºC'),
	(130977, 110, '2015-04-01 00:49:21.000000', 'temperatura', 24.0000, 'ºC'),
	(130978, 110, '2015-04-01 00:49:22.000000', 'temperatura', 910.0000, 'ºC'),
	(130979, 110, '2015-04-01 00:49:23.000000', 'temperatura', 879.0000, 'ºC'),
	(130980, 110, '2015-04-01 00:49:24.000000', 'temperatura', 466.0000, 'ºC'),
	(130981, 110, '2015-04-01 00:49:25.000000', 'temperatura', 892.0000, 'ºC'),
	(130982, 110, '2015-04-01 00:49:26.000000', 'temperatura', 663.0000, 'ºC'),
	(130983, 110, '2015-04-01 00:49:27.000000', 'temperatura', 641.0000, 'ºC'),
	(130984, 110, '2015-04-01 00:49:28.000000', 'temperatura', 14.0000, 'ºC'),
	(130985, 110, '2015-04-01 00:49:29.000000', 'temperatura', 549.0000, 'ºC'),
	(130986, 110, '2015-04-01 00:49:30.000000', 'temperatura', 303.0000, 'ºC'),
	(130987, 110, '2015-04-01 00:49:31.000000', 'temperatura', 1067.0000, 'ºC'),
	(130988, 110, '2015-04-01 00:49:32.000000', 'temperatura', 827.0000, 'ºC'),
	(130989, 110, '2015-04-01 00:49:33.000000', 'temperatura', 937.0000, 'ºC'),
	(130990, 110, '2015-04-01 00:49:34.000000', 'temperatura', 1001.0000, 'ºC'),
	(130991, 110, '2015-04-01 00:49:35.000000', 'temperatura', 998.0000, 'ºC'),
	(130992, 110, '2015-04-01 00:49:36.000000', 'temperatura', 786.0000, 'ºC'),
	(130993, 110, '2015-04-01 00:49:37.000000', 'temperatura', 938.0000, 'ºC'),
	(130994, 110, '2015-04-01 00:49:38.000000', 'temperatura', 1130.0000, 'ºC'),
	(130995, 110, '2015-04-01 00:49:39.000000', 'temperatura', 436.0000, 'ºC'),
	(130996, 110, '2015-04-01 00:49:40.000000', 'temperatura', 1191.0000, 'ºC'),
	(130997, 110, '2015-04-01 00:49:41.000000', 'temperatura', 1049.0000, 'ºC'),
	(130998, 110, '2015-04-01 00:49:42.000000', 'temperatura', 471.0000, 'ºC'),
	(130999, 110, '2015-04-01 00:49:43.000000', 'temperatura', 411.0000, 'ºC'),
	(131000, 110, '2015-04-01 00:49:44.000000', 'temperatura', 642.0000, 'ºC'),
	(131001, 110, '2015-04-01 00:49:45.000000', 'temperatura', 776.0000, 'ºC'),
	(131002, 110, '2015-04-01 00:49:46.000000', 'temperatura', 753.0000, 'ºC'),
	(131003, 110, '2015-04-01 00:49:47.000000', 'temperatura', 240.0000, 'ºC'),
	(131004, 110, '2015-04-01 00:49:48.000000', 'temperatura', 142.0000, 'ºC'),
	(131005, 110, '2015-04-01 00:49:49.000000', 'temperatura', 1192.0000, 'ºC'),
	(131006, 110, '2015-04-01 00:49:50.000000', 'temperatura', 731.0000, 'ºC'),
	(131007, 110, '2015-04-01 00:49:51.000000', 'temperatura', 82.0000, 'ºC'),
	(131008, 110, '2015-04-01 00:49:52.000000', 'temperatura', 616.0000, 'ºC'),
	(131009, 110, '2015-04-01 00:49:53.000000', 'temperatura', 434.0000, 'ºC'),
	(131010, 110, '2015-04-01 00:49:54.000000', 'temperatura', 325.0000, 'ºC'),
	(131011, 110, '2015-04-01 00:49:55.000000', 'temperatura', 323.0000, 'ºC'),
	(131012, 110, '2015-04-01 00:49:56.000000', 'temperatura', 640.0000, 'ºC'),
	(131013, 110, '2015-04-01 00:49:57.000000', 'temperatura', 1032.0000, 'ºC'),
	(131014, 110, '2015-04-01 00:49:58.000000', 'temperatura', 839.0000, 'ºC'),
	(131015, 110, '2015-04-01 00:49:59.000000', 'temperatura', 1100.0000, 'ºC'),
	(131016, 110, '2015-04-01 00:50:00.000000', 'temperatura', 582.0000, 'ºC'),
	(131017, 110, '2015-04-01 00:50:01.000000', 'temperatura', 811.0000, 'ºC'),
	(131018, 110, '2015-04-01 00:50:02.000000', 'temperatura', 1109.0000, 'ºC'),
	(131019, 110, '2015-04-01 00:50:03.000000', 'temperatura', 711.0000, 'ºC'),
	(131020, 110, '2015-04-01 00:50:04.000000', 'temperatura', 231.0000, 'ºC'),
	(131021, 110, '2015-04-01 00:50:05.000000', 'temperatura', 221.0000, 'ºC'),
	(131022, 110, '2015-04-01 00:50:06.000000', 'temperatura', 413.0000, 'ºC'),
	(131023, 110, '2015-04-01 00:50:07.000000', 'temperatura', 203.0000, 'ºC'),
	(131024, 110, '2015-04-01 00:50:08.000000', 'temperatura', 977.0000, 'ºC'),
	(131025, 110, '2015-04-01 00:50:09.000000', 'temperatura', 677.0000, 'ºC'),
	(131026, 110, '2015-04-01 00:50:10.000000', 'temperatura', 453.0000, 'ºC'),
	(131027, 110, '2015-04-01 00:50:11.000000', 'temperatura', 233.0000, 'ºC'),
	(131028, 110, '2015-04-01 00:50:12.000000', 'temperatura', 1009.0000, 'ºC'),
	(131029, 110, '2015-04-01 00:50:13.000000', 'temperatura', 747.0000, 'ºC'),
	(131030, 110, '2015-04-01 00:50:14.000000', 'temperatura', 707.0000, 'ºC'),
	(131031, 110, '2015-04-01 00:50:15.000000', 'temperatura', 94.0000, 'ºC'),
	(131032, 110, '2015-04-01 00:50:16.000000', 'temperatura', 751.0000, 'ºC'),
	(131033, 110, '2015-04-01 00:50:17.000000', 'temperatura', 1073.0000, 'ºC'),
	(131034, 110, '2015-04-01 00:50:18.000000', 'temperatura', 714.0000, 'ºC'),
	(131035, 110, '2015-04-01 00:50:19.000000', 'temperatura', 352.0000, 'ºC'),
	(131036, 110, '2015-04-01 00:50:20.000000', 'temperatura', 819.0000, 'ºC'),
	(131037, 110, '2015-04-01 00:50:21.000000', 'temperatura', 639.0000, 'ºC'),
	(131038, 110, '2015-04-01 00:50:22.000000', 'temperatura', 740.0000, 'ºC'),
	(131039, 110, '2015-04-01 00:50:23.000000', 'temperatura', 581.0000, 'ºC'),
	(131040, 110, '2015-04-01 00:50:24.000000', 'temperatura', 687.0000, 'ºC'),
	(131041, 110, '2015-04-01 00:50:25.000000', 'temperatura', 492.0000, 'ºC'),
	(131042, 110, '2015-04-01 00:50:26.000000', 'temperatura', 401.0000, 'ºC'),
	(131043, 110, '2015-04-01 00:50:27.000000', 'temperatura', 528.0000, 'ºC'),
	(131044, 110, '2015-04-01 00:50:28.000000', 'temperatura', 237.0000, 'ºC'),
	(131045, 110, '2015-04-01 00:50:29.000000', 'temperatura', 804.0000, 'ºC'),
	(131046, 110, '2015-04-01 00:50:30.000000', 'temperatura', 908.0000, 'ºC'),
	(131047, 110, '2015-04-01 00:50:31.000000', 'temperatura', 929.0000, 'ºC'),
	(131048, 110, '2015-04-01 00:50:32.000000', 'temperatura', 721.0000, 'ºC'),
	(131049, 110, '2015-04-01 00:50:33.000000', 'temperatura', 820.0000, 'ºC'),
	(131050, 110, '2015-04-01 00:50:34.000000', 'temperatura', 736.0000, 'ºC'),
	(131051, 110, '2015-04-01 00:50:35.000000', 'temperatura', 19.0000, 'ºC'),
	(131052, 110, '2015-04-01 00:50:36.000000', 'temperatura', 290.0000, 'ºC'),
	(131053, 110, '2015-04-01 00:50:37.000000', 'temperatura', 192.0000, 'ºC'),
	(131054, 110, '2015-04-01 00:50:38.000000', 'temperatura', 92.0000, 'ºC'),
	(131055, 110, '2015-04-01 00:50:39.000000', 'temperatura', 1084.0000, 'ºC'),
	(131056, 110, '2015-04-01 00:50:40.000000', 'temperatura', 345.0000, 'ºC'),
	(131057, 110, '2015-04-01 00:50:41.000000', 'temperatura', 871.0000, 'ºC'),
	(131058, 110, '2015-04-01 00:50:42.000000', 'temperatura', 923.0000, 'ºC'),
	(131059, 110, '2015-04-01 00:50:43.000000', 'temperatura', 802.0000, 'ºC'),
	(131060, 110, '2015-04-01 00:50:44.000000', 'temperatura', 40.0000, 'ºC'),
	(131061, 110, '2015-04-01 00:50:45.000000', 'temperatura', 197.0000, 'ºC'),
	(131062, 110, '2015-04-01 00:50:46.000000', 'temperatura', 866.0000, 'ºC'),
	(131063, 110, '2015-04-01 00:50:47.000000', 'temperatura', 139.0000, 'ºC'),
	(131064, 110, '2015-04-01 00:50:48.000000', 'temperatura', 497.0000, 'ºC'),
	(131065, 110, '2015-04-01 00:50:49.000000', 'temperatura', 869.0000, 'ºC'),
	(131066, 110, '2015-04-01 00:50:50.000000', 'temperatura', 455.0000, 'ºC'),
	(131067, 110, '2015-04-01 00:50:51.000000', 'temperatura', 866.0000, 'ºC'),
	(131068, 110, '2015-04-01 00:50:52.000000', 'temperatura', 568.0000, 'ºC'),
	(131069, 110, '2015-04-01 00:50:53.000000', 'temperatura', 242.0000, 'ºC'),
	(131070, 110, '2015-04-01 00:50:54.000000', 'temperatura', 705.0000, 'ºC'),
	(131071, 110, '2015-04-01 00:50:55.000000', 'temperatura', 401.0000, 'ºC'),
	(131072, 110, '2015-04-01 00:50:56.000000', 'temperatura', 1090.0000, 'ºC'),
	(131073, 110, '2015-04-01 00:50:57.000000', 'temperatura', 646.0000, 'ºC'),
	(131074, 110, '2015-04-01 00:50:58.000000', 'temperatura', 1160.0000, 'ºC'),
	(131075, 110, '2015-04-01 00:50:59.000000', 'temperatura', 265.0000, 'ºC'),
	(131076, 110, '2015-04-01 00:51:00.000000', 'temperatura', 245.0000, 'ºC'),
	(131077, 110, '2015-04-01 00:51:01.000000', 'temperatura', 430.0000, 'ºC'),
	(131078, 110, '2015-04-01 00:51:02.000000', 'temperatura', 214.0000, 'ºC'),
	(131079, 110, '2015-04-01 00:51:03.000000', 'temperatura', 980.0000, 'ºC'),
	(131080, 110, '2015-04-01 00:51:04.000000', 'temperatura', 661.0000, 'ºC'),
	(131081, 110, '2015-04-01 00:51:05.000000', 'temperatura', 363.0000, 'ºC'),
	(131082, 110, '2015-04-01 00:51:06.000000', 'temperatura', 1033.0000, 'ºC'),
	(131083, 110, '2015-04-01 00:51:07.000000', 'temperatura', 478.0000, 'ºC'),
	(131084, 110, '2015-04-01 00:51:08.000000', 'temperatura', 490.0000, 'ºC'),
	(131085, 110, '2015-04-01 00:51:09.000000', 'temperatura', 1018.0000, 'ºC'),
	(131086, 110, '2015-04-01 00:51:10.000000', 'temperatura', 20.0000, 'ºC'),
	(131087, 110, '2015-04-01 00:51:11.000000', 'temperatura', 647.0000, 'ºC'),
	(131088, 110, '2015-04-01 00:51:12.000000', 'temperatura', 775.0000, 'ºC'),
	(131089, 110, '2015-04-01 00:51:13.000000', 'temperatura', 733.0000, 'ºC'),
	(131090, 110, '2015-04-01 00:51:14.000000', 'temperatura', 144.0000, 'ºC'),
	(131091, 110, '2015-04-01 00:51:15.000000', 'temperatura', 918.0000, 'ºC'),
	(131092, 110, '2015-04-01 00:51:16.000000', 'temperatura', 559.0000, 'ºC'),
	(131093, 110, '2015-04-01 00:51:17.000000', 'temperatura', 42.0000, 'ºC'),
	(131094, 110, '2015-04-01 00:51:18.000000', 'temperatura', 934.0000, 'ºC'),
	(131095, 110, '2015-04-01 00:51:19.000000', 'temperatura', 946.0000, 'ºC'),
	(131096, 110, '2015-04-01 00:51:20.000000', 'temperatura', 726.0000, 'ºC'),
	(131097, 110, '2015-04-01 00:51:21.000000', 'temperatura', 793.0000, 'ºC'),
	(131098, 110, '2015-04-01 00:51:22.000000', 'temperatura', 589.0000, 'ºC'),
	(131099, 110, '2015-04-01 00:51:23.000000', 'temperatura', 566.0000, 'ºC'),
	(131100, 110, '2015-04-01 00:51:24.000000', 'temperatura', 1064.0000, 'ºC'),
	(131101, 110, '2015-04-01 00:51:25.000000', 'temperatura', 22.0000, 'ºC'),
	(131102, 110, '2015-04-01 00:51:26.000000', 'temperatura', 519.0000, 'ºC'),
	(131103, 110, '2015-04-01 00:51:27.000000', 'temperatura', 131.0000, 'ºC'),
	(131104, 110, '2015-04-01 00:51:28.000000', 'temperatura', 296.0000, 'ºC'),
	(131105, 110, '2015-04-01 00:51:29.000000', 'temperatura', 1090.0000, 'ºC'),
	(131106, 110, '2015-04-01 00:51:30.000000', 'temperatura', 962.0000, 'ºC'),
	(131107, 110, '2015-04-01 00:51:31.000000', 'temperatura', 341.0000, 'ºC'),
	(131108, 110, '2015-04-01 00:51:32.000000', 'temperatura', 17.0000, 'ºC'),
	(131109, 110, '2015-04-01 00:51:33.000000', 'temperatura', 265.0000, 'ºC'),
	(131110, 110, '2015-04-01 00:51:34.000000', 'temperatura', 75.0000, 'ºC'),
	(131111, 110, '2015-04-01 00:51:35.000000', 'temperatura', 779.0000, 'ºC'),
	(131112, 110, '2015-04-01 00:51:36.000000', 'temperatura', 70.0000, 'ºC'),
	(131113, 110, '2015-04-01 00:51:37.000000', 'temperatura', 415.0000, 'ºC'),
	(131114, 110, '2015-04-01 00:51:38.000000', 'temperatura', 663.0000, 'ºC'),
	(131115, 110, '2015-04-01 00:51:39.000000', 'temperatura', 874.0000, 'ºC'),
	(131116, 110, '2015-04-01 00:51:40.000000', 'temperatura', 1179.0000, 'ºC'),
	(131117, 110, '2015-04-01 00:51:41.000000', 'temperatura', 874.0000, 'ºC'),
	(131118, 110, '2015-04-01 00:51:42.000000', 'temperatura', 835.0000, 'ºC'),
	(131119, 110, '2015-04-01 00:51:43.000000', 'temperatura', 354.0000, 'ºC'),
	(131120, 110, '2015-04-01 00:51:44.000000', 'temperatura', 465.0000, 'ºC'),
	(131121, 110, '2015-04-01 00:51:45.000000', 'temperatura', 62.0000, 'ºC'),
	(131122, 110, '2015-04-01 00:51:46.000000', 'temperatura', 115.0000, 'ºC'),
	(131123, 110, '2015-04-01 00:51:47.000000', 'temperatura', 389.0000, 'ºC'),
	(131124, 110, '2015-04-01 00:51:48.000000', 'temperatura', 403.0000, 'ºC'),
	(131125, 110, '2015-04-01 00:51:49.000000', 'temperatura', 848.0000, 'ºC'),
	(131126, 110, '2015-04-01 00:51:50.000000', 'temperatura', 632.0000, 'ºC'),
	(131127, 110, '2015-04-01 00:51:51.000000', 'temperatura', 616.0000, 'ºC'),
	(131128, 110, '2015-04-01 00:51:52.000000', 'temperatura', 1186.0000, 'ºC'),
	(131129, 110, '2015-04-01 00:51:53.000000', 'temperatura', 482.0000, 'ºC'),
	(131130, 110, '2015-04-01 00:51:54.000000', 'temperatura', 52.0000, 'ºC'),
	(131131, 110, '2015-04-01 00:51:55.000000', 'temperatura', 13.0000, 'ºC'),
	(131132, 110, '2015-04-01 00:51:56.000000', 'temperatura', 1110.0000, 'ºC'),
	(131133, 110, '2015-04-01 00:51:57.000000', 'temperatura', 711.0000, 'ºC'),
	(131134, 110, '2015-04-01 00:51:58.000000', 'temperatura', 227.0000, 'ºC'),
	(131135, 110, '2015-04-01 00:51:59.000000', 'temperatura', 201.0000, 'ºC'),
	(131136, 110, '2015-04-01 00:52:00.000000', 'temperatura', 325.0000, 'ºC'),
	(131137, 110, '2015-04-01 00:52:01.000000', 'temperatura', 1021.0000, 'ºC'),
	(131138, 110, '2015-04-01 00:52:02.000000', 'temperatura', 530.0000, 'ºC'),
	(131139, 110, '2015-04-01 00:52:03.000000', 'temperatura', 787.0000, 'ºC'),
	(131140, 110, '2015-04-01 00:52:04.000000', 'temperatura', 1149.0000, 'ºC'),
	(131141, 110, '2015-04-01 00:52:05.000000', 'temperatura', 981.0000, 'ºC'),
	(131142, 110, '2015-04-01 00:52:06.000000', 'temperatura', 259.0000, 'ºC'),
	(131143, 110, '2015-04-01 00:52:07.000000', 'temperatura', 755.0000, 'ºC'),
	(131144, 110, '2015-04-01 00:52:08.000000', 'temperatura', 598.0000, 'ºC'),
	(131145, 110, '2015-04-01 00:52:09.000000', 'temperatura', 723.0000, 'ºC'),
	(131146, 110, '2015-04-01 00:52:10.000000', 'temperatura', 623.0000, 'ºC'),
	(131147, 110, '2015-04-01 00:52:11.000000', 'temperatura', 949.0000, 'ºC'),
	(131148, 110, '2015-04-01 00:52:12.000000', 'temperatura', 473.0000, 'ºC'),
	(131149, 110, '2015-04-01 00:52:13.000000', 'temperatura', 718.0000, 'ºC'),
	(131150, 110, '2015-04-01 00:52:14.000000', 'temperatura', 971.0000, 'ºC'),
	(131151, 110, '2015-04-01 00:52:15.000000', 'temperatura', 305.0000, 'ºC'),
	(131152, 110, '2015-04-01 00:52:16.000000', 'temperatura', 1009.0000, 'ºC'),
	(131153, 110, '2015-04-01 00:52:17.000000', 'temperatura', 534.0000, 'ºC'),
	(131154, 110, '2015-04-01 00:52:18.000000', 'temperatura', 841.0000, 'ºC'),
	(131155, 110, '2015-04-01 00:52:19.000000', 'temperatura', 204.0000, 'ºC'),
	(131156, 110, '2015-04-01 00:52:20.000000', 'temperatura', 897.0000, 'ºC'),
	(131157, 110, '2015-04-01 00:52:21.000000', 'temperatura', 272.0000, 'ºC'),
	(131158, 110, '2015-04-01 00:52:22.000000', 'temperatura', 1072.0000, 'ºC'),
	(131159, 110, '2015-04-01 00:52:23.000000', 'temperatura', 944.0000, 'ºC'),
	(131160, 110, '2015-04-01 00:52:24.000000', 'temperatura', 303.0000, 'ºC'),
	(131161, 110, '2015-04-01 00:52:25.000000', 'temperatura', 1086.0000, 'ºC'),
	(131162, 110, '2015-04-01 00:52:26.000000', 'temperatura', 919.0000, 'ºC'),
	(131163, 110, '2015-04-01 00:52:27.000000', 'temperatura', 139.0000, 'ºC'),
	(131164, 110, '2015-04-01 00:52:28.000000', 'temperatura', 337.0000, 'ºC'),
	(131165, 110, '2015-04-01 00:52:29.000000', 'temperatura', 71.0000, 'ºC'),
	(131166, 110, '2015-04-01 00:52:30.000000', 'temperatura', 543.0000, 'ºC'),
	(131167, 110, '2015-04-01 00:52:31.000000', 'temperatura', 103.0000, 'ºC'),
	(131168, 110, '2015-04-01 00:52:32.000000', 'temperatura', 88.0000, 'ºC'),
	(131169, 110, '2015-04-01 00:52:33.000000', 'temperatura', 132.0000, 'ºC'),
	(131170, 110, '2015-04-01 00:52:34.000000', 'temperatura', 394.0000, 'ºC'),
	(131171, 110, '2015-04-01 00:52:35.000000', 'temperatura', 377.0000, 'ºC'),
	(131172, 110, '2015-04-01 00:52:36.000000', 'temperatura', 704.0000, 'ºC'),
	(131173, 110, '2015-04-01 00:52:37.000000', 'temperatura', 1190.0000, 'ºC'),
	(131174, 110, '2015-04-01 00:52:38.000000', 'temperatura', 235.0000, 'ºC'),
	(131175, 110, '2015-04-01 00:52:39.000000', 'temperatura', 8.0000, 'ºC'),
	(131176, 110, '2015-04-01 00:52:40.000000', 'temperatura', 536.0000, 'ºC'),
	(131177, 110, '2015-04-01 00:52:41.000000', 'temperatura', 255.0000, 'ºC'),
	(131178, 110, '2015-04-01 00:52:42.000000', 'temperatura', 866.0000, 'ºC'),
	(131179, 110, '2015-04-01 00:52:43.000000', 'temperatura', 1168.0000, 'ºC'),
	(131180, 110, '2015-04-01 00:52:44.000000', 'temperatura', 841.0000, 'ºC'),
	(131181, 110, '2015-04-01 00:52:45.000000', 'temperatura', 700.0000, 'ºC'),
	(131182, 110, '2015-04-01 00:52:46.000000', 'temperatura', 980.0000, 'ºC'),
	(131183, 110, '2015-04-01 00:52:47.000000', 'temperatura', 399.0000, 'ºC'),
	(131184, 110, '2015-04-01 00:52:48.000000', 'temperatura', 254.0000, 'ºC'),
	(131185, 110, '2015-04-01 00:52:49.000000', 'temperatura', 76.0000, 'ºC'),
	(131186, 110, '2015-04-01 00:52:50.000000', 'temperatura', 820.0000, 'ºC'),
	(131187, 110, '2015-04-01 00:52:51.000000', 'temperatura', 270.0000, 'ºC'),
	(131188, 110, '2015-04-01 00:52:52.000000', 'temperatura', 92.0000, 'ºC'),
	(131189, 110, '2015-04-01 00:52:53.000000', 'temperatura', 851.0000, 'ºC'),
	(131190, 110, '2015-04-01 00:52:54.000000', 'temperatura', 377.0000, 'ºC'),
	(131191, 110, '2015-04-01 00:52:55.000000', 'temperatura', 534.0000, 'ºC'),
	(131192, 110, '2015-04-01 00:52:56.000000', 'temperatura', 338.0000, 'ºC'),
	(131193, 110, '2015-04-01 00:52:57.000000', 'temperatura', 88.0000, 'ºC'),
	(131194, 110, '2015-04-01 00:52:58.000000', 'temperatura', 629.0000, 'ºC'),
	(131195, 110, '2015-04-01 00:52:59.000000', 'temperatura', 481.0000, 'ºC'),
	(131196, 110, '2015-04-01 00:53:00.000000', 'temperatura', 520.0000, 'ºC'),
	(131197, 110, '2015-04-01 00:53:01.000000', 'temperatura', 1156.0000, 'ºC'),
	(131198, 110, '2015-04-01 00:53:02.000000', 'temperatura', 620.0000, 'ºC'),
	(131199, 110, '2015-04-01 00:53:03.000000', 'temperatura', 831.0000, 'ºC'),
	(131200, 110, '2015-04-01 00:53:04.000000', 'temperatura', 1099.0000, 'ºC'),
	(131201, 110, '2015-04-01 00:53:05.000000', 'temperatura', 601.0000, 'ºC'),
	(131202, 110, '2015-04-01 00:53:06.000000', 'temperatura', 907.0000, 'ºC'),
	(131203, 110, '2015-04-01 00:53:07.000000', 'temperatura', 331.0000, 'ºC'),
	(131204, 110, '2015-04-01 00:53:08.000000', 'temperatura', 138.0000, 'ºC'),
	(131205, 110, '2015-04-01 00:53:09.000000', 'temperatura', 898.0000, 'ºC'),
	(131206, 110, '2015-04-01 00:53:10.000000', 'temperatura', 474.0000, 'ºC'),
	(131207, 110, '2015-04-01 00:53:11.000000', 'temperatura', 876.0000, 'ºC'),
	(131208, 110, '2015-04-01 00:53:12.000000', 'temperatura', 560.0000, 'ºC'),
	(131209, 110, '2015-04-01 00:53:13.000000', 'temperatura', 170.0000, 'ºC'),
	(131210, 110, '2015-04-01 00:53:14.000000', 'temperatura', 373.0000, 'ºC'),
	(131211, 110, '2015-04-01 00:53:15.000000', 'temperatura', 155.0000, 'ºC'),
	(131212, 110, '2015-04-01 00:53:16.000000', 'temperatura', 858.0000, 'ºC'),
	(131213, 110, '2015-04-01 00:53:17.000000', 'temperatura', 222.0000, 'ºC'),
	(131214, 110, '2015-04-01 00:53:18.000000', 'temperatura', 939.0000, 'ºC'),
	(131215, 110, '2015-04-01 00:53:19.000000', 'temperatura', 430.0000, 'ºC'),
	(131216, 110, '2015-04-01 00:53:20.000000', 'temperatura', 531.0000, 'ºC'),
	(131217, 110, '2015-04-01 00:53:21.000000', 'temperatura', 165.0000, 'ºC'),
	(131218, 110, '2015-04-01 00:53:22.000000', 'temperatura', 436.0000, 'ºC'),
	(131219, 110, '2015-04-01 00:53:23.000000', 'temperatura', 482.0000, 'ºC'),
	(131220, 110, '2015-04-01 00:53:24.000000', 'temperatura', 1104.0000, 'ºC'),
	(131221, 110, '2015-04-01 00:53:25.000000', 'temperatura', 475.0000, 'ºC'),
	(131222, 110, '2015-04-01 00:53:26.000000', 'temperatura', 263.0000, 'ºC'),
	(131223, 110, '2015-04-01 00:53:27.000000', 'temperatura', 1090.0000, 'ºC'),
	(131224, 110, '2015-04-01 00:53:28.000000', 'temperatura', 1062.0000, 'ºC'),
	(131225, 110, '2015-04-01 00:53:29.000000', 'temperatura', 842.0000, 'ºC'),
	(131226, 110, '2015-04-01 00:53:30.000000', 'temperatura', 1024.0000, 'ºC'),
	(131227, 110, '2015-04-01 00:53:31.000000', 'temperatura', 193.0000, 'ºC'),
	(131228, 110, '2015-04-01 00:53:32.000000', 'temperatura', 293.0000, 'ºC'),
	(131229, 110, '2015-04-01 00:53:33.000000', 'temperatura', 887.0000, 'ºC'),
	(131230, 110, '2015-04-01 00:53:34.000000', 'temperatura', 1155.0000, 'ºC'),
	(131231, 110, '2015-04-01 00:53:35.000000', 'temperatura', 716.0000, 'ºC'),
	(131232, 110, '2015-04-01 00:53:36.000000', 'temperatura', 117.0000, 'ºC'),
	(131233, 110, '2015-04-01 00:53:37.000000', 'temperatura', 837.0000, 'ºC'),
	(131234, 110, '2015-04-01 00:53:38.000000', 'temperatura', 234.0000, 'ºC'),
	(131235, 110, '2015-04-01 00:53:39.000000', 'temperatura', 1058.0000, 'ºC'),
	(131236, 110, '2015-04-01 00:53:40.000000', 'temperatura', 989.0000, 'ºC'),
	(131237, 110, '2015-04-01 00:53:41.000000', 'temperatura', 574.0000, 'ºC'),
	(131238, 110, '2015-04-01 00:53:42.000000', 'temperatura', 1101.0000, 'ºC'),
	(131239, 110, '2015-04-01 00:53:43.000000', 'temperatura', 186.0000, 'ºC'),
	(131240, 110, '2015-04-01 00:53:44.000000', 'temperatura', 28.0000, 'ºC'),
	(131241, 110, '2015-04-01 00:53:45.000000', 'temperatura', 780.0000, 'ºC'),
	(131242, 110, '2015-04-01 00:53:46.000000', 'temperatura', 218.0000, 'ºC'),
	(131243, 110, '2015-04-01 00:53:47.000000', 'temperatura', 1149.0000, 'ºC'),
	(131244, 110, '2015-04-01 00:53:48.000000', 'temperatura', 294.0000, 'ºC'),
	(131245, 110, '2015-04-01 00:53:49.000000', 'temperatura', 422.0000, 'ºC'),
	(131246, 110, '2015-04-01 00:53:50.000000', 'temperatura', 27.0000, 'ºC'),
	(131247, 110, '2015-04-01 00:53:51.000000', 'temperatura', 69.0000, 'ºC'),
	(131248, 110, '2015-04-01 00:53:52.000000', 'temperatura', 265.0000, 'ºC'),
	(131249, 110, '2015-04-01 00:53:53.000000', 'temperatura', 1118.0000, 'ºC'),
	(131250, 110, '2015-04-01 00:53:54.000000', 'temperatura', 1194.0000, 'ºC'),
	(131251, 110, '2015-04-01 00:53:55.000000', 'temperatura', 219.0000, 'ºC'),
	(131252, 110, '2015-04-01 00:53:56.000000', 'temperatura', 1112.0000, 'ºC'),
	(131253, 110, '2015-04-01 00:53:57.000000', 'temperatura', 103.0000, 'ºC'),
	(131254, 110, '2015-04-01 00:53:58.000000', 'temperatura', 781.0000, 'ºC'),
	(131255, 110, '2015-04-01 00:53:59.000000', 'temperatura', 1197.0000, 'ºC'),
	(131256, 110, '2015-04-01 00:54:00.000000', 'temperatura', 41.0000, 'ºC'),
	(131257, 110, '2015-04-01 00:54:01.000000', 'temperatura', 214.0000, 'ºC'),
	(131258, 110, '2015-04-01 00:54:02.000000', 'temperatura', 947.0000, 'ºC'),
	(131259, 110, '2015-04-01 00:54:03.000000', 'temperatura', 493.0000, 'ºC'),
	(131260, 110, '2015-04-01 00:54:04.000000', 'temperatura', 824.0000, 'ºC'),
	(131261, 110, '2015-04-01 00:54:05.000000', 'temperatura', 241.0000, 'ºC'),
	(131262, 110, '2015-04-01 00:54:06.000000', 'temperatura', 1136.0000, 'ºC'),
	(131263, 110, '2015-04-01 00:54:07.000000', 'temperatura', 154.0000, 'ºC'),
	(131264, 110, '2015-04-01 00:54:08.000000', 'temperatura', 966.0000, 'ºC'),
	(131265, 110, '2015-04-01 00:54:09.000000', 'temperatura', 767.0000, 'ºC'),
	(131266, 110, '2015-04-01 00:54:10.000000', 'temperatura', 938.0000, 'ºC'),
	(131267, 110, '2015-04-01 00:54:11.000000', 'temperatura', 1191.0000, 'ºC'),
	(131268, 110, '2015-04-01 00:54:12.000000', 'temperatura', 740.0000, 'ºC'),
	(131269, 110, '2015-04-01 00:54:13.000000', 'temperatura', 128.0000, 'ºC'),
	(131270, 110, '2015-04-01 00:54:14.000000', 'temperatura', 822.0000, 'ºC'),
	(131271, 110, '2015-04-01 00:54:15.000000', 'temperatura', 125.0000, 'ºC'),
	(131272, 110, '2015-04-01 00:54:16.000000', 'temperatura', 559.0000, 'ºC'),
	(131273, 110, '2015-04-01 00:54:17.000000', 'temperatura', 19.0000, 'ºC'),
	(131274, 110, '2015-04-01 00:54:18.000000', 'temperatura', 820.0000, 'ºC'),
	(131275, 110, '2015-04-01 00:54:19.000000', 'temperatura', 443.0000, 'ºC'),
	(131276, 110, '2015-04-01 00:54:20.000000', 'temperatura', 958.0000, 'ºC'),
	(131277, 110, '2015-04-01 00:54:21.000000', 'temperatura', 1059.0000, 'ºC'),
	(131278, 110, '2015-04-01 00:54:22.000000', 'temperatura', 21.0000, 'ºC'),
	(131279, 110, '2015-04-01 00:54:23.000000', 'temperatura', 528.0000, 'ºC'),
	(131280, 110, '2015-04-01 00:54:24.000000', 'temperatura', 179.0000, 'ºC'),
	(131281, 110, '2015-04-01 00:54:25.000000', 'temperatura', 509.0000, 'ºC'),
	(131282, 110, '2015-04-01 00:54:26.000000', 'temperatura', 812.0000, 'ºC'),
	(131283, 110, '2015-04-01 00:54:27.000000', 'temperatura', 131.0000, 'ºC'),
	(131284, 110, '2015-04-01 00:54:28.000000', 'temperatura', 622.0000, 'ºC'),
	(131285, 110, '2015-04-01 00:54:29.000000', 'temperatura', 314.0000, 'ºC'),
	(131286, 110, '2015-04-01 00:54:30.000000', 'temperatura', 908.0000, 'ºC'),
	(131287, 110, '2015-04-01 00:54:31.000000', 'temperatura', 1195.0000, 'ºC'),
	(131288, 110, '2015-04-01 00:54:32.000000', 'temperatura', 855.0000, 'ºC'),
	(131289, 110, '2015-04-01 00:54:33.000000', 'temperatura', 687.0000, 'ºC'),
	(131290, 110, '2015-04-01 00:54:34.000000', 'temperatura', 872.0000, 'ºC'),
	(131291, 110, '2015-04-01 00:54:35.000000', 'temperatura', 1099.0000, 'ºC'),
	(131292, 110, '2015-04-01 00:54:36.000000', 'temperatura', 482.0000, 'ºC'),
	(131293, 110, '2015-04-01 00:54:37.000000', 'temperatura', 310.0000, 'ºC'),
	(131294, 110, '2015-04-01 00:54:38.000000', 'temperatura', 105.0000, 'ºC'),
	(131295, 110, '2015-04-01 00:54:39.000000', 'temperatura', 798.0000, 'ºC'),
	(131296, 110, '2015-04-01 00:54:40.000000', 'temperatura', 73.0000, 'ºC'),
	(131297, 110, '2015-04-01 00:54:41.000000', 'temperatura', 374.0000, 'ºC'),
	(131298, 110, '2015-04-01 00:54:42.000000', 'temperatura', 450.0000, 'ºC'),
	(131299, 110, '2015-04-01 00:54:43.000000', 'temperatura', 1130.0000, 'ºC'),
	(131300, 110, '2015-04-01 00:54:44.000000', 'temperatura', 698.0000, 'ºC'),
	(131301, 110, '2015-04-01 00:54:45.000000', 'temperatura', 100.0000, 'ºC'),
	(131302, 110, '2015-04-01 00:54:46.000000', 'temperatura', 809.0000, 'ºC'),
	(131303, 110, '2015-04-01 00:54:47.000000', 'temperatura', 145.0000, 'ºC'),
	(131304, 110, '2015-04-01 00:54:48.000000', 'temperatura', 697.0000, 'ºC'),
	(131305, 110, '2015-04-01 00:54:49.000000', 'temperatura', 652.0000, 'ºC'),
	(131306, 110, '2015-04-01 00:54:50.000000', 'temperatura', 1170.0000, 'ºC'),
	(131307, 110, '2015-04-01 00:54:51.000000', 'temperatura', 293.0000, 'ºC'),
	(131308, 110, '2015-04-01 00:54:52.000000', 'temperatura', 358.0000, 'ºC'),
	(131309, 110, '2015-04-01 00:54:53.000000', 'temperatura', 910.0000, 'ºC'),
	(131310, 110, '2015-04-01 00:54:54.000000', 'temperatura', 1077.0000, 'ºC'),
	(131311, 110, '2015-04-01 00:54:55.000000', 'temperatura', 254.0000, 'ºC'),
	(131312, 110, '2015-04-01 00:54:56.000000', 'temperatura', 442.0000, 'ºC'),
	(131313, 110, '2015-04-01 00:54:57.000000', 'temperatura', 246.0000, 'ºC'),
	(131314, 110, '2015-04-01 00:54:58.000000', 'temperatura', 1105.0000, 'ºC'),
	(131315, 110, '2015-04-01 00:54:59.000000', 'temperatura', 1188.0000, 'ºC'),
	(131316, 110, '2015-04-01 00:55:00.000000', 'temperatura', 225.0000, 'ºC'),
	(131317, 110, '2015-04-01 00:55:01.000000', 'temperatura', 1162.0000, 'ºC'),
	(131318, 110, '2015-04-01 00:55:02.000000', 'temperatura', 333.0000, 'ºC'),
	(131319, 110, '2015-04-01 00:55:03.000000', 'temperatura', 583.0000, 'ºC'),
	(131320, 110, '2015-04-01 00:55:04.000000', 'temperatura', 714.0000, 'ºC'),
	(131321, 110, '2015-04-01 00:55:05.000000', 'temperatura', 622.0000, 'ºC'),
	(131322, 110, '2015-04-01 00:55:06.000000', 'temperatura', 971.0000, 'ºC'),
	(131323, 110, '2015-04-01 00:55:07.000000', 'temperatura', 587.0000, 'ºC'),
	(131324, 110, '2015-04-01 00:55:08.000000', 'temperatura', 23.0000, 'ºC'),
	(131325, 110, '2015-04-01 00:55:09.000000', 'temperatura', 756.0000, 'ºC'),
	(131326, 110, '2015-04-01 00:55:10.000000', 'temperatura', 109.0000, 'ºC'),
	(131327, 110, '2015-04-01 00:55:11.000000', 'temperatura', 681.0000, 'ºC'),
	(131328, 110, '2015-04-01 00:55:12.000000', 'temperatura', 675.0000, 'ºC'),
	(131329, 110, '2015-04-01 00:55:13.000000', 'temperatura', 135.0000, 'ºC'),
	(131330, 110, '2015-04-01 00:55:14.000000', 'temperatura', 1049.0000, 'ºC'),
	(131331, 110, '2015-04-01 00:55:15.000000', 'temperatura', 42.0000, 'ºC'),
	(131332, 110, '2015-04-01 00:55:16.000000', 'temperatura', 663.0000, 'ºC'),
	(131333, 110, '2015-04-01 00:55:17.000000', 'temperatura', 787.0000, 'ºC'),
	(131334, 110, '2015-04-01 00:55:18.000000', 'temperatura', 750.0000, 'ºC'),
	(131335, 110, '2015-04-01 00:55:19.000000', 'temperatura', 188.0000, 'ºC'),
	(131336, 110, '2015-04-01 00:55:20.000000', 'temperatura', 1090.0000, 'ºC'),
	(131337, 110, '2015-04-01 00:55:21.000000', 'temperatura', 87.0000, 'ºC'),
	(131338, 110, '2015-04-01 00:55:22.000000', 'temperatura', 766.0000, 'ºC'),
	(131339, 110, '2015-04-01 00:55:23.000000', 'temperatura', 1167.0000, 'ºC'),
	(131340, 110, '2015-04-01 00:55:24.000000', 'temperatura', 1141.0000, 'ºC'),
	(131341, 110, '2015-04-01 00:55:25.000000', 'temperatura', 1002.0000, 'ºC'),
	(131342, 110, '2015-04-01 00:55:26.000000', 'temperatura', 389.0000, 'ºC'),
	(131343, 110, '2015-04-01 00:55:27.000000', 'temperatura', 139.0000, 'ºC'),
	(131344, 110, '2015-04-01 00:55:28.000000', 'temperatura', 727.0000, 'ºC'),
	(131345, 110, '2015-04-01 00:55:29.000000', 'temperatura', 821.0000, 'ºC'),
	(131346, 110, '2015-04-01 00:55:30.000000', 'temperatura', 722.0000, 'ºC'),
	(131347, 110, '2015-04-01 00:55:31.000000', 'temperatura', 1148.0000, 'ºC'),
	(131348, 110, '2015-04-01 00:55:32.000000', 'temperatura', 1175.0000, 'ºC'),
	(131349, 110, '2015-04-01 00:55:33.000000', 'temperatura', 33.0000, 'ºC'),
	(131350, 110, '2015-04-01 00:55:34.000000', 'temperatura', 238.0000, 'ºC'),
	(131351, 110, '2015-04-01 00:55:35.000000', 'temperatura', 1091.0000, 'ºC'),
	(131352, 110, '2015-04-01 00:55:36.000000', 'temperatura', 1145.0000, 'ºC'),
	(131353, 110, '2015-04-01 00:55:37.000000', 'temperatura', 49.0000, 'ºC'),
	(131354, 110, '2015-04-01 00:55:38.000000', 'temperatura', 412.0000, 'ºC'),
	(131355, 110, '2015-04-01 00:55:39.000000', 'temperatura', 714.0000, 'ºC'),
	(131356, 110, '2015-04-01 00:55:40.000000', 'temperatura', 1134.0000, 'ºC'),
	(131357, 110, '2015-04-01 00:55:41.000000', 'temperatura', 1129.0000, 'ºC'),
	(131358, 110, '2015-04-01 00:55:42.000000', 'temperatura', 1045.0000, 'ºC'),
	(131359, 110, '2015-04-01 00:55:43.000000', 'temperatura', 639.0000, 'ºC'),
	(131360, 110, '2015-04-01 00:55:44.000000', 'temperatura', 57.0000, 'ºC'),
	(131361, 110, '2015-04-01 00:55:45.000000', 'temperatura', 771.0000, 'ºC'),
	(131362, 110, '2015-04-01 00:55:46.000000', 'temperatura', 86.0000, 'ºC'),
	(131363, 110, '2015-04-01 00:55:47.000000', 'temperatura', 514.0000, 'ºC'),
	(131364, 110, '2015-04-01 00:55:48.000000', 'temperatura', 1114.0000, 'ºC'),
	(131365, 110, '2015-04-01 00:55:49.000000', 'temperatura', 431.0000, 'ºC'),
	(131366, 110, '2015-04-01 00:55:50.000000', 'temperatura', 10.0000, 'ºC'),
	(131367, 110, '2015-04-01 00:55:51.000000', 'temperatura', 1158.0000, 'ºC'),
	(131368, 110, '2015-04-01 00:55:52.000000', 'temperatura', 960.0000, 'ºC'),
	(131369, 110, '2015-04-01 00:55:53.000000', 'temperatura', 129.0000, 'ºC'),
	(131370, 110, '2015-04-01 00:55:54.000000', 'temperatura', 162.0000, 'ºC'),
	(131371, 110, '2015-04-01 00:55:55.000000', 'temperatura', 426.0000, 'ºC'),
	(131372, 110, '2015-04-01 00:55:56.000000', 'temperatura', 444.0000, 'ºC'),
	(131373, 110, '2015-04-01 00:55:57.000000', 'temperatura', 942.0000, 'ºC'),
	(131374, 110, '2015-04-01 00:55:58.000000', 'temperatura', 979.0000, 'ºC'),
	(131375, 110, '2015-04-01 00:55:59.000000', 'temperatura', 870.0000, 'ºC'),
	(131376, 110, '2015-04-01 00:56:00.000000', 'temperatura', 214.0000, 'ºC'),
	(131377, 110, '2015-04-01 00:56:01.000000', 'temperatura', 861.0000, 'ºC'),
	(131378, 110, '2015-04-01 00:56:02.000000', 'temperatura', 61.0000, 'ºC'),
	(131379, 110, '2015-04-01 00:56:03.000000', 'temperatura', 123.0000, 'ºC'),
	(131380, 110, '2015-04-01 00:56:04.000000', 'temperatura', 434.0000, 'ºC'),
	(131381, 110, '2015-04-01 00:56:05.000000', 'temperatura', 599.0000, 'ºC'),
	(131382, 110, '2015-04-01 00:56:06.000000', 'temperatura', 494.0000, 'ºC'),
	(131383, 110, '2015-04-01 00:56:07.000000', 'temperatura', 673.0000, 'ºC'),
	(131384, 110, '2015-04-01 00:56:08.000000', 'temperatura', 684.0000, 'ºC'),
	(131385, 110, '2015-04-01 00:56:09.000000', 'temperatura', 200.0000, 'ºC'),
	(131386, 110, '2015-04-01 00:56:10.000000', 'temperatura', 150.0000, 'ºC'),
	(131387, 110, '2015-04-01 00:56:11.000000', 'temperatura', 152.0000, 'ºC'),
	(131388, 110, '2015-04-01 00:56:12.000000', 'temperatura', 307.0000, 'ºC'),
	(131389, 110, '2015-04-01 00:56:13.000000', 'temperatura', 1082.0000, 'ºC'),
	(131390, 110, '2015-04-01 00:56:14.000000', 'temperatura', 890.0000, 'ºC'),
	(131391, 110, '2015-04-01 00:56:15.000000', 'temperatura', 4.0000, 'ºC'),
	(131392, 110, '2015-04-01 00:56:16.000000', 'temperatura', 951.0000, 'ºC'),
	(131393, 110, '2015-04-01 00:56:17.000000', 'temperatura', 1141.0000, 'ºC'),
	(131394, 110, '2015-04-01 00:56:18.000000', 'temperatura', 454.0000, 'ºC'),
	(131395, 110, '2015-04-01 00:56:19.000000', 'temperatura', 46.0000, 'ºC'),
	(131396, 110, '2015-04-01 00:56:20.000000', 'temperatura', 68.0000, 'ºC'),
	(131397, 110, '2015-04-01 00:56:21.000000', 'temperatura', 205.0000, 'ºC'),
	(131398, 110, '2015-04-01 00:56:22.000000', 'temperatura', 819.0000, 'ºC'),
	(131399, 110, '2015-04-01 00:56:23.000000', 'temperatura', 1081.0000, 'ºC'),
	(131400, 110, '2015-04-01 00:56:24.000000', 'temperatura', 548.0000, 'ºC'),
	(131401, 110, '2015-04-01 00:56:25.000000', 'temperatura', 699.0000, 'ºC'),
	(131402, 110, '2015-04-01 00:56:26.000000', 'temperatura', 651.0000, 'ºC'),
	(131403, 110, '2015-04-01 00:56:27.000000', 'temperatura', 1160.0000, 'ºC'),
	(131404, 110, '2015-04-01 00:56:28.000000', 'temperatura', 246.0000, 'ºC'),
	(131405, 110, '2015-04-01 00:56:29.000000', 'temperatura', 152.0000, 'ºC'),
	(131406, 110, '2015-04-01 00:56:30.000000', 'temperatura', 21.0000, 'ºC'),
	(131407, 110, '2015-04-01 00:56:31.000000', 'temperatura', 849.0000, 'ºC'),
	(131408, 110, '2015-04-01 00:56:32.000000', 'temperatura', 583.0000, 'ºC'),
	(131409, 110, '2015-04-01 00:56:33.000000', 'temperatura', 370.0000, 'ºC'),
	(131410, 110, '2015-04-01 00:56:34.000000', 'temperatura', 101.0000, 'ºC'),
	(131411, 110, '2015-04-01 00:56:35.000000', 'temperatura', 594.0000, 'ºC'),
	(131412, 110, '2015-04-01 00:56:36.000000', 'temperatura', 269.0000, 'ºC'),
	(131413, 110, '2015-04-01 00:56:37.000000', 'temperatura', 764.0000, 'ºC'),
	(131414, 110, '2015-04-01 00:56:38.000000', 'temperatura', 613.0000, 'ºC'),
	(131415, 110, '2015-04-01 00:56:39.000000', 'temperatura', 772.0000, 'ºC'),
	(131416, 110, '2015-04-01 00:56:40.000000', 'temperatura', 822.0000, 'ºC'),
	(131417, 110, '2015-04-01 00:56:41.000000', 'temperatura', 595.0000, 'ºC'),
	(131418, 110, '2015-04-01 00:56:42.000000', 'temperatura', 510.0000, 'ºC'),
	(131419, 110, '2015-04-01 00:56:43.000000', 'temperatura', 764.0000, 'ºC'),
	(131420, 110, '2015-04-01 00:56:44.000000', 'temperatura', 1092.0000, 'ºC'),
	(131421, 110, '2015-04-01 00:56:45.000000', 'temperatura', 770.0000, 'ºC'),
	(131422, 110, '2015-04-01 00:56:46.000000', 'temperatura', 573.0000, 'ºC'),
	(131423, 110, '2015-04-01 00:56:47.000000', 'temperatura', 556.0000, 'ºC'),
	(131424, 110, '2015-04-01 00:56:48.000000', 'temperatura', 1063.0000, 'ºC'),
	(131425, 110, '2015-04-01 00:56:49.000000', 'temperatura', 46.0000, 'ºC'),
	(131426, 110, '2015-04-01 00:56:50.000000', 'temperatura', 643.0000, 'ºC'),
	(131427, 110, '2015-04-01 00:56:51.000000', 'temperatura', 676.0000, 'ºC'),
	(131428, 110, '2015-04-01 00:56:52.000000', 'temperatura', 253.0000, 'ºC'),
	(131429, 110, '2015-04-01 00:56:53.000000', 'temperatura', 436.0000, 'ºC'),
	(131430, 110, '2015-04-01 00:56:54.000000', 'temperatura', 224.0000, 'ºC'),
	(131431, 110, '2015-04-01 00:56:55.000000', 'temperatura', 1012.0000, 'ºC'),
	(131432, 110, '2015-04-01 00:56:56.000000', 'temperatura', 787.0000, 'ºC'),
	(131433, 110, '2015-04-01 00:56:57.000000', 'temperatura', 899.0000, 'ºC'),
	(131434, 110, '2015-04-01 00:56:58.000000', 'temperatura', 935.0000, 'ºC'),
	(131435, 110, '2015-04-01 00:56:59.000000', 'temperatura', 777.0000, 'ºC'),
	(131436, 110, '2015-04-01 00:57:00.000000', 'temperatura', 1083.0000, 'ºC'),
	(131437, 110, '2015-04-01 00:57:01.000000', 'temperatura', 683.0000, 'ºC'),
	(131438, 110, '2015-04-01 00:57:02.000000', 'temperatura', 168.0000, 'ºC'),
	(131439, 110, '2015-04-01 00:57:03.000000', 'temperatura', 1191.0000, 'ºC'),
	(131440, 110, '2015-04-01 00:57:04.000000', 'temperatura', 650.0000, 'ºC'),
	(131441, 110, '2015-04-01 00:57:05.000000', 'temperatura', 878.0000, 'ºC'),
	(131442, 110, '2015-04-01 00:57:06.000000', 'temperatura', 39.0000, 'ºC'),
	(131443, 110, '2015-04-01 00:57:07.000000', 'temperatura', 1165.0000, 'ºC'),
	(131444, 110, '2015-04-01 00:57:08.000000', 'temperatura', 906.0000, 'ºC'),
	(131445, 110, '2015-04-01 00:57:09.000000', 'temperatura', 1036.0000, 'ºC'),
	(131446, 110, '2015-04-01 00:57:10.000000', 'temperatura', 61.0000, 'ºC'),
	(131447, 110, '2015-04-01 00:57:11.000000', 'temperatura', 797.0000, 'ºC'),
	(131448, 110, '2015-04-01 00:57:12.000000', 'temperatura', 206.0000, 'ºC'),
	(131449, 110, '2015-04-01 00:57:13.000000', 'temperatura', 1036.0000, 'ºC'),
	(131450, 110, '2015-04-01 00:57:14.000000', 'temperatura', 964.0000, 'ºC'),
	(131451, 110, '2015-04-01 00:57:15.000000', 'temperatura', 511.0000, 'ºC'),
	(131452, 110, '2015-04-01 00:57:16.000000', 'temperatura', 862.0000, 'ºC'),
	(131453, 110, '2015-04-01 00:57:17.000000', 'temperatura', 381.0000, 'ºC'),
	(131454, 110, '2015-04-01 00:57:18.000000', 'temperatura', 518.0000, 'ºC'),
	(131455, 110, '2015-04-01 00:57:19.000000', 'temperatura', 247.0000, 'ºC'),
	(131456, 110, '2015-04-01 00:57:20.000000', 'temperatura', 882.0000, 'ºC'),
	(131457, 110, '2015-04-01 00:57:21.000000', 'temperatura', 68.0000, 'ºC'),
	(131458, 110, '2015-04-01 00:57:22.000000', 'temperatura', 97.0000, 'ºC'),
	(131459, 110, '2015-04-01 00:57:23.000000', 'temperatura', 279.0000, 'ºC'),
	(131460, 110, '2015-04-01 00:57:24.000000', 'temperatura', 1106.0000, 'ºC'),
	(131461, 110, '2015-04-01 00:57:25.000000', 'temperatura', 1093.0000, 'ºC'),
	(131462, 110, '2015-04-01 00:57:26.000000', 'temperatura', 949.0000, 'ºC'),
	(131463, 110, '2015-04-01 00:57:27.000000', 'temperatura', 264.0000, 'ºC'),
	(131464, 110, '2015-04-01 00:57:28.000000', 'temperatura', 876.0000, 'ºC'),
	(131465, 110, '2015-04-01 00:57:29.000000', 'temperatura', 1188.0000, 'ºC'),
	(131466, 110, '2015-04-01 00:57:30.000000', 'temperatura', 911.0000, 'ºC'),
	(131467, 110, '2015-04-01 00:57:31.000000', 'temperatura', 990.0000, 'ºC'),
	(131468, 110, '2015-04-01 00:57:32.000000', 'temperatura', 1021.0000, 'ºC'),
	(131469, 110, '2015-04-01 00:57:33.000000', 'temperatura', 935.0000, 'ºC'),
	(131470, 110, '2015-04-01 00:57:34.000000', 'temperatura', 410.0000, 'ºC'),
	(131471, 110, '2015-04-01 00:57:35.000000', 'temperatura', 449.0000, 'ºC'),
	(131472, 110, '2015-04-01 00:57:36.000000', 'temperatura', 1012.0000, 'ºC'),
	(131473, 110, '2015-04-01 00:57:37.000000', 'temperatura', 115.0000, 'ºC'),
	(131474, 110, '2015-04-01 00:57:38.000000', 'temperatura', 1138.0000, 'ºC'),
	(131475, 110, '2015-04-01 00:57:39.000000', 'temperatura', 545.0000, 'ºC'),
	(131476, 110, '2015-04-01 00:57:40.000000', 'temperatura', 511.0000, 'ºC'),
	(131477, 110, '2015-04-01 00:57:41.000000', 'temperatura', 922.0000, 'ºC'),
	(131478, 110, '2015-04-01 00:57:42.000000', 'temperatura', 678.0000, 'ºC'),
	(131479, 110, '2015-04-01 00:57:43.000000', 'temperatura', 623.0000, 'ºC'),
	(131480, 110, '2015-04-01 00:57:44.000000', 'temperatura', 1083.0000, 'ºC'),
	(131481, 110, '2015-04-01 00:57:45.000000', 'temperatura', 1145.0000, 'ºC'),
	(131482, 110, '2015-04-01 00:57:46.000000', 'temperatura', 76.0000, 'ºC'),
	(131483, 110, '2015-04-01 00:57:47.000000', 'temperatura', 546.0000, 'ºC'),
	(131484, 110, '2015-04-01 00:57:48.000000', 'temperatura', 102.0000, 'ºC'),
	(131485, 110, '2015-04-01 00:57:49.000000', 'temperatura', 73.0000, 'ºC'),
	(131486, 110, '2015-04-01 00:57:50.000000', 'temperatura', 61.0000, 'ºC'),
	(131487, 110, '2015-04-01 00:57:51.000000', 'temperatura', 85.0000, 'ºC'),
	(131488, 110, '2015-04-01 00:57:52.000000', 'temperatura', 243.0000, 'ºC'),
	(131489, 110, '2015-04-01 00:57:53.000000', 'temperatura', 960.0000, 'ºC'),
	(131490, 110, '2015-04-01 00:57:54.000000', 'temperatura', 472.0000, 'ºC'),
	(131491, 110, '2015-04-01 00:57:55.000000', 'temperatura', 681.0000, 'ºC'),
	(131492, 110, '2015-04-01 00:57:56.000000', 'temperatura', 791.0000, 'ºC'),
	(131493, 110, '2015-04-01 00:57:57.000000', 'temperatura', 710.0000, 'ºC'),
	(131494, 110, '2015-04-01 00:57:58.000000', 'temperatura', 1180.0000, 'ºC'),
	(131495, 110, '2015-04-01 00:57:59.000000', 'temperatura', 167.0000, 'ºC'),
	(131496, 110, '2015-04-01 00:58:00.000000', 'temperatura', 899.0000, 'ºC'),
	(131497, 110, '2015-04-01 00:58:01.000000', 'temperatura', 393.0000, 'ºC'),
	(131498, 110, '2015-04-01 00:58:02.000000', 'temperatura', 468.0000, 'ºC'),
	(131499, 110, '2015-04-01 00:58:03.000000', 'temperatura', 1161.0000, 'ºC'),
	(131500, 110, '2015-04-01 00:58:04.000000', 'temperatura', 803.0000, 'ºC'),
	(131501, 110, '2015-04-01 00:58:05.000000', 'temperatura', 531.0000, 'ºC'),
	(131502, 110, '2015-04-01 00:58:06.000000', 'temperatura', 249.0000, 'ºC'),
	(131503, 110, '2015-04-01 00:58:07.000000', 'temperatura', 850.0000, 'ºC'),
	(131504, 110, '2015-04-01 00:58:08.000000', 'temperatura', 1104.0000, 'ºC'),
	(131505, 110, '2015-04-01 00:58:09.000000', 'temperatura', 569.0000, 'ºC'),
	(131506, 110, '2015-04-01 00:58:10.000000', 'temperatura', 736.0000, 'ºC'),
	(131507, 110, '2015-04-01 00:58:11.000000', 'temperatura', 771.0000, 'ºC'),
	(131508, 110, '2015-04-01 00:58:12.000000', 'temperatura', 448.0000, 'ºC'),
	(131509, 110, '2015-04-01 00:58:13.000000', 'temperatura', 1127.0000, 'ºC'),
	(131510, 110, '2015-04-01 00:58:14.000000', 'temperatura', 693.0000, 'ºC'),
	(131511, 110, '2015-04-01 00:58:15.000000', 'temperatura', 82.0000, 'ºC'),
	(131512, 110, '2015-04-01 00:58:16.000000', 'temperatura', 732.0000, 'ºC'),
	(131513, 110, '2015-04-01 00:58:17.000000', 'temperatura', 1016.0000, 'ºC'),
	(131514, 110, '2015-04-01 00:58:18.000000', 'temperatura', 483.0000, 'ºC'),
	(131515, 110, '2015-04-01 00:58:19.000000', 'temperatura', 567.0000, 'ºC'),
	(131516, 110, '2015-04-01 00:58:20.000000', 'temperatura', 189.0000, 'ºC'),
	(131517, 110, '2015-04-01 00:58:21.000000', 'temperatura', 443.0000, 'ºC'),
	(131518, 110, '2015-04-01 00:58:22.000000', 'temperatura', 450.0000, 'ºC'),
	(131519, 110, '2015-04-01 00:58:23.000000', 'temperatura', 919.0000, 'ºC'),
	(131520, 110, '2015-04-01 00:58:24.000000', 'temperatura', 847.0000, 'ºC'),
	(131521, 110, '2015-04-01 00:58:25.000000', 'temperatura', 280.0000, 'ºC'),
	(131522, 110, '2015-04-01 00:58:26.000000', 'temperatura', 58.0000, 'ºC'),
	(131523, 110, '2015-04-01 00:58:27.000000', 'temperatura', 650.0000, 'ºC'),
	(131524, 110, '2015-04-01 00:58:28.000000', 'temperatura', 679.0000, 'ºC'),
	(131525, 110, '2015-04-01 00:58:29.000000', 'temperatura', 245.0000, 'ºC'),
	(131526, 110, '2015-04-01 00:58:30.000000', 'temperatura', 386.0000, 'ºC'),
	(131527, 110, '2015-04-01 00:58:31.000000', 'temperatura', 1197.0000, 'ºC'),
	(131528, 110, '2015-04-01 00:58:32.000000', 'temperatura', 29.0000, 'ºC'),
	(131529, 110, '2015-04-01 00:58:33.000000', 'temperatura', 154.0000, 'ºC'),
	(131530, 110, '2015-04-01 00:58:34.000000', 'temperatura', 684.0000, 'ºC'),
	(131531, 110, '2015-04-01 00:58:35.000000', 'temperatura', 559.0000, 'ºC'),
	(131532, 110, '2015-04-01 00:58:36.000000', 'temperatura', 744.0000, 'ºC'),
	(131533, 110, '2015-04-01 00:58:37.000000', 'temperatura', 844.0000, 'ºC'),
	(131534, 110, '2015-04-01 00:58:38.000000', 'temperatura', 789.0000, 'ºC'),
	(131535, 110, '2015-04-01 00:58:39.000000', 'temperatura', 211.0000, 'ºC'),
	(131536, 110, '2015-04-01 00:58:40.000000', 'temperatura', 1091.0000, 'ºC'),
	(131537, 110, '2015-04-01 00:58:41.000000', 'temperatura', 22.0000, 'ºC'),
	(131538, 110, '2015-04-01 00:58:42.000000', 'temperatura', 437.0000, 'ºC'),
	(131539, 110, '2015-04-01 00:58:43.000000', 'temperatura', 921.0000, 'ºC'),
	(131540, 110, '2015-04-01 00:58:44.000000', 'temperatura', 892.0000, 'ºC'),
	(131541, 110, '2015-04-01 00:58:45.000000', 'temperatura', 499.0000, 'ºC'),
	(131542, 110, '2015-04-01 00:58:46.000000', 'temperatura', 1017.0000, 'ºC'),
	(131543, 110, '2015-04-01 00:58:47.000000', 'temperatura', 1191.0000, 'ºC'),
	(131544, 110, '2015-04-01 00:58:48.000000', 'temperatura', 502.0000, 'ºC'),
	(131545, 110, '2015-04-01 00:58:49.000000', 'temperatura', 138.0000, 'ºC'),
	(131546, 110, '2015-04-01 00:58:50.000000', 'temperatura', 387.0000, 'ºC'),
	(131547, 110, '2015-04-01 00:58:51.000000', 'temperatura', 319.0000, 'ºC'),
	(131548, 110, '2015-04-01 00:58:52.000000', 'temperatura', 436.0000, 'ºC'),
	(131549, 110, '2015-04-01 00:58:53.000000', 'temperatura', 24.0000, 'ºC'),
	(131550, 110, '2015-04-01 00:58:54.000000', 'temperatura', 12.0000, 'ºC'),
	(131551, 110, '2015-04-01 00:58:55.000000', 'temperatura', 1189.0000, 'ºC'),
	(131552, 110, '2015-04-01 00:58:56.000000', 'temperatura', 1111.0000, 'ºC'),
	(131553, 110, '2015-04-01 00:58:57.000000', 'temperatura', 787.0000, 'ºC'),
	(131554, 110, '2015-04-01 00:58:58.000000', 'temperatura', 605.0000, 'ºC'),
	(131555, 110, '2015-04-01 00:58:59.000000', 'temperatura', 662.0000, 'ºC'),
	(131556, 110, '2015-04-01 00:59:00.000000', 'temperatura', 295.0000, 'ºC'),
	(131557, 110, '2015-04-01 00:59:01.000000', 'temperatura', 690.0000, 'ºC'),
	(131558, 110, '2015-04-01 00:59:02.000000', 'temperatura', 164.0000, 'ºC'),
	(131559, 110, '2015-04-01 00:59:03.000000', 'temperatura', 1152.0000, 'ºC'),
	(131560, 110, '2015-04-01 00:59:04.000000', 'temperatura', 466.0000, 'ºC'),
	(131561, 110, '2015-04-01 00:59:05.000000', 'temperatura', 77.0000, 'ºC'),
	(131562, 110, '2015-04-01 00:59:06.000000', 'temperatura', 186.0000, 'ºC'),
	(131563, 110, '2015-04-01 00:59:07.000000', 'temperatura', 702.0000, 'ºC'),
	(131564, 110, '2015-04-01 00:59:08.000000', 'temperatura', 551.0000, 'ºC'),
	(131565, 110, '2015-04-01 00:59:09.000000', 'temperatura', 650.0000, 'ºC'),
	(131566, 110, '2015-04-01 00:59:10.000000', 'temperatura', 397.0000, 'ºC'),
	(131567, 110, '2015-04-01 00:59:11.000000', 'temperatura', 35.0000, 'ºC'),
	(131568, 110, '2015-04-01 00:59:12.000000', 'temperatura', 184.0000, 'ºC'),
	(131569, 110, '2015-04-01 00:59:13.000000', 'temperatura', 816.0000, 'ºC'),
	(131570, 110, '2015-04-01 00:59:14.000000', 'temperatura', 1129.0000, 'ºC'),
	(131571, 110, '2015-04-01 00:59:15.000000', 'temperatura', 799.0000, 'ºC'),
	(131572, 110, '2015-04-01 00:59:16.000000', 'temperatura', 606.0000, 'ºC'),
	(131573, 110, '2015-04-01 00:59:17.000000', 'temperatura', 636.0000, 'ºC'),
	(131574, 110, '2015-04-01 00:59:18.000000', 'temperatura', 162.0000, 'ºC'),
	(131575, 110, '2015-04-01 00:59:19.000000', 'temperatura', 102.0000, 'ºC'),
	(131576, 110, '2015-04-01 00:59:20.000000', 'temperatura', 24.0000, 'ºC'),
	(131577, 110, '2015-04-01 00:59:21.000000', 'temperatura', 1013.0000, 'ºC'),
	(131578, 110, '2015-04-01 00:59:22.000000', 'temperatura', 197.0000, 'ºC'),
	(131579, 110, '2015-04-01 00:59:23.000000', 'temperatura', 343.0000, 'ºC'),
	(131580, 110, '2015-04-01 00:59:24.000000', 'temperatura', 1127.0000, 'ºC'),
	(131581, 110, '2015-04-01 00:59:25.000000', 'temperatura', 1006.0000, 'ºC'),
	(131582, 110, '2015-04-01 00:59:26.000000', 'temperatura', 451.0000, 'ºC'),
	(131583, 110, '2015-04-01 00:59:27.000000', 'temperatura', 437.0000, 'ºC'),
	(131584, 110, '2015-04-01 00:59:28.000000', 'temperatura', 830.0000, 'ºC'),
	(131585, 110, '2015-04-01 00:59:29.000000', 'temperatura', 442.0000, 'ºC'),
	(131586, 110, '2015-04-01 00:59:30.000000', 'temperatura', 919.0000, 'ºC'),
	(131587, 110, '2015-04-01 00:59:31.000000', 'temperatura', 871.0000, 'ºC'),
	(131588, 110, '2015-04-01 00:59:32.000000', 'temperatura', 396.0000, 'ºC'),
	(131589, 110, '2015-04-01 00:59:33.000000', 'temperatura', 568.0000, 'ºC'),
	(131590, 110, '2015-04-01 00:59:34.000000', 'temperatura', 455.0000, 'ºC'),
	(131591, 110, '2015-04-01 00:59:35.000000', 'temperatura', 570.0000, 'ºC'),
	(131592, 110, '2015-04-01 00:59:36.000000', 'temperatura', 284.0000, 'ºC'),
	(131593, 110, '2015-04-01 00:59:37.000000', 'temperatura', 910.0000, 'ºC'),
	(131594, 110, '2015-04-01 00:59:38.000000', 'temperatura', 99.0000, 'ºC'),
	(131595, 110, '2015-04-01 00:59:39.000000', 'temperatura', 165.0000, 'ºC'),
	(131596, 110, '2015-04-01 00:59:40.000000', 'temperatura', 528.0000, 'ºC'),
	(131597, 110, '2015-04-01 00:59:41.000000', 'temperatura', 948.0000, 'ºC'),
	(131598, 110, '2015-04-01 00:59:42.000000', 'temperatura', 756.0000, 'ºC'),
	(131599, 110, '2015-04-01 00:59:43.000000', 'temperatura', 934.0000, 'ºC'),
	(131600, 110, '2015-04-01 00:59:44.000000', 'temperatura', 5.0000, 'ºC'),
	(131601, 110, '2015-04-01 00:59:45.000000', 'temperatura', 825.0000, 'ºC'),
	(131602, 110, '2015-04-01 00:59:46.000000', 'temperatura', 508.0000, 'ºC'),
	(131603, 110, '2015-04-01 00:59:47.000000', 'temperatura', 68.0000, 'ºC'),
	(131604, 110, '2015-04-01 00:59:48.000000', 'temperatura', 13.0000, 'ºC'),
	(131605, 110, '2015-04-01 00:59:49.000000', 'temperatura', 1064.0000, 'ºC'),
	(131606, 110, '2015-04-01 00:59:50.000000', 'temperatura', 481.0000, 'ºC'),
	(131607, 110, '2015-04-01 00:59:51.000000', 'temperatura', 414.0000, 'ºC'),
	(131608, 110, '2015-04-01 00:59:52.000000', 'temperatura', 629.0000, 'ºC'),
	(131609, 110, '2015-04-01 00:59:53.000000', 'temperatura', 702.0000, 'ºC'),
	(131610, 110, '2015-04-01 00:59:54.000000', 'temperatura', 423.0000, 'ºC'),
	(131611, 110, '2015-04-01 00:59:55.000000', 'temperatura', 10.0000, 'ºC'),
	(131612, 110, '2015-04-01 00:59:56.000000', 'temperatura', 1180.0000, 'ºC'),
	(131613, 110, '2015-04-01 00:59:57.000000', 'temperatura', 1073.0000, 'ºC'),
	(131614, 110, '2015-04-01 00:59:58.000000', 'temperatura', 625.0000, 'ºC'),
	(131615, 110, '2015-04-01 00:59:59.000000', 'temperatura', 1107.0000, 'ºC'),
	(131616, 110, '2015-04-01 01:00:00.000000', 'temperatura', 60.0000, 'ºC'),
	(131617, 110, '2015-04-01 01:00:01.000000', 'temperatura', 580.0000, 'ºC'),
	(131618, 110, '2015-04-01 01:00:02.000000', 'temperatura', 320.0000, 'ºC'),
	(131619, 110, '2015-04-01 01:00:03.000000', 'temperatura', 1059.0000, 'ºC'),
	(131620, 110, '2015-04-01 01:00:04.000000', 'temperatura', 735.0000, 'ºC'),
	(131621, 110, '2015-04-01 01:00:05.000000', 'temperatura', 498.0000, 'ºC'),
	(131622, 110, '2015-04-01 01:00:06.000000', 'temperatura', 286.0000, 'ºC'),
	(131623, 110, '2015-04-01 01:00:07.000000', 'temperatura', 1136.0000, 'ºC'),
	(131624, 110, '2015-04-01 01:00:08.000000', 'temperatura', 23.0000, 'ºC'),
	(131625, 110, '2015-04-01 01:00:09.000000', 'temperatura', 307.0000, 'ºC'),
	(131626, 110, '2015-04-01 01:00:10.000000', 'temperatura', 267.0000, 'ºC'),
	(131627, 110, '2015-04-01 01:00:11.000000', 'temperatura', 413.0000, 'ºC'),
	(131628, 110, '2015-04-01 01:00:12.000000', 'temperatura', 66.0000, 'ºC'),
	(131629, 110, '2015-04-01 01:00:13.000000', 'temperatura', 291.0000, 'ºC'),
	(131630, 110, '2015-04-01 01:00:14.000000', 'temperatura', 56.0000, 'ºC'),
	(131631, 110, '2015-04-01 01:00:15.000000', 'temperatura', 607.0000, 'ºC'),
	(131632, 110, '2015-04-01 01:00:16.000000', 'temperatura', 468.0000, 'ºC'),
	(131633, 110, '2015-04-01 01:00:17.000000', 'temperatura', 521.0000, 'ºC'),
	(131634, 110, '2015-04-01 01:00:18.000000', 'temperatura', 1199.0000, 'ºC'),
	(131635, 110, '2015-04-01 01:00:19.000000', 'temperatura', 833.0000, 'ºC'),
	(131636, 110, '2015-04-01 01:00:20.000000', 'temperatura', 568.0000, 'ºC'),
	(131637, 110, '2015-04-01 01:00:21.000000', 'temperatura', 343.0000, 'ºC'),
	(131638, 110, '2015-04-01 01:00:22.000000', 'temperatura', 12.0000, 'ºC'),
	(131639, 110, '2015-04-01 01:00:23.000000', 'temperatura', 231.0000, 'ºC'),
	(131640, 110, '2015-04-01 01:00:24.000000', 'temperatura', 1119.0000, 'ºC'),
	(131641, 110, '2015-04-01 01:00:25.000000', 'temperatura', 102.0000, 'ºC'),
	(131642, 110, '2015-04-01 01:00:26.000000', 'temperatura', 755.0000, 'ºC'),
	(131643, 110, '2015-04-01 01:00:27.000000', 'temperatura', 1070.0000, 'ºC'),
	(131644, 110, '2015-04-01 01:00:28.000000', 'temperatura', 685.0000, 'ºC'),
	(131645, 110, '2015-04-01 01:00:29.000000', 'temperatura', 217.0000, 'ºC'),
	(131646, 110, '2015-04-01 01:00:30.000000', 'temperatura', 228.0000, 'ºC'),
	(131647, 110, '2015-04-01 01:00:31.000000', 'temperatura', 491.0000, 'ºC'),
	(131648, 110, '2015-04-01 01:00:32.000000', 'temperatura', 570.0000, 'ºC'),
	(131649, 110, '2015-04-01 01:00:33.000000', 'temperatura', 178.0000, 'ºC'),
	(131650, 110, '2015-04-01 01:00:34.000000', 'temperatura', 382.0000, 'ºC'),
	(131651, 110, '2015-04-01 01:00:35.000000', 'temperatura', 176.0000, 'ºC'),
	(131652, 110, '2015-04-01 01:00:36.000000', 'temperatura', 936.0000, 'ºC'),
	(131653, 110, '2015-04-01 01:00:37.000000', 'temperatura', 551.0000, 'ºC'),
	(131654, 110, '2015-04-01 01:00:38.000000', 'temperatura', 1149.0000, 'ºC'),
	(131655, 110, '2015-04-01 01:00:39.000000', 'temperatura', 492.0000, 'ºC'),
	(131656, 110, '2015-04-01 01:00:40.000000', 'temperatura', 212.0000, 'ºC'),
	(131657, 110, '2015-04-01 01:00:41.000000', 'temperatura', 786.0000, 'ºC'),
	(131658, 110, '2015-04-01 01:00:42.000000', 'temperatura', 896.0000, 'ºC'),
	(131659, 110, '2015-04-01 01:00:43.000000', 'temperatura', 920.0000, 'ºC'),
	(131660, 110, '2015-04-01 01:00:44.000000', 'temperatura', 715.0000, 'ºC'),
	(131661, 110, '2015-04-01 01:00:45.000000', 'temperatura', 812.0000, 'ºC'),
	(131662, 110, '2015-04-01 01:00:46.000000', 'temperatura', 719.0000, 'ºC'),
	(131663, 110, '2015-04-01 01:00:47.000000', 'temperatura', 1158.0000, 'ºC'),
	(131664, 110, '2015-04-01 01:00:48.000000', 'temperatura', 35.0000, 'ºC'),
	(131665, 110, '2015-04-01 01:00:49.000000', 'temperatura', 301.0000, 'ºC'),
	(131666, 110, '2015-04-01 01:00:50.000000', 'temperatura', 201.0000, 'ºC'),
	(131667, 110, '2015-04-01 01:00:51.000000', 'temperatura', 100.0000, 'ºC'),
	(131668, 110, '2015-04-01 01:00:52.000000', 'temperatura', 1100.0000, 'ºC'),
	(131669, 110, '2015-04-01 01:00:53.000000', 'temperatura', 399.0000, 'ºC'),
	(131670, 110, '2015-04-01 01:00:54.000000', 'temperatura', 1098.0000, 'ºC'),
	(131671, 110, '2015-04-01 01:00:55.000000', 'temperatura', 693.0000, 'ºC'),
	(131672, 110, '2015-04-01 01:00:56.000000', 'temperatura', 169.0000, 'ºC'),
	(131673, 110, '2015-04-01 01:00:57.000000', 'temperatura', 1167.0000, 'ºC'),
	(131674, 110, '2015-04-01 01:00:58.000000', 'temperatura', 530.0000, 'ºC'),
	(131675, 110, '2015-04-01 01:00:59.000000', 'temperatura', 349.0000, 'ºC'),
	(131676, 110, '2015-04-01 01:01:00.000000', 'temperatura', 154.0000, 'ºC'),
	(131677, 110, '2015-04-01 01:01:01.000000', 'temperatura', 926.0000, 'ºC'),
	(131678, 110, '2015-04-01 01:01:02.000000', 'temperatura', 567.0000, 'ºC'),
	(131679, 110, '2015-04-01 01:01:03.000000', 'temperatura', 58.0000, 'ºC'),
	(131680, 110, '2015-04-01 01:01:04.000000', 'temperatura', 989.0000, 'ºC'),
	(131681, 110, '2015-04-01 01:01:05.000000', 'temperatura', 1170.0000, 'ºC'),
	(131682, 110, '2015-04-01 01:01:06.000000', 'temperatura', 486.0000, 'ºC'),
	(131683, 110, '2015-04-01 01:01:07.000000', 'temperatura', 120.0000, 'ºC'),
	(131684, 110, '2015-04-01 01:01:08.000000', 'temperatura', 340.0000, 'ºC'),
	(131685, 110, '2015-04-01 01:01:09.000000', 'temperatura', 144.0000, 'ºC'),
	(131686, 110, '2015-04-01 01:01:10.000000', 'temperatura', 898.0000, 'ºC'),
	(131687, 110, '2015-04-01 01:01:11.000000', 'temperatura', 458.0000, 'ºC'),
	(131688, 110, '2015-04-01 01:01:12.000000', 'temperatura', 799.0000, 'ºC'),
	(131689, 110, '2015-04-01 01:01:13.000000', 'temperatura', 222.0000, 'ºC'),
	(131690, 110, '2015-04-01 01:01:14.000000', 'temperatura', 1113.0000, 'ºC'),
	(131691, 110, '2015-04-01 01:01:15.000000', 'temperatura', 98.0000, 'ºC'),
	(131692, 110, '2015-04-01 01:01:16.000000', 'temperatura', 753.0000, 'ºC'),
	(131693, 110, '2015-04-01 01:01:17.000000', 'temperatura', 1071.0000, 'ºC'),
	(131694, 110, '2015-04-01 01:01:18.000000', 'temperatura', 695.0000, 'ºC'),
	(131695, 110, '2015-04-01 01:01:19.000000', 'temperatura', 265.0000, 'ºC'),
	(131696, 110, '2015-04-01 01:01:20.000000', 'temperatura', 439.0000, 'ºC'),
	(131697, 110, '2015-04-01 01:01:21.000000', 'temperatura', 200.0000, 'ºC'),
	(131698, 110, '2015-04-01 01:01:22.000000', 'temperatura', 883.0000, 'ºC'),
	(131699, 110, '2015-04-01 01:01:23.000000', 'temperatura', 217.0000, 'ºC'),
	(131700, 110, '2015-04-01 01:01:24.000000', 'temperatura', 838.0000, 'ºC'),
	(131701, 110, '2015-04-01 01:01:25.000000', 'temperatura', 1137.0000, 'ºC'),
	(131702, 110, '2015-04-01 01:01:26.000000', 'temperatura', 773.0000, 'ºC'),
	(131703, 110, '2015-04-01 01:01:27.000000', 'temperatura', 452.0000, 'ºC'),
	(131704, 110, '2015-04-01 01:01:28.000000', 'temperatura', 1142.0000, 'ºC'),
	(131705, 110, '2015-04-01 01:01:29.000000', 'temperatura', 756.0000, 'ºC'),
	(131706, 110, '2015-04-01 01:01:30.000000', 'temperatura', 354.0000, 'ºC'),
	(131707, 110, '2015-04-01 01:01:31.000000', 'temperatura', 704.0000, 'ºC'),
	(131708, 110, '2015-04-01 01:01:32.000000', 'temperatura', 59.0000, 'ºC'),
	(131709, 110, '2015-04-01 01:01:33.000000', 'temperatura', 581.0000, 'ºC'),
	(131710, 110, '2015-04-01 01:01:34.000000', 'temperatura', 329.0000, 'ºC'),
	(131711, 110, '2015-04-01 01:01:35.000000', 'temperatura', 1101.0000, 'ºC'),
	(131712, 110, '2015-04-01 01:01:36.000000', 'temperatura', 922.0000, 'ºC'),
	(131713, 110, '2015-04-01 01:01:37.000000', 'temperatura', 104.0000, 'ºC'),
	(131714, 110, '2015-04-01 01:01:38.000000', 'temperatura', 156.0000, 'ºC'),
	(131715, 110, '2015-04-01 01:01:39.000000', 'temperatura', 468.0000, 'ºC'),
	(131716, 110, '2015-04-01 01:01:40.000000', 'temperatura', 671.0000, 'ºC'),
	(131717, 110, '2015-04-01 01:01:41.000000', 'temperatura', 754.0000, 'ºC'),
	(131718, 110, '2015-04-01 01:01:42.000000', 'temperatura', 558.0000, 'ºC'),
	(131719, 110, '2015-04-01 01:01:43.000000', 'temperatura', 528.0000, 'ºC'),
	(131720, 110, '2015-04-01 01:01:44.000000', 'temperatura', 968.0000, 'ºC'),
	(131721, 110, '2015-04-01 01:01:45.000000', 'temperatura', 855.0000, 'ºC'),
	(131722, 110, '2015-04-01 01:01:46.000000', 'temperatura', 170.0000, 'ºC'),
	(131723, 110, '2015-04-01 01:01:47.000000', 'temperatura', 686.0000, 'ºC'),
	(131724, 110, '2015-04-01 01:01:48.000000', 'temperatura', 521.0000, 'ºC'),
	(131725, 110, '2015-04-01 01:01:49.000000', 'temperatura', 549.0000, 'ºC'),
	(131726, 110, '2015-04-01 01:01:50.000000', 'temperatura', 1180.0000, 'ºC'),
	(131727, 110, '2015-04-01 01:01:51.000000', 'temperatura', 656.0000, 'ºC'),
	(131728, 110, '2015-04-01 01:01:52.000000', 'temperatura', 938.0000, 'ºC'),
	(131729, 110, '2015-04-01 01:01:53.000000', 'temperatura', 325.0000, 'ºC'),
	(131730, 110, '2015-04-01 01:01:54.000000', 'temperatura', 12.0000, 'ºC'),
	(131731, 110, '2015-04-01 01:01:55.000000', 'temperatura', 286.0000, 'ºC'),
	(131732, 110, '2015-04-01 01:01:56.000000', 'temperatura', 194.0000, 'ºC'),
	(131733, 110, '2015-04-01 01:01:57.000000', 'temperatura', 112.0000, 'ºC'),
	(131734, 110, '2015-04-01 01:01:58.000000', 'temperatura', 1181.0000, 'ºC'),
	(131735, 110, '2015-04-01 01:01:59.000000', 'temperatura', 766.0000, 'ºC'),
	(131736, 110, '2015-04-01 01:02:00.000000', 'temperatura', 289.0000, 'ºC'),
	(131737, 110, '2015-04-01 01:02:01.000000', 'temperatura', 346.0000, 'ºC'),
	(131738, 110, '2015-04-01 01:02:02.000000', 'temperatura', 863.0000, 'ºC'),
	(131739, 110, '2015-04-01 01:02:03.000000', 'temperatura', 878.0000, 'ºC'),
	(131740, 110, '2015-04-01 01:02:04.000000', 'temperatura', 600.0000, 'ºC'),
	(131741, 110, '2015-04-01 01:02:05.000000', 'temperatura', 369.0000, 'ºC'),
	(131742, 110, '2015-04-01 01:02:06.000000', 'temperatura', 44.0000, 'ºC'),
	(131743, 110, '2015-04-01 01:02:07.000000', 'temperatura', 315.0000, 'ºC'),
	(131744, 110, '2015-04-01 01:02:08.000000', 'temperatura', 241.0000, 'ºC'),
	(131745, 110, '2015-04-01 01:02:09.000000', 'temperatura', 261.0000, 'ºC'),
	(131746, 110, '2015-04-01 01:02:10.000000', 'temperatura', 581.0000, 'ºC'),
	(131747, 110, '2015-04-01 01:02:11.000000', 'temperatura', 925.0000, 'ºC'),
	(131748, 110, '2015-04-01 01:02:12.000000', 'temperatura', 481.0000, 'ºC'),
	(131749, 110, '2015-04-01 01:02:13.000000', 'temperatura', 829.0000, 'ºC'),
	(131750, 110, '2015-04-01 01:02:14.000000', 'temperatura', 305.0000, 'ºC'),
	(131751, 110, '2015-04-01 01:02:15.000000', 'temperatura', 237.0000, 'ºC'),
	(131752, 110, '2015-04-01 01:02:16.000000', 'temperatura', 270.0000, 'ºC'),
	(131753, 110, '2015-04-01 01:02:17.000000', 'temperatura', 642.0000, 'ºC'),
	(131754, 110, '2015-04-01 01:02:18.000000', 'temperatura', 1199.0000, 'ºC'),
	(131755, 110, '2015-04-01 01:02:19.000000', 'temperatura', 472.0000, 'ºC'),
	(131756, 110, '2015-04-01 01:02:20.000000', 'temperatura', 1161.0000, 'ºC'),
	(131757, 110, '2015-04-01 01:02:21.000000', 'temperatura', 788.0000, 'ºC'),
	(131758, 110, '2015-04-01 01:02:22.000000', 'temperatura', 461.0000, 'ºC'),
	(131759, 110, '2015-04-01 01:02:23.000000', 'temperatura', 1139.0000, 'ºC'),
	(131760, 110, '2015-04-01 01:02:24.000000', 'temperatura', 715.0000, 'ºC'),
	(131761, 110, '2015-04-01 01:02:25.000000', 'temperatura', 158.0000, 'ºC'),
	(131762, 110, '2015-04-01 01:02:26.000000', 'temperatura', 1047.0000, 'ºC'),
	(131763, 110, '2015-04-01 01:02:27.000000', 'temperatura', 1159.0000, 'ºC'),
	(131764, 110, '2015-04-01 01:02:28.000000', 'temperatura', 257.0000, 'ºC'),
	(131765, 110, '2015-04-01 01:02:29.000000', 'temperatura', 205.0000, 'ºC'),
	(131766, 110, '2015-04-01 01:02:30.000000', 'temperatura', 258.0000, 'ºC'),
	(131767, 110, '2015-04-01 01:02:31.000000', 'temperatura', 675.0000, 'ºC'),
	(131768, 110, '2015-04-01 01:02:32.000000', 'temperatura', 199.0000, 'ºC'),
	(131769, 110, '2015-04-01 01:02:33.000000', 'temperatura', 172.0000, 'ºC'),
	(131770, 110, '2015-04-01 01:02:34.000000', 'temperatura', 265.0000, 'ºC'),
	(131771, 110, '2015-04-01 01:02:35.000000', 'temperatura', 807.0000, 'ºC'),
	(131772, 110, '2015-04-01 01:02:36.000000', 'temperatura', 843.0000, 'ºC'),
	(131773, 110, '2015-04-01 01:02:37.000000', 'temperatura', 594.0000, 'ºC'),
	(131774, 110, '2015-04-01 01:02:38.000000', 'temperatura', 440.0000, 'ºC'),
	(131775, 110, '2015-04-01 01:02:39.000000', 'temperatura', 418.0000, 'ºC'),
	(131776, 110, '2015-04-01 01:02:40.000000', 'temperatura', 771.0000, 'ºC'),
	(131777, 110, '2015-04-01 01:02:41.000000', 'temperatura', 201.0000, 'ºC'),
	(131778, 110, '2015-04-01 01:02:42.000000', 'temperatura', 1092.0000, 'ºC'),
	(131779, 110, '2015-04-01 01:02:43.000000', 'temperatura', 59.0000, 'ºC'),
	(131780, 110, '2015-04-01 01:02:44.000000', 'temperatura', 618.0000, 'ºC'),
	(131781, 110, '2015-04-01 01:02:45.000000', 'temperatura', 512.0000, 'ºC'),
	(131782, 110, '2015-04-01 01:02:46.000000', 'temperatura', 708.0000, 'ºC'),
	(131783, 110, '2015-04-01 01:02:47.000000', 'temperatura', 805.0000, 'ºC'),
	(131784, 110, '2015-04-01 01:02:48.000000', 'temperatura', 703.0000, 'ºC'),
	(131785, 110, '2015-04-01 01:02:49.000000', 'temperatura', 1098.0000, 'ºC'),
	(131786, 110, '2015-04-01 01:02:50.000000', 'temperatura', 982.0000, 'ºC'),
	(131787, 110, '2015-04-01 01:02:51.000000', 'temperatura', 416.0000, 'ºC'),
	(131788, 110, '2015-04-01 01:02:52.000000', 'temperatura', 337.0000, 'ºC'),
	(131789, 110, '2015-04-01 01:02:53.000000', 'temperatura', 436.0000, 'ºC'),
	(131790, 110, '2015-04-01 01:02:54.000000', 'temperatura', 1170.0000, 'ºC'),
	(131791, 110, '2015-04-01 01:02:55.000000', 'temperatura', 941.0000, 'ºC'),
	(131792, 110, '2015-04-01 01:02:56.000000', 'temperatura', 1196.0000, 'ºC'),
	(131793, 110, '2015-04-01 01:02:57.000000', 'temperatura', 760.0000, 'ºC'),
	(131794, 110, '2015-04-01 01:02:58.000000', 'temperatura', 210.0000, 'ºC'),
	(131795, 110, '2015-04-01 01:02:59.000000', 'temperatura', 1170.0000, 'ºC'),
	(131796, 110, '2015-04-01 01:03:00.000000', 'temperatura', 420.0000, 'ºC'),
	(131797, 110, '2015-04-01 01:03:01.000000', 'temperatura', 990.0000, 'ºC'),
	(131798, 110, '2015-04-01 01:03:02.000000', 'temperatura', 93.0000, 'ºC'),
	(131799, 110, '2015-04-01 01:03:03.000000', 'temperatura', 1094.0000, 'ºC'),
	(131800, 110, '2015-04-01 01:03:04.000000', 'temperatura', 390.0000, 'ºC'),
	(131801, 110, '2015-04-01 01:03:05.000000', 'temperatura', 1071.0000, 'ºC'),
	(131802, 110, '2015-04-01 01:03:06.000000', 'temperatura', 584.0000, 'ºC'),
	(131803, 110, '2015-04-01 01:03:07.000000', 'temperatura', 906.0000, 'ºC'),
	(131804, 110, '2015-04-01 01:03:08.000000', 'temperatura', 381.0000, 'ºC'),
	(131805, 110, '2015-04-01 01:03:09.000000', 'temperatura', 386.0000, 'ºC'),
	(131806, 110, '2015-04-01 01:03:10.000000', 'temperatura', 789.0000, 'ºC'),
	(131807, 110, '2015-04-01 01:03:11.000000', 'temperatura', 388.0000, 'ºC'),
	(131808, 110, '2015-04-01 01:03:12.000000', 'temperatura', 774.0000, 'ºC'),
	(131809, 110, '2015-04-01 01:03:13.000000', 'temperatura', 305.0000, 'ºC'),
	(131810, 110, '2015-04-01 01:03:14.000000', 'temperatura', 406.0000, 'ºC'),
	(131811, 110, '2015-04-01 01:03:15.000000', 'temperatura', 1112.0000, 'ºC'),
	(131812, 110, '2015-04-01 01:03:16.000000', 'temperatura', 746.0000, 'ºC'),
	(131813, 110, '2015-04-01 01:03:17.000000', 'temperatura', 393.0000, 'ºC'),
	(131814, 110, '2015-04-01 01:03:18.000000', 'temperatura', 926.0000, 'ºC'),
	(131815, 110, '2015-04-01 01:03:19.000000', 'temperatura', 1051.0000, 'ºC'),
	(131816, 110, '2015-04-01 01:03:20.000000', 'temperatura', 78.0000, 'ºC'),
	(131817, 110, '2015-04-01 01:03:21.000000', 'temperatura', 839.0000, 'ºC'),
	(131818, 110, '2015-04-01 01:03:22.000000', 'temperatura', 362.0000, 'ºC'),
	(131819, 110, '2015-04-01 01:03:23.000000', 'temperatura', 491.0000, 'ºC'),
	(131820, 110, '2015-04-01 01:03:24.000000', 'temperatura', 172.0000, 'ºC'),
	(131821, 110, '2015-04-01 01:03:25.000000', 'temperatura', 586.0000, 'ºC'),
	(131822, 110, '2015-04-01 01:03:26.000000', 'temperatura', 16.0000, 'ºC'),
	(131823, 110, '2015-04-01 01:03:27.000000', 'temperatura', 720.0000, 'ºC'),
	(131824, 110, '2015-04-01 01:03:28.000000', 'temperatura', 1155.0000, 'ºC'),
	(131825, 110, '2015-04-01 01:03:29.000000', 'temperatura', 16.0000, 'ºC'),
	(131826, 110, '2015-04-01 01:03:30.000000', 'temperatura', 216.0000, 'ºC'),
	(131827, 110, '2015-04-01 01:03:31.000000', 'temperatura', 1032.0000, 'ºC'),
	(131828, 110, '2015-04-01 01:03:32.000000', 'temperatura', 914.0000, 'ºC'),
	(131829, 110, '2015-04-01 01:03:33.000000', 'temperatura', 273.0000, 'ºC'),
	(131830, 110, '2015-04-01 01:03:34.000000', 'temperatura', 1023.0000, 'ºC'),
	(131831, 110, '2015-04-01 01:03:35.000000', 'temperatura', 697.0000, 'ºC'),
	(131832, 110, '2015-04-01 01:03:36.000000', 'temperatura', 416.0000, 'ºC'),
	(131833, 110, '2015-04-01 01:03:37.000000', 'temperatura', 1191.0000, 'ºC'),
	(131834, 110, '2015-04-01 01:03:38.000000', 'temperatura', 1105.0000, 'ºC'),
	(131835, 110, '2015-04-01 01:03:39.000000', 'temperatura', 753.0000, 'ºC'),
	(131836, 110, '2015-04-01 01:03:40.000000', 'temperatura', 452.0000, 'ºC'),
	(131837, 110, '2015-04-01 01:03:41.000000', 'temperatura', 1.0000, 'ºC'),
	(131838, 110, '2015-04-01 01:03:42.000000', 'temperatura', 1049.0000, 'ºC'),
	(131839, 110, '2015-04-01 01:03:43.000000', 'temperatura', 443.0000, 'ºC'),
	(131840, 110, '2015-04-01 01:03:44.000000', 'temperatura', 268.0000, 'ºC'),
	(131841, 110, '2015-04-01 01:03:45.000000', 'temperatura', 13.0000, 'ºC'),
	(131842, 110, '2015-04-01 01:03:46.000000', 'temperatura', 459.0000, 'ºC'),
	(131843, 110, '2015-04-01 01:03:47.000000', 'temperatura', 1057.0000, 'ºC'),
	(131844, 110, '2015-04-01 01:03:48.000000', 'temperatura', 311.0000, 'ºC'),
	(131845, 110, '2015-04-01 01:03:49.000000', 'temperatura', 781.0000, 'ºC'),
	(131846, 110, '2015-04-01 01:03:50.000000', 'temperatura', 575.0000, 'ºC'),
	(131847, 110, '2015-04-01 01:03:51.000000', 'temperatura', 530.0000, 'ºC'),
	(131848, 110, '2015-04-01 01:03:52.000000', 'temperatura', 928.0000, 'ºC'),
	(131849, 110, '2015-04-01 01:03:53.000000', 'temperatura', 648.0000, 'ºC'),
	(131850, 110, '2015-04-01 01:03:54.000000', 'temperatura', 458.0000, 'ºC'),
	(131851, 110, '2015-04-01 01:03:55.000000', 'temperatura', 344.0000, 'ºC'),
	(131852, 110, '2015-04-01 01:03:56.000000', 'temperatura', 350.0000, 'ºC'),
	(131853, 110, '2015-04-01 01:03:57.000000', 'temperatura', 716.0000, 'ºC'),
	(131854, 110, '2015-04-01 01:03:58.000000', 'temperatura', 130.0000, 'ºC'),
	(131855, 110, '2015-04-01 01:03:59.000000', 'temperatura', 902.0000, 'ºC'),
	(131856, 110, '2015-04-01 01:04:00.000000', 'temperatura', 521.0000, 'ºC'),
	(131857, 110, '2015-04-01 01:04:01.000000', 'temperatura', 1101.0000, 'ºC'),
	(131858, 110, '2015-04-01 01:04:02.000000', 'temperatura', 341.0000, 'ºC'),
	(131859, 110, '2015-04-01 01:04:03.000000', 'temperatura', 801.0000, 'ºC'),
	(131860, 110, '2015-04-01 01:04:04.000000', 'temperatura', 584.0000, 'ºC'),
	(131861, 110, '2015-04-01 01:04:05.000000', 'temperatura', 517.0000, 'ºC'),
	(131862, 110, '2015-04-01 01:04:06.000000', 'temperatura', 833.0000, 'ºC'),
	(131863, 110, '2015-04-01 01:04:07.000000', 'temperatura', 215.0000, 'ºC'),
	(131864, 110, '2015-04-01 01:04:08.000000', 'temperatura', 976.0000, 'ºC'),
	(131865, 110, '2015-04-01 01:04:09.000000', 'temperatura', 634.0000, 'ºC'),
	(131866, 110, '2015-04-01 01:04:10.000000', 'temperatura', 244.0000, 'ºC'),
	(131867, 110, '2015-04-01 01:04:11.000000', 'temperatura', 518.0000, 'ºC'),
	(131868, 110, '2015-04-01 01:04:12.000000', 'temperatura', 658.0000, 'ºC'),
	(131869, 110, '2015-04-01 01:04:13.000000', 'temperatura', 535.0000, 'ºC'),
	(131870, 110, '2015-04-01 01:04:14.000000', 'temperatura', 704.0000, 'ºC'),
	(131871, 110, '2015-04-01 01:04:15.000000', 'temperatura', 714.0000, 'ºC'),
	(131872, 110, '2015-04-01 01:04:16.000000', 'temperatura', 258.0000, 'ºC'),
	(131873, 110, '2015-04-01 01:04:17.000000', 'temperatura', 351.0000, 'ºC'),
	(131874, 110, '2015-04-01 01:04:18.000000', 'temperatura', 979.0000, 'ºC'),
	(131875, 110, '2015-04-01 01:04:19.000000', 'temperatura', 245.0000, 'ºC'),
	(131876, 110, '2015-04-01 01:04:20.000000', 'temperatura', 687.0000, 'ºC'),
	(131877, 110, '2015-04-01 01:04:21.000000', 'temperatura', 299.0000, 'ºC'),
	(131878, 110, '2015-04-01 01:04:22.000000', 'temperatura', 636.0000, 'ºC'),
	(131879, 110, '2015-04-01 01:04:23.000000', 'temperatura', 1082.0000, 'ºC'),
	(131880, 110, '2015-04-01 01:04:24.000000', 'temperatura', 1102.0000, 'ºC'),
	(131881, 110, '2015-04-01 01:04:25.000000', 'temperatura', 1066.0000, 'ºC'),
	(131882, 110, '2015-04-01 01:04:26.000000', 'temperatura', 822.0000, 'ºC'),
	(131883, 110, '2015-04-01 01:04:27.000000', 'temperatura', 914.0000, 'ºC'),
	(131884, 110, '2015-04-01 01:04:28.000000', 'temperatura', 906.0000, 'ºC'),
	(131885, 110, '2015-04-01 01:04:29.000000', 'temperatura', 585.0000, 'ºC'),
	(131886, 110, '2015-04-01 01:04:30.000000', 'temperatura', 211.0000, 'ºC'),
	(131887, 110, '2015-04-01 01:04:31.000000', 'temperatura', 498.0000, 'ºC'),
	(131888, 110, '2015-04-01 01:04:32.000000', 'temperatura', 659.0000, 'ºC'),
	(131889, 110, '2015-04-01 01:04:33.000000', 'temperatura', 603.0000, 'ºC'),
	(131890, 110, '2015-04-01 01:04:34.000000', 'temperatura', 1038.0000, 'ºC'),
	(131891, 110, '2015-04-01 01:04:35.000000', 'temperatura', 980.0000, 'ºC'),
	(131892, 110, '2015-04-01 01:04:36.000000', 'temperatura', 588.0000, 'ºC'),
	(131893, 110, '2015-04-01 01:04:37.000000', 'temperatura', 1199.0000, 'ºC'),
	(131894, 110, '2015-04-01 01:04:38.000000', 'temperatura', 632.0000, 'ºC'),
	(131895, 110, '2015-04-01 01:04:39.000000', 'temperatura', 764.0000, 'ºC'),
	(131896, 110, '2015-04-01 01:04:40.000000', 'temperatura', 722.0000, 'ºC'),
	(131897, 110, '2015-04-01 01:04:41.000000', 'temperatura', 121.0000, 'ºC'),
	(131898, 110, '2015-04-01 01:04:42.000000', 'temperatura', 840.0000, 'ºC'),
	(131899, 110, '2015-04-01 01:04:43.000000', 'temperatura', 236.0000, 'ºC'),
	(131900, 110, '2015-04-01 01:04:44.000000', 'temperatura', 1059.0000, 'ºC'),
	(131901, 110, '2015-04-01 01:04:45.000000', 'temperatura', 988.0000, 'ºC'),
	(131902, 110, '2015-04-01 01:04:46.000000', 'temperatura', 565.0000, 'ºC'),
	(131903, 110, '2015-04-01 01:04:47.000000', 'temperatura', 1060.0000, 'ºC'),
	(131904, 110, '2015-04-01 01:04:48.000000', 'temperatura', 8.0000, 'ºC'),
	(131905, 110, '2015-04-01 01:04:49.000000', 'temperatura', 459.0000, 'ºC'),
	(131906, 110, '2015-04-01 01:04:50.000000', 'temperatura', 1071.0000, 'ºC'),
	(131907, 110, '2015-04-01 01:04:51.000000', 'temperatura', 380.0000, 'ºC'),
	(131908, 110, '2015-04-01 01:04:52.000000', 'temperatura', 1086.0000, 'ºC'),
	(131909, 110, '2015-04-01 01:04:53.000000', 'temperatura', 693.0000, 'ºC'),
	(131910, 110, '2015-04-01 01:04:54.000000', 'temperatura', 204.0000, 'ºC'),
	(131911, 110, '2015-04-01 01:04:55.000000', 'temperatura', 143.0000, 'ºC'),
	(131912, 110, '2015-04-01 01:04:56.000000', 'temperatura', 104.0000, 'ºC'),
	(131913, 110, '2015-04-01 01:04:57.000000', 'temperatura', 91.0000, 'ºC'),
	(131914, 110, '2015-04-01 01:04:58.000000', 'temperatura', 142.0000, 'ºC'),
	(131915, 110, '2015-04-01 01:04:59.000000', 'temperatura', 440.0000, 'ºC'),
	(131916, 110, '2015-04-01 01:05:00.000000', 'temperatura', 574.0000, 'ºC'),
	(131917, 110, '2015-04-01 01:05:01.000000', 'temperatura', 352.0000, 'ºC'),
	(131918, 110, '2015-04-01 01:05:02.000000', 'temperatura', 38.0000, 'ºC'),
	(131919, 110, '2015-04-01 01:05:03.000000', 'temperatura', 336.0000, 'ºC'),
	(131920, 110, '2015-04-01 01:05:04.000000', 'temperatura', 364.0000, 'ºC'),
	(131921, 110, '2015-04-01 01:05:05.000000', 'temperatura', 814.0000, 'ºC'),
	(131922, 110, '2015-04-01 01:05:06.000000', 'temperatura', 576.0000, 'ºC'),
	(131923, 110, '2015-04-01 01:05:07.000000', 'temperatura', 439.0000, 'ºC'),
	(131924, 110, '2015-04-01 01:05:08.000000', 'temperatura', 469.0000, 'ºC'),
	(131925, 110, '2015-04-01 01:05:09.000000', 'temperatura', 1028.0000, 'ºC'),
	(131926, 110, '2015-04-01 01:05:10.000000', 'temperatura', 133.0000, 'ºC'),
	(131927, 110, '2015-04-01 01:05:11.000000', 'temperatura', 1182.0000, 'ºC'),
	(131928, 110, '2015-04-01 01:05:12.000000', 'temperatura', 713.0000, 'ºC'),
	(131929, 110, '2015-04-01 01:05:13.000000', 'temperatura', 18.0000, 'ºC'),
	(131930, 110, '2015-04-01 01:05:14.000000', 'temperatura', 351.0000, 'ºC'),
	(131931, 110, '2015-04-01 01:05:15.000000', 'temperatura', 500.0000, 'ºC'),
	(131932, 110, '2015-04-01 01:05:16.000000', 'temperatura', 250.0000, 'ºC'),
	(131933, 110, '2015-04-01 01:05:17.000000', 'temperatura', 951.0000, 'ºC'),
	(131934, 110, '2015-04-01 01:05:18.000000', 'temperatura', 406.0000, 'ºC'),
	(131935, 110, '2015-04-01 01:05:19.000000', 'temperatura', 379.0000, 'ºC'),
	(131936, 110, '2015-04-01 01:05:20.000000', 'temperatura', 674.0000, 'ºC'),
	(131937, 110, '2015-04-01 01:05:21.000000', 'temperatura', 1035.0000, 'ºC'),
	(131938, 110, '2015-04-01 01:05:22.000000', 'temperatura', 752.0000, 'ºC'),
	(131939, 110, '2015-04-01 01:05:23.000000', 'temperatura', 658.0000, 'ºC'),
	(131940, 110, '2015-04-01 01:05:24.000000', 'temperatura', 1032.0000, 'ºC'),
	(131941, 110, '2015-04-01 01:05:25.000000', 'temperatura', 787.0000, 'ºC'),
	(131942, 110, '2015-04-01 01:05:26.000000', 'temperatura', 838.0000, 'ºC'),
	(131943, 110, '2015-04-01 01:05:27.000000', 'temperatura', 633.0000, 'ºC'),
	(131944, 110, '2015-04-01 01:05:28.000000', 'temperatura', 649.0000, 'ºC'),
	(131945, 110, '2015-04-01 01:05:29.000000', 'temperatura', 146.0000, 'ºC'),
	(131946, 110, '2015-04-01 01:05:30.000000', 'temperatura', 1186.0000, 'ºC'),
	(131947, 110, '2015-04-01 01:05:31.000000', 'temperatura', 693.0000, 'ºC'),
	(131948, 110, '2015-04-01 01:05:32.000000', 'temperatura', 1106.0000, 'ºC'),
	(131949, 110, '2015-04-01 01:05:33.000000', 'temperatura', 1053.0000, 'ºC'),
	(131950, 110, '2015-04-01 01:05:34.000000', 'temperatura', 748.0000, 'ºC'),
	(131951, 110, '2015-04-01 01:05:35.000000', 'temperatura', 580.0000, 'ºC'),
	(131952, 110, '2015-04-01 01:05:36.000000', 'temperatura', 655.0000, 'ºC'),
	(131953, 110, '2015-04-01 01:05:37.000000', 'temperatura', 338.0000, 'ºC'),
	(131954, 110, '2015-04-01 01:05:38.000000', 'temperatura', 923.0000, 'ºC'),
	(131955, 110, '2015-04-01 01:05:39.000000', 'temperatura', 3.0000, 'ºC'),
	(131956, 110, '2015-04-01 01:05:40.000000', 'temperatura', 848.0000, 'ºC'),
	(131957, 110, '2015-04-01 01:05:41.000000', 'temperatura', 630.0000, 'ºC'),
	(131958, 110, '2015-04-01 01:05:42.000000', 'temperatura', 608.0000, 'ºC'),
	(131959, 110, '2015-04-01 01:05:43.000000', 'temperatura', 1148.0000, 'ºC'),
	(131960, 110, '2015-04-01 01:05:44.000000', 'temperatura', 318.0000, 'ºC'),
	(131961, 110, '2015-04-01 01:05:45.000000', 'temperatura', 548.0000, 'ºC'),
	(131962, 110, '2015-04-01 01:05:46.000000', 'temperatura', 586.0000, 'ºC'),
	(131963, 110, '2015-04-01 01:05:47.000000', 'temperatura', 85.0000, 'ºC'),
	(131964, 110, '2015-04-01 01:05:48.000000', 'temperatura', 1069.0000, 'ºC'),
	(131965, 110, '2015-04-01 01:05:49.000000', 'temperatura', 288.0000, 'ºC'),
	(131966, 110, '2015-04-01 01:05:50.000000', 'temperatura', 636.0000, 'ºC'),
	(131967, 110, '2015-04-01 01:05:51.000000', 'temperatura', 1115.0000, 'ºC'),
	(131968, 110, '2015-04-01 01:05:52.000000', 'temperatura', 70.0000, 'ºC'),
	(131969, 110, '2015-04-01 01:05:53.000000', 'temperatura', 604.0000, 'ºC'),
	(131970, 110, '2015-04-01 01:05:54.000000', 'temperatura', 410.0000, 'ºC'),
	(131971, 110, '2015-04-01 01:05:55.000000', 'temperatura', 240.0000, 'ºC'),
	(131972, 110, '2015-04-01 01:05:56.000000', 'temperatura', 1171.0000, 'ºC'),
	(131973, 110, '2015-04-01 01:05:57.000000', 'temperatura', 336.0000, 'ºC'),
	(131974, 110, '2015-04-01 01:05:58.000000', 'temperatura', 568.0000, 'ºC'),
	(131975, 110, '2015-04-01 01:05:59.000000', 'temperatura', 629.0000, 'ºC'),
	(131976, 110, '2015-04-01 01:06:00.000000', 'temperatura', 245.0000, 'ºC'),
	(131977, 110, '2015-04-01 01:06:01.000000', 'temperatura', 536.0000, 'ºC'),
	(131978, 110, '2015-04-01 01:06:02.000000', 'temperatura', 745.0000, 'ºC'),
	(131979, 110, '2015-04-01 01:06:03.000000', 'temperatura', 920.0000, 'ºC'),
	(131980, 110, '2015-04-01 01:06:04.000000', 'temperatura', 1164.0000, 'ºC'),
	(131981, 110, '2015-04-01 01:06:05.000000', 'temperatura', 662.0000, 'ºC'),
	(131982, 110, '2015-04-01 01:06:06.000000', 'temperatura', 1018.0000, 'ºC'),
	(131983, 110, '2015-04-01 01:06:07.000000', 'temperatura', 704.0000, 'ºC'),
	(131984, 110, '2015-04-01 01:06:08.000000', 'temperatura', 465.0000, 'ºC'),
	(131985, 110, '2015-04-01 01:06:09.000000', 'temperatura', 215.0000, 'ºC'),
	(131986, 110, '2015-04-01 01:06:10.000000', 'temperatura', 881.0000, 'ºC'),
	(131987, 110, '2015-04-01 01:06:11.000000', 'temperatura', 158.0000, 'ºC'),
	(131988, 110, '2015-04-01 01:06:12.000000', 'temperatura', 551.0000, 'ºC'),
	(131989, 110, '2015-04-01 01:06:13.000000', 'temperatura', 1079.0000, 'ºC'),
	(131990, 110, '2015-04-01 01:06:14.000000', 'temperatura', 143.0000, 'ºC'),
	(131991, 110, '2015-04-01 01:06:15.000000', 'temperatura', 1077.0000, 'ºC'),
	(131992, 110, '2015-04-01 01:06:16.000000', 'temperatura', 156.0000, 'ºC'),
	(131993, 110, '2015-04-01 01:06:17.000000', 'temperatura', 1151.0000, 'ºC'),
	(131994, 110, '2015-04-01 01:06:18.000000', 'temperatura', 485.0000, 'ºC'),
	(131995, 110, '2015-04-01 01:06:19.000000', 'temperatura', 175.0000, 'ºC'),
	(131996, 110, '2015-04-01 01:06:20.000000', 'temperatura', 619.0000, 'ºC'),
	(131997, 110, '2015-04-01 01:06:21.000000', 'temperatura', 172.0000, 'ºC'),
	(131998, 110, '2015-04-01 01:06:22.000000', 'temperatura', 203.0000, 'ºC'),
	(131999, 110, '2015-04-01 01:06:23.000000', 'temperatura', 501.0000, 'ºC'),
	(132000, 110, '2015-04-01 01:06:24.000000', 'temperatura', 697.0000, 'ºC'),
	(132001, 110, '2015-04-01 01:06:25.000000', 'temperatura', 780.0000, 'ºC'),
	(132002, 110, '2015-04-01 01:06:26.000000', 'temperatura', 609.0000, 'ºC'),
	(132003, 110, '2015-04-01 01:06:27.000000', 'temperatura', 705.0000, 'ºC'),
	(132004, 110, '2015-04-01 01:06:28.000000', 'temperatura', 498.0000, 'ºC'),
	(132005, 110, '2015-04-01 01:06:29.000000', 'temperatura', 378.0000, 'ºC'),
	(132006, 110, '2015-04-01 01:06:30.000000', 'temperatura', 394.0000, 'ºC'),
	(132007, 110, '2015-04-01 01:06:31.000000', 'temperatura', 836.0000, 'ºC'),
	(132008, 110, '2015-04-01 01:06:32.000000', 'temperatura', 601.0000, 'ºC'),
	(132009, 110, '2015-04-01 01:06:33.000000', 'temperatura', 497.0000, 'ºC'),
	(132010, 110, '2015-04-01 01:06:34.000000', 'temperatura', 682.0000, 'ºC'),
	(132011, 110, '2015-04-01 01:06:35.000000', 'temperatura', 721.0000, 'ºC'),
	(132012, 110, '2015-04-01 01:06:36.000000', 'temperatura', 358.0000, 'ºC'),
	(132013, 110, '2015-04-01 01:06:37.000000', 'temperatura', 826.0000, 'ºC'),
	(132014, 110, '2015-04-01 01:06:38.000000', 'temperatura', 658.0000, 'ºC'),
	(132015, 110, '2015-04-01 01:06:39.000000', 'temperatura', 811.0000, 'ºC'),
	(132016, 110, '2015-04-01 01:06:40.000000', 'temperatura', 883.0000, 'ºC'),
	(132017, 110, '2015-04-01 01:06:41.000000', 'temperatura', 781.0000, 'ºC'),
	(132018, 110, '2015-04-01 01:06:42.000000', 'temperatura', 56.0000, 'ºC'),
	(132019, 110, '2015-04-01 01:06:43.000000', 'temperatura', 337.0000, 'ºC'),
	(132020, 110, '2015-04-01 01:06:44.000000', 'temperatura', 318.0000, 'ºC'),
	(132021, 110, '2015-04-01 01:06:45.000000', 'temperatura', 578.0000, 'ºC'),
	(132022, 110, '2015-04-01 01:06:46.000000', 'temperatura', 740.0000, 'ºC'),
	(132023, 110, '2015-04-01 01:06:47.000000', 'temperatura', 763.0000, 'ºC'),
	(132024, 110, '2015-04-01 01:06:48.000000', 'temperatura', 396.0000, 'ºC'),
	(132025, 110, '2015-04-01 01:06:49.000000', 'temperatura', 894.0000, 'ºC'),
	(132026, 110, '2015-04-01 01:06:50.000000', 'temperatura', 880.0000, 'ºC'),
	(132027, 110, '2015-04-01 01:06:51.000000', 'temperatura', 520.0000, 'ºC'),
	(132028, 110, '2015-04-01 01:06:52.000000', 'temperatura', 1159.0000, 'ºC'),
	(132029, 110, '2015-04-01 01:06:53.000000', 'temperatura', 638.0000, 'ºC'),
	(132030, 110, '2015-04-01 01:06:54.000000', 'temperatura', 913.0000, 'ºC'),
	(132031, 110, '2015-04-01 01:06:55.000000', 'temperatura', 250.0000, 'ºC'),
	(132032, 110, '2015-04-01 01:06:56.000000', 'temperatura', 914.0000, 'ºC'),
	(132033, 110, '2015-04-01 01:06:57.000000', 'temperatura', 219.0000, 'ºC'),
	(132034, 110, '2015-04-01 01:06:58.000000', 'temperatura', 752.0000, 'ºC'),
	(132035, 110, '2015-04-01 01:06:59.000000', 'temperatura', 706.0000, 'ºC'),
	(132036, 110, '2015-04-01 01:07:00.000000', 'temperatura', 73.0000, 'ºC'),
	(132037, 110, '2015-04-01 01:07:01.000000', 'temperatura', 650.0000, 'ºC'),
	(132038, 110, '2015-04-01 01:07:02.000000', 'temperatura', 630.0000, 'ºC'),
	(132039, 110, '2015-04-01 01:07:03.000000', 'temperatura', 0.0000, 'ºC'),
	(132040, 110, '2015-04-01 01:07:04.000000', 'temperatura', 510.0000, 'ºC'),
	(132041, 110, '2015-04-01 01:07:05.000000', 'temperatura', 151.0000, 'ºC'),
	(132042, 110, '2015-04-01 01:07:06.000000', 'temperatura', 424.0000, 'ºC'),
	(132043, 110, '2015-04-01 01:07:07.000000', 'temperatura', 467.0000, 'ºC'),
	(132044, 110, '2015-04-01 01:07:08.000000', 'temperatura', 1063.0000, 'ºC'),
	(132045, 110, '2015-04-01 01:07:09.000000', 'temperatura', 317.0000, 'ºC'),
	(132046, 110, '2015-04-01 01:07:10.000000', 'temperatura', 797.0000, 'ºC'),
	(132047, 110, '2015-04-01 01:07:11.000000', 'temperatura', 635.0000, 'ºC'),
	(132048, 110, '2015-04-01 01:07:12.000000', 'temperatura', 783.0000, 'ºC'),
	(132049, 110, '2015-04-01 01:07:13.000000', 'temperatura', 811.0000, 'ºC'),
	(132050, 110, '2015-04-01 01:07:14.000000', 'temperatura', 506.0000, 'ºC'),
	(132051, 110, '2015-04-01 01:07:15.000000', 'temperatura', 96.0000, 'ºC'),
	(132052, 110, '2015-04-01 01:07:16.000000', 'temperatura', 165.0000, 'ºC'),
	(132053, 110, '2015-04-01 01:07:17.000000', 'temperatura', 537.0000, 'ºC'),
	(132054, 110, '2015-04-01 01:07:18.000000', 'temperatura', 992.0000, 'ºC'),
	(132055, 110, '2015-04-01 01:07:19.000000', 'temperatura', 947.0000, 'ºC'),
	(132056, 110, '2015-04-01 01:07:20.000000', 'temperatura', 560.0000, 'ºC'),
	(132057, 110, '2015-04-01 01:07:21.000000', 'temperatura', 1159.0000, 'ºC'),
	(132058, 110, '2015-04-01 01:07:22.000000', 'temperatura', 514.0000, 'ºC'),
	(132059, 110, '2015-04-01 01:07:23.000000', 'temperatura', 294.0000, 'ºC'),
	(132060, 110, '2015-04-01 01:07:24.000000', 'temperatura', 1131.0000, 'ºC'),
	(132061, 110, '2015-04-01 01:07:25.000000', 'temperatura', 1172.0000, 'ºC'),
	(132062, 110, '2015-04-01 01:07:26.000000', 'temperatura', 68.0000, 'ºC'),
	(132063, 110, '2015-04-01 01:07:27.000000', 'temperatura', 426.0000, 'ºC'),
	(132064, 110, '2015-04-01 01:07:28.000000', 'temperatura', 725.0000, 'ºC'),
	(132065, 110, '2015-04-01 01:07:29.000000', 'temperatura', 1149.0000, 'ºC'),
	(132066, 110, '2015-04-01 01:07:30.000000', 'temperatura', 1168.0000, 'ºC'),
	(132067, 110, '2015-04-01 01:07:31.000000', 'temperatura', 1196.0000, 'ºC'),
	(132068, 110, '2015-04-01 01:07:32.000000', 'temperatura', 75.0000, 'ºC'),
	(132069, 110, '2015-04-01 01:07:33.000000', 'temperatura', 387.0000, 'ºC'),
	(132070, 110, '2015-04-01 01:07:34.000000', 'temperatura', 512.0000, 'ºC'),
	(132071, 110, '2015-04-01 01:07:35.000000', 'temperatura', 197.0000, 'ºC'),
	(132072, 110, '2015-04-01 01:07:36.000000', 'temperatura', 652.0000, 'ºC'),
	(132073, 110, '2015-04-01 01:07:37.000000', 'temperatura', 269.0000, 'ºC'),
	(132074, 110, '2015-04-01 01:07:38.000000', 'temperatura', 588.0000, 'ºC'),
	(132075, 110, '2015-04-01 01:07:39.000000', 'temperatura', 933.0000, 'ºC'),
	(132076, 110, '2015-04-01 01:07:40.000000', 'temperatura', 502.0000, 'ºC'),
	(132077, 110, '2015-04-01 01:07:41.000000', 'temperatura', 911.0000, 'ºC'),
	(132078, 110, '2015-04-01 01:07:42.000000', 'temperatura', 648.0000, 'ºC'),
	(132079, 110, '2015-04-01 01:07:43.000000', 'temperatura', 510.0000, 'ºC'),
	(132080, 110, '2015-04-01 01:07:44.000000', 'temperatura', 604.0000, 'ºC'),
	(132081, 110, '2015-04-01 01:07:45.000000', 'temperatura', 294.0000, 'ºC'),
	(132082, 110, '2015-04-01 01:07:46.000000', 'temperatura', 855.0000, 'ºC'),
	(132083, 110, '2015-04-01 01:07:47.000000', 'temperatura', 996.0000, 'ºC'),
	(132084, 110, '2015-04-01 01:07:48.000000', 'temperatura', 13.0000, 'ºC'),
	(132085, 110, '2015-04-01 01:07:49.000000', 'temperatura', 679.0000, 'ºC'),
	(132086, 110, '2015-04-01 01:07:50.000000', 'temperatura', 956.0000, 'ºC'),
	(132087, 110, '2015-04-01 01:07:51.000000', 'temperatura', 346.0000, 'ºC'),
	(132088, 110, '2015-04-01 01:07:52.000000', 'temperatura', 59.0000, 'ºC'),
	(132089, 110, '2015-04-01 01:07:53.000000', 'temperatura', 461.0000, 'ºC'),
	(132090, 110, '2015-04-01 01:07:54.000000', 'temperatura', 926.0000, 'ºC'),
	(132091, 110, '2015-04-01 01:07:55.000000', 'temperatura', 849.0000, 'ºC'),
	(132092, 110, '2015-04-01 01:07:56.000000', 'temperatura', 266.0000, 'ºC'),
	(132093, 110, '2015-04-01 01:07:57.000000', 'temperatura', 1185.0000, 'ºC'),
	(132094, 110, '2015-04-01 01:07:58.000000', 'temperatura', 328.0000, 'ºC'),
	(132095, 110, '2015-04-01 01:07:59.000000', 'temperatura', 485.0000, 'ºC'),
	(132096, 110, '2015-04-01 01:08:00.000000', 'temperatura', 242.0000, 'ºC'),
	(132097, 110, '2015-04-01 01:08:01.000000', 'temperatura', 955.0000, 'ºC'),
	(132098, 110, '2015-04-01 01:08:02.000000', 'temperatura', 451.0000, 'ºC'),
	(132099, 110, '2015-04-01 01:08:03.000000', 'temperatura', 590.0000, 'ºC'),
	(132100, 110, '2015-04-01 01:08:04.000000', 'temperatura', 398.0000, 'ºC'),
	(132101, 110, '2015-04-01 01:08:05.000000', 'temperatura', 218.0000, 'ºC'),
	(132102, 110, '2015-04-01 01:08:06.000000', 'temperatura', 1097.0000, 'ºC'),
	(132103, 110, '2015-04-01 01:08:07.000000', 'temperatura', 33.0000, 'ºC'),
	(132104, 110, '2015-04-01 01:08:08.000000', 'temperatura', 473.0000, 'ºC'),
	(132105, 110, '2015-04-01 01:08:09.000000', 'temperatura', 1066.0000, 'ºC'),
	(132106, 110, '2015-04-01 01:08:10.000000', 'temperatura', 312.0000, 'ºC'),
	(132107, 110, '2015-04-01 01:08:11.000000', 'temperatura', 764.0000, 'ºC'),
	(132108, 110, '2015-04-01 01:08:12.000000', 'temperatura', 483.0000, 'ºC'),
	(132109, 110, '2015-04-01 01:08:13.000000', 'temperatura', 125.0000, 'ºC'),
	(132110, 110, '2015-04-01 01:08:14.000000', 'temperatura', 376.0000, 'ºC'),
	(132111, 110, '2015-04-01 01:08:15.000000', 'temperatura', 304.0000, 'ºC'),
	(132112, 110, '2015-04-01 01:08:16.000000', 'temperatura', 395.0000, 'ºC'),
	(132113, 110, '2015-04-01 01:08:17.000000', 'temperatura', 1062.0000, 'ºC'),
	(132114, 110, '2015-04-01 01:08:18.000000', 'temperatura', 527.0000, 'ºC'),
	(132115, 110, '2015-04-01 01:08:19.000000', 'temperatura', 648.0000, 'ºC'),
	(132116, 110, '2015-04-01 01:08:20.000000', 'temperatura', 459.0000, 'ºC'),
	(132117, 110, '2015-04-01 01:08:21.000000', 'temperatura', 354.0000, 'ºC'),
	(132118, 110, '2015-04-01 01:08:22.000000', 'temperatura', 391.0000, 'ºC'),
	(132119, 110, '2015-04-01 01:08:23.000000', 'temperatura', 894.0000, 'ºC'),
	(132120, 110, '2015-04-01 01:08:24.000000', 'temperatura', 899.0000, 'ºC'),
	(132121, 110, '2015-04-01 01:08:25.000000', 'temperatura', 612.0000, 'ºC'),
	(132122, 110, '2015-04-01 01:08:26.000000', 'temperatura', 362.0000, 'ºC'),
	(132123, 110, '2015-04-01 01:08:27.000000', 'temperatura', 1178.0000, 'ºC'),
	(132124, 110, '2015-04-01 01:08:28.000000', 'temperatura', 3.0000, 'ºC'),
	(132125, 110, '2015-04-01 01:08:29.000000', 'temperatura', 80.0000, 'ºC'),
	(132126, 110, '2015-04-01 01:08:30.000000', 'temperatura', 393.0000, 'ºC'),
	(132127, 110, '2015-04-01 01:08:31.000000', 'temperatura', 524.0000, 'ºC'),
	(132128, 110, '2015-04-01 01:08:32.000000', 'temperatura', 241.0000, 'ºC'),
	(132129, 110, '2015-04-01 01:08:33.000000', 'temperatura', 833.0000, 'ºC'),
	(132130, 110, '2015-04-01 01:08:34.000000', 'temperatura', 1045.0000, 'ºC'),
	(132131, 110, '2015-04-01 01:08:35.000000', 'temperatura', 326.0000, 'ºC'),
	(132132, 110, '2015-04-01 01:08:36.000000', 'temperatura', 894.0000, 'ºC'),
	(132133, 110, '2015-04-01 01:08:37.000000', 'temperatura', 1095.0000, 'ºC'),
	(132134, 110, '2015-04-01 01:08:38.000000', 'temperatura', 393.0000, 'ºC'),
	(132135, 110, '2015-04-01 01:08:39.000000', 'temperatura', 1078.0000, 'ºC'),
	(132136, 110, '2015-04-01 01:08:40.000000', 'temperatura', 613.0000, 'ºC'),
	(132137, 110, '2015-04-01 01:08:41.000000', 'temperatura', 1030.0000, 'ºC'),
	(132138, 110, '2015-04-01 01:08:42.000000', 'temperatura', 914.0000, 'ºC'),
	(132139, 110, '2015-04-01 01:08:43.000000', 'temperatura', 280.0000, 'ºC'),
	(132140, 110, '2015-04-01 01:08:44.000000', 'temperatura', 1057.0000, 'ºC'),
	(132141, 110, '2015-04-01 01:08:45.000000', 'temperatura', 844.0000, 'ºC'),
	(132142, 110, '2015-04-01 01:08:46.000000', 'temperatura', 1052.0000, 'ºC'),
	(132143, 110, '2015-04-01 01:08:47.000000', 'temperatura', 329.0000, 'ºC'),
	(132144, 110, '2015-04-01 01:08:48.000000', 'temperatura', 891.0000, 'ºC'),
	(132145, 110, '2015-04-01 01:08:49.000000', 'temperatura', 1065.0000, 'ºC'),
	(132146, 110, '2015-04-01 01:08:50.000000', 'temperatura', 255.0000, 'ºC'),
	(132147, 110, '2015-04-01 01:08:51.000000', 'temperatura', 481.0000, 'ºC'),
	(132148, 110, '2015-04-01 01:08:52.000000', 'temperatura', 438.0000, 'ºC'),
	(132149, 110, '2015-04-01 01:08:53.000000', 'temperatura', 750.0000, 'ºC'),
	(132150, 110, '2015-04-01 01:08:54.000000', 'temperatura', 37.0000, 'ºC'),
	(132151, 110, '2015-04-01 01:08:55.000000', 'temperatura', 334.0000, 'ºC'),
	(132152, 110, '2015-04-01 01:08:56.000000', 'temperatura', 359.0000, 'ºC'),
	(132153, 110, '2015-04-01 01:08:57.000000', 'temperatura', 794.0000, 'ºC'),
	(132154, 110, '2015-04-01 01:08:58.000000', 'temperatura', 495.0000, 'ºC'),
	(132155, 110, '2015-04-01 01:08:59.000000', 'temperatura', 91.0000, 'ºC'),
	(132156, 110, '2015-04-01 01:09:00.000000', 'temperatura', 171.0000, 'ºC'),
	(132157, 110, '2015-04-01 01:09:01.000000', 'temperatura', 584.0000, 'ºC'),
	(132158, 110, '2015-04-01 01:09:02.000000', 'temperatura', 5.0000, 'ºC'),
	(132159, 110, '2015-04-01 01:09:03.000000', 'temperatura', 673.0000, 'ºC'),
	(132160, 110, '2015-04-01 01:09:04.000000', 'temperatura', 952.0000, 'ºC'),
	(132161, 110, '2015-04-01 01:09:05.000000', 'temperatura', 343.0000, 'ºC'),
	(132162, 110, '2015-04-01 01:09:06.000000', 'temperatura', 58.0000, 'ºC'),
	(132163, 110, '2015-04-01 01:09:07.000000', 'temperatura', 460.0000, 'ºC'),
	(132164, 110, '2015-04-01 01:09:08.000000', 'temperatura', 929.0000, 'ºC'),
	(132165, 110, '2015-04-01 01:09:09.000000', 'temperatura', 863.0000, 'ºC'),
	(132166, 110, '2015-04-01 01:09:10.000000', 'temperatura', 329.0000, 'ºC'),
	(132167, 110, '2015-04-01 01:09:11.000000', 'temperatura', 256.0000, 'ºC'),
	(132168, 110, '2015-04-01 01:09:12.000000', 'temperatura', 296.0000, 'ºC'),
	(132169, 110, '2015-04-01 01:09:13.000000', 'temperatura', 710.0000, 'ºC'),
	(132170, 110, '2015-04-01 01:09:14.000000', 'temperatura', 265.0000, 'ºC'),
	(132171, 110, '2015-04-01 01:09:15.000000', 'temperatura', 395.0000, 'ºC'),
	(132172, 110, '2015-04-01 01:09:16.000000', 'temperatura', 1182.0000, 'ºC'),
	(132173, 110, '2015-04-01 01:09:17.000000', 'temperatura', 1122.0000, 'ºC'),
	(132174, 110, '2015-04-01 01:09:18.000000', 'temperatura', 867.0000, 'ºC'),
	(132175, 110, '2015-04-01 01:09:19.000000', 'temperatura', 971.0000, 'ºC'),
	(132176, 110, '2015-04-01 01:09:20.000000', 'temperatura', 1051.0000, 'ºC'),
	(132177, 110, '2015-04-01 01:09:21.000000', 'temperatura', 1146.0000, 'ºC'),
	(132178, 110, '2015-04-01 01:09:22.000000', 'temperatura', 175.0000, 'ºC'),
	(132179, 110, '2015-04-01 01:09:23.000000', 'temperatura', 1038.0000, 'ºC'),
	(132180, 110, '2015-04-01 01:09:24.000000', 'temperatura', 1066.0000, 'ºC'),
	(132181, 110, '2015-04-01 01:09:25.000000', 'temperatura', 1015.0000, 'ºC'),
	(132182, 110, '2015-04-01 01:09:26.000000', 'temperatura', 680.0000, 'ºC'),
	(132183, 110, '2015-04-01 01:09:27.000000', 'temperatura', 352.0000, 'ºC'),
	(132184, 110, '2015-04-01 01:09:28.000000', 'temperatura', 923.0000, 'ºC'),
	(132185, 110, '2015-04-01 01:09:29.000000', 'temperatura', 1160.0000, 'ºC'),
	(132186, 110, '2015-04-01 01:09:30.000000', 'temperatura', 630.0000, 'ºC'),
	(132187, 110, '2015-04-01 01:09:31.000000', 'temperatura', 870.0000, 'ºC'),
	(132188, 110, '2015-04-01 01:09:32.000000', 'temperatura', 61.0000, 'ºC'),
	(132189, 110, '2015-04-01 01:09:33.000000', 'temperatura', 98.0000, 'ºC'),
	(132190, 110, '2015-04-01 01:09:34.000000', 'temperatura', 305.0000, 'ºC'),
	(132191, 110, '2015-04-01 01:09:35.000000', 'temperatura', 30.0000, 'ºC'),
	(132192, 110, '2015-04-01 01:09:36.000000', 'temperatura', 437.0000, 'ºC'),
	(132193, 110, '2015-04-01 01:09:37.000000', 'temperatura', 896.0000, 'ºC'),
	(132194, 110, '2015-04-01 01:09:38.000000', 'temperatura', 768.0000, 'ºC'),
	(132195, 110, '2015-04-01 01:09:39.000000', 'temperatura', 1155.0000, 'ºC'),
	(132196, 110, '2015-04-01 01:09:40.000000', 'temperatura', 1070.0000, 'ºC'),
	(132197, 110, '2015-04-01 01:09:41.000000', 'temperatura', 687.0000, 'ºC'),
	(132198, 110, '2015-04-01 01:09:42.000000', 'temperatura', 225.0000, 'ºC'),
	(132199, 110, '2015-04-01 01:09:43.000000', 'temperatura', 263.0000, 'ºC'),
	(132200, 110, '2015-04-01 01:09:44.000000', 'temperatura', 640.0000, 'ºC'),
	(132201, 110, '2015-04-01 01:09:45.000000', 'temperatura', 12.0000, 'ºC'),
	(132202, 110, '2015-04-01 01:09:46.000000', 'temperatura', 539.0000, 'ºC'),
	(132203, 110, '2015-04-01 01:09:47.000000', 'temperatura', 262.0000, 'ºC'),
	(132204, 110, '2015-04-01 01:09:48.000000', 'temperatura', 892.0000, 'ºC'),
	(132205, 110, '2015-04-01 01:09:49.000000', 'temperatura', 76.0000, 'ºC'),
	(132206, 110, '2015-04-01 01:09:50.000000', 'temperatura', 104.0000, 'ºC'),
	(132207, 110, '2015-04-01 01:09:51.000000', 'temperatura', 293.0000, 'ºC'),
	(132208, 110, '2015-04-01 01:09:52.000000', 'temperatura', 1154.0000, 'ºC'),
	(132209, 110, '2015-04-01 01:09:53.000000', 'temperatura', 92.0000, 'ºC'),
	(132210, 110, '2015-04-01 01:09:54.000000', 'temperatura', 599.0000, 'ºC'),
	(132211, 110, '2015-04-01 01:09:55.000000', 'temperatura', 317.0000, 'ºC'),
	(132212, 110, '2015-04-01 01:09:56.000000', 'temperatura', 990.0000, 'ºC'),
	(132213, 110, '2015-04-01 01:09:57.000000', 'temperatura', 399.0000, 'ºC'),
	(132214, 110, '2015-04-01 01:09:58.000000', 'temperatura', 226.0000, 'ºC'),
	(132215, 110, '2015-04-01 01:09:59.000000', 'temperatura', 1132.0000, 'ºC'),
	(132216, 110, '2015-04-01 01:10:00.000000', 'temperatura', 185.0000, 'ºC'),
	(132217, 110, '2015-04-01 01:10:01.000000', 'temperatura', 1129.0000, 'ºC'),
	(132218, 110, '2015-04-01 01:10:02.000000', 'temperatura', 289.0000, 'ºC'),
	(132219, 110, '2015-04-01 01:10:03.000000', 'temperatura', 459.0000, 'ºC'),
	(132220, 110, '2015-04-01 01:10:04.000000', 'temperatura', 228.0000, 'ºC'),
	(132221, 110, '2015-04-01 01:10:05.000000', 'temperatura', 962.0000, 'ºC'),
	(132222, 110, '2015-04-01 01:10:06.000000', 'temperatura', 528.0000, 'ºC'),
	(132223, 110, '2015-04-01 01:10:07.000000', 'temperatura', 955.0000, 'ºC'),
	(132224, 110, '2015-04-01 01:10:08.000000', 'temperatura', 790.0000, 'ºC'),
	(132225, 110, '2015-04-01 01:10:09.000000', 'temperatura', 1087.0000, 'ºC'),
	(132226, 110, '2015-04-01 01:10:10.000000', 'temperatura', 664.0000, 'ºC'),
	(132227, 110, '2015-04-01 01:10:11.000000', 'temperatura', 59.0000, 'ºC'),
	(132228, 110, '2015-04-01 01:10:12.000000', 'temperatura', 706.0000, 'ºC'),
	(132229, 110, '2015-04-01 01:10:13.000000', 'temperatura', 951.0000, 'ºC'),
	(132230, 110, '2015-04-01 01:10:14.000000', 'temperatura', 239.0000, 'ºC'),
	(132231, 110, '2015-04-01 01:10:15.000000', 'temperatura', 740.0000, 'ºC'),
	(132232, 110, '2015-04-01 01:10:16.000000', 'temperatura', 586.0000, 'ºC'),
	(132233, 110, '2015-04-01 01:10:17.000000', 'temperatura', 711.0000, 'ºC'),
	(132234, 110, '2015-04-01 01:10:18.000000', 'temperatura', 598.0000, 'ºC'),
	(132235, 110, '2015-04-01 01:10:19.000000', 'temperatura', 855.0000, 'ºC'),
	(132236, 110, '2015-04-01 01:10:20.000000', 'temperatura', 85.0000, 'ºC'),
	(132237, 110, '2015-04-01 01:10:21.000000', 'temperatura', 257.0000, 'ºC'),
	(132238, 110, '2015-04-01 01:10:22.000000', 'temperatura', 1034.0000, 'ºC'),
	(132239, 110, '2015-04-01 01:10:23.000000', 'temperatura', 796.0000, 'ºC'),
	(132240, 110, '2015-04-01 01:10:24.000000', 'temperatura', 881.0000, 'ºC'),
	(132241, 110, '2015-04-01 01:10:25.000000', 'temperatura', 816.0000, 'ºC'),
	(132242, 110, '2015-04-01 01:10:26.000000', 'temperatura', 238.0000, 'ºC'),
	(132243, 110, '2015-04-01 01:10:27.000000', 'temperatura', 1142.0000, 'ºC'),
	(132244, 110, '2015-04-01 01:10:28.000000', 'temperatura', 197.0000, 'ºC'),
	(132245, 110, '2015-04-01 01:10:29.000000', 'temperatura', 1160.0000, 'ºC'),
	(132246, 110, '2015-04-01 01:10:30.000000', 'temperatura', 410.0000, 'ºC'),
	(132247, 110, '2015-04-01 01:10:31.000000', 'temperatura', 972.0000, 'ºC'),
	(132248, 110, '2015-04-01 01:10:32.000000', 'temperatura', 27.0000, 'ºC'),
	(132249, 110, '2015-04-01 01:10:33.000000', 'temperatura', 821.0000, 'ºC'),
	(132250, 110, '2015-04-01 01:10:34.000000', 'temperatura', 426.0000, 'ºC'),
	(132251, 110, '2015-04-01 01:10:35.000000', 'temperatura', 866.0000, 'ºC'),
	(132252, 110, '2015-04-01 01:10:36.000000', 'temperatura', 654.0000, 'ºC'),
	(132253, 110, '2015-04-01 01:10:37.000000', 'temperatura', 671.0000, 'ºC'),
	(132254, 110, '2015-04-01 01:10:38.000000', 'temperatura', 193.0000, 'ºC'),
	(132255, 110, '2015-04-01 01:10:39.000000', 'temperatura', 153.0000, 'ºC'),
	(132256, 110, '2015-04-01 01:10:40.000000', 'temperatura', 188.0000, 'ºC'),
	(132257, 110, '2015-04-01 01:10:41.000000', 'temperatura', 482.0000, 'ºC'),
	(132258, 110, '2015-04-01 01:10:42.000000', 'temperatura', 644.0000, 'ºC'),
	(132259, 110, '2015-04-01 01:10:43.000000', 'temperatura', 576.0000, 'ºC'),
	(132260, 110, '2015-04-01 01:10:44.000000', 'temperatura', 947.0000, 'ºC'),
	(132261, 110, '2015-04-01 01:10:45.000000', 'temperatura', 610.0000, 'ºC'),
	(132262, 110, '2015-04-01 01:10:46.000000', 'temperatura', 207.0000, 'ºC'),
	(132263, 110, '2015-04-01 01:10:47.000000', 'temperatura', 408.0000, 'ºC'),
	(132264, 110, '2015-04-01 01:10:48.000000', 'temperatura', 221.0000, 'ºC'),
	(132265, 110, '2015-04-01 01:10:49.000000', 'temperatura', 1078.0000, 'ºC'),
	(132266, 110, '2015-04-01 01:10:50.000000', 'temperatura', 1127.0000, 'ºC'),
	(132267, 110, '2015-04-01 01:10:51.000000', 'temperatura', 2.0000, 'ºC'),
	(132268, 110, '2015-04-01 01:10:52.000000', 'temperatura', 228.0000, 'ºC'),
	(132269, 110, '2015-04-01 01:10:53.000000', 'temperatura', 1136.0000, 'ºC'),
	(132270, 110, '2015-04-01 01:10:54.000000', 'temperatura', 197.0000, 'ºC'),
	(132271, 110, '2015-04-01 01:10:55.000000', 'temperatura', 1179.0000, 'ºC'),
	(132272, 110, '2015-04-01 01:10:56.000000', 'temperatura', 502.0000, 'ºC'),
	(132273, 110, '2015-04-01 01:10:57.000000', 'temperatura', 176.0000, 'ºC'),
	(132274, 110, '2015-04-01 01:10:58.000000', 'temperatura', 574.0000, 'ºC'),
	(132275, 110, '2015-04-01 01:10:59.000000', 'temperatura', 1140.0000, 'ºC'),
	(132276, 110, '2015-04-01 01:11:00.000000', 'temperatura', 381.0000, 'ºC'),
	(132277, 110, '2015-04-01 01:11:01.000000', 'temperatura', 884.0000, 'ºC'),
	(132278, 110, '2015-04-01 01:11:02.000000', 'temperatura', 879.0000, 'ºC'),
	(132279, 110, '2015-04-01 01:11:03.000000', 'temperatura', 542.0000, 'ºC'),
	(132280, 110, '2015-04-01 01:11:04.000000', 'temperatura', 73.0000, 'ºC'),
	(132281, 110, '2015-04-01 01:11:05.000000', 'temperatura', 1139.0000, 'ºC'),
	(132282, 110, '2015-04-01 01:11:06.000000', 'temperatura', 679.0000, 'ºC'),
	(132283, 110, '2015-04-01 01:11:07.000000', 'temperatura', 1175.0000, 'ºC'),
	(132284, 110, '2015-04-01 01:11:08.000000', 'temperatura', 242.0000, 'ºC'),
	(132285, 110, '2015-04-01 01:11:09.000000', 'temperatura', 84.0000, 'ºC'),
	(132286, 110, '2015-04-01 01:11:10.000000', 'temperatura', 897.0000, 'ºC'),
	(132287, 110, '2015-04-01 01:11:11.000000', 'temperatura', 631.0000, 'ºC'),
	(132288, 110, '2015-04-01 01:11:12.000000', 'temperatura', 464.0000, 'ºC'),
	(132289, 110, '2015-04-01 01:11:13.000000', 'temperatura', 428.0000, 'ºC'),
	(132290, 110, '2015-04-01 01:11:14.000000', 'temperatura', 750.0000, 'ºC'),
	(132291, 110, '2015-04-01 01:11:15.000000', 'temperatura', 68.0000, 'ºC'),
	(132292, 110, '2015-04-01 01:11:16.000000', 'temperatura', 487.0000, 'ºC'),
	(132293, 110, '2015-04-01 01:11:17.000000', 'temperatura', 1035.0000, 'ºC'),
	(132294, 110, '2015-04-01 01:11:18.000000', 'temperatura', 112.0000, 'ºC'),
	(132295, 110, '2015-04-01 01:11:19.000000', 'temperatura', 1057.0000, 'ºC'),
	(132296, 110, '2015-04-01 01:11:20.000000', 'temperatura', 149.0000, 'ºC'),
	(132297, 110, '2015-04-01 01:11:21.000000', 'temperatura', 1176.0000, 'ºC'),
	(132298, 110, '2015-04-01 01:11:22.000000', 'temperatura', 631.0000, 'ºC'),
	(132299, 110, '2015-04-01 01:11:23.000000', 'temperatura', 827.0000, 'ºC'),
	(132300, 110, '2015-04-01 01:11:24.000000', 'temperatura', 1045.0000, 'ºC'),
	(132301, 110, '2015-04-01 01:11:25.000000', 'temperatura', 342.0000, 'ºC'),
	(132302, 110, '2015-04-01 01:11:26.000000', 'temperatura', 978.0000, 'ºC'),
	(132303, 110, '2015-04-01 01:11:27.000000', 'temperatura', 264.0000, 'ºC'),
	(132304, 110, '2015-04-01 01:11:28.000000', 'temperatura', 787.0000, 'ºC'),
	(132305, 110, '2015-04-01 01:11:29.000000', 'temperatura', 745.0000, 'ºC'),
	(132306, 110, '2015-04-01 01:11:30.000000', 'temperatura', 162.0000, 'ºC'),
	(132307, 110, '2015-04-01 01:11:31.000000', 'temperatura', 977.0000, 'ºC'),
	(132308, 110, '2015-04-01 01:11:32.000000', 'temperatura', 800.0000, 'ºC'),
	(132309, 110, '2015-04-01 01:11:33.000000', 'temperatura', 1068.0000, 'ºC'),
	(132310, 110, '2015-04-01 01:11:34.000000', 'temperatura', 539.0000, 'ºC'),
	(132311, 110, '2015-04-01 01:11:35.000000', 'temperatura', 693.0000, 'ºC'),
	(132312, 110, '2015-04-01 01:11:36.000000', 'temperatura', 647.0000, 'ºC'),
	(132313, 110, '2015-04-01 01:11:37.000000', 'temperatura', 1158.0000, 'ºC'),
	(132314, 110, '2015-04-01 01:11:38.000000', 'temperatura', 247.0000, 'ºC'),
	(132315, 110, '2015-04-01 01:11:39.000000', 'temperatura', 165.0000, 'ºC'),
	(132316, 110, '2015-04-01 01:11:40.000000', 'temperatura', 83.0000, 'ºC'),
	(132317, 110, '2015-04-01 01:11:41.000000', 'temperatura', 1119.0000, 'ºC'),
	(132318, 110, '2015-04-01 01:11:42.000000', 'temperatura', 549.0000, 'ºC'),
	(132319, 110, '2015-04-01 01:11:43.000000', 'temperatura', 589.0000, 'ºC'),
	(132320, 110, '2015-04-01 01:11:44.000000', 'temperatura', 96.0000, 'ºC'),
	(132321, 110, '2015-04-01 01:11:45.000000', 'temperatura', 1116.0000, 'ºC'),
	(132322, 110, '2015-04-01 01:11:46.000000', 'temperatura', 491.0000, 'ºC'),
	(132323, 110, '2015-04-01 01:11:47.000000', 'temperatura', 306.0000, 'ºC'),
	(132324, 110, '2015-04-01 01:11:48.000000', 'temperatura', 60.0000, 'ºC'),
	(132325, 110, '2015-04-01 01:11:49.000000', 'temperatura', 582.0000, 'ºC'),
	(132326, 110, '2015-04-01 01:11:50.000000', 'temperatura', 331.0000, 'ºC'),
	(132327, 110, '2015-04-01 01:11:51.000000', 'temperatura', 1110.0000, 'ºC'),
	(132328, 110, '2015-04-01 01:11:52.000000', 'temperatura', 956.0000, 'ºC'),
	(132329, 110, '2015-04-01 01:11:53.000000', 'temperatura', 253.0000, 'ºC'),
	(132330, 110, '2015-04-01 01:11:54.000000', 'temperatura', 794.0000, 'ºC'),
	(132331, 110, '2015-04-01 01:11:55.000000', 'temperatura', 814.0000, 'ºC'),
	(132332, 110, '2015-04-01 01:11:56.000000', 'temperatura', 488.0000, 'ºC'),
	(132333, 110, '2015-04-01 01:11:57.000000', 'temperatura', 0.0000, 'ºC'),
	(132334, 110, '2015-04-01 01:11:58.000000', 'temperatura', 935.0000, 'ºC'),
	(132335, 110, '2015-04-01 01:11:59.000000', 'temperatura', 1075.0000, 'ºC'),
	(132336, 110, '2015-04-01 01:12:00.000000', 'temperatura', 170.0000, 'ºC'),
	(132337, 110, '2015-04-01 01:12:01.000000', 'temperatura', 26.0000, 'ºC'),
	(132338, 110, '2015-04-01 01:12:02.000000', 'temperatura', 822.0000, 'ºC'),
	(132339, 110, '2015-04-01 01:12:03.000000', 'temperatura', 433.0000, 'ºC'),
	(132340, 110, '2015-04-01 01:12:04.000000', 'temperatura', 900.0000, 'ºC'),
	(132341, 110, '2015-04-01 01:12:05.000000', 'temperatura', 799.0000, 'ºC'),
	(132342, 110, '2015-04-01 01:12:06.000000', 'temperatura', 95.0000, 'ºC'),
	(132343, 110, '2015-04-01 01:12:07.000000', 'temperatura', 481.0000, 'ºC'),
	(132344, 110, '2015-04-01 01:12:08.000000', 'temperatura', 918.0000, 'ºC'),
	(132345, 110, '2015-04-01 01:12:09.000000', 'temperatura', 750.0000, 'ºC'),
	(132346, 110, '2015-04-01 01:12:10.000000', 'temperatura', 997.0000, 'ºC'),
	(132347, 110, '2015-04-01 01:12:11.000000', 'temperatura', 334.0000, 'ºC'),
	(132348, 110, '2015-04-01 01:12:12.000000', 'temperatura', 1079.0000, 'ºC'),
	(132349, 110, '2015-04-01 01:12:13.000000', 'temperatura', 794.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(132350, 110, '2015-04-01 01:12:14.000000', 'temperatura', 736.0000, 'ºC'),
	(132351, 110, '2015-04-01 01:12:15.000000', 'temperatura', 95.0000, 'ºC'),
	(132352, 110, '2015-04-01 01:12:16.000000', 'temperatura', 670.0000, 'ºC'),
	(132353, 110, '2015-04-01 01:12:17.000000', 'temperatura', 663.0000, 'ºC'),
	(132354, 110, '2015-04-01 01:12:18.000000', 'temperatura', 106.0000, 'ºC'),
	(132355, 110, '2015-04-01 01:12:19.000000', 'temperatura', 940.0000, 'ºC'),
	(132356, 110, '2015-04-01 01:12:20.000000', 'temperatura', 783.0000, 'ºC'),
	(132357, 110, '2015-04-01 01:12:21.000000', 'temperatura', 1097.0000, 'ºC'),
	(132358, 110, '2015-04-01 01:12:22.000000', 'temperatura', 736.0000, 'ºC'),
	(132359, 110, '2015-04-01 01:12:23.000000', 'temperatura', 391.0000, 'ºC'),
	(132360, 110, '2015-04-01 01:12:24.000000', 'temperatura', 948.0000, 'ºC'),
	(132361, 110, '2015-04-01 01:12:25.000000', 'temperatura', 1165.0000, 'ºC'),
	(132362, 110, '2015-04-01 01:12:26.000000', 'temperatura', 583.0000, 'ºC'),
	(132363, 110, '2015-04-01 01:12:27.000000', 'temperatura', 621.0000, 'ºC'),
	(132364, 110, '2015-04-01 01:12:28.000000', 'temperatura', 156.0000, 'ºC'),
	(132365, 110, '2015-04-01 01:12:29.000000', 'temperatura', 118.0000, 'ºC'),
	(132366, 110, '2015-04-01 01:12:30.000000', 'temperatura', 124.0000, 'ºC'),
	(132367, 110, '2015-04-01 01:12:31.000000', 'temperatura', 264.0000, 'ºC'),
	(132368, 110, '2015-04-01 01:12:32.000000', 'temperatura', 951.0000, 'ºC'),
	(132369, 110, '2015-04-01 01:12:33.000000', 'temperatura', 364.0000, 'ºC'),
	(132370, 110, '2015-04-01 01:12:34.000000', 'temperatura', 165.0000, 'ºC'),
	(132371, 110, '2015-04-01 01:12:35.000000', 'temperatura', 935.0000, 'ºC'),
	(132372, 110, '2015-04-01 01:12:36.000000', 'temperatura', 580.0000, 'ºC'),
	(132373, 110, '2015-04-01 01:12:37.000000', 'temperatura', 95.0000, 'ºC'),
	(132374, 110, '2015-04-01 01:12:38.000000', 'temperatura', 1136.0000, 'ºC'),
	(132375, 110, '2015-04-01 01:12:39.000000', 'temperatura', 595.0000, 'ºC'),
	(132376, 110, '2015-04-01 01:12:40.000000', 'temperatura', 769.0000, 'ºC'),
	(132377, 110, '2015-04-01 01:12:41.000000', 'temperatura', 861.0000, 'ºC'),
	(132378, 110, '2015-04-01 01:12:42.000000', 'temperatura', 799.0000, 'ºC'),
	(132379, 110, '2015-04-01 01:12:43.000000', 'temperatura', 212.0000, 'ºC'),
	(132380, 110, '2015-04-01 01:12:44.000000', 'temperatura', 1062.0000, 'ºC'),
	(132381, 110, '2015-04-01 01:12:45.000000', 'temperatura', 1074.0000, 'ºC'),
	(132382, 110, '2015-04-01 01:12:46.000000', 'temperatura', 984.0000, 'ºC'),
	(132383, 110, '2015-04-01 01:12:47.000000', 'temperatura', 500.0000, 'ºC'),
	(132384, 110, '2015-04-01 01:12:48.000000', 'temperatura', 748.0000, 'ºC'),
	(132385, 110, '2015-04-01 01:12:49.000000', 'temperatura', 1039.0000, 'ºC'),
	(132386, 110, '2015-04-01 01:12:50.000000', 'temperatura', 553.0000, 'ºC'),
	(132387, 110, '2015-04-01 01:12:51.000000', 'temperatura', 847.0000, 'ºC'),
	(132388, 110, '2015-04-01 01:12:52.000000', 'temperatura', 175.0000, 'ºC'),
	(132389, 110, '2015-04-01 01:12:53.000000', 'temperatura', 737.0000, 'ºC'),
	(132390, 110, '2015-04-01 01:12:54.000000', 'temperatura', 761.0000, 'ºC'),
	(132391, 110, '2015-04-01 01:12:55.000000', 'temperatura', 395.0000, 'ºC'),
	(132392, 110, '2015-04-01 01:12:56.000000', 'temperatura', 892.0000, 'ºC'),
	(132393, 110, '2015-04-01 01:12:57.000000', 'temperatura', 876.0000, 'ºC'),
	(132394, 110, '2015-04-01 01:12:58.000000', 'temperatura', 504.0000, 'ºC'),
	(132395, 110, '2015-04-01 01:12:59.000000', 'temperatura', 1091.0000, 'ºC'),
	(132396, 110, '2015-04-01 01:13:00.000000', 'temperatura', 343.0000, 'ºC'),
	(132397, 110, '2015-04-01 01:13:01.000000', 'temperatura', 843.0000, 'ºC'),
	(132398, 110, '2015-04-01 01:13:02.000000', 'temperatura', 786.0000, 'ºC'),
	(132399, 110, '2015-04-01 01:13:03.000000', 'temperatura', 204.0000, 'ºC'),
	(132400, 110, '2015-04-01 01:13:04.000000', 'temperatura', 1061.0000, 'ºC'),
	(132401, 110, '2015-04-01 01:13:05.000000', 'temperatura', 1092.0000, 'ºC'),
	(132402, 110, '2015-04-01 01:13:06.000000', 'temperatura', 1080.0000, 'ºC'),
	(132403, 110, '2015-04-01 01:13:07.000000', 'temperatura', 922.0000, 'ºC'),
	(132404, 110, '2015-04-01 01:13:08.000000', 'temperatura', 172.0000, 'ºC'),
	(132405, 110, '2015-04-01 01:13:09.000000', 'temperatura', 494.0000, 'ºC'),
	(132406, 110, '2015-04-01 01:13:10.000000', 'temperatura', 755.0000, 'ºC'),
	(132407, 110, '2015-04-01 01:13:11.000000', 'temperatura', 1094.0000, 'ºC'),
	(132408, 110, '2015-04-01 01:13:12.000000', 'temperatura', 804.0000, 'ºC'),
	(132409, 110, '2015-04-01 01:13:13.000000', 'temperatura', 739.0000, 'ºC'),
	(132410, 110, '2015-04-01 01:13:14.000000', 'temperatura', 84.0000, 'ºC'),
	(132411, 110, '2015-04-01 01:13:15.000000', 'temperatura', 604.0000, 'ºC'),
	(132412, 110, '2015-04-01 01:13:16.000000', 'temperatura', 368.0000, 'ºC'),
	(132413, 110, '2015-04-01 01:13:17.000000', 'temperatura', 28.0000, 'ºC'),
	(132414, 110, '2015-04-01 01:13:18.000000', 'temperatura', 236.0000, 'ºC'),
	(132415, 110, '2015-04-01 01:13:19.000000', 'temperatura', 1096.0000, 'ºC'),
	(132416, 110, '2015-04-01 01:13:20.000000', 'temperatura', 1174.0000, 'ºC'),
	(132417, 110, '2015-04-01 01:13:21.000000', 'temperatura', 181.0000, 'ºC'),
	(132418, 110, '2015-04-01 01:13:22.000000', 'temperatura', 982.0000, 'ºC'),
	(132419, 110, '2015-04-01 01:13:23.000000', 'temperatura', 770.0000, 'ºC'),
	(132420, 110, '2015-04-01 01:13:24.000000', 'temperatura', 905.0000, 'ºC'),
	(132421, 110, '2015-04-01 01:13:25.000000', 'temperatura', 1014.0000, 'ºC'),
	(132422, 110, '2015-04-01 01:13:26.000000', 'temperatura', 1156.0000, 'ºC'),
	(132423, 110, '2015-04-01 01:13:27.000000', 'temperatura', 341.0000, 'ºC'),
	(132424, 110, '2015-04-01 01:13:28.000000', 'temperatura', 634.0000, 'ºC'),
	(132425, 110, '2015-04-01 01:13:29.000000', 'temperatura', 949.0000, 'ºC'),
	(132426, 110, '2015-04-01 01:13:30.000000', 'temperatura', 444.0000, 'ºC'),
	(132427, 110, '2015-04-01 01:13:31.000000', 'temperatura', 572.0000, 'ºC'),
	(132428, 110, '2015-04-01 01:13:32.000000', 'temperatura', 329.0000, 'ºC'),
	(132429, 110, '2015-04-01 01:13:33.000000', 'temperatura', 1128.0000, 'ºC'),
	(132430, 110, '2015-04-01 01:13:34.000000', 'temperatura', 1057.0000, 'ºC'),
	(132431, 110, '2015-04-01 01:13:35.000000', 'temperatura', 699.0000, 'ºC'),
	(132432, 110, '2015-04-01 01:13:36.000000', 'temperatura', 324.0000, 'ºC'),
	(132433, 110, '2015-04-01 01:13:37.000000', 'temperatura', 726.0000, 'ºC'),
	(132434, 110, '2015-04-01 01:13:38.000000', 'temperatura', 257.0000, 'ºC'),
	(132435, 110, '2015-04-01 01:13:39.000000', 'temperatura', 309.0000, 'ºC'),
	(132436, 110, '2015-04-01 01:13:40.000000', 'temperatura', 772.0000, 'ºC'),
	(132437, 110, '2015-04-01 01:13:41.000000', 'temperatura', 536.0000, 'ºC'),
	(132438, 110, '2015-04-01 01:13:42.000000', 'temperatura', 364.0000, 'ºC'),
	(132439, 110, '2015-04-01 01:13:43.000000', 'temperatura', 212.0000, 'ºC'),
	(132440, 110, '2015-04-01 01:13:44.000000', 'temperatura', 1170.0000, 'ºC'),
	(132441, 110, '2015-04-01 01:13:45.000000', 'temperatura', 416.0000, 'ºC'),
	(132442, 110, '2015-04-01 01:13:46.000000', 'temperatura', 967.0000, 'ºC'),
	(132443, 110, '2015-04-01 01:13:47.000000', 'temperatura', 1189.0000, 'ºC'),
	(132444, 110, '2015-04-01 01:13:48.000000', 'temperatura', 643.0000, 'ºC'),
	(132445, 110, '2015-04-01 01:13:49.000000', 'temperatura', 848.0000, 'ºC'),
	(132446, 110, '2015-04-01 01:13:50.000000', 'temperatura', 1113.0000, 'ºC'),
	(132447, 110, '2015-04-01 01:13:51.000000', 'temperatura', 623.0000, 'ºC'),
	(132448, 110, '2015-04-01 01:13:52.000000', 'temperatura', 974.0000, 'ºC'),
	(132449, 110, '2015-04-01 01:13:53.000000', 'temperatura', 600.0000, 'ºC'),
	(132450, 110, '2015-04-01 01:13:54.000000', 'temperatura', 82.0000, 'ºC'),
	(132451, 110, '2015-04-01 01:13:55.000000', 'temperatura', 1010.0000, 'ºC'),
	(132452, 110, '2015-04-01 01:13:56.000000', 'temperatura', 2.0000, 'ºC'),
	(132453, 110, '2015-04-01 01:13:57.000000', 'temperatura', 584.0000, 'ºC'),
	(132454, 110, '2015-04-01 01:13:58.000000', 'temperatura', 511.0000, 'ºC'),
	(132455, 110, '2015-04-01 01:13:59.000000', 'temperatura', 805.0000, 'ºC'),
	(132456, 110, '2015-04-01 01:14:00.000000', 'temperatura', 93.0000, 'ºC'),
	(132457, 110, '2015-04-01 01:14:01.000000', 'temperatura', 452.0000, 'ºC'),
	(132458, 110, '2015-04-01 01:14:02.000000', 'temperatura', 779.0000, 'ºC'),
	(132459, 110, '2015-04-01 01:14:03.000000', 'temperatura', 141.0000, 'ºC'),
	(132460, 110, '2015-04-01 01:14:04.000000', 'temperatura', 767.0000, 'ºC'),
	(132461, 110, '2015-04-01 01:14:05.000000', 'temperatura', 1015.0000, 'ºC'),
	(132462, 110, '2015-04-01 01:14:06.000000', 'temperatura', 373.0000, 'ºC'),
	(132463, 110, '2015-04-01 01:14:07.000000', 'temperatura', 20.0000, 'ºC'),
	(132464, 110, '2015-04-01 01:14:08.000000', 'temperatura', 180.0000, 'ºC'),
	(132465, 110, '2015-04-01 01:14:09.000000', 'temperatura', 842.0000, 'ºC'),
	(132466, 110, '2015-04-01 01:14:10.000000', 'temperatura', 71.0000, 'ºC'),
	(132467, 110, '2015-04-01 01:14:11.000000', 'temperatura', 229.0000, 'ºC'),
	(132468, 110, '2015-04-01 01:14:12.000000', 'temperatura', 933.0000, 'ºC'),
	(132469, 110, '2015-04-01 01:14:13.000000', 'temperatura', 379.0000, 'ºC'),
	(132470, 110, '2015-04-01 01:14:14.000000', 'temperatura', 296.0000, 'ºC'),
	(132471, 110, '2015-04-01 01:14:15.000000', 'temperatura', 342.0000, 'ºC'),
	(132472, 110, '2015-04-01 01:14:16.000000', 'temperatura', 824.0000, 'ºC'),
	(132473, 110, '2015-04-01 01:14:17.000000', 'temperatura', 693.0000, 'ºC'),
	(132474, 110, '2015-04-01 01:14:18.000000', 'temperatura', 995.0000, 'ºC'),
	(132475, 110, '2015-04-01 01:14:19.000000', 'temperatura', 495.0000, 'ºC'),
	(132476, 110, '2015-04-01 01:14:20.000000', 'temperatura', 691.0000, 'ºC'),
	(132477, 110, '2015-04-01 01:14:21.000000', 'temperatura', 771.0000, 'ºC'),
	(132478, 110, '2015-04-01 01:14:22.000000', 'temperatura', 584.0000, 'ºC'),
	(132479, 110, '2015-04-01 01:14:23.000000', 'temperatura', 605.0000, 'ºC'),
	(132480, 110, '2015-04-01 01:14:24.000000', 'temperatura', 74.0000, 'ºC'),
	(132481, 110, '2015-04-01 01:14:25.000000', 'temperatura', 957.0000, 'ºC'),
	(132482, 110, '2015-04-01 01:14:26.000000', 'temperatura', 961.0000, 'ºC'),
	(132483, 110, '2015-04-01 01:14:27.000000', 'temperatura', 734.0000, 'ºC'),
	(132484, 110, '2015-04-01 01:14:28.000000', 'temperatura', 791.0000, 'ºC'),
	(132485, 110, '2015-04-01 01:14:29.000000', 'temperatura', 550.0000, 'ºC'),
	(132486, 110, '2015-04-01 01:14:30.000000', 'temperatura', 380.0000, 'ºC'),
	(132487, 110, '2015-04-01 01:14:31.000000', 'temperatura', 248.0000, 'ºC'),
	(132488, 110, '2015-04-01 01:14:32.000000', 'temperatura', 103.0000, 'ºC'),
	(132489, 110, '2015-04-01 01:14:33.000000', 'temperatura', 973.0000, 'ºC'),
	(132490, 110, '2015-04-01 01:14:34.000000', 'temperatura', 953.0000, 'ºC'),
	(132491, 110, '2015-04-01 01:14:35.000000', 'temperatura', 649.0000, 'ºC'),
	(132492, 110, '2015-04-01 01:14:36.000000', 'temperatura', 384.0000, 'ºC'),
	(132493, 110, '2015-04-01 01:14:37.000000', 'temperatura', 1176.0000, 'ºC'),
	(132494, 110, '2015-04-01 01:14:38.000000', 'temperatura', 1127.0000, 'ºC'),
	(132495, 110, '2015-04-01 01:14:39.000000', 'temperatura', 908.0000, 'ºC'),
	(132496, 110, '2015-04-01 01:14:40.000000', 'temperatura', 1157.0000, 'ºC'),
	(132497, 110, '2015-04-01 01:14:41.000000', 'temperatura', 665.0000, 'ºC'),
	(132498, 110, '2015-04-01 01:14:42.000000', 'temperatura', 1052.0000, 'ºC'),
	(132499, 110, '2015-04-01 01:14:43.000000', 'temperatura', 866.0000, 'ºC'),
	(132500, 110, '2015-04-01 01:14:44.000000', 'temperatura', 1174.0000, 'ºC'),
	(132501, 110, '2015-04-01 01:14:45.000000', 'temperatura', 871.0000, 'ºC'),
	(132502, 110, '2015-04-01 01:14:46.000000', 'temperatura', 837.0000, 'ºC'),
	(132503, 110, '2015-04-01 01:14:47.000000', 'temperatura', 369.0000, 'ºC'),
	(132504, 110, '2015-04-01 01:14:48.000000', 'temperatura', 536.0000, 'ºC'),
	(132505, 110, '2015-04-01 01:14:49.000000', 'temperatura', 375.0000, 'ºC'),
	(132506, 110, '2015-04-01 01:14:50.000000', 'temperatura', 267.0000, 'ºC'),
	(132507, 110, '2015-04-01 01:14:51.000000', 'temperatura', 210.0000, 'ºC'),
	(132508, 110, '2015-04-01 01:14:52.000000', 'temperatura', 250.0000, 'ºC'),
	(132509, 110, '2015-04-01 01:14:53.000000', 'temperatura', 621.0000, 'ºC'),
	(132510, 110, '2015-04-01 01:14:54.000000', 'temperatura', 1154.0000, 'ºC'),
	(132511, 110, '2015-04-01 01:14:55.000000', 'temperatura', 306.0000, 'ºC'),
	(132512, 110, '2015-04-01 01:14:56.000000', 'temperatura', 471.0000, 'ºC'),
	(132513, 110, '2015-04-01 01:14:57.000000', 'temperatura', 239.0000, 'ºC'),
	(132514, 110, '2015-04-01 01:14:58.000000', 'temperatura', 980.0000, 'ºC'),
	(132515, 110, '2015-04-01 01:14:59.000000', 'temperatura', 586.0000, 'ºC'),
	(132516, 110, '2015-04-01 01:15:00.000000', 'temperatura', 1189.0000, 'ºC'),
	(132517, 110, '2015-04-01 01:15:01.000000', 'temperatura', 586.0000, 'ºC'),
	(132518, 110, '2015-04-01 01:15:02.000000', 'temperatura', 564.0000, 'ºC'),
	(132519, 110, '2015-04-01 01:15:03.000000', 'temperatura', 1062.0000, 'ºC'),
	(132520, 110, '2015-04-01 01:15:04.000000', 'temperatura', 18.0000, 'ºC'),
	(132521, 110, '2015-04-01 01:15:05.000000', 'temperatura', 507.0000, 'ºC'),
	(132522, 110, '2015-04-01 01:15:06.000000', 'temperatura', 82.0000, 'ºC'),
	(132523, 110, '2015-04-01 01:15:07.000000', 'temperatura', 89.0000, 'ºC'),
	(132524, 110, '2015-04-01 01:15:08.000000', 'temperatura', 200.0000, 'ºC'),
	(132525, 110, '2015-04-01 01:15:09.000000', 'temperatura', 731.0000, 'ºC'),
	(132526, 110, '2015-04-01 01:15:10.000000', 'temperatura', 658.0000, 'ºC'),
	(132527, 110, '2015-04-01 01:15:11.000000', 'temperatura', 1097.0000, 'ºC'),
	(132528, 110, '2015-04-01 01:15:12.000000', 'temperatura', 1110.0000, 'ºC'),
	(132529, 110, '2015-04-01 01:15:13.000000', 'temperatura', 1060.0000, 'ºC'),
	(132530, 110, '2015-04-01 01:15:14.000000', 'temperatura', 772.0000, 'ºC'),
	(132531, 110, '2015-04-01 01:15:15.000000', 'temperatura', 678.0000, 'ºC'),
	(132532, 110, '2015-04-01 01:15:16.000000', 'temperatura', 1076.0000, 'ºC'),
	(132533, 110, '2015-04-01 01:15:17.000000', 'temperatura', 945.0000, 'ºC'),
	(132534, 110, '2015-04-01 01:15:18.000000', 'temperatura', 300.0000, 'ºC'),
	(132535, 110, '2015-04-01 01:15:19.000000', 'temperatura', 1063.0000, 'ºC'),
	(132536, 110, '2015-04-01 01:15:20.000000', 'temperatura', 818.0000, 'ºC'),
	(132537, 110, '2015-04-01 01:15:21.000000', 'temperatura', 899.0000, 'ºC'),
	(132538, 110, '2015-04-01 01:15:22.000000', 'temperatura', 843.0000, 'ºC'),
	(132539, 110, '2015-04-01 01:15:23.000000', 'temperatura', 318.0000, 'ºC'),
	(132540, 110, '2015-04-01 01:15:24.000000', 'temperatura', 260.0000, 'ºC'),
	(132541, 110, '2015-04-01 01:15:25.000000', 'temperatura', 346.0000, 'ºC'),
	(132542, 110, '2015-04-01 01:15:26.000000', 'temperatura', 953.0000, 'ºC'),
	(132543, 110, '2015-04-01 01:15:27.000000', 'temperatura', 128.0000, 'ºC'),
	(132544, 110, '2015-04-01 01:15:28.000000', 'temperatura', 179.0000, 'ºC'),
	(132545, 110, '2015-04-01 01:15:29.000000', 'temperatura', 511.0000, 'ºC'),
	(132546, 110, '2015-04-01 01:15:30.000000', 'temperatura', 819.0000, 'ºC'),
	(132547, 110, '2015-04-01 01:15:31.000000', 'temperatura', 161.0000, 'ºC'),
	(132548, 110, '2015-04-01 01:15:32.000000', 'temperatura', 750.0000, 'ºC'),
	(132549, 110, '2015-04-01 01:15:33.000000', 'temperatura', 866.0000, 'ºC'),
	(132550, 110, '2015-04-01 01:15:34.000000', 'temperatura', 882.0000, 'ºC'),
	(132551, 110, '2015-04-01 01:15:35.000000', 'temperatura', 611.0000, 'ºC'),
	(132552, 110, '2015-04-01 01:15:36.000000', 'temperatura', 410.0000, 'ºC'),
	(132553, 110, '2015-04-01 01:15:37.000000', 'temperatura', 219.0000, 'ºC'),
	(132554, 110, '2015-04-01 01:15:38.000000', 'temperatura', 1066.0000, 'ºC'),
	(132555, 110, '2015-04-01 01:15:39.000000', 'temperatura', 1072.0000, 'ºC'),
	(132556, 110, '2015-04-01 01:15:40.000000', 'temperatura', 962.0000, 'ºC'),
	(132557, 110, '2015-04-01 01:15:41.000000', 'temperatura', 397.0000, 'ºC'),
	(132558, 110, '2015-04-01 01:15:42.000000', 'temperatura', 297.0000, 'ºC'),
	(132559, 110, '2015-04-01 01:15:43.000000', 'temperatura', 297.0000, 'ºC'),
	(132560, 110, '2015-04-01 01:15:44.000000', 'temperatura', 594.0000, 'ºC'),
	(132561, 110, '2015-04-01 01:15:45.000000', 'temperatura', 877.0000, 'ºC'),
	(132562, 110, '2015-04-01 01:15:46.000000', 'temperatura', 205.0000, 'ºC'),
	(132563, 110, '2015-04-01 01:15:47.000000', 'temperatura', 794.0000, 'ºC'),
	(132564, 110, '2015-04-01 01:15:48.000000', 'temperatura', 955.0000, 'ºC'),
	(132565, 110, '2015-04-01 01:15:49.000000', 'temperatura', 1194.0000, 'ºC'),
	(132566, 110, '2015-04-01 01:15:50.000000', 'temperatura', 705.0000, 'ºC'),
	(132567, 110, '2015-04-01 01:15:51.000000', 'temperatura', 1142.0000, 'ºC'),
	(132568, 110, '2015-04-01 01:15:52.000000', 'temperatura', 1197.0000, 'ºC'),
	(132569, 110, '2015-04-01 01:15:53.000000', 'temperatura', 158.0000, 'ºC'),
	(132570, 110, '2015-04-01 01:15:54.000000', 'temperatura', 799.0000, 'ºC'),
	(132571, 110, '2015-04-01 01:15:55.000000', 'temperatura', 1124.0000, 'ºC'),
	(132572, 110, '2015-04-01 01:15:56.000000', 'temperatura', 823.0000, 'ºC'),
	(132573, 110, '2015-04-01 01:15:57.000000', 'temperatura', 745.0000, 'ºC'),
	(132574, 110, '2015-04-01 01:15:58.000000', 'temperatura', 56.0000, 'ºC'),
	(132575, 110, '2015-04-01 01:15:59.000000', 'temperatura', 444.0000, 'ºC'),
	(132576, 110, '2015-04-01 01:16:00.000000', 'temperatura', 853.0000, 'ºC'),
	(132577, 110, '2015-04-01 01:16:01.000000', 'temperatura', 535.0000, 'ºC'),
	(132578, 110, '2015-04-01 01:16:02.000000', 'temperatura', 115.0000, 'ºC'),
	(132579, 110, '2015-04-01 01:16:03.000000', 'temperatura', 173.0000, 'ºC'),
	(132580, 110, '2015-04-01 01:16:04.000000', 'temperatura', 517.0000, 'ºC'),
	(132581, 110, '2015-04-01 01:16:05.000000', 'temperatura', 869.0000, 'ºC'),
	(132582, 110, '2015-04-01 01:16:06.000000', 'temperatura', 394.0000, 'ºC'),
	(132583, 110, '2015-04-01 01:16:07.000000', 'temperatura', 564.0000, 'ºC'),
	(132584, 110, '2015-04-01 01:16:08.000000', 'temperatura', 436.0000, 'ºC'),
	(132585, 110, '2015-04-01 01:16:09.000000', 'temperatura', 492.0000, 'ºC'),
	(132586, 110, '2015-04-01 01:16:10.000000', 'temperatura', 1150.0000, 'ºC'),
	(132587, 110, '2015-04-01 01:16:11.000000', 'temperatura', 673.0000, 'ºC'),
	(132588, 110, '2015-04-01 01:16:12.000000', 'temperatura', 1118.0000, 'ºC'),
	(132589, 110, '2015-04-01 01:16:13.000000', 'temperatura', 1170.0000, 'ºC'),
	(132590, 110, '2015-04-01 01:16:14.000000', 'temperatura', 97.0000, 'ºC'),
	(132591, 110, '2015-04-01 01:16:15.000000', 'temperatura', 575.0000, 'ºC'),
	(132592, 110, '2015-04-01 01:16:16.000000', 'temperatura', 184.0000, 'ºC'),
	(132593, 110, '2015-04-01 01:16:17.000000', 'temperatura', 396.0000, 'ºC'),
	(132594, 110, '2015-04-01 01:16:18.000000', 'temperatura', 229.0000, 'ºC'),
	(132595, 110, '2015-04-01 01:16:19.000000', 'temperatura', 1155.0000, 'ºC'),
	(132596, 110, '2015-04-01 01:16:20.000000', 'temperatura', 290.0000, 'ºC'),
	(132597, 110, '2015-04-01 01:16:21.000000', 'temperatura', 388.0000, 'ºC'),
	(132598, 110, '2015-04-01 01:16:22.000000', 'temperatura', 1067.0000, 'ºC'),
	(132599, 110, '2015-04-01 01:16:23.000000', 'temperatura', 571.0000, 'ºC'),
	(132600, 110, '2015-04-01 01:16:24.000000', 'temperatura', 856.0000, 'ºC'),
	(132601, 110, '2015-04-01 01:16:25.000000', 'temperatura', 169.0000, 'ºC'),
	(132602, 110, '2015-04-01 01:16:26.000000', 'temperatura', 676.0000, 'ºC'),
	(132603, 110, '2015-04-01 01:16:27.000000', 'temperatura', 474.0000, 'ºC'),
	(132604, 110, '2015-04-01 01:16:28.000000', 'temperatura', 343.0000, 'ºC'),
	(132605, 110, '2015-04-01 01:16:29.000000', 'temperatura', 293.0000, 'ºC'),
	(132606, 110, '2015-04-01 01:16:30.000000', 'temperatura', 438.0000, 'ºC'),
	(132607, 110, '2015-04-01 01:16:31.000000', 'temperatura', 109.0000, 'ºC'),
	(132608, 110, '2015-04-01 01:16:32.000000', 'temperatura', 434.0000, 'ºC'),
	(132609, 110, '2015-04-01 01:16:33.000000', 'temperatura', 642.0000, 'ºC'),
	(132610, 110, '2015-04-01 01:16:34.000000', 'temperatura', 707.0000, 'ºC'),
	(132611, 110, '2015-04-01 01:16:35.000000', 'temperatura', 411.0000, 'ºC'),
	(132612, 110, '2015-04-01 01:16:36.000000', 'temperatura', 1134.0000, 'ºC'),
	(132613, 110, '2015-04-01 01:16:37.000000', 'temperatura', 838.0000, 'ºC'),
	(132614, 110, '2015-04-01 01:16:38.000000', 'temperatura', 789.0000, 'ºC'),
	(132615, 110, '2015-04-01 01:16:39.000000', 'temperatura', 231.0000, 'ºC'),
	(132616, 110, '2015-04-01 01:16:40.000000', 'temperatura', 1187.0000, 'ºC'),
	(132617, 110, '2015-04-01 01:16:41.000000', 'temperatura', 441.0000, 'ºC'),
	(132618, 110, '2015-04-01 01:16:42.000000', 'temperatura', 1048.0000, 'ºC'),
	(132619, 110, '2015-04-01 01:16:43.000000', 'temperatura', 318.0000, 'ºC'),
	(132620, 110, '2015-04-01 01:16:44.000000', 'temperatura', 844.0000, 'ºC'),
	(132621, 110, '2015-04-01 01:16:45.000000', 'temperatura', 866.0000, 'ºC'),
	(132622, 110, '2015-04-01 01:16:46.000000', 'temperatura', 602.0000, 'ºC'),
	(132623, 110, '2015-04-01 01:16:47.000000', 'temperatura', 409.0000, 'ºC'),
	(132624, 110, '2015-04-01 01:16:48.000000', 'temperatura', 241.0000, 'ºC'),
	(132625, 110, '2015-04-01 01:16:49.000000', 'temperatura', 1178.0000, 'ºC'),
	(132626, 110, '2015-04-01 01:16:50.000000', 'temperatura', 370.0000, 'ºC'),
	(132627, 110, '2015-04-01 01:16:51.000000', 'temperatura', 713.0000, 'ºC'),
	(132628, 110, '2015-04-01 01:16:52.000000', 'temperatura', 58.0000, 'ºC'),
	(132629, 110, '2015-04-01 01:16:53.000000', 'temperatura', 550.0000, 'ºC'),
	(132630, 110, '2015-04-01 01:16:54.000000', 'temperatura', 177.0000, 'ºC'),
	(132631, 110, '2015-04-01 01:16:55.000000', 'temperatura', 435.0000, 'ºC'),
	(132632, 110, '2015-04-01 01:16:56.000000', 'temperatura', 445.0000, 'ºC'),
	(132633, 110, '2015-04-01 01:16:57.000000', 'temperatura', 920.0000, 'ºC'),
	(132634, 110, '2015-04-01 01:16:58.000000', 'temperatura', 867.0000, 'ºC'),
	(132635, 110, '2015-04-01 01:16:59.000000', 'temperatura', 376.0000, 'ºC'),
	(132636, 110, '2015-04-01 01:17:00.000000', 'temperatura', 478.0000, 'ºC'),
	(132637, 110, '2015-04-01 01:17:01.000000', 'temperatura', 63.0000, 'ºC'),
	(132638, 110, '2015-04-01 01:17:02.000000', 'temperatura', 80.0000, 'ºC'),
	(132639, 110, '2015-04-01 01:17:03.000000', 'temperatura', 213.0000, 'ºC'),
	(132640, 110, '2015-04-01 01:17:04.000000', 'temperatura', 824.0000, 'ºC'),
	(132641, 110, '2015-04-01 01:17:05.000000', 'temperatura', 1080.0000, 'ºC'),
	(132642, 110, '2015-04-01 01:17:06.000000', 'temperatura', 531.0000, 'ºC'),
	(132643, 110, '2015-04-01 01:17:07.000000', 'temperatura', 616.0000, 'ºC'),
	(132644, 110, '2015-04-01 01:17:08.000000', 'temperatura', 286.0000, 'ºC'),
	(132645, 110, '2015-04-01 01:17:09.000000', 'temperatura', 783.0000, 'ºC'),
	(132646, 110, '2015-04-01 01:17:10.000000', 'temperatura', 658.0000, 'ºC'),
	(132647, 110, '2015-04-01 01:17:11.000000', 'temperatura', 941.0000, 'ºC'),
	(132648, 110, '2015-04-01 01:17:12.000000', 'temperatura', 331.0000, 'ºC'),
	(132649, 110, '2015-04-01 01:17:13.000000', 'temperatura', 33.0000, 'ºC'),
	(132650, 110, '2015-04-01 01:17:14.000000', 'temperatura', 372.0000, 'ºC'),
	(132651, 110, '2015-04-01 01:17:15.000000', 'temperatura', 561.0000, 'ºC'),
	(132652, 110, '2015-04-01 01:17:16.000000', 'temperatura', 488.0000, 'ºC'),
	(132653, 110, '2015-04-01 01:17:17.000000', 'temperatura', 761.0000, 'ºC'),
	(132654, 110, '2015-04-01 01:17:18.000000', 'temperatura', 1140.0000, 'ºC'),
	(132655, 110, '2015-04-01 01:17:19.000000', 'temperatura', 1016.0000, 'ºC'),
	(132656, 110, '2015-04-01 01:17:20.000000', 'temperatura', 462.0000, 'ºC'),
	(132657, 110, '2015-04-01 01:17:21.000000', 'temperatura', 464.0000, 'ºC'),
	(132658, 110, '2015-04-01 01:17:22.000000', 'temperatura', 934.0000, 'ºC'),
	(132659, 110, '2015-04-01 01:17:23.000000', 'temperatura', 876.0000, 'ºC'),
	(132660, 110, '2015-04-01 01:17:24.000000', 'temperatura', 381.0000, 'ºC'),
	(132661, 110, '2015-04-01 01:17:25.000000', 'temperatura', 476.0000, 'ºC'),
	(132662, 110, '2015-04-01 01:17:26.000000', 'temperatura', 38.0000, 'ºC'),
	(132663, 110, '2015-04-01 01:17:27.000000', 'temperatura', 1163.0000, 'ºC'),
	(132664, 110, '2015-04-01 01:17:28.000000', 'temperatura', 902.0000, 'ºC'),
	(132665, 110, '2015-04-01 01:17:29.000000', 'temperatura', 1021.0000, 'ºC'),
	(132666, 110, '2015-04-01 01:17:30.000000', 'temperatura', 1199.0000, 'ºC'),
	(132667, 110, '2015-04-01 01:17:31.000000', 'temperatura', 531.0000, 'ºC'),
	(132668, 110, '2015-04-01 01:17:32.000000', 'temperatura', 260.0000, 'ºC'),
	(132669, 110, '2015-04-01 01:17:33.000000', 'temperatura', 907.0000, 'ºC'),
	(132670, 110, '2015-04-01 01:17:34.000000', 'temperatura', 158.0000, 'ºC'),
	(132671, 110, '2015-04-01 01:17:35.000000', 'temperatura', 466.0000, 'ºC'),
	(132672, 110, '2015-04-01 01:17:36.000000', 'temperatura', 659.0000, 'ºC'),
	(132673, 110, '2015-04-01 01:17:37.000000', 'temperatura', 696.0000, 'ºC'),
	(132674, 110, '2015-04-01 01:17:38.000000', 'temperatura', 304.0000, 'ºC'),
	(132675, 110, '2015-04-01 01:17:39.000000', 'temperatura', 630.0000, 'ºC'),
	(132676, 110, '2015-04-01 01:17:40.000000', 'temperatura', 1042.0000, 'ºC'),
	(132677, 110, '2015-04-01 01:17:41.000000', 'temperatura', 919.0000, 'ºC'),
	(132678, 110, '2015-04-01 01:17:42.000000', 'temperatura', 269.0000, 'ºC'),
	(132679, 110, '2015-04-01 01:17:43.000000', 'temperatura', 988.0000, 'ºC'),
	(132680, 110, '2015-04-01 01:17:44.000000', 'temperatura', 534.0000, 'ºC'),
	(132681, 110, '2015-04-01 01:17:45.000000', 'temperatura', 905.0000, 'ºC'),
	(132682, 110, '2015-04-01 01:17:46.000000', 'temperatura', 525.0000, 'ºC'),
	(132683, 110, '2015-04-01 01:17:47.000000', 'temperatura', 1110.0000, 'ºC'),
	(132684, 110, '2015-04-01 01:17:48.000000', 'temperatura', 378.0000, 'ºC'),
	(132685, 110, '2015-04-01 01:17:49.000000', 'temperatura', 958.0000, 'ºC'),
	(132686, 110, '2015-04-01 01:17:50.000000', 'temperatura', 57.0000, 'ºC'),
	(132687, 110, '2015-04-01 01:17:51.000000', 'temperatura', 1010.0000, 'ºC'),
	(132688, 110, '2015-04-01 01:17:52.000000', 'temperatura', 79.0000, 'ºC'),
	(132689, 110, '2015-04-01 01:17:53.000000', 'temperatura', 969.0000, 'ºC'),
	(132690, 110, '2015-04-01 01:17:54.000000', 'temperatura', 1005.0000, 'ºC'),
	(132691, 110, '2015-04-01 01:17:55.000000', 'temperatura', 920.0000, 'ºC'),
	(132692, 110, '2015-04-01 01:17:56.000000', 'temperatura', 383.0000, 'ºC'),
	(132693, 110, '2015-04-01 01:17:57.000000', 'temperatura', 358.0000, 'ºC'),
	(132694, 110, '2015-04-01 01:17:58.000000', 'temperatura', 642.0000, 'ºC'),
	(132695, 110, '2015-04-01 01:17:59.000000', 'temperatura', 937.0000, 'ºC'),
	(132696, 110, '2015-04-01 01:18:00.000000', 'temperatura', 360.0000, 'ºC'),
	(132697, 110, '2015-04-01 01:18:01.000000', 'temperatura', 190.0000, 'ºC'),
	(132698, 110, '2015-04-01 01:18:02.000000', 'temperatura', 1069.0000, 'ºC'),
	(132699, 110, '2015-04-01 01:18:03.000000', 'temperatura', 1174.0000, 'ºC'),
	(132700, 110, '2015-04-01 01:18:04.000000', 'temperatura', 266.0000, 'ºC'),
	(132701, 110, '2015-04-01 01:18:05.000000', 'temperatura', 207.0000, 'ºC'),
	(132702, 110, '2015-04-01 01:18:06.000000', 'temperatura', 237.0000, 'ºC'),
	(132703, 110, '2015-04-01 01:18:07.000000', 'temperatura', 566.0000, 'ºC'),
	(132704, 110, '2015-04-01 01:18:08.000000', 'temperatura', 918.0000, 'ºC'),
	(132705, 110, '2015-04-01 01:18:09.000000', 'temperatura', 495.0000, 'ºC'),
	(132706, 110, '2015-04-01 01:18:10.000000', 'temperatura', 919.0000, 'ºC'),
	(132707, 110, '2015-04-01 01:18:11.000000', 'temperatura', 713.0000, 'ºC'),
	(132708, 110, '2015-04-01 01:18:12.000000', 'temperatura', 807.0000, 'ºC'),
	(132709, 110, '2015-04-01 01:18:13.000000', 'temperatura', 698.0000, 'ºC'),
	(132710, 110, '2015-04-01 01:18:14.000000', 'temperatura', 1069.0000, 'ºC'),
	(132711, 110, '2015-04-01 01:18:15.000000', 'temperatura', 852.0000, 'ºC'),
	(132712, 110, '2015-04-01 01:18:16.000000', 'temperatura', 1052.0000, 'ºC'),
	(132713, 110, '2015-04-01 01:18:17.000000', 'temperatura', 305.0000, 'ºC'),
	(132714, 110, '2015-04-01 01:18:18.000000', 'temperatura', 771.0000, 'ºC'),
	(132715, 110, '2015-04-01 01:18:19.000000', 'temperatura', 540.0000, 'ºC'),
	(132716, 110, '2015-04-01 01:18:20.000000', 'temperatura', 389.0000, 'ºC'),
	(132717, 110, '2015-04-01 01:18:21.000000', 'temperatura', 325.0000, 'ºC'),
	(132718, 110, '2015-04-01 01:18:22.000000', 'temperatura', 460.0000, 'ºC'),
	(132719, 110, '2015-04-01 01:18:23.000000', 'temperatura', 124.0000, 'ºC'),
	(132720, 110, '2015-04-01 01:18:24.000000', 'temperatura', 443.0000, 'ºC'),
	(132721, 110, '2015-04-01 01:18:25.000000', 'temperatura', 640.0000, 'ºC'),
	(132722, 110, '2015-04-01 01:18:26.000000', 'temperatura', 672.0000, 'ºC'),
	(132723, 110, '2015-04-01 01:18:27.000000', 'temperatura', 239.0000, 'ºC'),
	(132724, 110, '2015-04-01 01:18:28.000000', 'temperatura', 382.0000, 'ºC'),
	(132725, 110, '2015-04-01 01:18:29.000000', 'temperatura', 1194.0000, 'ºC'),
	(132726, 110, '2015-04-01 01:18:30.000000', 'temperatura', 22.0000, 'ºC'),
	(132727, 110, '2015-04-01 01:18:31.000000', 'temperatura', 128.0000, 'ºC'),
	(132728, 110, '2015-04-01 01:18:32.000000', 'temperatura', 578.0000, 'ºC'),
	(132729, 110, '2015-04-01 01:18:33.000000', 'temperatura', 103.0000, 'ºC'),
	(132730, 110, '2015-04-01 01:18:34.000000', 'temperatura', 1182.0000, 'ºC'),
	(132731, 110, '2015-04-01 01:18:35.000000', 'temperatura', 803.0000, 'ºC'),
	(132732, 110, '2015-04-01 01:18:36.000000', 'temperatura', 470.0000, 'ºC'),
	(132733, 110, '2015-04-01 01:18:37.000000', 'temperatura', 1142.0000, 'ºC'),
	(132734, 110, '2015-04-01 01:18:38.000000', 'temperatura', 699.0000, 'ºC'),
	(132735, 110, '2015-04-01 01:18:39.000000', 'temperatura', 71.0000, 'ºC'),
	(132736, 110, '2015-04-01 01:18:40.000000', 'temperatura', 659.0000, 'ºC'),
	(132737, 110, '2015-04-01 01:18:41.000000', 'temperatura', 682.0000, 'ºC'),
	(132738, 110, '2015-04-01 01:18:42.000000', 'temperatura', 235.0000, 'ºC'),
	(132739, 110, '2015-04-01 01:18:43.000000', 'temperatura', 328.0000, 'ºC'),
	(132740, 110, '2015-04-01 01:18:44.000000', 'temperatura', 935.0000, 'ºC'),
	(132741, 110, '2015-04-01 01:18:45.000000', 'temperatura', 90.0000, 'ºC'),
	(132742, 110, '2015-04-01 01:18:46.000000', 'temperatura', 49.0000, 'ºC'),
	(132743, 110, '2015-04-01 01:18:47.000000', 'temperatura', 1173.0000, 'ºC'),
	(132744, 110, '2015-04-01 01:18:48.000000', 'temperatura', 920.0000, 'ºC'),
	(132745, 110, '2015-04-01 01:18:49.000000', 'temperatura', 1080.0000, 'ºC'),
	(132746, 110, '2015-04-01 01:18:50.000000', 'temperatura', 239.0000, 'ºC'),
	(132747, 110, '2015-04-01 01:18:51.000000', 'temperatura', 357.0000, 'ºC'),
	(132748, 110, '2015-04-01 01:18:52.000000', 'temperatura', 1070.0000, 'ºC'),
	(132749, 110, '2015-04-01 01:18:53.000000', 'temperatura', 678.0000, 'ºC'),
	(132750, 110, '2015-04-01 01:18:54.000000', 'temperatura', 179.0000, 'ºC'),
	(132751, 110, '2015-04-01 01:18:55.000000', 'temperatura', 62.0000, 'ºC'),
	(132752, 110, '2015-04-01 01:18:56.000000', 'temperatura', 974.0000, 'ºC'),
	(132753, 110, '2015-04-01 01:18:57.000000', 'temperatura', 1087.0000, 'ºC'),
	(132754, 110, '2015-04-01 01:18:58.000000', 'temperatura', 110.0000, 'ºC'),
	(132755, 110, '2015-04-01 01:18:59.000000', 'temperatura', 890.0000, 'ºC'),
	(132756, 110, '2015-04-01 01:19:00.000000', 'temperatura', 520.0000, 'ºC'),
	(132757, 110, '2015-04-01 01:19:01.000000', 'temperatura', 1133.0000, 'ºC'),
	(132758, 110, '2015-04-01 01:19:02.000000', 'temperatura', 504.0000, 'ºC'),
	(132759, 110, '2015-04-01 01:19:03.000000', 'temperatura', 323.0000, 'ºC'),
	(132760, 110, '2015-04-01 01:19:04.000000', 'temperatura', 101.0000, 'ºC'),
	(132761, 110, '2015-04-01 01:19:05.000000', 'temperatura', 738.0000, 'ºC'),
	(132762, 110, '2015-04-01 01:19:06.000000', 'temperatura', 989.0000, 'ºC'),
	(132763, 110, '2015-04-01 01:19:07.000000', 'temperatura', 330.0000, 'ºC'),
	(132764, 110, '2015-04-01 01:19:08.000000', 'temperatura', 1084.0000, 'ºC'),
	(132765, 110, '2015-04-01 01:19:09.000000', 'temperatura', 830.0000, 'ºC'),
	(132766, 110, '2015-04-01 01:19:10.000000', 'temperatura', 898.0000, 'ºC'),
	(132767, 110, '2015-04-01 01:19:11.000000', 'temperatura', 801.0000, 'ºC'),
	(132768, 110, '2015-04-01 01:19:12.000000', 'temperatura', 111.0000, 'ºC'),
	(132769, 110, '2015-04-01 01:19:13.000000', 'temperatura', 554.0000, 'ºC'),
	(132770, 110, '2015-04-01 01:19:14.000000', 'temperatura', 37.0000, 'ºC'),
	(132771, 110, '2015-04-01 01:19:15.000000', 'temperatura', 921.0000, 'ºC'),
	(132772, 110, '2015-04-01 01:19:16.000000', 'temperatura', 898.0000, 'ºC'),
	(132773, 110, '2015-04-01 01:19:17.000000', 'temperatura', 526.0000, 'ºC'),
	(132774, 110, '2015-04-01 01:19:18.000000', 'temperatura', 1135.0000, 'ºC'),
	(132775, 110, '2015-04-01 01:19:19.000000', 'temperatura', 500.0000, 'ºC'),
	(132776, 110, '2015-04-01 01:19:20.000000', 'temperatura', 294.0000, 'ºC'),
	(132777, 110, '2015-04-01 01:19:21.000000', 'temperatura', 1169.0000, 'ºC'),
	(132778, 110, '2015-04-01 01:19:22.000000', 'temperatura', 165.0000, 'ºC'),
	(132779, 110, '2015-04-01 01:19:23.000000', 'temperatura', 920.0000, 'ºC'),
	(132780, 110, '2015-04-01 01:19:24.000000', 'temperatura', 504.0000, 'ºC'),
	(132781, 110, '2015-04-01 01:19:25.000000', 'temperatura', 962.0000, 'ºC'),
	(132782, 110, '2015-04-01 01:19:26.000000', 'temperatura', 896.0000, 'ºC'),
	(132783, 110, '2015-04-01 01:19:27.000000', 'temperatura', 394.0000, 'ºC'),
	(132784, 110, '2015-04-01 01:19:28.000000', 'temperatura', 483.0000, 'ºC'),
	(132785, 110, '2015-04-01 01:19:29.000000', 'temperatura', 34.0000, 'ºC'),
	(132786, 110, '2015-04-01 01:19:30.000000', 'temperatura', 1119.0000, 'ºC'),
	(132787, 110, '2015-04-01 01:19:31.000000', 'temperatura', 697.0000, 'ºC'),
	(132788, 110, '2015-04-01 01:19:32.000000', 'temperatura', 126.0000, 'ºC'),
	(132789, 110, '2015-04-01 01:19:33.000000', 'temperatura', 942.0000, 'ºC'),
	(132790, 110, '2015-04-01 01:19:34.000000', 'temperatura', 733.0000, 'ºC'),
	(132791, 110, '2015-04-01 01:19:35.000000', 'temperatura', 839.0000, 'ºC'),
	(132792, 110, '2015-04-01 01:19:36.000000', 'temperatura', 794.0000, 'ºC'),
	(132793, 110, '2015-04-01 01:19:37.000000', 'temperatura', 257.0000, 'ºC'),
	(132794, 110, '2015-04-01 01:19:38.000000', 'temperatura', 102.0000, 'ºC'),
	(132795, 110, '2015-04-01 01:19:39.000000', 'temperatura', 941.0000, 'ºC'),
	(132796, 110, '2015-04-01 01:19:40.000000', 'temperatura', 797.0000, 'ºC'),
	(132797, 110, '2015-04-01 01:19:41.000000', 'temperatura', 1161.0000, 'ºC'),
	(132798, 110, '2015-04-01 01:19:42.000000', 'temperatura', 1018.0000, 'ºC'),
	(132799, 110, '2015-04-01 01:19:43.000000', 'temperatura', 407.0000, 'ºC'),
	(132800, 110, '2015-04-01 01:19:44.000000', 'temperatura', 183.0000, 'ºC'),
	(132801, 110, '2015-04-01 01:19:45.000000', 'temperatura', 891.0000, 'ºC'),
	(132802, 110, '2015-04-01 01:19:46.000000', 'temperatura', 309.0000, 'ºC'),
	(132803, 110, '2015-04-01 01:19:47.000000', 'temperatura', 74.0000, 'ºC'),
	(132804, 110, '2015-04-01 01:19:48.000000', 'temperatura', 641.0000, 'ºC'),
	(132805, 110, '2015-04-01 01:19:49.000000', 'temperatura', 584.0000, 'ºC'),
	(132806, 110, '2015-04-01 01:19:50.000000', 'temperatura', 998.0000, 'ºC'),
	(132807, 110, '2015-04-01 01:19:51.000000', 'temperatura', 837.0000, 'ºC'),
	(132808, 110, '2015-04-01 01:19:52.000000', 'temperatura', 1194.0000, 'ºC'),
	(132809, 110, '2015-04-01 01:19:53.000000', 'temperatura', 1060.0000, 'ºC'),
	(132810, 110, '2015-04-01 01:19:54.000000', 'temperatura', 518.0000, 'ºC'),
	(132811, 110, '2015-04-01 01:19:55.000000', 'temperatura', 610.0000, 'ºC'),
	(132812, 110, '2015-04-01 01:19:56.000000', 'temperatura', 295.0000, 'ºC'),
	(132813, 110, '2015-04-01 01:19:57.000000', 'temperatura', 846.0000, 'ºC'),
	(132814, 110, '2015-04-01 01:19:58.000000', 'temperatura', 947.0000, 'ºC'),
	(132815, 110, '2015-04-01 01:19:59.000000', 'temperatura', 995.0000, 'ºC'),
	(132816, 110, '2015-04-01 01:20:00.000000', 'temperatura', 935.0000, 'ºC'),
	(132817, 110, '2015-04-01 01:20:01.000000', 'temperatura', 492.0000, 'ºC'),
	(132818, 110, '2015-04-01 01:20:02.000000', 'temperatura', 854.0000, 'ºC'),
	(132819, 110, '2015-04-01 01:20:03.000000', 'temperatura', 394.0000, 'ºC'),
	(132820, 110, '2015-04-01 01:20:04.000000', 'temperatura', 608.0000, 'ºC'),
	(132821, 110, '2015-04-01 01:20:05.000000', 'temperatura', 659.0000, 'ºC'),
	(132822, 110, '2015-04-01 01:20:06.000000', 'temperatura', 273.0000, 'ºC'),
	(132823, 110, '2015-04-01 01:20:07.000000', 'temperatura', 586.0000, 'ºC'),
	(132824, 110, '2015-04-01 01:20:08.000000', 'temperatura', 912.0000, 'ºC'),
	(132825, 110, '2015-04-01 01:20:09.000000', 'temperatura', 405.0000, 'ºC'),
	(132826, 110, '2015-04-01 01:20:10.000000', 'temperatura', 487.0000, 'ºC'),
	(132827, 110, '2015-04-01 01:20:11.000000', 'temperatura', 23.0000, 'ºC'),
	(132828, 110, '2015-04-01 01:20:12.000000', 'temperatura', 1055.0000, 'ºC'),
	(132829, 110, '2015-04-01 01:20:13.000000', 'temperatura', 405.0000, 'ºC'),
	(132830, 110, '2015-04-01 01:20:14.000000', 'temperatura', 60.0000, 'ºC'),
	(132831, 110, '2015-04-01 01:20:15.000000', 'temperatura', 287.0000, 'ºC'),
	(132832, 110, '2015-04-01 01:20:16.000000', 'temperatura', 54.0000, 'ºC'),
	(132833, 110, '2015-04-01 01:20:17.000000', 'temperatura', 611.0000, 'ºC'),
	(132834, 110, '2015-04-01 01:20:18.000000', 'temperatura', 493.0000, 'ºC'),
	(132835, 110, '2015-04-01 01:20:19.000000', 'temperatura', 633.0000, 'ºC'),
	(132836, 110, '2015-04-01 01:20:20.000000', 'temperatura', 488.0000, 'ºC'),
	(132837, 110, '2015-04-01 01:20:21.000000', 'temperatura', 540.0000, 'ºC'),
	(132838, 110, '2015-04-01 01:20:22.000000', 'temperatura', 38.0000, 'ºC'),
	(132839, 110, '2015-04-01 01:20:23.000000', 'temperatura', 969.0000, 'ºC'),
	(132840, 110, '2015-04-01 01:20:24.000000', 'temperatura', 1132.0000, 'ºC'),
	(132841, 110, '2015-04-01 01:20:25.000000', 'temperatura', 352.0000, 'ºC'),
	(132842, 110, '2015-04-01 01:20:26.000000', 'temperatura', 765.0000, 'ºC'),
	(132843, 110, '2015-04-01 01:20:27.000000', 'temperatura', 371.0000, 'ºC'),
	(132844, 110, '2015-04-01 01:20:28.000000', 'temperatura', 759.0000, 'ºC'),
	(132845, 110, '2015-04-01 01:20:29.000000', 'temperatura', 283.0000, 'ºC'),
	(132846, 110, '2015-04-01 01:20:30.000000', 'temperatura', 336.0000, 'ºC'),
	(132847, 110, '2015-04-01 01:20:31.000000', 'temperatura', 835.0000, 'ºC'),
	(132848, 110, '2015-04-01 01:20:32.000000', 'temperatura', 766.0000, 'ºC'),
	(132849, 110, '2015-04-01 01:20:33.000000', 'temperatura', 125.0000, 'ºC'),
	(132850, 110, '2015-04-01 01:20:34.000000', 'temperatura', 727.0000, 'ºC'),
	(132851, 110, '2015-04-01 01:20:35.000000', 'temperatura', 862.0000, 'ºC'),
	(132852, 110, '2015-04-01 01:20:36.000000', 'temperatura', 929.0000, 'ºC'),
	(132853, 110, '2015-04-01 01:20:37.000000', 'temperatura', 861.0000, 'ºC'),
	(132854, 110, '2015-04-01 01:20:38.000000', 'temperatura', 319.0000, 'ºC'),
	(132855, 110, '2015-04-01 01:20:39.000000', 'temperatura', 212.0000, 'ºC'),
	(132856, 110, '2015-04-01 01:20:40.000000', 'temperatura', 105.0000, 'ºC'),
	(132857, 110, '2015-04-01 01:20:41.000000', 'temperatura', 1089.0000, 'ºC'),
	(132858, 110, '2015-04-01 01:20:42.000000', 'temperatura', 328.0000, 'ºC'),
	(132859, 110, '2015-04-01 01:20:43.000000', 'temperatura', 775.0000, 'ºC'),
	(132860, 110, '2015-04-01 01:20:44.000000', 'temperatura', 491.0000, 'ºC'),
	(132861, 110, '2015-04-01 01:20:45.000000', 'temperatura', 131.0000, 'ºC'),
	(132862, 110, '2015-04-01 01:20:46.000000', 'temperatura', 382.0000, 'ºC'),
	(132863, 110, '2015-04-01 01:20:47.000000', 'temperatura', 317.0000, 'ºC'),
	(132864, 110, '2015-04-01 01:20:48.000000', 'temperatura', 439.0000, 'ºC'),
	(132865, 110, '2015-04-01 01:20:49.000000', 'temperatura', 43.0000, 'ºC'),
	(132866, 110, '2015-04-01 01:20:50.000000', 'temperatura', 102.0000, 'ºC'),
	(132867, 110, '2015-04-01 01:20:51.000000', 'temperatura', 380.0000, 'ºC'),
	(132868, 110, '2015-04-01 01:20:52.000000', 'temperatura', 393.0000, 'ºC'),
	(132869, 110, '2015-04-01 01:20:53.000000', 'temperatura', 826.0000, 'ºC'),
	(132870, 110, '2015-04-01 01:20:54.000000', 'temperatura', 553.0000, 'ºC'),
	(132871, 110, '2015-04-01 01:20:55.000000', 'temperatura', 288.0000, 'ºC'),
	(132872, 110, '2015-04-01 01:20:56.000000', 'temperatura', 982.0000, 'ºC'),
	(132873, 110, '2015-04-01 01:20:57.000000', 'temperatura', 447.0000, 'ºC'),
	(132874, 110, '2015-04-01 01:20:58.000000', 'temperatura', 489.0000, 'ºC'),
	(132875, 110, '2015-04-01 01:20:59.000000', 'temperatura', 1103.0000, 'ºC'),
	(132876, 110, '2015-04-01 01:21:00.000000', 'temperatura', 447.0000, 'ºC'),
	(132877, 110, '2015-04-01 01:21:01.000000', 'temperatura', 130.0000, 'ºC'),
	(132878, 110, '2015-04-01 01:21:02.000000', 'temperatura', 508.0000, 'ºC'),
	(132879, 110, '2015-04-01 01:21:03.000000', 'temperatura', 949.0000, 'ºC'),
	(132880, 110, '2015-04-01 01:21:04.000000', 'temperatura', 821.0000, 'ºC'),
	(132881, 110, '2015-04-01 01:21:05.000000', 'temperatura', 61.0000, 'ºC'),
	(132882, 110, '2015-04-01 01:21:06.000000', 'temperatura', 243.0000, 'ºC'),
	(132883, 110, '2015-04-01 01:21:07.000000', 'temperatura', 1033.0000, 'ºC'),
	(132884, 110, '2015-04-01 01:21:08.000000', 'temperatura', 833.0000, 'ºC'),
	(132885, 110, '2015-04-01 01:21:09.000000', 'temperatura', 1070.0000, 'ºC'),
	(132886, 110, '2015-04-01 01:21:10.000000', 'temperatura', 452.0000, 'ºC'),
	(132887, 110, '2015-04-01 01:21:11.000000', 'temperatura', 248.0000, 'ºC'),
	(132888, 110, '2015-04-01 01:21:12.000000', 'temperatura', 1085.0000, 'ºC'),
	(132889, 110, '2015-04-01 01:21:13.000000', 'temperatura', 1082.0000, 'ºC'),
	(132890, 110, '2015-04-01 01:21:14.000000', 'temperatura', 955.0000, 'ºC'),
	(132891, 110, '2015-04-01 01:21:15.000000', 'temperatura', 329.0000, 'ºC'),
	(132892, 110, '2015-04-01 01:21:16.000000', 'temperatura', 1180.0000, 'ºC'),
	(132893, 110, '2015-04-01 01:21:17.000000', 'temperatura', 114.0000, 'ºC'),
	(132894, 110, '2015-04-01 01:21:18.000000', 'temperatura', 632.0000, 'ºC'),
	(132895, 110, '2015-04-01 01:21:19.000000', 'temperatura', 420.0000, 'ºC'),
	(132896, 110, '2015-04-01 01:21:20.000000', 'temperatura', 201.0000, 'ºC'),
	(132897, 110, '2015-04-01 01:21:21.000000', 'temperatura', 947.0000, 'ºC'),
	(132898, 110, '2015-04-01 01:21:22.000000', 'temperatura', 532.0000, 'ºC'),
	(132899, 110, '2015-04-01 01:21:23.000000', 'temperatura', 1020.0000, 'ºC'),
	(132900, 110, '2015-04-01 01:21:24.000000', 'temperatura', 1106.0000, 'ºC'),
	(132901, 110, '2015-04-01 01:21:25.000000', 'temperatura', 68.0000, 'ºC'),
	(132902, 110, '2015-04-01 01:21:26.000000', 'temperatura', 625.0000, 'ºC'),
	(132903, 110, '2015-04-01 01:21:27.000000', 'temperatura', 519.0000, 'ºC'),
	(132904, 110, '2015-04-01 01:21:28.000000', 'temperatura', 722.0000, 'ºC'),
	(132905, 110, '2015-04-01 01:21:29.000000', 'temperatura', 855.0000, 'ºC'),
	(132906, 110, '2015-04-01 01:21:30.000000', 'temperatura', 909.0000, 'ºC'),
	(132907, 110, '2015-04-01 01:21:31.000000', 'temperatura', 778.0000, 'ºC'),
	(132908, 110, '2015-04-01 01:21:32.000000', 'temperatura', 1165.0000, 'ºC'),
	(132909, 110, '2015-04-01 01:21:33.000000', 'temperatura', 1093.0000, 'ºC'),
	(132910, 110, '2015-04-01 01:21:34.000000', 'temperatura', 771.0000, 'ºC'),
	(132911, 110, '2015-04-01 01:21:35.000000', 'temperatura', 576.0000, 'ºC'),
	(132912, 110, '2015-04-01 01:21:36.000000', 'temperatura', 568.0000, 'ºC'),
	(132913, 110, '2015-04-01 01:21:37.000000', 'temperatura', 1110.0000, 'ºC'),
	(132914, 110, '2015-04-01 01:21:38.000000', 'temperatura', 247.0000, 'ºC'),
	(132915, 110, '2015-04-01 01:21:39.000000', 'temperatura', 305.0000, 'ºC'),
	(132916, 110, '2015-04-01 01:21:40.000000', 'temperatura', 785.0000, 'ºC'),
	(132917, 110, '2015-04-01 01:21:41.000000', 'temperatura', 612.0000, 'ºC'),
	(132918, 110, '2015-04-01 01:21:42.000000', 'temperatura', 705.0000, 'ºC'),
	(132919, 110, '2015-04-01 01:21:43.000000', 'temperatura', 490.0000, 'ºC'),
	(132920, 110, '2015-04-01 01:21:44.000000', 'temperatura', 335.0000, 'ºC'),
	(132921, 110, '2015-04-01 01:21:45.000000', 'temperatura', 206.0000, 'ºC'),
	(132922, 110, '2015-04-01 01:21:46.000000', 'temperatura', 26.0000, 'ºC'),
	(132923, 110, '2015-04-01 01:21:47.000000', 'temperatura', 712.0000, 'ºC'),
	(132924, 110, '2015-04-01 01:21:48.000000', 'temperatura', 1082.0000, 'ºC'),
	(132925, 110, '2015-04-01 01:21:49.000000', 'temperatura', 876.0000, 'ºC'),
	(132926, 110, '2015-04-01 01:21:50.000000', 'temperatura', 1134.0000, 'ºC'),
	(132927, 110, '2015-04-01 01:21:51.000000', 'temperatura', 644.0000, 'ºC'),
	(132928, 110, '2015-04-01 01:21:52.000000', 'temperatura', 1017.0000, 'ºC'),
	(132929, 110, '2015-04-01 01:21:53.000000', 'temperatura', 753.0000, 'ºC'),
	(132930, 110, '2015-04-01 01:21:54.000000', 'temperatura', 713.0000, 'ºC'),
	(132931, 110, '2015-04-01 01:21:55.000000', 'temperatura', 109.0000, 'ºC'),
	(132932, 110, '2015-04-01 01:21:56.000000', 'temperatura', 805.0000, 'ºC'),
	(132933, 110, '2015-04-01 01:21:57.000000', 'temperatura', 99.0000, 'ºC'),
	(132934, 110, '2015-04-01 01:21:58.000000', 'temperatura', 481.0000, 'ºC'),
	(132935, 110, '2015-04-01 01:21:59.000000', 'temperatura', 908.0000, 'ºC'),
	(132936, 110, '2015-04-01 01:22:00.000000', 'temperatura', 696.0000, 'ºC'),
	(132937, 110, '2015-04-01 01:22:01.000000', 'temperatura', 758.0000, 'ºC'),
	(132938, 110, '2015-04-01 01:22:02.000000', 'temperatura', 500.0000, 'ºC'),
	(132939, 110, '2015-04-01 01:22:03.000000', 'temperatura', 229.0000, 'ºC'),
	(132940, 110, '2015-04-01 01:22:04.000000', 'temperatura', 843.0000, 'ºC'),
	(132941, 110, '2015-04-01 01:22:05.000000', 'temperatura', 1130.0000, 'ºC'),
	(132942, 110, '2015-04-01 01:22:06.000000', 'temperatura', 721.0000, 'ºC'),
	(132943, 110, '2015-04-01 01:22:07.000000', 'temperatura', 215.0000, 'ºC'),
	(132944, 110, '2015-04-01 01:22:08.000000', 'temperatura', 114.0000, 'ºC'),
	(132945, 110, '2015-04-01 01:22:09.000000', 'temperatura', 1123.0000, 'ºC'),
	(132946, 110, '2015-04-01 01:22:10.000000', 'temperatura', 476.0000, 'ºC'),
	(132947, 110, '2015-04-01 01:22:11.000000', 'temperatura', 209.0000, 'ºC'),
	(132948, 110, '2015-04-01 01:22:12.000000', 'temperatura', 819.0000, 'ºC'),
	(132949, 110, '2015-04-01 01:22:13.000000', 'temperatura', 1069.0000, 'ºC'),
	(132950, 110, '2015-04-01 01:22:14.000000', 'temperatura', 489.0000, 'ºC'),
	(132951, 110, '2015-04-01 01:22:15.000000', 'temperatura', 437.0000, 'ºC'),
	(132952, 110, '2015-04-01 01:22:16.000000', 'temperatura', 718.0000, 'ºC'),
	(132953, 110, '2015-04-01 01:22:17.000000', 'temperatura', 1082.0000, 'ºC'),
	(132954, 110, '2015-04-01 01:22:18.000000', 'temperatura', 856.0000, 'ºC'),
	(132955, 110, '2015-04-01 01:22:19.000000', 'temperatura', 1034.0000, 'ºC'),
	(132956, 110, '2015-04-01 01:22:20.000000', 'temperatura', 204.0000, 'ºC'),
	(132957, 110, '2015-04-01 01:22:21.000000', 'temperatura', 317.0000, 'ºC'),
	(132958, 110, '2015-04-01 01:22:22.000000', 'temperatura', 973.0000, 'ºC'),
	(132959, 110, '2015-04-01 01:22:23.000000', 'temperatura', 314.0000, 'ºC'),
	(132960, 110, '2015-04-01 01:22:24.000000', 'temperatura', 1051.0000, 'ºC'),
	(132961, 110, '2015-04-01 01:22:25.000000', 'temperatura', 714.0000, 'ºC'),
	(132962, 110, '2015-04-01 01:22:26.000000', 'temperatura', 420.0000, 'ºC'),
	(132963, 110, '2015-04-01 01:22:27.000000', 'temperatura', 1156.0000, 'ºC'),
	(132964, 110, '2015-04-01 01:22:28.000000', 'temperatura', 921.0000, 'ºC'),
	(132965, 110, '2015-04-01 01:22:29.000000', 'temperatura', 1139.0000, 'ºC'),
	(132966, 110, '2015-04-01 01:22:30.000000', 'temperatura', 531.0000, 'ºC'),
	(132967, 110, '2015-04-01 01:22:31.000000', 'temperatura', 441.0000, 'ºC'),
	(132968, 110, '2015-04-01 01:22:32.000000', 'temperatura', 610.0000, 'ºC'),
	(132969, 110, '2015-04-01 01:22:33.000000', 'temperatura', 530.0000, 'ºC'),
	(132970, 110, '2015-04-01 01:22:34.000000', 'temperatura', 819.0000, 'ºC'),
	(132971, 110, '2015-04-01 01:22:35.000000', 'temperatura', 104.0000, 'ºC'),
	(132972, 110, '2015-04-01 01:22:36.000000', 'temperatura', 466.0000, 'ºC'),
	(132973, 110, '2015-04-01 01:22:37.000000', 'temperatura', 818.0000, 'ºC'),
	(132974, 110, '2015-04-01 01:22:38.000000', 'temperatura', 293.0000, 'ºC'),
	(132975, 110, '2015-04-01 01:22:39.000000', 'temperatura', 210.0000, 'ºC'),
	(132976, 110, '2015-04-01 01:22:40.000000', 'temperatura', 171.0000, 'ºC'),
	(132977, 110, '2015-04-01 01:22:41.000000', 'temperatura', 227.0000, 'ºC'),
	(132978, 110, '2015-04-01 01:22:42.000000', 'temperatura', 623.0000, 'ºC'),
	(132979, 110, '2015-04-01 01:22:43.000000', 'temperatura', 36.0000, 'ºC'),
	(132980, 110, '2015-04-01 01:22:44.000000', 'temperatura', 708.0000, 'ºC'),
	(132981, 110, '2015-04-01 01:22:45.000000', 'temperatura', 1036.0000, 'ºC'),
	(132982, 110, '2015-04-01 01:22:46.000000', 'temperatura', 654.0000, 'ºC'),
	(132983, 110, '2015-04-01 01:22:47.000000', 'temperatura', 164.0000, 'ºC'),
	(132984, 110, '2015-04-01 01:22:48.000000', 'temperatura', 56.0000, 'ºC'),
	(132985, 110, '2015-04-01 01:22:49.000000', 'temperatura', 989.0000, 'ºC'),
	(132986, 110, '2015-04-01 01:22:50.000000', 'temperatura', 1180.0000, 'ºC'),
	(132987, 110, '2015-04-01 01:22:51.000000', 'temperatura', 533.0000, 'ºC'),
	(132988, 110, '2015-04-01 01:22:52.000000', 'temperatura', 325.0000, 'ºC'),
	(132989, 110, '2015-04-01 01:22:53.000000', 'temperatura', 24.0000, 'ºC'),
	(132990, 110, '2015-04-01 01:22:54.000000', 'temperatura', 349.0000, 'ºC'),
	(132991, 110, '2015-04-01 01:22:55.000000', 'temperatura', 471.0000, 'ºC'),
	(132992, 110, '2015-04-01 01:22:56.000000', 'temperatura', 107.0000, 'ºC'),
	(132993, 110, '2015-04-01 01:22:57.000000', 'temperatura', 326.0000, 'ºC'),
	(132994, 110, '2015-04-01 01:22:58.000000', 'temperatura', 107.0000, 'ºC'),
	(132995, 110, '2015-04-01 01:22:59.000000', 'temperatura', 758.0000, 'ºC'),
	(132996, 110, '2015-04-01 01:23:00.000000', 'temperatura', 1069.0000, 'ºC'),
	(132997, 110, '2015-04-01 01:23:01.000000', 'temperatura', 673.0000, 'ºC'),
	(132998, 110, '2015-04-01 01:23:02.000000', 'temperatura', 158.0000, 'ºC'),
	(132999, 110, '2015-04-01 01:23:03.000000', 'temperatura', 1173.0000, 'ºC'),
	(133000, 110, '2015-04-01 01:23:04.000000', 'temperatura', 590.0000, 'ºC'),
	(133001, 110, '2015-04-01 01:23:05.000000', 'temperatura', 630.0000, 'ºC'),
	(133002, 110, '2015-04-01 01:23:06.000000', 'temperatura', 181.0000, 'ºC'),
	(133003, 110, '2015-04-01 01:23:07.000000', 'temperatura', 214.0000, 'ºC'),
	(133004, 110, '2015-04-01 01:23:08.000000', 'temperatura', 530.0000, 'ºC'),
	(133005, 110, '2015-04-01 01:23:09.000000', 'temperatura', 806.0000, 'ºC'),
	(133006, 110, '2015-04-01 01:23:10.000000', 'temperatura', 40.0000, 'ºC'),
	(133007, 110, '2015-04-01 01:23:11.000000', 'temperatura', 185.0000, 'ºC'),
	(133008, 110, '2015-04-01 01:23:12.000000', 'temperatura', 806.0000, 'ºC'),
	(133009, 110, '2015-04-01 01:23:13.000000', 'temperatura', 1074.0000, 'ºC'),
	(133010, 110, '2015-04-01 01:23:14.000000', 'temperatura', 551.0000, 'ºC'),
	(133011, 110, '2015-04-01 01:23:15.000000', 'temperatura', 736.0000, 'ºC'),
	(133012, 110, '2015-04-01 01:23:16.000000', 'temperatura', 825.0000, 'ºC'),
	(133013, 110, '2015-04-01 01:23:17.000000', 'temperatura', 721.0000, 'ºC'),
	(133014, 110, '2015-04-01 01:23:18.000000', 'temperatura', 1127.0000, 'ºC'),
	(133015, 110, '2015-04-01 01:23:19.000000', 'temperatura', 1076.0000, 'ºC'),
	(133016, 110, '2015-04-01 01:23:20.000000', 'temperatura', 797.0000, 'ºC'),
	(133017, 110, '2015-04-01 01:23:21.000000', 'temperatura', 757.0000, 'ºC'),
	(133018, 110, '2015-04-01 01:23:22.000000', 'temperatura', 194.0000, 'ºC'),
	(133019, 110, '2015-04-01 01:23:23.000000', 'temperatura', 1102.0000, 'ºC'),
	(133020, 110, '2015-04-01 01:23:24.000000', 'temperatura', 128.0000, 'ºC'),
	(133021, 110, '2015-04-01 01:23:25.000000', 'temperatura', 932.0000, 'ºC'),
	(133022, 110, '2015-04-01 01:23:26.000000', 'temperatura', 678.0000, 'ºC'),
	(133023, 110, '2015-04-01 01:23:27.000000', 'temperatura', 594.0000, 'ºC'),
	(133024, 110, '2015-04-01 01:23:28.000000', 'temperatura', 935.0000, 'ºC'),
	(133025, 110, '2015-04-01 01:23:29.000000', 'temperatura', 496.0000, 'ºC'),
	(133026, 110, '2015-04-01 01:23:30.000000', 'temperatura', 873.0000, 'ºC'),
	(133027, 110, '2015-04-01 01:23:31.000000', 'temperatura', 478.0000, 'ºC'),
	(133028, 110, '2015-04-01 01:23:32.000000', 'temperatura', 973.0000, 'ºC'),
	(133029, 110, '2015-04-01 01:23:33.000000', 'temperatura', 1032.0000, 'ºC'),
	(133030, 110, '2015-04-01 01:23:34.000000', 'temperatura', 1042.0000, 'ºC'),
	(133031, 110, '2015-04-01 01:23:35.000000', 'temperatura', 912.0000, 'ºC'),
	(133032, 110, '2015-04-01 01:23:36.000000', 'temperatura', 237.0000, 'ºC'),
	(133033, 110, '2015-04-01 01:23:37.000000', 'temperatura', 847.0000, 'ºC'),
	(133034, 110, '2015-04-01 01:23:38.000000', 'temperatura', 1127.0000, 'ºC'),
	(133035, 110, '2015-04-01 01:23:39.000000', 'temperatura', 694.0000, 'ºC'),
	(133036, 110, '2015-04-01 01:23:40.000000', 'temperatura', 87.0000, 'ºC'),
	(133037, 110, '2015-04-01 01:23:41.000000', 'temperatura', 755.0000, 'ºC'),
	(133038, 110, '2015-04-01 01:23:42.000000', 'temperatura', 1114.0000, 'ºC'),
	(133039, 110, '2015-04-01 01:23:43.000000', 'temperatura', 908.0000, 'ºC'),
	(133040, 110, '2015-04-01 01:23:44.000000', 'temperatura', 1195.0000, 'ºC'),
	(133041, 110, '2015-04-01 01:23:45.000000', 'temperatura', 854.0000, 'ºC'),
	(133042, 110, '2015-04-01 01:23:46.000000', 'temperatura', 685.0000, 'ºC'),
	(133043, 110, '2015-04-01 01:23:47.000000', 'temperatura', 862.0000, 'ºC'),
	(133044, 110, '2015-04-01 01:23:48.000000', 'temperatura', 1055.0000, 'ºC'),
	(133045, 110, '2015-04-01 01:23:49.000000', 'temperatura', 289.0000, 'ºC'),
	(133046, 110, '2015-04-01 01:23:50.000000', 'temperatura', 681.0000, 'ºC'),
	(133047, 110, '2015-04-01 01:23:51.000000', 'temperatura', 139.0000, 'ºC'),
	(133048, 110, '2015-04-01 01:23:52.000000', 'temperatura', 1051.0000, 'ºC'),
	(133049, 110, '2015-04-01 01:23:53.000000', 'temperatura', 42.0000, 'ºC'),
	(133050, 110, '2015-04-01 01:23:54.000000', 'temperatura', 654.0000, 'ºC'),
	(133051, 110, '2015-04-01 01:23:55.000000', 'temperatura', 744.0000, 'ºC'),
	(133052, 110, '2015-04-01 01:23:56.000000', 'temperatura', 561.0000, 'ºC'),
	(133053, 110, '2015-04-01 01:23:57.000000', 'temperatura', 571.0000, 'ºC'),
	(133054, 110, '2015-04-01 01:23:58.000000', 'temperatura', 1173.0000, 'ºC'),
	(133055, 110, '2015-04-01 01:23:59.000000', 'temperatura', 554.0000, 'ºC'),
	(133056, 110, '2015-04-01 01:24:00.000000', 'temperatura', 452.0000, 'ºC'),
	(133057, 110, '2015-04-01 01:24:01.000000', 'temperatura', 598.0000, 'ºC'),
	(133058, 110, '2015-04-01 01:24:02.000000', 'temperatura', 433.0000, 'ºC'),
	(133059, 110, '2015-04-01 01:24:03.000000', 'temperatura', 374.0000, 'ºC'),
	(133060, 110, '2015-04-01 01:24:04.000000', 'temperatura', 571.0000, 'ºC'),
	(133061, 110, '2015-04-01 01:24:05.000000', 'temperatura', 534.0000, 'ºC'),
	(133062, 110, '2015-04-01 01:24:06.000000', 'temperatura', 957.0000, 'ºC'),
	(133063, 110, '2015-04-01 01:24:07.000000', 'temperatura', 784.0000, 'ºC'),
	(133064, 110, '2015-04-01 01:24:08.000000', 'temperatura', 1047.0000, 'ºC'),
	(133065, 110, '2015-04-01 01:24:09.000000', 'temperatura', 486.0000, 'ºC'),
	(133066, 110, '2015-04-01 01:24:10.000000', 'temperatura', 487.0000, 'ºC'),
	(133067, 110, '2015-04-01 01:24:11.000000', 'temperatura', 980.0000, 'ºC'),
	(133068, 110, '2015-04-01 01:24:12.000000', 'temperatura', 1039.0000, 'ºC'),
	(133069, 110, '2015-04-01 01:24:13.000000', 'temperatura', 1053.0000, 'ºC'),
	(133070, 110, '2015-04-01 01:24:14.000000', 'temperatura', 951.0000, 'ºC'),
	(133071, 110, '2015-04-01 01:24:15.000000', 'temperatura', 396.0000, 'ºC'),
	(133072, 110, '2015-04-01 01:24:16.000000', 'temperatura', 329.0000, 'ºC'),
	(133073, 110, '2015-04-01 01:24:17.000000', 'temperatura', 457.0000, 'ºC'),
	(133074, 110, '2015-04-01 01:24:18.000000', 'temperatura', 98.0000, 'ºC'),
	(133075, 110, '2015-04-01 01:24:19.000000', 'temperatura', 321.0000, 'ºC'),
	(133076, 110, '2015-04-01 01:24:20.000000', 'temperatura', 109.0000, 'ºC'),
	(133077, 110, '2015-04-01 01:24:21.000000', 'temperatura', 783.0000, 'ºC'),
	(133078, 110, '2015-04-01 01:24:22.000000', 'temperatura', 1190.0000, 'ºC'),
	(133079, 110, '2015-04-01 01:24:23.000000', 'temperatura', 2.0000, 'ºC'),
	(133080, 110, '2015-04-01 01:24:24.000000', 'temperatura', 38.0000, 'ºC'),
	(133081, 110, '2015-04-01 01:24:25.000000', 'temperatura', 184.0000, 'ºC'),
	(133082, 110, '2015-04-01 01:24:26.000000', 'temperatura', 807.0000, 'ºC'),
	(133083, 110, '2015-04-01 01:24:27.000000', 'temperatura', 1084.0000, 'ºC'),
	(133084, 110, '2015-04-01 01:24:28.000000', 'temperatura', 600.0000, 'ºC'),
	(133085, 110, '2015-04-01 01:24:29.000000', 'temperatura', 949.0000, 'ºC'),
	(133086, 110, '2015-04-01 01:24:30.000000', 'temperatura', 546.0000, 'ºC'),
	(133087, 110, '2015-04-01 01:24:31.000000', 'temperatura', 1083.0000, 'ºC'),
	(133088, 110, '2015-04-01 01:24:32.000000', 'temperatura', 177.0000, 'ºC'),
	(133089, 110, '2015-04-01 01:24:33.000000', 'temperatura', 38.0000, 'ºC'),
	(133090, 110, '2015-04-01 01:24:34.000000', 'temperatura', 857.0000, 'ºC'),
	(133091, 110, '2015-04-01 01:24:35.000000', 'temperatura', 572.0000, 'ºC'),
	(133092, 110, '2015-04-01 01:24:36.000000', 'temperatura', 290.0000, 'ºC'),
	(133093, 110, '2015-04-01 01:24:37.000000', 'temperatura', 932.0000, 'ºC'),
	(133094, 110, '2015-04-01 01:24:38.000000', 'temperatura', 194.0000, 'ºC'),
	(133095, 110, '2015-04-01 01:24:39.000000', 'temperatura', 573.0000, 'ºC'),
	(133096, 110, '2015-04-01 01:24:40.000000', 'temperatura', 1085.0000, 'ºC'),
	(133097, 110, '2015-04-01 01:24:41.000000', 'temperatura', 104.0000, 'ºC'),
	(133098, 110, '2015-04-01 01:24:42.000000', 'temperatura', 866.0000, 'ºC'),
	(133099, 110, '2015-04-01 01:24:43.000000', 'temperatura', 421.0000, 'ºC'),
	(133100, 110, '2015-04-01 01:24:44.000000', 'temperatura', 706.0000, 'ºC'),
	(133101, 110, '2015-04-01 01:24:45.000000', 'temperatura', 1065.0000, 'ºC'),
	(133102, 110, '2015-04-01 01:24:46.000000', 'temperatura', 811.0000, 'ºC'),
	(133103, 110, '2015-04-01 01:24:47.000000', 'temperatura', 861.0000, 'ºC'),
	(133104, 110, '2015-04-01 01:24:48.000000', 'temperatura', 671.0000, 'ºC'),
	(133105, 110, '2015-04-01 01:24:49.000000', 'temperatura', 773.0000, 'ºC'),
	(133106, 110, '2015-04-01 01:24:50.000000', 'temperatura', 654.0000, 'ºC'),
	(133107, 110, '2015-04-01 01:24:51.000000', 'temperatura', 949.0000, 'ºC'),
	(133108, 110, '2015-04-01 01:24:52.000000', 'temperatura', 385.0000, 'ºC'),
	(133109, 110, '2015-04-01 01:24:53.000000', 'temperatura', 278.0000, 'ºC'),
	(133110, 110, '2015-04-01 01:24:54.000000', 'temperatura', 235.0000, 'ºC'),
	(133111, 110, '2015-04-01 01:24:55.000000', 'temperatura', 340.0000, 'ºC'),
	(133112, 110, '2015-04-01 01:24:56.000000', 'temperatura', 998.0000, 'ºC'),
	(133113, 110, '2015-04-01 01:24:57.000000', 'temperatura', 371.0000, 'ºC'),
	(133114, 110, '2015-04-01 01:24:58.000000', 'temperatura', 59.0000, 'ºC'),
	(133115, 110, '2015-04-01 01:24:59.000000', 'temperatura', 383.0000, 'ºC'),
	(133116, 110, '2015-04-01 01:25:00.000000', 'temperatura', 538.0000, 'ºC'),
	(133117, 110, '2015-04-01 01:25:01.000000', 'temperatura', 341.0000, 'ºC'),
	(133118, 110, '2015-04-01 01:25:02.000000', 'temperatura', 92.0000, 'ºC'),
	(133119, 110, '2015-04-01 01:25:03.000000', 'temperatura', 636.0000, 'ºC'),
	(133120, 110, '2015-04-01 01:25:04.000000', 'temperatura', 505.0000, 'ºC'),
	(133121, 110, '2015-04-01 01:25:05.000000', 'temperatura', 619.0000, 'ºC'),
	(133122, 110, '2015-04-01 01:25:06.000000', 'temperatura', 380.0000, 'ºC'),
	(133123, 110, '2015-04-01 01:25:07.000000', 'temperatura', 43.0000, 'ºC'),
	(133124, 110, '2015-04-01 01:25:08.000000', 'temperatura', 275.0000, 'ºC'),
	(133125, 110, '2015-04-01 01:25:09.000000', 'temperatura', 49.0000, 'ºC'),
	(133126, 110, '2015-04-01 01:25:10.000000', 'temperatura', 619.0000, 'ºC'),
	(133127, 110, '2015-04-01 01:25:11.000000', 'temperatura', 548.0000, 'ºC'),
	(133128, 110, '2015-04-01 01:25:12.000000', 'temperatura', 884.0000, 'ºC'),
	(133129, 110, '2015-04-01 01:25:13.000000', 'temperatura', 377.0000, 'ºC'),
	(133130, 110, '2015-04-01 01:25:14.000000', 'temperatura', 435.0000, 'ºC'),
	(133131, 110, '2015-04-01 01:25:15.000000', 'temperatura', 1044.0000, 'ºC'),
	(133132, 110, '2015-04-01 01:25:16.000000', 'temperatura', 313.0000, 'ºC'),
	(133133, 110, '2015-04-01 01:25:17.000000', 'temperatura', 834.0000, 'ºC'),
	(133134, 110, '2015-04-01 01:25:18.000000', 'temperatura', 832.0000, 'ºC'),
	(133135, 110, '2015-04-01 01:25:19.000000', 'temperatura', 460.0000, 'ºC'),
	(133136, 110, '2015-04-01 01:25:20.000000', 'temperatura', 1002.0000, 'ºC'),
	(133137, 110, '2015-04-01 01:25:21.000000', 'temperatura', 30.0000, 'ºC'),
	(133138, 110, '2015-04-01 01:25:22.000000', 'temperatura', 745.0000, 'ºC'),
	(133139, 110, '2015-04-01 01:25:23.000000', 'temperatura', 37.0000, 'ºC'),
	(133140, 110, '2015-04-01 01:25:24.000000', 'temperatura', 348.0000, 'ºC'),
	(133141, 110, '2015-04-01 01:25:25.000000', 'temperatura', 432.0000, 'ºC'),
	(133142, 110, '2015-04-01 01:25:26.000000', 'temperatura', 1115.0000, 'ºC'),
	(133143, 110, '2015-04-01 01:25:27.000000', 'temperatura', 679.0000, 'ºC'),
	(133144, 110, '2015-04-01 01:25:28.000000', 'temperatura', 52.0000, 'ºC'),
	(133145, 110, '2015-04-01 01:25:29.000000', 'temperatura', 622.0000, 'ºC'),
	(133146, 110, '2015-04-01 01:25:30.000000', 'temperatura', 553.0000, 'ºC'),
	(133147, 110, '2015-04-01 01:25:31.000000', 'temperatura', 903.0000, 'ºC'),
	(133148, 110, '2015-04-01 01:25:32.000000', 'temperatura', 453.0000, 'ºC'),
	(133149, 110, '2015-04-01 01:25:33.000000', 'temperatura', 758.0000, 'ºC'),
	(133150, 110, '2015-04-01 01:25:34.000000', 'temperatura', 32.0000, 'ºC'),
	(133151, 110, '2015-04-01 01:25:35.000000', 'temperatura', 286.0000, 'ºC'),
	(133152, 110, '2015-04-01 01:25:36.000000', 'temperatura', 136.0000, 'ºC'),
	(133153, 110, '2015-04-01 01:25:37.000000', 'temperatura', 1021.0000, 'ºC'),
	(133154, 110, '2015-04-01 01:25:38.000000', 'temperatura', 1098.0000, 'ºC'),
	(133155, 110, '2015-04-01 01:25:39.000000', 'temperatura', 27.0000, 'ºC'),
	(133156, 110, '2015-04-01 01:25:40.000000', 'temperatura', 444.0000, 'ºC'),
	(133157, 110, '2015-04-01 01:25:41.000000', 'temperatura', 937.0000, 'ºC'),
	(133158, 110, '2015-04-01 01:25:42.000000', 'temperatura', 956.0000, 'ºC'),
	(133159, 110, '2015-04-01 01:25:43.000000', 'temperatura', 766.0000, 'ºC'),
	(133160, 110, '2015-04-01 01:25:44.000000', 'temperatura', 966.0000, 'ºC'),
	(133161, 110, '2015-04-01 01:25:45.000000', 'temperatura', 129.0000, 'ºC'),
	(133162, 110, '2015-04-01 01:25:46.000000', 'temperatura', 150.0000, 'ºC'),
	(133163, 110, '2015-04-01 01:25:47.000000', 'temperatura', 364.0000, 'ºC'),
	(133164, 110, '2015-04-01 01:25:48.000000', 'temperatura', 169.0000, 'ºC'),
	(133165, 110, '2015-04-01 01:25:49.000000', 'temperatura', 952.0000, 'ºC'),
	(133166, 110, '2015-04-01 01:25:50.000000', 'temperatura', 657.0000, 'ºC'),
	(133167, 110, '2015-04-01 01:25:51.000000', 'temperatura', 426.0000, 'ºC'),
	(133168, 110, '2015-04-01 01:25:52.000000', 'temperatura', 161.0000, 'ºC'),
	(133169, 110, '2015-04-01 01:25:53.000000', 'temperatura', 729.0000, 'ºC'),
	(133170, 110, '2015-04-01 01:25:54.000000', 'temperatura', 760.0000, 'ºC'),
	(133171, 110, '2015-04-01 01:25:55.000000', 'temperatura', 416.0000, 'ºC'),
	(133172, 110, '2015-04-01 01:25:56.000000', 'temperatura', 999.0000, 'ºC'),
	(133173, 110, '2015-04-01 01:25:57.000000', 'temperatura', 150.0000, 'ºC'),
	(133174, 110, '2015-04-01 01:25:58.000000', 'temperatura', 151.0000, 'ºC'),
	(133175, 110, '2015-04-01 01:25:59.000000', 'temperatura', 305.0000, 'ºC'),
	(133176, 110, '2015-04-01 01:26:00.000000', 'temperatura', 1072.0000, 'ºC'),
	(133177, 110, '2015-04-01 01:26:01.000000', 'temperatura', 848.0000, 'ºC'),
	(133178, 110, '2015-04-01 01:26:02.000000', 'temperatura', 1023.0000, 'ºC'),
	(133179, 110, '2015-04-01 01:26:03.000000', 'temperatura', 173.0000, 'ºC'),
	(133180, 110, '2015-04-01 01:26:04.000000', 'temperatura', 197.0000, 'ºC'),
	(133181, 110, '2015-04-01 01:26:05.000000', 'temperatura', 465.0000, 'ºC'),
	(133182, 110, '2015-04-01 01:26:06.000000', 'temperatura', 534.0000, 'ºC'),
	(133183, 110, '2015-04-01 01:26:07.000000', 'temperatura', 76.0000, 'ºC'),
	(133184, 110, '2015-04-01 01:26:08.000000', 'temperatura', 1179.0000, 'ºC'),
	(133185, 110, '2015-04-01 01:26:09.000000', 'temperatura', 869.0000, 'ºC'),
	(133186, 110, '2015-04-01 01:26:10.000000', 'temperatura', 806.0000, 'ºC'),
	(133187, 110, '2015-04-01 01:26:11.000000', 'temperatura', 226.0000, 'ºC'),
	(133188, 110, '2015-04-01 01:26:12.000000', 'temperatura', 1111.0000, 'ºC'),
	(133189, 110, '2015-04-01 01:26:13.000000', 'temperatura', 78.0000, 'ºC'),
	(133190, 110, '2015-04-01 01:26:14.000000', 'temperatura', 658.0000, 'ºC'),
	(133191, 110, '2015-04-01 01:26:15.000000', 'temperatura', 658.0000, 'ºC'),
	(133192, 110, '2015-04-01 01:26:16.000000', 'temperatura', 115.0000, 'ºC'),
	(133193, 110, '2015-04-01 01:26:17.000000', 'temperatura', 1000.0000, 'ºC'),
	(133194, 110, '2015-04-01 01:26:18.000000', 'temperatura', 1058.0000, 'ºC'),
	(133195, 110, '2015-04-01 01:26:19.000000', 'temperatura', 1088.0000, 'ºC'),
	(133196, 110, '2015-04-01 01:26:20.000000', 'temperatura', 1067.0000, 'ºC'),
	(133197, 110, '2015-04-01 01:26:21.000000', 'temperatura', 871.0000, 'ºC'),
	(133198, 110, '2015-04-01 01:26:22.000000', 'temperatura', 1153.0000, 'ºC'),
	(133199, 110, '2015-04-01 01:26:23.000000', 'temperatura', 756.0000, 'ºC'),
	(133200, 110, '2015-04-01 01:26:24.000000', 'temperatura', 318.0000, 'ºC'),
	(133201, 110, '2015-04-01 01:26:25.000000', 'temperatura', 526.0000, 'ºC'),
	(133202, 110, '2015-04-01 01:26:26.000000', 'temperatura', 475.0000, 'ºC'),
	(133203, 110, '2015-04-01 01:26:27.000000', 'temperatura', 799.0000, 'ºC'),
	(133204, 110, '2015-04-01 01:26:28.000000', 'temperatura', 170.0000, 'ºC'),
	(133205, 110, '2015-04-01 01:26:29.000000', 'temperatura', 854.0000, 'ºC'),
	(133206, 110, '2015-04-01 01:26:30.000000', 'temperatura', 162.0000, 'ºC'),
	(133207, 110, '2015-04-01 01:26:31.000000', 'temperatura', 646.0000, 'ºC'),
	(133208, 110, '2015-04-01 01:26:32.000000', 'temperatura', 345.0000, 'ºC'),
	(133209, 110, '2015-04-01 01:26:33.000000', 'temperatura', 989.0000, 'ºC'),
	(133210, 110, '2015-04-01 01:26:34.000000', 'temperatura', 308.0000, 'ºC'),
	(133211, 110, '2015-04-01 01:26:35.000000', 'temperatura', 973.0000, 'ºC'),
	(133212, 110, '2015-04-01 01:26:36.000000', 'temperatura', 341.0000, 'ºC'),
	(133213, 110, '2015-04-01 01:26:37.000000', 'temperatura', 1188.0000, 'ºC'),
	(133214, 110, '2015-04-01 01:26:38.000000', 'temperatura', 117.0000, 'ºC'),
	(133215, 110, '2015-04-01 01:26:39.000000', 'temperatura', 622.0000, 'ºC'),
	(133216, 110, '2015-04-01 01:26:40.000000', 'temperatura', 360.0000, 'ºC'),
	(133217, 110, '2015-04-01 01:26:41.000000', 'temperatura', 1133.0000, 'ºC'),
	(133218, 110, '2015-04-01 01:26:42.000000', 'temperatura', 988.0000, 'ºC'),
	(133219, 110, '2015-04-01 01:26:43.000000', 'temperatura', 339.0000, 'ºC'),
	(133220, 110, '2015-04-01 01:26:44.000000', 'temperatura', 1134.0000, 'ºC'),
	(133221, 110, '2015-04-01 01:26:45.000000', 'temperatura', 1053.0000, 'ºC'),
	(133222, 110, '2015-04-01 01:26:46.000000', 'temperatura', 661.0000, 'ºC'),
	(133223, 110, '2015-04-01 01:26:47.000000', 'temperatura', 148.0000, 'ºC'),
	(133224, 110, '2015-04-01 01:26:48.000000', 'temperatura', 1158.0000, 'ºC'),
	(133225, 110, '2015-04-01 01:26:49.000000', 'temperatura', 545.0000, 'ºC'),
	(133226, 110, '2015-04-01 01:26:50.000000', 'temperatura', 454.0000, 'ºC'),
	(133227, 110, '2015-04-01 01:26:51.000000', 'temperatura', 633.0000, 'ºC'),
	(133228, 110, '2015-04-01 01:26:52.000000', 'temperatura', 605.0000, 'ºC'),
	(133229, 110, '2015-04-01 01:26:53.000000', 'temperatura', 1127.0000, 'ºC'),
	(133230, 110, '2015-04-01 01:26:54.000000', 'temperatura', 220.0000, 'ºC'),
	(133231, 110, '2015-04-01 01:26:55.000000', 'temperatura', 121.0000, 'ºC'),
	(133232, 110, '2015-04-01 01:26:56.000000', 'temperatura', 1145.0000, 'ºC'),
	(133233, 110, '2015-04-01 01:26:57.000000', 'temperatura', 564.0000, 'ºC'),
	(133234, 110, '2015-04-01 01:26:58.000000', 'temperatura', 584.0000, 'ºC'),
	(133235, 110, '2015-04-01 01:26:59.000000', 'temperatura', 29.0000, 'ºC'),
	(133236, 110, '2015-04-01 01:27:00.000000', 'temperatura', 792.0000, 'ºC'),
	(133237, 110, '2015-04-01 01:27:01.000000', 'temperatura', 276.0000, 'ºC'),
	(133238, 110, '2015-04-01 01:27:02.000000', 'temperatura', 204.0000, 'ºC'),
	(133239, 110, '2015-04-01 01:27:03.000000', 'temperatura', 193.0000, 'ºC'),
	(133240, 110, '2015-04-01 01:27:04.000000', 'temperatura', 353.0000, 'ºC'),
	(133241, 110, '2015-04-01 01:27:05.000000', 'temperatura', 1188.0000, 'ºC'),
	(133242, 110, '2015-04-01 01:27:06.000000', 'temperatura', 81.0000, 'ºC'),
	(133243, 110, '2015-04-01 01:27:07.000000', 'temperatura', 442.0000, 'ºC'),
	(133244, 110, '2015-04-01 01:27:08.000000', 'temperatura', 766.0000, 'ºC'),
	(133245, 110, '2015-04-01 01:27:09.000000', 'temperatura', 104.0000, 'ºC'),
	(133246, 110, '2015-04-01 01:27:10.000000', 'temperatura', 624.0000, 'ºC'),
	(133247, 110, '2015-04-01 01:27:11.000000', 'temperatura', 407.0000, 'ºC'),
	(133248, 110, '2015-04-01 01:27:12.000000', 'temperatura', 165.0000, 'ºC'),
	(133249, 110, '2015-04-01 01:27:13.000000', 'temperatura', 803.0000, 'ºC'),
	(133250, 110, '2015-04-01 01:27:14.000000', 'temperatura', 1123.0000, 'ºC'),
	(133251, 110, '2015-04-01 01:27:15.000000', 'temperatura', 803.0000, 'ºC'),
	(133252, 110, '2015-04-01 01:27:16.000000', 'temperatura', 649.0000, 'ºC'),
	(133253, 110, '2015-04-01 01:27:17.000000', 'temperatura', 836.0000, 'ºC'),
	(133254, 110, '2015-04-01 01:27:18.000000', 'temperatura', 1032.0000, 'ºC'),
	(133255, 110, '2015-04-01 01:27:19.000000', 'temperatura', 252.0000, 'ºC'),
	(133256, 110, '2015-04-01 01:27:20.000000', 'temperatura', 564.0000, 'ºC'),
	(133257, 110, '2015-04-01 01:27:21.000000', 'temperatura', 865.0000, 'ºC'),
	(133258, 110, '2015-04-01 01:27:22.000000', 'temperatura', 235.0000, 'ºC'),
	(133259, 110, '2015-04-01 01:27:23.000000', 'temperatura', 978.0000, 'ºC'),
	(133260, 110, '2015-04-01 01:27:24.000000', 'temperatura', 587.0000, 'ºC'),
	(133261, 110, '2015-04-01 01:27:25.000000', 'temperatura', 2.0000, 'ºC'),
	(133262, 110, '2015-04-01 01:27:26.000000', 'temperatura', 647.0000, 'ºC'),
	(133263, 110, '2015-04-01 01:27:27.000000', 'temperatura', 831.0000, 'ºC'),
	(133264, 110, '2015-04-01 01:27:28.000000', 'temperatura', 1016.0000, 'ºC'),
	(133265, 110, '2015-04-01 01:27:29.000000', 'temperatura', 184.0000, 'ºC'),
	(133266, 110, '2015-04-01 01:27:30.000000', 'temperatura', 276.0000, 'ºC'),
	(133267, 110, '2015-04-01 01:27:31.000000', 'temperatura', 827.0000, 'ºC'),
	(133268, 110, '2015-04-01 01:27:32.000000', 'temperatura', 906.0000, 'ºC'),
	(133269, 110, '2015-04-01 01:27:33.000000', 'temperatura', 851.0000, 'ºC'),
	(133270, 110, '2015-04-01 01:27:34.000000', 'temperatura', 336.0000, 'ºC'),
	(133271, 110, '2015-04-01 01:27:35.000000', 'temperatura', 327.0000, 'ºC'),
	(133272, 110, '2015-04-01 01:27:36.000000', 'temperatura', 629.0000, 'ºC'),
	(133273, 110, '2015-04-01 01:27:37.000000', 'temperatura', 964.0000, 'ºC'),
	(133274, 110, '2015-04-01 01:27:38.000000', 'temperatura', 533.0000, 'ºC'),
	(133275, 110, '2015-04-01 01:27:39.000000', 'temperatura', 972.0000, 'ºC'),
	(133276, 110, '2015-04-01 01:27:40.000000', 'temperatura', 864.0000, 'ºC'),
	(133277, 110, '2015-04-01 01:27:41.000000', 'temperatura', 204.0000, 'ºC'),
	(133278, 110, '2015-04-01 01:27:42.000000', 'temperatura', 828.0000, 'ºC'),
	(133279, 110, '2015-04-01 01:27:43.000000', 'temperatura', 1130.0000, 'ºC'),
	(133280, 110, '2015-04-01 01:27:44.000000', 'temperatura', 767.0000, 'ºC'),
	(133281, 110, '2015-04-01 01:27:45.000000', 'temperatura', 443.0000, 'ºC'),
	(133282, 110, '2015-04-01 01:27:46.000000', 'temperatura', 1116.0000, 'ºC'),
	(133283, 110, '2015-04-01 01:27:47.000000', 'temperatura', 652.0000, 'ºC'),
	(133284, 110, '2015-04-01 01:27:48.000000', 'temperatura', 1112.0000, 'ºC'),
	(133285, 110, '2015-04-01 01:27:49.000000', 'temperatura', 4.0000, 'ºC'),
	(133286, 110, '2015-04-01 01:27:50.000000', 'temperatura', 284.0000, 'ºC'),
	(133287, 110, '2015-04-01 01:27:51.000000', 'temperatura', 207.0000, 'ºC'),
	(133288, 110, '2015-04-01 01:27:52.000000', 'temperatura', 187.0000, 'ºC'),
	(133289, 110, '2015-04-01 01:27:53.000000', 'temperatura', 313.0000, 'ºC'),
	(133290, 110, '2015-04-01 01:27:54.000000', 'temperatura', 1004.0000, 'ºC'),
	(133291, 110, '2015-04-01 01:27:55.000000', 'temperatura', 482.0000, 'ºC'),
	(133292, 110, '2015-04-01 01:27:56.000000', 'temperatura', 598.0000, 'ºC'),
	(133293, 110, '2015-04-01 01:27:57.000000', 'temperatura', 345.0000, 'ºC'),
	(133294, 110, '2015-04-01 01:27:58.000000', 'temperatura', 1131.0000, 'ºC'),
	(133295, 110, '2015-04-01 01:27:59.000000', 'temperatura', 1022.0000, 'ºC'),
	(133296, 110, '2015-04-01 01:28:00.000000', 'temperatura', 517.0000, 'ºC'),
	(133297, 110, '2015-04-01 01:28:01.000000', 'temperatura', 721.0000, 'ºC'),
	(133298, 110, '2015-04-01 01:28:02.000000', 'temperatura', 854.0000, 'ºC'),
	(133299, 110, '2015-04-01 01:28:03.000000', 'temperatura', 908.0000, 'ºC'),
	(133300, 110, '2015-04-01 01:28:04.000000', 'temperatura', 776.0000, 'ºC'),
	(133301, 110, '2015-04-01 01:28:05.000000', 'temperatura', 1159.0000, 'ºC'),
	(133302, 110, '2015-04-01 01:28:06.000000', 'temperatura', 1069.0000, 'ºC'),
	(133303, 110, '2015-04-01 01:28:07.000000', 'temperatura', 666.0000, 'ºC'),
	(133304, 110, '2015-04-01 01:28:08.000000', 'temperatura', 124.0000, 'ºC'),
	(133305, 110, '2015-04-01 01:28:09.000000', 'temperatura', 1021.0000, 'ºC'),
	(133306, 110, '2015-04-01 01:28:10.000000', 'temperatura', 1134.0000, 'ºC'),
	(133307, 110, '2015-04-01 01:28:11.000000', 'temperatura', 207.0000, 'ºC'),
	(133308, 110, '2015-04-01 01:28:12.000000', 'temperatura', 34.0000, 'ºC'),
	(133309, 110, '2015-04-01 01:28:13.000000', 'temperatura', 748.0000, 'ºC'),
	(133310, 110, '2015-04-01 01:28:14.000000', 'temperatura', 39.0000, 'ºC'),
	(133311, 110, '2015-04-01 01:28:15.000000', 'temperatura', 352.0000, 'ºC'),
	(133312, 110, '2015-04-01 01:28:16.000000', 'temperatura', 443.0000, 'ºC'),
	(133313, 110, '2015-04-01 01:28:17.000000', 'temperatura', 1161.0000, 'ºC'),
	(133314, 110, '2015-04-01 01:28:18.000000', 'temperatura', 874.0000, 'ºC'),
	(133315, 110, '2015-04-01 01:28:19.000000', 'temperatura', 890.0000, 'ºC'),
	(133316, 110, '2015-04-01 01:28:20.000000', 'temperatura', 628.0000, 'ºC'),
	(133317, 110, '2015-04-01 01:28:21.000000', 'temperatura', 470.0000, 'ºC'),
	(133318, 110, '2015-04-01 01:28:22.000000', 'temperatura', 468.0000, 'ºC'),
	(133319, 110, '2015-04-01 01:28:23.000000', 'temperatura', 931.0000, 'ºC'),
	(133320, 110, '2015-04-01 01:28:24.000000', 'temperatura', 851.0000, 'ºC'),
	(133321, 110, '2015-04-01 01:28:25.000000', 'temperatura', 261.0000, 'ºC'),
	(133322, 110, '2015-04-01 01:28:26.000000', 'temperatura', 1155.0000, 'ºC'),
	(133323, 110, '2015-04-01 01:28:27.000000', 'temperatura', 193.0000, 'ºC'),
	(133324, 110, '2015-04-01 01:28:28.000000', 'temperatura', 1098.0000, 'ºC'),
	(133325, 110, '2015-04-01 01:28:29.000000', 'temperatura', 114.0000, 'ºC'),
	(133326, 110, '2015-04-01 01:28:30.000000', 'temperatura', 874.0000, 'ºC'),
	(133327, 110, '2015-04-01 01:28:31.000000', 'temperatura', 428.0000, 'ºC'),
	(133328, 110, '2015-04-01 01:28:32.000000', 'temperatura', 720.0000, 'ºC'),
	(133329, 110, '2015-04-01 01:28:33.000000', 'temperatura', 1117.0000, 'ºC'),
	(133330, 110, '2015-04-01 01:28:34.000000', 'temperatura', 1023.0000, 'ºC'),
	(133331, 110, '2015-04-01 01:28:35.000000', 'temperatura', 568.0000, 'ºC'),
	(133332, 110, '2015-04-01 01:28:36.000000', 'temperatura', 970.0000, 'ºC'),
	(133333, 110, '2015-04-01 01:28:37.000000', 'temperatura', 746.0000, 'ºC'),
	(133334, 110, '2015-04-01 01:28:38.000000', 'temperatura', 820.0000, 'ºC'),
	(133335, 110, '2015-04-01 01:28:39.000000', 'temperatura', 664.0000, 'ºC'),
	(133336, 110, '2015-04-01 01:28:40.000000', 'temperatura', 860.0000, 'ºC'),
	(133337, 110, '2015-04-01 01:28:41.000000', 'temperatura', 1110.0000, 'ºC'),
	(133338, 110, '2015-04-01 01:28:42.000000', 'temperatura', 571.0000, 'ºC'),
	(133339, 110, '2015-04-01 01:28:43.000000', 'temperatura', 722.0000, 'ºC'),
	(133340, 110, '2015-04-01 01:28:44.000000', 'temperatura', 701.0000, 'ºC'),
	(133341, 110, '2015-04-01 01:28:45.000000', 'temperatura', 138.0000, 'ºC'),
	(133342, 110, '2015-04-01 01:28:46.000000', 'temperatura', 986.0000, 'ºC'),
	(133343, 110, '2015-04-01 01:28:47.000000', 'temperatura', 916.0000, 'ºC'),
	(133344, 110, '2015-04-01 01:28:48.000000', 'temperatura', 424.0000, 'ºC'),
	(133345, 110, '2015-04-01 01:28:49.000000', 'temperatura', 572.0000, 'ºC'),
	(133346, 110, '2015-04-01 01:28:50.000000', 'temperatura', 388.0000, 'ºC'),
	(133347, 110, '2015-04-01 01:28:51.000000', 'temperatura', 224.0000, 'ºC'),
	(133348, 110, '2015-04-01 01:28:52.000000', 'temperatura', 1156.0000, 'ºC'),
	(133349, 110, '2015-04-01 01:28:53.000000', 'temperatura', 311.0000, 'ºC'),
	(133350, 110, '2015-04-01 01:28:54.000000', 'temperatura', 486.0000, 'ºC'),
	(133351, 110, '2015-04-01 01:28:55.000000', 'temperatura', 299.0000, 'ºC'),
	(133352, 110, '2015-04-01 01:28:56.000000', 'temperatura', 35.0000, 'ºC'),
	(133353, 110, '2015-04-01 01:28:57.000000', 'temperatura', 481.0000, 'ºC'),
	(133354, 110, '2015-04-01 01:28:58.000000', 'temperatura', 1100.0000, 'ºC'),
	(133355, 110, '2015-04-01 01:28:59.000000', 'temperatura', 457.0000, 'ºC'),
	(133356, 110, '2015-04-01 01:29:00.000000', 'temperatura', 186.0000, 'ºC'),
	(133357, 110, '2015-04-01 01:29:01.000000', 'temperatura', 759.0000, 'ºC'),
	(133358, 110, '2015-04-01 01:29:02.000000', 'temperatura', 838.0000, 'ºC'),
	(133359, 110, '2015-04-01 01:29:03.000000', 'temperatura', 714.0000, 'ºC'),
	(133360, 110, '2015-04-01 01:29:04.000000', 'temperatura', 1054.0000, 'ºC'),
	(133361, 110, '2015-04-01 01:29:05.000000', 'temperatura', 731.0000, 'ºC'),
	(133362, 110, '2015-04-01 01:29:06.000000', 'temperatura', 492.0000, 'ºC'),
	(133363, 110, '2015-04-01 01:29:07.000000', 'temperatura', 270.0000, 'ºC'),
	(133364, 110, '2015-04-01 01:29:08.000000', 'temperatura', 1072.0000, 'ºC'),
	(133365, 110, '2015-04-01 01:29:09.000000', 'temperatura', 951.0000, 'ºC'),
	(133366, 110, '2015-04-01 01:29:10.000000', 'temperatura', 339.0000, 'ºC'),
	(133367, 110, '2015-04-01 01:29:11.000000', 'temperatura', 42.0000, 'ºC'),
	(133368, 110, '2015-04-01 01:29:12.000000', 'temperatura', 394.0000, 'ºC'),
	(133369, 110, '2015-04-01 01:29:13.000000', 'temperatura', 646.0000, 'ºC'),
	(133370, 110, '2015-04-01 01:29:14.000000', 'temperatura', 847.0000, 'ºC'),
	(133371, 110, '2015-04-01 01:29:15.000000', 'temperatura', 1098.0000, 'ºC'),
	(133372, 110, '2015-04-01 01:29:16.000000', 'temperatura', 551.0000, 'ºC'),
	(133373, 110, '2015-04-01 01:29:17.000000', 'temperatura', 660.0000, 'ºC'),
	(133374, 110, '2015-04-01 01:29:18.000000', 'temperatura', 447.0000, 'ºC'),
	(133375, 110, '2015-04-01 01:29:19.000000', 'temperatura', 257.0000, 'ºC'),
	(133376, 110, '2015-04-01 01:29:20.000000', 'temperatura', 1143.0000, 'ºC'),
	(133377, 110, '2015-04-01 01:29:21.000000', 'temperatura', 146.0000, 'ºC'),
	(133378, 110, '2015-04-01 01:29:22.000000', 'temperatura', 903.0000, 'ºC'),
	(133379, 110, '2015-04-01 01:29:23.000000', 'temperatura', 475.0000, 'ºC'),
	(133380, 110, '2015-04-01 01:29:24.000000', 'temperatura', 869.0000, 'ºC'),
	(133381, 110, '2015-04-01 01:29:25.000000', 'temperatura', 519.0000, 'ºC'),
	(133382, 110, '2015-04-01 01:29:26.000000', 'temperatura', 1189.0000, 'ºC'),
	(133383, 110, '2015-04-01 01:29:27.000000', 'temperatura', 790.0000, 'ºC'),
	(133384, 110, '2015-04-01 01:29:28.000000', 'temperatura', 381.0000, 'ºC'),
	(133385, 110, '2015-04-01 01:29:29.000000', 'temperatura', 735.0000, 'ºC'),
	(133386, 110, '2015-04-01 01:29:30.000000', 'temperatura', 134.0000, 'ºC'),
	(133387, 110, '2015-04-01 01:29:31.000000', 'temperatura', 867.0000, 'ºC'),
	(133388, 110, '2015-04-01 01:29:32.000000', 'temperatura', 331.0000, 'ºC'),
	(133389, 110, '2015-04-01 01:29:33.000000', 'temperatura', 254.0000, 'ºC'),
	(133390, 110, '2015-04-01 01:29:34.000000', 'temperatura', 280.0000, 'ºC'),
	(133391, 110, '2015-04-01 01:29:35.000000', 'temperatura', 639.0000, 'ºC'),
	(133392, 110, '2015-04-01 01:29:36.000000', 'temperatura', 1155.0000, 'ºC'),
	(133393, 110, '2015-04-01 01:29:37.000000', 'temperatura', 260.0000, 'ºC'),
	(133394, 110, '2015-04-01 01:29:38.000000', 'temperatura', 234.0000, 'ºC'),
	(133395, 110, '2015-04-01 01:29:39.000000', 'temperatura', 392.0000, 'ºC'),
	(133396, 110, '2015-04-01 01:29:40.000000', 'temperatura', 56.0000, 'ºC'),
	(133397, 110, '2015-04-01 01:29:41.000000', 'temperatura', 305.0000, 'ºC'),
	(133398, 110, '2015-04-01 01:29:42.000000', 'temperatura', 158.0000, 'ºC'),
	(133399, 110, '2015-04-01 01:29:43.000000', 'temperatura', 1075.0000, 'ºC'),
	(133400, 110, '2015-04-01 01:29:44.000000', 'temperatura', 103.0000, 'ºC'),
	(133401, 110, '2015-04-01 01:29:45.000000', 'temperatura', 888.0000, 'ºC'),
	(133402, 110, '2015-04-01 01:29:46.000000', 'temperatura', 531.0000, 'ºC'),
	(133403, 110, '2015-04-01 01:29:47.000000', 'temperatura', 1195.0000, 'ºC'),
	(133404, 110, '2015-04-01 01:29:48.000000', 'temperatura', 779.0000, 'ºC'),
	(133405, 110, '2015-04-01 01:29:49.000000', 'temperatura', 312.0000, 'ºC'),
	(133406, 110, '2015-04-01 01:29:50.000000', 'temperatura', 424.0000, 'ºC'),
	(133407, 110, '2015-04-01 01:29:51.000000', 'temperatura', 1183.0000, 'ºC'),
	(133408, 110, '2015-04-01 01:29:52.000000', 'temperatura', 1043.0000, 'ºC'),
	(133409, 110, '2015-04-01 01:29:53.000000', 'temperatura', 467.0000, 'ºC'),
	(133410, 110, '2015-04-01 01:29:54.000000', 'temperatura', 406.0000, 'ºC'),
	(133411, 110, '2015-04-01 01:29:55.000000', 'temperatura', 628.0000, 'ºC'),
	(133412, 110, '2015-04-01 01:29:56.000000', 'temperatura', 725.0000, 'ºC'),
	(133413, 110, '2015-04-01 01:29:57.000000', 'temperatura', 540.0000, 'ºC'),
	(133414, 110, '2015-04-01 01:29:58.000000', 'temperatura', 526.0000, 'ºC'),
	(133415, 110, '2015-04-01 01:29:59.000000', 'temperatura', 1009.0000, 'ºC'),
	(133416, 110, '2015-04-01 01:30:00.000000', 'temperatura', 1068.0000, 'ºC'),
	(133417, 110, '2015-04-01 01:30:01.000000', 'temperatura', 1112.0000, 'ºC'),
	(133418, 110, '2015-04-01 01:30:02.000000', 'temperatura', 1160.0000, 'ºC'),
	(133419, 110, '2015-04-01 01:30:03.000000', 'temperatura', 63.0000, 'ºC'),
	(133420, 110, '2015-04-01 01:30:04.000000', 'temperatura', 434.0000, 'ºC'),
	(133421, 110, '2015-04-01 01:30:05.000000', 'temperatura', 781.0000, 'ºC'),
	(133422, 110, '2015-04-01 01:30:06.000000', 'temperatura', 205.0000, 'ºC'),
	(133423, 110, '2015-04-01 01:30:07.000000', 'temperatura', 1084.0000, 'ºC'),
	(133424, 110, '2015-04-01 01:30:08.000000', 'temperatura', 2.0000, 'ºC'),
	(133425, 110, '2015-04-01 01:30:09.000000', 'temperatura', 362.0000, 'ºC'),
	(133426, 110, '2015-04-01 01:30:10.000000', 'temperatura', 604.0000, 'ºC'),
	(133427, 110, '2015-04-01 01:30:11.000000', 'temperatura', 733.0000, 'ºC'),
	(133428, 110, '2015-04-01 01:30:12.000000', 'temperatura', 656.0000, 'ºC'),
	(133429, 110, '2015-04-01 01:30:13.000000', 'temperatura', 1081.0000, 'ºC'),
	(133430, 110, '2015-04-01 01:30:14.000000', 'temperatura', 1035.0000, 'ºC'),
	(133431, 110, '2015-04-01 01:30:15.000000', 'temperatura', 734.0000, 'ºC'),
	(133432, 110, '2015-04-01 01:30:16.000000', 'temperatura', 565.0000, 'ºC'),
	(133433, 110, '2015-04-01 01:30:17.000000', 'temperatura', 626.0000, 'ºC'),
	(133434, 110, '2015-04-01 01:30:18.000000', 'temperatura', 232.0000, 'ºC'),
	(133435, 110, '2015-04-01 01:30:19.000000', 'temperatura', 484.0000, 'ºC'),
	(133436, 110, '2015-04-01 01:30:20.000000', 'temperatura', 525.0000, 'ºC'),
	(133437, 110, '2015-04-01 01:30:21.000000', 'temperatura', 1175.0000, 'ºC'),
	(133438, 110, '2015-04-01 01:30:22.000000', 'temperatura', 698.0000, 'ºC'),
	(133439, 110, '2015-04-01 01:30:23.000000', 'temperatura', 1168.0000, 'ºC'),
	(133440, 110, '2015-04-01 01:30:24.000000', 'temperatura', 144.0000, 'ºC'),
	(133441, 110, '2015-04-01 01:30:25.000000', 'temperatura', 818.0000, 'ºC'),
	(133442, 110, '2015-04-01 01:30:26.000000', 'temperatura', 60.0000, 'ºC'),
	(133443, 110, '2015-04-01 01:30:27.000000', 'temperatura', 245.0000, 'ºC'),
	(133444, 110, '2015-04-01 01:30:28.000000', 'temperatura', 1047.0000, 'ºC'),
	(133445, 110, '2015-04-01 01:30:29.000000', 'temperatura', 900.0000, 'ºC'),
	(133446, 110, '2015-04-01 01:30:30.000000', 'temperatura', 161.0000, 'ºC'),
	(133447, 110, '2015-04-01 01:30:31.000000', 'temperatura', 504.0000, 'ºC'),
	(133448, 110, '2015-04-01 01:30:32.000000', 'temperatura', 838.0000, 'ºC'),
	(133449, 110, '2015-04-01 01:30:33.000000', 'temperatura', 276.0000, 'ºC'),
	(133450, 110, '2015-04-01 01:30:34.000000', 'temperatura', 70.0000, 'ºC'),
	(133451, 110, '2015-04-01 01:30:35.000000', 'temperatura', 720.0000, 'ºC'),
	(133452, 110, '2015-04-01 01:30:36.000000', 'temperatura', 990.0000, 'ºC'),
	(133453, 110, '2015-04-01 01:30:37.000000', 'temperatura', 391.0000, 'ºC'),
	(133454, 110, '2015-04-01 01:30:38.000000', 'temperatura', 186.0000, 'ºC'),
	(133455, 110, '2015-04-01 01:30:39.000000', 'temperatura', 959.0000, 'ºC'),
	(133456, 110, '2015-04-01 01:30:40.000000', 'temperatura', 636.0000, 'ºC'),
	(133457, 110, '2015-04-01 01:30:41.000000', 'temperatura', 305.0000, 'ºC'),
	(133458, 110, '2015-04-01 01:30:42.000000', 'temperatura', 817.0000, 'ºC'),
	(133459, 110, '2015-04-01 01:30:43.000000', 'temperatura', 771.0000, 'ºC'),
	(133460, 110, '2015-04-01 01:30:44.000000', 'temperatura', 205.0000, 'ºC'),
	(133461, 110, '2015-04-01 01:30:45.000000', 'temperatura', 1112.0000, 'ºC'),
	(133462, 110, '2015-04-01 01:30:46.000000', 'temperatura', 146.0000, 'ºC'),
	(133463, 110, '2015-04-01 01:30:47.000000', 'temperatura', 994.0000, 'ºC'),
	(133464, 110, '2015-04-01 01:30:48.000000', 'temperatura', 934.0000, 'ºC'),
	(133465, 110, '2015-04-01 01:30:49.000000', 'temperatura', 488.0000, 'ºC'),
	(133466, 110, '2015-04-01 01:30:50.000000', 'temperatura', 837.0000, 'ºC'),
	(133467, 110, '2015-04-01 01:30:51.000000', 'temperatura', 322.0000, 'ºC'),
	(133468, 110, '2015-04-01 01:30:52.000000', 'temperatura', 299.0000, 'ºC'),
	(133469, 110, '2015-04-01 01:30:53.000000', 'temperatura', 531.0000, 'ºC'),
	(133470, 110, '2015-04-01 01:30:54.000000', 'temperatura', 560.0000, 'ºC'),
	(133471, 110, '2015-04-01 01:30:55.000000', 'temperatura', 4.0000, 'ºC'),
	(133472, 110, '2015-04-01 01:30:56.000000', 'temperatura', 743.0000, 'ºC'),
	(133473, 110, '2015-04-01 01:30:57.000000', 'temperatura', 102.0000, 'ºC'),
	(133474, 110, '2015-04-01 01:30:58.000000', 'temperatura', 681.0000, 'ºC'),
	(133475, 110, '2015-04-01 01:30:59.000000', 'temperatura', 700.0000, 'ºC'),
	(133476, 110, '2015-04-01 01:31:00.000000', 'temperatura', 259.0000, 'ºC'),
	(133477, 110, '2015-04-01 01:31:01.000000', 'temperatura', 394.0000, 'ºC'),
	(133478, 110, '2015-04-01 01:31:02.000000', 'temperatura', 1193.0000, 'ºC'),
	(133479, 110, '2015-04-01 01:31:03.000000', 'temperatura', 1183.0000, 'ºC'),
	(133480, 110, '2015-04-01 01:31:04.000000', 'temperatura', 1138.0000, 'ºC'),
	(133481, 110, '2015-04-01 01:31:05.000000', 'temperatura', 939.0000, 'ºC'),
	(133482, 110, '2015-04-01 01:31:06.000000', 'temperatura', 83.0000, 'ºC'),
	(133483, 110, '2015-04-01 01:31:07.000000', 'temperatura', 0.0000, 'ºC'),
	(133484, 110, '2015-04-01 01:31:08.000000', 'temperatura', 949.0000, 'ºC'),
	(133485, 110, '2015-04-01 01:31:09.000000', 'temperatura', 1147.0000, 'ºC'),
	(133486, 110, '2015-04-01 01:31:10.000000', 'temperatura', 487.0000, 'ºC'),
	(133487, 110, '2015-04-01 01:31:11.000000', 'temperatura', 194.0000, 'ºC'),
	(133488, 110, '2015-04-01 01:31:12.000000', 'temperatura', 709.0000, 'ºC'),
	(133489, 110, '2015-04-01 01:31:13.000000', 'temperatura', 563.0000, 'ºC'),
	(133490, 110, '2015-04-01 01:31:14.000000', 'temperatura', 692.0000, 'ºC'),
	(133491, 110, '2015-04-01 01:31:15.000000', 'temperatura', 568.0000, 'ºC'),
	(133492, 110, '2015-04-01 01:31:16.000000', 'temperatura', 766.0000, 'ºC'),
	(133493, 110, '2015-04-01 01:31:17.000000', 'temperatura', 925.0000, 'ºC'),
	(133494, 110, '2015-04-01 01:31:18.000000', 'temperatura', 1127.0000, 'ºC'),
	(133495, 110, '2015-04-01 01:31:19.000000', 'temperatura', 463.0000, 'ºC'),
	(133496, 110, '2015-04-01 01:31:20.000000', 'temperatura', 133.0000, 'ºC'),
	(133497, 110, '2015-04-01 01:31:21.000000', 'temperatura', 476.0000, 'ºC'),
	(133498, 110, '2015-04-01 01:31:22.000000', 'temperatura', 783.0000, 'ºC'),
	(133499, 110, '2015-04-01 01:31:23.000000', 'temperatura', 88.0000, 'ºC'),
	(133500, 110, '2015-04-01 01:31:24.000000', 'temperatura', 491.0000, 'ºC'),
	(133501, 110, '2015-04-01 01:31:25.000000', 'temperatura', 992.0000, 'ºC'),
	(133502, 110, '2015-04-01 01:31:26.000000', 'temperatura', 1089.0000, 'ºC'),
	(133503, 110, '2015-04-01 01:31:27.000000', 'temperatura', 67.0000, 'ºC'),
	(133504, 110, '2015-04-01 01:31:28.000000', 'temperatura', 668.0000, 'ºC'),
	(133505, 110, '2015-04-01 01:31:29.000000', 'temperatura', 740.0000, 'ºC'),
	(133506, 110, '2015-04-01 01:31:30.000000', 'temperatura', 498.0000, 'ºC'),
	(133507, 110, '2015-04-01 01:31:31.000000', 'temperatura', 269.0000, 'ºC'),
	(133508, 110, '2015-04-01 01:31:32.000000', 'temperatura', 1051.0000, 'ºC'),
	(133509, 110, '2015-04-01 01:31:33.000000', 'temperatura', 850.0000, 'ºC'),
	(133510, 110, '2015-04-01 01:31:34.000000', 'temperatura', 1098.0000, 'ºC'),
	(133511, 110, '2015-04-01 01:31:35.000000', 'temperatura', 541.0000, 'ºC'),
	(133512, 110, '2015-04-01 01:31:36.000000', 'temperatura', 612.0000, 'ºC'),
	(133513, 110, '2015-04-01 01:31:37.000000', 'temperatura', 237.0000, 'ºC'),
	(133514, 110, '2015-04-01 01:31:38.000000', 'temperatura', 551.0000, 'ºC'),
	(133515, 110, '2015-04-01 01:31:39.000000', 'temperatura', 844.0000, 'ºC'),
	(133516, 110, '2015-04-01 01:31:40.000000', 'temperatura', 167.0000, 'ºC'),
	(133517, 110, '2015-04-01 01:31:41.000000', 'temperatura', 705.0000, 'ºC'),
	(133518, 110, '2015-04-01 01:31:42.000000', 'temperatura', 622.0000, 'ºC'),
	(133519, 110, '2015-04-01 01:31:43.000000', 'temperatura', 996.0000, 'ºC'),
	(133520, 110, '2015-04-01 01:31:44.000000', 'temperatura', 713.0000, 'ºC'),
	(133521, 110, '2015-04-01 01:31:45.000000', 'temperatura', 579.0000, 'ºC'),
	(133522, 110, '2015-04-01 01:31:46.000000', 'temperatura', 757.0000, 'ºC'),
	(133523, 110, '2015-04-01 01:31:47.000000', 'temperatura', 849.0000, 'ºC'),
	(133524, 110, '2015-04-01 01:31:48.000000', 'temperatura', 772.0000, 'ºC'),
	(133525, 110, '2015-04-01 01:31:49.000000', 'temperatura', 114.0000, 'ºC'),
	(133526, 110, '2015-04-01 01:31:50.000000', 'temperatura', 654.0000, 'ºC'),
	(133527, 110, '2015-04-01 01:31:51.000000', 'temperatura', 528.0000, 'ºC'),
	(133528, 110, '2015-04-01 01:31:52.000000', 'temperatura', 678.0000, 'ºC'),
	(133529, 110, '2015-04-01 01:31:53.000000', 'temperatura', 607.0000, 'ºC'),
	(133530, 110, '2015-04-01 01:31:54.000000', 'temperatura', 1000.0000, 'ºC'),
	(133531, 110, '2015-04-01 01:31:55.000000', 'temperatura', 780.0000, 'ºC'),
	(133532, 110, '2015-04-01 01:31:56.000000', 'temperatura', 901.0000, 'ºC'),
	(133533, 110, '2015-04-01 01:31:57.000000', 'temperatura', 964.0000, 'ºC'),
	(133534, 110, '2015-04-01 01:31:58.000000', 'temperatura', 919.0000, 'ºC'),
	(133535, 110, '2015-04-01 01:31:59.000000', 'temperatura', 504.0000, 'ºC'),
	(133536, 110, '2015-04-01 01:32:00.000000', 'temperatura', 963.0000, 'ºC'),
	(133537, 110, '2015-04-01 01:32:01.000000', 'temperatura', 905.0000, 'ºC'),
	(133538, 110, '2015-04-01 01:32:02.000000', 'temperatura', 434.0000, 'ºC'),
	(133539, 110, '2015-04-01 01:32:03.000000', 'temperatura', 658.0000, 'ºC'),
	(133540, 110, '2015-04-01 01:32:04.000000', 'temperatura', 788.0000, 'ºC'),
	(133541, 110, '2015-04-01 01:32:05.000000', 'temperatura', 767.0000, 'ºC'),
	(133542, 110, '2015-04-01 01:32:06.000000', 'temperatura', 269.0000, 'ºC'),
	(133543, 110, '2015-04-01 01:32:07.000000', 'temperatura', 247.0000, 'ºC'),
	(133544, 110, '2015-04-01 01:32:08.000000', 'temperatura', 428.0000, 'ºC'),
	(133545, 110, '2015-04-01 01:32:09.000000', 'temperatura', 199.0000, 'ºC'),
	(133546, 110, '2015-04-01 01:32:10.000000', 'temperatura', 914.0000, 'ºC'),
	(133547, 110, '2015-04-01 01:32:11.000000', 'temperatura', 371.0000, 'ºC'),
	(133548, 110, '2015-04-01 01:32:12.000000', 'temperatura', 313.0000, 'ºC'),
	(133549, 110, '2015-04-01 01:32:13.000000', 'temperatura', 455.0000, 'ºC'),
	(133550, 110, '2015-04-01 01:32:14.000000', 'temperatura', 135.0000, 'ºC'),
	(133551, 110, '2015-04-01 01:32:15.000000', 'temperatura', 509.0000, 'ºC'),
	(133552, 110, '2015-04-01 01:32:16.000000', 'temperatura', 943.0000, 'ºC'),
	(133553, 110, '2015-04-01 01:32:17.000000', 'temperatura', 786.0000, 'ºC'),
	(133554, 110, '2015-04-01 01:32:18.000000', 'temperatura', 1104.0000, 'ºC'),
	(133555, 110, '2015-04-01 01:32:19.000000', 'temperatura', 763.0000, 'ºC'),
	(133556, 110, '2015-04-01 01:32:20.000000', 'temperatura', 504.0000, 'ºC'),
	(133557, 110, '2015-04-01 01:32:21.000000', 'temperatura', 229.0000, 'ºC'),
	(133558, 110, '2015-04-01 01:32:22.000000', 'temperatura', 836.0000, 'ºC'),
	(133559, 110, '2015-04-01 01:32:23.000000', 'temperatura', 1091.0000, 'ºC'),
	(133560, 110, '2015-04-01 01:32:24.000000', 'temperatura', 549.0000, 'ºC'),
	(133561, 110, '2015-04-01 01:32:25.000000', 'temperatura', 674.0000, 'ºC'),
	(133562, 110, '2015-04-01 01:32:26.000000', 'temperatura', 523.0000, 'ºC'),
	(133563, 110, '2015-04-01 01:32:27.000000', 'temperatura', 592.0000, 'ºC'),
	(133564, 110, '2015-04-01 01:32:28.000000', 'temperatura', 190.0000, 'ºC'),
	(133565, 110, '2015-04-01 01:32:29.000000', 'temperatura', 376.0000, 'ºC'),
	(133566, 110, '2015-04-01 01:32:30.000000', 'temperatura', 112.0000, 'ºC'),
	(133567, 110, '2015-04-01 01:32:31.000000', 'temperatura', 629.0000, 'ºC'),
	(133568, 110, '2015-04-01 01:32:32.000000', 'temperatura', 413.0000, 'ºC'),
	(133569, 110, '2015-04-01 01:32:33.000000', 'temperatura', 177.0000, 'ºC'),
	(133570, 110, '2015-04-01 01:32:34.000000', 'temperatura', 845.0000, 'ºC'),
	(133571, 110, '2015-04-01 01:32:35.000000', 'temperatura', 96.0000, 'ºC'),
	(133572, 110, '2015-04-01 01:32:36.000000', 'temperatura', 347.0000, 'ºC'),
	(133573, 110, '2015-04-01 01:32:37.000000', 'temperatura', 246.0000, 'ºC'),
	(133574, 110, '2015-04-01 01:32:38.000000', 'temperatura', 189.0000, 'ºC'),
	(133575, 110, '2015-04-01 01:32:39.000000', 'temperatura', 207.0000, 'ºC'),
	(133576, 110, '2015-04-01 01:32:40.000000', 'temperatura', 469.0000, 'ºC'),
	(133577, 110, '2015-04-01 01:32:41.000000', 'temperatura', 524.0000, 'ºC'),
	(133578, 110, '2015-04-01 01:32:42.000000', 'temperatura', 15.0000, 'ºC'),
	(133579, 110, '2015-04-01 01:32:43.000000', 'temperatura', 902.0000, 'ºC'),
	(133580, 110, '2015-04-01 01:32:44.000000', 'temperatura', 868.0000, 'ºC'),
	(133581, 110, '2015-04-01 01:32:45.000000', 'temperatura', 434.0000, 'ºC'),
	(133582, 110, '2015-04-01 01:32:46.000000', 'temperatura', 764.0000, 'ºC'),
	(133583, 110, '2015-04-01 01:32:47.000000', 'temperatura', 120.0000, 'ºC'),
	(133584, 110, '2015-04-01 01:32:48.000000', 'temperatura', 710.0000, 'ºC'),
	(133585, 110, '2015-04-01 01:32:49.000000', 'temperatura', 787.0000, 'ºC'),
	(133586, 110, '2015-04-01 01:32:50.000000', 'temperatura', 608.0000, 'ºC'),
	(133587, 110, '2015-04-01 01:32:51.000000', 'temperatura', 681.0000, 'ºC'),
	(133588, 110, '2015-04-01 01:32:52.000000', 'temperatura', 380.0000, 'ºC'),
	(133589, 110, '2015-04-01 01:32:53.000000', 'temperatura', 1057.0000, 'ºC'),
	(133590, 110, '2015-04-01 01:32:54.000000', 'temperatura', 546.0000, 'ºC'),
	(133591, 110, '2015-04-01 01:32:55.000000', 'temperatura', 760.0000, 'ºC'),
	(133592, 110, '2015-04-01 01:32:56.000000', 'temperatura', 963.0000, 'ºC'),
	(133593, 110, '2015-04-01 01:32:57.000000', 'temperatura', 136.0000, 'ºC'),
	(133594, 110, '2015-04-01 01:32:58.000000', 'temperatura', 192.0000, 'ºC'),
	(133595, 110, '2015-04-01 01:32:59.000000', 'temperatura', 551.0000, 'ºC'),
	(133596, 110, '2015-04-01 01:33:00.000000', 'temperatura', 979.0000, 'ºC'),
	(133597, 110, '2015-04-01 01:33:01.000000', 'temperatura', 845.0000, 'ºC'),
	(133598, 110, '2015-04-01 01:33:02.000000', 'temperatura', 87.0000, 'ºC'),
	(133599, 110, '2015-04-01 01:33:03.000000', 'temperatura', 301.0000, 'ºC'),
	(133600, 110, '2015-04-01 01:33:04.000000', 'temperatura', 46.0000, 'ºC'),
	(133601, 110, '2015-04-01 01:33:05.000000', 'temperatura', 525.0000, 'ºC'),
	(133602, 110, '2015-04-01 01:33:06.000000', 'temperatura', 88.0000, 'ºC'),
	(133603, 110, '2015-04-01 01:33:07.000000', 'temperatura', 67.0000, 'ºC'),
	(133604, 110, '2015-04-01 01:33:08.000000', 'temperatura', 73.0000, 'ºC'),
	(133605, 110, '2015-04-01 01:33:09.000000', 'temperatura', 162.0000, 'ºC'),
	(133606, 110, '2015-04-01 01:33:10.000000', 'temperatura', 592.0000, 'ºC'),
	(133607, 110, '2015-04-01 01:33:11.000000', 'temperatura', 73.0000, 'ºC'),
	(133608, 110, '2015-04-01 01:33:12.000000', 'temperatura', 990.0000, 'ºC'),
	(133609, 110, '2015-04-01 01:33:13.000000', 'temperatura', 1133.0000, 'ºC'),
	(133610, 110, '2015-04-01 01:33:14.000000', 'temperatura', 295.0000, 'ºC'),
	(133611, 110, '2015-04-01 01:33:15.000000', 'temperatura', 477.0000, 'ºC'),
	(133612, 110, '2015-04-01 01:33:16.000000', 'temperatura', 298.0000, 'ºC'),
	(133613, 110, '2015-04-01 01:33:17.000000', 'temperatura', 62.0000, 'ºC'),
	(133614, 110, '2015-04-01 01:33:18.000000', 'temperatura', 616.0000, 'ºC'),
	(133615, 110, '2015-04-01 01:33:19.000000', 'temperatura', 496.0000, 'ºC'),
	(133616, 110, '2015-04-01 01:33:20.000000', 'temperatura', 629.0000, 'ºC'),
	(133617, 110, '2015-04-01 01:33:21.000000', 'temperatura', 461.0000, 'ºC'),
	(133618, 110, '2015-04-01 01:33:22.000000', 'temperatura', 417.0000, 'ºC'),
	(133619, 110, '2015-04-01 01:33:23.000000', 'temperatura', 704.0000, 'ºC'),
	(133620, 110, '2015-04-01 01:33:24.000000', 'temperatura', 1069.0000, 'ºC'),
	(133621, 110, '2015-04-01 01:33:25.000000', 'temperatura', 832.0000, 'ºC'),
	(133622, 110, '2015-04-01 01:33:26.000000', 'temperatura', 953.0000, 'ºC'),
	(133623, 110, '2015-04-01 01:33:27.000000', 'temperatura', 1073.0000, 'ºC'),
	(133624, 110, '2015-04-01 01:33:28.000000', 'temperatura', 103.0000, 'ºC'),
	(133625, 110, '2015-04-01 01:33:29.000000', 'temperatura', 896.0000, 'ºC'),
	(133626, 110, '2015-04-01 01:33:30.000000', 'temperatura', 572.0000, 'ºC'),
	(133627, 110, '2015-04-01 01:33:31.000000', 'temperatura', 175.0000, 'ºC'),
	(133628, 110, '2015-04-01 01:33:32.000000', 'temperatura', 357.0000, 'ºC'),
	(133629, 110, '2015-04-01 01:33:33.000000', 'temperatura', 59.0000, 'ºC'),
	(133630, 110, '2015-04-01 01:33:34.000000', 'temperatura', 428.0000, 'ºC'),
	(133631, 110, '2015-04-01 01:33:35.000000', 'temperatura', 761.0000, 'ºC'),
	(133632, 110, '2015-04-01 01:33:36.000000', 'temperatura', 122.0000, 'ºC'),
	(133633, 110, '2015-04-01 01:33:37.000000', 'temperatura', 729.0000, 'ºC'),
	(133634, 110, '2015-04-01 01:33:38.000000', 'temperatura', 880.0000, 'ºC'),
	(133635, 110, '2015-04-01 01:33:39.000000', 'temperatura', 1011.0000, 'ºC'),
	(133636, 110, '2015-04-01 01:33:40.000000', 'temperatura', 16.0000, 'ºC'),
	(133637, 110, '2015-04-01 01:33:41.000000', 'temperatura', 649.0000, 'ºC'),
	(133638, 110, '2015-04-01 01:33:42.000000', 'temperatura', 799.0000, 'ºC'),
	(133639, 110, '2015-04-01 01:33:43.000000', 'temperatura', 845.0000, 'ºC'),
	(133640, 110, '2015-04-01 01:33:44.000000', 'temperatura', 632.0000, 'ºC'),
	(133641, 110, '2015-04-01 01:33:45.000000', 'temperatura', 622.0000, 'ºC'),
	(133642, 110, '2015-04-01 01:33:46.000000', 'temperatura', 17.0000, 'ºC'),
	(133643, 110, '2015-04-01 01:33:47.000000', 'temperatura', 617.0000, 'ºC'),
	(133644, 110, '2015-04-01 01:33:48.000000', 'temperatura', 636.0000, 'ºC'),
	(133645, 110, '2015-04-01 01:33:49.000000', 'temperatura', 131.0000, 'ºC'),
	(133646, 110, '2015-04-01 01:33:50.000000', 'temperatura', 1147.0000, 'ºC'),
	(133647, 110, '2015-04-01 01:33:51.000000', 'temperatura', 543.0000, 'ºC'),
	(133648, 110, '2015-04-01 01:33:52.000000', 'temperatura', 472.0000, 'ºC'),
	(133649, 110, '2015-04-01 01:33:53.000000', 'temperatura', 733.0000, 'ºC'),
	(133650, 110, '2015-04-01 01:33:54.000000', 'temperatura', 1051.0000, 'ºC'),
	(133651, 110, '2015-04-01 01:33:55.000000', 'temperatura', 655.0000, 'ºC'),
	(133652, 110, '2015-04-01 01:33:56.000000', 'temperatura', 124.0000, 'ºC'),
	(133653, 110, '2015-04-01 01:33:57.000000', 'temperatura', 1057.0000, 'ºC'),
	(133654, 110, '2015-04-01 01:33:58.000000', 'temperatura', 110.0000, 'ºC'),
	(133655, 110, '2015-04-01 01:33:59.000000', 'temperatura', 980.0000, 'ºC'),
	(133656, 110, '2015-04-01 01:34:00.000000', 'temperatura', 969.0000, 'ºC'),
	(133657, 110, '2015-04-01 01:34:01.000000', 'temperatura', 708.0000, 'ºC'),
	(133658, 110, '2015-04-01 01:34:02.000000', 'temperatura', 632.0000, 'ºC'),
	(133659, 110, '2015-04-01 01:34:03.000000', 'temperatura', 1037.0000, 'ºC'),
	(133660, 110, '2015-04-01 01:34:04.000000', 'temperatura', 891.0000, 'ºC'),
	(133661, 110, '2015-04-01 01:34:05.000000', 'temperatura', 145.0000, 'ºC'),
	(133662, 110, '2015-04-01 01:34:06.000000', 'temperatura', 452.0000, 'ºC'),
	(133663, 110, '2015-04-01 01:34:07.000000', 'temperatura', 625.0000, 'ºC'),
	(133664, 110, '2015-04-01 01:34:08.000000', 'temperatura', 570.0000, 'ºC'),
	(133665, 110, '2015-04-01 01:34:09.000000', 'temperatura', 977.0000, 'ºC'),
	(133666, 110, '2015-04-01 01:34:10.000000', 'temperatura', 775.0000, 'ºC'),
	(133667, 110, '2015-04-01 01:34:11.000000', 'temperatura', 943.0000, 'ºC'),
	(133668, 110, '2015-04-01 01:34:12.000000', 'temperatura', 1192.0000, 'ºC'),
	(133669, 110, '2015-04-01 01:34:13.000000', 'temperatura', 730.0000, 'ºC'),
	(133670, 110, '2015-04-01 01:34:14.000000', 'temperatura', 74.0000, 'ºC'),
	(133671, 110, '2015-04-01 01:34:15.000000', 'temperatura', 580.0000, 'ºC'),
	(133672, 110, '2015-04-01 01:34:16.000000', 'temperatura', 280.0000, 'ºC'),
	(133673, 110, '2015-04-01 01:34:17.000000', 'temperatura', 858.0000, 'ºC'),
	(133674, 110, '2015-04-01 01:34:18.000000', 'temperatura', 1054.0000, 'ºC'),
	(133675, 110, '2015-04-01 01:34:19.000000', 'temperatura', 295.0000, 'ºC'),
	(133676, 110, '2015-04-01 01:34:20.000000', 'temperatura', 713.0000, 'ºC'),
	(133677, 110, '2015-04-01 01:34:21.000000', 'temperatura', 283.0000, 'ºC'),
	(133678, 110, '2015-04-01 01:34:22.000000', 'temperatura', 474.0000, 'ºC'),
	(133679, 110, '2015-04-01 01:34:23.000000', 'temperatura', 323.0000, 'ºC'),
	(133680, 110, '2015-04-01 01:34:24.000000', 'temperatura', 191.0000, 'ºC'),
	(133681, 110, '2015-04-01 01:34:25.000000', 'temperatura', 1188.0000, 'ºC'),
	(133682, 110, '2015-04-01 01:34:26.000000', 'temperatura', 569.0000, 'ºC'),
	(133683, 110, '2015-04-01 01:34:27.000000', 'temperatura', 482.0000, 'ºC'),
	(133684, 110, '2015-04-01 01:34:28.000000', 'temperatura', 704.0000, 'ºC'),
	(133685, 110, '2015-04-01 01:34:29.000000', 'temperatura', 875.0000, 'ºC'),
	(133686, 110, '2015-04-01 01:34:30.000000', 'temperatura', 1064.0000, 'ºC'),
	(133687, 110, '2015-04-01 01:34:31.000000', 'temperatura', 294.0000, 'ºC'),
	(133688, 110, '2015-04-01 01:34:32.000000', 'temperatura', 679.0000, 'ºC'),
	(133689, 110, '2015-04-01 01:34:33.000000', 'temperatura', 114.0000, 'ºC'),
	(133690, 110, '2015-04-01 01:34:34.000000', 'temperatura', 932.0000, 'ºC'),
	(133691, 110, '2015-04-01 01:34:35.000000', 'temperatura', 719.0000, 'ºC'),
	(133692, 110, '2015-04-01 01:34:36.000000', 'temperatura', 801.0000, 'ºC'),
	(133693, 110, '2015-04-01 01:34:37.000000', 'temperatura', 646.0000, 'ºC'),
	(133694, 110, '2015-04-01 01:34:38.000000', 'temperatura', 829.0000, 'ºC'),
	(133695, 110, '2015-04-01 01:34:39.000000', 'temperatura', 1007.0000, 'ºC'),
	(133696, 110, '2015-04-01 01:34:40.000000', 'temperatura', 148.0000, 'ºC'),
	(133697, 111, '2015-04-01 00:00:00.000000', 'temperatura', 162.0000, 'ºC'),
	(133698, 111, '2015-04-01 00:00:01.000000', 'temperatura', 447.0000, 'ºC'),
	(133699, 111, '2015-04-01 00:00:02.000000', 'temperatura', 548.0000, 'ºC'),
	(133700, 111, '2015-04-01 00:00:03.000000', 'temperatura', 200.0000, 'ºC'),
	(133701, 111, '2015-04-01 00:00:04.000000', 'temperatura', 557.0000, 'ºC'),
	(133702, 111, '2015-04-01 00:00:05.000000', 'temperatura', 987.0000, 'ºC'),
	(133703, 111, '2015-04-01 00:00:06.000000', 'temperatura', 865.0000, 'ºC'),
	(133704, 111, '2015-04-01 00:00:07.000000', 'temperatura', 163.0000, 'ºC'),
	(133705, 111, '2015-04-01 00:00:08.000000', 'temperatura', 619.0000, 'ºC'),
	(133706, 111, '2015-04-01 00:00:09.000000', 'temperatura', 208.0000, 'ºC'),
	(133707, 111, '2015-04-01 00:00:10.000000', 'temperatura', 383.0000, 'ºC'),
	(133708, 111, '2015-04-01 00:00:11.000000', 'temperatura', 90.0000, 'ºC'),
	(133709, 111, '2015-04-01 00:00:12.000000', 'temperatura', 505.0000, 'ºC'),
	(133710, 111, '2015-04-01 00:00:13.000000', 'temperatura', 1053.0000, 'ºC'),
	(133711, 111, '2015-04-01 00:00:14.000000', 'temperatura', 152.0000, 'ºC'),
	(133712, 111, '2015-04-01 00:00:15.000000', 'temperatura', 1199.0000, 'ºC'),
	(133713, 111, '2015-04-01 00:00:16.000000', 'temperatura', 741.0000, 'ºC'),
	(133714, 111, '2015-04-01 00:00:17.000000', 'temperatura', 107.0000, 'ºC'),
	(133715, 111, '2015-04-01 00:00:18.000000', 'temperatura', 714.0000, 'ºC'),
	(133716, 111, '2015-04-01 00:00:19.000000', 'temperatura', 849.0000, 'ºC'),
	(133717, 111, '2015-04-01 00:00:20.000000', 'temperatura', 903.0000, 'ºC'),
	(133718, 111, '2015-04-01 00:00:21.000000', 'temperatura', 770.0000, 'ºC'),
	(133719, 111, '2015-04-01 00:00:22.000000', 'temperatura', 1140.0000, 'ºC'),
	(133720, 111, '2015-04-01 00:00:23.000000', 'temperatura', 993.0000, 'ºC'),
	(133721, 111, '2015-04-01 00:00:24.000000', 'temperatura', 345.0000, 'ºC'),
	(133722, 111, '2015-04-01 00:00:25.000000', 'temperatura', 1145.0000, 'ºC'),
	(133723, 111, '2015-04-01 00:00:26.000000', 'temperatura', 1090.0000, 'ºC'),
	(133724, 111, '2015-04-01 00:00:27.000000', 'temperatura', 815.0000, 'ºC'),
	(133725, 111, '2015-04-01 00:00:28.000000', 'temperatura', 805.0000, 'ºC'),
	(133726, 111, '2015-04-01 00:00:29.000000', 'temperatura', 382.0000, 'ºC'),
	(133727, 111, '2015-04-01 00:00:30.000000', 'temperatura', 696.0000, 'ºC'),
	(133728, 111, '2015-04-01 00:00:31.000000', 'temperatura', 1132.0000, 'ºC'),
	(133729, 111, '2015-04-01 00:00:32.000000', 'temperatura', 1175.0000, 'ºC'),
	(133730, 111, '2015-04-01 00:00:33.000000', 'temperatura', 77.0000, 'ºC'),
	(133731, 111, '2015-04-01 00:00:34.000000', 'temperatura', 460.0000, 'ºC'),
	(133732, 111, '2015-04-01 00:00:35.000000', 'temperatura', 869.0000, 'ºC'),
	(133733, 111, '2015-04-01 00:00:36.000000', 'temperatura', 568.0000, 'ºC'),
	(133734, 111, '2015-04-01 00:00:37.000000', 'temperatura', 232.0000, 'ºC'),
	(133735, 111, '2015-04-01 00:00:38.000000', 'temperatura', 655.0000, 'ºC'),
	(133736, 111, '2015-04-01 00:00:39.000000', 'temperatura', 181.0000, 'ºC'),
	(133737, 111, '2015-04-01 00:00:40.000000', 'temperatura', 139.0000, 'ºC'),
	(133738, 111, '2015-04-01 00:00:41.000000', 'temperatura', 152.0000, 'ºC'),
	(133739, 111, '2015-04-01 00:00:42.000000', 'temperatura', 346.0000, 'ºC'),
	(133740, 111, '2015-04-01 00:00:43.000000', 'temperatura', 76.0000, 'ºC'),
	(133741, 111, '2015-04-01 00:00:44.000000', 'temperatura', 539.0000, 'ºC'),
	(133742, 111, '2015-04-01 00:00:45.000000', 'temperatura', 68.0000, 'ºC'),
	(133743, 111, '2015-04-01 00:00:46.000000', 'temperatura', 1124.0000, 'ºC'),
	(133744, 111, '2015-04-01 00:00:47.000000', 'temperatura', 618.0000, 'ºC'),
	(133745, 111, '2015-04-01 00:00:48.000000', 'temperatura', 917.0000, 'ºC'),
	(133746, 111, '2015-04-01 00:00:49.000000', 'temperatura', 330.0000, 'ºC'),
	(133747, 111, '2015-04-01 00:00:50.000000', 'temperatura', 101.0000, 'ºC'),
	(133748, 111, '2015-04-01 00:00:51.000000', 'temperatura', 715.0000, 'ºC'),
	(133749, 111, '2015-04-01 00:00:52.000000', 'temperatura', 874.0000, 'ºC'),
	(133750, 111, '2015-04-01 00:00:53.000000', 'temperatura', 1025.0000, 'ºC'),
	(133751, 111, '2015-04-01 00:00:54.000000', 'temperatura', 103.0000, 'ºC'),
	(133752, 111, '2015-04-01 00:00:55.000000', 'temperatura', 1042.0000, 'ºC'),
	(133753, 111, '2015-04-01 00:00:56.000000', 'temperatura', 101.0000, 'ºC'),
	(133754, 111, '2015-04-01 00:00:57.000000', 'temperatura', 978.0000, 'ºC'),
	(133755, 111, '2015-04-01 00:00:58.000000', 'temperatura', 987.0000, 'ºC'),
	(133756, 111, '2015-04-01 00:00:59.000000', 'temperatura', 802.0000, 'ºC'),
	(133757, 111, '2015-04-01 00:01:00.000000', 'temperatura', 1051.0000, 'ºC'),
	(133758, 111, '2015-04-01 00:01:01.000000', 'temperatura', 450.0000, 'ºC'),
	(133759, 111, '2015-04-01 00:01:02.000000', 'temperatura', 297.0000, 'ºC'),
	(133760, 111, '2015-04-01 00:01:03.000000', 'temperatura', 135.0000, 'ºC'),
	(133761, 111, '2015-04-01 00:01:04.000000', 'temperatura', 986.0000, 'ºC'),
	(133762, 111, '2015-04-01 00:01:05.000000', 'temperatura', 924.0000, 'ºC'),
	(133763, 111, '2015-04-01 00:01:06.000000', 'temperatura', 462.0000, 'ºC'),
	(133764, 111, '2015-04-01 00:01:07.000000', 'temperatura', 739.0000, 'ºC'),
	(133765, 111, '2015-04-01 00:01:08.000000', 'temperatura', 1110.0000, 'ºC'),
	(133766, 111, '2015-04-01 00:01:09.000000', 'temperatura', 932.0000, 'ºC'),
	(133767, 111, '2015-04-01 00:01:10.000000', 'temperatura', 133.0000, 'ºC'),
	(133768, 111, '2015-04-01 00:01:11.000000', 'temperatura', 268.0000, 'ºC'),
	(133769, 111, '2015-04-01 00:01:12.000000', 'temperatura', 941.0000, 'ºC'),
	(133770, 111, '2015-04-01 00:01:13.000000', 'temperatura', 303.0000, 'ºC'),
	(133771, 111, '2015-04-01 00:01:14.000000', 'temperatura', 1093.0000, 'ºC'),
	(133772, 111, '2015-04-01 00:01:15.000000', 'temperatura', 956.0000, 'ºC'),
	(133773, 111, '2015-04-01 00:01:16.000000', 'temperatura', 303.0000, 'ºC'),
	(133774, 111, '2015-04-01 00:01:17.000000', 'temperatura', 1045.0000, 'ºC'),
	(133775, 111, '2015-04-01 00:01:18.000000', 'temperatura', 719.0000, 'ºC'),
	(133776, 111, '2015-04-01 00:01:19.000000', 'temperatura', 462.0000, 'ºC'),
	(133777, 111, '2015-04-01 00:01:20.000000', 'temperatura', 150.0000, 'ºC'),
	(133778, 111, '2015-04-01 00:01:21.000000', 'temperatura', 564.0000, 'ºC'),
	(133779, 111, '2015-04-01 00:01:22.000000', 'temperatura', 1173.0000, 'ºC'),
	(133780, 111, '2015-04-01 00:01:23.000000', 'temperatura', 573.0000, 'ºC'),
	(133781, 111, '2015-04-01 00:01:24.000000', 'temperatura', 546.0000, 'ºC'),
	(133782, 111, '2015-04-01 00:01:25.000000', 'temperatura', 1014.0000, 'ºC'),
	(133783, 111, '2015-04-01 00:01:26.000000', 'temperatura', 1029.0000, 'ºC'),
	(133784, 111, '2015-04-01 00:01:27.000000', 'temperatura', 904.0000, 'ºC'),
	(133785, 111, '2015-04-01 00:01:28.000000', 'temperatura', 233.0000, 'ºC'),
	(133786, 111, '2015-04-01 00:01:29.000000', 'temperatura', 853.0000, 'ºC'),
	(133787, 111, '2015-04-01 00:01:30.000000', 'temperatura', 1169.0000, 'ºC'),
	(133788, 111, '2015-04-01 00:01:31.000000', 'temperatura', 884.0000, 'ºC'),
	(133789, 111, '2015-04-01 00:01:32.000000', 'temperatura', 914.0000, 'ºC'),
	(133790, 111, '2015-04-01 00:01:33.000000', 'temperatura', 719.0000, 'ºC'),
	(133791, 111, '2015-04-01 00:01:34.000000', 'temperatura', 852.0000, 'ºC'),
	(133792, 111, '2015-04-01 00:01:35.000000', 'temperatura', 904.0000, 'ºC'),
	(133793, 111, '2015-04-01 00:01:36.000000', 'temperatura', 766.0000, 'ºC'),
	(133794, 111, '2015-04-01 00:01:37.000000', 'temperatura', 1118.0000, 'ºC'),
	(133795, 111, '2015-04-01 00:01:38.000000', 'temperatura', 894.0000, 'ºC'),
	(133796, 111, '2015-04-01 00:01:39.000000', 'temperatura', 1116.0000, 'ºC'),
	(133797, 111, '2015-04-01 00:01:40.000000', 'temperatura', 500.0000, 'ºC'),
	(133798, 111, '2015-04-01 00:01:41.000000', 'temperatura', 351.0000, 'ºC'),
	(133799, 111, '2015-04-01 00:01:42.000000', 'temperatura', 254.0000, 'ºC'),
	(133800, 111, '2015-04-01 00:01:43.000000', 'temperatura', 219.0000, 'ºC'),
	(133801, 111, '2015-04-01 00:01:44.000000', 'temperatura', 334.0000, 'ºC'),
	(133802, 111, '2015-04-01 00:01:45.000000', 'temperatura', 1014.0000, 'ºC'),
	(133803, 111, '2015-04-01 00:01:46.000000', 'temperatura', 468.0000, 'ºC'),
	(133804, 111, '2015-04-01 00:01:47.000000', 'temperatura', 499.0000, 'ºC'),
	(133805, 111, '2015-04-01 00:01:48.000000', 'temperatura', 1091.0000, 'ºC'),
	(133806, 111, '2015-04-01 00:01:49.000000', 'temperatura', 360.0000, 'ºC'),
	(133807, 111, '2015-04-01 00:01:50.000000', 'temperatura', 925.0000, 'ºC'),
	(133808, 111, '2015-04-01 00:01:51.000000', 'temperatura', 1146.0000, 'ºC'),
	(133809, 111, '2015-04-01 00:01:52.000000', 'temperatura', 556.0000, 'ºC'),
	(133810, 111, '2015-04-01 00:01:53.000000', 'temperatura', 542.0000, 'ºC'),
	(133811, 111, '2015-04-01 00:01:54.000000', 'temperatura', 1044.0000, 'ºC'),
	(133812, 111, '2015-04-01 00:01:55.000000', 'temperatura', 1195.0000, 'ºC'),
	(133813, 111, '2015-04-01 00:01:56.000000', 'temperatura', 442.0000, 'ºC'),
	(133814, 111, '2015-04-01 00:01:57.000000', 'temperatura', 1025.0000, 'ºC'),
	(133815, 111, '2015-04-01 00:01:58.000000', 'temperatura', 200.0000, 'ºC'),
	(133816, 111, '2015-04-01 00:01:59.000000', 'temperatura', 324.0000, 'ºC'),
	(133817, 111, '2015-04-01 00:02:00.000000', 'temperatura', 1022.0000, 'ºC'),
	(133818, 111, '2015-04-01 00:02:01.000000', 'temperatura', 537.0000, 'ºC'),
	(133819, 111, '2015-04-01 00:02:02.000000', 'temperatura', 821.0000, 'ºC'),
	(133820, 111, '2015-04-01 00:02:03.000000', 'temperatura', 95.0000, 'ºC'),
	(133821, 111, '2015-04-01 00:02:04.000000', 'temperatura', 412.0000, 'ºC'),
	(133822, 111, '2015-04-01 00:02:05.000000', 'temperatura', 575.0000, 'ºC'),
	(133823, 111, '2015-04-01 00:02:06.000000', 'temperatura', 438.0000, 'ºC'),
	(133824, 111, '2015-04-01 00:02:07.000000', 'temperatura', 466.0000, 'ºC'),
	(133825, 111, '2015-04-01 00:02:08.000000', 'temperatura', 1019.0000, 'ºC'),
	(133826, 111, '2015-04-01 00:02:09.000000', 'temperatura', 96.0000, 'ºC'),
	(133827, 111, '2015-04-01 00:02:10.000000', 'temperatura', 1025.0000, 'ºC'),
	(133828, 111, '2015-04-01 00:02:11.000000', 'temperatura', 35.0000, 'ºC'),
	(133829, 111, '2015-04-01 00:02:12.000000', 'temperatura', 701.0000, 'ºC'),
	(133830, 111, '2015-04-01 00:02:13.000000', 'temperatura', 999.0000, 'ºC'),
	(133831, 111, '2015-04-01 00:02:14.000000', 'temperatura', 493.0000, 'ºC'),
	(133832, 111, '2015-04-01 00:02:15.000000', 'temperatura', 669.0000, 'ºC'),
	(133833, 111, '2015-04-01 00:02:16.000000', 'temperatura', 664.0000, 'ºC'),
	(133834, 111, '2015-04-01 00:02:17.000000', 'temperatura', 117.0000, 'ºC'),
	(133835, 111, '2015-04-01 00:02:18.000000', 'temperatura', 994.0000, 'ºC'),
	(133836, 111, '2015-04-01 00:02:19.000000', 'temperatura', 1017.0000, 'ºC'),
	(133837, 111, '2015-04-01 00:02:20.000000', 'temperatura', 904.0000, 'ºC'),
	(133838, 111, '2015-04-01 00:02:21.000000', 'temperatura', 271.0000, 'ºC'),
	(133839, 111, '2015-04-01 00:02:22.000000', 'temperatura', 1043.0000, 'ºC'),
	(133840, 111, '2015-04-01 00:02:23.000000', 'temperatura', 801.0000, 'ºC'),
	(133841, 111, '2015-04-01 00:02:24.000000', 'temperatura', 877.0000, 'ºC'),
	(133842, 111, '2015-04-01 00:02:25.000000', 'temperatura', 784.0000, 'ºC'),
	(133843, 111, '2015-04-01 00:02:26.000000', 'temperatura', 88.0000, 'ºC'),
	(133844, 111, '2015-04-01 00:02:27.000000', 'temperatura', 489.0000, 'ºC'),
	(133845, 111, '2015-04-01 00:02:28.000000', 'temperatura', 982.0000, 'ºC'),
	(133846, 111, '2015-04-01 00:02:29.000000', 'temperatura', 1043.0000, 'ºC'),
	(133847, 111, '2015-04-01 00:02:30.000000', 'temperatura', 1068.0000, 'ºC'),
	(133848, 111, '2015-04-01 00:02:31.000000', 'temperatura', 1012.0000, 'ºC'),
	(133849, 111, '2015-04-01 00:02:32.000000', 'temperatura', 656.0000, 'ºC'),
	(133850, 111, '2015-04-01 00:02:33.000000', 'temperatura', 247.0000, 'ºC'),
	(133851, 111, '2015-04-01 00:02:34.000000', 'temperatura', 466.0000, 'ºC'),
	(133852, 111, '2015-04-01 00:02:35.000000', 'temperatura', 389.0000, 'ºC'),
	(133853, 111, '2015-04-01 00:02:36.000000', 'temperatura', 549.0000, 'ºC'),
	(133854, 111, '2015-04-01 00:02:37.000000', 'temperatura', 377.0000, 'ºC'),
	(133855, 111, '2015-04-01 00:02:38.000000', 'temperatura', 240.0000, 'ºC'),
	(133856, 111, '2015-04-01 00:02:39.000000', 'temperatura', 67.0000, 'ºC'),
	(133857, 111, '2015-04-01 00:02:40.000000', 'temperatura', 816.0000, 'ºC'),
	(133858, 111, '2015-04-01 00:02:41.000000', 'temperatura', 282.0000, 'ºC'),
	(133859, 111, '2015-04-01 00:02:42.000000', 'temperatura', 161.0000, 'ºC'),
	(133860, 111, '2015-04-01 00:02:43.000000', 'temperatura', 1160.0000, 'ºC'),
	(133861, 111, '2015-04-01 00:02:44.000000', 'temperatura', 519.0000, 'ºC'),
	(133862, 111, '2015-04-01 00:02:45.000000', 'temperatura', 313.0000, 'ºC'),
	(133863, 111, '2015-04-01 00:02:46.000000', 'temperatura', 8.0000, 'ºC'),
	(133864, 111, '2015-04-01 00:02:47.000000', 'temperatura', 304.0000, 'ºC'),
	(133865, 111, '2015-04-01 00:02:48.000000', 'temperatura', 296.0000, 'ºC'),
	(133866, 111, '2015-04-01 00:02:49.000000', 'temperatura', 569.0000, 'ºC'),
	(133867, 111, '2015-04-01 00:02:50.000000', 'temperatura', 756.0000, 'ºC'),
	(133868, 111, '2015-04-01 00:02:51.000000', 'temperatura', 876.0000, 'ºC'),
	(133869, 111, '2015-04-01 00:02:52.000000', 'temperatura', 910.0000, 'ºC'),
	(133870, 111, '2015-04-01 00:02:53.000000', 'temperatura', 722.0000, 'ºC'),
	(133871, 111, '2015-04-01 00:02:54.000000', 'temperatura', 879.0000, 'ºC'),
	(133872, 111, '2015-04-01 00:02:55.000000', 'temperatura', 1033.0000, 'ºC'),
	(133873, 111, '2015-04-01 00:02:56.000000', 'temperatura', 127.0000, 'ºC'),
	(133874, 111, '2015-04-01 00:02:57.000000', 'temperatura', 1136.0000, 'ºC'),
	(133875, 111, '2015-04-01 00:02:58.000000', 'temperatura', 498.0000, 'ºC'),
	(133876, 111, '2015-04-01 00:02:59.000000', 'temperatura', 284.0000, 'ºC'),
	(133877, 111, '2015-04-01 00:03:00.000000', 'temperatura', 1126.0000, 'ºC'),
	(133878, 111, '2015-04-01 00:03:01.000000', 'temperatura', 1180.0000, 'ºC'),
	(133879, 111, '2015-04-01 00:03:02.000000', 'temperatura', 123.0000, 'ºC'),
	(133880, 111, '2015-04-01 00:03:03.000000', 'temperatura', 676.0000, 'ºC'),
	(133881, 111, '2015-04-01 00:03:04.000000', 'temperatura', 608.0000, 'ºC'),
	(133882, 111, '2015-04-01 00:03:05.000000', 'temperatura', 1016.0000, 'ºC'),
	(133883, 111, '2015-04-01 00:03:06.000000', 'temperatura', 855.0000, 'ºC'),
	(133884, 111, '2015-04-01 00:03:07.000000', 'temperatura', 29.0000, 'ºC'),
	(133885, 111, '2015-04-01 00:03:08.000000', 'temperatura', 1179.0000, 'ºC'),
	(133886, 111, '2015-04-01 00:03:09.000000', 'temperatura', 1010.0000, 'ºC'),
	(133887, 111, '2015-04-01 00:03:10.000000', 'temperatura', 314.0000, 'ºC'),
	(133888, 111, '2015-04-01 00:03:11.000000', 'temperatura', 938.0000, 'ºC'),
	(133889, 111, '2015-04-01 00:03:12.000000', 'temperatura', 148.0000, 'ºC'),
	(133890, 111, '2015-04-01 00:03:13.000000', 'temperatura', 326.0000, 'ºC'),
	(133891, 111, '2015-04-01 00:03:14.000000', 'temperatura', 1188.0000, 'ºC'),
	(133892, 111, '2015-04-01 00:03:15.000000', 'temperatura', 160.0000, 'ºC'),
	(133893, 111, '2015-04-01 00:03:16.000000', 'temperatura', 839.0000, 'ºC'),
	(133894, 111, '2015-04-01 00:03:17.000000', 'temperatura', 115.0000, 'ºC'),
	(133895, 111, '2015-04-01 00:03:18.000000', 'temperatura', 459.0000, 'ºC'),
	(133896, 111, '2015-04-01 00:03:19.000000', 'temperatura', 752.0000, 'ºC'),
	(133897, 111, '2015-04-01 00:03:20.000000', 'temperatura', 1182.0000, 'ºC'),
	(133898, 111, '2015-04-01 00:03:21.000000', 'temperatura', 56.0000, 'ºC'),
	(133899, 111, '2015-04-01 00:03:22.000000', 'temperatura', 335.0000, 'ºC'),
	(133900, 111, '2015-04-01 00:03:23.000000', 'temperatura', 307.0000, 'ºC'),
	(133901, 111, '2015-04-01 00:03:24.000000', 'temperatura', 531.0000, 'ºC'),
	(133902, 111, '2015-04-01 00:03:25.000000', 'temperatura', 535.0000, 'ºC'),
	(133903, 111, '2015-04-01 00:03:26.000000', 'temperatura', 1082.0000, 'ºC'),
	(133904, 111, '2015-04-01 00:03:27.000000', 'temperatura', 204.0000, 'ºC'),
	(133905, 111, '2015-04-01 00:03:28.000000', 'temperatura', 177.0000, 'ºC'),
	(133906, 111, '2015-04-01 00:03:29.000000', 'temperatura', 273.0000, 'ºC'),
	(133907, 111, '2015-04-01 00:03:30.000000', 'temperatura', 836.0000, 'ºC'),
	(133908, 111, '2015-04-01 00:03:31.000000', 'temperatura', 960.0000, 'ºC'),
	(133909, 111, '2015-04-01 00:03:32.000000', 'temperatura', 1092.0000, 'ºC'),
	(133910, 111, '2015-04-01 00:03:33.000000', 'temperatura', 181.0000, 'ºC'),
	(133911, 111, '2015-04-01 00:03:34.000000', 'temperatura', 29.0000, 'ºC'),
	(133912, 111, '2015-04-01 00:03:35.000000', 'temperatura', 801.0000, 'ºC'),
	(133913, 111, '2015-04-01 00:03:36.000000', 'temperatura', 318.0000, 'ºC'),
	(133914, 111, '2015-04-01 00:03:37.000000', 'temperatura', 390.0000, 'ºC'),
	(133915, 111, '2015-04-01 00:03:38.000000', 'temperatura', 997.0000, 'ºC'),
	(133916, 111, '2015-04-01 00:03:39.000000', 'temperatura', 216.0000, 'ºC'),
	(133917, 111, '2015-04-01 00:03:40.000000', 'temperatura', 489.0000, 'ºC'),
	(133918, 111, '2015-04-01 00:03:41.000000', 'temperatura', 598.0000, 'ºC'),
	(133919, 111, '2015-04-01 00:03:42.000000', 'temperatura', 324.0000, 'ºC'),
	(133920, 111, '2015-04-01 00:03:43.000000', 'temperatura', 1028.0000, 'ºC'),
	(133921, 111, '2015-04-01 00:03:44.000000', 'temperatura', 566.0000, 'ºC'),
	(133922, 111, '2015-04-01 00:03:45.000000', 'temperatura', 948.0000, 'ºC'),
	(133923, 111, '2015-04-01 00:03:46.000000', 'temperatura', 641.0000, 'ºC'),
	(133924, 111, '2015-04-01 00:03:47.000000', 'temperatura', 360.0000, 'ºC'),
	(133925, 111, '2015-04-01 00:03:48.000000', 'temperatura', 1080.0000, 'ºC'),
	(133926, 111, '2015-04-01 00:03:49.000000', 'temperatura', 720.0000, 'ºC'),
	(133927, 111, '2015-04-01 00:03:50.000000', 'temperatura', 359.0000, 'ºC'),
	(133928, 111, '2015-04-01 00:03:51.000000', 'temperatura', 834.0000, 'ºC'),
	(133929, 111, '2015-04-01 00:03:52.000000', 'temperatura', 697.0000, 'ºC'),
	(133930, 111, '2015-04-01 00:03:53.000000', 'temperatura', 982.0000, 'ºC'),
	(133931, 111, '2015-04-01 00:03:54.000000', 'temperatura', 421.0000, 'ºC'),
	(133932, 111, '2015-04-01 00:03:55.000000', 'temperatura', 360.0000, 'ºC'),
	(133933, 111, '2015-04-01 00:03:56.000000', 'temperatura', 538.0000, 'ºC'),
	(133934, 111, '2015-04-01 00:03:57.000000', 'temperatura', 408.0000, 'ºC'),
	(133935, 111, '2015-04-01 00:03:58.000000', 'temperatura', 430.0000, 'ºC'),
	(133936, 111, '2015-04-01 00:03:59.000000', 'temperatura', 923.0000, 'ºC'),
	(133937, 111, '2015-04-01 00:04:00.000000', 'temperatura', 925.0000, 'ºC'),
	(133938, 111, '2015-04-01 00:04:01.000000', 'temperatura', 658.0000, 'ºC'),
	(133939, 111, '2015-04-01 00:04:02.000000', 'temperatura', 517.0000, 'ºC'),
	(133940, 111, '2015-04-01 00:04:03.000000', 'temperatura', 609.0000, 'ºC'),
	(133941, 111, '2015-04-01 00:04:04.000000', 'temperatura', 297.0000, 'ºC'),
	(133942, 111, '2015-04-01 00:04:05.000000', 'temperatura', 857.0000, 'ºC'),
	(133943, 111, '2015-04-01 00:04:06.000000', 'temperatura', 995.0000, 'ºC'),
	(133944, 111, '2015-04-01 00:04:07.000000', 'temperatura', 6.0000, 'ºC'),
	(133945, 111, '2015-04-01 00:04:08.000000', 'temperatura', 643.0000, 'ºC'),
	(133946, 111, '2015-04-01 00:04:09.000000', 'temperatura', 799.0000, 'ºC'),
	(133947, 111, '2015-04-01 00:04:10.000000', 'temperatura', 865.0000, 'ºC'),
	(133948, 111, '2015-04-01 00:04:11.000000', 'temperatura', 730.0000, 'ºC'),
	(133949, 111, '2015-04-01 00:04:12.000000', 'temperatura', 1057.0000, 'ºC'),
	(133950, 111, '2015-04-01 00:04:13.000000', 'temperatura', 693.0000, 'ºC'),
	(133951, 111, '2015-04-01 00:04:14.000000', 'temperatura', 295.0000, 'ºC'),
	(133952, 111, '2015-04-01 00:04:15.000000', 'temperatura', 598.0000, 'ºC'),
	(133953, 111, '2015-04-01 00:04:16.000000', 'temperatura', 906.0000, 'ºC'),
	(133954, 111, '2015-04-01 00:04:17.000000', 'temperatura', 335.0000, 'ºC'),
	(133955, 111, '2015-04-01 00:04:18.000000', 'temperatura', 157.0000, 'ºC'),
	(133956, 111, '2015-04-01 00:04:19.000000', 'temperatura', 982.0000, 'ºC'),
	(133957, 111, '2015-04-01 00:04:20.000000', 'temperatura', 839.0000, 'ºC'),
	(133958, 111, '2015-04-01 00:04:21.000000', 'temperatura', 48.0000, 'ºC'),
	(133959, 111, '2015-04-01 00:04:22.000000', 'temperatura', 124.0000, 'ºC'),
	(133960, 111, '2015-04-01 00:04:23.000000', 'temperatura', 478.0000, 'ºC'),
	(133961, 111, '2015-04-01 00:04:24.000000', 'temperatura', 816.0000, 'ºC'),
	(133962, 111, '2015-04-01 00:04:25.000000', 'temperatura', 248.0000, 'ºC'),
	(133963, 111, '2015-04-01 00:04:26.000000', 'temperatura', 1193.0000, 'ºC'),
	(133964, 111, '2015-04-01 00:04:27.000000', 'temperatura', 421.0000, 'ºC'),
	(133965, 111, '2015-04-01 00:04:28.000000', 'temperatura', 926.0000, 'ºC'),
	(133966, 111, '2015-04-01 00:04:29.000000', 'temperatura', 969.0000, 'ºC'),
	(133967, 111, '2015-04-01 00:04:30.000000', 'temperatura', 868.0000, 'ºC'),
	(133968, 111, '2015-04-01 00:04:31.000000', 'temperatura', 234.0000, 'ºC'),
	(133969, 111, '2015-04-01 00:04:32.000000', 'temperatura', 965.0000, 'ºC'),
	(133970, 111, '2015-04-01 00:04:33.000000', 'temperatura', 523.0000, 'ºC'),
	(133971, 111, '2015-04-01 00:04:34.000000', 'temperatura', 921.0000, 'ºC'),
	(133972, 111, '2015-04-01 00:04:35.000000', 'temperatura', 635.0000, 'ºC'),
	(133973, 111, '2015-04-01 00:04:36.000000', 'temperatura', 413.0000, 'ºC'),
	(133974, 111, '2015-04-01 00:04:37.000000', 'temperatura', 160.0000, 'ºC'),
	(133975, 111, '2015-04-01 00:04:38.000000', 'temperatura', 762.0000, 'ºC'),
	(133976, 111, '2015-04-01 00:04:39.000000', 'temperatura', 931.0000, 'ºC'),
	(133977, 111, '2015-04-01 00:04:40.000000', 'temperatura', 1169.0000, 'ºC'),
	(133978, 111, '2015-04-01 00:04:41.000000', 'temperatura', 654.0000, 'ºC'),
	(133979, 111, '2015-04-01 00:04:42.000000', 'temperatura', 964.0000, 'ºC'),
	(133980, 111, '2015-04-01 00:04:43.000000', 'temperatura', 457.0000, 'ºC'),
	(133981, 111, '2015-04-01 00:04:44.000000', 'temperatura', 594.0000, 'ºC'),
	(133982, 111, '2015-04-01 00:04:45.000000', 'temperatura', 397.0000, 'ºC'),
	(133983, 111, '2015-04-01 00:04:46.000000', 'temperatura', 206.0000, 'ºC'),
	(133984, 111, '2015-04-01 00:04:47.000000', 'temperatura', 1040.0000, 'ºC'),
	(133985, 111, '2015-04-01 00:04:48.000000', 'temperatura', 984.0000, 'ºC'),
	(133986, 111, '2015-04-01 00:04:49.000000', 'temperatura', 597.0000, 'ºC'),
	(133987, 111, '2015-04-01 00:04:50.000000', 'temperatura', 35.0000, 'ºC'),
	(133988, 111, '2015-04-01 00:04:51.000000', 'temperatura', 782.0000, 'ºC'),
	(133989, 111, '2015-04-01 00:04:52.000000', 'temperatura', 209.0000, 'ºC'),
	(133990, 111, '2015-04-01 00:04:53.000000', 'temperatura', 1098.0000, 'ºC'),
	(133991, 111, '2015-04-01 00:04:54.000000', 'temperatura', 63.0000, 'ºC'),
	(133992, 111, '2015-04-01 00:04:55.000000', 'temperatura', 623.0000, 'ºC'),
	(133993, 111, '2015-04-01 00:04:56.000000', 'temperatura', 524.0000, 'ºC'),
	(133994, 111, '2015-04-01 00:04:57.000000', 'temperatura', 752.0000, 'ºC'),
	(133995, 111, '2015-04-01 00:04:58.000000', 'temperatura', 990.0000, 'ºC'),
	(133996, 111, '2015-04-01 00:04:59.000000', 'temperatura', 295.0000, 'ºC'),
	(133997, 111, '2015-04-01 00:05:00.000000', 'temperatura', 903.0000, 'ºC'),
	(133998, 111, '2015-04-01 00:05:01.000000', 'temperatura', 32.0000, 'ºC'),
	(133999, 111, '2015-04-01 00:05:02.000000', 'temperatura', 1053.0000, 'ºC'),
	(134000, 111, '2015-04-01 00:05:03.000000', 'temperatura', 368.0000, 'ºC'),
	(134001, 111, '2015-04-01 00:05:04.000000', 'temperatura', 1084.0000, 'ºC'),
	(134002, 111, '2015-04-01 00:05:05.000000', 'temperatura', 714.0000, 'ºC'),
	(134003, 111, '2015-04-01 00:05:06.000000', 'temperatura', 319.0000, 'ºC'),
	(134004, 111, '2015-04-01 00:05:07.000000', 'temperatura', 653.0000, 'ºC'),
	(134005, 111, '2015-04-01 00:05:08.000000', 'temperatura', 1108.0000, 'ºC'),
	(134006, 111, '2015-04-01 00:05:09.000000', 'temperatura', 1182.0000, 'ºC'),
	(134007, 111, '2015-04-01 00:05:10.000000', 'temperatura', 188.0000, 'ºC'),
	(134008, 111, '2015-04-01 00:05:11.000000', 'temperatura', 994.0000, 'ºC'),
	(134009, 111, '2015-04-01 00:05:12.000000', 'temperatura', 807.0000, 'ºC'),
	(134010, 111, '2015-04-01 00:05:13.000000', 'temperatura', 1052.0000, 'ºC'),
	(134011, 111, '2015-04-01 00:05:14.000000', 'temperatura', 442.0000, 'ºC'),
	(134012, 111, '2015-04-01 00:05:15.000000', 'temperatura', 254.0000, 'ºC'),
	(134013, 111, '2015-04-01 00:05:16.000000', 'temperatura', 1145.0000, 'ºC'),
	(134014, 111, '2015-04-01 00:05:17.000000', 'temperatura', 163.0000, 'ºC'),
	(134015, 111, '2015-04-01 00:05:18.000000', 'temperatura', 982.0000, 'ºC'),
	(134016, 111, '2015-04-01 00:05:19.000000', 'temperatura', 819.0000, 'ºC'),
	(134017, 111, '2015-04-01 00:05:20.000000', 'temperatura', 1152.0000, 'ºC'),
	(134018, 111, '2015-04-01 00:05:21.000000', 'temperatura', 903.0000, 'ºC'),
	(134019, 111, '2015-04-01 00:05:22.000000', 'temperatura', 1059.0000, 'ºC'),
	(134020, 111, '2015-04-01 00:05:23.000000', 'temperatura', 185.0000, 'ºC'),
	(134021, 111, '2015-04-01 00:05:24.000000', 'temperatura', 151.0000, 'ºC'),
	(134022, 111, '2015-04-01 00:05:25.000000', 'temperatura', 197.0000, 'ºC'),
	(134023, 111, '2015-04-01 00:05:26.000000', 'temperatura', 536.0000, 'ºC'),
	(134024, 111, '2015-04-01 00:05:27.000000', 'temperatura', 889.0000, 'ºC'),
	(134025, 111, '2015-04-01 00:05:28.000000', 'temperatura', 439.0000, 'ºC'),
	(134026, 111, '2015-04-01 00:05:29.000000', 'temperatura', 727.0000, 'ºC'),
	(134027, 111, '2015-04-01 00:05:30.000000', 'temperatura', 1119.0000, 'ºC'),
	(134028, 111, '2015-04-01 00:05:31.000000', 'temperatura', 1015.0000, 'ºC'),
	(134029, 111, '2015-04-01 00:05:32.000000', 'temperatura', 518.0000, 'ºC'),
	(134030, 111, '2015-04-01 00:05:33.000000', 'temperatura', 745.0000, 'ºC'),
	(134031, 111, '2015-04-01 00:05:34.000000', 'temperatura', 973.0000, 'ºC'),
	(134032, 111, '2015-04-01 00:05:35.000000', 'temperatura', 230.0000, 'ºC'),
	(134033, 111, '2015-04-01 00:05:36.000000', 'temperatura', 631.0000, 'ºC'),
	(134034, 111, '2015-04-01 00:05:37.000000', 'temperatura', 65.0000, 'ºC'),
	(134035, 111, '2015-04-01 00:05:38.000000', 'temperatura', 835.0000, 'ºC'),
	(134036, 111, '2015-04-01 00:05:39.000000', 'temperatura', 377.0000, 'ºC'),
	(134037, 111, '2015-04-01 00:05:40.000000', 'temperatura', 582.0000, 'ºC'),
	(134038, 111, '2015-04-01 00:05:41.000000', 'temperatura', 578.0000, 'ºC'),
	(134039, 111, '2015-04-01 00:05:42.000000', 'temperatura', 1147.0000, 'ºC'),
	(134040, 111, '2015-04-01 00:05:43.000000', 'temperatura', 402.0000, 'ºC'),
	(134041, 111, '2015-04-01 00:05:44.000000', 'temperatura', 966.0000, 'ºC'),
	(134042, 111, '2015-04-01 00:05:45.000000', 'temperatura', 28.0000, 'ºC'),
	(134043, 111, '2015-04-01 00:05:46.000000', 'temperatura', 841.0000, 'ºC'),
	(134044, 111, '2015-04-01 00:05:47.000000', 'temperatura', 524.0000, 'ºC'),
	(134045, 111, '2015-04-01 00:05:48.000000', 'temperatura', 94.0000, 'ºC'),
	(134046, 111, '2015-04-01 00:05:49.000000', 'temperatura', 102.0000, 'ºC'),
	(134047, 111, '2015-04-01 00:05:50.000000', 'temperatura', 225.0000, 'ºC'),
	(134048, 111, '2015-04-01 00:05:51.000000', 'temperatura', 822.0000, 'ºC'),
	(134049, 111, '2015-04-01 00:05:52.000000', 'temperatura', 1037.0000, 'ºC'),
	(134050, 111, '2015-04-01 00:05:53.000000', 'temperatura', 316.0000, 'ºC'),
	(134051, 111, '2015-04-01 00:05:54.000000', 'temperatura', 872.0000, 'ºC'),
	(134052, 111, '2015-04-01 00:05:55.000000', 'temperatura', 1013.0000, 'ºC'),
	(134053, 111, '2015-04-01 00:05:56.000000', 'temperatura', 49.0000, 'ºC'),
	(134054, 111, '2015-04-01 00:05:57.000000', 'temperatura', 808.0000, 'ºC'),
	(134055, 111, '2015-04-01 00:05:58.000000', 'temperatura', 291.0000, 'ºC'),
	(134056, 111, '2015-04-01 00:05:59.000000', 'temperatura', 233.0000, 'ºC'),
	(134057, 111, '2015-04-01 00:06:00.000000', 'temperatura', 294.0000, 'ºC'),
	(134058, 111, '2015-04-01 00:06:01.000000', 'temperatura', 770.0000, 'ºC'),
	(134059, 111, '2015-04-01 00:06:02.000000', 'temperatura', 567.0000, 'ºC'),
	(134060, 111, '2015-04-01 00:06:03.000000', 'temperatura', 527.0000, 'ºC'),
	(134061, 111, '2015-04-01 00:06:04.000000', 'temperatura', 935.0000, 'ºC'),
	(134062, 111, '2015-04-01 00:06:05.000000', 'temperatura', 695.0000, 'ºC'),
	(134063, 111, '2015-04-01 00:06:06.000000', 'temperatura', 668.0000, 'ºC'),
	(134064, 111, '2015-04-01 00:06:07.000000', 'temperatura', 56.0000, 'ºC'),
	(134065, 111, '2015-04-01 00:06:08.000000', 'temperatura', 676.0000, 'ºC'),
	(134066, 111, '2015-04-01 00:06:09.000000', 'temperatura', 812.0000, 'ºC'),
	(134067, 111, '2015-04-01 00:06:10.000000', 'temperatura', 833.0000, 'ºC'),
	(134068, 111, '2015-04-01 00:06:11.000000', 'temperatura', 531.0000, 'ºC'),
	(134069, 111, '2015-04-01 00:06:12.000000', 'temperatura', 155.0000, 'ºC'),
	(134070, 111, '2015-04-01 00:06:13.000000', 'temperatura', 382.0000, 'ºC'),
	(134071, 111, '2015-04-01 00:06:14.000000', 'temperatura', 247.0000, 'ºC'),
	(134072, 111, '2015-04-01 00:06:15.000000', 'temperatura', 89.0000, 'ºC'),
	(134073, 111, '2015-04-01 00:06:16.000000', 'temperatura', 904.0000, 'ºC'),
	(134074, 111, '2015-04-01 00:06:17.000000', 'temperatura', 653.0000, 'ºC'),
	(134075, 111, '2015-04-01 00:06:18.000000', 'temperatura', 555.0000, 'ºC'),
	(134076, 111, '2015-04-01 00:06:19.000000', 'temperatura', 814.0000, 'ºC'),
	(134077, 111, '2015-04-01 00:06:20.000000', 'temperatura', 8.0000, 'ºC'),
	(134078, 111, '2015-04-01 00:06:21.000000', 'temperatura', 1197.0000, 'ºC'),
	(134079, 111, '2015-04-01 00:06:22.000000', 'temperatura', 1160.0000, 'ºC'),
	(134080, 111, '2015-04-01 00:06:23.000000', 'temperatura', 1011.0000, 'ºC'),
	(134081, 111, '2015-04-01 00:06:24.000000', 'temperatura', 374.0000, 'ºC'),
	(134082, 111, '2015-04-01 00:06:25.000000', 'temperatura', 38.0000, 'ºC'),
	(134083, 111, '2015-04-01 00:06:26.000000', 'temperatura', 268.0000, 'ºC'),
	(134084, 111, '2015-04-01 00:06:27.000000', 'temperatura', 28.0000, 'ºC'),
	(134085, 111, '2015-04-01 00:06:28.000000', 'temperatura', 535.0000, 'ºC'),
	(134086, 111, '2015-04-01 00:06:29.000000', 'temperatura', 191.0000, 'ºC'),
	(134087, 111, '2015-04-01 00:06:30.000000', 'temperatura', 550.0000, 'ºC'),
	(134088, 111, '2015-04-01 00:06:31.000000', 'temperatura', 977.0000, 'ºC'),
	(134089, 111, '2015-04-01 00:06:32.000000', 'temperatura', 836.0000, 'ºC'),
	(134090, 111, '2015-04-01 00:06:33.000000', 'temperatura', 51.0000, 'ºC'),
	(134091, 111, '2015-04-01 00:06:34.000000', 'temperatura', 147.0000, 'ºC'),
	(134092, 111, '2015-04-01 00:06:35.000000', 'temperatura', 584.0000, 'ºC'),
	(134093, 111, '2015-04-01 00:06:36.000000', 'temperatura', 80.0000, 'ºC'),
	(134094, 111, '2015-04-01 00:06:37.000000', 'temperatura', 1047.0000, 'ºC'),
	(134095, 111, '2015-04-01 00:06:38.000000', 'temperatura', 194.0000, 'ºC'),
	(134096, 111, '2015-04-01 00:06:39.000000', 'temperatura', 233.0000, 'ºC'),
	(134097, 111, '2015-04-01 00:06:40.000000', 'temperatura', 580.0000, 'ºC'),
	(134098, 111, '2015-04-01 00:06:41.000000', 'temperatura', 1005.0000, 'ºC'),
	(134099, 111, '2015-04-01 00:06:42.000000', 'temperatura', 883.0000, 'ºC'),
	(134100, 111, '2015-04-01 00:06:43.000000', 'temperatura', 201.0000, 'ºC'),
	(134101, 111, '2015-04-01 00:06:44.000000', 'temperatura', 756.0000, 'ºC'),
	(134102, 111, '2015-04-01 00:06:45.000000', 'temperatura', 777.0000, 'ºC'),
	(134103, 111, '2015-04-01 00:06:46.000000', 'temperatura', 420.0000, 'ºC'),
	(134104, 111, '2015-04-01 00:06:47.000000', 'temperatura', 968.0000, 'ºC'),
	(134105, 111, '2015-04-01 00:06:48.000000', 'temperatura', 1181.0000, 'ºC'),
	(134106, 111, '2015-04-01 00:06:49.000000', 'temperatura', 601.0000, 'ºC'),
	(134107, 111, '2015-04-01 00:06:50.000000', 'temperatura', 664.0000, 'ºC'),
	(134108, 111, '2015-04-01 00:06:51.000000', 'temperatura', 318.0000, 'ºC'),
	(134109, 111, '2015-04-01 00:06:52.000000', 'temperatura', 797.0000, 'ºC'),
	(134110, 111, '2015-04-01 00:06:53.000000', 'temperatura', 631.0000, 'ºC'),
	(134111, 111, '2015-04-01 00:06:54.000000', 'temperatura', 766.0000, 'ºC'),
	(134112, 111, '2015-04-01 00:06:55.000000', 'temperatura', 739.0000, 'ºC'),
	(134113, 111, '2015-04-01 00:06:56.000000', 'temperatura', 195.0000, 'ºC'),
	(134114, 111, '2015-04-01 00:06:57.000000', 'temperatura', 1159.0000, 'ºC'),
	(134115, 111, '2015-04-01 00:06:58.000000', 'temperatura', 411.0000, 'ºC'),
	(134116, 111, '2015-04-01 00:06:59.000000', 'temperatura', 980.0000, 'ºC'),
	(134117, 111, '2015-04-01 00:07:00.000000', 'temperatura', 64.0000, 'ºC'),
	(134118, 111, '2015-04-01 00:07:01.000000', 'temperatura', 983.0000, 'ºC'),
	(134119, 111, '2015-04-01 00:07:02.000000', 'temperatura', 1124.0000, 'ºC'),
	(134120, 111, '2015-04-01 00:07:03.000000', 'temperatura', 271.0000, 'ºC'),
	(134121, 111, '2015-04-01 00:07:04.000000', 'temperatura', 383.0000, 'ºC'),
	(134122, 111, '2015-04-01 00:07:05.000000', 'temperatura', 1103.0000, 'ºC'),
	(134123, 111, '2015-04-01 00:07:06.000000', 'temperatura', 766.0000, 'ºC'),
	(134124, 111, '2015-04-01 00:07:07.000000', 'temperatura', 521.0000, 'ºC'),
	(134125, 111, '2015-04-01 00:07:08.000000', 'temperatura', 307.0000, 'ºC'),
	(134126, 111, '2015-04-01 00:07:09.000000', 'temperatura', 1174.0000, 'ºC'),
	(134127, 111, '2015-04-01 00:07:10.000000', 'temperatura', 148.0000, 'ºC'),
	(134128, 111, '2015-04-01 00:07:11.000000', 'temperatura', 820.0000, 'ºC'),
	(134129, 111, '2015-04-01 00:07:12.000000', 'temperatura', 56.0000, 'ºC'),
	(134130, 111, '2015-04-01 00:07:13.000000', 'temperatura', 222.0000, 'ºC'),
	(134131, 111, '2015-04-01 00:07:14.000000', 'temperatura', 942.0000, 'ºC'),
	(134132, 111, '2015-04-01 00:07:15.000000', 'temperatura', 443.0000, 'ºC'),
	(134133, 111, '2015-04-01 00:07:16.000000', 'temperatura', 590.0000, 'ºC'),
	(134134, 111, '2015-04-01 00:07:17.000000', 'temperatura', 423.0000, 'ºC'),
	(134135, 111, '2015-04-01 00:07:18.000000', 'temperatura', 343.0000, 'ºC'),
	(134136, 111, '2015-04-01 00:07:19.000000', 'temperatura', 449.0000, 'ºC'),
	(134137, 111, '2015-04-01 00:07:20.000000', 'temperatura', 14.0000, 'ºC'),
	(134138, 111, '2015-04-01 00:07:21.000000', 'temperatura', 1124.0000, 'ºC'),
	(134139, 111, '2015-04-01 00:07:22.000000', 'temperatura', 777.0000, 'ºC'),
	(134140, 111, '2015-04-01 00:07:23.000000', 'temperatura', 516.0000, 'ºC'),
	(134141, 111, '2015-04-01 00:07:24.000000', 'temperatura', 251.0000, 'ºC'),
	(134142, 111, '2015-04-01 00:07:25.000000', 'temperatura', 905.0000, 'ºC'),
	(134143, 111, '2015-04-01 00:07:26.000000', 'temperatura', 173.0000, 'ºC'),
	(134144, 111, '2015-04-01 00:07:27.000000', 'temperatura', 550.0000, 'ºC'),
	(134145, 111, '2015-04-01 00:07:28.000000', 'temperatura', 1031.0000, 'ºC'),
	(134146, 111, '2015-04-01 00:07:29.000000', 'temperatura', 1106.0000, 'ºC'),
	(134147, 111, '2015-04-01 00:07:30.000000', 'temperatura', 36.0000, 'ºC'),
	(134148, 111, '2015-04-01 00:07:31.000000', 'temperatura', 463.0000, 'ºC'),
	(134149, 111, '2015-04-01 00:07:32.000000', 'temperatura', 1007.0000, 'ºC'),
	(134150, 111, '2015-04-01 00:07:33.000000', 'temperatura', 48.0000, 'ºC'),
	(134151, 111, '2015-04-01 00:07:34.000000', 'temperatura', 819.0000, 'ºC'),
	(134152, 111, '2015-04-01 00:07:35.000000', 'temperatura', 352.0000, 'ºC'),
	(134153, 111, '2015-04-01 00:07:36.000000', 'temperatura', 504.0000, 'ºC'),
	(134154, 111, '2015-04-01 00:07:37.000000', 'temperatura', 264.0000, 'ºC'),
	(134155, 111, '2015-04-01 00:07:38.000000', 'temperatura', 1009.0000, 'ºC'),
	(134156, 111, '2015-04-01 00:07:39.000000', 'temperatura', 654.0000, 'ºC'),
	(134157, 111, '2015-04-01 00:07:40.000000', 'temperatura', 241.0000, 'ºC'),
	(134158, 111, '2015-04-01 00:07:41.000000', 'temperatura', 446.0000, 'ºC'),
	(134159, 111, '2015-04-01 00:07:42.000000', 'temperatura', 306.0000, 'ºC'),
	(134160, 111, '2015-04-01 00:07:43.000000', 'temperatura', 194.0000, 'ºC'),
	(134161, 111, '2015-04-01 00:07:44.000000', 'temperatura', 51.0000, 'ºC'),
	(134162, 111, '2015-04-01 00:07:45.000000', 'temperatura', 872.0000, 'ºC'),
	(134163, 111, '2015-04-01 00:07:46.000000', 'temperatura', 609.0000, 'ºC'),
	(134164, 111, '2015-04-01 00:07:47.000000', 'temperatura', 430.0000, 'ºC'),
	(134165, 111, '2015-04-01 00:07:48.000000', 'temperatura', 324.0000, 'ºC'),
	(134166, 111, '2015-04-01 00:07:49.000000', 'temperatura', 329.0000, 'ºC'),
	(134167, 111, '2015-04-01 00:07:50.000000', 'temperatura', 673.0000, 'ºC'),
	(134168, 111, '2015-04-01 00:07:51.000000', 'temperatura', 1178.0000, 'ºC'),
	(134169, 111, '2015-04-01 00:07:52.000000', 'temperatura', 274.0000, 'ºC'),
	(134170, 111, '2015-04-01 00:07:53.000000', 'temperatura', 235.0000, 'ºC'),
	(134171, 111, '2015-04-01 00:07:54.000000', 'temperatura', 353.0000, 'ºC'),
	(134172, 111, '2015-04-01 00:07:55.000000', 'temperatura', 1062.0000, 'ºC'),
	(134173, 111, '2015-04-01 00:07:56.000000', 'temperatura', 652.0000, 'ºC'),
	(134174, 111, '2015-04-01 00:07:57.000000', 'temperatura', 75.0000, 'ºC'),
	(134175, 111, '2015-04-01 00:07:58.000000', 'temperatura', 818.0000, 'ºC'),
	(134176, 111, '2015-04-01 00:07:59.000000', 'temperatura', 264.0000, 'ºC'),
	(134177, 111, '2015-04-01 00:08:00.000000', 'temperatura', 67.0000, 'ºC'),
	(134178, 111, '2015-04-01 00:08:01.000000', 'temperatura', 745.0000, 'ºC'),
	(134179, 111, '2015-04-01 00:08:02.000000', 'temperatura', 1122.0000, 'ºC'),
	(134180, 111, '2015-04-01 00:08:03.000000', 'temperatura', 978.0000, 'ºC'),
	(134181, 111, '2015-04-01 00:08:04.000000', 'temperatura', 322.0000, 'ºC'),
	(134182, 111, '2015-04-01 00:08:05.000000', 'temperatura', 1079.0000, 'ºC'),
	(134183, 111, '2015-04-01 00:08:06.000000', 'temperatura', 827.0000, 'ºC'),
	(134184, 111, '2015-04-01 00:08:07.000000', 'temperatura', 901.0000, 'ºC'),
	(134185, 111, '2015-04-01 00:08:08.000000', 'temperatura', 823.0000, 'ºC'),
	(134186, 111, '2015-04-01 00:08:09.000000', 'temperatura', 212.0000, 'ºC'),
	(134187, 111, '2015-04-01 00:08:10.000000', 'temperatura', 991.0000, 'ºC'),
	(134188, 111, '2015-04-01 00:08:11.000000', 'temperatura', 720.0000, 'ºC'),
	(134189, 111, '2015-04-01 00:08:12.000000', 'temperatura', 628.0000, 'ºC'),
	(134190, 111, '2015-04-01 00:08:13.000000', 'temperatura', 982.0000, 'ºC'),
	(134191, 111, '2015-04-01 00:08:14.000000', 'temperatura', 624.0000, 'ºC'),
	(134192, 111, '2015-04-01 00:08:15.000000', 'temperatura', 176.0000, 'ºC'),
	(134193, 111, '2015-04-01 00:08:16.000000', 'temperatura', 210.0000, 'ºC'),
	(134194, 111, '2015-04-01 00:08:17.000000', 'temperatura', 522.0000, 'ºC'),
	(134195, 111, '2015-04-01 00:08:18.000000', 'temperatura', 780.0000, 'ºC'),
	(134196, 111, '2015-04-01 00:08:19.000000', 'temperatura', 1135.0000, 'ºC'),
	(134197, 111, '2015-04-01 00:08:20.000000', 'temperatura', 934.0000, 'ºC'),
	(134198, 111, '2015-04-01 00:08:21.000000', 'temperatura', 66.0000, 'ºC'),
	(134199, 111, '2015-04-01 00:08:22.000000', 'temperatura', 1129.0000, 'ºC'),
	(134200, 111, '2015-04-01 00:08:23.000000', 'temperatura', 646.0000, 'ºC'),
	(134201, 111, '2015-04-01 00:08:24.000000', 'temperatura', 1045.0000, 'ºC'),
	(134202, 111, '2015-04-01 00:08:25.000000', 'temperatura', 886.0000, 'ºC'),
	(134203, 111, '2015-04-01 00:08:26.000000', 'temperatura', 96.0000, 'ºC'),
	(134204, 111, '2015-04-01 00:08:27.000000', 'temperatura', 223.0000, 'ºC'),
	(134205, 111, '2015-04-01 00:08:28.000000', 'temperatura', 828.0000, 'ºC'),
	(134206, 111, '2015-04-01 00:08:29.000000', 'temperatura', 1071.0000, 'ºC'),
	(134207, 111, '2015-04-01 00:08:30.000000', 'temperatura', 471.0000, 'ºC'),
	(134208, 111, '2015-04-01 00:08:31.000000', 'temperatura', 343.0000, 'ºC'),
	(134209, 111, '2015-04-01 00:08:32.000000', 'temperatura', 304.0000, 'ºC'),
	(134210, 111, '2015-04-01 00:08:33.000000', 'temperatura', 490.0000, 'ºC'),
	(134211, 111, '2015-04-01 00:08:34.000000', 'temperatura', 339.0000, 'ºC'),
	(134212, 111, '2015-04-01 00:08:35.000000', 'temperatura', 225.0000, 'ºC'),
	(134213, 111, '2015-04-01 00:08:36.000000', 'temperatura', 109.0000, 'ºC'),
	(134214, 111, '2015-04-01 00:08:37.000000', 'temperatura', 1068.0000, 'ºC'),
	(134215, 111, '2015-04-01 00:08:38.000000', 'temperatura', 217.0000, 'ºC'),
	(134216, 111, '2015-04-01 00:08:39.000000', 'temperatura', 278.0000, 'ºC'),
	(134217, 111, '2015-04-01 00:08:40.000000', 'temperatura', 743.0000, 'ºC'),
	(134218, 111, '2015-04-01 00:08:41.000000', 'temperatura', 480.0000, 'ºC'),
	(134219, 111, '2015-04-01 00:08:42.000000', 'temperatura', 170.0000, 'ºC'),
	(134220, 111, '2015-04-01 00:08:43.000000', 'temperatura', 612.0000, 'ºC'),
	(134221, 111, '2015-04-01 00:08:44.000000', 'temperatura', 150.0000, 'ºC'),
	(134222, 111, '2015-04-01 00:08:45.000000', 'temperatura', 116.0000, 'ºC'),
	(134223, 111, '2015-04-01 00:08:46.000000', 'temperatura', 129.0000, 'ºC'),
	(134224, 111, '2015-04-01 00:08:47.000000', 'temperatura', 296.0000, 'ºC'),
	(134225, 111, '2015-04-01 00:08:48.000000', 'temperatura', 1096.0000, 'ºC'),
	(134226, 111, '2015-04-01 00:08:49.000000', 'temperatura', 993.0000, 'ºC'),
	(134227, 111, '2015-04-01 00:08:50.000000', 'temperatura', 475.0000, 'ºC'),
	(134228, 111, '2015-04-01 00:08:51.000000', 'temperatura', 596.0000, 'ºC'),
	(134229, 111, '2015-04-01 00:08:52.000000', 'temperatura', 356.0000, 'ºC'),
	(134230, 111, '2015-04-01 00:08:53.000000', 'temperatura', 1193.0000, 'ºC'),
	(134231, 111, '2015-04-01 00:08:54.000000', 'temperatura', 99.0000, 'ºC'),
	(134232, 111, '2015-04-01 00:08:55.000000', 'temperatura', 514.0000, 'ºC'),
	(134233, 111, '2015-04-01 00:08:56.000000', 'temperatura', 1076.0000, 'ºC'),
	(134234, 111, '2015-04-01 00:08:57.000000', 'temperatura', 239.0000, 'ºC'),
	(134235, 111, '2015-04-01 00:08:58.000000', 'temperatura', 367.0000, 'ºC'),
	(134236, 111, '2015-04-01 00:08:59.000000', 'temperatura', 1119.0000, 'ºC'),
	(134237, 111, '2015-04-01 00:09:00.000000', 'temperatura', 895.0000, 'ºC'),
	(134238, 111, '2015-04-01 00:09:01.000000', 'temperatura', 1117.0000, 'ºC'),
	(134239, 111, '2015-04-01 00:09:02.000000', 'temperatura', 499.0000, 'ºC'),
	(134240, 111, '2015-04-01 00:09:03.000000', 'temperatura', 346.0000, 'ºC'),
	(134241, 111, '2015-04-01 00:09:04.000000', 'temperatura', 232.0000, 'ºC'),
	(134242, 111, '2015-04-01 00:09:05.000000', 'temperatura', 122.0000, 'ºC'),
	(134243, 111, '2015-04-01 00:09:06.000000', 'temperatura', 1116.0000, 'ºC'),
	(134244, 111, '2015-04-01 00:09:07.000000', 'temperatura', 415.0000, 'ºC'),
	(134245, 111, '2015-04-01 00:09:08.000000', 'temperatura', 1126.0000, 'ºC'),
	(134246, 111, '2015-04-01 00:09:09.000000', 'temperatura', 787.0000, 'ºC'),
	(134247, 111, '2015-04-01 00:09:10.000000', 'temperatura', 557.0000, 'ºC'),
	(134248, 111, '2015-04-01 00:09:11.000000', 'temperatura', 424.0000, 'ºC'),
	(134249, 111, '2015-04-01 00:09:12.000000', 'temperatura', 452.0000, 'ºC'),
	(134250, 111, '2015-04-01 00:09:13.000000', 'temperatura', 986.0000, 'ºC'),
	(134251, 111, '2015-04-01 00:09:14.000000', 'temperatura', 1176.0000, 'ºC'),
	(134252, 111, '2015-04-01 00:09:15.000000', 'temperatura', 522.0000, 'ºC'),
	(134253, 111, '2015-04-01 00:09:16.000000', 'temperatura', 283.0000, 'ºC'),
	(134254, 111, '2015-04-01 00:09:17.000000', 'temperatura', 1049.0000, 'ºC'),
	(134255, 111, '2015-04-01 00:09:18.000000', 'temperatura', 796.0000, 'ºC'),
	(134256, 111, '2015-04-01 00:09:19.000000', 'temperatura', 833.0000, 'ºC'),
	(134257, 111, '2015-04-01 00:09:20.000000', 'temperatura', 576.0000, 'ºC'),
	(134258, 111, '2015-04-01 00:09:21.000000', 'temperatura', 385.0000, 'ºC'),
	(134259, 111, '2015-04-01 00:09:22.000000', 'temperatura', 196.0000, 'ºC'),
	(134260, 111, '2015-04-01 00:09:23.000000', 'temperatura', 1024.0000, 'ºC'),
	(134261, 111, '2015-04-01 00:09:24.000000', 'temperatura', 934.0000, 'ºC'),
	(134262, 111, '2015-04-01 00:09:25.000000', 'temperatura', 399.0000, 'ºC'),
	(134263, 111, '2015-04-01 00:09:26.000000', 'temperatura', 395.0000, 'ºC'),
	(134264, 111, '2015-04-01 00:09:27.000000', 'temperatura', 776.0000, 'ºC'),
	(134265, 111, '2015-04-01 00:09:28.000000', 'temperatura', 295.0000, 'ºC'),
	(134266, 111, '2015-04-01 00:09:29.000000', 'temperatura', 350.0000, 'ºC'),
	(134267, 111, '2015-04-01 00:09:30.000000', 'temperatura', 864.0000, 'ºC'),
	(134268, 111, '2015-04-01 00:09:31.000000', 'temperatura', 871.0000, 'ºC'),
	(134269, 111, '2015-04-01 00:09:32.000000', 'temperatura', 563.0000, 'ºC'),
	(134270, 111, '2015-04-01 00:09:33.000000', 'temperatura', 202.0000, 'ºC'),
	(134271, 111, '2015-04-01 00:09:34.000000', 'temperatura', 520.0000, 'ºC'),
	(134272, 111, '2015-04-01 00:09:35.000000', 'temperatura', 795.0000, 'ºC'),
	(134273, 111, '2015-04-01 00:09:36.000000', 'temperatura', 17.0000, 'ºC'),
	(134274, 111, '2015-04-01 00:09:37.000000', 'temperatura', 102.0000, 'ºC'),
	(134275, 111, '2015-04-01 00:09:38.000000', 'temperatura', 458.0000, 'ºC'),
	(134276, 111, '2015-04-01 00:09:39.000000', 'temperatura', 785.0000, 'ºC'),
	(134277, 111, '2015-04-01 00:09:40.000000', 'temperatura', 152.0000, 'ºC'),
	(134278, 111, '2015-04-01 00:09:41.000000', 'temperatura', 807.0000, 'ºC'),
	(134279, 111, '2015-04-01 00:09:42.000000', 'temperatura', 1178.0000, 'ºC'),
	(134280, 111, '2015-04-01 00:09:43.000000', 'temperatura', 1068.0000, 'ºC'),
	(134281, 111, '2015-04-01 00:09:44.000000', 'temperatura', 610.0000, 'ºC'),
	(134282, 111, '2015-04-01 00:09:45.000000', 'temperatura', 1043.0000, 'ºC'),
	(134283, 111, '2015-04-01 00:09:46.000000', 'temperatura', 987.0000, 'ºC'),
	(134284, 111, '2015-04-01 00:09:47.000000', 'temperatura', 606.0000, 'ºC'),
	(134285, 111, '2015-04-01 00:09:48.000000', 'temperatura', 68.0000, 'ºC'),
	(134286, 111, '2015-04-01 00:09:49.000000', 'temperatura', 923.0000, 'ºC'),
	(134287, 111, '2015-04-01 00:09:50.000000', 'temperatura', 813.0000, 'ºC'),
	(134288, 111, '2015-04-01 00:09:51.000000', 'temperatura', 96.0000, 'ºC'),
	(134289, 111, '2015-04-01 00:09:52.000000', 'temperatura', 442.0000, 'ºC'),
	(134290, 111, '2015-04-01 00:09:53.000000', 'temperatura', 722.0000, 'ºC'),
	(134291, 111, '2015-04-01 00:09:54.000000', 'temperatura', 1084.0000, 'ºC'),
	(134292, 111, '2015-04-01 00:09:55.000000', 'temperatura', 854.0000, 'ºC'),
	(134293, 111, '2015-04-01 00:09:56.000000', 'temperatura', 1018.0000, 'ºC'),
	(134294, 111, '2015-04-01 00:09:57.000000', 'temperatura', 130.0000, 'ºC'),
	(134295, 111, '2015-04-01 00:09:58.000000', 'temperatura', 1198.0000, 'ºC'),
	(134296, 111, '2015-04-01 00:09:59.000000', 'temperatura', 798.0000, 'ºC'),
	(134297, 111, '2015-04-01 00:10:00.000000', 'temperatura', 399.0000, 'ºC'),
	(134298, 111, '2015-04-01 00:10:01.000000', 'temperatura', 802.0000, 'ºC'),
	(134299, 111, '2015-04-01 00:10:02.000000', 'temperatura', 412.0000, 'ºC'),
	(134300, 111, '2015-04-01 00:10:03.000000', 'temperatura', 853.0000, 'ºC'),
	(134301, 111, '2015-04-01 00:10:04.000000', 'temperatura', 629.0000, 'ºC'),
	(134302, 111, '2015-04-01 00:10:05.000000', 'temperatura', 587.0000, 'ºC'),
	(134303, 111, '2015-04-01 00:10:06.000000', 'temperatura', 1051.0000, 'ºC'),
	(134304, 111, '2015-04-01 00:10:07.000000', 'temperatura', 1093.0000, 'ºC'),
	(134305, 111, '2015-04-01 00:10:08.000000', 'temperatura', 1113.0000, 'ºC'),
	(134306, 111, '2015-04-01 00:10:09.000000', 'temperatura', 1085.0000, 'ºC'),
	(134307, 111, '2015-04-01 00:10:10.000000', 'temperatura', 886.0000, 'ºC'),
	(134308, 111, '2015-04-01 00:10:11.000000', 'temperatura', 1175.0000, 'ºC'),
	(134309, 111, '2015-04-01 00:10:12.000000', 'temperatura', 821.0000, 'ºC'),
	(134310, 111, '2015-04-01 00:10:13.000000', 'temperatura', 577.0000, 'ºC'),
	(134311, 111, '2015-04-01 00:10:14.000000', 'temperatura', 423.0000, 'ºC'),
	(134312, 111, '2015-04-01 00:10:15.000000', 'temperatura', 383.0000, 'ºC'),
	(134313, 111, '2015-04-01 00:10:16.000000', 'temperatura', 648.0000, 'ºC'),
	(134314, 111, '2015-04-01 00:10:17.000000', 'temperatura', 893.0000, 'ºC'),
	(134315, 111, '2015-04-01 00:10:18.000000', 'temperatura', 121.0000, 'ºC'),
	(134316, 111, '2015-04-01 00:10:19.000000', 'temperatura', 327.0000, 'ºC'),
	(134317, 111, '2015-04-01 00:10:20.000000', 'temperatura', 73.0000, 'ºC'),
	(134318, 111, '2015-04-01 00:10:21.000000', 'temperatura', 585.0000, 'ºC'),
	(134319, 111, '2015-04-01 00:10:22.000000', 'temperatura', 304.0000, 'ºC'),
	(134320, 111, '2015-04-01 00:10:23.000000', 'temperatura', 967.0000, 'ºC'),
	(134321, 111, '2015-04-01 00:10:24.000000', 'temperatura', 323.0000, 'ºC'),
	(134322, 111, '2015-04-01 00:10:25.000000', 'temperatura', 1113.0000, 'ºC'),
	(134323, 111, '2015-04-01 00:10:26.000000', 'temperatura', 996.0000, 'ºC'),
	(134324, 111, '2015-04-01 00:10:27.000000', 'temperatura', 443.0000, 'ºC'),
	(134325, 111, '2015-04-01 00:10:28.000000', 'temperatura', 429.0000, 'ºC'),
	(134326, 111, '2015-04-01 00:10:29.000000', 'temperatura', 814.0000, 'ºC'),
	(134327, 111, '2015-04-01 00:10:30.000000', 'temperatura', 386.0000, 'ºC'),
	(134328, 111, '2015-04-01 00:10:31.000000', 'temperatura', 687.0000, 'ºC'),
	(134329, 111, '2015-04-01 00:10:32.000000', 'temperatura', 1080.0000, 'ºC'),
	(134330, 111, '2015-04-01 00:10:33.000000', 'temperatura', 936.0000, 'ºC'),
	(134331, 111, '2015-04-01 00:10:34.000000', 'temperatura', 243.0000, 'ºC'),
	(134332, 111, '2015-04-01 00:10:35.000000', 'temperatura', 809.0000, 'ºC'),
	(134333, 111, '2015-04-01 00:10:36.000000', 'temperatura', 914.0000, 'ºC'),
	(134334, 111, '2015-04-01 00:10:37.000000', 'temperatura', 942.0000, 'ºC'),
	(134335, 111, '2015-04-01 00:10:38.000000', 'temperatura', 772.0000, 'ºC'),
	(134336, 111, '2015-04-01 00:10:39.000000', 'temperatura', 1032.0000, 'ºC'),
	(134337, 111, '2015-04-01 00:10:40.000000', 'temperatura', 444.0000, 'ºC'),
	(134338, 111, '2015-04-01 00:10:41.000000', 'temperatura', 324.0000, 'ºC'),
	(134339, 111, '2015-04-01 00:10:42.000000', 'temperatura', 290.0000, 'ºC'),
	(134340, 111, '2015-04-01 00:10:43.000000', 'temperatura', 476.0000, 'ºC'),
	(134341, 111, '2015-04-01 00:10:44.000000', 'temperatura', 314.0000, 'ºC'),
	(134342, 111, '2015-04-01 00:10:45.000000', 'temperatura', 141.0000, 'ºC'),
	(134343, 111, '2015-04-01 00:10:46.000000', 'temperatura', 963.0000, 'ºC'),
	(134344, 111, '2015-04-01 00:10:47.000000', 'temperatura', 795.0000, 'ºC'),
	(134345, 111, '2015-04-01 00:10:48.000000', 'temperatura', 1083.0000, 'ºC'),
	(134346, 111, '2015-04-01 00:10:49.000000', 'temperatura', 632.0000, 'ºC'),
	(134347, 111, '2015-04-01 00:10:50.000000', 'temperatura', 1109.0000, 'ºC'),
	(134348, 111, '2015-04-01 00:10:51.000000', 'temperatura', 53.0000, 'ºC'),
	(134349, 111, '2015-04-01 00:10:52.000000', 'temperatura', 537.0000, 'ºC'),
	(134350, 111, '2015-04-01 00:10:53.000000', 'temperatura', 127.0000, 'ºC'),
	(134351, 111, '2015-04-01 00:10:54.000000', 'temperatura', 226.0000, 'ºC'),
	(134352, 111, '2015-04-01 00:10:55.000000', 'temperatura', 747.0000, 'ºC'),
	(134353, 111, '2015-04-01 00:10:56.000000', 'temperatura', 660.0000, 'ºC'),
	(134354, 111, '2015-04-01 00:10:57.000000', 'temperatura', 1057.0000, 'ºC'),
	(134355, 111, '2015-04-01 00:10:58.000000', 'temperatura', 907.0000, 'ºC'),
	(134356, 111, '2015-04-01 00:10:59.000000', 'temperatura', 165.0000, 'ºC'),
	(134357, 111, '2015-04-01 00:11:00.000000', 'temperatura', 506.0000, 'ºC'),
	(134358, 111, '2015-04-01 00:11:01.000000', 'temperatura', 833.0000, 'ºC'),
	(134359, 111, '2015-04-01 00:11:02.000000', 'temperatura', 249.0000, 'ºC'),
	(134360, 111, '2015-04-01 00:11:03.000000', 'temperatura', 1146.0000, 'ºC'),
	(134361, 111, '2015-04-01 00:11:04.000000', 'temperatura', 186.0000, 'ºC'),
	(134362, 111, '2015-04-01 00:11:05.000000', 'temperatura', 1089.0000, 'ºC'),
	(134363, 111, '2015-04-01 00:11:06.000000', 'temperatura', 88.0000, 'ºC'),
	(134364, 111, '2015-04-01 00:11:07.000000', 'temperatura', 775.0000, 'ºC'),
	(134365, 111, '2015-04-01 00:11:08.000000', 'temperatura', 11.0000, 'ºC'),
	(134366, 111, '2015-04-01 00:11:09.000000', 'temperatura', 131.0000, 'ºC'),
	(134367, 111, '2015-04-01 00:11:10.000000', 'temperatura', 621.0000, 'ºC'),
	(134368, 111, '2015-04-01 00:11:11.000000', 'temperatura', 313.0000, 'ºC'),
	(134369, 111, '2015-04-01 00:11:12.000000', 'temperatura', 901.0000, 'ºC'),
	(134370, 111, '2015-04-01 00:11:13.000000', 'temperatura', 1167.0000, 'ºC'),
	(134371, 111, '2015-04-01 00:11:14.000000', 'temperatura', 732.0000, 'ºC'),
	(134372, 111, '2015-04-01 00:11:15.000000', 'temperatura', 160.0000, 'ºC'),
	(134373, 111, '2015-04-01 00:11:16.000000', 'temperatura', 1004.0000, 'ºC'),
	(134374, 111, '2015-04-01 00:11:17.000000', 'temperatura', 940.0000, 'ºC'),
	(134375, 111, '2015-04-01 00:11:18.000000', 'temperatura', 488.0000, 'ºC'),
	(134376, 111, '2015-04-01 00:11:19.000000', 'temperatura', 821.0000, 'ºC'),
	(134377, 111, '2015-04-01 00:11:20.000000', 'temperatura', 242.0000, 'ºC'),
	(134378, 111, '2015-04-01 00:11:21.000000', 'temperatura', 1148.0000, 'ºC'),
	(134379, 111, '2015-04-01 00:11:22.000000', 'temperatura', 213.0000, 'ºC'),
	(134380, 111, '2015-04-01 00:11:23.000000', 'temperatura', 21.0000, 'ºC'),
	(134381, 111, '2015-04-01 00:11:24.000000', 'temperatura', 665.0000, 'ºC'),
	(134382, 111, '2015-04-01 00:11:25.000000', 'temperatura', 865.0000, 'ºC'),
	(134383, 111, '2015-04-01 00:11:26.000000', 'temperatura', 1131.0000, 'ºC'),
	(134384, 111, '2015-04-01 00:11:27.000000', 'temperatura', 660.0000, 'ºC'),
	(134385, 111, '2015-04-01 00:11:28.000000', 'temperatura', 1108.0000, 'ºC'),
	(134386, 111, '2015-04-01 00:11:29.000000', 'temperatura', 1159.0000, 'ºC'),
	(134387, 111, '2015-04-01 00:11:30.000000', 'temperatura', 72.0000, 'ºC'),
	(134388, 111, '2015-04-01 00:11:31.000000', 'temperatura', 483.0000, 'ºC'),
	(134389, 111, '2015-04-01 00:11:32.000000', 'temperatura', 1002.0000, 'ºC'),
	(134390, 111, '2015-04-01 00:11:33.000000', 'temperatura', 1160.0000, 'ºC'),
	(134391, 111, '2015-04-01 00:11:34.000000', 'temperatura', 397.0000, 'ºC'),
	(134392, 111, '2015-04-01 00:11:35.000000', 'temperatura', 902.0000, 'ºC'),
	(134393, 111, '2015-04-01 00:11:36.000000', 'temperatura', 921.0000, 'ºC'),
	(134394, 111, '2015-04-01 00:11:37.000000', 'temperatura', 700.0000, 'ºC'),
	(134395, 111, '2015-04-01 00:11:38.000000', 'temperatura', 738.0000, 'ºC'),
	(134396, 111, '2015-04-01 00:11:39.000000', 'temperatura', 389.0000, 'ºC'),
	(134397, 111, '2015-04-01 00:11:40.000000', 'temperatura', 931.0000, 'ºC'),
	(134398, 111, '2015-04-01 00:11:41.000000', 'temperatura', 1090.0000, 'ºC'),
	(134399, 111, '2015-04-01 00:11:42.000000', 'temperatura', 257.0000, 'ºC'),
	(134400, 111, '2015-04-01 00:11:43.000000', 'temperatura', 417.0000, 'ºC'),
	(134401, 111, '2015-04-01 00:11:44.000000', 'temperatura', 115.0000, 'ºC'),
	(134402, 111, '2015-04-01 00:11:45.000000', 'temperatura', 522.0000, 'ºC'),
	(134403, 111, '2015-04-01 00:11:46.000000', 'temperatura', 1066.0000, 'ºC'),
	(134404, 111, '2015-04-01 00:11:47.000000', 'temperatura', 166.0000, 'ºC'),
	(134405, 111, '2015-04-01 00:11:48.000000', 'temperatura', 34.0000, 'ºC'),
	(134406, 111, '2015-04-01 00:11:49.000000', 'temperatura', 870.0000, 'ºC'),
	(134407, 111, '2015-04-01 00:11:50.000000', 'temperatura', 650.0000, 'ºC'),
	(134408, 111, '2015-04-01 00:11:51.000000', 'temperatura', 640.0000, 'ºC'),
	(134409, 111, '2015-04-01 00:11:52.000000', 'temperatura', 49.0000, 'ºC'),
	(134410, 111, '2015-04-01 00:11:53.000000', 'temperatura', 725.0000, 'ºC'),
	(134411, 111, '2015-04-01 00:11:54.000000', 'temperatura', 1079.0000, 'ºC'),
	(134412, 111, '2015-04-01 00:11:55.000000', 'temperatura', 819.0000, 'ºC'),
	(134413, 111, '2015-04-01 00:11:56.000000', 'temperatura', 860.0000, 'ºC'),
	(134414, 111, '2015-04-01 00:11:57.000000', 'temperatura', 642.0000, 'ºC'),
	(134415, 111, '2015-04-01 00:11:58.000000', 'temperatura', 630.0000, 'ºC'),
	(134416, 111, '2015-04-01 00:11:59.000000', 'temperatura', 27.0000, 'ºC'),
	(134417, 111, '2015-04-01 00:12:00.000000', 'temperatura', 644.0000, 'ºC'),
	(134418, 111, '2015-04-01 00:12:01.000000', 'temperatura', 740.0000, 'ºC'),
	(134419, 111, '2015-04-01 00:12:02.000000', 'temperatura', 568.0000, 'ºC'),
	(134420, 111, '2015-04-01 00:12:03.000000', 'temperatura', 622.0000, 'ºC'),
	(134421, 111, '2015-04-01 00:12:04.000000', 'temperatura', 205.0000, 'ºC'),
	(134422, 111, '2015-04-01 00:12:05.000000', 'temperatura', 362.0000, 'ºC'),
	(134423, 111, '2015-04-01 00:12:06.000000', 'temperatura', 1193.0000, 'ºC'),
	(134424, 111, '2015-04-01 00:12:07.000000', 'temperatura', 80.0000, 'ºC'),
	(134425, 111, '2015-04-01 00:12:08.000000', 'temperatura', 423.0000, 'ºC'),
	(134426, 111, '2015-04-01 00:12:09.000000', 'temperatura', 677.0000, 'ºC'),
	(134427, 111, '2015-04-01 00:12:10.000000', 'temperatura', 914.0000, 'ºC'),
	(134428, 111, '2015-04-01 00:12:11.000000', 'temperatura', 138.0000, 'ºC'),
	(134429, 111, '2015-04-01 00:12:12.000000', 'temperatura', 352.0000, 'ºC'),
	(134430, 111, '2015-04-01 00:12:13.000000', 'temperatura', 143.0000, 'ºC'),
	(134431, 111, '2015-04-01 00:12:14.000000', 'temperatura', 861.0000, 'ºC'),
	(134432, 111, '2015-04-01 00:12:15.000000', 'temperatura', 275.0000, 'ºC'),
	(134433, 111, '2015-04-01 00:12:16.000000', 'temperatura', 1194.0000, 'ºC'),
	(134434, 111, '2015-04-01 00:12:17.000000', 'temperatura', 343.0000, 'ºC'),
	(134435, 111, '2015-04-01 00:12:18.000000', 'temperatura', 537.0000, 'ºC'),
	(134436, 111, '2015-04-01 00:12:19.000000', 'temperatura', 456.0000, 'ºC'),
	(134437, 111, '2015-04-01 00:12:20.000000', 'temperatura', 668.0000, 'ºC'),
	(134438, 111, '2015-04-01 00:12:21.000000', 'temperatura', 772.0000, 'ºC'),
	(134439, 111, '2015-04-01 00:12:22.000000', 'temperatura', 659.0000, 'ºC'),
	(134440, 111, '2015-04-01 00:12:23.000000', 'temperatura', 977.0000, 'ºC'),
	(134441, 111, '2015-04-01 00:12:24.000000', 'temperatura', 510.0000, 'ºC'),
	(134442, 111, '2015-04-01 00:12:25.000000', 'temperatura', 820.0000, 'ºC'),
	(134443, 111, '2015-04-01 00:12:26.000000', 'temperatura', 170.0000, 'ºC'),
	(134444, 111, '2015-04-01 00:12:27.000000', 'temperatura', 793.0000, 'ºC'),
	(134445, 111, '2015-04-01 00:12:28.000000', 'temperatura', 1052.0000, 'ºC'),
	(134446, 111, '2015-04-01 00:12:29.000000', 'temperatura', 481.0000, 'ºC'),
	(134447, 111, '2015-04-01 00:12:30.000000', 'temperatura', 452.0000, 'ºC'),
	(134448, 111, '2015-04-01 00:12:31.000000', 'temperatura', 817.0000, 'ºC'),
	(134449, 111, '2015-04-01 00:12:32.000000', 'temperatura', 330.0000, 'ºC'),
	(134450, 111, '2015-04-01 00:12:33.000000', 'temperatura', 400.0000, 'ºC'),
	(134451, 111, '2015-04-01 00:12:34.000000', 'temperatura', 1011.0000, 'ºC'),
	(134452, 111, '2015-04-01 00:12:35.000000', 'temperatura', 253.0000, 'ºC'),
	(134453, 111, '2015-04-01 00:12:36.000000', 'temperatura', 634.0000, 'ºC'),
	(134454, 111, '2015-04-01 00:12:37.000000', 'temperatura', 10.0000, 'ºC'),
	(134455, 111, '2015-04-01 00:12:38.000000', 'temperatura', 550.0000, 'ºC'),
	(134456, 111, '2015-04-01 00:12:39.000000', 'temperatura', 318.0000, 'ºC'),
	(134457, 111, '2015-04-01 00:12:40.000000', 'temperatura', 1142.0000, 'ºC'),
	(134458, 111, '2015-04-01 00:12:41.000000', 'temperatura', 1155.0000, 'ºC'),
	(134459, 111, '2015-04-01 00:12:42.000000', 'temperatura', 1151.0000, 'ºC'),
	(134460, 111, '2015-04-01 00:12:43.000000', 'temperatura', 1092.0000, 'ºC'),
	(134461, 111, '2015-04-01 00:12:44.000000', 'temperatura', 805.0000, 'ºC'),
	(134462, 111, '2015-04-01 00:12:45.000000', 'temperatura', 749.0000, 'ºC'),
	(134463, 111, '2015-04-01 00:12:46.000000', 'temperatura', 129.0000, 'ºC'),
	(134464, 111, '2015-04-01 00:12:47.000000', 'temperatura', 802.0000, 'ºC'),
	(134465, 111, '2015-04-01 00:12:48.000000', 'temperatura', 20.0000, 'ºC'),
	(134466, 111, '2015-04-01 00:12:49.000000', 'temperatura', 98.0000, 'ºC'),
	(134467, 111, '2015-04-01 00:12:50.000000', 'temperatura', 429.0000, 'ºC'),
	(134468, 111, '2015-04-01 00:12:51.000000', 'temperatura', 653.0000, 'ºC'),
	(134469, 111, '2015-04-01 00:12:52.000000', 'temperatura', 780.0000, 'ºC'),
	(134470, 111, '2015-04-01 00:12:53.000000', 'temperatura', 738.0000, 'ºC'),
	(134471, 111, '2015-04-01 00:12:54.000000', 'temperatura', 153.0000, 'ºC'),
	(134472, 111, '2015-04-01 00:12:55.000000', 'temperatura', 949.0000, 'ºC'),
	(134473, 111, '2015-04-01 00:12:56.000000', 'temperatura', 687.0000, 'ºC'),
	(134474, 111, '2015-04-01 00:12:57.000000', 'temperatura', 589.0000, 'ºC'),
	(134475, 111, '2015-04-01 00:12:58.000000', 'temperatura', 883.0000, 'ºC'),
	(134476, 111, '2015-04-01 00:12:59.000000', 'temperatura', 248.0000, 'ºC'),
	(134477, 111, '2015-04-01 00:13:00.000000', 'temperatura', 993.0000, 'ºC'),
	(134478, 111, '2015-04-01 00:13:01.000000', 'temperatura', 623.0000, 'ºC'),
	(134479, 111, '2015-04-01 00:13:02.000000', 'temperatura', 134.0000, 'ºC'),
	(134480, 111, '2015-04-01 00:13:03.000000', 'temperatura', 0.0000, 'ºC'),
	(134481, 111, '2015-04-01 00:13:04.000000', 'temperatura', 802.0000, 'ºC'),
	(134482, 111, '2015-04-01 00:13:05.000000', 'temperatura', 410.0000, 'ºC'),
	(134483, 111, '2015-04-01 00:13:06.000000', 'temperatura', 843.0000, 'ºC'),
	(134484, 111, '2015-04-01 00:13:07.000000', 'temperatura', 586.0000, 'ºC'),
	(134485, 111, '2015-04-01 00:13:08.000000', 'temperatura', 400.0000, 'ºC'),
	(134486, 111, '2015-04-01 00:13:09.000000', 'temperatura', 242.0000, 'ºC'),
	(134487, 111, '2015-04-01 00:13:10.000000', 'temperatura', 12.0000, 'ºC'),
	(134488, 111, '2015-04-01 00:13:11.000000', 'temperatura', 536.0000, 'ºC'),
	(134489, 111, '2015-04-01 00:13:12.000000', 'temperatura', 242.0000, 'ºC'),
	(134490, 111, '2015-04-01 00:13:13.000000', 'temperatura', 804.0000, 'ºC'),
	(134491, 111, '2015-04-01 00:13:14.000000', 'temperatura', 896.0000, 'ºC'),
	(134492, 111, '2015-04-01 00:13:15.000000', 'temperatura', 865.0000, 'ºC'),
	(134493, 111, '2015-04-01 00:13:16.000000', 'temperatura', 439.0000, 'ºC'),
	(134494, 111, '2015-04-01 00:13:17.000000', 'temperatura', 802.0000, 'ºC'),
	(134495, 111, '2015-04-01 00:13:18.000000', 'temperatura', 293.0000, 'ºC'),
	(134496, 111, '2015-04-01 00:13:19.000000', 'temperatura', 260.0000, 'ºC'),
	(134497, 111, '2015-04-01 00:13:20.000000', 'temperatura', 420.0000, 'ºC'),
	(134498, 111, '2015-04-01 00:13:21.000000', 'temperatura', 119.0000, 'ºC'),
	(134499, 111, '2015-04-01 00:13:22.000000', 'temperatura', 539.0000, 'ºC'),
	(134500, 111, '2015-04-01 00:13:23.000000', 'temperatura', 1137.0000, 'ºC'),
	(134501, 111, '2015-04-01 00:13:24.000000', 'temperatura', 470.0000, 'ºC'),
	(134502, 111, '2015-04-01 00:13:25.000000', 'temperatura', 140.0000, 'ºC'),
	(134503, 111, '2015-04-01 00:13:26.000000', 'temperatura', 489.0000, 'ºC'),
	(134504, 111, '2015-04-01 00:13:27.000000', 'temperatura', 824.0000, 'ºC'),
	(134505, 111, '2015-04-01 00:13:28.000000', 'temperatura', 254.0000, 'ºC'),
	(134506, 111, '2015-04-01 00:13:29.000000', 'temperatura', 0.0000, 'ºC'),
	(134507, 111, '2015-04-01 00:13:30.000000', 'temperatura', 439.0000, 'ºC'),
	(134508, 111, '2015-04-01 00:13:31.000000', 'temperatura', 993.0000, 'ºC'),
	(134509, 111, '2015-04-01 00:13:32.000000', 'temperatura', 51.0000, 'ºC'),
	(134510, 111, '2015-04-01 00:13:33.000000', 'temperatura', 875.0000, 'ºC'),
	(134511, 111, '2015-04-01 00:13:34.000000', 'temperatura', 621.0000, 'ºC'),
	(134512, 111, '2015-04-01 00:13:35.000000', 'temperatura', 482.0000, 'ºC'),
	(134513, 111, '2015-04-01 00:13:36.000000', 'temperatura', 549.0000, 'ºC'),
	(134514, 111, '2015-04-01 00:13:37.000000', 'temperatura', 98.0000, 'ºC'),
	(134515, 111, '2015-04-01 00:13:38.000000', 'temperatura', 45.0000, 'ºC'),
	(134516, 111, '2015-04-01 00:13:39.000000', 'temperatura', 1129.0000, 'ºC'),
	(134517, 111, '2015-04-01 00:13:40.000000', 'temperatura', 711.0000, 'ºC'),
	(134518, 111, '2015-04-01 00:13:41.000000', 'temperatura', 169.0000, 'ºC'),
	(134519, 111, '2015-04-01 00:13:42.000000', 'temperatura', 1111.0000, 'ºC'),
	(134520, 111, '2015-04-01 00:13:43.000000', 'temperatura', 248.0000, 'ºC'),
	(134521, 111, '2015-04-01 00:13:44.000000', 'temperatura', 308.0000, 'ºC'),
	(134522, 111, '2015-04-01 00:13:45.000000', 'temperatura', 797.0000, 'ºC'),
	(134523, 111, '2015-04-01 00:13:46.000000', 'temperatura', 661.0000, 'ºC'),
	(134524, 111, '2015-04-01 00:13:47.000000', 'temperatura', 914.0000, 'ºC'),
	(134525, 111, '2015-04-01 00:13:48.000000', 'temperatura', 190.0000, 'ºC'),
	(134526, 111, '2015-04-01 00:13:49.000000', 'temperatura', 607.0000, 'ºC'),
	(134527, 111, '2015-04-01 00:13:50.000000', 'temperatura', 66.0000, 'ºC'),
	(134528, 111, '2015-04-01 00:13:51.000000', 'temperatura', 908.0000, 'ºC'),
	(134529, 111, '2015-04-01 00:13:52.000000', 'temperatura', 745.0000, 'ºC'),
	(134530, 111, '2015-04-01 00:13:53.000000', 'temperatura', 1002.0000, 'ºC'),
	(134531, 111, '2015-04-01 00:13:54.000000', 'temperatura', 376.0000, 'ºC'),
	(134532, 111, '2015-04-01 00:13:55.000000', 'temperatura', 74.0000, 'ºC'),
	(134533, 111, '2015-04-01 00:13:56.000000', 'temperatura', 441.0000, 'ºC'),
	(134534, 111, '2015-04-01 00:13:57.000000', 'temperatura', 785.0000, 'ºC'),
	(134535, 111, '2015-04-01 00:13:58.000000', 'temperatura', 200.0000, 'ºC'),
	(134536, 111, '2015-04-01 00:13:59.000000', 'temperatura', 1048.0000, 'ºC'),
	(134537, 111, '2015-04-01 00:14:00.000000', 'temperatura', 1041.0000, 'ºC'),
	(134538, 111, '2015-04-01 00:14:01.000000', 'temperatura', 859.0000, 'ºC'),
	(134539, 111, '2015-04-01 00:14:02.000000', 'temperatura', 1175.0000, 'ºC'),
	(134540, 111, '2015-04-01 00:14:03.000000', 'temperatura', 897.0000, 'ºC'),
	(134541, 111, '2015-04-01 00:14:04.000000', 'temperatura', 963.0000, 'ºC'),
	(134542, 111, '2015-04-01 00:14:05.000000', 'temperatura', 921.0000, 'ºC'),
	(134543, 111, '2015-04-01 00:14:06.000000', 'temperatura', 519.0000, 'ºC'),
	(134544, 111, '2015-04-01 00:14:07.000000', 'temperatura', 1030.0000, 'ºC'),
	(134545, 111, '2015-04-01 00:14:08.000000', 'temperatura', 1193.0000, 'ºC'),
	(134546, 111, '2015-04-01 00:14:09.000000', 'temperatura', 477.0000, 'ºC'),
	(134547, 111, '2015-04-01 00:14:10.000000', 'temperatura', 5.0000, 'ºC'),
	(134548, 111, '2015-04-01 00:14:11.000000', 'temperatura', 998.0000, 'ºC'),
	(134549, 111, '2015-04-01 00:14:12.000000', 'temperatura', 172.0000, 'ºC'),
	(134550, 111, '2015-04-01 00:14:13.000000', 'temperatura', 266.0000, 'ºC'),
	(134551, 111, '2015-04-01 00:14:14.000000', 'temperatura', 817.0000, 'ºC'),
	(134552, 111, '2015-04-01 00:14:15.000000', 'temperatura', 887.0000, 'ºC'),
	(134553, 111, '2015-04-01 00:14:16.000000', 'temperatura', 783.0000, 'ºC'),
	(134554, 111, '2015-04-01 00:14:17.000000', 'temperatura', 57.0000, 'ºC'),
	(134555, 111, '2015-04-01 00:14:18.000000', 'temperatura', 337.0000, 'ºC'),
	(134556, 111, '2015-04-01 00:14:19.000000', 'temperatura', 315.0000, 'ºC'),
	(134557, 111, '2015-04-01 00:14:20.000000', 'temperatura', 561.0000, 'ºC'),
	(134558, 111, '2015-04-01 00:14:21.000000', 'temperatura', 664.0000, 'ºC'),
	(134559, 111, '2015-04-01 00:14:22.000000', 'temperatura', 436.0000, 'ºC'),
	(134560, 111, '2015-04-01 00:14:23.000000', 'temperatura', 190.0000, 'ºC'),
	(134561, 111, '2015-04-01 00:14:24.000000', 'temperatura', 841.0000, 'ºC'),
	(134562, 111, '2015-04-01 00:14:25.000000', 'temperatura', 36.0000, 'ºC'),
	(134563, 111, '2015-04-01 00:14:26.000000', 'temperatura', 56.0000, 'ºC'),
	(134564, 111, '2015-04-01 00:14:27.000000', 'temperatura', 173.0000, 'ºC'),
	(134565, 111, '2015-04-01 00:14:28.000000', 'temperatura', 697.0000, 'ºC'),
	(134566, 111, '2015-04-01 00:14:29.000000', 'temperatura', 568.0000, 'ºC'),
	(134567, 111, '2015-04-01 00:14:30.000000', 'temperatura', 747.0000, 'ºC'),
	(134568, 111, '2015-04-01 00:14:31.000000', 'temperatura', 835.0000, 'ºC'),
	(134569, 111, '2015-04-01 00:14:32.000000', 'temperatura', 733.0000, 'ºC'),
	(134570, 111, '2015-04-01 00:14:33.000000', 'temperatura', 1159.0000, 'ºC'),
	(134571, 111, '2015-04-01 00:14:34.000000', 'temperatura', 1196.0000, 'ºC'),
	(134572, 111, '2015-04-01 00:14:35.000000', 'temperatura', 103.0000, 'ºC'),
	(134573, 111, '2015-04-01 00:14:36.000000', 'temperatura', 530.0000, 'ºC'),
	(134574, 111, '2015-04-01 00:14:37.000000', 'temperatura', 1139.0000, 'ºC'),
	(134575, 111, '2015-04-01 00:14:38.000000', 'temperatura', 507.0000, 'ºC'),
	(134576, 111, '2015-04-01 00:14:39.000000', 'temperatura', 320.0000, 'ºC'),
	(134577, 111, '2015-04-01 00:14:40.000000', 'temperatura', 76.0000, 'ºC'),
	(134578, 111, '2015-04-01 00:14:41.000000', 'temperatura', 623.0000, 'ºC'),
	(134579, 111, '2015-04-01 00:14:42.000000', 'temperatura', 486.0000, 'ºC'),
	(134580, 111, '2015-04-01 00:14:43.000000', 'temperatura', 563.0000, 'ºC'),
	(134581, 111, '2015-04-01 00:14:44.000000', 'temperatura', 155.0000, 'ºC'),
	(134582, 111, '2015-04-01 00:14:45.000000', 'temperatura', 289.0000, 'ºC'),
	(134583, 111, '2015-04-01 00:14:46.000000', 'temperatura', 978.0000, 'ºC'),
	(134584, 111, '2015-04-01 00:14:47.000000', 'temperatura', 426.0000, 'ºC'),
	(134585, 111, '2015-04-01 00:14:48.000000', 'temperatura', 395.0000, 'ºC'),
	(134586, 111, '2015-04-01 00:14:49.000000', 'temperatura', 699.0000, 'ºC'),
	(134587, 111, '2015-04-01 00:14:50.000000', 'temperatura', 1112.0000, 'ºC'),
	(134588, 111, '2015-04-01 00:14:51.000000', 'temperatura', 1061.0000, 'ºC'),
	(134589, 111, '2015-04-01 00:14:52.000000', 'temperatura', 771.0000, 'ºC'),
	(134590, 111, '2015-04-01 00:14:53.000000', 'temperatura', 671.0000, 'ºC'),
	(134591, 111, '2015-04-01 00:14:54.000000', 'temperatura', 1042.0000, 'ºC'),
	(134592, 111, '2015-04-01 00:14:55.000000', 'temperatura', 800.0000, 'ºC'),
	(134593, 111, '2015-04-01 00:14:56.000000', 'temperatura', 873.0000, 'ºC'),
	(134594, 111, '2015-04-01 00:14:57.000000', 'temperatura', 768.0000, 'ºC'),
	(134595, 111, '2015-04-01 00:14:58.000000', 'temperatura', 19.0000, 'ºC'),
	(134596, 111, '2015-04-01 00:14:59.000000', 'temperatura', 193.0000, 'ºC'),
	(134597, 111, '2015-04-01 00:15:00.000000', 'temperatura', 906.0000, 'ºC'),
	(134598, 111, '2015-04-01 00:15:01.000000', 'temperatura', 353.0000, 'ºC'),
	(134599, 111, '2015-04-01 00:15:02.000000', 'temperatura', 246.0000, 'ºC'),
	(134600, 111, '2015-04-01 00:15:03.000000', 'temperatura', 173.0000, 'ºC'),
	(134601, 111, '2015-04-01 00:15:04.000000', 'temperatura', 126.0000, 'ºC'),
	(134602, 111, '2015-04-01 00:15:05.000000', 'temperatura', 110.0000, 'ºC'),
	(134603, 111, '2015-04-01 00:15:06.000000', 'temperatura', 175.0000, 'ºC'),
	(134604, 111, '2015-04-01 00:15:07.000000', 'temperatura', 545.0000, 'ºC'),
	(134605, 111, '2015-04-01 00:15:08.000000', 'temperatura', 1000.0000, 'ºC'),
	(134606, 111, '2015-04-01 00:15:09.000000', 'temperatura', 968.0000, 'ºC'),
	(134607, 111, '2015-04-01 00:15:10.000000', 'temperatura', 638.0000, 'ºC'),
	(134608, 111, '2015-04-01 00:15:11.000000', 'temperatura', 287.0000, 'ºC'),
	(134609, 111, '2015-04-01 00:15:12.000000', 'temperatura', 723.0000, 'ºC'),
	(134610, 111, '2015-04-01 00:15:13.000000', 'temperatura', 354.0000, 'ºC'),
	(134611, 111, '2015-04-01 00:15:14.000000', 'temperatura', 803.0000, 'ºC'),
	(134612, 111, '2015-04-01 00:15:15.000000', 'temperatura', 553.0000, 'ºC'),
	(134613, 111, '2015-04-01 00:15:16.000000', 'temperatura', 356.0000, 'ºC'),
	(134614, 111, '2015-04-01 00:15:17.000000', 'temperatura', 121.0000, 'ºC'),
	(134615, 111, '2015-04-01 00:15:18.000000', 'temperatura', 738.0000, 'ºC'),
	(134616, 111, '2015-04-01 00:15:19.000000', 'temperatura', 928.0000, 'ºC'),
	(134617, 111, '2015-04-01 00:15:20.000000', 'temperatura', 27.0000, 'ºC'),
	(134618, 111, '2015-04-01 00:15:21.000000', 'temperatura', 949.0000, 'ºC'),
	(134619, 111, '2015-04-01 00:15:22.000000', 'temperatura', 1067.0000, 'ºC'),
	(134620, 111, '2015-04-01 00:15:23.000000', 'temperatura', 88.0000, 'ºC'),
	(134621, 111, '2015-04-01 00:15:24.000000', 'temperatura', 837.0000, 'ºC'),
	(134622, 111, '2015-04-01 00:15:25.000000', 'temperatura', 324.0000, 'ºC'),
	(134623, 111, '2015-04-01 00:15:26.000000', 'temperatura', 308.0000, 'ºC'),
	(134624, 111, '2015-04-01 00:15:27.000000', 'temperatura', 570.0000, 'ºC'),
	(134625, 111, '2015-04-01 00:15:28.000000', 'temperatura', 725.0000, 'ºC'),
	(134626, 111, '2015-04-01 00:15:29.000000', 'temperatura', 717.0000, 'ºC'),
	(134627, 111, '2015-04-01 00:15:30.000000', 'temperatura', 209.0000, 'ºC'),
	(134628, 111, '2015-04-01 00:15:31.000000', 'temperatura', 96.0000, 'ºC'),
	(134629, 111, '2015-04-01 00:15:32.000000', 'temperatura', 1054.0000, 'ºC'),
	(134630, 111, '2015-04-01 00:15:33.000000', 'temperatura', 183.0000, 'ºC'),
	(134631, 111, '2015-04-01 00:15:34.000000', 'temperatura', 151.0000, 'ºC'),
	(134632, 111, '2015-04-01 00:15:35.000000', 'temperatura', 206.0000, 'ºC'),
	(134633, 111, '2015-04-01 00:15:36.000000', 'temperatura', 580.0000, 'ºC'),
	(134634, 111, '2015-04-01 00:15:37.000000', 'temperatura', 1081.0000, 'ºC'),
	(134635, 111, '2015-04-01 00:15:38.000000', 'temperatura', 68.0000, 'ºC'),
	(134636, 111, '2015-04-01 00:15:39.000000', 'temperatura', 694.0000, 'ºC'),
	(134637, 111, '2015-04-01 00:15:40.000000', 'temperatura', 869.0000, 'ºC'),
	(134638, 111, '2015-04-01 00:15:41.000000', 'temperatura', 1061.0000, 'ºC'),
	(134639, 111, '2015-04-01 00:15:42.000000', 'temperatura', 301.0000, 'ºC'),
	(134640, 111, '2015-04-01 00:15:43.000000', 'temperatura', 722.0000, 'ºC'),
	(134641, 111, '2015-04-01 00:15:44.000000', 'temperatura', 309.0000, 'ºC'),
	(134642, 111, '2015-04-01 00:15:45.000000', 'temperatura', 577.0000, 'ºC'),
	(134643, 111, '2015-04-01 00:15:46.000000', 'temperatura', 761.0000, 'ºC'),
	(134644, 111, '2015-04-01 00:15:47.000000', 'temperatura', 875.0000, 'ºC'),
	(134645, 111, '2015-04-01 00:15:48.000000', 'temperatura', 893.0000, 'ºC'),
	(134646, 111, '2015-04-01 00:15:49.000000', 'temperatura', 641.0000, 'ºC'),
	(134647, 111, '2015-04-01 00:15:50.000000', 'temperatura', 525.0000, 'ºC'),
	(134648, 111, '2015-04-01 00:15:51.000000', 'temperatura', 702.0000, 'ºC'),
	(134649, 111, '2015-04-01 00:15:52.000000', 'temperatura', 735.0000, 'ºC'),
	(134650, 111, '2015-04-01 00:15:53.000000', 'temperatura', 372.0000, 'ºC'),
	(134651, 111, '2015-04-01 00:15:54.000000', 'temperatura', 855.0000, 'ºC'),
	(134652, 111, '2015-04-01 00:15:55.000000', 'temperatura', 758.0000, 'ºC'),
	(134653, 111, '2015-04-01 00:15:56.000000', 'temperatura', 25.0000, 'ºC'),
	(134654, 111, '2015-04-01 00:15:57.000000', 'temperatura', 254.0000, 'ºC'),
	(134655, 111, '2015-04-01 00:15:58.000000', 'temperatura', 1193.0000, 'ºC'),
	(134656, 111, '2015-04-01 00:15:59.000000', 'temperatura', 403.0000, 'ºC'),
	(134657, 111, '2015-04-01 00:16:00.000000', 'temperatura', 837.0000, 'ºC'),
	(134658, 111, '2015-04-01 00:16:01.000000', 'temperatura', 578.0000, 'ºC'),
	(134659, 111, '2015-04-01 00:16:02.000000', 'temperatura', 380.0000, 'ºC'),
	(134660, 111, '2015-04-01 00:16:03.000000', 'temperatura', 166.0000, 'ºC'),
	(134661, 111, '2015-04-01 00:16:04.000000', 'temperatura', 889.0000, 'ºC'),
	(134662, 111, '2015-04-01 00:16:05.000000', 'temperatura', 350.0000, 'ºC'),
	(134663, 111, '2015-04-01 00:16:06.000000', 'temperatura', 284.0000, 'ºC'),
	(134664, 111, '2015-04-01 00:16:07.000000', 'temperatura', 371.0000, 'ºC'),
	(134665, 111, '2015-04-01 00:16:08.000000', 'temperatura', 1001.0000, 'ºC'),
	(134666, 111, '2015-04-01 00:16:09.000000', 'temperatura', 294.0000, 'ºC'),
	(134667, 111, '2015-04-01 00:16:10.000000', 'temperatura', 865.0000, 'ºC'),
	(134668, 111, '2015-04-01 00:16:11.000000', 'temperatura', 1045.0000, 'ºC'),
	(134669, 111, '2015-04-01 00:16:12.000000', 'temperatura', 232.0000, 'ºC'),
	(134670, 111, '2015-04-01 00:16:13.000000', 'temperatura', 424.0000, 'ºC'),
	(134671, 111, '2015-04-01 00:16:14.000000', 'temperatura', 225.0000, 'ºC'),
	(134672, 111, '2015-04-01 00:16:15.000000', 'temperatura', 1055.0000, 'ºC'),
	(134673, 111, '2015-04-01 00:16:16.000000', 'temperatura', 999.0000, 'ºC'),
	(134674, 111, '2015-04-01 00:16:17.000000', 'temperatura', 633.0000, 'ºC'),
	(134675, 111, '2015-04-01 00:16:18.000000', 'temperatura', 165.0000, 'ºC'),
	(134676, 111, '2015-04-01 00:16:19.000000', 'temperatura', 129.0000, 'ºC'),
	(134677, 111, '2015-04-01 00:16:20.000000', 'temperatura', 149.0000, 'ºC'),
	(134678, 111, '2015-04-01 00:16:21.000000', 'temperatura', 359.0000, 'ºC'),
	(134679, 111, '2015-04-01 00:16:22.000000', 'temperatura', 147.0000, 'ºC'),
	(134680, 111, '2015-04-01 00:16:23.000000', 'temperatura', 858.0000, 'ºC'),
	(134681, 111, '2015-04-01 00:16:24.000000', 'temperatura', 249.0000, 'ºC'),
	(134682, 111, '2015-04-01 00:16:25.000000', 'temperatura', 1071.0000, 'ºC'),
	(134683, 111, '2015-04-01 00:16:26.000000', 'temperatura', 1011.0000, 'ºC'),
	(134684, 111, '2015-04-01 00:16:27.000000', 'temperatura', 639.0000, 'ºC'),
	(134685, 111, '2015-04-01 00:16:28.000000', 'temperatura', 166.0000, 'ºC'),
	(134686, 111, '2015-04-01 00:16:29.000000', 'temperatura', 114.0000, 'ºC'),
	(134687, 111, '2015-04-01 00:16:30.000000', 'temperatura', 71.0000, 'ºC'),
	(134688, 111, '2015-04-01 00:16:31.000000', 'temperatura', 14.0000, 'ºC'),
	(134689, 111, '2015-04-01 00:16:32.000000', 'temperatura', 1058.0000, 'ºC'),
	(134690, 111, '2015-04-01 00:16:33.000000', 'temperatura', 447.0000, 'ºC'),
	(134691, 111, '2015-04-01 00:16:34.000000', 'temperatura', 264.0000, 'ºC'),
	(134692, 111, '2015-04-01 00:16:35.000000', 'temperatura', 1177.0000, 'ºC'),
	(134693, 111, '2015-04-01 00:16:36.000000', 'temperatura', 293.0000, 'ºC'),
	(134694, 111, '2015-04-01 00:16:37.000000', 'temperatura', 336.0000, 'ºC'),
	(134695, 111, '2015-04-01 00:16:38.000000', 'temperatura', 800.0000, 'ºC'),
	(134696, 111, '2015-04-01 00:16:39.000000', 'temperatura', 592.0000, 'ºC'),
	(134697, 111, '2015-04-01 00:16:40.000000', 'temperatura', 562.0000, 'ºC'),
	(134698, 111, '2015-04-01 00:16:41.000000', 'temperatura', 1034.0000, 'ºC'),
	(134699, 111, '2015-04-01 00:16:42.000000', 'temperatura', 1083.0000, 'ºC'),
	(134700, 111, '2015-04-01 00:16:43.000000', 'temperatura', 1115.0000, 'ºC'),
	(134701, 111, '2015-04-01 00:16:44.000000', 'temperatura', 1126.0000, 'ºC'),
	(134702, 111, '2015-04-01 00:16:45.000000', 'temperatura', 1088.0000, 'ºC'),
	(134703, 111, '2015-04-01 00:16:46.000000', 'temperatura', 860.0000, 'ºC'),
	(134704, 111, '2015-04-01 00:16:47.000000', 'temperatura', 1035.0000, 'ºC'),
	(134705, 111, '2015-04-01 00:16:48.000000', 'temperatura', 197.0000, 'ºC'),
	(134706, 111, '2015-04-01 00:16:49.000000', 'temperatura', 282.0000, 'ºC'),
	(134707, 111, '2015-04-01 00:16:50.000000', 'temperatura', 817.0000, 'ºC'),
	(134708, 111, '2015-04-01 00:16:51.000000', 'temperatura', 842.0000, 'ºC'),
	(134709, 111, '2015-04-01 00:16:52.000000', 'temperatura', 560.0000, 'ºC'),
	(134710, 111, '2015-04-01 00:16:53.000000', 'temperatura', 275.0000, 'ºC'),
	(134711, 111, '2015-04-01 00:16:54.000000', 'temperatura', 894.0000, 'ºC'),
	(134712, 111, '2015-04-01 00:16:55.000000', 'temperatura', 47.0000, 'ºC'),
	(134713, 111, '2015-04-01 00:16:56.000000', 'temperatura', 1155.0000, 'ºC'),
	(134714, 111, '2015-04-01 00:16:57.000000', 'temperatura', 831.0000, 'ºC'),
	(134715, 111, '2015-04-01 00:16:58.000000', 'temperatura', 693.0000, 'ºC'),
	(134716, 111, '2015-04-01 00:16:59.000000', 'temperatura', 973.0000, 'ºC'),
	(134717, 111, '2015-04-01 00:17:00.000000', 'temperatura', 385.0000, 'ºC'),
	(134718, 111, '2015-04-01 00:17:01.000000', 'temperatura', 209.0000, 'ºC'),
	(134719, 111, '2015-04-01 00:17:02.000000', 'temperatura', 1088.0000, 'ºC'),
	(134720, 111, '2015-04-01 00:17:03.000000', 'temperatura', 13.0000, 'ºC'),
	(134721, 111, '2015-04-01 00:17:04.000000', 'temperatura', 402.0000, 'ºC'),
	(134722, 111, '2015-04-01 00:17:05.000000', 'temperatura', 773.0000, 'ºC'),
	(134723, 111, '2015-04-01 00:17:06.000000', 'temperatura', 258.0000, 'ºC'),
	(134724, 111, '2015-04-01 00:17:07.000000', 'temperatura', 170.0000, 'ºC'),
	(134725, 111, '2015-04-01 00:17:08.000000', 'temperatura', 78.0000, 'ºC'),
	(134726, 111, '2015-04-01 00:17:09.000000', 'temperatura', 1080.0000, 'ºC'),
	(134727, 111, '2015-04-01 00:17:10.000000', 'temperatura', 365.0000, 'ºC'),
	(134728, 111, '2015-04-01 00:17:11.000000', 'temperatura', 985.0000, 'ºC'),
	(134729, 111, '2015-04-01 00:17:12.000000', 'temperatura', 233.0000, 'ºC'),
	(134730, 111, '2015-04-01 00:17:13.000000', 'temperatura', 611.0000, 'ºC'),
	(134731, 111, '2015-04-01 00:17:14.000000', 'temperatura', 1155.0000, 'ºC'),
	(134732, 111, '2015-04-01 00:17:15.000000', 'temperatura', 341.0000, 'ºC'),
	(134733, 111, '2015-04-01 00:17:16.000000', 'temperatura', 642.0000, 'ºC'),
	(134734, 111, '2015-04-01 00:17:17.000000', 'temperatura', 985.0000, 'ºC'),
	(134735, 111, '2015-04-01 00:17:18.000000', 'temperatura', 602.0000, 'ºC'),
	(134736, 111, '2015-04-01 00:17:19.000000', 'temperatura', 56.0000, 'ºC'),
	(134737, 111, '2015-04-01 00:17:20.000000', 'temperatura', 873.0000, 'ºC'),
	(134738, 111, '2015-04-01 00:17:21.000000', 'temperatura', 598.0000, 'ºC'),
	(134739, 111, '2015-04-01 00:17:22.000000', 'temperatura', 372.0000, 'ºC'),
	(134740, 111, '2015-04-01 00:17:23.000000', 'temperatura', 65.0000, 'ºC'),
	(134741, 111, '2015-04-01 00:17:24.000000', 'temperatura', 412.0000, 'ºC'),
	(134742, 111, '2015-04-01 00:17:25.000000', 'temperatura', 663.0000, 'ºC'),
	(134743, 111, '2015-04-01 00:17:26.000000', 'temperatura', 881.0000, 'ºC'),
	(134744, 111, '2015-04-01 00:17:27.000000', 'temperatura', 18.0000, 'ºC'),
	(134745, 111, '2015-04-01 00:17:28.000000', 'temperatura', 1045.0000, 'ºC'),
	(134746, 111, '2015-04-01 00:17:29.000000', 'temperatura', 370.0000, 'ºC'),
	(134747, 111, '2015-04-01 00:17:30.000000', 'temperatura', 1119.0000, 'ºC'),
	(134748, 111, '2015-04-01 00:17:31.000000', 'temperatura', 884.0000, 'ºC'),
	(134749, 111, '2015-04-01 00:17:32.000000', 'temperatura', 1062.0000, 'ºC'),
	(134750, 111, '2015-04-01 00:17:33.000000', 'temperatura', 259.0000, 'ºC'),
	(134751, 111, '2015-04-01 00:17:34.000000', 'temperatura', 511.0000, 'ºC'),
	(134752, 111, '2015-04-01 00:17:35.000000', 'temperatura', 578.0000, 'ºC'),
	(134753, 111, '2015-04-01 00:17:36.000000', 'temperatura', 157.0000, 'ºC'),
	(134754, 111, '2015-04-01 00:17:37.000000', 'temperatura', 254.0000, 'ºC'),
	(134755, 111, '2015-04-01 00:17:38.000000', 'temperatura', 797.0000, 'ºC'),
	(134756, 111, '2015-04-01 00:17:39.000000', 'temperatura', 824.0000, 'ºC'),
	(134757, 111, '2015-04-01 00:17:40.000000', 'temperatura', 531.0000, 'ºC'),
	(134758, 111, '2015-04-01 00:17:41.000000', 'temperatura', 183.0000, 'ºC'),
	(134759, 111, '2015-04-01 00:17:42.000000', 'temperatura', 523.0000, 'ºC'),
	(134760, 111, '2015-04-01 00:17:43.000000', 'temperatura', 868.0000, 'ºC'),
	(134761, 111, '2015-04-01 00:17:44.000000', 'temperatura', 370.0000, 'ºC'),
	(134762, 111, '2015-04-01 00:17:45.000000', 'temperatura', 445.0000, 'ºC'),
	(134763, 111, '2015-04-01 00:17:46.000000', 'temperatura', 1116.0000, 'ºC'),
	(134764, 111, '2015-04-01 00:17:47.000000', 'temperatura', 645.0000, 'ºC'),
	(134765, 111, '2015-04-01 00:17:48.000000', 'temperatura', 1079.0000, 'ºC'),
	(134766, 111, '2015-04-01 00:17:49.000000', 'temperatura', 1061.0000, 'ºC'),
	(134767, 111, '2015-04-01 00:17:50.000000', 'temperatura', 870.0000, 'ºC'),
	(134768, 111, '2015-04-01 00:17:51.000000', 'temperatura', 1165.0000, 'ºC'),
	(134769, 111, '2015-04-01 00:17:52.000000', 'temperatura', 817.0000, 'ºC'),
	(134770, 111, '2015-04-01 00:17:53.000000', 'temperatura', 590.0000, 'ºC'),
	(134771, 111, '2015-04-01 00:17:54.000000', 'temperatura', 498.0000, 'ºC'),
	(134772, 111, '2015-04-01 00:17:55.000000', 'temperatura', 721.0000, 'ºC'),
	(134773, 111, '2015-04-01 00:17:56.000000', 'temperatura', 912.0000, 'ºC'),
	(134774, 111, '2015-04-01 00:17:57.000000', 'temperatura', 1198.0000, 'ºC'),
	(134775, 111, '2015-04-01 00:17:58.000000', 'temperatura', 852.0000, 'ºC'),
	(134776, 111, '2015-04-01 00:17:59.000000', 'temperatura', 668.0000, 'ºC'),
	(134777, 111, '2015-04-01 00:18:00.000000', 'temperatura', 786.0000, 'ºC'),
	(134778, 111, '2015-04-01 00:18:01.000000', 'temperatura', 725.0000, 'ºC'),
	(134779, 111, '2015-04-01 00:18:02.000000', 'temperatura', 67.0000, 'ºC'),
	(134780, 111, '2015-04-01 00:18:03.000000', 'temperatura', 562.0000, 'ºC'),
	(134781, 111, '2015-04-01 00:18:04.000000', 'temperatura', 210.0000, 'ºC'),
	(134782, 111, '2015-04-01 00:18:05.000000', 'temperatura', 564.0000, 'ºC'),
	(134783, 111, '2015-04-01 00:18:06.000000', 'temperatura', 990.0000, 'ºC'),
	(134784, 111, '2015-04-01 00:18:07.000000', 'temperatura', 859.0000, 'ºC'),
	(134785, 111, '2015-04-01 00:18:08.000000', 'temperatura', 126.0000, 'ºC'),
	(134786, 111, '2015-04-01 00:18:09.000000', 'temperatura', 454.0000, 'ºC'),
	(134787, 111, '2015-04-01 00:18:10.000000', 'temperatura', 693.0000, 'ºC'),
	(134788, 111, '2015-04-01 00:18:11.000000', 'temperatura', 903.0000, 'ºC'),
	(134789, 111, '2015-04-01 00:18:12.000000', 'temperatura', 35.0000, 'ºC'),
	(134790, 111, '2015-04-01 00:18:13.000000', 'temperatura', 1069.0000, 'ºC'),
	(134791, 111, '2015-04-01 00:18:14.000000', 'temperatura', 439.0000, 'ºC'),
	(134792, 111, '2015-04-01 00:18:15.000000', 'temperatura', 187.0000, 'ºC'),
	(134793, 111, '2015-04-01 00:18:16.000000', 'temperatura', 821.0000, 'ºC'),
	(134794, 111, '2015-04-01 00:18:17.000000', 'temperatura', 1146.0000, 'ºC'),
	(134795, 111, '2015-04-01 00:18:18.000000', 'temperatura', 864.0000, 'ºC'),
	(134796, 111, '2015-04-01 00:18:19.000000', 'temperatura', 883.0000, 'ºC'),
	(134797, 111, '2015-04-01 00:18:20.000000', 'temperatura', 625.0000, 'ºC'),
	(134798, 111, '2015-04-01 00:18:21.000000', 'temperatura', 474.0000, 'ºC'),
	(134799, 111, '2015-04-01 00:18:22.000000', 'temperatura', 496.0000, 'ºC'),
	(134800, 111, '2015-04-01 00:18:23.000000', 'temperatura', 1061.0000, 'ºC'),
	(134801, 111, '2015-04-01 00:18:24.000000', 'temperatura', 215.0000, 'ºC'),
	(134802, 111, '2015-04-01 00:18:25.000000', 'temperatura', 294.0000, 'ºC'),
	(134803, 111, '2015-04-01 00:18:26.000000', 'temperatura', 823.0000, 'ºC'),
	(134804, 111, '2015-04-01 00:18:27.000000', 'temperatura', 835.0000, 'ºC'),
	(134805, 111, '2015-04-01 00:18:28.000000', 'temperatura', 507.0000, 'ºC'),
	(134806, 111, '2015-04-01 00:18:29.000000', 'temperatura', 30.0000, 'ºC'),
	(134807, 111, '2015-04-01 00:18:30.000000', 'temperatura', 1029.0000, 'ºC'),
	(134808, 111, '2015-04-01 00:18:31.000000', 'temperatura', 254.0000, 'ºC'),
	(134809, 111, '2015-04-01 00:18:32.000000', 'temperatura', 587.0000, 'ºC'),
	(134810, 111, '2015-04-01 00:18:33.000000', 'temperatura', 972.0000, 'ºC'),
	(134811, 111, '2015-04-01 00:18:34.000000', 'temperatura', 698.0000, 'ºC'),
	(134812, 111, '2015-04-01 00:18:35.000000', 'temperatura', 576.0000, 'ºC'),
	(134813, 111, '2015-04-01 00:18:36.000000', 'temperatura', 787.0000, 'ºC'),
	(134814, 111, '2015-04-01 00:18:37.000000', 'temperatura', 1008.0000, 'ºC'),
	(134815, 111, '2015-04-01 00:18:38.000000', 'temperatura', 278.0000, 'ºC'),
	(134816, 111, '2015-04-01 00:18:39.000000', 'temperatura', 767.0000, 'ºC'),
	(134817, 111, '2015-04-01 00:18:40.000000', 'temperatura', 603.0000, 'ºC'),
	(134818, 111, '2015-04-01 00:18:41.000000', 'temperatura', 713.0000, 'ºC'),
	(134819, 111, '2015-04-01 00:18:42.000000', 'temperatura', 557.0000, 'ºC'),
	(134820, 111, '2015-04-01 00:18:43.000000', 'temperatura', 646.0000, 'ºC'),
	(134821, 111, '2015-04-01 00:18:44.000000', 'temperatura', 360.0000, 'ºC'),
	(134822, 111, '2015-04-01 00:18:45.000000', 'temperatura', 1062.0000, 'ºC'),
	(134823, 111, '2015-04-01 00:18:46.000000', 'temperatura', 629.0000, 'ºC'),
	(134824, 111, '2015-04-01 00:18:47.000000', 'temperatura', 1159.0000, 'ºC'),
	(134825, 111, '2015-04-01 00:18:48.000000', 'temperatura', 311.0000, 'ºC'),
	(134826, 111, '2015-04-01 00:18:49.000000', 'temperatura', 478.0000, 'ºC'),
	(134827, 111, '2015-04-01 00:18:50.000000', 'temperatura', 256.0000, 'ºC'),
	(134828, 111, '2015-04-01 00:18:51.000000', 'temperatura', 1046.0000, 'ºC'),
	(134829, 111, '2015-04-01 00:18:52.000000', 'temperatura', 865.0000, 'ºC'),
	(134830, 111, '2015-04-01 00:18:53.000000', 'temperatura', 1188.0000, 'ºC'),
	(134831, 111, '2015-04-01 00:18:54.000000', 'temperatura', 943.0000, 'ºC'),
	(134832, 111, '2015-04-01 00:18:55.000000', 'temperatura', 1152.0000, 'ºC'),
	(134833, 111, '2015-04-01 00:18:56.000000', 'temperatura', 531.0000, 'ºC'),
	(134834, 111, '2015-04-01 00:18:57.000000', 'temperatura', 400.0000, 'ºC'),
	(134835, 111, '2015-04-01 00:18:58.000000', 'temperatura', 409.0000, 'ºC'),
	(134836, 111, '2015-04-01 00:18:59.000000', 'temperatura', 846.0000, 'ºC'),
	(134837, 111, '2015-04-01 00:19:00.000000', 'temperatura', 602.0000, 'ºC'),
	(134838, 111, '2015-04-01 00:19:01.000000', 'temperatura', 474.0000, 'ºC'),
	(134839, 111, '2015-04-01 00:19:02.000000', 'temperatura', 563.0000, 'ºC'),
	(134840, 111, '2015-04-01 00:19:03.000000', 'temperatura', 193.0000, 'ºC'),
	(134841, 111, '2015-04-01 00:19:04.000000', 'temperatura', 476.0000, 'ºC'),
	(134842, 111, '2015-04-01 00:19:05.000000', 'temperatura', 602.0000, 'ºC'),
	(134843, 111, '2015-04-01 00:19:06.000000', 'temperatura', 383.0000, 'ºC'),
	(134844, 111, '2015-04-01 00:19:07.000000', 'temperatura', 110.0000, 'ºC'),
	(134845, 111, '2015-04-01 00:19:08.000000', 'temperatura', 602.0000, 'ºC'),
	(134846, 111, '2015-04-01 00:19:09.000000', 'temperatura', 278.0000, 'ºC'),
	(134847, 111, '2015-04-01 00:19:10.000000', 'temperatura', 788.0000, 'ºC'),
	(134848, 111, '2015-04-01 00:19:11.000000', 'temperatura', 704.0000, 'ºC'),
	(134849, 111, '2015-04-01 00:19:12.000000', 'temperatura', 1156.0000, 'ºC'),
	(134850, 111, '2015-04-01 00:19:13.000000', 'temperatura', 69.0000, 'ºC'),
	(134851, 111, '2015-04-01 00:19:14.000000', 'temperatura', 479.0000, 'ºC'),
	(134852, 111, '2015-04-01 00:19:15.000000', 'temperatura', 987.0000, 'ºC'),
	(134853, 111, '2015-04-01 00:19:16.000000', 'temperatura', 1101.0000, 'ºC'),
	(134854, 111, '2015-04-01 00:19:17.000000', 'temperatura', 143.0000, 'ºC'),
	(134855, 111, '2015-04-01 00:19:18.000000', 'temperatura', 1014.0000, 'ºC'),
	(134856, 111, '2015-04-01 00:19:19.000000', 'temperatura', 1040.0000, 'ºC'),
	(134857, 111, '2015-04-01 00:19:20.000000', 'temperatura', 957.0000, 'ºC'),
	(134858, 111, '2015-04-01 00:19:21.000000', 'temperatura', 466.0000, 'ºC'),
	(134859, 111, '2015-04-01 00:19:22.000000', 'temperatura', 661.0000, 'ºC'),
	(134860, 111, '2015-04-01 00:19:23.000000', 'temperatura', 707.0000, 'ºC'),
	(134861, 111, '2015-04-01 00:19:24.000000', 'temperatura', 351.0000, 'ºC'),
	(134862, 111, '2015-04-01 00:19:25.000000', 'temperatura', 837.0000, 'ºC'),
	(134863, 111, '2015-04-01 00:19:26.000000', 'temperatura', 732.0000, 'ºC'),
	(134864, 111, '2015-04-01 00:19:27.000000', 'temperatura', 1151.0000, 'ºC'),
	(134865, 111, '2015-04-01 00:19:28.000000', 'temperatura', 1157.0000, 'ºC'),
	(134866, 111, '2015-04-01 00:19:29.000000', 'temperatura', 1132.0000, 'ºC'),
	(134867, 111, '2015-04-01 00:19:30.000000', 'temperatura', 992.0000, 'ºC'),
	(134868, 111, '2015-04-01 00:19:31.000000', 'temperatura', 362.0000, 'ºC'),
	(134869, 111, '2015-04-01 00:19:32.000000', 'temperatura', 37.0000, 'ºC'),
	(134870, 111, '2015-04-01 00:19:33.000000', 'temperatura', 298.0000, 'ºC'),
	(134871, 111, '2015-04-01 00:19:34.000000', 'temperatura', 178.0000, 'ºC'),
	(134872, 111, '2015-04-01 00:19:35.000000', 'temperatura', 1199.0000, 'ºC'),
	(134873, 111, '2015-04-01 00:19:36.000000', 'temperatura', 659.0000, 'ºC'),
	(134874, 111, '2015-04-01 00:19:37.000000', 'temperatura', 902.0000, 'ºC'),
	(134875, 111, '2015-04-01 00:19:38.000000', 'temperatura', 130.0000, 'ºC'),
	(134876, 111, '2015-04-01 00:19:39.000000', 'temperatura', 347.0000, 'ºC'),
	(134877, 111, '2015-04-01 00:19:40.000000', 'temperatura', 145.0000, 'ºC'),
	(134878, 111, '2015-04-01 00:19:41.000000', 'temperatura', 884.0000, 'ºC'),
	(134879, 111, '2015-04-01 00:19:42.000000', 'temperatura', 385.0000, 'ºC'),
	(134880, 111, '2015-04-01 00:19:43.000000', 'temperatura', 476.0000, 'ºC'),
	(134881, 111, '2015-04-01 00:19:44.000000', 'temperatura', 23.0000, 'ºC'),
	(134882, 111, '2015-04-01 00:19:45.000000', 'temperatura', 1087.0000, 'ºC'),
	(134883, 111, '2015-04-01 00:19:46.000000', 'temperatura', 567.0000, 'ºC'),
	(134884, 111, '2015-04-01 00:19:47.000000', 'temperatura', 776.0000, 'ºC'),
	(134885, 111, '2015-04-01 00:19:48.000000', 'temperatura', 979.0000, 'ºC'),
	(134886, 111, '2015-04-01 00:19:49.000000', 'temperatura', 169.0000, 'ºC'),
	(134887, 111, '2015-04-01 00:19:50.000000', 'temperatura', 308.0000, 'ºC'),
	(134888, 111, '2015-04-01 00:19:51.000000', 'temperatura', 1031.0000, 'ºC'),
	(134889, 111, '2015-04-01 00:19:52.000000', 'temperatura', 634.0000, 'ºC'),
	(134890, 111, '2015-04-01 00:19:53.000000', 'temperatura', 76.0000, 'ºC'),
	(134891, 111, '2015-04-01 00:19:54.000000', 'temperatura', 878.0000, 'ºC'),
	(134892, 111, '2015-04-01 00:19:55.000000', 'temperatura', 563.0000, 'ºC'),
	(134893, 111, '2015-04-01 00:19:56.000000', 'temperatura', 181.0000, 'ºC'),
	(134894, 111, '2015-04-01 00:19:57.000000', 'temperatura', 416.0000, 'ºC'),
	(134895, 111, '2015-04-01 00:19:58.000000', 'temperatura', 339.0000, 'ºC'),
	(134896, 111, '2015-04-01 00:19:59.000000', 'temperatura', 447.0000, 'ºC'),
	(134897, 111, '2015-04-01 00:20:00.000000', 'temperatura', 18.0000, 'ºC'),
	(134898, 111, '2015-04-01 00:20:01.000000', 'temperatura', 1149.0000, 'ºC'),
	(134899, 111, '2015-04-01 00:20:02.000000', 'temperatura', 893.0000, 'ºC'),
	(134900, 111, '2015-04-01 00:20:03.000000', 'temperatura', 1018.0000, 'ºC'),
	(134901, 111, '2015-04-01 00:20:04.000000', 'temperatura', 12.0000, 'ºC'),
	(134902, 111, '2015-04-01 00:20:05.000000', 'temperatura', 606.0000, 'ºC'),
	(134903, 111, '2015-04-01 00:20:06.000000', 'temperatura', 596.0000, 'ºC'),
	(134904, 111, '2015-04-01 00:20:07.000000', 'temperatura', 1162.0000, 'ºC'),
	(134905, 111, '2015-04-01 00:20:08.000000', 'temperatura', 423.0000, 'ºC'),
	(134906, 111, '2015-04-01 00:20:09.000000', 'temperatura', 1029.0000, 'ºC'),
	(134907, 111, '2015-04-01 00:20:10.000000', 'temperatura', 276.0000, 'ºC'),
	(134908, 111, '2015-04-01 00:20:11.000000', 'temperatura', 695.0000, 'ºC'),
	(134909, 111, '2015-04-01 00:20:12.000000', 'temperatura', 248.0000, 'ºC'),
	(134910, 111, '2015-04-01 00:20:13.000000', 'temperatura', 354.0000, 'ºC'),
	(134911, 111, '2015-04-01 00:20:14.000000', 'temperatura', 1027.0000, 'ºC'),
	(134912, 111, '2015-04-01 00:20:15.000000', 'temperatura', 474.0000, 'ºC'),
	(134913, 111, '2015-04-01 00:20:16.000000', 'temperatura', 490.0000, 'ºC'),
	(134914, 111, '2015-04-01 00:20:17.000000', 'temperatura', 1027.0000, 'ºC'),
	(134915, 111, '2015-04-01 00:20:18.000000', 'temperatura', 66.0000, 'ºC'),
	(134916, 111, '2015-04-01 00:20:19.000000', 'temperatura', 851.0000, 'ºC'),
	(134917, 111, '2015-04-01 00:20:20.000000', 'temperatura', 459.0000, 'ºC'),
	(134918, 111, '2015-04-01 00:20:21.000000', 'temperatura', 939.0000, 'ºC'),
	(134919, 111, '2015-04-01 00:20:22.000000', 'temperatura', 920.0000, 'ºC'),
	(134920, 111, '2015-04-01 00:20:23.000000', 'temperatura', 582.0000, 'ºC'),
	(134921, 111, '2015-04-01 00:20:24.000000', 'temperatura', 152.0000, 'ºC'),
	(134922, 111, '2015-04-01 00:20:25.000000', 'temperatura', 216.0000, 'ºC'),
	(134923, 111, '2015-04-01 00:20:26.000000', 'temperatura', 623.0000, 'ºC'),
	(134924, 111, '2015-04-01 00:20:27.000000', 'temperatura', 69.0000, 'ºC'),
	(134925, 111, '2015-04-01 00:20:28.000000', 'temperatura', 876.0000, 'ºC'),
	(134926, 111, '2015-04-01 00:20:29.000000', 'temperatura', 574.0000, 'ºC'),
	(134927, 111, '2015-04-01 00:20:30.000000', 'temperatura', 241.0000, 'ºC'),
	(134928, 111, '2015-04-01 00:20:31.000000', 'temperatura', 683.0000, 'ºC'),
	(134929, 111, '2015-04-01 00:20:32.000000', 'temperatura', 293.0000, 'ºC'),
	(134930, 111, '2015-04-01 00:20:33.000000', 'temperatura', 618.0000, 'ºC'),
	(134931, 111, '2015-04-01 00:20:34.000000', 'temperatura', 1012.0000, 'ºC'),
	(134932, 111, '2015-04-01 00:20:35.000000', 'temperatura', 804.0000, 'ºC'),
	(134933, 111, '2015-04-01 00:20:36.000000', 'temperatura', 986.0000, 'ºC'),
	(134934, 111, '2015-04-01 00:20:37.000000', 'temperatura', 117.0000, 'ºC'),
	(134935, 111, '2015-04-01 00:20:38.000000', 'temperatura', 30.0000, 'ºC'),
	(134936, 111, '2015-04-01 00:20:39.000000', 'temperatura', 996.0000, 'ºC'),
	(134937, 111, '2015-04-01 00:20:40.000000', 'temperatura', 94.0000, 'ºC'),
	(134938, 111, '2015-04-01 00:20:41.000000', 'temperatura', 1080.0000, 'ºC'),
	(134939, 111, '2015-04-01 00:20:42.000000', 'temperatura', 317.0000, 'ºC'),
	(134940, 111, '2015-04-01 00:20:43.000000', 'temperatura', 748.0000, 'ºC'),
	(134941, 111, '2015-04-01 00:20:44.000000', 'temperatura', 389.0000, 'ºC'),
	(134942, 111, '2015-04-01 00:20:45.000000', 'temperatura', 901.0000, 'ºC'),
	(134943, 111, '2015-04-01 00:20:46.000000', 'temperatura', 939.0000, 'ºC'),
	(134944, 111, '2015-04-01 00:20:47.000000', 'temperatura', 793.0000, 'ºC'),
	(134945, 111, '2015-04-01 00:20:48.000000', 'temperatura', 1150.0000, 'ºC'),
	(134946, 111, '2015-04-01 00:20:49.000000', 'temperatura', 970.0000, 'ºC'),
	(134947, 111, '2015-04-01 00:20:50.000000', 'temperatura', 200.0000, 'ºC'),
	(134948, 111, '2015-04-01 00:20:51.000000', 'temperatura', 490.0000, 'ºC'),
	(134949, 111, '2015-04-01 00:20:52.000000', 'temperatura', 649.0000, 'ºC'),
	(134950, 111, '2015-04-01 00:20:53.000000', 'temperatura', 579.0000, 'ºC'),
	(134951, 111, '2015-04-01 00:20:54.000000', 'temperatura', 947.0000, 'ºC'),
	(134952, 111, '2015-04-01 00:20:55.000000', 'temperatura', 601.0000, 'ºC'),
	(134953, 111, '2015-04-01 00:20:56.000000', 'temperatura', 161.0000, 'ºC'),
	(134954, 111, '2015-04-01 00:20:57.000000', 'temperatura', 206.0000, 'ºC'),
	(134955, 111, '2015-04-01 00:20:58.000000', 'temperatura', 545.0000, 'ºC'),
	(134956, 111, '2015-04-01 00:20:59.000000', 'temperatura', 909.0000, 'ºC'),
	(134957, 111, '2015-04-01 00:21:00.000000', 'temperatura', 508.0000, 'ºC'),
	(134958, 111, '2015-04-01 00:21:01.000000', 'temperatura', 1015.0000, 'ºC'),
	(134959, 111, '2015-04-01 00:21:02.000000', 'temperatura', 1149.0000, 'ºC'),
	(134960, 111, '2015-04-01 00:21:03.000000', 'temperatura', 304.0000, 'ºC'),
	(134961, 111, '2015-04-01 00:21:04.000000', 'temperatura', 473.0000, 'ºC'),
	(134962, 111, '2015-04-01 00:21:05.000000', 'temperatura', 253.0000, 'ºC'),
	(134963, 111, '2015-04-01 00:21:06.000000', 'temperatura', 1045.0000, 'ºC'),
	(134964, 111, '2015-04-01 00:21:07.000000', 'temperatura', 866.0000, 'ºC'),
	(134965, 111, '2015-04-01 00:21:08.000000', 'temperatura', 1196.0000, 'ºC'),
	(134966, 111, '2015-04-01 00:21:09.000000', 'temperatura', 983.0000, 'ºC'),
	(134967, 111, '2015-04-01 00:21:10.000000', 'temperatura', 126.0000, 'ºC'),
	(134968, 111, '2015-04-01 00:21:11.000000', 'temperatura', 83.0000, 'ºC'),
	(134969, 111, '2015-04-01 00:21:12.000000', 'temperatura', 36.0000, 'ºC'),
	(134970, 111, '2015-04-01 00:21:13.000000', 'temperatura', 1131.0000, 'ºC'),
	(134971, 111, '2015-04-01 00:21:14.000000', 'temperatura', 749.0000, 'ºC'),
	(134972, 111, '2015-04-01 00:21:15.000000', 'temperatura', 350.0000, 'ºC'),
	(134973, 111, '2015-04-01 00:21:16.000000', 'temperatura', 705.0000, 'ºC'),
	(134974, 111, '2015-04-01 00:21:17.000000', 'temperatura', 75.0000, 'ºC'),
	(134975, 111, '2015-04-01 00:21:18.000000', 'temperatura', 660.0000, 'ºC'),
	(134976, 111, '2015-04-01 00:21:19.000000', 'temperatura', 677.0000, 'ºC'),
	(134977, 111, '2015-04-01 00:21:20.000000', 'temperatura', 203.0000, 'ºC'),
	(134978, 111, '2015-04-01 00:21:21.000000', 'temperatura', 187.0000, 'ºC'),
	(134979, 111, '2015-04-01 00:21:22.000000', 'temperatura', 326.0000, 'ºC'),
	(134980, 111, '2015-04-01 00:21:23.000000', 'temperatura', 1067.0000, 'ºC'),
	(134981, 111, '2015-04-01 00:21:24.000000', 'temperatura', 761.0000, 'ºC'),
	(134982, 111, '2015-04-01 00:21:25.000000', 'temperatura', 602.0000, 'ºC'),
	(134983, 111, '2015-04-01 00:21:26.000000', 'temperatura', 730.0000, 'ºC'),
	(134984, 111, '2015-04-01 00:21:27.000000', 'temperatura', 644.0000, 'ºC'),
	(134985, 111, '2015-04-01 00:21:28.000000', 'temperatura', 1032.0000, 'ºC'),
	(134986, 111, '2015-04-01 00:21:29.000000', 'temperatura', 827.0000, 'ºC'),
	(134987, 111, '2015-04-01 00:21:30.000000', 'temperatura', 1042.0000, 'ºC'),
	(134988, 111, '2015-04-01 00:21:31.000000', 'temperatura', 326.0000, 'ºC'),
	(134989, 111, '2015-04-01 00:21:32.000000', 'temperatura', 907.0000, 'ºC'),
	(134990, 111, '2015-04-01 00:21:33.000000', 'temperatura', 1156.0000, 'ºC'),
	(134991, 111, '2015-04-01 00:21:34.000000', 'temperatura', 660.0000, 'ºC'),
	(134992, 111, '2015-04-01 00:21:35.000000', 'temperatura', 1033.0000, 'ºC'),
	(134993, 111, '2015-04-01 00:21:36.000000', 'temperatura', 785.0000, 'ºC'),
	(134994, 111, '2015-04-01 00:21:37.000000', 'temperatura', 825.0000, 'ºC'),
	(134995, 111, '2015-04-01 00:21:38.000000', 'temperatura', 571.0000, 'ºC'),
	(134996, 111, '2015-04-01 00:21:39.000000', 'temperatura', 381.0000, 'ºC'),
	(134997, 111, '2015-04-01 00:21:40.000000', 'temperatura', 194.0000, 'ºC'),
	(134998, 111, '2015-04-01 00:21:41.000000', 'temperatura', 1026.0000, 'ºC'),
	(134999, 111, '2015-04-01 00:21:42.000000', 'temperatura', 949.0000, 'ºC'),
	(135000, 111, '2015-04-01 00:21:43.000000', 'temperatura', 469.0000, 'ºC'),
	(135001, 111, '2015-04-01 00:21:44.000000', 'temperatura', 696.0000, 'ºC'),
	(135002, 111, '2015-04-01 00:21:45.000000', 'temperatura', 875.0000, 'ºC'),
	(135003, 111, '2015-04-01 00:21:46.000000', 'temperatura', 1087.0000, 'ºC'),
	(135004, 111, '2015-04-01 00:21:47.000000', 'temperatura', 410.0000, 'ºC'),
	(135005, 111, '2015-04-01 00:21:48.000000', 'temperatura', 1188.0000, 'ºC'),
	(135006, 111, '2015-04-01 00:21:49.000000', 'temperatura', 1114.0000, 'ºC'),
	(135007, 111, '2015-04-01 00:21:50.000000', 'temperatura', 804.0000, 'ºC'),
	(135008, 111, '2015-04-01 00:21:51.000000', 'temperatura', 681.0000, 'ºC'),
	(135009, 111, '2015-04-01 00:21:52.000000', 'temperatura', 991.0000, 'ºC'),
	(135010, 111, '2015-04-01 00:21:53.000000', 'temperatura', 513.0000, 'ºC'),
	(135011, 111, '2015-04-01 00:21:54.000000', 'temperatura', 791.0000, 'ºC'),
	(135012, 111, '2015-04-01 00:21:55.000000', 'temperatura', 18.0000, 'ºC'),
	(135013, 111, '2015-04-01 00:21:56.000000', 'temperatura', 119.0000, 'ºC'),
	(135014, 111, '2015-04-01 00:21:57.000000', 'temperatura', 540.0000, 'ºC'),
	(135015, 111, '2015-04-01 00:21:58.000000', 'temperatura', 1143.0000, 'ºC'),
	(135016, 111, '2015-04-01 00:21:59.000000', 'temperatura', 495.0000, 'ºC'),
	(135017, 111, '2015-04-01 00:22:00.000000', 'temperatura', 245.0000, 'ºC'),
	(135018, 111, '2015-04-01 00:22:01.000000', 'temperatura', 943.0000, 'ºC'),
	(135019, 111, '2015-04-01 00:22:02.000000', 'temperatura', 378.0000, 'ºC'),
	(135020, 111, '2015-04-01 00:22:03.000000', 'temperatura', 265.0000, 'ºC'),
	(135021, 111, '2015-04-01 00:22:04.000000', 'temperatura', 188.0000, 'ºC'),
	(135022, 111, '2015-04-01 00:22:05.000000', 'temperatura', 146.0000, 'ºC'),
	(135023, 111, '2015-04-01 00:22:06.000000', 'temperatura', 167.0000, 'ºC'),
	(135024, 111, '2015-04-01 00:22:07.000000', 'temperatura', 398.0000, 'ºC'),
	(135025, 111, '2015-04-01 00:22:08.000000', 'temperatura', 289.0000, 'ºC'),
	(135026, 111, '2015-04-01 00:22:09.000000', 'temperatura', 250.0000, 'ºC'),
	(135027, 111, '2015-04-01 00:22:10.000000', 'temperatura', 385.0000, 'ºC'),
	(135028, 111, '2015-04-01 00:22:11.000000', 'temperatura', 1177.0000, 'ºC'),
	(135029, 111, '2015-04-01 00:22:12.000000', 'temperatura', 1130.0000, 'ºC'),
	(135030, 111, '2015-04-01 00:22:13.000000', 'temperatura', 920.0000, 'ºC'),
	(135031, 111, '2015-04-01 00:22:14.000000', 'temperatura', 9.0000, 'ºC'),
	(135032, 111, '2015-04-01 00:22:15.000000', 'temperatura', 887.0000, 'ºC'),
	(135033, 111, '2015-04-01 00:22:16.000000', 'temperatura', 807.0000, 'ºC'),
	(135034, 111, '2015-04-01 00:22:17.000000', 'temperatura', 176.0000, 'ºC'),
	(135035, 111, '2015-04-01 00:22:18.000000', 'temperatura', 857.0000, 'ºC'),
	(135036, 111, '2015-04-01 00:22:19.000000', 'temperatura', 159.0000, 'ºC'),
	(135037, 111, '2015-04-01 00:22:20.000000', 'temperatura', 623.0000, 'ºC'),
	(135038, 111, '2015-04-01 00:22:21.000000', 'temperatura', 241.0000, 'ºC'),
	(135039, 111, '2015-04-01 00:22:22.000000', 'temperatura', 536.0000, 'ºC'),
	(135040, 111, '2015-04-01 00:22:23.000000', 'temperatura', 756.0000, 'ºC'),
	(135041, 111, '2015-04-01 00:22:24.000000', 'temperatura', 974.0000, 'ºC'),
	(135042, 111, '2015-04-01 00:22:25.000000', 'temperatura', 204.0000, 'ºC'),
	(135043, 111, '2015-04-01 00:22:26.000000', 'temperatura', 496.0000, 'ºC'),
	(135044, 111, '2015-04-01 00:22:27.000000', 'temperatura', 668.0000, 'ºC'),
	(135045, 111, '2015-04-01 00:22:28.000000', 'temperatura', 653.0000, 'ºC'),
	(135046, 111, '2015-04-01 00:22:29.000000', 'temperatura', 62.0000, 'ºC'),
	(135047, 111, '2015-04-01 00:22:30.000000', 'temperatura', 749.0000, 'ºC'),
	(135048, 111, '2015-04-01 00:22:31.000000', 'temperatura', 1163.0000, 'ºC'),
	(135049, 111, '2015-04-01 00:22:32.000000', 'temperatura', 1167.0000, 'ºC'),
	(135050, 111, '2015-04-01 00:22:33.000000', 'temperatura', 1147.0000, 'ºC'),
	(135051, 111, '2015-04-01 00:22:34.000000', 'temperatura', 1033.0000, 'ºC'),
	(135052, 111, '2015-04-01 00:22:35.000000', 'temperatura', 527.0000, 'ºC'),
	(135053, 111, '2015-04-01 00:22:36.000000', 'temperatura', 737.0000, 'ºC'),
	(135054, 111, '2015-04-01 00:22:37.000000', 'temperatura', 904.0000, 'ºC'),
	(135055, 111, '2015-04-01 00:22:38.000000', 'temperatura', 1107.0000, 'ºC'),
	(135056, 111, '2015-04-01 00:22:39.000000', 'temperatura', 425.0000, 'ºC'),
	(135057, 111, '2015-04-01 00:22:40.000000', 'temperatura', 4.0000, 'ºC'),
	(135058, 111, '2015-04-01 00:22:41.000000', 'temperatura', 1144.0000, 'ºC'),
	(135059, 111, '2015-04-01 00:22:42.000000', 'temperatura', 911.0000, 'ºC'),
	(135060, 111, '2015-04-01 00:22:43.000000', 'temperatura', 1121.0000, 'ºC'),
	(135061, 111, '2015-04-01 00:22:44.000000', 'temperatura', 476.0000, 'ºC'),
	(135062, 111, '2015-04-01 00:22:45.000000', 'temperatura', 214.0000, 'ºC'),
	(135063, 111, '2015-04-01 00:22:46.000000', 'temperatura', 843.0000, 'ºC'),
	(135064, 111, '2015-04-01 00:22:47.000000', 'temperatura', 1172.0000, 'ºC'),
	(135065, 111, '2015-04-01 00:22:48.000000', 'temperatura', 934.0000, 'ºC'),
	(135066, 111, '2015-04-01 00:22:49.000000', 'temperatura', 1152.0000, 'ºC'),
	(135067, 111, '2015-04-01 00:22:50.000000', 'temperatura', 559.0000, 'ºC'),
	(135068, 111, '2015-04-01 00:22:51.000000', 'temperatura', 539.0000, 'ºC'),
	(135069, 111, '2015-04-01 00:22:52.000000', 'temperatura', 1020.0000, 'ºC'),
	(135070, 111, '2015-04-01 00:22:53.000000', 'temperatura', 1082.0000, 'ºC'),
	(135071, 111, '2015-04-01 00:22:54.000000', 'temperatura', 1152.0000, 'ºC'),
	(135072, 111, '2015-04-01 00:22:55.000000', 'temperatura', 114.0000, 'ºC'),
	(135073, 111, '2015-04-01 00:22:56.000000', 'temperatura', 713.0000, 'ºC'),
	(135074, 111, '2015-04-01 00:22:57.000000', 'temperatura', 824.0000, 'ºC'),
	(135075, 111, '2015-04-01 00:22:58.000000', 'temperatura', 780.0000, 'ºC'),
	(135076, 111, '2015-04-01 00:22:59.000000', 'temperatura', 229.0000, 'ºC'),
	(135077, 111, '2015-04-01 00:23:00.000000', 'temperatura', 4.0000, 'ºC'),
	(135078, 111, '2015-04-01 00:23:01.000000', 'temperatura', 536.0000, 'ºC'),
	(135079, 111, '2015-04-01 00:23:02.000000', 'temperatura', 267.0000, 'ºC'),
	(135080, 111, '2015-04-01 00:23:03.000000', 'temperatura', 930.0000, 'ºC'),
	(135081, 111, '2015-04-01 00:23:04.000000', 'temperatura', 247.0000, 'ºC'),
	(135082, 111, '2015-04-01 00:23:05.000000', 'temperatura', 845.0000, 'ºC'),
	(135083, 111, '2015-04-01 00:23:06.000000', 'temperatura', 1086.0000, 'ºC'),
	(135084, 111, '2015-04-01 00:23:07.000000', 'temperatura', 496.0000, 'ºC'),
	(135085, 111, '2015-04-01 00:23:08.000000', 'temperatura', 420.0000, 'ºC'),
	(135086, 111, '2015-04-01 00:23:09.000000', 'temperatura', 614.0000, 'ºC'),
	(135087, 111, '2015-04-01 00:23:10.000000', 'temperatura', 612.0000, 'ºC'),
	(135088, 111, '2015-04-01 00:23:11.000000', 'temperatura', 15.0000, 'ºC'),
	(135089, 111, '2015-04-01 00:23:12.000000', 'temperatura', 643.0000, 'ºC'),
	(135090, 111, '2015-04-01 00:23:13.000000', 'temperatura', 769.0000, 'ºC'),
	(135091, 111, '2015-04-01 00:23:14.000000', 'temperatura', 717.0000, 'ºC'),
	(135092, 111, '2015-04-01 00:23:15.000000', 'temperatura', 76.0000, 'ºC'),
	(135093, 111, '2015-04-01 00:23:16.000000', 'temperatura', 633.0000, 'ºC'),
	(135094, 111, '2015-04-01 00:23:17.000000', 'temperatura', 535.0000, 'ºC'),
	(135095, 111, '2015-04-01 00:23:18.000000', 'temperatura', 776.0000, 'ºC'),
	(135096, 111, '2015-04-01 00:23:19.000000', 'temperatura', 1078.0000, 'ºC'),
	(135097, 111, '2015-04-01 00:23:20.000000', 'temperatura', 662.0000, 'ºC'),
	(135098, 111, '2015-04-01 00:23:21.000000', 'temperatura', 74.0000, 'ºC'),
	(135099, 111, '2015-04-01 00:23:22.000000', 'temperatura', 787.0000, 'ºC'),
	(135100, 111, '2015-04-01 00:23:23.000000', 'temperatura', 113.0000, 'ºC'),
	(135101, 111, '2015-04-01 00:23:24.000000', 'temperatura', 605.0000, 'ºC'),
	(135102, 111, '2015-04-01 00:23:25.000000', 'temperatura', 284.0000, 'ºC'),
	(135103, 111, '2015-04-01 00:23:26.000000', 'temperatura', 807.0000, 'ºC'),
	(135104, 111, '2015-04-01 00:23:27.000000', 'temperatura', 781.0000, 'ºC'),
	(135105, 111, '2015-04-01 00:23:28.000000', 'temperatura', 288.0000, 'ºC'),
	(135106, 111, '2015-04-01 00:23:29.000000', 'temperatura', 296.0000, 'ºC'),
	(135107, 111, '2015-04-01 00:23:30.000000', 'temperatura', 618.0000, 'ºC'),
	(135108, 111, '2015-04-01 00:23:31.000000', 'temperatura', 1003.0000, 'ºC'),
	(135109, 111, '2015-04-01 00:23:32.000000', 'temperatura', 760.0000, 'ºC'),
	(135110, 111, '2015-04-01 00:23:33.000000', 'temperatura', 794.0000, 'ºC'),
	(135111, 111, '2015-04-01 00:23:34.000000', 'temperatura', 489.0000, 'ºC'),
	(135112, 111, '2015-04-01 00:23:35.000000', 'temperatura', 61.0000, 'ºC'),
	(135113, 111, '2015-04-01 00:23:36.000000', 'temperatura', 42.0000, 'ºC'),
	(135114, 111, '2015-04-01 00:23:37.000000', 'temperatura', 26.0000, 'ºC'),
	(135115, 111, '2015-04-01 00:23:38.000000', 'temperatura', 3.0000, 'ºC'),
	(135116, 111, '2015-04-01 00:23:39.000000', 'temperatura', 1141.0000, 'ºC'),
	(135117, 111, '2015-04-01 00:23:40.000000', 'temperatura', 893.0000, 'ºC'),
	(135118, 111, '2015-04-01 00:23:41.000000', 'temperatura', 1043.0000, 'ºC'),
	(135119, 111, '2015-04-01 00:23:42.000000', 'temperatura', 138.0000, 'ºC'),
	(135120, 111, '2015-04-01 00:23:43.000000', 'temperatura', 1161.0000, 'ºC'),
	(135121, 111, '2015-04-01 00:23:44.000000', 'temperatura', 590.0000, 'ºC'),
	(135122, 111, '2015-04-01 00:23:45.000000', 'temperatura', 669.0000, 'ºC'),
	(135123, 111, '2015-04-01 00:23:46.000000', 'temperatura', 375.0000, 'ºC'),
	(135124, 111, '2015-04-01 00:23:47.000000', 'temperatura', 1069.0000, 'ºC'),
	(135125, 111, '2015-04-01 00:23:48.000000', 'temperatura', 620.0000, 'ºC'),
	(135126, 111, '2015-04-01 00:23:49.000000', 'temperatura', 1093.0000, 'ºC'),
	(135127, 111, '2015-04-01 00:23:50.000000', 'temperatura', 5.0000, 'ºC'),
	(135128, 111, '2015-04-01 00:23:51.000000', 'temperatura', 348.0000, 'ºC'),
	(135129, 111, '2015-04-01 00:23:52.000000', 'temperatura', 523.0000, 'ºC'),
	(135130, 111, '2015-04-01 00:23:53.000000', 'temperatura', 375.0000, 'ºC'),
	(135131, 111, '2015-04-01 00:23:54.000000', 'temperatura', 304.0000, 'ºC'),
	(135132, 111, '2015-04-01 00:23:55.000000', 'temperatura', 395.0000, 'ºC'),
	(135133, 111, '2015-04-01 00:23:56.000000', 'temperatura', 1066.0000, 'ºC'),
	(135134, 111, '2015-04-01 00:23:57.000000', 'temperatura', 543.0000, 'ºC'),
	(135135, 111, '2015-04-01 00:23:58.000000', 'temperatura', 718.0000, 'ºC'),
	(135136, 111, '2015-04-01 00:23:59.000000', 'temperatura', 761.0000, 'ºC'),
	(135137, 111, '2015-04-01 00:24:00.000000', 'temperatura', 454.0000, 'ºC'),
	(135138, 111, '2015-04-01 00:24:01.000000', 'temperatura', 1187.0000, 'ºC'),
	(135139, 111, '2015-04-01 00:24:02.000000', 'temperatura', 973.0000, 'ºC'),
	(135140, 111, '2015-04-01 00:24:03.000000', 'temperatura', 104.0000, 'ºC'),
	(135141, 111, '2015-04-01 00:24:04.000000', 'temperatura', 3.0000, 'ºC'),
	(135142, 111, '2015-04-01 00:24:05.000000', 'temperatura', 901.0000, 'ºC'),
	(135143, 111, '2015-04-01 00:24:06.000000', 'temperatura', 896.0000, 'ºC'),
	(135144, 111, '2015-04-01 00:24:07.000000', 'temperatura', 580.0000, 'ºC'),
	(135145, 111, '2015-04-01 00:24:08.000000', 'temperatura', 211.0000, 'ºC'),
	(135146, 111, '2015-04-01 00:24:09.000000', 'temperatura', 514.0000, 'ºC'),
	(135147, 111, '2015-04-01 00:24:10.000000', 'temperatura', 741.0000, 'ºC'),
	(135148, 111, '2015-04-01 00:24:11.000000', 'temperatura', 962.0000, 'ºC'),
	(135149, 111, '2015-04-01 00:24:12.000000', 'temperatura', 186.0000, 'ºC'),
	(135150, 111, '2015-04-01 00:24:13.000000', 'temperatura', 447.0000, 'ºC'),
	(135151, 111, '2015-04-01 00:24:14.000000', 'temperatura', 476.0000, 'ºC'),
	(135152, 111, '2015-04-01 00:24:15.000000', 'temperatura', 1041.0000, 'ºC'),
	(135153, 111, '2015-04-01 00:24:16.000000', 'temperatura', 179.0000, 'ºC'),
	(135154, 111, '2015-04-01 00:24:17.000000', 'temperatura', 170.0000, 'ºC'),
	(135155, 111, '2015-04-01 00:24:18.000000', 'temperatura', 312.0000, 'ºC'),
	(135156, 111, '2015-04-01 00:24:19.000000', 'temperatura', 1054.0000, 'ºC'),
	(135157, 111, '2015-04-01 00:24:20.000000', 'temperatura', 732.0000, 'ºC'),
	(135158, 111, '2015-04-01 00:24:21.000000', 'temperatura', 500.0000, 'ºC'),
	(135159, 111, '2015-04-01 00:24:22.000000', 'temperatura', 303.0000, 'ºC'),
	(135160, 111, '2015-04-01 00:24:23.000000', 'temperatura', 14.0000, 'ºC'),
	(135161, 111, '2015-04-01 00:24:24.000000', 'temperatura', 364.0000, 'ºC'),
	(135162, 111, '2015-04-01 00:24:25.000000', 'temperatura', 576.0000, 'ºC'),
	(135163, 111, '2015-04-01 00:24:26.000000', 'temperatura', 588.0000, 'ºC'),
	(135164, 111, '2015-04-01 00:24:27.000000', 'temperatura', 16.0000, 'ºC'),
	(135165, 111, '2015-04-01 00:24:28.000000', 'temperatura', 714.0000, 'ºC'),
	(135166, 111, '2015-04-01 00:24:29.000000', 'temperatura', 1122.0000, 'ºC'),
	(135167, 111, '2015-04-01 00:24:30.000000', 'temperatura', 1071.0000, 'ºC'),
	(135168, 111, '2015-04-01 00:24:31.000000', 'temperatura', 789.0000, 'ºC'),
	(135169, 111, '2015-04-01 00:24:32.000000', 'temperatura', 734.0000, 'ºC'),
	(135170, 111, '2015-04-01 00:24:33.000000', 'temperatura', 103.0000, 'ºC'),
	(135171, 111, '2015-04-01 00:24:34.000000', 'temperatura', 712.0000, 'ºC'),
	(135172, 111, '2015-04-01 00:24:35.000000', 'temperatura', 851.0000, 'ºC'),
	(135173, 111, '2015-04-01 00:24:36.000000', 'temperatura', 919.0000, 'ºC'),
	(135174, 111, '2015-04-01 00:24:37.000000', 'temperatura', 844.0000, 'ºC'),
	(135175, 111, '2015-04-01 00:24:38.000000', 'temperatura', 263.0000, 'ºC'),
	(135176, 111, '2015-04-01 00:24:39.000000', 'temperatura', 1182.0000, 'ºC'),
	(135177, 111, '2015-04-01 00:24:40.000000', 'temperatura', 321.0000, 'ºC'),
	(135178, 111, '2015-04-01 00:24:41.000000', 'temperatura', 462.0000, 'ºC'),
	(135179, 111, '2015-04-01 00:24:42.000000', 'temperatura', 146.0000, 'ºC'),
	(135180, 111, '2015-04-01 00:24:43.000000', 'temperatura', 546.0000, 'ºC'),
	(135181, 111, '2015-04-01 00:24:44.000000', 'temperatura', 1093.0000, 'ºC'),
	(135182, 111, '2015-04-01 00:24:45.000000', 'temperatura', 228.0000, 'ºC'),
	(135183, 111, '2015-04-01 00:24:46.000000', 'temperatura', 260.0000, 'ºC'),
	(135184, 111, '2015-04-01 00:24:47.000000', 'temperatura', 617.0000, 'ºC'),
	(135185, 111, '2015-04-01 00:24:48.000000', 'temperatura', 1103.0000, 'ºC'),
	(135186, 111, '2015-04-01 00:24:49.000000', 'temperatura', 67.0000, 'ºC'),
	(135187, 111, '2015-04-01 00:24:50.000000', 'temperatura', 628.0000, 'ºC'),
	(135188, 111, '2015-04-01 00:24:51.000000', 'temperatura', 536.0000, 'ºC'),
	(135189, 111, '2015-04-01 00:24:52.000000', 'temperatura', 800.0000, 'ºC'),
	(135190, 111, '2015-04-01 00:24:53.000000', 'temperatura', 1191.0000, 'ºC'),
	(135191, 111, '2015-04-01 00:24:54.000000', 'temperatura', 1156.0000, 'ºC'),
	(135192, 111, '2015-04-01 00:24:55.000000', 'temperatura', 1006.0000, 'ºC'),
	(135193, 111, '2015-04-01 00:24:56.000000', 'temperatura', 362.0000, 'ºC'),
	(135194, 111, '2015-04-01 00:24:57.000000', 'temperatura', 1193.0000, 'ºC'),
	(135195, 111, '2015-04-01 00:24:58.000000', 'temperatura', 82.0000, 'ºC'),
	(135196, 111, '2015-04-01 00:24:59.000000', 'temperatura', 429.0000, 'ºC'),
	(135197, 111, '2015-04-01 00:25:00.000000', 'temperatura', 702.0000, 'ºC'),
	(135198, 111, '2015-04-01 00:25:01.000000', 'temperatura', 1023.0000, 'ºC'),
	(135199, 111, '2015-04-01 00:25:02.000000', 'temperatura', 609.0000, 'ºC'),
	(135200, 111, '2015-04-01 00:25:03.000000', 'temperatura', 1175.0000, 'ºC'),
	(135201, 111, '2015-04-01 00:25:04.000000', 'temperatura', 452.0000, 'ºC'),
	(135202, 111, '2015-04-01 00:25:05.000000', 'temperatura', 1132.0000, 'ºC'),
	(135203, 111, '2015-04-01 00:25:06.000000', 'temperatura', 707.0000, 'ºC'),
	(135204, 111, '2015-04-01 00:25:07.000000', 'temperatura', 139.0000, 'ºC'),
	(135205, 111, '2015-04-01 00:25:08.000000', 'temperatura', 973.0000, 'ºC'),
	(135206, 111, '2015-04-01 00:25:09.000000', 'temperatura', 851.0000, 'ºC'),
	(135207, 111, '2015-04-01 00:25:10.000000', 'temperatura', 133.0000, 'ºC'),
	(135208, 111, '2015-04-01 00:25:11.000000', 'temperatura', 515.0000, 'ºC'),
	(135209, 111, '2015-04-01 00:25:12.000000', 'temperatura', 976.0000, 'ºC'),
	(135210, 111, '2015-04-01 00:25:13.000000', 'temperatura', 937.0000, 'ºC'),
	(135211, 111, '2015-04-01 00:25:14.000000', 'temperatura', 556.0000, 'ºC'),
	(135212, 111, '2015-04-01 00:25:15.000000', 'temperatura', 1170.0000, 'ºC'),
	(135213, 111, '2015-04-01 00:25:16.000000', 'temperatura', 584.0000, 'ºC'),
	(135214, 111, '2015-04-01 00:25:17.000000', 'temperatura', 608.0000, 'ºC'),
	(135215, 111, '2015-04-01 00:25:18.000000', 'temperatura', 91.0000, 'ºC'),
	(135216, 111, '2015-04-01 00:25:19.000000', 'temperatura', 1031.0000, 'ºC'),
	(135217, 111, '2015-04-01 00:25:20.000000', 'temperatura', 84.0000, 'ºC'),
	(135218, 111, '2015-04-01 00:25:21.000000', 'temperatura', 927.0000, 'ºC'),
	(135219, 111, '2015-04-01 00:25:22.000000', 'temperatura', 782.0000, 'ºC'),
	(135220, 111, '2015-04-01 00:25:23.000000', 'temperatura', 1130.0000, 'ºC'),
	(135221, 111, '2015-04-01 00:25:24.000000', 'temperatura', 903.0000, 'ºC'),
	(135222, 111, '2015-04-01 00:25:25.000000', 'temperatura', 1128.0000, 'ºC'),
	(135223, 111, '2015-04-01 00:25:26.000000', 'temperatura', 532.0000, 'ºC'),
	(135224, 111, '2015-04-01 00:25:27.000000', 'temperatura', 477.0000, 'ºC'),
	(135225, 111, '2015-04-01 00:25:28.000000', 'temperatura', 790.0000, 'ºC'),
	(135226, 111, '2015-04-01 00:25:29.000000', 'temperatura', 119.0000, 'ºC'),
	(135227, 111, '2015-04-01 00:25:30.000000', 'temperatura', 624.0000, 'ºC'),
	(135228, 111, '2015-04-01 00:25:31.000000', 'temperatura', 365.0000, 'ºC'),
	(135229, 111, '2015-04-01 00:25:32.000000', 'temperatura', 1155.0000, 'ºC'),
	(135230, 111, '2015-04-01 00:25:33.000000', 'temperatura', 1078.0000, 'ºC'),
	(135231, 111, '2015-04-01 00:25:34.000000', 'temperatura', 727.0000, 'ºC'),
	(135232, 111, '2015-04-01 00:25:35.000000', 'temperatura', 401.0000, 'ºC'),
	(135233, 111, '2015-04-01 00:25:36.000000', 'temperatura', 1022.0000, 'ºC'),
	(135234, 111, '2015-04-01 00:25:37.000000', 'temperatura', 311.0000, 'ºC'),
	(135235, 111, '2015-04-01 00:25:38.000000', 'temperatura', 890.0000, 'ºC'),
	(135236, 111, '2015-04-01 00:25:39.000000', 'temperatura', 1116.0000, 'ºC'),
	(135237, 111, '2015-04-01 00:25:40.000000', 'temperatura', 509.0000, 'ºC'),
	(135238, 111, '2015-04-01 00:25:41.000000', 'temperatura', 401.0000, 'ºC'),
	(135239, 111, '2015-04-01 00:25:42.000000', 'temperatura', 476.0000, 'ºC'),
	(135240, 111, '2015-04-01 00:25:43.000000', 'temperatura', 1178.0000, 'ºC'),
	(135241, 111, '2015-04-01 00:25:44.000000', 'temperatura', 861.0000, 'ºC'),
	(135242, 111, '2015-04-01 00:25:45.000000', 'temperatura', 773.0000, 'ºC'),
	(135243, 111, '2015-04-01 00:25:46.000000', 'temperatura', 83.0000, 'ºC'),
	(135244, 111, '2015-04-01 00:25:47.000000', 'temperatura', 495.0000, 'ºC'),
	(135245, 111, '2015-04-01 00:25:48.000000', 'temperatura', 1029.0000, 'ºC'),
	(135246, 111, '2015-04-01 00:25:49.000000', 'temperatura', 60.0000, 'ºC'),
	(135247, 111, '2015-04-01 00:25:50.000000', 'temperatura', 811.0000, 'ºC'),
	(135248, 111, '2015-04-01 00:25:51.000000', 'temperatura', 277.0000, 'ºC'),
	(135249, 111, '2015-04-01 00:25:52.000000', 'temperatura', 152.0000, 'ºC'),
	(135250, 111, '2015-04-01 00:25:53.000000', 'temperatura', 1130.0000, 'ºC'),
	(135251, 111, '2015-04-01 00:25:54.000000', 'temperatura', 395.0000, 'ºC'),
	(135252, 111, '2015-04-01 00:25:55.000000', 'temperatura', 985.0000, 'ºC'),
	(135253, 111, '2015-04-01 00:25:56.000000', 'temperatura', 140.0000, 'ºC'),
	(135254, 111, '2015-04-01 00:25:57.000000', 'temperatura', 145.0000, 'ºC'),
	(135255, 111, '2015-04-01 00:25:58.000000', 'temperatura', 307.0000, 'ºC'),
	(135256, 111, '2015-04-01 00:25:59.000000', 'temperatura', 1102.0000, 'ºC'),
	(135257, 111, '2015-04-01 00:26:00.000000', 'temperatura', 988.0000, 'ºC'),
	(135258, 111, '2015-04-01 00:26:01.000000', 'temperatura', 433.0000, 'ºC'),
	(135259, 111, '2015-04-01 00:26:02.000000', 'temperatura', 404.0000, 'ºC'),
	(135260, 111, '2015-04-01 00:26:03.000000', 'temperatura', 722.0000, 'ºC'),
	(135261, 111, '2015-04-01 00:26:04.000000', 'temperatura', 1197.0000, 'ºC'),
	(135262, 111, '2015-04-01 00:26:05.000000', 'temperatura', 222.0000, 'ºC'),
	(135263, 111, '2015-04-01 00:26:06.000000', 'temperatura', 1118.0000, 'ºC'),
	(135264, 111, '2015-04-01 00:26:07.000000', 'temperatura', 123.0000, 'ºC'),
	(135265, 111, '2015-04-01 00:26:08.000000', 'temperatura', 861.0000, 'ºC'),
	(135266, 111, '2015-04-01 00:26:09.000000', 'temperatura', 337.0000, 'ºC'),
	(135267, 111, '2015-04-01 00:26:10.000000', 'temperatura', 301.0000, 'ºC'),
	(135268, 111, '2015-04-01 00:26:11.000000', 'temperatura', 497.0000, 'ºC'),
	(135269, 111, '2015-04-01 00:26:12.000000', 'temperatura', 383.0000, 'ºC'),
	(135270, 111, '2015-04-01 00:26:13.000000', 'temperatura', 422.0000, 'ºC'),
	(135271, 111, '2015-04-01 00:26:14.000000', 'temperatura', 962.0000, 'ºC'),
	(135272, 111, '2015-04-01 00:26:15.000000', 'temperatura', 1145.0000, 'ºC'),
	(135273, 111, '2015-04-01 00:26:16.000000', 'temperatura', 440.0000, 'ºC'),
	(135274, 111, '2015-04-01 00:26:17.000000', 'temperatura', 1165.0000, 'ºC'),
	(135275, 111, '2015-04-01 00:26:18.000000', 'temperatura', 905.0000, 'ºC'),
	(135276, 111, '2015-04-01 00:26:19.000000', 'temperatura', 1033.0000, 'ºC'),
	(135277, 111, '2015-04-01 00:26:20.000000', 'temperatura', 48.0000, 'ºC'),
	(135278, 111, '2015-04-01 00:26:21.000000', 'temperatura', 742.0000, 'ºC'),
	(135279, 111, '2015-04-01 00:26:22.000000', 'temperatura', 1165.0000, 'ºC'),
	(135280, 111, '2015-04-01 00:26:23.000000', 'temperatura', 1.0000, 'ºC'),
	(135281, 111, '2015-04-01 00:26:24.000000', 'temperatura', 110.0000, 'ºC'),
	(135282, 111, '2015-04-01 00:26:25.000000', 'temperatura', 550.0000, 'ºC'),
	(135283, 111, '2015-04-01 00:26:26.000000', 'temperatura', 17.0000, 'ºC'),
	(135284, 111, '2015-04-01 00:26:27.000000', 'temperatura', 839.0000, 'ºC'),
	(135285, 111, '2015-04-01 00:26:28.000000', 'temperatura', 542.0000, 'ºC'),
	(135286, 111, '2015-04-01 00:26:29.000000', 'temperatura', 192.0000, 'ºC'),
	(135287, 111, '2015-04-01 00:26:30.000000', 'temperatura', 537.0000, 'ºC'),
	(135288, 111, '2015-04-01 00:26:31.000000', 'temperatura', 908.0000, 'ºC'),
	(135289, 111, '2015-04-01 00:26:32.000000', 'temperatura', 530.0000, 'ºC'),
	(135290, 111, '2015-04-01 00:26:33.000000', 'temperatura', 1125.0000, 'ºC'),
	(135291, 111, '2015-04-01 00:26:34.000000', 'temperatura', 437.0000, 'ºC'),
	(135292, 111, '2015-04-01 00:26:35.000000', 'temperatura', 12.0000, 'ºC'),
	(135293, 111, '2015-04-01 00:26:36.000000', 'temperatura', 1147.0000, 'ºC'),
	(135294, 111, '2015-04-01 00:26:37.000000', 'temperatura', 901.0000, 'ºC'),
	(135295, 111, '2015-04-01 00:26:38.000000', 'temperatura', 1066.0000, 'ºC'),
	(135296, 111, '2015-04-01 00:26:39.000000', 'temperatura', 224.0000, 'ºC'),
	(135297, 111, '2015-04-01 00:26:40.000000', 'temperatura', 326.0000, 'ºC'),
	(135298, 111, '2015-04-01 00:26:41.000000', 'temperatura', 957.0000, 'ºC'),
	(135299, 111, '2015-04-01 00:26:42.000000', 'temperatura', 207.0000, 'ºC'),
	(135300, 111, '2015-04-01 00:26:43.000000', 'temperatura', 563.0000, 'ºC'),
	(135301, 111, '2015-04-01 00:26:44.000000', 'temperatura', 996.0000, 'ºC'),
	(135302, 111, '2015-04-01 00:26:45.000000', 'temperatura', 893.0000, 'ºC'),
	(135303, 111, '2015-04-01 00:26:46.000000', 'temperatura', 277.0000, 'ºC'),
	(135304, 111, '2015-04-01 00:26:47.000000', 'temperatura', 1105.0000, 'ºC'),
	(135305, 111, '2015-04-01 00:26:48.000000', 'temperatura', 1097.0000, 'ºC'),
	(135306, 111, '2015-04-01 00:26:49.000000', 'temperatura', 970.0000, 'ºC'),
	(135307, 111, '2015-04-01 00:26:50.000000', 'temperatura', 359.0000, 'ºC'),
	(135308, 111, '2015-04-01 00:26:51.000000', 'temperatura', 86.0000, 'ºC'),
	(135309, 111, '2015-04-01 00:26:52.000000', 'temperatura', 552.0000, 'ºC'),
	(135310, 111, '2015-04-01 00:26:53.000000', 'temperatura', 101.0000, 'ºC'),
	(135311, 111, '2015-04-01 00:26:54.000000', 'temperatura', 53.0000, 'ºC'),
	(135312, 111, '2015-04-01 00:26:55.000000', 'temperatura', 1161.0000, 'ºC'),
	(135313, 111, '2015-04-01 00:26:56.000000', 'temperatura', 846.0000, 'ºC'),
	(135314, 111, '2015-04-01 00:26:57.000000', 'temperatura', 746.0000, 'ºC'),
	(135315, 111, '2015-04-01 00:26:58.000000', 'temperatura', 1195.0000, 'ºC'),
	(135316, 111, '2015-04-01 00:26:59.000000', 'temperatura', 138.0000, 'ºC'),
	(135317, 111, '2015-04-01 00:27:00.000000', 'temperatura', 704.0000, 'ºC'),
	(135318, 111, '2015-04-01 00:27:01.000000', 'temperatura', 705.0000, 'ºC'),
	(135319, 111, '2015-04-01 00:27:02.000000', 'temperatura', 215.0000, 'ºC'),
	(135320, 111, '2015-04-01 00:27:03.000000', 'temperatura', 161.0000, 'ºC'),
	(135321, 111, '2015-04-01 00:27:04.000000', 'temperatura', 160.0000, 'ºC'),
	(135322, 111, '2015-04-01 00:27:05.000000', 'temperatura', 318.0000, 'ºC'),
	(135323, 111, '2015-04-01 00:27:06.000000', 'temperatura', 1112.0000, 'ºC'),
	(135324, 111, '2015-04-01 00:27:07.000000', 'temperatura', 1006.0000, 'ºC'),
	(135325, 111, '2015-04-01 00:27:08.000000', 'temperatura', 496.0000, 'ºC'),
	(135326, 111, '2015-04-01 00:27:09.000000', 'temperatura', 661.0000, 'ºC'),
	(135327, 111, '2015-04-01 00:27:10.000000', 'temperatura', 617.0000, 'ºC'),
	(135328, 111, '2015-04-01 00:27:11.000000', 'temperatura', 1105.0000, 'ºC'),
	(135329, 111, '2015-04-01 00:27:12.000000', 'temperatura', 71.0000, 'ºC'),
	(135330, 111, '2015-04-01 00:27:13.000000', 'temperatura', 642.0000, 'ºC'),
	(135331, 111, '2015-04-01 00:27:14.000000', 'temperatura', 599.0000, 'ºC'),
	(135332, 111, '2015-04-01 00:27:15.000000', 'temperatura', 1069.0000, 'ºC'),
	(135333, 111, '2015-04-01 00:27:16.000000', 'temperatura', 1146.0000, 'ºC'),
	(135334, 111, '2015-04-01 00:27:17.000000', 'temperatura', 127.0000, 'ºC'),
	(135335, 111, '2015-04-01 00:27:18.000000', 'temperatura', 795.0000, 'ºC'),
	(135336, 111, '2015-04-01 00:27:19.000000', 'temperatura', 1194.0000, 'ºC'),
	(135337, 111, '2015-04-01 00:27:20.000000', 'temperatura', 1188.0000, 'ºC'),
	(135338, 111, '2015-04-01 00:27:21.000000', 'temperatura', 1157.0000, 'ºC'),
	(135339, 111, '2015-04-01 00:27:22.000000', 'temperatura', 1020.0000, 'ºC'),
	(135340, 111, '2015-04-01 00:27:23.000000', 'temperatura', 430.0000, 'ºC'),
	(135341, 111, '2015-04-01 00:27:24.000000', 'temperatura', 289.0000, 'ºC'),
	(135342, 111, '2015-04-01 00:27:25.000000', 'temperatura', 159.0000, 'ºC'),
	(135343, 111, '2015-04-01 00:27:26.000000', 'temperatura', 1126.0000, 'ºC'),
	(135344, 111, '2015-04-01 00:27:27.000000', 'temperatura', 354.0000, 'ºC'),
	(135345, 111, '2015-04-01 00:27:28.000000', 'temperatura', 792.0000, 'ºC'),
	(135346, 111, '2015-04-01 00:27:29.000000', 'temperatura', 498.0000, 'ºC'),
	(135347, 111, '2015-04-01 00:27:30.000000', 'temperatura', 115.0000, 'ºC'),
	(135348, 111, '2015-04-01 00:27:31.000000', 'temperatura', 281.0000, 'ºC'),
	(135349, 111, '2015-04-01 00:27:32.000000', 'temperatura', 1063.0000, 'ºC'),
	(135350, 111, '2015-04-01 00:27:33.000000', 'temperatura', 869.0000, 'ºC'),
	(135351, 111, '2015-04-01 00:27:34.000000', 'temperatura', 1158.0000, 'ºC'),
	(135352, 111, '2015-04-01 00:27:35.000000', 'temperatura', 782.0000, 'ºC'),
	(135353, 111, '2015-04-01 00:27:36.000000', 'temperatura', 435.0000, 'ºC'),
	(135354, 111, '2015-04-01 00:27:37.000000', 'temperatura', 1033.0000, 'ºC'),
	(135355, 111, '2015-04-01 00:27:38.000000', 'temperatura', 261.0000, 'ºC'),
	(135356, 111, '2015-04-01 00:27:39.000000', 'temperatura', 605.0000, 'ºC'),
	(135357, 111, '2015-04-01 00:27:40.000000', 'temperatura', 1042.0000, 'ºC'),
	(135358, 111, '2015-04-01 00:27:41.000000', 'temperatura', 994.0000, 'ºC'),
	(135359, 111, '2015-04-01 00:27:42.000000', 'temperatura', 646.0000, 'ºC'),
	(135360, 111, '2015-04-01 00:27:43.000000', 'temperatura', 251.0000, 'ºC'),
	(135361, 111, '2015-04-01 00:27:44.000000', 'temperatura', 514.0000, 'ºC'),
	(135362, 111, '2015-04-01 00:27:45.000000', 'temperatura', 617.0000, 'ºC'),
	(135363, 111, '2015-04-01 00:27:46.000000', 'temperatura', 345.0000, 'ºC'),
	(135364, 111, '2015-04-01 00:27:47.000000', 'temperatura', 1074.0000, 'ºC'),
	(135365, 111, '2015-04-01 00:27:48.000000', 'temperatura', 737.0000, 'ºC'),
	(135366, 111, '2015-04-01 00:27:49.000000', 'temperatura', 463.0000, 'ºC'),
	(135367, 111, '2015-04-01 00:27:50.000000', 'temperatura', 103.0000, 'ºC'),
	(135368, 111, '2015-04-01 00:27:51.000000', 'temperatura', 326.0000, 'ºC'),
	(135369, 111, '2015-04-01 00:27:52.000000', 'temperatura', 123.0000, 'ºC'),
	(135370, 111, '2015-04-01 00:27:53.000000', 'temperatura', 839.0000, 'ºC'),
	(135371, 111, '2015-04-01 00:27:54.000000', 'temperatura', 223.0000, 'ºC'),
	(135372, 111, '2015-04-01 00:27:55.000000', 'temperatura', 1002.0000, 'ºC'),
	(135373, 111, '2015-04-01 00:27:56.000000', 'temperatura', 738.0000, 'ºC'),
	(135374, 111, '2015-04-01 00:27:57.000000', 'temperatura', 686.0000, 'ºC'),
	(135375, 111, '2015-04-01 00:27:58.000000', 'temperatura', 18.0000, 'ºC'),
	(135376, 111, '2015-04-01 00:27:59.000000', 'temperatura', 430.0000, 'ºC'),
	(135377, 111, '2015-04-01 00:28:00.000000', 'temperatura', 896.0000, 'ºC'),
	(135378, 111, '2015-04-01 00:28:01.000000', 'temperatura', 790.0000, 'ºC'),
	(135379, 111, '2015-04-01 00:28:02.000000', 'temperatura', 63.0000, 'ºC'),
	(135380, 111, '2015-04-01 00:28:03.000000', 'temperatura', 346.0000, 'ºC'),
	(135381, 111, '2015-04-01 00:28:04.000000', 'temperatura', 339.0000, 'ºC'),
	(135382, 111, '2015-04-01 00:28:05.000000', 'temperatura', 661.0000, 'ºC'),
	(135383, 111, '2015-04-01 00:28:06.000000', 'temperatura', 1085.0000, 'ºC'),
	(135384, 111, '2015-04-01 00:28:07.000000', 'temperatura', 1046.0000, 'ºC'),
	(135385, 111, '2015-04-01 00:28:08.000000', 'temperatura', 774.0000, 'ºC'),
	(135386, 111, '2015-04-01 00:28:09.000000', 'temperatura', 732.0000, 'ºC'),
	(135387, 111, '2015-04-01 00:28:10.000000', 'temperatura', 139.0000, 'ºC'),
	(135388, 111, '2015-04-01 00:28:11.000000', 'temperatura', 898.0000, 'ºC'),
	(135389, 111, '2015-04-01 00:28:12.000000', 'temperatura', 473.0000, 'ºC'),
	(135390, 111, '2015-04-01 00:28:13.000000', 'temperatura', 871.0000, 'ºC'),
	(135391, 111, '2015-04-01 00:28:14.000000', 'temperatura', 539.0000, 'ºC'),
	(135392, 111, '2015-04-01 00:28:15.000000', 'temperatura', 81.0000, 'ºC'),
	(135393, 111, '2015-04-01 00:28:16.000000', 'temperatura', 1187.0000, 'ºC'),
	(135394, 111, '2015-04-01 00:28:17.000000', 'temperatura', 893.0000, 'ºC'),
	(135395, 111, '2015-04-01 00:28:18.000000', 'temperatura', 907.0000, 'ºC'),
	(135396, 111, '2015-04-01 00:28:19.000000', 'temperatura', 655.0000, 'ºC'),
	(135397, 111, '2015-04-01 00:28:20.000000', 'temperatura', 553.0000, 'ºC'),
	(135398, 111, '2015-04-01 00:28:21.000000', 'temperatura', 802.0000, 'ºC'),
	(135399, 111, '2015-04-01 00:28:22.000000', 'temperatura', 1153.0000, 'ºC'),
	(135400, 111, '2015-04-01 00:28:23.000000', 'temperatura', 958.0000, 'ºC'),
	(135401, 111, '2015-04-01 00:28:24.000000', 'temperatura', 130.0000, 'ºC'),
	(135402, 111, '2015-04-01 00:28:25.000000', 'temperatura', 178.0000, 'ºC'),
	(135403, 111, '2015-04-01 00:28:26.000000', 'temperatura', 500.0000, 'ºC'),
	(135404, 111, '2015-04-01 00:28:27.000000', 'temperatura', 769.0000, 'ºC'),
	(135405, 111, '2015-04-01 00:28:28.000000', 'temperatura', 1143.0000, 'ºC'),
	(135406, 111, '2015-04-01 00:28:29.000000', 'temperatura', 1008.0000, 'ºC'),
	(135407, 111, '2015-04-01 00:28:30.000000', 'temperatura', 413.0000, 'ºC'),
	(135408, 111, '2015-04-01 00:28:31.000000', 'temperatura', 241.0000, 'ºC'),
	(135409, 111, '2015-04-01 00:28:32.000000', 'temperatura', 1167.0000, 'ºC'),
	(135410, 111, '2015-04-01 00:28:33.000000', 'temperatura', 314.0000, 'ºC'),
	(135411, 111, '2015-04-01 00:28:34.000000', 'temperatura', 467.0000, 'ºC'),
	(135412, 111, '2015-04-01 00:28:35.000000', 'temperatura', 195.0000, 'ºC'),
	(135413, 111, '2015-04-01 00:28:36.000000', 'temperatura', 773.0000, 'ºC'),
	(135414, 111, '2015-04-01 00:28:37.000000', 'temperatura', 882.0000, 'ºC'),
	(135415, 111, '2015-04-01 00:28:38.000000', 'temperatura', 891.0000, 'ºC'),
	(135416, 111, '2015-04-01 00:28:39.000000', 'temperatura', 608.0000, 'ºC'),
	(135417, 111, '2015-04-01 00:28:40.000000', 'temperatura', 368.0000, 'ºC'),
	(135418, 111, '2015-04-01 00:28:41.000000', 'temperatura', 17.0000, 'ºC'),
	(135419, 111, '2015-04-01 00:28:42.000000', 'temperatura', 181.0000, 'ºC'),
	(135420, 111, '2015-04-01 00:28:43.000000', 'temperatura', 855.0000, 'ºC'),
	(135421, 111, '2015-04-01 00:28:44.000000', 'temperatura', 132.0000, 'ºC'),
	(135422, 111, '2015-04-01 00:28:45.000000', 'temperatura', 498.0000, 'ºC'),
	(135423, 111, '2015-04-01 00:28:46.000000', 'temperatura', 892.0000, 'ºC'),
	(135424, 111, '2015-04-01 00:28:47.000000', 'temperatura', 568.0000, 'ºC'),
	(135425, 111, '2015-04-01 00:28:48.000000', 'temperatura', 164.0000, 'ºC'),
	(135426, 111, '2015-04-01 00:28:49.000000', 'temperatura', 315.0000, 'ºC'),
	(135427, 111, '2015-04-01 00:28:50.000000', 'temperatura', 1085.0000, 'ºC'),
	(135428, 111, '2015-04-01 00:28:51.000000', 'temperatura', 881.0000, 'ºC'),
	(135429, 111, '2015-04-01 00:28:52.000000', 'temperatura', 1149.0000, 'ºC'),
	(135430, 111, '2015-04-01 00:28:53.000000', 'temperatura', 705.0000, 'ºC'),
	(135431, 111, '2015-04-01 00:28:54.000000', 'temperatura', 78.0000, 'ºC'),
	(135432, 111, '2015-04-01 00:28:55.000000', 'temperatura', 676.0000, 'ºC'),
	(135433, 111, '2015-04-01 00:28:56.000000', 'temperatura', 747.0000, 'ºC'),
	(135434, 111, '2015-04-01 00:28:57.000000', 'temperatura', 506.0000, 'ºC'),
	(135435, 111, '2015-04-01 00:28:58.000000', 'temperatura', 288.0000, 'ºC'),
	(135436, 111, '2015-04-01 00:28:59.000000', 'temperatura', 1126.0000, 'ºC'),
	(135437, 111, '2015-04-01 00:29:00.000000', 'temperatura', 1165.0000, 'ºC'),
	(135438, 111, '2015-04-01 00:29:01.000000', 'temperatura', 47.0000, 'ºC'),
	(135439, 111, '2015-04-01 00:29:02.000000', 'temperatura', 339.0000, 'ºC'),
	(135440, 111, '2015-04-01 00:29:03.000000', 'temperatura', 357.0000, 'ºC'),
	(135441, 111, '2015-04-01 00:29:04.000000', 'temperatura', 769.0000, 'ºC'),
	(135442, 111, '2015-04-01 00:29:05.000000', 'temperatura', 374.0000, 'ºC'),
	(135443, 111, '2015-04-01 00:29:06.000000', 'temperatura', 765.0000, 'ºC'),
	(135444, 111, '2015-04-01 00:29:07.000000', 'temperatura', 301.0000, 'ºC'),
	(135445, 111, '2015-04-01 00:29:08.000000', 'temperatura', 412.0000, 'ºC'),
	(135446, 111, '2015-04-01 00:29:09.000000', 'temperatura', 1156.0000, 'ºC'),
	(135447, 111, '2015-04-01 00:29:10.000000', 'temperatura', 945.0000, 'ºC'),
	(135448, 111, '2015-04-01 00:29:11.000000', 'temperatura', 57.0000, 'ºC'),
	(135449, 111, '2015-04-01 00:29:12.000000', 'temperatura', 1053.0000, 'ºC'),
	(135450, 111, '2015-04-01 00:29:13.000000', 'temperatura', 292.0000, 'ºC'),
	(135451, 111, '2015-04-01 00:29:14.000000', 'temperatura', 701.0000, 'ºC'),
	(135452, 111, '2015-04-01 00:29:15.000000', 'temperatura', 230.0000, 'ºC'),
	(135453, 111, '2015-04-01 00:29:16.000000', 'temperatura', 246.0000, 'ºC'),
	(135454, 111, '2015-04-01 00:29:17.000000', 'temperatura', 543.0000, 'ºC'),
	(135455, 111, '2015-04-01 00:29:18.000000', 'temperatura', 775.0000, 'ºC'),
	(135456, 111, '2015-04-01 00:29:19.000000', 'temperatura', 1048.0000, 'ºC'),
	(135457, 111, '2015-04-01 00:29:20.000000', 'temperatura', 513.0000, 'ºC'),
	(135458, 111, '2015-04-01 00:29:21.000000', 'temperatura', 624.0000, 'ºC'),
	(135459, 111, '2015-04-01 00:29:22.000000', 'temperatura', 380.0000, 'ºC'),
	(135460, 111, '2015-04-01 00:29:23.000000', 'temperatura', 28.0000, 'ºC'),
	(135461, 111, '2015-04-01 00:29:24.000000', 'temperatura', 202.0000, 'ºC'),
	(135462, 111, '2015-04-01 00:29:25.000000', 'temperatura', 925.0000, 'ºC'),
	(135463, 111, '2015-04-01 00:29:26.000000', 'temperatura', 420.0000, 'ºC'),
	(135464, 111, '2015-04-01 00:29:27.000000', 'temperatura', 523.0000, 'ºC'),
	(135465, 111, '2015-04-01 00:29:28.000000', 'temperatura', 159.0000, 'ºC'),
	(135466, 111, '2015-04-01 00:29:29.000000', 'temperatura', 427.0000, 'ºC'),
	(135467, 111, '2015-04-01 00:29:30.000000', 'temperatura', 458.0000, 'ºC'),
	(135468, 111, '2015-04-01 00:29:31.000000', 'temperatura', 1008.0000, 'ºC'),
	(135469, 111, '2015-04-01 00:29:32.000000', 'temperatura', 68.0000, 'ºC'),
	(135470, 111, '2015-04-01 00:29:33.000000', 'temperatura', 914.0000, 'ºC'),
	(135471, 111, '2015-04-01 00:29:34.000000', 'temperatura', 769.0000, 'ºC'),
	(135472, 111, '2015-04-01 00:29:35.000000', 'temperatura', 1104.0000, 'ºC'),
	(135473, 111, '2015-04-01 00:29:36.000000', 'temperatura', 814.0000, 'ºC'),
	(135474, 111, '2015-04-01 00:29:37.000000', 'temperatura', 756.0000, 'ºC'),
	(135475, 111, '2015-04-01 00:29:38.000000', 'temperatura', 140.0000, 'ºC'),
	(135476, 111, '2015-04-01 00:29:39.000000', 'temperatura', 833.0000, 'ºC'),
	(135477, 111, '2015-04-01 00:29:40.000000', 'temperatura', 146.0000, 'ºC'),
	(135478, 111, '2015-04-01 00:29:41.000000', 'temperatura', 632.0000, 'ºC'),
	(135479, 111, '2015-04-01 00:29:42.000000', 'temperatura', 321.0000, 'ºC'),
	(135480, 111, '2015-04-01 00:29:43.000000', 'temperatura', 909.0000, 'ºC'),
	(135481, 111, '2015-04-01 00:29:44.000000', 'temperatura', 1183.0000, 'ºC'),
	(135482, 111, '2015-04-01 00:29:45.000000', 'temperatura', 790.0000, 'ºC'),
	(135483, 111, '2015-04-01 00:29:46.000000', 'temperatura', 400.0000, 'ºC'),
	(135484, 111, '2015-04-01 00:29:47.000000', 'temperatura', 831.0000, 'ºC'),
	(135485, 111, '2015-04-01 00:29:48.000000', 'temperatura', 556.0000, 'ºC'),
	(135486, 111, '2015-04-01 00:29:49.000000', 'temperatura', 289.0000, 'ºC'),
	(135487, 111, '2015-04-01 00:29:50.000000', 'temperatura', 975.0000, 'ºC'),
	(135488, 111, '2015-04-01 00:29:51.000000', 'temperatura', 411.0000, 'ºC'),
	(135489, 111, '2015-04-01 00:29:52.000000', 'temperatura', 331.0000, 'ºC'),
	(135490, 111, '2015-04-01 00:29:53.000000', 'temperatura', 420.0000, 'ºC'),
	(135491, 111, '2015-04-01 00:29:54.000000', 'temperatura', 1108.0000, 'ºC'),
	(135492, 111, '2015-04-01 00:29:55.000000', 'temperatura', 681.0000, 'ºC'),
	(135493, 111, '2015-04-01 00:29:56.000000', 'temperatura', 82.0000, 'ºC'),
	(135494, 111, '2015-04-01 00:29:57.000000', 'temperatura', 768.0000, 'ºC'),
	(135495, 111, '2015-04-01 00:29:58.000000', 'temperatura', 1193.0000, 'ºC'),
	(135496, 111, '2015-04-01 00:29:59.000000', 'temperatura', 60.0000, 'ºC'),
	(135497, 111, '2015-04-01 00:30:00.000000', 'temperatura', 325.0000, 'ºC'),
	(135498, 111, '2015-04-01 00:30:01.000000', 'temperatura', 243.0000, 'ºC'),
	(135499, 111, '2015-04-01 00:30:02.000000', 'temperatura', 242.0000, 'ºC'),
	(135500, 111, '2015-04-01 00:30:03.000000', 'temperatura', 480.0000, 'ºC'),
	(135501, 111, '2015-04-01 00:30:04.000000', 'temperatura', 473.0000, 'ºC'),
	(135502, 111, '2015-04-01 00:30:05.000000', 'temperatura', 927.0000, 'ºC'),
	(135503, 111, '2015-04-01 00:30:06.000000', 'temperatura', 818.0000, 'ºC'),
	(135504, 111, '2015-04-01 00:30:07.000000', 'temperatura', 110.0000, 'ºC'),
	(135505, 111, '2015-04-01 00:30:08.000000', 'temperatura', 494.0000, 'ºC'),
	(135506, 111, '2015-04-01 00:30:09.000000', 'temperatura', 940.0000, 'ºC'),
	(135507, 111, '2015-04-01 00:30:10.000000', 'temperatura', 819.0000, 'ºC'),
	(135508, 111, '2015-04-01 00:30:11.000000', 'temperatura', 76.0000, 'ºC'),
	(135509, 111, '2015-04-01 00:30:12.000000', 'temperatura', 322.0000, 'ºC'),
	(135510, 111, '2015-04-01 00:30:13.000000', 'temperatura', 181.0000, 'ºC'),
	(135511, 111, '2015-04-01 00:30:14.000000', 'temperatura', 1143.0000, 'ºC'),
	(135512, 111, '2015-04-01 00:30:15.000000', 'temperatura', 372.0000, 'ºC'),
	(135513, 111, '2015-04-01 00:30:16.000000', 'temperatura', 831.0000, 'ºC'),
	(135514, 111, '2015-04-01 00:30:17.000000', 'temperatura', 640.0000, 'ºC'),
	(135515, 111, '2015-04-01 00:30:18.000000', 'temperatura', 707.0000, 'ºC'),
	(135516, 111, '2015-04-01 00:30:19.000000', 'temperatura', 417.0000, 'ºC'),
	(135517, 111, '2015-04-01 00:30:20.000000', 'temperatura', 1163.0000, 'ºC'),
	(135518, 111, '2015-04-01 00:30:21.000000', 'temperatura', 964.0000, 'ºC'),
	(135519, 111, '2015-04-01 00:30:22.000000', 'temperatura', 132.0000, 'ºC'),
	(135520, 111, '2015-04-01 00:30:23.000000', 'temperatura', 171.0000, 'ºC'),
	(135521, 111, '2015-04-01 00:30:24.000000', 'temperatura', 456.0000, 'ºC'),
	(135522, 111, '2015-04-01 00:30:25.000000', 'temperatura', 569.0000, 'ºC'),
	(135523, 111, '2015-04-01 00:30:26.000000', 'temperatura', 278.0000, 'ºC'),
	(135524, 111, '2015-04-01 00:30:27.000000', 'temperatura', 884.0000, 'ºC'),
	(135525, 111, '2015-04-01 00:30:28.000000', 'temperatura', 1184.0000, 'ºC'),
	(135526, 111, '2015-04-01 00:30:29.000000', 'temperatura', 872.0000, 'ºC'),
	(135527, 111, '2015-04-01 00:30:30.000000', 'temperatura', 805.0000, 'ºC'),
	(135528, 111, '2015-04-01 00:30:31.000000', 'temperatura', 212.0000, 'ºC'),
	(135529, 111, '2015-04-01 00:30:32.000000', 'temperatura', 1045.0000, 'ºC'),
	(135530, 111, '2015-04-01 00:30:33.000000', 'temperatura', 989.0000, 'ºC'),
	(135531, 111, '2015-04-01 00:30:34.000000', 'temperatura', 611.0000, 'ºC'),
	(135532, 111, '2015-04-01 00:30:35.000000', 'temperatura', 90.0000, 'ºC'),
	(135533, 111, '2015-04-01 00:30:36.000000', 'temperatura', 1015.0000, 'ºC'),
	(135534, 111, '2015-04-01 00:30:37.000000', 'temperatura', 5.0000, 'ºC'),
	(135535, 111, '2015-04-01 00:30:38.000000', 'temperatura', 583.0000, 'ºC'),
	(135536, 111, '2015-04-01 00:30:39.000000', 'temperatura', 501.0000, 'ºC'),
	(135537, 111, '2015-04-01 00:30:40.000000', 'temperatura', 754.0000, 'ºC'),
	(135538, 111, '2015-04-01 00:30:41.000000', 'temperatura', 1068.0000, 'ºC'),
	(135539, 111, '2015-04-01 00:30:42.000000', 'temperatura', 677.0000, 'ºC'),
	(135540, 111, '2015-04-01 00:30:43.000000', 'temperatura', 183.0000, 'ºC'),
	(135541, 111, '2015-04-01 00:30:44.000000', 'temperatura', 84.0000, 'ºC'),
	(135542, 111, '2015-04-01 00:30:45.000000', 'temperatura', 1071.0000, 'ºC'),
	(135543, 111, '2015-04-01 00:30:46.000000', 'temperatura', 303.0000, 'ºC'),
	(135544, 111, '2015-04-01 00:30:47.000000', 'temperatura', 702.0000, 'ºC'),
	(135545, 111, '2015-04-01 00:30:48.000000', 'temperatura', 201.0000, 'ºC'),
	(135546, 111, '2015-04-01 00:30:49.000000', 'temperatura', 102.0000, 'ºC'),
	(135547, 111, '2015-04-01 00:30:50.000000', 'temperatura', 1104.0000, 'ºC'),
	(135548, 111, '2015-04-01 00:30:51.000000', 'temperatura', 418.0000, 'ºC'),
	(135549, 111, '2015-04-01 00:30:52.000000', 'temperatura', 1177.0000, 'ºC'),
	(135550, 111, '2015-04-01 00:30:53.000000', 'temperatura', 1033.0000, 'ºC'),
	(135551, 111, '2015-04-01 00:30:54.000000', 'temperatura', 433.0000, 'ºC'),
	(135552, 111, '2015-04-01 00:30:55.000000', 'temperatura', 266.0000, 'ºC'),
	(135553, 111, '2015-04-01 00:30:56.000000', 'temperatura', 34.0000, 'ºC'),
	(135554, 111, '2015-04-01 00:30:57.000000', 'temperatura', 571.0000, 'ºC'),
	(135555, 111, '2015-04-01 00:30:58.000000', 'temperatura', 353.0000, 'ºC'),
	(135556, 111, '2015-04-01 00:30:59.000000', 'temperatura', 52.0000, 'ºC'),
	(135557, 111, '2015-04-01 00:31:00.000000', 'temperatura', 403.0000, 'ºC'),
	(135558, 111, '2015-04-01 00:31:01.000000', 'temperatura', 661.0000, 'ºC'),
	(135559, 111, '2015-04-01 00:31:02.000000', 'temperatura', 894.0000, 'ºC'),
	(135560, 111, '2015-04-01 00:31:03.000000', 'temperatura', 87.0000, 'ºC'),
	(135561, 111, '2015-04-01 00:31:04.000000', 'temperatura', 153.0000, 'ºC'),
	(135562, 111, '2015-04-01 00:31:05.000000', 'temperatura', 507.0000, 'ºC'),
	(135563, 111, '2015-04-01 00:31:06.000000', 'temperatura', 876.0000, 'ºC'),
	(135564, 111, '2015-04-01 00:31:07.000000', 'temperatura', 457.0000, 'ºC'),
	(135565, 111, '2015-04-01 00:31:08.000000', 'temperatura', 860.0000, 'ºC'),
	(135566, 111, '2015-04-01 00:31:09.000000', 'temperatura', 531.0000, 'ºC'),
	(135567, 111, '2015-04-01 00:31:10.000000', 'temperatura', 73.0000, 'ºC'),
	(135568, 111, '2015-04-01 00:31:11.000000', 'temperatura', 1175.0000, 'ºC'),
	(135569, 111, '2015-04-01 00:31:12.000000', 'temperatura', 857.0000, 'ºC'),
	(135570, 111, '2015-04-01 00:31:13.000000', 'temperatura', 757.0000, 'ºC'),
	(135571, 111, '2015-04-01 00:31:14.000000', 'temperatura', 17.0000, 'ºC'),
	(135572, 111, '2015-04-01 00:31:15.000000', 'temperatura', 213.0000, 'ºC'),
	(135573, 111, '2015-04-01 00:31:16.000000', 'temperatura', 1015.0000, 'ºC'),
	(135574, 111, '2015-04-01 00:31:17.000000', 'temperatura', 837.0000, 'ºC'),
	(135575, 111, '2015-04-01 00:31:18.000000', 'temperatura', 1142.0000, 'ºC'),
	(135576, 111, '2015-04-01 00:31:19.000000', 'temperatura', 796.0000, 'ºC'),
	(135577, 111, '2015-04-01 00:31:20.000000', 'temperatura', 558.0000, 'ºC'),
	(135578, 111, '2015-04-01 00:31:21.000000', 'temperatura', 401.0000, 'ºC'),
	(135579, 111, '2015-04-01 00:31:22.000000', 'temperatura', 330.0000, 'ºC'),
	(135580, 111, '2015-04-01 00:31:23.000000', 'temperatura', 447.0000, 'ºC'),
	(135581, 111, '2015-04-01 00:31:24.000000', 'temperatura', 47.0000, 'ºC'),
	(135582, 111, '2015-04-01 00:31:25.000000', 'temperatura', 95.0000, 'ºC'),
	(135583, 111, '2015-04-01 00:31:26.000000', 'temperatura', 332.0000, 'ºC'),
	(135584, 111, '2015-04-01 00:31:27.000000', 'temperatura', 176.0000, 'ºC'),
	(135585, 111, '2015-04-01 00:31:28.000000', 'temperatura', 1086.0000, 'ºC'),
	(135586, 111, '2015-04-01 00:31:29.000000', 'temperatura', 102.0000, 'ºC'),
	(135587, 111, '2015-04-01 00:31:30.000000', 'temperatura', 852.0000, 'ºC'),
	(135588, 111, '2015-04-01 00:31:31.000000', 'temperatura', 355.0000, 'ºC'),
	(135589, 111, '2015-04-01 00:31:32.000000', 'temperatura', 419.0000, 'ºC'),
	(135590, 111, '2015-04-01 00:31:33.000000', 'temperatura', 1032.0000, 'ºC'),
	(135591, 111, '2015-04-01 00:31:34.000000', 'temperatura', 304.0000, 'ºC'),
	(135592, 111, '2015-04-01 00:31:35.000000', 'temperatura', 824.0000, 'ºC'),
	(135593, 111, '2015-04-01 00:31:36.000000', 'temperatura', 807.0000, 'ºC'),
	(135594, 111, '2015-04-01 00:31:37.000000', 'temperatura', 366.0000, 'ºC'),
	(135595, 111, '2015-04-01 00:31:38.000000', 'temperatura', 609.0000, 'ºC'),
	(135596, 111, '2015-04-01 00:31:39.000000', 'temperatura', 747.0000, 'ºC'),
	(135597, 111, '2015-04-01 00:31:40.000000', 'temperatura', 709.0000, 'ºC'),
	(135598, 111, '2015-04-01 00:31:41.000000', 'temperatura', 105.0000, 'ºC'),
	(135599, 111, '2015-04-01 00:31:42.000000', 'temperatura', 797.0000, 'ºC'),
	(135600, 111, '2015-04-01 00:31:43.000000', 'temperatura', 70.0000, 'ºC'),
	(135601, 111, '2015-04-01 00:31:44.000000', 'temperatura', 362.0000, 'ºC'),
	(135602, 111, '2015-04-01 00:31:45.000000', 'temperatura', 399.0000, 'ºC'),
	(135603, 111, '2015-04-01 00:31:46.000000', 'temperatura', 910.0000, 'ºC'),
	(135604, 111, '2015-04-01 00:31:47.000000', 'temperatura', 952.0000, 'ºC'),
	(135605, 111, '2015-04-01 00:31:48.000000', 'temperatura', 832.0000, 'ºC'),
	(135606, 111, '2015-04-01 00:31:49.000000', 'temperatura', 105.0000, 'ºC'),
	(135607, 111, '2015-04-01 00:31:50.000000', 'temperatura', 430.0000, 'ºC'),
	(135608, 111, '2015-04-01 00:31:51.000000', 'temperatura', 633.0000, 'ºC'),
	(135609, 111, '2015-04-01 00:31:52.000000', 'temperatura', 675.0000, 'ºC'),
	(135610, 111, '2015-04-01 00:31:53.000000', 'temperatura', 279.0000, 'ºC'),
	(135611, 111, '2015-04-01 00:31:54.000000', 'temperatura', 569.0000, 'ºC'),
	(135612, 111, '2015-04-01 00:31:55.000000', 'temperatura', 809.0000, 'ºC'),
	(135613, 111, '2015-04-01 00:31:56.000000', 'temperatura', 1137.0000, 'ºC'),
	(135614, 111, '2015-04-01 00:31:57.000000', 'temperatura', 861.0000, 'ºC'),
	(135615, 111, '2015-04-01 00:31:58.000000', 'temperatura', 895.0000, 'ºC'),
	(135616, 111, '2015-04-01 00:31:59.000000', 'temperatura', 691.0000, 'ºC'),
	(135617, 111, '2015-04-01 00:32:00.000000', 'temperatura', 770.0000, 'ºC'),
	(135618, 111, '2015-04-01 00:32:01.000000', 'temperatura', 579.0000, 'ºC'),
	(135619, 111, '2015-04-01 00:32:02.000000', 'temperatura', 586.0000, 'ºC'),
	(135620, 111, '2015-04-01 00:32:03.000000', 'temperatura', 1193.0000, 'ºC'),
	(135621, 111, '2015-04-01 00:32:04.000000', 'temperatura', 607.0000, 'ºC'),
	(135622, 111, '2015-04-01 00:32:05.000000', 'temperatura', 655.0000, 'ºC'),
	(135623, 111, '2015-04-01 00:32:06.000000', 'temperatura', 254.0000, 'ºC'),
	(135624, 111, '2015-04-01 00:32:07.000000', 'temperatura', 507.0000, 'ºC'),
	(135625, 111, '2015-04-01 00:32:08.000000', 'temperatura', 573.0000, 'ºC'),
	(135626, 111, '2015-04-01 00:32:09.000000', 'temperatura', 147.0000, 'ºC'),
	(135627, 111, '2015-04-01 00:32:10.000000', 'temperatura', 213.0000, 'ºC'),
	(135628, 111, '2015-04-01 00:32:11.000000', 'temperatura', 626.0000, 'ºC'),
	(135629, 111, '2015-04-01 00:32:12.000000', 'temperatura', 93.0000, 'ºC'),
	(135630, 111, '2015-04-01 00:32:13.000000', 'temperatura', 987.0000, 'ºC'),
	(135631, 111, '2015-04-01 00:32:14.000000', 'temperatura', 1057.0000, 'ºC'),
	(135632, 111, '2015-04-01 00:32:15.000000', 'temperatura', 1124.0000, 'ºC'),
	(135633, 111, '2015-04-01 00:32:16.000000', 'temperatura', 51.0000, 'ºC'),
	(135634, 111, '2015-04-01 00:32:17.000000', 'temperatura', 481.0000, 'ºC'),
	(135635, 111, '2015-04-01 00:32:18.000000', 'temperatura', 1054.0000, 'ºC'),
	(135636, 111, '2015-04-01 00:32:19.000000', 'temperatura', 227.0000, 'ºC'),
	(135637, 111, '2015-04-01 00:32:20.000000', 'temperatura', 374.0000, 'ºC'),
	(135638, 111, '2015-04-01 00:32:21.000000', 'temperatura', 1191.0000, 'ºC'),
	(135639, 111, '2015-04-01 00:32:22.000000', 'temperatura', 33.0000, 'ºC'),
	(135640, 111, '2015-04-01 00:32:23.000000', 'temperatura', 193.0000, 'ºC'),
	(135641, 111, '2015-04-01 00:32:24.000000', 'temperatura', 864.0000, 'ºC'),
	(135642, 111, '2015-04-01 00:32:25.000000', 'temperatura', 143.0000, 'ºC'),
	(135643, 111, '2015-04-01 00:32:26.000000', 'temperatura', 524.0000, 'ºC'),
	(135644, 111, '2015-04-01 00:32:27.000000', 'temperatura', 990.0000, 'ºC'),
	(135645, 111, '2015-04-01 00:32:28.000000', 'temperatura', 978.0000, 'ºC'),
	(135646, 111, '2015-04-01 00:32:29.000000', 'temperatura', 723.0000, 'ºC'),
	(135647, 111, '2015-04-01 00:32:30.000000', 'temperatura', 681.0000, 'ºC'),
	(135648, 111, '2015-04-01 00:32:31.000000', 'temperatura', 34.0000, 'ºC'),
	(135649, 111, '2015-04-01 00:32:32.000000', 'temperatura', 531.0000, 'ºC'),
	(135650, 111, '2015-04-01 00:32:33.000000', 'temperatura', 150.0000, 'ºC'),
	(135651, 111, '2015-04-01 00:32:34.000000', 'temperatura', 360.0000, 'ºC'),
	(135652, 111, '2015-04-01 00:32:35.000000', 'temperatura', 151.0000, 'ºC'),
	(135653, 111, '2015-04-01 00:32:36.000000', 'temperatura', 877.0000, 'ºC'),
	(135654, 111, '2015-04-01 00:32:37.000000', 'temperatura', 329.0000, 'ºC'),
	(135655, 111, '2015-04-01 00:32:38.000000', 'temperatura', 216.0000, 'ºC'),
	(135656, 111, '2015-04-01 00:32:39.000000', 'temperatura', 94.0000, 'ºC'),
	(135657, 111, '2015-04-01 00:32:40.000000', 'temperatura', 1023.0000, 'ºC'),
	(135658, 111, '2015-04-01 00:32:41.000000', 'temperatura', 34.0000, 'ºC'),
	(135659, 111, '2015-04-01 00:32:42.000000', 'temperatura', 699.0000, 'ºC'),
	(135660, 111, '2015-04-01 00:32:43.000000', 'temperatura', 996.0000, 'ºC'),
	(135661, 111, '2015-04-01 00:32:44.000000', 'temperatura', 481.0000, 'ºC'),
	(135662, 111, '2015-04-01 00:32:45.000000', 'temperatura', 619.0000, 'ºC'),
	(135663, 111, '2015-04-01 00:32:46.000000', 'temperatura', 453.0000, 'ºC'),
	(135664, 111, '2015-04-01 00:32:47.000000', 'temperatura', 408.0000, 'ºC'),
	(135665, 111, '2015-04-01 00:32:48.000000', 'temperatura', 681.0000, 'ºC'),
	(135666, 111, '2015-04-01 00:32:49.000000', 'temperatura', 982.0000, 'ºC'),
	(135667, 111, '2015-04-01 00:32:50.000000', 'temperatura', 466.0000, 'ºC'),
	(135668, 111, '2015-04-01 00:32:51.000000', 'temperatura', 587.0000, 'ºC'),
	(135669, 111, '2015-04-01 00:32:52.000000', 'temperatura', 338.0000, 'ºC'),
	(135670, 111, '2015-04-01 00:32:53.000000', 'temperatura', 1128.0000, 'ºC'),
	(135671, 111, '2015-04-01 00:32:54.000000', 'temperatura', 1027.0000, 'ºC'),
	(135672, 111, '2015-04-01 00:32:55.000000', 'temperatura', 552.0000, 'ºC'),
	(135673, 111, '2015-04-01 00:32:56.000000', 'temperatura', 877.0000, 'ºC'),
	(135674, 111, '2015-04-01 00:32:57.000000', 'temperatura', 333.0000, 'ºC'),
	(135675, 111, '2015-04-01 00:32:58.000000', 'temperatura', 233.0000, 'ºC'),
	(135676, 111, '2015-04-01 00:32:59.000000', 'temperatura', 165.0000, 'ºC'),
	(135677, 111, '2015-04-01 00:33:00.000000', 'temperatura', 129.0000, 'ºC'),
	(135678, 111, '2015-04-01 00:33:01.000000', 'temperatura', 149.0000, 'ºC'),
	(135679, 111, '2015-04-01 00:33:02.000000', 'temperatura', 358.0000, 'ºC'),
	(135680, 111, '2015-04-01 00:33:03.000000', 'temperatura', 146.0000, 'ºC'),
	(135681, 111, '2015-04-01 00:33:04.000000', 'temperatura', 854.0000, 'ºC'),
	(135682, 111, '2015-04-01 00:33:05.000000', 'temperatura', 232.0000, 'ºC'),
	(135683, 111, '2015-04-01 00:33:06.000000', 'temperatura', 999.0000, 'ºC'),
	(135684, 111, '2015-04-01 00:33:07.000000', 'temperatura', 698.0000, 'ºC'),
	(135685, 111, '2015-04-01 00:33:08.000000', 'temperatura', 496.0000, 'ºC'),
	(135686, 111, '2015-04-01 00:33:09.000000', 'temperatura', 386.0000, 'ºC'),
	(135687, 111, '2015-04-01 00:33:10.000000', 'temperatura', 444.0000, 'ºC'),
	(135688, 111, '2015-04-01 00:33:11.000000', 'temperatura', 1061.0000, 'ºC'),
	(135689, 111, '2015-04-01 00:33:12.000000', 'temperatura', 374.0000, 'ºC'),
	(135690, 111, '2015-04-01 00:33:13.000000', 'temperatura', 1086.0000, 'ºC'),
	(135691, 111, '2015-04-01 00:33:14.000000', 'temperatura', 709.0000, 'ºC'),
	(135692, 111, '2015-04-01 00:33:15.000000', 'temperatura', 286.0000, 'ºC'),
	(135693, 111, '2015-04-01 00:33:16.000000', 'temperatura', 503.0000, 'ºC'),
	(135694, 111, '2015-04-01 00:33:17.000000', 'temperatura', 460.0000, 'ºC'),
	(135695, 111, '2015-04-01 00:33:18.000000', 'temperatura', 790.0000, 'ºC'),
	(135696, 111, '2015-04-01 00:33:19.000000', 'temperatura', 173.0000, 'ºC'),
	(135697, 111, '2015-04-01 00:33:20.000000', 'temperatura', 892.0000, 'ºC'),
	(135698, 111, '2015-04-01 00:33:21.000000', 'temperatura', 345.0000, 'ºC'),
	(135699, 111, '2015-04-01 00:33:22.000000', 'temperatura', 248.0000, 'ºC'),
	(135700, 111, '2015-04-01 00:33:23.000000', 'temperatura', 206.0000, 'ºC'),
	(135701, 111, '2015-04-01 00:33:24.000000', 'temperatura', 286.0000, 'ºC'),
	(135702, 111, '2015-04-01 00:33:25.000000', 'temperatura', 814.0000, 'ºC'),
	(135703, 111, '2015-04-01 00:33:26.000000', 'temperatura', 811.0000, 'ºC'),
	(135704, 111, '2015-04-01 00:33:27.000000', 'temperatura', 414.0000, 'ºC'),
	(135705, 111, '2015-04-01 00:33:28.000000', 'temperatura', 839.0000, 'ºC'),
	(135706, 111, '2015-04-01 00:33:29.000000', 'temperatura', 552.0000, 'ºC'),
	(135707, 111, '2015-04-01 00:33:30.000000', 'temperatura', 242.0000, 'ºC'),
	(135708, 111, '2015-04-01 00:33:31.000000', 'temperatura', 756.0000, 'ºC'),
	(135709, 111, '2015-04-01 00:33:32.000000', 'temperatura', 656.0000, 'ºC'),
	(135710, 111, '2015-04-01 00:33:33.000000', 'temperatura', 1013.0000, 'ºC'),
	(135711, 111, '2015-04-01 00:33:34.000000', 'temperatura', 696.0000, 'ºC'),
	(135712, 111, '2015-04-01 00:33:35.000000', 'temperatura', 440.0000, 'ºC'),
	(135713, 111, '2015-04-01 00:33:36.000000', 'temperatura', 114.0000, 'ºC'),
	(135714, 111, '2015-04-01 00:33:37.000000', 'temperatura', 451.0000, 'ºC'),
	(135715, 111, '2015-04-01 00:33:38.000000', 'temperatura', 713.0000, 'ºC'),
	(135716, 111, '2015-04-01 00:33:39.000000', 'temperatura', 1011.0000, 'ºC'),
	(135717, 111, '2015-04-01 00:33:40.000000', 'temperatura', 517.0000, 'ºC'),
	(135718, 111, '2015-04-01 00:33:41.000000', 'temperatura', 754.0000, 'ºC'),
	(135719, 111, '2015-04-01 00:33:42.000000', 'temperatura', 1020.0000, 'ºC'),
	(135720, 111, '2015-04-01 00:33:43.000000', 'temperatura', 436.0000, 'ºC'),
	(135721, 111, '2015-04-01 00:33:44.000000', 'temperatura', 320.0000, 'ºC'),
	(135722, 111, '2015-04-01 00:33:45.000000', 'temperatura', 293.0000, 'ºC'),
	(135723, 111, '2015-04-01 00:33:46.000000', 'temperatura', 508.0000, 'ºC'),
	(135724, 111, '2015-04-01 00:33:47.000000', 'temperatura', 459.0000, 'ºC'),
	(135725, 111, '2015-04-01 00:33:48.000000', 'temperatura', 773.0000, 'ºC'),
	(135726, 111, '2015-04-01 00:33:49.000000', 'temperatura', 89.0000, 'ºC'),
	(135727, 111, '2015-04-01 00:33:50.000000', 'temperatura', 525.0000, 'ºC'),
	(135728, 111, '2015-04-01 00:33:51.000000', 'temperatura', 1158.0000, 'ºC'),
	(135729, 111, '2015-04-01 00:33:52.000000', 'temperatura', 616.0000, 'ºC'),
	(135730, 111, '2015-04-01 00:33:53.000000', 'temperatura', 807.0000, 'ºC'),
	(135731, 111, '2015-04-01 00:33:54.000000', 'temperatura', 987.0000, 'ºC'),
	(135732, 111, '2015-04-01 00:33:55.000000', 'temperatura', 114.0000, 'ºC'),
	(135733, 111, '2015-04-01 00:33:56.000000', 'temperatura', 10.0000, 'ºC'),
	(135734, 111, '2015-04-01 00:33:57.000000', 'temperatura', 908.0000, 'ºC'),
	(135735, 111, '2015-04-01 00:33:58.000000', 'temperatura', 912.0000, 'ºC'),
	(135736, 111, '2015-04-01 00:33:59.000000', 'temperatura', 637.0000, 'ºC'),
	(135737, 111, '2015-04-01 00:34:00.000000', 'temperatura', 447.0000, 'ºC'),
	(135738, 111, '2015-04-01 00:34:01.000000', 'temperatura', 327.0000, 'ºC'),
	(135739, 111, '2015-04-01 00:34:02.000000', 'temperatura', 292.0000, 'ºC'),
	(135740, 111, '2015-04-01 00:34:03.000000', 'temperatura', 479.0000, 'ºC'),
	(135741, 111, '2015-04-01 00:34:04.000000', 'temperatura', 321.0000, 'ºC'),
	(135742, 111, '2015-04-01 00:34:05.000000', 'temperatura', 169.0000, 'ºC'),
	(135743, 111, '2015-04-01 00:34:06.000000', 'temperatura', 1084.0000, 'ºC'),
	(135744, 111, '2015-04-01 00:34:07.000000', 'temperatura', 112.0000, 'ºC'),
	(135745, 111, '2015-04-01 00:34:08.000000', 'temperatura', 910.0000, 'ºC'),
	(135746, 111, '2015-04-01 00:34:09.000000', 'temperatura', 614.0000, 'ºC'),
	(135747, 111, '2015-04-01 00:34:10.000000', 'temperatura', 342.0000, 'ºC'),
	(135748, 111, '2015-04-01 00:34:11.000000', 'temperatura', 1065.0000, 'ºC'),
	(135749, 111, '2015-04-01 00:34:12.000000', 'temperatura', 702.0000, 'ºC'),
	(135750, 111, '2015-04-01 00:34:13.000000', 'temperatura', 316.0000, 'ºC'),
	(135751, 111, '2015-04-01 00:34:14.000000', 'temperatura', 675.0000, 'ºC'),
	(135752, 111, '2015-04-01 00:34:15.000000', 'temperatura', 26.0000, 'ºC'),
	(135753, 111, '2015-04-01 00:34:16.000000', 'temperatura', 506.0000, 'ºC'),
	(135754, 111, '2015-04-01 00:34:17.000000', 'temperatura', 52.0000, 'ºC'),
	(135755, 111, '2015-04-01 00:34:18.000000', 'temperatura', 1142.0000, 'ºC'),
	(135756, 111, '2015-04-01 00:34:19.000000', 'temperatura', 754.0000, 'ºC'),
	(135757, 111, '2015-04-01 00:34:20.000000', 'temperatura', 347.0000, 'ºC'),
	(135758, 111, '2015-04-01 00:34:21.000000', 'temperatura', 672.0000, 'ºC'),
	(135759, 111, '2015-04-01 00:34:22.000000', 'temperatura', 1121.0000, 'ºC'),
	(135760, 111, '2015-04-01 00:34:23.000000', 'temperatura', 1187.0000, 'ºC'),
	(135761, 111, '2015-04-01 00:34:24.000000', 'temperatura', 172.0000, 'ºC'),
	(135762, 111, '2015-04-01 00:34:25.000000', 'temperatura', 902.0000, 'ºC'),
	(135763, 111, '2015-04-01 00:34:26.000000', 'temperatura', 394.0000, 'ºC'),
	(135764, 111, '2015-04-01 00:34:27.000000', 'temperatura', 462.0000, 'ºC'),
	(135765, 111, '2015-04-01 00:34:28.000000', 'temperatura', 1132.0000, 'ºC'),
	(135766, 111, '2015-04-01 00:34:29.000000', 'temperatura', 671.0000, 'ºC'),
	(135767, 111, '2015-04-01 00:34:30.000000', 'temperatura', 1161.0000, 'ºC'),
	(135768, 111, '2015-04-01 00:34:31.000000', 'temperatura', 194.0000, 'ºC'),
	(135769, 111, '2015-04-01 00:34:32.000000', 'temperatura', 1085.0000, 'ºC'),
	(135770, 111, '2015-04-01 00:34:33.000000', 'temperatura', 46.0000, 'ºC'),
	(135771, 111, '2015-04-01 00:34:34.000000', 'temperatura', 577.0000, 'ºC'),
	(135772, 111, '2015-04-01 00:34:35.000000', 'temperatura', 344.0000, 'ºC'),
	(135773, 111, '2015-04-01 00:34:36.000000', 'temperatura', 1189.0000, 'ºC'),
	(135774, 111, '2015-04-01 00:34:37.000000', 'temperatura', 115.0000, 'ºC'),
	(135775, 111, '2015-04-01 00:34:38.000000', 'temperatura', 608.0000, 'ºC'),
	(135776, 111, '2015-04-01 00:34:39.000000', 'temperatura', 295.0000, 'ºC'),
	(135777, 111, '2015-04-01 00:34:40.000000', 'temperatura', 854.0000, 'ºC'),
	(135778, 111, '2015-04-01 00:34:41.000000', 'temperatura', 983.0000, 'ºC'),
	(135779, 111, '2015-04-01 00:34:42.000000', 'temperatura', 1153.0000, 'ºC'),
	(135780, 111, '2015-04-01 00:34:43.000000', 'temperatura', 419.0000, 'ºC'),
	(135781, 111, '2015-04-01 00:34:44.000000', 'temperatura', 1035.0000, 'ºC'),
	(135782, 111, '2015-04-01 00:34:45.000000', 'temperatura', 318.0000, 'ºC'),
	(135783, 111, '2015-04-01 00:34:46.000000', 'temperatura', 887.0000, 'ºC'),
	(135784, 111, '2015-04-01 00:34:47.000000', 'temperatura', 1081.0000, 'ºC'),
	(135785, 111, '2015-04-01 00:34:48.000000', 'temperatura', 343.0000, 'ºC'),
	(135786, 111, '2015-04-01 00:34:49.000000', 'temperatura', 875.0000, 'ºC'),
	(135787, 111, '2015-04-01 00:34:50.000000', 'temperatura', 946.0000, 'ºC'),
	(135788, 111, '2015-04-01 00:34:51.000000', 'temperatura', 907.0000, 'ºC'),
	(135789, 111, '2015-04-01 00:34:52.000000', 'temperatura', 494.0000, 'ºC'),
	(135790, 111, '2015-04-01 00:34:53.000000', 'temperatura', 952.0000, 'ºC'),
	(135791, 111, '2015-04-01 00:34:54.000000', 'temperatura', 878.0000, 'ºC'),
	(135792, 111, '2015-04-01 00:34:55.000000', 'temperatura', 335.0000, 'ºC'),
	(135793, 111, '2015-04-01 00:34:56.000000', 'temperatura', 242.0000, 'ºC'),
	(135794, 111, '2015-04-01 00:34:57.000000', 'temperatura', 205.0000, 'ºC'),
	(135795, 111, '2015-04-01 00:34:58.000000', 'temperatura', 298.0000, 'ºC'),
	(135796, 111, '2015-04-01 00:34:59.000000', 'temperatura', 875.0000, 'ºC'),
	(135797, 111, '2015-04-01 00:35:00.000000', 'temperatura', 1081.0000, 'ºC'),
	(135798, 111, '2015-04-01 00:35:01.000000', 'temperatura', 380.0000, 'ºC'),
	(135799, 111, '2015-04-01 00:35:02.000000', 'temperatura', 1057.0000, 'ºC'),
	(135800, 111, '2015-04-01 00:35:03.000000', 'temperatura', 547.0000, 'ºC'),
	(135801, 111, '2015-04-01 00:35:04.000000', 'temperatura', 765.0000, 'ºC'),
	(135802, 111, '2015-04-01 00:35:05.000000', 'temperatura', 984.0000, 'ºC'),
	(135803, 111, '2015-04-01 00:35:06.000000', 'temperatura', 224.0000, 'ºC'),
	(135804, 111, '2015-04-01 00:35:07.000000', 'temperatura', 569.0000, 'ºC'),
	(135805, 111, '2015-04-01 00:35:08.000000', 'temperatura', 975.0000, 'ºC'),
	(135806, 111, '2015-04-01 00:35:09.000000', 'temperatura', 766.0000, 'ºC'),
	(135807, 111, '2015-04-01 00:35:10.000000', 'temperatura', 908.0000, 'ºC'),
	(135808, 111, '2015-04-01 00:35:11.000000', 'temperatura', 1041.0000, 'ºC'),
	(135809, 111, '2015-04-01 00:35:12.000000', 'temperatura', 82.0000, 'ºC'),
	(135810, 111, '2015-04-01 00:35:13.000000', 'temperatura', 887.0000, 'ºC'),
	(135811, 111, '2015-04-01 00:35:14.000000', 'temperatura', 589.0000, 'ºC'),
	(135812, 111, '2015-04-01 00:35:15.000000', 'temperatura', 285.0000, 'ºC'),
	(135813, 111, '2015-04-01 00:35:16.000000', 'temperatura', 858.0000, 'ºC'),
	(135814, 111, '2015-04-01 00:35:17.000000', 'temperatura', 1036.0000, 'ºC'),
	(135815, 111, '2015-04-01 00:35:18.000000', 'temperatura', 207.0000, 'ºC'),
	(135816, 111, '2015-04-01 00:35:19.000000', 'temperatura', 329.0000, 'ºC'),
	(135817, 111, '2015-04-01 00:35:20.000000', 'temperatura', 1023.0000, 'ºC'),
	(135818, 111, '2015-04-01 00:35:21.000000', 'temperatura', 529.0000, 'ºC'),
	(135819, 111, '2015-04-01 00:35:22.000000', 'temperatura', 775.0000, 'ºC'),
	(135820, 111, '2015-04-01 00:35:23.000000', 'temperatura', 1091.0000, 'ºC'),
	(135821, 111, '2015-04-01 00:35:24.000000', 'temperatura', 728.0000, 'ºC'),
	(135822, 111, '2015-04-01 00:35:25.000000', 'temperatura', 369.0000, 'ºC'),
	(135823, 111, '2015-04-01 00:35:26.000000', 'temperatura', 862.0000, 'ºC'),
	(135824, 111, '2015-04-01 00:35:27.000000', 'temperatura', 803.0000, 'ºC'),
	(135825, 111, '2015-04-01 00:35:28.000000', 'temperatura', 231.0000, 'ºC'),
	(135826, 111, '2015-04-01 00:35:29.000000', 'temperatura', 1145.0000, 'ºC'),
	(135827, 111, '2015-04-01 00:35:30.000000', 'temperatura', 234.0000, 'ºC'),
	(135828, 111, '2015-04-01 00:35:31.000000', 'temperatura', 133.0000, 'ºC'),
	(135829, 111, '2015-04-01 00:35:32.000000', 'temperatura', 1163.0000, 'ºC'),
	(135830, 111, '2015-04-01 00:35:33.000000', 'temperatura', 619.0000, 'ºC'),
	(135831, 111, '2015-04-01 00:35:34.000000', 'temperatura', 803.0000, 'ºC'),
	(135832, 111, '2015-04-01 00:35:35.000000', 'temperatura', 962.0000, 'ºC'),
	(135833, 111, '2015-04-01 00:35:36.000000', 'temperatura', 2.0000, 'ºC'),
	(135834, 111, '2015-04-01 00:35:37.000000', 'temperatura', 722.0000, 'ºC'),
	(135835, 111, '2015-04-01 00:35:38.000000', 'temperatura', 4.0000, 'ºC'),
	(135836, 111, '2015-04-01 00:35:39.000000', 'temperatura', 257.0000, 'ºC'),
	(135837, 111, '2015-04-01 00:35:40.000000', 'temperatura', 73.0000, 'ºC'),
	(135838, 111, '2015-04-01 00:35:41.000000', 'temperatura', 795.0000, 'ºC'),
	(135839, 111, '2015-04-01 00:35:42.000000', 'temperatura', 155.0000, 'ºC'),
	(135840, 111, '2015-04-01 00:35:43.000000', 'temperatura', 793.0000, 'ºC'),
	(135841, 111, '2015-04-01 00:35:44.000000', 'temperatura', 1100.0000, 'ºC'),
	(135842, 111, '2015-04-01 00:35:45.000000', 'temperatura', 721.0000, 'ºC'),
	(135843, 111, '2015-04-01 00:35:46.000000', 'temperatura', 306.0000, 'ºC'),
	(135844, 111, '2015-04-01 00:35:47.000000', 'temperatura', 567.0000, 'ºC'),
	(135845, 111, '2015-04-01 00:35:48.000000', 'temperatura', 717.0000, 'ºC'),
	(135846, 111, '2015-04-01 00:35:49.000000', 'temperatura', 685.0000, 'ºC'),
	(135847, 111, '2015-04-01 00:35:50.000000', 'temperatura', 75.0000, 'ºC'),
	(135848, 111, '2015-04-01 00:35:51.000000', 'temperatura', 718.0000, 'ºC'),
	(135849, 111, '2015-04-01 00:35:52.000000', 'temperatura', 968.0000, 'ºC'),
	(135850, 111, '2015-04-01 00:35:53.000000', 'temperatura', 285.0000, 'ºC'),
	(135851, 111, '2015-04-01 00:35:54.000000', 'temperatura', 920.0000, 'ºC'),
	(135852, 111, '2015-04-01 00:35:55.000000', 'temperatura', 147.0000, 'ºC'),
	(135853, 111, '2015-04-01 00:35:56.000000', 'temperatura', 377.0000, 'ºC'),
	(135854, 111, '2015-04-01 00:35:57.000000', 'temperatura', 245.0000, 'ºC'),
	(135855, 111, '2015-04-01 00:35:58.000000', 'temperatura', 92.0000, 'ºC'),
	(135856, 111, '2015-04-01 00:35:59.000000', 'temperatura', 926.0000, 'ºC'),
	(135857, 111, '2015-04-01 00:36:00.000000', 'temperatura', 757.0000, 'ºC'),
	(135858, 111, '2015-04-01 00:36:01.000000', 'temperatura', 1004.0000, 'ºC'),
	(135859, 111, '2015-04-01 00:36:02.000000', 'temperatura', 351.0000, 'ºC'),
	(135860, 111, '2015-04-01 00:36:03.000000', 'temperatura', 1144.0000, 'ºC'),
	(135861, 111, '2015-04-01 00:36:04.000000', 'temperatura', 1068.0000, 'ºC'),
	(135862, 111, '2015-04-01 00:36:05.000000', 'temperatura', 710.0000, 'ºC'),
	(135863, 111, '2015-04-01 00:36:06.000000', 'temperatura', 345.0000, 'ºC'),
	(135864, 111, '2015-04-01 00:36:07.000000', 'temperatura', 796.0000, 'ºC'),
	(135865, 111, '2015-04-01 00:36:08.000000', 'temperatura', 543.0000, 'ºC'),
	(135866, 111, '2015-04-01 00:36:09.000000', 'temperatura', 330.0000, 'ºC'),
	(135867, 111, '2015-04-01 00:36:10.000000', 'temperatura', 19.0000, 'ºC'),
	(135868, 111, '2015-04-01 00:36:11.000000', 'temperatura', 309.0000, 'ºC'),
	(135869, 111, '2015-04-01 00:36:12.000000', 'temperatura', 286.0000, 'ºC'),
	(135870, 111, '2015-04-01 00:36:13.000000', 'temperatura', 504.0000, 'ºC'),
	(135871, 111, '2015-04-01 00:36:14.000000', 'temperatura', 463.0000, 'ºC'),
	(135872, 111, '2015-04-01 00:36:15.000000', 'temperatura', 805.0000, 'ºC'),
	(135873, 111, '2015-04-01 00:36:16.000000', 'temperatura', 236.0000, 'ºC'),
	(135874, 111, '2015-04-01 00:36:17.000000', 'temperatura', 1164.0000, 'ºC'),
	(135875, 111, '2015-04-01 00:36:18.000000', 'temperatura', 312.0000, 'ºC'),
	(135876, 111, '2015-04-01 00:36:19.000000', 'temperatura', 471.0000, 'ºC'),
	(135877, 111, '2015-04-01 00:36:20.000000', 'temperatura', 218.0000, 'ºC'),
	(135878, 111, '2015-04-01 00:36:21.000000', 'temperatura', 878.0000, 'ºC'),
	(135879, 111, '2015-04-01 00:36:22.000000', 'temperatura', 135.0000, 'ºC'),
	(135880, 111, '2015-04-01 00:36:23.000000', 'temperatura', 441.0000, 'ºC'),
	(135881, 111, '2015-04-01 00:36:24.000000', 'temperatura', 601.0000, 'ºC'),
	(135882, 111, '2015-04-01 00:36:25.000000', 'temperatura', 484.0000, 'ºC'),
	(135883, 111, '2015-04-01 00:36:26.000000', 'temperatura', 615.0000, 'ºC'),
	(135884, 111, '2015-04-01 00:36:27.000000', 'temperatura', 423.0000, 'ºC'),
	(135885, 111, '2015-04-01 00:36:28.000000', 'temperatura', 273.0000, 'ºC'),
	(135886, 111, '2015-04-01 00:36:29.000000', 'temperatura', 94.0000, 'ºC'),
	(135887, 111, '2015-04-01 00:36:30.000000', 'temperatura', 853.0000, 'ºC'),
	(135888, 111, '2015-04-01 00:36:31.000000', 'temperatura', 381.0000, 'ºC'),
	(135889, 111, '2015-04-01 00:36:32.000000', 'temperatura', 550.0000, 'ºC'),
	(135890, 111, '2015-04-01 00:36:33.000000', 'temperatura', 406.0000, 'ºC'),
	(135891, 111, '2015-04-01 00:36:34.000000', 'temperatura', 380.0000, 'ºC'),
	(135892, 111, '2015-04-01 00:36:35.000000', 'temperatura', 682.0000, 'ºC'),
	(135893, 111, '2015-04-01 00:36:36.000000', 'temperatura', 1069.0000, 'ºC'),
	(135894, 111, '2015-04-01 00:36:37.000000', 'temperatura', 902.0000, 'ºC'),
	(135895, 111, '2015-04-01 00:36:38.000000', 'temperatura', 105.0000, 'ºC'),
	(135896, 111, '2015-04-01 00:36:39.000000', 'temperatura', 217.0000, 'ºC'),
	(135897, 111, '2015-04-01 00:36:40.000000', 'temperatura', 770.0000, 'ºC'),
	(135898, 111, '2015-04-01 00:36:41.000000', 'temperatura', 802.0000, 'ºC'),
	(135899, 111, '2015-04-01 00:36:42.000000', 'temperatura', 499.0000, 'ºC'),
	(135900, 111, '2015-04-01 00:36:43.000000', 'temperatura', 90.0000, 'ºC'),
	(135901, 111, '2015-04-01 00:36:44.000000', 'temperatura', 153.0000, 'ºC'),
	(135902, 111, '2015-04-01 00:36:45.000000', 'temperatura', 496.0000, 'ºC'),
	(135903, 111, '2015-04-01 00:36:46.000000', 'temperatura', 821.0000, 'ºC'),
	(135904, 111, '2015-04-01 00:36:47.000000', 'temperatura', 219.0000, 'ºC'),
	(135905, 111, '2015-04-01 00:36:48.000000', 'temperatura', 1030.0000, 'ºC'),
	(135906, 111, '2015-04-01 00:36:49.000000', 'temperatura', 893.0000, 'ºC'),
	(135907, 111, '2015-04-01 00:36:50.000000', 'temperatura', 178.0000, 'ºC'),
	(135908, 111, '2015-04-01 00:36:51.000000', 'temperatura', 611.0000, 'ºC'),
	(135909, 111, '2015-04-01 00:36:52.000000', 'temperatura', 121.0000, 'ºC'),
	(135910, 111, '2015-04-01 00:36:53.000000', 'temperatura', 1174.0000, 'ºC'),
	(135911, 111, '2015-04-01 00:36:54.000000', 'temperatura', 706.0000, 'ºC'),
	(135912, 111, '2015-04-01 00:36:55.000000', 'temperatura', 11.0000, 'ºC'),
	(135913, 111, '2015-04-01 00:36:56.000000', 'temperatura', 334.0000, 'ºC'),
	(135914, 111, '2015-04-01 00:36:57.000000', 'temperatura', 440.0000, 'ºC'),
	(135915, 111, '2015-04-01 00:36:58.000000', 'temperatura', 1196.0000, 'ºC'),
	(135916, 111, '2015-04-01 00:36:59.000000', 'temperatura', 1063.0000, 'ºC'),
	(135917, 111, '2015-04-01 00:37:00.000000', 'temperatura', 526.0000, 'ºC'),
	(135918, 111, '2015-04-01 00:37:01.000000', 'temperatura', 640.0000, 'ºC'),
	(135919, 111, '2015-04-01 00:37:02.000000', 'temperatura', 423.0000, 'ºC'),
	(135920, 111, '2015-04-01 00:37:03.000000', 'temperatura', 198.0000, 'ºC'),
	(135921, 111, '2015-04-01 00:37:04.000000', 'temperatura', 921.0000, 'ºC'),
	(135922, 111, '2015-04-01 00:37:05.000000', 'temperatura', 410.0000, 'ºC'),
	(135923, 111, '2015-04-01 00:37:06.000000', 'temperatura', 488.0000, 'ºC'),
	(135924, 111, '2015-04-01 00:37:07.000000', 'temperatura', 8.0000, 'ºC'),
	(135925, 111, '2015-04-01 00:37:08.000000', 'temperatura', 980.0000, 'ºC'),
	(135926, 111, '2015-04-01 00:37:09.000000', 'temperatura', 77.0000, 'ºC'),
	(135927, 111, '2015-04-01 00:37:10.000000', 'temperatura', 1043.0000, 'ºC'),
	(135928, 111, '2015-04-01 00:37:11.000000', 'temperatura', 186.0000, 'ºC'),
	(135929, 111, '2015-04-01 00:37:12.000000', 'temperatura', 201.0000, 'ºC'),
	(135930, 111, '2015-04-01 00:37:13.000000', 'temperatura', 447.0000, 'ºC'),
	(135931, 111, '2015-04-01 00:37:14.000000', 'temperatura', 431.0000, 'ºC'),
	(135932, 111, '2015-04-01 00:37:15.000000', 'temperatura', 818.0000, 'ºC'),
	(135933, 111, '2015-04-01 00:37:16.000000', 'temperatura', 395.0000, 'ºC'),
	(135934, 111, '2015-04-01 00:37:17.000000', 'temperatura', 723.0000, 'ºC'),
	(135935, 111, '2015-04-01 00:37:18.000000', 'temperatura', 32.0000, 'ºC'),
	(135936, 111, '2015-04-01 00:37:19.000000', 'temperatura', 390.0000, 'ºC'),
	(135937, 111, '2015-04-01 00:37:20.000000', 'temperatura', 656.0000, 'ºC'),
	(135938, 111, '2015-04-01 00:37:21.000000', 'temperatura', 908.0000, 'ºC'),
	(135939, 111, '2015-04-01 00:37:22.000000', 'temperatura', 175.0000, 'ºC'),
	(135940, 111, '2015-04-01 00:37:23.000000', 'temperatura', 550.0000, 'ºC'),
	(135941, 111, '2015-04-01 00:37:24.000000', 'temperatura', 1025.0000, 'ºC'),
	(135942, 111, '2015-04-01 00:37:25.000000', 'temperatura', 1078.0000, 'ºC'),
	(135943, 111, '2015-04-01 00:37:26.000000', 'temperatura', 1113.0000, 'ºC'),
	(135944, 111, '2015-04-01 00:37:27.000000', 'temperatura', 1131.0000, 'ºC'),
	(135945, 111, '2015-04-01 00:37:28.000000', 'temperatura', 1118.0000, 'ºC'),
	(135946, 111, '2015-04-01 00:37:29.000000', 'temperatura', 998.0000, 'ºC'),
	(135947, 111, '2015-04-01 00:37:30.000000', 'temperatura', 434.0000, 'ºC'),
	(135948, 111, '2015-04-01 00:37:31.000000', 'temperatura', 379.0000, 'ºC'),
	(135949, 111, '2015-04-01 00:37:32.000000', 'temperatura', 594.0000, 'ºC'),
	(135950, 111, '2015-04-01 00:37:33.000000', 'temperatura', 634.0000, 'ºC'),
	(135951, 111, '2015-04-01 00:37:34.000000', 'temperatura', 189.0000, 'ºC'),
	(135952, 111, '2015-04-01 00:37:35.000000', 'temperatura', 244.0000, 'ºC'),
	(135953, 111, '2015-04-01 00:37:36.000000', 'temperatura', 651.0000, 'ºC'),
	(135954, 111, '2015-04-01 00:37:37.000000', 'temperatura', 124.0000, 'ºC'),
	(135955, 111, '2015-04-01 00:37:38.000000', 'temperatura', 1068.0000, 'ºC'),
	(135956, 111, '2015-04-01 00:37:39.000000', 'temperatura', 171.0000, 'ºC'),
	(135957, 111, '2015-04-01 00:37:40.000000', 'temperatura', 48.0000, 'ºC'),
	(135958, 111, '2015-04-01 00:37:41.000000', 'temperatura', 927.0000, 'ºC'),
	(135959, 111, '2015-04-01 00:37:42.000000', 'temperatura', 893.0000, 'ºC'),
	(135960, 111, '2015-04-01 00:37:43.000000', 'temperatura', 484.0000, 'ºC'),
	(135961, 111, '2015-04-01 00:37:44.000000', 'temperatura', 940.0000, 'ºC'),
	(135962, 111, '2015-04-01 00:37:45.000000', 'temperatura', 848.0000, 'ºC'),
	(135963, 111, '2015-04-01 00:37:46.000000', 'temperatura', 220.0000, 'ºC'),
	(135964, 111, '2015-04-01 00:37:47.000000', 'temperatura', 959.0000, 'ºC'),
	(135965, 111, '2015-04-01 00:37:48.000000', 'temperatura', 536.0000, 'ºC'),
	(135966, 111, '2015-04-01 00:37:49.000000', 'temperatura', 1001.0000, 'ºC'),
	(135967, 111, '2015-04-01 00:37:50.000000', 'temperatura', 999.0000, 'ºC'),
	(135968, 111, '2015-04-01 00:37:51.000000', 'temperatura', 793.0000, 'ºC'),
	(135969, 111, '2015-04-01 00:37:52.000000', 'temperatura', 968.0000, 'ºC'),
	(135970, 111, '2015-04-01 00:37:53.000000', 'temperatura', 62.0000, 'ºC'),
	(135971, 111, '2015-04-01 00:37:54.000000', 'temperatura', 1007.0000, 'ºC'),
	(135972, 111, '2015-04-01 00:37:55.000000', 'temperatura', 50.0000, 'ºC'),
	(135973, 111, '2015-04-01 00:37:56.000000', 'temperatura', 829.0000, 'ºC'),
	(135974, 111, '2015-04-01 00:37:57.000000', 'temperatura', 394.0000, 'ºC'),
	(135975, 111, '2015-04-01 00:37:58.000000', 'temperatura', 684.0000, 'ºC'),
	(135976, 111, '2015-04-01 00:37:59.000000', 'temperatura', 1037.0000, 'ºC'),
	(135977, 111, '2015-04-01 00:38:00.000000', 'temperatura', 734.0000, 'ºC'),
	(135978, 111, '2015-04-01 00:38:01.000000', 'temperatura', 561.0000, 'ºC'),
	(135979, 111, '2015-04-01 00:38:02.000000', 'temperatura', 602.0000, 'ºC'),
	(135980, 111, '2015-04-01 00:38:03.000000', 'temperatura', 127.0000, 'ºC'),
	(135981, 111, '2015-04-01 00:38:04.000000', 'temperatura', 29.0000, 'ºC'),
	(135982, 111, '2015-04-01 00:38:05.000000', 'temperatura', 964.0000, 'ºC'),
	(135983, 111, '2015-04-01 00:38:06.000000', 'temperatura', 1133.0000, 'ºC'),
	(135984, 111, '2015-04-01 00:38:07.000000', 'temperatura', 374.0000, 'ºC'),
	(135985, 111, '2015-04-01 00:38:08.000000', 'temperatura', 871.0000, 'ºC'),
	(135986, 111, '2015-04-01 00:38:09.000000', 'temperatura', 834.0000, 'ºC'),
	(135987, 111, '2015-04-01 00:38:10.000000', 'temperatura', 359.0000, 'ºC'),
	(135988, 111, '2015-04-01 00:38:11.000000', 'temperatura', 494.0000, 'ºC'),
	(135989, 111, '2015-04-01 00:38:12.000000', 'temperatura', 194.0000, 'ºC'),
	(135990, 111, '2015-04-01 00:38:13.000000', 'temperatura', 685.0000, 'ºC'),
	(135991, 111, '2015-04-01 00:38:14.000000', 'temperatura', 447.0000, 'ºC'),
	(135992, 111, '2015-04-01 00:38:15.000000', 'temperatura', 179.0000, 'ºC'),
	(135993, 111, '2015-04-01 00:38:16.000000', 'temperatura', 755.0000, 'ºC'),
	(135994, 111, '2015-04-01 00:38:17.000000', 'temperatura', 836.0000, 'ºC'),
	(135995, 111, '2015-04-01 00:38:18.000000', 'temperatura', 718.0000, 'ºC'),
	(135996, 111, '2015-04-01 00:38:19.000000', 'temperatura', 1082.0000, 'ºC'),
	(135997, 111, '2015-04-01 00:38:20.000000', 'temperatura', 859.0000, 'ºC'),
	(135998, 111, '2015-04-01 00:38:21.000000', 'temperatura', 1046.0000, 'ºC'),
	(135999, 111, '2015-04-01 00:38:22.000000', 'temperatura', 254.0000, 'ºC'),
	(136000, 111, '2015-04-01 00:38:23.000000', 'temperatura', 531.0000, 'ºC'),
	(136001, 111, '2015-04-01 00:38:24.000000', 'temperatura', 696.0000, 'ºC'),
	(136002, 111, '2015-04-01 00:38:25.000000', 'temperatura', 689.0000, 'ºC'),
	(136003, 111, '2015-04-01 00:38:26.000000', 'temperatura', 155.0000, 'ºC'),
	(136004, 111, '2015-04-01 00:38:27.000000', 'temperatura', 1108.0000, 'ºC'),
	(136005, 111, '2015-04-01 00:38:28.000000', 'temperatura', 274.0000, 'ºC'),
	(136006, 111, '2015-04-01 00:38:29.000000', 'temperatura', 450.0000, 'ºC'),
	(136007, 111, '2015-04-01 00:38:30.000000', 'temperatura', 226.0000, 'ºC'),
	(136008, 111, '2015-04-01 00:38:31.000000', 'temperatura', 981.0000, 'ºC'),
	(136009, 111, '2015-04-01 00:38:32.000000', 'temperatura', 628.0000, 'ºC'),
	(136010, 111, '2015-04-01 00:38:33.000000', 'temperatura', 197.0000, 'ºC'),
	(136011, 111, '2015-04-01 00:38:34.000000', 'temperatura', 300.0000, 'ºC'),
	(136012, 111, '2015-04-01 00:38:35.000000', 'temperatura', 910.0000, 'ºC'),
	(136013, 111, '2015-04-01 00:38:36.000000', 'temperatura', 49.0000, 'ºC'),
	(136014, 111, '2015-04-01 00:38:37.000000', 'temperatura', 1117.0000, 'ºC'),
	(136015, 111, '2015-04-01 00:38:38.000000', 'temperatura', 636.0000, 'ºC'),
	(136016, 111, '2015-04-01 00:38:39.000000', 'temperatura', 1032.0000, 'ºC'),
	(136017, 111, '2015-04-01 00:38:40.000000', 'temperatura', 853.0000, 'ºC'),
	(136018, 111, '2015-04-01 00:38:41.000000', 'temperatura', 1171.0000, 'ºC'),
	(136019, 111, '2015-04-01 00:38:42.000000', 'temperatura', 894.0000, 'ºC'),
	(136020, 111, '2015-04-01 00:38:43.000000', 'temperatura', 959.0000, 'ºC'),
	(136021, 111, '2015-04-01 00:38:44.000000', 'temperatura', 913.0000, 'ºC'),
	(136022, 111, '2015-04-01 00:38:45.000000', 'temperatura', 486.0000, 'ºC'),
	(136023, 111, '2015-04-01 00:38:46.000000', 'temperatura', 895.0000, 'ºC'),
	(136024, 111, '2015-04-01 00:38:47.000000', 'temperatura', 617.0000, 'ºC'),
	(136025, 111, '2015-04-01 00:38:48.000000', 'temperatura', 400.0000, 'ºC'),
	(136026, 111, '2015-04-01 00:38:49.000000', 'temperatura', 148.0000, 'ºC'),
	(136027, 111, '2015-04-01 00:38:50.000000', 'temperatura', 742.0000, 'ºC'),
	(136028, 111, '2015-04-01 00:38:51.000000', 'temperatura', 866.0000, 'ºC'),
	(136029, 111, '2015-04-01 00:38:52.000000', 'temperatura', 903.0000, 'ºC'),
	(136030, 111, '2015-04-01 00:38:53.000000', 'temperatura', 720.0000, 'ºC'),
	(136031, 111, '2015-04-01 00:38:54.000000', 'temperatura', 892.0000, 'ºC'),
	(136032, 111, '2015-04-01 00:38:55.000000', 'temperatura', 1100.0000, 'ºC'),
	(136033, 111, '2015-04-01 00:38:56.000000', 'temperatura', 424.0000, 'ºC'),
	(136034, 111, '2015-04-01 00:38:57.000000', 'temperatura', 20.0000, 'ºC'),
	(136035, 111, '2015-04-01 00:38:58.000000', 'temperatura', 29.0000, 'ºC'),
	(136036, 111, '2015-04-01 00:38:59.000000', 'temperatura', 84.0000, 'ºC'),
	(136037, 111, '2015-04-01 00:39:00.000000', 'temperatura', 333.0000, 'ºC'),
	(136038, 111, '2015-04-01 00:39:01.000000', 'temperatura', 213.0000, 'ºC'),
	(136039, 111, '2015-04-01 00:39:02.000000', 'temperatura', 69.0000, 'ºC'),
	(136040, 111, '2015-04-01 00:39:03.000000', 'temperatura', 906.0000, 'ºC'),
	(136041, 111, '2015-04-01 00:39:04.000000', 'temperatura', 723.0000, 'ºC'),
	(136042, 111, '2015-04-01 00:39:05.000000', 'temperatura', 897.0000, 'ºC'),
	(136043, 111, '2015-04-01 00:39:06.000000', 'temperatura', 1115.0000, 'ºC'),
	(136044, 111, '2015-04-01 00:39:07.000000', 'temperatura', 487.0000, 'ºC'),
	(136045, 111, '2015-04-01 00:39:08.000000', 'temperatura', 290.0000, 'ºC'),
	(136046, 111, '2015-04-01 00:39:09.000000', 'temperatura', 1190.0000, 'ºC'),
	(136047, 111, '2015-04-01 00:39:10.000000', 'temperatura', 279.0000, 'ºC'),
	(136048, 111, '2015-04-01 00:39:11.000000', 'temperatura', 225.0000, 'ºC'),
	(136049, 111, '2015-04-01 00:39:12.000000', 'temperatura', 291.0000, 'ºC'),
	(136050, 111, '2015-04-01 00:39:13.000000', 'temperatura', 781.0000, 'ºC'),
	(136051, 111, '2015-04-01 00:39:14.000000', 'temperatura', 631.0000, 'ºC'),
	(136052, 111, '2015-04-01 00:39:15.000000', 'temperatura', 814.0000, 'ºC'),
	(136053, 111, '2015-04-01 00:39:16.000000', 'temperatura', 976.0000, 'ºC'),
	(136054, 111, '2015-04-01 00:39:17.000000', 'temperatura', 41.0000, 'ºC'),
	(136055, 111, '2015-04-01 00:39:18.000000', 'temperatura', 875.0000, 'ºC'),
	(136056, 111, '2015-04-01 00:39:19.000000', 'temperatura', 655.0000, 'ºC'),
	(136057, 111, '2015-04-01 00:39:20.000000', 'temperatura', 649.0000, 'ºC'),
	(136058, 111, '2015-04-01 00:39:21.000000', 'temperatura', 81.0000, 'ºC'),
	(136059, 111, '2015-04-01 00:39:22.000000', 'temperatura', 856.0000, 'ºC'),
	(136060, 111, '2015-04-01 00:39:23.000000', 'temperatura', 441.0000, 'ºC'),
	(136061, 111, '2015-04-01 00:39:24.000000', 'temperatura', 836.0000, 'ºC'),
	(136062, 111, '2015-04-01 00:39:25.000000', 'temperatura', 459.0000, 'ºC'),
	(136063, 111, '2015-04-01 00:39:26.000000', 'temperatura', 986.0000, 'ºC'),
	(136064, 111, '2015-04-01 00:39:27.000000', 'temperatura', 1154.0000, 'ºC'),
	(136065, 111, '2015-04-01 00:39:28.000000', 'temperatura', 411.0000, 'ºC'),
	(136066, 111, '2015-04-01 00:39:29.000000', 'temperatura', 994.0000, 'ºC'),
	(136067, 111, '2015-04-01 00:39:30.000000', 'temperatura', 139.0000, 'ºC'),
	(136068, 111, '2015-04-01 00:39:31.000000', 'temperatura', 113.0000, 'ºC'),
	(136069, 111, '2015-04-01 00:39:32.000000', 'temperatura', 150.0000, 'ºC'),
	(136070, 111, '2015-04-01 00:39:33.000000', 'temperatura', 410.0000, 'ºC'),
	(136071, 111, '2015-04-01 00:39:34.000000', 'temperatura', 399.0000, 'ºC'),
	(136072, 111, '2015-04-01 00:39:35.000000', 'temperatura', 766.0000, 'ºC'),
	(136073, 111, '2015-04-01 00:39:36.000000', 'temperatura', 233.0000, 'ºC'),
	(136074, 111, '2015-04-01 00:39:37.000000', 'temperatura', 66.0000, 'ºC'),
	(136075, 111, '2015-04-01 00:39:38.000000', 'temperatura', 834.0000, 'ºC'),
	(136076, 111, '2015-04-01 00:39:39.000000', 'temperatura', 370.0000, 'ºC'),
	(136077, 111, '2015-04-01 00:39:40.000000', 'temperatura', 551.0000, 'ºC'),
	(136078, 111, '2015-04-01 00:39:41.000000', 'temperatura', 443.0000, 'ºC'),
	(136079, 111, '2015-04-01 00:39:42.000000', 'temperatura', 562.0000, 'ºC'),
	(136080, 111, '2015-04-01 00:39:43.000000', 'temperatura', 281.0000, 'ºC'),
	(136081, 111, '2015-04-01 00:39:44.000000', 'temperatura', 922.0000, 'ºC'),
	(136082, 111, '2015-04-01 00:39:45.000000', 'temperatura', 168.0000, 'ºC'),
	(136083, 111, '2015-04-01 00:39:46.000000', 'temperatura', 472.0000, 'ºC'),
	(136084, 111, '2015-04-01 00:39:47.000000', 'temperatura', 656.0000, 'ºC'),
	(136085, 111, '2015-04-01 00:39:48.000000', 'temperatura', 666.0000, 'ºC'),
	(136086, 111, '2015-04-01 00:39:49.000000', 'temperatura', 164.0000, 'ºC'),
	(136087, 111, '2015-04-01 00:39:50.000000', 'temperatura', 21.0000, 'ºC'),
	(136088, 111, '2015-04-01 00:39:51.000000', 'temperatura', 812.0000, 'ºC'),
	(136089, 111, '2015-04-01 00:39:52.000000', 'temperatura', 398.0000, 'ºC'),
	(136090, 111, '2015-04-01 00:39:53.000000', 'temperatura', 755.0000, 'ºC'),
	(136091, 111, '2015-04-01 00:39:54.000000', 'temperatura', 182.0000, 'ºC'),
	(136092, 111, '2015-04-01 00:39:55.000000', 'temperatura', 1043.0000, 'ºC'),
	(136093, 111, '2015-04-01 00:39:56.000000', 'temperatura', 1073.0000, 'ºC'),
	(136094, 111, '2015-04-01 00:39:57.000000', 'temperatura', 1033.0000, 'ºC'),
	(136095, 111, '2015-04-01 00:39:58.000000', 'temperatura', 749.0000, 'ºC'),
	(136096, 111, '2015-04-01 00:39:59.000000', 'temperatura', 645.0000, 'ºC'),
	(136097, 111, '2015-04-01 00:40:00.000000', 'temperatura', 977.0000, 'ºC'),
	(136098, 111, '2015-04-01 00:40:01.000000', 'temperatura', 552.0000, 'ºC'),
	(136099, 111, '2015-04-01 00:40:02.000000', 'temperatura', 1029.0000, 'ºC'),
	(136100, 111, '2015-04-01 00:40:03.000000', 'temperatura', 1090.0000, 'ºC'),
	(136101, 111, '2015-04-01 00:40:04.000000', 'temperatura', 1164.0000, 'ºC'),
	(136102, 111, '2015-04-01 00:40:05.000000', 'temperatura', 152.0000, 'ºC'),
	(136103, 111, '2015-04-01 00:40:06.000000', 'temperatura', 865.0000, 'ºC'),
	(136104, 111, '2015-04-01 00:40:07.000000', 'temperatura', 271.0000, 'ºC'),
	(136105, 111, '2015-04-01 00:40:08.000000', 'temperatura', 1162.0000, 'ºC'),
	(136106, 111, '2015-04-01 00:40:09.000000', 'temperatura', 196.0000, 'ºC'),
	(136107, 111, '2015-04-01 00:40:10.000000', 'temperatura', 1095.0000, 'ºC'),
	(136108, 111, '2015-04-01 00:40:11.000000', 'temperatura', 86.0000, 'ºC'),
	(136109, 111, '2015-04-01 00:40:12.000000', 'temperatura', 748.0000, 'ºC'),
	(136110, 111, '2015-04-01 00:40:13.000000', 'temperatura', 1081.0000, 'ºC'),
	(136111, 111, '2015-04-01 00:40:14.000000', 'temperatura', 764.0000, 'ºC'),
	(136112, 111, '2015-04-01 00:40:15.000000', 'temperatura', 575.0000, 'ºC'),
	(136113, 111, '2015-04-01 00:40:16.000000', 'temperatura', 583.0000, 'ºC'),
	(136114, 111, '2015-04-01 00:40:17.000000', 'temperatura', 1190.0000, 'ºC'),
	(136115, 111, '2015-04-01 00:40:18.000000', 'temperatura', 603.0000, 'ºC'),
	(136116, 111, '2015-04-01 00:40:19.000000', 'temperatura', 643.0000, 'ºC'),
	(136117, 111, '2015-04-01 00:40:20.000000', 'temperatura', 209.0000, 'ºC'),
	(136118, 111, '2015-04-01 00:40:21.000000', 'temperatura', 317.0000, 'ºC'),
	(136119, 111, '2015-04-01 00:40:22.000000', 'temperatura', 960.0000, 'ºC'),
	(136120, 111, '2015-04-01 00:40:23.000000', 'temperatura', 246.0000, 'ºC'),
	(136121, 111, '2015-04-01 00:40:24.000000', 'temperatura', 752.0000, 'ºC'),
	(136122, 111, '2015-04-01 00:40:25.000000', 'temperatura', 624.0000, 'ºC'),
	(136123, 111, '2015-04-01 00:40:26.000000', 'temperatura', 863.0000, 'ºC'),
	(136124, 111, '2015-04-01 00:40:27.000000', 'temperatura', 45.0000, 'ºC'),
	(136125, 111, '2015-04-01 00:40:28.000000', 'temperatura', 37.0000, 'ºC'),
	(136126, 111, '2015-04-01 00:40:29.000000', 'temperatura', 50.0000, 'ºC'),
	(136127, 111, '2015-04-01 00:40:30.000000', 'temperatura', 140.0000, 'ºC'),
	(136128, 111, '2015-04-01 00:40:31.000000', 'temperatura', 549.0000, 'ºC'),
	(136129, 111, '2015-04-01 00:40:32.000000', 'temperatura', 1128.0000, 'ºC'),
	(136130, 111, '2015-04-01 00:40:33.000000', 'temperatura', 393.0000, 'ºC'),
	(136131, 111, '2015-04-01 00:40:34.000000', 'temperatura', 979.0000, 'ºC'),
	(136132, 111, '2015-04-01 00:40:35.000000', 'temperatura', 118.0000, 'ºC'),
	(136133, 111, '2015-04-01 00:40:36.000000', 'temperatura', 54.0000, 'ºC'),
	(136134, 111, '2015-04-01 00:40:37.000000', 'temperatura', 1114.0000, 'ºC'),
	(136135, 111, '2015-04-01 00:40:38.000000', 'temperatura', 611.0000, 'ºC'),
	(136136, 111, '2015-04-01 00:40:39.000000', 'temperatura', 914.0000, 'ºC'),
	(136137, 111, '2015-04-01 00:40:40.000000', 'temperatura', 336.0000, 'ºC'),
	(136138, 111, '2015-04-01 00:40:41.000000', 'temperatura', 137.0000, 'ºC'),
	(136139, 111, '2015-04-01 00:40:42.000000', 'temperatura', 880.0000, 'ºC'),
	(136140, 111, '2015-04-01 00:40:43.000000', 'temperatura', 390.0000, 'ºC'),
	(136141, 111, '2015-04-01 00:40:44.000000', 'temperatura', 509.0000, 'ºC'),
	(136142, 111, '2015-04-01 00:40:45.000000', 'temperatura', 177.0000, 'ºC'),
	(136143, 111, '2015-04-01 00:40:46.000000', 'temperatura', 558.0000, 'ºC'),
	(136144, 111, '2015-04-01 00:40:47.000000', 'temperatura', 1060.0000, 'ºC'),
	(136145, 111, '2015-04-01 00:40:48.000000', 'temperatura', 25.0000, 'ºC'),
	(136146, 111, '2015-04-01 00:40:49.000000', 'temperatura', 545.0000, 'ºC'),
	(136147, 111, '2015-04-01 00:40:50.000000', 'temperatura', 251.0000, 'ºC'),
	(136148, 111, '2015-04-01 00:40:51.000000', 'temperatura', 821.0000, 'ºC'),
	(136149, 111, '2015-04-01 00:40:52.000000', 'temperatura', 951.0000, 'ºC'),
	(136150, 111, '2015-04-01 00:40:53.000000', 'temperatura', 1093.0000, 'ºC'),
	(136151, 111, '2015-04-01 00:40:54.000000', 'temperatura', 211.0000, 'ºC'),
	(136152, 111, '2015-04-01 00:40:55.000000', 'temperatura', 179.0000, 'ºC'),
	(136153, 111, '2015-04-01 00:40:56.000000', 'temperatura', 261.0000, 'ºC'),
	(136154, 111, '2015-04-01 00:40:57.000000', 'temperatura', 767.0000, 'ºC'),
	(136155, 111, '2015-04-01 00:40:58.000000', 'temperatura', 654.0000, 'ºC'),
	(136156, 111, '2015-04-01 00:40:59.000000', 'temperatura', 969.0000, 'ºC'),
	(136157, 111, '2015-04-01 00:41:00.000000', 'temperatura', 484.0000, 'ºC'),
	(136158, 111, '2015-04-01 00:41:01.000000', 'temperatura', 712.0000, 'ºC'),
	(136159, 111, '2015-04-01 00:41:02.000000', 'temperatura', 909.0000, 'ºC'),
	(136160, 111, '2015-04-01 00:41:03.000000', 'temperatura', 10.0000, 'ºC'),
	(136161, 111, '2015-04-01 00:41:04.000000', 'temperatura', 922.0000, 'ºC'),
	(136162, 111, '2015-04-01 00:41:05.000000', 'temperatura', 982.0000, 'ºC'),
	(136163, 111, '2015-04-01 00:41:06.000000', 'temperatura', 946.0000, 'ºC'),
	(136164, 111, '2015-04-01 00:41:07.000000', 'temperatura', 582.0000, 'ºC'),
	(136165, 111, '2015-04-01 00:41:08.000000', 'temperatura', 73.0000, 'ºC'),
	(136166, 111, '2015-04-01 00:41:09.000000', 'temperatura', 1018.0000, 'ºC'),
	(136167, 111, '2015-04-01 00:41:10.000000', 'temperatura', 73.0000, 'ºC'),
	(136168, 111, '2015-04-01 00:41:11.000000', 'temperatura', 913.0000, 'ºC'),
	(136169, 111, '2015-04-01 00:41:12.000000', 'temperatura', 745.0000, 'ºC'),
	(136170, 111, '2015-04-01 00:41:13.000000', 'temperatura', 988.0000, 'ºC'),
	(136171, 111, '2015-04-01 00:41:14.000000', 'temperatura', 303.0000, 'ºC'),
	(136172, 111, '2015-04-01 00:41:15.000000', 'temperatura', 955.0000, 'ºC'),
	(136173, 111, '2015-04-01 00:41:16.000000', 'temperatura', 263.0000, 'ºC'),
	(136174, 111, '2015-04-01 00:41:17.000000', 'temperatura', 854.0000, 'ºC'),
	(136175, 111, '2015-04-01 00:41:18.000000', 'temperatura', 1079.0000, 'ºC'),
	(136176, 111, '2015-04-01 00:41:19.000000', 'temperatura', 435.0000, 'ºC'),
	(136177, 111, '2015-04-01 00:41:20.000000', 'temperatura', 139.0000, 'ºC'),
	(136178, 111, '2015-04-01 00:41:21.000000', 'temperatura', 591.0000, 'ºC'),
	(136179, 111, '2015-04-01 00:41:22.000000', 'temperatura', 138.0000, 'ºC'),
	(136180, 111, '2015-04-01 00:41:23.000000', 'temperatura', 119.0000, 'ºC'),
	(136181, 111, '2015-04-01 00:41:24.000000', 'temperatura', 181.0000, 'ºC'),
	(136182, 111, '2015-04-01 00:41:25.000000', 'temperatura', 547.0000, 'ºC'),
	(136183, 111, '2015-04-01 00:41:26.000000', 'temperatura', 993.0000, 'ºC'),
	(136184, 111, '2015-04-01 00:41:27.000000', 'temperatura', 924.0000, 'ºC'),
	(136185, 111, '2015-04-01 00:41:28.000000', 'temperatura', 442.0000, 'ºC'),
	(136186, 111, '2015-04-01 00:41:29.000000', 'temperatura', 637.0000, 'ºC'),
	(136187, 111, '2015-04-01 00:41:30.000000', 'temperatura', 662.0000, 'ºC'),
	(136188, 111, '2015-04-01 00:41:31.000000', 'temperatura', 199.0000, 'ºC'),
	(136189, 111, '2015-04-01 00:41:32.000000', 'temperatura', 208.0000, 'ºC'),
	(136190, 111, '2015-04-01 00:41:33.000000', 'temperatura', 444.0000, 'ºC'),
	(136191, 111, '2015-04-01 00:41:34.000000', 'temperatura', 397.0000, 'ºC'),
	(136192, 111, '2015-04-01 00:41:35.000000', 'temperatura', 652.0000, 'ºC'),
	(136193, 111, '2015-04-01 00:41:36.000000', 'temperatura', 870.0000, 'ºC'),
	(136194, 111, '2015-04-01 00:41:37.000000', 'temperatura', 1194.0000, 'ºC'),
	(136195, 111, '2015-04-01 00:41:38.000000', 'temperatura', 963.0000, 'ºC'),
	(136196, 111, '2015-04-01 00:41:39.000000', 'temperatura', 32.0000, 'ºC'),
	(136197, 111, '2015-04-01 00:41:40.000000', 'temperatura', 870.0000, 'ºC'),
	(136198, 111, '2015-04-01 00:41:41.000000', 'temperatura', 655.0000, 'ºC'),
	(136199, 111, '2015-04-01 00:41:42.000000', 'temperatura', 667.0000, 'ºC'),
	(136200, 111, '2015-04-01 00:41:43.000000', 'temperatura', 169.0000, 'ºC'),
	(136201, 111, '2015-04-01 00:41:44.000000', 'temperatura', 46.0000, 'ºC'),
	(136202, 111, '2015-04-01 00:41:45.000000', 'temperatura', 922.0000, 'ºC'),
	(136203, 111, '2015-04-01 00:41:46.000000', 'temperatura', 871.0000, 'ºC'),
	(136204, 111, '2015-04-01 00:41:47.000000', 'temperatura', 392.0000, 'ºC'),
	(136205, 111, '2015-04-01 00:41:48.000000', 'temperatura', 545.0000, 'ºC'),
	(136206, 111, '2015-04-01 00:41:49.000000', 'temperatura', 351.0000, 'ºC'),
	(136207, 111, '2015-04-01 00:41:50.000000', 'temperatura', 118.0000, 'ºC'),
	(136208, 111, '2015-04-01 00:41:51.000000', 'temperatura', 741.0000, 'ºC'),
	(136209, 111, '2015-04-01 00:41:52.000000', 'temperatura', 948.0000, 'ºC'),
	(136210, 111, '2015-04-01 00:41:53.000000', 'temperatura', 119.0000, 'ºC'),
	(136211, 111, '2015-04-01 00:41:54.000000', 'temperatura', 154.0000, 'ºC'),
	(136212, 111, '2015-04-01 00:41:55.000000', 'temperatura', 410.0000, 'ºC'),
	(136213, 111, '2015-04-01 00:41:56.000000', 'temperatura', 389.0000, 'ºC'),
	(136214, 111, '2015-04-01 00:41:57.000000', 'temperatura', 717.0000, 'ºC'),
	(136215, 111, '2015-04-01 00:41:58.000000', 'temperatura', 19.0000, 'ºC'),
	(136216, 111, '2015-04-01 00:41:59.000000', 'temperatura', 344.0000, 'ºC'),
	(136217, 111, '2015-04-01 00:42:00.000000', 'temperatura', 465.0000, 'ºC'),
	(136218, 111, '2015-04-01 00:42:01.000000', 'temperatura', 91.0000, 'ºC'),
	(136219, 111, '2015-04-01 00:42:02.000000', 'temperatura', 261.0000, 'ºC'),
	(136220, 111, '2015-04-01 00:42:03.000000', 'temperatura', 1033.0000, 'ºC'),
	(136221, 111, '2015-04-01 00:42:04.000000', 'temperatura', 783.0000, 'ºC'),
	(136222, 111, '2015-04-01 00:42:05.000000', 'temperatura', 816.0000, 'ºC'),
	(136223, 111, '2015-04-01 00:42:06.000000', 'temperatura', 533.0000, 'ºC'),
	(136224, 111, '2015-04-01 00:42:07.000000', 'temperatura', 216.0000, 'ºC'),
	(136225, 111, '2015-04-01 00:42:08.000000', 'temperatura', 682.0000, 'ºC'),
	(136226, 111, '2015-04-01 00:42:09.000000', 'temperatura', 364.0000, 'ºC'),
	(136227, 111, '2015-04-01 00:42:10.000000', 'temperatura', 972.0000, 'ºC'),
	(136228, 111, '2015-04-01 00:42:11.000000', 'temperatura', 169.0000, 'ºC'),
	(136229, 111, '2015-04-01 00:42:12.000000', 'temperatura', 331.0000, 'ºC'),
	(136230, 111, '2015-04-01 00:42:13.000000', 'temperatura', 1147.0000, 'ºC'),
	(136231, 111, '2015-04-01 00:42:14.000000', 'temperatura', 1142.0000, 'ºC'),
	(136232, 111, '2015-04-01 00:42:15.000000', 'temperatura', 1070.0000, 'ºC'),
	(136233, 111, '2015-04-01 00:42:16.000000', 'temperatura', 726.0000, 'ºC'),
	(136234, 111, '2015-04-01 00:42:17.000000', 'temperatura', 418.0000, 'ºC'),
	(136235, 111, '2015-04-01 00:42:18.000000', 'temperatura', 1116.0000, 'ºC'),
	(136236, 111, '2015-04-01 00:42:19.000000', 'temperatura', 723.0000, 'ºC'),
	(136237, 111, '2015-04-01 00:42:20.000000', 'temperatura', 267.0000, 'ºC'),
	(136238, 111, '2015-04-01 00:42:21.000000', 'temperatura', 369.0000, 'ºC'),
	(136239, 111, '2015-04-01 00:42:22.000000', 'temperatura', 1045.0000, 'ºC'),
	(136240, 111, '2015-04-01 00:42:23.000000', 'temperatura', 516.0000, 'ºC'),
	(136241, 111, '2015-04-01 00:42:24.000000', 'temperatura', 648.0000, 'ºC'),
	(136242, 111, '2015-04-01 00:42:25.000000', 'temperatura', 491.0000, 'ºC'),
	(136243, 111, '2015-04-01 00:42:26.000000', 'temperatura', 510.0000, 'ºC'),
	(136244, 111, '2015-04-01 00:42:27.000000', 'temperatura', 1079.0000, 'ºC'),
	(136245, 111, '2015-04-01 00:42:28.000000', 'temperatura', 265.0000, 'ºC'),
	(136246, 111, '2015-04-01 00:42:29.000000', 'temperatura', 488.0000, 'ºC'),
	(136247, 111, '2015-04-01 00:42:30.000000', 'temperatura', 448.0000, 'ºC'),
	(136248, 111, '2015-04-01 00:42:31.000000', 'temperatura', 775.0000, 'ºC'),
	(136249, 111, '2015-04-01 00:42:32.000000', 'temperatura', 129.0000, 'ºC'),
	(136250, 111, '2015-04-01 00:42:33.000000', 'temperatura', 724.0000, 'ºC'),
	(136251, 111, '2015-04-01 00:42:34.000000', 'temperatura', 834.0000, 'ºC'),
	(136252, 111, '2015-04-01 00:42:35.000000', 'temperatura', 798.0000, 'ºC'),
	(136253, 111, '2015-04-01 00:42:36.000000', 'temperatura', 289.0000, 'ºC'),
	(136254, 111, '2015-04-01 00:42:37.000000', 'temperatura', 253.0000, 'ºC'),
	(136255, 111, '2015-04-01 00:42:38.000000', 'temperatura', 396.0000, 'ºC'),
	(136256, 111, '2015-04-01 00:42:39.000000', 'temperatura', 20.0000, 'ºC'),
	(136257, 111, '2015-04-01 00:42:40.000000', 'temperatura', 116.0000, 'ºC'),
	(136258, 111, '2015-04-01 00:42:41.000000', 'temperatura', 520.0000, 'ºC'),
	(136259, 111, '2015-04-01 00:42:42.000000', 'temperatura', 1051.0000, 'ºC'),
	(136260, 111, '2015-04-01 00:42:43.000000', 'temperatura', 94.0000, 'ºC'),
	(136261, 111, '2015-04-01 00:42:44.000000', 'temperatura', 919.0000, 'ºC'),
	(136262, 111, '2015-04-01 00:42:45.000000', 'temperatura', 716.0000, 'ºC'),
	(136263, 111, '2015-04-01 00:42:46.000000', 'temperatura', 820.0000, 'ºC'),
	(136264, 111, '2015-04-01 00:42:47.000000', 'temperatura', 753.0000, 'ºC'),
	(136265, 111, '2015-04-01 00:42:48.000000', 'temperatura', 105.0000, 'ºC'),
	(136266, 111, '2015-04-01 00:42:49.000000', 'temperatura', 667.0000, 'ºC'),
	(136267, 111, '2015-04-01 00:42:50.000000', 'temperatura', 620.0000, 'ºC'),
	(136268, 111, '2015-04-01 00:42:51.000000', 'temperatura', 1102.0000, 'ºC'),
	(136269, 111, '2015-04-01 00:42:52.000000', 'temperatura', 49.0000, 'ºC'),
	(136270, 111, '2015-04-01 00:42:53.000000', 'temperatura', 541.0000, 'ºC'),
	(136271, 111, '2015-04-01 00:42:54.000000', 'temperatura', 157.0000, 'ºC'),
	(136272, 111, '2015-04-01 00:42:55.000000', 'temperatura', 363.0000, 'ºC'),
	(136273, 111, '2015-04-01 00:42:56.000000', 'temperatura', 145.0000, 'ºC'),
	(136274, 111, '2015-04-01 00:42:57.000000', 'temperatura', 837.0000, 'ºC'),
	(136275, 111, '2015-04-01 00:42:58.000000', 'temperatura', 149.0000, 'ºC'),
	(136276, 111, '2015-04-01 00:42:59.000000', 'temperatura', 636.0000, 'ºC'),
	(136277, 111, '2015-04-01 00:43:00.000000', 'temperatura', 334.0000, 'ºC'),
	(136278, 111, '2015-04-01 00:43:01.000000', 'temperatura', 961.0000, 'ºC'),
	(136279, 111, '2015-04-01 00:43:02.000000', 'temperatura', 205.0000, 'ºC'),
	(136280, 111, '2015-04-01 00:43:03.000000', 'temperatura', 543.0000, 'ºC'),
	(136281, 111, '2015-04-01 00:43:04.000000', 'temperatura', 900.0000, 'ºC'),
	(136282, 111, '2015-04-01 00:43:05.000000', 'temperatura', 470.0000, 'ºC'),
	(136283, 111, '2015-04-01 00:43:06.000000', 'temperatura', 852.0000, 'ºC'),
	(136284, 111, '2015-04-01 00:43:07.000000', 'temperatura', 451.0000, 'ºC'),
	(136285, 111, '2015-04-01 00:43:08.000000', 'temperatura', 898.0000, 'ºC'),
	(136286, 111, '2015-04-01 00:43:09.000000', 'temperatura', 736.0000, 'ºC'),
	(136287, 111, '2015-04-01 00:43:10.000000', 'temperatura', 989.0000, 'ºC'),
	(136288, 111, '2015-04-01 00:43:11.000000', 'temperatura', 337.0000, 'ºC'),
	(136289, 111, '2015-04-01 00:43:12.000000', 'temperatura', 1118.0000, 'ºC'),
	(136290, 111, '2015-04-01 00:43:13.000000', 'temperatura', 981.0000, 'ºC'),
	(136291, 111, '2015-04-01 00:43:14.000000', 'temperatura', 350.0000, 'ºC'),
	(136292, 111, '2015-04-01 00:43:15.000000', 'temperatura', 8.0000, 'ºC'),
	(136293, 111, '2015-04-01 00:43:16.000000', 'temperatura', 192.0000, 'ºC'),
	(136294, 111, '2015-04-01 00:43:17.000000', 'temperatura', 935.0000, 'ºC'),
	(136295, 111, '2015-04-01 00:43:18.000000', 'temperatura', 500.0000, 'ºC'),
	(136296, 111, '2015-04-01 00:43:19.000000', 'temperatura', 896.0000, 'ºC'),
	(136297, 111, '2015-04-01 00:43:20.000000', 'temperatura', 580.0000, 'ºC'),
	(136298, 111, '2015-04-01 00:43:21.000000', 'temperatura', 214.0000, 'ºC'),
	(136299, 111, '2015-04-01 00:43:22.000000', 'temperatura', 531.0000, 'ºC'),
	(136300, 111, '2015-04-01 00:43:23.000000', 'temperatura', 814.0000, 'ºC'),
	(136301, 111, '2015-04-01 00:43:24.000000', 'temperatura', 78.0000, 'ºC'),
	(136302, 111, '2015-04-01 00:43:25.000000', 'temperatura', 349.0000, 'ºC'),
	(136303, 111, '2015-04-01 00:43:26.000000', 'temperatura', 312.0000, 'ºC'),
	(136304, 111, '2015-04-01 00:43:27.000000', 'temperatura', 512.0000, 'ºC'),
	(136305, 111, '2015-04-01 00:43:28.000000', 'temperatura', 426.0000, 'ºC'),
	(136306, 111, '2015-04-01 00:43:29.000000', 'temperatura', 593.0000, 'ºC'),
	(136307, 111, '2015-04-01 00:43:30.000000', 'temperatura', 486.0000, 'ºC'),
	(136308, 111, '2015-04-01 00:43:31.000000', 'temperatura', 653.0000, 'ºC'),
	(136309, 111, '2015-04-01 00:43:32.000000', 'temperatura', 606.0000, 'ºC'),
	(136310, 111, '2015-04-01 00:43:33.000000', 'temperatura', 1074.0000, 'ºC'),
	(136311, 111, '2015-04-01 00:43:34.000000', 'temperatura', 1152.0000, 'ºC'),
	(136312, 111, '2015-04-01 00:43:35.000000', 'temperatura', 137.0000, 'ºC'),
	(136313, 111, '2015-04-01 00:43:36.000000', 'temperatura', 832.0000, 'ºC'),
	(136314, 111, '2015-04-01 00:43:37.000000', 'temperatura', 149.0000, 'ºC'),
	(136315, 111, '2015-04-01 00:43:38.000000', 'temperatura', 647.0000, 'ºC'),
	(136316, 111, '2015-04-01 00:43:39.000000', 'temperatura', 390.0000, 'ºC'),
	(136317, 111, '2015-04-01 00:43:40.000000', 'temperatura', 7.0000, 'ºC'),
	(136318, 111, '2015-04-01 00:43:41.000000', 'temperatura', 69.0000, 'ºC'),
	(136319, 111, '2015-04-01 00:43:42.000000', 'temperatura', 322.0000, 'ºC'),
	(136320, 111, '2015-04-01 00:43:43.000000', 'temperatura', 204.0000, 'ºC'),
	(136321, 111, '2015-04-01 00:43:44.000000', 'temperatura', 56.0000, 'ºC'),
	(136322, 111, '2015-04-01 00:43:45.000000', 'temperatura', 867.0000, 'ºC'),
	(136323, 111, '2015-04-01 00:43:46.000000', 'temperatura', 570.0000, 'ºC'),
	(136324, 111, '2015-04-01 00:43:47.000000', 'temperatura', 246.0000, 'ºC'),
	(136325, 111, '2015-04-01 00:43:48.000000', 'temperatura', 722.0000, 'ºC'),
	(136326, 111, '2015-04-01 00:43:49.000000', 'temperatura', 474.0000, 'ºC'),
	(136327, 111, '2015-04-01 00:43:50.000000', 'temperatura', 203.0000, 'ºC'),
	(136328, 111, '2015-04-01 00:43:51.000000', 'temperatura', 793.0000, 'ºC'),
	(136329, 111, '2015-04-01 00:43:52.000000', 'temperatura', 956.0000, 'ºC'),
	(136330, 111, '2015-04-01 00:43:53.000000', 'temperatura', 2.0000, 'ºC'),
	(136331, 111, '2015-04-01 00:43:54.000000', 'temperatura', 744.0000, 'ºC'),
	(136332, 111, '2015-04-01 00:43:55.000000', 'temperatura', 112.0000, 'ºC'),
	(136333, 111, '2015-04-01 00:43:56.000000', 'temperatura', 731.0000, 'ºC'),
	(136334, 111, '2015-04-01 00:43:57.000000', 'temperatura', 918.0000, 'ºC'),
	(136335, 111, '2015-04-01 00:43:58.000000', 'temperatura', 1196.0000, 'ºC'),
	(136336, 111, '2015-04-01 00:43:59.000000', 'temperatura', 827.0000, 'ºC'),
	(136337, 111, '2015-04-01 00:44:00.000000', 'temperatura', 547.0000, 'ºC'),
	(136338, 111, '2015-04-01 00:44:01.000000', 'temperatura', 254.0000, 'ºC'),
	(136339, 111, '2015-04-01 00:44:02.000000', 'temperatura', 829.0000, 'ºC'),
	(136340, 111, '2015-04-01 00:44:03.000000', 'temperatura', 984.0000, 'ºC'),
	(136341, 111, '2015-04-01 00:44:04.000000', 'temperatura', 33.0000, 'ºC'),
	(136342, 111, '2015-04-01 00:44:05.000000', 'temperatura', 814.0000, 'ºC'),
	(136343, 111, '2015-04-01 00:44:06.000000', 'temperatura', 370.0000, 'ºC'),
	(136344, 111, '2015-04-01 00:44:07.000000', 'temperatura', 611.0000, 'ºC'),
	(136345, 111, '2015-04-01 00:44:08.000000', 'temperatura', 744.0000, 'ºC'),
	(136346, 111, '2015-04-01 00:44:09.000000', 'temperatura', 687.0000, 'ºC'),
	(136347, 111, '2015-04-01 00:44:10.000000', 'temperatura', 6.0000, 'ºC'),
	(136348, 111, '2015-04-01 00:44:11.000000', 'temperatura', 368.0000, 'ºC'),
	(136349, 111, '2015-04-01 00:44:12.000000', 'temperatura', 622.0000, 'ºC'),
	(136350, 111, '2015-04-01 00:44:13.000000', 'temperatura', 808.0000, 'ºC'),
	(136351, 111, '2015-04-01 00:44:14.000000', 'temperatura', 974.0000, 'ºC'),
	(136352, 111, '2015-04-01 00:44:15.000000', 'temperatura', 46.0000, 'ºC'),
	(136353, 111, '2015-04-01 00:44:16.000000', 'temperatura', 909.0000, 'ºC'),
	(136354, 111, '2015-04-01 00:44:17.000000', 'temperatura', 806.0000, 'ºC'),
	(136355, 111, '2015-04-01 00:44:18.000000', 'temperatura', 103.0000, 'ºC'),
	(136356, 111, '2015-04-01 00:44:19.000000', 'temperatura', 499.0000, 'ºC'),
	(136357, 111, '2015-04-01 00:44:20.000000', 'temperatura', 986.0000, 'ºC'),
	(136358, 111, '2015-04-01 00:44:21.000000', 'temperatura', 1034.0000, 'ºC'),
	(136359, 111, '2015-04-01 00:44:22.000000', 'temperatura', 1011.0000, 'ºC'),
	(136360, 111, '2015-04-01 00:44:23.000000', 'temperatura', 753.0000, 'ºC'),
	(136361, 111, '2015-04-01 00:44:24.000000', 'temperatura', 734.0000, 'ºC'),
	(136362, 111, '2015-04-01 00:44:25.000000', 'temperatura', 213.0000, 'ºC'),
	(136363, 111, '2015-04-01 00:44:26.000000', 'temperatura', 63.0000, 'ºC'),
	(136364, 111, '2015-04-01 00:44:27.000000', 'temperatura', 875.0000, 'ºC'),
	(136365, 111, '2015-04-01 00:44:28.000000', 'temperatura', 586.0000, 'ºC'),
	(136366, 111, '2015-04-01 00:44:29.000000', 'temperatura', 306.0000, 'ºC'),
	(136367, 111, '2015-04-01 00:44:30.000000', 'temperatura', 973.0000, 'ºC'),
	(136368, 111, '2015-04-01 00:44:31.000000', 'temperatura', 347.0000, 'ºC'),
	(136369, 111, '2015-04-01 00:44:32.000000', 'temperatura', 15.0000, 'ºC'),
	(136370, 111, '2015-04-01 00:44:33.000000', 'temperatura', 236.0000, 'ºC'),
	(136371, 111, '2015-04-01 00:44:34.000000', 'temperatura', 1136.0000, 'ºC'),
	(136372, 111, '2015-04-01 00:44:35.000000', 'temperatura', 171.0000, 'ºC'),
	(136373, 111, '2015-04-01 00:44:36.000000', 'temperatura', 1049.0000, 'ºC'),
	(136374, 111, '2015-04-01 00:44:37.000000', 'temperatura', 1132.0000, 'ºC'),
	(136375, 111, '2015-04-01 00:44:38.000000', 'temperatura', 112.0000, 'ºC'),
	(136376, 111, '2015-04-01 00:44:39.000000', 'temperatura', 765.0000, 'ºC'),
	(136377, 111, '2015-04-01 00:44:40.000000', 'temperatura', 1091.0000, 'ºC'),
	(136378, 111, '2015-04-01 00:44:41.000000', 'temperatura', 758.0000, 'ºC'),
	(136379, 111, '2015-04-01 00:44:42.000000', 'temperatura', 518.0000, 'ºC'),
	(136380, 111, '2015-04-01 00:44:43.000000', 'temperatura', 317.0000, 'ºC'),
	(136381, 111, '2015-04-01 00:44:44.000000', 'temperatura', 31.0000, 'ºC'),
	(136382, 111, '2015-04-01 00:44:45.000000', 'temperatura', 407.0000, 'ºC'),
	(136383, 111, '2015-04-01 00:44:46.000000', 'temperatura', 740.0000, 'ºC'),
	(136384, 111, '2015-04-01 00:44:47.000000', 'temperatura', 79.0000, 'ºC'),
	(136385, 111, '2015-04-01 00:44:48.000000', 'temperatura', 575.0000, 'ºC'),
	(136386, 111, '2015-04-01 00:44:49.000000', 'temperatura', 240.0000, 'ºC'),
	(136387, 111, '2015-04-01 00:44:50.000000', 'temperatura', 675.0000, 'ºC'),
	(136388, 111, '2015-04-01 00:44:51.000000', 'temperatura', 255.0000, 'ºC'),
	(136389, 111, '2015-04-01 00:44:52.000000', 'temperatura', 452.0000, 'ºC'),
	(136390, 111, '2015-04-01 00:44:53.000000', 'temperatura', 295.0000, 'ºC'),
	(136391, 111, '2015-04-01 00:44:54.000000', 'temperatura', 120.0000, 'ºC'),
	(136392, 111, '2015-04-01 00:44:55.000000', 'temperatura', 913.0000, 'ºC'),
	(136393, 111, '2015-04-01 00:44:56.000000', 'temperatura', 608.0000, 'ºC'),
	(136394, 111, '2015-04-01 00:44:57.000000', 'temperatura', 299.0000, 'ºC'),
	(136395, 111, '2015-04-01 00:44:58.000000', 'temperatura', 874.0000, 'ºC'),
	(136396, 111, '2015-04-01 00:44:59.000000', 'temperatura', 1074.0000, 'ºC'),
	(136397, 111, '2015-04-01 00:45:00.000000', 'temperatura', 349.0000, 'ºC'),
	(136398, 111, '2015-04-01 00:45:01.000000', 'temperatura', 925.0000, 'ºC'),
	(136399, 111, '2015-04-01 00:45:02.000000', 'temperatura', 1175.0000, 'ºC'),
	(136400, 111, '2015-04-01 00:45:03.000000', 'temperatura', 700.0000, 'ºC'),
	(136401, 111, '2015-04-01 00:45:04.000000', 'temperatura', 1178.0000, 'ºC'),
	(136402, 111, '2015-04-01 00:45:05.000000', 'temperatura', 191.0000, 'ºC'),
	(136403, 111, '2015-04-01 00:45:06.000000', 'temperatura', 1020.0000, 'ºC'),
	(136404, 111, '2015-04-01 00:45:07.000000', 'temperatura', 928.0000, 'ºC'),
	(136405, 111, '2015-04-01 00:45:08.000000', 'temperatura', 380.0000, 'ºC'),
	(136406, 111, '2015-04-01 00:45:09.000000', 'temperatura', 316.0000, 'ºC'),
	(136407, 111, '2015-04-01 00:45:10.000000', 'temperatura', 439.0000, 'ºC'),
	(136408, 111, '2015-04-01 00:45:11.000000', 'temperatura', 51.0000, 'ºC'),
	(136409, 111, '2015-04-01 00:45:12.000000', 'temperatura', 137.0000, 'ºC'),
	(136410, 111, '2015-04-01 00:45:13.000000', 'temperatura', 532.0000, 'ºC'),
	(136411, 111, '2015-04-01 00:45:14.000000', 'temperatura', 1050.0000, 'ºC'),
	(136412, 111, '2015-04-01 00:45:15.000000', 'temperatura', 55.0000, 'ºC'),
	(136413, 111, '2015-04-01 00:45:16.000000', 'temperatura', 726.0000, 'ºC'),
	(136414, 111, '2015-04-01 00:45:17.000000', 'temperatura', 1065.0000, 'ºC'),
	(136415, 111, '2015-04-01 00:45:18.000000', 'temperatura', 747.0000, 'ºC'),
	(136416, 111, '2015-04-01 00:45:19.000000', 'temperatura', 540.0000, 'ºC'),
	(136417, 111, '2015-04-01 00:45:20.000000', 'temperatura', 462.0000, 'ºC'),
	(136418, 111, '2015-04-01 00:45:21.000000', 'temperatura', 690.0000, 'ºC'),
	(136419, 111, '2015-04-01 00:45:22.000000', 'temperatura', 863.0000, 'ºC'),
	(136420, 111, '2015-04-01 00:45:23.000000', 'temperatura', 1047.0000, 'ºC'),
	(136421, 111, '2015-04-01 00:45:24.000000', 'temperatura', 247.0000, 'ºC'),
	(136422, 111, '2015-04-01 00:45:25.000000', 'temperatura', 492.0000, 'ºC'),
	(136423, 111, '2015-04-01 00:45:26.000000', 'temperatura', 522.0000, 'ºC'),
	(136424, 111, '2015-04-01 00:45:27.000000', 'temperatura', 1133.0000, 'ºC'),
	(136425, 111, '2015-04-01 00:45:28.000000', 'temperatura', 498.0000, 'ºC'),
	(136426, 111, '2015-04-01 00:45:29.000000', 'temperatura', 293.0000, 'ºC'),
	(136427, 111, '2015-04-01 00:45:30.000000', 'temperatura', 1170.0000, 'ºC'),
	(136428, 111, '2015-04-01 00:45:31.000000', 'temperatura', 172.0000, 'ºC'),
	(136429, 111, '2015-04-01 00:45:32.000000', 'temperatura', 953.0000, 'ºC'),
	(136430, 111, '2015-04-01 00:45:33.000000', 'temperatura', 646.0000, 'ºC'),
	(136431, 111, '2015-04-01 00:45:34.000000', 'temperatura', 374.0000, 'ºC'),
	(136432, 111, '2015-04-01 00:45:35.000000', 'temperatura', 1130.0000, 'ºC'),
	(136433, 111, '2015-04-01 00:45:36.000000', 'temperatura', 930.0000, 'ºC'),
	(136434, 111, '2015-04-01 00:45:37.000000', 'temperatura', 58.0000, 'ºC'),
	(136435, 111, '2015-04-01 00:45:38.000000', 'temperatura', 1104.0000, 'ºC'),
	(136436, 111, '2015-04-01 00:45:39.000000', 'temperatura', 544.0000, 'ºC'),
	(136437, 111, '2015-04-01 00:45:40.000000', 'temperatura', 608.0000, 'ºC'),
	(136438, 111, '2015-04-01 00:45:41.000000', 'temperatura', 209.0000, 'ºC'),
	(136439, 111, '2015-04-01 00:45:42.000000', 'temperatura', 421.0000, 'ºC'),
	(136440, 111, '2015-04-01 00:45:43.000000', 'temperatura', 278.0000, 'ºC'),
	(136441, 111, '2015-04-01 00:45:44.000000', 'temperatura', 127.0000, 'ºC'),
	(136442, 111, '2015-04-01 00:45:45.000000', 'temperatura', 1001.0000, 'ºC'),
	(136443, 111, '2015-04-01 00:45:46.000000', 'temperatura', 1024.0000, 'ºC'),
	(136444, 111, '2015-04-01 00:45:47.000000', 'temperatura', 917.0000, 'ºC'),
	(136445, 111, '2015-04-01 00:45:48.000000', 'temperatura', 314.0000, 'ºC'),
	(136446, 111, '2015-04-01 00:45:49.000000', 'temperatura', 20.0000, 'ºC'),
	(136447, 111, '2015-04-01 00:45:50.000000', 'temperatura', 360.0000, 'ºC'),
	(136448, 111, '2015-04-01 00:45:51.000000', 'temperatura', 539.0000, 'ºC'),
	(136449, 111, '2015-04-01 00:45:52.000000', 'temperatura', 416.0000, 'ºC'),
	(136450, 111, '2015-04-01 00:45:53.000000', 'temperatura', 461.0000, 'ºC'),
	(136451, 111, '2015-04-01 00:45:54.000000', 'temperatura', 1061.0000, 'ºC'),
	(136452, 111, '2015-04-01 00:45:55.000000', 'temperatura', 320.0000, 'ºC'),
	(136453, 111, '2015-04-01 00:45:56.000000', 'temperatura', 820.0000, 'ºC'),
	(136454, 111, '2015-04-01 00:45:57.000000', 'temperatura', 738.0000, 'ºC'),
	(136455, 111, '2015-04-01 00:45:58.000000', 'temperatura', 31.0000, 'ºC'),
	(136456, 111, '2015-04-01 00:45:59.000000', 'temperatura', 340.0000, 'ºC'),
	(136457, 111, '2015-04-01 00:46:00.000000', 'temperatura', 409.0000, 'ºC'),
	(136458, 111, '2015-04-01 00:46:01.000000', 'temperatura', 1024.0000, 'ºC'),
	(136459, 111, '2015-04-01 00:46:02.000000', 'temperatura', 293.0000, 'ºC'),
	(136460, 111, '2015-04-01 00:46:03.000000', 'temperatura', 792.0000, 'ºC'),
	(136461, 111, '2015-04-01 00:46:04.000000', 'temperatura', 685.0000, 'ºC'),
	(136462, 111, '2015-04-01 00:46:05.000000', 'temperatura', 1050.0000, 'ºC'),
	(136463, 111, '2015-04-01 00:46:06.000000', 'temperatura', 794.0000, 'ºC'),
	(136464, 111, '2015-04-01 00:46:07.000000', 'temperatura', 820.0000, 'ºC'),
	(136465, 111, '2015-04-01 00:46:08.000000', 'temperatura', 520.0000, 'ºC'),
	(136466, 111, '2015-04-01 00:46:09.000000', 'temperatura', 138.0000, 'ºC'),
	(136467, 111, '2015-04-01 00:46:10.000000', 'temperatura', 331.0000, 'ºC'),
	(136468, 111, '2015-04-01 00:46:11.000000', 'temperatura', 43.0000, 'ºC'),
	(136469, 111, '2015-04-01 00:46:12.000000', 'temperatura', 420.0000, 'ºC'),
	(136470, 111, '2015-04-01 00:46:13.000000', 'temperatura', 773.0000, 'ºC'),
	(136471, 111, '2015-04-01 00:46:14.000000', 'temperatura', 206.0000, 'ºC'),
	(136472, 111, '2015-04-01 00:46:15.000000', 'temperatura', 1111.0000, 'ºC'),
	(136473, 111, '2015-04-01 00:46:16.000000', 'temperatura', 136.0000, 'ºC'),
	(136474, 111, '2015-04-01 00:46:17.000000', 'temperatura', 949.0000, 'ºC'),
	(136475, 111, '2015-04-01 00:46:18.000000', 'temperatura', 736.0000, 'ºC'),
	(136476, 111, '2015-04-01 00:46:19.000000', 'temperatura', 832.0000, 'ºC'),
	(136477, 111, '2015-04-01 00:46:20.000000', 'temperatura', 756.0000, 'ºC'),
	(136478, 111, '2015-04-01 00:46:21.000000', 'temperatura', 84.0000, 'ºC'),
	(136479, 111, '2015-04-01 00:46:22.000000', 'temperatura', 552.0000, 'ºC'),
	(136480, 111, '2015-04-01 00:46:23.000000', 'temperatura', 109.0000, 'ºC'),
	(136481, 111, '2015-04-01 00:46:24.000000', 'temperatura', 90.0000, 'ºC'),
	(136482, 111, '2015-04-01 00:46:25.000000', 'temperatura', 123.0000, 'ºC'),
	(136483, 111, '2015-04-01 00:46:26.000000', 'temperatura', 346.0000, 'ºC'),
	(136484, 111, '2015-04-01 00:46:27.000000', 'temperatura', 159.0000, 'ºC'),
	(136485, 111, '2015-04-01 00:46:28.000000', 'temperatura', 960.0000, 'ºC'),
	(136486, 111, '2015-04-01 00:46:29.000000', 'temperatura', 721.0000, 'ºC'),
	(136487, 111, '2015-04-01 00:46:30.000000', 'temperatura', 725.0000, 'ºC'),
	(136488, 111, '2015-04-01 00:46:31.000000', 'temperatura', 265.0000, 'ºC'),
	(136489, 111, '2015-04-01 00:46:32.000000', 'temperatura', 350.0000, 'ºC'),
	(136490, 111, '2015-04-01 00:46:33.000000', 'temperatura', 954.0000, 'ºC'),
	(136491, 111, '2015-04-01 00:46:34.000000', 'temperatura', 121.0000, 'ºC'),
	(136492, 111, '2015-04-01 00:46:35.000000', 'temperatura', 145.0000, 'ºC'),
	(136493, 111, '2015-04-01 00:46:36.000000', 'temperatura', 360.0000, 'ºC'),
	(136494, 111, '2015-04-01 00:46:37.000000', 'temperatura', 168.0000, 'ºC'),
	(136495, 111, '2015-04-01 00:46:38.000000', 'temperatura', 958.0000, 'ºC'),
	(136496, 111, '2015-04-01 00:46:39.000000', 'temperatura', 685.0000, 'ºC'),
	(136497, 111, '2015-04-01 00:46:40.000000', 'temperatura', 555.0000, 'ºC'),
	(136498, 111, '2015-04-01 00:46:41.000000', 'temperatura', 720.0000, 'ºC'),
	(136499, 111, '2015-04-01 00:46:42.000000', 'temperatura', 736.0000, 'ºC'),
	(136500, 111, '2015-04-01 00:46:43.000000', 'temperatura', 320.0000, 'ºC'),
	(136501, 111, '2015-04-01 00:46:44.000000', 'temperatura', 590.0000, 'ºC'),
	(136502, 111, '2015-04-01 00:46:45.000000', 'temperatura', 794.0000, 'ºC'),
	(136503, 111, '2015-04-01 00:46:46.000000', 'temperatura', 999.0000, 'ºC'),
	(136504, 111, '2015-04-01 00:46:47.000000', 'temperatura', 214.0000, 'ºC'),
	(136505, 111, '2015-04-01 00:46:48.000000', 'temperatura', 472.0000, 'ºC'),
	(136506, 111, '2015-04-01 00:46:49.000000', 'temperatura', 520.0000, 'ºC'),
	(136507, 111, '2015-04-01 00:46:50.000000', 'temperatura', 1184.0000, 'ºC'),
	(136508, 111, '2015-04-01 00:46:51.000000', 'temperatura', 759.0000, 'ºC'),
	(136509, 111, '2015-04-01 00:46:52.000000', 'temperatura', 246.0000, 'ºC'),
	(136510, 111, '2015-04-01 00:46:53.000000', 'temperatura', 153.0000, 'ºC'),
	(136511, 111, '2015-04-01 00:46:54.000000', 'temperatura', 28.0000, 'ºC'),
	(136512, 111, '2015-04-01 00:46:55.000000', 'temperatura', 882.0000, 'ºC'),
	(136513, 111, '2015-04-01 00:46:56.000000', 'temperatura', 727.0000, 'ºC'),
	(136514, 111, '2015-04-01 00:46:57.000000', 'temperatura', 988.0000, 'ºC'),
	(136515, 111, '2015-04-01 00:46:58.000000', 'temperatura', 359.0000, 'ºC'),
	(136516, 111, '2015-04-01 00:46:59.000000', 'temperatura', 33.0000, 'ºC'),
	(136517, 111, '2015-04-01 00:47:00.000000', 'temperatura', 288.0000, 'ºC'),
	(136518, 111, '2015-04-01 00:47:01.000000', 'temperatura', 142.0000, 'ºC'),
	(136519, 111, '2015-04-01 00:47:02.000000', 'temperatura', 1047.0000, 'ºC'),
	(136520, 111, '2015-04-01 00:47:03.000000', 'temperatura', 8.0000, 'ºC'),
	(136521, 111, '2015-04-01 00:47:04.000000', 'temperatura', 500.0000, 'ºC'),
	(136522, 111, '2015-04-01 00:47:05.000000', 'temperatura', 75.0000, 'ºC'),
	(136523, 111, '2015-04-01 00:47:06.000000', 'temperatura', 76.0000, 'ºC'),
	(136524, 111, '2015-04-01 00:47:07.000000', 'temperatura', 154.0000, 'ºC'),
	(136525, 111, '2015-04-01 00:47:08.000000', 'temperatura', 546.0000, 'ºC'),
	(136526, 111, '2015-04-01 00:47:09.000000', 'temperatura', 1066.0000, 'ºC'),
	(136527, 111, '2015-04-01 00:47:10.000000', 'temperatura', 94.0000, 'ºC'),
	(136528, 111, '2015-04-01 00:47:11.000000', 'temperatura', 871.0000, 'ºC'),
	(136529, 111, '2015-04-01 00:47:12.000000', 'temperatura', 476.0000, 'ºC'),
	(136530, 111, '2015-04-01 00:47:13.000000', 'temperatura', 964.0000, 'ºC'),
	(136531, 111, '2015-04-01 00:47:14.000000', 'temperatura', 995.0000, 'ºC'),
	(136532, 111, '2015-04-01 00:47:15.000000', 'temperatura', 883.0000, 'ºC'),
	(136533, 111, '2015-04-01 00:47:16.000000', 'temperatura', 230.0000, 'ºC'),
	(136534, 111, '2015-04-01 00:47:17.000000', 'temperatura', 901.0000, 'ºC'),
	(136535, 111, '2015-04-01 00:47:18.000000', 'temperatura', 216.0000, 'ºC'),
	(136536, 111, '2015-04-01 00:47:19.000000', 'temperatura', 779.0000, 'ºC'),
	(136537, 111, '2015-04-01 00:47:20.000000', 'temperatura', 846.0000, 'ºC'),
	(136538, 111, '2015-04-01 00:47:21.000000', 'temperatura', 693.0000, 'ºC'),
	(136539, 111, '2015-04-01 00:47:22.000000', 'temperatura', 930.0000, 'ºC'),
	(136540, 111, '2015-04-01 00:47:23.000000', 'temperatura', 169.0000, 'ºC'),
	(136541, 111, '2015-04-01 00:47:24.000000', 'temperatura', 456.0000, 'ºC'),
	(136542, 111, '2015-04-01 00:47:25.000000', 'temperatura', 575.0000, 'ºC'),
	(136543, 111, '2015-04-01 00:47:26.000000', 'temperatura', 307.0000, 'ºC'),
	(136544, 111, '2015-04-01 00:47:27.000000', 'temperatura', 1010.0000, 'ºC'),
	(136545, 111, '2015-04-01 00:47:28.000000', 'temperatura', 531.0000, 'ºC'),
	(136546, 111, '2015-04-01 00:47:29.000000', 'temperatura', 825.0000, 'ºC'),
	(136547, 111, '2015-04-01 00:47:30.000000', 'temperatura', 130.0000, 'ºC'),
	(136548, 111, '2015-04-01 00:47:31.000000', 'temperatura', 578.0000, 'ºC'),
	(136549, 111, '2015-04-01 00:47:32.000000', 'temperatura', 98.0000, 'ºC'),
	(136550, 111, '2015-04-01 00:47:33.000000', 'temperatura', 1157.0000, 'ºC'),
	(136551, 111, '2015-04-01 00:47:34.000000', 'temperatura', 693.0000, 'ºC'),
	(136552, 111, '2015-04-01 00:47:35.000000', 'temperatura', 1193.0000, 'ºC'),
	(136553, 111, '2015-04-01 00:47:36.000000', 'temperatura', 287.0000, 'ºC'),
	(136554, 111, '2015-04-01 00:47:37.000000', 'temperatura', 258.0000, 'ºC'),
	(136555, 111, '2015-04-01 00:47:38.000000', 'temperatura', 429.0000, 'ºC'),
	(136556, 111, '2015-04-01 00:47:39.000000', 'temperatura', 169.0000, 'ºC'),
	(136557, 111, '2015-04-01 00:47:40.000000', 'temperatura', 762.0000, 'ºC'),
	(136558, 111, '2015-04-01 00:47:41.000000', 'temperatura', 901.0000, 'ºC'),
	(136559, 111, '2015-04-01 00:47:42.000000', 'temperatura', 1021.0000, 'ºC'),
	(136560, 111, '2015-04-01 00:47:43.000000', 'temperatura', 0.0000, 'ºC'),
	(136561, 111, '2015-04-01 00:47:44.000000', 'temperatura', 540.0000, 'ºC'),
	(136562, 111, '2015-04-01 00:47:45.000000', 'temperatura', 301.0000, 'ºC'),
	(136563, 111, '2015-04-01 00:47:46.000000', 'temperatura', 1084.0000, 'ºC'),
	(136564, 111, '2015-04-01 00:47:47.000000', 'temperatura', 918.0000, 'ºC'),
	(136565, 111, '2015-04-01 00:47:48.000000', 'temperatura', 140.0000, 'ºC'),
	(136566, 111, '2015-04-01 00:47:49.000000', 'temperatura', 345.0000, 'ºC'),
	(136567, 111, '2015-04-01 00:47:50.000000', 'temperatura', 106.0000, 'ºC'),
	(136568, 111, '2015-04-01 00:47:51.000000', 'temperatura', 696.0000, 'ºC'),
	(136569, 111, '2015-04-01 00:47:52.000000', 'temperatura', 762.0000, 'ºC'),
	(136570, 111, '2015-04-01 00:47:53.000000', 'temperatura', 521.0000, 'ºC'),
	(136571, 111, '2015-04-01 00:47:54.000000', 'temperatura', 319.0000, 'ºC'),
	(136572, 111, '2015-04-01 00:47:55.000000', 'temperatura', 34.0000, 'ºC'),
	(136573, 111, '2015-04-01 00:47:56.000000', 'temperatura', 413.0000, 'ºC'),
	(136574, 111, '2015-04-01 00:47:57.000000', 'temperatura', 764.0000, 'ºC'),
	(136575, 111, '2015-04-01 00:47:58.000000', 'temperatura', 179.0000, 'ºC'),
	(136576, 111, '2015-04-01 00:47:59.000000', 'temperatura', 1006.0000, 'ºC'),
	(136577, 111, '2015-04-01 00:48:00.000000', 'temperatura', 894.0000, 'ºC'),
	(136578, 111, '2015-04-01 00:48:01.000000', 'temperatura', 252.0000, 'ºC'),
	(136579, 111, '2015-04-01 00:48:02.000000', 'temperatura', 979.0000, 'ºC'),
	(136580, 111, '2015-04-01 00:48:03.000000', 'temperatura', 538.0000, 'ºC'),
	(136581, 111, '2015-04-01 00:48:04.000000', 'temperatura', 956.0000, 'ºC'),
	(136582, 111, '2015-04-01 00:48:05.000000', 'temperatura', 764.0000, 'ºC'),
	(136583, 111, '2015-04-01 00:48:06.000000', 'temperatura', 952.0000, 'ºC'),
	(136584, 111, '2015-04-01 00:48:07.000000', 'temperatura', 69.0000, 'ºC'),
	(136585, 111, '2015-04-01 00:48:08.000000', 'temperatura', 1091.0000, 'ºC'),
	(136586, 111, '2015-04-01 00:48:09.000000', 'temperatura', 450.0000, 'ºC'),
	(136587, 111, '2015-04-01 00:48:10.000000', 'temperatura', 174.0000, 'ºC'),
	(136588, 111, '2015-04-01 00:48:11.000000', 'temperatura', 722.0000, 'ºC'),
	(136589, 111, '2015-04-01 00:48:12.000000', 'temperatura', 688.0000, 'ºC'),
	(136590, 111, '2015-04-01 00:48:13.000000', 'temperatura', 73.0000, 'ºC'),
	(136591, 111, '2015-04-01 00:48:14.000000', 'temperatura', 704.0000, 'ºC'),
	(136592, 111, '2015-04-01 00:48:15.000000', 'temperatura', 901.0000, 'ºC'),
	(136593, 111, '2015-04-01 00:48:16.000000', 'temperatura', 1195.0000, 'ºC'),
	(136594, 111, '2015-04-01 00:48:17.000000', 'temperatura', 870.0000, 'ºC'),
	(136595, 111, '2015-04-01 00:48:18.000000', 'temperatura', 768.0000, 'ºC'),
	(136596, 111, '2015-04-01 00:48:19.000000', 'temperatura', 27.0000, 'ºC'),
	(136597, 111, '2015-04-01 00:48:20.000000', 'temperatura', 235.0000, 'ºC'),
	(136598, 111, '2015-04-01 00:48:21.000000', 'temperatura', 1093.0000, 'ºC'),
	(136599, 111, '2015-04-01 00:48:22.000000', 'temperatura', 1159.0000, 'ºC'),
	(136600, 111, '2015-04-01 00:48:23.000000', 'temperatura', 119.0000, 'ºC'),
	(136601, 111, '2015-04-01 00:48:24.000000', 'temperatura', 716.0000, 'ºC'),
	(136602, 111, '2015-04-01 00:48:25.000000', 'temperatura', 826.0000, 'ºC'),
	(136603, 111, '2015-04-01 00:48:26.000000', 'temperatura', 781.0000, 'ºC'),
	(136604, 111, '2015-04-01 00:48:27.000000', 'temperatura', 226.0000, 'ºC'),
	(136605, 111, '2015-04-01 00:48:28.000000', 'temperatura', 1190.0000, 'ºC'),
	(136606, 111, '2015-04-01 00:48:29.000000', 'temperatura', 470.0000, 'ºC'),
	(136607, 111, '2015-04-01 00:48:30.000000', 'temperatura', 1182.0000, 'ºC'),
	(136608, 111, '2015-04-01 00:48:31.000000', 'temperatura', 902.0000, 'ºC'),
	(136609, 111, '2015-04-01 00:48:32.000000', 'temperatura', 963.0000, 'ºC'),
	(136610, 111, '2015-04-01 00:48:33.000000', 'temperatura', 911.0000, 'ºC'),
	(136611, 111, '2015-04-01 00:48:34.000000', 'temperatura', 466.0000, 'ºC'),
	(136612, 111, '2015-04-01 00:48:35.000000', 'temperatura', 797.0000, 'ºC'),
	(136613, 111, '2015-04-01 00:48:36.000000', 'temperatura', 187.0000, 'ºC'),
	(136614, 111, '2015-04-01 00:48:37.000000', 'temperatura', 943.0000, 'ºC'),
	(136615, 111, '2015-04-01 00:48:38.000000', 'temperatura', 556.0000, 'ºC'),
	(136616, 111, '2015-04-01 00:48:39.000000', 'temperatura', 1153.0000, 'ºC'),
	(136617, 111, '2015-04-01 00:48:40.000000', 'temperatura', 496.0000, 'ºC'),
	(136618, 111, '2015-04-01 00:48:41.000000', 'temperatura', 220.0000, 'ºC'),
	(136619, 111, '2015-04-01 00:48:42.000000', 'temperatura', 813.0000, 'ºC'),
	(136620, 111, '2015-04-01 00:48:43.000000', 'temperatura', 1006.0000, 'ºC'),
	(136621, 111, '2015-04-01 00:48:44.000000', 'temperatura', 189.0000, 'ºC'),
	(136622, 111, '2015-04-01 00:48:45.000000', 'temperatura', 331.0000, 'ºC'),
	(136623, 111, '2015-04-01 00:48:46.000000', 'temperatura', 1089.0000, 'ºC'),
	(136624, 111, '2015-04-01 00:48:47.000000', 'temperatura', 851.0000, 'ºC'),
	(136625, 111, '2015-04-01 00:48:48.000000', 'temperatura', 988.0000, 'ºC'),
	(136626, 111, '2015-04-01 00:48:49.000000', 'temperatura', 1190.0000, 'ºC'),
	(136627, 111, '2015-04-01 00:48:50.000000', 'temperatura', 584.0000, 'ºC'),
	(136628, 111, '2015-04-01 00:48:51.000000', 'temperatura', 551.0000, 'ºC'),
	(136629, 111, '2015-04-01 00:48:52.000000', 'temperatura', 1003.0000, 'ºC'),
	(136630, 111, '2015-04-01 00:48:53.000000', 'temperatura', 964.0000, 'ºC'),
	(136631, 111, '2015-04-01 00:48:54.000000', 'temperatura', 611.0000, 'ºC'),
	(136632, 111, '2015-04-01 00:48:55.000000', 'temperatura', 164.0000, 'ºC'),
	(136633, 111, '2015-04-01 00:48:56.000000', 'temperatura', 189.0000, 'ºC'),
	(136634, 111, '2015-04-01 00:48:57.000000', 'temperatura', 452.0000, 'ºC'),
	(136635, 111, '2015-04-01 00:48:58.000000', 'temperatura', 493.0000, 'ºC'),
	(136636, 111, '2015-04-01 00:48:59.000000', 'temperatura', 1109.0000, 'ºC'),
	(136637, 111, '2015-04-01 00:49:00.000000', 'temperatura', 469.0000, 'ºC'),
	(136638, 111, '2015-04-01 00:49:01.000000', 'temperatura', 218.0000, 'ºC'),
	(136639, 111, '2015-04-01 00:49:02.000000', 'temperatura', 883.0000, 'ºC'),
	(136640, 111, '2015-04-01 00:49:03.000000', 'temperatura', 163.0000, 'ºC'),
	(136641, 111, '2015-04-01 00:49:04.000000', 'temperatura', 566.0000, 'ºC'),
	(136642, 111, '2015-04-01 00:49:05.000000', 'temperatura', 1141.0000, 'ºC'),
	(136643, 111, '2015-04-01 00:49:06.000000', 'temperatura', 409.0000, 'ºC'),
	(136644, 111, '2015-04-01 00:49:07.000000', 'temperatura', 1023.0000, 'ºC'),
	(136645, 111, '2015-04-01 00:49:08.000000', 'temperatura', 287.0000, 'ºC'),
	(136646, 111, '2015-04-01 00:49:09.000000', 'temperatura', 768.0000, 'ºC'),
	(136647, 111, '2015-04-01 00:49:10.000000', 'temperatura', 577.0000, 'ºC'),
	(136648, 111, '2015-04-01 00:49:11.000000', 'temperatura', 582.0000, 'ºC'),
	(136649, 111, '2015-04-01 00:49:12.000000', 'temperatura', 1181.0000, 'ºC'),
	(136650, 111, '2015-04-01 00:49:13.000000', 'temperatura', 559.0000, 'ºC'),
	(136651, 111, '2015-04-01 00:49:14.000000', 'temperatura', 450.0000, 'ºC'),
	(136652, 111, '2015-04-01 00:49:15.000000', 'temperatura', 576.0000, 'ºC'),
	(136653, 111, '2015-04-01 00:49:16.000000', 'temperatura', 330.0000, 'ºC'),
	(136654, 111, '2015-04-01 00:49:17.000000', 'temperatura', 1123.0000, 'ºC'),
	(136655, 111, '2015-04-01 00:49:18.000000', 'temperatura', 1027.0000, 'ºC'),
	(136656, 111, '2015-04-01 00:49:19.000000', 'temperatura', 565.0000, 'ºC'),
	(136657, 111, '2015-04-01 00:49:20.000000', 'temperatura', 944.0000, 'ºC'),
	(136658, 111, '2015-04-01 00:49:21.000000', 'temperatura', 625.0000, 'ºC'),
	(136659, 111, '2015-04-01 00:49:22.000000', 'temperatura', 294.0000, 'ºC'),
	(136660, 111, '2015-04-01 00:49:23.000000', 'temperatura', 795.0000, 'ºC'),
	(136661, 111, '2015-04-01 00:49:24.000000', 'temperatura', 694.0000, 'ºC'),
	(136662, 111, '2015-04-01 00:49:25.000000', 'temperatura', 1086.0000, 'ºC'),
	(136663, 111, '2015-04-01 00:49:26.000000', 'temperatura', 950.0000, 'ºC'),
	(136664, 111, '2015-04-01 00:49:27.000000', 'temperatura', 290.0000, 'ºC'),
	(136665, 111, '2015-04-01 00:49:28.000000', 'temperatura', 1000.0000, 'ºC'),
	(136666, 111, '2015-04-01 00:49:29.000000', 'temperatura', 530.0000, 'ºC'),
	(136667, 111, '2015-04-01 00:49:30.000000', 'temperatura', 852.0000, 'ºC'),
	(136668, 111, '2015-04-01 00:49:31.000000', 'temperatura', 271.0000, 'ºC'),
	(136669, 111, '2015-04-01 00:49:32.000000', 'temperatura', 1199.0000, 'ºC'),
	(136670, 111, '2015-04-01 00:49:33.000000', 'temperatura', 382.0000, 'ºC'),
	(136671, 111, '2015-04-01 00:49:34.000000', 'temperatura', 713.0000, 'ºC'),
	(136672, 111, '2015-04-01 00:49:35.000000', 'temperatura', 19.0000, 'ºC'),
	(136673, 111, '2015-04-01 00:49:36.000000', 'temperatura', 355.0000, 'ºC'),
	(136674, 111, '2015-04-01 00:49:37.000000', 'temperatura', 521.0000, 'ºC'),
	(136675, 111, '2015-04-01 00:49:38.000000', 'temperatura', 339.0000, 'ºC'),
	(136676, 111, '2015-04-01 00:49:39.000000', 'temperatura', 135.0000, 'ºC'),
	(136677, 111, '2015-04-01 00:49:40.000000', 'temperatura', 857.0000, 'ºC'),
	(136678, 111, '2015-04-01 00:49:41.000000', 'temperatura', 279.0000, 'ºC'),
	(136679, 111, '2015-04-01 00:49:42.000000', 'temperatura', 26.0000, 'ºC'),
	(136680, 111, '2015-04-01 00:49:43.000000', 'temperatura', 492.0000, 'ºC'),
	(136681, 111, '2015-04-01 00:49:44.000000', 'temperatura', 1182.0000, 'ºC'),
	(136682, 111, '2015-04-01 00:49:45.000000', 'temperatura', 835.0000, 'ºC'),
	(136683, 111, '2015-04-01 00:49:46.000000', 'temperatura', 629.0000, 'ºC'),
	(136684, 111, '2015-04-01 00:49:47.000000', 'temperatura', 642.0000, 'ºC'),
	(136685, 111, '2015-04-01 00:49:48.000000', 'temperatura', 121.0000, 'ºC'),
	(136686, 111, '2015-04-01 00:49:49.000000', 'temperatura', 1081.0000, 'ºC'),
	(136687, 111, '2015-04-01 00:49:50.000000', 'temperatura', 243.0000, 'ºC'),
	(136688, 111, '2015-04-01 00:49:51.000000', 'temperatura', 373.0000, 'ºC'),
	(136689, 111, '2015-04-01 00:49:52.000000', 'temperatura', 1136.0000, 'ºC'),
	(136690, 111, '2015-04-01 00:49:53.000000', 'temperatura', 960.0000, 'ºC'),
	(136691, 111, '2015-04-01 00:49:54.000000', 'temperatura', 195.0000, 'ºC'),
	(136692, 111, '2015-04-01 00:49:55.000000', 'temperatura', 494.0000, 'ºC'),
	(136693, 111, '2015-04-01 00:49:56.000000', 'temperatura', 687.0000, 'ºC'),
	(136694, 111, '2015-04-01 00:49:57.000000', 'temperatura', 751.0000, 'ºC'),
	(136695, 111, '2015-04-01 00:49:58.000000', 'temperatura', 497.0000, 'ºC'),
	(136696, 111, '2015-04-01 00:49:59.000000', 'temperatura', 231.0000, 'ºC'),
	(136697, 111, '2015-04-01 00:50:00.000000', 'temperatura', 867.0000, 'ºC'),
	(136698, 111, '2015-04-01 00:50:01.000000', 'temperatura', 40.0000, 'ºC'),
	(136699, 111, '2015-04-01 00:50:02.000000', 'temperatura', 0.0000, 'ºC'),
	(136700, 111, '2015-04-01 00:50:03.000000', 'temperatura', 1082.0000, 'ºC'),
	(136701, 111, '2015-04-01 00:50:04.000000', 'temperatura', 608.0000, 'ºC'),
	(136702, 111, '2015-04-01 00:50:05.000000', 'temperatura', 994.0000, 'ºC'),
	(136703, 111, '2015-04-01 00:50:06.000000', 'temperatura', 746.0000, 'ºC'),
	(136704, 111, '2015-04-01 00:50:07.000000', 'temperatura', 749.0000, 'ºC'),
	(136705, 111, '2015-04-01 00:50:08.000000', 'temperatura', 307.0000, 'ºC'),
	(136706, 111, '2015-04-01 00:50:09.000000', 'temperatura', 489.0000, 'ºC'),
	(136707, 111, '2015-04-01 00:50:10.000000', 'temperatura', 326.0000, 'ºC'),
	(136708, 111, '2015-04-01 00:50:11.000000', 'temperatura', 162.0000, 'ºC'),
	(136709, 111, '2015-04-01 00:50:12.000000', 'temperatura', 1034.0000, 'ºC'),
	(136710, 111, '2015-04-01 00:50:13.000000', 'temperatura', 1085.0000, 'ºC'),
	(136711, 111, '2015-04-01 00:50:14.000000', 'temperatura', 1121.0000, 'ºC'),
	(136712, 111, '2015-04-01 00:50:15.000000', 'temperatura', 1154.0000, 'ºC'),
	(136713, 111, '2015-04-01 00:50:16.000000', 'temperatura', 4.0000, 'ºC'),
	(136714, 111, '2015-04-01 00:50:17.000000', 'temperatura', 160.0000, 'ºC'),
	(136715, 111, '2015-04-01 00:50:18.000000', 'temperatura', 788.0000, 'ºC'),
	(136716, 111, '2015-04-01 00:50:19.000000', 'temperatura', 1059.0000, 'ºC'),
	(136717, 111, '2015-04-01 00:50:20.000000', 'temperatura', 532.0000, 'ºC'),
	(136718, 111, '2015-04-01 00:50:21.000000', 'temperatura', 685.0000, 'ºC'),
	(136719, 111, '2015-04-01 00:50:22.000000', 'temperatura', 629.0000, 'ºC'),
	(136720, 111, '2015-04-01 00:50:23.000000', 'temperatura', 1090.0000, 'ºC'),
	(136721, 111, '2015-04-01 00:50:24.000000', 'temperatura', 1164.0000, 'ºC'),
	(136722, 111, '2015-04-01 00:50:25.000000', 'temperatura', 148.0000, 'ºC'),
	(136723, 111, '2015-04-01 00:50:26.000000', 'temperatura', 851.0000, 'ºC'),
	(136724, 111, '2015-04-01 00:50:27.000000', 'temperatura', 212.0000, 'ºC'),
	(136725, 111, '2015-04-01 00:50:28.000000', 'temperatura', 905.0000, 'ºC'),
	(136726, 111, '2015-04-01 00:50:29.000000', 'temperatura', 291.0000, 'ºC'),
	(136727, 111, '2015-04-01 00:50:30.000000', 'temperatura', 1139.0000, 'ºC'),
	(136728, 111, '2015-04-01 00:50:31.000000', 'temperatura', 23.0000, 'ºC'),
	(136729, 111, '2015-04-01 00:50:32.000000', 'temperatura', 300.0000, 'ºC'),
	(136730, 111, '2015-04-01 00:50:33.000000', 'temperatura', 232.0000, 'ºC'),
	(136731, 111, '2015-04-01 00:50:34.000000', 'temperatura', 261.0000, 'ºC'),
	(136732, 111, '2015-04-01 00:50:35.000000', 'temperatura', 610.0000, 'ºC'),
	(136733, 111, '2015-04-01 00:50:36.000000', 'temperatura', 1065.0000, 'ºC'),
	(136734, 111, '2015-04-01 00:50:37.000000', 'temperatura', 1098.0000, 'ºC'),
	(136735, 111, '2015-04-01 00:50:38.000000', 'temperatura', 1096.0000, 'ºC'),
	(136736, 111, '2015-04-01 00:50:39.000000', 'temperatura', 984.0000, 'ºC'),
	(136737, 111, '2015-04-01 00:50:40.000000', 'temperatura', 432.0000, 'ºC'),
	(136738, 111, '2015-04-01 00:50:41.000000', 'temperatura', 409.0000, 'ºC'),
	(136739, 111, '2015-04-01 00:50:42.000000', 'temperatura', 750.0000, 'ºC'),
	(136740, 111, '2015-04-01 00:50:43.000000', 'temperatura', 121.0000, 'ºC'),
	(136741, 111, '2015-04-01 00:50:44.000000', 'temperatura', 759.0000, 'ºC'),
	(136742, 111, '2015-04-01 00:50:45.000000', 'temperatura', 1031.0000, 'ºC'),
	(136743, 111, '2015-04-01 00:50:46.000000', 'temperatura', 481.0000, 'ºC'),
	(136744, 111, '2015-04-01 00:50:47.000000', 'temperatura', 510.0000, 'ºC'),
	(136745, 111, '2015-04-01 00:50:48.000000', 'temperatura', 1107.0000, 'ºC'),
	(136746, 111, '2015-04-01 00:50:49.000000', 'temperatura', 408.0000, 'ºC'),
	(136747, 111, '2015-04-01 00:50:50.000000', 'temperatura', 1117.0000, 'ºC'),
	(136748, 111, '2015-04-01 00:50:51.000000', 'temperatura', 760.0000, 'ºC'),
	(136749, 111, '2015-04-01 00:50:52.000000', 'temperatura', 453.0000, 'ºC'),
	(136750, 111, '2015-04-01 00:50:53.000000', 'temperatura', 1182.0000, 'ºC'),
	(136751, 111, '2015-04-01 00:50:54.000000', 'temperatura', 954.0000, 'ºC'),
	(136752, 111, '2015-04-01 00:50:55.000000', 'temperatura', 23.0000, 'ºC'),
	(136753, 111, '2015-04-01 00:50:56.000000', 'temperatura', 854.0000, 'ºC'),
	(136754, 111, '2015-04-01 00:50:57.000000', 'temperatura', 599.0000, 'ºC'),
	(136755, 111, '2015-04-01 00:50:58.000000', 'temperatura', 437.0000, 'ºC'),
	(136756, 111, '2015-04-01 00:50:59.000000', 'temperatura', 389.0000, 'ºC'),
	(136757, 111, '2015-04-01 00:51:00.000000', 'temperatura', 634.0000, 'ºC'),
	(136758, 111, '2015-04-01 00:51:01.000000', 'temperatura', 803.0000, 'ºC'),
	(136759, 111, '2015-04-01 00:51:02.000000', 'temperatura', 913.0000, 'ºC'),
	(136760, 111, '2015-04-01 00:51:03.000000', 'temperatura', 957.0000, 'ºC'),
	(136761, 111, '2015-04-01 00:51:04.000000', 'temperatura', 845.0000, 'ºC'),
	(136762, 111, '2015-04-01 00:51:05.000000', 'temperatura', 155.0000, 'ºC'),
	(136763, 111, '2015-04-01 00:51:06.000000', 'temperatura', 642.0000, 'ºC'),
	(136764, 111, '2015-04-01 00:51:07.000000', 'temperatura', 344.0000, 'ºC'),
	(136765, 111, '2015-04-01 00:51:08.000000', 'temperatura', 996.0000, 'ºC'),
	(136766, 111, '2015-04-01 00:51:09.000000', 'temperatura', 350.0000, 'ºC'),
	(136767, 111, '2015-04-01 00:51:10.000000', 'temperatura', 1160.0000, 'ºC'),
	(136768, 111, '2015-04-01 00:51:11.000000', 'temperatura', 1150.0000, 'ºC'),
	(136769, 111, '2015-04-01 00:51:12.000000', 'temperatura', 1069.0000, 'ºC'),
	(136770, 111, '2015-04-01 00:51:13.000000', 'temperatura', 698.0000, 'ºC'),
	(136771, 111, '2015-04-01 00:51:14.000000', 'temperatura', 285.0000, 'ºC'),
	(136772, 111, '2015-04-01 00:51:15.000000', 'temperatura', 528.0000, 'ºC'),
	(136773, 111, '2015-04-01 00:51:16.000000', 'temperatura', 589.0000, 'ºC'),
	(136774, 111, '2015-04-01 00:51:17.000000', 'temperatura', 158.0000, 'ºC'),
	(136775, 111, '2015-04-01 00:51:18.000000', 'temperatura', 226.0000, 'ºC'),
	(136776, 111, '2015-04-01 00:51:19.000000', 'temperatura', 657.0000, 'ºC'),
	(136777, 111, '2015-04-01 00:51:20.000000', 'temperatura', 209.0000, 'ºC'),
	(136778, 111, '2015-04-01 00:51:21.000000', 'temperatura', 272.0000, 'ºC'),
	(136779, 111, '2015-04-01 00:51:22.000000', 'temperatura', 733.0000, 'ºC'),
	(136780, 111, '2015-04-01 00:51:23.000000', 'temperatura', 448.0000, 'ºC'),
	(136781, 111, '2015-04-01 00:51:24.000000', 'temperatura', 45.0000, 'ºC'),
	(136782, 111, '2015-04-01 00:51:25.000000', 'temperatura', 80.0000, 'ºC'),
	(136783, 111, '2015-04-01 00:51:26.000000', 'temperatura', 267.0000, 'ºC'),
	(136784, 111, '2015-04-01 00:51:27.000000', 'temperatura', 1096.0000, 'ºC'),
	(136785, 111, '2015-04-01 00:51:28.000000', 'temperatura', 1077.0000, 'ºC'),
	(136786, 111, '2015-04-01 00:51:29.000000', 'temperatura', 896.0000, 'ºC'),
	(136787, 111, '2015-04-01 00:51:30.000000', 'temperatura', 53.0000, 'ºC'),
	(136788, 111, '2015-04-01 00:51:31.000000', 'temperatura', 1178.0000, 'ºC'),
	(136789, 111, '2015-04-01 00:51:32.000000', 'temperatura', 930.0000, 'ºC'),
	(136790, 111, '2015-04-01 00:51:33.000000', 'temperatura', 1116.0000, 'ºC'),
	(136791, 111, '2015-04-01 00:51:34.000000', 'temperatura', 392.0000, 'ºC'),
	(136792, 111, '2015-04-01 00:51:35.000000', 'temperatura', 1011.0000, 'ºC'),
	(136793, 111, '2015-04-01 00:51:36.000000', 'temperatura', 281.0000, 'ºC'),
	(136794, 111, '2015-04-01 00:51:37.000000', 'temperatura', 771.0000, 'ºC'),
	(136795, 111, '2015-04-01 00:51:38.000000', 'temperatura', 615.0000, 'ºC'),
	(136796, 111, '2015-04-01 00:51:39.000000', 'temperatura', 760.0000, 'ºC'),
	(136797, 111, '2015-04-01 00:51:40.000000', 'temperatura', 755.0000, 'ºC'),
	(136798, 111, '2015-04-01 00:51:41.000000', 'temperatura', 296.0000, 'ºC'),
	(136799, 111, '2015-04-01 00:51:42.000000', 'temperatura', 417.0000, 'ºC'),
	(136800, 111, '2015-04-01 00:51:43.000000', 'temperatura', 1195.0000, 'ºC'),
	(136801, 111, '2015-04-01 00:51:44.000000', 'temperatura', 1126.0000, 'ºC'),
	(136802, 111, '2015-04-01 00:51:45.000000', 'temperatura', 843.0000, 'ºC'),
	(136803, 111, '2015-04-01 00:51:46.000000', 'temperatura', 840.0000, 'ºC'),
	(136804, 111, '2015-04-01 00:51:47.000000', 'temperatura', 470.0000, 'ºC'),
	(136805, 111, '2015-04-01 00:51:48.000000', 'temperatura', 1032.0000, 'ºC'),
	(136806, 111, '2015-04-01 00:51:49.000000', 'temperatura', 149.0000, 'ºC'),
	(136807, 111, '2015-04-01 00:51:50.000000', 'temperatura', 48.0000, 'ºC'),
	(136808, 111, '2015-04-01 00:51:51.000000', 'temperatura', 996.0000, 'ºC'),
	(136809, 111, '2015-04-01 00:51:52.000000', 'temperatura', 34.0000, 'ºC'),
	(136810, 111, '2015-04-01 00:51:53.000000', 'temperatura', 784.0000, 'ºC'),
	(136811, 111, '2015-04-01 00:51:54.000000', 'temperatura', 216.0000, 'ºC'),
	(136812, 111, '2015-04-01 00:51:55.000000', 'temperatura', 1131.0000, 'ºC'),
	(136813, 111, '2015-04-01 00:51:56.000000', 'temperatura', 209.0000, 'ºC'),
	(136814, 111, '2015-04-01 00:51:57.000000', 'temperatura', 51.0000, 'ºC'),
	(136815, 111, '2015-04-01 00:51:58.000000', 'temperatura', 827.0000, 'ºC'),
	(136816, 111, '2015-04-01 00:51:59.000000', 'temperatura', 382.0000, 'ºC'),
	(136817, 111, '2015-04-01 00:52:00.000000', 'temperatura', 630.0000, 'ºC'),
	(136818, 111, '2015-04-01 00:52:01.000000', 'temperatura', 806.0000, 'ºC'),
	(136819, 111, '2015-04-01 00:52:02.000000', 'temperatura', 938.0000, 'ºC'),
	(136820, 111, '2015-04-01 00:52:03.000000', 'temperatura', 1073.0000, 'ºC'),
	(136821, 111, '2015-04-01 00:52:04.000000', 'temperatura', 151.0000, 'ºC'),
	(136822, 111, '2015-04-01 00:52:05.000000', 'temperatura', 1137.0000, 'ºC'),
	(136823, 111, '2015-04-01 00:52:06.000000', 'temperatura', 432.0000, 'ºC'),
	(136824, 111, '2015-04-01 00:52:07.000000', 'temperatura', 1151.0000, 'ºC'),
	(136825, 111, '2015-04-01 00:52:08.000000', 'temperatura', 860.0000, 'ºC'),
	(136826, 111, '2015-04-01 00:52:09.000000', 'temperatura', 848.0000, 'ºC'),
	(136827, 111, '2015-04-01 00:52:10.000000', 'temperatura', 459.0000, 'ºC'),
	(136828, 111, '2015-04-01 00:52:11.000000', 'temperatura', 951.0000, 'ºC'),
	(136829, 111, '2015-04-01 00:52:12.000000', 'temperatura', 978.0000, 'ºC'),
	(136830, 111, '2015-04-01 00:52:13.000000', 'temperatura', 837.0000, 'ºC'),
	(136831, 111, '2015-04-01 00:52:14.000000', 'temperatura', 52.0000, 'ºC'),
	(136832, 111, '2015-04-01 00:52:15.000000', 'temperatura', 150.0000, 'ºC'),
	(136833, 111, '2015-04-01 00:52:16.000000', 'temperatura', 595.0000, 'ºC'),
	(136834, 111, '2015-04-01 00:52:17.000000', 'temperatura', 127.0000, 'ºC'),
	(136835, 111, '2015-04-01 00:52:18.000000', 'temperatura', 49.0000, 'ºC'),
	(136836, 111, '2015-04-01 00:52:19.000000', 'temperatura', 1065.0000, 'ºC'),
	(136837, 111, '2015-04-01 00:52:20.000000', 'temperatura', 379.0000, 'ºC'),
	(136838, 111, '2015-04-01 00:52:21.000000', 'temperatura', 1100.0000, 'ºC'),
	(136839, 111, '2015-04-01 00:52:22.000000', 'temperatura', 762.0000, 'ºC'),
	(136840, 111, '2015-04-01 00:52:23.000000', 'temperatura', 511.0000, 'ºC'),
	(136841, 111, '2015-04-01 00:52:24.000000', 'temperatura', 271.0000, 'ºC'),
	(136842, 111, '2015-04-01 00:52:25.000000', 'temperatura', 1024.0000, 'ºC'),
	(136843, 111, '2015-04-01 00:52:26.000000', 'temperatura', 704.0000, 'ºC'),
	(136844, 111, '2015-04-01 00:52:27.000000', 'temperatura', 451.0000, 'ºC'),
	(136845, 111, '2015-04-01 00:52:28.000000', 'temperatura', 142.0000, 'ºC'),
	(136846, 111, '2015-04-01 00:52:29.000000', 'temperatura', 558.0000, 'ºC'),
	(136847, 111, '2015-04-01 00:52:30.000000', 'temperatura', 1166.0000, 'ºC'),
	(136848, 111, '2015-04-01 00:52:31.000000', 'temperatura', 554.0000, 'ºC'),
	(136849, 111, '2015-04-01 00:52:32.000000', 'temperatura', 474.0000, 'ºC'),
	(136850, 111, '2015-04-01 00:52:33.000000', 'temperatura', 710.0000, 'ºC'),
	(136851, 111, '2015-04-01 00:52:34.000000', 'temperatura', 926.0000, 'ºC'),
	(136852, 111, '2015-04-01 00:52:35.000000', 'temperatura', 103.0000, 'ºC'),
	(136853, 111, '2015-04-01 00:52:36.000000', 'temperatura', 137.0000, 'ºC'),
	(136854, 111, '2015-04-01 00:52:37.000000', 'temperatura', 377.0000, 'ºC'),
	(136855, 111, '2015-04-01 00:52:38.000000', 'temperatura', 272.0000, 'ºC'),
	(136856, 111, '2015-04-01 00:52:39.000000', 'temperatura', 230.0000, 'ºC'),
	(136857, 111, '2015-04-01 00:52:40.000000', 'temperatura', 335.0000, 'ºC'),
	(136858, 111, '2015-04-01 00:52:41.000000', 'temperatura', 985.0000, 'ºC'),
	(136859, 111, '2015-04-01 00:52:42.000000', 'temperatura', 322.0000, 'ºC'),
	(136860, 111, '2015-04-01 00:52:43.000000', 'temperatura', 1054.0000, 'ºC'),
	(136861, 111, '2015-04-01 00:52:44.000000', 'temperatura', 703.0000, 'ºC'),
	(136862, 111, '2015-04-01 00:52:45.000000', 'temperatura', 354.0000, 'ºC'),
	(136863, 111, '2015-04-01 00:52:46.000000', 'temperatura', 863.0000, 'ºC'),
	(136864, 111, '2015-04-01 00:52:47.000000', 'temperatura', 853.0000, 'ºC'),
	(136865, 111, '2015-04-01 00:52:48.000000', 'temperatura', 478.0000, 'ºC'),
	(136866, 111, '2015-04-01 00:52:49.000000', 'temperatura', 1029.0000, 'ºC'),
	(136867, 111, '2015-04-01 00:52:50.000000', 'temperatura', 112.0000, 'ºC'),
	(136868, 111, '2015-04-01 00:52:51.000000', 'temperatura', 1075.0000, 'ºC'),
	(136869, 111, '2015-04-01 00:52:52.000000', 'temperatura', 238.0000, 'ºC'),
	(136870, 111, '2015-04-01 00:52:53.000000', 'temperatura', 368.0000, 'ºC'),
	(136871, 111, '2015-04-01 00:52:54.000000', 'temperatura', 1124.0000, 'ºC'),
	(136872, 111, '2015-04-01 00:52:55.000000', 'temperatura', 917.0000, 'ºC'),
	(136873, 111, '2015-04-01 00:52:56.000000', 'temperatura', 12.0000, 'ºC'),
	(136874, 111, '2015-04-01 00:52:57.000000', 'temperatura', 912.0000, 'ºC'),
	(136875, 111, '2015-04-01 00:52:58.000000', 'temperatura', 923.0000, 'ºC'),
	(136876, 111, '2015-04-01 00:52:59.000000', 'temperatura', 680.0000, 'ºC'),
	(136877, 111, '2015-04-01 00:53:00.000000', 'temperatura', 633.0000, 'ºC'),
	(136878, 111, '2015-04-01 00:53:01.000000', 'temperatura', 1123.0000, 'ºC'),
	(136879, 111, '2015-04-01 00:53:02.000000', 'temperatura', 117.0000, 'ºC'),
	(136880, 111, '2015-04-01 00:53:03.000000', 'temperatura', 818.0000, 'ºC'),
	(136881, 111, '2015-04-01 00:53:04.000000', 'temperatura', 139.0000, 'ºC'),
	(136882, 111, '2015-04-01 00:53:05.000000', 'temperatura', 641.0000, 'ºC'),
	(136883, 111, '2015-04-01 00:53:06.000000', 'temperatura', 390.0000, 'ºC'),
	(136884, 111, '2015-04-01 00:53:07.000000', 'temperatura', 27.0000, 'ºC'),
	(136885, 111, '2015-04-01 00:53:08.000000', 'temperatura', 167.0000, 'ºC'),
	(136886, 111, '2015-04-01 00:53:09.000000', 'temperatura', 754.0000, 'ºC'),
	(136887, 111, '2015-04-01 00:53:10.000000', 'temperatura', 867.0000, 'ºC'),
	(136888, 111, '2015-04-01 00:53:11.000000', 'temperatura', 877.0000, 'ºC'),
	(136889, 111, '2015-04-01 00:53:12.000000', 'temperatura', 581.0000, 'ºC'),
	(136890, 111, '2015-04-01 00:53:13.000000', 'temperatura', 277.0000, 'ºC'),
	(136891, 111, '2015-04-01 00:53:14.000000', 'temperatura', 841.0000, 'ºC'),
	(136892, 111, '2015-04-01 00:53:15.000000', 'temperatura', 973.0000, 'ºC'),
	(136893, 111, '2015-04-01 00:53:16.000000', 'temperatura', 1145.0000, 'ºC'),
	(136894, 111, '2015-04-01 00:53:17.000000', 'temperatura', 405.0000, 'ºC'),
	(136895, 111, '2015-04-01 00:53:18.000000', 'temperatura', 992.0000, 'ºC'),
	(136896, 111, '2015-04-01 00:53:19.000000', 'temperatura', 146.0000, 'ºC'),
	(136897, 111, '2015-04-01 00:53:20.000000', 'temperatura', 152.0000, 'ºC'),
	(136898, 111, '2015-04-01 00:53:21.000000', 'temperatura', 325.0000, 'ºC'),
	(136899, 111, '2015-04-01 00:53:22.000000', 'temperatura', 1168.0000, 'ºC'),
	(136900, 111, '2015-04-01 00:53:23.000000', 'temperatura', 64.0000, 'ºC'),
	(136901, 111, '2015-04-01 00:53:24.000000', 'temperatura', 418.0000, 'ºC'),
	(136902, 111, '2015-04-01 00:53:25.000000', 'temperatura', 698.0000, 'ºC'),
	(136903, 111, '2015-04-01 00:53:26.000000', 'temperatura', 1039.0000, 'ºC'),
	(136904, 111, '2015-04-01 00:53:27.000000', 'temperatura', 698.0000, 'ºC'),
	(136905, 111, '2015-04-01 00:53:28.000000', 'temperatura', 375.0000, 'ºC'),
	(136906, 111, '2015-04-01 00:53:29.000000', 'temperatura', 982.0000, 'ºC'),
	(136907, 111, '2015-04-01 00:53:30.000000', 'temperatura', 187.0000, 'ºC'),
	(136908, 111, '2015-04-01 00:53:31.000000', 'temperatura', 388.0000, 'ºC'),
	(136909, 111, '2015-04-01 00:53:32.000000', 'temperatura', 179.0000, 'ºC'),
	(136910, 111, '2015-04-01 00:53:33.000000', 'temperatura', 932.0000, 'ºC'),
	(136911, 111, '2015-04-01 00:53:34.000000', 'temperatura', 525.0000, 'ºC'),
	(136912, 111, '2015-04-01 00:53:35.000000', 'temperatura', 1030.0000, 'ºC'),
	(136913, 111, '2015-04-01 00:53:36.000000', 'temperatura', 1174.0000, 'ºC'),
	(136914, 111, '2015-04-01 00:53:37.000000', 'temperatura', 380.0000, 'ºC'),
	(136915, 111, '2015-04-01 00:53:38.000000', 'temperatura', 778.0000, 'ºC'),
	(136916, 111, '2015-04-01 00:53:39.000000', 'temperatura', 352.0000, 'ºC'),
	(136917, 111, '2015-04-01 00:53:40.000000', 'temperatura', 624.0000, 'ºC'),
	(136918, 111, '2015-04-01 00:53:41.000000', 'temperatura', 866.0000, 'ºC'),
	(136919, 111, '2015-04-01 00:53:42.000000', 'temperatura', 60.0000, 'ºC'),
	(136920, 111, '2015-04-01 00:53:43.000000', 'temperatura', 102.0000, 'ºC'),
	(136921, 111, '2015-04-01 00:53:44.000000', 'temperatura', 331.0000, 'ºC'),
	(136922, 111, '2015-04-01 00:53:45.000000', 'temperatura', 148.0000, 'ºC'),
	(136923, 111, '2015-04-01 00:53:46.000000', 'temperatura', 950.0000, 'ºC'),
	(136924, 111, '2015-04-01 00:53:47.000000', 'temperatura', 704.0000, 'ºC'),
	(136925, 111, '2015-04-01 00:53:48.000000', 'temperatura', 670.0000, 'ºC'),
	(136926, 111, '2015-04-01 00:53:49.000000', 'temperatura', 39.0000, 'ºC'),
	(136927, 111, '2015-04-01 00:53:50.000000', 'temperatura', 585.0000, 'ºC'),
	(136928, 111, '2015-04-01 00:53:51.000000', 'temperatura', 408.0000, 'ºC'),
	(136929, 111, '2015-04-01 00:53:52.000000', 'temperatura', 287.0000, 'ºC'),
	(136930, 111, '2015-04-01 00:53:53.000000', 'temperatura', 212.0000, 'ºC'),
	(136931, 111, '2015-04-01 00:53:54.000000', 'temperatura', 197.0000, 'ºC'),
	(136932, 111, '2015-04-01 00:53:55.000000', 'temperatura', 353.0000, 'ºC'),
	(136933, 111, '2015-04-01 00:53:56.000000', 'temperatura', 1172.0000, 'ºC'),
	(136934, 111, '2015-04-01 00:53:57.000000', 'temperatura', 2.0000, 'ºC'),
	(136935, 111, '2015-04-01 00:53:58.000000', 'temperatura', 95.0000, 'ºC'),
	(136936, 111, '2015-04-01 00:53:59.000000', 'temperatura', 471.0000, 'ºC'),
	(136937, 111, '2015-04-01 00:54:00.000000', 'temperatura', 867.0000, 'ºC'),
	(136938, 111, '2015-04-01 00:54:01.000000', 'temperatura', 525.0000, 'ºC'),
	(136939, 111, '2015-04-01 00:54:02.000000', 'temperatura', 25.0000, 'ºC'),
	(136940, 111, '2015-04-01 00:54:03.000000', 'temperatura', 949.0000, 'ºC'),
	(136941, 111, '2015-04-01 00:54:04.000000', 'temperatura', 1072.0000, 'ºC'),
	(136942, 111, '2015-04-01 00:54:05.000000', 'temperatura', 115.0000, 'ºC'),
	(136943, 111, '2015-04-01 00:54:06.000000', 'temperatura', 957.0000, 'ºC'),
	(136944, 111, '2015-04-01 00:54:07.000000', 'temperatura', 839.0000, 'ºC'),
	(136945, 111, '2015-04-01 00:54:08.000000', 'temperatura', 128.0000, 'ºC'),
	(136946, 111, '2015-04-01 00:54:09.000000', 'temperatura', 523.0000, 'ºC'),
	(136947, 111, '2015-04-01 00:54:10.000000', 'temperatura', 1030.0000, 'ºC'),
	(136948, 111, '2015-04-01 00:54:11.000000', 'temperatura', 1182.0000, 'ºC'),
	(136949, 111, '2015-04-01 00:54:12.000000', 'temperatura', 423.0000, 'ºC'),
	(136950, 111, '2015-04-01 00:54:13.000000', 'temperatura', 966.0000, 'ºC'),
	(136951, 111, '2015-04-01 00:54:14.000000', 'temperatura', 1161.0000, 'ºC'),
	(136952, 111, '2015-04-01 00:54:15.000000', 'temperatura', 511.0000, 'ºC'),
	(136953, 111, '2015-04-01 00:54:16.000000', 'temperatura', 269.0000, 'ºC'),
	(136954, 111, '2015-04-01 00:54:17.000000', 'temperatura', 1014.0000, 'ºC'),
	(136955, 111, '2015-04-01 00:54:18.000000', 'temperatura', 663.0000, 'ºC'),
	(136956, 111, '2015-04-01 00:54:19.000000', 'temperatura', 274.0000, 'ºC'),
	(136957, 111, '2015-04-01 00:54:20.000000', 'temperatura', 581.0000, 'ºC'),
	(136958, 111, '2015-04-01 00:54:21.000000', 'temperatura', 883.0000, 'ºC'),
	(136959, 111, '2015-04-01 00:54:22.000000', 'temperatura', 272.0000, 'ºC'),
	(136960, 111, '2015-04-01 00:54:23.000000', 'temperatura', 1113.0000, 'ºC'),
	(136961, 111, '2015-04-01 00:54:24.000000', 'temperatura', 1151.0000, 'ºC'),
	(136962, 111, '2015-04-01 00:54:25.000000', 'temperatura', 14.0000, 'ºC'),
	(136963, 111, '2015-04-01 00:54:26.000000', 'temperatura', 218.0000, 'ºC'),
	(136964, 111, '2015-04-01 00:54:27.000000', 'temperatura', 1051.0000, 'ºC'),
	(136965, 111, '2015-04-01 00:54:28.000000', 'temperatura', 998.0000, 'ºC'),
	(136966, 111, '2015-04-01 00:54:29.000000', 'temperatura', 640.0000, 'ºC'),
	(136967, 111, '2015-04-01 00:54:30.000000', 'temperatura', 204.0000, 'ºC'),
	(136968, 111, '2015-04-01 00:54:31.000000', 'temperatura', 301.0000, 'ºC'),
	(136969, 111, '2015-04-01 00:54:32.000000', 'temperatura', 894.0000, 'ºC'),
	(136970, 111, '2015-04-01 00:54:33.000000', 'temperatura', 1167.0000, 'ºC'),
	(136971, 111, '2015-04-01 00:54:34.000000', 'temperatura', 754.0000, 'ºC'),
	(136972, 111, '2015-04-01 00:54:35.000000', 'temperatura', 271.0000, 'ºC'),
	(136973, 111, '2015-04-01 00:54:36.000000', 'temperatura', 291.0000, 'ºC'),
	(136974, 111, '2015-04-01 00:54:37.000000', 'temperatura', 643.0000, 'ºC'),
	(136975, 111, '2015-04-01 00:54:38.000000', 'temperatura', 1141.0000, 'ºC'),
	(136976, 111, '2015-04-01 00:54:39.000000', 'temperatura', 178.0000, 'ºC'),
	(136977, 111, '2015-04-01 00:54:40.000000', 'temperatura', 1069.0000, 'ºC'),
	(136978, 111, '2015-04-01 00:54:41.000000', 'temperatura', 10.0000, 'ºC'),
	(136979, 111, '2015-04-01 00:54:42.000000', 'temperatura', 443.0000, 'ºC'),
	(136980, 111, '2015-04-01 00:54:43.000000', 'temperatura', 985.0000, 'ºC'),
	(136981, 111, '2015-04-01 00:54:44.000000', 'temperatura', 1197.0000, 'ºC'),
	(136982, 111, '2015-04-01 00:54:45.000000', 'temperatura', 629.0000, 'ºC'),
	(136983, 111, '2015-04-01 00:54:46.000000', 'temperatura', 756.0000, 'ºC'),
	(136984, 111, '2015-04-01 00:54:47.000000', 'temperatura', 693.0000, 'ºC'),
	(136985, 111, '2015-04-01 00:54:48.000000', 'temperatura', 0.0000, 'ºC'),
	(136986, 111, '2015-04-01 00:54:49.000000', 'temperatura', 319.0000, 'ºC'),
	(136987, 111, '2015-04-01 00:54:50.000000', 'temperatura', 394.0000, 'ºC'),
	(136988, 111, '2015-04-01 00:54:51.000000', 'temperatura', 1017.0000, 'ºC'),
	(136989, 111, '2015-04-01 00:54:52.000000', 'temperatura', 302.0000, 'ºC'),
	(136990, 111, '2015-04-01 00:54:53.000000', 'temperatura', 861.0000, 'ºC'),
	(136991, 111, '2015-04-01 00:54:54.000000', 'temperatura', 998.0000, 'ºC'),
	(136992, 111, '2015-04-01 00:54:55.000000', 'temperatura', 6.0000, 'ºC'),
	(136993, 111, '2015-04-01 00:54:56.000000', 'temperatura', 638.0000, 'ºC'),
	(136994, 111, '2015-04-01 00:54:57.000000', 'temperatura', 774.0000, 'ºC'),
	(136995, 111, '2015-04-01 00:54:58.000000', 'temperatura', 754.0000, 'ºC'),
	(136996, 111, '2015-04-01 00:54:59.000000', 'temperatura', 250.0000, 'ºC'),
	(136997, 111, '2015-04-01 00:55:00.000000', 'temperatura', 188.0000, 'ºC'),
	(136998, 111, '2015-04-01 00:55:01.000000', 'temperatura', 189.0000, 'ºC'),
	(136999, 111, '2015-04-01 00:55:02.000000', 'temperatura', 381.0000, 'ºC'),
	(137000, 111, '2015-04-01 00:55:03.000000', 'temperatura', 141.0000, 'ºC'),
	(137001, 112, '2015-04-01 00:00:00.000000', 'temperatura', 982.0000, 'ºC'),
	(137002, 112, '2015-04-01 00:00:01.000000', 'temperatura', 229.0000, 'ºC'),
	(137003, 112, '2015-04-01 00:00:02.000000', 'temperatura', 597.0000, 'ºC'),
	(137004, 112, '2015-04-01 00:00:03.000000', 'temperatura', 1101.0000, 'ºC'),
	(137005, 112, '2015-04-01 00:00:04.000000', 'temperatura', 112.0000, 'ºC'),
	(137006, 112, '2015-04-01 00:00:05.000000', 'temperatura', 860.0000, 'ºC'),
	(137007, 112, '2015-04-01 00:00:06.000000', 'temperatura', 363.0000, 'ºC'),
	(137008, 112, '2015-04-01 00:00:07.000000', 'temperatura', 435.0000, 'ºC'),
	(137009, 112, '2015-04-01 00:00:08.000000', 'temperatura', 1088.0000, 'ºC'),
	(137010, 112, '2015-04-01 00:00:09.000000', 'temperatura', 534.0000, 'ºC'),
	(137011, 112, '2015-04-01 00:00:10.000000', 'temperatura', 609.0000, 'ºC'),
	(137012, 112, '2015-04-01 00:00:11.000000', 'temperatura', 240.0000, 'ºC'),
	(137013, 112, '2015-04-01 00:00:12.000000', 'temperatura', 576.0000, 'ºC'),
	(137014, 112, '2015-04-01 00:00:13.000000', 'temperatura', 961.0000, 'ºC'),
	(137015, 112, '2015-04-01 00:00:14.000000', 'temperatura', 678.0000, 'ºC'),
	(137016, 112, '2015-04-01 00:00:15.000000', 'temperatura', 505.0000, 'ºC'),
	(137017, 112, '2015-04-01 00:00:16.000000', 'temperatura', 491.0000, 'ºC'),
	(137018, 112, '2015-04-01 00:00:17.000000', 'temperatura', 942.0000, 'ºC'),
	(137019, 112, '2015-04-01 00:00:18.000000', 'temperatura', 836.0000, 'ºC'),
	(137020, 112, '2015-04-01 00:00:19.000000', 'temperatura', 154.0000, 'ºC'),
	(137021, 112, '2015-04-01 00:00:20.000000', 'temperatura', 665.0000, 'ºC'),
	(137022, 112, '2015-04-01 00:00:21.000000', 'temperatura', 462.0000, 'ºC'),
	(137023, 112, '2015-04-01 00:00:22.000000', 'temperatura', 315.0000, 'ºC'),
	(137024, 112, '2015-04-01 00:00:23.000000', 'temperatura', 192.0000, 'ºC'),
	(137025, 112, '2015-04-01 00:00:24.000000', 'temperatura', 15.0000, 'ºC'),
	(137026, 112, '2015-04-01 00:00:25.000000', 'temperatura', 697.0000, 'ºC'),
	(137027, 112, '2015-04-01 00:00:26.000000', 'temperatura', 1043.0000, 'ºC'),
	(137028, 112, '2015-04-01 00:00:27.000000', 'temperatura', 725.0000, 'ºC'),
	(137029, 112, '2015-04-01 00:00:28.000000', 'temperatura', 496.0000, 'ºC'),
	(137030, 112, '2015-04-01 00:00:29.000000', 'temperatura', 303.0000, 'ºC'),
	(137031, 112, '2015-04-01 00:00:30.000000', 'temperatura', 30.0000, 'ºC'),
	(137032, 112, '2015-04-01 00:00:31.000000', 'temperatura', 440.0000, 'ºC'),
	(137033, 112, '2015-04-01 00:00:32.000000', 'temperatura', 909.0000, 'ºC'),
	(137034, 112, '2015-04-01 00:00:33.000000', 'temperatura', 828.0000, 'ºC'),
	(137035, 112, '2015-04-01 00:00:34.000000', 'temperatura', 213.0000, 'ºC'),
	(137036, 112, '2015-04-01 00:00:35.000000', 'temperatura', 982.0000, 'ºC'),
	(137037, 112, '2015-04-01 00:00:36.000000', 'temperatura', 671.0000, 'ºC'),
	(137038, 112, '2015-04-01 00:00:37.000000', 'temperatura', 412.0000, 'ºC'),
	(137039, 112, '2015-04-01 00:00:38.000000', 'temperatura', 44.0000, 'ºC'),
	(137040, 112, '2015-04-01 00:00:39.000000', 'temperatura', 185.0000, 'ºC'),
	(137041, 112, '2015-04-01 00:00:40.000000', 'temperatura', 796.0000, 'ºC'),
	(137042, 112, '2015-04-01 00:00:41.000000', 'temperatura', 1025.0000, 'ºC'),
	(137043, 112, '2015-04-01 00:00:42.000000', 'temperatura', 336.0000, 'ºC'),
	(137044, 112, '2015-04-01 00:00:43.000000', 'temperatura', 1005.0000, 'ºC'),
	(137045, 112, '2015-04-01 00:00:44.000000', 'temperatura', 416.0000, 'ºC'),
	(137046, 112, '2015-04-01 00:00:45.000000', 'temperatura', 269.0000, 'ºC'),
	(137047, 112, '2015-04-01 00:00:46.000000', 'temperatura', 96.0000, 'ºC'),
	(137048, 112, '2015-04-01 00:00:47.000000', 'temperatura', 874.0000, 'ºC'),
	(137049, 112, '2015-04-01 00:00:48.000000', 'temperatura', 484.0000, 'ºC'),
	(137050, 112, '2015-04-01 00:00:49.000000', 'temperatura', 995.0000, 'ºC'),
	(137051, 112, '2015-04-01 00:00:50.000000', 'temperatura', 1127.0000, 'ºC'),
	(137052, 112, '2015-04-01 00:00:51.000000', 'temperatura', 247.0000, 'ºC'),
	(137053, 112, '2015-04-01 00:00:52.000000', 'temperatura', 258.0000, 'ºC'),
	(137054, 112, '2015-04-01 00:00:53.000000', 'temperatura', 548.0000, 'ºC'),
	(137055, 112, '2015-04-01 00:00:54.000000', 'temperatura', 766.0000, 'ºC'),
	(137056, 112, '2015-04-01 00:00:55.000000', 'temperatura', 989.0000, 'ºC'),
	(137057, 112, '2015-04-01 00:00:56.000000', 'temperatura', 245.0000, 'ºC'),
	(137058, 112, '2015-04-01 00:00:57.000000', 'temperatura', 660.0000, 'ºC'),
	(137059, 112, '2015-04-01 00:00:58.000000', 'temperatura', 166.0000, 'ºC'),
	(137060, 112, '2015-04-01 00:00:59.000000', 'temperatura', 49.0000, 'ºC'),
	(137061, 112, '2015-04-01 00:01:00.000000', 'temperatura', 948.0000, 'ºC'),
	(137062, 112, '2015-04-01 00:01:01.000000', 'temperatura', 992.0000, 'ºC'),
	(137063, 112, '2015-04-01 00:01:02.000000', 'temperatura', 919.0000, 'ºC'),
	(137064, 112, '2015-04-01 00:01:03.000000', 'temperatura', 417.0000, 'ºC'),
	(137065, 112, '2015-04-01 00:01:04.000000', 'temperatura', 531.0000, 'ºC'),
	(137066, 112, '2015-04-01 00:01:05.000000', 'temperatura', 205.0000, 'ºC'),
	(137067, 112, '2015-04-01 00:01:06.000000', 'temperatura', 633.0000, 'ºC'),
	(137068, 112, '2015-04-01 00:01:07.000000', 'temperatura', 150.0000, 'ºC'),
	(137069, 112, '2015-04-01 00:01:08.000000', 'temperatura', 51.0000, 'ºC'),
	(137070, 112, '2015-04-01 00:01:09.000000', 'temperatura', 1007.0000, 'ºC'),
	(137071, 112, '2015-04-01 00:01:10.000000', 'temperatura', 80.0000, 'ºC'),
	(137072, 112, '2015-04-01 00:01:11.000000', 'temperatura', 979.0000, 'ºC'),
	(137073, 112, '2015-04-01 00:01:12.000000', 'temperatura', 1057.0000, 'ºC'),
	(137074, 112, '2015-04-01 00:01:13.000000', 'temperatura', 1148.0000, 'ºC'),
	(137075, 112, '2015-04-01 00:01:14.000000', 'temperatura', 170.0000, 'ºC'),
	(137076, 112, '2015-04-01 00:01:15.000000', 'temperatura', 1007.0000, 'ºC'),
	(137077, 112, '2015-04-01 00:01:16.000000', 'temperatura', 925.0000, 'ºC'),
	(137078, 112, '2015-04-01 00:01:17.000000', 'temperatura', 405.0000, 'ºC'),
	(137079, 112, '2015-04-01 00:01:18.000000', 'temperatura', 451.0000, 'ºC'),
	(137080, 112, '2015-04-01 00:01:19.000000', 'temperatura', 1040.0000, 'ºC'),
	(137081, 112, '2015-04-01 00:01:20.000000', 'temperatura', 249.0000, 'ºC'),
	(137082, 112, '2015-04-01 00:01:21.000000', 'temperatura', 526.0000, 'ºC'),
	(137083, 112, '2015-04-01 00:01:22.000000', 'temperatura', 682.0000, 'ºC'),
	(137084, 112, '2015-04-01 00:01:23.000000', 'temperatura', 632.0000, 'ºC'),
	(137085, 112, '2015-04-01 00:01:24.000000', 'temperatura', 1116.0000, 'ºC'),
	(137086, 112, '2015-04-01 00:01:25.000000', 'temperatura', 83.0000, 'ºC'),
	(137087, 112, '2015-04-01 00:01:26.000000', 'temperatura', 667.0000, 'ºC'),
	(137088, 112, '2015-04-01 00:01:27.000000', 'temperatura', 686.0000, 'ºC'),
	(137089, 112, '2015-04-01 00:01:28.000000', 'temperatura', 232.0000, 'ºC'),
	(137090, 112, '2015-04-01 00:01:29.000000', 'temperatura', 300.0000, 'ºC'),
	(137091, 112, '2015-04-01 00:01:30.000000', 'temperatura', 806.0000, 'ºC'),
	(137092, 112, '2015-04-01 00:01:31.000000', 'temperatura', 731.0000, 'ºC'),
	(137093, 112, '2015-04-01 00:01:32.000000', 'temperatura', 36.0000, 'ºC'),
	(137094, 112, '2015-04-01 00:01:33.000000', 'temperatura', 387.0000, 'ºC'),
	(137095, 112, '2015-04-01 00:01:34.000000', 'temperatura', 629.0000, 'ºC'),
	(137096, 112, '2015-04-01 00:01:35.000000', 'temperatura', 782.0000, 'ºC'),
	(137097, 112, '2015-04-01 00:01:36.000000', 'temperatura', 827.0000, 'ºC'),
	(137098, 112, '2015-04-01 00:01:37.000000', 'temperatura', 587.0000, 'ºC'),
	(137099, 112, '2015-04-01 00:01:38.000000', 'temperatura', 453.0000, 'ºC'),
	(137100, 112, '2015-04-01 00:01:39.000000', 'temperatura', 507.0000, 'ºC'),
	(137101, 112, '2015-04-01 00:01:40.000000', 'temperatura', 1177.0000, 'ºC'),
	(137102, 112, '2015-04-01 00:01:41.000000', 'temperatura', 766.0000, 'ºC'),
	(137103, 112, '2015-04-01 00:01:42.000000', 'temperatura', 296.0000, 'ºC'),
	(137104, 112, '2015-04-01 00:01:43.000000', 'temperatura', 384.0000, 'ºC'),
	(137105, 112, '2015-04-01 00:01:44.000000', 'temperatura', 1034.0000, 'ºC'),
	(137106, 112, '2015-04-01 00:01:45.000000', 'temperatura', 419.0000, 'ºC'),
	(137107, 112, '2015-04-01 00:01:46.000000', 'temperatura', 193.0000, 'ºC'),
	(137108, 112, '2015-04-01 00:01:47.000000', 'temperatura', 908.0000, 'ºC'),
	(137109, 112, '2015-04-01 00:01:48.000000', 'temperatura', 361.0000, 'ºC'),
	(137110, 112, '2015-04-01 00:01:49.000000', 'temperatura', 282.0000, 'ºC'),
	(137111, 112, '2015-04-01 00:01:50.000000', 'temperatura', 326.0000, 'ºC'),
	(137112, 112, '2015-04-01 00:01:51.000000', 'temperatura', 786.0000, 'ºC'),
	(137113, 112, '2015-04-01 00:01:52.000000', 'temperatura', 552.0000, 'ºC'),
	(137114, 112, '2015-04-01 00:01:53.000000', 'temperatura', 403.0000, 'ºC'),
	(137115, 112, '2015-04-01 00:01:54.000000', 'temperatura', 359.0000, 'ºC'),
	(137116, 112, '2015-04-01 00:01:55.000000', 'temperatura', 589.0000, 'ºC'),
	(137117, 112, '2015-04-01 00:01:56.000000', 'temperatura', 665.0000, 'ºC'),
	(137118, 112, '2015-04-01 00:01:57.000000', 'temperatura', 361.0000, 'ºC'),
	(137119, 112, '2015-04-01 00:01:58.000000', 'temperatura', 1008.0000, 'ºC'),
	(137120, 112, '2015-04-01 00:01:59.000000', 'temperatura', 357.0000, 'ºC'),
	(137121, 112, '2015-04-01 00:02:00.000000', 'temperatura', 1164.0000, 'ºC'),
	(137122, 112, '2015-04-01 00:02:01.000000', 'temperatura', 1149.0000, 'ºC'),
	(137123, 112, '2015-04-01 00:02:02.000000', 'temperatura', 1054.0000, 'ºC'),
	(137124, 112, '2015-04-01 00:02:03.000000', 'temperatura', 624.0000, 'ºC'),
	(137125, 112, '2015-04-01 00:02:04.000000', 'temperatura', 1159.0000, 'ºC'),
	(137126, 112, '2015-04-01 00:02:05.000000', 'temperatura', 323.0000, 'ºC'),
	(137127, 112, '2015-04-01 00:02:06.000000', 'temperatura', 537.0000, 'ºC'),
	(137128, 112, '2015-04-01 00:02:07.000000', 'temperatura', 518.0000, 'ºC'),
	(137129, 112, '2015-04-01 00:02:08.000000', 'temperatura', 978.0000, 'ºC'),
	(137130, 112, '2015-04-01 00:02:09.000000', 'temperatura', 936.0000, 'ºC'),
	(137131, 112, '2015-04-01 00:02:10.000000', 'temperatura', 547.0000, 'ºC'),
	(137132, 112, '2015-04-01 00:02:11.000000', 'temperatura', 1127.0000, 'ºC'),
	(137133, 112, '2015-04-01 00:02:12.000000', 'temperatura', 394.0000, 'ºC'),
	(137134, 112, '2015-04-01 00:02:13.000000', 'temperatura', 988.0000, 'ºC'),
	(137135, 112, '2015-04-01 00:02:14.000000', 'temperatura', 161.0000, 'ºC'),
	(137136, 112, '2015-04-01 00:02:15.000000', 'temperatura', 241.0000, 'ºC'),
	(137137, 112, '2015-04-01 00:02:16.000000', 'temperatura', 722.0000, 'ºC'),
	(137138, 112, '2015-04-01 00:02:17.000000', 'temperatura', 488.0000, 'ºC'),
	(137139, 112, '2015-04-01 00:02:18.000000', 'temperatura', 276.0000, 'ºC'),
	(137140, 112, '2015-04-01 00:02:19.000000', 'temperatura', 1115.0000, 'ºC'),
	(137141, 112, '2015-04-01 00:02:20.000000', 'temperatura', 1146.0000, 'ºC'),
	(137142, 112, '2015-04-01 00:02:21.000000', 'temperatura', 1186.0000, 'ºC'),
	(137143, 112, '2015-04-01 00:02:22.000000', 'temperatura', 93.0000, 'ºC'),
	(137144, 112, '2015-04-01 00:02:23.000000', 'temperatura', 509.0000, 'ºC'),
	(137145, 112, '2015-04-01 00:02:24.000000', 'temperatura', 1064.0000, 'ºC'),
	(137146, 112, '2015-04-01 00:02:25.000000', 'temperatura', 196.0000, 'ºC'),
	(137147, 112, '2015-04-01 00:02:26.000000', 'temperatura', 186.0000, 'ºC'),
	(137148, 112, '2015-04-01 00:02:27.000000', 'temperatura', 345.0000, 'ºC'),
	(137149, 112, '2015-04-01 00:02:28.000000', 'temperatura', 1168.0000, 'ºC'),
	(137150, 112, '2015-04-01 00:02:29.000000', 'temperatura', 3.0000, 'ºC'),
	(137151, 112, '2015-04-01 00:02:30.000000', 'temperatura', 111.0000, 'ºC'),
	(137152, 112, '2015-04-01 00:02:31.000000', 'temperatura', 549.0000, 'ºC'),
	(137153, 112, '2015-04-01 00:02:32.000000', 'temperatura', 12.0000, 'ºC'),
	(137154, 112, '2015-04-01 00:02:33.000000', 'temperatura', 812.0000, 'ºC'),
	(137155, 112, '2015-04-01 00:02:34.000000', 'temperatura', 424.0000, 'ºC'),
	(137156, 112, '2015-04-01 00:02:35.000000', 'temperatura', 883.0000, 'ºC'),
	(137157, 112, '2015-04-01 00:02:36.000000', 'temperatura', 747.0000, 'ºC'),
	(137158, 112, '2015-04-01 00:02:37.000000', 'temperatura', 1087.0000, 'ºC'),
	(137159, 112, '2015-04-01 00:02:38.000000', 'temperatura', 791.0000, 'ºC'),
	(137160, 112, '2015-04-01 00:02:39.000000', 'temperatura', 698.0000, 'ºC'),
	(137161, 112, '2015-04-01 00:02:40.000000', 'temperatura', 1117.0000, 'ºC'),
	(137162, 112, '2015-04-01 00:02:41.000000', 'temperatura', 1091.0000, 'ºC'),
	(137163, 112, '2015-04-01 00:02:42.000000', 'temperatura', 907.0000, 'ºC'),
	(137164, 112, '2015-04-01 00:02:43.000000', 'temperatura', 59.0000, 'ºC'),
	(137165, 112, '2015-04-01 00:02:44.000000', 'temperatura', 1174.0000, 'ºC'),
	(137166, 112, '2015-04-01 00:02:45.000000', 'temperatura', 894.0000, 'ºC'),
	(137167, 112, '2015-04-01 00:02:46.000000', 'temperatura', 950.0000, 'ºC'),
	(137168, 112, '2015-04-01 00:02:47.000000', 'temperatura', 867.0000, 'ºC'),
	(137169, 112, '2015-04-01 00:02:48.000000', 'temperatura', 285.0000, 'ºC'),
	(137170, 112, '2015-04-01 00:02:49.000000', 'temperatura', 25.0000, 'ºC'),
	(137171, 112, '2015-04-01 00:02:50.000000', 'temperatura', 470.0000, 'ºC'),
	(137172, 112, '2015-04-01 00:02:51.000000', 'temperatura', 1077.0000, 'ºC'),
	(137173, 112, '2015-04-01 00:02:52.000000', 'temperatura', 375.0000, 'ºC'),
	(137174, 112, '2015-04-01 00:02:53.000000', 'temperatura', 1043.0000, 'ºC'),
	(137175, 112, '2015-04-01 00:02:54.000000', 'temperatura', 491.0000, 'ºC'),
	(137176, 112, '2015-04-01 00:02:55.000000', 'temperatura', 526.0000, 'ºC'),
	(137177, 112, '2015-04-01 00:02:56.000000', 'temperatura', 1158.0000, 'ºC'),
	(137178, 112, '2015-04-01 00:02:57.000000', 'temperatura', 612.0000, 'ºC'),
	(137179, 112, '2015-04-01 00:02:58.000000', 'temperatura', 789.0000, 'ºC'),
	(137180, 112, '2015-04-01 00:02:59.000000', 'temperatura', 906.0000, 'ºC'),
	(137181, 112, '2015-04-01 00:03:00.000000', 'temperatura', 965.0000, 'ºC'),
	(137182, 112, '2015-04-01 00:03:01.000000', 'temperatura', 910.0000, 'ºC'),
	(137183, 112, '2015-04-01 00:03:02.000000', 'temperatura', 452.0000, 'ºC'),
	(137184, 112, '2015-04-01 00:03:03.000000', 'temperatura', 731.0000, 'ºC'),
	(137185, 112, '2015-04-01 00:03:04.000000', 'temperatura', 1098.0000, 'ºC'),
	(137186, 112, '2015-04-01 00:03:05.000000', 'temperatura', 901.0000, 'ºC'),
	(137187, 112, '2015-04-01 00:03:06.000000', 'temperatura', 10.0000, 'ºC'),
	(137188, 112, '2015-04-01 00:03:07.000000', 'temperatura', 948.0000, 'ºC'),
	(137189, 112, '2015-04-01 00:03:08.000000', 'temperatura', 1108.0000, 'ºC'),
	(137190, 112, '2015-04-01 00:03:09.000000', 'temperatura', 300.0000, 'ºC'),
	(137191, 112, '2015-04-01 00:03:10.000000', 'temperatura', 576.0000, 'ºC'),
	(137192, 112, '2015-04-01 00:03:11.000000', 'temperatura', 778.0000, 'ºC'),
	(137193, 112, '2015-04-01 00:03:12.000000', 'temperatura', 963.0000, 'ºC'),
	(137194, 112, '2015-04-01 00:03:13.000000', 'temperatura', 81.0000, 'ºC'),
	(137195, 112, '2015-04-01 00:03:14.000000', 'temperatura', 1117.0000, 'ºC'),
	(137196, 112, '2015-04-01 00:03:15.000000', 'temperatura', 542.0000, 'ºC'),
	(137197, 112, '2015-04-01 00:03:16.000000', 'temperatura', 561.0000, 'ºC'),
	(137198, 112, '2015-04-01 00:03:17.000000', 'temperatura', 1181.0000, 'ºC'),
	(137199, 112, '2015-04-01 00:03:18.000000', 'temperatura', 621.0000, 'ºC'),
	(137200, 112, '2015-04-01 00:03:19.000000', 'temperatura', 761.0000, 'ºC'),
	(137201, 112, '2015-04-01 00:03:20.000000', 'temperatura', 742.0000, 'ºC'),
	(137202, 112, '2015-04-01 00:03:21.000000', 'temperatura', 229.0000, 'ºC'),
	(137203, 112, '2015-04-01 00:03:22.000000', 'temperatura', 118.0000, 'ºC'),
	(137204, 112, '2015-04-01 00:03:23.000000', 'temperatura', 1103.0000, 'ºC'),
	(137205, 112, '2015-04-01 00:03:24.000000', 'temperatura', 363.0000, 'ºC'),
	(137206, 112, '2015-04-01 00:03:25.000000', 'temperatura', 908.0000, 'ºC'),
	(137207, 112, '2015-04-01 00:03:26.000000', 'temperatura', 1050.0000, 'ºC'),
	(137208, 112, '2015-04-01 00:03:27.000000', 'temperatura', 125.0000, 'ºC'),
	(137209, 112, '2015-04-01 00:03:28.000000', 'temperatura', 1077.0000, 'ºC'),
	(137210, 112, '2015-04-01 00:03:29.000000', 'temperatura', 210.0000, 'ºC'),
	(137211, 112, '2015-04-01 00:03:30.000000', 'temperatura', 218.0000, 'ºC'),
	(137212, 112, '2015-04-01 00:03:31.000000', 'temperatura', 463.0000, 'ºC'),
	(137213, 112, '2015-04-01 00:03:32.000000', 'temperatura', 462.0000, 'ºC'),
	(137214, 112, '2015-04-01 00:03:33.000000', 'temperatura', 922.0000, 'ºC'),
	(137215, 112, '2015-04-01 00:03:34.000000', 'temperatura', 824.0000, 'ºC'),
	(137216, 112, '2015-04-01 00:03:35.000000', 'temperatura', 156.0000, 'ºC'),
	(137217, 112, '2015-04-01 00:03:36.000000', 'temperatura', 707.0000, 'ºC'),
	(137218, 112, '2015-04-01 00:03:37.000000', 'temperatura', 666.0000, 'ºC'),
	(137219, 112, '2015-04-01 00:03:38.000000', 'temperatura', 12.0000, 'ºC'),
	(137220, 112, '2015-04-01 00:03:39.000000', 'temperatura', 463.0000, 'ºC'),
	(137221, 112, '2015-04-01 00:03:40.000000', 'temperatura', 1080.0000, 'ºC'),
	(137222, 112, '2015-04-01 00:03:41.000000', 'temperatura', 410.0000, 'ºC'),
	(137223, 112, '2015-04-01 00:03:42.000000', 'temperatura', 11.0000, 'ºC'),
	(137224, 112, '2015-04-01 00:03:43.000000', 'temperatura', 25.0000, 'ºC'),
	(137225, 112, '2015-04-01 00:03:44.000000', 'temperatura', 94.0000, 'ºC'),
	(137226, 112, '2015-04-01 00:03:45.000000', 'temperatura', 394.0000, 'ºC'),
	(137227, 112, '2015-04-01 00:03:46.000000', 'temperatura', 487.0000, 'ºC'),
	(137228, 112, '2015-04-01 00:03:47.000000', 'temperatura', 57.0000, 'ºC'),
	(137229, 112, '2015-04-01 00:03:48.000000', 'temperatura', 22.0000, 'ºC'),
	(137230, 112, '2015-04-01 00:03:49.000000', 'temperatura', 1140.0000, 'ºC'),
	(137231, 112, '2015-04-01 00:03:50.000000', 'temperatura', 837.0000, 'ºC'),
	(137232, 112, '2015-04-01 00:03:51.000000', 'temperatura', 763.0000, 'ºC'),
	(137233, 112, '2015-04-01 00:03:52.000000', 'temperatura', 104.0000, 'ºC'),
	(137234, 112, '2015-04-01 00:03:53.000000', 'temperatura', 634.0000, 'ºC'),
	(137235, 112, '2015-04-01 00:03:54.000000', 'temperatura', 458.0000, 'ºC'),
	(137236, 112, '2015-04-01 00:03:55.000000', 'temperatura', 386.0000, 'ºC'),
	(137237, 112, '2015-04-01 00:03:56.000000', 'temperatura', 558.0000, 'ºC'),
	(137238, 112, '2015-04-01 00:03:57.000000', 'temperatura', 433.0000, 'ºC'),
	(137239, 112, '2015-04-01 00:03:58.000000', 'temperatura', 489.0000, 'ºC'),
	(137240, 112, '2015-04-01 00:03:59.000000', 'temperatura', 1148.0000, 'ºC'),
	(137241, 112, '2015-04-01 00:04:00.000000', 'temperatura', 673.0000, 'ºC'),
	(137242, 112, '2015-04-01 00:04:01.000000', 'temperatura', 1121.0000, 'ºC'),
	(137243, 112, '2015-04-01 00:04:02.000000', 'temperatura', 1188.0000, 'ºC'),
	(137244, 112, '2015-04-01 00:04:03.000000', 'temperatura', 177.0000, 'ºC'),
	(137245, 112, '2015-04-01 00:04:04.000000', 'temperatura', 923.0000, 'ºC'),
	(137246, 112, '2015-04-01 00:04:05.000000', 'temperatura', 483.0000, 'ºC'),
	(137247, 112, '2015-04-01 00:04:06.000000', 'temperatura', 848.0000, 'ºC'),
	(137248, 112, '2015-04-01 00:04:07.000000', 'temperatura', 392.0000, 'ºC'),
	(137249, 112, '2015-04-01 00:04:08.000000', 'temperatura', 616.0000, 'ºC'),
	(137250, 112, '2015-04-01 00:04:09.000000', 'temperatura', 705.0000, 'ºC'),
	(137251, 112, '2015-04-01 00:04:10.000000', 'temperatura', 478.0000, 'ºC'),
	(137252, 112, '2015-04-01 00:04:11.000000', 'temperatura', 273.0000, 'ºC'),
	(137253, 112, '2015-04-01 00:04:12.000000', 'temperatura', 1134.0000, 'ºC'),
	(137254, 112, '2015-04-01 00:04:13.000000', 'temperatura', 50.0000, 'ºC'),
	(137255, 112, '2015-04-01 00:04:14.000000', 'temperatura', 447.0000, 'ºC'),
	(137256, 112, '2015-04-01 00:04:15.000000', 'temperatura', 888.0000, 'ºC'),
	(137257, 112, '2015-04-01 00:04:16.000000', 'temperatura', 697.0000, 'ºC'),
	(137258, 112, '2015-04-01 00:04:17.000000', 'temperatura', 822.0000, 'ºC'),
	(137259, 112, '2015-04-01 00:04:18.000000', 'temperatura', 820.0000, 'ºC'),
	(137260, 112, '2015-04-01 00:04:19.000000', 'temperatura', 435.0000, 'ºC'),
	(137261, 112, '2015-04-01 00:04:20.000000', 'temperatura', 917.0000, 'ºC'),
	(137262, 112, '2015-04-01 00:04:21.000000', 'temperatura', 879.0000, 'ºC'),
	(137263, 112, '2015-04-01 00:04:22.000000', 'temperatura', 443.0000, 'ºC'),
	(137264, 112, '2015-04-01 00:04:23.000000', 'temperatura', 780.0000, 'ºC'),
	(137265, 112, '2015-04-01 00:04:24.000000', 'temperatura', 173.0000, 'ºC'),
	(137266, 112, '2015-04-01 00:04:25.000000', 'temperatura', 923.0000, 'ºC'),
	(137267, 112, '2015-04-01 00:04:26.000000', 'temperatura', 496.0000, 'ºC'),
	(137268, 112, '2015-04-01 00:04:27.000000', 'temperatura', 910.0000, 'ºC'),
	(137269, 112, '2015-04-01 00:04:28.000000', 'temperatura', 666.0000, 'ºC'),
	(137270, 112, '2015-04-01 00:04:29.000000', 'temperatura', 598.0000, 'ºC'),
	(137271, 112, '2015-04-01 00:04:30.000000', 'temperatura', 992.0000, 'ºC'),
	(137272, 112, '2015-04-01 00:04:31.000000', 'temperatura', 769.0000, 'ºC'),
	(137273, 112, '2015-04-01 00:04:32.000000', 'temperatura', 868.0000, 'ºC'),
	(137274, 112, '2015-04-01 00:04:33.000000', 'temperatura', 833.0000, 'ºC'),
	(137275, 112, '2015-04-01 00:04:34.000000', 'temperatura', 364.0000, 'ºC'),
	(137276, 112, '2015-04-01 00:04:35.000000', 'temperatura', 520.0000, 'ºC'),
	(137277, 112, '2015-04-01 00:04:36.000000', 'temperatura', 310.0000, 'ºC'),
	(137278, 112, '2015-04-01 00:04:37.000000', 'temperatura', 1190.0000, 'ºC'),
	(137279, 112, '2015-04-01 00:04:38.000000', 'temperatura', 219.0000, 'ºC'),
	(137280, 112, '2015-04-01 00:04:39.000000', 'temperatura', 1124.0000, 'ºC'),
	(137281, 112, '2015-04-01 00:04:40.000000', 'temperatura', 166.0000, 'ºC'),
	(137282, 112, '2015-04-01 00:04:41.000000', 'temperatura', 1060.0000, 'ºC'),
	(137283, 112, '2015-04-01 00:04:42.000000', 'temperatura', 1.0000, 'ºC'),
	(137284, 112, '2015-04-01 00:04:43.000000', 'temperatura', 426.0000, 'ºC'),
	(137285, 112, '2015-04-01 00:04:44.000000', 'temperatura', 927.0000, 'ºC'),
	(137286, 112, '2015-04-01 00:04:45.000000', 'temperatura', 959.0000, 'ºC'),
	(137287, 112, '2015-04-01 00:04:46.000000', 'temperatura', 815.0000, 'ºC'),
	(137288, 112, '2015-04-01 00:04:47.000000', 'temperatura', 1196.0000, 'ºC'),
	(137289, 112, '2015-04-01 00:04:48.000000', 'temperatura', 1135.0000, 'ºC'),
	(137290, 112, '2015-04-01 00:04:49.000000', 'temperatura', 887.0000, 'ºC'),
	(137291, 112, '2015-04-01 00:04:50.000000', 'temperatura', 1032.0000, 'ºC'),
	(137292, 112, '2015-04-01 00:04:51.000000', 'temperatura', 99.0000, 'ºC'),
	(137293, 112, '2015-04-01 00:04:52.000000', 'temperatura', 999.0000, 'ºC'),
	(137294, 112, '2015-04-01 00:04:53.000000', 'temperatura', 1101.0000, 'ºC'),
	(137295, 112, '2015-04-01 00:04:54.000000', 'temperatura', 107.0000, 'ºC'),
	(137296, 112, '2015-04-01 00:04:55.000000', 'temperatura', 835.0000, 'ºC'),
	(137297, 112, '2015-04-01 00:04:56.000000', 'temperatura', 251.0000, 'ºC'),
	(137298, 112, '2015-04-01 00:04:57.000000', 'temperatura', 1152.0000, 'ºC'),
	(137299, 112, '2015-04-01 00:04:58.000000', 'temperatura', 207.0000, 'ºC'),
	(137300, 112, '2015-04-01 00:04:59.000000', 'temperatura', 1181.0000, 'ºC'),
	(137301, 112, '2015-04-01 00:05:00.000000', 'temperatura', 483.0000, 'ºC'),
	(137302, 112, '2015-04-01 00:05:01.000000', 'temperatura', 73.0000, 'ºC'),
	(137303, 112, '2015-04-01 00:05:02.000000', 'temperatura', 117.0000, 'ºC'),
	(137304, 112, '2015-04-01 00:05:03.000000', 'temperatura', 365.0000, 'ºC'),
	(137305, 112, '2015-04-01 00:05:04.000000', 'temperatura', 275.0000, 'ºC'),
	(137306, 112, '2015-04-01 00:05:05.000000', 'temperatura', 281.0000, 'ºC'),
	(137307, 112, '2015-04-01 00:05:06.000000', 'temperatura', 579.0000, 'ºC'),
	(137308, 112, '2015-04-01 00:05:07.000000', 'temperatura', 855.0000, 'ºC'),
	(137309, 112, '2015-04-01 00:05:08.000000', 'temperatura', 138.0000, 'ºC'),
	(137310, 112, '2015-04-01 00:05:09.000000', 'temperatura', 526.0000, 'ºC'),
	(137311, 112, '2015-04-01 00:05:10.000000', 'temperatura', 1014.0000, 'ºC'),
	(137312, 112, '2015-04-01 00:05:11.000000', 'temperatura', 1093.0000, 'ºC'),
	(137313, 112, '2015-04-01 00:05:12.000000', 'temperatura', 26.0000, 'ºC'),
	(137314, 112, '2015-04-01 00:05:13.000000', 'temperatura', 449.0000, 'ºC'),
	(137315, 112, '2015-04-01 00:05:14.000000', 'temperatura', 967.0000, 'ºC'),
	(137316, 112, '2015-04-01 00:05:15.000000', 'temperatura', 1089.0000, 'ºC'),
	(137317, 112, '2015-04-01 00:05:16.000000', 'temperatura', 147.0000, 'ºC'),
	(137318, 112, '2015-04-01 00:05:17.000000', 'temperatura', 1065.0000, 'ºC'),
	(137319, 112, '2015-04-01 00:05:18.000000', 'temperatura', 87.0000, 'ºC'),
	(137320, 112, '2015-04-01 00:05:19.000000', 'temperatura', 838.0000, 'ºC'),
	(137321, 112, '2015-04-01 00:05:20.000000', 'temperatura', 332.0000, 'ºC'),
	(137322, 112, '2015-04-01 00:05:21.000000', 'temperatura', 347.0000, 'ºC'),
	(137323, 112, '2015-04-01 00:05:22.000000', 'temperatura', 740.0000, 'ºC'),
	(137324, 112, '2015-04-01 00:05:23.000000', 'temperatura', 260.0000, 'ºC'),
	(137325, 112, '2015-04-01 00:05:24.000000', 'temperatura', 279.0000, 'ºC'),
	(137326, 112, '2015-04-01 00:05:25.000000', 'temperatura', 614.0000, 'ºC'),
	(137327, 112, '2015-04-01 00:05:26.000000', 'temperatura', 1036.0000, 'ºC'),
	(137328, 112, '2015-04-01 00:05:27.000000', 'temperatura', 939.0000, 'ºC'),
	(137329, 112, '2015-04-01 00:05:28.000000', 'temperatura', 385.0000, 'ºC'),
	(137330, 112, '2015-04-01 00:05:29.000000', 'temperatura', 308.0000, 'ºC'),
	(137331, 112, '2015-04-01 00:05:30.000000', 'temperatura', 387.0000, 'ºC'),
	(137332, 112, '2015-04-01 00:05:31.000000', 'temperatura', 1012.0000, 'ºC'),
	(137333, 112, '2015-04-01 00:05:32.000000', 'temperatura', 299.0000, 'ºC'),
	(137334, 112, '2015-04-01 00:05:33.000000', 'temperatura', 861.0000, 'ºC'),
	(137335, 112, '2015-04-01 00:05:34.000000', 'temperatura', 1008.0000, 'ºC'),
	(137336, 112, '2015-04-01 00:05:35.000000', 'temperatura', 57.0000, 'ºC'),
	(137337, 112, '2015-04-01 00:05:36.000000', 'temperatura', 863.0000, 'ºC'),
	(137338, 112, '2015-04-01 00:05:37.000000', 'temperatura', 544.0000, 'ºC'),
	(137339, 112, '2015-04-01 00:05:38.000000', 'temperatura', 133.0000, 'ºC'),
	(137340, 112, '2015-04-01 00:05:39.000000', 'temperatura', 232.0000, 'ºC'),
	(137341, 112, '2015-04-01 00:05:40.000000', 'temperatura', 763.0000, 'ºC'),
	(137342, 112, '2015-04-01 00:05:41.000000', 'temperatura', 719.0000, 'ºC'),
	(137343, 112, '2015-04-01 00:05:42.000000', 'temperatura', 106.0000, 'ºC'),
	(137344, 112, '2015-04-01 00:05:43.000000', 'temperatura', 775.0000, 'ºC'),
	(137345, 112, '2015-04-01 00:05:44.000000', 'temperatura', 1155.0000, 'ºC'),
	(137346, 112, '2015-04-01 00:05:45.000000', 'temperatura', 1052.0000, 'ºC'),
	(137347, 112, '2015-04-01 00:05:46.000000', 'temperatura', 593.0000, 'ºC'),
	(137348, 112, '2015-04-01 00:05:47.000000', 'temperatura', 1012.0000, 'ºC'),
	(137349, 112, '2015-04-01 00:05:48.000000', 'temperatura', 883.0000, 'ºC'),
	(137350, 112, '2015-04-01 00:05:49.000000', 'temperatura', 177.0000, 'ºC'),
	(137351, 112, '2015-04-01 00:05:50.000000', 'temperatura', 635.0000, 'ºC'),
	(137352, 112, '2015-04-01 00:05:51.000000', 'temperatura', 247.0000, 'ºC'),
	(137353, 112, '2015-04-01 00:05:52.000000', 'temperatura', 528.0000, 'ºC'),
	(137354, 112, '2015-04-01 00:05:53.000000', 'temperatura', 701.0000, 'ºC'),
	(137355, 112, '2015-04-01 00:05:54.000000', 'temperatura', 721.0000, 'ºC'),
	(137356, 112, '2015-04-01 00:05:55.000000', 'temperatura', 305.0000, 'ºC'),
	(137357, 112, '2015-04-01 00:05:56.000000', 'temperatura', 560.0000, 'ºC'),
	(137358, 112, '2015-04-01 00:05:57.000000', 'temperatura', 688.0000, 'ºC'),
	(137359, 112, '2015-04-01 00:05:58.000000', 'temperatura', 558.0000, 'ºC'),
	(137360, 112, '2015-04-01 00:05:59.000000', 'temperatura', 726.0000, 'ºC'),
	(137361, 112, '2015-04-01 00:06:00.000000', 'temperatura', 759.0000, 'ºC'),
	(137362, 112, '2015-04-01 00:06:01.000000', 'temperatura', 415.0000, 'ºC'),
	(137363, 112, '2015-04-01 00:06:02.000000', 'temperatura', 1001.0000, 'ºC'),
	(137364, 112, '2015-04-01 00:06:03.000000', 'temperatura', 159.0000, 'ºC'),
	(137365, 112, '2015-04-01 00:06:04.000000', 'temperatura', 191.0000, 'ºC'),
	(137366, 112, '2015-04-01 00:06:05.000000', 'temperatura', 479.0000, 'ºC'),
	(137367, 112, '2015-04-01 00:06:06.000000', 'temperatura', 621.0000, 'ºC'),
	(137368, 112, '2015-04-01 00:06:07.000000', 'temperatura', 470.0000, 'ºC'),
	(137369, 112, '2015-04-01 00:06:08.000000', 'temperatura', 488.0000, 'ºC'),
	(137370, 112, '2015-04-01 00:06:09.000000', 'temperatura', 1029.0000, 'ºC'),
	(137371, 112, '2015-04-01 00:06:10.000000', 'temperatura', 82.0000, 'ºC'),
	(137372, 112, '2015-04-01 00:06:11.000000', 'temperatura', 924.0000, 'ºC'),
	(137373, 112, '2015-04-01 00:06:12.000000', 'temperatura', 773.0000, 'ºC'),
	(137374, 112, '2015-04-01 00:06:13.000000', 'temperatura', 1095.0000, 'ºC'),
	(137375, 112, '2015-04-01 00:06:14.000000', 'temperatura', 755.0000, 'ºC'),
	(137376, 112, '2015-04-01 00:06:15.000000', 'temperatura', 491.0000, 'ºC'),
	(137377, 112, '2015-04-01 00:06:16.000000', 'temperatura', 192.0000, 'ºC'),
	(137378, 112, '2015-04-01 00:06:17.000000', 'temperatura', 687.0000, 'ºC'),
	(137379, 112, '2015-04-01 00:06:18.000000', 'temperatura', 458.0000, 'ºC'),
	(137380, 112, '2015-04-01 00:06:19.000000', 'temperatura', 229.0000, 'ºC'),
	(137381, 112, '2015-04-01 00:06:20.000000', 'temperatura', 973.0000, 'ºC'),
	(137382, 112, '2015-04-01 00:06:21.000000', 'temperatura', 579.0000, 'ºC'),
	(137383, 112, '2015-04-01 00:06:22.000000', 'temperatura', 1176.0000, 'ºC'),
	(137384, 112, '2015-04-01 00:06:23.000000', 'temperatura', 542.0000, 'ºC'),
	(137385, 112, '2015-04-01 00:06:24.000000', 'temperatura', 383.0000, 'ºC'),
	(137386, 112, '2015-04-01 00:06:25.000000', 'temperatura', 290.0000, 'ºC'),
	(137387, 112, '2015-04-01 00:06:26.000000', 'temperatura', 300.0000, 'ºC'),
	(137388, 112, '2015-04-01 00:06:27.000000', 'temperatura', 630.0000, 'ºC'),
	(137389, 112, '2015-04-01 00:06:28.000000', 'temperatura', 1053.0000, 'ºC'),
	(137390, 112, '2015-04-01 00:06:29.000000', 'temperatura', 976.0000, 'ºC'),
	(137391, 112, '2015-04-01 00:06:30.000000', 'temperatura', 518.0000, 'ºC'),
	(137392, 112, '2015-04-01 00:06:31.000000', 'temperatura', 865.0000, 'ºC'),
	(137393, 112, '2015-04-01 00:06:32.000000', 'temperatura', 373.0000, 'ºC'),
	(137394, 112, '2015-04-01 00:06:33.000000', 'temperatura', 468.0000, 'ºC'),
	(137395, 112, '2015-04-01 00:06:34.000000', 'temperatura', 22.0000, 'ºC'),
	(137396, 112, '2015-04-01 00:06:35.000000', 'temperatura', 1108.0000, 'ºC'),
	(137397, 112, '2015-04-01 00:06:36.000000', 'temperatura', 675.0000, 'ºC'),
	(137398, 112, '2015-04-01 00:06:37.000000', 'temperatura', 49.0000, 'ºC'),
	(137399, 112, '2015-04-01 00:06:38.000000', 'temperatura', 623.0000, 'ºC'),
	(137400, 112, '2015-04-01 00:06:39.000000', 'temperatura', 566.0000, 'ºC'),
	(137401, 112, '2015-04-01 00:06:40.000000', 'temperatura', 962.0000, 'ºC'),
	(137402, 112, '2015-04-01 00:06:41.000000', 'temperatura', 711.0000, 'ºC'),
	(137403, 112, '2015-04-01 00:06:42.000000', 'temperatura', 672.0000, 'ºC'),
	(137404, 112, '2015-04-01 00:06:43.000000', 'temperatura', 25.0000, 'ºC'),
	(137405, 112, '2015-04-01 00:06:44.000000', 'temperatura', 511.0000, 'ºC'),
	(137406, 112, '2015-04-01 00:06:45.000000', 'temperatura', 81.0000, 'ºC'),
	(137407, 112, '2015-04-01 00:06:46.000000', 'temperatura', 73.0000, 'ºC'),
	(137408, 112, '2015-04-01 00:06:47.000000', 'temperatura', 122.0000, 'ºC'),
	(137409, 112, '2015-04-01 00:06:48.000000', 'temperatura', 393.0000, 'ºC'),
	(137410, 112, '2015-04-01 00:06:49.000000', 'temperatura', 399.0000, 'ºC'),
	(137411, 112, '2015-04-01 00:06:50.000000', 'temperatura', 816.0000, 'ºC'),
	(137412, 112, '2015-04-01 00:06:51.000000', 'temperatura', 484.0000, 'ºC'),
	(137413, 112, '2015-04-01 00:06:52.000000', 'temperatura', 1171.0000, 'ºC'),
	(137414, 112, '2015-04-01 00:06:53.000000', 'temperatura', 806.0000, 'ºC'),
	(137415, 112, '2015-04-01 00:06:54.000000', 'temperatura', 517.0000, 'ºC'),
	(137416, 112, '2015-04-01 00:06:55.000000', 'temperatura', 167.0000, 'ºC'),
	(137417, 112, '2015-04-01 00:06:56.000000', 'temperatura', 485.0000, 'ºC'),
	(137418, 112, '2015-04-01 00:06:57.000000', 'temperatura', 725.0000, 'ºC'),
	(137419, 112, '2015-04-01 00:06:58.000000', 'temperatura', 970.0000, 'ºC'),
	(137420, 112, '2015-04-01 00:06:59.000000', 'temperatura', 274.0000, 'ºC'),
	(137421, 112, '2015-04-01 00:07:00.000000', 'temperatura', 861.0000, 'ºC'),
	(137422, 112, '2015-04-01 00:07:01.000000', 'temperatura', 1086.0000, 'ºC'),
	(137423, 112, '2015-04-01 00:07:02.000000', 'temperatura', 445.0000, 'ºC'),
	(137424, 112, '2015-04-01 00:07:03.000000', 'temperatura', 167.0000, 'ºC'),
	(137425, 112, '2015-04-01 00:07:04.000000', 'temperatura', 701.0000, 'ºC'),
	(137426, 112, '2015-04-01 00:07:05.000000', 'temperatura', 604.0000, 'ºC'),
	(137427, 112, '2015-04-01 00:07:06.000000', 'temperatura', 920.0000, 'ºC'),
	(137428, 112, '2015-04-01 00:07:07.000000', 'temperatura', 386.0000, 'ºC'),
	(137429, 112, '2015-04-01 00:07:08.000000', 'temperatura', 370.0000, 'ºC'),
	(137430, 112, '2015-04-01 00:07:09.000000', 'temperatura', 692.0000, 'ºC'),
	(137431, 112, '2015-04-01 00:07:10.000000', 'temperatura', 1150.0000, 'ºC'),
	(137432, 112, '2015-04-01 00:07:11.000000', 'temperatura', 75.0000, 'ºC'),
	(137433, 112, '2015-04-01 00:07:12.000000', 'temperatura', 525.0000, 'ºC'),
	(137434, 112, '2015-04-01 00:07:13.000000', 'temperatura', 1199.0000, 'ºC'),
	(137435, 112, '2015-04-01 00:07:14.000000', 'temperatura', 823.0000, 'ºC'),
	(137436, 112, '2015-04-01 00:07:15.000000', 'temperatura', 516.0000, 'ºC'),
	(137437, 112, '2015-04-01 00:07:16.000000', 'temperatura', 114.0000, 'ºC'),
	(137438, 112, '2015-04-01 00:07:17.000000', 'temperatura', 222.0000, 'ºC'),
	(137439, 112, '2015-04-01 00:07:18.000000', 'temperatura', 769.0000, 'ºC'),
	(137440, 112, '2015-04-01 00:07:19.000000', 'temperatura', 780.0000, 'ºC'),
	(137441, 112, '2015-04-01 00:07:20.000000', 'temperatura', 392.0000, 'ºC'),
	(137442, 112, '2015-04-01 00:07:21.000000', 'temperatura', 819.0000, 'ºC'),
	(137443, 112, '2015-04-01 00:07:22.000000', 'temperatura', 522.0000, 'ºC'),
	(137444, 112, '2015-04-01 00:07:23.000000', 'temperatura', 152.0000, 'ºC'),
	(137445, 112, '2015-04-01 00:07:24.000000', 'temperatura', 394.0000, 'ºC'),
	(137446, 112, '2015-04-01 00:07:25.000000', 'temperatura', 314.0000, 'ºC'),
	(137447, 112, '2015-04-01 00:07:26.000000', 'temperatura', 391.0000, 'ºC'),
	(137448, 112, '2015-04-01 00:07:27.000000', 'temperatura', 1014.0000, 'ºC'),
	(137449, 112, '2015-04-01 00:07:28.000000', 'temperatura', 297.0000, 'ºC'),
	(137450, 112, '2015-04-01 00:07:29.000000', 'temperatura', 844.0000, 'ºC'),
	(137451, 112, '2015-04-01 00:07:30.000000', 'temperatura', 929.0000, 'ºC'),
	(137452, 112, '2015-04-01 00:07:31.000000', 'temperatura', 915.0000, 'ºC'),
	(137453, 112, '2015-04-01 00:07:32.000000', 'temperatura', 586.0000, 'ºC'),
	(137454, 112, '2015-04-01 00:07:33.000000', 'temperatura', 185.0000, 'ºC'),
	(137455, 112, '2015-04-01 00:07:34.000000', 'temperatura', 370.0000, 'ºC'),
	(137456, 112, '2015-04-01 00:07:35.000000', 'temperatura', 96.0000, 'ºC'),
	(137457, 112, '2015-04-01 00:07:36.000000', 'temperatura', 571.0000, 'ºC'),
	(137458, 112, '2015-04-01 00:07:37.000000', 'temperatura', 165.0000, 'ºC'),
	(137459, 112, '2015-04-01 00:07:38.000000', 'temperatura', 312.0000, 'ºC'),
	(137460, 112, '2015-04-01 00:07:39.000000', 'temperatura', 1068.0000, 'ºC'),
	(137461, 112, '2015-04-01 00:07:40.000000', 'temperatura', 804.0000, 'ºC'),
	(137462, 112, '2015-04-01 00:07:41.000000', 'temperatura', 814.0000, 'ºC'),
	(137463, 112, '2015-04-01 00:07:42.000000', 'temperatura', 460.0000, 'ºC'),
	(137464, 112, '2015-04-01 00:07:43.000000', 'temperatura', 1059.0000, 'ºC'),
	(137465, 112, '2015-04-01 00:07:44.000000', 'temperatura', 315.0000, 'ºC'),
	(137466, 112, '2015-04-01 00:07:45.000000', 'temperatura', 799.0000, 'ºC'),
	(137467, 112, '2015-04-01 00:07:46.000000', 'temperatura', 652.0000, 'ºC'),
	(137468, 112, '2015-04-01 00:07:47.000000', 'temperatura', 861.0000, 'ºC'),
	(137469, 112, '2015-04-01 00:07:48.000000', 'temperatura', 1150.0000, 'ºC'),
	(137470, 112, '2015-04-01 00:07:49.000000', 'temperatura', 768.0000, 'ºC'),
	(137471, 112, '2015-04-01 00:07:50.000000', 'temperatura', 391.0000, 'ºC'),
	(137472, 112, '2015-04-01 00:07:51.000000', 'temperatura', 850.0000, 'ºC'),
	(137473, 112, '2015-04-01 00:07:52.000000', 'temperatura', 679.0000, 'ºC'),
	(137474, 112, '2015-04-01 00:07:53.000000', 'temperatura', 844.0000, 'ºC'),
	(137475, 112, '2015-04-01 00:07:54.000000', 'temperatura', 982.0000, 'ºC'),
	(137476, 112, '2015-04-01 00:07:55.000000', 'temperatura', 1181.0000, 'ºC'),
	(137477, 112, '2015-04-01 00:07:56.000000', 'temperatura', 557.0000, 'ºC'),
	(137478, 112, '2015-04-01 00:07:57.000000', 'temperatura', 443.0000, 'ºC'),
	(137479, 112, '2015-04-01 00:07:58.000000', 'temperatura', 543.0000, 'ºC'),
	(137480, 112, '2015-04-01 00:07:59.000000', 'temperatura', 188.0000, 'ºC'),
	(137481, 112, '2015-04-01 00:08:00.000000', 'temperatura', 513.0000, 'ºC'),
	(137482, 112, '2015-04-01 00:08:01.000000', 'temperatura', 801.0000, 'ºC'),
	(137483, 112, '2015-04-01 00:08:02.000000', 'temperatura', 67.0000, 'ºC'),
	(137484, 112, '2015-04-01 00:08:03.000000', 'temperatura', 330.0000, 'ºC'),
	(137485, 112, '2015-04-01 00:08:04.000000', 'temperatura', 252.0000, 'ºC'),
	(137486, 112, '2015-04-01 00:08:05.000000', 'temperatura', 268.0000, 'ºC'),
	(137487, 112, '2015-04-01 00:08:06.000000', 'temperatura', 585.0000, 'ºC'),
	(137488, 112, '2015-04-01 00:08:07.000000', 'temperatura', 922.0000, 'ºC'),
	(137489, 112, '2015-04-01 00:08:08.000000', 'temperatura', 454.0000, 'ºC'),
	(137490, 112, '2015-04-01 00:08:09.000000', 'temperatura', 705.0000, 'ºC'),
	(137491, 112, '2015-04-01 00:08:10.000000', 'temperatura', 962.0000, 'ºC'),
	(137492, 112, '2015-04-01 00:08:11.000000', 'temperatura', 296.0000, 'ºC'),
	(137493, 112, '2015-04-01 00:08:12.000000', 'temperatura', 995.0000, 'ºC'),
	(137494, 112, '2015-04-01 00:08:13.000000', 'temperatura', 488.0000, 'ºC'),
	(137495, 112, '2015-04-01 00:08:14.000000', 'temperatura', 655.0000, 'ºC'),
	(137496, 112, '2015-04-01 00:08:15.000000', 'temperatura', 611.0000, 'ºC'),
	(137497, 112, '2015-04-01 00:08:16.000000', 'temperatura', 1089.0000, 'ºC'),
	(137498, 112, '2015-04-01 00:08:17.000000', 'temperatura', 15.0000, 'ºC'),
	(137499, 112, '2015-04-01 00:08:18.000000', 'temperatura', 407.0000, 'ºC'),
	(137500, 112, '2015-04-01 00:08:19.000000', 'temperatura', 792.0000, 'ºC'),
	(137501, 112, '2015-04-01 00:08:20.000000', 'temperatura', 340.0000, 'ºC'),
	(137502, 112, '2015-04-01 00:08:21.000000', 'temperatura', 525.0000, 'ºC'),
	(137503, 112, '2015-04-01 00:08:22.000000', 'temperatura', 405.0000, 'ºC'),
	(137504, 112, '2015-04-01 00:08:23.000000', 'temperatura', 448.0000, 'ºC'),
	(137505, 112, '2015-04-01 00:08:24.000000', 'temperatura', 1028.0000, 'ºC'),
	(137506, 112, '2015-04-01 00:08:25.000000', 'temperatura', 197.0000, 'ºC'),
	(137507, 112, '2015-04-01 00:08:26.000000', 'temperatura', 302.0000, 'ºC'),
	(137508, 112, '2015-04-01 00:08:27.000000', 'temperatura', 918.0000, 'ºC'),
	(137509, 112, '2015-04-01 00:08:28.000000', 'temperatura', 83.0000, 'ºC'),
	(137510, 112, '2015-04-01 00:08:29.000000', 'temperatura', 62.0000, 'ºC'),
	(137511, 112, '2015-04-01 00:08:30.000000', 'temperatura', 62.0000, 'ºC'),
	(137512, 112, '2015-04-01 00:08:31.000000', 'temperatura', 124.0000, 'ºC'),
	(137513, 112, '2015-04-01 00:08:32.000000', 'temperatura', 435.0000, 'ºC'),
	(137514, 112, '2015-04-01 00:08:33.000000', 'temperatura', 605.0000, 'ºC'),
	(137515, 112, '2015-04-01 00:08:34.000000', 'temperatura', 519.0000, 'ºC'),
	(137516, 112, '2015-04-01 00:08:35.000000', 'temperatura', 780.0000, 'ºC'),
	(137517, 112, '2015-04-01 00:08:36.000000', 'temperatura', 1143.0000, 'ºC'),
	(137518, 112, '2015-04-01 00:08:37.000000', 'temperatura', 975.0000, 'ºC'),
	(137519, 112, '2015-04-01 00:08:38.000000', 'temperatura', 246.0000, 'ºC'),
	(137520, 112, '2015-04-01 00:08:39.000000', 'temperatura', 706.0000, 'ºC'),
	(137521, 112, '2015-04-01 00:08:40.000000', 'temperatura', 393.0000, 'ºC'),
	(137522, 112, '2015-04-01 00:08:41.000000', 'temperatura', 1046.0000, 'ºC'),
	(137523, 112, '2015-04-01 00:08:42.000000', 'temperatura', 451.0000, 'ºC'),
	(137524, 112, '2015-04-01 00:08:43.000000', 'temperatura', 320.0000, 'ºC'),
	(137525, 112, '2015-04-01 00:08:44.000000', 'temperatura', 245.0000, 'ºC'),
	(137526, 112, '2015-04-01 00:08:45.000000', 'temperatura', 269.0000, 'ºC'),
	(137527, 112, '2015-04-01 00:08:46.000000', 'temperatura', 607.0000, 'ºC'),
	(137528, 112, '2015-04-01 00:08:47.000000', 'temperatura', 1030.0000, 'ºC'),
	(137529, 112, '2015-04-01 00:08:48.000000', 'temperatura', 930.0000, 'ºC'),
	(137530, 112, '2015-04-01 00:08:49.000000', 'temperatura', 362.0000, 'ºC'),
	(137531, 112, '2015-04-01 00:08:50.000000', 'temperatura', 220.0000, 'ºC'),
	(137532, 112, '2015-04-01 00:08:51.000000', 'temperatura', 13.0000, 'ºC'),
	(137533, 112, '2015-04-01 00:08:52.000000', 'temperatura', 604.0000, 'ºC'),
	(137534, 112, '2015-04-01 00:08:53.000000', 'temperatura', 583.0000, 'ºC'),
	(137535, 112, '2015-04-01 00:08:54.000000', 'temperatura', 1103.0000, 'ºC'),
	(137536, 112, '2015-04-01 00:08:55.000000', 'temperatura', 167.0000, 'ºC'),
	(137537, 112, '2015-04-01 00:08:56.000000', 'temperatura', 1125.0000, 'ºC'),
	(137538, 112, '2015-04-01 00:08:57.000000', 'temperatura', 324.0000, 'ºC'),
	(137539, 112, '2015-04-01 00:08:58.000000', 'temperatura', 648.0000, 'ºC'),
	(137540, 112, '2015-04-01 00:08:59.000000', 'temperatura', 1069.0000, 'ºC'),
	(137541, 112, '2015-04-01 00:09:00.000000', 'temperatura', 1002.0000, 'ºC'),
	(137542, 112, '2015-04-01 00:09:01.000000', 'temperatura', 604.0000, 'ºC'),
	(137543, 112, '2015-04-01 00:09:02.000000', 'temperatura', 14.0000, 'ºC'),
	(137544, 112, '2015-04-01 00:09:03.000000', 'temperatura', 660.0000, 'ºC'),
	(137545, 112, '2015-04-01 00:09:04.000000', 'temperatura', 856.0000, 'ºC'),
	(137546, 112, '2015-04-01 00:09:05.000000', 'temperatura', 1102.0000, 'ºC'),
	(137547, 112, '2015-04-01 00:09:06.000000', 'temperatura', 543.0000, 'ºC'),
	(137548, 112, '2015-04-01 00:09:07.000000', 'temperatura', 608.0000, 'ºC'),
	(137549, 112, '2015-04-01 00:09:08.000000', 'temperatura', 213.0000, 'ºC'),
	(137550, 112, '2015-04-01 00:09:09.000000', 'temperatura', 442.0000, 'ºC'),
	(137551, 112, '2015-04-01 00:09:10.000000', 'temperatura', 370.0000, 'ºC'),
	(137552, 112, '2015-04-01 00:09:11.000000', 'temperatura', 526.0000, 'ºC'),
	(137553, 112, '2015-04-01 00:09:12.000000', 'temperatura', 318.0000, 'ºC'),
	(137554, 112, '2015-04-01 00:09:13.000000', 'temperatura', 15.0000, 'ºC'),
	(137555, 112, '2015-04-01 00:09:14.000000', 'temperatura', 321.0000, 'ºC'),
	(137556, 112, '2015-04-01 00:09:15.000000', 'temperatura', 361.0000, 'ºC'),
	(137557, 112, '2015-04-01 00:09:16.000000', 'temperatura', 843.0000, 'ºC'),
	(137558, 112, '2015-04-01 00:09:17.000000', 'temperatura', 733.0000, 'ºC'),
	(137559, 112, '2015-04-01 00:09:18.000000', 'temperatura', 1136.0000, 'ºC'),
	(137560, 112, '2015-04-01 00:09:19.000000', 'temperatura', 1080.0000, 'ºC'),
	(137561, 112, '2015-04-01 00:09:20.000000', 'temperatura', 795.0000, 'ºC'),
	(137562, 112, '2015-04-01 00:09:21.000000', 'temperatura', 735.0000, 'ºC'),
	(137563, 112, '2015-04-01 00:09:22.000000', 'temperatura', 89.0000, 'ºC'),
	(137564, 112, '2015-04-01 00:09:23.000000', 'temperatura', 643.0000, 'ºC'),
	(137565, 112, '2015-04-01 00:09:24.000000', 'temperatura', 546.0000, 'ºC'),
	(137566, 112, '2015-04-01 00:09:25.000000', 'temperatura', 801.0000, 'ºC'),
	(137567, 112, '2015-04-01 00:09:26.000000', 'temperatura', 1169.0000, 'ºC'),
	(137568, 112, '2015-04-01 00:09:27.000000', 'temperatura', 1040.0000, 'ºC'),
	(137569, 112, '2015-04-01 00:09:28.000000', 'temperatura', 496.0000, 'ºC'),
	(137570, 112, '2015-04-01 00:09:29.000000', 'temperatura', 559.0000, 'ºC'),
	(137571, 112, '2015-04-01 00:09:30.000000', 'temperatura', 110.0000, 'ºC'),
	(137572, 112, '2015-04-01 00:09:31.000000', 'temperatura', 73.0000, 'ºC'),
	(137573, 112, '2015-04-01 00:09:32.000000', 'temperatura', 33.0000, 'ºC'),
	(137574, 112, '2015-04-01 00:09:33.000000', 'temperatura', 1149.0000, 'ºC'),
	(137575, 112, '2015-04-01 00:09:34.000000', 'temperatura', 846.0000, 'ºC'),
	(137576, 112, '2015-04-01 00:09:35.000000', 'temperatura', 783.0000, 'ºC'),
	(137577, 112, '2015-04-01 00:09:36.000000', 'temperatura', 176.0000, 'ºC'),
	(137578, 112, '2015-04-01 00:09:37.000000', 'temperatura', 933.0000, 'ºC'),
	(137579, 112, '2015-04-01 00:09:38.000000', 'temperatura', 537.0000, 'ºC'),
	(137580, 112, '2015-04-01 00:09:39.000000', 'temperatura', 1087.0000, 'ºC'),
	(137581, 112, '2015-04-01 00:09:40.000000', 'temperatura', 223.0000, 'ºC'),
	(137582, 112, '2015-04-01 00:09:41.000000', 'temperatura', 255.0000, 'ºC'),
	(137583, 112, '2015-04-01 00:09:42.000000', 'temperatura', 606.0000, 'ºC'),
	(137584, 112, '2015-04-01 00:09:43.000000', 'temperatura', 1065.0000, 'ºC'),
	(137585, 112, '2015-04-01 00:09:44.000000', 'temperatura', 1110.0000, 'ºC'),
	(137586, 112, '2015-04-01 00:09:45.000000', 'temperatura', 1155.0000, 'ºC'),
	(137587, 112, '2015-04-01 00:09:46.000000', 'temperatura', 47.0000, 'ºC'),
	(137588, 112, '2015-04-01 00:09:47.000000', 'temperatura', 367.0000, 'ºC'),
	(137589, 112, '2015-04-01 00:09:48.000000', 'temperatura', 496.0000, 'ºC'),
	(137590, 112, '2015-04-01 00:09:49.000000', 'temperatura', 180.0000, 'ºC'),
	(137591, 112, '2015-04-01 00:09:50.000000', 'temperatura', 611.0000, 'ºC'),
	(137592, 112, '2015-04-01 00:09:51.000000', 'temperatura', 115.0000, 'ºC'),
	(137593, 112, '2015-04-01 00:09:52.000000', 'temperatura', 1145.0000, 'ºC'),
	(137594, 112, '2015-04-01 00:09:53.000000', 'temperatura', 580.0000, 'ºC'),
	(137595, 112, '2015-04-01 00:09:54.000000', 'temperatura', 664.0000, 'ºC'),
	(137596, 112, '2015-04-01 00:09:55.000000', 'temperatura', 381.0000, 'ºC'),
	(137597, 112, '2015-04-01 00:09:56.000000', 'temperatura', 1112.0000, 'ºC'),
	(137598, 112, '2015-04-01 00:09:57.000000', 'temperatura', 818.0000, 'ºC'),
	(137599, 112, '2015-04-01 00:09:58.000000', 'temperatura', 756.0000, 'ºC'),
	(137600, 112, '2015-04-01 00:09:59.000000', 'temperatura', 127.0000, 'ºC'),
	(137601, 112, '2015-04-01 00:10:00.000000', 'temperatura', 766.0000, 'ºC'),
	(137602, 112, '2015-04-01 00:10:01.000000', 'temperatura', 1052.0000, 'ºC'),
	(137603, 112, '2015-04-01 00:10:02.000000', 'temperatura', 560.0000, 'ºC'),
	(137604, 112, '2015-04-01 00:10:03.000000', 'temperatura', 845.0000, 'ºC'),
	(137605, 112, '2015-04-01 00:10:04.000000', 'temperatura', 144.0000, 'ºC'),
	(137606, 112, '2015-04-01 00:10:05.000000', 'temperatura', 588.0000, 'ºC'),
	(137607, 112, '2015-04-01 00:10:06.000000', 'temperatura', 108.0000, 'ºC'),
	(137608, 112, '2015-04-01 00:10:07.000000', 'temperatura', 1178.0000, 'ºC'),
	(137609, 112, '2015-04-01 00:10:08.000000', 'temperatura', 766.0000, 'ºC'),
	(137610, 112, '2015-04-01 00:10:09.000000', 'temperatura', 296.0000, 'ºC'),
	(137611, 112, '2015-04-01 00:10:10.000000', 'temperatura', 380.0000, 'ºC'),
	(137612, 112, '2015-04-01 00:10:11.000000', 'temperatura', 1016.0000, 'ºC'),
	(137613, 112, '2015-04-01 00:10:12.000000', 'temperatura', 340.0000, 'ºC'),
	(137614, 112, '2015-04-01 00:10:13.000000', 'temperatura', 1052.0000, 'ºC'),
	(137615, 112, '2015-04-01 00:10:14.000000', 'temperatura', 641.0000, 'ºC'),
	(137616, 112, '2015-04-01 00:10:15.000000', 'temperatura', 47.0000, 'ºC'),
	(137617, 112, '2015-04-01 00:10:16.000000', 'temperatura', 714.0000, 'ºC'),
	(137618, 112, '2015-04-01 00:10:17.000000', 'temperatura', 1030.0000, 'ºC'),
	(137619, 112, '2015-04-01 00:10:18.000000', 'temperatura', 606.0000, 'ºC'),
	(137620, 112, '2015-04-01 00:10:19.000000', 'temperatura', 1143.0000, 'ºC'),
	(137621, 112, '2015-04-01 00:10:20.000000', 'temperatura', 296.0000, 'ºC'),
	(137622, 112, '2015-04-01 00:10:21.000000', 'temperatura', 450.0000, 'ºC'),
	(137623, 112, '2015-04-01 00:10:22.000000', 'temperatura', 164.0000, 'ºC'),
	(137624, 112, '2015-04-01 00:10:23.000000', 'temperatura', 670.0000, 'ºC'),
	(137625, 112, '2015-04-01 00:10:24.000000', 'temperatura', 458.0000, 'ºC'),
	(137626, 112, '2015-04-01 00:10:25.000000', 'temperatura', 282.0000, 'ºC'),
	(137627, 112, '2015-04-01 00:10:26.000000', 'temperatura', 37.0000, 'ºC'),
	(137628, 112, '2015-04-01 00:10:27.000000', 'temperatura', 537.0000, 'ºC'),
	(137629, 112, '2015-04-01 00:10:28.000000', 'temperatura', 175.0000, 'ºC'),
	(137630, 112, '2015-04-01 00:10:29.000000', 'temperatura', 466.0000, 'ºC'),
	(137631, 112, '2015-04-01 00:10:30.000000', 'temperatura', 606.0000, 'ºC'),
	(137632, 112, '2015-04-01 00:10:31.000000', 'temperatura', 430.0000, 'ºC'),
	(137633, 112, '2015-04-01 00:10:32.000000', 'temperatura', 332.0000, 'ºC'),
	(137634, 112, '2015-04-01 00:10:33.000000', 'temperatura', 370.0000, 'ºC'),
	(137635, 112, '2015-04-01 00:10:34.000000', 'temperatura', 854.0000, 'ºC'),
	(137636, 112, '2015-04-01 00:10:35.000000', 'temperatura', 761.0000, 'ºC'),
	(137637, 112, '2015-04-01 00:10:36.000000', 'temperatura', 43.0000, 'ºC'),
	(137638, 112, '2015-04-01 00:10:37.000000', 'temperatura', 334.0000, 'ºC'),
	(137639, 112, '2015-04-01 00:10:38.000000', 'temperatura', 339.0000, 'ºC'),
	(137640, 112, '2015-04-01 00:10:39.000000', 'temperatura', 696.0000, 'ºC'),
	(137641, 112, '2015-04-01 00:10:40.000000', 'temperatura', 65.0000, 'ºC'),
	(137642, 112, '2015-04-01 00:10:41.000000', 'temperatura', 635.0000, 'ºC'),
	(137643, 112, '2015-04-01 00:10:42.000000', 'temperatura', 581.0000, 'ºC'),
	(137644, 112, '2015-04-01 00:10:43.000000', 'temperatura', 1001.0000, 'ºC'),
	(137645, 112, '2015-04-01 00:10:44.000000', 'temperatura', 863.0000, 'ºC'),
	(137646, 112, '2015-04-01 00:10:45.000000', 'temperatura', 112.0000, 'ºC'),
	(137647, 112, '2015-04-01 00:10:46.000000', 'temperatura', 370.0000, 'ºC'),
	(137648, 112, '2015-04-01 00:10:47.000000', 'temperatura', 318.0000, 'ºC'),
	(137649, 112, '2015-04-01 00:10:48.000000', 'temperatura', 477.0000, 'ºC'),
	(137650, 112, '2015-04-01 00:10:49.000000', 'temperatura', 231.0000, 'ºC'),
	(137651, 112, '2015-04-01 00:10:50.000000', 'temperatura', 926.0000, 'ºC'),
	(137652, 112, '2015-04-01 00:10:51.000000', 'temperatura', 339.0000, 'ºC'),
	(137653, 112, '2015-04-01 00:10:52.000000', 'temperatura', 116.0000, 'ºC'),
	(137654, 112, '2015-04-01 00:10:53.000000', 'temperatura', 763.0000, 'ºC'),
	(137655, 112, '2015-04-01 00:10:54.000000', 'temperatura', 1068.0000, 'ºC'),
	(137656, 112, '2015-04-01 00:10:55.000000', 'temperatura', 651.0000, 'ºC'),
	(137657, 112, '2015-04-01 00:10:56.000000', 'temperatura', 53.0000, 'ºC'),
	(137658, 112, '2015-04-01 00:10:57.000000', 'temperatura', 713.0000, 'ºC'),
	(137659, 112, '2015-04-01 00:10:58.000000', 'temperatura', 1005.0000, 'ºC'),
	(137660, 112, '2015-04-01 00:10:59.000000', 'temperatura', 485.0000, 'ºC'),
	(137661, 112, '2015-04-01 00:11:00.000000', 'temperatura', 613.0000, 'ºC'),
	(137662, 112, '2015-04-01 00:11:01.000000', 'temperatura', 409.0000, 'ºC'),
	(137663, 112, '2015-04-01 00:11:02.000000', 'temperatura', 205.0000, 'ºC'),
	(137664, 112, '2015-04-01 00:11:03.000000', 'temperatura', 999.0000, 'ºC'),
	(137665, 112, '2015-04-01 00:11:04.000000', 'temperatura', 782.0000, 'ºC'),
	(137666, 112, '2015-04-01 00:11:05.000000', 'temperatura', 913.0000, 'ºC'),
	(137667, 112, '2015-04-01 00:11:06.000000', 'temperatura', 1018.0000, 'ºC'),
	(137668, 112, '2015-04-01 00:11:07.000000', 'temperatura', 1153.0000, 'ºC'),
	(137669, 112, '2015-04-01 00:11:08.000000', 'temperatura', 312.0000, 'ºC'),
	(137670, 112, '2015-04-01 00:11:09.000000', 'temperatura', 501.0000, 'ºC'),
	(137671, 112, '2015-04-01 00:11:10.000000', 'temperatura', 371.0000, 'ºC'),
	(137672, 112, '2015-04-01 00:11:11.000000', 'temperatura', 352.0000, 'ºC'),
	(137673, 112, '2015-04-01 00:11:12.000000', 'temperatura', 649.0000, 'ºC'),
	(137674, 112, '2015-04-01 00:11:13.000000', 'temperatura', 988.0000, 'ºC'),
	(137675, 112, '2015-04-01 00:11:14.000000', 'temperatura', 593.0000, 'ºC'),
	(137676, 112, '2015-04-01 00:11:15.000000', 'temperatura', 2.0000, 'ºC'),
	(137677, 112, '2015-04-01 00:11:16.000000', 'temperatura', 633.0000, 'ºC'),
	(137678, 112, '2015-04-01 00:11:17.000000', 'temperatura', 757.0000, 'ºC'),
	(137679, 112, '2015-04-01 00:11:18.000000', 'temperatura', 690.0000, 'ºC'),
	(137680, 112, '2015-04-01 00:11:19.000000', 'temperatura', 1176.0000, 'ºC'),
	(137681, 112, '2015-04-01 00:11:20.000000', 'temperatura', 210.0000, 'ºC'),
	(137682, 112, '2015-04-01 00:11:21.000000', 'temperatura', 1125.0000, 'ºC'),
	(137683, 112, '2015-04-01 00:11:22.000000', 'temperatura', 196.0000, 'ºC'),
	(137684, 112, '2015-04-01 00:11:23.000000', 'temperatura', 4.0000, 'ºC'),
	(137685, 112, '2015-04-01 00:11:24.000000', 'temperatura', 635.0000, 'ºC'),
	(137686, 112, '2015-04-01 00:11:25.000000', 'temperatura', 762.0000, 'ºC'),
	(137687, 112, '2015-04-01 00:11:26.000000', 'temperatura', 705.0000, 'ºC'),
	(137688, 112, '2015-04-01 00:11:27.000000', 'temperatura', 39.0000, 'ºC'),
	(137689, 112, '2015-04-01 00:11:28.000000', 'temperatura', 483.0000, 'ºC'),
	(137690, 112, '2015-04-01 00:11:29.000000', 'temperatura', 1097.0000, 'ºC'),
	(137691, 112, '2015-04-01 00:11:30.000000', 'temperatura', 436.0000, 'ºC'),
	(137692, 112, '2015-04-01 00:11:31.000000', 'temperatura', 91.0000, 'ºC'),
	(137693, 112, '2015-04-01 00:11:32.000000', 'temperatura', 346.0000, 'ºC'),
	(137694, 112, '2015-04-01 00:11:33.000000', 'temperatura', 259.0000, 'ºC'),
	(137695, 112, '2015-04-01 00:11:34.000000', 'temperatura', 257.0000, 'ºC'),
	(137696, 112, '2015-04-01 00:11:35.000000', 'temperatura', 507.0000, 'ºC'),
	(137697, 112, '2015-04-01 00:11:36.000000', 'temperatura', 567.0000, 'ºC'),
	(137698, 112, '2015-04-01 00:11:37.000000', 'temperatura', 112.0000, 'ºC'),
	(137699, 112, '2015-04-01 00:11:38.000000', 'temperatura', 59.0000, 'ºC'),
	(137700, 112, '2015-04-01 00:11:39.000000', 'temperatura', 1163.0000, 'ºC'),
	(137701, 112, '2015-04-01 00:11:40.000000', 'temperatura', 835.0000, 'ºC'),
	(137702, 112, '2015-04-01 00:11:41.000000', 'temperatura', 687.0000, 'ºC'),
	(137703, 112, '2015-04-01 00:11:42.000000', 'temperatura', 932.0000, 'ºC'),
	(137704, 112, '2015-04-01 00:11:43.000000', 'temperatura', 198.0000, 'ºC'),
	(137705, 112, '2015-04-01 00:11:44.000000', 'temperatura', 597.0000, 'ºC'),
	(137706, 112, '2015-04-01 00:11:45.000000', 'temperatura', 1190.0000, 'ºC'),
	(137707, 112, '2015-04-01 00:11:46.000000', 'temperatura', 561.0000, 'ºC'),
	(137708, 112, '2015-04-01 00:11:47.000000', 'temperatura', 437.0000, 'ºC'),
	(137709, 112, '2015-04-01 00:11:48.000000', 'temperatura', 499.0000, 'ºC'),
	(137710, 112, '2015-04-01 00:11:49.000000', 'temperatura', 1187.0000, 'ºC'),
	(137711, 112, '2015-04-01 00:11:50.000000', 'temperatura', 837.0000, 'ºC'),
	(137712, 112, '2015-04-01 00:11:51.000000', 'temperatura', 626.0000, 'ºC'),
	(137713, 112, '2015-04-01 00:11:52.000000', 'temperatura', 620.0000, 'ºC'),
	(137714, 112, '2015-04-01 00:11:53.000000', 'temperatura', 21.0000, 'ºC'),
	(137715, 112, '2015-04-01 00:11:54.000000', 'temperatura', 646.0000, 'ºC'),
	(137716, 112, '2015-04-01 00:11:55.000000', 'temperatura', 766.0000, 'ºC'),
	(137717, 112, '2015-04-01 00:11:56.000000', 'temperatura', 692.0000, 'ºC'),
	(137718, 112, '2015-04-01 00:11:57.000000', 'temperatura', 1165.0000, 'ºC'),
	(137719, 112, '2015-04-01 00:11:58.000000', 'temperatura', 147.0000, 'ºC'),
	(137720, 112, '2015-04-01 00:11:59.000000', 'temperatura', 840.0000, 'ºC'),
	(137721, 112, '2015-04-01 00:12:00.000000', 'temperatura', 161.0000, 'ºC'),
	(137722, 112, '2015-04-01 00:12:01.000000', 'temperatura', 683.0000, 'ºC'),
	(137723, 112, '2015-04-01 00:12:02.000000', 'temperatura', 536.0000, 'ºC'),
	(137724, 112, '2015-04-01 00:12:03.000000', 'temperatura', 629.0000, 'ºC'),
	(137725, 112, '2015-04-01 00:12:04.000000', 'temperatura', 339.0000, 'ºC'),
	(137726, 112, '2015-04-01 00:12:05.000000', 'temperatura', 1009.0000, 'ºC'),
	(137727, 112, '2015-04-01 00:12:06.000000', 'temperatura', 428.0000, 'ºC'),
	(137728, 112, '2015-04-01 00:12:07.000000', 'temperatura', 314.0000, 'ºC'),
	(137729, 112, '2015-04-01 00:12:08.000000', 'temperatura', 284.0000, 'ºC'),
	(137730, 112, '2015-04-01 00:12:09.000000', 'temperatura', 482.0000, 'ºC'),
	(137731, 112, '2015-04-01 00:12:10.000000', 'temperatura', 355.0000, 'ºC'),
	(137732, 112, '2015-04-01 00:12:11.000000', 'temperatura', 333.0000, 'ºC'),
	(137733, 112, '2015-04-01 00:12:12.000000', 'temperatura', 598.0000, 'ºC'),
	(137734, 112, '2015-04-01 00:12:13.000000', 'temperatura', 791.0000, 'ºC'),
	(137735, 112, '2015-04-01 00:12:14.000000', 'temperatura', 963.0000, 'ºC'),
	(137736, 112, '2015-04-01 00:12:15.000000', 'temperatura', 41.0000, 'ºC'),
	(137737, 112, '2015-04-01 00:12:16.000000', 'temperatura', 918.0000, 'ºC'),
	(137738, 112, '2015-04-01 00:12:17.000000', 'temperatura', 866.0000, 'ºC'),
	(137739, 112, '2015-04-01 00:12:18.000000', 'temperatura', 378.0000, 'ºC'),
	(137740, 112, '2015-04-01 00:12:19.000000', 'temperatura', 493.0000, 'ºC'),
	(137741, 112, '2015-04-01 00:12:20.000000', 'temperatura', 130.0000, 'ºC'),
	(137742, 112, '2015-04-01 00:12:21.000000', 'temperatura', 372.0000, 'ºC'),
	(137743, 112, '2015-04-01 00:12:22.000000', 'temperatura', 270.0000, 'ºC'),
	(137744, 112, '2015-04-01 00:12:23.000000', 'temperatura', 236.0000, 'ºC'),
	(137745, 112, '2015-04-01 00:12:24.000000', 'temperatura', 370.0000, 'ºC'),
	(137746, 112, '2015-04-01 00:12:25.000000', 'temperatura', 1140.0000, 'ºC'),
	(137747, 112, '2015-04-01 00:12:26.000000', 'temperatura', 994.0000, 'ºC'),
	(137748, 112, '2015-04-01 00:12:27.000000', 'temperatura', 349.0000, 'ºC'),
	(137749, 112, '2015-04-01 00:12:28.000000', 'temperatura', 1162.0000, 'ºC'),
	(137750, 112, '2015-04-01 00:12:29.000000', 'temperatura', 1165.0000, 'ºC'),
	(137751, 112, '2015-04-01 00:12:30.000000', 'temperatura', 1137.0000, 'ºC'),
	(137752, 112, '2015-04-01 00:12:31.000000', 'temperatura', 994.0000, 'ºC'),
	(137753, 112, '2015-04-01 00:12:32.000000', 'temperatura', 357.0000, 'ºC'),
	(137754, 112, '2015-04-01 00:12:33.000000', 'temperatura', 4.0000, 'ºC'),
	(137755, 112, '2015-04-01 00:12:34.000000', 'temperatura', 150.0000, 'ºC'),
	(137756, 112, '2015-04-01 00:12:35.000000', 'temperatura', 738.0000, 'ºC'),
	(137757, 112, '2015-04-01 00:12:36.000000', 'temperatura', 841.0000, 'ºC'),
	(137758, 112, '2015-04-01 00:12:37.000000', 'temperatura', 791.0000, 'ºC'),
	(137759, 112, '2015-04-01 00:12:38.000000', 'temperatura', 234.0000, 'ºC'),
	(137760, 112, '2015-04-01 00:12:39.000000', 'temperatura', 1197.0000, 'ºC'),
	(137761, 112, '2015-04-01 00:12:40.000000', 'temperatura', 483.0000, 'ºC'),
	(137762, 112, '2015-04-01 00:12:41.000000', 'temperatura', 24.0000, 'ºC'),
	(137763, 112, '2015-04-01 00:12:42.000000', 'temperatura', 1072.0000, 'ºC'),
	(137764, 112, '2015-04-01 00:12:43.000000', 'temperatura', 490.0000, 'ºC'),
	(137765, 112, '2015-04-01 00:12:44.000000', 'temperatura', 434.0000, 'ºC'),
	(137766, 112, '2015-04-01 00:12:45.000000', 'temperatura', 700.0000, 'ºC'),
	(137767, 112, '2015-04-01 00:12:46.000000', 'temperatura', 998.0000, 'ºC'),
	(137768, 112, '2015-04-01 00:12:47.000000', 'temperatura', 490.0000, 'ºC'),
	(137769, 112, '2015-04-01 00:12:48.000000', 'temperatura', 659.0000, 'ºC'),
	(137770, 112, '2015-04-01 00:12:49.000000', 'temperatura', 625.0000, 'ºC'),
	(137771, 112, '2015-04-01 00:12:50.000000', 'temperatura', 1148.0000, 'ºC'),
	(137772, 112, '2015-04-01 00:12:51.000000', 'temperatura', 267.0000, 'ºC'),
	(137773, 112, '2015-04-01 00:12:52.000000', 'temperatura', 292.0000, 'ºC'),
	(137774, 112, '2015-04-01 00:12:53.000000', 'temperatura', 658.0000, 'ºC'),
	(137775, 112, '2015-04-01 00:12:54.000000', 'temperatura', 15.0000, 'ºC'),
	(137776, 112, '2015-04-01 00:12:55.000000', 'temperatura', 503.0000, 'ºC'),
	(137777, 112, '2015-04-01 00:12:56.000000', 'temperatura', 71.0000, 'ºC'),
	(137778, 112, '2015-04-01 00:12:57.000000', 'temperatura', 47.0000, 'ºC'),
	(137779, 112, '2015-04-01 00:12:58.000000', 'temperatura', 22.0000, 'ºC'),
	(137780, 112, '2015-04-01 00:12:59.000000', 'temperatura', 1167.0000, 'ºC'),
	(137781, 112, '2015-04-01 00:13:00.000000', 'temperatura', 971.0000, 'ºC'),
	(137782, 112, '2015-04-01 00:13:01.000000', 'temperatura', 153.0000, 'ºC'),
	(137783, 112, '2015-04-01 00:13:02.000000', 'temperatura', 255.0000, 'ºC'),
	(137784, 112, '2015-04-01 00:13:03.000000', 'temperatura', 815.0000, 'ºC'),
	(137785, 112, '2015-04-01 00:13:04.000000', 'temperatura', 910.0000, 'ºC'),
	(137786, 112, '2015-04-01 00:13:05.000000', 'temperatura', 908.0000, 'ºC'),
	(137787, 112, '2015-04-01 00:13:06.000000', 'temperatura', 610.0000, 'ºC'),
	(137788, 112, '2015-04-01 00:13:07.000000', 'temperatura', 324.0000, 'ºC'),
	(137789, 112, '2015-04-01 00:13:08.000000', 'temperatura', 992.0000, 'ºC'),
	(137790, 112, '2015-04-01 00:13:09.000000', 'temperatura', 389.0000, 'ºC'),
	(137791, 112, '2015-04-01 00:13:10.000000', 'temperatura', 168.0000, 'ºC'),
	(137792, 112, '2015-04-01 00:13:11.000000', 'temperatura', 876.0000, 'ºC'),
	(137793, 112, '2015-04-01 00:13:12.000000', 'temperatura', 275.0000, 'ºC'),
	(137794, 112, '2015-04-01 00:13:13.000000', 'temperatura', 1147.0000, 'ºC'),
	(137795, 112, '2015-04-01 00:13:14.000000', 'temperatura', 112.0000, 'ºC'),
	(137796, 112, '2015-04-01 00:13:15.000000', 'temperatura', 717.0000, 'ºC'),
	(137797, 112, '2015-04-01 00:13:16.000000', 'temperatura', 851.0000, 'ºC'),
	(137798, 112, '2015-04-01 00:13:17.000000', 'temperatura', 904.0000, 'ºC'),
	(137799, 112, '2015-04-01 00:13:18.000000', 'temperatura', 768.0000, 'ºC'),
	(137800, 112, '2015-04-01 00:13:19.000000', 'temperatura', 1130.0000, 'ºC'),
	(137801, 112, '2015-04-01 00:13:20.000000', 'temperatura', 946.0000, 'ºC'),
	(137802, 112, '2015-04-01 00:13:21.000000', 'temperatura', 142.0000, 'ºC'),
	(137803, 112, '2015-04-01 00:13:22.000000', 'temperatura', 272.0000, 'ºC'),
	(137804, 112, '2015-04-01 00:13:23.000000', 'temperatura', 933.0000, 'ºC'),
	(137805, 112, '2015-04-01 00:13:24.000000', 'temperatura', 251.0000, 'ºC'),
	(137806, 112, '2015-04-01 00:13:25.000000', 'temperatura', 854.0000, 'ºC'),
	(137807, 112, '2015-04-01 00:13:26.000000', 'temperatura', 1121.0000, 'ºC'),
	(137808, 112, '2015-04-01 00:13:27.000000', 'temperatura', 640.0000, 'ºC'),
	(137809, 112, '2015-04-01 00:13:28.000000', 'temperatura', 1040.0000, 'ºC'),
	(137810, 112, '2015-04-01 00:13:29.000000', 'temperatura', 878.0000, 'ºC'),
	(137811, 112, '2015-04-01 00:13:30.000000', 'temperatura', 72.0000, 'ºC'),
	(137812, 112, '2015-04-01 00:13:31.000000', 'temperatura', 125.0000, 'ºC'),
	(137813, 112, '2015-04-01 00:13:32.000000', 'temperatura', 412.0000, 'ºC'),
	(137814, 112, '2015-04-01 00:13:33.000000', 'temperatura', 485.0000, 'ºC'),
	(137815, 112, '2015-04-01 00:13:34.000000', 'temperatura', 1190.0000, 'ºC'),
	(137816, 112, '2015-04-01 00:13:35.000000', 'temperatura', 896.0000, 'ºC'),
	(137817, 112, '2015-04-01 00:13:36.000000', 'temperatura', 910.0000, 'ºC'),
	(137818, 112, '2015-04-01 00:13:37.000000', 'temperatura', 661.0000, 'ºC'),
	(137819, 112, '2015-04-01 00:13:38.000000', 'temperatura', 576.0000, 'ºC'),
	(137820, 112, '2015-04-01 00:13:39.000000', 'temperatura', 897.0000, 'ºC'),
	(137821, 112, '2015-04-01 00:13:40.000000', 'temperatura', 357.0000, 'ºC'),
	(137822, 112, '2015-04-01 00:13:41.000000', 'temperatura', 294.0000, 'ºC'),
	(137823, 112, '2015-04-01 00:13:42.000000', 'temperatura', 399.0000, 'ºC'),
	(137824, 112, '2015-04-01 00:13:43.000000', 'temperatura', 1113.0000, 'ºC'),
	(137825, 112, '2015-04-01 00:13:44.000000', 'temperatura', 771.0000, 'ºC'),
	(137826, 112, '2015-04-01 00:13:45.000000', 'temperatura', 514.0000, 'ºC'),
	(137827, 112, '2015-04-01 00:13:46.000000', 'temperatura', 258.0000, 'ºC'),
	(137828, 112, '2015-04-01 00:13:47.000000', 'temperatura', 947.0000, 'ºC'),
	(137829, 112, '2015-04-01 00:13:48.000000', 'temperatura', 363.0000, 'ºC'),
	(137830, 112, '2015-04-01 00:13:49.000000', 'temperatura', 175.0000, 'ºC'),
	(137831, 112, '2015-04-01 00:13:50.000000', 'temperatura', 988.0000, 'ºC'),
	(137832, 112, '2015-04-01 00:13:51.000000', 'temperatura', 814.0000, 'ºC'),
	(137833, 112, '2015-04-01 00:13:52.000000', 'temperatura', 1106.0000, 'ºC'),
	(137834, 112, '2015-04-01 00:13:53.000000', 'temperatura', 687.0000, 'ºC'),
	(137835, 112, '2015-04-01 00:13:54.000000', 'temperatura', 119.0000, 'ºC'),
	(137836, 112, '2015-04-01 00:13:55.000000', 'temperatura', 933.0000, 'ºC'),
	(137837, 112, '2015-04-01 00:13:56.000000', 'temperatura', 709.0000, 'ºC'),
	(137838, 112, '2015-04-01 00:13:57.000000', 'temperatura', 748.0000, 'ºC'),
	(137839, 112, '2015-04-01 00:13:58.000000', 'temperatura', 412.0000, 'ºC'),
	(137840, 112, '2015-04-01 00:13:59.000000', 'temperatura', 1017.0000, 'ºC'),
	(137841, 112, '2015-04-01 00:14:00.000000', 'temperatura', 247.0000, 'ºC'),
	(137842, 112, '2015-04-01 00:14:01.000000', 'temperatura', 588.0000, 'ºC'),
	(137843, 112, '2015-04-01 00:14:02.000000', 'temperatura', 997.0000, 'ºC'),
	(137844, 112, '2015-04-01 00:14:03.000000', 'temperatura', 822.0000, 'ºC'),
	(137845, 112, '2015-04-01 00:14:04.000000', 'temperatura', 1119.0000, 'ºC'),
	(137846, 112, '2015-04-01 00:14:05.000000', 'temperatura', 729.0000, 'ºC'),
	(137847, 112, '2015-04-01 00:14:06.000000', 'temperatura', 287.0000, 'ºC'),
	(137848, 112, '2015-04-01 00:14:07.000000', 'temperatura', 452.0000, 'ºC'),
	(137849, 112, '2015-04-01 00:14:08.000000', 'temperatura', 199.0000, 'ºC'),
	(137850, 112, '2015-04-01 00:14:09.000000', 'temperatura', 838.0000, 'ºC'),
	(137851, 112, '2015-04-01 00:14:10.000000', 'temperatura', 1193.0000, 'ºC'),
	(137852, 112, '2015-04-01 00:14:11.000000', 'temperatura', 1054.0000, 'ºC'),
	(137853, 112, '2015-04-01 00:14:12.000000', 'temperatura', 490.0000, 'ºC'),
	(137854, 112, '2015-04-01 00:14:13.000000', 'temperatura', 488.0000, 'ºC'),
	(137855, 112, '2015-04-01 00:14:14.000000', 'temperatura', 970.0000, 'ºC'),
	(137856, 112, '2015-04-01 00:14:15.000000', 'temperatura', 986.0000, 'ºC'),
	(137857, 112, '2015-04-01 00:14:16.000000', 'temperatura', 821.0000, 'ºC'),
	(137858, 112, '2015-04-01 00:14:17.000000', 'temperatura', 1146.0000, 'ºC'),
	(137859, 112, '2015-04-01 00:14:18.000000', 'temperatura', 871.0000, 'ºC'),
	(137860, 112, '2015-04-01 00:14:19.000000', 'temperatura', 914.0000, 'ºC'),
	(137861, 112, '2015-04-01 00:14:20.000000', 'temperatura', 760.0000, 'ºC'),
	(137862, 112, '2015-04-01 00:14:21.000000', 'temperatura', 1056.0000, 'ºC'),
	(137863, 112, '2015-04-01 00:14:22.000000', 'temperatura', 604.0000, 'ºC'),
	(137864, 112, '2015-04-01 00:14:23.000000', 'temperatura', 1049.0000, 'ºC'),
	(137865, 112, '2015-04-01 00:14:24.000000', 'temperatura', 1036.0000, 'ºC'),
	(137866, 112, '2015-04-01 00:14:25.000000', 'temperatura', 833.0000, 'ºC'),
	(137867, 112, '2015-04-01 00:14:26.000000', 'temperatura', 1059.0000, 'ºC'),
	(137868, 112, '2015-04-01 00:14:27.000000', 'temperatura', 397.0000, 'ºC'),
	(137869, 112, '2015-04-01 00:14:28.000000', 'temperatura', 6.0000, 'ºC'),
	(137870, 112, '2015-04-01 00:14:29.000000', 'temperatura', 40.0000, 'ºC'),
	(137871, 112, '2015-04-01 00:14:30.000000', 'temperatura', 184.0000, 'ºC'),
	(137872, 112, '2015-04-01 00:14:31.000000', 'temperatura', 800.0000, 'ºC'),
	(137873, 112, '2015-04-01 00:14:32.000000', 'temperatura', 1048.0000, 'ºC'),
	(137874, 112, '2015-04-01 00:14:33.000000', 'temperatura', 442.0000, 'ºC'),
	(137875, 112, '2015-04-01 00:14:34.000000', 'temperatura', 266.0000, 'ºC'),
	(137876, 112, '2015-04-01 00:14:35.000000', 'temperatura', 5.0000, 'ºC'),
	(137877, 112, '2015-04-01 00:14:36.000000', 'temperatura', 425.0000, 'ºC'),
	(137878, 112, '2015-04-01 00:14:37.000000', 'temperatura', 914.0000, 'ºC'),
	(137879, 112, '2015-04-01 00:14:38.000000', 'temperatura', 892.0000, 'ºC'),
	(137880, 112, '2015-04-01 00:14:39.000000', 'temperatura', 522.0000, 'ºC'),
	(137881, 112, '2015-04-01 00:14:40.000000', 'temperatura', 1132.0000, 'ºC'),
	(137882, 112, '2015-04-01 00:14:41.000000', 'temperatura', 497.0000, 'ºC'),
	(137883, 112, '2015-04-01 00:14:42.000000', 'temperatura', 286.0000, 'ºC'),
	(137884, 112, '2015-04-01 00:14:43.000000', 'temperatura', 1142.0000, 'ºC'),
	(137885, 112, '2015-04-01 00:14:44.000000', 'temperatura', 52.0000, 'ºC'),
	(137886, 112, '2015-04-01 00:14:45.000000', 'temperatura', 434.0000, 'ºC'),
	(137887, 112, '2015-04-01 00:14:46.000000', 'temperatura', 813.0000, 'ºC'),
	(137888, 112, '2015-04-01 00:14:47.000000', 'temperatura', 364.0000, 'ºC'),
	(137889, 112, '2015-04-01 00:14:48.000000', 'temperatura', 584.0000, 'ºC'),
	(137890, 112, '2015-04-01 00:14:49.000000', 'temperatura', 627.0000, 'ºC'),
	(137891, 112, '2015-04-01 00:14:50.000000', 'temperatura', 186.0000, 'ºC'),
	(137892, 112, '2015-04-01 00:14:51.000000', 'temperatura', 246.0000, 'ºC'),
	(137893, 112, '2015-04-01 00:14:52.000000', 'temperatura', 673.0000, 'ºC'),
	(137894, 112, '2015-04-01 00:14:53.000000', 'temperatura', 228.0000, 'ºC'),
	(137895, 112, '2015-04-01 00:14:54.000000', 'temperatura', 322.0000, 'ºC'),
	(137896, 112, '2015-04-01 00:14:55.000000', 'temperatura', 927.0000, 'ºC'),
	(137897, 112, '2015-04-01 00:14:56.000000', 'temperatura', 68.0000, 'ºC'),
	(137898, 112, '2015-04-01 00:14:57.000000', 'temperatura', 1162.0000, 'ºC'),
	(137899, 112, '2015-04-01 00:14:58.000000', 'temperatura', 803.0000, 'ºC'),
	(137900, 112, '2015-04-01 00:14:59.000000', 'temperatura', 532.0000, 'ºC'),
	(137901, 112, '2015-04-01 00:15:00.000000', 'temperatura', 252.0000, 'ºC'),
	(137902, 112, '2015-04-01 00:15:01.000000', 'temperatura', 864.0000, 'ºC'),
	(137903, 112, '2015-04-01 00:15:02.000000', 'temperatura', 1164.0000, 'ºC'),
	(137904, 112, '2015-04-01 00:15:03.000000', 'temperatura', 827.0000, 'ºC'),
	(137905, 112, '2015-04-01 00:15:04.000000', 'temperatura', 646.0000, 'ºC'),
	(137906, 112, '2015-04-01 00:15:05.000000', 'temperatura', 750.0000, 'ºC'),
	(137907, 112, '2015-04-01 00:15:06.000000', 'temperatura', 611.0000, 'ºC'),
	(137908, 112, '2015-04-01 00:15:07.000000', 'temperatura', 807.0000, 'ºC'),
	(137909, 112, '2015-04-01 00:15:08.000000', 'temperatura', 1001.0000, 'ºC'),
	(137910, 112, '2015-04-01 00:15:09.000000', 'temperatura', 186.0000, 'ºC'),
	(137911, 112, '2015-04-01 00:15:10.000000', 'temperatura', 329.0000, 'ºC'),
	(137912, 112, '2015-04-01 00:15:11.000000', 'temperatura', 1085.0000, 'ºC'),
	(137913, 112, '2015-04-01 00:15:12.000000', 'temperatura', 839.0000, 'ºC'),
	(137914, 112, '2015-04-01 00:15:13.000000', 'temperatura', 942.0000, 'ºC'),
	(137915, 112, '2015-04-01 00:15:14.000000', 'temperatura', 993.0000, 'ºC'),
	(137916, 112, '2015-04-01 00:15:15.000000', 'temperatura', 939.0000, 'ºC'),
	(137917, 112, '2015-04-01 00:15:16.000000', 'temperatura', 517.0000, 'ºC'),
	(137918, 112, '2015-04-01 00:15:17.000000', 'temperatura', 969.0000, 'ºC'),
	(137919, 112, '2015-04-01 00:15:18.000000', 'temperatura', 896.0000, 'ºC'),
	(137920, 112, '2015-04-01 00:15:19.000000', 'temperatura', 371.0000, 'ºC'),
	(137921, 112, '2015-04-01 00:15:20.000000', 'temperatura', 366.0000, 'ºC'),
	(137922, 112, '2015-04-01 00:15:21.000000', 'temperatura', 720.0000, 'ºC'),
	(137923, 112, '2015-04-01 00:15:22.000000', 'temperatura', 101.0000, 'ºC'),
	(137924, 112, '2015-04-01 00:15:23.000000', 'temperatura', 746.0000, 'ºC'),
	(137925, 112, '2015-04-01 00:15:24.000000', 'temperatura', 1027.0000, 'ºC'),
	(137926, 112, '2015-04-01 00:15:25.000000', 'temperatura', 496.0000, 'ºC'),
	(137927, 112, '2015-04-01 00:15:26.000000', 'temperatura', 601.0000, 'ºC'),
	(137928, 112, '2015-04-01 00:15:27.000000', 'temperatura', 318.0000, 'ºC'),
	(137929, 112, '2015-04-01 00:15:28.000000', 'temperatura', 988.0000, 'ºC'),
	(137930, 112, '2015-04-01 00:15:29.000000', 'temperatura', 384.0000, 'ºC'),
	(137931, 112, '2015-04-01 00:15:30.000000', 'temperatura', 159.0000, 'ºC'),
	(137932, 112, '2015-04-01 00:15:31.000000', 'temperatura', 841.0000, 'ºC'),
	(137933, 112, '2015-04-01 00:15:32.000000', 'temperatura', 130.0000, 'ºC'),
	(137934, 112, '2015-04-01 00:15:33.000000', 'temperatura', 525.0000, 'ºC'),
	(137935, 112, '2015-04-01 00:15:34.000000', 'temperatura', 1038.0000, 'ºC'),
	(137936, 112, '2015-04-01 00:15:35.000000', 'temperatura', 16.0000, 'ºC'),
	(137937, 112, '2015-04-01 00:15:36.000000', 'temperatura', 564.0000, 'ºC'),
	(137938, 112, '2015-04-01 00:15:37.000000', 'temperatura', 373.0000, 'ºC'),
	(137939, 112, '2015-04-01 00:15:38.000000', 'temperatura', 175.0000, 'ºC'),
	(137940, 112, '2015-04-01 00:15:39.000000', 'temperatura', 958.0000, 'ºC'),
	(137941, 112, '2015-04-01 00:15:40.000000', 'temperatura', 663.0000, 'ºC'),
	(137942, 112, '2015-04-01 00:15:41.000000', 'temperatura', 443.0000, 'ºC'),
	(137943, 112, '2015-04-01 00:15:42.000000', 'temperatura', 226.0000, 'ºC'),
	(137944, 112, '2015-04-01 00:15:43.000000', 'temperatura', 1001.0000, 'ºC'),
	(137945, 112, '2015-04-01 00:15:44.000000', 'temperatura', 726.0000, 'ºC'),
	(137946, 112, '2015-04-01 00:15:45.000000', 'temperatura', 629.0000, 'ºC'),
	(137947, 112, '2015-04-01 00:15:46.000000', 'temperatura', 966.0000, 'ºC'),
	(137948, 112, '2015-04-01 00:15:47.000000', 'temperatura', 544.0000, 'ºC'),
	(137949, 112, '2015-04-01 00:15:48.000000', 'temperatura', 1025.0000, 'ºC'),
	(137950, 112, '2015-04-01 00:15:49.000000', 'temperatura', 1091.0000, 'ºC'),
	(137951, 112, '2015-04-01 00:15:50.000000', 'temperatura', 1180.0000, 'ºC'),
	(137952, 112, '2015-04-01 00:15:51.000000', 'temperatura', 227.0000, 'ºC'),
	(137953, 112, '2015-04-01 00:15:52.000000', 'temperatura', 1199.0000, 'ºC'),
	(137954, 112, '2015-04-01 00:15:53.000000', 'temperatura', 511.0000, 'ºC'),
	(137955, 112, '2015-04-01 00:15:54.000000', 'temperatura', 159.0000, 'ºC'),
	(137956, 112, '2015-04-01 00:15:55.000000', 'temperatura', 462.0000, 'ºC'),
	(137957, 112, '2015-04-01 00:15:56.000000', 'temperatura', 633.0000, 'ºC'),
	(137958, 112, '2015-04-01 00:15:57.000000', 'temperatura', 578.0000, 'ºC'),
	(137959, 112, '2015-04-01 00:15:58.000000', 'temperatura', 995.0000, 'ºC'),
	(137960, 112, '2015-04-01 00:15:59.000000', 'temperatura', 841.0000, 'ºC'),
	(137961, 112, '2015-04-01 00:16:00.000000', 'temperatura', 21.0000, 'ºC'),
	(137962, 112, '2015-04-01 00:16:01.000000', 'temperatura', 1182.0000, 'ºC'),
	(137963, 112, '2015-04-01 00:16:02.000000', 'temperatura', 1047.0000, 'ºC'),
	(137964, 112, '2015-04-01 00:16:03.000000', 'temperatura', 489.0000, 'ºC'),
	(137965, 112, '2015-04-01 00:16:04.000000', 'temperatura', 506.0000, 'ºC'),
	(137966, 112, '2015-04-01 00:16:05.000000', 'temperatura', 1062.0000, 'ºC'),
	(137967, 112, '2015-04-01 00:16:06.000000', 'temperatura', 191.0000, 'ºC'),
	(137968, 112, '2015-04-01 00:16:07.000000', 'temperatura', 172.0000, 'ºC'),
	(137969, 112, '2015-04-01 00:16:08.000000', 'temperatura', 285.0000, 'ºC'),
	(137970, 112, '2015-04-01 00:16:09.000000', 'temperatura', 910.0000, 'ºC'),
	(137971, 112, '2015-04-01 00:16:10.000000', 'temperatura', 96.0000, 'ºC'),
	(137972, 112, '2015-04-01 00:16:11.000000', 'temperatura', 151.0000, 'ºC'),
	(137973, 112, '2015-04-01 00:16:12.000000', 'temperatura', 468.0000, 'ºC'),
	(137974, 112, '2015-04-01 00:16:13.000000', 'temperatura', 685.0000, 'ºC'),
	(137975, 112, '2015-04-01 00:16:14.000000', 'temperatura', 822.0000, 'ºC'),
	(137976, 112, '2015-04-01 00:16:15.000000', 'temperatura', 856.0000, 'ºC'),
	(137977, 112, '2015-04-01 00:16:16.000000', 'temperatura', 615.0000, 'ºC'),
	(137978, 112, '2015-04-01 00:16:17.000000', 'temperatura', 508.0000, 'ºC'),
	(137979, 112, '2015-04-01 00:16:18.000000', 'temperatura', 693.0000, 'ºC'),
	(137980, 112, '2015-04-01 00:16:19.000000', 'temperatura', 743.0000, 'ºC'),
	(137981, 112, '2015-04-01 00:16:20.000000', 'temperatura', 438.0000, 'ºC'),
	(137982, 112, '2015-04-01 00:16:21.000000', 'temperatura', 1159.0000, 'ºC'),
	(137983, 112, '2015-04-01 00:16:22.000000', 'temperatura', 881.0000, 'ºC'),
	(137984, 112, '2015-04-01 00:16:23.000000', 'temperatura', 929.0000, 'ºC'),
	(137985, 112, '2015-04-01 00:16:24.000000', 'temperatura', 802.0000, 'ºC'),
	(137986, 112, '2015-04-01 00:16:25.000000', 'temperatura', 25.0000, 'ºC'),
	(137987, 112, '2015-04-01 00:16:26.000000', 'temperatura', 120.0000, 'ºC'),
	(137988, 112, '2015-04-01 00:16:27.000000', 'temperatura', 524.0000, 'ºC'),
	(137989, 112, '2015-04-01 00:16:28.000000', 'temperatura', 1060.0000, 'ºC'),
	(137990, 112, '2015-04-01 00:16:29.000000', 'temperatura', 128.0000, 'ºC'),
	(137991, 112, '2015-04-01 00:16:30.000000', 'temperatura', 1063.0000, 'ºC'),
	(137992, 112, '2015-04-01 00:16:31.000000', 'temperatura', 128.0000, 'ºC'),
	(137993, 112, '2015-04-01 00:16:32.000000', 'temperatura', 1054.0000, 'ºC'),
	(137994, 112, '2015-04-01 00:16:33.000000', 'temperatura', 86.0000, 'ºC'),
	(137995, 112, '2015-04-01 00:16:34.000000', 'temperatura', 870.0000, 'ºC'),
	(137996, 112, '2015-04-01 00:16:35.000000', 'temperatura', 492.0000, 'ºC'),
	(137997, 112, '2015-04-01 00:16:36.000000', 'temperatura', 1049.0000, 'ºC'),
	(137998, 112, '2015-04-01 00:16:37.000000', 'temperatura', 169.0000, 'ºC'),
	(137999, 112, '2015-04-01 00:16:38.000000', 'temperatura', 100.0000, 'ºC'),
	(138000, 112, '2015-04-01 00:16:39.000000', 'temperatura', 1194.0000, 'ºC'),
	(138001, 112, '2015-04-01 00:16:40.000000', 'temperatura', 870.0000, 'ºC'),
	(138002, 112, '2015-04-01 00:16:41.000000', 'temperatura', 770.0000, 'ºC'),
	(138003, 112, '2015-04-01 00:16:42.000000', 'temperatura', 39.0000, 'ºC'),
	(138004, 112, '2015-04-01 00:16:43.000000', 'temperatura', 286.0000, 'ºC'),
	(138005, 112, '2015-04-01 00:16:44.000000', 'temperatura', 112.0000, 'ºC'),
	(138006, 112, '2015-04-01 00:16:45.000000', 'temperatura', 902.0000, 'ºC'),
	(138007, 112, '2015-04-01 00:16:46.000000', 'temperatura', 574.0000, 'ºC'),
	(138008, 112, '2015-04-01 00:16:47.000000', 'temperatura', 167.0000, 'ºC'),
	(138009, 112, '2015-04-01 00:16:48.000000', 'temperatura', 311.0000, 'ºC'),
	(138010, 112, '2015-04-01 00:16:49.000000', 'temperatura', 1055.0000, 'ºC'),
	(138011, 112, '2015-04-01 00:16:50.000000', 'temperatura', 744.0000, 'ºC'),
	(138012, 112, '2015-04-01 00:16:51.000000', 'temperatura', 554.0000, 'ºC'),
	(138013, 112, '2015-04-01 00:16:52.000000', 'temperatura', 540.0000, 'ºC'),
	(138014, 112, '2015-04-01 00:16:53.000000', 'temperatura', 1037.0000, 'ºC'),
	(138015, 112, '2015-04-01 00:16:54.000000', 'temperatura', 1165.0000, 'ºC'),
	(138016, 112, '2015-04-01 00:16:55.000000', 'temperatura', 314.0000, 'ºC'),
	(138017, 112, '2015-04-01 00:16:56.000000', 'temperatura', 475.0000, 'ºC'),
	(138018, 112, '2015-04-01 00:16:57.000000', 'temperatura', 236.0000, 'ºC'),
	(138019, 112, '2015-04-01 00:16:58.000000', 'temperatura', 955.0000, 'ºC'),
	(138020, 112, '2015-04-01 00:16:59.000000', 'temperatura', 466.0000, 'ºC'),
	(138021, 112, '2015-04-01 00:17:00.000000', 'temperatura', 666.0000, 'ºC'),
	(138022, 112, '2015-04-01 00:17:01.000000', 'temperatura', 734.0000, 'ºC'),
	(138023, 112, '2015-04-01 00:17:02.000000', 'temperatura', 470.0000, 'ºC'),
	(138024, 112, '2015-04-01 00:17:03.000000', 'temperatura', 148.0000, 'ºC'),
	(138025, 112, '2015-04-01 00:17:04.000000', 'temperatura', 532.0000, 'ºC'),
	(138026, 112, '2015-04-01 00:17:05.000000', 'temperatura', 1017.0000, 'ºC'),
	(138027, 112, '2015-04-01 00:17:06.000000', 'temperatura', 1091.0000, 'ºC'),
	(138028, 112, '2015-04-01 00:17:07.000000', 'temperatura', 3.0000, 'ºC'),
	(138029, 112, '2015-04-01 00:17:08.000000', 'temperatura', 342.0000, 'ºC'),
	(138030, 112, '2015-04-01 00:17:09.000000', 'temperatura', 500.0000, 'ºC'),
	(138031, 112, '2015-04-01 00:17:10.000000', 'temperatura', 275.0000, 'ºC'),
	(138032, 112, '2015-04-01 00:17:11.000000', 'temperatura', 1077.0000, 'ºC'),
	(138033, 112, '2015-04-01 00:17:12.000000', 'temperatura', 960.0000, 'ºC'),
	(138034, 112, '2015-04-01 00:17:13.000000', 'temperatura', 369.0000, 'ºC'),
	(138035, 112, '2015-04-01 00:17:14.000000', 'temperatura', 165.0000, 'ºC'),
	(138036, 112, '2015-04-01 00:17:15.000000', 'temperatura', 919.0000, 'ºC'),
	(138037, 112, '2015-04-01 00:17:16.000000', 'temperatura', 500.0000, 'ºC'),
	(138038, 112, '2015-04-01 00:17:17.000000', 'temperatura', 945.0000, 'ºC'),
	(138039, 112, '2015-04-01 00:17:18.000000', 'temperatura', 824.0000, 'ºC'),
	(138040, 112, '2015-04-01 00:17:19.000000', 'temperatura', 87.0000, 'ºC'),
	(138041, 112, '2015-04-01 00:17:20.000000', 'temperatura', 362.0000, 'ºC'),
	(138042, 112, '2015-04-01 00:17:21.000000', 'temperatura', 351.0000, 'ºC'),
	(138043, 112, '2015-04-01 00:17:22.000000', 'temperatura', 670.0000, 'ºC'),
	(138044, 112, '2015-04-01 00:17:23.000000', 'temperatura', 1095.0000, 'ºC'),
	(138045, 112, '2015-04-01 00:17:24.000000', 'temperatura', 1065.0000, 'ºC'),
	(138046, 112, '2015-04-01 00:17:25.000000', 'temperatura', 844.0000, 'ºC'),
	(138047, 112, '2015-04-01 00:17:26.000000', 'temperatura', 1023.0000, 'ºC'),
	(138048, 112, '2015-04-01 00:17:27.000000', 'temperatura', 184.0000, 'ºC'),
	(138049, 112, '2015-04-01 00:17:28.000000', 'temperatura', 249.0000, 'ºC'),
	(138050, 112, '2015-04-01 00:17:29.000000', 'temperatura', 697.0000, 'ºC'),
	(138051, 112, '2015-04-01 00:17:30.000000', 'temperatura', 339.0000, 'ºC'),
	(138052, 112, '2015-04-01 00:17:31.000000', 'temperatura', 803.0000, 'ºC'),
	(138053, 112, '2015-04-01 00:17:32.000000', 'temperatura', 600.0000, 'ºC'),
	(138054, 112, '2015-04-01 00:17:33.000000', 'temperatura', 591.0000, 'ºC'),
	(138055, 112, '2015-04-01 00:17:34.000000', 'temperatura', 1155.0000, 'ºC'),
	(138056, 112, '2015-04-01 00:17:35.000000', 'temperatura', 404.0000, 'ºC'),
	(138057, 112, '2015-04-01 00:17:36.000000', 'temperatura', 954.0000, 'ºC'),
	(138058, 112, '2015-04-01 00:17:37.000000', 'temperatura', 1160.0000, 'ºC'),
	(138059, 112, '2015-04-01 00:17:38.000000', 'temperatura', 538.0000, 'ºC'),
	(138060, 112, '2015-04-01 00:17:39.000000', 'temperatura', 410.0000, 'ºC'),
	(138061, 112, '2015-04-01 00:17:40.000000', 'temperatura', 436.0000, 'ºC'),
	(138062, 112, '2015-04-01 00:17:41.000000', 'temperatura', 951.0000, 'ºC'),
	(138063, 112, '2015-04-01 00:17:42.000000', 'temperatura', 1049.0000, 'ºC'),
	(138064, 112, '2015-04-01 00:17:43.000000', 'temperatura', 1190.0000, 'ºC'),
	(138065, 112, '2015-04-01 00:17:44.000000', 'temperatura', 406.0000, 'ºC'),
	(138066, 112, '2015-04-01 00:17:45.000000', 'temperatura', 858.0000, 'ºC'),
	(138067, 112, '2015-04-01 00:17:46.000000', 'temperatura', 672.0000, 'ºC'),
	(138068, 112, '2015-04-01 00:17:47.000000', 'temperatura', 787.0000, 'ºC'),
	(138069, 112, '2015-04-01 00:17:48.000000', 'temperatura', 718.0000, 'ºC'),
	(138070, 112, '2015-04-01 00:17:49.000000', 'temperatura', 31.0000, 'ºC'),
	(138071, 112, '2015-04-01 00:17:50.000000', 'temperatura', 401.0000, 'ºC'),
	(138072, 112, '2015-04-01 00:17:51.000000', 'temperatura', 715.0000, 'ºC'),
	(138073, 112, '2015-04-01 00:17:52.000000', 'temperatura', 1170.0000, 'ºC'),
	(138074, 112, '2015-04-01 00:17:53.000000', 'temperatura', 105.0000, 'ºC'),
	(138075, 112, '2015-04-01 00:17:54.000000', 'temperatura', 617.0000, 'ºC'),
	(138076, 112, '2015-04-01 00:17:55.000000', 'temperatura', 372.0000, 'ºC'),
	(138077, 112, '2015-04-01 00:17:56.000000', 'temperatura', 6.0000, 'ºC'),
	(138078, 112, '2015-04-01 00:17:57.000000', 'temperatura', 117.0000, 'ºC'),
	(138079, 112, '2015-04-01 00:17:58.000000', 'temperatura', 567.0000, 'ºC'),
	(138080, 112, '2015-04-01 00:17:59.000000', 'temperatura', 84.0000, 'ºC'),
	(138081, 112, '2015-04-01 00:18:00.000000', 'temperatura', 1119.0000, 'ºC'),
	(138082, 112, '2015-04-01 00:18:01.000000', 'temperatura', 543.0000, 'ºC'),
	(138083, 112, '2015-04-01 00:18:02.000000', 'temperatura', 559.0000, 'ºC'),
	(138084, 112, '2015-04-01 00:18:03.000000', 'temperatura', 1165.0000, 'ºC'),
	(138085, 112, '2015-04-01 00:18:04.000000', 'temperatura', 552.0000, 'ºC'),
	(138086, 112, '2015-04-01 00:18:05.000000', 'temperatura', 462.0000, 'ºC'),
	(138087, 112, '2015-04-01 00:18:06.000000', 'temperatura', 655.0000, 'ºC'),
	(138088, 112, '2015-04-01 00:18:07.000000', 'temperatura', 690.0000, 'ºC'),
	(138089, 112, '2015-04-01 00:18:08.000000', 'temperatura', 284.0000, 'ºC'),
	(138090, 112, '2015-04-01 00:18:09.000000', 'temperatura', 550.0000, 'ºC'),
	(138091, 112, '2015-04-01 00:18:10.000000', 'temperatura', 700.0000, 'ºC'),
	(138092, 112, '2015-04-01 00:18:11.000000', 'temperatura', 649.0000, 'ºC'),
	(138093, 112, '2015-04-01 00:18:12.000000', 'temperatura', 1148.0000, 'ºC'),
	(138094, 112, '2015-04-01 00:18:13.000000', 'temperatura', 194.0000, 'ºC'),
	(138095, 112, '2015-04-01 00:18:14.000000', 'temperatura', 1125.0000, 'ºC'),
	(138096, 112, '2015-04-01 00:18:15.000000', 'temperatura', 245.0000, 'ºC'),
	(138097, 112, '2015-04-01 00:18:16.000000', 'temperatura', 251.0000, 'ºC'),
	(138098, 112, '2015-04-01 00:18:17.000000', 'temperatura', 520.0000, 'ºC'),
	(138099, 112, '2015-04-01 00:18:18.000000', 'temperatura', 648.0000, 'ºC'),
	(138100, 112, '2015-04-01 00:18:19.000000', 'temperatura', 482.0000, 'ºC'),
	(138101, 112, '2015-04-01 00:18:20.000000', 'temperatura', 463.0000, 'ºC'),
	(138102, 112, '2015-04-01 00:18:21.000000', 'temperatura', 871.0000, 'ºC'),
	(138103, 112, '2015-04-01 00:18:22.000000', 'temperatura', 565.0000, 'ºC'),
	(138104, 112, '2015-04-01 00:18:23.000000', 'temperatura', 215.0000, 'ºC'),
	(138105, 112, '2015-04-01 00:18:24.000000', 'temperatura', 581.0000, 'ºC'),
	(138106, 112, '2015-04-01 00:18:25.000000', 'temperatura', 1057.0000, 'ºC'),
	(138107, 112, '2015-04-01 00:18:26.000000', 'temperatura', 1145.0000, 'ºC'),
	(138108, 112, '2015-04-01 00:18:27.000000', 'temperatura', 156.0000, 'ºC'),
	(138109, 112, '2015-04-01 00:18:28.000000', 'temperatura', 944.0000, 'ºC'),
	(138110, 112, '2015-04-01 00:18:29.000000', 'temperatura', 652.0000, 'ºC'),
	(138111, 112, '2015-04-01 00:18:30.000000', 'temperatura', 430.0000, 'ºC'),
	(138112, 112, '2015-04-01 00:18:31.000000', 'temperatura', 196.0000, 'ºC'),
	(138113, 112, '2015-04-01 00:18:32.000000', 'temperatura', 888.0000, 'ºC'),
	(138114, 112, '2015-04-01 00:18:33.000000', 'temperatura', 253.0000, 'ºC'),
	(138115, 112, '2015-04-01 00:18:34.000000', 'temperatura', 1000.0000, 'ºC'),
	(138116, 112, '2015-04-01 00:18:35.000000', 'temperatura', 644.0000, 'ºC'),
	(138117, 112, '2015-04-01 00:18:36.000000', 'temperatura', 220.0000, 'ºC'),
	(138118, 112, '2015-04-01 00:18:37.000000', 'temperatura', 369.0000, 'ºC'),
	(138119, 112, '2015-04-01 00:18:38.000000', 'temperatura', 1183.0000, 'ºC'),
	(138120, 112, '2015-04-01 00:18:39.000000', 'temperatura', 9.0000, 'ºC'),
	(138121, 112, '2015-04-01 00:18:40.000000', 'temperatura', 97.0000, 'ºC'),
	(138122, 112, '2015-04-01 00:18:41.000000', 'temperatura', 457.0000, 'ºC'),
	(138123, 112, '2015-04-01 00:18:42.000000', 'temperatura', 794.0000, 'ºC'),
	(138124, 112, '2015-04-01 00:18:43.000000', 'temperatura', 201.0000, 'ºC'),
	(138125, 112, '2015-04-01 00:18:44.000000', 'temperatura', 1021.0000, 'ºC'),
	(138126, 112, '2015-04-01 00:18:45.000000', 'temperatura', 906.0000, 'ºC'),
	(138127, 112, '2015-04-01 00:18:46.000000', 'temperatura', 267.0000, 'ºC'),
	(138128, 112, '2015-04-01 00:18:47.000000', 'temperatura', 1015.0000, 'ºC'),
	(138129, 112, '2015-04-01 00:18:48.000000', 'temperatura', 675.0000, 'ºC'),
	(138130, 112, '2015-04-01 00:18:49.000000', 'temperatura', 332.0000, 'ºC'),
	(138131, 112, '2015-04-01 00:18:50.000000', 'temperatura', 836.0000, 'ºC'),
	(138132, 112, '2015-04-01 00:18:51.000000', 'temperatura', 785.0000, 'ºC'),
	(138133, 112, '2015-04-01 00:18:52.000000', 'temperatura', 215.0000, 'ºC'),
	(138134, 112, '2015-04-01 00:18:53.000000', 'temperatura', 1121.0000, 'ºC'),
	(138135, 112, '2015-04-01 00:18:54.000000', 'temperatura', 160.0000, 'ºC'),
	(138136, 112, '2015-04-01 00:18:55.000000', 'temperatura', 1040.0000, 'ºC'),
	(138137, 112, '2015-04-01 00:18:56.000000', 'temperatura', 1117.0000, 'ºC'),
	(138138, 112, '2015-04-01 00:18:57.000000', 'temperatura', 68.0000, 'ºC'),
	(138139, 112, '2015-04-01 00:18:58.000000', 'temperatura', 588.0000, 'ºC'),
	(138140, 112, '2015-04-01 00:18:59.000000', 'temperatura', 339.0000, 'ºC'),
	(138141, 112, '2015-04-01 00:19:00.000000', 'temperatura', 1128.0000, 'ºC'),
	(138142, 112, '2015-04-01 00:19:01.000000', 'temperatura', 1027.0000, 'ºC'),
	(138143, 112, '2015-04-01 00:19:02.000000', 'temperatura', 548.0000, 'ºC'),
	(138144, 112, '2015-04-01 00:19:03.000000', 'temperatura', 862.0000, 'ºC'),
	(138145, 112, '2015-04-01 00:19:04.000000', 'temperatura', 268.0000, 'ºC'),
	(138146, 112, '2015-04-01 00:19:05.000000', 'temperatura', 1152.0000, 'ºC'),
	(138147, 112, '2015-04-01 00:19:06.000000', 'temperatura', 157.0000, 'ºC'),
	(138148, 112, '2015-04-01 00:19:07.000000', 'temperatura', 930.0000, 'ºC'),
	(138149, 112, '2015-04-01 00:19:08.000000', 'temperatura', 580.0000, 'ºC'),
	(138150, 112, '2015-04-01 00:19:09.000000', 'temperatura', 110.0000, 'ºC'),
	(138151, 112, '2015-04-01 00:19:10.000000', 'temperatura', 8.0000, 'ºC'),
	(138152, 112, '2015-04-01 00:19:11.000000', 'temperatura', 914.0000, 'ºC'),
	(138153, 112, '2015-04-01 00:19:12.000000', 'temperatura', 946.0000, 'ºC'),
	(138154, 112, '2015-04-01 00:19:13.000000', 'temperatura', 788.0000, 'ºC'),
	(138155, 112, '2015-04-01 00:19:14.000000', 'temperatura', 1104.0000, 'ºC'),
	(138156, 112, '2015-04-01 00:19:15.000000', 'temperatura', 756.0000, 'ºC'),
	(138157, 112, '2015-04-01 00:19:16.000000', 'temperatura', 470.0000, 'ºC'),
	(138158, 112, '2015-04-01 00:19:17.000000', 'temperatura', 81.0000, 'ºC'),
	(138159, 112, '2015-04-01 00:19:18.000000', 'temperatura', 195.0000, 'ºC'),
	(138160, 112, '2015-04-01 00:19:19.000000', 'temperatura', 733.0000, 'ºC'),
	(138161, 112, '2015-04-01 00:19:20.000000', 'temperatura', 681.0000, 'ºC'),
	(138162, 112, '2015-04-01 00:19:21.000000', 'temperatura', 6.0000, 'ºC'),
	(138163, 112, '2015-04-01 00:19:22.000000', 'temperatura', 387.0000, 'ºC'),
	(138164, 112, '2015-04-01 00:19:23.000000', 'temperatura', 718.0000, 'ºC'),
	(138165, 112, '2015-04-01 00:19:24.000000', 'temperatura', 30.0000, 'ºC'),
	(138166, 112, '2015-04-01 00:19:25.000000', 'temperatura', 398.0000, 'ºC'),
	(138167, 112, '2015-04-01 00:19:26.000000', 'temperatura', 700.0000, 'ºC'),
	(138168, 112, '2015-04-01 00:19:27.000000', 'temperatura', 1105.0000, 'ºC'),
	(138169, 112, '2015-04-01 00:19:28.000000', 'temperatura', 1028.0000, 'ºC'),
	(138170, 112, '2015-04-01 00:19:29.000000', 'temperatura', 623.0000, 'ºC'),
	(138171, 112, '2015-04-01 00:19:30.000000', 'temperatura', 33.0000, 'ºC'),
	(138172, 112, '2015-04-01 00:19:31.000000', 'temperatura', 696.0000, 'ºC'),
	(138173, 112, '2015-04-01 00:19:32.000000', 'temperatura', 981.0000, 'ºC'),
	(138174, 112, '2015-04-01 00:19:33.000000', 'temperatura', 418.0000, 'ºC'),
	(138175, 112, '2015-04-01 00:19:34.000000', 'temperatura', 347.0000, 'ºC'),
	(138176, 112, '2015-04-01 00:19:35.000000', 'temperatura', 483.0000, 'ºC'),
	(138177, 112, '2015-04-01 00:19:36.000000', 'temperatura', 173.0000, 'ºC'),
	(138178, 112, '2015-04-01 00:19:37.000000', 'temperatura', 616.0000, 'ºC'),
	(138179, 112, '2015-04-01 00:19:38.000000', 'temperatura', 160.0000, 'ºC'),
	(138180, 112, '2015-04-01 00:19:39.000000', 'temperatura', 156.0000, 'ºC'),
	(138181, 112, '2015-04-01 00:19:40.000000', 'temperatura', 298.0000, 'ºC'),
	(138182, 112, '2015-04-01 00:19:41.000000', 'temperatura', 1022.0000, 'ºC'),
	(138183, 112, '2015-04-01 00:19:42.000000', 'temperatura', 616.0000, 'ºC'),
	(138184, 112, '2015-04-01 00:19:43.000000', 'temperatura', 14.0000, 'ºC'),
	(138185, 112, '2015-04-01 00:19:44.000000', 'temperatura', 625.0000, 'ºC'),
	(138186, 112, '2015-04-01 00:19:45.000000', 'temperatura', 684.0000, 'ºC'),
	(138187, 112, '2015-04-01 00:19:46.000000', 'temperatura', 345.0000, 'ºC'),
	(138188, 112, '2015-04-01 00:19:47.000000', 'temperatura', 873.0000, 'ºC'),
	(138189, 112, '2015-04-01 00:19:48.000000', 'temperatura', 930.0000, 'ºC'),
	(138190, 112, '2015-04-01 00:19:49.000000', 'temperatura', 831.0000, 'ºC'),
	(138191, 112, '2015-04-01 00:19:50.000000', 'temperatura', 165.0000, 'ºC'),
	(138192, 112, '2015-04-01 00:19:51.000000', 'temperatura', 734.0000, 'ºC'),
	(138193, 112, '2015-04-01 00:19:52.000000', 'temperatura', 773.0000, 'ºC'),
	(138194, 112, '2015-04-01 00:19:53.000000', 'temperatura', 465.0000, 'ºC'),
	(138195, 112, '2015-04-01 00:19:54.000000', 'temperatura', 7.0000, 'ºC'),
	(138196, 112, '2015-04-01 00:19:55.000000', 'temperatura', 1041.0000, 'ºC'),
	(138197, 112, '2015-04-01 00:19:56.000000', 'temperatura', 386.0000, 'ºC'),
	(138198, 112, '2015-04-01 00:19:57.000000', 'temperatura', 4.0000, 'ºC'),
	(138199, 112, '2015-04-01 00:19:58.000000', 'temperatura', 64.0000, 'ºC'),
	(138200, 112, '2015-04-01 00:19:59.000000', 'temperatura', 307.0000, 'ºC'),
	(138201, 112, '2015-04-01 00:20:00.000000', 'temperatura', 142.0000, 'ºC'),
	(138202, 112, '2015-04-01 00:20:01.000000', 'temperatura', 993.0000, 'ºC'),
	(138203, 112, '2015-04-01 00:20:02.000000', 'temperatura', 940.0000, 'ºC'),
	(138204, 112, '2015-04-01 00:20:03.000000', 'temperatura', 518.0000, 'ºC'),
	(138205, 112, '2015-04-01 00:20:04.000000', 'temperatura', 974.0000, 'ºC'),
	(138206, 112, '2015-04-01 00:20:05.000000', 'temperatura', 914.0000, 'ºC'),
	(138207, 112, '2015-04-01 00:20:06.000000', 'temperatura', 449.0000, 'ºC'),
	(138208, 112, '2015-04-01 00:20:07.000000', 'temperatura', 703.0000, 'ºC'),
	(138209, 112, '2015-04-01 00:20:08.000000', 'temperatura', 970.0000, 'ºC'),
	(138210, 112, '2015-04-01 00:20:09.000000', 'temperatura', 341.0000, 'ºC'),
	(138211, 112, '2015-04-01 00:20:10.000000', 'temperatura', 1195.0000, 'ºC'),
	(138212, 112, '2015-04-01 00:20:11.000000', 'temperatura', 155.0000, 'ºC'),
	(138213, 112, '2015-04-01 00:20:12.000000', 'temperatura', 788.0000, 'ºC'),
	(138214, 112, '2015-04-01 00:20:13.000000', 'temperatura', 1074.0000, 'ºC'),
	(138215, 112, '2015-04-01 00:20:14.000000', 'temperatura', 609.0000, 'ºC'),
	(138216, 112, '2015-04-01 00:20:15.000000', 'temperatura', 1025.0000, 'ºC'),
	(138217, 112, '2015-04-01 00:20:16.000000', 'temperatura', 895.0000, 'ºC'),
	(138218, 112, '2015-04-01 00:20:17.000000', 'temperatura', 201.0000, 'ºC'),
	(138219, 112, '2015-04-01 00:20:18.000000', 'temperatura', 723.0000, 'ºC'),
	(138220, 112, '2015-04-01 00:20:19.000000', 'temperatura', 612.0000, 'ºC'),
	(138221, 112, '2015-04-01 00:20:20.000000', 'temperatura', 890.0000, 'ºC'),
	(138222, 112, '2015-04-01 00:20:21.000000', 'temperatura', 214.0000, 'ºC'),
	(138223, 112, '2015-04-01 00:20:22.000000', 'temperatura', 800.0000, 'ºC'),
	(138224, 112, '2015-04-01 00:20:23.000000', 'temperatura', 958.0000, 'ºC'),
	(138225, 112, '2015-04-01 00:20:24.000000', 'temperatura', 1192.0000, 'ºC'),
	(138226, 112, '2015-04-01 00:20:25.000000', 'temperatura', 685.0000, 'ºC'),
	(138227, 112, '2015-04-01 00:20:26.000000', 'temperatura', 1052.0000, 'ºC'),
	(138228, 112, '2015-04-01 00:20:27.000000', 'temperatura', 803.0000, 'ºC'),
	(138229, 112, '2015-04-01 00:20:28.000000', 'temperatura', 860.0000, 'ºC'),
	(138230, 112, '2015-04-01 00:20:29.000000', 'temperatura', 694.0000, 'ºC'),
	(138231, 112, '2015-04-01 00:20:30.000000', 'temperatura', 888.0000, 'ºC'),
	(138232, 112, '2015-04-01 00:20:31.000000', 'temperatura', 1159.0000, 'ºC'),
	(138233, 112, '2015-04-01 00:20:32.000000', 'temperatura', 732.0000, 'ºC'),
	(138234, 112, '2015-04-01 00:20:33.000000', 'temperatura', 182.0000, 'ºC'),
	(138235, 112, '2015-04-01 00:20:34.000000', 'temperatura', 1114.0000, 'ºC'),
	(138236, 112, '2015-04-01 00:20:35.000000', 'temperatura', 226.0000, 'ºC'),
	(138237, 112, '2015-04-01 00:20:36.000000', 'temperatura', 188.0000, 'ºC'),
	(138238, 112, '2015-04-01 00:20:37.000000', 'temperatura', 262.0000, 'ºC'),
	(138239, 112, '2015-04-01 00:20:38.000000', 'temperatura', 746.0000, 'ºC'),
	(138240, 112, '2015-04-01 00:20:39.000000', 'temperatura', 545.0000, 'ºC'),
	(138241, 112, '2015-04-01 00:20:40.000000', 'temperatura', 488.0000, 'ºC'),
	(138242, 112, '2015-04-01 00:20:41.000000', 'temperatura', 805.0000, 'ºC'),
	(138243, 112, '2015-04-01 00:20:42.000000', 'temperatura', 163.0000, 'ºC'),
	(138244, 112, '2015-04-01 00:20:43.000000', 'temperatura', 800.0000, 'ºC'),
	(138245, 112, '2015-04-01 00:20:44.000000', 'temperatura', 1111.0000, 'ºC'),
	(138246, 112, '2015-04-01 00:20:45.000000', 'temperatura', 755.0000, 'ºC'),
	(138247, 112, '2015-04-01 00:20:46.000000', 'temperatura', 445.0000, 'ºC'),
	(138248, 112, '2015-04-01 00:20:47.000000', 'temperatura', 1158.0000, 'ºC'),
	(138249, 112, '2015-04-01 00:20:48.000000', 'temperatura', 857.0000, 'ºC'),
	(138250, 112, '2015-04-01 00:20:49.000000', 'temperatura', 809.0000, 'ºC'),
	(138251, 112, '2015-04-01 00:20:50.000000', 'temperatura', 275.0000, 'ºC'),
	(138252, 112, '2015-04-01 00:20:51.000000', 'temperatura', 150.0000, 'ºC'),
	(138253, 112, '2015-04-01 00:20:52.000000', 'temperatura', 1126.0000, 'ºC'),
	(138254, 112, '2015-04-01 00:20:53.000000', 'temperatura', 380.0000, 'ºC'),
	(138255, 112, '2015-04-01 00:20:54.000000', 'temperatura', 922.0000, 'ºC'),
	(138256, 112, '2015-04-01 00:20:55.000000', 'temperatura', 1071.0000, 'ºC'),
	(138257, 112, '2015-04-01 00:20:56.000000', 'temperatura', 188.0000, 'ºC'),
	(138258, 112, '2015-04-01 00:20:57.000000', 'temperatura', 129.0000, 'ºC'),
	(138259, 112, '2015-04-01 00:20:58.000000', 'temperatura', 83.0000, 'ºC'),
	(138260, 112, '2015-04-01 00:20:59.000000', 'temperatura', 26.0000, 'ºC'),
	(138261, 112, '2015-04-01 00:21:00.000000', 'temperatura', 1081.0000, 'ºC'),
	(138262, 112, '2015-04-01 00:21:01.000000', 'temperatura', 528.0000, 'ºC'),
	(138263, 112, '2015-04-01 00:21:02.000000', 'temperatura', 599.0000, 'ºC'),
	(138264, 112, '2015-04-01 00:21:03.000000', 'temperatura', 211.0000, 'ºC'),
	(138265, 112, '2015-04-01 00:21:04.000000', 'temperatura', 460.0000, 'ºC'),
	(138266, 112, '2015-04-01 00:21:05.000000', 'temperatura', 468.0000, 'ºC'),
	(138267, 112, '2015-04-01 00:21:06.000000', 'temperatura', 958.0000, 'ºC'),
	(138268, 112, '2015-04-01 00:21:07.000000', 'temperatura', 985.0000, 'ºC'),
	(138269, 112, '2015-04-01 00:21:08.000000', 'temperatura', 855.0000, 'ºC'),
	(138270, 112, '2015-04-01 00:21:09.000000', 'temperatura', 119.0000, 'ºC'),
	(138271, 112, '2015-04-01 00:21:10.000000', 'temperatura', 429.0000, 'ºC'),
	(138272, 112, '2015-04-01 00:21:11.000000', 'temperatura', 591.0000, 'ºC'),
	(138273, 112, '2015-04-01 00:21:12.000000', 'temperatura', 470.0000, 'ºC'),
	(138274, 112, '2015-04-01 00:21:13.000000', 'temperatura', 574.0000, 'ºC'),
	(138275, 112, '2015-04-01 00:21:14.000000', 'temperatura', 263.0000, 'ºC'),
	(138276, 112, '2015-04-01 00:21:15.000000', 'temperatura', 794.0000, 'ºC'),
	(138277, 112, '2015-04-01 00:21:16.000000', 'temperatura', 781.0000, 'ºC'),
	(138278, 112, '2015-04-01 00:21:17.000000', 'temperatura', 321.0000, 'ºC'),
	(138279, 112, '2015-04-01 00:21:18.000000', 'temperatura', 466.0000, 'ºC'),
	(138280, 112, '2015-04-01 00:21:19.000000', 'temperatura', 166.0000, 'ºC'),
	(138281, 112, '2015-04-01 00:21:20.000000', 'temperatura', 633.0000, 'ºC'),
	(138282, 112, '2015-04-01 00:21:21.000000', 'temperatura', 269.0000, 'ºC'),
	(138283, 112, '2015-04-01 00:21:22.000000', 'temperatura', 645.0000, 'ºC'),
	(138284, 112, '2015-04-01 00:21:23.000000', 'temperatura', 21.0000, 'ºC'),
	(138285, 112, '2015-04-01 00:21:24.000000', 'temperatura', 568.0000, 'ºC'),
	(138286, 112, '2015-04-01 00:21:25.000000', 'temperatura', 377.0000, 'ºC'),
	(138287, 112, '2015-04-01 00:21:26.000000', 'temperatura', 183.0000, 'ºC'),
	(138288, 112, '2015-04-01 00:21:27.000000', 'temperatura', 982.0000, 'ºC'),
	(138289, 112, '2015-04-01 00:21:28.000000', 'temperatura', 763.0000, 'ºC'),
	(138290, 112, '2015-04-01 00:21:29.000000', 'temperatura', 868.0000, 'ºC'),
	(138291, 112, '2015-04-01 00:21:30.000000', 'temperatura', 852.0000, 'ºC'),
	(138292, 112, '2015-04-01 00:21:31.000000', 'temperatura', 459.0000, 'ºC'),
	(138293, 112, '2015-04-01 00:21:32.000000', 'temperatura', 937.0000, 'ºC'),
	(138294, 112, '2015-04-01 00:21:33.000000', 'temperatura', 908.0000, 'ºC'),
	(138295, 112, '2015-04-01 00:21:34.000000', 'temperatura', 529.0000, 'ºC'),
	(138296, 112, '2015-04-01 00:21:35.000000', 'temperatura', 1124.0000, 'ºC'),
	(138297, 112, '2015-04-01 00:21:36.000000', 'temperatura', 430.0000, 'ºC'),
	(138298, 112, '2015-04-01 00:21:37.000000', 'temperatura', 1181.0000, 'ºC'),
	(138299, 112, '2015-04-01 00:21:38.000000', 'temperatura', 1017.0000, 'ºC'),
	(138300, 112, '2015-04-01 00:21:39.000000', 'temperatura', 339.0000, 'ºC'),
	(138301, 112, '2015-04-01 00:21:40.000000', 'temperatura', 1048.0000, 'ºC'),
	(138302, 112, '2015-04-01 00:21:41.000000', 'temperatura', 622.0000, 'ºC'),
	(138303, 112, '2015-04-01 00:21:42.000000', 'temperatura', 1168.0000, 'ºC'),
	(138304, 112, '2015-04-01 00:21:43.000000', 'temperatura', 372.0000, 'ºC'),
	(138305, 112, '2015-04-01 00:21:44.000000', 'temperatura', 757.0000, 'ºC'),
	(138306, 112, '2015-04-01 00:21:45.000000', 'temperatura', 270.0000, 'ºC'),
	(138307, 112, '2015-04-01 00:21:46.000000', 'temperatura', 280.0000, 'ºC'),
	(138308, 112, '2015-04-01 00:21:47.000000', 'temperatura', 589.0000, 'ºC'),
	(138309, 112, '2015-04-01 00:21:48.000000', 'temperatura', 905.0000, 'ºC'),
	(138310, 112, '2015-04-01 00:21:49.000000', 'temperatura', 360.0000, 'ºC'),
	(138311, 112, '2015-04-01 00:21:50.000000', 'temperatura', 287.0000, 'ºC'),
	(138312, 112, '2015-04-01 00:21:51.000000', 'temperatura', 352.0000, 'ºC'),
	(138313, 112, '2015-04-01 00:21:52.000000', 'temperatura', 903.0000, 'ºC'),
	(138314, 112, '2015-04-01 00:21:53.000000', 'temperatura', 1059.0000, 'ºC'),
	(138315, 112, '2015-04-01 00:21:54.000000', 'temperatura', 184.0000, 'ºC'),
	(138316, 112, '2015-04-01 00:21:55.000000', 'temperatura', 147.0000, 'ºC'),
	(138317, 112, '2015-04-01 00:21:56.000000', 'temperatura', 181.0000, 'ºC'),
	(138318, 112, '2015-04-01 00:21:57.000000', 'temperatura', 467.0000, 'ºC'),
	(138319, 112, '2015-04-01 00:21:58.000000', 'temperatura', 592.0000, 'ºC'),
	(138320, 112, '2015-04-01 00:21:59.000000', 'temperatura', 361.0000, 'ºC'),
	(138321, 112, '2015-04-01 00:22:00.000000', 'temperatura', 28.0000, 'ºC'),
	(138322, 112, '2015-04-01 00:22:01.000000', 'temperatura', 256.0000, 'ºC'),
	(138323, 112, '2015-04-01 00:22:02.000000', 'temperatura', 1199.0000, 'ºC'),
	(138324, 112, '2015-04-01 00:22:03.000000', 'temperatura', 424.0000, 'ºC'),
	(138325, 112, '2015-04-01 00:22:04.000000', 'temperatura', 927.0000, 'ºC'),
	(138326, 112, '2015-04-01 00:22:05.000000', 'temperatura', 963.0000, 'ºC'),
	(138327, 112, '2015-04-01 00:22:06.000000', 'temperatura', 835.0000, 'ºC'),
	(138328, 112, '2015-04-01 00:22:07.000000', 'temperatura', 88.0000, 'ºC'),
	(138329, 112, '2015-04-01 00:22:08.000000', 'temperatura', 332.0000, 'ºC'),
	(138330, 112, '2015-04-01 00:22:09.000000', 'temperatura', 199.0000, 'ºC'),
	(138331, 112, '2015-04-01 00:22:10.000000', 'temperatura', 1197.0000, 'ºC'),
	(138332, 112, '2015-04-01 00:22:11.000000', 'temperatura', 588.0000, 'ºC'),
	(138333, 112, '2015-04-01 00:22:12.000000', 'temperatura', 551.0000, 'ºC'),
	(138334, 112, '2015-04-01 00:22:13.000000', 'temperatura', 990.0000, 'ºC'),
	(138335, 112, '2015-04-01 00:22:14.000000', 'temperatura', 898.0000, 'ºC'),
	(138336, 112, '2015-04-01 00:22:15.000000', 'temperatura', 321.0000, 'ºC'),
	(138337, 112, '2015-04-01 00:22:16.000000', 'temperatura', 112.0000, 'ºC'),
	(138338, 112, '2015-04-01 00:22:17.000000', 'temperatura', 797.0000, 'ºC'),
	(138339, 112, '2015-04-01 00:22:18.000000', 'temperatura', 48.0000, 'ºC'),
	(138340, 112, '2015-04-01 00:22:19.000000', 'temperatura', 252.0000, 'ºC'),
	(138341, 112, '2015-04-01 00:22:20.000000', 'temperatura', 1115.0000, 'ºC'),
	(138342, 112, '2015-04-01 00:22:21.000000', 'temperatura', 20.0000, 'ºC'),
	(138343, 112, '2015-04-01 00:22:22.000000', 'temperatura', 353.0000, 'ºC'),
	(138344, 112, '2015-04-01 00:22:23.000000', 'temperatura', 508.0000, 'ºC'),
	(138345, 112, '2015-04-01 00:22:24.000000', 'temperatura', 283.0000, 'ºC'),
	(138346, 112, '2015-04-01 00:22:25.000000', 'temperatura', 1088.0000, 'ºC'),
	(138347, 112, '2015-04-01 00:22:26.000000', 'temperatura', 994.0000, 'ºC'),
	(138348, 112, '2015-04-01 00:22:27.000000', 'temperatura', 505.0000, 'ºC'),
	(138349, 112, '2015-04-01 00:22:28.000000', 'temperatura', 742.0000, 'ºC'),
	(138350, 112, '2015-04-01 00:22:29.000000', 'temperatura', 999.0000, 'ºC'),
	(138351, 112, '2015-04-01 00:22:30.000000', 'temperatura', 366.0000, 'ºC'),
	(138352, 112, '2015-04-01 00:22:31.000000', 'temperatura', 34.0000, 'ºC'),
	(138353, 112, '2015-04-01 00:22:32.000000', 'temperatura', 275.0000, 'ºC'),
	(138354, 112, '2015-04-01 00:22:33.000000', 'temperatura', 73.0000, 'ºC'),
	(138355, 112, '2015-04-01 00:22:34.000000', 'temperatura', 741.0000, 'ºC'),
	(138356, 112, '2015-04-01 00:22:35.000000', 'temperatura', 1087.0000, 'ºC'),
	(138357, 112, '2015-04-01 00:22:36.000000', 'temperatura', 812.0000, 'ºC'),
	(138358, 112, '2015-04-01 00:22:37.000000', 'temperatura', 801.0000, 'ºC'),
	(138359, 112, '2015-04-01 00:22:38.000000', 'temperatura', 367.0000, 'ºC'),
	(138360, 112, '2015-04-01 00:22:39.000000', 'temperatura', 633.0000, 'ºC'),
	(138361, 112, '2015-04-01 00:22:40.000000', 'temperatura', 863.0000, 'ºC'),
	(138362, 112, '2015-04-01 00:22:41.000000', 'temperatura', 18.0000, 'ºC'),
	(138363, 112, '2015-04-01 00:22:42.000000', 'temperatura', 1099.0000, 'ºC'),
	(138364, 112, '2015-04-01 00:22:43.000000', 'temperatura', 645.0000, 'ºC'),
	(138365, 112, '2015-04-01 00:22:44.000000', 'temperatura', 1126.0000, 'ºC'),
	(138366, 112, '2015-04-01 00:22:45.000000', 'temperatura', 96.0000, 'ºC'),
	(138367, 112, '2015-04-01 00:22:46.000000', 'temperatura', 701.0000, 'ºC'),
	(138368, 112, '2015-04-01 00:22:47.000000', 'temperatura', 820.0000, 'ºC'),
	(138369, 112, '2015-04-01 00:22:48.000000', 'temperatura', 795.0000, 'ºC'),
	(138370, 112, '2015-04-01 00:22:49.000000', 'temperatura', 317.0000, 'ºC'),
	(138371, 112, '2015-04-01 00:22:50.000000', 'temperatura', 402.0000, 'ºC'),
	(138372, 112, '2015-04-01 00:22:51.000000', 'temperatura', 1056.0000, 'ºC'),
	(138373, 112, '2015-04-01 00:22:52.000000', 'temperatura', 477.0000, 'ºC'),
	(138374, 112, '2015-04-01 00:22:53.000000', 'temperatura', 417.0000, 'ºC'),
	(138375, 112, '2015-04-01 00:22:54.000000', 'temperatura', 655.0000, 'ºC'),
	(138376, 112, '2015-04-01 00:22:55.000000', 'temperatura', 824.0000, 'ºC'),
	(138377, 112, '2015-04-01 00:22:56.000000', 'temperatura', 954.0000, 'ºC'),
	(138378, 112, '2015-04-01 00:22:57.000000', 'temperatura', 1101.0000, 'ºC'),
	(138379, 112, '2015-04-01 00:22:58.000000', 'temperatura', 242.0000, 'ºC'),
	(138380, 112, '2015-04-01 00:22:59.000000', 'temperatura', 307.0000, 'ºC'),
	(138381, 112, '2015-04-01 00:23:00.000000', 'temperatura', 811.0000, 'ºC'),
	(138382, 112, '2015-04-01 00:23:01.000000', 'temperatura', 736.0000, 'ºC'),
	(138383, 112, '2015-04-01 00:23:02.000000', 'temperatura', 45.0000, 'ºC'),
	(138384, 112, '2015-04-01 00:23:03.000000', 'temperatura', 416.0000, 'ºC'),
	(138385, 112, '2015-04-01 00:23:04.000000', 'temperatura', 749.0000, 'ºC'),
	(138386, 112, '2015-04-01 00:23:05.000000', 'temperatura', 96.0000, 'ºC'),
	(138387, 112, '2015-04-01 00:23:06.000000', 'temperatura', 632.0000, 'ºC'),
	(138388, 112, '2015-04-01 00:23:07.000000', 'temperatura', 474.0000, 'ºC'),
	(138389, 112, '2015-04-01 00:23:08.000000', 'temperatura', 474.0000, 'ºC'),
	(138390, 112, '2015-04-01 00:23:09.000000', 'temperatura', 950.0000, 'ºC'),
	(138391, 112, '2015-04-01 00:23:10.000000', 'temperatura', 927.0000, 'ºC'),
	(138392, 112, '2015-04-01 00:23:11.000000', 'temperatura', 585.0000, 'ºC'),
	(138393, 112, '2015-04-01 00:23:12.000000', 'temperatura', 144.0000, 'ºC'),
	(138394, 112, '2015-04-01 00:23:13.000000', 'temperatura', 167.0000, 'ºC'),
	(138395, 112, '2015-04-01 00:23:14.000000', 'temperatura', 402.0000, 'ºC'),
	(138396, 112, '2015-04-01 00:23:15.000000', 'temperatura', 311.0000, 'ºC'),
	(138397, 112, '2015-04-01 00:23:16.000000', 'temperatura', 349.0000, 'ºC'),
	(138398, 112, '2015-04-01 00:23:17.000000', 'temperatura', 814.0000, 'ºC'),
	(138399, 112, '2015-04-01 00:23:18.000000', 'temperatura', 624.0000, 'ºC'),
	(138400, 112, '2015-04-01 00:23:19.000000', 'temperatura', 678.0000, 'ºC'),
	(138401, 112, '2015-04-01 00:23:20.000000', 'temperatura', 318.0000, 'ºC'),
	(138402, 112, '2015-04-01 00:23:21.000000', 'temperatura', 759.0000, 'ºC'),
	(138403, 112, '2015-04-01 00:23:22.000000', 'temperatura', 438.0000, 'ºC'),
	(138404, 112, '2015-04-01 00:23:23.000000', 'temperatura', 1114.0000, 'ºC'),
	(138405, 112, '2015-04-01 00:23:24.000000', 'temperatura', 657.0000, 'ºC'),
	(138406, 112, '2015-04-01 00:23:25.000000', 'temperatura', 1146.0000, 'ºC'),
	(138407, 112, '2015-04-01 00:23:26.000000', 'temperatura', 156.0000, 'ºC'),
	(138408, 112, '2015-04-01 00:23:27.000000', 'temperatura', 943.0000, 'ºC'),
	(138409, 112, '2015-04-01 00:23:28.000000', 'temperatura', 649.0000, 'ºC'),
	(138410, 112, '2015-04-01 00:23:29.000000', 'temperatura', 416.0000, 'ºC'),
	(138411, 112, '2015-04-01 00:23:30.000000', 'temperatura', 131.0000, 'ºC'),
	(138412, 112, '2015-04-01 00:23:31.000000', 'temperatura', 610.0000, 'ºC'),
	(138413, 112, '2015-04-01 00:23:32.000000', 'temperatura', 259.0000, 'ºC'),
	(138414, 112, '2015-04-01 00:23:33.000000', 'temperatura', 663.0000, 'ºC'),
	(138415, 112, '2015-04-01 00:23:34.000000', 'temperatura', 139.0000, 'ºC'),
	(138416, 112, '2015-04-01 00:23:35.000000', 'temperatura', 1108.0000, 'ºC'),
	(138417, 112, '2015-04-01 00:23:36.000000', 'temperatura', 322.0000, 'ºC'),
	(138418, 112, '2015-04-01 00:23:37.000000', 'temperatura', 685.0000, 'ºC'),
	(138419, 112, '2015-04-01 00:23:38.000000', 'temperatura', 62.0000, 'ºC'),
	(138420, 112, '2015-04-01 00:23:39.000000', 'temperatura', 654.0000, 'ºC'),
	(138421, 112, '2015-04-01 00:23:40.000000', 'temperatura', 684.0000, 'ºC'),
	(138422, 112, '2015-04-01 00:23:41.000000', 'temperatura', 261.0000, 'ºC'),
	(138423, 112, '2015-04-01 00:23:42.000000', 'temperatura', 450.0000, 'ºC'),
	(138424, 112, '2015-04-01 00:23:43.000000', 'temperatura', 271.0000, 'ºC'),
	(138425, 112, '2015-04-01 00:23:44.000000', 'temperatura', 5.0000, 'ºC'),
	(138426, 112, '2015-04-01 00:23:45.000000', 'temperatura', 411.0000, 'ºC'),
	(138427, 112, '2015-04-01 00:23:46.000000', 'temperatura', 843.0000, 'ºC'),
	(138428, 112, '2015-04-01 00:23:47.000000', 'temperatura', 580.0000, 'ºC'),
	(138429, 112, '2015-04-01 00:23:48.000000', 'temperatura', 373.0000, 'ºC'),
	(138430, 112, '2015-04-01 00:23:49.000000', 'temperatura', 125.0000, 'ºC'),
	(138431, 112, '2015-04-01 00:23:50.000000', 'temperatura', 706.0000, 'ºC'),
	(138432, 112, '2015-04-01 00:23:51.000000', 'temperatura', 755.0000, 'ºC'),
	(138433, 112, '2015-04-01 00:23:52.000000', 'temperatura', 458.0000, 'ºC'),
	(138434, 112, '2015-04-01 00:23:53.000000', 'temperatura', 25.0000, 'ºC'),
	(138435, 112, '2015-04-01 00:23:54.000000', 'temperatura', 1151.0000, 'ºC'),
	(138436, 112, '2015-04-01 00:23:55.000000', 'temperatura', 880.0000, 'ºC'),
	(138437, 112, '2015-04-01 00:23:56.000000', 'temperatura', 949.0000, 'ºC'),
	(138438, 112, '2015-04-01 00:23:57.000000', 'temperatura', 905.0000, 'ºC'),
	(138439, 112, '2015-04-01 00:23:58.000000', 'temperatura', 480.0000, 'ºC'),
	(138440, 112, '2015-04-01 00:23:59.000000', 'temperatura', 884.0000, 'ºC'),
	(138441, 112, '2015-04-01 00:24:00.000000', 'temperatura', 581.0000, 'ºC'),
	(138442, 112, '2015-04-01 00:24:01.000000', 'temperatura', 255.0000, 'ºC'),
	(138443, 112, '2015-04-01 00:24:02.000000', 'temperatura', 730.0000, 'ºC'),
	(138444, 112, '2015-04-01 00:24:03.000000', 'temperatura', 486.0000, 'ºC'),
	(138445, 112, '2015-04-01 00:24:04.000000', 'temperatura', 242.0000, 'ºC'),
	(138446, 112, '2015-04-01 00:24:05.000000', 'temperatura', 951.0000, 'ºC'),
	(138447, 112, '2015-04-01 00:24:06.000000', 'temperatura', 432.0000, 'ºC'),
	(138448, 112, '2015-04-01 00:24:07.000000', 'temperatura', 505.0000, 'ºC'),
	(138449, 112, '2015-04-01 00:24:08.000000', 'temperatura', 32.0000, 'ºC'),
	(138450, 112, '2015-04-01 00:24:09.000000', 'temperatura', 1046.0000, 'ºC'),
	(138451, 112, '2015-04-01 00:24:10.000000', 'temperatura', 332.0000, 'ºC'),
	(138452, 112, '2015-04-01 00:24:11.000000', 'temperatura', 922.0000, 'ºC'),
	(138453, 112, '2015-04-01 00:24:12.000000', 'temperatura', 15.0000, 'ºC'),
	(138454, 112, '2015-04-01 00:24:13.000000', 'temperatura', 912.0000, 'ºC'),
	(138455, 112, '2015-04-01 00:24:14.000000', 'temperatura', 913.0000, 'ºC'),
	(138456, 112, '2015-04-01 00:24:15.000000', 'temperatura', 631.0000, 'ºC'),
	(138457, 112, '2015-04-01 00:24:16.000000', 'temperatura', 417.0000, 'ºC'),
	(138458, 112, '2015-04-01 00:24:17.000000', 'temperatura', 194.0000, 'ºC'),
	(138459, 112, '2015-04-01 00:24:18.000000', 'temperatura', 917.0000, 'ºC'),
	(138460, 112, '2015-04-01 00:24:19.000000', 'temperatura', 402.0000, 'ºC'),
	(138461, 112, '2015-04-01 00:24:20.000000', 'temperatura', 462.0000, 'ºC'),
	(138462, 112, '2015-04-01 00:24:21.000000', 'temperatura', 1106.0000, 'ºC'),
	(138463, 112, '2015-04-01 00:24:22.000000', 'temperatura', 541.0000, 'ºC'),
	(138464, 112, '2015-04-01 00:24:23.000000', 'temperatura', 588.0000, 'ºC'),
	(138465, 112, '2015-04-01 00:24:24.000000', 'temperatura', 120.0000, 'ºC'),
	(138466, 112, '2015-04-01 00:24:25.000000', 'temperatura', 34.0000, 'ºC'),
	(138467, 112, '2015-04-01 00:24:26.000000', 'temperatura', 1011.0000, 'ºC'),
	(138468, 112, '2015-04-01 00:24:27.000000', 'temperatura', 154.0000, 'ºC'),
	(138469, 112, '2015-04-01 00:24:28.000000', 'temperatura', 135.0000, 'ºC'),
	(138470, 112, '2015-04-01 00:24:29.000000', 'temperatura', 217.0000, 'ºC'),
	(138471, 112, '2015-04-01 00:24:30.000000', 'temperatura', 677.0000, 'ºC'),
	(138472, 112, '2015-04-01 00:24:31.000000', 'temperatura', 337.0000, 'ºC'),
	(138473, 112, '2015-04-01 00:24:32.000000', 'temperatura', 852.0000, 'ºC'),
	(138474, 112, '2015-04-01 00:24:33.000000', 'temperatura', 853.0000, 'ºC'),
	(138475, 112, '2015-04-01 00:24:34.000000', 'temperatura', 507.0000, 'ºC'),
	(138476, 112, '2015-04-01 00:24:35.000000', 'temperatura', 1175.0000, 'ºC'),
	(138477, 112, '2015-04-01 00:24:36.000000', 'temperatura', 756.0000, 'ºC'),
	(138478, 112, '2015-04-01 00:24:37.000000', 'temperatura', 257.0000, 'ºC'),
	(138479, 112, '2015-04-01 00:24:38.000000', 'temperatura', 218.0000, 'ºC'),
	(138480, 112, '2015-04-01 00:24:39.000000', 'temperatura', 320.0000, 'ºC'),
	(138481, 112, '2015-04-01 00:24:40.000000', 'temperatura', 945.0000, 'ºC'),
	(138482, 112, '2015-04-01 00:24:41.000000', 'temperatura', 164.0000, 'ºC'),
	(138483, 112, '2015-04-01 00:24:42.000000', 'temperatura', 387.0000, 'ºC'),
	(138484, 112, '2015-04-01 00:24:43.000000', 'temperatura', 244.0000, 'ºC'),
	(138485, 112, '2015-04-01 00:24:44.000000', 'temperatura', 60.0000, 'ºC'),
	(138486, 112, '2015-04-01 00:24:45.000000', 'temperatura', 770.0000, 'ºC'),
	(138487, 112, '2015-04-01 00:24:46.000000', 'temperatura', 68.0000, 'ºC'),
	(138488, 112, '2015-04-01 00:24:47.000000', 'temperatura', 433.0000, 'ºC'),
	(138489, 112, '2015-04-01 00:24:48.000000', 'temperatura', 759.0000, 'ºC'),
	(138490, 112, '2015-04-01 00:24:49.000000', 'temperatura', 98.0000, 'ºC'),
	(138491, 112, '2015-04-01 00:24:50.000000', 'temperatura', 612.0000, 'ºC'),
	(138492, 112, '2015-04-01 00:24:51.000000', 'temperatura', 367.0000, 'ºC'),
	(138493, 112, '2015-04-01 00:24:52.000000', 'temperatura', 0.0000, 'ºC'),
	(138494, 112, '2015-04-01 00:24:53.000000', 'temperatura', 97.0000, 'ºC'),
	(138495, 112, '2015-04-01 00:24:54.000000', 'temperatura', 488.0000, 'ºC'),
	(138496, 112, '2015-04-01 00:24:55.000000', 'temperatura', 951.0000, 'ºC'),
	(138497, 112, '2015-04-01 00:24:56.000000', 'temperatura', 889.0000, 'ºC'),
	(138498, 112, '2015-04-01 00:24:57.000000', 'temperatura', 393.0000, 'ºC'),
	(138499, 112, '2015-04-01 00:24:58.000000', 'temperatura', 497.0000, 'ºC'),
	(138500, 112, '2015-04-01 00:24:59.000000', 'temperatura', 108.0000, 'ºC'),
	(138501, 112, '2015-04-01 00:25:00.000000', 'temperatura', 251.0000, 'ºC'),
	(138502, 112, '2015-04-01 00:25:01.000000', 'temperatura', 931.0000, 'ºC'),
	(138503, 112, '2015-04-01 00:25:02.000000', 'temperatura', 300.0000, 'ºC'),
	(138504, 112, '2015-04-01 00:25:03.000000', 'temperatura', 1111.0000, 'ºC'),
	(138505, 112, '2015-04-01 00:25:04.000000', 'temperatura', 1053.0000, 'ºC'),
	(138506, 112, '2015-04-01 00:25:05.000000', 'temperatura', 734.0000, 'ºC'),
	(138507, 112, '2015-04-01 00:25:06.000000', 'temperatura', 510.0000, 'ºC'),
	(138508, 112, '2015-04-01 00:25:07.000000', 'temperatura', 349.0000, 'ºC'),
	(138509, 112, '2015-04-01 00:25:08.000000', 'temperatura', 216.0000, 'ºC'),
	(138510, 112, '2015-04-01 00:25:09.000000', 'temperatura', 35.0000, 'ºC'),
	(138511, 112, '2015-04-01 00:25:10.000000', 'temperatura', 727.0000, 'ºC'),
	(138512, 112, '2015-04-01 00:25:11.000000', 'temperatura', 1128.0000, 'ºC'),
	(138513, 112, '2015-04-01 00:25:12.000000', 'temperatura', 1063.0000, 'ºC'),
	(138514, 112, '2015-04-01 00:25:13.000000', 'temperatura', 729.0000, 'ºC'),
	(138515, 112, '2015-04-01 00:25:14.000000', 'temperatura', 459.0000, 'ºC'),
	(138516, 112, '2015-04-01 00:25:15.000000', 'temperatura', 106.0000, 'ºC'),
	(138517, 112, '2015-04-01 00:25:16.000000', 'temperatura', 356.0000, 'ºC'),
	(138518, 112, '2015-04-01 00:25:17.000000', 'temperatura', 261.0000, 'ºC'),
	(138519, 112, '2015-04-01 00:25:18.000000', 'temperatura', 239.0000, 'ºC'),
	(138520, 112, '2015-04-01 00:25:19.000000', 'temperatura', 413.0000, 'ºC'),
	(138521, 112, '2015-04-01 00:25:20.000000', 'temperatura', 149.0000, 'ºC'),
	(138522, 112, '2015-04-01 00:25:21.000000', 'temperatura', 704.0000, 'ºC'),
	(138523, 112, '2015-04-01 00:25:22.000000', 'temperatura', 673.0000, 'ºC'),
	(138524, 112, '2015-04-01 00:25:23.000000', 'temperatura', 54.0000, 'ºC'),
	(138525, 112, '2015-04-01 00:25:24.000000', 'temperatura', 652.0000, 'ºC'),
	(138526, 112, '2015-04-01 00:25:25.000000', 'temperatura', 700.0000, 'ºC'),
	(138527, 112, '2015-04-01 00:25:26.000000', 'temperatura', 342.0000, 'ºC'),
	(138528, 112, '2015-04-01 00:25:27.000000', 'temperatura', 813.0000, 'ºC'),
	(138529, 112, '2015-04-01 00:25:28.000000', 'temperatura', 638.0000, 'ºC'),
	(138530, 112, '2015-04-01 00:25:29.000000', 'temperatura', 752.0000, 'ºC'),
	(138531, 112, '2015-04-01 00:25:30.000000', 'temperatura', 646.0000, 'ºC'),
	(138532, 112, '2015-04-01 00:25:31.000000', 'temperatura', 974.0000, 'ºC'),
	(138533, 112, '2015-04-01 00:25:32.000000', 'temperatura', 532.0000, 'ºC'),
	(138534, 112, '2015-04-01 00:25:33.000000', 'temperatura', 940.0000, 'ºC'),
	(138535, 112, '2015-04-01 00:25:34.000000', 'temperatura', 704.0000, 'ºC'),
	(138536, 112, '2015-04-01 00:25:35.000000', 'temperatura', 701.0000, 'ºC'),
	(138537, 112, '2015-04-01 00:25:36.000000', 'temperatura', 193.0000, 'ºC'),
	(138538, 112, '2015-04-01 00:25:37.000000', 'temperatura', 63.0000, 'ºC'),
	(138539, 112, '2015-04-01 00:25:38.000000', 'temperatura', 936.0000, 'ºC'),
	(138540, 112, '2015-04-01 00:25:39.000000', 'temperatura', 891.0000, 'ºC'),
	(138541, 112, '2015-04-01 00:25:40.000000', 'temperatura', 450.0000, 'ºC'),
	(138542, 112, '2015-04-01 00:25:41.000000', 'temperatura', 776.0000, 'ºC'),
	(138543, 112, '2015-04-01 00:25:42.000000', 'temperatura', 129.0000, 'ºC'),
	(138544, 112, '2015-04-01 00:25:43.000000', 'temperatura', 718.0000, 'ºC'),
	(138545, 112, '2015-04-01 00:25:44.000000', 'temperatura', 803.0000, 'ºC'),
	(138546, 112, '2015-04-01 00:25:45.000000', 'temperatura', 661.0000, 'ºC'),
	(138547, 112, '2015-04-01 00:25:46.000000', 'temperatura', 899.0000, 'ºC'),
	(138548, 112, '2015-04-01 00:25:47.000000', 'temperatura', 110.0000, 'ºC'),
	(138549, 112, '2015-04-01 00:25:48.000000', 'temperatura', 256.0000, 'ºC'),
	(138550, 112, '2015-04-01 00:25:49.000000', 'temperatura', 948.0000, 'ºC'),
	(138551, 112, '2015-04-01 00:25:50.000000', 'temperatura', 375.0000, 'ºC'),
	(138552, 112, '2015-04-01 00:25:51.000000', 'temperatura', 231.0000, 'ºC'),
	(138553, 112, '2015-04-01 00:25:52.000000', 'temperatura', 30.0000, 'ºC'),
	(138554, 112, '2015-04-01 00:25:53.000000', 'temperatura', 659.0000, 'ºC'),
	(138555, 112, '2015-04-01 00:25:54.000000', 'temperatura', 804.0000, 'ºC'),
	(138556, 112, '2015-04-01 00:25:55.000000', 'temperatura', 842.0000, 'ºC'),
	(138557, 112, '2015-04-01 00:25:56.000000', 'temperatura', 601.0000, 'ºC'),
	(138558, 112, '2015-04-01 00:25:57.000000', 'temperatura', 480.0000, 'ºC'),
	(138559, 112, '2015-04-01 00:25:58.000000', 'temperatura', 597.0000, 'ºC'),
	(138560, 112, '2015-04-01 00:25:59.000000', 'temperatura', 345.0000, 'ºC'),
	(138561, 112, '2015-04-01 00:26:00.000000', 'temperatura', 1136.0000, 'ºC'),
	(138562, 112, '2015-04-01 00:26:01.000000', 'temperatura', 1046.0000, 'ºC'),
	(138563, 112, '2015-04-01 00:26:02.000000', 'temperatura', 620.0000, 'ºC'),
	(138564, 112, '2015-04-01 00:26:03.000000', 'temperatura', 1165.0000, 'ºC'),
	(138565, 112, '2015-04-01 00:26:04.000000', 'temperatura', 363.0000, 'ºC'),
	(138566, 112, '2015-04-01 00:26:05.000000', 'temperatura', 723.0000, 'ºC'),
	(138567, 112, '2015-04-01 00:26:06.000000', 'temperatura', 126.0000, 'ºC'),
	(138568, 112, '2015-04-01 00:26:07.000000', 'temperatura', 859.0000, 'ºC'),
	(138569, 112, '2015-04-01 00:26:08.000000', 'temperatura', 320.0000, 'ºC'),
	(138570, 112, '2015-04-01 00:26:09.000000', 'temperatura', 222.0000, 'ºC'),
	(138571, 112, '2015-04-01 00:26:10.000000', 'temperatura', 151.0000, 'ºC'),
	(138572, 112, '2015-04-01 00:26:11.000000', 'temperatura', 89.0000, 'ºC'),
	(138573, 112, '2015-04-01 00:26:12.000000', 'temperatura', 1193.0000, 'ºC'),
	(138574, 112, '2015-04-01 00:26:13.000000', 'temperatura', 900.0000, 'ºC'),
	(138575, 112, '2015-04-01 00:26:14.000000', 'temperatura', 920.0000, 'ºC'),
	(138576, 112, '2015-04-01 00:26:15.000000', 'temperatura', 700.0000, 'ºC'),
	(138577, 112, '2015-04-01 00:26:16.000000', 'temperatura', 740.0000, 'ºC'),
	(138578, 112, '2015-04-01 00:26:17.000000', 'temperatura', 402.0000, 'ºC'),
	(138579, 112, '2015-04-01 00:26:18.000000', 'temperatura', 991.0000, 'ºC'),
	(138580, 112, '2015-04-01 00:26:19.000000', 'temperatura', 148.0000, 'ºC'),
	(138581, 112, '2015-04-01 00:26:20.000000', 'temperatura', 168.0000, 'ºC'),
	(138582, 112, '2015-04-01 00:26:21.000000', 'temperatura', 398.0000, 'ºC'),
	(138583, 112, '2015-04-01 00:26:22.000000', 'temperatura', 286.0000, 'ºC'),
	(138584, 112, '2015-04-01 00:26:23.000000', 'temperatura', 236.0000, 'ºC'),
	(138585, 112, '2015-04-01 00:26:24.000000', 'temperatura', 321.0000, 'ºC'),
	(138586, 112, '2015-04-01 00:26:25.000000', 'temperatura', 900.0000, 'ºC'),
	(138587, 112, '2015-04-01 00:26:26.000000', 'temperatura', 1137.0000, 'ºC'),
	(138588, 112, '2015-04-01 00:26:27.000000', 'temperatura', 586.0000, 'ºC'),
	(138589, 112, '2015-04-01 00:26:28.000000', 'temperatura', 718.0000, 'ºC'),
	(138590, 112, '2015-04-01 00:26:29.000000', 'temperatura', 633.0000, 'ºC'),
	(138591, 112, '2015-04-01 00:26:30.000000', 'temperatura', 1010.0000, 'ºC'),
	(138592, 112, '2015-04-01 00:26:31.000000', 'temperatura', 755.0000, 'ºC'),
	(138593, 112, '2015-04-01 00:26:32.000000', 'temperatura', 743.0000, 'ºC'),
	(138594, 112, '2015-04-01 00:26:33.000000', 'temperatura', 249.0000, 'ºC'),
	(138595, 112, '2015-04-01 00:26:34.000000', 'temperatura', 219.0000, 'ºC'),
	(138596, 112, '2015-04-01 00:26:35.000000', 'temperatura', 348.0000, 'ºC'),
	(138597, 112, '2015-04-01 00:26:36.000000', 'temperatura', 1084.0000, 'ºC'),
	(138598, 112, '2015-04-01 00:26:37.000000', 'temperatura', 775.0000, 'ºC'),
	(138599, 112, '2015-04-01 00:26:38.000000', 'temperatura', 623.0000, 'ºC'),
	(138600, 112, '2015-04-01 00:26:39.000000', 'temperatura', 793.0000, 'ºC'),
	(138601, 112, '2015-04-01 00:26:40.000000', 'temperatura', 896.0000, 'ºC'),
	(138602, 112, '2015-04-01 00:26:41.000000', 'temperatura', 901.0000, 'ºC'),
	(138603, 112, '2015-04-01 00:26:42.000000', 'temperatura', 616.0000, 'ºC'),
	(138604, 112, '2015-04-01 00:26:43.000000', 'temperatura', 378.0000, 'ºC'),
	(138605, 112, '2015-04-01 00:26:44.000000', 'temperatura', 41.0000, 'ºC'),
	(138606, 112, '2015-04-01 00:26:45.000000', 'temperatura', 274.0000, 'ºC'),
	(138607, 112, '2015-04-01 00:26:46.000000', 'temperatura', 47.0000, 'ºC'),
	(138608, 112, '2015-04-01 00:26:47.000000', 'temperatura', 615.0000, 'ºC'),
	(138609, 112, '2015-04-01 00:26:48.000000', 'temperatura', 535.0000, 'ºC'),
	(138610, 112, '2015-04-01 00:26:49.000000', 'temperatura', 829.0000, 'ºC'),
	(138611, 112, '2015-04-01 00:26:50.000000', 'temperatura', 141.0000, 'ºC'),
	(138612, 112, '2015-04-01 00:26:51.000000', 'temperatura', 619.0000, 'ºC'),
	(138613, 112, '2015-04-01 00:26:52.000000', 'temperatura', 272.0000, 'ºC'),
	(138614, 112, '2015-04-01 00:26:53.000000', 'temperatura', 703.0000, 'ºC'),
	(138615, 112, '2015-04-01 00:26:54.000000', 'temperatura', 299.0000, 'ºC'),
	(138616, 112, '2015-04-01 00:26:55.000000', 'temperatura', 586.0000, 'ºC'),
	(138617, 112, '2015-04-01 00:26:56.000000', 'temperatura', 833.0000, 'ºC'),
	(138618, 112, '2015-04-01 00:26:57.000000', 'temperatura', 9.0000, 'ºC'),
	(138619, 112, '2015-04-01 00:26:58.000000', 'temperatura', 1146.0000, 'ºC'),
	(138620, 112, '2015-04-01 00:26:59.000000', 'temperatura', 901.0000, 'ºC'),
	(138621, 112, '2015-04-01 00:27:00.000000', 'temperatura', 1071.0000, 'ºC'),
	(138622, 112, '2015-04-01 00:27:01.000000', 'temperatura', 252.0000, 'ºC'),
	(138623, 112, '2015-04-01 00:27:02.000000', 'temperatura', 448.0000, 'ºC'),
	(138624, 112, '2015-04-01 00:27:03.000000', 'temperatura', 285.0000, 'ºC'),
	(138625, 112, '2015-04-01 00:27:04.000000', 'temperatura', 79.0000, 'ºC'),
	(138626, 112, '2015-04-01 00:27:05.000000', 'temperatura', 743.0000, 'ºC'),
	(138627, 112, '2015-04-01 00:27:06.000000', 'temperatura', 1076.0000, 'ºC'),
	(138628, 112, '2015-04-01 00:27:07.000000', 'temperatura', 752.0000, 'ºC'),
	(138629, 112, '2015-04-01 00:27:08.000000', 'temperatura', 531.0000, 'ºC'),
	(138630, 112, '2015-04-01 00:27:09.000000', 'temperatura', 402.0000, 'ºC'),
	(138631, 112, '2015-04-01 00:27:10.000000', 'temperatura', 415.0000, 'ºC'),
	(138632, 112, '2015-04-01 00:27:11.000000', 'temperatura', 873.0000, 'ºC'),
	(138633, 112, '2015-04-01 00:27:12.000000', 'temperatura', 717.0000, 'ºC'),
	(138634, 112, '2015-04-01 00:27:13.000000', 'temperatura', 968.0000, 'ºC'),
	(138635, 112, '2015-04-01 00:27:14.000000', 'temperatura', 289.0000, 'ºC'),
	(138636, 112, '2015-04-01 00:27:15.000000', 'temperatura', 940.0000, 'ºC'),
	(138637, 112, '2015-04-01 00:27:16.000000', 'temperatura', 234.0000, 'ºC'),
	(138638, 112, '2015-04-01 00:27:17.000000', 'temperatura', 749.0000, 'ºC'),
	(138639, 112, '2015-04-01 00:27:18.000000', 'temperatura', 647.0000, 'ºC'),
	(138640, 112, '2015-04-01 00:27:19.000000', 'temperatura', 985.0000, 'ºC'),
	(138641, 112, '2015-04-01 00:27:20.000000', 'temperatura', 588.0000, 'ºC'),
	(138642, 112, '2015-04-01 00:27:21.000000', 'temperatura', 1184.0000, 'ºC'),
	(138643, 112, '2015-04-01 00:27:22.000000', 'temperatura', 557.0000, 'ºC'),
	(138644, 112, '2015-04-01 00:27:23.000000', 'temperatura', 433.0000, 'ºC'),
	(138645, 112, '2015-04-01 00:27:24.000000', 'temperatura', 497.0000, 'ºC'),
	(138646, 112, '2015-04-01 00:27:25.000000', 'temperatura', 1183.0000, 'ºC'),
	(138647, 112, '2015-04-01 00:27:26.000000', 'temperatura', 826.0000, 'ºC'),
	(138648, 112, '2015-04-01 00:27:27.000000', 'temperatura', 583.0000, 'ºC'),
	(138649, 112, '2015-04-01 00:27:28.000000', 'temperatura', 435.0000, 'ºC'),
	(138650, 112, '2015-04-01 00:27:29.000000', 'temperatura', 428.0000, 'ºC'),
	(138651, 112, '2015-04-01 00:27:30.000000', 'temperatura', 834.0000, 'ºC'),
	(138652, 112, '2015-04-01 00:27:31.000000', 'temperatura', 489.0000, 'ºC'),
	(138653, 112, '2015-04-01 00:27:32.000000', 'temperatura', 1141.0000, 'ºC'),
	(138654, 112, '2015-04-01 00:27:33.000000', 'temperatura', 640.0000, 'ºC'),
	(138655, 112, '2015-04-01 00:27:34.000000', 'temperatura', 977.0000, 'ºC'),
	(138656, 112, '2015-04-01 00:27:35.000000', 'temperatura', 566.0000, 'ºC'),
	(138657, 112, '2015-04-01 00:27:36.000000', 'temperatura', 1099.0000, 'ºC'),
	(138658, 112, '2015-04-01 00:27:37.000000', 'temperatura', 199.0000, 'ºC'),
	(138659, 112, '2015-04-01 00:27:38.000000', 'temperatura', 99.0000, 'ºC'),
	(138660, 112, '2015-04-01 00:27:39.000000', 'temperatura', 1096.0000, 'ºC'),
	(138661, 112, '2015-04-01 00:27:40.000000', 'temperatura', 384.0000, 'ºC'),
	(138662, 112, '2015-04-01 00:27:41.000000', 'temperatura', 1033.0000, 'ºC'),
	(138663, 112, '2015-04-01 00:27:42.000000', 'temperatura', 413.0000, 'ºC'),
	(138664, 112, '2015-04-01 00:27:43.000000', 'temperatura', 169.0000, 'ºC'),
	(138665, 112, '2015-04-01 00:27:44.000000', 'temperatura', 804.0000, 'ºC'),
	(138666, 112, '2015-04-01 00:27:45.000000', 'temperatura', 1114.0000, 'ºC'),
	(138667, 112, '2015-04-01 00:27:46.000000', 'temperatura', 760.0000, 'ºC'),
	(138668, 112, '2015-04-01 00:27:47.000000', 'temperatura', 459.0000, 'ºC'),
	(138669, 112, '2015-04-01 00:27:48.000000', 'temperatura', 13.0000, 'ºC'),
	(138670, 112, '2015-04-01 00:27:49.000000', 'temperatura', 1088.0000, 'ºC'),
	(138671, 112, '2015-04-01 00:27:50.000000', 'temperatura', 602.0000, 'ºC'),
	(138672, 112, '2015-04-01 00:27:51.000000', 'temperatura', 949.0000, 'ºC'),
	(138673, 112, '2015-04-01 00:27:52.000000', 'temperatura', 536.0000, 'ºC'),
	(138674, 112, '2015-04-01 00:27:53.000000', 'temperatura', 1037.0000, 'ºC'),
	(138675, 112, '2015-04-01 00:27:54.000000', 'temperatura', 1175.0000, 'ºC'),
	(138676, 112, '2015-04-01 00:27:55.000000', 'temperatura', 363.0000, 'ºC'),
	(138677, 112, '2015-04-01 00:27:56.000000', 'temperatura', 693.0000, 'ºC'),
	(138678, 112, '2015-04-01 00:27:57.000000', 'temperatura', 1176.0000, 'ºC'),
	(138679, 112, '2015-04-01 00:27:58.000000', 'temperatura', 202.0000, 'ºC'),
	(138680, 112, '2015-04-01 00:27:59.000000', 'temperatura', 1083.0000, 'ºC'),
	(138681, 112, '2015-04-01 00:28:00.000000', 'temperatura', 7.0000, 'ºC'),
	(138682, 112, '2015-04-01 00:28:01.000000', 'temperatura', 387.0000, 'ºC'),
	(138683, 112, '2015-04-01 00:28:02.000000', 'temperatura', 714.0000, 'ºC'),
	(138684, 112, '2015-04-01 00:28:03.000000', 'temperatura', 12.0000, 'ºC'),
	(138685, 112, '2015-04-01 00:28:04.000000', 'temperatura', 317.0000, 'ºC'),
	(138686, 112, '2015-04-01 00:28:05.000000', 'temperatura', 349.0000, 'ºC'),
	(138687, 112, '2015-04-01 00:28:06.000000', 'temperatura', 797.0000, 'ºC'),
	(138688, 112, '2015-04-01 00:28:07.000000', 'temperatura', 536.0000, 'ºC'),
	(138689, 112, '2015-04-01 00:28:08.000000', 'temperatura', 292.0000, 'ºC'),
	(138690, 112, '2015-04-01 00:28:09.000000', 'temperatura', 1051.0000, 'ºC'),
	(138691, 112, '2015-04-01 00:28:10.000000', 'temperatura', 780.0000, 'ºC'),
	(138692, 112, '2015-04-01 00:28:11.000000', 'temperatura', 748.0000, 'ºC'),
	(138693, 112, '2015-04-01 00:28:12.000000', 'temperatura', 198.0000, 'ºC'),
	(138694, 112, '2015-04-01 00:28:13.000000', 'temperatura', 1150.0000, 'ºC'),
	(138695, 112, '2015-04-01 00:28:14.000000', 'temperatura', 355.0000, 'ºC'),
	(138696, 112, '2015-04-01 00:28:15.000000', 'temperatura', 724.0000, 'ºC'),
	(138697, 112, '2015-04-01 00:28:16.000000', 'temperatura', 155.0000, 'ºC'),
	(138698, 112, '2015-04-01 00:28:17.000000', 'temperatura', 1005.0000, 'ºC'),
	(138699, 112, '2015-04-01 00:28:18.000000', 'temperatura', 959.0000, 'ºC'),
	(138700, 112, '2015-04-01 00:28:19.000000', 'temperatura', 582.0000, 'ºC'),
	(138701, 112, '2015-04-01 00:28:20.000000', 'temperatura', 33.0000, 'ºC'),
	(138702, 112, '2015-04-01 00:28:21.000000', 'temperatura', 818.0000, 'ºC'),
	(138703, 112, '2015-04-01 00:28:22.000000', 'temperatura', 394.0000, 'ºC'),
	(138704, 112, '2015-04-01 00:28:23.000000', 'temperatura', 713.0000, 'ºC'),
	(138705, 112, '2015-04-01 00:28:24.000000', 'temperatura', 1187.0000, 'ºC'),
	(138706, 112, '2015-04-01 00:28:25.000000', 'temperatura', 196.0000, 'ºC'),
	(138707, 112, '2015-04-01 00:28:26.000000', 'temperatura', 1018.0000, 'ºC'),
	(138708, 112, '2015-04-01 00:28:27.000000', 'temperatura', 904.0000, 'ºC'),
	(138709, 112, '2015-04-01 00:28:28.000000', 'temperatura', 265.0000, 'ºC'),
	(138710, 112, '2015-04-01 00:28:29.000000', 'temperatura', 1013.0000, 'ºC'),
	(138711, 112, '2015-04-01 00:28:30.000000', 'temperatura', 671.0000, 'ºC'),
	(138712, 112, '2015-04-01 00:28:31.000000', 'temperatura', 315.0000, 'ºC'),
	(138713, 112, '2015-04-01 00:28:32.000000', 'temperatura', 763.0000, 'ºC'),
	(138714, 112, '2015-04-01 00:28:33.000000', 'temperatura', 472.0000, 'ºC'),
	(138715, 112, '2015-04-01 00:28:34.000000', 'temperatura', 70.0000, 'ºC'),
	(138716, 112, '2015-04-01 00:28:35.000000', 'temperatura', 136.0000, 'ºC'),
	(138717, 112, '2015-04-01 00:28:36.000000', 'temperatura', 468.0000, 'ºC'),
	(138718, 112, '2015-04-01 00:28:37.000000', 'temperatura', 735.0000, 'ºC'),
	(138719, 112, '2015-04-01 00:28:38.000000', 'temperatura', 1072.0000, 'ºC'),
	(138720, 112, '2015-04-01 00:28:39.000000', 'temperatura', 755.0000, 'ºC'),
	(138721, 112, '2015-04-01 00:28:40.000000', 'temperatura', 558.0000, 'ºC'),
	(138722, 112, '2015-04-01 00:28:41.000000', 'temperatura', 528.0000, 'ºC'),
	(138723, 112, '2015-04-01 00:28:42.000000', 'temperatura', 967.0000, 'ºC'),
	(138724, 112, '2015-04-01 00:28:43.000000', 'temperatura', 852.0000, 'ºC'),
	(138725, 112, '2015-04-01 00:28:44.000000', 'temperatura', 159.0000, 'ºC'),
	(138726, 112, '2015-04-01 00:28:45.000000', 'temperatura', 639.0000, 'ºC'),
	(138727, 112, '2015-04-01 00:28:46.000000', 'temperatura', 317.0000, 'ºC'),
	(138728, 112, '2015-04-01 00:28:47.000000', 'temperatura', 868.0000, 'ºC'),
	(138729, 112, '2015-04-01 00:28:48.000000', 'temperatura', 992.0000, 'ºC'),
	(138730, 112, '2015-04-01 00:28:49.000000', 'temperatura', 1154.0000, 'ºC'),
	(138731, 112, '2015-04-01 00:28:50.000000', 'temperatura', 396.0000, 'ºC'),
	(138732, 112, '2015-04-01 00:28:51.000000', 'temperatura', 916.0000, 'ºC'),
	(138733, 112, '2015-04-01 00:28:52.000000', 'temperatura', 994.0000, 'ºC'),
	(138734, 112, '2015-04-01 00:28:53.000000', 'temperatura', 1025.0000, 'ºC'),
	(138735, 112, '2015-04-01 00:28:54.000000', 'temperatura', 940.0000, 'ºC'),
	(138736, 112, '2015-04-01 00:28:55.000000', 'temperatura', 426.0000, 'ºC'),
	(138737, 112, '2015-04-01 00:28:56.000000', 'temperatura', 513.0000, 'ºC'),
	(138738, 112, '2015-04-01 00:28:57.000000', 'temperatura', 85.0000, 'ºC'),
	(138739, 112, '2015-04-01 00:28:58.000000', 'temperatura', 86.0000, 'ºC'),
	(138740, 112, '2015-04-01 00:28:59.000000', 'temperatura', 175.0000, 'ºC'),
	(138741, 112, '2015-04-01 00:29:00.000000', 'temperatura', 619.0000, 'ºC'),
	(138742, 112, '2015-04-01 00:29:01.000000', 'temperatura', 171.0000, 'ºC'),
	(138743, 112, '2015-04-01 00:29:02.000000', 'temperatura', 197.0000, 'ºC'),
	(138744, 112, '2015-04-01 00:29:03.000000', 'temperatura', 475.0000, 'ºC'),
	(138745, 112, '2015-04-01 00:29:04.000000', 'temperatura', 581.0000, 'ºC'),
	(138746, 112, '2015-04-01 00:29:05.000000', 'temperatura', 283.0000, 'ºC'),
	(138747, 112, '2015-04-01 00:29:06.000000', 'temperatura', 870.0000, 'ºC'),
	(138748, 112, '2015-04-01 00:29:07.000000', 'temperatura', 1102.0000, 'ºC'),
	(138749, 112, '2015-04-01 00:29:08.000000', 'temperatura', 499.0000, 'ºC'),
	(138750, 112, '2015-04-01 00:29:09.000000', 'temperatura', 393.0000, 'ºC'),
	(138751, 112, '2015-04-01 00:29:10.000000', 'temperatura', 466.0000, 'ºC'),
	(138752, 112, '2015-04-01 00:29:11.000000', 'temperatura', 1151.0000, 'ºC'),
	(138753, 112, '2015-04-01 00:29:12.000000', 'temperatura', 760.0000, 'ºC'),
	(138754, 112, '2015-04-01 00:29:13.000000', 'temperatura', 345.0000, 'ºC'),
	(138755, 112, '2015-04-01 00:29:14.000000', 'temperatura', 647.0000, 'ºC'),
	(138756, 112, '2015-04-01 00:29:15.000000', 'temperatura', 1000.0000, 'ºC'),
	(138757, 112, '2015-04-01 00:29:16.000000', 'temperatura', 659.0000, 'ºC'),
	(138758, 112, '2015-04-01 00:29:17.000000', 'temperatura', 297.0000, 'ºC'),
	(138759, 112, '2015-04-01 00:29:18.000000', 'temperatura', 706.0000, 'ºC'),
	(138760, 112, '2015-04-01 00:29:19.000000', 'temperatura', 240.0000, 'ºC'),
	(138761, 112, '2015-04-01 00:29:20.000000', 'temperatura', 284.0000, 'ºC'),
	(138762, 112, '2015-04-01 00:29:21.000000', 'temperatura', 700.0000, 'ºC'),
	(138763, 112, '2015-04-01 00:29:22.000000', 'temperatura', 247.0000, 'ºC'),
	(138764, 112, '2015-04-01 00:29:23.000000', 'temperatura', 338.0000, 'ºC'),
	(138765, 112, '2015-04-01 00:29:24.000000', 'temperatura', 947.0000, 'ºC'),
	(138766, 112, '2015-04-01 00:29:25.000000', 'temperatura', 123.0000, 'ºC'),
	(138767, 112, '2015-04-01 00:29:26.000000', 'temperatura', 172.0000, 'ºC'),
	(138768, 112, '2015-04-01 00:29:27.000000', 'temperatura', 494.0000, 'ºC'),
	(138769, 112, '2015-04-01 00:29:28.000000', 'temperatura', 754.0000, 'ºC'),
	(138770, 112, '2015-04-01 00:29:29.000000', 'temperatura', 1090.0000, 'ºC'),
	(138771, 112, '2015-04-01 00:29:30.000000', 'temperatura', 788.0000, 'ºC'),
	(138772, 112, '2015-04-01 00:29:31.000000', 'temperatura', 671.0000, 'ºC'),
	(138773, 112, '2015-04-01 00:29:32.000000', 'temperatura', 990.0000, 'ºC'),
	(138774, 112, '2015-04-01 00:29:33.000000', 'temperatura', 539.0000, 'ºC'),
	(138775, 112, '2015-04-01 00:29:34.000000', 'temperatura', 923.0000, 'ºC'),
	(138776, 112, '2015-04-01 00:29:35.000000', 'temperatura', 601.0000, 'ºC'),
	(138777, 112, '2015-04-01 00:29:36.000000', 'temperatura', 237.0000, 'ºC'),
	(138778, 112, '2015-04-01 00:29:37.000000', 'temperatura', 582.0000, 'ºC'),
	(138779, 112, '2015-04-01 00:29:38.000000', 'temperatura', 999.0000, 'ºC'),
	(138780, 112, '2015-04-01 00:29:39.000000', 'temperatura', 848.0000, 'ºC'),
	(138781, 112, '2015-04-01 00:29:40.000000', 'temperatura', 46.0000, 'ºC'),
	(138782, 112, '2015-04-01 00:29:41.000000', 'temperatura', 85.0000, 'ºC'),
	(138783, 112, '2015-04-01 00:29:42.000000', 'temperatura', 288.0000, 'ºC'),
	(138784, 112, '2015-04-01 00:29:43.000000', 'temperatura', 1187.0000, 'ºC'),
	(138785, 112, '2015-04-01 00:29:44.000000', 'temperatura', 271.0000, 'ºC'),
	(138786, 112, '2015-04-01 00:29:45.000000', 'temperatura', 196.0000, 'ºC'),
	(138787, 112, '2015-04-01 00:29:46.000000', 'temperatura', 167.0000, 'ºC'),
	(138788, 112, '2015-04-01 00:29:47.000000', 'temperatura', 246.0000, 'ºC'),
	(138789, 112, '2015-04-01 00:29:48.000000', 'temperatura', 732.0000, 'ºC'),
	(138790, 112, '2015-04-01 00:29:49.000000', 'temperatura', 521.0000, 'ºC'),
	(138791, 112, '2015-04-01 00:29:50.000000', 'temperatura', 410.0000, 'ºC'),
	(138792, 112, '2015-04-01 00:29:51.000000', 'temperatura', 486.0000, 'ºC'),
	(138793, 112, '2015-04-01 00:29:52.000000', 'temperatura', 2.0000, 'ºC'),
	(138794, 112, '2015-04-01 00:29:53.000000', 'temperatura', 950.0000, 'ºC'),
	(138795, 112, '2015-04-01 00:29:54.000000', 'temperatura', 1148.0000, 'ºC'),
	(138796, 112, '2015-04-01 00:29:55.000000', 'temperatura', 487.0000, 'ºC'),
	(138797, 112, '2015-04-01 00:29:56.000000', 'temperatura', 193.0000, 'ºC'),
	(138798, 112, '2015-04-01 00:29:57.000000', 'temperatura', 703.0000, 'ºC'),
	(138799, 112, '2015-04-01 00:29:58.000000', 'temperatura', 537.0000, 'ºC'),
	(138800, 112, '2015-04-01 00:29:59.000000', 'temperatura', 576.0000, 'ºC'),
	(138801, 112, '2015-04-01 00:30:00.000000', 'temperatura', 71.0000, 'ºC'),
	(138802, 112, '2015-04-01 00:30:01.000000', 'temperatura', 1028.0000, 'ºC'),
	(138803, 112, '2015-04-01 00:30:02.000000', 'temperatura', 125.0000, 'ºC'),
	(138804, 112, '2015-04-01 00:30:03.000000', 'temperatura', 1142.0000, 'ºC'),
	(138805, 112, '2015-04-01 00:30:04.000000', 'temperatura', 534.0000, 'ºC'),
	(138806, 112, '2015-04-01 00:30:05.000000', 'temperatura', 447.0000, 'ºC'),
	(138807, 112, '2015-04-01 00:30:06.000000', 'temperatura', 632.0000, 'ºC'),
	(138808, 112, '2015-04-01 00:30:07.000000', 'temperatura', 621.0000, 'ºC'),
	(138809, 112, '2015-04-01 00:30:08.000000', 'temperatura', 10.0000, 'ºC'),
	(138810, 112, '2015-04-01 00:30:09.000000', 'temperatura', 585.0000, 'ºC'),
	(138811, 112, '2015-04-01 00:30:10.000000', 'temperatura', 499.0000, 'ºC'),
	(138812, 112, '2015-04-01 00:30:11.000000', 'temperatura', 738.0000, 'ºC'),
	(138813, 112, '2015-04-01 00:30:12.000000', 'temperatura', 993.0000, 'ºC'),
	(138814, 112, '2015-04-01 00:30:13.000000', 'temperatura', 354.0000, 'ºC'),
	(138815, 112, '2015-04-01 00:30:14.000000', 'temperatura', 1191.0000, 'ºC'),
	(138816, 112, '2015-04-01 00:30:15.000000', 'temperatura', 92.0000, 'ºC'),
	(138817, 112, '2015-04-01 00:30:16.000000', 'temperatura', 488.0000, 'ºC'),
	(138818, 112, '2015-04-01 00:30:17.000000', 'temperatura', 965.0000, 'ºC'),
	(138819, 112, '2015-04-01 00:30:18.000000', 'temperatura', 963.0000, 'ºC'),
	(138820, 112, '2015-04-01 00:30:19.000000', 'temperatura', 719.0000, 'ºC'),
	(138821, 112, '2015-04-01 00:30:20.000000', 'temperatura', 706.0000, 'ºC'),
	(138822, 112, '2015-04-01 00:30:21.000000', 'temperatura', 176.0000, 'ºC'),
	(138823, 112, '2015-04-01 00:30:22.000000', 'temperatura', 1161.0000, 'ºC'),
	(138824, 112, '2015-04-01 00:30:23.000000', 'temperatura', 476.0000, 'ºC'),
	(138825, 112, '2015-04-01 00:30:24.000000', 'temperatura', 97.0000, 'ºC'),
	(138826, 112, '2015-04-01 00:30:25.000000', 'temperatura', 259.0000, 'ºC'),
	(138827, 112, '2015-04-01 00:30:26.000000', 'temperatura', 1004.0000, 'ºC'),
	(138828, 112, '2015-04-01 00:30:27.000000', 'temperatura', 643.0000, 'ºC'),
	(138829, 112, '2015-04-01 00:30:28.000000', 'temperatura', 204.0000, 'ºC'),
	(138830, 112, '2015-04-01 00:30:29.000000', 'temperatura', 293.0000, 'ºC'),
	(138831, 112, '2015-04-01 00:30:30.000000', 'temperatura', 851.0000, 'ºC'),
	(138832, 112, '2015-04-01 00:30:31.000000', 'temperatura', 977.0000, 'ºC'),
	(138833, 112, '2015-04-01 00:30:32.000000', 'temperatura', 1131.0000, 'ºC'),
	(138834, 112, '2015-04-01 00:30:33.000000', 'temperatura', 325.0000, 'ºC'),
	(138835, 112, '2015-04-01 00:30:34.000000', 'temperatura', 632.0000, 'ºC'),
	(138836, 112, '2015-04-01 00:30:35.000000', 'temperatura', 984.0000, 'ºC'),
	(138837, 112, '2015-04-01 00:30:36.000000', 'temperatura', 627.0000, 'ºC'),
	(138838, 112, '2015-04-01 00:30:37.000000', 'temperatura', 182.0000, 'ºC'),
	(138839, 112, '2015-04-01 00:30:38.000000', 'temperatura', 230.0000, 'ºC'),
	(138840, 112, '2015-04-01 00:30:39.000000', 'temperatura', 603.0000, 'ºC'),
	(138841, 112, '2015-04-01 00:30:40.000000', 'temperatura', 1126.0000, 'ºC'),
	(138842, 112, '2015-04-01 00:30:41.000000', 'temperatura', 222.0000, 'ºC'),
	(138843, 112, '2015-04-01 00:30:42.000000', 'temperatura', 132.0000, 'ºC'),
	(138844, 112, '2015-04-01 00:30:43.000000', 'temperatura', 1194.0000, 'ºC'),
	(138845, 112, '2015-04-01 00:30:44.000000', 'temperatura', 775.0000, 'ºC'),
	(138846, 112, '2015-04-01 00:30:45.000000', 'temperatura', 295.0000, 'ºC'),
	(138847, 112, '2015-04-01 00:30:46.000000', 'temperatura', 351.0000, 'ºC'),
	(138848, 112, '2015-04-01 00:30:47.000000', 'temperatura', 871.0000, 'ºC'),
	(138849, 112, '2015-04-01 00:30:48.000000', 'temperatura', 902.0000, 'ºC'),
	(138850, 112, '2015-04-01 00:30:49.000000', 'temperatura', 699.0000, 'ºC'),
	(138851, 112, '2015-04-01 00:30:50.000000', 'temperatura', 786.0000, 'ºC'),
	(138852, 112, '2015-04-01 00:30:51.000000', 'temperatura', 636.0000, 'ºC'),
	(138853, 112, '2015-04-01 00:30:52.000000', 'temperatura', 823.0000, 'ºC'),
	(138854, 112, '2015-04-01 00:30:53.000000', 'temperatura', 1009.0000, 'ºC'),
	(138855, 112, '2015-04-01 00:30:54.000000', 'temperatura', 174.0000, 'ºC'),
	(138856, 112, '2015-04-01 00:30:55.000000', 'temperatura', 242.0000, 'ºC'),
	(138857, 112, '2015-04-01 00:30:56.000000', 'temperatura', 690.0000, 'ºC'),
	(138858, 112, '2015-04-01 00:30:57.000000', 'temperatura', 325.0000, 'ºC'),
	(138859, 112, '2015-04-01 00:30:58.000000', 'temperatura', 756.0000, 'ºC'),
	(138860, 112, '2015-04-01 00:30:59.000000', 'temperatura', 407.0000, 'ºC'),
	(138861, 112, '2015-04-01 00:31:00.000000', 'temperatura', 964.0000, 'ºC'),
	(138862, 112, '2015-04-01 00:31:01.000000', 'temperatura', 3.0000, 'ºC'),
	(138863, 112, '2015-04-01 00:31:02.000000', 'temperatura', 720.0000, 'ºC'),
	(138864, 112, '2015-04-01 00:31:03.000000', 'temperatura', 1195.0000, 'ºC'),
	(138865, 112, '2015-04-01 00:31:04.000000', 'temperatura', 212.0000, 'ºC'),
	(138866, 112, '2015-04-01 00:31:05.000000', 'temperatura', 1077.0000, 'ºC'),
	(138867, 112, '2015-04-01 00:31:06.000000', 'temperatura', 1148.0000, 'ºC'),
	(138868, 112, '2015-04-01 00:31:07.000000', 'temperatura', 109.0000, 'ºC'),
	(138869, 112, '2015-04-01 00:31:08.000000', 'temperatura', 703.0000, 'ºC'),
	(138870, 112, '2015-04-01 00:31:09.000000', 'temperatura', 787.0000, 'ºC'),
	(138871, 112, '2015-04-01 00:31:10.000000', 'temperatura', 628.0000, 'ºC'),
	(138872, 112, '2015-04-01 00:31:11.000000', 'temperatura', 778.0000, 'ºC'),
	(138873, 112, '2015-04-01 00:31:12.000000', 'temperatura', 805.0000, 'ºC'),
	(138874, 112, '2015-04-01 00:31:13.000000', 'temperatura', 494.0000, 'ºC'),
	(138875, 112, '2015-04-01 00:31:14.000000', 'temperatura', 55.0000, 'ºC'),
	(138876, 112, '2015-04-01 00:31:15.000000', 'temperatura', 1191.0000, 'ºC'),
	(138877, 112, '2015-04-01 00:31:16.000000', 'temperatura', 994.0000, 'ºC'),
	(138878, 112, '2015-04-01 00:31:17.000000', 'temperatura', 195.0000, 'ºC'),
	(138879, 112, '2015-04-01 00:31:18.000000', 'temperatura', 393.0000, 'ºC'),
	(138880, 112, '2015-04-01 00:31:19.000000', 'temperatura', 181.0000, 'ºC'),
	(138881, 112, '2015-04-01 00:31:20.000000', 'temperatura', 925.0000, 'ºC'),
	(138882, 112, '2015-04-01 00:31:21.000000', 'temperatura', 483.0000, 'ºC'),
	(138883, 112, '2015-04-01 00:31:22.000000', 'temperatura', 840.0000, 'ºC'),
	(138884, 112, '2015-04-01 00:31:23.000000', 'temperatura', 354.0000, 'ºC'),
	(138885, 112, '2015-04-01 00:31:24.000000', 'temperatura', 448.0000, 'ºC'),
	(138886, 112, '2015-04-01 00:31:25.000000', 'temperatura', 1178.0000, 'ºC'),
	(138887, 112, '2015-04-01 00:31:26.000000', 'temperatura', 949.0000, 'ºC'),
	(138888, 112, '2015-04-01 00:31:27.000000', 'temperatura', 11.0000, 'ºC'),
	(138889, 112, '2015-04-01 00:31:28.000000', 'temperatura', 807.0000, 'ºC'),
	(138890, 112, '2015-04-01 00:31:29.000000', 'temperatura', 403.0000, 'ºC'),
	(138891, 112, '2015-04-01 00:31:30.000000', 'temperatura', 794.0000, 'ºC'),
	(138892, 112, '2015-04-01 00:31:31.000000', 'temperatura', 360.0000, 'ºC'),
	(138893, 112, '2015-04-01 00:31:32.000000', 'temperatura', 619.0000, 'ºC'),
	(138894, 112, '2015-04-01 00:31:33.000000', 'temperatura', 817.0000, 'ºC'),
	(138895, 112, '2015-04-01 00:31:34.000000', 'temperatura', 1029.0000, 'ºC'),
	(138896, 112, '2015-04-01 00:31:35.000000', 'temperatura', 292.0000, 'ºC'),
	(138897, 112, '2015-04-01 00:31:36.000000', 'temperatura', 776.0000, 'ºC'),
	(138898, 112, '2015-04-01 00:31:37.000000', 'temperatura', 603.0000, 'ºC'),
	(138899, 112, '2015-04-01 00:31:38.000000', 'temperatura', 688.0000, 'ºC'),
	(138900, 112, '2015-04-01 00:31:39.000000', 'temperatura', 430.0000, 'ºC'),
	(138901, 112, '2015-04-01 00:31:40.000000', 'temperatura', 88.0000, 'ºC'),
	(138902, 112, '2015-04-01 00:31:41.000000', 'temperatura', 349.0000, 'ºC'),
	(138903, 112, '2015-04-01 00:31:42.000000', 'temperatura', 284.0000, 'ºC'),
	(138904, 112, '2015-04-01 00:31:43.000000', 'temperatura', 373.0000, 'ºC'),
	(138905, 112, '2015-04-01 00:31:44.000000', 'temperatura', 1013.0000, 'ºC'),
	(138906, 112, '2015-04-01 00:31:45.000000', 'temperatura', 347.0000, 'ºC'),
	(138907, 112, '2015-04-01 00:31:46.000000', 'temperatura', 1097.0000, 'ºC'),
	(138908, 112, '2015-04-01 00:31:47.000000', 'temperatura', 842.0000, 'ºC'),
	(138909, 112, '2015-04-01 00:31:48.000000', 'temperatura', 921.0000, 'ºC'),
	(138910, 112, '2015-04-01 00:31:49.000000', 'temperatura', 878.0000, 'ºC'),
	(138911, 112, '2015-04-01 00:31:50.000000', 'temperatura', 427.0000, 'ºC'),
	(138912, 112, '2015-04-01 00:31:51.000000', 'temperatura', 701.0000, 'ºC'),
	(138913, 112, '2015-04-01 00:31:52.000000', 'temperatura', 1024.0000, 'ºC'),
	(138914, 112, '2015-04-01 00:31:53.000000', 'temperatura', 617.0000, 'ºC'),
	(138915, 112, '2015-04-01 00:31:54.000000', 'temperatura', 16.0000, 'ºC'),
	(138916, 112, '2015-04-01 00:31:55.000000', 'temperatura', 629.0000, 'ºC'),
	(138917, 112, '2015-04-01 00:31:56.000000', 'temperatura', 699.0000, 'ºC'),
	(138918, 112, '2015-04-01 00:31:57.000000', 'temperatura', 406.0000, 'ºC'),
	(138919, 112, '2015-04-01 00:31:58.000000', 'temperatura', 1134.0000, 'ºC'),
	(138920, 112, '2015-04-01 00:31:59.000000', 'temperatura', 853.0000, 'ºC'),
	(138921, 112, '2015-04-01 00:32:00.000000', 'temperatura', 862.0000, 'ºC'),
	(138922, 112, '2015-04-01 00:32:01.000000', 'temperatura', 553.0000, 'ºC'),
	(138923, 112, '2015-04-01 00:32:02.000000', 'temperatura', 180.0000, 'ºC'),
	(138924, 112, '2015-04-01 00:32:03.000000', 'temperatura', 440.0000, 'ºC'),
	(138925, 112, '2015-04-01 00:32:04.000000', 'temperatura', 459.0000, 'ºC'),
	(138926, 112, '2015-04-01 00:32:05.000000', 'temperatura', 979.0000, 'ºC'),
	(138927, 112, '2015-04-01 00:32:06.000000', 'temperatura', 1116.0000, 'ºC'),
	(138928, 112, '2015-04-01 00:32:07.000000', 'temperatura', 245.0000, 'ºC'),
	(138929, 112, '2015-04-01 00:32:08.000000', 'temperatura', 276.0000, 'ºC'),
	(138930, 112, '2015-04-01 00:32:09.000000', 'temperatura', 644.0000, 'ºC'),
	(138931, 112, '2015-04-01 00:32:10.000000', 'temperatura', 1195.0000, 'ºC'),
	(138932, 112, '2015-04-01 00:32:11.000000', 'temperatura', 441.0000, 'ºC'),
	(138933, 112, '2015-04-01 00:32:12.000000', 'temperatura', 1022.0000, 'ºC'),
	(138934, 112, '2015-04-01 00:32:13.000000', 'temperatura', 186.0000, 'ºC'),
	(138935, 112, '2015-04-01 00:32:14.000000', 'temperatura', 266.0000, 'ºC'),
	(138936, 112, '2015-04-01 00:32:15.000000', 'temperatura', 774.0000, 'ºC'),
	(138937, 112, '2015-04-01 00:32:16.000000', 'temperatura', 669.0000, 'ºC'),
	(138938, 112, '2015-04-01 00:32:17.000000', 'temperatura', 1027.0000, 'ºC'),
	(138939, 112, '2015-04-01 00:32:18.000000', 'temperatura', 726.0000, 'ºC'),
	(138940, 112, '2015-04-01 00:32:19.000000', 'temperatura', 548.0000, 'ºC'),
	(138941, 112, '2015-04-01 00:32:20.000000', 'temperatura', 565.0000, 'ºC'),
	(138942, 112, '2015-04-01 00:32:21.000000', 'temperatura', 1180.0000, 'ºC'),
	(138943, 112, '2015-04-01 00:32:22.000000', 'temperatura', 607.0000, 'ºC'),
	(138944, 112, '2015-04-01 00:32:23.000000', 'temperatura', 696.0000, 'ºC'),
	(138945, 112, '2015-04-01 00:32:24.000000', 'temperatura', 460.0000, 'ºC'),
	(138946, 112, '2015-04-01 00:32:25.000000', 'temperatura', 210.0000, 'ºC'),
	(138947, 112, '2015-04-01 00:32:26.000000', 'temperatura', 872.0000, 'ºC'),
	(138948, 112, '2015-04-01 00:32:27.000000', 'temperatura', 128.0000, 'ºC'),
	(138949, 112, '2015-04-01 00:32:28.000000', 'temperatura', 427.0000, 'ºC'),
	(138950, 112, '2015-04-01 00:32:29.000000', 'temperatura', 552.0000, 'ºC'),
	(138951, 112, '2015-04-01 00:32:30.000000', 'temperatura', 277.0000, 'ºC'),
	(138952, 112, '2015-04-01 00:32:31.000000', 'temperatura', 932.0000, 'ºC'),
	(138953, 112, '2015-04-01 00:32:32.000000', 'temperatura', 228.0000, 'ºC'),
	(138954, 112, '2015-04-01 00:32:33.000000', 'temperatura', 746.0000, 'ºC'),
	(138955, 112, '2015-04-01 00:32:34.000000', 'temperatura', 646.0000, 'ºC'),
	(138956, 112, '2015-04-01 00:32:35.000000', 'temperatura', 994.0000, 'ºC'),
	(138957, 112, '2015-04-01 00:32:36.000000', 'temperatura', 633.0000, 'ºC'),
	(138958, 112, '2015-04-01 00:32:37.000000', 'temperatura', 183.0000, 'ºC'),
	(138959, 112, '2015-04-01 00:32:38.000000', 'temperatura', 217.0000, 'ºC'),
	(138960, 112, '2015-04-01 00:32:39.000000', 'temperatura', 538.0000, 'ºC'),
	(138961, 112, '2015-04-01 00:32:40.000000', 'temperatura', 836.0000, 'ºC'),
	(138962, 112, '2015-04-01 00:32:41.000000', 'temperatura', 169.0000, 'ºC'),
	(138963, 112, '2015-04-01 00:32:42.000000', 'temperatura', 736.0000, 'ºC'),
	(138964, 112, '2015-04-01 00:32:43.000000', 'temperatura', 773.0000, 'ºC'),
	(138965, 112, '2015-04-01 00:32:44.000000', 'temperatura', 459.0000, 'ºC'),
	(138966, 112, '2015-04-01 00:32:45.000000', 'temperatura', 1175.0000, 'ºC'),
	(138967, 112, '2015-04-01 00:32:46.000000', 'temperatura', 900.0000, 'ºC'),
	(138968, 112, '2015-04-01 00:32:47.000000', 'temperatura', 976.0000, 'ºC'),
	(138969, 112, '2015-04-01 00:32:48.000000', 'temperatura', 981.0000, 'ºC'),
	(138970, 112, '2015-04-01 00:32:49.000000', 'temperatura', 777.0000, 'ºC'),
	(138971, 112, '2015-04-01 00:32:50.000000', 'temperatura', 941.0000, 'ºC'),
	(138972, 112, '2015-04-01 00:32:51.000000', 'temperatura', 1176.0000, 'ºC'),
	(138973, 112, '2015-04-01 00:32:52.000000', 'temperatura', 655.0000, 'ºC'),
	(138974, 112, '2015-04-01 00:32:53.000000', 'temperatura', 951.0000, 'ºC'),
	(138975, 112, '2015-04-01 00:32:54.000000', 'temperatura', 388.0000, 'ºC'),
	(138976, 112, '2015-04-01 00:32:55.000000', 'temperatura', 289.0000, 'ºC'),
	(138977, 112, '2015-04-01 00:32:56.000000', 'temperatura', 283.0000, 'ºC'),
	(138978, 112, '2015-04-01 00:32:57.000000', 'temperatura', 546.0000, 'ºC'),
	(138979, 112, '2015-04-01 00:32:58.000000', 'temperatura', 683.0000, 'ºC'),
	(138980, 112, '2015-04-01 00:32:59.000000', 'temperatura', 578.0000, 'ºC'),
	(138981, 112, '2015-04-01 00:33:00.000000', 'temperatura', 841.0000, 'ºC'),
	(138982, 112, '2015-04-01 00:33:01.000000', 'temperatura', 69.0000, 'ºC'),
	(138983, 112, '2015-04-01 00:33:02.000000', 'temperatura', 226.0000, 'ºC'),
	(138984, 112, '2015-04-01 00:33:03.000000', 'temperatura', 921.0000, 'ºC'),
	(138985, 112, '2015-04-01 00:33:04.000000', 'temperatura', 326.0000, 'ºC'),
	(138986, 112, '2015-04-01 00:33:05.000000', 'temperatura', 70.0000, 'ºC'),
	(138987, 112, '2015-04-01 00:33:06.000000', 'temperatura', 574.0000, 'ºC'),
	(138988, 112, '2015-04-01 00:33:07.000000', 'temperatura', 259.0000, 'ºC'),
	(138989, 112, '2015-04-01 00:33:08.000000', 'temperatura', 772.0000, 'ºC'),
	(138990, 112, '2015-04-01 00:33:09.000000', 'temperatura', 683.0000, 'ºC'),
	(138991, 112, '2015-04-01 00:33:10.000000', 'temperatura', 1100.0000, 'ºC'),
	(138992, 112, '2015-04-01 00:33:11.000000', 'temperatura', 1052.0000, 'ºC'),
	(138993, 112, '2015-04-01 00:33:12.000000', 'temperatura', 760.0000, 'ºC'),
	(138994, 112, '2015-04-01 00:33:13.000000', 'temperatura', 643.0000, 'ºC'),
	(138995, 112, '2015-04-01 00:33:14.000000', 'temperatura', 938.0000, 'ºC'),
	(138996, 112, '2015-04-01 00:33:15.000000', 'temperatura', 361.0000, 'ºC'),
	(138997, 112, '2015-04-01 00:33:16.000000', 'temperatura', 191.0000, 'ºC'),
	(138998, 112, '2015-04-01 00:33:17.000000', 'temperatura', 1074.0000, 'ºC'),
	(138999, 112, '2015-04-01 00:33:18.000000', 'temperatura', 1198.0000, 'ºC'),
	(139000, 112, '2015-04-01 00:33:19.000000', 'temperatura', 367.0000, 'ºC'),
	(139001, 112, '2015-04-01 00:33:20.000000', 'temperatura', 643.0000, 'ºC'),
	(139002, 112, '2015-04-01 00:33:21.000000', 'temperatura', 913.0000, 'ºC'),
	(139003, 112, '2015-04-01 00:33:22.000000', 'temperatura', 235.0000, 'ºC'),
	(139004, 112, '2015-04-01 00:33:23.000000', 'temperatura', 838.0000, 'ºC'),
	(139005, 112, '2015-04-01 00:33:24.000000', 'temperatura', 1085.0000, 'ºC'),
	(139006, 112, '2015-04-01 00:33:25.000000', 'temperatura', 513.0000, 'ºC'),
	(139007, 112, '2015-04-01 00:33:26.000000', 'temperatura', 512.0000, 'ºC'),
	(139008, 112, '2015-04-01 00:33:27.000000', 'temperatura', 1019.0000, 'ºC'),
	(139009, 112, '2015-04-01 00:33:28.000000', 'temperatura', 1158.0000, 'ºC'),
	(139010, 112, '2015-04-01 00:33:29.000000', 'temperatura', 335.0000, 'ºC'),
	(139011, 112, '2015-04-01 00:33:30.000000', 'temperatura', 601.0000, 'ºC'),
	(139012, 112, '2015-04-01 00:33:31.000000', 'temperatura', 800.0000, 'ºC'),
	(139013, 112, '2015-04-01 00:33:32.000000', 'temperatura', 997.0000, 'ºC'),
	(139014, 112, '2015-04-01 00:33:33.000000', 'temperatura', 186.0000, 'ºC'),
	(139015, 112, '2015-04-01 00:33:34.000000', 'temperatura', 340.0000, 'ºC'),
	(139016, 112, '2015-04-01 00:33:35.000000', 'temperatura', 1143.0000, 'ºC'),
	(139017, 112, '2015-04-01 00:33:36.000000', 'temperatura', 1094.0000, 'ºC'),
	(139018, 112, '2015-04-01 00:33:37.000000', 'temperatura', 842.0000, 'ºC'),
	(139019, 112, '2015-04-01 00:33:38.000000', 'temperatura', 929.0000, 'ºC'),
	(139020, 112, '2015-04-01 00:33:39.000000', 'temperatura', 919.0000, 'ºC'),
	(139021, 112, '2015-04-01 00:33:40.000000', 'temperatura', 610.0000, 'ºC'),
	(139022, 112, '2015-04-01 00:33:41.000000', 'temperatura', 291.0000, 'ºC'),
	(139023, 112, '2015-04-01 00:33:42.000000', 'temperatura', 829.0000, 'ºC'),
	(139024, 112, '2015-04-01 00:33:43.000000', 'temperatura', 870.0000, 'ºC'),
	(139025, 112, '2015-04-01 00:33:44.000000', 'temperatura', 662.0000, 'ºC'),
	(139026, 112, '2015-04-01 00:33:45.000000', 'temperatura', 702.0000, 'ºC'),
	(139027, 112, '2015-04-01 00:33:46.000000', 'temperatura', 325.0000, 'ºC'),
	(139028, 112, '2015-04-01 00:33:47.000000', 'temperatura', 720.0000, 'ºC'),
	(139029, 112, '2015-04-01 00:33:48.000000', 'temperatura', 226.0000, 'ºC'),
	(139030, 112, '2015-04-01 00:33:49.000000', 'temperatura', 168.0000, 'ºC'),
	(139031, 112, '2015-04-01 00:33:50.000000', 'temperatura', 165.0000, 'ºC'),
	(139032, 112, '2015-04-01 00:33:51.000000', 'temperatura', 322.0000, 'ºC'),
	(139033, 112, '2015-04-01 00:33:52.000000', 'temperatura', 1116.0000, 'ºC'),
	(139034, 112, '2015-04-01 00:33:53.000000', 'temperatura', 1015.0000, 'ºC'),
	(139035, 112, '2015-04-01 00:33:54.000000', 'temperatura', 526.0000, 'ºC'),
	(139036, 112, '2015-04-01 00:33:55.000000', 'temperatura', 787.0000, 'ºC'),
	(139037, 112, '2015-04-01 00:33:56.000000', 'temperatura', 1156.0000, 'ºC'),
	(139038, 112, '2015-04-01 00:33:57.000000', 'temperatura', 1018.0000, 'ºC'),
	(139039, 112, '2015-04-01 00:33:58.000000', 'temperatura', 425.0000, 'ºC'),
	(139040, 112, '2015-04-01 00:33:59.000000', 'temperatura', 271.0000, 'ºC'),
	(139041, 112, '2015-04-01 00:34:00.000000', 'temperatura', 80.0000, 'ºC'),
	(139042, 112, '2015-04-01 00:34:01.000000', 'temperatura', 787.0000, 'ºC'),
	(139043, 112, '2015-04-01 00:34:02.000000', 'temperatura', 96.0000, 'ºC'),
	(139044, 112, '2015-04-01 00:34:03.000000', 'temperatura', 520.0000, 'ºC'),
	(139045, 112, '2015-04-01 00:34:04.000000', 'temperatura', 1111.0000, 'ºC'),
	(139046, 112, '2015-04-01 00:34:05.000000', 'temperatura', 395.0000, 'ºC'),
	(139047, 112, '2015-04-01 00:34:06.000000', 'temperatura', 1043.0000, 'ºC'),
	(139048, 112, '2015-04-01 00:34:07.000000', 'temperatura', 432.0000, 'ºC'),
	(139049, 112, '2015-04-01 00:34:08.000000', 'temperatura', 231.0000, 'ºC'),
	(139050, 112, '2015-04-01 00:34:09.000000', 'temperatura', 1058.0000, 'ºC'),
	(139051, 112, '2015-04-01 00:34:10.000000', 'temperatura', 997.0000, 'ºC'),
	(139052, 112, '2015-04-01 00:34:11.000000', 'temperatura', 611.0000, 'ºC'),
	(139053, 112, '2015-04-01 00:34:12.000000', 'temperatura', 64.0000, 'ºC'),
	(139054, 112, '2015-04-01 00:34:13.000000', 'temperatura', 889.0000, 'ºC'),
	(139055, 112, '2015-04-01 00:34:14.000000', 'temperatura', 652.0000, 'ºC'),
	(139056, 112, '2015-04-01 00:34:15.000000', 'temperatura', 592.0000, 'ºC'),
	(139057, 112, '2015-04-01 00:34:16.000000', 'temperatura', 1007.0000, 'ºC'),
	(139058, 112, '2015-04-01 00:34:17.000000', 'temperatura', 861.0000, 'ºC'),
	(139059, 112, '2015-04-01 00:34:18.000000', 'temperatura', 83.0000, 'ºC'),
	(139060, 112, '2015-04-01 00:34:19.000000', 'temperatura', 232.0000, 'ºC'),
	(139061, 112, '2015-04-01 00:34:20.000000', 'temperatura', 912.0000, 'ºC'),
	(139062, 112, '2015-04-01 00:34:21.000000', 'temperatura', 264.0000, 'ºC'),
	(139063, 112, '2015-04-01 00:34:22.000000', 'temperatura', 985.0000, 'ºC'),
	(139064, 112, '2015-04-01 00:34:23.000000', 'temperatura', 532.0000, 'ºC'),
	(139065, 112, '2015-04-01 00:34:24.000000', 'temperatura', 908.0000, 'ºC'),
	(139066, 112, '2015-04-01 00:34:25.000000', 'temperatura', 543.0000, 'ºC'),
	(139067, 112, '2015-04-01 00:34:26.000000', 'temperatura', 1193.0000, 'ºC'),
	(139068, 112, '2015-04-01 00:34:27.000000', 'temperatura', 735.0000, 'ºC'),
	(139069, 112, '2015-04-01 00:34:28.000000', 'temperatura', 98.0000, 'ºC'),
	(139070, 112, '2015-04-01 00:34:29.000000', 'temperatura', 686.0000, 'ºC'),
	(139071, 112, '2015-04-01 00:34:30.000000', 'temperatura', 734.0000, 'ºC'),
	(139072, 112, '2015-04-01 00:34:31.000000', 'temperatura', 415.0000, 'ºC'),
	(139073, 112, '2015-04-01 00:34:32.000000', 'temperatura', 1073.0000, 'ºC'),
	(139074, 112, '2015-04-01 00:34:33.000000', 'temperatura', 520.0000, 'ºC'),
	(139075, 112, '2015-04-01 00:34:34.000000', 'temperatura', 581.0000, 'ºC'),
	(139076, 112, '2015-04-01 00:34:35.000000', 'temperatura', 147.0000, 'ºC'),
	(139077, 112, '2015-04-01 00:34:36.000000', 'temperatura', 194.0000, 'ºC'),
	(139078, 112, '2015-04-01 00:34:37.000000', 'temperatura', 526.0000, 'ºC'),
	(139079, 112, '2015-04-01 00:34:38.000000', 'temperatura', 851.0000, 'ºC'),
	(139080, 112, '2015-04-01 00:34:39.000000', 'temperatura', 275.0000, 'ºC'),
	(139081, 112, '2015-04-01 00:34:40.000000', 'temperatura', 25.0000, 'ºC'),
	(139082, 112, '2015-04-01 00:34:41.000000', 'temperatura', 500.0000, 'ºC'),
	(139083, 112, '2015-04-01 00:34:42.000000', 'temperatura', 25.0000, 'ºC'),
	(139084, 112, '2015-04-01 00:34:43.000000', 'temperatura', 1027.0000, 'ºC'),
	(139085, 112, '2015-04-01 00:34:44.000000', 'temperatura', 259.0000, 'ºC'),
	(139086, 112, '2015-04-01 00:34:45.000000', 'temperatura', 614.0000, 'ºC'),
	(139087, 112, '2015-04-01 00:34:46.000000', 'temperatura', 1094.0000, 'ºC'),
	(139088, 112, '2015-04-01 00:34:47.000000', 'temperatura', 28.0000, 'ºC'),
	(139089, 112, '2015-04-01 00:34:48.000000', 'temperatura', 457.0000, 'ºC'),
	(139090, 112, '2015-04-01 00:34:49.000000', 'temperatura', 1005.0000, 'ºC'),
	(139091, 112, '2015-04-01 00:34:50.000000', 'temperatura', 52.0000, 'ºC'),
	(139092, 112, '2015-04-01 00:34:51.000000', 'temperatura', 848.0000, 'ºC'),
	(139093, 112, '2015-04-01 00:34:52.000000', 'temperatura', 484.0000, 'ºC'),
	(139094, 112, '2015-04-01 00:34:53.000000', 'temperatura', 1077.0000, 'ºC'),
	(139095, 112, '2015-04-01 00:34:54.000000', 'temperatura', 333.0000, 'ºC'),
	(139096, 112, '2015-04-01 00:34:55.000000', 'temperatura', 835.0000, 'ºC'),
	(139097, 112, '2015-04-01 00:34:56.000000', 'temperatura', 774.0000, 'ºC'),
	(139098, 112, '2015-04-01 00:34:57.000000', 'temperatura', 169.0000, 'ºC'),
	(139099, 112, '2015-04-01 00:34:58.000000', 'temperatura', 922.0000, 'ºC'),
	(139100, 112, '2015-04-01 00:34:59.000000', 'temperatura', 504.0000, 'ºC'),
	(139101, 112, '2015-04-01 00:35:00.000000', 'temperatura', 956.0000, 'ºC'),
	(139102, 112, '2015-04-01 00:35:01.000000', 'temperatura', 868.0000, 'ºC'),
	(139103, 112, '2015-04-01 00:35:02.000000', 'temperatura', 274.0000, 'ºC'),
	(139104, 112, '2015-04-01 00:35:03.000000', 'temperatura', 1164.0000, 'ºC'),
	(139105, 112, '2015-04-01 00:35:04.000000', 'temperatura', 198.0000, 'ºC'),
	(139106, 112, '2015-04-01 00:35:05.000000', 'temperatura', 1098.0000, 'ºC'),
	(139107, 112, '2015-04-01 00:35:06.000000', 'temperatura', 95.0000, 'ºC'),
	(139108, 112, '2015-04-01 00:35:07.000000', 'temperatura', 785.0000, 'ºC'),
	(139109, 112, '2015-04-01 00:35:08.000000', 'temperatura', 40.0000, 'ºC'),
	(139110, 112, '2015-04-01 00:35:09.000000', 'temperatura', 246.0000, 'ºC'),
	(139111, 112, '2015-04-01 00:35:10.000000', 'temperatura', 1110.0000, 'ºC'),
	(139112, 112, '2015-04-01 00:35:11.000000', 'temperatura', 14.0000, 'ºC'),
	(139113, 112, '2015-04-01 00:35:12.000000', 'temperatura', 340.0000, 'ºC'),
	(139114, 112, '2015-04-01 00:35:13.000000', 'temperatura', 457.0000, 'ºC'),
	(139115, 112, '2015-04-01 00:35:14.000000', 'temperatura', 66.0000, 'ºC'),
	(139116, 112, '2015-04-01 00:35:15.000000', 'temperatura', 160.0000, 'ºC'),
	(139117, 112, '2015-04-01 00:35:16.000000', 'temperatura', 602.0000, 'ºC'),
	(139118, 112, '2015-04-01 00:35:17.000000', 'temperatura', 129.0000, 'ºC'),
	(139119, 112, '2015-04-01 00:35:18.000000', 'temperatura', 42.0000, 'ºC'),
	(139120, 112, '2015-04-01 00:35:19.000000', 'temperatura', 1023.0000, 'ºC'),
	(139121, 112, '2015-04-01 00:35:20.000000', 'temperatura', 190.0000, 'ºC'),
	(139122, 112, '2015-04-01 00:35:21.000000', 'temperatura', 280.0000, 'ºC'),
	(139123, 112, '2015-04-01 00:35:22.000000', 'temperatura', 830.0000, 'ºC'),
	(139124, 112, '2015-04-01 00:35:23.000000', 'temperatura', 911.0000, 'ºC'),
	(139125, 112, '2015-04-01 00:35:24.000000', 'temperatura', 867.0000, 'ºC'),
	(139126, 112, '2015-04-01 00:35:25.000000', 'temperatura', 402.0000, 'ºC'),
	(139127, 112, '2015-04-01 00:35:26.000000', 'temperatura', 608.0000, 'ºC'),
	(139128, 112, '2015-04-01 00:35:27.000000', 'temperatura', 634.0000, 'ºC'),
	(139129, 112, '2015-04-01 00:35:28.000000', 'temperatura', 145.0000, 'ºC'),
	(139130, 112, '2015-04-01 00:35:29.000000', 'temperatura', 27.0000, 'ºC'),
	(139131, 112, '2015-04-01 00:35:30.000000', 'temperatura', 901.0000, 'ºC'),
	(139132, 112, '2015-04-01 00:35:31.000000', 'temperatura', 821.0000, 'ºC'),
	(139133, 112, '2015-04-01 00:35:32.000000', 'temperatura', 206.0000, 'ºC'),
	(139134, 112, '2015-04-01 00:35:33.000000', 'temperatura', 967.0000, 'ºC'),
	(139135, 112, '2015-04-01 00:35:34.000000', 'temperatura', 616.0000, 'ºC'),
	(139136, 112, '2015-04-01 00:35:35.000000', 'temperatura', 179.0000, 'ºC'),
	(139137, 112, '2015-04-01 00:35:36.000000', 'temperatura', 247.0000, 'ºC'),
	(139138, 112, '2015-04-01 00:35:37.000000', 'temperatura', 700.0000, 'ºC'),
	(139139, 112, '2015-04-01 00:35:38.000000', 'temperatura', 360.0000, 'ºC'),
	(139140, 112, '2015-04-01 00:35:39.000000', 'temperatura', 901.0000, 'ºC'),
	(139141, 112, '2015-04-01 00:35:40.000000', 'temperatura', 1026.0000, 'ºC'),
	(139142, 112, '2015-04-01 00:35:41.000000', 'temperatura', 26.0000, 'ºC'),
	(139143, 112, '2015-04-01 00:35:42.000000', 'temperatura', 654.0000, 'ºC'),
	(139144, 112, '2015-04-01 00:35:43.000000', 'temperatura', 791.0000, 'ºC'),
	(139145, 112, '2015-04-01 00:35:44.000000', 'temperatura', 793.0000, 'ºC'),
	(139146, 112, '2015-04-01 00:35:45.000000', 'temperatura', 395.0000, 'ºC'),
	(139147, 112, '2015-04-01 00:35:46.000000', 'temperatura', 794.0000, 'ºC'),
	(139148, 112, '2015-04-01 00:35:47.000000', 'temperatura', 385.0000, 'ºC'),
	(139149, 112, '2015-04-01 00:35:48.000000', 'temperatura', 743.0000, 'ºC'),
	(139150, 112, '2015-04-01 00:35:49.000000', 'temperatura', 160.0000, 'ºC'),
	(139151, 112, '2015-04-01 00:35:50.000000', 'temperatura', 974.0000, 'ºC'),
	(139152, 112, '2015-04-01 00:35:51.000000', 'temperatura', 791.0000, 'ºC'),
	(139153, 112, '2015-04-01 00:35:52.000000', 'temperatura', 1034.0000, 'ºC'),
	(139154, 112, '2015-04-01 00:35:53.000000', 'temperatura', 398.0000, 'ºC'),
	(139155, 112, '2015-04-01 00:35:54.000000', 'temperatura', 89.0000, 'ºC'),
	(139156, 112, '2015-04-01 00:35:55.000000', 'temperatura', 449.0000, 'ºC'),
	(139157, 112, '2015-04-01 00:35:56.000000', 'temperatura', 779.0000, 'ºC'),
	(139158, 112, '2015-04-01 00:35:57.000000', 'temperatura', 148.0000, 'ºC'),
	(139159, 112, '2015-04-01 00:35:58.000000', 'temperatura', 803.0000, 'ºC'),
	(139160, 112, '2015-04-01 00:35:59.000000', 'temperatura', 1173.0000, 'ºC'),
	(139161, 112, '2015-04-01 00:36:00.000000', 'temperatura', 1055.0000, 'ºC'),
	(139162, 112, '2015-04-01 00:36:01.000000', 'temperatura', 558.0000, 'ºC'),
	(139163, 112, '2015-04-01 00:36:02.000000', 'temperatura', 826.0000, 'ºC'),
	(139164, 112, '2015-04-01 00:36:03.000000', 'temperatura', 54.0000, 'ºC'),
	(139165, 112, '2015-04-01 00:36:04.000000', 'temperatura', 196.0000, 'ºC'),
	(139166, 112, '2015-04-01 00:36:05.000000', 'temperatura', 816.0000, 'ºC'),
	(139167, 112, '2015-04-01 00:36:06.000000', 'temperatura', 1092.0000, 'ºC'),
	(139168, 112, '2015-04-01 00:36:07.000000', 'temperatura', 614.0000, 'ºC'),
	(139169, 112, '2015-04-01 00:36:08.000000', 'temperatura', 994.0000, 'ºC'),
	(139170, 112, '2015-04-01 00:36:09.000000', 'temperatura', 729.0000, 'ºC'),
	(139171, 112, '2015-04-01 00:36:10.000000', 'temperatura', 661.0000, 'ºC'),
	(139172, 112, '2015-04-01 00:36:11.000000', 'temperatura', 1121.0000, 'ºC'),
	(139173, 112, '2015-04-01 00:36:12.000000', 'temperatura', 22.0000, 'ºC'),
	(139174, 112, '2015-04-01 00:36:13.000000', 'temperatura', 346.0000, 'ºC'),
	(139175, 112, '2015-04-01 00:36:14.000000', 'temperatura', 464.0000, 'ºC'),
	(139176, 112, '2015-04-01 00:36:15.000000', 'temperatura', 84.0000, 'ºC'),
	(139177, 112, '2015-04-01 00:36:16.000000', 'temperatura', 229.0000, 'ºC'),
	(139178, 112, '2015-04-01 00:36:17.000000', 'temperatura', 892.0000, 'ºC'),
	(139179, 112, '2015-04-01 00:36:18.000000', 'temperatura', 173.0000, 'ºC'),
	(139180, 112, '2015-04-01 00:36:19.000000', 'temperatura', 590.0000, 'ºC'),
	(139181, 112, '2015-04-01 00:36:20.000000', 'temperatura', 33.0000, 'ºC'),
	(139182, 112, '2015-04-01 00:36:21.000000', 'temperatura', 793.0000, 'ºC'),
	(139183, 112, '2015-04-01 00:36:22.000000', 'temperatura', 266.0000, 'ºC'),
	(139184, 112, '2015-04-01 00:36:23.000000', 'temperatura', 151.0000, 'ºC'),
	(139185, 112, '2015-04-01 00:36:24.000000', 'temperatura', 1158.0000, 'ºC'),
	(139186, 112, '2015-04-01 00:36:25.000000', 'temperatura', 540.0000, 'ºC'),
	(139187, 112, '2015-04-01 00:36:26.000000', 'temperatura', 423.0000, 'ºC'),
	(139188, 112, '2015-04-01 00:36:27.000000', 'temperatura', 497.0000, 'ºC'),
	(139189, 112, '2015-04-01 00:36:28.000000', 'temperatura', 16.0000, 'ºC'),
	(139190, 112, '2015-04-01 00:36:29.000000', 'temperatura', 990.0000, 'ºC'),
	(139191, 112, '2015-04-01 00:36:30.000000', 'temperatura', 104.0000, 'ºC'),
	(139192, 112, '2015-04-01 00:36:31.000000', 'temperatura', 1148.0000, 'ºC'),
	(139193, 112, '2015-04-01 00:36:32.000000', 'temperatura', 628.0000, 'ºC'),
	(139194, 112, '2015-04-01 00:36:33.000000', 'temperatura', 896.0000, 'ºC'),
	(139195, 112, '2015-04-01 00:36:34.000000', 'temperatura', 197.0000, 'ºC'),
	(139196, 112, '2015-04-01 00:36:35.000000', 'temperatura', 699.0000, 'ºC'),
	(139197, 112, '2015-04-01 00:36:36.000000', 'temperatura', 506.0000, 'ºC'),
	(139198, 112, '2015-04-01 00:36:37.000000', 'temperatura', 431.0000, 'ºC'),
	(139199, 112, '2015-04-01 00:36:38.000000', 'temperatura', 639.0000, 'ºC'),
	(139200, 112, '2015-04-01 00:36:39.000000', 'temperatura', 700.0000, 'ºC'),
	(139201, 112, '2015-04-01 00:36:40.000000', 'temperatura', 387.0000, 'ºC'),
	(139202, 112, '2015-04-01 00:36:41.000000', 'temperatura', 1034.0000, 'ºC'),
	(139203, 112, '2015-04-01 00:36:42.000000', 'temperatura', 408.0000, 'ºC'),
	(139204, 112, '2015-04-01 00:36:43.000000', 'temperatura', 140.0000, 'ºC'),
	(139205, 112, '2015-04-01 00:36:44.000000', 'temperatura', 675.0000, 'ºC'),
	(139206, 112, '2015-04-01 00:36:45.000000', 'temperatura', 555.0000, 'ºC'),
	(139207, 112, '2015-04-01 00:36:46.000000', 'temperatura', 753.0000, 'ºC'),
	(139208, 112, '2015-04-01 00:36:47.000000', 'temperatura', 897.0000, 'ºC'),
	(139209, 112, '2015-04-01 00:36:48.000000', 'temperatura', 1030.0000, 'ºC'),
	(139210, 112, '2015-04-01 00:36:49.000000', 'temperatura', 58.0000, 'ºC'),
	(139211, 112, '2015-04-01 00:36:50.000000', 'temperatura', 801.0000, 'ºC'),
	(139212, 112, '2015-04-01 00:36:51.000000', 'temperatura', 232.0000, 'ºC'),
	(139213, 112, '2015-04-01 00:36:52.000000', 'temperatura', 1157.0000, 'ºC'),
	(139214, 112, '2015-04-01 00:36:53.000000', 'temperatura', 289.0000, 'ºC'),
	(139215, 112, '2015-04-01 00:36:54.000000', 'temperatura', 375.0000, 'ºC'),
	(139216, 112, '2015-04-01 00:36:55.000000', 'temperatura', 1007.0000, 'ºC'),
	(139217, 112, '2015-04-01 00:36:56.000000', 'temperatura', 311.0000, 'ºC'),
	(139218, 112, '2015-04-01 00:36:57.000000', 'temperatura', 937.0000, 'ºC'),
	(139219, 112, '2015-04-01 00:36:58.000000', 'temperatura', 149.0000, 'ºC'),
	(139220, 112, '2015-04-01 00:36:59.000000', 'temperatura', 335.0000, 'ºC'),
	(139221, 112, '2015-04-01 00:37:00.000000', 'temperatura', 30.0000, 'ºC'),
	(139222, 112, '2015-04-01 00:37:01.000000', 'temperatura', 346.0000, 'ºC'),
	(139223, 112, '2015-04-01 00:37:02.000000', 'temperatura', 438.0000, 'ºC'),
	(139224, 112, '2015-04-01 00:37:03.000000', 'temperatura', 1152.0000, 'ºC'),
	(139225, 112, '2015-04-01 00:37:04.000000', 'temperatura', 849.0000, 'ºC'),
	(139226, 112, '2015-04-01 00:37:05.000000', 'temperatura', 787.0000, 'ºC'),
	(139227, 112, '2015-04-01 00:37:06.000000', 'temperatura', 190.0000, 'ºC'),
	(139228, 112, '2015-04-01 00:37:07.000000', 'temperatura', 989.0000, 'ºC'),
	(139229, 112, '2015-04-01 00:37:08.000000', 'temperatura', 775.0000, 'ºC'),
	(139230, 112, '2015-04-01 00:37:09.000000', 'temperatura', 911.0000, 'ºC'),
	(139231, 112, '2015-04-01 00:37:10.000000', 'temperatura', 1028.0000, 'ºC'),
	(139232, 112, '2015-04-01 00:37:11.000000', 'temperatura', 10.0000, 'ºC'),
	(139233, 112, '2015-04-01 00:37:12.000000', 'temperatura', 563.0000, 'ºC'),
	(139234, 112, '2015-04-01 00:37:13.000000', 'temperatura', 389.0000, 'ºC'),
	(139235, 112, '2015-04-01 00:37:14.000000', 'temperatura', 256.0000, 'ºC'),
	(139236, 112, '2015-04-01 00:37:15.000000', 'temperatura', 111.0000, 'ºC'),
	(139237, 112, '2015-04-01 00:37:16.000000', 'temperatura', 990.0000, 'ºC'),
	(139238, 112, '2015-04-01 00:37:17.000000', 'temperatura', 1018.0000, 'ºC'),
	(139239, 112, '2015-04-01 00:37:18.000000', 'temperatura', 921.0000, 'ºC'),
	(139240, 112, '2015-04-01 00:37:19.000000', 'temperatura', 351.0000, 'ºC'),
	(139241, 112, '2015-04-01 00:37:20.000000', 'temperatura', 194.0000, 'ºC'),
	(139242, 112, '2015-04-01 00:37:21.000000', 'temperatura', 1116.0000, 'ºC'),
	(139243, 112, '2015-04-01 00:37:22.000000', 'temperatura', 198.0000, 'ºC'),
	(139244, 112, '2015-04-01 00:37:23.000000', 'temperatura', 41.0000, 'ºC'),
	(139245, 112, '2015-04-01 00:37:24.000000', 'temperatura', 814.0000, 'ºC'),
	(139246, 112, '2015-04-01 00:37:25.000000', 'temperatura', 347.0000, 'ºC'),
	(139247, 112, '2015-04-01 00:37:26.000000', 'temperatura', 494.0000, 'ºC'),
	(139248, 112, '2015-04-01 00:37:27.000000', 'temperatura', 230.0000, 'ºC'),
	(139249, 112, '2015-04-01 00:37:28.000000', 'temperatura', 866.0000, 'ºC'),
	(139250, 112, '2015-04-01 00:37:29.000000', 'temperatura', 40.0000, 'ºC'),
	(139251, 112, '2015-04-01 00:37:30.000000', 'temperatura', 5.0000, 'ºC'),
	(139252, 112, '2015-04-01 00:37:31.000000', 'temperatura', 1105.0000, 'ºC'),
	(139253, 112, '2015-04-01 00:37:32.000000', 'temperatura', 710.0000, 'ºC'),
	(139254, 112, '2015-04-01 00:37:33.000000', 'temperatura', 237.0000, 'ºC'),
	(139255, 112, '2015-04-01 00:37:34.000000', 'temperatura', 256.0000, 'ºC'),
	(139256, 112, '2015-04-01 00:37:35.000000', 'temperatura', 570.0000, 'ºC'),
	(139257, 112, '2015-04-01 00:37:36.000000', 'temperatura', 879.0000, 'ºC'),
	(139258, 112, '2015-04-01 00:37:37.000000', 'temperatura', 289.0000, 'ºC'),
	(139259, 112, '2015-04-01 00:37:38.000000', 'temperatura', 9.0000, 'ºC'),
	(139260, 112, '2015-04-01 00:37:39.000000', 'temperatura', 376.0000, 'ºC'),
	(139261, 112, '2015-04-01 00:37:40.000000', 'temperatura', 655.0000, 'ºC'),
	(139262, 112, '2015-04-01 00:37:41.000000', 'temperatura', 945.0000, 'ºC'),
	(139263, 112, '2015-04-01 00:37:42.000000', 'temperatura', 362.0000, 'ºC'),
	(139264, 112, '2015-04-01 00:37:43.000000', 'temperatura', 177.0000, 'ºC'),
	(139265, 112, '2015-04-01 00:37:44.000000', 'temperatura', 997.0000, 'ºC'),
	(139266, 112, '2015-04-01 00:37:45.000000', 'temperatura', 856.0000, 'ºC'),
	(139267, 112, '2015-04-01 00:37:46.000000', 'temperatura', 91.0000, 'ºC'),
	(139268, 112, '2015-04-01 00:37:47.000000', 'temperatura', 286.0000, 'ºC'),
	(139269, 112, '2015-04-01 00:37:48.000000', 'temperatura', 1155.0000, 'ºC'),
	(139270, 112, '2015-04-01 00:37:49.000000', 'temperatura', 121.0000, 'ºC'),
	(139271, 112, '2015-04-01 00:37:50.000000', 'temperatura', 741.0000, 'ºC'),
	(139272, 112, '2015-04-01 00:37:51.000000', 'temperatura', 943.0000, 'ºC'),
	(139273, 112, '2015-04-01 00:37:52.000000', 'temperatura', 93.0000, 'ºC'),
	(139274, 112, '2015-04-01 00:37:53.000000', 'temperatura', 35.0000, 'ºC'),
	(139275, 112, '2015-04-01 00:37:54.000000', 'temperatura', 1096.0000, 'ºC'),
	(139276, 112, '2015-04-01 00:37:55.000000', 'temperatura', 577.0000, 'ºC'),
	(139277, 112, '2015-04-01 00:37:56.000000', 'temperatura', 799.0000, 'ºC'),
	(139278, 112, '2015-04-01 00:37:57.000000', 'temperatura', 1061.0000, 'ºC'),
	(139279, 112, '2015-04-01 00:37:58.000000', 'temperatura', 511.0000, 'ºC'),
	(139280, 112, '2015-04-01 00:37:59.000000', 'temperatura', 573.0000, 'ºC'),
	(139281, 112, '2015-04-01 00:38:00.000000', 'temperatura', 133.0000, 'ºC'),
	(139282, 112, '2015-04-01 00:38:01.000000', 'temperatura', 144.0000, 'ºC'),
	(139283, 112, '2015-04-01 00:38:02.000000', 'temperatura', 321.0000, 'ºC'),
	(139284, 112, '2015-04-01 00:38:03.000000', 'temperatura', 1175.0000, 'ºC'),
	(139285, 112, '2015-04-01 00:38:04.000000', 'temperatura', 111.0000, 'ºC'),
	(139286, 112, '2015-04-01 00:38:05.000000', 'temperatura', 630.0000, 'ºC'),
	(139287, 112, '2015-04-01 00:38:06.000000', 'temperatura', 419.0000, 'ºC'),
	(139288, 112, '2015-04-01 00:38:07.000000', 'temperatura', 205.0000, 'ºC'),
	(139289, 112, '2015-04-01 00:38:08.000000', 'temperatura', 969.0000, 'ºC'),
	(139290, 112, '2015-04-01 00:38:09.000000', 'temperatura', 630.0000, 'ºC'),
	(139291, 112, '2015-04-01 00:38:10.000000', 'temperatura', 245.0000, 'ºC'),
	(139292, 112, '2015-04-01 00:38:11.000000', 'temperatura', 534.0000, 'ºC'),
	(139293, 112, '2015-04-01 00:38:12.000000', 'temperatura', 734.0000, 'ºC'),
	(139294, 112, '2015-04-01 00:38:13.000000', 'temperatura', 871.0000, 'ºC'),
	(139295, 112, '2015-04-01 00:38:14.000000', 'temperatura', 954.0000, 'ºC'),
	(139296, 112, '2015-04-01 00:38:15.000000', 'temperatura', 957.0000, 'ºC'),
	(139297, 112, '2015-04-01 00:38:16.000000', 'temperatura', 725.0000, 'ºC'),
	(139298, 112, '2015-04-01 00:38:17.000000', 'temperatura', 751.0000, 'ºC'),
	(139299, 112, '2015-04-01 00:38:18.000000', 'temperatura', 383.0000, 'ºC'),
	(139300, 112, '2015-04-01 00:38:19.000000', 'temperatura', 861.0000, 'ºC'),
	(139301, 112, '2015-04-01 00:38:20.000000', 'temperatura', 757.0000, 'ºC'),
	(139302, 112, '2015-04-01 00:38:21.000000', 'temperatura', 3.0000, 'ºC'),
	(139303, 112, '2015-04-01 00:38:22.000000', 'temperatura', 142.0000, 'ºC'),
	(139304, 112, '2015-04-01 00:38:23.000000', 'temperatura', 704.0000, 'ºC'),
	(139305, 112, '2015-04-01 00:38:24.000000', 'temperatura', 693.0000, 'ºC'),
	(139306, 112, '2015-04-01 00:38:25.000000', 'temperatura', 155.0000, 'ºC'),
	(139307, 112, '2015-04-01 00:38:26.000000', 'temperatura', 1096.0000, 'ºC'),
	(139308, 112, '2015-04-01 00:38:27.000000', 'temperatura', 217.0000, 'ºC'),
	(139309, 112, '2015-04-01 00:38:28.000000', 'temperatura', 196.0000, 'ºC'),
	(139310, 112, '2015-04-01 00:38:29.000000', 'temperatura', 332.0000, 'ºC'),
	(139311, 112, '2015-04-01 00:38:30.000000', 'temperatura', 1069.0000, 'ºC'),
	(139312, 112, '2015-04-01 00:38:31.000000', 'temperatura', 752.0000, 'ºC'),
	(139313, 112, '2015-04-01 00:38:32.000000', 'temperatura', 552.0000, 'ºC'),
	(139314, 112, '2015-04-01 00:38:33.000000', 'temperatura', 505.0000, 'ºC'),
	(139315, 112, '2015-04-01 00:38:34.000000', 'temperatura', 867.0000, 'ºC'),
	(139316, 112, '2015-04-01 00:38:35.000000', 'temperatura', 424.0000, 'ºC'),
	(139317, 112, '2015-04-01 00:38:36.000000', 'temperatura', 719.0000, 'ºC'),
	(139318, 112, '2015-04-01 00:38:37.000000', 'temperatura', 1123.0000, 'ºC'),
	(139319, 112, '2015-04-01 00:38:38.000000', 'temperatura', 1057.0000, 'ºC'),
	(139320, 112, '2015-04-01 00:38:39.000000', 'temperatura', 717.0000, 'ºC'),
	(139321, 112, '2015-04-01 00:38:40.000000', 'temperatura', 413.0000, 'ºC'),
	(139322, 112, '2015-04-01 00:38:41.000000', 'temperatura', 1115.0000, 'ºC'),
	(139323, 112, '2015-04-01 00:38:42.000000', 'temperatura', 737.0000, 'ºC'),
	(139324, 112, '2015-04-01 00:38:43.000000', 'temperatura', 339.0000, 'ºC'),
	(139325, 112, '2015-04-01 00:38:44.000000', 'temperatura', 684.0000, 'ºC'),
	(139326, 112, '2015-04-01 00:38:45.000000', 'temperatura', 5.0000, 'ºC'),
	(139327, 112, '2015-04-01 00:38:46.000000', 'temperatura', 374.0000, 'ºC'),
	(139328, 112, '2015-04-01 00:38:47.000000', 'temperatura', 656.0000, 'ºC'),
	(139329, 112, '2015-04-01 00:38:48.000000', 'temperatura', 957.0000, 'ºC'),
	(139330, 112, '2015-04-01 00:38:49.000000', 'temperatura', 420.0000, 'ºC'),
	(139331, 112, '2015-04-01 00:38:50.000000', 'temperatura', 426.0000, 'ºC'),
	(139332, 112, '2015-04-01 00:38:51.000000', 'temperatura', 872.0000, 'ºC'),
	(139333, 112, '2015-04-01 00:38:52.000000', 'temperatura', 683.0000, 'ºC'),
	(139334, 112, '2015-04-01 00:38:53.000000', 'temperatura', 798.0000, 'ºC'),
	(139335, 112, '2015-04-01 00:38:54.000000', 'temperatura', 742.0000, 'ºC'),
	(139336, 112, '2015-04-01 00:38:55.000000', 'temperatura', 117.0000, 'ºC'),
	(139337, 112, '2015-04-01 00:38:56.000000', 'temperatura', 760.0000, 'ºC'),
	(139338, 112, '2015-04-01 00:38:57.000000', 'temperatura', 1048.0000, 'ºC'),
	(139339, 112, '2015-04-01 00:38:58.000000', 'temperatura', 560.0000, 'ºC'),
	(139340, 112, '2015-04-01 00:38:59.000000', 'temperatura', 857.0000, 'ºC'),
	(139341, 112, '2015-04-01 00:39:00.000000', 'temperatura', 207.0000, 'ºC'),
	(139342, 112, '2015-04-01 00:39:01.000000', 'temperatura', 864.0000, 'ºC'),
	(139343, 112, '2015-04-01 00:39:02.000000', 'temperatura', 99.0000, 'ºC'),
	(139344, 112, '2015-04-01 00:39:03.000000', 'temperatura', 302.0000, 'ºC'),
	(139345, 112, '2015-04-01 00:39:04.000000', 'temperatura', 16.0000, 'ºC'),
	(139346, 112, '2015-04-01 00:39:05.000000', 'temperatura', 375.0000, 'ºC'),
	(139347, 112, '2015-04-01 00:39:06.000000', 'temperatura', 626.0000, 'ºC'),
	(139348, 112, '2015-04-01 00:39:07.000000', 'temperatura', 807.0000, 'ºC'),
	(139349, 112, '2015-04-01 00:39:08.000000', 'temperatura', 957.0000, 'ºC'),
	(139350, 112, '2015-04-01 00:39:09.000000', 'temperatura', 1164.0000, 'ºC'),
	(139351, 112, '2015-04-01 00:39:10.000000', 'temperatura', 550.0000, 'ºC'),
	(139352, 112, '2015-04-01 00:39:11.000000', 'temperatura', 460.0000, 'ºC'),
	(139353, 112, '2015-04-01 00:39:12.000000', 'temperatura', 649.0000, 'ºC'),
	(139354, 112, '2015-04-01 00:39:13.000000', 'temperatura', 667.0000, 'ºC'),
	(139355, 112, '2015-04-01 00:39:14.000000', 'temperatura', 187.0000, 'ºC'),
	(139356, 112, '2015-04-01 00:39:15.000000', 'temperatura', 136.0000, 'ºC'),
	(139357, 112, '2015-04-01 00:39:16.000000', 'temperatura', 118.0000, 'ºC'),
	(139358, 112, '2015-04-01 00:39:17.000000', 'temperatura', 181.0000, 'ºC'),
	(139359, 112, '2015-04-01 00:39:18.000000', 'temperatura', 554.0000, 'ºC'),
	(139360, 112, '2015-04-01 00:39:19.000000', 'temperatura', 1027.0000, 'ºC'),
	(139361, 112, '2015-04-01 00:39:20.000000', 'temperatura', 1075.0000, 'ºC'),
	(139362, 112, '2015-04-01 00:39:21.000000', 'temperatura', 1091.0000, 'ºC'),
	(139363, 112, '2015-04-01 00:39:22.000000', 'temperatura', 1033.0000, 'ºC'),
	(139364, 112, '2015-04-01 00:39:23.000000', 'temperatura', 692.0000, 'ºC'),
	(139365, 112, '2015-04-01 00:39:24.000000', 'temperatura', 362.0000, 'ºC'),
	(139366, 112, '2015-04-01 00:39:25.000000', 'temperatura', 934.0000, 'ºC'),
	(139367, 112, '2015-04-01 00:39:26.000000', 'temperatura', 1186.0000, 'ºC'),
	(139368, 112, '2015-04-01 00:39:27.000000', 'temperatura', 727.0000, 'ºC'),
	(139369, 112, '2015-04-01 00:39:28.000000', 'temperatura', 76.0000, 'ºC'),
	(139370, 112, '2015-04-01 00:39:29.000000', 'temperatura', 600.0000, 'ºC'),
	(139371, 112, '2015-04-01 00:39:30.000000', 'temperatura', 373.0000, 'ºC'),
	(139372, 112, '2015-04-01 00:39:31.000000', 'temperatura', 67.0000, 'ºC'),
	(139373, 112, '2015-04-01 00:39:32.000000', 'temperatura', 416.0000, 'ºC'),
	(139374, 112, '2015-04-01 00:39:33.000000', 'temperatura', 680.0000, 'ºC'),
	(139375, 112, '2015-04-01 00:39:34.000000', 'temperatura', 953.0000, 'ºC'),
	(139376, 112, '2015-04-01 00:39:35.000000', 'temperatura', 323.0000, 'ºC'),
	(139377, 112, '2015-04-01 00:39:36.000000', 'temperatura', 1157.0000, 'ºC'),
	(139378, 112, '2015-04-01 00:39:37.000000', 'temperatura', 16.0000, 'ºC'),
	(139379, 112, '2015-04-01 00:39:38.000000', 'temperatura', 210.0000, 'ºC'),
	(139380, 112, '2015-04-01 00:39:39.000000', 'temperatura', 1002.0000, 'ºC'),
	(139381, 112, '2015-04-01 00:39:40.000000', 'temperatura', 780.0000, 'ºC'),
	(139382, 112, '2015-04-01 00:39:41.000000', 'temperatura', 893.0000, 'ºC'),
	(139383, 112, '2015-04-01 00:39:42.000000', 'temperatura', 928.0000, 'ºC'),
	(139384, 112, '2015-04-01 00:39:43.000000', 'temperatura', 759.0000, 'ºC'),
	(139385, 112, '2015-04-01 00:39:44.000000', 'temperatura', 1011.0000, 'ºC'),
	(139386, 112, '2015-04-01 00:39:45.000000', 'temperatura', 381.0000, 'ºC'),
	(139387, 112, '2015-04-01 00:39:46.000000', 'temperatura', 73.0000, 'ºC'),
	(139388, 112, '2015-04-01 00:39:47.000000', 'temperatura', 421.0000, 'ºC'),
	(139389, 112, '2015-04-01 00:39:48.000000', 'temperatura', 687.0000, 'ºC'),
	(139390, 112, '2015-04-01 00:39:49.000000', 'temperatura', 972.0000, 'ºC'),
	(139391, 112, '2015-04-01 00:39:50.000000', 'temperatura', 400.0000, 'ºC'),
	(139392, 112, '2015-04-01 00:39:51.000000', 'temperatura', 285.0000, 'ºC'),
	(139393, 112, '2015-04-01 00:39:52.000000', 'temperatura', 223.0000, 'ºC'),
	(139394, 112, '2015-04-01 00:39:53.000000', 'temperatura', 263.0000, 'ºC'),
	(139395, 112, '2015-04-01 00:39:54.000000', 'temperatura', 645.0000, 'ºC'),
	(139396, 112, '2015-04-01 00:39:55.000000', 'temperatura', 35.0000, 'ºC'),
	(139397, 112, '2015-04-01 00:39:56.000000', 'temperatura', 644.0000, 'ºC'),
	(139398, 112, '2015-04-01 00:39:57.000000', 'temperatura', 714.0000, 'ºC'),
	(139399, 112, '2015-04-01 00:39:58.000000', 'temperatura', 439.0000, 'ºC'),
	(139400, 112, '2015-04-01 00:39:59.000000', 'temperatura', 55.0000, 'ºC'),
	(139401, 112, '2015-04-01 00:40:00.000000', 'temperatura', 158.0000, 'ºC'),
	(139402, 112, '2015-04-01 00:40:01.000000', 'temperatura', 625.0000, 'ºC'),
	(139403, 112, '2015-04-01 00:40:02.000000', 'temperatura', 251.0000, 'ºC'),
	(139404, 112, '2015-04-01 00:40:03.000000', 'temperatura', 580.0000, 'ºC'),
	(139405, 112, '2015-04-01 00:40:04.000000', 'temperatura', 948.0000, 'ºC'),
	(139406, 112, '2015-04-01 00:40:05.000000', 'temperatura', 601.0000, 'ºC'),
	(139407, 112, '2015-04-01 00:40:06.000000', 'temperatura', 160.0000, 'ºC'),
	(139408, 112, '2015-04-01 00:40:07.000000', 'temperatura', 199.0000, 'ºC'),
	(139409, 112, '2015-04-01 00:40:08.000000', 'temperatura', 517.0000, 'ºC'),
	(139410, 112, '2015-04-01 00:40:09.000000', 'temperatura', 788.0000, 'ºC'),
	(139411, 112, '2015-04-01 00:40:10.000000', 'temperatura', 1187.0000, 'ºC'),
	(139412, 112, '2015-04-01 00:40:11.000000', 'temperatura', 1173.0000, 'ºC'),
	(139413, 112, '2015-04-01 00:40:12.000000', 'temperatura', 1104.0000, 'ºC'),
	(139414, 112, '2015-04-01 00:40:13.000000', 'temperatura', 804.0000, 'ºC'),
	(139415, 112, '2015-04-01 00:40:14.000000', 'temperatura', 705.0000, 'ºC'),
	(139416, 112, '2015-04-01 00:40:15.000000', 'temperatura', 1115.0000, 'ºC'),
	(139417, 112, '2015-04-01 00:40:16.000000', 'temperatura', 1062.0000, 'ºC'),
	(139418, 112, '2015-04-01 00:40:17.000000', 'temperatura', 764.0000, 'ºC'),
	(139419, 112, '2015-04-01 00:40:18.000000', 'temperatura', 633.0000, 'ºC'),
	(139420, 112, '2015-04-01 00:40:19.000000', 'temperatura', 874.0000, 'ºC'),
	(139421, 112, '2015-04-01 00:40:20.000000', 'temperatura', 71.0000, 'ºC'),
	(139422, 112, '2015-04-01 00:40:21.000000', 'temperatura', 135.0000, 'ºC'),
	(139423, 112, '2015-04-01 00:40:22.000000', 'temperatura', 463.0000, 'ºC'),
	(139424, 112, '2015-04-01 00:40:23.000000', 'temperatura', 708.0000, 'ºC'),
	(139425, 112, '2015-04-01 00:40:24.000000', 'temperatura', 952.0000, 'ºC'),
	(139426, 112, '2015-04-01 00:40:25.000000', 'temperatura', 236.0000, 'ºC'),
	(139427, 112, '2015-04-01 00:40:26.000000', 'temperatura', 727.0000, 'ºC'),
	(139428, 112, '2015-04-01 00:40:27.000000', 'temperatura', 524.0000, 'ºC'),
	(139429, 112, '2015-04-01 00:40:28.000000', 'temperatura', 442.0000, 'ºC'),
	(139430, 112, '2015-04-01 00:40:29.000000', 'temperatura', 639.0000, 'ºC'),
	(139431, 112, '2015-04-01 00:40:30.000000', 'temperatura', 669.0000, 'ºC'),
	(139432, 112, '2015-04-01 00:40:31.000000', 'temperatura', 230.0000, 'ºC'),
	(139433, 112, '2015-04-01 00:40:32.000000', 'temperatura', 344.0000, 'ºC'),
	(139434, 112, '2015-04-01 00:40:33.000000', 'temperatura', 1030.0000, 'ºC'),
	(139435, 112, '2015-04-01 00:40:34.000000', 'temperatura', 517.0000, 'ºC'),
	(139436, 112, '2015-04-01 00:40:35.000000', 'temperatura', 696.0000, 'ºC'),
	(139437, 112, '2015-04-01 00:40:36.000000', 'temperatura', 729.0000, 'ºC'),
	(139438, 112, '2015-04-01 00:40:37.000000', 'temperatura', 356.0000, 'ºC'),
	(139439, 112, '2015-04-01 00:40:38.000000', 'temperatura', 796.0000, 'ºC'),
	(139440, 112, '2015-04-01 00:40:39.000000', 'temperatura', 513.0000, 'ºC'),
	(139441, 112, '2015-04-01 00:40:40.000000', 'temperatura', 176.0000, 'ºC'),
	(139442, 112, '2015-04-01 00:40:41.000000', 'temperatura', 542.0000, 'ºC'),
	(139443, 112, '2015-04-01 00:40:42.000000', 'temperatura', 983.0000, 'ºC'),
	(139444, 112, '2015-04-01 00:40:43.000000', 'temperatura', 890.0000, 'ºC'),
	(139445, 112, '2015-04-01 00:40:44.000000', 'temperatura', 300.0000, 'ºC'),
	(139446, 112, '2015-04-01 00:40:45.000000', 'temperatura', 30.0000, 'ºC'),
	(139447, 112, '2015-04-01 00:40:46.000000', 'temperatura', 451.0000, 'ºC'),
	(139448, 112, '2015-04-01 00:40:47.000000', 'temperatura', 964.0000, 'ºC'),
	(139449, 112, '2015-04-01 00:40:48.000000', 'temperatura', 1067.0000, 'ºC'),
	(139450, 112, '2015-04-01 00:40:49.000000', 'temperatura', 44.0000, 'ºC'),
	(139451, 112, '2015-04-01 00:40:50.000000', 'temperatura', 622.0000, 'ºC'),
	(139452, 112, '2015-04-01 00:40:51.000000', 'temperatura', 577.0000, 'ºC'),
	(139453, 112, '2015-04-01 00:40:52.000000', 'temperatura', 1021.0000, 'ºC'),
	(139454, 112, '2015-04-01 00:40:53.000000', 'temperatura', 974.0000, 'ºC'),
	(139455, 112, '2015-04-01 00:40:54.000000', 'temperatura', 609.0000, 'ºC'),
	(139456, 112, '2015-04-01 00:40:55.000000', 'temperatura', 123.0000, 'ºC'),
	(139457, 112, '2015-04-01 00:40:56.000000', 'temperatura', 1189.0000, 'ºC'),
	(139458, 112, '2015-04-01 00:40:57.000000', 'temperatura', 777.0000, 'ºC'),
	(139459, 112, '2015-04-01 00:40:58.000000', 'temperatura', 316.0000, 'ºC'),
	(139460, 112, '2015-04-01 00:40:59.000000', 'temperatura', 449.0000, 'ºC'),
	(139461, 112, '2015-04-01 00:41:00.000000', 'temperatura', 100.0000, 'ºC'),
	(139462, 112, '2015-04-01 00:41:01.000000', 'temperatura', 351.0000, 'ºC'),
	(139463, 112, '2015-04-01 00:41:02.000000', 'temperatura', 257.0000, 'ºC'),
	(139464, 112, '2015-04-01 00:41:03.000000', 'temperatura', 232.0000, 'ºC'),
	(139465, 112, '2015-04-01 00:41:04.000000', 'temperatura', 389.0000, 'ºC'),
	(139466, 112, '2015-04-01 00:41:05.000000', 'temperatura', 52.0000, 'ºC'),
	(139467, 112, '2015-04-01 00:41:06.000000', 'temperatura', 290.0000, 'ºC'),
	(139468, 112, '2015-04-01 00:41:07.000000', 'temperatura', 97.0000, 'ºC'),
	(139469, 112, '2015-04-01 00:41:08.000000', 'temperatura', 814.0000, 'ºC'),
	(139470, 112, '2015-04-01 00:41:09.000000', 'temperatura', 178.0000, 'ºC'),
	(139471, 112, '2015-04-01 00:41:10.000000', 'temperatura', 850.0000, 'ºC'),
	(139472, 112, '2015-04-01 00:41:11.000000', 'temperatura', 115.0000, 'ºC'),
	(139473, 112, '2015-04-01 00:41:12.000000', 'temperatura', 427.0000, 'ºC'),
	(139474, 112, '2015-04-01 00:41:13.000000', 'temperatura', 588.0000, 'ºC'),
	(139475, 112, '2015-04-01 00:41:14.000000', 'temperatura', 462.0000, 'ºC'),
	(139476, 112, '2015-04-01 00:41:15.000000', 'temperatura', 544.0000, 'ºC'),
	(139477, 112, '2015-04-01 00:41:16.000000', 'temperatura', 137.0000, 'ºC'),
	(139478, 112, '2015-04-01 00:41:17.000000', 'temperatura', 251.0000, 'ºC'),
	(139479, 112, '2015-04-01 00:41:18.000000', 'temperatura', 846.0000, 'ºC'),
	(139480, 112, '2015-04-01 00:41:19.000000', 'temperatura', 1078.0000, 'ºC'),
	(139481, 112, '2015-04-01 00:41:20.000000', 'temperatura', 454.0000, 'ºC'),
	(139482, 112, '2015-04-01 00:41:21.000000', 'temperatura', 234.0000, 'ºC'),
	(139483, 112, '2015-04-01 00:41:22.000000', 'temperatura', 1011.0000, 'ºC'),
	(139484, 112, '2015-04-01 00:41:23.000000', 'temperatura', 752.0000, 'ºC'),
	(139485, 112, '2015-04-01 00:41:24.000000', 'temperatura', 729.0000, 'ºC'),
	(139486, 112, '2015-04-01 00:41:25.000000', 'temperatura', 189.0000, 'ºC'),
	(139487, 112, '2015-04-01 00:41:26.000000', 'temperatura', 1159.0000, 'ºC'),
	(139488, 112, '2015-04-01 00:41:27.000000', 'temperatura', 426.0000, 'ºC'),
	(139489, 112, '2015-04-01 00:41:28.000000', 'temperatura', 1055.0000, 'ºC'),
	(139490, 112, '2015-04-01 00:41:29.000000', 'temperatura', 397.0000, 'ºC'),
	(139491, 112, '2015-04-01 00:41:30.000000', 'temperatura', 19.0000, 'ºC'),
	(139492, 112, '2015-04-01 00:41:31.000000', 'temperatura', 108.0000, 'ºC'),
	(139493, 112, '2015-04-01 00:41:32.000000', 'temperatura', 481.0000, 'ºC'),
	(139494, 112, '2015-04-01 00:41:33.000000', 'temperatura', 882.0000, 'ºC'),
	(139495, 112, '2015-04-01 00:41:34.000000', 'temperatura', 569.0000, 'ºC'),
	(139496, 112, '2015-04-01 00:41:35.000000', 'temperatura', 199.0000, 'ºC'),
	(139497, 112, '2015-04-01 00:41:36.000000', 'temperatura', 490.0000, 'ºC'),
	(139498, 112, '2015-04-01 00:41:37.000000', 'temperatura', 651.0000, 'ºC'),
	(139499, 112, '2015-04-01 00:41:38.000000', 'temperatura', 585.0000, 'ºC'),
	(139500, 112, '2015-04-01 00:41:39.000000', 'temperatura', 973.0000, 'ºC'),
	(139501, 112, '2015-04-01 00:41:40.000000', 'temperatura', 713.0000, 'ºC'),
	(139502, 112, '2015-04-01 00:41:41.000000', 'temperatura', 643.0000, 'ºC'),
	(139503, 112, '2015-04-01 00:41:42.000000', 'temperatura', 1077.0000, 'ºC'),
	(139504, 112, '2015-04-01 00:41:43.000000', 'temperatura', 1058.0000, 'ºC'),
	(139505, 112, '2015-04-01 00:41:44.000000', 'temperatura', 857.0000, 'ºC'),
	(139506, 112, '2015-04-01 00:41:45.000000', 'temperatura', 1114.0000, 'ºC'),
	(139507, 112, '2015-04-01 00:41:46.000000', 'temperatura', 598.0000, 'ºC'),
	(139508, 112, '2015-04-01 00:41:47.000000', 'temperatura', 849.0000, 'ºC'),
	(139509, 112, '2015-04-01 00:41:48.000000', 'temperatura', 53.0000, 'ºC'),
	(139510, 112, '2015-04-01 00:41:49.000000', 'temperatura', 119.0000, 'ºC'),
	(139511, 112, '2015-04-01 00:41:50.000000', 'temperatura', 433.0000, 'ºC'),
	(139512, 112, '2015-04-01 00:41:51.000000', 'temperatura', 612.0000, 'ºC'),
	(139513, 112, '2015-04-01 00:41:52.000000', 'temperatura', 558.0000, 'ºC'),
	(139514, 112, '2015-04-01 00:41:53.000000', 'temperatura', 957.0000, 'ºC'),
	(139515, 112, '2015-04-01 00:41:54.000000', 'temperatura', 711.0000, 'ºC'),
	(139516, 112, '2015-04-01 00:41:55.000000', 'temperatura', 686.0000, 'ºC'),
	(139517, 112, '2015-04-01 00:41:56.000000', 'temperatura', 96.0000, 'ºC'),
	(139518, 112, '2015-04-01 00:41:57.000000', 'temperatura', 821.0000, 'ºC'),
	(139519, 112, '2015-04-01 00:41:58.000000', 'temperatura', 221.0000, 'ºC'),
	(139520, 112, '2015-04-01 00:41:59.000000', 'temperatura', 1040.0000, 'ºC'),
	(139521, 112, '2015-04-01 00:42:00.000000', 'temperatura', 940.0000, 'ºC'),
	(139522, 112, '2015-04-01 00:42:01.000000', 'temperatura', 378.0000, 'ºC'),
	(139523, 112, '2015-04-01 00:42:02.000000', 'temperatura', 270.0000, 'ºC'),
	(139524, 112, '2015-04-01 00:42:03.000000', 'temperatura', 217.0000, 'ºC'),
	(139525, 112, '2015-04-01 00:42:04.000000', 'temperatura', 274.0000, 'ºC'),
	(139526, 112, '2015-04-01 00:42:05.000000', 'temperatura', 720.0000, 'ºC'),
	(139527, 112, '2015-04-01 00:42:06.000000', 'temperatura', 379.0000, 'ºC'),
	(139528, 112, '2015-04-01 00:42:07.000000', 'temperatura', 937.0000, 'ºC'),
	(139529, 112, '2015-04-01 00:42:08.000000', 'temperatura', 1147.0000, 'ºC'),
	(139530, 112, '2015-04-01 00:42:09.000000', 'temperatura', 523.0000, 'ºC'),
	(139531, 112, '2015-04-01 00:42:10.000000', 'temperatura', 377.0000, 'ºC'),
	(139532, 112, '2015-04-01 00:42:11.000000', 'temperatura', 317.0000, 'ºC'),
	(139533, 112, '2015-04-01 00:42:12.000000', 'temperatura', 453.0000, 'ºC'),
	(139534, 112, '2015-04-01 00:42:13.000000', 'temperatura', 115.0000, 'ºC'),
	(139535, 112, '2015-04-01 00:42:14.000000', 'temperatura', 415.0000, 'ºC'),
	(139536, 112, '2015-04-01 00:42:15.000000', 'temperatura', 531.0000, 'ºC'),
	(139537, 112, '2015-04-01 00:42:16.000000', 'temperatura', 210.0000, 'ºC'),
	(139538, 112, '2015-04-01 00:42:17.000000', 'temperatura', 660.0000, 'ºC'),
	(139539, 112, '2015-04-01 00:42:18.000000', 'temperatura', 269.0000, 'ºC'),
	(139540, 112, '2015-04-01 00:42:19.000000', 'temperatura', 566.0000, 'ºC'),
	(139541, 112, '2015-04-01 00:42:20.000000', 'temperatura', 824.0000, 'ºC'),
	(139542, 112, '2015-04-01 00:42:21.000000', 'temperatura', 21.0000, 'ºC'),
	(139543, 112, '2015-04-01 00:42:22.000000', 'temperatura', 36.0000, 'ºC'),
	(139544, 112, '2015-04-01 00:42:23.000000', 'temperatura', 115.0000, 'ºC'),
	(139545, 112, '2015-04-01 00:42:24.000000', 'temperatura', 469.0000, 'ºC'),
	(139546, 112, '2015-04-01 00:42:25.000000', 'temperatura', 802.0000, 'ºC'),
	(139547, 112, '2015-04-01 00:42:26.000000', 'temperatura', 202.0000, 'ºC'),
	(139548, 112, '2015-04-01 00:42:27.000000', 'temperatura', 1006.0000, 'ºC'),
	(139549, 112, '2015-04-01 00:42:28.000000', 'temperatura', 825.0000, 'ºC'),
	(139550, 112, '2015-04-01 00:42:29.000000', 'temperatura', 1107.0000, 'ºC'),
	(139551, 112, '2015-04-01 00:42:30.000000', 'temperatura', 661.0000, 'ºC'),
	(139552, 112, '2015-04-01 00:42:31.000000', 'temperatura', 1183.0000, 'ºC'),
	(139553, 112, '2015-04-01 00:42:32.000000', 'temperatura', 332.0000, 'ºC'),
	(139554, 112, '2015-04-01 00:42:33.000000', 'temperatura', 511.0000, 'ºC'),
	(139555, 112, '2015-04-01 00:42:34.000000', 'temperatura', 362.0000, 'ºC'),
	(139556, 112, '2015-04-01 00:42:35.000000', 'temperatura', 278.0000, 'ºC'),
	(139557, 112, '2015-04-01 00:42:36.000000', 'temperatura', 302.0000, 'ºC'),
	(139558, 112, '2015-04-01 00:42:37.000000', 'temperatura', 676.0000, 'ºC'),
	(139559, 112, '2015-04-01 00:42:38.000000', 'temperatura', 77.0000, 'ºC'),
	(139560, 112, '2015-04-01 00:42:39.000000', 'temperatura', 756.0000, 'ºC'),
	(139561, 112, '2015-04-01 00:42:40.000000', 'temperatura', 1150.0000, 'ºC'),
	(139562, 112, '2015-04-01 00:42:41.000000', 'temperatura', 1084.0000, 'ºC'),
	(139563, 112, '2015-04-01 00:42:42.000000', 'temperatura', 767.0000, 'ºC'),
	(139564, 112, '2015-04-01 00:42:43.000000', 'temperatura', 587.0000, 'ºC'),
	(139565, 112, '2015-04-01 00:42:44.000000', 'temperatura', 633.0000, 'ºC'),
	(139566, 112, '2015-04-01 00:42:45.000000', 'temperatura', 203.0000, 'ºC'),
	(139567, 112, '2015-04-01 00:42:46.000000', 'temperatura', 318.0000, 'ºC'),
	(139568, 112, '2015-04-01 00:42:47.000000', 'temperatura', 983.0000, 'ºC'),
	(139569, 112, '2015-04-01 00:42:48.000000', 'temperatura', 362.0000, 'ºC'),
	(139570, 112, '2015-04-01 00:42:49.000000', 'temperatura', 59.0000, 'ºC'),
	(139571, 112, '2015-04-01 00:42:50.000000', 'temperatura', 410.0000, 'ºC'),
	(139572, 112, '2015-04-01 00:42:51.000000', 'temperatura', 674.0000, 'ºC'),
	(139573, 112, '2015-04-01 00:42:52.000000', 'temperatura', 940.0000, 'ºC'),
	(139574, 112, '2015-04-01 00:42:53.000000', 'temperatura', 279.0000, 'ºC'),
	(139575, 112, '2015-04-01 00:42:54.000000', 'temperatura', 974.0000, 'ºC'),
	(139576, 112, '2015-04-01 00:42:55.000000', 'temperatura', 433.0000, 'ºC'),
	(139577, 112, '2015-04-01 00:42:56.000000', 'temperatura', 444.0000, 'ºC'),
	(139578, 112, '2015-04-01 00:42:57.000000', 'temperatura', 921.0000, 'ºC'),
	(139579, 112, '2015-04-01 00:42:58.000000', 'temperatura', 872.0000, 'ºC'),
	(139580, 112, '2015-04-01 00:42:59.000000', 'temperatura', 400.0000, 'ºC'),
	(139581, 112, '2015-04-01 00:43:00.000000', 'temperatura', 586.0000, 'ºC'),
	(139582, 112, '2015-04-01 00:43:01.000000', 'temperatura', 527.0000, 'ºC'),
	(139583, 112, '2015-04-01 00:43:02.000000', 'temperatura', 878.0000, 'ºC'),
	(139584, 112, '2015-04-01 00:43:03.000000', 'temperatura', 412.0000, 'ºC'),
	(139585, 112, '2015-04-01 00:43:04.000000', 'temperatura', 624.0000, 'ºC'),
	(139586, 112, '2015-04-01 00:43:05.000000', 'temperatura', 686.0000, 'ºC'),
	(139587, 112, '2015-04-01 00:43:06.000000', 'temperatura', 360.0000, 'ºC'),
	(139588, 112, '2015-04-01 00:43:07.000000', 'temperatura', 941.0000, 'ºC'),
	(139589, 112, '2015-04-01 00:43:08.000000', 'temperatura', 27.0000, 'ºC'),
	(139590, 112, '2015-04-01 00:43:09.000000', 'temperatura', 912.0000, 'ºC'),
	(139591, 112, '2015-04-01 00:43:10.000000', 'temperatura', 880.0000, 'ºC'),
	(139592, 112, '2015-04-01 00:43:11.000000', 'temperatura', 466.0000, 'ºC'),
	(139593, 112, '2015-04-01 00:43:12.000000', 'temperatura', 887.0000, 'ºC'),
	(139594, 112, '2015-04-01 00:43:13.000000', 'temperatura', 641.0000, 'ºC'),
	(139595, 112, '2015-04-01 00:43:14.000000', 'temperatura', 543.0000, 'ºC'),
	(139596, 112, '2015-04-01 00:43:15.000000', 'temperatura', 791.0000, 'ºC'),
	(139597, 112, '2015-04-01 00:43:16.000000', 'temperatura', 1129.0000, 'ºC'),
	(139598, 112, '2015-04-01 00:43:17.000000', 'temperatura', 871.0000, 'ºC'),
	(139599, 112, '2015-04-01 00:43:18.000000', 'temperatura', 970.0000, 'ºC'),
	(139600, 112, '2015-04-01 00:43:19.000000', 'temperatura', 1037.0000, 'ºC'),
	(139601, 112, '2015-04-01 00:43:20.000000', 'temperatura', 1077.0000, 'ºC'),
	(139602, 112, '2015-04-01 00:43:21.000000', 'temperatura', 1071.0000, 'ºC'),
	(139603, 112, '2015-04-01 00:43:22.000000', 'temperatura', 928.0000, 'ºC'),
	(139604, 112, '2015-04-01 00:43:23.000000', 'temperatura', 227.0000, 'ºC'),
	(139605, 112, '2015-04-01 00:43:24.000000', 'temperatura', 752.0000, 'ºC'),
	(139606, 112, '2015-04-01 00:43:25.000000', 'temperatura', 679.0000, 'ºC'),
	(139607, 112, '2015-04-01 00:43:26.000000', 'temperatura', 1138.0000, 'ºC'),
	(139608, 112, '2015-04-01 00:43:27.000000', 'temperatura', 54.0000, 'ºC'),
	(139609, 112, '2015-04-01 00:43:28.000000', 'temperatura', 459.0000, 'ºC'),
	(139610, 112, '2015-04-01 00:43:29.000000', 'temperatura', 931.0000, 'ºC'),
	(139611, 112, '2015-04-01 00:43:30.000000', 'temperatura', 877.0000, 'ºC'),
	(139612, 112, '2015-04-01 00:43:31.000000', 'temperatura', 395.0000, 'ºC'),
	(139613, 112, '2015-04-01 00:43:32.000000', 'temperatura', 542.0000, 'ºC'),
	(139614, 112, '2015-04-01 00:43:33.000000', 'temperatura', 326.0000, 'ºC'),
	(139615, 112, '2015-04-01 00:43:34.000000', 'temperatura', 6.0000, 'ºC'),
	(139616, 112, '2015-04-01 00:43:35.000000', 'temperatura', 250.0000, 'ºC'),
	(139617, 112, '2015-04-01 00:43:36.000000', 'temperatura', 33.0000, 'ºC'),
	(139618, 112, '2015-04-01 00:43:37.000000', 'temperatura', 614.0000, 'ºC'),
	(139619, 112, '2015-04-01 00:43:38.000000', 'temperatura', 574.0000, 'ºC'),
	(139620, 112, '2015-04-01 00:43:39.000000', 'temperatura', 1027.0000, 'ºC'),
	(139621, 112, '2015-04-01 00:43:40.000000', 'temperatura', 1015.0000, 'ºC'),
	(139622, 112, '2015-04-01 00:43:41.000000', 'temperatura', 795.0000, 'ºC'),
	(139623, 112, '2015-04-01 00:43:42.000000', 'temperatura', 928.0000, 'ºC'),
	(139624, 112, '2015-04-01 00:43:43.000000', 'temperatura', 1055.0000, 'ºC'),
	(139625, 112, '2015-04-01 00:43:44.000000', 'temperatura', 91.0000, 'ºC'),
	(139626, 112, '2015-04-01 00:43:45.000000', 'temperatura', 894.0000, 'ºC'),
	(139627, 112, '2015-04-01 00:43:46.000000', 'temperatura', 595.0000, 'ºC'),
	(139628, 112, '2015-04-01 00:43:47.000000', 'temperatura', 293.0000, 'ºC'),
	(139629, 112, '2015-04-01 00:43:48.000000', 'temperatura', 881.0000, 'ºC'),
	(139630, 112, '2015-04-01 00:43:49.000000', 'temperatura', 1126.0000, 'ºC'),
	(139631, 112, '2015-04-01 00:43:50.000000', 'temperatura', 589.0000, 'ºC'),
	(139632, 112, '2015-04-01 00:43:51.000000', 'temperatura', 765.0000, 'ºC'),
	(139633, 112, '2015-04-01 00:43:52.000000', 'temperatura', 861.0000, 'ºC'),
	(139634, 112, '2015-04-01 00:43:53.000000', 'temperatura', 811.0000, 'ºC'),
	(139635, 112, '2015-04-01 00:43:54.000000', 'temperatura', 271.0000, 'ºC'),
	(139636, 112, '2015-04-01 00:43:55.000000', 'temperatura', 123.0000, 'ºC'),
	(139637, 112, '2015-04-01 00:43:56.000000', 'temperatura', 1003.0000, 'ºC'),
	(139638, 112, '2015-04-01 00:43:57.000000', 'temperatura', 1047.0000, 'ºC'),
	(139639, 112, '2015-04-01 00:43:58.000000', 'temperatura', 1027.0000, 'ºC'),
	(139640, 112, '2015-04-01 00:43:59.000000', 'temperatura', 792.0000, 'ºC'),
	(139641, 112, '2015-04-01 00:44:00.000000', 'temperatura', 880.0000, 'ºC'),
	(139642, 112, '2015-04-01 00:44:01.000000', 'temperatura', 826.0000, 'ºC'),
	(139643, 112, '2015-04-01 00:44:02.000000', 'temperatura', 289.0000, 'ºC'),
	(139644, 112, '2015-04-01 00:44:03.000000', 'temperatura', 169.0000, 'ºC'),
	(139645, 112, '2015-04-01 00:44:04.000000', 'temperatura', 1179.0000, 'ºC'),
	(139646, 112, '2015-04-01 00:44:05.000000', 'temperatura', 586.0000, 'ºC'),
	(139647, 112, '2015-04-01 00:44:06.000000', 'temperatura', 595.0000, 'ºC'),
	(139648, 112, '2015-04-01 00:44:07.000000', 'temperatura', 18.0000, 'ºC'),
	(139649, 112, '2015-04-01 00:44:08.000000', 'temperatura', 703.0000, 'ºC'),
	(139650, 112, '2015-04-01 00:44:09.000000', 'temperatura', 1063.0000, 'ºC'),
	(139651, 112, '2015-04-01 00:44:10.000000', 'temperatura', 808.0000, 'ºC'),
	(139652, 112, '2015-04-01 00:44:11.000000', 'temperatura', 848.0000, 'ºC'),
	(139653, 112, '2015-04-01 00:44:12.000000', 'temperatura', 620.0000, 'ºC'),
	(139654, 112, '2015-04-01 00:44:13.000000', 'temperatura', 556.0000, 'ºC'),
	(139655, 112, '2015-04-01 00:44:14.000000', 'temperatura', 919.0000, 'ºC'),
	(139656, 112, '2015-04-01 00:44:15.000000', 'temperatura', 529.0000, 'ºC'),
	(139657, 112, '2015-04-01 00:44:16.000000', 'temperatura', 1087.0000, 'ºC'),
	(139658, 112, '2015-04-01 00:44:17.000000', 'temperatura', 249.0000, 'ºC'),
	(139659, 112, '2015-04-01 00:44:18.000000', 'temperatura', 383.0000, 'ºC'),
	(139660, 112, '2015-04-01 00:44:19.000000', 'temperatura', 1171.0000, 'ºC'),
	(139661, 112, '2015-04-01 00:44:20.000000', 'temperatura', 1107.0000, 'ºC'),
	(139662, 112, '2015-04-01 00:44:21.000000', 'temperatura', 823.0000, 'ºC'),
	(139663, 112, '2015-04-01 00:44:22.000000', 'temperatura', 793.0000, 'ºC'),
	(139664, 112, '2015-04-01 00:44:23.000000', 'temperatura', 296.0000, 'ºC'),
	(139665, 112, '2015-04-01 00:44:24.000000', 'temperatura', 302.0000, 'ºC'),
	(139666, 112, '2015-04-01 00:44:25.000000', 'temperatura', 623.0000, 'ºC'),
	(139667, 112, '2015-04-01 00:44:26.000000', 'temperatura', 1009.0000, 'ºC'),
	(139668, 112, '2015-04-01 00:44:27.000000', 'temperatura', 779.0000, 'ºC'),
	(139669, 112, '2015-04-01 00:44:28.000000', 'temperatura', 865.0000, 'ºC'),
	(139670, 112, '2015-04-01 00:44:29.000000', 'temperatura', 790.0000, 'ºC'),
	(139671, 112, '2015-04-01 00:44:30.000000', 'temperatura', 155.0000, 'ºC'),
	(139672, 112, '2015-04-01 00:44:31.000000', 'temperatura', 805.0000, 'ºC'),
	(139673, 112, '2015-04-01 00:44:32.000000', 'temperatura', 1159.0000, 'ºC'),
	(139674, 112, '2015-04-01 00:44:33.000000', 'temperatura', 984.0000, 'ºC'),
	(139675, 112, '2015-04-01 00:44:34.000000', 'temperatura', 240.0000, 'ºC'),
	(139676, 112, '2015-04-01 00:44:35.000000', 'temperatura', 652.0000, 'ºC'),
	(139677, 112, '2015-04-01 00:44:36.000000', 'temperatura', 138.0000, 'ºC'),
	(139678, 112, '2015-04-01 00:44:37.000000', 'temperatura', 1136.0000, 'ºC'),
	(139679, 112, '2015-04-01 00:44:38.000000', 'temperatura', 467.0000, 'ºC'),
	(139680, 112, '2015-04-01 00:44:39.000000', 'temperatura', 125.0000, 'ºC'),
	(139681, 112, '2015-04-01 00:44:40.000000', 'temperatura', 425.0000, 'ºC'),
	(139682, 112, '2015-04-01 00:44:41.000000', 'temperatura', 552.0000, 'ºC'),
	(139683, 112, '2015-04-01 00:44:42.000000', 'temperatura', 283.0000, 'ºC'),
	(139684, 112, '2015-04-01 00:44:43.000000', 'temperatura', 963.0000, 'ºC'),
	(139685, 112, '2015-04-01 00:44:44.000000', 'temperatura', 363.0000, 'ºC'),
	(139686, 112, '2015-04-01 00:44:45.000000', 'temperatura', 128.0000, 'ºC'),
	(139687, 112, '2015-04-01 00:44:46.000000', 'temperatura', 752.0000, 'ºC'),
	(139688, 112, '2015-04-01 00:44:47.000000', 'temperatura', 978.0000, 'ºC'),
	(139689, 112, '2015-04-01 00:44:48.000000', 'temperatura', 233.0000, 'ºC'),
	(139690, 112, '2015-04-01 00:44:49.000000', 'temperatura', 629.0000, 'ºC'),
	(139691, 112, '2015-04-01 00:44:50.000000', 'temperatura', 50.0000, 'ºC'),
	(139692, 112, '2015-04-01 00:44:51.000000', 'temperatura', 764.0000, 'ºC'),
	(139693, 112, '2015-04-01 00:44:52.000000', 'temperatura', 68.0000, 'ºC'),
	(139694, 112, '2015-04-01 00:44:53.000000', 'temperatura', 449.0000, 'ºC'),
	(139695, 112, '2015-04-01 00:44:54.000000', 'temperatura', 842.0000, 'ºC'),
	(139696, 112, '2015-04-01 00:44:55.000000', 'temperatura', 464.0000, 'ºC'),
	(139697, 112, '2015-04-01 00:44:56.000000', 'temperatura', 993.0000, 'ºC'),
	(139698, 112, '2015-04-01 00:44:57.000000', 'temperatura', 1175.0000, 'ºC'),
	(139699, 112, '2015-04-01 00:44:58.000000', 'temperatura', 497.0000, 'ºC'),
	(139700, 112, '2015-04-01 00:44:59.000000', 'temperatura', 161.0000, 'ºC'),
	(139701, 112, '2015-04-01 00:45:00.000000', 'temperatura', 513.0000, 'ºC'),
	(139702, 112, '2015-04-01 00:45:01.000000', 'temperatura', 883.0000, 'ºC'),
	(139703, 112, '2015-04-01 00:45:02.000000', 'temperatura', 479.0000, 'ºC'),
	(139704, 112, '2015-04-01 00:45:03.000000', 'temperatura', 943.0000, 'ºC'),
	(139705, 112, '2015-04-01 00:45:04.000000', 'temperatura', 879.0000, 'ºC'),
	(139706, 112, '2015-04-01 00:45:05.000000', 'temperatura', 366.0000, 'ºC'),
	(139707, 112, '2015-04-01 00:45:06.000000', 'temperatura', 393.0000, 'ºC'),
	(139708, 112, '2015-04-01 00:45:07.000000', 'temperatura', 868.0000, 'ºC'),
	(139709, 112, '2015-04-01 00:45:08.000000', 'temperatura', 764.0000, 'ºC'),
	(139710, 112, '2015-04-01 00:45:09.000000', 'temperatura', 14.0000, 'ºC'),
	(139711, 112, '2015-04-01 00:45:10.000000', 'temperatura', 179.0000, 'ºC'),
	(139712, 112, '2015-04-01 00:45:11.000000', 'temperatura', 852.0000, 'ºC'),
	(139713, 112, '2015-04-01 00:45:12.000000', 'temperatura', 123.0000, 'ºC'),
	(139714, 112, '2015-04-01 00:45:13.000000', 'temperatura', 463.0000, 'ºC'),
	(139715, 112, '2015-04-01 00:45:14.000000', 'temperatura', 743.0000, 'ºC'),
	(139716, 112, '2015-04-01 00:45:15.000000', 'temperatura', 1127.0000, 'ºC'),
	(139717, 112, '2015-04-01 00:45:16.000000', 'temperatura', 1008.0000, 'ºC'),
	(139718, 112, '2015-04-01 00:45:17.000000', 'temperatura', 461.0000, 'ºC'),
	(139719, 112, '2015-04-01 00:45:18.000000', 'temperatura', 478.0000, 'ºC'),
	(139720, 112, '2015-04-01 00:45:19.000000', 'temperatura', 1011.0000, 'ºC'),
	(139721, 112, '2015-04-01 00:45:20.000000', 'temperatura', 18.0000, 'ºC'),
	(139722, 112, '2015-04-01 00:45:21.000000', 'temperatura', 659.0000, 'ºC'),
	(139723, 112, '2015-04-01 00:45:22.000000', 'temperatura', 840.0000, 'ºC'),
	(139724, 112, '2015-04-01 00:45:23.000000', 'temperatura', 1025.0000, 'ºC'),
	(139725, 112, '2015-04-01 00:45:24.000000', 'temperatura', 203.0000, 'ºC'),
	(139726, 112, '2015-04-01 00:45:25.000000', 'temperatura', 344.0000, 'ºC'),
	(139727, 112, '2015-04-01 00:45:26.000000', 'temperatura', 1109.0000, 'ºC'),
	(139728, 112, '2015-04-01 00:45:27.000000', 'temperatura', 916.0000, 'ºC'),
	(139729, 112, '2015-04-01 00:45:28.000000', 'temperatura', 54.0000, 'ºC'),
	(139730, 112, '2015-04-01 00:45:29.000000', 'temperatura', 1121.0000, 'ºC'),
	(139731, 112, '2015-04-01 00:45:30.000000', 'temperatura', 643.0000, 'ºC'),
	(139732, 112, '2015-04-01 00:45:31.000000', 'temperatura', 1053.0000, 'ºC'),
	(139733, 112, '2015-04-01 00:45:32.000000', 'temperatura', 936.0000, 'ºC'),
	(139734, 112, '2015-04-01 00:45:33.000000', 'temperatura', 322.0000, 'ºC'),
	(139735, 112, '2015-04-01 00:45:34.000000', 'temperatura', 2.0000, 'ºC'),
	(139736, 112, '2015-04-01 00:45:35.000000', 'temperatura', 247.0000, 'ºC'),
	(139737, 112, '2015-04-01 00:45:36.000000', 'temperatura', 27.0000, 'ºC'),
	(139738, 112, '2015-04-01 00:45:37.000000', 'temperatura', 595.0000, 'ºC'),
	(139739, 112, '2015-04-01 00:45:38.000000', 'temperatura', 494.0000, 'ºC'),
	(139740, 112, '2015-04-01 00:45:39.000000', 'temperatura', 685.0000, 'ºC'),
	(139741, 112, '2015-04-01 00:45:40.000000', 'temperatura', 745.0000, 'ºC'),
	(139742, 112, '2015-04-01 00:45:41.000000', 'temperatura', 471.0000, 'ºC'),
	(139743, 112, '2015-04-01 00:45:42.000000', 'temperatura', 121.0000, 'ºC'),
	(139744, 112, '2015-04-01 00:45:43.000000', 'temperatura', 391.0000, 'ºC'),
	(139745, 112, '2015-04-01 00:45:44.000000', 'temperatura', 391.0000, 'ºC'),
	(139746, 112, '2015-04-01 00:45:45.000000', 'temperatura', 785.0000, 'ºC'),
	(139747, 112, '2015-04-01 00:45:46.000000', 'temperatura', 353.0000, 'ºC'),
	(139748, 112, '2015-04-01 00:45:47.000000', 'temperatura', 610.0000, 'ºC'),
	(139749, 112, '2015-04-01 00:45:48.000000', 'temperatura', 790.0000, 'ºC'),
	(139750, 112, '2015-04-01 00:45:49.000000', 'temperatura', 919.0000, 'ºC'),
	(139751, 112, '2015-04-01 00:45:50.000000', 'temperatura', 1029.0000, 'ºC'),
	(139752, 112, '2015-04-01 00:45:51.000000', 'temperatura', 1185.0000, 'ºC'),
	(139753, 112, '2015-04-01 00:45:52.000000', 'temperatura', 441.0000, 'ºC'),
	(139754, 112, '2015-04-01 00:45:53.000000', 'temperatura', 1051.0000, 'ºC'),
	(139755, 112, '2015-04-01 00:45:54.000000', 'temperatura', 332.0000, 'ºC'),
	(139756, 112, '2015-04-01 00:45:55.000000', 'temperatura', 909.0000, 'ºC'),
	(139757, 112, '2015-04-01 00:45:56.000000', 'temperatura', 1147.0000, 'ºC'),
	(139758, 112, '2015-04-01 00:45:57.000000', 'temperatura', 611.0000, 'ºC'),
	(139759, 112, '2015-04-01 00:45:58.000000', 'temperatura', 812.0000, 'ºC'),
	(139760, 112, '2015-04-01 00:45:59.000000', 'temperatura', 1029.0000, 'ºC'),
	(139761, 112, '2015-04-01 00:46:00.000000', 'temperatura', 309.0000, 'ºC'),
	(139762, 112, '2015-04-01 00:46:01.000000', 'temperatura', 857.0000, 'ºC'),
	(139763, 112, '2015-04-01 00:46:02.000000', 'temperatura', 960.0000, 'ºC'),
	(139764, 112, '2015-04-01 00:46:03.000000', 'temperatura', 1029.0000, 'ºC'),
	(139765, 112, '2015-04-01 00:46:04.000000', 'temperatura', 1067.0000, 'ºC'),
	(139766, 112, '2015-04-01 00:46:05.000000', 'temperatura', 1050.0000, 'ºC'),
	(139767, 112, '2015-04-01 00:46:06.000000', 'temperatura', 846.0000, 'ºC'),
	(139768, 112, '2015-04-01 00:46:07.000000', 'temperatura', 1083.0000, 'ºC'),
	(139769, 112, '2015-04-01 00:46:08.000000', 'temperatura', 475.0000, 'ºC'),
	(139770, 112, '2015-04-01 00:46:09.000000', 'temperatura', 326.0000, 'ºC'),
	(139771, 112, '2015-04-01 00:46:10.000000', 'temperatura', 206.0000, 'ºC'),
	(139772, 112, '2015-04-01 00:46:11.000000', 'temperatura', 53.0000, 'ºC'),
	(139773, 112, '2015-04-01 00:46:12.000000', 'temperatura', 849.0000, 'ºC'),
	(139774, 112, '2015-04-01 00:46:13.000000', 'temperatura', 487.0000, 'ºC'),
	(139775, 112, '2015-04-01 00:46:14.000000', 'temperatura', 1087.0000, 'ºC'),
	(139776, 112, '2015-04-01 00:46:15.000000', 'temperatura', 375.0000, 'ºC'),
	(139777, 112, '2015-04-01 00:46:16.000000', 'temperatura', 1015.0000, 'ºC'),
	(139778, 112, '2015-04-01 00:46:17.000000', 'temperatura', 351.0000, 'ºC'),
	(139779, 112, '2015-04-01 00:46:18.000000', 'temperatura', 1108.0000, 'ºC'),
	(139780, 112, '2015-04-01 00:46:19.000000', 'temperatura', 889.0000, 'ºC'),
	(139781, 112, '2015-04-01 00:46:20.000000', 'temperatura', 1121.0000, 'ºC'),
	(139782, 112, '2015-04-01 00:46:21.000000', 'temperatura', 541.0000, 'ºC'),
	(139783, 112, '2015-04-01 00:46:22.000000', 'temperatura', 539.0000, 'ºC'),
	(139784, 112, '2015-04-01 00:46:23.000000', 'temperatura', 1075.0000, 'ºC'),
	(139785, 112, '2015-04-01 00:46:24.000000', 'temperatura', 158.0000, 'ºC'),
	(139786, 112, '2015-04-01 00:46:25.000000', 'temperatura', 1166.0000, 'ºC'),
	(139787, 112, '2015-04-01 00:46:26.000000', 'temperatura', 556.0000, 'ºC'),
	(139788, 112, '2015-04-01 00:46:27.000000', 'temperatura', 481.0000, 'ºC'),
	(139789, 112, '2015-04-01 00:46:28.000000', 'temperatura', 740.0000, 'ºC'),
	(139790, 112, '2015-04-01 00:46:29.000000', 'temperatura', 1055.0000, 'ºC'),
	(139791, 112, '2015-04-01 00:46:30.000000', 'temperatura', 656.0000, 'ºC'),
	(139792, 112, '2015-04-01 00:46:31.000000', 'temperatura', 115.0000, 'ºC'),
	(139793, 112, '2015-04-01 00:46:32.000000', 'temperatura', 1010.0000, 'ºC'),
	(139794, 112, '2015-04-01 00:46:33.000000', 'temperatura', 1105.0000, 'ºC'),
	(139795, 112, '2015-04-01 00:46:34.000000', 'temperatura', 96.0000, 'ºC'),
	(139796, 112, '2015-04-01 00:46:35.000000', 'temperatura', 763.0000, 'ºC'),
	(139797, 112, '2015-04-01 00:46:36.000000', 'temperatura', 1131.0000, 'ºC'),
	(139798, 112, '2015-04-01 00:46:37.000000', 'temperatura', 964.0000, 'ºC'),
	(139799, 112, '2015-04-01 00:46:38.000000', 'temperatura', 230.0000, 'ºC'),
	(139800, 112, '2015-04-01 00:46:39.000000', 'temperatura', 656.0000, 'ºC'),
	(139801, 112, '2015-04-01 00:46:40.000000', 'temperatura', 191.0000, 'ºC'),
	(139802, 112, '2015-04-01 00:46:41.000000', 'temperatura', 189.0000, 'ºC'),
	(139803, 112, '2015-04-01 00:46:42.000000', 'temperatura', 374.0000, 'ºC'),
	(139804, 112, '2015-04-01 00:46:43.000000', 'temperatura', 101.0000, 'ºC'),
	(139805, 112, '2015-04-01 00:46:44.000000', 'temperatura', 583.0000, 'ºC'),
	(139806, 112, '2015-04-01 00:46:45.000000', 'temperatura', 214.0000, 'ºC'),
	(139807, 112, '2015-04-01 00:46:46.000000', 'temperatura', 519.0000, 'ºC'),
	(139808, 112, '2015-04-01 00:46:47.000000', 'temperatura', 754.0000, 'ºC'),
	(139809, 112, '2015-04-01 00:46:48.000000', 'temperatura', 1015.0000, 'ºC'),
	(139810, 112, '2015-04-01 00:46:49.000000', 'temperatura', 414.0000, 'ºC'),
	(139811, 112, '2015-04-01 00:46:50.000000', 'temperatura', 223.0000, 'ºC'),
	(139812, 112, '2015-04-01 00:46:51.000000', 'temperatura', 1074.0000, 'ºC'),
	(139813, 112, '2015-04-01 00:46:52.000000', 'temperatura', 1104.0000, 'ºC'),
	(139814, 112, '2015-04-01 00:46:53.000000', 'temperatura', 1095.0000, 'ºC'),
	(139815, 112, '2015-04-01 00:46:54.000000', 'temperatura', 965.0000, 'ºC'),
	(139816, 112, '2015-04-01 00:46:55.000000', 'temperatura', 342.0000, 'ºC'),
	(139817, 112, '2015-04-01 00:46:56.000000', 'temperatura', 15.0000, 'ºC'),
	(139818, 112, '2015-04-01 00:46:57.000000', 'temperatura', 248.0000, 'ºC'),
	(139819, 112, '2015-04-01 00:46:58.000000', 'temperatura', 1194.0000, 'ºC'),
	(139820, 112, '2015-04-01 00:46:59.000000', 'temperatura', 430.0000, 'ºC'),
	(139821, 112, '2015-04-01 00:47:00.000000', 'temperatura', 967.0000, 'ºC'),
	(139822, 112, '2015-04-01 00:47:01.000000', 'temperatura', 1146.0000, 'ºC'),
	(139823, 112, '2015-04-01 00:47:02.000000', 'temperatura', 431.0000, 'ºC'),
	(139824, 112, '2015-04-01 00:47:03.000000', 'temperatura', 1116.0000, 'ºC'),
	(139825, 112, '2015-04-01 00:47:04.000000', 'temperatura', 686.0000, 'ºC'),
	(139826, 112, '2015-04-01 00:47:05.000000', 'temperatura', 85.0000, 'ºC'),
	(139827, 112, '2015-04-01 00:47:06.000000', 'temperatura', 767.0000, 'ºC'),
	(139828, 112, '2015-04-01 00:47:07.000000', 'temperatura', 1179.0000, 'ºC'),
	(139829, 112, '2015-04-01 00:47:08.000000', 'temperatura', 1195.0000, 'ºC'),
	(139830, 112, '2015-04-01 00:47:09.000000', 'temperatura', 39.0000, 'ºC'),
	(139831, 112, '2015-04-01 00:47:10.000000', 'temperatura', 211.0000, 'ºC'),
	(139832, 112, '2015-04-01 00:47:11.000000', 'temperatura', 936.0000, 'ºC'),
	(139833, 112, '2015-04-01 00:47:12.000000', 'temperatura', 449.0000, 'ºC'),
	(139834, 112, '2015-04-01 00:47:13.000000', 'temperatura', 636.0000, 'ºC'),
	(139835, 112, '2015-04-01 00:47:14.000000', 'temperatura', 635.0000, 'ºC'),
	(139836, 112, '2015-04-01 00:47:15.000000', 'temperatura', 65.0000, 'ºC'),
	(139837, 112, '2015-04-01 00:47:16.000000', 'temperatura', 823.0000, 'ºC'),
	(139838, 112, '2015-04-01 00:47:17.000000', 'temperatura', 320.0000, 'ºC'),
	(139839, 112, '2015-04-01 00:47:18.000000', 'temperatura', 333.0000, 'ºC'),
	(139840, 112, '2015-04-01 00:47:19.000000', 'temperatura', 705.0000, 'ºC'),
	(139841, 112, '2015-04-01 00:47:20.000000', 'temperatura', 127.0000, 'ºC'),
	(139842, 112, '2015-04-01 00:47:21.000000', 'temperatura', 918.0000, 'ºC'),
	(139843, 112, '2015-04-01 00:47:22.000000', 'temperatura', 610.0000, 'ºC'),
	(139844, 112, '2015-04-01 00:47:23.000000', 'temperatura', 295.0000, 'ºC'),
	(139845, 112, '2015-04-01 00:47:24.000000', 'temperatura', 848.0000, 'ºC'),
	(139846, 112, '2015-04-01 00:47:25.000000', 'temperatura', 953.0000, 'ºC'),
	(139847, 112, '2015-04-01 00:47:26.000000', 'temperatura', 1022.0000, 'ºC'),
	(139848, 112, '2015-04-01 00:47:27.000000', 'temperatura', 1051.0000, 'ºC'),
	(139849, 112, '2015-04-01 00:47:28.000000', 'temperatura', 991.0000, 'ºC'),
	(139850, 112, '2015-04-01 00:47:29.000000', 'temperatura', 600.0000, 'ºC'),
	(139851, 112, '2015-04-01 00:47:30.000000', 'temperatura', 31.0000, 'ºC'),
	(139852, 112, '2015-04-01 00:47:31.000000', 'temperatura', 752.0000, 'ºC'),
	(139853, 112, '2015-04-01 00:47:32.000000', 'temperatura', 69.0000, 'ºC'),
	(139854, 112, '2015-04-01 00:47:33.000000', 'temperatura', 490.0000, 'ºC'),
	(139855, 112, '2015-04-01 00:47:34.000000', 'temperatura', 1042.0000, 'ºC'),
	(139856, 112, '2015-04-01 00:47:35.000000', 'temperatura', 142.0000, 'ºC'),
	(139857, 112, '2015-04-01 00:47:36.000000', 'temperatura', 1183.0000, 'ºC'),
	(139858, 112, '2015-04-01 00:47:37.000000', 'temperatura', 689.0000, 'ºC'),
	(139859, 112, '2015-04-01 00:47:38.000000', 'temperatura', 1099.0000, 'ºC'),
	(139860, 112, '2015-04-01 00:47:39.000000', 'temperatura', 1029.0000, 'ºC'),
	(139861, 112, '2015-04-01 00:47:40.000000', 'temperatura', 645.0000, 'ºC'),
	(139862, 112, '2015-04-01 00:47:41.000000', 'temperatura', 141.0000, 'ºC'),
	(139863, 112, '2015-04-01 00:47:42.000000', 'temperatura', 1170.0000, 'ºC'),
	(139864, 112, '2015-04-01 00:47:43.000000', 'temperatura', 627.0000, 'ºC'),
	(139865, 112, '2015-04-01 00:47:44.000000', 'temperatura', 826.0000, 'ºC'),
	(139866, 112, '2015-04-01 00:47:45.000000', 'temperatura', 1051.0000, 'ºC'),
	(139867, 112, '2015-04-01 00:47:46.000000', 'temperatura', 377.0000, 'ºC'),
	(139868, 112, '2015-04-01 00:47:47.000000', 'temperatura', 1130.0000, 'ºC'),
	(139869, 112, '2015-04-01 00:47:48.000000', 'temperatura', 921.0000, 'ºC'),
	(139870, 112, '2015-04-01 00:47:49.000000', 'temperatura', 14.0000, 'ºC'),
	(139871, 112, '2015-04-01 00:47:50.000000', 'temperatura', 908.0000, 'ºC'),
	(139872, 112, '2015-04-01 00:47:51.000000', 'temperatura', 898.0000, 'ºC'),
	(139873, 112, '2015-04-01 00:47:52.000000', 'temperatura', 566.0000, 'ºC'),
	(139874, 112, '2015-04-01 00:47:53.000000', 'temperatura', 139.0000, 'ºC'),
	(139875, 112, '2015-04-01 00:47:54.000000', 'temperatura', 196.0000, 'ºC'),
	(139876, 112, '2015-04-01 00:47:55.000000', 'temperatura', 562.0000, 'ºC'),
	(139877, 112, '2015-04-01 00:47:56.000000', 'temperatura', 1024.0000, 'ºC'),
	(139878, 112, '2015-04-01 00:47:57.000000', 'temperatura', 1034.0000, 'ºC'),
	(139879, 112, '2015-04-01 00:47:58.000000', 'temperatura', 897.0000, 'ºC'),
	(139880, 112, '2015-04-01 00:47:59.000000', 'temperatura', 183.0000, 'ºC'),
	(139881, 112, '2015-04-01 00:48:00.000000', 'temperatura', 628.0000, 'ºC'),
	(139882, 112, '2015-04-01 00:48:01.000000', 'temperatura', 188.0000, 'ºC'),
	(139883, 112, '2015-04-01 00:48:02.000000', 'temperatura', 259.0000, 'ºC'),
	(139884, 112, '2015-04-01 00:48:03.000000', 'temperatura', 730.0000, 'ºC'),
	(139885, 112, '2015-04-01 00:48:04.000000', 'temperatura', 475.0000, 'ºC'),
	(139886, 112, '2015-04-01 00:48:05.000000', 'temperatura', 184.0000, 'ºC'),
	(139887, 112, '2015-04-01 00:48:06.000000', 'temperatura', 695.0000, 'ºC'),
	(139888, 112, '2015-04-01 00:48:07.000000', 'temperatura', 526.0000, 'ºC'),
	(139889, 112, '2015-04-01 00:48:08.000000', 'temperatura', 544.0000, 'ºC'),
	(139890, 112, '2015-04-01 00:48:09.000000', 'temperatura', 1143.0000, 'ºC'),
	(139891, 112, '2015-04-01 00:48:10.000000', 'temperatura', 485.0000, 'ºC'),
	(139892, 112, '2015-04-01 00:48:11.000000', 'temperatura', 195.0000, 'ºC'),
	(139893, 112, '2015-04-01 00:48:12.000000', 'temperatura', 720.0000, 'ºC'),
	(139894, 112, '2015-04-01 00:48:13.000000', 'temperatura', 616.0000, 'ºC'),
	(139895, 112, '2015-04-01 00:48:14.000000', 'temperatura', 920.0000, 'ºC'),
	(139896, 112, '2015-04-01 00:48:15.000000', 'temperatura', 352.0000, 'ºC'),
	(139897, 112, '2015-04-01 00:48:16.000000', 'temperatura', 202.0000, 'ºC'),
	(139898, 112, '2015-04-01 00:48:17.000000', 'temperatura', 1155.0000, 'ºC'),
	(139899, 112, '2015-04-01 00:48:18.000000', 'temperatura', 370.0000, 'ºC'),
	(139900, 112, '2015-04-01 00:48:19.000000', 'temperatura', 786.0000, 'ºC'),
	(139901, 112, '2015-04-01 00:48:20.000000', 'temperatura', 419.0000, 'ºC'),
	(139902, 112, '2015-04-01 00:48:21.000000', 'temperatura', 936.0000, 'ºC'),
	(139903, 112, '2015-04-01 00:48:22.000000', 'temperatura', 1025.0000, 'ºC'),
	(139904, 112, '2015-04-01 00:48:23.000000', 'temperatura', 1115.0000, 'ºC'),
	(139905, 112, '2015-04-01 00:48:24.000000', 'temperatura', 104.0000, 'ºC'),
	(139906, 112, '2015-04-01 00:48:25.000000', 'temperatura', 773.0000, 'ºC'),
	(139907, 112, '2015-04-01 00:48:26.000000', 'temperatura', 1156.0000, 'ºC'),
	(139908, 112, '2015-04-01 00:48:27.000000', 'temperatura', 1060.0000, 'ºC'),
	(139909, 112, '2015-04-01 00:48:28.000000', 'temperatura', 634.0000, 'ºC'),
	(139910, 112, '2015-04-01 00:48:29.000000', 'temperatura', 1189.0000, 'ºC'),
	(139911, 112, '2015-04-01 00:48:30.000000', 'temperatura', 443.0000, 'ºC'),
	(139912, 112, '2015-04-01 00:48:31.000000', 'temperatura', 1050.0000, 'ºC'),
	(139913, 112, '2015-04-01 00:48:32.000000', 'temperatura', 321.0000, 'ºC'),
	(139914, 112, '2015-04-01 00:48:33.000000', 'temperatura', 855.0000, 'ºC'),
	(139915, 112, '2015-04-01 00:48:34.000000', 'temperatura', 912.0000, 'ºC'),
	(139916, 112, '2015-04-01 00:48:35.000000', 'temperatura', 796.0000, 'ºC'),
	(139917, 112, '2015-04-01 00:48:36.000000', 'temperatura', 43.0000, 'ºC'),
	(139918, 112, '2015-04-01 00:48:37.000000', 'temperatura', 230.0000, 'ºC'),
	(139919, 112, '2015-04-01 00:48:38.000000', 'temperatura', 1019.0000, 'ºC'),
	(139920, 112, '2015-04-01 00:48:39.000000', 'temperatura', 805.0000, 'ºC'),
	(139921, 112, '2015-04-01 00:48:40.000000', 'temperatura', 969.0000, 'ºC'),
	(139922, 112, '2015-04-01 00:48:41.000000', 'temperatura', 32.0000, 'ºC'),
	(139923, 112, '2015-04-01 00:48:42.000000', 'temperatura', 851.0000, 'ºC'),
	(139924, 112, '2015-04-01 00:48:43.000000', 'temperatura', 562.0000, 'ºC'),
	(139925, 112, '2015-04-01 00:48:44.000000', 'temperatura', 255.0000, 'ºC'),
	(139926, 112, '2015-04-01 00:48:45.000000', 'temperatura', 791.0000, 'ºC'),
	(139927, 112, '2015-04-01 00:48:46.000000', 'temperatura', 789.0000, 'ºC'),
	(139928, 112, '2015-04-01 00:48:47.000000', 'temperatura', 372.0000, 'ºC'),
	(139929, 112, '2015-04-01 00:48:48.000000', 'temperatura', 695.0000, 'ºC'),
	(139930, 112, '2015-04-01 00:48:49.000000', 'temperatura', 1158.0000, 'ºC'),
	(139931, 112, '2015-04-01 00:48:50.000000', 'temperatura', 108.0000, 'ºC'),
	(139932, 112, '2015-04-01 00:48:51.000000', 'temperatura', 664.0000, 'ºC'),
	(139933, 112, '2015-04-01 00:48:52.000000', 'temperatura', 595.0000, 'ºC'),
	(139934, 112, '2015-04-01 00:48:53.000000', 'temperatura', 986.0000, 'ºC'),
	(139935, 112, '2015-04-01 00:48:54.000000', 'temperatura', 747.0000, 'ºC'),
	(139936, 112, '2015-04-01 00:48:55.000000', 'temperatura', 775.0000, 'ºC'),
	(139937, 112, '2015-04-01 00:48:56.000000', 'temperatura', 437.0000, 'ºC'),
	(139938, 112, '2015-04-01 00:48:57.000000', 'temperatura', 1059.0000, 'ºC'),
	(139939, 112, '2015-04-01 00:48:58.000000', 'temperatura', 386.0000, 'ºC'),
	(139940, 112, '2015-04-01 00:48:59.000000', 'temperatura', 1155.0000, 'ºC'),
	(139941, 112, '2015-04-01 00:49:00.000000', 'temperatura', 1015.0000, 'ºC'),
	(139942, 112, '2015-04-01 00:49:01.000000', 'temperatura', 409.0000, 'ºC'),
	(139943, 112, '2015-04-01 00:49:02.000000', 'temperatura', 203.0000, 'ºC'),
	(139944, 112, '2015-04-01 00:49:03.000000', 'temperatura', 988.0000, 'ºC'),
	(139945, 112, '2015-04-01 00:49:04.000000', 'temperatura', 730.0000, 'ºC'),
	(139946, 112, '2015-04-01 00:49:05.000000', 'temperatura', 686.0000, 'ºC'),
	(139947, 112, '2015-04-01 00:49:06.000000', 'temperatura', 43.0000, 'ºC'),
	(139948, 112, '2015-04-01 00:49:07.000000', 'temperatura', 557.0000, 'ºC'),
	(139949, 112, '2015-04-01 00:49:08.000000', 'temperatura', 257.0000, 'ºC'),
	(139950, 112, '2015-04-01 00:49:09.000000', 'temperatura', 815.0000, 'ºC'),
	(139951, 112, '2015-04-01 00:49:10.000000', 'temperatura', 905.0000, 'ºC'),
	(139952, 112, '2015-04-01 00:49:11.000000', 'temperatura', 878.0000, 'ºC'),
	(139953, 112, '2015-04-01 00:49:12.000000', 'temperatura', 476.0000, 'ºC'),
	(139954, 112, '2015-04-01 00:49:13.000000', 'temperatura', 945.0000, 'ºC'),
	(139955, 112, '2015-04-01 00:49:14.000000', 'temperatura', 899.0000, 'ºC'),
	(139956, 112, '2015-04-01 00:49:15.000000', 'temperatura', 460.0000, 'ºC'),
	(139957, 112, '2015-04-01 00:49:16.000000', 'temperatura', 803.0000, 'ºC'),
	(139958, 112, '2015-04-01 00:49:17.000000', 'temperatura', 238.0000, 'ºC'),
	(139959, 112, '2015-04-01 00:49:18.000000', 'temperatura', 1178.0000, 'ºC'),
	(139960, 112, '2015-04-01 00:49:19.000000', 'temperatura', 379.0000, 'ºC'),
	(139961, 112, '2015-04-01 00:49:20.000000', 'temperatura', 760.0000, 'ºC'),
	(139962, 112, '2015-04-01 00:49:21.000000', 'temperatura', 264.0000, 'ºC'),
	(139963, 112, '2015-04-01 00:49:22.000000', 'temperatura', 242.0000, 'ºC'),
	(139964, 112, '2015-04-01 00:49:23.000000', 'temperatura', 415.0000, 'ºC'),
	(139965, 112, '2015-04-01 00:49:24.000000', 'temperatura', 153.0000, 'ºC'),
	(139966, 112, '2015-04-01 00:49:25.000000', 'temperatura', 718.0000, 'ºC'),
	(139967, 112, '2015-04-01 00:49:26.000000', 'temperatura', 734.0000, 'ºC'),
	(139968, 112, '2015-04-01 00:49:27.000000', 'temperatura', 314.0000, 'ºC'),
	(139969, 112, '2015-04-01 00:49:28.000000', 'temperatura', 571.0000, 'ºC'),
	(139970, 112, '2015-04-01 00:49:29.000000', 'temperatura', 711.0000, 'ºC'),
	(139971, 112, '2015-04-01 00:49:30.000000', 'temperatura', 642.0000, 'ºC'),
	(139972, 112, '2015-04-01 00:49:31.000000', 'temperatura', 1080.0000, 'ºC'),
	(139973, 112, '2015-04-01 00:49:32.000000', 'temperatura', 1074.0000, 'ºC'),
	(139974, 112, '2015-04-01 00:49:33.000000', 'temperatura', 931.0000, 'ºC'),
	(139975, 112, '2015-04-01 00:49:34.000000', 'temperatura', 233.0000, 'ºC'),
	(139976, 112, '2015-04-01 00:49:35.000000', 'temperatura', 772.0000, 'ºC'),
	(139977, 112, '2015-04-01 00:49:36.000000', 'temperatura', 762.0000, 'ºC'),
	(139978, 112, '2015-04-01 00:49:37.000000', 'temperatura', 296.0000, 'ºC'),
	(139979, 112, '2015-04-01 00:49:38.000000', 'temperatura', 395.0000, 'ºC'),
	(139980, 112, '2015-04-01 00:49:39.000000', 'temperatura', 1087.0000, 'ºC'),
	(139981, 112, '2015-04-01 00:49:40.000000', 'temperatura', 651.0000, 'ºC'),
	(139982, 112, '2015-04-01 00:49:41.000000', 'temperatura', 1194.0000, 'ºC'),
	(139983, 112, '2015-04-01 00:49:42.000000', 'temperatura', 418.0000, 'ºC'),
	(139984, 112, '2015-04-01 00:49:43.000000', 'temperatura', 910.0000, 'ºC'),
	(139985, 112, '2015-04-01 00:49:44.000000', 'temperatura', 894.0000, 'ºC'),
	(139986, 112, '2015-04-01 00:49:45.000000', 'temperatura', 541.0000, 'ºC'),
	(139987, 112, '2015-04-01 00:49:46.000000', 'temperatura', 24.0000, 'ºC'),
	(139988, 112, '2015-04-01 00:49:47.000000', 'temperatura', 898.0000, 'ºC'),
	(139989, 112, '2015-04-01 00:49:48.000000', 'temperatura', 820.0000, 'ºC'),
	(139990, 112, '2015-04-01 00:49:49.000000', 'temperatura', 205.0000, 'ºC'),
	(139991, 112, '2015-04-01 00:49:50.000000', 'temperatura', 965.0000, 'ºC'),
	(139992, 112, '2015-04-01 00:49:51.000000', 'temperatura', 613.0000, 'ºC'),
	(139993, 112, '2015-04-01 00:49:52.000000', 'temperatura', 168.0000, 'ºC'),
	(139994, 112, '2015-04-01 00:49:53.000000', 'temperatura', 202.0000, 'ºC'),
	(139995, 112, '2015-04-01 00:49:54.000000', 'temperatura', 508.0000, 'ºC'),
	(139996, 112, '2015-04-01 00:49:55.000000', 'temperatura', 734.0000, 'ºC'),
	(139997, 112, '2015-04-01 00:49:56.000000', 'temperatura', 948.0000, 'ºC'),
	(139998, 112, '2015-04-01 00:49:57.000000', 'temperatura', 138.0000, 'ºC'),
	(139999, 112, '2015-04-01 00:49:58.000000', 'temperatura', 248.0000, 'ºC'),
	(140000, 112, '2015-04-01 00:49:59.000000', 'temperatura', 825.0000, 'ºC'),
	(140001, 112, '2015-04-01 00:50:00.000000', 'temperatura', 983.0000, 'ºC'),
	(140002, 112, '2015-04-01 00:50:01.000000', 'temperatura', 39.0000, 'ºC'),
	(140003, 112, '2015-04-01 00:50:02.000000', 'temperatura', 845.0000, 'ºC'),
	(140004, 112, '2015-04-01 00:50:03.000000', 'temperatura', 511.0000, 'ºC'),
	(140005, 112, '2015-04-01 00:50:04.000000', 'temperatura', 18.0000, 'ºC'),
	(140006, 112, '2015-04-01 00:50:05.000000', 'temperatura', 961.0000, 'ºC'),
	(140007, 112, '2015-04-01 00:50:06.000000', 'temperatura', 1149.0000, 'ºC'),
	(140008, 112, '2015-04-01 00:50:07.000000', 'temperatura', 463.0000, 'ºC'),
	(140009, 112, '2015-04-01 00:50:08.000000', 'temperatura', 67.0000, 'ºC'),
	(140010, 112, '2015-04-01 00:50:09.000000', 'temperatura', 146.0000, 'ºC'),
	(140011, 112, '2015-04-01 00:50:10.000000', 'temperatura', 531.0000, 'ºC'),
	(140012, 112, '2015-04-01 00:50:11.000000', 'temperatura', 1017.0000, 'ºC'),
	(140013, 112, '2015-04-01 00:50:12.000000', 'temperatura', 1094.0000, 'ºC'),
	(140014, 112, '2015-04-01 00:50:13.000000', 'temperatura', 20.0000, 'ºC'),
	(140015, 112, '2015-04-01 00:50:14.000000', 'temperatura', 419.0000, 'ºC'),
	(140016, 112, '2015-04-01 00:50:15.000000', 'temperatura', 836.0000, 'ºC'),
	(140017, 112, '2015-04-01 00:50:16.000000', 'temperatura', 523.0000, 'ºC'),
	(140018, 112, '2015-04-01 00:50:17.000000', 'temperatura', 109.0000, 'ºC'),
	(140019, 112, '2015-04-01 00:50:18.000000', 'temperatura', 174.0000, 'ºC'),
	(140020, 112, '2015-04-01 00:50:19.000000', 'temperatura', 545.0000, 'ºC'),
	(140021, 112, '2015-04-01 00:50:20.000000', 'temperatura', 1003.0000, 'ºC'),
	(140022, 112, '2015-04-01 00:50:21.000000', 'temperatura', 979.0000, 'ºC'),
	(140023, 112, '2015-04-01 00:50:22.000000', 'temperatura', 688.0000, 'ºC'),
	(140024, 112, '2015-04-01 00:50:23.000000', 'temperatura', 504.0000, 'ºC'),
	(140025, 112, '2015-04-01 00:50:24.000000', 'temperatura', 457.0000, 'ºC'),
	(140026, 112, '2015-04-01 00:50:25.000000', 'temperatura', 772.0000, 'ºC'),
	(140027, 112, '2015-04-01 00:50:26.000000', 'temperatura', 89.0000, 'ºC'),
	(140028, 112, '2015-04-01 00:50:27.000000', 'temperatura', 530.0000, 'ºC'),
	(140029, 112, '2015-04-01 00:50:28.000000', 'temperatura', 1182.0000, 'ºC'),
	(140030, 112, '2015-04-01 00:50:29.000000', 'temperatura', 723.0000, 'ºC'),
	(140031, 112, '2015-04-01 00:50:30.000000', 'temperatura', 70.0000, 'ºC'),
	(140032, 112, '2015-04-01 00:50:31.000000', 'temperatura', 579.0000, 'ºC'),
	(140033, 112, '2015-04-01 00:50:32.000000', 'temperatura', 286.0000, 'ºC'),
	(140034, 112, '2015-04-01 00:50:33.000000', 'temperatura', 894.0000, 'ºC'),
	(140035, 112, '2015-04-01 00:50:34.000000', 'temperatura', 10.0000, 'ºC'),
	(140036, 112, '2015-04-01 00:50:35.000000', 'temperatura', 972.0000, 'ºC'),
	(140037, 112, '2015-04-01 00:50:36.000000', 'temperatura', 29.0000, 'ºC'),
	(140038, 112, '2015-04-01 00:50:37.000000', 'temperatura', 831.0000, 'ºC'),
	(140039, 112, '2015-04-01 00:50:38.000000', 'temperatura', 470.0000, 'ºC'),
	(140040, 112, '2015-04-01 00:50:39.000000', 'temperatura', 1054.0000, 'ºC'),
	(140041, 112, '2015-04-01 00:50:40.000000', 'temperatura', 262.0000, 'ºC'),
	(140042, 112, '2015-04-01 00:50:41.000000', 'temperatura', 548.0000, 'ºC'),
	(140043, 112, '2015-04-01 00:50:42.000000', 'temperatura', 753.0000, 'ºC'),
	(140044, 112, '2015-04-01 00:50:43.000000', 'temperatura', 923.0000, 'ºC'),
	(140045, 112, '2015-04-01 00:50:44.000000', 'temperatura', 1155.0000, 'ºC'),
	(140046, 112, '2015-04-01 00:50:45.000000', 'temperatura', 609.0000, 'ºC'),
	(140047, 112, '2015-04-01 00:50:46.000000', 'temperatura', 778.0000, 'ºC'),
	(140048, 112, '2015-04-01 00:50:47.000000', 'temperatura', 863.0000, 'ºC'),
	(140049, 112, '2015-04-01 00:50:48.000000', 'temperatura', 782.0000, 'ºC'),
	(140050, 112, '2015-04-01 00:50:49.000000', 'temperatura', 122.0000, 'ºC'),
	(140051, 112, '2015-04-01 00:50:50.000000', 'temperatura', 665.0000, 'ºC'),
	(140052, 112, '2015-04-01 00:50:51.000000', 'temperatura', 560.0000, 'ºC'),
	(140053, 112, '2015-04-01 00:50:52.000000', 'temperatura', 807.0000, 'ºC'),
	(140054, 112, '2015-04-01 00:50:53.000000', 'temperatura', 1153.0000, 'ºC'),
	(140055, 112, '2015-04-01 00:50:54.000000', 'temperatura', 943.0000, 'ºC'),
	(140056, 112, '2015-04-01 00:50:55.000000', 'temperatura', 58.0000, 'ºC'),
	(140057, 112, '2015-04-01 00:50:56.000000', 'temperatura', 1063.0000, 'ºC'),
	(140058, 112, '2015-04-01 00:50:57.000000', 'temperatura', 340.0000, 'ºC'),
	(140059, 112, '2015-04-01 00:50:58.000000', 'temperatura', 913.0000, 'ºC'),
	(140060, 112, '2015-04-01 00:50:59.000000', 'temperatura', 1143.0000, 'ºC'),
	(140061, 112, '2015-04-01 00:51:00.000000', 'temperatura', 579.0000, 'ºC'),
	(140062, 112, '2015-04-01 00:51:01.000000', 'temperatura', 666.0000, 'ºC'),
	(140063, 112, '2015-04-01 00:51:02.000000', 'temperatura', 394.0000, 'ºC'),
	(140064, 112, '2015-04-01 00:51:03.000000', 'temperatura', 1173.0000, 'ºC'),
	(140065, 112, '2015-04-01 00:51:04.000000', 'temperatura', 1084.0000, 'ºC'),
	(140066, 112, '2015-04-01 00:51:05.000000', 'temperatura', 702.0000, 'ºC'),
	(140067, 112, '2015-04-01 00:51:06.000000', 'temperatura', 257.0000, 'ºC'),
	(140068, 112, '2015-04-01 00:51:07.000000', 'temperatura', 381.0000, 'ºC'),
	(140069, 112, '2015-04-01 00:51:08.000000', 'temperatura', 1134.0000, 'ºC'),
	(140070, 112, '2015-04-01 00:51:09.000000', 'temperatura', 929.0000, 'ºC'),
	(140071, 112, '2015-04-01 00:51:10.000000', 'temperatura', 41.0000, 'ºC'),
	(140072, 112, '2015-04-01 00:51:11.000000', 'temperatura', 1019.0000, 'ºC'),
	(140073, 112, '2015-04-01 00:51:12.000000', 'temperatura', 173.0000, 'ºC'),
	(140074, 112, '2015-04-01 00:51:13.000000', 'temperatura', 209.0000, 'ºC'),
	(140075, 112, '2015-04-01 00:51:14.000000', 'temperatura', 525.0000, 'ºC'),
	(140076, 112, '2015-04-01 00:51:15.000000', 'temperatura', 798.0000, 'ºC'),
	(140077, 112, '2015-04-01 00:51:16.000000', 'temperatura', 16.0000, 'ºC'),
	(140078, 112, '2015-04-01 00:51:17.000000', 'temperatura', 85.0000, 'ºC'),
	(140079, 112, '2015-04-01 00:51:18.000000', 'temperatura', 378.0000, 'ºC'),
	(140080, 112, '2015-04-01 00:51:19.000000', 'temperatura', 436.0000, 'ºC'),
	(140081, 112, '2015-04-01 00:51:20.000000', 'temperatura', 1046.0000, 'ºC'),
	(140082, 112, '2015-04-01 00:51:21.000000', 'temperatura', 322.0000, 'ºC'),
	(140083, 112, '2015-04-01 00:51:22.000000', 'temperatura', 875.0000, 'ºC'),
	(140084, 112, '2015-04-01 00:51:23.000000', 'temperatura', 1006.0000, 'ºC'),
	(140085, 112, '2015-04-01 00:51:24.000000', 'temperatura', 9.0000, 'ºC'),
	(140086, 112, '2015-04-01 00:51:25.000000', 'temperatura', 625.0000, 'ºC'),
	(140087, 112, '2015-04-01 00:51:26.000000', 'temperatura', 697.0000, 'ºC'),
	(140088, 112, '2015-04-01 00:51:27.000000', 'temperatura', 413.0000, 'ºC'),
	(140089, 112, '2015-04-01 00:51:28.000000', 'temperatura', 1174.0000, 'ºC'),
	(140090, 112, '2015-04-01 00:51:29.000000', 'temperatura', 1030.0000, 'ºC'),
	(140091, 112, '2015-04-01 00:51:30.000000', 'temperatura', 431.0000, 'ºC'),
	(140092, 112, '2015-04-01 00:51:31.000000', 'temperatura', 264.0000, 'ºC'),
	(140093, 112, '2015-04-01 00:51:32.000000', 'temperatura', 29.0000, 'ºC'),
	(140094, 112, '2015-04-01 00:51:33.000000', 'temperatura', 551.0000, 'ºC'),
	(140095, 112, '2015-04-01 00:51:34.000000', 'temperatura', 269.0000, 'ºC'),
	(140096, 112, '2015-04-01 00:51:35.000000', 'temperatura', 891.0000, 'ºC'),
	(140097, 112, '2015-04-01 00:51:36.000000', 'temperatura', 51.0000, 'ºC'),
	(140098, 112, '2015-04-01 00:51:37.000000', 'temperatura', 1181.0000, 'ºC'),
	(140099, 112, '2015-04-01 00:51:38.000000', 'temperatura', 954.0000, 'ºC'),
	(140100, 112, '2015-04-01 00:51:39.000000', 'temperatura', 28.0000, 'ºC'),
	(140101, 112, '2015-04-01 00:51:40.000000', 'temperatura', 879.0000, 'ºC'),
	(140102, 112, '2015-04-01 00:51:41.000000', 'temperatura', 710.0000, 'ºC'),
	(140103, 112, '2015-04-01 00:51:42.000000', 'temperatura', 912.0000, 'ºC'),
	(140104, 112, '2015-04-01 00:51:43.000000', 'temperatura', 33.0000, 'ºC'),
	(140105, 112, '2015-04-01 00:51:44.000000', 'temperatura', 1029.0000, 'ºC'),
	(140106, 112, '2015-04-01 00:51:45.000000', 'temperatura', 245.0000, 'ºC'),
	(140107, 112, '2015-04-01 00:51:46.000000', 'temperatura', 538.0000, 'ºC'),
	(140108, 112, '2015-04-01 00:51:47.000000', 'temperatura', 757.0000, 'ºC'),
	(140109, 112, '2015-04-01 00:51:48.000000', 'temperatura', 973.0000, 'ºC'),
	(140110, 112, '2015-04-01 00:51:49.000000', 'temperatura', 192.0000, 'ºC'),
	(140111, 112, '2015-04-01 00:51:50.000000', 'temperatura', 440.0000, 'ºC'),
	(140112, 112, '2015-04-01 00:51:51.000000', 'temperatura', 428.0000, 'ºC'),
	(140113, 112, '2015-04-01 00:51:52.000000', 'temperatura', 817.0000, 'ºC'),
	(140114, 112, '2015-04-01 00:51:53.000000', 'temperatura', 404.0000, 'ºC'),
	(140115, 112, '2015-04-01 00:51:54.000000', 'temperatura', 768.0000, 'ºC'),
	(140116, 112, '2015-04-01 00:51:55.000000', 'temperatura', 229.0000, 'ºC'),
	(140117, 112, '2015-04-01 00:51:56.000000', 'temperatura', 40.0000, 'ºC'),
	(140118, 112, '2015-04-01 00:51:57.000000', 'temperatura', 715.0000, 'ºC'),
	(140119, 112, '2015-04-01 00:51:58.000000', 'temperatura', 1056.0000, 'ºC'),
	(140120, 112, '2015-04-01 00:51:59.000000', 'temperatura', 735.0000, 'ºC'),
	(140121, 112, '2015-04-01 00:52:00.000000', 'temperatura', 508.0000, 'ºC'),
	(140122, 112, '2015-04-01 00:52:01.000000', 'temperatura', 334.0000, 'ºC'),
	(140123, 112, '2015-04-01 00:52:02.000000', 'temperatura', 146.0000, 'ºC'),
	(140124, 112, '2015-04-01 00:52:03.000000', 'temperatura', 928.0000, 'ºC'),
	(140125, 112, '2015-04-01 00:52:04.000000', 'temperatura', 605.0000, 'ºC'),
	(140126, 112, '2015-04-01 00:52:05.000000', 'temperatura', 241.0000, 'ºC'),
	(140127, 112, '2015-04-01 00:52:06.000000', 'temperatura', 589.0000, 'ºC'),
	(140128, 112, '2015-04-01 00:52:07.000000', 'temperatura', 1025.0000, 'ºC'),
	(140129, 112, '2015-04-01 00:52:08.000000', 'temperatura', 957.0000, 'ºC'),
	(140130, 112, '2015-04-01 00:52:09.000000', 'temperatura', 509.0000, 'ºC'),
	(140131, 112, '2015-04-01 00:52:10.000000', 'temperatura', 876.0000, 'ºC'),
	(140132, 112, '2015-04-01 00:52:11.000000', 'temperatura', 454.0000, 'ºC'),
	(140133, 112, '2015-04-01 00:52:12.000000', 'temperatura', 842.0000, 'ºC'),
	(140134, 112, '2015-04-01 00:52:13.000000', 'temperatura', 447.0000, 'ºC'),
	(140135, 112, '2015-04-01 00:52:14.000000', 'temperatura', 912.0000, 'ºC'),
	(140136, 112, '2015-04-01 00:52:15.000000', 'temperatura', 817.0000, 'ºC'),
	(140137, 112, '2015-04-01 00:52:16.000000', 'temperatura', 152.0000, 'ºC'),
	(140138, 112, '2015-04-01 00:52:17.000000', 'temperatura', 709.0000, 'ºC'),
	(140139, 112, '2015-04-01 00:52:18.000000', 'temperatura', 691.0000, 'ºC'),
	(140140, 112, '2015-04-01 00:52:19.000000', 'temperatura', 128.0000, 'ºC'),
	(140141, 112, '2015-04-01 00:52:20.000000', 'temperatura', 967.0000, 'ºC'),
	(140142, 112, '2015-04-01 00:52:21.000000', 'temperatura', 851.0000, 'ºC'),
	(140143, 112, '2015-04-01 00:52:22.000000', 'temperatura', 157.0000, 'ºC'),
	(140144, 112, '2015-04-01 00:52:23.000000', 'temperatura', 630.0000, 'ºC'),
	(140145, 112, '2015-04-01 00:52:24.000000', 'temperatura', 282.0000, 'ºC'),
	(140146, 112, '2015-04-01 00:52:25.000000', 'temperatura', 719.0000, 'ºC'),
	(140147, 112, '2015-04-01 00:52:26.000000', 'temperatura', 351.0000, 'ºC'),
	(140148, 112, '2015-04-01 00:52:27.000000', 'temperatura', 797.0000, 'ºC'),
	(140149, 112, '2015-04-01 00:52:28.000000', 'temperatura', 533.0000, 'ºC'),
	(140150, 112, '2015-04-01 00:52:29.000000', 'temperatura', 272.0000, 'ºC'),
	(140151, 112, '2015-04-01 00:52:30.000000', 'temperatura', 965.0000, 'ºC'),
	(140152, 112, '2015-04-01 00:52:31.000000', 'temperatura', 407.0000, 'ºC'),
	(140153, 112, '2015-04-01 00:52:32.000000', 'temperatura', 342.0000, 'ºC'),
	(140154, 112, '2015-04-01 00:52:33.000000', 'temperatura', 489.0000, 'ºC'),
	(140155, 112, '2015-04-01 00:52:34.000000', 'temperatura', 219.0000, 'ºC'),
	(140156, 112, '2015-04-01 00:52:35.000000', 'temperatura', 829.0000, 'ºC'),
	(140157, 112, '2015-04-01 00:52:36.000000', 'temperatura', 1087.0000, 'ºC'),
	(140158, 112, '2015-04-01 00:52:37.000000', 'temperatura', 548.0000, 'ºC'),
	(140159, 112, '2015-04-01 00:52:38.000000', 'temperatura', 680.0000, 'ºC'),
	(140160, 112, '2015-04-01 00:52:39.000000', 'temperatura', 557.0000, 'ºC'),
	(140161, 112, '2015-04-01 00:52:40.000000', 'temperatura', 743.0000, 'ºC'),
	(140162, 112, '2015-04-01 00:52:41.000000', 'temperatura', 848.0000, 'ºC'),
	(140163, 112, '2015-04-01 00:52:42.000000', 'temperatura', 810.0000, 'ºC'),
	(140164, 112, '2015-04-01 00:52:43.000000', 'temperatura', 305.0000, 'ºC'),
	(140165, 112, '2015-04-01 00:52:44.000000', 'temperatura', 297.0000, 'ºC'),
	(140166, 112, '2015-04-01 00:52:45.000000', 'temperatura', 568.0000, 'ºC'),
	(140167, 112, '2015-04-01 00:52:46.000000', 'temperatura', 752.0000, 'ºC'),
	(140168, 112, '2015-04-01 00:52:47.000000', 'temperatura', 857.0000, 'ºC'),
	(140169, 112, '2015-04-01 00:52:48.000000', 'temperatura', 828.0000, 'ºC'),
	(140170, 112, '2015-04-01 00:52:49.000000', 'temperatura', 372.0000, 'ºC'),
	(140171, 112, '2015-04-01 00:52:50.000000', 'temperatura', 575.0000, 'ºC'),
	(140172, 112, '2015-04-01 00:52:51.000000', 'temperatura', 558.0000, 'ºC'),
	(140173, 112, '2015-04-01 00:52:52.000000', 'temperatura', 1067.0000, 'ºC'),
	(140174, 112, '2015-04-01 00:52:53.000000', 'temperatura', 60.0000, 'ºC'),
	(140175, 112, '2015-04-01 00:52:54.000000', 'temperatura', 700.0000, 'ºC'),
	(140176, 112, '2015-04-01 00:52:55.000000', 'temperatura', 919.0000, 'ºC'),
	(140177, 112, '2015-04-01 00:52:56.000000', 'temperatura', 96.0000, 'ºC'),
	(140178, 112, '2015-04-01 00:52:57.000000', 'temperatura', 125.0000, 'ºC'),
	(140179, 112, '2015-04-01 00:52:58.000000', 'temperatura', 335.0000, 'ºC'),
	(140180, 112, '2015-04-01 00:52:59.000000', 'temperatura', 103.0000, 'ºC'),
	(140181, 112, '2015-04-01 00:53:00.000000', 'temperatura', 709.0000, 'ºC'),
	(140182, 112, '2015-04-01 00:53:01.000000', 'temperatura', 835.0000, 'ºC'),
	(140183, 112, '2015-04-01 00:53:02.000000', 'temperatura', 851.0000, 'ºC'),
	(140184, 112, '2015-04-01 00:53:03.000000', 'temperatura', 549.0000, 'ºC'),
	(140185, 112, '2015-04-01 00:53:04.000000', 'temperatura', 192.0000, 'ºC'),
	(140186, 112, '2015-04-01 00:53:05.000000', 'temperatura', 512.0000, 'ºC'),
	(140187, 112, '2015-04-01 00:53:06.000000', 'temperatura', 787.0000, 'ºC'),
	(140188, 112, '2015-04-01 00:53:07.000000', 'temperatura', 1197.0000, 'ºC'),
	(140189, 112, '2015-04-01 00:53:08.000000', 'temperatura', 26.0000, 'ºC'),
	(140190, 112, '2015-04-01 00:53:09.000000', 'temperatura', 137.0000, 'ºC'),
	(140191, 112, '2015-04-01 00:53:10.000000', 'temperatura', 610.0000, 'ºC'),
	(140192, 112, '2015-04-01 00:53:11.000000', 'temperatura', 239.0000, 'ºC'),
	(140193, 112, '2015-04-01 00:53:12.000000', 'temperatura', 567.0000, 'ºC'),
	(140194, 112, '2015-04-01 00:53:13.000000', 'temperatura', 916.0000, 'ºC'),
	(140195, 112, '2015-04-01 00:53:14.000000', 'temperatura', 481.0000, 'ºC'),
	(140196, 112, '2015-04-01 00:53:15.000000', 'temperatura', 858.0000, 'ºC'),
	(140197, 112, '2015-04-01 00:53:16.000000', 'temperatura', 446.0000, 'ºC'),
	(140198, 112, '2015-04-01 00:53:17.000000', 'temperatura', 857.0000, 'ºC'),
	(140199, 112, '2015-04-01 00:53:18.000000', 'temperatura', 549.0000, 'ºC'),
	(140200, 112, '2015-04-01 00:53:19.000000', 'temperatura', 174.0000, 'ºC'),
	(140201, 112, '2015-04-01 00:53:20.000000', 'temperatura', 425.0000, 'ºC'),
	(140202, 112, '2015-04-01 00:53:21.000000', 'temperatura', 400.0000, 'ºC'),
	(140203, 112, '2015-04-01 00:53:22.000000', 'temperatura', 727.0000, 'ºC'),
	(140204, 112, '2015-04-01 00:53:23.000000', 'temperatura', 37.0000, 'ºC'),
	(140205, 112, '2015-04-01 00:53:24.000000', 'temperatura', 404.0000, 'ºC'),
	(140206, 112, '2015-04-01 00:53:25.000000', 'temperatura', 708.0000, 'ºC'),
	(140207, 112, '2015-04-01 00:53:26.000000', 'temperatura', 1128.0000, 'ºC'),
	(140208, 112, '2015-04-01 00:53:27.000000', 'temperatura', 1116.0000, 'ºC'),
	(140209, 112, '2015-04-01 00:53:28.000000', 'temperatura', 999.0000, 'ºC'),
	(140210, 112, '2015-04-01 00:53:29.000000', 'temperatura', 445.0000, 'ºC'),
	(140211, 112, '2015-04-01 00:53:30.000000', 'temperatura', 430.0000, 'ºC'),
	(140212, 112, '2015-04-01 00:53:31.000000', 'temperatura', 814.0000, 'ºC'),
	(140213, 112, '2015-04-01 00:53:32.000000', 'temperatura', 380.0000, 'ºC'),
	(140214, 112, '2015-04-01 00:53:33.000000', 'temperatura', 661.0000, 'ºC'),
	(140215, 112, '2015-04-01 00:53:34.000000', 'temperatura', 963.0000, 'ºC'),
	(140216, 112, '2015-04-01 00:53:35.000000', 'temperatura', 432.0000, 'ºC'),
	(140217, 112, '2015-04-01 00:53:36.000000', 'temperatura', 473.0000, 'ºC'),
	(140218, 112, '2015-04-01 00:53:37.000000', 'temperatura', 1067.0000, 'ºC'),
	(140219, 112, '2015-04-01 00:53:38.000000', 'temperatura', 320.0000, 'ºC'),
	(140220, 112, '2015-04-01 00:53:39.000000', 'temperatura', 799.0000, 'ºC'),
	(140221, 112, '2015-04-01 00:53:40.000000', 'temperatura', 634.0000, 'ºC'),
	(140222, 112, '2015-04-01 00:53:41.000000', 'temperatura', 774.0000, 'ºC'),
	(140223, 112, '2015-04-01 00:53:42.000000', 'temperatura', 768.0000, 'ºC'),
	(140224, 112, '2015-04-01 00:53:43.000000', 'temperatura', 320.0000, 'ºC'),
	(140225, 112, '2015-04-01 00:53:44.000000', 'temperatura', 497.0000, 'ºC'),
	(140226, 112, '2015-04-01 00:53:45.000000', 'temperatura', 325.0000, 'ºC'),
	(140227, 112, '2015-04-01 00:53:46.000000', 'temperatura', 136.0000, 'ºC'),
	(140228, 112, '2015-04-01 00:53:47.000000', 'temperatura', 905.0000, 'ºC'),
	(140229, 112, '2015-04-01 00:53:48.000000', 'temperatura', 517.0000, 'ºC'),
	(140230, 112, '2015-04-01 00:53:49.000000', 'temperatura', 1072.0000, 'ºC'),
	(140231, 112, '2015-04-01 00:53:50.000000', 'temperatura', 208.0000, 'ºC'),
	(140232, 112, '2015-04-01 00:53:51.000000', 'temperatura', 226.0000, 'ºC'),
	(140233, 112, '2015-04-01 00:53:52.000000', 'temperatura', 504.0000, 'ºC'),
	(140234, 112, '2015-04-01 00:53:53.000000', 'temperatura', 645.0000, 'ºC'),
	(140235, 112, '2015-04-01 00:53:54.000000', 'temperatura', 512.0000, 'ºC'),
	(140236, 112, '2015-04-01 00:53:55.000000', 'temperatura', 627.0000, 'ºC'),
	(140237, 112, '2015-04-01 00:53:56.000000', 'temperatura', 399.0000, 'ºC'),
	(140238, 112, '2015-04-01 00:53:57.000000', 'temperatura', 113.0000, 'ºC'),
	(140239, 112, '2015-04-01 00:53:58.000000', 'temperatura', 570.0000, 'ºC'),
	(140240, 112, '2015-04-01 00:53:59.000000', 'temperatura', 111.0000, 'ºC'),
	(140241, 112, '2015-04-01 00:54:00.000000', 'temperatura', 45.0000, 'ºC'),
	(140242, 112, '2015-04-01 00:54:01.000000', 'temperatura', 1094.0000, 'ºC'),
	(140243, 112, '2015-04-01 00:54:02.000000', 'temperatura', 533.0000, 'ºC'),
	(140244, 112, '2015-04-01 00:54:03.000000', 'temperatura', 583.0000, 'ºC'),
	(140245, 112, '2015-04-01 00:54:04.000000', 'temperatura', 118.0000, 'ºC'),
	(140246, 112, '2015-04-01 00:54:05.000000', 'temperatura', 42.0000, 'ºC'),
	(140247, 112, '2015-04-01 00:54:06.000000', 'temperatura', 1056.0000, 'ºC'),
	(140248, 112, '2015-04-01 00:54:07.000000', 'temperatura', 356.0000, 'ºC'),
	(140249, 112, '2015-04-01 00:54:08.000000', 'temperatura', 1011.0000, 'ºC'),
	(140250, 112, '2015-04-01 00:54:09.000000', 'temperatura', 388.0000, 'ºC'),
	(140251, 112, '2015-04-01 00:54:10.000000', 'temperatura', 105.0000, 'ºC'),
	(140252, 112, '2015-04-01 00:54:11.000000', 'temperatura', 565.0000, 'ºC'),
	(140253, 112, '2015-04-01 00:54:12.000000', 'temperatura', 108.0000, 'ºC'),
	(140254, 112, '2015-04-01 00:54:13.000000', 'temperatura', 47.0000, 'ºC'),
	(140255, 112, '2015-04-01 00:54:14.000000', 'temperatura', 1110.0000, 'ºC'),
	(140256, 112, '2015-04-01 00:54:15.000000', 'temperatura', 609.0000, 'ºC'),
	(140257, 112, '2015-04-01 00:54:16.000000', 'temperatura', 916.0000, 'ºC'),
	(140258, 112, '2015-04-01 00:54:17.000000', 'temperatura', 352.0000, 'ºC'),
	(140259, 112, '2015-04-01 00:54:18.000000', 'temperatura', 215.0000, 'ºC'),
	(140260, 112, '2015-04-01 00:54:19.000000', 'temperatura', 18.0000, 'ºC'),
	(140261, 112, '2015-04-01 00:54:20.000000', 'temperatura', 645.0000, 'ºC'),
	(140262, 112, '2015-04-01 00:54:21.000000', 'temperatura', 774.0000, 'ºC'),
	(140263, 112, '2015-04-01 00:54:22.000000', 'temperatura', 733.0000, 'ºC'),
	(140264, 112, '2015-04-01 00:54:23.000000', 'temperatura', 145.0000, 'ºC'),
	(140265, 112, '2015-04-01 00:54:24.000000', 'temperatura', 926.0000, 'ºC'),
	(140266, 112, '2015-04-01 00:54:25.000000', 'temperatura', 596.0000, 'ºC'),
	(140267, 112, '2015-04-01 00:54:26.000000', 'temperatura', 201.0000, 'ºC'),
	(140268, 112, '2015-04-01 00:54:27.000000', 'temperatura', 419.0000, 'ºC'),
	(140269, 112, '2015-04-01 00:54:28.000000', 'temperatura', 294.0000, 'ºC'),
	(140270, 112, '2015-04-01 00:54:29.000000', 'temperatura', 210.0000, 'ºC'),
	(140271, 112, '2015-04-01 00:54:30.000000', 'temperatura', 171.0000, 'ºC'),
	(140272, 112, '2015-04-01 00:54:31.000000', 'temperatura', 225.0000, 'ºC'),
	(140273, 112, '2015-04-01 00:54:32.000000', 'temperatura', 613.0000, 'ºC'),
	(140274, 112, '2015-04-01 00:54:33.000000', 'temperatura', 1190.0000, 'ºC'),
	(140275, 112, '2015-04-01 00:54:34.000000', 'temperatura', 513.0000, 'ºC'),
	(140276, 112, '2015-04-01 00:54:35.000000', 'temperatura', 196.0000, 'ºC'),
	(140277, 112, '2015-04-01 00:54:36.000000', 'temperatura', 642.0000, 'ºC'),
	(140278, 112, '2015-04-01 00:54:37.000000', 'temperatura', 221.0000, 'ºC'),
	(140279, 112, '2015-04-01 00:54:38.000000', 'temperatura', 379.0000, 'ºC'),
	(140280, 112, '2015-04-01 00:54:39.000000', 'temperatura', 31.0000, 'ºC'),
	(140281, 112, '2015-04-01 00:54:40.000000', 'temperatura', 221.0000, 'ºC'),
	(140282, 112, '2015-04-01 00:54:41.000000', 'temperatura', 1011.0000, 'ºC'),
	(140283, 112, '2015-04-01 00:54:42.000000', 'temperatura', 794.0000, 'ºC'),
	(140284, 112, '2015-04-01 00:54:43.000000', 'temperatura', 937.0000, 'ºC'),
	(140285, 112, '2015-04-01 00:54:44.000000', 'temperatura', 1103.0000, 'ºC'),
	(140286, 112, '2015-04-01 00:54:45.000000', 'temperatura', 306.0000, 'ºC'),
	(140287, 112, '2015-04-01 00:54:46.000000', 'temperatura', 622.0000, 'ºC'),
	(140288, 112, '2015-04-01 00:54:47.000000', 'temperatura', 992.0000, 'ºC'),
	(140289, 112, '2015-04-01 00:54:48.000000', 'temperatura', 695.0000, 'ºC'),
	(140290, 112, '2015-04-01 00:54:49.000000', 'temperatura', 500.0000, 'ºC'),
	(140291, 112, '2015-04-01 00:54:50.000000', 'temperatura', 414.0000, 'ºC'),
	(140292, 112, '2015-04-01 00:54:51.000000', 'temperatura', 573.0000, 'ºC'),
	(140293, 112, '2015-04-01 00:54:52.000000', 'temperatura', 423.0000, 'ºC'),
	(140294, 112, '2015-04-01 00:54:53.000000', 'temperatura', 395.0000, 'ºC'),
	(140295, 112, '2015-04-01 00:54:54.000000', 'temperatura', 706.0000, 'ºC'),
	(140296, 112, '2015-04-01 00:54:55.000000', 'temperatura', 1146.0000, 'ºC'),
	(140297, 112, '2015-04-01 00:54:56.000000', 'temperatura', 12.0000, 'ºC'),
	(140298, 112, '2015-04-01 00:54:57.000000', 'temperatura', 224.0000, 'ºC'),
	(140299, 112, '2015-04-01 00:54:58.000000', 'temperatura', 1083.0000, 'ºC'),
	(140300, 112, '2015-04-01 00:54:59.000000', 'temperatura', 1145.0000, 'ºC'),
	(140301, 112, '2015-04-01 00:55:00.000000', 'temperatura', 74.0000, 'ºC'),
	(140302, 112, '2015-04-01 00:55:01.000000', 'temperatura', 537.0000, 'ºC'),
	(140303, 112, '2015-04-01 00:55:02.000000', 'temperatura', 65.0000, 'ºC'),
	(140304, 112, '2015-04-01 00:55:03.000000', 'temperatura', 1112.0000, 'ºC'),
	(140305, 112, '2015-04-01 00:55:04.000000', 'temperatura', 566.0000, 'ºC'),
	(140306, 112, '2015-04-01 00:55:05.000000', 'temperatura', 694.0000, 'ºC'),
	(140307, 112, '2015-04-01 00:55:06.000000', 'temperatura', 575.0000, 'ºC'),
	(140308, 112, '2015-04-01 00:55:07.000000', 'temperatura', 792.0000, 'ºC'),
	(140309, 112, '2015-04-01 00:55:08.000000', 'temperatura', 1035.0000, 'ºC'),
	(140310, 112, '2015-04-01 00:55:09.000000', 'temperatura', 401.0000, 'ºC'),
	(140311, 112, '2015-04-01 00:55:10.000000', 'temperatura', 101.0000, 'ºC'),
	(140312, 112, '2015-04-01 00:55:11.000000', 'temperatura', 503.0000, 'ºC'),
	(140313, 112, '2015-04-01 00:55:12.000000', 'temperatura', 1012.0000, 'ºC'),
	(140314, 112, '2015-04-01 00:55:13.000000', 'temperatura', 1150.0000, 'ºC'),
	(140315, 112, '2015-04-01 00:55:14.000000', 'temperatura', 315.0000, 'ºC'),
	(140316, 112, '2015-04-01 00:55:15.000000', 'temperatura', 527.0000, 'ºC'),
	(140317, 112, '2015-04-01 00:55:16.000000', 'temperatura', 487.0000, 'ºC'),
	(140318, 112, '2015-04-01 00:55:17.000000', 'temperatura', 858.0000, 'ºC'),
	(140319, 112, '2015-04-01 00:55:18.000000', 'temperatura', 430.0000, 'ºC'),
	(140320, 112, '2015-04-01 00:55:19.000000', 'temperatura', 775.0000, 'ºC'),
	(140321, 112, '2015-04-01 00:55:20.000000', 'temperatura', 187.0000, 'ºC'),
	(140322, 112, '2015-04-01 00:55:21.000000', 'temperatura', 1010.0000, 'ºC'),
	(140323, 112, '2015-04-01 00:55:22.000000', 'temperatura', 890.0000, 'ºC'),
	(140324, 112, '2015-04-01 00:55:23.000000', 'temperatura', 220.0000, 'ºC'),
	(140325, 112, '2015-04-01 00:55:24.000000', 'temperatura', 831.0000, 'ºC'),
	(140326, 112, '2015-04-01 00:55:25.000000', 'temperatura', 1095.0000, 'ºC'),
	(140327, 112, '2015-04-01 00:55:26.000000', 'temperatura', 583.0000, 'ºC'),
	(140328, 112, '2015-04-01 00:55:27.000000', 'temperatura', 832.0000, 'ºC'),
	(140329, 112, '2015-04-01 00:55:28.000000', 'temperatura', 10.0000, 'ºC'),
	(140330, 112, '2015-04-01 00:55:29.000000', 'temperatura', 1155.0000, 'ºC'),
	(140331, 112, '2015-04-01 00:55:30.000000', 'temperatura', 947.0000, 'ºC'),
	(140332, 112, '2015-04-01 00:55:31.000000', 'temperatura', 69.0000, 'ºC'),
	(140333, 112, '2015-04-01 00:55:32.000000', 'temperatura', 1107.0000, 'ºC'),
	(140334, 112, '2015-04-01 00:55:33.000000', 'temperatura', 525.0000, 'ºC'),
	(140335, 112, '2015-04-01 00:55:34.000000', 'temperatura', 506.0000, 'ºC'),
	(140336, 112, '2015-04-01 00:55:35.000000', 'temperatura', 956.0000, 'ºC'),
	(140337, 112, '2015-04-01 00:55:36.000000', 'temperatura', 860.0000, 'ºC'),
	(140338, 112, '2015-04-01 00:55:37.000000', 'temperatura', 235.0000, 'ºC'),
	(140339, 112, '2015-04-01 00:55:38.000000', 'temperatura', 995.0000, 'ºC'),
	(140340, 112, '2015-04-01 00:55:39.000000', 'temperatura', 672.0000, 'ºC'),
	(140341, 112, '2015-04-01 00:55:40.000000', 'temperatura', 375.0000, 'ºC'),
	(140342, 112, '2015-04-01 00:55:41.000000', 'temperatura', 1059.0000, 'ºC'),
	(140343, 112, '2015-04-01 00:55:42.000000', 'temperatura', 572.0000, 'ºC'),
	(140344, 112, '2015-04-01 00:55:43.000000', 'temperatura', 882.0000, 'ºC'),
	(140345, 112, '2015-04-01 00:55:44.000000', 'temperatura', 296.0000, 'ºC'),
	(140346, 112, '2015-04-01 00:55:45.000000', 'temperatura', 34.0000, 'ºC'),
	(140347, 112, '2015-04-01 00:55:46.000000', 'temperatura', 481.0000, 'ºC'),
	(140348, 112, '2015-04-01 00:55:47.000000', 'temperatura', 1105.0000, 'ºC'),
	(140349, 112, '2015-04-01 00:55:48.000000', 'temperatura', 482.0000, 'ºC'),
	(140350, 112, '2015-04-01 00:55:49.000000', 'temperatura', 297.0000, 'ºC'),
	(140351, 112, '2015-04-01 00:55:50.000000', 'temperatura', 38.0000, 'ºC'),
	(140352, 112, '2015-04-01 00:55:51.000000', 'temperatura', 500.0000, 'ºC'),
	(140353, 112, '2015-04-01 00:55:52.000000', 'temperatura', 1187.0000, 'ºC'),
	(140354, 112, '2015-04-01 00:55:53.000000', 'temperatura', 835.0000, 'ºC'),
	(140355, 112, '2015-04-01 00:55:54.000000', 'temperatura', 613.0000, 'ºC'),
	(140356, 112, '2015-04-01 00:55:55.000000', 'temperatura', 563.0000, 'ºC'),
	(140357, 112, '2015-04-01 00:55:56.000000', 'temperatura', 975.0000, 'ºC'),
	(140358, 112, '2015-04-01 00:55:57.000000', 'temperatura', 788.0000, 'ºC'),
	(140359, 112, '2015-04-01 00:55:58.000000', 'temperatura', 1013.0000, 'ºC'),
	(140360, 112, '2015-04-01 00:55:59.000000', 'temperatura', 305.0000, 'ºC'),
	(140361, 112, '2015-04-01 00:56:00.000000', 'temperatura', 883.0000, 'ºC'),
	(140362, 112, '2015-04-01 00:56:01.000000', 'temperatura', 1103.0000, 'ºC'),
	(140363, 112, '2015-04-01 00:56:02.000000', 'temperatura', 466.0000, 'ºC'),
	(140364, 112, '2015-04-01 00:56:03.000000', 'temperatura', 221.0000, 'ºC'),
	(140365, 112, '2015-04-01 00:56:04.000000', 'temperatura', 908.0000, 'ºC'),
	(140366, 112, '2015-04-01 00:56:05.000000', 'temperatura', 275.0000, 'ºC'),
	(140367, 112, '2015-04-01 00:56:06.000000', 'temperatura', 1054.0000, 'ºC'),
	(140368, 112, '2015-04-01 00:56:07.000000', 'temperatura', 846.0000, 'ºC'),
	(140369, 112, '2015-04-01 00:56:08.000000', 'temperatura', 1066.0000, 'ºC'),
	(140370, 112, '2015-04-01 00:56:09.000000', 'temperatura', 392.0000, 'ºC'),
	(140371, 112, '2015-04-01 00:56:10.000000', 'temperatura', 1164.0000, 'ºC'),
	(140372, 112, '2015-04-01 00:56:11.000000', 'temperatura', 1045.0000, 'ºC'),
	(140373, 112, '2015-04-01 00:56:12.000000', 'temperatura', 535.0000, 'ºC'),
	(140374, 112, '2015-04-01 00:56:13.000000', 'temperatura', 740.0000, 'ºC'),
	(140375, 112, '2015-04-01 00:56:14.000000', 'temperatura', 894.0000, 'ºC'),
	(140376, 112, '2015-04-01 00:56:15.000000', 'temperatura', 1050.0000, 'ºC'),
	(140377, 112, '2015-04-01 00:56:16.000000', 'temperatura', 167.0000, 'ºC'),
	(140378, 112, '2015-04-01 00:56:17.000000', 'temperatura', 88.0000, 'ºC'),
	(140379, 112, '2015-04-01 00:56:18.000000', 'temperatura', 1139.0000, 'ºC'),
	(140380, 112, '2015-04-01 00:56:19.000000', 'temperatura', 630.0000, 'ºC'),
	(140381, 112, '2015-04-01 00:56:20.000000', 'temperatura', 934.0000, 'ºC'),
	(140382, 112, '2015-04-01 00:56:21.000000', 'temperatura', 380.0000, 'ºC'),
	(140383, 112, '2015-04-01 00:56:22.000000', 'temperatura', 298.0000, 'ºC'),
	(140384, 112, '2015-04-01 00:56:23.000000', 'temperatura', 353.0000, 'ºC'),
	(140385, 112, '2015-04-01 00:56:24.000000', 'temperatura', 870.0000, 'ºC'),
	(140386, 112, '2015-04-01 00:56:25.000000', 'temperatura', 892.0000, 'ºC'),
	(140387, 112, '2015-04-01 00:56:26.000000', 'temperatura', 649.0000, 'ºC'),
	(140388, 112, '2015-04-01 00:56:27.000000', 'temperatura', 572.0000, 'ºC'),
	(140389, 112, '2015-04-01 00:56:28.000000', 'temperatura', 910.0000, 'ºC'),
	(140390, 112, '2015-04-01 00:56:29.000000', 'temperatura', 437.0000, 'ºC'),
	(140391, 112, '2015-04-01 00:56:30.000000', 'temperatura', 657.0000, 'ºC'),
	(140392, 112, '2015-04-01 00:56:31.000000', 'temperatura', 772.0000, 'ºC'),
	(140393, 112, '2015-04-01 00:56:32.000000', 'temperatura', 691.0000, 'ºC'),
	(140394, 112, '2015-04-01 00:56:33.000000', 'temperatura', 1139.0000, 'ºC'),
	(140395, 112, '2015-04-01 00:56:34.000000', 'temperatura', 21.0000, 'ºC'),
	(140396, 112, '2015-04-01 00:56:35.000000', 'temperatura', 288.0000, 'ºC'),
	(140397, 112, '2015-04-01 00:56:36.000000', 'temperatura', 178.0000, 'ºC'),
	(140398, 112, '2015-04-01 00:56:37.000000', 'temperatura', 28.0000, 'ºC'),
	(140399, 112, '2015-04-01 00:56:38.000000', 'temperatura', 805.0000, 'ºC'),
	(140400, 112, '2015-04-01 00:56:39.000000', 'temperatura', 342.0000, 'ºC'),
	(140401, 112, '2015-04-01 00:56:40.000000', 'temperatura', 494.0000, 'ºC'),
	(140402, 112, '2015-04-01 00:56:41.000000', 'temperatura', 245.0000, 'ºC'),
	(140403, 112, '2015-04-01 00:56:42.000000', 'temperatura', 946.0000, 'ºC'),
	(140404, 112, '2015-04-01 00:56:43.000000', 'temperatura', 392.0000, 'ºC'),
	(140405, 112, '2015-04-01 00:56:44.000000', 'temperatura', 324.0000, 'ºC'),
	(140406, 112, '2015-04-01 00:56:45.000000', 'temperatura', 445.0000, 'ºC'),
	(140407, 112, '2015-04-01 00:56:46.000000', 'temperatura', 54.0000, 'ºC'),
	(140408, 112, '2015-04-01 00:56:47.000000', 'temperatura', 136.0000, 'ºC'),
	(140409, 112, '2015-04-01 00:56:48.000000', 'temperatura', 517.0000, 'ºC'),
	(140410, 112, '2015-04-01 00:56:49.000000', 'temperatura', 976.0000, 'ºC'),
	(140411, 112, '2015-04-01 00:56:50.000000', 'temperatura', 930.0000, 'ºC'),
	(140412, 112, '2015-04-01 00:56:51.000000', 'temperatura', 524.0000, 'ºC'),
	(140413, 112, '2015-04-01 00:56:52.000000', 'temperatura', 1031.0000, 'ºC'),
	(140414, 112, '2015-04-01 00:56:53.000000', 'temperatura', 1182.0000, 'ºC'),
	(140415, 112, '2015-04-01 00:56:54.000000', 'temperatura', 417.0000, 'ºC'),
	(140416, 112, '2015-04-01 00:56:55.000000', 'temperatura', 941.0000, 'ºC'),
	(140417, 112, '2015-04-01 00:56:56.000000', 'temperatura', 1054.0000, 'ºC'),
	(140418, 112, '2015-04-01 00:56:57.000000', 'temperatura', 47.0000, 'ºC'),
	(140419, 112, '2015-04-01 00:56:58.000000', 'temperatura', 672.0000, 'ºC'),
	(140420, 112, '2015-04-01 00:56:59.000000', 'temperatura', 821.0000, 'ºC'),
	(140421, 112, '2015-04-01 00:57:00.000000', 'temperatura', 888.0000, 'ºC'),
	(140422, 112, '2015-04-01 00:57:01.000000', 'temperatura', 777.0000, 'ºC'),
	(140423, 112, '2015-04-01 00:57:02.000000', 'temperatura', 24.0000, 'ºC'),
	(140424, 112, '2015-04-01 00:57:03.000000', 'temperatura', 189.0000, 'ºC'),
	(140425, 112, '2015-04-01 00:57:04.000000', 'temperatura', 874.0000, 'ºC'),
	(140426, 112, '2015-04-01 00:57:05.000000', 'temperatura', 202.0000, 'ºC'),
	(140427, 112, '2015-04-01 00:57:06.000000', 'temperatura', 791.0000, 'ºC'),
	(140428, 112, '2015-04-01 00:57:07.000000', 'temperatura', 947.0000, 'ºC'),
	(140429, 112, '2015-04-01 00:57:08.000000', 'temperatura', 1162.0000, 'ºC'),
	(140430, 112, '2015-04-01 00:57:09.000000', 'temperatura', 572.0000, 'ºC'),
	(140431, 112, '2015-04-01 00:57:10.000000', 'temperatura', 573.0000, 'ºC'),
	(140432, 112, '2015-04-01 00:57:11.000000', 'temperatura', 1152.0000, 'ºC'),
	(140433, 112, '2015-04-01 00:57:12.000000', 'temperatura', 438.0000, 'ºC'),
	(140434, 112, '2015-04-01 00:57:13.000000', 'temperatura', 1136.0000, 'ºC'),
	(140435, 112, '2015-04-01 00:57:14.000000', 'temperatura', 768.0000, 'ºC'),
	(140436, 112, '2015-04-01 00:57:15.000000', 'temperatura', 432.0000, 'ºC'),
	(140437, 112, '2015-04-01 00:57:16.000000', 'temperatura', 1057.0000, 'ºC'),
	(140438, 112, '2015-04-01 00:57:17.000000', 'temperatura', 390.0000, 'ºC'),
	(140439, 112, '2015-04-01 00:57:18.000000', 'temperatura', 1177.0000, 'ºC'),
	(140440, 112, '2015-04-01 00:57:19.000000', 'temperatura', 1116.0000, 'ºC'),
	(140441, 112, '2015-04-01 00:57:20.000000', 'temperatura', 849.0000, 'ºC'),
	(140442, 112, '2015-04-01 00:57:21.000000', 'temperatura', 900.0000, 'ºC'),
	(140443, 112, '2015-04-01 00:57:22.000000', 'temperatura', 752.0000, 'ºC'),
	(140444, 112, '2015-04-01 00:57:23.000000', 'temperatura', 1059.0000, 'ºC'),
	(140445, 112, '2015-04-01 00:57:24.000000', 'temperatura', 642.0000, 'ºC'),
	(140446, 112, '2015-04-01 00:57:25.000000', 'temperatura', 31.0000, 'ºC'),
	(140447, 112, '2015-04-01 00:57:26.000000', 'temperatura', 629.0000, 'ºC'),
	(140448, 112, '2015-04-01 00:57:27.000000', 'temperatura', 656.0000, 'ºC'),
	(140449, 112, '2015-04-01 00:57:28.000000', 'temperatura', 190.0000, 'ºC'),
	(140450, 112, '2015-04-01 00:57:29.000000', 'temperatura', 184.0000, 'ºC'),
	(140451, 112, '2015-04-01 00:57:30.000000', 'temperatura', 349.0000, 'ºC'),
	(140452, 112, '2015-04-01 00:57:31.000000', 'temperatura', 1194.0000, 'ºC'),
	(140453, 112, '2015-04-01 00:57:32.000000', 'temperatura', 126.0000, 'ºC'),
	(140454, 112, '2015-04-01 00:57:33.000000', 'temperatura', 646.0000, 'ºC'),
	(140455, 112, '2015-04-01 00:57:34.000000', 'temperatura', 453.0000, 'ºC'),
	(140456, 112, '2015-04-01 00:57:35.000000', 'temperatura', 326.0000, 'ºC'),
	(140457, 112, '2015-04-01 00:57:36.000000', 'temperatura', 271.0000, 'ºC'),
	(140458, 112, '2015-04-01 00:57:37.000000', 'temperatura', 380.0000, 'ºC'),
	(140459, 112, '2015-04-01 00:57:38.000000', 'temperatura', 1087.0000, 'ºC'),
	(140460, 112, '2015-04-01 00:57:39.000000', 'temperatura', 696.0000, 'ºC'),
	(140461, 112, '2015-04-01 00:57:40.000000', 'temperatura', 219.0000, 'ºC'),
	(140462, 112, '2015-04-01 00:57:41.000000', 'temperatura', 207.0000, 'ºC'),
	(140463, 112, '2015-04-01 00:57:42.000000', 'temperatura', 379.0000, 'ºC'),
	(140464, 112, '2015-04-01 00:57:43.000000', 'temperatura', 74.0000, 'ºC'),
	(140465, 112, '2015-04-01 00:57:44.000000', 'temperatura', 433.0000, 'ºC'),
	(140466, 112, '2015-04-01 00:57:45.000000', 'temperatura', 743.0000, 'ºC'),
	(140467, 112, '2015-04-01 00:57:46.000000', 'temperatura', 18.0000, 'ºC'),
	(140468, 112, '2015-04-01 00:57:47.000000', 'temperatura', 260.0000, 'ºC'),
	(140469, 112, '2015-04-01 00:57:48.000000', 'temperatura', 46.0000, 'ºC'),
	(140470, 112, '2015-04-01 00:57:49.000000', 'temperatura', 653.0000, 'ºC'),
	(140471, 112, '2015-04-01 00:57:50.000000', 'temperatura', 724.0000, 'ºC'),
	(140472, 112, '2015-04-01 00:57:51.000000', 'temperatura', 465.0000, 'ºC'),
	(140473, 112, '2015-04-01 00:57:52.000000', 'temperatura', 151.0000, 'ºC'),
	(140474, 112, '2015-04-01 00:57:53.000000', 'temperatura', 562.0000, 'ºC'),
	(140475, 112, '2015-04-01 00:57:54.000000', 'temperatura', 1156.0000, 'ºC'),
	(140476, 112, '2015-04-01 00:57:55.000000', 'temperatura', 495.0000, 'ºC'),
	(140477, 112, '2015-04-01 00:57:56.000000', 'temperatura', 208.0000, 'ºC'),
	(140478, 112, '2015-04-01 00:57:57.000000', 'temperatura', 757.0000, 'ºC'),
	(140479, 112, '2015-04-01 00:57:58.000000', 'temperatura', 759.0000, 'ºC'),
	(140480, 112, '2015-04-01 00:57:59.000000', 'temperatura', 327.0000, 'ºC'),
	(140481, 112, '2015-04-01 00:58:00.000000', 'temperatura', 558.0000, 'ºC'),
	(140482, 112, '2015-04-01 00:58:01.000000', 'temperatura', 608.0000, 'ºC'),
	(140483, 112, '2015-04-01 00:58:02.000000', 'temperatura', 167.0000, 'ºC'),
	(140484, 112, '2015-04-01 00:58:03.000000', 'temperatura', 212.0000, 'ºC'),
	(140485, 112, '2015-04-01 00:58:04.000000', 'temperatura', 561.0000, 'ºC'),
	(140486, 112, '2015-04-01 00:58:05.000000', 'temperatura', 969.0000, 'ºC'),
	(140487, 112, '2015-04-01 00:58:06.000000', 'temperatura', 762.0000, 'ºC'),
	(140488, 112, '2015-04-01 00:58:07.000000', 'temperatura', 903.0000, 'ºC'),
	(140489, 112, '2015-04-01 00:58:08.000000', 'temperatura', 1029.0000, 'ºC'),
	(140490, 112, '2015-04-01 00:58:09.000000', 'temperatura', 39.0000, 'ºC'),
	(140491, 112, '2015-04-01 00:58:10.000000', 'temperatura', 708.0000, 'ºC'),
	(140492, 112, '2015-04-01 00:58:11.000000', 'temperatura', 1021.0000, 'ºC'),
	(140493, 112, '2015-04-01 00:58:12.000000', 'temperatura', 585.0000, 'ºC'),
	(140494, 112, '2015-04-01 00:58:13.000000', 'temperatura', 1059.0000, 'ºC'),
	(140495, 112, '2015-04-01 00:58:14.000000', 'temperatura', 1143.0000, 'ºC'),
	(140496, 112, '2015-04-01 00:58:15.000000', 'temperatura', 137.0000, 'ºC'),
	(140497, 112, '2015-04-01 00:58:16.000000', 'temperatura', 856.0000, 'ºC'),
	(140498, 112, '2015-04-01 00:58:17.000000', 'temperatura', 270.0000, 'ºC'),
	(140499, 112, '2015-04-01 00:58:18.000000', 'temperatura', 1182.0000, 'ºC'),
	(140500, 112, '2015-04-01 00:58:19.000000', 'temperatura', 302.0000, 'ºC'),
	(140501, 112, '2015-04-01 00:58:20.000000', 'temperatura', 362.0000, 'ºC'),
	(140502, 112, '2015-04-01 00:58:21.000000', 'temperatura', 907.0000, 'ºC'),
	(140503, 112, '2015-04-01 00:58:22.000000', 'temperatura', 1049.0000, 'ºC'),
	(140504, 112, '2015-04-01 00:58:23.000000', 'temperatura', 124.0000, 'ºC'),
	(140505, 112, '2015-04-01 00:58:24.000000', 'temperatura', 1073.0000, 'ºC'),
	(140506, 112, '2015-04-01 00:58:25.000000', 'temperatura', 194.0000, 'ºC'),
	(140507, 112, '2015-04-01 00:58:26.000000', 'temperatura', 152.0000, 'ºC'),
	(140508, 112, '2015-04-01 00:58:27.000000', 'temperatura', 178.0000, 'ºC'),
	(140509, 112, '2015-04-01 00:58:28.000000', 'temperatura', 434.0000, 'ºC'),
	(140510, 112, '2015-04-01 00:58:29.000000', 'temperatura', 436.0000, 'ºC'),
	(140511, 112, '2015-04-01 00:58:30.000000', 'temperatura', 878.0000, 'ºC'),
	(140512, 112, '2015-04-01 00:58:31.000000', 'temperatura', 684.0000, 'ºC'),
	(140513, 112, '2015-04-01 00:58:32.000000', 'temperatura', 786.0000, 'ºC'),
	(140514, 112, '2015-04-01 00:58:33.000000', 'temperatura', 677.0000, 'ºC'),
	(140515, 112, '2015-04-01 00:58:34.000000', 'temperatura', 1029.0000, 'ºC'),
	(140516, 112, '2015-04-01 00:58:35.000000', 'temperatura', 716.0000, 'ºC'),
	(140517, 112, '2015-04-01 00:58:36.000000', 'temperatura', 492.0000, 'ºC'),
	(140518, 112, '2015-04-01 00:58:37.000000', 'temperatura', 312.0000, 'ºC'),
	(140519, 112, '2015-04-01 00:58:38.000000', 'temperatura', 87.0000, 'ºC'),
	(140520, 112, '2015-04-01 00:58:39.000000', 'temperatura', 697.0000, 'ºC'),
	(140521, 112, '2015-04-01 00:58:40.000000', 'temperatura', 824.0000, 'ºC'),
	(140522, 112, '2015-04-01 00:58:41.000000', 'temperatura', 829.0000, 'ºC'),
	(140523, 112, '2015-04-01 00:58:42.000000', 'temperatura', 474.0000, 'ºC'),
	(140524, 112, '2015-04-01 00:58:43.000000', 'temperatura', 1085.0000, 'ºC'),
	(140525, 112, '2015-04-01 00:58:44.000000', 'temperatura', 404.0000, 'ºC'),
	(140526, 112, '2015-04-01 00:58:45.000000', 'temperatura', 1164.0000, 'ºC'),
	(140527, 112, '2015-04-01 00:58:46.000000', 'temperatura', 1011.0000, 'ºC'),
	(140528, 112, '2015-04-01 00:58:47.000000', 'temperatura', 362.0000, 'ºC'),
	(140529, 112, '2015-04-01 00:58:48.000000', 'temperatura', 1176.0000, 'ºC'),
	(140530, 112, '2015-04-01 00:58:49.000000', 'temperatura', 1197.0000, 'ºC'),
	(140531, 112, '2015-04-01 00:58:50.000000', 'temperatura', 57.0000, 'ºC'),
	(140532, 112, '2015-04-01 00:58:51.000000', 'temperatura', 294.0000, 'ºC'),
	(140533, 112, '2015-04-01 00:58:52.000000', 'temperatura', 98.0000, 'ºC'),
	(140534, 112, '2015-04-01 00:58:53.000000', 'temperatura', 810.0000, 'ºC'),
	(140535, 112, '2015-04-01 00:58:54.000000', 'temperatura', 155.0000, 'ºC'),
	(140536, 112, '2015-04-01 00:58:55.000000', 'temperatura', 746.0000, 'ºC'),
	(140537, 112, '2015-04-01 00:58:56.000000', 'temperatura', 865.0000, 'ºC'),
	(140538, 112, '2015-04-01 00:58:57.000000', 'temperatura', 889.0000, 'ºC'),
	(140539, 112, '2015-04-01 00:58:58.000000', 'temperatura', 651.0000, 'ºC'),
	(140540, 112, '2015-04-01 00:58:59.000000', 'temperatura', 589.0000, 'ºC'),
	(140541, 112, '2015-04-01 00:59:00.000000', 'temperatura', 993.0000, 'ºC'),
	(140542, 112, '2015-04-01 00:59:01.000000', 'temperatura', 795.0000, 'ºC'),
	(140543, 112, '2015-04-01 00:59:02.000000', 'temperatura', 1000.0000, 'ºC'),
	(140544, 112, '2015-04-01 00:59:03.000000', 'temperatura', 213.0000, 'ºC'),
	(140545, 112, '2015-04-01 00:59:04.000000', 'temperatura', 468.0000, 'ºC'),
	(140546, 112, '2015-04-01 00:59:05.000000', 'temperatura', 502.0000, 'ºC'),
	(140547, 112, '2015-04-01 00:59:06.000000', 'temperatura', 1104.0000, 'ºC'),
	(140548, 112, '2015-04-01 00:59:07.000000', 'temperatura', 418.0000, 'ºC'),
	(140549, 112, '2015-04-01 00:59:08.000000', 'temperatura', 1175.0000, 'ºC'),
	(140550, 112, '2015-04-01 00:59:09.000000', 'temperatura', 1022.0000, 'ºC'),
	(140551, 112, '2015-04-01 00:59:10.000000', 'temperatura', 384.0000, 'ºC'),
	(140552, 112, '2015-04-01 00:59:11.000000', 'temperatura', 57.0000, 'ºC'),
	(140553, 112, '2015-04-01 00:59:12.000000', 'temperatura', 333.0000, 'ºC'),
	(140554, 112, '2015-04-01 00:59:13.000000', 'temperatura', 294.0000, 'ºC'),
	(140555, 112, '2015-04-01 00:59:14.000000', 'temperatura', 473.0000, 'ºC'),
	(140556, 112, '2015-04-01 00:59:15.000000', 'temperatura', 284.0000, 'ºC'),
	(140557, 112, '2015-04-01 00:59:16.000000', 'temperatura', 2.0000, 'ºC'),
	(140558, 112, '2015-04-01 00:59:17.000000', 'temperatura', 359.0000, 'ºC'),
	(140559, 112, '2015-04-01 00:59:18.000000', 'temperatura', 590.0000, 'ºC'),
	(140560, 112, '2015-04-01 00:59:19.000000', 'temperatura', 671.0000, 'ºC'),
	(140561, 112, '2015-04-01 00:59:20.000000', 'temperatura', 386.0000, 'ºC'),
	(140562, 112, '2015-04-01 00:59:21.000000', 'temperatura', 1118.0000, 'ºC'),
	(140563, 112, '2015-04-01 00:59:22.000000', 'temperatura', 830.0000, 'ºC'),
	(140564, 112, '2015-04-01 00:59:23.000000', 'temperatura', 800.0000, 'ºC'),
	(140565, 112, '2015-04-01 00:59:24.000000', 'temperatura', 309.0000, 'ºC'),
	(140566, 112, '2015-04-01 00:59:25.000000', 'temperatura', 347.0000, 'ºC'),
	(140567, 112, '2015-04-01 00:59:26.000000', 'temperatura', 808.0000, 'ºC'),
	(140568, 112, '2015-04-01 00:59:27.000000', 'temperatura', 601.0000, 'ºC'),
	(140569, 112, '2015-04-01 00:59:28.000000', 'temperatura', 578.0000, 'ºC'),
	(140570, 112, '2015-04-01 00:59:29.000000', 'temperatura', 1090.0000, 'ºC'),
	(140571, 112, '2015-04-01 00:59:30.000000', 'temperatura', 115.0000, 'ºC'),
	(140572, 112, '2015-04-01 00:59:31.000000', 'temperatura', 907.0000, 'ºC'),
	(140573, 112, '2015-04-01 00:59:32.000000', 'temperatura', 590.0000, 'ºC'),
	(140574, 112, '2015-04-01 00:59:33.000000', 'temperatura', 227.0000, 'ºC'),
	(140575, 112, '2015-04-01 00:59:34.000000', 'temperatura', 569.0000, 'ºC'),
	(140576, 112, '2015-04-01 00:59:35.000000', 'temperatura', 963.0000, 'ºC'),
	(140577, 112, '2015-04-01 00:59:36.000000', 'temperatura', 707.0000, 'ºC'),
	(140578, 112, '2015-04-01 00:59:37.000000', 'temperatura', 646.0000, 'ºC'),
	(140579, 112, '2015-04-01 00:59:38.000000', 'temperatura', 1111.0000, 'ºC'),
	(140580, 112, '2015-04-01 00:59:39.000000', 'temperatura', 17.0000, 'ºC'),
	(140581, 112, '2015-04-01 00:59:40.000000', 'temperatura', 354.0000, 'ºC'),
	(140582, 112, '2015-04-01 00:59:41.000000', 'temperatura', 519.0000, 'ºC'),
	(140583, 112, '2015-04-01 00:59:42.000000', 'temperatura', 334.0000, 'ºC'),
	(140584, 112, '2015-04-01 00:59:43.000000', 'temperatura', 115.0000, 'ºC'),
	(140585, 112, '2015-04-01 00:59:44.000000', 'temperatura', 772.0000, 'ºC'),
	(140586, 112, '2015-04-01 00:59:45.000000', 'temperatura', 1114.0000, 'ºC'),
	(140587, 112, '2015-04-01 00:59:46.000000', 'temperatura', 855.0000, 'ºC'),
	(140588, 112, '2015-04-01 00:59:47.000000', 'temperatura', 932.0000, 'ºC'),
	(140589, 112, '2015-04-01 00:59:48.000000', 'temperatura', 898.0000, 'ºC'),
	(140590, 112, '2015-04-01 00:59:49.000000', 'temperatura', 494.0000, 'ºC'),
	(140591, 112, '2015-04-01 00:59:50.000000', 'temperatura', 975.0000, 'ºC'),
	(140592, 112, '2015-04-01 00:59:51.000000', 'temperatura', 994.0000, 'ºC'),
	(140593, 112, '2015-04-01 00:59:52.000000', 'temperatura', 844.0000, 'ºC'),
	(140594, 112, '2015-04-01 00:59:53.000000', 'temperatura', 41.0000, 'ºC'),
	(140595, 112, '2015-04-01 00:59:54.000000', 'temperatura', 73.0000, 'ºC'),
	(140596, 112, '2015-04-01 00:59:55.000000', 'temperatura', 243.0000, 'ºC'),
	(140597, 112, '2015-04-01 00:59:56.000000', 'temperatura', 994.0000, 'ºC'),
	(140598, 112, '2015-04-01 00:59:57.000000', 'temperatura', 645.0000, 'ºC'),
	(140599, 112, '2015-04-01 00:59:58.000000', 'temperatura', 241.0000, 'ºC'),
	(140600, 112, '2015-04-01 00:59:59.000000', 'temperatura', 469.0000, 'ºC'),
	(140601, 112, '2015-04-01 01:00:00.000000', 'temperatura', 425.0000, 'ºC'),
	(140602, 112, '2015-04-01 01:00:01.000000', 'temperatura', 716.0000, 'ºC'),
	(140603, 112, '2015-04-01 01:00:02.000000', 'temperatura', 1107.0000, 'ºC'),
	(140604, 112, '2015-04-01 01:00:03.000000', 'temperatura', 989.0000, 'ºC'),
	(140605, 112, '2015-04-01 01:00:04.000000', 'temperatura', 424.0000, 'ºC'),
	(140606, 112, '2015-04-01 01:00:05.000000', 'temperatura', 355.0000, 'ºC'),
	(140607, 112, '2015-04-01 01:00:06.000000', 'temperatura', 503.0000, 'ºC'),
	(140608, 112, '2015-04-01 01:00:07.000000', 'temperatura', 248.0000, 'ºC'),
	(140609, 112, '2015-04-01 01:00:08.000000', 'temperatura', 933.0000, 'ºC'),
	(140610, 112, '2015-04-01 01:00:09.000000', 'temperatura', 321.0000, 'ºC'),
	(140611, 112, '2015-04-01 01:00:10.000000', 'temperatura', 5.0000, 'ºC'),
	(140612, 112, '2015-04-01 01:00:11.000000', 'temperatura', 263.0000, 'ºC'),
	(140613, 112, '2015-04-01 01:00:12.000000', 'temperatura', 100.0000, 'ºC'),
	(140614, 112, '2015-04-01 01:00:13.000000', 'temperatura', 912.0000, 'ºC'),
	(140615, 112, '2015-04-01 01:00:14.000000', 'temperatura', 662.0000, 'ºC'),
	(140616, 112, '2015-04-01 01:00:15.000000', 'temperatura', 575.0000, 'ºC'),
	(140617, 112, '2015-04-01 01:00:16.000000', 'temperatura', 890.0000, 'ºC'),
	(140618, 112, '2015-04-01 01:00:17.000000', 'temperatura', 326.0000, 'ºC'),
	(140619, 112, '2015-04-01 01:00:18.000000', 'temperatura', 158.0000, 'ºC'),
	(140620, 112, '2015-04-01 01:00:19.000000', 'temperatura', 1012.0000, 'ºC'),
	(140621, 112, '2015-04-01 01:00:20.000000', 'temperatura', 989.0000, 'ºC'),
	(140622, 112, '2015-04-01 01:00:21.000000', 'temperatura', 707.0000, 'ºC'),
	(140623, 112, '2015-04-01 01:00:22.000000', 'temperatura', 568.0000, 'ºC'),
	(140624, 112, '2015-04-01 01:00:23.000000', 'temperatura', 718.0000, 'ºC'),
	(140625, 112, '2015-04-01 01:00:24.000000', 'temperatura', 690.0000, 'ºC'),
	(140626, 112, '2015-04-01 01:00:25.000000', 'temperatura', 97.0000, 'ºC'),
	(140627, 112, '2015-04-01 01:00:26.000000', 'temperatura', 813.0000, 'ºC'),
	(140628, 112, '2015-04-01 01:00:27.000000', 'temperatura', 178.0000, 'ºC'),
	(140629, 112, '2015-04-01 01:00:28.000000', 'temperatura', 848.0000, 'ºC'),
	(140630, 112, '2015-04-01 01:00:29.000000', 'temperatura', 106.0000, 'ºC'),
	(140631, 112, '2015-04-01 01:00:30.000000', 'temperatura', 389.0000, 'ºC'),
	(140632, 112, '2015-04-01 01:00:31.000000', 'temperatura', 427.0000, 'ºC'),
	(140633, 112, '2015-04-01 01:00:32.000000', 'temperatura', 967.0000, 'ºC'),
	(140634, 112, '2015-04-01 01:00:33.000000', 'temperatura', 1156.0000, 'ºC'),
	(140635, 112, '2015-04-01 01:00:34.000000', 'temperatura', 480.0000, 'ºC'),
	(140636, 112, '2015-04-01 01:00:35.000000', 'temperatura', 132.0000, 'ºC'),
	(140637, 112, '2015-04-01 01:00:36.000000', 'temperatura', 420.0000, 'ºC'),
	(140638, 112, '2015-04-01 01:00:37.000000', 'temperatura', 505.0000, 'ºC'),
	(140639, 112, '2015-04-01 01:00:38.000000', 'temperatura', 66.0000, 'ºC'),
	(140640, 112, '2015-04-01 01:00:39.000000', 'temperatura', 16.0000, 'ºC'),
	(140641, 112, '2015-04-01 01:00:40.000000', 'temperatura', 1081.0000, 'ºC'),
	(140642, 112, '2015-04-01 01:00:41.000000', 'temperatura', 560.0000, 'ºC'),
	(140643, 112, '2015-04-01 01:00:42.000000', 'temperatura', 756.0000, 'ºC'),
	(140644, 112, '2015-04-01 01:00:43.000000', 'temperatura', 901.0000, 'ºC'),
	(140645, 112, '2015-04-01 01:00:44.000000', 'temperatura', 1037.0000, 'ºC'),
	(140646, 112, '2015-04-01 01:00:45.000000', 'temperatura', 83.0000, 'ºC'),
	(140647, 112, '2015-04-01 01:00:46.000000', 'temperatura', 906.0000, 'ºC'),
	(140648, 112, '2015-04-01 01:00:47.000000', 'temperatura', 680.0000, 'ºC'),
	(140649, 112, '2015-04-01 01:00:48.000000', 'temperatura', 683.0000, 'ºC'),
	(140650, 112, '2015-04-01 01:00:49.000000', 'temperatura', 173.0000, 'ºC'),
	(140651, 112, '2015-04-01 01:00:50.000000', 'temperatura', 20.0000, 'ºC'),
	(140652, 112, '2015-04-01 01:00:51.000000', 'temperatura', 779.0000, 'ºC'),
	(140653, 112, '2015-04-01 01:00:52.000000', 'temperatura', 235.0000, 'ºC'),
	(140654, 112, '2015-04-01 01:00:53.000000', 'temperatura', 39.0000, 'ºC'),
	(140655, 112, '2015-04-01 01:00:54.000000', 'temperatura', 691.0000, 'ºC'),
	(140656, 112, '2015-04-01 01:00:55.000000', 'temperatura', 939.0000, 'ºC'),
	(140657, 112, '2015-04-01 01:00:56.000000', 'temperatura', 223.0000, 'ºC'),
	(140658, 112, '2015-04-01 01:00:57.000000', 'temperatura', 696.0000, 'ºC'),
	(140659, 112, '2015-04-01 01:00:58.000000', 'temperatura', 415.0000, 'ºC'),
	(140660, 112, '2015-04-01 01:00:59.000000', 'temperatura', 1185.0000, 'ºC'),
	(140661, 112, '2015-04-01 01:01:00.000000', 'temperatura', 1079.0000, 'ºC'),
	(140662, 112, '2015-04-01 01:01:01.000000', 'temperatura', 642.0000, 'ºC'),
	(140663, 112, '2015-04-01 01:01:02.000000', 'temperatura', 1174.0000, 'ºC'),
	(140664, 112, '2015-04-01 01:01:03.000000', 'temperatura', 346.0000, 'ºC'),
	(140665, 112, '2015-04-01 01:01:04.000000', 'temperatura', 605.0000, 'ºC'),
	(140666, 112, '2015-04-01 01:01:05.000000', 'temperatura', 790.0000, 'ºC'),
	(140667, 112, '2015-04-01 01:01:06.000000', 'temperatura', 937.0000, 'ºC'),
	(140668, 112, '2015-04-01 01:01:07.000000', 'temperatura', 1114.0000, 'ºC'),
	(140669, 112, '2015-04-01 01:01:08.000000', 'temperatura', 359.0000, 'ºC'),
	(140670, 112, '2015-04-01 01:01:09.000000', 'temperatura', 854.0000, 'ºC'),
	(140671, 112, '2015-04-01 01:01:10.000000', 'temperatura', 795.0000, 'ºC'),
	(140672, 112, '2015-04-01 01:01:11.000000', 'temperatura', 213.0000, 'ºC'),
	(140673, 112, '2015-04-01 01:01:12.000000', 'temperatura', 1080.0000, 'ºC'),
	(140674, 112, '2015-04-01 01:01:13.000000', 'temperatura', 1160.0000, 'ºC'),
	(140675, 112, '2015-04-01 01:01:14.000000', 'temperatura', 161.0000, 'ºC'),
	(140676, 112, '2015-04-01 01:01:15.000000', 'temperatura', 926.0000, 'ºC'),
	(140677, 112, '2015-04-01 01:01:16.000000', 'temperatura', 547.0000, 'ºC'),
	(140678, 112, '2015-04-01 01:01:17.000000', 'temperatura', 1158.0000, 'ºC'),
	(140679, 112, '2015-04-01 01:01:18.000000', 'temperatura', 551.0000, 'ºC'),
	(140680, 112, '2015-04-01 01:01:19.000000', 'temperatura', 480.0000, 'ºC'),
	(140681, 112, '2015-04-01 01:01:20.000000', 'temperatura', 747.0000, 'ºC'),
	(140682, 112, '2015-04-01 01:01:21.000000', 'temperatura', 1097.0000, 'ºC'),
	(140683, 112, '2015-04-01 01:01:22.000000', 'temperatura', 843.0000, 'ºC'),
	(140684, 112, '2015-04-01 01:01:23.000000', 'temperatura', 924.0000, 'ºC'),
	(140685, 112, '2015-04-01 01:01:24.000000', 'temperatura', 893.0000, 'ºC'),
	(140686, 112, '2015-04-01 01:01:25.000000', 'temperatura', 494.0000, 'ºC'),
	(140687, 112, '2015-04-01 01:01:26.000000', 'temperatura', 992.0000, 'ºC'),
	(140688, 112, '2015-04-01 01:01:27.000000', 'temperatura', 1076.0000, 'ºC'),
	(140689, 112, '2015-04-01 01:01:28.000000', 'temperatura', 6.0000, 'ºC'),
	(140690, 112, '2015-04-01 01:01:29.000000', 'temperatura', 404.0000, 'ºC'),
	(140691, 112, '2015-04-01 01:01:30.000000', 'temperatura', 799.0000, 'ºC'),
	(140692, 112, '2015-04-01 01:01:31.000000', 'temperatura', 387.0000, 'ºC'),
	(140693, 112, '2015-04-01 01:01:32.000000', 'temperatura', 736.0000, 'ºC'),
	(140694, 112, '2015-04-01 01:01:33.000000', 'temperatura', 120.0000, 'ºC'),
	(140695, 112, '2015-04-01 01:01:34.000000', 'temperatura', 791.0000, 'ºC'),
	(140696, 112, '2015-04-01 01:01:35.000000', 'temperatura', 1196.0000, 'ºC'),
	(140697, 112, '2015-04-01 01:01:36.000000', 'temperatura', 9.0000, 'ºC'),
	(140698, 112, '2015-04-01 01:01:37.000000', 'temperatura', 55.0000, 'ºC'),
	(140699, 112, '2015-04-01 01:01:38.000000', 'temperatura', 251.0000, 'ºC'),
	(140700, 112, '2015-04-01 01:01:39.000000', 'temperatura', 1090.0000, 'ºC'),
	(140701, 112, '2015-04-01 01:01:40.000000', 'temperatura', 1096.0000, 'ºC'),
	(140702, 112, '2015-04-01 01:01:41.000000', 'temperatura', 1009.0000, 'ºC'),
	(140703, 112, '2015-04-01 01:01:42.000000', 'temperatura', 561.0000, 'ºC'),
	(140704, 112, '2015-04-01 01:01:43.000000', 'temperatura', 978.0000, 'ºC'),
	(140705, 112, '2015-04-01 01:01:44.000000', 'temperatura', 805.0000, 'ºC'),
	(140706, 112, '2015-04-01 01:01:45.000000', 'temperatura', 1094.0000, 'ºC'),
	(140707, 112, '2015-04-01 01:01:46.000000', 'temperatura', 656.0000, 'ºC'),
	(140708, 112, '2015-04-01 01:01:47.000000', 'temperatura', 1199.0000, 'ºC'),
	(140709, 112, '2015-04-01 01:01:48.000000', 'temperatura', 426.0000, 'ºC'),
	(140710, 112, '2015-04-01 01:01:49.000000', 'temperatura', 935.0000, 'ºC'),
	(140711, 112, '2015-04-01 01:01:50.000000', 'temperatura', 996.0000, 'ºC'),
	(140712, 112, '2015-04-01 01:01:51.000000', 'temperatura', 978.0000, 'ºC'),
	(140713, 112, '2015-04-01 01:01:52.000000', 'temperatura', 700.0000, 'ºC'),
	(140714, 112, '2015-04-01 01:01:53.000000', 'temperatura', 569.0000, 'ºC'),
	(140715, 112, '2015-04-01 01:01:54.000000', 'temperatura', 746.0000, 'ºC'),
	(140716, 112, '2015-04-01 01:01:55.000000', 'temperatura', 822.0000, 'ºC'),
	(140717, 112, '2015-04-01 01:01:56.000000', 'temperatura', 671.0000, 'ºC'),
	(140718, 112, '2015-04-01 01:01:57.000000', 'temperatura', 892.0000, 'ºC'),
	(140719, 112, '2015-04-01 01:01:58.000000', 'temperatura', 48.0000, 'ºC'),
	(140720, 112, '2015-04-01 01:01:59.000000', 'temperatura', 1163.0000, 'ºC'),
	(140721, 112, '2015-04-01 01:02:00.000000', 'temperatura', 870.0000, 'ºC'),
	(140722, 112, '2015-04-01 01:02:01.000000', 'temperatura', 864.0000, 'ºC'),
	(140723, 112, '2015-04-01 01:02:02.000000', 'temperatura', 509.0000, 'ºC'),
	(140724, 112, '2015-04-01 01:02:03.000000', 'temperatura', 1153.0000, 'ºC'),
	(140725, 112, '2015-04-01 01:02:04.000000', 'temperatura', 638.0000, 'ºC'),
	(140726, 112, '2015-04-01 01:02:05.000000', 'temperatura', 931.0000, 'ºC'),
	(140727, 112, '2015-04-01 01:02:06.000000', 'temperatura', 343.0000, 'ºC'),
	(140728, 112, '2015-04-01 01:02:07.000000', 'temperatura', 121.0000, 'ºC'),
	(140729, 112, '2015-04-01 01:02:08.000000', 'temperatura', 778.0000, 'ºC'),
	(140730, 112, '2015-04-01 01:02:09.000000', 'temperatura', 1128.0000, 'ºC'),
	(140731, 112, '2015-04-01 01:02:10.000000', 'temperatura', 908.0000, 'ºC'),
	(140732, 112, '2015-04-01 01:02:11.000000', 'temperatura', 1153.0000, 'ºC'),
	(140733, 112, '2015-04-01 01:02:12.000000', 'temperatura', 643.0000, 'ºC'),
	(140734, 112, '2015-04-01 01:02:13.000000', 'temperatura', 956.0000, 'ºC'),
	(140735, 112, '2015-04-01 01:02:14.000000', 'temperatura', 450.0000, 'ºC'),
	(140736, 112, '2015-04-01 01:02:15.000000', 'temperatura', 583.0000, 'ºC'),
	(140737, 112, '2015-04-01 01:02:16.000000', 'temperatura', 365.0000, 'ºC'),
	(140738, 112, '2015-04-01 01:02:17.000000', 'temperatura', 79.0000, 'ºC'),
	(140739, 112, '2015-04-01 01:02:18.000000', 'temperatura', 499.0000, 'ºC'),
	(140740, 112, '2015-04-01 01:02:19.000000', 'temperatura', 1060.0000, 'ºC'),
	(140741, 112, '2015-04-01 01:02:20.000000', 'temperatura', 201.0000, 'ºC'),
	(140742, 112, '2015-04-01 01:02:21.000000', 'temperatura', 227.0000, 'ºC'),
	(140743, 112, '2015-04-01 01:02:22.000000', 'temperatura', 534.0000, 'ºC'),
	(140744, 112, '2015-04-01 01:02:23.000000', 'temperatura', 788.0000, 'ºC'),
	(140745, 112, '2015-04-01 01:02:24.000000', 'temperatura', 1140.0000, 'ºC'),
	(140746, 112, '2015-04-01 01:02:25.000000', 'temperatura', 938.0000, 'ºC'),
	(140747, 112, '2015-04-01 01:02:26.000000', 'temperatura', 67.0000, 'ºC'),
	(140748, 112, '2015-04-01 01:02:27.000000', 'temperatura', 1122.0000, 'ºC'),
	(140749, 112, '2015-04-01 01:02:28.000000', 'temperatura', 612.0000, 'ºC'),
	(140750, 112, '2015-04-01 01:02:29.000000', 'temperatura', 891.0000, 'ºC'),
	(140751, 112, '2015-04-01 01:02:30.000000', 'temperatura', 223.0000, 'ºC'),
	(140752, 112, '2015-04-01 01:02:31.000000', 'temperatura', 840.0000, 'ºC'),
	(140753, 112, '2015-04-01 01:02:32.000000', 'temperatura', 1133.0000, 'ºC'),
	(140754, 112, '2015-04-01 01:02:33.000000', 'temperatura', 747.0000, 'ºC'),
	(140755, 112, '2015-04-01 01:02:34.000000', 'temperatura', 335.0000, 'ºC'),
	(140756, 112, '2015-04-01 01:02:35.000000', 'temperatura', 635.0000, 'ºC'),
	(140757, 112, '2015-04-01 01:02:36.000000', 'temperatura', 971.0000, 'ºC'),
	(140758, 112, '2015-04-01 01:02:37.000000', 'temperatura', 551.0000, 'ºC'),
	(140759, 112, '2015-04-01 01:02:38.000000', 'temperatura', 1040.0000, 'ºC'),
	(140760, 112, '2015-04-01 01:02:39.000000', 'temperatura', 1148.0000, 'ºC'),
	(140761, 112, '2015-04-01 01:02:40.000000', 'temperatura', 221.0000, 'ºC'),
	(140762, 112, '2015-04-01 01:02:41.000000', 'temperatura', 60.0000, 'ºC'),
	(140763, 112, '2015-04-01 01:02:42.000000', 'temperatura', 840.0000, 'ºC'),
	(140764, 112, '2015-04-01 01:02:43.000000', 'temperatura', 421.0000, 'ºC'),
	(140765, 112, '2015-04-01 01:02:44.000000', 'temperatura', 785.0000, 'ºC'),
	(140766, 112, '2015-04-01 01:02:45.000000', 'temperatura', 261.0000, 'ºC'),
	(140767, 112, '2015-04-01 01:02:46.000000', 'temperatura', 151.0000, 'ºC'),
	(140768, 112, '2015-04-01 01:02:47.000000', 'temperatura', 1173.0000, 'ºC'),
	(140769, 112, '2015-04-01 01:02:48.000000', 'temperatura', 614.0000, 'ºC'),
	(140770, 112, '2015-04-01 01:02:49.000000', 'temperatura', 749.0000, 'ºC'),
	(140771, 112, '2015-04-01 01:02:50.000000', 'temperatura', 706.0000, 'ºC'),
	(140772, 112, '2015-04-01 01:02:51.000000', 'temperatura', 82.0000, 'ºC'),
	(140773, 112, '2015-04-01 01:02:52.000000', 'temperatura', 693.0000, 'ºC'),
	(140774, 112, '2015-04-01 01:02:53.000000', 'temperatura', 819.0000, 'ºC'),
	(140775, 112, '2015-04-01 01:02:54.000000', 'temperatura', 815.0000, 'ºC'),
	(140776, 112, '2015-04-01 01:02:55.000000', 'temperatura', 420.0000, 'ºC'),
	(140777, 112, '2015-04-01 01:02:56.000000', 'temperatura', 857.0000, 'ºC'),
	(140778, 112, '2015-04-01 01:02:57.000000', 'temperatura', 623.0000, 'ºC'),
	(140779, 112, '2015-04-01 01:02:58.000000', 'temperatura', 545.0000, 'ºC'),
	(140780, 112, '2015-04-01 01:02:59.000000', 'temperatura', 856.0000, 'ºC'),
	(140781, 112, '2015-04-01 01:03:00.000000', 'temperatura', 248.0000, 'ºC'),
	(140782, 112, '2015-04-01 01:03:01.000000', 'temperatura', 1072.0000, 'ºC'),
	(140783, 112, '2015-04-01 01:03:02.000000', 'temperatura', 1014.0000, 'ºC'),
	(140784, 112, '2015-04-01 01:03:03.000000', 'temperatura', 656.0000, 'ºC'),
	(140785, 112, '2015-04-01 01:03:04.000000', 'temperatura', 240.0000, 'ºC'),
	(140786, 112, '2015-04-01 01:03:05.000000', 'temperatura', 432.0000, 'ºC'),
	(140787, 112, '2015-04-01 01:03:06.000000', 'temperatura', 242.0000, 'ºC'),
	(140788, 112, '2015-04-01 01:03:07.000000', 'temperatura', 1113.0000, 'ºC'),
	(140789, 112, '2015-04-01 01:03:08.000000', 'temperatura', 40.0000, 'ºC'),
	(140790, 112, '2015-04-01 01:03:09.000000', 'temperatura', 459.0000, 'ºC'),
	(140791, 112, '2015-04-01 01:03:10.000000', 'temperatura', 978.0000, 'ºC'),
	(140792, 112, '2015-04-01 01:03:11.000000', 'temperatura', 1113.0000, 'ºC'),
	(140793, 112, '2015-04-01 01:03:12.000000', 'temperatura', 231.0000, 'ºC'),
	(140794, 112, '2015-04-01 01:03:13.000000', 'temperatura', 219.0000, 'ºC'),
	(140795, 112, '2015-04-01 01:03:14.000000', 'temperatura', 399.0000, 'ºC'),
	(140796, 112, '2015-04-01 01:03:15.000000', 'temperatura', 142.0000, 'ºC'),
	(140797, 112, '2015-04-01 01:03:16.000000', 'temperatura', 710.0000, 'ºC'),
	(140798, 112, '2015-04-01 01:03:17.000000', 'temperatura', 726.0000, 'ºC'),
	(140799, 112, '2015-04-01 01:03:18.000000', 'temperatura', 301.0000, 'ºC'),
	(140800, 112, '2015-04-01 01:03:19.000000', 'temperatura', 526.0000, 'ºC'),
	(140801, 112, '2015-04-01 01:03:20.000000', 'temperatura', 527.0000, 'ºC'),
	(140802, 112, '2015-04-01 01:03:21.000000', 'temperatura', 1058.0000, 'ºC'),
	(140803, 112, '2015-04-01 01:03:22.000000', 'temperatura', 108.0000, 'ºC'),
	(140804, 112, '2015-04-01 01:03:23.000000', 'temperatura', 967.0000, 'ºC'),
	(140805, 112, '2015-04-01 01:03:24.000000', 'temperatura', 914.0000, 'ºC'),
	(140806, 112, '2015-04-01 01:03:25.000000', 'temperatura', 466.0000, 'ºC'),
	(140807, 112, '2015-04-01 01:03:26.000000', 'temperatura', 790.0000, 'ºC'),
	(140808, 112, '2015-04-01 01:03:27.000000', 'temperatura', 153.0000, 'ºC'),
	(140809, 112, '2015-04-01 01:03:28.000000', 'temperatura', 796.0000, 'ºC'),
	(140810, 112, '2015-04-01 01:03:29.000000', 'temperatura', 1122.0000, 'ºC'),
	(140811, 112, '2015-04-01 01:03:30.000000', 'temperatura', 820.0000, 'ºC'),
	(140812, 112, '2015-04-01 01:03:31.000000', 'temperatura', 734.0000, 'ºC'),
	(140813, 112, '2015-04-01 01:03:32.000000', 'temperatura', 12.0000, 'ºC'),
	(140814, 112, '2015-04-01 01:03:33.000000', 'temperatura', 259.0000, 'ºC'),
	(140815, 112, '2015-04-01 01:03:34.000000', 'temperatura', 59.0000, 'ºC'),
	(140816, 112, '2015-04-01 01:03:35.000000', 'temperatura', 717.0000, 'ºC'),
	(140817, 112, '2015-04-01 01:03:36.000000', 'temperatura', 1012.0000, 'ºC'),
	(140818, 112, '2015-04-01 01:03:37.000000', 'temperatura', 506.0000, 'ºC'),
	(140819, 112, '2015-04-01 01:03:38.000000', 'temperatura', 697.0000, 'ºC'),
	(140820, 112, '2015-04-01 01:03:39.000000', 'temperatura', 768.0000, 'ºC'),
	(140821, 112, '2015-04-01 01:03:40.000000', 'temperatura', 548.0000, 'ºC'),
	(140822, 112, '2015-04-01 01:03:41.000000', 'temperatura', 437.0000, 'ºC'),
	(140823, 112, '2015-04-01 01:03:42.000000', 'temperatura', 540.0000, 'ºC'),
	(140824, 112, '2015-04-01 01:03:43.000000', 'temperatura', 190.0000, 'ºC'),
	(140825, 112, '2015-04-01 01:03:44.000000', 'temperatura', 530.0000, 'ºC'),
	(140826, 112, '2015-04-01 01:03:45.000000', 'temperatura', 881.0000, 'ºC'),
	(140827, 112, '2015-04-01 01:03:46.000000', 'temperatura', 415.0000, 'ºC'),
	(140828, 112, '2015-04-01 01:03:47.000000', 'temperatura', 631.0000, 'ºC'),
	(140829, 112, '2015-04-01 01:03:48.000000', 'temperatura', 711.0000, 'ºC'),
	(140830, 112, '2015-04-01 01:03:49.000000', 'temperatura', 465.0000, 'ºC'),
	(140831, 112, '2015-04-01 01:03:50.000000', 'temperatura', 190.0000, 'ºC'),
	(140832, 112, '2015-04-01 01:03:51.000000', 'temperatura', 756.0000, 'ºC'),
	(140833, 112, '2015-04-01 01:03:52.000000', 'temperatura', 811.0000, 'ºC'),
	(140834, 112, '2015-04-01 01:03:53.000000', 'temperatura', 587.0000, 'ºC'),
	(140835, 112, '2015-04-01 01:03:54.000000', 'temperatura', 501.0000, 'ºC'),
	(140836, 112, '2015-04-01 01:03:55.000000', 'temperatura', 747.0000, 'ºC'),
	(140837, 112, '2015-04-01 01:03:56.000000', 'temperatura', 1031.0000, 'ºC'),
	(140838, 112, '2015-04-01 01:03:57.000000', 'temperatura', 513.0000, 'ºC'),
	(140839, 112, '2015-04-01 01:03:58.000000', 'temperatura', 674.0000, 'ºC'),
	(140840, 112, '2015-04-01 01:03:59.000000', 'temperatura', 630.0000, 'ºC'),
	(140841, 112, '2015-04-01 01:04:00.000000', 'temperatura', 1130.0000, 'ºC'),
	(140842, 112, '2015-04-01 01:04:01.000000', 'temperatura', 161.0000, 'ºC'),
	(140843, 112, '2015-04-01 01:04:02.000000', 'temperatura', 1014.0000, 'ºC'),
	(140844, 112, '2015-04-01 01:04:03.000000', 'temperatura', 990.0000, 'ºC'),
	(140845, 112, '2015-04-01 01:04:04.000000', 'temperatura', 708.0000, 'ºC'),
	(140846, 112, '2015-04-01 01:04:05.000000', 'temperatura', 570.0000, 'ºC'),
	(140847, 112, '2015-04-01 01:04:06.000000', 'temperatura', 726.0000, 'ºC'),
	(140848, 112, '2015-04-01 01:04:07.000000', 'temperatura', 720.0000, 'ºC'),
	(140849, 112, '2015-04-01 01:04:08.000000', 'temperatura', 225.0000, 'ºC'),
	(140850, 112, '2015-04-01 01:04:09.000000', 'temperatura', 163.0000, 'ºC'),
	(140851, 112, '2015-04-01 01:04:10.000000', 'temperatura', 141.0000, 'ºC'),
	(140852, 112, '2015-04-01 01:04:11.000000', 'temperatura', 215.0000, 'ºC'),
	(140853, 112, '2015-04-01 01:04:12.000000', 'temperatura', 654.0000, 'ºC'),
	(140854, 112, '2015-04-01 01:04:13.000000', 'temperatura', 226.0000, 'ºC'),
	(140855, 112, '2015-04-01 01:04:14.000000', 'temperatura', 367.0000, 'ºC'),
	(140856, 112, '2015-04-01 01:04:15.000000', 'temperatura', 1156.0000, 'ºC'),
	(140857, 112, '2015-04-01 01:04:16.000000', 'temperatura', 1082.0000, 'ºC'),
	(140858, 112, '2015-04-01 01:04:17.000000', 'temperatura', 741.0000, 'ºC'),
	(140859, 112, '2015-04-01 01:04:18.000000', 'temperatura', 461.0000, 'ºC'),
	(140860, 112, '2015-04-01 01:04:19.000000', 'temperatura', 81.0000, 'ºC'),
	(140861, 112, '2015-04-01 01:04:20.000000', 'temperatura', 224.0000, 'ºC'),
	(140862, 112, '2015-04-01 01:04:21.000000', 'temperatura', 878.0000, 'ºC'),
	(140863, 112, '2015-04-01 01:04:22.000000', 'temperatura', 116.0000, 'ºC'),
	(140864, 112, '2015-04-01 01:04:23.000000', 'temperatura', 348.0000, 'ºC'),
	(140865, 112, '2015-04-01 01:04:24.000000', 'temperatura', 193.0000, 'ºC'),
	(140866, 112, '2015-04-01 01:04:25.000000', 'temperatura', 1119.0000, 'ºC'),
	(140867, 112, '2015-04-01 01:04:26.000000', 'temperatura', 218.0000, 'ºC'),
	(140868, 112, '2015-04-01 01:04:27.000000', 'temperatura', 132.0000, 'ºC'),
	(140869, 112, '2015-04-01 01:04:28.000000', 'temperatura', 7.0000, 'ºC'),
	(140870, 112, '2015-04-01 01:04:29.000000', 'temperatura', 841.0000, 'ºC'),
	(140871, 112, '2015-04-01 01:04:30.000000', 'temperatura', 583.0000, 'ºC'),
	(140872, 112, '2015-04-01 01:04:31.000000', 'temperatura', 393.0000, 'ºC'),
	(140873, 112, '2015-04-01 01:04:32.000000', 'temperatura', 215.0000, 'ºC'),
	(140874, 112, '2015-04-01 01:04:33.000000', 'temperatura', 1096.0000, 'ºC'),
	(140875, 112, '2015-04-01 01:04:34.000000', 'temperatura', 36.0000, 'ºC'),
	(140876, 112, '2015-04-01 01:04:35.000000', 'temperatura', 495.0000, 'ºC'),
	(140877, 112, '2015-04-01 01:04:36.000000', 'temperatura', 1165.0000, 'ºC'),
	(140878, 112, '2015-04-01 01:04:37.000000', 'temperatura', 740.0000, 'ºC'),
	(140879, 112, '2015-04-01 01:04:38.000000', 'temperatura', 208.0000, 'ºC'),
	(140880, 112, '2015-04-01 01:04:39.000000', 'temperatura', 20.0000, 'ºC'),
	(140881, 112, '2015-04-01 01:04:40.000000', 'temperatura', 677.0000, 'ºC'),
	(140882, 112, '2015-04-01 01:04:41.000000', 'temperatura', 924.0000, 'ºC'),
	(140883, 112, '2015-04-01 01:04:42.000000', 'temperatura', 189.0000, 'ºC'),
	(140884, 112, '2015-04-01 01:04:43.000000', 'temperatura', 576.0000, 'ºC'),
	(140885, 112, '2015-04-01 01:04:44.000000', 'temperatura', 1111.0000, 'ºC'),
	(140886, 112, '2015-04-01 01:04:45.000000', 'temperatura', 228.0000, 'ºC'),
	(140887, 112, '2015-04-01 01:04:46.000000', 'temperatura', 207.0000, 'ºC'),
	(140888, 112, '2015-04-01 01:04:47.000000', 'temperatura', 353.0000, 'ºC'),
	(140889, 112, '2015-04-01 01:04:48.000000', 'temperatura', 1146.0000, 'ºC'),
	(140890, 112, '2015-04-01 01:04:49.000000', 'temperatura', 1069.0000, 'ºC'),
	(140891, 112, '2015-04-01 01:04:50.000000', 'temperatura', 706.0000, 'ºC'),
	(140892, 112, '2015-04-01 01:04:51.000000', 'temperatura', 327.0000, 'ºC'),
	(140893, 112, '2015-04-01 01:04:52.000000', 'temperatura', 717.0000, 'ºC'),
	(140894, 112, '2015-04-01 01:04:53.000000', 'temperatura', 203.0000, 'ºC'),
	(140895, 112, '2015-04-01 01:04:54.000000', 'temperatura', 64.0000, 'ºC'),
	(140896, 112, '2015-04-01 01:04:55.000000', 'temperatura', 912.0000, 'ºC'),
	(140897, 112, '2015-04-01 01:04:56.000000', 'temperatura', 770.0000, 'ºC'),
	(140898, 112, '2015-04-01 01:04:57.000000', 'temperatura', 1114.0000, 'ºC'),
	(140899, 112, '2015-04-01 01:04:58.000000', 'temperatura', 860.0000, 'ºC'),
	(140900, 112, '2015-04-01 01:04:59.000000', 'temperatura', 957.0000, 'ºC'),
	(140901, 112, '2015-04-01 01:05:00.000000', 'temperatura', 1008.0000, 'ºC'),
	(140902, 112, '2015-04-01 01:05:01.000000', 'temperatura', 967.0000, 'ºC'),
	(140903, 112, '2015-04-01 01:05:02.000000', 'temperatura', 611.0000, 'ºC'),
	(140904, 112, '2015-04-01 01:05:03.000000', 'temperatura', 157.0000, 'ºC'),
	(140905, 112, '2015-04-01 01:05:04.000000', 'temperatura', 150.0000, 'ºC'),
	(140906, 112, '2015-04-01 01:05:05.000000', 'temperatura', 279.0000, 'ºC'),
	(140907, 112, '2015-04-01 01:05:06.000000', 'temperatura', 946.0000, 'ºC'),
	(140908, 112, '2015-04-01 01:05:07.000000', 'temperatura', 296.0000, 'ºC'),
	(140909, 112, '2015-04-01 01:05:08.000000', 'temperatura', 1040.0000, 'ºC'),
	(140910, 112, '2015-04-01 01:05:09.000000', 'temperatura', 712.0000, 'ºC'),
	(140911, 112, '2015-04-01 01:05:10.000000', 'temperatura', 442.0000, 'ºC'),
	(140912, 112, '2015-04-01 01:05:11.000000', 'temperatura', 73.0000, 'ºC'),
	(140913, 112, '2015-04-01 01:05:12.000000', 'temperatura', 241.0000, 'ºC'),
	(140914, 112, '2015-04-01 01:05:13.000000', 'temperatura', 986.0000, 'ºC'),
	(140915, 112, '2015-04-01 01:05:14.000000', 'temperatura', 606.0000, 'ºC'),
	(140916, 112, '2015-04-01 01:05:15.000000', 'temperatura', 72.0000, 'ºC'),
	(140917, 112, '2015-04-01 01:05:16.000000', 'temperatura', 944.0000, 'ºC'),
	(140918, 112, '2015-04-01 01:05:17.000000', 'temperatura', 906.0000, 'ºC'),
	(140919, 112, '2015-04-01 01:05:18.000000', 'temperatura', 496.0000, 'ºC'),
	(140920, 112, '2015-04-01 01:05:19.000000', 'temperatura', 962.0000, 'ºC'),
	(140921, 112, '2015-04-01 01:05:20.000000', 'temperatura', 923.0000, 'ºC'),
	(140922, 112, '2015-04-01 01:05:21.000000', 'temperatura', 528.0000, 'ºC'),
	(140923, 112, '2015-04-01 01:05:22.000000', 'temperatura', 1074.0000, 'ºC'),
	(140924, 112, '2015-04-01 01:05:23.000000', 'temperatura', 186.0000, 'ºC'),
	(140925, 112, '2015-04-01 01:05:24.000000', 'temperatura', 110.0000, 'ºC'),
	(140926, 112, '2015-04-01 01:05:25.000000', 'temperatura', 1190.0000, 'ºC'),
	(140927, 112, '2015-04-01 01:05:26.000000', 'temperatura', 823.0000, 'ºC'),
	(140928, 112, '2015-04-01 01:05:27.000000', 'temperatura', 545.0000, 'ºC'),
	(140929, 112, '2015-04-01 01:05:28.000000', 'temperatura', 258.0000, 'ºC'),
	(140930, 112, '2015-04-01 01:05:29.000000', 'temperatura', 854.0000, 'ºC'),
	(140931, 112, '2015-04-01 01:05:30.000000', 'temperatura', 1097.0000, 'ºC'),
	(140932, 112, '2015-04-01 01:05:31.000000', 'temperatura', 525.0000, 'ºC'),
	(140933, 112, '2015-04-01 01:05:32.000000', 'temperatura', 534.0000, 'ºC'),
	(140934, 112, '2015-04-01 01:05:33.000000', 'temperatura', 1095.0000, 'ºC'),
	(140935, 112, '2015-04-01 01:05:34.000000', 'temperatura', 272.0000, 'ºC'),
	(140936, 112, '2015-04-01 01:05:35.000000', 'temperatura', 475.0000, 'ºC'),
	(140937, 112, '2015-04-01 01:05:36.000000', 'temperatura', 360.0000, 'ºC'),
	(140938, 112, '2015-04-01 01:05:37.000000', 'temperatura', 374.0000, 'ºC'),
	(140939, 112, '2015-04-01 01:05:38.000000', 'temperatura', 793.0000, 'ºC'),
	(140940, 112, '2015-04-01 01:05:39.000000', 'temperatura', 443.0000, 'ºC'),
	(140941, 112, '2015-04-01 01:05:40.000000', 'temperatura', 1038.0000, 'ºC'),
	(140942, 112, '2015-04-01 01:05:41.000000', 'temperatura', 261.0000, 'ºC'),
	(140943, 112, '2015-04-01 01:05:42.000000', 'temperatura', 593.0000, 'ºC'),
	(140944, 112, '2015-04-01 01:05:43.000000', 'temperatura', 981.0000, 'ºC'),
	(140945, 112, '2015-04-01 01:05:44.000000', 'temperatura', 724.0000, 'ºC'),
	(140946, 112, '2015-04-01 01:05:45.000000', 'temperatura', 681.0000, 'ºC'),
	(140947, 112, '2015-04-01 01:05:46.000000', 'temperatura', 33.0000, 'ºC'),
	(140948, 112, '2015-04-01 01:05:47.000000', 'temperatura', 522.0000, 'ºC'),
	(140949, 112, '2015-04-01 01:05:48.000000', 'temperatura', 111.0000, 'ºC'),
	(140950, 112, '2015-04-01 01:05:49.000000', 'temperatura', 189.0000, 'ºC'),
	(140951, 112, '2015-04-01 01:05:50.000000', 'temperatura', 614.0000, 'ºC'),
	(140952, 112, '2015-04-01 01:05:51.000000', 'temperatura', 103.0000, 'ºC'),
	(140953, 112, '2015-04-01 01:05:52.000000', 'temperatura', 1075.0000, 'ºC'),
	(140954, 112, '2015-04-01 01:05:53.000000', 'temperatura', 267.0000, 'ºC'),
	(140955, 112, '2015-04-01 01:05:54.000000', 'temperatura', 508.0000, 'ºC'),
	(140956, 112, '2015-04-01 01:05:55.000000', 'temperatura', 540.0000, 'ºC'),
	(140957, 112, '2015-04-01 01:05:56.000000', 'temperatura', 1175.0000, 'ºC'),
	(140958, 112, '2015-04-01 01:05:57.000000', 'temperatura', 658.0000, 'ºC'),
	(140959, 112, '2015-04-01 01:05:58.000000', 'temperatura', 963.0000, 'ºC'),
	(140960, 112, '2015-04-01 01:05:59.000000', 'temperatura', 445.0000, 'ºC'),
	(140961, 112, '2015-04-01 01:06:00.000000', 'temperatura', 533.0000, 'ºC'),
	(140962, 112, '2015-04-01 01:06:01.000000', 'temperatura', 134.0000, 'ºC'),
	(140963, 112, '2015-04-01 01:06:02.000000', 'temperatura', 269.0000, 'ºC'),
	(140964, 112, '2015-04-01 01:06:03.000000', 'temperatura', 943.0000, 'ºC'),
	(140965, 112, '2015-04-01 01:06:04.000000', 'temperatura', 308.0000, 'ºC'),
	(140966, 112, '2015-04-01 01:06:05.000000', 'temperatura', 1113.0000, 'ºC'),
	(140967, 112, '2015-04-01 01:06:06.000000', 'temperatura', 1041.0000, 'ºC'),
	(140968, 112, '2015-04-01 01:06:07.000000', 'temperatura', 667.0000, 'ºC'),
	(140969, 112, '2015-04-01 01:06:08.000000', 'temperatura', 213.0000, 'ºC'),
	(140970, 112, '2015-04-01 01:06:09.000000', 'temperatura', 264.0000, 'ºC'),
	(140971, 112, '2015-04-01 01:06:10.000000', 'temperatura', 681.0000, 'ºC'),
	(140972, 112, '2015-04-01 01:06:11.000000', 'temperatura', 214.0000, 'ºC'),
	(140973, 112, '2015-04-01 01:06:12.000000', 'temperatura', 226.0000, 'ºC'),
	(140974, 112, '2015-04-01 01:06:13.000000', 'temperatura', 490.0000, 'ºC'),
	(140975, 112, '2015-04-01 01:06:14.000000', 'temperatura', 574.0000, 'ºC'),
	(140976, 112, '2015-04-01 01:06:15.000000', 'temperatura', 198.0000, 'ºC'),
	(140977, 112, '2015-04-01 01:06:16.000000', 'temperatura', 471.0000, 'ºC'),
	(140978, 112, '2015-04-01 01:06:17.000000', 'temperatura', 562.0000, 'ºC'),
	(140979, 112, '2015-04-01 01:06:18.000000', 'temperatura', 198.0000, 'ºC'),
	(140980, 112, '2015-04-01 01:06:19.000000', 'temperatura', 502.0000, 'ºC'),
	(140981, 112, '2015-04-01 01:06:20.000000', 'temperatura', 716.0000, 'ºC'),
	(140982, 112, '2015-04-01 01:06:21.000000', 'temperatura', 874.0000, 'ºC'),
	(140983, 112, '2015-04-01 01:06:22.000000', 'temperatura', 1025.0000, 'ºC'),
	(140984, 112, '2015-04-01 01:06:23.000000', 'temperatura', 104.0000, 'ºC'),
	(140985, 112, '2015-04-01 01:06:24.000000', 'temperatura', 1045.0000, 'ºC'),
	(140986, 112, '2015-04-01 01:06:25.000000', 'temperatura', 114.0000, 'ºC'),
	(140987, 112, '2015-04-01 01:06:26.000000', 'temperatura', 1035.0000, 'ºC'),
	(140988, 112, '2015-04-01 01:06:27.000000', 'temperatura', 33.0000, 'ºC'),
	(140989, 112, '2015-04-01 01:06:28.000000', 'temperatura', 659.0000, 'ºC'),
	(140990, 112, '2015-04-01 01:06:29.000000', 'temperatura', 797.0000, 'ºC'),
	(140991, 112, '2015-04-01 01:06:30.000000', 'temperatura', 807.0000, 'ºC'),
	(140992, 112, '2015-04-01 01:06:31.000000', 'temperatura', 447.0000, 'ºC'),
	(140993, 112, '2015-04-01 01:06:32.000000', 'temperatura', 1014.0000, 'ºC'),
	(140994, 112, '2015-04-01 01:06:33.000000', 'temperatura', 130.0000, 'ºC'),
	(140995, 112, '2015-04-01 01:06:34.000000', 'temperatura', 8.0000, 'ºC'),
	(140996, 112, '2015-04-01 01:06:35.000000', 'temperatura', 849.0000, 'ºC'),
	(140997, 112, '2015-04-01 01:06:36.000000', 'temperatura', 624.0000, 'ºC'),
	(140998, 112, '2015-04-01 01:06:37.000000', 'temperatura', 572.0000, 'ºC'),
	(140999, 112, '2015-04-01 01:06:38.000000', 'temperatura', 989.0000, 'ºC'),
	(141000, 112, '2015-04-01 01:06:39.000000', 'temperatura', 829.0000, 'ºC'),
	(141001, 112, '2015-04-01 01:06:40.000000', 'temperatura', 1178.0000, 'ºC'),
	(141002, 112, '2015-04-01 01:06:41.000000', 'temperatura', 1003.0000, 'ºC'),
	(141003, 112, '2015-04-01 01:06:42.000000', 'temperatura', 282.0000, 'ºC'),
	(141004, 112, '2015-04-01 01:06:43.000000', 'temperatura', 802.0000, 'ºC'),
	(141005, 112, '2015-04-01 01:06:44.000000', 'temperatura', 765.0000, 'ºC'),
	(141006, 112, '2015-04-01 01:06:45.000000', 'temperatura', 221.0000, 'ºC'),
	(141007, 112, '2015-04-01 01:06:46.000000', 'temperatura', 9.0000, 'ºC'),
	(141008, 112, '2015-04-01 01:06:47.000000', 'temperatura', 585.0000, 'ºC'),
	(141009, 112, '2015-04-01 01:06:48.000000', 'temperatura', 495.0000, 'ºC'),
	(141010, 112, '2015-04-01 01:06:49.000000', 'temperatura', 721.0000, 'ºC'),
	(141011, 112, '2015-04-01 01:06:50.000000', 'temperatura', 923.0000, 'ºC'),
	(141012, 112, '2015-04-01 01:06:51.000000', 'temperatura', 49.0000, 'ºC'),
	(141013, 112, '2015-04-01 01:06:52.000000', 'temperatura', 1079.0000, 'ºC'),
	(141014, 112, '2015-04-01 01:06:53.000000', 'temperatura', 448.0000, 'ºC'),
	(141015, 112, '2015-04-01 01:06:54.000000', 'temperatura', 204.0000, 'ºC'),
	(141016, 112, '2015-04-01 01:06:55.000000', 'temperatura', 878.0000, 'ºC'),
	(141017, 112, '2015-04-01 01:06:56.000000', 'temperatura', 176.0000, 'ºC'),
	(141018, 112, '2015-04-01 01:06:57.000000', 'temperatura', 648.0000, 'ºC'),
	(141019, 112, '2015-04-01 01:06:58.000000', 'temperatura', 313.0000, 'ºC'),
	(141020, 112, '2015-04-01 01:06:59.000000', 'temperatura', 820.0000, 'ºC'),
	(141021, 112, '2015-04-01 01:07:00.000000', 'temperatura', 762.0000, 'ºC'),
	(141022, 112, '2015-04-01 01:07:01.000000', 'temperatura', 152.0000, 'ºC'),
	(141023, 112, '2015-04-01 01:07:02.000000', 'temperatura', 871.0000, 'ºC'),
	(141024, 112, '2015-04-01 01:07:03.000000', 'temperatura', 303.0000, 'ºC'),
	(141025, 112, '2015-04-01 01:07:04.000000', 'temperatura', 102.0000, 'ºC'),
	(141026, 112, '2015-04-01 01:07:05.000000', 'temperatura', 802.0000, 'ºC'),
	(141027, 112, '2015-04-01 01:07:06.000000', 'temperatura', 103.0000, 'ºC'),
	(141028, 112, '2015-04-01 01:07:07.000000', 'temperatura', 511.0000, 'ºC'),
	(141029, 112, '2015-04-01 01:07:08.000000', 'temperatura', 1048.0000, 'ºC'),
	(141030, 112, '2015-04-01 01:07:09.000000', 'temperatura', 105.0000, 'ºC'),
	(141031, 112, '2015-04-01 01:07:10.000000', 'temperatura', 981.0000, 'ºC'),
	(141032, 112, '2015-04-01 01:07:11.000000', 'temperatura', 992.0000, 'ºC'),
	(141033, 112, '2015-04-01 01:07:12.000000', 'temperatura', 819.0000, 'ºC'),
	(141034, 112, '2015-04-01 01:07:13.000000', 'temperatura', 1116.0000, 'ºC'),
	(141035, 112, '2015-04-01 01:07:14.000000', 'temperatura', 725.0000, 'ºC'),
	(141036, 112, '2015-04-01 01:07:15.000000', 'temperatura', 278.0000, 'ºC'),
	(141037, 112, '2015-04-01 01:07:16.000000', 'temperatura', 415.0000, 'ºC'),
	(141038, 112, '2015-04-01 01:07:17.000000', 'temperatura', 42.0000, 'ºC'),
	(141039, 112, '2015-04-01 01:07:18.000000', 'temperatura', 167.0000, 'ºC'),
	(141040, 112, '2015-04-01 01:07:19.000000', 'temperatura', 710.0000, 'ºC'),
	(141041, 112, '2015-04-01 01:07:20.000000', 'temperatura', 647.0000, 'ºC'),
	(141042, 112, '2015-04-01 01:07:21.000000', 'temperatura', 1108.0000, 'ºC'),
	(141043, 112, '2015-04-01 01:07:22.000000', 'temperatura', 1199.0000, 'ºC'),
	(141044, 112, '2015-04-01 01:07:23.000000', 'temperatura', 273.0000, 'ºC'),
	(141045, 112, '2015-04-01 01:07:24.000000', 'temperatura', 166.0000, 'ºC'),
	(141046, 112, '2015-04-01 01:07:25.000000', 'temperatura', 14.0000, 'ºC'),
	(141047, 112, '2015-04-01 01:07:26.000000', 'temperatura', 770.0000, 'ºC'),
	(141048, 112, '2015-04-01 01:07:27.000000', 'temperatura', 207.0000, 'ºC'),
	(141049, 112, '2015-04-01 01:07:28.000000', 'temperatura', 1129.0000, 'ºC'),
	(141050, 112, '2015-04-01 01:07:29.000000', 'temperatura', 222.0000, 'ºC'),
	(141051, 112, '2015-04-01 01:07:30.000000', 'temperatura', 125.0000, 'ºC'),
	(141052, 112, '2015-04-01 01:07:31.000000', 'temperatura', 1158.0000, 'ºC'),
	(141053, 112, '2015-04-01 01:07:32.000000', 'temperatura', 617.0000, 'ºC'),
	(141054, 112, '2015-04-01 01:07:33.000000', 'temperatura', 809.0000, 'ºC'),
	(141055, 112, '2015-04-01 01:07:34.000000', 'temperatura', 997.0000, 'ºC'),
	(141056, 112, '2015-04-01 01:07:35.000000', 'temperatura', 156.0000, 'ºC'),
	(141057, 112, '2015-04-01 01:07:36.000000', 'temperatura', 192.0000, 'ºC'),
	(141058, 112, '2015-04-01 01:07:37.000000', 'temperatura', 492.0000, 'ºC'),
	(141059, 112, '2015-04-01 01:07:38.000000', 'temperatura', 684.0000, 'ºC'),
	(141060, 112, '2015-04-01 01:07:39.000000', 'temperatura', 744.0000, 'ºC'),
	(141061, 112, '2015-04-01 01:07:40.000000', 'temperatura', 471.0000, 'ºC'),
	(141062, 112, '2015-04-01 01:07:41.000000', 'temperatura', 121.0000, 'ºC'),
	(141063, 112, '2015-04-01 01:07:42.000000', 'temperatura', 394.0000, 'ºC'),
	(141064, 112, '2015-04-01 01:07:43.000000', 'temperatura', 407.0000, 'ºC'),
	(141065, 112, '2015-04-01 01:07:44.000000', 'temperatura', 854.0000, 'ºC'),
	(141066, 112, '2015-04-01 01:07:45.000000', 'temperatura', 649.0000, 'ºC'),
	(141067, 112, '2015-04-01 01:07:46.000000', 'temperatura', 685.0000, 'ºC'),
	(141068, 112, '2015-04-01 01:07:47.000000', 'temperatura', 276.0000, 'ºC'),
	(141069, 112, '2015-04-01 01:07:48.000000', 'temperatura', 525.0000, 'ºC'),
	(141070, 112, '2015-04-01 01:07:49.000000', 'temperatura', 601.0000, 'ºC'),
	(141071, 112, '2015-04-01 01:07:50.000000', 'temperatura', 227.0000, 'ºC'),
	(141072, 112, '2015-04-01 01:07:51.000000', 'temperatura', 534.0000, 'ºC'),
	(141073, 112, '2015-04-01 01:07:52.000000', 'temperatura', 790.0000, 'ºC'),
	(141074, 112, '2015-04-01 01:07:53.000000', 'temperatura', 1149.0000, 'ºC'),
	(141075, 112, '2015-04-01 01:07:54.000000', 'temperatura', 975.0000, 'ºC'),
	(141076, 112, '2015-04-01 01:07:55.000000', 'temperatura', 227.0000, 'ºC'),
	(141077, 112, '2015-04-01 01:07:56.000000', 'temperatura', 611.0000, 'ºC'),
	(141078, 112, '2015-04-01 01:07:57.000000', 'temperatura', 1174.0000, 'ºC'),
	(141079, 112, '2015-04-01 01:07:58.000000', 'temperatura', 440.0000, 'ºC'),
	(141080, 112, '2015-04-01 01:07:59.000000', 'temperatura', 1077.0000, 'ºC'),
	(141081, 112, '2015-04-01 01:08:00.000000', 'temperatura', 465.0000, 'ºC'),
	(141082, 112, '2015-04-01 01:08:01.000000', 'temperatura', 296.0000, 'ºC'),
	(141083, 112, '2015-04-01 01:08:02.000000', 'temperatura', 86.0000, 'ºC'),
	(141084, 112, '2015-04-01 01:08:03.000000', 'temperatura', 742.0000, 'ºC'),
	(141085, 112, '2015-04-01 01:08:04.000000', 'temperatura', 1054.0000, 'ºC'),
	(141086, 112, '2015-04-01 01:08:05.000000', 'temperatura', 644.0000, 'ºC'),
	(141087, 112, '2015-04-01 01:08:06.000000', 'temperatura', 60.0000, 'ºC'),
	(141088, 112, '2015-04-01 01:08:07.000000', 'temperatura', 767.0000, 'ºC'),
	(141089, 112, '2015-04-01 01:08:08.000000', 'temperatura', 56.0000, 'ºC'),
	(141090, 112, '2015-04-01 01:08:09.000000', 'temperatura', 380.0000, 'ºC'),
	(141091, 112, '2015-04-01 01:08:10.000000', 'temperatura', 533.0000, 'ºC'),
	(141092, 112, '2015-04-01 01:08:11.000000', 'temperatura', 324.0000, 'ºC'),
	(141093, 112, '2015-04-01 01:08:12.000000', 'temperatura', 24.0000, 'ºC'),
	(141094, 112, '2015-04-01 01:08:13.000000', 'temperatura', 346.0000, 'ºC'),
	(141095, 112, '2015-04-01 01:08:14.000000', 'temperatura', 460.0000, 'ºC'),
	(141096, 112, '2015-04-01 01:08:15.000000', 'temperatura', 62.0000, 'ºC'),
	(141097, 112, '2015-04-01 01:08:16.000000', 'temperatura', 129.0000, 'ºC'),
	(141098, 112, '2015-04-01 01:08:17.000000', 'temperatura', 462.0000, 'ºC'),
	(141099, 112, '2015-04-01 01:08:18.000000', 'temperatura', 725.0000, 'ºC'),
	(141100, 112, '2015-04-01 01:08:19.000000', 'temperatura', 1036.0000, 'ºC'),
	(141101, 112, '2015-04-01 01:08:20.000000', 'temperatura', 605.0000, 'ºC'),
	(141102, 112, '2015-04-01 01:08:21.000000', 'temperatura', 1120.0000, 'ºC'),
	(141103, 112, '2015-04-01 01:08:22.000000', 'temperatura', 183.0000, 'ºC'),
	(141104, 112, '2015-04-01 01:08:23.000000', 'temperatura', 1158.0000, 'ºC'),
	(141105, 112, '2015-04-01 01:08:24.000000', 'temperatura', 441.0000, 'ºC'),
	(141106, 112, '2015-04-01 01:08:25.000000', 'temperatura', 1130.0000, 'ºC'),
	(141107, 112, '2015-04-01 01:08:26.000000', 'temperatura', 727.0000, 'ºC'),
	(141108, 112, '2015-04-01 01:08:27.000000', 'temperatura', 245.0000, 'ºC'),
	(141109, 112, '2015-04-01 01:08:28.000000', 'temperatura', 245.0000, 'ºC'),
	(141110, 112, '2015-04-01 01:08:29.000000', 'temperatura', 492.0000, 'ºC'),
	(141111, 112, '2015-04-01 01:08:30.000000', 'temperatura', 526.0000, 'ºC'),
	(141112, 112, '2015-04-01 01:08:31.000000', 'temperatura', 1154.0000, 'ºC'),
	(141113, 112, '2015-04-01 01:08:32.000000', 'temperatura', 593.0000, 'ºC'),
	(141114, 112, '2015-04-01 01:08:33.000000', 'temperatura', 702.0000, 'ºC'),
	(141115, 112, '2015-04-01 01:08:34.000000', 'temperatura', 530.0000, 'ºC'),
	(141116, 112, '2015-04-01 01:08:35.000000', 'temperatura', 548.0000, 'ºC'),
	(141117, 112, '2015-04-01 01:08:36.000000', 'temperatura', 1147.0000, 'ºC'),
	(141118, 112, '2015-04-01 01:08:37.000000', 'temperatura', 493.0000, 'ºC'),
	(141119, 112, '2015-04-01 01:08:38.000000', 'temperatura', 226.0000, 'ºC'),
	(141120, 112, '2015-04-01 01:08:39.000000', 'temperatura', 851.0000, 'ºC'),
	(141121, 112, '2015-04-01 01:08:40.000000', 'temperatura', 1179.0000, 'ºC'),
	(141122, 112, '2015-04-01 01:08:41.000000', 'temperatura', 940.0000, 'ºC'),
	(141123, 112, '2015-04-01 01:08:42.000000', 'temperatura', 1165.0000, 'ºC'),
	(141124, 112, '2015-04-01 01:08:43.000000', 'temperatura', 606.0000, 'ºC'),
	(141125, 112, '2015-04-01 01:08:44.000000', 'temperatura', 734.0000, 'ºC'),
	(141126, 112, '2015-04-01 01:08:45.000000', 'temperatura', 651.0000, 'ºC'),
	(141127, 112, '2015-04-01 01:08:46.000000', 'temperatura', 1056.0000, 'ºC'),
	(141128, 112, '2015-04-01 01:08:47.000000', 'temperatura', 927.0000, 'ºC'),
	(141129, 112, '2015-04-01 01:08:48.000000', 'temperatura', 267.0000, 'ºC'),
	(141130, 112, '2015-04-01 01:08:49.000000', 'temperatura', 953.0000, 'ºC'),
	(141131, 112, '2015-04-01 01:08:50.000000', 'temperatura', 366.0000, 'ºC'),
	(141132, 112, '2015-04-01 01:08:51.000000', 'temperatura', 171.0000, 'ºC'),
	(141133, 112, '2015-04-01 01:08:52.000000', 'temperatura', 956.0000, 'ºC'),
	(141134, 112, '2015-04-01 01:08:53.000000', 'temperatura', 670.0000, 'ºC'),
	(141135, 112, '2015-04-01 01:08:54.000000', 'temperatura', 482.0000, 'ºC'),
	(141136, 112, '2015-04-01 01:08:55.000000', 'temperatura', 400.0000, 'ºC'),
	(141137, 112, '2015-04-01 01:08:56.000000', 'temperatura', 556.0000, 'ºC'),
	(141138, 112, '2015-04-01 01:08:57.000000', 'temperatura', 381.0000, 'ºC'),
	(141139, 112, '2015-04-01 01:08:58.000000', 'temperatura', 236.0000, 'ºC'),
	(141140, 112, '2015-04-01 01:08:59.000000', 'temperatura', 40.0000, 'ºC'),
	(141141, 112, '2015-04-01 01:09:00.000000', 'temperatura', 689.0000, 'ºC'),
	(141142, 112, '2015-04-01 01:09:01.000000', 'temperatura', 928.0000, 'ºC'),
	(141143, 112, '2015-04-01 01:09:02.000000', 'temperatura', 174.0000, 'ºC'),
	(141144, 112, '2015-04-01 01:09:03.000000', 'temperatura', 487.0000, 'ºC'),
	(141145, 112, '2015-04-01 01:09:04.000000', 'temperatura', 712.0000, 'ºC'),
	(141146, 112, '2015-04-01 01:09:05.000000', 'temperatura', 900.0000, 'ºC'),
	(141147, 112, '2015-04-01 01:09:06.000000', 'temperatura', 1166.0000, 'ºC'),
	(141148, 112, '2015-04-01 01:09:07.000000', 'temperatura', 731.0000, 'ºC'),
	(141149, 112, '2015-04-01 01:09:08.000000', 'temperatura', 156.0000, 'ºC'),
	(141150, 112, '2015-04-01 01:09:09.000000', 'temperatura', 987.0000, 'ºC'),
	(141151, 112, '2015-04-01 01:09:10.000000', 'temperatura', 866.0000, 'ºC'),
	(141152, 112, '2015-04-01 01:09:11.000000', 'temperatura', 173.0000, 'ºC'),
	(141153, 112, '2015-04-01 01:09:12.000000', 'temperatura', 664.0000, 'ºC'),
	(141154, 112, '2015-04-01 01:09:13.000000', 'temperatura', 404.0000, 'ºC'),
	(141155, 112, '2015-04-01 01:09:14.000000', 'temperatura', 29.0000, 'ºC'),
	(141156, 112, '2015-04-01 01:09:15.000000', 'temperatura', 134.0000, 'ºC'),
	(141157, 112, '2015-04-01 01:09:16.000000', 'temperatura', 582.0000, 'ºC'),
	(141158, 112, '2015-04-01 01:09:17.000000', 'temperatura', 108.0000, 'ºC'),
	(141159, 112, '2015-04-01 01:09:18.000000', 'temperatura', 1196.0000, 'ºC'),
	(141160, 112, '2015-04-01 01:09:19.000000', 'temperatura', 855.0000, 'ºC'),
	(141161, 112, '2015-04-01 01:09:20.000000', 'temperatura', 687.0000, 'ºC'),
	(141162, 112, '2015-04-01 01:09:21.000000', 'temperatura', 871.0000, 'ºC'),
	(141163, 112, '2015-04-01 01:09:22.000000', 'temperatura', 1093.0000, 'ºC'),
	(141164, 112, '2015-04-01 01:09:23.000000', 'temperatura', 454.0000, 'ºC'),
	(141165, 112, '2015-04-01 01:09:24.000000', 'temperatura', 191.0000, 'ºC'),
	(141166, 112, '2015-04-01 01:09:25.000000', 'temperatura', 795.0000, 'ºC'),
	(141167, 112, '2015-04-01 01:09:26.000000', 'temperatura', 1004.0000, 'ºC'),
	(141168, 112, '2015-04-01 01:09:27.000000', 'temperatura', 232.0000, 'ºC'),
	(141169, 112, '2015-04-01 01:09:28.000000', 'temperatura', 550.0000, 'ºC'),
	(141170, 112, '2015-04-01 01:09:29.000000', 'temperatura', 854.0000, 'ºC'),
	(141171, 112, '2015-04-01 01:09:30.000000', 'temperatura', 222.0000, 'ºC'),
	(141172, 112, '2015-04-01 01:09:31.000000', 'temperatura', 946.0000, 'ºC'),
	(141173, 112, '2015-04-01 01:09:32.000000', 'temperatura', 465.0000, 'ºC'),
	(141174, 112, '2015-04-01 01:09:33.000000', 'temperatura', 690.0000, 'ºC'),
	(141175, 112, '2015-04-01 01:09:34.000000', 'temperatura', 853.0000, 'ºC'),
	(141176, 112, '2015-04-01 01:09:35.000000', 'temperatura', 997.0000, 'ºC'),
	(141177, 112, '2015-04-01 01:09:36.000000', 'temperatura', 28.0000, 'ºC'),
	(141178, 112, '2015-04-01 01:09:37.000000', 'temperatura', 747.0000, 'ºC'),
	(141179, 112, '2015-04-01 01:09:38.000000', 'temperatura', 54.0000, 'ºC'),
	(141180, 112, '2015-04-01 01:09:39.000000', 'temperatura', 428.0000, 'ºC'),
	(141181, 112, '2015-04-01 01:09:40.000000', 'temperatura', 780.0000, 'ºC'),
	(141182, 112, '2015-04-01 01:09:41.000000', 'temperatura', 216.0000, 'ºC'),
	(141183, 112, '2015-04-01 01:09:42.000000', 'temperatura', 1142.0000, 'ºC'),
	(141184, 112, '2015-04-01 01:09:43.000000', 'temperatura', 262.0000, 'ºC'),
	(141185, 112, '2015-04-01 01:09:44.000000', 'temperatura', 284.0000, 'ºC'),
	(141186, 112, '2015-04-01 01:09:45.000000', 'temperatura', 633.0000, 'ºC'),
	(141187, 112, '2015-04-01 01:09:46.000000', 'temperatura', 1115.0000, 'ºC'),
	(141188, 112, '2015-04-01 01:09:47.000000', 'temperatura', 74.0000, 'ºC'),
	(141189, 112, '2015-04-01 01:09:48.000000', 'temperatura', 629.0000, 'ºC'),
	(141190, 112, '2015-04-01 01:09:49.000000', 'temperatura', 521.0000, 'ºC'),
	(141191, 112, '2015-04-01 01:09:50.000000', 'temperatura', 718.0000, 'ºC'),
	(141192, 112, '2015-04-01 01:09:51.000000', 'temperatura', 830.0000, 'ºC'),
	(141193, 112, '2015-04-01 01:09:52.000000', 'temperatura', 795.0000, 'ºC'),
	(141194, 112, '2015-04-01 01:09:53.000000', 'temperatura', 287.0000, 'ºC'),
	(141195, 112, '2015-04-01 01:09:54.000000', 'temperatura', 250.0000, 'ºC'),
	(141196, 112, '2015-04-01 01:09:55.000000', 'temperatura', 391.0000, 'ºC'),
	(141197, 112, '2015-04-01 01:09:56.000000', 'temperatura', 5.0000, 'ºC'),
	(141198, 112, '2015-04-01 01:09:57.000000', 'temperatura', 53.0000, 'ºC'),
	(141199, 112, '2015-04-01 01:09:58.000000', 'temperatura', 250.0000, 'ºC'),
	(141200, 112, '2015-04-01 01:09:59.000000', 'temperatura', 1093.0000, 'ºC'),
	(141201, 112, '2015-04-01 01:10:00.000000', 'temperatura', 1114.0000, 'ºC'),
	(141202, 112, '2015-04-01 01:10:01.000000', 'temperatura', 1091.0000, 'ºC'),
	(141203, 112, '2015-04-01 01:10:02.000000', 'temperatura', 912.0000, 'ºC'),
	(141204, 112, '2015-04-01 01:10:03.000000', 'temperatura', 89.0000, 'ºC'),
	(141205, 112, '2015-04-01 01:10:04.000000', 'temperatura', 109.0000, 'ºC'),
	(141206, 112, '2015-04-01 01:10:05.000000', 'temperatura', 281.0000, 'ºC'),
	(141207, 112, '2015-04-01 01:10:06.000000', 'temperatura', 1076.0000, 'ºC'),
	(141208, 112, '2015-04-01 01:10:07.000000', 'temperatura', 939.0000, 'ºC'),
	(141209, 112, '2015-04-01 01:10:08.000000', 'temperatura', 267.0000, 'ºC'),
	(141210, 112, '2015-04-01 01:10:09.000000', 'temperatura', 919.0000, 'ºC'),
	(141211, 112, '2015-04-01 01:10:10.000000', 'temperatura', 193.0000, 'ºC'),
	(141212, 112, '2015-04-01 01:10:11.000000', 'temperatura', 611.0000, 'ºC'),
	(141213, 112, '2015-04-01 01:10:12.000000', 'temperatura', 73.0000, 'ºC'),
	(141214, 112, '2015-04-01 01:10:13.000000', 'temperatura', 935.0000, 'ºC'),
	(141215, 112, '2015-04-01 01:10:14.000000', 'temperatura', 856.0000, 'ºC'),
	(141216, 112, '2015-04-01 01:10:15.000000', 'temperatura', 277.0000, 'ºC'),
	(141217, 112, '2015-04-01 01:10:16.000000', 'temperatura', 18.0000, 'ºC'),
	(141218, 112, '2015-04-01 01:10:17.000000', 'temperatura', 460.0000, 'ºC'),
	(141219, 112, '2015-04-01 01:10:18.000000', 'temperatura', 1046.0000, 'ºC'),
	(141220, 112, '2015-04-01 01:10:19.000000', 'temperatura', 248.0000, 'ºC'),
	(141221, 112, '2015-04-01 01:10:20.000000', 'temperatura', 504.0000, 'ºC'),
	(141222, 112, '2015-04-01 01:10:21.000000', 'temperatura', 576.0000, 'ºC'),
	(141223, 112, '2015-04-01 01:10:22.000000', 'temperatura', 170.0000, 'ºC'),
	(141224, 112, '2015-04-01 01:10:23.000000', 'temperatura', 320.0000, 'ºC'),
	(141225, 112, '2015-04-01 01:10:24.000000', 'temperatura', 1092.0000, 'ºC'),
	(141226, 112, '2015-04-01 01:10:25.000000', 'temperatura', 899.0000, 'ºC'),
	(141227, 112, '2015-04-01 01:10:26.000000', 'temperatura', 20.0000, 'ºC'),
	(141228, 112, '2015-04-01 01:10:27.000000', 'temperatura', 1005.0000, 'ºC'),
	(141229, 112, '2015-04-01 01:10:28.000000', 'temperatura', 164.0000, 'ºC'),
	(141230, 112, '2015-04-01 01:10:29.000000', 'temperatura', 207.0000, 'ºC'),
	(141231, 112, '2015-04-01 01:10:30.000000', 'temperatura', 542.0000, 'ºC'),
	(141232, 112, '2015-04-01 01:10:31.000000', 'temperatura', 888.0000, 'ºC'),
	(141233, 112, '2015-04-01 01:10:32.000000', 'temperatura', 417.0000, 'ºC'),
	(141234, 112, '2015-04-01 01:10:33.000000', 'temperatura', 622.0000, 'ºC'),
	(141235, 112, '2015-04-01 01:10:34.000000', 'temperatura', 657.0000, 'ºC'),
	(141236, 112, '2015-04-01 01:10:35.000000', 'temperatura', 222.0000, 'ºC'),
	(141237, 112, '2015-04-01 01:10:36.000000', 'temperatura', 340.0000, 'ºC'),
	(141238, 112, '2015-04-01 01:10:37.000000', 'temperatura', 1033.0000, 'ºC'),
	(141239, 112, '2015-04-01 01:10:38.000000', 'temperatura', 545.0000, 'ºC'),
	(141240, 112, '2015-04-01 01:10:39.000000', 'temperatura', 828.0000, 'ºC'),
	(141241, 112, '2015-04-01 01:10:40.000000', 'temperatura', 105.0000, 'ºC'),
	(141242, 112, '2015-04-01 01:10:41.000000', 'temperatura', 440.0000, 'ºC'),
	(141243, 112, '2015-04-01 01:10:42.000000', 'temperatura', 685.0000, 'ºC'),
	(141244, 112, '2015-04-01 01:10:43.000000', 'temperatura', 907.0000, 'ºC'),
	(141245, 112, '2015-04-01 01:10:44.000000', 'temperatura', 82.0000, 'ºC'),
	(141246, 112, '2015-04-01 01:10:45.000000', 'temperatura', 86.0000, 'ºC'),
	(141247, 112, '2015-04-01 01:10:46.000000', 'temperatura', 188.0000, 'ºC'),
	(141248, 112, '2015-04-01 01:10:47.000000', 'temperatura', 679.0000, 'ºC'),
	(141249, 112, '2015-04-01 01:10:48.000000', 'temperatura', 435.0000, 'ºC'),
	(141250, 112, '2015-04-01 01:10:49.000000', 'temperatura', 136.0000, 'ºC'),
	(141251, 112, '2015-04-01 01:10:50.000000', 'temperatura', 576.0000, 'ºC'),
	(141252, 112, '2015-04-01 01:10:51.000000', 'temperatura', 73.0000, 'ºC'),
	(141253, 112, '2015-04-01 01:10:52.000000', 'temperatura', 1038.0000, 'ºC'),
	(141254, 112, '2015-04-01 01:10:53.000000', 'temperatura', 170.0000, 'ºC'),
	(141255, 112, '2015-04-01 01:10:54.000000', 'temperatura', 136.0000, 'ºC'),
	(141256, 112, '2015-04-01 01:10:55.000000', 'temperatura', 173.0000, 'ºC'),
	(141257, 112, '2015-04-01 01:10:56.000000', 'temperatura', 455.0000, 'ºC'),
	(141258, 112, '2015-04-01 01:10:57.000000', 'temperatura', 559.0000, 'ºC'),
	(141259, 112, '2015-04-01 01:10:58.000000', 'temperatura', 231.0000, 'ºC'),
	(141260, 112, '2015-04-01 01:10:59.000000', 'temperatura', 678.0000, 'ºC'),
	(141261, 112, '2015-04-01 01:11:00.000000', 'temperatura', 297.0000, 'ºC'),
	(141262, 112, '2015-04-01 01:11:01.000000', 'temperatura', 650.0000, 'ºC'),
	(141263, 112, '2015-04-01 01:11:02.000000', 'temperatura', 1160.0000, 'ºC'),
	(141264, 112, '2015-04-01 01:11:03.000000', 'temperatura', 249.0000, 'ºC'),
	(141265, 112, '2015-04-01 01:11:04.000000', 'temperatura', 169.0000, 'ºC'),
	(141266, 112, '2015-04-01 01:11:05.000000', 'temperatura', 96.0000, 'ºC'),
	(141267, 112, '2015-04-01 01:11:06.000000', 'temperatura', 1176.0000, 'ºC'),
	(141268, 112, '2015-04-01 01:11:07.000000', 'temperatura', 790.0000, 'ºC'),
	(141269, 112, '2015-04-01 01:11:08.000000', 'temperatura', 423.0000, 'ºC'),
	(141270, 112, '2015-04-01 01:11:09.000000', 'temperatura', 945.0000, 'ºC'),
	(141271, 112, '2015-04-01 01:11:10.000000', 'temperatura', 1057.0000, 'ºC'),
	(141272, 112, '2015-04-01 01:11:11.000000', 'temperatura', 50.0000, 'ºC'),
	(141273, 112, '2015-04-01 01:11:12.000000', 'temperatura', 679.0000, 'ºC'),
	(141274, 112, '2015-04-01 01:11:13.000000', 'temperatura', 847.0000, 'ºC'),
	(141275, 112, '2015-04-01 01:11:14.000000', 'temperatura', 998.0000, 'ºC'),
	(141276, 112, '2015-04-01 01:11:15.000000', 'temperatura', 47.0000, 'ºC'),
	(141277, 112, '2015-04-01 01:11:16.000000', 'temperatura', 845.0000, 'ºC'),
	(141278, 112, '2015-04-01 01:11:17.000000', 'temperatura', 484.0000, 'ºC'),
	(141279, 112, '2015-04-01 01:11:18.000000', 'temperatura', 1084.0000, 'ºC'),
	(141280, 112, '2015-04-01 01:11:19.000000', 'temperatura', 369.0000, 'ºC'),
	(141281, 112, '2015-04-01 01:11:20.000000', 'temperatura', 992.0000, 'ºC'),
	(141282, 112, '2015-04-01 01:11:21.000000', 'temperatura', 256.0000, 'ºC'),
	(141283, 112, '2015-04-01 01:11:22.000000', 'temperatura', 702.0000, 'ºC'),
	(141284, 112, '2015-04-01 01:11:23.000000', 'temperatura', 345.0000, 'ºC'),
	(141285, 112, '2015-04-01 01:11:24.000000', 'temperatura', 819.0000, 'ºC'),
	(141286, 112, '2015-04-01 01:11:25.000000', 'temperatura', 660.0000, 'ºC'),
	(141287, 112, '2015-04-01 01:11:26.000000', 'temperatura', 844.0000, 'ºC'),
	(141288, 112, '2015-04-01 01:11:27.000000', 'temperatura', 1042.0000, 'ºC'),
	(141289, 112, '2015-04-01 01:11:28.000000', 'temperatura', 278.0000, 'ºC'),
	(141290, 112, '2015-04-01 01:11:29.000000', 'temperatura', 663.0000, 'ºC'),
	(141291, 112, '2015-04-01 01:11:30.000000', 'temperatura', 81.0000, 'ºC'),
	(141292, 112, '2015-04-01 01:11:31.000000', 'temperatura', 819.0000, 'ºC'),
	(141293, 112, '2015-04-01 01:11:32.000000', 'temperatura', 251.0000, 'ºC'),
	(141294, 112, '2015-04-01 01:11:33.000000', 'temperatura', 0.0000, 'ºC'),
	(141295, 112, '2015-04-01 01:11:34.000000', 'temperatura', 445.0000, 'ºC'),
	(141296, 112, '2015-04-01 01:11:35.000000', 'temperatura', 1028.0000, 'ºC'),
	(141297, 112, '2015-04-01 01:11:36.000000', 'temperatura', 203.0000, 'ºC'),
	(141298, 112, '2015-04-01 01:11:37.000000', 'temperatura', 334.0000, 'ºC'),
	(141299, 112, '2015-04-01 01:11:38.000000', 'temperatura', 1062.0000, 'ºC'),
	(141300, 112, '2015-04-01 01:11:39.000000', 'temperatura', 706.0000, 'ºC'),
	(141301, 112, '2015-04-01 01:11:40.000000', 'temperatura', 345.0000, 'ºC'),
	(141302, 112, '2015-04-01 01:11:41.000000', 'temperatura', 809.0000, 'ºC'),
	(141303, 112, '2015-04-01 01:11:42.000000', 'temperatura', 609.0000, 'ºC'),
	(141304, 112, '2015-04-01 01:11:43.000000', 'temperatura', 617.0000, 'ºC'),
	(141305, 112, '2015-04-01 01:11:44.000000', 'temperatura', 60.0000, 'ºC'),
	(141306, 112, '2015-04-01 01:11:45.000000', 'temperatura', 848.0000, 'ºC'),
	(141307, 112, '2015-04-01 01:11:46.000000', 'temperatura', 460.0000, 'ºC'),
	(141308, 112, '2015-04-01 01:11:47.000000', 'temperatura', 956.0000, 'ºC'),
	(141309, 112, '2015-04-01 01:11:48.000000', 'temperatura', 1002.0000, 'ºC'),
	(141310, 112, '2015-04-01 01:11:49.000000', 'temperatura', 942.0000, 'ºC'),
	(141311, 112, '2015-04-01 01:11:50.000000', 'temperatura', 506.0000, 'ºC'),
	(141312, 112, '2015-04-01 01:11:51.000000', 'temperatura', 903.0000, 'ºC'),
	(141313, 112, '2015-04-01 01:11:52.000000', 'temperatura', 596.0000, 'ºC'),
	(141314, 112, '2015-04-01 01:11:53.000000', 'temperatura', 274.0000, 'ºC'),
	(141315, 112, '2015-04-01 01:11:54.000000', 'temperatura', 782.0000, 'ºC'),
	(141316, 112, '2015-04-01 01:11:55.000000', 'temperatura', 690.0000, 'ºC'),
	(141317, 112, '2015-04-01 01:11:56.000000', 'temperatura', 1103.0000, 'ºC'),
	(141318, 112, '2015-04-01 01:11:57.000000', 'temperatura', 1048.0000, 'ºC'),
	(141319, 112, '2015-04-01 01:11:58.000000', 'temperatura', 728.0000, 'ºC'),
	(141320, 112, '2015-04-01 01:11:59.000000', 'temperatura', 498.0000, 'ºC'),
	(141321, 112, '2015-04-01 01:12:00.000000', 'temperatura', 306.0000, 'ºC'),
	(141322, 112, '2015-04-01 01:12:01.000000', 'temperatura', 36.0000, 'ºC'),
	(141323, 112, '2015-04-01 01:12:02.000000', 'temperatura', 462.0000, 'ºC'),
	(141324, 112, '2015-04-01 01:12:03.000000', 'temperatura', 1002.0000, 'ºC'),
	(141325, 112, '2015-04-01 01:12:04.000000', 'temperatura', 25.0000, 'ºC'),
	(141326, 112, '2015-04-01 01:12:05.000000', 'temperatura', 718.0000, 'ºC'),
	(141327, 112, '2015-04-01 01:12:06.000000', 'temperatura', 1118.0000, 'ºC'),
	(141328, 112, '2015-04-01 01:12:07.000000', 'temperatura', 1034.0000, 'ºC'),
	(141329, 112, '2015-04-01 01:12:08.000000', 'temperatura', 616.0000, 'ºC'),
	(141330, 112, '2015-04-01 01:12:09.000000', 'temperatura', 1179.0000, 'ºC'),
	(141331, 112, '2015-04-01 01:12:10.000000', 'temperatura', 449.0000, 'ºC'),
	(141332, 112, '2015-04-01 01:12:11.000000', 'temperatura', 1109.0000, 'ºC'),
	(141333, 112, '2015-04-01 01:12:12.000000', 'temperatura', 597.0000, 'ºC'),
	(141334, 112, '2015-04-01 01:12:13.000000', 'temperatura', 858.0000, 'ºC'),
	(141335, 112, '2015-04-01 01:12:14.000000', 'temperatura', 101.0000, 'ºC'),
	(141336, 112, '2015-04-01 01:12:15.000000', 'temperatura', 330.0000, 'ºC'),
	(141337, 112, '2015-04-01 01:12:16.000000', 'temperatura', 150.0000, 'ºC'),
	(141338, 112, '2015-04-01 01:12:17.000000', 'temperatura', 960.0000, 'ºC'),
	(141339, 112, '2015-04-01 01:12:18.000000', 'temperatura', 749.0000, 'ºC'),
	(141340, 112, '2015-04-01 01:12:19.000000', 'temperatura', 868.0000, 'ºC'),
	(141341, 112, '2015-04-01 01:12:20.000000', 'temperatura', 891.0000, 'ºC'),
	(141342, 112, '2015-04-01 01:12:21.000000', 'temperatura', 651.0000, 'ºC'),
	(141343, 112, '2015-04-01 01:12:22.000000', 'temperatura', 585.0000, 'ºC'),
	(141344, 112, '2015-04-01 01:12:23.000000', 'temperatura', 973.0000, 'ºC'),
	(141345, 112, '2015-04-01 01:12:24.000000', 'temperatura', 710.0000, 'ºC'),
	(141346, 112, '2015-04-01 01:12:25.000000', 'temperatura', 631.0000, 'ºC'),
	(141347, 112, '2015-04-01 01:12:26.000000', 'temperatura', 1024.0000, 'ºC'),
	(141348, 112, '2015-04-01 01:12:27.000000', 'temperatura', 829.0000, 'ºC'),
	(141349, 112, '2015-04-01 01:12:28.000000', 'temperatura', 1071.0000, 'ºC'),
	(141350, 112, '2015-04-01 01:12:29.000000', 'temperatura', 471.0000, 'ºC'),
	(141351, 112, '2015-04-01 01:12:30.000000', 'temperatura', 343.0000, 'ºC'),
	(141352, 112, '2015-04-01 01:12:31.000000', 'temperatura', 303.0000, 'ºC'),
	(141353, 112, '2015-04-01 01:12:32.000000', 'temperatura', 485.0000, 'ºC'),
	(141354, 112, '2015-04-01 01:12:33.000000', 'temperatura', 318.0000, 'ºC'),
	(141355, 112, '2015-04-01 01:12:34.000000', 'temperatura', 133.0000, 'ºC'),
	(141356, 112, '2015-04-01 01:12:35.000000', 'temperatura', 912.0000, 'ºC'),
	(141357, 112, '2015-04-01 01:12:36.000000', 'temperatura', 562.0000, 'ºC'),
	(141358, 112, '2015-04-01 01:12:37.000000', 'temperatura', 73.0000, 'ºC'),
	(141359, 112, '2015-04-01 01:12:38.000000', 'temperatura', 1082.0000, 'ºC'),
	(141360, 112, '2015-04-01 01:12:39.000000', 'temperatura', 391.0000, 'ºC'),
	(141361, 112, '2015-04-01 01:12:40.000000', 'temperatura', 1108.0000, 'ºC'),
	(141362, 112, '2015-04-01 01:12:41.000000', 'temperatura', 770.0000, 'ºC'),
	(141363, 112, '2015-04-01 01:12:42.000000', 'temperatura', 524.0000, 'ºC'),
	(141364, 112, '2015-04-01 01:12:43.000000', 'temperatura', 312.0000, 'ºC'),
	(141365, 112, '2015-04-01 01:12:44.000000', 'temperatura', 1188.0000, 'ºC'),
	(141366, 112, '2015-04-01 01:12:45.000000', 'temperatura', 203.0000, 'ºC'),
	(141367, 112, '2015-04-01 01:12:46.000000', 'temperatura', 1053.0000, 'ºC'),
	(141368, 112, '2015-04-01 01:12:47.000000', 'temperatura', 1056.0000, 'ºC'),
	(141369, 112, '2015-04-01 01:12:48.000000', 'temperatura', 921.0000, 'ºC'),
	(141370, 112, '2015-04-01 01:12:49.000000', 'temperatura', 237.0000, 'ºC'),
	(141371, 112, '2015-04-01 01:12:50.000000', 'temperatura', 823.0000, 'ºC'),
	(141372, 112, '2015-04-01 01:12:51.000000', 'temperatura', 1004.0000, 'ºC'),
	(141373, 112, '2015-04-01 01:12:52.000000', 'temperatura', 153.0000, 'ºC'),
	(141374, 112, '2015-04-01 01:12:53.000000', 'temperatura', 154.0000, 'ºC'),
	(141375, 112, '2015-04-01 01:12:54.000000', 'temperatura', 311.0000, 'ºC'),
	(141376, 112, '2015-04-01 01:12:55.000000', 'temperatura', 1093.0000, 'ºC'),
	(141377, 112, '2015-04-01 01:12:56.000000', 'temperatura', 931.0000, 'ºC'),
	(141378, 112, '2015-04-01 01:12:57.000000', 'temperatura', 177.0000, 'ºC'),
	(141379, 112, '2015-04-01 01:12:58.000000', 'temperatura', 492.0000, 'ºC'),
	(141380, 112, '2015-04-01 01:12:59.000000', 'temperatura', 728.0000, 'ºC'),
	(141381, 112, '2015-04-01 01:13:00.000000', 'temperatura', 967.0000, 'ºC'),
	(141382, 112, '2015-04-01 01:13:01.000000', 'temperatura', 252.0000, 'ºC'),
	(141383, 112, '2015-04-01 01:13:02.000000', 'temperatura', 759.0000, 'ºC'),
	(141384, 112, '2015-04-01 01:13:03.000000', 'temperatura', 638.0000, 'ºC'),
	(141385, 112, '2015-04-01 01:13:04.000000', 'temperatura', 913.0000, 'ºC'),
	(141386, 112, '2015-04-01 01:13:05.000000', 'temperatura', 254.0000, 'ºC'),
	(141387, 112, '2015-04-01 01:13:06.000000', 'temperatura', 933.0000, 'ºC'),
	(141388, 112, '2015-04-01 01:13:07.000000', 'temperatura', 300.0000, 'ºC'),
	(141389, 112, '2015-04-01 01:13:08.000000', 'temperatura', 1101.0000, 'ºC'),
	(141390, 112, '2015-04-01 01:13:09.000000', 'temperatura', 1007.0000, 'ºC'),
	(141391, 112, '2015-04-01 01:13:10.000000', 'temperatura', 533.0000, 'ºC'),
	(141392, 112, '2015-04-01 01:13:11.000000', 'temperatura', 844.0000, 'ºC'),
	(141393, 112, '2015-04-01 01:13:12.000000', 'temperatura', 223.0000, 'ºC'),
	(141394, 112, '2015-04-01 01:13:13.000000', 'temperatura', 984.0000, 'ºC'),
	(141395, 112, '2015-04-01 01:13:14.000000', 'temperatura', 652.0000, 'ºC'),
	(141396, 112, '2015-04-01 01:13:15.000000', 'temperatura', 307.0000, 'ºC'),
	(141397, 112, '2015-04-01 01:13:16.000000', 'temperatura', 780.0000, 'ºC'),
	(141398, 112, '2015-04-01 01:13:17.000000', 'temperatura', 578.0000, 'ºC'),
	(141399, 112, '2015-04-01 01:13:18.000000', 'temperatura', 551.0000, 'ºC'),
	(141400, 112, '2015-04-01 01:13:19.000000', 'temperatura', 1022.0000, 'ºC'),
	(141401, 112, '2015-04-01 01:13:20.000000', 'temperatura', 1058.0000, 'ºC'),
	(141402, 112, '2015-04-01 01:13:21.000000', 'temperatura', 1022.0000, 'ºC'),
	(141403, 112, '2015-04-01 01:13:22.000000', 'temperatura', 740.0000, 'ºC'),
	(141404, 112, '2015-04-01 01:13:23.000000', 'temperatura', 632.0000, 'ºC'),
	(141405, 112, '2015-04-01 01:13:24.000000', 'temperatura', 942.0000, 'ºC'),
	(141406, 112, '2015-04-01 01:13:25.000000', 'temperatura', 415.0000, 'ºC'),
	(141407, 112, '2015-04-01 01:13:26.000000', 'temperatura', 447.0000, 'ºC'),
	(141408, 112, '2015-04-01 01:13:27.000000', 'temperatura', 992.0000, 'ºC'),
	(141409, 112, '2015-04-01 01:13:28.000000', 'temperatura', 19.0000, 'ºC'),
	(141410, 112, '2015-04-01 01:13:29.000000', 'temperatura', 719.0000, 'ºC'),
	(141411, 112, '2015-04-01 01:13:30.000000', 'temperatura', 1139.0000, 'ºC'),
	(141412, 112, '2015-04-01 01:13:31.000000', 'temperatura', 1139.0000, 'ºC'),
	(141413, 112, '2015-04-01 01:13:32.000000', 'temperatura', 1080.0000, 'ºC'),
	(141414, 112, '2015-04-01 01:13:33.000000', 'temperatura', 780.0000, 'ºC'),
	(141415, 112, '2015-04-01 01:13:34.000000', 'temperatura', 663.0000, 'ºC'),
	(141416, 112, '2015-04-01 01:13:35.000000', 'temperatura', 976.0000, 'ºC'),
	(141417, 112, '2015-04-01 01:13:36.000000', 'temperatura', 490.0000, 'ºC'),
	(141418, 112, '2015-04-01 01:13:37.000000', 'temperatura', 725.0000, 'ºC'),
	(141419, 112, '2015-04-01 01:13:38.000000', 'temperatura', 953.0000, 'ºC'),
	(141420, 112, '2015-04-01 01:13:39.000000', 'temperatura', 193.0000, 'ºC'),
	(141421, 112, '2015-04-01 01:13:40.000000', 'temperatura', 506.0000, 'ºC'),
	(141422, 112, '2015-04-01 01:13:41.000000', 'temperatura', 750.0000, 'ºC'),
	(141423, 112, '2015-04-01 01:13:42.000000', 'temperatura', 1034.0000, 'ºC'),
	(141424, 112, '2015-04-01 01:13:43.000000', 'temperatura', 520.0000, 'ºC'),
	(141425, 112, '2015-04-01 01:13:44.000000', 'temperatura', 697.0000, 'ºC'),
	(141426, 112, '2015-04-01 01:13:45.000000', 'temperatura', 726.0000, 'ºC'),
	(141427, 112, '2015-04-01 01:13:46.000000', 'temperatura', 339.0000, 'ºC'),
	(141428, 112, '2015-04-01 01:13:47.000000', 'temperatura', 719.0000, 'ºC'),
	(141429, 112, '2015-04-01 01:13:48.000000', 'temperatura', 177.0000, 'ºC'),
	(141430, 112, '2015-04-01 01:13:49.000000', 'temperatura', 1127.0000, 'ºC'),
	(141431, 112, '2015-04-01 01:13:50.000000', 'temperatura', 308.0000, 'ºC'),
	(141432, 112, '2015-04-01 01:13:51.000000', 'temperatura', 557.0000, 'ºC'),
	(141433, 112, '2015-04-01 01:13:52.000000', 'temperatura', 663.0000, 'ºC'),
	(141434, 112, '2015-04-01 01:13:53.000000', 'temperatura', 445.0000, 'ºC'),
	(141435, 112, '2015-04-01 01:13:54.000000', 'temperatura', 234.0000, 'ºC'),
	(141436, 112, '2015-04-01 01:13:55.000000', 'temperatura', 1037.0000, 'ºC'),
	(141437, 112, '2015-04-01 01:13:56.000000', 'temperatura', 883.0000, 'ºC'),
	(141438, 112, '2015-04-01 01:13:57.000000', 'temperatura', 104.0000, 'ºC'),
	(141439, 112, '2015-04-01 01:13:58.000000', 'temperatura', 274.0000, 'ºC'),
	(141440, 112, '2015-04-01 01:13:59.000000', 'temperatura', 1055.0000, 'ºC'),
	(141441, 112, '2015-04-01 01:14:00.000000', 'temperatura', 856.0000, 'ºC'),
	(141442, 112, '2015-04-01 01:14:01.000000', 'temperatura', 1117.0000, 'ºC'),
	(141443, 112, '2015-04-01 01:14:02.000000', 'temperatura', 616.0000, 'ºC'),
	(141444, 112, '2015-04-01 01:14:03.000000', 'temperatura', 928.0000, 'ºC'),
	(141445, 112, '2015-04-01 01:14:04.000000', 'temperatura', 391.0000, 'ºC'),
	(141446, 112, '2015-04-01 01:14:05.000000', 'temperatura', 375.0000, 'ºC'),
	(141447, 112, '2015-04-01 01:14:06.000000', 'temperatura', 703.0000, 'ºC'),
	(141448, 112, '2015-04-01 01:14:07.000000', 'temperatura', 1188.0000, 'ºC'),
	(141449, 112, '2015-04-01 01:14:08.000000', 'temperatura', 233.0000, 'ºC'),
	(141450, 112, '2015-04-01 01:14:09.000000', 'temperatura', 3.0000, 'ºC'),
	(141451, 112, '2015-04-01 01:14:10.000000', 'temperatura', 515.0000, 'ºC'),
	(141452, 112, '2015-04-01 01:14:11.000000', 'temperatura', 166.0000, 'ºC'),
	(141453, 112, '2015-04-01 01:14:12.000000', 'temperatura', 484.0000, 'ºC'),
	(141454, 112, '2015-04-01 01:14:13.000000', 'temperatura', 724.0000, 'ºC'),
	(141455, 112, '2015-04-01 01:14:14.000000', 'temperatura', 970.0000, 'ºC'),
	(141456, 112, '2015-04-01 01:14:15.000000', 'temperatura', 276.0000, 'ºC'),
	(141457, 112, '2015-04-01 01:14:16.000000', 'temperatura', 872.0000, 'ºC'),
	(141458, 112, '2015-04-01 01:14:17.000000', 'temperatura', 1131.0000, 'ºC'),
	(141459, 112, '2015-04-01 01:14:18.000000', 'temperatura', 639.0000, 'ºC'),
	(141460, 112, '2015-04-01 01:14:19.000000', 'temperatura', 1004.0000, 'ºC'),
	(141461, 112, '2015-04-01 01:14:20.000000', 'temperatura', 703.0000, 'ºC'),
	(141462, 112, '2015-04-01 01:14:21.000000', 'temperatura', 505.0000, 'ºC'),
	(141463, 112, '2015-04-01 01:14:22.000000', 'temperatura', 415.0000, 'ºC'),
	(141464, 112, '2015-04-01 01:14:23.000000', 'temperatura', 559.0000, 'ºC'),
	(141465, 112, '2015-04-01 01:14:24.000000', 'temperatura', 353.0000, 'ºC'),
	(141466, 112, '2015-04-01 01:14:25.000000', 'temperatura', 86.0000, 'ºC'),
	(141467, 112, '2015-04-01 01:14:26.000000', 'temperatura', 572.0000, 'ºC'),
	(141468, 112, '2015-04-01 01:14:27.000000', 'temperatura', 204.0000, 'ºC'),
	(141469, 112, '2015-04-01 01:14:28.000000', 'temperatura', 503.0000, 'ºC'),
	(141470, 112, '2015-04-01 01:14:29.000000', 'temperatura', 704.0000, 'ºC'),
	(141471, 112, '2015-04-01 01:14:30.000000', 'temperatura', 812.0000, 'ºC'),
	(141472, 112, '2015-04-01 01:14:31.000000', 'temperatura', 749.0000, 'ºC'),
	(141473, 112, '2015-04-01 01:14:32.000000', 'temperatura', 108.0000, 'ºC'),
	(141474, 112, '2015-04-01 01:14:33.000000', 'temperatura', 694.0000, 'ºC'),
	(141475, 112, '2015-04-01 01:14:34.000000', 'temperatura', 748.0000, 'ºC'),
	(141476, 112, '2015-04-01 01:14:35.000000', 'temperatura', 459.0000, 'ºC'),
	(141477, 112, '2015-04-01 01:14:36.000000', 'temperatura', 51.0000, 'ºC'),
	(141478, 112, '2015-04-01 01:14:37.000000', 'temperatura', 79.0000, 'ºC'),
	(141479, 112, '2015-04-01 01:14:38.000000', 'temperatura', 241.0000, 'ºC'),
	(141480, 112, '2015-04-01 01:14:39.000000', 'temperatura', 967.0000, 'ºC'),
	(141481, 112, '2015-04-01 01:14:40.000000', 'temperatura', 515.0000, 'ºC'),
	(141482, 112, '2015-04-01 01:14:41.000000', 'temperatura', 874.0000, 'ºC'),
	(141483, 112, '2015-04-01 01:14:42.000000', 'temperatura', 425.0000, 'ºC'),
	(141484, 112, '2015-04-01 01:14:43.000000', 'temperatura', 702.0000, 'ºC'),
	(141485, 112, '2015-04-01 01:14:44.000000', 'temperatura', 1039.0000, 'ºC'),
	(141486, 112, '2015-04-01 01:14:45.000000', 'temperatura', 686.0000, 'ºC'),
	(141487, 112, '2015-04-01 01:14:46.000000', 'temperatura', 315.0000, 'ºC'),
	(141488, 112, '2015-04-01 01:14:47.000000', 'temperatura', 717.0000, 'ºC'),
	(141489, 112, '2015-04-01 01:14:48.000000', 'temperatura', 241.0000, 'ºC'),
	(141490, 112, '2015-04-01 01:14:49.000000', 'temperatura', 253.0000, 'ºC'),
	(141491, 112, '2015-04-01 01:14:50.000000', 'temperatura', 542.0000, 'ºC'),
	(141492, 112, '2015-04-01 01:14:51.000000', 'temperatura', 753.0000, 'ºC'),
	(141493, 112, '2015-04-01 01:14:52.000000', 'temperatura', 941.0000, 'ºC'),
	(141494, 112, '2015-04-01 01:14:53.000000', 'temperatura', 44.0000, 'ºC'),
	(141495, 112, '2015-04-01 01:14:54.000000', 'temperatura', 998.0000, 'ºC'),
	(141496, 112, '2015-04-01 01:14:55.000000', 'temperatura', 58.0000, 'ºC'),
	(141497, 112, '2015-04-01 01:14:56.000000', 'temperatura', 896.0000, 'ºC'),
	(141498, 112, '2015-04-01 01:14:57.000000', 'temperatura', 708.0000, 'ºC'),
	(141499, 112, '2015-04-01 01:14:58.000000', 'temperatura', 851.0000, 'ºC'),
	(141500, 112, '2015-04-01 01:14:59.000000', 'temperatura', 933.0000, 'ºC'),
	(141501, 112, '2015-04-01 01:15:00.000000', 'temperatura', 910.0000, 'ºC'),
	(141502, 112, '2015-04-01 01:15:01.000000', 'temperatura', 553.0000, 'ºC'),
	(141503, 112, '2015-04-01 01:15:02.000000', 'temperatura', 34.0000, 'ºC'),
	(141504, 112, '2015-04-01 01:15:03.000000', 'temperatura', 912.0000, 'ºC'),
	(141505, 112, '2015-04-01 01:15:04.000000', 'temperatura', 859.0000, 'ºC'),
	(141506, 112, '2015-04-01 01:15:05.000000', 'temperatura', 359.0000, 'ºC'),
	(141507, 112, '2015-04-01 01:15:06.000000', 'temperatura', 419.0000, 'ºC'),
	(141508, 112, '2015-04-01 01:15:07.000000', 'temperatura', 1017.0000, 'ºC'),
	(141509, 112, '2015-04-01 01:15:08.000000', 'temperatura', 230.0000, 'ºC'),
	(141510, 112, '2015-04-01 01:15:09.000000', 'temperatura', 498.0000, 'ºC'),
	(141511, 112, '2015-04-01 01:15:10.000000', 'temperatura', 603.0000, 'ºC'),
	(141512, 112, '2015-04-01 01:15:11.000000', 'temperatura', 321.0000, 'ºC'),
	(141513, 112, '2015-04-01 01:15:12.000000', 'temperatura', 994.0000, 'ºC'),
	(141514, 112, '2015-04-01 01:15:13.000000', 'temperatura', 410.0000, 'ºC'),
	(141515, 112, '2015-04-01 01:15:14.000000', 'temperatura', 268.0000, 'ºC'),
	(141516, 112, '2015-04-01 01:15:15.000000', 'temperatura', 109.0000, 'ºC'),
	(141517, 112, '2015-04-01 01:15:16.000000', 'temperatura', 943.0000, 'ºC'),
	(141518, 112, '2015-04-01 01:15:17.000000', 'temperatura', 789.0000, 'ºC'),
	(141519, 112, '2015-04-01 01:15:18.000000', 'temperatura', 1117.0000, 'ºC'),
	(141520, 112, '2015-04-01 01:15:19.000000', 'temperatura', 817.0000, 'ºC'),
	(141521, 112, '2015-04-01 01:15:20.000000', 'temperatura', 736.0000, 'ºC'),
	(141522, 112, '2015-04-01 01:15:21.000000', 'temperatura', 28.0000, 'ºC'),
	(141523, 112, '2015-04-01 01:15:22.000000', 'temperatura', 334.0000, 'ºC'),
	(141524, 112, '2015-04-01 01:15:23.000000', 'temperatura', 388.0000, 'ºC'),
	(141525, 112, '2015-04-01 01:15:24.000000', 'temperatura', 936.0000, 'ºC'),
	(141526, 112, '2015-04-01 01:15:25.000000', 'temperatura', 1118.0000, 'ºC'),
	(141527, 112, '2015-04-01 01:15:26.000000', 'temperatura', 381.0000, 'ºC'),
	(141528, 112, '2015-04-01 01:15:27.000000', 'temperatura', 950.0000, 'ºC'),
	(141529, 112, '2015-04-01 01:15:28.000000', 'temperatura', 10.0000, 'ºC'),
	(141530, 112, '2015-04-01 01:15:29.000000', 'temperatura', 799.0000, 'ºC'),
	(141531, 112, '2015-04-01 01:15:30.000000', 'temperatura', 364.0000, 'ºC'),
	(141532, 112, '2015-04-01 01:15:31.000000', 'temperatura', 626.0000, 'ºC'),
	(141533, 112, '2015-04-01 01:15:32.000000', 'temperatura', 839.0000, 'ºC'),
	(141534, 112, '2015-04-01 01:15:33.000000', 'temperatura', 1116.0000, 'ºC'),
	(141535, 112, '2015-04-01 01:15:34.000000', 'temperatura', 666.0000, 'ºC'),
	(141536, 112, '2015-04-01 01:15:35.000000', 'temperatura', 1181.0000, 'ºC'),
	(141537, 112, '2015-04-01 01:15:36.000000', 'temperatura', 307.0000, 'ºC'),
	(141538, 112, '2015-04-01 01:15:37.000000', 'temperatura', 393.0000, 'ºC'),
	(141539, 112, '2015-04-01 01:15:38.000000', 'temperatura', 1044.0000, 'ºC'),
	(141540, 112, '2015-04-01 01:15:39.000000', 'temperatura', 440.0000, 'ºC'),
	(141541, 112, '2015-04-01 01:15:40.000000', 'temperatura', 268.0000, 'ºC'),
	(141542, 112, '2015-04-01 01:15:41.000000', 'temperatura', 23.0000, 'ºC'),
	(141543, 112, '2015-04-01 01:15:42.000000', 'temperatura', 511.0000, 'ºC'),
	(141544, 112, '2015-04-01 01:15:43.000000', 'temperatura', 85.0000, 'ºC'),
	(141545, 112, '2015-04-01 01:15:44.000000', 'temperatura', 95.0000, 'ºC'),
	(141546, 112, '2015-04-01 01:15:45.000000', 'temperatura', 219.0000, 'ºC'),
	(141547, 112, '2015-04-01 01:15:46.000000', 'temperatura', 810.0000, 'ºC'),
	(141548, 112, '2015-04-01 01:15:47.000000', 'temperatura', 995.0000, 'ºC'),
	(141549, 112, '2015-04-01 01:15:48.000000', 'temperatura', 145.0000, 'ºC'),
	(141550, 112, '2015-04-01 01:15:49.000000', 'temperatura', 141.0000, 'ºC'),
	(141551, 112, '2015-04-01 01:15:50.000000', 'temperatura', 272.0000, 'ºC'),
	(141552, 112, '2015-04-01 01:15:51.000000', 'temperatura', 937.0000, 'ºC'),
	(141553, 112, '2015-04-01 01:15:52.000000', 'temperatura', 269.0000, 'ºC'),
	(141554, 112, '2015-04-01 01:15:53.000000', 'temperatura', 934.0000, 'ºC'),
	(141555, 112, '2015-04-01 01:15:54.000000', 'temperatura', 266.0000, 'ºC'),
	(141556, 112, '2015-04-01 01:15:55.000000', 'temperatura', 927.0000, 'ºC'),
	(141557, 112, '2015-04-01 01:15:56.000000', 'temperatura', 236.0000, 'ºC'),
	(141558, 112, '2015-04-01 01:15:57.000000', 'temperatura', 799.0000, 'ºC'),
	(141559, 112, '2015-04-01 01:15:58.000000', 'temperatura', 890.0000, 'ºC'),
	(141560, 112, '2015-04-01 01:15:59.000000', 'temperatura', 851.0000, 'ºC'),
	(141561, 112, '2015-04-01 01:16:00.000000', 'temperatura', 386.0000, 'ºC'),
	(141562, 112, '2015-04-01 01:16:01.000000', 'temperatura', 578.0000, 'ºC'),
	(141563, 112, '2015-04-01 01:16:02.000000', 'temperatura', 534.0000, 'ºC'),
	(141564, 112, '2015-04-01 01:16:03.000000', 'temperatura', 936.0000, 'ºC'),
	(141565, 112, '2015-04-01 01:16:04.000000', 'temperatura', 679.0000, 'ºC'),
	(141566, 112, '2015-04-01 01:16:05.000000', 'temperatura', 588.0000, 'ºC'),
	(141567, 112, '2015-04-01 01:16:06.000000', 'temperatura', 903.0000, 'ºC'),
	(141568, 112, '2015-04-01 01:16:07.000000', 'temperatura', 350.0000, 'ºC'),
	(141569, 112, '2015-04-01 01:16:08.000000', 'temperatura', 241.0000, 'ºC'),
	(141570, 112, '2015-04-01 01:16:09.000000', 'temperatura', 158.0000, 'ºC'),
	(141571, 112, '2015-04-01 01:16:10.000000', 'temperatura', 68.0000, 'ºC'),
	(141572, 112, '2015-04-01 01:16:11.000000', 'temperatura', 1064.0000, 'ºC'),
	(141573, 112, '2015-04-01 01:16:12.000000', 'temperatura', 315.0000, 'ºC'),
	(141574, 112, '2015-04-01 01:16:13.000000', 'temperatura', 787.0000, 'ºC'),
	(141575, 112, '2015-04-01 01:16:14.000000', 'temperatura', 590.0000, 'ºC'),
	(141576, 112, '2015-04-01 01:16:15.000000', 'temperatura', 590.0000, 'ºC'),
	(141577, 112, '2015-04-01 01:16:16.000000', 'temperatura', 1178.0000, 'ºC'),
	(141578, 112, '2015-04-01 01:16:17.000000', 'temperatura', 524.0000, 'ºC'),
	(141579, 112, '2015-04-01 01:16:18.000000', 'temperatura', 284.0000, 'ºC'),
	(141580, 112, '2015-04-01 01:16:19.000000', 'temperatura', 1051.0000, 'ºC'),
	(141581, 112, '2015-04-01 01:16:20.000000', 'temperatura', 803.0000, 'ºC'),
	(141582, 112, '2015-04-01 01:16:21.000000', 'temperatura', 862.0000, 'ºC'),
	(141583, 112, '2015-04-01 01:16:22.000000', 'temperatura', 703.0000, 'ºC'),
	(141584, 112, '2015-04-01 01:16:23.000000', 'temperatura', 927.0000, 'ºC'),
	(141585, 112, '2015-04-01 01:16:24.000000', 'temperatura', 127.0000, 'ºC'),
	(141586, 112, '2015-04-01 01:16:25.000000', 'temperatura', 256.0000, 'ºC'),
	(141587, 112, '2015-04-01 01:16:26.000000', 'temperatura', 901.0000, 'ºC'),
	(141588, 112, '2015-04-01 01:16:27.000000', 'temperatura', 135.0000, 'ºC'),
	(141589, 112, '2015-04-01 01:16:28.000000', 'temperatura', 373.0000, 'ºC'),
	(141590, 112, '2015-04-01 01:16:29.000000', 'temperatura', 263.0000, 'ºC'),
	(141591, 112, '2015-04-01 01:16:30.000000', 'temperatura', 193.0000, 'ºC'),
	(141592, 112, '2015-04-01 01:16:31.000000', 'temperatura', 179.0000, 'ºC'),
	(141593, 112, '2015-04-01 01:16:32.000000', 'temperatura', 315.0000, 'ºC'),
	(141594, 112, '2015-04-01 01:16:33.000000', 'temperatura', 1041.0000, 'ºC'),
	(141595, 112, '2015-04-01 01:16:34.000000', 'temperatura', 658.0000, 'ºC'),
	(141596, 112, '2015-04-01 01:16:35.000000', 'temperatura', 167.0000, 'ºC'),
	(141597, 112, '2015-04-01 01:16:36.000000', 'temperatura', 63.0000, 'ºC'),
	(141598, 112, '2015-04-01 01:16:37.000000', 'temperatura', 1016.0000, 'ºC'),
	(141599, 112, '2015-04-01 01:16:38.000000', 'temperatura', 88.0000, 'ºC'),
	(141600, 112, '2015-04-01 01:16:39.000000', 'temperatura', 995.0000, 'ºC'),
	(141601, 112, '2015-04-01 01:16:40.000000', 'temperatura', 1111.0000, 'ºC'),
	(141602, 112, '2015-04-01 01:16:41.000000', 'temperatura', 172.0000, 'ºC'),
	(141603, 112, '2015-04-01 01:16:42.000000', 'temperatura', 1127.0000, 'ºC'),
	(141604, 112, '2015-04-01 01:16:43.000000', 'temperatura', 320.0000, 'ºC'),
	(141605, 112, '2015-04-01 01:16:44.000000', 'temperatura', 620.0000, 'ºC'),
	(141606, 112, '2015-04-01 01:16:45.000000', 'temperatura', 938.0000, 'ºC'),
	(141607, 112, '2015-04-01 01:16:46.000000', 'temperatura', 434.0000, 'ºC'),
	(141608, 112, '2015-04-01 01:16:47.000000', 'temperatura', 554.0000, 'ºC'),
	(141609, 112, '2015-04-01 01:16:48.000000', 'temperatura', 269.0000, 'ºC'),
	(141610, 112, '2015-04-01 01:16:49.000000', 'temperatura', 885.0000, 'ºC'),
	(141611, 112, '2015-04-01 01:16:50.000000', 'temperatura', 18.0000, 'ºC'),
	(141612, 112, '2015-04-01 01:16:51.000000', 'temperatura', 1037.0000, 'ºC'),
	(141613, 112, '2015-04-01 01:16:52.000000', 'temperatura', 330.0000, 'ºC'),
	(141614, 112, '2015-04-01 01:16:53.000000', 'temperatura', 939.0000, 'ºC'),
	(141615, 112, '2015-04-01 01:16:54.000000', 'temperatura', 104.0000, 'ºC'),
	(141616, 112, '2015-04-01 01:16:55.000000', 'temperatura', 106.0000, 'ºC'),
	(141617, 112, '2015-04-01 01:16:56.000000', 'temperatura', 218.0000, 'ºC'),
	(141618, 112, '2015-04-01 01:16:57.000000', 'temperatura', 774.0000, 'ºC'),
	(141619, 112, '2015-04-01 01:16:58.000000', 'temperatura', 816.0000, 'ºC'),
	(141620, 112, '2015-04-01 01:16:59.000000', 'temperatura', 559.0000, 'ºC'),
	(141621, 112, '2015-04-01 01:17:00.000000', 'temperatura', 348.0000, 'ºC'),
	(141622, 112, '2015-04-01 01:17:01.000000', 'temperatura', 62.0000, 'ºC'),
	(141623, 112, '2015-04-01 01:17:02.000000', 'temperatura', 469.0000, 'ºC'),
	(141624, 112, '2015-04-01 01:17:03.000000', 'temperatura', 957.0000, 'ºC'),
	(141625, 112, '2015-04-01 01:17:04.000000', 'temperatura', 980.0000, 'ºC'),
	(141626, 112, '2015-04-01 01:17:05.000000', 'temperatura', 828.0000, 'ºC'),
	(141627, 112, '2015-04-01 01:17:06.000000', 'temperatura', 0.0000, 'ºC'),
	(141628, 112, '2015-04-01 01:17:07.000000', 'temperatura', 1116.0000, 'ºC'),
	(141629, 112, '2015-04-01 01:17:08.000000', 'temperatura', 781.0000, 'ºC'),
	(141630, 112, '2015-04-01 01:17:09.000000', 'temperatura', 556.0000, 'ºC'),
	(141631, 112, '2015-04-01 01:17:10.000000', 'temperatura', 437.0000, 'ºC'),
	(141632, 112, '2015-04-01 01:17:11.000000', 'temperatura', 521.0000, 'ºC'),
	(141633, 112, '2015-04-01 01:17:12.000000', 'temperatura', 92.0000, 'ºC'),
	(141634, 112, '2015-04-01 01:17:13.000000', 'temperatura', 98.0000, 'ºC'),
	(141635, 112, '2015-04-01 01:17:14.000000', 'temperatura', 215.0000, 'ºC'),
	(141636, 112, '2015-04-01 01:17:15.000000', 'temperatura', 782.0000, 'ºC'),
	(141637, 112, '2015-04-01 01:17:16.000000', 'temperatura', 863.0000, 'ºC'),
	(141638, 112, '2015-04-01 01:17:17.000000', 'temperatura', 771.0000, 'ºC'),
	(141639, 112, '2015-04-01 01:17:18.000000', 'temperatura', 65.0000, 'ºC'),
	(141640, 112, '2015-04-01 01:17:19.000000', 'temperatura', 414.0000, 'ºC'),
	(141641, 112, '2015-04-01 01:17:20.000000', 'temperatura', 677.0000, 'ºC'),
	(141642, 112, '2015-04-01 01:17:21.000000', 'temperatura', 943.0000, 'ºC'),
	(141643, 112, '2015-04-01 01:17:22.000000', 'temperatura', 283.0000, 'ºC'),
	(141644, 112, '2015-04-01 01:17:23.000000', 'temperatura', 987.0000, 'ºC'),
	(141645, 112, '2015-04-01 01:17:24.000000', 'temperatura', 488.0000, 'ºC'),
	(141646, 112, '2015-04-01 01:17:25.000000', 'temperatura', 680.0000, 'ºC'),
	(141647, 112, '2015-04-01 01:17:26.000000', 'temperatura', 736.0000, 'ºC'),
	(141648, 112, '2015-04-01 01:17:27.000000', 'temperatura', 440.0000, 'ºC'),
	(141649, 112, '2015-04-01 01:17:28.000000', 'temperatura', 1194.0000, 'ºC'),
	(141650, 112, '2015-04-01 01:17:29.000000', 'temperatura', 1048.0000, 'ºC'),
	(141651, 112, '2015-04-01 01:17:30.000000', 'temperatura', 460.0000, 'ºC'),
	(141652, 112, '2015-04-01 01:17:31.000000', 'temperatura', 354.0000, 'ºC'),
	(141653, 112, '2015-04-01 01:17:32.000000', 'temperatura', 394.0000, 'ºC'),
	(141654, 112, '2015-04-01 01:17:33.000000', 'temperatura', 907.0000, 'ºC'),
	(141655, 112, '2015-04-01 01:17:34.000000', 'temperatura', 953.0000, 'ºC'),
	(141656, 112, '2015-04-01 01:17:35.000000', 'temperatura', 845.0000, 'ºC'),
	(141657, 112, '2015-04-01 01:17:36.000000', 'temperatura', 165.0000, 'ºC'),
	(141658, 112, '2015-04-01 01:17:37.000000', 'temperatura', 693.0000, 'ºC'),
	(141659, 112, '2015-04-01 01:17:38.000000', 'temperatura', 568.0000, 'ºC'),
	(141660, 112, '2015-04-01 01:17:39.000000', 'temperatura', 764.0000, 'ºC'),
	(141661, 112, '2015-04-01 01:17:40.000000', 'temperatura', 915.0000, 'ºC'),
	(141662, 112, '2015-04-01 01:17:41.000000', 'temperatura', 1082.0000, 'ºC'),
	(141663, 112, '2015-04-01 01:17:42.000000', 'temperatura', 268.0000, 'ºC'),
	(141664, 112, '2015-04-01 01:17:43.000000', 'temperatura', 492.0000, 'ºC'),
	(141665, 112, '2015-04-01 01:17:44.000000', 'temperatura', 458.0000, 'ºC'),
	(141666, 112, '2015-04-01 01:17:45.000000', 'temperatura', 814.0000, 'ºC'),
	(141667, 112, '2015-04-01 01:17:46.000000', 'temperatura', 297.0000, 'ºC'),
	(141668, 112, '2015-04-01 01:17:47.000000', 'temperatura', 242.0000, 'ºC'),
	(141669, 112, '2015-04-01 01:17:48.000000', 'temperatura', 319.0000, 'ºC'),
	(141670, 112, '2015-04-01 01:17:49.000000', 'temperatura', 873.0000, 'ºC'),
	(141671, 112, '2015-04-01 01:17:50.000000', 'temperatura', 1005.0000, 'ºC'),
	(141672, 112, '2015-04-01 01:17:51.000000', 'temperatura', 7.0000, 'ºC'),
	(141673, 112, '2015-04-01 01:17:52.000000', 'temperatura', 619.0000, 'ºC'),
	(141674, 112, '2015-04-01 01:17:53.000000', 'temperatura', 677.0000, 'ºC'),
	(141675, 112, '2015-04-01 01:17:54.000000', 'temperatura', 327.0000, 'ºC'),
	(141676, 112, '2015-04-01 01:17:55.000000', 'temperatura', 807.0000, 'ºC'),
	(141677, 112, '2015-04-01 01:17:56.000000', 'temperatura', 652.0000, 'ºC'),
	(141678, 112, '2015-04-01 01:17:57.000000', 'temperatura', 840.0000, 'ºC'),
	(141679, 112, '2015-04-01 01:17:58.000000', 'temperatura', 1045.0000, 'ºC'),
	(141680, 112, '2015-04-01 01:17:59.000000', 'temperatura', 305.0000, 'ºC'),
	(141681, 112, '2015-04-01 01:18:00.000000', 'temperatura', 789.0000, 'ºC'),
	(141682, 112, '2015-04-01 01:18:01.000000', 'temperatura', 632.0000, 'ºC'),
	(141683, 112, '2015-04-01 01:18:02.000000', 'temperatura', 792.0000, 'ºC'),
	(141684, 112, '2015-04-01 01:18:03.000000', 'temperatura', 865.0000, 'ºC'),
	(141685, 112, '2015-04-01 01:18:04.000000', 'temperatura', 752.0000, 'ºC'),
	(141686, 112, '2015-04-01 01:18:05.000000', 'temperatura', 1162.0000, 'ºC'),
	(141687, 112, '2015-04-01 01:18:06.000000', 'temperatura', 1156.0000, 'ºC'),
	(141688, 112, '2015-04-01 01:18:07.000000', 'temperatura', 1095.0000, 'ºC'),
	(141689, 112, '2015-04-01 01:18:08.000000', 'temperatura', 808.0000, 'ºC'),
	(141690, 112, '2015-04-01 01:18:09.000000', 'temperatura', 756.0000, 'ºC'),
	(141691, 112, '2015-04-01 01:18:10.000000', 'temperatura', 158.0000, 'ºC'),
	(141692, 112, '2015-04-01 01:18:11.000000', 'temperatura', 919.0000, 'ºC'),
	(141693, 112, '2015-04-01 01:18:12.000000', 'temperatura', 523.0000, 'ºC'),
	(141694, 112, '2015-04-01 01:18:13.000000', 'temperatura', 1058.0000, 'ºC'),
	(141695, 112, '2015-04-01 01:18:14.000000', 'temperatura', 123.0000, 'ºC'),
	(141696, 112, '2015-04-01 01:18:15.000000', 'temperatura', 1042.0000, 'ºC'),
	(141697, 112, '2015-04-01 01:18:16.000000', 'temperatura', 39.0000, 'ºC'),
	(141698, 112, '2015-04-01 01:18:17.000000', 'temperatura', 672.0000, 'ºC'),
	(141699, 112, '2015-04-01 01:18:18.000000', 'temperatura', 841.0000, 'ºC'),
	(141700, 112, '2015-04-01 01:18:19.000000', 'temperatura', 991.0000, 'ºC'),
	(141701, 112, '2015-04-01 01:18:20.000000', 'temperatura', 31.0000, 'ºC'),
	(141702, 112, '2015-04-01 01:18:21.000000', 'temperatura', 784.0000, 'ºC'),
	(141703, 112, '2015-04-01 01:18:22.000000', 'temperatura', 228.0000, 'ºC'),
	(141704, 112, '2015-04-01 01:18:23.000000', 'temperatura', 1188.0000, 'ºC'),
	(141705, 112, '2015-04-01 01:18:24.000000', 'temperatura', 455.0000, 'ºC'),
	(141706, 112, '2015-04-01 01:18:25.000000', 'temperatura', 1113.0000, 'ºC'),
	(141707, 112, '2015-04-01 01:18:26.000000', 'temperatura', 598.0000, 'ºC'),
	(141708, 112, '2015-04-01 01:18:27.000000', 'temperatura', 854.0000, 'ºC'),
	(141709, 112, '2015-04-01 01:18:28.000000', 'temperatura', 76.0000, 'ºC'),
	(141710, 112, '2015-04-01 01:18:29.000000', 'temperatura', 217.0000, 'ºC'),
	(141711, 112, '2015-04-01 01:18:30.000000', 'temperatura', 858.0000, 'ºC'),
	(141712, 112, '2015-04-01 01:18:31.000000', 'temperatura', 39.0000, 'ºC'),
	(141713, 112, '2015-04-01 01:18:32.000000', 'temperatura', 21.0000, 'ºC'),
	(141714, 112, '2015-04-01 01:18:33.000000', 'temperatura', 1189.0000, 'ºC'),
	(141715, 112, '2015-04-01 01:18:34.000000', 'temperatura', 1084.0000, 'ºC'),
	(141716, 112, '2015-04-01 01:18:35.000000', 'temperatura', 654.0000, 'ºC'),
	(141717, 112, '2015-04-01 01:18:36.000000', 'temperatura', 17.0000, 'ºC'),
	(141718, 112, '2015-04-01 01:18:37.000000', 'temperatura', 524.0000, 'ºC'),
	(141719, 112, '2015-04-01 01:18:38.000000', 'temperatura', 170.0000, 'ºC'),
	(141720, 112, '2015-04-01 01:18:39.000000', 'temperatura', 478.0000, 'ºC'),
	(141721, 112, '2015-04-01 01:18:40.000000', 'temperatura', 681.0000, 'ºC'),
	(141722, 112, '2015-04-01 01:18:41.000000', 'temperatura', 770.0000, 'ºC'),
	(141723, 112, '2015-04-01 01:18:42.000000', 'temperatura', 608.0000, 'ºC'),
	(141724, 112, '2015-04-01 01:18:43.000000', 'temperatura', 731.0000, 'ºC'),
	(141725, 112, '2015-04-01 01:18:44.000000', 'temperatura', 633.0000, 'ºC'),
	(141726, 112, '2015-04-01 01:18:45.000000', 'temperatura', 973.0000, 'ºC'),
	(141727, 112, '2015-04-01 01:18:46.000000', 'temperatura', 565.0000, 'ºC'),
	(141728, 112, '2015-04-01 01:18:47.000000', 'temperatura', 1107.0000, 'ºC'),
	(141729, 112, '2015-04-01 01:18:48.000000', 'temperatura', 242.0000, 'ºC'),
	(141730, 112, '2015-04-01 01:18:49.000000', 'temperatura', 289.0000, 'ºC'),
	(141731, 112, '2015-04-01 01:18:50.000000', 'temperatura', 720.0000, 'ºC'),
	(141732, 112, '2015-04-01 01:18:51.000000', 'temperatura', 333.0000, 'ºC'),
	(141733, 112, '2015-04-01 01:18:52.000000', 'temperatura', 706.0000, 'ºC'),
	(141734, 112, '2015-04-01 01:18:53.000000', 'temperatura', 129.0000, 'ºC'),
	(141735, 112, '2015-04-01 01:18:54.000000', 'temperatura', 931.0000, 'ºC'),
	(141736, 112, '2015-04-01 01:18:55.000000', 'temperatura', 665.0000, 'ºC'),
	(141737, 112, '2015-04-01 01:18:56.000000', 'temperatura', 535.0000, 'ºC'),
	(141738, 112, '2015-04-01 01:18:57.000000', 'temperatura', 678.0000, 'ºC'),
	(141739, 112, '2015-04-01 01:18:58.000000', 'temperatura', 586.0000, 'ºC'),
	(141740, 112, '2015-04-01 01:18:59.000000', 'temperatura', 896.0000, 'ºC'),
	(141741, 112, '2015-04-01 01:19:00.000000', 'temperatura', 323.0000, 'ºC'),
	(141742, 112, '2015-04-01 01:19:01.000000', 'temperatura', 127.0000, 'ºC'),
	(141743, 112, '2015-04-01 01:19:02.000000', 'temperatura', 866.0000, 'ºC'),
	(141744, 112, '2015-04-01 01:19:03.000000', 'temperatura', 348.0000, 'ºC'),
	(141745, 112, '2015-04-01 01:19:04.000000', 'temperatura', 344.0000, 'ºC'),
	(141746, 112, '2015-04-01 01:19:05.000000', 'temperatura', 677.0000, 'ºC'),
	(141747, 112, '2015-04-01 01:19:06.000000', 'temperatura', 1152.0000, 'ºC'),
	(141748, 112, '2015-04-01 01:19:07.000000', 'temperatura', 131.0000, 'ºC'),
	(141749, 112, '2015-04-01 01:19:08.000000', 'temperatura', 800.0000, 'ºC'),
	(141750, 112, '2015-04-01 01:19:09.000000', 'temperatura', 7.0000, 'ºC'),
	(141751, 112, '2015-04-01 01:19:10.000000', 'temperatura', 36.0000, 'ºC'),
	(141752, 112, '2015-04-01 01:19:11.000000', 'temperatura', 161.0000, 'ºC'),
	(141753, 112, '2015-04-01 01:19:12.000000', 'temperatura', 695.0000, 'ºC'),
	(141754, 112, '2015-04-01 01:19:13.000000', 'temperatura', 592.0000, 'ºC'),
	(141755, 112, '2015-04-01 01:19:14.000000', 'temperatura', 878.0000, 'ºC'),
	(141756, 112, '2015-04-01 01:19:15.000000', 'temperatura', 216.0000, 'ºC'),
	(141757, 112, '2015-04-01 01:19:16.000000', 'temperatura', 843.0000, 'ºC'),
	(141758, 112, '2015-04-01 01:19:17.000000', 'temperatura', 1167.0000, 'ºC'),
	(141759, 112, '2015-04-01 01:19:18.000000', 'temperatura', 907.0000, 'ºC'),
	(141760, 112, '2015-04-01 01:19:19.000000', 'temperatura', 1036.0000, 'ºC'),
	(141761, 112, '2015-04-01 01:19:20.000000', 'temperatura', 59.0000, 'ºC'),
	(141762, 112, '2015-04-01 01:19:21.000000', 'temperatura', 789.0000, 'ºC'),
	(141763, 112, '2015-04-01 01:19:22.000000', 'temperatura', 169.0000, 'ºC'),
	(141764, 112, '2015-04-01 01:19:23.000000', 'temperatura', 879.0000, 'ºC'),
	(141765, 112, '2015-04-01 01:19:24.000000', 'temperatura', 288.0000, 'ºC'),
	(141766, 112, '2015-04-01 01:19:25.000000', 'temperatura', 3.0000, 'ºC'),
	(141767, 112, '2015-04-01 01:19:26.000000', 'temperatura', 353.0000, 'ºC'),
	(141768, 112, '2015-04-01 01:19:27.000000', 'temperatura', 555.0000, 'ºC'),
	(141769, 112, '2015-04-01 01:19:28.000000', 'temperatura', 515.0000, 'ºC'),
	(141770, 112, '2015-04-01 01:19:29.000000', 'temperatura', 913.0000, 'ºC'),
	(141771, 112, '2015-04-01 01:19:30.000000', 'temperatura', 618.0000, 'ºC'),
	(141772, 112, '2015-04-01 01:19:31.000000', 'temperatura', 352.0000, 'ºC'),
	(141773, 112, '2015-04-01 01:19:32.000000', 'temperatura', 1107.0000, 'ºC'),
	(141774, 112, '2015-04-01 01:19:33.000000', 'temperatura', 880.0000, 'ºC'),
	(141775, 112, '2015-04-01 01:19:34.000000', 'temperatura', 1078.0000, 'ºC'),
	(141776, 112, '2015-04-01 01:19:35.000000', 'temperatura', 351.0000, 'ºC'),
	(141777, 112, '2015-04-01 01:19:36.000000', 'temperatura', 924.0000, 'ºC'),
	(141778, 112, '2015-04-01 01:19:37.000000', 'temperatura', 1165.0000, 'ºC'),
	(141779, 112, '2015-04-01 01:19:38.000000', 'temperatura', 655.0000, 'ºC'),
	(141780, 112, '2015-04-01 01:19:39.000000', 'temperatura', 980.0000, 'ºC'),
	(141781, 112, '2015-04-01 01:19:40.000000', 'temperatura', 536.0000, 'ºC'),
	(141782, 112, '2015-04-01 01:19:41.000000', 'temperatura', 940.0000, 'ºC'),
	(141783, 112, '2015-04-01 01:19:42.000000', 'temperatura', 692.0000, 'ºC'),
	(141784, 112, '2015-04-01 01:19:43.000000', 'temperatura', 642.0000, 'ºC'),
	(141785, 112, '2015-04-01 01:19:44.000000', 'temperatura', 1134.0000, 'ºC'),
	(141786, 112, '2015-04-01 01:19:45.000000', 'temperatura', 146.0000, 'ºC'),
	(141787, 112, '2015-04-01 01:19:46.000000', 'temperatura', 928.0000, 'ºC'),
	(141788, 112, '2015-04-01 01:19:47.000000', 'temperatura', 604.0000, 'ºC'),
	(141789, 112, '2015-04-01 01:19:48.000000', 'temperatura', 234.0000, 'ºC'),
	(141790, 112, '2015-04-01 01:19:49.000000', 'temperatura', 560.0000, 'ºC'),
	(141791, 112, '2015-04-01 01:19:50.000000', 'temperatura', 897.0000, 'ºC'),
	(141792, 112, '2015-04-01 01:19:51.000000', 'temperatura', 408.0000, 'ºC'),
	(141793, 112, '2015-04-01 01:19:52.000000', 'temperatura', 546.0000, 'ºC'),
	(141794, 112, '2015-04-01 01:19:53.000000', 'temperatura', 310.0000, 'ºC'),
	(141795, 112, '2015-04-01 01:19:54.000000', 'temperatura', 1110.0000, 'ºC'),
	(141796, 112, '2015-04-01 01:19:55.000000', 'temperatura', 1020.0000, 'ºC'),
	(141797, 112, '2015-04-01 01:19:56.000000', 'temperatura', 570.0000, 'ºC'),
	(141798, 112, '2015-04-01 01:19:57.000000', 'temperatura', 991.0000, 'ºC'),
	(141799, 112, '2015-04-01 01:19:58.000000', 'temperatura', 846.0000, 'ºC'),
	(141800, 112, '2015-04-01 01:19:59.000000', 'temperatura', 57.0000, 'ºC'),
	(141801, 112, '2015-04-01 01:20:00.000000', 'temperatura', 146.0000, 'ºC'),
	(141802, 112, '2015-04-01 01:20:01.000000', 'temperatura', 561.0000, 'ºC'),
	(141803, 112, '2015-04-01 01:20:02.000000', 'temperatura', 1166.0000, 'ºC'),
	(141804, 112, '2015-04-01 01:20:03.000000', 'temperatura', 549.0000, 'ºC'),
	(141805, 112, '2015-04-01 01:20:04.000000', 'temperatura', 447.0000, 'ºC'),
	(141806, 112, '2015-04-01 01:20:05.000000', 'temperatura', 590.0000, 'ºC'),
	(141807, 112, '2015-04-01 01:20:06.000000', 'temperatura', 407.0000, 'ºC'),
	(141808, 112, '2015-04-01 01:20:07.000000', 'temperatura', 268.0000, 'ºC'),
	(141809, 112, '2015-04-01 01:20:08.000000', 'temperatura', 118.0000, 'ºC'),
	(141810, 112, '2015-04-01 01:20:09.000000', 'temperatura', 988.0000, 'ºC'),
	(141811, 112, '2015-04-01 01:20:10.000000', 'temperatura', 984.0000, 'ºC'),
	(141812, 112, '2015-04-01 01:20:11.000000', 'temperatura', 757.0000, 'ºC'),
	(141813, 112, '2015-04-01 01:20:12.000000', 'temperatura', 833.0000, 'ºC'),
	(141814, 112, '2015-04-01 01:20:13.000000', 'temperatura', 694.0000, 'ºC'),
	(141815, 112, '2015-04-01 01:20:14.000000', 'temperatura', 973.0000, 'ºC'),
	(141816, 112, '2015-04-01 01:20:15.000000', 'temperatura', 381.0000, 'ºC'),
	(141817, 112, '2015-04-01 01:20:16.000000', 'temperatura', 188.0000, 'ºC'),
	(141818, 112, '2015-04-01 01:20:17.000000', 'temperatura', 999.0000, 'ºC'),
	(141819, 112, '2015-04-01 01:20:18.000000', 'temperatura', 828.0000, 'ºC'),
	(141820, 112, '2015-04-01 01:20:19.000000', 'temperatura', 1147.0000, 'ºC'),
	(141821, 112, '2015-04-01 01:20:20.000000', 'temperatura', 850.0000, 'ºC'),
	(141822, 112, '2015-04-01 01:20:21.000000', 'temperatura', 810.0000, 'ºC'),
	(141823, 112, '2015-04-01 01:20:22.000000', 'temperatura', 301.0000, 'ºC'),
	(141824, 112, '2015-04-01 01:20:23.000000', 'temperatura', 273.0000, 'ºC'),
	(141825, 112, '2015-04-01 01:20:24.000000', 'temperatura', 464.0000, 'ºC'),
	(141826, 112, '2015-04-01 01:20:25.000000', 'temperatura', 300.0000, 'ºC'),
	(141827, 112, '2015-04-01 01:20:26.000000', 'temperatura', 108.0000, 'ºC'),
	(141828, 112, '2015-04-01 01:20:27.000000', 'temperatura', 841.0000, 'ºC'),
	(141829, 112, '2015-04-01 01:20:28.000000', 'temperatura', 282.0000, 'ºC'),
	(141830, 112, '2015-04-01 01:20:29.000000', 'temperatura', 90.0000, 'ºC'),
	(141831, 112, '2015-04-01 01:20:30.000000', 'temperatura', 801.0000, 'ºC'),
	(141832, 112, '2015-04-01 01:20:31.000000', 'temperatura', 135.0000, 'ºC'),
	(141833, 112, '2015-04-01 01:20:32.000000', 'temperatura', 674.0000, 'ºC'),
	(141834, 112, '2015-04-01 01:20:33.000000', 'temperatura', 567.0000, 'ºC'),
	(141835, 112, '2015-04-01 01:20:34.000000', 'temperatura', 810.0000, 'ºC'),
	(141836, 112, '2015-04-01 01:20:35.000000', 'temperatura', 1152.0000, 'ºC'),
	(141837, 112, '2015-04-01 01:20:36.000000', 'temperatura', 930.0000, 'ºC'),
	(141838, 112, '2015-04-01 01:20:37.000000', 'temperatura', 1194.0000, 'ºC'),
	(141839, 112, '2015-04-01 01:20:38.000000', 'temperatura', 781.0000, 'ºC'),
	(141840, 112, '2015-04-01 01:20:39.000000', 'temperatura', 325.0000, 'ºC'),
	(141841, 112, '2015-04-01 01:20:40.000000', 'temperatura', 480.0000, 'ºC'),
	(141842, 112, '2015-04-01 01:20:41.000000', 'temperatura', 228.0000, 'ºC'),
	(141843, 112, '2015-04-01 01:20:42.000000', 'temperatura', 901.0000, 'ºC'),
	(141844, 112, '2015-04-01 01:20:43.000000', 'temperatura', 222.0000, 'ºC'),
	(141845, 112, '2015-04-01 01:20:44.000000', 'temperatura', 806.0000, 'ºC'),
	(141846, 112, '2015-04-01 01:20:45.000000', 'temperatura', 964.0000, 'ºC'),
	(141847, 112, '2015-04-01 01:20:46.000000', 'temperatura', 4.0000, 'ºC'),
	(141848, 112, '2015-04-01 01:20:47.000000', 'temperatura', 726.0000, 'ºC'),
	(141849, 112, '2015-04-01 01:20:48.000000', 'temperatura', 19.0000, 'ºC'),
	(141850, 112, '2015-04-01 01:20:49.000000', 'temperatura', 316.0000, 'ºC'),
	(141851, 112, '2015-04-01 01:20:50.000000', 'temperatura', 325.0000, 'ºC'),
	(141852, 112, '2015-04-01 01:20:51.000000', 'temperatura', 679.0000, 'ºC'),
	(141853, 112, '2015-04-01 01:20:52.000000', 'temperatura', 18.0000, 'ºC'),
	(141854, 112, '2015-04-01 01:20:53.000000', 'temperatura', 456.0000, 'ºC'),
	(141855, 112, '2015-04-01 01:20:54.000000', 'temperatura', 1024.0000, 'ºC'),
	(141856, 112, '2015-04-01 01:20:55.000000', 'temperatura', 152.0000, 'ºC'),
	(141857, 112, '2015-04-01 01:20:56.000000', 'temperatura', 91.0000, 'ºC'),
	(141858, 112, '2015-04-01 01:20:57.000000', 'temperatura', 0.0000, 'ºC'),
	(141859, 112, '2015-04-01 01:20:58.000000', 'temperatura', 927.0000, 'ºC'),
	(141860, 112, '2015-04-01 01:20:59.000000', 'temperatura', 1037.0000, 'ºC'),
	(141861, 112, '2015-04-01 01:21:00.000000', 'temperatura', 2.0000, 'ºC'),
	(141862, 112, '2015-04-01 01:21:01.000000', 'temperatura', 498.0000, 'ºC'),
	(141863, 112, '2015-04-01 01:21:02.000000', 'temperatura', 87.0000, 'ºC'),
	(141864, 112, '2015-04-01 01:21:03.000000', 'temperatura', 141.0000, 'ºC'),
	(141865, 112, '2015-04-01 01:21:04.000000', 'temperatura', 445.0000, 'ºC'),
	(141866, 112, '2015-04-01 01:21:05.000000', 'temperatura', 602.0000, 'ºC'),
	(141867, 112, '2015-04-01 01:21:06.000000', 'temperatura', 475.0000, 'ºC'),
	(141868, 112, '2015-04-01 01:21:07.000000', 'temperatura', 569.0000, 'ºC'),
	(141869, 112, '2015-04-01 01:21:08.000000', 'temperatura', 222.0000, 'ºC'),
	(141870, 112, '2015-04-01 01:21:09.000000', 'temperatura', 604.0000, 'ºC'),
	(141871, 112, '2015-04-01 01:21:10.000000', 'temperatura', 1153.0000, 'ºC'),
	(141872, 112, '2015-04-01 01:21:11.000000', 'temperatura', 355.0000, 'ºC'),
	(141873, 112, '2015-04-01 01:21:12.000000', 'temperatura', 714.0000, 'ºC'),
	(141874, 112, '2015-04-01 01:21:13.000000', 'temperatura', 109.0000, 'ºC'),
	(141875, 112, '2015-04-01 01:21:14.000000', 'temperatura', 801.0000, 'ºC'),
	(141876, 112, '2015-04-01 01:21:15.000000', 'temperatura', 79.0000, 'ºC'),
	(141877, 112, '2015-04-01 01:21:16.000000', 'temperatura', 392.0000, 'ºC'),
	(141878, 112, '2015-04-01 01:21:17.000000', 'temperatura', 526.0000, 'ºC'),
	(141879, 112, '2015-04-01 01:21:18.000000', 'temperatura', 251.0000, 'ºC'),
	(141880, 112, '2015-04-01 01:21:19.000000', 'temperatura', 880.0000, 'ºC'),
	(141881, 112, '2015-04-01 01:21:20.000000', 'temperatura', 47.0000, 'ºC'),
	(141882, 112, '2015-04-01 01:21:21.000000', 'temperatura', 1196.0000, 'ºC'),
	(141883, 112, '2015-04-01 01:21:22.000000', 'temperatura', 1040.0000, 'ºC'),
	(141884, 112, '2015-04-01 01:21:23.000000', 'temperatura', 414.0000, 'ºC'),
	(141885, 112, '2015-04-01 01:21:24.000000', 'temperatura', 148.0000, 'ºC'),
	(141886, 112, '2015-04-01 01:21:25.000000', 'temperatura', 700.0000, 'ºC'),
	(141887, 112, '2015-04-01 01:21:26.000000', 'temperatura', 655.0000, 'ºC'),
	(141888, 112, '2015-04-01 01:21:27.000000', 'temperatura', 1175.0000, 'ºC'),
	(141889, 112, '2015-04-01 01:21:28.000000', 'temperatura', 310.0000, 'ºC'),
	(141890, 112, '2015-04-01 01:21:29.000000', 'temperatura', 428.0000, 'ºC'),
	(141891, 112, '2015-04-01 01:21:30.000000', 'temperatura', 9.0000, 'ºC'),
	(141892, 112, '2015-04-01 01:21:31.000000', 'temperatura', 1162.0000, 'ºC'),
	(141893, 112, '2015-04-01 01:21:32.000000', 'temperatura', 983.0000, 'ºC'),
	(141894, 112, '2015-04-01 01:21:33.000000', 'temperatura', 228.0000, 'ºC'),
	(141895, 112, '2015-04-01 01:21:34.000000', 'temperatura', 594.0000, 'ºC'),
	(141896, 112, '2015-04-01 01:21:35.000000', 'temperatura', 1087.0000, 'ºC'),
	(141897, 112, '2015-04-01 01:21:36.000000', 'temperatura', 51.0000, 'ºC'),
	(141898, 112, '2015-04-01 01:21:37.000000', 'temperatura', 596.0000, 'ºC'),
	(141899, 112, '2015-04-01 01:21:38.000000', 'temperatura', 428.0000, 'ºC'),
	(141900, 112, '2015-04-01 01:21:39.000000', 'temperatura', 351.0000, 'ºC'),
	(141901, 112, '2015-04-01 01:21:40.000000', 'temperatura', 474.0000, 'ºC'),
	(141902, 112, '2015-04-01 01:21:41.000000', 'temperatura', 116.0000, 'ºC'),
	(141903, 112, '2015-04-01 01:21:42.000000', 'temperatura', 360.0000, 'ºC'),
	(141904, 118, '2014-01-15 00:00:00.000000', 'temperatura', 179.0000, 'ºC'),
	(141905, 118, '2014-01-15 00:00:01.000000', 'temperatura', 139.0000, 'ºC'),
	(141906, 118, '2014-01-15 00:00:02.000000', 'temperatura', 158.0000, 'ºC'),
	(141907, 118, '2014-01-15 00:00:03.000000', 'temperatura', 374.0000, 'ºC'),
	(141908, 118, '2014-01-15 00:00:04.000000', 'temperatura', 197.0000, 'ºC'),
	(141909, 118, '2014-01-15 00:00:05.000000', 'temperatura', 1062.0000, 'ºC'),
	(141910, 118, '2014-01-15 00:00:06.000000', 'temperatura', 1122.0000, 'ºC'),
	(141911, 118, '2014-01-15 00:00:07.000000', 'temperatura', 22.0000, 'ºC'),
	(141912, 118, '2014-01-15 00:00:08.000000', 'temperatura', 344.0000, 'ºC'),
	(141913, 118, '2014-01-15 00:00:09.000000', 'temperatura', 456.0000, 'ºC'),
	(141914, 118, '2014-01-15 00:00:10.000000', 'temperatura', 47.0000, 'ºC'),
	(141915, 118, '2014-01-15 00:00:11.000000', 'temperatura', 68.0000, 'ºC'),
	(141916, 118, '2014-01-15 00:00:12.000000', 'temperatura', 202.0000, 'ºC'),
	(141917, 118, '2014-01-15 00:00:13.000000', 'temperatura', 803.0000, 'ºC'),
	(141918, 118, '2014-01-15 00:00:14.000000', 'temperatura', 1011.0000, 'ºC'),
	(141919, 118, '2014-01-15 00:00:15.000000', 'temperatura', 246.0000, 'ºC'),
	(141920, 118, '2014-01-15 00:00:16.000000', 'temperatura', 597.0000, 'ºC'),
	(141921, 118, '2014-01-15 00:00:17.000000', 'temperatura', 1048.0000, 'ºC'),
	(141922, 118, '2014-01-15 00:00:18.000000', 'temperatura', 1048.0000, 'ºC'),
	(141923, 118, '2014-01-15 00:00:19.000000', 'temperatura', 899.0000, 'ºC'),
	(141924, 118, '2014-01-15 00:00:20.000000', 'temperatura', 149.0000, 'ºC'),
	(141925, 118, '2014-01-15 00:00:21.000000', 'temperatura', 449.0000, 'ºC'),
	(141926, 118, '2014-01-15 00:00:22.000000', 'temperatura', 597.0000, 'ºC'),
	(141927, 118, '2014-01-15 00:00:23.000000', 'temperatura', 439.0000, 'ºC'),
	(141928, 118, '2014-01-15 00:00:24.000000', 'temperatura', 406.0000, 'ºC'),
	(141929, 118, '2014-01-15 00:00:25.000000', 'temperatura', 714.0000, 'ºC'),
	(141930, 118, '2014-01-15 00:00:26.000000', 'temperatura', 1152.0000, 'ºC'),
	(141931, 118, '2014-01-15 00:00:27.000000', 'temperatura', 20.0000, 'ºC'),
	(141932, 118, '2014-01-15 00:00:28.000000', 'temperatura', 245.0000, 'ºC'),
	(141933, 118, '2014-01-15 00:00:29.000000', 'temperatura', 1163.0000, 'ºC'),
	(141934, 118, '2014-01-15 00:00:30.000000', 'temperatura', 281.0000, 'ºC'),
	(141935, 118, '2014-01-15 00:00:31.000000', 'temperatura', 316.0000, 'ºC'),
	(141936, 118, '2014-01-15 00:00:32.000000', 'temperatura', 737.0000, 'ºC'),
	(141937, 118, '2014-01-15 00:00:33.000000', 'temperatura', 338.0000, 'ºC'),
	(141938, 118, '2014-01-15 00:00:34.000000', 'temperatura', 681.0000, 'ºC'),
	(141939, 118, '2014-01-15 00:00:35.000000', 'temperatura', 1189.0000, 'ºC'),
	(141940, 118, '2014-01-15 00:00:36.000000', 'temperatura', 303.0000, 'ºC'),
	(141941, 118, '2014-01-15 00:00:37.000000', 'temperatura', 348.0000, 'ºC'),
	(141942, 118, '2014-01-15 00:00:38.000000', 'temperatura', 831.0000, 'ºC'),
	(141943, 118, '2014-01-15 00:00:39.000000', 'temperatura', 712.0000, 'ºC'),
	(141944, 118, '2014-01-15 00:00:40.000000', 'temperatura', 1067.0000, 'ºC'),
	(141945, 118, '2014-01-15 00:00:41.000000', 'temperatura', 802.0000, 'ºC'),
	(141946, 118, '2014-01-15 00:00:42.000000', 'temperatura', 808.0000, 'ºC'),
	(141947, 118, '2014-01-15 00:00:43.000000', 'temperatura', 434.0000, 'ºC'),
	(141948, 118, '2014-01-15 00:00:44.000000', 'temperatura', 948.0000, 'ºC'),
	(141949, 118, '2014-01-15 00:00:45.000000', 'temperatura', 1038.0000, 'ºC'),
	(141950, 118, '2014-01-15 00:00:46.000000', 'temperatura', 1146.0000, 'ºC'),
	(141951, 118, '2014-01-15 00:00:47.000000', 'temperatura', 216.0000, 'ºC'),
	(141952, 118, '2014-01-15 00:00:48.000000', 'temperatura', 45.0000, 'ºC'),
	(141953, 118, '2014-01-15 00:00:49.000000', 'temperatura', 775.0000, 'ºC'),
	(141954, 118, '2014-01-15 00:00:50.000000', 'temperatura', 140.0000, 'ºC'),
	(141955, 118, '2014-01-15 00:00:51.000000', 'temperatura', 777.0000, 'ºC'),
	(141956, 118, '2014-01-15 00:00:52.000000', 'temperatura', 1063.0000, 'ºC'),
	(141957, 118, '2014-01-15 00:00:53.000000', 'temperatura', 588.0000, 'ºC'),
	(141958, 118, '2014-01-15 00:00:54.000000', 'temperatura', 950.0000, 'ºC'),
	(141959, 118, '2014-01-15 00:00:55.000000', 'temperatura', 588.0000, 'ºC'),
	(141960, 118, '2014-01-15 00:00:56.000000', 'temperatura', 90.0000, 'ºC'),
	(141961, 118, '2014-01-15 00:00:57.000000', 'temperatura', 1084.0000, 'ºC'),
	(141962, 118, '2014-01-15 00:00:58.000000', 'temperatura', 354.0000, 'ºC'),
	(141963, 118, '2014-01-15 00:00:59.000000', 'temperatura', 915.0000, 'ºC'),
	(141964, 118, '2014-01-15 00:01:00.000000', 'temperatura', 1117.0000, 'ºC'),
	(141965, 118, '2014-01-15 00:01:01.000000', 'temperatura', 437.0000, 'ºC'),
	(141966, 118, '2014-01-15 00:01:02.000000', 'temperatura', 37.0000, 'ºC'),
	(141967, 118, '2014-01-15 00:01:03.000000', 'temperatura', 72.0000, 'ºC'),
	(141968, 118, '2014-01-15 00:01:04.000000', 'temperatura', 250.0000, 'ºC'),
	(141969, 118, '2014-01-15 00:01:05.000000', 'temperatura', 1037.0000, 'ºC'),
	(141970, 118, '2014-01-15 00:01:06.000000', 'temperatura', 832.0000, 'ºC'),
	(141971, 118, '2014-01-15 00:01:07.000000', 'temperatura', 1053.0000, 'ºC'),
	(141972, 118, '2014-01-15 00:01:08.000000', 'temperatura', 368.0000, 'ºC'),
	(141973, 118, '2014-01-15 00:01:09.000000', 'temperatura', 1083.0000, 'ºC'),
	(141974, 118, '2014-01-15 00:01:10.000000', 'temperatura', 711.0000, 'ºC'),
	(141975, 118, '2014-01-15 00:01:11.000000', 'temperatura', 304.0000, 'ºC'),
	(141976, 118, '2014-01-15 00:01:12.000000', 'temperatura', 591.0000, 'ºC'),
	(141977, 118, '2014-01-15 00:01:13.000000', 'temperatura', 840.0000, 'ºC'),
	(141978, 118, '2014-01-15 00:01:14.000000', 'temperatura', 31.0000, 'ºC'),
	(141979, 118, '2014-01-15 00:01:15.000000', 'temperatura', 33.0000, 'ºC'),
	(141980, 118, '2014-01-15 00:01:16.000000', 'temperatura', 73.0000, 'ºC'),
	(141981, 118, '2014-01-15 00:01:17.000000', 'temperatura', 265.0000, 'ºC'),
	(141982, 118, '2014-01-15 00:01:18.000000', 'temperatura', 1108.0000, 'ºC'),
	(141983, 118, '2014-01-15 00:01:19.000000', 'temperatura', 1144.0000, 'ºC'),
	(141984, 118, '2014-01-15 00:01:20.000000', 'temperatura', 1198.0000, 'ºC'),
	(141985, 118, '2014-01-15 00:01:21.000000', 'temperatura', 160.0000, 'ºC'),
	(141986, 118, '2014-01-15 00:01:22.000000', 'temperatura', 804.0000, 'ºC'),
	(141987, 118, '2014-01-15 00:01:23.000000', 'temperatura', 1142.0000, 'ºC'),
	(141988, 118, '2014-01-15 00:01:24.000000', 'temperatura', 898.0000, 'ºC'),
	(141989, 118, '2014-01-15 00:01:25.000000', 'temperatura', 1063.0000, 'ºC'),
	(141990, 118, '2014-01-15 00:01:26.000000', 'temperatura', 225.0000, 'ºC'),
	(141991, 118, '2014-01-15 00:01:27.000000', 'temperatura', 333.0000, 'ºC'),
	(141992, 118, '2014-01-15 00:01:28.000000', 'temperatura', 991.0000, 'ºC'),
	(141993, 118, '2014-01-15 00:01:29.000000', 'temperatura', 357.0000, 'ºC'),
	(141994, 118, '2014-01-15 00:01:30.000000', 'temperatura', 12.0000, 'ºC'),
	(141995, 118, '2014-01-15 00:01:31.000000', 'temperatura', 188.0000, 'ºC'),
	(141996, 118, '2014-01-15 00:01:32.000000', 'temperatura', 907.0000, 'ºC'),
	(141997, 118, '2014-01-15 00:01:33.000000', 'temperatura', 370.0000, 'ºC'),
	(141998, 118, '2014-01-15 00:01:34.000000', 'temperatura', 328.0000, 'ºC'),
	(141999, 118, '2014-01-15 00:01:35.000000', 'temperatura', 532.0000, 'ºC'),
	(142000, 118, '2014-01-15 00:01:36.000000', 'temperatura', 478.0000, 'ºC'),
	(142001, 118, '2014-01-15 00:01:37.000000', 'temperatura', 794.0000, 'ºC'),
	(142002, 118, '2014-01-15 00:01:38.000000', 'temperatura', 136.0000, 'ºC'),
	(142003, 118, '2014-01-15 00:01:39.000000', 'temperatura', 697.0000, 'ºC'),
	(142004, 118, '2014-01-15 00:01:40.000000', 'temperatura', 678.0000, 'ºC'),
	(142005, 118, '2014-01-15 00:01:41.000000', 'temperatura', 98.0000, 'ºC'),
	(142006, 118, '2014-01-15 00:01:42.000000', 'temperatura', 857.0000, 'ºC'),
	(142007, 118, '2014-01-15 00:01:43.000000', 'temperatura', 393.0000, 'ºC'),
	(142008, 118, '2014-01-15 00:01:44.000000', 'temperatura', 594.0000, 'ºC'),
	(142009, 118, '2014-01-15 00:01:45.000000', 'temperatura', 590.0000, 'ºC'),
	(142010, 118, '2014-01-15 00:01:46.000000', 'temperatura', 1169.0000, 'ºC'),
	(142011, 118, '2014-01-15 00:01:47.000000', 'temperatura', 475.0000, 'ºC'),
	(142012, 118, '2014-01-15 00:01:48.000000', 'temperatura', 71.0000, 'ºC'),
	(142013, 118, '2014-01-15 00:01:49.000000', 'temperatura', 129.0000, 'ºC'),
	(142014, 118, '2014-01-15 00:01:50.000000', 'temperatura', 432.0000, 'ºC'),
	(142015, 118, '2014-01-15 00:01:51.000000', 'temperatura', 574.0000, 'ºC'),
	(142016, 118, '2014-01-15 00:01:52.000000', 'temperatura', 375.0000, 'ºC'),
	(142017, 118, '2014-01-15 00:01:53.000000', 'temperatura', 152.0000, 'ºC'),
	(142018, 118, '2014-01-15 00:01:54.000000', 'temperatura', 835.0000, 'ºC'),
	(142019, 118, '2014-01-15 00:01:55.000000', 'temperatura', 122.0000, 'ºC'),
	(142020, 118, '2014-01-15 00:01:56.000000', 'temperatura', 505.0000, 'ºC'),
	(142021, 118, '2014-01-15 00:01:57.000000', 'temperatura', 960.0000, 'ºC'),
	(142022, 118, '2014-01-15 00:01:58.000000', 'temperatura', 886.0000, 'ºC'),
	(142023, 118, '2014-01-15 00:01:59.000000', 'temperatura', 349.0000, 'ºC'),
	(142024, 118, '2014-01-15 00:02:00.000000', 'temperatura', 288.0000, 'ºC'),
	(142025, 118, '2014-01-15 00:02:01.000000', 'temperatura', 393.0000, 'ºC'),
	(142026, 118, '2014-01-15 00:02:02.000000', 'temperatura', 1104.0000, 'ºC'),
	(142027, 118, '2014-01-15 00:02:03.000000', 'temperatura', 738.0000, 'ºC'),
	(142028, 118, '2014-01-15 00:02:04.000000', 'temperatura', 381.0000, 'ºC'),
	(142029, 118, '2014-01-15 00:02:05.000000', 'temperatura', 893.0000, 'ºC'),
	(142030, 118, '2014-01-15 00:02:06.000000', 'temperatura', 919.0000, 'ºC'),
	(142031, 118, '2014-01-15 00:02:07.000000', 'temperatura', 717.0000, 'ºC'),
	(142032, 118, '2014-01-15 00:02:08.000000', 'temperatura', 829.0000, 'ºC'),
	(142033, 118, '2014-01-15 00:02:09.000000', 'temperatura', 793.0000, 'ºC'),
	(142034, 118, '2014-01-15 00:02:10.000000', 'temperatura', 279.0000, 'ºC'),
	(142035, 118, '2014-01-15 00:02:11.000000', 'temperatura', 217.0000, 'ºC'),
	(142036, 118, '2014-01-15 00:02:12.000000', 'temperatura', 247.0000, 'ºC'),
	(142037, 118, '2014-01-15 00:02:13.000000', 'temperatura', 587.0000, 'ºC'),
	(142038, 118, '2014-01-15 00:02:14.000000', 'temperatura', 993.0000, 'ºC'),
	(142039, 118, '2014-01-15 00:02:15.000000', 'temperatura', 804.0000, 'ºC'),
	(142040, 118, '2014-01-15 00:02:16.000000', 'temperatura', 1043.0000, 'ºC'),
	(142041, 118, '2014-01-15 00:02:17.000000', 'temperatura', 402.0000, 'ºC'),
	(142042, 118, '2014-01-15 00:02:18.000000', 'temperatura', 84.0000, 'ºC'),
	(142043, 118, '2014-01-15 00:02:19.000000', 'temperatura', 412.0000, 'ºC'),
	(142044, 118, '2014-01-15 00:02:20.000000', 'temperatura', 610.0000, 'ºC'),
	(142045, 118, '2014-01-15 00:02:21.000000', 'temperatura', 613.0000, 'ºC'),
	(142046, 118, '2014-01-15 00:02:22.000000', 'temperatura', 35.0000, 'ºC'),
	(142047, 118, '2014-01-15 00:02:23.000000', 'temperatura', 736.0000, 'ºC'),
	(142048, 118, '2014-01-15 00:02:24.000000', 'temperatura', 1175.0000, 'ºC'),
	(142049, 118, '2014-01-15 00:02:25.000000', 'temperatura', 71.0000, 'ºC'),
	(142050, 118, '2014-01-15 00:02:26.000000', 'temperatura', 427.0000, 'ºC'),
	(142051, 118, '2014-01-15 00:02:27.000000', 'temperatura', 723.0000, 'ºC'),
	(142052, 118, '2014-01-15 00:02:28.000000', 'temperatura', 1133.0000, 'ºC'),
	(142053, 118, '2014-01-15 00:02:29.000000', 'temperatura', 1100.0000, 'ºC'),
	(142054, 118, '2014-01-15 00:02:30.000000', 'temperatura', 900.0000, 'ºC'),
	(142055, 118, '2014-01-15 00:02:31.000000', 'temperatura', 0.0000, 'ºC'),
	(142056, 118, '2014-01-15 00:02:32.000000', 'temperatura', 899.0000, 'ºC'),
	(142057, 118, '2014-01-15 00:02:33.000000', 'temperatura', 898.0000, 'ºC'),
	(142058, 118, '2014-01-15 00:02:34.000000', 'temperatura', 592.0000, 'ºC'),
	(142059, 118, '2014-01-15 00:02:35.000000', 'temperatura', 266.0000, 'ºC'),
	(142060, 118, '2014-01-15 00:02:36.000000', 'temperatura', 754.0000, 'ºC'),
	(142061, 118, '2014-01-15 00:02:37.000000', 'temperatura', 574.0000, 'ºC'),
	(142062, 118, '2014-01-15 00:02:38.000000', 'temperatura', 607.0000, 'ºC'),
	(142063, 118, '2014-01-15 00:02:39.000000', 'temperatura', 115.0000, 'ºC'),
	(142064, 118, '2014-01-15 00:02:40.000000', 'temperatura', 1154.0000, 'ºC'),
	(142065, 118, '2014-01-15 00:02:41.000000', 'temperatura', 627.0000, 'ºC'),
	(142066, 118, '2014-01-15 00:02:42.000000', 'temperatura', 874.0000, 'ºC'),
	(142067, 118, '2014-01-15 00:02:43.000000', 'temperatura', 89.0000, 'ºC'),
	(142068, 118, '2014-01-15 00:02:44.000000', 'temperatura', 225.0000, 'ºC'),
	(142069, 118, '2014-01-15 00:02:45.000000', 'temperatura', 856.0000, 'ºC'),
	(142070, 118, '2014-01-15 00:02:46.000000', 'temperatura', 5.0000, 'ºC'),
	(142071, 118, '2014-01-15 00:02:47.000000', 'temperatura', 1058.0000, 'ºC'),
	(142072, 118, '2014-01-15 00:02:48.000000', 'temperatura', 475.0000, 'ºC'),
	(142073, 118, '2014-01-15 00:02:49.000000', 'temperatura', 402.0000, 'ºC'),
	(142074, 118, '2014-01-15 00:02:50.000000', 'temperatura', 585.0000, 'ºC'),
	(142075, 118, '2014-01-15 00:02:51.000000', 'temperatura', 520.0000, 'ºC'),
	(142076, 118, '2014-01-15 00:02:52.000000', 'temperatura', 847.0000, 'ºC'),
	(142077, 118, '2014-01-15 00:02:53.000000', 'temperatura', 273.0000, 'ºC'),
	(142078, 118, '2014-01-15 00:02:54.000000', 'temperatura', 25.0000, 'ºC'),
	(142079, 118, '2014-01-15 00:02:55.000000', 'temperatura', 505.0000, 'ºC'),
	(142080, 118, '2014-01-15 00:02:56.000000', 'temperatura', 51.0000, 'ºC'),
	(142081, 118, '2014-01-15 00:02:57.000000', 'temperatura', 1142.0000, 'ºC'),
	(142082, 118, '2014-01-15 00:02:58.000000', 'temperatura', 756.0000, 'ºC'),
	(142083, 118, '2014-01-15 00:02:59.000000', 'temperatura', 355.0000, 'ºC'),
	(142084, 118, '2014-01-15 00:03:00.000000', 'temperatura', 709.0000, 'ºC'),
	(142085, 118, '2014-01-15 00:03:01.000000', 'temperatura', 80.0000, 'ºC'),
	(142086, 118, '2014-01-15 00:03:02.000000', 'temperatura', 673.0000, 'ºC'),
	(142087, 118, '2014-01-15 00:03:03.000000', 'temperatura', 728.0000, 'ºC'),
	(142088, 118, '2014-01-15 00:03:04.000000', 'temperatura', 418.0000, 'ºC'),
	(142089, 118, '2014-01-15 00:03:05.000000', 'temperatura', 1107.0000, 'ºC'),
	(142090, 118, '2014-01-15 00:03:06.000000', 'temperatura', 684.0000, 'ºC'),
	(142091, 118, '2014-01-15 00:03:07.000000', 'temperatura', 97.0000, 'ºC'),
	(142092, 118, '2014-01-15 00:03:08.000000', 'temperatura', 834.0000, 'ºC'),
	(142093, 118, '2014-01-15 00:03:09.000000', 'temperatura', 279.0000, 'ºC'),
	(142094, 118, '2014-01-15 00:03:10.000000', 'temperatura', 94.0000, 'ºC'),
	(142095, 118, '2014-01-15 00:03:11.000000', 'temperatura', 835.0000, 'ºC'),
	(142096, 118, '2014-01-15 00:03:12.000000', 'temperatura', 293.0000, 'ºC'),
	(142097, 118, '2014-01-15 00:03:13.000000', 'temperatura', 161.0000, 'ºC'),
	(142098, 118, '2014-01-15 00:03:14.000000', 'temperatura', 1126.0000, 'ºC'),
	(142099, 118, '2014-01-15 00:03:15.000000', 'temperatura', 346.0000, 'ºC'),
	(142100, 118, '2014-01-15 00:03:16.000000', 'temperatura', 752.0000, 'ºC'),
	(142101, 118, '2014-01-15 00:03:17.000000', 'temperatura', 325.0000, 'ºC'),
	(142102, 118, '2014-01-15 00:03:18.000000', 'temperatura', 570.0000, 'ºC'),
	(142103, 118, '2014-01-15 00:03:19.000000', 'temperatura', 676.0000, 'ºC'),
	(142104, 118, '2014-01-15 00:03:20.000000', 'temperatura', 468.0000, 'ºC'),
	(142105, 118, '2014-01-15 00:03:21.000000', 'temperatura', 315.0000, 'ºC'),
	(142106, 118, '2014-01-15 00:03:22.000000', 'temperatura', 171.0000, 'ºC'),
	(142107, 118, '2014-01-15 00:03:23.000000', 'temperatura', 1111.0000, 'ºC'),
	(142108, 118, '2014-01-15 00:03:24.000000', 'temperatura', 242.0000, 'ºC'),
	(142109, 118, '2014-01-15 00:03:25.000000', 'temperatura', 277.0000, 'ºC'),
	(142110, 118, '2014-01-15 00:03:26.000000', 'temperatura', 660.0000, 'ºC'),
	(142111, 118, '2014-01-15 00:03:27.000000', 'temperatura', 70.0000, 'ºC'),
	(142112, 118, '2014-01-15 00:03:28.000000', 'temperatura', 771.0000, 'ºC'),
	(142113, 118, '2014-01-15 00:03:29.000000', 'temperatura', 47.0000, 'ºC'),
	(142114, 118, '2014-01-15 00:03:30.000000', 'temperatura', 320.0000, 'ºC'),
	(142115, 118, '2014-01-15 00:03:31.000000', 'temperatura', 259.0000, 'ºC'),
	(142116, 118, '2014-01-15 00:03:32.000000', 'temperatura', 337.0000, 'ºC'),
	(142117, 118, '2014-01-15 00:03:33.000000', 'temperatura', 909.0000, 'ºC'),
	(142118, 118, '2014-01-15 00:03:34.000000', 'temperatura', 1132.0000, 'ºC'),
	(142119, 118, '2014-01-15 00:03:35.000000', 'temperatura', 535.0000, 'ºC'),
	(142120, 118, '2014-01-15 00:03:36.000000', 'temperatura', 479.0000, 'ºC'),
	(142121, 118, '2014-01-15 00:03:37.000000', 'temperatura', 790.0000, 'ºC'),
	(142122, 118, '2014-01-15 00:03:38.000000', 'temperatura', 116.0000, 'ºC'),
	(142123, 118, '2014-01-15 00:03:39.000000', 'temperatura', 609.0000, 'ºC'),
	(142124, 118, '2014-01-15 00:03:40.000000', 'temperatura', 296.0000, 'ºC'),
	(142125, 118, '2014-01-15 00:03:41.000000', 'temperatura', 854.0000, 'ºC'),
	(142126, 118, '2014-01-15 00:03:42.000000', 'temperatura', 985.0000, 'ºC'),
	(142127, 118, '2014-01-15 00:03:43.000000', 'temperatura', 1162.0000, 'ºC'),
	(142128, 118, '2014-01-15 00:03:44.000000', 'temperatura', 455.0000, 'ºC'),
	(142129, 118, '2014-01-15 00:03:45.000000', 'temperatura', 1192.0000, 'ºC'),
	(142130, 118, '2014-01-15 00:03:46.000000', 'temperatura', 992.0000, 'ºC'),
	(142131, 118, '2014-01-15 00:03:47.000000', 'temperatura', 187.0000, 'ºC'),
	(142132, 118, '2014-01-15 00:03:48.000000', 'temperatura', 358.0000, 'ºC'),
	(142133, 118, '2014-01-15 00:03:49.000000', 'temperatura', 30.0000, 'ºC'),
	(142134, 118, '2014-01-15 00:03:50.000000', 'temperatura', 275.0000, 'ºC'),
	(142135, 118, '2014-01-15 00:03:51.000000', 'temperatura', 87.0000, 'ºC'),
	(142136, 118, '2014-01-15 00:03:52.000000', 'temperatura', 811.0000, 'ºC'),
	(142137, 118, '2014-01-15 00:03:53.000000', 'temperatura', 195.0000, 'ºC'),
	(142138, 118, '2014-01-15 00:03:54.000000', 'temperatura', 942.0000, 'ºC'),
	(142139, 118, '2014-01-15 00:03:55.000000', 'temperatura', 525.0000, 'ºC'),
	(142140, 118, '2014-01-15 00:03:56.000000', 'temperatura', 1001.0000, 'ºC'),
	(142141, 118, '2014-01-15 00:03:57.000000', 'temperatura', 1030.0000, 'ºC'),
	(142142, 118, '2014-01-15 00:03:58.000000', 'temperatura', 946.0000, 'ºC'),
	(142143, 118, '2014-01-15 00:03:59.000000', 'temperatura', 440.0000, 'ºC'),
	(142144, 118, '2014-01-15 00:04:00.000000', 'temperatura', 565.0000, 'ºC'),
	(142145, 118, '2014-01-15 00:04:01.000000', 'temperatura', 306.0000, 'ºC'),
	(142146, 118, '2014-01-15 00:04:02.000000', 'temperatura', 1033.0000, 'ºC'),
	(142147, 118, '2014-01-15 00:04:03.000000', 'temperatura', 650.0000, 'ºC'),
	(142148, 118, '2014-01-15 00:04:04.000000', 'temperatura', 149.0000, 'ºC'),
	(142149, 118, '2014-01-15 00:04:05.000000', 'temperatura', 1197.0000, 'ºC'),
	(142150, 118, '2014-01-15 00:04:06.000000', 'temperatura', 740.0000, 'ºC'),
	(142151, 118, '2014-01-15 00:04:07.000000', 'temperatura', 109.0000, 'ºC'),
	(142152, 118, '2014-01-15 00:04:08.000000', 'temperatura', 726.0000, 'ºC'),
	(142153, 118, '2014-01-15 00:04:09.000000', 'temperatura', 903.0000, 'ºC'),
	(142154, 118, '2014-01-15 00:04:10.000000', 'temperatura', 1138.0000, 'ºC'),
	(142155, 118, '2014-01-15 00:04:11.000000', 'temperatura', 579.0000, 'ºC'),
	(142156, 118, '2014-01-15 00:04:12.000000', 'temperatura', 683.0000, 'ºC'),
	(142157, 118, '2014-01-15 00:04:13.000000', 'temperatura', 480.0000, 'ºC'),
	(142158, 118, '2014-01-15 00:04:14.000000', 'temperatura', 350.0000, 'ºC'),
	(142159, 118, '2014-01-15 00:04:15.000000', 'temperatura', 312.0000, 'ºC'),
	(142160, 118, '2014-01-15 00:04:16.000000', 'temperatura', 509.0000, 'ºC'),
	(142161, 118, '2014-01-15 00:04:17.000000', 'temperatura', 410.0000, 'ºC'),
	(142162, 118, '2014-01-15 00:04:18.000000', 'temperatura', 524.0000, 'ºC'),
	(142163, 118, '2014-01-15 00:04:19.000000', 'temperatura', 191.0000, 'ºC'),
	(142164, 118, '2014-01-15 00:04:20.000000', 'temperatura', 582.0000, 'ºC'),
	(142165, 118, '2014-01-15 00:04:21.000000', 'temperatura', 1140.0000, 'ºC'),
	(142166, 118, '2014-01-15 00:04:22.000000', 'temperatura', 354.0000, 'ºC'),
	(142167, 118, '2014-01-15 00:04:23.000000', 'temperatura', 749.0000, 'ºC'),
	(142168, 118, '2014-01-15 00:04:24.000000', 'temperatura', 286.0000, 'ºC'),
	(142169, 118, '2014-01-15 00:04:25.000000', 'temperatura', 381.0000, 'ºC'),
	(142170, 118, '2014-01-15 00:04:26.000000', 'temperatura', 1047.0000, 'ºC'),
	(142171, 118, '2014-01-15 00:04:27.000000', 'temperatura', 491.0000, 'ºC'),
	(142172, 118, '2014-01-15 00:04:28.000000', 'temperatura', 517.0000, 'ºC'),
	(142173, 118, '2014-01-15 00:04:29.000000', 'temperatura', 1114.0000, 'ºC'),
	(142174, 118, '2014-01-15 00:04:30.000000', 'temperatura', 418.0000, 'ºC'),
	(142175, 118, '2014-01-15 00:04:31.000000', 'temperatura', 1147.0000, 'ºC'),
	(142176, 118, '2014-01-15 00:04:32.000000', 'temperatura', 883.0000, 'ºC'),
	(142177, 118, '2014-01-15 00:04:33.000000', 'temperatura', 976.0000, 'ºC'),
	(142178, 118, '2014-01-15 00:04:34.000000', 'temperatura', 1030.0000, 'ºC'),
	(142179, 118, '2014-01-15 00:04:35.000000', 'temperatura', 1023.0000, 'ºC'),
	(142180, 118, '2014-01-15 00:04:36.000000', 'temperatura', 826.0000, 'ºC'),
	(142181, 118, '2014-01-15 00:04:37.000000', 'temperatura', 1060.0000, 'ºC'),
	(142182, 118, '2014-01-15 00:04:38.000000', 'temperatura', 425.0000, 'ºC'),
	(142183, 118, '2014-01-15 00:04:39.000000', 'temperatura', 143.0000, 'ºC'),
	(142184, 118, '2014-01-15 00:04:40.000000', 'temperatura', 641.0000, 'ºC'),
	(142185, 118, '2014-01-15 00:04:41.000000', 'temperatura', 378.0000, 'ºC'),
	(142186, 118, '2014-01-15 00:04:42.000000', 'temperatura', 1167.0000, 'ºC'),
	(142187, 118, '2014-01-15 00:04:43.000000', 'temperatura', 1101.0000, 'ºC'),
	(142188, 118, '2014-01-15 00:04:44.000000', 'temperatura', 806.0000, 'ºC'),
	(142189, 118, '2014-01-15 00:04:45.000000', 'temperatura', 728.0000, 'ºC'),
	(142190, 118, '2014-01-15 00:04:46.000000', 'temperatura', 21.0000, 'ºC'),
	(142191, 118, '2014-01-15 00:04:47.000000', 'temperatura', 324.0000, 'ºC'),
	(142192, 118, '2014-01-15 00:04:48.000000', 'temperatura', 355.0000, 'ºC'),
	(142193, 118, '2014-01-15 00:04:49.000000', 'temperatura', 806.0000, 'ºC'),
	(142194, 118, '2014-01-15 00:04:50.000000', 'temperatura', 563.0000, 'ºC'),
	(142195, 118, '2014-01-15 00:04:51.000000', 'temperatura', 399.0000, 'ºC'),
	(142196, 118, '2014-01-15 00:04:52.000000', 'temperatura', 304.0000, 'ºC'),
	(142197, 118, '2014-01-15 00:04:53.000000', 'temperatura', 325.0000, 'ºC'),
	(142198, 118, '2014-01-15 00:04:54.000000', 'temperatura', 712.0000, 'ºC'),
	(142199, 118, '2014-01-15 00:04:55.000000', 'temperatura', 186.0000, 'ºC'),
	(142200, 118, '2014-01-15 00:04:56.000000', 'temperatura', 1196.0000, 'ºC'),
	(142201, 118, '2014-01-15 00:04:57.000000', 'temperatura', 624.0000, 'ºC'),
	(142202, 118, '2014-01-15 00:04:58.000000', 'temperatura', 729.0000, 'ºC'),
	(142203, 118, '2014-01-15 00:04:59.000000', 'temperatura', 576.0000, 'ºC'),
	(142204, 118, '2014-01-15 00:05:00.000000', 'temperatura', 692.0000, 'ºC'),
	(142205, 118, '2014-01-15 00:05:01.000000', 'temperatura', 531.0000, 'ºC'),
	(142206, 118, '2014-01-15 00:05:02.000000', 'temperatura', 583.0000, 'ºC'),
	(142207, 118, '2014-01-15 00:05:03.000000', 'temperatura', 120.0000, 'ºC'),
	(142208, 118, '2014-01-15 00:05:04.000000', 'temperatura', 50.0000, 'ºC'),
	(142209, 118, '2014-01-15 00:05:05.000000', 'temperatura', 1094.0000, 'ºC'),
	(142210, 118, '2014-01-15 00:05:06.000000', 'temperatura', 518.0000, 'ºC'),
	(142211, 118, '2014-01-15 00:05:07.000000', 'temperatura', 511.0000, 'ºC'),
	(142212, 118, '2014-01-15 00:05:08.000000', 'temperatura', 1002.0000, 'ºC'),
	(142213, 118, '2014-01-15 00:05:09.000000', 'temperatura', 1077.0000, 'ºC'),
	(142214, 118, '2014-01-15 00:05:10.000000', 'temperatura', 1180.0000, 'ºC'),
	(142215, 118, '2014-01-15 00:05:11.000000', 'temperatura', 267.0000, 'ºC'),
	(142216, 118, '2014-01-15 00:05:12.000000', 'temperatura', 197.0000, 'ºC'),
	(142217, 118, '2014-01-15 00:05:13.000000', 'temperatura', 184.0000, 'ºC'),
	(142218, 118, '2014-01-15 00:05:14.000000', 'temperatura', 329.0000, 'ºC'),
	(142219, 118, '2014-01-15 00:05:15.000000', 'temperatura', 1096.0000, 'ºC'),
	(142220, 118, '2014-01-15 00:05:16.000000', 'temperatura', 891.0000, 'ºC'),
	(142221, 118, '2014-01-15 00:05:17.000000', 'temperatura', 1167.0000, 'ºC'),
	(142222, 118, '2014-01-15 00:05:18.000000', 'temperatura', 763.0000, 'ºC'),
	(142223, 118, '2014-01-15 00:05:19.000000', 'temperatura', 316.0000, 'ºC'),
	(142224, 118, '2014-01-15 00:05:20.000000', 'temperatura', 490.0000, 'ºC'),
	(142225, 118, '2014-01-15 00:05:21.000000', 'temperatura', 303.0000, 'ºC'),
	(142226, 118, '2014-01-15 00:05:22.000000', 'temperatura', 46.0000, 'ºC'),
	(142227, 118, '2014-01-15 00:05:23.000000', 'temperatura', 520.0000, 'ºC'),
	(142228, 118, '2014-01-15 00:05:24.000000', 'temperatura', 62.0000, 'ºC'),
	(142229, 118, '2014-01-15 00:05:25.000000', 'temperatura', 1150.0000, 'ºC'),
	(142230, 118, '2014-01-15 00:05:26.000000', 'temperatura', 764.0000, 'ºC'),
	(142231, 118, '2014-01-15 00:05:27.000000', 'temperatura', 370.0000, 'ºC'),
	(142232, 118, '2014-01-15 00:05:28.000000', 'temperatura', 759.0000, 'ºC'),
	(142233, 118, '2014-01-15 00:05:29.000000', 'temperatura', 284.0000, 'ºC'),
	(142234, 118, '2014-01-15 00:05:30.000000', 'temperatura', 347.0000, 'ºC'),
	(142235, 118, '2014-01-15 00:05:31.000000', 'temperatura', 881.0000, 'ºC'),
	(142236, 118, '2014-01-15 00:05:32.000000', 'temperatura', 964.0000, 'ºC'),
	(142237, 118, '2014-01-15 00:05:33.000000', 'temperatura', 978.0000, 'ºC'),
	(142238, 118, '2014-01-15 00:05:34.000000', 'temperatura', 799.0000, 'ºC'),
	(142239, 118, '2014-01-15 00:05:35.000000', 'temperatura', 1061.0000, 'ºC'),
	(142240, 118, '2014-01-15 00:05:36.000000', 'temperatura', 511.0000, 'ºC'),
	(142241, 118, '2014-01-15 00:05:37.000000', 'temperatura', 570.0000, 'ºC'),
	(142242, 118, '2014-01-15 00:05:38.000000', 'temperatura', 119.0000, 'ºC'),
	(142243, 118, '2014-01-15 00:05:39.000000', 'temperatura', 84.0000, 'ºC'),
	(142244, 118, '2014-01-15 00:05:40.000000', 'temperatura', 64.0000, 'ºC'),
	(142245, 118, '2014-01-15 00:05:41.000000', 'temperatura', 67.0000, 'ºC'),
	(142246, 118, '2014-01-15 00:05:42.000000', 'temperatura', 146.0000, 'ºC'),
	(142247, 118, '2014-01-15 00:05:43.000000', 'temperatura', 527.0000, 'ºC'),
	(142248, 118, '2014-01-15 00:05:44.000000', 'temperatura', 996.0000, 'ºC'),
	(142249, 118, '2014-01-15 00:05:45.000000', 'temperatura', 1003.0000, 'ºC'),
	(142250, 118, '2014-01-15 00:05:46.000000', 'temperatura', 828.0000, 'ºC'),
	(142251, 118, '2014-01-15 00:05:47.000000', 'temperatura', 1128.0000, 'ºC'),
	(142252, 118, '2014-01-15 00:05:48.000000', 'temperatura', 760.0000, 'ºC'),
	(142253, 118, '2014-01-15 00:05:49.000000', 'temperatura', 413.0000, 'ºC'),
	(142254, 118, '2014-01-15 00:05:50.000000', 'temperatura', 988.0000, 'ºC'),
	(142255, 118, '2014-01-15 00:05:51.000000', 'temperatura', 101.0000, 'ºC'),
	(142256, 118, '2014-01-15 00:05:52.000000', 'temperatura', 1140.0000, 'ºC'),
	(142257, 118, '2014-01-15 00:05:53.000000', 'temperatura', 598.0000, 'ºC'),
	(142258, 118, '2014-01-15 00:05:54.000000', 'temperatura', 770.0000, 'ºC'),
	(142259, 118, '2014-01-15 00:05:55.000000', 'temperatura', 857.0000, 'ºC'),
	(142260, 118, '2014-01-15 00:05:56.000000', 'temperatura', 774.0000, 'ºC'),
	(142261, 118, '2014-01-15 00:05:57.000000', 'temperatura', 101.0000, 'ºC'),
	(142262, 118, '2014-01-15 00:05:58.000000', 'temperatura', 585.0000, 'ºC'),
	(142263, 118, '2014-01-15 00:05:59.000000', 'temperatura', 219.0000, 'ºC'),
	(142264, 118, '2014-01-15 00:06:00.000000', 'temperatura', 544.0000, 'ºC'),
	(142265, 118, '2014-01-15 00:06:01.000000', 'temperatura', 862.0000, 'ºC'),
	(142266, 118, '2014-01-15 00:06:02.000000', 'temperatura', 280.0000, 'ºC'),
	(142267, 118, '2014-01-15 00:06:03.000000', 'temperatura', 13.0000, 'ºC'),
	(142268, 118, '2014-01-15 00:06:04.000000', 'temperatura', 424.0000, 'ºC'),
	(142269, 118, '2014-01-15 00:06:05.000000', 'temperatura', 882.0000, 'ºC'),
	(142270, 118, '2014-01-15 00:06:06.000000', 'temperatura', 739.0000, 'ºC'),
	(142271, 118, '2014-01-15 00:06:07.000000', 'temperatura', 1049.0000, 'ºC'),
	(142272, 118, '2014-01-15 00:06:08.000000', 'temperatura', 629.0000, 'ºC'),
	(142273, 118, '2014-01-15 00:06:09.000000', 'temperatura', 1197.0000, 'ºC'),
	(142274, 118, '2014-01-15 00:06:10.000000', 'temperatura', 501.0000, 'ºC'),
	(142275, 118, '2014-01-15 00:06:11.000000', 'temperatura', 113.0000, 'ºC'),
	(142276, 118, '2014-01-15 00:06:12.000000', 'temperatura', 264.0000, 'ºC'),
	(142277, 118, '2014-01-15 00:06:13.000000', 'temperatura', 982.0000, 'ºC'),
	(142278, 118, '2014-01-15 00:06:14.000000', 'temperatura', 516.0000, 'ºC'),
	(142279, 118, '2014-01-15 00:06:15.000000', 'temperatura', 837.0000, 'ºC'),
	(142280, 118, '2014-01-15 00:06:16.000000', 'temperatura', 236.0000, 'ºC'),
	(142281, 118, '2014-01-15 00:06:17.000000', 'temperatura', 1070.0000, 'ºC'),
	(142282, 118, '2014-01-15 00:06:18.000000', 'temperatura', 1041.0000, 'ºC'),
	(142283, 118, '2014-01-15 00:06:19.000000', 'temperatura', 794.0000, 'ºC'),
	(142284, 118, '2014-01-15 00:06:20.000000', 'temperatura', 851.0000, 'ºC'),
	(142285, 118, '2014-01-15 00:06:21.000000', 'temperatura', 674.0000, 'ºC'),
	(142286, 118, '2014-01-15 00:06:22.000000', 'temperatura', 815.0000, 'ºC'),
	(142287, 118, '2014-01-15 00:06:23.000000', 'temperatura', 855.0000, 'ºC'),
	(142288, 118, '2014-01-15 00:06:24.000000', 'temperatura', 631.0000, 'ºC'),
	(142289, 118, '2014-01-15 00:06:25.000000', 'temperatura', 592.0000, 'ºC'),
	(142290, 118, '2014-01-15 00:06:26.000000', 'temperatura', 1065.0000, 'ºC'),
	(142291, 118, '2014-01-15 00:06:27.000000', 'temperatura', 1150.0000, 'ºC'),
	(142292, 118, '2014-01-15 00:06:28.000000', 'temperatura', 154.0000, 'ºC'),
	(142293, 118, '2014-01-15 00:06:29.000000', 'temperatura', 920.0000, 'ºC'),
	(142294, 118, '2014-01-15 00:06:30.000000', 'temperatura', 538.0000, 'ºC'),
	(142295, 118, '2014-01-15 00:06:31.000000', 'temperatura', 1131.0000, 'ºC'),
	(142296, 118, '2014-01-15 00:06:32.000000', 'temperatura', 440.0000, 'ºC'),
	(142297, 118, '2014-01-15 00:06:33.000000', 'temperatura', 11.0000, 'ºC'),
	(142298, 118, '2014-01-15 00:06:34.000000', 'temperatura', 1133.0000, 'ºC'),
	(142299, 118, '2014-01-15 00:06:35.000000', 'temperatura', 832.0000, 'ºC'),
	(142300, 118, '2014-01-15 00:06:36.000000', 'temperatura', 761.0000, 'ºC'),
	(142301, 118, '2014-01-15 00:06:37.000000', 'temperatura', 111.0000, 'ºC'),
	(142302, 118, '2014-01-15 00:06:38.000000', 'temperatura', 673.0000, 'ºC'),
	(142303, 118, '2014-01-15 00:06:39.000000', 'temperatura', 631.0000, 'ºC'),
	(142304, 118, '2014-01-15 00:06:40.000000', 'temperatura', 1137.0000, 'ºC'),
	(142305, 118, '2014-01-15 00:06:41.000000', 'temperatura', 191.0000, 'ºC'),
	(142306, 118, '2014-01-15 00:06:42.000000', 'temperatura', 1144.0000, 'ºC'),
	(142307, 118, '2014-01-15 00:06:43.000000', 'temperatura', 348.0000, 'ºC'),
	(142308, 118, '2014-01-15 00:06:44.000000', 'temperatura', 709.0000, 'ºC'),
	(142309, 118, '2014-01-15 00:06:45.000000', 'temperatura', 102.0000, 'ºC'),
	(142310, 118, '2014-01-15 00:06:46.000000', 'temperatura', 784.0000, 'ºC'),
	(142311, 118, '2014-01-15 00:06:47.000000', 'temperatura', 16.0000, 'ºC'),
	(142312, 118, '2014-01-15 00:06:48.000000', 'temperatura', 125.0000, 'ºC'),
	(142313, 118, '2014-01-15 00:06:49.000000', 'temperatura', 579.0000, 'ºC'),
	(142314, 118, '2014-01-15 00:06:50.000000', 'temperatura', 119.0000, 'ºC'),
	(142315, 118, '2014-01-15 00:06:51.000000', 'temperatura', 58.0000, 'ºC'),
	(142316, 118, '2014-01-15 00:06:52.000000', 'temperatura', 1132.0000, 'ºC'),
	(142317, 118, '2014-01-15 00:06:53.000000', 'temperatura', 690.0000, 'ºC'),
	(142318, 118, '2014-01-15 00:06:54.000000', 'temperatura', 53.0000, 'ºC'),
	(142319, 118, '2014-01-15 00:06:55.000000', 'temperatura', 598.0000, 'ºC'),
	(142320, 118, '2014-01-15 00:06:56.000000', 'temperatura', 428.0000, 'ºC'),
	(142321, 118, '2014-01-15 00:06:57.000000', 'temperatura', 348.0000, 'ºC'),
	(142322, 118, '2014-01-15 00:06:58.000000', 'temperatura', 455.0000, 'ºC'),
	(142323, 118, '2014-01-15 00:06:59.000000', 'temperatura', 34.0000, 'ºC'),
	(142324, 118, '2014-01-15 00:07:00.000000', 'temperatura', 4.0000, 'ºC'),
	(142325, 118, '2014-01-15 00:07:01.000000', 'temperatura', 1120.0000, 'ºC'),
	(142326, 118, '2014-01-15 00:07:02.000000', 'temperatura', 788.0000, 'ºC'),
	(142327, 118, '2014-01-15 00:07:03.000000', 'temperatura', 580.0000, 'ºC'),
	(142328, 118, '2014-01-15 00:07:04.000000', 'temperatura', 536.0000, 'ºC'),
	(142329, 118, '2014-01-15 00:07:05.000000', 'temperatura', 940.0000, 'ºC'),
	(142330, 118, '2014-01-15 00:07:06.000000', 'temperatura', 693.0000, 'ºC'),
	(142331, 118, '2014-01-15 00:07:07.000000', 'temperatura', 647.0000, 'ºC'),
	(142332, 118, '2014-01-15 00:07:08.000000', 'temperatura', 1155.0000, 'ºC'),
	(142333, 118, '2014-01-15 00:07:09.000000', 'temperatura', 236.0000, 'ºC'),
	(142334, 118, '2014-01-15 00:07:10.000000', 'temperatura', 115.0000, 'ºC'),
	(142335, 118, '2014-01-15 00:07:11.000000', 'temperatura', 1069.0000, 'ºC'),
	(142336, 118, '2014-01-15 00:07:12.000000', 'temperatura', 200.0000, 'ºC'),
	(142337, 118, '2014-01-15 00:07:13.000000', 'temperatura', 191.0000, 'ºC'),
	(142338, 118, '2014-01-15 00:07:14.000000', 'temperatura', 357.0000, 'ºC'),
	(142339, 118, '2014-01-15 00:07:15.000000', 'temperatura', 14.0000, 'ºC'),
	(142340, 118, '2014-01-15 00:07:16.000000', 'temperatura', 196.0000, 'ºC'),
	(142341, 118, '2014-01-15 00:07:17.000000', 'temperatura', 942.0000, 'ºC'),
	(142342, 118, '2014-01-15 00:07:18.000000', 'temperatura', 522.0000, 'ºC'),
	(142343, 118, '2014-01-15 00:07:19.000000', 'temperatura', 982.0000, 'ºC'),
	(142344, 118, '2014-01-15 00:07:20.000000', 'temperatura', 945.0000, 'ºC'),
	(142345, 118, '2014-01-15 00:07:21.000000', 'temperatura', 582.0000, 'ºC'),
	(142346, 118, '2014-01-15 00:07:22.000000', 'temperatura', 73.0000, 'ºC'),
	(142347, 118, '2014-01-15 00:07:23.000000', 'temperatura', 1020.0000, 'ºC'),
	(142348, 118, '2014-01-15 00:07:24.000000', 'temperatura', 83.0000, 'ºC'),
	(142349, 118, '2014-01-15 00:07:25.000000', 'temperatura', 956.0000, 'ºC'),
	(142350, 118, '2014-01-15 00:07:26.000000', 'temperatura', 932.0000, 'ºC'),
	(142351, 118, '2014-01-15 00:07:27.000000', 'temperatura', 591.0000, 'ºC'),
	(142352, 118, '2014-01-15 00:07:28.000000', 'temperatura', 160.0000, 'ºC'),
	(142353, 118, '2014-01-15 00:07:29.000000', 'temperatura', 227.0000, 'ºC'),
	(142354, 118, '2014-01-15 00:07:30.000000', 'temperatura', 657.0000, 'ºC'),
	(142355, 118, '2014-01-15 00:07:31.000000', 'temperatura', 204.0000, 'ºC'),
	(142356, 118, '2014-01-15 00:07:32.000000', 'temperatura', 250.0000, 'ºC'),
	(142357, 118, '2014-01-15 00:07:33.000000', 'temperatura', 637.0000, 'ºC'),
	(142358, 118, '2014-01-15 00:07:34.000000', 'temperatura', 36.0000, 'ºC'),
	(142359, 118, '2014-01-15 00:07:35.000000', 'temperatura', 669.0000, 'ºC'),
	(142360, 118, '2014-01-15 00:07:36.000000', 'temperatura', 840.0000, 'ºC'),
	(142361, 118, '2014-01-15 00:07:37.000000', 'temperatura', 992.0000, 'ºC'),
	(142362, 118, '2014-01-15 00:07:38.000000', 'temperatura', 41.0000, 'ºC'),
	(142363, 118, '2014-01-15 00:07:39.000000', 'temperatura', 831.0000, 'ºC'),
	(142364, 118, '2014-01-15 00:07:40.000000', 'temperatura', 430.0000, 'ºC'),
	(142365, 118, '2014-01-15 00:07:41.000000', 'temperatura', 856.0000, 'ºC'),
	(142366, 118, '2014-01-15 00:07:42.000000', 'temperatura', 593.0000, 'ºC'),
	(142367, 118, '2014-01-15 00:07:43.000000', 'temperatura', 397.0000, 'ºC'),
	(142368, 118, '2014-01-15 00:07:44.000000', 'temperatura', 208.0000, 'ºC'),
	(142369, 118, '2014-01-15 00:07:45.000000', 'temperatura', 1046.0000, 'ºC'),
	(142370, 118, '2014-01-15 00:07:46.000000', 'temperatura', 1010.0000, 'ºC'),
	(142371, 118, '2014-01-15 00:07:47.000000', 'temperatura', 710.0000, 'ºC'),
	(142372, 118, '2014-01-15 00:07:48.000000', 'temperatura', 524.0000, 'ºC'),
	(142373, 118, '2014-01-15 00:07:49.000000', 'temperatura', 487.0000, 'ºC'),
	(142374, 118, '2014-01-15 00:07:50.000000', 'temperatura', 863.0000, 'ºC'),
	(142375, 118, '2014-01-15 00:07:51.000000', 'temperatura', 454.0000, 'ºC'),
	(142376, 118, '2014-01-15 00:07:52.000000', 'temperatura', 881.0000, 'ºC'),
	(142377, 118, '2014-01-15 00:07:53.000000', 'temperatura', 645.0000, 'ºC'),
	(142378, 118, '2014-01-15 00:07:54.000000', 'temperatura', 583.0000, 'ºC'),
	(142379, 118, '2014-01-15 00:07:55.000000', 'temperatura', 981.0000, 'ºC'),
	(142380, 118, '2014-01-15 00:07:56.000000', 'temperatura', 756.0000, 'ºC'),
	(142381, 118, '2014-01-15 00:07:57.000000', 'temperatura', 838.0000, 'ºC'),
	(142382, 118, '2014-01-15 00:07:58.000000', 'temperatura', 723.0000, 'ºC'),
	(142383, 118, '2014-01-15 00:07:59.000000', 'temperatura', 1102.0000, 'ºC'),
	(142384, 118, '2014-01-15 00:08:00.000000', 'temperatura', 943.0000, 'ºC'),
	(142385, 118, '2014-01-15 00:08:01.000000', 'temperatura', 206.0000, 'ºC'),
	(142386, 118, '2014-01-15 00:08:02.000000', 'temperatura', 602.0000, 'ºC'),
	(142387, 118, '2014-01-15 00:08:03.000000', 'temperatura', 1192.0000, 'ºC'),
	(142388, 118, '2014-01-15 00:08:04.000000', 'temperatura', 555.0000, 'ºC'),
	(142389, 118, '2014-01-15 00:08:05.000000', 'temperatura', 399.0000, 'ºC'),
	(142390, 118, '2014-01-15 00:08:06.000000', 'temperatura', 331.0000, 'ºC'),
	(142391, 118, '2014-01-15 00:08:07.000000', 'temperatura', 457.0000, 'ºC'),
	(142392, 118, '2014-01-15 00:08:08.000000', 'temperatura', 93.0000, 'ºC'),
	(142393, 118, '2014-01-15 00:08:09.000000', 'temperatura', 293.0000, 'ºC'),
	(142394, 118, '2014-01-15 00:08:10.000000', 'temperatura', 1188.0000, 'ºC'),
	(142395, 118, '2014-01-15 00:08:11.000000', 'temperatura', 260.0000, 'ºC'),
	(142396, 118, '2014-01-15 00:08:12.000000', 'temperatura', 140.0000, 'ºC'),
	(142397, 118, '2014-01-15 00:08:13.000000', 'temperatura', 1117.0000, 'ºC'),
	(142398, 118, '2014-01-15 00:08:14.000000', 'temperatura', 367.0000, 'ºC'),
	(142399, 118, '2014-01-15 00:08:15.000000', 'temperatura', 883.0000, 'ºC'),
	(142400, 118, '2014-01-15 00:08:16.000000', 'temperatura', 914.0000, 'ºC'),
	(142401, 118, '2014-01-15 00:08:17.000000', 'temperatura', 721.0000, 'ºC'),
	(142402, 118, '2014-01-15 00:08:18.000000', 'temperatura', 864.0000, 'ºC'),
	(142403, 118, '2014-01-15 00:08:19.000000', 'temperatura', 957.0000, 'ºC'),
	(142404, 118, '2014-01-15 00:08:20.000000', 'temperatura', 992.0000, 'ºC'),
	(142405, 118, '2014-01-15 00:08:21.000000', 'temperatura', 891.0000, 'ºC'),
	(142406, 118, '2014-01-15 00:08:22.000000', 'temperatura', 279.0000, 'ºC'),
	(142407, 118, '2014-01-15 00:08:23.000000', 'temperatura', 1122.0000, 'ºC'),
	(142408, 118, '2014-01-15 00:08:24.000000', 'temperatura', 1176.0000, 'ºC'),
	(142409, 118, '2014-01-15 00:08:25.000000', 'temperatura', 112.0000, 'ºC'),
	(142410, 118, '2014-01-15 00:08:26.000000', 'temperatura', 633.0000, 'ºC'),
	(142411, 118, '2014-01-15 00:08:27.000000', 'temperatura', 429.0000, 'ºC'),
	(142412, 118, '2014-01-15 00:08:28.000000', 'temperatura', 248.0000, 'ºC'),
	(142413, 118, '2014-01-15 00:08:29.000000', 'temperatura', 1154.0000, 'ºC'),
	(142414, 118, '2014-01-15 00:08:30.000000', 'temperatura', 227.0000, 'ºC'),
	(142415, 118, '2014-01-15 00:08:31.000000', 'temperatura', 73.0000, 'ºC'),
	(142416, 118, '2014-01-15 00:08:32.000000', 'temperatura', 886.0000, 'ºC'),
	(142417, 118, '2014-01-15 00:08:33.000000', 'temperatura', 609.0000, 'ºC'),
	(142418, 118, '2014-01-15 00:08:34.000000', 'temperatura', 389.0000, 'ºC'),
	(142419, 118, '2014-01-15 00:08:35.000000', 'temperatura', 120.0000, 'ºC'),
	(142420, 118, '2014-01-15 00:08:36.000000', 'temperatura', 633.0000, 'ºC'),
	(142421, 118, '2014-01-15 00:08:37.000000', 'temperatura', 404.0000, 'ºC'),
	(142422, 118, '2014-01-15 00:08:38.000000', 'temperatura', 121.0000, 'ºC'),
	(142423, 118, '2014-01-15 00:08:39.000000', 'temperatura', 592.0000, 'ºC'),
	(142424, 118, '2014-01-15 00:08:40.000000', 'temperatura', 200.0000, 'ºC'),
	(142425, 118, '2014-01-15 00:08:41.000000', 'temperatura', 423.0000, 'ºC'),
	(142426, 118, '2014-01-15 00:08:42.000000', 'temperatura', 315.0000, 'ºC'),
	(142427, 118, '2014-01-15 00:08:43.000000', 'temperatura', 308.0000, 'ºC'),
	(142428, 118, '2014-01-15 00:08:44.000000', 'temperatura', 596.0000, 'ºC'),
	(142429, 118, '2014-01-15 00:08:45.000000', 'temperatura', 855.0000, 'ºC'),
	(142430, 118, '2014-01-15 00:08:46.000000', 'temperatura', 86.0000, 'ºC'),
	(142431, 118, '2014-01-15 00:08:47.000000', 'temperatura', 269.0000, 'ºC'),
	(142432, 118, '2014-01-15 00:08:48.000000', 'temperatura', 1084.0000, 'ºC'),
	(142433, 118, '2014-01-15 00:08:49.000000', 'temperatura', 1015.0000, 'ºC'),
	(142434, 118, '2014-01-15 00:08:50.000000', 'temperatura', 625.0000, 'ºC'),
	(142435, 118, '2014-01-15 00:08:51.000000', 'temperatura', 80.0000, 'ºC'),
	(142436, 118, '2014-01-15 00:08:52.000000', 'temperatura', 925.0000, 'ºC'),
	(142437, 118, '2014-01-15 00:08:53.000000', 'temperatura', 786.0000, 'ºC'),
	(142438, 118, '2014-01-15 00:08:54.000000', 'temperatura', 1157.0000, 'ºC'),
	(142439, 118, '2014-01-15 00:08:55.000000', 'temperatura', 1027.0000, 'ºC'),
	(142440, 118, '2014-01-15 00:08:56.000000', 'temperatura', 464.0000, 'ºC'),
	(142441, 118, '2014-01-15 00:08:57.000000', 'temperatura', 438.0000, 'ºC'),
	(142442, 118, '2014-01-15 00:08:58.000000', 'temperatura', 800.0000, 'ºC'),
	(142443, 118, '2014-01-15 00:08:59.000000', 'temperatura', 284.0000, 'ºC'),
	(142444, 118, '2014-01-15 00:09:00.000000', 'temperatura', 223.0000, 'ºC'),
	(142445, 118, '2014-01-15 00:09:01.000000', 'temperatura', 265.0000, 'ºC'),
	(142446, 118, '2014-01-15 00:09:02.000000', 'temperatura', 654.0000, 'ºC'),
	(142447, 118, '2014-01-15 00:09:03.000000', 'temperatura', 76.0000, 'ºC'),
	(142448, 118, '2014-01-15 00:09:04.000000', 'temperatura', 818.0000, 'ºC'),
	(142449, 118, '2014-01-15 00:09:05.000000', 'temperatura', 262.0000, 'ºC'),
	(142450, 118, '2014-01-15 00:09:06.000000', 'temperatura', 57.0000, 'ºC'),
	(142451, 118, '2014-01-15 00:09:07.000000', 'temperatura', 700.0000, 'ºC'),
	(142452, 118, '2014-01-15 00:09:08.000000', 'temperatura', 929.0000, 'ºC'),
	(142453, 118, '2014-01-15 00:09:09.000000', 'temperatura', 145.0000, 'ºC'),
	(142454, 118, '2014-01-15 00:09:10.000000', 'temperatura', 339.0000, 'ºC'),
	(142455, 118, '2014-01-15 00:09:11.000000', 'temperatura', 61.0000, 'ºC'),
	(142456, 118, '2014-01-15 00:09:12.000000', 'temperatura', 487.0000, 'ºC'),
	(142457, 118, '2014-01-15 00:09:13.000000', 'temperatura', 1052.0000, 'ºC'),
	(142458, 118, '2014-01-15 00:09:14.000000', 'temperatura', 199.0000, 'ºC'),
	(142459, 118, '2014-01-15 00:09:15.000000', 'temperatura', 242.0000, 'ºC'),
	(142460, 118, '2014-01-15 00:09:16.000000', 'temperatura', 610.0000, 'ºC'),
	(142461, 118, '2014-01-15 00:09:17.000000', 'temperatura', 1128.0000, 'ºC'),
	(142462, 118, '2014-01-15 00:09:18.000000', 'temperatura', 208.0000, 'ºC'),
	(142463, 118, '2014-01-15 00:09:19.000000', 'temperatura', 57.0000, 'ºC'),
	(142464, 118, '2014-01-15 00:09:20.000000', 'temperatura', 862.0000, 'ºC'),
	(142465, 118, '2014-01-15 00:09:21.000000', 'temperatura', 540.0000, 'ºC'),
	(142466, 118, '2014-01-15 00:09:22.000000', 'temperatura', 115.0000, 'ºC'),
	(142467, 118, '2014-01-15 00:09:23.000000', 'temperatura', 154.0000, 'ºC'),
	(142468, 118, '2014-01-15 00:09:24.000000', 'temperatura', 426.0000, 'ºC'),
	(142469, 118, '2014-01-15 00:09:25.000000', 'temperatura', 470.0000, 'ºC'),
	(142470, 118, '2014-01-15 00:09:26.000000', 'temperatura', 1074.0000, 'ºC'),
	(142471, 118, '2014-01-15 00:09:27.000000', 'temperatura', 357.0000, 'ºC'),
	(142472, 118, '2014-01-15 00:09:28.000000', 'temperatura', 965.0000, 'ºC'),
	(142473, 118, '2014-01-15 00:09:29.000000', 'temperatura', 156.0000, 'ºC'),
	(142474, 118, '2014-01-15 00:09:30.000000', 'temperatura', 283.0000, 'ºC'),
	(142475, 118, '2014-01-15 00:09:31.000000', 'temperatura', 947.0000, 'ºC'),
	(142476, 118, '2014-01-15 00:09:32.000000', 'temperatura', 286.0000, 'ºC'),
	(142477, 118, '2014-01-15 00:09:33.000000', 'temperatura', 992.0000, 'ºC'),
	(142478, 118, '2014-01-15 00:09:34.000000', 'temperatura', 499.0000, 'ºC'),
	(142479, 118, '2014-01-15 00:09:35.000000', 'temperatura', 723.0000, 'ºC'),
	(142480, 118, '2014-01-15 00:09:36.000000', 'temperatura', 919.0000, 'ºC'),
	(142481, 118, '2014-01-15 00:09:37.000000', 'temperatura', 24.0000, 'ºC'),
	(142482, 118, '2014-01-15 00:09:38.000000', 'temperatura', 964.0000, 'ºC'),
	(142483, 118, '2014-01-15 00:09:39.000000', 'temperatura', 1150.0000, 'ºC'),
	(142484, 118, '2014-01-15 00:09:40.000000', 'temperatura', 458.0000, 'ºC'),
	(142485, 118, '2014-01-15 00:09:41.000000', 'temperatura', 41.0000, 'ºC'),
	(142486, 118, '2014-01-15 00:09:42.000000', 'temperatura', 30.0000, 'ºC'),
	(142487, 118, '2014-01-15 00:09:43.000000', 'temperatura', 28.0000, 'ºC'),
	(142488, 118, '2014-01-15 00:09:44.000000', 'temperatura', 49.0000, 'ºC'),
	(142489, 118, '2014-01-15 00:09:45.000000', 'temperatura', 164.0000, 'ºC'),
	(142490, 118, '2014-01-15 00:09:46.000000', 'temperatura', 672.0000, 'ºC'),
	(142491, 118, '2014-01-15 00:09:47.000000', 'temperatura', 469.0000, 'ºC'),
	(142492, 118, '2014-01-15 00:09:48.000000', 'temperatura', 328.0000, 'ºC'),
	(142493, 118, '2014-01-15 00:09:49.000000', 'temperatura', 236.0000, 'ºC'),
	(142494, 118, '2014-01-15 00:09:50.000000', 'temperatura', 194.0000, 'ºC'),
	(142495, 118, '2014-01-15 00:09:51.000000', 'temperatura', 263.0000, 'ºC'),
	(142496, 118, '2014-01-15 00:09:52.000000', 'temperatura', 733.0000, 'ºC'),
	(142497, 118, '2014-01-15 00:09:53.000000', 'temperatura', 475.0000, 'ºC'),
	(142498, 118, '2014-01-15 00:09:54.000000', 'temperatura', 180.0000, 'ºC'),
	(142499, 118, '2014-01-15 00:09:55.000000', 'temperatura', 673.0000, 'ºC'),
	(142500, 118, '2014-01-15 00:09:56.000000', 'temperatura', 427.0000, 'ºC'),
	(142501, 118, '2014-01-15 00:09:57.000000', 'temperatura', 117.0000, 'ºC'),
	(142502, 118, '2014-01-15 00:09:58.000000', 'temperatura', 504.0000, 'ºC'),
	(142503, 118, '2014-01-15 00:09:59.000000', 'temperatura', 967.0000, 'ºC'),
	(142504, 118, '2014-01-15 00:10:00.000000', 'temperatura', 927.0000, 'ºC'),
	(142505, 118, '2014-01-15 00:10:01.000000', 'temperatura', 533.0000, 'ºC'),
	(142506, 118, '2014-01-15 00:10:02.000000', 'temperatura', 1083.0000, 'ºC'),
	(142507, 118, '2014-01-15 00:10:03.000000', 'temperatura', 219.0000, 'ºC'),
	(142508, 118, '2014-01-15 00:10:04.000000', 'temperatura', 245.0000, 'ºC'),
	(142509, 118, '2014-01-15 00:10:05.000000', 'temperatura', 569.0000, 'ºC'),
	(142510, 118, '2014-01-15 00:10:06.000000', 'temperatura', 909.0000, 'ºC'),
	(142511, 118, '2014-01-15 00:10:07.000000', 'temperatura', 441.0000, 'ºC'),
	(142512, 118, '2014-01-15 00:10:08.000000', 'temperatura', 678.0000, 'ºC'),
	(142513, 118, '2014-01-15 00:10:09.000000', 'temperatura', 869.0000, 'ºC'),
	(142514, 118, '2014-01-15 00:10:10.000000', 'temperatura', 1111.0000, 'ºC'),
	(142515, 118, '2014-01-15 00:10:11.000000', 'temperatura', 547.0000, 'ºC'),
	(142516, 118, '2014-01-15 00:10:12.000000', 'temperatura', 601.0000, 'ºC'),
	(142517, 118, '2014-01-15 00:10:13.000000', 'temperatura', 166.0000, 'ºC'),
	(142518, 118, '2014-01-15 00:10:14.000000', 'temperatura', 229.0000, 'ºC'),
	(142519, 118, '2014-01-15 00:10:15.000000', 'temperatura', 648.0000, 'ºC'),
	(142520, 118, '2014-01-15 00:10:16.000000', 'temperatura', 151.0000, 'ºC'),
	(142521, 118, '2014-01-15 00:10:17.000000', 'temperatura', 12.0000, 'ºC'),
	(142522, 118, '2014-01-15 00:10:18.000000', 'temperatura', 810.0000, 'ºC'),
	(142523, 118, '2014-01-15 00:10:19.000000', 'temperatura', 411.0000, 'ºC'),
	(142524, 118, '2014-01-15 00:10:20.000000', 'temperatura', 827.0000, 'ºC'),
	(142525, 118, '2014-01-15 00:10:21.000000', 'temperatura', 504.0000, 'ºC'),
	(142526, 118, '2014-01-15 00:10:22.000000', 'temperatura', 39.0000, 'ºC'),
	(142527, 118, '2014-01-15 00:10:23.000000', 'temperatura', 1085.0000, 'ºC'),
	(142528, 118, '2014-01-15 00:10:24.000000', 'temperatura', 507.0000, 'ºC'),
	(142529, 118, '2014-01-15 00:10:25.000000', 'temperatura', 481.0000, 'ºC'),
	(142530, 118, '2014-01-15 00:10:26.000000', 'temperatura', 886.0000, 'ºC'),
	(142531, 118, '2014-01-15 00:10:27.000000', 'temperatura', 585.0000, 'ºC'),
	(142532, 118, '2014-01-15 00:10:28.000000', 'temperatura', 269.0000, 'ºC'),
	(142533, 118, '2014-01-15 00:10:29.000000', 'temperatura', 791.0000, 'ºC'),
	(142534, 118, '2014-01-15 00:10:30.000000', 'temperatura', 746.0000, 'ºC'),
	(142535, 118, '2014-01-15 00:10:31.000000', 'temperatura', 159.0000, 'ºC'),
	(142536, 118, '2014-01-15 00:10:32.000000', 'temperatura', 958.0000, 'ºC'),
	(142537, 118, '2014-01-15 00:10:33.000000', 'temperatura', 715.0000, 'ºC'),
	(142538, 118, '2014-01-15 00:10:34.000000', 'temperatura', 699.0000, 'ºC'),
	(142539, 118, '2014-01-15 00:10:35.000000', 'temperatura', 151.0000, 'ºC'),
	(142540, 118, '2014-01-15 00:10:36.000000', 'temperatura', 1057.0000, 'ºC'),
	(142541, 118, '2014-01-15 00:10:37.000000', 'temperatura', 33.0000, 'ºC'),
	(142542, 118, '2014-01-15 00:10:38.000000', 'temperatura', 593.0000, 'ºC'),
	(142543, 118, '2014-01-15 00:10:39.000000', 'temperatura', 470.0000, 'ºC'),
	(142544, 118, '2014-01-15 00:10:40.000000', 'temperatura', 569.0000, 'ºC'),
	(142545, 118, '2014-01-15 00:10:41.000000', 'temperatura', 237.0000, 'ºC'),
	(142546, 118, '2014-01-15 00:10:42.000000', 'temperatura', 677.0000, 'ºC'),
	(142547, 118, '2014-01-15 00:10:43.000000', 'temperatura', 275.0000, 'ºC'),
	(142548, 118, '2014-01-15 00:10:44.000000', 'temperatura', 544.0000, 'ºC'),
	(142549, 118, '2014-01-15 00:10:45.000000', 'temperatura', 694.0000, 'ºC'),
	(142550, 118, '2014-01-15 00:10:46.000000', 'temperatura', 639.0000, 'ºC'),
	(142551, 118, '2014-01-15 00:10:47.000000', 'temperatura', 1114.0000, 'ºC'),
	(142552, 118, '2014-01-15 00:10:48.000000', 'temperatura', 55.0000, 'ºC'),
	(142553, 118, '2014-01-15 00:10:49.000000', 'temperatura', 534.0000, 'ºC'),
	(142554, 118, '2014-01-15 00:10:50.000000', 'temperatura', 104.0000, 'ºC'),
	(142555, 118, '2014-01-15 00:10:51.000000', 'temperatura', 120.0000, 'ºC'),
	(142556, 118, '2014-01-15 00:10:52.000000', 'temperatura', 288.0000, 'ºC'),
	(142557, 118, '2014-01-15 00:10:53.000000', 'temperatura', 1079.0000, 'ºC'),
	(142558, 118, '2014-01-15 00:10:54.000000', 'temperatura', 934.0000, 'ºC'),
	(142559, 118, '2014-01-15 00:10:55.000000', 'temperatura', 232.0000, 'ºC'),
	(142560, 118, '2014-01-15 00:10:56.000000', 'temperatura', 759.0000, 'ºC'),
	(142561, 118, '2014-01-15 00:10:57.000000', 'temperatura', 699.0000, 'ºC'),
	(142562, 118, '2014-01-15 00:10:58.000000', 'temperatura', 17.0000, 'ºC'),
	(142563, 118, '2014-01-15 00:10:59.000000', 'temperatura', 390.0000, 'ºC'),
	(142564, 118, '2014-01-15 00:11:00.000000', 'temperatura', 699.0000, 'ºC'),
	(142565, 118, '2014-01-15 00:11:01.000000', 'temperatura', 1127.0000, 'ºC'),
	(142566, 118, '2014-01-15 00:11:02.000000', 'temperatura', 1136.0000, 'ºC'),
	(142567, 118, '2014-01-15 00:11:03.000000', 'temperatura', 1099.0000, 'ºC'),
	(142568, 118, '2014-01-15 00:11:04.000000', 'temperatura', 888.0000, 'ºC'),
	(142569, 118, '2014-01-15 00:11:05.000000', 'temperatura', 1144.0000, 'ºC'),
	(142570, 118, '2014-01-15 00:11:06.000000', 'temperatura', 658.0000, 'ºC'),
	(142571, 118, '2014-01-15 00:11:07.000000', 'temperatura', 1057.0000, 'ºC'),
	(142572, 118, '2014-01-15 00:11:08.000000', 'temperatura', 912.0000, 'ºC'),
	(142573, 118, '2014-01-15 00:11:09.000000', 'temperatura', 189.0000, 'ºC'),
	(142574, 118, '2014-01-15 00:11:10.000000', 'temperatura', 610.0000, 'ºC'),
	(142575, 118, '2014-01-15 00:11:11.000000', 'temperatura', 85.0000, 'ºC'),
	(142576, 118, '2014-01-15 00:11:12.000000', 'temperatura', 996.0000, 'ºC'),
	(142577, 118, '2014-01-15 00:11:13.000000', 'temperatura', 1125.0000, 'ºC'),
	(142578, 118, '2014-01-15 00:11:14.000000', 'temperatura', 237.0000, 'ºC'),
	(142579, 118, '2014-01-15 00:11:15.000000', 'temperatura', 212.0000, 'ºC'),
	(142580, 118, '2014-01-15 00:11:16.000000', 'temperatura', 351.0000, 'ºC'),
	(142581, 118, '2014-01-15 00:11:17.000000', 'temperatura', 1116.0000, 'ºC'),
	(142582, 118, '2014-01-15 00:11:18.000000', 'temperatura', 927.0000, 'ºC'),
	(142583, 118, '2014-01-15 00:11:19.000000', 'temperatura', 89.0000, 'ºC'),
	(142584, 118, '2014-01-15 00:11:20.000000', 'temperatura', 65.0000, 'ºC'),
	(142585, 118, '2014-01-15 00:11:21.000000', 'temperatura', 58.0000, 'ºC'),
	(142586, 118, '2014-01-15 00:11:22.000000', 'temperatura', 94.0000, 'ºC'),
	(142587, 118, '2014-01-15 00:11:23.000000', 'temperatura', 297.0000, 'ºC'),
	(142588, 118, '2014-01-15 00:11:24.000000', 'temperatura', 6.0000, 'ºC'),
	(142589, 118, '2014-01-15 00:11:25.000000', 'temperatura', 337.0000, 'ºC'),
	(142590, 118, '2014-01-15 00:11:26.000000', 'temperatura', 468.0000, 'ºC'),
	(142591, 118, '2014-01-15 00:11:27.000000', 'temperatura', 131.0000, 'ºC'),
	(142592, 118, '2014-01-15 00:11:28.000000', 'temperatura', 449.0000, 'ºC'),
	(142593, 118, '2014-01-15 00:11:29.000000', 'temperatura', 654.0000, 'ºC'),
	(142594, 118, '2014-01-15 00:11:30.000000', 'temperatura', 723.0000, 'ºC'),
	(142595, 118, '2014-01-15 00:11:31.000000', 'temperatura', 455.0000, 'ºC'),
	(142596, 118, '2014-01-15 00:11:32.000000', 'temperatura', 107.0000, 'ºC'),
	(142597, 118, '2014-01-15 00:11:33.000000', 'temperatura', 370.0000, 'ºC'),
	(142598, 118, '2014-01-15 00:11:34.000000', 'temperatura', 328.0000, 'ºC'),
	(142599, 118, '2014-01-15 00:11:35.000000', 'temperatura', 532.0000, 'ºC'),
	(142600, 118, '2014-01-15 00:11:36.000000', 'temperatura', 476.0000, 'ºC'),
	(142601, 118, '2014-01-15 00:11:37.000000', 'temperatura', 786.0000, 'ºC'),
	(142602, 118, '2014-01-15 00:11:38.000000', 'temperatura', 100.0000, 'ºC'),
	(142603, 118, '2014-01-15 00:11:39.000000', 'temperatura', 544.0000, 'ºC'),
	(142604, 118, '2014-01-15 00:11:40.000000', 'temperatura', 21.0000, 'ºC'),
	(142605, 118, '2014-01-15 00:11:41.000000', 'temperatura', 875.0000, 'ºC'),
	(142606, 118, '2014-01-15 00:11:42.000000', 'temperatura', 710.0000, 'ºC'),
	(142607, 118, '2014-01-15 00:11:43.000000', 'temperatura', 927.0000, 'ºC'),
	(142608, 118, '2014-01-15 00:11:44.000000', 'temperatura', 107.0000, 'ºC'),
	(142609, 118, '2014-01-15 00:11:45.000000', 'temperatura', 151.0000, 'ºC'),
	(142610, 118, '2014-01-15 00:11:46.000000', 'temperatura', 436.0000, 'ºC'),
	(142611, 118, '2014-01-15 00:11:47.000000', 'temperatura', 529.0000, 'ºC'),
	(142612, 118, '2014-01-15 00:11:48.000000', 'temperatura', 137.0000, 'ºC'),
	(142613, 118, '2014-01-15 00:11:49.000000', 'temperatura', 297.0000, 'ºC'),
	(142614, 118, '2014-01-15 00:11:50.000000', 'temperatura', 1076.0000, 'ºC'),
	(142615, 118, '2014-01-15 00:11:51.000000', 'temperatura', 890.0000, 'ºC'),
	(142616, 118, '2014-01-15 00:11:52.000000', 'temperatura', 23.0000, 'ºC'),
	(142617, 118, '2014-01-15 00:11:53.000000', 'temperatura', 1044.0000, 'ºC'),
	(142618, 118, '2014-01-15 00:11:54.000000', 'temperatura', 353.0000, 'ºC'),
	(142619, 118, '2014-01-15 00:11:55.000000', 'temperatura', 1032.0000, 'ºC'),
	(142620, 118, '2014-01-15 00:11:56.000000', 'temperatura', 500.0000, 'ºC'),
	(142621, 118, '2014-01-15 00:11:57.000000', 'temperatura', 607.0000, 'ºC'),
	(142622, 118, '2014-01-15 00:11:58.000000', 'temperatura', 334.0000, 'ºC'),
	(142623, 118, '2014-01-15 00:11:59.000000', 'temperatura', 1051.0000, 'ºC'),
	(142624, 118, '2014-01-15 00:12:00.000000', 'temperatura', 654.0000, 'ºC'),
	(142625, 118, '2014-01-15 00:12:01.000000', 'temperatura', 116.0000, 'ºC'),
	(142626, 118, '2014-01-15 00:12:02.000000', 'temperatura', 1019.0000, 'ºC'),
	(142627, 118, '2014-01-15 00:12:03.000000', 'temperatura', 1148.0000, 'ºC'),
	(142628, 118, '2014-01-15 00:12:04.000000', 'temperatura', 284.0000, 'ºC'),
	(142629, 118, '2014-01-15 00:12:05.000000', 'temperatura', 377.0000, 'ºC'),
	(142630, 118, '2014-01-15 00:12:06.000000', 'temperatura', 1034.0000, 'ºC'),
	(142631, 118, '2014-01-15 00:12:07.000000', 'temperatura', 439.0000, 'ºC'),
	(142632, 118, '2014-01-15 00:12:08.000000', 'temperatura', 294.0000, 'ºC'),
	(142633, 118, '2014-01-15 00:12:09.000000', 'temperatura', 153.0000, 'ºC'),
	(142634, 118, '2014-01-15 00:12:10.000000', 'temperatura', 1082.0000, 'ºC'),
	(142635, 118, '2014-01-15 00:12:11.000000', 'temperatura', 153.0000, 'ºC'),
	(142636, 118, '2014-01-15 00:12:12.000000', 'temperatura', 1121.0000, 'ºC'),
	(142637, 118, '2014-01-15 00:12:13.000000', 'temperatura', 346.0000, 'ºC'),
	(142638, 118, '2014-01-15 00:12:14.000000', 'temperatura', 769.0000, 'ºC'),
	(142639, 118, '2014-01-15 00:12:15.000000', 'temperatura', 405.0000, 'ºC'),
	(142640, 118, '2014-01-15 00:12:16.000000', 'temperatura', 919.0000, 'ºC'),
	(142641, 118, '2014-01-15 00:12:17.000000', 'temperatura', 979.0000, 'ºC'),
	(142642, 118, '2014-01-15 00:12:18.000000', 'temperatura', 939.0000, 'ºC'),
	(142643, 118, '2014-01-15 00:12:19.000000', 'temperatura', 560.0000, 'ºC'),
	(142644, 118, '2014-01-15 00:12:20.000000', 'temperatura', 1181.0000, 'ºC'),
	(142645, 118, '2014-01-15 00:12:21.000000', 'temperatura', 626.0000, 'ºC'),
	(142646, 118, '2014-01-15 00:12:22.000000', 'temperatura', 788.0000, 'ºC'),
	(142647, 118, '2014-01-15 00:12:23.000000', 'temperatura', 860.0000, 'ºC'),
	(142648, 118, '2014-01-15 00:12:24.000000', 'temperatura', 740.0000, 'ºC'),
	(142649, 118, '2014-01-15 00:12:25.000000', 'temperatura', 1120.0000, 'ºC'),
	(142650, 118, '2014-01-15 00:12:26.000000', 'temperatura', 982.0000, 'ºC'),
	(142651, 118, '2014-01-15 00:12:27.000000', 'temperatura', 347.0000, 'ºC'),
	(142652, 118, '2014-01-15 00:12:28.000000', 'temperatura', 1192.0000, 'ºC'),
	(142653, 118, '2014-01-15 00:12:29.000000', 'temperatura', 118.0000, 'ºC'),
	(142654, 118, '2014-01-15 00:12:30.000000', 'temperatura', 616.0000, 'ºC'),
	(142655, 118, '2014-01-15 00:12:31.000000', 'temperatura', 327.0000, 'ºC'),
	(142656, 118, '2014-01-15 00:12:32.000000', 'temperatura', 987.0000, 'ºC'),
	(142657, 118, '2014-01-15 00:12:33.000000', 'temperatura', 355.0000, 'ºC'),
	(142658, 118, '2014-01-15 00:12:34.000000', 'temperatura', 14.0000, 'ºC'),
	(142659, 118, '2014-01-15 00:12:35.000000', 'temperatura', 206.0000, 'ºC'),
	(142660, 118, '2014-01-15 00:12:36.000000', 'temperatura', 990.0000, 'ºC'),
	(142661, 118, '2014-01-15 00:12:37.000000', 'temperatura', 732.0000, 'ºC'),
	(142662, 118, '2014-01-15 00:12:38.000000', 'temperatura', 689.0000, 'ºC'),
	(142663, 118, '2014-01-15 00:12:39.000000', 'temperatura', 52.0000, 'ºC'),
	(142664, 118, '2014-01-15 00:12:40.000000', 'temperatura', 592.0000, 'ºC'),
	(142665, 118, '2014-01-15 00:12:41.000000', 'temperatura', 405.0000, 'ºC'),
	(142666, 118, '2014-01-15 00:12:42.000000', 'temperatura', 250.0000, 'ºC'),
	(142667, 118, '2014-01-15 00:12:43.000000', 'temperatura', 36.0000, 'ºC'),
	(142668, 118, '2014-01-15 00:12:44.000000', 'temperatura', 632.0000, 'ºC'),
	(142669, 118, '2014-01-15 00:12:45.000000', 'temperatura', 649.0000, 'ºC'),
	(142670, 118, '2014-01-15 00:12:46.000000', 'temperatura', 153.0000, 'ºC'),
	(142671, 118, '2014-01-15 00:12:47.000000', 'temperatura', 16.0000, 'ºC'),
	(142672, 118, '2014-01-15 00:12:48.000000', 'temperatura', 824.0000, 'ºC'),
	(142673, 118, '2014-01-15 00:12:49.000000', 'temperatura', 470.0000, 'ºC'),
	(142674, 118, '2014-01-15 00:12:50.000000', 'temperatura', 1080.0000, 'ºC'),
	(142675, 118, '2014-01-15 00:12:51.000000', 'temperatura', 391.0000, 'ºC'),
	(142676, 118, '2014-01-15 00:12:52.000000', 'temperatura', 1114.0000, 'ºC'),
	(142677, 118, '2014-01-15 00:12:53.000000', 'temperatura', 799.0000, 'ºC'),
	(142678, 118, '2014-01-15 00:12:54.000000', 'temperatura', 651.0000, 'ºC'),
	(142679, 118, '2014-01-15 00:12:55.000000', 'temperatura', 860.0000, 'ºC'),
	(142680, 118, '2014-01-15 00:12:56.000000', 'temperatura', 1148.0000, 'ºC'),
	(142681, 118, '2014-01-15 00:12:57.000000', 'temperatura', 760.0000, 'ºC'),
	(142682, 118, '2014-01-15 00:12:58.000000', 'temperatura', 358.0000, 'ºC'),
	(142683, 118, '2014-01-15 00:12:59.000000', 'temperatura', 710.0000, 'ºC'),
	(142684, 118, '2014-01-15 00:13:00.000000', 'temperatura', 77.0000, 'ºC'),
	(142685, 118, '2014-01-15 00:13:01.000000', 'temperatura', 657.0000, 'ºC'),
	(142686, 118, '2014-01-15 00:13:02.000000', 'temperatura', 652.0000, 'ºC'),
	(142687, 118, '2014-01-15 00:13:03.000000', 'temperatura', 92.0000, 'ºC'),
	(142688, 118, '2014-01-15 00:13:04.000000', 'temperatura', 902.0000, 'ºC'),
	(142689, 118, '2014-01-15 00:13:05.000000', 'temperatura', 633.0000, 'ºC'),
	(142690, 118, '2014-01-15 00:13:06.000000', 'temperatura', 462.0000, 'ºC'),
	(142691, 118, '2014-01-15 00:13:07.000000', 'temperatura', 412.0000, 'ºC'),
	(142692, 118, '2014-01-15 00:13:08.000000', 'temperatura', 673.0000, 'ºC'),
	(142693, 118, '2014-01-15 00:13:09.000000', 'temperatura', 929.0000, 'ºC'),
	(142694, 118, '2014-01-15 00:13:10.000000', 'temperatura', 226.0000, 'ºC'),
	(142695, 118, '2014-01-15 00:13:11.000000', 'temperatura', 744.0000, 'ºC'),
	(142696, 118, '2014-01-15 00:13:12.000000', 'temperatura', 642.0000, 'ºC'),
	(142697, 118, '2014-01-15 00:13:13.000000', 'temperatura', 977.0000, 'ºC'),
	(142698, 118, '2014-01-15 00:13:14.000000', 'temperatura', 563.0000, 'ºC'),
	(142699, 118, '2014-01-15 00:13:15.000000', 'temperatura', 1083.0000, 'ºC'),
	(142700, 118, '2014-01-15 00:13:16.000000', 'temperatura', 126.0000, 'ºC'),
	(142701, 118, '2014-01-15 00:13:17.000000', 'temperatura', 982.0000, 'ºC'),
	(142702, 118, '2014-01-15 00:13:18.000000', 'temperatura', 930.0000, 'ºC'),
	(142703, 118, '2014-01-15 00:13:19.000000', 'temperatura', 508.0000, 'ºC'),
	(142704, 118, '2014-01-15 00:13:20.000000', 'temperatura', 949.0000, 'ºC'),
	(142705, 118, '2014-01-15 00:13:21.000000', 'temperatura', 821.0000, 'ºC'),
	(142706, 118, '2014-01-15 00:13:22.000000', 'temperatura', 57.0000, 'ºC'),
	(142707, 118, '2014-01-15 00:13:23.000000', 'temperatura', 225.0000, 'ºC'),
	(142708, 118, '2014-01-15 00:13:24.000000', 'temperatura', 955.0000, 'ºC'),
	(142709, 118, '2014-01-15 00:13:25.000000', 'temperatura', 500.0000, 'ºC'),
	(142710, 118, '2014-01-15 00:13:26.000000', 'temperatura', 833.0000, 'ºC'),
	(142711, 118, '2014-01-15 00:13:27.000000', 'temperatura', 268.0000, 'ºC'),
	(142712, 118, '2014-01-15 00:13:28.000000', 'temperatura', 39.0000, 'ºC'),
	(142713, 118, '2014-01-15 00:13:29.000000', 'temperatura', 595.0000, 'ºC'),
	(142714, 118, '2014-01-15 00:13:30.000000', 'temperatura', 455.0000, 'ºC'),
	(142715, 118, '2014-01-15 00:13:31.000000', 'temperatura', 494.0000, 'ºC'),
	(142716, 118, '2014-01-15 00:13:32.000000', 'temperatura', 1103.0000, 'ºC'),
	(142717, 118, '2014-01-15 00:13:33.000000', 'temperatura', 433.0000, 'ºC'),
	(142718, 118, '2014-01-15 00:13:34.000000', 'temperatura', 58.0000, 'ºC'),
	(142719, 118, '2014-01-15 00:13:35.000000', 'temperatura', 191.0000, 'ºC'),
	(142720, 118, '2014-01-15 00:13:36.000000', 'temperatura', 781.0000, 'ºC'),
	(142721, 118, '2014-01-15 00:13:37.000000', 'temperatura', 932.0000, 'ºC'),
	(142722, 118, '2014-01-15 00:13:38.000000', 'temperatura', 1120.0000, 'ºC'),
	(142723, 118, '2014-01-15 00:13:39.000000', 'temperatura', 403.0000, 'ºC'),
	(142724, 118, '2014-01-15 00:13:40.000000', 'temperatura', 1056.0000, 'ºC'),
	(142725, 118, '2014-01-15 00:13:41.000000', 'temperatura', 470.0000, 'ºC'),
	(142726, 118, '2014-01-15 00:13:42.000000', 'temperatura', 385.0000, 'ºC'),
	(142727, 118, '2014-01-15 00:13:43.000000', 'temperatura', 514.0000, 'ºC'),
	(142728, 118, '2014-01-15 00:13:44.000000', 'temperatura', 216.0000, 'ºC'),
	(142729, 118, '2014-01-15 00:13:45.000000', 'temperatura', 740.0000, 'ºC'),
	(142730, 118, '2014-01-15 00:13:46.000000', 'temperatura', 651.0000, 'ºC'),
	(142731, 118, '2014-01-15 00:13:47.000000', 'temperatura', 1034.0000, 'ºC'),
	(142732, 118, '2014-01-15 00:13:48.000000', 'temperatura', 817.0000, 'ºC'),
	(142733, 118, '2014-01-15 00:13:49.000000', 'temperatura', 987.0000, 'ºC'),
	(142734, 118, '2014-01-15 00:13:50.000000', 'temperatura', 82.0000, 'ºC'),
	(142735, 118, '2014-01-15 00:13:51.000000', 'temperatura', 1050.0000, 'ºC'),
	(142736, 118, '2014-01-15 00:13:52.000000', 'temperatura', 206.0000, 'ºC'),
	(142737, 118, '2014-01-15 00:13:53.000000', 'temperatura', 280.0000, 'ºC'),
	(142738, 118, '2014-01-15 00:13:54.000000', 'temperatura', 782.0000, 'ºC'),
	(142739, 118, '2014-01-15 00:13:55.000000', 'temperatura', 671.0000, 'ºC'),
	(142740, 118, '2014-01-15 00:13:56.000000', 'temperatura', 1011.0000, 'ºC'),
	(142741, 118, '2014-01-15 00:13:57.000000', 'temperatura', 639.0000, 'ºC'),
	(142742, 118, '2014-01-15 00:13:58.000000', 'temperatura', 165.0000, 'ºC'),
	(142743, 118, '2014-01-15 00:13:59.000000', 'temperatura', 106.0000, 'ºC'),
	(142744, 118, '2014-01-15 00:14:00.000000', 'temperatura', 38.0000, 'ºC'),
	(142745, 118, '2014-01-15 00:14:01.000000', 'temperatura', 1071.0000, 'ºC'),
	(142746, 118, '2014-01-15 00:14:02.000000', 'temperatura', 441.0000, 'ºC'),
	(142747, 118, '2014-01-15 00:14:03.000000', 'temperatura', 194.0000, 'ºC'),
	(142748, 118, '2014-01-15 00:14:04.000000', 'temperatura', 849.0000, 'ºC'),
	(142749, 118, '2014-01-15 00:14:05.000000', 'temperatura', 60.0000, 'ºC'),
	(142750, 118, '2014-01-15 00:14:06.000000', 'temperatura', 156.0000, 'ºC'),
	(142751, 118, '2014-01-15 00:14:07.000000', 'temperatura', 601.0000, 'ºC'),
	(142752, 118, '2014-01-15 00:14:08.000000', 'temperatura', 136.0000, 'ºC'),
	(142753, 118, '2014-01-15 00:14:09.000000', 'temperatura', 78.0000, 'ºC'),
	(142754, 118, '2014-01-15 00:14:10.000000', 'temperatura', 1181.0000, 'ºC'),
	(142755, 118, '2014-01-15 00:14:11.000000', 'temperatura', 872.0000, 'ºC'),
	(142756, 118, '2014-01-15 00:14:12.000000', 'temperatura', 819.0000, 'ºC'),
	(142757, 118, '2014-01-15 00:14:13.000000', 'temperatura', 277.0000, 'ºC'),
	(142758, 118, '2014-01-15 00:14:14.000000', 'temperatura', 130.0000, 'ºC'),
	(142759, 118, '2014-01-15 00:14:15.000000', 'temperatura', 1021.0000, 'ºC'),
	(142760, 118, '2014-01-15 00:14:16.000000', 'temperatura', 1115.0000, 'ºC'),
	(142761, 118, '2014-01-15 00:14:17.000000', 'temperatura', 114.0000, 'ºC'),
	(142762, 118, '2014-01-15 00:14:18.000000', 'temperatura', 825.0000, 'ºC'),
	(142763, 118, '2014-01-15 00:14:19.000000', 'temperatura', 181.0000, 'ºC'),
	(142764, 118, '2014-01-15 00:14:20.000000', 'temperatura', 832.0000, 'ºC'),
	(142765, 118, '2014-01-15 00:14:21.000000', 'temperatura', 19.0000, 'ºC'),
	(142766, 118, '2014-01-15 00:14:22.000000', 'temperatura', 1198.0000, 'ºC'),
	(142767, 118, '2014-01-15 00:14:23.000000', 'temperatura', 1133.0000, 'ºC'),
	(142768, 118, '2014-01-15 00:14:24.000000', 'temperatura', 873.0000, 'ºC'),
	(142769, 118, '2014-01-15 00:14:25.000000', 'temperatura', 965.0000, 'ºC'),
	(142770, 118, '2014-01-15 00:14:26.000000', 'temperatura', 1008.0000, 'ºC'),
	(142771, 118, '2014-01-15 00:14:27.000000', 'temperatura', 944.0000, 'ºC'),
	(142772, 118, '2014-01-15 00:14:28.000000', 'temperatura', 496.0000, 'ºC'),
	(142773, 118, '2014-01-15 00:14:29.000000', 'temperatura', 849.0000, 'ºC'),
	(142774, 118, '2014-01-15 00:14:30.000000', 'temperatura', 357.0000, 'ºC'),
	(142775, 118, '2014-01-15 00:14:31.000000', 'temperatura', 438.0000, 'ºC'),
	(142776, 118, '2014-01-15 00:14:32.000000', 'temperatura', 1120.0000, 'ºC'),
	(142777, 118, '2014-01-15 00:14:33.000000', 'temperatura', 688.0000, 'ºC'),
	(142778, 118, '2014-01-15 00:14:34.000000', 'temperatura', 81.0000, 'ºC'),
	(142779, 118, '2014-01-15 00:14:35.000000', 'temperatura', 741.0000, 'ºC'),
	(142780, 118, '2014-01-15 00:14:36.000000', 'temperatura', 1064.0000, 'ºC'),
	(142781, 118, '2014-01-15 00:14:37.000000', 'temperatura', 695.0000, 'ºC'),
	(142782, 118, '2014-01-15 00:14:38.000000', 'temperatura', 284.0000, 'ºC'),
	(142783, 118, '2014-01-15 00:14:39.000000', 'temperatura', 534.0000, 'ºC'),
	(142784, 118, '2014-01-15 00:14:40.000000', 'temperatura', 619.0000, 'ºC'),
	(142785, 118, '2014-01-15 00:14:41.000000', 'temperatura', 293.0000, 'ºC'),
	(142786, 118, '2014-01-15 00:14:42.000000', 'temperatura', 810.0000, 'ºC'),
	(142787, 118, '2014-01-15 00:14:43.000000', 'temperatura', 770.0000, 'ºC'),
	(142788, 118, '2014-01-15 00:14:44.000000', 'temperatura', 222.0000, 'ºC'),
	(142789, 118, '2014-01-15 00:14:45.000000', 'temperatura', 1.0000, 'ºC'),
	(142790, 118, '2014-01-15 00:14:46.000000', 'temperatura', 538.0000, 'ºC'),
	(142791, 118, '2014-01-15 00:14:47.000000', 'temperatura', 287.0000, 'ºC'),
	(142792, 118, '2014-01-15 00:14:48.000000', 'temperatura', 1023.0000, 'ºC'),
	(142793, 118, '2014-01-15 00:14:49.000000', 'temperatura', 655.0000, 'ºC'),
	(142794, 118, '2014-01-15 00:14:50.000000', 'temperatura', 204.0000, 'ºC'),
	(142795, 118, '2014-01-15 00:14:51.000000', 'temperatura', 256.0000, 'ºC'),
	(142796, 118, '2014-01-15 00:14:52.000000', 'temperatura', 670.0000, 'ºC'),
	(142797, 118, '2014-01-15 00:14:53.000000', 'temperatura', 180.0000, 'ºC'),
	(142798, 118, '2014-01-15 00:14:54.000000', 'temperatura', 92.0000, 'ºC'),
	(142799, 118, '2014-01-15 00:14:55.000000', 'temperatura', 1121.0000, 'ºC'),
	(142800, 118, '2014-01-15 00:14:56.000000', 'temperatura', 530.0000, 'ºC'),
	(142801, 118, '2014-01-15 00:14:57.000000', 'temperatura', 486.0000, 'ºC'),
	(142802, 118, '2014-01-15 00:14:58.000000', 'temperatura', 843.0000, 'ºC'),
	(142803, 118, '2014-01-15 00:14:59.000000', 'temperatura', 355.0000, 'ºC'),
	(142804, 118, '2014-01-15 00:15:00.000000', 'temperatura', 449.0000, 'ºC'),
	(142805, 118, '2014-01-15 00:15:01.000000', 'temperatura', 1178.0000, 'ºC'),
	(142806, 118, '2014-01-15 00:15:02.000000', 'temperatura', 946.0000, 'ºC'),
	(142807, 118, '2014-01-15 00:15:03.000000', 'temperatura', 1196.0000, 'ºC'),
	(142808, 118, '2014-01-15 00:15:04.000000', 'temperatura', 741.0000, 'ºC'),
	(142809, 118, '2014-01-15 00:15:05.000000', 'temperatura', 120.0000, 'ºC'),
	(142810, 118, '2014-01-15 00:15:06.000000', 'temperatura', 778.0000, 'ºC'),
	(142811, 118, '2014-01-15 00:15:07.000000', 'temperatura', 1128.0000, 'ºC'),
	(142812, 118, '2014-01-15 00:15:08.000000', 'temperatura', 908.0000, 'ºC'),
	(142813, 118, '2014-01-15 00:15:09.000000', 'temperatura', 1158.0000, 'ºC'),
	(142814, 118, '2014-01-15 00:15:10.000000', 'temperatura', 664.0000, 'ºC'),
	(142815, 118, '2014-01-15 00:15:11.000000', 'temperatura', 1049.0000, 'ºC'),
	(142816, 118, '2014-01-15 00:15:12.000000', 'temperatura', 851.0000, 'ºC'),
	(142817, 118, '2014-01-15 00:15:13.000000', 'temperatura', 1108.0000, 'ºC'),
	(142818, 118, '2014-01-15 00:15:14.000000', 'temperatura', 591.0000, 'ºC'),
	(142819, 118, '2014-01-15 00:15:15.000000', 'temperatura', 828.0000, 'ºC'),
	(142820, 118, '2014-01-15 00:15:16.000000', 'temperatura', 1169.0000, 'ºC'),
	(142821, 118, '2014-01-15 00:15:17.000000', 'temperatura', 962.0000, 'ºC'),
	(142822, 118, '2014-01-15 00:15:18.000000', 'temperatura', 104.0000, 'ºC'),
	(142823, 118, '2014-01-15 00:15:19.000000', 'temperatura', 34.0000, 'ºC'),
	(142824, 118, '2014-01-15 00:15:20.000000', 'temperatura', 1059.0000, 'ºC'),
	(142825, 118, '2014-01-15 00:15:21.000000', 'temperatura', 391.0000, 'ºC'),
	(142826, 118, '2014-01-15 00:15:22.000000', 'temperatura', 1180.0000, 'ºC'),
	(142827, 118, '2014-01-15 00:15:23.000000', 'temperatura', 1129.0000, 'ºC'),
	(142828, 118, '2014-01-15 00:15:24.000000', 'temperatura', 903.0000, 'ºC'),
	(142829, 118, '2014-01-15 00:15:25.000000', 'temperatura', 1130.0000, 'ºC'),
	(142830, 118, '2014-01-15 00:15:26.000000', 'temperatura', 541.0000, 'ºC'),
	(142831, 118, '2014-01-15 00:15:27.000000', 'temperatura', 515.0000, 'ºC'),
	(142832, 118, '2014-01-15 00:15:28.000000', 'temperatura', 953.0000, 'ºC'),
	(142833, 118, '2014-01-15 00:15:29.000000', 'temperatura', 820.0000, 'ºC'),
	(142834, 118, '2014-01-15 00:15:30.000000', 'temperatura', 40.0000, 'ºC'),
	(142835, 118, '2014-01-15 00:15:31.000000', 'temperatura', 142.0000, 'ºC'),
	(142836, 118, '2014-01-15 00:15:32.000000', 'temperatura', 592.0000, 'ºC'),
	(142837, 118, '2014-01-15 00:15:33.000000', 'temperatura', 132.0000, 'ºC'),
	(142838, 118, '2014-01-15 00:15:34.000000', 'temperatura', 85.0000, 'ºC'),
	(142839, 118, '2014-01-15 00:15:35.000000', 'temperatura', 30.0000, 'ºC'),
	(142840, 118, '2014-01-15 00:15:36.000000', 'temperatura', 1093.0000, 'ºC'),
	(142841, 118, '2014-01-15 00:15:37.000000', 'temperatura', 579.0000, 'ºC'),
	(142842, 118, '2014-01-15 00:15:38.000000', 'temperatura', 814.0000, 'ºC'),
	(142843, 118, '2014-01-15 00:15:39.000000', 'temperatura', 1136.0000, 'ºC'),
	(142844, 118, '2014-01-15 00:15:40.000000', 'temperatura', 836.0000, 'ºC'),
	(142845, 118, '2014-01-15 00:15:41.000000', 'temperatura', 774.0000, 'ºC'),
	(142846, 118, '2014-01-15 00:15:42.000000', 'temperatura', 161.0000, 'ºC'),
	(142847, 118, '2014-01-15 00:15:43.000000', 'temperatura', 885.0000, 'ºC'),
	(142848, 118, '2014-01-15 00:15:44.000000', 'temperatura', 342.0000, 'ºC'),
	(142849, 118, '2014-01-15 00:15:45.000000', 'temperatura', 254.0000, 'ºC'),
	(142850, 118, '2014-01-15 00:15:46.000000', 'temperatura', 245.0000, 'ºC'),
	(142851, 118, '2014-01-15 00:15:47.000000', 'temperatura', 465.0000, 'ºC'),
	(142852, 118, '2014-01-15 00:15:48.000000', 'temperatura', 389.0000, 'ºC'),
	(142853, 118, '2014-01-15 00:15:49.000000', 'temperatura', 549.0000, 'ºC'),
	(142854, 118, '2014-01-15 00:15:50.000000', 'temperatura', 379.0000, 'ºC'),
	(142855, 118, '2014-01-15 00:15:51.000000', 'temperatura', 250.0000, 'ºC'),
	(142856, 118, '2014-01-15 00:15:52.000000', 'temperatura', 114.0000, 'ºC'),
	(142857, 118, '2014-01-15 00:15:53.000000', 'temperatura', 1020.0000, 'ºC'),
	(142858, 118, '2014-01-15 00:15:54.000000', 'temperatura', 1160.0000, 'ºC'),
	(142859, 118, '2014-01-15 00:15:55.000000', 'temperatura', 340.0000, 'ºC'),
	(142860, 118, '2014-01-15 00:15:56.000000', 'temperatura', 620.0000, 'ºC'),
	(142861, 118, '2014-01-15 00:15:57.000000', 'temperatura', 879.0000, 'ºC'),
	(142862, 118, '2014-01-15 00:15:58.000000', 'temperatura', 136.0000, 'ºC'),
	(142863, 118, '2014-01-15 00:15:59.000000', 'temperatura', 446.0000, 'ºC'),
	(142864, 118, '2014-01-15 00:16:00.000000', 'temperatura', 620.0000, 'ºC'),
	(142865, 118, '2014-01-15 00:16:01.000000', 'temperatura', 562.0000, 'ºC'),
	(142866, 118, '2014-01-15 00:16:02.000000', 'temperatura', 952.0000, 'ºC'),
	(142867, 118, '2014-01-15 00:16:03.000000', 'temperatura', 672.0000, 'ºC'),
	(142868, 118, '2014-01-15 00:16:04.000000', 'temperatura', 506.0000, 'ºC'),
	(142869, 118, '2014-01-15 00:16:05.000000', 'temperatura', 514.0000, 'ºC'),
	(142870, 118, '2014-01-15 00:16:06.000000', 'temperatura', 1053.0000, 'ºC'),
	(142871, 118, '2014-01-15 00:16:07.000000', 'temperatura', 125.0000, 'ºC'),
	(142872, 118, '2014-01-15 00:16:08.000000', 'temperatura', 1065.0000, 'ºC'),
	(142873, 118, '2014-01-15 00:16:09.000000', 'temperatura', 152.0000, 'ºC'),
	(142874, 118, '2014-01-15 00:16:10.000000', 'temperatura', 1166.0000, 'ºC'),
	(142875, 118, '2014-01-15 00:16:11.000000', 'temperatura', 572.0000, 'ºC'),
	(142876, 118, '2014-01-15 00:16:12.000000', 'temperatura', 565.0000, 'ºC'),
	(142877, 118, '2014-01-15 00:16:13.000000', 'temperatura', 1109.0000, 'ºC'),
	(142878, 118, '2014-01-15 00:16:14.000000', 'temperatura', 252.0000, 'ºC'),
	(142879, 118, '2014-01-15 00:16:15.000000', 'temperatura', 331.0000, 'ºC'),
	(142880, 118, '2014-01-15 00:16:16.000000', 'temperatura', 900.0000, 'ºC'),
	(142881, 118, '2014-01-15 00:16:17.000000', 'temperatura', 1109.0000, 'ºC'),
	(142882, 118, '2014-01-15 00:16:18.000000', 'temperatura', 447.0000, 'ºC'),
	(142883, 118, '2014-01-15 00:16:19.000000', 'temperatura', 105.0000, 'ºC'),
	(142884, 118, '2014-01-15 00:16:20.000000', 'temperatura', 386.0000, 'ºC'),
	(142885, 118, '2014-01-15 00:16:21.000000', 'temperatura', 414.0000, 'ºC'),
	(142886, 118, '2014-01-15 00:16:22.000000', 'temperatura', 915.0000, 'ºC'),
	(142887, 118, '2014-01-15 00:16:23.000000', 'temperatura', 933.0000, 'ºC'),
	(142888, 118, '2014-01-15 00:16:24.000000', 'temperatura', 722.0000, 'ºC'),
	(142889, 118, '2014-01-15 00:16:25.000000', 'temperatura', 810.0000, 'ºC'),
	(142890, 118, '2014-01-15 00:16:26.000000', 'temperatura', 685.0000, 'ºC'),
	(142891, 118, '2014-01-15 00:16:27.000000', 'temperatura', 997.0000, 'ºC'),
	(142892, 118, '2014-01-15 00:16:28.000000', 'temperatura', 530.0000, 'ºC'),
	(142893, 118, '2014-01-15 00:16:29.000000', 'temperatura', 859.0000, 'ºC'),
	(142894, 118, '2014-01-15 00:16:30.000000', 'temperatura', 304.0000, 'ºC'),
	(142895, 118, '2014-01-15 00:16:31.000000', 'temperatura', 144.0000, 'ºC'),
	(142896, 118, '2014-01-15 00:16:32.000000', 'temperatura', 1007.0000, 'ºC'),
	(142897, 118, '2014-01-15 00:16:33.000000', 'temperatura', 1006.0000, 'ºC'),
	(142898, 118, '2014-01-15 00:16:34.000000', 'temperatura', 807.0000, 'ºC'),
	(142899, 118, '2014-01-15 00:16:35.000000', 'temperatura', 1019.0000, 'ºC'),
	(142900, 118, '2014-01-15 00:16:36.000000', 'temperatura', 275.0000, 'ºC'),
	(142901, 118, '2014-01-15 00:16:37.000000', 'temperatura', 720.0000, 'ºC'),
	(142902, 118, '2014-01-15 00:16:38.000000', 'temperatura', 373.0000, 'ºC'),
	(142903, 118, '2014-01-15 00:16:39.000000', 'temperatura', 907.0000, 'ºC'),
	(142904, 118, '2014-01-15 00:16:40.000000', 'temperatura', 1018.0000, 'ºC'),
	(142905, 118, '2014-01-15 00:16:41.000000', 'temperatura', 1168.0000, 'ºC'),
	(142906, 118, '2014-01-15 00:16:42.000000', 'temperatura', 387.0000, 'ºC'),
	(142907, 118, '2014-01-15 00:16:43.000000', 'temperatura', 833.0000, 'ºC'),
	(142908, 118, '2014-01-15 00:16:44.000000', 'temperatura', 603.0000, 'ºC'),
	(142909, 118, '2014-01-15 00:16:45.000000', 'temperatura', 517.0000, 'ºC'),
	(142910, 118, '2014-01-15 00:16:46.000000', 'temperatura', 776.0000, 'ºC'),
	(142911, 118, '2014-01-15 00:16:47.000000', 'temperatura', 1131.0000, 'ºC'),
	(142912, 118, '2014-01-15 00:16:48.000000', 'temperatura', 927.0000, 'ºC'),
	(142913, 118, '2014-01-15 00:16:49.000000', 'temperatura', 40.0000, 'ºC'),
	(142914, 118, '2014-01-15 00:16:50.000000', 'temperatura', 1022.0000, 'ºC'),
	(142915, 118, '2014-01-15 00:16:51.000000', 'temperatura', 191.0000, 'ºC'),
	(142916, 118, '2014-01-15 00:16:52.000000', 'temperatura', 290.0000, 'ºC'),
	(142917, 118, '2014-01-15 00:16:53.000000', 'temperatura', 877.0000, 'ºC'),
	(142918, 118, '2014-01-15 00:16:54.000000', 'temperatura', 1114.0000, 'ºC'),
	(142919, 118, '2014-01-15 00:16:55.000000', 'temperatura', 541.0000, 'ºC'),
	(142920, 118, '2014-01-15 00:16:56.000000', 'temperatura', 563.0000, 'ºC'),
	(142921, 118, '2014-01-15 00:16:57.000000', 'temperatura', 1191.0000, 'ºC'),
	(142922, 118, '2014-01-15 00:16:58.000000', 'temperatura', 668.0000, 'ºC'),
	(142923, 118, '2014-01-15 00:16:59.000000', 'temperatura', 969.0000, 'ºC'),
	(142924, 118, '2014-01-15 00:17:00.000000', 'temperatura', 440.0000, 'ºC'),
	(142925, 118, '2014-01-15 00:17:01.000000', 'temperatura', 492.0000, 'ºC'),
	(142926, 118, '2014-01-15 00:17:02.000000', 'temperatura', 1140.0000, 'ºC'),
	(142927, 118, '2014-01-15 00:17:03.000000', 'temperatura', 627.0000, 'ºC'),
	(142928, 118, '2014-01-15 00:17:04.000000', 'temperatura', 915.0000, 'ºC'),
	(142929, 118, '2014-01-15 00:17:05.000000', 'temperatura', 295.0000, 'ºC'),
	(142930, 118, '2014-01-15 00:17:06.000000', 'temperatura', 1129.0000, 'ºC'),
	(142931, 118, '2014-01-15 00:17:07.000000', 'temperatura', 1159.0000, 'ºC'),
	(142932, 118, '2014-01-15 00:17:08.000000', 'temperatura', 12.0000, 'ºC'),
	(142933, 118, '2014-01-15 00:17:09.000000', 'temperatura', 183.0000, 'ºC'),
	(142934, 118, '2014-01-15 00:17:10.000000', 'temperatura', 877.0000, 'ºC'),
	(142935, 118, '2014-01-15 00:17:11.000000', 'temperatura', 239.0000, 'ºC'),
	(142936, 118, '2014-01-15 00:17:12.000000', 'temperatura', 962.0000, 'ºC'),
	(142937, 118, '2014-01-15 00:17:13.000000', 'temperatura', 495.0000, 'ºC'),
	(142938, 118, '2014-01-15 00:17:14.000000', 'temperatura', 788.0000, 'ºC'),
	(142939, 118, '2014-01-15 00:17:15.000000', 'temperatura', 56.0000, 'ºC'),
	(142940, 118, '2014-01-15 00:17:16.000000', 'temperatura', 316.0000, 'ºC'),
	(142941, 118, '2014-01-15 00:17:17.000000', 'temperatura', 213.0000, 'ºC'),
	(142942, 118, '2014-01-15 00:17:18.000000', 'temperatura', 116.0000, 'ºC'),
	(142943, 118, '2014-01-15 00:17:19.000000', 'temperatura', 1144.0000, 'ºC'),
	(142944, 118, '2014-01-15 00:17:20.000000', 'temperatura', 570.0000, 'ºC'),
	(142945, 118, '2014-01-15 00:17:21.000000', 'temperatura', 620.0000, 'ºC'),
	(142946, 118, '2014-01-15 00:17:22.000000', 'temperatura', 189.0000, 'ºC'),
	(142947, 118, '2014-01-15 00:17:23.000000', 'temperatura', 285.0000, 'ºC'),
	(142948, 118, '2014-01-15 00:17:24.000000', 'temperatura', 860.0000, 'ºC'),
	(142949, 118, '2014-01-15 00:17:25.000000', 'temperatura', 1045.0000, 'ºC'),
	(142950, 118, '2014-01-15 00:17:26.000000', 'temperatura', 245.0000, 'ºC'),
	(142951, 118, '2014-01-15 00:17:27.000000', 'temperatura', 492.0000, 'ºC'),
	(142952, 118, '2014-01-15 00:17:28.000000', 'temperatura', 527.0000, 'ºC'),
	(142953, 118, '2014-01-15 00:17:29.000000', 'temperatura', 1156.0000, 'ºC'),
	(142954, 118, '2014-01-15 00:17:30.000000', 'temperatura', 601.0000, 'ºC'),
	(142955, 118, '2014-01-15 00:17:31.000000', 'temperatura', 737.0000, 'ºC'),
	(142956, 118, '2014-01-15 00:17:32.000000', 'temperatura', 684.0000, 'ºC'),
	(142957, 118, '2014-01-15 00:17:33.000000', 'temperatura', 8.0000, 'ºC'),
	(142958, 118, '2014-01-15 00:17:34.000000', 'temperatura', 390.0000, 'ºC'),
	(142959, 118, '2014-01-15 00:17:35.000000', 'temperatura', 725.0000, 'ºC'),
	(142960, 118, '2014-01-15 00:17:36.000000', 'temperatura', 55.0000, 'ºC'),
	(142961, 118, '2014-01-15 00:17:37.000000', 'temperatura', 500.0000, 'ºC'),
	(142962, 118, '2014-01-15 00:17:38.000000', 'temperatura', 1138.0000, 'ºC'),
	(142963, 118, '2014-01-15 00:17:39.000000', 'temperatura', 588.0000, 'ºC'),
	(142964, 118, '2014-01-15 00:17:40.000000', 'temperatura', 727.0000, 'ºC'),
	(142965, 118, '2014-01-15 00:17:41.000000', 'temperatura', 671.0000, 'ºC'),
	(142966, 118, '2014-01-15 00:17:42.000000', 'temperatura', 1175.0000, 'ºC'),
	(142967, 118, '2014-01-15 00:17:43.000000', 'temperatura', 261.0000, 'ºC'),
	(142968, 118, '2014-01-15 00:17:44.000000', 'temperatura', 182.0000, 'ºC'),
	(142969, 118, '2014-01-15 00:17:45.000000', 'temperatura', 126.0000, 'ºC'),
	(142970, 118, '2014-01-15 00:17:46.000000', 'temperatura', 86.0000, 'ºC'),
	(142971, 118, '2014-01-15 00:17:47.000000', 'temperatura', 53.0000, 'ºC'),
	(142972, 118, '2014-01-15 00:17:48.000000', 'temperatura', 7.0000, 'ºC'),
	(142973, 118, '2014-01-15 00:17:49.000000', 'temperatura', 1075.0000, 'ºC'),
	(142974, 118, '2014-01-15 00:17:50.000000', 'temperatura', 556.0000, 'ºC'),
	(142975, 118, '2014-01-15 00:17:51.000000', 'temperatura', 753.0000, 'ºC'),
	(142976, 118, '2014-01-15 00:17:52.000000', 'temperatura', 899.0000, 'ºC'),
	(142977, 118, '2014-01-15 00:17:53.000000', 'temperatura', 1039.0000, 'ºC'),
	(142978, 118, '2014-01-15 00:17:54.000000', 'temperatura', 95.0000, 'ºC'),
	(142979, 118, '2014-01-15 00:17:55.000000', 'temperatura', 959.0000, 'ºC'),
	(142980, 118, '2014-01-15 00:17:56.000000', 'temperatura', 913.0000, 'ºC'),
	(142981, 118, '2014-01-15 00:17:57.000000', 'temperatura', 486.0000, 'ºC'),
	(142982, 118, '2014-01-15 00:17:58.000000', 'temperatura', 894.0000, 'ºC'),
	(142983, 118, '2014-01-15 00:17:59.000000', 'temperatura', 612.0000, 'ºC'),
	(142984, 118, '2014-01-15 00:18:00.000000', 'temperatura', 379.0000, 'ºC'),
	(142985, 118, '2014-01-15 00:18:01.000000', 'temperatura', 61.0000, 'ºC'),
	(142986, 118, '2014-01-15 00:18:02.000000', 'temperatura', 366.0000, 'ºC'),
	(142987, 118, '2014-01-15 00:18:03.000000', 'temperatura', 446.0000, 'ºC'),
	(142988, 118, '2014-01-15 00:18:04.000000', 'temperatura', 1135.0000, 'ºC'),
	(142989, 118, '2014-01-15 00:18:05.000000', 'temperatura', 737.0000, 'ºC'),
	(142990, 118, '2014-01-15 00:18:06.000000', 'temperatura', 282.0000, 'ºC'),
	(142991, 118, '2014-01-15 00:18:07.000000', 'temperatura', 398.0000, 'ºC'),
	(142992, 118, '2014-01-15 00:18:08.000000', 'temperatura', 1147.0000, 'ºC'),
	(142993, 118, '2014-01-15 00:18:09.000000', 'temperatura', 938.0000, 'ºC'),
	(142994, 118, '2014-01-15 00:18:10.000000', 'temperatura', 50.0000, 'ºC'),
	(142995, 118, '2014-01-15 00:18:11.000000', 'temperatura', 1037.0000, 'ºC'),
	(142996, 118, '2014-01-15 00:18:12.000000', 'temperatura', 237.0000, 'ºC'),
	(142997, 118, '2014-01-15 00:18:13.000000', 'temperatura', 476.0000, 'ºC'),
	(142998, 118, '2014-01-15 00:18:14.000000', 'temperatura', 466.0000, 'ºC'),
	(142999, 118, '2014-01-15 00:18:15.000000', 'temperatura', 903.0000, 'ºC'),
	(143000, 118, '2014-01-15 00:18:16.000000', 'temperatura', 716.0000, 'ºC'),
	(143001, 118, '2014-01-15 00:18:17.000000', 'temperatura', 874.0000, 'ºC'),
	(143002, 118, '2014-01-15 00:18:18.000000', 'temperatura', 1021.0000, 'ºC'),
	(143003, 118, '2014-01-15 00:18:19.000000', 'temperatura', 83.0000, 'ºC'),
	(143004, 118, '2014-01-15 00:18:20.000000', 'temperatura', 952.0000, 'ºC'),
	(143005, 118, '2014-01-15 00:18:21.000000', 'temperatura', 911.0000, 'ºC'),
	(143006, 118, '2014-01-15 00:18:22.000000', 'temperatura', 499.0000, 'ºC'),
	(143007, 118, '2014-01-15 00:18:23.000000', 'temperatura', 964.0000, 'ºC'),
	(143008, 118, '2014-01-15 00:18:24.000000', 'temperatura', 922.0000, 'ºC'),
	(143009, 118, '2014-01-15 00:18:25.000000', 'temperatura', 520.0000, 'ºC'),
	(143010, 118, '2014-01-15 00:18:26.000000', 'temperatura', 1036.0000, 'ºC'),
	(143011, 118, '2014-01-15 00:18:27.000000', 'temperatura', 17.0000, 'ºC'),
	(143012, 118, '2014-01-15 00:18:28.000000', 'temperatura', 581.0000, 'ºC'),
	(143013, 118, '2014-01-15 00:18:29.000000', 'temperatura', 451.0000, 'ºC'),
	(143014, 118, '2014-01-15 00:18:30.000000', 'temperatura', 515.0000, 'ºC'),
	(143015, 118, '2014-01-15 00:18:31.000000', 'temperatura', 24.0000, 'ºC'),
	(143016, 118, '2014-01-15 00:18:32.000000', 'temperatura', 972.0000, 'ºC'),
	(143017, 118, '2014-01-15 00:18:33.000000', 'temperatura', 1189.0000, 'ºC'),
	(143018, 118, '2014-01-15 00:18:34.000000', 'temperatura', 631.0000, 'ºC'),
	(143019, 118, '2014-01-15 00:18:35.000000', 'temperatura', 786.0000, 'ºC'),
	(143020, 118, '2014-01-15 00:18:36.000000', 'temperatura', 841.0000, 'ºC'),
	(143021, 118, '2014-01-15 00:18:37.000000', 'temperatura', 644.0000, 'ºC'),
	(143022, 118, '2014-01-15 00:18:38.000000', 'temperatura', 700.0000, 'ºC'),
	(143023, 118, '2014-01-15 00:18:39.000000', 'temperatura', 367.0000, 'ºC'),
	(143024, 118, '2014-01-15 00:18:40.000000', 'temperatura', 936.0000, 'ºC'),
	(143025, 118, '2014-01-15 00:18:41.000000', 'temperatura', 1182.0000, 'ºC'),
	(143026, 118, '2014-01-15 00:18:42.000000', 'temperatura', 699.0000, 'ºC'),
	(143027, 118, '2014-01-15 00:18:43.000000', 'temperatura', 1152.0000, 'ºC'),
	(143028, 118, '2014-01-15 00:18:44.000000', 'temperatura', 61.0000, 'ºC'),
	(143029, 118, '2014-01-15 00:18:45.000000', 'temperatura', 451.0000, 'ºC'),
	(143030, 118, '2014-01-15 00:18:46.000000', 'temperatura', 874.0000, 'ºC'),
	(143031, 118, '2014-01-15 00:18:47.000000', 'temperatura', 617.0000, 'ºC'),
	(143032, 118, '2014-01-15 00:18:48.000000', 'temperatura', 465.0000, 'ºC'),
	(143033, 118, '2014-01-15 00:18:49.000000', 'temperatura', 471.0000, 'ºC'),
	(143034, 118, '2014-01-15 00:18:50.000000', 'temperatura', 963.0000, 'ºC'),
	(143035, 118, '2014-01-15 00:18:51.000000', 'temperatura', 1000.0000, 'ºC'),
	(143036, 118, '2014-01-15 00:18:52.000000', 'temperatura', 912.0000, 'ºC'),
	(143037, 118, '2014-01-15 00:18:53.000000', 'temperatura', 363.0000, 'ºC'),
	(143038, 118, '2014-01-15 00:18:54.000000', 'temperatura', 276.0000, 'ºC'),
	(143039, 118, '2014-01-15 00:18:55.000000', 'temperatura', 294.0000, 'ºC'),
	(143040, 118, '2014-01-15 00:18:56.000000', 'temperatura', 643.0000, 'ºC'),
	(143041, 118, '2014-01-15 00:18:57.000000', 'temperatura', 1133.0000, 'ºC'),
	(143042, 118, '2014-01-15 00:18:58.000000', 'temperatura', 134.0000, 'ºC'),
	(143043, 118, '2014-01-15 00:18:59.000000', 'temperatura', 875.0000, 'ºC'),
	(143044, 118, '2014-01-15 00:19:00.000000', 'temperatura', 372.0000, 'ºC'),
	(143045, 118, '2014-01-15 00:19:01.000000', 'temperatura', 436.0000, 'ºC'),
	(143046, 118, '2014-01-15 00:19:02.000000', 'temperatura', 1065.0000, 'ºC'),
	(143047, 118, '2014-01-15 00:19:03.000000', 'temperatura', 418.0000, 'ºC'),
	(143048, 118, '2014-01-15 00:19:04.000000', 'temperatura', 94.0000, 'ºC'),
	(143049, 118, '2014-01-15 00:19:05.000000', 'temperatura', 416.0000, 'ºC'),
	(143050, 118, '2014-01-15 00:19:06.000000', 'temperatura', 599.0000, 'ºC'),
	(143051, 118, '2014-01-15 00:19:07.000000', 'temperatura', 549.0000, 'ºC'),
	(143052, 118, '2014-01-15 00:19:08.000000', 'temperatura', 948.0000, 'ºC'),
	(143053, 118, '2014-01-15 00:19:09.000000', 'temperatura', 692.0000, 'ºC'),
	(143054, 118, '2014-01-15 00:19:10.000000', 'temperatura', 618.0000, 'ºC'),
	(143055, 118, '2014-01-15 00:19:11.000000', 'temperatura', 1012.0000, 'ºC'),
	(143056, 118, '2014-01-15 00:19:12.000000', 'temperatura', 808.0000, 'ºC'),
	(143057, 118, '2014-01-15 00:19:13.000000', 'temperatura', 1006.0000, 'ºC'),
	(143058, 118, '2014-01-15 00:19:14.000000', 'temperatura', 205.0000, 'ºC'),
	(143059, 118, '2014-01-15 00:19:15.000000', 'temperatura', 407.0000, 'ºC'),
	(143060, 118, '2014-01-15 00:19:16.000000', 'temperatura', 221.0000, 'ºC'),
	(143061, 118, '2014-01-15 00:19:17.000000', 'temperatura', 1087.0000, 'ºC'),
	(143062, 118, '2014-01-15 00:19:18.000000', 'temperatura', 1169.0000, 'ºC'),
	(143063, 118, '2014-01-15 00:19:19.000000', 'temperatura', 186.0000, 'ºC'),
	(143064, 118, '2014-01-15 00:19:20.000000', 'temperatura', 1022.0000, 'ºC'),
	(143065, 118, '2014-01-15 00:19:21.000000', 'temperatura', 954.0000, 'ºC'),
	(143066, 118, '2014-01-15 00:19:22.000000', 'temperatura', 505.0000, 'ºC'),
	(143067, 118, '2014-01-15 00:19:23.000000', 'temperatura', 863.0000, 'ºC'),
	(143068, 118, '2014-01-15 00:19:24.000000', 'temperatura', 401.0000, 'ºC'),
	(143069, 118, '2014-01-15 00:19:25.000000', 'temperatura', 617.0000, 'ºC'),
	(143070, 118, '2014-01-15 00:19:26.000000', 'temperatura', 684.0000, 'ºC'),
	(143071, 118, '2014-01-15 00:19:27.000000', 'temperatura', 368.0000, 'ºC'),
	(143072, 118, '2014-01-15 00:19:28.000000', 'temperatura', 987.0000, 'ºC'),
	(143073, 118, '2014-01-15 00:19:29.000000', 'temperatura', 233.0000, 'ºC'),
	(143074, 118, '2014-01-15 00:19:30.000000', 'temperatura', 604.0000, 'ºC'),
	(143075, 118, '2014-01-15 00:19:31.000000', 'temperatura', 1123.0000, 'ºC'),
	(143076, 118, '2014-01-15 00:19:32.000000', 'temperatura', 202.0000, 'ºC'),
	(143077, 118, '2014-01-15 00:19:33.000000', 'temperatura', 43.0000, 'ºC'),
	(143078, 118, '2014-01-15 00:19:34.000000', 'temperatura', 807.0000, 'ºC'),
	(143079, 118, '2014-01-15 00:19:35.000000', 'temperatura', 308.0000, 'ºC'),
	(143080, 118, '2014-01-15 00:19:36.000000', 'temperatura', 320.0000, 'ºC'),
	(143081, 118, '2014-01-15 00:19:37.000000', 'temperatura', 675.0000, 'ºC'),
	(143082, 118, '2014-01-15 00:19:38.000000', 'temperatura', 15.0000, 'ºC'),
	(143083, 118, '2014-01-15 00:19:39.000000', 'temperatura', 449.0000, 'ºC'),
	(143084, 118, '2014-01-15 00:19:40.000000', 'temperatura', 1004.0000, 'ºC'),
	(143085, 118, '2014-01-15 00:19:41.000000', 'temperatura', 71.0000, 'ºC'),
	(143086, 118, '2014-01-15 00:19:42.000000', 'temperatura', 945.0000, 'ºC'),
	(143087, 118, '2014-01-15 00:19:43.000000', 'temperatura', 910.0000, 'ºC'),
	(143088, 118, '2014-01-15 00:19:44.000000', 'temperatura', 518.0000, 'ºC'),
	(143089, 118, '2014-01-15 00:19:45.000000', 'temperatura', 1061.0000, 'ºC'),
	(143090, 118, '2014-01-15 00:19:46.000000', 'temperatura', 149.0000, 'ºC'),
	(143091, 118, '2014-01-15 00:19:47.000000', 'temperatura', 1166.0000, 'ºC'),
	(143092, 118, '2014-01-15 00:19:48.000000', 'temperatura', 580.0000, 'ºC'),
	(143093, 118, '2014-01-15 00:19:49.000000', 'temperatura', 605.0000, 'ºC'),
	(143094, 118, '2014-01-15 00:19:50.000000', 'temperatura', 85.0000, 'ºC'),
	(143095, 118, '2014-01-15 00:19:51.000000', 'temperatura', 1010.0000, 'ºC'),
	(143096, 118, '2014-01-15 00:19:52.000000', 'temperatura', 1196.0000, 'ºC'),
	(143097, 118, '2014-01-15 00:19:53.000000', 'temperatura', 549.0000, 'ºC'),
	(143098, 118, '2014-01-15 00:19:54.000000', 'temperatura', 357.0000, 'ºC'),
	(143099, 118, '2014-01-15 00:19:55.000000', 'temperatura', 141.0000, 'ºC'),
	(143100, 118, '2014-01-15 00:19:56.000000', 'temperatura', 833.0000, 'ºC'),
	(143101, 118, '2014-01-15 00:19:57.000000', 'temperatura', 144.0000, 'ºC'),
	(143102, 118, '2014-01-15 00:19:58.000000', 'temperatura', 620.0000, 'ºC'),
	(143103, 118, '2014-01-15 00:19:59.000000', 'temperatura', 270.0000, 'ºC'),
	(143104, 118, '2014-01-15 00:20:00.000000', 'temperatura', 691.0000, 'ºC'),
	(143105, 118, '2014-01-15 00:20:01.000000', 'temperatura', 245.0000, 'ºC'),
	(143106, 118, '2014-01-15 00:20:02.000000', 'temperatura', 354.0000, 'ºC'),
	(143107, 118, '2014-01-15 00:20:03.000000', 'temperatura', 1035.0000, 'ºC'),
	(143108, 118, '2014-01-15 00:20:04.000000', 'temperatura', 514.0000, 'ºC'),
	(143109, 118, '2014-01-15 00:20:05.000000', 'temperatura', 664.0000, 'ºC'),
	(143110, 118, '2014-01-15 00:20:06.000000', 'temperatura', 581.0000, 'ºC'),
	(143111, 118, '2014-01-15 00:20:07.000000', 'temperatura', 911.0000, 'ºC'),
	(143112, 118, '2014-01-15 00:20:08.000000', 'temperatura', 413.0000, 'ºC'),
	(143113, 118, '2014-01-15 00:20:09.000000', 'temperatura', 533.0000, 'ºC'),
	(143114, 118, '2014-01-15 00:20:10.000000', 'temperatura', 228.0000, 'ºC'),
	(143115, 118, '2014-01-15 00:20:11.000000', 'temperatura', 742.0000, 'ºC'),
	(143116, 118, '2014-01-15 00:20:12.000000', 'temperatura', 625.0000, 'ºC'),
	(143117, 118, '2014-01-15 00:20:13.000000', 'temperatura', 898.0000, 'ºC'),
	(143118, 118, '2014-01-15 00:20:14.000000', 'temperatura', 215.0000, 'ºC'),
	(143119, 118, '2014-01-15 00:20:15.000000', 'temperatura', 783.0000, 'ºC'),
	(143120, 118, '2014-01-15 00:20:16.000000', 'temperatura', 869.0000, 'ºC'),
	(143121, 118, '2014-01-15 00:20:17.000000', 'temperatura', 796.0000, 'ºC'),
	(143122, 118, '2014-01-15 00:20:18.000000', 'temperatura', 173.0000, 'ºC'),
	(143123, 118, '2014-01-15 00:20:19.000000', 'temperatura', 878.0000, 'ºC'),
	(143124, 118, '2014-01-15 00:20:20.000000', 'temperatura', 270.0000, 'ºC'),
	(143125, 118, '2014-01-15 00:20:21.000000', 'temperatura', 1118.0000, 'ºC'),
	(143126, 118, '2014-01-15 00:20:22.000000', 'temperatura', 1181.0000, 'ºC'),
	(143127, 118, '2014-01-15 00:20:23.000000', 'temperatura', 152.0000, 'ºC'),
	(143128, 118, '2014-01-15 00:20:24.000000', 'temperatura', 816.0000, 'ºC'),
	(143129, 118, '2014-01-15 00:20:25.000000', 'temperatura', 25.0000, 'ºC'),
	(143130, 118, '2014-01-15 00:20:26.000000', 'temperatura', 76.0000, 'ºC'),
	(143131, 118, '2014-01-15 00:20:27.000000', 'temperatura', 306.0000, 'ºC'),
	(143132, 118, '2014-01-15 00:20:28.000000', 'temperatura', 102.0000, 'ºC'),
	(143133, 118, '2014-01-15 00:20:29.000000', 'temperatura', 791.0000, 'ºC'),
	(143134, 118, '2014-01-15 00:20:30.000000', 'temperatura', 51.0000, 'ºC'),
	(143135, 118, '2014-01-15 00:20:31.000000', 'temperatura', 284.0000, 'ºC'),
	(143136, 118, '2014-01-15 00:20:32.000000', 'temperatura', 67.0000, 'ºC'),
	(143137, 118, '2014-01-15 00:20:33.000000', 'temperatura', 681.0000, 'ºC'),
	(143138, 118, '2014-01-15 00:20:34.000000', 'temperatura', 806.0000, 'ºC'),
	(143139, 118, '2014-01-15 00:20:35.000000', 'temperatura', 789.0000, 'ºC'),
	(143140, 118, '2014-01-15 00:20:36.000000', 'temperatura', 324.0000, 'ºC'),
	(143141, 118, '2014-01-15 00:20:37.000000', 'temperatura', 457.0000, 'ºC'),
	(143142, 118, '2014-01-15 00:20:38.000000', 'temperatura', 113.0000, 'ºC'),
	(143143, 118, '2014-01-15 00:20:39.000000', 'temperatura', 395.0000, 'ºC'),
	(143144, 118, '2014-01-15 00:20:40.000000', 'temperatura', 435.0000, 'ºC'),
	(143145, 118, '2014-01-15 00:20:41.000000', 'temperatura', 991.0000, 'ºC'),
	(143146, 118, '2014-01-15 00:20:42.000000', 'temperatura', 49.0000, 'ºC'),
	(143147, 118, '2014-01-15 00:20:43.000000', 'temperatura', 873.0000, 'ºC'),
	(143148, 118, '2014-01-15 00:20:44.000000', 'temperatura', 621.0000, 'ºC'),
	(143149, 118, '2014-01-15 00:20:45.000000', 'temperatura', 485.0000, 'ºC'),
	(143150, 118, '2014-01-15 00:20:46.000000', 'temperatura', 561.0000, 'ºC'),
	(143151, 118, '2014-01-15 00:20:47.000000', 'temperatura', 151.0000, 'ºC'),
	(143152, 118, '2014-01-15 00:20:48.000000', 'temperatura', 274.0000, 'ºC'),
	(143153, 118, '2014-01-15 00:20:49.000000', 'temperatura', 918.0000, 'ºC'),
	(143154, 118, '2014-01-15 00:20:50.000000', 'temperatura', 169.0000, 'ºC'),
	(143155, 118, '2014-01-15 00:20:51.000000', 'temperatura', 491.0000, 'ºC'),
	(143156, 118, '2014-01-15 00:20:52.000000', 'temperatura', 746.0000, 'ºC'),
	(143157, 118, '2014-01-15 00:20:53.000000', 'temperatura', 1059.0000, 'ºC'),
	(143158, 118, '2014-01-15 00:20:54.000000', 'temperatura', 659.0000, 'ºC'),
	(143159, 118, '2014-01-15 00:20:55.000000', 'temperatura', 116.0000, 'ºC'),
	(143160, 118, '2014-01-15 00:20:56.000000', 'temperatura', 1006.0000, 'ºC'),
	(143161, 118, '2014-01-15 00:20:57.000000', 'temperatura', 1081.0000, 'ºC'),
	(143162, 118, '2014-01-15 00:20:58.000000', 'temperatura', 1189.0000, 'ºC'),
	(143163, 118, '2014-01-15 00:20:59.000000', 'temperatura', 302.0000, 'ºC'),
	(143164, 118, '2014-01-15 00:21:00.000000', 'temperatura', 342.0000, 'ºC'),
	(143165, 118, '2014-01-15 00:21:01.000000', 'temperatura', 804.0000, 'ºC'),
	(143166, 118, '2014-01-15 00:21:02.000000', 'temperatura', 597.0000, 'ºC'),
	(143167, 118, '2014-01-15 00:21:03.000000', 'temperatura', 572.0000, 'ºC'),
	(143168, 118, '2014-01-15 00:21:04.000000', 'temperatura', 1069.0000, 'ºC'),
	(143169, 118, '2014-01-15 00:21:05.000000', 'temperatura', 32.0000, 'ºC'),
	(143170, 118, '2014-01-15 00:21:06.000000', 'temperatura', 552.0000, 'ºC'),
	(143171, 118, '2014-01-15 00:21:07.000000', 'temperatura', 264.0000, 'ºC'),
	(143172, 118, '2014-01-15 00:21:08.000000', 'temperatura', 866.0000, 'ºC'),
	(143173, 118, '2014-01-15 00:21:09.000000', 'temperatura', 1140.0000, 'ºC'),
	(143174, 118, '2014-01-15 00:21:10.000000', 'temperatura', 700.0000, 'ºC'),
	(143175, 118, '2014-01-15 00:21:11.000000', 'temperatura', 80.0000, 'ºC'),
	(143176, 118, '2014-01-15 00:21:12.000000', 'temperatura', 703.0000, 'ºC'),
	(143177, 118, '2014-01-15 00:21:13.000000', 'temperatura', 875.0000, 'ºC'),
	(143178, 118, '2014-01-15 00:21:14.000000', 'temperatura', 1066.0000, 'ºC'),
	(143179, 118, '2014-01-15 00:21:15.000000', 'temperatura', 306.0000, 'ºC'),
	(143180, 118, '2014-01-15 00:21:16.000000', 'temperatura', 730.0000, 'ºC'),
	(143181, 118, '2014-01-15 00:21:17.000000', 'temperatura', 335.0000, 'ºC'),
	(143182, 118, '2014-01-15 00:21:18.000000', 'temperatura', 685.0000, 'ºC'),
	(143183, 118, '2014-01-15 00:21:19.000000', 'temperatura', 20.0000, 'ºC'),
	(143184, 118, '2014-01-15 00:21:20.000000', 'temperatura', 448.0000, 'ºC'),
	(143185, 118, '2014-01-15 00:21:21.000000', 'temperatura', 978.0000, 'ºC'),
	(143186, 118, '2014-01-15 00:21:22.000000', 'temperatura', 1149.0000, 'ºC'),
	(143187, 118, '2014-01-15 00:21:23.000000', 'temperatura', 410.0000, 'ºC'),
	(143188, 118, '2014-01-15 00:21:24.000000', 'temperatura', 1006.0000, 'ºC'),
	(143189, 118, '2014-01-15 00:21:25.000000', 'temperatura', 197.0000, 'ºC'),
	(143190, 118, '2014-01-15 00:21:26.000000', 'temperatura', 370.0000, 'ºC'),
	(143191, 118, '2014-01-15 00:21:27.000000', 'temperatura', 57.0000, 'ºC'),
	(143192, 118, '2014-01-15 00:21:28.000000', 'temperatura', 377.0000, 'ºC'),
	(143193, 118, '2014-01-15 00:21:29.000000', 'temperatura', 514.0000, 'ºC'),
	(143194, 118, '2014-01-15 00:21:30.000000', 'temperatura', 240.0000, 'ºC'),
	(143195, 118, '2014-01-15 00:21:31.000000', 'temperatura', 859.0000, 'ºC'),
	(143196, 118, '2014-01-15 00:21:32.000000', 'temperatura', 1175.0000, 'ºC'),
	(143197, 118, '2014-01-15 00:21:33.000000', 'temperatura', 897.0000, 'ºC'),
	(143198, 118, '2014-01-15 00:21:34.000000', 'temperatura', 963.0000, 'ºC'),
	(143199, 118, '2014-01-15 00:21:35.000000', 'temperatura', 922.0000, 'ºC'),
	(143200, 118, '2014-01-15 00:21:36.000000', 'temperatura', 524.0000, 'ºC'),
	(143201, 118, '2014-01-15 00:21:37.000000', 'temperatura', 1056.0000, 'ºC'),
	(143202, 118, '2014-01-15 00:21:38.000000', 'temperatura', 105.0000, 'ºC'),
	(143203, 118, '2014-01-15 00:21:39.000000', 'temperatura', 958.0000, 'ºC'),
	(143204, 118, '2014-01-15 00:21:40.000000', 'temperatura', 877.0000, 'ºC'),
	(143205, 118, '2014-01-15 00:21:41.000000', 'temperatura', 309.0000, 'ºC'),
	(143206, 118, '2014-01-15 00:21:42.000000', 'temperatura', 116.0000, 'ºC'),
	(143207, 118, '2014-01-15 00:21:43.000000', 'temperatura', 854.0000, 'ºC'),
	(143208, 118, '2014-01-15 00:21:44.000000', 'temperatura', 323.0000, 'ºC'),
	(143209, 118, '2014-01-15 00:21:45.000000', 'temperatura', 253.0000, 'ºC'),
	(143210, 118, '2014-01-15 00:21:46.000000', 'temperatura', 298.0000, 'ºC'),
	(143211, 118, '2014-01-15 00:21:47.000000', 'temperatura', 732.0000, 'ºC'),
	(143212, 118, '2014-01-15 00:21:48.000000', 'temperatura', 367.0000, 'ºC'),
	(143213, 118, '2014-01-15 00:21:49.000000', 'temperatura', 837.0000, 'ºC'),
	(143214, 118, '2014-01-15 00:21:50.000000', 'temperatura', 685.0000, 'ºC'),
	(143215, 118, '2014-01-15 00:21:51.000000', 'temperatura', 915.0000, 'ºC'),
	(143216, 118, '2014-01-15 00:21:52.000000', 'temperatura', 118.0000, 'ºC'),
	(143217, 118, '2014-01-15 00:21:53.000000', 'temperatura', 249.0000, 'ºC'),
	(143218, 118, '2014-01-15 00:21:54.000000', 'temperatura', 891.0000, 'ºC'),
	(143219, 118, '2014-01-15 00:21:55.000000', 'temperatura', 106.0000, 'ºC'),
	(143220, 118, '2014-01-15 00:21:56.000000', 'temperatura', 259.0000, 'ºC'),
	(143221, 118, '2014-01-15 00:21:57.000000', 'temperatura', 977.0000, 'ºC'),
	(143222, 118, '2014-01-15 00:21:58.000000', 'temperatura', 511.0000, 'ºC'),
	(143223, 118, '2014-01-15 00:21:59.000000', 'temperatura', 821.0000, 'ºC'),
	(143224, 118, '2014-01-15 00:22:00.000000', 'temperatura', 176.0000, 'ºC'),
	(143225, 118, '2014-01-15 00:22:01.000000', 'temperatura', 816.0000, 'ºC'),
	(143226, 118, '2014-01-15 00:22:02.000000', 'temperatura', 1151.0000, 'ºC'),
	(143227, 118, '2014-01-15 00:22:03.000000', 'temperatura', 911.0000, 'ºC'),
	(143228, 118, '2014-01-15 00:22:04.000000', 'temperatura', 1099.0000, 'ºC'),
	(143229, 118, '2014-01-15 00:22:05.000000', 'temperatura', 365.0000, 'ºC'),
	(143230, 118, '2014-01-15 00:22:06.000000', 'temperatura', 928.0000, 'ºC'),
	(143231, 118, '2014-01-15 00:22:07.000000', 'temperatura', 1144.0000, 'ºC'),
	(143232, 118, '2014-01-15 00:22:08.000000', 'temperatura', 539.0000, 'ºC'),
	(143233, 118, '2014-01-15 00:22:09.000000', 'temperatura', 462.0000, 'ºC'),
	(143234, 118, '2014-01-15 00:22:10.000000', 'temperatura', 694.0000, 'ºC'),
	(143235, 118, '2014-01-15 00:22:11.000000', 'temperatura', 883.0000, 'ºC'),
	(143236, 118, '2014-01-15 00:22:12.000000', 'temperatura', 1133.0000, 'ºC'),
	(143237, 118, '2014-01-15 00:22:13.000000', 'temperatura', 618.0000, 'ºC'),
	(143238, 118, '2014-01-15 00:22:14.000000', 'temperatura', 892.0000, 'ºC'),
	(143239, 118, '2014-01-15 00:22:15.000000', 'temperatura', 205.0000, 'ºC'),
	(143240, 118, '2014-01-15 00:22:16.000000', 'temperatura', 751.0000, 'ºC'),
	(143241, 118, '2014-01-15 00:22:17.000000', 'temperatura', 739.0000, 'ºC'),
	(143242, 118, '2014-01-15 00:22:18.000000', 'temperatura', 242.0000, 'ºC'),
	(143243, 118, '2014-01-15 00:22:19.000000', 'temperatura', 193.0000, 'ºC'),
	(143244, 118, '2014-01-15 00:22:20.000000', 'temperatura', 239.0000, 'ºC'),
	(143245, 118, '2014-01-15 00:22:21.000000', 'temperatura', 616.0000, 'ºC'),
	(143246, 118, '2014-01-15 00:22:22.000000', 'temperatura', 1165.0000, 'ºC'),
	(143247, 118, '2014-01-15 00:22:23.000000', 'temperatura', 379.0000, 'ºC'),
	(143248, 118, '2014-01-15 00:22:24.000000', 'temperatura', 798.0000, 'ºC'),
	(143249, 118, '2014-01-15 00:22:25.000000', 'temperatura', 456.0000, 'ºC'),
	(143250, 118, '2014-01-15 00:22:26.000000', 'temperatura', 1087.0000, 'ºC'),
	(143251, 118, '2014-01-15 00:22:27.000000', 'temperatura', 468.0000, 'ºC'),
	(143252, 118, '2014-01-15 00:22:28.000000', 'temperatura', 277.0000, 'ºC'),
	(143253, 118, '2014-01-15 00:22:29.000000', 'temperatura', 1184.0000, 'ºC'),
	(143254, 118, '2014-01-15 00:22:30.000000', 'temperatura', 290.0000, 'ºC'),
	(143255, 118, '2014-01-15 00:22:31.000000', 'temperatura', 298.0000, 'ºC'),
	(143256, 118, '2014-01-15 00:22:32.000000', 'temperatura', 619.0000, 'ºC'),
	(143257, 118, '2014-01-15 00:22:33.000000', 'temperatura', 1001.0000, 'ºC'),
	(143258, 118, '2014-01-15 00:22:34.000000', 'temperatura', 749.0000, 'ºC'),
	(143259, 118, '2014-01-15 00:22:35.000000', 'temperatura', 741.0000, 'ºC'),
	(143260, 118, '2014-01-15 00:22:36.000000', 'temperatura', 260.0000, 'ºC'),
	(143261, 118, '2014-01-15 00:22:37.000000', 'temperatura', 277.0000, 'ºC'),
	(143262, 118, '2014-01-15 00:22:38.000000', 'temperatura', 608.0000, 'ºC'),
	(143263, 118, '2014-01-15 00:22:39.000000', 'temperatura', 1006.0000, 'ºC'),
	(143264, 118, '2014-01-15 00:22:40.000000', 'temperatura', 807.0000, 'ºC'),
	(143265, 118, '2014-01-15 00:22:41.000000', 'temperatura', 1018.0000, 'ºC'),
	(143266, 118, '2014-01-15 00:22:42.000000', 'temperatura', 269.0000, 'ºC'),
	(143267, 118, '2014-01-15 00:22:43.000000', 'temperatura', 691.0000, 'ºC'),
	(143268, 118, '2014-01-15 00:22:44.000000', 'temperatura', 250.0000, 'ºC'),
	(143269, 118, '2014-01-15 00:22:45.000000', 'temperatura', 376.0000, 'ºC'),
	(143270, 118, '2014-01-15 00:22:46.000000', 'temperatura', 1133.0000, 'ºC'),
	(143271, 118, '2014-01-15 00:22:47.000000', 'temperatura', 935.0000, 'ºC'),
	(143272, 118, '2014-01-15 00:22:48.000000', 'temperatura', 76.0000, 'ºC'),
	(143273, 118, '2014-01-15 00:22:49.000000', 'temperatura', 1177.0000, 'ºC'),
	(143274, 118, '2014-01-15 00:22:50.000000', 'temperatura', 855.0000, 'ºC'),
	(143275, 118, '2014-01-15 00:22:51.000000', 'temperatura', 747.0000, 'ºC'),
	(143276, 118, '2014-01-15 00:22:52.000000', 'temperatura', 1170.0000, 'ºC'),
	(143277, 118, '2014-01-15 00:22:53.000000', 'temperatura', 11.0000, 'ºC'),
	(143278, 118, '2014-01-15 00:22:54.000000', 'temperatura', 146.0000, 'ºC'),
	(143279, 118, '2014-01-15 00:22:55.000000', 'temperatura', 697.0000, 'ºC'),
	(143280, 118, '2014-01-15 00:22:56.000000', 'temperatura', 648.0000, 'ºC'),
	(143281, 118, '2014-01-15 00:22:57.000000', 'temperatura', 1151.0000, 'ºC'),
	(143282, 118, '2014-01-15 00:22:58.000000', 'temperatura', 208.0000, 'ºC'),
	(143283, 118, '2014-01-15 00:22:59.000000', 'temperatura', 1188.0000, 'ºC'),
	(143284, 118, '2014-01-15 00:23:00.000000', 'temperatura', 518.0000, 'ºC'),
	(143285, 118, '2014-01-15 00:23:01.000000', 'temperatura', 228.0000, 'ºC'),
	(143286, 118, '2014-01-15 00:23:02.000000', 'temperatura', 784.0000, 'ºC'),
	(143287, 118, '2014-01-15 00:23:03.000000', 'temperatura', 836.0000, 'ºC'),
	(143288, 118, '2014-01-15 00:23:04.000000', 'temperatura', 630.0000, 'ºC'),
	(143289, 118, '2014-01-15 00:23:05.000000', 'temperatura', 643.0000, 'ºC'),
	(143290, 118, '2014-01-15 00:23:06.000000', 'temperatura', 123.0000, 'ºC'),
	(143291, 118, '2014-01-15 00:23:07.000000', 'temperatura', 1089.0000, 'ºC'),
	(143292, 118, '2014-01-15 00:23:08.000000', 'temperatura', 275.0000, 'ºC'),
	(143293, 118, '2014-01-15 00:23:09.000000', 'temperatura', 508.0000, 'ºC'),
	(143294, 118, '2014-01-15 00:23:10.000000', 'temperatura', 515.0000, 'ºC'),
	(143295, 118, '2014-01-15 00:23:11.000000', 'temperatura', 1052.0000, 'ºC'),
	(143296, 118, '2014-01-15 00:23:12.000000', 'temperatura', 117.0000, 'ºC'),
	(143297, 118, '2014-01-15 00:23:13.000000', 'temperatura', 1028.0000, 'ºC'),
	(143298, 118, '2014-01-15 00:23:14.000000', 'temperatura', 1190.0000, 'ºC'),
	(143299, 118, '2014-01-15 00:23:15.000000', 'temperatura', 468.0000, 'ºC'),
	(143300, 118, '2014-01-15 00:23:16.000000', 'temperatura', 1170.0000, 'ºC'),
	(143301, 118, '2014-01-15 00:23:17.000000', 'temperatura', 846.0000, 'ºC'),
	(143302, 118, '2014-01-15 00:23:18.000000', 'temperatura', 722.0000, 'ºC'),
	(143303, 118, '2014-01-15 00:23:19.000000', 'temperatura', 1073.0000, 'ºC'),
	(143304, 118, '2014-01-15 00:23:20.000000', 'temperatura', 800.0000, 'ºC'),
	(143305, 118, '2014-01-15 00:23:21.000000', 'temperatura', 782.0000, 'ºC'),
	(143306, 118, '2014-01-15 00:23:22.000000', 'temperatura', 308.0000, 'ºC'),
	(143307, 118, '2014-01-15 00:23:23.000000', 'temperatura', 397.0000, 'ºC'),
	(143308, 118, '2014-01-15 00:23:24.000000', 'temperatura', 1062.0000, 'ºC'),
	(143309, 118, '2014-01-15 00:23:25.000000', 'temperatura', 517.0000, 'ºC'),
	(143310, 118, '2014-01-15 00:23:26.000000', 'temperatura', 602.0000, 'ºC'),
	(143311, 118, '2014-01-15 00:23:27.000000', 'temperatura', 258.0000, 'ºC'),
	(143312, 118, '2014-01-15 00:23:28.000000', 'temperatura', 683.0000, 'ºC'),
	(143313, 118, '2014-01-15 00:23:29.000000', 'temperatura', 244.0000, 'ºC'),
	(143314, 118, '2014-01-15 00:23:30.000000', 'temperatura', 372.0000, 'ºC'),
	(143315, 118, '2014-01-15 00:23:31.000000', 'temperatura', 1129.0000, 'ºC'),
	(143316, 118, '2014-01-15 00:23:32.000000', 'temperatura', 929.0000, 'ºC'),
	(143317, 118, '2014-01-15 00:23:33.000000', 'temperatura', 60.0000, 'ºC'),
	(143318, 118, '2014-01-15 00:23:34.000000', 'temperatura', 1112.0000, 'ºC'),
	(143319, 118, '2014-01-15 00:23:35.000000', 'temperatura', 580.0000, 'ºC'),
	(143320, 118, '2014-01-15 00:23:36.000000', 'temperatura', 765.0000, 'ºC'),
	(143321, 118, '2014-01-15 00:23:37.000000', 'temperatura', 884.0000, 'ºC'),
	(143322, 118, '2014-01-15 00:23:38.000000', 'temperatura', 928.0000, 'ºC'),
	(143323, 118, '2014-01-15 00:23:39.000000', 'temperatura', 789.0000, 'ºC'),
	(143324, 118, '2014-01-15 00:23:40.000000', 'temperatura', 1161.0000, 'ºC'),
	(143325, 118, '2014-01-15 00:23:41.000000', 'temperatura', 1037.0000, 'ºC'),
	(143326, 118, '2014-01-15 00:23:42.000000', 'temperatura', 502.0000, 'ºC'),
	(143327, 118, '2014-01-15 00:23:43.000000', 'temperatura', 602.0000, 'ºC'),
	(143328, 118, '2014-01-15 00:23:44.000000', 'temperatura', 305.0000, 'ºC'),
	(143329, 118, '2014-01-15 00:23:45.000000', 'temperatura', 919.0000, 'ºC'),
	(143330, 118, '2014-01-15 00:23:46.000000', 'temperatura', 80.0000, 'ºC'),
	(143331, 118, '2014-01-15 00:23:47.000000', 'temperatura', 44.0000, 'ºC'),
	(143332, 118, '2014-01-15 00:23:48.000000', 'temperatura', 1181.0000, 'ºC'),
	(143333, 118, '2014-01-15 00:23:49.000000', 'temperatura', 971.0000, 'ºC'),
	(143334, 118, '2014-01-15 00:23:50.000000', 'temperatura', 113.0000, 'ºC'),
	(143335, 118, '2014-01-15 00:23:51.000000', 'temperatura', 53.0000, 'ºC'),
	(143336, 118, '2014-01-15 00:23:52.000000', 'temperatura', 1128.0000, 'ºC'),
	(143337, 118, '2014-01-15 00:23:53.000000', 'temperatura', 681.0000, 'ºC'),
	(143338, 118, '2014-01-15 00:23:54.000000', 'temperatura', 22.0000, 'ºC'),
	(143339, 118, '2014-01-15 00:23:55.000000', 'temperatura', 465.0000, 'ºC'),
	(143340, 118, '2014-01-15 00:23:56.000000', 'temperatura', 1061.0000, 'ºC'),
	(143341, 118, '2014-01-15 00:23:57.000000', 'temperatura', 312.0000, 'ºC'),
	(143342, 118, '2014-01-15 00:23:58.000000', 'temperatura', 778.0000, 'ºC'),
	(143343, 118, '2014-01-15 00:23:59.000000', 'temperatura', 552.0000, 'ºC'),
	(143344, 118, '2014-01-15 00:24:00.000000', 'temperatura', 428.0000, 'ºC'),
	(143345, 118, '2014-01-15 00:24:01.000000', 'temperatura', 485.0000, 'ºC'),
	(143346, 118, '2014-01-15 00:24:02.000000', 'temperatura', 1141.0000, 'ºC'),
	(143347, 118, '2014-01-15 00:24:03.000000', 'temperatura', 652.0000, 'ºC'),
	(143348, 118, '2014-01-15 00:24:04.000000', 'temperatura', 1035.0000, 'ºC'),
	(143349, 118, '2014-01-15 00:24:05.000000', 'temperatura', 820.0000, 'ºC'),
	(143350, 118, '2014-01-15 00:24:06.000000', 'temperatura', 996.0000, 'ºC'),
	(143351, 118, '2014-01-15 00:24:07.000000', 'temperatura', 119.0000, 'ºC'),
	(143352, 118, '2014-01-15 00:24:08.000000', 'temperatura', 10.0000, 'ºC'),
	(143353, 118, '2014-01-15 00:24:09.000000', 'temperatura', 894.0000, 'ºC'),
	(143354, 118, '2014-01-15 00:24:10.000000', 'temperatura', 838.0000, 'ºC'),
	(143355, 118, '2014-01-15 00:24:11.000000', 'temperatura', 309.0000, 'ºC'),
	(143356, 118, '2014-01-15 00:24:12.000000', 'temperatura', 233.0000, 'ºC'),
	(143357, 118, '2014-01-15 00:24:13.000000', 'temperatura', 237.0000, 'ºC'),
	(143358, 118, '2014-01-15 00:24:14.000000', 'temperatura', 485.0000, 'ºC'),
	(143359, 118, '2014-01-15 00:24:15.000000', 'temperatura', 517.0000, 'ºC'),
	(143360, 118, '2014-01-15 00:24:16.000000', 'temperatura', 1131.0000, 'ºC'),
	(143361, 118, '2014-01-15 00:24:17.000000', 'temperatura', 502.0000, 'ºC'),
	(143362, 118, '2014-01-15 00:24:18.000000', 'temperatura', 317.0000, 'ºC'),
	(143363, 118, '2014-01-15 00:24:19.000000', 'temperatura', 80.0000, 'ºC'),
	(143364, 118, '2014-01-15 00:24:20.000000', 'temperatura', 651.0000, 'ºC'),
	(143365, 118, '2014-01-15 00:24:21.000000', 'temperatura', 614.0000, 'ºC'),
	(143366, 118, '2014-01-15 00:24:22.000000', 'temperatura', 1117.0000, 'ºC'),
	(143367, 118, '2014-01-15 00:24:23.000000', 'temperatura', 145.0000, 'ºC'),
	(143368, 118, '2014-01-15 00:24:24.000000', 'temperatura', 976.0000, 'ºC'),
	(143369, 118, '2014-01-15 00:24:25.000000', 'temperatura', 842.0000, 'ºC'),
	(143370, 118, '2014-01-15 00:24:26.000000', 'temperatura', 85.0000, 'ºC'),
	(143371, 118, '2014-01-15 00:24:27.000000', 'temperatura', 298.0000, 'ºC'),
	(143372, 118, '2014-01-15 00:24:28.000000', 'temperatura', 37.0000, 'ºC'),
	(143373, 118, '2014-01-15 00:24:29.000000', 'temperatura', 491.0000, 'ºC'),
	(143374, 118, '2014-01-15 00:24:30.000000', 'temperatura', 1144.0000, 'ºC'),
	(143375, 118, '2014-01-15 00:24:31.000000', 'temperatura', 647.0000, 'ºC'),
	(143376, 118, '2014-01-15 00:24:32.000000', 'temperatura', 1003.0000, 'ºC'),
	(143377, 118, '2014-01-15 00:24:33.000000', 'temperatura', 676.0000, 'ºC'),
	(143378, 118, '2014-01-15 00:24:34.000000', 'temperatura', 373.0000, 'ºC'),
	(143379, 118, '2014-01-15 00:24:35.000000', 'temperatura', 1034.0000, 'ºC'),
	(143380, 118, '2014-01-15 00:24:36.000000', 'temperatura', 455.0000, 'ºC'),
	(143381, 118, '2014-01-15 00:24:37.000000', 'temperatura', 372.0000, 'ºC'),
	(143382, 118, '2014-01-15 00:24:38.000000', 'temperatura', 495.0000, 'ºC'),
	(143383, 118, '2014-01-15 00:24:39.000000', 'temperatura', 160.0000, 'ºC'),
	(143384, 118, '2014-01-15 00:24:40.000000', 'temperatura', 518.0000, 'ºC'),
	(143385, 118, '2014-01-15 00:24:41.000000', 'temperatura', 907.0000, 'ºC'),
	(143386, 118, '2014-01-15 00:24:42.000000', 'temperatura', 581.0000, 'ºC'),
	(143387, 118, '2014-01-15 00:24:43.000000', 'temperatura', 187.0000, 'ºC'),
	(143388, 118, '2014-01-15 00:24:44.000000', 'temperatura', 393.0000, 'ºC'),
	(143389, 118, '2014-01-15 00:24:45.000000', 'temperatura', 203.0000, 'ºC'),
	(143390, 118, '2014-01-15 00:24:46.000000', 'temperatura', 1035.0000, 'ºC'),
	(143391, 118, '2014-01-15 00:24:47.000000', 'temperatura', 969.0000, 'ºC'),
	(143392, 118, '2014-01-15 00:24:48.000000', 'temperatura', 540.0000, 'ºC'),
	(143393, 118, '2014-01-15 00:24:49.000000', 'temperatura', 994.0000, 'ºC'),
	(143394, 118, '2014-01-15 00:24:50.000000', 'temperatura', 951.0000, 'ºC'),
	(143395, 118, '2014-01-15 00:24:51.000000', 'temperatura', 573.0000, 'ºC'),
	(143396, 118, '2014-01-15 00:24:52.000000', 'temperatura', 12.0000, 'ºC'),
	(143397, 118, '2014-01-15 00:24:53.000000', 'temperatura', 741.0000, 'ºC'),
	(143398, 118, '2014-01-15 00:24:54.000000', 'temperatura', 69.0000, 'ºC'),
	(143399, 118, '2014-01-15 00:24:55.000000', 'temperatura', 522.0000, 'ºC'),
	(143400, 118, '2014-01-15 00:24:56.000000', 'temperatura', 4.0000, 'ºC'),
	(143401, 118, '2014-01-15 00:24:57.000000', 'temperatura', 855.0000, 'ºC'),
	(143402, 118, '2014-01-15 00:24:58.000000', 'temperatura', 664.0000, 'ºC'),
	(143403, 118, '2014-01-15 00:24:59.000000', 'temperatura', 755.0000, 'ºC'),
	(143404, 118, '2014-01-15 00:25:00.000000', 'temperatura', 584.0000, 'ºC'),
	(143405, 118, '2014-01-15 00:25:01.000000', 'temperatura', 657.0000, 'ºC'),
	(143406, 118, '2014-01-15 00:25:02.000000', 'temperatura', 331.0000, 'ºC'),
	(143407, 118, '2014-01-15 00:25:03.000000', 'temperatura', 887.0000, 'ºC'),
	(143408, 118, '2014-01-15 00:25:04.000000', 'temperatura', 1041.0000, 'ºC'),
	(143409, 118, '2014-01-15 00:25:05.000000', 'temperatura', 144.0000, 'ºC'),
	(143410, 118, '2014-01-15 00:25:06.000000', 'temperatura', 1196.0000, 'ºC'),
	(143411, 118, '2014-01-15 00:25:07.000000', 'temperatura', 751.0000, 'ºC'),
	(143412, 118, '2014-01-15 00:25:08.000000', 'temperatura', 165.0000, 'ºC'),
	(143413, 118, '2014-01-15 00:25:09.000000', 'temperatura', 974.0000, 'ºC'),
	(143414, 118, '2014-01-15 00:25:10.000000', 'temperatura', 774.0000, 'ºC'),
	(143415, 118, '2014-01-15 00:25:11.000000', 'temperatura', 950.0000, 'ºC'),
	(143416, 118, '2014-01-15 00:25:12.000000', 'temperatura', 27.0000, 'ºC'),
	(143417, 118, '2014-01-15 00:25:13.000000', 'temperatura', 887.0000, 'ºC'),
	(143418, 118, '2014-01-15 00:25:14.000000', 'temperatura', 754.0000, 'ºC'),
	(143419, 118, '2014-01-15 00:25:15.000000', 'temperatura', 1108.0000, 'ºC'),
	(143420, 118, '2014-01-15 00:25:16.000000', 'temperatura', 878.0000, 'ºC'),
	(143421, 118, '2014-01-15 00:25:17.000000', 'temperatura', 1069.0000, 'ºC'),
	(143422, 118, '2014-01-15 00:25:18.000000', 'temperatura', 310.0000, 'ºC'),
	(143423, 118, '2014-01-15 00:25:19.000000', 'temperatura', 745.0000, 'ºC'),
	(143424, 118, '2014-01-15 00:25:20.000000', 'temperatura', 393.0000, 'ºC'),
	(143425, 118, '2014-01-15 00:25:21.000000', 'temperatura', 931.0000, 'ºC'),
	(143426, 118, '2014-01-15 00:25:22.000000', 'temperatura', 1078.0000, 'ºC'),
	(143427, 118, '2014-01-15 00:25:23.000000', 'temperatura', 196.0000, 'ºC'),
	(143428, 118, '2014-01-15 00:25:24.000000', 'temperatura', 149.0000, 'ºC'),
	(143429, 118, '2014-01-15 00:25:25.000000', 'temperatura', 157.0000, 'ºC'),
	(143430, 118, '2014-01-15 00:25:26.000000', 'temperatura', 337.0000, 'ºC'),
	(143431, 118, '2014-01-15 00:25:27.000000', 'temperatura', 15.0000, 'ºC'),
	(143432, 118, '2014-01-15 00:25:28.000000', 'temperatura', 263.0000, 'ºC'),
	(143433, 118, '2014-01-15 00:25:29.000000', 'temperatura', 73.0000, 'ºC'),
	(143434, 118, '2014-01-15 00:25:30.000000', 'temperatura', 776.0000, 'ºC'),
	(143435, 118, '2014-01-15 00:25:31.000000', 'temperatura', 63.0000, 'ºC'),
	(143436, 118, '2014-01-15 00:25:32.000000', 'temperatura', 386.0000, 'ºC'),
	(143437, 118, '2014-01-15 00:25:33.000000', 'temperatura', 540.0000, 'ºC'),
	(143438, 118, '2014-01-15 00:25:34.000000', 'temperatura', 346.0000, 'ºC'),
	(143439, 118, '2014-01-15 00:25:35.000000', 'temperatura', 108.0000, 'ºC'),
	(143440, 118, '2014-01-15 00:25:36.000000', 'temperatura', 701.0000, 'ºC'),
	(143441, 118, '2014-01-15 00:25:37.000000', 'temperatura', 785.0000, 'ºC'),
	(143442, 118, '2014-01-15 00:25:38.000000', 'temperatura', 621.0000, 'ºC'),
	(143443, 118, '2014-01-15 00:25:39.000000', 'temperatura', 750.0000, 'ºC'),
	(143444, 118, '2014-01-15 00:25:40.000000', 'temperatura', 688.0000, 'ºC'),
	(143445, 118, '2014-01-15 00:25:41.000000', 'temperatura', 1189.0000, 'ºC'),
	(143446, 118, '2014-01-15 00:25:42.000000', 'temperatura', 282.0000, 'ºC'),
	(143447, 118, '2014-01-15 00:25:43.000000', 'temperatura', 246.0000, 'ºC'),
	(143448, 118, '2014-01-15 00:25:44.000000', 'temperatura', 381.0000, 'ºC'),
	(143449, 118, '2014-01-15 00:25:45.000000', 'temperatura', 1170.0000, 'ºC'),
	(143450, 118, '2014-01-15 00:25:46.000000', 'temperatura', 1109.0000, 'ºC'),
	(143451, 118, '2014-01-15 00:25:47.000000', 'temperatura', 832.0000, 'ºC'),
	(143452, 118, '2014-01-15 00:25:48.000000', 'temperatura', 835.0000, 'ºC'),
	(143453, 118, '2014-01-15 00:25:49.000000', 'temperatura', 478.0000, 'ºC'),
	(143454, 118, '2014-01-15 00:25:50.000000', 'temperatura', 1087.0000, 'ºC'),
	(143455, 118, '2014-01-15 00:25:51.000000', 'temperatura', 400.0000, 'ºC'),
	(143456, 118, '2014-01-15 00:25:52.000000', 'temperatura', 1139.0000, 'ºC'),
	(143457, 118, '2014-01-15 00:25:53.000000', 'temperatura', 894.0000, 'ºC'),
	(143458, 118, '2014-01-15 00:25:54.000000', 'temperatura', 1056.0000, 'ºC'),
	(143459, 118, '2014-01-15 00:25:55.000000', 'temperatura', 200.0000, 'ºC'),
	(143460, 118, '2014-01-15 00:25:56.000000', 'temperatura', 230.0000, 'ºC'),
	(143461, 118, '2014-01-15 00:25:57.000000', 'temperatura', 551.0000, 'ºC'),
	(143462, 118, '2014-01-15 00:25:58.000000', 'temperatura', 866.0000, 'ºC'),
	(143463, 118, '2014-01-15 00:25:59.000000', 'temperatura', 275.0000, 'ºC'),
	(143464, 118, '2014-01-15 00:26:00.000000', 'temperatura', 1181.0000, 'ºC'),
	(143465, 118, '2014-01-15 00:26:01.000000', 'temperatura', 279.0000, 'ºC'),
	(143466, 118, '2014-01-15 00:26:02.000000', 'temperatura', 254.0000, 'ºC'),
	(143467, 118, '2014-01-15 00:26:03.000000', 'temperatura', 435.0000, 'ºC'),
	(143468, 118, '2014-01-15 00:26:04.000000', 'temperatura', 210.0000, 'ºC'),
	(143469, 118, '2014-01-15 00:26:05.000000', 'temperatura', 948.0000, 'ºC'),
	(143470, 118, '2014-01-15 00:26:06.000000', 'temperatura', 508.0000, 'ºC'),
	(143471, 118, '2014-01-15 00:26:07.000000', 'temperatura', 898.0000, 'ºC'),
	(143472, 118, '2014-01-15 00:26:08.000000', 'temperatura', 565.0000, 'ºC'),
	(143473, 118, '2014-01-15 00:26:09.000000', 'temperatura', 133.0000, 'ºC'),
	(143474, 118, '2014-01-15 00:26:10.000000', 'temperatura', 168.0000, 'ºC'),
	(143475, 118, '2014-01-15 00:26:11.000000', 'temperatura', 444.0000, 'ºC'),
	(143476, 118, '2014-01-15 00:26:12.000000', 'temperatura', 514.0000, 'ºC'),
	(143477, 118, '2014-01-15 00:26:13.000000', 'temperatura', 41.0000, 'ºC'),
	(143478, 118, '2014-01-15 00:26:14.000000', 'temperatura', 1063.0000, 'ºC'),
	(143479, 118, '2014-01-15 00:26:15.000000', 'temperatura', 393.0000, 'ºC'),
	(143480, 118, '2014-01-15 00:26:16.000000', 'temperatura', 1176.0000, 'ºC'),
	(143481, 118, '2014-01-15 00:26:17.000000', 'temperatura', 1102.0000, 'ºC'),
	(143482, 118, '2014-01-15 00:26:18.000000', 'temperatura', 783.0000, 'ºC'),
	(143483, 118, '2014-01-15 00:26:19.000000', 'temperatura', 609.0000, 'ºC'),
	(143484, 118, '2014-01-15 00:26:20.000000', 'temperatura', 696.0000, 'ºC'),
	(143485, 118, '2014-01-15 00:26:21.000000', 'temperatura', 453.0000, 'ºC'),
	(143486, 118, '2014-01-15 00:26:22.000000', 'temperatura', 177.0000, 'ºC'),
	(143487, 118, '2014-01-15 00:26:23.000000', 'temperatura', 725.0000, 'ºC'),
	(143488, 118, '2014-01-15 00:26:24.000000', 'temperatura', 697.0000, 'ºC'),
	(143489, 118, '2014-01-15 00:26:25.000000', 'temperatura', 110.0000, 'ºC'),
	(143490, 118, '2014-01-15 00:26:26.000000', 'temperatura', 861.0000, 'ºC'),
	(143491, 118, '2014-01-15 00:26:27.000000', 'temperatura', 375.0000, 'ºC'),
	(143492, 118, '2014-01-15 00:26:28.000000', 'temperatura', 492.0000, 'ºC'),
	(143493, 118, '2014-01-15 00:26:29.000000', 'temperatura', 137.0000, 'ºC'),
	(143494, 118, '2014-01-15 00:26:30.000000', 'temperatura', 409.0000, 'ºC'),
	(143495, 118, '2014-01-15 00:26:31.000000', 'temperatura', 434.0000, 'ºC'),
	(143496, 118, '2014-01-15 00:26:32.000000', 'temperatura', 942.0000, 'ºC'),
	(143497, 118, '2014-01-15 00:26:33.000000', 'temperatura', 1009.0000, 'ºC'),
	(143498, 118, '2014-01-15 00:26:34.000000', 'temperatura', 1020.0000, 'ºC'),
	(143499, 118, '2014-01-15 00:26:35.000000', 'temperatura', 872.0000, 'ºC'),
	(143500, 118, '2014-01-15 00:26:36.000000', 'temperatura', 101.0000, 'ºC'),
	(143501, 118, '2014-01-15 00:26:37.000000', 'temperatura', 288.0000, 'ºC'),
	(143502, 118, '2014-01-15 00:26:38.000000', 'temperatura', 1139.0000, 'ºC'),
	(143503, 118, '2014-01-15 00:26:39.000000', 'temperatura', 31.0000, 'ºC'),
	(143504, 118, '2014-01-15 00:26:40.000000', 'temperatura', 337.0000, 'ºC'),
	(143505, 118, '2014-01-15 00:26:41.000000', 'temperatura', 393.0000, 'ºC'),
	(143506, 118, '2014-01-15 00:26:42.000000', 'temperatura', 954.0000, 'ºC'),
	(143507, 118, '2014-01-15 00:26:43.000000', 'temperatura', 1193.0000, 'ºC'),
	(143508, 118, '2014-01-15 00:26:44.000000', 'temperatura', 703.0000, 'ºC'),
	(143509, 118, '2014-01-15 00:26:45.000000', 'temperatura', 1138.0000, 'ºC'),
	(143510, 118, '2014-01-15 00:26:46.000000', 'temperatura', 1180.0000, 'ºC'),
	(143511, 118, '2014-01-15 00:26:47.000000', 'temperatura', 87.0000, 'ºC'),
	(143512, 118, '2014-01-15 00:26:48.000000', 'temperatura', 496.0000, 'ºC'),
	(143513, 118, '2014-01-15 00:26:49.000000', 'temperatura', 1018.0000, 'ºC'),
	(143514, 118, '2014-01-15 00:26:50.000000', 'temperatura', 5.0000, 'ºC'),
	(143515, 118, '2014-01-15 00:26:51.000000', 'temperatura', 569.0000, 'ºC'),
	(143516, 118, '2014-01-15 00:26:52.000000', 'temperatura', 432.0000, 'ºC'),
	(143517, 118, '2014-01-15 00:26:53.000000', 'temperatura', 451.0000, 'ºC'),
	(143518, 118, '2014-01-15 00:26:54.000000', 'temperatura', 962.0000, 'ºC'),
	(143519, 118, '2014-01-15 00:26:55.000000', 'temperatura', 1057.0000, 'ºC'),
	(143520, 118, '2014-01-15 00:26:56.000000', 'temperatura', 1199.0000, 'ºC'),
	(143521, 118, '2014-01-15 00:26:57.000000', 'temperatura', 424.0000, 'ºC'),
	(143522, 118, '2014-01-15 00:26:58.000000', 'temperatura', 925.0000, 'ºC'),
	(143523, 118, '2014-01-15 00:26:59.000000', 'temperatura', 954.0000, 'ºC'),
	(143524, 118, '2014-01-15 00:27:00.000000', 'temperatura', 794.0000, 'ºC'),
	(143525, 118, '2014-01-15 00:27:01.000000', 'temperatura', 1108.0000, 'ºC'),
	(143526, 118, '2014-01-15 00:27:02.000000', 'temperatura', 760.0000, 'ºC'),
	(143527, 118, '2014-01-15 00:27:03.000000', 'temperatura', 477.0000, 'ºC'),
	(143528, 118, '2014-01-15 00:27:04.000000', 'temperatura', 106.0000, 'ºC'),
	(143529, 118, '2014-01-15 00:27:05.000000', 'temperatura', 298.0000, 'ºC'),
	(143530, 118, '2014-01-15 00:27:06.000000', 'temperatura', 1173.0000, 'ºC'),
	(143531, 118, '2014-01-15 00:27:07.000000', 'temperatura', 171.0000, 'ºC'),
	(143532, 118, '2014-01-15 00:27:08.000000', 'temperatura', 937.0000, 'ºC'),
	(143533, 118, '2014-01-15 00:27:09.000000', 'temperatura', 573.0000, 'ºC'),
	(143534, 118, '2014-01-15 00:27:10.000000', 'temperatura', 52.0000, 'ºC'),
	(143535, 118, '2014-01-15 00:27:11.000000', 'temperatura', 944.0000, 'ºC'),
	(143536, 118, '2014-01-15 00:27:12.000000', 'temperatura', 963.0000, 'ºC'),
	(143537, 118, '2014-01-15 00:27:13.000000', 'temperatura', 786.0000, 'ºC'),
	(143538, 118, '2014-01-15 00:27:14.000000', 'temperatura', 1040.0000, 'ºC'),
	(143539, 118, '2014-01-15 00:27:15.000000', 'temperatura', 441.0000, 'ºC'),
	(143540, 118, '2014-01-15 00:27:16.000000', 'temperatura', 286.0000, 'ºC'),
	(143541, 118, '2014-01-15 00:27:17.000000', 'temperatura', 106.0000, 'ºC'),
	(143542, 118, '2014-01-15 00:27:18.000000', 'temperatura', 874.0000, 'ºC'),
	(143543, 118, '2014-01-15 00:27:19.000000', 'temperatura', 451.0000, 'ºC'),
	(143544, 118, '2014-01-15 00:27:20.000000', 'temperatura', 833.0000, 'ºC'),
	(143545, 118, '2014-01-15 00:27:21.000000', 'temperatura', 415.0000, 'ºC'),
	(143546, 118, '2014-01-15 00:27:22.000000', 'temperatura', 774.0000, 'ºC'),
	(143547, 118, '2014-01-15 00:27:23.000000', 'temperatura', 228.0000, 'ºC'),
	(143548, 118, '2014-01-15 00:27:24.000000', 'temperatura', 17.0000, 'ºC'),
	(143549, 118, '2014-01-15 00:27:25.000000', 'temperatura', 602.0000, 'ºC'),
	(143550, 118, '2014-01-15 00:27:26.000000', 'temperatura', 560.0000, 'ºC'),
	(143551, 118, '2014-01-15 00:27:27.000000', 'temperatura', 994.0000, 'ºC'),
	(143552, 118, '2014-01-15 00:27:28.000000', 'temperatura', 890.0000, 'ºC'),
	(143553, 118, '2014-01-15 00:27:29.000000', 'temperatura', 270.0000, 'ºC'),
	(143554, 118, '2014-01-15 00:27:30.000000', 'temperatura', 1082.0000, 'ºC'),
	(143555, 118, '2014-01-15 00:27:31.000000', 'temperatura', 998.0000, 'ºC'),
	(143556, 118, '2014-01-15 00:27:32.000000', 'temperatura', 545.0000, 'ºC'),
	(143557, 118, '2014-01-15 00:27:33.000000', 'temperatura', 930.0000, 'ºC'),
	(143558, 118, '2014-01-15 00:27:34.000000', 'temperatura', 615.0000, 'ºC'),
	(143559, 118, '2014-01-15 00:27:35.000000', 'temperatura', 286.0000, 'ºC'),
	(143560, 118, '2014-01-15 00:27:36.000000', 'temperatura', 786.0000, 'ºC'),
	(143561, 118, '2014-01-15 00:27:37.000000', 'temperatura', 673.0000, 'ºC'),
	(143562, 118, '2014-01-15 00:27:38.000000', 'temperatura', 1009.0000, 'ºC'),
	(143563, 118, '2014-01-15 00:27:39.000000', 'temperatura', 624.0000, 'ºC'),
	(143564, 118, '2014-01-15 00:27:40.000000', 'temperatura', 94.0000, 'ºC'),
	(143565, 118, '2014-01-15 00:27:41.000000', 'temperatura', 997.0000, 'ºC'),
	(143566, 118, '2014-01-15 00:27:42.000000', 'temperatura', 1105.0000, 'ºC'),
	(143567, 118, '2014-01-15 00:27:43.000000', 'temperatura', 136.0000, 'ºC'),
	(143568, 118, '2014-01-15 00:27:44.000000', 'temperatura', 965.0000, 'ºC'),
	(143569, 118, '2014-01-15 00:27:45.000000', 'temperatura', 817.0000, 'ºC'),
	(143570, 118, '2014-01-15 00:27:46.000000', 'temperatura', 1189.0000, 'ºC'),
	(143571, 118, '2014-01-15 00:27:47.000000', 'temperatura', 1097.0000, 'ºC'),
	(143572, 118, '2014-01-15 00:27:48.000000', 'temperatura', 720.0000, 'ºC'),
	(143573, 118, '2014-01-15 00:27:49.000000', 'temperatura', 306.0000, 'ºC'),
	(143574, 118, '2014-01-15 00:27:50.000000', 'temperatura', 571.0000, 'ºC'),
	(143575, 118, '2014-01-15 00:27:51.000000', 'temperatura', 738.0000, 'ºC'),
	(143576, 118, '2014-01-15 00:27:52.000000', 'temperatura', 776.0000, 'ºC'),
	(143577, 118, '2014-01-15 00:27:53.000000', 'temperatura', 466.0000, 'ºC'),
	(143578, 118, '2014-01-15 00:27:54.000000', 'temperatura', 5.0000, 'ºC'),
	(143579, 118, '2014-01-15 00:27:55.000000', 'temperatura', 1025.0000, 'ºC'),
	(143580, 118, '2014-01-15 00:27:56.000000', 'temperatura', 310.0000, 'ºC'),
	(143581, 118, '2014-01-15 00:27:57.000000', 'temperatura', 877.0000, 'ºC'),
	(143582, 118, '2014-01-15 00:27:58.000000', 'temperatura', 1053.0000, 'ºC'),
	(143583, 118, '2014-01-15 00:27:59.000000', 'temperatura', 238.0000, 'ºC'),
	(143584, 118, '2014-01-15 00:28:00.000000', 'temperatura', 430.0000, 'ºC'),
	(143585, 118, '2014-01-15 00:28:01.000000', 'temperatura', 235.0000, 'ºC'),
	(143586, 118, '2014-01-15 00:28:02.000000', 'temperatura', 1087.0000, 'ºC'),
	(143587, 118, '2014-01-15 00:28:03.000000', 'temperatura', 1129.0000, 'ºC'),
	(143588, 118, '2014-01-15 00:28:04.000000', 'temperatura', 1185.0000, 'ºC'),
	(143589, 118, '2014-01-15 00:28:05.000000', 'temperatura', 137.0000, 'ºC'),
	(143590, 118, '2014-01-15 00:28:06.000000', 'temperatura', 732.0000, 'ºC'),
	(143591, 118, '2014-01-15 00:28:07.000000', 'temperatura', 851.0000, 'ºC'),
	(143592, 118, '2014-01-15 00:28:08.000000', 'temperatura', 857.0000, 'ºC'),
	(143593, 118, '2014-01-15 00:28:09.000000', 'temperatura', 532.0000, 'ºC'),
	(143594, 118, '2014-01-15 00:28:10.000000', 'temperatura', 92.0000, 'ºC'),
	(143595, 118, '2014-01-15 00:28:11.000000', 'temperatura', 62.0000, 'ºC'),
	(143596, 118, '2014-01-15 00:28:12.000000', 'temperatura', 37.0000, 'ºC'),
	(143597, 118, '2014-01-15 00:28:13.000000', 'temperatura', 1199.0000, 'ºC'),
	(143598, 118, '2014-01-15 00:28:14.000000', 'temperatura', 1084.0000, 'ºC'),
	(143599, 118, '2014-01-15 00:28:15.000000', 'temperatura', 624.0000, 'ºC'),
	(143600, 118, '2014-01-15 00:28:16.000000', 'temperatura', 1066.0000, 'ºC'),
	(143601, 118, '2014-01-15 00:28:17.000000', 'temperatura', 1062.0000, 'ºC'),
	(143602, 118, '2014-01-15 00:28:18.000000', 'temperatura', 911.0000, 'ºC'),
	(143603, 118, '2014-01-15 00:28:19.000000', 'temperatura', 170.0000, 'ºC'),
	(143604, 118, '2014-01-15 00:28:20.000000', 'temperatura', 518.0000, 'ºC'),
	(143605, 118, '2014-01-15 00:28:21.000000', 'temperatura', 878.0000, 'ºC'),
	(143606, 118, '2014-01-15 00:28:22.000000', 'temperatura', 439.0000, 'ºC'),
	(143607, 118, '2014-01-15 00:28:23.000000', 'temperatura', 760.0000, 'ºC'),
	(143608, 118, '2014-01-15 00:28:24.000000', 'temperatura', 84.0000, 'ºC'),
	(143609, 118, '2014-01-15 00:28:25.000000', 'temperatura', 539.0000, 'ºC'),
	(143610, 118, '2014-01-15 00:28:26.000000', 'temperatura', 44.0000, 'ºC'),
	(143611, 118, '2014-01-15 00:28:27.000000', 'temperatura', 1004.0000, 'ºC'),
	(143612, 118, '2014-01-15 00:28:28.000000', 'temperatura', 89.0000, 'ºC'),
	(143613, 118, '2014-01-15 00:28:29.000000', 'temperatura', 1032.0000, 'ºC'),
	(143614, 118, '2014-01-15 00:28:30.000000', 'temperatura', 96.0000, 'ºC'),
	(143615, 118, '2014-01-15 00:28:31.000000', 'temperatura', 985.0000, 'ºC'),
	(143616, 118, '2014-01-15 00:28:32.000000', 'temperatura', 1036.0000, 'ºC'),
	(143617, 118, '2014-01-15 00:28:33.000000', 'temperatura', 1024.0000, 'ºC'),
	(143618, 118, '2014-01-15 00:28:34.000000', 'temperatura', 812.0000, 'ºC'),
	(143619, 118, '2014-01-15 00:28:35.000000', 'temperatura', 992.0000, 'ºC'),
	(143620, 118, '2014-01-15 00:28:36.000000', 'temperatura', 121.0000, 'ºC'),
	(143621, 118, '2014-01-15 00:28:37.000000', 'temperatura', 30.0000, 'ºC'),
	(143622, 118, '2014-01-15 00:28:38.000000', 'temperatura', 990.0000, 'ºC'),
	(143623, 118, '2014-01-15 00:28:39.000000', 'temperatura', 58.0000, 'ºC'),
	(143624, 118, '2014-01-15 00:28:40.000000', 'temperatura', 923.0000, 'ºC'),
	(143625, 118, '2014-01-15 00:28:41.000000', 'temperatura', 838.0000, 'ºC'),
	(143626, 118, '2014-01-15 00:28:42.000000', 'temperatura', 225.0000, 'ºC'),
	(143627, 118, '2014-01-15 00:28:43.000000', 'temperatura', 1011.0000, 'ºC'),
	(143628, 118, '2014-01-15 00:28:44.000000', 'temperatura', 781.0000, 'ºC'),
	(143629, 118, '2014-01-15 00:28:45.000000', 'temperatura', 872.0000, 'ºC'),
	(143630, 118, '2014-01-15 00:28:46.000000', 'temperatura', 817.0000, 'ºC'),
	(143631, 118, '2014-01-15 00:28:47.000000', 'temperatura', 268.0000, 'ºC'),
	(143632, 118, '2014-01-15 00:28:48.000000', 'temperatura', 89.0000, 'ºC'),
	(143633, 118, '2014-01-15 00:28:49.000000', 'temperatura', 843.0000, 'ºC'),
	(143634, 118, '2014-01-15 00:28:50.000000', 'temperatura', 348.0000, 'ºC'),
	(143635, 118, '2014-01-15 00:28:51.000000', 'temperatura', 411.0000, 'ºC'),
	(143636, 118, '2014-01-15 00:28:52.000000', 'temperatura', 1013.0000, 'ºC'),
	(143637, 118, '2014-01-15 00:28:53.000000', 'temperatura', 231.0000, 'ºC'),
	(143638, 118, '2014-01-15 00:28:54.000000', 'temperatura', 515.0000, 'ºC'),
	(143639, 118, '2014-01-15 00:28:55.000000', 'temperatura', 684.0000, 'ºC'),
	(143640, 118, '2014-01-15 00:28:56.000000', 'temperatura', 674.0000, 'ºC'),
	(143641, 118, '2014-01-15 00:28:57.000000', 'temperatura', 119.0000, 'ºC'),
	(143642, 118, '2014-01-15 00:28:58.000000', 'temperatura', 973.0000, 'ºC'),
	(143643, 118, '2014-01-15 00:28:59.000000', 'temperatura', 910.0000, 'ºC'),
	(143644, 118, '2014-01-15 00:29:00.000000', 'temperatura', 432.0000, 'ºC'),
	(143645, 118, '2014-01-15 00:29:01.000000', 'temperatura', 629.0000, 'ºC'),
	(143646, 118, '2014-01-15 00:29:02.000000', 'temperatura', 648.0000, 'ºC'),
	(143647, 118, '2014-01-15 00:29:03.000000', 'temperatura', 157.0000, 'ºC'),
	(143648, 118, '2014-01-15 00:29:04.000000', 'temperatura', 40.0000, 'ºC'),
	(143649, 118, '2014-01-15 00:29:05.000000', 'temperatura', 929.0000, 'ºC'),
	(143650, 118, '2014-01-15 00:29:06.000000', 'temperatura', 924.0000, 'ºC'),
	(143651, 118, '2014-01-15 00:29:07.000000', 'temperatura', 636.0000, 'ºC'),
	(143652, 118, '2014-01-15 00:29:08.000000', 'temperatura', 407.0000, 'ºC'),
	(143653, 118, '2014-01-15 00:29:09.000000', 'temperatura', 129.0000, 'ºC'),
	(143654, 118, '2014-01-15 00:29:10.000000', 'temperatura', 622.0000, 'ºC'),
	(143655, 118, '2014-01-15 00:29:11.000000', 'temperatura', 325.0000, 'ºC'),
	(143656, 118, '2014-01-15 00:29:12.000000', 'temperatura', 960.0000, 'ºC'),
	(143657, 118, '2014-01-15 00:29:13.000000', 'temperatura', 224.0000, 'ºC'),
	(143658, 118, '2014-01-15 00:29:14.000000', 'temperatura', 641.0000, 'ºC'),
	(143659, 118, '2014-01-15 00:29:15.000000', 'temperatura', 133.0000, 'ºC'),
	(143660, 118, '2014-01-15 00:29:16.000000', 'temperatura', 1142.0000, 'ºC'),
	(143661, 118, '2014-01-15 00:29:17.000000', 'temperatura', 512.0000, 'ºC'),
	(143662, 118, '2014-01-15 00:29:18.000000', 'temperatura', 335.0000, 'ºC'),
	(143663, 118, '2014-01-15 00:29:19.000000', 'temperatura', 138.0000, 'ºC'),
	(143664, 118, '2014-01-15 00:29:20.000000', 'temperatura', 885.0000, 'ºC'),
	(143665, 118, '2014-01-15 00:29:21.000000', 'temperatura', 414.0000, 'ºC'),
	(143666, 118, '2014-01-15 00:29:22.000000', 'temperatura', 614.0000, 'ºC'),
	(143667, 118, '2014-01-15 00:29:23.000000', 'temperatura', 630.0000, 'ºC'),
	(143668, 118, '2014-01-15 00:29:24.000000', 'temperatura', 107.0000, 'ºC'),
	(143669, 118, '2014-01-15 00:29:25.000000', 'temperatura', 1044.0000, 'ºC'),
	(143670, 118, '2014-01-15 00:29:26.000000', 'temperatura', 102.0000, 'ºC'),
	(143671, 118, '2014-01-15 00:29:27.000000', 'temperatura', 977.0000, 'ºC'),
	(143672, 118, '2014-01-15 00:29:28.000000', 'temperatura', 979.0000, 'ºC'),
	(143673, 118, '2014-01-15 00:29:29.000000', 'temperatura', 765.0000, 'ºC'),
	(143674, 118, '2014-01-15 00:29:30.000000', 'temperatura', 889.0000, 'ºC'),
	(143675, 118, '2014-01-15 00:29:31.000000', 'temperatura', 949.0000, 'ºC'),
	(143676, 118, '2014-01-15 00:29:32.000000', 'temperatura', 879.0000, 'ºC'),
	(143677, 118, '2014-01-15 00:29:33.000000', 'temperatura', 349.0000, 'ºC'),
	(143678, 118, '2014-01-15 00:29:34.000000', 'temperatura', 310.0000, 'ºC'),
	(143679, 118, '2014-01-15 00:29:35.000000', 'temperatura', 501.0000, 'ºC'),
	(143680, 118, '2014-01-15 00:29:36.000000', 'temperatura', 377.0000, 'ºC'),
	(143681, 118, '2014-01-15 00:29:37.000000', 'temperatura', 384.0000, 'ºC'),
	(143682, 118, '2014-01-15 00:29:38.000000', 'temperatura', 787.0000, 'ºC'),
	(143683, 118, '2014-01-15 00:29:39.000000', 'temperatura', 384.0000, 'ºC'),
	(143684, 118, '2014-01-15 00:29:40.000000', 'temperatura', 761.0000, 'ºC'),
	(143685, 118, '2014-01-15 00:29:41.000000', 'temperatura', 254.0000, 'ºC'),
	(143686, 118, '2014-01-15 00:29:42.000000', 'temperatura', 186.0000, 'ºC'),
	(143687, 118, '2014-01-15 00:29:43.000000', 'temperatura', 168.0000, 'ºC'),
	(143688, 118, '2014-01-15 00:29:44.000000', 'temperatura', 281.0000, 'ºC'),
	(143689, 118, '2014-01-15 00:29:45.000000', 'temperatura', 904.0000, 'ºC'),
	(143690, 118, '2014-01-15 00:29:46.000000', 'temperatura', 77.0000, 'ºC'),
	(143691, 118, '2014-01-15 00:29:47.000000', 'temperatura', 73.0000, 'ºC'),
	(143692, 118, '2014-01-15 00:29:48.000000', 'temperatura', 133.0000, 'ºC'),
	(143693, 118, '2014-01-15 00:29:49.000000', 'temperatura', 448.0000, 'ºC'),
	(143694, 118, '2014-01-15 00:29:50.000000', 'temperatura', 643.0000, 'ºC'),
	(143695, 118, '2014-01-15 00:29:51.000000', 'temperatura', 670.0000, 'ºC'),
	(143696, 118, '2014-01-15 00:29:52.000000', 'temperatura', 224.0000, 'ºC'),
	(143697, 118, '2014-01-15 00:29:53.000000', 'temperatura', 307.0000, 'ºC'),
	(143698, 118, '2014-01-15 00:29:54.000000', 'temperatura', 865.0000, 'ºC'),
	(143699, 118, '2014-01-15 00:29:55.000000', 'temperatura', 1007.0000, 'ºC'),
	(143700, 118, '2014-01-15 00:29:56.000000', 'temperatura', 37.0000, 'ºC'),
	(143701, 118, '2014-01-15 00:29:57.000000', 'temperatura', 764.0000, 'ºC'),
	(143702, 118, '2014-01-15 00:29:58.000000', 'temperatura', 110.0000, 'ºC'),
	(143703, 118, '2014-01-15 00:29:59.000000', 'temperatura', 659.0000, 'ºC'),
	(143704, 118, '2014-01-15 00:30:00.000000', 'temperatura', 564.0000, 'ºC'),
	(143705, 118, '2014-01-15 00:30:01.000000', 'temperatura', 845.0000, 'ºC'),
	(143706, 118, '2014-01-15 00:30:02.000000', 'temperatura', 131.0000, 'ºC'),
	(143707, 118, '2014-01-15 00:30:03.000000', 'temperatura', 524.0000, 'ºC'),
	(143708, 118, '2014-01-15 00:30:04.000000', 'temperatura', 1026.0000, 'ºC'),
	(143709, 118, '2014-01-15 00:30:05.000000', 'temperatura', 1160.0000, 'ºC'),
	(143710, 118, '2014-01-15 00:30:06.000000', 'temperatura', 320.0000, 'ºC'),
	(143711, 118, '2014-01-15 00:30:07.000000', 'temperatura', 523.0000, 'ºC'),
	(143712, 118, '2014-01-15 00:30:08.000000', 'temperatura', 453.0000, 'ºC'),
	(143713, 118, '2014-01-15 00:30:09.000000', 'temperatura', 698.0000, 'ºC'),
	(143714, 118, '2014-01-15 00:30:10.000000', 'temperatura', 930.0000, 'ºC'),
	(143715, 118, '2014-01-15 00:30:11.000000', 'temperatura', 157.0000, 'ºC'),
	(143716, 118, '2014-01-15 00:30:12.000000', 'temperatura', 397.0000, 'ºC'),
	(143717, 118, '2014-01-15 00:30:13.000000', 'temperatura', 314.0000, 'ºC'),
	(143718, 118, '2014-01-15 00:30:14.000000', 'temperatura', 381.0000, 'ºC'),
	(143719, 118, '2014-01-15 00:30:15.000000', 'temperatura', 961.0000, 'ºC'),
	(143720, 118, '2014-01-15 00:30:16.000000', 'temperatura', 62.0000, 'ºC'),
	(143721, 118, '2014-01-15 00:30:17.000000', 'temperatura', 1027.0000, 'ºC'),
	(143722, 118, '2014-01-15 00:30:18.000000', 'temperatura', 151.0000, 'ºC'),
	(143723, 118, '2014-01-15 00:30:19.000000', 'temperatura', 74.0000, 'ºC'),
	(143724, 118, '2014-01-15 00:30:20.000000', 'temperatura', 1116.0000, 'ºC'),
	(143725, 118, '2014-01-15 00:30:21.000000', 'temperatura', 559.0000, 'ºC'),
	(143726, 118, '2014-01-15 00:30:22.000000', 'temperatura', 650.0000, 'ºC'),
	(143727, 118, '2014-01-15 00:30:23.000000', 'temperatura', 371.0000, 'ºC'),
	(143728, 118, '2014-01-15 00:30:24.000000', 'temperatura', 1105.0000, 'ºC'),
	(143729, 118, '2014-01-15 00:30:25.000000', 'temperatura', 812.0000, 'ºC'),
	(143730, 118, '2014-01-15 00:30:26.000000', 'temperatura', 746.0000, 'ºC'),
	(143731, 118, '2014-01-15 00:30:27.000000', 'temperatura', 96.0000, 'ºC'),
	(143732, 118, '2014-01-15 00:30:28.000000', 'temperatura', 643.0000, 'ºC'),
	(143733, 118, '2014-01-15 00:30:29.000000', 'temperatura', 527.0000, 'ºC'),
	(143734, 118, '2014-01-15 00:30:30.000000', 'temperatura', 705.0000, 'ºC'),
	(143735, 118, '2014-01-15 00:30:31.000000', 'temperatura', 746.0000, 'ºC'),
	(143736, 118, '2014-01-15 00:30:32.000000', 'temperatura', 415.0000, 'ºC'),
	(143737, 118, '2014-01-15 00:30:33.000000', 'temperatura', 1038.0000, 'ºC'),
	(143738, 118, '2014-01-15 00:30:34.000000', 'temperatura', 345.0000, 'ºC'),
	(143739, 118, '2014-01-15 00:30:35.000000', 'temperatura', 1013.0000, 'ºC'),
	(143740, 118, '2014-01-15 00:30:36.000000', 'temperatura', 429.0000, 'ºC'),
	(143741, 118, '2014-01-15 00:30:37.000000', 'temperatura', 308.0000, 'ºC'),
	(143742, 118, '2014-01-15 00:30:38.000000', 'temperatura', 252.0000, 'ºC'),
	(143743, 118, '2014-01-15 00:30:39.000000', 'temperatura', 336.0000, 'ºC'),
	(143744, 118, '2014-01-15 00:30:40.000000', 'temperatura', 926.0000, 'ºC'),
	(143745, 118, '2014-01-15 00:30:41.000000', 'temperatura', 22.0000, 'ºC'),
	(143746, 118, '2014-01-15 00:30:42.000000', 'temperatura', 931.0000, 'ºC'),
	(143747, 118, '2014-01-15 00:30:43.000000', 'temperatura', 990.0000, 'ºC'),
	(143748, 118, '2014-01-15 00:30:44.000000', 'temperatura', 958.0000, 'ºC'),
	(143749, 118, '2014-01-15 00:30:45.000000', 'temperatura', 619.0000, 'ºC'),
	(143750, 118, '2014-01-15 00:30:46.000000', 'temperatura', 222.0000, 'ºC'),
	(143751, 118, '2014-01-15 00:30:47.000000', 'temperatura', 454.0000, 'ºC'),
	(143752, 118, '2014-01-15 00:30:48.000000', 'temperatura', 405.0000, 'ºC'),
	(143753, 118, '2014-01-15 00:30:49.000000', 'temperatura', 661.0000, 'ºC'),
	(143754, 118, '2014-01-15 00:30:50.000000', 'temperatura', 892.0000, 'ºC'),
	(143755, 118, '2014-01-15 00:30:51.000000', 'temperatura', 78.0000, 'ºC'),
	(143756, 118, '2014-01-15 00:30:52.000000', 'temperatura', 112.0000, 'ºC'),
	(143757, 118, '2014-01-15 00:30:53.000000', 'temperatura', 328.0000, 'ºC'),
	(143758, 118, '2014-01-15 00:30:54.000000', 'temperatura', 105.0000, 'ºC'),
	(143759, 118, '2014-01-15 00:30:55.000000', 'temperatura', 740.0000, 'ºC'),
	(143760, 118, '2014-01-15 00:30:56.000000', 'temperatura', 985.0000, 'ºC'),
	(143761, 118, '2014-01-15 00:30:57.000000', 'temperatura', 308.0000, 'ºC'),
	(143762, 118, '2014-01-15 00:30:58.000000', 'temperatura', 985.0000, 'ºC'),
	(143763, 118, '2014-01-15 00:30:59.000000', 'temperatura', 401.0000, 'ºC'),
	(143764, 118, '2014-01-15 00:31:00.000000', 'temperatura', 250.0000, 'ºC'),
	(143765, 118, '2014-01-15 00:31:01.000000', 'temperatura', 49.0000, 'ºC'),
	(143766, 118, '2014-01-15 00:31:02.000000', 'temperatura', 695.0000, 'ºC'),
	(143767, 118, '2014-01-15 00:31:03.000000', 'temperatura', 928.0000, 'ºC'),
	(143768, 118, '2014-01-15 00:31:04.000000', 'temperatura', 158.0000, 'ºC'),
	(143769, 118, '2014-01-15 00:31:05.000000', 'temperatura', 404.0000, 'ºC'),
	(143770, 118, '2014-01-15 00:31:06.000000', 'temperatura', 348.0000, 'ºC'),
	(143771, 118, '2014-01-15 00:31:07.000000', 'temperatura', 529.0000, 'ºC'),
	(143772, 118, '2014-01-15 00:31:08.000000', 'temperatura', 400.0000, 'ºC'),
	(143773, 118, '2014-01-15 00:31:09.000000', 'temperatura', 413.0000, 'ºC'),
	(143774, 118, '2014-01-15 00:31:10.000000', 'temperatura', 866.0000, 'ºC'),
	(143775, 118, '2014-01-15 00:31:11.000000', 'temperatura', 691.0000, 'ºC'),
	(143776, 118, '2014-01-15 00:31:12.000000', 'temperatura', 856.0000, 'ºC'),
	(143777, 118, '2014-01-15 00:31:13.000000', 'temperatura', 1009.0000, 'ºC'),
	(143778, 118, '2014-01-15 00:31:14.000000', 'temperatura', 77.0000, 'ºC'),
	(143779, 118, '2014-01-15 00:31:15.000000', 'temperatura', 957.0000, 'ºC'),
	(143780, 118, '2014-01-15 00:31:16.000000', 'temperatura', 957.0000, 'ºC'),
	(143781, 118, '2014-01-15 00:31:17.000000', 'temperatura', 716.0000, 'ºC'),
	(143782, 118, '2014-01-15 00:31:18.000000', 'temperatura', 707.0000, 'ºC'),
	(143783, 118, '2014-01-15 00:31:19.000000', 'temperatura', 186.0000, 'ºC'),
	(143784, 118, '2014-01-15 00:31:20.000000', 'temperatura', 11.0000, 'ºC'),
	(143785, 118, '2014-01-15 00:31:21.000000', 'temperatura', 697.0000, 'ºC'),
	(143786, 118, '2014-01-15 00:31:22.000000', 'temperatura', 1053.0000, 'ºC'),
	(143787, 118, '2014-01-15 00:31:23.000000', 'temperatura', 776.0000, 'ºC'),
	(143788, 118, '2014-01-15 00:31:24.000000', 'temperatura', 722.0000, 'ºC'),
	(143789, 118, '2014-01-15 00:31:25.000000', 'temperatura', 82.0000, 'ºC'),
	(143790, 118, '2014-01-15 00:31:26.000000', 'temperatura', 644.0000, 'ºC'),
	(143791, 118, '2014-01-15 00:31:27.000000', 'temperatura', 573.0000, 'ºC'),
	(143792, 118, '2014-01-15 00:31:28.000000', 'temperatura', 933.0000, 'ºC'),
	(143793, 118, '2014-01-15 00:31:29.000000', 'temperatura', 548.0000, 'ºC'),
	(143794, 118, '2014-01-15 00:31:30.000000', 'temperatura', 1142.0000, 'ºC'),
	(143795, 118, '2014-01-15 00:31:31.000000', 'temperatura', 466.0000, 'ºC'),
	(143796, 118, '2014-01-15 00:31:32.000000', 'temperatura', 107.0000, 'ºC'),
	(143797, 118, '2014-01-15 00:31:33.000000', 'temperatura', 334.0000, 'ºC'),
	(143798, 118, '2014-01-15 00:31:34.000000', 'temperatura', 150.0000, 'ºC'),
	(143799, 118, '2014-01-15 00:31:35.000000', 'temperatura', 947.0000, 'ºC'),
	(143800, 118, '2014-01-15 00:31:36.000000', 'temperatura', 687.0000, 'ºC'),
	(143801, 118, '2014-01-15 00:31:37.000000', 'temperatura', 595.0000, 'ºC'),
	(143802, 118, '2014-01-15 00:31:38.000000', 'temperatura', 913.0000, 'ºC'),
	(143803, 118, '2014-01-15 00:31:39.000000', 'temperatura', 383.0000, 'ºC'),
	(143804, 118, '2014-01-15 00:31:40.000000', 'temperatura', 377.0000, 'ºC'),
	(143805, 118, '2014-01-15 00:31:41.000000', 'temperatura', 734.0000, 'ºC'),
	(143806, 118, '2014-01-15 00:31:42.000000', 'temperatura', 139.0000, 'ºC'),
	(143807, 118, '2014-01-15 00:31:43.000000', 'temperatura', 894.0000, 'ºC'),
	(143808, 118, '2014-01-15 00:31:44.000000', 'temperatura', 455.0000, 'ºC'),
	(143809, 118, '2014-01-15 00:31:45.000000', 'temperatura', 792.0000, 'ºC'),
	(143810, 118, '2014-01-15 00:31:46.000000', 'temperatura', 196.0000, 'ºC'),
	(143811, 118, '2014-01-15 00:31:47.000000', 'temperatura', 1004.0000, 'ºC'),
	(143812, 118, '2014-01-15 00:31:48.000000', 'temperatura', 834.0000, 'ºC'),
	(143813, 118, '2014-01-15 00:31:49.000000', 'temperatura', 1156.0000, 'ºC'),
	(143814, 118, '2014-01-15 00:31:50.000000', 'temperatura', 880.0000, 'ºC'),
	(143815, 118, '2014-01-15 00:31:51.000000', 'temperatura', 931.0000, 'ºC'),
	(143816, 118, '2014-01-15 00:31:52.000000', 'temperatura', 816.0000, 'ºC'),
	(143817, 118, '2014-01-15 00:31:53.000000', 'temperatura', 87.0000, 'ºC'),
	(143818, 118, '2014-01-15 00:31:54.000000', 'temperatura', 387.0000, 'ºC'),
	(143819, 118, '2014-01-15 00:31:55.000000', 'temperatura', 477.0000, 'ºC'),
	(143820, 118, '2014-01-15 00:31:56.000000', 'temperatura', 21.0000, 'ºC'),
	(143821, 118, '2014-01-15 00:31:57.000000', 'temperatura', 1077.0000, 'ºC'),
	(143822, 118, '2014-01-15 00:31:58.000000', 'temperatura', 524.0000, 'ºC'),
	(143823, 118, '2014-01-15 00:31:59.000000', 'temperatura', 586.0000, 'ºC'),
	(143824, 118, '2014-01-15 00:32:00.000000', 'temperatura', 161.0000, 'ºC'),
	(143825, 118, '2014-01-15 00:32:01.000000', 'temperatura', 247.0000, 'ºC'),
	(143826, 118, '2014-01-15 00:32:02.000000', 'temperatura', 750.0000, 'ºC'),
	(143827, 118, '2014-01-15 00:32:03.000000', 'temperatura', 613.0000, 'ºC'),
	(143828, 118, '2014-01-15 00:32:04.000000', 'temperatura', 814.0000, 'ºC'),
	(143829, 118, '2014-01-15 00:32:05.000000', 'temperatura', 1031.0000, 'ºC'),
	(143830, 118, '2014-01-15 00:32:06.000000', 'temperatura', 315.0000, 'ºC'),
	(143831, 118, '2014-01-15 00:32:07.000000', 'temperatura', 882.0000, 'ºC'),
	(143832, 118, '2014-01-15 00:32:08.000000', 'temperatura', 1066.0000, 'ºC'),
	(143833, 118, '2014-01-15 00:32:09.000000', 'temperatura', 283.0000, 'ºC'),
	(143834, 118, '2014-01-15 00:32:10.000000', 'temperatura', 616.0000, 'ºC'),
	(143835, 118, '2014-01-15 00:32:11.000000', 'temperatura', 1035.0000, 'ºC'),
	(143836, 118, '2014-01-15 00:32:12.000000', 'temperatura', 925.0000, 'ºC'),
	(143837, 118, '2014-01-15 00:32:13.000000', 'temperatura', 322.0000, 'ºC'),
	(143838, 118, '2014-01-15 00:32:14.000000', 'temperatura', 35.0000, 'ºC'),
	(143839, 118, '2014-01-15 00:32:15.000000', 'temperatura', 408.0000, 'ºC'),
	(143840, 118, '2014-01-15 00:32:16.000000', 'temperatura', 736.0000, 'ºC'),
	(143841, 118, '2014-01-15 00:32:17.000000', 'temperatura', 58.0000, 'ºC'),
	(143842, 118, '2014-01-15 00:32:18.000000', 'temperatura', 480.0000, 'ºC'),
	(143843, 118, '2014-01-15 00:32:19.000000', 'temperatura', 1028.0000, 'ºC'),
	(143844, 118, '2014-01-15 00:32:20.000000', 'temperatura', 102.0000, 'ºC'),
	(143845, 118, '2014-01-15 00:32:21.000000', 'temperatura', 1025.0000, 'ºC'),
	(143846, 118, '2014-01-15 00:32:22.000000', 'temperatura', 21.0000, 'ºC'),
	(143847, 118, '2014-01-15 00:32:23.000000', 'temperatura', 628.0000, 'ºC'),
	(143848, 118, '2014-01-15 00:32:24.000000', 'temperatura', 677.0000, 'ºC'),
	(143849, 118, '2014-01-15 00:32:25.000000', 'temperatura', 301.0000, 'ºC'),
	(143850, 118, '2014-01-15 00:32:26.000000', 'temperatura', 674.0000, 'ºC'),
	(143851, 118, '2014-01-15 00:32:27.000000', 'temperatura', 70.0000, 'ºC'),
	(143852, 118, '2014-01-15 00:32:28.000000', 'temperatura', 730.0000, 'ºC'),
	(143853, 118, '2014-01-15 00:32:29.000000', 'temperatura', 1037.0000, 'ºC'),
	(143854, 118, '2014-01-15 00:32:30.000000', 'temperatura', 597.0000, 'ºC'),
	(143855, 118, '2014-01-15 00:32:31.000000', 'temperatura', 1072.0000, 'ºC'),
	(143856, 118, '2014-01-15 00:32:32.000000', 'temperatura', 1172.0000, 'ºC'),
	(143857, 118, '2014-01-15 00:32:33.000000', 'temperatura', 244.0000, 'ºC'),
	(143858, 118, '2014-01-15 00:32:34.000000', 'temperatura', 102.0000, 'ºC'),
	(143859, 118, '2014-01-15 00:32:35.000000', 'temperatura', 982.0000, 'ºC'),
	(143860, 118, '2014-01-15 00:32:36.000000', 'temperatura', 1004.0000, 'ºC'),
	(143861, 118, '2014-01-15 00:32:37.000000', 'temperatura', 875.0000, 'ºC'),
	(143862, 118, '2014-01-15 00:32:38.000000', 'temperatura', 162.0000, 'ºC'),
	(143863, 118, '2014-01-15 00:32:39.000000', 'temperatura', 586.0000, 'ºC'),
	(143864, 118, '2014-01-15 00:32:40.000000', 'temperatura', 44.0000, 'ºC'),
	(143865, 118, '2014-01-15 00:32:41.000000', 'temperatura', 864.0000, 'ºC'),
	(143866, 118, '2014-01-15 00:32:42.000000', 'temperatura', 588.0000, 'ºC'),
	(143867, 118, '2014-01-15 00:32:43.000000', 'temperatura', 349.0000, 'ºC'),
	(143868, 118, '2014-01-15 00:32:44.000000', 'temperatura', 1180.0000, 'ºC'),
	(143869, 118, '2014-01-15 00:32:45.000000', 'temperatura', 56.0000, 'ºC'),
	(143870, 118, '2014-01-15 00:32:46.000000', 'temperatura', 338.0000, 'ºC'),
	(143871, 118, '2014-01-15 00:32:47.000000', 'temperatura', 322.0000, 'ºC'),
	(143872, 118, '2014-01-15 00:32:48.000000', 'temperatura', 597.0000, 'ºC'),
	(143873, 118, '2014-01-15 00:32:49.000000', 'temperatura', 818.0000, 'ºC'),
	(143874, 118, '2014-01-15 00:32:50.000000', 'temperatura', 1100.0000, 'ºC'),
	(143875, 118, '2014-01-15 00:32:51.000000', 'temperatura', 648.0000, 'ºC'),
	(143876, 118, '2014-01-15 00:32:52.000000', 'temperatura', 1141.0000, 'ºC'),
	(143877, 118, '2014-01-15 00:32:53.000000', 'temperatura', 160.0000, 'ºC'),
	(143878, 118, '2014-01-15 00:32:54.000000', 'temperatura', 978.0000, 'ºC'),
	(143879, 118, '2014-01-15 00:32:55.000000', 'temperatura', 809.0000, 'ºC'),
	(143880, 118, '2014-01-15 00:32:56.000000', 'temperatura', 1113.0000, 'ºC'),
	(143881, 118, '2014-01-15 00:32:57.000000', 'temperatura', 739.0000, 'ºC'),
	(143882, 118, '2014-01-15 00:32:58.000000', 'temperatura', 356.0000, 'ºC'),
	(143883, 118, '2014-01-15 00:32:59.000000', 'temperatura', 761.0000, 'ºC'),
	(143884, 118, '2014-01-15 00:33:00.000000', 'temperatura', 341.0000, 'ºC'),
	(143885, 118, '2014-01-15 00:33:01.000000', 'temperatura', 620.0000, 'ºC'),
	(143886, 118, '2014-01-15 00:33:02.000000', 'temperatura', 880.0000, 'ºC'),
	(143887, 118, '2014-01-15 00:33:03.000000', 'temperatura', 141.0000, 'ºC'),
	(143888, 118, '2014-01-15 00:33:04.000000', 'temperatura', 463.0000, 'ºC'),
	(143889, 118, '2014-01-15 00:33:05.000000', 'temperatura', 695.0000, 'ºC'),
	(143890, 118, '2014-01-15 00:33:06.000000', 'temperatura', 884.0000, 'ºC'),
	(143891, 118, '2014-01-15 00:33:07.000000', 'temperatura', 1137.0000, 'ºC'),
	(143892, 118, '2014-01-15 00:33:08.000000', 'temperatura', 632.0000, 'ºC'),
	(143893, 118, '2014-01-15 00:33:09.000000', 'temperatura', 950.0000, 'ºC'),
	(143894, 118, '2014-01-15 00:33:10.000000', 'temperatura', 456.0000, 'ºC'),
	(143895, 118, '2014-01-15 00:33:11.000000', 'temperatura', 628.0000, 'ºC'),
	(143896, 118, '2014-01-15 00:33:12.000000', 'temperatura', 575.0000, 'ºC'),
	(143897, 118, '2014-01-15 00:33:13.000000', 'temperatura', 989.0000, 'ºC'),
	(143898, 118, '2014-01-15 00:33:14.000000', 'temperatura', 821.0000, 'ºC'),
	(143899, 118, '2014-01-15 00:33:15.000000', 'temperatura', 1139.0000, 'ºC'),
	(143900, 118, '2014-01-15 00:33:16.000000', 'temperatura', 833.0000, 'ºC'),
	(143901, 118, '2014-01-15 00:33:17.000000', 'temperatura', 747.0000, 'ºC'),
	(143902, 118, '2014-01-15 00:33:18.000000', 'temperatura', 39.0000, 'ºC'),
	(143903, 118, '2014-01-15 00:33:19.000000', 'temperatura', 353.0000, 'ºC'),
	(143904, 118, '2014-01-15 00:33:20.000000', 'temperatura', 451.0000, 'ºC'),
	(143905, 118, '2014-01-15 00:33:21.000000', 'temperatura', 1194.0000, 'ºC'),
	(143906, 118, '2014-01-15 00:33:22.000000', 'temperatura', 1017.0000, 'ºC'),
	(143907, 118, '2014-01-15 00:33:23.000000', 'temperatura', 304.0000, 'ºC'),
	(143908, 118, '2014-01-15 00:33:24.000000', 'temperatura', 869.0000, 'ºC'),
	(143909, 118, '2014-01-15 00:33:25.000000', 'temperatura', 1036.0000, 'ºC'),
	(143910, 118, '2014-01-15 00:33:26.000000', 'temperatura', 170.0000, 'ºC'),
	(143911, 118, '2014-01-15 00:33:27.000000', 'temperatura', 146.0000, 'ºC'),
	(143912, 118, '2014-01-15 00:33:28.000000', 'temperatura', 218.0000, 'ºC'),
	(143913, 118, '2014-01-15 00:33:29.000000', 'temperatura', 654.0000, 'ºC'),
	(143914, 118, '2014-01-15 00:33:30.000000', 'temperatura', 215.0000, 'ºC'),
	(143915, 118, '2014-01-15 00:33:31.000000', 'temperatura', 316.0000, 'ºC'),
	(143916, 118, '2014-01-15 00:33:32.000000', 'temperatura', 933.0000, 'ºC'),
	(143917, 118, '2014-01-15 00:33:33.000000', 'temperatura', 119.0000, 'ºC'),
	(143918, 118, '2014-01-15 00:33:34.000000', 'temperatura', 195.0000, 'ºC'),
	(143919, 118, '2014-01-15 00:33:35.000000', 'temperatura', 619.0000, 'ºC'),
	(143920, 118, '2014-01-15 00:33:36.000000', 'temperatura', 109.0000, 'ºC'),
	(143921, 118, '2014-01-15 00:33:37.000000', 'temperatura', 1091.0000, 'ºC'),
	(143922, 118, '2014-01-15 00:33:38.000000', 'temperatura', 328.0000, 'ºC'),
	(143923, 118, '2014-01-15 00:33:39.000000', 'temperatura', 765.0000, 'ºC'),
	(143924, 118, '2014-01-15 00:33:40.000000', 'temperatura', 444.0000, 'ºC'),
	(143925, 118, '2014-01-15 00:33:41.000000', 'temperatura', 1126.0000, 'ºC'),
	(143926, 118, '2014-01-15 00:33:42.000000', 'temperatura', 699.0000, 'ºC'),
	(143927, 118, '2014-01-15 00:33:43.000000', 'temperatura', 115.0000, 'ºC'),
	(143928, 118, '2014-01-15 00:33:44.000000', 'temperatura', 879.0000, 'ºC'),
	(143929, 118, '2014-01-15 00:33:45.000000', 'temperatura', 451.0000, 'ºC'),
	(143930, 118, '2014-01-15 00:33:46.000000', 'temperatura', 818.0000, 'ºC'),
	(143931, 118, '2014-01-15 00:33:47.000000', 'temperatura', 336.0000, 'ºC'),
	(143932, 118, '2014-01-15 00:33:48.000000', 'temperatura', 426.0000, 'ºC'),
	(143933, 118, '2014-01-15 00:33:49.000000', 'temperatura', 1126.0000, 'ºC'),
	(143934, 118, '2014-01-15 00:33:50.000000', 'temperatura', 750.0000, 'ºC'),
	(143935, 118, '2014-01-15 00:33:51.000000', 'temperatura', 372.0000, 'ºC'),
	(143936, 118, '2014-01-15 00:33:52.000000', 'temperatura', 809.0000, 'ºC'),
	(143937, 118, '2014-01-15 00:33:53.000000', 'temperatura', 532.0000, 'ºC'),
	(143938, 118, '2014-01-15 00:33:54.000000', 'temperatura', 233.0000, 'ºC'),
	(143939, 118, '2014-01-15 00:33:55.000000', 'temperatura', 769.0000, 'ºC'),
	(143940, 118, '2014-01-15 00:33:56.000000', 'temperatura', 747.0000, 'ºC'),
	(143941, 118, '2014-01-15 00:33:57.000000', 'temperatura', 228.0000, 'ºC'),
	(143942, 118, '2014-01-15 00:33:58.000000', 'temperatura', 100.0000, 'ºC'),
	(143943, 118, '2014-01-15 00:33:59.000000', 'temperatura', 1017.0000, 'ºC'),
	(143944, 118, '2014-01-15 00:34:00.000000', 'temperatura', 1187.0000, 'ºC'),
	(143945, 118, '2014-01-15 00:34:01.000000', 'temperatura', 483.0000, 'ºC'),
	(143946, 118, '2014-01-15 00:34:02.000000', 'temperatura', 53.0000, 'ºC'),
	(143947, 118, '2014-01-15 00:34:03.000000', 'temperatura', 19.0000, 'ºC'),
	(143948, 118, '2014-01-15 00:34:04.000000', 'temperatura', 1137.0000, 'ºC'),
	(143949, 118, '2014-01-15 00:34:05.000000', 'temperatura', 828.0000, 'ºC'),
	(143950, 118, '2014-01-15 00:34:06.000000', 'temperatura', 730.0000, 'ºC'),
	(143951, 118, '2014-01-15 00:34:07.000000', 'temperatura', 1164.0000, 'ºC'),
	(143952, 118, '2014-01-15 00:34:08.000000', 'temperatura', 33.0000, 'ºC'),
	(143953, 118, '2014-01-15 00:34:09.000000', 'temperatura', 272.0000, 'ºC'),
	(143954, 118, '2014-01-15 00:34:10.000000', 'temperatura', 61.0000, 'ºC'),
	(143955, 118, '2014-01-15 00:34:11.000000', 'temperatura', 691.0000, 'ºC'),
	(143956, 118, '2014-01-15 00:34:12.000000', 'temperatura', 871.0000, 'ºC'),
	(143957, 118, '2014-01-15 00:34:13.000000', 'temperatura', 1084.0000, 'ºC'),
	(143958, 118, '2014-01-15 00:34:14.000000', 'temperatura', 406.0000, 'ºC'),
	(143959, 118, '2014-01-15 00:34:15.000000', 'temperatura', 1181.0000, 'ºC'),
	(143960, 118, '2014-01-15 00:34:16.000000', 'temperatura', 1085.0000, 'ºC'),
	(143961, 118, '2014-01-15 00:34:17.000000', 'temperatura', 683.0000, 'ºC'),
	(143962, 118, '2014-01-15 00:34:18.000000', 'temperatura', 159.0000, 'ºC'),
	(143963, 118, '2014-01-15 00:34:19.000000', 'temperatura', 1146.0000, 'ºC'),
	(143964, 118, '2014-01-15 00:34:20.000000', 'temperatura', 456.0000, 'ºC'),
	(143965, 118, '2014-01-15 00:34:21.000000', 'temperatura', 42.0000, 'ºC'),
	(143966, 118, '2014-01-15 00:34:22.000000', 'temperatura', 43.0000, 'ºC'),
	(143967, 118, '2014-01-15 00:34:23.000000', 'temperatura', 87.0000, 'ºC'),
	(143968, 118, '2014-01-15 00:34:24.000000', 'temperatura', 308.0000, 'ºC'),
	(143969, 118, '2014-01-15 00:34:25.000000', 'temperatura', 80.0000, 'ºC'),
	(143970, 118, '2014-01-15 00:34:26.000000', 'temperatura', 675.0000, 'ºC'),
	(143971, 118, '2014-01-15 00:34:27.000000', 'temperatura', 735.0000, 'ºC'),
	(143972, 118, '2014-01-15 00:34:28.000000', 'temperatura', 453.0000, 'ºC'),
	(143973, 118, '2014-01-15 00:34:29.000000', 'temperatura', 61.0000, 'ºC'),
	(143974, 118, '2014-01-15 00:34:30.000000', 'temperatura', 143.0000, 'ºC'),
	(143975, 118, '2014-01-15 00:34:31.000000', 'temperatura', 536.0000, 'ºC'),
	(143976, 118, '2014-01-15 00:34:32.000000', 'temperatura', 1049.0000, 'ºC'),
	(143977, 118, '2014-01-15 00:34:33.000000', 'temperatura', 40.0000, 'ºC'),
	(143978, 118, '2014-01-15 00:34:34.000000', 'temperatura', 651.0000, 'ºC'),
	(143979, 118, '2014-01-15 00:34:35.000000', 'temperatura', 736.0000, 'ºC'),
	(143980, 118, '2014-01-15 00:34:36.000000', 'temperatura', 528.0000, 'ºC'),
	(143981, 118, '2014-01-15 00:34:37.000000', 'temperatura', 434.0000, 'ºC'),
	(143982, 118, '2014-01-15 00:34:38.000000', 'temperatura', 584.0000, 'ºC'),
	(143983, 118, '2014-01-15 00:34:39.000000', 'temperatura', 420.0000, 'ºC'),
	(143984, 118, '2014-01-15 00:34:40.000000', 'temperatura', 346.0000, 'ºC'),
	(143985, 118, '2014-01-15 00:34:41.000000', 'temperatura', 474.0000, 'ºC'),
	(143986, 118, '2014-01-15 00:34:42.000000', 'temperatura', 132.0000, 'ºC'),
	(143987, 118, '2014-01-15 00:34:43.000000', 'temperatura', 436.0000, 'ºC'),
	(143988, 118, '2014-01-15 00:34:44.000000', 'temperatura', 586.0000, 'ºC'),
	(143989, 118, '2014-01-15 00:34:45.000000', 'temperatura', 424.0000, 'ºC'),
	(143990, 118, '2014-01-15 00:34:46.000000', 'temperatura', 361.0000, 'ºC'),
	(143991, 118, '2014-01-15 00:34:47.000000', 'temperatura', 533.0000, 'ºC'),
	(143992, 118, '2014-01-15 00:34:48.000000', 'temperatura', 382.0000, 'ºC'),
	(143993, 118, '2014-01-15 00:34:49.000000', 'temperatura', 310.0000, 'ºC'),
	(143994, 118, '2014-01-15 00:34:50.000000', 'temperatura', 407.0000, 'ºC'),
	(143995, 118, '2014-01-15 00:34:51.000000', 'temperatura', 1105.0000, 'ºC'),
	(143996, 118, '2014-01-15 00:34:52.000000', 'temperatura', 706.0000, 'ºC'),
	(143997, 118, '2014-01-15 00:34:53.000000', 'temperatura', 215.0000, 'ºC'),
	(143998, 118, '2014-01-15 00:34:54.000000', 'temperatura', 159.0000, 'ºC'),
	(143999, 118, '2014-01-15 00:34:55.000000', 'temperatura', 149.0000, 'ºC'),
	(144000, 118, '2014-01-15 00:34:56.000000', 'temperatura', 267.0000, 'ºC'),
	(144001, 118, '2014-01-15 00:34:57.000000', 'temperatura', 891.0000, 'ºC'),
	(144002, 118, '2014-01-15 00:34:58.000000', 'temperatura', 54.0000, 'ºC'),
	(144003, 118, '2014-01-15 00:34:59.000000', 'temperatura', 1198.0000, 'ºC'),
	(144004, 118, '2014-01-15 00:35:00.000000', 'temperatura', 1029.0000, 'ºC'),
	(144005, 118, '2014-01-15 00:35:01.000000', 'temperatura', 351.0000, 'ºC'),
	(144006, 118, '2014-01-15 00:35:02.000000', 'temperatura', 1070.0000, 'ºC'),
	(144007, 118, '2014-01-15 00:35:03.000000', 'temperatura', 695.0000, 'ºC'),
	(144008, 118, '2014-01-15 00:35:04.000000', 'temperatura', 265.0000, 'ºC'),
	(144009, 118, '2014-01-15 00:35:05.000000', 'temperatura', 443.0000, 'ºC'),
	(144010, 118, '2014-01-15 00:35:06.000000', 'temperatura', 218.0000, 'ºC'),
	(144011, 118, '2014-01-15 00:35:07.000000', 'temperatura', 964.0000, 'ºC'),
	(144012, 118, '2014-01-15 00:35:08.000000', 'temperatura', 564.0000, 'ºC'),
	(144013, 118, '2014-01-15 00:35:09.000000', 'temperatura', 1128.0000, 'ºC'),
	(144014, 118, '2014-01-15 00:35:10.000000', 'temperatura', 350.0000, 'ºC'),
	(144015, 118, '2014-01-15 00:35:11.000000', 'temperatura', 765.0000, 'ºC'),
	(144016, 118, '2014-01-15 00:35:12.000000', 'temperatura', 378.0000, 'ºC'),
	(144017, 118, '2014-01-15 00:35:13.000000', 'temperatura', 793.0000, 'ºC'),
	(144018, 118, '2014-01-15 00:35:14.000000', 'temperatura', 434.0000, 'ºC'),
	(144019, 118, '2014-01-15 00:35:15.000000', 'temperatura', 989.0000, 'ºC'),
	(144020, 118, '2014-01-15 00:35:16.000000', 'temperatura', 43.0000, 'ºC'),
	(144021, 118, '2014-01-15 00:35:17.000000', 'temperatura', 848.0000, 'ºC'),
	(144022, 118, '2014-01-15 00:35:18.000000', 'temperatura', 513.0000, 'ºC'),
	(144023, 118, '2014-01-15 00:35:19.000000', 'temperatura', 20.0000, 'ºC'),
	(144024, 118, '2014-01-15 00:35:20.000000', 'temperatura', 964.0000, 'ºC'),
	(144025, 118, '2014-01-15 00:35:21.000000', 'temperatura', 1159.0000, 'ºC'),
	(144026, 118, '2014-01-15 00:35:22.000000', 'temperatura', 503.0000, 'ºC'),
	(144027, 118, '2014-01-15 00:35:23.000000', 'temperatura', 240.0000, 'ºC'),
	(144028, 118, '2014-01-15 00:35:24.000000', 'temperatura', 891.0000, 'ºC'),
	(144029, 118, '2014-01-15 00:35:25.000000', 'temperatura', 135.0000, 'ºC'),
	(144030, 118, '2014-01-15 00:35:26.000000', 'temperatura', 401.0000, 'ºC'),
	(144031, 118, '2014-01-15 00:35:27.000000', 'temperatura', 404.0000, 'ºC'),
	(144032, 118, '2014-01-15 00:35:28.000000', 'temperatura', 815.0000, 'ºC'),
	(144033, 118, '2014-01-15 00:35:29.000000', 'temperatura', 464.0000, 'ºC'),
	(144034, 118, '2014-01-15 00:35:30.000000', 'temperatura', 1076.0000, 'ºC'),
	(144035, 118, '2014-01-15 00:35:31.000000', 'temperatura', 388.0000, 'ºC'),
	(144036, 118, '2014-01-15 00:35:32.000000', 'temperatura', 1113.0000, 'ºC'),
	(144037, 118, '2014-01-15 00:35:33.000000', 'temperatura', 802.0000, 'ºC'),
	(144038, 118, '2014-01-15 00:35:34.000000', 'temperatura', 672.0000, 'ºC'),
	(144039, 118, '2014-01-15 00:35:35.000000', 'temperatura', 955.0000, 'ºC'),
	(144040, 118, '2014-01-15 00:35:36.000000', 'temperatura', 360.0000, 'ºC'),
	(144041, 118, '2014-01-15 00:35:37.000000', 'temperatura', 134.0000, 'ºC'),
	(144042, 118, '2014-01-15 00:35:38.000000', 'temperatura', 793.0000, 'ºC'),
	(144043, 118, '2014-01-15 00:35:39.000000', 'temperatura', 1161.0000, 'ºC'),
	(144044, 118, '2014-01-15 00:35:40.000000', 'temperatura', 1025.0000, 'ºC'),
	(144045, 118, '2014-01-15 00:35:41.000000', 'temperatura', 445.0000, 'ºC'),
	(144046, 118, '2014-01-15 00:35:42.000000', 'temperatura', 351.0000, 'ºC'),
	(144047, 118, '2014-01-15 00:35:43.000000', 'temperatura', 419.0000, 'ºC'),
	(144048, 118, '2014-01-15 00:35:44.000000', 'temperatura', 1042.0000, 'ºC'),
	(144049, 118, '2014-01-15 00:35:45.000000', 'temperatura', 354.0000, 'ºC'),
	(144050, 118, '2014-01-15 00:35:46.000000', 'temperatura', 1043.0000, 'ºC'),
	(144051, 118, '2014-01-15 00:35:47.000000', 'temperatura', 554.0000, 'ºC'),
	(144052, 118, '2014-01-15 00:35:48.000000', 'temperatura', 844.0000, 'ºC'),
	(144053, 118, '2014-01-15 00:35:49.000000', 'temperatura', 157.0000, 'ºC'),
	(144054, 118, '2014-01-15 00:35:50.000000', 'temperatura', 655.0000, 'ºC'),
	(144055, 118, '2014-01-15 00:35:51.000000', 'temperatura', 401.0000, 'ºC'),
	(144056, 118, '2014-01-15 00:35:52.000000', 'temperatura', 44.0000, 'ºC'),
	(144057, 118, '2014-01-15 00:35:53.000000', 'temperatura', 215.0000, 'ºC'),
	(144058, 118, '2014-01-15 00:35:54.000000', 'temperatura', 946.0000, 'ºC'),
	(144059, 118, '2014-01-15 00:35:55.000000', 'temperatura', 484.0000, 'ºC'),
	(144060, 118, '2014-01-15 00:35:56.000000', 'temperatura', 782.0000, 'ºC'),
	(144061, 118, '2014-01-15 00:35:57.000000', 'temperatura', 58.0000, 'ºC'),
	(144062, 118, '2014-01-15 00:35:58.000000', 'temperatura', 345.0000, 'ºC'),
	(144063, 118, '2014-01-15 00:35:59.000000', 'temperatura', 351.0000, 'ºC'),
	(144064, 118, '2014-01-15 00:36:00.000000', 'temperatura', 719.0000, 'ºC'),
	(144065, 118, '2014-01-15 00:36:01.000000', 'temperatura', 146.0000, 'ºC'),
	(144066, 118, '2014-01-15 00:36:02.000000', 'temperatura', 970.0000, 'ºC'),
	(144067, 118, '2014-01-15 00:36:03.000000', 'temperatura', 815.0000, 'ºC'),
	(144068, 118, '2014-01-15 00:36:04.000000', 'temperatura', 1164.0000, 'ºC'),
	(144069, 118, '2014-01-15 00:36:05.000000', 'temperatura', 974.0000, 'ºC'),
	(144070, 118, '2014-01-15 00:36:06.000000', 'temperatura', 181.0000, 'ºC'),
	(144071, 118, '2014-01-15 00:36:07.000000', 'temperatura', 383.0000, 'ºC'),
	(144072, 118, '2014-01-15 00:36:08.000000', 'temperatura', 171.0000, 'ºC'),
	(144073, 118, '2014-01-15 00:36:09.000000', 'temperatura', 906.0000, 'ºC'),
	(144074, 118, '2014-01-15 00:36:10.000000', 'temperatura', 419.0000, 'ºC'),
	(144075, 118, '2014-01-15 00:36:11.000000', 'temperatura', 578.0000, 'ºC'),
	(144076, 118, '2014-01-15 00:36:12.000000', 'temperatura', 433.0000, 'ºC'),
	(144077, 118, '2014-01-15 00:36:13.000000', 'temperatura', 433.0000, 'ºC'),
	(144078, 118, '2014-01-15 00:36:14.000000', 'temperatura', 864.0000, 'ºC'),
	(144079, 118, '2014-01-15 00:36:15.000000', 'temperatura', 623.0000, 'ºC'),
	(144080, 118, '2014-01-15 00:36:16.000000', 'temperatura', 524.0000, 'ºC'),
	(144081, 118, '2014-01-15 00:36:17.000000', 'temperatura', 751.0000, 'ºC'),
	(144082, 118, '2014-01-15 00:36:18.000000', 'temperatura', 982.0000, 'ºC'),
	(144083, 118, '2014-01-15 00:36:19.000000', 'temperatura', 258.0000, 'ºC'),
	(144084, 118, '2014-01-15 00:36:20.000000', 'temperatura', 743.0000, 'ºC'),
	(144085, 118, '2014-01-15 00:36:21.000000', 'temperatura', 542.0000, 'ºC'),
	(144086, 118, '2014-01-15 00:36:22.000000', 'temperatura', 480.0000, 'ºC'),
	(144087, 118, '2014-01-15 00:36:23.000000', 'temperatura', 776.0000, 'ºC'),
	(144088, 118, '2014-01-15 00:36:24.000000', 'temperatura', 41.0000, 'ºC'),
	(144089, 118, '2014-01-15 00:36:25.000000', 'temperatura', 278.0000, 'ºC'),
	(144090, 118, '2014-01-15 00:36:26.000000', 'temperatura', 66.0000, 'ºC'),
	(144091, 118, '2014-01-15 00:36:27.000000', 'temperatura', 695.0000, 'ºC'),
	(144092, 118, '2014-01-15 00:36:28.000000', 'temperatura', 880.0000, 'ºC'),
	(144093, 118, '2014-01-15 00:36:29.000000', 'temperatura', 1115.0000, 'ºC'),
	(144094, 118, '2014-01-15 00:36:30.000000', 'temperatura', 533.0000, 'ºC'),
	(144095, 118, '2014-01-15 00:36:31.000000', 'temperatura', 524.0000, 'ºC'),
	(144096, 118, '2014-01-15 00:36:32.000000', 'temperatura', 1021.0000, 'ºC'),
	(144097, 118, '2014-01-15 00:36:33.000000', 'temperatura', 1132.0000, 'ºC'),
	(144098, 118, '2014-01-15 00:36:34.000000', 'temperatura', 196.0000, 'ºC'),
	(144099, 118, '2014-01-15 00:36:35.000000', 'temperatura', 1186.0000, 'ºC'),
	(144100, 118, '2014-01-15 00:36:36.000000', 'temperatura', 544.0000, 'ºC'),
	(144101, 118, '2014-01-15 00:36:37.000000', 'temperatura', 363.0000, 'ºC'),
	(144102, 118, '2014-01-15 00:36:38.000000', 'temperatura', 183.0000, 'ºC'),
	(144103, 118, '2014-01-15 00:36:39.000000', 'temperatura', 1028.0000, 'ºC'),
	(144104, 118, '2014-01-15 00:36:40.000000', 'temperatura', 991.0000, 'ºC'),
	(144105, 118, '2014-01-15 00:36:41.000000', 'temperatura', 671.0000, 'ºC'),
	(144106, 118, '2014-01-15 00:36:42.000000', 'temperatura', 383.0000, 'ºC'),
	(144107, 118, '2014-01-15 00:36:43.000000', 'temperatura', 1102.0000, 'ºC'),
	(144108, 118, '2014-01-15 00:36:44.000000', 'temperatura', 764.0000, 'ºC'),
	(144109, 118, '2014-01-15 00:36:45.000000', 'temperatura', 511.0000, 'ºC'),
	(144110, 118, '2014-01-15 00:36:46.000000', 'temperatura', 267.0000, 'ºC'),
	(144111, 118, '2014-01-15 00:36:47.000000', 'temperatura', 1000.0000, 'ºC'),
	(144112, 118, '2014-01-15 00:36:48.000000', 'temperatura', 601.0000, 'ºC'),
	(144113, 118, '2014-01-15 00:36:49.000000', 'temperatura', 4.0000, 'ºC'),
	(144114, 118, '2014-01-15 00:36:50.000000', 'temperatura', 617.0000, 'ºC'),
	(144115, 118, '2014-01-15 00:36:51.000000', 'temperatura', 676.0000, 'ºC'),
	(144116, 118, '2014-01-15 00:36:52.000000', 'temperatura', 329.0000, 'ºC'),
	(144117, 118, '2014-01-15 00:36:53.000000', 'temperatura', 817.0000, 'ºC'),
	(144118, 118, '2014-01-15 00:36:54.000000', 'temperatura', 699.0000, 'ºC'),
	(144119, 118, '2014-01-15 00:36:55.000000', 'temperatura', 1046.0000, 'ºC'),
	(144120, 118, '2014-01-15 00:36:56.000000', 'temperatura', 733.0000, 'ºC'),
	(144121, 118, '2014-01-15 00:36:57.000000', 'temperatura', 528.0000, 'ºC'),
	(144122, 118, '2014-01-15 00:36:58.000000', 'temperatura', 440.0000, 'ºC'),
	(144123, 118, '2014-01-15 00:36:59.000000', 'temperatura', 618.0000, 'ºC'),
	(144124, 118, '2014-01-15 00:37:00.000000', 'temperatura', 569.0000, 'ºC'),
	(144125, 118, '2014-01-15 00:37:01.000000', 'temperatura', 991.0000, 'ºC'),
	(144126, 118, '2014-01-15 00:37:02.000000', 'temperatura', 851.0000, 'ºC'),
	(144127, 118, '2014-01-15 00:37:03.000000', 'temperatura', 82.0000, 'ºC'),
	(144128, 118, '2014-01-15 00:37:04.000000', 'temperatura', 258.0000, 'ºC'),
	(144129, 118, '2014-01-15 00:37:05.000000', 'temperatura', 1043.0000, 'ºC'),
	(144130, 118, '2014-01-15 00:37:06.000000', 'temperatura', 841.0000, 'ºC'),
	(144131, 118, '2014-01-15 00:37:07.000000', 'temperatura', 1078.0000, 'ºC'),
	(144132, 118, '2014-01-15 00:37:08.000000', 'temperatura', 466.0000, 'ºC'),
	(144133, 118, '2014-01-15 00:37:09.000000', 'temperatura', 298.0000, 'ºC'),
	(144134, 118, '2014-01-15 00:37:10.000000', 'temperatura', 91.0000, 'ºC'),
	(144135, 118, '2014-01-15 00:37:11.000000', 'temperatura', 764.0000, 'ºC'),
	(144136, 118, '2014-01-15 00:37:12.000000', 'temperatura', 1145.0000, 'ºC'),
	(144137, 118, '2014-01-15 00:37:13.000000', 'temperatura', 1033.0000, 'ºC'),
	(144138, 118, '2014-01-15 00:37:14.000000', 'temperatura', 531.0000, 'ºC'),
	(144139, 118, '2014-01-15 00:37:15.000000', 'temperatura', 755.0000, 'ºC'),
	(144140, 118, '2014-01-15 00:37:16.000000', 'temperatura', 982.0000, 'ºC'),
	(144141, 118, '2014-01-15 00:37:17.000000', 'temperatura', 249.0000, 'ºC'),
	(144142, 118, '2014-01-15 00:37:18.000000', 'temperatura', 696.0000, 'ºC'),
	(144143, 118, '2014-01-15 00:37:19.000000', 'temperatura', 336.0000, 'ºC'),
	(144144, 118, '2014-01-15 00:37:20.000000', 'temperatura', 790.0000, 'ºC'),
	(144145, 118, '2014-01-15 00:37:21.000000', 'temperatura', 543.0000, 'ºC'),
	(144146, 118, '2014-01-15 00:37:22.000000', 'temperatura', 346.0000, 'ºC'),
	(144147, 118, '2014-01-15 00:37:23.000000', 'temperatura', 100.0000, 'ºC'),
	(144148, 118, '2014-01-15 00:37:24.000000', 'temperatura', 663.0000, 'ºC'),
	(144149, 118, '2014-01-15 00:37:25.000000', 'temperatura', 615.0000, 'ºC'),
	(144150, 118, '2014-01-15 00:37:26.000000', 'temperatura', 1087.0000, 'ºC'),
	(144151, 118, '2014-01-15 00:37:27.000000', 'temperatura', 1190.0000, 'ºC'),
	(144152, 118, '2014-01-15 00:37:28.000000', 'temperatura', 291.0000, 'ºC'),
	(144153, 118, '2014-01-15 00:37:29.000000', 'temperatura', 283.0000, 'ºC'),
	(144154, 118, '2014-01-15 00:37:30.000000', 'temperatura', 543.0000, 'ºC'),
	(144155, 118, '2014-01-15 00:37:31.000000', 'temperatura', 669.0000, 'ºC'),
	(144156, 118, '2014-01-15 00:37:32.000000', 'temperatura', 514.0000, 'ºC'),
	(144157, 118, '2014-01-15 00:37:33.000000', 'temperatura', 563.0000, 'ºC'),
	(144158, 118, '2014-01-15 00:37:34.000000', 'temperatura', 73.0000, 'ºC'),
	(144159, 118, '2014-01-15 00:37:35.000000', 'temperatura', 1079.0000, 'ºC'),
	(144160, 118, '2014-01-15 00:37:36.000000', 'temperatura', 376.0000, 'ºC'),
	(144161, 118, '2014-01-15 00:37:37.000000', 'temperatura', 1041.0000, 'ºC'),
	(144162, 118, '2014-01-15 00:37:38.000000', 'temperatura', 481.0000, 'ºC'),
	(144163, 118, '2014-01-15 00:37:39.000000', 'temperatura', 480.0000, 'ºC'),
	(144164, 118, '2014-01-15 00:37:40.000000', 'temperatura', 957.0000, 'ºC'),
	(144165, 118, '2014-01-15 00:37:41.000000', 'temperatura', 946.0000, 'ºC'),
	(144166, 118, '2014-01-15 00:37:42.000000', 'temperatura', 662.0000, 'ºC'),
	(144167, 118, '2014-01-15 00:37:43.000000', 'temperatura', 469.0000, 'ºC'),
	(144168, 118, '2014-01-15 00:37:44.000000', 'temperatura', 362.0000, 'ºC'),
	(144169, 118, '2014-01-15 00:37:45.000000', 'temperatura', 402.0000, 'ºC'),
	(144170, 118, '2014-01-15 00:37:46.000000', 'temperatura', 927.0000, 'ºC'),
	(144171, 118, '2014-01-15 00:37:47.000000', 'temperatura', 1027.0000, 'ºC'),
	(144172, 118, '2014-01-15 00:37:48.000000', 'temperatura', 1153.0000, 'ºC'),
	(144173, 118, '2014-01-15 00:37:49.000000', 'temperatura', 288.0000, 'ºC'),
	(144174, 118, '2014-01-15 00:37:50.000000', 'temperatura', 380.0000, 'ºC'),
	(144175, 118, '2014-01-15 00:37:51.000000', 'temperatura', 1038.0000, 'ºC'),
	(144176, 118, '2014-01-15 00:37:52.000000', 'temperatura', 451.0000, 'ºC'),
	(144177, 118, '2014-01-15 00:37:53.000000', 'temperatura', 341.0000, 'ºC'),
	(144178, 118, '2014-01-15 00:37:54.000000', 'temperatura', 352.0000, 'ºC'),
	(144179, 118, '2014-01-15 00:37:55.000000', 'temperatura', 738.0000, 'ºC'),
	(144180, 118, '2014-01-15 00:37:56.000000', 'temperatura', 234.0000, 'ºC'),
	(144181, 118, '2014-01-15 00:37:57.000000', 'temperatura', 156.0000, 'ºC'),
	(144182, 118, '2014-01-15 00:37:58.000000', 'temperatura', 80.0000, 'ºC'),
	(144183, 118, '2014-01-15 00:37:59.000000', 'temperatura', 1133.0000, 'ºC'),
	(144184, 118, '2014-01-15 00:38:00.000000', 'temperatura', 624.0000, 'ºC'),
	(144185, 118, '2014-01-15 00:38:01.000000', 'temperatura', 922.0000, 'ºC'),
	(144186, 118, '2014-01-15 00:38:02.000000', 'temperatura', 337.0000, 'ºC'),
	(144187, 118, '2014-01-15 00:38:03.000000', 'temperatura', 120.0000, 'ºC'),
	(144188, 118, '2014-01-15 00:38:04.000000', 'temperatura', 791.0000, 'ºC'),
	(144189, 118, '2014-01-15 00:38:05.000000', 'temperatura', 1194.0000, 'ºC'),
	(144190, 118, '2014-01-15 00:38:06.000000', 'temperatura', 1198.0000, 'ºC'),
	(144191, 118, '2014-01-15 00:38:07.000000', 'temperatura', 8.0000, 'ºC'),
	(144192, 118, '2014-01-15 00:38:08.000000', 'temperatura', 47.0000, 'ºC'),
	(144193, 118, '2014-01-15 00:38:09.000000', 'temperatura', 212.0000, 'ºC'),
	(144194, 118, '2014-01-15 00:38:10.000000', 'temperatura', 918.0000, 'ºC'),
	(144195, 118, '2014-01-15 00:38:11.000000', 'temperatura', 355.0000, 'ºC'),
	(144196, 118, '2014-01-15 00:38:12.000000', 'temperatura', 223.0000, 'ºC'),
	(144197, 118, '2014-01-15 00:38:13.000000', 'temperatura', 48.0000, 'ºC'),
	(144198, 118, '2014-01-15 00:38:14.000000', 'temperatura', 771.0000, 'ºC'),
	(144199, 118, '2014-01-15 00:38:15.000000', 'temperatura', 112.0000, 'ºC'),
	(144200, 118, '2014-01-15 00:38:16.000000', 'temperatura', 647.0000, 'ºC'),
	(144201, 118, '2014-01-15 00:38:17.000000', 'temperatura', 499.0000, 'ºC'),
	(144202, 118, '2014-01-15 00:38:18.000000', 'temperatura', 555.0000, 'ºC'),
	(144203, 118, '2014-01-15 00:38:19.000000', 'temperatura', 78.0000, 'ºC'),
	(144204, 118, '2014-01-15 00:38:20.000000', 'temperatura', 1124.0000, 'ºC'),
	(144205, 118, '2014-01-15 00:38:21.000000', 'temperatura', 589.0000, 'ºC'),
	(144206, 118, '2014-01-15 00:38:22.000000', 'temperatura', 771.0000, 'ºC'),
	(144207, 118, '2014-01-15 00:38:23.000000', 'temperatura', 891.0000, 'ºC'),
	(144208, 118, '2014-01-15 00:38:24.000000', 'temperatura', 943.0000, 'ºC'),
	(144209, 118, '2014-01-15 00:38:25.000000', 'temperatura', 841.0000, 'ºC'),
	(144210, 118, '2014-01-15 00:38:26.000000', 'temperatura', 177.0000, 'ºC'),
	(144211, 118, '2014-01-15 00:38:27.000000', 'temperatura', 764.0000, 'ºC'),
	(144212, 118, '2014-01-15 00:38:28.000000', 'temperatura', 888.0000, 'ºC'),
	(144213, 118, '2014-01-15 00:38:29.000000', 'temperatura', 948.0000, 'ºC'),
	(144214, 118, '2014-01-15 00:38:30.000000', 'temperatura', 877.0000, 'ºC'),
	(144215, 118, '2014-01-15 00:38:31.000000', 'temperatura', 343.0000, 'ºC'),
	(144216, 118, '2014-01-15 00:38:32.000000', 'temperatura', 283.0000, 'ºC'),
	(144217, 118, '2014-01-15 00:38:33.000000', 'temperatura', 386.0000, 'ºC'),
	(144218, 118, '2014-01-15 00:38:34.000000', 'temperatura', 1081.0000, 'ºC'),
	(144219, 118, '2014-01-15 00:38:35.000000', 'temperatura', 649.0000, 'ºC'),
	(144220, 118, '2014-01-15 00:38:36.000000', 'temperatura', 1.0000, 'ºC'),
	(144221, 118, '2014-01-15 00:38:37.000000', 'temperatura', 460.0000, 'ºC'),
	(144222, 118, '2014-01-15 00:38:38.000000', 'temperatura', 1098.0000, 'ºC'),
	(144223, 118, '2014-01-15 00:38:39.000000', 'temperatura', 508.0000, 'ºC'),
	(144224, 118, '2014-01-15 00:38:40.000000', 'temperatura', 449.0000, 'ºC'),
	(144225, 118, '2014-01-15 00:38:41.000000', 'temperatura', 722.0000, 'ºC'),
	(144226, 118, '2014-01-15 00:38:42.000000', 'temperatura', 1063.0000, 'ºC'),
	(144227, 118, '2014-01-15 00:38:43.000000', 'temperatura', 747.0000, 'ºC'),
	(144228, 118, '2014-01-15 00:38:44.000000', 'temperatura', 550.0000, 'ºC'),
	(144229, 118, '2014-01-15 00:38:45.000000', 'temperatura', 508.0000, 'ºC'),
	(144230, 118, '2014-01-15 00:38:46.000000', 'temperatura', 890.0000, 'ºC'),
	(144231, 118, '2014-01-15 00:38:47.000000', 'temperatura', 529.0000, 'ºC'),
	(144232, 118, '2014-01-15 00:38:48.000000', 'temperatura', 1174.0000, 'ºC'),
	(144233, 118, '2014-01-15 00:38:49.000000', 'temperatura', 683.0000, 'ºC'),
	(144234, 118, '2014-01-15 00:38:50.000000', 'temperatura', 1093.0000, 'ºC'),
	(144235, 118, '2014-01-15 00:38:51.000000', 'temperatura', 1015.0000, 'ºC'),
	(144236, 118, '2014-01-15 00:38:52.000000', 'temperatura', 598.0000, 'ºC'),
	(144237, 118, '2014-01-15 00:38:53.000000', 'temperatura', 1146.0000, 'ºC'),
	(144238, 118, '2014-01-15 00:38:54.000000', 'temperatura', 334.0000, 'ºC'),
	(144239, 118, '2014-01-15 00:38:55.000000', 'temperatura', 635.0000, 'ºC'),
	(144240, 118, '2014-01-15 00:38:56.000000', 'temperatura', 971.0000, 'ºC'),
	(144241, 118, '2014-01-15 00:38:57.000000', 'temperatura', 550.0000, 'ºC'),
	(144242, 118, '2014-01-15 00:38:58.000000', 'temperatura', 1040.0000, 'ºC'),
	(144243, 118, '2014-01-15 00:38:59.000000', 'temperatura', 1150.0000, 'ºC'),
	(144244, 118, '2014-01-15 00:39:00.000000', 'temperatura', 229.0000, 'ºC'),
	(144245, 118, '2014-01-15 00:39:01.000000', 'temperatura', 96.0000, 'ºC'),
	(144246, 118, '2014-01-15 00:39:02.000000', 'temperatura', 994.0000, 'ºC'),
	(144247, 118, '2014-01-15 00:39:03.000000', 'temperatura', 1082.0000, 'ºC'),
	(144248, 118, '2014-01-15 00:39:04.000000', 'temperatura', 27.0000, 'ºC'),
	(144249, 118, '2014-01-15 00:39:05.000000', 'temperatura', 489.0000, 'ºC'),
	(144250, 118, '2014-01-15 00:39:06.000000', 'temperatura', 1168.0000, 'ºC'),
	(144251, 118, '2014-01-15 00:39:07.000000', 'temperatura', 771.0000, 'ºC'),
	(144252, 118, '2014-01-15 00:39:08.000000', 'temperatura', 351.0000, 'ºC'),
	(144253, 118, '2014-01-15 00:39:09.000000', 'temperatura', 643.0000, 'ºC'),
	(144254, 118, '2014-01-15 00:39:10.000000', 'temperatura', 962.0000, 'ºC'),
	(144255, 118, '2014-01-15 00:39:11.000000', 'temperatura', 480.0000, 'ºC'),
	(144256, 118, '2014-01-15 00:39:12.000000', 'temperatura', 716.0000, 'ºC'),
	(144257, 118, '2014-01-15 00:39:13.000000', 'temperatura', 940.0000, 'ºC'),
	(144258, 118, '2014-01-15 00:39:14.000000', 'temperatura', 152.0000, 'ºC'),
	(144259, 118, '2014-01-15 00:39:15.000000', 'temperatura', 340.0000, 'ºC'),
	(144260, 118, '2014-01-15 00:39:16.000000', 'temperatura', 43.0000, 'ºC'),
	(144261, 118, '2014-01-15 00:39:17.000000', 'temperatura', 398.0000, 'ºC'),
	(144262, 118, '2014-01-15 00:39:18.000000', 'temperatura', 659.0000, 'ºC'),
	(144263, 118, '2014-01-15 00:39:19.000000', 'temperatura', 904.0000, 'ºC'),
	(144264, 118, '2014-01-15 00:39:20.000000', 'temperatura', 144.0000, 'ºC'),
	(144265, 118, '2014-01-15 00:39:21.000000', 'temperatura', 409.0000, 'ºC'),
	(144266, 118, '2014-01-15 00:39:22.000000', 'temperatura', 414.0000, 'ºC'),
	(144267, 118, '2014-01-15 00:39:23.000000', 'temperatura', 842.0000, 'ºC'),
	(144268, 118, '2014-01-15 00:39:24.000000', 'temperatura', 568.0000, 'ºC'),
	(144269, 118, '2014-01-15 00:39:25.000000', 'temperatura', 317.0000, 'ºC'),
	(144270, 118, '2014-01-15 00:39:26.000000', 'temperatura', 1079.0000, 'ºC'),
	(144271, 118, '2014-01-15 00:39:27.000000', 'temperatura', 847.0000, 'ºC'),
	(144272, 118, '2014-01-15 00:39:28.000000', 'temperatura', 996.0000, 'ºC'),
	(144273, 118, '2014-01-15 00:39:29.000000', 'temperatura', 42.0000, 'ºC'),
	(144274, 118, '2014-01-15 00:39:30.000000', 'temperatura', 820.0000, 'ºC'),
	(144275, 118, '2014-01-15 00:39:31.000000', 'temperatura', 374.0000, 'ºC'),
	(144276, 118, '2014-01-15 00:39:32.000000', 'temperatura', 610.0000, 'ºC'),
	(144277, 118, '2014-01-15 00:39:33.000000', 'temperatura', 730.0000, 'ºC'),
	(144278, 118, '2014-01-15 00:39:34.000000', 'temperatura', 620.0000, 'ºC'),
	(144279, 118, '2014-01-15 00:39:35.000000', 'temperatura', 913.0000, 'ºC'),
	(144280, 118, '2014-01-15 00:39:36.000000', 'temperatura', 302.0000, 'ºC'),
	(144281, 118, '2014-01-15 00:39:37.000000', 'temperatura', 1173.0000, 'ºC'),
	(144282, 118, '2014-01-15 00:39:38.000000', 'temperatura', 157.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(144283, 118, '2014-01-15 00:39:39.000000', 'temperatura', 869.0000, 'ºC'),
	(144284, 118, '2014-01-15 00:39:40.000000', 'temperatura', 275.0000, 'ºC'),
	(144285, 118, '2014-01-15 00:39:41.000000', 'temperatura', 1169.0000, 'ºC'),
	(144286, 118, '2014-01-15 00:39:42.000000', 'temperatura', 218.0000, 'ºC'),
	(144287, 118, '2014-01-15 00:39:43.000000', 'temperatura', 1184.0000, 'ºC'),
	(144288, 118, '2014-01-15 00:39:44.000000', 'temperatura', 466.0000, 'ºC'),
	(144289, 118, '2014-01-15 00:39:45.000000', 'temperatura', 1178.0000, 'ºC'),
	(144290, 118, '2014-01-15 00:39:46.000000', 'temperatura', 895.0000, 'ºC'),
	(144291, 118, '2014-01-15 00:39:47.000000', 'temperatura', 942.0000, 'ºC'),
	(144292, 118, '2014-01-15 00:39:48.000000', 'temperatura', 824.0000, 'ºC'),
	(144293, 118, '2014-01-15 00:39:49.000000', 'temperatura', 95.0000, 'ºC'),
	(144294, 118, '2014-01-15 00:39:50.000000', 'temperatura', 404.0000, 'ºC'),
	(144295, 118, '2014-01-15 00:39:51.000000', 'temperatura', 535.0000, 'ºC'),
	(144296, 118, '2014-01-15 00:39:52.000000', 'temperatura', 262.0000, 'ºC'),
	(144297, 118, '2014-01-15 00:39:53.000000', 'temperatura', 904.0000, 'ºC'),
	(144298, 118, '2014-01-15 00:39:54.000000', 'temperatura', 138.0000, 'ºC'),
	(144299, 118, '2014-01-15 00:39:55.000000', 'temperatura', 378.0000, 'ºC'),
	(144300, 118, '2014-01-15 00:39:56.000000', 'temperatura', 276.0000, 'ºC'),
	(144301, 118, '2014-01-15 00:39:57.000000', 'temperatura', 246.0000, 'ºC'),
	(144302, 118, '2014-01-15 00:39:58.000000', 'temperatura', 403.0000, 'ºC'),
	(144303, 118, '2014-01-15 00:39:59.000000', 'temperatura', 76.0000, 'ºC'),
	(144304, 118, '2014-01-15 00:40:00.000000', 'temperatura', 372.0000, 'ºC'),
	(144305, 118, '2014-01-15 00:40:01.000000', 'temperatura', 433.0000, 'ºC'),
	(144306, 118, '2014-01-15 00:40:02.000000', 'temperatura', 1050.0000, 'ºC'),
	(144307, 118, '2014-01-15 00:40:03.000000', 'temperatura', 353.0000, 'ºC'),
	(144308, 118, '2014-01-15 00:40:04.000000', 'temperatura', 1013.0000, 'ºC'),
	(144309, 118, '2014-01-15 00:40:05.000000', 'temperatura', 407.0000, 'ºC'),
	(144310, 118, '2014-01-15 00:40:06.000000', 'temperatura', 198.0000, 'ºC'),
	(144311, 118, '2014-01-15 00:40:07.000000', 'temperatura', 970.0000, 'ºC'),
	(144312, 118, '2014-01-15 00:40:08.000000', 'temperatura', 655.0000, 'ºC'),
	(144313, 118, '2014-01-15 00:40:09.000000', 'temperatura', 365.0000, 'ºC'),
	(144314, 118, '2014-01-15 00:40:10.000000', 'temperatura', 1063.0000, 'ºC'),
	(144315, 118, '2014-01-15 00:40:11.000000', 'temperatura', 618.0000, 'ºC'),
	(144316, 118, '2014-01-15 00:40:12.000000', 'temperatura', 1101.0000, 'ºC'),
	(144317, 118, '2014-01-15 00:40:13.000000', 'temperatura', 53.0000, 'ºC'),
	(144318, 118, '2014-01-15 00:40:14.000000', 'temperatura', 563.0000, 'ºC'),
	(144319, 118, '2014-01-15 00:40:15.000000', 'temperatura', 254.0000, 'ºC'),
	(144320, 118, '2014-01-15 00:40:16.000000', 'temperatura', 783.0000, 'ºC'),
	(144321, 118, '2014-01-15 00:40:17.000000', 'temperatura', 753.0000, 'ºC'),
	(144322, 118, '2014-01-15 00:40:18.000000', 'temperatura', 215.0000, 'ºC'),
	(144323, 118, '2014-01-15 00:40:19.000000', 'temperatura', 17.0000, 'ºC'),
	(144324, 118, '2014-01-15 00:40:20.000000', 'temperatura', 640.0000, 'ºC'),
	(144325, 118, '2014-01-15 00:40:21.000000', 'temperatura', 751.0000, 'ºC'),
	(144326, 118, '2014-01-15 00:40:22.000000', 'temperatura', 635.0000, 'ºC'),
	(144327, 118, '2014-01-15 00:40:23.000000', 'temperatura', 923.0000, 'ºC'),
	(144328, 118, '2014-01-15 00:40:24.000000', 'temperatura', 310.0000, 'ºC'),
	(144329, 118, '2014-01-15 00:40:25.000000', 'temperatura', 1180.0000, 'ºC'),
	(144330, 118, '2014-01-15 00:40:26.000000', 'temperatura', 170.0000, 'ºC'),
	(144331, 118, '2014-01-15 00:40:27.000000', 'temperatura', 911.0000, 'ºC'),
	(144332, 118, '2014-01-15 00:40:28.000000', 'temperatura', 444.0000, 'ºC'),
	(144333, 118, '2014-01-15 00:40:29.000000', 'temperatura', 688.0000, 'ºC'),
	(144334, 118, '2014-01-15 00:40:30.000000', 'temperatura', 911.0000, 'ºC'),
	(144335, 118, '2014-01-15 00:40:31.000000', 'temperatura', 91.0000, 'ºC'),
	(144336, 118, '2014-01-15 00:40:32.000000', 'temperatura', 121.0000, 'ºC'),
	(144337, 118, '2014-01-15 00:40:33.000000', 'temperatura', 334.0000, 'ºC'),
	(144338, 118, '2014-01-15 00:40:34.000000', 'temperatura', 108.0000, 'ºC'),
	(144339, 118, '2014-01-15 00:40:35.000000', 'temperatura', 737.0000, 'ºC'),
	(144340, 118, '2014-01-15 00:40:36.000000', 'temperatura', 962.0000, 'ºC'),
	(144341, 118, '2014-01-15 00:40:37.000000', 'temperatura', 198.0000, 'ºC'),
	(144342, 118, '2014-01-15 00:40:38.000000', 'temperatura', 504.0000, 'ºC'),
	(144343, 118, '2014-01-15 00:40:39.000000', 'temperatura', 729.0000, 'ºC'),
	(144344, 118, '2014-01-15 00:40:40.000000', 'temperatura', 931.0000, 'ºC'),
	(144345, 118, '2014-01-15 00:40:41.000000', 'temperatura', 69.0000, 'ºC'),
	(144346, 118, '2014-01-15 00:40:42.000000', 'temperatura', 1153.0000, 'ºC'),
	(144347, 118, '2014-01-15 00:40:43.000000', 'temperatura', 758.0000, 'ºC'),
	(144348, 118, '2014-01-15 00:40:44.000000', 'temperatura', 333.0000, 'ºC'),
	(144349, 118, '2014-01-15 00:40:45.000000', 'temperatura', 590.0000, 'ºC'),
	(144350, 118, '2014-01-15 00:40:46.000000', 'temperatura', 752.0000, 'ºC'),
	(144351, 118, '2014-01-15 00:40:47.000000', 'temperatura', 790.0000, 'ºC'),
	(144352, 118, '2014-01-15 00:40:48.000000', 'temperatura', 496.0000, 'ºC'),
	(144353, 118, '2014-01-15 00:40:49.000000', 'temperatura', 112.0000, 'ºC'),
	(144354, 118, '2014-01-15 00:40:50.000000', 'temperatura', 270.0000, 'ºC'),
	(144355, 118, '2014-01-15 00:40:51.000000', 'temperatura', 1014.0000, 'ºC'),
	(144356, 118, '2014-01-15 00:40:52.000000', 'temperatura', 663.0000, 'ºC'),
	(144357, 118, '2014-01-15 00:40:53.000000', 'temperatura', 274.0000, 'ºC'),
	(144358, 118, '2014-01-15 00:40:54.000000', 'temperatura', 580.0000, 'ºC'),
	(144359, 118, '2014-01-15 00:40:55.000000', 'temperatura', 877.0000, 'ºC'),
	(144360, 118, '2014-01-15 00:40:56.000000', 'temperatura', 249.0000, 'ºC'),
	(144361, 118, '2014-01-15 00:40:57.000000', 'temperatura', 1012.0000, 'ºC'),
	(144362, 118, '2014-01-15 00:40:58.000000', 'temperatura', 715.0000, 'ºC'),
	(144363, 118, '2014-01-15 00:40:59.000000', 'temperatura', 538.0000, 'ºC'),
	(144364, 118, '2014-01-15 00:41:00.000000', 'temperatura', 545.0000, 'ºC'),
	(144365, 118, '2014-01-15 00:41:01.000000', 'temperatura', 1112.0000, 'ºC'),
	(144366, 118, '2014-01-15 00:41:02.000000', 'temperatura', 324.0000, 'ºC'),
	(144367, 118, '2014-01-15 00:41:03.000000', 'temperatura', 685.0000, 'ºC'),
	(144368, 118, '2014-01-15 00:41:04.000000', 'temperatura', 55.0000, 'ºC'),
	(144369, 118, '2014-01-15 00:41:05.000000', 'temperatura', 619.0000, 'ºC'),
	(144370, 118, '2014-01-15 00:41:06.000000', 'temperatura', 530.0000, 'ºC'),
	(144371, 118, '2014-01-15 00:41:07.000000', 'temperatura', 793.0000, 'ºC'),
	(144372, 118, '2014-01-15 00:41:08.000000', 'temperatura', 1176.0000, 'ºC'),
	(144373, 118, '2014-01-15 00:41:09.000000', 'temperatura', 1101.0000, 'ºC'),
	(144374, 118, '2014-01-15 00:41:10.000000', 'temperatura', 780.0000, 'ºC'),
	(144375, 118, '2014-01-15 00:41:11.000000', 'temperatura', 596.0000, 'ºC'),
	(144376, 118, '2014-01-15 00:41:12.000000', 'temperatura', 640.0000, 'ºC'),
	(144377, 118, '2014-01-15 00:41:13.000000', 'temperatura', 213.0000, 'ºC'),
	(144378, 118, '2014-01-15 00:41:14.000000', 'temperatura', 347.0000, 'ºC'),
	(144379, 118, '2014-01-15 00:41:15.000000', 'temperatura', 1095.0000, 'ºC'),
	(144380, 118, '2014-01-15 00:41:16.000000', 'temperatura', 836.0000, 'ºC'),
	(144381, 118, '2014-01-15 00:41:17.000000', 'temperatura', 895.0000, 'ºC'),
	(144382, 118, '2014-01-15 00:41:18.000000', 'temperatura', 766.0000, 'ºC'),
	(144383, 118, '2014-01-15 00:41:19.000000', 'temperatura', 1144.0000, 'ºC'),
	(144384, 118, '2014-01-15 00:41:20.000000', 'temperatura', 1025.0000, 'ºC'),
	(144385, 118, '2014-01-15 00:41:21.000000', 'temperatura', 494.0000, 'ºC'),
	(144386, 118, '2014-01-15 00:41:22.000000', 'temperatura', 593.0000, 'ºC'),
	(144387, 118, '2014-01-15 00:41:23.000000', 'temperatura', 286.0000, 'ºC'),
	(144388, 118, '2014-01-15 00:41:24.000000', 'temperatura', 850.0000, 'ºC'),
	(144389, 118, '2014-01-15 00:41:25.000000', 'temperatura', 992.0000, 'ºC'),
	(144390, 118, '2014-01-15 00:41:26.000000', 'temperatura', 12.0000, 'ºC'),
	(144391, 118, '2014-01-15 00:41:27.000000', 'temperatura', 686.0000, 'ºC'),
	(144392, 118, '2014-01-15 00:41:28.000000', 'temperatura', 991.0000, 'ºC'),
	(144393, 118, '2014-01-15 00:41:29.000000', 'temperatura', 499.0000, 'ºC'),
	(144394, 118, '2014-01-15 00:41:30.000000', 'temperatura', 721.0000, 'ºC'),
	(144395, 118, '2014-01-15 00:41:31.000000', 'temperatura', 908.0000, 'ºC'),
	(144396, 118, '2014-01-15 00:41:32.000000', 'temperatura', 1178.0000, 'ºC'),
	(144397, 118, '2014-01-15 00:41:33.000000', 'temperatura', 765.0000, 'ºC'),
	(144398, 118, '2014-01-15 00:41:34.000000', 'temperatura', 294.0000, 'ºC'),
	(144399, 118, '2014-01-15 00:41:35.000000', 'temperatura', 376.0000, 'ºC'),
	(144400, 118, '2014-01-15 00:41:36.000000', 'temperatura', 998.0000, 'ºC'),
	(144401, 118, '2014-01-15 00:41:37.000000', 'temperatura', 260.0000, 'ºC'),
	(144402, 118, '2014-01-15 00:41:38.000000', 'temperatura', 709.0000, 'ºC'),
	(144403, 118, '2014-01-15 00:41:39.000000', 'temperatura', 365.0000, 'ºC'),
	(144404, 118, '2014-01-15 00:41:40.000000', 'temperatura', 898.0000, 'ºC'),
	(144405, 118, '2014-01-15 00:41:41.000000', 'temperatura', 996.0000, 'ºC'),
	(144406, 118, '2014-01-15 00:41:42.000000', 'temperatura', 1085.0000, 'ºC'),
	(144407, 118, '2014-01-15 00:41:43.000000', 'temperatura', 41.0000, 'ºC'),
	(144408, 118, '2014-01-15 00:41:44.000000', 'temperatura', 547.0000, 'ºC'),
	(144409, 118, '2014-01-15 00:41:45.000000', 'temperatura', 213.0000, 'ºC'),
	(144410, 118, '2014-01-15 00:41:46.000000', 'temperatura', 624.0000, 'ºC'),
	(144411, 118, '2014-01-15 00:41:47.000000', 'temperatura', 84.0000, 'ºC'),
	(144412, 118, '2014-01-15 00:41:48.000000', 'temperatura', 945.0000, 'ºC'),
	(144413, 118, '2014-01-15 00:41:49.000000', 'temperatura', 876.0000, 'ºC'),
	(144414, 118, '2014-01-15 00:41:50.000000', 'temperatura', 343.0000, 'ºC'),
	(144415, 118, '2014-01-15 00:41:51.000000', 'temperatura', 288.0000, 'ºC'),
	(144416, 118, '2014-01-15 00:41:52.000000', 'temperatura', 411.0000, 'ºC'),
	(144417, 118, '2014-01-15 00:41:53.000000', 'temperatura', 1191.0000, 'ºC'),
	(144418, 118, '2014-01-15 00:41:54.000000', 'temperatura', 1123.0000, 'ºC'),
	(144419, 118, '2014-01-15 00:41:55.000000', 'temperatura', 841.0000, 'ºC'),
	(144420, 118, '2014-01-15 00:41:56.000000', 'temperatura', 838.0000, 'ºC'),
	(144421, 118, '2014-01-15 00:41:57.000000', 'temperatura', 468.0000, 'ºC'),
	(144422, 118, '2014-01-15 00:41:58.000000', 'temperatura', 1026.0000, 'ºC'),
	(144423, 118, '2014-01-15 00:41:59.000000', 'temperatura', 125.0000, 'ºC'),
	(144424, 118, '2014-01-15 00:42:00.000000', 'temperatura', 1148.0000, 'ºC'),
	(144425, 118, '2014-01-15 00:42:01.000000', 'temperatura', 566.0000, 'ºC'),
	(144426, 118, '2014-01-15 00:42:02.000000', 'temperatura', 588.0000, 'ºC'),
	(144427, 118, '2014-01-15 00:42:03.000000', 'temperatura', 42.0000, 'ºC'),
	(144428, 118, '2014-01-15 00:42:04.000000', 'temperatura', 847.0000, 'ºC'),
	(144429, 118, '2014-01-15 00:42:05.000000', 'temperatura', 511.0000, 'ºC'),
	(144430, 118, '2014-01-15 00:42:06.000000', 'temperatura', 13.0000, 'ºC'),
	(144431, 118, '2014-01-15 00:42:07.000000', 'temperatura', 931.0000, 'ºC'),
	(144432, 118, '2014-01-15 00:42:08.000000', 'temperatura', 1018.0000, 'ºC'),
	(144433, 118, '2014-01-15 00:42:09.000000', 'temperatura', 1098.0000, 'ºC'),
	(144434, 118, '2014-01-15 00:42:10.000000', 'temperatura', 37.0000, 'ºC'),
	(144435, 118, '2014-01-15 00:42:11.000000', 'temperatura', 492.0000, 'ºC'),
	(144436, 118, '2014-01-15 00:42:12.000000', 'temperatura', 1150.0000, 'ºC'),
	(144437, 118, '2014-01-15 00:42:13.000000', 'temperatura', 672.0000, 'ºC'),
	(144438, 118, '2014-01-15 00:42:14.000000', 'temperatura', 1112.0000, 'ºC'),
	(144439, 118, '2014-01-15 00:42:15.000000', 'temperatura', 1144.0000, 'ºC'),
	(144440, 118, '2014-01-15 00:42:16.000000', 'temperatura', 1183.0000, 'ºC'),
	(144441, 118, '2014-01-15 00:42:17.000000', 'temperatura', 86.0000, 'ºC'),
	(144442, 118, '2014-01-15 00:42:18.000000', 'temperatura', 481.0000, 'ºC'),
	(144443, 118, '2014-01-15 00:42:19.000000', 'temperatura', 946.0000, 'ºC'),
	(144444, 118, '2014-01-15 00:42:20.000000', 'temperatura', 888.0000, 'ºC'),
	(144445, 118, '2014-01-15 00:42:21.000000', 'temperatura', 403.0000, 'ºC'),
	(144446, 118, '2014-01-15 00:42:22.000000', 'temperatura', 552.0000, 'ºC'),
	(144447, 118, '2014-01-15 00:42:23.000000', 'temperatura', 352.0000, 'ºC'),
	(144448, 118, '2014-01-15 00:42:24.000000', 'temperatura', 106.0000, 'ºC'),
	(144449, 118, '2014-01-15 00:42:25.000000', 'temperatura', 672.0000, 'ºC'),
	(144450, 118, '2014-01-15 00:42:26.000000', 'temperatura', 642.0000, 'ºC'),
	(144451, 118, '2014-01-15 00:42:27.000000', 'temperatura', 1194.0000, 'ºC'),
	(144452, 118, '2014-01-15 00:42:28.000000', 'temperatura', 445.0000, 'ºC'),
	(144453, 118, '2014-01-15 00:42:29.000000', 'temperatura', 1044.0000, 'ºC'),
	(144454, 118, '2014-01-15 00:42:30.000000', 'temperatura', 284.0000, 'ºC'),
	(144455, 118, '2014-01-15 00:42:31.000000', 'temperatura', 691.0000, 'ºC'),
	(144456, 118, '2014-01-15 00:42:32.000000', 'temperatura', 201.0000, 'ºC'),
	(144457, 118, '2014-01-15 00:42:33.000000', 'temperatura', 132.0000, 'ºC'),
	(144458, 118, '2014-01-15 00:42:34.000000', 'temperatura', 58.0000, 'ºC'),
	(144459, 118, '2014-01-15 00:42:35.000000', 'temperatura', 1095.0000, 'ºC'),
	(144460, 118, '2014-01-15 00:42:36.000000', 'temperatura', 503.0000, 'ºC'),
	(144461, 118, '2014-01-15 00:42:37.000000', 'temperatura', 428.0000, 'ºC'),
	(144462, 118, '2014-01-15 00:42:38.000000', 'temperatura', 632.0000, 'ºC'),
	(144463, 118, '2014-01-15 00:42:39.000000', 'temperatura', 675.0000, 'ºC'),
	(144464, 118, '2014-01-15 00:42:40.000000', 'temperatura', 280.0000, 'ºC'),
	(144465, 118, '2014-01-15 00:42:41.000000', 'temperatura', 577.0000, 'ºC'),
	(144466, 118, '2014-01-15 00:42:42.000000', 'temperatura', 845.0000, 'ºC'),
	(144467, 118, '2014-01-15 00:42:43.000000', 'temperatura', 96.0000, 'ºC'),
	(144468, 118, '2014-01-15 00:42:44.000000', 'temperatura', 343.0000, 'ºC'),
	(144469, 118, '2014-01-15 00:42:45.000000', 'temperatura', 229.0000, 'ºC'),
	(144470, 118, '2014-01-15 00:42:46.000000', 'temperatura', 114.0000, 'ºC'),
	(144471, 118, '2014-01-15 00:42:47.000000', 'temperatura', 1085.0000, 'ºC'),
	(144472, 118, '2014-01-15 00:42:48.000000', 'temperatura', 283.0000, 'ºC'),
	(144473, 118, '2014-01-15 00:42:49.000000', 'temperatura', 560.0000, 'ºC'),
	(144474, 118, '2014-01-15 00:42:50.000000', 'temperatura', 753.0000, 'ºC'),
	(144475, 118, '2014-01-15 00:42:51.000000', 'temperatura', 886.0000, 'ºC'),
	(144476, 118, '2014-01-15 00:42:52.000000', 'temperatura', 973.0000, 'ºC'),
	(144477, 118, '2014-01-15 00:42:53.000000', 'temperatura', 1004.0000, 'ºC'),
	(144478, 118, '2014-01-15 00:42:54.000000', 'temperatura', 904.0000, 'ºC'),
	(144479, 118, '2014-01-15 00:42:55.000000', 'temperatura', 308.0000, 'ºC'),
	(144480, 118, '2014-01-15 00:42:56.000000', 'temperatura', 27.0000, 'ºC'),
	(144481, 118, '2014-01-15 00:42:57.000000', 'temperatura', 414.0000, 'ºC'),
	(144482, 118, '2014-01-15 00:42:58.000000', 'temperatura', 788.0000, 'ºC'),
	(144483, 118, '2014-01-15 00:42:59.000000', 'temperatura', 300.0000, 'ºC'),
	(144484, 118, '2014-01-15 00:43:00.000000', 'temperatura', 336.0000, 'ºC'),
	(144485, 118, '2014-01-15 00:43:01.000000', 'temperatura', 780.0000, 'ºC'),
	(144486, 118, '2014-01-15 00:43:02.000000', 'temperatura', 494.0000, 'ºC'),
	(144487, 118, '2014-01-15 00:43:03.000000', 'temperatura', 129.0000, 'ºC'),
	(144488, 118, '2014-01-15 00:43:04.000000', 'temperatura', 364.0000, 'ºC'),
	(144489, 118, '2014-01-15 00:43:05.000000', 'temperatura', 232.0000, 'ºC'),
	(144490, 118, '2014-01-15 00:43:06.000000', 'temperatura', 70.0000, 'ºC'),
	(144491, 118, '2014-01-15 00:43:07.000000', 'temperatura', 855.0000, 'ºC'),
	(144492, 118, '2014-01-15 00:43:08.000000', 'temperatura', 467.0000, 'ºC'),
	(144493, 118, '2014-01-15 00:43:09.000000', 'temperatura', 967.0000, 'ºC'),
	(144494, 118, '2014-01-15 00:43:10.000000', 'temperatura', 1037.0000, 'ºC'),
	(144495, 118, '2014-01-15 00:43:11.000000', 'temperatura', 1082.0000, 'ºC'),
	(144496, 118, '2014-01-15 00:43:12.000000', 'temperatura', 1101.0000, 'ºC'),
	(144497, 118, '2014-01-15 00:43:13.000000', 'temperatura', 1061.0000, 'ºC'),
	(144498, 118, '2014-01-15 00:43:14.000000', 'temperatura', 800.0000, 'ºC'),
	(144499, 118, '2014-01-15 00:43:15.000000', 'temperatura', 819.0000, 'ºC'),
	(144500, 118, '2014-01-15 00:43:16.000000', 'temperatura', 497.0000, 'ºC'),
	(144501, 118, '2014-01-15 00:43:17.000000', 'temperatura', 28.0000, 'ºC'),
	(144502, 118, '2014-01-15 00:43:18.000000', 'temperatura', 1050.0000, 'ºC'),
	(144503, 118, '2014-01-15 00:43:19.000000', 'temperatura', 364.0000, 'ºC'),
	(144504, 118, '2014-01-15 00:43:20.000000', 'temperatura', 1072.0000, 'ºC'),
	(144505, 118, '2014-01-15 00:43:21.000000', 'temperatura', 668.0000, 'ºC'),
	(144506, 118, '2014-01-15 00:43:22.000000', 'temperatura', 123.0000, 'ºC'),
	(144507, 118, '2014-01-15 00:43:23.000000', 'temperatura', 1013.0000, 'ºC'),
	(144508, 118, '2014-01-15 00:43:24.000000', 'temperatura', 1095.0000, 'ºC'),
	(144509, 118, '2014-01-15 00:43:25.000000', 'temperatura', 35.0000, 'ºC'),
	(144510, 118, '2014-01-15 00:43:26.000000', 'temperatura', 494.0000, 'ºC'),
	(144511, 118, '2014-01-15 00:43:27.000000', 'temperatura', 1165.0000, 'ºC'),
	(144512, 118, '2014-01-15 00:43:28.000000', 'temperatura', 744.0000, 'ºC'),
	(144513, 118, '2014-01-15 00:43:29.000000', 'temperatura', 223.0000, 'ºC'),
	(144514, 118, '2014-01-15 00:43:30.000000', 'temperatura', 85.0000, 'ºC'),
	(144515, 118, '2014-01-15 00:43:31.000000', 'temperatura', 954.0000, 'ºC'),
	(144516, 118, '2014-01-15 00:43:32.000000', 'temperatura', 919.0000, 'ºC'),
	(144517, 118, '2014-01-15 00:43:33.000000', 'temperatura', 532.0000, 'ºC'),
	(144518, 118, '2014-01-15 00:43:34.000000', 'temperatura', 1104.0000, 'ºC'),
	(144519, 118, '2014-01-15 00:43:35.000000', 'temperatura', 323.0000, 'ºC'),
	(144520, 118, '2014-01-15 00:43:36.000000', 'temperatura', 703.0000, 'ºC'),
	(144521, 118, '2014-01-15 00:43:37.000000', 'temperatura', 148.0000, 'ºC'),
	(144522, 118, '2014-01-15 00:43:38.000000', 'temperatura', 1032.0000, 'ºC'),
	(144523, 118, '2014-01-15 00:43:39.000000', 'temperatura', 1117.0000, 'ºC'),
	(144524, 118, '2014-01-15 00:43:40.000000', 'temperatura', 88.0000, 'ºC'),
	(144525, 118, '2014-01-15 00:43:41.000000', 'temperatura', 692.0000, 'ºC'),
	(144526, 118, '2014-01-15 00:43:42.000000', 'temperatura', 793.0000, 'ºC'),
	(144527, 118, '2014-01-15 00:43:43.000000', 'temperatura', 691.0000, 'ºC'),
	(144528, 118, '2014-01-15 00:43:44.000000', 'temperatura', 1078.0000, 'ºC'),
	(144529, 118, '2014-01-15 00:43:45.000000', 'temperatura', 917.0000, 'ºC'),
	(144530, 118, '2014-01-15 00:43:46.000000', 'temperatura', 151.0000, 'ºC'),
	(144531, 118, '2014-01-15 00:43:47.000000', 'temperatura', 404.0000, 'ºC'),
	(144532, 118, '2014-01-15 00:43:48.000000', 'temperatura', 368.0000, 'ºC'),
	(144533, 118, '2014-01-15 00:43:49.000000', 'temperatura', 628.0000, 'ºC'),
	(144534, 118, '2014-01-15 00:43:50.000000', 'temperatura', 835.0000, 'ºC'),
	(144535, 118, '2014-01-15 00:43:51.000000', 'temperatura', 1092.0000, 'ºC'),
	(144536, 118, '2014-01-15 00:43:52.000000', 'temperatura', 555.0000, 'ºC'),
	(144537, 118, '2014-01-15 00:43:53.000000', 'temperatura', 702.0000, 'ºC'),
	(144538, 118, '2014-01-15 00:43:54.000000', 'temperatura', 642.0000, 'ºC'),
	(144539, 118, '2014-01-15 00:43:55.000000', 'temperatura', 1108.0000, 'ºC'),
	(144540, 118, '2014-01-15 00:43:56.000000', 'temperatura', 12.0000, 'ºC'),
	(144541, 118, '2014-01-15 00:43:57.000000', 'temperatura', 338.0000, 'ºC'),
	(144542, 118, '2014-01-15 00:43:58.000000', 'temperatura', 453.0000, 'ºC'),
	(144543, 118, '2014-01-15 00:43:59.000000', 'temperatura', 53.0000, 'ºC'),
	(144544, 118, '2014-01-15 00:44:00.000000', 'temperatura', 107.0000, 'ºC'),
	(144545, 118, '2014-01-15 00:44:01.000000', 'temperatura', 376.0000, 'ºC'),
	(144546, 118, '2014-01-15 00:44:02.000000', 'temperatura', 361.0000, 'ºC'),
	(144547, 118, '2014-01-15 00:44:03.000000', 'temperatura', 676.0000, 'ºC'),
	(144548, 118, '2014-01-15 00:44:04.000000', 'temperatura', 1099.0000, 'ºC'),
	(144549, 118, '2014-01-15 00:44:05.000000', 'temperatura', 1066.0000, 'ºC'),
	(144550, 118, '2014-01-15 00:44:06.000000', 'temperatura', 832.0000, 'ºC'),
	(144551, 118, '2014-01-15 00:44:07.000000', 'temperatura', 963.0000, 'ºC'),
	(144552, 118, '2014-01-15 00:44:08.000000', 'temperatura', 1121.0000, 'ºC'),
	(144553, 118, '2014-01-15 00:44:09.000000', 'temperatura', 318.0000, 'ºC'),
	(144554, 118, '2014-01-15 00:44:10.000000', 'temperatura', 625.0000, 'ºC'),
	(144555, 118, '2014-01-15 00:44:11.000000', 'temperatura', 970.0000, 'ºC'),
	(144556, 118, '2014-01-15 00:44:12.000000', 'temperatura', 578.0000, 'ºC'),
	(144557, 118, '2014-01-15 00:44:13.000000', 'temperatura', 1178.0000, 'ºC'),
	(144558, 118, '2014-01-15 00:44:14.000000', 'temperatura', 557.0000, 'ºC'),
	(144559, 118, '2014-01-15 00:44:15.000000', 'temperatura', 451.0000, 'ºC'),
	(144560, 118, '2014-01-15 00:44:16.000000', 'temperatura', 584.0000, 'ºC'),
	(144561, 118, '2014-01-15 00:44:17.000000', 'temperatura', 368.0000, 'ºC'),
	(144562, 118, '2014-01-15 00:44:18.000000', 'temperatura', 89.0000, 'ºC'),
	(144563, 118, '2014-01-15 00:44:19.000000', 'temperatura', 542.0000, 'ºC'),
	(144564, 118, '2014-01-15 00:44:20.000000', 'temperatura', 44.0000, 'ºC'),
	(144565, 118, '2014-01-15 00:44:21.000000', 'temperatura', 994.0000, 'ºC'),
	(144566, 118, '2014-01-15 00:44:22.000000', 'temperatura', 38.0000, 'ºC'),
	(144567, 118, '2014-01-15 00:44:23.000000', 'temperatura', 808.0000, 'ºC'),
	(144568, 118, '2014-01-15 00:44:24.000000', 'temperatura', 329.0000, 'ºC'),
	(144569, 118, '2014-01-15 00:44:25.000000', 'temperatura', 421.0000, 'ºC'),
	(144570, 118, '2014-01-15 00:44:26.000000', 'temperatura', 1116.0000, 'ºC'),
	(144571, 118, '2014-01-15 00:44:27.000000', 'temperatura', 720.0000, 'ºC'),
	(144572, 118, '2014-01-15 00:44:28.000000', 'temperatura', 253.0000, 'ºC'),
	(144573, 118, '2014-01-15 00:44:29.000000', 'temperatura', 305.0000, 'ºC'),
	(144574, 118, '2014-01-15 00:44:30.000000', 'temperatura', 765.0000, 'ºC'),
	(144575, 118, '2014-01-15 00:44:31.000000', 'temperatura', 511.0000, 'ºC'),
	(144576, 118, '2014-01-15 00:44:32.000000', 'temperatura', 262.0000, 'ºC'),
	(144577, 118, '2014-01-15 00:44:33.000000', 'temperatura', 978.0000, 'ºC'),
	(144578, 118, '2014-01-15 00:44:34.000000', 'temperatura', 505.0000, 'ºC'),
	(144579, 118, '2014-01-15 00:44:35.000000', 'temperatura', 790.0000, 'ºC'),
	(144580, 118, '2014-01-15 00:44:36.000000', 'temperatura', 35.0000, 'ºC'),
	(144581, 118, '2014-01-15 00:44:37.000000', 'temperatura', 207.0000, 'ºC'),
	(144582, 118, '2014-01-15 00:44:38.000000', 'temperatura', 929.0000, 'ºC'),
	(144583, 118, '2014-01-15 00:44:39.000000', 'temperatura', 423.0000, 'ºC'),
	(144584, 118, '2014-01-15 00:44:40.000000', 'temperatura', 531.0000, 'ºC'),
	(144585, 118, '2014-01-15 00:44:41.000000', 'temperatura', 187.0000, 'ºC'),
	(144586, 118, '2014-01-15 00:44:42.000000', 'temperatura', 540.0000, 'ºC'),
	(144587, 118, '2014-01-15 00:44:43.000000', 'temperatura', 939.0000, 'ºC'),
	(144588, 118, '2014-01-15 00:44:44.000000', 'temperatura', 679.0000, 'ºC'),
	(144589, 118, '2014-01-15 00:44:45.000000', 'temperatura', 575.0000, 'ºC'),
	(144590, 118, '2014-01-15 00:44:46.000000', 'temperatura', 839.0000, 'ºC'),
	(144591, 118, '2014-01-15 00:44:47.000000', 'temperatura', 72.0000, 'ºC'),
	(144592, 118, '2014-01-15 00:44:48.000000', 'temperatura', 245.0000, 'ºC'),
	(144593, 118, '2014-01-15 00:44:49.000000', 'temperatura', 1007.0000, 'ºC'),
	(144594, 118, '2014-01-15 00:44:50.000000', 'temperatura', 699.0000, 'ºC'),
	(144595, 118, '2014-01-15 00:44:51.000000', 'temperatura', 476.0000, 'ºC'),
	(144596, 118, '2014-01-15 00:44:52.000000', 'temperatura', 285.0000, 'ºC'),
	(144597, 118, '2014-01-15 00:44:53.000000', 'temperatura', 1195.0000, 'ºC'),
	(144598, 118, '2014-01-15 00:44:54.000000', 'temperatura', 323.0000, 'ºC'),
	(144599, 118, '2014-01-15 00:44:55.000000', 'temperatura', 428.0000, 'ºC'),
	(144600, 118, '2014-01-15 00:44:56.000000', 'temperatura', 1173.0000, 'ºC'),
	(144601, 118, '2014-01-15 00:44:57.000000', 'temperatura', 980.0000, 'ºC'),
	(144602, 118, '2014-01-15 00:44:58.000000', 'temperatura', 181.0000, 'ºC'),
	(144603, 118, '2014-01-15 00:44:59.000000', 'temperatura', 365.0000, 'ºC'),
	(144604, 118, '2014-01-15 00:45:00.000000', 'temperatura', 83.0000, 'ºC'),
	(144605, 118, '2014-01-15 00:45:01.000000', 'temperatura', 521.0000, 'ºC'),
	(144606, 118, '2014-01-15 00:45:02.000000', 'temperatura', 1156.0000, 'ºC'),
	(144607, 118, '2014-01-15 00:45:03.000000', 'temperatura', 616.0000, 'ºC'),
	(144608, 118, '2014-01-15 00:45:04.000000', 'temperatura', 814.0000, 'ºC'),
	(144609, 118, '2014-01-15 00:45:05.000000', 'temperatura', 1024.0000, 'ºC'),
	(144610, 118, '2014-01-15 00:45:06.000000', 'temperatura', 277.0000, 'ºC'),
	(144611, 118, '2014-01-15 00:45:07.000000', 'temperatura', 712.0000, 'ºC'),
	(144612, 118, '2014-01-15 00:45:08.000000', 'temperatura', 330.0000, 'ºC'),
	(144613, 118, '2014-01-15 00:45:09.000000', 'temperatura', 715.0000, 'ºC'),
	(144614, 118, '2014-01-15 00:45:10.000000', 'temperatura', 184.0000, 'ºC'),
	(144615, 118, '2014-01-15 00:45:11.000000', 'temperatura', 1178.0000, 'ºC'),
	(144616, 118, '2014-01-15 00:45:12.000000', 'temperatura', 536.0000, 'ºC'),
	(144617, 118, '2014-01-15 00:45:13.000000', 'temperatura', 349.0000, 'ºC'),
	(144618, 118, '2014-01-15 00:45:14.000000', 'temperatura', 136.0000, 'ºC'),
	(144619, 118, '2014-01-15 00:45:15.000000', 'temperatura', 836.0000, 'ºC'),
	(144620, 118, '2014-01-15 00:45:16.000000', 'temperatura', 170.0000, 'ºC'),
	(144621, 118, '2014-01-15 00:45:17.000000', 'temperatura', 742.0000, 'ºC'),
	(144622, 118, '2014-01-15 00:45:18.000000', 'temperatura', 802.0000, 'ºC'),
	(144623, 118, '2014-01-15 00:45:19.000000', 'temperatura', 582.0000, 'ºC'),
	(144624, 118, '2014-01-15 00:45:20.000000', 'temperatura', 507.0000, 'ºC'),
	(144625, 118, '2014-01-15 00:45:21.000000', 'temperatura', 791.0000, 'ºC'),
	(144626, 118, '2014-01-15 00:45:22.000000', 'temperatura', 32.0000, 'ºC'),
	(144627, 118, '2014-01-15 00:45:23.000000', 'temperatura', 190.0000, 'ºC'),
	(144628, 118, '2014-01-15 00:45:24.000000', 'temperatura', 852.0000, 'ºC'),
	(144629, 118, '2014-01-15 00:45:25.000000', 'temperatura', 93.0000, 'ºC'),
	(144630, 118, '2014-01-15 00:45:26.000000', 'temperatura', 308.0000, 'ºC'),
	(144631, 118, '2014-01-15 00:45:27.000000', 'temperatura', 64.0000, 'ºC'),
	(144632, 118, '2014-01-15 00:45:28.000000', 'temperatura', 593.0000, 'ºC'),
	(144633, 118, '2014-01-15 00:45:29.000000', 'temperatura', 375.0000, 'ºC'),
	(144634, 118, '2014-01-15 00:45:30.000000', 'temperatura', 97.0000, 'ºC'),
	(144635, 118, '2014-01-15 00:45:31.000000', 'temperatura', 561.0000, 'ºC'),
	(144636, 118, '2014-01-15 00:45:32.000000', 'temperatura', 115.0000, 'ºC'),
	(144637, 118, '2014-01-15 00:45:33.000000', 'temperatura', 90.0000, 'ºC'),
	(144638, 118, '2014-01-15 00:45:34.000000', 'temperatura', 109.0000, 'ºC'),
	(144639, 118, '2014-01-15 00:45:35.000000', 'temperatura', 272.0000, 'ºC'),
	(144640, 118, '2014-01-15 00:45:36.000000', 'temperatura', 1035.0000, 'ºC'),
	(144641, 118, '2014-01-15 00:45:37.000000', 'temperatura', 759.0000, 'ºC'),
	(144642, 118, '2014-01-15 00:45:38.000000', 'temperatura', 691.0000, 'ºC'),
	(144643, 118, '2014-01-15 00:45:39.000000', 'temperatura', 1179.0000, 'ºC'),
	(144644, 118, '2014-01-15 00:45:40.000000', 'temperatura', 224.0000, 'ºC'),
	(144645, 118, '2014-01-15 00:45:41.000000', 'temperatura', 1180.0000, 'ºC'),
	(144646, 118, '2014-01-15 00:45:42.000000', 'temperatura', 431.0000, 'ºC'),
	(144647, 118, '2014-01-15 00:45:43.000000', 'temperatura', 1014.0000, 'ºC'),
	(144648, 118, '2014-01-15 00:45:44.000000', 'temperatura', 177.0000, 'ºC'),
	(144649, 118, '2014-01-15 00:45:45.000000', 'temperatura', 242.0000, 'ºC'),
	(144650, 118, '2014-01-15 00:45:46.000000', 'temperatura', 682.0000, 'ºC'),
	(144651, 118, '2014-01-15 00:45:47.000000', 'temperatura', 284.0000, 'ºC'),
	(144652, 118, '2014-01-15 00:45:48.000000', 'temperatura', 576.0000, 'ºC'),
	(144653, 118, '2014-01-15 00:45:49.000000', 'temperatura', 828.0000, 'ºC'),
	(144654, 118, '2014-01-15 00:45:50.000000', 'temperatura', 11.0000, 'ºC'),
	(144655, 118, '2014-01-15 00:45:51.000000', 'temperatura', 1172.0000, 'ºC'),
	(144656, 118, '2014-01-15 00:45:52.000000', 'temperatura', 1026.0000, 'ºC'),
	(144657, 118, '2014-01-15 00:45:53.000000', 'temperatura', 417.0000, 'ºC'),
	(144658, 118, '2014-01-15 00:45:54.000000', 'temperatura', 206.0000, 'ºC'),
	(144659, 118, '2014-01-15 00:45:55.000000', 'temperatura', 979.0000, 'ºC'),
	(144660, 118, '2014-01-15 00:45:56.000000', 'temperatura', 677.0000, 'ºC'),
	(144661, 118, '2014-01-15 00:45:57.000000', 'temperatura', 449.0000, 'ºC'),
	(144662, 118, '2014-01-15 00:45:58.000000', 'temperatura', 214.0000, 'ºC'),
	(144663, 118, '2014-01-15 00:45:59.000000', 'temperatura', 922.0000, 'ºC'),
	(144664, 118, '2014-01-15 00:46:00.000000', 'temperatura', 370.0000, 'ºC'),
	(144665, 118, '2014-01-15 00:46:01.000000', 'temperatura', 285.0000, 'ºC'),
	(144666, 118, '2014-01-15 00:46:02.000000', 'temperatura', 316.0000, 'ºC'),
	(144667, 118, '2014-01-15 00:46:03.000000', 'temperatura', 724.0000, 'ºC'),
	(144668, 118, '2014-01-15 00:46:04.000000', 'temperatura', 272.0000, 'ºC'),
	(144669, 118, '2014-01-15 00:46:05.000000', 'temperatura', 387.0000, 'ºC'),
	(144670, 118, '2014-01-15 00:46:06.000000', 'temperatura', 1123.0000, 'ºC'),
	(144671, 118, '2014-01-15 00:46:07.000000', 'temperatura', 854.0000, 'ºC'),
	(144672, 118, '2014-01-15 00:46:08.000000', 'temperatura', 900.0000, 'ºC'),
	(144673, 118, '2014-01-15 00:46:09.000000', 'temperatura', 739.0000, 'ºC'),
	(144674, 118, '2014-01-15 00:46:10.000000', 'temperatura', 997.0000, 'ºC'),
	(144675, 118, '2014-01-15 00:46:11.000000', 'temperatura', 368.0000, 'ºC'),
	(144676, 118, '2014-01-15 00:46:12.000000', 'temperatura', 48.0000, 'ºC'),
	(144677, 118, '2014-01-15 00:46:13.000000', 'temperatura', 336.0000, 'ºC'),
	(144678, 118, '2014-01-15 00:46:14.000000', 'temperatura', 339.0000, 'ºC'),
	(144679, 118, '2014-01-15 00:46:15.000000', 'temperatura', 687.0000, 'ºC'),
	(144680, 118, '2014-01-15 00:46:16.000000', 'temperatura', 17.0000, 'ºC'),
	(144681, 118, '2014-01-15 00:46:17.000000', 'temperatura', 425.0000, 'ºC'),
	(144682, 118, '2014-01-15 00:46:18.000000', 'temperatura', 874.0000, 'ºC'),
	(144683, 118, '2014-01-15 00:46:19.000000', 'temperatura', 698.0000, 'ºC'),
	(144684, 118, '2014-01-15 00:46:20.000000', 'temperatura', 866.0000, 'ºC'),
	(144685, 118, '2014-01-15 00:46:21.000000', 'temperatura', 1035.0000, 'ºC'),
	(144686, 118, '2014-01-15 00:46:22.000000', 'temperatura', 180.0000, 'ºC'),
	(144687, 118, '2014-01-15 00:46:23.000000', 'temperatura', 194.0000, 'ºC'),
	(144688, 118, '2014-01-15 00:46:24.000000', 'temperatura', 429.0000, 'ºC'),
	(144689, 118, '2014-01-15 00:46:25.000000', 'temperatura', 365.0000, 'ºC'),
	(144690, 118, '2014-01-15 00:46:26.000000', 'temperatura', 539.0000, 'ºC'),
	(144691, 118, '2014-01-15 00:46:27.000000', 'temperatura', 400.0000, 'ºC'),
	(144692, 118, '2014-01-15 00:46:28.000000', 'temperatura', 384.0000, 'ºC'),
	(144693, 118, '2014-01-15 00:46:29.000000', 'temperatura', 720.0000, 'ºC'),
	(144694, 118, '2014-01-15 00:46:30.000000', 'temperatura', 47.0000, 'ºC'),
	(144695, 118, '2014-01-15 00:46:31.000000', 'temperatura', 475.0000, 'ºC'),
	(144696, 118, '2014-01-15 00:46:32.000000', 'temperatura', 1036.0000, 'ºC'),
	(144697, 118, '2014-01-15 00:46:33.000000', 'temperatura', 153.0000, 'ºC'),
	(144698, 118, '2014-01-15 00:46:34.000000', 'temperatura', 61.0000, 'ºC'),
	(144699, 118, '2014-01-15 00:46:35.000000', 'temperatura', 1044.0000, 'ºC'),
	(144700, 118, '2014-01-15 00:46:36.000000', 'temperatura', 237.0000, 'ºC'),
	(144701, 118, '2014-01-15 00:46:37.000000', 'temperatura', 454.0000, 'ºC'),
	(144702, 118, '2014-01-15 00:46:38.000000', 'temperatura', 358.0000, 'ºC'),
	(144703, 118, '2014-01-15 00:46:39.000000', 'temperatura', 431.0000, 'ºC'),
	(144704, 118, '2014-01-15 00:46:40.000000', 'temperatura', 1082.0000, 'ºC'),
	(144705, 118, '2014-01-15 00:46:41.000000', 'temperatura', 516.0000, 'ºC'),
	(144706, 118, '2014-01-15 00:46:42.000000', 'temperatura', 535.0000, 'ºC'),
	(144707, 118, '2014-01-15 00:46:43.000000', 'temperatura', 1128.0000, 'ºC'),
	(144708, 118, '2014-01-15 00:46:44.000000', 'temperatura', 436.0000, 'ºC'),
	(144709, 118, '2014-01-15 00:46:45.000000', 'temperatura', 1197.0000, 'ºC'),
	(144710, 118, '2014-01-15 00:46:46.000000', 'temperatura', 1076.0000, 'ºC'),
	(144711, 118, '2014-01-15 00:46:47.000000', 'temperatura', 592.0000, 'ºC'),
	(144712, 118, '2014-01-15 00:46:48.000000', 'temperatura', 929.0000, 'ºC'),
	(144713, 118, '2014-01-15 00:46:49.000000', 'temperatura', 472.0000, 'ºC'),
	(144714, 118, '2014-01-15 00:46:50.000000', 'temperatura', 772.0000, 'ºC'),
	(144715, 118, '2014-01-15 00:46:51.000000', 'temperatura', 45.0000, 'ºC'),
	(144716, 118, '2014-01-15 00:46:52.000000', 'temperatura', 308.0000, 'ºC'),
	(144717, 118, '2014-01-15 00:46:53.000000', 'temperatura', 207.0000, 'ºC'),
	(144718, 118, '2014-01-15 00:46:54.000000', 'temperatura', 113.0000, 'ºC'),
	(144719, 118, '2014-01-15 00:46:55.000000', 'temperatura', 1143.0000, 'ºC'),
	(144720, 118, '2014-01-15 00:46:56.000000', 'temperatura', 576.0000, 'ºC'),
	(144721, 118, '2014-01-15 00:46:57.000000', 'temperatura', 653.0000, 'ºC'),
	(144722, 118, '2014-01-15 00:46:58.000000', 'temperatura', 337.0000, 'ºC'),
	(144723, 118, '2014-01-15 00:46:59.000000', 'temperatura', 927.0000, 'ºC'),
	(144724, 118, '2014-01-15 00:47:00.000000', 'temperatura', 25.0000, 'ºC'),
	(144725, 118, '2014-01-15 00:47:01.000000', 'temperatura', 944.0000, 'ºC'),
	(144726, 118, '2014-01-15 00:47:02.000000', 'temperatura', 1044.0000, 'ºC'),
	(144727, 118, '2014-01-15 00:47:03.000000', 'temperatura', 1190.0000, 'ºC'),
	(144728, 118, '2014-01-15 00:47:04.000000', 'temperatura', 420.0000, 'ºC'),
	(144729, 118, '2014-01-15 00:47:05.000000', 'temperatura', 928.0000, 'ºC'),
	(144730, 118, '2014-01-15 00:47:06.000000', 'temperatura', 981.0000, 'ºC'),
	(144731, 118, '2014-01-15 00:47:07.000000', 'temperatura', 921.0000, 'ºC'),
	(144732, 118, '2014-01-15 00:47:08.000000', 'temperatura', 461.0000, 'ºC'),
	(144733, 118, '2014-01-15 00:47:09.000000', 'temperatura', 746.0000, 'ºC'),
	(144734, 118, '2014-01-15 00:47:10.000000', 'temperatura', 1146.0000, 'ºC'),
	(144735, 118, '2014-01-15 00:47:11.000000', 'temperatura', 1093.0000, 'ºC'),
	(144736, 118, '2014-01-15 00:47:12.000000', 'temperatura', 827.0000, 'ºC'),
	(144737, 118, '2014-01-15 00:47:13.000000', 'temperatura', 858.0000, 'ºC'),
	(144738, 118, '2014-01-15 00:47:14.000000', 'temperatura', 610.0000, 'ºC'),
	(144739, 118, '2014-01-15 00:47:15.000000', 'temperatura', 477.0000, 'ºC'),
	(144740, 118, '2014-01-15 00:47:16.000000', 'temperatura', 556.0000, 'ºC'),
	(144741, 118, '2014-01-15 00:47:17.000000', 'temperatura', 148.0000, 'ºC'),
	(144742, 118, '2014-01-15 00:47:18.000000', 'temperatura', 271.0000, 'ºC'),
	(144743, 118, '2014-01-15 00:47:19.000000', 'temperatura', 913.0000, 'ºC'),
	(144744, 118, '2014-01-15 00:47:20.000000', 'temperatura', 151.0000, 'ºC'),
	(144745, 118, '2014-01-15 00:47:21.000000', 'temperatura', 419.0000, 'ºC'),
	(144746, 118, '2014-01-15 00:47:22.000000', 'temperatura', 443.0000, 'ºC'),
	(144747, 118, '2014-01-15 00:47:23.000000', 'temperatura', 957.0000, 'ºC'),
	(144748, 118, '2014-01-15 00:47:24.000000', 'temperatura', 1058.0000, 'ºC'),
	(144749, 118, '2014-01-15 00:47:25.000000', 'temperatura', 18.0000, 'ºC'),
	(144750, 118, '2014-01-15 00:47:26.000000', 'temperatura', 516.0000, 'ºC'),
	(144751, 118, '2014-01-15 00:47:27.000000', 'temperatura', 129.0000, 'ºC'),
	(144752, 118, '2014-01-15 00:47:28.000000', 'temperatura', 294.0000, 'ºC'),
	(144753, 118, '2014-01-15 00:47:29.000000', 'temperatura', 1086.0000, 'ºC'),
	(144754, 118, '2014-01-15 00:47:30.000000', 'temperatura', 947.0000, 'ºC'),
	(144755, 118, '2014-01-15 00:47:31.000000', 'temperatura', 277.0000, 'ºC'),
	(144756, 118, '2014-01-15 00:47:32.000000', 'temperatura', 945.0000, 'ºC'),
	(144757, 118, '2014-01-15 00:47:33.000000', 'temperatura', 297.0000, 'ºC'),
	(144758, 118, '2014-01-15 00:47:34.000000', 'temperatura', 1047.0000, 'ºC'),
	(144759, 118, '2014-01-15 00:47:35.000000', 'temperatura', 748.0000, 'ºC'),
	(144760, 118, '2014-01-15 00:47:36.000000', 'temperatura', 596.0000, 'ºC'),
	(144761, 118, '2014-01-15 00:47:37.000000', 'temperatura', 739.0000, 'ºC'),
	(144762, 118, '2014-01-15 00:47:38.000000', 'temperatura', 707.0000, 'ºC'),
	(144763, 118, '2014-01-15 00:47:39.000000', 'temperatura', 118.0000, 'ºC'),
	(144764, 118, '2014-01-15 00:47:40.000000', 'temperatura', 870.0000, 'ºC'),
	(144765, 118, '2014-01-15 00:47:41.000000', 'temperatura', 397.0000, 'ºC'),
	(144766, 118, '2014-01-15 00:47:42.000000', 'temperatura', 573.0000, 'ºC'),
	(144767, 118, '2014-01-15 00:47:43.000000', 'temperatura', 476.0000, 'ºC'),
	(144768, 118, '2014-01-15 00:47:44.000000', 'temperatura', 660.0000, 'ºC'),
	(144769, 118, '2014-01-15 00:47:45.000000', 'temperatura', 674.0000, 'ºC'),
	(144770, 118, '2014-01-15 00:47:46.000000', 'temperatura', 191.0000, 'ºC'),
	(144771, 118, '2014-01-15 00:47:47.000000', 'temperatura', 133.0000, 'ºC'),
	(144772, 118, '2014-01-15 00:47:48.000000', 'temperatura', 92.0000, 'ºC'),
	(144773, 118, '2014-01-15 00:47:49.000000', 'temperatura', 62.0000, 'ºC'),
	(144774, 118, '2014-01-15 00:47:50.000000', 'temperatura', 36.0000, 'ºC'),
	(144775, 118, '2014-01-15 00:47:51.000000', 'temperatura', 1195.0000, 'ºC'),
	(144776, 118, '2014-01-15 00:47:52.000000', 'temperatura', 1067.0000, 'ºC'),
	(144777, 118, '2014-01-15 00:47:53.000000', 'temperatura', 551.0000, 'ºC'),
	(144778, 118, '2014-01-15 00:47:54.000000', 'temperatura', 752.0000, 'ºC'),
	(144779, 118, '2014-01-15 00:47:55.000000', 'temperatura', 908.0000, 'ºC'),
	(144780, 118, '2014-01-15 00:47:56.000000', 'temperatura', 1084.0000, 'ºC'),
	(144781, 118, '2014-01-15 00:47:57.000000', 'temperatura', 298.0000, 'ºC'),
	(144782, 118, '2014-01-15 00:47:58.000000', 'temperatura', 636.0000, 'ºC'),
	(144783, 118, '2014-01-15 00:47:59.000000', 'temperatura', 1088.0000, 'ºC'),
	(144784, 118, '2014-01-15 00:48:00.000000', 'temperatura', 1131.0000, 'ºC'),
	(144785, 118, '2014-01-15 00:48:01.000000', 'temperatura', 1194.0000, 'ºC'),
	(144786, 118, '2014-01-15 00:48:02.000000', 'temperatura', 178.0000, 'ºC'),
	(144787, 118, '2014-01-15 00:48:03.000000', 'temperatura', 907.0000, 'ºC'),
	(144788, 118, '2014-01-15 00:48:04.000000', 'temperatura', 402.0000, 'ºC'),
	(144789, 118, '2014-01-15 00:48:05.000000', 'temperatura', 490.0000, 'ºC'),
	(144790, 118, '2014-01-15 00:48:06.000000', 'temperatura', 45.0000, 'ºC'),
	(144791, 118, '2014-01-15 00:48:07.000000', 'temperatura', 1155.0000, 'ºC'),
	(144792, 118, '2014-01-15 00:48:08.000000', 'temperatura', 841.0000, 'ºC'),
	(144793, 118, '2014-01-15 00:48:09.000000', 'temperatura', 742.0000, 'ºC'),
	(144794, 118, '2014-01-15 00:48:10.000000', 'temperatura', 1185.0000, 'ºC'),
	(144795, 118, '2014-01-15 00:48:11.000000', 'temperatura', 99.0000, 'ºC'),
	(144796, 118, '2014-01-15 00:48:12.000000', 'temperatura', 541.0000, 'ºC'),
	(144797, 118, '2014-01-15 00:48:13.000000', 'temperatura', 9.0000, 'ºC'),
	(144798, 118, '2014-01-15 00:48:14.000000', 'temperatura', 820.0000, 'ºC'),
	(144799, 118, '2014-01-15 00:48:15.000000', 'temperatura', 477.0000, 'ºC'),
	(144800, 118, '2014-01-15 00:48:16.000000', 'temperatura', 1125.0000, 'ºC'),
	(144801, 118, '2014-01-15 00:48:17.000000', 'temperatura', 596.0000, 'ºC'),
	(144802, 118, '2014-01-15 00:48:18.000000', 'temperatura', 802.0000, 'ºC'),
	(144803, 118, '2014-01-15 00:48:19.000000', 'temperatura', 1026.0000, 'ºC'),
	(144804, 118, '2014-01-15 00:48:20.000000', 'temperatura', 321.0000, 'ºC'),
	(144805, 118, '2014-01-15 00:48:21.000000', 'temperatura', 931.0000, 'ºC'),
	(144806, 118, '2014-01-15 00:48:22.000000', 'temperatura', 89.0000, 'ºC'),
	(144807, 118, '2014-01-15 00:48:23.000000', 'temperatura', 54.0000, 'ºC'),
	(144808, 118, '2014-01-15 00:48:24.000000', 'temperatura', 3.0000, 'ºC'),
	(144809, 118, '2014-01-15 00:48:25.000000', 'temperatura', 1054.0000, 'ºC'),
	(144810, 118, '2014-01-15 00:48:26.000000', 'temperatura', 461.0000, 'ºC'),
	(144811, 118, '2014-01-15 00:48:27.000000', 'temperatura', 342.0000, 'ºC'),
	(144812, 118, '2014-01-15 00:48:28.000000', 'temperatura', 330.0000, 'ºC'),
	(144813, 118, '2014-01-15 00:48:29.000000', 'temperatura', 625.0000, 'ºC'),
	(144814, 118, '2014-01-15 00:48:30.000000', 'temperatura', 933.0000, 'ºC'),
	(144815, 118, '2014-01-15 00:48:31.000000', 'temperatura', 390.0000, 'ºC'),
	(144816, 118, '2014-01-15 00:48:32.000000', 'temperatura', 355.0000, 'ºC'),
	(144817, 118, '2014-01-15 00:48:33.000000', 'temperatura', 603.0000, 'ºC'),
	(144818, 118, '2014-01-15 00:48:34.000000', 'temperatura', 749.0000, 'ºC'),
	(144819, 118, '2014-01-15 00:48:35.000000', 'temperatura', 740.0000, 'ºC'),
	(144820, 118, '2014-01-15 00:48:36.000000', 'temperatura', 252.0000, 'ºC'),
	(144821, 118, '2014-01-15 00:48:37.000000', 'temperatura', 240.0000, 'ºC'),
	(144822, 118, '2014-01-15 00:48:38.000000', 'temperatura', 446.0000, 'ºC'),
	(144823, 118, '2014-01-15 00:48:39.000000', 'temperatura', 310.0000, 'ºC'),
	(144824, 118, '2014-01-15 00:48:40.000000', 'temperatura', 214.0000, 'ºC'),
	(144825, 118, '2014-01-15 00:48:41.000000', 'temperatura', 141.0000, 'ºC'),
	(144826, 118, '2014-01-15 00:48:42.000000', 'temperatura', 61.0000, 'ºC'),
	(144827, 118, '2014-01-15 00:48:43.000000', 'temperatura', 1081.0000, 'ºC'),
	(144828, 118, '2014-01-15 00:48:44.000000', 'temperatura', 426.0000, 'ºC'),
	(144829, 118, '2014-01-15 00:48:45.000000', 'temperatura', 86.0000, 'ºC'),
	(144830, 118, '2014-01-15 00:48:46.000000', 'temperatura', 351.0000, 'ºC'),
	(144831, 118, '2014-01-15 00:48:47.000000', 'temperatura', 298.0000, 'ºC'),
	(144832, 118, '2014-01-15 00:48:48.000000', 'temperatura', 437.0000, 'ºC'),
	(144833, 118, '2014-01-15 00:48:49.000000', 'temperatura', 92.0000, 'ºC'),
	(144834, 118, '2014-01-15 00:48:50.000000', 'temperatura', 349.0000, 'ºC'),
	(144835, 118, '2014-01-15 00:48:51.000000', 'temperatura', 269.0000, 'ºC'),
	(144836, 118, '2014-01-15 00:48:52.000000', 'temperatura', 299.0000, 'ºC'),
	(144837, 118, '2014-01-15 00:48:53.000000', 'temperatura', 688.0000, 'ºC'),
	(144838, 118, '2014-01-15 00:48:54.000000', 'temperatura', 144.0000, 'ºC'),
	(144839, 118, '2014-01-15 00:48:55.000000', 'temperatura', 1057.0000, 'ºC'),
	(144840, 118, '2014-01-15 00:48:56.000000', 'temperatura', 54.0000, 'ºC'),
	(144841, 118, '2014-01-15 00:48:57.000000', 'temperatura', 700.0000, 'ºC'),
	(144842, 118, '2014-01-15 00:48:58.000000', 'temperatura', 937.0000, 'ºC'),
	(144843, 118, '2014-01-15 00:48:59.000000', 'temperatura', 186.0000, 'ºC'),
	(144844, 118, '2014-01-15 00:49:00.000000', 'temperatura', 520.0000, 'ºC'),
	(144845, 118, '2014-01-15 00:49:01.000000', 'temperatura', 843.0000, 'ºC'),
	(144846, 118, '2014-01-15 00:49:02.000000', 'temperatura', 257.0000, 'ºC'),
	(144847, 118, '2014-01-15 00:49:03.000000', 'temperatura', 1155.0000, 'ºC'),
	(144848, 118, '2014-01-15 00:49:04.000000', 'temperatura', 204.0000, 'ºC'),
	(144849, 118, '2014-01-15 00:49:05.000000', 'temperatura', 1155.0000, 'ºC'),
	(144850, 118, '2014-01-15 00:49:06.000000', 'temperatura', 364.0000, 'ºC'),
	(144851, 118, '2014-01-15 00:49:07.000000', 'temperatura', 754.0000, 'ºC'),
	(144852, 118, '2014-01-15 00:49:08.000000', 'temperatura', 280.0000, 'ºC'),
	(144853, 118, '2014-01-15 00:49:09.000000', 'temperatura', 337.0000, 'ºC'),
	(144854, 118, '2014-01-15 00:49:10.000000', 'temperatura', 844.0000, 'ºC'),
	(144855, 118, '2014-01-15 00:49:11.000000', 'temperatura', 812.0000, 'ºC'),
	(144856, 118, '2014-01-15 00:49:12.000000', 'temperatura', 328.0000, 'ºC'),
	(144857, 118, '2014-01-15 00:49:13.000000', 'temperatura', 406.0000, 'ºC'),
	(144858, 118, '2014-01-15 00:49:14.000000', 'temperatura', 1044.0000, 'ºC'),
	(144859, 118, '2014-01-15 00:49:15.000000', 'temperatura', 405.0000, 'ºC'),
	(144860, 118, '2014-01-15 00:49:16.000000', 'temperatura', 92.0000, 'ºC'),
	(144861, 118, '2014-01-15 00:49:17.000000', 'temperatura', 444.0000, 'ºC'),
	(144862, 118, '2014-01-15 00:49:18.000000', 'temperatura', 746.0000, 'ºC'),
	(144863, 118, '2014-01-15 00:49:19.000000', 'temperatura', 1197.0000, 'ºC'),
	(144864, 118, '2014-01-15 00:49:20.000000', 'temperatura', 150.0000, 'ºC'),
	(144865, 118, '2014-01-15 00:49:21.000000', 'temperatura', 760.0000, 'ºC'),
	(144866, 118, '2014-01-15 00:49:22.000000', 'temperatura', 950.0000, 'ºC'),
	(144867, 118, '2014-01-15 00:49:23.000000', 'temperatura', 71.0000, 'ºC'),
	(144868, 118, '2014-01-15 00:49:24.000000', 'temperatura', 1106.0000, 'ºC'),
	(144869, 118, '2014-01-15 00:49:25.000000', 'temperatura', 518.0000, 'ºC'),
	(144870, 118, '2014-01-15 00:49:26.000000', 'temperatura', 471.0000, 'ºC'),
	(144871, 118, '2014-01-15 00:49:27.000000', 'temperatura', 800.0000, 'ºC'),
	(144872, 118, '2014-01-15 00:49:28.000000', 'temperatura', 191.0000, 'ºC'),
	(144873, 118, '2014-01-15 00:49:29.000000', 'temperatura', 953.0000, 'ºC'),
	(144874, 118, '2014-01-15 00:49:30.000000', 'temperatura', 592.0000, 'ºC'),
	(144875, 118, '2014-01-15 00:49:31.000000', 'temperatura', 104.0000, 'ºC'),
	(144876, 118, '2014-01-15 00:49:32.000000', 'temperatura', 1142.0000, 'ºC'),
	(144877, 118, '2014-01-15 00:49:33.000000', 'temperatura', 598.0000, 'ºC'),
	(144878, 118, '2014-01-15 00:49:34.000000', 'temperatura', 767.0000, 'ºC'),
	(144879, 118, '2014-01-15 00:49:35.000000', 'temperatura', 842.0000, 'ºC'),
	(144880, 118, '2014-01-15 00:49:36.000000', 'temperatura', 710.0000, 'ºC'),
	(144881, 118, '2014-01-15 00:49:37.000000', 'temperatura', 1023.0000, 'ºC'),
	(144882, 118, '2014-01-15 00:49:38.000000', 'temperatura', 587.0000, 'ºC'),
	(144883, 118, '2014-01-15 00:49:39.000000', 'temperatura', 1064.0000, 'ºC'),
	(144884, 118, '2014-01-15 00:49:40.000000', 'temperatura', 1159.0000, 'ºC'),
	(144885, 118, '2014-01-15 00:49:41.000000', 'temperatura', 204.0000, 'ºC'),
	(144886, 118, '2014-01-15 00:49:42.000000', 'temperatura', 1145.0000, 'ºC'),
	(144887, 118, '2014-01-15 00:49:43.000000', 'temperatura', 311.0000, 'ºC'),
	(144888, 118, '2014-01-15 00:49:44.000000', 'temperatura', 521.0000, 'ºC'),
	(144889, 118, '2014-01-15 00:49:45.000000', 'temperatura', 475.0000, 'ºC'),
	(144890, 118, '2014-01-15 00:49:46.000000', 'temperatura', 809.0000, 'ºC'),
	(144891, 118, '2014-01-15 00:49:47.000000', 'temperatura', 222.0000, 'ºC'),
	(144892, 118, '2014-01-15 00:49:48.000000', 'temperatura', 1085.0000, 'ºC'),
	(144893, 118, '2014-01-15 00:49:49.000000', 'temperatura', 1158.0000, 'ºC'),
	(144894, 118, '2014-01-15 00:49:50.000000', 'temperatura', 136.0000, 'ºC'),
	(144895, 118, '2014-01-15 00:49:51.000000', 'temperatura', 804.0000, 'ºC'),
	(144896, 118, '2014-01-15 00:49:52.000000', 'temperatura', 16.0000, 'ºC'),
	(144897, 118, '2014-01-15 00:49:53.000000', 'temperatura', 68.0000, 'ºC'),
	(144898, 118, '2014-01-15 00:49:54.000000', 'temperatura', 294.0000, 'ºC'),
	(144899, 118, '2014-01-15 00:49:55.000000', 'temperatura', 64.0000, 'ºC'),
	(144900, 118, '2014-01-15 00:49:56.000000', 'temperatura', 641.0000, 'ºC'),
	(144901, 118, '2014-01-15 00:49:57.000000', 'temperatura', 612.0000, 'ºC'),
	(144902, 118, '2014-01-15 00:49:58.000000', 'temperatura', 1140.0000, 'ºC'),
	(144903, 118, '2014-01-15 00:49:59.000000', 'temperatura', 261.0000, 'ºC'),
	(144904, 118, '2014-01-15 00:50:00.000000', 'temperatura', 289.0000, 'ºC'),
	(144905, 118, '2014-01-15 00:50:01.000000', 'temperatura', 660.0000, 'ºC'),
	(144906, 118, '2014-01-15 00:50:02.000000', 'temperatura', 33.0000, 'ºC'),
	(144907, 118, '2014-01-15 00:50:03.000000', 'temperatura', 586.0000, 'ºC'),
	(144908, 118, '2014-01-15 00:50:04.000000', 'temperatura', 431.0000, 'ºC'),
	(144909, 118, '2014-01-15 00:50:05.000000', 'temperatura', 398.0000, 'ºC'),
	(144910, 118, '2014-01-15 00:50:06.000000', 'temperatura', 697.0000, 'ºC'),
	(144911, 118, '2014-01-15 00:50:07.000000', 'temperatura', 1092.0000, 'ºC'),
	(144912, 118, '2014-01-15 00:50:08.000000', 'temperatura', 968.0000, 'ºC'),
	(144913, 118, '2014-01-15 00:50:09.000000', 'temperatura', 364.0000, 'ºC'),
	(144914, 118, '2014-01-15 00:50:10.000000', 'temperatura', 116.0000, 'ºC'),
	(144915, 118, '2014-01-15 00:50:11.000000', 'temperatura', 689.0000, 'ºC'),
	(144916, 118, '2014-01-15 00:50:12.000000', 'temperatura', 698.0000, 'ºC'),
	(144917, 118, '2014-01-15 00:50:13.000000', 'temperatura', 225.0000, 'ºC'),
	(144918, 118, '2014-01-15 00:50:14.000000', 'temperatura', 229.0000, 'ºC'),
	(144919, 118, '2014-01-15 00:50:15.000000', 'temperatura', 473.0000, 'ºC'),
	(144920, 118, '2014-01-15 00:50:16.000000', 'temperatura', 475.0000, 'ºC'),
	(144921, 118, '2014-01-15 00:50:17.000000', 'temperatura', 960.0000, 'ºC'),
	(144922, 118, '2014-01-15 00:50:18.000000', 'temperatura', 974.0000, 'ºC'),
	(144923, 118, '2014-01-15 00:50:19.000000', 'temperatura', 791.0000, 'ºC'),
	(144924, 118, '2014-01-15 00:50:20.000000', 'temperatura', 1034.0000, 'ºC'),
	(144925, 118, '2014-01-15 00:50:21.000000', 'temperatura', 398.0000, 'ºC'),
	(144926, 118, '2014-01-15 00:50:22.000000', 'temperatura', 87.0000, 'ºC'),
	(144927, 118, '2014-01-15 00:50:23.000000', 'temperatura', 441.0000, 'ºC'),
	(144928, 118, '2014-01-15 00:50:24.000000', 'temperatura', 747.0000, 'ºC'),
	(144929, 118, '2014-01-15 00:50:25.000000', 'temperatura', 10.0000, 'ºC'),
	(144930, 118, '2014-01-15 00:50:26.000000', 'temperatura', 209.0000, 'ºC'),
	(144931, 118, '2014-01-15 00:50:27.000000', 'temperatura', 1018.0000, 'ºC'),
	(144932, 118, '2014-01-15 00:50:28.000000', 'temperatura', 861.0000, 'ºC'),
	(144933, 118, '2014-01-15 00:50:29.000000', 'temperatura', 52.0000, 'ºC'),
	(144934, 118, '2014-01-15 00:50:30.000000', 'temperatura', 78.0000, 'ºC'),
	(144935, 118, '2014-01-15 00:50:31.000000', 'temperatura', 235.0000, 'ºC'),
	(144936, 118, '2014-01-15 00:50:32.000000', 'temperatura', 941.0000, 'ºC'),
	(144937, 118, '2014-01-15 00:50:33.000000', 'temperatura', 400.0000, 'ºC'),
	(144938, 118, '2014-01-15 00:50:34.000000', 'temperatura', 376.0000, 'ºC'),
	(144939, 118, '2014-01-15 00:50:35.000000', 'temperatura', 683.0000, 'ºC'),
	(144940, 118, '2014-01-15 00:50:36.000000', 'temperatura', 1088.0000, 'ºC'),
	(144941, 118, '2014-01-15 00:50:37.000000', 'temperatura', 989.0000, 'ºC'),
	(144942, 118, '2014-01-15 00:50:38.000000', 'temperatura', 485.0000, 'ºC'),
	(144943, 118, '2014-01-15 00:50:39.000000', 'temperatura', 655.0000, 'ºC'),
	(144944, 118, '2014-01-15 00:50:40.000000', 'temperatura', 623.0000, 'ºC'),
	(144945, 118, '2014-01-15 00:50:41.000000', 'temperatura', 1152.0000, 'ºC'),
	(144946, 118, '2014-01-15 00:50:42.000000', 'temperatura', 288.0000, 'ºC'),
	(144947, 118, '2014-01-15 00:50:43.000000', 'temperatura', 387.0000, 'ºC'),
	(144948, 118, '2014-01-15 00:50:44.000000', 'temperatura', 1072.0000, 'ºC'),
	(144949, 118, '2014-01-15 00:50:45.000000', 'temperatura', 600.0000, 'ºC'),
	(144950, 118, '2014-01-15 00:50:46.000000', 'temperatura', 985.0000, 'ºC'),
	(144951, 118, '2014-01-15 00:50:47.000000', 'temperatura', 726.0000, 'ºC'),
	(144952, 118, '2014-01-15 00:50:48.000000', 'temperatura', 675.0000, 'ºC'),
	(144953, 118, '2014-01-15 00:50:49.000000', 'temperatura', 1199.0000, 'ºC'),
	(144954, 118, '2014-01-15 00:50:50.000000', 'temperatura', 370.0000, 'ºC'),
	(144955, 118, '2014-01-15 00:50:51.000000', 'temperatura', 651.0000, 'ºC'),
	(144956, 118, '2014-01-15 00:50:52.000000', 'temperatura', 948.0000, 'ºC'),
	(144957, 118, '2014-01-15 00:50:53.000000', 'temperatura', 385.0000, 'ºC'),
	(144958, 118, '2014-01-15 00:50:54.000000', 'temperatura', 281.0000, 'ºC'),
	(144959, 118, '2014-01-15 00:50:55.000000', 'temperatura', 251.0000, 'ºC'),
	(144960, 118, '2014-01-15 00:50:56.000000', 'temperatura', 415.0000, 'ºC'),
	(144961, 118, '2014-01-15 00:50:57.000000', 'temperatura', 120.0000, 'ºC'),
	(144962, 118, '2014-01-15 00:50:58.000000', 'temperatura', 555.0000, 'ºC'),
	(144963, 118, '2014-01-15 00:50:59.000000', 'temperatura', 16.0000, 'ºC'),
	(144964, 118, '2014-01-15 00:51:00.000000', 'temperatura', 817.0000, 'ºC'),
	(144965, 118, '2014-01-15 00:51:01.000000', 'temperatura', 437.0000, 'ºC'),
	(144966, 118, '2014-01-15 00:51:02.000000', 'temperatura', 936.0000, 'ºC'),
	(144967, 118, '2014-01-15 00:51:03.000000', 'temperatura', 970.0000, 'ºC'),
	(144968, 118, '2014-01-15 00:51:04.000000', 'temperatura', 841.0000, 'ºC'),
	(144969, 118, '2014-01-15 00:51:05.000000', 'temperatura', 95.0000, 'ºC'),
	(144970, 118, '2014-01-15 00:51:06.000000', 'temperatura', 354.0000, 'ºC'),
	(144971, 118, '2014-01-15 00:51:07.000000', 'temperatura', 284.0000, 'ºC'),
	(144972, 118, '2014-01-15 00:51:08.000000', 'temperatura', 359.0000, 'ºC'),
	(144973, 118, '2014-01-15 00:51:09.000000', 'temperatura', 943.0000, 'ºC'),
	(144974, 118, '2014-01-15 00:51:10.000000', 'temperatura', 39.0000, 'ºC'),
	(144975, 118, '2014-01-15 00:51:11.000000', 'temperatura', 965.0000, 'ºC'),
	(144976, 118, '2014-01-15 00:51:12.000000', 'temperatura', 1109.0000, 'ºC'),
	(144977, 118, '2014-01-15 00:51:13.000000', 'temperatura', 251.0000, 'ºC'),
	(144978, 118, '2014-01-15 00:51:14.000000', 'temperatura', 326.0000, 'ºC'),
	(144979, 118, '2014-01-15 00:51:15.000000', 'temperatura', 880.0000, 'ºC'),
	(144980, 118, '2014-01-15 00:51:16.000000', 'temperatura', 1024.0000, 'ºC'),
	(144981, 118, '2014-01-15 00:51:17.000000', 'temperatura', 79.0000, 'ºC'),
	(144982, 118, '2014-01-15 00:51:18.000000', 'temperatura', 922.0000, 'ºC'),
	(144983, 118, '2014-01-15 00:51:19.000000', 'temperatura', 775.0000, 'ºC'),
	(144984, 118, '2014-01-15 00:51:20.000000', 'temperatura', 1109.0000, 'ºC'),
	(144985, 118, '2014-01-15 00:51:21.000000', 'temperatura', 819.0000, 'ºC'),
	(144986, 118, '2014-01-15 00:51:22.000000', 'temperatura', 768.0000, 'ºC'),
	(144987, 118, '2014-01-15 00:51:23.000000', 'temperatura', 186.0000, 'ºC'),
	(144988, 118, '2014-01-15 00:51:24.000000', 'temperatura', 1026.0000, 'ºC'),
	(144989, 118, '2014-01-15 00:51:25.000000', 'temperatura', 972.0000, 'ºC'),
	(144990, 118, '2014-01-15 00:51:26.000000', 'temperatura', 584.0000, 'ºC'),
	(144991, 118, '2014-01-15 00:51:27.000000', 'temperatura', 2.0000, 'ºC'),
	(144992, 118, '2014-01-15 00:51:28.000000', 'temperatura', 662.0000, 'ºC'),
	(144993, 118, '2014-01-15 00:51:29.000000', 'temperatura', 902.0000, 'ºC'),
	(144994, 118, '2014-01-15 00:51:30.000000', 'temperatura', 123.0000, 'ºC'),
	(144995, 118, '2014-01-15 00:51:31.000000', 'temperatura', 312.0000, 'ºC'),
	(144996, 118, '2014-01-15 00:51:32.000000', 'temperatura', 1191.0000, 'ºC'),
	(144997, 118, '2014-01-15 00:51:33.000000', 'temperatura', 221.0000, 'ºC'),
	(144998, 118, '2014-01-15 00:51:34.000000', 'temperatura', 1130.0000, 'ºC'),
	(144999, 118, '2014-01-15 00:51:35.000000', 'temperatura', 187.0000, 'ºC'),
	(145000, 118, '2014-01-15 00:51:36.000000', 'temperatura', 1148.0000, 'ºC'),
	(145001, 118, '2014-01-15 00:51:37.000000', 'temperatura', 377.0000, 'ºC'),
	(145002, 118, '2014-01-15 00:51:38.000000', 'temperatura', 841.0000, 'ºC'),
	(145003, 118, '2014-01-15 00:51:39.000000', 'temperatura', 676.0000, 'ºC'),
	(145004, 118, '2014-01-15 00:51:40.000000', 'temperatura', 856.0000, 'ºC'),
	(145005, 118, '2014-01-15 00:51:41.000000', 'temperatura', 1055.0000, 'ºC'),
	(145006, 118, '2014-01-15 00:51:42.000000', 'temperatura', 306.0000, 'ºC'),
	(145007, 118, '2014-01-15 00:51:43.000000', 'temperatura', 764.0000, 'ºC'),
	(145008, 118, '2014-01-15 00:51:44.000000', 'temperatura', 502.0000, 'ºC'),
	(145009, 118, '2014-01-15 00:51:45.000000', 'temperatura', 221.0000, 'ºC'),
	(145010, 118, '2014-01-15 00:51:46.000000', 'temperatura', 799.0000, 'ºC'),
	(145011, 118, '2014-01-15 00:51:47.000000', 'temperatura', 933.0000, 'ºC'),
	(145012, 118, '2014-01-15 00:51:48.000000', 'temperatura', 1067.0000, 'ºC'),
	(145013, 118, '2014-01-15 00:51:49.000000', 'temperatura', 139.0000, 'ºC'),
	(145014, 118, '2014-01-15 00:51:50.000000', 'temperatura', 1093.0000, 'ºC'),
	(145015, 118, '2014-01-15 00:51:51.000000', 'temperatura', 247.0000, 'ºC'),
	(145016, 118, '2014-01-15 00:51:52.000000', 'temperatura', 357.0000, 'ºC'),
	(145017, 118, '2014-01-15 00:51:53.000000', 'temperatura', 1047.0000, 'ºC'),
	(145018, 118, '2014-01-15 00:51:54.000000', 'temperatura', 561.0000, 'ºC'),
	(145019, 118, '2014-01-15 00:51:55.000000', 'temperatura', 866.0000, 'ºC'),
	(145020, 118, '2014-01-15 00:51:56.000000', 'temperatura', 249.0000, 'ºC'),
	(145021, 118, '2014-01-15 00:51:57.000000', 'temperatura', 1046.0000, 'ºC'),
	(145022, 118, '2014-01-15 00:51:58.000000', 'temperatura', 883.0000, 'ºC'),
	(145023, 118, '2014-01-15 00:51:59.000000', 'temperatura', 78.0000, 'ºC'),
	(145024, 118, '2014-01-15 00:52:00.000000', 'temperatura', 140.0000, 'ºC'),
	(145025, 118, '2014-01-15 00:52:01.000000', 'temperatura', 470.0000, 'ºC'),
	(145026, 118, '2014-01-15 00:52:02.000000', 'temperatura', 727.0000, 'ºC'),
	(145027, 118, '2014-01-15 00:52:03.000000', 'temperatura', 1027.0000, 'ºC'),
	(145028, 118, '2014-01-15 00:52:04.000000', 'temperatura', 553.0000, 'ºC'),
	(145029, 118, '2014-01-15 00:52:05.000000', 'temperatura', 887.0000, 'ºC'),
	(145030, 118, '2014-01-15 00:52:06.000000', 'temperatura', 376.0000, 'ºC'),
	(145031, 118, '2014-01-15 00:52:07.000000', 'temperatura', 419.0000, 'ºC'),
	(145032, 118, '2014-01-15 00:52:08.000000', 'temperatura', 968.0000, 'ºC'),
	(145033, 118, '2014-01-15 00:52:09.000000', 'temperatura', 1185.0000, 'ºC'),
	(145034, 118, '2014-01-15 00:52:10.000000', 'temperatura', 620.0000, 'ºC'),
	(145035, 118, '2014-01-15 00:52:11.000000', 'temperatura', 744.0000, 'ºC'),
	(145036, 118, '2014-01-15 00:52:12.000000', 'temperatura', 663.0000, 'ºC'),
	(145037, 118, '2014-01-15 00:52:13.000000', 'temperatura', 1082.0000, 'ºC'),
	(145038, 118, '2014-01-15 00:52:14.000000', 'temperatura', 1020.0000, 'ºC'),
	(145039, 118, '2014-01-15 00:52:15.000000', 'temperatura', 657.0000, 'ºC'),
	(145040, 118, '2014-01-15 00:52:16.000000', 'temperatura', 223.0000, 'ºC'),
	(145041, 118, '2014-01-15 00:52:17.000000', 'temperatura', 347.0000, 'ºC'),
	(145042, 118, '2014-01-15 00:52:18.000000', 'temperatura', 1065.0000, 'ºC'),
	(145043, 118, '2014-01-15 00:52:19.000000', 'temperatura', 686.0000, 'ºC'),
	(145044, 118, '2014-01-15 00:52:20.000000', 'temperatura', 235.0000, 'ºC'),
	(145045, 118, '2014-01-15 00:52:21.000000', 'temperatura', 316.0000, 'ºC'),
	(145046, 118, '2014-01-15 00:52:22.000000', 'temperatura', 875.0000, 'ºC'),
	(145047, 118, '2014-01-15 00:52:23.000000', 'temperatura', 1027.0000, 'ºC'),
	(145048, 118, '2014-01-15 00:52:24.000000', 'temperatura', 113.0000, 'ºC'),
	(145049, 118, '2014-01-15 00:52:25.000000', 'temperatura', 1084.0000, 'ºC'),
	(145050, 118, '2014-01-15 00:52:26.000000', 'temperatura', 281.0000, 'ºC'),
	(145051, 118, '2014-01-15 00:52:27.000000', 'temperatura', 554.0000, 'ºC'),
	(145052, 118, '2014-01-15 00:52:28.000000', 'temperatura', 725.0000, 'ºC'),
	(145053, 118, '2014-01-15 00:52:29.000000', 'temperatura', 767.0000, 'ºC'),
	(145054, 118, '2014-01-15 00:52:30.000000', 'temperatura', 458.0000, 'ºC'),
	(145055, 118, '2014-01-15 00:52:31.000000', 'temperatura', 1189.0000, 'ºC'),
	(145056, 118, '2014-01-15 00:52:32.000000', 'temperatura', 973.0000, 'ºC'),
	(145057, 118, '2014-01-15 00:52:33.000000', 'temperatura', 96.0000, 'ºC'),
	(145058, 118, '2014-01-15 00:52:34.000000', 'temperatura', 1164.0000, 'ºC'),
	(145059, 118, '2014-01-15 00:52:35.000000', 'temperatura', 732.0000, 'ºC'),
	(145060, 118, '2014-01-15 00:52:36.000000', 'temperatura', 170.0000, 'ºC'),
	(145061, 118, '2014-01-15 00:52:37.000000', 'temperatura', 1052.0000, 'ºC'),
	(145062, 118, '2014-01-15 00:52:38.000000', 'temperatura', 1151.0000, 'ºC'),
	(145063, 118, '2014-01-15 00:52:39.000000', 'temperatura', 201.0000, 'ºC'),
	(145064, 118, '2014-01-15 00:52:40.000000', 'temperatura', 1152.0000, 'ºC'),
	(145065, 118, '2014-01-15 00:52:41.000000', 'temperatura', 359.0000, 'ºC'),
	(145066, 118, '2014-01-15 00:52:42.000000', 'temperatura', 739.0000, 'ºC'),
	(145067, 118, '2014-01-15 00:52:43.000000', 'temperatura', 220.0000, 'ºC'),
	(145068, 118, '2014-01-15 00:52:44.000000', 'temperatura', 82.0000, 'ºC'),
	(145069, 118, '2014-01-15 00:52:45.000000', 'temperatura', 950.0000, 'ºC'),
	(145070, 118, '2014-01-15 00:52:46.000000', 'temperatura', 906.0000, 'ºC'),
	(145071, 118, '2014-01-15 00:52:47.000000', 'temperatura', 482.0000, 'ºC'),
	(145072, 118, '2014-01-15 00:52:48.000000', 'temperatura', 890.0000, 'ºC'),
	(145073, 118, '2014-01-15 00:52:49.000000', 'temperatura', 604.0000, 'ºC'),
	(145074, 118, '2014-01-15 00:52:50.000000', 'temperatura', 352.0000, 'ºC'),
	(145075, 118, '2014-01-15 00:52:51.000000', 'temperatura', 1148.0000, 'ºC'),
	(145076, 118, '2014-01-15 00:52:52.000000', 'temperatura', 1084.0000, 'ºC'),
	(145077, 118, '2014-01-15 00:52:53.000000', 'temperatura', 779.0000, 'ºC'),
	(145078, 118, '2014-01-15 00:52:54.000000', 'temperatura', 640.0000, 'ºC'),
	(145079, 118, '2014-01-15 00:52:55.000000', 'temperatura', 866.0000, 'ºC'),
	(145080, 118, '2014-01-15 00:52:56.000000', 'temperatura', 8.0000, 'ºC'),
	(145081, 118, '2014-01-15 00:52:57.000000', 'temperatura', 1043.0000, 'ºC'),
	(145082, 118, '2014-01-15 00:52:58.000000', 'temperatura', 392.0000, 'ºC'),
	(145083, 118, '2014-01-15 00:52:59.000000', 'temperatura', 32.0000, 'ºC'),
	(145084, 118, '2014-01-15 00:53:00.000000', 'temperatura', 186.0000, 'ºC'),
	(145085, 118, '2014-01-15 00:53:01.000000', 'temperatura', 832.0000, 'ºC'),
	(145086, 118, '2014-01-15 00:53:02.000000', 'temperatura', 3.0000, 'ºC'),
	(145087, 118, '2014-01-15 00:53:03.000000', 'temperatura', 1119.0000, 'ºC'),
	(145088, 118, '2014-01-15 00:53:04.000000', 'temperatura', 788.0000, 'ºC'),
	(145089, 118, '2014-01-15 00:53:05.000000', 'temperatura', 582.0000, 'ºC'),
	(145090, 118, '2014-01-15 00:53:06.000000', 'temperatura', 547.0000, 'ºC'),
	(145091, 118, '2014-01-15 00:53:07.000000', 'temperatura', 988.0000, 'ºC'),
	(145092, 118, '2014-01-15 00:53:08.000000', 'temperatura', 901.0000, 'ºC'),
	(145093, 118, '2014-01-15 00:53:09.000000', 'temperatura', 341.0000, 'ºC'),
	(145094, 118, '2014-01-15 00:53:10.000000', 'temperatura', 203.0000, 'ºC'),
	(145095, 118, '2014-01-15 00:53:11.000000', 'temperatura', 1192.0000, 'ºC'),
	(145096, 118, '2014-01-15 00:53:12.000000', 'temperatura', 551.0000, 'ºC'),
	(145097, 118, '2014-01-15 00:53:13.000000', 'temperatura', 379.0000, 'ºC'),
	(145098, 118, '2014-01-15 00:53:14.000000', 'temperatura', 243.0000, 'ºC'),
	(145099, 118, '2014-01-15 00:53:15.000000', 'temperatura', 79.0000, 'ºC'),
	(145100, 118, '2014-01-15 00:53:16.000000', 'temperatura', 867.0000, 'ºC'),
	(145101, 118, '2014-01-15 00:53:17.000000', 'temperatura', 499.0000, 'ºC'),
	(145102, 118, '2014-01-15 00:53:18.000000', 'temperatura', 1095.0000, 'ºC'),
	(145103, 118, '2014-01-15 00:53:19.000000', 'temperatura', 376.0000, 'ºC'),
	(145104, 118, '2014-01-15 00:53:20.000000', 'temperatura', 997.0000, 'ºC'),
	(145105, 118, '2014-01-15 00:53:21.000000', 'temperatura', 258.0000, 'ºC'),
	(145106, 118, '2014-01-15 00:53:22.000000', 'temperatura', 701.0000, 'ºC'),
	(145107, 118, '2014-01-15 00:53:23.000000', 'temperatura', 329.0000, 'ºC'),
	(145108, 118, '2014-01-15 00:53:24.000000', 'temperatura', 741.0000, 'ºC'),
	(145109, 118, '2014-01-15 00:53:25.000000', 'temperatura', 321.0000, 'ºC'),
	(145110, 118, '2014-01-15 00:53:26.000000', 'temperatura', 583.0000, 'ºC'),
	(145111, 118, '2014-01-15 00:53:27.000000', 'temperatura', 751.0000, 'ºC'),
	(145112, 118, '2014-01-15 00:53:28.000000', 'temperatura', 809.0000, 'ºC'),
	(145113, 118, '2014-01-15 00:53:29.000000', 'temperatura', 590.0000, 'ºC'),
	(145114, 118, '2014-01-15 00:53:30.000000', 'temperatura', 523.0000, 'ºC'),
	(145115, 118, '2014-01-15 00:53:31.000000', 'temperatura', 846.0000, 'ºC'),
	(145116, 118, '2014-01-15 00:53:32.000000', 'temperatura', 262.0000, 'ºC'),
	(145117, 118, '2014-01-15 00:53:33.000000', 'temperatura', 1173.0000, 'ºC'),
	(145118, 118, '2014-01-15 00:53:34.000000', 'temperatura', 279.0000, 'ºC'),
	(145119, 118, '2014-01-15 00:53:35.000000', 'temperatura', 277.0000, 'ºC'),
	(145120, 118, '2014-01-15 00:53:36.000000', 'temperatura', 547.0000, 'ºC'),
	(145121, 118, '2014-01-15 00:53:37.000000', 'temperatura', 706.0000, 'ºC'),
	(145122, 118, '2014-01-15 00:53:38.000000', 'temperatura', 688.0000, 'ºC'),
	(145123, 118, '2014-01-15 00:53:39.000000', 'temperatura', 123.0000, 'ºC'),
	(145124, 118, '2014-01-15 00:53:40.000000', 'temperatura', 952.0000, 'ºC'),
	(145125, 118, '2014-01-15 00:53:41.000000', 'temperatura', 790.0000, 'ºC'),
	(145126, 118, '2014-01-15 00:53:42.000000', 'temperatura', 1095.0000, 'ºC'),
	(145127, 118, '2014-01-15 00:53:43.000000', 'temperatura', 705.0000, 'ºC'),
	(145128, 118, '2014-01-15 00:53:44.000000', 'temperatura', 242.0000, 'ºC'),
	(145129, 118, '2014-01-15 00:53:45.000000', 'temperatura', 297.0000, 'ºC'),
	(145130, 118, '2014-01-15 00:53:46.000000', 'temperatura', 757.0000, 'ºC'),
	(145131, 118, '2014-01-15 00:53:47.000000', 'temperatura', 496.0000, 'ºC'),
	(145132, 118, '2014-01-15 00:53:48.000000', 'temperatura', 207.0000, 'ºC'),
	(145133, 118, '2014-01-15 00:53:49.000000', 'temperatura', 750.0000, 'ºC'),
	(145134, 118, '2014-01-15 00:53:50.000000', 'temperatura', 727.0000, 'ºC'),
	(145135, 118, '2014-01-15 00:53:51.000000', 'temperatura', 188.0000, 'ºC'),
	(145136, 118, '2014-01-15 00:53:52.000000', 'temperatura', 1157.0000, 'ºC'),
	(145137, 118, '2014-01-15 00:53:53.000000', 'temperatura', 423.0000, 'ºC'),
	(145138, 118, '2014-01-15 00:53:54.000000', 'temperatura', 1042.0000, 'ºC'),
	(145139, 118, '2014-01-15 00:53:55.000000', 'temperatura', 344.0000, 'ºC'),
	(145140, 118, '2014-01-15 00:53:56.000000', 'temperatura', 995.0000, 'ºC'),
	(145141, 118, '2014-01-15 00:53:57.000000', 'temperatura', 341.0000, 'ºC'),
	(145142, 118, '2014-01-15 00:53:58.000000', 'temperatura', 1124.0000, 'ºC'),
	(145143, 118, '2014-01-15 00:53:59.000000', 'temperatura', 995.0000, 'ºC'),
	(145144, 118, '2014-01-15 00:54:00.000000', 'temperatura', 403.0000, 'ºC'),
	(145145, 118, '2014-01-15 00:54:01.000000', 'temperatura', 233.0000, 'ºC'),
	(145146, 118, '2014-01-15 00:54:02.000000', 'temperatura', 1155.0000, 'ºC'),
	(145147, 118, '2014-01-15 00:54:03.000000', 'temperatura', 276.0000, 'ºC'),
	(145148, 118, '2014-01-15 00:54:04.000000', 'temperatura', 318.0000, 'ºC'),
	(145149, 118, '2014-01-15 00:54:05.000000', 'temperatura', 761.0000, 'ºC'),
	(145150, 118, '2014-01-15 00:54:06.000000', 'temperatura', 453.0000, 'ºC'),
	(145151, 118, '2014-01-15 00:54:07.000000', 'temperatura', 1181.0000, 'ºC'),
	(145152, 118, '2014-01-15 00:54:08.000000', 'temperatura', 945.0000, 'ºC'),
	(145153, 118, '2014-01-15 00:54:09.000000', 'temperatura', 1185.0000, 'ºC'),
	(145154, 118, '2014-01-15 00:54:10.000000', 'temperatura', 690.0000, 'ºC'),
	(145155, 118, '2014-01-15 00:54:11.000000', 'temperatura', 1094.0000, 'ºC'),
	(145156, 118, '2014-01-15 00:54:12.000000', 'temperatura', 1003.0000, 'ºC'),
	(145157, 118, '2014-01-15 00:54:13.000000', 'temperatura', 531.0000, 'ºC'),
	(145158, 118, '2014-01-15 00:54:14.000000', 'temperatura', 849.0000, 'ºC'),
	(145159, 118, '2014-01-15 00:54:15.000000', 'temperatura', 251.0000, 'ºC'),
	(145160, 118, '2014-01-15 00:54:16.000000', 'temperatura', 1109.0000, 'ºC'),
	(145161, 118, '2014-01-15 00:54:17.000000', 'temperatura', 1193.0000, 'ºC'),
	(145162, 118, '2014-01-15 00:54:18.000000', 'temperatura', 237.0000, 'ºC'),
	(145163, 118, '2014-01-15 00:54:19.000000', 'temperatura', 5.0000, 'ºC'),
	(145164, 118, '2014-01-15 00:54:20.000000', 'temperatura', 518.0000, 'ºC'),
	(145165, 118, '2014-01-15 00:54:21.000000', 'temperatura', 175.0000, 'ºC'),
	(145166, 118, '2014-01-15 00:54:22.000000', 'temperatura', 519.0000, 'ºC'),
	(145167, 118, '2014-01-15 00:54:23.000000', 'temperatura', 874.0000, 'ºC'),
	(145168, 118, '2014-01-15 00:54:24.000000', 'temperatura', 412.0000, 'ºC'),
	(145169, 118, '2014-01-15 00:54:25.000000', 'temperatura', 637.0000, 'ºC'),
	(145170, 118, '2014-01-15 00:54:26.000000', 'temperatura', 752.0000, 'ºC'),
	(145171, 118, '2014-01-15 00:54:27.000000', 'temperatura', 650.0000, 'ºC'),
	(145172, 118, '2014-01-15 00:54:28.000000', 'temperatura', 993.0000, 'ºC'),
	(145173, 118, '2014-01-15 00:54:29.000000', 'temperatura', 616.0000, 'ºC'),
	(145174, 118, '2014-01-15 00:54:30.000000', 'temperatura', 103.0000, 'ºC'),
	(145175, 118, '2014-01-15 00:54:31.000000', 'temperatura', 1065.0000, 'ºC'),
	(145176, 118, '2014-01-15 00:54:32.000000', 'temperatura', 217.0000, 'ºC'),
	(145177, 118, '2014-01-15 00:54:33.000000', 'temperatura', 292.0000, 'ºC'),
	(145178, 118, '2014-01-15 00:54:34.000000', 'temperatura', 808.0000, 'ºC'),
	(145179, 118, '2014-01-15 00:54:35.000000', 'temperatura', 767.0000, 'ºC'),
	(145180, 118, '2014-01-15 00:54:36.000000', 'temperatura', 208.0000, 'ºC'),
	(145181, 118, '2014-01-15 00:54:37.000000', 'temperatura', 1141.0000, 'ºC'),
	(145182, 118, '2014-01-15 00:54:38.000000', 'temperatura', 283.0000, 'ºC'),
	(145183, 118, '2014-01-15 00:54:39.000000', 'temperatura', 393.0000, 'ºC'),
	(145184, 118, '2014-01-15 00:54:40.000000', 'temperatura', 1117.0000, 'ºC'),
	(145185, 118, '2014-01-15 00:54:41.000000', 'temperatura', 804.0000, 'ºC'),
	(145186, 118, '2014-01-15 00:54:42.000000', 'temperatura', 671.0000, 'ºC'),
	(145187, 118, '2014-01-15 00:54:43.000000', 'temperatura', 941.0000, 'ºC'),
	(145188, 118, '2014-01-15 00:54:44.000000', 'temperatura', 296.0000, 'ºC'),
	(145189, 118, '2014-01-15 00:54:45.000000', 'temperatura', 1055.0000, 'ºC'),
	(145190, 118, '2014-01-15 00:54:46.000000', 'temperatura', 789.0000, 'ºC'),
	(145191, 118, '2014-01-15 00:54:47.000000', 'temperatura', 782.0000, 'ºC'),
	(145192, 118, '2014-01-15 00:54:48.000000', 'temperatura', 341.0000, 'ºC'),
	(145193, 118, '2014-01-15 00:54:49.000000', 'temperatura', 559.0000, 'ºC'),
	(145194, 118, '2014-01-15 00:54:50.000000', 'temperatura', 574.0000, 'ºC'),
	(145195, 118, '2014-01-15 00:54:51.000000', 'temperatura', 1195.0000, 'ºC'),
	(145196, 118, '2014-01-15 00:54:52.000000', 'temperatura', 651.0000, 'ºC'),
	(145197, 118, '2014-01-15 00:54:53.000000', 'temperatura', 870.0000, 'ºC'),
	(145198, 118, '2014-01-15 00:54:54.000000', 'temperatura', 1199.0000, 'ºC'),
	(145199, 118, '2014-01-15 00:54:55.000000', 'temperatura', 986.0000, 'ºC'),
	(145200, 118, '2014-01-15 00:54:56.000000', 'temperatura', 132.0000, 'ºC'),
	(145201, 118, '2014-01-15 00:54:57.000000', 'temperatura', 101.0000, 'ºC'),
	(145202, 118, '2014-01-15 00:54:58.000000', 'temperatura', 113.0000, 'ºC'),
	(145203, 118, '2014-01-15 00:54:59.000000', 'temperatura', 261.0000, 'ºC'),
	(145204, 118, '2014-01-15 00:55:00.000000', 'temperatura', 965.0000, 'ºC'),
	(145205, 118, '2014-01-15 00:55:01.000000', 'temperatura', 444.0000, 'ºC'),
	(145206, 118, '2014-01-15 00:55:02.000000', 'temperatura', 527.0000, 'ºC'),
	(145207, 118, '2014-01-15 00:55:03.000000', 'temperatura', 104.0000, 'ºC'),
	(145208, 118, '2014-01-15 00:55:04.000000', 'temperatura', 136.0000, 'ºC'),
	(145209, 118, '2014-01-15 00:55:05.000000', 'temperatura', 371.0000, 'ºC'),
	(145210, 118, '2014-01-15 00:55:06.000000', 'temperatura', 247.0000, 'ºC'),
	(145211, 118, '2014-01-15 00:55:07.000000', 'temperatura', 123.0000, 'ºC'),
	(145212, 118, '2014-01-15 00:55:08.000000', 'temperatura', 1072.0000, 'ºC'),
	(145213, 118, '2014-01-15 00:55:09.000000', 'temperatura', 193.0000, 'ºC'),
	(145214, 118, '2014-01-15 00:55:10.000000', 'temperatura', 149.0000, 'ºC'),
	(145215, 118, '2014-01-15 00:55:11.000000', 'temperatura', 167.0000, 'ºC'),
	(145216, 118, '2014-01-15 00:55:12.000000', 'temperatura', 388.0000, 'ºC'),
	(145217, 118, '2014-01-15 00:55:13.000000', 'temperatura', 240.0000, 'ºC'),
	(145218, 118, '2014-01-15 00:55:14.000000', 'temperatura', 35.0000, 'ºC'),
	(145219, 118, '2014-01-15 00:55:15.000000', 'temperatura', 657.0000, 'ºC'),
	(145220, 118, '2014-01-15 00:55:16.000000', 'temperatura', 782.0000, 'ºC'),
	(145221, 118, '2014-01-15 00:55:17.000000', 'temperatura', 739.0000, 'ºC'),
	(145222, 118, '2014-01-15 00:55:18.000000', 'temperatura', 149.0000, 'ºC'),
	(145223, 118, '2014-01-15 00:55:19.000000', 'temperatura', 930.0000, 'ºC'),
	(145224, 118, '2014-01-15 00:55:20.000000', 'temperatura', 602.0000, 'ºC'),
	(145225, 118, '2014-01-15 00:55:21.000000', 'temperatura', 220.0000, 'ºC'),
	(145226, 118, '2014-01-15 00:55:22.000000', 'temperatura', 495.0000, 'ºC'),
	(145227, 118, '2014-01-15 00:55:23.000000', 'temperatura', 615.0000, 'ºC'),
	(145228, 118, '2014-01-15 00:55:24.000000', 'temperatura', 391.0000, 'ºC'),
	(145229, 118, '2014-01-15 00:55:25.000000', 'temperatura', 110.0000, 'ºC'),
	(145230, 118, '2014-01-15 00:55:26.000000', 'temperatura', 579.0000, 'ºC'),
	(145231, 118, '2014-01-15 00:55:27.000000', 'temperatura', 163.0000, 'ºC'),
	(145232, 118, '2014-01-15 00:55:28.000000', 'temperatura', 281.0000, 'ºC'),
	(145233, 118, '2014-01-15 00:55:29.000000', 'temperatura', 916.0000, 'ºC'),
	(145234, 118, '2014-01-15 00:55:30.000000', 'temperatura', 139.0000, 'ºC'),
	(145235, 118, '2014-01-15 00:55:31.000000', 'temperatura', 347.0000, 'ºC'),
	(145236, 118, '2014-01-15 00:55:32.000000', 'temperatura', 117.0000, 'ºC'),
	(145237, 118, '2014-01-15 00:55:33.000000', 'temperatura', 744.0000, 'ºC'),
	(145238, 118, '2014-01-15 00:55:34.000000', 'temperatura', 972.0000, 'ºC'),
	(145239, 118, '2014-01-15 00:55:35.000000', 'temperatura', 228.0000, 'ºC'),
	(145240, 118, '2014-01-15 00:55:36.000000', 'temperatura', 623.0000, 'ºC'),
	(145241, 118, '2014-01-15 00:55:37.000000', 'temperatura', 33.0000, 'ºC'),
	(145242, 118, '2014-01-15 00:55:38.000000', 'temperatura', 695.0000, 'ºC'),
	(145243, 118, '2014-01-15 00:55:39.000000', 'temperatura', 977.0000, 'ºC'),
	(145244, 118, '2014-01-15 00:55:40.000000', 'temperatura', 401.0000, 'ºC'),
	(145245, 118, '2014-01-15 00:55:41.000000', 'temperatura', 276.0000, 'ºC'),
	(145246, 118, '2014-01-15 00:55:42.000000', 'temperatura', 175.0000, 'ºC'),
	(145247, 118, '2014-01-15 00:55:43.000000', 'temperatura', 50.0000, 'ºC'),
	(145248, 118, '2014-01-15 00:55:44.000000', 'temperatura', 925.0000, 'ºC'),
	(145249, 118, '2014-01-15 00:55:45.000000', 'temperatura', 874.0000, 'ºC'),
	(145250, 118, '2014-01-15 00:55:46.000000', 'temperatura', 396.0000, 'ºC'),
	(145251, 118, '2014-01-15 00:55:47.000000', 'temperatura', 558.0000, 'ºC'),
	(145252, 118, '2014-01-15 00:55:48.000000', 'temperatura', 403.0000, 'ºC'),
	(145253, 118, '2014-01-15 00:55:49.000000', 'temperatura', 339.0000, 'ºC'),
	(145254, 118, '2014-01-15 00:55:50.000000', 'temperatura', 490.0000, 'ºC'),
	(145255, 118, '2014-01-15 00:55:51.000000', 'temperatura', 232.0000, 'ºC'),
	(145256, 118, '2014-01-15 00:55:52.000000', 'temperatura', 891.0000, 'ºC'),
	(145257, 118, '2014-01-15 00:55:53.000000', 'temperatura', 160.0000, 'ºC'),
	(145258, 118, '2014-01-15 00:55:54.000000', 'temperatura', 525.0000, 'ºC'),
	(145259, 118, '2014-01-15 00:55:55.000000', 'temperatura', 948.0000, 'ºC'),
	(145260, 118, '2014-01-15 00:55:56.000000', 'temperatura', 765.0000, 'ºC'),
	(145261, 118, '2014-01-15 00:55:57.000000', 'temperatura', 982.0000, 'ºC'),
	(145262, 118, '2014-01-15 00:55:58.000000', 'temperatura', 214.0000, 'ºC'),
	(145263, 118, '2014-01-15 00:55:59.000000', 'temperatura', 525.0000, 'ºC'),
	(145264, 118, '2014-01-15 00:56:00.000000', 'temperatura', 784.0000, 'ºC'),
	(145265, 118, '2014-01-15 00:56:01.000000', 'temperatura', 1147.0000, 'ºC'),
	(145266, 118, '2014-01-15 00:56:02.000000', 'temperatura', 982.0000, 'ºC'),
	(145267, 118, '2014-01-15 00:56:03.000000', 'temperatura', 269.0000, 'ºC'),
	(145268, 118, '2014-01-15 00:56:04.000000', 'temperatura', 799.0000, 'ºC'),
	(145269, 118, '2014-01-15 00:56:05.000000', 'temperatura', 788.0000, 'ºC'),
	(145270, 118, '2014-01-15 00:56:06.000000', 'temperatura', 344.0000, 'ºC'),
	(145271, 118, '2014-01-15 00:56:07.000000', 'temperatura', 557.0000, 'ºC'),
	(145272, 118, '2014-01-15 00:56:08.000000', 'temperatura', 553.0000, 'ºC'),
	(145273, 118, '2014-01-15 00:56:09.000000', 'temperatura', 1095.0000, 'ºC'),
	(145274, 118, '2014-01-15 00:56:10.000000', 'temperatura', 216.0000, 'ºC'),
	(145275, 118, '2014-01-15 00:56:11.000000', 'temperatura', 197.0000, 'ºC'),
	(145276, 118, '2014-01-15 00:56:12.000000', 'temperatura', 335.0000, 'ºC'),
	(145277, 118, '2014-01-15 00:56:13.000000', 'temperatura', 1084.0000, 'ºC'),
	(145278, 118, '2014-01-15 00:56:14.000000', 'temperatura', 818.0000, 'ºC'),
	(145279, 118, '2014-01-15 00:56:15.000000', 'temperatura', 839.0000, 'ºC'),
	(145280, 118, '2014-01-15 00:56:16.000000', 'temperatura', 540.0000, 'ºC'),
	(145281, 118, '2014-01-15 00:56:17.000000', 'temperatura', 186.0000, 'ºC'),
	(145282, 118, '2014-01-15 00:56:18.000000', 'temperatura', 507.0000, 'ºC'),
	(145283, 118, '2014-01-15 00:56:19.000000', 'temperatura', 780.0000, 'ºC'),
	(145284, 118, '2014-01-15 00:56:20.000000', 'temperatura', 1180.0000, 'ºC'),
	(145285, 118, '2014-01-15 00:56:21.000000', 'temperatura', 1161.0000, 'ºC'),
	(145286, 118, '2014-01-15 00:56:22.000000', 'temperatura', 1063.0000, 'ºC'),
	(145287, 118, '2014-01-15 00:56:23.000000', 'temperatura', 633.0000, 'ºC'),
	(145288, 118, '2014-01-15 00:56:24.000000', 'temperatura', 1176.0000, 'ºC'),
	(145289, 118, '2014-01-15 00:56:25.000000', 'temperatura', 384.0000, 'ºC'),
	(145290, 118, '2014-01-15 00:56:26.000000', 'temperatura', 790.0000, 'ºC'),
	(145291, 118, '2014-01-15 00:56:27.000000', 'temperatura', 400.0000, 'ºC'),
	(145292, 118, '2014-01-15 00:56:28.000000', 'temperatura', 830.0000, 'ºC'),
	(145293, 118, '2014-01-15 00:56:29.000000', 'temperatura', 552.0000, 'ºC'),
	(145294, 118, '2014-01-15 00:56:30.000000', 'temperatura', 268.0000, 'ºC'),
	(145295, 118, '2014-01-15 00:56:31.000000', 'temperatura', 884.0000, 'ºC'),
	(145296, 118, '2014-01-15 00:56:32.000000', 'temperatura', 18.0000, 'ºC'),
	(145297, 118, '2014-01-15 00:56:33.000000', 'temperatura', 1038.0000, 'ºC'),
	(145298, 118, '2014-01-15 00:56:34.000000', 'temperatura', 336.0000, 'ºC'),
	(145299, 118, '2014-01-15 00:56:35.000000', 'temperatura', 966.0000, 'ºC'),
	(145300, 118, '2014-01-15 00:56:36.000000', 'temperatura', 225.0000, 'ºC'),
	(145301, 118, '2014-01-15 00:56:37.000000', 'temperatura', 625.0000, 'ºC'),
	(145302, 118, '2014-01-15 00:56:38.000000', 'temperatura', 53.0000, 'ºC'),
	(145303, 118, '2014-01-15 00:56:39.000000', 'temperatura', 788.0000, 'ºC'),
	(145304, 118, '2014-01-15 00:56:40.000000', 'temperatura', 181.0000, 'ºC'),
	(145305, 118, '2014-01-15 00:56:41.000000', 'temperatura', 944.0000, 'ºC'),
	(145306, 118, '2014-01-15 00:56:42.000000', 'temperatura', 577.0000, 'ºC'),
	(145307, 118, '2014-01-15 00:56:43.000000', 'temperatura', 54.0000, 'ºC'),
	(145308, 118, '2014-01-15 00:56:44.000000', 'temperatura', 937.0000, 'ºC'),
	(145309, 118, '2014-01-15 00:56:45.000000', 'temperatura', 925.0000, 'ºC'),
	(145310, 118, '2014-01-15 00:56:46.000000', 'temperatura', 613.0000, 'ºC'),
	(145311, 118, '2014-01-15 00:56:47.000000', 'temperatura', 291.0000, 'ºC'),
	(145312, 118, '2014-01-15 00:56:48.000000', 'temperatura', 818.0000, 'ºC'),
	(145313, 118, '2014-01-15 00:56:49.000000', 'temperatura', 815.0000, 'ºC'),
	(145314, 118, '2014-01-15 00:56:50.000000', 'temperatura', 425.0000, 'ºC'),
	(145315, 118, '2014-01-15 00:56:51.000000', 'temperatura', 878.0000, 'ºC'),
	(145316, 118, '2014-01-15 00:56:52.000000', 'temperatura', 716.0000, 'ºC'),
	(145317, 118, '2014-01-15 00:56:53.000000', 'temperatura', 946.0000, 'ºC'),
	(145318, 118, '2014-01-15 00:56:54.000000', 'temperatura', 183.0000, 'ºC'),
	(145319, 118, '2014-01-15 00:56:55.000000', 'temperatura', 477.0000, 'ºC'),
	(145320, 118, '2014-01-15 00:56:56.000000', 'temperatura', 638.0000, 'ºC'),
	(145321, 118, '2014-01-15 00:56:57.000000', 'temperatura', 561.0000, 'ºC'),
	(145322, 118, '2014-01-15 00:56:58.000000', 'temperatura', 888.0000, 'ºC'),
	(145323, 118, '2014-01-15 00:56:59.000000', 'temperatura', 359.0000, 'ºC'),
	(145324, 118, '2014-01-15 00:57:00.000000', 'temperatura', 331.0000, 'ºC'),
	(145325, 118, '2014-01-15 00:57:01.000000', 'temperatura', 580.0000, 'ºC'),
	(145326, 118, '2014-01-15 00:57:02.000000', 'temperatura', 708.0000, 'ºC'),
	(145327, 118, '2014-01-15 00:57:03.000000', 'temperatura', 600.0000, 'ºC'),
	(145328, 118, '2014-01-15 00:57:04.000000', 'temperatura', 877.0000, 'ºC'),
	(145329, 118, '2014-01-15 00:57:05.000000', 'temperatura', 185.0000, 'ºC'),
	(145330, 118, '2014-01-15 00:57:06.000000', 'temperatura', 694.0000, 'ºC'),
	(145331, 118, '2014-01-15 00:57:07.000000', 'temperatura', 515.0000, 'ºC'),
	(145332, 118, '2014-01-15 00:57:08.000000', 'temperatura', 495.0000, 'ºC'),
	(145333, 118, '2014-01-15 00:57:09.000000', 'temperatura', 930.0000, 'ºC'),
	(145334, 118, '2014-01-15 00:57:10.000000', 'temperatura', 766.0000, 'ºC'),
	(145335, 118, '2014-01-15 00:57:11.000000', 'temperatura', 1041.0000, 'ºC'),
	(145336, 118, '2014-01-15 00:57:12.000000', 'temperatura', 507.0000, 'ºC'),
	(145337, 118, '2014-01-15 00:57:13.000000', 'temperatura', 612.0000, 'ºC'),
	(145338, 118, '2014-01-15 00:57:14.000000', 'temperatura', 338.0000, 'ºC'),
	(145339, 118, '2014-01-15 00:57:15.000000', 'temperatura', 1057.0000, 'ºC'),
	(145340, 118, '2014-01-15 00:57:16.000000', 'temperatura', 672.0000, 'ºC'),
	(145341, 118, '2014-01-15 00:57:17.000000', 'temperatura', 187.0000, 'ºC'),
	(145342, 118, '2014-01-15 00:57:18.000000', 'temperatura', 121.0000, 'ºC'),
	(145343, 118, '2014-01-15 00:57:19.000000', 'temperatura', 46.0000, 'ºC'),
	(145344, 118, '2014-01-15 00:57:20.000000', 'temperatura', 1067.0000, 'ºC'),
	(145345, 118, '2014-01-15 00:57:21.000000', 'temperatura', 399.0000, 'ºC'),
	(145346, 118, '2014-01-15 00:57:22.000000', 'temperatura', 1192.0000, 'ºC'),
	(145347, 118, '2014-01-15 00:57:23.000000', 'temperatura', 1166.0000, 'ºC'),
	(145348, 118, '2014-01-15 00:57:24.000000', 'temperatura', 1052.0000, 'ºC'),
	(145349, 118, '2014-01-15 00:57:25.000000', 'temperatura', 561.0000, 'ºC'),
	(145350, 118, '2014-01-15 00:57:26.000000', 'temperatura', 853.0000, 'ºC'),
	(145351, 118, '2014-01-15 00:57:27.000000', 'temperatura', 180.0000, 'ºC'),
	(145352, 118, '2014-01-15 00:57:28.000000', 'temperatura', 743.0000, 'ºC'),
	(145353, 118, '2014-01-15 00:57:29.000000', 'temperatura', 776.0000, 'ºC'),
	(145354, 118, '2014-01-15 00:57:30.000000', 'temperatura', 452.0000, 'ºC'),
	(145355, 118, '2014-01-15 00:57:31.000000', 'temperatura', 1130.0000, 'ºC'),
	(145356, 118, '2014-01-15 00:57:32.000000', 'temperatura', 696.0000, 'ºC'),
	(145357, 118, '2014-01-15 00:57:33.000000', 'temperatura', 92.0000, 'ºC'),
	(145358, 118, '2014-01-15 00:57:34.000000', 'temperatura', 773.0000, 'ºC'),
	(145359, 118, '2014-01-15 00:57:35.000000', 'temperatura', 1187.0000, 'ºC'),
	(145360, 118, '2014-01-15 00:57:36.000000', 'temperatura', 17.0000, 'ºC'),
	(145361, 118, '2014-01-15 00:57:37.000000', 'temperatura', 126.0000, 'ºC'),
	(145362, 118, '2014-01-15 00:57:38.000000', 'temperatura', 579.0000, 'ºC'),
	(145363, 118, '2014-01-15 00:57:39.000000', 'temperatura', 117.0000, 'ºC'),
	(145364, 118, '2014-01-15 00:57:40.000000', 'temperatura', 49.0000, 'ºC'),
	(145365, 118, '2014-01-15 00:57:41.000000', 'temperatura', 1093.0000, 'ºC'),
	(145366, 118, '2014-01-15 00:57:42.000000', 'temperatura', 519.0000, 'ºC'),
	(145367, 118, '2014-01-15 00:57:43.000000', 'temperatura', 515.0000, 'ºC'),
	(145368, 118, '2014-01-15 00:57:44.000000', 'temperatura', 1021.0000, 'ºC'),
	(145369, 118, '2014-01-15 00:57:45.000000', 'temperatura', 1158.0000, 'ºC'),
	(145370, 118, '2014-01-15 00:57:46.000000', 'temperatura', 329.0000, 'ºC'),
	(145371, 118, '2014-01-15 00:57:47.000000', 'temperatura', 573.0000, 'ºC'),
	(145372, 118, '2014-01-15 00:57:48.000000', 'temperatura', 679.0000, 'ºC'),
	(145373, 118, '2014-01-15 00:57:49.000000', 'temperatura', 475.0000, 'ºC'),
	(145374, 118, '2014-01-15 00:57:50.000000', 'temperatura', 339.0000, 'ºC'),
	(145375, 118, '2014-01-15 00:57:51.000000', 'temperatura', 270.0000, 'ºC'),
	(145376, 118, '2014-01-15 00:57:52.000000', 'temperatura', 333.0000, 'ºC'),
	(145377, 118, '2014-01-15 00:57:53.000000', 'temperatura', 855.0000, 'ºC'),
	(145378, 118, '2014-01-15 00:57:54.000000', 'temperatura', 876.0000, 'ºC'),
	(145379, 118, '2014-01-15 00:57:55.000000', 'temperatura', 617.0000, 'ºC'),
	(145380, 118, '2014-01-15 00:57:56.000000', 'temperatura', 458.0000, 'ºC'),
	(145381, 118, '2014-01-15 00:57:57.000000', 'temperatura', 439.0000, 'ºC'),
	(145382, 118, '2014-01-15 00:57:58.000000', 'temperatura', 822.0000, 'ºC'),
	(145383, 118, '2014-01-15 00:57:59.000000', 'temperatura', 391.0000, 'ºC'),
	(145384, 118, '2014-01-15 00:58:00.000000', 'temperatura', 692.0000, 'ºC'),
	(145385, 118, '2014-01-15 00:58:01.000000', 'temperatura', 1088.0000, 'ºC'),
	(145386, 118, '2014-01-15 00:58:02.000000', 'temperatura', 965.0000, 'ºC'),
	(145387, 118, '2014-01-15 00:58:03.000000', 'temperatura', 360.0000, 'ºC'),
	(145388, 118, '2014-01-15 00:58:04.000000', 'temperatura', 107.0000, 'ºC'),
	(145389, 118, '2014-01-15 00:58:05.000000', 'temperatura', 656.0000, 'ºC'),
	(145390, 118, '2014-01-15 00:58:06.000000', 'temperatura', 556.0000, 'ºC'),
	(145391, 118, '2014-01-15 00:58:07.000000', 'temperatura', 816.0000, 'ºC'),
	(145392, 118, '2014-01-15 00:58:08.000000', 'temperatura', 13.0000, 'ºC'),
	(145393, 118, '2014-01-15 00:58:09.000000', 'temperatura', 17.0000, 'ºC'),
	(145394, 118, '2014-01-15 00:58:10.000000', 'temperatura', 48.0000, 'ºC'),
	(145395, 118, '2014-01-15 00:58:11.000000', 'temperatura', 189.0000, 'ºC'),
	(145396, 118, '2014-01-15 00:58:12.000000', 'temperatura', 799.0000, 'ºC'),
	(145397, 118, '2014-01-15 00:58:13.000000', 'temperatura', 1032.0000, 'ºC'),
	(145398, 118, '2014-01-15 00:58:14.000000', 'temperatura', 361.0000, 'ºC'),
	(145399, 118, '2014-01-15 00:58:15.000000', 'temperatura', 1111.0000, 'ºC'),
	(145400, 118, '2014-01-15 00:58:16.000000', 'temperatura', 871.0000, 'ºC'),
	(145401, 118, '2014-01-15 00:58:17.000000', 'temperatura', 1021.0000, 'ºC'),
	(145402, 118, '2014-01-15 00:58:18.000000', 'temperatura', 95.0000, 'ºC'),
	(145403, 118, '2014-01-15 00:58:19.000000', 'temperatura', 1012.0000, 'ºC'),
	(145404, 118, '2014-01-15 00:58:20.000000', 'temperatura', 1175.0000, 'ºC'),
	(145405, 118, '2014-01-15 00:58:21.000000', 'temperatura', 440.0000, 'ºC'),
	(145406, 118, '2014-01-15 00:58:22.000000', 'temperatura', 1075.0000, 'ºC'),
	(145407, 118, '2014-01-15 00:58:23.000000', 'temperatura', 457.0000, 'ºC'),
	(145408, 118, '2014-01-15 00:58:24.000000', 'temperatura', 258.0000, 'ºC'),
	(145409, 118, '2014-01-15 00:58:25.000000', 'temperatura', 1120.0000, 'ºC'),
	(145410, 118, '2014-01-15 00:58:26.000000', 'temperatura', 27.0000, 'ºC'),
	(145411, 118, '2014-01-15 00:58:27.000000', 'temperatura', 374.0000, 'ºC'),
	(145412, 118, '2014-01-15 00:58:28.000000', 'temperatura', 589.0000, 'ºC'),
	(145413, 118, '2014-01-15 00:58:29.000000', 'temperatura', 626.0000, 'ºC'),
	(145414, 118, '2014-01-15 00:58:30.000000', 'temperatura', 164.0000, 'ºC'),
	(145415, 118, '2014-01-15 00:58:31.000000', 'temperatura', 142.0000, 'ºC'),
	(145416, 118, '2014-01-15 00:58:32.000000', 'temperatura', 219.0000, 'ºC'),
	(145417, 118, '2014-01-15 00:58:33.000000', 'temperatura', 670.0000, 'ºC'),
	(145418, 118, '2014-01-15 00:58:34.000000', 'temperatura', 295.0000, 'ºC'),
	(145419, 118, '2014-01-15 00:58:35.000000', 'temperatura', 662.0000, 'ºC'),
	(145420, 118, '2014-01-15 00:58:36.000000', 'temperatura', 26.0000, 'ºC'),
	(145421, 118, '2014-01-15 00:58:37.000000', 'temperatura', 547.0000, 'ºC'),
	(145422, 118, '2014-01-15 00:58:38.000000', 'temperatura', 257.0000, 'ºC'),
	(145423, 118, '2014-01-15 00:58:39.000000', 'temperatura', 843.0000, 'ºC'),
	(145424, 118, '2014-01-15 00:58:40.000000', 'temperatura', 1044.0000, 'ºC'),
	(145425, 118, '2014-01-15 00:58:41.000000', 'temperatura', 293.0000, 'ºC'),
	(145426, 118, '2014-01-15 00:58:42.000000', 'temperatura', 735.0000, 'ºC'),
	(145427, 118, '2014-01-15 00:58:43.000000', 'temperatura', 395.0000, 'ºC'),
	(145428, 118, '2014-01-15 00:58:44.000000', 'temperatura', 969.0000, 'ºC'),
	(145429, 118, '2014-01-15 00:58:45.000000', 'temperatura', 63.0000, 'ºC'),
	(145430, 118, '2014-01-15 00:58:46.000000', 'temperatura', 1008.0000, 'ºC'),
	(145431, 118, '2014-01-15 00:58:47.000000', 'temperatura', 52.0000, 'ºC'),
	(145432, 118, '2014-01-15 00:58:48.000000', 'temperatura', 835.0000, 'ºC'),
	(145433, 118, '2014-01-15 00:58:49.000000', 'temperatura', 422.0000, 'ºC'),
	(145434, 118, '2014-01-15 00:58:50.000000', 'temperatura', 804.0000, 'ºC'),
	(145435, 118, '2014-01-15 00:58:51.000000', 'temperatura', 357.0000, 'ºC'),
	(145436, 118, '2014-01-15 00:58:52.000000', 'temperatura', 570.0000, 'ºC'),
	(145437, 118, '2014-01-15 00:58:53.000000', 'temperatura', 580.0000, 'ºC'),
	(145438, 118, '2014-01-15 00:58:54.000000', 'temperatura', 1190.0000, 'ºC'),
	(145439, 118, '2014-01-15 00:58:55.000000', 'temperatura', 612.0000, 'ºC'),
	(145440, 118, '2014-01-15 00:58:56.000000', 'temperatura', 692.0000, 'ºC'),
	(145441, 118, '2014-01-15 00:58:57.000000', 'temperatura', 423.0000, 'ºC'),
	(145442, 118, '2014-01-15 00:58:58.000000', 'temperatura', 39.0000, 'ºC'),
	(145443, 118, '2014-01-15 00:58:59.000000', 'temperatura', 128.0000, 'ºC'),
	(145444, 118, '2014-01-15 00:59:00.000000', 'temperatura', 523.0000, 'ºC'),
	(145445, 118, '2014-01-15 00:59:01.000000', 'temperatura', 1033.0000, 'ºC'),
	(145446, 118, '2014-01-15 00:59:02.000000', 'temperatura', 1195.0000, 'ºC'),
	(145447, 118, '2014-01-15 00:59:03.000000', 'temperatura', 478.0000, 'ºC'),
	(145448, 118, '2014-01-15 00:59:04.000000', 'temperatura', 7.0000, 'ºC'),
	(145449, 118, '2014-01-15 00:59:05.000000', 'temperatura', 998.0000, 'ºC'),
	(145450, 118, '2014-01-15 00:59:06.000000', 'temperatura', 171.0000, 'ºC'),
	(145451, 118, '2014-01-15 00:59:07.000000', 'temperatura', 260.0000, 'ºC'),
	(145452, 118, '2014-01-15 00:59:08.000000', 'temperatura', 790.0000, 'ºC'),
	(145453, 118, '2014-01-15 00:59:09.000000', 'temperatura', 771.0000, 'ºC'),
	(145454, 118, '2014-01-15 00:59:10.000000', 'temperatura', 284.0000, 'ºC'),
	(145455, 118, '2014-01-15 00:59:11.000000', 'temperatura', 306.0000, 'ºC'),
	(145456, 118, '2014-01-15 00:59:12.000000', 'temperatura', 680.0000, 'ºC'),
	(145457, 118, '2014-01-15 00:59:13.000000', 'temperatura', 83.0000, 'ºC'),
	(145458, 118, '2014-01-15 00:59:14.000000', 'temperatura', 773.0000, 'ºC'),
	(145459, 118, '2014-01-15 00:59:15.000000', 'temperatura', 18.0000, 'ºC'),
	(145460, 118, '2014-01-15 00:59:16.000000', 'temperatura', 171.0000, 'ºC'),
	(145461, 118, '2014-01-15 00:59:17.000000', 'temperatura', 800.0000, 'ºC'),
	(145462, 118, '2014-01-15 00:59:18.000000', 'temperatura', 1089.0000, 'ºC'),
	(145463, 118, '2014-01-15 00:59:19.000000', 'temperatura', 647.0000, 'ºC'),
	(145464, 118, '2014-01-15 00:59:20.000000', 'temperatura', 1165.0000, 'ºC'),
	(145465, 118, '2014-01-15 00:59:21.000000', 'temperatura', 288.0000, 'ºC'),
	(145466, 118, '2014-01-15 00:59:22.000000', 'temperatura', 345.0000, 'ºC'),
	(145467, 118, '2014-01-15 00:59:23.000000', 'temperatura', 860.0000, 'ºC'),
	(145468, 118, '2014-01-15 00:59:24.000000', 'temperatura', 868.0000, 'ºC'),
	(145469, 118, '2014-01-15 00:59:25.000000', 'temperatura', 558.0000, 'ºC'),
	(145470, 118, '2014-01-15 00:59:26.000000', 'temperatura', 189.0000, 'ºC'),
	(145471, 118, '2014-01-15 00:59:27.000000', 'temperatura', 469.0000, 'ºC'),
	(145472, 118, '2014-01-15 00:59:28.000000', 'temperatura', 578.0000, 'ºC'),
	(145473, 118, '2014-01-15 00:59:29.000000', 'temperatura', 286.0000, 'ºC'),
	(145474, 118, '2014-01-15 00:59:30.000000', 'temperatura', 895.0000, 'ºC'),
	(145475, 118, '2014-01-15 00:59:31.000000', 'temperatura', 16.0000, 'ºC'),
	(145476, 118, '2014-01-15 00:59:32.000000', 'temperatura', 996.0000, 'ºC'),
	(145477, 118, '2014-01-15 00:59:33.000000', 'temperatura', 135.0000, 'ºC'),
	(145478, 118, '2014-01-15 00:59:34.000000', 'temperatura', 85.0000, 'ºC'),
	(145479, 118, '2014-01-15 00:59:35.000000', 'temperatura', 21.0000, 'ºC'),
	(145480, 118, '2014-01-15 00:59:36.000000', 'temperatura', 1049.0000, 'ºC'),
	(145481, 118, '2014-01-15 00:59:37.000000', 'temperatura', 384.0000, 'ºC'),
	(145482, 118, '2014-01-15 00:59:38.000000', 'temperatura', 1173.0000, 'ºC'),
	(145483, 118, '2014-01-15 00:59:39.000000', 'temperatura', 1114.0000, 'ºC'),
	(145484, 118, '2014-01-15 00:59:40.000000', 'temperatura', 852.0000, 'ºC'),
	(145485, 118, '2014-01-15 00:59:41.000000', 'temperatura', 917.0000, 'ºC'),
	(145486, 118, '2014-01-15 00:59:42.000000', 'temperatura', 832.0000, 'ºC'),
	(145487, 118, '2014-01-15 00:59:43.000000', 'temperatura', 207.0000, 'ºC'),
	(145488, 118, '2014-01-15 00:59:44.000000', 'temperatura', 939.0000, 'ºC'),
	(145489, 118, '2014-01-15 00:59:45.000000', 'temperatura', 477.0000, 'ºC'),
	(145490, 118, '2014-01-15 00:59:46.000000', 'temperatura', 767.0000, 'ºC'),
	(145491, 118, '2014-01-15 00:59:47.000000', 'temperatura', 3.0000, 'ºC'),
	(145492, 118, '2014-01-15 00:59:48.000000', 'temperatura', 118.0000, 'ºC'),
	(145493, 118, '2014-01-15 00:59:49.000000', 'temperatura', 579.0000, 'ºC'),
	(145494, 118, '2014-01-15 00:59:50.000000', 'temperatura', 143.0000, 'ºC'),
	(145495, 118, '2014-01-15 00:59:51.000000', 'temperatura', 176.0000, 'ºC'),
	(145496, 118, '2014-01-15 00:59:52.000000', 'temperatura', 454.0000, 'ºC'),
	(145497, 118, '2014-01-15 00:59:53.000000', 'temperatura', 540.0000, 'ºC'),
	(145498, 118, '2014-01-15 00:59:54.000000', 'temperatura', 141.0000, 'ºC'),
	(145499, 118, '2014-01-15 00:59:55.000000', 'temperatura', 285.0000, 'ºC'),
	(145500, 118, '2014-01-15 00:59:56.000000', 'temperatura', 1001.0000, 'ºC'),
	(145501, 118, '2014-01-15 00:59:57.000000', 'temperatura', 553.0000, 'ºC'),
	(145502, 118, '2014-01-15 00:59:58.000000', 'temperatura', 962.0000, 'ºC'),
	(145503, 118, '2014-01-15 00:59:59.000000', 'temperatura', 752.0000, 'ºC'),
	(145504, 118, '2014-01-15 01:00:00.000000', 'temperatura', 876.0000, 'ºC'),
	(145505, 118, '2014-01-15 01:00:01.000000', 'temperatura', 923.0000, 'ºC'),
	(145506, 118, '2014-01-15 01:00:02.000000', 'temperatura', 787.0000, 'ºC'),
	(145507, 118, '2014-01-15 01:00:03.000000', 'temperatura', 1166.0000, 'ºC'),
	(145508, 118, '2014-01-15 01:00:04.000000', 'temperatura', 1069.0000, 'ºC'),
	(145509, 118, '2014-01-15 01:00:05.000000', 'temperatura', 649.0000, 'ºC'),
	(145510, 118, '2014-01-15 01:00:06.000000', 'temperatura', 37.0000, 'ºC'),
	(145511, 118, '2014-01-15 01:00:07.000000', 'temperatura', 641.0000, 'ºC'),
	(145512, 118, '2014-01-15 01:00:08.000000', 'temperatura', 693.0000, 'ºC'),
	(145513, 118, '2014-01-15 01:00:09.000000', 'temperatura', 343.0000, 'ºC'),
	(145514, 118, '2014-01-15 01:00:10.000000', 'temperatura', 836.0000, 'ºC'),
	(145515, 118, '2014-01-15 01:00:11.000000', 'temperatura', 752.0000, 'ºC'),
	(145516, 118, '2014-01-15 01:00:12.000000', 'temperatura', 52.0000, 'ºC'),
	(145517, 118, '2014-01-15 01:00:13.000000', 'temperatura', 407.0000, 'ºC'),
	(145518, 118, '2014-01-15 01:00:14.000000', 'temperatura', 676.0000, 'ºC'),
	(145519, 118, '2014-01-15 01:00:15.000000', 'temperatura', 961.0000, 'ºC'),
	(145520, 118, '2014-01-15 01:00:16.000000', 'temperatura', 378.0000, 'ºC'),
	(145521, 118, '2014-01-15 01:00:17.000000', 'temperatura', 206.0000, 'ºC'),
	(145522, 118, '2014-01-15 01:00:18.000000', 'temperatura', 1097.0000, 'ºC'),
	(145523, 118, '2014-01-15 01:00:19.000000', 'temperatura', 69.0000, 'ºC'),
	(145524, 118, '2014-01-15 01:00:20.000000', 'temperatura', 652.0000, 'ºC'),
	(145525, 118, '2014-01-15 01:00:21.000000', 'temperatura', 655.0000, 'ºC'),
	(145526, 118, '2014-01-15 01:00:22.000000', 'temperatura', 121.0000, 'ºC'),
	(145527, 118, '2014-01-15 01:00:23.000000', 'temperatura', 1038.0000, 'ºC'),
	(145528, 118, '2014-01-15 01:00:24.000000', 'temperatura', 26.0000, 'ºC'),
	(145529, 118, '2014-01-15 01:00:25.000000', 'temperatura', 620.0000, 'ºC'),
	(145530, 118, '2014-01-15 01:00:26.000000', 'temperatura', 620.0000, 'ºC'),
	(145531, 118, '2014-01-15 01:00:27.000000', 'temperatura', 41.0000, 'ºC'),
	(145532, 118, '2014-01-15 01:00:28.000000', 'temperatura', 748.0000, 'ºC'),
	(145533, 118, '2014-01-15 01:00:29.000000', 'temperatura', 15.0000, 'ºC'),
	(145534, 119, '2014-01-15 00:00:00.000000', 'temperatura', 1119.0000, 'ºC'),
	(145535, 119, '2014-01-15 00:00:01.000000', 'temperatura', 95.0000, 'ºC'),
	(145536, 119, '2014-01-15 00:00:02.000000', 'temperatura', 720.0000, 'ºC'),
	(145537, 119, '2014-01-15 00:00:03.000000', 'temperatura', 917.0000, 'ºC'),
	(145538, 119, '2014-01-15 00:00:04.000000', 'temperatura', 25.0000, 'ºC'),
	(145539, 119, '2014-01-15 00:00:05.000000', 'temperatura', 976.0000, 'ºC'),
	(145540, 119, '2014-01-15 00:00:06.000000', 'temperatura', 2.0000, 'ºC'),
	(145541, 119, '2014-01-15 00:00:07.000000', 'temperatura', 686.0000, 'ºC'),
	(145542, 119, '2014-01-15 00:00:08.000000', 'temperatura', 1022.0000, 'ºC'),
	(145543, 119, '2014-01-15 00:00:09.000000', 'temperatura', 652.0000, 'ºC'),
	(145544, 119, '2014-01-15 00:00:10.000000', 'temperatura', 196.0000, 'ºC'),
	(145545, 119, '2014-01-15 00:00:11.000000', 'temperatura', 224.0000, 'ºC'),
	(145546, 119, '2014-01-15 00:00:12.000000', 'temperatura', 533.0000, 'ºC'),
	(145547, 119, '2014-01-15 00:00:13.000000', 'temperatura', 792.0000, 'ºC'),
	(145548, 119, '2014-01-15 00:00:14.000000', 'temperatura', 1161.0000, 'ºC'),
	(145549, 119, '2014-01-15 00:00:15.000000', 'temperatura', 1031.0000, 'ºC'),
	(145550, 119, '2014-01-15 00:00:16.000000', 'temperatura', 470.0000, 'ºC'),
	(145551, 119, '2014-01-15 00:00:17.000000', 'temperatura', 459.0000, 'ºC'),
	(145552, 119, '2014-01-15 00:00:18.000000', 'temperatura', 886.0000, 'ºC'),
	(145553, 119, '2014-01-15 00:00:19.000000', 'temperatura', 655.0000, 'ºC'),
	(145554, 119, '2014-01-15 00:00:20.000000', 'temperatura', 616.0000, 'ºC'),
	(145555, 119, '2014-01-15 00:00:21.000000', 'temperatura', 1117.0000, 'ºC'),
	(145556, 119, '2014-01-15 00:00:22.000000', 'temperatura', 134.0000, 'ºC'),
	(145557, 119, '2014-01-15 00:00:23.000000', 'temperatura', 923.0000, 'ºC'),
	(145558, 119, '2014-01-15 00:00:24.000000', 'temperatura', 614.0000, 'ºC'),
	(145559, 119, '2014-01-15 00:00:25.000000', 'temperatura', 299.0000, 'ºC'),
	(145560, 119, '2014-01-15 00:00:26.000000', 'temperatura', 853.0000, 'ºC'),
	(145561, 119, '2014-01-15 00:00:27.000000', 'temperatura', 967.0000, 'ºC'),
	(145562, 119, '2014-01-15 00:00:28.000000', 'temperatura', 1080.0000, 'ºC'),
	(145563, 119, '2014-01-15 00:00:29.000000', 'temperatura', 99.0000, 'ºC'),
	(145564, 119, '2014-01-15 00:00:30.000000', 'temperatura', 857.0000, 'ºC'),
	(145565, 119, '2014-01-15 00:00:31.000000', 'temperatura', 386.0000, 'ºC'),
	(145566, 119, '2014-01-15 00:00:32.000000', 'temperatura', 559.0000, 'ºC'),
	(145567, 119, '2014-01-15 00:00:33.000000', 'temperatura', 439.0000, 'ºC'),
	(145568, 119, '2014-01-15 00:00:34.000000', 'temperatura', 519.0000, 'ºC'),
	(145569, 119, '2014-01-15 00:00:35.000000', 'temperatura', 76.0000, 'ºC'),
	(145570, 119, '2014-01-15 00:00:36.000000', 'temperatura', 24.0000, 'ºC'),
	(145571, 119, '2014-01-15 00:00:37.000000', 'temperatura', 1095.0000, 'ºC'),
	(145572, 119, '2014-01-15 00:00:38.000000', 'temperatura', 601.0000, 'ºC'),
	(145573, 119, '2014-01-15 00:00:39.000000', 'temperatura', 923.0000, 'ºC'),
	(145574, 119, '2014-01-15 00:00:40.000000', 'temperatura', 413.0000, 'ºC'),
	(145575, 119, '2014-01-15 00:00:41.000000', 'temperatura', 494.0000, 'ºC'),
	(145576, 119, '2014-01-15 00:00:42.000000', 'temperatura', 31.0000, 'ºC'),
	(145577, 119, '2014-01-15 00:00:43.000000', 'temperatura', 1074.0000, 'ºC'),
	(145578, 119, '2014-01-15 00:00:44.000000', 'temperatura', 478.0000, 'ºC'),
	(145579, 119, '2014-01-15 00:00:45.000000', 'temperatura', 370.0000, 'ºC'),
	(145580, 119, '2014-01-15 00:00:46.000000', 'temperatura', 416.0000, 'ºC'),
	(145581, 119, '2014-01-15 00:00:47.000000', 'temperatura', 972.0000, 'ºC'),
	(145582, 119, '2014-01-15 00:00:48.000000', 'temperatura', 10.0000, 'ºC'),
	(145583, 119, '2014-01-15 00:00:49.000000', 'temperatura', 737.0000, 'ºC'),
	(145584, 119, '2014-01-15 00:00:50.000000', 'temperatura', 53.0000, 'ºC'),
	(145585, 119, '2014-01-15 00:00:51.000000', 'temperatura', 457.0000, 'ºC'),
	(145586, 119, '2014-01-15 00:00:52.000000', 'temperatura', 928.0000, 'ºC'),
	(145587, 119, '2014-01-15 00:00:53.000000', 'temperatura', 866.0000, 'ºC'),
	(145588, 119, '2014-01-15 00:00:54.000000', 'temperatura', 346.0000, 'ºC'),
	(145589, 119, '2014-01-15 00:00:55.000000', 'temperatura', 333.0000, 'ºC'),
	(145590, 119, '2014-01-15 00:00:56.000000', 'temperatura', 630.0000, 'ºC'),
	(145591, 119, '2014-01-15 00:00:57.000000', 'temperatura', 948.0000, 'ºC'),
	(145592, 119, '2014-01-15 00:00:58.000000', 'temperatura', 453.0000, 'ºC'),
	(145593, 119, '2014-01-15 00:00:59.000000', 'temperatura', 620.0000, 'ºC'),
	(145594, 119, '2014-01-15 00:01:00.000000', 'temperatura', 542.0000, 'ºC'),
	(145595, 119, '2014-01-15 00:01:01.000000', 'temperatura', 851.0000, 'ºC'),
	(145596, 119, '2014-01-15 00:01:02.000000', 'temperatura', 229.0000, 'ºC'),
	(145597, 119, '2014-01-15 00:01:03.000000', 'temperatura', 991.0000, 'ºC'),
	(145598, 119, '2014-01-15 00:01:04.000000', 'temperatura', 672.0000, 'ºC'),
	(145599, 119, '2014-01-15 00:01:05.000000', 'temperatura', 384.0000, 'ºC'),
	(145600, 119, '2014-01-15 00:01:06.000000', 'temperatura', 1106.0000, 'ºC'),
	(145601, 119, '2014-01-15 00:01:07.000000', 'temperatura', 779.0000, 'ºC'),
	(145602, 119, '2014-01-15 00:01:08.000000', 'temperatura', 576.0000, 'ºC'),
	(145603, 119, '2014-01-15 00:01:09.000000', 'temperatura', 546.0000, 'ºC'),
	(145604, 119, '2014-01-15 00:01:10.000000', 'temperatura', 1001.0000, 'ºC'),
	(145605, 119, '2014-01-15 00:01:11.000000', 'temperatura', 967.0000, 'ºC'),
	(145606, 119, '2014-01-15 00:01:12.000000', 'temperatura', 632.0000, 'ºC'),
	(145607, 119, '2014-01-15 00:01:13.000000', 'temperatura', 261.0000, 'ºC'),
	(145608, 119, '2014-01-15 00:01:14.000000', 'temperatura', 610.0000, 'ºC'),
	(145609, 119, '2014-01-15 00:01:15.000000', 'temperatura', 1068.0000, 'ºC'),
	(145610, 119, '2014-01-15 00:01:16.000000', 'temperatura', 1110.0000, 'ºC'),
	(145611, 119, '2014-01-15 00:01:17.000000', 'temperatura', 1144.0000, 'ºC'),
	(145612, 119, '2014-01-15 00:01:18.000000', 'temperatura', 1193.0000, 'ºC'),
	(145613, 119, '2014-01-15 00:01:19.000000', 'temperatura', 134.0000, 'ºC'),
	(145614, 119, '2014-01-15 00:01:20.000000', 'temperatura', 689.0000, 'ºC'),
	(145615, 119, '2014-01-15 00:01:21.000000', 'temperatura', 644.0000, 'ºC'),
	(145616, 119, '2014-01-15 00:01:22.000000', 'temperatura', 1153.0000, 'ºC'),
	(145617, 119, '2014-01-15 00:01:23.000000', 'temperatura', 233.0000, 'ºC'),
	(145618, 119, '2014-01-15 00:01:24.000000', 'temperatura', 109.0000, 'ºC'),
	(145619, 119, '2014-01-15 00:01:25.000000', 'temperatura', 1044.0000, 'ºC'),
	(145620, 119, '2014-01-15 00:01:26.000000', 'temperatura', 96.0000, 'ºC'),
	(145621, 119, '2014-01-15 00:01:27.000000', 'temperatura', 946.0000, 'ºC'),
	(145622, 119, '2014-01-15 00:01:28.000000', 'temperatura', 845.0000, 'ºC'),
	(145623, 119, '2014-01-15 00:01:29.000000', 'temperatura', 186.0000, 'ºC'),
	(145624, 119, '2014-01-15 00:01:30.000000', 'temperatura', 796.0000, 'ºC'),
	(145625, 119, '2014-01-15 00:01:31.000000', 'temperatura', 1024.0000, 'ºC'),
	(145626, 119, '2014-01-15 00:01:32.000000', 'temperatura', 330.0000, 'ºC'),
	(145627, 119, '2014-01-15 00:01:33.000000', 'temperatura', 979.0000, 'ºC'),
	(145628, 119, '2014-01-15 00:01:34.000000', 'temperatura', 305.0000, 'ºC'),
	(145629, 119, '2014-01-15 00:01:35.000000', 'temperatura', 989.0000, 'ºC'),
	(145630, 119, '2014-01-15 00:01:36.000000', 'temperatura', 430.0000, 'ºC'),
	(145631, 119, '2014-01-15 00:01:37.000000', 'temperatura', 382.0000, 'ºC'),
	(145632, 119, '2014-01-15 00:01:38.000000', 'temperatura', 623.0000, 'ºC'),
	(145633, 119, '2014-01-15 00:01:39.000000', 'temperatura', 771.0000, 'ºC'),
	(145634, 119, '2014-01-15 00:01:40.000000', 'temperatura', 783.0000, 'ºC'),
	(145635, 119, '2014-01-15 00:01:41.000000', 'temperatura', 406.0000, 'ºC'),
	(145636, 119, '2014-01-15 00:01:42.000000', 'temperatura', 880.0000, 'ºC'),
	(145637, 119, '2014-01-15 00:01:43.000000', 'temperatura', 781.0000, 'ºC'),
	(145638, 119, '2014-01-15 00:01:44.000000', 'temperatura', 67.0000, 'ºC'),
	(145639, 119, '2014-01-15 00:01:45.000000', 'temperatura', 391.0000, 'ºC'),
	(145640, 119, '2014-01-15 00:01:46.000000', 'temperatura', 555.0000, 'ºC'),
	(145641, 119, '2014-01-15 00:01:47.000000', 'temperatura', 402.0000, 'ºC'),
	(145642, 119, '2014-01-15 00:01:48.000000', 'temperatura', 344.0000, 'ºC'),
	(145643, 119, '2014-01-15 00:01:49.000000', 'temperatura', 518.0000, 'ºC'),
	(145644, 119, '2014-01-15 00:01:50.000000', 'temperatura', 357.0000, 'ºC'),
	(145645, 119, '2014-01-15 00:01:51.000000', 'temperatura', 231.0000, 'ºC'),
	(145646, 119, '2014-01-15 00:01:52.000000', 'temperatura', 86.0000, 'ºC'),
	(145647, 119, '2014-01-15 00:01:53.000000', 'temperatura', 936.0000, 'ºC'),
	(145648, 119, '2014-01-15 00:01:54.000000', 'temperatura', 824.0000, 'ºC'),
	(145649, 119, '2014-01-15 00:01:55.000000', 'temperatura', 112.0000, 'ºC'),
	(145650, 119, '2014-01-15 00:01:56.000000', 'temperatura', 487.0000, 'ºC'),
	(145651, 119, '2014-01-15 00:01:57.000000', 'temperatura', 901.0000, 'ºC'),
	(145652, 119, '2014-01-15 00:01:58.000000', 'temperatura', 644.0000, 'ºC'),
	(145653, 119, '2014-01-15 00:01:59.000000', 'temperatura', 519.0000, 'ºC'),
	(145654, 119, '2014-01-15 00:02:00.000000', 'temperatura', 662.0000, 'ºC'),
	(145655, 119, '2014-01-15 00:02:01.000000', 'temperatura', 554.0000, 'ºC'),
	(145656, 119, '2014-01-15 00:02:02.000000', 'temperatura', 785.0000, 'ºC'),
	(145657, 119, '2014-01-15 00:02:03.000000', 'temperatura', 1062.0000, 'ºC'),
	(145658, 119, '2014-01-15 00:02:04.000000', 'temperatura', 558.0000, 'ºC'),
	(145659, 119, '2014-01-15 00:02:05.000000', 'temperatura', 804.0000, 'ºC'),
	(145660, 119, '2014-01-15 00:02:06.000000', 'temperatura', 1147.0000, 'ºC'),
	(145661, 119, '2014-01-15 00:02:07.000000', 'temperatura', 922.0000, 'ºC'),
	(145662, 119, '2014-01-15 00:02:08.000000', 'temperatura', 1172.0000, 'ºC'),
	(145663, 119, '2014-01-15 00:02:09.000000', 'temperatura', 692.0000, 'ºC'),
	(145664, 119, '2014-01-15 00:02:10.000000', 'temperatura', 1147.0000, 'ºC'),
	(145665, 119, '2014-01-15 00:02:11.000000', 'temperatura', 57.0000, 'ºC'),
	(145666, 119, '2014-01-15 00:02:12.000000', 'temperatura', 445.0000, 'ºC'),
	(145667, 119, '2014-01-15 00:02:13.000000', 'temperatura', 855.0000, 'ºC'),
	(145668, 119, '2014-01-15 00:02:14.000000', 'temperatura', 540.0000, 'ºC'),
	(145669, 119, '2014-01-15 00:02:15.000000', 'temperatura', 137.0000, 'ºC'),
	(145670, 119, '2014-01-15 00:02:16.000000', 'temperatura', 263.0000, 'ºC'),
	(145671, 119, '2014-01-15 00:02:17.000000', 'temperatura', 905.0000, 'ºC'),
	(145672, 119, '2014-01-15 00:02:18.000000', 'temperatura', 138.0000, 'ºC'),
	(145673, 119, '2014-01-15 00:02:19.000000', 'temperatura', 374.0000, 'ºC'),
	(145674, 119, '2014-01-15 00:02:20.000000', 'temperatura', 255.0000, 'ºC'),
	(145675, 119, '2014-01-15 00:02:21.000000', 'temperatura', 157.0000, 'ºC'),
	(145676, 119, '2014-01-15 00:02:22.000000', 'temperatura', 18.0000, 'ºC'),
	(145677, 119, '2014-01-15 00:02:23.000000', 'temperatura', 821.0000, 'ºC'),
	(145678, 119, '2014-01-15 00:02:24.000000', 'temperatura', 452.0000, 'ºC'),
	(145679, 119, '2014-01-15 00:02:25.000000', 'temperatura', 999.0000, 'ºC'),
	(145680, 119, '2014-01-15 00:02:26.000000', 'temperatura', 36.0000, 'ºC'),
	(145681, 119, '2014-01-15 00:02:27.000000', 'temperatura', 784.0000, 'ºC'),
	(145682, 119, '2014-01-15 00:02:28.000000', 'temperatura', 214.0000, 'ºC'),
	(145683, 119, '2014-01-15 00:02:29.000000', 'temperatura', 1118.0000, 'ºC'),
	(145684, 119, '2014-01-15 00:02:30.000000', 'temperatura', 147.0000, 'ºC'),
	(145685, 119, '2014-01-15 00:02:31.000000', 'temperatura', 984.0000, 'ºC'),
	(145686, 119, '2014-01-15 00:02:32.000000', 'temperatura', 880.0000, 'ºC'),
	(145687, 119, '2014-01-15 00:02:33.000000', 'temperatura', 248.0000, 'ºC'),
	(145688, 119, '2014-01-15 00:02:34.000000', 'temperatura', 999.0000, 'ºC'),
	(145689, 119, '2014-01-15 00:02:35.000000', 'temperatura', 652.0000, 'ºC'),
	(145690, 119, '2014-01-15 00:02:36.000000', 'temperatura', 262.0000, 'ºC'),
	(145691, 119, '2014-01-15 00:02:37.000000', 'temperatura', 557.0000, 'ºC'),
	(145692, 119, '2014-01-15 00:02:38.000000', 'temperatura', 797.0000, 'ºC'),
	(145693, 119, '2014-01-15 00:02:39.000000', 'temperatura', 1113.0000, 'ºC'),
	(145694, 119, '2014-01-15 00:02:40.000000', 'temperatura', 778.0000, 'ºC'),
	(145695, 119, '2014-01-15 00:02:41.000000', 'temperatura', 552.0000, 'ºC'),
	(145696, 119, '2014-01-15 00:02:42.000000', 'temperatura', 426.0000, 'ºC'),
	(145697, 119, '2014-01-15 00:02:43.000000', 'temperatura', 475.0000, 'ºC'),
	(145698, 119, '2014-01-15 00:02:44.000000', 'temperatura', 1099.0000, 'ºC'),
	(145699, 119, '2014-01-15 00:02:45.000000', 'temperatura', 467.0000, 'ºC'),
	(145700, 119, '2014-01-15 00:02:46.000000', 'temperatura', 242.0000, 'ºC'),
	(145701, 119, '2014-01-15 00:02:47.000000', 'temperatura', 1008.0000, 'ºC'),
	(145702, 119, '2014-01-15 00:02:48.000000', 'temperatura', 714.0000, 'ºC'),
	(145703, 119, '2014-01-15 00:02:49.000000', 'temperatura', 545.0000, 'ºC'),
	(145704, 119, '2014-01-15 00:02:50.000000', 'temperatura', 585.0000, 'ºC'),
	(145705, 119, '2014-01-15 00:02:51.000000', 'temperatura', 90.0000, 'ºC'),
	(145706, 119, '2014-01-15 00:02:52.000000', 'temperatura', 1094.0000, 'ºC'),
	(145707, 119, '2014-01-15 00:02:53.000000', 'temperatura', 403.0000, 'ºC'),
	(145708, 119, '2014-01-15 00:02:54.000000', 'temperatura', 1132.0000, 'ºC'),
	(145709, 119, '2014-01-15 00:02:55.000000', 'temperatura', 850.0000, 'ºC'),
	(145710, 119, '2014-01-15 00:02:56.000000', 'temperatura', 856.0000, 'ºC'),
	(145711, 119, '2014-01-15 00:02:57.000000', 'temperatura', 529.0000, 'ºC'),
	(145712, 119, '2014-01-15 00:02:58.000000', 'temperatura', 77.0000, 'ºC'),
	(145713, 119, '2014-01-15 00:02:59.000000', 'temperatura', 1.0000, 'ºC'),
	(145714, 119, '2014-01-15 00:03:00.000000', 'temperatura', 973.0000, 'ºC'),
	(145715, 119, '2014-01-15 00:03:01.000000', 'temperatura', 63.0000, 'ºC'),
	(145716, 119, '2014-01-15 00:03:02.000000', 'temperatura', 996.0000, 'ºC'),
	(145717, 119, '2014-01-15 00:03:03.000000', 'temperatura', 1192.0000, 'ºC'),
	(145718, 119, '2014-01-15 00:03:04.000000', 'temperatura', 573.0000, 'ºC'),
	(145719, 119, '2014-01-15 00:03:05.000000', 'temperatura', 489.0000, 'ºC'),
	(145720, 119, '2014-01-15 00:03:06.000000', 'temperatura', 728.0000, 'ºC'),
	(145721, 119, '2014-01-15 00:03:07.000000', 'temperatura', 971.0000, 'ºC'),
	(145722, 119, '2014-01-15 00:03:08.000000', 'temperatura', 275.0000, 'ºC'),
	(145723, 119, '2014-01-15 00:03:09.000000', 'temperatura', 859.0000, 'ºC'),
	(145724, 119, '2014-01-15 00:03:10.000000', 'temperatura', 1072.0000, 'ºC'),
	(145725, 119, '2014-01-15 00:03:11.000000', 'temperatura', 383.0000, 'ºC'),
	(145726, 119, '2014-01-15 00:03:12.000000', 'temperatura', 1099.0000, 'ºC'),
	(145727, 119, '2014-01-15 00:03:13.000000', 'temperatura', 746.0000, 'ºC'),
	(145728, 119, '2014-01-15 00:03:14.000000', 'temperatura', 434.0000, 'ºC'),
	(145729, 119, '2014-01-15 00:03:15.000000', 'temperatura', 1133.0000, 'ºC'),
	(145730, 119, '2014-01-15 00:03:16.000000', 'temperatura', 765.0000, 'ºC'),
	(145731, 119, '2014-01-15 00:03:17.000000', 'temperatura', 425.0000, 'ºC'),
	(145732, 119, '2014-01-15 00:03:18.000000', 'temperatura', 1032.0000, 'ºC'),
	(145733, 119, '2014-01-15 00:03:19.000000', 'temperatura', 286.0000, 'ºC'),
	(145734, 119, '2014-01-15 00:03:20.000000', 'temperatura', 734.0000, 'ºC'),
	(145735, 119, '2014-01-15 00:03:21.000000', 'temperatura', 410.0000, 'ºC'),
	(145736, 119, '2014-01-15 00:03:22.000000', 'temperatura', 1050.0000, 'ºC'),
	(145737, 119, '2014-01-15 00:03:23.000000', 'temperatura', 421.0000, 'ºC'),
	(145738, 119, '2014-01-15 00:03:24.000000', 'temperatura', 155.0000, 'ºC'),
	(145739, 119, '2014-01-15 00:03:25.000000', 'temperatura', 714.0000, 'ºC'),
	(145740, 119, '2014-01-15 00:03:26.000000', 'temperatura', 705.0000, 'ºC'),
	(145741, 119, '2014-01-15 00:03:27.000000', 'temperatura', 182.0000, 'ºC'),
	(145742, 119, '2014-01-15 00:03:28.000000', 'temperatura', 1194.0000, 'ºC'),
	(145743, 119, '2014-01-15 00:03:29.000000', 'temperatura', 627.0000, 'ºC'),
	(145744, 119, '2014-01-15 00:03:30.000000', 'temperatura', 753.0000, 'ºC'),
	(145745, 119, '2014-01-15 00:03:31.000000', 'temperatura', 684.0000, 'ºC'),
	(145746, 119, '2014-01-15 00:03:32.000000', 'temperatura', 1162.0000, 'ºC'),
	(145747, 119, '2014-01-15 00:03:33.000000', 'temperatura', 156.0000, 'ºC'),
	(145748, 119, '2014-01-15 00:03:34.000000', 'temperatura', 898.0000, 'ºC'),
	(145749, 119, '2014-01-15 00:03:35.000000', 'temperatura', 421.0000, 'ºC'),
	(145750, 119, '2014-01-15 00:03:36.000000', 'temperatura', 610.0000, 'ºC'),
	(145751, 119, '2014-01-15 00:03:37.000000', 'temperatura', 589.0000, 'ºC'),
	(145752, 119, '2014-01-15 00:03:38.000000', 'temperatura', 1116.0000, 'ºC'),
	(145753, 119, '2014-01-15 00:03:39.000000', 'temperatura', 211.0000, 'ºC'),
	(145754, 119, '2014-01-15 00:03:40.000000', 'temperatura', 110.0000, 'ºC'),
	(145755, 119, '2014-01-15 00:03:41.000000', 'temperatura', 1116.0000, 'ºC'),
	(145756, 119, '2014-01-15 00:03:42.000000', 'temperatura', 453.0000, 'ºC'),
	(145757, 119, '2014-01-15 00:03:43.000000', 'temperatura', 116.0000, 'ºC'),
	(145758, 119, '2014-01-15 00:03:44.000000', 'temperatura', 421.0000, 'ºC'),
	(145759, 119, '2014-01-15 00:03:45.000000', 'temperatura', 557.0000, 'ºC'),
	(145760, 119, '2014-01-15 00:03:46.000000', 'temperatura', 322.0000, 'ºC'),
	(145761, 119, '2014-01-15 00:03:47.000000', 'temperatura', 1141.0000, 'ºC'),
	(145762, 119, '2014-01-15 00:03:48.000000', 'temperatura', 1137.0000, 'ºC'),
	(145763, 119, '2014-01-15 00:03:49.000000', 'temperatura', 1065.0000, 'ºC'),
	(145764, 119, '2014-01-15 00:03:50.000000', 'temperatura', 714.0000, 'ºC'),
	(145765, 119, '2014-01-15 00:03:51.000000', 'temperatura', 377.0000, 'ºC'),
	(145766, 119, '2014-01-15 00:03:52.000000', 'temperatura', 944.0000, 'ºC'),
	(145767, 119, '2014-01-15 00:03:53.000000', 'temperatura', 1187.0000, 'ºC'),
	(145768, 119, '2014-01-15 00:03:54.000000', 'temperatura', 702.0000, 'ºC'),
	(145769, 119, '2014-01-15 00:03:55.000000', 'temperatura', 1153.0000, 'ºC'),
	(145770, 119, '2014-01-15 00:03:56.000000', 'temperatura', 56.0000, 'ºC'),
	(145771, 119, '2014-01-15 00:03:57.000000', 'temperatura', 425.0000, 'ºC'),
	(145772, 119, '2014-01-15 00:03:58.000000', 'temperatura', 755.0000, 'ºC'),
	(145773, 119, '2014-01-15 00:03:59.000000', 'temperatura', 100.0000, 'ºC'),
	(145774, 119, '2014-01-15 00:04:00.000000', 'temperatura', 638.0000, 'ºC'),
	(145775, 119, '2014-01-15 00:04:01.000000', 'temperatura', 488.0000, 'ºC'),
	(145776, 119, '2014-01-15 00:04:02.000000', 'temperatura', 526.0000, 'ºC'),
	(145777, 119, '2014-01-15 00:04:03.000000', 'temperatura', 1169.0000, 'ºC'),
	(145778, 119, '2014-01-15 00:04:04.000000', 'temperatura', 668.0000, 'ºC'),
	(145779, 119, '2014-01-15 00:04:05.000000', 'temperatura', 1032.0000, 'ºC'),
	(145780, 119, '2014-01-15 00:04:06.000000', 'temperatura', 758.0000, 'ºC'),
	(145781, 119, '2014-01-15 00:04:07.000000', 'temperatura', 692.0000, 'ºC'),
	(145782, 119, '2014-01-15 00:04:08.000000', 'temperatura', 1188.0000, 'ºC'),
	(145783, 119, '2014-01-15 00:04:09.000000', 'temperatura', 264.0000, 'ºC'),
	(145784, 119, '2014-01-15 00:04:10.000000', 'temperatura', 156.0000, 'ºC'),
	(145785, 119, '2014-01-15 00:04:11.000000', 'temperatura', 1187.0000, 'ºC'),
	(145786, 119, '2014-01-15 00:04:12.000000', 'temperatura', 668.0000, 'ºC'),
	(145787, 119, '2014-01-15 00:04:13.000000', 'temperatura', 982.0000, 'ºC'),
	(145788, 119, '2014-01-15 00:04:14.000000', 'temperatura', 505.0000, 'ºC'),
	(145789, 119, '2014-01-15 00:04:15.000000', 'temperatura', 778.0000, 'ºC'),
	(145790, 119, '2014-01-15 00:04:16.000000', 'temperatura', 1175.0000, 'ºC'),
	(145791, 119, '2014-01-15 00:04:17.000000', 'temperatura', 1142.0000, 'ºC'),
	(145792, 119, '2014-01-15 00:04:18.000000', 'temperatura', 985.0000, 'ºC'),
	(145793, 119, '2014-01-15 00:04:19.000000', 'temperatura', 301.0000, 'ºC'),
	(145794, 119, '2014-01-15 00:04:20.000000', 'temperatura', 950.0000, 'ºC'),
	(145795, 119, '2014-01-15 00:04:21.000000', 'temperatura', 246.0000, 'ºC'),
	(145796, 119, '2014-01-15 00:04:22.000000', 'temperatura', 782.0000, 'ºC'),
	(145797, 119, '2014-01-15 00:04:23.000000', 'temperatura', 770.0000, 'ºC'),
	(145798, 119, '2014-01-15 00:04:24.000000', 'temperatura', 307.0000, 'ºC'),
	(145799, 119, '2014-01-15 00:04:25.000000', 'temperatura', 423.0000, 'ºC'),
	(145800, 119, '2014-01-15 00:04:26.000000', 'temperatura', 1195.0000, 'ºC'),
	(145801, 119, '2014-01-15 00:04:27.000000', 'temperatura', 1109.0000, 'ºC'),
	(145802, 119, '2014-01-15 00:04:28.000000', 'temperatura', 759.0000, 'ºC'),
	(145803, 119, '2014-01-15 00:04:29.000000', 'temperatura', 470.0000, 'ºC'),
	(145804, 119, '2014-01-15 00:04:30.000000', 'temperatura', 70.0000, 'ºC'),
	(145805, 119, '2014-01-15 00:04:31.000000', 'temperatura', 144.0000, 'ºC'),
	(145806, 119, '2014-01-15 00:04:32.000000', 'temperatura', 509.0000, 'ºC'),
	(145807, 119, '2014-01-15 00:04:33.000000', 'temperatura', 913.0000, 'ºC'),
	(145808, 119, '2014-01-15 00:04:34.000000', 'temperatura', 638.0000, 'ºC'),
	(145809, 119, '2014-01-15 00:04:35.000000', 'temperatura', 454.0000, 'ºC'),
	(145810, 119, '2014-01-15 00:04:36.000000', 'temperatura', 356.0000, 'ºC'),
	(145811, 119, '2014-01-15 00:04:37.000000', 'temperatura', 419.0000, 'ºC'),
	(145812, 119, '2014-01-15 00:04:38.000000', 'temperatura', 1028.0000, 'ºC'),
	(145813, 119, '2014-01-15 00:04:39.000000', 'temperatura', 281.0000, 'ºC'),
	(145814, 119, '2014-01-15 00:04:40.000000', 'temperatura', 724.0000, 'ºC'),
	(145815, 119, '2014-01-15 00:04:41.000000', 'temperatura', 378.0000, 'ºC'),
	(145816, 119, '2014-01-15 00:04:42.000000', 'temperatura', 916.0000, 'ºC'),
	(145817, 119, '2014-01-15 00:04:43.000000', 'temperatura', 1049.0000, 'ºC'),
	(145818, 119, '2014-01-15 00:04:44.000000', 'temperatura', 95.0000, 'ºC'),
	(145819, 119, '2014-01-15 00:04:45.000000', 'temperatura', 931.0000, 'ºC'),
	(145820, 119, '2014-01-15 00:04:46.000000', 'temperatura', 769.0000, 'ºC'),
	(145821, 119, '2014-01-15 00:04:47.000000', 'temperatura', 1052.0000, 'ºC'),
	(145822, 119, '2014-01-15 00:04:48.000000', 'temperatura', 552.0000, 'ºC'),
	(145823, 119, '2014-01-15 00:04:49.000000', 'temperatura', 807.0000, 'ºC'),
	(145824, 119, '2014-01-15 00:04:50.000000', 'temperatura', 1179.0000, 'ºC'),
	(145825, 119, '2014-01-15 00:04:51.000000', 'temperatura', 1075.0000, 'ºC'),
	(145826, 119, '2014-01-15 00:04:52.000000', 'temperatura', 638.0000, 'ºC'),
	(145827, 119, '2014-01-15 00:04:53.000000', 'temperatura', 1167.0000, 'ºC'),
	(145828, 119, '2014-01-15 00:04:54.000000', 'temperatura', 320.0000, 'ºC'),
	(145829, 119, '2014-01-15 00:04:55.000000', 'temperatura', 500.0000, 'ºC'),
	(145830, 119, '2014-01-15 00:04:56.000000', 'temperatura', 342.0000, 'ºC'),
	(145831, 119, '2014-01-15 00:04:57.000000', 'temperatura', 210.0000, 'ºC'),
	(145832, 119, '2014-01-15 00:04:58.000000', 'temperatura', 26.0000, 'ºC'),
	(145833, 119, '2014-01-15 00:04:59.000000', 'temperatura', 697.0000, 'ºC'),
	(145834, 119, '2014-01-15 00:05:00.000000', 'temperatura', 1009.0000, 'ºC'),
	(145835, 119, '2014-01-15 00:05:01.000000', 'temperatura', 556.0000, 'ºC'),
	(145836, 119, '2014-01-15 00:05:02.000000', 'temperatura', 950.0000, 'ºC'),
	(145837, 119, '2014-01-15 00:05:03.000000', 'temperatura', 686.0000, 'ºC'),
	(145838, 119, '2014-01-15 00:05:04.000000', 'temperatura', 579.0000, 'ºC'),
	(145839, 119, '2014-01-15 00:05:05.000000', 'temperatura', 836.0000, 'ºC'),
	(145840, 119, '2014-01-15 00:05:06.000000', 'temperatura', 43.0000, 'ºC'),
	(145841, 119, '2014-01-15 00:05:07.000000', 'temperatura', 110.0000, 'ºC'),
	(145842, 119, '2014-01-15 00:05:08.000000', 'temperatura', 422.0000, 'ºC'),
	(145843, 119, '2014-01-15 00:05:09.000000', 'temperatura', 581.0000, 'ºC'),
	(145844, 119, '2014-01-15 00:05:10.000000', 'temperatura', 439.0000, 'ºC'),
	(145845, 119, '2014-01-15 00:05:11.000000', 'temperatura', 452.0000, 'ºC'),
	(145846, 119, '2014-01-15 00:05:12.000000', 'temperatura', 944.0000, 'ºC'),
	(145847, 119, '2014-01-15 00:05:13.000000', 'temperatura', 965.0000, 'ºC'),
	(145848, 119, '2014-01-15 00:05:14.000000', 'temperatura', 791.0000, 'ºC'),
	(145849, 119, '2014-01-15 00:05:15.000000', 'temperatura', 1064.0000, 'ºC'),
	(145850, 119, '2014-01-15 00:05:16.000000', 'temperatura', 546.0000, 'ºC'),
	(145851, 119, '2014-01-15 00:05:17.000000', 'temperatura', 737.0000, 'ºC'),
	(145852, 119, '2014-01-15 00:05:18.000000', 'temperatura', 846.0000, 'ºC'),
	(145853, 119, '2014-01-15 00:05:19.000000', 'temperatura', 823.0000, 'ºC'),
	(145854, 119, '2014-01-15 00:05:20.000000', 'temperatura', 377.0000, 'ºC'),
	(145855, 119, '2014-01-15 00:05:21.000000', 'temperatura', 617.0000, 'ºC'),
	(145856, 119, '2014-01-15 00:05:22.000000', 'temperatura', 753.0000, 'ºC'),
	(145857, 119, '2014-01-15 00:05:23.000000', 'temperatura', 717.0000, 'ºC'),
	(145858, 119, '2014-01-15 00:05:24.000000', 'temperatura', 124.0000, 'ºC'),
	(145859, 119, '2014-01-15 00:05:25.000000', 'temperatura', 869.0000, 'ºC'),
	(145860, 119, '2014-01-15 00:05:26.000000', 'temperatura', 375.0000, 'ºC'),
	(145861, 119, '2014-01-15 00:05:27.000000', 'temperatura', 469.0000, 'ºC'),
	(145862, 119, '2014-01-15 00:05:28.000000', 'temperatura', 21.0000, 'ºC'),
	(145863, 119, '2014-01-15 00:05:29.000000', 'temperatura', 1098.0000, 'ºC'),
	(145864, 119, '2014-01-15 00:05:30.000000', 'temperatura', 625.0000, 'ºC'),
	(145865, 119, '2014-01-15 00:05:31.000000', 'temperatura', 1035.0000, 'ºC'),
	(145866, 119, '2014-01-15 00:05:32.000000', 'temperatura', 897.0000, 'ºC'),
	(145867, 119, '2014-01-15 00:05:33.000000', 'temperatura', 183.0000, 'ºC'),
	(145868, 119, '2014-01-15 00:05:34.000000', 'temperatura', 625.0000, 'ºC'),
	(145869, 119, '2014-01-15 00:05:35.000000', 'temperatura', 178.0000, 'ºC'),
	(145870, 119, '2014-01-15 00:05:36.000000', 'temperatura', 213.0000, 'ºC'),
	(145871, 119, '2014-01-15 00:05:37.000000', 'temperatura', 531.0000, 'ºC'),
	(145872, 119, '2014-01-15 00:05:38.000000', 'temperatura', 816.0000, 'ºC'),
	(145873, 119, '2014-01-15 00:05:39.000000', 'temperatura', 87.0000, 'ºC'),
	(145874, 119, '2014-01-15 00:05:40.000000', 'temperatura', 386.0000, 'ºC'),
	(145875, 119, '2014-01-15 00:05:41.000000', 'temperatura', 473.0000, 'ºC'),
	(145876, 119, '2014-01-15 00:05:42.000000', 'temperatura', 7.0000, 'ºC'),
	(145877, 119, '2014-01-15 00:05:43.000000', 'temperatura', 1015.0000, 'ºC'),
	(145878, 119, '2014-01-15 00:05:44.000000', 'temperatura', 253.0000, 'ºC'),
	(145879, 119, '2014-01-15 00:05:45.000000', 'temperatura', 624.0000, 'ºC'),
	(145880, 119, '2014-01-15 00:05:46.000000', 'temperatura', 1161.0000, 'ºC'),
	(145881, 119, '2014-01-15 00:05:47.000000', 'temperatura', 332.0000, 'ºC'),
	(145882, 119, '2014-01-15 00:05:48.000000', 'temperatura', 578.0000, 'ºC'),
	(145883, 119, '2014-01-15 00:05:49.000000', 'temperatura', 692.0000, 'ºC'),
	(145884, 119, '2014-01-15 00:05:50.000000', 'temperatura', 530.0000, 'ºC'),
	(145885, 119, '2014-01-15 00:05:51.000000', 'temperatura', 575.0000, 'ºC'),
	(145886, 119, '2014-01-15 00:05:52.000000', 'temperatura', 82.0000, 'ºC'),
	(145887, 119, '2014-01-15 00:05:53.000000', 'temperatura', 1088.0000, 'ºC'),
	(145888, 119, '2014-01-15 00:05:54.000000', 'temperatura', 396.0000, 'ºC'),
	(145889, 119, '2014-01-15 00:05:55.000000', 'temperatura', 1113.0000, 'ºC'),
	(145890, 119, '2014-01-15 00:05:56.000000', 'temperatura', 780.0000, 'ºC'),
	(145891, 119, '2014-01-15 00:05:57.000000', 'temperatura', 559.0000, 'ºC'),
	(145892, 119, '2014-01-15 00:05:58.000000', 'temperatura', 458.0000, 'ºC'),
	(145893, 119, '2014-01-15 00:05:59.000000', 'temperatura', 611.0000, 'ºC'),
	(145894, 119, '2014-01-15 00:06:00.000000', 'temperatura', 482.0000, 'ºC'),
	(145895, 119, '2014-01-15 00:06:01.000000', 'temperatura', 577.0000, 'ºC'),
	(145896, 119, '2014-01-15 00:06:02.000000', 'temperatura', 239.0000, 'ºC'),
	(145897, 119, '2014-01-15 00:06:03.000000', 'temperatura', 665.0000, 'ºC'),
	(145898, 119, '2014-01-15 00:06:04.000000', 'temperatura', 210.0000, 'ºC'),
	(145899, 119, '2014-01-15 00:06:05.000000', 'temperatura', 256.0000, 'ºC'),
	(145900, 119, '2014-01-15 00:06:06.000000', 'temperatura', 650.0000, 'ºC'),
	(145901, 119, '2014-01-15 00:06:07.000000', 'temperatura', 81.0000, 'ºC'),
	(145902, 119, '2014-01-15 00:06:08.000000', 'temperatura', 858.0000, 'ºC'),
	(145903, 119, '2014-01-15 00:06:09.000000', 'temperatura', 447.0000, 'ºC'),
	(145904, 119, '2014-01-15 00:06:10.000000', 'temperatura', 860.0000, 'ºC'),
	(145905, 119, '2014-01-15 00:06:11.000000', 'temperatura', 558.0000, 'ºC'),
	(145906, 119, '2014-01-15 00:06:12.000000', 'temperatura', 214.0000, 'ºC'),
	(145907, 119, '2014-01-15 00:06:13.000000', 'temperatura', 595.0000, 'ºC'),
	(145908, 119, '2014-01-15 00:06:14.000000', 'temperatura', 1132.0000, 'ºC'),
	(145909, 119, '2014-01-15 00:06:15.000000', 'temperatura', 278.0000, 'ºC'),
	(145910, 119, '2014-01-15 00:06:16.000000', 'temperatura', 393.0000, 'ºC'),
	(145911, 119, '2014-01-15 00:06:17.000000', 'temperatura', 1134.0000, 'ºC'),
	(145912, 119, '2014-01-15 00:06:18.000000', 'temperatura', 890.0000, 'ºC'),
	(145913, 119, '2014-01-15 00:06:19.000000', 'temperatura', 1047.0000, 'ºC'),
	(145914, 119, '2014-01-15 00:06:20.000000', 'temperatura', 167.0000, 'ºC'),
	(145915, 119, '2014-01-15 00:06:21.000000', 'temperatura', 94.0000, 'ºC'),
	(145916, 119, '2014-01-15 00:06:22.000000', 'temperatura', 1168.0000, 'ºC'),
	(145917, 119, '2014-01-15 00:06:23.000000', 'temperatura', 762.0000, 'ºC'),
	(145918, 119, '2014-01-15 00:06:24.000000', 'temperatura', 303.0000, 'ºC'),
	(145919, 119, '2014-01-15 00:06:25.000000', 'temperatura', 430.0000, 'ºC'),
	(145920, 119, '2014-01-15 00:06:26.000000', 'temperatura', 44.0000, 'ºC'),
	(145921, 119, '2014-01-15 00:06:27.000000', 'temperatura', 129.0000, 'ºC'),
	(145922, 119, '2014-01-15 00:06:28.000000', 'temperatura', 514.0000, 'ºC'),
	(145923, 119, '2014-01-15 00:06:29.000000', 'temperatura', 985.0000, 'ºC'),
	(145924, 119, '2014-01-15 00:06:30.000000', 'temperatura', 980.0000, 'ºC'),
	(145925, 119, '2014-01-15 00:06:31.000000', 'temperatura', 748.0000, 'ºC'),
	(145926, 119, '2014-01-15 00:06:32.000000', 'temperatura', 801.0000, 'ºC'),
	(145927, 119, '2014-01-15 00:06:33.000000', 'temperatura', 562.0000, 'ºC'),
	(145928, 119, '2014-01-15 00:06:34.000000', 'temperatura', 407.0000, 'ºC'),
	(145929, 119, '2014-01-15 00:06:35.000000', 'temperatura', 348.0000, 'ºC'),
	(145930, 119, '2014-01-15 00:06:36.000000', 'temperatura', 521.0000, 'ºC'),
	(145931, 119, '2014-01-15 00:06:37.000000', 'temperatura', 361.0000, 'ºC'),
	(145932, 119, '2014-01-15 00:06:38.000000', 'temperatura', 244.0000, 'ºC'),
	(145933, 119, '2014-01-15 00:06:39.000000', 'temperatura', 135.0000, 'ºC'),
	(145934, 119, '2014-01-15 00:06:40.000000', 'temperatura', 1143.0000, 'ºC'),
	(145935, 119, '2014-01-15 00:06:41.000000', 'temperatura', 510.0000, 'ºC'),
	(145936, 119, '2014-01-15 00:06:42.000000', 'temperatura', 324.0000, 'ºC'),
	(145937, 119, '2014-01-15 00:06:43.000000', 'temperatura', 91.0000, 'ºC'),
	(145938, 119, '2014-01-15 00:06:44.000000', 'temperatura', 682.0000, 'ºC'),
	(145939, 119, '2014-01-15 00:06:45.000000', 'temperatura', 738.0000, 'ºC'),
	(145940, 119, '2014-01-15 00:06:46.000000', 'temperatura', 444.0000, 'ºC'),
	(145941, 119, '2014-01-15 00:06:47.000000', 'temperatura', 5.0000, 'ºC'),
	(145942, 119, '2014-01-15 00:06:48.000000', 'temperatura', 1097.0000, 'ºC'),
	(145943, 119, '2014-01-15 00:06:49.000000', 'temperatura', 667.0000, 'ºC'),
	(145944, 119, '2014-01-15 00:06:50.000000', 'temperatura', 47.0000, 'ºC'),
	(145945, 119, '2014-01-15 00:06:51.000000', 'temperatura', 636.0000, 'ºC'),
	(145946, 119, '2014-01-15 00:06:52.000000', 'temperatura', 637.0000, 'ºC'),
	(145947, 119, '2014-01-15 00:06:53.000000', 'temperatura', 77.0000, 'ºC'),
	(145948, 119, '2014-01-15 00:06:54.000000', 'temperatura', 876.0000, 'ºC'),
	(145949, 119, '2014-01-15 00:06:55.000000', 'temperatura', 547.0000, 'ºC'),
	(145950, 119, '2014-01-15 00:06:56.000000', 'temperatura', 111.0000, 'ºC'),
	(145951, 119, '2014-01-15 00:06:57.000000', 'temperatura', 111.0000, 'ºC'),
	(145952, 119, '2014-01-15 00:06:58.000000', 'temperatura', 224.0000, 'ºC'),
	(145953, 119, '2014-01-15 00:06:59.000000', 'temperatura', 788.0000, 'ºC'),
	(145954, 119, '2014-01-15 00:07:00.000000', 'temperatura', 867.0000, 'ºC'),
	(145955, 119, '2014-01-15 00:07:01.000000', 'temperatura', 774.0000, 'ºC'),
	(145956, 119, '2014-01-15 00:07:02.000000', 'temperatura', 69.0000, 'ºC'),
	(145957, 119, '2014-01-15 00:07:03.000000', 'temperatura', 424.0000, 'ºC'),
	(145958, 119, '2014-01-15 00:07:04.000000', 'temperatura', 714.0000, 'ºC'),
	(145959, 119, '2014-01-15 00:07:05.000000', 'temperatura', 1100.0000, 'ºC'),
	(145960, 119, '2014-01-15 00:07:06.000000', 'temperatura', 956.0000, 'ºC'),
	(145961, 119, '2014-01-15 00:07:07.000000', 'temperatura', 279.0000, 'ºC'),
	(145962, 119, '2014-01-15 00:07:08.000000', 'temperatura', 929.0000, 'ºC'),
	(145963, 119, '2014-01-15 00:07:09.000000', 'temperatura', 209.0000, 'ºC'),
	(145964, 119, '2014-01-15 00:07:10.000000', 'temperatura', 660.0000, 'ºC'),
	(145965, 119, '2014-01-15 00:07:11.000000', 'temperatura', 270.0000, 'ºC'),
	(145966, 119, '2014-01-15 00:07:12.000000', 'temperatura', 573.0000, 'ºC'),
	(145967, 119, '2014-01-15 00:07:13.000000', 'temperatura', 854.0000, 'ºC'),
	(145968, 119, '2014-01-15 00:07:14.000000', 'temperatura', 150.0000, 'ºC'),
	(145969, 119, '2014-01-15 00:07:15.000000', 'temperatura', 591.0000, 'ºC'),
	(145970, 119, '2014-01-15 00:07:16.000000', 'temperatura', 106.0000, 'ºC'),
	(145971, 119, '2014-01-15 00:07:17.000000', 'temperatura', 1156.0000, 'ºC'),
	(145972, 119, '2014-01-15 00:07:18.000000', 'temperatura', 663.0000, 'ºC'),
	(145973, 119, '2014-01-15 00:07:19.000000', 'temperatura', 1049.0000, 'ºC'),
	(145974, 119, '2014-01-15 00:07:20.000000', 'temperatura', 856.0000, 'ºC'),
	(145975, 119, '2014-01-15 00:07:21.000000', 'temperatura', 1135.0000, 'ºC'),
	(145976, 119, '2014-01-15 00:07:22.000000', 'temperatura', 705.0000, 'ºC'),
	(145977, 119, '2014-01-15 00:07:23.000000', 'temperatura', 120.0000, 'ºC'),
	(145978, 119, '2014-01-15 00:07:24.000000', 'temperatura', 885.0000, 'ºC'),
	(145979, 119, '2014-01-15 00:07:25.000000', 'temperatura', 467.0000, 'ºC'),
	(145980, 119, '2014-01-15 00:07:26.000000', 'temperatura', 881.0000, 'ºC'),
	(145981, 119, '2014-01-15 00:07:27.000000', 'temperatura', 602.0000, 'ºC'),
	(145982, 119, '2014-01-15 00:07:28.000000', 'temperatura', 371.0000, 'ºC'),
	(145983, 119, '2014-01-15 00:07:29.000000', 'temperatura', 47.0000, 'ºC'),
	(145984, 119, '2014-01-15 00:07:30.000000', 'temperatura', 323.0000, 'ºC'),
	(145985, 119, '2014-01-15 00:07:31.000000', 'temperatura', 276.0000, 'ºC'),
	(145986, 119, '2014-01-15 00:07:32.000000', 'temperatura', 412.0000, 'ºC'),
	(145987, 119, '2014-01-15 00:07:33.000000', 'temperatura', 31.0000, 'ºC'),
	(145988, 119, '2014-01-15 00:07:34.000000', 'temperatura', 119.0000, 'ºC'),
	(145989, 119, '2014-01-15 00:07:35.000000', 'temperatura', 505.0000, 'ºC'),
	(145990, 119, '2014-01-15 00:07:36.000000', 'temperatura', 966.0000, 'ºC'),
	(145991, 119, '2014-01-15 00:07:37.000000', 'temperatura', 914.0000, 'ºC'),
	(145992, 119, '2014-01-15 00:07:38.000000', 'temperatura', 475.0000, 'ºC'),
	(145993, 119, '2014-01-15 00:07:39.000000', 'temperatura', 834.0000, 'ºC'),
	(145994, 119, '2014-01-15 00:07:40.000000', 'temperatura', 343.0000, 'ºC'),
	(145995, 119, '2014-01-15 00:07:41.000000', 'temperatura', 416.0000, 'ºC'),
	(145996, 119, '2014-01-15 00:07:42.000000', 'temperatura', 1050.0000, 'ºC'),
	(145997, 119, '2014-01-15 00:07:43.000000', 'temperatura', 404.0000, 'ºC'),
	(145998, 119, '2014-01-15 00:07:44.000000', 'temperatura', 69.0000, 'ºC'),
	(145999, 119, '2014-01-15 00:07:45.000000', 'temperatura', 335.0000, 'ºC'),
	(146000, 119, '2014-01-15 00:07:46.000000', 'temperatura', 268.0000, 'ºC'),
	(146001, 119, '2014-01-15 00:07:47.000000', 'temperatura', 336.0000, 'ºC'),
	(146002, 119, '2014-01-15 00:07:48.000000', 'temperatura', 876.0000, 'ºC'),
	(146003, 119, '2014-01-15 00:07:49.000000', 'temperatura', 973.0000, 'ºC'),
	(146004, 119, '2014-01-15 00:07:50.000000', 'temperatura', 1038.0000, 'ºC'),
	(146005, 119, '2014-01-15 00:07:51.000000', 'temperatura', 1071.0000, 'ºC'),
	(146006, 119, '2014-01-15 00:07:52.000000', 'temperatura', 1040.0000, 'ºC'),
	(146007, 119, '2014-01-15 00:07:53.000000', 'temperatura', 787.0000, 'ºC'),
	(146008, 119, '2014-01-15 00:07:54.000000', 'temperatura', 819.0000, 'ºC'),
	(146009, 119, '2014-01-15 00:07:55.000000', 'temperatura', 531.0000, 'ºC'),
	(146010, 119, '2014-01-15 00:07:56.000000', 'temperatura', 199.0000, 'ºC'),
	(146011, 119, '2014-01-15 00:07:57.000000', 'temperatura', 601.0000, 'ºC'),
	(146012, 119, '2014-01-15 00:07:58.000000', 'temperatura', 12.0000, 'ºC'),
	(146013, 119, '2014-01-15 00:07:59.000000', 'temperatura', 654.0000, 'ºC'),
	(146014, 119, '2014-01-15 00:08:00.000000', 'temperatura', 837.0000, 'ºC'),
	(146015, 119, '2014-01-15 00:08:01.000000', 'temperatura', 1024.0000, 'ºC'),
	(146016, 119, '2014-01-15 00:08:02.000000', 'temperatura', 211.0000, 'ºC'),
	(146017, 119, '2014-01-15 00:08:03.000000', 'temperatura', 381.0000, 'ºC'),
	(146018, 119, '2014-01-15 00:08:04.000000', 'temperatura', 72.0000, 'ºC'),
	(146019, 119, '2014-01-15 00:08:05.000000', 'temperatura', 417.0000, 'ºC'),
	(146020, 119, '2014-01-15 00:08:06.000000', 'temperatura', 669.0000, 'ºC'),
	(146021, 119, '2014-01-15 00:08:07.000000', 'temperatura', 895.0000, 'ºC'),
	(146022, 119, '2014-01-15 00:08:08.000000', 'temperatura', 70.0000, 'ºC'),
	(146023, 119, '2014-01-15 00:08:09.000000', 'temperatura', 63.0000, 'ºC'),
	(146024, 119, '2014-01-15 00:08:10.000000', 'temperatura', 105.0000, 'ºC'),
	(146025, 119, '2014-01-15 00:08:11.000000', 'temperatura', 340.0000, 'ºC'),
	(146026, 119, '2014-01-15 00:08:12.000000', 'temperatura', 182.0000, 'ºC'),
	(146027, 119, '2014-01-15 00:08:13.000000', 'temperatura', 1092.0000, 'ºC'),
	(146028, 119, '2014-01-15 00:08:14.000000', 'temperatura', 115.0000, 'ºC'),
	(146029, 119, '2014-01-15 00:08:15.000000', 'temperatura', 899.0000, 'ºC'),
	(146030, 119, '2014-01-15 00:08:16.000000', 'temperatura', 550.0000, 'ºC'),
	(146031, 119, '2014-01-15 00:08:17.000000', 'temperatura', 53.0000, 'ºC'),
	(146032, 119, '2014-01-15 00:08:18.000000', 'temperatura', 1014.0000, 'ºC'),
	(146033, 119, '2014-01-15 00:08:19.000000', 'temperatura', 115.0000, 'ºC'),
	(146034, 119, '2014-01-15 00:08:20.000000', 'temperatura', 1130.0000, 'ºC'),
	(146035, 119, '2014-01-15 00:08:21.000000', 'temperatura', 509.0000, 'ºC'),
	(146036, 119, '2014-01-15 00:08:22.000000', 'temperatura', 353.0000, 'ºC'),
	(146037, 119, '2014-01-15 00:08:23.000000', 'temperatura', 240.0000, 'ºC'),
	(146038, 119, '2014-01-15 00:08:24.000000', 'temperatura', 140.0000, 'ºC'),
	(146039, 119, '2014-01-15 00:08:25.000000', 'temperatura', 1182.0000, 'ºC'),
	(146040, 119, '2014-01-15 00:08:26.000000', 'temperatura', 689.0000, 'ºC'),
	(146041, 119, '2014-01-15 00:08:27.000000', 'temperatura', 1099.0000, 'ºC'),
	(146042, 119, '2014-01-15 00:08:28.000000', 'temperatura', 1030.0000, 'ºC'),
	(146043, 119, '2014-01-15 00:08:29.000000', 'temperatura', 651.0000, 'ºC'),
	(146044, 119, '2014-01-15 00:08:30.000000', 'temperatura', 167.0000, 'ºC'),
	(146045, 119, '2014-01-15 00:08:31.000000', 'temperatura', 82.0000, 'ºC'),
	(146046, 119, '2014-01-15 00:08:32.000000', 'temperatura', 1109.0000, 'ºC'),
	(146047, 119, '2014-01-15 00:08:33.000000', 'temperatura', 500.0000, 'ºC'),
	(146048, 119, '2014-01-15 00:08:34.000000', 'temperatura', 376.0000, 'ºC'),
	(146049, 119, '2014-01-15 00:08:35.000000', 'temperatura', 377.0000, 'ºC'),
	(146050, 119, '2014-01-15 00:08:36.000000', 'temperatura', 758.0000, 'ºC'),
	(146051, 119, '2014-01-15 00:08:37.000000', 'temperatura', 262.0000, 'ºC'),
	(146052, 119, '2014-01-15 00:08:38.000000', 'temperatura', 236.0000, 'ºC'),
	(146053, 119, '2014-01-15 00:08:39.000000', 'temperatura', 393.0000, 'ºC'),
	(146054, 119, '2014-01-15 00:08:40.000000', 'temperatura', 56.0000, 'ºC'),
	(146055, 119, '2014-01-15 00:08:41.000000', 'temperatura', 303.0000, 'ºC'),
	(146056, 119, '2014-01-15 00:08:42.000000', 'temperatura', 148.0000, 'ºC'),
	(146057, 119, '2014-01-15 00:08:43.000000', 'temperatura', 1032.0000, 'ºC'),
	(146058, 119, '2014-01-15 00:08:44.000000', 'temperatura', 1114.0000, 'ºC'),
	(146059, 119, '2014-01-15 00:08:45.000000', 'temperatura', 76.0000, 'ºC'),
	(146060, 119, '2014-01-15 00:08:46.000000', 'temperatura', 637.0000, 'ºC'),
	(146061, 119, '2014-01-15 00:08:47.000000', 'temperatura', 560.0000, 'ºC'),
	(146062, 119, '2014-01-15 00:08:48.000000', 'temperatura', 890.0000, 'ºC'),
	(146063, 119, '2014-01-15 00:08:49.000000', 'temperatura', 368.0000, 'ºC'),
	(146064, 119, '2014-01-15 00:08:50.000000', 'temperatura', 371.0000, 'ºC'),
	(146065, 119, '2014-01-15 00:08:51.000000', 'temperatura', 750.0000, 'ºC'),
	(146066, 119, '2014-01-15 00:08:52.000000', 'temperatura', 239.0000, 'ºC'),
	(146067, 119, '2014-01-15 00:08:53.000000', 'temperatura', 145.0000, 'ºC'),
	(146068, 119, '2014-01-15 00:08:54.000000', 'temperatura', 8.0000, 'ºC'),
	(146069, 119, '2014-01-15 00:08:55.000000', 'temperatura', 807.0000, 'ºC'),
	(146070, 119, '2014-01-15 00:08:56.000000', 'temperatura', 409.0000, 'ºC'),
	(146071, 119, '2014-01-15 00:08:57.000000', 'temperatura', 827.0000, 'ºC'),
	(146072, 119, '2014-01-15 00:08:58.000000', 'temperatura', 508.0000, 'ºC'),
	(146073, 119, '2014-01-15 00:08:59.000000', 'temperatura', 58.0000, 'ºC'),
	(146074, 119, '2014-01-15 00:09:00.000000', 'temperatura', 1165.0000, 'ºC'),
	(146075, 119, '2014-01-15 00:09:01.000000', 'temperatura', 855.0000, 'ºC'),
	(146076, 119, '2014-01-15 00:09:02.000000', 'temperatura', 778.0000, 'ºC'),
	(146077, 119, '2014-01-15 00:09:03.000000', 'temperatura', 128.0000, 'ºC'),
	(146078, 119, '2014-01-15 00:09:04.000000', 'temperatura', 706.0000, 'ºC'),
	(146079, 119, '2014-01-15 00:09:05.000000', 'temperatura', 747.0000, 'ºC'),
	(146080, 119, '2014-01-15 00:09:06.000000', 'temperatura', 419.0000, 'ºC'),
	(146081, 119, '2014-01-15 00:09:07.000000', 'temperatura', 1052.0000, 'ºC'),
	(146082, 119, '2014-01-15 00:09:08.000000', 'temperatura', 403.0000, 'ºC'),
	(146083, 119, '2014-01-15 00:09:09.000000', 'temperatura', 60.0000, 'ºC'),
	(146084, 119, '2014-01-15 00:09:10.000000', 'temperatura', 291.0000, 'ºC'),
	(146085, 119, '2014-01-15 00:09:11.000000', 'temperatura', 74.0000, 'ºC'),
	(146086, 119, '2014-01-15 00:09:12.000000', 'temperatura', 699.0000, 'ºC'),
	(146087, 119, '2014-01-15 00:09:13.000000', 'temperatura', 872.0000, 'ºC'),
	(146088, 119, '2014-01-15 00:09:14.000000', 'temperatura', 1066.0000, 'ºC'),
	(146089, 119, '2014-01-15 00:09:15.000000', 'temperatura', 312.0000, 'ºC'),
	(146090, 119, '2014-01-15 00:09:16.000000', 'temperatura', 763.0000, 'ºC'),
	(146091, 119, '2014-01-15 00:09:17.000000', 'temperatura', 480.0000, 'ºC'),
	(146092, 119, '2014-01-15 00:09:18.000000', 'temperatura', 112.0000, 'ºC'),
	(146093, 119, '2014-01-15 00:09:19.000000', 'temperatura', 319.0000, 'ºC'),
	(146094, 119, '2014-01-15 00:09:20.000000', 'temperatura', 62.0000, 'ºC'),
	(146095, 119, '2014-01-15 00:09:21.000000', 'temperatura', 551.0000, 'ºC'),
	(146096, 119, '2014-01-15 00:09:22.000000', 'temperatura', 172.0000, 'ºC'),
	(146097, 119, '2014-01-15 00:09:23.000000', 'temperatura', 405.0000, 'ºC'),
	(146098, 119, '2014-01-15 00:09:24.000000', 'temperatura', 311.0000, 'ºC'),
	(146099, 119, '2014-01-15 00:09:25.000000', 'temperatura', 341.0000, 'ºC'),
	(146100, 119, '2014-01-15 00:09:26.000000', 'temperatura', 773.0000, 'ºC'),
	(146101, 119, '2014-01-15 00:09:27.000000', 'temperatura', 442.0000, 'ºC'),
	(146102, 119, '2014-01-15 00:09:28.000000', 'temperatura', 1091.0000, 'ºC'),
	(146103, 119, '2014-01-15 00:09:29.000000', 'temperatura', 528.0000, 'ºC'),
	(146104, 119, '2014-01-15 00:09:30.000000', 'temperatura', 568.0000, 'ºC'),
	(146105, 119, '2014-01-15 00:09:31.000000', 'temperatura', 56.0000, 'ºC'),
	(146106, 119, '2014-01-15 00:09:32.000000', 'temperatura', 978.0000, 'ºC'),
	(146107, 119, '2014-01-15 00:09:33.000000', 'temperatura', 1122.0000, 'ºC'),
	(146108, 119, '2014-01-15 00:09:34.000000', 'temperatura', 278.0000, 'ºC'),
	(146109, 119, '2014-01-15 00:09:35.000000', 'temperatura', 425.0000, 'ºC'),
	(146110, 119, '2014-01-15 00:09:36.000000', 'temperatura', 90.0000, 'ºC'),
	(146111, 119, '2014-01-15 00:09:37.000000', 'temperatura', 377.0000, 'ºC'),
	(146112, 119, '2014-01-15 00:09:38.000000', 'temperatura', 416.0000, 'ºC'),
	(146113, 119, '2014-01-15 00:09:39.000000', 'temperatura', 951.0000, 'ºC'),
	(146114, 119, '2014-01-15 00:09:40.000000', 'temperatura', 1104.0000, 'ºC'),
	(146115, 119, '2014-01-15 00:09:41.000000', 'temperatura', 269.0000, 'ºC'),
	(146116, 119, '2014-01-15 00:09:42.000000', 'temperatura', 433.0000, 'ºC'),
	(146117, 119, '2014-01-15 00:09:43.000000', 'temperatura', 159.0000, 'ºC'),
	(146118, 119, '2014-01-15 00:09:44.000000', 'temperatura', 697.0000, 'ºC'),
	(146119, 119, '2014-01-15 00:09:45.000000', 'temperatura', 608.0000, 'ºC'),
	(146120, 119, '2014-01-15 00:09:46.000000', 'temperatura', 948.0000, 'ºC'),
	(146121, 119, '2014-01-15 00:09:47.000000', 'temperatura', 516.0000, 'ºC'),
	(146122, 119, '2014-01-15 00:09:48.000000', 'temperatura', 936.0000, 'ºC'),
	(146123, 119, '2014-01-15 00:09:49.000000', 'temperatura', 734.0000, 'ºC'),
	(146124, 119, '2014-01-15 00:09:50.000000', 'temperatura', 860.0000, 'ºC'),
	(146125, 119, '2014-01-15 00:09:51.000000', 'temperatura', 901.0000, 'ºC'),
	(146126, 119, '2014-01-15 00:09:52.000000', 'temperatura', 723.0000, 'ºC'),
	(146127, 119, '2014-01-15 00:09:53.000000', 'temperatura', 913.0000, 'ºC'),
	(146128, 119, '2014-01-15 00:09:54.000000', 'temperatura', 1196.0000, 'ºC'),
	(146129, 119, '2014-01-15 00:09:55.000000', 'temperatura', 842.0000, 'ºC'),
	(146130, 119, '2014-01-15 00:09:56.000000', 'temperatura', 623.0000, 'ºC'),
	(146131, 119, '2014-01-15 00:09:57.000000', 'temperatura', 589.0000, 'ºC'),
	(146132, 119, '2014-01-15 00:09:58.000000', 'temperatura', 1078.0000, 'ºC'),
	(146133, 119, '2014-01-15 00:09:59.000000', 'temperatura', 23.0000, 'ºC'),
	(146134, 119, '2014-01-15 00:10:00.000000', 'temperatura', 479.0000, 'ºC'),
	(146135, 119, '2014-01-15 00:10:01.000000', 'temperatura', 1130.0000, 'ºC'),
	(146136, 119, '2014-01-15 00:10:02.000000', 'temperatura', 611.0000, 'ºC'),
	(146137, 119, '2014-01-15 00:10:03.000000', 'temperatura', 867.0000, 'ºC'),
	(146138, 119, '2014-01-15 00:10:04.000000', 'temperatura', 100.0000, 'ºC'),
	(146139, 119, '2014-01-15 00:10:05.000000', 'temperatura', 301.0000, 'ºC'),
	(146140, 119, '2014-01-15 00:10:06.000000', 'temperatura', 5.0000, 'ºC'),
	(146141, 119, '2014-01-15 00:10:07.000000', 'temperatura', 325.0000, 'ºC'),
	(146142, 119, '2014-01-15 00:10:08.000000', 'temperatura', 408.0000, 'ºC'),
	(146143, 119, '2014-01-15 00:10:09.000000', 'temperatura', 1067.0000, 'ºC'),
	(146144, 119, '2014-01-15 00:10:10.000000', 'temperatura', 509.0000, 'ºC'),
	(146145, 119, '2014-01-15 00:10:11.000000', 'temperatura', 548.0000, 'ºC'),
	(146146, 119, '2014-01-15 00:10:12.000000', 'temperatura', 10.0000, 'ºC'),
	(146147, 119, '2014-01-15 00:10:13.000000', 'temperatura', 810.0000, 'ºC'),
	(146148, 119, '2014-01-15 00:10:14.000000', 'temperatura', 417.0000, 'ºC'),
	(146149, 119, '2014-01-15 00:10:15.000000', 'temperatura', 858.0000, 'ºC'),
	(146150, 119, '2014-01-15 00:10:16.000000', 'temperatura', 640.0000, 'ºC'),
	(146151, 119, '2014-01-15 00:10:17.000000', 'temperatura', 625.0000, 'ºC'),
	(146152, 119, '2014-01-15 00:10:18.000000', 'temperatura', 8.0000, 'ºC'),
	(146153, 119, '2014-01-15 00:10:19.000000', 'temperatura', 562.0000, 'ºC'),
	(146154, 119, '2014-01-15 00:10:20.000000', 'temperatura', 388.0000, 'ºC'),
	(146155, 119, '2014-01-15 00:10:21.000000', 'temperatura', 253.0000, 'ºC'),
	(146156, 119, '2014-01-15 00:10:22.000000', 'temperatura', 101.0000, 'ºC'),
	(146157, 119, '2014-01-15 00:10:23.000000', 'temperatura', 946.0000, 'ºC'),
	(146158, 119, '2014-01-15 00:10:24.000000', 'temperatura', 827.0000, 'ºC'),
	(146159, 119, '2014-01-15 00:10:25.000000', 'temperatura', 99.0000, 'ºC'),
	(146160, 119, '2014-01-15 00:10:26.000000', 'temperatura', 414.0000, 'ºC'),
	(146161, 119, '2014-01-15 00:10:27.000000', 'temperatura', 576.0000, 'ºC'),
	(146162, 119, '2014-01-15 00:10:28.000000', 'temperatura', 436.0000, 'ºC'),
	(146163, 119, '2014-01-15 00:10:29.000000', 'temperatura', 452.0000, 'ºC'),
	(146164, 119, '2014-01-15 00:10:30.000000', 'temperatura', 953.0000, 'ºC'),
	(146165, 119, '2014-01-15 00:10:31.000000', 'temperatura', 1008.0000, 'ºC'),
	(146166, 119, '2014-01-15 00:10:32.000000', 'temperatura', 985.0000, 'ºC'),
	(146167, 119, '2014-01-15 00:10:33.000000', 'temperatura', 698.0000, 'ºC'),
	(146168, 119, '2014-01-15 00:10:34.000000', 'temperatura', 537.0000, 'ºC'),
	(146169, 119, '2014-01-15 00:10:35.000000', 'temperatura', 590.0000, 'ºC'),
	(146170, 119, '2014-01-15 00:10:36.000000', 'temperatura', 142.0000, 'ºC'),
	(146171, 119, '2014-01-15 00:10:37.000000', 'temperatura', 138.0000, 'ºC'),
	(146172, 119, '2014-01-15 00:10:38.000000', 'temperatura', 266.0000, 'ºC'),
	(146173, 119, '2014-01-15 00:10:39.000000', 'temperatura', 914.0000, 'ºC'),
	(146174, 119, '2014-01-15 00:10:40.000000', 'temperatura', 174.0000, 'ºC'),
	(146175, 119, '2014-01-15 00:10:41.000000', 'temperatura', 530.0000, 'ºC'),
	(146176, 119, '2014-01-15 00:10:42.000000', 'temperatura', 928.0000, 'ºC'),
	(146177, 119, '2014-01-15 00:10:43.000000', 'temperatura', 652.0000, 'ºC'),
	(146178, 119, '2014-01-15 00:10:44.000000', 'temperatura', 475.0000, 'ºC'),
	(146179, 119, '2014-01-15 00:10:45.000000', 'temperatura', 419.0000, 'ºC'),
	(146180, 119, '2014-01-15 00:10:46.000000', 'temperatura', 673.0000, 'ºC'),
	(146181, 119, '2014-01-15 00:10:47.000000', 'temperatura', 906.0000, 'ºC'),
	(146182, 119, '2014-01-15 00:10:48.000000', 'temperatura', 111.0000, 'ºC'),
	(146183, 119, '2014-01-15 00:10:49.000000', 'temperatura', 240.0000, 'ºC'),
	(146184, 119, '2014-01-15 00:10:50.000000', 'temperatura', 867.0000, 'ºC'),
	(146185, 119, '2014-01-15 00:10:51.000000', 'temperatura', 15.0000, 'ºC'),
	(146186, 119, '2014-01-15 00:10:52.000000', 'temperatura', 1074.0000, 'ºC'),
	(146187, 119, '2014-01-15 00:10:53.000000', 'temperatura', 524.0000, 'ºC'),
	(146188, 119, '2014-01-15 00:10:54.000000', 'temperatura', 599.0000, 'ºC'),
	(146189, 119, '2014-01-15 00:10:55.000000', 'temperatura', 226.0000, 'ºC'),
	(146190, 119, '2014-01-15 00:10:56.000000', 'temperatura', 532.0000, 'ºC'),
	(146191, 119, '2014-01-15 00:10:57.000000', 'temperatura', 783.0000, 'ºC'),
	(146192, 119, '2014-01-15 00:10:58.000000', 'temperatura', 1119.0000, 'ºC'),
	(146193, 119, '2014-01-15 00:10:59.000000', 'temperatura', 846.0000, 'ºC'),
	(146194, 119, '2014-01-15 00:11:00.000000', 'temperatura', 873.0000, 'ºC'),
	(146195, 119, '2014-01-15 00:11:01.000000', 'temperatura', 628.0000, 'ºC'),
	(146196, 119, '2014-01-15 00:11:02.000000', 'temperatura', 522.0000, 'ºC'),
	(146197, 119, '2014-01-15 00:11:03.000000', 'temperatura', 727.0000, 'ºC'),
	(146198, 119, '2014-01-15 00:11:04.000000', 'temperatura', 868.0000, 'ºC'),
	(146199, 119, '2014-01-15 00:11:05.000000', 'temperatura', 961.0000, 'ºC'),
	(146200, 119, '2014-01-15 00:11:06.000000', 'temperatura', 1002.0000, 'ºC'),
	(146201, 119, '2014-01-15 00:11:07.000000', 'temperatura', 925.0000, 'ºC'),
	(146202, 119, '2014-01-15 00:11:08.000000', 'temperatura', 423.0000, 'ºC'),
	(146203, 119, '2014-01-15 00:11:09.000000', 'temperatura', 537.0000, 'ºC'),
	(146204, 119, '2014-01-15 00:11:10.000000', 'temperatura', 217.0000, 'ºC'),
	(146205, 119, '2014-01-15 00:11:11.000000', 'temperatura', 675.0000, 'ºC'),
	(146206, 119, '2014-01-15 00:11:12.000000', 'temperatura', 326.0000, 'ºC'),
	(146207, 119, '2014-01-15 00:11:13.000000', 'temperatura', 805.0000, 'ºC'),
	(146208, 119, '2014-01-15 00:11:14.000000', 'temperatura', 649.0000, 'ºC'),
	(146209, 119, '2014-01-15 00:11:15.000000', 'temperatura', 829.0000, 'ºC'),
	(146210, 119, '2014-01-15 00:11:16.000000', 'temperatura', 997.0000, 'ºC'),
	(146211, 119, '2014-01-15 00:11:17.000000', 'temperatura', 102.0000, 'ºC'),
	(146212, 119, '2014-01-15 00:11:18.000000', 'temperatura', 1117.0000, 'ºC'),
	(146213, 119, '2014-01-15 00:11:19.000000', 'temperatura', 478.0000, 'ºC'),
	(146214, 119, '2014-01-15 00:11:20.000000', 'temperatura', 243.0000, 'ºC'),
	(146215, 119, '2014-01-15 00:11:21.000000', 'temperatura', 978.0000, 'ºC'),
	(146216, 119, '2014-01-15 00:11:22.000000', 'temperatura', 565.0000, 'ºC'),
	(146217, 119, '2014-01-15 00:11:23.000000', 'temperatura', 1090.0000, 'ºC'),
	(146218, 119, '2014-01-15 00:11:24.000000', 'temperatura', 157.0000, 'ºC'),
	(146219, 119, '2014-01-15 00:11:25.000000', 'temperatura', 1115.0000, 'ºC'),
	(146220, 119, '2014-01-15 00:11:26.000000', 'temperatura', 303.0000, 'ºC'),
	(146221, 119, '2014-01-15 00:11:27.000000', 'temperatura', 573.0000, 'ºC'),
	(146222, 119, '2014-01-15 00:11:28.000000', 'temperatura', 757.0000, 'ºC'),
	(146223, 119, '2014-01-15 00:11:29.000000', 'temperatura', 865.0000, 'ºC'),
	(146224, 119, '2014-01-15 00:11:30.000000', 'temperatura', 853.0000, 'ºC'),
	(146225, 119, '2014-01-15 00:11:31.000000', 'temperatura', 474.0000, 'ºC'),
	(146226, 119, '2014-01-15 00:11:32.000000', 'temperatura', 1009.0000, 'ºC'),
	(146227, 119, '2014-01-15 00:11:33.000000', 'temperatura', 24.0000, 'ºC'),
	(146228, 119, '2014-01-15 00:11:34.000000', 'temperatura', 695.0000, 'ºC'),
	(146229, 119, '2014-01-15 00:11:35.000000', 'temperatura', 1005.0000, 'ºC'),
	(146230, 119, '2014-01-15 00:11:36.000000', 'temperatura', 537.0000, 'ºC'),
	(146231, 119, '2014-01-15 00:11:37.000000', 'temperatura', 871.0000, 'ºC'),
	(146232, 119, '2014-01-15 00:11:38.000000', 'temperatura', 346.0000, 'ºC'),
	(146233, 119, '2014-01-15 00:11:39.000000', 'temperatura', 318.0000, 'ºC'),
	(146234, 119, '2014-01-15 00:11:40.000000', 'temperatura', 550.0000, 'ºC'),
	(146235, 119, '2014-01-15 00:11:41.000000', 'temperatura', 599.0000, 'ºC'),
	(146236, 119, '2014-01-15 00:11:42.000000', 'temperatura', 145.0000, 'ºC'),
	(146237, 119, '2014-01-15 00:11:43.000000', 'temperatura', 127.0000, 'ºC'),
	(146238, 119, '2014-01-15 00:11:44.000000', 'temperatura', 199.0000, 'ºC'),
	(146239, 119, '2014-01-15 00:11:45.000000', 'temperatura', 617.0000, 'ºC'),
	(146240, 119, '2014-01-15 00:11:46.000000', 'temperatura', 89.0000, 'ºC'),
	(146241, 119, '2014-01-15 00:11:47.000000', 'temperatura', 992.0000, 'ºC'),
	(146242, 119, '2014-01-15 00:11:48.000000', 'temperatura', 1093.0000, 'ºC'),
	(146243, 119, '2014-01-15 00:11:49.000000', 'temperatura', 92.0000, 'ºC'),
	(146244, 119, '2014-01-15 00:11:50.000000', 'temperatura', 781.0000, 'ºC'),
	(146245, 119, '2014-01-15 00:11:51.000000', 'temperatura', 28.0000, 'ºC'),
	(146246, 119, '2014-01-15 00:11:52.000000', 'temperatura', 197.0000, 'ºC'),
	(146247, 119, '2014-01-15 00:11:53.000000', 'temperatura', 904.0000, 'ºC'),
	(146248, 119, '2014-01-15 00:11:54.000000', 'temperatura', 327.0000, 'ºC'),
	(146249, 119, '2014-01-15 00:11:55.000000', 'temperatura', 126.0000, 'ºC'),
	(146250, 119, '2014-01-15 00:11:56.000000', 'temperatura', 849.0000, 'ºC'),
	(146251, 119, '2014-01-15 00:11:57.000000', 'temperatura', 266.0000, 'ºC'),
	(146252, 119, '2014-01-15 00:11:58.000000', 'temperatura', 1183.0000, 'ºC'),
	(146253, 119, '2014-01-15 00:11:59.000000', 'temperatura', 317.0000, 'ºC'),
	(146254, 119, '2014-01-15 00:12:00.000000', 'temperatura', 439.0000, 'ºC'),
	(146255, 119, '2014-01-15 00:12:01.000000', 'temperatura', 43.0000, 'ºC'),
	(146256, 119, '2014-01-15 00:12:02.000000', 'temperatura', 99.0000, 'ºC'),
	(146257, 119, '2014-01-15 00:12:03.000000', 'temperatura', 368.0000, 'ºC'),
	(146258, 119, '2014-01-15 00:12:04.000000', 'temperatura', 341.0000, 'ºC'),
	(146259, 119, '2014-01-15 00:12:05.000000', 'temperatura', 604.0000, 'ºC'),
	(146260, 119, '2014-01-15 00:12:06.000000', 'temperatura', 797.0000, 'ºC'),
	(146261, 119, '2014-01-15 00:12:07.000000', 'temperatura', 973.0000, 'ºC'),
	(146262, 119, '2014-01-15 00:12:08.000000', 'temperatura', 77.0000, 'ºC'),
	(146263, 119, '2014-01-15 00:12:09.000000', 'temperatura', 1063.0000, 'ºC'),
	(146264, 119, '2014-01-15 00:12:10.000000', 'temperatura', 284.0000, 'ºC'),
	(146265, 119, '2014-01-15 00:12:11.000000', 'temperatura', 634.0000, 'ºC'),
	(146266, 119, '2014-01-15 00:12:12.000000', 'temperatura', 1120.0000, 'ºC'),
	(146267, 119, '2014-01-15 00:12:13.000000', 'temperatura', 95.0000, 'ºC'),
	(146268, 119, '2014-01-15 00:12:14.000000', 'temperatura', 717.0000, 'ºC'),
	(146269, 119, '2014-01-15 00:12:15.000000', 'temperatura', 900.0000, 'ºC'),
	(146270, 119, '2014-01-15 00:12:16.000000', 'temperatura', 1150.0000, 'ºC'),
	(146271, 119, '2014-01-15 00:12:17.000000', 'temperatura', 651.0000, 'ºC'),
	(146272, 119, '2014-01-15 00:12:18.000000', 'temperatura', 1005.0000, 'ºC'),
	(146273, 119, '2014-01-15 00:12:19.000000', 'temperatura', 671.0000, 'ºC'),
	(146274, 119, '2014-01-15 00:12:20.000000', 'temperatura', 341.0000, 'ºC'),
	(146275, 119, '2014-01-15 00:12:21.000000', 'temperatura', 894.0000, 'ºC'),
	(146276, 119, '2014-01-15 00:12:22.000000', 'temperatura', 1048.0000, 'ºC'),
	(146277, 119, '2014-01-15 00:12:23.000000', 'temperatura', 159.0000, 'ºC'),
	(146278, 119, '2014-01-15 00:12:24.000000', 'temperatura', 49.0000, 'ºC'),
	(146279, 119, '2014-01-15 00:12:25.000000', 'temperatura', 970.0000, 'ºC'),
	(146280, 119, '2014-01-15 00:12:26.000000', 'temperatura', 1105.0000, 'ºC'),
	(146281, 119, '2014-01-15 00:12:27.000000', 'temperatura', 215.0000, 'ºC'),
	(146282, 119, '2014-01-15 00:12:28.000000', 'temperatura', 159.0000, 'ºC'),
	(146283, 119, '2014-01-15 00:12:29.000000', 'temperatura', 150.0000, 'ºC'),
	(146284, 119, '2014-01-15 00:12:30.000000', 'temperatura', 272.0000, 'ºC'),
	(146285, 119, '2014-01-15 00:12:31.000000', 'temperatura', 914.0000, 'ºC'),
	(146286, 119, '2014-01-15 00:12:32.000000', 'temperatura', 152.0000, 'ºC'),
	(146287, 119, '2014-01-15 00:12:33.000000', 'temperatura', 420.0000, 'ºC'),
	(146288, 119, '2014-01-15 00:12:34.000000', 'temperatura', 446.0000, 'ºC'),
	(146289, 119, '2014-01-15 00:12:35.000000', 'temperatura', 970.0000, 'ºC'),
	(146290, 119, '2014-01-15 00:12:36.000000', 'temperatura', 1111.0000, 'ºC'),
	(146291, 119, '2014-01-15 00:12:37.000000', 'temperatura', 248.0000, 'ºC'),
	(146292, 119, '2014-01-15 00:12:38.000000', 'temperatura', 307.0000, 'ºC'),
	(146293, 119, '2014-01-15 00:12:39.000000', 'temperatura', 789.0000, 'ºC'),
	(146294, 119, '2014-01-15 00:12:40.000000', 'temperatura', 625.0000, 'ºC'),
	(146295, 119, '2014-01-15 00:12:41.000000', 'temperatura', 759.0000, 'ºC'),
	(146296, 119, '2014-01-15 00:12:42.000000', 'temperatura', 721.0000, 'ºC'),
	(146297, 119, '2014-01-15 00:12:43.000000', 'temperatura', 129.0000, 'ºC'),
	(146298, 119, '2014-01-15 00:12:44.000000', 'temperatura', 882.0000, 'ºC'),
	(146299, 119, '2014-01-15 00:12:45.000000', 'temperatura', 422.0000, 'ºC'),
	(146300, 119, '2014-01-15 00:12:46.000000', 'temperatura', 666.0000, 'ºC'),
	(146301, 119, '2014-01-15 00:12:47.000000', 'temperatura', 865.0000, 'ºC'),
	(146302, 119, '2014-01-15 00:12:48.000000', 'temperatura', 1126.0000, 'ºC'),
	(146303, 119, '2014-01-15 00:12:49.000000', 'temperatura', 634.0000, 'ºC'),
	(146304, 119, '2014-01-15 00:12:50.000000', 'temperatura', 995.0000, 'ºC'),
	(146305, 119, '2014-01-15 00:12:51.000000', 'temperatura', 673.0000, 'ºC'),
	(146306, 119, '2014-01-15 00:12:52.000000', 'temperatura', 379.0000, 'ºC'),
	(146307, 119, '2014-01-15 00:12:53.000000', 'temperatura', 1079.0000, 'ºC'),
	(146308, 119, '2014-01-15 00:12:54.000000', 'temperatura', 656.0000, 'ºC'),
	(146309, 119, '2014-01-15 00:12:55.000000', 'temperatura', 45.0000, 'ºC'),
	(146310, 119, '2014-01-15 00:12:56.000000', 'temperatura', 658.0000, 'ºC'),
	(146311, 119, '2014-01-15 00:12:57.000000', 'temperatura', 754.0000, 'ºC'),
	(146312, 119, '2014-01-15 00:12:58.000000', 'temperatura', 599.0000, 'ºC'),
	(146313, 119, '2014-01-15 00:12:59.000000', 'temperatura', 731.0000, 'ºC'),
	(146314, 119, '2014-01-15 00:13:00.000000', 'temperatura', 658.0000, 'ºC'),
	(146315, 119, '2014-01-15 00:13:01.000000', 'temperatura', 1100.0000, 'ºC'),
	(146316, 119, '2014-01-15 00:13:02.000000', 'temperatura', 1124.0000, 'ºC'),
	(146317, 119, '2014-01-15 00:13:03.000000', 'temperatura', 1121.0000, 'ºC'),
	(146318, 119, '2014-01-15 00:13:04.000000', 'temperatura', 1035.0000, 'ºC'),
	(146319, 119, '2014-01-15 00:13:05.000000', 'temperatura', 611.0000, 'ºC'),
	(146320, 119, '2014-01-15 00:13:06.000000', 'temperatura', 1153.0000, 'ºC'),
	(146321, 119, '2014-01-15 00:13:07.000000', 'temperatura', 329.0000, 'ºC'),
	(146322, 119, '2014-01-15 00:13:08.000000', 'temperatura', 588.0000, 'ºC'),
	(146323, 119, '2014-01-15 00:13:09.000000', 'temperatura', 752.0000, 'ºC'),
	(146324, 119, '2014-01-15 00:13:10.000000', 'temperatura', 800.0000, 'ºC'),
	(146325, 119, '2014-01-15 00:13:11.000000', 'temperatura', 541.0000, 'ºC'),
	(146326, 119, '2014-01-15 00:13:12.000000', 'temperatura', 306.0000, 'ºC'),
	(146327, 119, '2014-01-15 00:13:13.000000', 'temperatura', 1107.0000, 'ºC'),
	(146328, 119, '2014-01-15 00:13:14.000000', 'temperatura', 1016.0000, 'ºC'),
	(146329, 119, '2014-01-15 00:13:15.000000', 'temperatura', 563.0000, 'ºC'),
	(146330, 119, '2014-01-15 00:13:16.000000', 'temperatura', 965.0000, 'ºC'),
	(146331, 119, '2014-01-15 00:13:17.000000', 'temperatura', 736.0000, 'ºC'),
	(146332, 119, '2014-01-15 00:13:18.000000', 'temperatura', 787.0000, 'ºC'),
	(146333, 119, '2014-01-15 00:13:19.000000', 'temperatura', 527.0000, 'ºC'),
	(146334, 119, '2014-01-15 00:13:20.000000', 'temperatura', 276.0000, 'ºC'),
	(146335, 119, '2014-01-15 00:13:21.000000', 'temperatura', 999.0000, 'ºC'),
	(146336, 119, '2014-01-15 00:13:22.000000', 'temperatura', 566.0000, 'ºC'),
	(146337, 119, '2014-01-15 00:13:23.000000', 'temperatura', 1035.0000, 'ºC'),
	(146338, 119, '2014-01-15 00:13:24.000000', 'temperatura', 1076.0000, 'ºC'),
	(146339, 119, '2014-01-15 00:13:25.000000', 'temperatura', 1074.0000, 'ºC'),
	(146340, 119, '2014-01-15 00:13:26.000000', 'temperatura', 946.0000, 'ºC'),
	(146341, 119, '2014-01-15 00:13:27.000000', 'temperatura', 307.0000, 'ºC'),
	(146342, 119, '2014-01-15 00:13:28.000000', 'temperatura', 1099.0000, 'ºC'),
	(146343, 119, '2014-01-15 00:13:29.000000', 'temperatura', 972.0000, 'ºC'),
	(146344, 119, '2014-01-15 00:13:30.000000', 'temperatura', 365.0000, 'ºC'),
	(146345, 119, '2014-01-15 00:13:31.000000', 'temperatura', 108.0000, 'ºC'),
	(146346, 119, '2014-01-15 00:13:32.000000', 'temperatura', 648.0000, 'ºC'),
	(146347, 119, '2014-01-15 00:13:33.000000', 'temperatura', 517.0000, 'ºC'),
	(146348, 119, '2014-01-15 00:13:34.000000', 'temperatura', 641.0000, 'ºC'),
	(146349, 119, '2014-01-15 00:13:35.000000', 'temperatura', 455.0000, 'ºC'),
	(146350, 119, '2014-01-15 00:13:36.000000', 'temperatura', 352.0000, 'ºC'),
	(146351, 119, '2014-01-15 00:13:37.000000', 'temperatura', 397.0000, 'ºC'),
	(146352, 119, '2014-01-15 00:13:38.000000', 'temperatura', 927.0000, 'ºC'),
	(146353, 119, '2014-01-15 00:13:39.000000', 'temperatura', 1044.0000, 'ºC'),
	(146354, 119, '2014-01-15 00:13:40.000000', 'temperatura', 40.0000, 'ºC'),
	(146355, 119, '2014-01-15 00:13:41.000000', 'temperatura', 669.0000, 'ºC'),
	(146356, 119, '2014-01-15 00:13:42.000000', 'temperatura', 827.0000, 'ºC'),
	(146357, 119, '2014-01-15 00:13:43.000000', 'temperatura', 926.0000, 'ºC'),
	(146358, 119, '2014-01-15 00:13:44.000000', 'temperatura', 949.0000, 'ºC'),
	(146359, 119, '2014-01-15 00:13:45.000000', 'temperatura', 770.0000, 'ºC'),
	(146360, 119, '2014-01-15 00:13:46.000000', 'temperatura', 1002.0000, 'ºC'),
	(146361, 119, '2014-01-15 00:13:47.000000', 'temperatura', 303.0000, 'ºC'),
	(146362, 119, '2014-01-15 00:13:48.000000', 'temperatura', 906.0000, 'ºC'),
	(146363, 119, '2014-01-15 00:13:49.000000', 'temperatura', 22.0000, 'ºC'),
	(146364, 119, '2014-01-15 00:13:50.000000', 'temperatura', 995.0000, 'ºC'),
	(146365, 119, '2014-01-15 00:13:51.000000', 'temperatura', 109.0000, 'ºC'),
	(146366, 119, '2014-01-15 00:13:52.000000', 'temperatura', 1159.0000, 'ºC'),
	(146367, 119, '2014-01-15 00:13:53.000000', 'temperatura', 669.0000, 'ºC'),
	(146368, 119, '2014-01-15 00:13:54.000000', 'temperatura', 1067.0000, 'ºC'),
	(146369, 119, '2014-01-15 00:13:55.000000', 'temperatura', 932.0000, 'ºC'),
	(146370, 119, '2014-01-15 00:13:56.000000', 'temperatura', 256.0000, 'ºC'),
	(146371, 119, '2014-01-15 00:13:57.000000', 'temperatura', 885.0000, 'ºC'),
	(146372, 119, '2014-01-15 00:13:58.000000', 'temperatura', 56.0000, 'ºC'),
	(146373, 119, '2014-01-15 00:13:59.000000', 'temperatura', 28.0000, 'ºC'),
	(146374, 119, '2014-01-15 00:14:00.000000', 'temperatura', 1171.0000, 'ºC'),
	(146375, 119, '2014-01-15 00:14:01.000000', 'temperatura', 972.0000, 'ºC'),
	(146376, 119, '2014-01-15 00:14:02.000000', 'temperatura', 146.0000, 'ºC'),
	(146377, 119, '2014-01-15 00:14:03.000000', 'temperatura', 214.0000, 'ºC'),
	(146378, 119, '2014-01-15 00:14:04.000000', 'temperatura', 632.0000, 'ºC'),
	(146379, 119, '2014-01-15 00:14:05.000000', 'temperatura', 118.0000, 'ºC'),
	(146380, 119, '2014-01-15 00:14:06.000000', 'temperatura', 1096.0000, 'ºC'),
	(146381, 119, '2014-01-15 00:14:07.000000', 'temperatura', 328.0000, 'ºC'),
	(146382, 119, '2014-01-15 00:14:08.000000', 'temperatura', 750.0000, 'ºC'),
	(146383, 119, '2014-01-15 00:14:09.000000', 'temperatura', 367.0000, 'ºC'),
	(146384, 119, '2014-01-15 00:14:10.000000', 'temperatura', 788.0000, 'ºC'),
	(146385, 119, '2014-01-15 00:14:11.000000', 'temperatura', 438.0000, 'ºC'),
	(146386, 119, '2014-01-15 00:14:12.000000', 'temperatura', 1025.0000, 'ºC'),
	(146387, 119, '2014-01-15 00:14:13.000000', 'temperatura', 211.0000, 'ºC'),
	(146388, 119, '2014-01-15 00:14:14.000000', 'temperatura', 380.0000, 'ºC'),
	(146389, 119, '2014-01-15 00:14:15.000000', 'temperatura', 67.0000, 'ºC'),
	(146390, 119, '2014-01-15 00:14:16.000000', 'temperatura', 399.0000, 'ºC'),
	(146391, 119, '2014-01-15 00:14:17.000000', 'temperatura', 591.0000, 'ºC'),
	(146392, 119, '2014-01-15 00:14:18.000000', 'temperatura', 559.0000, 'ºC'),
	(146393, 119, '2014-01-15 00:14:19.000000', 'temperatura', 1021.0000, 'ºC'),
	(146394, 119, '2014-01-15 00:14:20.000000', 'temperatura', 1031.0000, 'ºC'),
	(146395, 119, '2014-01-15 00:14:21.000000', 'temperatura', 891.0000, 'ºC'),
	(146396, 119, '2014-01-15 00:14:22.000000', 'temperatura', 161.0000, 'ºC'),
	(146397, 119, '2014-01-15 00:14:23.000000', 'temperatura', 536.0000, 'ºC'),
	(146398, 119, '2014-01-15 00:14:24.000000', 'temperatura', 995.0000, 'ºC'),
	(146399, 119, '2014-01-15 00:14:25.000000', 'temperatura', 969.0000, 'ºC'),
	(146400, 119, '2014-01-15 00:14:26.000000', 'temperatura', 660.0000, 'ºC'),
	(146401, 119, '2014-01-15 00:14:27.000000', 'temperatura', 393.0000, 'ºC'),
	(146402, 119, '2014-01-15 00:14:28.000000', 'temperatura', 1184.0000, 'ºC'),
	(146403, 119, '2014-01-15 00:14:29.000000', 'temperatura', 1143.0000, 'ºC'),
	(146404, 119, '2014-01-15 00:14:30.000000', 'temperatura', 962.0000, 'ºC'),
	(146405, 119, '2014-01-15 00:14:31.000000', 'temperatura', 181.0000, 'ºC'),
	(146406, 119, '2014-01-15 00:14:32.000000', 'temperatura', 419.0000, 'ºC'),
	(146407, 119, '2014-01-15 00:14:33.000000', 'temperatura', 354.0000, 'ºC'),
	(146408, 119, '2014-01-15 00:14:34.000000', 'temperatura', 514.0000, 'ºC'),
	(146409, 119, '2014-01-15 00:14:35.000000', 'temperatura', 306.0000, 'ºC'),
	(146410, 119, '2014-01-15 00:14:36.000000', 'temperatura', 1192.0000, 'ºC'),
	(146411, 119, '2014-01-15 00:14:37.000000', 'temperatura', 239.0000, 'ºC'),
	(146412, 119, '2014-01-15 00:14:38.000000', 'temperatura', 21.0000, 'ºC'),
	(146413, 119, '2014-01-15 00:14:39.000000', 'temperatura', 588.0000, 'ºC'),
	(146414, 119, '2014-01-15 00:14:40.000000', 'temperatura', 478.0000, 'ºC'),
	(146415, 119, '2014-01-15 00:14:41.000000', 'temperatura', 627.0000, 'ºC'),
	(146416, 119, '2014-01-15 00:14:42.000000', 'temperatura', 500.0000, 'ºC'),
	(146417, 119, '2014-01-15 00:14:43.000000', 'temperatura', 619.0000, 'ºC'),
	(146418, 119, '2014-01-15 00:14:44.000000', 'temperatura', 395.0000, 'ºC'),
	(146419, 119, '2014-01-15 00:14:45.000000', 'temperatura', 121.0000, 'ºC'),
	(146420, 119, '2014-01-15 00:14:46.000000', 'temperatura', 619.0000, 'ºC'),
	(146421, 119, '2014-01-15 00:14:47.000000', 'temperatura', 334.0000, 'ºC'),
	(146422, 119, '2014-01-15 00:14:48.000000', 'temperatura', 1012.0000, 'ºC'),
	(146423, 119, '2014-01-15 00:14:49.000000', 'temperatura', 458.0000, 'ºC'),
	(146424, 119, '2014-01-15 00:14:50.000000', 'temperatura', 457.0000, 'ºC'),
	(146425, 119, '2014-01-15 00:14:51.000000', 'temperatura', 909.0000, 'ºC'),
	(146426, 119, '2014-01-15 00:14:52.000000', 'temperatura', 777.0000, 'ºC'),
	(146427, 119, '2014-01-15 00:14:53.000000', 'temperatura', 1157.0000, 'ºC'),
	(146428, 119, '2014-01-15 00:14:54.000000', 'temperatura', 1054.0000, 'ºC'),
	(146429, 119, '2014-01-15 00:14:55.000000', 'temperatura', 598.0000, 'ºC'),
	(146430, 119, '2014-01-15 00:14:56.000000', 'temperatura', 1030.0000, 'ºC'),
	(146431, 119, '2014-01-15 00:14:57.000000', 'temperatura', 954.0000, 'ºC'),
	(146432, 119, '2014-01-15 00:14:58.000000', 'temperatura', 484.0000, 'ºC'),
	(146433, 119, '2014-01-15 00:14:59.000000', 'temperatura', 756.0000, 'ºC'),
	(146434, 119, '2014-01-15 00:15:00.000000', 'temperatura', 1130.0000, 'ºC'),
	(146435, 119, '2014-01-15 00:15:01.000000', 'temperatura', 980.0000, 'ºC'),
	(146436, 119, '2014-01-15 00:15:02.000000', 'temperatura', 313.0000, 'ºC'),
	(146437, 119, '2014-01-15 00:15:03.000000', 'temperatura', 1024.0000, 'ºC'),
	(146438, 119, '2014-01-15 00:15:04.000000', 'temperatura', 584.0000, 'ºC'),
	(146439, 119, '2014-01-15 00:15:05.000000', 'temperatura', 1046.0000, 'ºC'),
	(146440, 119, '2014-01-15 00:15:06.000000', 'temperatura', 1081.0000, 'ºC'),
	(146441, 119, '2014-01-15 00:15:07.000000', 'temperatura', 1066.0000, 'ºC'),
	(146442, 119, '2014-01-15 00:15:08.000000', 'temperatura', 887.0000, 'ºC'),
	(146443, 119, '2014-01-15 00:15:09.000000', 'temperatura', 38.0000, 'ºC'),
	(146444, 119, '2014-01-15 00:15:10.000000', 'temperatura', 1131.0000, 'ºC'),
	(146445, 119, '2014-01-15 00:15:11.000000', 'temperatura', 740.0000, 'ºC'),
	(146446, 119, '2014-01-15 00:15:12.000000', 'temperatura', 307.0000, 'ºC'),
	(146447, 119, '2014-01-15 00:15:13.000000', 'temperatura', 518.0000, 'ºC'),
	(146448, 119, '2014-01-15 00:15:14.000000', 'temperatura', 468.0000, 'ºC'),
	(146449, 119, '2014-01-15 00:15:15.000000', 'temperatura', 787.0000, 'ºC'),
	(146450, 119, '2014-01-15 00:15:16.000000', 'temperatura', 133.0000, 'ºC'),
	(146451, 119, '2014-01-15 00:15:17.000000', 'temperatura', 703.0000, 'ºC'),
	(146452, 119, '2014-01-15 00:15:18.000000', 'temperatura', 718.0000, 'ºC'),
	(146453, 119, '2014-01-15 00:15:19.000000', 'temperatura', 280.0000, 'ºC'),
	(146454, 119, '2014-01-15 00:15:20.000000', 'temperatura', 448.0000, 'ºC'),
	(146455, 119, '2014-01-15 00:15:21.000000', 'temperatura', 202.0000, 'ºC'),
	(146456, 119, '2014-01-15 00:15:22.000000', 'temperatura', 864.0000, 'ºC'),
	(146457, 119, '2014-01-15 00:15:23.000000', 'temperatura', 116.0000, 'ºC'),
	(146458, 119, '2014-01-15 00:15:24.000000', 'temperatura', 388.0000, 'ºC'),
	(146459, 119, '2014-01-15 00:15:25.000000', 'temperatura', 391.0000, 'ºC'),
	(146460, 119, '2014-01-15 00:15:26.000000', 'temperatura', 790.0000, 'ºC'),
	(146461, 119, '2014-01-15 00:15:27.000000', 'temperatura', 381.0000, 'ºC'),
	(146462, 119, '2014-01-15 00:15:28.000000', 'temperatura', 735.0000, 'ºC'),
	(146463, 119, '2014-01-15 00:15:29.000000', 'temperatura', 133.0000, 'ºC'),
	(146464, 119, '2014-01-15 00:15:30.000000', 'temperatura', 862.0000, 'ºC'),
	(146465, 119, '2014-01-15 00:15:31.000000', 'temperatura', 308.0000, 'ºC'),
	(146466, 119, '2014-01-15 00:15:32.000000', 'temperatura', 156.0000, 'ºC'),
	(146467, 119, '2014-01-15 00:15:33.000000', 'temperatura', 1057.0000, 'ºC'),
	(146468, 119, '2014-01-15 00:15:34.000000', 'temperatura', 17.0000, 'ºC'),
	(146469, 119, '2014-01-15 00:15:35.000000', 'temperatura', 514.0000, 'ºC'),
	(146470, 119, '2014-01-15 00:15:36.000000', 'temperatura', 120.0000, 'ºC'),
	(146471, 119, '2014-01-15 00:15:37.000000', 'temperatura', 257.0000, 'ºC'),
	(146472, 119, '2014-01-15 00:15:38.000000', 'temperatura', 924.0000, 'ºC'),
	(146473, 119, '2014-01-15 00:15:39.000000', 'temperatura', 253.0000, 'ºC'),
	(146474, 119, '2014-01-15 00:15:40.000000', 'temperatura', 892.0000, 'ºC'),
	(146475, 119, '2014-01-15 00:15:41.000000', 'temperatura', 101.0000, 'ºC'),
	(146476, 119, '2014-01-15 00:15:42.000000', 'temperatura', 230.0000, 'ºC'),
	(146477, 119, '2014-01-15 00:15:43.000000', 'temperatura', 848.0000, 'ºC'),
	(146478, 119, '2014-01-15 00:15:44.000000', 'temperatura', 1148.0000, 'ºC'),
	(146479, 119, '2014-01-15 00:15:45.000000', 'temperatura', 799.0000, 'ºC'),
	(146480, 119, '2014-01-15 00:15:46.000000', 'temperatura', 549.0000, 'ºC'),
	(146481, 119, '2014-01-15 00:15:47.000000', 'temperatura', 350.0000, 'ºC'),
	(146482, 119, '2014-01-15 00:15:48.000000', 'temperatura', 104.0000, 'ºC'),
	(146483, 119, '2014-01-15 00:15:49.000000', 'temperatura', 672.0000, 'ºC'),
	(146484, 119, '2014-01-15 00:15:50.000000', 'temperatura', 645.0000, 'ºC'),
	(146485, 119, '2014-01-15 00:15:51.000000', 'temperatura', 12.0000, 'ºC'),
	(146486, 119, '2014-01-15 00:15:52.000000', 'temperatura', 523.0000, 'ºC'),
	(146487, 119, '2014-01-15 00:15:53.000000', 'temperatura', 183.0000, 'ºC'),
	(146488, 119, '2014-01-15 00:15:54.000000', 'temperatura', 544.0000, 'ºC'),
	(146489, 119, '2014-01-15 00:15:55.000000', 'temperatura', 972.0000, 'ºC'),
	(146490, 119, '2014-01-15 00:15:56.000000', 'temperatura', 829.0000, 'ºC'),
	(146491, 119, '2014-01-15 00:15:57.000000', 'temperatura', 30.0000, 'ºC'),
	(146492, 119, '2014-01-15 00:15:58.000000', 'temperatura', 64.0000, 'ºC'),
	(146493, 119, '2014-01-15 00:15:59.000000', 'temperatura', 230.0000, 'ºC'),
	(146494, 119, '2014-01-15 00:16:00.000000', 'temperatura', 960.0000, 'ºC'),
	(146495, 119, '2014-01-15 00:16:01.000000', 'temperatura', 510.0000, 'ºC'),
	(146496, 119, '2014-01-15 00:16:02.000000', 'temperatura', 870.0000, 'ºC'),
	(146497, 119, '2014-01-15 00:16:03.000000', 'temperatura', 422.0000, 'ºC'),
	(146498, 119, '2014-01-15 00:16:04.000000', 'temperatura', 698.0000, 'ºC'),
	(146499, 119, '2014-01-15 00:16:05.000000', 'temperatura', 1024.0000, 'ºC'),
	(146500, 119, '2014-01-15 00:16:06.000000', 'temperatura', 627.0000, 'ºC'),
	(146501, 119, '2014-01-15 00:16:07.000000', 'temperatura', 62.0000, 'ºC'),
	(146502, 119, '2014-01-15 00:16:08.000000', 'temperatura', 833.0000, 'ºC'),
	(146503, 119, '2014-01-15 00:16:09.000000', 'temperatura', 377.0000, 'ºC'),
	(146504, 119, '2014-01-15 00:16:10.000000', 'temperatura', 589.0000, 'ºC'),
	(146505, 119, '2014-01-15 00:16:11.000000', 'temperatura', 612.0000, 'ºC'),
	(146506, 119, '2014-01-15 00:16:12.000000', 'temperatura', 94.0000, 'ºC'),
	(146507, 119, '2014-01-15 00:16:13.000000', 'temperatura', 1036.0000, 'ºC'),
	(146508, 119, '2014-01-15 00:16:14.000000', 'temperatura', 96.0000, 'ºC'),
	(146509, 119, '2014-01-15 00:16:15.000000', 'temperatura', 973.0000, 'ºC'),
	(146510, 119, '2014-01-15 00:16:16.000000', 'temperatura', 979.0000, 'ºC'),
	(146511, 119, '2014-01-15 00:16:17.000000', 'temperatura', 777.0000, 'ºC'),
	(146512, 119, '2014-01-15 00:16:18.000000', 'temperatura', 950.0000, 'ºC'),
	(146513, 119, '2014-01-15 00:16:19.000000', 'temperatura', 16.0000, 'ºC'),
	(146514, 119, '2014-01-15 00:16:20.000000', 'temperatura', 831.0000, 'ºC'),
	(146515, 119, '2014-01-15 00:16:21.000000', 'temperatura', 508.0000, 'ºC'),
	(146516, 119, '2014-01-15 00:16:22.000000', 'temperatura', 49.0000, 'ºC'),
	(146517, 119, '2014-01-15 00:16:23.000000', 'temperatura', 1120.0000, 'ºC'),
	(146518, 119, '2014-01-15 00:16:24.000000', 'temperatura', 654.0000, 'ºC'),
	(146519, 119, '2014-01-15 00:16:25.000000', 'temperatura', 1111.0000, 'ºC'),
	(146520, 119, '2014-01-15 00:16:26.000000', 'temperatura', 1192.0000, 'ºC'),
	(146521, 119, '2014-01-15 00:16:27.000000', 'temperatura', 227.0000, 'ºC'),
	(146522, 119, '2014-01-15 00:16:28.000000', 'temperatura', 1161.0000, 'ºC'),
	(146523, 119, '2014-01-15 00:16:29.000000', 'temperatura', 325.0000, 'ºC'),
	(146524, 119, '2014-01-15 00:16:30.000000', 'temperatura', 542.0000, 'ºC'),
	(146525, 119, '2014-01-15 00:16:31.000000', 'temperatura', 535.0000, 'ºC'),
	(146526, 119, '2014-01-15 00:16:32.000000', 'temperatura', 1049.0000, 'ºC'),
	(146527, 119, '2014-01-15 00:16:33.000000', 'temperatura', 42.0000, 'ºC'),
	(146528, 119, '2014-01-15 00:16:34.000000', 'temperatura', 662.0000, 'ºC'),
	(146529, 119, '2014-01-15 00:16:35.000000', 'temperatura', 786.0000, 'ºC'),
	(146530, 119, '2014-01-15 00:16:36.000000', 'temperatura', 746.0000, 'ºC'),
	(146531, 119, '2014-01-15 00:16:37.000000', 'temperatura', 170.0000, 'ºC'),
	(146532, 119, '2014-01-15 00:16:38.000000', 'temperatura', 1013.0000, 'ºC'),
	(146533, 119, '2014-01-15 00:16:39.000000', 'temperatura', 955.0000, 'ºC'),
	(146534, 119, '2014-01-15 00:16:40.000000', 'temperatura', 537.0000, 'ºC'),
	(146535, 119, '2014-01-15 00:16:41.000000', 'temperatura', 1019.0000, 'ºC'),
	(146536, 119, '2014-01-15 00:16:42.000000', 'temperatura', 1087.0000, 'ºC'),
	(146537, 119, '2014-01-15 00:16:43.000000', 'temperatura', 1175.0000, 'ºC'),
	(146538, 119, '2014-01-15 00:16:44.000000', 'temperatura', 218.0000, 'ºC'),
	(146539, 119, '2014-01-15 00:16:45.000000', 'temperatura', 1165.0000, 'ºC'),
	(146540, 119, '2014-01-15 00:16:46.000000', 'temperatura', 369.0000, 'ºC'),
	(146541, 119, '2014-01-15 00:16:47.000000', 'temperatura', 753.0000, 'ºC'),
	(146542, 119, '2014-01-15 00:16:48.000000', 'temperatura', 256.0000, 'ºC'),
	(146543, 119, '2014-01-15 00:16:49.000000', 'temperatura', 224.0000, 'ºC'),
	(146544, 119, '2014-01-15 00:16:50.000000', 'temperatura', 351.0000, 'ºC'),
	(146545, 119, '2014-01-15 00:16:51.000000', 'temperatura', 1082.0000, 'ºC'),
	(146546, 119, '2014-01-15 00:16:52.000000', 'temperatura', 760.0000, 'ºC'),
	(146547, 119, '2014-01-15 00:16:53.000000', 'temperatura', 556.0000, 'ºC'),
	(146548, 119, '2014-01-15 00:16:54.000000', 'temperatura', 497.0000, 'ºC'),
	(146549, 119, '2014-01-15 00:16:55.000000', 'temperatura', 821.0000, 'ºC'),
	(146550, 119, '2014-01-15 00:16:56.000000', 'temperatura', 212.0000, 'ºC'),
	(146551, 119, '2014-01-15 00:16:57.000000', 'temperatura', 996.0000, 'ºC'),
	(146552, 119, '2014-01-15 00:16:58.000000', 'temperatura', 746.0000, 'ºC'),
	(146553, 119, '2014-01-15 00:16:59.000000', 'temperatura', 744.0000, 'ºC'),
	(146554, 119, '2014-01-15 00:17:00.000000', 'temperatura', 284.0000, 'ºC'),
	(146555, 119, '2014-01-15 00:17:01.000000', 'temperatura', 385.0000, 'ºC'),
	(146556, 119, '2014-01-15 00:17:02.000000', 'temperatura', 1073.0000, 'ºC'),
	(146557, 119, '2014-01-15 00:17:03.000000', 'temperatura', 612.0000, 'ºC'),
	(146558, 119, '2014-01-15 00:17:04.000000', 'temperatura', 1041.0000, 'ºC'),
	(146559, 119, '2014-01-15 00:17:05.000000', 'temperatura', 970.0000, 'ºC'),
	(146560, 119, '2014-01-15 00:17:06.000000', 'temperatura', 527.0000, 'ºC'),
	(146561, 119, '2014-01-15 00:17:07.000000', 'temperatura', 925.0000, 'ºC'),
	(146562, 119, '2014-01-15 00:17:08.000000', 'temperatura', 643.0000, 'ºC'),
	(146563, 119, '2014-01-15 00:17:09.000000', 'temperatura', 444.0000, 'ºC'),
	(146564, 119, '2014-01-15 00:17:10.000000', 'temperatura', 288.0000, 'ºC'),
	(146565, 119, '2014-01-15 00:17:11.000000', 'temperatura', 111.0000, 'ºC'),
	(146566, 119, '2014-01-15 00:17:12.000000', 'temperatura', 891.0000, 'ºC'),
	(146567, 119, '2014-01-15 00:17:13.000000', 'temperatura', 522.0000, 'ºC'),
	(146568, 119, '2014-01-15 00:17:14.000000', 'temperatura', 1137.0000, 'ºC'),
	(146569, 119, '2014-01-15 00:17:15.000000', 'temperatura', 518.0000, 'ºC'),
	(146570, 119, '2014-01-15 00:17:16.000000', 'temperatura', 382.0000, 'ºC'),
	(146571, 119, '2014-01-15 00:17:17.000000', 'temperatura', 357.0000, 'ºC'),
	(146572, 119, '2014-01-15 00:17:18.000000', 'temperatura', 640.0000, 'ºC'),
	(146573, 119, '2014-01-15 00:17:19.000000', 'temperatura', 927.0000, 'ºC'),
	(146574, 119, '2014-01-15 00:17:20.000000', 'temperatura', 316.0000, 'ºC'),
	(146575, 119, '2014-01-15 00:17:21.000000', 'temperatura', 2.0000, 'ºC'),
	(146576, 119, '2014-01-15 00:17:22.000000', 'temperatura', 259.0000, 'ºC'),
	(146577, 119, '2014-01-15 00:17:23.000000', 'temperatura', 92.0000, 'ºC'),
	(146578, 119, '2014-01-15 00:17:24.000000', 'temperatura', 884.0000, 'ºC'),
	(146579, 119, '2014-01-15 00:17:25.000000', 'temperatura', 544.0000, 'ºC'),
	(146580, 119, '2014-01-15 00:17:26.000000', 'temperatura', 70.0000, 'ºC'),
	(146581, 119, '2014-01-15 00:17:27.000000', 'temperatura', 1116.0000, 'ºC'),
	(146582, 119, '2014-01-15 00:17:28.000000', 'temperatura', 570.0000, 'ºC'),
	(146583, 119, '2014-01-15 00:17:29.000000', 'temperatura', 702.0000, 'ºC'),
	(146584, 119, '2014-01-15 00:17:30.000000', 'temperatura', 600.0000, 'ºC'),
	(146585, 119, '2014-01-15 00:17:31.000000', 'temperatura', 895.0000, 'ºC'),
	(146586, 119, '2014-01-15 00:17:32.000000', 'temperatura', 274.0000, 'ºC'),
	(146587, 119, '2014-01-15 00:17:33.000000', 'temperatura', 1086.0000, 'ºC'),
	(146588, 119, '2014-01-15 00:17:34.000000', 'temperatura', 1010.0000, 'ºC'),
	(146589, 119, '2014-01-15 00:17:35.000000', 'temperatura', 592.0000, 'ºC'),
	(146590, 119, '2014-01-15 00:17:36.000000', 'temperatura', 1130.0000, 'ºC'),
	(146591, 119, '2014-01-15 00:17:37.000000', 'temperatura', 273.0000, 'ºC'),
	(146592, 119, '2014-01-15 00:17:38.000000', 'temperatura', 376.0000, 'ºC'),
	(146593, 119, '2014-01-15 00:17:39.000000', 'temperatura', 1062.0000, 'ºC'),
	(146594, 119, '2014-01-15 00:17:40.000000', 'temperatura', 581.0000, 'ºC'),
	(146595, 119, '2014-01-15 00:17:41.000000', 'temperatura', 920.0000, 'ºC'),
	(146596, 119, '2014-01-15 00:17:42.000000', 'temperatura', 458.0000, 'ºC'),
	(146597, 119, '2014-01-15 00:17:43.000000', 'temperatura', 731.0000, 'ºC'),
	(146598, 119, '2014-01-15 00:17:44.000000', 'temperatura', 1079.0000, 'ºC'),
	(146599, 119, '2014-01-15 00:17:45.000000', 'temperatura', 805.0000, 'ºC'),
	(146600, 119, '2014-01-15 00:17:46.000000', 'temperatura', 790.0000, 'ºC'),
	(146601, 119, '2014-01-15 00:17:47.000000', 'temperatura', 333.0000, 'ºC'),
	(146602, 119, '2014-01-15 00:17:48.000000', 'temperatura', 497.0000, 'ºC'),
	(146603, 119, '2014-01-15 00:17:49.000000', 'temperatura', 288.0000, 'ºC'),
	(146604, 119, '2014-01-15 00:17:50.000000', 'temperatura', 1147.0000, 'ºC'),
	(146605, 119, '2014-01-15 00:17:51.000000', 'temperatura', 72.0000, 'ºC'),
	(146606, 119, '2014-01-15 00:17:52.000000', 'temperatura', 518.0000, 'ºC'),
	(146607, 119, '2014-01-15 00:17:53.000000', 'temperatura', 1178.0000, 'ºC'),
	(146608, 119, '2014-01-15 00:17:54.000000', 'temperatura', 733.0000, 'ºC'),
	(146609, 119, '2014-01-15 00:17:55.000000', 'temperatura', 134.0000, 'ºC'),
	(146610, 119, '2014-01-15 00:17:56.000000', 'temperatura', 871.0000, 'ºC'),
	(146611, 119, '2014-01-15 00:17:57.000000', 'temperatura', 355.0000, 'ºC'),
	(146612, 119, '2014-01-15 00:17:58.000000', 'temperatura', 363.0000, 'ºC'),
	(146613, 119, '2014-01-15 00:17:59.000000', 'temperatura', 748.0000, 'ºC'),
	(146614, 119, '2014-01-15 00:18:00.000000', 'temperatura', 252.0000, 'ºC'),
	(146615, 119, '2014-01-15 00:18:01.000000', 'temperatura', 215.0000, 'ºC'),
	(146616, 119, '2014-01-15 00:18:02.000000', 'temperatura', 322.0000, 'ºC'),
	(146617, 119, '2014-01-15 00:18:03.000000', 'temperatura', 964.0000, 'ºC'),
	(146618, 119, '2014-01-15 00:18:04.000000', 'temperatura', 256.0000, 'ºC'),
	(146619, 119, '2014-01-15 00:18:05.000000', 'temperatura', 786.0000, 'ºC'),
	(146620, 119, '2014-01-15 00:18:06.000000', 'temperatura', 763.0000, 'ºC'),
	(146621, 119, '2014-01-15 00:18:07.000000', 'temperatura', 256.0000, 'ºC'),
	(146622, 119, '2014-01-15 00:18:08.000000', 'temperatura', 195.0000, 'ºC'),
	(146623, 119, '2014-01-15 00:18:09.000000', 'temperatura', 206.0000, 'ºC'),
	(146624, 119, '2014-01-15 00:18:10.000000', 'temperatura', 444.0000, 'ºC'),
	(146625, 119, '2014-01-15 00:18:11.000000', 'temperatura', 403.0000, 'ºC'),
	(146626, 119, '2014-01-15 00:18:12.000000', 'temperatura', 683.0000, 'ºC'),
	(146627, 119, '2014-01-15 00:18:13.000000', 'temperatura', 1008.0000, 'ºC'),
	(146628, 119, '2014-01-15 00:18:14.000000', 'temperatura', 591.0000, 'ºC'),
	(146629, 119, '2014-01-15 00:18:15.000000', 'temperatura', 1130.0000, 'ºC'),
	(146630, 119, '2014-01-15 00:18:16.000000', 'temperatura', 277.0000, 'ºC'),
	(146631, 119, '2014-01-15 00:18:17.000000', 'temperatura', 395.0000, 'ºC'),
	(146632, 119, '2014-01-15 00:18:18.000000', 'temperatura', 1145.0000, 'ºC'),
	(146633, 119, '2014-01-15 00:18:19.000000', 'temperatura', 942.0000, 'ºC'),
	(146634, 119, '2014-01-15 00:18:20.000000', 'temperatura', 76.0000, 'ºC'),
	(146635, 119, '2014-01-15 00:18:21.000000', 'temperatura', 1154.0000, 'ºC'),
	(146636, 119, '2014-01-15 00:18:22.000000', 'temperatura', 742.0000, 'ºC'),
	(146637, 119, '2014-01-15 00:18:23.000000', 'temperatura', 248.0000, 'ºC'),
	(146638, 119, '2014-01-15 00:18:24.000000', 'temperatura', 215.0000, 'ºC'),
	(146639, 119, '2014-01-15 00:18:25.000000', 'temperatura', 333.0000, 'ºC'),
	(146640, 119, '2014-01-15 00:18:26.000000', 'temperatura', 1020.0000, 'ºC'),
	(146641, 119, '2014-01-15 00:18:27.000000', 'temperatura', 499.0000, 'ºC'),
	(146642, 119, '2014-01-15 00:18:28.000000', 'temperatura', 638.0000, 'ºC'),
	(146643, 119, '2014-01-15 00:18:29.000000', 'temperatura', 491.0000, 'ºC'),
	(146644, 119, '2014-01-15 00:18:30.000000', 'temperatura', 545.0000, 'ºC'),
	(146645, 119, '2014-01-15 00:18:31.000000', 'temperatura', 50.0000, 'ºC'),
	(146646, 119, '2014-01-15 00:18:32.000000', 'temperatura', 1014.0000, 'ºC'),
	(146647, 119, '2014-01-15 00:18:33.000000', 'temperatura', 122.0000, 'ºC'),
	(146648, 119, '2014-01-15 00:18:34.000000', 'temperatura', 1169.0000, 'ºC'),
	(146649, 119, '2014-01-15 00:18:35.000000', 'temperatura', 680.0000, 'ºC'),
	(146650, 119, '2014-01-15 00:18:36.000000', 'temperatura', 1093.0000, 'ºC'),
	(146651, 119, '2014-01-15 00:18:37.000000', 'temperatura', 1027.0000, 'ºC'),
	(146652, 119, '2014-01-15 00:18:38.000000', 'temperatura', 657.0000, 'ºC'),
	(146653, 119, '2014-01-15 00:18:39.000000', 'temperatura', 205.0000, 'ºC'),
	(146654, 119, '2014-01-15 00:18:40.000000', 'temperatura', 252.0000, 'ºC'),
	(146655, 119, '2014-01-15 00:18:41.000000', 'temperatura', 645.0000, 'ºC'),
	(146656, 119, '2014-01-15 00:18:42.000000', 'temperatura', 71.0000, 'ºC'),
	(146657, 119, '2014-01-15 00:18:43.000000', 'temperatura', 820.0000, 'ºC'),
	(146658, 119, '2014-01-15 00:18:44.000000', 'temperatura', 287.0000, 'ºC'),
	(146659, 119, '2014-01-15 00:18:45.000000', 'temperatura', 177.0000, 'ºC'),
	(146660, 119, '2014-01-15 00:18:46.000000', 'temperatura', 23.0000, 'ºC'),
	(146661, 119, '2014-01-15 00:18:47.000000', 'temperatura', 785.0000, 'ºC'),
	(146662, 119, '2014-01-15 00:18:48.000000', 'temperatura', 258.0000, 'ºC'),
	(146663, 119, '2014-01-15 00:18:49.000000', 'temperatura', 137.0000, 'ºC'),
	(146664, 119, '2014-01-15 00:18:50.000000', 'temperatura', 1108.0000, 'ºC'),
	(146665, 119, '2014-01-15 00:18:51.000000', 'temperatura', 329.0000, 'ºC'),
	(146666, 119, '2014-01-15 00:18:52.000000', 'temperatura', 724.0000, 'ºC'),
	(146667, 119, '2014-01-15 00:18:53.000000', 'temperatura', 231.0000, 'ºC'),
	(146668, 119, '2014-01-15 00:18:54.000000', 'temperatura', 186.0000, 'ºC'),
	(146669, 119, '2014-01-15 00:18:55.000000', 'temperatura', 237.0000, 'ºC'),
	(146670, 119, '2014-01-15 00:18:56.000000', 'temperatura', 625.0000, 'ºC'),
	(146671, 119, '2014-01-15 00:18:57.000000', 'temperatura', 18.0000, 'ºC'),
	(146672, 119, '2014-01-15 00:18:58.000000', 'temperatura', 613.0000, 'ºC'),
	(146673, 119, '2014-01-15 00:18:59.000000', 'temperatura', 611.0000, 'ºC'),
	(146674, 119, '2014-01-15 00:19:00.000000', 'temperatura', 20.0000, 'ºC'),
	(146675, 119, '2014-01-15 00:19:01.000000', 'temperatura', 664.0000, 'ºC'),
	(146676, 119, '2014-01-15 00:19:02.000000', 'temperatura', 860.0000, 'ºC'),
	(146677, 119, '2014-01-15 00:19:03.000000', 'temperatura', 1110.0000, 'ºC'),
	(146678, 119, '2014-01-15 00:19:04.000000', 'temperatura', 571.0000, 'ºC'),
	(146679, 119, '2014-01-15 00:19:05.000000', 'temperatura', 726.0000, 'ºC'),
	(146680, 119, '2014-01-15 00:19:06.000000', 'temperatura', 717.0000, 'ºC'),
	(146681, 119, '2014-01-15 00:19:07.000000', 'temperatura', 206.0000, 'ºC'),
	(146682, 119, '2014-01-15 00:19:08.000000', 'temperatura', 82.0000, 'ºC'),
	(146683, 119, '2014-01-15 00:19:09.000000', 'temperatura', 992.0000, 'ºC'),
	(146684, 119, '2014-01-15 00:19:10.000000', 'temperatura', 1113.0000, 'ºC'),
	(146685, 119, '2014-01-15 00:19:11.000000', 'temperatura', 191.0000, 'ºC'),
	(146686, 119, '2014-01-15 00:19:12.000000', 'temperatura', 17.0000, 'ºC'),
	(146687, 119, '2014-01-15 00:19:13.000000', 'temperatura', 713.0000, 'ºC'),
	(146688, 119, '2014-01-15 00:19:14.000000', 'temperatura', 1114.0000, 'ºC'),
	(146689, 119, '2014-01-15 00:19:15.000000', 'temperatura', 1031.0000, 'ºC'),
	(146690, 119, '2014-01-15 00:19:16.000000', 'temperatura', 615.0000, 'ºC'),
	(146691, 119, '2014-01-15 00:19:17.000000', 'temperatura', 1181.0000, 'ºC'),
	(146692, 119, '2014-01-15 00:19:18.000000', 'temperatura', 459.0000, 'ºC'),
	(146693, 119, '2014-01-15 00:19:19.000000', 'temperatura', 1155.0000, 'ºC'),
	(146694, 119, '2014-01-15 00:19:20.000000', 'temperatura', 797.0000, 'ºC'),
	(146695, 119, '2014-01-15 00:19:21.000000', 'temperatura', 520.0000, 'ºC'),
	(146696, 119, '2014-01-15 00:19:22.000000', 'temperatura', 212.0000, 'ºC'),
	(146697, 119, '2014-01-15 00:19:23.000000', 'temperatura', 701.0000, 'ºC'),
	(146698, 119, '2014-01-15 00:19:24.000000', 'temperatura', 466.0000, 'ºC'),
	(146699, 119, '2014-01-15 00:19:25.000000', 'temperatura', 230.0000, 'ºC'),
	(146700, 119, '2014-01-15 00:19:26.000000', 'temperatura', 952.0000, 'ºC'),
	(146701, 119, '2014-01-15 00:19:27.000000', 'temperatura', 472.0000, 'ºC'),
	(146702, 119, '2014-01-15 00:19:28.000000', 'temperatura', 705.0000, 'ºC'),
	(146703, 119, '2014-01-15 00:19:29.000000', 'temperatura', 908.0000, 'ºC'),
	(146704, 119, '2014-01-15 00:19:30.000000', 'temperatura', 28.0000, 'ºC'),
	(146705, 119, '2014-01-15 00:19:31.000000', 'temperatura', 1014.0000, 'ºC'),
	(146706, 119, '2014-01-15 00:19:32.000000', 'temperatura', 186.0000, 'ºC'),
	(146707, 119, '2014-01-15 00:19:33.000000', 'temperatura', 291.0000, 'ºC'),
	(146708, 119, '2014-01-15 00:19:34.000000', 'temperatura', 897.0000, 'ºC'),
	(146709, 119, '2014-01-15 00:19:35.000000', 'temperatura', 11.0000, 'ºC'),
	(146710, 119, '2014-01-15 00:19:36.000000', 'temperatura', 964.0000, 'ºC'),
	(146711, 119, '2014-01-15 00:19:37.000000', 'temperatura', 1190.0000, 'ºC'),
	(146712, 119, '2014-01-15 00:19:38.000000', 'temperatura', 657.0000, 'ºC'),
	(146713, 119, '2014-01-15 00:19:39.000000', 'temperatura', 917.0000, 'ºC'),
	(146714, 119, '2014-01-15 00:19:40.000000', 'temperatura', 213.0000, 'ºC'),
	(146715, 119, '2014-01-15 00:19:41.000000', 'temperatura', 715.0000, 'ºC'),
	(146716, 119, '2014-01-15 00:19:42.000000', 'temperatura', 538.0000, 'ºC'),
	(146717, 119, '2014-01-15 00:19:43.000000', 'temperatura', 543.0000, 'ºC'),
	(146718, 119, '2014-01-15 00:19:44.000000', 'temperatura', 1102.0000, 'ºC'),
	(146719, 119, '2014-01-15 00:19:45.000000', 'temperatura', 283.0000, 'ºC'),
	(146720, 119, '2014-01-15 00:19:46.000000', 'temperatura', 509.0000, 'ºC'),
	(146721, 119, '2014-01-15 00:19:47.000000', 'temperatura', 496.0000, 'ºC'),
	(146722, 119, '2014-01-15 00:19:48.000000', 'temperatura', 953.0000, 'ºC'),
	(146723, 119, '2014-01-15 00:19:49.000000', 'temperatura', 879.0000, 'ºC'),
	(146724, 119, '2014-01-15 00:19:50.000000', 'temperatura', 337.0000, 'ºC'),
	(146725, 119, '2014-01-15 00:19:51.000000', 'temperatura', 249.0000, 'ºC'),
	(146726, 119, '2014-01-15 00:19:52.000000', 'temperatura', 232.0000, 'ºC'),
	(146727, 119, '2014-01-15 00:19:53.000000', 'temperatura', 417.0000, 'ºC'),
	(146728, 119, '2014-01-15 00:19:54.000000', 'temperatura', 186.0000, 'ºC'),
	(146729, 119, '2014-01-15 00:19:55.000000', 'temperatura', 882.0000, 'ºC'),
	(146730, 119, '2014-01-15 00:19:56.000000', 'temperatura', 251.0000, 'ºC'),
	(146731, 119, '2014-01-15 00:19:57.000000', 'temperatura', 1009.0000, 'ºC'),
	(146732, 119, '2014-01-15 00:19:58.000000', 'temperatura', 694.0000, 'ºC'),
	(146733, 119, '2014-01-15 00:19:59.000000', 'temperatura', 445.0000, 'ºC'),
	(146734, 119, '2014-01-15 00:20:00.000000', 'temperatura', 141.0000, 'ºC'),
	(146735, 119, '2014-01-15 00:20:01.000000', 'temperatura', 573.0000, 'ºC'),
	(146736, 119, '2014-01-15 00:20:02.000000', 'temperatura', 42.0000, 'ºC'),
	(146737, 119, '2014-01-15 00:20:03.000000', 'temperatura', 891.0000, 'ºC'),
	(146738, 119, '2014-01-15 00:20:04.000000', 'temperatura', 728.0000, 'ºC'),
	(146739, 119, '2014-01-15 00:20:05.000000', 'temperatura', 970.0000, 'ºC'),
	(146740, 119, '2014-01-15 00:20:06.000000', 'temperatura', 266.0000, 'ºC'),
	(146741, 119, '2014-01-15 00:20:07.000000', 'temperatura', 821.0000, 'ºC'),
	(146742, 119, '2014-01-15 00:20:08.000000', 'temperatura', 906.0000, 'ºC'),
	(146743, 119, '2014-01-15 00:20:09.000000', 'temperatura', 867.0000, 'ºC'),
	(146744, 119, '2014-01-15 00:20:10.000000', 'temperatura', 417.0000, 'ºC'),
	(146745, 119, '2014-01-15 00:20:11.000000', 'temperatura', 686.0000, 'ºC'),
	(146746, 119, '2014-01-15 00:20:12.000000', 'temperatura', 978.0000, 'ºC'),
	(146747, 119, '2014-01-15 00:20:13.000000', 'temperatura', 432.0000, 'ºC'),
	(146748, 119, '2014-01-15 00:20:14.000000', 'temperatura', 429.0000, 'ºC'),
	(146749, 119, '2014-01-15 00:20:15.000000', 'temperatura', 847.0000, 'ºC'),
	(146750, 119, '2014-01-15 00:20:16.000000', 'temperatura', 551.0000, 'ºC'),
	(146751, 119, '2014-01-15 00:20:17.000000', 'temperatura', 214.0000, 'ºC'),
	(146752, 119, '2014-01-15 00:20:18.000000', 'temperatura', 617.0000, 'ºC'),
	(146753, 119, '2014-01-15 00:20:19.000000', 'temperatura', 45.0000, 'ºC'),
	(146754, 119, '2014-01-15 00:20:20.000000', 'temperatura', 774.0000, 'ºC'),
	(146755, 119, '2014-01-15 00:20:21.000000', 'temperatura', 135.0000, 'ºC'),
	(146756, 119, '2014-01-15 00:20:22.000000', 'temperatura', 755.0000, 'ºC'),
	(146757, 119, '2014-01-15 00:20:23.000000', 'temperatura', 970.0000, 'ºC'),
	(146758, 119, '2014-01-15 00:20:24.000000', 'temperatura', 183.0000, 'ºC'),
	(146759, 119, '2014-01-15 00:20:25.000000', 'temperatura', 408.0000, 'ºC'),
	(146760, 119, '2014-01-15 00:20:26.000000', 'temperatura', 289.0000, 'ºC'),
	(146761, 119, '2014-01-15 00:20:27.000000', 'temperatura', 223.0000, 'ºC'),
	(146762, 119, '2014-01-15 00:20:28.000000', 'temperatura', 248.0000, 'ºC'),
	(146763, 119, '2014-01-15 00:20:29.000000', 'temperatura', 573.0000, 'ºC'),
	(146764, 119, '2014-01-15 00:20:30.000000', 'temperatura', 918.0000, 'ºC'),
	(146765, 119, '2014-01-15 00:20:31.000000', 'temperatura', 475.0000, 'ºC'),
	(146766, 119, '2014-01-15 00:20:32.000000', 'temperatura', 822.0000, 'ºC'),
	(146767, 119, '2014-01-15 00:20:33.000000', 'temperatura', 284.0000, 'ºC'),
	(146768, 119, '2014-01-15 00:20:34.000000', 'temperatura', 156.0000, 'ºC'),
	(146769, 119, '2014-01-15 00:20:35.000000', 'temperatura', 1127.0000, 'ºC'),
	(146770, 119, '2014-01-15 00:20:36.000000', 'temperatura', 369.0000, 'ºC'),
	(146771, 119, '2014-01-15 00:20:37.000000', 'temperatura', 864.0000, 'ºC'),
	(146772, 119, '2014-01-15 00:20:38.000000', 'temperatura', 814.0000, 'ºC'),
	(146773, 119, '2014-01-15 00:20:39.000000', 'temperatura', 278.0000, 'ºC'),
	(146774, 119, '2014-01-15 00:20:40.000000', 'temperatura', 146.0000, 'ºC'),
	(146775, 119, '2014-01-15 00:20:41.000000', 'temperatura', 1100.0000, 'ºC'),
	(146776, 119, '2014-01-15 00:20:42.000000', 'temperatura', 262.0000, 'ºC'),
	(146777, 119, '2014-01-15 00:20:43.000000', 'temperatura', 408.0000, 'ºC'),
	(146778, 119, '2014-01-15 00:20:44.000000', 'temperatura', 56.0000, 'ºC'),
	(146779, 119, '2014-01-15 00:20:45.000000', 'temperatura', 255.0000, 'ºC'),
	(146780, 119, '2014-01-15 00:20:46.000000', 'temperatura', 1108.0000, 'ºC'),
	(146781, 119, '2014-01-15 00:20:47.000000', 'temperatura', 1177.0000, 'ºC'),
	(146782, 119, '2014-01-15 00:20:48.000000', 'temperatura', 162.0000, 'ºC'),
	(146783, 119, '2014-01-15 00:20:49.000000', 'temperatura', 879.0000, 'ºC'),
	(146784, 119, '2014-01-15 00:20:50.000000', 'temperatura', 308.0000, 'ºC'),
	(146785, 119, '2014-01-15 00:20:51.000000', 'temperatura', 106.0000, 'ºC'),
	(146786, 119, '2014-01-15 00:20:52.000000', 'temperatura', 804.0000, 'ºC'),
	(146787, 119, '2014-01-15 00:20:53.000000', 'temperatura', 101.0000, 'ºC'),
	(146788, 119, '2014-01-15 00:20:54.000000', 'temperatura', 497.0000, 'ºC'),
	(146789, 119, '2014-01-15 00:20:55.000000', 'temperatura', 981.0000, 'ºC'),
	(146790, 119, '2014-01-15 00:20:56.000000', 'temperatura', 1016.0000, 'ºC'),
	(146791, 119, '2014-01-15 00:20:57.000000', 'temperatura', 937.0000, 'ºC'),
	(146792, 119, '2014-01-15 00:20:58.000000', 'temperatura', 435.0000, 'ºC'),
	(146793, 119, '2014-01-15 00:20:59.000000', 'temperatura', 567.0000, 'ºC'),
	(146794, 119, '2014-01-15 00:21:00.000000', 'temperatura', 330.0000, 'ºC'),
	(146795, 119, '2014-01-15 00:21:01.000000', 'temperatura', 1149.0000, 'ºC'),
	(146796, 119, '2014-01-15 00:21:02.000000', 'temperatura', 1156.0000, 'ºC'),
	(146797, 119, '2014-01-15 00:21:03.000000', 'temperatura', 1133.0000, 'ºC'),
	(146798, 119, '2014-01-15 00:21:04.000000', 'temperatura', 999.0000, 'ºC'),
	(146799, 119, '2014-01-15 00:21:05.000000', 'temperatura', 394.0000, 'ºC'),
	(146800, 119, '2014-01-15 00:21:06.000000', 'temperatura', 174.0000, 'ºC'),
	(146801, 119, '2014-01-15 00:21:07.000000', 'temperatura', 888.0000, 'ºC'),
	(146802, 119, '2014-01-15 00:21:08.000000', 'temperatura', 320.0000, 'ºC'),
	(146803, 119, '2014-01-15 00:21:09.000000', 'temperatura', 138.0000, 'ºC'),
	(146804, 119, '2014-01-15 00:21:10.000000', 'temperatura', 928.0000, 'ºC'),
	(146805, 119, '2014-01-15 00:21:11.000000', 'temperatura', 626.0000, 'ºC'),
	(146806, 119, '2014-01-15 00:21:12.000000', 'temperatura', 346.0000, 'ºC'),
	(146807, 119, '2014-01-15 00:21:13.000000', 'temperatura', 1055.0000, 'ºC'),
	(146808, 119, '2014-01-15 00:21:14.000000', 'temperatura', 635.0000, 'ºC'),
	(146809, 119, '2014-01-15 00:21:15.000000', 'temperatura', 13.0000, 'ºC'),
	(146810, 119, '2014-01-15 00:21:16.000000', 'temperatura', 558.0000, 'ºC'),
	(146811, 119, '2014-01-15 00:21:17.000000', 'temperatura', 354.0000, 'ºC'),
	(146812, 119, '2014-01-15 00:21:18.000000', 'temperatura', 96.0000, 'ºC'),
	(146813, 119, '2014-01-15 00:21:19.000000', 'temperatura', 617.0000, 'ºC'),
	(146814, 119, '2014-01-15 00:21:20.000000', 'temperatura', 397.0000, 'ºC'),
	(146815, 119, '2014-01-15 00:21:21.000000', 'temperatura', 135.0000, 'ºC'),
	(146816, 119, '2014-01-15 00:21:22.000000', 'temperatura', 683.0000, 'ºC'),
	(146817, 119, '2014-01-15 00:21:23.000000', 'temperatura', 612.0000, 'ºC'),
	(146818, 119, '2014-01-15 00:21:24.000000', 'temperatura', 1013.0000, 'ºC'),
	(146819, 119, '2014-01-15 00:21:25.000000', 'temperatura', 830.0000, 'ºC'),
	(146820, 119, '2014-01-15 00:21:26.000000', 'temperatura', 1110.0000, 'ºC'),
	(146821, 119, '2014-01-15 00:21:27.000000', 'temperatura', 659.0000, 'ºC'),
	(146822, 119, '2014-01-15 00:21:28.000000', 'temperatura', 1168.0000, 'ºC'),
	(146823, 119, '2014-01-15 00:21:29.000000', 'temperatura', 264.0000, 'ºC'),
	(146824, 119, '2014-01-15 00:21:30.000000', 'temperatura', 216.0000, 'ºC'),
	(146825, 119, '2014-01-15 00:21:31.000000', 'temperatura', 289.0000, 'ºC'),
	(146826, 119, '2014-01-15 00:21:32.000000', 'temperatura', 796.0000, 'ºC'),
	(146827, 119, '2014-01-15 00:21:33.000000', 'temperatura', 713.0000, 'ºC'),
	(146828, 119, '2014-01-15 00:21:34.000000', 'temperatura', 1178.0000, 'ºC'),
	(146829, 119, '2014-01-15 00:21:35.000000', 'temperatura', 153.0000, 'ºC'),
	(146830, 119, '2014-01-15 00:21:36.000000', 'temperatura', 831.0000, 'ºC'),
	(146831, 119, '2014-01-15 00:21:37.000000', 'temperatura', 95.0000, 'ºC'),
	(146832, 119, '2014-01-15 00:21:38.000000', 'temperatura', 384.0000, 'ºC'),
	(146833, 119, '2014-01-15 00:21:39.000000', 'temperatura', 434.0000, 'ºC'),
	(146834, 119, '2014-01-15 00:21:40.000000', 'temperatura', 1020.0000, 'ºC'),
	(146835, 119, '2014-01-15 00:21:41.000000', 'temperatura', 197.0000, 'ºC'),
	(146836, 119, '2014-01-15 00:21:42.000000', 'temperatura', 327.0000, 'ºC'),
	(146837, 119, '2014-01-15 00:21:43.000000', 'temperatura', 1042.0000, 'ºC'),
	(146838, 119, '2014-01-15 00:21:44.000000', 'temperatura', 631.0000, 'ºC'),
	(146839, 119, '2014-01-15 00:21:45.000000', 'temperatura', 29.0000, 'ºC'),
	(146840, 119, '2014-01-15 00:21:46.000000', 'temperatura', 652.0000, 'ºC'),
	(146841, 119, '2014-01-15 00:21:47.000000', 'temperatura', 772.0000, 'ºC'),
	(146842, 119, '2014-01-15 00:21:48.000000', 'temperatura', 707.0000, 'ºC'),
	(146843, 119, '2014-01-15 00:21:49.000000', 'temperatura', 18.0000, 'ºC'),
	(146844, 119, '2014-01-15 00:21:50.000000', 'temperatura', 370.0000, 'ºC'),
	(146845, 119, '2014-01-15 00:21:51.000000', 'temperatura', 596.0000, 'ºC'),
	(146846, 119, '2014-01-15 00:21:52.000000', 'temperatura', 671.0000, 'ºC'),
	(146847, 119, '2014-01-15 00:21:53.000000', 'temperatura', 368.0000, 'ºC'),
	(146848, 119, '2014-01-15 00:21:54.000000', 'temperatura', 1029.0000, 'ºC'),
	(146849, 119, '2014-01-15 00:21:55.000000', 'temperatura', 440.0000, 'ºC'),
	(146850, 119, '2014-01-15 00:21:56.000000', 'temperatura', 313.0000, 'ºC'),
	(146851, 119, '2014-01-15 00:21:57.000000', 'temperatura', 246.0000, 'ºC'),
	(146852, 119, '2014-01-15 00:21:58.000000', 'temperatura', 291.0000, 'ºC'),
	(146853, 119, '2014-01-15 00:21:59.000000', 'temperatura', 718.0000, 'ºC'),
	(146854, 119, '2014-01-15 00:22:00.000000', 'temperatura', 319.0000, 'ºC'),
	(146855, 119, '2014-01-15 00:22:01.000000', 'temperatura', 642.0000, 'ºC'),
	(146856, 119, '2014-01-15 00:22:02.000000', 'temperatura', 1051.0000, 'ºC'),
	(146857, 119, '2014-01-15 00:22:03.000000', 'temperatura', 930.0000, 'ºC'),
	(146858, 119, '2014-01-15 00:22:04.000000', 'temperatura', 298.0000, 'ºC'),
	(146859, 119, '2014-01-15 00:22:05.000000', 'temperatura', 1099.0000, 'ºC'),
	(146860, 119, '2014-01-15 00:22:06.000000', 'temperatura', 1002.0000, 'ºC'),
	(146861, 119, '2014-01-15 00:22:07.000000', 'temperatura', 512.0000, 'ºC'),
	(146862, 119, '2014-01-15 00:22:08.000000', 'temperatura', 757.0000, 'ºC'),
	(146863, 119, '2014-01-15 00:22:09.000000', 'temperatura', 1049.0000, 'ºC'),
	(146864, 119, '2014-01-15 00:22:10.000000', 'temperatura', 576.0000, 'ºC'),
	(146865, 119, '2014-01-15 00:22:11.000000', 'temperatura', 932.0000, 'ºC'),
	(146866, 119, '2014-01-15 00:22:12.000000', 'temperatura', 531.0000, 'ºC'),
	(146867, 119, '2014-01-15 00:22:13.000000', 'temperatura', 1059.0000, 'ºC'),
	(146868, 119, '2014-01-15 00:22:14.000000', 'temperatura', 103.0000, 'ºC'),
	(146869, 119, '2014-01-15 00:22:15.000000', 'temperatura', 939.0000, 'ºC'),
	(146870, 119, '2014-01-15 00:22:16.000000', 'temperatura', 789.0000, 'ºC'),
	(146871, 119, '2014-01-15 00:22:17.000000', 'temperatura', 1125.0000, 'ºC'),
	(146872, 119, '2014-01-15 00:22:18.000000', 'temperatura', 859.0000, 'ºC'),
	(146873, 119, '2014-01-15 00:22:19.000000', 'temperatura', 922.0000, 'ºC'),
	(146874, 119, '2014-01-15 00:22:20.000000', 'temperatura', 833.0000, 'ºC'),
	(146875, 119, '2014-01-15 00:22:21.000000', 'temperatura', 200.0000, 'ºC'),
	(146876, 119, '2014-01-15 00:22:22.000000', 'temperatura', 900.0000, 'ºC'),
	(146877, 119, '2014-01-15 00:22:23.000000', 'temperatura', 300.0000, 'ºC'),
	(146878, 119, '2014-01-15 00:22:24.000000', 'temperatura', 0.0000, 'ºC'),
	(146879, 119, '2014-01-15 00:22:25.000000', 'temperatura', 303.0000, 'ºC'),
	(146880, 119, '2014-01-15 00:22:26.000000', 'temperatura', 316.0000, 'ºC'),
	(146881, 119, '2014-01-15 00:22:27.000000', 'temperatura', 669.0000, 'ºC'),
	(146882, 119, '2014-01-15 00:22:28.000000', 'temperatura', 1199.0000, 'ºC'),
	(146883, 119, '2014-01-15 00:22:29.000000', 'temperatura', 389.0000, 'ºC'),
	(146884, 119, '2014-01-15 00:22:30.000000', 'temperatura', 749.0000, 'ºC'),
	(146885, 119, '2014-01-15 00:22:31.000000', 'temperatura', 176.0000, 'ºC'),
	(146886, 119, '2014-01-15 00:22:32.000000', 'temperatura', 1035.0000, 'ºC'),
	(146887, 119, '2014-01-15 00:22:33.000000', 'temperatura', 1047.0000, 'ºC'),
	(146888, 119, '2014-01-15 00:22:34.000000', 'temperatura', 929.0000, 'ºC'),
	(146889, 119, '2014-01-15 00:22:35.000000', 'temperatura', 306.0000, 'ºC'),
	(146890, 119, '2014-01-15 00:22:36.000000', 'temperatura', 1145.0000, 'ºC'),
	(146891, 119, '2014-01-15 00:22:37.000000', 'temperatura', 5.0000, 'ºC'),
	(146892, 119, '2014-01-15 00:22:38.000000', 'temperatura', 190.0000, 'ºC'),
	(146893, 119, '2014-01-15 00:22:39.000000', 'temperatura', 937.0000, 'ºC'),
	(146894, 119, '2014-01-15 00:22:40.000000', 'temperatura', 517.0000, 'ºC'),
	(146895, 119, '2014-01-15 00:22:41.000000', 'temperatura', 974.0000, 'ºC'),
	(146896, 119, '2014-01-15 00:22:42.000000', 'temperatura', 920.0000, 'ºC'),
	(146897, 119, '2014-01-15 00:22:43.000000', 'temperatura', 480.0000, 'ºC'),
	(146898, 119, '2014-01-15 00:22:44.000000', 'temperatura', 838.0000, 'ºC'),
	(146899, 119, '2014-01-15 00:22:45.000000', 'temperatura', 351.0000, 'ºC'),
	(146900, 119, '2014-01-15 00:22:46.000000', 'temperatura', 441.0000, 'ºC'),
	(146901, 119, '2014-01-15 00:22:47.000000', 'temperatura', 1154.0000, 'ºC'),
	(146902, 119, '2014-01-15 00:22:48.000000', 'temperatura', 846.0000, 'ºC'),
	(146903, 119, '2014-01-15 00:22:49.000000', 'temperatura', 770.0000, 'ºC'),
	(146904, 119, '2014-01-15 00:22:50.000000', 'temperatura', 111.0000, 'ºC'),
	(146905, 119, '2014-01-15 00:22:51.000000', 'temperatura', 648.0000, 'ºC'),
	(146906, 119, '2014-01-15 00:22:52.000000', 'temperatura', 505.0000, 'ºC'),
	(146907, 119, '2014-01-15 00:22:53.000000', 'temperatura', 582.0000, 'ºC'),
	(146908, 119, '2014-01-15 00:22:54.000000', 'temperatura', 198.0000, 'ºC'),
	(146909, 119, '2014-01-15 00:22:55.000000', 'temperatura', 442.0000, 'ºC'),
	(146910, 119, '2014-01-15 00:22:56.000000', 'temperatura', 418.0000, 'ºC'),
	(146911, 119, '2014-01-15 00:22:57.000000', 'temperatura', 765.0000, 'ºC'),
	(146912, 119, '2014-01-15 00:22:58.000000', 'temperatura', 169.0000, 'ºC'),
	(146913, 119, '2014-01-15 00:22:59.000000', 'temperatura', 954.0000, 'ºC'),
	(146914, 119, '2014-01-15 00:23:00.000000', 'temperatura', 661.0000, 'ºC'),
	(146915, 119, '2014-01-15 00:23:01.000000', 'temperatura', 445.0000, 'ºC'),
	(146916, 119, '2014-01-15 00:23:02.000000', 'temperatura', 243.0000, 'ºC'),
	(146917, 119, '2014-01-15 00:23:03.000000', 'temperatura', 1078.0000, 'ºC'),
	(146918, 119, '2014-01-15 00:23:04.000000', 'temperatura', 1063.0000, 'ºC'),
	(146919, 119, '2014-01-15 00:23:05.000000', 'temperatura', 882.0000, 'ºC'),
	(146920, 119, '2014-01-15 00:23:06.000000', 'temperatura', 19.0000, 'ºC'),
	(146921, 119, '2014-01-15 00:23:07.000000', 'temperatura', 1051.0000, 'ºC'),
	(146922, 119, '2014-01-15 00:23:08.000000', 'temperatura', 398.0000, 'ºC'),
	(146923, 119, '2014-01-15 00:23:09.000000', 'temperatura', 40.0000, 'ºC'),
	(146924, 119, '2014-01-15 00:23:10.000000', 'temperatura', 203.0000, 'ºC'),
	(146925, 119, '2014-01-15 00:23:11.000000', 'temperatura', 897.0000, 'ºC'),
	(146926, 119, '2014-01-15 00:23:12.000000', 'temperatura', 275.0000, 'ºC'),
	(146927, 119, '2014-01-15 00:23:13.000000', 'temperatura', 1085.0000, 'ºC'),
	(146928, 119, '2014-01-15 00:23:14.000000', 'temperatura', 999.0000, 'ºC'),
	(146929, 119, '2014-01-15 00:23:15.000000', 'temperatura', 543.0000, 'ºC'),
	(146930, 119, '2014-01-15 00:23:16.000000', 'temperatura', 919.0000, 'ºC'),
	(146931, 119, '2014-01-15 00:23:17.000000', 'temperatura', 564.0000, 'ºC'),
	(146932, 119, '2014-01-15 00:23:18.000000', 'temperatura', 65.0000, 'ºC'),
	(146933, 119, '2014-01-15 00:23:19.000000', 'temperatura', 1035.0000, 'ºC'),
	(146934, 119, '2014-01-15 00:23:20.000000', 'temperatura', 179.0000, 'ºC'),
	(146935, 119, '2014-01-15 00:23:21.000000', 'temperatura', 190.0000, 'ºC'),
	(146936, 119, '2014-01-15 00:23:22.000000', 'temperatura', 412.0000, 'ºC'),
	(146937, 119, '2014-01-15 00:23:23.000000', 'temperatura', 293.0000, 'ºC'),
	(146938, 119, '2014-01-15 00:23:24.000000', 'temperatura', 228.0000, 'ºC'),
	(146939, 119, '2014-01-15 00:23:25.000000', 'temperatura', 262.0000, 'ºC'),
	(146940, 119, '2014-01-15 00:23:26.000000', 'temperatura', 625.0000, 'ºC'),
	(146941, 119, '2014-01-15 00:23:27.000000', 'temperatura', 1139.0000, 'ºC'),
	(146942, 119, '2014-01-15 00:23:28.000000', 'temperatura', 220.0000, 'ºC'),
	(146943, 119, '2014-01-15 00:23:29.000000', 'temperatura', 87.0000, 'ºC'),
	(146944, 119, '2014-01-15 00:23:30.000000', 'temperatura', 972.0000, 'ºC'),
	(146945, 119, '2014-01-15 00:23:31.000000', 'temperatura', 1003.0000, 'ºC'),
	(146946, 119, '2014-01-15 00:23:32.000000', 'temperatura', 897.0000, 'ºC'),
	(146947, 119, '2014-01-15 00:23:33.000000', 'temperatura', 278.0000, 'ºC'),
	(146948, 119, '2014-01-15 00:23:34.000000', 'temperatura', 1099.0000, 'ºC'),
	(146949, 119, '2014-01-15 00:23:35.000000', 'temperatura', 1060.0000, 'ºC'),
	(146950, 119, '2014-01-15 00:23:36.000000', 'temperatura', 804.0000, 'ºC'),
	(146951, 119, '2014-01-15 00:23:37.000000', 'temperatura', 843.0000, 'ºC'),
	(146952, 119, '2014-01-15 00:23:38.000000', 'temperatura', 602.0000, 'ºC'),
	(146953, 119, '2014-01-15 00:23:39.000000', 'temperatura', 481.0000, 'ºC'),
	(146954, 119, '2014-01-15 00:23:40.000000', 'temperatura', 599.0000, 'ºC'),
	(146955, 119, '2014-01-15 00:23:41.000000', 'temperatura', 354.0000, 'ºC'),
	(146956, 119, '2014-01-15 00:23:42.000000', 'temperatura', 1175.0000, 'ºC'),
	(146957, 119, '2014-01-15 00:23:43.000000', 'temperatura', 11.0000, 'ºC'),
	(146958, 119, '2014-01-15 00:23:44.000000', 'temperatura', 132.0000, 'ºC'),
	(146959, 119, '2014-01-15 00:23:45.000000', 'temperatura', 627.0000, 'ºC'),
	(146960, 119, '2014-01-15 00:23:46.000000', 'temperatura', 340.0000, 'ºC'),
	(146961, 119, '2014-01-15 00:23:47.000000', 'temperatura', 1018.0000, 'ºC'),
	(146962, 119, '2014-01-15 00:23:48.000000', 'temperatura', 472.0000, 'ºC'),
	(146963, 119, '2014-01-15 00:23:49.000000', 'temperatura', 507.0000, 'ºC'),
	(146964, 119, '2014-01-15 00:23:50.000000', 'temperatura', 1120.0000, 'ºC'),
	(146965, 119, '2014-01-15 00:23:51.000000', 'temperatura', 480.0000, 'ºC'),
	(146966, 119, '2014-01-15 00:23:52.000000', 'temperatura', 239.0000, 'ºC'),
	(146967, 119, '2014-01-15 00:23:53.000000', 'temperatura', 958.0000, 'ºC'),
	(146968, 119, '2014-01-15 00:23:54.000000', 'temperatura', 470.0000, 'ºC'),
	(146969, 119, '2014-01-15 00:23:55.000000', 'temperatura', 679.0000, 'ºC'),
	(146970, 119, '2014-01-15 00:23:56.000000', 'temperatura', 783.0000, 'ºC'),
	(146971, 119, '2014-01-15 00:23:57.000000', 'temperatura', 679.0000, 'ºC'),
	(146972, 119, '2014-01-15 00:23:58.000000', 'temperatura', 1047.0000, 'ºC'),
	(146973, 119, '2014-01-15 00:23:59.000000', 'temperatura', 801.0000, 'ºC'),
	(146974, 119, '2014-01-15 00:24:00.000000', 'temperatura', 861.0000, 'ºC'),
	(146975, 119, '2014-01-15 00:24:01.000000', 'temperatura', 703.0000, 'ºC'),
	(146976, 119, '2014-01-15 00:24:02.000000', 'temperatura', 934.0000, 'ºC'),
	(146977, 119, '2014-01-15 00:24:03.000000', 'temperatura', 159.0000, 'ºC'),
	(146978, 119, '2014-01-15 00:24:04.000000', 'temperatura', 394.0000, 'ºC'),
	(146979, 119, '2014-01-15 00:24:05.000000', 'temperatura', 294.0000, 'ºC'),
	(146980, 119, '2014-01-15 00:24:06.000000', 'temperatura', 290.0000, 'ºC'),
	(146981, 119, '2014-01-15 00:24:07.000000', 'temperatura', 567.0000, 'ºC'),
	(146982, 119, '2014-01-15 00:24:08.000000', 'temperatura', 767.0000, 'ºC'),
	(146983, 119, '2014-01-15 00:24:09.000000', 'temperatura', 935.0000, 'ºC'),
	(146984, 119, '2014-01-15 00:24:10.000000', 'temperatura', 1174.0000, 'ºC'),
	(146985, 119, '2014-01-15 00:24:11.000000', 'temperatura', 665.0000, 'ºC'),
	(146986, 119, '2014-01-15 00:24:12.000000', 'temperatura', 1002.0000, 'ºC'),
	(146987, 119, '2014-01-15 00:24:13.000000', 'temperatura', 616.0000, 'ºC'),
	(146988, 119, '2014-01-15 00:24:14.000000', 'temperatura', 74.0000, 'ºC'),
	(146989, 119, '2014-01-15 00:24:15.000000', 'temperatura', 923.0000, 'ºC'),
	(146990, 119, '2014-01-15 00:24:16.000000', 'temperatura', 794.0000, 'ºC'),
	(146991, 119, '2014-01-15 00:24:17.000000', 'temperatura', 1199.0000, 'ºC'),
	(146992, 119, '2014-01-15 00:24:18.000000', 'temperatura', 16.0000, 'ºC'),
	(146993, 119, '2014-01-15 00:24:19.000000', 'temperatura', 83.0000, 'ºC'),
	(146994, 119, '2014-01-15 00:24:20.000000', 'temperatura', 369.0000, 'ºC'),
	(146995, 119, '2014-01-15 00:24:21.000000', 'temperatura', 396.0000, 'ºC'),
	(146996, 119, '2014-01-15 00:24:22.000000', 'temperatura', 873.0000, 'ºC'),
	(146997, 119, '2014-01-15 00:24:23.000000', 'temperatura', 776.0000, 'ºC'),
	(146998, 119, '2014-01-15 00:24:24.000000', 'temperatura', 62.0000, 'ºC'),
	(146999, 119, '2014-01-15 00:24:25.000000', 'temperatura', 381.0000, 'ºC'),
	(147000, 119, '2014-01-15 00:24:26.000000', 'temperatura', 522.0000, 'ºC'),
	(147001, 119, '2014-01-15 00:24:27.000000', 'temperatura', 268.0000, 'ºC'),
	(147002, 119, '2014-01-15 00:24:28.000000', 'temperatura', 975.0000, 'ºC'),
	(147003, 119, '2014-01-15 00:24:29.000000', 'temperatura', 469.0000, 'ºC'),
	(147004, 119, '2014-01-15 00:24:30.000000', 'temperatura', 621.0000, 'ºC'),
	(147005, 119, '2014-01-15 00:24:31.000000', 'temperatura', 499.0000, 'ºC'),
	(147006, 119, '2014-01-15 00:24:32.000000', 'temperatura', 633.0000, 'ºC'),
	(147007, 119, '2014-01-15 00:24:33.000000', 'temperatura', 467.0000, 'ºC'),
	(147008, 119, '2014-01-15 00:24:34.000000', 'temperatura', 437.0000, 'ºC'),
	(147009, 119, '2014-01-15 00:24:35.000000', 'temperatura', 783.0000, 'ºC'),
	(147010, 119, '2014-01-15 00:24:36.000000', 'temperatura', 205.0000, 'ºC'),
	(147011, 119, '2014-01-15 00:24:37.000000', 'temperatura', 1076.0000, 'ºC'),
	(147012, 119, '2014-01-15 00:24:38.000000', 'temperatura', 1164.0000, 'ºC'),
	(147013, 119, '2014-01-15 00:24:39.000000', 'temperatura', 195.0000, 'ºC'),
	(147014, 119, '2014-01-15 00:24:40.000000', 'temperatura', 1084.0000, 'ºC'),
	(147015, 119, '2014-01-15 00:24:41.000000', 'temperatura', 34.0000, 'ºC'),
	(147016, 119, '2014-01-15 00:24:42.000000', 'temperatura', 519.0000, 'ºC'),
	(147017, 119, '2014-01-15 00:24:43.000000', 'temperatura', 92.0000, 'ºC'),
	(147018, 119, '2014-01-15 00:24:44.000000', 'temperatura', 103.0000, 'ºC'),
	(147019, 119, '2014-01-15 00:24:45.000000', 'temperatura', 239.0000, 'ºC'),
	(147020, 119, '2014-01-15 00:24:46.000000', 'temperatura', 889.0000, 'ºC'),
	(147021, 119, '2014-01-15 00:24:47.000000', 'temperatura', 127.0000, 'ºC'),
	(147022, 119, '2014-01-15 00:24:48.000000', 'temperatura', 367.0000, 'ºC'),
	(147023, 119, '2014-01-15 00:24:49.000000', 'temperatura', 257.0000, 'ºC'),
	(147024, 119, '2014-01-15 00:24:50.000000', 'temperatura', 185.0000, 'ºC'),
	(147025, 119, '2014-01-15 00:24:51.000000', 'temperatura', 154.0000, 'ºC'),
	(147026, 119, '2014-01-15 00:24:52.000000', 'temperatura', 214.0000, 'ºC'),
	(147027, 119, '2014-01-15 00:24:53.000000', 'temperatura', 611.0000, 'ºC'),
	(147028, 119, '2014-01-15 00:24:54.000000', 'temperatura', 14.0000, 'ºC'),
	(147029, 119, '2014-01-15 00:24:55.000000', 'temperatura', 636.0000, 'ºC'),
	(147030, 119, '2014-01-15 00:24:56.000000', 'temperatura', 738.0000, 'ºC'),
	(147031, 119, '2014-01-15 00:24:57.000000', 'temperatura', 583.0000, 'ºC'),
	(147032, 119, '2014-01-15 00:24:58.000000', 'temperatura', 703.0000, 'ºC'),
	(147033, 119, '2014-01-15 00:24:59.000000', 'temperatura', 565.0000, 'ºC'),
	(147034, 119, '2014-01-15 00:25:00.000000', 'temperatura', 715.0000, 'ºC'),
	(147035, 119, '2014-01-15 00:25:01.000000', 'temperatura', 682.0000, 'ºC'),
	(147036, 119, '2014-01-15 00:25:02.000000', 'temperatura', 65.0000, 'ºC'),
	(147037, 119, '2014-01-15 00:25:03.000000', 'temperatura', 681.0000, 'ºC'),
	(147038, 119, '2014-01-15 00:25:04.000000', 'temperatura', 809.0000, 'ºC'),
	(147039, 119, '2014-01-15 00:25:05.000000', 'temperatura', 802.0000, 'ºC'),
	(147040, 119, '2014-01-15 00:25:06.000000', 'temperatura', 383.0000, 'ºC'),
	(147041, 119, '2014-01-15 00:25:07.000000', 'temperatura', 712.0000, 'ºC'),
	(147042, 119, '2014-01-15 00:25:08.000000', 'temperatura', 11.0000, 'ºC'),
	(147043, 119, '2014-01-15 00:25:09.000000', 'temperatura', 321.0000, 'ºC'),
	(147044, 119, '2014-01-15 00:25:10.000000', 'temperatura', 370.0000, 'ºC'),
	(147045, 119, '2014-01-15 00:25:11.000000', 'temperatura', 888.0000, 'ºC'),
	(147046, 119, '2014-01-15 00:25:12.000000', 'temperatura', 929.0000, 'ºC'),
	(147047, 119, '2014-01-15 00:25:13.000000', 'temperatura', 781.0000, 'ºC'),
	(147048, 119, '2014-01-15 00:25:14.000000', 'temperatura', 1121.0000, 'ºC'),
	(147049, 119, '2014-01-15 00:25:15.000000', 'temperatura', 862.0000, 'ºC'),
	(147050, 119, '2014-01-15 00:25:16.000000', 'temperatura', 948.0000, 'ºC'),
	(147051, 119, '2014-01-15 00:25:17.000000', 'temperatura', 954.0000, 'ºC'),
	(147052, 119, '2014-01-15 00:25:18.000000', 'temperatura', 728.0000, 'ºC'),
	(147053, 119, '2014-01-15 00:25:19.000000', 'temperatura', 777.0000, 'ºC'),
	(147054, 119, '2014-01-15 00:25:20.000000', 'temperatura', 503.0000, 'ºC'),
	(147055, 119, '2014-01-15 00:25:21.000000', 'temperatura', 185.0000, 'ºC'),
	(147056, 119, '2014-01-15 00:25:22.000000', 'temperatura', 614.0000, 'ºC'),
	(147057, 119, '2014-01-15 00:25:23.000000', 'temperatura', 115.0000, 'ºC'),
	(147058, 119, '2014-01-15 00:25:24.000000', 'temperatura', 1134.0000, 'ºC'),
	(147059, 119, '2014-01-15 00:25:25.000000', 'temperatura', 527.0000, 'ºC'),
	(147060, 119, '2014-01-15 00:25:26.000000', 'temperatura', 433.0000, 'ºC'),
	(147061, 119, '2014-01-15 00:25:27.000000', 'temperatura', 583.0000, 'ºC'),
	(147062, 119, '2014-01-15 00:25:28.000000', 'temperatura', 418.0000, 'ºC'),
	(147063, 119, '2014-01-15 00:25:29.000000', 'temperatura', 343.0000, 'ºC'),
	(147064, 119, '2014-01-15 00:25:30.000000', 'temperatura', 458.0000, 'ºC'),
	(147065, 119, '2014-01-15 00:25:31.000000', 'temperatura', 65.0000, 'ºC'),
	(147066, 119, '2014-01-15 00:25:32.000000', 'temperatura', 149.0000, 'ºC'),
	(147067, 119, '2014-01-15 00:25:33.000000', 'temperatura', 552.0000, 'ºC'),
	(147068, 119, '2014-01-15 00:25:34.000000', 'temperatura', 1114.0000, 'ºC'),
	(147069, 119, '2014-01-15 00:25:35.000000', 'temperatura', 312.0000, 'ºC'),
	(147070, 119, '2014-01-15 00:25:36.000000', 'temperatura', 621.0000, 'ºC'),
	(147071, 119, '2014-01-15 00:25:37.000000', 'temperatura', 970.0000, 'ºC'),
	(147072, 119, '2014-01-15 00:25:38.000000', 'temperatura', 587.0000, 'ºC'),
	(147073, 119, '2014-01-15 00:25:39.000000', 'temperatura', 25.0000, 'ºC'),
	(147074, 119, '2014-01-15 00:25:40.000000', 'temperatura', 766.0000, 'ºC'),
	(147075, 119, '2014-01-15 00:25:41.000000', 'temperatura', 155.0000, 'ºC'),
	(147076, 119, '2014-01-15 00:25:42.000000', 'temperatura', 876.0000, 'ºC'),
	(147077, 119, '2014-01-15 00:25:43.000000', 'temperatura', 316.0000, 'ºC'),
	(147078, 119, '2014-01-15 00:25:44.000000', 'temperatura', 155.0000, 'ºC'),
	(147079, 119, '2014-01-15 00:25:45.000000', 'temperatura', 1025.0000, 'ºC'),
	(147080, 119, '2014-01-15 00:25:46.000000', 'temperatura', 1062.0000, 'ºC'),
	(147081, 119, '2014-01-15 00:25:47.000000', 'temperatura', 1035.0000, 'ºC'),
	(147082, 119, '2014-01-15 00:25:48.000000', 'temperatura', 789.0000, 'ºC'),
	(147083, 119, '2014-01-15 00:25:49.000000', 'temperatura', 843.0000, 'ºC'),
	(147084, 119, '2014-01-15 00:25:50.000000', 'temperatura', 647.0000, 'ºC'),
	(147085, 119, '2014-01-15 00:25:51.000000', 'temperatura', 705.0000, 'ºC'),
	(147086, 119, '2014-01-15 00:25:52.000000', 'temperatura', 387.0000, 'ºC'),
	(147087, 119, '2014-01-15 00:25:53.000000', 'temperatura', 1018.0000, 'ºC'),
	(147088, 119, '2014-01-15 00:25:54.000000', 'temperatura', 330.0000, 'ºC'),
	(147089, 119, '2014-01-15 00:25:55.000000', 'temperatura', 995.0000, 'ºC'),
	(147090, 119, '2014-01-15 00:25:56.000000', 'temperatura', 388.0000, 'ºC'),
	(147091, 119, '2014-01-15 00:25:57.000000', 'temperatura', 154.0000, 'ºC'),
	(147092, 119, '2014-01-15 00:25:58.000000', 'temperatura', 806.0000, 'ºC'),
	(147093, 119, '2014-01-15 00:25:59.000000', 'temperatura', 1171.0000, 'ºC'),
	(147094, 119, '2014-01-15 00:26:00.000000', 'temperatura', 1036.0000, 'ºC'),
	(147095, 119, '2014-01-15 00:26:01.000000', 'temperatura', 469.0000, 'ºC'),
	(147096, 119, '2014-01-15 00:26:02.000000', 'temperatura', 437.0000, 'ºC'),
	(147097, 119, '2014-01-15 00:26:03.000000', 'temperatura', 780.0000, 'ºC'),
	(147098, 119, '2014-01-15 00:26:04.000000', 'temperatura', 189.0000, 'ºC'),
	(147099, 119, '2014-01-15 00:26:05.000000', 'temperatura', 1006.0000, 'ºC'),
	(147100, 119, '2014-01-15 00:26:06.000000', 'temperatura', 862.0000, 'ºC'),
	(147101, 119, '2014-01-15 00:26:07.000000', 'temperatura', 95.0000, 'ºC'),
	(147102, 119, '2014-01-15 00:26:08.000000', 'temperatura', 288.0000, 'ºC'),
	(147103, 119, '2014-01-15 00:26:09.000000', 'temperatura', 1154.0000, 'ºC'),
	(147104, 119, '2014-01-15 00:26:10.000000', 'temperatura', 106.0000, 'ºC'),
	(147105, 119, '2014-01-15 00:26:11.000000', 'temperatura', 671.0000, 'ºC'),
	(147106, 119, '2014-01-15 00:26:12.000000', 'temperatura', 637.0000, 'ºC'),
	(147107, 119, '2014-01-15 00:26:13.000000', 'temperatura', 1173.0000, 'ºC'),
	(147108, 119, '2014-01-15 00:26:14.000000', 'temperatura', 352.0000, 'ºC'),
	(147109, 119, '2014-01-15 00:26:15.000000', 'temperatura', 645.0000, 'ºC'),
	(147110, 119, '2014-01-15 00:26:16.000000', 'temperatura', 966.0000, 'ºC'),
	(147111, 119, '2014-01-15 00:26:17.000000', 'temperatura', 497.0000, 'ºC'),
	(147112, 119, '2014-01-15 00:26:18.000000', 'temperatura', 788.0000, 'ºC'),
	(147113, 119, '2014-01-15 00:26:19.000000', 'temperatura', 49.0000, 'ºC'),
	(147114, 119, '2014-01-15 00:26:20.000000', 'temperatura', 282.0000, 'ºC'),
	(147115, 119, '2014-01-15 00:26:21.000000', 'temperatura', 62.0000, 'ºC'),
	(147116, 119, '2014-01-15 00:26:22.000000', 'temperatura', 667.0000, 'ºC'),
	(147117, 119, '2014-01-15 00:26:23.000000', 'temperatura', 747.0000, 'ºC'),
	(147118, 119, '2014-01-15 00:26:24.000000', 'temperatura', 536.0000, 'ºC'),
	(147119, 119, '2014-01-15 00:26:25.000000', 'temperatura', 439.0000, 'ºC'),
	(147120, 119, '2014-01-15 00:26:26.000000', 'temperatura', 587.0000, 'ºC'),
	(147121, 119, '2014-01-15 00:26:27.000000', 'temperatura', 421.0000, 'ºC'),
	(147122, 119, '2014-01-15 00:26:28.000000', 'temperatura', 343.0000, 'ºC'),
	(147123, 119, '2014-01-15 00:26:29.000000', 'temperatura', 453.0000, 'ºC'),
	(147124, 119, '2014-01-15 00:26:30.000000', 'temperatura', 36.0000, 'ºC'),
	(147125, 119, '2014-01-15 00:26:31.000000', 'temperatura', 22.0000, 'ºC'),
	(147126, 119, '2014-01-15 00:26:32.000000', 'temperatura', 4.0000, 'ºC'),
	(147127, 119, '2014-01-15 00:26:33.000000', 'temperatura', 1151.0000, 'ºC'),
	(147128, 119, '2014-01-15 00:26:34.000000', 'temperatura', 947.0000, 'ºC'),
	(147129, 119, '2014-01-15 00:26:35.000000', 'temperatura', 81.0000, 'ºC'),
	(147130, 119, '2014-01-15 00:26:36.000000', 'temperatura', 1163.0000, 'ºC'),
	(147131, 119, '2014-01-15 00:26:37.000000', 'temperatura', 775.0000, 'ºC'),
	(147132, 119, '2014-01-15 00:26:38.000000', 'temperatura', 387.0000, 'ºC'),
	(147133, 119, '2014-01-15 00:26:39.000000', 'temperatura', 808.0000, 'ºC'),
	(147134, 119, '2014-01-15 00:26:40.000000', 'temperatura', 480.0000, 'ºC'),
	(147135, 119, '2014-01-15 00:26:41.000000', 'temperatura', 1179.0000, 'ºC'),
	(147136, 119, '2014-01-15 00:26:42.000000', 'temperatura', 853.0000, 'ºC'),
	(147137, 119, '2014-01-15 00:26:43.000000', 'temperatura', 728.0000, 'ºC'),
	(147138, 119, '2014-01-15 00:26:44.000000', 'temperatura', 1082.0000, 'ºC'),
	(147139, 119, '2014-01-15 00:26:45.000000', 'temperatura', 825.0000, 'ºC'),
	(147140, 119, '2014-01-15 00:26:46.000000', 'temperatura', 880.0000, 'ºC'),
	(147141, 119, '2014-01-15 00:26:47.000000', 'temperatura', 725.0000, 'ºC'),
	(147142, 119, '2014-01-15 00:26:48.000000', 'temperatura', 984.0000, 'ºC'),
	(147143, 119, '2014-01-15 00:26:49.000000', 'temperatura', 348.0000, 'ºC'),
	(147144, 119, '2014-01-15 00:26:50.000000', 'temperatura', 1189.0000, 'ºC'),
	(147145, 119, '2014-01-15 00:26:51.000000', 'temperatura', 102.0000, 'ºC'),
	(147146, 119, '2014-01-15 00:26:52.000000', 'temperatura', 544.0000, 'ºC'),
	(147147, 119, '2014-01-15 00:26:53.000000', 'temperatura', 15.0000, 'ºC'),
	(147148, 119, '2014-01-15 00:26:54.000000', 'temperatura', 842.0000, 'ºC'),
	(147149, 119, '2014-01-15 00:26:55.000000', 'temperatura', 565.0000, 'ºC'),
	(147150, 119, '2014-01-15 00:26:56.000000', 'temperatura', 300.0000, 'ºC'),
	(147151, 119, '2014-01-15 00:26:57.000000', 'temperatura', 1007.0000, 'ºC'),
	(147152, 119, '2014-01-15 00:26:58.000000', 'temperatura', 533.0000, 'ºC'),
	(147153, 119, '2014-01-15 00:26:59.000000', 'temperatura', 844.0000, 'ºC'),
	(147154, 119, '2014-01-15 00:27:00.000000', 'temperatura', 222.0000, 'ºC'),
	(147155, 119, '2014-01-15 00:27:01.000000', 'temperatura', 981.0000, 'ºC'),
	(147156, 119, '2014-01-15 00:27:02.000000', 'temperatura', 638.0000, 'ºC'),
	(147157, 119, '2014-01-15 00:27:03.000000', 'temperatura', 246.0000, 'ºC'),
	(147158, 119, '2014-01-15 00:27:04.000000', 'temperatura', 516.0000, 'ºC'),
	(147159, 119, '2014-01-15 00:27:05.000000', 'temperatura', 643.0000, 'ºC'),
	(147160, 119, '2014-01-15 00:27:06.000000', 'temperatura', 467.0000, 'ºC'),
	(147161, 119, '2014-01-15 00:27:07.000000', 'temperatura', 406.0000, 'ºC'),
	(147162, 119, '2014-01-15 00:27:08.000000', 'temperatura', 632.0000, 'ºC'),
	(147163, 119, '2014-01-15 00:27:09.000000', 'temperatura', 740.0000, 'ºC'),
	(147164, 119, '2014-01-15 00:27:10.000000', 'temperatura', 606.0000, 'ºC'),
	(147165, 119, '2014-01-15 00:27:11.000000', 'temperatura', 812.0000, 'ºC'),
	(147166, 119, '2014-01-15 00:27:12.000000', 'temperatura', 1042.0000, 'ºC'),
	(147167, 119, '2014-01-15 00:27:13.000000', 'temperatura', 375.0000, 'ºC'),
	(147168, 119, '2014-01-15 00:27:14.000000', 'temperatura', 1148.0000, 'ºC'),
	(147169, 119, '2014-01-15 00:27:15.000000', 'temperatura', 1014.0000, 'ºC'),
	(147170, 119, '2014-01-15 00:27:16.000000', 'temperatura', 429.0000, 'ºC'),
	(147171, 119, '2014-01-15 00:27:17.000000', 'temperatura', 302.0000, 'ºC'),
	(147172, 119, '2014-01-15 00:27:18.000000', 'temperatura', 225.0000, 'ºC'),
	(147173, 119, '2014-01-15 00:27:19.000000', 'temperatura', 218.0000, 'ºC'),
	(147174, 119, '2014-01-15 00:27:20.000000', 'temperatura', 416.0000, 'ºC'),
	(147175, 119, '2014-01-15 00:27:21.000000', 'temperatura', 227.0000, 'ºC'),
	(147176, 119, '2014-01-15 00:27:22.000000', 'temperatura', 1085.0000, 'ºC'),
	(147177, 119, '2014-01-15 00:27:23.000000', 'temperatura', 1147.0000, 'ºC'),
	(147178, 119, '2014-01-15 00:27:24.000000', 'temperatura', 80.0000, 'ºC'),
	(147179, 119, '2014-01-15 00:27:25.000000', 'temperatura', 560.0000, 'ºC'),
	(147180, 119, '2014-01-15 00:27:26.000000', 'temperatura', 161.0000, 'ºC'),
	(147181, 119, '2014-01-15 00:27:27.000000', 'temperatura', 326.0000, 'ºC'),
	(147182, 119, '2014-01-15 00:27:28.000000', 'temperatura', 1145.0000, 'ºC'),
	(147183, 119, '2014-01-15 00:27:29.000000', 'temperatura', 1149.0000, 'ºC'),
	(147184, 119, '2014-01-15 00:27:30.000000', 'temperatura', 1109.0000, 'ºC'),
	(147185, 119, '2014-01-15 00:27:31.000000', 'temperatura', 900.0000, 'ºC'),
	(147186, 119, '2014-01-15 00:27:32.000000', 'temperatura', 1173.0000, 'ºC'),
	(147187, 119, '2014-01-15 00:27:33.000000', 'temperatura', 768.0000, 'ºC'),
	(147188, 119, '2014-01-15 00:27:34.000000', 'temperatura', 318.0000, 'ºC'),
	(147189, 119, '2014-01-15 00:27:35.000000', 'temperatura', 487.0000, 'ºC'),
	(147190, 119, '2014-01-15 00:27:36.000000', 'temperatura', 282.0000, 'ºC'),
	(147191, 119, '2014-01-15 00:27:37.000000', 'temperatura', 1151.0000, 'ºC'),
	(147192, 119, '2014-01-15 00:27:38.000000', 'temperatura', 106.0000, 'ºC'),
	(147193, 119, '2014-01-15 00:27:39.000000', 'temperatura', 681.0000, 'ºC'),
	(147194, 119, '2014-01-15 00:27:40.000000', 'temperatura', 685.0000, 'ºC'),
	(147195, 119, '2014-01-15 00:27:41.000000', 'temperatura', 182.0000, 'ºC'),
	(147196, 119, '2014-01-15 00:27:42.000000', 'temperatura', 56.0000, 'ºC'),
	(147197, 119, '2014-01-15 00:27:43.000000', 'temperatura', 936.0000, 'ºC'),
	(147198, 119, '2014-01-15 00:27:44.000000', 'temperatura', 911.0000, 'ºC'),
	(147199, 119, '2014-01-15 00:27:45.000000', 'temperatura', 547.0000, 'ºC'),
	(147200, 119, '2014-01-15 00:27:46.000000', 'temperatura', 5.0000, 'ºC'),
	(147201, 119, '2014-01-15 00:27:47.000000', 'temperatura', 783.0000, 'ºC'),
	(147202, 119, '2014-01-15 00:27:48.000000', 'temperatura', 300.0000, 'ºC'),
	(147203, 119, '2014-01-15 00:27:49.000000', 'temperatura', 351.0000, 'ºC'),
	(147204, 119, '2014-01-15 00:27:50.000000', 'temperatura', 856.0000, 'ºC'),
	(147205, 119, '2014-01-15 00:27:51.000000', 'temperatura', 829.0000, 'ºC'),
	(147206, 119, '2014-01-15 00:27:52.000000', 'temperatura', 376.0000, 'ºC'),
	(147207, 119, '2014-01-15 00:27:53.000000', 'temperatura', 594.0000, 'ºC'),
	(147208, 119, '2014-01-15 00:27:54.000000', 'temperatura', 642.0000, 'ºC'),
	(147209, 119, '2014-01-15 00:27:55.000000', 'temperatura', 227.0000, 'ºC'),
	(147210, 119, '2014-01-15 00:27:56.000000', 'temperatura', 410.0000, 'ºC'),
	(147211, 119, '2014-01-15 00:27:57.000000', 'temperatura', 170.0000, 'ºC'),
	(147212, 119, '2014-01-15 00:27:58.000000', 'temperatura', 822.0000, 'ºC'),
	(147213, 119, '2014-01-15 00:27:59.000000', 'temperatura', 1198.0000, 'ºC'),
	(147214, 119, '2014-01-15 00:28:00.000000', 'temperatura', 1127.0000, 'ºC'),
	(147215, 119, '2014-01-15 00:28:01.000000', 'temperatura', 840.0000, 'ºC'),
	(147216, 119, '2014-01-15 00:28:02.000000', 'temperatura', 819.0000, 'ºC'),
	(147217, 119, '2014-01-15 00:28:03.000000', 'temperatura', 375.0000, 'ºC'),
	(147218, 119, '2014-01-15 00:28:04.000000', 'temperatura', 621.0000, 'ºC'),
	(147219, 119, '2014-01-15 00:28:05.000000', 'temperatura', 778.0000, 'ºC'),
	(147220, 119, '2014-01-15 00:28:06.000000', 'temperatura', 830.0000, 'ºC'),
	(147221, 119, '2014-01-15 00:28:07.000000', 'temperatura', 617.0000, 'ºC'),
	(147222, 119, '2014-01-15 00:28:08.000000', 'temperatura', 596.0000, 'ºC'),
	(147223, 119, '2014-01-15 00:28:09.000000', 'temperatura', 1130.0000, 'ºC'),
	(147224, 119, '2014-01-15 00:28:10.000000', 'temperatura', 260.0000, 'ºC'),
	(147225, 119, '2014-01-15 00:28:11.000000', 'temperatura', 309.0000, 'ºC'),
	(147226, 119, '2014-01-15 00:28:12.000000', 'temperatura', 769.0000, 'ºC'),
	(147227, 119, '2014-01-15 00:28:13.000000', 'temperatura', 517.0000, 'ºC'),
	(147228, 119, '2014-01-15 00:28:14.000000', 'temperatura', 280.0000, 'ºC'),
	(147229, 119, '2014-01-15 00:28:15.000000', 'temperatura', 1050.0000, 'ºC'),
	(147230, 119, '2014-01-15 00:28:16.000000', 'temperatura', 807.0000, 'ºC'),
	(147231, 119, '2014-01-15 00:28:17.000000', 'temperatura', 889.0000, 'ºC'),
	(147232, 119, '2014-01-15 00:28:18.000000', 'temperatura', 822.0000, 'ºC'),
	(147233, 119, '2014-01-15 00:28:19.000000', 'temperatura', 246.0000, 'ºC'),
	(147234, 119, '2014-01-15 00:28:20.000000', 'temperatura', 1164.0000, 'ºC'),
	(147235, 119, '2014-01-15 00:28:21.000000', 'temperatura', 280.0000, 'ºC'),
	(147236, 119, '2014-01-15 00:28:22.000000', 'temperatura', 310.0000, 'ºC'),
	(147237, 119, '2014-01-15 00:28:23.000000', 'temperatura', 711.0000, 'ºC'),
	(147238, 119, '2014-01-15 00:28:24.000000', 'temperatura', 226.0000, 'ºC'),
	(147239, 119, '2014-01-15 00:28:25.000000', 'temperatura', 198.0000, 'ºC'),
	(147240, 119, '2014-01-15 00:28:26.000000', 'temperatura', 312.0000, 'ºC'),
	(147241, 119, '2014-01-15 00:28:27.000000', 'temperatura', 964.0000, 'ºC'),
	(147242, 119, '2014-01-15 00:28:28.000000', 'temperatura', 287.0000, 'ºC'),
	(147243, 119, '2014-01-15 00:28:29.000000', 'temperatura', 942.0000, 'ºC'),
	(147244, 119, '2014-01-15 00:28:30.000000', 'temperatura', 252.0000, 'ºC'),
	(147245, 119, '2014-01-15 00:28:31.000000', 'temperatura', 832.0000, 'ºC'),
	(147246, 119, '2014-01-15 00:28:32.000000', 'temperatura', 1004.0000, 'ºC'),
	(147247, 119, '2014-01-15 00:28:33.000000', 'temperatura', 125.0000, 'ºC'),
	(147248, 119, '2014-01-15 00:28:34.000000', 'temperatura', 12.0000, 'ºC'),
	(147249, 119, '2014-01-15 00:28:35.000000', 'temperatura', 889.0000, 'ºC'),
	(147250, 119, '2014-01-15 00:28:36.000000', 'temperatura', 806.0000, 'ºC'),
	(147251, 119, '2014-01-15 00:28:37.000000', 'temperatura', 166.0000, 'ºC'),
	(147252, 119, '2014-01-15 00:28:38.000000', 'temperatura', 811.0000, 'ºC'),
	(147253, 119, '2014-01-15 00:28:39.000000', 'temperatura', 1158.0000, 'ºC'),
	(147254, 119, '2014-01-15 00:28:40.000000', 'temperatura', 956.0000, 'ºC'),
	(147255, 119, '2014-01-15 00:28:41.000000', 'temperatura', 107.0000, 'ºC'),
	(147256, 119, '2014-01-15 00:28:42.000000', 'temperatura', 67.0000, 'ºC'),
	(147257, 119, '2014-01-15 00:28:43.000000', 'temperatura', 14.0000, 'ºC'),
	(147258, 119, '2014-01-15 00:28:44.000000', 'temperatura', 1069.0000, 'ºC'),
	(147259, 119, '2014-01-15 00:28:45.000000', 'temperatura', 503.0000, 'ºC'),
	(147260, 119, '2014-01-15 00:28:46.000000', 'temperatura', 511.0000, 'ºC'),
	(147261, 119, '2014-01-15 00:28:47.000000', 'temperatura', 1046.0000, 'ºC'),
	(147262, 119, '2014-01-15 00:28:48.000000', 'temperatura', 99.0000, 'ºC'),
	(147263, 119, '2014-01-15 00:28:49.000000', 'temperatura', 956.0000, 'ºC'),
	(147264, 119, '2014-01-15 00:28:50.000000', 'temperatura', 886.0000, 'ºC'),
	(147265, 119, '2014-01-15 00:28:51.000000', 'temperatura', 360.0000, 'ºC'),
	(147266, 119, '2014-01-15 00:28:52.000000', 'temperatura', 341.0000, 'ºC'),
	(147267, 119, '2014-01-15 00:28:53.000000', 'temperatura', 628.0000, 'ºC'),
	(147268, 119, '2014-01-15 00:28:54.000000', 'temperatura', 915.0000, 'ºC'),
	(147269, 119, '2014-01-15 00:28:55.000000', 'temperatura', 294.0000, 'ºC'),
	(147270, 119, '2014-01-15 00:28:56.000000', 'temperatura', 1126.0000, 'ºC'),
	(147271, 119, '2014-01-15 00:28:57.000000', 'temperatura', 1147.0000, 'ºC'),
	(147272, 119, '2014-01-15 00:28:58.000000', 'temperatura', 1158.0000, 'ºC'),
	(147273, 119, '2014-01-15 00:28:59.000000', 'temperatura', 1148.0000, 'ºC'),
	(147274, 119, '2014-01-15 00:29:00.000000', 'temperatura', 1066.0000, 'ºC'),
	(147275, 119, '2014-01-15 00:29:01.000000', 'temperatura', 686.0000, 'ºC'),
	(147276, 119, '2014-01-15 00:29:02.000000', 'temperatura', 234.0000, 'ºC'),
	(147277, 119, '2014-01-15 00:29:03.000000', 'temperatura', 313.0000, 'ºC'),
	(147278, 119, '2014-01-15 00:29:04.000000', 'temperatura', 862.0000, 'ºC'),
	(147279, 119, '2014-01-15 00:29:05.000000', 'temperatura', 971.0000, 'ºC'),
	(147280, 119, '2014-01-15 00:29:06.000000', 'temperatura', 1071.0000, 'ºC'),
	(147281, 119, '2014-01-15 00:29:07.000000', 'temperatura', 40.0000, 'ºC'),
	(147282, 119, '2014-01-15 00:29:08.000000', 'temperatura', 589.0000, 'ºC'),
	(147283, 119, '2014-01-15 00:29:09.000000', 'temperatura', 427.0000, 'ºC'),
	(147284, 119, '2014-01-15 00:29:10.000000', 'temperatura', 369.0000, 'ºC'),
	(147285, 119, '2014-01-15 00:29:11.000000', 'temperatura', 563.0000, 'ºC'),
	(147286, 119, '2014-01-15 00:29:12.000000', 'temperatura', 510.0000, 'ºC'),
	(147287, 119, '2014-01-15 00:29:13.000000', 'temperatura', 859.0000, 'ºC'),
	(147288, 119, '2014-01-15 00:29:14.000000', 'temperatura', 365.0000, 'ºC'),
	(147289, 119, '2014-01-15 00:29:15.000000', 'temperatura', 449.0000, 'ºC'),
	(147290, 119, '2014-01-15 00:29:16.000000', 'temperatura', 1153.0000, 'ºC'),
	(147291, 119, '2014-01-15 00:29:17.000000', 'temperatura', 817.0000, 'ºC'),
	(147292, 119, '2014-01-15 00:29:18.000000', 'temperatura', 628.0000, 'ºC'),
	(147293, 119, '2014-01-15 00:29:19.000000', 'temperatura', 691.0000, 'ºC'),
	(147294, 119, '2014-01-15 00:29:20.000000', 'temperatura', 368.0000, 'ºC'),
	(147295, 119, '2014-01-15 00:29:21.000000', 'temperatura', 968.0000, 'ºC'),
	(147296, 119, '2014-01-15 00:29:22.000000', 'temperatura', 138.0000, 'ºC'),
	(147297, 119, '2014-01-15 00:29:23.000000', 'temperatura', 185.0000, 'ºC'),
	(147298, 119, '2014-01-15 00:29:24.000000', 'temperatura', 510.0000, 'ºC'),
	(147299, 119, '2014-01-15 00:29:25.000000', 'temperatura', 798.0000, 'ºC'),
	(147300, 119, '2014-01-15 00:29:26.000000', 'temperatura', 60.0000, 'ºC'),
	(147301, 119, '2014-01-15 00:29:27.000000', 'temperatura', 306.0000, 'ºC'),
	(147302, 119, '2014-01-15 00:29:28.000000', 'temperatura', 149.0000, 'ºC'),
	(147303, 119, '2014-01-15 00:29:29.000000', 'temperatura', 1030.0000, 'ºC'),
	(147304, 119, '2014-01-15 00:29:30.000000', 'temperatura', 1104.0000, 'ºC'),
	(147305, 119, '2014-01-15 00:29:31.000000', 'temperatura', 31.0000, 'ºC'),
	(147306, 119, '2014-01-15 00:29:32.000000', 'temperatura', 441.0000, 'ºC'),
	(147307, 119, '2014-01-15 00:29:33.000000', 'temperatura', 912.0000, 'ºC'),
	(147308, 119, '2014-01-15 00:29:34.000000', 'temperatura', 839.0000, 'ºC'),
	(147309, 119, '2014-01-15 00:29:35.000000', 'temperatura', 259.0000, 'ºC'),
	(147310, 119, '2014-01-15 00:29:36.000000', 'temperatura', 1177.0000, 'ºC'),
	(147311, 119, '2014-01-15 00:29:37.000000', 'temperatura', 308.0000, 'ºC'),
	(147312, 119, '2014-01-15 00:29:38.000000', 'temperatura', 410.0000, 'ºC'),
	(147313, 119, '2014-01-15 00:29:39.000000', 'temperatura', 1125.0000, 'ºC'),
	(147314, 119, '2014-01-15 00:29:40.000000', 'temperatura', 798.0000, 'ºC'),
	(147315, 119, '2014-01-15 00:29:41.000000', 'temperatura', 616.0000, 'ºC'),
	(147316, 119, '2014-01-15 00:29:42.000000', 'temperatura', 686.0000, 'ºC'),
	(147317, 119, '2014-01-15 00:29:43.000000', 'temperatura', 383.0000, 'ºC'),
	(147318, 119, '2014-01-15 00:29:44.000000', 'temperatura', 1056.0000, 'ºC'),
	(147319, 119, '2014-01-15 00:29:45.000000', 'temperatura', 533.0000, 'ºC'),
	(147320, 119, '2014-01-15 00:29:46.000000', 'temperatura', 697.0000, 'ºC'),
	(147321, 119, '2014-01-15 00:29:47.000000', 'temperatura', 685.0000, 'ºC'),
	(147322, 119, '2014-01-15 00:29:48.000000', 'temperatura', 135.0000, 'ºC'),
	(147323, 119, '2014-01-15 00:29:49.000000', 'temperatura', 1023.0000, 'ºC'),
	(147324, 119, '2014-01-15 00:29:50.000000', 'temperatura', 1108.0000, 'ºC'),
	(147325, 119, '2014-01-15 00:29:51.000000', 'temperatura', 71.0000, 'ºC'),
	(147326, 119, '2014-01-15 00:29:52.000000', 'temperatura', 631.0000, 'ºC'),
	(147327, 119, '2014-01-15 00:29:53.000000', 'temperatura', 545.0000, 'ºC'),
	(147328, 119, '2014-01-15 00:29:54.000000', 'temperatura', 830.0000, 'ºC'),
	(147329, 119, '2014-01-15 00:29:55.000000', 'temperatura', 116.0000, 'ºC'),
	(147330, 119, '2014-01-15 00:29:56.000000', 'temperatura', 489.0000, 'ºC'),
	(147331, 119, '2014-01-15 00:29:57.000000', 'temperatura', 899.0000, 'ºC'),
	(147332, 119, '2014-01-15 00:29:58.000000', 'temperatura', 630.0000, 'ºC'),
	(147333, 119, '2014-01-15 00:29:59.000000', 'temperatura', 452.0000, 'ºC'),
	(147334, 119, '2014-01-15 00:30:00.000000', 'temperatura', 370.0000, 'ºC'),
	(147335, 119, '2014-01-15 00:30:01.000000', 'temperatura', 497.0000, 'ºC'),
	(147336, 119, '2014-01-15 00:30:02.000000', 'temperatura', 173.0000, 'ºC'),
	(147337, 119, '2014-01-15 00:30:03.000000', 'temperatura', 575.0000, 'ºC'),
	(147338, 119, '2014-01-15 00:30:04.000000', 'temperatura', 1157.0000, 'ºC'),
	(147339, 119, '2014-01-15 00:30:05.000000', 'temperatura', 462.0000, 'ºC'),
	(147340, 119, '2014-01-15 00:30:06.000000', 'temperatura', 40.0000, 'ºC'),
	(147341, 119, '2014-01-15 00:30:07.000000', 'temperatura', 11.0000, 'ºC'),
	(147342, 119, '2014-01-15 00:30:08.000000', 'temperatura', 1139.0000, 'ºC'),
	(147343, 119, '2014-01-15 00:30:09.000000', 'temperatura', 861.0000, 'ºC'),
	(147344, 119, '2014-01-15 00:30:10.000000', 'temperatura', 888.0000, 'ºC'),
	(147345, 119, '2014-01-15 00:30:11.000000', 'temperatura', 656.0000, 'ºC'),
	(147346, 119, '2014-01-15 00:30:12.000000', 'temperatura', 619.0000, 'ºC'),
	(147347, 119, '2014-01-15 00:30:13.000000', 'temperatura', 1127.0000, 'ºC'),
	(147348, 119, '2014-01-15 00:30:14.000000', 'temperatura', 180.0000, 'ºC'),
	(147349, 119, '2014-01-15 00:30:15.000000', 'temperatura', 1118.0000, 'ºC'),
	(147350, 119, '2014-01-15 00:30:16.000000', 'temperatura', 249.0000, 'ºC'),
	(147351, 119, '2014-01-15 00:30:17.000000', 'temperatura', 294.0000, 'ºC'),
	(147352, 119, '2014-01-15 00:30:18.000000', 'temperatura', 725.0000, 'ºC'),
	(147353, 119, '2014-01-15 00:30:19.000000', 'temperatura', 340.0000, 'ºC'),
	(147354, 119, '2014-01-15 00:30:20.000000', 'temperatura', 728.0000, 'ºC'),
	(147355, 119, '2014-01-15 00:30:21.000000', 'temperatura', 218.0000, 'ºC'),
	(147356, 119, '2014-01-15 00:30:22.000000', 'temperatura', 106.0000, 'ºC'),
	(147357, 119, '2014-01-15 00:30:23.000000', 'temperatura', 1076.0000, 'ºC'),
	(147358, 119, '2014-01-15 00:30:24.000000', 'temperatura', 262.0000, 'ºC'),
	(147359, 119, '2014-01-15 00:30:25.000000', 'temperatura', 485.0000, 'ºC'),
	(147360, 119, '2014-01-15 00:30:26.000000', 'temperatura', 439.0000, 'ºC'),
	(147361, 119, '2014-01-15 00:30:27.000000', 'temperatura', 738.0000, 'ºC'),
	(147362, 119, '2014-01-15 00:30:28.000000', 'temperatura', 1177.0000, 'ºC'),
	(147363, 119, '2014-01-15 00:30:29.000000', 'temperatura', 70.0000, 'ºC'),
	(147364, 119, '2014-01-15 00:30:30.000000', 'temperatura', 419.0000, 'ºC'),
	(147365, 119, '2014-01-15 00:30:31.000000', 'temperatura', 685.0000, 'ºC'),
	(147366, 119, '2014-01-15 00:30:32.000000', 'temperatura', 967.0000, 'ºC'),
	(147367, 119, '2014-01-15 00:30:33.000000', 'temperatura', 384.0000, 'ºC'),
	(147368, 119, '2014-01-15 00:30:34.000000', 'temperatura', 218.0000, 'ºC'),
	(147369, 119, '2014-01-15 00:30:35.000000', 'temperatura', 1138.0000, 'ºC'),
	(147370, 119, '2014-01-15 00:30:36.000000', 'temperatura', 235.0000, 'ºC'),
	(147371, 119, '2014-01-15 00:30:37.000000', 'temperatura', 164.0000, 'ºC'),
	(147372, 119, '2014-01-15 00:30:38.000000', 'temperatura', 114.0000, 'ºC'),
	(147373, 119, '2014-01-15 00:30:39.000000', 'temperatura', 78.0000, 'ºC'),
	(147374, 119, '2014-01-15 00:30:40.000000', 'temperatura', 51.0000, 'ºC'),
	(147375, 119, '2014-01-15 00:30:41.000000', 'temperatura', 19.0000, 'ºC'),
	(147376, 119, '2014-01-15 00:30:42.000000', 'temperatura', 1143.0000, 'ºC'),
	(147377, 119, '2014-01-15 00:30:43.000000', 'temperatura', 858.0000, 'ºC'),
	(147378, 119, '2014-01-15 00:30:44.000000', 'temperatura', 863.0000, 'ºC'),
	(147379, 119, '2014-01-15 00:30:45.000000', 'temperatura', 540.0000, 'ºC'),
	(147380, 119, '2014-01-15 00:30:46.000000', 'temperatura', 110.0000, 'ºC'),
	(147381, 119, '2014-01-15 00:30:47.000000', 'temperatura', 133.0000, 'ºC'),
	(147382, 119, '2014-01-15 00:30:48.000000', 'temperatura', 335.0000, 'ºC'),
	(147383, 119, '2014-01-15 00:30:49.000000', 'temperatura', 77.0000, 'ºC'),
	(147384, 119, '2014-01-15 00:30:50.000000', 'temperatura', 581.0000, 'ºC'),
	(147385, 119, '2014-01-15 00:30:51.000000', 'temperatura', 273.0000, 'ºC'),
	(147386, 119, '2014-01-15 00:30:52.000000', 'temperatura', 822.0000, 'ºC'),
	(147387, 119, '2014-01-15 00:30:53.000000', 'temperatura', 891.0000, 'ºC'),
	(147388, 119, '2014-01-15 00:30:54.000000', 'temperatura', 790.0000, 'ºC'),
	(147389, 119, '2014-01-15 00:30:55.000000', 'temperatura', 77.0000, 'ºC'),
	(147390, 119, '2014-01-15 00:30:56.000000', 'temperatura', 415.0000, 'ºC'),
	(147391, 119, '2014-01-15 00:30:57.000000', 'temperatura', 645.0000, 'ºC'),
	(147392, 119, '2014-01-15 00:30:58.000000', 'temperatura', 782.0000, 'ºC'),
	(147393, 119, '2014-01-15 00:30:59.000000', 'temperatura', 775.0000, 'ºC'),
	(147394, 119, '2014-01-15 00:31:00.000000', 'temperatura', 329.0000, 'ºC'),
	(147395, 119, '2014-01-15 00:31:01.000000', 'temperatura', 520.0000, 'ºC'),
	(147396, 119, '2014-01-15 00:31:02.000000', 'temperatura', 414.0000, 'ºC'),
	(147397, 119, '2014-01-15 00:31:03.000000', 'temperatura', 510.0000, 'ºC'),
	(147398, 119, '2014-01-15 00:31:04.000000', 'temperatura', 108.0000, 'ºC'),
	(147399, 119, '2014-01-15 00:31:05.000000', 'temperatura', 210.0000, 'ºC'),
	(147400, 119, '2014-01-15 00:31:06.000000', 'temperatura', 726.0000, 'ºC'),
	(147401, 119, '2014-01-15 00:31:07.000000', 'temperatura', 601.0000, 'ºC'),
	(147402, 119, '2014-01-15 00:31:08.000000', 'temperatura', 827.0000, 'ºC'),
	(147403, 119, '2014-01-15 00:31:09.000000', 'temperatura', 1133.0000, 'ºC'),
	(147404, 119, '2014-01-15 00:31:10.000000', 'temperatura', 784.0000, 'ºC'),
	(147405, 119, '2014-01-15 00:31:11.000000', 'temperatura', 523.0000, 'ºC'),
	(147406, 119, '2014-01-15 00:31:12.000000', 'temperatura', 263.0000, 'ºC'),
	(147407, 119, '2014-01-15 00:31:13.000000', 'temperatura', 946.0000, 'ºC'),
	(147408, 119, '2014-01-15 00:31:14.000000', 'temperatura', 343.0000, 'ºC'),
	(147409, 119, '2014-01-15 00:31:15.000000', 'temperatura', 75.0000, 'ºC'),
	(147410, 119, '2014-01-15 00:31:16.000000', 'temperatura', 549.0000, 'ºC'),
	(147411, 119, '2014-01-15 00:31:17.000000', 'temperatura', 121.0000, 'ºC'),
	(147412, 119, '2014-01-15 00:31:18.000000', 'temperatura', 155.0000, 'ºC'),
	(147413, 119, '2014-01-15 00:31:19.000000', 'temperatura', 416.0000, 'ºC'),
	(147414, 119, '2014-01-15 00:31:20.000000', 'temperatura', 414.0000, 'ºC'),
	(147415, 119, '2014-01-15 00:31:21.000000', 'temperatura', 824.0000, 'ºC'),
	(147416, 119, '2014-01-15 00:31:22.000000', 'temperatura', 478.0000, 'ºC'),
	(147417, 119, '2014-01-15 00:31:23.000000', 'temperatura', 1120.0000, 'ºC'),
	(147418, 119, '2014-01-15 00:31:24.000000', 'temperatura', 563.0000, 'ºC'),
	(147419, 119, '2014-01-15 00:31:25.000000', 'temperatura', 658.0000, 'ºC'),
	(147420, 119, '2014-01-15 00:31:26.000000', 'temperatura', 401.0000, 'ºC'),
	(147421, 119, '2014-01-15 00:31:27.000000', 'temperatura', 30.0000, 'ºC'),
	(147422, 119, '2014-01-15 00:31:28.000000', 'temperatura', 149.0000, 'ºC'),
	(147423, 119, '2014-01-15 00:31:29.000000', 'temperatura', 655.0000, 'ºC'),
	(147424, 119, '2014-01-15 00:31:30.000000', 'temperatura', 428.0000, 'ºC'),
	(147425, 119, '2014-01-15 00:31:31.000000', 'temperatura', 177.0000, 'ºC'),
	(147426, 119, '2014-01-15 00:31:32.000000', 'temperatura', 802.0000, 'ºC'),
	(147427, 119, '2014-01-15 00:31:33.000000', 'temperatura', 1078.0000, 'ºC'),
	(147428, 119, '2014-01-15 00:31:34.000000', 'temperatura', 585.0000, 'ºC'),
	(147429, 119, '2014-01-15 00:31:35.000000', 'temperatura', 891.0000, 'ºC'),
	(147430, 119, '2014-01-15 00:31:36.000000', 'temperatura', 300.0000, 'ºC'),
	(147431, 119, '2014-01-15 00:31:37.000000', 'temperatura', 27.0000, 'ºC'),
	(147432, 119, '2014-01-15 00:31:38.000000', 'temperatura', 436.0000, 'ºC'),
	(147433, 119, '2014-01-15 00:31:39.000000', 'temperatura', 898.0000, 'ºC'),
	(147434, 119, '2014-01-15 00:31:40.000000', 'temperatura', 784.0000, 'ºC'),
	(147435, 119, '2014-01-15 00:31:41.000000', 'temperatura', 28.0000, 'ºC'),
	(147436, 119, '2014-01-15 00:31:42.000000', 'temperatura', 189.0000, 'ºC'),
	(147437, 119, '2014-01-15 00:31:43.000000', 'temperatura', 860.0000, 'ºC'),
	(147438, 119, '2014-01-15 00:31:44.000000', 'temperatura', 136.0000, 'ºC'),
	(147439, 119, '2014-01-15 00:31:45.000000', 'temperatura', 497.0000, 'ºC'),
	(147440, 119, '2014-01-15 00:31:46.000000', 'temperatura', 879.0000, 'ºC'),
	(147441, 119, '2014-01-15 00:31:47.000000', 'temperatura', 504.0000, 'ºC'),
	(147442, 119, '2014-01-15 00:31:48.000000', 'temperatura', 1083.0000, 'ºC'),
	(147443, 119, '2014-01-15 00:31:49.000000', 'temperatura', 303.0000, 'ºC'),
	(147444, 119, '2014-01-15 00:31:50.000000', 'temperatura', 666.0000, 'ºC'),
	(147445, 119, '2014-01-15 00:31:51.000000', 'temperatura', 23.0000, 'ºC'),
	(147446, 119, '2014-01-15 00:31:52.000000', 'temperatura', 516.0000, 'ºC'),
	(147447, 119, '2014-01-15 00:31:53.000000', 'temperatura', 113.0000, 'ºC'),
	(147448, 119, '2014-01-15 00:31:54.000000', 'temperatura', 216.0000, 'ºC'),
	(147449, 119, '2014-01-15 00:31:55.000000', 'temperatura', 742.0000, 'ºC'),
	(147450, 119, '2014-01-15 00:31:56.000000', 'temperatura', 663.0000, 'ºC'),
	(147451, 119, '2014-01-15 00:31:57.000000', 'temperatura', 1090.0000, 'ºC'),
	(147452, 119, '2014-01-15 00:31:58.000000', 'temperatura', 1060.0000, 'ºC'),
	(147453, 119, '2014-01-15 00:31:59.000000', 'temperatura', 831.0000, 'ºC'),
	(147454, 119, '2014-01-15 00:32:00.000000', 'temperatura', 976.0000, 'ºC'),
	(147455, 119, '2014-01-15 00:32:01.000000', 'temperatura', 1189.0000, 'ºC'),
	(147456, 119, '2014-01-15 00:32:02.000000', 'temperatura', 616.0000, 'ºC'),
	(147457, 119, '2014-01-15 00:32:03.000000', 'temperatura', 714.0000, 'ºC'),
	(147458, 119, '2014-01-15 00:32:04.000000', 'temperatura', 520.0000, 'ºC'),
	(147459, 119, '2014-01-15 00:32:05.000000', 'temperatura', 461.0000, 'ºC'),
	(147460, 119, '2014-01-15 00:32:06.000000', 'temperatura', 745.0000, 'ºC'),
	(147461, 119, '2014-01-15 00:32:07.000000', 'temperatura', 1140.0000, 'ºC'),
	(147462, 119, '2014-01-15 00:32:08.000000', 'temperatura', 1069.0000, 'ºC'),
	(147463, 119, '2014-01-15 00:32:09.000000', 'temperatura', 724.0000, 'ºC'),
	(147464, 119, '2014-01-15 00:32:10.000000', 'temperatura', 412.0000, 'ºC'),
	(147465, 119, '2014-01-15 00:32:11.000000', 'temperatura', 1088.0000, 'ºC'),
	(147466, 119, '2014-01-15 00:32:12.000000', 'temperatura', 607.0000, 'ºC'),
	(147467, 119, '2014-01-15 00:32:13.000000', 'temperatura', 970.0000, 'ºC'),
	(147468, 119, '2014-01-15 00:32:14.000000', 'temperatura', 632.0000, 'ºC'),
	(147469, 119, '2014-01-15 00:32:15.000000', 'temperatura', 247.0000, 'ºC'),
	(147470, 119, '2014-01-15 00:32:16.000000', 'temperatura', 542.0000, 'ºC'),
	(147471, 119, '2014-01-15 00:32:17.000000', 'temperatura', 770.0000, 'ºC'),
	(147472, 119, '2014-01-15 00:32:18.000000', 'temperatura', 1022.0000, 'ºC'),
	(147473, 119, '2014-01-15 00:32:19.000000', 'temperatura', 402.0000, 'ºC'),
	(147474, 119, '2014-01-15 00:32:20.000000', 'temperatura', 144.0000, 'ºC'),
	(147475, 119, '2014-01-15 00:32:21.000000', 'temperatura', 714.0000, 'ºC'),
	(147476, 119, '2014-01-15 00:32:22.000000', 'temperatura', 738.0000, 'ºC'),
	(147477, 119, '2014-01-15 00:32:23.000000', 'temperatura', 350.0000, 'ºC'),
	(147478, 119, '2014-01-15 00:32:24.000000', 'temperatura', 735.0000, 'ºC'),
	(147479, 119, '2014-01-15 00:32:25.000000', 'temperatura', 227.0000, 'ºC'),
	(147480, 119, '2014-01-15 00:32:26.000000', 'temperatura', 131.0000, 'ºC'),
	(147481, 119, '2014-01-15 00:32:27.000000', 'temperatura', 1173.0000, 'ºC'),
	(147482, 119, '2014-01-15 00:32:28.000000', 'temperatura', 672.0000, 'ºC'),
	(147483, 119, '2014-01-15 00:32:29.000000', 'temperatura', 1044.0000, 'ºC'),
	(147484, 119, '2014-01-15 00:32:30.000000', 'temperatura', 802.0000, 'ºC'),
	(147485, 119, '2014-01-15 00:32:31.000000', 'temperatura', 879.0000, 'ºC'),
	(147486, 119, '2014-01-15 00:32:32.000000', 'temperatura', 790.0000, 'ºC'),
	(147487, 119, '2014-01-15 00:32:33.000000', 'temperatura', 115.0000, 'ºC'),
	(147488, 119, '2014-01-15 00:32:34.000000', 'temperatura', 603.0000, 'ºC'),
	(147489, 119, '2014-01-15 00:32:35.000000', 'temperatura', 273.0000, 'ºC'),
	(147490, 119, '2014-01-15 00:32:36.000000', 'temperatura', 753.0000, 'ºC'),
	(147491, 119, '2014-01-15 00:32:37.000000', 'temperatura', 550.0000, 'ºC'),
	(147492, 119, '2014-01-15 00:32:38.000000', 'temperatura', 489.0000, 'ºC'),
	(147493, 119, '2014-01-15 00:32:39.000000', 'temperatura', 796.0000, 'ºC'),
	(147494, 119, '2014-01-15 00:32:40.000000', 'temperatura', 115.0000, 'ºC'),
	(147495, 119, '2014-01-15 00:32:41.000000', 'temperatura', 588.0000, 'ºC'),
	(147496, 119, '2014-01-15 00:32:42.000000', 'temperatura', 197.0000, 'ºC'),
	(147497, 119, '2014-01-15 00:32:43.000000', 'temperatura', 418.0000, 'ºC'),
	(147498, 119, '2014-01-15 00:32:44.000000', 'temperatura', 300.0000, 'ºC'),
	(147499, 119, '2014-01-15 00:32:45.000000', 'temperatura', 246.0000, 'ºC'),
	(147500, 119, '2014-01-15 00:32:46.000000', 'temperatura', 331.0000, 'ºC'),
	(147501, 119, '2014-01-15 00:32:47.000000', 'temperatura', 920.0000, 'ºC'),
	(147502, 119, '2014-01-15 00:32:48.000000', 'temperatura', 5.0000, 'ºC'),
	(147503, 119, '2014-01-15 00:32:49.000000', 'temperatura', 865.0000, 'ºC'),
	(147504, 119, '2014-01-15 00:32:50.000000', 'temperatura', 711.0000, 'ºC'),
	(147505, 119, '2014-01-15 00:32:51.000000', 'temperatura', 961.0000, 'ºC'),
	(147506, 119, '2014-01-15 00:32:52.000000', 'temperatura', 271.0000, 'ºC'),
	(147507, 119, '2014-01-15 00:32:53.000000', 'temperatura', 875.0000, 'ºC'),
	(147508, 119, '2014-01-15 00:32:54.000000', 'temperatura', 1160.0000, 'ºC'),
	(147509, 119, '2014-01-15 00:32:55.000000', 'temperatura', 776.0000, 'ºC'),
	(147510, 119, '2014-01-15 00:32:56.000000', 'temperatura', 402.0000, 'ºC'),
	(147511, 119, '2014-01-15 00:32:57.000000', 'temperatura', 882.0000, 'ºC'),
	(147512, 119, '2014-01-15 00:32:58.000000', 'temperatura', 804.0000, 'ºC'),
	(147513, 119, '2014-01-15 00:32:59.000000', 'temperatura', 176.0000, 'ºC'),
	(147514, 119, '2014-01-15 00:33:00.000000', 'temperatura', 868.0000, 'ºC'),
	(147515, 119, '2014-01-15 00:33:01.000000', 'temperatura', 212.0000, 'ºC'),
	(147516, 119, '2014-01-15 00:33:02.000000', 'temperatura', 855.0000, 'ºC'),
	(147517, 119, '2014-01-15 00:33:03.000000', 'temperatura', 39.0000, 'ºC'),
	(147518, 119, '2014-01-15 00:33:04.000000', 'temperatura', 32.0000, 'ºC'),
	(147519, 119, '2014-01-15 00:33:05.000000', 'temperatura', 44.0000, 'ºC'),
	(147520, 119, '2014-01-15 00:33:06.000000', 'temperatura', 125.0000, 'ºC'),
	(147521, 119, '2014-01-15 00:33:07.000000', 'temperatura', 493.0000, 'ºC'),
	(147522, 119, '2014-01-15 00:33:08.000000', 'temperatura', 889.0000, 'ºC'),
	(147523, 119, '2014-01-15 00:33:09.000000', 'temperatura', 566.0000, 'ºC'),
	(147524, 119, '2014-01-15 00:33:10.000000', 'temperatura', 165.0000, 'ºC'),
	(147525, 119, '2014-01-15 00:33:11.000000', 'temperatura', 326.0000, 'ºC'),
	(147526, 119, '2014-01-15 00:33:12.000000', 'temperatura', 1135.0000, 'ºC'),
	(147527, 119, '2014-01-15 00:33:13.000000', 'temperatura', 1098.0000, 'ºC'),
	(147528, 119, '2014-01-15 00:33:14.000000', 'temperatura', 887.0000, 'ºC'),
	(147529, 119, '2014-01-15 00:33:15.000000', 'temperatura', 1142.0000, 'ºC'),
	(147530, 119, '2014-01-15 00:33:16.000000', 'temperatura', 650.0000, 'ºC'),
	(147531, 119, '2014-01-15 00:33:17.000000', 'temperatura', 1022.0000, 'ºC'),
	(147532, 119, '2014-01-15 00:33:18.000000', 'temperatura', 762.0000, 'ºC'),
	(147533, 119, '2014-01-15 00:33:19.000000', 'temperatura', 745.0000, 'ºC'),
	(147534, 119, '2014-01-15 00:33:20.000000', 'temperatura', 240.0000, 'ºC'),
	(147535, 119, '2014-01-15 00:33:21.000000', 'temperatura', 167.0000, 'ºC'),
	(147536, 119, '2014-01-15 00:33:22.000000', 'temperatura', 113.0000, 'ºC'),
	(147537, 119, '2014-01-15 00:33:23.000000', 'temperatura', 64.0000, 'ºC'),
	(147538, 119, '2014-01-15 00:33:24.000000', 'temperatura', 1182.0000, 'ºC'),
	(147539, 119, '2014-01-15 00:33:25.000000', 'temperatura', 918.0000, 'ºC'),
	(147540, 119, '2014-01-15 00:33:26.000000', 'temperatura', 1044.0000, 'ºC'),
	(147541, 119, '2014-01-15 00:33:27.000000', 'temperatura', 67.0000, 'ºC'),
	(147542, 119, '2014-01-15 00:33:28.000000', 'temperatura', 803.0000, 'ºC'),
	(147543, 119, '2014-01-15 00:33:29.000000', 'temperatura', 217.0000, 'ºC'),
	(147544, 119, '2014-01-15 00:33:30.000000', 'temperatura', 1074.0000, 'ºC'),
	(147545, 119, '2014-01-15 00:33:31.000000', 'temperatura', 1122.0000, 'ºC'),
	(147546, 119, '2014-01-15 00:33:32.000000', 'temperatura', 1185.0000, 'ºC'),
	(147547, 119, '2014-01-15 00:33:33.000000', 'temperatura', 162.0000, 'ºC'),
	(147548, 119, '2014-01-15 00:33:34.000000', 'temperatura', 856.0000, 'ºC'),
	(147549, 119, '2014-01-15 00:33:35.000000', 'temperatura', 193.0000, 'ºC'),
	(147550, 119, '2014-01-15 00:33:36.000000', 'temperatura', 800.0000, 'ºC'),
	(147551, 119, '2014-01-15 00:33:37.000000', 'temperatura', 1018.0000, 'ºC'),
	(147552, 119, '2014-01-15 00:33:38.000000', 'temperatura', 293.0000, 'ºC'),
	(147553, 119, '2014-01-15 00:33:39.000000', 'temperatura', 812.0000, 'ºC'),
	(147554, 119, '2014-01-15 00:33:40.000000', 'temperatura', 781.0000, 'ºC'),
	(147555, 119, '2014-01-15 00:33:41.000000', 'temperatura', 270.0000, 'ºC'),
	(147556, 119, '2014-01-15 00:33:42.000000', 'temperatura', 209.0000, 'ºC'),
	(147557, 119, '2014-01-15 00:33:43.000000', 'temperatura', 232.0000, 'ºC'),
	(147558, 119, '2014-01-15 00:33:44.000000', 'temperatura', 536.0000, 'ºC'),
	(147559, 119, '2014-01-15 00:33:45.000000', 'temperatura', 785.0000, 'ºC'),
	(147560, 119, '2014-01-15 00:33:46.000000', 'temperatura', 1117.0000, 'ºC'),
	(147561, 119, '2014-01-15 00:33:47.000000', 'temperatura', 829.0000, 'ºC'),
	(147562, 119, '2014-01-15 00:33:48.000000', 'temperatura', 796.0000, 'ºC'),
	(147563, 119, '2014-01-15 00:33:49.000000', 'temperatura', 294.0000, 'ºC'),
	(147564, 119, '2014-01-15 00:33:50.000000', 'temperatura', 282.0000, 'ºC'),
	(147565, 119, '2014-01-15 00:33:51.000000', 'temperatura', 529.0000, 'ºC'),
	(147566, 119, '2014-01-15 00:33:52.000000', 'temperatura', 601.0000, 'ºC'),
	(147567, 119, '2014-01-15 00:33:53.000000', 'temperatura', 217.0000, 'ºC'),
	(147568, 119, '2014-01-15 00:33:54.000000', 'temperatura', 482.0000, 'ºC'),
	(147569, 119, '2014-01-15 00:33:55.000000', 'temperatura', 560.0000, 'ºC'),
	(147570, 119, '2014-01-15 00:33:56.000000', 'temperatura', 155.0000, 'ºC'),
	(147571, 119, '2014-01-15 00:33:57.000000', 'temperatura', 295.0000, 'ºC'),
	(147572, 119, '2014-01-15 00:33:58.000000', 'temperatura', 1010.0000, 'ºC'),
	(147573, 119, '2014-01-15 00:33:59.000000', 'temperatura', 565.0000, 'ºC'),
	(147574, 119, '2014-01-15 00:34:00.000000', 'temperatura', 994.0000, 'ºC'),
	(147575, 119, '2014-01-15 00:34:01.000000', 'temperatura', 877.0000, 'ºC'),
	(147576, 119, '2014-01-15 00:34:02.000000', 'temperatura', 204.0000, 'ºC'),
	(147577, 119, '2014-01-15 00:34:03.000000', 'temperatura', 789.0000, 'ºC'),
	(147578, 119, '2014-01-15 00:34:04.000000', 'temperatura', 935.0000, 'ºC'),
	(147579, 119, '2014-01-15 00:34:05.000000', 'temperatura', 1106.0000, 'ºC'),
	(147580, 119, '2014-01-15 00:34:06.000000', 'temperatura', 328.0000, 'ºC'),
	(147581, 119, '2014-01-15 00:34:07.000000', 'temperatura', 720.0000, 'ºC'),
	(147582, 119, '2014-01-15 00:34:08.000000', 'temperatura', 217.0000, 'ºC'),
	(147583, 119, '2014-01-15 00:34:09.000000', 'temperatura', 126.0000, 'ºC'),
	(147584, 119, '2014-01-15 00:34:10.000000', 'temperatura', 1178.0000, 'ºC'),
	(147585, 119, '2014-01-15 00:34:11.000000', 'temperatura', 715.0000, 'ºC'),
	(147586, 119, '2014-01-15 00:34:12.000000', 'temperatura', 38.0000, 'ºC'),
	(147587, 119, '2014-01-15 00:34:13.000000', 'temperatura', 449.0000, 'ºC'),
	(147588, 119, '2014-01-15 00:34:14.000000', 'temperatura', 932.0000, 'ºC'),
	(147589, 119, '2014-01-15 00:34:15.000000', 'temperatura', 911.0000, 'ºC'),
	(147590, 119, '2014-01-15 00:34:16.000000', 'temperatura', 560.0000, 'ºC'),
	(147591, 119, '2014-01-15 00:34:17.000000', 'temperatura', 67.0000, 'ºC'),
	(147592, 119, '2014-01-15 00:34:18.000000', 'temperatura', 1054.0000, 'ºC'),
	(147593, 119, '2014-01-15 00:34:19.000000', 'temperatura', 272.0000, 'ºC'),
	(147594, 119, '2014-01-15 00:34:20.000000', 'temperatura', 597.0000, 'ºC'),
	(147595, 119, '2014-01-15 00:34:21.000000', 'temperatura', 968.0000, 'ºC'),
	(147596, 119, '2014-01-15 00:34:22.000000', 'temperatura', 652.0000, 'ºC'),
	(147597, 119, '2014-01-15 00:34:23.000000', 'temperatura', 358.0000, 'ºC'),
	(147598, 119, '2014-01-15 00:34:24.000000', 'temperatura', 1031.0000, 'ºC'),
	(147599, 119, '2014-01-15 00:34:25.000000', 'temperatura', 482.0000, 'ºC'),
	(147600, 119, '2014-01-15 00:34:26.000000', 'temperatura', 518.0000, 'ºC'),
	(147601, 119, '2014-01-15 00:34:27.000000', 'temperatura', 1143.0000, 'ºC'),
	(147602, 119, '2014-01-15 00:34:28.000000', 'temperatura', 564.0000, 'ºC'),
	(147603, 119, '2014-01-15 00:34:29.000000', 'temperatura', 588.0000, 'ºC'),
	(147604, 119, '2014-01-15 00:34:30.000000', 'temperatura', 52.0000, 'ºC'),
	(147605, 119, '2014-01-15 00:34:31.000000', 'temperatura', 895.0000, 'ºC'),
	(147606, 119, '2014-01-15 00:34:32.000000', 'temperatura', 718.0000, 'ºC'),
	(147607, 119, '2014-01-15 00:34:33.000000', 'temperatura', 908.0000, 'ºC'),
	(147608, 119, '2014-01-15 00:34:34.000000', 'temperatura', 1186.0000, 'ºC'),
	(147609, 119, '2014-01-15 00:34:35.000000', 'temperatura', 806.0000, 'ºC'),
	(147610, 119, '2014-01-15 00:34:36.000000', 'temperatura', 471.0000, 'ºC'),
	(147611, 119, '2014-01-15 00:34:37.000000', 'temperatura', 1137.0000, 'ºC'),
	(147612, 119, '2014-01-15 00:34:38.000000', 'temperatura', 674.0000, 'ºC'),
	(147613, 119, '2014-01-15 00:34:39.000000', 'temperatura', 1158.0000, 'ºC'),
	(147614, 119, '2014-01-15 00:34:40.000000', 'temperatura', 169.0000, 'ºC'),
	(147615, 119, '2014-01-15 00:34:41.000000', 'temperatura', 973.0000, 'ºC'),
	(147616, 119, '2014-01-15 00:34:42.000000', 'temperatura', 758.0000, 'ºC'),
	(147617, 119, '2014-01-15 00:34:43.000000', 'temperatura', 871.0000, 'ºC'),
	(147618, 119, '2014-01-15 00:34:44.000000', 'temperatura', 883.0000, 'ºC'),
	(147619, 119, '2014-01-15 00:34:45.000000', 'temperatura', 601.0000, 'ºC'),
	(147620, 119, '2014-01-15 00:34:46.000000', 'temperatura', 358.0000, 'ºC'),
	(147621, 119, '2014-01-15 00:34:47.000000', 'temperatura', 1185.0000, 'ºC'),
	(147622, 119, '2014-01-15 00:34:48.000000', 'temperatura', 53.0000, 'ºC'),
	(147623, 119, '2014-01-15 00:34:49.000000', 'temperatura', 309.0000, 'ºC'),
	(147624, 119, '2014-01-15 00:34:50.000000', 'temperatura', 187.0000, 'ºC'),
	(147625, 119, '2014-01-15 00:34:51.000000', 'temperatura', 8.0000, 'ºC'),
	(147626, 119, '2014-01-15 00:34:52.000000', 'temperatura', 681.0000, 'ºC'),
	(147627, 119, '2014-01-15 00:34:53.000000', 'temperatura', 982.0000, 'ºC'),
	(147628, 119, '2014-01-15 00:34:54.000000', 'temperatura', 466.0000, 'ºC'),
	(147629, 119, '2014-01-15 00:34:55.000000', 'temperatura', 587.0000, 'ºC'),
	(147630, 119, '2014-01-15 00:34:56.000000', 'temperatura', 336.0000, 'ºC'),
	(147631, 119, '2014-01-15 00:34:57.000000', 'temperatura', 1120.0000, 'ºC'),
	(147632, 119, '2014-01-15 00:34:58.000000', 'temperatura', 990.0000, 'ºC'),
	(147633, 119, '2014-01-15 00:34:59.000000', 'temperatura', 392.0000, 'ºC'),
	(147634, 119, '2014-01-15 00:35:00.000000', 'temperatura', 192.0000, 'ºC'),
	(147635, 119, '2014-01-15 00:35:01.000000', 'temperatura', 982.0000, 'ºC'),
	(147636, 119, '2014-01-15 00:35:02.000000', 'temperatura', 734.0000, 'ºC'),
	(147637, 119, '2014-01-15 00:35:03.000000', 'temperatura', 726.0000, 'ºC'),
	(147638, 119, '2014-01-15 00:35:04.000000', 'temperatura', 226.0000, 'ºC'),
	(147639, 119, '2014-01-15 00:35:05.000000', 'temperatura', 154.0000, 'ºC'),
	(147640, 119, '2014-01-15 00:35:06.000000', 'temperatura', 94.0000, 'ºC'),
	(147641, 119, '2014-01-15 00:35:07.000000', 'temperatura', 6.0000, 'ºC'),
	(147642, 119, '2014-01-15 00:35:08.000000', 'temperatura', 950.0000, 'ºC'),
	(147643, 119, '2014-01-15 00:35:09.000000', 'temperatura', 1131.0000, 'ºC'),
	(147644, 119, '2014-01-15 00:35:10.000000', 'temperatura', 405.0000, 'ºC'),
	(147645, 119, '2014-01-15 00:35:11.000000', 'temperatura', 1032.0000, 'ºC'),
	(147646, 119, '2014-01-15 00:35:12.000000', 'temperatura', 345.0000, 'ºC'),
	(147647, 119, '2014-01-15 00:35:13.000000', 'temperatura', 1030.0000, 'ºC'),
	(147648, 119, '2014-01-15 00:35:14.000000', 'temperatura', 518.0000, 'ºC'),
	(147649, 119, '2014-01-15 00:35:15.000000', 'temperatura', 698.0000, 'ºC'),
	(147650, 119, '2014-01-15 00:35:16.000000', 'temperatura', 737.0000, 'ºC'),
	(147651, 119, '2014-01-15 00:35:17.000000', 'temperatura', 390.0000, 'ºC'),
	(147652, 119, '2014-01-15 00:35:18.000000', 'temperatura', 941.0000, 'ºC'),
	(147653, 119, '2014-01-15 00:35:19.000000', 'temperatura', 1134.0000, 'ºC'),
	(147654, 119, '2014-01-15 00:35:20.000000', 'temperatura', 448.0000, 'ºC'),
	(147655, 119, '2014-01-15 00:35:21.000000', 'temperatura', 40.0000, 'ºC'),
	(147656, 119, '2014-01-15 00:35:22.000000', 'temperatura', 57.0000, 'ºC'),
	(147657, 119, '2014-01-15 00:35:23.000000', 'temperatura', 165.0000, 'ºC'),
	(147658, 119, '2014-01-15 00:35:24.000000', 'temperatura', 656.0000, 'ºC'),
	(147659, 119, '2014-01-15 00:35:25.000000', 'temperatura', 382.0000, 'ºC'),
	(147660, 119, '2014-01-15 00:35:26.000000', 'temperatura', 1145.0000, 'ºC'),
	(147661, 119, '2014-01-15 00:35:27.000000', 'temperatura', 981.0000, 'ºC'),
	(147662, 119, '2014-01-15 00:35:28.000000', 'temperatura', 269.0000, 'ºC'),
	(147663, 119, '2014-01-15 00:35:29.000000', 'temperatura', 802.0000, 'ºC'),
	(147664, 119, '2014-01-15 00:35:30.000000', 'temperatura', 803.0000, 'ºC'),
	(147665, 119, '2014-01-15 00:35:31.000000', 'temperatura', 411.0000, 'ºC'),
	(147666, 119, '2014-01-15 00:35:32.000000', 'temperatura', 845.0000, 'ºC'),
	(147667, 119, '2014-01-15 00:35:33.000000', 'temperatura', 591.0000, 'ºC'),
	(147668, 119, '2014-01-15 00:35:34.000000', 'temperatura', 423.0000, 'ºC'),
	(147669, 119, '2014-01-15 00:35:35.000000', 'temperatura', 341.0000, 'ºC'),
	(147670, 119, '2014-01-15 00:35:36.000000', 'temperatura', 436.0000, 'ºC'),
	(147671, 119, '2014-01-15 00:35:37.000000', 'temperatura', 1157.0000, 'ºC'),
	(147672, 119, '2014-01-15 00:35:38.000000', 'temperatura', 880.0000, 'ºC'),
	(147673, 119, '2014-01-15 00:35:39.000000', 'temperatura', 930.0000, 'ºC'),
	(147674, 119, '2014-01-15 00:35:40.000000', 'temperatura', 808.0000, 'ºC'),
	(147675, 119, '2014-01-15 00:35:41.000000', 'temperatura', 49.0000, 'ºC'),
	(147676, 119, '2014-01-15 00:35:42.000000', 'temperatura', 225.0000, 'ºC'),
	(147677, 119, '2014-01-15 00:35:43.000000', 'temperatura', 977.0000, 'ºC'),
	(147678, 119, '2014-01-15 00:35:44.000000', 'temperatura', 609.0000, 'ºC'),
	(147679, 119, '2014-01-15 00:35:45.000000', 'temperatura', 117.0000, 'ºC'),
	(147680, 119, '2014-01-15 00:35:46.000000', 'temperatura', 1157.0000, 'ºC'),
	(147681, 119, '2014-01-15 00:35:47.000000', 'temperatura', 635.0000, 'ºC'),
	(147682, 119, '2014-01-15 00:35:48.000000', 'temperatura', 903.0000, 'ºC'),
	(147683, 119, '2014-01-15 00:35:49.000000', 'temperatura', 213.0000, 'ºC'),
	(147684, 119, '2014-01-15 00:35:50.000000', 'temperatura', 756.0000, 'ºC'),
	(147685, 119, '2014-01-15 00:35:51.000000', 'temperatura', 741.0000, 'ºC'),
	(147686, 119, '2014-01-15 00:35:52.000000', 'temperatura', 237.0000, 'ºC'),
	(147687, 119, '2014-01-15 00:35:53.000000', 'temperatura', 162.0000, 'ºC'),
	(147688, 119, '2014-01-15 00:35:54.000000', 'temperatura', 98.0000, 'ºC'),
	(147689, 119, '2014-01-15 00:35:55.000000', 'temperatura', 6.0000, 'ºC'),
	(147690, 119, '2014-01-15 00:35:56.000000', 'temperatura', 937.0000, 'ºC'),
	(147691, 119, '2014-01-15 00:35:57.000000', 'temperatura', 1067.0000, 'ºC'),
	(147692, 119, '2014-01-15 00:35:58.000000', 'temperatura', 126.0000, 'ºC'),
	(147693, 119, '2014-01-15 00:35:59.000000', 'temperatura', 1030.0000, 'ºC'),
	(147694, 119, '2014-01-15 00:36:00.000000', 'temperatura', 1169.0000, 'ºC'),
	(147695, 119, '2014-01-15 00:36:01.000000', 'temperatura', 359.0000, 'ºC'),
	(147696, 119, '2014-01-15 00:36:02.000000', 'temperatura', 686.0000, 'ºC'),
	(147697, 119, '2014-01-15 00:36:03.000000', 'temperatura', 1155.0000, 'ºC'),
	(147698, 119, '2014-01-15 00:36:04.000000', 'temperatura', 116.0000, 'ºC'),
	(147699, 119, '2014-01-15 00:36:05.000000', 'temperatura', 718.0000, 'ºC'),
	(147700, 119, '2014-01-15 00:36:06.000000', 'temperatura', 841.0000, 'ºC'),
	(147701, 119, '2014-01-15 00:36:07.000000', 'temperatura', 851.0000, 'ºC'),
	(147702, 119, '2014-01-15 00:36:08.000000', 'temperatura', 532.0000, 'ºC'),
	(147703, 119, '2014-01-15 00:36:09.000000', 'temperatura', 109.0000, 'ºC'),
	(147704, 119, '2014-01-15 00:36:10.000000', 'temperatura', 148.0000, 'ºC'),
	(147705, 119, '2014-01-15 00:36:11.000000', 'temperatura', 412.0000, 'ºC'),
	(147706, 119, '2014-01-15 00:36:12.000000', 'temperatura', 419.0000, 'ºC'),
	(147707, 119, '2014-01-15 00:36:13.000000', 'temperatura', 858.0000, 'ºC'),
	(147708, 119, '2014-01-15 00:36:14.000000', 'temperatura', 634.0000, 'ºC'),
	(147709, 119, '2014-01-15 00:36:15.000000', 'temperatura', 596.0000, 'ºC'),
	(147710, 119, '2014-01-15 00:36:16.000000', 'temperatura', 1079.0000, 'ºC'),
	(147711, 119, '2014-01-15 00:36:17.000000', 'temperatura', 8.0000, 'ºC'),
	(147712, 119, '2014-01-15 00:36:18.000000', 'temperatura', 402.0000, 'ºC'),
	(147713, 119, '2014-01-15 00:36:19.000000', 'temperatura', 786.0000, 'ºC'),
	(147714, 119, '2014-01-15 00:36:20.000000', 'temperatura', 325.0000, 'ºC'),
	(147715, 119, '2014-01-15 00:36:21.000000', 'temperatura', 470.0000, 'ºC'),
	(147716, 119, '2014-01-15 00:36:22.000000', 'temperatura', 173.0000, 'ºC'),
	(147717, 119, '2014-01-15 00:36:23.000000', 'temperatura', 657.0000, 'ºC'),
	(147718, 119, '2014-01-15 00:36:24.000000', 'temperatura', 365.0000, 'ºC'),
	(147719, 119, '2014-01-15 00:36:25.000000', 'temperatura', 1056.0000, 'ºC'),
	(147720, 119, '2014-01-15 00:36:26.000000', 'temperatura', 587.0000, 'ºC'),
	(147721, 119, '2014-01-15 00:36:27.000000', 'temperatura', 964.0000, 'ºC'),
	(147722, 119, '2014-01-15 00:36:28.000000', 'temperatura', 662.0000, 'ºC'),
	(147723, 119, '2014-01-15 00:36:29.000000', 'temperatura', 416.0000, 'ºC'),
	(147724, 119, '2014-01-15 00:36:30.000000', 'temperatura', 97.0000, 'ºC'),
	(147725, 119, '2014-01-15 00:36:31.000000', 'temperatura', 437.0000, 'ºC'),
	(147726, 119, '2014-01-15 00:36:32.000000', 'temperatura', 693.0000, 'ºC'),
	(147727, 119, '2014-01-15 00:36:33.000000', 'temperatura', 954.0000, 'ºC'),
	(147728, 119, '2014-01-15 00:36:34.000000', 'temperatura', 292.0000, 'ºC'),
	(147729, 119, '2014-01-15 00:36:35.000000', 'temperatura', 998.0000, 'ºC'),
	(147730, 119, '2014-01-15 00:36:36.000000', 'temperatura', 514.0000, 'ºC'),
	(147731, 119, '2014-01-15 00:36:37.000000', 'temperatura', 778.0000, 'ºC'),
	(147732, 119, '2014-01-15 00:36:38.000000', 'temperatura', 1147.0000, 'ºC'),
	(147733, 119, '2014-01-15 00:36:39.000000', 'temperatura', 1004.0000, 'ºC'),
	(147734, 119, '2014-01-15 00:36:40.000000', 'temperatura', 379.0000, 'ºC'),
	(147735, 119, '2014-01-15 00:36:41.000000', 'temperatura', 85.0000, 'ºC'),
	(147736, 119, '2014-01-15 00:36:42.000000', 'temperatura', 485.0000, 'ºC'),
	(147737, 119, '2014-01-15 00:36:43.000000', 'temperatura', 973.0000, 'ºC'),
	(147738, 119, '2014-01-15 00:36:44.000000', 'temperatura', 1011.0000, 'ºC'),
	(147739, 119, '2014-01-15 00:36:45.000000', 'temperatura', 936.0000, 'ºC'),
	(147740, 119, '2014-01-15 00:36:46.000000', 'temperatura', 446.0000, 'ºC'),
	(147741, 119, '2014-01-15 00:36:47.000000', 'temperatura', 623.0000, 'ºC'),
	(147742, 119, '2014-01-15 00:36:48.000000', 'temperatura', 576.0000, 'ºC'),
	(147743, 119, '2014-01-15 00:36:49.000000', 'temperatura', 1014.0000, 'ºC'),
	(147744, 119, '2014-01-15 00:36:50.000000', 'temperatura', 941.0000, 'ºC'),
	(147745, 119, '2014-01-15 00:36:51.000000', 'temperatura', 465.0000, 'ºC'),
	(147746, 119, '2014-01-15 00:36:52.000000', 'temperatura', 701.0000, 'ºC'),
	(147747, 119, '2014-01-15 00:36:53.000000', 'temperatura', 911.0000, 'ºC'),
	(147748, 119, '2014-01-15 00:36:54.000000', 'temperatura', 55.0000, 'ºC'),
	(147749, 119, '2014-01-15 00:36:55.000000', 'temperatura', 1139.0000, 'ºC'),
	(147750, 119, '2014-01-15 00:36:56.000000', 'temperatura', 732.0000, 'ºC'),
	(147751, 119, '2014-01-15 00:36:57.000000', 'temperatura', 245.0000, 'ºC'),
	(147752, 119, '2014-01-15 00:36:58.000000', 'temperatura', 228.0000, 'ºC'),
	(147753, 119, '2014-01-15 00:36:59.000000', 'temperatura', 404.0000, 'ºC'),
	(147754, 119, '2014-01-15 00:37:00.000000', 'temperatura', 136.0000, 'ºC'),
	(147755, 119, '2014-01-15 00:37:01.000000', 'temperatura', 671.0000, 'ºC'),
	(147756, 119, '2014-01-15 00:37:02.000000', 'temperatura', 548.0000, 'ºC'),
	(147757, 119, '2014-01-15 00:37:03.000000', 'temperatura', 725.0000, 'ºC'),
	(147758, 119, '2014-01-15 00:37:04.000000', 'temperatura', 782.0000, 'ºC'),
	(147759, 119, '2014-01-15 00:37:05.000000', 'temperatura', 536.0000, 'ºC'),
	(147760, 119, '2014-01-15 00:37:06.000000', 'temperatura', 336.0000, 'ºC'),
	(147761, 119, '2014-01-15 00:37:07.000000', 'temperatura', 72.0000, 'ºC'),
	(147762, 119, '2014-01-15 00:37:08.000000', 'temperatura', 551.0000, 'ºC'),
	(147763, 119, '2014-01-15 00:37:09.000000', 'temperatura', 140.0000, 'ºC'),
	(147764, 119, '2014-01-15 00:37:10.000000', 'temperatura', 248.0000, 'ºC'),
	(147765, 119, '2014-01-15 00:37:11.000000', 'temperatura', 821.0000, 'ºC'),
	(147766, 119, '2014-01-15 00:37:12.000000', 'temperatura', 962.0000, 'ºC'),
	(147767, 119, '2014-01-15 00:37:13.000000', 'temperatura', 1147.0000, 'ºC'),
	(147768, 119, '2014-01-15 00:37:14.000000', 'temperatura', 449.0000, 'ºC'),
	(147769, 119, '2014-01-15 00:37:15.000000', 'temperatura', 4.0000, 'ºC'),
	(147770, 119, '2014-01-15 00:37:16.000000', 'temperatura', 1073.0000, 'ºC'),
	(147771, 119, '2014-01-15 00:37:17.000000', 'temperatura', 554.0000, 'ºC'),
	(147772, 119, '2014-01-15 00:37:18.000000', 'temperatura', 751.0000, 'ºC'),
	(147773, 119, '2014-01-15 00:37:19.000000', 'temperatura', 894.0000, 'ºC'),
	(147774, 119, '2014-01-15 00:37:20.000000', 'temperatura', 1019.0000, 'ºC'),
	(147775, 119, '2014-01-15 00:37:21.000000', 'temperatura', 14.0000, 'ºC'),
	(147776, 119, '2014-01-15 00:37:22.000000', 'temperatura', 611.0000, 'ºC'),
	(147777, 119, '2014-01-15 00:37:23.000000', 'temperatura', 614.0000, 'ºC'),
	(147778, 119, '2014-01-15 00:37:24.000000', 'temperatura', 38.0000, 'ºC'),
	(147779, 119, '2014-01-15 00:37:25.000000', 'temperatura', 747.0000, 'ºC'),
	(147780, 119, '2014-01-15 00:37:26.000000', 'temperatura', 22.0000, 'ºC'),
	(147781, 119, '2014-01-15 00:37:27.000000', 'temperatura', 271.0000, 'ºC'),
	(147782, 119, '2014-01-15 00:37:28.000000', 'temperatura', 90.0000, 'ºC'),
	(147783, 119, '2014-01-15 00:37:29.000000', 'temperatura', 836.0000, 'ºC'),
	(147784, 119, '2014-01-15 00:37:30.000000', 'temperatura', 311.0000, 'ºC'),
	(147785, 119, '2014-01-15 00:37:31.000000', 'temperatura', 247.0000, 'ºC'),
	(147786, 119, '2014-01-15 00:37:32.000000', 'temperatura', 304.0000, 'ºC'),
	(147787, 119, '2014-01-15 00:37:33.000000', 'temperatura', 779.0000, 'ºC'),
	(147788, 119, '2014-01-15 00:37:34.000000', 'temperatura', 582.0000, 'ºC'),
	(147789, 119, '2014-01-15 00:37:35.000000', 'temperatura', 576.0000, 'ºC'),
	(147790, 119, '2014-01-15 00:37:36.000000', 'temperatura', 1133.0000, 'ºC'),
	(147791, 119, '2014-01-15 00:37:37.000000', 'temperatura', 338.0000, 'ºC'),
	(147792, 119, '2014-01-15 00:37:38.000000', 'temperatura', 690.0000, 'ºC'),
	(147793, 119, '2014-01-15 00:37:39.000000', 'temperatura', 36.0000, 'ºC'),
	(147794, 119, '2014-01-15 00:37:40.000000', 'temperatura', 512.0000, 'ºC'),
	(147795, 119, '2014-01-15 00:37:41.000000', 'temperatura', 52.0000, 'ºC'),
	(147796, 119, '2014-01-15 00:37:42.000000', 'temperatura', 1123.0000, 'ºC'),
	(147797, 119, '2014-01-15 00:37:43.000000', 'temperatura', 659.0000, 'ºC'),
	(147798, 119, '2014-01-15 00:37:44.000000', 'temperatura', 1128.0000, 'ºC'),
	(147799, 119, '2014-01-15 00:37:45.000000', 'temperatura', 64.0000, 'ºC'),
	(147800, 119, '2014-01-15 00:37:46.000000', 'temperatura', 534.0000, 'ºC'),
	(147801, 119, '2014-01-15 00:37:47.000000', 'temperatura', 80.0000, 'ºC'),
	(147802, 119, '2014-01-15 00:37:48.000000', 'temperatura', 1199.0000, 'ºC'),
	(147803, 119, '2014-01-15 00:37:49.000000', 'temperatura', 956.0000, 'ºC'),
	(147804, 119, '2014-01-15 00:37:50.000000', 'temperatura', 1184.0000, 'ºC'),
	(147805, 119, '2014-01-15 00:37:51.000000', 'temperatura', 650.0000, 'ºC'),
	(147806, 119, '2014-01-15 00:37:52.000000', 'temperatura', 898.0000, 'ºC'),
	(147807, 119, '2014-01-15 00:37:53.000000', 'temperatura', 143.0000, 'ºC'),
	(147808, 119, '2014-01-15 00:37:54.000000', 'temperatura', 419.0000, 'ºC'),
	(147809, 119, '2014-01-15 00:37:55.000000', 'temperatura', 466.0000, 'ºC'),
	(147810, 119, '2014-01-15 00:37:56.000000', 'temperatura', 1073.0000, 'ºC'),
	(147811, 119, '2014-01-15 00:37:57.000000', 'temperatura', 369.0000, 'ºC'),
	(147812, 119, '2014-01-15 00:37:58.000000', 'temperatura', 1026.0000, 'ºC'),
	(147813, 119, '2014-01-15 00:37:59.000000', 'temperatura', 424.0000, 'ºC'),
	(147814, 119, '2014-01-15 00:38:00.000000', 'temperatura', 243.0000, 'ºC'),
	(147815, 119, '2014-01-15 00:38:01.000000', 'temperatura', 1145.0000, 'ºC'),
	(147816, 119, '2014-01-15 00:38:02.000000', 'temperatura', 194.0000, 'ºC'),
	(147817, 119, '2014-01-15 00:38:03.000000', 'temperatura', 1136.0000, 'ºC'),
	(147818, 119, '2014-01-15 00:38:04.000000', 'temperatura', 300.0000, 'ºC'),
	(147819, 119, '2014-01-15 00:38:05.000000', 'temperatura', 491.0000, 'ºC'),
	(147820, 119, '2014-01-15 00:38:06.000000', 'temperatura', 356.0000, 'ºC'),
	(147821, 119, '2014-01-15 00:38:07.000000', 'temperatura', 306.0000, 'ºC'),
	(147822, 119, '2014-01-15 00:38:08.000000', 'temperatura', 462.0000, 'ºC'),
	(147823, 119, '2014-01-15 00:38:09.000000', 'temperatura', 194.0000, 'ºC'),
	(147824, 119, '2014-01-15 00:38:10.000000', 'temperatura', 784.0000, 'ºC'),
	(147825, 119, '2014-01-15 00:38:11.000000', 'temperatura', 941.0000, 'ºC'),
	(147826, 119, '2014-01-15 00:38:12.000000', 'temperatura', 1150.0000, 'ºC'),
	(147827, 119, '2014-01-15 00:38:13.000000', 'temperatura', 529.0000, 'ºC'),
	(147828, 119, '2014-01-15 00:38:14.000000', 'temperatura', 397.0000, 'ºC'),
	(147829, 119, '2014-01-15 00:38:15.000000', 'temperatura', 399.0000, 'ºC'),
	(147830, 119, '2014-01-15 00:38:16.000000', 'temperatura', 803.0000, 'ºC'),
	(147831, 119, '2014-01-15 00:38:17.000000', 'temperatura', 420.0000, 'ºC'),
	(147832, 119, '2014-01-15 00:38:18.000000', 'temperatura', 889.0000, 'ºC'),
	(147833, 119, '2014-01-15 00:38:19.000000', 'temperatura', 788.0000, 'ºC'),
	(147834, 119, '2014-01-15 00:38:20.000000', 'temperatura', 71.0000, 'ºC'),
	(147835, 119, '2014-01-15 00:38:21.000000', 'temperatura', 391.0000, 'ºC'),
	(147836, 119, '2014-01-15 00:38:22.000000', 'temperatura', 542.0000, 'ºC'),
	(147837, 119, '2014-01-15 00:38:23.000000', 'temperatura', 340.0000, 'ºC'),
	(147838, 119, '2014-01-15 00:38:24.000000', 'temperatura', 75.0000, 'ºC'),
	(147839, 119, '2014-01-15 00:38:25.000000', 'temperatura', 553.0000, 'ºC'),
	(147840, 119, '2014-01-15 00:38:26.000000', 'temperatura', 142.0000, 'ºC'),
	(147841, 119, '2014-01-15 00:38:27.000000', 'temperatura', 250.0000, 'ºC'),
	(147842, 119, '2014-01-15 00:38:28.000000', 'temperatura', 825.0000, 'ºC'),
	(147843, 119, '2014-01-15 00:38:29.000000', 'temperatura', 977.0000, 'ºC'),
	(147844, 119, '2014-01-15 00:38:30.000000', 'temperatura', 8.0000, 'ºC'),
	(147845, 119, '2014-01-15 00:38:31.000000', 'temperatura', 712.0000, 'ºC'),
	(147846, 119, '2014-01-15 00:38:32.000000', 'temperatura', 1135.0000, 'ºC'),
	(147847, 119, '2014-01-15 00:38:33.000000', 'temperatura', 1139.0000, 'ºC'),
	(147848, 119, '2014-01-15 00:38:34.000000', 'temperatura', 1092.0000, 'ºC'),
	(147849, 119, '2014-01-15 00:38:35.000000', 'temperatura', 845.0000, 'ºC'),
	(147850, 119, '2014-01-15 00:38:36.000000', 'temperatura', 947.0000, 'ºC'),
	(147851, 119, '2014-01-15 00:38:37.000000', 'temperatura', 1003.0000, 'ºC'),
	(147852, 119, '2014-01-15 00:38:38.000000', 'temperatura', 972.0000, 'ºC'),
	(147853, 119, '2014-01-15 00:38:39.000000', 'temperatura', 651.0000, 'ºC'),
	(147854, 119, '2014-01-15 00:38:40.000000', 'temperatura', 339.0000, 'ºC'),
	(147855, 119, '2014-01-15 00:38:41.000000', 'temperatura', 944.0000, 'ºC'),
	(147856, 119, '2014-01-15 00:38:42.000000', 'temperatura', 105.0000, 'ºC'),
	(147857, 119, '2014-01-15 00:38:43.000000', 'temperatura', 91.0000, 'ºC'),
	(147858, 119, '2014-01-15 00:38:44.000000', 'temperatura', 140.0000, 'ºC'),
	(147859, 119, '2014-01-15 00:38:45.000000', 'temperatura', 428.0000, 'ºC'),
	(147860, 119, '2014-01-15 00:38:46.000000', 'temperatura', 520.0000, 'ºC'),
	(147861, 119, '2014-01-15 00:38:47.000000', 'temperatura', 117.0000, 'ºC'),
	(147862, 119, '2014-01-15 00:38:48.000000', 'temperatura', 226.0000, 'ºC'),
	(147863, 119, '2014-01-15 00:38:49.000000', 'temperatura', 778.0000, 'ºC'),
	(147864, 119, '2014-01-15 00:38:50.000000', 'temperatura', 813.0000, 'ºC'),
	(147865, 119, '2014-01-15 00:38:51.000000', 'temperatura', 532.0000, 'ºC'),
	(147866, 119, '2014-01-15 00:38:52.000000', 'temperatura', 222.0000, 'ºC'),
	(147867, 119, '2014-01-15 00:38:53.000000', 'temperatura', 712.0000, 'ºC'),
	(147868, 119, '2014-01-15 00:38:54.000000', 'temperatura', 497.0000, 'ºC'),
	(147869, 119, '2014-01-15 00:38:55.000000', 'temperatura', 349.0000, 'ºC'),
	(147870, 119, '2014-01-15 00:38:56.000000', 'temperatura', 254.0000, 'ºC'),
	(147871, 119, '2014-01-15 00:38:57.000000', 'temperatura', 224.0000, 'ºC'),
	(147872, 119, '2014-01-15 00:38:58.000000', 'temperatura', 359.0000, 'ºC'),
	(147873, 119, '2014-01-15 00:38:59.000000', 'temperatura', 1122.0000, 'ºC'),
	(147874, 119, '2014-01-15 00:39:00.000000', 'temperatura', 934.0000, 'ºC'),
	(147875, 119, '2014-01-15 00:39:01.000000', 'temperatura', 103.0000, 'ºC'),
	(147876, 119, '2014-01-15 00:39:02.000000', 'temperatura', 117.0000, 'ºC'),
	(147877, 119, '2014-01-15 00:39:03.000000', 'temperatura', 273.0000, 'ºC'),
	(147878, 119, '2014-01-15 00:39:04.000000', 'temperatura', 1016.0000, 'ºC'),
	(147879, 119, '2014-01-15 00:39:05.000000', 'temperatura', 661.0000, 'ºC'),
	(147880, 119, '2014-01-15 00:39:06.000000', 'temperatura', 256.0000, 'ºC'),
	(147881, 119, '2014-01-15 00:39:07.000000', 'temperatura', 499.0000, 'ºC'),
	(147882, 119, '2014-01-15 00:39:08.000000', 'temperatura', 529.0000, 'ºC'),
	(147883, 119, '2014-01-15 00:39:09.000000', 'temperatura', 1148.0000, 'ºC'),
	(147884, 119, '2014-01-15 00:39:10.000000', 'temperatura', 551.0000, 'ºC'),
	(147885, 119, '2014-01-15 00:39:11.000000', 'temperatura', 514.0000, 'ºC'),
	(147886, 119, '2014-01-15 00:39:12.000000', 'temperatura', 916.0000, 'ºC'),
	(147887, 119, '2014-01-15 00:39:13.000000', 'temperatura', 638.0000, 'ºC'),
	(147888, 119, '2014-01-15 00:39:14.000000', 'temperatura', 442.0000, 'ºC'),
	(147889, 119, '2014-01-15 00:39:15.000000', 'temperatura', 296.0000, 'ºC'),
	(147890, 119, '2014-01-15 00:39:16.000000', 'temperatura', 156.0000, 'ºC'),
	(147891, 119, '2014-01-15 00:39:17.000000', 'temperatura', 1091.0000, 'ºC'),
	(147892, 119, '2014-01-15 00:39:18.000000', 'temperatura', 188.0000, 'ºC'),
	(147893, 119, '2014-01-15 00:39:19.000000', 'temperatura', 67.0000, 'ºC'),
	(147894, 119, '2014-01-15 00:39:20.000000', 'temperatura', 972.0000, 'ºC'),
	(147895, 119, '2014-01-15 00:39:21.000000', 'temperatura', 1059.0000, 'ºC'),
	(147896, 119, '2014-01-15 00:39:22.000000', 'temperatura', 1180.0000, 'ºC'),
	(147897, 119, '2014-01-15 00:39:23.000000', 'temperatura', 323.0000, 'ºC'),
	(147898, 119, '2014-01-15 00:39:24.000000', 'temperatura', 475.0000, 'ºC'),
	(147899, 119, '2014-01-15 00:39:25.000000', 'temperatura', 208.0000, 'ºC'),
	(147900, 119, '2014-01-15 00:39:26.000000', 'temperatura', 816.0000, 'ºC'),
	(147901, 119, '2014-01-15 00:39:27.000000', 'temperatura', 1058.0000, 'ºC'),
	(147902, 119, '2014-01-15 00:39:28.000000', 'temperatura', 439.0000, 'ºC'),
	(147903, 119, '2014-01-15 00:39:29.000000', 'temperatura', 223.0000, 'ºC'),
	(147904, 119, '2014-01-15 00:39:30.000000', 'temperatura', 998.0000, 'ºC'),
	(147905, 119, '2014-01-15 00:39:31.000000', 'temperatura', 723.0000, 'ºC'),
	(147906, 119, '2014-01-15 00:39:32.000000', 'temperatura', 621.0000, 'ºC'),
	(147907, 119, '2014-01-15 00:39:33.000000', 'temperatura', 936.0000, 'ºC'),
	(147908, 119, '2014-01-15 00:39:34.000000', 'temperatura', 419.0000, 'ºC'),
	(147909, 119, '2014-01-15 00:39:35.000000', 'temperatura', 488.0000, 'ºC'),
	(147910, 119, '2014-01-15 00:39:36.000000', 'temperatura', 1181.0000, 'ºC'),
	(147911, 119, '2014-01-15 00:39:37.000000', 'temperatura', 843.0000, 'ºC'),
	(147912, 119, '2014-01-15 00:39:38.000000', 'temperatura', 672.0000, 'ºC'),
	(147913, 119, '2014-01-15 00:39:39.000000', 'temperatura', 830.0000, 'ºC'),
	(147914, 119, '2014-01-15 00:39:40.000000', 'temperatura', 936.0000, 'ºC'),
	(147915, 119, '2014-01-15 00:39:41.000000', 'temperatura', 989.0000, 'ºC'),
	(147916, 119, '2014-01-15 00:39:42.000000', 'temperatura', 938.0000, 'ºC'),
	(147917, 119, '2014-01-15 00:39:43.000000', 'temperatura', 525.0000, 'ºC'),
	(147918, 119, '2014-01-15 00:39:44.000000', 'temperatura', 1011.0000, 'ºC'),
	(147919, 119, '2014-01-15 00:39:45.000000', 'temperatura', 1081.0000, 'ºC'),
	(147920, 119, '2014-01-15 00:39:46.000000', 'temperatura', 1172.0000, 'ºC'),
	(147921, 119, '2014-01-15 00:39:47.000000', 'temperatura', 219.0000, 'ºC'),
	(147922, 119, '2014-01-15 00:39:48.000000', 'temperatura', 1179.0000, 'ºC'),
	(147923, 119, '2014-01-15 00:39:49.000000', 'temperatura', 436.0000, 'ºC'),
	(147924, 119, '2014-01-15 00:39:50.000000', 'temperatura', 1046.0000, 'ºC'),
	(147925, 119, '2014-01-15 00:39:51.000000', 'temperatura', 320.0000, 'ºC'),
	(147926, 119, '2014-01-15 00:39:52.000000', 'temperatura', 863.0000, 'ºC'),
	(147927, 119, '2014-01-15 00:39:53.000000', 'temperatura', 957.0000, 'ºC'),
	(147928, 119, '2014-01-15 00:39:54.000000', 'temperatura', 996.0000, 'ºC'),
	(147929, 119, '2014-01-15 00:39:55.000000', 'temperatura', 911.0000, 'ºC'),
	(147930, 119, '2014-01-15 00:39:56.000000', 'temperatura', 368.0000, 'ºC'),
	(147931, 119, '2014-01-15 00:39:57.000000', 'temperatura', 307.0000, 'ºC'),
	(147932, 119, '2014-01-15 00:39:58.000000', 'temperatura', 432.0000, 'ºC'),
	(147933, 119, '2014-01-15 00:39:59.000000', 'temperatura', 39.0000, 'ºC'),
	(147934, 119, '2014-01-15 00:40:00.000000', 'temperatura', 98.0000, 'ºC'),
	(147935, 119, '2014-01-15 00:40:01.000000', 'temperatura', 374.0000, 'ºC'),
	(147936, 119, '2014-01-15 00:40:02.000000', 'temperatura', 377.0000, 'ºC'),
	(147937, 119, '2014-01-15 00:40:03.000000', 'temperatura', 763.0000, 'ºC'),
	(147938, 119, '2014-01-15 00:40:04.000000', 'temperatura', 286.0000, 'ºC'),
	(147939, 119, '2014-01-15 00:40:05.000000', 'temperatura', 339.0000, 'ºC'),
	(147940, 119, '2014-01-15 00:40:06.000000', 'temperatura', 840.0000, 'ºC'),
	(147941, 119, '2014-01-15 00:40:07.000000', 'temperatura', 785.0000, 'ºC'),
	(147942, 119, '2014-01-15 00:40:08.000000', 'temperatura', 202.0000, 'ºC'),
	(147943, 119, '2014-01-15 00:40:09.000000', 'temperatura', 1057.0000, 'ºC'),
	(147944, 119, '2014-01-15 00:40:10.000000', 'temperatura', 1080.0000, 'ºC'),
	(147945, 119, '2014-01-15 00:40:11.000000', 'temperatura', 1029.0000, 'ºC'),
	(147946, 119, '2014-01-15 00:40:12.000000', 'temperatura', 707.0000, 'ºC'),
	(147947, 119, '2014-01-15 00:40:13.000000', 'temperatura', 447.0000, 'ºC'),
	(147948, 119, '2014-01-15 00:40:14.000000', 'temperatura', 117.0000, 'ºC'),
	(147949, 119, '2014-01-15 00:40:15.000000', 'temperatura', 441.0000, 'ºC'),
	(147950, 119, '2014-01-15 00:40:16.000000', 'temperatura', 657.0000, 'ºC'),
	(147951, 119, '2014-01-15 00:40:17.000000', 'temperatura', 764.0000, 'ºC'),
	(147952, 119, '2014-01-15 00:40:18.000000', 'temperatura', 646.0000, 'ºC'),
	(147953, 119, '2014-01-15 00:40:19.000000', 'temperatura', 940.0000, 'ºC'),
	(147954, 119, '2014-01-15 00:40:20.000000', 'temperatura', 364.0000, 'ºC'),
	(147955, 119, '2014-01-15 00:40:21.000000', 'temperatura', 198.0000, 'ºC'),
	(147956, 119, '2014-01-15 00:40:22.000000', 'temperatura', 1098.0000, 'ºC'),
	(147957, 119, '2014-01-15 00:40:23.000000', 'temperatura', 99.0000, 'ºC'),
	(147958, 119, '2014-01-15 00:40:24.000000', 'temperatura', 801.0000, 'ºC'),
	(147959, 119, '2014-01-15 00:40:25.000000', 'temperatura', 106.0000, 'ºC'),
	(147960, 119, '2014-01-15 00:40:26.000000', 'temperatura', 529.0000, 'ºC'),
	(147961, 119, '2014-01-15 00:40:27.000000', 'temperatura', 1129.0000, 'ºC'),
	(147962, 119, '2014-01-15 00:40:28.000000', 'temperatura', 456.0000, 'ºC'),
	(147963, 119, '2014-01-15 00:40:29.000000', 'temperatura', 95.0000, 'ºC'),
	(147964, 119, '2014-01-15 00:40:30.000000', 'temperatura', 306.0000, 'ºC'),
	(147965, 119, '2014-01-15 00:40:31.000000', 'temperatura', 48.0000, 'ºC'),
	(147966, 119, '2014-01-15 00:40:32.000000', 'temperatura', 521.0000, 'ºC'),
	(147967, 119, '2014-01-15 00:40:33.000000', 'temperatura', 62.0000, 'ºC'),
	(147968, 119, '2014-01-15 00:40:34.000000', 'temperatura', 1147.0000, 'ºC'),
	(147969, 119, '2014-01-15 00:40:35.000000', 'temperatura', 749.0000, 'ºC'),
	(147970, 119, '2014-01-15 00:40:36.000000', 'temperatura', 306.0000, 'ºC'),
	(147971, 119, '2014-01-15 00:40:37.000000', 'temperatura', 481.0000, 'ºC'),
	(147972, 119, '2014-01-15 00:40:38.000000', 'temperatura', 288.0000, 'ºC'),
	(147973, 119, '2014-01-15 00:40:39.000000', 'temperatura', 1199.0000, 'ºC'),
	(147974, 119, '2014-01-15 00:40:40.000000', 'temperatura', 333.0000, 'ºC'),
	(147975, 119, '2014-01-15 00:40:41.000000', 'temperatura', 466.0000, 'ºC'),
	(147976, 119, '2014-01-15 00:40:42.000000', 'temperatura', 133.0000, 'ºC'),
	(147977, 119, '2014-01-15 00:40:43.000000', 'temperatura', 467.0000, 'ºC'),
	(147978, 119, '2014-01-15 00:40:44.000000', 'temperatura', 736.0000, 'ºC'),
	(147979, 119, '2014-01-15 00:40:45.000000', 'temperatura', 1080.0000, 'ºC'),
	(147980, 119, '2014-01-15 00:40:46.000000', 'temperatura', 793.0000, 'ºC'),
	(147981, 119, '2014-01-15 00:40:47.000000', 'temperatura', 724.0000, 'ºC'),
	(147982, 119, '2014-01-15 00:40:48.000000', 'temperatura', 42.0000, 'ºC'),
	(147983, 119, '2014-01-15 00:40:49.000000', 'temperatura', 437.0000, 'ºC'),
	(147984, 119, '2014-01-15 00:40:50.000000', 'temperatura', 859.0000, 'ºC'),
	(147985, 119, '2014-01-15 00:40:51.000000', 'temperatura', 584.0000, 'ºC'),
	(147986, 119, '2014-01-15 00:40:52.000000', 'temperatura', 345.0000, 'ºC'),
	(147987, 119, '2014-01-15 00:40:53.000000', 'temperatura', 1174.0000, 'ºC'),
	(147988, 119, '2014-01-15 00:40:54.000000', 'temperatura', 33.0000, 'ºC'),
	(147989, 119, '2014-01-15 00:40:55.000000', 'temperatura', 246.0000, 'ºC'),
	(147990, 119, '2014-01-15 00:40:56.000000', 'temperatura', 1131.0000, 'ºC'),
	(147991, 119, '2014-01-15 00:40:57.000000', 'temperatura', 118.0000, 'ºC'),
	(147992, 119, '2014-01-15 00:40:58.000000', 'temperatura', 797.0000, 'ºC'),
	(147993, 119, '2014-01-15 00:40:59.000000', 'temperatura', 32.0000, 'ºC'),
	(147994, 119, '2014-01-15 00:41:00.000000', 'temperatura', 169.0000, 'ºC'),
	(147995, 119, '2014-01-15 00:41:01.000000', 'temperatura', 752.0000, 'ºC'),
	(147996, 119, '2014-01-15 00:41:02.000000', 'temperatura', 850.0000, 'ºC'),
	(147997, 119, '2014-01-15 00:41:03.000000', 'temperatura', 795.0000, 'ºC'),
	(147998, 119, '2014-01-15 00:41:04.000000', 'temperatura', 224.0000, 'ºC'),
	(147999, 119, '2014-01-15 00:41:05.000000', 'temperatura', 1138.0000, 'ºC'),
	(148000, 119, '2014-01-15 00:41:06.000000', 'temperatura', 217.0000, 'ºC'),
	(148001, 119, '2014-01-15 00:41:07.000000', 'temperatura', 73.0000, 'ºC'),
	(148002, 119, '2014-01-15 00:41:08.000000', 'temperatura', 913.0000, 'ºC'),
	(148003, 119, '2014-01-15 00:41:09.000000', 'temperatura', 748.0000, 'ºC'),
	(148004, 119, '2014-01-15 00:41:10.000000', 'temperatura', 999.0000, 'ºC'),
	(148005, 119, '2014-01-15 00:41:11.000000', 'temperatura', 353.0000, 'ºC'),
	(148006, 119, '2014-01-15 00:41:12.000000', 'temperatura', 1170.0000, 'ºC'),
	(148007, 119, '2014-01-15 00:41:13.000000', 'temperatura', 1192.0000, 'ºC'),
	(148008, 119, '2014-01-15 00:41:14.000000', 'temperatura', 48.0000, 'ºC'),
	(148009, 119, '2014-01-15 00:41:15.000000', 'temperatura', 264.0000, 'ºC'),
	(148010, 119, '2014-01-15 00:41:16.000000', 'temperatura', 1178.0000, 'ºC'),
	(148011, 119, '2014-01-15 00:41:17.000000', 'temperatura', 297.0000, 'ºC'),
	(148012, 119, '2014-01-15 00:41:18.000000', 'temperatura', 352.0000, 'ºC'),
	(148013, 119, '2014-01-15 00:41:19.000000', 'temperatura', 868.0000, 'ºC'),
	(148014, 119, '2014-01-15 00:41:20.000000', 'temperatura', 886.0000, 'ºC'),
	(148015, 119, '2014-01-15 00:41:21.000000', 'temperatura', 626.0000, 'ºC'),
	(148016, 119, '2014-01-15 00:41:22.000000', 'temperatura', 471.0000, 'ºC'),
	(148017, 119, '2014-01-15 00:41:23.000000', 'temperatura', 478.0000, 'ºC'),
	(148018, 119, '2014-01-15 00:41:24.000000', 'temperatura', 980.0000, 'ºC'),
	(148019, 119, '2014-01-15 00:41:25.000000', 'temperatura', 1065.0000, 'ºC'),
	(148020, 119, '2014-01-15 00:41:26.000000', 'temperatura', 1185.0000, 'ºC'),
	(148021, 119, '2014-01-15 00:41:27.000000', 'temperatura', 332.0000, 'ºC'),
	(148022, 119, '2014-01-15 00:41:28.000000', 'temperatura', 506.0000, 'ºC'),
	(148023, 119, '2014-01-15 00:41:29.000000', 'temperatura', 334.0000, 'ºC'),
	(148024, 119, '2014-01-15 00:41:30.000000', 'temperatura', 152.0000, 'ºC'),
	(148025, 119, '2014-01-15 00:41:31.000000', 'temperatura', 960.0000, 'ºC'),
	(148026, 119, '2014-01-15 00:41:32.000000', 'temperatura', 745.0000, 'ºC'),
	(148027, 119, '2014-01-15 00:41:33.000000', 'temperatura', 847.0000, 'ºC'),
	(148028, 119, '2014-01-15 00:41:34.000000', 'temperatura', 797.0000, 'ºC'),
	(148029, 119, '2014-01-15 00:41:35.000000', 'temperatura', 246.0000, 'ºC'),
	(148030, 119, '2014-01-15 00:41:36.000000', 'temperatura', 41.0000, 'ºC'),
	(148031, 119, '2014-01-15 00:41:37.000000', 'temperatura', 666.0000, 'ºC'),
	(148032, 119, '2014-01-15 00:41:38.000000', 'temperatura', 809.0000, 'ºC'),
	(148033, 119, '2014-01-15 00:41:39.000000', 'temperatura', 847.0000, 'ºC'),
	(148034, 119, '2014-01-15 00:41:40.000000', 'temperatura', 607.0000, 'ºC'),
	(148035, 119, '2014-01-15 00:41:41.000000', 'temperatura', 495.0000, 'ºC'),
	(148036, 119, '2014-01-15 00:41:42.000000', 'temperatura', 656.0000, 'ºC'),
	(148037, 119, '2014-01-15 00:41:43.000000', 'temperatura', 593.0000, 'ºC'),
	(148038, 119, '2014-01-15 00:41:44.000000', 'temperatura', 997.0000, 'ºC'),
	(148039, 119, '2014-01-15 00:41:45.000000', 'temperatura', 808.0000, 'ºC'),
	(148040, 119, '2014-01-15 00:41:46.000000', 'temperatura', 1050.0000, 'ºC'),
	(148041, 119, '2014-01-15 00:41:47.000000', 'temperatura', 424.0000, 'ºC'),
	(148042, 119, '2014-01-15 00:41:48.000000', 'temperatura', 172.0000, 'ºC'),
	(148043, 119, '2014-01-15 00:41:49.000000', 'temperatura', 788.0000, 'ºC'),
	(148044, 119, '2014-01-15 00:41:50.000000', 'temperatura', 1025.0000, 'ºC'),
	(148045, 119, '2014-01-15 00:41:51.000000', 'temperatura', 361.0000, 'ºC'),
	(148046, 119, '2014-01-15 00:41:52.000000', 'temperatura', 1131.0000, 'ºC'),
	(148047, 119, '2014-01-15 00:41:53.000000', 'temperatura', 972.0000, 'ºC'),
	(148048, 119, '2014-01-15 00:41:54.000000', 'temperatura', 269.0000, 'ºC'),
	(148049, 119, '2014-01-15 00:41:55.000000', 'temperatura', 828.0000, 'ºC'),
	(148050, 119, '2014-01-15 00:41:56.000000', 'temperatura', 934.0000, 'ºC'),
	(148051, 119, '2014-01-15 00:41:57.000000', 'temperatura', 988.0000, 'ºC'),
	(148052, 119, '2014-01-15 00:41:58.000000', 'temperatura', 936.0000, 'ºC'),
	(148053, 119, '2014-01-15 00:41:59.000000', 'temperatura', 518.0000, 'ºC'),
	(148054, 119, '2014-01-15 00:42:00.000000', 'temperatura', 981.0000, 'ºC'),
	(148055, 119, '2014-01-15 00:42:01.000000', 'temperatura', 954.0000, 'ºC'),
	(148056, 119, '2014-01-15 00:42:02.000000', 'temperatura', 627.0000, 'ºC'),
	(148057, 119, '2014-01-15 00:42:03.000000', 'temperatura', 275.0000, 'ºC'),
	(148058, 119, '2014-01-15 00:42:04.000000', 'temperatura', 691.0000, 'ºC'),
	(148059, 119, '2014-01-15 00:42:05.000000', 'temperatura', 233.0000, 'ºC'),
	(148060, 119, '2014-01-15 00:42:06.000000', 'temperatura', 292.0000, 'ºC'),
	(148061, 119, '2014-01-15 00:42:07.000000', 'temperatura', 763.0000, 'ºC'),
	(148062, 119, '2014-01-15 00:42:08.000000', 'temperatura', 540.0000, 'ºC'),
	(148063, 119, '2014-01-15 00:42:09.000000', 'temperatura', 410.0000, 'ºC'),
	(148064, 119, '2014-01-15 00:42:10.000000', 'temperatura', 432.0000, 'ºC'),
	(148065, 119, '2014-01-15 00:42:11.000000', 'temperatura', 928.0000, 'ºC'),
	(148066, 119, '2014-01-15 00:42:12.000000', 'temperatura', 947.0000, 'ºC'),
	(148067, 119, '2014-01-15 00:42:13.000000', 'temperatura', 749.0000, 'ºC'),
	(148068, 119, '2014-01-15 00:42:14.000000', 'temperatura', 905.0000, 'ºC'),
	(148069, 119, '2014-01-15 00:42:15.000000', 'temperatura', 1077.0000, 'ºC'),
	(148070, 119, '2014-01-15 00:42:16.000000', 'temperatura', 272.0000, 'ºC'),
	(148071, 119, '2014-01-15 00:42:17.000000', 'temperatura', 529.0000, 'ºC'),
	(148072, 119, '2014-01-15 00:42:18.000000', 'temperatura', 628.0000, 'ºC'),
	(148073, 119, '2014-01-15 00:42:19.000000', 'temperatura', 356.0000, 'ºC'),
	(148074, 119, '2014-01-15 00:42:20.000000', 'temperatura', 1095.0000, 'ºC'),
	(148075, 119, '2014-01-15 00:42:21.000000', 'temperatura', 809.0000, 'ºC'),
	(148076, 119, '2014-01-15 00:42:22.000000', 'temperatura', 762.0000, 'ºC'),
	(148077, 119, '2014-01-15 00:42:23.000000', 'temperatura', 180.0000, 'ºC'),
	(148078, 119, '2014-01-15 00:42:24.000000', 'temperatura', 1015.0000, 'ºC'),
	(148079, 119, '2014-01-15 00:42:25.000000', 'temperatura', 938.0000, 'ºC'),
	(148080, 119, '2014-01-15 00:42:26.000000', 'temperatura', 444.0000, 'ºC'),
	(148081, 119, '2014-01-15 00:42:27.000000', 'temperatura', 608.0000, 'ºC'),
	(148082, 119, '2014-01-15 00:42:28.000000', 'temperatura', 509.0000, 'ºC'),
	(148083, 119, '2014-01-15 00:42:29.000000', 'temperatura', 722.0000, 'ºC'),
	(148084, 119, '2014-01-15 00:42:30.000000', 'temperatura', 883.0000, 'ºC'),
	(148085, 119, '2014-01-15 00:42:31.000000', 'temperatura', 1050.0000, 'ºC'),
	(148086, 119, '2014-01-15 00:42:32.000000', 'temperatura', 202.0000, 'ºC'),
	(148087, 119, '2014-01-15 00:42:33.000000', 'temperatura', 258.0000, 'ºC'),
	(148088, 119, '2014-01-15 00:42:34.000000', 'temperatura', 687.0000, 'ºC'),
	(148089, 119, '2014-01-15 00:42:35.000000', 'temperatura', 262.0000, 'ºC'),
	(148090, 119, '2014-01-15 00:42:36.000000', 'temperatura', 450.0000, 'ºC'),
	(148091, 119, '2014-01-15 00:42:37.000000', 'temperatura', 265.0000, 'ºC'),
	(148092, 119, '2014-01-15 00:42:38.000000', 'temperatura', 1175.0000, 'ºC'),
	(148093, 119, '2014-01-15 00:42:39.000000', 'temperatura', 282.0000, 'ºC'),
	(148094, 119, '2014-01-15 00:42:40.000000', 'temperatura', 282.0000, 'ºC'),
	(148095, 119, '2014-01-15 00:42:41.000000', 'temperatura', 566.0000, 'ºC'),
	(148096, 119, '2014-01-15 00:42:42.000000', 'temperatura', 785.0000, 'ºC'),
	(148097, 119, '2014-01-15 00:42:43.000000', 'temperatura', 1028.0000, 'ºC'),
	(148098, 119, '2014-01-15 00:42:44.000000', 'temperatura', 386.0000, 'ºC'),
	(148099, 119, '2014-01-15 00:42:45.000000', 'temperatura', 44.0000, 'ºC'),
	(148100, 119, '2014-01-15 00:42:46.000000', 'temperatura', 264.0000, 'ºC'),
	(148101, 119, '2014-01-15 00:42:47.000000', 'temperatura', 1190.0000, 'ºC'),
	(148102, 119, '2014-01-15 00:42:48.000000', 'temperatura', 358.0000, 'ºC'),
	(148103, 119, '2014-01-15 00:42:49.000000', 'temperatura', 622.0000, 'ºC'),
	(148104, 119, '2014-01-15 00:42:50.000000', 'temperatura', 835.0000, 'ºC'),
	(148105, 119, '2014-01-15 00:42:51.000000', 'temperatura', 1111.0000, 'ºC'),
	(148106, 119, '2014-01-15 00:42:52.000000', 'temperatura', 647.0000, 'ºC'),
	(148107, 119, '2014-01-15 00:42:53.000000', 'temperatura', 1106.0000, 'ºC'),
	(148108, 119, '2014-01-15 00:42:54.000000', 'temperatura', 1189.0000, 'ºC'),
	(148109, 119, '2014-01-15 00:42:55.000000', 'temperatura', 228.0000, 'ºC'),
	(148110, 119, '2014-01-15 00:42:56.000000', 'temperatura', 1172.0000, 'ºC'),
	(148111, 119, '2014-01-15 00:42:57.000000', 'temperatura', 376.0000, 'ºC'),
	(148112, 119, '2014-01-15 00:42:58.000000', 'temperatura', 767.0000, 'ºC'),
	(148113, 119, '2014-01-15 00:42:59.000000', 'temperatura', 307.0000, 'ºC'),
	(148114, 119, '2014-01-15 00:43:00.000000', 'temperatura', 436.0000, 'ºC'),
	(148115, 119, '2014-01-15 00:43:01.000000', 'temperatura', 58.0000, 'ºC'),
	(148116, 119, '2014-01-15 00:43:02.000000', 'temperatura', 183.0000, 'ºC'),
	(148117, 119, '2014-01-15 00:43:03.000000', 'temperatura', 741.0000, 'ºC'),
	(148118, 119, '2014-01-15 00:43:04.000000', 'temperatura', 757.0000, 'ºC'),
	(148119, 119, '2014-01-15 00:43:05.000000', 'temperatura', 363.0000, 'ºC'),
	(148120, 119, '2014-01-15 00:43:06.000000', 'temperatura', 745.0000, 'ºC'),
	(148121, 119, '2014-01-15 00:43:07.000000', 'temperatura', 237.0000, 'ºC'),
	(148122, 119, '2014-01-15 00:43:08.000000', 'temperatura', 148.0000, 'ºC'),
	(148123, 119, '2014-01-15 00:43:09.000000', 'temperatura', 29.0000, 'ºC'),
	(148124, 119, '2014-01-15 00:43:10.000000', 'temperatura', 904.0000, 'ºC'),
	(148125, 119, '2014-01-15 00:43:11.000000', 'temperatura', 834.0000, 'ºC'),
	(148126, 119, '2014-01-15 00:43:12.000000', 'temperatura', 257.0000, 'ºC'),
	(148127, 119, '2014-01-15 00:43:13.000000', 'temperatura', 1186.0000, 'ºC'),
	(148128, 119, '2014-01-15 00:43:14.000000', 'temperatura', 357.0000, 'ºC'),
	(148129, 119, '2014-01-15 00:43:15.000000', 'temperatura', 628.0000, 'ºC'),
	(148130, 119, '2014-01-15 00:43:16.000000', 'temperatura', 872.0000, 'ºC'),
	(148131, 119, '2014-01-15 00:43:17.000000', 'temperatura', 73.0000, 'ºC'),
	(148132, 119, '2014-01-15 00:43:18.000000', 'temperatura', 150.0000, 'ºC'),
	(148133, 119, '2014-01-15 00:43:19.000000', 'temperatura', 534.0000, 'ºC'),
	(148134, 119, '2014-01-15 00:43:20.000000', 'temperatura', 1019.0000, 'ºC'),
	(148135, 119, '2014-01-15 00:43:21.000000', 'temperatura', 1094.0000, 'ºC'),
	(148136, 119, '2014-01-15 00:43:22.000000', 'temperatura', 14.0000, 'ºC'),
	(148137, 119, '2014-01-15 00:43:23.000000', 'temperatura', 386.0000, 'ºC'),
	(148138, 119, '2014-01-15 00:43:24.000000', 'temperatura', 690.0000, 'ºC'),
	(148139, 119, '2014-01-15 00:43:25.000000', 'temperatura', 1091.0000, 'ºC'),
	(148140, 119, '2014-01-15 00:43:26.000000', 'temperatura', 984.0000, 'ºC'),
	(148141, 119, '2014-01-15 00:43:27.000000', 'temperatura', 451.0000, 'ºC'),
	(148142, 119, '2014-01-15 00:43:28.000000', 'temperatura', 501.0000, 'ºC'),
	(148143, 119, '2014-01-15 00:43:29.000000', 'temperatura', 1152.0000, 'ºC'),
	(148144, 119, '2014-01-15 00:43:30.000000', 'temperatura', 660.0000, 'ºC'),
	(148145, 119, '2014-01-15 00:43:31.000000', 'temperatura', 1043.0000, 'ºC'),
	(148146, 119, '2014-01-15 00:43:32.000000', 'temperatura', 835.0000, 'ºC'),
	(148147, 119, '2014-01-15 00:43:33.000000', 'temperatura', 1045.0000, 'ºC'),
	(148148, 119, '2014-01-15 00:43:34.000000', 'temperatura', 322.0000, 'ºC'),
	(148149, 119, '2014-01-15 00:43:35.000000', 'temperatura', 876.0000, 'ºC'),
	(148150, 119, '2014-01-15 00:43:36.000000', 'temperatura', 1012.0000, 'ºC'),
	(148151, 119, '2014-01-15 00:43:37.000000', 'temperatura', 34.0000, 'ºC'),
	(148152, 119, '2014-01-15 00:43:38.000000', 'temperatura', 735.0000, 'ºC'),
	(148153, 119, '2014-01-15 00:43:39.000000', 'temperatura', 1173.0000, 'ºC'),
	(148154, 119, '2014-01-15 00:43:40.000000', 'temperatura', 62.0000, 'ºC'),
	(148155, 119, '2014-01-15 00:43:41.000000', 'temperatura', 390.0000, 'ºC'),
	(148156, 119, '2014-01-15 00:43:42.000000', 'temperatura', 563.0000, 'ºC'),
	(148157, 119, '2014-01-15 00:43:43.000000', 'temperatura', 447.0000, 'ºC'),
	(148158, 119, '2014-01-15 00:43:44.000000', 'temperatura', 544.0000, 'ºC'),
	(148159, 119, '2014-01-15 00:43:45.000000', 'temperatura', 183.0000, 'ºC'),
	(148160, 119, '2014-01-15 00:43:46.000000', 'temperatura', 482.0000, 'ºC'),
	(148161, 119, '2014-01-15 00:43:47.000000', 'temperatura', 663.0000, 'ºC'),
	(148162, 119, '2014-01-15 00:43:48.000000', 'temperatura', 670.0000, 'ºC'),
	(148163, 119, '2014-01-15 00:43:49.000000', 'temperatura', 159.0000, 'ºC'),
	(148164, 119, '2014-01-15 00:43:50.000000', 'temperatura', 1185.0000, 'ºC'),
	(148165, 119, '2014-01-15 00:43:51.000000', 'temperatura', 648.0000, 'ºC'),
	(148166, 119, '2014-01-15 00:43:52.000000', 'temperatura', 886.0000, 'ºC'),
	(148167, 119, '2014-01-15 00:43:53.000000', 'temperatura', 86.0000, 'ºC'),
	(148168, 119, '2014-01-15 00:43:54.000000', 'temperatura', 174.0000, 'ºC'),
	(148169, 119, '2014-01-15 00:43:55.000000', 'temperatura', 611.0000, 'ºC'),
	(148170, 119, '2014-01-15 00:43:56.000000', 'temperatura', 132.0000, 'ºC'),
	(148171, 119, '2014-01-15 00:43:57.000000', 'temperatura', 29.0000, 'ºC'),
	(148172, 119, '2014-01-15 00:43:58.000000', 'temperatura', 951.0000, 'ºC'),
	(148173, 119, '2014-01-15 00:43:59.000000', 'temperatura', 1069.0000, 'ºC'),
	(148174, 119, '2014-01-15 00:44:00.000000', 'temperatura', 92.0000, 'ºC'),
	(148175, 119, '2014-01-15 00:44:01.000000', 'temperatura', 854.0000, 'ºC'),
	(148176, 119, '2014-01-15 00:44:02.000000', 'temperatura', 394.0000, 'ºC'),
	(148177, 119, '2014-01-15 00:44:03.000000', 'temperatura', 608.0000, 'ºC'),
	(148178, 119, '2014-01-15 00:44:04.000000', 'temperatura', 659.0000, 'ºC'),
	(148179, 119, '2014-01-15 00:44:05.000000', 'temperatura', 270.0000, 'ºC'),
	(148180, 119, '2014-01-15 00:44:06.000000', 'temperatura', 573.0000, 'ºC'),
	(148181, 119, '2014-01-15 00:44:07.000000', 'temperatura', 858.0000, 'ºC'),
	(148182, 119, '2014-01-15 00:44:08.000000', 'temperatura', 171.0000, 'ºC'),
	(148183, 119, '2014-01-15 00:44:09.000000', 'temperatura', 682.0000, 'ºC'),
	(148184, 119, '2014-01-15 00:44:10.000000', 'temperatura', 498.0000, 'ºC'),
	(148185, 119, '2014-01-15 00:44:11.000000', 'temperatura', 442.0000, 'ºC'),
	(148186, 119, '2014-01-15 00:44:12.000000', 'temperatura', 720.0000, 'ºC'),
	(148187, 119, '2014-01-15 00:44:13.000000', 'temperatura', 1071.0000, 'ºC'),
	(148188, 119, '2014-01-15 00:44:14.000000', 'temperatura', 797.0000, 'ºC'),
	(148189, 119, '2014-01-15 00:44:15.000000', 'temperatura', 772.0000, 'ºC'),
	(148190, 119, '2014-01-15 00:44:16.000000', 'temperatura', 271.0000, 'ºC'),
	(148191, 119, '2014-01-15 00:44:17.000000', 'temperatura', 237.0000, 'ºC'),
	(148192, 119, '2014-01-15 00:44:18.000000', 'temperatura', 375.0000, 'ºC'),
	(148193, 119, '2014-01-15 00:44:19.000000', 'temperatura', 1165.0000, 'ºC'),
	(148194, 119, '2014-01-15 00:44:20.000000', 'temperatura', 1098.0000, 'ºC'),
	(148195, 119, '2014-01-15 00:44:21.000000', 'temperatura', 797.0000, 'ºC'),
	(148196, 119, '2014-01-15 00:44:22.000000', 'temperatura', 691.0000, 'ºC'),
	(148197, 119, '2014-01-15 00:44:23.000000', 'temperatura', 1064.0000, 'ºC'),
	(148198, 119, '2014-01-15 00:44:24.000000', 'temperatura', 846.0000, 'ºC'),
	(148199, 119, '2014-01-15 00:44:25.000000', 'temperatura', 1040.0000, 'ºC'),
	(148200, 119, '2014-01-15 00:44:26.000000', 'temperatura', 263.0000, 'ºC'),
	(148201, 119, '2014-01-15 00:44:27.000000', 'temperatura', 597.0000, 'ºC'),
	(148202, 119, '2014-01-15 00:44:28.000000', 'temperatura', 995.0000, 'ºC'),
	(148203, 119, '2014-01-15 00:44:29.000000', 'temperatura', 783.0000, 'ºC'),
	(148204, 119, '2014-01-15 00:44:30.000000', 'temperatura', 931.0000, 'ºC'),
	(148205, 119, '2014-01-15 00:44:31.000000', 'temperatura', 1105.0000, 'ºC'),
	(148206, 119, '2014-01-15 00:44:32.000000', 'temperatura', 335.0000, 'ºC'),
	(148207, 119, '2014-01-15 00:44:33.000000', 'temperatura', 760.0000, 'ºC'),
	(148208, 119, '2014-01-15 00:44:34.000000', 'temperatura', 397.0000, 'ºC'),
	(148209, 119, '2014-01-15 00:44:35.000000', 'temperatura', 905.0000, 'ºC'),
	(148210, 119, '2014-01-15 00:44:36.000000', 'temperatura', 935.0000, 'ºC'),
	(148211, 119, '2014-01-15 00:44:37.000000', 'temperatura', 759.0000, 'ºC'),
	(148212, 119, '2014-01-15 00:44:38.000000', 'temperatura', 990.0000, 'ºC'),
	(148213, 119, '2014-01-15 00:44:39.000000', 'temperatura', 274.0000, 'ºC'),
	(148214, 119, '2014-01-15 00:44:40.000000', 'temperatura', 799.0000, 'ºC'),
	(148215, 119, '2014-01-15 00:44:41.000000', 'temperatura', 777.0000, 'ºC'),
	(148216, 119, '2014-01-15 00:44:42.000000', 'temperatura', 285.0000, 'ºC'),
	(148217, 119, '2014-01-15 00:44:43.000000', 'temperatura', 295.0000, 'ºC'),
	(148218, 119, '2014-01-15 00:44:44.000000', 'temperatura', 623.0000, 'ºC'),
	(148219, 119, '2014-01-15 00:44:45.000000', 'temperatura', 1030.0000, 'ºC'),
	(148220, 119, '2014-01-15 00:44:46.000000', 'temperatura', 881.0000, 'ºC'),
	(148221, 119, '2014-01-15 00:44:47.000000', 'temperatura', 114.0000, 'ºC'),
	(148222, 119, '2014-01-15 00:44:48.000000', 'temperatura', 329.0000, 'ºC'),
	(148223, 119, '2014-01-15 00:44:49.000000', 'temperatura', 105.0000, 'ºC'),
	(148224, 119, '2014-01-15 00:44:50.000000', 'temperatura', 736.0000, 'ºC'),
	(148225, 119, '2014-01-15 00:44:51.000000', 'temperatura', 968.0000, 'ºC'),
	(148226, 119, '2014-01-15 00:44:52.000000', 'temperatura', 233.0000, 'ºC'),
	(148227, 119, '2014-01-15 00:44:53.000000', 'temperatura', 661.0000, 'ºC'),
	(148228, 119, '2014-01-15 00:44:54.000000', 'temperatura', 206.0000, 'ºC'),
	(148229, 119, '2014-01-15 00:44:55.000000', 'temperatura', 249.0000, 'ºC'),
	(148230, 119, '2014-01-15 00:44:56.000000', 'temperatura', 628.0000, 'ºC'),
	(148231, 119, '2014-01-15 00:44:57.000000', 'temperatura', 1194.0000, 'ºC'),
	(148232, 119, '2014-01-15 00:44:58.000000', 'temperatura', 485.0000, 'ºC'),
	(148233, 119, '2014-01-15 00:44:59.000000', 'temperatura', 46.0000, 'ºC'),
	(148234, 119, '2014-01-15 00:45:00.000000', 'temperatura', 1173.0000, 'ºC'),
	(148235, 119, '2014-01-15 00:45:01.000000', 'temperatura', 928.0000, 'ºC'),
	(148236, 119, '2014-01-15 00:45:02.000000', 'temperatura', 1122.0000, 'ºC'),
	(148237, 119, '2014-01-15 00:45:03.000000', 'temperatura', 427.0000, 'ºC'),
	(148238, 119, '2014-01-15 00:45:04.000000', 'temperatura', 1170.0000, 'ºC'),
	(148239, 119, '2014-01-15 00:45:05.000000', 'temperatura', 968.0000, 'ºC'),
	(148240, 119, '2014-01-15 00:45:06.000000', 'temperatura', 129.0000, 'ºC'),
	(148241, 119, '2014-01-15 00:45:07.000000', 'temperatura', 143.0000, 'ºC'),
	(148242, 119, '2014-01-15 00:45:08.000000', 'temperatura', 328.0000, 'ºC'),
	(148243, 119, '2014-01-15 00:45:09.000000', 'temperatura', 14.0000, 'ºC'),
	(148244, 119, '2014-01-15 00:45:10.000000', 'temperatura', 284.0000, 'ºC'),
	(148245, 119, '2014-01-15 00:45:11.000000', 'temperatura', 180.0000, 'ºC'),
	(148246, 119, '2014-01-15 00:45:12.000000', 'temperatura', 49.0000, 'ºC'),
	(148247, 119, '2014-01-15 00:45:13.000000', 'temperatura', 903.0000, 'ºC'),
	(148248, 119, '2014-01-15 00:45:14.000000', 'temperatura', 768.0000, 'ºC'),
	(148249, 119, '2014-01-15 00:45:15.000000', 'temperatura', 1133.0000, 'ºC'),
	(148250, 119, '2014-01-15 00:45:16.000000', 'temperatura', 961.0000, 'ºC'),
	(148251, 119, '2014-01-15 00:45:17.000000', 'temperatura', 209.0000, 'ºC'),
	(148252, 119, '2014-01-15 00:45:18.000000', 'temperatura', 559.0000, 'ºC'),
	(148253, 119, '2014-01-15 00:45:19.000000', 'temperatura', 971.0000, 'ºC'),
	(148254, 119, '2014-01-15 00:45:20.000000', 'temperatura', 778.0000, 'ºC'),
	(148255, 119, '2014-01-15 00:45:21.000000', 'temperatura', 977.0000, 'ºC'),
	(148256, 119, '2014-01-15 00:45:22.000000', 'temperatura', 152.0000, 'ºC'),
	(148257, 119, '2014-01-15 00:45:23.000000', 'temperatura', 229.0000, 'ºC'),
	(148258, 119, '2014-01-15 00:45:24.000000', 'temperatura', 689.0000, 'ºC'),
	(148259, 119, '2014-01-15 00:45:25.000000', 'temperatura', 360.0000, 'ºC'),
	(148260, 119, '2014-01-15 00:45:26.000000', 'temperatura', 932.0000, 'ºC'),
	(148261, 119, '2014-01-15 00:45:27.000000', 'temperatura', 1179.0000, 'ºC'),
	(148262, 119, '2014-01-15 00:45:28.000000', 'temperatura', 701.0000, 'ºC'),
	(148263, 119, '2014-01-15 00:45:29.000000', 'temperatura', 1170.0000, 'ºC'),
	(148264, 119, '2014-01-15 00:45:30.000000', 'temperatura', 148.0000, 'ºC'),
	(148265, 119, '2014-01-15 00:45:31.000000', 'temperatura', 828.0000, 'ºC'),
	(148266, 119, '2014-01-15 00:45:32.000000', 'temperatura', 99.0000, 'ºC'),
	(148267, 119, '2014-01-15 00:45:33.000000', 'temperatura', 410.0000, 'ºC'),
	(148268, 119, '2014-01-15 00:45:34.000000', 'temperatura', 552.0000, 'ºC'),
	(148269, 119, '2014-01-15 00:45:35.000000', 'temperatura', 331.0000, 'ºC'),
	(148270, 119, '2014-01-15 00:45:36.000000', 'temperatura', 1.0000, 'ºC'),
	(148271, 119, '2014-01-15 00:45:37.000000', 'temperatura', 213.0000, 'ºC'),
	(148272, 119, '2014-01-15 00:45:38.000000', 'temperatura', 1060.0000, 'ºC'),
	(148273, 119, '2014-01-15 00:45:39.000000', 'temperatura', 1062.0000, 'ºC'),
	(148274, 119, '2014-01-15 00:45:40.000000', 'temperatura', 930.0000, 'ºC'),
	(148275, 119, '2014-01-15 00:45:41.000000', 'temperatura', 267.0000, 'ºC'),
	(148276, 119, '2014-01-15 00:45:42.000000', 'temperatura', 945.0000, 'ºC'),
	(148277, 119, '2014-01-15 00:45:43.000000', 'temperatura', 325.0000, 'ºC'),
	(148278, 119, '2014-01-15 00:45:44.000000', 'temperatura', 1189.0000, 'ºC'),
	(148279, 119, '2014-01-15 00:45:45.000000', 'temperatura', 171.0000, 'ºC'),
	(148280, 119, '2014-01-15 00:45:46.000000', 'temperatura', 888.0000, 'ºC'),
	(148281, 119, '2014-01-15 00:45:47.000000', 'temperatura', 329.0000, 'ºC'),
	(148282, 119, '2014-01-15 00:45:48.000000', 'temperatura', 180.0000, 'ºC'),
	(148283, 119, '2014-01-15 00:45:49.000000', 'temperatura', 1114.0000, 'ºC'),
	(148284, 119, '2014-01-15 00:45:50.000000', 'temperatura', 232.0000, 'ºC'),
	(148285, 119, '2014-01-15 00:45:51.000000', 'temperatura', 218.0000, 'ºC'),
	(148286, 119, '2014-01-15 00:45:52.000000', 'temperatura', 392.0000, 'ºC'),
	(148287, 119, '2014-01-15 00:45:53.000000', 'temperatura', 109.0000, 'ºC'),
	(148288, 119, '2014-01-15 00:45:54.000000', 'temperatura', 569.0000, 'ºC'),
	(148289, 119, '2014-01-15 00:45:55.000000', 'temperatura', 120.0000, 'ºC'),
	(148290, 119, '2014-01-15 00:45:56.000000', 'temperatura', 91.0000, 'ºC'),
	(148291, 119, '2014-01-15 00:45:57.000000', 'temperatura', 97.0000, 'ºC'),
	(148292, 119, '2014-01-15 00:45:58.000000', 'temperatura', 214.0000, 'ºC'),
	(148293, 119, '2014-01-15 00:45:59.000000', 'temperatura', 776.0000, 'ºC'),
	(148294, 119, '2014-01-15 00:46:00.000000', 'temperatura', 841.0000, 'ºC'),
	(148295, 119, '2014-01-15 00:46:01.000000', 'temperatura', 678.0000, 'ºC'),
	(148296, 119, '2014-01-15 00:46:02.000000', 'temperatura', 866.0000, 'ºC'),
	(148297, 119, '2014-01-15 00:46:03.000000', 'temperatura', 1097.0000, 'ºC'),
	(148298, 119, '2014-01-15 00:46:04.000000', 'temperatura', 489.0000, 'ºC'),
	(148299, 119, '2014-01-15 00:46:05.000000', 'temperatura', 352.0000, 'ºC'),
	(148300, 119, '2014-01-15 00:46:06.000000', 'temperatura', 295.0000, 'ºC'),
	(148301, 119, '2014-01-15 00:46:07.000000', 'temperatura', 419.0000, 'ºC'),
	(148302, 119, '2014-01-15 00:46:08.000000', 'temperatura', 11.0000, 'ºC'),
	(148303, 119, '2014-01-15 00:46:09.000000', 'temperatura', 1199.0000, 'ºC'),
	(148304, 119, '2014-01-15 00:46:10.000000', 'temperatura', 1160.0000, 'ºC'),
	(148305, 119, '2014-01-15 00:46:11.000000', 'temperatura', 1007.0000, 'ºC'),
	(148306, 119, '2014-01-15 00:46:12.000000', 'temperatura', 353.0000, 'ºC'),
	(148307, 119, '2014-01-15 00:46:13.000000', 'temperatura', 1145.0000, 'ºC'),
	(148308, 119, '2014-01-15 00:46:14.000000', 'temperatura', 1066.0000, 'ºC'),
	(148309, 119, '2014-01-15 00:46:15.000000', 'temperatura', 694.0000, 'ºC'),
	(148310, 119, '2014-01-15 00:46:16.000000', 'temperatura', 274.0000, 'ºC'),
	(148311, 119, '2014-01-15 00:46:17.000000', 'temperatura', 488.0000, 'ºC'),
	(148312, 119, '2014-01-15 00:46:18.000000', 'temperatura', 420.0000, 'ºC'),
	(148313, 119, '2014-01-15 00:46:19.000000', 'temperatura', 638.0000, 'ºC'),
	(148314, 119, '2014-01-15 00:46:20.000000', 'temperatura', 727.0000, 'ºC'),
	(148315, 119, '2014-01-15 00:46:21.000000', 'temperatura', 525.0000, 'ºC'),
	(148316, 119, '2014-01-15 00:46:22.000000', 'temperatura', 442.0000, 'ºC'),
	(148317, 119, '2014-01-15 00:46:23.000000', 'temperatura', 634.0000, 'ºC'),
	(148318, 119, '2014-01-15 00:46:24.000000', 'temperatura', 646.0000, 'ºC'),
	(148319, 119, '2014-01-15 00:46:25.000000', 'temperatura', 129.0000, 'ºC'),
	(148320, 119, '2014-01-15 00:46:26.000000', 'temperatura', 1109.0000, 'ºC'),
	(148321, 119, '2014-01-15 00:46:27.000000', 'temperatura', 356.0000, 'ºC'),
	(148322, 119, '2014-01-15 00:46:28.000000', 'temperatura', 854.0000, 'ºC'),
	(148323, 119, '2014-01-15 00:46:29.000000', 'temperatura', 804.0000, 'ºC'),
	(148324, 119, '2014-01-15 00:46:30.000000', 'temperatura', 257.0000, 'ºC'),
	(148325, 119, '2014-01-15 00:46:31.000000', 'temperatura', 72.0000, 'ºC'),
	(148326, 119, '2014-01-15 00:46:32.000000', 'temperatura', 793.0000, 'ºC'),
	(148327, 119, '2014-01-15 00:46:33.000000', 'temperatura', 147.0000, 'ºC'),
	(148328, 119, '2014-01-15 00:46:34.000000', 'temperatura', 759.0000, 'ºC'),
	(148329, 119, '2014-01-15 00:46:35.000000', 'temperatura', 954.0000, 'ºC'),
	(148330, 119, '2014-01-15 00:46:36.000000', 'temperatura', 95.0000, 'ºC'),
	(148331, 119, '2014-01-15 00:46:37.000000', 'temperatura', 12.0000, 'ºC'),
	(148332, 119, '2014-01-15 00:46:38.000000', 'temperatura', 974.0000, 'ºC'),
	(148333, 119, '2014-01-15 00:46:39.000000', 'temperatura', 36.0000, 'ºC'),
	(148334, 119, '2014-01-15 00:46:40.000000', 'temperatura', 857.0000, 'ºC'),
	(148335, 119, '2014-01-15 00:46:41.000000', 'temperatura', 576.0000, 'ºC'),
	(148336, 119, '2014-01-15 00:46:42.000000', 'temperatura', 313.0000, 'ºC'),
	(148337, 119, '2014-01-15 00:46:43.000000', 'temperatura', 1036.0000, 'ºC'),
	(148338, 119, '2014-01-15 00:46:44.000000', 'temperatura', 642.0000, 'ºC'),
	(148339, 119, '2014-01-15 00:46:45.000000', 'temperatura', 102.0000, 'ºC'),
	(148340, 119, '2014-01-15 00:46:46.000000', 'temperatura', 983.0000, 'ºC'),
	(148341, 119, '2014-01-15 00:46:47.000000', 'temperatura', 1009.0000, 'ºC'),
	(148342, 119, '2014-01-15 00:46:48.000000', 'temperatura', 897.0000, 'ºC'),
	(148343, 119, '2014-01-15 00:46:49.000000', 'temperatura', 258.0000, 'ºC'),
	(148344, 119, '2014-01-15 00:46:50.000000', 'temperatura', 1001.0000, 'ºC'),
	(148345, 119, '2014-01-15 00:46:51.000000', 'temperatura', 632.0000, 'ºC'),
	(148346, 119, '2014-01-15 00:46:52.000000', 'temperatura', 158.0000, 'ºC'),
	(148347, 119, '2014-01-15 00:46:53.000000', 'temperatura', 92.0000, 'ºC'),
	(148348, 119, '2014-01-15 00:46:54.000000', 'temperatura', 1188.0000, 'ºC'),
	(148349, 119, '2014-01-15 00:46:55.000000', 'temperatura', 865.0000, 'ºC'),
	(148350, 119, '2014-01-15 00:46:56.000000', 'temperatura', 763.0000, 'ºC'),
	(148351, 119, '2014-01-15 00:46:57.000000', 'temperatura', 18.0000, 'ºC'),
	(148352, 119, '2014-01-15 00:46:58.000000', 'temperatura', 203.0000, 'ºC'),
	(148353, 119, '2014-01-15 00:46:59.000000', 'temperatura', 960.0000, 'ºC'),
	(148354, 119, '2014-01-15 00:47:00.000000', 'temperatura', 592.0000, 'ºC'),
	(148355, 119, '2014-01-15 00:47:01.000000', 'temperatura', 81.0000, 'ºC'),
	(148356, 119, '2014-01-15 00:47:02.000000', 'temperatura', 1030.0000, 'ºC'),
	(148357, 119, '2014-01-15 00:47:03.000000', 'temperatura', 105.0000, 'ºC'),
	(148358, 119, '2014-01-15 00:47:04.000000', 'temperatura', 1038.0000, 'ºC'),
	(148359, 119, '2014-01-15 00:47:05.000000', 'temperatura', 76.0000, 'ºC'),
	(148360, 119, '2014-01-15 00:47:06.000000', 'temperatura', 865.0000, 'ºC'),
	(148361, 119, '2014-01-15 00:47:07.000000', 'temperatura', 498.0000, 'ºC'),
	(148362, 119, '2014-01-15 00:47:08.000000', 'temperatura', 1097.0000, 'ºC'),
	(148363, 119, '2014-01-15 00:47:09.000000', 'temperatura', 388.0000, 'ºC'),
	(148364, 119, '2014-01-15 00:47:10.000000', 'temperatura', 1053.0000, 'ºC'),
	(148365, 119, '2014-01-15 00:47:11.000000', 'temperatura', 500.0000, 'ºC'),
	(148366, 119, '2014-01-15 00:47:12.000000', 'temperatura', 541.0000, 'ºC'),
	(148367, 119, '2014-01-15 00:47:13.000000', 'temperatura', 5.0000, 'ºC'),
	(148368, 119, '2014-01-15 00:47:14.000000', 'temperatura', 802.0000, 'ºC'),
	(148369, 119, '2014-01-15 00:47:15.000000', 'temperatura', 395.0000, 'ºC'),
	(148370, 119, '2014-01-15 00:47:16.000000', 'temperatura', 771.0000, 'ºC'),
	(148371, 119, '2014-01-15 00:47:17.000000', 'temperatura', 272.0000, 'ºC'),
	(148372, 119, '2014-01-15 00:47:18.000000', 'temperatura', 245.0000, 'ºC'),
	(148373, 119, '2014-01-15 00:47:19.000000', 'temperatura', 411.0000, 'ºC'),
	(148374, 119, '2014-01-15 00:47:20.000000', 'temperatura', 119.0000, 'ºC'),
	(148375, 119, '2014-01-15 00:47:21.000000', 'temperatura', 564.0000, 'ºC'),
	(148376, 119, '2014-01-15 00:47:22.000000', 'temperatura', 63.0000, 'ºC'),
	(148377, 119, '2014-01-15 00:47:23.000000', 'temperatura', 1025.0000, 'ºC'),
	(148378, 119, '2014-01-15 00:47:24.000000', 'temperatura', 134.0000, 'ºC'),
	(148379, 119, '2014-01-15 00:47:25.000000', 'temperatura', 1197.0000, 'ºC'),
	(148380, 119, '2014-01-15 00:47:26.000000', 'temperatura', 783.0000, 'ºC'),
	(148381, 119, '2014-01-15 00:47:27.000000', 'temperatura', 323.0000, 'ºC'),
	(148382, 119, '2014-01-15 00:47:28.000000', 'temperatura', 469.0000, 'ºC'),
	(148383, 119, '2014-01-15 00:47:29.000000', 'temperatura', 176.0000, 'ºC'),
	(148384, 119, '2014-01-15 00:47:30.000000', 'temperatura', 674.0000, 'ºC'),
	(148385, 119, '2014-01-15 00:47:31.000000', 'temperatura', 443.0000, 'ºC'),
	(148386, 119, '2014-01-15 00:47:32.000000', 'temperatura', 192.0000, 'ºC'),
	(148387, 119, '2014-01-15 00:47:33.000000', 'temperatura', 832.0000, 'ºC'),
	(148388, 119, '2014-01-15 00:47:34.000000', 'temperatura', 1186.0000, 'ºC'),
	(148389, 119, '2014-01-15 00:47:35.000000', 'temperatura', 1035.0000, 'ºC'),
	(148390, 119, '2014-01-15 00:47:36.000000', 'temperatura', 415.0000, 'ºC'),
	(148391, 119, '2014-01-15 00:47:37.000000', 'temperatura', 172.0000, 'ºC'),
	(148392, 119, '2014-01-15 00:47:38.000000', 'temperatura', 816.0000, 'ºC'),
	(148393, 119, '2014-01-15 00:47:39.000000', 'temperatura', 1163.0000, 'ºC'),
	(148394, 119, '2014-01-15 00:47:40.000000', 'temperatura', 970.0000, 'ºC'),
	(148395, 119, '2014-01-15 00:47:41.000000', 'temperatura', 158.0000, 'ºC'),
	(148396, 119, '2014-01-15 00:47:42.000000', 'temperatura', 283.0000, 'ºC'),
	(148397, 119, '2014-01-15 00:47:43.000000', 'temperatura', 940.0000, 'ºC'),
	(148398, 119, '2014-01-15 00:47:44.000000', 'temperatura', 253.0000, 'ºC'),
	(148399, 119, '2014-01-15 00:47:45.000000', 'temperatura', 847.0000, 'ºC'),
	(148400, 119, '2014-01-15 00:47:46.000000', 'temperatura', 1073.0000, 'ºC'),
	(148401, 119, '2014-01-15 00:47:47.000000', 'temperatura', 426.0000, 'ºC'),
	(148402, 119, '2014-01-15 00:47:48.000000', 'temperatura', 113.0000, 'ºC'),
	(148403, 119, '2014-01-15 00:47:49.000000', 'temperatura', 485.0000, 'ºC'),
	(148404, 119, '2014-01-15 00:47:50.000000', 'temperatura', 886.0000, 'ºC'),
	(148405, 119, '2014-01-15 00:47:51.000000', 'temperatura', 578.0000, 'ºC'),
	(148406, 119, '2014-01-15 00:47:52.000000', 'temperatura', 231.0000, 'ºC'),
	(148407, 119, '2014-01-15 00:47:53.000000', 'temperatura', 622.0000, 'ºC'),
	(148408, 119, '2014-01-15 00:47:54.000000', 'temperatura', 16.0000, 'ºC'),
	(148409, 119, '2014-01-15 00:47:55.000000', 'temperatura', 614.0000, 'ºC'),
	(148410, 119, '2014-01-15 00:47:56.000000', 'temperatura', 623.0000, 'ºC'),
	(148411, 119, '2014-01-15 00:47:57.000000', 'temperatura', 76.0000, 'ºC'),
	(148412, 119, '2014-01-15 00:47:58.000000', 'temperatura', 909.0000, 'ºC'),
	(148413, 119, '2014-01-15 00:47:59.000000', 'temperatura', 718.0000, 'ºC'),
	(148414, 119, '2014-01-15 00:48:00.000000', 'temperatura', 863.0000, 'ºC'),
	(148415, 119, '2014-01-15 00:48:01.000000', 'temperatura', 963.0000, 'ºC'),
	(148416, 119, '2014-01-15 00:48:02.000000', 'temperatura', 1027.0000, 'ºC'),
	(148417, 119, '2014-01-15 00:48:03.000000', 'temperatura', 1047.0000, 'ºC'),
	(148418, 119, '2014-01-15 00:48:04.000000', 'temperatura', 956.0000, 'ºC'),
	(148419, 119, '2014-01-15 00:48:05.000000', 'temperatura', 436.0000, 'ºC'),
	(148420, 119, '2014-01-15 00:48:06.000000', 'temperatura', 514.0000, 'ºC'),
	(148421, 119, '2014-01-15 00:48:07.000000', 'temperatura', 64.0000, 'ºC'),
	(148422, 119, '2014-01-15 00:48:08.000000', 'temperatura', 1179.0000, 'ºC'),
	(148423, 119, '2014-01-15 00:48:09.000000', 'temperatura', 902.0000, 'ºC'),
	(148424, 119, '2014-01-15 00:48:10.000000', 'temperatura', 974.0000, 'ºC'),
	(148425, 119, '2014-01-15 00:48:11.000000', 'temperatura', 963.0000, 'ºC'),
	(148426, 119, '2014-01-15 00:48:12.000000', 'temperatura', 695.0000, 'ºC'),
	(148427, 119, '2014-01-15 00:48:13.000000', 'temperatura', 587.0000, 'ºC'),
	(148428, 119, '2014-01-15 00:48:14.000000', 'temperatura', 850.0000, 'ºC'),
	(148429, 119, '2014-01-15 00:48:15.000000', 'temperatura', 91.0000, 'ºC'),
	(148430, 119, '2014-01-15 00:48:16.000000', 'temperatura', 306.0000, 'ºC'),
	(148431, 119, '2014-01-15 00:48:17.000000', 'temperatura', 57.0000, 'ºC'),
	(148432, 119, '2014-01-15 00:48:18.000000', 'temperatura', 567.0000, 'ºC'),
	(148433, 119, '2014-01-15 00:48:19.000000', 'temperatura', 265.0000, 'ºC'),
	(148434, 119, '2014-01-15 00:48:20.000000', 'temperatura', 825.0000, 'ºC'),
	(148435, 119, '2014-01-15 00:48:21.000000', 'temperatura', 931.0000, 'ºC'),
	(148436, 119, '2014-01-15 00:48:22.000000', 'temperatura', 979.0000, 'ºC'),
	(148437, 119, '2014-01-15 00:48:23.000000', 'temperatura', 903.0000, 'ºC'),
	(148438, 119, '2014-01-15 00:48:24.000000', 'temperatura', 377.0000, 'ºC'),
	(148439, 119, '2014-01-15 00:48:25.000000', 'temperatura', 378.0000, 'ºC'),
	(148440, 119, '2014-01-15 00:48:26.000000', 'temperatura', 760.0000, 'ºC'),
	(148441, 119, '2014-01-15 00:48:27.000000', 'temperatura', 264.0000, 'ºC'),
	(148442, 119, '2014-01-15 00:48:28.000000', 'temperatura', 244.0000, 'ºC'),
	(148443, 119, '2014-01-15 00:48:29.000000', 'temperatura', 425.0000, 'ºC'),
	(148444, 119, '2014-01-15 00:48:30.000000', 'temperatura', 195.0000, 'ºC'),
	(148445, 119, '2014-01-15 00:48:31.000000', 'temperatura', 899.0000, 'ºC'),
	(148446, 119, '2014-01-15 00:48:32.000000', 'temperatura', 310.0000, 'ºC'),
	(148447, 119, '2014-01-15 00:48:33.000000', 'temperatura', 56.0000, 'ºC'),
	(148448, 119, '2014-01-15 00:48:34.000000', 'temperatura', 551.0000, 'ºC'),
	(148449, 119, '2014-01-15 00:48:35.000000', 'temperatura', 186.0000, 'ºC'),
	(148450, 119, '2014-01-15 00:48:36.000000', 'temperatura', 476.0000, 'ºC'),
	(148451, 119, '2014-01-15 00:48:37.000000', 'temperatura', 625.0000, 'ºC'),
	(148452, 119, '2014-01-15 00:48:38.000000', 'temperatura', 498.0000, 'ºC'),
	(148453, 119, '2014-01-15 00:48:39.000000', 'temperatura', 613.0000, 'ºC'),
	(148454, 119, '2014-01-15 00:48:40.000000', 'temperatura', 372.0000, 'ºC'),
	(148455, 119, '2014-01-15 00:48:41.000000', 'temperatura', 21.0000, 'ºC'),
	(148456, 119, '2014-01-15 00:48:42.000000', 'temperatura', 192.0000, 'ºC'),
	(148457, 119, '2014-01-15 00:48:43.000000', 'temperatura', 896.0000, 'ºC'),
	(148458, 119, '2014-01-15 00:48:44.000000', 'temperatura', 306.0000, 'ºC'),
	(148459, 119, '2014-01-15 00:48:45.000000', 'temperatura', 41.0000, 'ºC'),
	(148460, 119, '2014-01-15 00:48:46.000000', 'temperatura', 487.0000, 'ºC'),
	(148461, 119, '2014-01-15 00:48:47.000000', 'temperatura', 1113.0000, 'ºC'),
	(148462, 119, '2014-01-15 00:48:48.000000', 'temperatura', 506.0000, 'ºC'),
	(148463, 119, '2014-01-15 00:48:49.000000', 'temperatura', 392.0000, 'ºC'),
	(148464, 119, '2014-01-15 00:48:50.000000', 'temperatura', 440.0000, 'ºC'),
	(148465, 119, '2014-01-15 00:48:51.000000', 'temperatura', 1027.0000, 'ºC'),
	(148466, 119, '2014-01-15 00:48:52.000000', 'temperatura', 213.0000, 'ºC'),
	(148467, 119, '2014-01-15 00:48:53.000000', 'temperatura', 386.0000, 'ºC'),
	(148468, 119, '2014-01-15 00:48:54.000000', 'temperatura', 90.0000, 'ºC'),
	(148469, 119, '2014-01-15 00:48:55.000000', 'temperatura', 495.0000, 'ºC'),
	(148470, 119, '2014-01-15 00:48:56.000000', 'temperatura', 1006.0000, 'ºC'),
	(148471, 119, '2014-01-15 00:48:57.000000', 'temperatura', 1146.0000, 'ºC'),
	(148472, 119, '2014-01-15 00:48:58.000000', 'temperatura', 310.0000, 'ºC'),
	(148473, 119, '2014-01-15 00:48:59.000000', 'temperatura', 511.0000, 'ºC'),
	(148474, 119, '2014-01-15 00:49:00.000000', 'temperatura', 429.0000, 'ºC'),
	(148475, 119, '2014-01-15 00:49:01.000000', 'temperatura', 612.0000, 'ºC'),
	(148476, 119, '2014-01-15 00:49:02.000000', 'temperatura', 572.0000, 'ºC'),
	(148477, 119, '2014-01-15 00:49:03.000000', 'temperatura', 1023.0000, 'ºC'),
	(148478, 119, '2014-01-15 00:49:04.000000', 'temperatura', 1002.0000, 'ºC'),
	(148479, 119, '2014-01-15 00:49:05.000000', 'temperatura', 742.0000, 'ºC'),
	(148480, 119, '2014-01-15 00:49:06.000000', 'temperatura', 702.0000, 'ºC'),
	(148481, 119, '2014-01-15 00:49:07.000000', 'temperatura', 85.0000, 'ºC'),
	(148482, 119, '2014-01-15 00:49:08.000000', 'temperatura', 718.0000, 'ºC'),
	(148483, 119, '2014-01-15 00:49:09.000000', 'temperatura', 936.0000, 'ºC'),
	(148484, 119, '2014-01-15 00:49:10.000000', 'temperatura', 128.0000, 'ºC'),
	(148485, 119, '2014-01-15 00:49:11.000000', 'temperatura', 230.0000, 'ºC'),
	(148486, 119, '2014-01-15 00:49:12.000000', 'temperatura', 768.0000, 'ºC'),
	(148487, 119, '2014-01-15 00:49:13.000000', 'temperatura', 752.0000, 'ºC'),
	(148488, 119, '2014-01-15 00:49:14.000000', 'temperatura', 254.0000, 'ºC'),
	(148489, 119, '2014-01-15 00:49:15.000000', 'temperatura', 215.0000, 'ºC'),
	(148490, 119, '2014-01-15 00:49:16.000000', 'temperatura', 313.0000, 'ºC'),
	(148491, 119, '2014-01-15 00:49:17.000000', 'temperatura', 922.0000, 'ºC'),
	(148492, 119, '2014-01-15 00:49:18.000000', 'temperatura', 73.0000, 'ºC'),
	(148493, 119, '2014-01-15 00:49:19.000000', 'temperatura', 1197.0000, 'ºC'),
	(148494, 119, '2014-01-15 00:49:20.000000', 'temperatura', 968.0000, 'ºC'),
	(148495, 119, '2014-01-15 00:49:21.000000', 'temperatura', 50.0000, 'ºC'),
	(148496, 119, '2014-01-15 00:49:22.000000', 'temperatura', 947.0000, 'ºC'),
	(148497, 119, '2014-01-15 00:49:23.000000', 'temperatura', 983.0000, 'ºC'),
	(148498, 119, '2014-01-15 00:49:24.000000', 'temperatura', 876.0000, 'ºC'),
	(148499, 119, '2014-01-15 00:49:25.000000', 'temperatura', 229.0000, 'ºC'),
	(148500, 119, '2014-01-15 00:49:26.000000', 'temperatura', 920.0000, 'ºC'),
	(148501, 119, '2014-01-15 00:49:27.000000', 'temperatura', 312.0000, 'ºC'),
	(148502, 119, '2014-01-15 00:49:28.000000', 'temperatura', 1.0000, 'ºC'),
	(148503, 119, '2014-01-15 00:49:29.000000', 'temperatura', 271.0000, 'ºC'),
	(148504, 119, '2014-01-15 00:49:30.000000', 'temperatura', 152.0000, 'ºC'),
	(148505, 119, '2014-01-15 00:49:31.000000', 'temperatura', 1147.0000, 'ºC'),
	(148506, 119, '2014-01-15 00:49:32.000000', 'temperatura', 481.0000, 'ºC'),
	(148507, 119, '2014-01-15 00:49:33.000000', 'temperatura', 165.0000, 'ºC'),
	(148508, 119, '2014-01-15 00:49:34.000000', 'temperatura', 582.0000, 'ºC'),
	(148509, 119, '2014-01-15 00:49:35.000000', 'temperatura', 17.0000, 'ºC'),
	(148510, 119, '2014-01-15 00:49:36.000000', 'temperatura', 738.0000, 'ºC'),
	(148511, 119, '2014-01-15 00:49:37.000000', 'temperatura', 40.0000, 'ºC'),
	(148512, 119, '2014-01-15 00:49:38.000000', 'temperatura', 388.0000, 'ºC'),
	(148513, 119, '2014-01-15 00:49:39.000000', 'temperatura', 620.0000, 'ºC'),
	(148514, 119, '2014-01-15 00:49:40.000000', 'temperatura', 738.0000, 'ºC'),
	(148515, 119, '2014-01-15 00:49:41.000000', 'temperatura', 629.0000, 'ºC'),
	(148516, 119, '2014-01-15 00:49:42.000000', 'temperatura', 931.0000, 'ºC'),
	(148517, 119, '2014-01-15 00:49:43.000000', 'temperatura', 369.0000, 'ºC'),
	(148518, 119, '2014-01-15 00:49:44.000000', 'temperatura', 253.0000, 'ºC'),
	(148519, 119, '2014-01-15 00:49:45.000000', 'temperatura', 157.0000, 'ºC'),
	(148520, 119, '2014-01-15 00:49:46.000000', 'temperatura', 29.0000, 'ºC'),
	(148521, 119, '2014-01-15 00:49:47.000000', 'temperatura', 872.0000, 'ºC'),
	(148522, 119, '2014-01-15 00:49:48.000000', 'temperatura', 672.0000, 'ºC'),
	(148523, 119, '2014-01-15 00:49:49.000000', 'temperatura', 748.0000, 'ºC'),
	(148524, 119, '2014-01-15 00:49:50.000000', 'temperatura', 522.0000, 'ºC'),
	(148525, 119, '2014-01-15 00:49:51.000000', 'temperatura', 369.0000, 'ºC'),
	(148526, 119, '2014-01-15 00:49:52.000000', 'temperatura', 277.0000, 'ºC'),
	(148527, 119, '2014-01-15 00:49:53.000000', 'temperatura', 281.0000, 'ºC'),
	(148528, 119, '2014-01-15 00:49:54.000000', 'temperatura', 575.0000, 'ºC'),
	(148529, 119, '2014-01-15 00:49:55.000000', 'temperatura', 830.0000, 'ºC'),
	(148530, 119, '2014-01-15 00:49:56.000000', 'temperatura', 28.0000, 'ºC'),
	(148531, 119, '2014-01-15 00:49:57.000000', 'temperatura', 48.0000, 'ºC'),
	(148532, 119, '2014-01-15 00:49:58.000000', 'temperatura', 158.0000, 'ºC'),
	(148533, 119, '2014-01-15 00:49:59.000000', 'temperatura', 647.0000, 'ºC'),
	(148534, 119, '2014-01-15 00:50:00.000000', 'temperatura', 359.0000, 'ºC'),
	(148535, 119, '2014-01-15 00:50:01.000000', 'temperatura', 1058.0000, 'ºC'),
	(148536, 119, '2014-01-15 00:50:02.000000', 'temperatura', 612.0000, 'ºC'),
	(148537, 119, '2014-01-15 00:50:03.000000', 'temperatura', 1086.0000, 'ºC'),
	(148538, 119, '2014-01-15 00:50:04.000000', 'temperatura', 1194.0000, 'ºC'),
	(148539, 119, '2014-01-15 00:50:05.000000', 'temperatura', 312.0000, 'ºC'),
	(148540, 119, '2014-01-15 00:50:06.000000', 'temperatura', 377.0000, 'ºC'),
	(148541, 119, '2014-01-15 00:50:07.000000', 'temperatura', 952.0000, 'ºC'),
	(148542, 119, '2014-01-15 00:50:08.000000', 'temperatura', 30.0000, 'ºC'),
	(148543, 119, '2014-01-15 00:50:09.000000', 'temperatura', 895.0000, 'ºC'),
	(148544, 119, '2014-01-15 00:50:10.000000', 'temperatura', 785.0000, 'ºC'),
	(148545, 119, '2014-01-15 00:50:11.000000', 'temperatura', 42.0000, 'ºC'),
	(148546, 119, '2014-01-15 00:50:12.000000', 'temperatura', 253.0000, 'ºC'),
	(148547, 119, '2014-01-15 00:50:13.000000', 'temperatura', 1140.0000, 'ºC'),
	(148548, 119, '2014-01-15 00:50:14.000000', 'temperatura', 140.0000, 'ºC'),
	(148549, 119, '2014-01-15 00:50:15.000000', 'temperatura', 882.0000, 'ºC'),
	(148550, 119, '2014-01-15 00:50:16.000000', 'temperatura', 391.0000, 'ºC'),
	(148551, 119, '2014-01-15 00:50:17.000000', 'temperatura', 510.0000, 'ºC'),
	(148552, 119, '2014-01-15 00:50:18.000000', 'temperatura', 176.0000, 'ºC'),
	(148553, 119, '2014-01-15 00:50:19.000000', 'temperatura', 550.0000, 'ºC'),
	(148554, 119, '2014-01-15 00:50:20.000000', 'temperatura', 1025.0000, 'ºC'),
	(148555, 119, '2014-01-15 00:50:21.000000', 'temperatura', 1076.0000, 'ºC'),
	(148556, 119, '2014-01-15 00:50:22.000000', 'temperatura', 1103.0000, 'ºC'),
	(148557, 119, '2014-01-15 00:50:23.000000', 'temperatura', 1087.0000, 'ºC'),
	(148558, 119, '2014-01-15 00:50:24.000000', 'temperatura', 929.0000, 'ºC'),
	(148559, 119, '2014-01-15 00:50:25.000000', 'temperatura', 185.0000, 'ºC'),
	(148560, 119, '2014-01-15 00:50:26.000000', 'temperatura', 537.0000, 'ºC'),
	(148561, 119, '2014-01-15 00:50:27.000000', 'temperatura', 929.0000, 'ºC'),
	(148562, 119, '2014-01-15 00:50:28.000000', 'temperatura', 637.0000, 'ºC'),
	(148563, 119, '2014-01-15 00:50:29.000000', 'temperatura', 396.0000, 'ºC'),
	(148564, 119, '2014-01-15 00:50:30.000000', 'temperatura', 70.0000, 'ºC'),
	(148565, 119, '2014-01-15 00:50:31.000000', 'temperatura', 363.0000, 'ºC'),
	(148566, 119, '2014-01-15 00:50:32.000000', 'temperatura', 405.0000, 'ºC'),
	(148567, 119, '2014-01-15 00:50:33.000000', 'temperatura', 935.0000, 'ºC'),
	(148568, 119, '2014-01-15 00:50:34.000000', 'temperatura', 1061.0000, 'ºC'),
	(148569, 119, '2014-01-15 00:50:35.000000', 'temperatura', 100.0000, 'ºC'),
	(148570, 119, '2014-01-15 00:50:36.000000', 'temperatura', 918.0000, 'ºC'),
	(148571, 119, '2014-01-15 00:50:37.000000', 'temperatura', 689.0000, 'ºC'),
	(148572, 119, '2014-01-15 00:50:38.000000', 'temperatura', 694.0000, 'ºC'),
	(148573, 119, '2014-01-15 00:50:39.000000', 'temperatura', 203.0000, 'ºC'),
	(148574, 119, '2014-01-15 00:50:40.000000', 'temperatura', 133.0000, 'ºC'),
	(148575, 119, '2014-01-15 00:50:41.000000', 'temperatura', 58.0000, 'ºC'),
	(148576, 119, '2014-01-15 00:50:42.000000', 'temperatura', 1092.0000, 'ºC'),
	(148577, 119, '2014-01-15 00:50:43.000000', 'temperatura', 485.0000, 'ºC'),
	(148578, 119, '2014-01-15 00:50:44.000000', 'temperatura', 350.0000, 'ºC'),
	(148579, 119, '2014-01-15 00:50:45.000000', 'temperatura', 296.0000, 'ºC'),
	(148580, 119, '2014-01-15 00:50:46.000000', 'temperatura', 431.0000, 'ºC'),
	(148581, 119, '2014-01-15 00:50:47.000000', 'temperatura', 65.0000, 'ºC'),
	(148582, 119, '2014-01-15 00:50:48.000000', 'temperatura', 233.0000, 'ºC'),
	(148583, 119, '2014-01-15 00:50:49.000000', 'temperatura', 970.0000, 'ºC'),
	(148584, 119, '2014-01-15 00:50:50.000000', 'temperatura', 551.0000, 'ºC'),
	(148585, 119, '2014-01-15 00:50:51.000000', 'temperatura', 1048.0000, 'ºC'),
	(148586, 119, '2014-01-15 00:50:52.000000', 'temperatura', 1188.0000, 'ºC'),
	(148587, 119, '2014-01-15 00:50:53.000000', 'temperatura', 397.0000, 'ºC'),
	(148588, 119, '2014-01-15 00:50:54.000000', 'temperatura', 819.0000, 'ºC'),
	(148589, 119, '2014-01-15 00:50:55.000000', 'temperatura', 505.0000, 'ºC'),
	(148590, 119, '2014-01-15 00:50:56.000000', 'temperatura', 70.0000, 'ºC'),
	(148591, 119, '2014-01-15 00:50:57.000000', 'temperatura', 35.0000, 'ºC'),
	(148592, 119, '2014-01-15 00:50:58.000000', 'temperatura', 1165.0000, 'ºC'),
	(148593, 119, '2014-01-15 00:50:59.000000', 'temperatura', 922.0000, 'ºC'),
	(148594, 119, '2014-01-15 00:51:00.000000', 'temperatura', 1117.0000, 'ºC'),
	(148595, 119, '2014-01-15 00:51:01.000000', 'temperatura', 416.0000, 'ºC'),
	(148596, 119, '2014-01-15 00:51:02.000000', 'temperatura', 1131.0000, 'ºC'),
	(148597, 119, '2014-01-15 00:51:03.000000', 'temperatura', 806.0000, 'ºC'),
	(148598, 119, '2014-01-15 00:51:04.000000', 'temperatura', 639.0000, 'ºC'),
	(148599, 119, '2014-01-15 00:51:05.000000', 'temperatura', 777.0000, 'ºC'),
	(148600, 119, '2014-01-15 00:51:06.000000', 'temperatura', 767.0000, 'ºC'),
	(148601, 119, '2014-01-15 00:51:07.000000', 'temperatura', 304.0000, 'ºC'),
	(148602, 119, '2014-01-15 00:51:08.000000', 'temperatura', 419.0000, 'ºC'),
	(148603, 119, '2014-01-15 00:51:09.000000', 'temperatura', 1187.0000, 'ºC'),
	(148604, 119, '2014-01-15 00:51:10.000000', 'temperatura', 1076.0000, 'ºC'),
	(148605, 119, '2014-01-15 00:51:11.000000', 'temperatura', 619.0000, 'ºC'),
	(148606, 119, '2014-01-15 00:51:12.000000', 'temperatura', 1067.0000, 'ºC'),
	(148607, 119, '2014-01-15 00:51:13.000000', 'temperatura', 1080.0000, 'ºC'),
	(148608, 119, '2014-01-15 00:51:14.000000', 'temperatura', 1001.0000, 'ºC'),
	(148609, 119, '2014-01-15 00:51:15.000000', 'temperatura', 564.0000, 'ºC'),
	(148610, 119, '2014-01-15 00:51:16.000000', 'temperatura', 1016.0000, 'ºC'),
	(148611, 119, '2014-01-15 00:51:17.000000', 'temperatura', 989.0000, 'ºC'),
	(148612, 119, '2014-01-15 00:51:18.000000', 'temperatura', 697.0000, 'ºC'),
	(148613, 119, '2014-01-15 00:51:19.000000', 'temperatura', 519.0000, 'ºC'),
	(148614, 119, '2014-01-15 00:51:20.000000', 'temperatura', 503.0000, 'ºC'),
	(148615, 119, '2014-01-15 00:51:21.000000', 'temperatura', 959.0000, 'ºC'),
	(148616, 119, '2014-01-15 00:51:22.000000', 'temperatura', 887.0000, 'ºC'),
	(148617, 119, '2014-01-15 00:51:23.000000', 'temperatura', 359.0000, 'ºC'),
	(148618, 119, '2014-01-15 00:51:24.000000', 'temperatura', 336.0000, 'ºC'),
	(148619, 119, '2014-01-15 00:51:25.000000', 'temperatura', 602.0000, 'ºC'),
	(148620, 119, '2014-01-15 00:51:26.000000', 'temperatura', 801.0000, 'ºC'),
	(148621, 119, '2014-01-15 00:51:27.000000', 'temperatura', 1001.0000, 'ºC'),
	(148622, 119, '2014-01-15 00:51:28.000000', 'temperatura', 204.0000, 'ºC'),
	(148623, 119, '2014-01-15 00:51:29.000000', 'temperatura', 414.0000, 'ºC'),
	(148624, 119, '2014-01-15 00:51:30.000000', 'temperatura', 261.0000, 'ºC'),
	(148625, 119, '2014-01-15 00:51:31.000000', 'temperatura', 65.0000, 'ºC'),
	(148626, 119, '2014-01-15 00:51:32.000000', 'temperatura', 739.0000, 'ºC'),
	(148627, 119, '2014-01-15 00:51:33.000000', 'temperatura', 1103.0000, 'ºC'),
	(148628, 119, '2014-01-15 00:51:34.000000', 'temperatura', 897.0000, 'ºC'),
	(148629, 119, '2014-01-15 00:51:35.000000', 'temperatura', 1176.0000, 'ºC'),
	(148630, 119, '2014-01-15 00:51:36.000000', 'temperatura', 790.0000, 'ºC'),
	(148631, 119, '2014-01-15 00:51:37.000000', 'temperatura', 422.0000, 'ºC'),
	(148632, 119, '2014-01-15 00:51:38.000000', 'temperatura', 939.0000, 'ºC'),
	(148633, 119, '2014-01-15 00:51:39.000000', 'temperatura', 1032.0000, 'ºC'),
	(148634, 119, '2014-01-15 00:51:40.000000', 'temperatura', 1143.0000, 'ºC'),
	(148635, 119, '2014-01-15 00:51:41.000000', 'temperatura', 221.0000, 'ºC'),
	(148636, 119, '2014-01-15 00:51:42.000000', 'temperatura', 74.0000, 'ºC'),
	(148637, 119, '2014-01-15 00:51:43.000000', 'temperatura', 907.0000, 'ºC'),
	(148638, 119, '2014-01-15 00:51:44.000000', 'temperatura', 716.0000, 'ºC'),
	(148639, 119, '2014-01-15 00:51:45.000000', 'temperatura', 860.0000, 'ºC'),
	(148640, 119, '2014-01-15 00:51:46.000000', 'temperatura', 953.0000, 'ºC'),
	(148641, 119, '2014-01-15 00:51:47.000000', 'temperatura', 985.0000, 'ºC'),
	(148642, 119, '2014-01-15 00:51:48.000000', 'temperatura', 866.0000, 'ºC'),
	(148643, 119, '2014-01-15 00:51:49.000000', 'temperatura', 175.0000, 'ºC'),
	(148644, 119, '2014-01-15 00:51:50.000000', 'temperatura', 678.0000, 'ºC'),
	(148645, 119, '2014-01-15 00:51:51.000000', 'temperatura', 465.0000, 'ºC'),
	(148646, 119, '2014-01-15 00:51:52.000000', 'temperatura', 292.0000, 'ºC'),
	(148647, 119, '2014-01-15 00:51:53.000000', 'temperatura', 66.0000, 'ºC'),
	(148648, 119, '2014-01-15 00:51:54.000000', 'temperatura', 653.0000, 'ºC'),
	(148649, 119, '2014-01-15 00:51:55.000000', 'temperatura', 668.0000, 'ºC'),
	(148650, 119, '2014-01-15 00:51:56.000000', 'temperatura', 181.0000, 'ºC'),
	(148651, 119, '2014-01-15 00:51:57.000000', 'temperatura', 104.0000, 'ºC'),
	(148652, 119, '2014-01-15 00:51:58.000000', 'temperatura', 1175.0000, 'ºC'),
	(148653, 119, '2014-01-15 00:51:59.000000', 'temperatura', 764.0000, 'ºC'),
	(148654, 119, '2014-01-15 00:52:00.000000', 'temperatura', 297.0000, 'ºC'),
	(148655, 119, '2014-01-15 00:52:01.000000', 'temperatura', 391.0000, 'ºC'),
	(148656, 119, '2014-01-15 00:52:02.000000', 'temperatura', 1066.0000, 'ºC'),
	(148657, 119, '2014-01-15 00:52:03.000000', 'temperatura', 558.0000, 'ºC'),
	(148658, 119, '2014-01-15 00:52:04.000000', 'temperatura', 793.0000, 'ºC'),
	(148659, 119, '2014-01-15 00:52:05.000000', 'temperatura', 1089.0000, 'ºC'),
	(148660, 119, '2014-01-15 00:52:06.000000', 'temperatura', 669.0000, 'ºC'),
	(148661, 119, '2014-01-15 00:52:07.000000', 'temperatura', 79.0000, 'ºC'),
	(148662, 119, '2014-01-15 00:52:08.000000', 'temperatura', 787.0000, 'ºC'),
	(148663, 119, '2014-01-15 00:52:09.000000', 'temperatura', 97.0000, 'ºC'),
	(148664, 119, '2014-01-15 00:52:10.000000', 'temperatura', 527.0000, 'ºC'),
	(148665, 119, '2014-01-15 00:52:11.000000', 'temperatura', 1142.0000, 'ºC'),
	(148666, 119, '2014-01-15 00:52:12.000000', 'temperatura', 532.0000, 'ºC'),
	(148667, 119, '2014-01-15 00:52:13.000000', 'temperatura', 433.0000, 'ºC'),
	(148668, 119, '2014-01-15 00:52:14.000000', 'temperatura', 568.0000, 'ºC'),
	(148669, 119, '2014-01-15 00:52:15.000000', 'temperatura', 343.0000, 'ºC'),
	(148670, 119, '2014-01-15 00:52:16.000000', 'temperatura', 11.0000, 'ºC'),
	(148671, 119, '2014-01-15 00:52:17.000000', 'temperatura', 227.0000, 'ºC'),
	(148672, 119, '2014-01-15 00:52:18.000000', 'temperatura', 1103.0000, 'ºC'),
	(148673, 119, '2014-01-15 00:52:19.000000', 'temperatura', 36.0000, 'ºC'),
	(148674, 119, '2014-01-15 00:52:20.000000', 'temperatura', 469.0000, 'ºC'),
	(148675, 119, '2014-01-15 00:52:21.000000', 'temperatura', 1037.0000, 'ºC'),
	(148676, 119, '2014-01-15 00:52:22.000000', 'temperatura', 179.0000, 'ºC'),
	(148677, 119, '2014-01-15 00:52:23.000000', 'temperatura', 186.0000, 'ºC'),
	(148678, 119, '2014-01-15 00:52:24.000000', 'temperatura', 392.0000, 'ºC'),
	(148679, 119, '2014-01-15 00:52:25.000000', 'temperatura', 202.0000, 'ºC'),
	(148680, 119, '2014-01-15 00:52:26.000000', 'temperatura', 1035.0000, 'ºC'),
	(148681, 119, '2014-01-15 00:52:27.000000', 'temperatura', 970.0000, 'ºC'),
	(148682, 119, '2014-01-15 00:52:28.000000', 'temperatura', 545.0000, 'ºC'),
	(148683, 119, '2014-01-15 00:52:29.000000', 'temperatura', 1014.0000, 'ºC'),
	(148684, 119, '2014-01-15 00:52:30.000000', 'temperatura', 1037.0000, 'ºC'),
	(148685, 119, '2014-01-15 00:52:31.000000', 'temperatura', 944.0000, 'ºC'),
	(148686, 119, '2014-01-15 00:52:32.000000', 'temperatura', 410.0000, 'ºC'),
	(148687, 119, '2014-01-15 00:52:33.000000', 'temperatura', 416.0000, 'ºC'),
	(148688, 119, '2014-01-15 00:52:34.000000', 'temperatura', 852.0000, 'ºC'),
	(148689, 119, '2014-01-15 00:52:35.000000', 'temperatura', 611.0000, 'ºC'),
	(148690, 119, '2014-01-15 00:52:36.000000', 'temperatura', 501.0000, 'ºC'),
	(148691, 119, '2014-01-15 00:52:37.000000', 'temperatura', 671.0000, 'ºC'),
	(148692, 119, '2014-01-15 00:52:38.000000', 'temperatura', 651.0000, 'ºC'),
	(148693, 119, '2014-01-15 00:52:39.000000', 'temperatura', 45.0000, 'ºC'),
	(148694, 119, '2014-01-15 00:52:40.000000', 'temperatura', 671.0000, 'ºC'),
	(148695, 119, '2014-01-15 00:52:41.000000', 'temperatura', 823.0000, 'ºC'),
	(148696, 119, '2014-01-15 00:52:42.000000', 'temperatura', 902.0000, 'ºC'),
	(148697, 119, '2014-01-15 00:52:43.000000', 'temperatura', 840.0000, 'ºC'),
	(148698, 119, '2014-01-15 00:52:44.000000', 'temperatura', 294.0000, 'ºC'),
	(148699, 119, '2014-01-15 00:52:45.000000', 'temperatura', 153.0000, 'ºC'),
	(148700, 119, '2014-01-15 00:52:46.000000', 'temperatura', 1084.0000, 'ºC'),
	(148701, 119, '2014-01-15 00:52:47.000000', 'temperatura', 160.0000, 'ºC'),
	(148702, 119, '2014-01-15 00:52:48.000000', 'temperatura', 1147.0000, 'ºC'),
	(148703, 119, '2014-01-15 00:52:49.000000', 'temperatura', 458.0000, 'ºC'),
	(148704, 119, '2014-01-15 00:52:50.000000', 'temperatura', 50.0000, 'ºC'),
	(148705, 119, '2014-01-15 00:52:51.000000', 'temperatura', 76.0000, 'ºC'),
	(148706, 119, '2014-01-15 00:52:52.000000', 'temperatura', 229.0000, 'ºC'),
	(148707, 119, '2014-01-15 00:52:53.000000', 'temperatura', 918.0000, 'ºC'),
	(148708, 119, '2014-01-15 00:52:54.000000', 'temperatura', 304.0000, 'ºC'),
	(148709, 119, '2014-01-15 00:52:55.000000', 'temperatura', 1165.0000, 'ºC'),
	(148710, 119, '2014-01-15 00:52:56.000000', 'temperatura', 113.0000, 'ºC'),
	(148711, 119, '2014-01-15 00:52:57.000000', 'temperatura', 670.0000, 'ºC'),
	(148712, 119, '2014-01-15 00:52:58.000000', 'temperatura', 611.0000, 'ºC'),
	(148713, 119, '2014-01-15 00:52:59.000000', 'temperatura', 1045.0000, 'ºC'),
	(148714, 119, '2014-01-15 00:53:00.000000', 'temperatura', 994.0000, 'ºC'),
	(148715, 119, '2014-01-15 00:53:01.000000', 'temperatura', 634.0000, 'ºC'),
	(148716, 119, '2014-01-15 00:53:02.000000', 'temperatura', 189.0000, 'ºC'),
	(148717, 119, '2014-01-15 00:53:03.000000', 'temperatura', 242.0000, 'ºC'),
	(148718, 119, '2014-01-15 00:53:04.000000', 'temperatura', 646.0000, 'ºC'),
	(148719, 119, '2014-01-15 00:53:05.000000', 'temperatura', 102.0000, 'ºC'),
	(148720, 119, '2014-01-15 00:53:06.000000', 'temperatura', 972.0000, 'ºC'),
	(148721, 119, '2014-01-15 00:53:07.000000', 'temperatura', 957.0000, 'ºC'),
	(148722, 119, '2014-01-15 00:53:08.000000', 'temperatura', 667.0000, 'ºC'),
	(148723, 119, '2014-01-15 00:53:09.000000', 'temperatura', 465.0000, 'ºC'),
	(148724, 119, '2014-01-15 00:53:10.000000', 'temperatura', 324.0000, 'ºC'),
	(148725, 119, '2014-01-15 00:53:11.000000', 'temperatura', 226.0000, 'ºC'),
	(148726, 119, '2014-01-15 00:53:12.000000', 'temperatura', 158.0000, 'ºC'),
	(148727, 119, '2014-01-15 00:53:13.000000', 'temperatura', 114.0000, 'ºC'),
	(148728, 119, '2014-01-15 00:53:14.000000', 'temperatura', 95.0000, 'ºC'),
	(148729, 119, '2014-01-15 00:53:15.000000', 'temperatura', 132.0000, 'ºC'),
	(148730, 119, '2014-01-15 00:53:16.000000', 'temperatura', 377.0000, 'ºC'),
	(148731, 119, '2014-01-15 00:53:17.000000', 'temperatura', 291.0000, 'ºC'),
	(148732, 119, '2014-01-15 00:53:18.000000', 'temperatura', 325.0000, 'ºC'),
	(148733, 119, '2014-01-15 00:53:19.000000', 'temperatura', 749.0000, 'ºC'),
	(148734, 119, '2014-01-15 00:53:20.000000', 'temperatura', 374.0000, 'ºC'),
	(148735, 119, '2014-01-15 00:53:21.000000', 'temperatura', 822.0000, 'ºC'),
	(148736, 119, '2014-01-15 00:53:22.000000', 'temperatura', 588.0000, 'ºC'),
	(148737, 119, '2014-01-15 00:53:23.000000', 'temperatura', 475.0000, 'ºC'),
	(148738, 119, '2014-01-15 00:53:24.000000', 'temperatura', 613.0000, 'ºC'),
	(148739, 119, '2014-01-15 00:53:25.000000', 'temperatura', 438.0000, 'ºC'),
	(148740, 119, '2014-01-15 00:53:26.000000', 'temperatura', 351.0000, 'ºC'),
	(148741, 119, '2014-01-15 00:53:27.000000', 'temperatura', 443.0000, 'ºC'),
	(148742, 119, '2014-01-15 00:53:28.000000', 'temperatura', 1163.0000, 'ºC'),
	(148743, 119, '2014-01-15 00:53:29.000000', 'temperatura', 885.0000, 'ºC'),
	(148744, 119, '2014-01-15 00:53:30.000000', 'temperatura', 939.0000, 'ºC'),
	(148745, 119, '2014-01-15 00:53:31.000000', 'temperatura', 837.0000, 'ºC'),
	(148746, 119, '2014-01-15 00:53:32.000000', 'temperatura', 171.0000, 'ºC'),
	(148747, 119, '2014-01-15 00:53:33.000000', 'temperatura', 746.0000, 'ºC'),
	(148748, 119, '2014-01-15 00:53:34.000000', 'temperatura', 815.0000, 'ºC'),
	(148749, 119, '2014-01-15 00:53:35.000000', 'temperatura', 640.0000, 'ºC'),
	(148750, 119, '2014-01-15 00:53:36.000000', 'temperatura', 754.0000, 'ºC'),
	(148751, 119, '2014-01-15 00:53:37.000000', 'temperatura', 653.0000, 'ºC'),
	(148752, 119, '2014-01-15 00:53:38.000000', 'temperatura', 1001.0000, 'ºC'),
	(148753, 119, '2014-01-15 00:53:39.000000', 'temperatura', 646.0000, 'ºC'),
	(148754, 119, '2014-01-15 00:53:40.000000', 'temperatura', 230.0000, 'ºC'),
	(148755, 119, '2014-01-15 00:53:41.000000', 'temperatura', 412.0000, 'ºC'),
	(148756, 119, '2014-01-15 00:53:42.000000', 'temperatura', 170.0000, 'ºC'),
	(148757, 119, '2014-01-15 00:53:43.000000', 'temperatura', 816.0000, 'ºC'),
	(148758, 119, '2014-01-15 00:53:44.000000', 'temperatura', 1170.0000, 'ºC'),
	(148759, 119, '2014-01-15 00:53:45.000000', 'temperatura', 1004.0000, 'ºC'),
	(148760, 119, '2014-01-15 00:53:46.000000', 'temperatura', 309.0000, 'ºC'),
	(148761, 119, '2014-01-15 00:53:47.000000', 'temperatura', 932.0000, 'ºC'),
	(148762, 119, '2014-01-15 00:53:48.000000', 'temperatura', 133.0000, 'ºC'),
	(148763, 119, '2014-01-15 00:53:49.000000', 'temperatura', 273.0000, 'ºC'),
	(148764, 119, '2014-01-15 00:53:50.000000', 'temperatura', 963.0000, 'ºC'),
	(148765, 119, '2014-01-15 00:53:51.000000', 'temperatura', 399.0000, 'ºC'),
	(148766, 119, '2014-01-15 00:53:52.000000', 'temperatura', 304.0000, 'ºC'),
	(148767, 119, '2014-01-15 00:53:53.000000', 'temperatura', 325.0000, 'ºC'),
	(148768, 119, '2014-01-15 00:53:54.000000', 'temperatura', 712.0000, 'ºC'),
	(148769, 119, '2014-01-15 00:53:55.000000', 'temperatura', 185.0000, 'ºC'),
	(148770, 119, '2014-01-15 00:53:56.000000', 'temperatura', 1191.0000, 'ºC'),
	(148771, 119, '2014-01-15 00:53:57.000000', 'temperatura', 599.0000, 'ºC'),
	(148772, 119, '2014-01-15 00:53:58.000000', 'temperatura', 624.0000, 'ºC'),
	(148773, 119, '2014-01-15 00:53:59.000000', 'temperatura', 123.0000, 'ºC'),
	(148774, 119, '2014-01-15 00:54:00.000000', 'temperatura', 1142.0000, 'ºC'),
	(148775, 119, '2014-01-15 00:54:01.000000', 'temperatura', 544.0000, 'ºC'),
	(148776, 119, '2014-01-15 00:54:02.000000', 'temperatura', 494.0000, 'ºC'),
	(148777, 119, '2014-01-15 00:54:03.000000', 'temperatura', 838.0000, 'ºC'),
	(148778, 119, '2014-01-15 00:54:04.000000', 'temperatura', 306.0000, 'ºC'),
	(148779, 119, '2014-01-15 00:54:05.000000', 'temperatura', 220.0000, 'ºC'),
	(148780, 119, '2014-01-15 00:54:06.000000', 'temperatura', 182.0000, 'ºC'),
	(148781, 119, '2014-01-15 00:54:07.000000', 'temperatura', 252.0000, 'ºC'),
	(148782, 119, '2014-01-15 00:54:08.000000', 'temperatura', 712.0000, 'ºC'),
	(148783, 119, '2014-01-15 00:54:09.000000', 'temperatura', 405.0000, 'ºC'),
	(148784, 119, '2014-01-15 00:54:10.000000', 'temperatura', 1088.0000, 'ºC'),
	(148785, 119, '2014-01-15 00:54:11.000000', 'temperatura', 628.0000, 'ºC'),
	(148786, 119, '2014-01-15 00:54:12.000000', 'temperatura', 1077.0000, 'ºC'),
	(148787, 119, '2014-01-15 00:54:13.000000', 'temperatura', 1101.0000, 'ºC'),
	(148788, 119, '2014-01-15 00:54:14.000000', 'temperatura', 1075.0000, 'ºC'),
	(148789, 119, '2014-01-15 00:54:15.000000', 'temperatura', 873.0000, 'ºC'),
	(148790, 119, '2014-01-15 00:54:16.000000', 'temperatura', 1139.0000, 'ºC'),
	(148791, 119, '2014-01-15 00:54:17.000000', 'temperatura', 678.0000, 'ºC'),
	(148792, 119, '2014-01-15 00:54:18.000000', 'temperatura', 1173.0000, 'ºC'),
	(148793, 119, '2014-01-15 00:54:19.000000', 'temperatura', 232.0000, 'ºC'),
	(148794, 119, '2014-01-15 00:54:20.000000', 'temperatura', 41.0000, 'ºC'),
	(148795, 119, '2014-01-15 00:54:21.000000', 'temperatura', 711.0000, 'ºC'),
	(148796, 119, '2014-01-15 00:54:22.000000', 'temperatura', 1033.0000, 'ºC'),
	(148797, 119, '2014-01-15 00:54:23.000000', 'temperatura', 633.0000, 'ºC'),
	(148798, 119, '2014-01-15 00:54:24.000000', 'temperatura', 67.0000, 'ºC'),
	(148799, 119, '2014-01-15 00:54:25.000000', 'temperatura', 835.0000, 'ºC'),
	(148800, 119, '2014-01-15 00:54:26.000000', 'temperatura', 374.0000, 'ºC'),
	(148801, 119, '2014-01-15 00:54:27.000000', 'temperatura', 568.0000, 'ºC'),
	(148802, 119, '2014-01-15 00:54:28.000000', 'temperatura', 516.0000, 'ºC'),
	(148803, 119, '2014-01-15 00:54:29.000000', 'temperatura', 877.0000, 'ºC'),
	(148804, 119, '2014-01-15 00:54:30.000000', 'temperatura', 439.0000, 'ºC'),
	(148805, 119, '2014-01-15 00:54:31.000000', 'temperatura', 764.0000, 'ºC'),
	(148806, 119, '2014-01-15 00:54:32.000000', 'temperatura', 105.0000, 'ºC'),
	(148807, 119, '2014-01-15 00:54:33.000000', 'temperatura', 631.0000, 'ºC'),
	(148808, 119, '2014-01-15 00:54:34.000000', 'temperatura', 442.0000, 'ºC'),
	(148809, 119, '2014-01-15 00:54:35.000000', 'temperatura', 316.0000, 'ºC'),
	(148810, 119, '2014-01-15 00:54:36.000000', 'temperatura', 257.0000, 'ºC'),
	(148811, 119, '2014-01-15 00:54:37.000000', 'temperatura', 337.0000, 'ºC'),
	(148812, 119, '2014-01-15 00:54:38.000000', 'temperatura', 914.0000, 'ºC'),
	(148813, 119, '2014-01-15 00:54:39.000000', 'temperatura', 1159.0000, 'ºC'),
	(148814, 119, '2014-01-15 00:54:40.000000', 'temperatura', 653.0000, 'ºC'),
	(148815, 119, '2014-01-15 00:54:41.000000', 'temperatura', 990.0000, 'ºC'),
	(148816, 119, '2014-01-15 00:54:42.000000', 'temperatura', 589.0000, 'ºC'),
	(148817, 119, '2014-01-15 00:54:43.000000', 'temperatura', 1179.0000, 'ºC'),
	(148818, 119, '2014-01-15 00:54:44.000000', 'temperatura', 526.0000, 'ºC'),
	(148819, 119, '2014-01-15 00:54:45.000000', 'temperatura', 294.0000, 'ºC'),
	(148820, 119, '2014-01-15 00:54:46.000000', 'temperatura', 1091.0000, 'ºC'),
	(148821, 119, '2014-01-15 00:54:47.000000', 'temperatura', 975.0000, 'ºC'),
	(148822, 119, '2014-01-15 00:54:48.000000', 'temperatura', 401.0000, 'ºC'),
	(148823, 119, '2014-01-15 00:54:49.000000', 'temperatura', 280.0000, 'ºC'),
	(148824, 119, '2014-01-15 00:54:50.000000', 'temperatura', 199.0000, 'ºC'),
	(148825, 119, '2014-01-15 00:54:51.000000', 'temperatura', 155.0000, 'ºC'),
	(148826, 119, '2014-01-15 00:54:52.000000', 'temperatura', 180.0000, 'ºC'),
	(148827, 119, '2014-01-15 00:54:53.000000', 'temperatura', 434.0000, 'ºC'),
	(148828, 119, '2014-01-15 00:54:54.000000', 'temperatura', 432.0000, 'ºC'),
	(148829, 119, '2014-01-15 00:54:55.000000', 'temperatura', 857.0000, 'ºC'),
	(148830, 119, '2014-01-15 00:54:56.000000', 'temperatura', 591.0000, 'ºC'),
	(148831, 119, '2014-01-15 00:54:57.000000', 'temperatura', 384.0000, 'ºC'),
	(148832, 119, '2014-01-15 00:54:58.000000', 'temperatura', 145.0000, 'ºC'),
	(148833, 119, '2014-01-15 00:54:59.000000', 'temperatura', 776.0000, 'ºC'),
	(148834, 119, '2014-01-15 00:55:00.000000', 'temperatura', 1047.0000, 'ºC'),
	(148835, 119, '2014-01-15 00:55:01.000000', 'temperatura', 505.0000, 'ºC'),
	(148836, 119, '2014-01-15 00:55:02.000000', 'temperatura', 584.0000, 'ºC'),
	(148837, 119, '2014-01-15 00:55:03.000000', 'temperatura', 208.0000, 'ºC'),
	(148838, 119, '2014-01-15 00:55:04.000000', 'temperatura', 486.0000, 'ºC'),
	(148839, 119, '2014-01-15 00:55:05.000000', 'temperatura', 606.0000, 'ºC'),
	(148840, 119, '2014-01-15 00:55:06.000000', 'temperatura', 373.0000, 'ºC'),
	(148841, 119, '2014-01-15 00:55:07.000000', 'temperatura', 50.0000, 'ºC'),
	(148842, 119, '2014-01-15 00:55:08.000000', 'temperatura', 329.0000, 'ºC'),
	(148843, 119, '2014-01-15 00:55:09.000000', 'temperatura', 296.0000, 'ºC'),
	(148844, 119, '2014-01-15 00:55:10.000000', 'temperatura', 494.0000, 'ºC'),
	(148845, 119, '2014-01-15 00:55:11.000000', 'temperatura', 384.0000, 'ºC'),
	(148846, 119, '2014-01-15 00:55:12.000000', 'temperatura', 436.0000, 'ºC'),
	(148847, 119, '2014-01-15 00:55:13.000000', 'temperatura', 1030.0000, 'ºC'),
	(148848, 119, '2014-01-15 00:55:14.000000', 'temperatura', 241.0000, 'ºC'),
	(148849, 119, '2014-01-15 00:55:15.000000', 'temperatura', 516.0000, 'ºC'),
	(148850, 119, '2014-01-15 00:55:16.000000', 'temperatura', 656.0000, 'ºC'),
	(148851, 119, '2014-01-15 00:55:17.000000', 'temperatura', 535.0000, 'ºC'),
	(148852, 119, '2014-01-15 00:55:18.000000', 'temperatura', 706.0000, 'ºC'),
	(148853, 119, '2014-01-15 00:55:19.000000', 'temperatura', 726.0000, 'ºC'),
	(148854, 119, '2014-01-15 00:55:20.000000', 'temperatura', 314.0000, 'ºC'),
	(148855, 119, '2014-01-15 00:55:21.000000', 'temperatura', 592.0000, 'ºC'),
	(148856, 119, '2014-01-15 00:55:22.000000', 'temperatura', 819.0000, 'ºC'),
	(148857, 119, '2014-01-15 00:55:23.000000', 'temperatura', 1120.0000, 'ºC'),
	(148858, 119, '2014-01-15 00:55:24.000000', 'temperatura', 745.0000, 'ºC'),
	(148859, 119, '2014-01-15 00:55:25.000000', 'temperatura', 362.0000, 'ºC'),
	(148860, 119, '2014-01-15 00:55:26.000000', 'temperatura', 777.0000, 'ºC'),
	(148861, 119, '2014-01-15 00:55:27.000000', 'temperatura', 398.0000, 'ºC'),
	(148862, 119, '2014-01-15 00:55:28.000000', 'temperatura', 860.0000, 'ºC'),
	(148863, 119, '2014-01-15 00:55:29.000000', 'temperatura', 707.0000, 'ºC'),
	(148864, 119, '2014-01-15 00:55:30.000000', 'temperatura', 955.0000, 'ºC'),
	(148865, 119, '2014-01-15 00:55:31.000000', 'temperatura', 254.0000, 'ºC'),
	(148866, 119, '2014-01-15 00:55:32.000000', 'temperatura', 807.0000, 'ºC'),
	(148867, 119, '2014-01-15 00:55:33.000000', 'temperatura', 875.0000, 'ºC'),
	(148868, 119, '2014-01-15 00:55:34.000000', 'temperatura', 753.0000, 'ºC'),
	(148869, 119, '2014-01-15 00:55:35.000000', 'temperatura', 1139.0000, 'ºC'),
	(148870, 119, '2014-01-15 00:55:36.000000', 'temperatura', 1036.0000, 'ºC'),
	(148871, 119, '2014-01-15 00:55:37.000000', 'temperatura', 565.0000, 'ºC'),
	(148872, 119, '2014-01-15 00:55:38.000000', 'temperatura', 916.0000, 'ºC'),
	(148873, 119, '2014-01-15 00:55:39.000000', 'temperatura', 486.0000, 'ºC'),
	(148874, 119, '2014-01-15 00:55:40.000000', 'temperatura', 884.0000, 'ºC'),
	(148875, 119, '2014-01-15 00:55:41.000000', 'temperatura', 564.0000, 'ºC'),
	(148876, 119, '2014-01-15 00:55:42.000000', 'temperatura', 165.0000, 'ºC'),
	(148877, 119, '2014-01-15 00:55:43.000000', 'temperatura', 334.0000, 'ºC'),
	(148878, 119, '2014-01-15 00:55:44.000000', 'temperatura', 1177.0000, 'ºC'),
	(148879, 119, '2014-01-15 00:55:45.000000', 'temperatura', 84.0000, 'ºC'),
	(148880, 119, '2014-01-15 00:55:46.000000', 'temperatura', 490.0000, 'ºC'),
	(148881, 119, '2014-01-15 00:55:47.000000', 'temperatura', 999.0000, 'ºC'),
	(148882, 119, '2014-01-15 00:55:48.000000', 'temperatura', 1126.0000, 'ºC'),
	(148883, 119, '2014-01-15 00:55:49.000000', 'temperatura', 232.0000, 'ºC'),
	(148884, 119, '2014-01-15 00:55:50.000000', 'temperatura', 183.0000, 'ºC'),
	(148885, 119, '2014-01-15 00:55:51.000000', 'temperatura', 218.0000, 'ºC'),
	(148886, 119, '2014-01-15 00:55:52.000000', 'temperatura', 544.0000, 'ºC'),
	(148887, 119, '2014-01-15 00:55:53.000000', 'temperatura', 866.0000, 'ºC'),
	(148888, 119, '2014-01-15 00:55:54.000000', 'temperatura', 297.0000, 'ºC'),
	(148889, 119, '2014-01-15 00:55:55.000000', 'temperatura', 89.0000, 'ºC'),
	(148890, 119, '2014-01-15 00:55:56.000000', 'temperatura', 755.0000, 'ºC'),
	(148891, 119, '2014-01-15 00:55:57.000000', 'temperatura', 1109.0000, 'ºC'),
	(148892, 119, '2014-01-15 00:55:58.000000', 'temperatura', 878.0000, 'ºC'),
	(148893, 119, '2014-01-15 00:55:59.000000', 'temperatura', 1065.0000, 'ºC'),
	(148894, 119, '2014-01-15 00:56:00.000000', 'temperatura', 293.0000, 'ºC'),
	(148895, 119, '2014-01-15 00:56:01.000000', 'temperatura', 671.0000, 'ºC'),
	(148896, 119, '2014-01-15 00:56:02.000000', 'temperatura', 74.0000, 'ºC'),
	(148897, 119, '2014-01-15 00:56:03.000000', 'temperatura', 757.0000, 'ºC'),
	(148898, 119, '2014-01-15 00:56:04.000000', 'temperatura', 1164.0000, 'ºC'),
	(148899, 119, '2014-01-15 00:56:05.000000', 'temperatura', 1151.0000, 'ºC'),
	(148900, 119, '2014-01-15 00:56:06.000000', 'temperatura', 1061.0000, 'ºC'),
	(148901, 119, '2014-01-15 00:56:07.000000', 'temperatura', 654.0000, 'ºC'),
	(148902, 119, '2014-01-15 00:56:08.000000', 'temperatura', 89.0000, 'ºC'),
	(148903, 119, '2014-01-15 00:56:09.000000', 'temperatura', 882.0000, 'ºC'),
	(148904, 119, '2014-01-15 00:56:10.000000', 'temperatura', 545.0000, 'ºC'),
	(148905, 119, '2014-01-15 00:56:11.000000', 'temperatura', 80.0000, 'ºC'),
	(148906, 119, '2014-01-15 00:56:12.000000', 'temperatura', 1163.0000, 'ºC'),
	(148907, 119, '2014-01-15 00:56:13.000000', 'temperatura', 779.0000, 'ºC'),
	(148908, 119, '2014-01-15 00:56:14.000000', 'temperatura', 403.0000, 'ºC'),
	(148909, 119, '2014-01-15 00:56:15.000000', 'temperatura', 880.0000, 'ºC'),
	(148910, 119, '2014-01-15 00:56:16.000000', 'temperatura', 792.0000, 'ºC'),
	(148911, 119, '2014-01-15 00:56:17.000000', 'temperatura', 119.0000, 'ºC'),
	(148912, 119, '2014-01-15 00:56:18.000000', 'temperatura', 618.0000, 'ºC'),
	(148913, 119, '2014-01-15 00:56:19.000000', 'temperatura', 337.0000, 'ºC'),
	(148914, 119, '2014-01-15 00:56:20.000000', 'temperatura', 1031.0000, 'ºC'),
	(148915, 119, '2014-01-15 00:56:21.000000', 'temperatura', 543.0000, 'ºC'),
	(148916, 119, '2014-01-15 00:56:22.000000', 'temperatura', 825.0000, 'ºC'),
	(148917, 119, '2014-01-15 00:56:23.000000', 'temperatura', 96.0000, 'ºC'),
	(148918, 119, '2014-01-15 00:56:24.000000', 'temperatura', 406.0000, 'ºC'),
	(148919, 119, '2014-01-15 00:56:25.000000', 'temperatura', 544.0000, 'ºC'),
	(148920, 119, '2014-01-15 00:56:26.000000', 'temperatura', 299.0000, 'ºC'),
	(148921, 119, '2014-01-15 00:56:27.000000', 'temperatura', 1066.0000, 'ºC'),
	(148922, 119, '2014-01-15 00:56:28.000000', 'temperatura', 835.0000, 'ºC'),
	(148923, 119, '2014-01-15 00:56:29.000000', 'temperatura', 974.0000, 'ºC'),
	(148924, 119, '2014-01-15 00:56:30.000000', 'temperatura', 1166.0000, 'ºC'),
	(148925, 119, '2014-01-15 00:56:31.000000', 'temperatura', 510.0000, 'ºC'),
	(148926, 119, '2014-01-15 00:56:32.000000', 'temperatura', 252.0000, 'ºC'),
	(148927, 119, '2014-01-15 00:56:33.000000', 'temperatura', 932.0000, 'ºC'),
	(148928, 119, '2014-01-15 00:56:34.000000', 'temperatura', 303.0000, 'ºC'),
	(148929, 119, '2014-01-15 00:56:35.000000', 'temperatura', 1118.0000, 'ºC'),
	(148930, 119, '2014-01-15 00:56:36.000000', 'temperatura', 1083.0000, 'ºC'),
	(148931, 119, '2014-01-15 00:56:37.000000', 'temperatura', 862.0000, 'ºC'),
	(148932, 119, '2014-01-15 00:56:38.000000', 'temperatura', 1059.0000, 'ºC'),
	(148933, 119, '2014-01-15 00:56:39.000000', 'temperatura', 312.0000, 'ºC'),
	(148934, 119, '2014-01-15 00:56:40.000000', 'temperatura', 785.0000, 'ºC'),
	(148935, 119, '2014-01-15 00:56:41.000000', 'temperatura', 587.0000, 'ºC'),
	(148936, 119, '2014-01-15 00:56:42.000000', 'temperatura', 581.0000, 'ºC'),
	(148937, 119, '2014-01-15 00:56:43.000000', 'temperatura', 1143.0000, 'ºC'),
	(148938, 119, '2014-01-15 00:56:44.000000', 'temperatura', 376.0000, 'ºC'),
	(148939, 119, '2014-01-15 00:56:45.000000', 'temperatura', 849.0000, 'ºC'),
	(148940, 119, '2014-01-15 00:56:46.000000', 'temperatura', 716.0000, 'ºC'),
	(148941, 119, '2014-01-15 00:56:47.000000', 'temperatura', 1036.0000, 'ºC'),
	(148942, 119, '2014-01-15 00:56:48.000000', 'temperatura', 633.0000, 'ºC'),
	(148943, 119, '2014-01-15 00:56:49.000000', 'temperatura', 55.0000, 'ºC'),
	(148944, 119, '2014-01-15 00:56:50.000000', 'temperatura', 779.0000, 'ºC'),
	(148945, 119, '2014-01-15 00:56:51.000000', 'temperatura', 129.0000, 'ºC'),
	(148946, 119, '2014-01-15 00:56:52.000000', 'temperatura', 707.0000, 'ºC'),
	(148947, 119, '2014-01-15 00:56:53.000000', 'temperatura', 751.0000, 'ºC'),
	(148948, 119, '2014-01-15 00:56:54.000000', 'temperatura', 433.0000, 'ºC'),
	(148949, 119, '2014-01-15 00:56:55.000000', 'temperatura', 1114.0000, 'ºC'),
	(148950, 119, '2014-01-15 00:56:56.000000', 'temperatura', 673.0000, 'ºC'),
	(148951, 119, '2014-01-15 00:56:57.000000', 'temperatura', 21.0000, 'ºC'),
	(148952, 119, '2014-01-15 00:56:58.000000', 'temperatura', 487.0000, 'ºC'),
	(148953, 119, '2014-01-15 00:56:59.000000', 'temperatura', 1174.0000, 'ºC'),
	(148954, 119, '2014-01-15 00:57:00.000000', 'temperatura', 808.0000, 'ºC'),
	(148955, 119, '2014-01-15 00:57:01.000000', 'temperatura', 519.0000, 'ºC'),
	(148956, 119, '2014-01-15 00:57:02.000000', 'temperatura', 170.0000, 'ºC'),
	(148957, 119, '2014-01-15 00:57:03.000000', 'temperatura', 495.0000, 'ºC'),
	(148958, 119, '2014-01-15 00:57:04.000000', 'temperatura', 766.0000, 'ºC'),
	(148959, 119, '2014-01-15 00:57:05.000000', 'temperatura', 1147.0000, 'ºC'),
	(148960, 119, '2014-01-15 00:57:06.000000', 'temperatura', 1035.0000, 'ºC'),
	(148961, 119, '2014-01-15 00:57:07.000000', 'temperatura', 536.0000, 'ºC'),
	(148962, 119, '2014-01-15 00:57:08.000000', 'temperatura', 775.0000, 'ºC'),
	(148963, 119, '2014-01-15 00:57:09.000000', 'temperatura', 1067.0000, 'ºC'),
	(148964, 119, '2014-01-15 00:57:10.000000', 'temperatura', 612.0000, 'ºC'),
	(148965, 119, '2014-01-15 00:57:11.000000', 'temperatura', 1059.0000, 'ºC'),
	(148966, 119, '2014-01-15 00:57:12.000000', 'temperatura', 1057.0000, 'ºC'),
	(148967, 119, '2014-01-15 00:57:13.000000', 'temperatura', 911.0000, 'ºC'),
	(148968, 119, '2014-01-15 00:57:14.000000', 'temperatura', 182.0000, 'ºC'),
	(148969, 119, '2014-01-15 00:57:15.000000', 'temperatura', 581.0000, 'ºC'),
	(148970, 119, '2014-01-15 00:57:16.000000', 'temperatura', 1158.0000, 'ºC'),
	(148971, 119, '2014-01-15 00:57:17.000000', 'temperatura', 445.0000, 'ºC'),
	(148972, 119, '2014-01-15 00:57:18.000000', 'temperatura', 1155.0000, 'ºC'),
	(148973, 119, '2014-01-15 00:57:19.000000', 'temperatura', 838.0000, 'ºC'),
	(148974, 119, '2014-01-15 00:57:20.000000', 'temperatura', 726.0000, 'ºC'),
	(148975, 119, '2014-01-15 00:57:21.000000', 'temperatura', 1115.0000, 'ºC'),
	(148976, 119, '2014-01-15 00:57:22.000000', 'temperatura', 1000.0000, 'ºC'),
	(148977, 119, '2014-01-15 00:57:23.000000', 'temperatura', 454.0000, 'ºC'),
	(148978, 119, '2014-01-15 00:57:24.000000', 'temperatura', 471.0000, 'ºC'),
	(148979, 119, '2014-01-15 00:57:25.000000', 'temperatura', 992.0000, 'ºC'),
	(148980, 119, '2014-01-15 00:57:26.000000', 'temperatura', 1149.0000, 'ºC'),
	(148981, 119, '2014-01-15 00:57:27.000000', 'temperatura', 371.0000, 'ºC'),
	(148982, 119, '2014-01-15 00:57:28.000000', 'temperatura', 806.0000, 'ºC'),
	(148983, 119, '2014-01-15 00:57:29.000000', 'temperatura', 519.0000, 'ºC'),
	(148984, 119, '2014-01-15 00:57:30.000000', 'temperatura', 176.0000, 'ºC'),
	(148985, 119, '2014-01-15 00:57:31.000000', 'temperatura', 522.0000, 'ºC'),
	(148986, 119, '2014-01-15 00:57:32.000000', 'temperatura', 885.0000, 'ºC'),
	(148987, 119, '2014-01-15 00:57:33.000000', 'temperatura', 459.0000, 'ºC'),
	(148988, 119, '2014-01-15 00:57:34.000000', 'temperatura', 841.0000, 'ºC'),
	(148989, 119, '2014-01-15 00:57:35.000000', 'temperatura', 427.0000, 'ºC'),
	(148990, 119, '2014-01-15 00:57:36.000000', 'temperatura', 814.0000, 'ºC'),
	(148991, 119, '2014-01-15 00:57:37.000000', 'temperatura', 390.0000, 'ºC'),
	(148992, 119, '2014-01-15 00:57:38.000000', 'temperatura', 708.0000, 'ºC'),
	(148993, 119, '2014-01-15 00:57:39.000000', 'temperatura', 1169.0000, 'ºC'),
	(148994, 119, '2014-01-15 00:57:40.000000', 'temperatura', 123.0000, 'ºC'),
	(148995, 119, '2014-01-15 00:57:41.000000', 'temperatura', 707.0000, 'ºC'),
	(148996, 119, '2014-01-15 00:57:42.000000', 'temperatura', 768.0000, 'ºC'),
	(148997, 119, '2014-01-15 00:57:43.000000', 'temperatura', 518.0000, 'ºC'),
	(148998, 119, '2014-01-15 00:57:44.000000', 'temperatura', 287.0000, 'ºC'),
	(148999, 119, '2014-01-15 00:57:45.000000', 'temperatura', 1082.0000, 'ºC'),
	(149000, 119, '2014-01-15 00:57:46.000000', 'temperatura', 947.0000, 'ºC'),
	(149001, 119, '2014-01-15 00:57:47.000000', 'temperatura', 293.0000, 'ºC'),
	(149002, 119, '2014-01-15 00:57:48.000000', 'temperatura', 1021.0000, 'ºC'),
	(149003, 119, '2014-01-15 00:57:49.000000', 'temperatura', 628.0000, 'ºC'),
	(149004, 119, '2014-01-15 00:57:50.000000', 'temperatura', 78.0000, 'ºC'),
	(149005, 119, '2014-01-15 00:57:51.000000', 'temperatura', 907.0000, 'ºC'),
	(149006, 119, '2014-01-15 00:57:52.000000', 'temperatura', 702.0000, 'ºC'),
	(149007, 119, '2014-01-15 00:57:53.000000', 'temperatura', 790.0000, 'ºC'),
	(149008, 119, '2014-01-15 00:57:54.000000', 'temperatura', 645.0000, 'ºC'),
	(149009, 119, '2014-01-15 00:57:55.000000', 'temperatura', 853.0000, 'ºC'),
	(149010, 119, '2014-01-15 00:57:56.000000', 'temperatura', 1133.0000, 'ºC'),
	(149011, 119, '2014-01-15 00:57:57.000000', 'temperatura', 705.0000, 'ºC'),
	(149012, 119, '2014-01-15 00:57:58.000000', 'temperatura', 128.0000, 'ºC'),
	(149013, 119, '2014-01-15 00:57:59.000000', 'temperatura', 924.0000, 'ºC'),
	(149014, 119, '2014-01-15 00:58:00.000000', 'temperatura', 638.0000, 'ºC'),
	(149015, 119, '2014-01-15 00:58:01.000000', 'temperatura', 419.0000, 'ºC'),
	(149016, 119, '2014-01-15 00:58:02.000000', 'temperatura', 182.0000, 'ºC'),
	(149017, 119, '2014-01-15 00:58:03.000000', 'temperatura', 851.0000, 'ºC'),
	(149018, 119, '2014-01-15 00:58:04.000000', 'temperatura', 112.0000, 'ºC'),
	(149019, 119, '2014-01-15 00:58:05.000000', 'temperatura', 408.0000, 'ºC'),
	(149020, 119, '2014-01-15 00:58:06.000000', 'temperatura', 502.0000, 'ºC'),
	(149021, 119, '2014-01-15 00:58:07.000000', 'temperatura', 88.0000, 'ºC'),
	(149022, 119, '2014-01-15 00:58:08.000000', 'temperatura', 134.0000, 'ºC'),
	(149023, 119, '2014-01-15 00:58:09.000000', 'temperatura', 406.0000, 'ºC'),
	(149024, 119, '2014-01-15 00:58:10.000000', 'temperatura', 429.0000, 'ºC'),
	(149025, 119, '2014-01-15 00:58:11.000000', 'temperatura', 927.0000, 'ºC'),
	(149026, 119, '2014-01-15 00:58:12.000000', 'temperatura', 949.0000, 'ºC'),
	(149027, 119, '2014-01-15 00:58:13.000000', 'temperatura', 763.0000, 'ºC'),
	(149028, 119, '2014-01-15 00:58:14.000000', 'temperatura', 970.0000, 'ºC'),
	(149029, 119, '2014-01-15 00:58:15.000000', 'temperatura', 160.0000, 'ºC'),
	(149030, 119, '2014-01-15 00:58:16.000000', 'temperatura', 292.0000, 'ºC'),
	(149031, 119, '2014-01-15 00:58:17.000000', 'temperatura', 979.0000, 'ºC'),
	(149032, 119, '2014-01-15 00:58:18.000000', 'temperatura', 420.0000, 'ºC'),
	(149033, 119, '2014-01-15 00:58:19.000000', 'temperatura', 366.0000, 'ºC'),
	(149034, 119, '2014-01-15 00:58:20.000000', 'temperatura', 568.0000, 'ºC'),
	(149035, 119, '2014-01-15 00:58:21.000000', 'temperatura', 541.0000, 'ºC'),
	(149036, 119, '2014-01-15 00:58:22.000000', 'temperatura', 1005.0000, 'ºC'),
	(149037, 119, '2014-01-15 00:58:23.000000', 'temperatura', 999.0000, 'ºC'),
	(149038, 119, '2014-01-15 00:58:24.000000', 'temperatura', 783.0000, 'ºC'),
	(149039, 119, '2014-01-15 00:58:25.000000', 'temperatura', 918.0000, 'ºC'),
	(149040, 119, '2014-01-15 00:58:26.000000', 'temperatura', 1040.0000, 'ºC'),
	(149041, 119, '2014-01-15 00:58:27.000000', 'temperatura', 49.0000, 'ºC'),
	(149042, 119, '2014-01-15 00:58:28.000000', 'temperatura', 724.0000, 'ºC'),
	(149043, 119, '2014-01-15 00:58:29.000000', 'temperatura', 1075.0000, 'ºC'),
	(149044, 119, '2014-01-15 00:58:30.000000', 'temperatura', 801.0000, 'ºC'),
	(149045, 119, '2014-01-15 00:58:31.000000', 'temperatura', 781.0000, 'ºC'),
	(149046, 119, '2014-01-15 00:58:32.000000', 'temperatura', 302.0000, 'ºC'),
	(149047, 119, '2014-01-15 00:58:33.000000', 'temperatura', 369.0000, 'ºC'),
	(149048, 119, '2014-01-15 00:58:34.000000', 'temperatura', 938.0000, 'ºC'),
	(149049, 119, '2014-01-15 00:58:35.000000', 'temperatura', 1183.0000, 'ºC'),
	(149050, 119, '2014-01-15 00:58:36.000000', 'temperatura', 700.0000, 'ºC'),
	(149051, 119, '2014-01-15 00:58:37.000000', 'temperatura', 1154.0000, 'ºC'),
	(149052, 119, '2014-01-15 00:58:38.000000', 'temperatura', 72.0000, 'ºC'),
	(149053, 119, '2014-01-15 00:58:39.000000', 'temperatura', 496.0000, 'ºC'),
	(149054, 119, '2014-01-15 00:58:40.000000', 'temperatura', 1067.0000, 'ºC'),
	(149055, 119, '2014-01-15 00:58:41.000000', 'temperatura', 245.0000, 'ºC'),
	(149056, 119, '2014-01-15 00:58:42.000000', 'temperatura', 424.0000, 'ºC'),
	(149057, 119, '2014-01-15 00:58:43.000000', 'temperatura', 188.0000, 'ºC'),
	(149058, 119, '2014-01-15 00:58:44.000000', 'temperatura', 867.0000, 'ºC'),
	(149059, 119, '2014-01-15 00:58:45.000000', 'temperatura', 171.0000, 'ºC'),
	(149060, 119, '2014-01-15 00:58:46.000000', 'temperatura', 656.0000, 'ºC'),
	(149061, 119, '2014-01-15 00:58:47.000000', 'temperatura', 367.0000, 'ºC'),
	(149062, 119, '2014-01-15 00:58:48.000000', 'temperatura', 1069.0000, 'ºC'),
	(149063, 119, '2014-01-15 00:58:49.000000', 'temperatura', 645.0000, 'ºC'),
	(149064, 119, '2014-01-15 00:58:50.000000', 'temperatura', 16.0000, 'ºC'),
	(149065, 119, '2014-01-15 00:58:51.000000', 'temperatura', 548.0000, 'ºC'),
	(149066, 119, '2014-01-15 00:58:52.000000', 'temperatura', 293.0000, 'ºC'),
	(149067, 119, '2014-01-15 00:58:53.000000', 'temperatura', 1020.0000, 'ºC'),
	(149068, 119, '2014-01-15 00:58:54.000000', 'temperatura', 620.0000, 'ºC'),
	(149069, 119, '2014-01-15 00:58:55.000000', 'temperatura', 42.0000, 'ºC'),
	(149070, 119, '2014-01-15 00:58:56.000000', 'temperatura', 751.0000, 'ºC'),
	(149071, 119, '2014-01-15 00:58:57.000000', 'temperatura', 29.0000, 'ºC'),
	(149072, 119, '2014-01-15 00:58:58.000000', 'temperatura', 291.0000, 'ºC'),
	(149073, 119, '2014-01-15 00:58:59.000000', 'temperatura', 171.0000, 'ºC'),
	(149074, 119, '2014-01-15 00:59:00.000000', 'temperatura', 1183.0000, 'ºC'),
	(149075, 119, '2014-01-15 00:59:01.000000', 'temperatura', 603.0000, 'ºC'),
	(149076, 119, '2014-01-15 00:59:02.000000', 'temperatura', 667.0000, 'ºC'),
	(149077, 119, '2014-01-15 00:59:03.000000', 'temperatura', 326.0000, 'ºC'),
	(149078, 119, '2014-01-15 00:59:04.000000', 'temperatura', 828.0000, 'ºC'),
	(149079, 119, '2014-01-15 00:59:05.000000', 'temperatura', 765.0000, 'ºC'),
	(149080, 119, '2014-01-15 00:59:06.000000', 'temperatura', 141.0000, 'ºC'),
	(149081, 119, '2014-01-15 00:59:07.000000', 'temperatura', 810.0000, 'ºC'),
	(149082, 119, '2014-01-15 00:59:08.000000', 'temperatura', 29.0000, 'ºC'),
	(149083, 119, '2014-01-15 00:59:09.000000', 'temperatura', 117.0000, 'ºC'),
	(149084, 119, '2014-01-15 00:59:10.000000', 'temperatura', 495.0000, 'ºC'),
	(149085, 119, '2014-01-15 00:59:11.000000', 'temperatura', 925.0000, 'ºC'),
	(149086, 119, '2014-01-15 00:59:12.000000', 'temperatura', 740.0000, 'ºC'),
	(149087, 119, '2014-01-15 00:59:13.000000', 'temperatura', 924.0000, 'ºC'),
	(149088, 119, '2014-01-15 00:59:14.000000', 'temperatura', 4.0000, 'ºC'),
	(149089, 119, '2014-01-15 00:59:15.000000', 'temperatura', 845.0000, 'ºC'),
	(149090, 119, '2014-01-15 00:59:16.000000', 'temperatura', 617.0000, 'ºC'),
	(149091, 119, '2014-01-15 00:59:17.000000', 'temperatura', 549.0000, 'ºC'),
	(149092, 119, '2014-01-15 00:59:18.000000', 'temperatura', 896.0000, 'ºC'),
	(149093, 119, '2014-01-15 00:59:19.000000', 'temperatura', 434.0000, 'ºC'),
	(149094, 119, '2014-01-15 00:59:20.000000', 'temperatura', 683.0000, 'ºC'),
	(149095, 119, '2014-01-15 00:59:21.000000', 'temperatura', 911.0000, 'ºC'),
	(149096, 119, '2014-01-15 00:59:22.000000', 'temperatura', 108.0000, 'ºC'),
	(149097, 119, '2014-01-15 00:59:23.000000', 'temperatura', 205.0000, 'ºC'),
	(149098, 119, '2014-01-15 00:59:24.000000', 'temperatura', 703.0000, 'ºC'),
	(149099, 119, '2014-01-15 00:59:25.000000', 'temperatura', 500.0000, 'ºC'),
	(149100, 119, '2014-01-15 00:59:26.000000', 'temperatura', 394.0000, 'ºC'),
	(149101, 119, '2014-01-15 00:59:27.000000', 'temperatura', 467.0000, 'ºC'),
	(149102, 119, '2014-01-15 00:59:28.000000', 'temperatura', 1156.0000, 'ºC'),
	(149103, 119, '2014-01-15 00:59:29.000000', 'temperatura', 778.0000, 'ºC'),
	(149104, 119, '2014-01-15 00:59:30.000000', 'temperatura', 423.0000, 'ºC'),
	(149105, 119, '2014-01-15 00:59:31.000000', 'temperatura', 980.0000, 'ºC'),
	(149106, 119, '2014-01-15 00:59:32.000000', 'temperatura', 35.0000, 'ºC'),
	(149107, 119, '2014-01-15 00:59:33.000000', 'temperatura', 832.0000, 'ºC'),
	(149108, 119, '2014-01-15 00:59:34.000000', 'temperatura', 459.0000, 'ºC'),
	(149109, 119, '2014-01-15 00:59:35.000000', 'temperatura', 996.0000, 'ºC'),
	(149110, 119, '2014-01-15 00:59:36.000000', 'temperatura', 7.0000, 'ºC'),
	(149111, 119, '2014-01-15 00:59:37.000000', 'temperatura', 645.0000, 'ºC'),
	(149112, 119, '2014-01-15 00:59:38.000000', 'temperatura', 804.0000, 'ºC'),
	(149113, 119, '2014-01-15 00:59:39.000000', 'temperatura', 884.0000, 'ºC'),
	(149114, 119, '2014-01-15 00:59:40.000000', 'temperatura', 811.0000, 'ºC'),
	(149115, 119, '2014-01-15 00:59:41.000000', 'temperatura', 203.0000, 'ºC'),
	(149116, 120, '2014-01-15 00:00:00.000000', 'temperatura', 702.0000, 'ºC'),
	(149117, 120, '2014-01-15 00:00:01.000000', 'temperatura', 564.0000, 'ºC'),
	(149118, 120, '2014-01-15 00:00:02.000000', 'temperatura', 714.0000, 'ºC'),
	(149119, 120, '2014-01-15 00:00:03.000000', 'temperatura', 680.0000, 'ºC'),
	(149120, 120, '2014-01-15 00:00:04.000000', 'temperatura', 58.0000, 'ºC'),
	(149121, 120, '2014-01-15 00:00:05.000000', 'temperatura', 652.0000, 'ºC'),
	(149122, 120, '2014-01-15 00:00:06.000000', 'temperatura', 687.0000, 'ºC'),
	(149123, 120, '2014-01-15 00:00:07.000000', 'temperatura', 280.0000, 'ºC'),
	(149124, 120, '2014-01-15 00:00:08.000000', 'temperatura', 539.0000, 'ºC'),
	(149125, 120, '2014-01-15 00:00:09.000000', 'temperatura', 655.0000, 'ºC'),
	(149126, 120, '2014-01-15 00:00:10.000000', 'temperatura', 460.0000, 'ºC'),
	(149127, 120, '2014-01-15 00:00:11.000000', 'temperatura', 336.0000, 'ºC'),
	(149128, 120, '2014-01-15 00:00:12.000000', 'temperatura', 298.0000, 'ºC'),
	(149129, 120, '2014-01-15 00:00:13.000000', 'temperatura', 482.0000, 'ºC'),
	(149130, 120, '2014-01-15 00:00:14.000000', 'temperatura', 319.0000, 'ºC'),
	(149131, 120, '2014-01-15 00:00:15.000000', 'temperatura', 147.0000, 'ºC'),
	(149132, 120, '2014-01-15 00:00:16.000000', 'temperatura', 981.0000, 'ºC'),
	(149133, 120, '2014-01-15 00:00:17.000000', 'temperatura', 865.0000, 'ºC'),
	(149134, 120, '2014-01-15 00:00:18.000000', 'temperatura', 182.0000, 'ºC'),
	(149135, 120, '2014-01-15 00:00:19.000000', 'temperatura', 717.0000, 'ºC'),
	(149136, 120, '2014-01-15 00:00:20.000000', 'temperatura', 638.0000, 'ºC'),
	(149137, 120, '2014-01-15 00:00:21.000000', 'temperatura', 1041.0000, 'ºC'),
	(149138, 120, '2014-01-15 00:00:22.000000', 'temperatura', 891.0000, 'ºC'),
	(149139, 120, '2014-01-15 00:00:23.000000', 'temperatura', 132.0000, 'ºC'),
	(149140, 120, '2014-01-15 00:00:24.000000', 'temperatura', 386.0000, 'ºC'),
	(149141, 120, '2014-01-15 00:00:25.000000', 'temperatura', 334.0000, 'ºC'),
	(149142, 120, '2014-01-15 00:00:26.000000', 'temperatura', 513.0000, 'ºC'),
	(149143, 120, '2014-01-15 00:00:27.000000', 'temperatura', 364.0000, 'ºC'),
	(149144, 120, '2014-01-15 00:00:28.000000', 'temperatura', 282.0000, 'ºC'),
	(149145, 120, '2014-01-15 00:00:29.000000', 'temperatura', 318.0000, 'ºC'),
	(149146, 120, '2014-01-15 00:00:30.000000', 'temperatura', 746.0000, 'ºC'),
	(149147, 120, '2014-01-15 00:00:31.000000', 'temperatura', 376.0000, 'ºC'),
	(149148, 120, '2014-01-15 00:00:32.000000', 'temperatura', 842.0000, 'ºC'),
	(149149, 120, '2014-01-15 00:00:33.000000', 'temperatura', 682.0000, 'ºC'),
	(149150, 120, '2014-01-15 00:00:34.000000', 'temperatura', 884.0000, 'ºC'),
	(149151, 120, '2014-01-15 00:00:35.000000', 'temperatura', 1174.0000, 'ºC'),
	(149152, 120, '2014-01-15 00:00:36.000000', 'temperatura', 821.0000, 'ºC'),
	(149153, 120, '2014-01-15 00:00:37.000000', 'temperatura', 582.0000, 'ºC'),
	(149154, 120, '2014-01-15 00:00:38.000000', 'temperatura', 448.0000, 'ºC'),
	(149155, 120, '2014-01-15 00:00:39.000000', 'temperatura', 494.0000, 'ºC'),
	(149156, 120, '2014-01-15 00:00:40.000000', 'temperatura', 1125.0000, 'ºC'),
	(149157, 120, '2014-01-15 00:00:41.000000', 'temperatura', 546.0000, 'ºC'),
	(149158, 120, '2014-01-15 00:00:42.000000', 'temperatura', 556.0000, 'ºC'),
	(149159, 120, '2014-01-15 00:00:43.000000', 'temperatura', 1141.0000, 'ºC'),
	(149160, 120, '2014-01-15 00:00:44.000000', 'temperatura', 437.0000, 'ºC'),
	(149161, 120, '2014-01-15 00:00:45.000000', 'temperatura', 1163.0000, 'ºC'),
	(149162, 120, '2014-01-15 00:00:46.000000', 'temperatura', 903.0000, 'ºC'),
	(149163, 120, '2014-01-15 00:00:47.000000', 'temperatura', 1029.0000, 'ºC'),
	(149164, 120, '2014-01-15 00:00:48.000000', 'temperatura', 37.0000, 'ºC'),
	(149165, 120, '2014-01-15 00:00:49.000000', 'temperatura', 698.0000, 'ºC'),
	(149166, 120, '2014-01-15 00:00:50.000000', 'temperatura', 979.0000, 'ºC'),
	(149167, 120, '2014-01-15 00:00:51.000000', 'temperatura', 402.0000, 'ºC'),
	(149168, 120, '2014-01-15 00:00:52.000000', 'temperatura', 272.0000, 'ºC'),
	(149169, 120, '2014-01-15 00:00:53.000000', 'temperatura', 155.0000, 'ºC'),
	(149170, 120, '2014-01-15 00:00:54.000000', 'temperatura', 1159.0000, 'ºC'),
	(149171, 120, '2014-01-15 00:00:55.000000', 'temperatura', 531.0000, 'ºC'),
	(149172, 120, '2014-01-15 00:00:56.000000', 'temperatura', 379.0000, 'ºC'),
	(149173, 120, '2014-01-15 00:00:57.000000', 'temperatura', 303.0000, 'ºC'),
	(149174, 120, '2014-01-15 00:00:58.000000', 'temperatura', 376.0000, 'ºC'),
	(149175, 120, '2014-01-15 00:00:59.000000', 'temperatura', 973.0000, 'ºC'),
	(149176, 120, '2014-01-15 00:01:00.000000', 'temperatura', 136.0000, 'ºC'),
	(149177, 120, '2014-01-15 00:01:01.000000', 'temperatura', 162.0000, 'ºC'),
	(149178, 120, '2014-01-15 00:01:02.000000', 'temperatura', 402.0000, 'ºC'),
	(149179, 120, '2014-01-15 00:01:03.000000', 'temperatura', 326.0000, 'ºC'),
	(149180, 120, '2014-01-15 00:01:04.000000', 'temperatura', 423.0000, 'ºC'),
	(149181, 120, '2014-01-15 00:01:05.000000', 'temperatura', 1140.0000, 'ºC'),
	(149182, 120, '2014-01-15 00:01:06.000000', 'temperatura', 829.0000, 'ºC'),
	(149183, 120, '2014-01-15 00:01:07.000000', 'temperatura', 726.0000, 'ºC'),
	(149184, 120, '2014-01-15 00:01:08.000000', 'temperatura', 1143.0000, 'ºC'),
	(149185, 120, '2014-01-15 00:01:09.000000', 'temperatura', 1137.0000, 'ºC'),
	(149186, 120, '2014-01-15 00:01:10.000000', 'temperatura', 1057.0000, 'ºC'),
	(149187, 120, '2014-01-15 00:01:11.000000', 'temperatura', 675.0000, 'ºC'),
	(149188, 120, '2014-01-15 00:01:12.000000', 'temperatura', 202.0000, 'ºC'),
	(149189, 120, '2014-01-15 00:01:13.000000', 'temperatura', 188.0000, 'ºC'),
	(149190, 120, '2014-01-15 00:01:14.000000', 'temperatura', 336.0000, 'ºC'),
	(149191, 120, '2014-01-15 00:01:15.000000', 'temperatura', 1113.0000, 'ºC'),
	(149192, 120, '2014-01-15 00:01:16.000000', 'temperatura', 959.0000, 'ºC'),
	(149193, 120, '2014-01-15 00:01:17.000000', 'temperatura', 258.0000, 'ºC'),
	(149194, 120, '2014-01-15 00:01:18.000000', 'temperatura', 814.0000, 'ºC'),
	(149195, 120, '2014-01-15 00:01:19.000000', 'temperatura', 897.0000, 'ºC'),
	(149196, 120, '2014-01-15 00:01:20.000000', 'temperatura', 841.0000, 'ºC'),
	(149197, 120, '2014-01-15 00:01:21.000000', 'temperatura', 315.0000, 'ºC'),
	(149198, 120, '2014-01-15 00:01:22.000000', 'temperatura', 251.0000, 'ºC'),
	(149199, 120, '2014-01-15 00:01:23.000000', 'temperatura', 310.0000, 'ºC'),
	(149200, 120, '2014-01-15 00:01:24.000000', 'temperatura', 801.0000, 'ºC'),
	(149201, 120, '2014-01-15 00:01:25.000000', 'temperatura', 672.0000, 'ºC'),
	(149202, 120, '2014-01-15 00:01:26.000000', 'temperatura', 960.0000, 'ºC'),
	(149203, 120, '2014-01-15 00:01:27.000000', 'temperatura', 382.0000, 'ºC'),
	(149204, 120, '2014-01-15 00:01:28.000000', 'temperatura', 230.0000, 'ºC'),
	(149205, 120, '2014-01-15 00:01:29.000000', 'temperatura', 6.0000, 'ºC'),
	(149206, 120, '2014-01-15 00:01:30.000000', 'temperatura', 540.0000, 'ºC'),
	(149207, 120, '2014-01-15 00:01:31.000000', 'temperatura', 284.0000, 'ºC'),
	(149208, 120, '2014-01-15 00:01:32.000000', 'temperatura', 998.0000, 'ºC'),
	(149209, 120, '2014-01-15 00:01:33.000000', 'temperatura', 538.0000, 'ºC'),
	(149210, 120, '2014-01-15 00:01:34.000000', 'temperatura', 898.0000, 'ºC'),
	(149211, 120, '2014-01-15 00:01:35.000000', 'temperatura', 476.0000, 'ºC'),
	(149212, 120, '2014-01-15 00:01:36.000000', 'temperatura', 888.0000, 'ºC'),
	(149213, 120, '2014-01-15 00:01:37.000000', 'temperatura', 612.0000, 'ºC'),
	(149214, 120, '2014-01-15 00:01:38.000000', 'temperatura', 396.0000, 'ºC'),
	(149215, 120, '2014-01-15 00:01:39.000000', 'temperatura', 146.0000, 'ºC'),
	(149216, 120, '2014-01-15 00:01:40.000000', 'temperatura', 743.0000, 'ºC'),
	(149217, 120, '2014-01-15 00:01:41.000000', 'temperatura', 876.0000, 'ºC'),
	(149218, 120, '2014-01-15 00:01:42.000000', 'temperatura', 952.0000, 'ºC'),
	(149219, 120, '2014-01-15 00:01:43.000000', 'temperatura', 932.0000, 'ºC'),
	(149220, 120, '2014-01-15 00:01:44.000000', 'temperatura', 604.0000, 'ºC'),
	(149221, 120, '2014-01-15 00:01:45.000000', 'temperatura', 225.0000, 'ºC'),
	(149222, 120, '2014-01-15 00:01:46.000000', 'temperatura', 515.0000, 'ºC'),
	(149223, 120, '2014-01-15 00:01:47.000000', 'temperatura', 700.0000, 'ºC'),
	(149224, 120, '2014-01-15 00:01:48.000000', 'temperatura', 754.0000, 'ºC'),
	(149225, 120, '2014-01-15 00:01:49.000000', 'temperatura', 470.0000, 'ºC'),
	(149226, 120, '2014-01-15 00:01:50.000000', 'temperatura', 91.0000, 'ºC'),
	(149227, 120, '2014-01-15 00:01:51.000000', 'temperatura', 246.0000, 'ºC'),
	(149228, 120, '2014-01-15 00:01:52.000000', 'temperatura', 956.0000, 'ºC'),
	(149229, 120, '2014-01-15 00:01:53.000000', 'temperatura', 443.0000, 'ºC'),
	(149230, 120, '2014-01-15 00:01:54.000000', 'temperatura', 548.0000, 'ºC'),
	(149231, 120, '2014-01-15 00:01:55.000000', 'temperatura', 212.0000, 'ºC'),
	(149232, 120, '2014-01-15 00:01:56.000000', 'temperatura', 616.0000, 'ºC'),
	(149233, 120, '2014-01-15 00:01:57.000000', 'temperatura', 43.0000, 'ºC'),
	(149234, 120, '2014-01-15 00:01:58.000000', 'temperatura', 768.0000, 'ºC'),
	(149235, 120, '2014-01-15 00:01:59.000000', 'temperatura', 112.0000, 'ºC'),
	(149236, 120, '2014-01-15 00:02:00.000000', 'temperatura', 655.0000, 'ºC'),
	(149237, 120, '2014-01-15 00:02:01.000000', 'temperatura', 540.0000, 'ºC'),
	(149238, 120, '2014-01-15 00:02:02.000000', 'temperatura', 735.0000, 'ºC'),
	(149239, 120, '2014-01-15 00:02:03.000000', 'temperatura', 858.0000, 'ºC'),
	(149240, 120, '2014-01-15 00:02:04.000000', 'temperatura', 882.0000, 'ºC'),
	(149241, 120, '2014-01-15 00:02:05.000000', 'temperatura', 638.0000, 'ºC'),
	(149242, 120, '2014-01-15 00:02:06.000000', 'temperatura', 546.0000, 'ºC'),
	(149243, 120, '2014-01-15 00:02:07.000000', 'temperatura', 817.0000, 'ºC'),
	(149244, 120, '2014-01-15 00:02:08.000000', 'temperatura', 45.0000, 'ºC'),
	(149245, 120, '2014-01-15 00:02:09.000000', 'temperatura', 177.0000, 'ºC'),
	(149246, 120, '2014-01-15 00:02:10.000000', 'temperatura', 749.0000, 'ºC'),
	(149247, 120, '2014-01-15 00:02:11.000000', 'temperatura', 815.0000, 'ºC'),
	(149248, 120, '2014-01-15 00:02:12.000000', 'temperatura', 628.0000, 'ºC'),
	(149249, 120, '2014-01-15 00:02:13.000000', 'temperatura', 697.0000, 'ºC'),
	(149250, 120, '2014-01-15 00:02:14.000000', 'temperatura', 401.0000, 'ºC'),
	(149251, 120, '2014-01-15 00:02:15.000000', 'temperatura', 1113.0000, 'ºC'),
	(149252, 120, '2014-01-15 00:02:16.000000', 'temperatura', 764.0000, 'ºC'),
	(149253, 120, '2014-01-15 00:02:17.000000', 'temperatura', 483.0000, 'ºC'),
	(149254, 120, '2014-01-15 00:02:18.000000', 'temperatura', 120.0000, 'ºC'),
	(149255, 120, '2014-01-15 00:02:19.000000', 'temperatura', 354.0000, 'ºC'),
	(149256, 120, '2014-01-15 00:02:20.000000', 'temperatura', 211.0000, 'ºC'),
	(149257, 120, '2014-01-15 00:02:21.000000', 'temperatura', 1192.0000, 'ºC'),
	(149258, 120, '2014-01-15 00:02:22.000000', 'temperatura', 530.0000, 'ºC'),
	(149259, 120, '2014-01-15 00:02:23.000000', 'temperatura', 273.0000, 'ºC'),
	(149260, 120, '2014-01-15 00:02:24.000000', 'temperatura', 978.0000, 'ºC'),
	(149261, 120, '2014-01-15 00:02:25.000000', 'temperatura', 468.0000, 'ºC'),
	(149262, 120, '2014-01-15 00:02:26.000000', 'temperatura', 608.0000, 'ºC'),
	(149263, 120, '2014-01-15 00:02:27.000000', 'temperatura', 438.0000, 'ºC'),
	(149264, 120, '2014-01-15 00:02:28.000000', 'temperatura', 364.0000, 'ºC'),
	(149265, 120, '2014-01-15 00:02:29.000000', 'temperatura', 509.0000, 'ºC'),
	(149266, 120, '2014-01-15 00:02:30.000000', 'temperatura', 251.0000, 'ºC'),
	(149267, 120, '2014-01-15 00:02:31.000000', 'temperatura', 931.0000, 'ºC'),
	(149268, 120, '2014-01-15 00:02:32.000000', 'temperatura', 300.0000, 'ºC'),
	(149269, 120, '2014-01-15 00:02:33.000000', 'temperatura', 1108.0000, 'ºC'),
	(149270, 120, '2014-01-15 00:02:34.000000', 'temperatura', 1042.0000, 'ºC'),
	(149271, 120, '2014-01-15 00:02:35.000000', 'temperatura', 684.0000, 'ºC'),
	(149272, 120, '2014-01-15 00:02:36.000000', 'temperatura', 295.0000, 'ºC'),
	(149273, 120, '2014-01-15 00:02:37.000000', 'temperatura', 625.0000, 'ºC'),
	(149274, 120, '2014-01-15 00:02:38.000000', 'temperatura', 1042.0000, 'ºC'),
	(149275, 120, '2014-01-15 00:02:39.000000', 'temperatura', 933.0000, 'ºC'),
	(149276, 120, '2014-01-15 00:02:40.000000', 'temperatura', 340.0000, 'ºC'),
	(149277, 120, '2014-01-15 00:02:41.000000', 'temperatura', 104.0000, 'ºC'),
	(149278, 120, '2014-01-15 00:02:42.000000', 'temperatura', 697.0000, 'ºC'),
	(149279, 120, '2014-01-15 00:02:43.000000', 'temperatura', 775.0000, 'ºC'),
	(149280, 120, '2014-01-15 00:02:44.000000', 'temperatura', 585.0000, 'ºC'),
	(149281, 120, '2014-01-15 00:02:45.000000', 'temperatura', 600.0000, 'ºC'),
	(149282, 120, '2014-01-15 00:02:46.000000', 'temperatura', 44.0000, 'ºC'),
	(149283, 120, '2014-01-15 00:02:47.000000', 'temperatura', 821.0000, 'ºC'),
	(149284, 120, '2014-01-15 00:02:48.000000', 'temperatura', 375.0000, 'ºC'),
	(149285, 120, '2014-01-15 00:02:49.000000', 'temperatura', 610.0000, 'ºC'),
	(149286, 120, '2014-01-15 00:02:50.000000', 'temperatura', 729.0000, 'ºC'),
	(149287, 120, '2014-01-15 00:02:51.000000', 'temperatura', 612.0000, 'ºC'),
	(149288, 120, '2014-01-15 00:02:52.000000', 'temperatura', 875.0000, 'ºC'),
	(149289, 120, '2014-01-15 00:02:53.000000', 'temperatura', 140.0000, 'ºC'),
	(149290, 120, '2014-01-15 00:02:54.000000', 'temperatura', 476.0000, 'ºC'),
	(149291, 120, '2014-01-15 00:02:55.000000', 'temperatura', 758.0000, 'ºC'),
	(149292, 120, '2014-01-15 00:02:56.000000', 'temperatura', 1163.0000, 'ºC'),
	(149293, 120, '2014-01-15 00:02:57.000000', 'temperatura', 1141.0000, 'ºC'),
	(149294, 120, '2014-01-15 00:02:58.000000', 'temperatura', 1019.0000, 'ºC'),
	(149295, 120, '2014-01-15 00:02:59.000000', 'temperatura', 471.0000, 'ºC'),
	(149296, 120, '2014-01-15 00:03:00.000000', 'temperatura', 497.0000, 'ºC'),
	(149297, 120, '2014-01-15 00:03:01.000000', 'temperatura', 1073.0000, 'ºC'),
	(149298, 120, '2014-01-15 00:03:02.000000', 'temperatura', 276.0000, 'ºC'),
	(149299, 120, '2014-01-15 00:03:03.000000', 'temperatura', 561.0000, 'ºC'),
	(149300, 120, '2014-01-15 00:03:04.000000', 'temperatura', 775.0000, 'ºC'),
	(149301, 120, '2014-01-15 00:03:05.000000', 'temperatura', 995.0000, 'ºC'),
	(149302, 120, '2014-01-15 00:03:06.000000', 'temperatura', 251.0000, 'ºC'),
	(149303, 120, '2014-01-15 00:03:07.000000', 'temperatura', 669.0000, 'ºC'),
	(149304, 120, '2014-01-15 00:03:08.000000', 'temperatura', 192.0000, 'ºC'),
	(149305, 120, '2014-01-15 00:03:09.000000', 'temperatura', 154.0000, 'ºC'),
	(149306, 120, '2014-01-15 00:03:10.000000', 'temperatura', 194.0000, 'ºC'),
	(149307, 120, '2014-01-15 00:03:11.000000', 'temperatura', 510.0000, 'ºC'),
	(149308, 120, '2014-01-15 00:03:12.000000', 'temperatura', 768.0000, 'ºC'),
	(149309, 120, '2014-01-15 00:03:13.000000', 'temperatura', 1110.0000, 'ºC'),
	(149310, 120, '2014-01-15 00:03:14.000000', 'temperatura', 849.0000, 'ºC'),
	(149311, 120, '2014-01-15 00:03:15.000000', 'temperatura', 913.0000, 'ºC'),
	(149312, 120, '2014-01-15 00:03:16.000000', 'temperatura', 821.0000, 'ºC'),
	(149313, 120, '2014-01-15 00:03:17.000000', 'temperatura', 165.0000, 'ºC'),
	(149314, 120, '2014-01-15 00:03:18.000000', 'temperatura', 762.0000, 'ºC'),
	(149315, 120, '2014-01-15 00:03:19.000000', 'temperatura', 916.0000, 'ºC'),
	(149316, 120, '2014-01-15 00:03:20.000000', 'temperatura', 1095.0000, 'ºC'),
	(149317, 120, '2014-01-15 00:03:21.000000', 'temperatura', 328.0000, 'ºC'),
	(149318, 120, '2014-01-15 00:03:22.000000', 'temperatura', 757.0000, 'ºC'),
	(149319, 120, '2014-01-15 00:03:23.000000', 'temperatura', 400.0000, 'ºC'),
	(149320, 120, '2014-01-15 00:03:24.000000', 'temperatura', 930.0000, 'ºC'),
	(149321, 120, '2014-01-15 00:03:25.000000', 'temperatura', 1048.0000, 'ºC'),
	(149322, 120, '2014-01-15 00:03:26.000000', 'temperatura', 52.0000, 'ºC'),
	(149323, 120, '2014-01-15 00:03:27.000000', 'temperatura', 717.0000, 'ºC'),
	(149324, 120, '2014-01-15 00:03:28.000000', 'temperatura', 1030.0000, 'ºC'),
	(149325, 120, '2014-01-15 00:03:29.000000', 'temperatura', 598.0000, 'ºC'),
	(149326, 120, '2014-01-15 00:03:30.000000', 'temperatura', 1101.0000, 'ºC'),
	(149327, 120, '2014-01-15 00:03:31.000000', 'temperatura', 113.0000, 'ºC'),
	(149328, 120, '2014-01-15 00:03:32.000000', 'temperatura', 863.0000, 'ºC'),
	(149329, 120, '2014-01-15 00:03:33.000000', 'temperatura', 373.0000, 'ºC'),
	(149330, 120, '2014-01-15 00:03:34.000000', 'temperatura', 480.0000, 'ºC'),
	(149331, 120, '2014-01-15 00:03:35.000000', 'temperatura', 82.0000, 'ºC'),
	(149332, 120, '2014-01-15 00:03:36.000000', 'temperatura', 167.0000, 'ºC'),
	(149333, 120, '2014-01-15 00:03:37.000000', 'temperatura', 592.0000, 'ºC'),
	(149334, 120, '2014-01-15 00:03:38.000000', 'temperatura', 61.0000, 'ºC'),
	(149335, 120, '2014-01-15 00:03:39.000000', 'temperatura', 927.0000, 'ºC'),
	(149336, 120, '2014-01-15 00:03:40.000000', 'temperatura', 852.0000, 'ºC'),
	(149337, 120, '2014-01-15 00:03:41.000000', 'temperatura', 279.0000, 'ºC'),
	(149338, 120, '2014-01-15 00:03:42.000000', 'temperatura', 39.0000, 'ºC'),
	(149339, 120, '2014-01-15 00:03:43.000000', 'temperatura', 559.0000, 'ºC'),
	(149340, 120, '2014-01-15 00:03:44.000000', 'temperatura', 280.0000, 'ºC'),
	(149341, 120, '2014-01-15 00:03:45.000000', 'temperatura', 922.0000, 'ºC'),
	(149342, 120, '2014-01-15 00:03:46.000000', 'temperatura', 171.0000, 'ºC'),
	(149343, 120, '2014-01-15 00:03:47.000000', 'temperatura', 491.0000, 'ºC'),
	(149344, 120, '2014-01-15 00:03:48.000000', 'temperatura', 740.0000, 'ºC'),
	(149345, 120, '2014-01-15 00:03:49.000000', 'temperatura', 1030.0000, 'ºC'),
	(149346, 120, '2014-01-15 00:03:50.000000', 'temperatura', 531.0000, 'ºC'),
	(149347, 120, '2014-01-15 00:03:51.000000', 'temperatura', 763.0000, 'ºC'),
	(149348, 120, '2014-01-15 00:03:52.000000', 'temperatura', 1025.0000, 'ºC'),
	(149349, 120, '2014-01-15 00:03:53.000000', 'temperatura', 434.0000, 'ºC'),
	(149350, 120, '2014-01-15 00:03:54.000000', 'temperatura', 298.0000, 'ºC'),
	(149351, 120, '2014-01-15 00:03:55.000000', 'temperatura', 189.0000, 'ºC'),
	(149352, 120, '2014-01-15 00:03:56.000000', 'temperatura', 51.0000, 'ºC'),
	(149353, 120, '2014-01-15 00:03:57.000000', 'temperatura', 888.0000, 'ºC'),
	(149354, 120, '2014-01-15 00:03:58.000000', 'temperatura', 686.0000, 'ºC'),
	(149355, 120, '2014-01-15 00:03:59.000000', 'temperatura', 767.0000, 'ºC'),
	(149356, 120, '2014-01-15 00:04:00.000000', 'temperatura', 579.0000, 'ºC'),
	(149357, 120, '2014-01-15 00:04:01.000000', 'temperatura', 594.0000, 'ºC'),
	(149358, 120, '2014-01-15 00:04:02.000000', 'temperatura', 31.0000, 'ºC'),
	(149359, 120, '2014-01-15 00:04:03.000000', 'temperatura', 776.0000, 'ºC'),
	(149360, 120, '2014-01-15 00:04:04.000000', 'temperatura', 187.0000, 'ºC'),
	(149361, 120, '2014-01-15 00:04:05.000000', 'temperatura', 1007.0000, 'ºC'),
	(149362, 120, '2014-01-15 00:04:06.000000', 'temperatura', 874.0000, 'ºC'),
	(149363, 120, '2014-01-15 00:04:07.000000', 'temperatura', 152.0000, 'ºC'),
	(149364, 120, '2014-01-15 00:04:08.000000', 'temperatura', 536.0000, 'ºC'),
	(149365, 120, '2014-01-15 00:04:09.000000', 'temperatura', 1024.0000, 'ºC'),
	(149366, 120, '2014-01-15 00:04:10.000000', 'temperatura', 1113.0000, 'ºC'),
	(149367, 120, '2014-01-15 00:04:11.000000', 'temperatura', 93.0000, 'ºC'),
	(149368, 120, '2014-01-15 00:04:12.000000', 'temperatura', 728.0000, 'ºC'),
	(149369, 120, '2014-01-15 00:04:13.000000', 'temperatura', 959.0000, 'ºC'),
	(149370, 120, '2014-01-15 00:04:14.000000', 'temperatura', 214.0000, 'ºC'),
	(149371, 120, '2014-01-15 00:04:15.000000', 'temperatura', 591.0000, 'ºC'),
	(149372, 120, '2014-01-15 00:04:16.000000', 'temperatura', 1114.0000, 'ºC'),
	(149373, 120, '2014-01-15 00:04:17.000000', 'temperatura', 196.0000, 'ºC'),
	(149374, 120, '2014-01-15 00:04:18.000000', 'temperatura', 42.0000, 'ºC'),
	(149375, 120, '2014-01-15 00:04:19.000000', 'temperatura', 820.0000, 'ºC'),
	(149376, 120, '2014-01-15 00:04:20.000000', 'temperatura', 374.0000, 'ºC'),
	(149377, 120, '2014-01-15 00:04:21.000000', 'temperatura', 613.0000, 'ºC'),
	(149378, 120, '2014-01-15 00:04:22.000000', 'temperatura', 743.0000, 'ºC'),
	(149379, 120, '2014-01-15 00:04:23.000000', 'temperatura', 677.0000, 'ºC'),
	(149380, 120, '2014-01-15 00:04:24.000000', 'temperatura', 1156.0000, 'ºC'),
	(149381, 120, '2014-01-15 00:04:25.000000', 'temperatura', 149.0000, 'ºC'),
	(149382, 120, '2014-01-15 00:04:26.000000', 'temperatura', 876.0000, 'ºC'),
	(149383, 120, '2014-01-15 00:04:27.000000', 'temperatura', 333.0000, 'ºC'),
	(149384, 120, '2014-01-15 00:04:28.000000', 'temperatura', 241.0000, 'ºC'),
	(149385, 120, '2014-01-15 00:04:29.000000', 'temperatura', 204.0000, 'ºC'),
	(149386, 120, '2014-01-15 00:04:30.000000', 'temperatura', 298.0000, 'ºC'),
	(149387, 120, '2014-01-15 00:04:31.000000', 'temperatura', 880.0000, 'ºC'),
	(149388, 120, '2014-01-15 00:04:32.000000', 'temperatura', 1107.0000, 'ºC'),
	(149389, 120, '2014-01-15 00:04:33.000000', 'temperatura', 494.0000, 'ºC'),
	(149390, 120, '2014-01-15 00:04:34.000000', 'temperatura', 351.0000, 'ºC'),
	(149391, 120, '2014-01-15 00:04:35.000000', 'temperatura', 272.0000, 'ºC'),
	(149392, 120, '2014-01-15 00:04:36.000000', 'temperatura', 308.0000, 'ºC'),
	(149393, 120, '2014-01-15 00:04:37.000000', 'temperatura', 725.0000, 'ºC'),
	(149394, 120, '2014-01-15 00:04:38.000000', 'temperatura', 300.0000, 'ºC'),
	(149395, 120, '2014-01-15 00:04:39.000000', 'temperatura', 525.0000, 'ºC'),
	(149396, 120, '2014-01-15 00:04:40.000000', 'temperatura', 527.0000, 'ºC'),
	(149397, 120, '2014-01-15 00:04:41.000000', 'temperatura', 1062.0000, 'ºC'),
	(149398, 120, '2014-01-15 00:04:42.000000', 'temperatura', 126.0000, 'ºC'),
	(149399, 120, '2014-01-15 00:04:43.000000', 'temperatura', 1047.0000, 'ºC'),
	(149400, 120, '2014-01-15 00:04:44.000000', 'temperatura', 57.0000, 'ºC'),
	(149401, 120, '2014-01-15 00:04:45.000000', 'temperatura', 745.0000, 'ºC'),
	(149402, 120, '2014-01-15 00:04:46.000000', 'temperatura', 1154.0000, 'ºC'),
	(149403, 120, '2014-01-15 00:04:47.000000', 'temperatura', 1135.0000, 'ºC'),
	(149404, 120, '2014-01-15 00:04:48.000000', 'temperatura', 1015.0000, 'ºC'),
	(149405, 120, '2014-01-15 00:04:49.000000', 'temperatura', 471.0000, 'ºC'),
	(149406, 120, '2014-01-15 00:04:50.000000', 'temperatura', 508.0000, 'ºC'),
	(149407, 120, '2014-01-15 00:04:51.000000', 'temperatura', 1129.0000, 'ºC'),
	(149408, 120, '2014-01-15 00:04:52.000000', 'temperatura', 521.0000, 'ºC'),
	(149409, 120, '2014-01-15 00:04:53.000000', 'temperatura', 420.0000, 'ºC'),
	(149410, 120, '2014-01-15 00:04:54.000000', 'temperatura', 536.0000, 'ºC'),
	(149411, 120, '2014-01-15 00:04:55.000000', 'temperatura', 219.0000, 'ºC'),
	(149412, 120, '2014-01-15 00:04:56.000000', 'temperatura', 690.0000, 'ºC'),
	(149413, 120, '2014-01-15 00:04:57.000000', 'temperatura', 391.0000, 'ºC'),
	(149414, 120, '2014-01-15 00:04:58.000000', 'temperatura', 1086.0000, 'ºC'),
	(149415, 120, '2014-01-15 00:04:59.000000', 'temperatura', 656.0000, 'ºC'),
	(149416, 120, '2014-01-15 00:05:00.000000', 'temperatura', 24.0000, 'ºC'),
	(149417, 120, '2014-01-15 00:05:01.000000', 'temperatura', 552.0000, 'ºC'),
	(149418, 120, '2014-01-15 00:05:02.000000', 'temperatura', 290.0000, 'ºC'),
	(149419, 120, '2014-01-15 00:05:03.000000', 'temperatura', 992.0000, 'ºC'),
	(149420, 120, '2014-01-15 00:05:04.000000', 'temperatura', 493.0000, 'ºC'),
	(149421, 120, '2014-01-15 00:05:05.000000', 'temperatura', 689.0000, 'ºC'),
	(149422, 120, '2014-01-15 00:05:06.000000', 'temperatura', 764.0000, 'ºC'),
	(149423, 120, '2014-01-15 00:05:07.000000', 'temperatura', 556.0000, 'ºC'),
	(149424, 120, '2014-01-15 00:05:08.000000', 'temperatura', 489.0000, 'ºC'),
	(149425, 120, '2014-01-15 00:05:09.000000', 'temperatura', 777.0000, 'ºC'),
	(149426, 120, '2014-01-15 00:05:10.000000', 'temperatura', 19.0000, 'ºC'),
	(149427, 120, '2014-01-15 00:05:11.000000', 'temperatura', 166.0000, 'ºC'),
	(149428, 120, '2014-01-15 00:05:12.000000', 'temperatura', 771.0000, 'ºC'),
	(149429, 120, '2014-01-15 00:05:13.000000', 'temperatura', 959.0000, 'ºC'),
	(149430, 120, '2014-01-15 00:05:14.000000', 'temperatura', 83.0000, 'ºC'),
	(149431, 120, '2014-01-15 00:05:15.000000', 'temperatura', 1136.0000, 'ºC'),
	(149432, 120, '2014-01-15 00:05:16.000000', 'temperatura', 633.0000, 'ºC'),
	(149433, 120, '2014-01-15 00:05:17.000000', 'temperatura', 956.0000, 'ºC'),
	(149434, 120, '2014-01-15 00:05:18.000000', 'temperatura', 482.0000, 'ºC'),
	(149435, 120, '2014-01-15 00:05:19.000000', 'temperatura', 742.0000, 'ºC'),
	(149436, 120, '2014-01-15 00:05:20.000000', 'temperatura', 1067.0000, 'ºC'),
	(149437, 120, '2014-01-15 00:05:21.000000', 'temperatura', 709.0000, 'ºC'),
	(149438, 120, '2014-01-15 00:05:22.000000', 'temperatura', 342.0000, 'ºC'),
	(149439, 120, '2014-01-15 00:05:23.000000', 'temperatura', 786.0000, 'ºC'),
	(149440, 120, '2014-01-15 00:05:24.000000', 'temperatura', 503.0000, 'ºC'),
	(149441, 120, '2014-01-15 00:05:25.000000', 'temperatura', 157.0000, 'ºC'),
	(149442, 120, '2014-01-15 00:05:26.000000', 'temperatura', 479.0000, 'ºC'),
	(149443, 120, '2014-01-15 00:05:27.000000', 'temperatura', 722.0000, 'ºC'),
	(149444, 120, '2014-01-15 00:05:28.000000', 'temperatura', 976.0000, 'ºC'),
	(149445, 120, '2014-01-15 00:05:29.000000', 'temperatura', 314.0000, 'ºC'),
	(149446, 120, '2014-01-15 00:05:30.000000', 'temperatura', 1042.0000, 'ºC'),
	(149447, 120, '2014-01-15 00:05:31.000000', 'temperatura', 669.0000, 'ºC'),
	(149448, 120, '2014-01-15 00:05:32.000000', 'temperatura', 218.0000, 'ºC'),
	(149449, 120, '2014-01-15 00:05:33.000000', 'temperatura', 284.0000, 'ºC'),
	(149450, 120, '2014-01-15 00:05:34.000000', 'temperatura', 768.0000, 'ºC'),
	(149451, 120, '2014-01-15 00:05:35.000000', 'temperatura', 587.0000, 'ºC'),
	(149452, 120, '2014-01-15 00:05:36.000000', 'temperatura', 631.0000, 'ºC'),
	(149453, 120, '2014-01-15 00:05:37.000000', 'temperatura', 194.0000, 'ºC'),
	(149454, 120, '2014-01-15 00:05:38.000000', 'temperatura', 278.0000, 'ºC'),
	(149455, 120, '2014-01-15 00:05:39.000000', 'temperatura', 808.0000, 'ºC'),
	(149456, 120, '2014-01-15 00:05:40.000000', 'temperatura', 808.0000, 'ºC'),
	(149457, 120, '2014-01-15 00:05:41.000000', 'temperatura', 415.0000, 'ºC'),
	(149458, 120, '2014-01-15 00:05:42.000000', 'temperatura', 851.0000, 'ºC'),
	(149459, 120, '2014-01-15 00:05:43.000000', 'temperatura', 611.0000, 'ºC'),
	(149460, 120, '2014-01-15 00:05:44.000000', 'temperatura', 502.0000, 'ºC'),
	(149461, 120, '2014-01-15 00:05:45.000000', 'temperatura', 678.0000, 'ºC'),
	(149462, 120, '2014-01-15 00:05:46.000000', 'temperatura', 686.0000, 'ºC'),
	(149463, 120, '2014-01-15 00:05:47.000000', 'temperatura', 196.0000, 'ºC'),
	(149464, 120, '2014-01-15 00:05:48.000000', 'temperatura', 121.0000, 'ºC'),
	(149465, 120, '2014-01-15 00:05:49.000000', 'temperatura', 19.0000, 'ºC'),
	(149466, 120, '2014-01-15 00:05:50.000000', 'temperatura', 932.0000, 'ºC'),
	(149467, 120, '2014-01-15 00:05:51.000000', 'temperatura', 1004.0000, 'ºC'),
	(149468, 120, '2014-01-15 00:05:52.000000', 'temperatura', 1022.0000, 'ºC'),
	(149469, 120, '2014-01-15 00:05:53.000000', 'temperatura', 900.0000, 'ºC'),
	(149470, 120, '2014-01-15 00:05:54.000000', 'temperatura', 235.0000, 'ºC'),
	(149471, 120, '2014-01-15 00:05:55.000000', 'temperatura', 875.0000, 'ºC'),
	(149472, 120, '2014-01-15 00:05:56.000000', 'temperatura', 69.0000, 'ºC'),
	(149473, 120, '2014-01-15 00:05:57.000000', 'temperatura', 121.0000, 'ºC'),
	(149474, 120, '2014-01-15 00:05:58.000000', 'temperatura', 400.0000, 'ºC'),
	(149475, 120, '2014-01-15 00:05:59.000000', 'temperatura', 435.0000, 'ºC'),
	(149476, 120, '2014-01-15 00:06:00.000000', 'temperatura', 977.0000, 'ºC'),
	(149477, 120, '2014-01-15 00:06:01.000000', 'temperatura', 1179.0000, 'ºC'),
	(149478, 120, '2014-01-15 00:06:02.000000', 'temperatura', 565.0000, 'ºC'),
	(149479, 120, '2014-01-15 00:06:03.000000', 'temperatura', 490.0000, 'ºC'),
	(149480, 120, '2014-01-15 00:06:04.000000', 'temperatura', 754.0000, 'ºC'),
	(149481, 120, '2014-01-15 00:06:05.000000', 'temperatura', 1103.0000, 'ºC'),
	(149482, 120, '2014-01-15 00:06:06.000000', 'temperatura', 851.0000, 'ºC'),
	(149483, 120, '2014-01-15 00:06:07.000000', 'temperatura', 949.0000, 'ºC'),
	(149484, 120, '2014-01-15 00:06:08.000000', 'temperatura', 991.0000, 'ºC'),
	(149485, 120, '2014-01-15 00:06:09.000000', 'temperatura', 907.0000, 'ºC'),
	(149486, 120, '2014-01-15 00:06:10.000000', 'temperatura', 363.0000, 'ºC'),
	(149487, 120, '2014-01-15 00:06:11.000000', 'temperatura', 293.0000, 'ºC'),
	(149488, 120, '2014-01-15 00:06:12.000000', 'temperatura', 380.0000, 'ºC'),
	(149489, 120, '2014-01-15 00:06:13.000000', 'temperatura', 1020.0000, 'ºC'),
	(149490, 120, '2014-01-15 00:06:14.000000', 'temperatura', 359.0000, 'ºC'),
	(149491, 120, '2014-01-15 00:06:15.000000', 'temperatura', 1137.0000, 'ºC'),
	(149492, 120, '2014-01-15 00:06:16.000000', 'temperatura', 1009.0000, 'ºC'),
	(149493, 120, '2014-01-15 00:06:17.000000', 'temperatura', 435.0000, 'ºC'),
	(149494, 120, '2014-01-15 00:06:18.000000', 'temperatura', 347.0000, 'ºC'),
	(149495, 120, '2014-01-15 00:06:19.000000', 'temperatura', 431.0000, 'ºC'),
	(149496, 120, '2014-01-15 00:06:20.000000', 'temperatura', 1116.0000, 'ºC'),
	(149497, 120, '2014-01-15 00:06:21.000000', 'temperatura', 685.0000, 'ºC'),
	(149498, 120, '2014-01-15 00:06:22.000000', 'temperatura', 77.0000, 'ºC'),
	(149499, 120, '2014-01-15 00:06:23.000000', 'temperatura', 732.0000, 'ºC'),
	(149500, 120, '2014-01-15 00:06:24.000000', 'temperatura', 1031.0000, 'ºC'),
	(149501, 120, '2014-01-15 00:06:25.000000', 'temperatura', 559.0000, 'ºC'),
	(149502, 120, '2014-01-15 00:06:26.000000', 'temperatura', 904.0000, 'ºC'),
	(149503, 120, '2014-01-15 00:06:27.000000', 'temperatura', 442.0000, 'ºC'),
	(149504, 120, '2014-01-15 00:06:28.000000', 'temperatura', 700.0000, 'ºC'),
	(149505, 120, '2014-01-15 00:06:29.000000', 'temperatura', 971.0000, 'ºC'),
	(149506, 120, '2014-01-15 00:06:30.000000', 'temperatura', 359.0000, 'ºC'),
	(149507, 120, '2014-01-15 00:06:31.000000', 'temperatura', 81.0000, 'ºC'),
	(149508, 120, '2014-01-15 00:06:32.000000', 'temperatura', 530.0000, 'ºC'),
	(149509, 120, '2014-01-15 00:06:33.000000', 'temperatura', 8.0000, 'ºC'),
	(149510, 120, '2014-01-15 00:06:34.000000', 'temperatura', 852.0000, 'ºC'),
	(149511, 120, '2014-01-15 00:06:35.000000', 'temperatura', 633.0000, 'ºC'),
	(149512, 120, '2014-01-15 00:06:36.000000', 'temperatura', 612.0000, 'ºC'),
	(149513, 120, '2014-01-15 00:06:37.000000', 'temperatura', 1160.0000, 'ºC'),
	(149514, 120, '2014-01-15 00:06:38.000000', 'temperatura', 363.0000, 'ºC'),
	(149515, 120, '2014-01-15 00:06:39.000000', 'temperatura', 737.0000, 'ºC'),
	(149516, 120, '2014-01-15 00:06:40.000000', 'temperatura', 196.0000, 'ºC'),
	(149517, 120, '2014-01-15 00:06:41.000000', 'temperatura', 1169.0000, 'ºC'),
	(149518, 120, '2014-01-15 00:06:42.000000', 'temperatura', 459.0000, 'ºC'),
	(149519, 120, '2014-01-15 00:06:43.000000', 'temperatura', 1186.0000, 'ºC'),
	(149520, 120, '2014-01-15 00:06:44.000000', 'temperatura', 955.0000, 'ºC'),
	(149521, 120, '2014-01-15 00:06:45.000000', 'temperatura', 16.0000, 'ºC'),
	(149522, 120, '2014-01-15 00:06:46.000000', 'temperatura', 817.0000, 'ºC'),
	(149523, 120, '2014-01-15 00:06:47.000000', 'temperatura', 435.0000, 'ºC'),
	(149524, 120, '2014-01-15 00:06:48.000000', 'temperatura', 926.0000, 'ºC'),
	(149525, 120, '2014-01-15 00:06:49.000000', 'temperatura', 927.0000, 'ºC'),
	(149526, 120, '2014-01-15 00:06:50.000000', 'temperatura', 657.0000, 'ºC'),
	(149527, 120, '2014-01-15 00:06:51.000000', 'temperatura', 503.0000, 'ºC'),
	(149528, 120, '2014-01-15 00:06:52.000000', 'temperatura', 546.0000, 'ºC'),
	(149529, 120, '2014-01-15 00:06:53.000000', 'temperatura', 21.0000, 'ºC'),
	(149530, 120, '2014-01-15 00:06:54.000000', 'temperatura', 867.0000, 'ºC'),
	(149531, 120, '2014-01-15 00:06:55.000000', 'temperatura', 674.0000, 'ºC'),
	(149532, 120, '2014-01-15 00:06:56.000000', 'temperatura', 769.0000, 'ºC'),
	(149533, 120, '2014-01-15 00:06:57.000000', 'temperatura', 624.0000, 'ºC'),
	(149534, 120, '2014-01-15 00:06:58.000000', 'temperatura', 813.0000, 'ºC'),
	(149535, 120, '2014-01-15 00:06:59.000000', 'temperatura', 995.0000, 'ºC'),
	(149536, 120, '2014-01-15 00:07:00.000000', 'temperatura', 134.0000, 'ºC'),
	(149537, 120, '2014-01-15 00:07:01.000000', 'temperatura', 88.0000, 'ºC'),
	(149538, 120, '2014-01-15 00:07:02.000000', 'temperatura', 35.0000, 'ºC'),
	(149539, 120, '2014-01-15 00:07:03.000000', 'temperatura', 1115.0000, 'ºC'),
	(149540, 120, '2014-01-15 00:07:04.000000', 'temperatura', 668.0000, 'ºC'),
	(149541, 120, '2014-01-15 00:07:05.000000', 'temperatura', 1196.0000, 'ºC'),
	(149542, 120, '2014-01-15 00:07:06.000000', 'temperatura', 376.0000, 'ºC'),
	(149543, 120, '2014-01-15 00:07:07.000000', 'temperatura', 692.0000, 'ºC'),
	(149544, 120, '2014-01-15 00:07:08.000000', 'temperatura', 1133.0000, 'ºC'),
	(149545, 120, '2014-01-15 00:07:09.000000', 'temperatura', 1191.0000, 'ºC'),
	(149546, 120, '2014-01-15 00:07:10.000000', 'temperatura', 157.0000, 'ºC'),
	(149547, 120, '2014-01-15 00:07:11.000000', 'temperatura', 810.0000, 'ºC'),
	(149548, 120, '2014-01-15 00:07:12.000000', 'temperatura', 1181.0000, 'ºC'),
	(149549, 120, '2014-01-15 00:07:13.000000', 'temperatura', 1076.0000, 'ºC'),
	(149550, 120, '2014-01-15 00:07:14.000000', 'temperatura', 635.0000, 'ºC'),
	(149551, 120, '2014-01-15 00:07:15.000000', 'temperatura', 1150.0000, 'ºC'),
	(149552, 120, '2014-01-15 00:07:16.000000', 'temperatura', 246.0000, 'ºC'),
	(149553, 120, '2014-01-15 00:07:17.000000', 'temperatura', 181.0000, 'ºC'),
	(149554, 120, '2014-01-15 00:07:18.000000', 'temperatura', 167.0000, 'ºC'),
	(149555, 120, '2014-01-15 00:07:19.000000', 'temperatura', 291.0000, 'ºC'),
	(149556, 120, '2014-01-15 00:07:20.000000', 'temperatura', 956.0000, 'ºC'),
	(149557, 120, '2014-01-15 00:07:21.000000', 'temperatura', 307.0000, 'ºC'),
	(149558, 120, '2014-01-15 00:07:22.000000', 'temperatura', 1070.0000, 'ºC'),
	(149559, 120, '2014-01-15 00:07:23.000000', 'temperatura', 826.0000, 'ºC'),
	(149560, 120, '2014-01-15 00:07:24.000000', 'temperatura', 923.0000, 'ºC'),
	(149561, 120, '2014-01-15 00:07:25.000000', 'temperatura', 935.0000, 'ºC'),
	(149562, 120, '2014-01-15 00:07:26.000000', 'temperatura', 708.0000, 'ºC'),
	(149563, 120, '2014-01-15 00:07:27.000000', 'temperatura', 733.0000, 'ºC'),
	(149564, 120, '2014-01-15 00:07:28.000000', 'temperatura', 345.0000, 'ºC'),
	(149565, 120, '2014-01-15 00:07:29.000000', 'temperatura', 725.0000, 'ºC'),
	(149566, 120, '2014-01-15 00:07:30.000000', 'temperatura', 191.0000, 'ºC'),
	(149567, 120, '2014-01-15 00:07:31.000000', 'temperatura', 1178.0000, 'ºC'),
	(149568, 120, '2014-01-15 00:07:32.000000', 'temperatura', 521.0000, 'ºC'),
	(149569, 120, '2014-01-15 00:07:33.000000', 'temperatura', 269.0000, 'ºC'),
	(149570, 120, '2014-01-15 00:07:34.000000', 'temperatura', 981.0000, 'ºC'),
	(149571, 120, '2014-01-15 00:07:35.000000', 'temperatura', 501.0000, 'ºC'),
	(149572, 120, '2014-01-15 00:07:36.000000', 'temperatura', 764.0000, 'ºC'),
	(149573, 120, '2014-01-15 00:07:37.000000', 'temperatura', 1115.0000, 'ºC'),
	(149574, 120, '2014-01-15 00:07:38.000000', 'temperatura', 884.0000, 'ºC'),
	(149575, 120, '2014-01-15 00:07:39.000000', 'temperatura', 1076.0000, 'ºC'),
	(149576, 120, '2014-01-15 00:07:40.000000', 'temperatura', 327.0000, 'ºC'),
	(149577, 120, '2014-01-15 00:07:41.000000', 'temperatura', 810.0000, 'ºC'),
	(149578, 120, '2014-01-15 00:07:42.000000', 'temperatura', 670.0000, 'ºC'),
	(149579, 120, '2014-01-15 00:07:43.000000', 'temperatura', 918.0000, 'ºC'),
	(149580, 120, '2014-01-15 00:07:44.000000', 'temperatura', 183.0000, 'ºC'),
	(149581, 120, '2014-01-15 00:07:45.000000', 'temperatura', 559.0000, 'ºC'),
	(149582, 120, '2014-01-15 00:07:46.000000', 'temperatura', 1046.0000, 'ºC'),
	(149583, 120, '2014-01-15 00:07:47.000000', 'temperatura', 1156.0000, 'ºC'),
	(149584, 120, '2014-01-15 00:07:48.000000', 'temperatura', 243.0000, 'ºC'),
	(149585, 120, '2014-01-15 00:07:49.000000', 'temperatura', 148.0000, 'ºC'),
	(149586, 120, '2014-01-15 00:07:50.000000', 'temperatura', 10.0000, 'ºC'),
	(149587, 120, '2014-01-15 00:07:51.000000', 'temperatura', 808.0000, 'ºC'),
	(149588, 120, '2014-01-15 00:07:52.000000', 'temperatura', 408.0000, 'ºC'),
	(149589, 120, '2014-01-15 00:07:53.000000', 'temperatura', 819.0000, 'ºC'),
	(149590, 120, '2014-01-15 00:07:54.000000', 'temperatura', 471.0000, 'ºC'),
	(149591, 120, '2014-01-15 00:07:55.000000', 'temperatura', 1097.0000, 'ºC'),
	(149592, 120, '2014-01-15 00:07:56.000000', 'temperatura', 475.0000, 'ºC'),
	(149593, 120, '2014-01-15 00:07:57.000000', 'temperatura', 281.0000, 'ºC'),
	(149594, 120, '2014-01-15 00:07:58.000000', 'temperatura', 1183.0000, 'ºC'),
	(149595, 120, '2014-01-15 00:07:59.000000', 'temperatura', 274.0000, 'ºC'),
	(149596, 120, '2014-01-15 00:08:00.000000', 'temperatura', 220.0000, 'ºC'),
	(149597, 120, '2014-01-15 00:08:01.000000', 'temperatura', 278.0000, 'ºC'),
	(149598, 120, '2014-01-15 00:08:02.000000', 'temperatura', 731.0000, 'ºC'),
	(149599, 120, '2014-01-15 00:08:03.000000', 'temperatura', 421.0000, 'ºC'),
	(149600, 120, '2014-01-15 00:08:04.000000', 'temperatura', 1114.0000, 'ºC'),
	(149601, 120, '2014-01-15 00:08:05.000000', 'temperatura', 706.0000, 'ºC'),
	(149602, 120, '2014-01-15 00:08:06.000000', 'temperatura', 190.0000, 'ºC'),
	(149603, 120, '2014-01-15 00:08:07.000000', 'temperatura', 30.0000, 'ºC'),
	(149604, 120, '2014-01-15 00:08:08.000000', 'temperatura', 781.0000, 'ºC'),
	(149605, 120, '2014-01-15 00:08:09.000000', 'temperatura', 217.0000, 'ºC'),
	(149606, 120, '2014-01-15 00:08:10.000000', 'temperatura', 1140.0000, 'ºC'),
	(149607, 120, '2014-01-15 00:08:11.000000', 'temperatura', 252.0000, 'ºC'),
	(149608, 120, '2014-01-15 00:08:12.000000', 'temperatura', 240.0000, 'ºC'),
	(149609, 120, '2014-01-15 00:08:13.000000', 'temperatura', 445.0000, 'ºC'),
	(149610, 120, '2014-01-15 00:08:14.000000', 'temperatura', 305.0000, 'ºC'),
	(149611, 120, '2014-01-15 00:08:15.000000', 'temperatura', 190.0000, 'ºC'),
	(149612, 120, '2014-01-15 00:08:16.000000', 'temperatura', 36.0000, 'ºC'),
	(149613, 120, '2014-01-15 00:08:17.000000', 'temperatura', 812.0000, 'ºC'),
	(149614, 120, '2014-01-15 00:08:18.000000', 'temperatura', 353.0000, 'ºC'),
	(149615, 120, '2014-01-15 00:08:19.000000', 'temperatura', 527.0000, 'ºC'),
	(149616, 120, '2014-01-15 00:08:20.000000', 'temperatura', 376.0000, 'ºC'),
	(149617, 120, '2014-01-15 00:08:21.000000', 'temperatura', 301.0000, 'ºC'),
	(149618, 120, '2014-01-15 00:08:22.000000', 'temperatura', 377.0000, 'ºC'),
	(149619, 120, '2014-01-15 00:08:23.000000', 'temperatura', 983.0000, 'ºC'),
	(149620, 120, '2014-01-15 00:08:24.000000', 'temperatura', 183.0000, 'ºC'),
	(149621, 120, '2014-01-15 00:08:25.000000', 'temperatura', 366.0000, 'ºC'),
	(149622, 120, '2014-01-15 00:08:26.000000', 'temperatura', 82.0000, 'ºC'),
	(149623, 120, '2014-01-15 00:08:27.000000', 'temperatura', 514.0000, 'ºC'),
	(149624, 120, '2014-01-15 00:08:28.000000', 'temperatura', 1123.0000, 'ºC'),
	(149625, 120, '2014-01-15 00:08:29.000000', 'temperatura', 472.0000, 'ºC'),
	(149626, 120, '2014-01-15 00:08:30.000000', 'temperatura', 194.0000, 'ºC'),
	(149627, 120, '2014-01-15 00:08:31.000000', 'temperatura', 755.0000, 'ºC'),
	(149628, 120, '2014-01-15 00:08:32.000000', 'temperatura', 792.0000, 'ºC'),
	(149629, 120, '2014-01-15 00:08:33.000000', 'temperatura', 495.0000, 'ºC'),
	(149630, 120, '2014-01-15 00:08:34.000000', 'temperatura', 99.0000, 'ºC'),
	(149631, 120, '2014-01-15 00:08:35.000000', 'temperatura', 211.0000, 'ºC'),
	(149632, 120, '2014-01-15 00:08:36.000000', 'temperatura', 757.0000, 'ºC'),
	(149633, 120, '2014-01-15 00:08:37.000000', 'temperatura', 756.0000, 'ºC'),
	(149634, 120, '2014-01-15 00:08:38.000000', 'temperatura', 307.0000, 'ºC'),
	(149635, 120, '2014-01-15 00:08:39.000000', 'temperatura', 469.0000, 'ºC'),
	(149636, 120, '2014-01-15 00:08:40.000000', 'temperatura', 224.0000, 'ºC'),
	(149637, 120, '2014-01-15 00:08:41.000000', 'temperatura', 913.0000, 'ºC'),
	(149638, 120, '2014-01-15 00:08:42.000000', 'temperatura', 294.0000, 'ºC'),
	(149639, 120, '2014-01-15 00:08:43.000000', 'temperatura', 1130.0000, 'ºC'),
	(149640, 120, '2014-01-15 00:08:44.000000', 'temperatura', 1170.0000, 'ºC'),
	(149641, 120, '2014-01-15 00:08:45.000000', 'temperatura', 62.0000, 'ºC'),
	(149642, 120, '2014-01-15 00:08:46.000000', 'temperatura', 399.0000, 'ºC'),
	(149643, 120, '2014-01-15 00:08:47.000000', 'temperatura', 610.0000, 'ºC'),
	(149644, 120, '2014-01-15 00:08:48.000000', 'temperatura', 654.0000, 'ºC'),
	(149645, 120, '2014-01-15 00:08:49.000000', 'temperatura', 240.0000, 'ºC'),
	(149646, 120, '2014-01-15 00:08:50.000000', 'temperatura', 440.0000, 'ºC'),
	(149647, 120, '2014-01-15 00:08:51.000000', 'temperatura', 281.0000, 'ºC'),
	(149648, 120, '2014-01-15 00:08:52.000000', 'temperatura', 84.0000, 'ºC'),
	(149649, 120, '2014-01-15 00:08:53.000000', 'temperatura', 779.0000, 'ºC'),
	(149650, 120, '2014-01-15 00:08:54.000000', 'temperatura', 44.0000, 'ºC'),
	(149651, 120, '2014-01-15 00:08:55.000000', 'temperatura', 281.0000, 'ºC'),
	(149652, 120, '2014-01-15 00:08:56.000000', 'temperatura', 75.0000, 'ºC'),
	(149653, 120, '2014-01-15 00:08:57.000000', 'temperatura', 733.0000, 'ºC'),
	(149654, 120, '2014-01-15 00:08:58.000000', 'temperatura', 1038.0000, 'ºC'),
	(149655, 120, '2014-01-15 00:08:59.000000', 'temperatura', 594.0000, 'ºC'),
	(149656, 120, '2014-01-15 00:09:00.000000', 'temperatura', 1055.0000, 'ºC'),
	(149657, 120, '2014-01-15 00:09:01.000000', 'temperatura', 1094.0000, 'ºC'),
	(149658, 120, '2014-01-15 00:09:02.000000', 'temperatura', 1107.0000, 'ºC'),
	(149659, 120, '2014-01-15 00:09:03.000000', 'temperatura', 1053.0000, 'ºC'),
	(149660, 120, '2014-01-15 00:09:04.000000', 'temperatura', 743.0000, 'ºC'),
	(149661, 120, '2014-01-15 00:09:05.000000', 'temperatura', 558.0000, 'ºC'),
	(149662, 120, '2014-01-15 00:09:06.000000', 'temperatura', 559.0000, 'ºC'),
	(149663, 120, '2014-01-15 00:09:07.000000', 'temperatura', 1125.0000, 'ºC'),
	(149664, 120, '2014-01-15 00:09:08.000000', 'temperatura', 347.0000, 'ºC'),
	(149665, 120, '2014-01-15 00:09:09.000000', 'temperatura', 759.0000, 'ºC'),
	(149666, 120, '2014-01-15 00:09:10.000000', 'temperatura', 353.0000, 'ºC'),
	(149667, 120, '2014-01-15 00:09:11.000000', 'temperatura', 692.0000, 'ºC'),
	(149668, 120, '2014-01-15 00:09:12.000000', 'temperatura', 2.0000, 'ºC'),
	(149669, 120, '2014-01-15 00:09:13.000000', 'temperatura', 332.0000, 'ºC'),
	(149670, 120, '2014-01-15 00:09:14.000000', 'temperatura', 454.0000, 'ºC'),
	(149671, 120, '2014-01-15 00:09:15.000000', 'temperatura', 75.0000, 'ºC'),
	(149672, 120, '2014-01-15 00:09:16.000000', 'temperatura', 215.0000, 'ºC'),
	(149673, 120, '2014-01-15 00:09:17.000000', 'temperatura', 850.0000, 'ºC'),
	(149674, 120, '2014-01-15 00:09:18.000000', 'temperatura', 7.0000, 'ºC'),
	(149675, 120, '2014-01-15 00:09:19.000000', 'temperatura', 1085.0000, 'ºC'),
	(149676, 120, '2014-01-15 00:09:20.000000', 'temperatura', 602.0000, 'ºC'),
	(149677, 120, '2014-01-15 00:09:21.000000', 'temperatura', 959.0000, 'ºC'),
	(149678, 120, '2014-01-15 00:09:22.000000', 'temperatura', 587.0000, 'ºC'),
	(149679, 120, '2014-01-15 00:09:23.000000', 'temperatura', 61.0000, 'ºC'),
	(149680, 120, '2014-01-15 00:09:24.000000', 'temperatura', 943.0000, 'ºC'),
	(149681, 120, '2014-01-15 00:09:25.000000', 'temperatura', 931.0000, 'ºC'),
	(149682, 120, '2014-01-15 00:09:26.000000', 'temperatura', 629.0000, 'ºC'),
	(149683, 120, '2014-01-15 00:09:27.000000', 'temperatura', 351.0000, 'ºC'),
	(149684, 120, '2014-01-15 00:09:28.000000', 'temperatura', 1069.0000, 'ºC'),
	(149685, 120, '2014-01-15 00:09:29.000000', 'temperatura', 691.0000, 'ºC'),
	(149686, 120, '2014-01-15 00:09:30.000000', 'temperatura', 251.0000, 'ºC'),
	(149687, 120, '2014-01-15 00:09:31.000000', 'temperatura', 379.0000, 'ºC'),
	(149688, 120, '2014-01-15 00:09:32.000000', 'temperatura', 1146.0000, 'ºC'),
	(149689, 120, '2014-01-15 00:09:33.000000', 'temperatura', 992.0000, 'ºC'),
	(149690, 120, '2014-01-15 00:09:34.000000', 'temperatura', 325.0000, 'ºC'),
	(149691, 120, '2014-01-15 00:09:35.000000', 'temperatura', 1047.0000, 'ºC'),
	(149692, 120, '2014-01-15 00:09:36.000000', 'temperatura', 659.0000, 'ºC'),
	(149693, 120, '2014-01-15 00:09:37.000000', 'temperatura', 156.0000, 'ºC'),
	(149694, 120, '2014-01-15 00:09:38.000000', 'temperatura', 4.0000, 'ºC'),
	(149695, 120, '2014-01-15 00:09:39.000000', 'temperatura', 752.0000, 'ºC'),
	(149696, 120, '2014-01-15 00:09:40.000000', 'temperatura', 150.0000, 'ºC'),
	(149697, 120, '2014-01-15 00:09:41.000000', 'temperatura', 893.0000, 'ºC'),
	(149698, 120, '2014-01-15 00:09:42.000000', 'temperatura', 417.0000, 'ºC'),
	(149699, 120, '2014-01-15 00:09:43.000000', 'temperatura', 607.0000, 'ºC'),
	(149700, 120, '2014-01-15 00:09:44.000000', 'temperatura', 585.0000, 'ºC'),
	(149701, 120, '2014-01-15 00:09:45.000000', 'temperatura', 1105.0000, 'ºC'),
	(149702, 120, '2014-01-15 00:09:46.000000', 'temperatura', 170.0000, 'ºC'),
	(149703, 120, '2014-01-15 00:09:47.000000', 'temperatura', 1136.0000, 'ºC'),
	(149704, 120, '2014-01-15 00:09:48.000000', 'temperatura', 372.0000, 'ºC'),
	(149705, 120, '2014-01-15 00:09:49.000000', 'temperatura', 849.0000, 'ºC'),
	(149706, 120, '2014-01-15 00:09:50.000000', 'temperatura', 731.0000, 'ºC'),
	(149707, 120, '2014-01-15 00:09:51.000000', 'temperatura', 1107.0000, 'ºC'),
	(149708, 120, '2014-01-15 00:09:52.000000', 'temperatura', 941.0000, 'ºC'),
	(149709, 120, '2014-01-15 00:09:53.000000', 'temperatura', 188.0000, 'ºC'),
	(149710, 120, '2014-01-15 00:09:54.000000', 'temperatura', 517.0000, 'ºC'),
	(149711, 120, '2014-01-15 00:09:55.000000', 'temperatura', 821.0000, 'ºC'),
	(149712, 120, '2014-01-15 00:09:56.000000', 'temperatura', 154.0000, 'ºC'),
	(149713, 120, '2014-01-15 00:09:57.000000', 'temperatura', 707.0000, 'ºC'),
	(149714, 120, '2014-01-15 00:09:58.000000', 'temperatura', 675.0000, 'ºC'),
	(149715, 120, '2014-01-15 00:09:59.000000', 'temperatura', 54.0000, 'ºC'),
	(149716, 120, '2014-01-15 00:10:00.000000', 'temperatura', 644.0000, 'ºC'),
	(149717, 120, '2014-01-15 00:10:01.000000', 'temperatura', 658.0000, 'ºC'),
	(149718, 120, '2014-01-15 00:10:02.000000', 'temperatura', 161.0000, 'ºC'),
	(149719, 120, '2014-01-15 00:10:03.000000', 'temperatura', 33.0000, 'ºC'),
	(149720, 120, '2014-01-15 00:10:04.000000', 'temperatura', 879.0000, 'ºC'),
	(149721, 120, '2014-01-15 00:10:05.000000', 'temperatura', 698.0000, 'ºC'),
	(149722, 120, '2014-01-15 00:10:06.000000', 'temperatura', 852.0000, 'ºC'),
	(149723, 120, '2014-01-15 00:10:07.000000', 'temperatura', 968.0000, 'ºC'),
	(149724, 120, '2014-01-15 00:10:08.000000', 'temperatura', 1083.0000, 'ºC'),
	(149725, 120, '2014-01-15 00:10:09.000000', 'temperatura', 114.0000, 'ºC'),
	(149726, 120, '2014-01-15 00:10:10.000000', 'temperatura', 919.0000, 'ºC'),
	(149727, 120, '2014-01-15 00:10:11.000000', 'temperatura', 654.0000, 'ºC'),
	(149728, 120, '2014-01-15 00:10:12.000000', 'temperatura', 513.0000, 'ºC'),
	(149729, 120, '2014-01-15 00:10:13.000000', 'temperatura', 606.0000, 'ºC'),
	(149730, 120, '2014-01-15 00:10:14.000000', 'temperatura', 289.0000, 'ºC'),
	(149731, 120, '2014-01-15 00:10:15.000000', 'temperatura', 827.0000, 'ºC'),
	(149732, 120, '2014-01-15 00:10:16.000000', 'temperatura', 868.0000, 'ºC'),
	(149733, 120, '2014-01-15 00:10:17.000000', 'temperatura', 660.0000, 'ºC'),
	(149734, 120, '2014-01-15 00:10:18.000000', 'temperatura', 697.0000, 'ºC'),
	(149735, 120, '2014-01-15 00:10:19.000000', 'temperatura', 304.0000, 'ºC'),
	(149736, 120, '2014-01-15 00:10:20.000000', 'temperatura', 631.0000, 'ºC'),
	(149737, 120, '2014-01-15 00:10:21.000000', 'temperatura', 1041.0000, 'ºC'),
	(149738, 120, '2014-01-15 00:10:22.000000', 'temperatura', 916.0000, 'ºC'),
	(149739, 120, '2014-01-15 00:10:23.000000', 'temperatura', 256.0000, 'ºC'),
	(149740, 120, '2014-01-15 00:10:24.000000', 'temperatura', 933.0000, 'ºC'),
	(149741, 120, '2014-01-15 00:10:25.000000', 'temperatura', 296.0000, 'ºC'),
	(149742, 120, '2014-01-15 00:10:26.000000', 'temperatura', 1082.0000, 'ºC'),
	(149743, 120, '2014-01-15 00:10:27.000000', 'temperatura', 921.0000, 'ºC'),
	(149744, 120, '2014-01-15 00:10:28.000000', 'temperatura', 159.0000, 'ºC'),
	(149745, 120, '2014-01-15 00:10:29.000000', 'temperatura', 434.0000, 'ºC'),
	(149746, 120, '2014-01-15 00:10:30.000000', 'temperatura', 495.0000, 'ºC'),
	(149747, 120, '2014-01-15 00:10:31.000000', 'temperatura', 1172.0000, 'ºC'),
	(149748, 120, '2014-01-15 00:10:32.000000', 'temperatura', 775.0000, 'ºC'),
	(149749, 120, '2014-01-15 00:10:33.000000', 'temperatura', 361.0000, 'ºC'),
	(149750, 120, '2014-01-15 00:10:34.000000', 'temperatura', 678.0000, 'ºC'),
	(149751, 120, '2014-01-15 00:10:35.000000', 'temperatura', 1107.0000, 'ºC'),
	(149752, 120, '2014-01-15 00:10:36.000000', 'temperatura', 1105.0000, 'ºC'),
	(149753, 120, '2014-01-15 00:10:37.000000', 'temperatura', 1002.0000, 'ºC'),
	(149754, 120, '2014-01-15 00:10:38.000000', 'temperatura', 494.0000, 'ºC'),
	(149755, 120, '2014-01-15 00:10:39.000000', 'temperatura', 666.0000, 'ºC'),
	(149756, 120, '2014-01-15 00:10:40.000000', 'temperatura', 650.0000, 'ºC'),
	(149757, 120, '2014-01-15 00:10:41.000000', 'temperatura', 51.0000, 'ºC'),
	(149758, 120, '2014-01-15 00:10:42.000000', 'temperatura', 705.0000, 'ºC'),
	(149759, 120, '2014-01-15 00:10:43.000000', 'temperatura', 974.0000, 'ºC'),
	(149760, 120, '2014-01-15 00:10:44.000000', 'temperatura', 354.0000, 'ºC'),
	(149761, 120, '2014-01-15 00:10:45.000000', 'temperatura', 49.0000, 'ºC'),
	(149762, 120, '2014-01-15 00:10:46.000000', 'temperatura', 382.0000, 'ºC'),
	(149763, 120, '2014-01-15 00:10:47.000000', 'temperatura', 566.0000, 'ºC'),
	(149764, 120, '2014-01-15 00:10:48.000000', 'temperatura', 484.0000, 'ºC'),
	(149765, 120, '2014-01-15 00:10:49.000000', 'temperatura', 723.0000, 'ºC'),
	(149766, 120, '2014-01-15 00:10:50.000000', 'temperatura', 965.0000, 'ºC'),
	(149767, 120, '2014-01-15 00:10:51.000000', 'temperatura', 255.0000, 'ºC'),
	(149768, 120, '2014-01-15 00:10:52.000000', 'temperatura', 782.0000, 'ºC'),
	(149769, 120, '2014-01-15 00:10:53.000000', 'temperatura', 743.0000, 'ºC'),
	(149770, 120, '2014-01-15 00:10:54.000000', 'temperatura', 172.0000, 'ºC'),
	(149771, 120, '2014-01-15 00:10:55.000000', 'temperatura', 1031.0000, 'ºC'),
	(149772, 120, '2014-01-15 00:10:56.000000', 'temperatura', 1039.0000, 'ºC'),
	(149773, 120, '2014-01-15 00:10:57.000000', 'temperatura', 903.0000, 'ºC'),
	(149774, 120, '2014-01-15 00:10:58.000000', 'temperatura', 198.0000, 'ºC'),
	(149775, 120, '2014-01-15 00:10:59.000000', 'temperatura', 681.0000, 'ºC'),
	(149776, 120, '2014-01-15 00:11:00.000000', 'temperatura', 413.0000, 'ºC'),
	(149777, 120, '2014-01-15 00:11:01.000000', 'temperatura', 21.0000, 'ºC'),
	(149778, 120, '2014-01-15 00:11:02.000000', 'temperatura', 68.0000, 'ºC'),
	(149779, 120, '2014-01-15 00:11:03.000000', 'temperatura', 277.0000, 'ºC'),
	(149780, 120, '2014-01-15 00:11:04.000000', 'temperatura', 1183.0000, 'ºC'),
	(149781, 120, '2014-01-15 00:11:05.000000', 'temperatura', 282.0000, 'ºC'),
	(149782, 120, '2014-01-15 00:11:06.000000', 'temperatura', 261.0000, 'ºC'),
	(149783, 120, '2014-01-15 00:11:07.000000', 'temperatura', 461.0000, 'ºC'),
	(149784, 120, '2014-01-15 00:11:08.000000', 'temperatura', 323.0000, 'ºC'),
	(149785, 120, '2014-01-15 00:11:09.000000', 'temperatura', 233.0000, 'ºC'),
	(149786, 120, '2014-01-15 00:11:10.000000', 'temperatura', 195.0000, 'ºC'),
	(149787, 120, '2014-01-15 00:11:11.000000', 'temperatura', 279.0000, 'ºC'),
	(149788, 120, '2014-01-15 00:11:12.000000', 'temperatura', 808.0000, 'ºC'),
	(149789, 120, '2014-01-15 00:11:13.000000', 'temperatura', 806.0000, 'ºC'),
	(149790, 120, '2014-01-15 00:11:14.000000', 'temperatura', 405.0000, 'ºC'),
	(149791, 120, '2014-01-15 00:11:15.000000', 'temperatura', 808.0000, 'ºC'),
	(149792, 120, '2014-01-15 00:11:16.000000', 'temperatura', 425.0000, 'ºC'),
	(149793, 120, '2014-01-15 00:11:17.000000', 'temperatura', 900.0000, 'ºC'),
	(149794, 120, '2014-01-15 00:11:18.000000', 'temperatura', 828.0000, 'ºC'),
	(149795, 120, '2014-01-15 00:11:19.000000', 'temperatura', 239.0000, 'ºC'),
	(149796, 120, '2014-01-15 00:11:20.000000', 'temperatura', 1110.0000, 'ºC'),
	(149797, 120, '2014-01-15 00:11:21.000000', 'temperatura', 36.0000, 'ºC'),
	(149798, 120, '2014-01-15 00:11:22.000000', 'temperatura', 451.0000, 'ºC'),
	(149799, 120, '2014-01-15 00:11:23.000000', 'temperatura', 945.0000, 'ºC'),
	(149800, 120, '2014-01-15 00:11:24.000000', 'temperatura', 975.0000, 'ºC'),
	(149801, 120, '2014-01-15 00:11:25.000000', 'temperatura', 839.0000, 'ºC'),
	(149802, 120, '2014-01-15 00:11:26.000000', 'temperatura', 69.0000, 'ºC'),
	(149803, 120, '2014-01-15 00:11:27.000000', 'temperatura', 229.0000, 'ºC'),
	(149804, 120, '2014-01-15 00:11:28.000000', 'temperatura', 938.0000, 'ºC'),
	(149805, 120, '2014-01-15 00:11:29.000000', 'temperatura', 406.0000, 'ºC'),
	(149806, 120, '2014-01-15 00:11:30.000000', 'temperatura', 413.0000, 'ºC'),
	(149807, 120, '2014-01-15 00:11:31.000000', 'temperatura', 851.0000, 'ºC'),
	(149808, 120, '2014-01-15 00:11:32.000000', 'temperatura', 614.0000, 'ºC'),
	(149809, 120, '2014-01-15 00:11:33.000000', 'temperatura', 518.0000, 'ºC'),
	(149810, 120, '2014-01-15 00:11:34.000000', 'temperatura', 750.0000, 'ºC'),
	(149811, 120, '2014-01-15 00:11:35.000000', 'temperatura', 994.0000, 'ºC'),
	(149812, 120, '2014-01-15 00:11:36.000000', 'temperatura', 320.0000, 'ºC'),
	(149813, 120, '2014-01-15 00:11:37.000000', 'temperatura', 1018.0000, 'ºC'),
	(149814, 120, '2014-01-15 00:11:38.000000', 'temperatura', 530.0000, 'ºC'),
	(149815, 120, '2014-01-15 00:11:39.000000', 'temperatura', 796.0000, 'ºC'),
	(149816, 120, '2014-01-15 00:11:40.000000', 'temperatura', 1190.0000, 'ºC'),
	(149817, 120, '2014-01-15 00:11:41.000000', 'temperatura', 1162.0000, 'ºC'),
	(149818, 120, '2014-01-15 00:11:42.000000', 'temperatura', 1043.0000, 'ºC'),
	(149819, 120, '2014-01-15 00:11:43.000000', 'temperatura', 529.0000, 'ºC'),
	(149820, 120, '2014-01-15 00:11:44.000000', 'temperatura', 716.0000, 'ºC'),
	(149821, 120, '2014-01-15 00:11:45.000000', 'temperatura', 792.0000, 'ºC'),
	(149822, 120, '2014-01-15 00:11:46.000000', 'temperatura', 615.0000, 'ºC'),
	(149823, 120, '2014-01-15 00:11:47.000000', 'temperatura', 698.0000, 'ºC'),
	(149824, 120, '2014-01-15 00:11:48.000000', 'temperatura', 444.0000, 'ºC'),
	(149825, 120, '2014-01-15 00:11:49.000000', 'temperatura', 128.0000, 'ºC'),
	(149826, 120, '2014-01-15 00:11:50.000000', 'temperatura', 506.0000, 'ºC'),
	(149827, 120, '2014-01-15 00:11:51.000000', 'temperatura', 950.0000, 'ºC'),
	(149828, 120, '2014-01-15 00:11:52.000000', 'temperatura', 831.0000, 'ºC'),
	(149829, 120, '2014-01-15 00:11:53.000000', 'temperatura', 105.0000, 'ºC'),
	(149830, 120, '2014-01-15 00:11:54.000000', 'temperatura', 434.0000, 'ºC'),
	(149831, 120, '2014-01-15 00:11:55.000000', 'temperatura', 654.0000, 'ºC'),
	(149832, 120, '2014-01-15 00:11:56.000000', 'temperatura', 771.0000, 'ºC'),
	(149833, 120, '2014-01-15 00:11:57.000000', 'temperatura', 692.0000, 'ºC'),
	(149834, 120, '2014-01-15 00:11:58.000000', 'temperatura', 1146.0000, 'ºC'),
	(149835, 120, '2014-01-15 00:11:59.000000', 'temperatura', 57.0000, 'ºC'),
	(149836, 120, '2014-01-15 00:12:00.000000', 'temperatura', 448.0000, 'ºC'),
	(149837, 120, '2014-01-15 00:12:01.000000', 'temperatura', 870.0000, 'ºC'),
	(149838, 120, '2014-01-15 00:12:02.000000', 'temperatura', 604.0000, 'ºC'),
	(149839, 120, '2014-01-15 00:12:03.000000', 'temperatura', 410.0000, 'ºC'),
	(149840, 120, '2014-01-15 00:12:04.000000', 'temperatura', 238.0000, 'ºC'),
	(149841, 120, '2014-01-15 00:12:05.000000', 'temperatura', 1162.0000, 'ºC'),
	(149842, 120, '2014-01-15 00:12:06.000000', 'temperatura', 296.0000, 'ºC'),
	(149843, 120, '2014-01-15 00:12:07.000000', 'temperatura', 395.0000, 'ºC'),
	(149844, 120, '2014-01-15 00:12:08.000000', 'temperatura', 1086.0000, 'ºC'),
	(149845, 120, '2014-01-15 00:12:09.000000', 'temperatura', 645.0000, 'ºC'),
	(149846, 120, '2014-01-15 00:12:10.000000', 'temperatura', 1168.0000, 'ºC'),
	(149847, 120, '2014-01-15 00:12:11.000000', 'temperatura', 304.0000, 'ºC'),
	(149848, 120, '2014-01-15 00:12:12.000000', 'temperatura', 419.0000, 'ºC'),
	(149849, 120, '2014-01-15 00:12:13.000000', 'temperatura', 1181.0000, 'ºC'),
	(149850, 120, '2014-01-15 00:12:14.000000', 'temperatura', 1048.0000, 'ºC'),
	(149851, 120, '2014-01-15 00:12:15.000000', 'temperatura', 498.0000, 'ºC'),
	(149852, 120, '2014-01-15 00:12:16.000000', 'temperatura', 546.0000, 'ºC'),
	(149853, 120, '2014-01-15 00:12:17.000000', 'temperatura', 37.0000, 'ºC'),
	(149854, 120, '2014-01-15 00:12:18.000000', 'temperatura', 947.0000, 'ºC'),
	(149855, 120, '2014-01-15 00:12:19.000000', 'temperatura', 1026.0000, 'ºC'),
	(149856, 120, '2014-01-15 00:12:20.000000', 'temperatura', 1089.0000, 'ºC'),
	(149857, 120, '2014-01-15 00:12:21.000000', 'temperatura', 1166.0000, 'ºC'),
	(149858, 120, '2014-01-15 00:12:22.000000', 'temperatura', 166.0000, 'ºC'),
	(149859, 120, '2014-01-15 00:12:23.000000', 'temperatura', 930.0000, 'ºC'),
	(149860, 120, '2014-01-15 00:12:24.000000', 'temperatura', 554.0000, 'ºC'),
	(149861, 120, '2014-01-15 00:12:25.000000', 'temperatura', 1182.0000, 'ºC'),
	(149862, 120, '2014-01-15 00:12:26.000000', 'temperatura', 645.0000, 'ºC'),
	(149863, 120, '2014-01-15 00:12:27.000000', 'temperatura', 883.0000, 'ºC'),
	(149864, 120, '2014-01-15 00:12:28.000000', 'temperatura', 77.0000, 'ºC'),
	(149865, 120, '2014-01-15 00:12:29.000000', 'temperatura', 140.0000, 'ºC'),
	(149866, 120, '2014-01-15 00:12:30.000000', 'temperatura', 469.0000, 'ºC'),
	(149867, 120, '2014-01-15 00:12:31.000000', 'temperatura', 723.0000, 'ºC'),
	(149868, 120, '2014-01-15 00:12:32.000000', 'temperatura', 1012.0000, 'ºC'),
	(149869, 120, '2014-01-15 00:12:33.000000', 'temperatura', 488.0000, 'ºC'),
	(149870, 120, '2014-01-15 00:12:34.000000', 'temperatura', 608.0000, 'ºC'),
	(149871, 120, '2014-01-15 00:12:35.000000', 'temperatura', 374.0000, 'ºC'),
	(149872, 120, '2014-01-15 00:12:36.000000', 'temperatura', 48.0000, 'ºC'),
	(149873, 120, '2014-01-15 00:12:37.000000', 'temperatura', 320.0000, 'ºC'),
	(149874, 120, '2014-01-15 00:12:38.000000', 'temperatura', 255.0000, 'ºC'),
	(149875, 120, '2014-01-15 00:12:39.000000', 'temperatura', 317.0000, 'ºC'),
	(149876, 120, '2014-01-15 00:12:40.000000', 'temperatura', 820.0000, 'ºC'),
	(149877, 120, '2014-01-15 00:12:41.000000', 'temperatura', 749.0000, 'ºC'),
	(149878, 120, '2014-01-15 00:12:42.000000', 'temperatura', 86.0000, 'ºC'),
	(149879, 120, '2014-01-15 00:12:43.000000', 'temperatura', 583.0000, 'ºC'),
	(149880, 120, '2014-01-15 00:12:44.000000', 'temperatura', 257.0000, 'ºC'),
	(149881, 120, '2014-01-15 00:12:45.000000', 'temperatura', 736.0000, 'ºC'),
	(149882, 120, '2014-01-15 00:12:46.000000', 'temperatura', 510.0000, 'ºC'),
	(149883, 120, '2014-01-15 00:12:47.000000', 'temperatura', 342.0000, 'ºC'),
	(149884, 120, '2014-01-15 00:12:48.000000', 'temperatura', 182.0000, 'ºC'),
	(149885, 120, '2014-01-15 00:12:49.000000', 'temperatura', 1086.0000, 'ºC'),
	(149886, 120, '2014-01-15 00:12:50.000000', 'temperatura', 81.0000, 'ºC'),
	(149887, 120, '2014-01-15 00:12:51.000000', 'temperatura', 748.0000, 'ºC'),
	(149888, 120, '2014-01-15 00:12:52.000000', 'temperatura', 1099.0000, 'ºC'),
	(149889, 120, '2014-01-15 00:12:53.000000', 'temperatura', 852.0000, 'ºC'),
	(149890, 120, '2014-01-15 00:12:54.000000', 'temperatura', 962.0000, 'ºC'),
	(149891, 120, '2014-01-15 00:12:55.000000', 'temperatura', 1055.0000, 'ºC'),
	(149892, 120, '2014-01-15 00:12:56.000000', 'temperatura', 1192.0000, 'ºC'),
	(149893, 120, '2014-01-15 00:12:57.000000', 'temperatura', 392.0000, 'ºC'),
	(149894, 120, '2014-01-15 00:12:58.000000', 'temperatura', 787.0000, 'ºC'),
	(149895, 120, '2014-01-15 00:12:59.000000', 'temperatura', 357.0000, 'ºC'),
	(149896, 120, '2014-01-15 00:13:00.000000', 'temperatura', 624.0000, 'ºC'),
	(149897, 120, '2014-01-15 00:13:01.000000', 'temperatura', 851.0000, 'ºC'),
	(149898, 120, '2014-01-15 00:13:02.000000', 'temperatura', 1183.0000, 'ºC'),
	(149899, 120, '2014-01-15 00:13:03.000000', 'temperatura', 963.0000, 'ºC'),
	(149900, 120, '2014-01-15 00:13:04.000000', 'temperatura', 65.0000, 'ºC'),
	(149901, 120, '2014-01-15 00:13:05.000000', 'temperatura', 1037.0000, 'ºC'),
	(149902, 120, '2014-01-15 00:13:06.000000', 'temperatura', 192.0000, 'ºC'),
	(149903, 120, '2014-01-15 00:13:07.000000', 'temperatura', 248.0000, 'ºC'),
	(149904, 120, '2014-01-15 00:13:08.000000', 'temperatura', 665.0000, 'ºC'),
	(149905, 120, '2014-01-15 00:13:09.000000', 'temperatura', 183.0000, 'ºC'),
	(149906, 120, '2014-01-15 00:13:10.000000', 'temperatura', 121.0000, 'ºC'),
	(149907, 120, '2014-01-15 00:13:11.000000', 'temperatura', 53.0000, 'ºC'),
	(149908, 120, '2014-01-15 00:13:12.000000', 'temperatura', 1106.0000, 'ºC'),
	(149909, 120, '2014-01-15 00:13:13.000000', 'temperatura', 570.0000, 'ºC'),
	(149910, 120, '2014-01-15 00:13:14.000000', 'temperatura', 734.0000, 'ºC'),
	(149911, 120, '2014-01-15 00:13:15.000000', 'temperatura', 759.0000, 'ºC'),
	(149912, 120, '2014-01-15 00:13:16.000000', 'temperatura', 395.0000, 'ºC'),
	(149913, 120, '2014-01-15 00:13:17.000000', 'temperatura', 896.0000, 'ºC'),
	(149914, 120, '2014-01-15 00:13:18.000000', 'temperatura', 897.0000, 'ºC'),
	(149915, 120, '2014-01-15 00:13:19.000000', 'temperatura', 598.0000, 'ºC'),
	(149916, 120, '2014-01-15 00:13:20.000000', 'temperatura', 300.0000, 'ºC'),
	(149917, 120, '2014-01-15 00:13:21.000000', 'temperatura', 908.0000, 'ºC'),
	(149918, 120, '2014-01-15 00:13:22.000000', 'temperatura', 39.0000, 'ºC'),
	(149919, 120, '2014-01-15 00:13:23.000000', 'temperatura', 1070.0000, 'ºC'),
	(149920, 120, '2014-01-15 00:13:24.000000', 'temperatura', 435.0000, 'ºC'),
	(149921, 120, '2014-01-15 00:13:25.000000', 'temperatura', 163.0000, 'ºC'),
	(149922, 120, '2014-01-15 00:13:26.000000', 'temperatura', 714.0000, 'ºC'),
	(149923, 120, '2014-01-15 00:13:27.000000', 'temperatura', 681.0000, 'ºC'),
	(149924, 120, '2014-01-15 00:13:28.000000', 'temperatura', 61.0000, 'ºC'),
	(149925, 120, '2014-01-15 00:13:29.000000', 'temperatura', 665.0000, 'ºC'),
	(149926, 120, '2014-01-15 00:13:30.000000', 'temperatura', 740.0000, 'ºC'),
	(149927, 120, '2014-01-15 00:13:31.000000', 'temperatura', 505.0000, 'ºC'),
	(149928, 120, '2014-01-15 00:13:32.000000', 'temperatura', 306.0000, 'ºC'),
	(149929, 120, '2014-01-15 00:13:33.000000', 'temperatura', 17.0000, 'ºC'),
	(149930, 120, '2014-01-15 00:13:34.000000', 'temperatura', 367.0000, 'ºC'),
	(149931, 120, '2014-01-15 00:13:35.000000', 'temperatura', 584.0000, 'ºC'),
	(149932, 120, '2014-01-15 00:13:36.000000', 'temperatura', 621.0000, 'ºC'),
	(149933, 120, '2014-01-15 00:13:37.000000', 'temperatura', 151.0000, 'ºC'),
	(149934, 120, '2014-01-15 00:13:38.000000', 'temperatura', 94.0000, 'ºC'),
	(149935, 120, '2014-01-15 00:13:39.000000', 'temperatura', 17.0000, 'ºC'),
	(149936, 120, '2014-01-15 00:13:40.000000', 'temperatura', 1005.0000, 'ºC'),
	(149937, 120, '2014-01-15 00:13:41.000000', 'temperatura', 173.0000, 'ºC'),
	(149938, 120, '2014-01-15 00:13:42.000000', 'temperatura', 250.0000, 'ºC'),
	(149939, 120, '2014-01-15 00:13:43.000000', 'temperatura', 734.0000, 'ºC'),
	(149940, 120, '2014-01-15 00:13:44.000000', 'temperatura', 518.0000, 'ºC'),
	(149941, 120, '2014-01-15 00:13:45.000000', 'temperatura', 389.0000, 'ºC'),
	(149942, 120, '2014-01-15 00:13:46.000000', 'temperatura', 391.0000, 'ºC'),
	(149943, 120, '2014-01-15 00:13:47.000000', 'temperatura', 789.0000, 'ºC'),
	(149944, 120, '2014-01-15 00:13:48.000000', 'temperatura', 373.0000, 'ºC'),
	(149945, 120, '2014-01-15 00:13:49.000000', 'temperatura', 699.0000, 'ºC'),
	(149946, 120, '2014-01-15 00:13:50.000000', 'temperatura', 1178.0000, 'ºC'),
	(149947, 120, '2014-01-15 00:13:51.000000', 'temperatura', 192.0000, 'ºC'),
	(149948, 120, '2014-01-15 00:13:52.000000', 'temperatura', 1025.0000, 'ºC'),
	(149949, 120, '2014-01-15 00:13:53.000000', 'temperatura', 952.0000, 'ºC'),
	(149950, 120, '2014-01-15 00:13:54.000000', 'temperatura', 486.0000, 'ºC'),
	(149951, 120, '2014-01-15 00:13:55.000000', 'temperatura', 774.0000, 'ºC'),
	(149952, 120, '2014-01-15 00:13:56.000000', 'temperatura', 11.0000, 'ºC'),
	(149953, 120, '2014-01-15 00:13:57.000000', 'temperatura', 132.0000, 'ºC'),
	(149954, 120, '2014-01-15 00:13:58.000000', 'temperatura', 630.0000, 'ºC'),
	(149955, 120, '2014-01-15 00:13:59.000000', 'temperatura', 355.0000, 'ºC'),
	(149956, 120, '2014-01-15 00:14:00.000000', 'temperatura', 1087.0000, 'ºC'),
	(149957, 120, '2014-01-15 00:14:01.000000', 'temperatura', 768.0000, 'ºC'),
	(149958, 120, '2014-01-15 00:14:02.000000', 'temperatura', 581.0000, 'ºC'),
	(149959, 120, '2014-01-15 00:14:03.000000', 'temperatura', 602.0000, 'ºC'),
	(149960, 120, '2014-01-15 00:14:04.000000', 'temperatura', 65.0000, 'ºC'),
	(149961, 120, '2014-01-15 00:14:05.000000', 'temperatura', 922.0000, 'ºC'),
	(149962, 120, '2014-01-15 00:14:06.000000', 'temperatura', 815.0000, 'ºC'),
	(149963, 120, '2014-01-15 00:14:07.000000', 'temperatura', 110.0000, 'ºC'),
	(149964, 120, '2014-01-15 00:14:08.000000', 'temperatura', 506.0000, 'ºC'),
	(149965, 120, '2014-01-15 00:14:09.000000', 'temperatura', 1000.0000, 'ºC'),
	(149966, 120, '2014-01-15 00:14:10.000000', 'temperatura', 1080.0000, 'ºC'),
	(149967, 120, '2014-01-15 00:14:11.000000', 'temperatura', 4.0000, 'ºC'),
	(149968, 120, '2014-01-15 00:14:12.000000', 'temperatura', 380.0000, 'ºC'),
	(149969, 120, '2014-01-15 00:14:13.000000', 'temperatura', 686.0000, 'ºC'),
	(149970, 120, '2014-01-15 00:14:14.000000', 'temperatura', 1092.0000, 'ºC'),
	(149971, 120, '2014-01-15 00:14:15.000000', 'temperatura', 1002.0000, 'ºC'),
	(149972, 120, '2014-01-15 00:14:16.000000', 'temperatura', 533.0000, 'ºC'),
	(149973, 120, '2014-01-15 00:14:17.000000', 'temperatura', 859.0000, 'ºC'),
	(149974, 120, '2014-01-15 00:14:18.000000', 'temperatura', 299.0000, 'ºC'),
	(149975, 120, '2014-01-15 00:14:19.000000', 'temperatura', 117.0000, 'ºC'),
	(149976, 120, '2014-01-15 00:14:20.000000', 'temperatura', 887.0000, 'ºC'),
	(149977, 120, '2014-01-15 00:14:21.000000', 'temperatura', 487.0000, 'ºC'),
	(149978, 120, '2014-01-15 00:14:22.000000', 'temperatura', 974.0000, 'ºC'),
	(149979, 120, '2014-01-15 00:14:23.000000', 'temperatura', 1007.0000, 'ºC'),
	(149980, 120, '2014-01-15 00:14:24.000000', 'temperatura', 916.0000, 'ºC'),
	(149981, 120, '2014-01-15 00:14:25.000000', 'temperatura', 358.0000, 'ºC'),
	(149982, 120, '2014-01-15 00:14:26.000000', 'temperatura', 242.0000, 'ºC'),
	(149983, 120, '2014-01-15 00:14:27.000000', 'temperatura', 137.0000, 'ºC'),
	(149984, 120, '2014-01-15 00:14:28.000000', 'temperatura', 1161.0000, 'ºC'),
	(149985, 120, '2014-01-15 00:14:29.000000', 'temperatura', 592.0000, 'ºC'),
	(149986, 120, '2014-01-15 00:14:30.000000', 'temperatura', 677.0000, 'ºC'),
	(149987, 120, '2014-01-15 00:14:31.000000', 'temperatura', 412.0000, 'ºC'),
	(149988, 120, '2014-01-15 00:14:32.000000', 'temperatura', 27.0000, 'ºC'),
	(149989, 120, '2014-01-15 00:14:33.000000', 'temperatura', 101.0000, 'ºC'),
	(149990, 120, '2014-01-15 00:14:34.000000', 'temperatura', 423.0000, 'ºC'),
	(149991, 120, '2014-01-15 00:14:35.000000', 'temperatura', 613.0000, 'ºC'),
	(149992, 120, '2014-01-15 00:14:36.000000', 'temperatura', 598.0000, 'ºC'),
	(149993, 120, '2014-01-15 00:14:37.000000', 'temperatura', 1151.0000, 'ºC'),
	(149994, 120, '2014-01-15 00:14:38.000000', 'temperatura', 360.0000, 'ºC'),
	(149995, 120, '2014-01-15 00:14:39.000000', 'temperatura', 748.0000, 'ºC'),
	(149996, 120, '2014-01-15 00:14:40.000000', 'temperatura', 262.0000, 'ºC'),
	(149997, 120, '2014-01-15 00:14:41.000000', 'temperatura', 266.0000, 'ºC'),
	(149998, 120, '2014-01-15 00:14:42.000000', 'temperatura', 543.0000, 'ºC'),
	(149999, 120, '2014-01-15 00:14:43.000000', 'temperatura', 720.0000, 'ºC'),
	(150000, 120, '2014-01-15 00:14:44.000000', 'temperatura', 772.0000, 'ºC'),
	(150001, 120, '2014-01-15 00:14:45.000000', 'temperatura', 499.0000, 'ºC'),
	(150002, 120, '2014-01-15 00:14:46.000000', 'temperatura', 181.0000, 'ºC'),
	(150003, 120, '2014-01-15 00:14:47.000000', 'temperatura', 609.0000, 'ºC'),
	(150004, 120, '2014-01-15 00:14:48.000000', 'temperatura', 103.0000, 'ºC'),
	(150005, 120, '2014-01-15 00:14:49.000000', 'temperatura', 1088.0000, 'ºC'),
	(150006, 120, '2014-01-15 00:14:50.000000', 'temperatura', 332.0000, 'ºC'),
	(150007, 120, '2014-01-15 00:14:51.000000', 'temperatura', 796.0000, 'ºC'),
	(150008, 120, '2014-01-15 00:14:52.000000', 'temperatura', 586.0000, 'ºC'),
	(150009, 120, '2014-01-15 00:14:53.000000', 'temperatura', 544.0000, 'ºC'),
	(150010, 120, '2014-01-15 00:14:54.000000', 'temperatura', 959.0000, 'ºC'),
	(150011, 120, '2014-01-15 00:14:55.000000', 'temperatura', 763.0000, 'ºC'),
	(150012, 120, '2014-01-15 00:14:56.000000', 'temperatura', 939.0000, 'ºC'),
	(150013, 120, '2014-01-15 00:14:57.000000', 'temperatura', 8.0000, 'ºC'),
	(150014, 120, '2014-01-15 00:14:58.000000', 'temperatura', 824.0000, 'ºC'),
	(150015, 120, '2014-01-15 00:14:59.000000', 'temperatura', 497.0000, 'ºC'),
	(150016, 120, '2014-01-15 00:15:00.000000', 'temperatura', 14.0000, 'ºC'),
	(150017, 120, '2014-01-15 00:15:01.000000', 'temperatura', 980.0000, 'ºC'),
	(150018, 120, '2014-01-15 00:15:02.000000', 'temperatura', 57.0000, 'ºC'),
	(150019, 120, '2014-01-15 00:15:03.000000', 'temperatura', 947.0000, 'ºC'),
	(150020, 120, '2014-01-15 00:15:04.000000', 'temperatura', 962.0000, 'ºC'),
	(150021, 120, '2014-01-15 00:15:05.000000', 'temperatura', 769.0000, 'ºC'),
	(150022, 120, '2014-01-15 00:15:06.000000', 'temperatura', 960.0000, 'ºC'),
	(150023, 120, '2014-01-15 00:15:07.000000', 'temperatura', 92.0000, 'ºC'),
	(150024, 120, '2014-01-15 00:15:08.000000', 'temperatura', 1183.0000, 'ºC'),
	(150025, 120, '2014-01-15 00:15:09.000000', 'temperatura', 839.0000, 'ºC'),
	(150026, 120, '2014-01-15 00:15:10.000000', 'temperatura', 648.0000, 'ºC'),
	(150027, 120, '2014-01-15 00:15:11.000000', 'temperatura', 723.0000, 'ºC'),
	(150028, 120, '2014-01-15 00:15:12.000000', 'temperatura', 473.0000, 'ºC'),
	(150029, 120, '2014-01-15 00:15:13.000000', 'temperatura', 195.0000, 'ºC'),
	(150030, 120, '2014-01-15 00:15:14.000000', 'temperatura', 755.0000, 'ºC'),
	(150031, 120, '2014-01-15 00:15:15.000000', 'temperatura', 790.0000, 'ºC'),
	(150032, 120, '2014-01-15 00:15:16.000000', 'temperatura', 487.0000, 'ºC'),
	(150033, 120, '2014-01-15 00:15:17.000000', 'temperatura', 65.0000, 'ºC'),
	(150034, 120, '2014-01-15 00:15:18.000000', 'temperatura', 64.0000, 'ºC'),
	(150035, 120, '2014-01-15 00:15:19.000000', 'temperatura', 124.0000, 'ºC'),
	(150036, 120, '2014-01-15 00:15:20.000000', 'temperatura', 430.0000, 'ºC'),
	(150037, 120, '2014-01-15 00:15:21.000000', 'temperatura', 580.0000, 'ºC'),
	(150038, 120, '2014-01-15 00:15:22.000000', 'temperatura', 409.0000, 'ºC'),
	(150039, 120, '2014-01-15 00:15:23.000000', 'temperatura', 307.0000, 'ºC'),
	(150040, 120, '2014-01-15 00:15:24.000000', 'temperatura', 308.0000, 'ºC'),
	(150041, 120, '2014-01-15 00:15:25.000000', 'temperatura', 619.0000, 'ºC'),
	(150042, 120, '2014-01-15 00:15:26.000000', 'temperatura', 973.0000, 'ºC'),
	(150043, 120, '2014-01-15 00:15:27.000000', 'temperatura', 606.0000, 'ºC'),
	(150044, 120, '2014-01-15 00:15:28.000000', 'temperatura', 114.0000, 'ºC'),
	(150045, 120, '2014-01-15 00:15:29.000000', 'temperatura', 1153.0000, 'ºC'),
	(150046, 120, '2014-01-15 00:15:30.000000', 'temperatura', 624.0000, 'ºC'),
	(150047, 120, '2014-01-15 00:15:31.000000', 'temperatura', 861.0000, 'ºC'),
	(150048, 120, '2014-01-15 00:15:32.000000', 'temperatura', 34.0000, 'ºC'),
	(150049, 120, '2014-01-15 00:15:33.000000', 'temperatura', 1187.0000, 'ºC'),
	(150050, 120, '2014-01-15 00:15:34.000000', 'temperatura', 1034.0000, 'ºC'),
	(150051, 120, '2014-01-15 00:15:35.000000', 'temperatura', 410.0000, 'ºC'),
	(150052, 120, '2014-01-15 00:15:36.000000', 'temperatura', 149.0000, 'ºC'),
	(150053, 120, '2014-01-15 00:15:37.000000', 'temperatura', 715.0000, 'ºC'),
	(150054, 120, '2014-01-15 00:15:38.000000', 'temperatura', 726.0000, 'ºC'),
	(150055, 120, '2014-01-15 00:15:39.000000', 'temperatura', 288.0000, 'ºC'),
	(150056, 120, '2014-01-15 00:15:40.000000', 'temperatura', 463.0000, 'ºC'),
	(150057, 120, '2014-01-15 00:15:41.000000', 'temperatura', 251.0000, 'ºC'),
	(150058, 120, '2014-01-15 00:15:42.000000', 'temperatura', 1067.0000, 'ºC'),
	(150059, 120, '2014-01-15 00:15:43.000000', 'temperatura', 983.0000, 'ºC'),
	(150060, 120, '2014-01-15 00:15:44.000000', 'temperatura', 514.0000, 'ºC'),
	(150061, 120, '2014-01-15 00:15:45.000000', 'temperatura', 823.0000, 'ºC'),
	(150062, 120, '2014-01-15 00:15:46.000000', 'temperatura', 172.0000, 'ºC'),
	(150063, 120, '2014-01-15 00:15:47.000000', 'temperatura', 792.0000, 'ºC'),
	(150064, 120, '2014-01-15 00:15:48.000000', 'temperatura', 1046.0000, 'ºC'),
	(150065, 120, '2014-01-15 00:15:49.000000', 'temperatura', 455.0000, 'ºC'),
	(150066, 120, '2014-01-15 00:15:50.000000', 'temperatura', 337.0000, 'ºC'),
	(150067, 120, '2014-01-15 00:15:51.000000', 'temperatura', 318.0000, 'ºC'),
	(150068, 120, '2014-01-15 00:15:52.000000', 'temperatura', 582.0000, 'ºC'),
	(150069, 120, '2014-01-15 00:15:53.000000', 'temperatura', 757.0000, 'ºC'),
	(150070, 120, '2014-01-15 00:15:54.000000', 'temperatura', 840.0000, 'ºC'),
	(150071, 120, '2014-01-15 00:15:55.000000', 'temperatura', 730.0000, 'ºC'),
	(150072, 120, '2014-01-15 00:15:56.000000', 'temperatura', 1131.0000, 'ºC'),
	(150073, 120, '2014-01-15 00:15:57.000000', 'temperatura', 1065.0000, 'ºC'),
	(150074, 120, '2014-01-15 00:15:58.000000', 'temperatura', 731.0000, 'ºC'),
	(150075, 120, '2014-01-15 00:15:59.000000', 'temperatura', 463.0000, 'ºC'),
	(150076, 120, '2014-01-15 00:16:00.000000', 'temperatura', 121.0000, 'ºC'),
	(150077, 120, '2014-01-15 00:16:01.000000', 'temperatura', 416.0000, 'ºC'),
	(150078, 120, '2014-01-15 00:16:02.000000', 'temperatura', 516.0000, 'ºC'),
	(150079, 120, '2014-01-15 00:16:03.000000', 'temperatura', 136.0000, 'ºC'),
	(150080, 120, '2014-01-15 00:16:04.000000', 'temperatura', 329.0000, 'ºC'),
	(150081, 120, '2014-01-15 00:16:05.000000', 'temperatura', 41.0000, 'ºC'),
	(150082, 120, '2014-01-15 00:16:06.000000', 'temperatura', 416.0000, 'ºC'),
	(150083, 120, '2014-01-15 00:16:07.000000', 'temperatura', 759.0000, 'ºC'),
	(150084, 120, '2014-01-15 00:16:08.000000', 'temperatura', 145.0000, 'ºC'),
	(150085, 120, '2014-01-15 00:16:09.000000', 'temperatura', 850.0000, 'ºC'),
	(150086, 120, '2014-01-15 00:16:10.000000', 'temperatura', 213.0000, 'ºC'),
	(150087, 120, '2014-01-15 00:16:11.000000', 'temperatura', 919.0000, 'ºC'),
	(150088, 120, '2014-01-15 00:16:12.000000', 'temperatura', 355.0000, 'ºC'),
	(150089, 120, '2014-01-15 00:16:13.000000', 'temperatura', 220.0000, 'ºC'),
	(150090, 120, '2014-01-15 00:16:14.000000', 'temperatura', 33.0000, 'ºC'),
	(150091, 120, '2014-01-15 00:16:15.000000', 'temperatura', 706.0000, 'ºC'),
	(150092, 120, '2014-01-15 00:16:16.000000', 'temperatura', 1031.0000, 'ºC'),
	(150093, 120, '2014-01-15 00:16:17.000000', 'temperatura', 640.0000, 'ºC'),
	(150094, 120, '2014-01-15 00:16:18.000000', 'temperatura', 104.0000, 'ºC'),
	(150095, 120, '2014-01-15 00:16:19.000000', 'temperatura', 1003.0000, 'ºC'),
	(150096, 120, '2014-01-15 00:16:20.000000', 'temperatura', 1102.0000, 'ºC'),
	(150097, 120, '2014-01-15 00:16:21.000000', 'temperatura', 100.0000, 'ºC'),
	(150098, 120, '2014-01-15 00:16:22.000000', 'temperatura', 796.0000, 'ºC'),
	(150099, 120, '2014-01-15 00:16:23.000000', 'temperatura', 80.0000, 'ºC'),
	(150100, 120, '2014-01-15 00:16:24.000000', 'temperatura', 415.0000, 'ºC'),
	(150101, 120, '2014-01-15 00:16:25.000000', 'temperatura', 632.0000, 'ºC'),
	(150102, 120, '2014-01-15 00:16:26.000000', 'temperatura', 718.0000, 'ºC'),
	(150103, 120, '2014-01-15 00:16:27.000000', 'temperatura', 493.0000, 'ºC'),
	(150104, 120, '2014-01-15 00:16:28.000000', 'temperatura', 312.0000, 'ºC'),
	(150105, 120, '2014-01-15 00:16:29.000000', 'temperatura', 82.0000, 'ºC'),
	(150106, 120, '2014-01-15 00:16:30.000000', 'temperatura', 675.0000, 'ºC'),
	(150107, 120, '2014-01-15 00:16:31.000000', 'temperatura', 731.0000, 'ºC'),
	(150108, 120, '2014-01-15 00:16:32.000000', 'temperatura', 428.0000, 'ºC'),
	(150109, 120, '2014-01-15 00:16:33.000000', 'temperatura', 1147.0000, 'ºC'),
	(150110, 120, '2014-01-15 00:16:34.000000', 'temperatura', 851.0000, 'ºC'),
	(150111, 120, '2014-01-15 00:16:35.000000', 'temperatura', 815.0000, 'ºC'),
	(150112, 120, '2014-01-15 00:16:36.000000', 'temperatura', 324.0000, 'ºC'),
	(150113, 120, '2014-01-15 00:16:37.000000', 'temperatura', 376.0000, 'ºC'),
	(150114, 120, '2014-01-15 00:16:38.000000', 'temperatura', 908.0000, 'ºC'),
	(150115, 120, '2014-01-15 00:16:39.000000', 'temperatura', 1010.0000, 'ºC'),
	(150116, 120, '2014-01-15 00:16:40.000000', 'temperatura', 1128.0000, 'ºC'),
	(150117, 120, '2014-01-15 00:16:41.000000', 'temperatura', 213.0000, 'ºC'),
	(150118, 120, '2014-01-15 00:16:42.000000', 'temperatura', 78.0000, 'ºC'),
	(150119, 120, '2014-01-15 00:16:43.000000', 'temperatura', 952.0000, 'ºC'),
	(150120, 120, '2014-01-15 00:16:44.000000', 'temperatura', 926.0000, 'ºC'),
	(150121, 120, '2014-01-15 00:16:45.000000', 'temperatura', 576.0000, 'ºC'),
	(150122, 120, '2014-01-15 00:16:46.000000', 'temperatura', 102.0000, 'ºC'),
	(150123, 120, '2014-01-15 00:16:47.000000', 'temperatura', 1181.0000, 'ºC'),
	(150124, 120, '2014-01-15 00:16:48.000000', 'temperatura', 802.0000, 'ºC'),
	(150125, 120, '2014-01-15 00:16:49.000000', 'temperatura', 465.0000, 'ºC'),
	(150126, 120, '2014-01-15 00:16:50.000000', 'temperatura', 1122.0000, 'ºC'),
	(150127, 120, '2014-01-15 00:16:51.000000', 'temperatura', 612.0000, 'ºC'),
	(150128, 120, '2014-01-15 00:16:52.000000', 'temperatura', 898.0000, 'ºC'),
	(150129, 120, '2014-01-15 00:16:53.000000', 'temperatura', 253.0000, 'ºC'),
	(150130, 120, '2014-01-15 00:16:54.000000', 'temperatura', 971.0000, 'ºC'),
	(150131, 120, '2014-01-15 00:16:55.000000', 'temperatura', 498.0000, 'ºC'),
	(150132, 120, '2014-01-15 00:16:56.000000', 'temperatura', 778.0000, 'ºC'),
	(150133, 120, '2014-01-15 00:16:57.000000', 'temperatura', 1195.0000, 'ºC'),
	(150134, 120, '2014-01-15 00:16:58.000000', 'temperatura', 43.0000, 'ºC'),
	(150135, 120, '2014-01-15 00:16:59.000000', 'temperatura', 232.0000, 'ºC'),
	(150136, 120, '2014-01-15 00:17:00.000000', 'temperatura', 1029.0000, 'ºC'),
	(150137, 120, '2014-01-15 00:17:01.000000', 'temperatura', 849.0000, 'ºC'),
	(150138, 120, '2014-01-15 00:17:02.000000', 'temperatura', 1160.0000, 'ºC'),
	(150139, 120, '2014-01-15 00:17:03.000000', 'temperatura', 852.0000, 'ºC'),
	(150140, 120, '2014-01-15 00:17:04.000000', 'temperatura', 782.0000, 'ºC'),
	(150141, 120, '2014-01-15 00:17:05.000000', 'temperatura', 153.0000, 'ºC'),
	(150142, 120, '2014-01-15 00:17:06.000000', 'temperatura', 821.0000, 'ºC'),
	(150143, 120, '2014-01-15 00:17:07.000000', 'temperatura', 46.0000, 'ºC'),
	(150144, 120, '2014-01-15 00:17:08.000000', 'temperatura', 168.0000, 'ºC'),
	(150145, 120, '2014-01-15 00:17:09.000000', 'temperatura', 704.0000, 'ºC'),
	(150146, 120, '2014-01-15 00:17:10.000000', 'temperatura', 614.0000, 'ºC'),
	(150147, 120, '2014-01-15 00:17:11.000000', 'temperatura', 961.0000, 'ºC'),
	(150148, 120, '2014-01-15 00:17:12.000000', 'temperatura', 561.0000, 'ºC'),
	(150149, 120, '2014-01-15 00:17:13.000000', 'temperatura', 1124.0000, 'ºC'),
	(150150, 120, '2014-01-15 00:17:14.000000', 'temperatura', 337.0000, 'ºC'),
	(150151, 120, '2014-01-15 00:17:15.000000', 'temperatura', 712.0000, 'ºC'),
	(150152, 120, '2014-01-15 00:17:16.000000', 'temperatura', 149.0000, 'ºC'),
	(150153, 120, '2014-01-15 00:17:17.000000', 'temperatura', 1009.0000, 'ºC'),
	(150154, 120, '2014-01-15 00:17:18.000000', 'temperatura', 999.0000, 'ºC'),
	(150155, 120, '2014-01-15 00:17:19.000000', 'temperatura', 768.0000, 'ºC'),
	(150156, 120, '2014-01-15 00:17:20.000000', 'temperatura', 845.0000, 'ºC'),
	(150157, 120, '2014-01-15 00:17:21.000000', 'temperatura', 722.0000, 'ºC'),
	(150158, 120, '2014-01-15 00:17:22.000000', 'temperatura', 1076.0000, 'ºC'),
	(150159, 120, '2014-01-15 00:17:23.000000', 'temperatura', 815.0000, 'ºC'),
	(150160, 120, '2014-01-15 00:17:24.000000', 'temperatura', 847.0000, 'ºC'),
	(150161, 120, '2014-01-15 00:17:25.000000', 'temperatura', 590.0000, 'ºC'),
	(150162, 120, '2014-01-15 00:17:26.000000', 'temperatura', 408.0000, 'ºC'),
	(150163, 120, '2014-01-15 00:17:27.000000', 'temperatura', 272.0000, 'ºC'),
	(150164, 120, '2014-01-15 00:17:28.000000', 'temperatura', 138.0000, 'ºC'),
	(150165, 120, '2014-01-15 00:17:29.000000', 'temperatura', 1073.0000, 'ºC'),
	(150166, 120, '2014-01-15 00:17:30.000000', 'temperatura', 151.0000, 'ºC'),
	(150167, 120, '2014-01-15 00:17:31.000000', 'temperatura', 1137.0000, 'ºC'),
	(150168, 120, '2014-01-15 00:17:32.000000', 'temperatura', 434.0000, 'ºC'),
	(150169, 120, '2014-01-15 00:17:33.000000', 'temperatura', 1156.0000, 'ºC'),
	(150170, 120, '2014-01-15 00:17:34.000000', 'temperatura', 882.0000, 'ºC'),
	(150171, 120, '2014-01-15 00:17:35.000000', 'temperatura', 941.0000, 'ºC'),
	(150172, 120, '2014-01-15 00:17:36.000000', 'temperatura', 861.0000, 'ºC'),
	(150173, 120, '2014-01-15 00:17:37.000000', 'temperatura', 283.0000, 'ºC'),
	(150174, 120, '2014-01-15 00:17:38.000000', 'temperatura', 32.0000, 'ºC'),
	(150175, 120, '2014-01-15 00:17:39.000000', 'temperatura', 512.0000, 'ºC'),
	(150176, 120, '2014-01-15 00:17:40.000000', 'temperatura', 63.0000, 'ºC'),
	(150177, 120, '2014-01-15 00:17:41.000000', 'temperatura', 1178.0000, 'ºC'),
	(150178, 120, '2014-01-15 00:17:42.000000', 'temperatura', 904.0000, 'ºC'),
	(150179, 120, '2014-01-15 00:17:43.000000', 'temperatura', 984.0000, 'ºC'),
	(150180, 120, '2014-01-15 00:17:44.000000', 'temperatura', 1012.0000, 'ºC'),
	(150181, 120, '2014-01-15 00:17:45.000000', 'temperatura', 905.0000, 'ºC'),
	(150182, 120, '2014-01-15 00:17:46.000000', 'temperatura', 293.0000, 'ºC'),
	(150183, 120, '2014-01-15 00:17:47.000000', 'temperatura', 1148.0000, 'ºC'),
	(150184, 120, '2014-01-15 00:17:48.000000', 'temperatura', 61.0000, 'ºC'),
	(150185, 120, '2014-01-15 00:17:49.000000', 'temperatura', 464.0000, 'ºC'),
	(150186, 120, '2014-01-15 00:17:50.000000', 'temperatura', 937.0000, 'ºC'),
	(150187, 120, '2014-01-15 00:17:51.000000', 'temperatura', 894.0000, 'ºC'),
	(150188, 120, '2014-01-15 00:17:52.000000', 'temperatura', 458.0000, 'ºC'),
	(150189, 120, '2014-01-15 00:17:53.000000', 'temperatura', 807.0000, 'ºC'),
	(150190, 120, '2014-01-15 00:17:54.000000', 'temperatura', 264.0000, 'ºC'),
	(150191, 120, '2014-01-15 00:17:55.000000', 'temperatura', 97.0000, 'ºC'),
	(150192, 120, '2014-01-15 00:17:56.000000', 'temperatura', 896.0000, 'ºC'),
	(150193, 120, '2014-01-15 00:17:57.000000', 'temperatura', 587.0000, 'ºC'),
	(150194, 120, '2014-01-15 00:17:58.000000', 'temperatura', 248.0000, 'ºC'),
	(150195, 120, '2014-01-15 00:17:59.000000', 'temperatura', 679.0000, 'ºC'),
	(150196, 120, '2014-01-15 00:18:00.000000', 'temperatura', 251.0000, 'ºC'),
	(150197, 120, '2014-01-15 00:18:01.000000', 'temperatura', 418.0000, 'ºC'),
	(150198, 120, '2014-01-15 00:18:02.000000', 'temperatura', 139.0000, 'ºC'),
	(150199, 120, '2014-01-15 00:18:03.000000', 'temperatura', 642.0000, 'ºC'),
	(150200, 120, '2014-01-15 00:18:04.000000', 'temperatura', 395.0000, 'ºC'),
	(150201, 120, '2014-01-15 00:18:05.000000', 'temperatura', 47.0000, 'ºC'),
	(150202, 120, '2014-01-15 00:18:06.000000', 'temperatura', 250.0000, 'ºC'),
	(150203, 120, '2014-01-15 00:18:07.000000', 'temperatura', 1109.0000, 'ºC'),
	(150204, 120, '2014-01-15 00:18:08.000000', 'temperatura', 1198.0000, 'ºC'),
	(150205, 120, '2014-01-15 00:18:09.000000', 'temperatura', 262.0000, 'ºC'),
	(150206, 120, '2014-01-15 00:18:10.000000', 'temperatura', 115.0000, 'ºC'),
	(150207, 120, '2014-01-15 00:18:11.000000', 'temperatura', 991.0000, 'ºC'),
	(150208, 120, '2014-01-15 00:18:12.000000', 'temperatura', 1011.0000, 'ºC'),
	(150209, 120, '2014-01-15 00:18:13.000000', 'temperatura', 883.0000, 'ºC'),
	(150210, 120, '2014-01-15 00:18:14.000000', 'temperatura', 180.0000, 'ºC'),
	(150211, 120, '2014-01-15 00:18:15.000000', 'temperatura', 652.0000, 'ºC'),
	(150212, 120, '2014-01-15 00:18:16.000000', 'temperatura', 322.0000, 'ºC'),
	(150213, 120, '2014-01-15 00:18:17.000000', 'temperatura', 854.0000, 'ºC'),
	(150214, 120, '2014-01-15 00:18:18.000000', 'temperatura', 906.0000, 'ºC'),
	(150215, 120, '2014-01-15 00:18:19.000000', 'temperatura', 767.0000, 'ºC'),
	(150216, 120, '2014-01-15 00:18:20.000000', 'temperatura', 1119.0000, 'ºC'),
	(150217, 120, '2014-01-15 00:18:21.000000', 'temperatura', 895.0000, 'ºC'),
	(150218, 120, '2014-01-15 00:18:22.000000', 'temperatura', 1116.0000, 'ºC'),
	(150219, 120, '2014-01-15 00:18:23.000000', 'temperatura', 498.0000, 'ºC'),
	(150220, 120, '2014-01-15 00:18:24.000000', 'temperatura', 341.0000, 'ºC'),
	(150221, 120, '2014-01-15 00:18:25.000000', 'temperatura', 212.0000, 'ºC'),
	(150222, 120, '2014-01-15 00:18:26.000000', 'temperatura', 36.0000, 'ºC'),
	(150223, 120, '2014-01-15 00:18:27.000000', 'temperatura', 744.0000, 'ºC'),
	(150224, 120, '2014-01-15 00:18:28.000000', 'temperatura', 14.0000, 'ºC'),
	(150225, 120, '2014-01-15 00:18:29.000000', 'temperatura', 237.0000, 'ºC'),
	(150226, 120, '2014-01-15 00:18:30.000000', 'temperatura', 1144.0000, 'ºC'),
	(150227, 120, '2014-01-15 00:18:31.000000', 'temperatura', 211.0000, 'ºC'),
	(150228, 120, '2014-01-15 00:18:32.000000', 'temperatura', 21.0000, 'ºC'),
	(150229, 120, '2014-01-15 00:18:33.000000', 'temperatura', 674.0000, 'ºC'),
	(150230, 120, '2014-01-15 00:18:34.000000', 'temperatura', 908.0000, 'ºC'),
	(150231, 120, '2014-01-15 00:18:35.000000', 'temperatura', 120.0000, 'ºC'),
	(150232, 120, '2014-01-15 00:18:36.000000', 'temperatura', 274.0000, 'ºC'),
	(150233, 120, '2014-01-15 00:18:37.000000', 'temperatura', 1013.0000, 'ºC'),
	(150234, 120, '2014-01-15 00:18:38.000000', 'temperatura', 641.0000, 'ºC'),
	(150235, 120, '2014-01-15 00:18:39.000000', 'temperatura', 168.0000, 'ºC'),
	(150236, 120, '2014-01-15 00:18:40.000000', 'temperatura', 115.0000, 'ºC'),
	(150237, 120, '2014-01-15 00:18:41.000000', 'temperatura', 73.0000, 'ºC'),
	(150238, 120, '2014-01-15 00:18:42.000000', 'temperatura', 22.0000, 'ºC'),
	(150239, 120, '2014-01-15 00:18:43.000000', 'temperatura', 1090.0000, 'ºC'),
	(150240, 120, '2014-01-15 00:18:44.000000', 'temperatura', 583.0000, 'ºC'),
	(150241, 120, '2014-01-15 00:18:45.000000', 'temperatura', 848.0000, 'ºC'),
	(150242, 120, '2014-01-15 00:18:46.000000', 'temperatura', 92.0000, 'ºC'),
	(150243, 120, '2014-01-15 00:18:47.000000', 'temperatura', 318.0000, 'ºC'),
	(150244, 120, '2014-01-15 00:18:48.000000', 'temperatura', 111.0000, 'ºC'),
	(150245, 120, '2014-01-15 00:18:49.000000', 'temperatura', 803.0000, 'ºC'),
	(150246, 120, '2014-01-15 00:18:50.000000', 'temperatura', 84.0000, 'ºC'),
	(150247, 120, '2014-01-15 00:18:51.000000', 'temperatura', 410.0000, 'ºC'),
	(150248, 120, '2014-01-15 00:18:52.000000', 'temperatura', 601.0000, 'ºC'),
	(150249, 120, '2014-01-15 00:18:53.000000', 'temperatura', 573.0000, 'ºC'),
	(150250, 120, '2014-01-15 00:18:54.000000', 'temperatura', 1061.0000, 'ºC'),
	(150251, 120, '2014-01-15 00:18:55.000000', 'temperatura', 1188.0000, 'ºC'),
	(150252, 120, '2014-01-15 00:18:56.000000', 'temperatura', 358.0000, 'ºC'),
	(150253, 120, '2014-01-15 00:18:57.000000', 'temperatura', 626.0000, 'ºC'),
	(150254, 120, '2014-01-15 00:18:58.000000', 'temperatura', 857.0000, 'ºC'),
	(150255, 120, '2014-01-15 00:18:59.000000', 'temperatura', 9.0000, 'ºC'),
	(150256, 120, '2014-01-15 00:19:00.000000', 'temperatura', 1073.0000, 'ºC'),
	(150257, 120, '2014-01-15 00:19:01.000000', 'temperatura', 539.0000, 'ºC'),
	(150258, 120, '2014-01-15 00:19:02.000000', 'temperatura', 677.0000, 'ºC'),
	(150259, 120, '2014-01-15 00:19:03.000000', 'temperatura', 566.0000, 'ºC'),
	(150260, 120, '2014-01-15 00:19:04.000000', 'temperatura', 802.0000, 'ºC'),
	(150261, 120, '2014-01-15 00:19:05.000000', 'temperatura', 1110.0000, 'ºC'),
	(150262, 120, '2014-01-15 00:19:06.000000', 'temperatura', 747.0000, 'ºC'),
	(150263, 120, '2014-01-15 00:19:07.000000', 'temperatura', 404.0000, 'ºC'),
	(150264, 120, '2014-01-15 00:19:08.000000', 'temperatura', 979.0000, 'ºC'),
	(150265, 120, '2014-01-15 00:19:09.000000', 'temperatura', 83.0000, 'ºC'),
	(150266, 120, '2014-01-15 00:19:10.000000', 'temperatura', 1080.0000, 'ºC'),
	(150267, 120, '2014-01-15 00:19:11.000000', 'temperatura', 352.0000, 'ºC'),
	(150268, 120, '2014-01-15 00:19:12.000000', 'temperatura', 919.0000, 'ºC'),
	(150269, 120, '2014-01-15 00:19:13.000000', 'temperatura', 1139.0000, 'ºC'),
	(150270, 120, '2014-01-15 00:19:14.000000', 'temperatura', 539.0000, 'ºC'),
	(150271, 120, '2014-01-15 00:19:15.000000', 'temperatura', 477.0000, 'ºC'),
	(150272, 120, '2014-01-15 00:19:16.000000', 'temperatura', 770.0000, 'ºC'),
	(150273, 120, '2014-01-15 00:19:17.000000', 'temperatura', 18.0000, 'ºC'),
	(150274, 120, '2014-01-15 00:19:18.000000', 'temperatura', 181.0000, 'ºC'),
	(150275, 120, '2014-01-15 00:19:19.000000', 'temperatura', 850.0000, 'ºC'),
	(150276, 120, '2014-01-15 00:19:20.000000', 'temperatura', 108.0000, 'ºC'),
	(150277, 120, '2014-01-15 00:19:21.000000', 'temperatura', 392.0000, 'ºC'),
	(150278, 120, '2014-01-15 00:19:22.000000', 'temperatura', 434.0000, 'ºC'),
	(150279, 120, '2014-01-15 00:19:23.000000', 'temperatura', 996.0000, 'ºC'),
	(150280, 120, '2014-01-15 00:19:24.000000', 'temperatura', 78.0000, 'ºC'),
	(150281, 120, '2014-01-15 00:19:25.000000', 'temperatura', 1001.0000, 'ºC'),
	(150282, 120, '2014-01-15 00:19:26.000000', 'temperatura', 1175.0000, 'ºC'),
	(150283, 120, '2014-01-15 00:19:27.000000', 'temperatura', 470.0000, 'ºC'),
	(150284, 120, '2014-01-15 00:19:28.000000', 'temperatura', 26.0000, 'ºC'),
	(150285, 120, '2014-01-15 00:19:29.000000', 'temperatura', 1119.0000, 'ºC'),
	(150286, 120, '2014-01-15 00:19:30.000000', 'temperatura', 720.0000, 'ºC'),
	(150287, 120, '2014-01-15 00:19:31.000000', 'temperatura', 243.0000, 'ºC'),
	(150288, 120, '2014-01-15 00:19:32.000000', 'temperatura', 257.0000, 'ºC'),
	(150289, 120, '2014-01-15 00:19:33.000000', 'temperatura', 554.0000, 'ºC'),
	(150290, 120, '2014-01-15 00:19:34.000000', 'temperatura', 799.0000, 'ºC'),
	(150291, 120, '2014-01-15 00:19:35.000000', 'temperatura', 1135.0000, 'ºC'),
	(150292, 120, '2014-01-15 00:19:36.000000', 'temperatura', 877.0000, 'ºC'),
	(150293, 120, '2014-01-15 00:19:37.000000', 'temperatura', 979.0000, 'ºC'),
	(150294, 120, '2014-01-15 00:19:38.000000', 'temperatura', 1067.0000, 'ºC'),
	(150295, 120, '2014-01-15 00:19:39.000000', 'temperatura', 1197.0000, 'ºC'),
	(150296, 120, '2014-01-15 00:19:40.000000', 'temperatura', 387.0000, 'ºC'),
	(150297, 120, '2014-01-15 00:19:41.000000', 'temperatura', 741.0000, 'ºC'),
	(150298, 120, '2014-01-15 00:19:42.000000', 'temperatura', 147.0000, 'ºC'),
	(150299, 120, '2014-01-15 00:19:43.000000', 'temperatura', 910.0000, 'ºC'),
	(150300, 120, '2014-01-15 00:19:44.000000', 'temperatura', 512.0000, 'ºC'),
	(150301, 120, '2014-01-15 00:19:45.000000', 'temperatura', 1028.0000, 'ºC'),
	(150302, 120, '2014-01-15 00:19:46.000000', 'temperatura', 4.0000, 'ºC'),
	(150303, 120, '2014-01-15 00:19:47.000000', 'temperatura', 537.0000, 'ºC'),
	(150304, 120, '2014-01-15 00:19:48.000000', 'temperatura', 273.0000, 'ºC'),
	(150305, 120, '2014-01-15 00:19:49.000000', 'temperatura', 954.0000, 'ºC'),
	(150306, 120, '2014-01-15 00:19:50.000000', 'temperatura', 352.0000, 'ºC'),
	(150307, 120, '2014-01-15 00:19:51.000000', 'temperatura', 99.0000, 'ºC'),
	(150308, 120, '2014-01-15 00:19:52.000000', 'temperatura', 640.0000, 'ºC'),
	(150309, 120, '2014-01-15 00:19:53.000000', 'temperatura', 502.0000, 'ºC'),
	(150310, 120, '2014-01-15 00:19:54.000000', 'temperatura', 589.0000, 'ºC'),
	(150311, 120, '2014-01-15 00:19:55.000000', 'temperatura', 242.0000, 'ºC'),
	(150312, 120, '2014-01-15 00:19:56.000000', 'temperatura', 643.0000, 'ºC'),
	(150313, 120, '2014-01-15 00:19:57.000000', 'temperatura', 89.0000, 'ºC'),
	(150314, 120, '2014-01-15 00:19:58.000000', 'temperatura', 917.0000, 'ºC'),
	(150315, 120, '2014-01-15 00:19:59.000000', 'temperatura', 719.0000, 'ºC'),
	(150316, 120, '2014-01-15 00:20:00.000000', 'temperatura', 843.0000, 'ºC'),
	(150317, 120, '2014-01-15 00:20:01.000000', 'temperatura', 858.0000, 'ºC'),
	(150318, 120, '2014-01-15 00:20:02.000000', 'temperatura', 560.0000, 'ºC'),
	(150319, 120, '2014-01-15 00:20:03.000000', 'temperatura', 230.0000, 'ºC'),
	(150320, 120, '2014-01-15 00:20:04.000000', 'temperatura', 670.0000, 'ºC'),
	(150321, 120, '2014-01-15 00:20:05.000000', 'temperatura', 259.0000, 'ºC'),
	(150322, 120, '2014-01-15 00:20:06.000000', 'temperatura', 486.0000, 'ºC'),
	(150323, 120, '2014-01-15 00:20:07.000000', 'temperatura', 452.0000, 'ºC'),
	(150324, 120, '2014-01-15 00:20:08.000000', 'temperatura', 803.0000, 'ºC'),
	(150325, 120, '2014-01-15 00:20:09.000000', 'temperatura', 262.0000, 'ºC'),
	(150326, 120, '2014-01-15 00:20:10.000000', 'temperatura', 100.0000, 'ºC'),
	(150327, 120, '2014-01-15 00:20:11.000000', 'temperatura', 914.0000, 'ºC'),
	(150328, 120, '2014-01-15 00:20:12.000000', 'temperatura', 670.0000, 'ºC'),
	(150329, 120, '2014-01-15 00:20:13.000000', 'temperatura', 608.0000, 'ºC'),
	(150330, 120, '2014-01-15 00:20:14.000000', 'temperatura', 1030.0000, 'ºC'),
	(150331, 120, '2014-01-15 00:20:15.000000', 'temperatura', 926.0000, 'ºC'),
	(150332, 120, '2014-01-15 00:20:16.000000', 'temperatura', 342.0000, 'ºC'),
	(150333, 120, '2014-01-15 00:20:17.000000', 'temperatura', 134.0000, 'ºC'),
	(150334, 120, '2014-01-15 00:20:18.000000', 'temperatura', 843.0000, 'ºC'),
	(150335, 120, '2014-01-15 00:20:19.000000', 'temperatura', 214.0000, 'ºC'),
	(150336, 120, '2014-01-15 00:20:20.000000', 'temperatura', 940.0000, 'ºC'),
	(150337, 120, '2014-01-15 00:20:21.000000', 'temperatura', 460.0000, 'ºC'),
	(150338, 120, '2014-01-15 00:20:22.000000', 'temperatura', 681.0000, 'ºC'),
	(150339, 120, '2014-01-15 00:20:23.000000', 'temperatura', 826.0000, 'ºC'),
	(150340, 120, '2014-01-15 00:20:24.000000', 'temperatura', 886.0000, 'ºC'),
	(150341, 120, '2014-01-15 00:20:25.000000', 'temperatura', 751.0000, 'ºC'),
	(150342, 120, '2014-01-15 00:20:26.000000', 'temperatura', 1099.0000, 'ºC'),
	(150343, 120, '2014-01-15 00:20:27.000000', 'temperatura', 841.0000, 'ºC'),
	(150344, 120, '2014-01-15 00:20:28.000000', 'temperatura', 910.0000, 'ºC'),
	(150345, 120, '2014-01-15 00:20:29.000000', 'temperatura', 828.0000, 'ºC'),
	(150346, 120, '2014-01-15 00:20:30.000000', 'temperatura', 210.0000, 'ºC'),
	(150347, 120, '2014-01-15 00:20:31.000000', 'temperatura', 964.0000, 'ºC'),
	(150348, 120, '2014-01-15 00:20:32.000000', 'temperatura', 594.0000, 'ºC'),
	(150349, 120, '2014-01-15 00:20:33.000000', 'temperatura', 78.0000, 'ºC'),
	(150350, 120, '2014-01-15 00:20:34.000000', 'temperatura', 1010.0000, 'ºC'),
	(150351, 120, '2014-01-15 00:20:35.000000', 'temperatura', 15.0000, 'ºC'),
	(150352, 120, '2014-01-15 00:20:36.000000', 'temperatura', 644.0000, 'ºC'),
	(150353, 120, '2014-01-15 00:20:37.000000', 'temperatura', 777.0000, 'ºC'),
	(150354, 120, '2014-01-15 00:20:38.000000', 'temperatura', 752.0000, 'ºC'),
	(150355, 120, '2014-01-15 00:20:39.000000', 'temperatura', 228.0000, 'ºC'),
	(150356, 120, '2014-01-15 00:20:40.000000', 'temperatura', 88.0000, 'ºC'),
	(150357, 120, '2014-01-15 00:20:41.000000', 'temperatura', 953.0000, 'ºC'),
	(150358, 120, '2014-01-15 00:20:42.000000', 'temperatura', 904.0000, 'ºC'),
	(150359, 120, '2014-01-15 00:20:43.000000', 'temperatura', 459.0000, 'ºC'),
	(150360, 120, '2014-01-15 00:20:44.000000', 'temperatura', 785.0000, 'ºC'),
	(150361, 120, '2014-01-15 00:20:45.000000', 'temperatura', 149.0000, 'ºC'),
	(150362, 120, '2014-01-15 00:20:46.000000', 'temperatura', 789.0000, 'ºC'),
	(150363, 120, '2014-01-15 00:20:47.000000', 'temperatura', 1097.0000, 'ºC'),
	(150364, 120, '2014-01-15 00:20:48.000000', 'temperatura', 722.0000, 'ºC'),
	(150365, 120, '2014-01-15 00:20:49.000000', 'temperatura', 317.0000, 'ºC'),
	(150366, 120, '2014-01-15 00:20:50.000000', 'temperatura', 621.0000, 'ºC'),
	(150367, 120, '2014-01-15 00:20:51.000000', 'temperatura', 954.0000, 'ºC'),
	(150368, 120, '2014-01-15 00:20:52.000000', 'temperatura', 509.0000, 'ºC'),
	(150369, 120, '2014-01-15 00:20:53.000000', 'temperatura', 882.0000, 'ºC'),
	(150370, 120, '2014-01-15 00:20:54.000000', 'temperatura', 485.0000, 'ºC'),
	(150371, 120, '2014-01-15 00:20:55.000000', 'temperatura', 979.0000, 'ºC'),
	(150372, 120, '2014-01-15 00:20:56.000000', 'temperatura', 1042.0000, 'ºC'),
	(150373, 120, '2014-01-15 00:20:57.000000', 'temperatura', 1071.0000, 'ºC'),
	(150374, 120, '2014-01-15 00:20:58.000000', 'temperatura', 1032.0000, 'ºC'),
	(150375, 120, '2014-01-15 00:20:59.000000', 'temperatura', 745.0000, 'ºC'),
	(150376, 120, '2014-01-15 00:21:00.000000', 'temperatura', 629.0000, 'ºC'),
	(150377, 120, '2014-01-15 00:21:01.000000', 'temperatura', 912.0000, 'ºC'),
	(150378, 120, '2014-01-15 00:21:02.000000', 'temperatura', 271.0000, 'ºC'),
	(150379, 120, '2014-01-15 00:21:03.000000', 'temperatura', 1022.0000, 'ºC'),
	(150380, 120, '2014-01-15 00:21:04.000000', 'temperatura', 697.0000, 'ºC'),
	(150381, 120, '2014-01-15 00:21:05.000000', 'temperatura', 420.0000, 'ºC'),
	(150382, 120, '2014-01-15 00:21:06.000000', 'temperatura', 10.0000, 'ºC'),
	(150383, 120, '2014-01-15 00:21:07.000000', 'temperatura', 1188.0000, 'ºC'),
	(150384, 120, '2014-01-15 00:21:08.000000', 'temperatura', 1111.0000, 'ºC'),
	(150385, 120, '2014-01-15 00:21:09.000000', 'temperatura', 793.0000, 'ºC'),
	(150386, 120, '2014-01-15 00:21:10.000000', 'temperatura', 633.0000, 'ºC'),
	(150387, 120, '2014-01-15 00:21:11.000000', 'temperatura', 788.0000, 'ºC'),
	(150388, 120, '2014-01-15 00:21:12.000000', 'temperatura', 838.0000, 'ºC'),
	(150389, 120, '2014-01-15 00:21:13.000000', 'temperatura', 629.0000, 'ºC'),
	(150390, 120, '2014-01-15 00:21:14.000000', 'temperatura', 631.0000, 'ºC'),
	(150391, 120, '2014-01-15 00:21:15.000000', 'temperatura', 68.0000, 'ºC'),
	(150392, 120, '2014-01-15 00:21:16.000000', 'temperatura', 846.0000, 'ºC'),
	(150393, 120, '2014-01-15 00:21:17.000000', 'temperatura', 426.0000, 'ºC'),
	(150394, 120, '2014-01-15 00:21:18.000000', 'temperatura', 794.0000, 'ºC'),
	(150395, 120, '2014-01-15 00:21:19.000000', 'temperatura', 294.0000, 'ºC'),
	(150396, 120, '2014-01-15 00:21:20.000000', 'temperatura', 287.0000, 'ºC'),
	(150397, 120, '2014-01-15 00:21:21.000000', 'temperatura', 555.0000, 'ºC'),
	(150398, 120, '2014-01-15 00:21:22.000000', 'temperatura', 714.0000, 'ºC'),
	(150399, 120, '2014-01-15 00:21:23.000000', 'temperatura', 707.0000, 'ºC'),
	(150400, 120, '2014-01-15 00:21:24.000000', 'temperatura', 191.0000, 'ºC'),
	(150401, 120, '2014-01-15 00:21:25.000000', 'temperatura', 33.0000, 'ºC'),
	(150402, 120, '2014-01-15 00:21:26.000000', 'temperatura', 796.0000, 'ºC'),
	(150403, 120, '2014-01-15 00:21:27.000000', 'temperatura', 281.0000, 'ºC'),
	(150404, 120, '2014-01-15 00:21:28.000000', 'temperatura', 215.0000, 'ºC'),
	(150405, 120, '2014-01-15 00:21:29.000000', 'temperatura', 233.0000, 'ºC'),
	(150406, 120, '2014-01-15 00:21:30.000000', 'temperatura', 521.0000, 'ºC'),
	(150407, 120, '2014-01-15 00:21:31.000000', 'temperatura', 709.0000, 'ºC'),
	(150408, 120, '2014-01-15 00:21:32.000000', 'temperatura', 779.0000, 'ºC'),
	(150409, 120, '2014-01-15 00:21:33.000000', 'temperatura', 571.0000, 'ºC'),
	(150410, 120, '2014-01-15 00:21:34.000000', 'temperatura', 516.0000, 'ºC'),
	(150411, 120, '2014-01-15 00:21:35.000000', 'temperatura', 868.0000, 'ºC'),
	(150412, 120, '2014-01-15 00:21:36.000000', 'temperatura', 395.0000, 'ºC'),
	(150413, 120, '2014-01-15 00:21:37.000000', 'temperatura', 568.0000, 'ºC'),
	(150414, 120, '2014-01-15 00:21:38.000000', 'temperatura', 457.0000, 'ºC'),
	(150415, 120, '2014-01-15 00:21:39.000000', 'temperatura', 582.0000, 'ºC'),
	(150416, 120, '2014-01-15 00:21:40.000000', 'temperatura', 341.0000, 'ºC'),
	(150417, 120, '2014-01-15 00:21:41.000000', 'temperatura', 1156.0000, 'ºC'),
	(150418, 120, '2014-01-15 00:21:42.000000', 'temperatura', 1159.0000, 'ºC'),
	(150419, 120, '2014-01-15 00:21:43.000000', 'temperatura', 1129.0000, 'ºC'),
	(150420, 120, '2014-01-15 00:21:44.000000', 'temperatura', 969.0000, 'ºC'),
	(150421, 120, '2014-01-15 00:21:45.000000', 'temperatura', 256.0000, 'ºC'),
	(150422, 120, '2014-01-15 00:21:46.000000', 'temperatura', 774.0000, 'ºC'),
	(150423, 120, '2014-01-15 00:21:47.000000', 'temperatura', 703.0000, 'ºC'),
	(150424, 120, '2014-01-15 00:21:48.000000', 'temperatura', 1193.0000, 'ºC'),
	(150425, 120, '2014-01-15 00:21:49.000000', 'temperatura', 256.0000, 'ºC'),
	(150426, 120, '2014-01-15 00:21:50.000000', 'temperatura', 101.0000, 'ºC'),
	(150427, 120, '2014-01-15 00:21:51.000000', 'temperatura', 939.0000, 'ºC'),
	(150428, 120, '2014-01-15 00:21:52.000000', 'temperatura', 790.0000, 'ºC'),
	(150429, 120, '2014-01-15 00:21:53.000000', 'temperatura', 1137.0000, 'ºC'),
	(150430, 120, '2014-01-15 00:21:54.000000', 'temperatura', 912.0000, 'ºC'),
	(150431, 120, '2014-01-15 00:21:55.000000', 'temperatura', 1150.0000, 'ºC'),
	(150432, 120, '2014-01-15 00:21:56.000000', 'temperatura', 617.0000, 'ºC'),
	(150433, 120, '2014-01-15 00:21:57.000000', 'temperatura', 833.0000, 'ºC'),
	(150434, 120, '2014-01-15 00:21:58.000000', 'temperatura', 1117.0000, 'ºC'),
	(150435, 120, '2014-01-15 00:21:59.000000', 'temperatura', 687.0000, 'ºC'),
	(150436, 120, '2014-01-15 00:22:00.000000', 'temperatura', 82.0000, 'ºC'),
	(150437, 120, '2014-01-15 00:22:01.000000', 'temperatura', 749.0000, 'ºC'),
	(150438, 120, '2014-01-15 00:22:02.000000', 'temperatura', 1100.0000, 'ºC'),
	(150439, 120, '2014-01-15 00:22:03.000000', 'temperatura', 855.0000, 'ºC'),
	(150440, 120, '2014-01-15 00:22:04.000000', 'temperatura', 974.0000, 'ºC'),
	(150441, 120, '2014-01-15 00:22:05.000000', 'temperatura', 1107.0000, 'ºC'),
	(150442, 120, '2014-01-15 00:22:06.000000', 'temperatura', 212.0000, 'ºC'),
	(150443, 120, '2014-01-15 00:22:07.000000', 'temperatura', 142.0000, 'ºC'),
	(150444, 120, '2014-01-15 00:22:08.000000', 'temperatura', 73.0000, 'ºC'),
	(150445, 120, '2014-01-15 00:22:09.000000', 'temperatura', 1139.0000, 'ºC'),
	(150446, 120, '2014-01-15 00:22:10.000000', 'temperatura', 677.0000, 'ºC'),
	(150447, 120, '2014-01-15 00:22:11.000000', 'temperatura', 1167.0000, 'ºC'),
	(150448, 120, '2014-01-15 00:22:12.000000', 'temperatura', 206.0000, 'ºC'),
	(150449, 120, '2014-01-15 00:22:13.000000', 'temperatura', 1131.0000, 'ºC'),
	(150450, 120, '2014-01-15 00:22:14.000000', 'temperatura', 236.0000, 'ºC'),
	(150451, 120, '2014-01-15 00:22:15.000000', 'temperatura', 189.0000, 'ºC'),
	(150452, 120, '2014-01-15 00:22:16.000000', 'temperatura', 236.0000, 'ºC'),
	(150453, 120, '2014-01-15 00:22:17.000000', 'temperatura', 614.0000, 'ºC'),
	(150454, 120, '2014-01-15 00:22:18.000000', 'temperatura', 1161.0000, 'ºC'),
	(150455, 120, '2014-01-15 00:22:19.000000', 'temperatura', 362.0000, 'ºC'),
	(150456, 120, '2014-01-15 00:22:20.000000', 'temperatura', 731.0000, 'ºC'),
	(150457, 120, '2014-01-15 00:22:21.000000', 'temperatura', 169.0000, 'ºC'),
	(150458, 120, '2014-01-15 00:22:22.000000', 'temperatura', 1053.0000, 'ºC'),
	(150459, 120, '2014-01-15 00:22:23.000000', 'temperatura', 1158.0000, 'ºC'),
	(150460, 120, '2014-01-15 00:22:24.000000', 'temperatura', 231.0000, 'ºC'),
	(150461, 120, '2014-01-15 00:22:25.000000', 'temperatura', 83.0000, 'ºC'),
	(150462, 120, '2014-01-15 00:22:26.000000', 'temperatura', 921.0000, 'ºC'),
	(150463, 120, '2014-01-15 00:22:27.000000', 'temperatura', 757.0000, 'ºC'),
	(150464, 120, '2014-01-15 00:22:28.000000', 'temperatura', 1022.0000, 'ºC'),
	(150465, 120, '2014-01-15 00:22:29.000000', 'temperatura', 439.0000, 'ºC'),
	(150466, 120, '2014-01-15 00:22:30.000000', 'temperatura', 331.0000, 'ºC'),
	(150467, 120, '2014-01-15 00:22:31.000000', 'temperatura', 338.0000, 'ºC'),
	(150468, 120, '2014-01-15 00:22:32.000000', 'temperatura', 698.0000, 'ºC'),
	(150469, 120, '2014-01-15 00:22:33.000000', 'temperatura', 76.0000, 'ºC'),
	(150470, 120, '2014-01-15 00:22:34.000000', 'temperatura', 685.0000, 'ºC'),
	(150471, 120, '2014-01-15 00:22:35.000000', 'temperatura', 797.0000, 'ºC'),
	(150472, 120, '2014-01-15 00:22:36.000000', 'temperatura', 733.0000, 'ºC'),
	(150473, 120, '2014-01-15 00:22:37.000000', 'temperatura', 76.0000, 'ºC'),
	(150474, 120, '2014-01-15 00:22:38.000000', 'temperatura', 578.0000, 'ºC'),
	(150475, 120, '2014-01-15 00:22:39.000000', 'temperatura', 264.0000, 'ºC'),
	(150476, 120, '2014-01-15 00:22:40.000000', 'temperatura', 785.0000, 'ºC'),
	(150477, 120, '2014-01-15 00:22:41.000000', 'temperatura', 736.0000, 'ºC'),
	(150478, 120, '2014-01-15 00:22:42.000000', 'temperatura', 124.0000, 'ºC'),
	(150479, 120, '2014-01-15 00:22:43.000000', 'temperatura', 813.0000, 'ºC'),
	(150480, 120, '2014-01-15 00:22:44.000000', 'temperatura', 92.0000, 'ºC'),
	(150481, 120, '2014-01-15 00:22:45.000000', 'temperatura', 422.0000, 'ºC'),
	(150482, 120, '2014-01-15 00:22:46.000000', 'temperatura', 637.0000, 'ºC'),
	(150483, 120, '2014-01-15 00:22:47.000000', 'temperatura', 716.0000, 'ºC'),
	(150484, 120, '2014-01-15 00:22:48.000000', 'temperatura', 473.0000, 'ºC'),
	(150485, 120, '2014-01-15 00:22:49.000000', 'temperatura', 214.0000, 'ºC'),
	(150486, 120, '2014-01-15 00:22:50.000000', 'temperatura', 853.0000, 'ºC'),
	(150487, 120, '2014-01-15 00:22:51.000000', 'temperatura', 23.0000, 'ºC'),
	(150488, 120, '2014-01-15 00:22:52.000000', 'temperatura', 1156.0000, 'ºC'),
	(150489, 120, '2014-01-15 00:22:53.000000', 'temperatura', 911.0000, 'ºC'),
	(150490, 120, '2014-01-15 00:22:54.000000', 'temperatura', 1087.0000, 'ºC'),
	(150491, 120, '2014-01-15 00:22:55.000000', 'temperatura', 305.0000, 'ºC'),
	(150492, 120, '2014-01-15 00:22:56.000000', 'temperatura', 662.0000, 'ºC'),
	(150493, 120, '2014-01-15 00:22:57.000000', 'temperatura', 1195.0000, 'ºC'),
	(150494, 120, '2014-01-15 00:22:58.000000', 'temperatura', 391.0000, 'ºC'),
	(150495, 120, '2014-01-15 00:22:59.000000', 'temperatura', 770.0000, 'ºC'),
	(150496, 120, '2014-01-15 00:23:00.000000', 'temperatura', 279.0000, 'ºC'),
	(150497, 120, '2014-01-15 00:23:01.000000', 'temperatura', 284.0000, 'ºC'),
	(150498, 120, '2014-01-15 00:23:02.000000', 'temperatura', 584.0000, 'ºC'),
	(150499, 120, '2014-01-15 00:23:03.000000', 'temperatura', 870.0000, 'ºC'),
	(150500, 120, '2014-01-15 00:23:04.000000', 'temperatura', 199.0000, 'ºC'),
	(150501, 120, '2014-01-15 00:23:05.000000', 'temperatura', 786.0000, 'ºC'),
	(150502, 120, '2014-01-15 00:23:06.000000', 'temperatura', 932.0000, 'ºC'),
	(150503, 120, '2014-01-15 00:23:07.000000', 'temperatura', 1102.0000, 'ºC'),
	(150504, 120, '2014-01-15 00:23:08.000000', 'temperatura', 314.0000, 'ºC'),
	(150505, 120, '2014-01-15 00:23:09.000000', 'temperatura', 665.0000, 'ºC'),
	(150506, 120, '2014-01-15 00:23:10.000000', 'temperatura', 1186.0000, 'ºC'),
	(150507, 120, '2014-01-15 00:23:11.000000', 'temperatura', 333.0000, 'ºC'),
	(150508, 120, '2014-01-15 00:23:12.000000', 'temperatura', 507.0000, 'ºC'),
	(150509, 120, '2014-01-15 00:23:13.000000', 'temperatura', 337.0000, 'ºC'),
	(150510, 120, '2014-01-15 00:23:14.000000', 'temperatura', 165.0000, 'ºC'),
	(150511, 120, '2014-01-15 00:23:15.000000', 'temperatura', 1014.0000, 'ºC'),
	(150512, 120, '2014-01-15 00:23:16.000000', 'temperatura', 976.0000, 'ºC'),
	(150513, 120, '2014-01-15 00:23:17.000000', 'temperatura', 640.0000, 'ºC'),
	(150514, 120, '2014-01-15 00:23:18.000000', 'temperatura', 271.0000, 'ºC'),
	(150515, 120, '2014-01-15 00:23:19.000000', 'temperatura', 634.0000, 'ºC'),
	(150516, 120, '2014-01-15 00:23:20.000000', 'temperatura', 1160.0000, 'ºC'),
	(150517, 120, '2014-01-15 00:23:21.000000', 'temperatura', 297.0000, 'ºC'),
	(150518, 120, '2014-01-15 00:23:22.000000', 'temperatura', 404.0000, 'ºC'),
	(150519, 120, '2014-01-15 00:23:23.000000', 'temperatura', 1132.0000, 'ºC'),
	(150520, 120, '2014-01-15 00:23:24.000000', 'temperatura', 849.0000, 'ºC'),
	(150521, 120, '2014-01-15 00:23:25.000000', 'temperatura', 851.0000, 'ºC'),
	(150522, 120, '2014-01-15 00:23:26.000000', 'temperatura', 505.0000, 'ºC'),
	(150523, 120, '2014-01-15 00:23:27.000000', 'temperatura', 1176.0000, 'ºC'),
	(150524, 120, '2014-01-15 00:23:28.000000', 'temperatura', 764.0000, 'ºC'),
	(150525, 120, '2014-01-15 00:23:29.000000', 'temperatura', 290.0000, 'ºC'),
	(150526, 120, '2014-01-15 00:23:30.000000', 'temperatura', 362.0000, 'ºC'),
	(150527, 120, '2014-01-15 00:23:31.000000', 'temperatura', 940.0000, 'ºC'),
	(150528, 120, '2014-01-15 00:23:32.000000', 'temperatura', 16.0000, 'ºC'),
	(150529, 120, '2014-01-15 00:23:33.000000', 'temperatura', 857.0000, 'ºC'),
	(150530, 120, '2014-01-15 00:23:34.000000', 'temperatura', 640.0000, 'ºC'),
	(150531, 120, '2014-01-15 00:23:35.000000', 'temperatura', 627.0000, 'ºC'),
	(150532, 120, '2014-01-15 00:23:36.000000', 'temperatura', 17.0000, 'ºC'),
	(150533, 120, '2014-01-15 00:23:37.000000', 'temperatura', 603.0000, 'ºC'),
	(150534, 120, '2014-01-15 00:23:38.000000', 'temperatura', 567.0000, 'ºC'),
	(150535, 120, '2014-01-15 00:23:39.000000', 'temperatura', 1024.0000, 'ºC'),
	(150536, 120, '2014-01-15 00:23:40.000000', 'temperatura', 1019.0000, 'ºC'),
	(150537, 120, '2014-01-15 00:23:41.000000', 'temperatura', 826.0000, 'ºC'),
	(150538, 120, '2014-01-15 00:23:42.000000', 'temperatura', 1073.0000, 'ºC'),
	(150539, 120, '2014-01-15 00:23:43.000000', 'temperatura', 485.0000, 'ºC'),
	(150540, 120, '2014-01-15 00:23:44.000000', 'temperatura', 409.0000, 'ºC'),
	(150541, 120, '2014-01-15 00:23:45.000000', 'temperatura', 591.0000, 'ºC'),
	(150542, 120, '2014-01-15 00:23:46.000000', 'temperatura', 527.0000, 'ºC'),
	(150543, 120, '2014-01-15 00:23:47.000000', 'temperatura', 862.0000, 'ºC'),
	(150544, 120, '2014-01-15 00:23:48.000000', 'temperatura', 331.0000, 'ºC'),
	(150545, 120, '2014-01-15 00:23:49.000000', 'temperatura', 270.0000, 'ºC'),
	(150546, 120, '2014-01-15 00:23:50.000000', 'temperatura', 357.0000, 'ºC'),
	(150547, 120, '2014-01-15 00:23:51.000000', 'temperatura', 974.0000, 'ºC'),
	(150548, 120, '2014-01-15 00:23:52.000000', 'temperatura', 201.0000, 'ºC'),
	(150549, 120, '2014-01-15 00:23:53.000000', 'temperatura', 482.0000, 'ºC'),
	(150550, 120, '2014-01-15 00:23:54.000000', 'temperatura', 608.0000, 'ºC'),
	(150551, 120, '2014-01-15 00:23:55.000000', 'temperatura', 396.0000, 'ºC'),
	(150552, 120, '2014-01-15 00:23:56.000000', 'temperatura', 154.0000, 'ºC'),
	(150553, 120, '2014-01-15 00:23:57.000000', 'temperatura', 783.0000, 'ºC'),
	(150554, 120, '2014-01-15 00:23:58.000000', 'temperatura', 1055.0000, 'ºC'),
	(150555, 120, '2014-01-15 00:23:59.000000', 'temperatura', 525.0000, 'ºC'),
	(150556, 120, '2014-01-15 00:24:00.000000', 'temperatura', 662.0000, 'ºC'),
	(150557, 120, '2014-01-15 00:24:01.000000', 'temperatura', 536.0000, 'ºC'),
	(150558, 120, '2014-01-15 00:24:02.000000', 'temperatura', 692.0000, 'ºC'),
	(150559, 120, '2014-01-15 00:24:03.000000', 'temperatura', 653.0000, 'ºC'),
	(150560, 120, '2014-01-15 00:24:04.000000', 'temperatura', 1191.0000, 'ºC'),
	(150561, 120, '2014-01-15 00:24:05.000000', 'temperatura', 398.0000, 'ºC'),
	(150562, 120, '2014-01-15 00:24:06.000000', 'temperatura', 815.0000, 'ºC'),
	(150563, 120, '2014-01-15 00:24:07.000000', 'temperatura', 483.0000, 'ºC'),
	(150564, 120, '2014-01-15 00:24:08.000000', 'temperatura', 1171.0000, 'ºC'),
	(150565, 120, '2014-01-15 00:24:09.000000', 'temperatura', 806.0000, 'ºC'),
	(150566, 120, '2014-01-15 00:24:10.000000', 'temperatura', 518.0000, 'ºC'),
	(150567, 120, '2014-01-15 00:24:11.000000', 'temperatura', 173.0000, 'ºC'),
	(150568, 120, '2014-01-15 00:24:12.000000', 'temperatura', 510.0000, 'ºC'),
	(150569, 120, '2014-01-15 00:24:13.000000', 'temperatura', 831.0000, 'ºC'),
	(150570, 120, '2014-01-15 00:24:14.000000', 'temperatura', 226.0000, 'ºC'),
	(150571, 120, '2014-01-15 00:24:15.000000', 'temperatura', 1038.0000, 'ºC'),
	(150572, 120, '2014-01-15 00:24:16.000000', 'temperatura', 914.0000, 'ºC'),
	(150573, 120, '2014-01-15 00:24:17.000000', 'temperatura', 255.0000, 'ºC'),
	(150574, 120, '2014-01-15 00:24:18.000000', 'temperatura', 935.0000, 'ºC'),
	(150575, 120, '2014-01-15 00:24:19.000000', 'temperatura', 311.0000, 'ºC'),
	(150576, 120, '2014-01-15 00:24:20.000000', 'temperatura', 1151.0000, 'ºC'),
	(150577, 120, '2014-01-15 00:24:21.000000', 'temperatura', 22.0000, 'ºC'),
	(150578, 120, '2014-01-15 00:24:22.000000', 'temperatura', 255.0000, 'ºC'),
	(150579, 120, '2014-01-15 00:24:23.000000', 'temperatura', 12.0000, 'ºC'),
	(150580, 120, '2014-01-15 00:24:24.000000', 'temperatura', 496.0000, 'ºC'),
	(150581, 120, '2014-01-15 00:24:25.000000', 'temperatura', 42.0000, 'ºC'),
	(150582, 120, '2014-01-15 00:24:26.000000', 'temperatura', 1124.0000, 'ºC'),
	(150583, 120, '2014-01-15 00:24:27.000000', 'temperatura', 692.0000, 'ºC'),
	(150584, 120, '2014-01-15 00:24:28.000000', 'temperatura', 91.0000, 'ºC'),
	(150585, 120, '2014-01-15 00:24:29.000000', 'temperatura', 778.0000, 'ºC'),
	(150586, 120, '2014-01-15 00:24:30.000000', 'temperatura', 20.0000, 'ºC'),
	(150587, 120, '2014-01-15 00:24:31.000000', 'temperatura', 165.0000, 'ºC'),
	(150588, 120, '2014-01-15 00:24:32.000000', 'temperatura', 764.0000, 'ºC'),
	(150589, 120, '2014-01-15 00:24:33.000000', 'temperatura', 927.0000, 'ºC'),
	(150590, 120, '2014-01-15 00:24:34.000000', 'temperatura', 1142.0000, 'ºC'),
	(150591, 120, '2014-01-15 00:24:35.000000', 'temperatura', 530.0000, 'ºC'),
	(150592, 120, '2014-01-15 00:24:36.000000', 'temperatura', 423.0000, 'ºC'),
	(150593, 120, '2014-01-15 00:24:37.000000', 'temperatura', 529.0000, 'ºC'),
	(150594, 120, '2014-01-15 00:24:38.000000', 'temperatura', 174.0000, 'ºC'),
	(150595, 120, '2014-01-15 00:24:39.000000', 'temperatura', 485.0000, 'ºC'),
	(150596, 120, '2014-01-15 00:24:40.000000', 'temperatura', 701.0000, 'ºC'),
	(150597, 120, '2014-01-15 00:24:41.000000', 'temperatura', 852.0000, 'ºC'),
	(150598, 120, '2014-01-15 00:24:42.000000', 'temperatura', 957.0000, 'ºC'),
	(150599, 120, '2014-01-15 00:24:43.000000', 'temperatura', 1029.0000, 'ºC'),
	(150600, 120, '2014-01-15 00:24:44.000000', 'temperatura', 1074.0000, 'ºC'),
	(150601, 120, '2014-01-15 00:24:45.000000', 'temperatura', 1085.0000, 'ºC'),
	(150602, 120, '2014-01-15 00:24:46.000000', 'temperatura', 1002.0000, 'ºC'),
	(150603, 120, '2014-01-15 00:24:47.000000', 'temperatura', 557.0000, 'ºC'),
	(150604, 120, '2014-01-15 00:24:48.000000', 'temperatura', 977.0000, 'ºC'),
	(150605, 120, '2014-01-15 00:24:49.000000', 'temperatura', 816.0000, 'ºC'),
	(150606, 120, '2014-01-15 00:24:50.000000', 'temperatura', 1151.0000, 'ºC'),
	(150607, 120, '2014-01-15 00:24:51.000000', 'temperatura', 908.0000, 'ºC'),
	(150608, 120, '2014-01-15 00:24:52.000000', 'temperatura', 1088.0000, 'ºC'),
	(150609, 120, '2014-01-15 00:24:53.000000', 'temperatura', 317.0000, 'ºC'),
	(150610, 120, '2014-01-15 00:24:54.000000', 'temperatura', 720.0000, 'ºC'),
	(150611, 120, '2014-01-15 00:24:55.000000', 'temperatura', 249.0000, 'ºC'),
	(150612, 120, '2014-01-15 00:24:56.000000', 'temperatura', 285.0000, 'ºC'),
	(150613, 120, '2014-01-15 00:24:57.000000', 'temperatura', 680.0000, 'ºC'),
	(150614, 120, '2014-01-15 00:24:58.000000', 'temperatura', 146.0000, 'ºC'),
	(150615, 120, '2014-01-15 00:24:59.000000', 'temperatura', 1092.0000, 'ºC'),
	(150616, 120, '2014-01-15 00:25:00.000000', 'temperatura', 220.0000, 'ºC'),
	(150617, 120, '2014-01-15 00:25:01.000000', 'temperatura', 227.0000, 'ºC'),
	(150618, 120, '2014-01-15 00:25:02.000000', 'temperatura', 472.0000, 'ºC'),
	(150619, 120, '2014-01-15 00:25:03.000000', 'temperatura', 481.0000, 'ºC'),
	(150620, 120, '2014-01-15 00:25:04.000000', 'temperatura', 992.0000, 'ºC'),
	(150621, 120, '2014-01-15 00:25:05.000000', 'temperatura', 1114.0000, 'ºC'),
	(150622, 120, '2014-01-15 00:25:06.000000', 'temperatura', 196.0000, 'ºC'),
	(150623, 120, '2014-01-15 00:25:07.000000', 'temperatura', 40.0000, 'ºC'),
	(150624, 120, '2014-01-15 00:25:08.000000', 'temperatura', 813.0000, 'ºC'),
	(150625, 120, '2014-01-15 00:25:09.000000', 'temperatura', 345.0000, 'ºC'),
	(150626, 120, '2014-01-15 00:25:10.000000', 'temperatura', 487.0000, 'ºC'),
	(150627, 120, '2014-01-15 00:25:11.000000', 'temperatura', 201.0000, 'ºC'),
	(150628, 120, '2014-01-15 00:25:12.000000', 'temperatura', 744.0000, 'ºC'),
	(150629, 120, '2014-01-15 00:25:13.000000', 'temperatura', 718.0000, 'ºC'),
	(150630, 120, '2014-01-15 00:25:14.000000', 'temperatura', 157.0000, 'ºC'),
	(150631, 120, '2014-01-15 00:25:15.000000', 'temperatura', 1033.0000, 'ºC'),
	(150632, 120, '2014-01-15 00:25:16.000000', 'temperatura', 1093.0000, 'ºC'),
	(150633, 120, '2014-01-15 00:25:17.000000', 'temperatura', 1167.0000, 'ºC'),
	(150634, 120, '2014-01-15 00:25:18.000000', 'temperatura', 156.0000, 'ºC'),
	(150635, 120, '2014-01-15 00:25:19.000000', 'temperatura', 881.0000, 'ºC'),
	(150636, 120, '2014-01-15 00:25:20.000000', 'temperatura', 336.0000, 'ºC'),
	(150637, 120, '2014-01-15 00:25:21.000000', 'temperatura', 237.0000, 'ºC'),
	(150638, 120, '2014-01-15 00:25:22.000000', 'temperatura', 179.0000, 'ºC'),
	(150639, 120, '2014-01-15 00:25:23.000000', 'temperatura', 182.0000, 'ºC'),
	(150640, 120, '2014-01-15 00:25:24.000000', 'temperatura', 375.0000, 'ºC'),
	(150641, 120, '2014-01-15 00:25:25.000000', 'temperatura', 131.0000, 'ºC'),
	(150642, 120, '2014-01-15 00:25:26.000000', 'temperatura', 731.0000, 'ºC'),
	(150643, 120, '2014-01-15 00:25:27.000000', 'temperatura', 859.0000, 'ºC'),
	(150644, 120, '2014-01-15 00:25:28.000000', 'temperatura', 906.0000, 'ºC'),
	(150645, 120, '2014-01-15 00:25:29.000000', 'temperatura', 751.0000, 'ºC'),
	(150646, 120, '2014-01-15 00:25:30.000000', 'temperatura', 1039.0000, 'ºC'),
	(150647, 120, '2014-01-15 00:25:31.000000', 'temperatura', 544.0000, 'ºC'),
	(150648, 120, '2014-01-15 00:25:32.000000', 'temperatura', 801.0000, 'ºC'),
	(150649, 120, '2014-01-15 00:25:33.000000', 'temperatura', 1173.0000, 'ºC'),
	(150650, 120, '2014-01-15 00:25:34.000000', 'temperatura', 1062.0000, 'ºC'),
	(150651, 120, '2014-01-15 00:25:35.000000', 'temperatura', 593.0000, 'ºC'),
	(150652, 120, '2014-01-15 00:25:36.000000', 'temperatura', 979.0000, 'ºC'),
	(150653, 120, '2014-01-15 00:25:37.000000', 'temperatura', 717.0000, 'ºC'),
	(150654, 120, '2014-01-15 00:25:38.000000', 'temperatura', 650.0000, 'ºC'),
	(150655, 120, '2014-01-15 00:25:39.000000', 'temperatura', 1097.0000, 'ºC'),
	(150656, 120, '2014-01-15 00:25:40.000000', 'temperatura', 1136.0000, 'ºC'),
	(150657, 120, '2014-01-15 00:25:41.000000', 'temperatura', 1190.0000, 'ºC'),
	(150658, 120, '2014-01-15 00:25:42.000000', 'temperatura', 144.0000, 'ºC'),
	(150659, 120, '2014-01-15 00:25:43.000000', 'temperatura', 749.0000, 'ºC'),
	(150660, 120, '2014-01-15 00:25:44.000000', 'temperatura', 912.0000, 'ºC'),
	(150661, 120, '2014-01-15 00:25:45.000000', 'temperatura', 1115.0000, 'ºC'),
	(150662, 120, '2014-01-15 00:25:46.000000', 'temperatura', 441.0000, 'ºC'),
	(150663, 120, '2014-01-15 00:25:47.000000', 'temperatura', 61.0000, 'ºC'),
	(150664, 120, '2014-01-15 00:25:48.000000', 'temperatura', 180.0000, 'ºC'),
	(150665, 120, '2014-01-15 00:25:49.000000', 'temperatura', 717.0000, 'ºC'),
	(150666, 120, '2014-01-15 00:25:50.000000', 'temperatura', 647.0000, 'ºC'),
	(150667, 120, '2014-01-15 00:25:51.000000', 'temperatura', 1084.0000, 'ºC'),
	(150668, 120, '2014-01-15 00:25:52.000000', 'temperatura', 1081.0000, 'ºC'),
	(150669, 120, '2014-01-15 00:25:53.000000', 'temperatura', 953.0000, 'ºC'),
	(150670, 120, '2014-01-15 00:25:54.000000', 'temperatura', 323.0000, 'ºC'),
	(150671, 120, '2014-01-15 00:25:55.000000', 'temperatura', 1156.0000, 'ºC'),
	(150672, 120, '2014-01-15 00:25:56.000000', 'temperatura', 11.0000, 'ºC'),
	(150673, 120, '2014-01-15 00:25:57.000000', 'temperatura', 186.0000, 'ºC'),
	(150674, 120, '2014-01-15 00:25:58.000000', 'temperatura', 899.0000, 'ºC'),
	(150675, 120, '2014-01-15 00:25:59.000000', 'temperatura', 337.0000, 'ºC'),
	(150676, 120, '2014-01-15 00:26:00.000000', 'temperatura', 188.0000, 'ºC'),
	(150677, 120, '2014-01-15 00:26:01.000000', 'temperatura', 1131.0000, 'ºC'),
	(150678, 120, '2014-01-15 00:26:02.000000', 'temperatura', 292.0000, 'ºC'),
	(150679, 120, '2014-01-15 00:26:03.000000', 'temperatura', 468.0000, 'ºC'),
	(150680, 120, '2014-01-15 00:26:04.000000', 'temperatura', 263.0000, 'ºC'),
	(150681, 120, '2014-01-15 00:26:05.000000', 'temperatura', 1111.0000, 'ºC'),
	(150682, 120, '2014-01-15 00:26:06.000000', 'temperatura', 1168.0000, 'ºC'),
	(150683, 120, '2014-01-15 00:26:07.000000', 'temperatura', 108.0000, 'ºC'),
	(150684, 120, '2014-01-15 00:26:08.000000', 'temperatura', 637.0000, 'ºC'),
	(150685, 120, '2014-01-15 00:26:09.000000', 'temperatura', 460.0000, 'ºC'),
	(150686, 120, '2014-01-15 00:26:10.000000', 'temperatura', 391.0000, 'ºC'),
	(150687, 120, '2014-01-15 00:26:11.000000', 'temperatura', 574.0000, 'ºC'),
	(150688, 120, '2014-01-15 00:26:12.000000', 'temperatura', 497.0000, 'ºC'),
	(150689, 120, '2014-01-15 00:26:13.000000', 'temperatura', 765.0000, 'ºC'),
	(150690, 120, '2014-01-15 00:26:14.000000', 'temperatura', 1135.0000, 'ºC'),
	(150691, 120, '2014-01-15 00:26:15.000000', 'temperatura', 978.0000, 'ºC'),
	(150692, 120, '2014-01-15 00:26:16.000000', 'temperatura', 286.0000, 'ºC'),
	(150693, 120, '2014-01-15 00:26:17.000000', 'temperatura', 898.0000, 'ºC'),
	(150694, 120, '2014-01-15 00:26:18.000000', 'temperatura', 30.0000, 'ºC'),
	(150695, 120, '2014-01-15 00:26:19.000000', 'temperatura', 1057.0000, 'ºC'),
	(150696, 120, '2014-01-15 00:26:20.000000', 'temperatura', 394.0000, 'ºC'),
	(150697, 120, '2014-01-15 00:26:21.000000', 'temperatura', 1.0000, 'ºC'),
	(150698, 120, '2014-01-15 00:26:22.000000', 'temperatura', 23.0000, 'ºC'),
	(150699, 120, '2014-01-15 00:26:23.000000', 'temperatura', 113.0000, 'ºC'),
	(150700, 120, '2014-01-15 00:26:24.000000', 'temperatura', 498.0000, 'ºC'),
	(150701, 120, '2014-01-15 00:26:25.000000', 'temperatura', 952.0000, 'ºC'),
	(150702, 120, '2014-01-15 00:26:26.000000', 'temperatura', 867.0000, 'ºC'),
	(150703, 120, '2014-01-15 00:26:27.000000', 'temperatura', 277.0000, 'ºC'),
	(150704, 120, '2014-01-15 00:26:28.000000', 'temperatura', 1184.0000, 'ºC'),
	(150705, 120, '2014-01-15 00:26:29.000000', 'temperatura', 291.0000, 'ºC'),
	(150706, 120, '2014-01-15 00:26:30.000000', 'temperatura', 301.0000, 'ºC'),
	(150707, 120, '2014-01-15 00:26:31.000000', 'temperatura', 635.0000, 'ºC'),
	(150708, 120, '2014-01-15 00:26:32.000000', 'temperatura', 1072.0000, 'ºC'),
	(150709, 120, '2014-01-15 00:26:33.000000', 'temperatura', 1057.0000, 'ºC'),
	(150710, 120, '2014-01-15 00:26:34.000000', 'temperatura', 869.0000, 'ºC'),
	(150711, 120, '2014-01-15 00:26:35.000000', 'temperatura', 1173.0000, 'ºC'),
	(150712, 120, '2014-01-15 00:26:36.000000', 'temperatura', 859.0000, 'ºC'),
	(150713, 120, '2014-01-15 00:26:37.000000', 'temperatura', 776.0000, 'ºC'),
	(150714, 120, '2014-01-15 00:26:38.000000', 'temperatura', 105.0000, 'ºC'),
	(150715, 120, '2014-01-15 00:26:39.000000', 'temperatura', 598.0000, 'ºC'),
	(150716, 120, '2014-01-15 00:26:40.000000', 'temperatura', 275.0000, 'ºC'),
	(150717, 120, '2014-01-15 00:26:41.000000', 'temperatura', 783.0000, 'ºC'),
	(150718, 120, '2014-01-15 00:26:42.000000', 'temperatura', 688.0000, 'ºC'),
	(150719, 120, '2014-01-15 00:26:43.000000', 'temperatura', 1091.0000, 'ºC'),
	(150720, 120, '2014-01-15 00:26:44.000000', 'temperatura', 992.0000, 'ºC'),
	(150721, 120, '2014-01-15 00:26:45.000000', 'temperatura', 489.0000, 'ºC'),
	(150722, 120, '2014-01-15 00:26:46.000000', 'temperatura', 668.0000, 'ºC'),
	(150723, 120, '2014-01-15 00:26:47.000000', 'temperatura', 675.0000, 'ºC'),
	(150724, 120, '2014-01-15 00:26:48.000000', 'temperatura', 170.0000, 'ºC'),
	(150725, 120, '2014-01-15 00:26:49.000000', 'temperatura', 24.0000, 'ºC'),
	(150726, 120, '2014-01-15 00:26:50.000000', 'temperatura', 814.0000, 'ºC'),
	(150727, 120, '2014-01-15 00:26:51.000000', 'temperatura', 396.0000, 'ºC'),
	(150728, 120, '2014-01-15 00:26:52.000000', 'temperatura', 739.0000, 'ºC'),
	(150729, 120, '2014-01-15 00:26:53.000000', 'temperatura', 108.0000, 'ºC'),
	(150730, 120, '2014-01-15 00:26:54.000000', 'temperatura', 724.0000, 'ºC'),
	(150731, 120, '2014-01-15 00:26:55.000000', 'temperatura', 897.0000, 'ºC'),
	(150732, 120, '2014-01-15 00:26:56.000000', 'temperatura', 1111.0000, 'ºC'),
	(150733, 120, '2014-01-15 00:26:57.000000', 'temperatura', 468.0000, 'ºC'),
	(150734, 120, '2014-01-15 00:26:58.000000', 'temperatura', 204.0000, 'ºC'),
	(150735, 120, '2014-01-15 00:26:59.000000', 'temperatura', 818.0000, 'ºC'),
	(150736, 120, '2014-01-15 00:27:00.000000', 'temperatura', 1077.0000, 'ºC'),
	(150737, 120, '2014-01-15 00:27:01.000000', 'temperatura', 533.0000, 'ºC'),
	(150738, 120, '2014-01-15 00:27:02.000000', 'temperatura', 636.0000, 'ºC'),
	(150739, 120, '2014-01-15 00:27:03.000000', 'temperatura', 381.0000, 'ºC'),
	(150740, 120, '2014-01-15 00:27:04.000000', 'temperatura', 1197.0000, 'ºC'),
	(150741, 120, '2014-01-15 00:27:05.000000', 'temperatura', 44.0000, 'ºC'),
	(150742, 120, '2014-01-15 00:27:06.000000', 'temperatura', 229.0000, 'ºC'),
	(150743, 120, '2014-01-15 00:27:07.000000', 'temperatura', 1012.0000, 'ºC'),
	(150744, 120, '2014-01-15 00:27:08.000000', 'temperatura', 775.0000, 'ºC'),
	(150745, 120, '2014-01-15 00:27:09.000000', 'temperatura', 839.0000, 'ºC'),
	(150746, 120, '2014-01-15 00:27:10.000000', 'temperatura', 670.0000, 'ºC'),
	(150747, 120, '2014-01-15 00:27:11.000000', 'temperatura', 833.0000, 'ºC'),
	(150748, 120, '2014-01-15 00:27:12.000000', 'temperatura', 956.0000, 'ºC'),
	(150749, 120, '2014-01-15 00:27:13.000000', 'temperatura', 1083.0000, 'ºC'),
	(150750, 120, '2014-01-15 00:27:14.000000', 'temperatura', 146.0000, 'ºC'),
	(150751, 120, '2014-01-15 00:27:15.000000', 'temperatura', 1084.0000, 'ºC'),
	(150752, 120, '2014-01-15 00:27:16.000000', 'temperatura', 179.0000, 'ºC'),
	(150753, 120, '2014-01-15 00:27:17.000000', 'temperatura', 46.0000, 'ºC'),
	(150754, 120, '2014-01-15 00:27:18.000000', 'temperatura', 893.0000, 'ºC'),
	(150755, 120, '2014-01-15 00:27:19.000000', 'temperatura', 727.0000, 'ºC'),
	(150756, 120, '2014-01-15 00:27:20.000000', 'temperatura', 956.0000, 'ºC'),
	(150757, 120, '2014-01-15 00:27:21.000000', 'temperatura', 198.0000, 'ºC'),
	(150758, 120, '2014-01-15 00:27:22.000000', 'temperatura', 525.0000, 'ºC'),
	(150759, 120, '2014-01-15 00:27:23.000000', 'temperatura', 830.0000, 'ºC'),
	(150760, 120, '2014-01-15 00:27:24.000000', 'temperatura', 177.0000, 'ºC'),
	(150761, 120, '2014-01-15 00:27:25.000000', 'temperatura', 793.0000, 'ºC'),
	(150762, 120, '2014-01-15 00:27:26.000000', 'temperatura', 1035.0000, 'ºC'),
	(150763, 120, '2014-01-15 00:27:27.000000', 'temperatura', 397.0000, 'ºC'),
	(150764, 120, '2014-01-15 00:27:28.000000', 'temperatura', 79.0000, 'ºC'),
	(150765, 120, '2014-01-15 00:27:29.000000', 'temperatura', 405.0000, 'ºC'),
	(150766, 120, '2014-01-15 00:27:30.000000', 'temperatura', 588.0000, 'ºC'),
	(150767, 120, '2014-01-15 00:27:31.000000', 'temperatura', 525.0000, 'ºC'),
	(150768, 120, '2014-01-15 00:27:32.000000', 'temperatura', 861.0000, 'ºC'),
	(150769, 120, '2014-01-15 00:27:33.000000', 'temperatura', 333.0000, 'ºC'),
	(150770, 120, '2014-01-15 00:27:34.000000', 'temperatura', 280.0000, 'ºC'),
	(150771, 120, '2014-01-15 00:27:35.000000', 'temperatura', 404.0000, 'ºC'),
	(150772, 120, '2014-01-15 00:27:36.000000', 'temperatura', 1178.0000, 'ºC'),
	(150773, 120, '2014-01-15 00:27:37.000000', 'temperatura', 1077.0000, 'ºC'),
	(150774, 120, '2014-01-15 00:27:38.000000', 'temperatura', 655.0000, 'ºC'),
	(150775, 120, '2014-01-15 00:27:39.000000', 'temperatura', 44.0000, 'ºC'),
	(150776, 120, '2014-01-15 00:27:40.000000', 'temperatura', 654.0000, 'ºC'),
	(150777, 120, '2014-01-15 00:27:41.000000', 'temperatura', 738.0000, 'ºC'),
	(150778, 120, '2014-01-15 00:27:42.000000', 'temperatura', 531.0000, 'ºC'),
	(150779, 120, '2014-01-15 00:27:43.000000', 'temperatura', 440.0000, 'ºC'),
	(150780, 120, '2014-01-15 00:27:44.000000', 'temperatura', 608.0000, 'ºC'),
	(150781, 120, '2014-01-15 00:27:45.000000', 'temperatura', 522.0000, 'ºC'),
	(150782, 120, '2014-01-15 00:27:46.000000', 'temperatura', 787.0000, 'ºC'),
	(150783, 120, '2014-01-15 00:27:47.000000', 'temperatura', 1166.0000, 'ºC'),
	(150784, 120, '2014-01-15 00:27:48.000000', 'temperatura', 1072.0000, 'ºC'),
	(150785, 120, '2014-01-15 00:27:49.000000', 'temperatura', 664.0000, 'ºC'),
	(150786, 120, '2014-01-15 00:27:50.000000', 'temperatura', 102.0000, 'ºC'),
	(150787, 120, '2014-01-15 00:27:51.000000', 'temperatura', 918.0000, 'ºC'),
	(150788, 120, '2014-01-15 00:27:52.000000', 'temperatura', 687.0000, 'ºC'),
	(150789, 120, '2014-01-15 00:27:53.000000', 'temperatura', 681.0000, 'ºC'),
	(150790, 120, '2014-01-15 00:27:54.000000', 'temperatura', 143.0000, 'ºC'),
	(150791, 120, '2014-01-15 00:27:55.000000', 'temperatura', 1073.0000, 'ºC'),
	(150792, 120, '2014-01-15 00:27:56.000000', 'temperatura', 135.0000, 'ºC'),
	(150793, 120, '2014-01-15 00:27:57.000000', 'temperatura', 1058.0000, 'ºC'),
	(150794, 120, '2014-01-15 00:27:58.000000', 'temperatura', 85.0000, 'ºC'),
	(150795, 120, '2014-01-15 00:27:59.000000', 'temperatura', 850.0000, 'ºC'),
	(150796, 120, '2014-01-15 00:28:00.000000', 'temperatura', 398.0000, 'ºC'),
	(150797, 120, '2014-01-15 00:28:01.000000', 'temperatura', 640.0000, 'ºC'),
	(150798, 120, '2014-01-15 00:28:02.000000', 'temperatura', 806.0000, 'ºC'),
	(150799, 120, '2014-01-15 00:28:03.000000', 'temperatura', 910.0000, 'ºC'),
	(150800, 120, '2014-01-15 00:28:04.000000', 'temperatura', 931.0000, 'ºC'),
	(150801, 120, '2014-01-15 00:28:05.000000', 'temperatura', 727.0000, 'ºC'),
	(150802, 120, '2014-01-15 00:28:06.000000', 'temperatura', 844.0000, 'ºC'),
	(150803, 120, '2014-01-15 00:28:07.000000', 'temperatura', 840.0000, 'ºC'),
	(150804, 120, '2014-01-15 00:28:08.000000', 'temperatura', 465.0000, 'ºC'),
	(150805, 120, '2014-01-15 00:28:09.000000', 'temperatura', 1009.0000, 'ºC'),
	(150806, 120, '2014-01-15 00:28:10.000000', 'temperatura', 48.0000, 'ºC'),
	(150807, 120, '2014-01-15 00:28:11.000000', 'temperatura', 816.0000, 'ºC'),
	(150808, 120, '2014-01-15 00:28:12.000000', 'temperatura', 335.0000, 'ºC'),
	(150809, 120, '2014-01-15 00:28:13.000000', 'temperatura', 429.0000, 'ºC'),
	(150810, 120, '2014-01-15 00:28:14.000000', 'temperatura', 1141.0000, 'ºC'),
	(150811, 120, '2014-01-15 00:28:15.000000', 'temperatura', 816.0000, 'ºC'),
	(150812, 120, '2014-01-15 00:28:16.000000', 'temperatura', 660.0000, 'ºC'),
	(150813, 120, '2014-01-15 00:28:17.000000', 'temperatura', 851.0000, 'ºC'),
	(150814, 120, '2014-01-15 00:28:18.000000', 'temperatura', 1075.0000, 'ºC'),
	(150815, 120, '2014-01-15 00:28:19.000000', 'temperatura', 424.0000, 'ºC'),
	(150816, 120, '2014-01-15 00:28:20.000000', 'temperatura', 93.0000, 'ºC'),
	(150817, 120, '2014-01-15 00:28:21.000000', 'temperatura', 394.0000, 'ºC'),
	(150818, 120, '2014-01-15 00:28:22.000000', 'temperatura', 492.0000, 'ºC'),
	(150819, 120, '2014-01-15 00:28:23.000000', 'temperatura', 77.0000, 'ºC'),
	(150820, 120, '2014-01-15 00:28:24.000000', 'temperatura', 111.0000, 'ºC'),
	(150821, 120, '2014-01-15 00:28:25.000000', 'temperatura', 323.0000, 'ºC'),
	(150822, 120, '2014-01-15 00:28:26.000000', 'temperatura', 82.0000, 'ºC'),
	(150823, 120, '2014-01-15 00:28:27.000000', 'temperatura', 640.0000, 'ºC'),
	(150824, 120, '2014-01-15 00:28:28.000000', 'temperatura', 558.0000, 'ºC'),
	(150825, 120, '2014-01-15 00:28:29.000000', 'temperatura', 868.0000, 'ºC'),
	(150826, 120, '2014-01-15 00:28:30.000000', 'temperatura', 267.0000, 'ºC'),
	(150827, 120, '2014-01-15 00:28:31.000000', 'temperatura', 1131.0000, 'ºC'),
	(150828, 120, '2014-01-15 00:28:32.000000', 'temperatura', 55.0000, 'ºC'),
	(150829, 120, '2014-01-15 00:28:33.000000', 'temperatura', 482.0000, 'ºC'),
	(150830, 120, '2014-01-15 00:28:34.000000', 'temperatura', 1047.0000, 'ºC'),
	(150831, 120, '2014-01-15 00:28:35.000000', 'temperatura', 190.0000, 'ºC'),
	(150832, 120, '2014-01-15 00:28:36.000000', 'temperatura', 209.0000, 'ºC'),
	(150833, 120, '2014-01-15 00:28:37.000000', 'temperatura', 473.0000, 'ºC'),
	(150834, 120, '2014-01-15 00:28:38.000000', 'temperatura', 541.0000, 'ºC'),
	(150835, 120, '2014-01-15 00:28:39.000000', 'temperatura', 84.0000, 'ºC'),
	(150836, 120, '2014-01-15 00:28:40.000000', 'temperatura', 1199.0000, 'ºC'),
	(150837, 120, '2014-01-15 00:28:41.000000', 'temperatura', 944.0000, 'ºC'),
	(150838, 120, '2014-01-15 00:28:42.000000', 'temperatura', 1123.0000, 'ºC'),
	(150839, 120, '2014-01-15 00:28:43.000000', 'temperatura', 382.0000, 'ºC'),
	(150840, 120, '2014-01-15 00:28:44.000000', 'temperatura', 944.0000, 'ºC'),
	(150841, 120, '2014-01-15 00:28:45.000000', 'temperatura', 1175.0000, 'ºC'),
	(150842, 120, '2014-01-15 00:28:46.000000', 'temperatura', 640.0000, 'ºC'),
	(150843, 120, '2014-01-15 00:28:47.000000', 'temperatura', 879.0000, 'ºC'),
	(150844, 120, '2014-01-15 00:28:48.000000', 'temperatura', 76.0000, 'ºC'),
	(150845, 120, '2014-01-15 00:28:49.000000', 'temperatura', 141.0000, 'ºC'),
	(150846, 120, '2014-01-15 00:28:50.000000', 'temperatura', 480.0000, 'ºC'),
	(150847, 120, '2014-01-15 00:28:51.000000', 'temperatura', 776.0000, 'ºC'),
	(150848, 120, '2014-01-15 00:28:52.000000', 'temperatura', 41.0000, 'ºC'),
	(150849, 120, '2014-01-15 00:28:53.000000', 'temperatura', 279.0000, 'ºC'),
	(150850, 120, '2014-01-15 00:28:54.000000', 'temperatura', 71.0000, 'ºC'),
	(150851, 120, '2014-01-15 00:28:55.000000', 'temperatura', 719.0000, 'ºC'),
	(150852, 120, '2014-01-15 00:28:56.000000', 'temperatura', 980.0000, 'ºC'),
	(150853, 120, '2014-01-15 00:28:57.000000', 'temperatura', 346.0000, 'ºC'),
	(150854, 120, '2014-01-15 00:28:58.000000', 'temperatura', 1190.0000, 'ºC'),
	(150855, 120, '2014-01-15 00:28:59.000000', 'temperatura', 111.0000, 'ºC'),
	(150856, 120, '2014-01-15 00:29:00.000000', 'temperatura', 584.0000, 'ºC'),
	(150857, 120, '2014-01-15 00:29:01.000000', 'temperatura', 191.0000, 'ºC'),
	(150858, 120, '2014-01-15 00:29:02.000000', 'temperatura', 403.0000, 'ºC'),
	(150859, 120, '2014-01-15 00:29:03.000000', 'temperatura', 241.0000, 'ºC'),
	(150860, 120, '2014-01-15 00:29:04.000000', 'temperatura', 1196.0000, 'ºC'),
	(150861, 120, '2014-01-15 00:29:05.000000', 'temperatura', 459.0000, 'ºC'),
	(150862, 120, '2014-01-15 00:29:06.000000', 'temperatura', 1106.0000, 'ºC'),
	(150863, 120, '2014-01-15 00:29:07.000000', 'temperatura', 553.0000, 'ºC'),
	(150864, 120, '2014-01-15 00:29:08.000000', 'temperatura', 650.0000, 'ºC'),
	(150865, 120, '2014-01-15 00:29:09.000000', 'temperatura', 389.0000, 'ºC'),
	(150866, 120, '2014-01-15 00:29:10.000000', 'temperatura', 1195.0000, 'ºC'),
	(150867, 120, '2014-01-15 00:29:11.000000', 'temperatura', 8.0000, 'ºC'),
	(150868, 120, '2014-01-15 00:29:12.000000', 'temperatura', 59.0000, 'ºC'),
	(150869, 120, '2014-01-15 00:29:13.000000', 'temperatura', 268.0000, 'ºC'),
	(150870, 120, '2014-01-15 00:29:14.000000', 'temperatura', 1164.0000, 'ºC'),
	(150871, 120, '2014-01-15 00:29:15.000000', 'temperatura', 215.0000, 'ºC'),
	(150872, 120, '2014-01-15 00:29:16.000000', 'temperatura', 1186.0000, 'ºC'),
	(150873, 120, '2014-01-15 00:29:17.000000', 'temperatura', 484.0000, 'ºC'),
	(150874, 120, '2014-01-15 00:29:18.000000', 'temperatura', 62.0000, 'ºC'),
	(150875, 120, '2014-01-15 00:29:19.000000', 'temperatura', 58.0000, 'ºC'),
	(150876, 120, '2014-01-15 00:29:20.000000', 'temperatura', 103.0000, 'ºC'),
	(150877, 120, '2014-01-15 00:29:21.000000', 'temperatura', 344.0000, 'ºC'),
	(150878, 120, '2014-01-15 00:29:22.000000', 'temperatura', 212.0000, 'ºC'),
	(150879, 120, '2014-01-15 00:29:23.000000', 'temperatura', 27.0000, 'ºC'),
	(150880, 120, '2014-01-15 00:29:24.000000', 'temperatura', 702.0000, 'ºC'),
	(150881, 120, '2014-01-15 00:29:25.000000', 'temperatura', 1028.0000, 'ºC'),
	(150882, 120, '2014-01-15 00:29:26.000000', 'temperatura', 634.0000, 'ºC'),
	(150883, 120, '2014-01-15 00:29:27.000000', 'temperatura', 86.0000, 'ºC'),
	(150884, 120, '2014-01-15 00:29:28.000000', 'temperatura', 927.0000, 'ºC'),
	(150885, 120, '2014-01-15 00:29:29.000000', 'temperatura', 780.0000, 'ºC'),
	(150886, 120, '2014-01-15 00:29:30.000000', 'temperatura', 1117.0000, 'ºC'),
	(150887, 120, '2014-01-15 00:29:31.000000', 'temperatura', 846.0000, 'ºC'),
	(150888, 120, '2014-01-15 00:29:32.000000', 'temperatura', 878.0000, 'ºC'),
	(150889, 120, '2014-01-15 00:29:33.000000', 'temperatura', 655.0000, 'ºC'),
	(150890, 120, '2014-01-15 00:29:34.000000', 'temperatura', 639.0000, 'ºC'),
	(150891, 120, '2014-01-15 00:29:35.000000', 'temperatura', 33.0000, 'ºC'),
	(150892, 120, '2014-01-15 00:29:36.000000', 'temperatura', 647.0000, 'ºC'),
	(150893, 120, '2014-01-15 00:29:37.000000', 'temperatura', 736.0000, 'ºC'),
	(150894, 120, '2014-01-15 00:29:38.000000', 'temperatura', 541.0000, 'ºC'),
	(150895, 120, '2014-01-15 00:29:39.000000', 'temperatura', 495.0000, 'ºC'),
	(150896, 120, '2014-01-15 00:29:40.000000', 'temperatura', 856.0000, 'ºC'),
	(150897, 120, '2014-01-15 00:29:41.000000', 'temperatura', 392.0000, 'ºC'),
	(150898, 120, '2014-01-15 00:29:42.000000', 'temperatura', 593.0000, 'ºC'),
	(150899, 120, '2014-01-15 00:29:43.000000', 'temperatura', 591.0000, 'ºC'),
	(150900, 120, '2014-01-15 00:29:44.000000', 'temperatura', 1176.0000, 'ºC'),
	(150901, 120, '2014-01-15 00:29:45.000000', 'temperatura', 506.0000, 'ºC'),
	(150902, 120, '2014-01-15 00:29:46.000000', 'temperatura', 202.0000, 'ºC'),
	(150903, 120, '2014-01-15 00:29:47.000000', 'temperatura', 696.0000, 'ºC'),
	(150904, 120, '2014-01-15 00:29:48.000000', 'temperatura', 471.0000, 'ºC'),
	(150905, 120, '2014-01-15 00:29:49.000000', 'temperatura', 269.0000, 'ºC'),
	(150906, 120, '2014-01-15 00:29:50.000000', 'temperatura', 1130.0000, 'ºC'),
	(150907, 120, '2014-01-15 00:29:51.000000', 'temperatura', 46.0000, 'ºC'),
	(150908, 120, '2014-01-15 00:29:52.000000', 'temperatura', 442.0000, 'ºC'),
	(150909, 120, '2014-01-15 00:29:53.000000', 'temperatura', 869.0000, 'ºC'),
	(150910, 120, '2014-01-15 00:29:54.000000', 'temperatura', 622.0000, 'ºC'),
	(150911, 120, '2014-01-15 00:29:55.000000', 'temperatura', 501.0000, 'ºC'),
	(150912, 120, '2014-01-15 00:29:56.000000', 'temperatura', 639.0000, 'ºC'),
	(150913, 120, '2014-01-15 00:29:57.000000', 'temperatura', 495.0000, 'ºC'),
	(150914, 120, '2014-01-15 00:29:58.000000', 'temperatura', 560.0000, 'ºC'),
	(150915, 120, '2014-01-15 00:29:59.000000', 'temperatura', 112.0000, 'ºC'),
	(150916, 120, '2014-01-15 00:30:00.000000', 'temperatura', 82.0000, 'ºC'),
	(150917, 120, '2014-01-15 00:30:01.000000', 'temperatura', 73.0000, 'ºC'),
	(150918, 120, '2014-01-15 00:30:02.000000', 'temperatura', 122.0000, 'ºC'),
	(150919, 120, '2014-01-15 00:30:03.000000', 'temperatura', 389.0000, 'ºC'),
	(150920, 120, '2014-01-15 00:30:04.000000', 'temperatura', 380.0000, 'ºC'),
	(150921, 120, '2014-01-15 00:30:05.000000', 'temperatura', 732.0000, 'ºC'),
	(150922, 120, '2014-01-15 00:30:06.000000', 'temperatura', 122.0000, 'ºC'),
	(150923, 120, '2014-01-15 00:30:07.000000', 'temperatura', 813.0000, 'ºC'),
	(150924, 120, '2014-01-15 00:30:08.000000', 'temperatura', 100.0000, 'ºC'),
	(150925, 120, '2014-01-15 00:30:09.000000', 'temperatura', 462.0000, 'ºC'),
	(150926, 120, '2014-01-15 00:30:10.000000', 'temperatura', 808.0000, 'ºC'),
	(150927, 120, '2014-01-15 00:30:11.000000', 'temperatura', 257.0000, 'ºC'),
	(150928, 120, '2014-01-15 00:30:12.000000', 'temperatura', 63.0000, 'ºC'),
	(150929, 120, '2014-01-15 00:30:13.000000', 'temperatura', 741.0000, 'ºC'),
	(150930, 120, '2014-01-15 00:30:14.000000', 'temperatura', 1118.0000, 'ºC'),
	(150931, 120, '2014-01-15 00:30:15.000000', 'temperatura', 967.0000, 'ºC'),
	(150932, 120, '2014-01-15 00:30:16.000000', 'temperatura', 283.0000, 'ºC'),
	(150933, 120, '2014-01-15 00:30:17.000000', 'temperatura', 916.0000, 'ºC'),
	(150934, 120, '2014-01-15 00:30:18.000000', 'temperatura', 129.0000, 'ºC'),
	(150935, 120, '2014-01-15 00:30:19.000000', 'temperatura', 297.0000, 'ºC'),
	(150936, 120, '2014-01-15 00:30:20.000000', 'temperatura', 1101.0000, 'ºC'),
	(150937, 120, '2014-01-15 00:30:21.000000', 'temperatura', 1015.0000, 'ºC'),
	(150938, 120, '2014-01-15 00:30:22.000000', 'temperatura', 572.0000, 'ºC'),
	(150939, 120, '2014-01-15 00:30:23.000000', 'temperatura', 1014.0000, 'ºC'),
	(150940, 120, '2014-01-15 00:30:24.000000', 'temperatura', 956.0000, 'ºC'),
	(150941, 120, '2014-01-15 00:30:25.000000', 'temperatura', 536.0000, 'ºC'),
	(150942, 120, '2014-01-15 00:30:26.000000', 'temperatura', 1015.0000, 'ºC'),
	(150943, 120, '2014-01-15 00:30:27.000000', 'temperatura', 1065.0000, 'ºC'),
	(150944, 120, '2014-01-15 00:30:28.000000', 'temperatura', 1084.0000, 'ºC'),
	(150945, 120, '2014-01-15 00:30:29.000000', 'temperatura', 1023.0000, 'ºC'),
	(150946, 120, '2014-01-15 00:30:30.000000', 'temperatura', 664.0000, 'ºC'),
	(150947, 120, '2014-01-15 00:30:31.000000', 'temperatura', 253.0000, 'ºC'),
	(150948, 120, '2014-01-15 00:30:32.000000', 'temperatura', 471.0000, 'ºC'),
	(150949, 120, '2014-01-15 00:30:33.000000', 'temperatura', 398.0000, 'ºC'),
	(150950, 120, '2014-01-15 00:30:34.000000', 'temperatura', 576.0000, 'ºC'),
	(150951, 120, '2014-01-15 00:30:35.000000', 'temperatura', 489.0000, 'ºC'),
	(150952, 120, '2014-01-15 00:30:36.000000', 'temperatura', 716.0000, 'ºC'),
	(150953, 120, '2014-01-15 00:30:37.000000', 'temperatura', 913.0000, 'ºC'),
	(150954, 120, '2014-01-15 00:30:38.000000', 'temperatura', 18.0000, 'ºC'),
	(150955, 120, '2014-01-15 00:30:39.000000', 'temperatura', 952.0000, 'ºC'),
	(150956, 120, '2014-01-15 00:30:40.000000', 'temperatura', 1106.0000, 'ºC'),
	(150957, 120, '2014-01-15 00:30:41.000000', 'temperatura', 274.0000, 'ºC'),
	(150958, 120, '2014-01-15 00:30:42.000000', 'temperatura', 452.0000, 'ºC'),
	(150959, 120, '2014-01-15 00:30:43.000000', 'temperatura', 240.0000, 'ºC'),
	(150960, 120, '2014-01-15 00:30:44.000000', 'temperatura', 1045.0000, 'ºC'),
	(150961, 120, '2014-01-15 00:30:45.000000', 'temperatura', 903.0000, 'ºC'),
	(150962, 120, '2014-01-15 00:30:46.000000', 'temperatura', 181.0000, 'ºC'),
	(150963, 120, '2014-01-15 00:30:47.000000', 'temperatura', 597.0000, 'ºC'),
	(150964, 120, '2014-01-15 00:30:48.000000', 'temperatura', 42.0000, 'ºC'),
	(150965, 120, '2014-01-15 00:30:49.000000', 'temperatura', 822.0000, 'ºC'),
	(150966, 120, '2014-01-15 00:30:50.000000', 'temperatura', 382.0000, 'ºC'),
	(150967, 120, '2014-01-15 00:30:51.000000', 'temperatura', 646.0000, 'ºC'),
	(150968, 120, '2014-01-15 00:30:52.000000', 'temperatura', 883.0000, 'ºC'),
	(150969, 120, '2014-01-15 00:30:53.000000', 'temperatura', 79.0000, 'ºC'),
	(150970, 120, '2014-01-15 00:30:54.000000', 'temperatura', 145.0000, 'ºC'),
	(150971, 120, '2014-01-15 00:30:55.000000', 'temperatura', 491.0000, 'ºC'),
	(150972, 120, '2014-01-15 00:30:56.000000', 'temperatura', 819.0000, 'ºC'),
	(150973, 120, '2014-01-15 00:30:57.000000', 'temperatura', 223.0000, 'ºC'),
	(150974, 120, '2014-01-15 00:30:58.000000', 'temperatura', 1058.0000, 'ºC'),
	(150975, 120, '2014-01-15 00:30:59.000000', 'temperatura', 1021.0000, 'ºC'),
	(150976, 120, '2014-01-15 00:31:00.000000', 'temperatura', 733.0000, 'ºC'),
	(150977, 120, '2014-01-15 00:31:01.000000', 'temperatura', 604.0000, 'ºC'),
	(150978, 120, '2014-01-15 00:31:02.000000', 'temperatura', 818.0000, 'ºC'),
	(150979, 120, '2014-01-15 00:31:03.000000', 'temperatura', 1082.0000, 'ºC'),
	(150980, 120, '2014-01-15 00:31:04.000000', 'temperatura', 553.0000, 'ºC'),
	(150981, 120, '2014-01-15 00:31:05.000000', 'temperatura', 721.0000, 'ºC'),
	(150982, 120, '2014-01-15 00:31:06.000000', 'temperatura', 748.0000, 'ºC'),
	(150983, 120, '2014-01-15 00:31:07.000000', 'temperatura', 377.0000, 'ºC'),
	(150984, 120, '2014-01-15 00:31:08.000000', 'temperatura', 840.0000, 'ºC'),
	(150985, 120, '2014-01-15 00:31:09.000000', 'temperatura', 671.0000, 'ºC'),
	(150986, 120, '2014-01-15 00:31:10.000000', 'temperatura', 837.0000, 'ºC'),
	(150987, 120, '2014-01-15 00:31:11.000000', 'temperatura', 971.0000, 'ºC'),
	(150988, 120, '2014-01-15 00:31:12.000000', 'temperatura', 1143.0000, 'ºC'),
	(150989, 120, '2014-01-15 00:31:13.000000', 'temperatura', 402.0000, 'ºC'),
	(150990, 120, '2014-01-15 00:31:14.000000', 'temperatura', 983.0000, 'ºC'),
	(150991, 120, '2014-01-15 00:31:15.000000', 'temperatura', 109.0000, 'ºC'),
	(150992, 120, '2014-01-15 00:31:16.000000', 'temperatura', 1197.0000, 'ºC'),
	(150993, 120, '2014-01-15 00:31:17.000000', 'temperatura', 858.0000, 'ºC'),
	(150994, 120, '2014-01-15 00:31:18.000000', 'temperatura', 702.0000, 'ºC'),
	(150995, 120, '2014-01-15 00:31:19.000000', 'temperatura', 934.0000, 'ºC'),
	(150996, 120, '2014-01-15 00:31:20.000000', 'temperatura', 165.0000, 'ºC'),
	(150997, 120, '2014-01-15 00:31:21.000000', 'temperatura', 423.0000, 'ºC'),
	(150998, 120, '2014-01-15 00:31:22.000000', 'temperatura', 421.0000, 'ºC'),
	(150999, 120, '2014-01-15 00:31:23.000000', 'temperatura', 837.0000, 'ºC'),
	(151000, 120, '2014-01-15 00:31:24.000000', 'temperatura', 521.0000, 'ºC'),
	(151001, 120, '2014-01-15 00:31:25.000000', 'temperatura', 93.0000, 'ºC'),
	(151002, 120, '2014-01-15 00:31:26.000000', 'temperatura', 105.0000, 'ºC'),
	(151003, 120, '2014-01-15 00:31:27.000000', 'temperatura', 244.0000, 'ºC'),
	(151004, 120, '2014-01-15 00:31:28.000000', 'temperatura', 908.0000, 'ºC'),
	(151005, 120, '2014-01-15 00:31:29.000000', 'temperatura', 210.0000, 'ºC'),
	(151006, 120, '2014-01-15 00:31:30.000000', 'temperatura', 724.0000, 'ºC'),
	(151007, 120, '2014-01-15 00:31:31.000000', 'temperatura', 591.0000, 'ºC'),
	(151008, 120, '2014-01-15 00:31:32.000000', 'temperatura', 782.0000, 'ºC'),
	(151009, 120, '2014-01-15 00:31:33.000000', 'temperatura', 937.0000, 'ºC'),
	(151010, 120, '2014-01-15 00:31:34.000000', 'temperatura', 1141.0000, 'ºC'),
	(151011, 120, '2014-01-15 00:31:35.000000', 'temperatura', 492.0000, 'ºC'),
	(151012, 120, '2014-01-15 00:31:36.000000', 'temperatura', 240.0000, 'ºC'),
	(151013, 120, '2014-01-15 00:31:37.000000', 'temperatura', 922.0000, 'ºC'),
	(151014, 120, '2014-01-15 00:31:38.000000', 'temperatura', 292.0000, 'ºC'),
	(151015, 120, '2014-01-15 00:31:39.000000', 'temperatura', 1095.0000, 'ºC'),
	(151016, 120, '2014-01-15 00:31:40.000000', 'temperatura', 999.0000, 'ºC'),
	(151017, 120, '2014-01-15 00:31:41.000000', 'temperatura', 512.0000, 'ºC'),
	(151018, 120, '2014-01-15 00:31:42.000000', 'temperatura', 762.0000, 'ºC'),
	(151019, 120, '2014-01-15 00:31:43.000000', 'temperatura', 1077.0000, 'ºC'),
	(151020, 120, '2014-01-15 00:31:44.000000', 'temperatura', 696.0000, 'ºC'),
	(151021, 120, '2014-01-15 00:31:45.000000', 'temperatura', 252.0000, 'ºC'),
	(151022, 120, '2014-01-15 00:31:46.000000', 'temperatura', 374.0000, 'ºC'),
	(151023, 120, '2014-01-15 00:31:47.000000', 'temperatura', 1111.0000, 'ºC'),
	(151024, 120, '2014-01-15 00:31:48.000000', 'temperatura', 835.0000, 'ºC'),
	(151025, 120, '2014-01-15 00:31:49.000000', 'temperatura', 842.0000, 'ºC'),
	(151026, 120, '2014-01-15 00:31:50.000000', 'temperatura', 505.0000, 'ºC'),
	(151027, 120, '2014-01-15 00:31:51.000000', 'temperatura', 1.0000, 'ºC'),
	(151028, 120, '2014-01-15 00:31:52.000000', 'temperatura', 890.0000, 'ºC'),
	(151029, 120, '2014-01-15 00:31:53.000000', 'temperatura', 846.0000, 'ºC'),
	(151030, 120, '2014-01-15 00:31:54.000000', 'temperatura', 363.0000, 'ºC'),
	(151031, 120, '2014-01-15 00:31:55.000000', 'temperatura', 478.0000, 'ºC'),
	(151032, 120, '2014-01-15 00:31:56.000000', 'temperatura', 99.0000, 'ºC'),
	(151033, 120, '2014-01-15 00:31:57.000000', 'temperatura', 261.0000, 'ºC'),
	(151034, 120, '2014-01-15 00:31:58.000000', 'temperatura', 1009.0000, 'ºC'),
	(151035, 120, '2014-01-15 00:31:59.000000', 'temperatura', 661.0000, 'ºC'),
	(151036, 120, '2014-01-15 00:32:00.000000', 'temperatura', 279.0000, 'ºC'),
	(151037, 120, '2014-01-15 00:32:01.000000', 'temperatura', 612.0000, 'ºC'),
	(151038, 120, '2014-01-15 00:32:02.000000', 'temperatura', 1024.0000, 'ºC'),
	(151039, 120, '2014-01-15 00:32:03.000000', 'temperatura', 886.0000, 'ºC'),
	(151040, 120, '2014-01-15 00:32:04.000000', 'temperatura', 156.0000, 'ºC'),
	(151041, 120, '2014-01-15 00:32:05.000000', 'temperatura', 525.0000, 'ºC'),
	(151042, 120, '2014-01-15 00:32:06.000000', 'temperatura', 957.0000, 'ºC'),
	(151043, 120, '2014-01-15 00:32:07.000000', 'temperatura', 812.0000, 'ºC'),
	(151044, 120, '2014-01-15 00:32:08.000000', 'temperatura', 1188.0000, 'ºC'),
	(151045, 120, '2014-01-15 00:32:09.000000', 'temperatura', 1104.0000, 'ºC'),
	(151046, 120, '2014-01-15 00:32:10.000000', 'temperatura', 756.0000, 'ºC'),
	(151047, 120, '2014-01-15 00:32:11.000000', 'temperatura', 468.0000, 'ºC'),
	(151048, 120, '2014-01-15 00:32:12.000000', 'temperatura', 74.0000, 'ºC'),
	(151049, 120, '2014-01-15 00:32:13.000000', 'temperatura', 166.0000, 'ºC'),
	(151050, 120, '2014-01-15 00:32:14.000000', 'temperatura', 608.0000, 'ºC'),
	(151051, 120, '2014-01-15 00:32:15.000000', 'temperatura', 143.0000, 'ºC'),
	(151052, 120, '2014-01-15 00:32:16.000000', 'temperatura', 93.0000, 'ºC'),
	(151053, 120, '2014-01-15 00:32:17.000000', 'temperatura', 37.0000, 'ºC'),
	(151054, 120, '2014-01-15 00:32:18.000000', 'temperatura', 1105.0000, 'ºC'),
	(151055, 120, '2014-01-15 00:32:19.000000', 'temperatura', 613.0000, 'ºC'),
	(151056, 120, '2014-01-15 00:32:20.000000', 'temperatura', 952.0000, 'ºC'),
	(151057, 120, '2014-01-15 00:32:21.000000', 'temperatura', 522.0000, 'ºC'),
	(151058, 120, '2014-01-15 00:32:22.000000', 'temperatura', 954.0000, 'ºC'),
	(151059, 120, '2014-01-15 00:32:23.000000', 'temperatura', 804.0000, 'ºC'),
	(151060, 120, '2014-01-15 00:32:24.000000', 'temperatura', 1161.0000, 'ºC'),
	(151061, 120, '2014-01-15 00:32:25.000000', 'temperatura', 992.0000, 'ºC'),
	(151062, 120, '2014-01-15 00:32:26.000000', 'temperatura', 276.0000, 'ºC'),
	(151063, 120, '2014-01-15 00:32:27.000000', 'temperatura', 805.0000, 'ºC'),
	(151064, 120, '2014-01-15 00:32:28.000000', 'temperatura', 799.0000, 'ºC'),
	(151065, 120, '2014-01-15 00:32:29.000000', 'temperatura', 381.0000, 'ºC'),
	(151066, 120, '2014-01-15 00:32:30.000000', 'temperatura', 710.0000, 'ºC'),
	(151067, 120, '2014-01-15 00:32:31.000000', 'temperatura', 4.0000, 'ºC'),
	(151068, 120, '2014-01-15 00:32:32.000000', 'temperatura', 291.0000, 'ºC'),
	(151069, 120, '2014-01-15 00:32:33.000000', 'temperatura', 244.0000, 'ºC'),
	(151070, 120, '2014-01-15 00:32:34.000000', 'temperatura', 346.0000, 'ºC'),
	(151071, 120, '2014-01-15 00:32:35.000000', 'temperatura', 1000.0000, 'ºC'),
	(151072, 120, '2014-01-15 00:32:36.000000', 'temperatura', 361.0000, 'ºC'),
	(151073, 120, '2014-01-15 00:32:37.000000', 'temperatura', 5.0000, 'ºC'),
	(151074, 120, '2014-01-15 00:32:38.000000', 'temperatura', 143.0000, 'ºC'),
	(151075, 120, '2014-01-15 00:32:39.000000', 'temperatura', 700.0000, 'ºC'),
	(151076, 120, '2014-01-15 00:32:40.000000', 'temperatura', 672.0000, 'ºC'),
	(151077, 120, '2014-01-15 00:32:41.000000', 'temperatura', 59.0000, 'ºC'),
	(151078, 120, '2014-01-15 00:32:42.000000', 'temperatura', 682.0000, 'ºC'),
	(151079, 120, '2014-01-15 00:32:43.000000', 'temperatura', 834.0000, 'ºC'),
	(151080, 120, '2014-01-15 00:32:44.000000', 'temperatura', 925.0000, 'ºC'),
	(151081, 120, '2014-01-15 00:32:45.000000', 'temperatura', 922.0000, 'ºC'),
	(151082, 120, '2014-01-15 00:32:46.000000', 'temperatura', 637.0000, 'ºC'),
	(151083, 120, '2014-01-15 00:32:47.000000', 'temperatura', 419.0000, 'ºC'),
	(151084, 120, '2014-01-15 00:32:48.000000', 'temperatura', 185.0000, 'ºC'),
	(151085, 120, '2014-01-15 00:32:49.000000', 'temperatura', 867.0000, 'ºC'),
	(151086, 120, '2014-01-15 00:32:50.000000', 'temperatura', 180.0000, 'ºC'),
	(151087, 120, '2014-01-15 00:32:51.000000', 'temperatura', 702.0000, 'ºC'),
	(151088, 120, '2014-01-15 00:32:52.000000', 'temperatura', 569.0000, 'ºC'),
	(151089, 120, '2014-01-15 00:32:53.000000', 'temperatura', 739.0000, 'ºC'),
	(151090, 120, '2014-01-15 00:32:54.000000', 'temperatura', 788.0000, 'ºC'),
	(151091, 120, '2014-01-15 00:32:55.000000', 'temperatura', 526.0000, 'ºC'),
	(151092, 120, '2014-01-15 00:32:56.000000', 'temperatura', 267.0000, 'ºC'),
	(151093, 120, '2014-01-15 00:32:57.000000', 'temperatura', 955.0000, 'ºC'),
	(151094, 120, '2014-01-15 00:32:58.000000', 'temperatura', 375.0000, 'ºC'),
	(151095, 120, '2014-01-15 00:32:59.000000', 'temperatura', 211.0000, 'ºC'),
	(151096, 120, '2014-01-15 00:33:00.000000', 'temperatura', 1128.0000, 'ºC'),
	(151097, 120, '2014-01-15 00:33:01.000000', 'temperatura', 211.0000, 'ºC'),
	(151098, 120, '2014-01-15 00:33:02.000000', 'temperatura', 69.0000, 'ºC'),
	(151099, 120, '2014-01-15 00:33:03.000000', 'temperatura', 915.0000, 'ºC'),
	(151100, 120, '2014-01-15 00:33:04.000000', 'temperatura', 769.0000, 'ºC'),
	(151101, 120, '2014-01-15 00:33:05.000000', 'temperatura', 1099.0000, 'ºC'),
	(151102, 120, '2014-01-15 00:33:06.000000', 'temperatura', 788.0000, 'ºC'),
	(151103, 120, '2014-01-15 00:33:07.000000', 'temperatura', 645.0000, 'ºC'),
	(151104, 120, '2014-01-15 00:33:08.000000', 'temperatura', 859.0000, 'ºC'),
	(151105, 120, '2014-01-15 00:33:09.000000', 'temperatura', 1162.0000, 'ºC'),
	(151106, 120, '2014-01-15 00:33:10.000000', 'temperatura', 832.0000, 'ºC'),
	(151107, 120, '2014-01-15 00:33:11.000000', 'temperatura', 676.0000, 'ºC'),
	(151108, 120, '2014-01-15 00:33:12.000000', 'temperatura', 885.0000, 'ºC'),
	(151109, 120, '2014-01-15 00:33:13.000000', 'temperatura', 1195.0000, 'ºC'),
	(151110, 120, '2014-01-15 00:33:14.000000', 'temperatura', 922.0000, 'ºC'),
	(151111, 120, '2014-01-15 00:33:15.000000', 'temperatura', 1026.0000, 'ºC'),
	(151112, 120, '2014-01-15 00:33:16.000000', 'temperatura', 1162.0000, 'ºC'),
	(151113, 120, '2014-01-15 00:33:17.000000', 'temperatura', 334.0000, 'ºC'),
	(151114, 120, '2014-01-15 00:33:18.000000', 'temperatura', 584.0000, 'ºC'),
	(151115, 120, '2014-01-15 00:33:19.000000', 'temperatura', 720.0000, 'ºC'),
	(151116, 120, '2014-01-15 00:33:20.000000', 'temperatura', 649.0000, 'ºC'),
	(151117, 120, '2014-01-15 00:33:21.000000', 'temperatura', 1083.0000, 'ºC'),
	(151118, 120, '2014-01-15 00:33:22.000000', 'temperatura', 1070.0000, 'ºC'),
	(151119, 120, '2014-01-15 00:33:23.000000', 'temperatura', 903.0000, 'ºC'),
	(151120, 120, '2014-01-15 00:33:24.000000', 'temperatura', 106.0000, 'ºC'),
	(151121, 120, '2014-01-15 00:33:25.000000', 'temperatura', 218.0000, 'ºC'),
	(151122, 120, '2014-01-15 00:33:26.000000', 'temperatura', 775.0000, 'ºC'),
	(151123, 120, '2014-01-15 00:33:27.000000', 'temperatura', 820.0000, 'ºC'),
	(151124, 120, '2014-01-15 00:33:28.000000', 'temperatura', 575.0000, 'ºC'),
	(151125, 120, '2014-01-15 00:33:29.000000', 'temperatura', 415.0000, 'ºC'),
	(151126, 120, '2014-01-15 00:33:30.000000', 'temperatura', 351.0000, 'ºC'),
	(151127, 120, '2014-01-15 00:33:31.000000', 'temperatura', 512.0000, 'ºC'),
	(151128, 120, '2014-01-15 00:33:32.000000', 'temperatura', 307.0000, 'ºC'),
	(151129, 120, '2014-01-15 00:33:33.000000', 'temperatura', 1199.0000, 'ºC'),
	(151130, 120, '2014-01-15 00:33:34.000000', 'temperatura', 273.0000, 'ºC'),
	(151131, 120, '2014-01-15 00:33:35.000000', 'temperatura', 168.0000, 'ºC'),
	(151132, 120, '2014-01-15 00:33:36.000000', 'temperatura', 24.0000, 'ºC'),
	(151133, 120, '2014-01-15 00:33:37.000000', 'temperatura', 815.0000, 'ºC'),
	(151134, 120, '2014-01-15 00:33:38.000000', 'temperatura', 405.0000, 'ºC'),
	(151135, 120, '2014-01-15 00:33:39.000000', 'temperatura', 782.0000, 'ºC'),
	(151136, 120, '2014-01-15 00:33:40.000000', 'temperatura', 292.0000, 'ºC'),
	(151137, 120, '2014-01-15 00:33:41.000000', 'temperatura', 315.0000, 'ºC'),
	(151138, 120, '2014-01-15 00:33:42.000000', 'temperatura', 701.0000, 'ºC'),
	(151139, 120, '2014-01-15 00:33:43.000000', 'temperatura', 160.0000, 'ºC'),
	(151140, 120, '2014-01-15 00:33:44.000000', 'temperatura', 1096.0000, 'ºC'),
	(151141, 120, '2014-01-15 00:33:45.000000', 'temperatura', 201.0000, 'ºC'),
	(151142, 120, '2014-01-15 00:33:46.000000', 'temperatura', 118.0000, 'ºC'),
	(151143, 120, '2014-01-15 00:33:47.000000', 'temperatura', 1190.0000, 'ºC'),
	(151144, 120, '2014-01-15 00:33:48.000000', 'temperatura', 793.0000, 'ºC'),
	(151145, 120, '2014-01-15 00:33:49.000000', 'temperatura', 395.0000, 'ºC'),
	(151146, 120, '2014-01-15 00:33:50.000000', 'temperatura', 796.0000, 'ºC'),
	(151147, 120, '2014-01-15 00:33:51.000000', 'temperatura', 398.0000, 'ºC'),
	(151148, 120, '2014-01-15 00:33:52.000000', 'temperatura', 799.0000, 'ºC'),
	(151149, 120, '2014-01-15 00:33:53.000000', 'temperatura', 405.0000, 'ºC'),
	(151150, 120, '2014-01-15 00:33:54.000000', 'temperatura', 828.0000, 'ºC'),
	(151151, 120, '2014-01-15 00:33:55.000000', 'temperatura', 526.0000, 'ºC'),
	(151152, 120, '2014-01-15 00:33:56.000000', 'temperatura', 145.0000, 'ºC'),
	(151153, 120, '2014-01-15 00:33:57.000000', 'temperatura', 346.0000, 'ºC'),
	(151154, 120, '2014-01-15 00:33:58.000000', 'temperatura', 98.0000, 'ºC'),
	(151155, 120, '2014-01-15 00:33:59.000000', 'temperatura', 651.0000, 'ºC'),
	(151156, 120, '2014-01-15 00:34:00.000000', 'temperatura', 563.0000, 'ºC'),
	(151157, 120, '2014-01-15 00:34:01.000000', 'temperatura', 861.0000, 'ºC'),
	(151158, 120, '2014-01-15 00:34:02.000000', 'temperatura', 217.0000, 'ºC'),
	(151159, 120, '2014-01-15 00:34:03.000000', 'temperatura', 903.0000, 'ºC'),
	(151160, 120, '2014-01-15 00:34:04.000000', 'temperatura', 266.0000, 'ºC'),
	(151161, 120, '2014-01-15 00:34:05.000000', 'temperatura', 1022.0000, 'ºC'),
	(151162, 120, '2014-01-15 00:34:06.000000', 'temperatura', 710.0000, 'ºC'),
	(151163, 120, '2014-01-15 00:34:07.000000', 'temperatura', 485.0000, 'ºC'),
	(151164, 120, '2014-01-15 00:34:08.000000', 'temperatura', 295.0000, 'ºC'),
	(151165, 120, '2014-01-15 00:34:09.000000', 'temperatura', 21.0000, 'ºC'),
	(151166, 120, '2014-01-15 00:34:10.000000', 'temperatura', 422.0000, 'ºC'),
	(151167, 120, '2014-01-15 00:34:11.000000', 'temperatura', 848.0000, 'ºC'),
	(151168, 120, '2014-01-15 00:34:12.000000', 'temperatura', 575.0000, 'ºC'),
	(151169, 120, '2014-01-15 00:34:13.000000', 'temperatura', 331.0000, 'ºC'),
	(151170, 120, '2014-01-15 00:34:14.000000', 'temperatura', 1129.0000, 'ºC'),
	(151171, 120, '2014-01-15 00:34:15.000000', 'temperatura', 1052.0000, 'ºC'),
	(151172, 120, '2014-01-15 00:34:16.000000', 'temperatura', 676.0000, 'ºC'),
	(151173, 120, '2014-01-15 00:34:17.000000', 'temperatura', 223.0000, 'ºC'),
	(151174, 120, '2014-01-15 00:34:18.000000', 'temperatura', 288.0000, 'ºC'),
	(151175, 120, '2014-01-15 00:34:19.000000', 'temperatura', 773.0000, 'ºC'),
	(151176, 120, '2014-01-15 00:34:20.000000', 'temperatura', 601.0000, 'ºC'),
	(151177, 120, '2014-01-15 00:34:21.000000', 'temperatura', 685.0000, 'ºC'),
	(151178, 120, '2014-01-15 00:34:22.000000', 'temperatura', 422.0000, 'ºC'),
	(151179, 120, '2014-01-15 00:34:23.000000', 'temperatura', 57.0000, 'ºC'),
	(151180, 120, '2014-01-15 00:34:24.000000', 'temperatura', 219.0000, 'ºC'),
	(151181, 120, '2014-01-15 00:34:25.000000', 'temperatura', 925.0000, 'ºC'),
	(151182, 120, '2014-01-15 00:34:26.000000', 'temperatura', 366.0000, 'ºC'),
	(151183, 120, '2014-01-15 00:34:27.000000', 'temperatura', 258.0000, 'ºC'),
	(151184, 120, '2014-01-15 00:34:28.000000', 'temperatura', 190.0000, 'ºC'),
	(151185, 120, '2014-01-15 00:34:29.000000', 'temperatura', 178.0000, 'ºC'),
	(151186, 120, '2014-01-15 00:34:30.000000', 'temperatura', 319.0000, 'ºC'),
	(151187, 120, '2014-01-15 00:34:31.000000', 'temperatura', 1062.0000, 'ºC'),
	(151188, 120, '2014-01-15 00:34:32.000000', 'temperatura', 753.0000, 'ºC'),
	(151189, 120, '2014-01-15 00:34:33.000000', 'temperatura', 578.0000, 'ºC'),
	(151190, 120, '2014-01-15 00:34:34.000000', 'temperatura', 634.0000, 'ºC'),
	(151191, 120, '2014-01-15 00:34:35.000000', 'temperatura', 235.0000, 'ºC'),
	(151192, 120, '2014-01-15 00:34:36.000000', 'temperatura', 473.0000, 'ºC'),
	(151193, 120, '2014-01-15 00:34:37.000000', 'temperatura', 461.0000, 'ºC'),
	(151194, 120, '2014-01-15 00:34:38.000000', 'temperatura', 887.0000, 'ºC'),
	(151195, 120, '2014-01-15 00:34:39.000000', 'temperatura', 654.0000, 'ºC'),
	(151196, 120, '2014-01-15 00:34:40.000000', 'temperatura', 608.0000, 'ºC'),
	(151197, 120, '2014-01-15 00:34:41.000000', 'temperatura', 1079.0000, 'ºC'),
	(151198, 120, '2014-01-15 00:34:42.000000', 'temperatura', 1170.0000, 'ºC'),
	(151199, 120, '2014-01-15 00:34:43.000000', 'temperatura', 216.0000, 'ºC'),
	(151200, 120, '2014-01-15 00:34:44.000000', 'temperatura', 1168.0000, 'ºC'),
	(151201, 120, '2014-01-15 00:34:45.000000', 'temperatura', 394.0000, 'ºC'),
	(151202, 120, '2014-01-15 00:34:46.000000', 'temperatura', 865.0000, 'ºC'),
	(151203, 120, '2014-01-15 00:34:47.000000', 'temperatura', 744.0000, 'ºC'),
	(151204, 120, '2014-01-15 00:34:48.000000', 'temperatura', 1126.0000, 'ºC'),
	(151205, 120, '2014-01-15 00:34:49.000000', 'temperatura', 997.0000, 'ºC'),
	(151206, 120, '2014-01-15 00:34:50.000000', 'temperatura', 406.0000, 'ºC'),
	(151207, 120, '2014-01-15 00:34:51.000000', 'temperatura', 242.0000, 'ºC'),
	(151208, 120, '2014-01-15 00:34:52.000000', 'temperatura', 1193.0000, 'ºC'),
	(151209, 120, '2014-01-15 00:34:53.000000', 'temperatura', 439.0000, 'ºC'),
	(151210, 120, '2014-01-15 00:34:54.000000', 'temperatura', 1017.0000, 'ºC'),
	(151211, 120, '2014-01-15 00:34:55.000000', 'temperatura', 166.0000, 'ºC'),
	(151212, 120, '2014-01-15 00:34:56.000000', 'temperatura', 182.0000, 'ºC'),
	(151213, 120, '2014-01-15 00:34:57.000000', 'temperatura', 414.0000, 'ºC'),
	(151214, 120, '2014-01-15 00:34:58.000000', 'temperatura', 322.0000, 'ºC'),
	(151215, 120, '2014-01-15 00:34:59.000000', 'temperatura', 369.0000, 'ºC'),
	(151216, 120, '2014-01-15 00:35:00.000000', 'temperatura', 882.0000, 'ºC'),
	(151217, 120, '2014-01-15 00:35:01.000000', 'temperatura', 900.0000, 'ºC'),
	(151218, 120, '2014-01-15 00:35:02.000000', 'temperatura', 656.0000, 'ºC'),
	(151219, 120, '2014-01-15 00:35:03.000000', 'temperatura', 579.0000, 'ºC'),
	(151220, 120, '2014-01-15 00:35:04.000000', 'temperatura', 928.0000, 'ºC'),
	(151221, 120, '2014-01-15 00:35:05.000000', 'temperatura', 504.0000, 'ºC'),
	(151222, 120, '2014-01-15 00:35:06.000000', 'temperatura', 936.0000, 'ºC'),
	(151223, 120, '2014-01-15 00:35:07.000000', 'temperatura', 768.0000, 'ºC'),
	(151224, 120, '2014-01-15 00:35:08.000000', 'temperatura', 1033.0000, 'ºC'),
	(151225, 120, '2014-01-15 00:35:09.000000', 'temperatura', 463.0000, 'ºC'),
	(151226, 120, '2014-01-15 00:35:10.000000', 'temperatura', 417.0000, 'ºC'),
	(151227, 120, '2014-01-15 00:35:11.000000', 'temperatura', 697.0000, 'ºC'),
	(151228, 120, '2014-01-15 00:35:12.000000', 'temperatura', 1035.0000, 'ºC'),
	(151229, 120, '2014-01-15 00:35:13.000000', 'temperatura', 683.0000, 'ºC'),
	(151230, 120, '2014-01-15 00:35:14.000000', 'temperatura', 311.0000, 'ºC'),
	(151231, 120, '2014-01-15 00:35:15.000000', 'temperatura', 708.0000, 'ºC'),
	(151232, 120, '2014-01-15 00:35:16.000000', 'temperatura', 208.0000, 'ºC'),
	(151233, 120, '2014-01-15 00:35:17.000000', 'temperatura', 114.0000, 'ºC'),
	(151234, 120, '2014-01-15 00:35:18.000000', 'temperatura', 1149.0000, 'ºC'),
	(151235, 120, '2014-01-15 00:35:19.000000', 'temperatura', 601.0000, 'ºC'),
	(151236, 120, '2014-01-15 00:35:20.000000', 'temperatura', 759.0000, 'ºC'),
	(151237, 120, '2014-01-15 00:35:21.000000', 'temperatura', 791.0000, 'ºC'),
	(151238, 120, '2014-01-15 00:35:22.000000', 'temperatura', 482.0000, 'ºC'),
	(151239, 120, '2014-01-15 00:35:23.000000', 'temperatura', 35.0000, 'ºC'),
	(151240, 120, '2014-01-15 00:35:24.000000', 'temperatura', 1131.0000, 'ºC'),
	(151241, 120, '2014-01-15 00:35:25.000000', 'temperatura', 752.0000, 'ºC'),
	(151242, 120, '2014-01-15 00:35:26.000000', 'temperatura', 365.0000, 'ºC'),
	(151243, 120, '2014-01-15 00:35:27.000000', 'temperatura', 772.0000, 'ºC'),
	(151244, 120, '2014-01-15 00:35:28.000000', 'temperatura', 363.0000, 'ºC'),
	(151245, 120, '2014-01-15 00:35:29.000000', 'temperatura', 699.0000, 'ºC'),
	(151246, 120, '2014-01-15 00:35:30.000000', 'temperatura', 7.0000, 'ºC'),
	(151247, 120, '2014-01-15 00:35:31.000000', 'temperatura', 339.0000, 'ºC'),
	(151248, 120, '2014-01-15 00:35:32.000000', 'temperatura', 476.0000, 'ºC'),
	(151249, 120, '2014-01-15 00:35:33.000000', 'temperatura', 162.0000, 'ºC'),
	(151250, 120, '2014-01-15 00:35:34.000000', 'temperatura', 581.0000, 'ºC'),
	(151251, 120, '2014-01-15 00:35:35.000000', 'temperatura', 19.0000, 'ºC'),
	(151252, 120, '2014-01-15 00:35:36.000000', 'temperatura', 754.0000, 'ºC'),
	(151253, 120, '2014-01-15 00:35:37.000000', 'temperatura', 115.0000, 'ºC'),
	(151254, 120, '2014-01-15 00:35:38.000000', 'temperatura', 711.0000, 'ºC'),
	(151255, 120, '2014-01-15 00:35:39.000000', 'temperatura', 810.0000, 'ºC'),
	(151256, 120, '2014-01-15 00:35:40.000000', 'temperatura', 718.0000, 'ºC'),
	(151257, 120, '2014-01-15 00:35:41.000000', 'temperatura', 1161.0000, 'ºC'),
	(151258, 120, '2014-01-15 00:35:42.000000', 'temperatura', 53.0000, 'ºC'),
	(151259, 120, '2014-01-15 00:35:43.000000', 'temperatura', 383.0000, 'ºC'),
	(151260, 120, '2014-01-15 00:35:44.000000', 'temperatura', 554.0000, 'ºC'),
	(151261, 120, '2014-01-15 00:35:45.000000', 'temperatura', 422.0000, 'ºC'),
	(151262, 120, '2014-01-15 00:35:46.000000', 'temperatura', 448.0000, 'ºC'),
	(151263, 120, '2014-01-15 00:35:47.000000', 'temperatura', 975.0000, 'ºC'),
	(151264, 120, '2014-01-15 00:35:48.000000', 'temperatura', 1131.0000, 'ºC'),
	(151265, 120, '2014-01-15 00:35:49.000000', 'temperatura', 329.0000, 'ºC'),
	(151266, 120, '2014-01-15 00:35:50.000000', 'temperatura', 653.0000, 'ºC'),
	(151267, 120, '2014-01-15 00:35:51.000000', 'temperatura', 1079.0000, 'ºC'),
	(151268, 120, '2014-01-15 00:35:52.000000', 'temperatura', 1036.0000, 'ºC'),
	(151269, 120, '2014-01-15 00:35:53.000000', 'temperatura', 743.0000, 'ºC'),
	(151270, 120, '2014-01-15 00:35:54.000000', 'temperatura', 608.0000, 'ºC'),
	(151271, 120, '2014-01-15 00:35:55.000000', 'temperatura', 811.0000, 'ºC'),
	(151272, 120, '2014-01-15 00:35:56.000000', 'temperatura', 1033.0000, 'ºC'),
	(151273, 120, '2014-01-15 00:35:57.000000', 'temperatura', 330.0000, 'ºC'),
	(151274, 120, '2014-01-15 00:35:58.000000', 'temperatura', 954.0000, 'ºC'),
	(151275, 120, '2014-01-15 00:35:59.000000', 'temperatura', 182.0000, 'ºC'),
	(151276, 120, '2014-01-15 00:36:00.000000', 'temperatura', 445.0000, 'ºC'),
	(151277, 120, '2014-01-15 00:36:01.000000', 'temperatura', 483.0000, 'ºC'),
	(151278, 120, '2014-01-15 00:36:02.000000', 'temperatura', 1078.0000, 'ºC'),
	(151279, 120, '2014-01-15 00:36:03.000000', 'temperatura', 341.0000, 'ºC'),
	(151280, 120, '2014-01-15 00:36:04.000000', 'temperatura', 873.0000, 'ºC'),
	(151281, 120, '2014-01-15 00:36:05.000000', 'temperatura', 944.0000, 'ºC'),
	(151282, 120, '2014-01-15 00:36:06.000000', 'temperatura', 898.0000, 'ºC'),
	(151283, 120, '2014-01-15 00:36:07.000000', 'temperatura', 460.0000, 'ºC'),
	(151284, 120, '2014-01-15 00:36:08.000000', 'temperatura', 807.0000, 'ºC'),
	(151285, 120, '2014-01-15 00:36:09.000000', 'temperatura', 256.0000, 'ºC'),
	(151286, 120, '2014-01-15 00:36:10.000000', 'temperatura', 60.0000, 'ºC'),
	(151287, 120, '2014-01-15 00:36:11.000000', 'temperatura', 730.0000, 'ºC'),
	(151288, 120, '2014-01-15 00:36:12.000000', 'temperatura', 1071.0000, 'ºC'),
	(151289, 120, '2014-01-15 00:36:13.000000', 'temperatura', 767.0000, 'ºC'),
	(151290, 120, '2014-01-15 00:36:14.000000', 'temperatura', 621.0000, 'ºC'),
	(151291, 120, '2014-01-15 00:36:15.000000', 'temperatura', 805.0000, 'ºC'),
	(151292, 120, '2014-01-15 00:36:16.000000', 'temperatura', 961.0000, 'ºC'),
	(151293, 120, '2014-01-15 00:36:17.000000', 'temperatura', 1193.0000, 'ºC'),
	(151294, 120, '2014-01-15 00:36:18.000000', 'temperatura', 683.0000, 'ºC'),
	(151295, 120, '2014-01-15 00:36:19.000000', 'temperatura', 1035.0000, 'ºC'),
	(151296, 120, '2014-01-15 00:36:20.000000', 'temperatura', 726.0000, 'ºC'),
	(151297, 120, '2014-01-15 00:36:21.000000', 'temperatura', 527.0000, 'ºC'),
	(151298, 120, '2014-01-15 00:36:22.000000', 'temperatura', 458.0000, 'ºC'),
	(151299, 120, '2014-01-15 00:36:23.000000', 'temperatura', 708.0000, 'ºC'),
	(151300, 120, '2014-01-15 00:36:24.000000', 'temperatura', 965.0000, 'ºC'),
	(151301, 120, '2014-01-15 00:36:25.000000', 'temperatura', 303.0000, 'ºC'),
	(151302, 120, '2014-01-15 00:36:26.000000', 'temperatura', 1019.0000, 'ºC'),
	(151303, 120, '2014-01-15 00:36:27.000000', 'temperatura', 590.0000, 'ºC'),
	(151304, 120, '2014-01-15 00:36:28.000000', 'temperatura', 1090.0000, 'ºC'),
	(151305, 120, '2014-01-15 00:36:29.000000', 'temperatura', 81.0000, 'ºC'),
	(151306, 120, '2014-01-15 00:36:30.000000', 'temperatura', 735.0000, 'ºC'),
	(151307, 120, '2014-01-15 00:36:31.000000', 'temperatura', 1034.0000, 'ºC'),
	(151308, 120, '2014-01-15 00:36:32.000000', 'temperatura', 566.0000, 'ºC'),
	(151309, 120, '2014-01-15 00:36:33.000000', 'temperatura', 928.0000, 'ºC'),
	(151310, 120, '2014-01-15 00:36:34.000000', 'temperatura', 544.0000, 'ºC'),
	(151311, 120, '2014-01-15 00:36:35.000000', 'temperatura', 1135.0000, 'ºC'),
	(151312, 120, '2014-01-15 00:36:36.000000', 'temperatura', 444.0000, 'ºC'),
	(151313, 120, '2014-01-15 00:36:37.000000', 'temperatura', 15.0000, 'ºC'),
	(151314, 120, '2014-01-15 00:36:38.000000', 'temperatura', 1142.0000, 'ºC'),
	(151315, 120, '2014-01-15 00:36:39.000000', 'temperatura', 867.0000, 'ºC'),
	(151316, 120, '2014-01-15 00:36:40.000000', 'temperatura', 910.0000, 'ºC'),
	(151317, 120, '2014-01-15 00:36:41.000000', 'temperatura', 751.0000, 'ºC'),
	(151318, 120, '2014-01-15 00:36:42.000000', 'temperatura', 1024.0000, 'ºC'),
	(151319, 120, '2014-01-15 00:36:43.000000', 'temperatura', 469.0000, 'ºC'),
	(151320, 120, '2014-01-15 00:36:44.000000', 'temperatura', 474.0000, 'ºC'),
	(151321, 120, '2014-01-15 00:36:45.000000', 'temperatura', 962.0000, 'ºC'),
	(151322, 120, '2014-01-15 00:36:46.000000', 'temperatura', 989.0000, 'ºC'),
	(151323, 120, '2014-01-15 00:36:47.000000', 'temperatura', 858.0000, 'ºC'),
	(151324, 120, '2014-01-15 00:36:48.000000', 'temperatura', 126.0000, 'ºC'),
	(151325, 120, '2014-01-15 00:36:49.000000', 'temperatura', 457.0000, 'ºC'),
	(151326, 120, '2014-01-15 00:36:50.000000', 'temperatura', 708.0000, 'ºC'),
	(151327, 120, '2014-01-15 00:36:51.000000', 'temperatura', 968.0000, 'ºC'),
	(151328, 120, '2014-01-15 00:36:52.000000', 'temperatura', 316.0000, 'ºC'),
	(151329, 120, '2014-01-15 00:36:53.000000', 'temperatura', 1079.0000, 'ºC'),
	(151330, 120, '2014-01-15 00:36:54.000000', 'temperatura', 846.0000, 'ºC'),
	(151331, 120, '2014-01-15 00:36:55.000000', 'temperatura', 994.0000, 'ºC'),
	(151332, 120, '2014-01-15 00:36:56.000000', 'temperatura', 34.0000, 'ºC'),
	(151333, 120, '2014-01-15 00:36:57.000000', 'temperatura', 788.0000, 'ºC'),
	(151334, 120, '2014-01-15 00:36:58.000000', 'temperatura', 239.0000, 'ºC'),
	(151335, 120, '2014-01-15 00:36:59.000000', 'temperatura', 32.0000, 'ºC'),
	(151336, 120, '2014-01-15 00:37:00.000000', 'temperatura', 643.0000, 'ºC'),
	(151337, 120, '2014-01-15 00:37:01.000000', 'temperatura', 719.0000, 'ºC'),
	(151338, 120, '2014-01-15 00:37:02.000000', 'temperatura', 467.0000, 'ºC'),
	(151339, 120, '2014-01-15 00:37:03.000000', 'temperatura', 178.0000, 'ºC'),
	(151340, 120, '2014-01-15 00:37:04.000000', 'temperatura', 691.0000, 'ºC'),
	(151341, 120, '2014-01-15 00:37:05.000000', 'temperatura', 520.0000, 'ºC'),
	(151342, 120, '2014-01-15 00:37:06.000000', 'temperatura', 527.0000, 'ºC'),
	(151343, 120, '2014-01-15 00:37:07.000000', 'temperatura', 1076.0000, 'ºC'),
	(151344, 120, '2014-01-15 00:37:08.000000', 'temperatura', 199.0000, 'ºC'),
	(151345, 120, '2014-01-15 00:37:09.000000', 'temperatura', 168.0000, 'ºC'),
	(151346, 120, '2014-01-15 00:37:10.000000', 'temperatura', 245.0000, 'ºC'),
	(151347, 120, '2014-01-15 00:37:11.000000', 'temperatura', 721.0000, 'ºC'),
	(151348, 120, '2014-01-15 00:37:12.000000', 'temperatura', 468.0000, 'ºC'),
	(151349, 120, '2014-01-15 00:37:13.000000', 'temperatura', 180.0000, 'ºC'),
	(151350, 120, '2014-01-15 00:37:14.000000', 'temperatura', 694.0000, 'ºC'),
	(151351, 120, '2014-01-15 00:37:15.000000', 'temperatura', 531.0000, 'ºC'),
	(151352, 120, '2014-01-15 00:37:16.000000', 'temperatura', 573.0000, 'ºC'),
	(151353, 120, '2014-01-15 00:37:17.000000', 'temperatura', 74.0000, 'ºC'),
	(151354, 120, '2014-01-15 00:37:18.000000', 'temperatura', 1049.0000, 'ºC'),
	(151355, 120, '2014-01-15 00:37:19.000000', 'temperatura', 224.0000, 'ºC'),
	(151356, 120, '2014-01-15 00:37:20.000000', 'temperatura', 376.0000, 'ºC'),
	(151357, 120, '2014-01-15 00:37:21.000000', 'temperatura', 7.0000, 'ºC'),
	(151358, 120, '2014-01-15 00:37:22.000000', 'temperatura', 108.0000, 'ºC'),
	(151359, 120, '2014-01-15 00:37:23.000000', 'temperatura', 517.0000, 'ºC'),
	(151360, 120, '2014-01-15 00:37:24.000000', 'temperatura', 1065.0000, 'ºC'),
	(151361, 120, '2014-01-15 00:37:25.000000', 'temperatura', 173.0000, 'ºC'),
	(151362, 120, '2014-01-15 00:37:26.000000', 'temperatura', 72.0000, 'ºC'),
	(151363, 120, '2014-01-15 00:37:27.000000', 'temperatura', 1040.0000, 'ºC'),
	(151364, 120, '2014-01-15 00:37:28.000000', 'temperatura', 185.0000, 'ºC'),
	(151365, 120, '2014-01-15 00:37:29.000000', 'temperatura', 205.0000, 'ºC'),
	(151366, 120, '2014-01-15 00:37:30.000000', 'temperatura', 471.0000, 'ºC'),
	(151367, 120, '2014-01-15 00:37:31.000000', 'temperatura', 539.0000, 'ºC'),
	(151368, 120, '2014-01-15 00:37:32.000000', 'temperatura', 85.0000, 'ºC'),
	(151369, 120, '2014-01-15 00:37:33.000000', 'temperatura', 7.0000, 'ºC'),
	(151370, 120, '2014-01-15 00:37:34.000000', 'temperatura', 983.0000, 'ºC'),
	(151371, 120, '2014-01-15 00:37:35.000000', 'temperatura', 91.0000, 'ºC'),
	(151372, 120, '2014-01-15 00:37:36.000000', 'temperatura', 1107.0000, 'ºC'),
	(151373, 120, '2014-01-15 00:37:37.000000', 'temperatura', 464.0000, 'ºC'),
	(151374, 120, '2014-01-15 00:37:38.000000', 'temperatura', 198.0000, 'ºC'),
	(151375, 120, '2014-01-15 00:37:39.000000', 'temperatura', 798.0000, 'ºC'),
	(151376, 120, '2014-01-15 00:37:40.000000', 'temperatura', 998.0000, 'ºC'),
	(151377, 120, '2014-01-15 00:37:41.000000', 'temperatura', 194.0000, 'ºC'),
	(151378, 120, '2014-01-15 00:37:42.000000', 'temperatura', 378.0000, 'ºC'),
	(151379, 120, '2014-01-15 00:37:43.000000', 'temperatura', 111.0000, 'ºC'),
	(151380, 120, '2014-01-15 00:37:44.000000', 'temperatura', 618.0000, 'ºC'),
	(151381, 120, '2014-01-15 00:37:45.000000', 'temperatura', 357.0000, 'ºC'),
	(151382, 120, '2014-01-15 00:37:46.000000', 'temperatura', 1133.0000, 'ºC'),
	(151383, 120, '2014-01-15 00:37:47.000000', 'temperatura', 994.0000, 'ºC'),
	(151384, 120, '2014-01-15 00:37:48.000000', 'temperatura', 374.0000, 'ºC'),
	(151385, 120, '2014-01-15 00:37:49.000000', 'temperatura', 85.0000, 'ºC'),
	(151386, 120, '2014-01-15 00:37:50.000000', 'temperatura', 504.0000, 'ºC'),
	(151387, 120, '2014-01-15 00:37:51.000000', 'temperatura', 1065.0000, 'ºC'),
	(151388, 120, '2014-01-15 00:37:52.000000', 'temperatura', 215.0000, 'ºC'),
	(151389, 120, '2014-01-15 00:37:53.000000', 'temperatura', 281.0000, 'ºC'),
	(151390, 120, '2014-01-15 00:37:54.000000', 'temperatura', 758.0000, 'ºC'),
	(151391, 120, '2014-01-15 00:37:55.000000', 'temperatura', 549.0000, 'ºC'),
	(151392, 120, '2014-01-15 00:37:56.000000', 'temperatura', 472.0000, 'ºC'),
	(151393, 120, '2014-01-15 00:37:57.000000', 'temperatura', 712.0000, 'ºC'),
	(151394, 120, '2014-01-15 00:37:58.000000', 'temperatura', 944.0000, 'ºC'),
	(151395, 120, '2014-01-15 00:37:59.000000', 'temperatura', 185.0000, 'ºC'),
	(151396, 120, '2014-01-15 00:38:00.000000', 'temperatura', 494.0000, 'ºC'),
	(151397, 120, '2014-01-15 00:38:01.000000', 'temperatura', 717.0000, 'ºC'),
	(151398, 120, '2014-01-15 00:38:02.000000', 'temperatura', 901.0000, 'ºC'),
	(151399, 120, '2014-01-15 00:38:03.000000', 'temperatura', 1154.0000, 'ºC'),
	(151400, 120, '2014-01-15 00:38:04.000000', 'temperatura', 667.0000, 'ºC'),
	(151401, 120, '2014-01-15 00:38:05.000000', 'temperatura', 1076.0000, 'ºC'),
	(151402, 120, '2014-01-15 00:38:06.000000', 'temperatura', 978.0000, 'ºC'),
	(151403, 120, '2014-01-15 00:38:07.000000', 'temperatura', 464.0000, 'ºC'),
	(151404, 120, '2014-01-15 00:38:08.000000', 'temperatura', 587.0000, 'ºC'),
	(151405, 120, '2014-01-15 00:38:09.000000', 'temperatura', 343.0000, 'ºC'),
	(151406, 120, '2014-01-15 00:38:10.000000', 'temperatura', 1156.0000, 'ºC'),
	(151407, 120, '2014-01-15 00:38:11.000000', 'temperatura', 1151.0000, 'ºC'),
	(151408, 120, '2014-01-15 00:38:12.000000', 'temperatura', 1085.0000, 'ºC'),
	(151409, 120, '2014-01-15 00:38:13.000000', 'temperatura', 775.0000, 'ºC'),
	(151410, 120, '2014-01-15 00:38:14.000000', 'temperatura', 620.0000, 'ºC'),
	(151411, 120, '2014-01-15 00:38:15.000000', 'temperatura', 774.0000, 'ºC'),
	(151412, 120, '2014-01-15 00:38:16.000000', 'temperatura', 812.0000, 'ºC'),
	(151413, 120, '2014-01-15 00:38:17.000000', 'temperatura', 540.0000, 'ºC'),
	(151414, 120, '2014-01-15 00:38:18.000000', 'temperatura', 263.0000, 'ºC'),
	(151415, 120, '2014-01-15 00:38:19.000000', 'temperatura', 897.0000, 'ºC'),
	(151416, 120, '2014-01-15 00:38:20.000000', 'temperatura', 96.0000, 'ºC'),
	(151417, 120, '2014-01-15 00:38:21.000000', 'temperatura', 190.0000, 'ºC'),
	(151418, 120, '2014-01-15 00:38:22.000000', 'temperatura', 661.0000, 'ºC'),
	(151419, 120, '2014-01-15 00:38:23.000000', 'temperatura', 338.0000, 'ºC'),
	(151420, 120, '2014-01-15 00:38:24.000000', 'temperatura', 905.0000, 'ºC'),
	(151421, 120, '2014-01-15 00:38:25.000000', 'temperatura', 1112.0000, 'ºC'),
	(151422, 120, '2014-01-15 00:38:26.000000', 'temperatura', 444.0000, 'ºC'),
	(151423, 120, '2014-01-15 00:38:27.000000', 'temperatura', 86.0000, 'ºC'),
	(151424, 120, '2014-01-15 00:38:28.000000', 'temperatura', 299.0000, 'ºC'),
	(151425, 120, '2014-01-15 00:38:29.000000', 'temperatura', 36.0000, 'ºC'),
	(151426, 120, '2014-01-15 00:38:30.000000', 'temperatura', 483.0000, 'ºC'),
	(151427, 120, '2014-01-15 00:38:31.000000', 'temperatura', 1109.0000, 'ºC'),
	(151428, 120, '2014-01-15 00:38:32.000000', 'temperatura', 496.0000, 'ºC'),
	(151429, 120, '2014-01-15 00:38:33.000000', 'temperatura', 354.0000, 'ºC'),
	(151430, 120, '2014-01-15 00:38:34.000000', 'temperatura', 283.0000, 'ºC'),
	(151431, 120, '2014-01-15 00:38:35.000000', 'temperatura', 351.0000, 'ºC'),
	(151432, 120, '2014-01-15 00:38:36.000000', 'temperatura', 909.0000, 'ºC'),
	(151433, 120, '2014-01-15 00:38:37.000000', 'temperatura', 1093.0000, 'ºC'),
	(151434, 120, '2014-01-15 00:38:38.000000', 'temperatura', 336.0000, 'ºC'),
	(151435, 120, '2014-01-15 00:38:39.000000', 'temperatura', 803.0000, 'ºC'),
	(151436, 120, '2014-01-15 00:38:40.000000', 'temperatura', 608.0000, 'ºC'),
	(151437, 120, '2014-01-15 00:38:41.000000', 'temperatura', 632.0000, 'ºC'),
	(151438, 120, '2014-01-15 00:38:42.000000', 'temperatura', 134.0000, 'ºC'),
	(151439, 120, '2014-01-15 00:38:43.000000', 'temperatura', 1175.0000, 'ºC'),
	(151440, 120, '2014-01-15 00:38:44.000000', 'temperatura', 673.0000, 'ºC'),
	(151441, 120, '2014-01-15 00:38:45.000000', 'temperatura', 1041.0000, 'ºC'),
	(151442, 120, '2014-01-15 00:38:46.000000', 'temperatura', 788.0000, 'ºC'),
	(151443, 120, '2014-01-15 00:38:47.000000', 'temperatura', 816.0000, 'ºC'),
	(151444, 120, '2014-01-15 00:38:48.000000', 'temperatura', 517.0000, 'ºC'),
	(151445, 120, '2014-01-15 00:38:49.000000', 'temperatura', 136.0000, 'ºC'),
	(151446, 120, '2014-01-15 00:38:50.000000', 'temperatura', 332.0000, 'ºC'),
	(151447, 120, '2014-01-15 00:38:51.000000', 'temperatura', 53.0000, 'ºC'),
	(151448, 120, '2014-01-15 00:38:52.000000', 'temperatura', 470.0000, 'ºC'),
	(151449, 120, '2014-01-15 00:38:53.000000', 'temperatura', 992.0000, 'ºC'),
	(151450, 120, '2014-01-15 00:38:54.000000', 'temperatura', 1149.0000, 'ºC'),
	(151451, 120, '2014-01-15 00:38:55.000000', 'temperatura', 371.0000, 'ºC'),
	(151452, 120, '2014-01-15 00:38:56.000000', 'temperatura', 806.0000, 'ºC'),
	(151453, 120, '2014-01-15 00:38:57.000000', 'temperatura', 518.0000, 'ºC'),
	(151454, 120, '2014-01-15 00:38:58.000000', 'temperatura', 171.0000, 'ºC'),
	(151455, 120, '2014-01-15 00:38:59.000000', 'temperatura', 505.0000, 'ºC'),
	(151456, 120, '2014-01-15 00:39:00.000000', 'temperatura', 810.0000, 'ºC'),
	(151457, 120, '2014-01-15 00:39:01.000000', 'temperatura', 138.0000, 'ºC'),
	(151458, 120, '2014-01-15 00:39:02.000000', 'temperatura', 661.0000, 'ºC'),
	(151459, 120, '2014-01-15 00:39:03.000000', 'temperatura', 489.0000, 'ºC'),
	(151460, 120, '2014-01-15 00:39:04.000000', 'temperatura', 463.0000, 'ºC'),
	(151461, 120, '2014-01-15 00:39:05.000000', 'temperatura', 849.0000, 'ºC'),
	(151462, 120, '2014-01-15 00:39:06.000000', 'temperatura', 455.0000, 'ºC'),
	(151463, 120, '2014-01-15 00:39:07.000000', 'temperatura', 928.0000, 'ºC'),
	(151464, 120, '2014-01-15 00:39:08.000000', 'temperatura', 877.0000, 'ºC'),
	(151465, 120, '2014-01-15 00:39:09.000000', 'temperatura', 403.0000, 'ºC'),
	(151466, 120, '2014-01-15 00:39:10.000000', 'temperatura', 581.0000, 'ºC'),
	(151467, 120, '2014-01-15 00:39:11.000000', 'temperatura', 499.0000, 'ºC'),
	(151468, 120, '2014-01-15 00:39:12.000000', 'temperatura', 750.0000, 'ºC'),
	(151469, 120, '2014-01-15 00:39:13.000000', 'temperatura', 1054.0000, 'ºC'),
	(151470, 120, '2014-01-15 00:39:14.000000', 'temperatura', 622.0000, 'ºC'),
	(151471, 120, '2014-01-15 00:39:15.000000', 'temperatura', 1146.0000, 'ºC'),
	(151472, 120, '2014-01-15 00:39:16.000000', 'temperatura', 268.0000, 'ºC'),
	(151473, 120, '2014-01-15 00:39:17.000000', 'temperatura', 299.0000, 'ºC'),
	(151474, 120, '2014-01-15 00:39:18.000000', 'temperatura', 694.0000, 'ºC'),
	(151475, 120, '2014-01-15 00:39:19.000000', 'temperatura', 171.0000, 'ºC'),
	(151476, 120, '2014-01-15 00:39:20.000000', 'temperatura', 1176.0000, 'ºC'),
	(151477, 120, '2014-01-15 00:39:21.000000', 'temperatura', 565.0000, 'ºC'),
	(151478, 120, '2014-01-15 00:39:22.000000', 'temperatura', 498.0000, 'ºC'),
	(151479, 120, '2014-01-15 00:39:23.000000', 'temperatura', 796.0000, 'ºC'),
	(151480, 120, '2014-01-15 00:39:24.000000', 'temperatura', 87.0000, 'ºC'),
	(151481, 120, '2014-01-15 00:39:25.000000', 'temperatura', 447.0000, 'ºC'),
	(151482, 120, '2014-01-15 00:39:26.000000', 'temperatura', 777.0000, 'ºC'),
	(151483, 120, '2014-01-15 00:39:27.000000', 'temperatura', 141.0000, 'ºC'),
	(151484, 120, '2014-01-15 00:39:28.000000', 'temperatura', 775.0000, 'ºC'),
	(151485, 120, '2014-01-15 00:39:29.000000', 'temperatura', 1055.0000, 'ºC'),
	(151486, 120, '2014-01-15 00:39:30.000000', 'temperatura', 548.0000, 'ºC'),
	(151487, 120, '2014-01-15 00:39:31.000000', 'temperatura', 778.0000, 'ºC'),
	(151488, 120, '2014-01-15 00:39:32.000000', 'temperatura', 1047.0000, 'ºC'),
	(151489, 120, '2014-01-15 00:39:33.000000', 'temperatura', 501.0000, 'ºC'),
	(151490, 120, '2014-01-15 00:39:34.000000', 'temperatura', 563.0000, 'ºC'),
	(151491, 120, '2014-01-15 00:39:35.000000', 'temperatura', 115.0000, 'ºC'),
	(151492, 120, '2014-01-15 00:39:36.000000', 'temperatura', 85.0000, 'ºC'),
	(151493, 120, '2014-01-15 00:39:37.000000', 'temperatura', 79.0000, 'ºC'),
	(151494, 120, '2014-01-15 00:39:38.000000', 'temperatura', 143.0000, 'ºC'),
	(151495, 120, '2014-01-15 00:39:39.000000', 'temperatura', 477.0000, 'ºC'),
	(151496, 120, '2014-01-15 00:39:40.000000', 'temperatura', 759.0000, 'ºC'),
	(151497, 120, '2014-01-15 00:39:41.000000', 'temperatura', 1162.0000, 'ºC'),
	(151498, 120, '2014-01-15 00:39:42.000000', 'temperatura', 1136.0000, 'ºC'),
	(151499, 120, '2014-01-15 00:39:43.000000', 'temperatura', 995.0000, 'ºC'),
	(151500, 120, '2014-01-15 00:39:44.000000', 'temperatura', 365.0000, 'ºC'),
	(151501, 120, '2014-01-15 00:39:45.000000', 'temperatura', 40.0000, 'ºC'),
	(151502, 120, '2014-01-15 00:39:46.000000', 'temperatura', 306.0000, 'ºC'),
	(151503, 120, '2014-01-15 00:39:47.000000', 'temperatura', 211.0000, 'ºC'),
	(151504, 120, '2014-01-15 00:39:48.000000', 'temperatura', 137.0000, 'ºC'),
	(151505, 120, '2014-01-15 00:39:49.000000', 'temperatura', 53.0000, 'ºC'),
	(151506, 120, '2014-01-15 00:39:50.000000', 'temperatura', 1055.0000, 'ºC'),
	(151507, 120, '2014-01-15 00:39:51.000000', 'temperatura', 316.0000, 'ºC'),
	(151508, 120, '2014-01-15 00:39:52.000000', 'temperatura', 815.0000, 'ºC'),
	(151509, 120, '2014-01-15 00:39:53.000000', 'temperatura', 726.0000, 'ºC'),
	(151510, 120, '2014-01-15 00:39:54.000000', 'temperatura', 1188.0000, 'ºC'),
	(151511, 120, '2014-01-15 00:39:55.000000', 'temperatura', 162.0000, 'ºC'),
	(151512, 120, '2014-01-15 00:39:56.000000', 'temperatura', 845.0000, 'ºC'),
	(151513, 120, '2014-01-15 00:39:57.000000', 'temperatura', 141.0000, 'ºC'),
	(151514, 120, '2014-01-15 00:39:58.000000', 'temperatura', 568.0000, 'ºC'),
	(151515, 120, '2014-01-15 00:39:59.000000', 'temperatura', 19.0000, 'ºC'),
	(151516, 120, '2014-01-15 00:40:00.000000', 'temperatura', 794.0000, 'ºC'),
	(151517, 120, '2014-01-15 00:40:01.000000', 'temperatura', 310.0000, 'ºC'),
	(151518, 120, '2014-01-15 00:40:02.000000', 'temperatura', 369.0000, 'ºC'),
	(151519, 120, '2014-01-15 00:40:03.000000', 'temperatura', 918.0000, 'ºC'),
	(151520, 120, '2014-01-15 00:40:04.000000', 'temperatura', 1081.0000, 'ºC'),
	(151521, 120, '2014-01-15 00:40:05.000000', 'temperatura', 253.0000, 'ºC'),
	(151522, 120, '2014-01-15 00:40:06.000000', 'temperatura', 420.0000, 'ºC'),
	(151523, 120, '2014-01-15 00:40:07.000000', 'temperatura', 145.0000, 'ºC'),
	(151524, 120, '2014-01-15 00:40:08.000000', 'temperatura', 662.0000, 'ºC'),
	(151525, 120, '2014-01-15 00:40:09.000000', 'temperatura', 479.0000, 'ºC'),
	(151526, 120, '2014-01-15 00:40:10.000000', 'temperatura', 407.0000, 'ºC'),
	(151527, 120, '2014-01-15 00:40:11.000000', 'temperatura', 599.0000, 'ºC'),
	(151528, 120, '2014-01-15 00:40:12.000000', 'temperatura', 574.0000, 'ºC'),
	(151529, 120, '2014-01-15 00:40:13.000000', 'temperatura', 1074.0000, 'ºC'),
	(151530, 120, '2014-01-15 00:40:14.000000', 'temperatura', 48.0000, 'ºC'),
	(151531, 120, '2014-01-15 00:40:15.000000', 'temperatura', 618.0000, 'ºC'),
	(151532, 120, '2014-01-15 00:40:16.000000', 'temperatura', 546.0000, 'ºC'),
	(151533, 120, '2014-01-15 00:40:17.000000', 'temperatura', 878.0000, 'ºC'),
	(151534, 120, '2014-01-15 00:40:18.000000', 'temperatura', 352.0000, 'ºC'),
	(151535, 120, '2014-01-15 00:40:19.000000', 'temperatura', 327.0000, 'ºC'),
	(151536, 120, '2014-01-15 00:40:20.000000', 'temperatura', 578.0000, 'ºC'),
	(151537, 120, '2014-01-15 00:40:21.000000', 'temperatura', 712.0000, 'ºC'),
	(151538, 120, '2014-01-15 00:40:22.000000', 'temperatura', 626.0000, 'ºC'),
	(151539, 120, '2014-01-15 00:40:23.000000', 'temperatura', 994.0000, 'ºC'),
	(151540, 120, '2014-01-15 00:40:24.000000', 'temperatura', 691.0000, 'ºC'),
	(151541, 120, '2014-01-15 00:40:25.000000', 'temperatura', 476.0000, 'ºC'),
	(151542, 120, '2014-01-15 00:40:26.000000', 'temperatura', 307.0000, 'ºC'),
	(151543, 120, '2014-01-15 00:40:27.000000', 'temperatura', 106.0000, 'ºC'),
	(151544, 120, '2014-01-15 00:40:28.000000', 'temperatura', 812.0000, 'ºC'),
	(151545, 120, '2014-01-15 00:40:29.000000', 'temperatura', 141.0000, 'ºC'),
	(151546, 120, '2014-01-15 00:40:30.000000', 'temperatura', 671.0000, 'ºC'),
	(151547, 120, '2014-01-15 00:40:31.000000', 'temperatura', 531.0000, 'ºC'),
	(151548, 120, '2014-01-15 00:40:32.000000', 'temperatura', 642.0000, 'ºC'),
	(151549, 120, '2014-01-15 00:40:33.000000', 'temperatura', 420.0000, 'ºC'),
	(151550, 120, '2014-01-15 00:40:34.000000', 'temperatura', 173.0000, 'ºC'),
	(151551, 120, '2014-01-15 00:40:35.000000', 'temperatura', 806.0000, 'ºC'),
	(151552, 120, '2014-01-15 00:40:36.000000', 'temperatura', 1112.0000, 'ºC'),
	(151553, 120, '2014-01-15 00:40:37.000000', 'temperatura', 744.0000, 'ºC'),
	(151554, 120, '2014-01-15 00:40:38.000000', 'temperatura', 384.0000, 'ºC'),
	(151555, 120, '2014-01-15 00:40:39.000000', 'temperatura', 886.0000, 'ºC'),
	(151556, 120, '2014-01-15 00:40:40.000000', 'temperatura', 881.0000, 'ºC'),
	(151557, 120, '2014-01-15 00:40:41.000000', 'temperatura', 546.0000, 'ºC'),
	(151558, 120, '2014-01-15 00:40:42.000000', 'temperatura', 89.0000, 'ºC'),
	(151559, 120, '2014-01-15 00:40:43.000000', 'temperatura', 7.0000, 'ºC'),
	(151560, 120, '2014-01-15 00:40:44.000000', 'temperatura', 970.0000, 'ºC'),
	(151561, 120, '2014-01-15 00:40:45.000000', 'temperatura', 28.0000, 'ºC'),
	(151562, 120, '2014-01-15 00:40:46.000000', 'temperatura', 829.0000, 'ºC'),
	(151563, 120, '2014-01-15 00:40:47.000000', 'temperatura', 464.0000, 'ºC'),
	(151564, 120, '2014-01-15 00:40:48.000000', 'temperatura', 1032.0000, 'ºC'),
	(151565, 120, '2014-01-15 00:40:49.000000', 'temperatura', 168.0000, 'ºC'),
	(151566, 120, '2014-01-15 00:40:50.000000', 'temperatura', 146.0000, 'ºC'),
	(151567, 120, '2014-01-15 00:40:51.000000', 'temperatura', 225.0000, 'ºC'),
	(151568, 120, '2014-01-15 00:40:52.000000', 'temperatura', 688.0000, 'ºC'),
	(151569, 120, '2014-01-15 00:40:53.000000', 'temperatura', 364.0000, 'ºC'),
	(151570, 120, '2014-01-15 00:40:54.000000', 'temperatura', 959.0000, 'ºC'),
	(151571, 120, '2014-01-15 00:40:55.000000', 'temperatura', 101.0000, 'ºC'),
	(151572, 120, '2014-01-15 00:40:56.000000', 'temperatura', 29.0000, 'ºC'),
	(151573, 120, '2014-01-15 00:40:57.000000', 'temperatura', 1044.0000, 'ºC'),
	(151574, 120, '2014-01-15 00:40:58.000000', 'temperatura', 333.0000, 'ºC'),
	(151575, 120, '2014-01-15 00:40:59.000000', 'temperatura', 932.0000, 'ºC'),
	(151576, 120, '2014-01-15 00:41:00.000000', 'temperatura', 63.0000, 'ºC'),
	(151577, 120, '2014-01-15 00:41:01.000000', 'temperatura', 1119.0000, 'ºC'),
	(151578, 120, '2014-01-15 00:41:02.000000', 'temperatura', 606.0000, 'ºC'),
	(151579, 120, '2014-01-15 00:41:03.000000', 'temperatura', 873.0000, 'ºC'),
	(151580, 120, '2014-01-15 00:41:04.000000', 'temperatura', 147.0000, 'ºC'),
	(151581, 120, '2014-01-15 00:41:05.000000', 'temperatura', 518.0000, 'ºC'),
	(151582, 120, '2014-01-15 00:41:06.000000', 'temperatura', 948.0000, 'ºC'),
	(151583, 120, '2014-01-15 00:41:07.000000', 'temperatura', 787.0000, 'ºC'),
	(151584, 120, '2014-01-15 00:41:08.000000', 'temperatura', 1090.0000, 'ºC'),
	(151585, 120, '2014-01-15 00:41:09.000000', 'temperatura', 692.0000, 'ºC'),
	(151586, 120, '2014-01-15 00:41:10.000000', 'temperatura', 189.0000, 'ºC'),
	(151587, 120, '2014-01-15 00:41:11.000000', 'temperatura', 72.0000, 'ºC'),
	(151588, 120, '2014-01-15 00:41:12.000000', 'temperatura', 992.0000, 'ºC'),
	(151589, 120, '2014-01-15 00:41:13.000000', 'temperatura', 1144.0000, 'ºC'),
	(151590, 120, '2014-01-15 00:41:14.000000', 'temperatura', 346.0000, 'ºC'),
	(151591, 120, '2014-01-15 00:41:15.000000', 'temperatura', 698.0000, 'ºC'),
	(151592, 120, '2014-01-15 00:41:16.000000', 'temperatura', 52.0000, 'ºC'),
	(151593, 120, '2014-01-15 00:41:17.000000', 'temperatura', 565.0000, 'ºC'),
	(151594, 120, '2014-01-15 00:41:18.000000', 'temperatura', 273.0000, 'ºC'),
	(151595, 120, '2014-01-15 00:41:19.000000', 'temperatura', 868.0000, 'ºC'),
	(151596, 120, '2014-01-15 00:41:20.000000', 'temperatura', 1121.0000, 'ºC'),
	(151597, 120, '2014-01-15 00:41:21.000000', 'temperatura', 603.0000, 'ºC'),
	(151598, 120, '2014-01-15 00:41:22.000000', 'temperatura', 851.0000, 'ºC'),
	(151599, 120, '2014-01-15 00:41:23.000000', 'temperatura', 46.0000, 'ºC'),
	(151600, 120, '2014-01-15 00:41:24.000000', 'temperatura', 78.0000, 'ºC'),
	(151601, 120, '2014-01-15 00:41:25.000000', 'temperatura', 252.0000, 'ºC'),
	(151602, 120, '2014-01-15 00:41:26.000000', 'temperatura', 1025.0000, 'ºC'),
	(151603, 120, '2014-01-15 00:41:27.000000', 'temperatura', 771.0000, 'ºC'),
	(151604, 120, '2014-01-15 00:41:28.000000', 'temperatura', 780.0000, 'ºC'),
	(151605, 120, '2014-01-15 00:41:29.000000', 'temperatura', 387.0000, 'ºC'),
	(151606, 120, '2014-01-15 00:41:30.000000', 'temperatura', 794.0000, 'ºC'),
	(151607, 120, '2014-01-15 00:41:31.000000', 'temperatura', 411.0000, 'ºC'),
	(151608, 120, '2014-01-15 00:41:32.000000', 'temperatura', 873.0000, 'ºC'),
	(151609, 120, '2014-01-15 00:41:33.000000', 'temperatura', 732.0000, 'ºC'),
	(151610, 120, '2014-01-15 00:41:34.000000', 'temperatura', 1041.0000, 'ºC'),
	(151611, 120, '2014-01-15 00:41:35.000000', 'temperatura', 608.0000, 'ºC'),
	(151612, 120, '2014-01-15 00:41:36.000000', 'temperatura', 1121.0000, 'ºC'),
	(151613, 120, '2014-01-15 00:41:37.000000', 'temperatura', 181.0000, 'ºC'),
	(151614, 120, '2014-01-15 00:41:38.000000', 'temperatura', 1140.0000, 'ºC'),
	(151615, 120, '2014-01-15 00:41:39.000000', 'temperatura', 359.0000, 'ºC'),
	(151616, 120, '2014-01-15 00:41:40.000000', 'temperatura', 774.0000, 'ºC'),
	(151617, 120, '2014-01-15 00:41:41.000000', 'temperatura', 394.0000, 'ºC'),
	(151618, 120, '2014-01-15 00:41:42.000000', 'temperatura', 850.0000, 'ºC'),
	(151619, 120, '2014-01-15 00:41:43.000000', 'temperatura', 666.0000, 'ºC'),
	(151620, 120, '2014-01-15 00:41:44.000000', 'temperatura', 782.0000, 'ºC'),
	(151621, 120, '2014-01-15 00:41:45.000000', 'temperatura', 711.0000, 'ºC'),
	(151622, 120, '2014-01-15 00:41:46.000000', 'temperatura', 10.0000, 'ºC'),
	(151623, 120, '2014-01-15 00:41:47.000000', 'temperatura', 316.0000, 'ºC'),
	(151624, 120, '2014-01-15 00:41:48.000000', 'temperatura', 352.0000, 'ºC'),
	(151625, 120, '2014-01-15 00:41:49.000000', 'temperatura', 812.0000, 'ºC'),
	(151626, 120, '2014-01-15 00:41:50.000000', 'temperatura', 604.0000, 'ºC'),
	(151627, 120, '2014-01-15 00:41:51.000000', 'temperatura', 583.0000, 'ºC'),
	(151628, 120, '2014-01-15 00:41:52.000000', 'temperatura', 1107.0000, 'ºC'),
	(151629, 120, '2014-01-15 00:41:53.000000', 'temperatura', 184.0000, 'ºC'),
	(151630, 120, '2014-01-15 00:41:54.000000', 'temperatura', 2.0000, 'ºC'),
	(151631, 120, '2014-01-15 00:41:55.000000', 'temperatura', 658.0000, 'ºC'),
	(151632, 120, '2014-01-15 00:41:56.000000', 'temperatura', 885.0000, 'ºC'),
	(151633, 120, '2014-01-15 00:41:57.000000', 'temperatura', 49.0000, 'ºC'),
	(151634, 120, '2014-01-15 00:41:58.000000', 'temperatura', 1194.0000, 'ºC'),
	(151635, 120, '2014-01-15 00:41:59.000000', 'temperatura', 1020.0000, 'ºC'),
	(151636, 120, '2014-01-15 00:42:00.000000', 'temperatura', 322.0000, 'ºC'),
	(151637, 120, '2014-01-15 00:42:01.000000', 'temperatura', 948.0000, 'ºC'),
	(151638, 120, '2014-01-15 00:42:02.000000', 'temperatura', 177.0000, 'ºC'),
	(151639, 120, '2014-01-15 00:42:03.000000', 'temperatura', 439.0000, 'ºC'),
	(151640, 120, '2014-01-15 00:42:04.000000', 'temperatura', 465.0000, 'ºC'),
	(151641, 120, '2014-01-15 00:42:05.000000', 'temperatura', 1007.0000, 'ºC'),
	(151642, 120, '2014-01-15 00:42:06.000000', 'temperatura', 41.0000, 'ºC'),
	(151643, 120, '2014-01-15 00:42:07.000000', 'temperatura', 783.0000, 'ºC'),
	(151644, 120, '2014-01-15 00:42:08.000000', 'temperatura', 195.0000, 'ºC'),
	(151645, 120, '2014-01-15 00:42:09.000000', 'temperatura', 1027.0000, 'ºC'),
	(151646, 120, '2014-01-15 00:42:10.000000', 'temperatura', 951.0000, 'ºC'),
	(151647, 120, '2014-01-15 00:42:11.000000', 'temperatura', 472.0000, 'ºC'),
	(151648, 120, '2014-01-15 00:42:12.000000', 'temperatura', 709.0000, 'ºC'),
	(151649, 120, '2014-01-15 00:42:13.000000', 'temperatura', 930.0000, 'ºC'),
	(151650, 120, '2014-01-15 00:42:14.000000', 'temperatura', 122.0000, 'ºC'),
	(151651, 120, '2014-01-15 00:42:15.000000', 'temperatura', 222.0000, 'ºC'),
	(151652, 120, '2014-01-15 00:42:16.000000', 'temperatura', 743.0000, 'ºC'),
	(151653, 120, '2014-01-15 00:42:17.000000', 'temperatura', 651.0000, 'ºC'),
	(151654, 120, '2014-01-15 00:42:18.000000', 'temperatura', 1028.0000, 'ºC'),
	(151655, 120, '2014-01-15 00:42:19.000000', 'temperatura', 785.0000, 'ºC'),
	(151656, 120, '2014-01-15 00:42:20.000000', 'temperatura', 841.0000, 'ºC'),
	(151657, 120, '2014-01-15 00:42:21.000000', 'temperatura', 652.0000, 'ºC'),
	(151658, 120, '2014-01-15 00:42:22.000000', 'temperatura', 737.0000, 'ºC'),
	(151659, 120, '2014-01-15 00:42:23.000000', 'temperatura', 528.0000, 'ºC'),
	(151660, 120, '2014-01-15 00:42:24.000000', 'temperatura', 430.0000, 'ºC'),
	(151661, 120, '2014-01-15 00:42:25.000000', 'temperatura', 565.0000, 'ºC'),
	(151662, 120, '2014-01-15 00:42:26.000000', 'temperatura', 337.0000, 'ºC'),
	(151663, 120, '2014-01-15 00:42:27.000000', 'temperatura', 1188.0000, 'ºC'),
	(151664, 120, '2014-01-15 00:42:28.000000', 'temperatura', 132.0000, 'ºC'),
	(151665, 120, '2014-01-15 00:42:29.000000', 'temperatura', 697.0000, 'ºC'),
	(151666, 120, '2014-01-15 00:42:30.000000', 'temperatura', 690.0000, 'ºC'),
	(151667, 120, '2014-01-15 00:42:31.000000', 'temperatura', 158.0000, 'ºC'),
	(151668, 120, '2014-01-15 00:42:32.000000', 'temperatura', 1122.0000, 'ºC'),
	(151669, 120, '2014-01-15 00:42:33.000000', 'temperatura', 337.0000, 'ºC'),
	(151670, 120, '2014-01-15 00:42:34.000000', 'temperatura', 717.0000, 'ºC'),
	(151671, 120, '2014-01-15 00:42:35.000000', 'temperatura', 175.0000, 'ºC'),
	(151672, 120, '2014-01-15 00:42:36.000000', 'temperatura', 1126.0000, 'ºC'),
	(151673, 120, '2014-01-15 00:42:37.000000', 'temperatura', 304.0000, 'ºC'),
	(151674, 120, '2014-01-15 00:42:38.000000', 'temperatura', 545.0000, 'ºC'),
	(151675, 120, '2014-01-15 00:42:39.000000', 'temperatura', 612.0000, 'ºC'),
	(151676, 120, '2014-01-15 00:42:40.000000', 'temperatura', 225.0000, 'ºC'),
	(151677, 120, '2014-01-15 00:42:41.000000', 'temperatura', 489.0000, 'ºC'),
	(151678, 120, '2014-01-15 00:42:42.000000', 'temperatura', 571.0000, 'ºC'),
	(151679, 120, '2014-01-15 00:42:43.000000', 'temperatura', 190.0000, 'ºC'),
	(151680, 120, '2014-01-15 00:42:44.000000', 'temperatura', 438.0000, 'ºC'),
	(151681, 120, '2014-01-15 00:42:45.000000', 'temperatura', 420.0000, 'ºC'),
	(151682, 120, '2014-01-15 00:42:46.000000', 'temperatura', 786.0000, 'ºC'),
	(151683, 120, '2014-01-15 00:42:47.000000', 'temperatura', 268.0000, 'ºC'),
	(151684, 120, '2014-01-15 00:42:48.000000', 'temperatura', 186.0000, 'ºC'),
	(151685, 120, '2014-01-15 00:42:49.000000', 'temperatura', 127.0000, 'ºC'),
	(151686, 120, '2014-01-15 00:42:50.000000', 'temperatura', 75.0000, 'ºC'),
	(151687, 120, '2014-01-15 00:42:51.000000', 'temperatura', 1197.0000, 'ºC'),
	(151688, 120, '2014-01-15 00:42:52.000000', 'temperatura', 957.0000, 'ºC'),
	(151689, 120, '2014-01-15 00:42:53.000000', 'temperatura', 1197.0000, 'ºC'),
	(151690, 120, '2014-01-15 00:42:54.000000', 'temperatura', 716.0000, 'ºC'),
	(151691, 120, '2014-01-15 00:42:55.000000', 'temperatura', 1188.0000, 'ºC'),
	(151692, 120, '2014-01-15 00:42:56.000000', 'temperatura', 190.0000, 'ºC'),
	(151693, 120, '2014-01-15 00:42:57.000000', 'temperatura', 990.0000, 'ºC'),
	(151694, 120, '2014-01-15 00:42:58.000000', 'temperatura', 781.0000, 'ºC'),
	(151695, 120, '2014-01-15 00:42:59.000000', 'temperatura', 935.0000, 'ºC'),
	(151696, 120, '2014-01-15 00:43:00.000000', 'temperatura', 1131.0000, 'ºC'),
	(151697, 120, '2014-01-15 00:43:01.000000', 'temperatura', 449.0000, 'ºC'),
	(151698, 120, '2014-01-15 00:43:02.000000', 'temperatura', 55.0000, 'ºC'),
	(151699, 120, '2014-01-15 00:43:03.000000', 'temperatura', 128.0000, 'ºC'),
	(151700, 120, '2014-01-15 00:43:04.000000', 'temperatura', 474.0000, 'ºC'),
	(151701, 120, '2014-01-15 00:43:05.000000', 'temperatura', 786.0000, 'ºC'),
	(151702, 120, '2014-01-15 00:43:06.000000', 'temperatura', 111.0000, 'ºC'),
	(151703, 120, '2014-01-15 00:43:07.000000', 'temperatura', 595.0000, 'ºC'),
	(151704, 120, '2014-01-15 00:43:08.000000', 'temperatura', 243.0000, 'ºC'),
	(151705, 120, '2014-01-15 00:43:09.000000', 'temperatura', 629.0000, 'ºC'),
	(151706, 120, '2014-01-15 00:43:10.000000', 'temperatura', 19.0000, 'ºC'),
	(151707, 120, '2014-01-15 00:43:11.000000', 'temperatura', 606.0000, 'ºC'),
	(151708, 120, '2014-01-15 00:43:12.000000', 'temperatura', 575.0000, 'ºC'),
	(151709, 120, '2014-01-15 00:43:13.000000', 'temperatura', 1058.0000, 'ºC'),
	(151710, 120, '2014-01-15 00:43:14.000000', 'temperatura', 1165.0000, 'ºC'),
	(151711, 120, '2014-01-15 00:43:15.000000', 'temperatura', 252.0000, 'ºC'),
	(151712, 120, '2014-01-15 00:43:16.000000', 'temperatura', 167.0000, 'ºC'),
	(151713, 120, '2014-01-15 00:43:17.000000', 'temperatura', 79.0000, 'ºC'),
	(151714, 120, '2014-01-15 00:43:18.000000', 'temperatura', 1096.0000, 'ºC'),
	(151715, 120, '2014-01-15 00:43:19.000000', 'temperatura', 441.0000, 'ºC'),
	(151716, 120, '2014-01-15 00:43:20.000000', 'temperatura', 119.0000, 'ºC'),
	(151717, 120, '2014-01-15 00:43:21.000000', 'temperatura', 472.0000, 'ºC'),
	(151718, 120, '2014-01-15 00:43:22.000000', 'temperatura', 803.0000, 'ºC'),
	(151719, 120, '2014-01-15 00:43:23.000000', 'temperatura', 201.0000, 'ºC'),
	(151720, 120, '2014-01-15 00:43:24.000000', 'temperatura', 994.0000, 'ºC'),
	(151721, 120, '2014-01-15 00:43:25.000000', 'temperatura', 768.0000, 'ºC'),
	(151722, 120, '2014-01-15 00:43:26.000000', 'temperatura', 860.0000, 'ºC'),
	(151723, 120, '2014-01-15 00:43:27.000000', 'temperatura', 794.0000, 'ºC'),
	(151724, 120, '2014-01-15 00:43:28.000000', 'temperatura', 192.0000, 'ºC'),
	(151725, 120, '2014-01-15 00:43:29.000000', 'temperatura', 977.0000, 'ºC'),
	(151726, 120, '2014-01-15 00:43:30.000000', 'temperatura', 711.0000, 'ºC'),
	(151727, 120, '2014-01-15 00:43:31.000000', 'temperatura', 626.0000, 'ºC'),
	(151728, 120, '2014-01-15 00:43:32.000000', 'temperatura', 995.0000, 'ºC'),
	(151729, 120, '2014-01-15 00:43:33.000000', 'temperatura', 697.0000, 'ºC'),
	(151730, 120, '2014-01-15 00:43:34.000000', 'temperatura', 500.0000, 'ºC'),
	(151731, 120, '2014-01-15 00:43:35.000000', 'temperatura', 410.0000, 'ºC'),
	(151732, 120, '2014-01-15 00:43:36.000000', 'temperatura', 551.0000, 'ºC'),
	(151733, 120, '2014-01-15 00:43:37.000000', 'temperatura', 325.0000, 'ºC'),
	(151734, 120, '2014-01-15 00:43:38.000000', 'temperatura', 1173.0000, 'ºC'),
	(151735, 120, '2014-01-15 00:43:39.000000', 'temperatura', 89.0000, 'ºC'),
	(151736, 120, '2014-01-15 00:43:40.000000', 'temperatura', 528.0000, 'ºC'),
	(151737, 120, '2014-01-15 00:43:41.000000', 'temperatura', 1173.0000, 'ºC'),
	(151738, 120, '2014-01-15 00:43:42.000000', 'temperatura', 682.0000, 'ºC'),
	(151739, 120, '2014-01-15 00:43:43.000000', 'temperatura', 1090.0000, 'ºC'),
	(151740, 120, '2014-01-15 00:43:44.000000', 'temperatura', 1004.0000, 'ºC'),
	(151741, 120, '2014-01-15 00:43:45.000000', 'temperatura', 551.0000, 'ºC'),
	(151742, 120, '2014-01-15 00:43:46.000000', 'temperatura', 944.0000, 'ºC'),
	(151743, 120, '2014-01-15 00:43:47.000000', 'temperatura', 666.0000, 'ºC'),
	(151744, 120, '2014-01-15 00:43:48.000000', 'temperatura', 497.0000, 'ºC'),
	(151745, 120, '2014-01-15 00:43:49.000000', 'temperatura', 491.0000, 'ºC'),
	(151746, 120, '2014-01-15 00:43:50.000000', 'temperatura', 963.0000, 'ºC'),
	(151747, 120, '2014-01-15 00:43:51.000000', 'temperatura', 941.0000, 'ºC'),
	(151748, 120, '2014-01-15 00:43:52.000000', 'temperatura', 618.0000, 'ºC'),
	(151749, 120, '2014-01-15 00:43:53.000000', 'temperatura', 266.0000, 'ºC'),
	(151750, 120, '2014-01-15 00:43:54.000000', 'temperatura', 676.0000, 'ºC'),
	(151751, 120, '2014-01-15 00:43:55.000000', 'temperatura', 185.0000, 'ºC'),
	(151752, 120, '2014-01-15 00:43:56.000000', 'temperatura', 97.0000, 'ºC'),
	(151753, 120, '2014-01-15 00:43:57.000000', 'temperatura', 1132.0000, 'ºC'),
	(151754, 120, '2014-01-15 00:43:58.000000', 'temperatura', 569.0000, 'ºC'),
	(151755, 120, '2014-01-15 00:43:59.000000', 'temperatura', 650.0000, 'ºC'),
	(151756, 120, '2014-01-15 00:44:00.000000', 'temperatura', 343.0000, 'ºC'),
	(151757, 120, '2014-01-15 00:44:01.000000', 'temperatura', 963.0000, 'ºC'),
	(151758, 120, '2014-01-15 00:44:02.000000', 'temperatura', 189.0000, 'ºC'),
	(151759, 120, '2014-01-15 00:44:03.000000', 'temperatura', 457.0000, 'ºC'),
	(151760, 120, '2014-01-15 00:44:04.000000', 'temperatura', 517.0000, 'ºC'),
	(151761, 120, '2014-01-15 00:44:05.000000', 'temperatura', 13.0000, 'ºC'),
	(151762, 120, '2014-01-15 00:44:06.000000', 'temperatura', 917.0000, 'ºC'),
	(151763, 120, '2014-01-15 00:44:07.000000', 'temperatura', 948.0000, 'ºC'),
	(151764, 120, '2014-01-15 00:44:08.000000', 'temperatura', 786.0000, 'ºC'),
	(151765, 120, '2014-01-15 00:44:09.000000', 'temperatura', 1088.0000, 'ºC'),
	(151766, 120, '2014-01-15 00:44:10.000000', 'temperatura', 682.0000, 'ºC'),
	(151767, 120, '2014-01-15 00:44:11.000000', 'temperatura', 146.0000, 'ºC'),
	(151768, 120, '2014-01-15 00:44:12.000000', 'temperatura', 1083.0000, 'ºC'),
	(151769, 120, '2014-01-15 00:44:13.000000', 'temperatura', 180.0000, 'ºC'),
	(151770, 120, '2014-01-15 00:44:14.000000', 'temperatura', 50.0000, 'ºC'),
	(151771, 120, '2014-01-15 00:44:15.000000', 'temperatura', 909.0000, 'ºC'),
	(151772, 120, '2014-01-15 00:44:16.000000', 'temperatura', 798.0000, 'ºC'),
	(151773, 120, '2014-01-15 00:44:17.000000', 'temperatura', 61.0000, 'ºC'),
	(151774, 120, '2014-01-15 00:44:18.000000', 'temperatura', 313.0000, 'ºC'),
	(151775, 120, '2014-01-15 00:44:19.000000', 'temperatura', 182.0000, 'ºC'),
	(151776, 120, '2014-01-15 00:44:20.000000', 'temperatura', 1171.0000, 'ºC'),
	(151777, 120, '2014-01-15 00:44:21.000000', 'temperatura', 511.0000, 'ºC'),
	(151778, 120, '2014-01-15 00:44:22.000000', 'temperatura', 242.0000, 'ºC'),
	(151779, 120, '2014-01-15 00:44:23.000000', 'temperatura', 876.0000, 'ºC'),
	(151780, 120, '2014-01-15 00:44:24.000000', 'temperatura', 57.0000, 'ºC'),
	(151781, 120, '2014-01-15 00:44:25.000000', 'temperatura', 57.0000, 'ºC'),
	(151782, 120, '2014-01-15 00:44:26.000000', 'temperatura', 116.0000, 'ºC'),
	(151783, 120, '2014-01-15 00:44:27.000000', 'temperatura', 409.0000, 'ºC'),
	(151784, 120, '2014-01-15 00:44:28.000000', 'temperatura', 497.0000, 'ºC'),
	(151785, 120, '2014-01-15 00:44:29.000000', 'temperatura', 59.0000, 'ºC'),
	(151786, 120, '2014-01-15 00:44:30.000000', 'temperatura', 5.0000, 'ºC'),
	(151787, 120, '2014-01-15 00:44:31.000000', 'temperatura', 1050.0000, 'ºC'),
	(151788, 120, '2014-01-15 00:44:32.000000', 'temperatura', 434.0000, 'ºC'),
	(151789, 120, '2014-01-15 00:44:33.000000', 'temperatura', 220.0000, 'ºC'),
	(151790, 120, '2014-01-15 00:44:34.000000', 'temperatura', 998.0000, 'ºC'),
	(151791, 120, '2014-01-15 00:44:35.000000', 'temperatura', 730.0000, 'ºC'),
	(151792, 120, '2014-01-15 00:44:36.000000', 'temperatura', 658.0000, 'ºC'),
	(151793, 120, '2014-01-15 00:44:37.000000', 'temperatura', 1098.0000, 'ºC'),
	(151794, 120, '2014-01-15 00:44:38.000000', 'temperatura', 1120.0000, 'ºC'),
	(151795, 120, '2014-01-15 00:44:39.000000', 'temperatura', 1105.0000, 'ºC'),
	(151796, 120, '2014-01-15 00:44:40.000000', 'temperatura', 966.0000, 'ºC'),
	(151797, 120, '2014-01-15 00:44:41.000000', 'temperatura', 314.0000, 'ºC'),
	(151798, 120, '2014-01-15 00:44:42.000000', 'temperatura', 1073.0000, 'ºC'),
	(151799, 120, '2014-01-15 00:44:43.000000', 'temperatura', 824.0000, 'ºC'),
	(151800, 120, '2014-01-15 00:44:44.000000', 'temperatura', 902.0000, 'ºC'),
	(151801, 120, '2014-01-15 00:44:45.000000', 'temperatura', 838.0000, 'ºC'),
	(151802, 120, '2014-01-15 00:44:46.000000', 'temperatura', 286.0000, 'ºC'),
	(151803, 120, '2014-01-15 00:44:47.000000', 'temperatura', 116.0000, 'ºC'),
	(151804, 120, '2014-01-15 00:44:48.000000', 'temperatura', 922.0000, 'ºC'),
	(151805, 120, '2014-01-15 00:44:49.000000', 'temperatura', 661.0000, 'ºC'),
	(151806, 120, '2014-01-15 00:44:50.000000', 'temperatura', 541.0000, 'ºC'),
	(151807, 120, '2014-01-15 00:44:51.000000', 'temperatura', 722.0000, 'ºC'),
	(151808, 120, '2014-01-15 00:44:52.000000', 'temperatura', 788.0000, 'ºC'),
	(151809, 120, '2014-01-15 00:44:53.000000', 'temperatura', 575.0000, 'ºC'),
	(151810, 120, '2014-01-15 00:44:54.000000', 'temperatura', 511.0000, 'ºC'),
	(151811, 120, '2014-01-15 00:44:55.000000', 'temperatura', 830.0000, 'ºC'),
	(151812, 120, '2014-01-15 00:44:56.000000', 'temperatura', 219.0000, 'ºC'),
	(151813, 120, '2014-01-15 00:44:57.000000', 'temperatura', 1004.0000, 'ºC'),
	(151814, 120, '2014-01-15 00:44:58.000000', 'temperatura', 763.0000, 'ºC'),
	(151815, 120, '2014-01-15 00:44:59.000000', 'temperatura', 804.0000, 'ºC'),
	(151816, 120, '2014-01-15 00:45:00.000000', 'temperatura', 533.0000, 'ºC'),
	(151817, 120, '2014-01-15 00:45:01.000000', 'temperatura', 251.0000, 'ºC'),
	(151818, 120, '2014-01-15 00:45:02.000000', 'temperatura', 858.0000, 'ºC'),
	(151819, 120, '2014-01-15 00:45:03.000000', 'temperatura', 1138.0000, 'ºC'),
	(151820, 120, '2014-01-15 00:45:04.000000', 'temperatura', 715.0000, 'ºC'),
	(151821, 120, '2014-01-15 00:45:05.000000', 'temperatura', 161.0000, 'ºC'),
	(151822, 120, '2014-01-15 00:45:06.000000', 'temperatura', 1060.0000, 'ºC'),
	(151823, 120, '2014-01-15 00:45:07.000000', 'temperatura', 18.0000, 'ºC'),
	(151824, 120, '2014-01-15 00:45:08.000000', 'temperatura', 512.0000, 'ºC'),
	(151825, 120, '2014-01-15 00:45:09.000000', 'temperatura', 104.0000, 'ºC'),
	(151826, 120, '2014-01-15 00:45:10.000000', 'temperatura', 186.0000, 'ºC'),
	(151827, 120, '2014-01-15 00:45:11.000000', 'temperatura', 619.0000, 'ºC'),
	(151828, 120, '2014-01-15 00:45:12.000000', 'temperatura', 135.0000, 'ºC'),
	(151829, 120, '2014-01-15 00:45:13.000000', 'temperatura', 21.0000, 'ºC'),
	(151830, 120, '2014-01-15 00:45:14.000000', 'temperatura', 902.0000, 'ºC'),
	(151831, 120, '2014-01-15 00:45:15.000000', 'temperatura', 845.0000, 'ºC'),
	(151832, 120, '2014-01-15 00:45:16.000000', 'temperatura', 321.0000, 'ºC'),
	(151833, 120, '2014-01-15 00:45:17.000000', 'temperatura', 269.0000, 'ºC'),
	(151834, 120, '2014-01-15 00:45:18.000000', 'temperatura', 385.0000, 'ºC'),
	(151835, 120, '2014-01-15 00:45:19.000000', 'temperatura', 1115.0000, 'ºC'),
	(151836, 120, '2014-01-15 00:45:20.000000', 'temperatura', 824.0000, 'ºC'),
	(151837, 120, '2014-01-15 00:45:21.000000', 'temperatura', 774.0000, 'ºC'),
	(151838, 120, '2014-01-15 00:45:22.000000', 'temperatura', 201.0000, 'ºC'),
	(151839, 120, '2014-01-15 00:45:23.000000', 'temperatura', 1080.0000, 'ºC'),
	(151840, 120, '2014-01-15 00:45:24.000000', 'temperatura', 1.0000, 'ºC'),
	(151841, 120, '2014-01-15 00:45:25.000000', 'temperatura', 362.0000, 'ºC'),
	(151842, 120, '2014-01-15 00:45:26.000000', 'temperatura', 609.0000, 'ºC'),
	(151843, 120, '2014-01-15 00:45:27.000000', 'temperatura', 759.0000, 'ºC'),
	(151844, 120, '2014-01-15 00:45:28.000000', 'temperatura', 767.0000, 'ºC'),
	(151845, 120, '2014-01-15 00:45:29.000000', 'temperatura', 361.0000, 'ºC'),
	(151846, 120, '2014-01-15 00:45:30.000000', 'temperatura', 705.0000, 'ºC'),
	(151847, 120, '2014-01-15 00:45:31.000000', 'temperatura', 43.0000, 'ºC'),
	(151848, 120, '2014-01-15 00:45:32.000000', 'temperatura', 502.0000, 'ºC'),
	(151849, 120, '2014-01-15 00:45:33.000000', 'temperatura', 1178.0000, 'ºC'),
	(151850, 120, '2014-01-15 00:45:34.000000', 'temperatura', 784.0000, 'ºC'),
	(151851, 120, '2014-01-15 00:45:35.000000', 'temperatura', 389.0000, 'ºC'),
	(151852, 120, '2014-01-15 00:45:36.000000', 'temperatura', 792.0000, 'ºC'),
	(151853, 120, '2014-01-15 00:45:37.000000', 'temperatura', 396.0000, 'ºC'),
	(151854, 120, '2014-01-15 00:45:38.000000', 'temperatura', 802.0000, 'ºC'),
	(151855, 120, '2014-01-15 00:45:39.000000', 'temperatura', 425.0000, 'ºC'),
	(151856, 120, '2014-01-15 00:45:40.000000', 'temperatura', 919.0000, 'ºC'),
	(151857, 120, '2014-01-15 00:45:41.000000', 'temperatura', 919.0000, 'ºC'),
	(151858, 120, '2014-01-15 00:45:42.000000', 'temperatura', 641.0000, 'ºC'),
	(151859, 120, '2014-01-15 00:45:43.000000', 'temperatura', 447.0000, 'ºC'),
	(151860, 120, '2014-01-15 00:45:44.000000', 'temperatura', 311.0000, 'ºC'),
	(151861, 120, '2014-01-15 00:45:45.000000', 'temperatura', 217.0000, 'ºC'),
	(151862, 120, '2014-01-15 00:45:46.000000', 'temperatura', 152.0000, 'ºC'),
	(151863, 120, '2014-01-15 00:45:47.000000', 'temperatura', 109.0000, 'ºC'),
	(151864, 120, '2014-01-15 00:45:48.000000', 'temperatura', 91.0000, 'ºC'),
	(151865, 120, '2014-01-15 00:45:49.000000', 'temperatura', 126.0000, 'ºC'),
	(151866, 120, '2014-01-15 00:45:50.000000', 'temperatura', 358.0000, 'ºC'),
	(151867, 120, '2014-01-15 00:45:51.000000', 'temperatura', 212.0000, 'ºC'),
	(151868, 120, '2014-01-15 00:45:52.000000', 'temperatura', 1187.0000, 'ºC'),
	(151869, 120, '2014-01-15 00:45:53.000000', 'temperatura', 501.0000, 'ºC'),
	(151870, 120, '2014-01-15 00:45:54.000000', 'temperatura', 144.0000, 'ºC'),
	(151871, 120, '2014-01-15 00:45:55.000000', 'temperatura', 418.0000, 'ºC'),
	(151872, 120, '2014-01-15 00:45:56.000000', 'temperatura', 456.0000, 'ºC'),
	(151873, 120, '2014-01-15 00:45:57.000000', 'temperatura', 1027.0000, 'ºC'),
	(151874, 120, '2014-01-15 00:45:58.000000', 'temperatura', 168.0000, 'ºC'),
	(151875, 120, '2014-01-15 00:45:59.000000', 'temperatura', 159.0000, 'ºC'),
	(151876, 120, '2014-01-15 00:46:00.000000', 'temperatura', 290.0000, 'ºC'),
	(151877, 120, '2014-01-15 00:46:01.000000', 'temperatura', 975.0000, 'ºC'),
	(151878, 120, '2014-01-15 00:46:02.000000', 'temperatura', 406.0000, 'ºC'),
	(151879, 120, '2014-01-15 00:46:03.000000', 'temperatura', 303.0000, 'ºC'),
	(151880, 120, '2014-01-15 00:46:04.000000', 'temperatura', 301.0000, 'ºC'),
	(151881, 120, '2014-01-15 00:46:05.000000', 'temperatura', 595.0000, 'ºC'),
	(151882, 120, '2014-01-15 00:46:06.000000', 'temperatura', 871.0000, 'ºC'),
	(151883, 120, '2014-01-15 00:46:07.000000', 'temperatura', 172.0000, 'ºC'),
	(151884, 120, '2014-01-15 00:46:08.000000', 'temperatura', 649.0000, 'ºC'),
	(151885, 120, '2014-01-15 00:46:09.000000', 'temperatura', 329.0000, 'ºC'),
	(151886, 120, '2014-01-15 00:46:10.000000', 'temperatura', 896.0000, 'ºC'),
	(151887, 120, '2014-01-15 00:46:11.000000', 'temperatura', 1097.0000, 'ºC'),
	(151888, 120, '2014-01-15 00:46:12.000000', 'temperatura', 396.0000, 'ºC'),
	(151889, 120, '2014-01-15 00:46:13.000000', 'temperatura', 1088.0000, 'ºC'),
	(151890, 120, '2014-01-15 00:46:14.000000', 'temperatura', 653.0000, 'ºC'),
	(151891, 120, '2014-01-15 00:46:15.000000', 'temperatura', 1.0000, 'ºC'),
	(151892, 120, '2014-01-15 00:46:16.000000', 'temperatura', 447.0000, 'ºC'),
	(151893, 120, '2014-01-15 00:46:17.000000', 'temperatura', 1034.0000, 'ºC'),
	(151894, 120, '2014-01-15 00:46:18.000000', 'temperatura', 230.0000, 'ºC'),
	(151895, 120, '2014-01-15 00:46:19.000000', 'temperatura', 448.0000, 'ºC'),
	(151896, 120, '2014-01-15 00:46:20.000000', 'temperatura', 352.0000, 'ºC'),
	(151897, 120, '2014-01-15 00:46:21.000000', 'temperatura', 413.0000, 'ºC'),
	(151898, 120, '2014-01-15 00:46:22.000000', 'temperatura', 1012.0000, 'ºC'),
	(151899, 120, '2014-01-15 00:46:23.000000', 'temperatura', 219.0000, 'ºC'),
	(151900, 120, '2014-01-15 00:46:24.000000', 'temperatura', 461.0000, 'ºC'),
	(151901, 120, '2014-01-15 00:46:25.000000', 'temperatura', 448.0000, 'ºC'),
	(151902, 120, '2014-01-15 00:46:26.000000', 'temperatura', 857.0000, 'ºC'),
	(151903, 120, '2014-01-15 00:46:27.000000', 'temperatura', 542.0000, 'ºC'),
	(151904, 120, '2014-01-15 00:46:28.000000', 'temperatura', 141.0000, 'ºC'),
	(151905, 120, '2014-01-15 00:46:29.000000', 'temperatura', 278.0000, 'ºC'),
	(151906, 120, '2014-01-15 00:46:30.000000', 'temperatura', 969.0000, 'ºC'),
	(151907, 120, '2014-01-15 00:46:31.000000', 'temperatura', 409.0000, 'ºC'),
	(151908, 120, '2014-01-15 00:46:32.000000', 'temperatura', 341.0000, 'ºC'),
	(151909, 120, '2014-01-15 00:46:33.000000', 'temperatura', 476.0000, 'ºC'),
	(151910, 120, '2014-01-15 00:46:34.000000', 'temperatura', 159.0000, 'ºC'),
	(151911, 120, '2014-01-15 00:46:35.000000', 'temperatura', 566.0000, 'ºC'),
	(151912, 120, '2014-01-15 00:46:36.000000', 'temperatura', 1154.0000, 'ºC'),
	(151913, 120, '2014-01-15 00:46:37.000000', 'temperatura', 475.0000, 'ºC'),
	(151914, 120, '2014-01-15 00:46:38.000000', 'temperatura', 111.0000, 'ºC'),
	(151915, 120, '2014-01-15 00:46:39.000000', 'temperatura', 330.0000, 'ºC'),
	(151916, 120, '2014-01-15 00:46:40.000000', 'temperatura', 117.0000, 'ºC'),
	(151917, 120, '2014-01-15 00:46:41.000000', 'temperatura', 797.0000, 'ºC'),
	(151918, 120, '2014-01-15 00:46:42.000000', 'temperatura', 36.0000, 'ºC'),
	(151919, 120, '2014-01-15 00:46:43.000000', 'temperatura', 187.0000, 'ºC'),
	(151920, 120, '2014-01-15 00:46:44.000000', 'temperatura', 826.0000, 'ºC'),
	(151921, 120, '2014-01-15 00:46:45.000000', 'temperatura', 1173.0000, 'ºC'),
	(151922, 120, '2014-01-15 00:46:46.000000', 'temperatura', 986.0000, 'ºC'),
	(151923, 120, '2014-01-15 00:46:47.000000', 'temperatura', 212.0000, 'ºC'),
	(151924, 120, '2014-01-15 00:46:48.000000', 'temperatura', 503.0000, 'ºC'),
	(151925, 120, '2014-01-15 00:46:49.000000', 'temperatura', 678.0000, 'ºC'),
	(151926, 120, '2014-01-15 00:46:50.000000', 'temperatura', 684.0000, 'ºC'),
	(151927, 120, '2014-01-15 00:46:51.000000', 'temperatura', 186.0000, 'ºC'),
	(151928, 120, '2014-01-15 00:46:52.000000', 'temperatura', 76.0000, 'ºC'),
	(151929, 120, '2014-01-15 00:46:53.000000', 'temperatura', 1025.0000, 'ºC'),
	(151930, 120, '2014-01-15 00:46:54.000000', 'temperatura', 96.0000, 'ºC'),
	(151931, 120, '2014-01-15 00:46:55.000000', 'temperatura', 1004.0000, 'ºC'),
	(151932, 120, '2014-01-15 00:46:56.000000', 'temperatura', 1134.0000, 'ºC'),
	(151933, 120, '2014-01-15 00:46:57.000000', 'temperatura', 258.0000, 'ºC'),
	(151934, 120, '2014-01-15 00:46:58.000000', 'temperatura', 288.0000, 'ºC'),
	(151935, 120, '2014-01-15 00:46:59.000000', 'temperatura', 668.0000, 'ºC'),
	(151936, 120, '2014-01-15 00:47:00.000000', 'temperatura', 77.0000, 'ºC'),
	(151937, 120, '2014-01-15 00:47:01.000000', 'temperatura', 781.0000, 'ºC'),
	(151938, 120, '2014-01-15 00:47:02.000000', 'temperatura', 74.0000, 'ºC'),
	(151939, 120, '2014-01-15 00:47:03.000000', 'temperatura', 429.0000, 'ºC'),
	(151940, 120, '2014-01-15 00:47:04.000000', 'temperatura', 722.0000, 'ºC'),
	(151941, 120, '2014-01-15 00:47:05.000000', 'temperatura', 1123.0000, 'ºC'),
	(151942, 120, '2014-01-15 00:47:06.000000', 'temperatura', 1049.0000, 'ºC'),
	(151943, 120, '2014-01-15 00:47:07.000000', 'temperatura', 678.0000, 'ºC'),
	(151944, 120, '2014-01-15 00:47:08.000000', 'temperatura', 241.0000, 'ºC'),
	(151945, 120, '2014-01-15 00:47:09.000000', 'temperatura', 372.0000, 'ºC'),
	(151946, 120, '2014-01-15 00:47:10.000000', 'temperatura', 1139.0000, 'ºC'),
	(151947, 120, '2014-01-15 00:47:11.000000', 'temperatura', 981.0000, 'ºC'),
	(151948, 120, '2014-01-15 00:47:12.000000', 'temperatura', 287.0000, 'ºC'),
	(151949, 120, '2014-01-15 00:47:13.000000', 'temperatura', 890.0000, 'ºC'),
	(151950, 120, '2014-01-15 00:47:14.000000', 'temperatura', 1193.0000, 'ºC'),
	(151951, 120, '2014-01-15 00:47:15.000000', 'temperatura', 894.0000, 'ºC'),
	(151952, 120, '2014-01-15 00:47:16.000000', 'temperatura', 893.0000, 'ºC'),
	(151953, 120, '2014-01-15 00:47:17.000000', 'temperatura', 582.0000, 'ºC'),
	(151954, 120, '2014-01-15 00:47:18.000000', 'temperatura', 233.0000, 'ºC'),
	(151955, 120, '2014-01-15 00:47:19.000000', 'temperatura', 619.0000, 'ºC'),
	(151956, 120, '2014-01-15 00:47:20.000000', 'temperatura', 1198.0000, 'ºC'),
	(151957, 120, '2014-01-15 00:47:21.000000', 'temperatura', 532.0000, 'ºC'),
	(151958, 120, '2014-01-15 00:47:22.000000', 'temperatura', 267.0000, 'ºC'),
	(151959, 120, '2014-01-15 00:47:23.000000', 'temperatura', 939.0000, 'ºC'),
	(151960, 120, '2014-01-15 00:47:24.000000', 'temperatura', 296.0000, 'ºC'),
	(151961, 120, '2014-01-15 00:47:25.000000', 'temperatura', 1061.0000, 'ºC'),
	(151962, 120, '2014-01-15 00:47:26.000000', 'temperatura', 819.0000, 'ºC'),
	(151963, 120, '2014-01-15 00:47:27.000000', 'temperatura', 913.0000, 'ºC'),
	(151964, 120, '2014-01-15 00:47:28.000000', 'temperatura', 908.0000, 'ºC'),
	(151965, 120, '2014-01-15 00:47:29.000000', 'temperatura', 603.0000, 'ºC'),
	(151966, 120, '2014-01-15 00:47:30.000000', 'temperatura', 289.0000, 'ºC'),
	(151967, 120, '2014-01-15 00:47:31.000000', 'temperatura', 837.0000, 'ºC'),
	(151968, 120, '2014-01-15 00:47:32.000000', 'temperatura', 920.0000, 'ºC'),
	(151969, 120, '2014-01-15 00:47:33.000000', 'temperatura', 889.0000, 'ºC'),
	(151970, 120, '2014-01-15 00:47:34.000000', 'temperatura', 484.0000, 'ºC'),
	(151971, 120, '2014-01-15 00:47:35.000000', 'temperatura', 953.0000, 'ºC'),
	(151972, 120, '2014-01-15 00:47:36.000000', 'temperatura', 916.0000, 'ºC'),
	(151973, 120, '2014-01-15 00:47:37.000000', 'temperatura', 521.0000, 'ºC'),
	(151974, 120, '2014-01-15 00:47:38.000000', 'temperatura', 1057.0000, 'ºC'),
	(151975, 120, '2014-01-15 00:47:39.000000', 'temperatura', 124.0000, 'ºC'),
	(151976, 120, '2014-01-15 00:47:40.000000', 'temperatura', 1050.0000, 'ºC'),
	(151977, 120, '2014-01-15 00:47:41.000000', 'temperatura', 75.0000, 'ºC'),
	(151978, 120, '2014-01-15 00:47:42.000000', 'temperatura', 829.0000, 'ºC'),
	(151979, 120, '2014-01-15 00:47:43.000000', 'temperatura', 319.0000, 'ºC'),
	(151980, 120, '2014-01-15 00:47:44.000000', 'temperatura', 307.0000, 'ºC'),
	(151981, 120, '2014-01-15 00:47:45.000000', 'temperatura', 580.0000, 'ºC'),
	(151982, 120, '2014-01-15 00:47:46.000000', 'temperatura', 777.0000, 'ºC'),
	(151983, 120, '2014-01-15 00:47:47.000000', 'temperatura', 949.0000, 'ºC'),
	(151984, 120, '2014-01-15 00:47:48.000000', 'temperatura', 13.0000, 'ºC'),
	(151985, 120, '2014-01-15 00:47:49.000000', 'temperatura', 819.0000, 'ºC'),
	(151986, 120, '2014-01-15 00:47:50.000000', 'temperatura', 455.0000, 'ºC'),
	(151987, 120, '2014-01-15 00:47:51.000000', 'temperatura', 1021.0000, 'ºC'),
	(151988, 120, '2014-01-15 00:47:52.000000', 'temperatura', 141.0000, 'ºC'),
	(151989, 120, '2014-01-15 00:47:53.000000', 'temperatura', 42.0000, 'ºC'),
	(151990, 120, '2014-01-15 00:47:54.000000', 'temperatura', 986.0000, 'ºC'),
	(151991, 120, '2014-01-15 00:47:55.000000', 'temperatura', 4.0000, 'ºC'),
	(151992, 120, '2014-01-15 00:47:56.000000', 'temperatura', 663.0000, 'ºC'),
	(151993, 120, '2014-01-15 00:47:57.000000', 'temperatura', 903.0000, 'ºC'),
	(151994, 120, '2014-01-15 00:47:58.000000', 'temperatura', 126.0000, 'ºC'),
	(151995, 120, '2014-01-15 00:47:59.000000', 'temperatura', 320.0000, 'ºC'),
	(151996, 120, '2014-01-15 00:48:00.000000', 'temperatura', 24.0000, 'ºC'),
	(151997, 120, '2014-01-15 00:48:01.000000', 'temperatura', 362.0000, 'ºC'),
	(151998, 120, '2014-01-15 00:48:02.000000', 'temperatura', 537.0000, 'ºC'),
	(151999, 120, '2014-01-15 00:48:03.000000', 'temperatura', 401.0000, 'ºC'),
	(152000, 120, '2014-01-15 00:48:04.000000', 'temperatura', 393.0000, 'ºC'),
	(152001, 120, '2014-01-15 00:48:05.000000', 'temperatura', 764.0000, 'ºC'),
	(152002, 120, '2014-01-15 00:48:06.000000', 'temperatura', 240.0000, 'ºC'),
	(152003, 120, '2014-01-15 00:48:07.000000', 'temperatura', 108.0000, 'ºC'),
	(152004, 120, '2014-01-15 00:48:08.000000', 'temperatura', 1019.0000, 'ºC'),
	(152005, 120, '2014-01-15 00:48:09.000000', 'temperatura', 1174.0000, 'ºC'),
	(152006, 120, '2014-01-15 00:48:10.000000', 'temperatura', 414.0000, 'ºC'),
	(152007, 120, '2014-01-15 00:48:11.000000', 'temperatura', 946.0000, 'ºC'),
	(152008, 120, '2014-01-15 00:48:12.000000', 'temperatura', 1091.0000, 'ºC'),
	(152009, 120, '2014-01-15 00:48:13.000000', 'temperatura', 215.0000, 'ºC'),
	(152010, 120, '2014-01-15 00:48:14.000000', 'temperatura', 204.0000, 'ºC'),
	(152011, 120, '2014-01-15 00:48:15.000000', 'temperatura', 374.0000, 'ºC'),
	(152012, 120, '2014-01-15 00:48:16.000000', 'temperatura', 60.0000, 'ºC'),
	(152013, 120, '2014-01-15 00:48:17.000000', 'temperatura', 378.0000, 'ºC'),
	(152014, 120, '2014-01-15 00:48:18.000000', 'temperatura', 511.0000, 'ºC'),
	(152015, 120, '2014-01-15 00:48:19.000000', 'temperatura', 221.0000, 'ºC'),
	(152016, 120, '2014-01-15 00:48:20.000000', 'temperatura', 772.0000, 'ºC'),
	(152017, 120, '2014-01-15 00:48:21.000000', 'temperatura', 797.0000, 'ºC'),
	(152018, 120, '2014-01-15 00:48:22.000000', 'temperatura', 471.0000, 'ºC'),
	(152019, 120, '2014-01-15 00:48:23.000000', 'temperatura', 1164.0000, 'ºC'),
	(152020, 120, '2014-01-15 00:48:24.000000', 'temperatura', 806.0000, 'ºC'),
	(152021, 120, '2014-01-15 00:48:25.000000', 'temperatura', 540.0000, 'ºC'),
	(152022, 120, '2014-01-15 00:48:26.000000', 'temperatura', 283.0000, 'ºC'),
	(152023, 120, '2014-01-15 00:48:27.000000', 'temperatura', 994.0000, 'ºC'),
	(152024, 120, '2014-01-15 00:48:28.000000', 'temperatura', 524.0000, 'ºC'),
	(152025, 120, '2014-01-15 00:48:29.000000', 'temperatura', 837.0000, 'ºC'),
	(152026, 120, '2014-01-15 00:48:30.000000', 'temperatura', 216.0000, 'ºC'),
	(152027, 120, '2014-01-15 00:48:31.000000', 'temperatura', 966.0000, 'ºC'),
	(152028, 120, '2014-01-15 00:48:32.000000', 'temperatura', 586.0000, 'ºC'),
	(152029, 120, '2014-01-15 00:48:33.000000', 'temperatura', 31.0000, 'ºC'),
	(152030, 120, '2014-01-15 00:48:34.000000', 'temperatura', 796.0000, 'ºC'),
	(152031, 120, '2014-01-15 00:48:35.000000', 'temperatura', 287.0000, 'ºC'),
	(152032, 120, '2014-01-15 00:48:36.000000', 'temperatura', 248.0000, 'ºC'),
	(152033, 120, '2014-01-15 00:48:37.000000', 'temperatura', 380.0000, 'ºC'),
	(152034, 120, '2014-01-15 00:48:38.000000', 'temperatura', 1155.0000, 'ºC'),
	(152035, 120, '2014-01-15 00:48:39.000000', 'temperatura', 1037.0000, 'ºC'),
	(152036, 120, '2014-01-15 00:48:40.000000', 'temperatura', 521.0000, 'ºC'),
	(152037, 120, '2014-01-15 00:48:41.000000', 'temperatura', 694.0000, 'ºC'),
	(152038, 120, '2014-01-15 00:48:42.000000', 'temperatura', 708.0000, 'ºC'),
	(152039, 120, '2014-01-15 00:48:43.000000', 'temperatura', 257.0000, 'ºC'),
	(152040, 120, '2014-01-15 00:48:44.000000', 'temperatura', 362.0000, 'ºC'),
	(152041, 120, '2014-01-15 00:48:45.000000', 'temperatura', 1038.0000, 'ºC'),
	(152042, 120, '2014-01-15 00:48:46.000000', 'temperatura', 507.0000, 'ºC'),
	(152043, 120, '2014-01-15 00:48:47.000000', 'temperatura', 620.0000, 'ºC'),
	(152044, 120, '2014-01-15 00:48:48.000000', 'temperatura', 379.0000, 'ºC'),
	(152045, 120, '2014-01-15 00:48:49.000000', 'temperatura', 37.0000, 'ºC'),
	(152046, 120, '2014-01-15 00:48:50.000000', 'temperatura', 249.0000, 'ºC'),
	(152047, 120, '2014-01-15 00:48:51.000000', 'temperatura', 1133.0000, 'ºC'),
	(152048, 120, '2014-01-15 00:48:52.000000', 'temperatura', 117.0000, 'ºC'),
	(152049, 120, '2014-01-15 00:48:53.000000', 'temperatura', 789.0000, 'ºC'),
	(152050, 120, '2014-01-15 00:48:54.000000', 'temperatura', 1194.0000, 'ºC'),
	(152051, 120, '2014-01-15 00:48:55.000000', 'temperatura', 5.0000, 'ºC'),
	(152052, 120, '2014-01-15 00:48:56.000000', 'temperatura', 41.0000, 'ºC'),
	(152053, 120, '2014-01-15 00:48:57.000000', 'temperatura', 190.0000, 'ºC'),
	(152054, 120, '2014-01-15 00:48:58.000000', 'temperatura', 826.0000, 'ºC'),
	(152055, 120, '2014-01-15 00:48:59.000000', 'temperatura', 1164.0000, 'ºC'),
	(152056, 120, '2014-01-15 00:49:00.000000', 'temperatura', 943.0000, 'ºC'),
	(152057, 120, '2014-01-15 00:49:01.000000', 'temperatura', 21.0000, 'ºC'),
	(152058, 120, '2014-01-15 00:49:02.000000', 'temperatura', 878.0000, 'ºC'),
	(152059, 120, '2014-01-15 00:49:03.000000', 'temperatura', 725.0000, 'ºC'),
	(152060, 120, '2014-01-15 00:49:04.000000', 'temperatura', 994.0000, 'ºC'),
	(152061, 120, '2014-01-15 00:49:05.000000', 'temperatura', 395.0000, 'ºC'),
	(152062, 120, '2014-01-15 00:49:06.000000', 'temperatura', 191.0000, 'ºC'),
	(152063, 120, '2014-01-15 00:49:07.000000', 'temperatura', 974.0000, 'ºC'),
	(152064, 120, '2014-01-15 00:49:08.000000', 'temperatura', 696.0000, 'ºC'),
	(152065, 120, '2014-01-15 00:49:09.000000', 'temperatura', 557.0000, 'ºC'),
	(152066, 120, '2014-01-15 00:49:10.000000', 'temperatura', 700.0000, 'ºC'),
	(152067, 120, '2014-01-15 00:49:11.000000', 'temperatura', 630.0000, 'ºC'),
	(152068, 120, '2014-01-15 00:49:12.000000', 'temperatura', 1047.0000, 'ºC'),
	(152069, 120, '2014-01-15 00:49:13.000000', 'temperatura', 949.0000, 'ºC'),
	(152070, 120, '2014-01-15 00:49:14.000000', 'temperatura', 405.0000, 'ºC'),
	(152071, 120, '2014-01-15 00:49:15.000000', 'temperatura', 375.0000, 'ºC'),
	(152072, 120, '2014-01-15 00:49:16.000000', 'temperatura', 664.0000, 'ºC'),
	(152073, 120, '2014-01-15 00:49:17.000000', 'temperatura', 992.0000, 'ºC'),
	(152074, 120, '2014-01-15 00:49:18.000000', 'temperatura', 571.0000, 'ºC'),
	(152075, 120, '2014-01-15 00:49:19.000000', 'temperatura', 1077.0000, 'ºC'),
	(152076, 120, '2014-01-15 00:49:20.000000', 'temperatura', 76.0000, 'ºC'),
	(152077, 120, '2014-01-15 00:49:21.000000', 'temperatura', 747.0000, 'ºC'),
	(152078, 120, '2014-01-15 00:49:22.000000', 'temperatura', 1110.0000, 'ºC'),
	(152079, 120, '2014-01-15 00:49:23.000000', 'temperatura', 907.0000, 'ºC'),
	(152080, 120, '2014-01-15 00:49:24.000000', 'temperatura', 8.0000, 'ºC'),
	(152081, 120, '2014-01-15 00:49:25.000000', 'temperatura', 920.0000, 'ºC'),
	(152082, 120, '2014-01-15 00:49:26.000000', 'temperatura', 977.0000, 'ºC'),
	(152083, 120, '2014-01-15 00:49:27.000000', 'temperatura', 923.0000, 'ºC'),
	(152084, 120, '2014-01-15 00:49:28.000000', 'temperatura', 486.0000, 'ºC'),
	(152085, 120, '2014-01-15 00:49:29.000000', 'temperatura', 861.0000, 'ºC'),
	(152086, 120, '2014-01-15 00:49:30.000000', 'temperatura', 446.0000, 'ºC'),
	(152087, 120, '2014-01-15 00:49:31.000000', 'temperatura', 849.0000, 'ºC'),
	(152088, 120, '2014-01-15 00:49:32.000000', 'temperatura', 506.0000, 'ºC'),
	(152089, 120, '2014-01-15 00:49:33.000000', 'temperatura', 1183.0000, 'ºC'),
	(152090, 120, '2014-01-15 00:49:34.000000', 'temperatura', 799.0000, 'ºC'),
	(152091, 120, '2014-01-15 00:49:35.000000', 'temperatura', 447.0000, 'ºC'),
	(152092, 120, '2014-01-15 00:49:36.000000', 'temperatura', 1037.0000, 'ºC'),
	(152093, 120, '2014-01-15 00:49:37.000000', 'temperatura', 247.0000, 'ºC'),
	(152094, 120, '2014-01-15 00:49:38.000000', 'temperatura', 522.0000, 'ºC'),
	(152095, 120, '2014-01-15 00:49:39.000000', 'temperatura', 668.0000, 'ºC'),
	(152096, 120, '2014-01-15 00:49:40.000000', 'temperatura', 578.0000, 'ºC'),
	(152097, 120, '2014-01-15 00:49:41.000000', 'temperatura', 886.0000, 'ºC'),
	(152098, 120, '2014-01-15 00:49:42.000000', 'temperatura', 296.0000, 'ºC'),
	(152099, 120, '2014-01-15 00:49:43.000000', 'temperatura', 24.0000, 'ºC'),
	(152100, 120, '2014-01-15 00:49:44.000000', 'temperatura', 431.0000, 'ºC'),
	(152101, 120, '2014-01-15 00:49:45.000000', 'temperatura', 883.0000, 'ºC'),
	(152102, 120, '2014-01-15 00:49:46.000000', 'temperatura', 723.0000, 'ºC'),
	(152103, 120, '2014-01-15 00:49:47.000000', 'temperatura', 967.0000, 'ºC'),
	(152104, 120, '2014-01-15 00:49:48.000000', 'temperatura', 268.0000, 'ºC'),
	(152105, 120, '2014-01-15 00:49:49.000000', 'temperatura', 839.0000, 'ºC'),
	(152106, 120, '2014-01-15 00:49:50.000000', 'temperatura', 989.0000, 'ºC'),
	(152107, 120, '2014-01-15 00:49:51.000000', 'temperatura', 30.0000, 'ºC'),
	(152108, 120, '2014-01-15 00:49:52.000000', 'temperatura', 784.0000, 'ºC'),
	(152109, 120, '2014-01-15 00:49:53.000000', 'temperatura', 232.0000, 'ºC'),
	(152110, 120, '2014-01-15 00:49:54.000000', 'temperatura', 7.0000, 'ºC'),
	(152111, 120, '2014-01-15 00:49:55.000000', 'temperatura', 540.0000, 'ºC'),
	(152112, 120, '2014-01-15 00:49:56.000000', 'temperatura', 278.0000, 'ºC'),
	(152113, 120, '2014-01-15 00:49:57.000000', 'temperatura', 973.0000, 'ºC'),
	(152114, 120, '2014-01-15 00:49:58.000000', 'temperatura', 432.0000, 'ºC'),
	(152115, 120, '2014-01-15 00:49:59.000000', 'temperatura', 442.0000, 'ºC'),
	(152116, 120, '2014-01-15 00:50:00.000000', 'temperatura', 914.0000, 'ºC'),
	(152117, 120, '2014-01-15 00:50:01.000000', 'temperatura', 843.0000, 'ºC'),
	(152118, 120, '2014-01-15 00:50:02.000000', 'temperatura', 276.0000, 'ºC'),
	(152119, 120, '2014-01-15 00:50:03.000000', 'temperatura', 48.0000, 'ºC'),
	(152120, 120, '2014-01-15 00:50:04.000000', 'temperatura', 616.0000, 'ºC'),
	(152121, 120, '2014-01-15 00:50:05.000000', 'temperatura', 536.0000, 'ºC'),
	(152122, 120, '2014-01-15 00:50:06.000000', 'temperatura', 831.0000, 'ºC'),
	(152123, 120, '2014-01-15 00:50:07.000000', 'temperatura', 150.0000, 'ºC'),
	(152124, 120, '2014-01-15 00:50:08.000000', 'temperatura', 657.0000, 'ºC'),
	(152125, 120, '2014-01-15 00:50:09.000000', 'temperatura', 435.0000, 'ºC'),
	(152126, 120, '2014-01-15 00:50:10.000000', 'temperatura', 206.0000, 'ºC'),
	(152127, 120, '2014-01-15 00:50:11.000000', 'temperatura', 923.0000, 'ºC'),
	(152128, 120, '2014-01-15 00:50:12.000000', 'temperatura', 399.0000, 'ºC'),
	(152129, 120, '2014-01-15 00:50:13.000000', 'temperatura', 428.0000, 'ºC'),
	(152130, 120, '2014-01-15 00:50:14.000000', 'temperatura', 940.0000, 'ºC'),
	(152131, 120, '2014-01-15 00:50:15.000000', 'temperatura', 1019.0000, 'ºC'),
	(152132, 120, '2014-01-15 00:50:16.000000', 'temperatura', 1074.0000, 'ºC'),
	(152133, 120, '2014-01-15 00:50:17.000000', 'temperatura', 1114.0000, 'ºC'),
	(152134, 120, '2014-01-15 00:50:18.000000', 'temperatura', 1148.0000, 'ºC'),
	(152135, 120, '2014-01-15 00:50:19.000000', 'temperatura', 1.0000, 'ºC'),
	(152136, 120, '2014-01-15 00:50:20.000000', 'temperatura', 158.0000, 'ºC'),
	(152137, 120, '2014-01-15 00:50:21.000000', 'temperatura', 790.0000, 'ºC'),
	(152138, 120, '2014-01-15 00:50:22.000000', 'temperatura', 1074.0000, 'ºC'),
	(152139, 120, '2014-01-15 00:50:23.000000', 'temperatura', 602.0000, 'ºC'),
	(152140, 120, '2014-01-15 00:50:24.000000', 'temperatura', 989.0000, 'ºC'),
	(152141, 120, '2014-01-15 00:50:25.000000', 'temperatura', 740.0000, 'ºC'),
	(152142, 120, '2014-01-15 00:50:26.000000', 'temperatura', 732.0000, 'ºC'),
	(152143, 120, '2014-01-15 00:50:27.000000', 'temperatura', 243.0000, 'ºC'),
	(152144, 120, '2014-01-15 00:50:28.000000', 'temperatura', 218.0000, 'ºC'),
	(152145, 120, '2014-01-15 00:50:29.000000', 'temperatura', 363.0000, 'ºC'),
	(152146, 120, '2014-01-15 00:50:30.000000', 'temperatura', 1161.0000, 'ºC'),
	(152147, 120, '2014-01-15 00:50:31.000000', 'temperatura', 1116.0000, 'ºC'),
	(152148, 120, '2014-01-15 00:50:32.000000', 'temperatura', 899.0000, 'ºC'),
	(152149, 120, '2014-01-15 00:50:33.000000', 'temperatura', 1148.0000, 'ºC'),
	(152150, 120, '2014-01-15 00:50:34.000000', 'temperatura', 641.0000, 'ºC'),
	(152151, 120, '2014-01-15 00:50:35.000000', 'temperatura', 963.0000, 'ºC'),
	(152152, 120, '2014-01-15 00:50:36.000000', 'temperatura', 491.0000, 'ºC'),
	(152153, 120, '2014-01-15 00:50:37.000000', 'temperatura', 767.0000, 'ºC'),
	(152154, 120, '2014-01-15 00:50:38.000000', 'temperatura', 1163.0000, 'ºC'),
	(152155, 120, '2014-01-15 00:50:39.000000', 'temperatura', 1115.0000, 'ºC'),
	(152156, 120, '2014-01-15 00:50:40.000000', 'temperatura', 886.0000, 'ºC'),
	(152157, 120, '2014-01-15 00:50:41.000000', 'temperatura', 1084.0000, 'ºC'),
	(152158, 120, '2014-01-15 00:50:42.000000', 'temperatura', 362.0000, 'ºC'),
	(152159, 120, '2014-01-15 00:50:43.000000', 'temperatura', 957.0000, 'ºC'),
	(152160, 120, '2014-01-15 00:50:44.000000', 'temperatura', 103.0000, 'ºC'),
	(152161, 120, '2014-01-15 00:50:45.000000', 'temperatura', 44.0000, 'ºC'),
	(152162, 120, '2014-01-15 00:50:46.000000', 'temperatura', 1113.0000, 'ºC'),
	(152163, 120, '2014-01-15 00:50:47.000000', 'temperatura', 631.0000, 'ºC'),
	(152164, 120, '2014-01-15 00:50:48.000000', 'temperatura', 1018.0000, 'ºC'),
	(152165, 120, '2014-01-15 00:50:49.000000', 'temperatura', 799.0000, 'ºC'),
	(152166, 120, '2014-01-15 00:50:50.000000', 'temperatura', 938.0000, 'ºC'),
	(152167, 120, '2014-01-15 00:50:51.000000', 'temperatura', 1096.0000, 'ºC'),
	(152168, 120, '2014-01-15 00:50:52.000000', 'temperatura', 264.0000, 'ºC'),
	(152169, 120, '2014-01-15 00:50:53.000000', 'temperatura', 434.0000, 'ºC'),
	(152170, 120, '2014-01-15 00:50:54.000000', 'temperatura', 180.0000, 'ºC'),
	(152171, 120, '2014-01-15 00:50:55.000000', 'temperatura', 798.0000, 'ºC'),
	(152172, 120, '2014-01-15 00:50:56.000000', 'temperatura', 1051.0000, 'ºC'),
	(152173, 120, '2014-01-15 00:50:57.000000', 'temperatura', 459.0000, 'ºC'),
	(152174, 120, '2014-01-15 00:50:58.000000', 'temperatura', 343.0000, 'ºC'),
	(152175, 120, '2014-01-15 00:50:59.000000', 'temperatura', 339.0000, 'ºC'),
	(152176, 120, '2014-01-15 00:51:00.000000', 'temperatura', 665.0000, 'ºC'),
	(152177, 120, '2014-01-15 00:51:01.000000', 'temperatura', 1108.0000, 'ºC'),
	(152178, 120, '2014-01-15 00:51:02.000000', 'temperatura', 1146.0000, 'ºC'),
	(152179, 120, '2014-01-15 00:51:03.000000', 'temperatura', 8.0000, 'ºC'),
	(152180, 120, '2014-01-15 00:51:04.000000', 'temperatura', 203.0000, 'ºC'),
	(152181, 120, '2014-01-15 00:51:05.000000', 'temperatura', 992.0000, 'ºC'),
	(152182, 120, '2014-01-15 00:51:06.000000', 'temperatura', 751.0000, 'ºC'),
	(152183, 120, '2014-01-15 00:51:07.000000', 'temperatura', 780.0000, 'ºC'),
	(152184, 120, '2014-01-15 00:51:08.000000', 'temperatura', 445.0000, 'ºC'),
	(152185, 120, '2014-01-15 00:51:09.000000', 'temperatura', 1088.0000, 'ºC'),
	(152186, 120, '2014-01-15 00:51:10.000000', 'temperatura', 503.0000, 'ºC'),
	(152187, 120, '2014-01-15 00:51:11.000000', 'temperatura', 455.0000, 'ºC'),
	(152188, 120, '2014-01-15 00:51:12.000000', 'temperatura', 764.0000, 'ºC'),
	(152189, 120, '2014-01-15 00:51:13.000000', 'temperatura', 57.0000, 'ºC'),
	(152190, 120, '2014-01-15 00:51:14.000000', 'temperatura', 391.0000, 'ºC'),
	(152191, 120, '2014-01-15 00:51:15.000000', 'temperatura', 586.0000, 'ºC'),
	(152192, 120, '2014-01-15 00:51:16.000000', 'temperatura', 555.0000, 'ºC'),
	(152193, 120, '2014-01-15 00:51:17.000000', 'temperatura', 1020.0000, 'ºC'),
	(152194, 120, '2014-01-15 00:51:18.000000', 'temperatura', 1037.0000, 'ºC'),
	(152195, 120, '2014-01-15 00:51:19.000000', 'temperatura', 924.0000, 'ºC'),
	(152196, 120, '2014-01-15 00:51:20.000000', 'temperatura', 309.0000, 'ºC'),
	(152197, 120, '2014-01-15 00:51:21.000000', 'temperatura', 1174.0000, 'ºC'),
	(152198, 120, '2014-01-15 00:51:22.000000', 'temperatura', 143.0000, 'ºC'),
	(152199, 120, '2014-01-15 00:51:23.000000', 'temperatura', 795.0000, 'ºC'),
	(152200, 120, '2014-01-15 00:51:24.000000', 'temperatura', 1144.0000, 'ºC'),
	(152201, 120, '2014-01-15 00:51:25.000000', 'temperatura', 935.0000, 'ºC'),
	(152202, 120, '2014-01-15 00:51:26.000000', 'temperatura', 46.0000, 'ºC'),
	(152203, 120, '2014-01-15 00:51:27.000000', 'temperatura', 1023.0000, 'ºC'),
	(152204, 120, '2014-01-15 00:51:28.000000', 'temperatura', 177.0000, 'ºC'),
	(152205, 120, '2014-01-15 00:51:29.000000', 'temperatura', 219.0000, 'ºC'),
	(152206, 120, '2014-01-15 00:51:30.000000', 'temperatura', 564.0000, 'ºC'),
	(152207, 120, '2014-01-15 00:51:31.000000', 'temperatura', 964.0000, 'ºC'),
	(152208, 120, '2014-01-15 00:51:32.000000', 'temperatura', 727.0000, 'ºC'),
	(152209, 120, '2014-01-15 00:51:33.000000', 'temperatura', 745.0000, 'ºC'),
	(152210, 120, '2014-01-15 00:51:34.000000', 'temperatura', 344.0000, 'ºC'),
	(152211, 120, '2014-01-15 00:51:35.000000', 'temperatura', 685.0000, 'ºC'),
	(152212, 120, '2014-01-15 00:51:36.000000', 'temperatura', 1194.0000, 'ºC'),
	(152213, 120, '2014-01-15 00:51:37.000000', 'temperatura', 315.0000, 'ºC'),
	(152214, 120, '2014-01-15 00:51:38.000000', 'temperatura', 392.0000, 'ºC'),
	(152215, 120, '2014-01-15 00:51:39.000000', 'temperatura', 1018.0000, 'ºC'),
	(152216, 120, '2014-01-15 00:51:40.000000', 'temperatura', 315.0000, 'ºC'),
	(152217, 120, '2014-01-15 00:51:41.000000', 'temperatura', 922.0000, 'ºC'),
	(152218, 120, '2014-01-15 00:51:42.000000', 'temperatura', 64.0000, 'ºC'),
	(152219, 120, '2014-01-15 00:51:43.000000', 'temperatura', 1153.0000, 'ºC'),
	(152220, 120, '2014-01-15 00:51:44.000000', 'temperatura', 774.0000, 'ºC'),
	(152221, 120, '2014-01-15 00:51:45.000000', 'temperatura', 413.0000, 'ºC'),
	(152222, 120, '2014-01-15 00:51:46.000000', 'temperatura', 944.0000, 'ºC'),
	(152223, 120, '2014-01-15 00:51:47.000000', 'temperatura', 1080.0000, 'ºC'),
	(152224, 120, '2014-01-15 00:51:48.000000', 'temperatura', 168.0000, 'ºC'),
	(152225, 120, '2014-01-15 00:51:49.000000', 'temperatura', 1.0000, 'ºC'),
	(152226, 120, '2014-01-15 00:51:50.000000', 'temperatura', 703.0000, 'ºC'),
	(152227, 120, '2014-01-15 00:51:51.000000', 'temperatura', 1110.0000, 'ºC'),
	(152228, 120, '2014-01-15 00:51:52.000000', 'temperatura', 1043.0000, 'ºC'),
	(152229, 120, '2014-01-15 00:51:53.000000', 'temperatura', 685.0000, 'ºC'),
	(152230, 120, '2014-01-15 00:51:54.000000', 'temperatura', 298.0000, 'ºC'),
	(152231, 120, '2014-01-15 00:51:55.000000', 'temperatura', 635.0000, 'ºC'),
	(152232, 120, '2014-01-15 00:51:56.000000', 'temperatura', 1082.0000, 'ºC'),
	(152233, 120, '2014-01-15 00:51:57.000000', 'temperatura', 1106.0000, 'ºC'),
	(152234, 120, '2014-01-15 00:51:58.000000', 'temperatura', 1086.0000, 'ºC'),
	(152235, 120, '2014-01-15 00:51:59.000000', 'temperatura', 909.0000, 'ºC'),
	(152236, 120, '2014-01-15 00:52:00.000000', 'temperatura', 88.0000, 'ºC'),
	(152237, 120, '2014-01-15 00:52:01.000000', 'temperatura', 116.0000, 'ºC'),
	(152238, 120, '2014-01-15 00:52:02.000000', 'temperatura', 314.0000, 'ºC'),
	(152239, 120, '2014-01-15 00:52:03.000000', 'temperatura', 24.0000, 'ºC'),
	(152240, 120, '2014-01-15 00:52:04.000000', 'temperatura', 379.0000, 'ºC'),
	(152241, 120, '2014-01-15 00:52:05.000000', 'temperatura', 622.0000, 'ºC'),
	(152242, 120, '2014-01-15 00:52:06.000000', 'temperatura', 774.0000, 'ºC'),
	(152243, 120, '2014-01-15 00:52:07.000000', 'temperatura', 803.0000, 'ºC'),
	(152244, 120, '2014-01-15 00:52:08.000000', 'temperatura', 494.0000, 'ºC'),
	(152245, 120, '2014-01-15 00:52:09.000000', 'temperatura', 62.0000, 'ºC'),
	(152246, 120, '2014-01-15 00:52:10.000000', 'temperatura', 27.0000, 'ºC'),
	(152247, 120, '2014-01-15 00:52:11.000000', 'temperatura', 1152.0000, 'ºC'),
	(152248, 120, '2014-01-15 00:52:12.000000', 'temperatura', 879.0000, 'ºC'),
	(152249, 120, '2014-01-15 00:52:13.000000', 'temperatura', 939.0000, 'ºC'),
	(152250, 120, '2014-01-15 00:52:14.000000', 'temperatura', 857.0000, 'ºC'),
	(152251, 120, '2014-01-15 00:52:15.000000', 'temperatura', 270.0000, 'ºC'),
	(152252, 120, '2014-01-15 00:52:16.000000', 'temperatura', 1181.0000, 'ºC'),
	(152253, 120, '2014-01-15 00:52:17.000000', 'temperatura', 295.0000, 'ºC'),
	(152254, 120, '2014-01-15 00:52:18.000000', 'temperatura', 333.0000, 'ºC'),
	(152255, 120, '2014-01-15 00:52:19.000000', 'temperatura', 778.0000, 'ºC'),
	(152256, 120, '2014-01-15 00:52:20.000000', 'temperatura', 494.0000, 'ºC'),
	(152257, 120, '2014-01-15 00:52:21.000000', 'temperatura', 137.0000, 'ºC'),
	(152258, 120, '2014-01-15 00:52:22.000000', 'temperatura', 402.0000, 'ºC'),
	(152259, 120, '2014-01-15 00:52:23.000000', 'temperatura', 400.0000, 'ºC'),
	(152260, 120, '2014-01-15 00:52:24.000000', 'temperatura', 793.0000, 'ºC'),
	(152261, 120, '2014-01-15 00:52:25.000000', 'temperatura', 367.0000, 'ºC'),
	(152262, 120, '2014-01-15 00:52:26.000000', 'temperatura', 655.0000, 'ºC'),
	(152263, 120, '2014-01-15 00:52:27.000000', 'temperatura', 976.0000, 'ºC'),
	(152264, 120, '2014-01-15 00:52:28.000000', 'temperatura', 516.0000, 'ºC'),
	(152265, 120, '2014-01-15 00:52:29.000000', 'temperatura', 853.0000, 'ºC'),
	(152266, 120, '2014-01-15 00:52:30.000000', 'temperatura', 318.0000, 'ºC'),
	(152267, 120, '2014-01-15 00:52:31.000000', 'temperatura', 229.0000, 'ºC'),
	(152268, 120, '2014-01-15 00:52:32.000000', 'temperatura', 194.0000, 'ºC'),
	(152269, 120, '2014-01-15 00:52:33.000000', 'temperatura', 284.0000, 'ºC'),
	(152270, 120, '2014-01-15 00:52:34.000000', 'temperatura', 839.0000, 'ºC'),
	(152271, 120, '2014-01-15 00:52:35.000000', 'temperatura', 941.0000, 'ºC'),
	(152272, 120, '2014-01-15 00:52:36.000000', 'temperatura', 989.0000, 'ºC'),
	(152273, 120, '2014-01-15 00:52:37.000000', 'temperatura', 925.0000, 'ºC'),
	(152274, 120, '2014-01-15 00:52:38.000000', 'temperatura', 456.0000, 'ºC'),
	(152275, 120, '2014-01-15 00:52:39.000000', 'temperatura', 704.0000, 'ºC'),
	(152276, 120, '2014-01-15 00:52:40.000000', 'temperatura', 956.0000, 'ºC'),
	(152277, 120, '2014-01-15 00:52:41.000000', 'temperatura', 267.0000, 'ºC'),
	(152278, 120, '2014-01-15 00:52:42.000000', 'temperatura', 867.0000, 'ºC'),
	(152279, 120, '2014-01-15 00:52:43.000000', 'temperatura', 1136.0000, 'ºC'),
	(152280, 120, '2014-01-15 00:52:44.000000', 'temperatura', 679.0000, 'ºC'),
	(152281, 120, '2014-01-15 00:52:45.000000', 'temperatura', 1187.0000, 'ºC'),
	(152282, 120, '2014-01-15 00:52:46.000000', 'temperatura', 300.0000, 'ºC'),
	(152283, 120, '2014-01-15 00:52:47.000000', 'temperatura', 337.0000, 'ºC'),
	(152284, 120, '2014-01-15 00:52:48.000000', 'temperatura', 788.0000, 'ºC'),
	(152285, 120, '2014-01-15 00:52:49.000000', 'temperatura', 527.0000, 'ºC'),
	(152286, 120, '2014-01-15 00:52:50.000000', 'temperatura', 272.0000, 'ºC'),
	(152287, 120, '2014-01-15 00:52:51.000000', 'temperatura', 978.0000, 'ºC'),
	(152288, 120, '2014-01-15 00:52:52.000000', 'temperatura', 475.0000, 'ºC'),
	(152289, 120, '2014-01-15 00:52:53.000000', 'temperatura', 643.0000, 'ºC'),
	(152290, 120, '2014-01-15 00:52:54.000000', 'temperatura', 591.0000, 'ºC'),
	(152291, 120, '2014-01-15 00:52:55.000000', 'temperatura', 1024.0000, 'ºC'),
	(152292, 120, '2014-01-15 00:52:56.000000', 'temperatura', 949.0000, 'ºC'),
	(152293, 120, '2014-01-15 00:52:57.000000', 'temperatura', 474.0000, 'ºC'),
	(152294, 120, '2014-01-15 00:52:58.000000', 'temperatura', 722.0000, 'ºC'),
	(152295, 120, '2014-01-15 00:52:59.000000', 'temperatura', 989.0000, 'ºC'),
	(152296, 120, '2014-01-15 00:53:00.000000', 'temperatura', 380.0000, 'ºC'),
	(152297, 120, '2014-01-15 00:53:01.000000', 'temperatura', 133.0000, 'ºC'),
	(152298, 120, '2014-01-15 00:53:02.000000', 'temperatura', 728.0000, 'ºC'),
	(152299, 120, '2014-01-15 00:53:03.000000', 'temperatura', 839.0000, 'ºC'),
	(152300, 120, '2014-01-15 00:53:04.000000', 'temperatura', 812.0000, 'ºC'),
	(152301, 120, '2014-01-15 00:53:05.000000', 'temperatura', 343.0000, 'ºC'),
	(152302, 120, '2014-01-15 00:53:06.000000', 'temperatura', 480.0000, 'ºC'),
	(152303, 120, '2014-01-15 00:53:07.000000', 'temperatura', 171.0000, 'ºC'),
	(152304, 120, '2014-01-15 00:53:08.000000', 'temperatura', 616.0000, 'ºC'),
	(152305, 120, '2014-01-15 00:53:09.000000', 'temperatura', 165.0000, 'ºC'),
	(152306, 120, '2014-01-15 00:53:10.000000', 'temperatura', 180.0000, 'ºC'),
	(152307, 120, '2014-01-15 00:53:11.000000', 'temperatura', 407.0000, 'ºC'),
	(152308, 120, '2014-01-15 00:53:12.000000', 'temperatura', 293.0000, 'ºC'),
	(152309, 120, '2014-01-15 00:53:13.000000', 'temperatura', 245.0000, 'ºC'),
	(152310, 120, '2014-01-15 00:53:14.000000', 'temperatura', 345.0000, 'ºC'),
	(152311, 120, '2014-01-15 00:53:15.000000', 'temperatura', 991.0000, 'ºC'),
	(152312, 120, '2014-01-15 00:53:16.000000', 'temperatura', 319.0000, 'ºC'),
	(152313, 120, '2014-01-15 00:53:17.000000', 'temperatura', 1023.0000, 'ºC'),
	(152314, 120, '2014-01-15 00:53:18.000000', 'temperatura', 560.0000, 'ºC'),
	(152315, 120, '2014-01-15 00:53:19.000000', 'temperatura', 930.0000, 'ºC'),
	(152316, 120, '2014-01-15 00:53:20.000000', 'temperatura', 573.0000, 'ºC'),
	(152317, 120, '2014-01-15 00:53:21.000000', 'temperatura', 73.0000, 'ºC'),
	(152318, 120, '2014-01-15 00:53:22.000000', 'temperatura', 1047.0000, 'ºC'),
	(152319, 120, '2014-01-15 00:53:23.000000', 'temperatura', 217.0000, 'ºC'),
	(152320, 120, '2014-01-15 00:53:24.000000', 'temperatura', 345.0000, 'ºC'),
	(152321, 120, '2014-01-15 00:53:25.000000', 'temperatura', 1073.0000, 'ºC'),
	(152322, 120, '2014-01-15 00:53:26.000000', 'temperatura', 731.0000, 'ºC'),
	(152323, 120, '2014-01-15 00:53:27.000000', 'temperatura', 437.0000, 'ºC'),
	(152324, 120, '2014-01-15 00:53:28.000000', 'temperatura', 1194.0000, 'ºC'),
	(152325, 120, '2014-01-15 00:53:29.000000', 'temperatura', 1058.0000, 'ºC'),
	(152326, 120, '2014-01-15 00:53:30.000000', 'temperatura', 508.0000, 'ºC'),
	(152327, 120, '2014-01-15 00:53:31.000000', 'temperatura', 566.0000, 'ºC'),
	(152328, 120, '2014-01-15 00:53:32.000000', 'temperatura', 108.0000, 'ºC'),
	(152329, 120, '2014-01-15 00:53:33.000000', 'temperatura', 44.0000, 'ºC'),
	(152330, 120, '2014-01-15 00:53:34.000000', 'temperatura', 1095.0000, 'ºC'),
	(152331, 120, '2014-01-15 00:53:35.000000', 'temperatura', 544.0000, 'ºC'),
	(152332, 120, '2014-01-15 00:53:36.000000', 'temperatura', 633.0000, 'ºC'),
	(152333, 120, '2014-01-15 00:53:37.000000', 'temperatura', 337.0000, 'ºC'),
	(152334, 120, '2014-01-15 00:53:38.000000', 'temperatura', 985.0000, 'ºC'),
	(152335, 120, '2014-01-15 00:53:39.000000', 'temperatura', 314.0000, 'ºC'),
	(152336, 120, '2014-01-15 00:53:40.000000', 'temperatura', 1017.0000, 'ºC'),
	(152337, 120, '2014-01-15 00:53:41.000000', 'temperatura', 541.0000, 'ºC'),
	(152338, 120, '2014-01-15 00:53:42.000000', 'temperatura', 854.0000, 'ºC'),
	(152339, 120, '2014-01-15 00:53:43.000000', 'temperatura', 249.0000, 'ºC'),
	(152340, 120, '2014-01-15 00:53:44.000000', 'temperatura', 1085.0000, 'ºC'),
	(152341, 120, '2014-01-15 00:53:45.000000', 'temperatura', 1077.0000, 'ºC'),
	(152342, 120, '2014-01-15 00:53:46.000000', 'temperatura', 929.0000, 'ºC'),
	(152343, 120, '2014-01-15 00:53:47.000000', 'temperatura', 216.0000, 'ºC'),
	(152344, 120, '2014-01-15 00:53:48.000000', 'temperatura', 695.0000, 'ºC'),
	(152345, 120, '2014-01-15 00:53:49.000000', 'temperatura', 425.0000, 'ºC'),
	(152346, 120, '2014-01-15 00:53:50.000000', 'temperatura', 42.0000, 'ºC'),
	(152347, 120, '2014-01-15 00:53:51.000000', 'temperatura', 135.0000, 'ºC'),
	(152348, 120, '2014-01-15 00:53:52.000000', 'temperatura', 548.0000, 'ºC'),
	(152349, 120, '2014-01-15 00:53:53.000000', 'temperatura', 1138.0000, 'ºC'),
	(152350, 120, '2014-01-15 00:53:54.000000', 'temperatura', 445.0000, 'ºC'),
	(152351, 120, '2014-01-15 00:53:55.000000', 'temperatura', 14.0000, 'ºC'),
	(152352, 120, '2014-01-15 00:53:56.000000', 'temperatura', 1132.0000, 'ºC'),
	(152353, 120, '2014-01-15 00:53:57.000000', 'temperatura', 820.0000, 'ºC'),
	(152354, 120, '2014-01-15 00:53:58.000000', 'temperatura', 703.0000, 'ºC'),
	(152355, 120, '2014-01-15 00:53:59.000000', 'temperatura', 1054.0000, 'ºC'),
	(152356, 120, '2014-01-15 00:54:00.000000', 'temperatura', 765.0000, 'ºC'),
	(152357, 120, '2014-01-15 00:54:01.000000', 'temperatura', 662.0000, 'ºC'),
	(152358, 120, '2014-01-15 00:54:02.000000', 'temperatura', 1016.0000, 'ºC'),
	(152359, 120, '2014-01-15 00:54:03.000000', 'temperatura', 696.0000, 'ºC'),
	(152360, 120, '2014-01-15 00:54:04.000000', 'temperatura', 432.0000, 'ºC'),
	(152361, 120, '2014-01-15 00:54:05.000000', 'temperatura', 71.0000, 'ºC'),
	(152362, 120, '2014-01-15 00:54:06.000000', 'temperatura', 261.0000, 'ºC'),
	(152363, 120, '2014-01-15 00:54:07.000000', 'temperatura', 1092.0000, 'ºC'),
	(152364, 120, '2014-01-15 00:54:08.000000', 'temperatura', 1076.0000, 'ºC'),
	(152365, 120, '2014-01-15 00:54:09.000000', 'temperatura', 904.0000, 'ºC'),
	(152366, 120, '2014-01-15 00:54:10.000000', 'temperatura', 93.0000, 'ºC'),
	(152367, 120, '2014-01-15 00:54:11.000000', 'temperatura', 152.0000, 'ºC'),
	(152368, 120, '2014-01-15 00:54:12.000000', 'temperatura', 482.0000, 'ºC'),
	(152369, 120, '2014-01-15 00:54:13.000000', 'temperatura', 756.0000, 'ºC'),
	(152370, 120, '2014-01-15 00:54:14.000000', 'temperatura', 1133.0000, 'ºC'),
	(152371, 120, '2014-01-15 00:54:15.000000', 'temperatura', 997.0000, 'ºC'),
	(152372, 120, '2014-01-15 00:54:16.000000', 'temperatura', 386.0000, 'ºC'),
	(152373, 120, '2014-01-15 00:54:17.000000', 'temperatura', 141.0000, 'ºC'),
	(152374, 120, '2014-01-15 00:54:18.000000', 'temperatura', 747.0000, 'ºC'),
	(152375, 120, '2014-01-15 00:54:19.000000', 'temperatura', 911.0000, 'ºC'),
	(152376, 120, '2014-01-15 00:54:20.000000', 'temperatura', 1117.0000, 'ºC'),
	(152377, 120, '2014-01-15 00:54:21.000000', 'temperatura', 451.0000, 'ºC'),
	(152378, 120, '2014-01-15 00:54:22.000000', 'temperatura', 104.0000, 'ºC'),
	(152379, 120, '2014-01-15 00:54:23.000000', 'temperatura', 366.0000, 'ºC'),
	(152380, 120, '2014-01-15 00:54:24.000000', 'temperatura', 321.0000, 'ºC'),
	(152381, 120, '2014-01-15 00:54:25.000000', 'temperatura', 507.0000, 'ºC'),
	(152382, 120, '2014-01-15 00:54:26.000000', 'temperatura', 374.0000, 'ºC'),
	(152383, 120, '2014-01-15 00:54:27.000000', 'temperatura', 349.0000, 'ºC'),
	(152384, 120, '2014-01-15 00:54:28.000000', 'temperatura', 622.0000, 'ºC'),
	(152385, 120, '2014-01-15 00:54:29.000000', 'temperatura', 863.0000, 'ºC'),
	(152386, 120, '2014-01-15 00:54:30.000000', 'temperatura', 50.0000, 'ºC'),
	(152387, 120, '2014-01-15 00:54:31.000000', 'temperatura', 60.0000, 'ºC'),
	(152388, 120, '2014-01-15 00:54:32.000000', 'temperatura', 154.0000, 'ºC'),
	(152389, 120, '2014-01-15 00:54:33.000000', 'temperatura', 587.0000, 'ºC'),
	(152390, 120, '2014-01-15 00:54:34.000000', 'temperatura', 76.0000, 'ºC'),
	(152391, 120, '2014-01-15 00:54:35.000000', 'temperatura', 1021.0000, 'ºC'),
	(152392, 120, '2014-01-15 00:54:36.000000', 'temperatura', 74.0000, 'ºC'),
	(152393, 120, '2014-01-15 00:54:37.000000', 'temperatura', 911.0000, 'ºC'),
	(152394, 120, '2014-01-15 00:54:38.000000', 'temperatura', 731.0000, 'ºC'),
	(152395, 120, '2014-01-15 00:54:39.000000', 'temperatura', 925.0000, 'ºC'),
	(152396, 120, '2014-01-15 00:54:40.000000', 'temperatura', 31.0000, 'ºC'),
	(152397, 120, '2014-01-15 00:54:41.000000', 'temperatura', 980.0000, 'ºC'),
	(152398, 120, '2014-01-15 00:54:42.000000', 'temperatura', 8.0000, 'ºC'),
	(152399, 120, '2014-01-15 00:54:43.000000', 'temperatura', 701.0000, 'ºC'),
	(152400, 120, '2014-01-15 00:54:44.000000', 'temperatura', 1082.0000, 'ºC'),
	(152401, 120, '2014-01-15 00:54:45.000000', 'temperatura', 908.0000, 'ºC'),
	(152402, 120, '2014-01-15 00:54:46.000000', 'temperatura', 94.0000, 'ºC'),
	(152403, 120, '2014-01-15 00:54:47.000000', 'temperatura', 145.0000, 'ºC'),
	(152404, 120, '2014-01-15 00:54:48.000000', 'temperatura', 444.0000, 'ºC'),
	(152405, 120, '2014-01-15 00:54:49.000000', 'temperatura', 585.0000, 'ºC'),
	(152406, 120, '2014-01-15 00:54:50.000000', 'temperatura', 395.0000, 'ºC'),
	(152407, 120, '2014-01-15 00:54:51.000000', 'temperatura', 219.0000, 'ºC'),
	(152408, 120, '2014-01-15 00:54:52.000000', 'temperatura', 1112.0000, 'ºC'),
	(152409, 120, '2014-01-15 00:54:53.000000', 'temperatura', 104.0000, 'ºC'),
	(152410, 120, '2014-01-15 00:54:54.000000', 'temperatura', 782.0000, 'ºC'),
	(152411, 120, '2014-01-15 00:54:55.000000', 'temperatura', 2.0000, 'ºC'),
	(152412, 120, '2014-01-15 00:54:56.000000', 'temperatura', 62.0000, 'ºC'),
	(152413, 120, '2014-01-15 00:54:57.000000', 'temperatura', 304.0000, 'ºC'),
	(152414, 120, '2014-01-15 00:54:58.000000', 'temperatura', 134.0000, 'ºC'),
	(152415, 120, '2014-01-15 00:54:59.000000', 'temperatura', 958.0000, 'ºC'),
	(152416, 120, '2014-01-15 00:55:00.000000', 'temperatura', 790.0000, 'ºC'),
	(152417, 120, '2014-01-15 00:55:01.000000', 'temperatura', 1078.0000, 'ºC'),
	(152418, 120, '2014-01-15 00:55:02.000000', 'temperatura', 619.0000, 'ºC'),
	(152419, 120, '2014-01-15 00:55:03.000000', 'temperatura', 1062.0000, 'ºC'),
	(152420, 120, '2014-01-15 00:55:04.000000', 'temperatura', 1052.0000, 'ºC'),
	(152421, 120, '2014-01-15 00:55:05.000000', 'temperatura', 874.0000, 'ºC'),
	(152422, 120, '2014-01-15 00:55:06.000000', 'temperatura', 16.0000, 'ºC'),
	(152423, 120, '2014-01-15 00:55:07.000000', 'temperatura', 1057.0000, 'ºC'),
	(152424, 120, '2014-01-15 00:55:08.000000', 'temperatura', 437.0000, 'ºC'),
	(152425, 120, '2014-01-15 00:55:09.000000', 'temperatura', 214.0000, 'ºC'),
	(152426, 120, '2014-01-15 00:55:10.000000', 'temperatura', 961.0000, 'ºC'),
	(152427, 120, '2014-01-15 00:55:11.000000', 'temperatura', 565.0000, 'ºC'),
	(152428, 120, '2014-01-15 00:55:12.000000', 'temperatura', 1140.0000, 'ºC'),
	(152429, 120, '2014-01-15 00:55:13.000000', 'temperatura', 407.0000, 'ºC'),
	(152430, 120, '2014-01-15 00:55:14.000000', 'temperatura', 1013.0000, 'ºC'),
	(152431, 120, '2014-01-15 00:55:15.000000', 'temperatura', 246.0000, 'ºC'),
	(152432, 120, '2014-01-15 00:55:16.000000', 'temperatura', 593.0000, 'ºC'),
	(152433, 120, '2014-01-15 00:55:17.000000', 'temperatura', 1026.0000, 'ºC'),
	(152434, 120, '2014-01-15 00:55:18.000000', 'temperatura', 950.0000, 'ºC'),
	(152435, 120, '2014-01-15 00:55:19.000000', 'temperatura', 475.0000, 'ºC'),
	(152436, 120, '2014-01-15 00:55:20.000000', 'temperatura', 723.0000, 'ºC'),
	(152437, 120, '2014-01-15 00:55:21.000000', 'temperatura', 991.0000, 'ºC'),
	(152438, 120, '2014-01-15 00:55:22.000000', 'temperatura', 385.0000, 'ºC'),
	(152439, 120, '2014-01-15 00:55:23.000000', 'temperatura', 155.0000, 'ºC'),
	(152440, 120, '2014-01-15 00:55:24.000000', 'temperatura', 821.0000, 'ºC'),
	(152441, 120, '2014-01-15 00:55:25.000000', 'temperatura', 39.0000, 'ºC'),
	(152442, 120, '2014-01-15 00:55:26.000000', 'temperatura', 133.0000, 'ºC'),
	(152443, 120, '2014-01-15 00:55:27.000000', 'temperatura', 549.0000, 'ºC'),
	(152444, 120, '2014-01-15 00:55:28.000000', 'temperatura', 1145.0000, 'ºC'),
	(152445, 120, '2014-01-15 00:55:29.000000', 'temperatura', 481.0000, 'ºC'),
	(152446, 120, '2014-01-15 00:55:30.000000', 'temperatura', 169.0000, 'ºC'),
	(152447, 120, '2014-01-15 00:55:31.000000', 'temperatura', 604.0000, 'ºC'),
	(152448, 120, '2014-01-15 00:55:32.000000', 'temperatura', 113.0000, 'ºC'),
	(152449, 120, '2014-01-15 00:55:33.000000', 'temperatura', 1155.0000, 'ºC'),
	(152450, 120, '2014-01-15 00:55:34.000000', 'temperatura', 635.0000, 'ºC'),
	(152451, 120, '2014-01-15 00:55:35.000000', 'temperatura', 911.0000, 'ºC'),
	(152452, 120, '2014-01-15 00:55:36.000000', 'temperatura', 252.0000, 'ºC'),
	(152453, 120, '2014-01-15 00:55:37.000000', 'temperatura', 927.0000, 'ºC'),
	(152454, 120, '2014-01-15 00:55:38.000000', 'temperatura', 277.0000, 'ºC'),
	(152455, 120, '2014-01-15 00:55:39.000000', 'temperatura', 1007.0000, 'ºC'),
	(152456, 120, '2014-01-15 00:55:40.000000', 'temperatura', 605.0000, 'ºC'),
	(152457, 120, '2014-01-15 00:55:41.000000', 'temperatura', 4.0000, 'ºC'),
	(152458, 120, '2014-01-15 00:55:42.000000', 'temperatura', 605.0000, 'ºC'),
	(152459, 120, '2014-01-15 00:55:43.000000', 'temperatura', 615.0000, 'ºC'),
	(152460, 120, '2014-01-15 00:55:44.000000', 'temperatura', 60.0000, 'ºC'),
	(152461, 120, '2014-01-15 00:55:45.000000', 'temperatura', 855.0000, 'ºC'),
	(152462, 120, '2014-01-15 00:55:46.000000', 'temperatura', 495.0000, 'ºC'),
	(152463, 120, '2014-01-15 00:55:47.000000', 'temperatura', 1112.0000, 'ºC'),
	(152464, 120, '2014-01-15 00:55:48.000000', 'temperatura', 473.0000, 'ºC'),
	(152465, 120, '2014-01-15 00:55:49.000000', 'temperatura', 230.0000, 'ºC'),
	(152466, 120, '2014-01-15 00:55:50.000000', 'temperatura', 933.0000, 'ºC'),
	(152467, 120, '2014-01-15 00:55:51.000000', 'temperatura', 374.0000, 'ºC'),
	(152468, 120, '2014-01-15 00:55:52.000000', 'temperatura', 274.0000, 'ºC'),
	(152469, 120, '2014-01-15 00:55:53.000000', 'temperatura', 246.0000, 'ºC'),
	(152470, 120, '2014-01-15 00:55:54.000000', 'temperatura', 410.0000, 'ºC'),
	(152471, 120, '2014-01-15 00:55:55.000000', 'temperatura', 113.0000, 'ºC'),
	(152472, 120, '2014-01-15 00:55:56.000000', 'temperatura', 533.0000, 'ºC'),
	(152473, 120, '2014-01-15 00:55:57.000000', 'temperatura', 1128.0000, 'ºC'),
	(152474, 120, '2014-01-15 00:55:58.000000', 'temperatura', 443.0000, 'ºC'),
	(152475, 120, '2014-01-15 00:55:59.000000', 'temperatura', 32.0000, 'ºC'),
	(152476, 120, '2014-01-15 00:56:00.000000', 'temperatura', 28.0000, 'ºC'),
	(152477, 120, '2014-01-15 00:56:01.000000', 'temperatura', 48.0000, 'ºC'),
	(152478, 120, '2014-01-15 00:56:02.000000', 'temperatura', 154.0000, 'ºC'),
	(152479, 120, '2014-01-15 00:56:03.000000', 'temperatura', 629.0000, 'ºC'),
	(152480, 120, '2014-01-15 00:56:04.000000', 'temperatura', 281.0000, 'ºC'),
	(152481, 120, '2014-01-15 00:56:05.000000', 'temperatura', 721.0000, 'ºC'),
	(152482, 120, '2014-01-15 00:56:06.000000', 'temperatura', 363.0000, 'ºC'),
	(152483, 120, '2014-01-15 00:56:07.000000', 'temperatura', 850.0000, 'ºC'),
	(152484, 120, '2014-01-15 00:56:08.000000', 'temperatura', 764.0000, 'ºC'),
	(152485, 120, '2014-01-15 00:56:09.000000', 'temperatura', 69.0000, 'ºC'),
	(152486, 120, '2014-01-15 00:56:10.000000', 'temperatura', 455.0000, 'ºC'),
	(152487, 120, '2014-01-15 00:56:11.000000', 'temperatura', 869.0000, 'ºC'),
	(152488, 120, '2014-01-15 00:56:12.000000', 'temperatura', 580.0000, 'ºC'),
	(152489, 120, '2014-01-15 00:56:13.000000', 'temperatura', 293.0000, 'ºC'),
	(152490, 120, '2014-01-15 00:56:14.000000', 'temperatura', 927.0000, 'ºC'),
	(152491, 120, '2014-01-15 00:56:15.000000', 'temperatura', 157.0000, 'ºC'),
	(152492, 120, '2014-01-15 00:56:16.000000', 'temperatura', 403.0000, 'ºC'),
	(152493, 120, '2014-01-15 00:56:17.000000', 'temperatura', 347.0000, 'ºC'),
	(152494, 120, '2014-01-15 00:56:18.000000', 'temperatura', 524.0000, 'ºC'),
	(152495, 120, '2014-01-15 00:56:19.000000', 'temperatura', 378.0000, 'ºC'),
	(152496, 120, '2014-01-15 00:56:20.000000', 'temperatura', 320.0000, 'ºC'),
	(152497, 120, '2014-01-15 00:56:21.000000', 'temperatura', 468.0000, 'ºC'),
	(152498, 120, '2014-01-15 00:56:22.000000', 'temperatura', 179.0000, 'ºC'),
	(152499, 120, '2014-01-15 00:56:23.000000', 'temperatura', 693.0000, 'ºC'),
	(152500, 120, '2014-01-15 00:56:24.000000', 'temperatura', 527.0000, 'ºC'),
	(152501, 120, '2014-01-15 00:56:25.000000', 'temperatura', 558.0000, 'ºC'),
	(152502, 120, '2014-01-15 00:56:26.000000', 'temperatura', 7.0000, 'ºC'),
	(152503, 120, '2014-01-15 00:56:27.000000', 'temperatura', 762.0000, 'ºC'),
	(152504, 120, '2014-01-15 00:56:28.000000', 'temperatura', 190.0000, 'ºC'),
	(152505, 120, '2014-01-15 00:56:29.000000', 'temperatura', 1063.0000, 'ºC'),
	(152506, 120, '2014-01-15 00:56:30.000000', 'temperatura', 1147.0000, 'ºC'),
	(152507, 120, '2014-01-15 00:56:31.000000', 'temperatura', 144.0000, 'ºC'),
	(152508, 120, '2014-01-15 00:56:32.000000', 'temperatura', 882.0000, 'ºC'),
	(152509, 120, '2014-01-15 00:56:33.000000', 'temperatura', 376.0000, 'ºC'),
	(152510, 120, '2014-01-15 00:56:34.000000', 'temperatura', 437.0000, 'ºC'),
	(152511, 120, '2014-01-15 00:56:35.000000', 'temperatura', 1058.0000, 'ºC'),
	(152512, 120, '2014-01-15 00:56:36.000000', 'temperatura', 377.0000, 'ºC'),
	(152513, 120, '2014-01-15 00:56:37.000000', 'temperatura', 1112.0000, 'ºC'),
	(152514, 120, '2014-01-15 00:56:38.000000', 'temperatura', 831.0000, 'ºC'),
	(152515, 120, '2014-01-15 00:56:39.000000', 'temperatura', 817.0000, 'ºC'),
	(152516, 120, '2014-01-15 00:56:40.000000', 'temperatura', 396.0000, 'ºC'),
	(152517, 120, '2014-01-15 00:56:41.000000', 'temperatura', 726.0000, 'ºC'),
	(152518, 120, '2014-01-15 00:56:42.000000', 'temperatura', 45.0000, 'ºC'),
	(152519, 120, '2014-01-15 00:56:43.000000', 'temperatura', 448.0000, 'ºC'),
	(152520, 120, '2014-01-15 00:56:44.000000', 'temperatura', 904.0000, 'ºC'),
	(152521, 120, '2014-01-15 00:56:45.000000', 'temperatura', 778.0000, 'ºC'),
	(152522, 120, '2014-01-15 00:56:46.000000', 'temperatura', 1179.0000, 'ºC'),
	(152523, 120, '2014-01-15 00:56:47.000000', 'temperatura', 1160.0000, 'ºC'),
	(152524, 120, '2014-01-15 00:56:48.000000', 'temperatura', 1065.0000, 'ºC'),
	(152525, 120, '2014-01-15 00:56:49.000000', 'temperatura', 646.0000, 'ºC'),
	(152526, 120, '2014-01-15 00:56:50.000000', 'temperatura', 33.0000, 'ºC'),
	(152527, 120, '2014-01-15 00:56:51.000000', 'temperatura', 630.0000, 'ºC'),
	(152528, 120, '2014-01-15 00:56:52.000000', 'temperatura', 650.0000, 'ºC'),
	(152529, 120, '2014-01-15 00:56:53.000000', 'temperatura', 161.0000, 'ºC'),
	(152530, 120, '2014-01-15 00:56:54.000000', 'temperatura', 54.0000, 'ºC'),
	(152531, 120, '2014-01-15 00:56:55.000000', 'temperatura', 988.0000, 'ºC'),
	(152532, 120, '2014-01-15 00:56:56.000000', 'temperatura', 1179.0000, 'ºC'),
	(152533, 120, '2014-01-15 00:56:57.000000', 'temperatura', 529.0000, 'ºC'),
	(152534, 120, '2014-01-15 00:56:58.000000', 'temperatura', 311.0000, 'ºC'),
	(152535, 120, '2014-01-15 00:56:59.000000', 'temperatura', 1169.0000, 'ºC'),
	(152536, 120, '2014-01-15 00:57:00.000000', 'temperatura', 111.0000, 'ºC'),
	(152537, 120, '2014-01-15 00:57:01.000000', 'temperatura', 649.0000, 'ºC'),
	(152538, 120, '2014-01-15 00:57:02.000000', 'temperatura', 513.0000, 'ºC'),
	(152539, 120, '2014-01-15 00:57:03.000000', 'temperatura', 616.0000, 'ºC'),
	(152540, 120, '2014-01-15 00:57:04.000000', 'temperatura', 345.0000, 'ºC'),
	(152541, 120, '2014-01-15 00:57:05.000000', 'temperatura', 1076.0000, 'ºC'),
	(152542, 120, '2014-01-15 00:57:06.000000', 'temperatura', 746.0000, 'ºC'),
	(152543, 120, '2014-01-15 00:57:07.000000', 'temperatura', 504.0000, 'ºC'),
	(152544, 120, '2014-01-15 00:57:08.000000', 'temperatura', 279.0000, 'ºC'),
	(152545, 120, '2014-01-15 00:57:09.000000', 'temperatura', 1086.0000, 'ºC'),
	(152546, 120, '2014-01-15 00:57:10.000000', 'temperatura', 991.0000, 'ºC'),
	(152547, 120, '2014-01-15 00:57:11.000000', 'temperatura', 499.0000, 'ºC'),
	(152548, 120, '2014-01-15 00:57:12.000000', 'temperatura', 721.0000, 'ºC'),
	(152549, 120, '2014-01-15 00:57:13.000000', 'temperatura', 910.0000, 'ºC'),
	(152550, 120, '2014-01-15 00:57:14.000000', 'temperatura', 1187.0000, 'ºC'),
	(152551, 120, '2014-01-15 00:57:15.000000', 'temperatura', 807.0000, 'ºC'),
	(152552, 120, '2014-01-15 00:57:16.000000', 'temperatura', 475.0000, 'ºC'),
	(152553, 120, '2014-01-15 00:57:17.000000', 'temperatura', 1152.0000, 'ºC'),
	(152554, 120, '2014-01-15 00:57:18.000000', 'temperatura', 735.0000, 'ºC'),
	(152555, 120, '2014-01-15 00:57:19.000000', 'temperatura', 221.0000, 'ºC'),
	(152556, 120, '2014-01-15 00:57:20.000000', 'temperatura', 101.0000, 'ºC'),
	(152557, 120, '2014-01-15 00:57:21.000000', 'temperatura', 1043.0000, 'ºC'),
	(152558, 120, '2014-01-15 00:57:22.000000', 'temperatura', 110.0000, 'ºC'),
	(152559, 120, '2014-01-15 00:57:23.000000', 'temperatura', 1022.0000, 'ºC'),
	(152560, 120, '2014-01-15 00:57:24.000000', 'temperatura', 1180.0000, 'ºC'),
	(152561, 120, '2014-01-15 00:57:25.000000', 'temperatura', 436.0000, 'ºC'),
	(152562, 120, '2014-01-15 00:57:26.000000', 'temperatura', 1041.0000, 'ºC'),
	(152563, 120, '2014-01-15 00:57:27.000000', 'temperatura', 299.0000, 'ºC'),
	(152564, 120, '2014-01-15 00:57:28.000000', 'temperatura', 770.0000, 'ºC'),
	(152565, 120, '2014-01-15 00:57:29.000000', 'temperatura', 553.0000, 'ºC'),
	(152566, 120, '2014-01-15 00:57:30.000000', 'temperatura', 456.0000, 'ºC'),
	(152567, 120, '2014-01-15 00:57:31.000000', 'temperatura', 622.0000, 'ºC'),
	(152568, 120, '2014-01-15 00:57:32.000000', 'temperatura', 541.0000, 'ºC'),
	(152569, 120, '2014-01-15 00:57:33.000000', 'temperatura', 839.0000, 'ºC'),
	(152570, 120, '2014-01-15 00:57:34.000000', 'temperatura', 172.0000, 'ºC'),
	(152571, 120, '2014-01-15 00:57:35.000000', 'temperatura', 746.0000, 'ºC'),
	(152572, 120, '2014-01-15 00:57:36.000000', 'temperatura', 814.0000, 'ºC'),
	(152573, 120, '2014-01-15 00:57:37.000000', 'temperatura', 630.0000, 'ºC'),
	(152574, 120, '2014-01-15 00:57:38.000000', 'temperatura', 711.0000, 'ºC'),
	(152575, 120, '2014-01-15 00:57:39.000000', 'temperatura', 465.0000, 'ºC'),
	(152576, 120, '2014-01-15 00:57:40.000000', 'temperatura', 192.0000, 'ºC'),
	(152577, 120, '2014-01-15 00:57:41.000000', 'temperatura', 765.0000, 'ºC'),
	(152578, 120, '2014-01-15 00:57:42.000000', 'temperatura', 848.0000, 'ºC'),
	(152579, 120, '2014-01-15 00:57:43.000000', 'temperatura', 749.0000, 'ºC'),
	(152580, 120, '2014-01-15 00:57:44.000000', 'temperatura', 1198.0000, 'ºC'),
	(152581, 120, '2014-01-15 00:57:45.000000', 'temperatura', 146.0000, 'ºC'),
	(152582, 120, '2014-01-15 00:57:46.000000', 'temperatura', 734.0000, 'ºC'),
	(152583, 120, '2014-01-15 00:57:47.000000', 'temperatura', 835.0000, 'ºC'),
	(152584, 120, '2014-01-15 00:57:48.000000', 'temperatura', 773.0000, 'ºC'),
	(152585, 120, '2014-01-15 00:57:49.000000', 'temperatura', 160.0000, 'ºC'),
	(152586, 120, '2014-01-15 00:57:50.000000', 'temperatura', 880.0000, 'ºC'),
	(152587, 120, '2014-01-15 00:57:51.000000', 'temperatura', 323.0000, 'ºC'),
	(152588, 120, '2014-01-15 00:57:52.000000', 'temperatura', 173.0000, 'ºC'),
	(152589, 120, '2014-01-15 00:57:53.000000', 'temperatura', 1096.0000, 'ºC'),
	(152590, 120, '2014-01-15 00:57:54.000000', 'temperatura', 161.0000, 'ºC'),
	(152591, 120, '2014-01-15 00:57:55.000000', 'temperatura', 1117.0000, 'ºC'),
	(152592, 120, '2014-01-15 00:57:56.000000', 'temperatura', 305.0000, 'ºC'),
	(152593, 120, '2014-01-15 00:57:57.000000', 'temperatura', 575.0000, 'ºC'),
	(152594, 120, '2014-01-15 00:57:58.000000', 'temperatura', 761.0000, 'ºC'),
	(152595, 120, '2014-01-15 00:57:59.000000', 'temperatura', 877.0000, 'ºC'),
	(152596, 120, '2014-01-15 00:58:00.000000', 'temperatura', 906.0000, 'ºC'),
	(152597, 120, '2014-01-15 00:58:01.000000', 'temperatura', 699.0000, 'ºC'),
	(152598, 120, '2014-01-15 00:58:02.000000', 'temperatura', 776.0000, 'ºC'),
	(152599, 120, '2014-01-15 00:58:03.000000', 'temperatura', 583.0000, 'ºC'),
	(152600, 120, '2014-01-15 00:58:04.000000', 'temperatura', 589.0000, 'ºC'),
	(152601, 120, '2014-01-15 00:58:05.000000', 'temperatura', 1196.0000, 'ºC'),
	(152602, 120, '2014-01-15 00:58:06.000000', 'temperatura', 615.0000, 'ºC'),
	(152603, 120, '2014-01-15 00:58:07.000000', 'temperatura', 686.0000, 'ºC'),
	(152604, 120, '2014-01-15 00:58:08.000000', 'temperatura', 386.0000, 'ºC'),
	(152605, 120, '2014-01-15 00:58:09.000000', 'temperatura', 1071.0000, 'ºC'),
	(152606, 120, '2014-01-15 00:58:10.000000', 'temperatura', 600.0000, 'ºC'),
	(152607, 120, '2014-01-15 00:58:11.000000', 'temperatura', 985.0000, 'ºC'),
	(152608, 120, '2014-01-15 00:58:12.000000', 'temperatura', 726.0000, 'ºC'),
	(152609, 120, '2014-01-15 00:58:13.000000', 'temperatura', 677.0000, 'ºC'),
	(152610, 120, '2014-01-15 00:58:14.000000', 'temperatura', 8.0000, 'ºC'),
	(152611, 120, '2014-01-15 00:58:15.000000', 'temperatura', 410.0000, 'ºC'),
	(152612, 120, '2014-01-15 00:58:16.000000', 'temperatura', 826.0000, 'ºC'),
	(152613, 120, '2014-01-15 00:58:17.000000', 'temperatura', 501.0000, 'ºC'),
	(152614, 120, '2014-01-15 00:58:18.000000', 'temperatura', 25.0000, 'ºC'),
	(152615, 120, '2014-01-15 00:58:19.000000', 'temperatura', 1025.0000, 'ºC'),
	(152616, 120, '2014-01-15 00:58:20.000000', 'temperatura', 250.0000, 'ºC'),
	(152617, 120, '2014-01-15 00:58:21.000000', 'temperatura', 574.0000, 'ºC'),
	(152618, 120, '2014-01-15 00:58:22.000000', 'temperatura', 922.0000, 'ºC'),
	(152619, 120, '2014-01-15 00:58:23.000000', 'temperatura', 486.0000, 'ºC'),
	(152620, 120, '2014-01-15 00:58:24.000000', 'temperatura', 866.0000, 'ºC'),
	(152621, 120, '2014-01-15 00:58:25.000000', 'temperatura', 473.0000, 'ºC'),
	(152622, 120, '2014-01-15 00:58:26.000000', 'temperatura', 968.0000, 'ºC'),
	(152623, 120, '2014-01-15 00:58:27.000000', 'temperatura', 1023.0000, 'ºC'),
	(152624, 120, '2014-01-15 00:58:28.000000', 'temperatura', 1009.0000, 'ºC'),
	(152625, 120, '2014-01-15 00:58:29.000000', 'temperatura', 779.0000, 'ºC'),
	(152626, 120, '2014-01-15 00:58:30.000000', 'temperatura', 866.0000, 'ºC'),
	(152627, 120, '2014-01-15 00:58:31.000000', 'temperatura', 796.0000, 'ºC'),
	(152628, 120, '2014-01-15 00:58:32.000000', 'temperatura', 183.0000, 'ºC'),
	(152629, 120, '2014-01-15 00:58:33.000000', 'temperatura', 924.0000, 'ºC'),
	(152630, 120, '2014-01-15 00:58:34.000000', 'temperatura', 474.0000, 'ºC'),
	(152631, 120, '2014-01-15 00:58:35.000000', 'temperatura', 798.0000, 'ºC'),
	(152632, 120, '2014-01-15 00:58:36.000000', 'temperatura', 170.0000, 'ºC'),
	(152633, 120, '2014-01-15 00:58:37.000000', 'temperatura', 855.0000, 'ºC'),
	(152634, 120, '2014-01-15 00:58:38.000000', 'temperatura', 165.0000, 'ºC'),
	(152635, 120, '2014-01-15 00:58:39.000000', 'temperatura', 663.0000, 'ºC'),
	(152636, 120, '2014-01-15 00:58:40.000000', 'temperatura', 417.0000, 'ºC'),
	(152637, 120, '2014-01-15 00:58:41.000000', 'temperatura', 98.0000, 'ºC'),
	(152638, 120, '2014-01-15 00:58:42.000000', 'temperatura', 441.0000, 'ºC'),
	(152639, 120, '2014-01-15 00:58:43.000000', 'temperatura', 711.0000, 'ºC'),
	(152640, 120, '2014-01-15 00:58:44.000000', 'temperatura', 1033.0000, 'ºC'),
	(152641, 120, '2014-01-15 00:58:45.000000', 'temperatura', 631.0000, 'ºC'),
	(152642, 120, '2014-01-15 00:58:46.000000', 'temperatura', 56.0000, 'ºC'),
	(152643, 120, '2014-01-15 00:58:47.000000', 'temperatura', 789.0000, 'ºC'),
	(152644, 120, '2014-01-15 00:58:48.000000', 'temperatura', 179.0000, 'ºC'),
	(152645, 120, '2014-01-15 00:58:49.000000', 'temperatura', 925.0000, 'ºC'),
	(152646, 120, '2014-01-15 00:58:50.000000', 'temperatura', 492.0000, 'ºC'),
	(152647, 120, '2014-01-15 00:58:51.000000', 'temperatura', 883.0000, 'ºC'),
	(152648, 120, '2014-01-15 00:58:52.000000', 'temperatura', 538.0000, 'ºC'),
	(152649, 120, '2014-01-15 00:58:53.000000', 'temperatura', 44.0000, 'ºC'),
	(152650, 120, '2014-01-15 00:58:54.000000', 'temperatura', 1007.0000, 'ºC'),
	(152651, 120, '2014-01-15 00:58:55.000000', 'temperatura', 104.0000, 'ºC'),
	(152652, 120, '2014-01-15 00:58:56.000000', 'temperatura', 1097.0000, 'ºC'),
	(152653, 120, '2014-01-15 00:58:57.000000', 'temperatura', 376.0000, 'ºC'),
	(152654, 120, '2014-01-15 00:58:58.000000', 'temperatura', 987.0000, 'ºC'),
	(152655, 120, '2014-01-15 00:58:59.000000', 'temperatura', 208.0000, 'ºC'),
	(152656, 120, '2014-01-15 00:59:00.000000', 'temperatura', 478.0000, 'ºC'),
	(152657, 120, '2014-01-15 00:59:01.000000', 'temperatura', 568.0000, 'ºC'),
	(152658, 120, '2014-01-15 00:59:02.000000', 'temperatura', 206.0000, 'ºC'),
	(152659, 120, '2014-01-15 00:59:03.000000', 'temperatura', 526.0000, 'ºC'),
	(152660, 120, '2014-01-15 00:59:04.000000', 'temperatura', 814.0000, 'ºC'),
	(152661, 120, '2014-01-15 00:59:05.000000', 'temperatura', 93.0000, 'ºC'),
	(152662, 120, '2014-01-15 00:59:06.000000', 'temperatura', 424.0000, 'ºC'),
	(152663, 120, '2014-01-15 00:59:07.000000', 'temperatura', 642.0000, 'ºC'),
	(152664, 120, '2014-01-15 00:59:08.000000', 'temperatura', 737.0000, 'ºC'),
	(152665, 120, '2014-01-15 00:59:09.000000', 'temperatura', 559.0000, 'ºC'),
	(152666, 120, '2014-01-15 00:59:10.000000', 'temperatura', 584.0000, 'ºC'),
	(152667, 120, '2014-01-15 00:59:11.000000', 'temperatura', 44.0000, 'ºC'),
	(152668, 120, '2014-01-15 00:59:12.000000', 'temperatura', 870.0000, 'ºC'),
	(152669, 120, '2014-01-15 00:59:13.000000', 'temperatura', 619.0000, 'ºC'),
	(152670, 120, '2014-01-15 00:59:14.000000', 'temperatura', 486.0000, 'ºC'),
	(152671, 120, '2014-01-15 00:59:15.000000', 'temperatura', 574.0000, 'ºC'),
	(152672, 120, '2014-01-15 00:59:16.000000', 'temperatura', 210.0000, 'ºC'),
	(152673, 120, '2014-01-15 00:59:17.000000', 'temperatura', 529.0000, 'ºC'),
	(152674, 120, '2014-01-15 00:59:18.000000', 'temperatura', 818.0000, 'ºC'),
	(152675, 120, '2014-01-15 00:59:19.000000', 'temperatura', 102.0000, 'ºC'),
	(152676, 120, '2014-01-15 00:59:20.000000', 'temperatura', 455.0000, 'ºC'),
	(152677, 120, '2014-01-15 00:59:21.000000', 'temperatura', 770.0000, 'ºC'),
	(152678, 120, '2014-01-15 00:59:22.000000', 'temperatura', 85.0000, 'ºC'),
	(152679, 120, '2014-01-15 00:59:23.000000', 'temperatura', 516.0000, 'ºC'),
	(152680, 120, '2014-01-15 00:59:24.000000', 'temperatura', 1127.0000, 'ºC'),
	(152681, 120, '2014-01-15 00:59:25.000000', 'temperatura', 487.0000, 'ºC'),
	(152682, 120, '2014-01-15 00:59:26.000000', 'temperatura', 255.0000, 'ºC'),
	(152683, 120, '2014-01-15 00:59:27.000000', 'temperatura', 1015.0000, 'ºC'),
	(152684, 120, '2014-01-15 00:59:28.000000', 'temperatura', 710.0000, 'ºC'),
	(152685, 120, '2014-01-15 00:59:29.000000', 'temperatura', 506.0000, 'ºC'),
	(152686, 120, '2014-01-15 00:59:30.000000', 'temperatura', 400.0000, 'ºC'),
	(152687, 120, '2014-01-15 00:59:31.000000', 'temperatura', 484.0000, 'ºC'),
	(152688, 120, '2014-01-15 00:59:32.000000', 'temperatura', 19.0000, 'ºC'),
	(152689, 120, '2014-01-15 00:59:33.000000', 'temperatura', 1042.0000, 'ºC'),
	(152690, 120, '2014-01-15 00:59:34.000000', 'temperatura', 355.0000, 'ºC'),
	(152691, 120, '2014-01-15 00:59:35.000000', 'temperatura', 1048.0000, 'ºC'),
	(152692, 120, '2014-01-15 00:59:36.000000', 'temperatura', 575.0000, 'ºC'),
	(152693, 120, '2014-01-15 00:59:37.000000', 'temperatura', 934.0000, 'ºC'),
	(152694, 120, '2014-01-15 00:59:38.000000', 'temperatura', 546.0000, 'ºC'),
	(152695, 120, '2014-01-15 00:59:39.000000', 'temperatura', 1128.0000, 'ºC'),
	(152696, 120, '2014-01-15 00:59:40.000000', 'temperatura', 404.0000, 'ºC'),
	(152697, 120, '2014-01-15 00:59:41.000000', 'temperatura', 1034.0000, 'ºC'),
	(152698, 120, '2014-01-15 00:59:42.000000', 'temperatura', 360.0000, 'ºC'),
	(152699, 120, '2014-01-15 00:59:43.000000', 'temperatura', 1097.0000, 'ºC'),
	(152700, 120, '2014-01-15 00:59:44.000000', 'temperatura', 808.0000, 'ºC'),
	(152701, 120, '2014-01-15 00:59:45.000000', 'temperatura', 747.0000, 'ºC'),
	(152702, 120, '2014-01-15 00:59:46.000000', 'temperatura', 114.0000, 'ºC'),
	(152703, 120, '2014-01-15 00:59:47.000000', 'temperatura', 729.0000, 'ºC'),
	(152704, 120, '2014-01-15 00:59:48.000000', 'temperatura', 903.0000, 'ºC'),
	(152705, 120, '2014-01-15 00:59:49.000000', 'temperatura', 1129.0000, 'ºC'),
	(152706, 120, '2014-01-15 00:59:50.000000', 'temperatura', 537.0000, 'ºC'),
	(152707, 120, '2014-01-15 00:59:51.000000', 'temperatura', 499.0000, 'ºC'),
	(152708, 120, '2014-01-15 00:59:52.000000', 'temperatura', 882.0000, 'ºC'),
	(152709, 120, '2014-01-15 00:59:53.000000', 'temperatura', 516.0000, 'ºC'),
	(152710, 120, '2014-01-15 00:59:54.000000', 'temperatura', 1133.0000, 'ºC'),
	(152711, 120, '2014-01-15 00:59:55.000000', 'temperatura', 517.0000, 'ºC'),
	(152712, 120, '2014-01-15 00:59:56.000000', 'temperatura', 389.0000, 'ºC'),
	(152713, 120, '2014-01-15 00:59:57.000000', 'temperatura', 392.0000, 'ºC'),
	(152714, 120, '2014-01-15 00:59:58.000000', 'temperatura', 796.0000, 'ºC'),
	(152715, 120, '2014-01-15 00:59:59.000000', 'temperatura', 405.0000, 'ºC'),
	(152716, 120, '2014-01-15 01:00:00.000000', 'temperatura', 835.0000, 'ºC'),
	(152717, 120, '2014-01-15 01:00:01.000000', 'temperatura', 560.0000, 'ºC'),
	(152718, 120, '2014-01-15 01:00:02.000000', 'temperatura', 295.0000, 'ºC'),
	(152719, 120, '2014-01-15 01:00:03.000000', 'temperatura', 998.0000, 'ºC'),
	(152720, 120, '2014-01-15 01:00:04.000000', 'temperatura', 506.0000, 'ºC'),
	(152721, 120, '2014-01-15 01:00:05.000000', 'temperatura', 737.0000, 'ºC'),
	(152722, 120, '2014-01-15 01:00:06.000000', 'temperatura', 966.0000, 'ºC'),
	(152723, 120, '2014-01-15 01:00:07.000000', 'temperatura', 222.0000, 'ºC'),
	(152724, 120, '2014-01-15 01:00:08.000000', 'temperatura', 610.0000, 'ºC'),
	(152725, 120, '2014-01-15 01:00:09.000000', 'temperatura', 1186.0000, 'ºC'),
	(152726, 120, '2014-01-15 01:00:10.000000', 'temperatura', 501.0000, 'ºC'),
	(152727, 120, '2014-01-15 01:00:11.000000', 'temperatura', 145.0000, 'ºC'),
	(152728, 120, '2014-01-15 01:00:12.000000', 'temperatura', 424.0000, 'ºC'),
	(152729, 120, '2014-01-15 01:00:13.000000', 'temperatura', 486.0000, 'ºC'),
	(152730, 120, '2014-01-15 01:00:14.000000', 'temperatura', 1159.0000, 'ºC'),
	(152731, 120, '2014-01-15 01:00:15.000000', 'temperatura', 736.0000, 'ºC'),
	(152732, 120, '2014-01-15 01:00:16.000000', 'temperatura', 205.0000, 'ºC'),
	(152733, 120, '2014-01-15 01:00:17.000000', 'temperatura', 19.0000, 'ºC'),
	(152734, 120, '2014-01-15 01:00:18.000000', 'temperatura', 678.0000, 'ºC'),
	(152735, 120, '2014-01-15 01:00:19.000000', 'temperatura', 934.0000, 'ºC'),
	(152736, 120, '2014-01-15 01:00:20.000000', 'temperatura', 237.0000, 'ºC'),
	(152737, 120, '2014-01-15 01:00:21.000000', 'temperatura', 784.0000, 'ºC'),
	(152738, 120, '2014-01-15 01:00:22.000000', 'temperatura', 810.0000, 'ºC'),
	(152739, 120, '2014-01-15 01:00:23.000000', 'temperatura', 500.0000, 'ºC'),
	(152740, 120, '2014-01-15 01:00:24.000000', 'temperatura', 68.0000, 'ºC'),
	(152741, 120, '2014-01-15 01:00:25.000000', 'temperatura', 39.0000, 'ºC'),
	(152742, 120, '2014-01-15 01:00:26.000000', 'temperatura', 1194.0000, 'ºC'),
	(152743, 120, '2014-01-15 01:00:27.000000', 'temperatura', 1051.0000, 'ºC'),
	(152744, 120, '2014-01-15 01:00:28.000000', 'temperatura', 474.0000, 'ºC'),
	(152745, 120, '2014-01-15 01:00:29.000000', 'temperatura', 419.0000, 'ºC'),
	(152746, 120, '2014-01-15 01:00:30.000000', 'temperatura', 671.0000, 'ºC'),
	(152747, 120, '2014-01-15 01:00:31.000000', 'temperatura', 900.0000, 'ºC'),
	(152748, 120, '2014-01-15 01:00:32.000000', 'temperatura', 88.0000, 'ºC'),
	(152749, 120, '2014-01-15 01:00:33.000000', 'temperatura', 138.0000, 'ºC'),
	(152750, 120, '2014-01-15 01:00:34.000000', 'temperatura', 428.0000, 'ºC'),
	(152751, 120, '2014-01-15 01:00:35.000000', 'temperatura', 525.0000, 'ºC'),
	(152752, 120, '2014-01-15 01:00:36.000000', 'temperatura', 143.0000, 'ºC'),
	(152753, 120, '2014-01-15 01:00:37.000000', 'temperatura', 340.0000, 'ºC'),
	(152754, 120, '2014-01-15 01:00:38.000000', 'temperatura', 73.0000, 'ºC'),
	(152755, 120, '2014-01-15 01:00:39.000000', 'temperatura', 545.0000, 'ºC'),
	(152756, 120, '2014-01-15 01:00:40.000000', 'temperatura', 105.0000, 'ºC'),
	(152757, 120, '2014-01-15 01:00:41.000000', 'temperatura', 91.0000, 'ºC'),
	(152758, 120, '2014-01-15 01:00:42.000000', 'temperatura', 140.0000, 'ºC'),
	(152759, 120, '2014-01-15 01:00:43.000000', 'temperatura', 427.0000, 'ºC'),
	(152760, 120, '2014-01-15 01:00:44.000000', 'temperatura', 515.0000, 'ºC'),
	(152761, 120, '2014-01-15 01:00:45.000000', 'temperatura', 96.0000, 'ºC'),
	(152762, 120, '2014-01-15 01:00:46.000000', 'temperatura', 133.0000, 'ºC'),
	(152763, 120, '2014-01-15 01:00:47.000000', 'temperatura', 380.0000, 'ºC'),
	(152764, 120, '2014-01-15 01:00:48.000000', 'temperatura', 300.0000, 'ºC'),
	(152765, 120, '2014-01-15 01:00:49.000000', 'temperatura', 361.0000, 'ºC'),
	(152766, 120, '2014-01-15 01:00:50.000000', 'temperatura', 905.0000, 'ºC'),
	(152767, 120, '2014-01-15 01:00:51.000000', 'temperatura', 1044.0000, 'ºC'),
	(152768, 120, '2014-01-15 01:00:52.000000', 'temperatura', 105.0000, 'ºC'),
	(152769, 120, '2014-01-15 01:00:53.000000', 'temperatura', 994.0000, 'ºC'),
	(152770, 120, '2014-01-15 01:00:54.000000', 'temperatura', 1055.0000, 'ºC'),
	(152771, 120, '2014-01-15 01:00:55.000000', 'temperatura', 1093.0000, 'ºC'),
	(152772, 120, '2014-01-15 01:00:56.000000', 'temperatura', 1101.0000, 'ºC'),
	(152773, 120, '2014-01-15 01:00:57.000000', 'temperatura', 1026.0000, 'ºC'),
	(152774, 120, '2014-01-15 01:00:58.000000', 'temperatura', 629.0000, 'ºC'),
	(152775, 120, '2014-01-15 01:00:59.000000', 'temperatura', 65.0000, 'ºC'),
	(152776, 120, '2014-01-15 01:01:00.000000', 'temperatura', 840.0000, 'ºC'),
	(152777, 120, '2014-01-15 01:01:01.000000', 'temperatura', 405.0000, 'ºC'),
	(152778, 120, '2014-01-15 01:01:02.000000', 'temperatura', 706.0000, 'ºC'),
	(152779, 120, '2014-01-15 01:01:03.000000', 'temperatura', 1116.0000, 'ºC'),
	(152780, 120, '2014-01-15 01:01:04.000000', 'temperatura', 1061.0000, 'ºC'),
	(152781, 120, '2014-01-15 01:01:05.000000', 'temperatura', 756.0000, 'ºC'),
	(152782, 120, '2014-01-15 01:01:06.000000', 'temperatura', 600.0000, 'ºC'),
	(152783, 120, '2014-01-15 01:01:07.000000', 'temperatura', 731.0000, 'ºC'),
	(152784, 120, '2014-01-15 01:01:08.000000', 'temperatura', 656.0000, 'ºC'),
	(152785, 120, '2014-01-15 01:01:09.000000', 'temperatura', 1088.0000, 'ºC'),
	(152786, 120, '2014-01-15 01:01:10.000000', 'temperatura', 1074.0000, 'ºC'),
	(152787, 120, '2014-01-15 01:01:11.000000', 'temperatura', 905.0000, 'ºC'),
	(152788, 120, '2014-01-15 01:01:12.000000', 'temperatura', 103.0000, 'ºC'),
	(152789, 120, '2014-01-15 01:01:13.000000', 'temperatura', 202.0000, 'ºC'),
	(152790, 120, '2014-01-15 01:01:14.000000', 'temperatura', 700.0000, 'ºC'),
	(152791, 120, '2014-01-15 01:01:15.000000', 'temperatura', 493.0000, 'ºC'),
	(152792, 120, '2014-01-15 01:01:16.000000', 'temperatura', 368.0000, 'ºC'),
	(152793, 120, '2014-01-15 01:01:17.000000', 'temperatura', 362.0000, 'ºC'),
	(152794, 120, '2014-01-15 01:01:18.000000', 'temperatura', 706.0000, 'ºC'),
	(152795, 120, '2014-01-15 01:01:19.000000', 'temperatura', 43.0000, 'ºC'),
	(152796, 120, '2014-01-15 01:01:20.000000', 'temperatura', 496.0000, 'ºC'),
	(152797, 120, '2014-01-15 01:01:21.000000', 'temperatura', 1155.0000, 'ºC'),
	(152798, 120, '2014-01-15 01:01:22.000000', 'temperatura', 685.0000, 'ºC'),
	(152799, 120, '2014-01-15 01:01:23.000000', 'temperatura', 1161.0000, 'ºC'),
	(152800, 120, '2014-01-15 01:01:24.000000', 'temperatura', 150.0000, 'ºC'),
	(152801, 120, '2014-01-15 01:01:25.000000', 'temperatura', 869.0000, 'ºC'),
	(152802, 120, '2014-01-15 01:01:26.000000', 'temperatura', 294.0000, 'ºC'),
	(152803, 120, '2014-01-15 01:01:27.000000', 'temperatura', 63.0000, 'ºC'),
	(152804, 120, '2014-01-15 01:01:28.000000', 'temperatura', 634.0000, 'ºC'),
	(152805, 120, '2014-01-15 01:01:29.000000', 'temperatura', 583.0000, 'ºC'),
	(152806, 120, '2014-01-15 01:01:30.000000', 'temperatura', 1014.0000, 'ºC'),
	(152807, 120, '2014-01-15 01:01:31.000000', 'temperatura', 922.0000, 'ºC'),
	(152808, 120, '2014-01-15 01:01:32.000000', 'temperatura', 368.0000, 'ºC'),
	(152809, 120, '2014-01-15 01:01:33.000000', 'temperatura', 272.0000, 'ºC'),
	(152810, 120, '2014-01-15 01:01:34.000000', 'temperatura', 258.0000, 'ºC'),
	(152811, 120, '2014-01-15 01:01:35.000000', 'temperatura', 476.0000, 'ºC'),
	(152812, 120, '2014-01-15 01:01:36.000000', 'temperatura', 404.0000, 'ºC'),
	(152813, 120, '2014-01-15 01:01:37.000000', 'temperatura', 594.0000, 'ºC'),
	(152814, 120, '2014-01-15 01:01:38.000000', 'temperatura', 558.0000, 'ºC'),
	(152815, 120, '2014-01-15 01:01:39.000000', 'temperatura', 1009.0000, 'ºC'),
	(152816, 120, '2014-01-15 01:01:40.000000', 'temperatura', 969.0000, 'ºC'),
	(152817, 120, '2014-01-15 01:01:41.000000', 'temperatura', 621.0000, 'ºC'),
	(152818, 120, '2014-01-15 01:01:42.000000', 'temperatura', 198.0000, 'ºC'),
	(152819, 120, '2014-01-15 01:01:43.000000', 'temperatura', 328.0000, 'ºC'),
	(152820, 120, '2014-01-15 01:01:44.000000', 'temperatura', 1045.0000, 'ºC'),
	(152821, 120, '2014-01-15 01:01:45.000000', 'temperatura', 641.0000, 'ºC'),
	(152822, 120, '2014-01-15 01:01:46.000000', 'temperatura', 73.0000, 'ºC'),
	(152823, 120, '2014-01-15 01:01:47.000000', 'temperatura', 841.0000, 'ºC'),
	(152824, 120, '2014-01-15 01:01:48.000000', 'temperatura', 386.0000, 'ºC'),
	(152825, 120, '2014-01-15 01:01:49.000000', 'temperatura', 606.0000, 'ºC'),
	(152826, 120, '2014-01-15 01:01:50.000000', 'temperatura', 673.0000, 'ºC'),
	(152827, 120, '2014-01-15 01:01:51.000000', 'temperatura', 350.0000, 'ºC'),
	(152828, 120, '2014-01-15 01:01:52.000000', 'temperatura', 930.0000, 'ºC'),
	(152829, 120, '2014-01-15 01:01:53.000000', 'temperatura', 1199.0000, 'ºC'),
	(152830, 120, '2014-01-15 01:01:54.000000', 'temperatura', 807.0000, 'ºC'),
	(152831, 120, '2014-01-15 01:01:55.000000', 'temperatura', 437.0000, 'ºC'),
	(152832, 120, '2014-01-15 01:01:56.000000', 'temperatura', 964.0000, 'ºC'),
	(152833, 120, '2014-01-15 01:01:57.000000', 'temperatura', 1112.0000, 'ºC'),
	(152834, 120, '2014-01-15 01:01:58.000000', 'temperatura', 269.0000, 'ºC'),
	(152835, 120, '2014-01-15 01:01:59.000000', 'temperatura', 409.0000, 'ºC'),
	(152836, 120, '2014-01-15 01:02:00.000000', 'temperatura', 36.0000, 'ºC'),
	(152837, 120, '2014-01-15 01:02:01.000000', 'temperatura', 156.0000, 'ºC'),
	(152838, 120, '2014-01-15 01:02:02.000000', 'temperatura', 672.0000, 'ºC'),
	(152839, 120, '2014-01-15 01:02:03.000000', 'temperatura', 494.0000, 'ºC'),
	(152840, 120, '2014-01-15 01:02:04.000000', 'temperatura', 454.0000, 'ºC'),
	(152841, 120, '2014-01-15 01:02:05.000000', 'temperatura', 790.0000, 'ºC'),
	(152842, 120, '2014-01-15 01:02:06.000000', 'temperatura', 185.0000, 'ºC'),
	(152843, 120, '2014-01-15 01:02:07.000000', 'temperatura', 958.0000, 'ºC'),
	(152844, 120, '2014-01-15 01:02:08.000000', 'temperatura', 636.0000, 'ºC'),
	(152845, 120, '2014-01-15 01:02:09.000000', 'temperatura', 304.0000, 'ºC'),
	(152846, 120, '2014-01-15 01:02:10.000000', 'temperatura', 815.0000, 'ºC'),
	(152847, 120, '2014-01-15 01:02:11.000000', 'temperatura', 763.0000, 'ºC'),
	(152848, 120, '2014-01-15 01:02:12.000000', 'temperatura', 172.0000, 'ºC'),
	(152849, 120, '2014-01-15 01:02:13.000000', 'temperatura', 968.0000, 'ºC'),
	(152850, 120, '2014-01-15 01:02:14.000000', 'temperatura', 728.0000, 'ºC'),
	(152851, 120, '2014-01-15 01:02:15.000000', 'temperatura', 735.0000, 'ºC'),
	(152852, 120, '2014-01-15 01:02:16.000000', 'temperatura', 291.0000, 'ºC'),
	(152853, 120, '2014-01-15 01:02:17.000000', 'temperatura', 449.0000, 'ºC'),
	(152854, 120, '2014-01-15 01:02:18.000000', 'temperatura', 175.0000, 'ºC'),
	(152855, 120, '2014-01-15 01:02:19.000000', 'temperatura', 726.0000, 'ºC'),
	(152856, 120, '2014-01-15 01:02:20.000000', 'temperatura', 706.0000, 'ºC'),
	(152857, 120, '2014-01-15 01:02:21.000000', 'temperatura', 153.0000, 'ºC'),
	(152858, 120, '2014-01-15 01:02:22.000000', 'temperatura', 1048.0000, 'ºC'),
	(152859, 120, '2014-01-15 01:02:23.000000', 'temperatura', 1180.0000, 'ºC'),
	(152860, 120, '2014-01-15 01:02:24.000000', 'temperatura', 356.0000, 'ºC'),
	(152861, 120, '2014-01-15 01:02:25.000000', 'temperatura', 640.0000, 'ºC'),
	(152862, 120, '2014-01-15 01:02:26.000000', 'temperatura', 932.0000, 'ºC'),
	(152863, 120, '2014-01-15 01:02:27.000000', 'temperatura', 342.0000, 'ºC'),
	(152864, 120, '2014-01-15 01:02:28.000000', 'temperatura', 116.0000, 'ºC'),
	(152865, 120, '2014-01-15 01:02:29.000000', 'temperatura', 752.0000, 'ºC'),
	(152866, 120, '2014-01-15 01:02:30.000000', 'temperatura', 1015.0000, 'ºC'),
	(152867, 120, '2014-01-15 01:02:31.000000', 'temperatura', 420.0000, 'ºC'),
	(152868, 120, '2014-01-15 01:02:32.000000', 'temperatura', 254.0000, 'ºC'),
	(152869, 120, '2014-01-15 01:02:33.000000', 'temperatura', 12.0000, 'ºC'),
	(152870, 120, '2014-01-15 01:02:34.000000', 'temperatura', 499.0000, 'ºC'),
	(152871, 120, '2014-01-15 01:02:35.000000', 'temperatura', 59.0000, 'ºC'),
	(152872, 120, '2014-01-15 01:02:36.000000', 'temperatura', 0.0000, 'ºC'),
	(152873, 120, '2014-01-15 01:02:37.000000', 'temperatura', 1022.0000, 'ºC'),
	(152874, 120, '2014-01-15 01:02:38.000000', 'temperatura', 309.0000, 'ºC'),
	(152875, 120, '2014-01-15 01:02:39.000000', 'temperatura', 879.0000, 'ºC'),
	(152876, 120, '2014-01-15 01:02:40.000000', 'temperatura', 1069.0000, 'ºC'),
	(152877, 120, '2014-01-15 01:02:41.000000', 'temperatura', 309.0000, 'ºC'),
	(152878, 120, '2014-01-15 01:02:42.000000', 'temperatura', 739.0000, 'ºC'),
	(152879, 120, '2014-01-15 01:02:43.000000', 'temperatura', 370.0000, 'ºC'),
	(152880, 120, '2014-01-15 01:02:44.000000', 'temperatura', 833.0000, 'ºC'),
	(152881, 120, '2014-01-15 01:02:45.000000', 'temperatura', 653.0000, 'ºC'),
	(152882, 120, '2014-01-15 01:02:46.000000', 'temperatura', 768.0000, 'ºC'),
	(152883, 120, '2014-01-15 01:02:47.000000', 'temperatura', 683.0000, 'ºC'),
	(152884, 120, '2014-01-15 01:02:48.000000', 'temperatura', 1112.0000, 'ºC'),
	(152885, 120, '2014-01-15 01:02:49.000000', 'temperatura', 1110.0000, 'ºC'),
	(152886, 120, '2014-01-15 01:02:50.000000', 'temperatura', 1014.0000, 'ºC'),
	(152887, 120, '2014-01-15 01:02:51.000000', 'temperatura', 543.0000, 'ºC'),
	(152888, 120, '2014-01-15 01:02:52.000000', 'temperatura', 871.0000, 'ºC'),
	(152889, 120, '2014-01-15 01:02:53.000000', 'temperatura', 326.0000, 'ºC'),
	(152890, 120, '2014-01-15 01:02:54.000000', 'temperatura', 217.0000, 'ºC'),
	(152891, 120, '2014-01-15 01:02:55.000000', 'temperatura', 109.0000, 'ºC'),
	(152892, 120, '2014-01-15 01:02:56.000000', 'temperatura', 1096.0000, 'ºC'),
	(152893, 120, '2014-01-15 01:02:57.000000', 'temperatura', 351.0000, 'ºC'),
	(152894, 120, '2014-01-15 01:02:58.000000', 'temperatura', 870.0000, 'ºC'),
	(152895, 120, '2014-01-15 01:02:59.000000', 'temperatura', 897.0000, 'ºC'),
	(152896, 120, '2014-01-15 01:03:00.000000', 'temperatura', 675.0000, 'ºC'),
	(152897, 120, '2014-01-15 01:03:01.000000', 'temperatura', 684.0000, 'ºC'),
	(152898, 120, '2014-01-15 01:03:02.000000', 'temperatura', 197.0000, 'ºC'),
	(152899, 120, '2014-01-15 01:03:03.000000', 'temperatura', 131.0000, 'ºC'),
	(152900, 120, '2014-01-15 01:03:04.000000', 'temperatura', 67.0000, 'ºC'),
	(152901, 120, '2014-01-15 01:03:05.000000', 'temperatura', 1142.0000, 'ºC'),
	(152902, 120, '2014-01-15 01:03:06.000000', 'temperatura', 709.0000, 'ºC'),
	(152903, 120, '2014-01-15 01:03:07.000000', 'temperatura', 121.0000, 'ºC'),
	(152904, 120, '2014-01-15 01:03:08.000000', 'temperatura', 876.0000, 'ºC'),
	(152905, 120, '2014-01-15 01:03:09.000000', 'temperatura', 418.0000, 'ºC'),
	(152906, 120, '2014-01-15 01:03:10.000000', 'temperatura', 663.0000, 'ºC'),
	(152907, 120, '2014-01-15 01:03:11.000000', 'temperatura', 862.0000, 'ºC'),
	(152908, 120, '2014-01-15 01:03:12.000000', 'temperatura', 1123.0000, 'ºC'),
	(152909, 120, '2014-01-15 01:03:13.000000', 'temperatura', 627.0000, 'ºC'),
	(152910, 120, '2014-01-15 01:03:14.000000', 'temperatura', 967.0000, 'ºC'),
	(152911, 120, '2014-01-15 01:03:15.000000', 'temperatura', 554.0000, 'ºC'),
	(152912, 120, '2014-01-15 01:03:16.000000', 'temperatura', 1070.0000, 'ºC'),
	(152913, 120, '2014-01-15 01:03:17.000000', 'temperatura', 87.0000, 'ºC'),
	(152914, 120, '2014-01-15 01:03:18.000000', 'temperatura', 826.0000, 'ºC'),
	(152915, 120, '2014-01-15 01:03:19.000000', 'temperatura', 269.0000, 'ºC'),
	(152916, 120, '2014-01-15 01:03:20.000000', 'temperatura', 69.0000, 'ºC'),
	(152917, 120, '2014-01-15 01:03:21.000000', 'temperatura', 737.0000, 'ºC'),
	(152918, 120, '2014-01-15 01:03:22.000000', 'temperatura', 1081.0000, 'ºC'),
	(152919, 120, '2014-01-15 01:03:23.000000', 'temperatura', 792.0000, 'ºC'),
	(152920, 120, '2014-01-15 01:03:24.000000', 'temperatura', 719.0000, 'ºC'),
	(152921, 120, '2014-01-15 01:03:25.000000', 'temperatura', 20.0000, 'ºC'),
	(152922, 120, '2014-01-15 01:03:26.000000', 'temperatura', 341.0000, 'ºC'),
	(152923, 120, '2014-01-15 01:03:27.000000', 'temperatura', 447.0000, 'ºC'),
	(152924, 120, '2014-01-15 01:03:28.000000', 'temperatura', 13.0000, 'ºC'),
	(152925, 120, '2014-01-15 01:03:29.000000', 'temperatura', 1123.0000, 'ºC'),
	(152926, 120, '2014-01-15 01:03:30.000000', 'temperatura', 778.0000, 'ºC'),
	(152927, 120, '2014-01-15 01:03:31.000000', 'temperatura', 519.0000, 'ºC'),
	(152928, 120, '2014-01-15 01:03:32.000000', 'temperatura', 265.0000, 'ºC'),
	(152929, 120, '2014-01-15 01:03:33.000000', 'temperatura', 966.0000, 'ºC'),
	(152930, 120, '2014-01-15 01:03:34.000000', 'temperatura', 437.0000, 'ºC'),
	(152931, 120, '2014-01-15 01:03:35.000000', 'temperatura', 488.0000, 'ºC'),
	(152932, 120, '2014-01-15 01:03:36.000000', 'temperatura', 1131.0000, 'ºC'),
	(152933, 120, '2014-01-15 01:03:37.000000', 'temperatura', 589.0000, 'ºC'),
	(152934, 120, '2014-01-15 01:03:38.000000', 'temperatura', 754.0000, 'ºC'),
	(152935, 120, '2014-01-15 01:03:39.000000', 'temperatura', 802.0000, 'ºC'),
	(152936, 120, '2014-01-15 01:03:40.000000', 'temperatura', 548.0000, 'ºC'),
	(152937, 120, '2014-01-15 01:03:41.000000', 'temperatura', 335.0000, 'ºC'),
	(152938, 120, '2014-01-15 01:03:42.000000', 'temperatura', 30.0000, 'ºC'),
	(152939, 120, '2014-01-15 01:03:43.000000', 'temperatura', 347.0000, 'ºC'),
	(152940, 120, '2014-01-15 01:03:44.000000', 'temperatura', 446.0000, 'ºC'),
	(152941, 120, '2014-01-15 01:03:45.000000', 'temperatura', 1189.0000, 'ºC'),
	(152942, 120, '2014-01-15 01:03:46.000000', 'temperatura', 1008.0000, 'ºC'),
	(152943, 120, '2014-01-15 01:03:47.000000', 'temperatura', 274.0000, 'ºC'),
	(152944, 120, '2014-01-15 01:03:48.000000', 'temperatura', 746.0000, 'ºC'),
	(152945, 120, '2014-01-15 01:03:49.000000', 'temperatura', 509.0000, 'ºC'),
	(152946, 120, '2014-01-15 01:03:50.000000', 'temperatura', 309.0000, 'ºC'),
	(152947, 120, '2014-01-15 01:03:51.000000', 'temperatura', 18.0000, 'ºC'),
	(152948, 120, '2014-01-15 01:03:52.000000', 'temperatura', 362.0000, 'ºC'),
	(152949, 120, '2014-01-15 01:03:53.000000', 'temperatura', 555.0000, 'ºC'),
	(152950, 120, '2014-01-15 01:03:54.000000', 'temperatura', 492.0000, 'ºC'),
	(152951, 120, '2014-01-15 01:03:55.000000', 'temperatura', 793.0000, 'ºC'),
	(152952, 120, '2014-01-15 01:03:56.000000', 'temperatura', 89.0000, 'ºC'),
	(152953, 120, '2014-01-15 01:03:57.000000', 'temperatura', 469.0000, 'ºC'),
	(152954, 120, '2014-01-15 01:03:58.000000', 'temperatura', 877.0000, 'ºC'),
	(152955, 120, '2014-01-15 01:03:59.000000', 'temperatura', 579.0000, 'ºC'),
	(152956, 120, '2014-01-15 01:04:00.000000', 'temperatura', 263.0000, 'ºC'),
	(152957, 120, '2014-01-15 01:04:01.000000', 'temperatura', 781.0000, 'ºC'),
	(152958, 120, '2014-01-15 01:04:02.000000', 'temperatura', 717.0000, 'ºC'),
	(152959, 120, '2014-01-15 01:04:03.000000', 'temperatura', 42.0000, 'ºC'),
	(152960, 120, '2014-01-15 01:04:04.000000', 'temperatura', 459.0000, 'ºC'),
	(152961, 120, '2014-01-15 01:04:05.000000', 'temperatura', 969.0000, 'ºC'),
	(152962, 120, '2014-01-15 01:04:06.000000', 'temperatura', 1069.0000, 'ºC'),
	(152963, 120, '2014-01-15 01:04:07.000000', 'temperatura', 38.0000, 'ºC'),
	(152964, 120, '2014-01-15 01:04:08.000000', 'temperatura', 583.0000, 'ºC'),
	(152965, 120, '2014-01-15 01:04:09.000000', 'temperatura', 402.0000, 'ºC'),
	(152966, 120, '2014-01-15 01:04:10.000000', 'temperatura', 260.0000, 'ºC'),
	(152967, 120, '2014-01-15 01:04:11.000000', 'temperatura', 97.0000, 'ºC'),
	(152968, 120, '2014-01-15 01:04:12.000000', 'temperatura', 905.0000, 'ºC'),
	(152969, 120, '2014-01-15 01:04:13.000000', 'temperatura', 632.0000, 'ºC'),
	(152970, 120, '2014-01-15 01:04:14.000000', 'temperatura', 449.0000, 'ºC'),
	(152971, 120, '2014-01-15 01:04:15.000000', 'temperatura', 347.0000, 'ºC'),
	(152972, 120, '2014-01-15 01:04:16.000000', 'temperatura', 390.0000, 'ºC'),
	(152973, 120, '2014-01-15 01:04:17.000000', 'temperatura', 908.0000, 'ºC'),
	(152974, 120, '2014-01-15 01:04:18.000000', 'temperatura', 970.0000, 'ºC'),
	(152975, 120, '2014-01-15 01:04:19.000000', 'temperatura', 925.0000, 'ºC'),
	(152976, 120, '2014-01-15 01:04:20.000000', 'temperatura', 518.0000, 'ºC'),
	(152977, 120, '2014-01-15 01:04:21.000000', 'temperatura', 1016.0000, 'ºC'),
	(152978, 120, '2014-01-15 01:04:22.000000', 'temperatura', 1124.0000, 'ºC'),
	(152979, 120, '2014-01-15 01:04:23.000000', 'temperatura', 174.0000, 'ºC'),
	(152980, 120, '2014-01-15 01:04:24.000000', 'temperatura', 1099.0000, 'ºC'),
	(152981, 120, '2014-01-15 01:04:25.000000', 'temperatura', 172.0000, 'ºC'),
	(152982, 120, '2014-01-15 01:04:26.000000', 'temperatura', 1165.0000, 'ºC'),
	(152983, 120, '2014-01-15 01:04:27.000000', 'temperatura', 508.0000, 'ºC'),
	(152984, 120, '2014-01-15 01:04:28.000000', 'temperatura', 248.0000, 'ºC'),
	(152985, 120, '2014-01-15 01:04:29.000000', 'temperatura', 916.0000, 'ºC'),
	(152986, 120, '2014-01-15 01:04:30.000000', 'temperatura', 237.0000, 'ºC'),
	(152987, 120, '2014-01-15 01:04:31.000000', 'temperatura', 836.0000, 'ºC'),
	(152988, 120, '2014-01-15 01:04:32.000000', 'temperatura', 1068.0000, 'ºC'),
	(152989, 120, '2014-01-15 01:04:33.000000', 'temperatura', 434.0000, 'ºC'),
	(152990, 120, '2014-01-15 01:04:34.000000', 'temperatura', 168.0000, 'ºC'),
	(152991, 120, '2014-01-15 01:04:35.000000', 'temperatura', 736.0000, 'ºC'),
	(152992, 120, '2014-01-15 01:04:36.000000', 'temperatura', 777.0000, 'ºC'),
	(152993, 120, '2014-01-15 01:04:37.000000', 'temperatura', 479.0000, 'ºC'),
	(152994, 120, '2014-01-15 01:04:38.000000', 'temperatura', 62.0000, 'ºC'),
	(152995, 120, '2014-01-15 01:04:39.000000', 'temperatura', 74.0000, 'ºC'),
	(152996, 120, '2014-01-15 01:04:40.000000', 'temperatura', 184.0000, 'ºC'),
	(152997, 120, '2014-01-15 01:04:41.000000', 'temperatura', 697.0000, 'ºC'),
	(152998, 120, '2014-01-15 01:04:42.000000', 'temperatura', 536.0000, 'ºC'),
	(152999, 120, '2014-01-15 01:04:43.000000', 'temperatura', 590.0000, 'ºC'),
	(153000, 120, '2014-01-15 01:04:44.000000', 'temperatura', 143.0000, 'ºC'),
	(153001, 120, '2014-01-15 01:04:45.000000', 'temperatura', 144.0000, 'ºC'),
	(153002, 120, '2014-01-15 01:04:46.000000', 'temperatura', 290.0000, 'ºC'),
	(153003, 120, '2014-01-15 01:04:47.000000', 'temperatura', 1019.0000, 'ºC'),
	(153004, 120, '2014-01-15 01:04:48.000000', 'temperatura', 627.0000, 'ºC'),
	(153005, 120, '2014-01-15 01:04:49.000000', 'temperatura', 76.0000, 'ºC'),
	(153006, 120, '2014-01-15 01:04:50.000000', 'temperatura', 901.0000, 'ºC'),
	(153007, 120, '2014-01-15 01:04:51.000000', 'temperatura', 678.0000, 'ºC'),
	(153008, 120, '2014-01-15 01:04:52.000000', 'temperatura', 688.0000, 'ºC'),
	(153009, 120, '2014-01-15 01:04:53.000000', 'temperatura', 205.0000, 'ºC'),
	(153010, 120, '2014-01-15 01:04:54.000000', 'temperatura', 160.0000, 'ºC'),
	(153011, 120, '2014-01-15 01:04:55.000000', 'temperatura', 189.0000, 'ºC'),
	(153012, 120, '2014-01-15 01:04:56.000000', 'temperatura', 464.0000, 'ºC'),
	(153013, 120, '2014-01-15 01:04:57.000000', 'temperatura', 555.0000, 'ºC'),
	(153014, 120, '2014-01-15 01:04:58.000000', 'temperatura', 182.0000, 'ºC'),
	(153015, 120, '2014-01-15 01:04:59.000000', 'temperatura', 445.0000, 'ºC'),
	(153016, 120, '2014-01-15 01:05:00.000000', 'temperatura', 479.0000, 'ºC'),
	(153017, 120, '2014-01-15 01:05:01.000000', 'temperatura', 1063.0000, 'ºC'),
	(153018, 120, '2014-01-15 01:05:02.000000', 'temperatura', 278.0000, 'ºC'),
	(153019, 120, '2014-01-15 01:05:03.000000', 'temperatura', 602.0000, 'ºC'),
	(153020, 120, '2014-01-15 01:05:04.000000', 'temperatura', 974.0000, 'ºC'),
	(153021, 120, '2014-01-15 01:05:05.000000', 'temperatura', 668.0000, 'ºC'),
	(153022, 120, '2014-01-15 01:05:06.000000', 'temperatura', 415.0000, 'ºC'),
	(153023, 120, '2014-01-15 01:05:07.000000', 'temperatura', 74.0000, 'ºC'),
	(153024, 120, '2014-01-15 01:05:08.000000', 'temperatura', 324.0000, 'ºC'),
	(153025, 120, '2014-01-15 01:05:09.000000', 'temperatura', 200.0000, 'ºC'),
	(153026, 120, '2014-01-15 01:05:10.000000', 'temperatura', 29.0000, 'ºC'),
	(153027, 120, '2014-01-15 01:05:11.000000', 'temperatura', 743.0000, 'ºC'),
	(153028, 120, '2014-01-15 01:05:12.000000', 'temperatura', 31.0000, 'ºC'),
	(153029, 120, '2014-01-15 01:05:13.000000', 'temperatura', 326.0000, 'ºC'),
	(153030, 120, '2014-01-15 01:05:14.000000', 'temperatura', 337.0000, 'ºC'),
	(153031, 120, '2014-01-15 01:05:15.000000', 'temperatura', 708.0000, 'ºC'),
	(153032, 120, '2014-01-15 01:05:16.000000', 'temperatura', 131.0000, 'ºC'),
	(153033, 120, '2014-01-15 01:05:17.000000', 'temperatura', 930.0000, 'ºC'),
	(153034, 120, '2014-01-15 01:05:18.000000', 'temperatura', 657.0000, 'ºC'),
	(153035, 120, '2014-01-15 01:05:19.000000', 'temperatura', 497.0000, 'ºC'),
	(153036, 120, '2014-01-15 01:05:20.000000', 'temperatura', 514.0000, 'ºC'),
	(153037, 120, '2014-01-15 01:05:21.000000', 'temperatura', 1081.0000, 'ºC'),
	(153038, 120, '2014-01-15 01:05:22.000000', 'temperatura', 263.0000, 'ºC'),
	(153039, 120, '2014-01-15 01:05:23.000000', 'temperatura', 471.0000, 'ºC'),
	(153040, 120, '2014-01-15 01:05:24.000000', 'temperatura', 365.0000, 'ºC'),
	(153041, 120, '2014-01-15 01:05:25.000000', 'temperatura', 415.0000, 'ºC'),
	(153042, 120, '2014-01-15 01:05:26.000000', 'temperatura', 979.0000, 'ºC'),
	(153043, 120, '2014-01-15 01:05:27.000000', 'temperatura', 52.0000, 'ºC'),
	(153044, 120, '2014-01-15 01:05:28.000000', 'temperatura', 923.0000, 'ºC'),
	(153045, 120, '2014-01-15 01:05:29.000000', 'temperatura', 858.0000, 'ºC'),
	(153046, 120, '2014-01-15 01:05:30.000000', 'temperatura', 325.0000, 'ºC'),
	(153047, 120, '2014-01-15 01:05:31.000000', 'temperatura', 248.0000, 'ºC'),
	(153048, 120, '2014-01-15 01:05:32.000000', 'temperatura', 265.0000, 'ºC'),
	(153049, 120, '2014-01-15 01:05:33.000000', 'temperatura', 585.0000, 'ºC'),
	(153050, 120, '2014-01-15 01:05:34.000000', 'temperatura', 927.0000, 'ºC'),
	(153051, 120, '2014-01-15 01:05:35.000000', 'temperatura', 483.0000, 'ºC'),
	(153052, 120, '2014-01-15 01:05:36.000000', 'temperatura', 832.0000, 'ºC'),
	(153053, 120, '2014-01-15 01:05:37.000000', 'temperatura', 312.0000, 'ºC'),
	(153054, 120, '2014-01-15 01:05:38.000000', 'temperatura', 263.0000, 'ºC'),
	(153055, 120, '2014-01-15 01:05:39.000000', 'temperatura', 383.0000, 'ºC'),
	(153056, 120, '2014-01-15 01:05:40.000000', 'temperatura', 1124.0000, 'ºC'),
	(153057, 120, '2014-01-15 01:05:41.000000', 'temperatura', 871.0000, 'ºC'),
	(153058, 120, '2014-01-15 01:05:42.000000', 'temperatura', 985.0000, 'ºC'),
	(153059, 120, '2014-01-15 01:05:43.000000', 'temperatura', 1111.0000, 'ºC'),
	(153060, 120, '2014-01-15 01:05:44.000000', 'temperatura', 202.0000, 'ºC'),
	(153061, 120, '2014-01-15 01:05:45.000000', 'temperatura', 78.0000, 'ºC'),
	(153062, 120, '2014-01-15 01:05:46.000000', 'temperatura', 984.0000, 'ºC'),
	(153063, 120, '2014-01-15 01:05:47.000000', 'temperatura', 1085.0000, 'ºC'),
	(153064, 120, '2014-01-15 01:05:48.000000', 'temperatura', 73.0000, 'ºC'),
	(153065, 120, '2014-01-15 01:05:49.000000', 'temperatura', 712.0000, 'ºC'),
	(153066, 120, '2014-01-15 01:05:50.000000', 'temperatura', 940.0000, 'ºC'),
	(153067, 120, '2014-01-15 01:05:51.000000', 'temperatura', 165.0000, 'ºC'),
	(153068, 120, '2014-01-15 01:05:52.000000', 'temperatura', 406.0000, 'ºC'),
	(153069, 120, '2014-01-15 01:05:53.000000', 'temperatura', 337.0000, 'ºC'),
	(153070, 120, '2014-01-15 01:05:54.000000', 'temperatura', 465.0000, 'ºC'),
	(153071, 120, '2014-01-15 01:05:55.000000', 'temperatura', 117.0000, 'ºC'),
	(153072, 120, '2014-01-15 01:05:56.000000', 'temperatura', 389.0000, 'ºC'),
	(153073, 120, '2014-01-15 01:05:57.000000', 'temperatura', 394.0000, 'ºC'),
	(153074, 120, '2014-01-15 01:05:58.000000', 'temperatura', 803.0000, 'ºC'),
	(153075, 120, '2014-01-15 01:05:59.000000', 'temperatura', 436.0000, 'ºC'),
	(153076, 120, '2014-01-15 01:06:00.000000', 'temperatura', 972.0000, 'ºC'),
	(153077, 120, '2014-01-15 01:06:01.000000', 'temperatura', 1150.0000, 'ºC'),
	(153078, 120, '2014-01-15 01:06:02.000000', 'temperatura', 437.0000, 'ºC'),
	(153079, 120, '2014-01-15 01:06:03.000000', 'temperatura', 1133.0000, 'ºC'),
	(153080, 120, '2014-01-15 01:06:04.000000', 'temperatura', 753.0000, 'ºC'),
	(153081, 120, '2014-01-15 01:06:05.000000', 'temperatura', 370.0000, 'ºC'),
	(153082, 120, '2014-01-15 01:06:06.000000', 'temperatura', 790.0000, 'ºC'),
	(153083, 120, '2014-01-15 01:06:07.000000', 'temperatura', 441.0000, 'ºC'),
	(153084, 120, '2014-01-15 01:06:08.000000', 'temperatura', 1036.0000, 'ºC'),
	(153085, 120, '2014-01-15 01:06:09.000000', 'temperatura', 259.0000, 'ºC'),
	(153086, 120, '2014-01-15 01:06:10.000000', 'temperatura', 585.0000, 'ºC'),
	(153087, 120, '2014-01-15 01:06:11.000000', 'temperatura', 951.0000, 'ºC'),
	(153088, 120, '2014-01-15 01:06:12.000000', 'temperatura', 598.0000, 'ºC'),
	(153089, 120, '2014-01-15 01:06:13.000000', 'temperatura', 139.0000, 'ºC'),
	(153090, 120, '2014-01-15 01:06:14.000000', 'temperatura', 103.0000, 'ºC'),
	(153091, 120, '2014-01-15 01:06:15.000000', 'temperatura', 97.0000, 'ºC'),
	(153092, 120, '2014-01-15 01:06:16.000000', 'temperatura', 175.0000, 'ºC'),
	(153093, 120, '2014-01-15 01:06:17.000000', 'temperatura', 586.0000, 'ºC'),
	(153094, 120, '2014-01-15 01:06:18.000000', 'temperatura', 6.0000, 'ºC'),
	(153095, 120, '2014-01-15 01:06:19.000000', 'temperatura', 673.0000, 'ºC'),
	(153096, 120, '2014-01-15 01:06:20.000000', 'temperatura', 947.0000, 'ºC'),
	(153097, 120, '2014-01-15 01:06:21.000000', 'temperatura', 318.0000, 'ºC'),
	(153098, 120, '2014-01-15 01:06:22.000000', 'temperatura', 1150.0000, 'ºC'),
	(153099, 120, '2014-01-15 01:06:23.000000', 'temperatura', 1195.0000, 'ºC'),
	(153100, 120, '2014-01-15 01:06:24.000000', 'temperatura', 124.0000, 'ºC'),
	(153101, 120, '2014-01-15 01:06:25.000000', 'temperatura', 638.0000, 'ºC'),
	(153102, 120, '2014-01-15 01:06:26.000000', 'temperatura', 417.0000, 'ºC'),
	(153103, 120, '2014-01-15 01:06:27.000000', 'temperatura', 173.0000, 'ºC'),
	(153104, 120, '2014-01-15 01:06:28.000000', 'temperatura', 815.0000, 'ºC'),
	(153105, 120, '2014-01-15 01:06:29.000000', 'temperatura', 1154.0000, 'ºC'),
	(153106, 120, '2014-01-15 01:06:30.000000', 'temperatura', 925.0000, 'ºC'),
	(153107, 120, '2014-01-15 01:06:31.000000', 'temperatura', 1164.0000, 'ºC'),
	(153108, 120, '2014-01-15 01:06:32.000000', 'temperatura', 645.0000, 'ºC'),
	(153109, 120, '2014-01-15 01:06:33.000000', 'temperatura', 934.0000, 'ºC'),
	(153110, 120, '2014-01-15 01:06:34.000000', 'temperatura', 336.0000, 'ºC'),
	(153111, 120, '2014-01-15 01:06:35.000000', 'temperatura', 78.0000, 'ºC'),
	(153112, 120, '2014-01-15 01:06:36.000000', 'temperatura', 583.0000, 'ºC'),
	(153113, 120, '2014-01-15 01:06:37.000000', 'temperatura', 281.0000, 'ºC'),
	(153114, 120, '2014-01-15 01:06:38.000000', 'temperatura', 856.0000, 'ºC'),
	(153115, 120, '2014-01-15 01:06:39.000000', 'temperatura', 1036.0000, 'ºC'),
	(153116, 120, '2014-01-15 01:06:40.000000', 'temperatura', 215.0000, 'ºC'),
	(153117, 120, '2014-01-15 01:06:41.000000', 'temperatura', 365.0000, 'ºC'),
	(153118, 120, '2014-01-15 01:06:42.000000', 'temperatura', 1181.0000, 'ºC'),
	(153119, 120, '2014-01-15 01:06:43.000000', 'temperatura', 12.0000, 'ºC'),
	(153120, 120, '2014-01-15 01:06:44.000000', 'temperatura', 118.0000, 'ºC'),
	(153121, 120, '2014-01-15 01:06:45.000000', 'temperatura', 553.0000, 'ºC'),
	(153122, 120, '2014-01-15 01:06:46.000000', 'temperatura', 13.0000, 'ºC'),
	(153123, 120, '2014-01-15 01:06:47.000000', 'temperatura', 807.0000, 'ºC'),
	(153124, 120, '2014-01-15 01:06:48.000000', 'temperatura', 398.0000, 'ºC'),
	(153125, 120, '2014-01-15 01:06:49.000000', 'temperatura', 767.0000, 'ºC'),
	(153126, 120, '2014-01-15 01:06:50.000000', 'temperatura', 240.0000, 'ºC'),
	(153127, 120, '2014-01-15 01:06:51.000000', 'temperatura', 102.0000, 'ºC'),
	(153128, 120, '2014-01-15 01:06:52.000000', 'temperatura', 990.0000, 'ºC'),
	(153129, 120, '2014-01-15 01:06:53.000000', 'temperatura', 1043.0000, 'ºC'),
	(153130, 120, '2014-01-15 01:06:54.000000', 'temperatura', 1045.0000, 'ºC'),
	(153131, 120, '2014-01-15 01:06:55.000000', 'temperatura', 896.0000, 'ºC'),
	(153132, 120, '2014-01-15 01:06:56.000000', 'temperatura', 148.0000, 'ºC'),
	(153133, 120, '2014-01-15 01:06:57.000000', 'temperatura', 453.0000, 'ºC'),
	(153134, 120, '2014-01-15 01:06:58.000000', 'temperatura', 622.0000, 'ºC'),
	(153135, 120, '2014-01-15 01:06:59.000000', 'temperatura', 548.0000, 'ºC'),
	(153136, 120, '2014-01-15 01:07:00.000000', 'temperatura', 878.0000, 'ºC'),
	(153137, 120, '2014-01-15 01:07:01.000000', 'temperatura', 343.0000, 'ºC'),
	(153138, 120, '2014-01-15 01:07:02.000000', 'temperatura', 285.0000, 'ºC'),
	(153139, 120, '2014-01-15 01:07:03.000000', 'temperatura', 395.0000, 'ºC'),
	(153140, 120, '2014-01-15 01:07:04.000000', 'temperatura', 1121.0000, 'ºC'),
	(153141, 120, '2014-01-15 01:07:05.000000', 'temperatura', 818.0000, 'ºC'),
	(153142, 120, '2014-01-15 01:07:06.000000', 'temperatura', 731.0000, 'ºC'),
	(153143, 120, '2014-01-15 01:07:07.000000', 'temperatura', 1199.0000, 'ºC'),
	(153144, 120, '2014-01-15 01:07:08.000000', 'temperatura', 202.0000, 'ºC'),
	(153145, 120, '2014-01-15 01:07:09.000000', 'temperatura', 1014.0000, 'ºC'),
	(153146, 120, '2014-01-15 01:07:10.000000', 'temperatura', 867.0000, 'ºC'),
	(153147, 120, '2014-01-15 01:07:11.000000', 'temperatura', 91.0000, 'ºC'),
	(153148, 120, '2014-01-15 01:07:12.000000', 'temperatura', 256.0000, 'ºC'),
	(153149, 120, '2014-01-15 01:07:13.000000', 'temperatura', 1005.0000, 'ºC'),
	(153150, 120, '2014-01-15 01:07:14.000000', 'temperatura', 660.0000, 'ºC'),
	(153151, 120, '2014-01-15 01:07:15.000000', 'temperatura', 284.0000, 'ºC'),
	(153152, 120, '2014-01-15 01:07:16.000000', 'temperatura', 642.0000, 'ºC'),
	(153153, 120, '2014-01-15 01:07:17.000000', 'temperatura', 1157.0000, 'ºC'),
	(153154, 120, '2014-01-15 01:07:18.000000', 'temperatura', 259.0000, 'ºC'),
	(153155, 120, '2014-01-15 01:07:19.000000', 'temperatura', 226.0000, 'ºC'),
	(153156, 120, '2014-01-15 01:07:20.000000', 'temperatura', 351.0000, 'ºC'),
	(153157, 120, '2014-01-15 01:07:21.000000', 'temperatura', 1080.0000, 'ºC'),
	(153158, 120, '2014-01-15 01:07:22.000000', 'temperatura', 748.0000, 'ºC'),
	(153159, 120, '2014-01-15 01:07:23.000000', 'temperatura', 501.0000, 'ºC'),
	(153160, 120, '2014-01-15 01:07:24.000000', 'temperatura', 259.0000, 'ºC'),
	(153161, 120, '2014-01-15 01:07:25.000000', 'temperatura', 994.0000, 'ºC'),
	(153162, 120, '2014-01-15 01:07:26.000000', 'temperatura', 595.0000, 'ºC'),
	(153163, 120, '2014-01-15 01:07:27.000000', 'temperatura', 1192.0000, 'ºC'),
	(153164, 120, '2014-01-15 01:07:28.000000', 'temperatura', 575.0000, 'ºC'),
	(153165, 120, '2014-01-15 01:07:29.000000', 'temperatura', 499.0000, 'ºC'),
	(153166, 120, '2014-01-15 01:07:30.000000', 'temperatura', 773.0000, 'ºC'),
	(153167, 120, '2014-01-15 01:07:31.000000', 'temperatura', 1166.0000, 'ºC'),
	(153168, 120, '2014-01-15 01:07:32.000000', 'temperatura', 1110.0000, 'ºC'),
	(153169, 120, '2014-01-15 01:07:33.000000', 'temperatura', 855.0000, 'ºC'),
	(153170, 120, '2014-01-15 01:07:34.000000', 'temperatura', 946.0000, 'ºC'),
	(153171, 120, '2014-01-15 01:07:35.000000', 'temperatura', 963.0000, 'ºC'),
	(153172, 120, '2014-01-15 01:07:36.000000', 'temperatura', 780.0000, 'ºC'),
	(153173, 120, '2014-01-15 01:07:37.000000', 'temperatura', 1011.0000, 'ºC'),
	(153174, 120, '2014-01-15 01:07:38.000000', 'temperatura', 313.0000, 'ºC'),
	(153175, 120, '2014-01-15 01:07:39.000000', 'temperatura', 936.0000, 'ºC'),
	(153176, 120, '2014-01-15 01:07:40.000000', 'temperatura', 140.0000, 'ºC'),
	(153177, 120, '2014-01-15 01:07:41.000000', 'temperatura', 293.0000, 'ºC'),
	(153178, 120, '2014-01-15 01:07:42.000000', 'temperatura', 1044.0000, 'ºC'),
	(153179, 120, '2014-01-15 01:07:43.000000', 'temperatura', 740.0000, 'ºC'),
	(153180, 120, '2014-01-15 01:07:44.000000', 'temperatura', 571.0000, 'ºC'),
	(153181, 120, '2014-01-15 01:07:45.000000', 'temperatura', 635.0000, 'ºC'),
	(153182, 120, '2014-01-15 01:07:46.000000', 'temperatura', 263.0000, 'ºC'),
	(153183, 120, '2014-01-15 01:07:47.000000', 'temperatura', 611.0000, 'ºC'),
	(153184, 120, '2014-01-15 01:07:48.000000', 'temperatura', 1064.0000, 'ºC'),
	(153185, 120, '2014-01-15 01:07:49.000000', 'temperatura', 1091.0000, 'ºC'),
	(153186, 120, '2014-01-15 01:07:50.000000', 'temperatura', 1060.0000, 'ºC'),
	(153187, 120, '2014-01-15 01:07:51.000000', 'temperatura', 830.0000, 'ºC'),
	(153188, 120, '2014-01-15 01:07:52.000000', 'temperatura', 970.0000, 'ºC'),
	(153189, 120, '2014-01-15 01:07:53.000000', 'temperatura', 1161.0000, 'ºC'),
	(153190, 120, '2014-01-15 01:07:54.000000', 'temperatura', 494.0000, 'ºC'),
	(153191, 120, '2014-01-15 01:07:55.000000', 'temperatura', 187.0000, 'ºC'),
	(153192, 120, '2014-01-15 01:07:56.000000', 'temperatura', 655.0000, 'ºC'),
	(153193, 120, '2014-01-15 01:07:57.000000', 'temperatura', 315.0000, 'ºC'),
	(153194, 120, '2014-01-15 01:07:58.000000', 'temperatura', 810.0000, 'ºC'),
	(153195, 120, '2014-01-15 01:07:59.000000', 'temperatura', 706.0000, 'ºC'),
	(153196, 120, '2014-01-15 01:08:00.000000', 'temperatura', 1102.0000, 'ºC'),
	(153197, 120, '2014-01-15 01:08:01.000000', 'temperatura', 990.0000, 'ºC'),
	(153198, 120, '2014-01-15 01:08:02.000000', 'temperatura', 446.0000, 'ºC'),
	(153199, 120, '2014-01-15 01:08:03.000000', 'temperatura', 462.0000, 'ºC'),
	(153200, 120, '2014-01-15 01:08:04.000000', 'temperatura', 970.0000, 'ºC'),
	(153201, 120, '2014-01-15 01:08:05.000000', 'temperatura', 1067.0000, 'ºC'),
	(153202, 120, '2014-01-15 01:08:06.000000', 'temperatura', 23.0000, 'ºC'),
	(153203, 120, '2014-01-15 01:08:07.000000', 'temperatura', 515.0000, 'ºC'),
	(153204, 120, '2014-01-15 01:08:08.000000', 'temperatura', 106.0000, 'ºC'),
	(153205, 120, '2014-01-15 01:08:09.000000', 'temperatura', 184.0000, 'ºC'),
	(153206, 120, '2014-01-15 01:08:10.000000', 'temperatura', 605.0000, 'ºC'),
	(153207, 120, '2014-01-15 01:08:11.000000', 'temperatura', 74.0000, 'ºC'),
	(153208, 120, '2014-01-15 01:08:12.000000', 'temperatura', 953.0000, 'ºC'),
	(153209, 120, '2014-01-15 01:08:13.000000', 'temperatura', 944.0000, 'ºC'),
	(153210, 120, '2014-01-15 01:08:14.000000', 'temperatura', 664.0000, 'ºC'),
	(153211, 120, '2014-01-15 01:08:15.000000', 'temperatura', 487.0000, 'ºC'),
	(153212, 120, '2014-01-15 01:08:16.000000', 'temperatura', 445.0000, 'ºC'),
	(153213, 120, '2014-01-15 01:08:17.000000', 'temperatura', 762.0000, 'ºC'),
	(153214, 120, '2014-01-15 01:08:18.000000', 'temperatura', 77.0000, 'ºC'),
	(153215, 120, '2014-01-15 01:08:19.000000', 'temperatura', 499.0000, 'ºC'),
	(153216, 120, '2014-01-15 01:08:20.000000', 'temperatura', 1066.0000, 'ºC'),
	(153217, 120, '2014-01-15 01:08:21.000000', 'temperatura', 231.0000, 'ºC'),
	(153218, 120, '2014-01-15 01:08:22.000000', 'temperatura', 360.0000, 'ºC'),
	(153219, 120, '2014-01-15 01:08:23.000000', 'temperatura', 1105.0000, 'ºC'),
	(153220, 120, '2014-01-15 01:08:24.000000', 'temperatura', 848.0000, 'ºC'),
	(153221, 120, '2014-01-15 01:08:25.000000', 'temperatura', 924.0000, 'ºC'),
	(153222, 120, '2014-01-15 01:08:26.000000', 'temperatura', 877.0000, 'ºC'),
	(153223, 120, '2014-01-15 01:08:27.000000', 'temperatura', 414.0000, 'ºC'),
	(153224, 120, '2014-01-15 01:08:28.000000', 'temperatura', 641.0000, 'ºC'),
	(153225, 120, '2014-01-15 01:08:29.000000', 'temperatura', 760.0000, 'ºC'),
	(153226, 120, '2014-01-15 01:08:30.000000', 'temperatura', 681.0000, 'ºC'),
	(153227, 120, '2014-01-15 01:08:31.000000', 'temperatura', 1122.0000, 'ºC'),
	(153228, 120, '2014-01-15 01:08:32.000000', 'temperatura', 1169.0000, 'ºC'),
	(153229, 120, '2014-01-15 01:08:33.000000', 'temperatura', 81.0000, 'ºC'),
	(153230, 120, '2014-01-15 01:08:34.000000', 'temperatura', 499.0000, 'ºC'),
	(153231, 120, '2014-01-15 01:08:35.000000', 'temperatura', 1050.0000, 'ºC'),
	(153232, 120, '2014-01-15 01:08:36.000000', 'temperatura', 154.0000, 'ºC'),
	(153233, 120, '2014-01-15 01:08:37.000000', 'temperatura', 21.0000, 'ºC'),
	(153234, 120, '2014-01-15 01:08:38.000000', 'temperatura', 843.0000, 'ºC'),
	(153235, 120, '2014-01-15 01:08:39.000000', 'temperatura', 552.0000, 'ºC'),
	(153236, 120, '2014-01-15 01:08:40.000000', 'temperatura', 231.0000, 'ºC'),
	(153237, 120, '2014-01-15 01:08:41.000000', 'temperatura', 698.0000, 'ºC'),
	(153238, 120, '2014-01-15 01:08:42.000000', 'temperatura', 400.0000, 'ºC'),
	(153239, 120, '2014-01-15 01:08:43.000000', 'temperatura', 1106.0000, 'ºC'),
	(153240, 120, '2014-01-15 01:08:44.000000', 'temperatura', 732.0000, 'ºC'),
	(153241, 120, '2014-01-15 01:08:45.000000', 'temperatura', 341.0000, 'ºC'),
	(153242, 120, '2014-01-15 01:08:46.000000', 'temperatura', 710.0000, 'ºC'),
	(153243, 120, '2014-01-15 01:08:47.000000', 'temperatura', 127.0000, 'ºC'),
	(153244, 120, '2014-01-15 01:08:48.000000', 'temperatura', 904.0000, 'ºC'),
	(153245, 120, '2014-01-15 01:08:49.000000', 'temperatura', 542.0000, 'ºC'),
	(153246, 120, '2014-01-15 01:08:50.000000', 'temperatura', 1199.0000, 'ºC'),
	(153247, 120, '2014-01-15 01:08:51.000000', 'temperatura', 770.0000, 'ºC'),
	(153248, 120, '2014-01-15 01:08:52.000000', 'temperatura', 251.0000, 'ºC'),
	(153249, 120, '2014-01-15 01:08:53.000000', 'temperatura', 147.0000, 'ºC'),
	(153250, 120, '2014-01-15 01:08:54.000000', 'temperatura', 1180.0000, 'ºC'),
	(153251, 120, '2014-01-15 01:08:55.000000', 'temperatura', 662.0000, 'ºC'),
	(153252, 120, '2014-01-15 01:08:56.000000', 'temperatura', 972.0000, 'ºC'),
	(153253, 120, '2014-01-15 01:08:57.000000', 'temperatura', 472.0000, 'ºC'),
	(153254, 120, '2014-01-15 01:08:58.000000', 'temperatura', 647.0000, 'ºC'),
	(153255, 120, '2014-01-15 01:08:59.000000', 'temperatura', 616.0000, 'ºC'),
	(153256, 120, '2014-01-15 01:09:00.000000', 'temperatura', 1143.0000, 'ºC'),
	(153257, 120, '2014-01-15 01:09:01.000000', 'temperatura', 264.0000, 'ºC'),
	(153258, 120, '2014-01-15 01:09:02.000000', 'temperatura', 295.0000, 'ºC'),
	(153259, 120, '2014-01-15 01:09:03.000000', 'temperatura', 680.0000, 'ºC'),
	(153260, 120, '2014-01-15 01:09:04.000000', 'temperatura', 118.0000, 'ºC'),
	(153261, 120, '2014-01-15 01:09:05.000000', 'temperatura', 949.0000, 'ºC'),
	(153262, 120, '2014-01-15 01:09:06.000000', 'temperatura', 794.0000, 'ºC'),
	(153263, 120, '2014-01-15 01:09:07.000000', 'temperatura', 1121.0000, 'ºC'),
	(153264, 120, '2014-01-15 01:09:08.000000', 'temperatura', 822.0000, 'ºC'),
	(153265, 120, '2014-01-15 01:09:09.000000', 'temperatura', 751.0000, 'ºC'),
	(153266, 120, '2014-01-15 01:09:10.000000', 'temperatura', 88.0000, 'ºC'),
	(153267, 120, '2014-01-15 01:09:11.000000', 'temperatura', 587.0000, 'ºC'),
	(153268, 120, '2014-01-15 01:09:12.000000', 'temperatura', 274.0000, 'ºC'),
	(153269, 120, '2014-01-15 01:09:13.000000', 'temperatura', 808.0000, 'ºC'),
	(153270, 120, '2014-01-15 01:09:14.000000', 'temperatura', 817.0000, 'ºC'),
	(153271, 120, '2014-01-15 01:09:15.000000', 'temperatura', 464.0000, 'ºC'),
	(153272, 120, '2014-01-15 01:09:16.000000', 'temperatura', 1070.0000, 'ºC'),
	(153273, 120, '2014-01-15 01:09:17.000000', 'temperatura', 357.0000, 'ºC'),
	(153274, 120, '2014-01-15 01:09:18.000000', 'temperatura', 974.0000, 'ºC'),
	(153275, 120, '2014-01-15 01:09:19.000000', 'temperatura', 201.0000, 'ºC'),
	(153276, 120, '2014-01-15 01:09:20.000000', 'temperatura', 484.0000, 'ºC'),
	(153277, 120, '2014-01-15 01:09:21.000000', 'temperatura', 615.0000, 'ºC'),
	(153278, 120, '2014-01-15 01:09:22.000000', 'temperatura', 425.0000, 'ºC'),
	(153279, 120, '2014-01-15 01:09:23.000000', 'temperatura', 281.0000, 'ºC'),
	(153280, 120, '2014-01-15 01:09:24.000000', 'temperatura', 132.0000, 'ºC'),
	(153281, 120, '2014-01-15 01:09:25.000000', 'temperatura', 1016.0000, 'ºC'),
	(153282, 120, '2014-01-15 01:09:26.000000', 'temperatura', 1084.0000, 'ºC'),
	(153283, 120, '2014-01-15 01:09:27.000000', 'temperatura', 1175.0000, 'ºC'),
	(153284, 120, '2014-01-15 01:09:28.000000', 'temperatura', 220.0000, 'ºC'),
	(153285, 120, '2014-01-15 01:09:29.000000', 'temperatura', 1179.0000, 'ºC'),
	(153286, 120, '2014-01-15 01:09:30.000000', 'temperatura', 434.0000, 'ºC'),
	(153287, 120, '2014-01-15 01:09:31.000000', 'temperatura', 1032.0000, 'ºC'),
	(153288, 120, '2014-01-15 01:09:32.000000', 'temperatura', 262.0000, 'ºC'),
	(153289, 120, '2014-01-15 01:09:33.000000', 'temperatura', 611.0000, 'ºC'),
	(153290, 120, '2014-01-15 01:09:34.000000', 'temperatura', 1070.0000, 'ºC'),
	(153291, 120, '2014-01-15 01:09:35.000000', 'temperatura', 1120.0000, 'ºC'),
	(153292, 120, '2014-01-15 01:09:36.000000', 'temperatura', 1188.0000, 'ºC'),
	(153293, 120, '2014-01-15 01:09:37.000000', 'temperatura', 182.0000, 'ºC'),
	(153294, 120, '2014-01-15 01:09:38.000000', 'temperatura', 945.0000, 'ºC'),
	(153295, 120, '2014-01-15 01:09:39.000000', 'temperatura', 582.0000, 'ºC'),
	(153296, 120, '2014-01-15 01:09:40.000000', 'temperatura', 73.0000, 'ºC'),
	(153297, 120, '2014-01-15 01:09:41.000000', 'temperatura', 1021.0000, 'ºC'),
	(153298, 120, '2014-01-15 01:09:42.000000', 'temperatura', 84.0000, 'ºC'),
	(153299, 120, '2014-01-15 01:09:43.000000', 'temperatura', 960.0000, 'ºC'),
	(153300, 120, '2014-01-15 01:09:44.000000', 'temperatura', 948.0000, 'ºC'),
	(153301, 120, '2014-01-15 01:09:45.000000', 'temperatura', 660.0000, 'ºC'),
	(153302, 120, '2014-01-15 01:09:46.000000', 'temperatura', 456.0000, 'ºC'),
	(153303, 120, '2014-01-15 01:09:47.000000', 'temperatura', 302.0000, 'ºC'),
	(153304, 120, '2014-01-15 01:09:48.000000', 'temperatura', 142.0000, 'ºC'),
	(153305, 120, '2014-01-15 01:09:49.000000', 'temperatura', 1004.0000, 'ºC'),
	(153306, 120, '2014-01-15 01:09:50.000000', 'temperatura', 997.0000, 'ºC'),
	(153307, 120, '2014-01-15 01:09:51.000000', 'temperatura', 770.0000, 'ºC'),
	(153308, 120, '2014-01-15 01:09:52.000000', 'temperatura', 860.0000, 'ºC'),
	(153309, 120, '2014-01-15 01:09:53.000000', 'temperatura', 792.0000, 'ºC'),
	(153310, 120, '2014-01-15 01:09:54.000000', 'temperatura', 180.0000, 'ºC'),
	(153311, 120, '2014-01-15 01:09:55.000000', 'temperatura', 923.0000, 'ºC'),
	(153312, 120, '2014-01-15 01:09:56.000000', 'temperatura', 476.0000, 'ºC'),
	(153313, 120, '2014-01-15 01:09:57.000000', 'temperatura', 812.0000, 'ºC'),
	(153314, 120, '2014-01-15 01:09:58.000000', 'temperatura', 233.0000, 'ºC'),
	(153315, 120, '2014-01-15 01:09:59.000000', 'temperatura', 1130.0000, 'ºC'),
	(153316, 120, '2014-01-15 01:10:00.000000', 'temperatura', 152.0000, 'ºC'),
	(153317, 120, '2014-01-15 01:10:01.000000', 'temperatura', 970.0000, 'ºC'),
	(153318, 120, '2014-01-15 01:10:02.000000', 'temperatura', 793.0000, 'ºC'),
	(153319, 120, '2014-01-15 01:10:03.000000', 'temperatura', 1058.0000, 'ºC'),
	(153320, 120, '2014-01-15 01:10:04.000000', 'temperatura', 511.0000, 'ºC'),
	(153321, 120, '2014-01-15 01:10:05.000000', 'temperatura', 583.0000, 'ºC'),
	(153322, 120, '2014-01-15 01:10:06.000000', 'temperatura', 181.0000, 'ºC'),
	(153323, 120, '2014-01-15 01:10:07.000000', 'temperatura', 357.0000, 'ºC'),
	(153324, 120, '2014-01-15 01:10:08.000000', 'temperatura', 41.0000, 'ºC'),
	(153325, 120, '2014-01-15 01:10:09.000000', 'temperatura', 334.0000, 'ºC'),
	(153326, 120, '2014-01-15 01:10:10.000000', 'temperatura', 349.0000, 'ºC'),
	(153327, 120, '2014-01-15 01:10:11.000000', 'temperatura', 742.0000, 'ºC'),
	(153328, 120, '2014-01-15 01:10:12.000000', 'temperatura', 264.0000, 'ºC'),
	(153329, 120, '2014-01-15 01:10:13.000000', 'temperatura', 297.0000, 'ºC'),
	(153330, 120, '2014-01-15 01:10:14.000000', 'temperatura', 690.0000, 'ºC'),
	(153331, 120, '2014-01-15 01:10:15.000000', 'temperatura', 161.0000, 'ºC'),
	(153332, 120, '2014-01-15 01:10:16.000000', 'temperatura', 1136.0000, 'ºC'),
	(153333, 120, '2014-01-15 01:10:17.000000', 'temperatura', 397.0000, 'ºC'),
	(153334, 120, '2014-01-15 01:10:18.000000', 'temperatura', 978.0000, 'ºC'),
	(153335, 120, '2014-01-15 01:10:19.000000', 'temperatura', 99.0000, 'ºC'),
	(153336, 120, '2014-01-15 01:10:20.000000', 'temperatura', 1160.0000, 'ºC'),
	(153337, 120, '2014-01-15 01:10:21.000000', 'temperatura', 702.0000, 'ºC'),
	(153338, 120, '2014-01-15 01:10:22.000000', 'temperatura', 34.0000, 'ºC'),
	(153339, 120, '2014-01-15 01:10:23.000000', 'temperatura', 465.0000, 'ºC'),
	(153340, 120, '2014-01-15 01:10:24.000000', 'temperatura', 1023.0000, 'ºC'),
	(153341, 120, '2014-01-15 01:10:25.000000', 'temperatura', 121.0000, 'ºC'),
	(153342, 120, '2014-01-15 01:10:26.000000', 'temperatura', 1135.0000, 'ºC'),
	(153343, 120, '2014-01-15 01:10:27.000000', 'temperatura', 513.0000, 'ºC'),
	(153344, 120, '2014-01-15 01:10:28.000000', 'temperatura', 359.0000, 'ºC'),
	(153345, 120, '2014-01-15 01:10:29.000000', 'temperatura', 258.0000, 'ºC'),
	(153346, 120, '2014-01-15 01:10:30.000000', 'temperatura', 214.0000, 'ºC'),
	(153347, 120, '2014-01-15 01:10:31.000000', 'temperatura', 294.0000, 'ºC'),
	(153348, 120, '2014-01-15 01:10:32.000000', 'temperatura', 830.0000, 'ºC'),
	(153349, 120, '2014-01-15 01:10:33.000000', 'temperatura', 869.0000, 'ºC'),
	(153350, 120, '2014-01-15 01:10:34.000000', 'temperatura', 654.0000, 'ºC'),
	(153351, 120, '2014-01-15 01:10:35.000000', 'temperatura', 666.0000, 'ºC'),
	(153352, 120, '2014-01-15 01:10:36.000000', 'temperatura', 167.0000, 'ºC'),
	(153353, 120, '2014-01-15 01:10:37.000000', 'temperatura', 37.0000, 'ºC'),
	(153354, 120, '2014-01-15 01:10:38.000000', 'temperatura', 886.0000, 'ºC'),
	(153355, 120, '2014-01-15 01:10:39.000000', 'temperatura', 720.0000, 'ºC'),
	(153356, 120, '2014-01-15 01:10:40.000000', 'temperatura', 943.0000, 'ºC'),
	(153357, 120, '2014-01-15 01:10:41.000000', 'temperatura', 155.0000, 'ºC'),
	(153358, 120, '2014-01-15 01:10:42.000000', 'temperatura', 346.0000, 'ºC'),
	(153359, 120, '2014-01-15 01:10:43.000000', 'temperatura', 65.0000, 'ºC'),
	(153360, 120, '2014-01-15 01:10:44.000000', 'temperatura', 489.0000, 'ºC'),
	(153361, 120, '2014-01-15 01:10:45.000000', 'temperatura', 1049.0000, 'ºC'),
	(153362, 120, '2014-01-15 01:10:46.000000', 'temperatura', 178.0000, 'ºC'),
	(153363, 120, '2014-01-15 01:10:47.000000', 'temperatura', 143.0000, 'ºC'),
	(153364, 120, '2014-01-15 01:10:48.000000', 'temperatura', 181.0000, 'ºC'),
	(153365, 120, '2014-01-15 01:10:49.000000', 'temperatura', 478.0000, 'ºC'),
	(153366, 120, '2014-01-15 01:10:50.000000', 'temperatura', 647.0000, 'ºC'),
	(153367, 120, '2014-01-15 01:10:51.000000', 'temperatura', 600.0000, 'ºC'),
	(153368, 120, '2014-01-15 01:10:52.000000', 'temperatura', 1061.0000, 'ºC'),
	(153369, 120, '2014-01-15 01:10:53.000000', 'temperatura', 1105.0000, 'ºC'),
	(153370, 120, '2014-01-15 01:10:54.000000', 'temperatura', 1142.0000, 'ºC'),
	(153371, 120, '2014-01-15 01:10:55.000000', 'temperatura', 1194.0000, 'ºC'),
	(153372, 120, '2014-01-15 01:10:56.000000', 'temperatura', 146.0000, 'ºC'),
	(153373, 120, '2014-01-15 01:10:57.000000', 'temperatura', 750.0000, 'ºC'),
	(153374, 120, '2014-01-15 01:10:58.000000', 'temperatura', 912.0000, 'ºC'),
	(153375, 120, '2014-01-15 01:10:59.000000', 'temperatura', 1110.0000, 'ºC'),
	(153376, 120, '2014-01-15 01:11:00.000000', 'temperatura', 416.0000, 'ºC'),
	(153377, 120, '2014-01-15 01:11:01.000000', 'temperatura', 1151.0000, 'ºC'),
	(153378, 120, '2014-01-15 01:11:02.000000', 'temperatura', 906.0000, 'ºC'),
	(153379, 120, '2014-01-15 01:11:03.000000', 'temperatura', 1079.0000, 'ºC'),
	(153380, 120, '2014-01-15 01:11:04.000000', 'temperatura', 275.0000, 'ºC'),
	(153381, 120, '2014-01-15 01:11:05.000000', 'temperatura', 541.0000, 'ºC'),
	(153382, 120, '2014-01-15 01:11:06.000000', 'temperatura', 678.0000, 'ºC'),
	(153383, 120, '2014-01-15 01:11:07.000000', 'temperatura', 568.0000, 'ºC'),
	(153384, 120, '2014-01-15 01:11:08.000000', 'temperatura', 805.0000, 'ºC'),
	(153385, 120, '2014-01-15 01:11:09.000000', 'temperatura', 1124.0000, 'ºC'),
	(153386, 120, '2014-01-15 01:11:10.000000', 'temperatura', 807.0000, 'ºC'),
	(153387, 120, '2014-01-15 01:11:11.000000', 'temperatura', 661.0000, 'ºC'),
	(153388, 120, '2014-01-15 01:11:12.000000', 'temperatura', 885.0000, 'ºC'),
	(153389, 120, '2014-01-15 01:11:13.000000', 'temperatura', 44.0000, 'ºC'),
	(153390, 120, '2014-01-15 01:11:14.000000', 'temperatura', 1163.0000, 'ºC'),
	(153391, 120, '2014-01-15 01:11:15.000000', 'temperatura', 886.0000, 'ºC'),
	(153392, 120, '2014-01-15 01:11:16.000000', 'temperatura', 940.0000, 'ºC'),
	(153393, 120, '2014-01-15 01:11:17.000000', 'temperatura', 844.0000, 'ºC'),
	(153394, 120, '2014-01-15 01:11:18.000000', 'temperatura', 198.0000, 'ºC'),
	(153395, 120, '2014-01-15 01:11:19.000000', 'temperatura', 858.0000, 'ºC'),
	(153396, 120, '2014-01-15 01:11:20.000000', 'temperatura', 98.0000, 'ºC'),
	(153397, 120, '2014-01-15 01:11:21.000000', 'temperatura', 316.0000, 'ºC'),
	(153398, 120, '2014-01-15 01:11:22.000000', 'temperatura', 87.0000, 'ºC'),
	(153399, 120, '2014-01-15 01:11:23.000000', 'temperatura', 687.0000, 'ºC'),
	(153400, 120, '2014-01-15 01:11:24.000000', 'temperatura', 775.0000, 'ºC'),
	(153401, 120, '2014-01-15 01:11:25.000000', 'temperatura', 616.0000, 'ºC'),
	(153402, 120, '2014-01-15 01:11:26.000000', 'temperatura', 753.0000, 'ºC'),
	(153403, 120, '2014-01-15 01:11:27.000000', 'temperatura', 718.0000, 'ºC'),
	(153404, 120, '2014-01-15 01:11:28.000000', 'temperatura', 133.0000, 'ºC'),
	(153405, 120, '2014-01-15 01:11:29.000000', 'temperatura', 912.0000, 'ºC'),
	(153406, 120, '2014-01-15 01:11:30.000000', 'temperatura', 559.0000, 'ºC'),
	(153407, 120, '2014-01-15 01:11:31.000000', 'temperatura', 62.0000, 'ºC'),
	(153408, 120, '2014-01-15 01:11:32.000000', 'temperatura', 1034.0000, 'ºC'),
	(153409, 120, '2014-01-15 01:11:33.000000', 'temperatura', 184.0000, 'ºC'),
	(153410, 120, '2014-01-15 01:11:34.000000', 'temperatura', 220.0000, 'ºC'),
	(153411, 120, '2014-01-15 01:11:35.000000', 'temperatura', 548.0000, 'ºC'),
	(153412, 120, '2014-01-15 01:11:36.000000', 'temperatura', 878.0000, 'ºC'),
	(153413, 120, '2014-01-15 01:11:37.000000', 'temperatura', 349.0000, 'ºC'),
	(153414, 120, '2014-01-15 01:11:38.000000', 'temperatura', 312.0000, 'ºC'),
	(153415, 120, '2014-01-15 01:11:39.000000', 'temperatura', 514.0000, 'ºC'),
	(153416, 120, '2014-01-15 01:11:40.000000', 'temperatura', 432.0000, 'ºC'),
	(153417, 120, '2014-01-15 01:11:41.000000', 'temperatura', 619.0000, 'ºC'),
	(153418, 120, '2014-01-15 01:11:42.000000', 'temperatura', 600.0000, 'ºC'),
	(153419, 120, '2014-01-15 01:11:43.000000', 'temperatura', 1143.0000, 'ºC'),
	(153420, 120, '2014-01-15 01:11:44.000000', 'temperatura', 315.0000, 'ºC'),
	(153421, 120, '2014-01-15 01:11:45.000000', 'temperatura', 547.0000, 'ºC'),
	(153422, 120, '2014-01-15 01:11:46.000000', 'temperatura', 590.0000, 'ºC'),
	(153423, 120, '2014-01-15 01:11:47.000000', 'temperatura', 109.0000, 'ºC'),
	(153424, 120, '2014-01-15 01:11:48.000000', 'temperatura', 1178.0000, 'ºC'),
	(153425, 120, '2014-01-15 01:11:49.000000', 'temperatura', 761.0000, 'ºC'),
	(153426, 120, '2014-01-15 01:11:50.000000', 'temperatura', 272.0000, 'ºC'),
	(153427, 120, '2014-01-15 01:11:51.000000', 'temperatura', 278.0000, 'ºC'),
	(153428, 120, '2014-01-15 01:11:52.000000', 'temperatura', 575.0000, 'ºC'),
	(153429, 120, '2014-01-15 01:11:53.000000', 'temperatura', 843.0000, 'ºC'),
	(153430, 120, '2014-01-15 01:11:54.000000', 'temperatura', 89.0000, 'ºC'),
	(153431, 120, '2014-01-15 01:11:55.000000', 'temperatura', 316.0000, 'ºC'),
	(153432, 120, '2014-01-15 01:11:56.000000', 'temperatura', 116.0000, 'ºC'),
	(153433, 120, '2014-01-15 01:11:57.000000', 'temperatura', 830.0000, 'ºC'),
	(153434, 120, '2014-01-15 01:11:58.000000', 'temperatura', 205.0000, 'ºC'),
	(153435, 120, '2014-01-15 01:11:59.000000', 'temperatura', 935.0000, 'ºC'),
	(153436, 120, '2014-01-15 01:12:00.000000', 'temperatura', 458.0000, 'ºC'),
	(153437, 120, '2014-01-15 01:12:01.000000', 'temperatura', 687.0000, 'ºC'),
	(153438, 120, '2014-01-15 01:12:02.000000', 'temperatura', 860.0000, 'ºC'),
	(153439, 120, '2014-01-15 01:12:03.000000', 'temperatura', 1041.0000, 'ºC'),
	(153440, 120, '2014-01-15 01:12:04.000000', 'temperatura', 226.0000, 'ºC'),
	(153441, 120, '2014-01-15 01:12:05.000000', 'temperatura', 406.0000, 'ºC'),
	(153442, 120, '2014-01-15 01:12:06.000000', 'temperatura', 155.0000, 'ºC'),
	(153443, 120, '2014-01-15 01:12:07.000000', 'temperatura', 755.0000, 'ºC'),
	(153444, 120, '2014-01-15 01:12:08.000000', 'temperatura', 913.0000, 'ºC'),
	(153445, 120, '2014-01-15 01:12:09.000000', 'temperatura', 1098.0000, 'ºC'),
	(153446, 120, '2014-01-15 01:12:10.000000', 'temperatura', 351.0000, 'ºC'),
	(153447, 120, '2014-01-15 01:12:11.000000', 'temperatura', 863.0000, 'ºC'),
	(153448, 120, '2014-01-15 01:12:12.000000', 'temperatura', 864.0000, 'ºC'),
	(153449, 120, '2014-01-15 01:12:13.000000', 'temperatura', 530.0000, 'ºC'),
	(153450, 120, '2014-01-15 01:12:14.000000', 'temperatura', 57.0000, 'ºC'),
	(153451, 120, '2014-01-15 01:12:15.000000', 'temperatura', 1096.0000, 'ºC'),
	(153452, 120, '2014-01-15 01:12:16.000000', 'temperatura', 511.0000, 'ºC'),
	(153453, 120, '2014-01-15 01:12:17.000000', 'temperatura', 467.0000, 'ºC'),
	(153454, 120, '2014-01-15 01:12:18.000000', 'temperatura', 801.0000, 'ºC'),
	(153455, 120, '2014-01-15 01:12:19.000000', 'temperatura', 207.0000, 'ºC'),
	(153456, 120, '2014-01-15 01:12:20.000000', 'temperatura', 1033.0000, 'ºC'),
	(153457, 120, '2014-01-15 01:12:21.000000', 'temperatura', 944.0000, 'ºC'),
	(153458, 120, '2014-01-15 01:12:22.000000', 'temperatura', 422.0000, 'ºC'),
	(153459, 120, '2014-01-15 01:12:23.000000', 'temperatura', 477.0000, 'ºC'),
	(153460, 120, '2014-01-15 01:12:24.000000', 'temperatura', 1122.0000, 'ºC'),
	(153461, 120, '2014-01-15 01:12:25.000000', 'temperatura', 578.0000, 'ºC'),
	(153462, 120, '2014-01-15 01:12:26.000000', 'temperatura', 725.0000, 'ºC'),
	(153463, 120, '2014-01-15 01:12:27.000000', 'temperatura', 691.0000, 'ºC'),
	(153464, 120, '2014-01-15 01:12:28.000000', 'temperatura', 82.0000, 'ºC'),
	(153465, 120, '2014-01-15 01:12:29.000000', 'temperatura', 736.0000, 'ºC'),
	(153466, 120, '2014-01-15 01:12:30.000000', 'temperatura', 1037.0000, 'ºC'),
	(153467, 120, '2014-01-15 01:12:31.000000', 'temperatura', 575.0000, 'ºC'),
	(153468, 120, '2014-01-15 01:12:32.000000', 'temperatura', 964.0000, 'ºC'),
	(153469, 120, '2014-01-15 01:12:33.000000', 'temperatura', 697.0000, 'ºC'),
	(153470, 120, '2014-01-15 01:12:34.000000', 'temperatura', 595.0000, 'ºC'),
	(153471, 120, '2014-01-15 01:12:35.000000', 'temperatura', 882.0000, 'ºC'),
	(153472, 120, '2014-01-15 01:12:36.000000', 'temperatura', 228.0000, 'ºC'),
	(153473, 120, '2014-01-15 01:12:37.000000', 'temperatura', 893.0000, 'ºC'),
	(153474, 120, '2014-01-15 01:12:38.000000', 'temperatura', 181.0000, 'ºC'),
	(153475, 120, '2014-01-15 01:12:39.000000', 'temperatura', 628.0000, 'ºC'),
	(153476, 120, '2014-01-15 01:12:40.000000', 'temperatura', 199.0000, 'ºC'),
	(153477, 120, '2014-01-15 01:12:41.000000', 'temperatura', 308.0000, 'ºC'),
	(153478, 120, '2014-01-15 01:12:42.000000', 'temperatura', 944.0000, 'ºC'),
	(153479, 120, '2014-01-15 01:12:43.000000', 'temperatura', 199.0000, 'ºC'),
	(153480, 120, '2014-01-15 01:12:44.000000', 'temperatura', 563.0000, 'ºC'),
	(153481, 120, '2014-01-15 01:12:45.000000', 'temperatura', 1018.0000, 'ºC'),
	(153482, 120, '2014-01-15 01:12:46.000000', 'temperatura', 1000.0000, 'ºC'),
	(153483, 120, '2014-01-15 01:12:47.000000', 'temperatura', 749.0000, 'ºC'),
	(153484, 120, '2014-01-15 01:12:48.000000', 'temperatura', 744.0000, 'ºC'),
	(153485, 120, '2014-01-15 01:12:49.000000', 'temperatura', 276.0000, 'ºC'),
	(153486, 120, '2014-01-15 01:12:50.000000', 'temperatura', 346.0000, 'ºC'),
	(153487, 120, '2014-01-15 01:12:51.000000', 'temperatura', 903.0000, 'ºC'),
	(153488, 120, '2014-01-15 01:12:52.000000', 'temperatura', 1079.0000, 'ºC'),
	(153489, 120, '2014-01-15 01:12:53.000000', 'temperatura', 285.0000, 'ºC'),
	(153490, 120, '2014-01-15 01:12:54.000000', 'temperatura', 590.0000, 'ºC'),
	(153491, 120, '2014-01-15 01:12:55.000000', 'temperatura', 893.0000, 'ºC'),
	(153492, 120, '2014-01-15 01:12:56.000000', 'temperatura', 297.0000, 'ºC'),
	(153493, 120, '2014-01-15 01:12:57.000000', 'temperatura', 7.0000, 'ºC'),
	(153494, 120, '2014-01-15 01:12:58.000000', 'temperatura', 346.0000, 'ºC'),
	(153495, 120, '2014-01-15 01:12:59.000000', 'temperatura', 508.0000, 'ºC'),
	(153496, 120, '2014-01-15 01:13:00.000000', 'temperatura', 302.0000, 'ºC'),
	(153497, 120, '2014-01-15 01:13:01.000000', 'temperatura', 1188.0000, 'ºC'),
	(153498, 120, '2014-01-15 01:13:02.000000', 'temperatura', 232.0000, 'ºC'),
	(153499, 120, '2014-01-15 01:13:03.000000', 'temperatura', 1198.0000, 'ºC'),
	(153500, 120, '2014-01-15 01:13:04.000000', 'temperatura', 493.0000, 'ºC'),
	(153501, 120, '2014-01-15 01:13:05.000000', 'temperatura', 72.0000, 'ºC'),
	(153502, 120, '2014-01-15 01:13:06.000000', 'temperatura', 80.0000, 'ºC'),
	(153503, 120, '2014-01-15 01:13:07.000000', 'temperatura', 186.0000, 'ºC'),
	(153504, 120, '2014-01-15 01:13:08.000000', 'temperatura', 691.0000, 'ºC'),
	(153505, 120, '2014-01-15 01:13:09.000000', 'temperatura', 495.0000, 'ºC'),
	(153506, 120, '2014-01-15 01:13:10.000000', 'temperatura', 404.0000, 'ºC'),
	(153507, 120, '2014-01-15 01:13:11.000000', 'temperatura', 538.0000, 'ºC'),
	(153508, 120, '2014-01-15 01:13:12.000000', 'temperatura', 275.0000, 'ºC'),
	(153509, 120, '2014-01-15 01:13:13.000000', 'temperatura', 962.0000, 'ºC'),
	(153510, 120, '2014-01-15 01:13:14.000000', 'temperatura', 384.0000, 'ºC'),
	(153511, 120, '2014-01-15 01:13:15.000000', 'temperatura', 237.0000, 'ºC'),
	(153512, 120, '2014-01-15 01:13:16.000000', 'temperatura', 32.0000, 'ºC'),
	(153513, 120, '2014-01-15 01:13:17.000000', 'temperatura', 649.0000, 'ºC'),
	(153514, 120, '2014-01-15 01:13:18.000000', 'temperatura', 751.0000, 'ºC'),
	(153515, 120, '2014-01-15 01:13:19.000000', 'temperatura', 610.0000, 'ºC'),
	(153516, 120, '2014-01-15 01:13:20.000000', 'temperatura', 796.0000, 'ºC'),
	(153517, 120, '2014-01-15 01:13:21.000000', 'temperatura', 949.0000, 'ºC'),
	(153518, 120, '2014-01-15 01:13:22.000000', 'temperatura', 1159.0000, 'ºC'),
	(153519, 120, '2014-01-15 01:13:23.000000', 'temperatura', 547.0000, 'ºC'),
	(153520, 120, '2014-01-15 01:13:24.000000', 'temperatura', 461.0000, 'ºC'),
	(153521, 120, '2014-01-15 01:13:25.000000', 'temperatura', 662.0000, 'ºC'),
	(153522, 120, '2014-01-15 01:13:26.000000', 'temperatura', 730.0000, 'ºC'),
	(153523, 120, '2014-01-15 01:13:27.000000', 'temperatura', 464.0000, 'ºC'),
	(153524, 120, '2014-01-15 01:13:28.000000', 'temperatura', 132.0000, 'ºC'),
	(153525, 120, '2014-01-15 01:13:29.000000', 'temperatura', 468.0000, 'ºC'),
	(153526, 120, '2014-01-15 01:13:30.000000', 'temperatura', 743.0000, 'ºC'),
	(153527, 120, '2014-01-15 01:13:31.000000', 'temperatura', 1111.0000, 'ºC'),
	(153528, 120, '2014-01-15 01:13:32.000000', 'temperatura', 927.0000, 'ºC'),
	(153529, 120, '2014-01-15 01:13:33.000000', 'temperatura', 101.0000, 'ºC'),
	(153530, 120, '2014-01-15 01:13:34.000000', 'temperatura', 124.0000, 'ºC'),
	(153531, 120, '2014-01-15 01:13:35.000000', 'temperatura', 319.0000, 'ºC'),
	(153532, 120, '2014-01-15 01:13:36.000000', 'temperatura', 21.0000, 'ºC'),
	(153533, 120, '2014-01-15 01:13:37.000000', 'temperatura', 351.0000, 'ºC'),
	(153534, 120, '2014-01-15 01:13:38.000000', 'temperatura', 493.0000, 'ºC'),
	(153535, 120, '2014-01-15 01:13:39.000000', 'temperatura', 212.0000, 'ºC'),
	(153536, 120, '2014-01-15 01:13:40.000000', 'temperatura', 783.0000, 'ºC'),
	(153537, 120, '2014-01-15 01:13:41.000000', 'temperatura', 878.0000, 'ºC'),
	(153538, 120, '2014-01-15 01:13:42.000000', 'temperatura', 841.0000, 'ºC'),
	(153539, 120, '2014-01-15 01:13:43.000000', 'temperatura', 374.0000, 'ºC'),
	(153540, 120, '2014-01-15 01:13:44.000000', 'temperatura', 546.0000, 'ºC'),
	(153541, 120, '2014-01-15 01:13:45.000000', 'temperatura', 409.0000, 'ºC'),
	(153542, 120, '2014-01-15 01:13:46.000000', 'temperatura', 409.0000, 'ºC'),
	(153543, 120, '2014-01-15 01:13:47.000000', 'temperatura', 818.0000, 'ºC'),
	(153544, 120, '2014-01-15 01:13:48.000000', 'temperatura', 463.0000, 'ºC'),
	(153545, 120, '2014-01-15 01:13:49.000000', 'temperatura', 1060.0000, 'ºC'),
	(153546, 120, '2014-01-15 01:13:50.000000', 'temperatura', 312.0000, 'ºC'),
	(153547, 120, '2014-01-15 01:13:51.000000', 'temperatura', 781.0000, 'ºC'),
	(153548, 120, '2014-01-15 01:13:52.000000', 'temperatura', 568.0000, 'ºC'),
	(153549, 120, '2014-01-15 01:13:53.000000', 'temperatura', 497.0000, 'ºC'),
	(153550, 120, '2014-01-15 01:13:54.000000', 'temperatura', 781.0000, 'ºC'),
	(153551, 120, '2014-01-15 01:13:55.000000', 'temperatura', 16.0000, 'ºC'),
	(153552, 120, '2014-01-15 01:13:56.000000', 'temperatura', 136.0000, 'ºC'),
	(153553, 120, '2014-01-15 01:13:57.000000', 'temperatura', 634.0000, 'ºC'),
	(153554, 120, '2014-01-15 01:13:58.000000', 'temperatura', 362.0000, 'ºC'),
	(153555, 120, '2014-01-15 01:13:59.000000', 'temperatura', 1107.0000, 'ºC'),
	(153556, 120, '2014-01-15 01:14:00.000000', 'temperatura', 850.0000, 'ºC'),
	(153557, 120, '2014-01-15 01:14:01.000000', 'temperatura', 929.0000, 'ºC'),
	(153558, 120, '2014-01-15 01:14:02.000000', 'temperatura', 895.0000, 'ºC'),
	(153559, 120, '2014-01-15 01:14:03.000000', 'temperatura', 488.0000, 'ºC'),
	(153560, 120, '2014-01-15 01:14:04.000000', 'temperatura', 955.0000, 'ºC'),
	(153561, 120, '2014-01-15 01:14:05.000000', 'temperatura', 913.0000, 'ºC'),
	(153562, 120, '2014-01-15 01:14:06.000000', 'temperatura', 501.0000, 'ºC'),
	(153563, 120, '2014-01-15 01:14:07.000000', 'temperatura', 965.0000, 'ºC'),
	(153564, 120, '2014-01-15 01:14:08.000000', 'temperatura', 923.0000, 'ºC'),
	(153565, 120, '2014-01-15 01:14:09.000000', 'temperatura', 521.0000, 'ºC'),
	(153566, 120, '2014-01-15 01:14:10.000000', 'temperatura', 1038.0000, 'ºC'),
	(153567, 120, '2014-01-15 01:14:11.000000', 'temperatura', 26.0000, 'ºC'),
	(153568, 120, '2014-01-15 01:14:12.000000', 'temperatura', 616.0000, 'ºC'),
	(153569, 120, '2014-01-15 01:14:13.000000', 'temperatura', 604.0000, 'ºC'),
	(153570, 120, '2014-01-15 01:14:14.000000', 'temperatura', 1174.0000, 'ºC'),
	(153571, 120, '2014-01-15 01:14:15.000000', 'temperatura', 456.0000, 'ºC'),
	(153572, 120, '2014-01-15 01:14:16.000000', 'temperatura', 1160.0000, 'ºC'),
	(153573, 120, '2014-01-15 01:14:17.000000', 'temperatura', 831.0000, 'ºC'),
	(153574, 120, '2014-01-15 01:14:18.000000', 'temperatura', 676.0000, 'ºC'),
	(153575, 120, '2014-01-15 01:14:19.000000', 'temperatura', 886.0000, 'ºC'),
	(153576, 120, '2014-01-15 01:14:20.000000', 'temperatura', 4.0000, 'ºC'),
	(153577, 120, '2014-01-15 01:14:21.000000', 'temperatura', 963.0000, 'ºC'),
	(153578, 120, '2014-01-15 01:14:22.000000', 'temperatura', 1.0000, 'ºC'),
	(153579, 120, '2014-01-15 01:14:23.000000', 'temperatura', 720.0000, 'ºC'),
	(153580, 120, '2014-01-15 01:14:24.000000', 'temperatura', 1195.0000, 'ºC'),
	(153581, 120, '2014-01-15 01:14:25.000000', 'temperatura', 215.0000, 'ºC'),
	(153582, 120, '2014-01-15 01:14:26.000000', 'temperatura', 1093.0000, 'ºC'),
	(153583, 120, '2014-01-15 01:14:27.000000', 'temperatura', 17.0000, 'ºC'),
	(153584, 120, '2014-01-15 01:14:28.000000', 'temperatura', 410.0000, 'ºC'),
	(153585, 120, '2014-01-15 01:14:29.000000', 'temperatura', 798.0000, 'ºC'),
	(153586, 120, '2014-01-15 01:14:30.000000', 'temperatura', 362.0000, 'ºC'),
	(153587, 120, '2014-01-15 01:14:31.000000', 'temperatura', 616.0000, 'ºC'),
	(153588, 120, '2014-01-15 01:14:32.000000', 'temperatura', 793.0000, 'ºC'),
	(153589, 120, '2014-01-15 01:14:33.000000', 'temperatura', 919.0000, 'ºC'),
	(153590, 120, '2014-01-15 01:14:34.000000', 'temperatura', 1018.0000, 'ºC'),
	(153591, 120, '2014-01-15 01:14:35.000000', 'temperatura', 1133.0000, 'ºC'),
	(153592, 120, '2014-01-15 01:14:36.000000', 'temperatura', 210.0000, 'ºC'),
	(153593, 120, '2014-01-15 01:14:37.000000', 'temperatura', 52.0000, 'ºC'),
	(153594, 120, '2014-01-15 01:14:38.000000', 'temperatura', 828.0000, 'ºC'),
	(153595, 120, '2014-01-15 01:14:39.000000', 'temperatura', 388.0000, 'ºC'),
	(153596, 120, '2014-01-15 01:14:40.000000', 'temperatura', 656.0000, 'ºC'),
	(153597, 120, '2014-01-15 01:14:41.000000', 'temperatura', 918.0000, 'ºC'),
	(153598, 120, '2014-01-15 01:14:42.000000', 'temperatura', 219.0000, 'ºC'),
	(153599, 120, '2014-01-15 01:14:43.000000', 'temperatura', 745.0000, 'ºC'),
	(153600, 120, '2014-01-15 01:14:44.000000', 'temperatura', 666.0000, 'ºC'),
	(153601, 120, '2014-01-15 01:14:45.000000', 'temperatura', 1097.0000, 'ºC'),
	(153602, 120, '2014-01-15 01:14:46.000000', 'temperatura', 1085.0000, 'ºC'),
	(153603, 120, '2014-01-15 01:14:47.000000', 'temperatura', 935.0000, 'ºC'),
	(153604, 120, '2014-01-15 01:14:48.000000', 'temperatura', 222.0000, 'ºC'),
	(153605, 120, '2014-01-15 01:14:49.000000', 'temperatura', 706.0000, 'ºC'),
	(153606, 120, '2014-01-15 01:14:50.000000', 'temperatura', 463.0000, 'ºC'),
	(153607, 120, '2014-01-15 01:14:51.000000', 'temperatura', 197.0000, 'ºC'),
	(153608, 120, '2014-01-15 01:14:52.000000', 'temperatura', 795.0000, 'ºC'),
	(153609, 120, '2014-01-15 01:14:53.000000', 'temperatura', 987.0000, 'ºC'),
	(153610, 120, '2014-01-15 01:14:54.000000', 'temperatura', 151.0000, 'ºC'),
	(153611, 120, '2014-01-15 01:14:55.000000', 'temperatura', 193.0000, 'ºC'),
	(153612, 120, '2014-01-15 01:14:56.000000', 'temperatura', 514.0000, 'ºC'),
	(153613, 120, '2014-01-15 01:14:57.000000', 'temperatura', 793.0000, 'ºC'),
	(153614, 120, '2014-01-15 01:14:58.000000', 'temperatura', 20.0000, 'ºC'),
	(153615, 120, '2014-01-15 01:14:59.000000', 'temperatura', 123.0000, 'ºC'),
	(153616, 120, '2014-01-15 01:15:00.000000', 'temperatura', 554.0000, 'ºC'),
	(153617, 120, '2014-01-15 01:15:01.000000', 'temperatura', 1.0000, 'ºC'),
	(153618, 120, '2014-01-15 01:15:02.000000', 'temperatura', 747.0000, 'ºC'),
	(153619, 120, '2014-01-15 01:15:03.000000', 'temperatura', 129.0000, 'ºC'),
	(153620, 120, '2014-01-15 01:15:04.000000', 'temperatura', 805.0000, 'ºC'),
	(153621, 120, '2014-01-15 01:15:05.000000', 'temperatura', 38.0000, 'ºC'),
	(153622, 120, '2014-01-15 01:15:06.000000', 'temperatura', 176.0000, 'ºC'),
	(153623, 120, '2014-01-15 01:15:07.000000', 'temperatura', 765.0000, 'ºC'),
	(153624, 120, '2014-01-15 01:15:08.000000', 'temperatura', 899.0000, 'ºC'),
	(153625, 120, '2014-01-15 01:15:09.000000', 'temperatura', 999.0000, 'ºC'),
	(153626, 120, '2014-01-15 01:15:10.000000', 'temperatura', 1101.0000, 'ºC'),
	(153627, 120, '2014-01-15 01:15:11.000000', 'temperatura', 108.0000, 'ºC'),
	(153628, 120, '2014-01-15 01:15:12.000000', 'temperatura', 837.0000, 'ºC'),
	(153629, 120, '2014-01-15 01:15:13.000000', 'temperatura', 263.0000, 'ºC'),
	(153630, 120, '2014-01-15 01:15:14.000000', 'temperatura', 4.0000, 'ºC'),
	(153631, 120, '2014-01-15 01:15:15.000000', 'temperatura', 433.0000, 'ºC'),
	(153632, 120, '2014-01-15 01:15:16.000000', 'temperatura', 951.0000, 'ºC'),
	(153633, 120, '2014-01-15 01:15:17.000000', 'temperatura', 1059.0000, 'ºC'),
	(153634, 120, '2014-01-15 01:15:18.000000', 'temperatura', 43.0000, 'ºC'),
	(153635, 120, '2014-01-15 01:15:19.000000', 'temperatura', 637.0000, 'ºC'),
	(153636, 120, '2014-01-15 01:15:20.000000', 'temperatura', 656.0000, 'ºC'),
	(153637, 120, '2014-01-15 01:15:21.000000', 'temperatura', 171.0000, 'ºC'),
	(153638, 120, '2014-01-15 01:15:22.000000', 'temperatura', 88.0000, 'ºC'),
	(153639, 120, '2014-01-15 01:15:23.000000', 'temperatura', 1126.0000, 'ºC'),
	(153640, 120, '2014-01-15 01:15:24.000000', 'temperatura', 569.0000, 'ºC'),
	(153641, 120, '2014-01-15 01:15:25.000000', 'temperatura', 665.0000, 'ºC'),
	(153642, 120, '2014-01-15 01:15:26.000000', 'temperatura', 420.0000, 'ºC'),
	(153643, 120, '2014-01-15 01:15:27.000000', 'temperatura', 104.0000, 'ºC'),
	(153644, 120, '2014-01-15 01:15:28.000000', 'temperatura', 459.0000, 'ºC'),
	(153645, 120, '2014-01-15 01:15:29.000000', 'temperatura', 786.0000, 'ºC'),
	(153646, 120, '2014-01-15 01:15:30.000000', 'temperatura', 153.0000, 'ºC'),
	(153647, 120, '2014-01-15 01:15:31.000000', 'temperatura', 807.0000, 'ºC'),
	(153648, 120, '2014-01-15 01:15:32.000000', 'temperatura', 1176.0000, 'ºC'),
	(153649, 120, '2014-01-15 01:15:33.000000', 'temperatura', 1059.0000, 'ºC'),
	(153650, 120, '2014-01-15 01:15:34.000000', 'temperatura', 568.0000, 'ºC'),
	(153651, 120, '2014-01-15 01:15:35.000000', 'temperatura', 863.0000, 'ºC'),
	(153652, 120, '2014-01-15 01:15:36.000000', 'temperatura', 210.0000, 'ºC'),
	(153653, 120, '2014-01-15 01:15:37.000000', 'temperatura', 865.0000, 'ºC'),
	(153654, 120, '2014-01-15 01:15:38.000000', 'temperatura', 92.0000, 'ºC'),
	(153655, 120, '2014-01-15 01:15:39.000000', 'temperatura', 267.0000, 'ºC'),
	(153656, 120, '2014-01-15 01:15:40.000000', 'temperatura', 1058.0000, 'ºC'),
	(153657, 120, '2014-01-15 01:15:41.000000', 'temperatura', 891.0000, 'ºC'),
	(153658, 120, '2014-01-15 01:15:42.000000', 'temperatura', 80.0000, 'ºC'),
	(153659, 120, '2014-01-15 01:15:43.000000', 'temperatura', 126.0000, 'ºC'),
	(153660, 120, '2014-01-15 01:15:44.000000', 'temperatura', 393.0000, 'ºC'),
	(153661, 120, '2014-01-15 01:15:45.000000', 'temperatura', 387.0000, 'ºC'),
	(153662, 120, '2014-01-15 01:15:46.000000', 'temperatura', 757.0000, 'ºC'),
	(153663, 120, '2014-01-15 01:15:47.000000', 'temperatura', 225.0000, 'ºC'),
	(153664, 120, '2014-01-15 01:15:48.000000', 'temperatura', 53.0000, 'ºC'),
	(153665, 120, '2014-01-15 01:15:49.000000', 'temperatura', 793.0000, 'ºC'),
	(153666, 120, '2014-01-15 01:15:50.000000', 'temperatura', 205.0000, 'ºC'),
	(153667, 120, '2014-01-15 01:15:51.000000', 'temperatura', 1048.0000, 'ºC'),
	(153668, 120, '2014-01-15 01:15:52.000000', 'temperatura', 1026.0000, 'ºC'),
	(153669, 120, '2014-01-15 01:15:53.000000', 'temperatura', 786.0000, 'ºC'),
	(153670, 120, '2014-01-15 01:15:54.000000', 'temperatura', 854.0000, 'ºC'),
	(153671, 120, '2014-01-15 01:15:55.000000', 'temperatura', 711.0000, 'ºC'),
	(153672, 120, '2014-01-15 01:15:56.000000', 'temperatura', 993.0000, 'ºC'),
	(153673, 120, '2014-01-15 01:15:57.000000', 'temperatura', 433.0000, 'ºC'),
	(153674, 120, '2014-01-15 01:15:58.000000', 'temperatura', 385.0000, 'ºC'),
	(153675, 120, '2014-01-15 01:15:59.000000', 'temperatura', 626.0000, 'ºC'),
	(153676, 120, '2014-01-15 01:16:00.000000', 'temperatura', 778.0000, 'ºC'),
	(153677, 120, '2014-01-15 01:16:01.000000', 'temperatura', 812.0000, 'ºC'),
	(153678, 120, '2014-01-15 01:16:02.000000', 'temperatura', 525.0000, 'ºC'),
	(153679, 120, '2014-01-15 01:16:03.000000', 'temperatura', 189.0000, 'ºC'),
	(153680, 120, '2014-01-15 01:16:04.000000', 'temperatura', 573.0000, 'ºC'),
	(153681, 120, '2014-01-15 01:16:05.000000', 'temperatura', 1097.0000, 'ºC'),
	(153682, 120, '2014-01-15 01:16:06.000000', 'temperatura', 165.0000, 'ºC'),
	(153683, 120, '2014-01-15 01:16:07.000000', 'temperatura', 1136.0000, 'ºC'),
	(153684, 120, '2014-01-15 01:16:08.000000', 'temperatura', 387.0000, 'ºC'),
	(153685, 120, '2014-01-15 01:16:09.000000', 'temperatura', 926.0000, 'ºC'),
	(153686, 120, '2014-01-15 01:16:10.000000', 'temperatura', 1069.0000, 'ºC'),
	(153687, 120, '2014-01-15 01:16:11.000000', 'temperatura', 167.0000, 'ºC'),
	(153688, 120, '2014-01-15 01:16:12.000000', 'temperatura', 30.0000, 'ºC'),
	(153689, 120, '2014-01-15 01:16:13.000000', 'temperatura', 848.0000, 'ºC'),
	(153690, 120, '2014-01-15 01:16:14.000000', 'temperatura', 551.0000, 'ºC'),
	(153691, 120, '2014-01-15 01:16:15.000000', 'temperatura', 211.0000, 'ºC'),
	(153692, 120, '2014-01-15 01:16:16.000000', 'temperatura', 602.0000, 'ºC'),
	(153693, 120, '2014-01-15 01:16:17.000000', 'temperatura', 1180.0000, 'ºC'),
	(153694, 120, '2014-01-15 01:16:18.000000', 'temperatura', 493.0000, 'ºC'),
	(153695, 120, '2014-01-15 01:16:19.000000', 'temperatura', 125.0000, 'ºC'),
	(153696, 120, '2014-01-15 01:16:20.000000', 'temperatura', 347.0000, 'ºC'),
	(153697, 120, '2014-01-15 01:16:21.000000', 'temperatura', 160.0000, 'ºC'),
	(153698, 120, '2014-01-15 01:16:22.000000', 'temperatura', 962.0000, 'ºC'),
	(153699, 120, '2014-01-15 01:16:23.000000', 'temperatura', 728.0000, 'ºC'),
	(153700, 120, '2014-01-15 01:16:24.000000', 'temperatura', 756.0000, 'ºC'),
	(153701, 120, '2014-01-15 01:16:25.000000', 'temperatura', 396.0000, 'ºC'),
	(153702, 120, '2014-01-15 01:16:26.000000', 'temperatura', 912.0000, 'ºC'),
	(153703, 120, '2014-01-15 01:16:27.000000', 'temperatura', 972.0000, 'ºC'),
	(153704, 120, '2014-01-15 01:16:28.000000', 'temperatura', 927.0000, 'ºC'),
	(153705, 120, '2014-01-15 01:16:29.000000', 'temperatura', 518.0000, 'ºC'),
	(153706, 120, '2014-01-15 01:16:30.000000', 'temperatura', 1011.0000, 'ºC'),
	(153707, 120, '2014-01-15 01:16:31.000000', 'temperatura', 1102.0000, 'ºC'),
	(153708, 120, '2014-01-15 01:16:32.000000', 'temperatura', 78.0000, 'ºC'),
	(153709, 120, '2014-01-15 01:16:33.000000', 'temperatura', 683.0000, 'ºC'),
	(153710, 120, '2014-01-15 01:16:34.000000', 'temperatura', 781.0000, 'ºC'),
	(153711, 120, '2014-01-15 01:16:35.000000', 'temperatura', 656.0000, 'ºC'),
	(153712, 120, '2014-01-15 01:16:36.000000', 'temperatura', 937.0000, 'ºC'),
	(153713, 120, '2014-01-15 01:16:37.000000', 'temperatura', 317.0000, 'ºC'),
	(153714, 120, '2014-01-15 01:16:38.000000', 'temperatura', 1177.0000, 'ºC'),
	(153715, 120, '2014-01-15 01:16:39.000000', 'temperatura', 135.0000, 'ºC'),
	(153716, 120, '2014-01-15 01:16:40.000000', 'temperatura', 742.0000, 'ºC'),
	(153717, 120, '2014-01-15 01:16:41.000000', 'temperatura', 906.0000, 'ºC'),
	(153718, 120, '2014-01-15 01:16:42.000000', 'temperatura', 1106.0000, 'ºC'),
	(153719, 120, '2014-01-15 01:16:43.000000', 'temperatura', 414.0000, 'ºC'),
	(153720, 120, '2014-01-15 01:16:44.000000', 'temperatura', 1149.0000, 'ºC'),
	(153721, 120, '2014-01-15 01:16:45.000000', 'temperatura', 906.0000, 'ºC'),
	(153722, 120, '2014-01-15 01:16:46.000000', 'temperatura', 1085.0000, 'ºC'),
	(153723, 120, '2014-01-15 01:16:47.000000', 'temperatura', 304.0000, 'ºC'),
	(153724, 120, '2014-01-15 01:16:48.000000', 'temperatura', 667.0000, 'ºC'),
	(153725, 120, '2014-01-15 01:16:49.000000', 'temperatura', 21.0000, 'ºC'),
	(153726, 120, '2014-01-15 01:16:50.000000', 'temperatura', 507.0000, 'ºC'),
	(153727, 120, '2014-01-15 01:16:51.000000', 'temperatura', 73.0000, 'ºC'),
	(153728, 120, '2014-01-15 01:16:52.000000', 'temperatura', 43.0000, 'ºC'),
	(153729, 120, '2014-01-15 01:16:53.000000', 'temperatura', 1195.0000, 'ºC'),
	(153730, 120, '2014-01-15 01:16:54.000000', 'temperatura', 1050.0000, 'ºC'),
	(153731, 120, '2014-01-15 01:16:55.000000', 'temperatura', 463.0000, 'ºC'),
	(153732, 120, '2014-01-15 01:16:56.000000', 'temperatura', 368.0000, 'ºC'),
	(153733, 120, '2014-01-15 01:16:57.000000', 'temperatura', 452.0000, 'ºC'),
	(153734, 120, '2014-01-15 01:16:58.000000', 'temperatura', 1153.0000, 'ºC'),
	(153735, 120, '2014-01-15 01:16:59.000000', 'temperatura', 812.0000, 'ºC'),
	(153736, 120, '2014-01-15 01:17:00.000000', 'temperatura', 601.0000, 'ºC'),
	(153737, 120, '2014-01-15 01:17:01.000000', 'temperatura', 569.0000, 'ºC'),
	(153738, 120, '2014-01-15 01:17:02.000000', 'temperatura', 1042.0000, 'ºC'),
	(153739, 120, '2014-01-15 01:17:03.000000', 'temperatura', 1104.0000, 'ºC'),
	(153740, 120, '2014-01-15 01:17:04.000000', 'temperatura', 1193.0000, 'ºC'),
	(153741, 120, '2014-01-15 01:17:05.000000', 'temperatura', 253.0000, 'ºC'),
	(153742, 120, '2014-01-15 01:17:06.000000', 'temperatura', 86.0000, 'ºC'),
	(153743, 120, '2014-01-15 01:17:07.000000', 'temperatura', 871.0000, 'ºC'),
	(153744, 120, '2014-01-15 01:17:08.000000', 'temperatura', 501.0000, 'ºC'),
	(153745, 120, '2014-01-15 01:17:09.000000', 'temperatura', 1089.0000, 'ºC'),
	(153746, 120, '2014-01-15 01:17:10.000000', 'temperatura', 344.0000, 'ºC'),
	(153747, 120, '2014-01-15 01:17:11.000000', 'temperatura', 854.0000, 'ºC'),
	(153748, 120, '2014-01-15 01:17:12.000000', 'temperatura', 839.0000, 'ºC'),
	(153749, 120, '2014-01-15 01:17:13.000000', 'temperatura', 433.0000, 'ºC'),
	(153750, 120, '2014-01-15 01:17:14.000000', 'temperatura', 850.0000, 'ºC'),
	(153751, 120, '2014-01-15 01:17:15.000000', 'temperatura', 551.0000, 'ºC'),
	(153752, 120, '2014-01-15 01:17:16.000000', 'temperatura', 204.0000, 'ºC'),
	(153753, 120, '2014-01-15 01:17:17.000000', 'temperatura', 566.0000, 'ºC'),
	(153754, 120, '2014-01-15 01:17:18.000000', 'temperatura', 1022.0000, 'ºC'),
	(153755, 120, '2014-01-15 01:17:19.000000', 'temperatura', 1009.0000, 'ºC'),
	(153756, 120, '2014-01-15 01:17:20.000000', 'temperatura', 783.0000, 'ºC'),
	(153757, 120, '2014-01-15 01:17:21.000000', 'temperatura', 887.0000, 'ºC'),
	(153758, 120, '2014-01-15 01:17:22.000000', 'temperatura', 888.0000, 'ºC'),
	(153759, 120, '2014-01-15 01:17:23.000000', 'temperatura', 578.0000, 'ºC'),
	(153760, 120, '2014-01-15 01:17:24.000000', 'temperatura', 229.0000, 'ºC'),
	(153761, 120, '2014-01-15 01:17:25.000000', 'temperatura', 609.0000, 'ºC'),
	(153762, 120, '2014-01-15 01:17:26.000000', 'temperatura', 1158.0000, 'ºC'),
	(153763, 120, '2014-01-15 01:17:27.000000', 'temperatura', 365.0000, 'ºC'),
	(153764, 120, '2014-01-15 01:17:28.000000', 'temperatura', 749.0000, 'ºC'),
	(153765, 120, '2014-01-15 01:17:29.000000', 'temperatura', 254.0000, 'ºC'),
	(153766, 120, '2014-01-15 01:17:30.000000', 'temperatura', 220.0000, 'ºC'),
	(153767, 120, '2014-01-15 01:17:31.000000', 'temperatura', 341.0000, 'ºC'),
	(153768, 120, '2014-01-15 01:17:32.000000', 'temperatura', 1044.0000, 'ºC'),
	(153769, 120, '2014-01-15 01:17:33.000000', 'temperatura', 599.0000, 'ºC'),
	(153770, 120, '2014-01-15 01:17:34.000000', 'temperatura', 1064.0000, 'ºC'),
	(153771, 120, '2014-01-15 01:17:35.000000', 'temperatura', 1125.0000, 'ºC'),
	(153772, 120, '2014-01-15 01:17:36.000000', 'temperatura', 31.0000, 'ºC'),
	(153773, 120, '2014-01-15 01:17:37.000000', 'temperatura', 380.0000, 'ºC'),
	(153774, 120, '2014-01-15 01:17:38.000000', 'temperatura', 610.0000, 'ºC'),
	(153775, 120, '2014-01-15 01:17:39.000000', 'temperatura', 707.0000, 'ºC'),
	(153776, 120, '2014-01-15 01:17:40.000000', 'temperatura', 509.0000, 'ºC'),
	(153777, 120, '2014-01-15 01:17:41.000000', 'temperatura', 424.0000, 'ºC'),
	(153778, 120, '2014-01-15 01:17:42.000000', 'temperatura', 593.0000, 'ºC'),
	(153779, 120, '2014-01-15 01:17:43.000000', 'temperatura', 493.0000, 'ºC'),
	(153780, 120, '2014-01-15 01:17:44.000000', 'temperatura', 688.0000, 'ºC'),
	(153781, 120, '2014-01-15 01:17:45.000000', 'temperatura', 762.0000, 'ºC'),
	(153782, 120, '2014-01-15 01:17:46.000000', 'temperatura', 545.0000, 'ºC'),
	(153783, 120, '2014-01-15 01:17:47.000000', 'temperatura', 440.0000, 'ºC'),
	(153784, 120, '2014-01-15 01:17:48.000000', 'temperatura', 565.0000, 'ºC'),
	(153785, 120, '2014-01-15 01:17:49.000000', 'temperatura', 307.0000, 'ºC'),
	(153786, 120, '2014-01-15 01:17:50.000000', 'temperatura', 1038.0000, 'ºC'),
	(153787, 120, '2014-01-15 01:17:51.000000', 'temperatura', 672.0000, 'ºC'),
	(153788, 120, '2014-01-15 01:17:52.000000', 'temperatura', 247.0000, 'ºC'),
	(153789, 120, '2014-01-15 01:17:53.000000', 'temperatura', 418.0000, 'ºC'),
	(153790, 120, '2014-01-15 01:17:54.000000', 'temperatura', 152.0000, 'ºC'),
	(153791, 120, '2014-01-15 01:17:55.000000', 'temperatura', 704.0000, 'ºC'),
	(153792, 120, '2014-01-15 01:17:56.000000', 'temperatura', 667.0000, 'ºC'),
	(153793, 120, '2014-01-15 01:17:57.000000', 'temperatura', 22.0000, 'ºC'),
	(153794, 120, '2014-01-15 01:17:58.000000', 'temperatura', 508.0000, 'ºC'),
	(153795, 120, '2014-01-15 01:17:59.000000', 'temperatura', 78.0000, 'ºC'),
	(153796, 120, '2014-01-15 01:18:00.000000', 'temperatura', 63.0000, 'ºC'),
	(153797, 120, '2014-01-15 01:18:01.000000', 'temperatura', 82.0000, 'ºC'),
	(153798, 120, '2014-01-15 01:18:02.000000', 'temperatura', 224.0000, 'ºC'),
	(153799, 120, '2014-01-15 01:18:03.000000', 'temperatura', 872.0000, 'ºC'),
	(153800, 120, '2014-01-15 01:18:04.000000', 'temperatura', 90.0000, 'ºC'),
	(153801, 120, '2014-01-15 01:18:05.000000', 'temperatura', 235.0000, 'ºC'),
	(153802, 120, '2014-01-15 01:18:06.000000', 'temperatura', 904.0000, 'ºC'),
	(153803, 120, '2014-01-15 01:18:07.000000', 'temperatura', 218.0000, 'ºC'),
	(153804, 120, '2014-01-15 01:18:08.000000', 'temperatura', 777.0000, 'ºC'),
	(153805, 120, '2014-01-15 01:18:09.000000', 'temperatura', 831.0000, 'ºC'),
	(153806, 120, '2014-01-15 01:18:10.000000', 'temperatura', 623.0000, 'ºC'),
	(153807, 120, '2014-01-15 01:18:11.000000', 'temperatura', 625.0000, 'ºC'),
	(153808, 120, '2014-01-15 01:18:12.000000', 'temperatura', 57.0000, 'ºC'),
	(153809, 120, '2014-01-15 01:18:13.000000', 'temperatura', 810.0000, 'ºC'),
	(153810, 120, '2014-01-15 01:18:14.000000', 'temperatura', 278.0000, 'ºC'),
	(153811, 120, '2014-01-15 01:18:15.000000', 'temperatura', 163.0000, 'ºC'),
	(153812, 120, '2014-01-15 01:18:16.000000', 'temperatura', 1182.0000, 'ºC'),
	(153813, 120, '2014-01-15 01:18:17.000000', 'temperatura', 619.0000, 'ºC'),
	(153814, 120, '2014-01-15 01:18:18.000000', 'temperatura', 751.0000, 'ºC'),
	(153815, 120, '2014-01-15 01:18:19.000000', 'temperatura', 700.0000, 'ºC'),
	(153816, 120, '2014-01-15 01:18:20.000000', 'temperatura', 46.0000, 'ºC'),
	(153817, 120, '2014-01-15 01:18:21.000000', 'temperatura', 529.0000, 'ºC'),
	(153818, 120, '2014-01-15 01:18:22.000000', 'temperatura', 110.0000, 'ºC'),
	(153819, 120, '2014-01-15 01:18:23.000000', 'temperatura', 164.0000, 'ºC'),
	(153820, 120, '2014-01-15 01:18:24.000000', 'temperatura', 490.0000, 'ºC'),
	(153821, 120, '2014-01-15 01:18:25.000000', 'temperatura', 759.0000, 'ºC'),
	(153822, 120, '2014-01-15 01:18:26.000000', 'temperatura', 1125.0000, 'ºC'),
	(153823, 120, '2014-01-15 01:18:27.000000', 'temperatura', 948.0000, 'ºC'),
	(153824, 120, '2014-01-15 01:18:28.000000', 'temperatura', 166.0000, 'ºC'),
	(153825, 120, '2014-01-15 01:18:29.000000', 'temperatura', 387.0000, 'ºC'),
	(153826, 120, '2014-01-15 01:18:30.000000', 'temperatura', 237.0000, 'ºC'),
	(153827, 120, '2014-01-15 01:18:31.000000', 'temperatura', 27.0000, 'ºC'),
	(153828, 120, '2014-01-15 01:18:32.000000', 'temperatura', 621.0000, 'ºC'),
	(153829, 120, '2014-01-15 01:18:33.000000', 'temperatura', 627.0000, 'ºC'),
	(153830, 120, '2014-01-15 01:18:34.000000', 'temperatura', 71.0000, 'ºC'),
	(153831, 120, '2014-01-15 01:18:35.000000', 'temperatura', 873.0000, 'ºC'),
	(153832, 120, '2014-01-15 01:18:36.000000', 'temperatura', 554.0000, 'ºC'),
	(153833, 120, '2014-01-15 01:18:37.000000', 'temperatura', 154.0000, 'ºC'),
	(153834, 120, '2014-01-15 01:18:38.000000', 'temperatura', 305.0000, 'ºC'),
	(153835, 120, '2014-01-15 01:18:39.000000', 'temperatura', 1063.0000, 'ºC'),
	(153836, 120, '2014-01-15 01:18:40.000000', 'temperatura', 801.0000, 'ºC'),
	(153837, 120, '2014-01-15 01:18:41.000000', 'temperatura', 819.0000, 'ºC'),
	(153838, 120, '2014-01-15 01:18:42.000000', 'temperatura', 490.0000, 'ºC'),
	(153839, 120, '2014-01-15 01:18:43.000000', 'temperatura', 1194.0000, 'ºC'),
	(153840, 120, '2014-01-15 01:18:44.000000', 'temperatura', 900.0000, 'ºC'),
	(153841, 120, '2014-01-15 01:18:45.000000', 'temperatura', 919.0000, 'ºC'),
	(153842, 120, '2014-01-15 01:18:46.000000', 'temperatura', 695.0000, 'ºC'),
	(153843, 120, '2014-01-15 01:18:47.000000', 'temperatura', 720.0000, 'ºC'),
	(153844, 120, '2014-01-15 01:18:48.000000', 'temperatura', 316.0000, 'ºC'),
	(153845, 120, '2014-01-15 01:18:49.000000', 'temperatura', 620.0000, 'ºC'),
	(153846, 120, '2014-01-15 01:18:50.000000', 'temperatura', 952.0000, 'ºC'),
	(153847, 120, '2014-01-15 01:18:51.000000', 'temperatura', 501.0000, 'ºC'),
	(153848, 120, '2014-01-15 01:18:52.000000', 'temperatura', 848.0000, 'ºC'),
	(153849, 120, '2014-01-15 01:18:53.000000', 'temperatura', 339.0000, 'ºC'),
	(153850, 120, '2014-01-15 01:18:54.000000', 'temperatura', 352.0000, 'ºC'),
	(153851, 120, '2014-01-15 01:18:55.000000', 'temperatura', 744.0000, 'ºC'),
	(153852, 120, '2014-01-15 01:18:56.000000', 'temperatura', 265.0000, 'ºC'),
	(153853, 120, '2014-01-15 01:18:57.000000', 'temperatura', 291.0000, 'ºC'),
	(153854, 120, '2014-01-15 01:18:58.000000', 'temperatura', 660.0000, 'ºC'),
	(153855, 120, '2014-01-15 01:18:59.000000', 'temperatura', 27.0000, 'ºC'),
	(153856, 120, '2014-01-15 01:19:00.000000', 'temperatura', 558.0000, 'ºC'),
	(153857, 120, '2014-01-15 01:19:01.000000', 'temperatura', 309.0000, 'ºC'),
	(153858, 120, '2014-01-15 01:19:02.000000', 'temperatura', 1073.0000, 'ºC'),
	(153859, 120, '2014-01-15 01:19:03.000000', 'temperatura', 836.0000, 'ºC'),
	(153860, 120, '2014-01-15 01:19:04.000000', 'temperatura', 963.0000, 'ºC'),
	(153861, 120, '2014-01-15 01:19:05.000000', 'temperatura', 1105.0000, 'ºC'),
	(153862, 120, '2014-01-15 01:19:06.000000', 'temperatura', 238.0000, 'ºC'),
	(153863, 120, '2014-01-15 01:19:07.000000', 'temperatura', 277.0000, 'ºC'),
	(153864, 120, '2014-01-15 01:19:08.000000', 'temperatura', 669.0000, 'ºC'),
	(153865, 120, '2014-01-15 01:19:09.000000', 'temperatura', 114.0000, 'ºC'),
	(153866, 120, '2014-01-15 01:19:10.000000', 'temperatura', 963.0000, 'ºC'),
	(153867, 120, '2014-01-15 01:19:11.000000', 'temperatura', 876.0000, 'ºC'),
	(153868, 120, '2014-01-15 01:19:12.000000', 'temperatura', 290.0000, 'ºC'),
	(153869, 120, '2014-01-15 01:19:13.000000', 'temperatura', 21.0000, 'ºC'),
	(153870, 120, '2014-01-15 01:19:14.000000', 'temperatura', 437.0000, 'ºC'),
	(153871, 120, '2014-01-15 01:19:15.000000', 'temperatura', 924.0000, 'ºC'),
	(153872, 120, '2014-01-15 01:19:16.000000', 'temperatura', 910.0000, 'ºC'),
	(153873, 120, '2014-01-15 01:19:17.000000', 'temperatura', 576.0000, 'ºC'),
	(153874, 120, '2014-01-15 01:19:18.000000', 'temperatura', 152.0000, 'ºC'),
	(153875, 120, '2014-01-15 01:19:19.000000', 'temperatura', 234.0000, 'ºC'),
	(153876, 120, '2014-01-15 01:19:20.000000', 'temperatura', 712.0000, 'ºC'),
	(153877, 120, '2014-01-15 01:19:21.000000', 'temperatura', 458.0000, 'ºC'),
	(153878, 120, '2014-01-15 01:19:22.000000', 'temperatura', 155.0000, 'ºC'),
	(153879, 120, '2014-01-15 01:19:23.000000', 'temperatura', 601.0000, 'ºC'),
	(153880, 120, '2014-01-15 01:19:24.000000', 'temperatura', 140.0000, 'ºC'),
	(153881, 120, '2014-01-15 01:19:25.000000', 'temperatura', 98.0000, 'ºC'),
	(153882, 120, '2014-01-15 01:19:26.000000', 'temperatura', 72.0000, 'ºC'),
	(153883, 120, '2014-01-15 01:19:27.000000', 'temperatura', 67.0000, 'ºC'),
	(153884, 120, '2014-01-15 01:19:28.000000', 'temperatura', 117.0000, 'ºC'),
	(153885, 120, '2014-01-15 01:19:29.000000', 'temperatura', 385.0000, 'ºC'),
	(153886, 120, '2014-01-15 01:19:30.000000', 'temperatura', 376.0000, 'ºC'),
	(153887, 120, '2014-01-15 01:19:31.000000', 'temperatura', 723.0000, 'ºC'),
	(153888, 120, '2014-01-15 01:19:32.000000', 'temperatura', 88.0000, 'ºC'),
	(153889, 120, '2014-01-15 01:19:33.000000', 'temperatura', 671.0000, 'ºC'),
	(153890, 120, '2014-01-15 01:19:34.000000', 'temperatura', 691.0000, 'ºC'),
	(153891, 120, '2014-01-15 01:19:35.000000', 'temperatura', 242.0000, 'ºC'),
	(153892, 120, '2014-01-15 01:19:36.000000', 'temperatura', 338.0000, 'ºC'),
	(153893, 120, '2014-01-15 01:19:37.000000', 'temperatura', 963.0000, 'ºC'),
	(153894, 120, '2014-01-15 01:19:38.000000', 'temperatura', 205.0000, 'ºC'),
	(153895, 120, '2014-01-15 01:19:39.000000', 'temperatura', 534.0000, 'ºC'),
	(153896, 120, '2014-01-15 01:19:40.000000', 'temperatura', 857.0000, 'ºC'),
	(153897, 120, '2014-01-15 01:19:41.000000', 'temperatura', 282.0000, 'ºC'),
	(153898, 120, '2014-01-15 01:19:42.000000', 'temperatura', 42.0000, 'ºC'),
	(153899, 120, '2014-01-15 01:19:43.000000', 'temperatura', 561.0000, 'ºC'),
	(153900, 120, '2014-01-15 01:19:44.000000', 'temperatura', 283.0000, 'ºC'),
	(153901, 120, '2014-01-15 01:19:45.000000', 'temperatura', 931.0000, 'ºC'),
	(153902, 120, '2014-01-15 01:19:46.000000', 'temperatura', 205.0000, 'ºC'),
	(153903, 120, '2014-01-15 01:19:47.000000', 'temperatura', 635.0000, 'ºC'),
	(153904, 120, '2014-01-15 01:19:48.000000', 'temperatura', 158.0000, 'ºC'),
	(153905, 120, '2014-01-15 01:19:49.000000', 'temperatura', 86.0000, 'ºC'),
	(153906, 120, '2014-01-15 01:19:50.000000', 'temperatura', 1156.0000, 'ºC'),
	(153907, 120, '2014-01-15 01:19:51.000000', 'temperatura', 722.0000, 'ºC'),
	(153908, 120, '2014-01-15 01:19:52.000000', 'temperatura', 141.0000, 'ºC'),
	(153909, 120, '2014-01-15 01:19:53.000000', 'temperatura', 942.0000, 'ºC'),
	(153910, 120, '2014-01-15 01:19:54.000000', 'temperatura', 687.0000, 'ºC'),
	(153911, 120, '2014-01-15 01:19:55.000000', 'temperatura', 612.0000, 'ºC'),
	(153912, 120, '2014-01-15 01:19:56.000000', 'temperatura', 996.0000, 'ºC'),
	(153913, 120, '2014-01-15 01:19:57.000000', 'temperatura', 744.0000, 'ºC'),
	(153914, 120, '2014-01-15 01:19:58.000000', 'temperatura', 733.0000, 'ºC'),
	(153915, 120, '2014-01-15 01:19:59.000000', 'temperatura', 233.0000, 'ºC'),
	(153916, 120, '2014-01-15 01:20:00.000000', 'temperatura', 166.0000, 'ºC'),
	(153917, 120, '2014-01-15 01:20:01.000000', 'temperatura', 133.0000, 'ºC'),
	(153918, 120, '2014-01-15 01:20:02.000000', 'temperatura', 166.0000, 'ºC'),
	(153919, 120, '2014-01-15 01:20:03.000000', 'temperatura', 430.0000, 'ºC'),
	(153920, 120, '2014-01-15 01:20:04.000000', 'temperatura', 455.0000, 'ºC'),
	(153921, 120, '2014-01-15 01:20:05.000000', 'temperatura', 987.0000, 'ºC'),
	(153922, 120, '2014-01-15 01:20:06.000000', 'temperatura', 1167.0000, 'ºC'),
	(153923, 120, '2014-01-15 01:20:07.000000', 'temperatura', 477.0000, 'ºC'),
	(153924, 120, '2014-01-15 01:20:08.000000', 'temperatura', 83.0000, 'ºC'),
	(153925, 120, '2014-01-15 01:20:09.000000', 'temperatura', 185.0000, 'ºC'),
	(153926, 120, '2014-01-15 01:20:10.000000', 'temperatura', 676.0000, 'ºC'),
	(153927, 120, '2014-01-15 01:20:11.000000', 'temperatura', 426.0000, 'ºC'),
	(153928, 120, '2014-01-15 01:20:12.000000', 'temperatura', 105.0000, 'ºC'),
	(153929, 120, '2014-01-15 01:20:13.000000', 'temperatura', 444.0000, 'ºC'),
	(153930, 120, '2014-01-15 01:20:14.000000', 'temperatura', 705.0000, 'ºC'),
	(153931, 120, '2014-01-15 01:20:15.000000', 'temperatura', 996.0000, 'ºC'),
	(153932, 120, '2014-01-15 01:20:16.000000', 'temperatura', 466.0000, 'ºC'),
	(153933, 120, '2014-01-15 01:20:17.000000', 'temperatura', 540.0000, 'ºC'),
	(153934, 120, '2014-01-15 01:20:18.000000', 'temperatura', 106.0000, 'ºC'),
	(153935, 120, '2014-01-15 01:20:19.000000', 'temperatura', 107.0000, 'ºC'),
	(153936, 120, '2014-01-15 01:20:20.000000', 'temperatura', 220.0000, 'ºC'),
	(153937, 120, '2014-01-15 01:20:21.000000', 'temperatura', 778.0000, 'ºC'),
	(153938, 120, '2014-01-15 01:20:22.000000', 'temperatura', 831.0000, 'ºC'),
	(153939, 120, '2014-01-15 01:20:23.000000', 'temperatura', 619.0000, 'ºC'),
	(153940, 120, '2014-01-15 01:20:24.000000', 'temperatura', 606.0000, 'ºC'),
	(153941, 120, '2014-01-15 01:20:25.000000', 'temperatura', 1173.0000, 'ºC'),
	(153942, 120, '2014-01-15 01:20:26.000000', 'temperatura', 448.0000, 'ºC'),
	(153943, 120, '2014-01-15 01:20:27.000000', 'temperatura', 1119.0000, 'ºC'),
	(153944, 120, '2014-01-15 01:20:28.000000', 'temperatura', 653.0000, 'ºC'),
	(153945, 120, '2014-01-15 01:20:29.000000', 'temperatura', 1110.0000, 'ºC'),
	(153946, 120, '2014-01-15 01:20:30.000000', 'temperatura', 1191.0000, 'ºC'),
	(153947, 120, '2014-01-15 01:20:31.000000', 'temperatura', 223.0000, 'ºC'),
	(153948, 120, '2014-01-15 01:20:32.000000', 'temperatura', 1144.0000, 'ºC'),
	(153949, 120, '2014-01-15 01:20:33.000000', 'temperatura', 253.0000, 'ºC'),
	(153950, 120, '2014-01-15 01:20:34.000000', 'temperatura', 232.0000, 'ºC'),
	(153951, 120, '2014-01-15 01:20:35.000000', 'temperatura', 402.0000, 'ºC'),
	(153952, 120, '2014-01-15 01:20:36.000000', 'temperatura', 113.0000, 'ºC'),
	(153953, 120, '2014-01-15 01:20:37.000000', 'temperatura', 558.0000, 'ºC'),
	(153954, 120, '2014-01-15 01:20:38.000000', 'temperatura', 55.0000, 'ºC'),
	(153955, 120, '2014-01-15 01:20:39.000000', 'temperatura', 1000.0000, 'ºC'),
	(153956, 120, '2014-01-15 01:20:40.000000', 'temperatura', 34.0000, 'ºC'),
	(153957, 120, '2014-01-15 01:20:41.000000', 'temperatura', 772.0000, 'ºC'),
	(153958, 120, '2014-01-15 01:20:42.000000', 'temperatura', 157.0000, 'ºC'),
	(153959, 120, '2014-01-15 01:20:43.000000', 'temperatura', 869.0000, 'ºC'),
	(153960, 120, '2014-01-15 01:20:44.000000', 'temperatura', 274.0000, 'ºC'),
	(153961, 120, '2014-01-15 01:20:45.000000', 'temperatura', 1165.0000, 'ºC'),
	(153962, 120, '2014-01-15 01:20:46.000000', 'temperatura', 203.0000, 'ºC'),
	(153963, 120, '2014-01-15 01:20:47.000000', 'temperatura', 1121.0000, 'ºC'),
	(153964, 120, '2014-01-15 01:20:48.000000', 'temperatura', 197.0000, 'ºC'),
	(153965, 120, '2014-01-15 01:20:49.000000', 'temperatura', 21.0000, 'ºC'),
	(153966, 120, '2014-01-15 01:20:50.000000', 'temperatura', 714.0000, 'ºC'),
	(153967, 120, '2014-01-15 01:20:51.000000', 'temperatura', 1108.0000, 'ºC'),
	(153968, 120, '2014-01-15 01:20:52.000000', 'temperatura', 998.0000, 'ºC'),
	(153969, 120, '2014-01-15 01:20:53.000000', 'temperatura', 467.0000, 'ºC'),
	(153970, 120, '2014-01-15 01:20:54.000000', 'temperatura', 543.0000, 'ºC'),
	(153971, 120, '2014-01-15 01:20:55.000000', 'temperatura', 112.0000, 'ºC'),
	(153972, 120, '2014-01-15 01:20:56.000000', 'temperatura', 132.0000, 'ºC'),
	(153973, 120, '2014-01-15 01:20:57.000000', 'temperatura', 325.0000, 'ºC'),
	(153974, 120, '2014-01-15 01:20:58.000000', 'temperatura', 31.0000, 'ºC'),
	(153975, 120, '2014-01-15 01:20:59.000000', 'temperatura', 380.0000, 'ºC'),
	(153976, 120, '2014-01-15 01:21:00.000000', 'temperatura', 609.0000, 'ºC'),
	(153977, 120, '2014-01-15 01:21:01.000000', 'temperatura', 703.0000, 'ºC'),
	(153978, 120, '2014-01-15 01:21:02.000000', 'temperatura', 489.0000, 'ºC'),
	(153979, 120, '2014-01-15 01:21:03.000000', 'temperatura', 339.0000, 'ºC'),
	(153980, 120, '2014-01-15 01:21:04.000000', 'temperatura', 226.0000, 'ºC'),
	(153981, 120, '2014-01-15 01:21:05.000000', 'temperatura', 114.0000, 'ºC'),
	(153982, 120, '2014-01-15 01:21:06.000000', 'temperatura', 1094.0000, 'ºC'),
	(153983, 120, '2014-01-15 01:21:07.000000', 'temperatura', 329.0000, 'ºC'),
	(153984, 120, '2014-01-15 01:21:08.000000', 'temperatura', 763.0000, 'ºC'),
	(153985, 120, '2014-01-15 01:21:09.000000', 'temperatura', 428.0000, 'ºC'),
	(153986, 120, '2014-01-15 01:21:10.000000', 'temperatura', 1050.0000, 'ºC'),
	(153987, 120, '2014-01-15 01:21:11.000000', 'temperatura', 367.0000, 'ºC'),
	(153988, 120, '2014-01-15 01:21:12.000000', 'temperatura', 1088.0000, 'ºC'),
	(153989, 120, '2014-01-15 01:21:13.000000', 'temperatura', 738.0000, 'ºC'),
	(153990, 120, '2014-01-15 01:21:14.000000', 'temperatura', 426.0000, 'ºC'),
	(153991, 120, '2014-01-15 01:21:15.000000', 'temperatura', 1117.0000, 'ºC'),
	(153992, 120, '2014-01-15 01:21:16.000000', 'temperatura', 707.0000, 'ºC'),
	(153993, 120, '2014-01-15 01:21:17.000000', 'temperatura', 183.0000, 'ºC'),
	(153994, 120, '2014-01-15 01:21:18.000000', 'temperatura', 1196.0000, 'ºC'),
	(153995, 120, '2014-01-15 01:21:19.000000', 'temperatura', 630.0000, 'ºC'),
	(153996, 120, '2014-01-15 01:21:20.000000', 'temperatura', 763.0000, 'ºC'),
	(153997, 120, '2014-01-15 01:21:21.000000', 'temperatura', 724.0000, 'ºC'),
	(153998, 120, '2014-01-15 01:21:22.000000', 'temperatura', 134.0000, 'ºC'),
	(153999, 120, '2014-01-15 01:21:23.000000', 'temperatura', 896.0000, 'ºC'),
	(154000, 120, '2014-01-15 01:21:24.000000', 'temperatura', 479.0000, 'ºC'),
	(154001, 120, '2014-01-15 01:21:25.000000', 'temperatura', 909.0000, 'ºC'),
	(154002, 120, '2014-01-15 01:21:26.000000', 'temperatura', 707.0000, 'ºC'),
	(154003, 120, '2014-01-15 01:21:27.000000', 'temperatura', 807.0000, 'ºC'),
	(154004, 120, '2014-01-15 01:21:28.000000', 'temperatura', 717.0000, 'ºC'),
	(154005, 120, '2014-01-15 01:21:29.000000', 'temperatura', 1162.0000, 'ºC'),
	(154006, 120, '2014-01-15 01:21:30.000000', 'temperatura', 59.0000, 'ºC'),
	(154007, 120, '2014-01-15 01:21:31.000000', 'temperatura', 412.0000, 'ºC'),
	(154008, 120, '2014-01-15 01:21:32.000000', 'temperatura', 684.0000, 'ºC'),
	(154009, 120, '2014-01-15 01:21:33.000000', 'temperatura', 983.0000, 'ºC'),
	(154010, 120, '2014-01-15 01:21:34.000000', 'temperatura', 463.0000, 'ºC'),
	(154011, 120, '2014-01-15 01:21:35.000000', 'temperatura', 566.0000, 'ºC'),
	(154012, 120, '2014-01-15 01:21:36.000000', 'temperatura', 244.0000, 'ºC'),
	(154013, 120, '2014-01-15 01:21:37.000000', 'temperatura', 723.0000, 'ºC'),
	(154014, 120, '2014-01-15 01:21:38.000000', 'temperatura', 482.0000, 'ºC'),
	(154015, 120, '2014-01-15 01:21:39.000000', 'temperatura', 242.0000, 'ºC'),
	(154016, 120, '2014-01-15 01:21:40.000000', 'temperatura', 962.0000, 'ºC'),
	(154017, 120, '2014-01-15 01:21:41.000000', 'temperatura', 487.0000, 'ºC'),
	(154018, 120, '2014-01-15 01:21:42.000000', 'temperatura', 750.0000, 'ºC'),
	(154019, 120, '2014-01-15 01:21:43.000000', 'temperatura', 1090.0000, 'ºC'),
	(154020, 120, '2014-01-15 01:21:44.000000', 'temperatura', 799.0000, 'ºC'),
	(154021, 120, '2014-01-15 01:21:45.000000', 'temperatura', 726.0000, 'ºC'),
	(154022, 120, '2014-01-15 01:21:46.000000', 'temperatura', 34.0000, 'ºC'),
	(154023, 120, '2014-01-15 01:21:47.000000', 'temperatura', 390.0000, 'ºC'),
	(154024, 120, '2014-01-15 01:21:48.000000', 'temperatura', 652.0000, 'ºC'),
	(154025, 120, '2014-01-15 01:21:49.000000', 'temperatura', 889.0000, 'ºC'),
	(154026, 120, '2014-01-15 01:21:50.000000', 'temperatura', 91.0000, 'ºC'),
	(154027, 120, '2014-01-15 01:21:51.000000', 'temperatura', 185.0000, 'ºC'),
	(154028, 120, '2014-01-15 01:21:52.000000', 'temperatura', 656.0000, 'ºC'),
	(154029, 120, '2014-01-15 01:21:53.000000', 'temperatura', 325.0000, 'ºC'),
	(154030, 120, '2014-01-15 01:21:54.000000', 'temperatura', 856.0000, 'ºC'),
	(154031, 120, '2014-01-15 01:21:55.000000', 'temperatura', 906.0000, 'ºC'),
	(154032, 120, '2014-01-15 01:21:56.000000', 'temperatura', 761.0000, 'ºC'),
	(154033, 120, '2014-01-15 01:21:57.000000', 'temperatura', 1091.0000, 'ºC'),
	(154034, 120, '2014-01-15 01:21:58.000000', 'temperatura', 769.0000, 'ºC'),
	(154035, 120, '2014-01-15 01:21:59.000000', 'temperatura', 575.0000, 'ºC'),
	(154036, 120, '2014-01-15 01:22:00.000000', 'temperatura', 566.0000, 'ºC'),
	(154037, 120, '2014-01-15 01:22:01.000000', 'temperatura', 1108.0000, 'ºC'),
	(154038, 120, '2014-01-15 01:22:02.000000', 'temperatura', 242.0000, 'ºC'),
	(154039, 120, '2014-01-15 01:22:03.000000', 'temperatura', 285.0000, 'ºC'),
	(154040, 120, '2014-01-15 01:22:04.000000', 'temperatura', 701.0000, 'ºC'),
	(154041, 120, '2014-01-15 01:22:05.000000', 'temperatura', 248.0000, 'ºC'),
	(154042, 120, '2014-01-15 01:22:06.000000', 'temperatura', 339.0000, 'ºC'),
	(154043, 120, '2014-01-15 01:22:07.000000', 'temperatura', 952.0000, 'ºC'),
	(154044, 120, '2014-01-15 01:22:08.000000', 'temperatura', 143.0000, 'ºC'),
	(154045, 120, '2014-01-15 01:22:09.000000', 'temperatura', 262.0000, 'ºC'),
	(154046, 120, '2014-01-15 01:22:10.000000', 'temperatura', 878.0000, 'ºC'),
	(154047, 120, '2014-01-15 01:22:11.000000', 'temperatura', 7.0000, 'ºC'),
	(154048, 120, '2014-01-15 01:22:12.000000', 'temperatura', 1000.0000, 'ºC'),
	(154049, 120, '2014-01-15 01:22:13.000000', 'temperatura', 178.0000, 'ºC'),
	(154050, 120, '2014-01-15 01:22:14.000000', 'temperatura', 293.0000, 'ºC'),
	(154051, 120, '2014-01-15 01:22:15.000000', 'temperatura', 932.0000, 'ºC'),
	(154052, 120, '2014-01-15 01:22:16.000000', 'temperatura', 179.0000, 'ºC'),
	(154053, 120, '2014-01-15 01:22:17.000000', 'temperatura', 500.0000, 'ºC'),
	(154054, 120, '2014-01-15 01:22:18.000000', 'temperatura', 762.0000, 'ºC'),
	(154055, 120, '2014-01-15 01:22:19.000000', 'temperatura', 1113.0000, 'ºC'),
	(154056, 120, '2014-01-15 01:22:20.000000', 'temperatura', 879.0000, 'ºC'),
	(154057, 120, '2014-01-15 01:22:21.000000', 'temperatura', 1056.0000, 'ºC'),
	(154058, 120, '2014-01-15 01:22:22.000000', 'temperatura', 242.0000, 'ºC'),
	(154059, 120, '2014-01-15 01:22:23.000000', 'temperatura', 442.0000, 'ºC'),
	(154060, 120, '2014-01-15 01:22:24.000000', 'temperatura', 286.0000, 'ºC'),
	(154061, 120, '2014-01-15 01:22:25.000000', 'temperatura', 106.0000, 'ºC'),
	(154062, 120, '2014-01-15 01:22:26.000000', 'temperatura', 871.0000, 'ºC'),
	(154063, 120, '2014-01-15 01:22:27.000000', 'temperatura', 438.0000, 'ºC'),
	(154064, 120, '2014-01-15 01:22:28.000000', 'temperatura', 778.0000, 'ºC'),
	(154065, 120, '2014-01-15 01:22:29.000000', 'temperatura', 177.0000, 'ºC'),
	(154066, 120, '2014-01-15 01:22:30.000000', 'temperatura', 949.0000, 'ºC'),
	(154067, 120, '2014-01-15 01:22:31.000000', 'temperatura', 615.0000, 'ºC'),
	(154068, 120, '2014-01-15 01:22:32.000000', 'temperatura', 230.0000, 'ºC'),
	(154069, 120, '2014-01-15 01:22:33.000000', 'temperatura', 503.0000, 'ºC'),
	(154070, 120, '2014-01-15 01:22:34.000000', 'temperatura', 628.0000, 'ºC'),
	(154071, 120, '2014-01-15 01:22:35.000000', 'temperatura', 431.0000, 'ºC'),
	(154072, 120, '2014-01-15 01:22:36.000000', 'temperatura', 272.0000, 'ºC'),
	(154073, 120, '2014-01-15 01:22:37.000000', 'temperatura', 65.0000, 'ºC'),
	(154074, 120, '2014-01-15 01:22:38.000000', 'temperatura', 712.0000, 'ºC'),
	(154075, 120, '2014-01-15 01:22:39.000000', 'temperatura', 965.0000, 'ºC'),
	(154076, 120, '2014-01-15 01:22:40.000000', 'temperatura', 288.0000, 'ºC'),
	(154077, 120, '2014-01-15 01:22:41.000000', 'temperatura', 947.0000, 'ºC'),
	(154078, 120, '2014-01-15 01:22:42.000000', 'temperatura', 272.0000, 'ºC'),
	(154079, 120, '2014-01-15 01:22:43.000000', 'temperatura', 917.0000, 'ºC'),
	(154080, 120, '2014-01-15 01:22:44.000000', 'temperatura', 172.0000, 'ºC'),
	(154081, 120, '2014-01-15 01:22:45.000000', 'temperatura', 509.0000, 'ºC'),
	(154082, 120, '2014-01-15 01:22:46.000000', 'temperatura', 830.0000, 'ºC'),
	(154083, 120, '2014-01-15 01:22:47.000000', 'temperatura', 225.0000, 'ºC'),
	(154084, 120, '2014-01-15 01:22:48.000000', 'temperatura', 1032.0000, 'ºC'),
	(154085, 120, '2014-01-15 01:22:49.000000', 'temperatura', 887.0000, 'ºC'),
	(154086, 120, '2014-01-15 01:22:50.000000', 'temperatura', 139.0000, 'ºC'),
	(154087, 120, '2014-01-15 01:22:51.000000', 'temperatura', 436.0000, 'ºC'),
	(154088, 120, '2014-01-15 01:22:52.000000', 'temperatura', 562.0000, 'ºC'),
	(154089, 120, '2014-01-15 01:22:53.000000', 'temperatura', 304.0000, 'ºC'),
	(154090, 120, '2014-01-15 01:22:54.000000', 'temperatura', 1034.0000, 'ºC'),
	(154091, 120, '2014-01-15 01:22:55.000000', 'temperatura', 659.0000, 'ºC'),
	(154092, 120, '2014-01-15 01:22:56.000000', 'temperatura', 193.0000, 'ºC'),
	(154093, 120, '2014-01-15 01:22:57.000000', 'temperatura', 190.0000, 'ºC'),
	(154094, 120, '2014-01-15 01:22:58.000000', 'temperatura', 369.0000, 'ºC'),
	(154095, 120, '2014-01-15 01:22:59.000000', 'temperatura', 78.0000, 'ºC'),
	(154096, 120, '2014-01-15 01:23:00.000000', 'temperatura', 483.0000, 'ºC'),
	(154097, 120, '2014-01-15 01:23:01.000000', 'temperatura', 983.0000, 'ºC'),
	(154098, 120, '2014-01-15 01:23:02.000000', 'temperatura', 1066.0000, 'ºC'),
	(154099, 120, '2014-01-15 01:23:03.000000', 'temperatura', 1179.0000, 'ºC'),
	(154100, 120, '2014-01-15 01:23:04.000000', 'temperatura', 298.0000, 'ºC'),
	(154101, 120, '2014-01-15 01:23:05.000000', 'temperatura', 354.0000, 'ºC'),
	(154102, 120, '2014-01-15 01:23:06.000000', 'temperatura', 876.0000, 'ºC'),
	(154103, 120, '2014-01-15 01:23:07.000000', 'temperatura', 921.0000, 'ºC'),
	(154104, 120, '2014-01-15 01:23:08.000000', 'temperatura', 775.0000, 'ºC'),
	(154105, 120, '2014-01-15 01:23:09.000000', 'temperatura', 1113.0000, 'ºC'),
	(154106, 120, '2014-01-15 01:23:10.000000', 'temperatura', 839.0000, 'ºC'),
	(154107, 120, '2014-01-15 01:23:11.000000', 'temperatura', 857.0000, 'ºC'),
	(154108, 120, '2014-01-15 01:23:12.000000', 'temperatura', 568.0000, 'ºC'),
	(154109, 120, '2014-01-15 01:23:13.000000', 'temperatura', 271.0000, 'ºC'),
	(154110, 120, '2014-01-15 01:23:14.000000', 'temperatura', 851.0000, 'ºC'),
	(154111, 120, '2014-01-15 01:23:15.000000', 'temperatura', 1043.0000, 'ºC'),
	(154112, 120, '2014-01-15 01:23:16.000000', 'temperatura', 264.0000, 'ºC'),
	(154113, 120, '2014-01-15 01:23:17.000000', 'temperatura', 589.0000, 'ºC'),
	(154114, 120, '2014-01-15 01:23:18.000000', 'temperatura', 952.0000, 'ºC'),
	(154115, 120, '2014-01-15 01:23:19.000000', 'temperatura', 597.0000, 'ºC'),
	(154116, 120, '2014-01-15 01:23:20.000000', 'temperatura', 128.0000, 'ºC'),
	(154117, 120, '2014-01-15 01:23:21.000000', 'temperatura', 48.0000, 'ºC'),
	(154118, 120, '2014-01-15 01:23:22.000000', 'temperatura', 1056.0000, 'ºC'),
	(154119, 120, '2014-01-15 01:23:23.000000', 'temperatura', 340.0000, 'ºC'),
	(154120, 120, '2014-01-15 01:23:24.000000', 'temperatura', 929.0000, 'ºC'),
	(154121, 120, '2014-01-15 01:23:25.000000', 'temperatura', 28.0000, 'ºC'),
	(154122, 120, '2014-01-15 01:23:26.000000', 'temperatura', 951.0000, 'ºC'),
	(154123, 120, '2014-01-15 01:23:27.000000', 'temperatura', 1073.0000, 'ºC'),
	(154124, 120, '2014-01-15 01:23:28.000000', 'temperatura', 111.0000, 'ºC'),
	(154125, 120, '2014-01-15 01:23:29.000000', 'temperatura', 939.0000, 'ºC'),
	(154126, 120, '2014-01-15 01:23:30.000000', 'temperatura', 760.0000, 'ºC'),
	(154127, 120, '2014-01-15 01:23:31.000000', 'temperatura', 983.0000, 'ºC'),
	(154128, 120, '2014-01-15 01:23:32.000000', 'temperatura', 236.0000, 'ºC'),
	(154129, 120, '2014-01-15 01:23:33.000000', 'temperatura', 634.0000, 'ºC'),
	(154130, 120, '2014-01-15 01:23:34.000000', 'temperatura', 61.0000, 'ºC'),
	(154131, 120, '2014-01-15 01:23:35.000000', 'temperatura', 802.0000, 'ºC'),
	(154132, 120, '2014-01-15 01:23:36.000000', 'temperatura', 228.0000, 'ºC'),
	(154133, 120, '2014-01-15 01:23:37.000000', 'temperatura', 1135.0000, 'ºC'),
	(154134, 120, '2014-01-15 01:23:38.000000', 'temperatura', 190.0000, 'ºC'),
	(154135, 120, '2014-01-15 01:23:39.000000', 'temperatura', 1147.0000, 'ºC'),
	(154136, 120, '2014-01-15 01:23:40.000000', 'temperatura', 365.0000, 'ºC'),
	(154137, 120, '2014-01-15 01:23:41.000000', 'temperatura', 783.0000, 'ºC'),
	(154138, 120, '2014-01-15 01:23:42.000000', 'temperatura', 420.0000, 'ºC'),
	(154139, 120, '2014-01-15 01:23:43.000000', 'temperatura', 954.0000, 'ºC'),
	(154140, 120, '2014-01-15 01:23:44.000000', 'temperatura', 1110.0000, 'ºC'),
	(154141, 120, '2014-01-15 01:23:45.000000', 'temperatura', 287.0000, 'ºC'),
	(154142, 120, '2014-01-15 01:23:46.000000', 'temperatura', 504.0000, 'ºC'),
	(154143, 120, '2014-01-15 01:23:47.000000', 'temperatura', 462.0000, 'ºC'),
	(154144, 120, '2014-01-15 01:23:48.000000', 'temperatura', 797.0000, 'ºC'),
	(154145, 120, '2014-01-15 01:23:49.000000', 'temperatura', 202.0000, 'ºC'),
	(154146, 120, '2014-01-15 01:23:50.000000', 'temperatura', 1019.0000, 'ºC'),
	(154147, 120, '2014-01-15 01:23:51.000000', 'temperatura', 887.0000, 'ºC'),
	(154148, 120, '2014-01-15 01:23:52.000000', 'temperatura', 181.0000, 'ºC'),
	(154149, 120, '2014-01-15 01:23:53.000000', 'temperatura', 645.0000, 'ºC'),
	(154150, 120, '2014-01-15 01:23:54.000000', 'temperatura', 281.0000, 'ºC'),
	(154151, 120, '2014-01-15 01:23:55.000000', 'temperatura', 669.0000, 'ºC'),
	(154152, 120, '2014-01-15 01:23:56.000000', 'temperatura', 105.0000, 'ºC'),
	(154153, 120, '2014-01-15 01:23:57.000000', 'temperatura', 919.0000, 'ºC'),
	(154154, 120, '2014-01-15 01:23:58.000000', 'temperatura', 681.0000, 'ºC'),
	(154155, 120, '2014-01-15 01:23:59.000000', 'temperatura', 648.0000, 'ºC'),
	(154156, 120, '2014-01-15 01:24:00.000000', 'temperatura', 1197.0000, 'ºC'),
	(154157, 120, '2014-01-15 01:24:01.000000', 'temperatura', 442.0000, 'ºC'),
	(154158, 120, '2014-01-15 01:24:02.000000', 'temperatura', 1021.0000, 'ºC'),
	(154159, 120, '2014-01-15 01:24:03.000000', 'temperatura', 180.0000, 'ºC'),
	(154160, 120, '2014-01-15 01:24:04.000000', 'temperatura', 235.0000, 'ºC'),
	(154161, 120, '2014-01-15 01:24:05.000000', 'temperatura', 637.0000, 'ºC'),
	(154162, 120, '2014-01-15 01:24:06.000000', 'temperatura', 80.0000, 'ºC'),
	(154163, 120, '2014-01-15 01:24:07.000000', 'temperatura', 890.0000, 'ºC'),
	(154164, 120, '2014-01-15 01:24:08.000000', 'temperatura', 609.0000, 'ºC'),
	(154165, 120, '2014-01-15 01:24:09.000000', 'temperatura', 378.0000, 'ºC'),
	(154166, 120, '2014-01-15 01:24:10.000000', 'temperatura', 61.0000, 'ºC'),
	(154167, 120, '2014-01-15 01:24:11.000000', 'temperatura', 372.0000, 'ºC'),
	(154168, 120, '2014-01-15 01:24:12.000000', 'temperatura', 476.0000, 'ºC'),
	(154169, 120, '2014-01-15 01:24:13.000000', 'temperatura', 65.0000, 'ºC'),
	(154170, 120, '2014-01-15 01:24:14.000000', 'temperatura', 98.0000, 'ºC'),
	(154171, 120, '2014-01-15 01:24:15.000000', 'temperatura', 296.0000, 'ºC'),
	(154172, 120, '2014-01-15 01:24:16.000000', 'temperatura', 1187.0000, 'ºC'),
	(154173, 120, '2014-01-15 01:24:17.000000', 'temperatura', 248.0000, 'ºC'),
	(154174, 120, '2014-01-15 01:24:18.000000', 'temperatura', 80.0000, 'ºC'),
	(154175, 120, '2014-01-15 01:24:19.000000', 'temperatura', 857.0000, 'ºC'),
	(154176, 120, '2014-01-15 01:24:20.000000', 'temperatura', 443.0000, 'ºC'),
	(154177, 120, '2014-01-15 01:24:21.000000', 'temperatura', 844.0000, 'ºC'),
	(154178, 120, '2014-01-15 01:24:22.000000', 'temperatura', 491.0000, 'ºC'),
	(154179, 120, '2014-01-15 01:24:23.000000', 'temperatura', 1123.0000, 'ºC'),
	(154180, 120, '2014-01-15 01:24:24.000000', 'temperatura', 542.0000, 'ºC'),
	(154181, 120, '2014-01-15 01:24:25.000000', 'temperatura', 544.0000, 'ºC'),
	(154182, 120, '2014-01-15 01:24:26.000000', 'temperatura', 1092.0000, 'ºC'),
	(154183, 120, '2014-01-15 01:24:27.000000', 'temperatura', 229.0000, 'ºC'),
	(154184, 120, '2014-01-15 01:24:28.000000', 'temperatura', 269.0000, 'ºC'),
	(154185, 120, '2014-01-15 01:24:29.000000', 'temperatura', 657.0000, 'ºC'),
	(154186, 120, '2014-01-15 01:24:30.000000', 'temperatura', 81.0000, 'ºC'),
	(154187, 120, '2014-01-15 01:24:31.000000', 'temperatura', 834.0000, 'ºC'),
	(154188, 120, '2014-01-15 01:24:32.000000', 'temperatura', 327.0000, 'ºC'),
	(154189, 120, '2014-01-15 01:24:33.000000', 'temperatura', 332.0000, 'ºC'),
	(154190, 120, '2014-01-15 01:24:34.000000', 'temperatura', 679.0000, 'ºC'),
	(154191, 120, '2014-01-15 01:24:35.000000', 'temperatura', 1.0000, 'ºC'),
	(154192, 120, '2014-01-15 01:24:36.000000', 'temperatura', 369.0000, 'ºC'),
	(154193, 120, '2014-01-15 01:24:37.000000', 'temperatura', 641.0000, 'ºC'),
	(154194, 120, '2014-01-15 01:24:38.000000', 'temperatura', 900.0000, 'ºC'),
	(154195, 120, '2014-01-15 01:24:39.000000', 'temperatura', 177.0000, 'ºC'),
	(154196, 120, '2014-01-15 01:24:40.000000', 'temperatura', 586.0000, 'ºC'),
	(154197, 120, '2014-01-15 01:24:41.000000', 'temperatura', 0.0000, 'ºC'),
	(154198, 120, '2014-01-15 01:24:42.000000', 'temperatura', 641.0000, 'ºC'),
	(154199, 120, '2014-01-15 01:24:43.000000', 'temperatura', 805.0000, 'ºC'),
	(154200, 120, '2014-01-15 01:24:44.000000', 'temperatura', 903.0000, 'ºC'),
	(154201, 120, '2014-01-15 01:24:45.000000', 'temperatura', 900.0000, 'ºC'),
	(154202, 120, '2014-01-15 01:24:46.000000', 'temperatura', 592.0000, 'ºC'),
	(154203, 120, '2014-01-15 01:24:47.000000', 'temperatura', 260.0000, 'ºC'),
	(154204, 120, '2014-01-15 01:24:48.000000', 'temperatura', 727.0000, 'ºC'),
	(154205, 120, '2014-01-15 01:24:49.000000', 'temperatura', 453.0000, 'ºC'),
	(154206, 120, '2014-01-15 01:24:50.000000', 'temperatura', 85.0000, 'ºC'),
	(154207, 120, '2014-01-15 01:24:51.000000', 'temperatura', 266.0000, 'ºC'),
	(154208, 120, '2014-01-15 01:24:52.000000', 'temperatura', 1075.0000, 'ºC'),
	(154209, 120, '2014-01-15 01:24:53.000000', 'temperatura', 977.0000, 'ºC'),
	(154210, 120, '2014-01-15 01:24:54.000000', 'temperatura', 461.0000, 'ºC'),
	(154211, 120, '2014-01-15 01:24:55.000000', 'temperatura', 573.0000, 'ºC'),
	(154212, 120, '2014-01-15 01:24:56.000000', 'temperatura', 284.0000, 'ºC'),
	(154213, 120, '2014-01-15 01:24:57.000000', 'temperatura', 899.0000, 'ºC'),
	(154214, 120, '2014-01-15 01:24:58.000000', 'temperatura', 47.0000, 'ºC'),
	(154215, 120, '2014-01-15 01:24:59.000000', 'temperatura', 1136.0000, 'ºC'),
	(154216, 120, '2014-01-15 01:25:00.000000', 'temperatura', 740.0000, 'ºC'),
	(154217, 120, '2014-01-15 01:25:01.000000', 'temperatura', 292.0000, 'ºC'),
	(154218, 120, '2014-01-15 01:25:02.000000', 'temperatura', 439.0000, 'ºC'),
	(154219, 120, '2014-01-15 01:25:03.000000', 'temperatura', 122.0000, 'ºC'),
	(154220, 120, '2014-01-15 01:25:04.000000', 'temperatura', 492.0000, 'ºC'),
	(154221, 120, '2014-01-15 01:25:05.000000', 'temperatura', 897.0000, 'ºC'),
	(154222, 120, '2014-01-15 01:25:06.000000', 'temperatura', 608.0000, 'ºC'),
	(154223, 120, '2014-01-15 01:25:07.000000', 'temperatura', 349.0000, 'ºC'),
	(154224, 120, '2014-01-15 01:25:08.000000', 'temperatura', 1121.0000, 'ºC'),
	(154225, 120, '2014-01-15 01:25:09.000000', 'temperatura', 960.0000, 'ºC'),
	(154226, 120, '2014-01-15 01:25:10.000000', 'temperatura', 237.0000, 'ºC'),
	(154227, 120, '2014-01-15 01:25:11.000000', 'temperatura', 707.0000, 'ºC'),
	(154228, 120, '2014-01-15 01:25:12.000000', 'temperatura', 422.0000, 'ºC'),
	(154229, 120, '2014-01-15 01:25:13.000000', 'temperatura', 1191.0000, 'ºC'),
	(154230, 120, '2014-01-15 01:25:14.000000', 'temperatura', 1090.0000, 'ºC'),
	(154231, 120, '2014-01-15 01:25:15.000000', 'temperatura', 678.0000, 'ºC'),
	(154232, 120, '2014-01-15 01:25:16.000000', 'temperatura', 119.0000, 'ºC'),
	(154233, 120, '2014-01-15 01:25:17.000000', 'temperatura', 964.0000, 'ºC'),
	(154234, 120, '2014-01-15 01:25:18.000000', 'temperatura', 862.0000, 'ºC'),
	(154235, 120, '2014-01-15 01:25:19.000000', 'temperatura', 218.0000, 'ºC'),
	(154236, 120, '2014-01-15 01:25:20.000000', 'temperatura', 904.0000, 'ºC'),
	(154237, 120, '2014-01-15 01:25:21.000000', 'temperatura', 266.0000, 'ºC'),
	(154238, 120, '2014-01-15 01:25:22.000000', 'temperatura', 1018.0000, 'ºC'),
	(154239, 120, '2014-01-15 01:25:23.000000', 'temperatura', 692.0000, 'ºC'),
	(154240, 120, '2014-01-15 01:25:24.000000', 'temperatura', 409.0000, 'ºC'),
	(154241, 120, '2014-01-15 01:25:25.000000', 'temperatura', 1168.0000, 'ºC'),
	(154242, 120, '2014-01-15 01:25:26.000000', 'temperatura', 1013.0000, 'ºC'),
	(154243, 120, '2014-01-15 01:25:27.000000', 'temperatura', 361.0000, 'ºC'),
	(154244, 120, '2014-01-15 01:25:28.000000', 'temperatura', 1167.0000, 'ºC'),
	(154245, 120, '2014-01-15 01:25:29.000000', 'temperatura', 1153.0000, 'ºC'),
	(154246, 120, '2014-01-15 01:25:30.000000', 'temperatura', 1066.0000, 'ºC'),
	(154247, 120, '2014-01-15 01:25:31.000000', 'temperatura', 670.0000, 'ºC'),
	(154248, 120, '2014-01-15 01:25:32.000000', 'temperatura', 152.0000, 'ºC'),
	(154249, 120, '2014-01-15 01:25:33.000000', 'temperatura', 1152.0000, 'ºC'),
	(154250, 120, '2014-01-15 01:25:34.000000', 'temperatura', 504.0000, 'ºC'),
	(154251, 120, '2014-01-15 01:25:35.000000', 'temperatura', 266.0000, 'ºC'),
	(154252, 120, '2014-01-15 01:25:36.000000', 'temperatura', 1019.0000, 'ºC'),
	(154253, 120, '2014-01-15 01:25:37.000000', 'temperatura', 696.0000, 'ºC'),
	(154254, 120, '2014-01-15 01:25:38.000000', 'temperatura', 422.0000, 'ºC'),
	(154255, 120, '2014-01-15 01:25:39.000000', 'temperatura', 23.0000, 'ºC'),
	(154256, 120, '2014-01-15 01:25:40.000000', 'temperatura', 51.0000, 'ºC'),
	(154257, 120, '2014-01-15 01:25:41.000000', 'temperatura', 187.0000, 'ºC'),
	(154258, 120, '2014-01-15 01:25:42.000000', 'temperatura', 783.0000, 'ºC'),
	(154259, 120, '2014-01-15 01:25:43.000000', 'temperatura', 955.0000, 'ºC'),
	(154260, 120, '2014-01-15 01:25:44.000000', 'temperatura', 26.0000, 'ºC'),
	(154261, 120, '2014-01-15 01:25:45.000000', 'temperatura', 865.0000, 'ºC'),
	(154262, 120, '2014-01-15 01:25:46.000000', 'temperatura', 646.0000, 'ºC'),
	(154263, 120, '2014-01-15 01:25:47.000000', 'temperatura', 636.0000, 'ºC'),
	(154264, 120, '2014-01-15 01:25:48.000000', 'temperatura', 44.0000, 'ºC'),
	(154265, 120, '2014-01-15 01:25:49.000000', 'temperatura', 714.0000, 'ºC'),
	(154266, 120, '2014-01-15 01:25:50.000000', 'temperatura', 1035.0000, 'ºC'),
	(154267, 120, '2014-01-15 01:25:51.000000', 'temperatura', 636.0000, 'ºC'),
	(154268, 120, '2014-01-15 01:25:52.000000', 'temperatura', 76.0000, 'ºC'),
	(154269, 120, '2014-01-15 01:25:53.000000', 'temperatura', 874.0000, 'ºC'),
	(154270, 120, '2014-01-15 01:25:54.000000', 'temperatura', 539.0000, 'ºC'),
	(154271, 120, '2014-01-15 01:25:55.000000', 'temperatura', 74.0000, 'ºC'),
	(154272, 120, '2014-01-15 01:25:56.000000', 'temperatura', 1152.0000, 'ºC'),
	(154273, 120, '2014-01-15 01:25:57.000000', 'temperatura', 740.0000, 'ºC'),
	(154274, 120, '2014-01-15 01:25:58.000000', 'temperatura', 243.0000, 'ºC'),
	(154275, 120, '2014-01-15 01:25:59.000000', 'temperatura', 197.0000, 'ºC'),
	(154276, 120, '2014-01-15 01:26:00.000000', 'temperatura', 255.0000, 'ºC'),
	(154277, 120, '2014-01-15 01:26:01.000000', 'temperatura', 685.0000, 'ºC'),
	(154278, 120, '2014-01-15 01:26:02.000000', 'temperatura', 262.0000, 'ºC'),
	(154279, 120, '2014-01-15 01:26:03.000000', 'temperatura', 453.0000, 'ºC'),
	(154280, 120, '2014-01-15 01:26:04.000000', 'temperatura', 279.0000, 'ºC'),
	(154281, 120, '2014-01-15 01:26:05.000000', 'temperatura', 39.0000, 'ºC'),
	(154282, 120, '2014-01-15 01:26:06.000000', 'temperatura', 557.0000, 'ºC'),
	(154283, 120, '2014-01-15 01:26:07.000000', 'temperatura', 267.0000, 'ºC'),
	(154284, 120, '2014-01-15 01:26:08.000000', 'temperatura', 868.0000, 'ºC'),
	(154285, 120, '2014-01-15 01:26:09.000000', 'temperatura', 1138.0000, 'ºC'),
	(154286, 120, '2014-01-15 01:26:10.000000', 'temperatura', 686.0000, 'ºC'),
	(154287, 120, '2014-01-15 01:26:11.000000', 'temperatura', 15.0000, 'ºC'),
	(154288, 120, '2014-01-15 01:26:12.000000', 'temperatura', 420.0000, 'ºC'),
	(154289, 120, '2014-01-15 01:26:13.000000', 'temperatura', 853.0000, 'ºC'),
	(154290, 120, '2014-01-15 01:26:14.000000', 'temperatura', 608.0000, 'ºC'),
	(154291, 120, '2014-01-15 01:26:15.000000', 'temperatura', 480.0000, 'ºC'),
	(154292, 120, '2014-01-15 01:26:16.000000', 'temperatura', 576.0000, 'ºC'),
	(154293, 120, '2014-01-15 01:26:17.000000', 'temperatura', 243.0000, 'ºC'),
	(154294, 120, '2014-01-15 01:26:18.000000', 'temperatura', 686.0000, 'ºC'),
	(154295, 120, '2014-01-15 01:26:19.000000', 'temperatura', 301.0000, 'ºC'),
	(154296, 120, '2014-01-15 01:26:20.000000', 'temperatura', 649.0000, 'ºC'),
	(154297, 120, '2014-01-15 01:26:21.000000', 'temperatura', 1140.0000, 'ºC'),
	(154298, 120, '2014-01-15 01:26:22.000000', 'temperatura', 156.0000, 'ºC'),
	(154299, 120, '2014-01-15 01:26:23.000000', 'temperatura', 960.0000, 'ºC'),
	(154300, 120, '2014-01-15 01:26:24.000000', 'temperatura', 730.0000, 'ºC'),
	(154301, 120, '2014-01-15 01:26:25.000000', 'temperatura', 774.0000, 'ºC'),
	(154302, 120, '2014-01-15 01:26:26.000000', 'temperatura', 477.0000, 'ºC'),
	(154303, 120, '2014-01-15 01:26:27.000000', 'temperatura', 67.0000, 'ºC'),
	(154304, 120, '2014-01-15 01:26:28.000000', 'temperatura', 102.0000, 'ºC'),
	(154305, 120, '2014-01-15 01:26:29.000000', 'temperatura', 309.0000, 'ºC'),
	(154306, 120, '2014-01-15 01:26:30.000000', 'temperatura', 40.0000, 'ºC'),
	(154307, 120, '2014-01-15 01:26:31.000000', 'temperatura', 474.0000, 'ºC'),
	(154308, 120, '2014-01-15 01:26:32.000000', 'temperatura', 1051.0000, 'ºC'),
	(154309, 120, '2014-01-15 01:26:33.000000', 'temperatura', 233.0000, 'ºC'),
	(154310, 120, '2014-01-15 01:26:34.000000', 'temperatura', 414.0000, 'ºC'),
	(154311, 120, '2014-01-15 01:26:35.000000', 'temperatura', 171.0000, 'ºC'),
	(154312, 120, '2014-01-15 01:26:36.000000', 'temperatura', 815.0000, 'ºC'),
	(154313, 120, '2014-01-15 01:26:37.000000', 'temperatura', 1159.0000, 'ºC'),
	(154314, 120, '2014-01-15 01:26:38.000000', 'temperatura', 953.0000, 'ºC'),
	(154315, 120, '2014-01-15 01:26:39.000000', 'temperatura', 87.0000, 'ºC'),
	(154316, 120, '2014-01-15 01:26:40.000000', 'temperatura', 1178.0000, 'ºC'),
	(154317, 120, '2014-01-15 01:26:41.000000', 'temperatura', 829.0000, 'ºC'),
	(154318, 120, '2014-01-15 01:26:42.000000', 'temperatura', 612.0000, 'ºC'),
	(154319, 120, '2014-01-15 01:26:43.000000', 'temperatura', 575.0000, 'ºC'),
	(154320, 120, '2014-01-15 01:26:44.000000', 'temperatura', 1037.0000, 'ºC'),
	(154321, 120, '2014-01-15 01:26:45.000000', 'temperatura', 1060.0000, 'ºC'),
	(154322, 120, '2014-01-15 01:26:46.000000', 'temperatura', 992.0000, 'ºC'),
	(154323, 120, '2014-01-15 01:26:47.000000', 'temperatura', 581.0000, 'ºC'),
	(154324, 120, '2014-01-15 01:26:48.000000', 'temperatura', 1129.0000, 'ºC'),
	(154325, 120, '2014-01-15 01:26:49.000000', 'temperatura', 303.0000, 'ºC'),
	(154326, 120, '2014-01-15 01:26:50.000000', 'temperatura', 529.0000, 'ºC'),
	(154327, 120, '2014-01-15 01:26:51.000000', 'temperatura', 537.0000, 'ºC'),
	(154328, 120, '2014-01-15 01:26:52.000000', 'temperatura', 1098.0000, 'ºC'),
	(154329, 120, '2014-01-15 01:26:53.000000', 'temperatura', 280.0000, 'ºC'),
	(154330, 120, '2014-01-15 01:26:54.000000', 'temperatura', 508.0000, 'ºC'),
	(154331, 120, '2014-01-15 01:26:55.000000', 'temperatura', 499.0000, 'ºC'),
	(154332, 120, '2014-01-15 01:26:56.000000', 'temperatura', 973.0000, 'ºC'),
	(154333, 120, '2014-01-15 01:26:57.000000', 'temperatura', 968.0000, 'ºC'),
	(154334, 120, '2014-01-15 01:26:58.000000', 'temperatura', 722.0000, 'ºC'),
	(154335, 120, '2014-01-15 01:26:59.000000', 'temperatura', 706.0000, 'ºC'),
	(154336, 120, '2014-01-15 01:27:00.000000', 'temperatura', 163.0000, 'ºC'),
	(154337, 120, '2014-01-15 01:27:01.000000', 'temperatura', 1099.0000, 'ºC'),
	(154338, 120, '2014-01-15 01:27:02.000000', 'temperatura', 206.0000, 'ºC'),
	(154339, 120, '2014-01-15 01:27:03.000000', 'temperatura', 134.0000, 'ºC'),
	(154340, 120, '2014-01-15 01:27:04.000000', 'temperatura', 52.0000, 'ºC'),
	(154341, 120, '2014-01-15 01:27:05.000000', 'temperatura', 1060.0000, 'ºC'),
	(154342, 120, '2014-01-15 01:27:06.000000', 'temperatura', 342.0000, 'ºC'),
	(154343, 120, '2014-01-15 01:27:07.000000', 'temperatura', 931.0000, 'ºC'),
	(154344, 120, '2014-01-15 01:27:08.000000', 'temperatura', 29.0000, 'ºC'),
	(154345, 120, '2014-01-15 01:27:09.000000', 'temperatura', 952.0000, 'ºC'),
	(154346, 120, '2014-01-15 01:27:10.000000', 'temperatura', 1073.0000, 'ºC'),
	(154347, 120, '2014-01-15 01:27:11.000000', 'temperatura', 110.0000, 'ºC'),
	(154348, 120, '2014-01-15 01:27:12.000000', 'temperatura', 933.0000, 'ºC'),
	(154349, 120, '2014-01-15 01:27:13.000000', 'temperatura', 736.0000, 'ºC'),
	(154350, 120, '2014-01-15 01:27:14.000000', 'temperatura', 881.0000, 'ºC'),
	(154351, 120, '2014-01-15 01:27:15.000000', 'temperatura', 997.0000, 'ºC'),
	(154352, 120, '2014-01-15 01:27:16.000000', 'temperatura', 1141.0000, 'ºC'),
	(154353, 120, '2014-01-15 01:27:17.000000', 'temperatura', 316.0000, 'ºC'),
	(154354, 120, '2014-01-15 01:27:18.000000', 'temperatura', 558.0000, 'ºC'),
	(154355, 120, '2014-01-15 01:27:19.000000', 'temperatura', 643.0000, 'ºC'),
	(154356, 120, '2014-01-15 01:27:20.000000', 'temperatura', 341.0000, 'ºC'),
	(154357, 120, '2014-01-15 01:27:21.000000', 'temperatura', 976.0000, 'ºC'),
	(154358, 120, '2014-01-15 01:27:22.000000', 'temperatura', 257.0000, 'ºC'),
	(154359, 120, '2014-01-15 01:27:23.000000', 'temperatura', 756.0000, 'ºC'),
	(154360, 120, '2014-01-15 01:27:24.000000', 'temperatura', 611.0000, 'ºC'),
	(154361, 120, '2014-01-15 01:27:25.000000', 'temperatura', 786.0000, 'ºC'),
	(154362, 120, '2014-01-15 01:27:26.000000', 'temperatura', 899.0000, 'ºC'),
	(154363, 120, '2014-01-15 01:27:27.000000', 'temperatura', 939.0000, 'ºC'),
	(154364, 120, '2014-01-15 01:27:28.000000', 'temperatura', 798.0000, 'ºC'),
	(154365, 120, '2014-01-15 01:27:29.000000', 'temperatura', 1174.0000, 'ºC'),
	(154366, 120, '2014-01-15 01:27:30.000000', 'temperatura', 1076.0000, 'ºC'),
	(154367, 120, '2014-01-15 01:27:31.000000', 'temperatura', 660.0000, 'ºC'),
	(154368, 120, '2014-01-15 01:27:32.000000', 'temperatura', 72.0000, 'ºC'),
	(154369, 120, '2014-01-15 01:27:33.000000', 'temperatura', 781.0000, 'ºC'),
	(154370, 120, '2014-01-15 01:27:34.000000', 'temperatura', 89.0000, 'ºC'),
	(154371, 120, '2014-01-15 01:27:35.000000', 'temperatura', 501.0000, 'ºC'),
	(154372, 120, '2014-01-15 01:27:36.000000', 'temperatura', 1038.0000, 'ºC'),
	(154373, 120, '2014-01-15 01:27:37.000000', 'temperatura', 87.0000, 'ºC'),
	(154374, 120, '2014-01-15 01:27:38.000000', 'temperatura', 922.0000, 'ºC'),
	(154375, 120, '2014-01-15 01:27:39.000000', 'temperatura', 751.0000, 'ºC'),
	(154376, 120, '2014-01-15 01:27:40.000000', 'temperatura', 987.0000, 'ºC'),
	(154377, 120, '2014-01-15 01:27:41.000000', 'temperatura', 286.0000, 'ºC'),
	(154378, 120, '2014-01-15 01:27:42.000000', 'temperatura', 867.0000, 'ºC'),
	(154379, 120, '2014-01-15 01:27:43.000000', 'temperatura', 1076.0000, 'ºC'),
	(154380, 120, '2014-01-15 01:27:44.000000', 'temperatura', 383.0000, 'ºC'),
	(154381, 120, '2014-01-15 01:27:45.000000', 'temperatura', 1085.0000, 'ºC'),
	(154382, 120, '2014-01-15 01:27:46.000000', 'temperatura', 676.0000, 'ºC'),
	(154383, 120, '2014-01-15 01:27:47.000000', 'temperatura', 127.0000, 'ºC'),
	(154384, 120, '2014-01-15 01:27:48.000000', 'temperatura', 1006.0000, 'ºC'),
	(154385, 120, '2014-01-15 01:27:49.000000', 'temperatura', 1049.0000, 'ºC'),
	(154386, 120, '2014-01-15 01:27:50.000000', 'temperatura', 1030.0000, 'ºC'),
	(154387, 120, '2014-01-15 01:27:51.000000', 'temperatura', 803.0000, 'ºC'),
	(154388, 120, '2014-01-15 01:27:52.000000', 'temperatura', 926.0000, 'ºC'),
	(154389, 120, '2014-01-15 01:27:53.000000', 'temperatura', 1020.0000, 'ºC'),
	(154390, 120, '2014-01-15 01:27:54.000000', 'temperatura', 1123.0000, 'ºC'),
	(154391, 120, '2014-01-15 01:27:55.000000', 'temperatura', 157.0000, 'ºC'),
	(154392, 120, '2014-01-15 01:27:56.000000', 'temperatura', 1015.0000, 'ºC'),
	(154393, 120, '2014-01-15 01:27:57.000000', 'temperatura', 1007.0000, 'ºC'),
	(154394, 120, '2014-01-15 01:27:58.000000', 'temperatura', 788.0000, 'ºC'),
	(154395, 120, '2014-01-15 01:27:59.000000', 'temperatura', 919.0000, 'ºC'),
	(154396, 120, '2014-01-15 01:28:00.000000', 'temperatura', 1032.0000, 'ºC'),
	(154397, 120, '2014-01-15 01:28:01.000000', 'temperatura', 5.0000, 'ºC'),
	(154398, 120, '2014-01-15 01:28:02.000000', 'temperatura', 527.0000, 'ºC'),
	(154399, 120, '2014-01-15 01:28:03.000000', 'temperatura', 222.0000, 'ºC'),
	(154400, 120, '2014-01-15 01:28:04.000000', 'temperatura', 728.0000, 'ºC'),
	(154401, 120, '2014-01-15 01:28:05.000000', 'temperatura', 576.0000, 'ºC'),
	(154402, 120, '2014-01-15 01:28:06.000000', 'temperatura', 697.0000, 'ºC'),
	(154403, 120, '2014-01-15 01:28:07.000000', 'temperatura', 559.0000, 'ºC'),
	(154404, 120, '2014-01-15 01:28:08.000000', 'temperatura', 702.0000, 'ºC'),
	(154405, 120, '2014-01-15 01:28:09.000000', 'temperatura', 634.0000, 'ºC'),
	(154406, 120, '2014-01-15 01:28:10.000000', 'temperatura', 1065.0000, 'ºC'),
	(154407, 120, '2014-01-15 01:28:11.000000', 'temperatura', 1023.0000, 'ºC'),
	(154408, 120, '2014-01-15 01:28:12.000000', 'temperatura', 719.0000, 'ºC'),
	(154409, 120, '2014-01-15 01:28:13.000000', 'temperatura', 528.0000, 'ºC'),
	(154410, 120, '2014-01-15 01:28:14.000000', 'temperatura', 483.0000, 'ºC'),
	(154411, 120, '2014-01-15 01:28:15.000000', 'temperatura', 831.0000, 'ºC'),
	(154412, 120, '2014-01-15 01:28:16.000000', 'temperatura', 308.0000, 'ºC'),
	(154413, 120, '2014-01-15 01:28:17.000000', 'temperatura', 247.0000, 'ºC'),
	(154414, 120, '2014-01-15 01:28:18.000000', 'temperatura', 312.0000, 'ºC'),
	(154415, 120, '2014-01-15 01:28:19.000000', 'temperatura', 819.0000, 'ºC'),
	(154416, 120, '2014-01-15 01:28:20.000000', 'temperatura', 759.0000, 'ºC'),
	(154417, 120, '2014-01-15 01:28:21.000000', 'temperatura', 137.0000, 'ºC'),
	(154418, 120, '2014-01-15 01:28:22.000000', 'temperatura', 810.0000, 'ºC'),
	(154419, 120, '2014-01-15 01:28:23.000000', 'temperatura', 41.0000, 'ºC'),
	(154420, 120, '2014-01-15 01:28:24.000000', 'temperatura', 174.0000, 'ºC'),
	(154421, 120, '2014-01-15 01:28:25.000000', 'temperatura', 747.0000, 'ºC'),
	(154422, 120, '2014-01-15 01:28:26.000000', 'temperatura', 812.0000, 'ºC'),
	(154423, 120, '2014-01-15 01:28:27.000000', 'temperatura', 623.0000, 'ºC'),
	(154424, 120, '2014-01-15 01:28:28.000000', 'temperatura', 678.0000, 'ºC'),
	(154425, 120, '2014-01-15 01:28:29.000000', 'temperatura', 319.0000, 'ºC'),
	(154426, 120, '2014-01-15 01:28:30.000000', 'temperatura', 765.0000, 'ºC'),
	(154427, 120, '2014-01-15 01:28:31.000000', 'temperatura', 468.0000, 'ºC'),
	(154428, 120, '2014-01-15 01:28:32.000000', 'temperatura', 44.0000, 'ºC'),
	(154429, 120, '2014-01-15 01:28:33.000000', 'temperatura', 18.0000, 'ºC'),
	(154430, 120, '2014-01-15 01:28:34.000000', 'temperatura', 1156.0000, 'ºC'),
	(154431, 120, '2014-01-15 01:28:35.000000', 'temperatura', 929.0000, 'ºC'),
	(154432, 120, '2014-01-15 01:28:36.000000', 'temperatura', 1177.0000, 'ºC'),
	(154433, 120, '2014-01-15 01:28:37.000000', 'temperatura', 700.0000, 'ºC'),
	(154434, 120, '2014-01-15 01:28:38.000000', 'temperatura', 1167.0000, 'ºC'),
	(154435, 120, '2014-01-15 01:28:39.000000', 'temperatura', 136.0000, 'ºC'),
	(154436, 120, '2014-01-15 01:28:40.000000', 'temperatura', 781.0000, 'ºC'),
	(154437, 120, '2014-01-15 01:28:41.000000', 'temperatura', 1095.0000, 'ºC'),
	(154438, 120, '2014-01-15 01:28:42.000000', 'temperatura', 733.0000, 'ºC'),
	(154439, 120, '2014-01-15 01:28:43.000000', 'temperatura', 382.0000, 'ºC'),
	(154440, 120, '2014-01-15 01:28:44.000000', 'temperatura', 913.0000, 'ºC'),
	(154441, 120, '2014-01-15 01:28:45.000000', 'temperatura', 1017.0000, 'ºC'),
	(154442, 120, '2014-01-15 01:28:46.000000', 'temperatura', 1145.0000, 'ºC'),
	(154443, 120, '2014-01-15 01:28:47.000000', 'temperatura', 277.0000, 'ºC'),
	(154444, 120, '2014-01-15 01:28:48.000000', 'temperatura', 349.0000, 'ºC'),
	(154445, 120, '2014-01-15 01:28:49.000000', 'temperatura', 915.0000, 'ºC'),
	(154446, 120, '2014-01-15 01:28:50.000000', 'temperatura', 1131.0000, 'ºC'),
	(154447, 120, '2014-01-15 01:28:51.000000', 'temperatura', 507.0000, 'ºC'),
	(154448, 120, '2014-01-15 01:28:52.000000', 'temperatura', 344.0000, 'ºC'),
	(154449, 120, '2014-01-15 01:28:53.000000', 'temperatura', 199.0000, 'ºC'),
	(154450, 120, '2014-01-15 01:28:54.000000', 'temperatura', 1165.0000, 'ºC'),
	(154451, 120, '2014-01-15 01:28:55.000000', 'temperatura', 426.0000, 'ºC'),
	(154452, 120, '2014-01-15 01:28:56.000000', 'temperatura', 1036.0000, 'ºC'),
	(154453, 120, '2014-01-15 01:28:57.000000', 'temperatura', 302.0000, 'ºC'),
	(154454, 120, '2014-01-15 01:28:58.000000', 'temperatura', 802.0000, 'ºC'),
	(154455, 120, '2014-01-15 01:28:59.000000', 'temperatura', 707.0000, 'ºC'),
	(154456, 120, '2014-01-15 01:29:00.000000', 'temperatura', 1129.0000, 'ºC'),
	(154457, 120, '2014-01-15 01:29:01.000000', 'temperatura', 1123.0000, 'ºC'),
	(154458, 120, '2014-01-15 01:29:02.000000', 'temperatura', 1028.0000, 'ºC'),
	(154459, 120, '2014-01-15 01:29:03.000000', 'temperatura', 571.0000, 'ºC'),
	(154460, 120, '2014-01-15 01:29:04.000000', 'temperatura', 971.0000, 'ºC'),
	(154461, 120, '2014-01-15 01:29:05.000000', 'temperatura', 743.0000, 'ºC'),
	(154462, 120, '2014-01-15 01:29:06.000000', 'temperatura', 802.0000, 'ºC'),
	(154463, 120, '2014-01-15 01:29:07.000000', 'temperatura', 584.0000, 'ºC'),
	(154464, 120, '2014-01-15 01:29:08.000000', 'temperatura', 513.0000, 'ºC'),
	(154465, 120, '2014-01-15 01:29:09.000000', 'temperatura', 812.0000, 'ºC'),
	(154466, 120, '2014-01-15 01:29:10.000000', 'temperatura', 122.0000, 'ºC'),
	(154467, 120, '2014-01-15 01:29:11.000000', 'temperatura', 574.0000, 'ºC'),
	(154468, 120, '2014-01-15 01:29:12.000000', 'temperatura', 106.0000, 'ºC'),
	(154469, 120, '2014-01-15 01:29:13.000000', 'temperatura', 8.0000, 'ºC'),
	(154470, 120, '2014-01-15 01:29:14.000000', 'temperatura', 923.0000, 'ºC'),
	(154471, 120, '2014-01-15 01:29:15.000000', 'temperatura', 989.0000, 'ºC'),
	(154472, 120, '2014-01-15 01:29:16.000000', 'temperatura', 980.0000, 'ºC'),
	(154473, 120, '2014-01-15 01:29:17.000000', 'temperatura', 732.0000, 'ºC'),
	(154474, 120, '2014-01-15 01:29:18.000000', 'temperatura', 720.0000, 'ºC'),
	(154475, 120, '2014-01-15 01:29:19.000000', 'temperatura', 203.0000, 'ºC'),
	(154476, 120, '2014-01-15 01:29:20.000000', 'temperatura', 58.0000, 'ºC'),
	(154477, 120, '2014-01-15 01:29:21.000000', 'temperatura', 882.0000, 'ºC'),
	(154478, 120, '2014-01-15 01:29:22.000000', 'temperatura', 636.0000, 'ºC'),
	(154479, 120, '2014-01-15 01:29:23.000000', 'temperatura', 536.0000, 'ºC'),
	(154480, 120, '2014-01-15 01:29:24.000000', 'temperatura', 772.0000, 'ºC'),
	(154481, 120, '2014-01-15 01:29:25.000000', 'temperatura', 1054.0000, 'ºC'),
	(154482, 120, '2014-01-15 01:29:26.000000', 'temperatura', 552.0000, 'ºC'),
	(154483, 120, '2014-01-15 01:29:27.000000', 'temperatura', 798.0000, 'ºC'),
	(154484, 120, '2014-01-15 01:29:28.000000', 'temperatura', 1137.0000, 'ºC'),
	(154485, 120, '2014-01-15 01:29:29.000000', 'temperatura', 890.0000, 'ºC'),
	(154486, 120, '2014-01-15 01:29:30.000000', 'temperatura', 1039.0000, 'ºC'),
	(154487, 120, '2014-01-15 01:29:31.000000', 'temperatura', 125.0000, 'ºC'),
	(154488, 120, '2014-01-15 01:29:32.000000', 'temperatura', 1109.0000, 'ºC'),
	(154489, 120, '2014-01-15 01:29:33.000000', 'temperatura', 373.0000, 'ºC'),
	(154490, 120, '2014-01-15 01:29:34.000000', 'temperatura', 935.0000, 'ºC'),
	(154491, 120, '2014-01-15 01:29:35.000000', 'temperatura', 1157.0000, 'ºC'),
	(154492, 120, '2014-01-15 01:29:36.000000', 'temperatura', 581.0000, 'ºC'),
	(154493, 120, '2014-01-15 01:29:37.000000', 'temperatura', 636.0000, 'ºC'),
	(154494, 120, '2014-01-15 01:29:38.000000', 'temperatura', 236.0000, 'ºC'),
	(154495, 120, '2014-01-15 01:29:39.000000', 'temperatura', 471.0000, 'ºC'),
	(154496, 120, '2014-01-15 01:29:40.000000', 'temperatura', 450.0000, 'ºC'),
	(154497, 120, '2014-01-15 01:29:41.000000', 'temperatura', 838.0000, 'ºC'),
	(154498, 120, '2014-01-15 01:29:42.000000', 'temperatura', 440.0000, 'ºC'),
	(154499, 120, '2014-01-15 01:29:43.000000', 'temperatura', 886.0000, 'ºC'),
	(154500, 120, '2014-01-15 01:29:44.000000', 'temperatura', 712.0000, 'ºC'),
	(154501, 120, '2014-01-15 01:29:45.000000', 'temperatura', 902.0000, 'ºC'),
	(154502, 120, '2014-01-15 01:29:46.000000', 'temperatura', 1175.0000, 'ºC'),
	(154503, 120, '2014-01-15 01:29:47.000000', 'temperatura', 769.0000, 'ºC'),
	(154504, 120, '2014-01-15 01:29:48.000000', 'temperatura', 322.0000, 'ºC'),
	(154505, 120, '2014-01-15 01:29:49.000000', 'temperatura', 504.0000, 'ºC'),
	(154506, 120, '2014-01-15 01:29:50.000000', 'temperatura', 353.0000, 'ºC'),
	(154507, 120, '2014-01-15 01:29:51.000000', 'temperatura', 255.0000, 'ºC'),
	(154508, 120, '2014-01-15 01:29:52.000000', 'temperatura', 216.0000, 'ºC'),
	(154509, 120, '2014-01-15 01:29:53.000000', 'temperatura', 315.0000, 'ºC'),
	(154510, 120, '2014-01-15 01:29:54.000000', 'temperatura', 927.0000, 'ºC'),
	(154511, 120, '2014-01-15 01:29:55.000000', 'temperatura', 92.0000, 'ºC'),
	(154512, 120, '2014-01-15 01:29:56.000000', 'temperatura', 77.0000, 'ºC'),
	(154513, 120, '2014-01-15 01:29:57.000000', 'temperatura', 112.0000, 'ºC'),
	(154514, 120, '2014-01-15 01:29:58.000000', 'temperatura', 330.0000, 'ºC'),
	(154515, 120, '2014-01-15 01:29:59.000000', 'temperatura', 113.0000, 'ºC'),
	(154516, 120, '2014-01-15 01:30:00.000000', 'temperatura', 775.0000, 'ºC'),
	(154517, 120, '2014-01-15 01:30:01.000000', 'temperatura', 1136.0000, 'ºC'),
	(154518, 120, '2014-01-15 01:30:02.000000', 'temperatura', 956.0000, 'ºC'),
	(154519, 120, '2014-01-15 01:30:03.000000', 'temperatura', 171.0000, 'ºC'),
	(154520, 120, '2014-01-15 01:30:04.000000', 'temperatura', 389.0000, 'ºC'),
	(154521, 120, '2014-01-15 01:30:05.000000', 'temperatura', 234.0000, 'ºC'),
	(154522, 120, '2014-01-15 01:30:06.000000', 'temperatura', 1.0000, 'ºC'),
	(154523, 120, '2014-01-15 01:30:07.000000', 'temperatura', 505.0000, 'ºC'),
	(154524, 120, '2014-01-15 01:30:08.000000', 'temperatura', 121.0000, 'ºC'),
	(154525, 120, '2014-01-15 01:30:09.000000', 'temperatura', 292.0000, 'ºC'),
	(154526, 120, '2014-01-15 01:30:10.000000', 'temperatura', 1099.0000, 'ºC'),
	(154527, 120, '2014-01-15 01:30:11.000000', 'temperatura', 1016.0000, 'ºC'),
	(154528, 120, '2014-01-15 01:30:12.000000', 'temperatura', 586.0000, 'ºC'),
	(154529, 120, '2014-01-15 01:30:13.000000', 'temperatura', 1084.0000, 'ºC'),
	(154530, 120, '2014-01-15 01:30:14.000000', 'temperatura', 60.0000, 'ºC'),
	(154531, 120, '2014-01-15 01:30:15.000000', 'temperatura', 648.0000, 'ºC'),
	(154532, 120, '2014-01-15 01:30:16.000000', 'temperatura', 663.0000, 'ºC'),
	(154533, 120, '2014-01-15 01:30:17.000000', 'temperatura', 171.0000, 'ºC'),
	(154534, 120, '2014-01-15 01:30:18.000000', 'temperatura', 68.0000, 'ºC'),
	(154535, 120, '2014-01-15 01:30:19.000000', 'temperatura', 1025.0000, 'ºC'),
	(154536, 120, '2014-01-15 01:30:20.000000', 'temperatura', 123.0000, 'ºC'),
	(154537, 120, '2014-01-15 01:30:21.000000', 'temperatura', 1139.0000, 'ºC'),
	(154538, 120, '2014-01-15 01:30:22.000000', 'temperatura', 528.0000, 'ºC'),
	(154539, 120, '2014-01-15 01:30:23.000000', 'temperatura', 424.0000, 'ºC'),
	(154540, 120, '2014-01-15 01:30:24.000000', 'temperatura', 535.0000, 'ºC'),
	(154541, 120, '2014-01-15 01:30:25.000000', 'temperatura', 203.0000, 'ºC'),
	(154542, 120, '2014-01-15 01:30:26.000000', 'temperatura', 610.0000, 'ºC'),
	(154543, 120, '2014-01-15 01:30:27.000000', 'temperatura', 43.0000, 'ºC'),
	(154544, 120, '2014-01-15 01:30:28.000000', 'temperatura', 785.0000, 'ºC'),
	(154545, 120, '2014-01-15 01:30:29.000000', 'temperatura', 196.0000, 'ºC'),
	(154546, 120, '2014-01-15 01:30:30.000000', 'temperatura', 1026.0000, 'ºC'),
	(154547, 120, '2014-01-15 01:30:31.000000', 'temperatura', 943.0000, 'ºC'),
	(154548, 120, '2014-01-15 01:30:32.000000', 'temperatura', 435.0000, 'ºC'),
	(154549, 120, '2014-01-15 01:30:33.000000', 'temperatura', 548.0000, 'ºC'),
	(154550, 120, '2014-01-15 01:30:34.000000', 'temperatura', 236.0000, 'ºC'),
	(154551, 120, '2014-01-15 01:30:35.000000', 'temperatura', 737.0000, 'ºC'),
	(154552, 120, '2014-01-15 01:30:36.000000', 'temperatura', 579.0000, 'ºC'),
	(154553, 120, '2014-01-15 01:30:37.000000', 'temperatura', 681.0000, 'ºC'),
	(154554, 120, '2014-01-15 01:30:38.000000', 'temperatura', 470.0000, 'ºC'),
	(154555, 120, '2014-01-15 01:30:39.000000', 'temperatura', 306.0000, 'ºC'),
	(154556, 120, '2014-01-15 01:30:40.000000', 'temperatura', 122.0000, 'ºC'),
	(154557, 120, '2014-01-15 01:30:41.000000', 'temperatura', 893.0000, 'ºC'),
	(154558, 120, '2014-01-15 01:30:42.000000', 'temperatura', 501.0000, 'ºC'),
	(154559, 120, '2014-01-15 01:30:43.000000', 'temperatura', 1023.0000, 'ºC'),
	(154560, 120, '2014-01-15 01:30:44.000000', 'temperatura', 14.0000, 'ºC'),
	(154561, 120, '2014-01-15 01:30:45.000000', 'temperatura', 602.0000, 'ºC'),
	(154562, 120, '2014-01-15 01:30:46.000000', 'temperatura', 568.0000, 'ºC'),
	(154563, 120, '2014-01-15 01:30:47.000000', 'temperatura', 1036.0000, 'ºC'),
	(154564, 120, '2014-01-15 01:30:48.000000', 'temperatura', 1074.0000, 'ºC'),
	(154565, 120, '2014-01-15 01:30:49.000000', 'temperatura', 1066.0000, 'ºC'),
	(154566, 120, '2014-01-15 01:30:50.000000', 'temperatura', 905.0000, 'ºC'),
	(154567, 120, '2014-01-15 01:30:51.000000', 'temperatura', 127.0000, 'ºC'),
	(154568, 120, '2014-01-15 01:30:52.000000', 'temperatura', 323.0000, 'ºC'),
	(154569, 120, '2014-01-15 01:30:53.000000', 'temperatura', 34.0000, 'ºC'),
	(154570, 120, '2014-01-15 01:30:54.000000', 'temperatura', 403.0000, 'ºC'),
	(154571, 120, '2014-01-15 01:30:55.000000', 'temperatura', 711.0000, 'ºC'),
	(154572, 121, '2014-01-15 00:00:00.000000', 'temperatura', 0.0000, 'ºC'),
	(154573, 121, '2014-01-15 00:00:01.000000', 'temperatura', 163.0000, 'ºC'),
	(154574, 121, '2014-01-15 00:00:02.000000', 'temperatura', 813.0000, 'ºC'),
	(154575, 121, '2014-01-15 00:00:03.000000', 'temperatura', 1177.0000, 'ºC'),
	(154576, 121, '2014-01-15 00:00:04.000000', 'temperatura', 1045.0000, 'ºC'),
	(154577, 121, '2014-01-15 00:00:05.000000', 'temperatura', 497.0000, 'ºC'),
	(154578, 121, '2014-01-15 00:00:06.000000', 'temperatura', 551.0000, 'ºC'),
	(154579, 121, '2014-01-15 00:00:07.000000', 'temperatura', 64.0000, 'ºC'),
	(154580, 121, '2014-01-15 00:00:08.000000', 'temperatura', 1066.0000, 'ºC'),
	(154581, 121, '2014-01-15 00:00:09.000000', 'temperatura', 337.0000, 'ºC'),
	(154582, 121, '2014-01-15 00:00:10.000000', 'temperatura', 891.0000, 'ºC'),
	(154583, 121, '2014-01-15 00:00:11.000000', 'temperatura', 1043.0000, 'ºC'),
	(154584, 121, '2014-01-15 00:00:12.000000', 'temperatura', 141.0000, 'ºC'),
	(154585, 121, '2014-01-15 00:00:13.000000', 'temperatura', 1176.0000, 'ºC'),
	(154586, 121, '2014-01-15 00:00:14.000000', 'temperatura', 658.0000, 'ºC'),
	(154587, 121, '2014-01-15 00:00:15.000000', 'temperatura', 963.0000, 'ºC'),
	(154588, 121, '2014-01-15 00:00:16.000000', 'temperatura', 442.0000, 'ºC'),
	(154589, 121, '2014-01-15 00:00:17.000000', 'temperatura', 520.0000, 'ºC'),
	(154590, 121, '2014-01-15 00:00:18.000000', 'temperatura', 76.0000, 'ºC'),
	(154591, 121, '2014-01-15 00:00:19.000000', 'temperatura', 21.0000, 'ºC'),
	(154592, 121, '2014-01-15 00:00:20.000000', 'temperatura', 1078.0000, 'ºC'),
	(154593, 121, '2014-01-15 00:00:21.000000', 'temperatura', 525.0000, 'ºC'),
	(154594, 121, '2014-01-15 00:00:22.000000', 'temperatura', 591.0000, 'ºC'),
	(154595, 121, '2014-01-15 00:00:23.000000', 'temperatura', 181.0000, 'ºC'),
	(154596, 121, '2014-01-15 00:00:24.000000', 'temperatura', 332.0000, 'ºC'),
	(154597, 121, '2014-01-15 00:00:25.000000', 'temperatura', 1118.0000, 'ºC'),
	(154598, 121, '2014-01-15 00:00:26.000000', 'temperatura', 996.0000, 'ºC'),
	(154599, 121, '2014-01-15 00:00:27.000000', 'temperatura', 427.0000, 'ºC'),
	(154600, 121, '2014-01-15 00:00:28.000000', 'temperatura', 346.0000, 'ºC'),
	(154601, 121, '2014-01-15 00:00:29.000000', 'temperatura', 448.0000, 'ºC'),
	(154602, 121, '2014-01-15 00:00:30.000000', 'temperatura', 3.0000, 'ºC'),
	(154603, 121, '2014-01-15 00:00:31.000000', 'temperatura', 1072.0000, 'ºC'),
	(154604, 121, '2014-01-15 00:00:32.000000', 'temperatura', 553.0000, 'ºC'),
	(154605, 121, '2014-01-15 00:00:33.000000', 'temperatura', 746.0000, 'ºC'),
	(154606, 121, '2014-01-15 00:00:34.000000', 'temperatura', 875.0000, 'ºC'),
	(154607, 121, '2014-01-15 00:00:35.000000', 'temperatura', 936.0000, 'ºC'),
	(154608, 121, '2014-01-15 00:00:36.000000', 'temperatura', 857.0000, 'ºC'),
	(154609, 121, '2014-01-15 00:00:37.000000', 'temperatura', 275.0000, 'ºC'),
	(154610, 121, '2014-01-15 00:00:38.000000', 'temperatura', 8.0000, 'ºC'),
	(154611, 121, '2014-01-15 00:00:39.000000', 'temperatura', 412.0000, 'ºC'),
	(154612, 121, '2014-01-15 00:00:40.000000', 'temperatura', 837.0000, 'ºC'),
	(154613, 121, '2014-01-15 00:00:41.000000', 'temperatura', 551.0000, 'ºC'),
	(154614, 121, '2014-01-15 00:00:42.000000', 'temperatura', 246.0000, 'ºC'),
	(154615, 121, '2014-01-15 00:00:43.000000', 'temperatura', 774.0000, 'ºC'),
	(154616, 121, '2014-01-15 00:00:44.000000', 'temperatura', 735.0000, 'ºC'),
	(154617, 121, '2014-01-15 00:00:45.000000', 'temperatura', 152.0000, 'ºC'),
	(154618, 121, '2014-01-15 00:00:46.000000', 'temperatura', 958.0000, 'ºC'),
	(154619, 121, '2014-01-15 00:00:47.000000', 'temperatura', 732.0000, 'ºC'),
	(154620, 121, '2014-01-15 00:00:48.000000', 'temperatura', 786.0000, 'ºC'),
	(154621, 121, '2014-01-15 00:00:49.000000', 'temperatura', 534.0000, 'ºC'),
	(154622, 121, '2014-01-15 00:00:50.000000', 'temperatura', 315.0000, 'ºC'),
	(154623, 121, '2014-01-15 00:00:51.000000', 'temperatura', 1172.0000, 'ºC'),
	(154624, 121, '2014-01-15 00:00:52.000000', 'temperatura', 116.0000, 'ºC'),
	(154625, 121, '2014-01-15 00:00:53.000000', 'temperatura', 665.0000, 'ºC'),
	(154626, 121, '2014-01-15 00:00:54.000000', 'temperatura', 576.0000, 'ºC'),
	(154627, 121, '2014-01-15 00:00:55.000000', 'temperatura', 884.0000, 'ºC'),
	(154628, 121, '2014-01-15 00:00:56.000000', 'temperatura', 296.0000, 'ºC'),
	(154629, 121, '2014-01-15 00:00:57.000000', 'temperatura', 27.0000, 'ºC'),
	(154630, 121, '2014-01-15 00:00:58.000000', 'temperatura', 446.0000, 'ºC'),
	(154631, 121, '2014-01-15 00:00:59.000000', 'temperatura', 949.0000, 'ºC'),
	(154632, 121, '2014-01-15 00:01:00.000000', 'temperatura', 1008.0000, 'ºC'),
	(154633, 121, '2014-01-15 00:01:01.000000', 'temperatura', 995.0000, 'ºC'),
	(154634, 121, '2014-01-15 00:01:02.000000', 'temperatura', 751.0000, 'ºC'),
	(154635, 121, '2014-01-15 00:01:03.000000', 'temperatura', 769.0000, 'ºC'),
	(154636, 121, '2014-01-15 00:01:04.000000', 'temperatura', 392.0000, 'ºC'),
	(154637, 121, '2014-01-15 00:01:05.000000', 'temperatura', 855.0000, 'ºC'),
	(154638, 121, '2014-01-15 00:01:06.000000', 'temperatura', 698.0000, 'ºC'),
	(154639, 121, '2014-01-15 00:01:07.000000', 'temperatura', 926.0000, 'ºC'),
	(154640, 121, '2014-01-15 00:01:08.000000', 'temperatura', 136.0000, 'ºC'),
	(154641, 121, '2014-01-15 00:01:09.000000', 'temperatura', 303.0000, 'ºC'),
	(154642, 121, '2014-01-15 00:01:10.000000', 'temperatura', 1107.0000, 'ºC'),
	(154643, 121, '2014-01-15 00:01:11.000000', 'temperatura', 1026.0000, 'ºC'),
	(154644, 121, '2014-01-15 00:01:12.000000', 'temperatura', 612.0000, 'ºC'),
	(154645, 121, '2014-01-15 00:01:13.000000', 'temperatura', 1181.0000, 'ºC'),
	(154646, 121, '2014-01-15 00:01:14.000000', 'temperatura', 469.0000, 'ºC'),
	(154647, 121, '2014-01-15 00:01:15.000000', 'temperatura', 4.0000, 'ºC'),
	(154648, 121, '2014-01-15 00:01:16.000000', 'temperatura', 1011.0000, 'ºC'),
	(154649, 121, '2014-01-15 00:01:17.000000', 'temperatura', 246.0000, 'ºC'),
	(154650, 121, '2014-01-15 00:01:18.000000', 'temperatura', 595.0000, 'ºC'),
	(154651, 121, '2014-01-15 00:01:19.000000', 'temperatura', 1039.0000, 'ºC'),
	(154652, 121, '2014-01-15 00:01:20.000000', 'temperatura', 1009.0000, 'ºC'),
	(154653, 121, '2014-01-15 00:01:21.000000', 'temperatura', 728.0000, 'ºC'),
	(154654, 121, '2014-01-15 00:01:22.000000', 'temperatura', 614.0000, 'ºC'),
	(154655, 121, '2014-01-15 00:01:23.000000', 'temperatura', 887.0000, 'ºC'),
	(154656, 121, '2014-01-15 00:01:24.000000', 'temperatura', 193.0000, 'ºC'),
	(154657, 121, '2014-01-15 00:01:25.000000', 'temperatura', 705.0000, 'ºC'),
	(154658, 121, '2014-01-15 00:01:26.000000', 'temperatura', 547.0000, 'ºC'),
	(154659, 121, '2014-01-15 00:01:27.000000', 'temperatura', 622.0000, 'ºC'),
	(154660, 121, '2014-01-15 00:01:28.000000', 'temperatura', 267.0000, 'ºC'),
	(154661, 121, '2014-01-15 00:01:29.000000', 'temperatura', 672.0000, 'ºC'),
	(154662, 121, '2014-01-15 00:01:30.000000', 'temperatura', 160.0000, 'ºC'),
	(154663, 121, '2014-01-15 00:01:31.000000', 'temperatura', 1182.0000, 'ºC'),
	(154664, 121, '2014-01-15 00:01:32.000000', 'temperatura', 632.0000, 'ºC'),
	(154665, 121, '2014-01-15 00:01:33.000000', 'temperatura', 815.0000, 'ºC'),
	(154666, 121, '2014-01-15 00:01:34.000000', 'temperatura', 977.0000, 'ºC'),
	(154667, 121, '2014-01-15 00:01:35.000000', 'temperatura', 41.0000, 'ºC'),
	(154668, 121, '2014-01-15 00:01:36.000000', 'temperatura', 877.0000, 'ºC'),
	(154669, 121, '2014-01-15 00:01:37.000000', 'temperatura', 659.0000, 'ºC'),
	(154670, 121, '2014-01-15 00:01:38.000000', 'temperatura', 667.0000, 'ºC'),
	(154671, 121, '2014-01-15 00:01:39.000000', 'temperatura', 157.0000, 'ºC'),
	(154672, 121, '2014-01-15 00:01:40.000000', 'temperatura', 1183.0000, 'ºC'),
	(154673, 121, '2014-01-15 00:01:41.000000', 'temperatura', 646.0000, 'ºC'),
	(154674, 121, '2014-01-15 00:01:42.000000', 'temperatura', 882.0000, 'ºC'),
	(154675, 121, '2014-01-15 00:01:43.000000', 'temperatura', 73.0000, 'ºC'),
	(154676, 121, '2014-01-15 00:01:44.000000', 'temperatura', 118.0000, 'ºC'),
	(154677, 121, '2014-01-15 00:01:45.000000', 'temperatura', 371.0000, 'ºC'),
	(154678, 121, '2014-01-15 00:01:46.000000', 'temperatura', 303.0000, 'ºC'),
	(154679, 121, '2014-01-15 00:01:47.000000', 'temperatura', 404.0000, 'ºC'),
	(154680, 121, '2014-01-15 00:01:48.000000', 'temperatura', 1108.0000, 'ºC'),
	(154681, 121, '2014-01-15 00:01:49.000000', 'temperatura', 730.0000, 'ºC'),
	(154682, 121, '2014-01-15 00:01:50.000000', 'temperatura', 326.0000, 'ºC'),
	(154683, 121, '2014-01-15 00:01:51.000000', 'temperatura', 642.0000, 'ºC'),
	(154684, 121, '2014-01-15 00:01:52.000000', 'temperatura', 1030.0000, 'ºC'),
	(154685, 121, '2014-01-15 00:01:53.000000', 'temperatura', 826.0000, 'ºC'),
	(154686, 121, '2014-01-15 00:01:54.000000', 'temperatura', 1041.0000, 'ºC'),
	(154687, 121, '2014-01-15 00:01:55.000000', 'temperatura', 326.0000, 'ºC'),
	(154688, 121, '2014-01-15 00:01:56.000000', 'temperatura', 910.0000, 'ºC'),
	(154689, 121, '2014-01-15 00:01:57.000000', 'temperatura', 1169.0000, 'ºC'),
	(154690, 121, '2014-01-15 00:01:58.000000', 'temperatura', 718.0000, 'ºC'),
	(154691, 121, '2014-01-15 00:01:59.000000', 'temperatura', 81.0000, 'ºC'),
	(154692, 121, '2014-01-15 00:02:00.000000', 'temperatura', 653.0000, 'ºC'),
	(154693, 121, '2014-01-15 00:02:01.000000', 'temperatura', 623.0000, 'ºC'),
	(154694, 121, '2014-01-15 00:02:02.000000', 'temperatura', 1157.0000, 'ºC'),
	(154695, 121, '2014-01-15 00:02:03.000000', 'temperatura', 315.0000, 'ºC'),
	(154696, 121, '2014-01-15 00:02:04.000000', 'temperatura', 506.0000, 'ºC'),
	(154697, 121, '2014-01-15 00:02:05.000000', 'temperatura', 384.0000, 'ºC'),
	(154698, 121, '2014-01-15 00:02:06.000000', 'temperatura', 402.0000, 'ºC'),
	(154699, 121, '2014-01-15 00:02:07.000000', 'temperatura', 857.0000, 'ºC'),
	(154700, 121, '2014-01-15 00:02:08.000000', 'temperatura', 683.0000, 'ºC'),
	(154701, 121, '2014-01-15 00:02:09.000000', 'temperatura', 843.0000, 'ºC'),
	(154702, 121, '2014-01-15 00:02:10.000000', 'temperatura', 969.0000, 'ºC'),
	(154703, 121, '2014-01-15 00:02:11.000000', 'temperatura', 1114.0000, 'ºC'),
	(154704, 121, '2014-01-15 00:02:12.000000', 'temperatura', 262.0000, 'ºC'),
	(154705, 121, '2014-01-15 00:02:13.000000', 'temperatura', 370.0000, 'ºC'),
	(154706, 121, '2014-01-15 00:02:14.000000', 'temperatura', 1065.0000, 'ºC'),
	(154707, 121, '2014-01-15 00:02:15.000000', 'temperatura', 615.0000, 'ºC'),
	(154708, 121, '2014-01-15 00:02:16.000000', 'temperatura', 1079.0000, 'ºC'),
	(154709, 121, '2014-01-15 00:02:17.000000', 'temperatura', 1150.0000, 'ºC'),
	(154710, 121, '2014-01-15 00:02:18.000000', 'temperatura', 113.0000, 'ºC'),
	(154711, 121, '2014-01-15 00:02:19.000000', 'temperatura', 717.0000, 'ºC'),
	(154712, 121, '2014-01-15 00:02:20.000000', 'temperatura', 845.0000, 'ºC'),
	(154713, 121, '2014-01-15 00:02:21.000000', 'temperatura', 875.0000, 'ºC'),
	(154714, 121, '2014-01-15 00:02:22.000000', 'temperatura', 640.0000, 'ºC'),
	(154715, 121, '2014-01-15 00:02:23.000000', 'temperatura', 577.0000, 'ºC'),
	(154716, 121, '2014-01-15 00:02:24.000000', 'temperatura', 966.0000, 'ºC'),
	(154717, 121, '2014-01-15 00:02:25.000000', 'temperatura', 699.0000, 'ºC'),
	(154718, 121, '2014-01-15 00:02:26.000000', 'temperatura', 596.0000, 'ºC'),
	(154719, 121, '2014-01-15 00:02:27.000000', 'temperatura', 882.0000, 'ºC'),
	(154720, 121, '2014-01-15 00:02:28.000000', 'temperatura', 226.0000, 'ºC'),
	(154721, 121, '2014-01-15 00:02:29.000000', 'temperatura', 884.0000, 'ºC'),
	(154722, 121, '2014-01-15 00:02:30.000000', 'temperatura', 141.0000, 'ºC'),
	(154723, 121, '2014-01-15 00:02:31.000000', 'temperatura', 452.0000, 'ºC'),
	(154724, 121, '2014-01-15 00:02:32.000000', 'temperatura', 639.0000, 'ºC'),
	(154725, 121, '2014-01-15 00:02:33.000000', 'temperatura', 641.0000, 'ºC'),
	(154726, 121, '2014-01-15 00:02:34.000000', 'temperatura', 88.0000, 'ºC'),
	(154727, 121, '2014-01-15 00:02:35.000000', 'temperatura', 915.0000, 'ºC'),
	(154728, 121, '2014-01-15 00:02:36.000000', 'temperatura', 715.0000, 'ºC'),
	(154729, 121, '2014-01-15 00:02:37.000000', 'temperatura', 828.0000, 'ºC'),
	(154730, 121, '2014-01-15 00:02:38.000000', 'temperatura', 796.0000, 'ºC'),
	(154731, 121, '2014-01-15 00:02:39.000000', 'temperatura', 298.0000, 'ºC'),
	(154732, 121, '2014-01-15 00:02:40.000000', 'temperatura', 302.0000, 'ºC'),
	(154733, 121, '2014-01-15 00:02:41.000000', 'temperatura', 616.0000, 'ºC'),
	(154734, 121, '2014-01-15 00:02:42.000000', 'temperatura', 976.0000, 'ºC'),
	(154735, 121, '2014-01-15 00:02:43.000000', 'temperatura', 632.0000, 'ºC'),
	(154736, 121, '2014-01-15 00:02:44.000000', 'temperatura', 233.0000, 'ºC'),
	(154737, 121, '2014-01-15 00:02:45.000000', 'temperatura', 469.0000, 'ºC'),
	(154738, 121, '2014-01-15 00:02:46.000000', 'temperatura', 447.0000, 'ºC'),
	(154739, 121, '2014-01-15 00:02:47.000000', 'temperatura', 826.0000, 'ºC'),
	(154740, 121, '2014-01-15 00:02:48.000000', 'temperatura', 391.0000, 'ºC'),
	(154741, 121, '2014-01-15 00:02:49.000000', 'temperatura', 679.0000, 'ºC'),
	(154742, 121, '2014-01-15 00:02:50.000000', 'temperatura', 1020.0000, 'ºC'),
	(154743, 121, '2014-01-15 00:02:51.000000', 'temperatura', 664.0000, 'ºC'),
	(154744, 121, '2014-01-15 00:02:52.000000', 'temperatura', 260.0000, 'ºC'),
	(154745, 121, '2014-01-15 00:02:53.000000', 'temperatura', 508.0000, 'ºC'),
	(154746, 121, '2014-01-15 00:02:54.000000', 'temperatura', 559.0000, 'ºC'),
	(154747, 121, '2014-01-15 00:02:55.000000', 'temperatura', 75.0000, 'ºC'),
	(154748, 121, '2014-01-15 00:02:56.000000', 'temperatura', 1097.0000, 'ºC'),
	(154749, 121, '2014-01-15 00:02:57.000000', 'temperatura', 459.0000, 'ºC'),
	(154750, 121, '2014-01-15 00:02:58.000000', 'temperatura', 205.0000, 'ºC'),
	(154751, 121, '2014-01-15 00:02:59.000000', 'temperatura', 850.0000, 'ºC'),
	(154752, 121, '2014-01-15 00:03:00.000000', 'temperatura', 35.0000, 'ºC'),
	(154753, 121, '2014-01-15 00:03:01.000000', 'temperatura', 24.0000, 'ºC'),
	(154754, 121, '2014-01-15 00:03:02.000000', 'temperatura', 15.0000, 'ºC'),
	(154755, 121, '2014-01-15 00:03:03.000000', 'temperatura', 6.0000, 'ºC'),
	(154756, 121, '2014-01-15 00:03:04.000000', 'temperatura', 1184.0000, 'ºC'),
	(154757, 121, '2014-01-15 00:03:05.000000', 'temperatura', 1102.0000, 'ºC'),
	(154758, 121, '2014-01-15 00:03:06.000000', 'temperatura', 758.0000, 'ºC'),
	(154759, 121, '2014-01-15 00:03:07.000000', 'temperatura', 485.0000, 'ºC'),
	(154760, 121, '2014-01-15 00:03:08.000000', 'temperatura', 150.0000, 'ºC'),
	(154761, 121, '2014-01-15 00:03:09.000000', 'temperatura', 499.0000, 'ºC'),
	(154762, 121, '2014-01-15 00:03:10.000000', 'temperatura', 843.0000, 'ºC'),
	(154763, 121, '2014-01-15 00:03:11.000000', 'temperatura', 319.0000, 'ºC'),
	(154764, 121, '2014-01-15 00:03:12.000000', 'temperatura', 267.0000, 'ºC'),
	(154765, 121, '2014-01-15 00:03:13.000000', 'temperatura', 378.0000, 'ºC'),
	(154766, 121, '2014-01-15 00:03:14.000000', 'temperatura', 1088.0000, 'ºC'),
	(154767, 121, '2014-01-15 00:03:15.000000', 'temperatura', 707.0000, 'ºC'),
	(154768, 121, '2014-01-15 00:03:16.000000', 'temperatura', 270.0000, 'ºC'),
	(154769, 121, '2014-01-15 00:03:17.000000', 'temperatura', 432.0000, 'ºC'),
	(154770, 121, '2014-01-15 00:03:18.000000', 'temperatura', 149.0000, 'ºC'),
	(154771, 121, '2014-01-15 00:03:19.000000', 'temperatura', 649.0000, 'ºC'),
	(154772, 121, '2014-01-15 00:03:20.000000', 'temperatura', 401.0000, 'ºC'),
	(154773, 121, '2014-01-15 00:03:21.000000', 'temperatura', 57.0000, 'ºC'),
	(154774, 121, '2014-01-15 00:03:22.000000', 'temperatura', 285.0000, 'ºC'),
	(154775, 121, '2014-01-15 00:03:23.000000', 'temperatura', 52.0000, 'ºC'),
	(154776, 121, '2014-01-15 00:03:24.000000', 'temperatura', 605.0000, 'ºC'),
	(154777, 121, '2014-01-15 00:03:25.000000', 'temperatura', 469.0000, 'ºC'),
	(154778, 121, '2014-01-15 00:03:26.000000', 'temperatura', 533.0000, 'ºC'),
	(154779, 121, '2014-01-15 00:03:27.000000', 'temperatura', 58.0000, 'ºC'),
	(154780, 121, '2014-01-15 00:03:28.000000', 'temperatura', 1089.0000, 'ºC'),
	(154781, 121, '2014-01-15 00:03:29.000000', 'temperatura', 474.0000, 'ºC'),
	(154782, 121, '2014-01-15 00:03:30.000000', 'temperatura', 301.0000, 'ºC'),
	(154783, 121, '2014-01-15 00:03:31.000000', 'temperatura', 85.0000, 'ºC'),
	(154784, 121, '2014-01-15 00:03:32.000000', 'temperatura', 722.0000, 'ºC'),
	(154785, 121, '2014-01-15 00:03:33.000000', 'temperatura', 955.0000, 'ºC'),
	(154786, 121, '2014-01-15 00:03:34.000000', 'temperatura', 211.0000, 'ºC'),
	(154787, 121, '2014-01-15 00:03:35.000000', 'temperatura', 590.0000, 'ºC'),
	(154788, 121, '2014-01-15 00:03:36.000000', 'temperatura', 1115.0000, 'ºC'),
	(154789, 121, '2014-01-15 00:03:37.000000', 'temperatura', 208.0000, 'ºC'),
	(154790, 121, '2014-01-15 00:03:38.000000', 'temperatura', 97.0000, 'ºC'),
	(154791, 121, '2014-01-15 00:03:39.000000', 'temperatura', 1059.0000, 'ºC'),
	(154792, 121, '2014-01-15 00:03:40.000000', 'temperatura', 204.0000, 'ºC'),
	(154793, 121, '2014-01-15 00:03:41.000000', 'temperatura', 246.0000, 'ºC'),
	(154794, 121, '2014-01-15 00:03:42.000000', 'temperatura', 619.0000, 'ºC'),
	(154795, 121, '2014-01-15 00:03:43.000000', 'temperatura', 1158.0000, 'ºC'),
	(154796, 121, '2014-01-15 00:03:44.000000', 'temperatura', 330.0000, 'ºC'),
	(154797, 121, '2014-01-15 00:03:45.000000', 'temperatura', 580.0000, 'ºC'),
	(154798, 121, '2014-01-15 00:03:46.000000', 'temperatura', 708.0000, 'ºC'),
	(154799, 121, '2014-01-15 00:03:47.000000', 'temperatura', 600.0000, 'ºC'),
	(154800, 121, '2014-01-15 00:03:48.000000', 'temperatura', 880.0000, 'ºC'),
	(154801, 121, '2014-01-15 00:03:49.000000', 'temperatura', 197.0000, 'ºC'),
	(154802, 121, '2014-01-15 00:03:50.000000', 'temperatura', 745.0000, 'ºC'),
	(154803, 121, '2014-01-15 00:03:51.000000', 'temperatura', 737.0000, 'ºC'),
	(154804, 121, '2014-01-15 00:03:52.000000', 'temperatura', 248.0000, 'ºC'),
	(154805, 121, '2014-01-15 00:03:53.000000', 'temperatura', 229.0000, 'ºC'),
	(154806, 121, '2014-01-15 00:03:54.000000', 'temperatura', 402.0000, 'ºC'),
	(154807, 121, '2014-01-15 00:03:55.000000', 'temperatura', 122.0000, 'ºC'),
	(154808, 121, '2014-01-15 00:03:56.000000', 'temperatura', 608.0000, 'ºC'),
	(154809, 121, '2014-01-15 00:03:57.000000', 'temperatura', 271.0000, 'ºC'),
	(154810, 121, '2014-01-15 00:03:58.000000', 'temperatura', 735.0000, 'ºC'),
	(154811, 121, '2014-01-15 00:03:59.000000', 'temperatura', 460.0000, 'ºC'),
	(154812, 121, '2014-01-15 00:04:00.000000', 'temperatura', 98.0000, 'ºC'),
	(154813, 121, '2014-01-15 00:04:01.000000', 'temperatura', 307.0000, 'ºC'),
	(154814, 121, '2014-01-15 00:04:02.000000', 'temperatura', 44.0000, 'ºC'),
	(154815, 121, '2014-01-15 00:04:03.000000', 'temperatura', 497.0000, 'ºC'),
	(154816, 121, '2014-01-15 00:04:04.000000', 'temperatura', 1154.0000, 'ºC'),
	(154817, 121, '2014-01-15 00:04:05.000000', 'temperatura', 681.0000, 'ºC'),
	(154818, 121, '2014-01-15 00:04:06.000000', 'temperatura', 1145.0000, 'ºC'),
	(154819, 121, '2014-01-15 00:04:07.000000', 'temperatura', 81.0000, 'ºC'),
	(154820, 121, '2014-01-15 00:04:08.000000', 'temperatura', 570.0000, 'ºC'),
	(154821, 121, '2014-01-15 00:04:09.000000', 'temperatura', 207.0000, 'ºC'),
	(154822, 121, '2014-01-15 00:04:10.000000', 'temperatura', 527.0000, 'ºC'),
	(154823, 121, '2014-01-15 00:04:11.000000', 'temperatura', 815.0000, 'ºC'),
	(154824, 121, '2014-01-15 00:04:12.000000', 'temperatura', 93.0000, 'ºC'),
	(154825, 121, '2014-01-15 00:04:13.000000', 'temperatura', 421.0000, 'ºC'),
	(154826, 121, '2014-01-15 00:04:14.000000', 'temperatura', 628.0000, 'ºC'),
	(154827, 121, '2014-01-15 00:04:15.000000', 'temperatura', 675.0000, 'ºC'),
	(154828, 121, '2014-01-15 00:04:16.000000', 'temperatura', 291.0000, 'ºC'),
	(154829, 121, '2014-01-15 00:04:17.000000', 'temperatura', 632.0000, 'ºC'),
	(154830, 121, '2014-01-15 00:04:18.000000', 'temperatura', 1086.0000, 'ºC'),
	(154831, 121, '2014-01-15 00:04:19.000000', 'temperatura', 1137.0000, 'ºC'),
	(154832, 121, '2014-01-15 00:04:20.000000', 'temperatura', 28.0000, 'ºC'),
	(154833, 121, '2014-01-15 00:04:21.000000', 'temperatura', 328.0000, 'ºC'),
	(154834, 121, '2014-01-15 00:04:22.000000', 'temperatura', 358.0000, 'ºC'),
	(154835, 121, '2014-01-15 00:04:23.000000', 'temperatura', 807.0000, 'ºC'),
	(154836, 121, '2014-01-15 00:04:24.000000', 'temperatura', 562.0000, 'ºC'),
	(154837, 121, '2014-01-15 00:04:25.000000', 'temperatura', 390.0000, 'ºC'),
	(154838, 121, '2014-01-15 00:04:26.000000', 'temperatura', 264.0000, 'ºC'),
	(154839, 121, '2014-01-15 00:04:27.000000', 'temperatura', 150.0000, 'ºC'),
	(154840, 121, '2014-01-15 00:04:28.000000', 'temperatura', 1158.0000, 'ºC'),
	(154841, 121, '2014-01-15 00:04:29.000000', 'temperatura', 542.0000, 'ºC'),
	(154842, 121, '2014-01-15 00:04:30.000000', 'temperatura', 437.0000, 'ºC'),
	(154843, 121, '2014-01-15 00:04:31.000000', 'temperatura', 560.0000, 'ºC'),
	(154844, 121, '2014-01-15 00:04:32.000000', 'temperatura', 290.0000, 'ºC'),
	(154845, 121, '2014-01-15 00:04:33.000000', 'temperatura', 972.0000, 'ºC'),
	(154846, 121, '2014-01-15 00:04:34.000000', 'temperatura', 387.0000, 'ºC'),
	(154847, 121, '2014-01-15 00:04:35.000000', 'temperatura', 220.0000, 'ºC'),
	(154848, 121, '2014-01-15 00:04:36.000000', 'temperatura', 1141.0000, 'ºC'),
	(154849, 121, '2014-01-15 00:04:37.000000', 'temperatura', 246.0000, 'ºC'),
	(154850, 121, '2014-01-15 00:04:38.000000', 'temperatura', 206.0000, 'ºC'),
	(154851, 121, '2014-01-15 00:04:39.000000', 'temperatura', 293.0000, 'ºC'),
	(154852, 121, '2014-01-15 00:04:40.000000', 'temperatura', 848.0000, 'ºC'),
	(154853, 121, '2014-01-15 00:04:41.000000', 'temperatura', 963.0000, 'ºC'),
	(154854, 121, '2014-01-15 00:04:42.000000', 'temperatura', 1069.0000, 'ºC'),
	(154855, 121, '2014-01-15 00:04:43.000000', 'temperatura', 56.0000, 'ºC'),
	(154856, 121, '2014-01-15 00:04:44.000000', 'temperatura', 676.0000, 'ºC'),
	(154857, 121, '2014-01-15 00:04:45.000000', 'temperatura', 812.0000, 'ºC'),
	(154858, 121, '2014-01-15 00:04:46.000000', 'temperatura', 831.0000, 'ºC'),
	(154859, 121, '2014-01-15 00:04:47.000000', 'temperatura', 519.0000, 'ºC'),
	(154860, 121, '2014-01-15 00:04:48.000000', 'temperatura', 104.0000, 'ºC'),
	(154861, 121, '2014-01-15 00:04:49.000000', 'temperatura', 161.0000, 'ºC'),
	(154862, 121, '2014-01-15 00:04:50.000000', 'temperatura', 496.0000, 'ºC'),
	(154863, 121, '2014-01-15 00:04:51.000000', 'temperatura', 798.0000, 'ºC'),
	(154864, 121, '2014-01-15 00:04:52.000000', 'temperatura', 102.0000, 'ºC'),
	(154865, 121, '2014-01-15 00:04:53.000000', 'temperatura', 516.0000, 'ºC'),
	(154866, 121, '2014-01-15 00:04:54.000000', 'temperatura', 1075.0000, 'ºC'),
	(154867, 121, '2014-01-15 00:04:55.000000', 'temperatura', 227.0000, 'ºC'),
	(154868, 121, '2014-01-15 00:04:56.000000', 'temperatura', 312.0000, 'ºC'),
	(154869, 121, '2014-01-15 00:04:57.000000', 'temperatura', 877.0000, 'ºC'),
	(154870, 121, '2014-01-15 00:04:58.000000', 'temperatura', 1051.0000, 'ºC'),
	(154871, 121, '2014-01-15 00:04:59.000000', 'temperatura', 223.0000, 'ºC'),
	(154872, 121, '2014-01-15 00:05:00.000000', 'temperatura', 364.0000, 'ºC'),
	(154873, 121, '2014-01-15 00:05:01.000000', 'temperatura', 1153.0000, 'ºC'),
	(154874, 121, '2014-01-15 00:05:02.000000', 'temperatura', 1072.0000, 'ºC'),
	(154875, 121, '2014-01-15 00:05:03.000000', 'temperatura', 703.0000, 'ºC'),
	(154876, 121, '2014-01-15 00:05:04.000000', 'temperatura', 297.0000, 'ºC'),
	(154877, 121, '2014-01-15 00:05:05.000000', 'temperatura', 576.0000, 'ºC'),
	(154878, 121, '2014-01-15 00:05:06.000000', 'temperatura', 791.0000, 'ºC'),
	(154879, 121, '2014-01-15 00:05:07.000000', 'temperatura', 1026.0000, 'ºC'),
	(154880, 121, '2014-01-15 00:05:08.000000', 'temperatura', 357.0000, 'ºC'),
	(154881, 121, '2014-01-15 00:05:09.000000', 'temperatura', 1110.0000, 'ºC'),
	(154882, 121, '2014-01-15 00:05:10.000000', 'temperatura', 880.0000, 'ºC'),
	(154883, 121, '2014-01-15 00:05:11.000000', 'temperatura', 1070.0000, 'ºC'),
	(154884, 121, '2014-01-15 00:05:12.000000', 'temperatura', 309.0000, 'ºC'),
	(154885, 121, '2014-01-15 00:05:13.000000', 'temperatura', 736.0000, 'ºC'),
	(154886, 121, '2014-01-15 00:05:14.000000', 'temperatura', 355.0000, 'ºC'),
	(154887, 121, '2014-01-15 00:05:15.000000', 'temperatura', 767.0000, 'ºC'),
	(154888, 121, '2014-01-15 00:05:16.000000', 'temperatura', 371.0000, 'ºC'),
	(154889, 121, '2014-01-15 00:05:17.000000', 'temperatura', 754.0000, 'ºC'),
	(154890, 121, '2014-01-15 00:05:18.000000', 'temperatura', 258.0000, 'ºC'),
	(154891, 121, '2014-01-15 00:05:19.000000', 'temperatura', 227.0000, 'ºC'),
	(154892, 121, '2014-01-15 00:05:20.000000', 'temperatura', 360.0000, 'ºC'),
	(154893, 121, '2014-01-15 00:05:21.000000', 'temperatura', 1123.0000, 'ºC'),
	(154894, 121, '2014-01-15 00:05:22.000000', 'temperatura', 933.0000, 'ºC'),
	(154895, 121, '2014-01-15 00:05:23.000000', 'temperatura', 98.0000, 'ºC'),
	(154896, 121, '2014-01-15 00:05:24.000000', 'temperatura', 93.0000, 'ºC'),
	(154897, 121, '2014-01-15 00:05:25.000000', 'temperatura', 170.0000, 'ºC'),
	(154898, 121, '2014-01-15 00:05:26.000000', 'temperatura', 571.0000, 'ºC'),
	(154899, 121, '2014-01-15 00:05:27.000000', 'temperatura', 1145.0000, 'ºC'),
	(154900, 121, '2014-01-15 00:05:28.000000', 'temperatura', 412.0000, 'ºC'),
	(154901, 121, '2014-01-15 00:05:29.000000', 'temperatura', 1028.0000, 'ºC'),
	(154902, 121, '2014-01-15 00:05:30.000000', 'temperatura', 303.0000, 'ºC'),
	(154903, 121, '2014-01-15 00:05:31.000000', 'temperatura', 833.0000, 'ºC'),
	(154904, 121, '2014-01-15 00:05:32.000000', 'temperatura', 855.0000, 'ºC'),
	(154905, 121, '2014-01-15 00:05:33.000000', 'temperatura', 578.0000, 'ºC'),
	(154906, 121, '2014-01-15 00:05:34.000000', 'temperatura', 323.0000, 'ºC'),
	(154907, 121, '2014-01-15 00:05:35.000000', 'temperatura', 1082.0000, 'ºC'),
	(154908, 121, '2014-01-15 00:05:36.000000', 'temperatura', 842.0000, 'ºC'),
	(154909, 121, '2014-01-15 00:05:37.000000', 'temperatura', 962.0000, 'ºC'),
	(154910, 121, '2014-01-15 00:05:38.000000', 'temperatura', 1088.0000, 'ºC'),
	(154911, 121, '2014-01-15 00:05:39.000000', 'temperatura', 154.0000, 'ºC'),
	(154912, 121, '2014-01-15 00:05:40.000000', 'temperatura', 1106.0000, 'ºC'),
	(154913, 121, '2014-01-15 00:05:41.000000', 'temperatura', 270.0000, 'ºC'),
	(154914, 121, '2014-01-15 00:05:42.000000', 'temperatura', 431.0000, 'ºC'),
	(154915, 121, '2014-01-15 00:05:43.000000', 'temperatura', 147.0000, 'ºC'),
	(154916, 121, '2014-01-15 00:05:44.000000', 'temperatura', 643.0000, 'ºC'),
	(154917, 121, '2014-01-15 00:05:45.000000', 'temperatura', 373.0000, 'ºC'),
	(154918, 121, '2014-01-15 00:05:46.000000', 'temperatura', 1136.0000, 'ºC'),
	(154919, 121, '2014-01-15 00:05:47.000000', 'temperatura', 961.0000, 'ºC'),
	(154920, 121, '2014-01-15 00:05:48.000000', 'temperatura', 199.0000, 'ºC'),
	(154921, 121, '2014-01-15 00:05:49.000000', 'temperatura', 511.0000, 'ºC'),
	(154922, 121, '2014-01-15 00:05:50.000000', 'temperatura', 759.0000, 'ºC'),
	(154923, 121, '2014-01-15 00:05:51.000000', 'temperatura', 1061.0000, 'ºC'),
	(154924, 121, '2014-01-15 00:05:52.000000', 'temperatura', 631.0000, 'ºC'),
	(154925, 121, '2014-01-15 00:05:53.000000', 'temperatura', 1173.0000, 'ºC'),
	(154926, 121, '2014-01-15 00:05:54.000000', 'temperatura', 374.0000, 'ºC'),
	(154927, 121, '2014-01-15 00:05:55.000000', 'temperatura', 748.0000, 'ºC'),
	(154928, 121, '2014-01-15 00:05:56.000000', 'temperatura', 219.0000, 'ºC'),
	(154929, 121, '2014-01-15 00:05:57.000000', 'temperatura', 50.0000, 'ºC'),
	(154930, 121, '2014-01-15 00:05:58.000000', 'temperatura', 794.0000, 'ºC'),
	(154931, 121, '2014-01-15 00:05:59.000000', 'temperatura', 223.0000, 'ºC'),
	(154932, 121, '2014-01-15 00:06:00.000000', 'temperatura', 1131.0000, 'ºC'),
	(154933, 121, '2014-01-15 00:06:01.000000', 'temperatura', 187.0000, 'ºC'),
	(154934, 121, '2014-01-15 00:06:02.000000', 'temperatura', 1144.0000, 'ºC'),
	(154935, 121, '2014-01-15 00:06:03.000000', 'temperatura', 358.0000, 'ºC'),
	(154936, 121, '2014-01-15 00:06:04.000000', 'temperatura', 758.0000, 'ºC'),
	(154937, 121, '2014-01-15 00:06:05.000000', 'temperatura', 315.0000, 'ºC'),
	(154938, 121, '2014-01-15 00:06:06.000000', 'temperatura', 504.0000, 'ºC'),
	(154939, 121, '2014-01-15 00:06:07.000000', 'temperatura', 374.0000, 'ºC'),
	(154940, 121, '2014-01-15 00:06:08.000000', 'temperatura', 358.0000, 'ºC'),
	(154941, 121, '2014-01-15 00:06:09.000000', 'temperatura', 670.0000, 'ºC'),
	(154942, 121, '2014-01-15 00:06:10.000000', 'temperatura', 1078.0000, 'ºC'),
	(154943, 121, '2014-01-15 00:06:11.000000', 'temperatura', 978.0000, 'ºC'),
	(154944, 121, '2014-01-15 00:06:12.000000', 'temperatura', 457.0000, 'ºC'),
	(154945, 121, '2014-01-15 00:06:13.000000', 'temperatura', 553.0000, 'ºC'),
	(154946, 121, '2014-01-15 00:06:14.000000', 'temperatura', 193.0000, 'ºC'),
	(154947, 121, '2014-01-15 00:06:15.000000', 'temperatura', 507.0000, 'ºC'),
	(154948, 121, '2014-01-15 00:06:16.000000', 'temperatura', 756.0000, 'ºC'),
	(154949, 121, '2014-01-15 00:06:17.000000', 'temperatura', 1058.0000, 'ºC'),
	(154950, 121, '2014-01-15 00:06:18.000000', 'temperatura', 623.0000, 'ºC'),
	(154951, 121, '2014-01-15 00:06:19.000000', 'temperatura', 1142.0000, 'ºC'),
	(154952, 121, '2014-01-15 00:06:20.000000', 'temperatura', 242.0000, 'ºC'),
	(154953, 121, '2014-01-15 00:06:21.000000', 'temperatura', 185.0000, 'ºC'),
	(154954, 121, '2014-01-15 00:06:22.000000', 'temperatura', 201.0000, 'ºC'),
	(154955, 121, '2014-01-15 00:06:23.000000', 'temperatura', 447.0000, 'ºC'),
	(154956, 121, '2014-01-15 00:06:24.000000', 'temperatura', 434.0000, 'ºC'),
	(154957, 121, '2014-01-15 00:06:25.000000', 'temperatura', 828.0000, 'ºC'),
	(154958, 121, '2014-01-15 00:06:26.000000', 'temperatura', 439.0000, 'ºC'),
	(154959, 121, '2014-01-15 00:06:27.000000', 'temperatura', 912.0000, 'ºC'),
	(154960, 121, '2014-01-15 00:06:28.000000', 'temperatura', 844.0000, 'ºC'),
	(154961, 121, '2014-01-15 00:06:29.000000', 'temperatura', 283.0000, 'ºC'),
	(154962, 121, '2014-01-15 00:06:30.000000', 'temperatura', 83.0000, 'ºC'),
	(154963, 121, '2014-01-15 00:06:31.000000', 'temperatura', 767.0000, 'ºC'),
	(154964, 121, '2014-01-15 00:06:32.000000', 'temperatura', 1188.0000, 'ºC'),
	(154965, 121, '2014-01-15 00:06:33.000000', 'temperatura', 38.0000, 'ºC'),
	(154966, 121, '2014-01-15 00:06:34.000000', 'temperatura', 229.0000, 'ºC'),
	(154967, 121, '2014-01-15 00:06:35.000000', 'temperatura', 1029.0000, 'ºC'),
	(154968, 121, '2014-01-15 00:06:36.000000', 'temperatura', 860.0000, 'ºC'),
	(154969, 121, '2014-01-15 00:06:37.000000', 'temperatura', 14.0000, 'ºC'),
	(154970, 121, '2014-01-15 00:06:38.000000', 'temperatura', 1091.0000, 'ºC'),
	(154971, 121, '2014-01-15 00:06:39.000000', 'temperatura', 612.0000, 'ºC'),
	(154972, 121, '2014-01-15 00:06:40.000000', 'temperatura', 988.0000, 'ºC'),
	(154973, 121, '2014-01-15 00:06:41.000000', 'temperatura', 704.0000, 'ºC'),
	(154974, 121, '2014-01-15 00:06:42.000000', 'temperatura', 558.0000, 'ºC'),
	(154975, 121, '2014-01-15 00:06:43.000000', 'temperatura', 680.0000, 'ºC'),
	(154976, 121, '2014-01-15 00:06:44.000000', 'temperatura', 523.0000, 'ºC'),
	(154977, 121, '2014-01-15 00:06:45.000000', 'temperatura', 578.0000, 'ºC'),
	(154978, 121, '2014-01-15 00:06:46.000000', 'temperatura', 120.0000, 'ºC'),
	(154979, 121, '2014-01-15 00:06:47.000000', 'temperatura', 69.0000, 'ºC'),
	(154980, 121, '2014-01-15 00:06:48.000000', 'temperatura', 1184.0000, 'ºC'),
	(154981, 121, '2014-01-15 00:06:49.000000', 'temperatura', 914.0000, 'ºC'),
	(154982, 121, '2014-01-15 00:06:50.000000', 'temperatura', 1018.0000, 'ºC'),
	(154983, 121, '2014-01-15 00:06:51.000000', 'temperatura', 1150.0000, 'ºC'),
	(154984, 121, '2014-01-15 00:06:52.000000', 'temperatura', 296.0000, 'ºC'),
	(154985, 121, '2014-01-15 00:06:53.000000', 'temperatura', 430.0000, 'ºC'),
	(154986, 121, '2014-01-15 00:06:54.000000', 'temperatura', 63.0000, 'ºC'),
	(154987, 121, '2014-01-15 00:06:55.000000', 'temperatura', 226.0000, 'ºC'),
	(154988, 121, '2014-01-15 00:06:56.000000', 'temperatura', 939.0000, 'ºC'),
	(154989, 121, '2014-01-15 00:06:57.000000', 'temperatura', 420.0000, 'ºC'),
	(154990, 121, '2014-01-15 00:06:58.000000', 'temperatura', 483.0000, 'ºC'),
	(154991, 121, '2014-01-15 00:06:59.000000', 'temperatura', 1154.0000, 'ºC'),
	(154992, 121, '2014-01-15 00:07:00.000000', 'temperatura', 721.0000, 'ºC'),
	(154993, 121, '2014-01-15 00:07:01.000000', 'temperatura', 146.0000, 'ºC'),
	(154994, 121, '2014-01-15 00:07:02.000000', 'temperatura', 966.0000, 'ºC'),
	(154995, 121, '2014-01-15 00:07:03.000000', 'temperatura', 791.0000, 'ºC'),
	(154996, 121, '2014-01-15 00:07:04.000000', 'temperatura', 1060.0000, 'ºC'),
	(154997, 121, '2014-01-15 00:07:05.000000', 'temperatura', 525.0000, 'ºC'),
	(154998, 121, '2014-01-15 00:07:06.000000', 'temperatura', 648.0000, 'ºC'),
	(154999, 121, '2014-01-15 00:07:07.000000', 'temperatura', 464.0000, 'ºC'),
	(155000, 121, '2014-01-15 00:07:08.000000', 'temperatura', 376.0000, 'ºC'),
	(155001, 121, '2014-01-15 00:07:09.000000', 'temperatura', 491.0000, 'ºC'),
	(155002, 121, '2014-01-15 00:07:10.000000', 'temperatura', 127.0000, 'ºC'),
	(155003, 121, '2014-01-15 00:07:11.000000', 'temperatura', 362.0000, 'ºC'),
	(155004, 121, '2014-01-15 00:07:12.000000', 'temperatura', 228.0000, 'ºC'),
	(155005, 121, '2014-01-15 00:07:13.000000', 'temperatura', 56.0000, 'ºC'),
	(155006, 121, '2014-01-15 00:07:14.000000', 'temperatura', 795.0000, 'ºC'),
	(155007, 121, '2014-01-15 00:07:15.000000', 'temperatura', 208.0000, 'ºC'),
	(155008, 121, '2014-01-15 00:07:16.000000', 'temperatura', 1055.0000, 'ºC'),
	(155009, 121, '2014-01-15 00:07:17.000000', 'temperatura', 1052.0000, 'ºC'),
	(155010, 121, '2014-01-15 00:07:18.000000', 'temperatura', 895.0000, 'ºC'),
	(155011, 121, '2014-01-15 00:07:19.000000', 'temperatura', 119.0000, 'ºC'),
	(155012, 121, '2014-01-15 00:07:20.000000', 'temperatura', 310.0000, 'ºC'),
	(155013, 121, '2014-01-15 00:07:21.000000', 'temperatura', 1192.0000, 'ºC'),
	(155014, 121, '2014-01-15 00:07:22.000000', 'temperatura', 234.0000, 'ºC'),
	(155015, 121, '2014-01-15 00:07:23.000000', 'temperatura', 1194.0000, 'ºC'),
	(155016, 121, '2014-01-15 00:07:24.000000', 'temperatura', 466.0000, 'ºC'),
	(155017, 121, '2014-01-15 00:07:25.000000', 'temperatura', 1151.0000, 'ºC'),
	(155018, 121, '2014-01-15 00:07:26.000000', 'temperatura', 756.0000, 'ºC'),
	(155019, 121, '2014-01-15 00:07:27.000000', 'temperatura', 327.0000, 'ºC'),
	(155020, 121, '2014-01-15 00:07:28.000000', 'temperatura', 567.0000, 'ºC'),
	(155021, 121, '2014-01-15 00:07:29.000000', 'temperatura', 657.0000, 'ºC'),
	(155022, 121, '2014-01-15 00:07:30.000000', 'temperatura', 382.0000, 'ºC'),
	(155023, 121, '2014-01-15 00:07:31.000000', 'temperatura', 1140.0000, 'ºC'),
	(155024, 121, '2014-01-15 00:07:32.000000', 'temperatura', 956.0000, 'ºC'),
	(155025, 121, '2014-01-15 00:07:33.000000', 'temperatura', 161.0000, 'ºC'),
	(155026, 121, '2014-01-15 00:07:34.000000', 'temperatura', 338.0000, 'ºC'),
	(155027, 121, '2014-01-15 00:07:35.000000', 'temperatura', 8.0000, 'ºC'),
	(155028, 121, '2014-01-15 00:07:36.000000', 'temperatura', 227.0000, 'ºC'),
	(155029, 121, '2014-01-15 00:07:37.000000', 'temperatura', 1109.0000, 'ºC'),
	(155030, 121, '2014-01-15 00:07:38.000000', 'temperatura', 66.0000, 'ºC'),
	(155031, 121, '2014-01-15 00:07:39.000000', 'temperatura', 601.0000, 'ºC'),
	(155032, 121, '2014-01-15 00:07:40.000000', 'temperatura', 411.0000, 'ºC'),
	(155033, 121, '2014-01-15 00:07:41.000000', 'temperatura', 251.0000, 'ºC'),
	(155034, 121, '2014-01-15 00:07:42.000000', 'temperatura', 25.0000, 'ºC'),
	(155035, 121, '2014-01-15 00:07:43.000000', 'temperatura', 569.0000, 'ºC'),
	(155036, 121, '2014-01-15 00:07:44.000000', 'temperatura', 373.0000, 'ºC'),
	(155037, 121, '2014-01-15 00:07:45.000000', 'temperatura', 159.0000, 'ºC'),
	(155038, 121, '2014-01-15 00:07:46.000000', 'temperatura', 874.0000, 'ºC'),
	(155039, 121, '2014-01-15 00:07:47.000000', 'temperatura', 293.0000, 'ºC'),
	(155040, 121, '2014-01-15 00:07:48.000000', 'temperatura', 45.0000, 'ºC'),
	(155041, 121, '2014-01-15 00:07:49.000000', 'temperatura', 545.0000, 'ºC'),
	(155042, 121, '2014-01-15 00:07:50.000000', 'temperatura', 191.0000, 'ºC'),
	(155043, 121, '2014-01-15 00:07:51.000000', 'temperatura', 521.0000, 'ºC'),
	(155044, 121, '2014-01-15 00:07:52.000000', 'temperatura', 832.0000, 'ºC'),
	(155045, 121, '2014-01-15 00:07:53.000000', 'temperatura', 200.0000, 'ºC'),
	(155046, 121, '2014-01-15 00:07:54.000000', 'temperatura', 902.0000, 'ºC'),
	(155047, 121, '2014-01-15 00:07:55.000000', 'temperatura', 310.0000, 'ºC'),
	(155048, 121, '2014-01-15 00:07:56.000000', 'temperatura', 47.0000, 'ºC'),
	(155049, 121, '2014-01-15 00:07:57.000000', 'temperatura', 506.0000, 'ºC'),
	(155050, 121, '2014-01-15 00:07:58.000000', 'temperatura', 1187.0000, 'ºC'),
	(155051, 121, '2014-01-15 00:07:59.000000', 'temperatura', 819.0000, 'ºC'),
	(155052, 121, '2014-01-15 00:08:00.000000', 'temperatura', 536.0000, 'ºC'),
	(155053, 121, '2014-01-15 00:08:01.000000', 'temperatura', 222.0000, 'ºC'),
	(155054, 121, '2014-01-15 00:08:02.000000', 'temperatura', 701.0000, 'ºC'),
	(155055, 121, '2014-01-15 00:08:03.000000', 'temperatura', 442.0000, 'ºC'),
	(155056, 121, '2014-01-15 00:08:04.000000', 'temperatura', 106.0000, 'ºC'),
	(155057, 121, '2014-01-15 00:08:05.000000', 'temperatura', 405.0000, 'ºC'),
	(155058, 121, '2014-01-15 00:08:06.000000', 'temperatura', 506.0000, 'ºC'),
	(155059, 121, '2014-01-15 00:08:07.000000', 'temperatura', 118.0000, 'ºC'),
	(155060, 121, '2014-01-15 00:08:08.000000', 'temperatura', 271.0000, 'ºC'),
	(155061, 121, '2014-01-15 00:08:09.000000', 'temperatura', 1001.0000, 'ºC'),
	(155062, 121, '2014-01-15 00:08:10.000000', 'temperatura', 595.0000, 'ºC'),
	(155063, 121, '2014-01-15 00:08:11.000000', 'temperatura', 1171.0000, 'ºC'),
	(155064, 121, '2014-01-15 00:08:12.000000', 'temperatura', 472.0000, 'ºC'),
	(155065, 121, '2014-01-15 00:08:13.000000', 'temperatura', 49.0000, 'ºC'),
	(155066, 121, '2014-01-15 00:08:14.000000', 'temperatura', 26.0000, 'ºC'),
	(155067, 121, '2014-01-15 00:08:15.000000', 'temperatura', 1184.0000, 'ºC'),
	(155068, 121, '2014-01-15 00:08:16.000000', 'temperatura', 1041.0000, 'ºC'),
	(155069, 121, '2014-01-15 00:08:17.000000', 'temperatura', 455.0000, 'ºC'),
	(155070, 121, '2014-01-15 00:08:18.000000', 'temperatura', 355.0000, 'ºC'),
	(155071, 121, '2014-01-15 00:08:19.000000', 'temperatura', 407.0000, 'ºC'),
	(155072, 121, '2014-01-15 00:08:20.000000', 'temperatura', 971.0000, 'ºC'),
	(155073, 121, '2014-01-15 00:08:21.000000', 'temperatura', 34.0000, 'ºC'),
	(155074, 121, '2014-01-15 00:08:22.000000', 'temperatura', 858.0000, 'ºC'),
	(155075, 121, '2014-01-15 00:08:23.000000', 'temperatura', 590.0000, 'ºC'),
	(155076, 121, '2014-01-15 00:08:24.000000', 'temperatura', 375.0000, 'ºC'),
	(155077, 121, '2014-01-15 00:08:25.000000', 'temperatura', 108.0000, 'ºC'),
	(155078, 121, '2014-01-15 00:08:26.000000', 'temperatura', 613.0000, 'ºC'),
	(155079, 121, '2014-01-15 00:08:27.000000', 'temperatura', 341.0000, 'ºC'),
	(155080, 121, '2014-01-15 00:08:28.000000', 'temperatura', 1069.0000, 'ºC'),
	(155081, 121, '2014-01-15 00:08:29.000000', 'temperatura', 720.0000, 'ºC'),
	(155082, 121, '2014-01-15 00:08:30.000000', 'temperatura', 394.0000, 'ºC'),
	(155083, 121, '2014-01-15 00:08:31.000000', 'temperatura', 1010.0000, 'ºC'),
	(155084, 121, '2014-01-15 00:08:32.000000', 'temperatura', 270.0000, 'ºC'),
	(155085, 121, '2014-01-15 00:08:33.000000', 'temperatura', 720.0000, 'ºC'),
	(155086, 121, '2014-01-15 00:08:34.000000', 'temperatura', 391.0000, 'ºC'),
	(155087, 121, '2014-01-15 00:08:35.000000', 'temperatura', 995.0000, 'ºC'),
	(155088, 121, '2014-01-15 00:08:36.000000', 'temperatura', 203.0000, 'ºC'),
	(155089, 121, '2014-01-15 00:08:37.000000', 'temperatura', 430.0000, 'ºC'),
	(155090, 121, '2014-01-15 00:08:38.000000', 'temperatura', 340.0000, 'ºC'),
	(155091, 121, '2014-01-15 00:08:39.000000', 'temperatura', 410.0000, 'ºC'),
	(155092, 121, '2014-01-15 00:08:40.000000', 'temperatura', 1032.0000, 'ºC'),
	(155093, 121, '2014-01-15 00:08:41.000000', 'temperatura', 332.0000, 'ºC'),
	(155094, 121, '2014-01-15 00:08:42.000000', 'temperatura', 964.0000, 'ºC'),
	(155095, 121, '2014-01-15 00:08:43.000000', 'temperatura', 223.0000, 'ºC'),
	(155096, 121, '2014-01-15 00:08:44.000000', 'temperatura', 625.0000, 'ºC'),
	(155097, 121, '2014-01-15 00:08:45.000000', 'temperatura', 56.0000, 'ºC'),
	(155098, 121, '2014-01-15 00:08:46.000000', 'temperatura', 808.0000, 'ºC'),
	(155099, 121, '2014-01-15 00:08:47.000000', 'temperatura', 269.0000, 'ºC'),
	(155100, 121, '2014-01-15 00:08:48.000000', 'temperatura', 122.0000, 'ºC'),
	(155101, 121, '2014-01-15 00:08:49.000000', 'temperatura', 1004.0000, 'ºC'),
	(155102, 121, '2014-01-15 00:08:50.000000', 'temperatura', 1054.0000, 'ºC'),
	(155103, 121, '2014-01-15 00:08:51.000000', 'temperatura', 1060.0000, 'ºC'),
	(155104, 121, '2014-01-15 00:08:52.000000', 'temperatura', 938.0000, 'ºC'),
	(155105, 121, '2014-01-15 00:08:53.000000', 'temperatura', 312.0000, 'ºC'),
	(155106, 121, '2014-01-15 00:08:54.000000', 'temperatura', 1144.0000, 'ºC'),
	(155107, 121, '2014-01-15 00:08:55.000000', 'temperatura', 1185.0000, 'ºC'),
	(155108, 121, '2014-01-15 00:08:56.000000', 'temperatura', 92.0000, 'ºC'),
	(155109, 121, '2014-01-15 00:08:57.000000', 'temperatura', 507.0000, 'ºC'),
	(155110, 121, '2014-01-15 00:08:58.000000', 'temperatura', 1061.0000, 'ºC'),
	(155111, 121, '2014-01-15 00:08:59.000000', 'temperatura', 182.0000, 'ºC'),
	(155112, 121, '2014-01-15 00:09:00.000000', 'temperatura', 130.0000, 'ºC'),
	(155113, 121, '2014-01-15 00:09:01.000000', 'temperatura', 102.0000, 'ºC'),
	(155114, 121, '2014-01-15 00:09:02.000000', 'temperatura', 121.0000, 'ºC'),
	(155115, 121, '2014-01-15 00:09:03.000000', 'temperatura', 302.0000, 'ºC'),
	(155116, 121, '2014-01-15 00:09:04.000000', 'temperatura', 1145.0000, 'ºC'),
	(155117, 121, '2014-01-15 00:09:05.000000', 'temperatura', 20.0000, 'ºC'),
	(155118, 121, '2014-01-15 00:09:06.000000', 'temperatura', 264.0000, 'ºC'),
	(155119, 121, '2014-01-15 00:09:07.000000', 'temperatura', 61.0000, 'ºC'),
	(155120, 121, '2014-01-15 00:09:08.000000', 'temperatura', 712.0000, 'ºC'),
	(155121, 121, '2014-01-15 00:09:09.000000', 'temperatura', 978.0000, 'ºC'),
	(155122, 121, '2014-01-15 00:09:10.000000', 'temperatura', 357.0000, 'ºC'),
	(155123, 121, '2014-01-15 00:09:11.000000', 'temperatura', 48.0000, 'ºC'),
	(155124, 121, '2014-01-15 00:09:12.000000', 'temperatura', 372.0000, 'ºC'),
	(155125, 121, '2014-01-15 00:09:13.000000', 'temperatura', 514.0000, 'ºC'),
	(155126, 121, '2014-01-15 00:09:14.000000', 'temperatura', 256.0000, 'ºC'),
	(155127, 121, '2014-01-15 00:09:15.000000', 'temperatura', 940.0000, 'ºC'),
	(155128, 121, '2014-01-15 00:09:16.000000', 'temperatura', 332.0000, 'ºC'),
	(155129, 121, '2014-01-15 00:09:17.000000', 'temperatura', 42.0000, 'ºC'),
	(155130, 121, '2014-01-15 00:09:18.000000', 'temperatura', 412.0000, 'ºC'),
	(155131, 121, '2014-01-15 00:09:19.000000', 'temperatura', 734.0000, 'ºC'),
	(155132, 121, '2014-01-15 00:09:20.000000', 'temperatura', 35.0000, 'ºC'),
	(155133, 121, '2014-01-15 00:09:21.000000', 'temperatura', 372.0000, 'ºC'),
	(155134, 121, '2014-01-15 00:09:22.000000', 'temperatura', 558.0000, 'ºC'),
	(155135, 121, '2014-01-15 00:09:23.000000', 'temperatura', 472.0000, 'ºC'),
	(155136, 121, '2014-01-15 00:09:24.000000', 'temperatura', 688.0000, 'ºC'),
	(155137, 121, '2014-01-15 00:09:25.000000', 'temperatura', 824.0000, 'ºC'),
	(155138, 121, '2014-01-15 00:09:26.000000', 'temperatura', 857.0000, 'ºC'),
	(155139, 121, '2014-01-15 00:09:27.000000', 'temperatura', 614.0000, 'ºC'),
	(155140, 121, '2014-01-15 00:09:28.000000', 'temperatura', 498.0000, 'ºC'),
	(155141, 121, '2014-01-15 00:09:29.000000', 'temperatura', 651.0000, 'ºC'),
	(155142, 121, '2014-01-15 00:09:30.000000', 'temperatura', 558.0000, 'ºC'),
	(155143, 121, '2014-01-15 00:09:31.000000', 'temperatura', 840.0000, 'ºC'),
	(155144, 121, '2014-01-15 00:09:32.000000', 'temperatura', 126.0000, 'ºC'),
	(155145, 121, '2014-01-15 00:09:33.000000', 'temperatura', 509.0000, 'ºC'),
	(155146, 121, '2014-01-15 00:09:34.000000', 'temperatura', 970.0000, 'ºC'),
	(155147, 121, '2014-01-15 00:09:35.000000', 'temperatura', 921.0000, 'ºC'),
	(155148, 121, '2014-01-15 00:09:36.000000', 'temperatura', 498.0000, 'ºC'),
	(155149, 121, '2014-01-15 00:09:37.000000', 'temperatura', 928.0000, 'ºC'),
	(155150, 121, '2014-01-15 00:09:38.000000', 'temperatura', 745.0000, 'ºC'),
	(155151, 121, '2014-01-15 00:09:39.000000', 'temperatura', 942.0000, 'ºC'),
	(155152, 121, '2014-01-15 00:09:40.000000', 'temperatura', 77.0000, 'ºC'),
	(155153, 121, '2014-01-15 00:09:41.000000', 'temperatura', 1157.0000, 'ºC'),
	(155154, 121, '2014-01-15 00:09:42.000000', 'temperatura', 754.0000, 'ºC'),
	(155155, 121, '2014-01-15 00:09:43.000000', 'temperatura', 302.0000, 'ºC'),
	(155156, 121, '2014-01-15 00:09:44.000000', 'temperatura', 446.0000, 'ºC'),
	(155157, 121, '2014-01-15 00:09:45.000000', 'temperatura', 127.0000, 'ºC'),
	(155158, 121, '2014-01-15 00:09:46.000000', 'temperatura', 497.0000, 'ºC'),
	(155159, 121, '2014-01-15 00:09:47.000000', 'temperatura', 906.0000, 'ºC'),
	(155160, 121, '2014-01-15 00:09:48.000000', 'temperatura', 637.0000, 'ºC'),
	(155161, 121, '2014-01-15 00:09:49.000000', 'temperatura', 468.0000, 'ºC'),
	(155162, 121, '2014-01-15 00:09:50.000000', 'temperatura', 429.0000, 'ºC'),
	(155163, 121, '2014-01-15 00:09:51.000000', 'temperatura', 742.0000, 'ºC'),
	(155164, 121, '2014-01-15 00:09:52.000000', 'temperatura', 24.0000, 'ºC'),
	(155165, 121, '2014-01-15 00:09:53.000000', 'temperatura', 295.0000, 'ºC'),
	(155166, 121, '2014-01-15 00:09:54.000000', 'temperatura', 203.0000, 'ºC'),
	(155167, 121, '2014-01-15 00:09:55.000000', 'temperatura', 130.0000, 'ºC'),
	(155168, 121, '2014-01-15 00:09:56.000000', 'temperatura', 43.0000, 'ºC'),
	(155169, 121, '2014-01-15 00:09:57.000000', 'temperatura', 1024.0000, 'ºC'),
	(155170, 121, '2014-01-15 00:09:58.000000', 'temperatura', 190.0000, 'ºC'),
	(155171, 121, '2014-01-15 00:09:59.000000', 'temperatura', 282.0000, 'ºC'),
	(155172, 121, '2014-01-15 00:10:00.000000', 'temperatura', 837.0000, 'ºC'),
	(155173, 121, '2014-01-15 00:10:01.000000', 'temperatura', 941.0000, 'ºC'),
	(155174, 121, '2014-01-15 00:10:02.000000', 'temperatura', 993.0000, 'ºC'),
	(155175, 121, '2014-01-15 00:10:03.000000', 'temperatura', 942.0000, 'ºC'),
	(155176, 121, '2014-01-15 00:10:04.000000', 'temperatura', 532.0000, 'ºC'),
	(155177, 121, '2014-01-15 00:10:05.000000', 'temperatura', 1035.0000, 'ºC'),
	(155178, 121, '2014-01-15 00:10:06.000000', 'temperatura', 1181.0000, 'ºC'),
	(155179, 121, '2014-01-15 00:10:07.000000', 'temperatura', 398.0000, 'ºC'),
	(155180, 121, '2014-01-15 00:10:08.000000', 'temperatura', 846.0000, 'ºC'),
	(155181, 121, '2014-01-15 00:10:09.000000', 'temperatura', 640.0000, 'ºC'),
	(155182, 121, '2014-01-15 00:10:10.000000', 'temperatura', 663.0000, 'ºC'),
	(155183, 121, '2014-01-15 00:10:11.000000', 'temperatura', 193.0000, 'ºC'),
	(155184, 121, '2014-01-15 00:10:12.000000', 'temperatura', 178.0000, 'ºC'),
	(155185, 121, '2014-01-15 00:10:13.000000', 'temperatura', 310.0000, 'ºC'),
	(155186, 121, '2014-01-15 00:10:14.000000', 'temperatura', 1015.0000, 'ºC'),
	(155187, 121, '2014-01-15 00:10:15.000000', 'temperatura', 548.0000, 'ºC'),
	(155188, 121, '2014-01-15 00:10:16.000000', 'temperatura', 894.0000, 'ºC'),
	(155189, 121, '2014-01-15 00:10:17.000000', 'temperatura', 428.0000, 'ºC'),
	(155190, 121, '2014-01-15 00:10:18.000000', 'temperatura', 659.0000, 'ºC'),
	(155191, 121, '2014-01-15 00:10:19.000000', 'temperatura', 812.0000, 'ºC'),
	(155192, 121, '2014-01-15 00:10:20.000000', 'temperatura', 883.0000, 'ºC'),
	(155193, 121, '2014-01-15 00:10:21.000000', 'temperatura', 778.0000, 'ºC'),
	(155194, 121, '2014-01-15 00:10:22.000000', 'temperatura', 41.0000, 'ºC'),
	(155195, 121, '2014-01-15 00:10:23.000000', 'temperatura', 273.0000, 'ºC'),
	(155196, 121, '2014-01-15 00:10:24.000000', 'temperatura', 44.0000, 'ºC'),
	(155197, 121, '2014-01-15 00:10:25.000000', 'temperatura', 601.0000, 'ºC'),
	(155198, 121, '2014-01-15 00:10:26.000000', 'temperatura', 473.0000, 'ºC'),
	(155199, 121, '2014-01-15 00:10:27.000000', 'temperatura', 563.0000, 'ºC'),
	(155200, 121, '2014-01-15 00:10:28.000000', 'temperatura', 198.0000, 'ºC'),
	(155201, 121, '2014-01-15 00:10:29.000000', 'temperatura', 501.0000, 'ºC'),
	(155202, 121, '2014-01-15 00:10:30.000000', 'temperatura', 709.0000, 'ºC'),
	(155203, 121, '2014-01-15 00:10:31.000000', 'temperatura', 845.0000, 'ºC'),
	(155204, 121, '2014-01-15 00:10:32.000000', 'temperatura', 898.0000, 'ºC'),
	(155205, 121, '2014-01-15 00:10:33.000000', 'temperatura', 753.0000, 'ºC'),
	(155206, 121, '2014-01-15 00:10:34.000000', 'temperatura', 1074.0000, 'ºC'),
	(155207, 121, '2014-01-15 00:10:35.000000', 'temperatura', 713.0000, 'ºC'),
	(155208, 121, '2014-01-15 00:10:36.000000', 'temperatura', 341.0000, 'ºC'),
	(155209, 121, '2014-01-15 00:10:37.000000', 'temperatura', 766.0000, 'ºC'),
	(155210, 121, '2014-01-15 00:10:38.000000', 'temperatura', 410.0000, 'ºC'),
	(155211, 121, '2014-01-15 00:10:39.000000', 'temperatura', 950.0000, 'ºC'),
	(155212, 121, '2014-01-15 00:10:40.000000', 'temperatura', 1121.0000, 'ºC'),
	(155213, 121, '2014-01-15 00:10:41.000000', 'temperatura', 355.0000, 'ºC'),
	(155214, 121, '2014-01-15 00:10:42.000000', 'temperatura', 812.0000, 'ºC'),
	(155215, 121, '2014-01-15 00:10:43.000000', 'temperatura', 596.0000, 'ºC'),
	(155216, 121, '2014-01-15 00:10:44.000000', 'temperatura', 544.0000, 'ºC'),
	(155217, 121, '2014-01-15 00:10:45.000000', 'temperatura', 932.0000, 'ºC'),
	(155218, 121, '2014-01-15 00:10:46.000000', 'temperatura', 630.0000, 'ºC'),
	(155219, 121, '2014-01-15 00:10:47.000000', 'temperatura', 353.0000, 'ºC'),
	(155220, 121, '2014-01-15 00:10:48.000000', 'temperatura', 1076.0000, 'ºC'),
	(155221, 121, '2014-01-15 00:10:49.000000', 'temperatura', 720.0000, 'ºC'),
	(155222, 121, '2014-01-15 00:10:50.000000', 'temperatura', 375.0000, 'ºC'),
	(155223, 121, '2014-01-15 00:10:51.000000', 'temperatura', 916.0000, 'ºC'),
	(155224, 121, '2014-01-15 00:10:52.000000', 'temperatura', 1055.0000, 'ºC'),
	(155225, 121, '2014-01-15 00:10:53.000000', 'temperatura', 129.0000, 'ºC'),
	(155226, 121, '2014-01-15 00:10:54.000000', 'temperatura', 1080.0000, 'ºC'),
	(155227, 121, '2014-01-15 00:10:55.000000', 'temperatura', 213.0000, 'ºC'),
	(155228, 121, '2014-01-15 00:10:56.000000', 'temperatura', 225.0000, 'ºC'),
	(155229, 121, '2014-01-15 00:10:57.000000', 'temperatura', 488.0000, 'ºC'),
	(155230, 121, '2014-01-15 00:10:58.000000', 'temperatura', 563.0000, 'ºC'),
	(155231, 121, '2014-01-15 00:10:59.000000', 'temperatura', 153.0000, 'ºC'),
	(155232, 121, '2014-01-15 00:11:00.000000', 'temperatura', 277.0000, 'ºC'),
	(155233, 121, '2014-01-15 00:11:01.000000', 'temperatura', 927.0000, 'ºC'),
	(155234, 121, '2014-01-15 00:11:02.000000', 'temperatura', 205.0000, 'ºC'),
	(155235, 121, '2014-01-15 00:11:03.000000', 'temperatura', 642.0000, 'ºC'),
	(155236, 121, '2014-01-15 00:11:04.000000', 'temperatura', 199.0000, 'ºC'),
	(155237, 121, '2014-01-15 00:11:05.000000', 'temperatura', 266.0000, 'ºC'),
	(155238, 121, '2014-01-15 00:11:06.000000', 'temperatura', 736.0000, 'ºC'),
	(155239, 121, '2014-01-15 00:11:07.000000', 'temperatura', 481.0000, 'ºC'),
	(155240, 121, '2014-01-15 00:11:08.000000', 'temperatura', 199.0000, 'ºC'),
	(155241, 121, '2014-01-15 00:11:09.000000', 'temperatura', 753.0000, 'ºC'),
	(155242, 121, '2014-01-15 00:11:10.000000', 'temperatura', 770.0000, 'ºC'),
	(155243, 121, '2014-01-15 00:11:11.000000', 'temperatura', 389.0000, 'ºC'),
	(155244, 121, '2014-01-15 00:11:12.000000', 'temperatura', 835.0000, 'ºC'),
	(155245, 121, '2014-01-15 00:11:13.000000', 'temperatura', 608.0000, 'ºC'),
	(155246, 121, '2014-01-15 00:11:14.000000', 'temperatura', 536.0000, 'ºC'),
	(155247, 121, '2014-01-15 00:11:15.000000', 'temperatura', 855.0000, 'ºC'),
	(155248, 121, '2014-01-15 00:11:16.000000', 'temperatura', 268.0000, 'ºC'),
	(155249, 121, '2014-01-15 00:11:17.000000', 'temperatura', 1177.0000, 'ºC'),
	(155250, 121, '2014-01-15 00:11:18.000000', 'temperatura', 280.0000, 'ºC'),
	(155251, 121, '2014-01-15 00:11:19.000000', 'temperatura', 269.0000, 'ºC'),
	(155252, 121, '2014-01-15 00:11:20.000000', 'temperatura', 507.0000, 'ºC'),
	(155253, 121, '2014-01-15 00:11:21.000000', 'temperatura', 528.0000, 'ºC'),
	(155254, 121, '2014-01-15 00:11:22.000000', 'temperatura', 1121.0000, 'ºC'),
	(155255, 121, '2014-01-15 00:11:23.000000', 'temperatura', 422.0000, 'ºC'),
	(155256, 121, '2014-01-15 00:11:24.000000', 'temperatura', 1145.0000, 'ºC'),
	(155257, 121, '2014-01-15 00:11:25.000000', 'temperatura', 859.0000, 'ºC'),
	(155258, 121, '2014-01-15 00:11:26.000000', 'temperatura', 863.0000, 'ºC'),
	(155259, 121, '2014-01-15 00:11:27.000000', 'temperatura', 536.0000, 'ºC'),
	(155260, 121, '2014-01-15 00:11:28.000000', 'temperatura', 91.0000, 'ºC'),
	(155261, 121, '2014-01-15 00:11:29.000000', 'temperatura', 48.0000, 'ºC'),
	(155262, 121, '2014-01-15 00:11:30.000000', 'temperatura', 1168.0000, 'ºC'),
	(155263, 121, '2014-01-15 00:11:31.000000', 'temperatura', 898.0000, 'ºC'),
	(155264, 121, '2014-01-15 00:11:32.000000', 'temperatura', 985.0000, 'ºC'),
	(155265, 121, '2014-01-15 00:11:33.000000', 'temperatura', 1033.0000, 'ºC'),
	(155266, 121, '2014-01-15 00:11:34.000000', 'temperatura', 1008.0000, 'ºC'),
	(155267, 121, '2014-01-15 00:11:35.000000', 'temperatura', 743.0000, 'ºC'),
	(155268, 121, '2014-01-15 00:11:36.000000', 'temperatura', 691.0000, 'ºC'),
	(155269, 121, '2014-01-15 00:11:37.000000', 'temperatura', 26.0000, 'ºC'),
	(155270, 121, '2014-01-15 00:11:38.000000', 'temperatura', 460.0000, 'ºC'),
	(155271, 121, '2014-01-15 00:11:39.000000', 'temperatura', 1019.0000, 'ºC'),
	(155272, 121, '2014-01-15 00:11:40.000000', 'temperatura', 119.0000, 'ºC'),
	(155273, 121, '2014-01-15 00:11:41.000000', 'temperatura', 1135.0000, 'ºC'),
	(155274, 121, '2014-01-15 00:11:42.000000', 'temperatura', 521.0000, 'ºC'),
	(155275, 121, '2014-01-15 00:11:43.000000', 'temperatura', 401.0000, 'ºC'),
	(155276, 121, '2014-01-15 00:11:44.000000', 'temperatura', 441.0000, 'ºC'),
	(155277, 121, '2014-01-15 00:11:45.000000', 'temperatura', 1004.0000, 'ºC'),
	(155278, 121, '2014-01-15 00:11:46.000000', 'temperatura', 99.0000, 'ºC'),
	(155279, 121, '2014-01-15 00:11:47.000000', 'temperatura', 1081.0000, 'ºC'),
	(155280, 121, '2014-01-15 00:11:48.000000', 'temperatura', 311.0000, 'ºC'),
	(155281, 121, '2014-01-15 00:11:49.000000', 'temperatura', 710.0000, 'ºC'),
	(155282, 121, '2014-01-15 00:11:50.000000', 'temperatura', 220.0000, 'ºC'),
	(155283, 121, '2014-01-15 00:11:51.000000', 'temperatura', 171.0000, 'ºC'),
	(155284, 121, '2014-01-15 00:11:52.000000', 'temperatura', 195.0000, 'ºC'),
	(155285, 121, '2014-01-15 00:11:53.000000', 'temperatura', 463.0000, 'ºC'),
	(155286, 121, '2014-01-15 00:11:54.000000', 'temperatura', 529.0000, 'ºC'),
	(155287, 121, '2014-01-15 00:11:55.000000', 'temperatura', 56.0000, 'ºC'),
	(155288, 121, '2014-01-15 00:11:56.000000', 'temperatura', 1094.0000, 'ºC'),
	(155289, 121, '2014-01-15 00:11:57.000000', 'temperatura', 501.0000, 'ºC'),
	(155290, 121, '2014-01-15 00:11:58.000000', 'temperatura', 424.0000, 'ºC'),
	(155291, 121, '2014-01-15 00:11:59.000000', 'temperatura', 619.0000, 'ºC'),
	(155292, 121, '2014-01-15 00:12:00.000000', 'temperatura', 622.0000, 'ºC'),
	(155293, 121, '2014-01-15 00:12:01.000000', 'temperatura', 54.0000, 'ºC'),
	(155294, 121, '2014-01-15 00:12:02.000000', 'temperatura', 806.0000, 'ºC'),
	(155295, 121, '2014-01-15 00:12:03.000000', 'temperatura', 268.0000, 'ºC'),
	(155296, 121, '2014-01-15 00:12:04.000000', 'temperatura', 121.0000, 'ºC'),
	(155297, 121, '2014-01-15 00:12:05.000000', 'temperatura', 1002.0000, 'ºC'),
	(155298, 121, '2014-01-15 00:12:06.000000', 'temperatura', 1046.0000, 'ºC'),
	(155299, 121, '2014-01-15 00:12:07.000000', 'temperatura', 1025.0000, 'ºC'),
	(155300, 121, '2014-01-15 00:12:08.000000', 'temperatura', 788.0000, 'ºC'),
	(155301, 121, '2014-01-15 00:12:09.000000', 'temperatura', 864.0000, 'ºC'),
	(155302, 121, '2014-01-15 00:12:10.000000', 'temperatura', 755.0000, 'ºC'),
	(155303, 121, '2014-01-15 00:12:11.000000', 'temperatura', 1187.0000, 'ºC'),
	(155304, 121, '2014-01-15 00:12:12.000000', 'temperatura', 70.0000, 'ºC'),
	(155305, 121, '2014-01-15 00:12:13.000000', 'temperatura', 389.0000, 'ºC'),
	(155306, 121, '2014-01-15 00:12:14.000000', 'temperatura', 537.0000, 'ºC'),
	(155307, 121, '2014-01-15 00:12:15.000000', 'temperatura', 316.0000, 'ºC'),
	(155308, 121, '2014-01-15 00:12:16.000000', 'temperatura', 1170.0000, 'ºC'),
	(155309, 121, '2014-01-15 00:12:17.000000', 'temperatura', 102.0000, 'ºC'),
	(155310, 121, '2014-01-15 00:12:18.000000', 'temperatura', 600.0000, 'ºC'),
	(155311, 121, '2014-01-15 00:12:19.000000', 'temperatura', 294.0000, 'ºC'),
	(155312, 121, '2014-01-15 00:12:20.000000', 'temperatura', 872.0000, 'ºC'),
	(155313, 121, '2014-01-15 00:12:21.000000', 'temperatura', 1078.0000, 'ºC'),
	(155314, 121, '2014-01-15 00:12:22.000000', 'temperatura', 373.0000, 'ºC'),
	(155315, 121, '2014-01-15 00:12:23.000000', 'temperatura', 1032.0000, 'ºC'),
	(155316, 121, '2014-01-15 00:12:24.000000', 'temperatura', 444.0000, 'ºC'),
	(155317, 121, '2014-01-15 00:12:25.000000', 'temperatura', 322.0000, 'ºC'),
	(155318, 121, '2014-01-15 00:12:26.000000', 'temperatura', 278.0000, 'ºC'),
	(155319, 121, '2014-01-15 00:12:27.000000', 'temperatura', 424.0000, 'ºC'),
	(155320, 121, '2014-01-15 00:12:28.000000', 'temperatura', 87.0000, 'ºC'),
	(155321, 121, '2014-01-15 00:12:29.000000', 'temperatura', 363.0000, 'ºC'),
	(155322, 121, '2014-01-15 00:12:30.000000', 'temperatura', 353.0000, 'ºC'),
	(155323, 121, '2014-01-15 00:12:31.000000', 'temperatura', 680.0000, 'ºC'),
	(155324, 121, '2014-01-15 00:12:32.000000', 'temperatura', 1139.0000, 'ºC'),
	(155325, 121, '2014-01-15 00:12:33.000000', 'temperatura', 57.0000, 'ºC'),
	(155326, 121, '2014-01-15 00:12:34.000000', 'temperatura', 466.0000, 'ºC'),
	(155327, 121, '2014-01-15 00:12:35.000000', 'temperatura', 961.0000, 'ºC'),
	(155328, 121, '2014-01-15 00:12:36.000000', 'temperatura', 1009.0000, 'ºC'),
	(155329, 121, '2014-01-15 00:12:37.000000', 'temperatura', 963.0000, 'ºC'),
	(155330, 121, '2014-01-15 00:12:38.000000', 'temperatura', 588.0000, 'ºC'),
	(155331, 121, '2014-01-15 00:12:39.000000', 'temperatura', 50.0000, 'ºC'),
	(155332, 121, '2014-01-15 00:12:40.000000', 'temperatura', 885.0000, 'ºC'),
	(155333, 121, '2014-01-15 00:12:41.000000', 'temperatura', 679.0000, 'ºC'),
	(155334, 121, '2014-01-15 00:12:42.000000', 'temperatura', 739.0000, 'ºC'),
	(155335, 121, '2014-01-15 00:12:43.000000', 'temperatura', 458.0000, 'ºC'),
	(155336, 121, '2014-01-15 00:12:44.000000', 'temperatura', 74.0000, 'ºC'),
	(155337, 121, '2014-01-15 00:12:45.000000', 'temperatura', 195.0000, 'ºC'),
	(155338, 121, '2014-01-15 00:12:46.000000', 'temperatura', 755.0000, 'ºC'),
	(155339, 121, '2014-01-15 00:12:47.000000', 'temperatura', 789.0000, 'ºC'),
	(155340, 121, '2014-01-15 00:12:48.000000', 'temperatura', 480.0000, 'ºC'),
	(155341, 121, '2014-01-15 00:12:49.000000', 'temperatura', 35.0000, 'ºC'),
	(155342, 121, '2014-01-15 00:12:50.000000', 'temperatura', 1137.0000, 'ºC'),
	(155343, 121, '2014-01-15 00:12:51.000000', 'temperatura', 778.0000, 'ºC'),
	(155344, 121, '2014-01-15 00:12:52.000000', 'temperatura', 479.0000, 'ºC'),
	(155345, 121, '2014-01-15 00:12:53.000000', 'temperatura', 64.0000, 'ºC'),
	(155346, 121, '2014-01-15 00:12:54.000000', 'temperatura', 82.0000, 'ºC'),
	(155347, 121, '2014-01-15 00:12:55.000000', 'temperatura', 217.0000, 'ºC'),
	(155348, 121, '2014-01-15 00:12:56.000000', 'temperatura', 842.0000, 'ºC'),
	(155349, 121, '2014-01-15 00:12:57.000000', 'temperatura', 1157.0000, 'ºC'),
	(155350, 121, '2014-01-15 00:12:58.000000', 'temperatura', 859.0000, 'ºC'),
	(155351, 121, '2014-01-15 00:12:59.000000', 'temperatura', 827.0000, 'ºC'),
	(155352, 121, '2014-01-15 00:13:00.000000', 'temperatura', 356.0000, 'ºC'),
	(155353, 121, '2014-01-15 00:13:01.000000', 'temperatura', 502.0000, 'ºC'),
	(155354, 121, '2014-01-15 00:13:02.000000', 'temperatura', 242.0000, 'ºC'),
	(155355, 121, '2014-01-15 00:13:03.000000', 'temperatura', 903.0000, 'ºC'),
	(155356, 121, '2014-01-15 00:13:04.000000', 'temperatura', 191.0000, 'ºC'),
	(155357, 121, '2014-01-15 00:13:05.000000', 'temperatura', 644.0000, 'ºC'),
	(155358, 121, '2014-01-15 00:13:06.000000', 'temperatura', 250.0000, 'ºC'),
	(155359, 121, '2014-01-15 00:13:07.000000', 'temperatura', 517.0000, 'ºC'),
	(155360, 121, '2014-01-15 00:13:08.000000', 'temperatura', 636.0000, 'ºC'),
	(155361, 121, '2014-01-15 00:13:09.000000', 'temperatura', 432.0000, 'ºC'),
	(155362, 121, '2014-01-15 00:13:10.000000', 'temperatura', 249.0000, 'ºC'),
	(155363, 121, '2014-01-15 00:13:11.000000', 'temperatura', 1151.0000, 'ºC'),
	(155364, 121, '2014-01-15 00:13:12.000000', 'temperatura', 209.0000, 'ºC'),
	(155365, 121, '2014-01-15 00:13:13.000000', 'temperatura', 1193.0000, 'ºC'),
	(155366, 121, '2014-01-15 00:13:14.000000', 'temperatura', 539.0000, 'ºC'),
	(155367, 121, '2014-01-15 00:13:15.000000', 'temperatura', 315.0000, 'ºC'),
	(155368, 121, '2014-01-15 00:13:16.000000', 'temperatura', 1158.0000, 'ºC'),
	(155369, 121, '2014-01-15 00:13:17.000000', 'temperatura', 48.0000, 'ºC'),
	(155370, 121, '2014-01-15 00:13:18.000000', 'temperatura', 366.0000, 'ºC'),
	(155371, 121, '2014-01-15 00:13:19.000000', 'temperatura', 488.0000, 'ºC'),
	(155372, 121, '2014-01-15 00:13:20.000000', 'temperatura', 141.0000, 'ºC'),
	(155373, 121, '2014-01-15 00:13:21.000000', 'temperatura', 441.0000, 'ºC'),
	(155374, 121, '2014-01-15 00:13:22.000000', 'temperatura', 583.0000, 'ºC'),
	(155375, 121, '2014-01-15 00:13:23.000000', 'temperatura', 394.0000, 'ºC'),
	(155376, 121, '2014-01-15 00:13:24.000000', 'temperatura', 220.0000, 'ºC'),
	(155377, 121, '2014-01-15 00:13:25.000000', 'temperatura', 1119.0000, 'ºC'),
	(155378, 121, '2014-01-15 00:13:26.000000', 'temperatura', 135.0000, 'ºC'),
	(155379, 121, '2014-01-15 00:13:27.000000', 'temperatura', 920.0000, 'ºC'),
	(155380, 121, '2014-01-15 00:13:28.000000', 'temperatura', 596.0000, 'ºC'),
	(155381, 121, '2014-01-15 00:13:29.000000', 'temperatura', 221.0000, 'ºC'),
	(155382, 121, '2014-01-15 00:13:30.000000', 'temperatura', 515.0000, 'ºC'),
	(155383, 121, '2014-01-15 00:13:31.000000', 'temperatura', 712.0000, 'ºC'),
	(155384, 121, '2014-01-15 00:13:32.000000', 'temperatura', 817.0000, 'ºC'),
	(155385, 121, '2014-01-15 00:13:33.000000', 'temperatura', 751.0000, 'ºC'),
	(155386, 121, '2014-01-15 00:13:34.000000', 'temperatura', 104.0000, 'ºC'),
	(155387, 121, '2014-01-15 00:13:35.000000', 'temperatura', 666.0000, 'ºC'),
	(155388, 121, '2014-01-15 00:13:36.000000', 'temperatura', 621.0000, 'ºC'),
	(155389, 121, '2014-01-15 00:13:37.000000', 'temperatura', 1105.0000, 'ºC'),
	(155390, 121, '2014-01-15 00:13:38.000000', 'temperatura', 64.0000, 'ºC'),
	(155391, 121, '2014-01-15 00:13:39.000000', 'temperatura', 605.0000, 'ºC'),
	(155392, 121, '2014-01-15 00:13:40.000000', 'temperatura', 435.0000, 'ºC'),
	(155393, 121, '2014-01-15 00:13:41.000000', 'temperatura', 358.0000, 'ºC'),
	(155394, 121, '2014-01-15 00:13:42.000000', 'temperatura', 486.0000, 'ºC'),
	(155395, 121, '2014-01-15 00:13:43.000000', 'temperatura', 158.0000, 'ºC'),
	(155396, 121, '2014-01-15 00:13:44.000000', 'temperatura', 534.0000, 'ºC'),
	(155397, 121, '2014-01-15 00:13:45.000000', 'temperatura', 993.0000, 'ºC'),
	(155398, 121, '2014-01-15 00:13:46.000000', 'temperatura', 965.0000, 'ºC'),
	(155399, 121, '2014-01-15 00:13:47.000000', 'temperatura', 645.0000, 'ºC'),
	(155400, 121, '2014-01-15 00:13:48.000000', 'temperatura', 331.0000, 'ºC'),
	(155401, 121, '2014-01-15 00:13:49.000000', 'temperatura', 920.0000, 'ºC'),
	(155402, 121, '2014-01-15 00:13:50.000000', 'temperatura', 6.0000, 'ºC'),
	(155403, 121, '2014-01-15 00:13:51.000000', 'temperatura', 874.0000, 'ºC'),
	(155404, 121, '2014-01-15 00:13:52.000000', 'temperatura', 751.0000, 'ºC'),
	(155405, 121, '2014-01-15 00:13:53.000000', 'temperatura', 1133.0000, 'ºC'),
	(155406, 121, '2014-01-15 00:13:54.000000', 'temperatura', 1013.0000, 'ºC'),
	(155407, 121, '2014-01-15 00:13:55.000000', 'temperatura', 468.0000, 'ºC'),
	(155408, 121, '2014-01-15 00:13:56.000000', 'temperatura', 499.0000, 'ºC'),
	(155409, 121, '2014-01-15 00:13:57.000000', 'temperatura', 1092.0000, 'ºC'),
	(155410, 121, '2014-01-15 00:13:58.000000', 'temperatura', 363.0000, 'ºC'),
	(155411, 121, '2014-01-15 00:13:59.000000', 'temperatura', 941.0000, 'ºC'),
	(155412, 121, '2014-01-15 00:14:00.000000', 'temperatura', 16.0000, 'ºC'),
	(155413, 121, '2014-01-15 00:14:01.000000', 'temperatura', 856.0000, 'ºC'),
	(155414, 121, '2014-01-15 00:14:02.000000', 'temperatura', 633.0000, 'ºC'),
	(155415, 121, '2014-01-15 00:14:03.000000', 'temperatura', 599.0000, 'ºC'),
	(155416, 121, '2014-01-15 00:14:04.000000', 'temperatura', 1096.0000, 'ºC'),
	(155417, 121, '2014-01-15 00:14:05.000000', 'temperatura', 83.0000, 'ºC'),
	(155418, 121, '2014-01-15 00:14:06.000000', 'temperatura', 726.0000, 'ºC'),
	(155419, 121, '2014-01-15 00:14:07.000000', 'temperatura', 982.0000, 'ºC'),
	(155420, 121, '2014-01-15 00:14:08.000000', 'temperatura', 332.0000, 'ºC'),
	(155421, 121, '2014-01-15 00:14:09.000000', 'temperatura', 1114.0000, 'ºC'),
	(155422, 121, '2014-01-15 00:14:10.000000', 'temperatura', 977.0000, 'ºC'),
	(155423, 121, '2014-01-15 00:14:11.000000', 'temperatura', 344.0000, 'ºC'),
	(155424, 121, '2014-01-15 00:14:12.000000', 'temperatura', 1188.0000, 'ºC'),
	(155425, 121, '2014-01-15 00:14:13.000000', 'temperatura', 111.0000, 'ºC'),
	(155426, 121, '2014-01-15 00:14:14.000000', 'temperatura', 589.0000, 'ºC'),
	(155427, 121, '2014-01-15 00:14:15.000000', 'temperatura', 214.0000, 'ºC'),
	(155428, 121, '2014-01-15 00:14:16.000000', 'temperatura', 505.0000, 'ºC'),
	(155429, 121, '2014-01-15 00:14:17.000000', 'temperatura', 681.0000, 'ºC'),
	(155430, 121, '2014-01-15 00:14:18.000000', 'temperatura', 693.0000, 'ºC'),
	(155431, 121, '2014-01-15 00:14:19.000000', 'temperatura', 222.0000, 'ºC'),
	(155432, 121, '2014-01-15 00:14:20.000000', 'temperatura', 230.0000, 'ºC'),
	(155433, 121, '2014-01-15 00:14:21.000000', 'temperatura', 487.0000, 'ºC'),
	(155434, 121, '2014-01-15 00:14:22.000000', 'temperatura', 542.0000, 'ºC'),
	(155435, 121, '2014-01-15 00:14:23.000000', 'temperatura', 52.0000, 'ºC'),
	(155436, 121, '2014-01-15 00:14:24.000000', 'temperatura', 1033.0000, 'ºC'),
	(155437, 121, '2014-01-15 00:14:25.000000', 'temperatura', 208.0000, 'ºC'),
	(155438, 121, '2014-01-15 00:14:26.000000', 'temperatura', 344.0000, 'ºC'),
	(155439, 121, '2014-01-15 00:14:27.000000', 'temperatura', 1096.0000, 'ºC'),
	(155440, 121, '2014-01-15 00:14:28.000000', 'temperatura', 850.0000, 'ºC'),
	(155441, 121, '2014-01-15 00:14:29.000000', 'temperatura', 962.0000, 'ºC'),
	(155442, 121, '2014-01-15 00:14:30.000000', 'temperatura', 1059.0000, 'ºC'),
	(155443, 121, '2014-01-15 00:14:31.000000', 'temperatura', 9.0000, 'ºC'),
	(155444, 121, '2014-01-15 00:14:32.000000', 'temperatura', 468.0000, 'ºC'),
	(155445, 121, '2014-01-15 00:14:33.000000', 'temperatura', 1113.0000, 'ºC'),
	(155446, 121, '2014-01-15 00:14:34.000000', 'temperatura', 564.0000, 'ºC'),
	(155447, 121, '2014-01-15 00:14:35.000000', 'temperatura', 680.0000, 'ºC'),
	(155448, 121, '2014-01-15 00:14:36.000000', 'temperatura', 509.0000, 'ºC'),
	(155449, 121, '2014-01-15 00:14:37.000000', 'temperatura', 504.0000, 'ºC'),
	(155450, 121, '2014-01-15 00:14:38.000000', 'temperatura', 996.0000, 'ºC'),
	(155451, 121, '2014-01-15 00:14:39.000000', 'temperatura', 1067.0000, 'ºC'),
	(155452, 121, '2014-01-15 00:14:40.000000', 'temperatura', 1147.0000, 'ºC'),
	(155453, 121, '2014-01-15 00:14:41.000000', 'temperatura', 133.0000, 'ºC'),
	(155454, 121, '2014-01-15 00:14:42.000000', 'temperatura', 827.0000, 'ºC'),
	(155455, 121, '2014-01-15 00:14:43.000000', 'temperatura', 134.0000, 'ºC'),
	(155456, 121, '2014-01-15 00:14:44.000000', 'temperatura', 590.0000, 'ºC'),
	(155457, 121, '2014-01-15 00:14:45.000000', 'temperatura', 147.0000, 'ºC'),
	(155458, 121, '2014-01-15 00:14:46.000000', 'temperatura', 168.0000, 'ºC'),
	(155459, 121, '2014-01-15 00:14:47.000000', 'temperatura', 397.0000, 'ºC'),
	(155460, 121, '2014-01-15 00:14:48.000000', 'temperatura', 282.0000, 'ºC'),
	(155461, 121, '2014-01-15 00:14:49.000000', 'temperatura', 219.0000, 'ºC'),
	(155462, 121, '2014-01-15 00:14:50.000000', 'temperatura', 249.0000, 'ºC'),
	(155463, 121, '2014-01-15 00:14:51.000000', 'temperatura', 591.0000, 'ºC'),
	(155464, 121, '2014-01-15 00:14:52.000000', 'temperatura', 1007.0000, 'ºC'),
	(155465, 121, '2014-01-15 00:14:53.000000', 'temperatura', 864.0000, 'ºC'),
	(155466, 121, '2014-01-15 00:14:54.000000', 'temperatura', 97.0000, 'ºC'),
	(155467, 121, '2014-01-15 00:14:55.000000', 'temperatura', 297.0000, 'ºC'),
	(155468, 121, '2014-01-15 00:14:56.000000', 'temperatura', 1191.0000, 'ºC'),
	(155469, 121, '2014-01-15 00:14:57.000000', 'temperatura', 267.0000, 'ºC'),
	(155470, 121, '2014-01-15 00:14:58.000000', 'temperatura', 161.0000, 'ºC'),
	(155471, 121, '2014-01-15 00:14:59.000000', 'temperatura', 6.0000, 'ºC'),
	(155472, 121, '2014-01-15 00:15:00.000000', 'temperatura', 747.0000, 'ºC'),
	(155473, 121, '2014-01-15 00:15:01.000000', 'temperatura', 119.0000, 'ºC'),
	(155474, 121, '2014-01-15 00:15:02.000000', 'temperatura', 752.0000, 'ºC'),
	(155475, 121, '2014-01-15 00:15:03.000000', 'temperatura', 1003.0000, 'ºC'),
	(155476, 121, '2014-01-15 00:15:04.000000', 'temperatura', 360.0000, 'ºC'),
	(155477, 121, '2014-01-15 00:15:05.000000', 'temperatura', 1192.0000, 'ºC'),
	(155478, 121, '2014-01-15 00:15:06.000000', 'temperatura', 78.0000, 'ºC'),
	(155479, 121, '2014-01-15 00:15:07.000000', 'temperatura', 418.0000, 'ºC'),
	(155480, 121, '2014-01-15 00:15:08.000000', 'temperatura', 654.0000, 'ºC'),
	(155481, 121, '2014-01-15 00:15:09.000000', 'temperatura', 819.0000, 'ºC'),
	(155482, 121, '2014-01-15 00:15:10.000000', 'temperatura', 933.0000, 'ºC'),
	(155483, 121, '2014-01-15 00:15:11.000000', 'temperatura', 1007.0000, 'ºC'),
	(155484, 121, '2014-01-15 00:15:12.000000', 'temperatura', 1038.0000, 'ºC'),
	(155485, 121, '2014-01-15 00:15:13.000000', 'temperatura', 971.0000, 'ºC'),
	(155486, 121, '2014-01-15 00:15:14.000000', 'temperatura', 538.0000, 'ºC'),
	(155487, 121, '2014-01-15 00:15:15.000000', 'temperatura', 981.0000, 'ºC'),
	(155488, 121, '2014-01-15 00:15:16.000000', 'temperatura', 890.0000, 'ºC'),
	(155489, 121, '2014-01-15 00:15:17.000000', 'temperatura', 307.0000, 'ºC'),
	(155490, 121, '2014-01-15 00:15:18.000000', 'temperatura', 68.0000, 'ºC'),
	(155491, 121, '2014-01-15 00:15:19.000000', 'temperatura', 616.0000, 'ºC'),
	(155492, 121, '2014-01-15 00:15:20.000000', 'temperatura', 479.0000, 'ºC'),
	(155493, 121, '2014-01-15 00:15:21.000000', 'temperatura', 546.0000, 'ºC'),
	(155494, 121, '2014-01-15 00:15:22.000000', 'temperatura', 92.0000, 'ºC'),
	(155495, 121, '2014-01-15 00:15:23.000000', 'temperatura', 26.0000, 'ºC'),
	(155496, 121, '2014-01-15 00:15:24.000000', 'temperatura', 1053.0000, 'ºC'),
	(155497, 121, '2014-01-15 00:15:25.000000', 'temperatura', 388.0000, 'ºC'),
	(155498, 121, '2014-01-15 00:15:26.000000', 'temperatura', 1181.0000, 'ºC'),
	(155499, 121, '2014-01-15 00:15:27.000000', 'temperatura', 1142.0000, 'ºC'),
	(155500, 121, '2014-01-15 00:15:28.000000', 'temperatura', 969.0000, 'ºC'),
	(155501, 121, '2014-01-15 00:15:29.000000', 'temperatura', 217.0000, 'ºC'),
	(155502, 121, '2014-01-15 00:15:30.000000', 'temperatura', 580.0000, 'ºC'),
	(155503, 121, '2014-01-15 00:15:31.000000', 'temperatura', 1049.0000, 'ºC'),
	(155504, 121, '2014-01-15 00:15:32.000000', 'temperatura', 1105.0000, 'ºC'),
	(155505, 121, '2014-01-15 00:15:33.000000', 'temperatura', 1181.0000, 'ºC'),
	(155506, 121, '2014-01-15 00:15:34.000000', 'temperatura', 187.0000, 'ºC'),
	(155507, 121, '2014-01-15 00:15:35.000000', 'temperatura', 994.0000, 'ºC'),
	(155508, 121, '2014-01-15 00:15:36.000000', 'temperatura', 809.0000, 'ºC'),
	(155509, 121, '2014-01-15 00:15:37.000000', 'temperatura', 1063.0000, 'ºC'),
	(155510, 121, '2014-01-15 00:15:38.000000', 'temperatura', 488.0000, 'ºC'),
	(155511, 121, '2014-01-15 00:15:39.000000', 'temperatura', 453.0000, 'ºC'),
	(155512, 121, '2014-01-15 00:15:40.000000', 'temperatura', 800.0000, 'ºC'),
	(155513, 121, '2014-01-15 00:15:41.000000', 'temperatura', 241.0000, 'ºC'),
	(155514, 121, '2014-01-15 00:15:42.000000', 'temperatura', 8.0000, 'ºC'),
	(155515, 121, '2014-01-15 00:15:43.000000', 'temperatura', 517.0000, 'ºC'),
	(155516, 121, '2014-01-15 00:15:44.000000', 'temperatura', 159.0000, 'ºC'),
	(155517, 121, '2014-01-15 00:15:45.000000', 'temperatura', 447.0000, 'ºC'),
	(155518, 121, '2014-01-15 00:15:46.000000', 'temperatura', 558.0000, 'ºC'),
	(155519, 121, '2014-01-15 00:15:47.000000', 'temperatura', 248.0000, 'ºC'),
	(155520, 121, '2014-01-15 00:15:48.000000', 'temperatura', 768.0000, 'ºC'),
	(155521, 121, '2014-01-15 00:15:49.000000', 'temperatura', 696.0000, 'ºC'),
	(155522, 121, '2014-01-15 00:15:50.000000', 'temperatura', 1179.0000, 'ºC'),
	(155523, 121, '2014-01-15 00:15:51.000000', 'temperatura', 204.0000, 'ºC'),
	(155524, 121, '2014-01-15 00:15:52.000000', 'temperatura', 1084.0000, 'ºC'),
	(155525, 121, '2014-01-15 00:15:53.000000', 'temperatura', 9.0000, 'ºC'),
	(155526, 121, '2014-01-15 00:15:54.000000', 'temperatura', 393.0000, 'ºC'),
	(155527, 121, '2014-01-15 00:15:55.000000', 'temperatura', 737.0000, 'ºC'),
	(155528, 121, '2014-01-15 00:15:56.000000', 'temperatura', 109.0000, 'ºC'),
	(155529, 121, '2014-01-15 00:15:57.000000', 'temperatura', 734.0000, 'ºC'),
	(155530, 121, '2014-01-15 00:15:58.000000', 'temperatura', 944.0000, 'ºC'),
	(155531, 121, '2014-01-15 00:15:59.000000', 'temperatura', 116.0000, 'ºC'),
	(155532, 121, '2014-01-15 00:16:00.000000', 'temperatura', 151.0000, 'ºC'),
	(155533, 121, '2014-01-15 00:16:01.000000', 'temperatura', 406.0000, 'ºC'),
	(155534, 121, '2014-01-15 00:16:02.000000', 'temperatura', 379.0000, 'ºC'),
	(155535, 121, '2014-01-15 00:16:03.000000', 'temperatura', 679.0000, 'ºC'),
	(155536, 121, '2014-01-15 00:16:04.000000', 'temperatura', 1057.0000, 'ºC'),
	(155537, 121, '2014-01-15 00:16:05.000000', 'temperatura', 847.0000, 'ºC'),
	(155538, 121, '2014-01-15 00:16:06.000000', 'temperatura', 1065.0000, 'ºC'),
	(155539, 121, '2014-01-15 00:16:07.000000', 'temperatura', 386.0000, 'ºC'),
	(155540, 121, '2014-01-15 00:16:08.000000', 'temperatura', 1135.0000, 'ºC'),
	(155541, 121, '2014-01-15 00:16:09.000000', 'temperatura', 916.0000, 'ºC'),
	(155542, 121, '2014-01-15 00:16:10.000000', 'temperatura', 1178.0000, 'ºC'),
	(155543, 121, '2014-01-15 00:16:11.000000', 'temperatura', 740.0000, 'ºC'),
	(155544, 121, '2014-01-15 00:16:12.000000', 'temperatura', 168.0000, 'ºC'),
	(155545, 121, '2014-01-15 00:16:13.000000', 'temperatura', 1022.0000, 'ºC'),
	(155546, 121, '2014-01-15 00:16:14.000000', 'temperatura', 1005.0000, 'ºC'),
	(155547, 121, '2014-01-15 00:16:15.000000', 'temperatura', 761.0000, 'ºC'),
	(155548, 121, '2014-01-15 00:16:16.000000', 'temperatura', 788.0000, 'ºC'),
	(155549, 121, '2014-01-15 00:16:17.000000', 'temperatura', 458.0000, 'ºC'),
	(155550, 121, '2014-01-15 00:16:18.000000', 'temperatura', 1127.0000, 'ºC'),
	(155551, 121, '2014-01-15 00:16:19.000000', 'temperatura', 661.0000, 'ºC'),
	(155552, 121, '2014-01-15 00:16:20.000000', 'temperatura', 1123.0000, 'ºC'),
	(155553, 121, '2014-01-15 00:16:21.000000', 'temperatura', 33.0000, 'ºC'),
	(155554, 121, '2014-01-15 00:16:22.000000', 'temperatura', 396.0000, 'ºC'),
	(155555, 121, '2014-01-15 00:16:23.000000', 'temperatura', 682.0000, 'ºC'),
	(155556, 121, '2014-01-15 00:16:24.000000', 'temperatura', 1024.0000, 'ºC'),
	(155557, 121, '2014-01-15 00:16:25.000000', 'temperatura', 673.0000, 'ºC'),
	(155558, 121, '2014-01-15 00:16:26.000000', 'temperatura', 293.0000, 'ºC'),
	(155559, 121, '2014-01-15 00:16:27.000000', 'temperatura', 646.0000, 'ºC'),
	(155560, 121, '2014-01-15 00:16:28.000000', 'temperatura', 1150.0000, 'ºC'),
	(155561, 121, '2014-01-15 00:16:29.000000', 'temperatura', 215.0000, 'ºC'),
	(155562, 121, '2014-01-15 00:16:30.000000', 'temperatura', 26.0000, 'ºC'),
	(155563, 121, '2014-01-15 00:16:31.000000', 'temperatura', 683.0000, 'ºC'),
	(155564, 121, '2014-01-15 00:16:32.000000', 'temperatura', 938.0000, 'ºC'),
	(155565, 121, '2014-01-15 00:16:33.000000', 'temperatura', 240.0000, 'ºC'),
	(155566, 121, '2014-01-15 00:16:34.000000', 'temperatura', 788.0000, 'ºC'),
	(155567, 121, '2014-01-15 00:16:35.000000', 'temperatura', 819.0000, 'ºC'),
	(155568, 121, '2014-01-15 00:16:36.000000', 'temperatura', 533.0000, 'ºC'),
	(155569, 121, '2014-01-15 00:16:37.000000', 'temperatura', 210.0000, 'ºC'),
	(155570, 121, '2014-01-15 00:16:38.000000', 'temperatura', 651.0000, 'ºC'),
	(155571, 121, '2014-01-15 00:16:39.000000', 'temperatura', 223.0000, 'ºC'),
	(155572, 121, '2014-01-15 00:16:40.000000', 'temperatura', 365.0000, 'ºC'),
	(155573, 121, '2014-01-15 00:16:41.000000', 'temperatura', 1158.0000, 'ºC'),
	(155574, 121, '2014-01-15 00:16:42.000000', 'temperatura', 1093.0000, 'ºC'),
	(155575, 121, '2014-01-15 00:16:43.000000', 'temperatura', 791.0000, 'ºC'),
	(155576, 121, '2014-01-15 00:16:44.000000', 'temperatura', 676.0000, 'ºC'),
	(155577, 121, '2014-01-15 00:16:45.000000', 'temperatura', 1008.0000, 'ºC'),
	(155578, 121, '2014-01-15 00:16:46.000000', 'temperatura', 611.0000, 'ºC'),
	(155579, 121, '2014-01-15 00:16:47.000000', 'temperatura', 35.0000, 'ºC'),
	(155580, 121, '2014-01-15 00:16:48.000000', 'temperatura', 739.0000, 'ºC'),
	(155581, 121, '2014-01-15 00:16:49.000000', 'temperatura', 1192.0000, 'ºC'),
	(155582, 121, '2014-01-15 00:16:50.000000', 'temperatura', 144.0000, 'ºC'),
	(155583, 121, '2014-01-15 00:16:51.000000', 'temperatura', 743.0000, 'ºC'),
	(155584, 121, '2014-01-15 00:16:52.000000', 'temperatura', 885.0000, 'ºC'),
	(155585, 121, '2014-01-15 00:16:53.000000', 'temperatura', 995.0000, 'ºC'),
	(155586, 121, '2014-01-15 00:16:54.000000', 'temperatura', 1121.0000, 'ºC'),
	(155587, 121, '2014-01-15 00:16:55.000000', 'temperatura', 219.0000, 'ºC'),
	(155588, 121, '2014-01-15 00:16:56.000000', 'temperatura', 134.0000, 'ºC'),
	(155589, 121, '2014-01-15 00:16:57.000000', 'temperatura', 14.0000, 'ºC'),
	(155590, 121, '2014-01-15 00:16:58.000000', 'temperatura', 870.0000, 'ºC'),
	(155591, 121, '2014-01-15 00:16:59.000000', 'temperatura', 706.0000, 'ºC'),
	(155592, 121, '2014-01-15 00:17:00.000000', 'temperatura', 923.0000, 'ºC'),
	(155593, 121, '2014-01-15 00:17:01.000000', 'temperatura', 97.0000, 'ºC'),
	(155594, 121, '2014-01-15 00:17:02.000000', 'temperatura', 114.0000, 'ºC'),
	(155595, 121, '2014-01-15 00:17:03.000000', 'temperatura', 281.0000, 'ºC'),
	(155596, 121, '2014-01-15 00:17:04.000000', 'temperatura', 1062.0000, 'ºC'),
	(155597, 121, '2014-01-15 00:17:05.000000', 'temperatura', 868.0000, 'ºC'),
	(155598, 121, '2014-01-15 00:17:06.000000', 'temperatura', 1155.0000, 'ºC'),
	(155599, 121, '2014-01-15 00:17:07.000000', 'temperatura', 772.0000, 'ºC'),
	(155600, 121, '2014-01-15 00:17:08.000000', 'temperatura', 396.0000, 'ºC'),
	(155601, 121, '2014-01-15 00:17:09.000000', 'temperatura', 864.0000, 'ºC'),
	(155602, 121, '2014-01-15 00:17:10.000000', 'temperatura', 732.0000, 'ºC'),
	(155603, 121, '2014-01-15 00:17:11.000000', 'temperatura', 1069.0000, 'ºC'),
	(155604, 121, '2014-01-15 00:17:12.000000', 'temperatura', 748.0000, 'ºC'),
	(155605, 121, '2014-01-15 00:17:13.000000', 'temperatura', 536.0000, 'ºC'),
	(155606, 121, '2014-01-15 00:17:14.000000', 'temperatura', 436.0000, 'ºC'),
	(155607, 121, '2014-01-15 00:17:15.000000', 'temperatura', 573.0000, 'ºC'),
	(155608, 121, '2014-01-15 00:17:16.000000', 'temperatura', 356.0000, 'ºC'),
	(155609, 121, '2014-01-15 00:17:17.000000', 'temperatura', 63.0000, 'ºC'),
	(155610, 121, '2014-01-15 00:17:18.000000', 'temperatura', 447.0000, 'ºC'),
	(155611, 121, '2014-01-15 00:17:19.000000', 'temperatura', 847.0000, 'ºC'),
	(155612, 121, '2014-01-15 00:17:20.000000', 'temperatura', 492.0000, 'ºC'),
	(155613, 121, '2014-01-15 00:17:21.000000', 'temperatura', 1122.0000, 'ºC'),
	(155614, 121, '2014-01-15 00:17:22.000000', 'temperatura', 533.0000, 'ºC'),
	(155615, 121, '2014-01-15 00:17:23.000000', 'temperatura', 500.0000, 'ºC'),
	(155616, 121, '2014-01-15 00:17:24.000000', 'temperatura', 902.0000, 'ºC'),
	(155617, 121, '2014-01-15 00:17:25.000000', 'temperatura', 609.0000, 'ºC'),
	(155618, 121, '2014-01-15 00:17:26.000000', 'temperatura', 339.0000, 'ºC'),
	(155619, 121, '2014-01-15 00:17:27.000000', 'temperatura', 1071.0000, 'ºC'),
	(155620, 121, '2014-01-15 00:17:28.000000', 'temperatura', 736.0000, 'ºC'),
	(155621, 121, '2014-01-15 00:17:29.000000', 'temperatura', 468.0000, 'ºC'),
	(155622, 121, '2014-01-15 00:17:30.000000', 'temperatura', 133.0000, 'ºC'),
	(155623, 121, '2014-01-15 00:17:31.000000', 'temperatura', 461.0000, 'ºC'),
	(155624, 121, '2014-01-15 00:17:32.000000', 'temperatura', 706.0000, 'ºC'),
	(155625, 121, '2014-01-15 00:17:33.000000', 'temperatura', 949.0000, 'ºC'),
	(155626, 121, '2014-01-15 00:17:34.000000', 'temperatura', 229.0000, 'ºC'),
	(155627, 121, '2014-01-15 00:17:35.000000', 'temperatura', 697.0000, 'ºC'),
	(155628, 121, '2014-01-15 00:17:36.000000', 'temperatura', 398.0000, 'ºC'),
	(155629, 121, '2014-01-15 00:17:37.000000', 'temperatura', 1099.0000, 'ºC'),
	(155630, 121, '2014-01-15 00:17:38.000000', 'temperatura', 700.0000, 'ºC'),
	(155631, 121, '2014-01-15 00:17:39.000000', 'temperatura', 206.0000, 'ºC'),
	(155632, 121, '2014-01-15 00:17:40.000000', 'temperatura', 128.0000, 'ºC'),
	(155633, 121, '2014-01-15 00:17:41.000000', 'temperatura', 26.0000, 'ºC'),
	(155634, 121, '2014-01-15 00:17:42.000000', 'temperatura', 944.0000, 'ºC'),
	(155635, 121, '2014-01-15 00:17:43.000000', 'temperatura', 1045.0000, 'ºC'),
	(155636, 121, '2014-01-15 00:17:44.000000', 'temperatura', 1192.0000, 'ºC'),
	(155637, 121, '2014-01-15 00:17:45.000000', 'temperatura', 426.0000, 'ºC'),
	(155638, 121, '2014-01-15 00:17:46.000000', 'temperatura', 954.0000, 'ºC'),
	(155639, 121, '2014-01-15 00:17:47.000000', 'temperatura', 1094.0000, 'ºC'),
	(155640, 121, '2014-01-15 00:17:48.000000', 'temperatura', 208.0000, 'ºC'),
	(155641, 121, '2014-01-15 00:17:49.000000', 'temperatura', 157.0000, 'ºC'),
	(155642, 121, '2014-01-15 00:17:50.000000', 'temperatura', 161.0000, 'ºC'),
	(155643, 121, '2014-01-15 00:17:51.000000', 'temperatura', 334.0000, 'ºC'),
	(155644, 121, '2014-01-15 00:17:52.000000', 'temperatura', 1187.0000, 'ºC'),
	(155645, 121, '2014-01-15 00:17:53.000000', 'temperatura', 135.0000, 'ºC'),
	(155646, 121, '2014-01-15 00:17:54.000000', 'temperatura', 715.0000, 'ºC'),
	(155647, 121, '2014-01-15 00:17:55.000000', 'temperatura', 772.0000, 'ºC'),
	(155648, 121, '2014-01-15 00:17:56.000000', 'temperatura', 513.0000, 'ºC'),
	(155649, 121, '2014-01-15 00:17:57.000000', 'temperatura', 252.0000, 'ºC'),
	(155650, 121, '2014-01-15 00:17:58.000000', 'temperatura', 920.0000, 'ºC'),
	(155651, 121, '2014-01-15 00:17:59.000000', 'temperatura', 244.0000, 'ºC'),
	(155652, 121, '2014-01-15 00:18:00.000000', 'temperatura', 859.0000, 'ºC'),
	(155653, 121, '2014-01-15 00:18:01.000000', 'temperatura', 1166.0000, 'ºC'),
	(155654, 121, '2014-01-15 00:18:02.000000', 'temperatura', 854.0000, 'ºC'),
	(155655, 121, '2014-01-15 00:18:03.000000', 'temperatura', 770.0000, 'ºC'),
	(155656, 121, '2014-01-15 00:18:04.000000', 'temperatura', 91.0000, 'ºC'),
	(155657, 121, '2014-01-15 00:18:05.000000', 'temperatura', 543.0000, 'ºC'),
	(155658, 121, '2014-01-15 00:18:06.000000', 'temperatura', 42.0000, 'ºC'),
	(155659, 121, '2014-01-15 00:18:07.000000', 'temperatura', 982.0000, 'ºC'),
	(155660, 121, '2014-01-15 00:18:08.000000', 'temperatura', 1186.0000, 'ºC'),
	(155661, 121, '2014-01-15 00:18:09.000000', 'temperatura', 582.0000, 'ºC'),
	(155662, 121, '2014-01-15 00:18:10.000000', 'temperatura', 554.0000, 'ºC'),
	(155663, 121, '2014-01-15 00:18:11.000000', 'temperatura', 1026.0000, 'ºC'),
	(155664, 121, '2014-01-15 00:18:12.000000', 'temperatura', 1068.0000, 'ºC'),
	(155665, 121, '2014-01-15 00:18:13.000000', 'temperatura', 1063.0000, 'ºC'),
	(155666, 121, '2014-01-15 00:18:14.000000', 'temperatura', 910.0000, 'ºC'),
	(155667, 121, '2014-01-15 00:18:15.000000', 'temperatura', 162.0000, 'ºC'),
	(155668, 121, '2014-01-15 00:18:16.000000', 'temperatura', 482.0000, 'ºC'),
	(155669, 121, '2014-01-15 00:18:17.000000', 'temperatura', 724.0000, 'ºC'),
	(155670, 121, '2014-01-15 00:18:18.000000', 'temperatura', 976.0000, 'ºC'),
	(155671, 121, '2014-01-15 00:18:19.000000', 'temperatura', 306.0000, 'ºC'),
	(155672, 121, '2014-01-15 00:18:20.000000', 'temperatura', 1002.0000, 'ºC'),
	(155673, 121, '2014-01-15 00:18:21.000000', 'temperatura', 494.0000, 'ºC'),
	(155674, 121, '2014-01-15 00:18:22.000000', 'temperatura', 666.0000, 'ºC'),
	(155675, 121, '2014-01-15 00:18:23.000000', 'temperatura', 648.0000, 'ºC'),
	(155676, 121, '2014-01-15 00:18:24.000000', 'temperatura', 42.0000, 'ºC'),
	(155677, 121, '2014-01-15 00:18:25.000000', 'temperatura', 668.0000, 'ºC'),
	(155678, 121, '2014-01-15 00:18:26.000000', 'temperatura', 815.0000, 'ºC'),
	(155679, 121, '2014-01-15 00:18:27.000000', 'temperatura', 870.0000, 'ºC'),
	(155680, 121, '2014-01-15 00:18:28.000000', 'temperatura', 708.0000, 'ºC'),
	(155681, 121, '2014-01-15 00:18:29.000000', 'temperatura', 928.0000, 'ºC'),
	(155682, 121, '2014-01-15 00:18:30.000000', 'temperatura', 118.0000, 'ºC'),
	(155683, 121, '2014-01-15 00:18:31.000000', 'temperatura', 204.0000, 'ºC'),
	(155684, 121, '2014-01-15 00:18:32.000000', 'temperatura', 667.0000, 'ºC'),
	(155685, 121, '2014-01-15 00:18:33.000000', 'temperatura', 324.0000, 'ºC'),
	(155686, 121, '2014-01-15 00:18:34.000000', 'temperatura', 821.0000, 'ºC'),
	(155687, 121, '2014-01-15 00:18:35.000000', 'temperatura', 735.0000, 'ºC'),
	(155688, 121, '2014-01-15 00:18:36.000000', 'temperatura', 9.0000, 'ºC'),
	(155689, 121, '2014-01-15 00:18:37.000000', 'temperatura', 242.0000, 'ºC'),
	(155690, 121, '2014-01-15 00:18:38.000000', 'temperatura', 1183.0000, 'ºC'),
	(155691, 121, '2014-01-15 00:18:39.000000', 'temperatura', 388.0000, 'ºC'),
	(155692, 121, '2014-01-15 00:18:40.000000', 'temperatura', 792.0000, 'ºC'),
	(155693, 121, '2014-01-15 00:18:41.000000', 'temperatura', 399.0000, 'ºC'),
	(155694, 121, '2014-01-15 00:18:42.000000', 'temperatura', 818.0000, 'ºC'),
	(155695, 121, '2014-01-15 00:18:43.000000', 'temperatura', 494.0000, 'ºC'),
	(155696, 121, '2014-01-15 00:18:44.000000', 'temperatura', 16.0000, 'ºC'),
	(155697, 121, '2014-01-15 00:18:45.000000', 'temperatura', 997.0000, 'ºC'),
	(155698, 121, '2014-01-15 00:18:46.000000', 'temperatura', 139.0000, 'ºC'),
	(155699, 121, '2014-01-15 00:18:47.000000', 'temperatura', 106.0000, 'ºC'),
	(155700, 121, '2014-01-15 00:18:48.000000', 'temperatura', 113.0000, 'ºC'),
	(155701, 121, '2014-01-15 00:18:49.000000', 'temperatura', 249.0000, 'ºC'),
	(155702, 121, '2014-01-15 00:18:50.000000', 'temperatura', 905.0000, 'ºC'),
	(155703, 121, '2014-01-15 00:18:51.000000', 'temperatura', 178.0000, 'ºC'),
	(155704, 121, '2014-01-15 00:18:52.000000', 'temperatura', 577.0000, 'ºC'),
	(155705, 121, '2014-01-15 00:18:53.000000', 'temperatura', 1149.0000, 'ºC'),
	(155706, 121, '2014-01-15 00:18:54.000000', 'temperatura', 417.0000, 'ºC'),
	(155707, 121, '2014-01-15 00:18:55.000000', 'temperatura', 1039.0000, 'ºC'),
	(155708, 121, '2014-01-15 00:18:56.000000', 'temperatura', 344.0000, 'ºC'),
	(155709, 121, '2014-01-15 00:18:57.000000', 'temperatura', 1003.0000, 'ºC'),
	(155710, 121, '2014-01-15 00:18:58.000000', 'temperatura', 386.0000, 'ºC'),
	(155711, 121, '2014-01-15 00:18:59.000000', 'temperatura', 118.0000, 'ºC'),
	(155712, 121, '2014-01-15 00:19:00.000000', 'temperatura', 632.0000, 'ºC'),
	(155713, 121, '2014-01-15 00:19:01.000000', 'temperatura', 410.0000, 'ºC'),
	(155714, 121, '2014-01-15 00:19:02.000000', 'temperatura', 152.0000, 'ºC'),
	(155715, 121, '2014-01-15 00:19:03.000000', 'temperatura', 730.0000, 'ºC'),
	(155716, 121, '2014-01-15 00:19:04.000000', 'temperatura', 794.0000, 'ºC'),
	(155717, 121, '2014-01-15 00:19:05.000000', 'temperatura', 583.0000, 'ºC'),
	(155718, 121, '2014-01-15 00:19:06.000000', 'temperatura', 532.0000, 'ºC'),
	(155719, 121, '2014-01-15 00:19:07.000000', 'temperatura', 913.0000, 'ºC'),
	(155720, 121, '2014-01-15 00:19:08.000000', 'temperatura', 569.0000, 'ºC'),
	(155721, 121, '2014-01-15 00:19:09.000000', 'temperatura', 107.0000, 'ºC'),
	(155722, 121, '2014-01-15 00:19:10.000000', 'temperatura', 28.0000, 'ºC'),
	(155723, 121, '2014-01-15 00:19:11.000000', 'temperatura', 1019.0000, 'ºC'),
	(155724, 121, '2014-01-15 00:19:12.000000', 'temperatura', 211.0000, 'ºC'),
	(155725, 121, '2014-01-15 00:19:13.000000', 'temperatura', 398.0000, 'ºC'),
	(155726, 121, '2014-01-15 00:19:14.000000', 'temperatura', 159.0000, 'ºC'),
	(155727, 121, '2014-01-15 00:19:15.000000', 'temperatura', 803.0000, 'ºC'),
	(155728, 121, '2014-01-15 00:19:16.000000', 'temperatura', 1137.0000, 'ºC'),
	(155729, 121, '2014-01-15 00:19:17.000000', 'temperatura', 877.0000, 'ºC'),
	(155730, 121, '2014-01-15 00:19:18.000000', 'temperatura', 974.0000, 'ºC'),
	(155731, 121, '2014-01-15 00:19:19.000000', 'temperatura', 1038.0000, 'ºC'),
	(155732, 121, '2014-01-15 00:19:20.000000', 'temperatura', 1069.0000, 'ºC'),
	(155733, 121, '2014-01-15 00:19:21.000000', 'temperatura', 1034.0000, 'ºC'),
	(155734, 121, '2014-01-15 00:19:22.000000', 'temperatura', 761.0000, 'ºC'),
	(155735, 121, '2014-01-15 00:19:23.000000', 'temperatura', 704.0000, 'ºC'),
	(155736, 121, '2014-01-15 00:19:24.000000', 'temperatura', 40.0000, 'ºC'),
	(155737, 121, '2014-01-15 00:19:25.000000', 'temperatura', 485.0000, 'ºC'),
	(155738, 121, '2014-01-15 00:19:26.000000', 'temperatura', 1106.0000, 'ºC'),
	(155739, 121, '2014-01-15 00:19:27.000000', 'temperatura', 476.0000, 'ºC'),
	(155740, 121, '2014-01-15 00:19:28.000000', 'temperatura', 264.0000, 'ºC'),
	(155741, 121, '2014-01-15 00:19:29.000000', 'temperatura', 1090.0000, 'ºC'),
	(155742, 121, '2014-01-15 00:19:30.000000', 'temperatura', 1059.0000, 'ºC'),
	(155743, 121, '2014-01-15 00:19:31.000000', 'temperatura', 826.0000, 'ºC'),
	(155744, 121, '2014-01-15 00:19:32.000000', 'temperatura', 952.0000, 'ºC'),
	(155745, 121, '2014-01-15 00:19:33.000000', 'temperatura', 1084.0000, 'ºC'),
	(155746, 121, '2014-01-15 00:19:34.000000', 'temperatura', 164.0000, 'ºC'),
	(155747, 121, '2014-01-15 00:19:35.000000', 'temperatura', 1170.0000, 'ºC'),
	(155748, 121, '2014-01-15 00:19:36.000000', 'temperatura', 558.0000, 'ºC'),
	(155749, 121, '2014-01-15 00:19:37.000000', 'temperatura', 481.0000, 'ºC'),
	(155750, 121, '2014-01-15 00:19:38.000000', 'temperatura', 729.0000, 'ºC'),
	(155751, 121, '2014-01-15 00:19:39.000000', 'temperatura', 1004.0000, 'ºC'),
	(155752, 121, '2014-01-15 00:19:40.000000', 'temperatura', 434.0000, 'ºC'),
	(155753, 121, '2014-01-15 00:19:41.000000', 'temperatura', 356.0000, 'ºC'),
	(155754, 121, '2014-01-15 00:19:42.000000', 'temperatura', 481.0000, 'ºC'),
	(155755, 121, '2014-01-15 00:19:43.000000', 'temperatura', 135.0000, 'ºC'),
	(155756, 121, '2014-01-15 00:19:44.000000', 'temperatura', 435.0000, 'ºC'),
	(155757, 121, '2014-01-15 00:19:45.000000', 'temperatura', 571.0000, 'ºC'),
	(155758, 121, '2014-01-15 00:19:46.000000', 'temperatura', 348.0000, 'ºC'),
	(155759, 121, '2014-01-15 00:19:47.000000', 'temperatura', 28.0000, 'ºC'),
	(155760, 121, '2014-01-15 00:19:48.000000', 'temperatura', 296.0000, 'ºC'),
	(155761, 121, '2014-01-15 00:19:49.000000', 'temperatura', 196.0000, 'ºC'),
	(155762, 121, '2014-01-15 00:19:50.000000', 'temperatura', 95.0000, 'ºC'),
	(155763, 121, '2014-01-15 00:19:51.000000', 'temperatura', 1085.0000, 'ºC'),
	(155764, 121, '2014-01-15 00:19:52.000000', 'temperatura', 340.0000, 'ºC'),
	(155765, 121, '2014-01-15 00:19:53.000000', 'temperatura', 849.0000, 'ºC'),
	(155766, 121, '2014-01-15 00:19:54.000000', 'temperatura', 822.0000, 'ºC'),
	(155767, 121, '2014-01-15 00:19:55.000000', 'temperatura', 365.0000, 'ºC'),
	(155768, 121, '2014-01-15 00:19:56.000000', 'temperatura', 558.0000, 'ºC'),
	(155769, 121, '2014-01-15 00:19:57.000000', 'temperatura', 497.0000, 'ºC'),
	(155770, 121, '2014-01-15 00:19:58.000000', 'temperatura', 810.0000, 'ºC'),
	(155771, 121, '2014-01-15 00:19:59.000000', 'temperatura', 161.0000, 'ºC'),
	(155772, 121, '2014-01-15 00:20:00.000000', 'temperatura', 774.0000, 'ºC'),
	(155773, 121, '2014-01-15 00:20:01.000000', 'temperatura', 988.0000, 'ºC'),
	(155774, 121, '2014-01-15 00:20:02.000000', 'temperatura', 220.0000, 'ºC'),
	(155775, 121, '2014-01-15 00:20:03.000000', 'temperatura', 537.0000, 'ºC'),
	(155776, 121, '2014-01-15 00:20:04.000000', 'temperatura', 826.0000, 'ºC'),
	(155777, 121, '2014-01-15 00:20:05.000000', 'temperatura', 118.0000, 'ºC'),
	(155778, 121, '2014-01-15 00:20:06.000000', 'temperatura', 514.0000, 'ºC'),
	(155779, 121, '2014-01-15 00:20:07.000000', 'temperatura', 1018.0000, 'ºC'),
	(155780, 121, '2014-01-15 00:20:08.000000', 'temperatura', 1145.0000, 'ºC'),
	(155781, 121, '2014-01-15 00:20:09.000000', 'temperatura', 275.0000, 'ºC'),
	(155782, 121, '2014-01-15 00:20:10.000000', 'temperatura', 338.0000, 'ºC'),
	(155783, 121, '2014-01-15 00:20:11.000000', 'temperatura', 864.0000, 'ºC'),
	(155784, 121, '2014-01-15 00:20:12.000000', 'temperatura', 910.0000, 'ºC'),
	(155785, 121, '2014-01-15 00:20:13.000000', 'temperatura', 757.0000, 'ºC'),
	(155786, 121, '2014-01-15 00:20:14.000000', 'temperatura', 1057.0000, 'ºC'),
	(155787, 121, '2014-01-15 00:20:15.000000', 'temperatura', 615.0000, 'ºC'),
	(155788, 121, '2014-01-15 00:20:16.000000', 'temperatura', 1103.0000, 'ºC'),
	(155789, 121, '2014-01-15 00:20:17.000000', 'temperatura', 71.0000, 'ºC'),
	(155790, 121, '2014-01-15 00:20:18.000000', 'temperatura', 647.0000, 'ºC'),
	(155791, 121, '2014-01-15 00:20:19.000000', 'temperatura', 620.0000, 'ºC'),
	(155792, 121, '2014-01-15 00:20:20.000000', 'temperatura', 1163.0000, 'ºC'),
	(155793, 121, '2014-01-15 00:20:21.000000', 'temperatura', 352.0000, 'ºC'),
	(155794, 121, '2014-01-15 00:20:22.000000', 'temperatura', 674.0000, 'ºC'),
	(155795, 121, '2014-01-15 00:20:23.000000', 'temperatura', 1113.0000, 'ºC'),
	(155796, 121, '2014-01-15 00:20:24.000000', 'temperatura', 1142.0000, 'ºC'),
	(155797, 121, '2014-01-15 00:20:25.000000', 'temperatura', 1174.0000, 'ºC'),
	(155798, 121, '2014-01-15 00:20:26.000000', 'temperatura', 45.0000, 'ºC'),
	(155799, 121, '2014-01-15 00:20:27.000000', 'temperatura', 305.0000, 'ºC'),
	(155800, 121, '2014-01-15 00:20:28.000000', 'temperatura', 187.0000, 'ºC'),
	(155801, 121, '2014-01-15 00:20:29.000000', 'temperatura', 24.0000, 'ºC'),
	(155802, 121, '2014-01-15 00:20:30.000000', 'temperatura', 757.0000, 'ºC'),
	(155803, 121, '2014-01-15 00:20:31.000000', 'temperatura', 116.0000, 'ºC'),
	(155804, 121, '2014-01-15 00:20:32.000000', 'temperatura', 709.0000, 'ºC'),
	(155805, 121, '2014-01-15 00:20:33.000000', 'temperatura', 799.0000, 'ºC'),
	(155806, 121, '2014-01-15 00:20:34.000000', 'temperatura', 667.0000, 'ºC'),
	(155807, 121, '2014-01-15 00:20:35.000000', 'temperatura', 937.0000, 'ºC'),
	(155808, 121, '2014-01-15 00:20:36.000000', 'temperatura', 284.0000, 'ºC'),
	(155809, 121, '2014-01-15 00:20:37.000000', 'temperatura', 1009.0000, 'ºC'),
	(155810, 121, '2014-01-15 00:20:38.000000', 'temperatura', 595.0000, 'ºC'),
	(155811, 121, '2014-01-15 00:20:39.000000', 'temperatura', 1149.0000, 'ºC'),
	(155812, 121, '2014-01-15 00:20:40.000000', 'temperatura', 362.0000, 'ºC'),
	(155813, 121, '2014-01-15 00:20:41.000000', 'temperatura', 762.0000, 'ºC'),
	(155814, 121, '2014-01-15 00:20:42.000000', 'temperatura', 326.0000, 'ºC'),
	(155815, 121, '2014-01-15 00:20:43.000000', 'temperatura', 545.0000, 'ºC'),
	(155816, 121, '2014-01-15 00:20:44.000000', 'temperatura', 546.0000, 'ºC'),
	(155817, 121, '2014-01-15 00:20:45.000000', 'temperatura', 1095.0000, 'ºC'),
	(155818, 121, '2014-01-15 00:20:46.000000', 'temperatura', 239.0000, 'ºC'),
	(155819, 121, '2014-01-15 00:20:47.000000', 'temperatura', 312.0000, 'ºC'),
	(155820, 121, '2014-01-15 00:20:48.000000', 'temperatura', 841.0000, 'ºC'),
	(155821, 121, '2014-01-15 00:20:49.000000', 'temperatura', 872.0000, 'ºC'),
	(155822, 121, '2014-01-15 00:20:50.000000', 'temperatura', 637.0000, 'ºC'),
	(155823, 121, '2014-01-15 00:20:51.000000', 'temperatura', 569.0000, 'ºC'),
	(155824, 121, '2014-01-15 00:20:52.000000', 'temperatura', 937.0000, 'ºC'),
	(155825, 121, '2014-01-15 00:20:53.000000', 'temperatura', 575.0000, 'ºC'),
	(155826, 121, '2014-01-15 00:20:54.000000', 'temperatura', 65.0000, 'ºC'),
	(155827, 121, '2014-01-15 00:20:55.000000', 'temperatura', 1002.0000, 'ºC'),
	(155828, 121, '2014-01-15 00:20:56.000000', 'temperatura', 14.0000, 'ºC'),
	(155829, 121, '2014-01-15 00:20:57.000000', 'temperatura', 663.0000, 'ºC'),
	(155830, 121, '2014-01-15 00:20:58.000000', 'temperatura', 875.0000, 'ºC'),
	(155831, 121, '2014-01-15 00:20:59.000000', 'temperatura', 1188.0000, 'ºC'),
	(155832, 121, '2014-01-15 00:21:00.000000', 'temperatura', 914.0000, 'ºC'),
	(155833, 121, '2014-01-15 00:21:01.000000', 'temperatura', 1007.0000, 'ºC'),
	(155834, 121, '2014-01-15 00:21:02.000000', 'temperatura', 1094.0000, 'ºC'),
	(155835, 121, '2014-01-15 00:21:03.000000', 'temperatura', 48.0000, 'ºC'),
	(155836, 121, '2014-01-15 00:21:04.000000', 'temperatura', 561.0000, 'ºC'),
	(155837, 121, '2014-01-15 00:21:05.000000', 'temperatura', 261.0000, 'ºC'),
	(155838, 121, '2014-01-15 00:21:06.000000', 'temperatura', 821.0000, 'ºC'),
	(155839, 121, '2014-01-15 00:21:07.000000', 'temperatura', 922.0000, 'ºC'),
	(155840, 121, '2014-01-15 00:21:08.000000', 'temperatura', 948.0000, 'ºC'),
	(155841, 121, '2014-01-15 00:21:09.000000', 'temperatura', 777.0000, 'ºC'),
	(155842, 121, '2014-01-15 00:21:10.000000', 'temperatura', 1038.0000, 'ºC'),
	(155843, 121, '2014-01-15 00:21:11.000000', 'temperatura', 462.0000, 'ºC'),
	(155844, 121, '2014-01-15 00:21:12.000000', 'temperatura', 395.0000, 'ºC'),
	(155845, 121, '2014-01-15 00:21:13.000000', 'temperatura', 592.0000, 'ºC'),
	(155846, 121, '2014-01-15 00:21:14.000000', 'temperatura', 573.0000, 'ºC'),
	(155847, 121, '2014-01-15 00:21:15.000000', 'temperatura', 1092.0000, 'ºC'),
	(155848, 121, '2014-01-15 00:21:16.000000', 'temperatura', 140.0000, 'ºC'),
	(155849, 121, '2014-01-15 00:21:17.000000', 'temperatura', 1023.0000, 'ºC'),
	(155850, 121, '2014-01-15 00:21:18.000000', 'temperatura', 1095.0000, 'ºC'),
	(155851, 121, '2014-01-15 00:21:19.000000', 'temperatura', 7.0000, 'ºC'),
	(155852, 121, '2014-01-15 00:21:20.000000', 'temperatura', 350.0000, 'ºC'),
	(155853, 121, '2014-01-15 00:21:21.000000', 'temperatura', 530.0000, 'ºC'),
	(155854, 121, '2014-01-15 00:21:22.000000', 'temperatura', 400.0000, 'ºC'),
	(155855, 121, '2014-01-15 00:21:23.000000', 'temperatura', 411.0000, 'ºC'),
	(155856, 121, '2014-01-15 00:21:24.000000', 'temperatura', 856.0000, 'ºC'),
	(155857, 121, '2014-01-15 00:21:25.000000', 'temperatura', 645.0000, 'ºC'),
	(155858, 121, '2014-01-15 00:21:26.000000', 'temperatura', 659.0000, 'ºC'),
	(155859, 121, '2014-01-15 00:21:27.000000', 'temperatura', 162.0000, 'ºC'),
	(155860, 121, '2014-01-15 00:21:28.000000', 'temperatura', 33.0000, 'ºC'),
	(155861, 121, '2014-01-15 00:21:29.000000', 'temperatura', 878.0000, 'ºC'),
	(155862, 121, '2014-01-15 00:21:30.000000', 'temperatura', 692.0000, 'ºC'),
	(155863, 121, '2014-01-15 00:21:31.000000', 'temperatura', 826.0000, 'ºC'),
	(155864, 121, '2014-01-15 00:21:32.000000', 'temperatura', 854.0000, 'ºC'),
	(155865, 121, '2014-01-15 00:21:33.000000', 'temperatura', 593.0000, 'ºC'),
	(155866, 121, '2014-01-15 00:21:34.000000', 'temperatura', 406.0000, 'ºC'),
	(155867, 121, '2014-01-15 00:21:35.000000', 'temperatura', 248.0000, 'ºC'),
	(155868, 121, '2014-01-15 00:21:36.000000', 'temperatura', 25.0000, 'ºC'),
	(155869, 121, '2014-01-15 00:21:37.000000', 'temperatura', 581.0000, 'ºC'),
	(155870, 121, '2014-01-15 00:21:38.000000', 'temperatura', 430.0000, 'ºC'),
	(155871, 121, '2014-01-15 00:21:39.000000', 'temperatura', 406.0000, 'ºC'),
	(155872, 121, '2014-01-15 00:21:40.000000', 'temperatura', 742.0000, 'ºC'),
	(155873, 121, '2014-01-15 00:21:41.000000', 'temperatura', 91.0000, 'ºC'),
	(155874, 121, '2014-01-15 00:21:42.000000', 'temperatura', 632.0000, 'ºC'),
	(155875, 121, '2014-01-15 00:21:43.000000', 'temperatura', 488.0000, 'ºC'),
	(155876, 121, '2014-01-15 00:21:44.000000', 'temperatura', 544.0000, 'ºC'),
	(155877, 121, '2014-01-15 00:21:45.000000', 'temperatura', 54.0000, 'ºC'),
	(155878, 121, '2014-01-15 00:21:46.000000', 'temperatura', 1041.0000, 'ºC'),
	(155879, 121, '2014-01-15 00:21:47.000000', 'temperatura', 242.0000, 'ºC'),
	(155880, 121, '2014-01-15 00:21:48.000000', 'temperatura', 490.0000, 'ºC'),
	(155881, 121, '2014-01-15 00:21:49.000000', 'temperatura', 523.0000, 'ºC'),
	(155882, 121, '2014-01-15 00:21:50.000000', 'temperatura', 1145.0000, 'ºC'),
	(155883, 121, '2014-01-15 00:21:51.000000', 'temperatura', 556.0000, 'ºC'),
	(155884, 121, '2014-01-15 00:21:52.000000', 'temperatura', 545.0000, 'ºC'),
	(155885, 121, '2014-01-15 00:21:53.000000', 'temperatura', 1057.0000, 'ºC'),
	(155886, 121, '2014-01-15 00:21:54.000000', 'temperatura', 51.0000, 'ºC'),
	(155887, 121, '2014-01-15 00:21:55.000000', 'temperatura', 687.0000, 'ºC'),
	(155888, 121, '2014-01-15 00:21:56.000000', 'temperatura', 879.0000, 'ºC'),
	(155889, 121, '2014-01-15 00:21:57.000000', 'temperatura', 1137.0000, 'ºC'),
	(155890, 121, '2014-01-15 00:21:58.000000', 'temperatura', 646.0000, 'ºC'),
	(155891, 121, '2014-01-15 00:21:59.000000', 'temperatura', 1022.0000, 'ºC'),
	(155892, 121, '2014-01-15 00:22:00.000000', 'temperatura', 772.0000, 'ºC'),
	(155893, 121, '2014-01-15 00:22:01.000000', 'temperatura', 793.0000, 'ºC'),
	(155894, 121, '2014-01-15 00:22:02.000000', 'temperatura', 448.0000, 'ºC'),
	(155895, 121, '2014-01-15 00:22:03.000000', 'temperatura', 1065.0000, 'ºC'),
	(155896, 121, '2014-01-15 00:22:04.000000', 'temperatura', 379.0000, 'ºC'),
	(155897, 121, '2014-01-15 00:22:05.000000', 'temperatura', 1100.0000, 'ºC'),
	(155898, 121, '2014-01-15 00:22:06.000000', 'temperatura', 766.0000, 'ºC'),
	(155899, 121, '2014-01-15 00:22:07.000000', 'temperatura', 531.0000, 'ºC'),
	(155900, 121, '2014-01-15 00:22:08.000000', 'temperatura', 358.0000, 'ºC'),
	(155901, 121, '2014-01-15 00:22:09.000000', 'temperatura', 196.0000, 'ºC'),
	(155902, 121, '2014-01-15 00:22:10.000000', 'temperatura', 1108.0000, 'ºC'),
	(155903, 121, '2014-01-15 00:22:11.000000', 'temperatura', 150.0000, 'ºC'),
	(155904, 121, '2014-01-15 00:22:12.000000', 'temperatura', 1028.0000, 'ºC'),
	(155905, 121, '2014-01-15 00:22:13.000000', 'temperatura', 1092.0000, 'ºC'),
	(155906, 121, '2014-01-15 00:22:14.000000', 'temperatura', 1177.0000, 'ºC'),
	(155907, 121, '2014-01-15 00:22:15.000000', 'temperatura', 206.0000, 'ºC'),
	(155908, 121, '2014-01-15 00:22:16.000000', 'temperatura', 1103.0000, 'ºC'),
	(155909, 121, '2014-01-15 00:22:17.000000', 'temperatura', 95.0000, 'ºC'),
	(155910, 121, '2014-01-15 00:22:18.000000', 'temperatura', 768.0000, 'ºC'),
	(155911, 121, '2014-01-15 00:22:19.000000', 'temperatura', 1157.0000, 'ºC'),
	(155912, 121, '2014-01-15 00:22:20.000000', 'temperatura', 1080.0000, 'ºC'),
	(155913, 121, '2014-01-15 00:22:21.000000', 'temperatura', 728.0000, 'ºC'),
	(155914, 121, '2014-01-15 00:22:22.000000', 'temperatura', 402.0000, 'ºC'),
	(155915, 121, '2014-01-15 00:22:23.000000', 'temperatura', 1028.0000, 'ºC'),
	(155916, 121, '2014-01-15 00:22:24.000000', 'temperatura', 332.0000, 'ºC'),
	(155917, 121, '2014-01-15 00:22:25.000000', 'temperatura', 976.0000, 'ºC'),
	(155918, 121, '2014-01-15 00:22:26.000000', 'temperatura', 286.0000, 'ºC'),
	(155919, 121, '2014-01-15 00:22:27.000000', 'temperatura', 903.0000, 'ºC'),
	(155920, 121, '2014-01-15 00:22:28.000000', 'temperatura', 57.0000, 'ºC'),
	(155921, 121, '2014-01-15 00:22:29.000000', 'temperatura', 1176.0000, 'ºC'),
	(155922, 121, '2014-01-15 00:22:30.000000', 'temperatura', 911.0000, 'ºC'),
	(155923, 121, '2014-01-15 00:22:31.000000', 'temperatura', 1025.0000, 'ºC'),
	(155924, 121, '2014-01-15 00:22:32.000000', 'temperatura', 1195.0000, 'ºC'),
	(155925, 121, '2014-01-15 00:22:33.000000', 'temperatura', 498.0000, 'ºC'),
	(155926, 121, '2014-01-15 00:22:34.000000', 'temperatura', 107.0000, 'ºC'),
	(155927, 121, '2014-01-15 00:22:35.000000', 'temperatura', 241.0000, 'ºC'),
	(155928, 121, '2014-01-15 00:22:36.000000', 'temperatura', 883.0000, 'ºC'),
	(155929, 121, '2014-01-15 00:22:37.000000', 'temperatura', 94.0000, 'ºC'),
	(155930, 121, '2014-01-15 00:22:38.000000', 'temperatura', 222.0000, 'ºC'),
	(155931, 121, '2014-01-15 00:22:39.000000', 'temperatura', 827.0000, 'ºC'),
	(155932, 121, '2014-01-15 00:22:40.000000', 'temperatura', 1069.0000, 'ºC'),
	(155933, 121, '2014-01-15 00:22:41.000000', 'temperatura', 464.0000, 'ºC'),
	(155934, 121, '2014-01-15 00:22:42.000000', 'temperatura', 316.0000, 'ºC'),
	(155935, 121, '2014-01-15 00:22:43.000000', 'temperatura', 187.0000, 'ºC'),
	(155936, 121, '2014-01-15 00:22:44.000000', 'temperatura', 1187.0000, 'ºC'),
	(155937, 121, '2014-01-15 00:22:45.000000', 'temperatura', 575.0000, 'ºC'),
	(155938, 121, '2014-01-15 00:22:46.000000', 'temperatura', 514.0000, 'ºC'),
	(155939, 121, '2014-01-15 00:22:47.000000', 'temperatura', 847.0000, 'ºC'),
	(155940, 121, '2014-01-15 00:22:48.000000', 'temperatura', 292.0000, 'ºC'),
	(155941, 121, '2014-01-15 00:22:49.000000', 'temperatura', 120.0000, 'ºC'),
	(155942, 121, '2014-01-15 00:22:50.000000', 'temperatura', 924.0000, 'ºC'),
	(155943, 121, '2014-01-15 00:22:51.000000', 'temperatura', 661.0000, 'ºC'),
	(155944, 121, '2014-01-15 00:22:52.000000', 'temperatura', 535.0000, 'ºC'),
	(155945, 121, '2014-01-15 00:22:53.000000', 'temperatura', 690.0000, 'ºC'),
	(155946, 121, '2014-01-15 00:22:54.000000', 'temperatura', 646.0000, 'ºC'),
	(155947, 121, '2014-01-15 00:22:55.000000', 'temperatura', 1163.0000, 'ºC'),
	(155948, 121, '2014-01-15 00:22:56.000000', 'temperatura', 276.0000, 'ºC'),
	(155949, 121, '2014-01-15 00:22:57.000000', 'temperatura', 289.0000, 'ºC'),
	(155950, 121, '2014-01-15 00:22:58.000000', 'temperatura', 621.0000, 'ºC'),
	(155951, 121, '2014-01-15 00:22:59.000000', 'temperatura', 1038.0000, 'ºC'),
	(155952, 121, '2014-01-15 00:23:00.000000', 'temperatura', 927.0000, 'ºC'),
	(155953, 121, '2014-01-15 00:23:01.000000', 'temperatura', 320.0000, 'ºC'),
	(155954, 121, '2014-01-15 00:23:02.000000', 'temperatura', 19.0000, 'ºC'),
	(155955, 121, '2014-01-15 00:23:03.000000', 'temperatura', 336.0000, 'ºC'),
	(155956, 121, '2014-01-15 00:23:04.000000', 'temperatura', 424.0000, 'ºC'),
	(155957, 121, '2014-01-15 00:23:05.000000', 'temperatura', 1113.0000, 'ºC'),
	(155958, 121, '2014-01-15 00:23:06.000000', 'temperatura', 693.0000, 'ºC'),
	(155959, 121, '2014-01-15 00:23:07.000000', 'temperatura', 126.0000, 'ºC'),
	(155960, 121, '2014-01-15 00:23:08.000000', 'temperatura', 951.0000, 'ºC'),
	(155961, 121, '2014-01-15 00:23:09.000000', 'temperatura', 776.0000, 'ºC'),
	(155962, 121, '2014-01-15 00:23:10.000000', 'temperatura', 1030.0000, 'ºC'),
	(155963, 121, '2014-01-15 00:23:11.000000', 'temperatura', 422.0000, 'ºC'),
	(155964, 121, '2014-01-15 00:23:12.000000', 'temperatura', 219.0000, 'ºC'),
	(155965, 121, '2014-01-15 00:23:13.000000', 'temperatura', 1032.0000, 'ºC'),
	(155966, 121, '2014-01-15 00:23:14.000000', 'temperatura', 902.0000, 'ºC'),
	(155967, 121, '2014-01-15 00:23:15.000000', 'temperatura', 216.0000, 'ºC'),
	(155968, 121, '2014-01-15 00:23:16.000000', 'temperatura', 773.0000, 'ºC'),
	(155969, 121, '2014-01-15 00:23:17.000000', 'temperatura', 819.0000, 'ºC'),
	(155970, 121, '2014-01-15 00:23:18.000000', 'temperatura', 575.0000, 'ºC'),
	(155971, 121, '2014-01-15 00:23:19.000000', 'temperatura', 418.0000, 'ºC'),
	(155972, 121, '2014-01-15 00:23:20.000000', 'temperatura', 366.0000, 'ºC'),
	(155973, 121, '2014-01-15 00:23:21.000000', 'temperatura', 577.0000, 'ºC'),
	(155974, 121, '2014-01-15 00:23:22.000000', 'temperatura', 588.0000, 'ºC'),
	(155975, 121, '2014-01-15 00:23:23.000000', 'temperatura', 8.0000, 'ºC'),
	(155976, 121, '2014-01-15 00:23:24.000000', 'temperatura', 675.0000, 'ºC'),
	(155977, 121, '2014-01-15 00:23:25.000000', 'temperatura', 954.0000, 'ºC'),
	(155978, 121, '2014-01-15 00:23:26.000000', 'temperatura', 344.0000, 'ºC'),
	(155979, 121, '2014-01-15 00:23:27.000000', 'temperatura', 58.0000, 'ºC'),
	(155980, 121, '2014-01-15 00:23:28.000000', 'temperatura', 460.0000, 'ºC'),
	(155981, 121, '2014-01-15 00:23:29.000000', 'temperatura', 925.0000, 'ºC'),
	(155982, 121, '2014-01-15 00:23:30.000000', 'temperatura', 845.0000, 'ºC'),
	(155983, 121, '2014-01-15 00:23:31.000000', 'temperatura', 253.0000, 'ºC'),
	(155984, 121, '2014-01-15 00:23:32.000000', 'temperatura', 1130.0000, 'ºC'),
	(155985, 121, '2014-01-15 00:23:33.000000', 'temperatura', 90.0000, 'ºC'),
	(155986, 121, '2014-01-15 00:23:34.000000', 'temperatura', 661.0000, 'ºC'),
	(155987, 121, '2014-01-15 00:23:35.000000', 'temperatura', 634.0000, 'ºC'),
	(155988, 121, '2014-01-15 00:23:36.000000', 'temperatura', 1190.0000, 'ºC'),
	(155989, 121, '2014-01-15 00:23:37.000000', 'temperatura', 449.0000, 'ºC'),
	(155990, 121, '2014-01-15 00:23:38.000000', 'temperatura', 1077.0000, 'ºC'),
	(155991, 121, '2014-01-15 00:23:39.000000', 'temperatura', 435.0000, 'ºC'),
	(155992, 121, '2014-01-15 00:23:40.000000', 'temperatura', 147.0000, 'ºC'),
	(155993, 121, '2014-01-15 00:23:41.000000', 'temperatura', 628.0000, 'ºC'),
	(155994, 121, '2014-01-15 00:23:42.000000', 'temperatura', 300.0000, 'ºC'),
	(155995, 121, '2014-01-15 00:23:43.000000', 'temperatura', 816.0000, 'ºC'),
	(155996, 121, '2014-01-15 00:23:44.000000', 'temperatura', 781.0000, 'ºC'),
	(155997, 121, '2014-01-15 00:23:45.000000', 'temperatura', 258.0000, 'ºC'),
	(155998, 121, '2014-01-15 00:23:46.000000', 'temperatura', 147.0000, 'ºC'),
	(155999, 121, '2014-01-15 00:23:47.000000', 'temperatura', 1162.0000, 'ºC'),
	(156000, 121, '2014-01-15 00:23:48.000000', 'temperatura', 568.0000, 'ºC'),
	(156001, 121, '2014-01-15 00:23:49.000000', 'temperatura', 557.0000, 'ºC'),
	(156002, 121, '2014-01-15 00:23:50.000000', 'temperatura', 1078.0000, 'ºC'),
	(156003, 121, '2014-01-15 00:23:51.000000', 'temperatura', 123.0000, 'ºC'),
	(156004, 121, '2014-01-15 00:23:52.000000', 'temperatura', 979.0000, 'ºC'),
	(156005, 121, '2014-01-15 00:23:53.000000', 'temperatura', 926.0000, 'ºC'),
	(156006, 121, '2014-01-15 00:23:54.000000', 'temperatura', 495.0000, 'ºC'),
	(156007, 121, '2014-01-15 00:23:55.000000', 'temperatura', 897.0000, 'ºC'),
	(156008, 121, '2014-01-15 00:23:56.000000', 'temperatura', 599.0000, 'ºC'),
	(156009, 121, '2014-01-15 00:23:57.000000', 'temperatura', 304.0000, 'ºC'),
	(156010, 121, '2014-01-15 00:23:58.000000', 'temperatura', 924.0000, 'ºC'),
	(156011, 121, '2014-01-15 00:23:59.000000', 'temperatura', 108.0000, 'ºC'),
	(156012, 121, '2014-01-15 00:24:00.000000', 'temperatura', 169.0000, 'ºC'),
	(156013, 121, '2014-01-15 00:24:01.000000', 'temperatura', 522.0000, 'ºC'),
	(156014, 121, '2014-01-15 00:24:02.000000', 'temperatura', 902.0000, 'ºC'),
	(156015, 121, '2014-01-15 00:24:03.000000', 'temperatura', 547.0000, 'ºC'),
	(156016, 121, '2014-01-15 00:24:04.000000', 'temperatura', 30.0000, 'ºC'),
	(156017, 121, '2014-01-15 00:24:05.000000', 'temperatura', 909.0000, 'ºC'),
	(156018, 121, '2014-01-15 00:24:06.000000', 'temperatura', 856.0000, 'ºC'),
	(156019, 121, '2014-01-15 00:24:07.000000', 'temperatura', 354.0000, 'ºC'),
	(156020, 121, '2014-01-15 00:24:08.000000', 'temperatura', 403.0000, 'ºC'),
	(156021, 121, '2014-01-15 00:24:09.000000', 'temperatura', 952.0000, 'ºC'),
	(156022, 121, '2014-01-15 00:24:10.000000', 'temperatura', 1150.0000, 'ºC'),
	(156023, 121, '2014-01-15 00:24:11.000000', 'temperatura', 495.0000, 'ºC'),
	(156024, 121, '2014-01-15 00:24:12.000000', 'temperatura', 227.0000, 'ºC'),
	(156025, 121, '2014-01-15 00:24:13.000000', 'temperatura', 851.0000, 'ºC'),
	(156026, 121, '2014-01-15 00:24:14.000000', 'temperatura', 1173.0000, 'ºC'),
	(156027, 121, '2014-01-15 00:24:15.000000', 'temperatura', 912.0000, 'ºC'),
	(156028, 121, '2014-01-15 00:24:16.000000', 'temperatura', 1041.0000, 'ºC'),
	(156029, 121, '2014-01-15 00:24:17.000000', 'temperatura', 69.0000, 'ºC'),
	(156030, 121, '2014-01-15 00:24:18.000000', 'temperatura', 824.0000, 'ºC'),
	(156031, 121, '2014-01-15 00:24:19.000000', 'temperatura', 314.0000, 'ºC'),
	(156032, 121, '2014-01-15 00:24:20.000000', 'temperatura', 296.0000, 'ºC'),
	(156033, 121, '2014-01-15 00:24:21.000000', 'temperatura', 541.0000, 'ºC'),
	(156034, 121, '2014-01-15 00:24:22.000000', 'temperatura', 617.0000, 'ºC'),
	(156035, 121, '2014-01-15 00:24:23.000000', 'temperatura', 262.0000, 'ºC'),
	(156036, 121, '2014-01-15 00:24:24.000000', 'temperatura', 659.0000, 'ºC'),
	(156037, 121, '2014-01-15 00:24:25.000000', 'temperatura', 110.0000, 'ºC'),
	(156038, 121, '2014-01-15 00:24:26.000000', 'temperatura', 973.0000, 'ºC'),
	(156039, 121, '2014-01-15 00:24:27.000000', 'temperatura', 937.0000, 'ºC'),
	(156040, 121, '2014-01-15 00:24:28.000000', 'temperatura', 567.0000, 'ºC'),
	(156041, 121, '2014-01-15 00:24:29.000000', 'temperatura', 25.0000, 'ºC'),
	(156042, 121, '2014-01-15 00:24:30.000000', 'temperatura', 823.0000, 'ºC'),
	(156043, 121, '2014-01-15 00:24:31.000000', 'temperatura', 443.0000, 'ºC'),
	(156044, 121, '2014-01-15 00:24:32.000000', 'temperatura', 943.0000, 'ºC'),
	(156045, 121, '2014-01-15 00:24:33.000000', 'temperatura', 988.0000, 'ºC'),
	(156046, 121, '2014-01-15 00:24:34.000000', 'temperatura', 911.0000, 'ºC'),
	(156047, 121, '2014-01-15 00:24:35.000000', 'temperatura', 393.0000, 'ºC'),
	(156048, 121, '2014-01-15 00:24:36.000000', 'temperatura', 433.0000, 'ºC'),
	(156049, 121, '2014-01-15 00:24:37.000000', 'temperatura', 987.0000, 'ºC'),
	(156050, 121, '2014-01-15 00:24:38.000000', 'temperatura', 36.0000, 'ºC'),
	(156051, 121, '2014-01-15 00:24:39.000000', 'temperatura', 821.0000, 'ºC'),
	(156052, 121, '2014-01-15 00:24:40.000000', 'temperatura', 397.0000, 'ºC'),
	(156053, 121, '2014-01-15 00:24:41.000000', 'temperatura', 722.0000, 'ºC'),
	(156054, 121, '2014-01-15 00:24:42.000000', 'temperatura', 20.0000, 'ºC'),
	(156055, 121, '2014-01-15 00:24:43.000000', 'temperatura', 336.0000, 'ºC'),
	(156056, 121, '2014-01-15 00:24:44.000000', 'temperatura', 417.0000, 'ºC'),
	(156057, 121, '2014-01-15 00:24:45.000000', 'temperatura', 1080.0000, 'ºC'),
	(156058, 121, '2014-01-15 00:24:46.000000', 'temperatura', 550.0000, 'ºC'),
	(156059, 121, '2014-01-15 00:24:47.000000', 'temperatura', 709.0000, 'ºC'),
	(156060, 121, '2014-01-15 00:24:48.000000', 'temperatura', 696.0000, 'ºC'),
	(156061, 121, '2014-01-15 00:24:49.000000', 'temperatura', 154.0000, 'ºC'),
	(156062, 121, '2014-01-15 00:24:50.000000', 'temperatura', 1081.0000, 'ºC'),
	(156063, 121, '2014-01-15 00:24:51.000000', 'temperatura', 144.0000, 'ºC'),
	(156064, 121, '2014-01-15 00:24:52.000000', 'temperatura', 1076.0000, 'ºC'),
	(156065, 121, '2014-01-15 00:24:53.000000', 'temperatura', 149.0000, 'ºC'),
	(156066, 121, '2014-01-15 00:24:54.000000', 'temperatura', 1118.0000, 'ºC'),
	(156067, 121, '2014-01-15 00:24:55.000000', 'temperatura', 345.0000, 'ºC'),
	(156068, 121, '2014-01-15 00:24:56.000000', 'temperatura', 772.0000, 'ºC'),
	(156069, 121, '2014-01-15 00:24:57.000000', 'temperatura', 426.0000, 'ºC'),
	(156070, 121, '2014-01-15 00:24:58.000000', 'temperatura', 1016.0000, 'ºC'),
	(156071, 121, '2014-01-15 00:24:59.000000', 'temperatura', 199.0000, 'ºC'),
	(156072, 121, '2014-01-15 00:25:00.000000', 'temperatura', 347.0000, 'ºC'),
	(156073, 121, '2014-01-15 00:25:01.000000', 'temperatura', 1140.0000, 'ºC'),
	(156074, 121, '2014-01-15 00:25:02.000000', 'temperatura', 1060.0000, 'ºC'),
	(156075, 121, '2014-01-15 00:25:03.000000', 'temperatura', 680.0000, 'ºC'),
	(156076, 121, '2014-01-15 00:25:04.000000', 'temperatura', 222.0000, 'ºC'),
	(156077, 121, '2014-01-15 00:25:05.000000', 'temperatura', 271.0000, 'ºC'),
	(156078, 121, '2014-01-15 00:25:06.000000', 'temperatura', 688.0000, 'ºC'),
	(156079, 121, '2014-01-15 00:25:07.000000', 'temperatura', 229.0000, 'ºC'),
	(156080, 121, '2014-01-15 00:25:08.000000', 'temperatura', 280.0000, 'ºC'),
	(156081, 121, '2014-01-15 00:25:09.000000', 'temperatura', 714.0000, 'ºC'),
	(156082, 121, '2014-01-15 00:25:10.000000', 'temperatura', 330.0000, 'ºC'),
	(156083, 121, '2014-01-15 00:25:11.000000', 'temperatura', 710.0000, 'ºC'),
	(156084, 121, '2014-01-15 00:25:12.000000', 'temperatura', 161.0000, 'ºC'),
	(156085, 121, '2014-01-15 00:25:13.000000', 'temperatura', 1074.0000, 'ºC'),
	(156086, 121, '2014-01-15 00:25:14.000000', 'temperatura', 87.0000, 'ºC'),
	(156087, 121, '2014-01-15 00:25:15.000000', 'temperatura', 814.0000, 'ºC'),
	(156088, 121, '2014-01-15 00:25:16.000000', 'temperatura', 210.0000, 'ºC'),
	(156089, 121, '2014-01-15 00:25:17.000000', 'temperatura', 1008.0000, 'ºC'),
	(156090, 121, '2014-01-15 00:25:18.000000', 'temperatura', 810.0000, 'ºC'),
	(156091, 121, '2014-01-15 00:25:19.000000', 'temperatura', 1026.0000, 'ºC'),
	(156092, 121, '2014-01-15 00:25:20.000000', 'temperatura', 302.0000, 'ºC'),
	(156093, 121, '2014-01-15 00:25:21.000000', 'temperatura', 832.0000, 'ºC'),
	(156094, 121, '2014-01-15 00:25:22.000000', 'temperatura', 855.0000, 'ºC'),
	(156095, 121, '2014-01-15 00:25:23.000000', 'temperatura', 579.0000, 'ºC'),
	(156096, 121, '2014-01-15 00:25:24.000000', 'temperatura', 331.0000, 'ºC'),
	(156097, 121, '2014-01-15 00:25:25.000000', 'temperatura', 1118.0000, 'ºC'),
	(156098, 121, '2014-01-15 00:25:26.000000', 'temperatura', 998.0000, 'ºC'),
	(156099, 121, '2014-01-15 00:25:27.000000', 'temperatura', 435.0000, 'ºC'),
	(156100, 121, '2014-01-15 00:25:28.000000', 'temperatura', 381.0000, 'ºC'),
	(156101, 121, '2014-01-15 00:25:29.000000', 'temperatura', 603.0000, 'ºC'),
	(156102, 121, '2014-01-15 00:25:30.000000', 'temperatura', 673.0000, 'ºC'),
	(156103, 121, '2014-01-15 00:25:31.000000', 'temperatura', 355.0000, 'ºC'),
	(156104, 121, '2014-01-15 00:25:32.000000', 'temperatura', 955.0000, 'ºC'),
	(156105, 121, '2014-01-15 00:25:33.000000', 'temperatura', 113.0000, 'ºC'),
	(156106, 121, '2014-01-15 00:25:34.000000', 'temperatura', 102.0000, 'ºC'),
	(156107, 121, '2014-01-15 00:25:35.000000', 'temperatura', 169.0000, 'ºC'),
	(156108, 121, '2014-01-15 00:25:36.000000', 'temperatura', 538.0000, 'ºC'),
	(156109, 121, '2014-01-15 00:25:37.000000', 'temperatura', 987.0000, 'ºC'),
	(156110, 121, '2014-01-15 00:25:38.000000', 'temperatura', 920.0000, 'ºC'),
	(156111, 121, '2014-01-15 00:25:39.000000', 'temperatura', 439.0000, 'ºC'),
	(156112, 121, '2014-01-15 00:25:40.000000', 'temperatura', 635.0000, 'ºC'),
	(156113, 121, '2014-01-15 00:25:41.000000', 'temperatura', 660.0000, 'ºC'),
	(156114, 121, '2014-01-15 00:25:42.000000', 'temperatura', 193.0000, 'ºC'),
	(156115, 121, '2014-01-15 00:25:43.000000', 'temperatura', 188.0000, 'ºC'),
	(156116, 121, '2014-01-15 00:25:44.000000', 'temperatura', 362.0000, 'ºC'),
	(156117, 121, '2014-01-15 00:25:45.000000', 'temperatura', 47.0000, 'ºC'),
	(156118, 121, '2014-01-15 00:25:46.000000', 'temperatura', 348.0000, 'ºC'),
	(156119, 121, '2014-01-15 00:25:47.000000', 'temperatura', 401.0000, 'ºC'),
	(156120, 121, '2014-01-15 00:25:48.000000', 'temperatura', 959.0000, 'ºC'),
	(156121, 121, '2014-01-15 00:25:49.000000', 'temperatura', 1193.0000, 'ºC'),
	(156122, 121, '2014-01-15 00:25:50.000000', 'temperatura', 691.0000, 'ºC'),
	(156123, 121, '2014-01-15 00:25:51.000000', 'temperatura', 1075.0000, 'ºC'),
	(156124, 121, '2014-01-15 00:25:52.000000', 'temperatura', 901.0000, 'ºC'),
	(156125, 121, '2014-01-15 00:25:53.000000', 'temperatura', 80.0000, 'ºC'),
	(156126, 121, '2014-01-15 00:25:54.000000', 'temperatura', 100.0000, 'ºC'),
	(156127, 121, '2014-01-15 00:25:55.000000', 'temperatura', 259.0000, 'ºC'),
	(156128, 121, '2014-01-15 00:25:56.000000', 'temperatura', 996.0000, 'ºC'),
	(156129, 121, '2014-01-15 00:25:57.000000', 'temperatura', 603.0000, 'ºC'),
	(156130, 121, '2014-01-15 00:25:58.000000', 'temperatura', 28.0000, 'ºC'),
	(156131, 121, '2014-01-15 00:25:59.000000', 'temperatura', 730.0000, 'ºC'),
	(156132, 121, '2014-01-15 00:26:00.000000', 'temperatura', 1167.0000, 'ºC'),
	(156133, 121, '2014-01-15 00:26:01.000000', 'temperatura', 45.0000, 'ºC'),
	(156134, 121, '2014-01-15 00:26:02.000000', 'temperatura', 324.0000, 'ºC'),
	(156135, 121, '2014-01-15 00:26:03.000000', 'temperatura', 285.0000, 'ºC'),
	(156136, 121, '2014-01-15 00:26:04.000000', 'temperatura', 454.0000, 'ºC'),
	(156137, 121, '2014-01-15 00:26:05.000000', 'temperatura', 215.0000, 'ºC'),
	(156138, 121, '2014-01-15 00:26:06.000000', 'temperatura', 915.0000, 'ºC'),
	(156139, 121, '2014-01-15 00:26:07.000000', 'temperatura', 329.0000, 'ºC'),
	(156140, 121, '2014-01-15 00:26:08.000000', 'temperatura', 102.0000, 'ºC'),
	(156141, 121, '2014-01-15 00:26:09.000000', 'temperatura', 721.0000, 'ºC'),
	(156142, 121, '2014-01-15 00:26:10.000000', 'temperatura', 901.0000, 'ºC'),
	(156143, 121, '2014-01-15 00:26:11.000000', 'temperatura', 1141.0000, 'ºC'),
	(156144, 121, '2014-01-15 00:26:12.000000', 'temperatura', 602.0000, 'ºC'),
	(156145, 121, '2014-01-15 00:26:13.000000', 'temperatura', 790.0000, 'ºC'),
	(156146, 121, '2014-01-15 00:26:14.000000', 'temperatura', 941.0000, 'ºC'),
	(156147, 121, '2014-01-15 00:26:15.000000', 'temperatura', 1139.0000, 'ºC'),
	(156148, 121, '2014-01-15 00:26:16.000000', 'temperatura', 472.0000, 'ºC'),
	(156149, 121, '2014-01-15 00:26:17.000000', 'temperatura', 143.0000, 'ºC'),
	(156150, 121, '2014-01-15 00:26:18.000000', 'temperatura', 499.0000, 'ºC'),
	(156151, 121, '2014-01-15 00:26:19.000000', 'temperatura', 866.0000, 'ºC'),
	(156152, 121, '2014-01-15 00:26:20.000000', 'temperatura', 434.0000, 'ºC'),
	(156153, 121, '2014-01-15 00:26:21.000000', 'temperatura', 773.0000, 'ºC'),
	(156154, 121, '2014-01-15 00:26:22.000000', 'temperatura', 162.0000, 'ºC'),
	(156155, 121, '2014-01-15 00:26:23.000000', 'temperatura', 891.0000, 'ºC'),
	(156156, 121, '2014-01-15 00:26:24.000000', 'temperatura', 371.0000, 'ºC'),
	(156157, 121, '2014-01-15 00:26:25.000000', 'temperatura', 380.0000, 'ºC'),
	(156158, 121, '2014-01-15 00:26:26.000000', 'temperatura', 789.0000, 'ºC'),
	(156159, 121, '2014-01-15 00:26:27.000000', 'temperatura', 407.0000, 'ºC'),
	(156160, 121, '2014-01-15 00:26:28.000000', 'temperatura', 869.0000, 'ºC'),
	(156161, 121, '2014-01-15 00:26:29.000000', 'temperatura', 725.0000, 'ºC'),
	(156162, 121, '2014-01-15 00:26:30.000000', 'temperatura', 1017.0000, 'ºC'),
	(156163, 121, '2014-01-15 00:26:31.000000', 'temperatura', 512.0000, 'ºC'),
	(156164, 121, '2014-01-15 00:26:32.000000', 'temperatura', 711.0000, 'ºC'),
	(156165, 121, '2014-01-15 00:26:33.000000', 'temperatura', 816.0000, 'ºC'),
	(156166, 121, '2014-01-15 00:26:34.000000', 'temperatura', 750.0000, 'ºC'),
	(156167, 121, '2014-01-15 00:26:35.000000', 'temperatura', 101.0000, 'ºC'),
	(156168, 121, '2014-01-15 00:26:36.000000', 'temperatura', 657.0000, 'ºC'),
	(156169, 121, '2014-01-15 00:26:37.000000', 'temperatura', 583.0000, 'ºC'),
	(156170, 121, '2014-01-15 00:26:38.000000', 'temperatura', 945.0000, 'ºC'),
	(156171, 121, '2014-01-15 00:26:39.000000', 'temperatura', 575.0000, 'ºC'),
	(156172, 121, '2014-01-15 00:26:40.000000', 'temperatura', 41.0000, 'ºC'),
	(156173, 121, '2014-01-15 00:26:41.000000', 'temperatura', 879.0000, 'ºC'),
	(156174, 121, '2014-01-15 00:26:42.000000', 'temperatura', 674.0000, 'ºC'),
	(156175, 121, '2014-01-15 00:26:43.000000', 'temperatura', 735.0000, 'ºC'),
	(156176, 121, '2014-01-15 00:26:44.000000', 'temperatura', 453.0000, 'ºC'),
	(156177, 121, '2014-01-15 00:26:45.000000', 'temperatura', 62.0000, 'ºC'),
	(156178, 121, '2014-01-15 00:26:46.000000', 'temperatura', 148.0000, 'ºC'),
	(156179, 121, '2014-01-15 00:26:47.000000', 'temperatura', 556.0000, 'ºC'),
	(156180, 121, '2014-01-15 00:26:48.000000', 'temperatura', 1136.0000, 'ºC'),
	(156181, 121, '2014-01-15 00:26:49.000000', 'temperatura', 413.0000, 'ºC'),
	(156182, 121, '2014-01-15 00:26:50.000000', 'temperatura', 1059.0000, 'ºC'),
	(156183, 121, '2014-01-15 00:26:51.000000', 'temperatura', 455.0000, 'ºC'),
	(156184, 121, '2014-01-15 00:26:52.000000', 'temperatura', 301.0000, 'ºC'),
	(156185, 121, '2014-01-15 00:26:53.000000', 'temperatura', 138.0000, 'ºC'),
	(156186, 121, '2014-01-15 00:26:54.000000', 'temperatura', 990.0000, 'ºC'),
	(156187, 121, '2014-01-15 00:26:55.000000', 'temperatura', 936.0000, 'ºC'),
	(156188, 121, '2014-01-15 00:26:56.000000', 'temperatura', 510.0000, 'ºC'),
	(156189, 121, '2014-01-15 00:26:57.000000', 'temperatura', 944.0000, 'ºC'),
	(156190, 121, '2014-01-15 00:26:58.000000', 'temperatura', 789.0000, 'ºC'),
	(156191, 121, '2014-01-15 00:26:59.000000', 'temperatura', 1115.0000, 'ºC'),
	(156192, 121, '2014-01-15 00:27:00.000000', 'temperatura', 807.0000, 'ºC'),
	(156193, 121, '2014-01-15 00:27:01.000000', 'temperatura', 691.0000, 'ºC'),
	(156194, 121, '2014-01-15 00:27:02.000000', 'temperatura', 1036.0000, 'ºC'),
	(156195, 121, '2014-01-15 00:27:03.000000', 'temperatura', 709.0000, 'ºC'),
	(156196, 121, '2014-01-15 00:27:04.000000', 'temperatura', 434.0000, 'ºC'),
	(156197, 121, '2014-01-15 00:27:05.000000', 'temperatura', 44.0000, 'ºC'),
	(156198, 121, '2014-01-15 00:27:06.000000', 'temperatura', 118.0000, 'ºC'),
	(156199, 121, '2014-01-15 00:27:07.000000', 'temperatura', 460.0000, 'ºC'),
	(156200, 121, '2014-01-15 00:27:08.000000', 'temperatura', 746.0000, 'ºC'),
	(156201, 121, '2014-01-15 00:27:09.000000', 'temperatura', 1150.0000, 'ºC'),
	(156202, 121, '2014-01-15 00:27:10.000000', 'temperatura', 1115.0000, 'ºC'),
	(156203, 121, '2014-01-15 00:27:11.000000', 'temperatura', 922.0000, 'ºC'),
	(156204, 121, '2014-01-15 00:27:12.000000', 'temperatura', 67.0000, 'ºC'),
	(156205, 121, '2014-01-15 00:27:13.000000', 'temperatura', 1169.0000, 'ºC'),
	(156206, 121, '2014-01-15 00:27:14.000000', 'temperatura', 845.0000, 'ºC'),
	(156207, 121, '2014-01-15 00:27:15.000000', 'temperatura', 717.0000, 'ºC'),
	(156208, 121, '2014-01-15 00:27:16.000000', 'temperatura', 1051.0000, 'ºC'),
	(156209, 121, '2014-01-15 00:27:17.000000', 'temperatura', 706.0000, 'ºC'),
	(156210, 121, '2014-01-15 00:27:18.000000', 'temperatura', 377.0000, 'ºC'),
	(156211, 121, '2014-01-15 00:27:19.000000', 'temperatura', 966.0000, 'ºC'),
	(156212, 121, '2014-01-15 00:27:20.000000', 'temperatura', 101.0000, 'ºC'),
	(156213, 121, '2014-01-15 00:27:21.000000', 'temperatura', 8.0000, 'ºC'),
	(156214, 121, '2014-01-15 00:27:22.000000', 'temperatura', 936.0000, 'ºC'),
	(156215, 121, '2014-01-15 00:27:23.000000', 'temperatura', 1058.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(156216, 121, '2014-01-15 00:27:24.000000', 'temperatura', 82.0000, 'ºC'),
	(156217, 121, '2014-01-15 00:27:25.000000', 'temperatura', 836.0000, 'ºC'),
	(156218, 121, '2014-01-15 00:27:26.000000', 'temperatura', 333.0000, 'ºC'),
	(156219, 121, '2014-01-15 00:27:27.000000', 'temperatura', 360.0000, 'ºC'),
	(156220, 121, '2014-01-15 00:27:28.000000', 'temperatura', 801.0000, 'ºC'),
	(156221, 121, '2014-01-15 00:27:29.000000', 'temperatura', 527.0000, 'ºC'),
	(156222, 121, '2014-01-15 00:27:30.000000', 'temperatura', 231.0000, 'ºC'),
	(156223, 121, '2014-01-15 00:27:31.000000', 'temperatura', 777.0000, 'ºC'),
	(156224, 121, '2014-01-15 00:27:32.000000', 'temperatura', 789.0000, 'ºC'),
	(156225, 121, '2014-01-15 00:27:33.000000', 'temperatura', 417.0000, 'ºC'),
	(156226, 121, '2014-01-15 00:27:34.000000', 'temperatura', 916.0000, 'ºC'),
	(156227, 121, '2014-01-15 00:27:35.000000', 'temperatura', 933.0000, 'ºC'),
	(156228, 121, '2014-01-15 00:27:36.000000', 'temperatura', 715.0000, 'ºC'),
	(156229, 121, '2014-01-15 00:27:37.000000', 'temperatura', 777.0000, 'ºC'),
	(156230, 121, '2014-01-15 00:27:38.000000', 'temperatura', 540.0000, 'ºC'),
	(156231, 121, '2014-01-15 00:27:39.000000', 'temperatura', 371.0000, 'ºC'),
	(156232, 121, '2014-01-15 00:27:40.000000', 'temperatura', 237.0000, 'ºC'),
	(156233, 121, '2014-01-15 00:27:41.000000', 'temperatura', 70.0000, 'ºC'),
	(156234, 121, '2014-01-15 00:27:42.000000', 'temperatura', 841.0000, 'ºC'),
	(156235, 121, '2014-01-15 00:27:43.000000', 'temperatura', 397.0000, 'ºC'),
	(156236, 121, '2014-01-15 00:27:44.000000', 'temperatura', 661.0000, 'ºC'),
	(156237, 121, '2014-01-15 00:27:45.000000', 'temperatura', 914.0000, 'ºC'),
	(156238, 121, '2014-01-15 00:27:46.000000', 'temperatura', 189.0000, 'ºC'),
	(156239, 121, '2014-01-15 00:27:47.000000', 'temperatura', 601.0000, 'ºC'),
	(156240, 121, '2014-01-15 00:27:48.000000', 'temperatura', 41.0000, 'ºC'),
	(156241, 121, '2014-01-15 00:27:49.000000', 'temperatura', 803.0000, 'ºC'),
	(156242, 121, '2014-01-15 00:27:50.000000', 'temperatura', 291.0000, 'ºC'),
	(156243, 121, '2014-01-15 00:27:51.000000', 'temperatura', 247.0000, 'ºC'),
	(156244, 121, '2014-01-15 00:27:52.000000', 'temperatura', 363.0000, 'ºC'),
	(156245, 121, '2014-01-15 00:27:53.000000', 'temperatura', 1074.0000, 'ºC'),
	(156246, 121, '2014-01-15 00:27:54.000000', 'temperatura', 681.0000, 'ºC'),
	(156247, 121, '2014-01-15 00:27:55.000000', 'temperatura', 185.0000, 'ºC'),
	(156248, 121, '2014-01-15 00:27:56.000000', 'temperatura', 81.0000, 'ºC'),
	(156249, 121, '2014-01-15 00:27:57.000000', 'temperatura', 1049.0000, 'ºC'),
	(156250, 121, '2014-01-15 00:27:58.000000', 'temperatura', 204.0000, 'ºC'),
	(156251, 121, '2014-01-15 00:27:59.000000', 'temperatura', 274.0000, 'ºC'),
	(156252, 121, '2014-01-15 00:28:00.000000', 'temperatura', 757.0000, 'ºC'),
	(156253, 121, '2014-01-15 00:28:01.000000', 'temperatura', 565.0000, 'ºC'),
	(156254, 121, '2014-01-15 00:28:02.000000', 'temperatura', 555.0000, 'ºC'),
	(156255, 121, '2014-01-15 00:28:03.000000', 'temperatura', 1081.0000, 'ºC'),
	(156256, 121, '2014-01-15 00:28:04.000000', 'temperatura', 141.0000, 'ºC'),
	(156257, 121, '2014-01-15 00:28:05.000000', 'temperatura', 1061.0000, 'ºC'),
	(156258, 121, '2014-01-15 00:28:06.000000', 'temperatura', 84.0000, 'ºC'),
	(156259, 121, '2014-01-15 00:28:07.000000', 'temperatura', 837.0000, 'ºC'),
	(156260, 121, '2014-01-15 00:28:08.000000', 'temperatura', 331.0000, 'ºC'),
	(156261, 121, '2014-01-15 00:28:09.000000', 'temperatura', 348.0000, 'ºC'),
	(156262, 121, '2014-01-15 00:28:10.000000', 'temperatura', 747.0000, 'ºC'),
	(156263, 121, '2014-01-15 00:28:11.000000', 'temperatura', 289.0000, 'ºC'),
	(156264, 121, '2014-01-15 00:28:12.000000', 'temperatura', 408.0000, 'ºC'),
	(156265, 121, '2014-01-15 00:28:13.000000', 'temperatura', 1171.0000, 'ºC'),
	(156266, 121, '2014-01-15 00:28:14.000000', 'temperatura', 1033.0000, 'ºC'),
	(156267, 121, '2014-01-15 00:28:15.000000', 'temperatura', 451.0000, 'ºC'),
	(156268, 121, '2014-01-15 00:28:16.000000', 'temperatura', 356.0000, 'ºC'),
	(156269, 121, '2014-01-15 00:28:17.000000', 'temperatura', 426.0000, 'ºC'),
	(156270, 121, '2014-01-15 00:28:18.000000', 'temperatura', 1066.0000, 'ºC'),
	(156271, 121, '2014-01-15 00:28:19.000000', 'temperatura', 450.0000, 'ºC'),
	(156272, 121, '2014-01-15 00:28:20.000000', 'temperatura', 254.0000, 'ºC'),
	(156273, 121, '2014-01-15 00:28:21.000000', 'temperatura', 1119.0000, 'ºC'),
	(156274, 121, '2014-01-15 00:28:22.000000', 'temperatura', 35.0000, 'ºC'),
	(156275, 121, '2014-01-15 00:28:23.000000', 'temperatura', 416.0000, 'ºC'),
	(156276, 121, '2014-01-15 00:28:24.000000', 'temperatura', 778.0000, 'ºC'),
	(156277, 121, '2014-01-15 00:28:25.000000', 'temperatura', 243.0000, 'ºC'),
	(156278, 121, '2014-01-15 00:28:26.000000', 'temperatura', 81.0000, 'ºC'),
	(156279, 121, '2014-01-15 00:28:27.000000', 'temperatura', 875.0000, 'ºC'),
	(156280, 121, '2014-01-15 00:28:28.000000', 'temperatura', 535.0000, 'ºC'),
	(156281, 121, '2014-01-15 00:28:29.000000', 'temperatura', 50.0000, 'ºC'),
	(156282, 121, '2014-01-15 00:28:30.000000', 'temperatura', 1047.0000, 'ºC'),
	(156283, 121, '2014-01-15 00:28:31.000000', 'temperatura', 285.0000, 'ºC'),
	(156284, 121, '2014-01-15 00:28:32.000000', 'temperatura', 682.0000, 'ºC'),
	(156285, 121, '2014-01-15 00:28:33.000000', 'temperatura', 157.0000, 'ºC'),
	(156286, 121, '2014-01-15 00:28:34.000000', 'temperatura', 1138.0000, 'ºC'),
	(156287, 121, '2014-01-15 00:28:35.000000', 'temperatura', 422.0000, 'ºC'),
	(156288, 121, '2014-01-15 00:28:36.000000', 'temperatura', 1097.0000, 'ºC'),
	(156289, 121, '2014-01-15 00:28:37.000000', 'temperatura', 620.0000, 'ºC'),
	(156290, 121, '2014-01-15 00:28:38.000000', 'temperatura', 1009.0000, 'ºC'),
	(156291, 121, '2014-01-15 00:28:39.000000', 'temperatura', 783.0000, 'ºC'),
	(156292, 121, '2014-01-15 00:28:40.000000', 'temperatura', 891.0000, 'ºC'),
	(156293, 121, '2014-01-15 00:28:41.000000', 'temperatura', 906.0000, 'ºC'),
	(156294, 121, '2014-01-15 00:28:42.000000', 'temperatura', 659.0000, 'ºC'),
	(156295, 121, '2014-01-15 00:28:43.000000', 'temperatura', 575.0000, 'ºC'),
	(156296, 121, '2014-01-15 00:28:44.000000', 'temperatura', 898.0000, 'ºC'),
	(156297, 121, '2014-01-15 00:28:45.000000', 'temperatura', 366.0000, 'ºC'),
	(156298, 121, '2014-01-15 00:28:46.000000', 'temperatura', 338.0000, 'ºC'),
	(156299, 121, '2014-01-15 00:28:47.000000', 'temperatura', 590.0000, 'ºC'),
	(156300, 121, '2014-01-15 00:28:48.000000', 'temperatura', 740.0000, 'ºC'),
	(156301, 121, '2014-01-15 00:28:49.000000', 'temperatura', 727.0000, 'ºC'),
	(156302, 121, '2014-01-15 00:28:50.000000', 'temperatura', 217.0000, 'ºC'),
	(156303, 121, '2014-01-15 00:28:51.000000', 'temperatura', 102.0000, 'ºC'),
	(156304, 121, '2014-01-15 00:28:52.000000', 'temperatura', 1062.0000, 'ºC'),
	(156305, 121, '2014-01-15 00:28:53.000000', 'temperatura', 204.0000, 'ºC'),
	(156306, 121, '2014-01-15 00:28:54.000000', 'temperatura', 236.0000, 'ºC'),
	(156307, 121, '2014-01-15 00:28:55.000000', 'temperatura', 569.0000, 'ºC'),
	(156308, 121, '2014-01-15 00:28:56.000000', 'temperatura', 936.0000, 'ºC'),
	(156309, 121, '2014-01-15 00:28:57.000000', 'temperatura', 574.0000, 'ºC'),
	(156310, 121, '2014-01-15 00:28:58.000000', 'temperatura', 60.0000, 'ºC'),
	(156311, 121, '2014-01-15 00:28:59.000000', 'temperatura', 982.0000, 'ºC'),
	(156312, 121, '2014-01-15 00:29:00.000000', 'temperatura', 1130.0000, 'ºC'),
	(156313, 121, '2014-01-15 00:29:01.000000', 'temperatura', 305.0000, 'ºC'),
	(156314, 121, '2014-01-15 00:29:02.000000', 'temperatura', 535.0000, 'ºC'),
	(156315, 121, '2014-01-15 00:29:03.000000', 'temperatura', 562.0000, 'ºC'),
	(156316, 121, '2014-01-15 00:29:04.000000', 'temperatura', 3.0000, 'ºC'),
	(156317, 121, '2014-01-15 00:29:05.000000', 'temperatura', 732.0000, 'ºC'),
	(156318, 121, '2014-01-15 00:29:06.000000', 'temperatura', 49.0000, 'ºC'),
	(156319, 121, '2014-01-15 00:29:07.000000', 'temperatura', 448.0000, 'ºC'),
	(156320, 121, '2014-01-15 00:29:08.000000', 'temperatura', 897.0000, 'ºC'),
	(156321, 121, '2014-01-15 00:29:09.000000', 'temperatura', 742.0000, 'ºC'),
	(156322, 121, '2014-01-15 00:29:10.000000', 'temperatura', 1017.0000, 'ºC'),
	(156323, 121, '2014-01-15 00:29:11.000000', 'temperatura', 462.0000, 'ºC'),
	(156324, 121, '2014-01-15 00:29:12.000000', 'temperatura', 457.0000, 'ºC'),
	(156325, 121, '2014-01-15 00:29:13.000000', 'temperatura', 900.0000, 'ºC'),
	(156326, 121, '2014-01-15 00:29:14.000000', 'temperatura', 728.0000, 'ºC'),
	(156327, 121, '2014-01-15 00:29:15.000000', 'temperatura', 944.0000, 'ºC'),
	(156328, 121, '2014-01-15 00:29:16.000000', 'temperatura', 133.0000, 'ºC'),
	(156329, 121, '2014-01-15 00:29:17.000000', 'temperatura', 235.0000, 'ºC'),
	(156330, 121, '2014-01-15 00:29:18.000000', 'temperatura', 777.0000, 'ºC'),
	(156331, 121, '2014-01-15 00:29:19.000000', 'temperatura', 782.0000, 'ºC'),
	(156332, 121, '2014-01-15 00:29:20.000000', 'temperatura', 376.0000, 'ºC'),
	(156333, 121, '2014-01-15 00:29:21.000000', 'temperatura', 738.0000, 'ºC'),
	(156334, 121, '2014-01-15 00:29:22.000000', 'temperatura', 162.0000, 'ºC'),
	(156335, 121, '2014-01-15 00:29:23.000000', 'temperatura', 995.0000, 'ºC'),
	(156336, 121, '2014-01-15 00:29:24.000000', 'temperatura', 889.0000, 'ºC'),
	(156337, 121, '2014-01-15 00:29:25.000000', 'temperatura', 262.0000, 'ºC'),
	(156338, 121, '2014-01-15 00:29:26.000000', 'temperatura', 1044.0000, 'ºC'),
	(156339, 121, '2014-01-15 00:29:27.000000', 'temperatura', 835.0000, 'ºC'),
	(156340, 121, '2014-01-15 00:29:28.000000', 'temperatura', 1042.0000, 'ºC'),
	(156341, 121, '2014-01-15 00:29:29.000000', 'temperatura', 306.0000, 'ºC'),
	(156342, 121, '2014-01-15 00:29:30.000000', 'temperatura', 805.0000, 'ºC'),
	(156343, 121, '2014-01-15 00:29:31.000000', 'temperatura', 708.0000, 'ºC'),
	(156344, 121, '2014-01-15 00:29:32.000000', 'temperatura', 1124.0000, 'ºC'),
	(156345, 121, '2014-01-15 00:29:33.000000', 'temperatura', 1095.0000, 'ºC'),
	(156346, 121, '2014-01-15 00:29:34.000000', 'temperatura', 906.0000, 'ºC'),
	(156347, 121, '2014-01-15 00:29:35.000000', 'temperatura', 45.0000, 'ºC'),
	(156348, 121, '2014-01-15 00:29:36.000000', 'temperatura', 1109.0000, 'ºC'),
	(156349, 121, '2014-01-15 00:29:37.000000', 'temperatura', 608.0000, 'ºC'),
	(156350, 121, '2014-01-15 00:29:38.000000', 'temperatura', 915.0000, 'ºC'),
	(156351, 121, '2014-01-15 00:29:39.000000', 'temperatura', 353.0000, 'ºC'),
	(156352, 121, '2014-01-15 00:29:40.000000', 'temperatura', 218.0000, 'ºC'),
	(156353, 121, '2014-01-15 00:29:41.000000', 'temperatura', 33.0000, 'ºC'),
	(156354, 121, '2014-01-15 00:29:42.000000', 'temperatura', 712.0000, 'ºC'),
	(156355, 121, '2014-01-15 00:29:43.000000', 'temperatura', 1062.0000, 'ºC'),
	(156356, 121, '2014-01-15 00:29:44.000000', 'temperatura', 775.0000, 'ºC'),
	(156357, 121, '2014-01-15 00:29:45.000000', 'temperatura', 690.0000, 'ºC'),
	(156358, 121, '2014-01-15 00:29:46.000000', 'temperatura', 1123.0000, 'ºC'),
	(156359, 121, '2014-01-15 00:29:47.000000', 'temperatura', 1148.0000, 'ºC'),
	(156360, 121, '2014-01-15 00:29:48.000000', 'temperatura', 1172.0000, 'ºC'),
	(156361, 121, '2014-01-15 00:29:49.000000', 'temperatura', 15.0000, 'ºC'),
	(156362, 121, '2014-01-15 00:29:50.000000', 'temperatura', 160.0000, 'ºC'),
	(156363, 121, '2014-01-15 00:29:51.000000', 'temperatura', 753.0000, 'ºC'),
	(156364, 121, '2014-01-15 00:29:52.000000', 'temperatura', 889.0000, 'ºC'),
	(156365, 121, '2014-01-15 00:29:53.000000', 'temperatura', 985.0000, 'ºC'),
	(156366, 121, '2014-01-15 00:29:54.000000', 'temperatura', 1060.0000, 'ºC'),
	(156367, 121, '2014-01-15 00:29:55.000000', 'temperatura', 1144.0000, 'ºC'),
	(156368, 121, '2014-01-15 00:29:56.000000', 'temperatura', 142.0000, 'ºC'),
	(156369, 121, '2014-01-15 00:29:57.000000', 'temperatura', 876.0000, 'ºC'),
	(156370, 121, '2014-01-15 00:29:58.000000', 'temperatura', 356.0000, 'ºC'),
	(156371, 121, '2014-01-15 00:29:59.000000', 'temperatura', 353.0000, 'ºC'),
	(156372, 121, '2014-01-15 00:30:00.000000', 'temperatura', 697.0000, 'ºC'),
	(156373, 121, '2014-01-15 00:30:01.000000', 'temperatura', 27.0000, 'ºC'),
	(156374, 121, '2014-01-15 00:30:02.000000', 'temperatura', 444.0000, 'ºC'),
	(156375, 121, '2014-01-15 00:30:03.000000', 'temperatura', 938.0000, 'ºC'),
	(156376, 121, '2014-01-15 00:30:04.000000', 'temperatura', 961.0000, 'ºC'),
	(156377, 121, '2014-01-15 00:30:05.000000', 'temperatura', 791.0000, 'ºC'),
	(156378, 121, '2014-01-15 00:30:06.000000', 'temperatura', 1071.0000, 'ºC'),
	(156379, 121, '2014-01-15 00:30:07.000000', 'temperatura', 583.0000, 'ºC'),
	(156380, 121, '2014-01-15 00:30:08.000000', 'temperatura', 904.0000, 'ºC'),
	(156381, 121, '2014-01-15 00:30:09.000000', 'temperatura', 372.0000, 'ºC'),
	(156382, 121, '2014-01-15 00:30:10.000000', 'temperatura', 346.0000, 'ºC'),
	(156383, 121, '2014-01-15 00:30:11.000000', 'temperatura', 615.0000, 'ºC'),
	(156384, 121, '2014-01-15 00:30:12.000000', 'temperatura', 840.0000, 'ºC'),
	(156385, 121, '2014-01-15 00:30:13.000000', 'temperatura', 1154.0000, 'ºC'),
	(156386, 121, '2014-01-15 00:30:14.000000', 'temperatura', 850.0000, 'ºC'),
	(156387, 121, '2014-01-15 00:30:15.000000', 'temperatura', 790.0000, 'ºC'),
	(156388, 121, '2014-01-15 00:30:16.000000', 'temperatura', 199.0000, 'ºC'),
	(156389, 121, '2014-01-15 00:30:17.000000', 'temperatura', 1027.0000, 'ºC'),
	(156390, 121, '2014-01-15 00:30:18.000000', 'temperatura', 937.0000, 'ºC'),
	(156391, 121, '2014-01-15 00:30:19.000000', 'temperatura', 406.0000, 'ºC'),
	(156392, 121, '2014-01-15 00:30:20.000000', 'temperatura', 419.0000, 'ºC'),
	(156393, 121, '2014-01-15 00:30:21.000000', 'temperatura', 876.0000, 'ºC'),
	(156394, 121, '2014-01-15 00:30:22.000000', 'temperatura', 725.0000, 'ºC'),
	(156395, 121, '2014-01-15 00:30:23.000000', 'temperatura', 997.0000, 'ºC'),
	(156396, 121, '2014-01-15 00:30:24.000000', 'temperatura', 412.0000, 'ºC'),
	(156397, 121, '2014-01-15 00:30:25.000000', 'temperatura', 269.0000, 'ºC'),
	(156398, 121, '2014-01-15 00:30:26.000000', 'temperatura', 109.0000, 'ºC'),
	(156399, 121, '2014-01-15 00:30:27.000000', 'temperatura', 939.0000, 'ºC'),
	(156400, 121, '2014-01-15 00:30:28.000000', 'temperatura', 769.0000, 'ºC'),
	(156401, 121, '2014-01-15 00:30:29.000000', 'temperatura', 1029.0000, 'ºC'),
	(156402, 121, '2014-01-15 00:30:30.000000', 'temperatura', 438.0000, 'ºC'),
	(156403, 121, '2014-01-15 00:30:31.000000', 'temperatura', 304.0000, 'ºC'),
	(156404, 121, '2014-01-15 00:30:32.000000', 'temperatura', 206.0000, 'ºC'),
	(156405, 121, '2014-01-15 00:30:33.000000', 'temperatura', 119.0000, 'ºC'),
	(156406, 121, '2014-01-15 00:30:34.000000', 'temperatura', 1179.0000, 'ºC'),
	(156407, 121, '2014-01-15 00:30:35.000000', 'temperatura', 735.0000, 'ºC'),
	(156408, 121, '2014-01-15 00:30:36.000000', 'temperatura', 141.0000, 'ºC'),
	(156409, 121, '2014-01-15 00:30:37.000000', 'temperatura', 901.0000, 'ºC'),
	(156410, 121, '2014-01-15 00:30:38.000000', 'temperatura', 481.0000, 'ºC'),
	(156411, 121, '2014-01-15 00:30:39.000000', 'temperatura', 904.0000, 'ºC'),
	(156412, 121, '2014-01-15 00:30:40.000000', 'temperatura', 677.0000, 'ºC'),
	(156413, 121, '2014-01-15 00:30:41.000000', 'temperatura', 675.0000, 'ºC'),
	(156414, 121, '2014-01-15 00:30:42.000000', 'temperatura', 144.0000, 'ºC'),
	(156415, 121, '2014-01-15 00:30:43.000000', 'temperatura', 1095.0000, 'ºC'),
	(156416, 121, '2014-01-15 00:30:44.000000', 'temperatura', 243.0000, 'ºC'),
	(156417, 121, '2014-01-15 00:30:45.000000', 'temperatura', 332.0000, 'ºC'),
	(156418, 121, '2014-01-15 00:30:46.000000', 'temperatura', 931.0000, 'ºC'),
	(156419, 121, '2014-01-15 00:30:47.000000', 'temperatura', 58.0000, 'ºC'),
	(156420, 121, '2014-01-15 00:30:48.000000', 'temperatura', 1098.0000, 'ºC'),
	(156421, 121, '2014-01-15 00:30:49.000000', 'temperatura', 519.0000, 'ºC'),
	(156422, 121, '2014-01-15 00:30:50.000000', 'temperatura', 498.0000, 'ºC'),
	(156423, 121, '2014-01-15 00:30:51.000000', 'temperatura', 936.0000, 'ºC'),
	(156424, 121, '2014-01-15 00:30:52.000000', 'temperatura', 784.0000, 'ºC'),
	(156425, 121, '2014-01-15 00:30:53.000000', 'temperatura', 1115.0000, 'ºC'),
	(156426, 121, '2014-01-15 00:30:54.000000', 'temperatura', 823.0000, 'ºC'),
	(156427, 121, '2014-01-15 00:30:55.000000', 'temperatura', 769.0000, 'ºC'),
	(156428, 121, '2014-01-15 00:30:56.000000', 'temperatura', 176.0000, 'ºC'),
	(156429, 121, '2014-01-15 00:30:57.000000', 'temperatura', 974.0000, 'ºC'),
	(156430, 121, '2014-01-15 00:30:58.000000', 'temperatura', 742.0000, 'ºC'),
	(156431, 121, '2014-01-15 00:30:59.000000', 'temperatura', 788.0000, 'ºC'),
	(156432, 121, '2014-01-15 00:31:00.000000', 'temperatura', 516.0000, 'ºC'),
	(156433, 121, '2014-01-15 00:31:01.000000', 'temperatura', 215.0000, 'ºC'),
	(156434, 121, '2014-01-15 00:31:02.000000', 'temperatura', 730.0000, 'ºC'),
	(156435, 121, '2014-01-15 00:31:03.000000', 'temperatura', 604.0000, 'ºC'),
	(156436, 121, '2014-01-15 00:31:04.000000', 'temperatura', 830.0000, 'ºC'),
	(156437, 121, '2014-01-15 00:31:05.000000', 'temperatura', 1141.0000, 'ºC'),
	(156438, 121, '2014-01-15 00:31:06.000000', 'temperatura', 812.0000, 'ºC'),
	(156439, 121, '2014-01-15 00:31:07.000000', 'temperatura', 639.0000, 'ºC'),
	(156440, 121, '2014-01-15 00:31:08.000000', 'temperatura', 759.0000, 'ºC'),
	(156441, 121, '2014-01-15 00:31:09.000000', 'temperatura', 678.0000, 'ºC'),
	(156442, 121, '2014-01-15 00:31:10.000000', 'temperatura', 1115.0000, 'ºC'),
	(156443, 121, '2014-01-15 00:31:11.000000', 'temperatura', 1142.0000, 'ºC'),
	(156444, 121, '2014-01-15 00:31:12.000000', 'temperatura', 1164.0000, 'ºC'),
	(156445, 121, '2014-01-15 00:31:13.000000', 'temperatura', 1196.0000, 'ºC'),
	(156446, 121, '2014-01-15 00:31:14.000000', 'temperatura', 87.0000, 'ºC'),
	(156447, 121, '2014-01-15 00:31:15.000000', 'temperatura', 450.0000, 'ºC'),
	(156448, 121, '2014-01-15 00:31:16.000000', 'temperatura', 789.0000, 'ºC'),
	(156449, 121, '2014-01-15 00:31:17.000000', 'temperatura', 194.0000, 'ºC'),
	(156450, 121, '2014-01-15 00:31:18.000000', 'temperatura', 1003.0000, 'ºC'),
	(156451, 121, '2014-01-15 00:31:19.000000', 'temperatura', 833.0000, 'ºC'),
	(156452, 121, '2014-01-15 00:31:20.000000', 'temperatura', 1159.0000, 'ºC'),
	(156453, 121, '2014-01-15 00:31:21.000000', 'temperatura', 895.0000, 'ºC'),
	(156454, 121, '2014-01-15 00:31:22.000000', 'temperatura', 997.0000, 'ºC'),
	(156455, 121, '2014-01-15 00:31:23.000000', 'temperatura', 1103.0000, 'ºC'),
	(156456, 121, '2014-01-15 00:31:24.000000', 'temperatura', 122.0000, 'ºC'),
	(156457, 121, '2014-01-15 00:31:25.000000', 'temperatura', 904.0000, 'ºC'),
	(156458, 121, '2014-01-15 00:31:26.000000', 'temperatura', 554.0000, 'ºC'),
	(156459, 121, '2014-01-15 00:31:27.000000', 'temperatura', 59.0000, 'ºC'),
	(156460, 121, '2014-01-15 00:31:28.000000', 'temperatura', 1031.0000, 'ºC'),
	(156461, 121, '2014-01-15 00:31:29.000000', 'temperatura', 179.0000, 'ºC'),
	(156462, 121, '2014-01-15 00:31:30.000000', 'temperatura', 203.0000, 'ºC'),
	(156463, 121, '2014-01-15 00:31:31.000000', 'temperatura', 479.0000, 'ºC'),
	(156464, 121, '2014-01-15 00:31:32.000000', 'temperatura', 585.0000, 'ºC'),
	(156465, 121, '2014-01-15 00:31:33.000000', 'temperatura', 289.0000, 'ºC'),
	(156466, 121, '2014-01-15 00:31:34.000000', 'temperatura', 890.0000, 'ºC'),
	(156467, 121, '2014-01-15 00:31:35.000000', 'temperatura', 1184.0000, 'ºC'),
	(156468, 121, '2014-01-15 00:31:36.000000', 'temperatura', 852.0000, 'ºC'),
	(156469, 121, '2014-01-15 00:31:37.000000', 'temperatura', 709.0000, 'ºC'),
	(156470, 121, '2014-01-15 00:31:38.000000', 'temperatura', 986.0000, 'ºC'),
	(156471, 121, '2014-01-15 00:31:39.000000', 'temperatura', 406.0000, 'ºC'),
	(156472, 121, '2014-01-15 00:31:40.000000', 'temperatura', 274.0000, 'ºC'),
	(156473, 121, '2014-01-15 00:31:41.000000', 'temperatura', 149.0000, 'ºC'),
	(156474, 121, '2014-01-15 00:31:42.000000', 'temperatura', 1127.0000, 'ºC'),
	(156475, 121, '2014-01-15 00:31:43.000000', 'temperatura', 387.0000, 'ºC'),
	(156476, 121, '2014-01-15 00:31:44.000000', 'temperatura', 956.0000, 'ºC'),
	(156477, 121, '2014-01-15 00:31:45.000000', 'temperatura', 19.0000, 'ºC'),
	(156478, 121, '2014-01-15 00:31:46.000000', 'temperatura', 829.0000, 'ºC'),
	(156479, 121, '2014-01-15 00:31:47.000000', 'temperatura', 488.0000, 'ºC'),
	(156480, 121, '2014-01-15 00:31:48.000000', 'temperatura', 1154.0000, 'ºC'),
	(156481, 121, '2014-01-15 00:31:49.000000', 'temperatura', 706.0000, 'ºC'),
	(156482, 121, '2014-01-15 00:31:50.000000', 'temperatura', 69.0000, 'ºC'),
	(156483, 121, '2014-01-15 00:31:51.000000', 'temperatura', 628.0000, 'ºC'),
	(156484, 121, '2014-01-15 00:31:52.000000', 'temperatura', 533.0000, 'ºC'),
	(156485, 121, '2014-01-15 00:31:53.000000', 'temperatura', 780.0000, 'ºC'),
	(156486, 121, '2014-01-15 00:31:54.000000', 'temperatura', 1104.0000, 'ºC'),
	(156487, 121, '2014-01-15 00:31:55.000000', 'temperatura', 778.0000, 'ºC'),
	(156488, 121, '2014-01-15 00:31:56.000000', 'temperatura', 579.0000, 'ºC'),
	(156489, 121, '2014-01-15 00:31:57.000000', 'temperatura', 564.0000, 'ºC'),
	(156490, 121, '2014-01-15 00:31:58.000000', 'temperatura', 1082.0000, 'ºC'),
	(156491, 121, '2014-01-15 00:31:59.000000', 'temperatura', 117.0000, 'ºC'),
	(156492, 121, '2014-01-15 00:32:00.000000', 'temperatura', 941.0000, 'ºC'),
	(156493, 121, '2014-01-15 00:32:01.000000', 'temperatura', 754.0000, 'ºC'),
	(156494, 121, '2014-01-15 00:32:02.000000', 'temperatura', 946.0000, 'ºC'),
	(156495, 121, '2014-01-15 00:32:03.000000', 'temperatura', 71.0000, 'ºC'),
	(156496, 121, '2014-01-15 00:32:04.000000', 'temperatura', 1116.0000, 'ºC'),
	(156497, 121, '2014-01-15 00:32:05.000000', 'temperatura', 567.0000, 'ºC'),
	(156498, 121, '2014-01-15 00:32:06.000000', 'temperatura', 688.0000, 'ºC'),
	(156499, 121, '2014-01-15 00:32:07.000000', 'temperatura', 539.0000, 'ºC'),
	(156500, 121, '2014-01-15 00:32:08.000000', 'temperatura', 630.0000, 'ºC'),
	(156501, 121, '2014-01-15 00:32:09.000000', 'temperatura', 335.0000, 'ºC'),
	(156502, 121, '2014-01-15 00:32:10.000000', 'temperatura', 987.0000, 'ºC'),
	(156503, 121, '2014-01-15 00:32:11.000000', 'temperatura', 331.0000, 'ºC'),
	(156504, 121, '2014-01-15 00:32:12.000000', 'temperatura', 1093.0000, 'ºC'),
	(156505, 121, '2014-01-15 00:32:13.000000', 'temperatura', 871.0000, 'ºC'),
	(156506, 121, '2014-01-15 00:32:14.000000', 'temperatura', 1078.0000, 'ºC'),
	(156507, 121, '2014-01-15 00:32:15.000000', 'temperatura', 376.0000, 'ºC'),
	(156508, 121, '2014-01-15 00:32:16.000000', 'temperatura', 1049.0000, 'ºC'),
	(156509, 121, '2014-01-15 00:32:17.000000', 'temperatura', 516.0000, 'ºC'),
	(156510, 121, '2014-01-15 00:32:18.000000', 'temperatura', 635.0000, 'ºC'),
	(156511, 121, '2014-01-15 00:32:19.000000', 'temperatura', 427.0000, 'ºC'),
	(156512, 121, '2014-01-15 00:32:20.000000', 'temperatura', 231.0000, 'ºC'),
	(156513, 121, '2014-01-15 00:32:21.000000', 'temperatura', 1075.0000, 'ºC'),
	(156514, 121, '2014-01-15 00:32:22.000000', 'temperatura', 1080.0000, 'ºC'),
	(156515, 121, '2014-01-15 00:32:23.000000', 'temperatura', 977.0000, 'ºC'),
	(156516, 121, '2014-01-15 00:32:24.000000', 'temperatura', 445.0000, 'ºC'),
	(156517, 121, '2014-01-15 00:32:25.000000', 'temperatura', 494.0000, 'ºC'),
	(156518, 121, '2014-01-15 00:32:26.000000', 'temperatura', 1136.0000, 'ºC'),
	(156519, 121, '2014-01-15 00:32:27.000000', 'temperatura', 598.0000, 'ºC'),
	(156520, 121, '2014-01-15 00:32:28.000000', 'temperatura', 782.0000, 'ºC'),
	(156521, 121, '2014-01-15 00:32:29.000000', 'temperatura', 917.0000, 'ºC'),
	(156522, 121, '2014-01-15 00:32:30.000000', 'temperatura', 1038.0000, 'ºC'),
	(156523, 121, '2014-01-15 00:32:31.000000', 'temperatura', 39.0000, 'ºC'),
	(156524, 121, '2014-01-15 00:32:32.000000', 'temperatura', 683.0000, 'ºC'),
	(156525, 121, '2014-01-15 00:32:33.000000', 'temperatura', 900.0000, 'ºC'),
	(156526, 121, '2014-01-15 00:32:34.000000', 'temperatura', 49.0000, 'ºC'),
	(156527, 121, '2014-01-15 00:32:35.000000', 'temperatura', 1145.0000, 'ºC'),
	(156528, 121, '2014-01-15 00:32:36.000000', 'temperatura', 778.0000, 'ºC'),
	(156529, 121, '2014-01-15 00:32:37.000000', 'temperatura', 457.0000, 'ºC'),
	(156530, 121, '2014-01-15 00:32:38.000000', 'temperatura', 1150.0000, 'ºC'),
	(156531, 121, '2014-01-15 00:32:39.000000', 'temperatura', 779.0000, 'ºC'),
	(156532, 121, '2014-01-15 00:32:40.000000', 'temperatura', 448.0000, 'ºC'),
	(156533, 121, '2014-01-15 00:32:41.000000', 'temperatura', 1101.0000, 'ºC'),
	(156534, 121, '2014-01-15 00:32:42.000000', 'temperatura', 562.0000, 'ºC'),
	(156535, 121, '2014-01-15 00:32:43.000000', 'temperatura', 706.0000, 'ºC'),
	(156536, 121, '2014-01-15 00:32:44.000000', 'temperatura', 645.0000, 'ºC'),
	(156537, 121, '2014-01-15 00:32:45.000000', 'temperatura', 1110.0000, 'ºC'),
	(156538, 121, '2014-01-15 00:32:46.000000', 'temperatura', 13.0000, 'ºC'),
	(156539, 121, '2014-01-15 00:32:47.000000', 'temperatura', 336.0000, 'ºC'),
	(156540, 121, '2014-01-15 00:32:48.000000', 'temperatura', 442.0000, 'ºC'),
	(156541, 121, '2014-01-15 00:32:49.000000', 'temperatura', 2.0000, 'ºC'),
	(156542, 121, '2014-01-15 00:32:50.000000', 'temperatura', 1086.0000, 'ºC'),
	(156543, 121, '2014-01-15 00:32:51.000000', 'temperatura', 625.0000, 'ºC'),
	(156544, 121, '2014-01-15 00:32:52.000000', 'temperatura', 1066.0000, 'ºC'),
	(156545, 121, '2014-01-15 00:32:53.000000', 'temperatura', 1054.0000, 'ºC'),
	(156546, 121, '2014-01-15 00:32:54.000000', 'temperatura', 875.0000, 'ºC'),
	(156547, 121, '2014-01-15 00:32:55.000000', 'temperatura', 14.0000, 'ºC'),
	(156548, 121, '2014-01-15 00:32:56.000000', 'temperatura', 1046.0000, 'ºC'),
	(156549, 121, '2014-01-15 00:32:57.000000', 'temperatura', 389.0000, 'ºC'),
	(156550, 121, '2014-01-15 00:32:58.000000', 'temperatura', 5.0000, 'ºC'),
	(156551, 121, '2014-01-15 00:32:59.000000', 'temperatura', 61.0000, 'ºC'),
	(156552, 121, '2014-01-15 00:33:00.000000', 'temperatura', 289.0000, 'ºC'),
	(156553, 121, '2014-01-15 00:33:01.000000', 'temperatura', 63.0000, 'ºC'),
	(156554, 121, '2014-01-15 00:33:02.000000', 'temperatura', 649.0000, 'ºC'),
	(156555, 121, '2014-01-15 00:33:03.000000', 'temperatura', 656.0000, 'ºC'),
	(156556, 121, '2014-01-15 00:33:04.000000', 'temperatura', 132.0000, 'ºC'),
	(156557, 121, '2014-01-15 00:33:05.000000', 'temperatura', 1095.0000, 'ºC'),
	(156558, 121, '2014-01-15 00:33:06.000000', 'temperatura', 277.0000, 'ºC'),
	(156559, 121, '2014-01-15 00:33:07.000000', 'temperatura', 499.0000, 'ºC'),
	(156560, 121, '2014-01-15 00:33:08.000000', 'temperatura', 468.0000, 'ºC'),
	(156561, 121, '2014-01-15 00:33:09.000000', 'temperatura', 843.0000, 'ºC'),
	(156562, 121, '2014-01-15 00:33:10.000000', 'temperatura', 410.0000, 'ºC'),
	(156563, 121, '2014-01-15 00:33:11.000000', 'temperatura', 722.0000, 'ºC'),
	(156564, 121, '2014-01-15 00:33:12.000000', 'temperatura', 1183.0000, 'ºC'),
	(156565, 121, '2014-01-15 00:33:13.000000', 'temperatura', 146.0000, 'ºC'),
	(156566, 121, '2014-01-15 00:33:14.000000', 'temperatura', 785.0000, 'ºC'),
	(156567, 121, '2014-01-15 00:33:15.000000', 'temperatura', 1085.0000, 'ºC'),
	(156568, 121, '2014-01-15 00:33:16.000000', 'temperatura', 673.0000, 'ºC'),
	(156569, 121, '2014-01-15 00:33:17.000000', 'temperatura', 110.0000, 'ºC'),
	(156570, 121, '2014-01-15 00:33:18.000000', 'temperatura', 931.0000, 'ºC'),
	(156571, 121, '2014-01-15 00:33:19.000000', 'temperatura', 726.0000, 'ºC'),
	(156572, 121, '2014-01-15 00:33:20.000000', 'temperatura', 836.0000, 'ºC'),
	(156573, 121, '2014-01-15 00:33:21.000000', 'temperatura', 803.0000, 'ºC'),
	(156574, 121, '2014-01-15 00:33:22.000000', 'temperatura', 308.0000, 'ºC'),
	(156575, 121, '2014-01-15 00:33:23.000000', 'temperatura', 331.0000, 'ºC'),
	(156576, 121, '2014-01-15 00:33:24.000000', 'temperatura', 730.0000, 'ºC'),
	(156577, 121, '2014-01-15 00:33:25.000000', 'temperatura', 257.0000, 'ºC'),
	(156578, 121, '2014-01-15 00:33:26.000000', 'temperatura', 296.0000, 'ºC'),
	(156579, 121, '2014-01-15 00:33:27.000000', 'temperatura', 710.0000, 'ºC'),
	(156580, 121, '2014-01-15 00:33:28.000000', 'temperatura', 264.0000, 'ºC'),
	(156581, 121, '2014-01-15 00:33:29.000000', 'temperatura', 388.0000, 'ºC'),
	(156582, 121, '2014-01-15 00:33:30.000000', 'temperatura', 1149.0000, 'ºC'),
	(156583, 121, '2014-01-15 00:33:31.000000', 'temperatura', 983.0000, 'ºC'),
	(156584, 121, '2014-01-15 00:33:32.000000', 'temperatura', 269.0000, 'ºC'),
	(156585, 121, '2014-01-15 00:33:33.000000', 'temperatura', 798.0000, 'ºC'),
	(156586, 121, '2014-01-15 00:33:34.000000', 'temperatura', 780.0000, 'ºC'),
	(156587, 121, '2014-01-15 00:33:35.000000', 'temperatura', 308.0000, 'ºC'),
	(156588, 121, '2014-01-15 00:33:36.000000', 'temperatura', 402.0000, 'ºC'),
	(156589, 121, '2014-01-15 00:33:37.000000', 'temperatura', 1087.0000, 'ºC'),
	(156590, 121, '2014-01-15 00:33:38.000000', 'temperatura', 628.0000, 'ºC'),
	(156591, 121, '2014-01-15 00:33:39.000000', 'temperatura', 1079.0000, 'ºC'),
	(156592, 121, '2014-01-15 00:33:40.000000', 'temperatura', 1113.0000, 'ºC'),
	(156593, 121, '2014-01-15 00:33:41.000000', 'temperatura', 1126.0000, 'ºC'),
	(156594, 121, '2014-01-15 00:33:42.000000', 'temperatura', 1093.0000, 'ºC'),
	(156595, 121, '2014-01-15 00:33:43.000000', 'temperatura', 887.0000, 'ºC'),
	(156596, 121, '2014-01-15 00:33:44.000000', 'temperatura', 1156.0000, 'ºC'),
	(156597, 121, '2014-01-15 00:33:45.000000', 'temperatura', 721.0000, 'ºC'),
	(156598, 121, '2014-01-15 00:33:46.000000', 'temperatura', 138.0000, 'ºC'),
	(156599, 121, '2014-01-15 00:33:47.000000', 'temperatura', 926.0000, 'ºC'),
	(156600, 121, '2014-01-15 00:33:48.000000', 'temperatura', 618.0000, 'ºC'),
	(156601, 121, '2014-01-15 00:33:49.000000', 'temperatura', 312.0000, 'ºC'),
	(156602, 121, '2014-01-15 00:33:50.000000', 'temperatura', 907.0000, 'ºC'),
	(156603, 121, '2014-01-15 00:33:51.000000', 'temperatura', 1199.0000, 'ºC'),
	(156604, 121, '2014-01-15 00:33:52.000000', 'temperatura', 875.0000, 'ºC'),
	(156605, 121, '2014-01-15 00:33:53.000000', 'temperatura', 776.0000, 'ºC'),
	(156606, 121, '2014-01-15 00:33:54.000000', 'temperatura', 58.0000, 'ºC'),
	(156607, 121, '2014-01-15 00:33:55.000000', 'temperatura', 362.0000, 'ºC'),
	(156608, 121, '2014-01-15 00:33:56.000000', 'temperatura', 437.0000, 'ºC'),
	(156609, 121, '2014-01-15 00:33:57.000000', 'temperatura', 1097.0000, 'ºC'),
	(156610, 121, '2014-01-15 00:33:58.000000', 'temperatura', 576.0000, 'ºC'),
	(156611, 121, '2014-01-15 00:33:59.000000', 'temperatura', 788.0000, 'ºC'),
	(156612, 121, '2014-01-15 00:34:00.000000', 'temperatura', 1013.0000, 'ºC'),
	(156613, 121, '2014-01-15 00:34:01.000000', 'temperatura', 301.0000, 'ºC'),
	(156614, 121, '2014-01-15 00:34:02.000000', 'temperatura', 868.0000, 'ºC'),
	(156615, 121, '2014-01-15 00:34:03.000000', 'temperatura', 1039.0000, 'ºC'),
	(156616, 121, '2014-01-15 00:34:04.000000', 'temperatura', 189.0000, 'ºC'),
	(156617, 121, '2014-01-15 00:34:05.000000', 'temperatura', 231.0000, 'ºC'),
	(156618, 121, '2014-01-15 00:34:06.000000', 'temperatura', 589.0000, 'ºC'),
	(156619, 121, '2014-01-15 00:34:07.000000', 'temperatura', 1050.0000, 'ºC'),
	(156620, 121, '2014-01-15 00:34:08.000000', 'temperatura', 1084.0000, 'ºC'),
	(156621, 121, '2014-01-15 00:34:09.000000', 'temperatura', 1071.0000, 'ºC'),
	(156622, 121, '2014-01-15 00:34:10.000000', 'temperatura', 903.0000, 'ºC'),
	(156623, 121, '2014-01-15 00:34:11.000000', 'temperatura', 104.0000, 'ºC'),
	(156624, 121, '2014-01-15 00:34:12.000000', 'temperatura', 211.0000, 'ºC'),
	(156625, 121, '2014-01-15 00:34:13.000000', 'temperatura', 744.0000, 'ºC'),
	(156626, 121, '2014-01-15 00:34:14.000000', 'temperatura', 685.0000, 'ºC'),
	(156627, 121, '2014-01-15 00:34:15.000000', 'temperatura', 1196.0000, 'ºC'),
	(156628, 121, '2014-01-15 00:34:16.000000', 'temperatura', 325.0000, 'ºC'),
	(156629, 121, '2014-01-15 00:34:17.000000', 'temperatura', 435.0000, 'ºC'),
	(156630, 121, '2014-01-15 00:34:18.000000', 'temperatura', 3.0000, 'ºC'),
	(156631, 121, '2014-01-15 00:34:19.000000', 'temperatura', 1109.0000, 'ºC'),
	(156632, 121, '2014-01-15 00:34:20.000000', 'temperatura', 739.0000, 'ºC'),
	(156633, 121, '2014-01-15 00:34:21.000000', 'temperatura', 368.0000, 'ºC'),
	(156634, 121, '2014-01-15 00:34:22.000000', 'temperatura', 822.0000, 'ºC'),
	(156635, 121, '2014-01-15 00:34:23.000000', 'temperatura', 608.0000, 'ºC'),
	(156636, 121, '2014-01-15 00:34:24.000000', 'temperatura', 575.0000, 'ºC'),
	(156637, 121, '2014-01-15 00:34:25.000000', 'temperatura', 1051.0000, 'ºC'),
	(156638, 121, '2014-01-15 00:34:26.000000', 'temperatura', 1128.0000, 'ºC'),
	(156639, 121, '2014-01-15 00:34:27.000000', 'temperatura', 90.0000, 'ºC'),
	(156640, 121, '2014-01-15 00:34:28.000000', 'temperatura', 665.0000, 'ºC'),
	(156641, 121, '2014-01-15 00:34:29.000000', 'temperatura', 657.0000, 'ºC'),
	(156642, 121, '2014-01-15 00:34:30.000000', 'temperatura', 89.0000, 'ºC'),
	(156643, 121, '2014-01-15 00:34:31.000000', 'temperatura', 877.0000, 'ºC'),
	(156644, 121, '2014-01-15 00:34:32.000000', 'temperatura', 517.0000, 'ºC'),
	(156645, 121, '2014-01-15 00:34:33.000000', 'temperatura', 1156.0000, 'ºC'),
	(156646, 121, '2014-01-15 00:34:34.000000', 'temperatura', 629.0000, 'ºC'),
	(156647, 121, '2014-01-15 00:34:35.000000', 'temperatura', 879.0000, 'ºC'),
	(156648, 121, '2014-01-15 00:34:36.000000', 'temperatura', 107.0000, 'ºC'),
	(156649, 121, '2014-01-15 00:34:37.000000', 'temperatura', 297.0000, 'ºC'),
	(156650, 121, '2014-01-15 00:34:38.000000', 'temperatura', 1167.0000, 'ºC'),
	(156651, 121, '2014-01-15 00:34:39.000000', 'temperatura', 142.0000, 'ºC'),
	(156652, 121, '2014-01-15 00:34:40.000000', 'temperatura', 812.0000, 'ºC'),
	(156653, 121, '2014-01-15 00:34:41.000000', 'temperatura', 34.0000, 'ºC'),
	(156654, 121, '2014-01-15 00:34:42.000000', 'temperatura', 135.0000, 'ºC'),
	(156655, 121, '2014-01-15 00:34:43.000000', 'temperatura', 571.0000, 'ºC'),
	(156656, 121, '2014-01-15 00:34:44.000000', 'temperatura', 51.0000, 'ºC'),
	(156657, 121, '2014-01-15 00:34:45.000000', 'temperatura', 943.0000, 'ºC'),
	(156658, 121, '2014-01-15 00:34:46.000000', 'temperatura', 963.0000, 'ºC'),
	(156659, 121, '2014-01-15 00:34:47.000000', 'temperatura', 784.0000, 'ºC'),
	(156660, 121, '2014-01-15 00:34:48.000000', 'temperatura', 1035.0000, 'ºC'),
	(156661, 121, '2014-01-15 00:34:49.000000', 'temperatura', 420.0000, 'ºC'),
	(156662, 121, '2014-01-15 00:34:50.000000', 'temperatura', 199.0000, 'ºC'),
	(156663, 121, '2014-01-15 00:34:51.000000', 'temperatura', 932.0000, 'ºC'),
	(156664, 121, '2014-01-15 00:34:52.000000', 'temperatura', 465.0000, 'ºC'),
	(156665, 121, '2014-01-15 00:34:53.000000', 'temperatura', 729.0000, 'ºC'),
	(156666, 121, '2014-01-15 00:34:54.000000', 'temperatura', 1052.0000, 'ºC'),
	(156667, 121, '2014-01-15 00:34:55.000000', 'temperatura', 672.0000, 'ºC'),
	(156668, 121, '2014-01-15 00:34:56.000000', 'temperatura', 206.0000, 'ºC'),
	(156669, 121, '2014-01-15 00:34:57.000000', 'temperatura', 213.0000, 'ºC'),
	(156670, 121, '2014-01-15 00:34:58.000000', 'temperatura', 450.0000, 'ºC'),
	(156671, 121, '2014-01-15 00:34:59.000000', 'temperatura', 409.0000, 'ºC'),
	(156672, 121, '2014-01-15 00:35:00.000000', 'temperatura', 698.0000, 'ºC'),
	(156673, 121, '2014-01-15 00:35:01.000000', 'temperatura', 1064.0000, 'ºC'),
	(156674, 121, '2014-01-15 00:35:02.000000', 'temperatura', 824.0000, 'ºC'),
	(156675, 121, '2014-01-15 00:35:03.000000', 'temperatura', 931.0000, 'ºC'),
	(156676, 121, '2014-01-15 00:35:04.000000', 'temperatura', 982.0000, 'ºC'),
	(156677, 121, '2014-01-15 00:35:05.000000', 'temperatura', 916.0000, 'ºC'),
	(156678, 121, '2014-01-15 00:35:06.000000', 'temperatura', 436.0000, 'ºC'),
	(156679, 121, '2014-01-15 00:35:07.000000', 'temperatura', 631.0000, 'ºC'),
	(156680, 121, '2014-01-15 00:35:08.000000', 'temperatura', 650.0000, 'ºC'),
	(156681, 121, '2014-01-15 00:35:09.000000', 'temperatura', 158.0000, 'ºC'),
	(156682, 121, '2014-01-15 00:35:10.000000', 'temperatura', 39.0000, 'ºC'),
	(156683, 121, '2014-01-15 00:35:11.000000', 'temperatura', 921.0000, 'ºC'),
	(156684, 121, '2014-01-15 00:35:12.000000', 'temperatura', 889.0000, 'ºC'),
	(156685, 121, '2014-01-15 00:35:13.000000', 'temperatura', 481.0000, 'ºC'),
	(156686, 121, '2014-01-15 00:35:14.000000', 'temperatura', 941.0000, 'ºC'),
	(156687, 121, '2014-01-15 00:35:15.000000', 'temperatura', 861.0000, 'ºC'),
	(156688, 121, '2014-01-15 00:35:16.000000', 'temperatura', 281.0000, 'ºC'),
	(156689, 121, '2014-01-15 00:35:17.000000', 'temperatura', 23.0000, 'ºC'),
	(156690, 121, '2014-01-15 00:35:18.000000', 'temperatura', 472.0000, 'ºC'),
	(156691, 121, '2014-01-15 00:35:19.000000', 'temperatura', 1094.0000, 'ºC'),
	(156692, 121, '2014-01-15 00:35:20.000000', 'temperatura', 454.0000, 'ºC'),
	(156693, 121, '2014-01-15 00:35:21.000000', 'temperatura', 187.0000, 'ºC'),
	(156694, 121, '2014-01-15 00:35:22.000000', 'temperatura', 775.0000, 'ºC'),
	(156695, 121, '2014-01-15 00:35:23.000000', 'temperatura', 915.0000, 'ºC'),
	(156696, 121, '2014-01-15 00:35:24.000000', 'temperatura', 1050.0000, 'ºC'),
	(156697, 121, '2014-01-15 00:35:25.000000', 'temperatura', 105.0000, 'ºC'),
	(156698, 121, '2014-01-15 00:35:26.000000', 'temperatura', 976.0000, 'ºC'),
	(156699, 121, '2014-01-15 00:35:27.000000', 'temperatura', 964.0000, 'ºC'),
	(156700, 121, '2014-01-15 00:35:28.000000', 'temperatura', 694.0000, 'ºC'),
	(156701, 121, '2014-01-15 00:35:29.000000', 'temperatura', 578.0000, 'ºC'),
	(156702, 121, '2014-01-15 00:35:30.000000', 'temperatura', 807.0000, 'ºC'),
	(156703, 121, '2014-01-15 00:35:31.000000', 'temperatura', 1104.0000, 'ºC'),
	(156704, 121, '2014-01-15 00:35:32.000000', 'temperatura', 700.0000, 'ºC'),
	(156705, 121, '2014-01-15 00:35:33.000000', 'temperatura', 186.0000, 'ºC'),
	(156706, 121, '2014-01-15 00:35:34.000000', 'temperatura', 33.0000, 'ºC'),
	(156707, 121, '2014-01-15 00:35:35.000000', 'temperatura', 805.0000, 'ºC'),
	(156708, 121, '2014-01-15 00:35:36.000000', 'temperatura', 329.0000, 'ºC'),
	(156709, 121, '2014-01-15 00:35:37.000000', 'temperatura', 428.0000, 'ºC'),
	(156710, 121, '2014-01-15 00:35:38.000000', 'temperatura', 1153.0000, 'ºC'),
	(156711, 121, '2014-01-15 00:35:39.000000', 'temperatura', 882.0000, 'ºC'),
	(156712, 121, '2014-01-15 00:35:40.000000', 'temperatura', 951.0000, 'ºC'),
	(156713, 121, '2014-01-15 00:35:41.000000', 'temperatura', 909.0000, 'ºC'),
	(156714, 121, '2014-01-15 00:35:42.000000', 'temperatura', 494.0000, 'ºC'),
	(156715, 121, '2014-01-15 00:35:43.000000', 'temperatura', 942.0000, 'ºC'),
	(156716, 121, '2014-01-15 00:35:44.000000', 'temperatura', 828.0000, 'ºC'),
	(156717, 121, '2014-01-15 00:35:45.000000', 'temperatura', 116.0000, 'ºC'),
	(156718, 121, '2014-01-15 00:35:46.000000', 'temperatura', 495.0000, 'ºC'),
	(156719, 121, '2014-01-15 00:35:47.000000', 'temperatura', 928.0000, 'ºC'),
	(156720, 121, '2014-01-15 00:35:48.000000', 'temperatura', 754.0000, 'ºC'),
	(156721, 121, '2014-01-15 00:35:49.000000', 'temperatura', 986.0000, 'ºC'),
	(156722, 121, '2014-01-15 00:35:50.000000', 'temperatura', 271.0000, 'ºC'),
	(156723, 121, '2014-01-15 00:35:51.000000', 'temperatura', 795.0000, 'ºC'),
	(156724, 121, '2014-01-15 00:35:52.000000', 'temperatura', 763.0000, 'ºC'),
	(156725, 121, '2014-01-15 00:35:53.000000', 'temperatura', 229.0000, 'ºC'),
	(156726, 121, '2014-01-15 00:35:54.000000', 'temperatura', 59.0000, 'ºC'),
	(156727, 121, '2014-01-15 00:35:55.000000', 'temperatura', 810.0000, 'ºC'),
	(156728, 121, '2014-01-15 00:35:56.000000', 'temperatura', 270.0000, 'ºC'),
	(156729, 121, '2014-01-15 00:35:57.000000', 'temperatura', 123.0000, 'ºC'),
	(156730, 121, '2014-01-15 00:35:58.000000', 'temperatura', 1003.0000, 'ºC'),
	(156731, 121, '2014-01-15 00:35:59.000000', 'temperatura', 1048.0000, 'ºC'),
	(156732, 121, '2014-01-15 00:36:00.000000', 'temperatura', 1032.0000, 'ºC'),
	(156733, 121, '2014-01-15 00:36:01.000000', 'temperatura', 817.0000, 'ºC'),
	(156734, 121, '2014-01-15 00:36:02.000000', 'temperatura', 989.0000, 'ºC'),
	(156735, 121, '2014-01-15 00:36:03.000000', 'temperatura', 96.0000, 'ºC'),
	(156736, 121, '2014-01-15 00:36:04.000000', 'temperatura', 1114.0000, 'ºC'),
	(156737, 121, '2014-01-15 00:36:05.000000', 'temperatura', 482.0000, 'ºC'),
	(156738, 121, '2014-01-15 00:36:06.000000', 'temperatura', 268.0000, 'ºC'),
	(156739, 121, '2014-01-15 00:36:07.000000', 'temperatura', 1096.0000, 'ºC'),
	(156740, 121, '2014-01-15 00:36:08.000000', 'temperatura', 1076.0000, 'ºC'),
	(156741, 121, '2014-01-15 00:36:09.000000', 'temperatura', 892.0000, 'ºC'),
	(156742, 121, '2014-01-15 00:36:10.000000', 'temperatura', 34.0000, 'ºC'),
	(156743, 121, '2014-01-15 00:36:11.000000', 'temperatura', 1092.0000, 'ºC'),
	(156744, 121, '2014-01-15 00:36:12.000000', 'temperatura', 560.0000, 'ºC'),
	(156745, 121, '2014-01-15 00:36:13.000000', 'temperatura', 722.0000, 'ºC'),
	(156746, 121, '2014-01-15 00:36:14.000000', 'temperatura', 734.0000, 'ºC'),
	(156747, 121, '2014-01-15 00:36:15.000000', 'temperatura', 304.0000, 'ºC'),
	(156748, 121, '2014-01-15 00:36:16.000000', 'temperatura', 517.0000, 'ºC'),
	(156749, 121, '2014-01-15 00:36:17.000000', 'temperatura', 475.0000, 'ºC'),
	(156750, 121, '2014-01-15 00:36:18.000000', 'temperatura', 822.0000, 'ºC'),
	(156751, 121, '2014-01-15 00:36:19.000000', 'temperatura', 288.0000, 'ºC'),
	(156752, 121, '2014-01-15 00:36:20.000000', 'temperatura', 172.0000, 'ºC'),
	(156753, 121, '2014-01-15 00:36:21.000000', 'temperatura', 1196.0000, 'ºC'),
	(156754, 121, '2014-01-15 00:36:22.000000', 'temperatura', 665.0000, 'ºC'),
	(156755, 121, '2014-01-15 00:36:23.000000', 'temperatura', 939.0000, 'ºC'),
	(156756, 121, '2014-01-15 00:36:24.000000', 'temperatura', 299.0000, 'ºC'),
	(156757, 121, '2014-01-15 00:36:25.000000', 'temperatura', 1078.0000, 'ºC'),
	(156758, 121, '2014-01-15 00:36:26.000000', 'temperatura', 894.0000, 'ºC'),
	(156759, 121, '2014-01-15 00:36:27.000000', 'temperatura', 36.0000, 'ºC'),
	(156760, 121, '2014-01-15 00:36:28.000000', 'temperatura', 1099.0000, 'ºC'),
	(156761, 121, '2014-01-15 00:36:29.000000', 'temperatura', 587.0000, 'ºC'),
	(156762, 121, '2014-01-15 00:36:30.000000', 'temperatura', 838.0000, 'ºC'),
	(156763, 121, '2014-01-15 00:36:31.000000', 'temperatura', 31.0000, 'ºC'),
	(156764, 121, '2014-01-15 00:36:32.000000', 'temperatura', 39.0000, 'ºC'),
	(156765, 121, '2014-01-15 00:36:33.000000', 'temperatura', 104.0000, 'ºC'),
	(156766, 121, '2014-01-15 00:36:34.000000', 'temperatura', 403.0000, 'ºC'),
	(156767, 121, '2014-01-15 00:36:35.000000', 'temperatura', 503.0000, 'ºC'),
	(156768, 121, '2014-01-15 00:36:36.000000', 'temperatura', 106.0000, 'ºC'),
	(156769, 121, '2014-01-15 00:36:37.000000', 'temperatura', 220.0000, 'ºC'),
	(156770, 121, '2014-01-15 00:36:38.000000', 'temperatura', 785.0000, 'ºC'),
	(156771, 121, '2014-01-15 00:36:39.000000', 'temperatura', 867.0000, 'ºC'),
	(156772, 121, '2014-01-15 00:36:40.000000', 'temperatura', 779.0000, 'ºC'),
	(156773, 121, '2014-01-15 00:36:41.000000', 'temperatura', 94.0000, 'ºC'),
	(156774, 121, '2014-01-15 00:36:42.000000', 'temperatura', 532.0000, 'ºC'),
	(156775, 121, '2014-01-15 00:36:43.000000', 'temperatura', 1179.0000, 'ºC'),
	(156776, 121, '2014-01-15 00:36:44.000000', 'temperatura', 701.0000, 'ºC'),
	(156777, 121, '2014-01-15 00:36:45.000000', 'temperatura', 1167.0000, 'ºC'),
	(156778, 121, '2014-01-15 00:36:46.000000', 'temperatura', 134.0000, 'ºC'),
	(156779, 121, '2014-01-15 00:36:47.000000', 'temperatura', 770.0000, 'ºC'),
	(156780, 121, '2014-01-15 00:36:48.000000', 'temperatura', 1046.0000, 'ºC'),
	(156781, 121, '2014-01-15 00:36:49.000000', 'temperatura', 523.0000, 'ºC'),
	(156782, 121, '2014-01-15 00:36:50.000000', 'temperatura', 677.0000, 'ºC'),
	(156783, 121, '2014-01-15 00:36:51.000000', 'temperatura', 617.0000, 'ºC'),
	(156784, 121, '2014-01-15 00:36:52.000000', 'temperatura', 1054.0000, 'ºC'),
	(156785, 121, '2014-01-15 00:36:53.000000', 'temperatura', 1018.0000, 'ºC'),
	(156786, 121, '2014-01-15 00:36:54.000000', 'temperatura', 729.0000, 'ºC'),
	(156787, 121, '2014-01-15 00:36:55.000000', 'temperatura', 592.0000, 'ºC'),
	(156788, 121, '2014-01-15 00:36:56.000000', 'temperatura', 774.0000, 'ºC'),
	(156789, 121, '2014-01-15 00:36:57.000000', 'temperatura', 892.0000, 'ºC'),
	(156790, 121, '2014-01-15 00:36:58.000000', 'temperatura', 941.0000, 'ºC'),
	(156791, 121, '2014-01-15 00:36:59.000000', 'temperatura', 829.0000, 'ºC'),
	(156792, 121, '2014-01-15 00:37:00.000000', 'temperatura', 123.0000, 'ºC'),
	(156793, 121, '2014-01-15 00:37:01.000000', 'temperatura', 527.0000, 'ºC'),
	(156794, 121, '2014-01-15 00:37:02.000000', 'temperatura', 1068.0000, 'ºC'),
	(156795, 121, '2014-01-15 00:37:03.000000', 'temperatura', 158.0000, 'ºC'),
	(156796, 121, '2014-01-15 00:37:04.000000', 'temperatura', 1185.0000, 'ºC'),
	(156797, 121, '2014-01-15 00:37:05.000000', 'temperatura', 653.0000, 'ºC'),
	(156798, 121, '2014-01-15 00:37:06.000000', 'temperatura', 912.0000, 'ºC'),
	(156799, 121, '2014-01-15 00:37:07.000000', 'temperatura', 198.0000, 'ºC'),
	(156800, 121, '2014-01-15 00:37:08.000000', 'temperatura', 658.0000, 'ºC'),
	(156801, 121, '2014-01-15 00:37:09.000000', 'temperatura', 294.0000, 'ºC'),
	(156802, 121, '2014-01-15 00:37:10.000000', 'temperatura', 697.0000, 'ºC'),
	(156803, 121, '2014-01-15 00:37:11.000000', 'temperatura', 204.0000, 'ºC'),
	(156804, 121, '2014-01-15 00:37:12.000000', 'temperatura', 128.0000, 'ºC'),
	(156805, 121, '2014-01-15 00:37:13.000000', 'temperatura', 30.0000, 'ºC'),
	(156806, 121, '2014-01-15 00:37:14.000000', 'temperatura', 966.0000, 'ºC'),
	(156807, 121, '2014-01-15 00:37:15.000000', 'temperatura', 1141.0000, 'ºC'),
	(156808, 121, '2014-01-15 00:37:16.000000', 'temperatura', 409.0000, 'ºC'),
	(156809, 121, '2014-01-15 00:37:17.000000', 'temperatura', 1020.0000, 'ºC'),
	(156810, 121, '2014-01-15 00:37:18.000000', 'temperatura', 272.0000, 'ºC'),
	(156811, 121, '2014-01-15 00:37:19.000000', 'temperatura', 703.0000, 'ºC'),
	(156812, 121, '2014-01-15 00:37:20.000000', 'temperatura', 300.0000, 'ºC'),
	(156813, 121, '2014-01-15 00:37:21.000000', 'temperatura', 591.0000, 'ºC'),
	(156814, 121, '2014-01-15 00:37:22.000000', 'temperatura', 855.0000, 'ºC'),
	(156815, 121, '2014-01-15 00:37:23.000000', 'temperatura', 102.0000, 'ºC'),
	(156816, 121, '2014-01-15 00:37:24.000000', 'temperatura', 346.0000, 'ºC'),
	(156817, 121, '2014-01-15 00:37:25.000000', 'temperatura', 226.0000, 'ºC'),
	(156818, 121, '2014-01-15 00:37:26.000000', 'temperatura', 90.0000, 'ºC'),
	(156819, 121, '2014-01-15 00:37:27.000000', 'temperatura', 976.0000, 'ºC'),
	(156820, 121, '2014-01-15 00:37:28.000000', 'temperatura', 1007.0000, 'ºC'),
	(156821, 121, '2014-01-15 00:37:29.000000', 'temperatura', 908.0000, 'ºC'),
	(156822, 121, '2014-01-15 00:37:30.000000', 'temperatura', 319.0000, 'ºC'),
	(156823, 121, '2014-01-15 00:37:31.000000', 'temperatura', 73.0000, 'ºC'),
	(156824, 121, '2014-01-15 00:37:32.000000', 'temperatura', 609.0000, 'ºC'),
	(156825, 121, '2014-01-15 00:37:33.000000', 'temperatura', 428.0000, 'ºC'),
	(156826, 121, '2014-01-15 00:37:34.000000', 'temperatura', 310.0000, 'ºC'),
	(156827, 121, '2014-01-15 00:37:35.000000', 'temperatura', 268.0000, 'ºC'),
	(156828, 121, '2014-01-15 00:37:36.000000', 'temperatura', 409.0000, 'ºC'),
	(156829, 121, '2014-01-15 00:37:37.000000', 'temperatura', 43.0000, 'ºC'),
	(156830, 121, '2014-01-15 00:37:38.000000', 'temperatura', 187.0000, 'ºC'),
	(156831, 121, '2014-01-15 00:37:39.000000', 'temperatura', 808.0000, 'ºC'),
	(156832, 121, '2014-01-15 00:37:40.000000', 'temperatura', 1080.0000, 'ºC'),
	(156833, 121, '2014-01-15 00:37:41.000000', 'temperatura', 574.0000, 'ºC'),
	(156834, 121, '2014-01-15 00:37:42.000000', 'temperatura', 832.0000, 'ºC'),
	(156835, 121, '2014-01-15 00:37:43.000000', 'temperatura', 39.0000, 'ºC'),
	(156836, 121, '2014-01-15 00:37:44.000000', 'temperatura', 98.0000, 'ºC'),
	(156837, 121, '2014-01-15 00:37:45.000000', 'temperatura', 372.0000, 'ºC'),
	(156838, 121, '2014-01-15 00:37:46.000000', 'temperatura', 369.0000, 'ºC'),
	(156839, 121, '2014-01-15 00:37:47.000000', 'temperatura', 727.0000, 'ºC'),
	(156840, 121, '2014-01-15 00:37:48.000000', 'temperatura', 129.0000, 'ºC'),
	(156841, 121, '2014-01-15 00:37:49.000000', 'temperatura', 865.0000, 'ºC'),
	(156842, 121, '2014-01-15 00:37:50.000000', 'temperatura', 337.0000, 'ºC'),
	(156843, 121, '2014-01-15 00:37:51.000000', 'temperatura', 293.0000, 'ºC'),
	(156844, 121, '2014-01-15 00:37:52.000000', 'temperatura', 453.0000, 'ºC'),
	(156845, 121, '2014-01-15 00:37:53.000000', 'temperatura', 185.0000, 'ºC'),
	(156846, 121, '2014-01-15 00:37:54.000000', 'temperatura', 768.0000, 'ºC'),
	(156847, 121, '2014-01-15 00:37:55.000000', 'temperatura', 887.0000, 'ºC'),
	(156848, 121, '2014-01-15 00:37:56.000000', 'temperatura', 930.0000, 'ºC'),
	(156849, 121, '2014-01-15 00:37:57.000000', 'temperatura', 791.0000, 'ºC'),
	(156850, 121, '2014-01-15 00:37:58.000000', 'temperatura', 1165.0000, 'ºC'),
	(156851, 121, '2014-01-15 00:37:59.000000', 'temperatura', 1054.0000, 'ºC'),
	(156852, 121, '2014-01-15 00:38:00.000000', 'temperatura', 572.0000, 'ºC'),
	(156853, 121, '2014-01-15 00:38:01.000000', 'temperatura', 902.0000, 'ºC'),
	(156854, 121, '2014-01-15 00:38:02.000000', 'temperatura', 393.0000, 'ºC'),
	(156855, 121, '2014-01-15 00:38:03.000000', 'temperatura', 461.0000, 'ºC'),
	(156856, 121, '2014-01-15 00:38:04.000000', 'temperatura', 1126.0000, 'ºC'),
	(156857, 121, '2014-01-15 00:38:05.000000', 'temperatura', 648.0000, 'ºC'),
	(156858, 121, '2014-01-15 00:38:06.000000', 'temperatura', 1060.0000, 'ºC'),
	(156859, 121, '2014-01-15 00:38:07.000000', 'temperatura', 959.0000, 'ºC'),
	(156860, 121, '2014-01-15 00:38:08.000000', 'temperatura', 416.0000, 'ºC'),
	(156861, 121, '2014-01-15 00:38:09.000000', 'temperatura', 403.0000, 'ºC'),
	(156862, 121, '2014-01-15 00:38:10.000000', 'temperatura', 769.0000, 'ºC'),
	(156863, 121, '2014-01-15 00:38:11.000000', 'temperatura', 236.0000, 'ºC'),
	(156864, 121, '2014-01-15 00:38:12.000000', 'temperatura', 75.0000, 'ºC'),
	(156865, 121, '2014-01-15 00:38:13.000000', 'temperatura', 866.0000, 'ºC'),
	(156866, 121, '2014-01-15 00:38:14.000000', 'temperatura', 505.0000, 'ºC'),
	(156867, 121, '2014-01-15 00:38:15.000000', 'temperatura', 1128.0000, 'ºC'),
	(156868, 121, '2014-01-15 00:38:16.000000', 'temperatura', 527.0000, 'ºC'),
	(156869, 121, '2014-01-15 00:38:17.000000', 'temperatura', 449.0000, 'ºC'),
	(156870, 121, '2014-01-15 00:38:18.000000', 'temperatura', 666.0000, 'ºC'),
	(156871, 121, '2014-01-15 00:38:19.000000', 'temperatura', 782.0000, 'ºC'),
	(156872, 121, '2014-01-15 00:38:20.000000', 'temperatura', 713.0000, 'ºC'),
	(156873, 121, '2014-01-15 00:38:21.000000', 'temperatura', 20.0000, 'ºC'),
	(156874, 121, '2014-01-15 00:38:22.000000', 'temperatura', 361.0000, 'ºC'),
	(156875, 121, '2014-01-15 00:38:23.000000', 'temperatura', 546.0000, 'ºC'),
	(156876, 121, '2014-01-15 00:38:24.000000', 'temperatura', 445.0000, 'ºC'),
	(156877, 121, '2014-01-15 00:38:25.000000', 'temperatura', 590.0000, 'ºC'),
	(156878, 121, '2014-01-15 00:38:26.000000', 'temperatura', 417.0000, 'ºC'),
	(156879, 121, '2014-01-15 00:38:27.000000', 'temperatura', 313.0000, 'ºC'),
	(156880, 121, '2014-01-15 00:38:28.000000', 'temperatura', 314.0000, 'ºC'),
	(156881, 121, '2014-01-15 00:38:29.000000', 'temperatura', 630.0000, 'ºC'),
	(156882, 121, '2014-01-15 00:38:30.000000', 'temperatura', 1011.0000, 'ºC'),
	(156883, 121, '2014-01-15 00:38:31.000000', 'temperatura', 766.0000, 'ºC'),
	(156884, 121, '2014-01-15 00:38:32.000000', 'temperatura', 795.0000, 'ºC'),
	(156885, 121, '2014-01-15 00:38:33.000000', 'temperatura', 477.0000, 'ºC'),
	(156886, 121, '2014-01-15 00:38:34.000000', 'temperatura', 3.0000, 'ºC'),
	(156887, 121, '2014-01-15 00:38:35.000000', 'temperatura', 984.0000, 'ºC'),
	(156888, 121, '2014-01-15 00:38:36.000000', 'temperatura', 113.0000, 'ºC'),
	(156889, 121, '2014-01-15 00:38:37.000000', 'temperatura', 11.0000, 'ºC'),
	(156890, 121, '2014-01-15 00:38:38.000000', 'temperatura', 915.0000, 'ºC'),
	(156891, 121, '2014-01-15 00:38:39.000000', 'temperatura', 946.0000, 'ºC'),
	(156892, 121, '2014-01-15 00:38:40.000000', 'temperatura', 784.0000, 'ºC'),
	(156893, 121, '2014-01-15 00:38:41.000000', 'temperatura', 1084.0000, 'ºC'),
	(156894, 121, '2014-01-15 00:38:42.000000', 'temperatura', 669.0000, 'ºC'),
	(156895, 121, '2014-01-15 00:38:43.000000', 'temperatura', 94.0000, 'ºC'),
	(156896, 121, '2014-01-15 00:38:44.000000', 'temperatura', 861.0000, 'ºC'),
	(156897, 121, '2014-01-15 00:38:45.000000', 'temperatura', 423.0000, 'ºC'),
	(156898, 121, '2014-01-15 00:38:46.000000', 'temperatura', 734.0000, 'ºC'),
	(156899, 121, '2014-01-15 00:38:47.000000', 'temperatura', 1.0000, 'ºC'),
	(156900, 121, '2014-01-15 00:38:48.000000', 'temperatura', 202.0000, 'ºC'),
	(156901, 121, '2014-01-15 00:38:49.000000', 'temperatura', 1008.0000, 'ºC'),
	(156902, 121, '2014-01-15 00:38:50.000000', 'temperatura', 834.0000, 'ºC'),
	(156903, 121, '2014-01-15 00:38:51.000000', 'temperatura', 1149.0000, 'ºC'),
	(156904, 121, '2014-01-15 00:38:52.000000', 'temperatura', 843.0000, 'ºC'),
	(156905, 121, '2014-01-15 00:38:53.000000', 'temperatura', 767.0000, 'ºC'),
	(156906, 121, '2014-01-15 00:38:54.000000', 'temperatura', 106.0000, 'ºC'),
	(156907, 121, '2014-01-15 00:38:55.000000', 'temperatura', 630.0000, 'ºC'),
	(156908, 121, '2014-01-15 00:38:56.000000', 'temperatura', 435.0000, 'ºC'),
	(156909, 121, '2014-01-15 00:38:57.000000', 'temperatura', 283.0000, 'ºC'),
	(156910, 121, '2014-01-15 00:38:58.000000', 'temperatura', 110.0000, 'ºC'),
	(156911, 121, '2014-01-15 00:38:59.000000', 'temperatura', 902.0000, 'ºC'),
	(156912, 121, '2014-01-15 00:39:00.000000', 'temperatura', 583.0000, 'ºC'),
	(156913, 121, '2014-01-15 00:39:01.000000', 'temperatura', 207.0000, 'ºC'),
	(156914, 121, '2014-01-15 00:39:02.000000', 'temperatura', 486.0000, 'ºC'),
	(156915, 121, '2014-01-15 00:39:03.000000', 'temperatura', 608.0000, 'ºC'),
	(156916, 121, '2014-01-15 00:39:04.000000', 'temperatura', 385.0000, 'ºC'),
	(156917, 121, '2014-01-15 00:39:05.000000', 'temperatura', 101.0000, 'ºC'),
	(156918, 121, '2014-01-15 00:39:06.000000', 'temperatura', 550.0000, 'ºC'),
	(156919, 121, '2014-01-15 00:39:07.000000', 'temperatura', 49.0000, 'ºC'),
	(156920, 121, '2014-01-15 00:39:08.000000', 'temperatura', 996.0000, 'ºC'),
	(156921, 121, '2014-01-15 00:39:09.000000', 'temperatura', 34.0000, 'ºC'),
	(156922, 121, '2014-01-15 00:39:10.000000', 'temperatura', 781.0000, 'ºC'),
	(156923, 121, '2014-01-15 00:39:11.000000', 'temperatura', 205.0000, 'ºC'),
	(156924, 121, '2014-01-15 00:39:12.000000', 'temperatura', 1082.0000, 'ºC'),
	(156925, 121, '2014-01-15 00:39:13.000000', 'temperatura', 1193.0000, 'ºC'),
	(156926, 121, '2014-01-15 00:39:14.000000', 'temperatura', 323.0000, 'ºC'),
	(156927, 121, '2014-01-15 00:39:15.000000', 'temperatura', 433.0000, 'ºC'),
	(156928, 121, '2014-01-15 00:39:16.000000', 'temperatura', 1198.0000, 'ºC'),
	(156929, 121, '2014-01-15 00:39:17.000000', 'temperatura', 1093.0000, 'ºC'),
	(156930, 121, '2014-01-15 00:39:18.000000', 'temperatura', 669.0000, 'ºC'),
	(156931, 121, '2014-01-15 00:39:19.000000', 'temperatura', 66.0000, 'ºC'),
	(156932, 121, '2014-01-15 00:39:20.000000', 'temperatura', 723.0000, 'ºC'),
	(156933, 121, '2014-01-15 00:39:21.000000', 'temperatura', 1020.0000, 'ºC'),
	(156934, 121, '2014-01-15 00:39:22.000000', 'temperatura', 530.0000, 'ºC'),
	(156935, 121, '2014-01-15 00:39:23.000000', 'temperatura', 792.0000, 'ºC'),
	(156936, 121, '2014-01-15 00:39:24.000000', 'temperatura', 1168.0000, 'ºC'),
	(156937, 121, '2014-01-15 00:39:25.000000', 'temperatura', 1065.0000, 'ºC'),
	(156938, 121, '2014-01-15 00:39:26.000000', 'temperatura', 621.0000, 'ºC'),
	(156939, 121, '2014-01-15 00:39:27.000000', 'temperatura', 1109.0000, 'ºC'),
	(156940, 121, '2014-01-15 00:39:28.000000', 'temperatura', 86.0000, 'ºC'),
	(156941, 121, '2014-01-15 00:39:29.000000', 'temperatura', 702.0000, 'ºC'),
	(156942, 121, '2014-01-15 00:39:30.000000', 'temperatura', 854.0000, 'ºC'),
	(156943, 121, '2014-01-15 00:39:31.000000', 'temperatura', 964.0000, 'ºC'),
	(156944, 121, '2014-01-15 00:39:32.000000', 'temperatura', 1058.0000, 'ºC'),
	(156945, 121, '2014-01-15 00:39:33.000000', 'temperatura', 1198.0000, 'ºC'),
	(156946, 121, '2014-01-15 00:39:34.000000', 'temperatura', 419.0000, 'ºC'),
	(156947, 121, '2014-01-15 00:39:35.000000', 'temperatura', 900.0000, 'ºC'),
	(156948, 121, '2014-01-15 00:39:36.000000', 'temperatura', 844.0000, 'ºC'),
	(156949, 121, '2014-01-15 00:39:37.000000', 'temperatura', 318.0000, 'ºC'),
	(156950, 121, '2014-01-15 00:39:38.000000', 'temperatura', 261.0000, 'ºC'),
	(156951, 121, '2014-01-15 00:39:39.000000', 'temperatura', 352.0000, 'ºC'),
	(156952, 121, '2014-01-15 00:39:40.000000', 'temperatura', 978.0000, 'ºC'),
	(156953, 121, '2014-01-15 00:39:41.000000', 'temperatura', 235.0000, 'ºC'),
	(156954, 121, '2014-01-15 00:39:42.000000', 'temperatura', 639.0000, 'ºC'),
	(156955, 121, '2014-01-15 00:39:43.000000', 'temperatura', 92.0000, 'ºC'),
	(156956, 121, '2014-01-15 00:39:44.000000', 'temperatura', 944.0000, 'ºC'),
	(156957, 121, '2014-01-15 00:39:45.000000', 'temperatura', 842.0000, 'ºC'),
	(156958, 121, '2014-01-15 00:39:46.000000', 'temperatura', 180.0000, 'ºC'),
	(156959, 121, '2014-01-15 00:39:47.000000', 'temperatura', 774.0000, 'ºC'),
	(156960, 121, '2014-01-15 00:39:48.000000', 'temperatura', 930.0000, 'ºC'),
	(156961, 121, '2014-01-15 00:39:49.000000', 'temperatura', 1127.0000, 'ºC'),
	(156962, 121, '2014-01-15 00:39:50.000000', 'temperatura', 449.0000, 'ºC'),
	(156963, 121, '2014-01-15 00:39:51.000000', 'temperatura', 62.0000, 'ºC'),
	(156964, 121, '2014-01-15 00:39:52.000000', 'temperatura', 166.0000, 'ºC'),
	(156965, 121, '2014-01-15 00:39:53.000000', 'temperatura', 642.0000, 'ºC'),
	(156966, 121, '2014-01-15 00:39:54.000000', 'temperatura', 311.0000, 'ºC'),
	(156967, 121, '2014-01-15 00:39:55.000000', 'temperatura', 833.0000, 'ºC'),
	(156968, 121, '2014-01-15 00:39:56.000000', 'temperatura', 829.0000, 'ºC'),
	(156969, 121, '2014-01-15 00:39:57.000000', 'temperatura', 449.0000, 'ºC'),
	(156970, 121, '2014-01-15 00:39:58.000000', 'temperatura', 957.0000, 'ºC'),
	(156971, 121, '2014-01-15 00:39:59.000000', 'temperatura', 1040.0000, 'ºC'),
	(156972, 121, '2014-01-15 00:40:00.000000', 'temperatura', 1130.0000, 'ºC'),
	(156973, 121, '2014-01-15 00:40:01.000000', 'temperatura', 129.0000, 'ºC'),
	(156974, 121, '2014-01-15 00:40:02.000000', 'temperatura', 858.0000, 'ºC'),
	(156975, 121, '2014-01-15 00:40:03.000000', 'temperatura', 302.0000, 'ºC'),
	(156976, 121, '2014-01-15 00:40:04.000000', 'temperatura', 137.0000, 'ºC'),
	(156977, 121, '2014-01-15 00:40:05.000000', 'temperatura', 981.0000, 'ºC'),
	(156978, 121, '2014-01-15 00:40:06.000000', 'temperatura', 892.0000, 'ºC'),
	(156979, 121, '2014-01-15 00:40:07.000000', 'temperatura', 318.0000, 'ºC'),
	(156980, 121, '2014-01-15 00:40:08.000000', 'temperatura', 116.0000, 'ºC'),
	(156981, 121, '2014-01-15 00:40:09.000000', 'temperatura', 824.0000, 'ºC'),
	(156982, 121, '2014-01-15 00:40:10.000000', 'temperatura', 172.0000, 'ºC'),
	(156983, 121, '2014-01-15 00:40:11.000000', 'temperatura', 792.0000, 'ºC'),
	(156984, 121, '2014-01-15 00:40:12.000000', 'temperatura', 1041.0000, 'ºC'),
	(156985, 121, '2014-01-15 00:40:13.000000', 'temperatura', 432.0000, 'ºC'),
	(156986, 121, '2014-01-15 00:40:14.000000', 'temperatura', 235.0000, 'ºC'),
	(156987, 121, '2014-01-15 00:40:15.000000', 'temperatura', 1079.0000, 'ºC'),
	(156988, 121, '2014-01-15 00:40:16.000000', 'temperatura', 1091.0000, 'ºC'),
	(156989, 121, '2014-01-15 00:40:17.000000', 'temperatura', 1019.0000, 'ºC'),
	(156990, 121, '2014-01-15 00:40:18.000000', 'temperatura', 623.0000, 'ºC'),
	(156991, 121, '2014-01-15 00:40:19.000000', 'temperatura', 59.0000, 'ºC'),
	(156992, 121, '2014-01-15 00:40:20.000000', 'temperatura', 827.0000, 'ºC'),
	(156993, 121, '2014-01-15 00:40:21.000000', 'temperatura', 356.0000, 'ºC'),
	(156994, 121, '2014-01-15 00:40:22.000000', 'temperatura', 500.0000, 'ºC'),
	(156995, 121, '2014-01-15 00:40:23.000000', 'temperatura', 235.0000, 'ºC'),
	(156996, 121, '2014-01-15 00:40:24.000000', 'temperatura', 872.0000, 'ºC'),
	(156997, 121, '2014-01-15 00:40:25.000000', 'temperatura', 58.0000, 'ºC'),
	(156998, 121, '2014-01-15 00:40:26.000000', 'temperatura', 72.0000, 'ºC'),
	(156999, 121, '2014-01-15 00:40:27.000000', 'temperatura', 186.0000, 'ºC'),
	(157000, 121, '2014-01-15 00:40:28.000000', 'temperatura', 717.0000, 'ºC'),
	(157001, 121, '2014-01-15 00:40:29.000000', 'temperatura', 627.0000, 'ºC'),
	(157002, 121, '2014-01-15 00:40:30.000000', 'temperatura', 985.0000, 'ºC'),
	(157003, 121, '2014-01-15 00:40:31.000000', 'temperatura', 642.0000, 'ºC'),
	(157004, 121, '2014-01-15 00:40:32.000000', 'temperatura', 259.0000, 'ºC'),
	(157005, 121, '2014-01-15 00:40:33.000000', 'temperatura', 566.0000, 'ºC'),
	(157006, 121, '2014-01-15 00:40:34.000000', 'temperatura', 855.0000, 'ºC'),
	(157007, 121, '2014-01-15 00:40:35.000000', 'temperatura', 178.0000, 'ºC'),
	(157008, 121, '2014-01-15 00:40:36.000000', 'temperatura', 725.0000, 'ºC'),
	(157009, 121, '2014-01-15 00:40:37.000000', 'temperatura', 691.0000, 'ºC'),
	(157010, 121, '2014-01-15 00:40:38.000000', 'temperatura', 81.0000, 'ºC'),
	(157011, 121, '2014-01-15 00:40:39.000000', 'temperatura', 731.0000, 'ºC'),
	(157012, 121, '2014-01-15 00:40:40.000000', 'temperatura', 1014.0000, 'ºC'),
	(157013, 121, '2014-01-15 00:40:41.000000', 'temperatura', 478.0000, 'ºC'),
	(157014, 121, '2014-01-15 00:40:42.000000', 'temperatura', 546.0000, 'ºC'),
	(157015, 121, '2014-01-15 00:40:43.000000', 'temperatura', 98.0000, 'ºC'),
	(157016, 121, '2014-01-15 00:40:44.000000', 'temperatura', 51.0000, 'ºC'),
	(157017, 121, '2014-01-15 00:40:45.000000', 'temperatura', 1162.0000, 'ºC'),
	(157018, 121, '2014-01-15 00:40:46.000000', 'temperatura', 859.0000, 'ºC'),
	(157019, 121, '2014-01-15 00:40:47.000000', 'temperatura', 810.0000, 'ºC'),
	(157020, 121, '2014-01-15 00:40:48.000000', 'temperatura', 273.0000, 'ºC'),
	(157021, 121, '2014-01-15 00:40:49.000000', 'temperatura', 135.0000, 'ºC'),
	(157022, 121, '2014-01-15 00:40:50.000000', 'temperatura', 1055.0000, 'ºC'),
	(157023, 121, '2014-01-15 00:40:51.000000', 'temperatura', 74.0000, 'ºC'),
	(157024, 121, '2014-01-15 00:40:52.000000', 'temperatura', 803.0000, 'ºC'),
	(157025, 121, '2014-01-15 00:40:53.000000', 'temperatura', 192.0000, 'ºC'),
	(157026, 121, '2014-01-15 00:40:54.000000', 'temperatura', 954.0000, 'ºC'),
	(157027, 121, '2014-01-15 00:40:55.000000', 'temperatura', 596.0000, 'ºC'),
	(157028, 121, '2014-01-15 00:40:56.000000', 'temperatura', 116.0000, 'ºC'),
	(157029, 121, '2014-01-15 00:40:57.000000', 'temperatura', 1194.0000, 'ºC'),
	(157030, 121, '2014-01-15 00:40:58.000000', 'temperatura', 823.0000, 'ºC'),
	(157031, 121, '2014-01-15 00:40:59.000000', 'temperatura', 534.0000, 'ºC'),
	(157032, 121, '2014-01-15 00:41:00.000000', 'temperatura', 200.0000, 'ºC'),
	(157033, 121, '2014-01-15 00:41:01.000000', 'temperatura', 597.0000, 'ºC'),
	(157034, 121, '2014-01-15 00:41:02.000000', 'temperatura', 1188.0000, 'ºC'),
	(157035, 121, '2014-01-15 00:41:03.000000', 'temperatura', 547.0000, 'ºC'),
	(157036, 121, '2014-01-15 00:41:04.000000', 'temperatura', 371.0000, 'ºC'),
	(157037, 121, '2014-01-15 00:41:05.000000', 'temperatura', 216.0000, 'ºC'),
	(157038, 121, '2014-01-15 00:41:06.000000', 'temperatura', 1167.0000, 'ºC'),
	(157039, 121, '2014-01-15 00:41:07.000000', 'temperatura', 390.0000, 'ºC'),
	(157040, 121, '2014-01-15 00:41:08.000000', 'temperatura', 847.0000, 'ºC'),
	(157041, 121, '2014-01-15 00:41:09.000000', 'temperatura', 666.0000, 'ºC'),
	(157042, 121, '2014-01-15 00:41:10.000000', 'temperatura', 791.0000, 'ºC'),
	(157043, 121, '2014-01-15 00:41:11.000000', 'temperatura', 757.0000, 'ºC'),
	(157044, 121, '2014-01-15 00:41:12.000000', 'temperatura', 210.0000, 'ºC'),
	(157045, 121, '2014-01-15 00:41:13.000000', 'temperatura', 1183.0000, 'ºC'),
	(157046, 121, '2014-01-15 00:41:14.000000', 'temperatura', 484.0000, 'ºC'),
	(157047, 121, '2014-01-15 00:41:15.000000', 'temperatura', 70.0000, 'ºC'),
	(157048, 121, '2014-01-15 00:41:16.000000', 'temperatura', 101.0000, 'ºC'),
	(157049, 121, '2014-01-15 00:41:17.000000', 'temperatura', 295.0000, 'ºC'),
	(157050, 121, '2014-01-15 00:41:18.000000', 'temperatura', 1171.0000, 'ºC'),
	(157051, 121, '2014-01-15 00:41:19.000000', 'temperatura', 173.0000, 'ºC'),
	(157052, 121, '2014-01-15 00:41:20.000000', 'temperatura', 952.0000, 'ºC'),
	(157053, 121, '2014-01-15 00:41:21.000000', 'temperatura', 643.0000, 'ºC'),
	(157054, 121, '2014-01-15 00:41:22.000000', 'temperatura', 358.0000, 'ºC'),
	(157055, 121, '2014-01-15 00:41:23.000000', 'temperatura', 1060.0000, 'ºC'),
	(157056, 121, '2014-01-15 00:41:24.000000', 'temperatura', 628.0000, 'ºC'),
	(157057, 121, '2014-01-15 00:41:25.000000', 'temperatura', 1160.0000, 'ºC'),
	(157058, 121, '2014-01-15 00:41:26.000000', 'temperatura', 315.0000, 'ºC'),
	(157059, 121, '2014-01-15 00:41:27.000000', 'temperatura', 498.0000, 'ºC'),
	(157060, 121, '2014-01-15 00:41:28.000000', 'temperatura', 344.0000, 'ºC'),
	(157061, 121, '2014-01-15 00:41:29.000000', 'temperatura', 228.0000, 'ºC'),
	(157062, 121, '2014-01-15 00:41:30.000000', 'temperatura', 107.0000, 'ºC'),
	(157063, 121, '2014-01-15 00:41:31.000000', 'temperatura', 1054.0000, 'ºC'),
	(157064, 121, '2014-01-15 00:41:32.000000', 'temperatura', 149.0000, 'ºC'),
	(157065, 121, '2014-01-15 00:41:33.000000', 'temperatura', 1181.0000, 'ºC'),
	(157066, 121, '2014-01-15 00:41:34.000000', 'temperatura', 661.0000, 'ºC'),
	(157067, 121, '2014-01-15 00:41:35.000000', 'temperatura', 960.0000, 'ºC'),
	(157068, 121, '2014-01-15 00:41:36.000000', 'temperatura', 418.0000, 'ºC'),
	(157069, 121, '2014-01-15 00:41:37.000000', 'temperatura', 409.0000, 'ºC'),
	(157070, 121, '2014-01-15 00:41:38.000000', 'temperatura', 793.0000, 'ºC'),
	(157071, 121, '2014-01-15 00:41:39.000000', 'temperatura', 340.0000, 'ºC'),
	(157072, 121, '2014-01-15 00:41:40.000000', 'temperatura', 522.0000, 'ºC'),
	(157073, 121, '2014-01-15 00:41:41.000000', 'temperatura', 390.0000, 'ºC'),
	(157074, 121, '2014-01-15 00:41:42.000000', 'temperatura', 386.0000, 'ºC'),
	(157075, 121, '2014-01-15 00:41:43.000000', 'temperatura', 760.0000, 'ºC'),
	(157076, 121, '2014-01-15 00:41:44.000000', 'temperatura', 241.0000, 'ºC'),
	(157077, 121, '2014-01-15 00:41:45.000000', 'temperatura', 125.0000, 'ºC'),
	(157078, 121, '2014-01-15 00:41:46.000000', 'temperatura', 1103.0000, 'ºC'),
	(157079, 121, '2014-01-15 00:41:47.000000', 'temperatura', 342.0000, 'ºC'),
	(157080, 121, '2014-01-15 00:41:48.000000', 'temperatura', 798.0000, 'ºC'),
	(157081, 121, '2014-01-15 00:41:49.000000', 'temperatura', 568.0000, 'ºC'),
	(157082, 121, '2014-01-15 00:41:50.000000', 'temperatura', 447.0000, 'ºC'),
	(157083, 121, '2014-01-15 00:41:51.000000', 'temperatura', 529.0000, 'ºC'),
	(157084, 121, '2014-01-15 00:41:52.000000', 'temperatura', 105.0000, 'ºC'),
	(157085, 121, '2014-01-15 00:41:53.000000', 'temperatura', 140.0000, 'ºC'),
	(157086, 121, '2014-01-15 00:41:54.000000', 'temperatura', 384.0000, 'ºC'),
	(157087, 121, '2014-01-15 00:41:55.000000', 'temperatura', 302.0000, 'ºC'),
	(157088, 121, '2014-01-15 00:41:56.000000', 'temperatura', 356.0000, 'ºC'),
	(157089, 121, '2014-01-15 00:41:57.000000', 'temperatura', 878.0000, 'ºC'),
	(157090, 121, '2014-01-15 00:41:58.000000', 'temperatura', 920.0000, 'ºC'),
	(157091, 121, '2014-01-15 00:41:59.000000', 'temperatura', 766.0000, 'ºC'),
	(157092, 121, '2014-01-15 00:42:00.000000', 'temperatura', 1072.0000, 'ºC'),
	(157093, 121, '2014-01-15 00:42:01.000000', 'temperatura', 661.0000, 'ºC'),
	(157094, 121, '2014-01-15 00:42:02.000000', 'temperatura', 89.0000, 'ºC'),
	(157095, 121, '2014-01-15 00:42:03.000000', 'temperatura', 862.0000, 'ºC'),
	(157096, 121, '2014-01-15 00:42:04.000000', 'temperatura', 445.0000, 'ºC'),
	(157097, 121, '2014-01-15 00:42:05.000000', 'temperatura', 840.0000, 'ºC'),
	(157098, 121, '2014-01-15 00:42:06.000000', 'temperatura', 465.0000, 'ºC'),
	(157099, 121, '2014-01-15 00:42:07.000000', 'temperatura', 1006.0000, 'ºC'),
	(157100, 121, '2014-01-15 00:42:08.000000', 'temperatura', 36.0000, 'ºC'),
	(157101, 121, '2014-01-15 00:42:09.000000', 'temperatura', 762.0000, 'ºC'),
	(157102, 121, '2014-01-15 00:42:10.000000', 'temperatura', 104.0000, 'ºC'),
	(157103, 121, '2014-01-15 00:42:11.000000', 'temperatura', 635.0000, 'ºC'),
	(157104, 121, '2014-01-15 00:42:12.000000', 'temperatura', 462.0000, 'ºC'),
	(157105, 121, '2014-01-15 00:42:13.000000', 'temperatura', 404.0000, 'ºC'),
	(157106, 121, '2014-01-15 00:42:14.000000', 'temperatura', 636.0000, 'ºC'),
	(157107, 121, '2014-01-15 00:42:15.000000', 'temperatura', 769.0000, 'ºC'),
	(157108, 121, '2014-01-15 00:42:16.000000', 'temperatura', 738.0000, 'ºC'),
	(157109, 121, '2014-01-15 00:42:17.000000', 'temperatura', 184.0000, 'ºC'),
	(157110, 121, '2014-01-15 00:42:18.000000', 'temperatura', 1105.0000, 'ºC'),
	(157111, 121, '2014-01-15 00:42:19.000000', 'temperatura', 173.0000, 'ºC'),
	(157112, 121, '2014-01-15 00:42:20.000000', 'temperatura', 1152.0000, 'ºC'),
	(157113, 121, '2014-01-15 00:42:21.000000', 'temperatura', 441.0000, 'ºC'),
	(157114, 121, '2014-01-15 00:42:22.000000', 'temperatura', 1148.0000, 'ºC'),
	(157115, 121, '2014-01-15 00:42:23.000000', 'temperatura', 819.0000, 'ºC'),
	(157116, 121, '2014-01-15 00:42:24.000000', 'temperatura', 650.0000, 'ºC'),
	(157117, 121, '2014-01-15 00:42:25.000000', 'temperatura', 795.0000, 'ºC'),
	(157118, 121, '2014-01-15 00:42:26.000000', 'temperatura', 826.0000, 'ºC'),
	(157119, 121, '2014-01-15 00:42:27.000000', 'temperatura', 545.0000, 'ºC'),
	(157120, 121, '2014-01-15 00:42:28.000000', 'temperatura', 249.0000, 'ºC'),
	(157121, 121, '2014-01-15 00:42:29.000000', 'temperatura', 809.0000, 'ºC'),
	(157122, 121, '2014-01-15 00:42:30.000000', 'temperatura', 897.0000, 'ºC'),
	(157123, 121, '2014-01-15 00:42:31.000000', 'temperatura', 859.0000, 'ºC'),
	(157124, 121, '2014-01-15 00:42:32.000000', 'temperatura', 403.0000, 'ºC'),
	(157125, 121, '2014-01-15 00:42:33.000000', 'temperatura', 640.0000, 'ºC'),
	(157126, 121, '2014-01-15 00:42:34.000000', 'temperatura', 791.0000, 'ºC'),
	(157127, 121, '2014-01-15 00:42:35.000000', 'temperatura', 834.0000, 'ºC'),
	(157128, 121, '2014-01-15 00:42:36.000000', 'temperatura', 598.0000, 'ºC'),
	(157129, 121, '2014-01-15 00:42:37.000000', 'temperatura', 489.0000, 'ºC'),
	(157130, 121, '2014-01-15 00:42:38.000000', 'temperatura', 653.0000, 'ºC'),
	(157131, 121, '2014-01-15 00:42:39.000000', 'temperatura', 597.0000, 'ºC'),
	(157132, 121, '2014-01-15 00:42:40.000000', 'temperatura', 1028.0000, 'ºC'),
	(157133, 121, '2014-01-15 00:42:41.000000', 'temperatura', 949.0000, 'ºC'),
	(157134, 121, '2014-01-15 00:42:42.000000', 'temperatura', 461.0000, 'ºC'),
	(157135, 121, '2014-01-15 00:42:43.000000', 'temperatura', 660.0000, 'ºC'),
	(157136, 121, '2014-01-15 00:42:44.000000', 'temperatura', 716.0000, 'ºC'),
	(157137, 121, '2014-01-15 00:42:45.000000', 'temperatura', 403.0000, 'ºC'),
	(157138, 121, '2014-01-15 00:42:46.000000', 'temperatura', 1064.0000, 'ºC'),
	(157139, 121, '2014-01-15 00:42:47.000000', 'temperatura', 514.0000, 'ºC'),
	(157140, 121, '2014-01-15 00:42:48.000000', 'temperatura', 577.0000, 'ºC'),
	(157141, 121, '2014-01-15 00:42:49.000000', 'temperatura', 142.0000, 'ºC'),
	(157142, 121, '2014-01-15 00:42:50.000000', 'temperatura', 181.0000, 'ºC'),
	(157143, 121, '2014-01-15 00:42:51.000000', 'temperatura', 479.0000, 'ºC'),
	(157144, 121, '2014-01-15 00:42:52.000000', 'temperatura', 652.0000, 'ºC'),
	(157145, 121, '2014-01-15 00:42:53.000000', 'temperatura', 624.0000, 'ºC'),
	(157146, 121, '2014-01-15 00:42:54.000000', 'temperatura', 1163.0000, 'ºC'),
	(157147, 121, '2014-01-15 00:42:55.000000', 'temperatura', 343.0000, 'ºC'),
	(157148, 121, '2014-01-15 00:42:56.000000', 'temperatura', 628.0000, 'ºC'),
	(157149, 121, '2014-01-15 00:42:57.000000', 'temperatura', 910.0000, 'ºC'),
	(157150, 121, '2014-01-15 00:42:58.000000', 'temperatura', 267.0000, 'ºC'),
	(157151, 121, '2014-01-15 00:42:59.000000', 'temperatura', 1004.0000, 'ºC'),
	(157152, 121, '2014-01-15 00:43:00.000000', 'temperatura', 622.0000, 'ºC'),
	(157153, 121, '2014-01-15 00:43:01.000000', 'temperatura', 98.0000, 'ºC'),
	(157154, 121, '2014-01-15 00:43:02.000000', 'temperatura', 1024.0000, 'ºC'),
	(157155, 121, '2014-01-15 00:43:03.000000', 'temperatura', 25.0000, 'ºC'),
	(157156, 121, '2014-01-15 00:43:04.000000', 'temperatura', 653.0000, 'ºC'),
	(157157, 121, '2014-01-15 00:43:05.000000', 'temperatura', 794.0000, 'ºC'),
	(157158, 121, '2014-01-15 00:43:06.000000', 'temperatura', 809.0000, 'ºC'),
	(157159, 121, '2014-01-15 00:43:07.000000', 'temperatura', 463.0000, 'ºC'),
	(157160, 121, '2014-01-15 00:43:08.000000', 'temperatura', 1087.0000, 'ºC'),
	(157161, 121, '2014-01-15 00:43:09.000000', 'temperatura', 450.0000, 'ºC'),
	(157162, 121, '2014-01-15 00:43:10.000000', 'temperatura', 189.0000, 'ºC'),
	(157163, 121, '2014-01-15 00:43:11.000000', 'temperatura', 793.0000, 'ºC'),
	(157164, 121, '2014-01-15 00:43:12.000000', 'temperatura', 1001.0000, 'ºC'),
	(157165, 121, '2014-01-15 00:43:13.000000', 'temperatura', 225.0000, 'ºC'),
	(157166, 121, '2014-01-15 00:43:14.000000', 'temperatura', 522.0000, 'ºC'),
	(157167, 121, '2014-01-15 00:43:15.000000', 'temperatura', 736.0000, 'ºC'),
	(157168, 121, '2014-01-15 00:43:16.000000', 'temperatura', 913.0000, 'ºC'),
	(157169, 121, '2014-01-15 00:43:17.000000', 'temperatura', 1159.0000, 'ºC'),
	(157170, 121, '2014-01-15 00:43:18.000000', 'temperatura', 656.0000, 'ºC'),
	(157171, 121, '2014-01-15 00:43:19.000000', 'temperatura', 1005.0000, 'ºC'),
	(157172, 121, '2014-01-15 00:43:20.000000', 'temperatura', 655.0000, 'ºC'),
	(157173, 121, '2014-01-15 00:43:21.000000', 'temperatura', 263.0000, 'ºC'),
	(157174, 121, '2014-01-15 00:43:22.000000', 'temperatura', 548.0000, 'ºC'),
	(157175, 121, '2014-01-15 00:43:23.000000', 'temperatura', 754.0000, 'ºC'),
	(157176, 121, '2014-01-15 00:43:24.000000', 'temperatura', 926.0000, 'ºC'),
	(157177, 121, '2014-01-15 00:43:25.000000', 'temperatura', 1168.0000, 'ºC'),
	(157178, 121, '2014-01-15 00:43:26.000000', 'temperatura', 664.0000, 'ºC'),
	(157179, 121, '2014-01-15 00:43:27.000000', 'temperatura', 1017.0000, 'ºC'),
	(157180, 121, '2014-01-15 00:43:28.000000', 'temperatura', 693.0000, 'ºC'),
	(157181, 121, '2014-01-15 00:43:29.000000', 'temperatura', 412.0000, 'ºC'),
	(157182, 121, '2014-01-15 00:43:30.000000', 'temperatura', 1184.0000, 'ºC'),
	(157183, 121, '2014-01-15 00:43:31.000000', 'temperatura', 1086.0000, 'ºC'),
	(157184, 121, '2014-01-15 00:43:32.000000', 'temperatura', 677.0000, 'ºC'),
	(157185, 121, '2014-01-15 00:43:33.000000', 'temperatura', 125.0000, 'ºC'),
	(157186, 121, '2014-01-15 00:43:34.000000', 'temperatura', 998.0000, 'ºC'),
	(157187, 121, '2014-01-15 00:43:35.000000', 'temperatura', 1014.0000, 'ºC'),
	(157188, 121, '2014-01-15 00:43:36.000000', 'temperatura', 875.0000, 'ºC'),
	(157189, 121, '2014-01-15 00:43:37.000000', 'temperatura', 134.0000, 'ºC'),
	(157190, 121, '2014-01-15 00:43:38.000000', 'temperatura', 445.0000, 'ºC'),
	(157191, 121, '2014-01-15 00:43:39.000000', 'temperatura', 622.0000, 'ºC'),
	(157192, 121, '2014-01-15 00:43:40.000000', 'temperatura', 578.0000, 'ºC'),
	(157193, 121, '2014-01-15 00:43:41.000000', 'temperatura', 1026.0000, 'ºC'),
	(157194, 121, '2014-01-15 00:43:42.000000', 'temperatura', 995.0000, 'ºC'),
	(157195, 121, '2014-01-15 00:43:43.000000', 'temperatura', 696.0000, 'ºC'),
	(157196, 121, '2014-01-15 00:43:44.000000', 'temperatura', 494.0000, 'ºC'),
	(157197, 121, '2014-01-15 00:43:45.000000', 'temperatura', 386.0000, 'ºC'),
	(157198, 121, '2014-01-15 00:43:46.000000', 'temperatura', 447.0000, 'ºC'),
	(157199, 121, '2014-01-15 00:43:47.000000', 'temperatura', 1078.0000, 'ºC'),
	(157200, 121, '2014-01-15 00:43:48.000000', 'temperatura', 451.0000, 'ºC'),
	(157201, 121, '2014-01-15 00:43:49.000000', 'temperatura', 219.0000, 'ºC'),
	(157202, 121, '2014-01-15 00:43:50.000000', 'temperatura', 945.0000, 'ºC'),
	(157203, 121, '2014-01-15 00:43:51.000000', 'temperatura', 465.0000, 'ºC'),
	(157204, 121, '2014-01-15 00:43:52.000000', 'temperatura', 694.0000, 'ºC'),
	(157205, 121, '2014-01-15 00:43:53.000000', 'temperatura', 872.0000, 'ºC'),
	(157206, 121, '2014-01-15 00:43:54.000000', 'temperatura', 1082.0000, 'ºC'),
	(157207, 121, '2014-01-15 00:43:55.000000', 'temperatura', 391.0000, 'ºC'),
	(157208, 121, '2014-01-15 00:43:56.000000', 'temperatura', 1113.0000, 'ºC'),
	(157209, 121, '2014-01-15 00:43:57.000000', 'temperatura', 790.0000, 'ºC'),
	(157210, 121, '2014-01-15 00:43:58.000000', 'temperatura', 611.0000, 'ºC'),
	(157211, 121, '2014-01-15 00:43:59.000000', 'temperatura', 688.0000, 'ºC'),
	(157212, 121, '2014-01-15 00:44:00.000000', 'temperatura', 406.0000, 'ºC'),
	(157213, 121, '2014-01-15 00:44:01.000000', 'temperatura', 1168.0000, 'ºC'),
	(157214, 121, '2014-01-15 00:44:02.000000', 'temperatura', 1024.0000, 'ºC'),
	(157215, 121, '2014-01-15 00:44:03.000000', 'temperatura', 413.0000, 'ºC'),
	(157216, 121, '2014-01-15 00:44:04.000000', 'temperatura', 197.0000, 'ºC'),
	(157217, 121, '2014-01-15 00:44:05.000000', 'temperatura', 943.0000, 'ºC'),
	(157218, 121, '2014-01-15 00:44:06.000000', 'temperatura', 528.0000, 'ºC'),
	(157219, 121, '2014-01-15 00:44:07.000000', 'temperatura', 1009.0000, 'ºC'),
	(157220, 121, '2014-01-15 00:44:08.000000', 'temperatura', 1064.0000, 'ºC'),
	(157221, 121, '2014-01-15 00:44:09.000000', 'temperatura', 1091.0000, 'ºC'),
	(157222, 121, '2014-01-15 00:44:10.000000', 'temperatura', 1064.0000, 'ºC'),
	(157223, 121, '2014-01-15 00:44:11.000000', 'temperatura', 846.0000, 'ºC'),
	(157224, 121, '2014-01-15 00:44:12.000000', 'temperatura', 1041.0000, 'ºC'),
	(157225, 121, '2014-01-15 00:44:13.000000', 'temperatura', 266.0000, 'ºC'),
	(157226, 121, '2014-01-15 00:44:14.000000', 'temperatura', 607.0000, 'ºC'),
	(157227, 121, '2014-01-15 00:44:15.000000', 'temperatura', 1037.0000, 'ºC'),
	(157228, 121, '2014-01-15 00:44:16.000000', 'temperatura', 966.0000, 'ºC'),
	(157229, 121, '2014-01-15 00:44:17.000000', 'temperatura', 519.0000, 'ºC'),
	(157230, 121, '2014-01-15 00:44:18.000000', 'temperatura', 898.0000, 'ºC'),
	(157231, 121, '2014-01-15 00:44:19.000000', 'temperatura', 534.0000, 'ºC'),
	(157232, 121, '2014-01-15 00:44:20.000000', 'temperatura', 1175.0000, 'ºC'),
	(157233, 121, '2014-01-15 00:44:21.000000', 'temperatura', 676.0000, 'ºC'),
	(157234, 121, '2014-01-15 00:44:22.000000', 'temperatura', 1053.0000, 'ºC'),
	(157235, 121, '2014-01-15 00:44:23.000000', 'temperatura', 839.0000, 'ºC'),
	(157236, 121, '2014-01-15 00:44:24.000000', 'temperatura', 1035.0000, 'ºC'),
	(157237, 121, '2014-01-15 00:44:25.000000', 'temperatura', 259.0000, 'ºC'),
	(157238, 121, '2014-01-15 00:44:26.000000', 'temperatura', 589.0000, 'ºC'),
	(157239, 121, '2014-01-15 00:44:27.000000', 'temperatura', 971.0000, 'ºC'),
	(157240, 121, '2014-01-15 00:44:28.000000', 'temperatura', 687.0000, 'ºC'),
	(157241, 121, '2014-01-15 00:44:29.000000', 'temperatura', 523.0000, 'ºC'),
	(157242, 121, '2014-01-15 00:44:30.000000', 'temperatura', 555.0000, 'ºC'),
	(157243, 121, '2014-01-15 00:44:31.000000', 'temperatura', 5.0000, 'ºC'),
	(157244, 121, '2014-01-15 00:44:32.000000', 'temperatura', 763.0000, 'ºC'),
	(157245, 121, '2014-01-15 00:44:33.000000', 'temperatura', 199.0000, 'ºC'),
	(157246, 121, '2014-01-15 00:44:34.000000', 'temperatura', 1108.0000, 'ºC'),
	(157247, 121, '2014-01-15 00:44:35.000000', 'temperatura', 142.0000, 'ºC'),
	(157248, 121, '2014-01-15 00:44:36.000000', 'temperatura', 988.0000, 'ºC'),
	(157249, 121, '2014-01-15 00:44:37.000000', 'temperatura', 914.0000, 'ºC'),
	(157250, 121, '2014-01-15 00:44:38.000000', 'temperatura', 406.0000, 'ºC'),
	(157251, 121, '2014-01-15 00:44:39.000000', 'temperatura', 491.0000, 'ºC'),
	(157252, 121, '2014-01-15 00:44:40.000000', 'temperatura', 35.0000, 'ºC'),
	(157253, 121, '2014-01-15 00:44:41.000000', 'temperatura', 1103.0000, 'ºC'),
	(157254, 121, '2014-01-15 00:44:42.000000', 'temperatura', 612.0000, 'ºC'),
	(157255, 121, '2014-01-15 00:44:43.000000', 'temperatura', 949.0000, 'ºC'),
	(157256, 121, '2014-01-15 00:44:44.000000', 'temperatura', 512.0000, 'ºC'),
	(157257, 121, '2014-01-15 00:44:45.000000', 'temperatura', 914.0000, 'ºC'),
	(157258, 121, '2014-01-15 00:44:46.000000', 'temperatura', 633.0000, 'ºC'),
	(157259, 121, '2014-01-15 00:44:47.000000', 'temperatura', 423.0000, 'ºC'),
	(157260, 121, '2014-01-15 00:44:48.000000', 'temperatura', 219.0000, 'ºC'),
	(157261, 121, '2014-01-15 00:44:49.000000', 'temperatura', 1024.0000, 'ºC'),
	(157262, 121, '2014-01-15 00:44:50.000000', 'temperatura', 864.0000, 'ºC'),
	(157263, 121, '2014-01-15 00:44:51.000000', 'temperatura', 47.0000, 'ºC'),
	(157264, 121, '2014-01-15 00:44:52.000000', 'temperatura', 44.0000, 'ºC'),
	(157265, 121, '2014-01-15 00:44:53.000000', 'temperatura', 79.0000, 'ºC'),
	(157266, 121, '2014-01-15 00:44:54.000000', 'temperatura', 263.0000, 'ºC'),
	(157267, 121, '2014-01-15 00:44:55.000000', 'temperatura', 1077.0000, 'ºC'),
	(157268, 121, '2014-01-15 00:44:56.000000', 'temperatura', 999.0000, 'ºC'),
	(157269, 121, '2014-01-15 00:44:57.000000', 'temperatura', 565.0000, 'ºC'),
	(157270, 121, '2014-01-15 00:44:58.000000', 'temperatura', 1026.0000, 'ºC'),
	(157271, 121, '2014-01-15 00:44:59.000000', 'temperatura', 1037.0000, 'ºC'),
	(157272, 121, '2014-01-15 00:45:00.000000', 'temperatura', 907.0000, 'ºC'),
	(157273, 121, '2014-01-15 00:45:01.000000', 'temperatura', 226.0000, 'ºC'),
	(157274, 121, '2014-01-15 00:45:02.000000', 'temperatura', 808.0000, 'ºC'),
	(157275, 121, '2014-01-15 00:45:03.000000', 'temperatura', 962.0000, 'ºC'),
	(157276, 121, '2014-01-15 00:45:04.000000', 'temperatura', 1187.0000, 'ºC'),
	(157277, 121, '2014-01-15 00:45:05.000000', 'temperatura', 648.0000, 'ºC'),
	(157278, 121, '2014-01-15 00:45:06.000000', 'temperatura', 881.0000, 'ºC'),
	(157279, 121, '2014-01-15 00:45:07.000000', 'temperatura', 61.0000, 'ºC'),
	(157280, 121, '2014-01-15 00:45:08.000000', 'temperatura', 63.0000, 'ºC'),
	(157281, 121, '2014-01-15 00:45:09.000000', 'temperatura', 134.0000, 'ºC'),
	(157282, 121, '2014-01-15 00:45:10.000000', 'temperatura', 479.0000, 'ºC'),
	(157283, 121, '2014-01-15 00:45:11.000000', 'temperatura', 793.0000, 'ºC'),
	(157284, 121, '2014-01-15 00:45:12.000000', 'temperatura', 131.0000, 'ºC'),
	(157285, 121, '2014-01-15 00:45:13.000000', 'temperatura', 674.0000, 'ºC'),
	(157286, 121, '2014-01-15 00:45:14.000000', 'temperatura', 578.0000, 'ºC'),
	(157287, 121, '2014-01-15 00:45:15.000000', 'temperatura', 870.0000, 'ºC'),
	(157288, 121, '2014-01-15 00:45:16.000000', 'temperatura', 215.0000, 'ºC'),
	(157289, 121, '2014-01-15 00:45:17.000000', 'temperatura', 867.0000, 'ºC'),
	(157290, 121, '2014-01-15 00:45:18.000000', 'temperatura', 89.0000, 'ºC'),
	(157291, 121, '2014-01-15 00:45:19.000000', 'temperatura', 245.0000, 'ºC'),
	(157292, 121, '2014-01-15 00:45:20.000000', 'temperatura', 960.0000, 'ºC'),
	(157293, 121, '2014-01-15 00:45:21.000000', 'temperatura', 464.0000, 'ºC'),
	(157294, 121, '2014-01-15 00:45:22.000000', 'temperatura', 641.0000, 'ºC'),
	(157295, 121, '2014-01-15 00:45:23.000000', 'temperatura', 615.0000, 'ºC'),
	(157296, 121, '2014-01-15 00:45:24.000000', 'temperatura', 1152.0000, 'ºC'),
	(157297, 121, '2014-01-15 00:45:25.000000', 'temperatura', 315.0000, 'ºC'),
	(157298, 121, '2014-01-15 00:45:26.000000', 'temperatura', 517.0000, 'ºC'),
	(157299, 121, '2014-01-15 00:45:27.000000', 'temperatura', 444.0000, 'ºC'),
	(157300, 121, '2014-01-15 00:45:28.000000', 'temperatura', 669.0000, 'ºC'),
	(157301, 121, '2014-01-15 00:45:29.000000', 'temperatura', 813.0000, 'ºC'),
	(157302, 121, '2014-01-15 00:45:30.000000', 'temperatura', 858.0000, 'ºC'),
	(157303, 121, '2014-01-15 00:45:31.000000', 'temperatura', 652.0000, 'ºC'),
	(157304, 121, '2014-01-15 00:45:32.000000', 'temperatura', 684.0000, 'ºC'),
	(157305, 121, '2014-01-15 00:45:33.000000', 'temperatura', 268.0000, 'ºC'),
	(157306, 121, '2014-01-15 00:45:34.000000', 'temperatura', 487.0000, 'ºC'),
	(157307, 121, '2014-01-15 00:45:35.000000', 'temperatura', 430.0000, 'ºC'),
	(157308, 121, '2014-01-15 00:45:36.000000', 'temperatura', 691.0000, 'ºC'),
	(157309, 121, '2014-01-15 00:45:37.000000', 'temperatura', 965.0000, 'ºC'),
	(157310, 121, '2014-01-15 00:45:38.000000', 'temperatura', 355.0000, 'ºC'),
	(157311, 121, '2014-01-15 00:45:39.000000', 'temperatura', 78.0000, 'ºC'),
	(157312, 121, '2014-01-15 00:45:40.000000', 'temperatura', 525.0000, 'ºC'),
	(157313, 121, '2014-01-15 00:45:41.000000', 'temperatura', 1192.0000, 'ºC'),
	(157314, 121, '2014-01-15 00:45:42.000000', 'temperatura', 784.0000, 'ºC'),
	(157315, 121, '2014-01-15 00:45:43.000000', 'temperatura', 346.0000, 'ºC'),
	(157316, 121, '2014-01-15 00:45:44.000000', 'temperatura', 579.0000, 'ºC'),
	(157317, 121, '2014-01-15 00:45:45.000000', 'temperatura', 656.0000, 'ºC'),
	(157318, 121, '2014-01-15 00:45:46.000000', 'temperatura', 344.0000, 'ºC'),
	(157319, 121, '2014-01-15 00:45:47.000000', 'temperatura', 951.0000, 'ºC'),
	(157320, 121, '2014-01-15 00:45:48.000000', 'temperatura', 123.0000, 'ºC'),
	(157321, 121, '2014-01-15 00:45:49.000000', 'temperatura', 163.0000, 'ºC'),
	(157322, 121, '2014-01-15 00:45:50.000000', 'temperatura', 447.0000, 'ºC'),
	(157323, 121, '2014-01-15 00:45:51.000000', 'temperatura', 546.0000, 'ºC'),
	(157324, 121, '2014-01-15 00:45:52.000000', 'temperatura', 191.0000, 'ºC'),
	(157325, 121, '2014-01-15 00:45:53.000000', 'temperatura', 517.0000, 'ºC'),
	(157326, 121, '2014-01-15 00:45:54.000000', 'temperatura', 814.0000, 'ºC'),
	(157327, 121, '2014-01-15 00:45:55.000000', 'temperatura', 117.0000, 'ºC'),
	(157328, 121, '2014-01-15 00:45:56.000000', 'temperatura', 543.0000, 'ºC'),
	(157329, 121, '2014-01-15 00:45:57.000000', 'temperatura', 1164.0000, 'ºC'),
	(157330, 121, '2014-01-15 00:45:58.000000', 'temperatura', 592.0000, 'ºC'),
	(157331, 121, '2014-01-15 00:45:59.000000', 'temperatura', 667.0000, 'ºC'),
	(157332, 121, '2014-01-15 00:46:00.000000', 'temperatura', 360.0000, 'ºC'),
	(157333, 121, '2014-01-15 00:46:01.000000', 'temperatura', 999.0000, 'ºC'),
	(157334, 121, '2014-01-15 00:46:02.000000', 'temperatura', 316.0000, 'ºC'),
	(157335, 121, '2014-01-15 00:46:03.000000', 'temperatura', 982.0000, 'ºC'),
	(157336, 121, '2014-01-15 00:46:04.000000', 'temperatura', 362.0000, 'ºC'),
	(157337, 121, '2014-01-15 00:46:05.000000', 'temperatura', 65.0000, 'ºC'),
	(157338, 121, '2014-01-15 00:46:06.000000', 'temperatura', 441.0000, 'ºC'),
	(157339, 121, '2014-01-15 00:46:07.000000', 'temperatura', 811.0000, 'ºC'),
	(157340, 121, '2014-01-15 00:46:08.000000', 'temperatura', 332.0000, 'ºC'),
	(157341, 121, '2014-01-15 00:46:09.000000', 'temperatura', 429.0000, 'ºC'),
	(157342, 121, '2014-01-15 00:46:10.000000', 'temperatura', 1146.0000, 'ºC'),
	(157343, 121, '2014-01-15 00:46:11.000000', 'temperatura', 846.0000, 'ºC'),
	(157344, 121, '2014-01-15 00:46:12.000000', 'temperatura', 792.0000, 'ºC'),
	(157345, 121, '2014-01-15 00:46:13.000000', 'temperatura', 221.0000, 'ºC'),
	(157346, 121, '2014-01-15 00:46:14.000000', 'temperatura', 1132.0000, 'ºC'),
	(157347, 121, '2014-01-15 00:46:15.000000', 'temperatura', 195.0000, 'ºC'),
	(157348, 121, '2014-01-15 00:46:16.000000', 'temperatura', 1182.0000, 'ºC'),
	(157349, 121, '2014-01-15 00:46:17.000000', 'temperatura', 526.0000, 'ºC'),
	(157350, 121, '2014-01-15 00:46:18.000000', 'temperatura', 284.0000, 'ºC'),
	(157351, 121, '2014-01-15 00:46:19.000000', 'temperatura', 1043.0000, 'ºC'),
	(157352, 121, '2014-01-15 00:46:20.000000', 'temperatura', 762.0000, 'ºC'),
	(157353, 121, '2014-01-15 00:46:21.000000', 'temperatura', 684.0000, 'ºC'),
	(157354, 121, '2014-01-15 00:46:22.000000', 'temperatura', 1134.0000, 'ºC'),
	(157355, 121, '2014-01-15 00:46:23.000000', 'temperatura', 17.0000, 'ºC'),
	(157356, 121, '2014-01-15 00:46:24.000000', 'temperatura', 284.0000, 'ºC'),
	(157357, 121, '2014-01-15 00:46:25.000000', 'temperatura', 168.0000, 'ºC'),
	(157358, 121, '2014-01-15 00:46:26.000000', 'temperatura', 1191.0000, 'ºC'),
	(157359, 121, '2014-01-15 00:46:27.000000', 'temperatura', 649.0000, 'ºC'),
	(157360, 121, '2014-01-15 00:46:28.000000', 'temperatura', 875.0000, 'ºC'),
	(157361, 121, '2014-01-15 00:46:29.000000', 'temperatura', 27.0000, 'ºC'),
	(157362, 121, '2014-01-15 00:46:30.000000', 'temperatura', 1109.0000, 'ºC'),
	(157363, 121, '2014-01-15 00:46:31.000000', 'temperatura', 666.0000, 'ºC'),
	(157364, 121, '2014-01-15 00:46:32.000000', 'temperatura', 2.0000, 'ºC'),
	(157365, 121, '2014-01-15 00:46:33.000000', 'temperatura', 413.0000, 'ºC'),
	(157366, 121, '2014-01-15 00:46:34.000000', 'temperatura', 861.0000, 'ºC'),
	(157367, 121, '2014-01-15 00:46:35.000000', 'temperatura', 668.0000, 'ºC'),
	(157368, 121, '2014-01-15 00:46:36.000000', 'temperatura', 754.0000, 'ºC'),
	(157369, 121, '2014-01-15 00:46:37.000000', 'temperatura', 569.0000, 'ºC'),
	(157370, 121, '2014-01-15 00:46:38.000000', 'temperatura', 584.0000, 'ºC'),
	(157371, 121, '2014-01-15 00:46:39.000000', 'temperatura', 12.0000, 'ºC'),
	(157372, 121, '2014-01-15 00:46:40.000000', 'temperatura', 710.0000, 'ºC'),
	(157373, 121, '2014-01-15 00:46:41.000000', 'temperatura', 1112.0000, 'ºC'),
	(157374, 121, '2014-01-15 00:46:42.000000', 'temperatura', 1033.0000, 'ºC'),
	(157375, 121, '2014-01-15 00:46:43.000000', 'temperatura', 630.0000, 'ºC'),
	(157376, 121, '2014-01-15 00:46:44.000000', 'temperatura', 50.0000, 'ºC'),
	(157377, 121, '2014-01-15 00:46:45.000000', 'temperatura', 763.0000, 'ºC'),
	(157378, 121, '2014-01-15 00:46:46.000000', 'temperatura', 63.0000, 'ºC'),
	(157379, 121, '2014-01-15 00:46:47.000000', 'temperatura', 425.0000, 'ºC'),
	(157380, 121, '2014-01-15 00:46:48.000000', 'temperatura', 740.0000, 'ºC'),
	(157381, 121, '2014-01-15 00:46:49.000000', 'temperatura', 25.0000, 'ºC'),
	(157382, 121, '2014-01-15 00:46:50.000000', 'temperatura', 304.0000, 'ºC'),
	(157383, 121, '2014-01-15 00:46:51.000000', 'temperatura', 244.0000, 'ºC'),
	(157384, 121, '2014-01-15 00:46:52.000000', 'temperatura', 312.0000, 'ºC'),
	(157385, 121, '2014-01-15 00:46:53.000000', 'temperatura', 825.0000, 'ºC'),
	(157386, 121, '2014-01-15 00:46:54.000000', 'temperatura', 793.0000, 'ºC'),
	(157387, 121, '2014-01-15 00:46:55.000000', 'temperatura', 288.0000, 'ºC'),
	(157388, 121, '2014-01-15 00:46:56.000000', 'temperatura', 264.0000, 'ºC'),
	(157389, 121, '2014-01-15 00:46:57.000000', 'temperatura', 455.0000, 'ºC'),
	(157390, 121, '2014-01-15 00:46:58.000000', 'temperatura', 284.0000, 'ºC'),
	(157391, 121, '2014-01-15 00:46:59.000000', 'temperatura', 56.0000, 'ºC'),
	(157392, 121, '2014-01-15 00:47:00.000000', 'temperatura', 627.0000, 'ºC'),
	(157393, 121, '2014-01-15 00:47:01.000000', 'temperatura', 567.0000, 'ºC'),
	(157394, 121, '2014-01-15 00:47:02.000000', 'temperatura', 957.0000, 'ºC'),
	(157395, 121, '2014-01-15 00:47:03.000000', 'temperatura', 684.0000, 'ºC'),
	(157396, 121, '2014-01-15 00:47:04.000000', 'temperatura', 548.0000, 'ºC'),
	(157397, 121, '2014-01-15 00:47:05.000000', 'temperatura', 688.0000, 'ºC'),
	(157398, 121, '2014-01-15 00:47:06.000000', 'temperatura', 597.0000, 'ºC'),
	(157399, 121, '2014-01-15 00:47:07.000000', 'temperatura', 922.0000, 'ºC'),
	(157400, 121, '2014-01-15 00:47:08.000000', 'temperatura', 420.0000, 'ºC'),
	(157401, 121, '2014-01-15 00:47:09.000000', 'temperatura', 534.0000, 'ºC'),
	(157402, 121, '2014-01-15 00:47:10.000000', 'temperatura', 212.0000, 'ºC'),
	(157403, 121, '2014-01-15 00:47:11.000000', 'temperatura', 656.0000, 'ºC'),
	(157404, 121, '2014-01-15 00:47:12.000000', 'temperatura', 245.0000, 'ºC'),
	(157405, 121, '2014-01-15 00:47:13.000000', 'temperatura', 460.0000, 'ºC'),
	(157406, 121, '2014-01-15 00:47:14.000000', 'temperatura', 364.0000, 'ºC'),
	(157407, 121, '2014-01-15 00:47:15.000000', 'temperatura', 440.0000, 'ºC'),
	(157408, 121, '2014-01-15 00:47:16.000000', 'temperatura', 1107.0000, 'ºC'),
	(157409, 121, '2014-01-15 00:47:17.000000', 'temperatura', 619.0000, 'ºC'),
	(157410, 121, '2014-01-15 00:47:18.000000', 'temperatura', 971.0000, 'ºC'),
	(157411, 121, '2014-01-15 00:47:19.000000', 'temperatura', 600.0000, 'ºC'),
	(157412, 121, '2014-01-15 00:47:20.000000', 'temperatura', 89.0000, 'ºC'),
	(157413, 121, '2014-01-15 00:47:21.000000', 'temperatura', 1046.0000, 'ºC'),
	(157414, 121, '2014-01-15 00:47:22.000000', 'temperatura', 161.0000, 'ºC'),
	(157415, 121, '2014-01-15 00:47:23.000000', 'temperatura', 70.0000, 'ºC'),
	(157416, 121, '2014-01-15 00:47:24.000000', 'temperatura', 1066.0000, 'ºC'),
	(157417, 121, '2014-01-15 00:47:25.000000', 'temperatura', 320.0000, 'ºC'),
	(157418, 121, '2014-01-15 00:47:26.000000', 'temperatura', 803.0000, 'ºC'),
	(157419, 121, '2014-01-15 00:47:27.000000', 'temperatura', 655.0000, 'ºC'),
	(157420, 121, '2014-01-15 00:47:28.000000', 'temperatura', 869.0000, 'ºC'),
	(157421, 121, '2014-01-15 00:47:29.000000', 'temperatura', 1178.0000, 'ºC'),
	(157422, 121, '2014-01-15 00:47:30.000000', 'temperatura', 885.0000, 'ºC'),
	(157423, 121, '2014-01-15 00:47:31.000000', 'temperatura', 889.0000, 'ºC'),
	(157424, 121, '2014-01-15 00:47:32.000000', 'temperatura', 594.0000, 'ºC'),
	(157425, 121, '2014-01-15 00:47:33.000000', 'temperatura', 301.0000, 'ºC'),
	(157426, 121, '2014-01-15 00:47:34.000000', 'temperatura', 924.0000, 'ºC'),
	(157427, 121, '2014-01-15 00:47:35.000000', 'temperatura', 119.0000, 'ºC'),
	(157428, 121, '2014-01-15 00:47:36.000000', 'temperatura', 222.0000, 'ºC'),
	(157429, 121, '2014-01-15 00:47:37.000000', 'temperatura', 755.0000, 'ºC'),
	(157430, 121, '2014-01-15 00:47:38.000000', 'temperatura', 710.0000, 'ºC'),
	(157431, 121, '2014-01-15 00:47:39.000000', 'temperatura', 85.0000, 'ºC'),
	(157432, 121, '2014-01-15 00:47:40.000000', 'temperatura', 697.0000, 'ºC'),
	(157433, 121, '2014-01-15 00:47:41.000000', 'temperatura', 830.0000, 'ºC'),
	(157434, 121, '2014-01-15 00:47:42.000000', 'temperatura', 860.0000, 'ºC'),
	(157435, 121, '2014-01-15 00:47:43.000000', 'temperatura', 610.0000, 'ºC'),
	(157436, 121, '2014-01-15 00:47:44.000000', 'temperatura', 471.0000, 'ºC'),
	(157437, 121, '2014-01-15 00:47:45.000000', 'temperatura', 524.0000, 'ºC'),
	(157438, 121, '2014-01-15 00:47:46.000000', 'temperatura', 9.0000, 'ºC'),
	(157439, 121, '2014-01-15 00:47:47.000000', 'temperatura', 873.0000, 'ºC'),
	(157440, 121, '2014-01-15 00:47:48.000000', 'temperatura', 737.0000, 'ºC'),
	(157441, 121, '2014-01-15 00:47:49.000000', 'temperatura', 1067.0000, 'ºC'),
	(157442, 121, '2014-01-15 00:47:50.000000', 'temperatura', 727.0000, 'ºC'),
	(157443, 121, '2014-01-15 00:47:51.000000', 'temperatura', 433.0000, 'ºC'),
	(157444, 121, '2014-01-15 00:47:52.000000', 'temperatura', 1185.0000, 'ºC'),
	(157445, 121, '2014-01-15 00:47:53.000000', 'temperatura', 1024.0000, 'ºC'),
	(157446, 121, '2014-01-15 00:47:54.000000', 'temperatura', 367.0000, 'ºC'),
	(157447, 121, '2014-01-15 00:47:55.000000', 'temperatura', 1165.0000, 'ºC'),
	(157448, 121, '2014-01-15 00:47:56.000000', 'temperatura', 1124.0000, 'ºC'),
	(157449, 121, '2014-01-15 00:47:57.000000', 'temperatura', 927.0000, 'ºC'),
	(157450, 121, '2014-01-15 00:47:58.000000', 'temperatura', 63.0000, 'ºC'),
	(157451, 121, '2014-01-15 00:47:59.000000', 'temperatura', 1135.0000, 'ºC'),
	(157452, 121, '2014-01-15 00:48:00.000000', 'temperatura', 684.0000, 'ºC'),
	(157453, 121, '2014-01-15 00:48:01.000000', 'temperatura', 19.0000, 'ºC'),
	(157454, 121, '2014-01-15 00:48:02.000000', 'temperatura', 441.0000, 'ºC'),
	(157455, 121, '2014-01-15 00:48:03.000000', 'temperatura', 950.0000, 'ºC'),
	(157456, 121, '2014-01-15 00:48:04.000000', 'temperatura', 1027.0000, 'ºC'),
	(157457, 121, '2014-01-15 00:48:05.000000', 'temperatura', 1087.0000, 'ºC'),
	(157458, 121, '2014-01-15 00:48:06.000000', 'temperatura', 1151.0000, 'ºC'),
	(157459, 121, '2014-01-15 00:48:07.000000', 'temperatura', 98.0000, 'ºC'),
	(157460, 121, '2014-01-15 00:48:08.000000', 'temperatura', 635.0000, 'ºC'),
	(157461, 121, '2014-01-15 00:48:09.000000', 'temperatura', 483.0000, 'ºC'),
	(157462, 121, '2014-01-15 00:48:10.000000', 'temperatura', 509.0000, 'ºC'),
	(157463, 121, '2014-01-15 00:48:11.000000', 'temperatura', 1097.0000, 'ºC'),
	(157464, 121, '2014-01-15 00:48:12.000000', 'temperatura', 359.0000, 'ºC'),
	(157465, 121, '2014-01-15 00:48:13.000000', 'temperatura', 905.0000, 'ºC'),
	(157466, 121, '2014-01-15 00:48:14.000000', 'temperatura', 1050.0000, 'ºC'),
	(157467, 121, '2014-01-15 00:48:15.000000', 'temperatura', 135.0000, 'ºC'),
	(157468, 121, '2014-01-15 00:48:16.000000', 'temperatura', 1123.0000, 'ºC'),
	(157469, 121, '2014-01-15 00:48:17.000000', 'temperatura', 411.0000, 'ºC'),
	(157470, 121, '2014-01-15 00:48:18.000000', 'temperatura', 1087.0000, 'ºC'),
	(157471, 121, '2014-01-15 00:48:19.000000', 'temperatura', 603.0000, 'ºC'),
	(157472, 121, '2014-01-15 00:48:20.000000', 'temperatura', 952.0000, 'ºC'),
	(157473, 121, '2014-01-15 00:48:21.000000', 'temperatura', 554.0000, 'ºC'),
	(157474, 121, '2014-01-15 00:48:22.000000', 'temperatura', 1116.0000, 'ºC'),
	(157475, 121, '2014-01-15 00:48:23.000000', 'temperatura', 316.0000, 'ºC'),
	(157476, 121, '2014-01-15 00:48:24.000000', 'temperatura', 632.0000, 'ºC'),
	(157477, 121, '2014-01-15 00:48:25.000000', 'temperatura', 1011.0000, 'ºC'),
	(157478, 121, '2014-01-15 00:48:26.000000', 'temperatura', 763.0000, 'ºC'),
	(157479, 121, '2014-01-15 00:48:27.000000', 'temperatura', 781.0000, 'ºC'),
	(157480, 121, '2014-01-15 00:48:28.000000', 'temperatura', 419.0000, 'ºC'),
	(157481, 121, '2014-01-15 00:48:29.000000', 'temperatura', 949.0000, 'ºC'),
	(157482, 121, '2014-01-15 00:48:30.000000', 'temperatura', 1091.0000, 'ºC'),
	(157483, 121, '2014-01-15 00:48:31.000000', 'temperatura', 208.0000, 'ºC'),
	(157484, 121, '2014-01-15 00:48:32.000000', 'temperatura', 168.0000, 'ºC'),
	(157485, 121, '2014-01-15 00:48:33.000000', 'temperatura', 215.0000, 'ºC'),
	(157486, 121, '2014-01-15 00:48:34.000000', 'temperatura', 574.0000, 'ºC'),
	(157487, 121, '2014-01-15 00:48:35.000000', 'temperatura', 1024.0000, 'ºC'),
	(157488, 121, '2014-01-15 00:48:36.000000', 'temperatura', 1000.0000, 'ºC'),
	(157489, 121, '2014-01-15 00:48:37.000000', 'temperatura', 728.0000, 'ºC'),
	(157490, 121, '2014-01-15 00:48:38.000000', 'temperatura', 638.0000, 'ºC'),
	(157491, 121, '2014-01-15 00:48:39.000000', 'temperatura', 1010.0000, 'ºC'),
	(157492, 121, '2014-01-15 00:48:40.000000', 'temperatura', 733.0000, 'ºC'),
	(157493, 121, '2014-01-15 00:48:41.000000', 'temperatura', 637.0000, 'ºC'),
	(157494, 121, '2014-01-15 00:48:42.000000', 'temperatura', 986.0000, 'ºC'),
	(157495, 121, '2014-01-15 00:48:43.000000', 'temperatura', 622.0000, 'ºC'),
	(157496, 121, '2014-01-15 00:48:44.000000', 'temperatura', 149.0000, 'ºC'),
	(157497, 121, '2014-01-15 00:48:45.000000', 'temperatura', 81.0000, 'ºC'),
	(157498, 121, '2014-01-15 00:48:46.000000', 'temperatura', 1158.0000, 'ºC'),
	(157499, 121, '2014-01-15 00:48:47.000000', 'temperatura', 750.0000, 'ºC'),
	(157500, 121, '2014-01-15 00:48:48.000000', 'temperatura', 274.0000, 'ºC'),
	(157501, 121, '2014-01-15 00:48:49.000000', 'temperatura', 320.0000, 'ºC'),
	(157502, 121, '2014-01-15 00:48:50.000000', 'temperatura', 780.0000, 'ºC'),
	(157503, 121, '2014-01-15 00:48:51.000000', 'temperatura', 542.0000, 'ºC'),
	(157504, 121, '2014-01-15 00:48:52.000000', 'temperatura', 368.0000, 'ºC'),
	(157505, 121, '2014-01-15 00:48:53.000000', 'temperatura', 214.0000, 'ºC'),
	(157506, 121, '2014-01-15 00:48:54.000000', 'temperatura', 1166.0000, 'ºC'),
	(157507, 121, '2014-01-15 00:48:55.000000', 'temperatura', 390.0000, 'ºC'),
	(157508, 121, '2014-01-15 00:48:56.000000', 'temperatura', 853.0000, 'ºC'),
	(157509, 121, '2014-01-15 00:48:57.000000', 'temperatura', 696.0000, 'ºC'),
	(157510, 121, '2014-01-15 00:48:58.000000', 'temperatura', 919.0000, 'ºC'),
	(157511, 121, '2014-01-15 00:48:59.000000', 'temperatura', 108.0000, 'ºC'),
	(157512, 121, '2014-01-15 00:49:00.000000', 'temperatura', 185.0000, 'ºC'),
	(157513, 121, '2014-01-15 00:49:01.000000', 'temperatura', 601.0000, 'ºC'),
	(157514, 121, '2014-01-15 00:49:02.000000', 'temperatura', 51.0000, 'ºC'),
	(157515, 121, '2014-01-15 00:49:03.000000', 'temperatura', 852.0000, 'ºC'),
	(157516, 121, '2014-01-15 00:49:04.000000', 'temperatura', 509.0000, 'ºC'),
	(157517, 121, '2014-01-15 00:49:05.000000', 'temperatura', 1190.0000, 'ºC'),
	(157518, 121, '2014-01-15 00:49:06.000000', 'temperatura', 823.0000, 'ºC'),
	(157519, 121, '2014-01-15 00:49:07.000000', 'temperatura', 543.0000, 'ºC'),
	(157520, 121, '2014-01-15 00:49:08.000000', 'temperatura', 248.0000, 'ºC'),
	(157521, 121, '2014-01-15 00:49:09.000000', 'temperatura', 812.0000, 'ºC'),
	(157522, 121, '2014-01-15 00:49:10.000000', 'temperatura', 917.0000, 'ºC'),
	(157523, 121, '2014-01-15 00:49:11.000000', 'temperatura', 951.0000, 'ºC'),
	(157524, 121, '2014-01-15 00:49:12.000000', 'temperatura', 801.0000, 'ºC'),
	(157525, 121, '2014-01-15 00:49:13.000000', 'temperatura', 1154.0000, 'ºC'),
	(157526, 121, '2014-01-15 00:49:14.000000', 'temperatura', 966.0000, 'ºC'),
	(157527, 121, '2014-01-15 00:49:15.000000', 'temperatura', 169.0000, 'ºC'),
	(157528, 121, '2014-01-15 00:49:16.000000', 'temperatura', 348.0000, 'ºC'),
	(157529, 121, '2014-01-15 00:49:17.000000', 'temperatura', 35.0000, 'ºC'),
	(157530, 121, '2014-01-15 00:49:18.000000', 'temperatura', 332.0000, 'ºC'),
	(157531, 121, '2014-01-15 00:49:19.000000', 'temperatura', 353.0000, 'ºC'),
	(157532, 121, '2014-01-15 00:49:20.000000', 'temperatura', 769.0000, 'ºC'),
	(157533, 121, '2014-01-15 00:49:21.000000', 'temperatura', 387.0000, 'ºC'),
	(157534, 121, '2014-01-15 00:49:22.000000', 'temperatura', 830.0000, 'ºC'),
	(157535, 121, '2014-01-15 00:49:23.000000', 'temperatura', 588.0000, 'ºC'),
	(157536, 121, '2014-01-15 00:49:24.000000', 'temperatura', 450.0000, 'ºC'),
	(157537, 121, '2014-01-15 00:49:25.000000', 'temperatura', 487.0000, 'ºC'),
	(157538, 121, '2014-01-15 00:49:26.000000', 'temperatura', 1084.0000, 'ºC'),
	(157539, 121, '2014-01-15 00:49:27.000000', 'temperatura', 361.0000, 'ºC'),
	(157540, 121, '2014-01-15 00:49:28.000000', 'temperatura', 952.0000, 'ºC'),
	(157541, 121, '2014-01-15 00:49:29.000000', 'temperatura', 79.0000, 'ºC'),
	(157542, 121, '2014-01-15 00:49:30.000000', 'temperatura', 1139.0000, 'ºC'),
	(157543, 121, '2014-01-15 00:49:31.000000', 'temperatura', 660.0000, 'ºC'),
	(157544, 121, '2014-01-15 00:49:32.000000', 'temperatura', 1084.0000, 'ºC'),
	(157545, 121, '2014-01-15 00:49:33.000000', 'temperatura', 1042.0000, 'ºC'),
	(157546, 121, '2014-01-15 00:49:34.000000', 'temperatura', 755.0000, 'ºC'),
	(157547, 121, '2014-01-15 00:49:35.000000', 'temperatura', 649.0000, 'ºC'),
	(157548, 121, '2014-01-15 00:49:36.000000', 'temperatura', 983.0000, 'ºC'),
	(157549, 121, '2014-01-15 00:49:37.000000', 'temperatura', 567.0000, 'ºC'),
	(157550, 121, '2014-01-15 00:49:38.000000', 'temperatura', 1085.0000, 'ºC'),
	(157551, 121, '2014-01-15 00:49:39.000000', 'temperatura', 127.0000, 'ºC'),
	(157552, 121, '2014-01-15 00:49:40.000000', 'temperatura', 981.0000, 'ºC'),
	(157553, 121, '2014-01-15 00:49:41.000000', 'temperatura', 922.0000, 'ºC'),
	(157554, 121, '2014-01-15 00:49:42.000000', 'temperatura', 470.0000, 'ºC'),
	(157555, 121, '2014-01-15 00:49:43.000000', 'temperatura', 785.0000, 'ºC'),
	(157556, 121, '2014-01-15 00:49:44.000000', 'temperatura', 115.0000, 'ºC'),
	(157557, 121, '2014-01-15 00:49:45.000000', 'temperatura', 620.0000, 'ºC'),
	(157558, 121, '2014-01-15 00:49:46.000000', 'temperatura', 354.0000, 'ºC'),
	(157559, 121, '2014-01-15 00:49:47.000000', 'temperatura', 1112.0000, 'ºC'),
	(157560, 121, '2014-01-15 00:49:48.000000', 'temperatura', 900.0000, 'ºC'),
	(157561, 121, '2014-01-15 00:49:49.000000', 'temperatura', 1163.0000, 'ºC'),
	(157562, 121, '2014-01-15 00:49:50.000000', 'temperatura', 714.0000, 'ºC'),
	(157563, 121, '2014-01-15 00:49:51.000000', 'temperatura', 83.0000, 'ºC'),
	(157564, 121, '2014-01-15 00:49:52.000000', 'temperatura', 675.0000, 'ºC'),
	(157565, 121, '2014-01-15 00:49:53.000000', 'temperatura', 726.0000, 'ºC'),
	(157566, 121, '2014-01-15 00:49:54.000000', 'temperatura', 404.0000, 'ºC'),
	(157567, 121, '2014-01-15 00:49:55.000000', 'temperatura', 1041.0000, 'ºC'),
	(157568, 121, '2014-01-15 00:49:56.000000', 'temperatura', 396.0000, 'ºC'),
	(157569, 121, '2014-01-15 00:49:57.000000', 'temperatura', 55.0000, 'ºC'),
	(157570, 121, '2014-01-15 00:49:58.000000', 'temperatura', 289.0000, 'ºC'),
	(157571, 121, '2014-01-15 00:49:59.000000', 'temperatura', 81.0000, 'ºC'),
	(157572, 121, '2014-01-15 00:50:00.000000', 'temperatura', 737.0000, 'ºC'),
	(157573, 121, '2014-01-15 00:50:01.000000', 'temperatura', 1044.0000, 'ºC'),
	(157574, 121, '2014-01-15 00:50:02.000000', 'temperatura', 608.0000, 'ºC'),
	(157575, 121, '2014-01-15 00:50:03.000000', 'temperatura', 1107.0000, 'ºC'),
	(157576, 121, '2014-01-15 00:50:04.000000', 'temperatura', 115.0000, 'ºC'),
	(157577, 121, '2014-01-15 00:50:05.000000', 'temperatura', 852.0000, 'ºC'),
	(157578, 121, '2014-01-15 00:50:06.000000', 'temperatura', 314.0000, 'ºC'),
	(157579, 121, '2014-01-15 00:50:07.000000', 'temperatura', 217.0000, 'ºC'),
	(157580, 121, '2014-01-15 00:50:08.000000', 'temperatura', 144.0000, 'ºC'),
	(157581, 121, '2014-01-15 00:50:09.000000', 'temperatura', 70.0000, 'ºC'),
	(157582, 121, '2014-01-15 00:50:10.000000', 'temperatura', 1116.0000, 'ºC'),
	(157583, 121, '2014-01-15 00:50:11.000000', 'temperatura', 570.0000, 'ºC'),
	(157584, 121, '2014-01-15 00:50:12.000000', 'temperatura', 702.0000, 'ºC'),
	(157585, 121, '2014-01-15 00:50:13.000000', 'temperatura', 603.0000, 'ºC'),
	(157586, 121, '2014-01-15 00:50:14.000000', 'temperatura', 910.0000, 'ºC'),
	(157587, 121, '2014-01-15 00:50:15.000000', 'temperatura', 341.0000, 'ºC'),
	(157588, 121, '2014-01-15 00:50:16.000000', 'temperatura', 177.0000, 'ºC'),
	(157589, 121, '2014-01-15 00:50:17.000000', 'temperatura', 1061.0000, 'ºC'),
	(157590, 121, '2014-01-15 00:50:18.000000', 'temperatura', 1175.0000, 'ºC'),
	(157591, 121, '2014-01-15 00:50:19.000000', 'temperatura', 290.0000, 'ºC'),
	(157592, 121, '2014-01-15 00:50:20.000000', 'temperatura', 329.0000, 'ºC'),
	(157593, 121, '2014-01-15 00:50:21.000000', 'temperatura', 774.0000, 'ºC'),
	(157594, 121, '2014-01-15 00:50:22.000000', 'temperatura', 483.0000, 'ºC'),
	(157595, 121, '2014-01-15 00:50:23.000000', 'temperatura', 92.0000, 'ºC'),
	(157596, 121, '2014-01-15 00:50:24.000000', 'temperatura', 214.0000, 'ºC'),
	(157597, 121, '2014-01-15 00:50:25.000000', 'temperatura', 792.0000, 'ºC'),
	(157598, 121, '2014-01-15 00:50:26.000000', 'temperatura', 921.0000, 'ºC'),
	(157599, 121, '2014-01-15 00:50:27.000000', 'temperatura', 1027.0000, 'ºC'),
	(157600, 121, '2014-01-15 00:50:28.000000', 'temperatura', 1173.0000, 'ºC'),
	(157601, 121, '2014-01-15 00:50:29.000000', 'temperatura', 384.0000, 'ºC'),
	(157602, 121, '2014-01-15 00:50:30.000000', 'temperatura', 801.0000, 'ºC'),
	(157603, 121, '2014-01-15 00:50:31.000000', 'temperatura', 453.0000, 'ºC'),
	(157604, 121, '2014-01-15 00:50:32.000000', 'temperatura', 1064.0000, 'ºC'),
	(157605, 121, '2014-01-15 00:50:33.000000', 'temperatura', 362.0000, 'ºC'),
	(157606, 121, '2014-01-15 00:50:34.000000', 'temperatura', 1018.0000, 'ºC'),
	(157607, 121, '2014-01-15 00:50:35.000000', 'temperatura', 402.0000, 'ºC'),
	(157608, 121, '2014-01-15 00:50:36.000000', 'temperatura', 160.0000, 'ºC'),
	(157609, 121, '2014-01-15 00:50:37.000000', 'temperatura', 794.0000, 'ºC'),
	(157610, 121, '2014-01-15 00:50:38.000000', 'temperatura', 1089.0000, 'ºC'),
	(157611, 121, '2014-01-15 00:50:39.000000', 'temperatura', 665.0000, 'ºC'),
	(157612, 121, '2014-01-15 00:50:40.000000', 'temperatura', 58.0000, 'ºC'),
	(157613, 121, '2014-01-15 00:50:41.000000', 'temperatura', 697.0000, 'ºC'),
	(157614, 121, '2014-01-15 00:50:42.000000', 'temperatura', 911.0000, 'ºC'),
	(157615, 121, '2014-01-15 00:50:43.000000', 'temperatura', 64.0000, 'ºC'),
	(157616, 121, '2014-01-15 00:50:44.000000', 'temperatura', 1186.0000, 'ºC'),
	(157617, 121, '2014-01-15 00:50:45.000000', 'temperatura', 941.0000, 'ºC'),
	(157618, 121, '2014-01-15 00:50:46.000000', 'temperatura', 1148.0000, 'ºC'),
	(157619, 121, '2014-01-15 00:50:47.000000', 'temperatura', 516.0000, 'ºC'),
	(157620, 121, '2014-01-15 00:50:48.000000', 'temperatura', 335.0000, 'ºC'),
	(157621, 121, '2014-01-15 00:50:49.000000', 'temperatura', 130.0000, 'ºC'),
	(157622, 121, '2014-01-15 00:50:50.000000', 'temperatura', 844.0000, 'ºC'),
	(157623, 121, '2014-01-15 00:50:51.000000', 'temperatura', 229.0000, 'ºC'),
	(157624, 121, '2014-01-15 00:50:52.000000', 'temperatura', 1015.0000, 'ºC'),
	(157625, 121, '2014-01-15 00:50:53.000000', 'temperatura', 789.0000, 'ºC'),
	(157626, 121, '2014-01-15 00:50:54.000000', 'temperatura', 901.0000, 'ºC'),
	(157627, 121, '2014-01-15 00:50:55.000000', 'temperatura', 940.0000, 'ºC'),
	(157628, 121, '2014-01-15 00:50:56.000000', 'temperatura', 795.0000, 'ºC'),
	(157629, 121, '2014-01-15 00:50:57.000000', 'temperatura', 1157.0000, 'ºC'),
	(157630, 121, '2014-01-15 00:50:58.000000', 'temperatura', 999.0000, 'ºC'),
	(157631, 121, '2014-01-15 00:50:59.000000', 'temperatura', 326.0000, 'ºC'),
	(157632, 121, '2014-01-15 00:51:00.000000', 'temperatura', 1033.0000, 'ºC'),
	(157633, 121, '2014-01-15 00:51:01.000000', 'temperatura', 589.0000, 'ºC'),
	(157634, 121, '2014-01-15 00:51:02.000000', 'temperatura', 1046.0000, 'ºC'),
	(157635, 121, '2014-01-15 00:51:03.000000', 'temperatura', 1064.0000, 'ºC'),
	(157636, 121, '2014-01-15 00:51:04.000000', 'temperatura', 983.0000, 'ºC'),
	(157637, 121, '2014-01-15 00:51:05.000000', 'temperatura', 524.0000, 'ºC'),
	(157638, 121, '2014-01-15 00:51:06.000000', 'temperatura', 870.0000, 'ºC'),
	(157639, 121, '2014-01-15 00:51:07.000000', 'temperatura', 379.0000, 'ºC'),
	(157640, 121, '2014-01-15 00:51:08.000000', 'temperatura', 486.0000, 'ºC'),
	(157641, 121, '2014-01-15 00:51:09.000000', 'temperatura', 93.0000, 'ºC'),
	(157642, 121, '2014-01-15 00:51:10.000000', 'temperatura', 208.0000, 'ºC'),
	(157643, 121, '2014-01-15 00:51:11.000000', 'temperatura', 763.0000, 'ºC'),
	(157644, 121, '2014-01-15 00:51:12.000000', 'temperatura', 791.0000, 'ºC'),
	(157645, 121, '2014-01-15 00:51:13.000000', 'temperatura', 467.0000, 'ºC'),
	(157646, 121, '2014-01-15 00:51:14.000000', 'temperatura', 1164.0000, 'ºC'),
	(157647, 121, '2014-01-15 00:51:15.000000', 'temperatura', 818.0000, 'ºC'),
	(157648, 121, '2014-01-15 00:51:16.000000', 'temperatura', 597.0000, 'ºC'),
	(157649, 121, '2014-01-15 00:51:17.000000', 'temperatura', 533.0000, 'ºC'),
	(157650, 121, '2014-01-15 00:51:18.000000', 'temperatura', 874.0000, 'ºC'),
	(157651, 121, '2014-01-15 00:51:19.000000', 'temperatura', 374.0000, 'ºC'),
	(157652, 121, '2014-01-15 00:51:20.000000', 'temperatura', 446.0000, 'ºC'),
	(157653, 121, '2014-01-15 00:51:21.000000', 'temperatura', 1108.0000, 'ºC'),
	(157654, 121, '2014-01-15 00:51:22.000000', 'temperatura', 604.0000, 'ºC'),
	(157655, 121, '2014-01-15 00:51:23.000000', 'temperatura', 898.0000, 'ºC'),
	(157656, 121, '2014-01-15 00:51:24.000000', 'temperatura', 276.0000, 'ºC'),
	(157657, 121, '2014-01-15 00:51:25.000000', 'temperatura', 1085.0000, 'ºC'),
	(157658, 121, '2014-01-15 00:51:26.000000', 'temperatura', 1000.0000, 'ºC'),
	(157659, 121, '2014-01-15 00:51:27.000000', 'temperatura', 544.0000, 'ºC'),
	(157660, 121, '2014-01-15 00:51:28.000000', 'temperatura', 919.0000, 'ºC'),
	(157661, 121, '2014-01-15 00:51:29.000000', 'temperatura', 567.0000, 'ºC'),
	(157662, 121, '2014-01-15 00:51:30.000000', 'temperatura', 75.0000, 'ºC'),
	(157663, 121, '2014-01-15 00:51:31.000000', 'temperatura', 1076.0000, 'ºC'),
	(157664, 121, '2014-01-15 00:51:32.000000', 'temperatura', 355.0000, 'ºC'),
	(157665, 121, '2014-01-15 00:51:33.000000', 'temperatura', 948.0000, 'ºC'),
	(157666, 121, '2014-01-15 00:51:34.000000', 'temperatura', 77.0000, 'ºC'),
	(157667, 121, '2014-01-15 00:51:35.000000', 'temperatura', 1142.0000, 'ºC'),
	(157668, 121, '2014-01-15 00:51:36.000000', 'temperatura', 677.0000, 'ºC'),
	(157669, 121, '2014-01-15 00:51:37.000000', 'temperatura', 1160.0000, 'ºC'),
	(157670, 121, '2014-01-15 00:51:38.000000', 'temperatura', 170.0000, 'ºC'),
	(157671, 121, '2014-01-15 00:51:39.000000', 'temperatura', 969.0000, 'ºC'),
	(157672, 121, '2014-01-15 00:51:40.000000', 'temperatura', 737.0000, 'ºC'),
	(157673, 121, '2014-01-15 00:51:41.000000', 'temperatura', 778.0000, 'ºC'),
	(157674, 121, '2014-01-15 00:51:42.000000', 'temperatura', 478.0000, 'ºC'),
	(157675, 121, '2014-01-15 00:51:43.000000', 'temperatura', 60.0000, 'ºC'),
	(157676, 121, '2014-01-15 00:51:44.000000', 'temperatura', 64.0000, 'ºC'),
	(157677, 121, '2014-01-15 00:51:45.000000', 'temperatura', 139.0000, 'ºC'),
	(157678, 121, '2014-01-15 00:51:46.000000', 'temperatura', 505.0000, 'ºC'),
	(157679, 121, '2014-01-15 00:51:47.000000', 'temperatura', 908.0000, 'ºC'),
	(157680, 121, '2014-01-15 00:51:48.000000', 'temperatura', 628.0000, 'ºC'),
	(157681, 121, '2014-01-15 00:51:49.000000', 'temperatura', 414.0000, 'ºC'),
	(157682, 121, '2014-01-15 00:51:50.000000', 'temperatura', 187.0000, 'ºC'),
	(157683, 121, '2014-01-15 00:51:51.000000', 'temperatura', 894.0000, 'ºC'),
	(157684, 121, '2014-01-15 00:51:52.000000', 'temperatura', 308.0000, 'ºC'),
	(157685, 121, '2014-01-15 00:51:53.000000', 'temperatura', 59.0000, 'ºC'),
	(157686, 121, '2014-01-15 00:51:54.000000', 'temperatura', 570.0000, 'ºC'),
	(157687, 121, '2014-01-15 00:51:55.000000', 'temperatura', 276.0000, 'ºC'),
	(157688, 121, '2014-01-15 00:51:56.000000', 'temperatura', 870.0000, 'ºC'),
	(157689, 121, '2014-01-15 00:51:57.000000', 'temperatura', 1124.0000, 'ºC'),
	(157690, 121, '2014-01-15 00:51:58.000000', 'temperatura', 608.0000, 'ºC'),
	(157691, 121, '2014-01-15 00:51:59.000000', 'temperatura', 870.0000, 'ºC'),
	(157692, 121, '2014-01-15 00:52:00.000000', 'temperatura', 125.0000, 'ºC'),
	(157693, 121, '2014-01-15 00:52:01.000000', 'temperatura', 416.0000, 'ºC'),
	(157694, 121, '2014-01-15 00:52:02.000000', 'temperatura', 507.0000, 'ºC'),
	(157695, 121, '2014-01-15 00:52:03.000000', 'temperatura', 85.0000, 'ºC'),
	(157696, 121, '2014-01-15 00:52:04.000000', 'temperatura', 104.0000, 'ºC'),
	(157697, 121, '2014-01-15 00:52:05.000000', 'temperatura', 268.0000, 'ºC'),
	(157698, 121, '2014-01-15 00:52:06.000000', 'temperatura', 1026.0000, 'ºC'),
	(157699, 121, '2014-01-15 00:52:07.000000', 'temperatura', 726.0000, 'ºC'),
	(157700, 121, '2014-01-15 00:52:08.000000', 'temperatura', 555.0000, 'ºC'),
	(157701, 121, '2014-01-15 00:52:09.000000', 'temperatura', 597.0000, 'ºC'),
	(157702, 121, '2014-01-15 00:52:10.000000', 'temperatura', 119.0000, 'ºC'),
	(157703, 121, '2014-01-15 00:52:11.000000', 'temperatura', 6.0000, 'ºC'),
	(157704, 121, '2014-01-15 00:52:12.000000', 'temperatura', 871.0000, 'ºC'),
	(157705, 121, '2014-01-15 00:52:13.000000', 'temperatura', 739.0000, 'ºC'),
	(157706, 121, '2014-01-15 00:52:14.000000', 'temperatura', 1082.0000, 'ºC'),
	(157707, 121, '2014-01-15 00:52:15.000000', 'temperatura', 792.0000, 'ºC'),
	(157708, 121, '2014-01-15 00:52:16.000000', 'temperatura', 717.0000, 'ºC'),
	(157709, 121, '2014-01-15 00:52:17.000000', 'temperatura', 10.0000, 'ºC'),
	(157710, 121, '2014-01-15 00:52:18.000000', 'temperatura', 300.0000, 'ºC'),
	(157711, 121, '2014-01-15 00:52:19.000000', 'temperatura', 269.0000, 'ºC'),
	(157712, 121, '2014-01-15 00:52:20.000000', 'temperatura', 448.0000, 'ºC'),
	(157713, 121, '2014-01-15 00:52:21.000000', 'temperatura', 231.0000, 'ºC'),
	(157714, 121, '2014-01-15 00:52:22.000000', 'temperatura', 1011.0000, 'ºC'),
	(157715, 121, '2014-01-15 00:52:23.000000', 'temperatura', 764.0000, 'ºC'),
	(157716, 121, '2014-01-15 00:52:24.000000', 'temperatura', 788.0000, 'ºC'),
	(157717, 121, '2014-01-15 00:52:25.000000', 'temperatura', 448.0000, 'ºC'),
	(157718, 121, '2014-01-15 00:52:26.000000', 'temperatura', 1075.0000, 'ºC'),
	(157719, 121, '2014-01-15 00:52:27.000000', 'temperatura', 431.0000, 'ºC'),
	(157720, 121, '2014-01-15 00:52:28.000000', 'temperatura', 131.0000, 'ºC'),
	(157721, 121, '2014-01-15 00:52:29.000000', 'temperatura', 565.0000, 'ºC'),
	(157722, 121, '2014-01-15 00:52:30.000000', 'temperatura', 29.0000, 'ºC'),
	(157723, 121, '2014-01-15 00:52:31.000000', 'temperatura', 853.0000, 'ºC'),
	(157724, 121, '2014-01-15 00:52:32.000000', 'temperatura', 578.0000, 'ºC'),
	(157725, 121, '2014-01-15 00:52:33.000000', 'temperatura', 333.0000, 'ºC'),
	(157726, 121, '2014-01-15 00:52:34.000000', 'temperatura', 1132.0000, 'ºC'),
	(157727, 121, '2014-01-15 00:52:35.000000', 'temperatura', 1060.0000, 'ºC'),
	(157728, 121, '2014-01-15 00:52:36.000000', 'temperatura', 704.0000, 'ºC'),
	(157729, 121, '2014-01-15 00:52:37.000000', 'temperatura', 341.0000, 'ºC'),
	(157730, 121, '2014-01-15 00:52:38.000000', 'temperatura', 793.0000, 'ºC'),
	(157731, 121, '2014-01-15 00:52:39.000000', 'temperatura', 541.0000, 'ºC'),
	(157732, 121, '2014-01-15 00:52:40.000000', 'temperatura', 327.0000, 'ºC'),
	(157733, 121, '2014-01-15 00:52:41.000000', 'temperatura', 11.0000, 'ºC'),
	(157734, 121, '2014-01-15 00:52:42.000000', 'temperatura', 277.0000, 'ºC'),
	(157735, 121, '2014-01-15 00:52:43.000000', 'temperatura', 151.0000, 'ºC'),
	(157736, 121, '2014-01-15 00:52:44.000000', 'temperatura', 1123.0000, 'ºC'),
	(157737, 121, '2014-01-15 00:52:45.000000', 'temperatura', 366.0000, 'ºC'),
	(157738, 121, '2014-01-15 00:52:46.000000', 'temperatura', 860.0000, 'ºC'),
	(157739, 121, '2014-01-15 00:52:47.000000', 'temperatura', 802.0000, 'ºC'),
	(157740, 121, '2014-01-15 00:52:48.000000', 'temperatura', 230.0000, 'ºC'),
	(157741, 121, '2014-01-15 00:52:49.000000', 'temperatura', 1146.0000, 'ºC'),
	(157742, 121, '2014-01-15 00:52:50.000000', 'temperatura', 241.0000, 'ºC'),
	(157743, 121, '2014-01-15 00:52:51.000000', 'temperatura', 165.0000, 'ºC'),
	(157744, 121, '2014-01-15 00:52:52.000000', 'temperatura', 102.0000, 'ºC'),
	(157745, 121, '2014-01-15 00:52:53.000000', 'temperatura', 17.0000, 'ºC'),
	(157746, 121, '2014-01-15 00:52:54.000000', 'temperatura', 979.0000, 'ºC'),
	(157747, 121, '2014-01-15 00:52:55.000000', 'temperatura', 44.0000, 'ºC'),
	(157748, 121, '2014-01-15 00:52:56.000000', 'temperatura', 886.0000, 'ºC'),
	(157749, 121, '2014-01-15 00:52:57.000000', 'temperatura', 697.0000, 'ºC'),
	(157750, 121, '2014-01-15 00:52:58.000000', 'temperatura', 830.0000, 'ºC'),
	(157751, 121, '2014-01-15 00:52:59.000000', 'temperatura', 856.0000, 'ºC'),
	(157752, 121, '2014-01-15 00:53:00.000000', 'temperatura', 590.0000, 'ºC'),
	(157753, 121, '2014-01-15 00:53:01.000000', 'temperatura', 385.0000, 'ºC'),
	(157754, 121, '2014-01-15 00:53:02.000000', 'temperatura', 156.0000, 'ºC'),
	(157755, 121, '2014-01-15 00:53:03.000000', 'temperatura', 826.0000, 'ºC'),
	(157756, 121, '2014-01-15 00:53:04.000000', 'temperatura', 59.0000, 'ºC'),
	(157757, 121, '2014-01-15 00:53:05.000000', 'temperatura', 221.0000, 'ºC'),
	(157758, 121, '2014-01-15 00:53:06.000000', 'temperatura', 927.0000, 'ºC'),
	(157759, 121, '2014-01-15 00:53:07.000000', 'temperatura', 372.0000, 'ºC'),
	(157760, 121, '2014-01-15 00:53:08.000000', 'temperatura', 278.0000, 'ºC'),
	(157761, 121, '2014-01-15 00:53:09.000000', 'temperatura', 275.0000, 'ºC'),
	(157762, 121, '2014-01-15 00:53:10.000000', 'temperatura', 544.0000, 'ºC'),
	(157763, 121, '2014-01-15 00:53:11.000000', 'temperatura', 695.0000, 'ºC'),
	(157764, 121, '2014-01-15 00:53:12.000000', 'temperatura', 644.0000, 'ºC'),
	(157765, 121, '2014-01-15 00:53:13.000000', 'temperatura', 1135.0000, 'ºC'),
	(157766, 121, '2014-01-15 00:53:14.000000', 'temperatura', 141.0000, 'ºC'),
	(157767, 121, '2014-01-15 00:53:15.000000', 'temperatura', 903.0000, 'ºC'),
	(157768, 121, '2014-01-15 00:53:16.000000', 'temperatura', 494.0000, 'ºC'),
	(157769, 121, '2014-01-15 00:53:17.000000', 'temperatura', 960.0000, 'ºC'),
	(157770, 121, '2014-01-15 00:53:18.000000', 'temperatura', 919.0000, 'ºC'),
	(157771, 121, '2014-01-15 00:53:19.000000', 'temperatura', 513.0000, 'ºC'),
	(157772, 121, '2014-01-15 00:53:20.000000', 'temperatura', 1012.0000, 'ºC'),
	(157773, 121, '2014-01-15 00:53:21.000000', 'temperatura', 1118.0000, 'ºC'),
	(157774, 121, '2014-01-15 00:53:22.000000', 'temperatura', 158.0000, 'ºC'),
	(157775, 121, '2014-01-15 00:53:23.000000', 'temperatura', 1035.0000, 'ºC'),
	(157776, 121, '2014-01-15 00:53:24.000000', 'temperatura', 1102.0000, 'ºC'),
	(157777, 121, '2014-01-15 00:53:25.000000', 'temperatura', 4.0000, 'ºC'),
	(157778, 121, '2014-01-15 00:53:26.000000', 'temperatura', 313.0000, 'ºC'),
	(157779, 121, '2014-01-15 00:53:27.000000', 'temperatura', 357.0000, 'ºC'),
	(157780, 121, '2014-01-15 00:53:28.000000', 'temperatura', 846.0000, 'ºC'),
	(157781, 121, '2014-01-15 00:53:29.000000', 'temperatura', 758.0000, 'ºC'),
	(157782, 121, '2014-01-15 00:53:30.000000', 'temperatura', 53.0000, 'ºC'),
	(157783, 121, '2014-01-15 00:53:31.000000', 'temperatura', 392.0000, 'ºC'),
	(157784, 121, '2014-01-15 00:53:32.000000', 'temperatura', 603.0000, 'ºC'),
	(157785, 121, '2014-01-15 00:53:33.000000', 'temperatura', 639.0000, 'ºC'),
	(157786, 121, '2014-01-15 00:53:34.000000', 'temperatura', 186.0000, 'ºC'),
	(157787, 121, '2014-01-15 00:53:35.000000', 'temperatura', 211.0000, 'ºC'),
	(157788, 121, '2014-01-15 00:53:36.000000', 'temperatura', 501.0000, 'ºC'),
	(157789, 121, '2014-01-15 00:53:37.000000', 'temperatura', 672.0000, 'ºC'),
	(157790, 121, '2014-01-15 00:53:38.000000', 'temperatura', 656.0000, 'ºC'),
	(157791, 121, '2014-01-15 00:53:39.000000', 'temperatura', 66.0000, 'ºC'),
	(157792, 121, '2014-01-15 00:53:40.000000', 'temperatura', 761.0000, 'ºC'),
	(157793, 121, '2014-01-15 00:53:41.000000', 'temperatura', 7.0000, 'ºC'),
	(157794, 121, '2014-01-15 00:53:42.000000', 'temperatura', 152.0000, 'ºC'),
	(157795, 121, '2014-01-15 00:53:43.000000', 'temperatura', 740.0000, 'ºC'),
	(157796, 121, '2014-01-15 00:53:44.000000', 'temperatura', 846.0000, 'ºC'),
	(157797, 121, '2014-01-15 00:53:45.000000', 'temperatura', 809.0000, 'ºC'),
	(157798, 121, '2014-01-15 00:53:46.000000', 'temperatura', 309.0000, 'ºC'),
	(157799, 121, '2014-01-15 00:53:47.000000', 'temperatura', 319.0000, 'ºC'),
	(157800, 121, '2014-01-15 00:53:48.000000', 'temperatura', 668.0000, 'ºC'),
	(157801, 121, '2014-01-15 00:53:49.000000', 'temperatura', 1184.0000, 'ºC'),
	(157802, 121, '2014-01-15 00:53:50.000000', 'temperatura', 318.0000, 'ºC'),
	(157803, 121, '2014-01-15 00:53:51.000000', 'temperatura', 437.0000, 'ºC'),
	(157804, 121, '2014-01-15 00:53:52.000000', 'temperatura', 33.0000, 'ºC'),
	(157805, 121, '2014-01-15 00:53:53.000000', 'temperatura', 55.0000, 'ºC'),
	(157806, 121, '2014-01-15 00:53:54.000000', 'temperatura', 176.0000, 'ºC'),
	(157807, 121, '2014-01-15 00:53:55.000000', 'temperatura', 715.0000, 'ºC'),
	(157808, 121, '2014-01-15 00:53:56.000000', 'temperatura', 648.0000, 'ºC'),
	(157809, 121, '2014-01-15 00:53:57.000000', 'temperatura', 1096.0000, 'ºC'),
	(157810, 121, '2014-01-15 00:53:58.000000', 'temperatura', 1136.0000, 'ºC'),
	(157811, 121, '2014-01-15 00:53:59.000000', 'temperatura', 1191.0000, 'ºC'),
	(157812, 121, '2014-01-15 00:54:00.000000', 'temperatura', 150.0000, 'ºC'),
	(157813, 121, '2014-01-15 00:54:01.000000', 'temperatura', 778.0000, 'ºC'),
	(157814, 121, '2014-01-15 00:54:02.000000', 'temperatura', 1038.0000, 'ºC'),
	(157815, 121, '2014-01-15 00:54:03.000000', 'temperatura', 459.0000, 'ºC'),
	(157816, 121, '2014-01-15 00:54:04.000000', 'temperatura', 382.0000, 'ºC'),
	(157817, 121, '2014-01-15 00:54:05.000000', 'temperatura', 534.0000, 'ºC'),
	(157818, 121, '2014-01-15 00:54:06.000000', 'temperatura', 324.0000, 'ºC'),
	(157819, 121, '2014-01-15 00:54:07.000000', 'temperatura', 18.0000, 'ºC'),
	(157820, 121, '2014-01-15 00:54:08.000000', 'temperatura', 319.0000, 'ºC'),
	(157821, 121, '2014-01-15 00:54:09.000000', 'temperatura', 342.0000, 'ºC'),
	(157822, 121, '2014-01-15 00:54:10.000000', 'temperatura', 753.0000, 'ºC'),
	(157823, 121, '2014-01-15 00:54:11.000000', 'temperatura', 339.0000, 'ºC'),
	(157824, 121, '2014-01-15 00:54:12.000000', 'temperatura', 637.0000, 'ºC'),
	(157825, 121, '2014-01-15 00:54:13.000000', 'temperatura', 969.0000, 'ºC'),
	(157826, 121, '2014-01-15 00:54:14.000000', 'temperatura', 532.0000, 'ºC'),
	(157827, 121, '2014-01-15 00:54:15.000000', 'temperatura', 955.0000, 'ºC'),
	(157828, 121, '2014-01-15 00:54:16.000000', 'temperatura', 778.0000, 'ºC'),
	(157829, 121, '2014-01-15 00:54:17.000000', 'temperatura', 1026.0000, 'ºC'),
	(157830, 121, '2014-01-15 00:54:18.000000', 'temperatura', 399.0000, 'ºC'),
	(157831, 121, '2014-01-15 00:54:19.000000', 'temperatura', 116.0000, 'ºC'),
	(157832, 121, '2014-01-15 00:54:20.000000', 'temperatura', 582.0000, 'ºC'),
	(157833, 121, '2014-01-15 00:54:21.000000', 'temperatura', 163.0000, 'ºC'),
	(157834, 121, '2014-01-15 00:54:22.000000', 'temperatura', 270.0000, 'ºC'),
	(157835, 121, '2014-01-15 00:54:23.000000', 'temperatura', 860.0000, 'ºC'),
	(157836, 121, '2014-01-15 00:54:24.000000', 'temperatura', 1093.0000, 'ºC'),
	(157837, 121, '2014-01-15 00:54:25.000000', 'temperatura', 484.0000, 'ºC'),
	(157838, 121, '2014-01-15 00:54:26.000000', 'temperatura', 343.0000, 'ºC'),
	(157839, 121, '2014-01-15 00:54:27.000000', 'temperatura', 264.0000, 'ºC'),
	(157840, 121, '2014-01-15 00:54:28.000000', 'temperatura', 290.0000, 'ºC'),
	(157841, 121, '2014-01-15 00:54:29.000000', 'temperatura', 661.0000, 'ºC'),
	(157842, 121, '2014-01-15 00:54:30.000000', 'temperatura', 33.0000, 'ºC'),
	(157843, 121, '2014-01-15 00:54:31.000000', 'temperatura', 582.0000, 'ºC'),
	(157844, 121, '2014-01-15 00:54:32.000000', 'temperatura', 411.0000, 'ºC'),
	(157845, 121, '2014-01-15 00:54:33.000000', 'temperatura', 311.0000, 'ºC'),
	(157846, 121, '2014-01-15 00:54:34.000000', 'temperatura', 324.0000, 'ºC'),
	(157847, 121, '2014-01-15 00:54:35.000000', 'temperatura', 684.0000, 'ºC'),
	(157848, 121, '2014-01-15 00:54:36.000000', 'temperatura', 52.0000, 'ºC'),
	(157849, 121, '2014-01-15 00:54:37.000000', 'temperatura', 607.0000, 'ºC'),
	(157850, 121, '2014-01-15 00:54:38.000000', 'temperatura', 479.0000, 'ºC'),
	(157851, 121, '2014-01-15 00:54:39.000000', 'temperatura', 576.0000, 'ºC'),
	(157852, 121, '2014-01-15 00:54:40.000000', 'temperatura', 244.0000, 'ºC'),
	(157853, 121, '2014-01-15 00:54:41.000000', 'temperatura', 691.0000, 'ºC'),
	(157854, 121, '2014-01-15 00:54:42.000000', 'temperatura', 324.0000, 'ºC'),
	(157855, 121, '2014-01-15 00:54:43.000000', 'temperatura', 746.0000, 'ºC'),
	(157856, 121, '2014-01-15 00:54:44.000000', 'temperatura', 359.0000, 'ºC'),
	(157857, 121, '2014-01-15 00:54:45.000000', 'temperatura', 758.0000, 'ºC'),
	(157858, 121, '2014-01-15 00:54:46.000000', 'temperatura', 315.0000, 'ºC'),
	(157859, 121, '2014-01-15 00:54:47.000000', 'temperatura', 502.0000, 'ºC'),
	(157860, 121, '2014-01-15 00:54:48.000000', 'temperatura', 364.0000, 'ºC'),
	(157861, 121, '2014-01-15 00:54:49.000000', 'temperatura', 315.0000, 'ºC'),
	(157862, 121, '2014-01-15 00:54:50.000000', 'temperatura', 482.0000, 'ºC'),
	(157863, 121, '2014-01-15 00:54:51.000000', 'temperatura', 268.0000, 'ºC'),
	(157864, 121, '2014-01-15 00:54:52.000000', 'temperatura', 1095.0000, 'ºC'),
	(157865, 121, '2014-01-15 00:54:53.000000', 'temperatura', 1069.0000, 'ºC'),
	(157866, 121, '2014-01-15 00:54:54.000000', 'temperatura', 861.0000, 'ºC'),
	(157867, 121, '2014-01-15 00:54:55.000000', 'temperatura', 1100.0000, 'ºC'),
	(157868, 121, '2014-01-15 00:54:56.000000', 'temperatura', 517.0000, 'ºC'),
	(157869, 121, '2014-01-15 00:54:57.000000', 'temperatura', 487.0000, 'ºC'),
	(157870, 121, '2014-01-15 00:54:58.000000', 'temperatura', 885.0000, 'ºC'),
	(157871, 121, '2014-01-15 00:54:59.000000', 'temperatura', 561.0000, 'ºC'),
	(157872, 121, '2014-01-15 00:55:00.000000', 'temperatura', 153.0000, 'ºC'),
	(157873, 121, '2014-01-15 00:55:01.000000', 'temperatura', 281.0000, 'ºC'),
	(157874, 121, '2014-01-15 00:55:02.000000', 'temperatura', 948.0000, 'ºC'),
	(157875, 121, '2014-01-15 00:55:03.000000', 'temperatura', 299.0000, 'ºC'),
	(157876, 121, '2014-01-15 00:55:04.000000', 'temperatura', 1050.0000, 'ºC'),
	(157877, 121, '2014-01-15 00:55:05.000000', 'temperatura', 753.0000, 'ºC'),
	(157878, 121, '2014-01-15 00:55:06.000000', 'temperatura', 617.0000, 'ºC'),
	(157879, 121, '2014-01-15 00:55:07.000000', 'temperatura', 825.0000, 'ºC'),
	(157880, 121, '2014-01-15 00:55:08.000000', 'temperatura', 1077.0000, 'ºC'),
	(157881, 121, '2014-01-15 00:55:09.000000', 'temperatura', 508.0000, 'ºC'),
	(157882, 121, '2014-01-15 00:55:10.000000', 'temperatura', 509.0000, 'ºC'),
	(157883, 121, '2014-01-15 00:55:11.000000', 'temperatura', 1021.0000, 'ºC'),
	(157884, 121, '2014-01-15 00:55:12.000000', 'temperatura', 1179.0000, 'ºC'),
	(157885, 121, '2014-01-15 00:55:13.000000', 'temperatura', 431.0000, 'ºC'),
	(157886, 121, '2014-01-15 00:55:14.000000', 'temperatura', 1022.0000, 'ºC'),
	(157887, 121, '2014-01-15 00:55:15.000000', 'temperatura', 215.0000, 'ºC'),
	(157888, 121, '2014-01-15 00:55:16.000000', 'temperatura', 410.0000, 'ºC'),
	(157889, 121, '2014-01-15 00:55:17.000000', 'temperatura', 208.0000, 'ºC'),
	(157890, 121, '2014-01-15 00:55:18.000000', 'temperatura', 1007.0000, 'ºC'),
	(157891, 121, '2014-01-15 00:55:19.000000', 'temperatura', 815.0000, 'ºC'),
	(157892, 121, '2014-01-15 00:55:20.000000', 'temperatura', 1052.0000, 'ºC'),
	(157893, 121, '2014-01-15 00:55:21.000000', 'temperatura', 416.0000, 'ºC'),
	(157894, 121, '2014-01-15 00:55:22.000000', 'temperatura', 127.0000, 'ºC'),
	(157895, 121, '2014-01-15 00:55:23.000000', 'temperatura', 584.0000, 'ºC'),
	(157896, 121, '2014-01-15 00:55:24.000000', 'temperatura', 140.0000, 'ºC'),
	(157897, 121, '2014-01-15 00:55:25.000000', 'temperatura', 150.0000, 'ºC'),
	(157898, 121, '2014-01-15 00:55:26.000000', 'temperatura', 330.0000, 'ºC'),
	(157899, 121, '2014-01-15 00:55:27.000000', 'temperatura', 0.0000, 'ºC'),
	(157900, 121, '2014-01-15 00:55:28.000000', 'temperatura', 210.0000, 'ºC'),
	(157901, 121, '2014-01-15 00:55:29.000000', 'temperatura', 1050.0000, 'ºC'),
	(157902, 121, '2014-01-15 00:55:30.000000', 'temperatura', 1020.0000, 'ºC'),
	(157903, 121, '2014-01-15 00:55:31.000000', 'temperatura', 750.0000, 'ºC'),
	(157904, 121, '2014-01-15 00:55:32.000000', 'temperatura', 692.0000, 'ºC'),
	(157905, 121, '2014-01-15 00:55:33.000000', 'temperatura', 8.0000, 'ºC'),
	(157906, 121, '2014-01-15 00:55:34.000000', 'temperatura', 367.0000, 'ºC'),
	(157907, 121, '2014-01-15 00:55:35.000000', 'temperatura', 613.0000, 'ºC'),
	(157908, 121, '2014-01-15 00:55:36.000000', 'temperatura', 762.0000, 'ºC'),
	(157909, 121, '2014-01-15 00:55:37.000000', 'temperatura', 772.0000, 'ºC'),
	(157910, 121, '2014-01-15 00:55:38.000000', 'temperatura', 376.0000, 'ºC'),
	(157911, 121, '2014-01-15 00:55:39.000000', 'temperatura', 763.0000, 'ºC'),
	(157912, 121, '2014-01-15 00:55:40.000000', 'temperatura', 288.0000, 'ºC'),
	(157913, 121, '2014-01-15 00:55:41.000000', 'temperatura', 353.0000, 'ºC'),
	(157914, 121, '2014-01-15 00:55:42.000000', 'temperatura', 902.0000, 'ºC'),
	(157915, 121, '2014-01-15 00:55:43.000000', 'temperatura', 1052.0000, 'ºC'),
	(157916, 121, '2014-01-15 00:55:44.000000', 'temperatura', 153.0000, 'ºC'),
	(157917, 121, '2014-01-15 00:55:45.000000', 'temperatura', 8.0000, 'ºC'),
	(157918, 121, '2014-01-15 00:55:46.000000', 'temperatura', 783.0000, 'ºC'),
	(157919, 121, '2014-01-15 00:55:47.000000', 'temperatura', 292.0000, 'ºC'),
	(157920, 121, '2014-01-15 00:55:48.000000', 'temperatura', 312.0000, 'ºC'),
	(157921, 121, '2014-01-15 00:55:49.000000', 'temperatura', 684.0000, 'ºC'),
	(157922, 121, '2014-01-15 00:55:50.000000', 'temperatura', 86.0000, 'ºC'),
	(157923, 121, '2014-01-15 00:55:51.000000', 'temperatura', 776.0000, 'ºC'),
	(157924, 121, '2014-01-15 00:55:52.000000', 'temperatura', 24.0000, 'ºC'),
	(157925, 121, '2014-01-15 00:55:53.000000', 'temperatura', 190.0000, 'ºC'),
	(157926, 121, '2014-01-15 00:55:54.000000', 'temperatura', 882.0000, 'ºC'),
	(157927, 121, '2014-01-15 00:55:55.000000', 'temperatura', 238.0000, 'ºC'),
	(157928, 121, '2014-01-15 00:55:56.000000', 'temperatura', 945.0000, 'ºC'),
	(157929, 121, '2014-01-15 00:55:57.000000', 'temperatura', 413.0000, 'ºC'),
	(157930, 121, '2014-01-15 00:55:58.000000', 'temperatura', 430.0000, 'ºC'),
	(157931, 121, '2014-01-15 00:55:59.000000', 'temperatura', 911.0000, 'ºC'),
	(157932, 121, '2014-01-15 00:56:00.000000', 'temperatura', 864.0000, 'ºC'),
	(157933, 121, '2014-01-15 00:56:01.000000', 'temperatura', 391.0000, 'ºC'),
	(157934, 121, '2014-01-15 00:56:02.000000', 'temperatura', 560.0000, 'ºC'),
	(157935, 121, '2014-01-15 00:56:03.000000', 'temperatura', 429.0000, 'ºC'),
	(157936, 121, '2014-01-15 00:56:04.000000', 'temperatura', 467.0000, 'ºC'),
	(157937, 121, '2014-01-15 00:56:05.000000', 'temperatura', 1046.0000, 'ºC'),
	(157938, 121, '2014-01-15 00:56:06.000000', 'temperatura', 229.0000, 'ºC'),
	(157939, 121, '2014-01-15 00:56:07.000000', 'temperatura', 407.0000, 'ºC'),
	(157940, 121, '2014-01-15 00:56:08.000000', 'temperatura', 149.0000, 'ºC'),
	(157941, 121, '2014-01-15 00:56:09.000000', 'temperatura', 724.0000, 'ºC'),
	(157942, 121, '2014-01-15 00:56:10.000000', 'temperatura', 774.0000, 'ºC'),
	(157943, 121, '2014-01-15 00:56:11.000000', 'temperatura', 500.0000, 'ºC'),
	(157944, 121, '2014-01-15 00:56:12.000000', 'temperatura', 179.0000, 'ºC'),
	(157945, 121, '2014-01-15 00:56:13.000000', 'temperatura', 593.0000, 'ºC'),
	(157946, 121, '2014-01-15 00:56:14.000000', 'temperatura', 29.0000, 'ºC'),
	(157947, 121, '2014-01-15 00:56:15.000000', 'temperatura', 766.0000, 'ºC'),
	(157948, 121, '2014-01-15 00:56:16.000000', 'temperatura', 142.0000, 'ºC'),
	(157949, 121, '2014-01-15 00:56:17.000000', 'temperatura', 815.0000, 'ºC'),
	(157950, 121, '2014-01-15 00:56:18.000000', 'temperatura', 50.0000, 'ºC'),
	(157951, 121, '2014-01-15 00:56:19.000000', 'temperatura', 207.0000, 'ºC'),
	(157952, 121, '2014-01-15 00:56:20.000000', 'temperatura', 882.0000, 'ºC'),
	(157953, 121, '2014-01-15 00:56:21.000000', 'temperatura', 191.0000, 'ºC'),
	(157954, 121, '2014-01-15 00:56:22.000000', 'temperatura', 711.0000, 'ºC'),
	(157955, 121, '2014-01-15 00:56:23.000000', 'temperatura', 581.0000, 'ºC'),
	(157956, 121, '2014-01-15 00:56:24.000000', 'temperatura', 775.0000, 'ºC'),
	(157957, 121, '2014-01-15 00:56:25.000000', 'temperatura', 929.0000, 'ºC'),
	(157958, 121, '2014-01-15 00:56:26.000000', 'temperatura', 1122.0000, 'ºC'),
	(157959, 121, '2014-01-15 00:56:27.000000', 'temperatura', 425.0000, 'ºC'),
	(157960, 121, '2014-01-15 00:56:28.000000', 'temperatura', 1158.0000, 'ºC'),
	(157961, 121, '2014-01-15 00:56:29.000000', 'temperatura', 914.0000, 'ºC'),
	(157962, 121, '2014-01-15 00:56:30.000000', 'temperatura', 1099.0000, 'ºC'),
	(157963, 121, '2014-01-15 00:56:31.000000', 'temperatura', 353.0000, 'ºC'),
	(157964, 121, '2014-01-15 00:56:32.000000', 'temperatura', 866.0000, 'ºC'),
	(157965, 121, '2014-01-15 00:56:33.000000', 'temperatura', 875.0000, 'ºC'),
	(157966, 121, '2014-01-15 00:56:34.000000', 'temperatura', 575.0000, 'ºC'),
	(157967, 121, '2014-01-15 00:56:35.000000', 'temperatura', 253.0000, 'ºC'),
	(157968, 121, '2014-01-15 00:56:36.000000', 'temperatura', 738.0000, 'ºC'),
	(157969, 121, '2014-01-15 00:56:37.000000', 'temperatura', 532.0000, 'ºC'),
	(157970, 121, '2014-01-15 00:56:38.000000', 'temperatura', 446.0000, 'ºC'),
	(157971, 121, '2014-01-15 00:56:39.000000', 'temperatura', 634.0000, 'ºC'),
	(157972, 121, '2014-01-15 00:56:40.000000', 'temperatura', 632.0000, 'ºC'),
	(157973, 121, '2014-01-15 00:56:41.000000', 'temperatura', 61.0000, 'ºC'),
	(157974, 121, '2014-01-15 00:56:42.000000', 'temperatura', 809.0000, 'ºC'),
	(157975, 121, '2014-01-15 00:56:43.000000', 'temperatura', 260.0000, 'ºC'),
	(157976, 121, '2014-01-15 00:56:44.000000', 'temperatura', 77.0000, 'ºC'),
	(157977, 121, '2014-01-15 00:56:45.000000', 'temperatura', 803.0000, 'ºC'),
	(157978, 121, '2014-01-15 00:56:46.000000', 'temperatura', 186.0000, 'ºC'),
	(157979, 121, '2014-01-15 00:56:47.000000', 'temperatura', 920.0000, 'ºC'),
	(157980, 121, '2014-01-15 00:56:48.000000', 'temperatura', 443.0000, 'ºC'),
	(157981, 121, '2014-01-15 00:56:49.000000', 'temperatura', 656.0000, 'ºC'),
	(157982, 121, '2014-01-15 00:56:50.000000', 'temperatura', 752.0000, 'ºC'),
	(157983, 121, '2014-01-15 00:56:51.000000', 'temperatura', 591.0000, 'ºC'),
	(157984, 121, '2014-01-15 00:56:52.000000', 'temperatura', 699.0000, 'ºC'),
	(157985, 121, '2014-01-15 00:56:53.000000', 'temperatura', 524.0000, 'ºC'),
	(157986, 121, '2014-01-15 00:56:54.000000', 'temperatura', 521.0000, 'ºC'),
	(157987, 121, '2014-01-15 00:56:55.000000', 'temperatura', 1036.0000, 'ºC'),
	(157988, 121, '2014-01-15 00:56:56.000000', 'temperatura', 18.0000, 'ºC'),
	(157989, 121, '2014-01-15 00:56:57.000000', 'temperatura', 582.0000, 'ºC'),
	(157990, 121, '2014-01-15 00:56:58.000000', 'temperatura', 458.0000, 'ºC'),
	(157991, 121, '2014-01-15 00:56:59.000000', 'temperatura', 544.0000, 'ºC'),
	(157992, 121, '2014-01-15 00:57:00.000000', 'temperatura', 145.0000, 'ºC'),
	(157993, 121, '2014-01-15 00:57:01.000000', 'temperatura', 293.0000, 'ºC'),
	(157994, 121, '2014-01-15 00:57:02.000000', 'temperatura', 1033.0000, 'ºC'),
	(157995, 121, '2014-01-15 00:57:03.000000', 'temperatura', 684.0000, 'ºC'),
	(157996, 121, '2014-01-15 00:57:04.000000', 'temperatura', 323.0000, 'ºC'),
	(157997, 121, '2014-01-15 00:57:05.000000', 'temperatura', 762.0000, 'ºC'),
	(157998, 121, '2014-01-15 00:57:06.000000', 'temperatura', 443.0000, 'ºC'),
	(157999, 121, '2014-01-15 00:57:07.000000', 'temperatura', 1129.0000, 'ºC'),
	(158000, 121, '2014-01-15 00:57:08.000000', 'temperatura', 716.0000, 'ºC'),
	(158001, 121, '2014-01-15 00:57:09.000000', 'temperatura', 193.0000, 'ºC'),
	(158002, 121, '2014-01-15 00:57:10.000000', 'temperatura', 19.0000, 'ºC'),
	(158003, 121, '2014-01-15 00:57:11.000000', 'temperatura', 717.0000, 'ºC'),
	(158004, 121, '2014-01-15 00:57:12.000000', 'temperatura', 1127.0000, 'ºC'),
	(158005, 121, '2014-01-15 00:57:13.000000', 'temperatura', 1083.0000, 'ºC'),
	(158006, 121, '2014-01-15 00:57:14.000000', 'temperatura', 835.0000, 'ºC'),
	(158007, 121, '2014-01-15 00:57:15.000000', 'temperatura', 929.0000, 'ºC'),
	(158008, 121, '2014-01-15 00:57:16.000000', 'temperatura', 938.0000, 'ºC'),
	(158009, 121, '2014-01-15 00:57:17.000000', 'temperatura', 706.0000, 'ºC'),
	(158010, 121, '2014-01-15 00:57:18.000000', 'temperatura', 717.0000, 'ºC'),
	(158011, 121, '2014-01-15 00:57:19.000000', 'temperatura', 267.0000, 'ºC'),
	(158012, 121, '2014-01-15 00:57:20.000000', 'temperatura', 384.0000, 'ºC'),
	(158013, 121, '2014-01-15 00:57:21.000000', 'temperatura', 1119.0000, 'ºC'),
	(158014, 121, '2014-01-15 00:57:22.000000', 'temperatura', 846.0000, 'ºC'),
	(158015, 121, '2014-01-15 00:57:23.000000', 'temperatura', 872.0000, 'ºC'),
	(158016, 121, '2014-01-15 00:57:24.000000', 'temperatura', 622.0000, 'ºC'),
	(158017, 121, '2014-01-15 00:57:25.000000', 'temperatura', 497.0000, 'ºC'),
	(158018, 121, '2014-01-15 00:57:26.000000', 'temperatura', 616.0000, 'ºC'),
	(158019, 121, '2014-01-15 00:57:27.000000', 'temperatura', 392.0000, 'ºC'),
	(158020, 121, '2014-01-15 00:57:28.000000', 'temperatura', 110.0000, 'ºC'),
	(158021, 121, '2014-01-15 00:57:29.000000', 'temperatura', 577.0000, 'ºC'),
	(158022, 121, '2014-01-15 00:57:30.000000', 'temperatura', 154.0000, 'ºC'),
	(158023, 121, '2014-01-15 00:57:31.000000', 'temperatura', 241.0000, 'ºC'),
	(158024, 121, '2014-01-15 00:57:32.000000', 'temperatura', 741.0000, 'ºC'),
	(158025, 121, '2014-01-15 00:57:33.000000', 'temperatura', 582.0000, 'ºC'),
	(158026, 121, '2014-01-15 00:57:34.000000', 'temperatura', 690.0000, 'ºC'),
	(158027, 121, '2014-01-15 00:57:35.000000', 'temperatura', 503.0000, 'ºC'),
	(158028, 121, '2014-01-15 00:57:36.000000', 'temperatura', 447.0000, 'ºC'),
	(158029, 121, '2014-01-15 00:57:37.000000', 'temperatura', 727.0000, 'ºC'),
	(158030, 121, '2014-01-15 00:57:38.000000', 'temperatura', 1095.0000, 'ºC'),
	(158031, 121, '2014-01-15 00:57:39.000000', 'temperatura', 892.0000, 'ºC'),
	(158032, 121, '2014-01-15 00:57:40.000000', 'temperatura', 1177.0000, 'ºC'),
	(158033, 121, '2014-01-15 00:57:41.000000', 'temperatura', 807.0000, 'ºC'),
	(158034, 121, '2014-01-15 00:57:42.000000', 'temperatura', 507.0000, 'ºC'),
	(158035, 121, '2014-01-15 00:57:43.000000', 'temperatura', 115.0000, 'ºC'),
	(158036, 121, '2014-01-15 00:57:44.000000', 'temperatura', 253.0000, 'ºC'),
	(158037, 121, '2014-01-15 00:57:45.000000', 'temperatura', 921.0000, 'ºC'),
	(158038, 121, '2014-01-15 00:57:46.000000', 'temperatura', 246.0000, 'ºC'),
	(158039, 121, '2014-01-15 00:57:47.000000', 'temperatura', 869.0000, 'ºC'),
	(158040, 121, '2014-01-15 00:57:48.000000', 'temperatura', 9.0000, 'ºC'),
	(158041, 121, '2014-01-15 00:57:49.000000', 'temperatura', 1035.0000, 'ºC'),
	(158042, 121, '2014-01-15 00:57:50.000000', 'temperatura', 350.0000, 'ºC'),
	(158043, 121, '2014-01-15 00:57:51.000000', 'temperatura', 1047.0000, 'ºC'),
	(158044, 121, '2014-01-15 00:57:52.000000', 'temperatura', 584.0000, 'ºC'),
	(158045, 121, '2014-01-15 00:57:53.000000', 'temperatura', 980.0000, 'ºC'),
	(158046, 121, '2014-01-15 00:57:54.000000', 'temperatura', 747.0000, 'ºC'),
	(158047, 121, '2014-01-15 00:57:55.000000', 'temperatura', 795.0000, 'ºC'),
	(158048, 121, '2014-01-15 00:57:56.000000', 'temperatura', 537.0000, 'ºC'),
	(158049, 121, '2014-01-15 00:57:57.000000', 'temperatura', 298.0000, 'ºC'),
	(158050, 121, '2014-01-15 00:57:58.000000', 'temperatura', 1081.0000, 'ºC'),
	(158051, 121, '2014-01-15 00:57:59.000000', 'temperatura', 910.0000, 'ºC'),
	(158052, 121, '2014-01-15 00:58:00.000000', 'temperatura', 108.0000, 'ºC'),
	(158053, 121, '2014-01-15 00:58:01.000000', 'temperatura', 213.0000, 'ºC'),
	(158054, 121, '2014-01-15 00:58:02.000000', 'temperatura', 738.0000, 'ºC'),
	(158055, 121, '2014-01-15 00:58:03.000000', 'temperatura', 652.0000, 'ºC'),
	(158056, 121, '2014-01-15 00:58:04.000000', 'temperatura', 1046.0000, 'ºC'),
	(158057, 121, '2014-01-15 00:58:05.000000', 'temperatura', 877.0000, 'ºC'),
	(158058, 121, '2014-01-15 00:58:06.000000', 'temperatura', 46.0000, 'ºC'),
	(158059, 121, '2014-01-15 00:58:07.000000', 'temperatura', 0.0000, 'ºC'),
	(158060, 121, '2014-01-15 00:58:08.000000', 'temperatura', 1060.0000, 'ºC'),
	(158061, 121, '2014-01-15 00:58:09.000000', 'temperatura', 504.0000, 'ºC'),
	(158062, 121, '2014-01-15 00:58:10.000000', 'temperatura', 539.0000, 'ºC'),
	(158063, 121, '2014-01-15 00:58:11.000000', 'temperatura', 1182.0000, 'ºC'),
	(158064, 121, '2014-01-15 00:58:12.000000', 'temperatura', 694.0000, 'ºC'),
	(158065, 121, '2014-01-15 00:58:13.000000', 'temperatura', 1127.0000, 'ºC'),
	(158066, 121, '2014-01-15 00:58:14.000000', 'temperatura', 1150.0000, 'ºC'),
	(158067, 121, '2014-01-15 00:58:15.000000', 'temperatura', 1172.0000, 'ºC'),
	(158068, 121, '2014-01-15 00:58:16.000000', 'temperatura', 11.0000, 'ºC'),
	(158069, 121, '2014-01-15 00:58:17.000000', 'temperatura', 140.0000, 'ºC'),
	(158070, 121, '2014-01-15 00:58:18.000000', 'temperatura', 667.0000, 'ºC'),
	(158071, 121, '2014-01-15 00:58:19.000000', 'temperatura', 516.0000, 'ºC'),
	(158072, 121, '2014-01-15 00:58:20.000000', 'temperatura', 579.0000, 'ºC'),
	(158073, 121, '2014-01-15 00:58:21.000000', 'temperatura', 148.0000, 'ºC'),
	(158074, 121, '2014-01-15 00:58:22.000000', 'temperatura', 204.0000, 'ºC'),
	(158075, 121, '2014-01-15 00:58:23.000000', 'temperatura', 574.0000, 'ºC'),
	(158076, 121, '2014-01-15 00:58:24.000000', 'temperatura', 1062.0000, 'ºC'),
	(158077, 121, '2014-01-15 00:58:25.000000', 'temperatura', 1186.0000, 'ºC'),
	(158078, 121, '2014-01-15 00:58:26.000000', 'temperatura', 344.0000, 'ºC'),
	(158079, 121, '2014-01-15 00:58:27.000000', 'temperatura', 564.0000, 'ºC'),
	(158080, 121, '2014-01-15 00:58:28.000000', 'temperatura', 586.0000, 'ºC'),
	(158081, 121, '2014-01-15 00:58:29.000000', 'temperatura', 41.0000, 'ºC'),
	(158082, 121, '2014-01-15 00:58:30.000000', 'temperatura', 848.0000, 'ºC'),
	(158083, 121, '2014-01-15 00:58:31.000000', 'temperatura', 517.0000, 'ºC'),
	(158084, 121, '2014-01-15 00:58:32.000000', 'temperatura', 42.0000, 'ºC'),
	(158085, 121, '2014-01-15 00:58:33.000000', 'temperatura', 1057.0000, 'ºC'),
	(158086, 121, '2014-01-15 00:58:34.000000', 'temperatura', 361.0000, 'ºC'),
	(158087, 121, '2014-01-15 00:58:35.000000', 'temperatura', 1034.0000, 'ºC'),
	(158088, 121, '2014-01-15 00:58:36.000000', 'temperatura', 487.0000, 'ºC'),
	(158089, 121, '2014-01-15 00:58:37.000000', 'temperatura', 535.0000, 'ºC'),
	(158090, 121, '2014-01-15 00:58:38.000000', 'temperatura', 15.0000, 'ºC'),
	(158091, 121, '2014-01-15 00:58:39.000000', 'temperatura', 870.0000, 'ºC'),
	(158092, 121, '2014-01-15 00:58:40.000000', 'temperatura', 707.0000, 'ºC'),
	(158093, 121, '2014-01-15 00:58:41.000000', 'temperatura', 926.0000, 'ºC'),
	(158094, 121, '2014-01-15 00:58:42.000000', 'temperatura', 106.0000, 'ºC'),
	(158095, 121, '2014-01-15 00:58:43.000000', 'temperatura', 156.0000, 'ºC'),
	(158096, 121, '2014-01-15 00:58:44.000000', 'temperatura', 460.0000, 'ºC'),
	(158097, 121, '2014-01-15 00:58:45.000000', 'temperatura', 633.0000, 'ºC'),
	(158098, 121, '2014-01-15 00:58:46.000000', 'temperatura', 584.0000, 'ºC'),
	(158099, 121, '2014-01-15 00:58:47.000000', 'temperatura', 1024.0000, 'ºC'),
	(158100, 121, '2014-01-15 00:58:48.000000', 'temperatura', 968.0000, 'ºC'),
	(158101, 121, '2014-01-15 00:58:49.000000', 'temperatura', 567.0000, 'ºC'),
	(158102, 121, '2014-01-15 00:58:50.000000', 'temperatura', 1134.0000, 'ºC'),
	(158103, 121, '2014-01-15 00:58:51.000000', 'temperatura', 370.0000, 'ºC'),
	(158104, 121, '2014-01-15 00:58:52.000000', 'temperatura', 848.0000, 'ºC'),
	(158105, 121, '2014-01-15 00:58:53.000000', 'temperatura', 728.0000, 'ºC'),
	(158106, 121, '2014-01-15 00:58:54.000000', 'temperatura', 1099.0000, 'ºC'),
	(158107, 121, '2014-01-15 00:58:55.000000', 'temperatura', 909.0000, 'ºC'),
	(158108, 121, '2014-01-15 00:58:56.000000', 'temperatura', 49.0000, 'ºC'),
	(158109, 121, '2014-01-15 00:58:57.000000', 'temperatura', 1117.0000, 'ºC'),
	(158110, 121, '2014-01-15 00:58:58.000000', 'temperatura', 642.0000, 'ºC'),
	(158111, 121, '2014-01-15 00:58:59.000000', 'temperatura', 1056.0000, 'ºC'),
	(158112, 121, '2014-01-15 00:59:00.000000', 'temperatura', 958.0000, 'ºC'),
	(158113, 121, '2014-01-15 00:59:01.000000', 'temperatura', 419.0000, 'ºC'),
	(158114, 121, '2014-01-15 00:59:02.000000', 'temperatura', 424.0000, 'ºC'),
	(158115, 121, '2014-01-15 00:59:03.000000', 'temperatura', 863.0000, 'ºC'),
	(158116, 121, '2014-01-15 00:59:04.000000', 'temperatura', 643.0000, 'ºC'),
	(158117, 121, '2014-01-15 00:59:05.000000', 'temperatura', 625.0000, 'ºC'),
	(158118, 121, '2014-01-15 00:59:06.000000', 'temperatura', 1198.0000, 'ºC'),
	(158119, 121, '2014-01-15 00:59:07.000000', 'temperatura', 516.0000, 'ºC'),
	(158120, 121, '2014-01-15 00:59:08.000000', 'temperatura', 187.0000, 'ºC'),
	(158121, 121, '2014-01-15 00:59:09.000000', 'temperatura', 589.0000, 'ºC'),
	(158122, 121, '2014-01-15 00:59:10.000000', 'temperatura', 1182.0000, 'ºC'),
	(158123, 121, '2014-01-15 00:59:11.000000', 'temperatura', 545.0000, 'ºC'),
	(158124, 121, '2014-01-15 00:59:12.000000', 'temperatura', 378.0000, 'ºC'),
	(158125, 121, '2014-01-15 00:59:13.000000', 'temperatura', 255.0000, 'ºC'),
	(158126, 121, '2014-01-15 00:59:14.000000', 'temperatura', 142.0000, 'ºC'),
	(158127, 121, '2014-01-15 00:59:15.000000', 'temperatura', 1148.0000, 'ºC'),
	(158128, 121, '2014-01-15 00:59:16.000000', 'temperatura', 512.0000, 'ºC'),
	(158129, 121, '2014-01-15 00:59:17.000000', 'temperatura', 317.0000, 'ºC'),
	(158130, 121, '2014-01-15 00:59:18.000000', 'temperatura', 49.0000, 'ºC'),
	(158131, 121, '2014-01-15 00:59:19.000000', 'temperatura', 497.0000, 'ºC'),
	(158132, 121, '2014-01-15 00:59:20.000000', 'temperatura', 1137.0000, 'ºC'),
	(158133, 121, '2014-01-15 00:59:21.000000', 'temperatura', 594.0000, 'ºC'),
	(158134, 121, '2014-01-15 00:59:22.000000', 'temperatura', 761.0000, 'ºC'),
	(158135, 121, '2014-01-15 00:59:23.000000', 'temperatura', 822.0000, 'ºC'),
	(158136, 121, '2014-01-15 00:59:24.000000', 'temperatura', 630.0000, 'ºC'),
	(158137, 121, '2014-01-15 00:59:25.000000', 'temperatura', 683.0000, 'ºC'),
	(158138, 121, '2014-01-15 00:59:26.000000', 'temperatura', 326.0000, 'ºC'),
	(158139, 121, '2014-01-15 00:59:27.000000', 'temperatura', 780.0000, 'ºC'),
	(158140, 121, '2014-01-15 00:59:28.000000', 'temperatura', 522.0000, 'ºC'),
	(158141, 121, '2014-01-15 00:59:29.000000', 'temperatura', 270.0000, 'ºC'),
	(158142, 121, '2014-01-15 00:59:30.000000', 'temperatura', 985.0000, 'ºC'),
	(158143, 121, '2014-01-15 00:59:31.000000', 'temperatura', 514.0000, 'ºC'),
	(158144, 121, '2014-01-15 00:59:32.000000', 'temperatura', 817.0000, 'ºC'),
	(158145, 121, '2014-01-15 00:59:33.000000', 'temperatura', 142.0000, 'ºC'),
	(158146, 121, '2014-01-15 00:59:34.000000', 'temperatura', 660.0000, 'ºC'),
	(158147, 121, '2014-01-15 00:59:35.000000', 'temperatura', 476.0000, 'ºC'),
	(158148, 121, '2014-01-15 00:59:36.000000', 'temperatura', 400.0000, 'ºC'),
	(158149, 121, '2014-01-15 00:59:37.000000', 'temperatura', 572.0000, 'ºC'),
	(158150, 121, '2014-01-15 00:59:38.000000', 'temperatura', 461.0000, 'ºC'),
	(158151, 121, '2014-01-15 00:59:39.000000', 'temperatura', 588.0000, 'ºC'),
	(158152, 121, '2014-01-15 00:59:40.000000', 'temperatura', 359.0000, 'ºC'),
	(158153, 121, '2014-01-15 00:59:41.000000', 'temperatura', 31.0000, 'ºC'),
	(158154, 121, '2014-01-15 00:59:42.000000', 'temperatura', 278.0000, 'ºC'),
	(158155, 121, '2014-01-15 00:59:43.000000', 'temperatura', 97.0000, 'ºC'),
	(158156, 121, '2014-01-15 00:59:44.000000', 'temperatura', 853.0000, 'ºC'),
	(158157, 121, '2014-01-15 00:59:45.000000', 'temperatura', 376.0000, 'ºC'),
	(158158, 121, '2014-01-15 00:59:46.000000', 'temperatura', 520.0000, 'ºC'),
	(158159, 121, '2014-01-15 00:59:47.000000', 'temperatura', 271.0000, 'ºC'),
	(158160, 121, '2014-01-15 00:59:48.000000', 'temperatura', 998.0000, 'ºC'),
	(158161, 121, '2014-01-15 00:59:49.000000', 'temperatura', 577.0000, 'ºC'),
	(158162, 121, '2014-01-15 00:59:50.000000', 'temperatura', 1090.0000, 'ºC'),
	(158163, 121, '2014-01-15 00:59:51.000000', 'temperatura', 119.0000, 'ºC'),
	(158164, 121, '2014-01-15 00:59:52.000000', 'temperatura', 928.0000, 'ºC'),
	(158165, 121, '2014-01-15 00:59:53.000000', 'temperatura', 682.0000, 'ºC'),
	(158166, 121, '2014-01-15 00:59:54.000000', 'temperatura', 625.0000, 'ºC'),
	(158167, 121, '2014-01-15 00:59:55.000000', 'temperatura', 1082.0000, 'ºC'),
	(158168, 121, '2014-01-15 00:59:56.000000', 'temperatura', 1133.0000, 'ºC'),
	(158169, 121, '2014-01-15 00:59:57.000000', 'temperatura', 19.0000, 'ºC'),
	(158170, 121, '2014-01-15 00:59:58.000000', 'temperatura', 296.0000, 'ºC'),
	(158171, 121, '2014-01-15 00:59:59.000000', 'temperatura', 224.0000, 'ºC'),
	(158172, 121, '2014-01-15 01:00:00.000000', 'temperatura', 234.0000, 'ºC'),
	(158173, 121, '2014-01-15 01:00:01.000000', 'temperatura', 497.0000, 'ºC'),
	(158174, 121, '2014-01-15 01:00:02.000000', 'temperatura', 584.0000, 'ºC'),
	(158175, 121, '2014-01-15 01:00:03.000000', 'temperatura', 228.0000, 'ºC'),
	(158176, 121, '2014-01-15 01:00:04.000000', 'temperatura', 588.0000, 'ºC'),
	(158177, 121, '2014-01-15 01:00:05.000000', 'temperatura', 1057.0000, 'ºC'),
	(158178, 121, '2014-01-15 01:00:06.000000', 'temperatura', 1124.0000, 'ºC'),
	(158179, 121, '2014-01-15 01:00:07.000000', 'temperatura', 46.0000, 'ºC'),
	(158180, 121, '2014-01-15 01:00:08.000000', 'temperatura', 461.0000, 'ºC'),
	(158181, 121, '2014-01-15 01:00:09.000000', 'temperatura', 965.0000, 'ºC'),
	(158182, 121, '2014-01-15 01:00:10.000000', 'temperatura', 1043.0000, 'ºC'),
	(158183, 121, '2014-01-15 01:00:11.000000', 'temperatura', 1120.0000, 'ºC'),
	(158184, 121, '2014-01-15 01:00:12.000000', 'temperatura', 71.0000, 'ºC'),
	(158185, 121, '2014-01-15 01:00:13.000000', 'temperatura', 595.0000, 'ºC'),
	(158186, 121, '2014-01-15 01:00:14.000000', 'temperatura', 365.0000, 'ºC'),
	(158187, 121, '2014-01-15 01:00:15.000000', 'temperatura', 38.0000, 'ºC'),
	(158188, 121, '2014-01-15 01:00:16.000000', 'temperatura', 296.0000, 'ºC'),
	(158189, 121, '2014-01-15 01:00:17.000000', 'temperatura', 166.0000, 'ºC'),
	(158190, 121, '2014-01-15 01:00:18.000000', 'temperatura', 1145.0000, 'ºC'),
	(158191, 121, '2014-01-15 01:00:19.000000', 'temperatura', 425.0000, 'ºC'),
	(158192, 121, '2014-01-15 01:00:20.000000', 'temperatura', 1090.0000, 'ºC'),
	(158193, 121, '2014-01-15 01:00:21.000000', 'temperatura', 575.0000, 'ºC'),
	(158194, 121, '2014-01-15 01:00:22.000000', 'temperatura', 808.0000, 'ºC'),
	(158195, 121, '2014-01-15 01:00:23.000000', 'temperatura', 1113.0000, 'ºC'),
	(158196, 121, '2014-01-15 01:00:24.000000', 'temperatura', 742.0000, 'ºC'),
	(158197, 121, '2014-01-15 01:00:25.000000', 'temperatura', 371.0000, 'ºC'),
	(158198, 121, '2014-01-15 01:00:26.000000', 'temperatura', 829.0000, 'ºC'),
	(158199, 121, '2014-01-15 01:00:27.000000', 'temperatura', 632.0000, 'ºC'),
	(158200, 121, '2014-01-15 01:00:28.000000', 'temperatura', 673.0000, 'ºC'),
	(158201, 121, '2014-01-15 01:00:29.000000', 'temperatura', 270.0000, 'ºC'),
	(158202, 121, '2014-01-15 01:00:30.000000', 'temperatura', 534.0000, 'ºC'),
	(158203, 121, '2014-01-15 01:00:31.000000', 'temperatura', 658.0000, 'ºC'),
	(158204, 121, '2014-01-15 01:00:32.000000', 'temperatura', 491.0000, 'ºC'),
	(158205, 121, '2014-01-15 01:00:33.000000', 'temperatura', 479.0000, 'ºC'),
	(158206, 121, '2014-01-15 01:00:34.000000', 'temperatura', 923.0000, 'ºC'),
	(158207, 121, '2014-01-15 01:00:35.000000', 'temperatura', 780.0000, 'ºC'),
	(158208, 121, '2014-01-15 01:00:36.000000', 'temperatura', 1131.0000, 'ºC'),
	(158209, 121, '2014-01-15 01:00:37.000000', 'temperatura', 916.0000, 'ºC'),
	(158210, 121, '2014-01-15 01:00:38.000000', 'temperatura', 1186.0000, 'ºC'),
	(158211, 121, '2014-01-15 01:00:39.000000', 'temperatura', 784.0000, 'ºC'),
	(158212, 121, '2014-01-15 01:00:40.000000', 'temperatura', 363.0000, 'ºC'),
	(158213, 121, '2014-01-15 01:00:41.000000', 'temperatura', 665.0000, 'ºC'),
	(158214, 121, '2014-01-15 01:00:42.000000', 'temperatura', 1034.0000, 'ºC'),
	(158215, 121, '2014-01-15 01:00:43.000000', 'temperatura', 774.0000, 'ºC'),
	(158216, 121, '2014-01-15 01:00:44.000000', 'temperatura', 772.0000, 'ºC'),
	(158217, 121, '2014-01-15 01:00:45.000000', 'temperatura', 337.0000, 'ºC'),
	(158218, 121, '2014-01-15 01:00:46.000000', 'temperatura', 569.0000, 'ºC'),
	(158219, 121, '2014-01-15 01:00:47.000000', 'temperatura', 636.0000, 'ºC'),
	(158220, 121, '2014-01-15 01:00:48.000000', 'temperatura', 271.0000, 'ºC'),
	(158221, 121, '2014-01-15 01:00:49.000000', 'temperatura', 650.0000, 'ºC'),
	(158222, 121, '2014-01-15 01:00:50.000000', 'temperatura', 37.0000, 'ºC'),
	(158223, 121, '2014-01-15 01:00:51.000000', 'temperatura', 633.0000, 'ºC'),
	(158224, 121, '2014-01-15 01:00:52.000000', 'temperatura', 656.0000, 'ºC'),
	(158225, 121, '2014-01-15 01:00:53.000000', 'temperatura', 183.0000, 'ºC'),
	(158226, 121, '2014-01-15 01:00:54.000000', 'temperatura', 148.0000, 'ºC'),
	(158227, 121, '2014-01-15 01:00:55.000000', 'temperatura', 192.0000, 'ºC'),
	(158228, 121, '2014-01-15 01:00:56.000000', 'temperatura', 515.0000, 'ºC'),
	(158229, 121, '2014-01-15 01:00:57.000000', 'temperatura', 801.0000, 'ºC'),
	(158230, 121, '2014-01-15 01:00:58.000000', 'temperatura', 58.0000, 'ºC'),
	(158231, 121, '2014-01-15 01:00:59.000000', 'temperatura', 291.0000, 'ºC'),
	(158232, 121, '2014-01-15 01:01:00.000000', 'temperatura', 78.0000, 'ºC'),
	(158233, 121, '2014-01-15 01:01:01.000000', 'temperatura', 719.0000, 'ºC'),
	(158234, 121, '2014-01-15 01:01:02.000000', 'temperatura', 963.0000, 'ºC'),
	(158235, 121, '2014-01-15 01:01:03.000000', 'temperatura', 257.0000, 'ºC'),
	(158236, 121, '2014-01-15 01:01:04.000000', 'temperatura', 795.0000, 'ºC'),
	(158237, 121, '2014-01-15 01:01:05.000000', 'temperatura', 805.0000, 'ºC'),
	(158238, 121, '2014-01-15 01:01:06.000000', 'temperatura', 440.0000, 'ºC'),
	(158239, 121, '2014-01-15 01:01:07.000000', 'temperatura', 988.0000, 'ºC'),
	(158240, 121, '2014-01-15 01:01:08.000000', 'temperatura', 17.0000, 'ºC'),
	(158241, 121, '2014-01-15 01:01:09.000000', 'temperatura', 725.0000, 'ºC'),
	(158242, 121, '2014-01-15 01:01:10.000000', 'temperatura', 1172.0000, 'ºC'),
	(158243, 121, '2014-01-15 01:01:11.000000', 'temperatura', 87.0000, 'ºC'),
	(158244, 121, '2014-01-15 01:01:12.000000', 'temperatura', 517.0000, 'ºC'),
	(158245, 121, '2014-01-15 01:01:13.000000', 'temperatura', 1126.0000, 'ºC'),
	(158246, 121, '2014-01-15 01:01:14.000000', 'temperatura', 478.0000, 'ºC'),
	(158247, 121, '2014-01-15 01:01:15.000000', 'temperatura', 213.0000, 'ºC'),
	(158248, 121, '2014-01-15 01:01:16.000000', 'temperatura', 830.0000, 'ºC'),
	(158249, 121, '2014-01-15 01:01:17.000000', 'temperatura', 1115.0000, 'ºC'),
	(158250, 121, '2014-01-15 01:01:18.000000', 'temperatura', 683.0000, 'ºC'),
	(158251, 121, '2014-01-15 01:01:19.000000', 'temperatura', 72.0000, 'ºC'),
	(158252, 121, '2014-01-15 01:01:20.000000', 'temperatura', 713.0000, 'ºC'),
	(158253, 121, '2014-01-15 01:01:21.000000', 'temperatura', 947.0000, 'ºC'),
	(158254, 121, '2014-01-15 01:01:22.000000', 'temperatura', 196.0000, 'ºC'),
	(158255, 121, '2014-01-15 01:01:23.000000', 'temperatura', 539.0000, 'ºC'),
	(158256, 121, '2014-01-15 01:01:24.000000', 'temperatura', 909.0000, 'ºC'),
	(158257, 121, '2014-01-15 01:01:25.000000', 'temperatura', 527.0000, 'ºC'),
	(158258, 121, '2014-01-15 01:01:26.000000', 'temperatura', 1108.0000, 'ºC'),
	(158259, 121, '2014-01-15 01:01:27.000000', 'temperatura', 361.0000, 'ºC'),
	(158260, 121, '2014-01-15 01:01:28.000000', 'temperatura', 882.0000, 'ºC'),
	(158261, 121, '2014-01-15 01:01:29.000000', 'temperatura', 928.0000, 'ºC'),
	(158262, 121, '2014-01-15 01:01:30.000000', 'temperatura', 794.0000, 'ºC'),
	(158263, 121, '2014-01-15 01:01:31.000000', 'temperatura', 1185.0000, 'ºC'),
	(158264, 121, '2014-01-15 01:01:32.000000', 'temperatura', 1144.0000, 'ºC'),
	(158265, 121, '2014-01-15 01:01:33.000000', 'temperatura', 964.0000, 'ºC'),
	(158266, 121, '2014-01-15 01:01:34.000000', 'temperatura', 189.0000, 'ºC'),
	(158267, 121, '2014-01-15 01:01:35.000000', 'temperatura', 454.0000, 'ºC'),
	(158268, 121, '2014-01-15 01:01:36.000000', 'temperatura', 503.0000, 'ºC'),
	(158269, 121, '2014-01-15 01:01:37.000000', 'temperatura', 1152.0000, 'ºC'),
	(158270, 121, '2014-01-15 01:01:38.000000', 'temperatura', 653.0000, 'ºC'),
	(158271, 121, '2014-01-15 01:01:39.000000', 'temperatura', 1011.0000, 'ºC'),
	(158272, 121, '2014-01-15 01:01:40.000000', 'temperatura', 696.0000, 'ºC'),
	(158273, 121, '2014-01-15 01:01:41.000000', 'temperatura', 448.0000, 'ºC'),
	(158274, 121, '2014-01-15 01:01:42.000000', 'temperatura', 150.0000, 'ºC'),
	(158275, 121, '2014-01-15 01:01:43.000000', 'temperatura', 608.0000, 'ºC'),
	(158276, 121, '2014-01-15 01:01:44.000000', 'temperatura', 192.0000, 'ºC'),
	(158277, 121, '2014-01-15 01:01:45.000000', 'temperatura', 337.0000, 'ºC'),
	(158278, 121, '2014-01-15 01:01:46.000000', 'temperatura', 1109.0000, 'ºC'),
	(158279, 121, '2014-01-15 01:01:47.000000', 'temperatura', 933.0000, 'ºC'),
	(158280, 121, '2014-01-15 01:01:48.000000', 'temperatura', 138.0000, 'ºC'),
	(158281, 121, '2014-01-15 01:01:49.000000', 'temperatura', 291.0000, 'ºC'),
	(158282, 121, '2014-01-15 01:01:50.000000', 'temperatura', 1041.0000, 'ºC'),
	(158283, 121, '2014-01-15 01:01:51.000000', 'temperatura', 734.0000, 'ºC'),
	(158284, 121, '2014-01-15 01:01:52.000000', 'temperatura', 549.0000, 'ºC'),
	(158285, 121, '2014-01-15 01:01:53.000000', 'temperatura', 540.0000, 'ºC'),
	(158286, 121, '2014-01-15 01:01:54.000000', 'temperatura', 1056.0000, 'ºC'),
	(158287, 121, '2014-01-15 01:01:55.000000', 'temperatura', 61.0000, 'ºC'),
	(158288, 121, '2014-01-15 01:01:56.000000', 'temperatura', 735.0000, 'ºC'),
	(158289, 121, '2014-01-15 01:01:57.000000', 'temperatura', 1092.0000, 'ºC'),
	(158290, 121, '2014-01-15 01:01:58.000000', 'temperatura', 859.0000, 'ºC'),
	(158291, 121, '2014-01-15 01:01:59.000000', 'temperatura', 1017.0000, 'ºC'),
	(158292, 121, '2014-01-15 01:02:00.000000', 'temperatura', 108.0000, 'ºC'),
	(158293, 121, '2014-01-15 01:02:01.000000', 'temperatura', 1090.0000, 'ºC'),
	(158294, 121, '2014-01-15 01:02:02.000000', 'temperatura', 325.0000, 'ºC'),
	(158295, 121, '2014-01-15 01:02:03.000000', 'temperatura', 756.0000, 'ºC'),
	(158296, 121, '2014-01-15 01:02:04.000000', 'temperatura', 405.0000, 'ºC'),
	(158297, 121, '2014-01-15 01:02:05.000000', 'temperatura', 960.0000, 'ºC'),
	(158298, 121, '2014-01-15 01:02:06.000000', 'temperatura', 1183.0000, 'ºC'),
	(158299, 121, '2014-01-15 01:02:07.000000', 'temperatura', 638.0000, 'ºC'),
	(158300, 121, '2014-01-15 01:02:08.000000', 'temperatura', 840.0000, 'ºC'),
	(158301, 121, '2014-01-15 01:02:09.000000', 'temperatura', 1087.0000, 'ºC'),
	(158302, 121, '2014-01-15 01:02:10.000000', 'temperatura', 517.0000, 'ºC'),
	(158303, 121, '2014-01-15 01:02:11.000000', 'temperatura', 522.0000, 'ºC'),
	(158304, 121, '2014-01-15 01:02:12.000000', 'temperatura', 1061.0000, 'ºC'),
	(158305, 121, '2014-01-15 01:02:13.000000', 'temperatura', 140.0000, 'ºC'),
	(158306, 121, '2014-01-15 01:02:14.000000', 'temperatura', 1117.0000, 'ºC'),
	(158307, 121, '2014-01-15 01:02:15.000000', 'temperatura', 366.0000, 'ºC'),
	(158308, 121, '2014-01-15 01:02:16.000000', 'temperatura', 878.0000, 'ºC'),
	(158309, 121, '2014-01-15 01:02:17.000000', 'temperatura', 895.0000, 'ºC'),
	(158310, 121, '2014-01-15 01:02:18.000000', 'temperatura', 640.0000, 'ºC'),
	(158311, 121, '2014-01-15 01:02:19.000000', 'temperatura', 514.0000, 'ºC'),
	(158312, 121, '2014-01-15 01:02:20.000000', 'temperatura', 653.0000, 'ºC'),
	(158313, 121, '2014-01-15 01:02:21.000000', 'temperatura', 524.0000, 'ºC'),
	(158314, 121, '2014-01-15 01:02:22.000000', 'temperatura', 660.0000, 'ºC'),
	(158315, 121, '2014-01-15 01:02:23.000000', 'temperatura', 527.0000, 'ºC'),
	(158316, 121, '2014-01-15 01:02:24.000000', 'temperatura', 657.0000, 'ºC'),
	(158317, 121, '2014-01-15 01:02:25.000000', 'temperatura', 502.0000, 'ºC'),
	(158318, 121, '2014-01-15 01:02:26.000000', 'temperatura', 543.0000, 'ºC'),
	(158319, 121, '2014-01-15 01:02:27.000000', 'temperatura', 8.0000, 'ºC'),
	(158320, 121, '2014-01-15 01:02:28.000000', 'temperatura', 811.0000, 'ºC'),
	(158321, 121, '2014-01-15 01:02:29.000000', 'temperatura', 432.0000, 'ºC'),
	(158322, 121, '2014-01-15 01:02:30.000000', 'temperatura', 927.0000, 'ºC'),
	(158323, 121, '2014-01-15 01:02:31.000000', 'temperatura', 942.0000, 'ºC'),
	(158324, 121, '2014-01-15 01:02:32.000000', 'temperatura', 728.0000, 'ºC'),
	(158325, 121, '2014-01-15 01:02:33.000000', 'temperatura', 813.0000, 'ºC'),
	(158326, 121, '2014-01-15 01:02:34.000000', 'temperatura', 683.0000, 'ºC'),
	(158327, 121, '2014-01-15 01:02:35.000000', 'temperatura', 977.0000, 'ºC'),
	(158328, 121, '2014-01-15 01:02:36.000000', 'temperatura', 435.0000, 'ºC'),
	(158329, 121, '2014-01-15 01:02:37.000000', 'temperatura', 443.0000, 'ºC'),
	(158330, 121, '2014-01-15 01:02:38.000000', 'temperatura', 914.0000, 'ºC'),
	(158331, 121, '2014-01-15 01:02:39.000000', 'temperatura', 839.0000, 'ºC'),
	(158332, 121, '2014-01-15 01:02:40.000000', 'temperatura', 253.0000, 'ºC'),
	(158333, 121, '2014-01-15 01:02:41.000000', 'temperatura', 1147.0000, 'ºC'),
	(158334, 121, '2014-01-15 01:02:42.000000', 'temperatura', 180.0000, 'ºC'),
	(158335, 121, '2014-01-15 01:02:43.000000', 'temperatura', 1059.0000, 'ºC'),
	(158336, 121, '2014-01-15 01:02:44.000000', 'temperatura', 1154.0000, 'ºC'),
	(158337, 121, '2014-01-15 01:02:45.000000', 'temperatura', 192.0000, 'ºC'),
	(158338, 121, '2014-01-15 01:02:46.000000', 'temperatura', 1102.0000, 'ºC'),
	(158339, 121, '2014-01-15 01:02:47.000000', 'temperatura', 132.0000, 'ºC'),
	(158340, 121, '2014-01-15 01:02:48.000000', 'temperatura', 956.0000, 'ºC'),
	(158341, 121, '2014-01-15 01:02:49.000000', 'temperatura', 783.0000, 'ºC'),
	(158342, 121, '2014-01-15 01:02:50.000000', 'temperatura', 1047.0000, 'ºC'),
	(158343, 121, '2014-01-15 01:02:51.000000', 'temperatura', 486.0000, 'ºC'),
	(158344, 121, '2014-01-15 01:02:52.000000', 'temperatura', 490.0000, 'ºC'),
	(158345, 121, '2014-01-15 01:02:53.000000', 'temperatura', 992.0000, 'ºC'),
	(158346, 121, '2014-01-15 01:02:54.000000', 'temperatura', 1090.0000, 'ºC'),
	(158347, 121, '2014-01-15 01:02:55.000000', 'temperatura', 74.0000, 'ºC'),
	(158348, 121, '2014-01-15 01:02:56.000000', 'temperatura', 701.0000, 'ºC'),
	(158349, 121, '2014-01-15 01:02:57.000000', 'temperatura', 882.0000, 'ºC'),
	(158350, 121, '2014-01-15 01:02:58.000000', 'temperatura', 1107.0000, 'ºC'),
	(158351, 121, '2014-01-15 01:02:59.000000', 'temperatura', 492.0000, 'ºC'),
	(158352, 121, '2014-01-15 01:03:00.000000', 'temperatura', 338.0000, 'ºC'),
	(158353, 121, '2014-01-15 01:03:01.000000', 'temperatura', 216.0000, 'ºC'),
	(158354, 121, '2014-01-15 01:03:02.000000', 'temperatura', 64.0000, 'ºC'),
	(158355, 121, '2014-01-15 01:03:03.000000', 'temperatura', 873.0000, 'ºC'),
	(158356, 121, '2014-01-15 01:03:04.000000', 'temperatura', 576.0000, 'ºC'),
	(158357, 121, '2014-01-15 01:03:05.000000', 'temperatura', 258.0000, 'ºC'),
	(158358, 121, '2014-01-15 01:03:06.000000', 'temperatura', 765.0000, 'ºC'),
	(158359, 121, '2014-01-15 01:03:07.000000', 'temperatura', 650.0000, 'ºC'),
	(158360, 121, '2014-01-15 01:03:08.000000', 'temperatura', 954.0000, 'ºC'),
	(158361, 121, '2014-01-15 01:03:09.000000', 'temperatura', 424.0000, 'ºC'),
	(158362, 121, '2014-01-15 01:03:10.000000', 'temperatura', 456.0000, 'ºC'),
	(158363, 121, '2014-01-15 01:03:11.000000', 'temperatura', 1007.0000, 'ºC'),
	(158364, 121, '2014-01-15 01:03:12.000000', 'temperatura', 71.0000, 'ºC'),
	(158365, 121, '2014-01-15 01:03:13.000000', 'temperatura', 932.0000, 'ºC'),
	(158366, 121, '2014-01-15 01:03:14.000000', 'temperatura', 846.0000, 'ºC'),
	(158367, 121, '2014-01-15 01:03:15.000000', 'temperatura', 237.0000, 'ºC'),
	(158368, 121, '2014-01-15 01:03:16.000000', 'temperatura', 1049.0000, 'ºC'),
	(158369, 121, '2014-01-15 01:03:17.000000', 'temperatura', 932.0000, 'ºC'),
	(158370, 121, '2014-01-15 01:03:18.000000', 'temperatura', 316.0000, 'ºC'),
	(158371, 121, '2014-01-15 01:03:19.000000', 'temperatura', 1183.0000, 'ºC'),
	(158372, 121, '2014-01-15 01:03:20.000000', 'temperatura', 167.0000, 'ºC'),
	(158373, 121, '2014-01-15 01:03:21.000000', 'temperatura', 889.0000, 'ºC'),
	(158374, 121, '2014-01-15 01:03:22.000000', 'temperatura', 341.0000, 'ºC'),
	(158375, 121, '2014-01-15 01:03:23.000000', 'temperatura', 241.0000, 'ºC'),
	(158376, 121, '2014-01-15 01:03:24.000000', 'temperatura', 181.0000, 'ºC'),
	(158377, 121, '2014-01-15 01:03:25.000000', 'temperatura', 185.0000, 'ºC'),
	(158378, 121, '2014-01-15 01:03:26.000000', 'temperatura', 381.0000, 'ºC'),
	(158379, 121, '2014-01-15 01:03:27.000000', 'temperatura', 149.0000, 'ºC'),
	(158380, 121, '2014-01-15 01:03:28.000000', 'temperatura', 805.0000, 'ºC'),
	(158381, 121, '2014-01-15 01:03:29.000000', 'temperatura', 1179.0000, 'ºC'),
	(158382, 121, '2014-01-15 01:03:30.000000', 'temperatura', 1082.0000, 'ºC'),
	(158383, 121, '2014-01-15 01:03:31.000000', 'temperatura', 670.0000, 'ºC'),
	(158384, 121, '2014-01-15 01:03:32.000000', 'temperatura', 104.0000, 'ºC'),
	(158385, 121, '2014-01-15 01:03:33.000000', 'temperatura', 912.0000, 'ºC'),
	(158386, 121, '2014-01-15 01:03:34.000000', 'temperatura', 646.0000, 'ºC'),
	(158387, 121, '2014-01-15 01:03:35.000000', 'temperatura', 497.0000, 'ºC'),
	(158388, 121, '2014-01-15 01:03:36.000000', 'temperatura', 548.0000, 'ºC'),
	(158389, 121, '2014-01-15 01:03:37.000000', 'temperatura', 47.0000, 'ºC'),
	(158390, 121, '2014-01-15 01:03:38.000000', 'temperatura', 994.0000, 'ºC'),
	(158391, 121, '2014-01-15 01:03:39.000000', 'temperatura', 30.0000, 'ºC'),
	(158392, 121, '2014-01-15 01:03:40.000000', 'temperatura', 766.0000, 'ºC'),
	(158393, 121, '2014-01-15 01:03:41.000000', 'temperatura', 142.0000, 'ºC'),
	(158394, 121, '2014-01-15 01:03:42.000000', 'temperatura', 812.0000, 'ºC'),
	(158395, 121, '2014-01-15 01:03:43.000000', 'temperatura', 34.0000, 'ºC'),
	(158396, 121, '2014-01-15 01:03:44.000000', 'temperatura', 136.0000, 'ºC'),
	(158397, 121, '2014-01-15 01:03:45.000000', 'temperatura', 578.0000, 'ºC'),
	(158398, 121, '2014-01-15 01:03:46.000000', 'temperatura', 81.0000, 'ºC'),
	(158399, 121, '2014-01-15 01:03:47.000000', 'temperatura', 1073.0000, 'ºC'),
	(158400, 121, '2014-01-15 01:03:48.000000', 'temperatura', 321.0000, 'ºC'),
	(158401, 121, '2014-01-15 01:03:49.000000', 'temperatura', 786.0000, 'ºC'),
	(158402, 121, '2014-01-15 01:03:50.000000', 'temperatura', 566.0000, 'ºC'),
	(158403, 121, '2014-01-15 01:03:51.000000', 'temperatura', 476.0000, 'ºC'),
	(158404, 121, '2014-01-15 01:03:52.000000', 'temperatura', 682.0000, 'ºC'),
	(158405, 121, '2014-01-15 01:03:53.000000', 'temperatura', 782.0000, 'ºC'),
	(158406, 121, '2014-01-15 01:03:54.000000', 'temperatura', 665.0000, 'ºC'),
	(158407, 121, '2014-01-15 01:03:55.000000', 'temperatura', 981.0000, 'ºC'),
	(158408, 121, '2014-01-15 01:03:56.000000', 'temperatura', 507.0000, 'ºC'),
	(158409, 121, '2014-01-15 01:03:57.000000', 'temperatura', 795.0000, 'ºC'),
	(158410, 121, '2014-01-15 01:03:58.000000', 'temperatura', 55.0000, 'ºC'),
	(158411, 121, '2014-01-15 01:03:59.000000', 'temperatura', 292.0000, 'ºC'),
	(158412, 121, '2014-01-15 01:04:00.000000', 'temperatura', 92.0000, 'ºC'),
	(158413, 121, '2014-01-15 01:04:01.000000', 'temperatura', 785.0000, 'ºC'),
	(158414, 121, '2014-01-15 01:04:02.000000', 'temperatura', 49.0000, 'ºC'),
	(158415, 121, '2014-01-15 01:04:03.000000', 'temperatura', 291.0000, 'ºC'),
	(158416, 121, '2014-01-15 01:04:04.000000', 'temperatura', 110.0000, 'ºC'),
	(158417, 121, '2014-01-15 01:04:05.000000', 'temperatura', 876.0000, 'ºC'),
	(158418, 121, '2014-01-15 01:04:06.000000', 'temperatura', 450.0000, 'ºC'),
	(158419, 121, '2014-01-15 01:04:07.000000', 'temperatura', 825.0000, 'ºC'),
	(158420, 121, '2014-01-15 01:04:08.000000', 'temperatura', 374.0000, 'ºC'),
	(158421, 121, '2014-01-15 01:04:09.000000', 'temperatura', 597.0000, 'ºC'),
	(158422, 121, '2014-01-15 01:04:10.000000', 'temperatura', 662.0000, 'ºC'),
	(158423, 121, '2014-01-15 01:04:11.000000', 'temperatura', 319.0000, 'ºC'),
	(158424, 121, '2014-01-15 01:04:12.000000', 'temperatura', 811.0000, 'ºC'),
	(158425, 121, '2014-01-15 01:04:13.000000', 'temperatura', 700.0000, 'ºC'),
	(158426, 121, '2014-01-15 01:04:14.000000', 'temperatura', 1066.0000, 'ºC'),
	(158427, 121, '2014-01-15 01:04:15.000000', 'temperatura', 831.0000, 'ºC'),
	(158428, 121, '2014-01-15 01:04:16.000000', 'temperatura', 957.0000, 'ºC'),
	(158429, 121, '2014-01-15 01:04:17.000000', 'temperatura', 1093.0000, 'ºC'),
	(158430, 121, '2014-01-15 01:04:18.000000', 'temperatura', 196.0000, 'ºC'),
	(158431, 121, '2014-01-15 01:04:19.000000', 'temperatura', 99.0000, 'ºC'),
	(158432, 121, '2014-01-15 01:04:20.000000', 'temperatura', 1109.0000, 'ºC'),
	(158433, 121, '2014-01-15 01:04:21.000000', 'temperatura', 448.0000, 'ºC'),
	(158434, 121, '2014-01-15 01:04:22.000000', 'temperatura', 114.0000, 'ºC'),
	(158435, 121, '2014-01-15 01:04:23.000000', 'temperatura', 426.0000, 'ºC'),
	(158436, 121, '2014-01-15 01:04:24.000000', 'temperatura', 591.0000, 'ºC'),
	(158437, 121, '2014-01-15 01:04:25.000000', 'temperatura', 475.0000, 'ºC'),
	(158438, 121, '2014-01-15 01:04:26.000000', 'temperatura', 603.0000, 'ºC'),
	(158439, 121, '2014-01-15 01:04:27.000000', 'temperatura', 389.0000, 'ºC'),
	(158440, 121, '2014-01-15 01:04:28.000000', 'temperatura', 136.0000, 'ºC'),
	(158441, 121, '2014-01-15 01:04:29.000000', 'temperatura', 714.0000, 'ºC'),
	(158442, 121, '2014-01-15 01:04:30.000000', 'temperatura', 762.0000, 'ºC'),
	(158443, 121, '2014-01-15 01:04:31.000000', 'temperatura', 468.0000, 'ºC'),
	(158444, 121, '2014-01-15 01:04:32.000000', 'temperatura', 54.0000, 'ºC'),
	(158445, 121, '2014-01-15 01:04:33.000000', 'temperatura', 67.0000, 'ºC'),
	(158446, 121, '2014-01-15 01:04:34.000000', 'temperatura', 174.0000, 'ºC'),
	(158447, 121, '2014-01-15 01:04:35.000000', 'temperatura', 670.0000, 'ºC'),
	(158448, 121, '2014-01-15 01:04:36.000000', 'temperatura', 427.0000, 'ºC'),
	(158449, 121, '2014-01-15 01:04:37.000000', 'temperatura', 126.0000, 'ºC'),
	(158450, 121, '2014-01-15 01:04:38.000000', 'temperatura', 552.0000, 'ºC'),
	(158451, 121, '2014-01-15 01:04:39.000000', 'temperatura', 1179.0000, 'ºC'),
	(158452, 121, '2014-01-15 01:04:40.000000', 'temperatura', 640.0000, 'ºC'),
	(158453, 121, '2014-01-15 01:04:41.000000', 'temperatura', 862.0000, 'ºC'),
	(158454, 121, '2014-01-15 01:04:42.000000', 'temperatura', 1193.0000, 'ºC'),
	(158455, 121, '2014-01-15 01:04:43.000000', 'temperatura', 981.0000, 'ºC'),
	(158456, 121, '2014-01-15 01:04:44.000000', 'temperatura', 124.0000, 'ºC'),
	(158457, 121, '2014-01-15 01:04:45.000000', 'temperatura', 77.0000, 'ºC'),
	(158458, 121, '2014-01-15 01:04:46.000000', 'temperatura', 12.0000, 'ºC'),
	(158459, 121, '2014-01-15 01:04:47.000000', 'temperatura', 1033.0000, 'ºC'),
	(158460, 121, '2014-01-15 01:04:48.000000', 'temperatura', 326.0000, 'ºC'),
	(158461, 121, '2014-01-15 01:04:49.000000', 'temperatura', 933.0000, 'ºC'),
	(158462, 121, '2014-01-15 01:04:50.000000', 'temperatura', 89.0000, 'ºC'),
	(158463, 121, '2014-01-15 01:04:51.000000', 'temperatura', 44.0000, 'ºC'),
	(158464, 121, '2014-01-15 01:04:52.000000', 'temperatura', 1153.0000, 'ºC'),
	(158465, 121, '2014-01-15 01:04:53.000000', 'temperatura', 835.0000, 'ºC'),
	(158466, 121, '2014-01-15 01:04:54.000000', 'temperatura', 715.0000, 'ºC'),
	(158467, 121, '2014-01-15 01:04:55.000000', 'temperatura', 1072.0000, 'ºC'),
	(158468, 121, '2014-01-15 01:04:56.000000', 'temperatura', 815.0000, 'ºC'),
	(158469, 121, '2014-01-15 01:04:57.000000', 'temperatura', 861.0000, 'ºC'),
	(158470, 121, '2014-01-15 01:04:58.000000', 'temperatura', 658.0000, 'ºC'),
	(158471, 121, '2014-01-15 01:04:59.000000', 'temperatura', 707.0000, 'ºC'),
	(158472, 121, '2014-01-15 01:05:00.000000', 'temperatura', 364.0000, 'ºC'),
	(158473, 121, '2014-01-15 01:05:01.000000', 'temperatura', 897.0000, 'ºC'),
	(158474, 121, '2014-01-15 01:05:02.000000', 'temperatura', 993.0000, 'ºC'),
	(158475, 121, '2014-01-15 01:05:03.000000', 'temperatura', 1076.0000, 'ºC'),
	(158476, 121, '2014-01-15 01:05:04.000000', 'temperatura', 0.0000, 'ºC'),
	(158477, 121, '2014-01-15 01:05:05.000000', 'temperatura', 374.0000, 'ºC'),
	(158478, 121, '2014-01-15 01:05:06.000000', 'temperatura', 668.0000, 'ºC'),
	(158479, 121, '2014-01-15 01:05:07.000000', 'temperatura', 1021.0000, 'ºC'),
	(158480, 121, '2014-01-15 01:05:08.000000', 'temperatura', 699.0000, 'ºC'),
	(158481, 121, '2014-01-15 01:05:09.000000', 'temperatura', 435.0000, 'ºC'),
	(158482, 121, '2014-01-15 01:05:10.000000', 'temperatura', 76.0000, 'ºC'),
	(158483, 121, '2014-01-15 01:05:11.000000', 'temperatura', 276.0000, 'ºC'),
	(158484, 121, '2014-01-15 01:05:12.000000', 'temperatura', 1152.0000, 'ºC'),
	(158485, 121, '2014-01-15 01:05:13.000000', 'temperatura', 131.0000, 'ºC'),
	(158486, 121, '2014-01-15 01:05:14.000000', 'temperatura', 803.0000, 'ºC'),
	(158487, 121, '2014-01-15 01:05:15.000000', 'temperatura', 20.0000, 'ºC'),
	(158488, 121, '2014-01-15 01:05:16.000000', 'temperatura', 91.0000, 'ºC'),
	(158489, 121, '2014-01-15 01:05:17.000000', 'temperatura', 395.0000, 'ºC'),
	(158490, 121, '2014-01-15 01:05:18.000000', 'temperatura', 502.0000, 'ºC'),
	(158491, 121, '2014-01-15 01:05:19.000000', 'temperatura', 125.0000, 'ºC'),
	(158492, 121, '2014-01-15 01:05:20.000000', 'temperatura', 321.0000, 'ºC'),
	(158493, 121, '2014-01-15 01:05:21.000000', 'temperatura', 29.0000, 'ºC'),
	(158494, 121, '2014-01-15 01:05:22.000000', 'temperatura', 383.0000, 'ºC'),
	(158495, 121, '2014-01-15 01:05:23.000000', 'temperatura', 631.0000, 'ºC'),
	(158496, 121, '2014-01-15 01:05:24.000000', 'temperatura', 803.0000, 'ºC'),
	(158497, 121, '2014-01-15 01:05:25.000000', 'temperatura', 924.0000, 'ºC'),
	(158498, 121, '2014-01-15 01:05:26.000000', 'temperatura', 1010.0000, 'ºC'),
	(158499, 121, '2014-01-15 01:05:27.000000', 'temperatura', 1080.0000, 'ºC'),
	(158500, 121, '2014-01-15 01:05:28.000000', 'temperatura', 1171.0000, 'ºC'),
	(158501, 121, '2014-01-15 01:05:29.000000', 'temperatura', 213.0000, 'ºC'),
	(158502, 121, '2014-01-15 01:05:30.000000', 'temperatura', 1155.0000, 'ºC'),
	(158503, 121, '2014-01-15 01:05:31.000000', 'temperatura', 334.0000, 'ºC'),
	(158504, 121, '2014-01-15 01:05:32.000000', 'temperatura', 606.0000, 'ºC'),
	(158505, 121, '2014-01-15 01:05:33.000000', 'temperatura', 831.0000, 'ºC'),
	(158506, 121, '2014-01-15 01:05:34.000000', 'temperatura', 1135.0000, 'ºC'),
	(158507, 121, '2014-01-15 01:05:35.000000', 'temperatura', 783.0000, 'ºC'),
	(158508, 121, '2014-01-15 01:05:36.000000', 'temperatura', 512.0000, 'ºC'),
	(158509, 121, '2014-01-15 01:05:37.000000', 'temperatura', 209.0000, 'ºC'),
	(158510, 121, '2014-01-15 01:05:38.000000', 'temperatura', 711.0000, 'ºC'),
	(158511, 121, '2014-01-15 01:05:39.000000', 'temperatura', 528.0000, 'ºC'),
	(158512, 121, '2014-01-15 01:05:40.000000', 'temperatura', 506.0000, 'ºC'),
	(158513, 121, '2014-01-15 01:05:41.000000', 'temperatura', 949.0000, 'ºC'),
	(158514, 121, '2014-01-15 01:05:42.000000', 'temperatura', 829.0000, 'ºC'),
	(158515, 121, '2014-01-15 01:05:43.000000', 'temperatura', 95.0000, 'ºC'),
	(158516, 121, '2014-01-15 01:05:44.000000', 'temperatura', 392.0000, 'ºC'),
	(158517, 121, '2014-01-15 01:05:45.000000', 'temperatura', 472.0000, 'ºC'),
	(158518, 121, '2014-01-15 01:05:46.000000', 'temperatura', 1185.0000, 'ºC'),
	(158519, 121, '2014-01-15 01:05:47.000000', 'temperatura', 912.0000, 'ºC'),
	(158520, 121, '2014-01-15 01:05:48.000000', 'temperatura', 1003.0000, 'ºC'),
	(158521, 121, '2014-01-15 01:05:49.000000', 'temperatura', 1082.0000, 'ºC'),
	(158522, 121, '2014-01-15 01:05:50.000000', 'temperatura', 1199.0000, 'ºC'),
	(158523, 121, '2014-01-15 01:05:51.000000', 'temperatura', 352.0000, 'ºC'),
	(158524, 121, '2014-01-15 01:05:52.000000', 'temperatura', 561.0000, 'ºC'),
	(158525, 121, '2014-01-15 01:05:53.000000', 'temperatura', 551.0000, 'ºC'),
	(158526, 121, '2014-01-15 01:05:54.000000', 'temperatura', 1074.0000, 'ºC'),
	(158527, 121, '2014-01-15 01:05:55.000000', 'temperatura', 115.0000, 'ºC'),
	(158528, 121, '2014-01-15 01:05:56.000000', 'temperatura', 955.0000, 'ºC'),
	(158529, 121, '2014-01-15 01:05:57.000000', 'temperatura', 828.0000, 'ºC'),
	(158530, 121, '2014-01-15 01:05:58.000000', 'temperatura', 77.0000, 'ºC'),
	(158531, 121, '2014-01-15 01:05:59.000000', 'temperatura', 303.0000, 'ºC'),
	(158532, 121, '2014-01-15 01:06:00.000000', 'temperatura', 83.0000, 'ºC'),
	(158533, 121, '2014-01-15 01:06:01.000000', 'temperatura', 707.0000, 'ºC'),
	(158534, 121, '2014-01-15 01:06:02.000000', 'temperatura', 886.0000, 'ºC'),
	(158535, 121, '2014-01-15 01:06:03.000000', 'temperatura', 1111.0000, 'ºC'),
	(158536, 121, '2014-01-15 01:06:04.000000', 'temperatura', 498.0000, 'ºC'),
	(158537, 121, '2014-01-15 01:06:05.000000', 'temperatura', 356.0000, 'ºC'),
	(158538, 121, '2014-01-15 01:06:06.000000', 'temperatura', 285.0000, 'ºC'),
	(158539, 121, '2014-01-15 01:06:07.000000', 'temperatura', 359.0000, 'ºC'),
	(158540, 121, '2014-01-15 01:06:08.000000', 'temperatura', 939.0000, 'ºC'),
	(158541, 121, '2014-01-15 01:06:09.000000', 'temperatura', 19.0000, 'ºC'),
	(158542, 121, '2014-01-15 01:06:10.000000', 'temperatura', 880.0000, 'ºC'),
	(158543, 121, '2014-01-15 01:06:11.000000', 'temperatura', 743.0000, 'ºC'),
	(158544, 121, '2014-01-15 01:06:12.000000', 'temperatura', 1076.0000, 'ºC'),
	(158545, 121, '2014-01-15 01:06:13.000000', 'temperatura', 750.0000, 'ºC'),
	(158546, 121, '2014-01-15 01:06:14.000000', 'temperatura', 523.0000, 'ºC'),
	(158547, 121, '2014-01-15 01:06:15.000000', 'temperatura', 365.0000, 'ºC'),
	(158548, 121, '2014-01-15 01:06:16.000000', 'temperatura', 257.0000, 'ºC'),
	(158549, 121, '2014-01-15 01:06:17.000000', 'temperatura', 188.0000, 'ºC'),
	(158550, 121, '2014-01-15 01:06:18.000000', 'temperatura', 173.0000, 'ºC'),
	(158551, 121, '2014-01-15 01:06:19.000000', 'temperatura', 299.0000, 'ºC'),
	(158552, 121, '2014-01-15 01:06:20.000000', 'temperatura', 979.0000, 'ºC'),
	(158553, 121, '2014-01-15 01:06:21.000000', 'temperatura', 399.0000, 'ºC'),
	(158554, 121, '2014-01-15 01:06:22.000000', 'temperatura', 258.0000, 'ºC'),
	(158555, 121, '2014-01-15 01:06:23.000000', 'temperatura', 95.0000, 'ºC'),
	(158556, 121, '2014-01-15 01:06:24.000000', 'temperatura', 900.0000, 'ºC'),
	(158557, 121, '2014-01-15 01:06:25.000000', 'temperatura', 614.0000, 'ºC'),
	(158558, 121, '2014-01-15 01:06:26.000000', 'temperatura', 371.0000, 'ºC'),
	(158559, 121, '2014-01-15 01:06:27.000000', 'temperatura', 16.0000, 'ºC'),
	(158560, 121, '2014-01-15 01:06:28.000000', 'temperatura', 166.0000, 'ºC'),
	(158561, 121, '2014-01-15 01:06:29.000000', 'temperatura', 782.0000, 'ºC'),
	(158562, 121, '2014-01-15 01:06:30.000000', 'temperatura', 1013.0000, 'ºC'),
	(158563, 121, '2014-01-15 01:06:31.000000', 'temperatura', 320.0000, 'ºC'),
	(158564, 121, '2014-01-15 01:06:32.000000', 'temperatura', 961.0000, 'ºC'),
	(158565, 121, '2014-01-15 01:06:33.000000', 'temperatura', 245.0000, 'ºC'),
	(158566, 121, '2014-01-15 01:06:34.000000', 'temperatura', 744.0000, 'ºC'),
	(158567, 121, '2014-01-15 01:06:35.000000', 'temperatura', 583.0000, 'ºC'),
	(158568, 121, '2014-01-15 01:06:36.000000', 'temperatura', 685.0000, 'ºC'),
	(158569, 121, '2014-01-15 01:06:37.000000', 'temperatura', 477.0000, 'ºC'),
	(158570, 121, '2014-01-15 01:06:38.000000', 'temperatura', 331.0000, 'ºC'),
	(158571, 121, '2014-01-15 01:06:39.000000', 'temperatura', 226.0000, 'ºC'),
	(158572, 121, '2014-01-15 01:06:40.000000', 'temperatura', 135.0000, 'ºC'),
	(158573, 121, '2014-01-15 01:06:41.000000', 'temperatura', 1199.0000, 'ºC'),
	(158574, 121, '2014-01-15 01:06:42.000000', 'temperatura', 790.0000, 'ºC'),
	(158575, 121, '2014-01-15 01:06:43.000000', 'temperatura', 351.0000, 'ºC'),
	(158576, 121, '2014-01-15 01:06:44.000000', 'temperatura', 589.0000, 'ºC'),
	(158577, 121, '2014-01-15 01:06:45.000000', 'temperatura', 691.0000, 'ºC'),
	(158578, 121, '2014-01-15 01:06:46.000000', 'temperatura', 489.0000, 'ºC'),
	(158579, 121, '2014-01-15 01:06:47.000000', 'temperatura', 372.0000, 'ºC'),
	(158580, 121, '2014-01-15 01:06:48.000000', 'temperatura', 393.0000, 'ºC'),
	(158581, 121, '2014-01-15 01:06:49.000000', 'temperatura', 850.0000, 'ºC'),
	(158582, 121, '2014-01-15 01:06:50.000000', 'temperatura', 671.0000, 'ºC'),
	(158583, 121, '2014-01-15 01:06:51.000000', 'temperatura', 807.0000, 'ºC'),
	(158584, 121, '2014-01-15 01:06:52.000000', 'temperatura', 822.0000, 'ºC'),
	(158585, 121, '2014-01-15 01:06:53.000000', 'temperatura', 489.0000, 'ºC'),
	(158586, 121, '2014-01-15 01:06:54.000000', 'temperatura', 1178.0000, 'ºC'),
	(158587, 121, '2014-01-15 01:06:55.000000', 'temperatura', 823.0000, 'ºC'),
	(158588, 121, '2014-01-15 01:06:56.000000', 'temperatura', 582.0000, 'ºC'),
	(158589, 121, '2014-01-15 01:06:57.000000', 'temperatura', 443.0000, 'ºC'),
	(158590, 121, '2014-01-15 01:06:58.000000', 'temperatura', 467.0000, 'ºC'),
	(158591, 121, '2014-01-15 01:06:59.000000', 'temperatura', 1007.0000, 'ºC'),
	(158592, 121, '2014-01-15 01:07:00.000000', 'temperatura', 36.0000, 'ºC'),
	(158593, 121, '2014-01-15 01:07:01.000000', 'temperatura', 760.0000, 'ºC'),
	(158594, 121, '2014-01-15 01:07:02.000000', 'temperatura', 91.0000, 'ºC'),
	(158595, 121, '2014-01-15 01:07:03.000000', 'temperatura', 574.0000, 'ºC'),
	(158596, 121, '2014-01-15 01:07:04.000000', 'temperatura', 199.0000, 'ºC'),
	(158597, 121, '2014-01-15 01:07:05.000000', 'temperatura', 474.0000, 'ºC'),
	(158598, 121, '2014-01-15 01:07:06.000000', 'temperatura', 573.0000, 'ºC'),
	(158599, 121, '2014-01-15 01:07:07.000000', 'temperatura', 244.0000, 'ºC'),
	(158600, 121, '2014-01-15 01:07:08.000000', 'temperatura', 699.0000, 'ºC'),
	(158601, 121, '2014-01-15 01:07:09.000000', 'temperatura', 367.0000, 'ºC'),
	(158602, 121, '2014-01-15 01:07:10.000000', 'temperatura', 938.0000, 'ºC'),
	(158603, 121, '2014-01-15 01:07:11.000000', 'temperatura', 1188.0000, 'ºC'),
	(158604, 121, '2014-01-15 01:07:12.000000', 'temperatura', 725.0000, 'ºC'),
	(158605, 121, '2014-01-15 01:07:13.000000', 'temperatura', 63.0000, 'ºC'),
	(158606, 121, '2014-01-15 01:07:14.000000', 'temperatura', 542.0000, 'ºC'),
	(158607, 121, '2014-01-15 01:07:15.000000', 'temperatura', 119.0000, 'ºC'),
	(158608, 121, '2014-01-15 01:07:16.000000', 'temperatura', 169.0000, 'ºC'),
	(158609, 121, '2014-01-15 01:07:17.000000', 'temperatura', 491.0000, 'ºC'),
	(158610, 121, '2014-01-15 01:07:18.000000', 'temperatura', 746.0000, 'ºC'),
	(158611, 121, '2014-01-15 01:07:19.000000', 'temperatura', 1059.0000, 'ºC'),
	(158612, 121, '2014-01-15 01:07:20.000000', 'temperatura', 657.0000, 'ºC'),
	(158613, 121, '2014-01-15 01:07:21.000000', 'temperatura', 109.0000, 'ºC'),
	(158614, 121, '2014-01-15 01:07:22.000000', 'temperatura', 972.0000, 'ºC'),
	(158615, 121, '2014-01-15 01:07:23.000000', 'temperatura', 937.0000, 'ºC'),
	(158616, 121, '2014-01-15 01:07:24.000000', 'temperatura', 569.0000, 'ºC'),
	(158617, 121, '2014-01-15 01:07:25.000000', 'temperatura', 33.0000, 'ºC'),
	(158618, 121, '2014-01-15 01:07:26.000000', 'temperatura', 861.0000, 'ºC'),
	(158619, 121, '2014-01-15 01:07:27.000000', 'temperatura', 606.0000, 'ºC'),
	(158620, 121, '2014-01-15 01:07:28.000000', 'temperatura', 447.0000, 'ºC'),
	(158621, 121, '2014-01-15 01:07:29.000000', 'temperatura', 416.0000, 'ºC'),
	(158622, 121, '2014-01-15 01:07:30.000000', 'temperatura', 742.0000, 'ºC'),
	(158623, 121, '2014-01-15 01:07:31.000000', 'temperatura', 60.0000, 'ºC'),
	(158624, 121, '2014-01-15 01:07:32.000000', 'temperatura', 474.0000, 'ºC'),
	(158625, 121, '2014-01-15 01:07:33.000000', 'temperatura', 990.0000, 'ºC'),
	(158626, 121, '2014-01-15 01:07:34.000000', 'temperatura', 1130.0000, 'ºC'),
	(158627, 121, '2014-01-15 01:07:35.000000', 'temperatura', 282.0000, 'ºC'),
	(158628, 121, '2014-01-15 01:07:36.000000', 'temperatura', 418.0000, 'ºC'),
	(158629, 121, '2014-01-15 01:07:37.000000', 'temperatura', 45.0000, 'ºC'),
	(158630, 121, '2014-01-15 01:07:38.000000', 'temperatura', 171.0000, 'ºC'),
	(158631, 121, '2014-01-15 01:07:39.000000', 'temperatura', 720.0000, 'ºC'),
	(158632, 121, '2014-01-15 01:07:40.000000', 'temperatura', 687.0000, 'ºC'),
	(158633, 121, '2014-01-15 01:07:41.000000', 'temperatura', 76.0000, 'ºC'),
	(158634, 121, '2014-01-15 01:07:42.000000', 'temperatura', 720.0000, 'ºC'),
	(158635, 121, '2014-01-15 01:07:43.000000', 'temperatura', 972.0000, 'ºC'),
	(158636, 121, '2014-01-15 01:07:44.000000', 'temperatura', 300.0000, 'ºC'),
	(158637, 121, '2014-01-15 01:07:45.000000', 'temperatura', 984.0000, 'ºC'),
	(158638, 121, '2014-01-15 01:07:46.000000', 'temperatura', 421.0000, 'ºC'),
	(158639, 121, '2014-01-15 01:07:47.000000', 'temperatura', 355.0000, 'ºC'),
	(158640, 121, '2014-01-15 01:07:48.000000', 'temperatura', 510.0000, 'ºC'),
	(158641, 121, '2014-01-15 01:07:49.000000', 'temperatura', 288.0000, 'ºC'),
	(158642, 121, '2014-01-15 01:07:50.000000', 'temperatura', 1110.0000, 'ºC'),
	(158643, 121, '2014-01-15 01:07:51.000000', 'temperatura', 1088.0000, 'ºC'),
	(158644, 121, '2014-01-15 01:07:52.000000', 'temperatura', 910.0000, 'ºC'),
	(158645, 121, '2014-01-15 01:07:53.000000', 'temperatura', 86.0000, 'ºC'),
	(158646, 121, '2014-01-15 01:07:54.000000', 'temperatura', 101.0000, 'ºC'),
	(158647, 121, '2014-01-15 01:07:55.000000', 'temperatura', 249.0000, 'ºC'),
	(158648, 121, '2014-01-15 01:07:56.000000', 'temperatura', 940.0000, 'ºC'),
	(158649, 121, '2014-01-15 01:07:57.000000', 'temperatura', 354.0000, 'ºC'),
	(158650, 121, '2014-01-15 01:07:58.000000', 'temperatura', 151.0000, 'ºC'),
	(158651, 121, '2014-01-15 01:07:59.000000', 'temperatura', 892.0000, 'ºC'),
	(158652, 121, '2014-01-15 01:08:00.000000', 'temperatura', 411.0000, 'ºC'),
	(158653, 121, '2014-01-15 01:08:01.000000', 'temperatura', 576.0000, 'ºC'),
	(158654, 121, '2014-01-15 01:08:02.000000', 'temperatura', 447.0000, 'ºC'),
	(158655, 121, '2014-01-15 01:08:03.000000', 'temperatura', 508.0000, 'ºC'),
	(158656, 121, '2014-01-15 01:08:04.000000', 'temperatura', 1.0000, 'ºC'),
	(158657, 121, '2014-01-15 01:08:05.000000', 'temperatura', 879.0000, 'ºC'),
	(158658, 121, '2014-01-15 01:08:06.000000', 'temperatura', 793.0000, 'ºC'),
	(158659, 121, '2014-01-15 01:08:07.000000', 'temperatura', 128.0000, 'ºC'),
	(158660, 121, '2014-01-15 01:08:08.000000', 'temperatura', 661.0000, 'ºC'),
	(158661, 121, '2014-01-15 01:08:09.000000', 'temperatura', 521.0000, 'ºC'),
	(158662, 121, '2014-01-15 01:08:10.000000', 'temperatura', 624.0000, 'ºC'),
	(158663, 121, '2014-01-15 01:08:11.000000', 'temperatura', 355.0000, 'ºC'),
	(158664, 121, '2014-01-15 01:08:12.000000', 'temperatura', 1105.0000, 'ºC'),
	(158665, 121, '2014-01-15 01:08:13.000000', 'temperatura', 860.0000, 'ºC'),
	(158666, 121, '2014-01-15 01:08:14.000000', 'temperatura', 986.0000, 'ºC'),
	(158667, 121, '2014-01-15 01:08:15.000000', 'temperatura', 1149.0000, 'ºC'),
	(158668, 121, '2014-01-15 01:08:16.000000', 'temperatura', 387.0000, 'ºC'),
	(158669, 121, '2014-01-15 01:08:17.000000', 'temperatura', 890.0000, 'ºC'),
	(158670, 121, '2014-01-15 01:08:18.000000', 'temperatura', 890.0000, 'ºC'),
	(158671, 121, '2014-01-15 01:08:19.000000', 'temperatura', 581.0000, 'ºC'),
	(158672, 121, '2014-01-15 01:08:20.000000', 'temperatura', 236.0000, 'ºC'),
	(158673, 121, '2014-01-15 01:08:21.000000', 'temperatura', 637.0000, 'ºC'),
	(158674, 121, '2014-01-15 01:08:22.000000', 'temperatura', 77.0000, 'ºC'),
	(158675, 121, '2014-01-15 01:08:23.000000', 'temperatura', 877.0000, 'ºC'),
	(158676, 121, '2014-01-15 01:08:24.000000', 'temperatura', 551.0000, 'ºC'),
	(158677, 121, '2014-01-15 01:08:25.000000', 'temperatura', 128.0000, 'ºC'),
	(158678, 121, '2014-01-15 01:08:26.000000', 'temperatura', 185.0000, 'ºC'),
	(158679, 121, '2014-01-15 01:08:27.000000', 'temperatura', 542.0000, 'ºC'),
	(158680, 121, '2014-01-15 01:08:28.000000', 'temperatura', 956.0000, 'ºC'),
	(158681, 121, '2014-01-15 01:08:29.000000', 'temperatura', 756.0000, 'ºC'),
	(158682, 121, '2014-01-15 01:08:30.000000', 'temperatura', 909.0000, 'ºC'),
	(158683, 121, '2014-01-15 01:08:31.000000', 'temperatura', 1081.0000, 'ºC'),
	(158684, 121, '2014-01-15 01:08:32.000000', 'temperatura', 277.0000, 'ºC'),
	(158685, 121, '2014-01-15 01:08:33.000000', 'temperatura', 541.0000, 'ºC'),
	(158686, 121, '2014-01-15 01:08:34.000000', 'temperatura', 678.0000, 'ºC'),
	(158687, 121, '2014-01-15 01:08:35.000000', 'temperatura', 564.0000, 'ºC'),
	(158688, 121, '2014-01-15 01:08:36.000000', 'temperatura', 787.0000, 'ºC'),
	(158689, 121, '2014-01-15 01:08:37.000000', 'temperatura', 1046.0000, 'ºC'),
	(158690, 121, '2014-01-15 01:08:38.000000', 'temperatura', 469.0000, 'ºC'),
	(158691, 121, '2014-01-15 01:08:39.000000', 'temperatura', 407.0000, 'ºC'),
	(158692, 121, '2014-01-15 01:08:40.000000', 'temperatura', 626.0000, 'ºC'),
	(158693, 121, '2014-01-15 01:08:41.000000', 'temperatura', 712.0000, 'ºC'),
	(158694, 121, '2014-01-15 01:08:42.000000', 'temperatura', 484.0000, 'ºC'),
	(158695, 121, '2014-01-15 01:08:43.000000', 'temperatura', 283.0000, 'ºC'),
	(158696, 121, '2014-01-15 01:08:44.000000', 'temperatura', 1163.0000, 'ºC'),
	(158697, 121, '2014-01-15 01:08:45.000000', 'temperatura', 167.0000, 'ºC'),
	(158698, 121, '2014-01-15 01:08:46.000000', 'temperatura', 948.0000, 'ºC'),
	(158699, 121, '2014-01-15 01:08:47.000000', 'temperatura', 640.0000, 'ºC'),
	(158700, 121, '2014-01-15 01:08:48.000000', 'temperatura', 357.0000, 'ºC'),
	(158701, 121, '2014-01-15 01:08:49.000000', 'temperatura', 1062.0000, 'ºC'),
	(158702, 121, '2014-01-15 01:08:50.000000', 'temperatura', 643.0000, 'ºC'),
	(158703, 121, '2014-01-15 01:08:51.000000', 'temperatura', 29.0000, 'ºC'),
	(158704, 121, '2014-01-15 01:08:52.000000', 'temperatura', 614.0000, 'ºC'),
	(158705, 121, '2014-01-15 01:08:53.000000', 'temperatura', 586.0000, 'ºC'),
	(158706, 121, '2014-01-15 01:08:54.000000', 'temperatura', 1090.0000, 'ºC'),
	(158707, 121, '2014-01-15 01:08:55.000000', 'temperatura', 89.0000, 'ºC'),
	(158708, 121, '2014-01-15 01:08:56.000000', 'temperatura', 776.0000, 'ºC'),
	(158709, 121, '2014-01-15 01:08:57.000000', 'temperatura', 14.0000, 'ºC'),
	(158710, 121, '2014-01-15 01:08:58.000000', 'temperatura', 143.0000, 'ºC'),
	(158711, 121, '2014-01-15 01:08:59.000000', 'temperatura', 673.0000, 'ºC'),
	(158712, 121, '2014-01-15 01:09:00.000000', 'temperatura', 535.0000, 'ºC'),
	(158713, 121, '2014-01-15 01:09:01.000000', 'temperatura', 660.0000, 'ºC'),
	(158714, 121, '2014-01-15 01:09:02.000000', 'temperatura', 492.0000, 'ºC'),
	(158715, 121, '2014-01-15 01:09:03.000000', 'temperatura', 484.0000, 'ºC'),
	(158716, 121, '2014-01-15 01:09:04.000000', 'temperatura', 942.0000, 'ºC'),
	(158717, 121, '2014-01-15 01:09:05.000000', 'temperatura', 860.0000, 'ºC'),
	(158718, 121, '2014-01-15 01:09:06.000000', 'temperatura', 275.0000, 'ºC'),
	(158719, 121, '2014-01-15 01:09:07.000000', 'temperatura', 1196.0000, 'ºC'),
	(158720, 121, '2014-01-15 01:09:08.000000', 'temperatura', 356.0000, 'ºC'),
	(158721, 121, '2014-01-15 01:09:09.000000', 'temperatura', 591.0000, 'ºC'),
	(158722, 121, '2014-01-15 01:09:10.000000', 'temperatura', 689.0000, 'ºC'),
	(158723, 121, '2014-01-15 01:09:11.000000', 'temperatura', 472.0000, 'ºC'),
	(158724, 121, '2014-01-15 01:09:12.000000', 'temperatura', 294.0000, 'ºC'),
	(158725, 121, '2014-01-15 01:09:13.000000', 'temperatura', 55.0000, 'ºC'),
	(158726, 121, '2014-01-15 01:09:14.000000', 'temperatura', 593.0000, 'ºC'),
	(158727, 121, '2014-01-15 01:09:15.000000', 'temperatura', 400.0000, 'ºC'),
	(158728, 121, '2014-01-15 01:09:16.000000', 'temperatura', 221.0000, 'ºC'),
	(158729, 121, '2014-01-15 01:09:17.000000', 'temperatura', 1105.0000, 'ºC'),
	(158730, 121, '2014-01-15 01:09:18.000000', 'temperatura', 62.0000, 'ºC'),
	(158731, 121, '2014-01-15 01:09:19.000000', 'temperatura', 597.0000, 'ºC'),
	(158732, 121, '2014-01-15 01:09:20.000000', 'temperatura', 398.0000, 'ºC'),
	(158733, 121, '2014-01-15 01:09:21.000000', 'temperatura', 201.0000, 'ºC'),
	(158734, 121, '2014-01-15 01:09:22.000000', 'temperatura', 1012.0000, 'ºC'),
	(158735, 121, '2014-01-15 01:09:23.000000', 'temperatura', 855.0000, 'ºC'),
	(158736, 121, '2014-01-15 01:09:24.000000', 'temperatura', 39.0000, 'ºC'),
	(158737, 121, '2014-01-15 01:09:25.000000', 'temperatura', 33.0000, 'ºC'),
	(158738, 121, '2014-01-15 01:09:26.000000', 'temperatura', 47.0000, 'ºC'),
	(158739, 121, '2014-01-15 01:09:27.000000', 'temperatura', 137.0000, 'ºC'),
	(158740, 121, '2014-01-15 01:09:28.000000', 'temperatura', 544.0000, 'ºC'),
	(158741, 121, '2014-01-15 01:09:29.000000', 'temperatura', 1109.0000, 'ºC'),
	(158742, 121, '2014-01-15 01:09:30.000000', 'temperatura', 316.0000, 'ºC'),
	(158743, 121, '2014-01-15 01:09:31.000000', 'temperatura', 652.0000, 'ºC'),
	(158744, 121, '2014-01-15 01:09:32.000000', 'temperatura', 1114.0000, 'ºC'),
	(158745, 121, '2014-01-15 01:09:33.000000', 'temperatura', 12.0000, 'ºC'),
	(158746, 121, '2014-01-15 01:09:34.000000', 'temperatura', 320.0000, 'ºC'),
	(158747, 121, '2014-01-15 01:09:35.000000', 'temperatura', 365.0000, 'ºC'),
	(158748, 121, '2014-01-15 01:09:36.000000', 'temperatura', 864.0000, 'ºC'),
	(158749, 121, '2014-01-15 01:09:37.000000', 'temperatura', 827.0000, 'ºC'),
	(158750, 121, '2014-01-15 01:09:38.000000', 'temperatura', 341.0000, 'ºC'),
	(158751, 121, '2014-01-15 01:09:39.000000', 'temperatura', 428.0000, 'ºC'),
	(158752, 121, '2014-01-15 01:09:40.000000', 'temperatura', 1115.0000, 'ºC'),
	(158753, 121, '2014-01-15 01:09:41.000000', 'temperatura', 691.0000, 'ºC'),
	(158754, 121, '2014-01-15 01:09:42.000000', 'temperatura', 110.0000, 'ºC'),
	(158755, 121, '2014-01-15 01:09:43.000000', 'temperatura', 878.0000, 'ºC'),
	(158756, 121, '2014-01-15 01:09:44.000000', 'temperatura', 462.0000, 'ºC'),
	(158757, 121, '2014-01-15 01:09:45.000000', 'temperatura', 876.0000, 'ºC'),
	(158758, 121, '2014-01-15 01:09:46.000000', 'temperatura', 596.0000, 'ºC'),
	(158759, 121, '2014-01-15 01:09:47.000000', 'temperatura', 350.0000, 'ºC'),
	(158760, 121, '2014-01-15 01:09:48.000000', 'temperatura', 1165.0000, 'ºC'),
	(158761, 121, '2014-01-15 01:09:49.000000', 'temperatura', 1173.0000, 'ºC'),
	(158762, 121, '2014-01-15 01:09:50.000000', 'temperatura', 1173.0000, 'ºC'),
	(158763, 121, '2014-01-15 01:09:51.000000', 'temperatura', 1144.0000, 'ºC'),
	(158764, 121, '2014-01-15 01:09:52.000000', 'temperatura', 1004.0000, 'ºC'),
	(158765, 121, '2014-01-15 01:09:53.000000', 'temperatura', 388.0000, 'ºC'),
	(158766, 121, '2014-01-15 01:09:54.000000', 'temperatura', 127.0000, 'ºC'),
	(158767, 121, '2014-01-15 01:09:55.000000', 'temperatura', 674.0000, 'ºC'),
	(158768, 121, '2014-01-15 01:09:56.000000', 'temperatura', 589.0000, 'ºC'),
	(158769, 121, '2014-01-15 01:09:57.000000', 'temperatura', 925.0000, 'ºC'),
	(158770, 121, '2014-01-15 01:09:58.000000', 'temperatura', 456.0000, 'ºC'),
	(158771, 121, '2014-01-15 01:09:59.000000', 'temperatura', 704.0000, 'ºC'),
	(158772, 121, '2014-01-15 01:10:00.000000', 'temperatura', 955.0000, 'ºC'),
	(158773, 121, '2014-01-15 01:10:01.000000', 'temperatura', 262.0000, 'ºC'),
	(158774, 121, '2014-01-15 01:10:02.000000', 'temperatura', 845.0000, 'ºC'),
	(158775, 121, '2014-01-15 01:10:03.000000', 'temperatura', 1039.0000, 'ºC'),
	(158776, 121, '2014-01-15 01:10:04.000000', 'temperatura', 263.0000, 'ºC'),
	(158777, 121, '2014-01-15 01:10:05.000000', 'temperatura', 598.0000, 'ºC'),
	(158778, 121, '2014-01-15 01:10:06.000000', 'temperatura', 1000.0000, 'ºC'),
	(158779, 121, '2014-01-15 01:10:07.000000', 'temperatura', 806.0000, 'ºC'),
	(158780, 121, '2014-01-15 01:10:08.000000', 'temperatura', 1032.0000, 'ºC'),
	(158781, 121, '2014-01-15 01:10:09.000000', 'temperatura', 343.0000, 'ºC'),
	(158782, 121, '2014-01-15 01:10:10.000000', 'temperatura', 1017.0000, 'ºC'),
	(158783, 121, '2014-01-15 01:10:11.000000', 'temperatura', 457.0000, 'ºC'),
	(158784, 121, '2014-01-15 01:10:12.000000', 'temperatura', 436.0000, 'ºC'),
	(158785, 121, '2014-01-15 01:10:13.000000', 'temperatura', 810.0000, 'ºC'),
	(158786, 121, '2014-01-15 01:10:14.000000', 'temperatura', 343.0000, 'ºC'),
	(158787, 121, '2014-01-15 01:10:15.000000', 'temperatura', 482.0000, 'ºC'),
	(158788, 121, '2014-01-15 01:10:16.000000', 'temperatura', 185.0000, 'ºC'),
	(158789, 121, '2014-01-15 01:10:17.000000', 'temperatura', 679.0000, 'ºC'),
	(158790, 121, '2014-01-15 01:10:18.000000', 'temperatura', 441.0000, 'ºC'),
	(158791, 121, '2014-01-15 01:10:19.000000', 'temperatura', 169.0000, 'ºC'),
	(158792, 121, '2014-01-15 01:10:20.000000', 'temperatura', 723.0000, 'ºC'),
	(158793, 121, '2014-01-15 01:10:21.000000', 'temperatura', 707.0000, 'ºC'),
	(158794, 121, '2014-01-15 01:10:22.000000', 'temperatura', 165.0000, 'ºC'),
	(158795, 121, '2014-01-15 01:10:23.000000', 'temperatura', 1107.0000, 'ºC'),
	(158796, 121, '2014-01-15 01:10:24.000000', 'temperatura', 239.0000, 'ºC'),
	(158797, 121, '2014-01-15 01:10:25.000000', 'temperatura', 273.0000, 'ºC'),
	(158798, 121, '2014-01-15 01:10:26.000000', 'temperatura', 651.0000, 'ºC'),
	(158799, 121, '2014-01-15 01:10:27.000000', 'temperatura', 37.0000, 'ºC'),
	(158800, 121, '2014-01-15 01:10:28.000000', 'temperatura', 630.0000, 'ºC'),
	(158801, 121, '2014-01-15 01:10:29.000000', 'temperatura', 639.0000, 'ºC'),
	(158802, 121, '2014-01-15 01:10:30.000000', 'temperatura', 107.0000, 'ºC'),
	(158803, 121, '2014-01-15 01:10:31.000000', 'temperatura', 1020.0000, 'ºC'),
	(158804, 121, '2014-01-15 01:10:32.000000', 'temperatura', 1177.0000, 'ºC'),
	(158805, 121, '2014-01-15 01:10:33.000000', 'temperatura', 427.0000, 'ºC'),
	(158806, 121, '2014-01-15 01:10:34.000000', 'temperatura', 1004.0000, 'ºC'),
	(158807, 121, '2014-01-15 01:10:35.000000', 'temperatura', 138.0000, 'ºC'),
	(158808, 121, '2014-01-15 01:10:36.000000', 'temperatura', 82.0000, 'ºC'),
	(158809, 121, '2014-01-15 01:10:37.000000', 'temperatura', 1193.0000, 'ºC'),
	(158810, 121, '2014-01-15 01:10:38.000000', 'temperatura', 922.0000, 'ºC'),
	(158811, 121, '2014-01-15 01:10:39.000000', 'temperatura', 1032.0000, 'ºC'),
	(158812, 121, '2014-01-15 01:10:40.000000', 'temperatura', 1192.0000, 'ºC'),
	(158813, 121, '2014-01-15 01:10:41.000000', 'temperatura', 464.0000, 'ºC'),
	(158814, 121, '2014-01-15 01:10:42.000000', 'temperatura', 1145.0000, 'ºC'),
	(158815, 121, '2014-01-15 01:10:43.000000', 'temperatura', 732.0000, 'ºC'),
	(158816, 121, '2014-01-15 01:10:44.000000', 'temperatura', 227.0000, 'ºC'),
	(158817, 121, '2014-01-15 01:10:45.000000', 'temperatura', 139.0000, 'ºC'),
	(158818, 121, '2014-01-15 01:10:46.000000', 'temperatura', 16.0000, 'ºC'),
	(158819, 121, '2014-01-15 01:10:47.000000', 'temperatura', 864.0000, 'ºC'),
	(158820, 121, '2014-01-15 01:10:48.000000', 'temperatura', 671.0000, 'ºC'),
	(158821, 121, '2014-01-15 01:10:49.000000', 'temperatura', 765.0000, 'ºC'),
	(158822, 121, '2014-01-15 01:10:50.000000', 'temperatura', 611.0000, 'ºC'),
	(158823, 121, '2014-01-15 01:10:51.000000', 'temperatura', 762.0000, 'ºC'),
	(158824, 121, '2014-01-15 01:10:52.000000', 'temperatura', 775.0000, 'ºC'),
	(158825, 121, '2014-01-15 01:10:53.000000', 'temperatura', 392.0000, 'ºC'),
	(158826, 121, '2014-01-15 01:10:54.000000', 'temperatura', 834.0000, 'ºC'),
	(158827, 121, '2014-01-15 01:10:55.000000', 'temperatura', 593.0000, 'ºC'),
	(158828, 121, '2014-01-15 01:10:56.000000', 'temperatura', 464.0000, 'ºC'),
	(158829, 121, '2014-01-15 01:10:57.000000', 'temperatura', 543.0000, 'ºC'),
	(158830, 121, '2014-01-15 01:10:58.000000', 'temperatura', 122.0000, 'ºC'),
	(158831, 121, '2014-01-15 01:10:59.000000', 'temperatura', 184.0000, 'ºC'),
	(158832, 121, '2014-01-15 01:11:00.000000', 'temperatura', 554.0000, 'ºC'),
	(158833, 121, '2014-01-15 01:11:01.000000', 'temperatura', 1017.0000, 'ºC'),
	(158834, 121, '2014-01-15 01:11:02.000000', 'temperatura', 1026.0000, 'ºC'),
	(158835, 121, '2014-01-15 01:11:03.000000', 'temperatura', 877.0000, 'ºC'),
	(158836, 121, '2014-01-15 01:11:04.000000', 'temperatura', 108.0000, 'ºC'),
	(158837, 121, '2014-01-15 01:11:05.000000', 'temperatura', 312.0000, 'ºC'),
	(158838, 121, '2014-01-15 01:11:06.000000', 'temperatura', 33.0000, 'ºC'),
	(158839, 121, '2014-01-15 01:11:07.000000', 'temperatura', 433.0000, 'ºC'),
	(158840, 121, '2014-01-15 01:11:08.000000', 'temperatura', 863.0000, 'ºC'),
	(158841, 121, '2014-01-15 01:11:09.000000', 'temperatura', 619.0000, 'ºC'),
	(158842, 121, '2014-01-15 01:11:10.000000', 'temperatura', 506.0000, 'ºC'),
	(158843, 121, '2014-01-15 01:11:11.000000', 'temperatura', 673.0000, 'ºC'),
	(158844, 121, '2014-01-15 01:11:12.000000', 'temperatura', 646.0000, 'ºC'),
	(158845, 121, '2014-01-15 01:11:13.000000', 'temperatura', 12.0000, 'ºC'),
	(158846, 121, '2014-01-15 01:11:14.000000', 'temperatura', 523.0000, 'ºC'),
	(158847, 121, '2014-01-15 01:11:15.000000', 'temperatura', 180.0000, 'ºC'),
	(158848, 121, '2014-01-15 01:11:16.000000', 'temperatura', 533.0000, 'ºC'),
	(158849, 121, '2014-01-15 01:11:17.000000', 'temperatura', 925.0000, 'ºC'),
	(158850, 121, '2014-01-15 01:11:18.000000', 'temperatura', 624.0000, 'ºC'),
	(158851, 121, '2014-01-15 01:11:19.000000', 'temperatura', 348.0000, 'ºC'),
	(158852, 121, '2014-01-15 01:11:20.000000', 'temperatura', 1068.0000, 'ºC'),
	(158853, 121, '2014-01-15 01:11:21.000000', 'temperatura', 698.0000, 'ºC'),
	(158854, 121, '2014-01-15 01:11:22.000000', 'temperatura', 287.0000, 'ºC'),
	(158855, 121, '2014-01-15 01:11:23.000000', 'temperatura', 538.0000, 'ºC'),
	(158856, 121, '2014-01-15 01:11:24.000000', 'temperatura', 633.0000, 'ºC'),
	(158857, 121, '2014-01-15 01:11:25.000000', 'temperatura', 350.0000, 'ºC'),
	(158858, 121, '2014-01-15 01:11:26.000000', 'temperatura', 1053.0000, 'ºC'),
	(158859, 121, '2014-01-15 01:11:27.000000', 'temperatura', 615.0000, 'ºC'),
	(158860, 121, '2014-01-15 01:11:28.000000', 'temperatura', 1116.0000, 'ºC'),
	(158861, 121, '2014-01-15 01:11:29.000000', 'temperatura', 134.0000, 'ºC'),
	(158862, 121, '2014-01-15 01:11:30.000000', 'temperatura', 925.0000, 'ºC'),
	(158863, 121, '2014-01-15 01:11:31.000000', 'temperatura', 622.0000, 'ºC'),
	(158864, 121, '2014-01-15 01:11:32.000000', 'temperatura', 335.0000, 'ºC'),
	(158865, 121, '2014-01-15 01:11:33.000000', 'temperatura', 1009.0000, 'ºC'),
	(158866, 121, '2014-01-15 01:11:34.000000', 'temperatura', 441.0000, 'ºC'),
	(158867, 121, '2014-01-15 01:11:35.000000', 'temperatura', 378.0000, 'ºC'),
	(158868, 121, '2014-01-15 01:11:36.000000', 'temperatura', 568.0000, 'ºC'),
	(158869, 121, '2014-01-15 01:11:37.000000', 'temperatura', 508.0000, 'ºC'),
	(158870, 121, '2014-01-15 01:11:38.000000', 'temperatura', 836.0000, 'ºC'),
	(158871, 121, '2014-01-15 01:11:39.000000', 'temperatura', 257.0000, 'ºC'),
	(158872, 121, '2014-01-15 01:11:40.000000', 'temperatura', 1179.0000, 'ºC'),
	(158873, 121, '2014-01-15 01:11:41.000000', 'temperatura', 322.0000, 'ºC'),
	(158874, 121, '2014-01-15 01:11:42.000000', 'temperatura', 474.0000, 'ºC'),
	(158875, 121, '2014-01-15 01:11:43.000000', 'temperatura', 205.0000, 'ºC'),
	(158876, 121, '2014-01-15 01:11:44.000000', 'temperatura', 804.0000, 'ºC'),
	(158877, 121, '2014-01-15 01:11:45.000000', 'temperatura', 1004.0000, 'ºC'),
	(158878, 121, '2014-01-15 01:11:46.000000', 'temperatura', 209.0000, 'ºC'),
	(158879, 121, '2014-01-15 01:11:47.000000', 'temperatura', 434.0000, 'ºC'),
	(158880, 121, '2014-01-15 01:11:48.000000', 'temperatura', 344.0000, 'ºC'),
	(158881, 121, '2014-01-15 01:11:49.000000', 'temperatura', 419.0000, 'ºC'),
	(158882, 121, '2014-01-15 01:11:50.000000', 'temperatura', 1062.0000, 'ºC'),
	(158883, 121, '2014-01-15 01:11:51.000000', 'temperatura', 454.0000, 'ºC'),
	(158884, 121, '2014-01-15 01:11:52.000000', 'temperatura', 282.0000, 'ºC'),
	(158885, 121, '2014-01-15 01:11:53.000000', 'temperatura', 52.0000, 'ºC'),
	(158886, 121, '2014-01-15 01:11:54.000000', 'temperatura', 615.0000, 'ºC'),
	(158887, 121, '2014-01-15 01:11:55.000000', 'temperatura', 516.0000, 'ºC'),
	(158888, 121, '2014-01-15 01:11:56.000000', 'temperatura', 738.0000, 'ºC'),
	(158889, 121, '2014-01-15 01:11:57.000000', 'temperatura', 943.0000, 'ºC'),
	(158890, 121, '2014-01-15 01:11:58.000000', 'temperatura', 102.0000, 'ºC'),
	(158891, 121, '2014-01-15 01:11:59.000000', 'temperatura', 80.0000, 'ºC'),
	(158892, 121, '2014-01-15 01:12:00.000000', 'temperatura', 93.0000, 'ºC'),
	(158893, 121, '2014-01-15 01:12:01.000000', 'temperatura', 227.0000, 'ºC'),
	(158894, 121, '2014-01-15 01:12:02.000000', 'temperatura', 856.0000, 'ºC'),
	(158895, 121, '2014-01-15 01:12:03.000000', 'temperatura', 1198.0000, 'ºC'),
	(158896, 121, '2014-01-15 01:12:04.000000', 'temperatura', 1023.0000, 'ºC'),
	(158897, 121, '2014-01-15 01:12:05.000000', 'temperatura', 322.0000, 'ºC'),
	(158898, 121, '2014-01-15 01:12:06.000000', 'temperatura', 941.0000, 'ºC'),
	(158899, 121, '2014-01-15 01:12:07.000000', 'temperatura', 138.0000, 'ºC'),
	(158900, 121, '2014-01-15 01:12:08.000000', 'temperatura', 270.0000, 'ºC'),
	(158901, 121, '2014-01-15 01:12:09.000000', 'temperatura', 935.0000, 'ºC'),
	(158902, 121, '2014-01-15 01:12:10.000000', 'temperatura', 265.0000, 'ºC'),
	(158903, 121, '2014-01-15 01:12:11.000000', 'temperatura', 923.0000, 'ºC'),
	(158904, 121, '2014-01-15 01:12:12.000000', 'temperatura', 218.0000, 'ºC'),
	(158905, 121, '2014-01-15 01:12:13.000000', 'temperatura', 723.0000, 'ºC'),
	(158906, 121, '2014-01-15 01:12:14.000000', 'temperatura', 563.0000, 'ºC'),
	(158907, 121, '2014-01-15 01:12:15.000000', 'temperatura', 643.0000, 'ºC'),
	(158908, 121, '2014-01-15 01:12:16.000000', 'temperatura', 329.0000, 'ºC'),
	(158909, 121, '2014-01-15 01:12:17.000000', 'temperatura', 915.0000, 'ºC'),
	(158910, 121, '2014-01-15 01:12:18.000000', 'temperatura', 1189.0000, 'ºC'),
	(158911, 121, '2014-01-15 01:12:19.000000', 'temperatura', 800.0000, 'ºC'),
	(158912, 121, '2014-01-15 01:12:20.000000', 'temperatura', 436.0000, 'ºC'),
	(158913, 121, '2014-01-15 01:12:21.000000', 'temperatura', 977.0000, 'ºC'),
	(158914, 121, '2014-01-15 01:12:22.000000', 'temperatura', 1180.0000, 'ºC'),
	(158915, 121, '2014-01-15 01:12:23.000000', 'temperatura', 567.0000, 'ºC'),
	(158916, 121, '2014-01-15 01:12:24.000000', 'temperatura', 496.0000, 'ºC'),
	(158917, 121, '2014-01-15 01:12:25.000000', 'temperatura', 782.0000, 'ºC'),
	(158918, 121, '2014-01-15 01:12:26.000000', 'temperatura', 20.0000, 'ºC'),
	(158919, 121, '2014-01-15 01:12:27.000000', 'temperatura', 154.0000, 'ºC'),
	(158920, 121, '2014-01-15 01:12:28.000000', 'temperatura', 709.0000, 'ºC'),
	(158921, 121, '2014-01-15 01:12:29.000000', 'temperatura', 687.0000, 'ºC'),
	(158922, 121, '2014-01-15 01:12:30.000000', 'temperatura', 106.0000, 'ºC'),
	(158923, 121, '2014-01-15 01:12:31.000000', 'temperatura', 870.0000, 'ºC'),
	(158924, 121, '2014-01-15 01:12:32.000000', 'temperatura', 434.0000, 'ºC'),
	(158925, 121, '2014-01-15 01:12:33.000000', 'temperatura', 759.0000, 'ºC'),
	(158926, 121, '2014-01-15 01:12:34.000000', 'temperatura', 92.0000, 'ºC'),
	(158927, 121, '2014-01-15 01:12:35.000000', 'temperatura', 586.0000, 'ºC'),
	(158928, 121, '2014-01-15 01:12:36.000000', 'temperatura', 253.0000, 'ºC'),
	(158929, 121, '2014-01-15 01:12:37.000000', 'temperatura', 708.0000, 'ºC'),
	(158930, 121, '2014-01-15 01:12:38.000000', 'temperatura', 381.0000, 'ºC'),
	(158931, 121, '2014-01-15 01:12:39.000000', 'temperatura', 982.0000, 'ºC'),
	(158932, 121, '2014-01-15 01:12:40.000000', 'temperatura', 168.0000, 'ºC'),
	(158933, 121, '2014-01-15 01:12:41.000000', 'temperatura', 295.0000, 'ºC'),
	(158934, 121, '2014-01-15 01:12:42.000000', 'temperatura', 970.0000, 'ºC'),
	(158935, 121, '2014-01-15 01:12:43.000000', 'temperatura', 365.0000, 'ºC'),
	(158936, 121, '2014-01-15 01:12:44.000000', 'temperatura', 116.0000, 'ºC'),
	(158937, 121, '2014-01-15 01:12:45.000000', 'temperatura', 687.0000, 'ºC'),
	(158938, 121, '2014-01-15 01:12:46.000000', 'temperatura', 687.0000, 'ºC'),
	(158939, 121, '2014-01-15 01:12:47.000000', 'temperatura', 174.0000, 'ºC'),
	(158940, 121, '2014-01-15 01:12:48.000000', 'temperatura', 10.0000, 'ºC'),
	(158941, 121, '2014-01-15 01:12:49.000000', 'temperatura', 728.0000, 'ºC'),
	(158942, 121, '2014-01-15 01:12:50.000000', 'temperatura', 9.0000, 'ºC'),
	(158943, 121, '2014-01-15 01:12:51.000000', 'temperatura', 262.0000, 'ºC'),
	(158944, 121, '2014-01-15 01:12:52.000000', 'temperatura', 85.0000, 'ºC'),
	(158945, 121, '2014-01-15 01:12:53.000000', 'temperatura', 839.0000, 'ºC'),
	(158946, 121, '2014-01-15 01:12:54.000000', 'temperatura', 338.0000, 'ºC'),
	(158947, 121, '2014-01-15 01:12:55.000000', 'temperatura', 376.0000, 'ºC'),
	(158948, 121, '2014-01-15 01:12:56.000000', 'temperatura', 867.0000, 'ºC'),
	(158949, 121, '2014-01-15 01:12:57.000000', 'temperatura', 805.0000, 'ºC'),
	(158950, 121, '2014-01-15 01:12:58.000000', 'temperatura', 225.0000, 'ºC'),
	(158951, 121, '2014-01-15 01:12:59.000000', 'temperatura', 1112.0000, 'ºC'),
	(158952, 121, '2014-01-15 01:13:00.000000', 'temperatura', 86.0000, 'ºC'),
	(158953, 121, '2014-01-15 01:13:01.000000', 'temperatura', 693.0000, 'ºC'),
	(158954, 121, '2014-01-15 01:13:02.000000', 'temperatura', 807.0000, 'ºC'),
	(158955, 121, '2014-01-15 01:13:03.000000', 'temperatura', 758.0000, 'ºC'),
	(158956, 121, '2014-01-15 01:13:04.000000', 'temperatura', 170.0000, 'ºC'),
	(158957, 121, '2014-01-15 01:13:05.000000', 'temperatura', 975.0000, 'ºC'),
	(158958, 121, '2014-01-15 01:13:06.000000', 'temperatura', 765.0000, 'ºC'),
	(158959, 121, '2014-01-15 01:13:07.000000', 'temperatura', 901.0000, 'ºC'),
	(158960, 121, '2014-01-15 01:13:08.000000', 'temperatura', 1012.0000, 'ºC'),
	(158961, 121, '2014-01-15 01:13:09.000000', 'temperatura', 1155.0000, 'ºC'),
	(158962, 121, '2014-01-15 01:13:10.000000', 'temperatura', 340.0000, 'ºC'),
	(158963, 121, '2014-01-15 01:13:11.000000', 'temperatura', 636.0000, 'ºC'),
	(158964, 121, '2014-01-15 01:13:12.000000', 'temperatura', 961.0000, 'ºC'),
	(158965, 121, '2014-01-15 01:13:13.000000', 'temperatura', 496.0000, 'ºC'),
	(158966, 121, '2014-01-15 01:13:14.000000', 'temperatura', 797.0000, 'ºC'),
	(158967, 121, '2014-01-15 01:13:15.000000', 'temperatura', 97.0000, 'ºC'),
	(158968, 121, '2014-01-15 01:13:16.000000', 'temperatura', 495.0000, 'ºC'),
	(158969, 121, '2014-01-15 01:13:17.000000', 'temperatura', 984.0000, 'ºC'),
	(158970, 121, '2014-01-15 01:13:18.000000', 'temperatura', 1038.0000, 'ºC'),
	(158971, 121, '2014-01-15 01:13:19.000000', 'temperatura', 1038.0000, 'ºC'),
	(158972, 121, '2014-01-15 01:13:20.000000', 'temperatura', 874.0000, 'ºC'),
	(158973, 121, '2014-01-15 01:13:21.000000', 'temperatura', 59.0000, 'ºC'),
	(158974, 121, '2014-01-15 01:13:22.000000', 'temperatura', 72.0000, 'ºC'),
	(158975, 121, '2014-01-15 01:13:23.000000', 'temperatura', 184.0000, 'ºC'),
	(158976, 121, '2014-01-15 01:13:24.000000', 'temperatura', 705.0000, 'ºC'),
	(158977, 121, '2014-01-15 01:13:25.000000', 'temperatura', 571.0000, 'ºC'),
	(158978, 121, '2014-01-15 01:13:26.000000', 'temperatura', 743.0000, 'ºC'),
	(158979, 121, '2014-01-15 01:13:27.000000', 'temperatura', 802.0000, 'ºC'),
	(158980, 121, '2014-01-15 01:13:28.000000', 'temperatura', 581.0000, 'ºC'),
	(158981, 121, '2014-01-15 01:13:29.000000', 'temperatura', 501.0000, 'ºC'),
	(158982, 121, '2014-01-15 01:13:30.000000', 'temperatura', 761.0000, 'ºC'),
	(158983, 121, '2014-01-15 01:13:31.000000', 'temperatura', 1103.0000, 'ºC'),
	(158984, 121, '2014-01-15 01:13:32.000000', 'temperatura', 834.0000, 'ºC'),
	(158985, 121, '2014-01-15 01:13:33.000000', 'temperatura', 862.0000, 'ºC'),
	(158986, 121, '2014-01-15 01:13:34.000000', 'temperatura', 606.0000, 'ºC'),
	(158987, 121, '2014-01-15 01:13:35.000000', 'temperatura', 447.0000, 'ºC'),
	(158988, 121, '2014-01-15 01:13:36.000000', 'temperatura', 414.0000, 'ºC'),
	(158989, 121, '2014-01-15 01:13:37.000000', 'temperatura', 733.0000, 'ºC'),
	(158990, 121, '2014-01-15 01:13:38.000000', 'temperatura', 22.0000, 'ºC'),
	(158991, 121, '2014-01-15 01:13:39.000000', 'temperatura', 312.0000, 'ºC'),
	(158992, 121, '2014-01-15 01:13:40.000000', 'temperatura', 293.0000, 'ºC'),
	(158993, 121, '2014-01-15 01:13:41.000000', 'temperatura', 532.0000, 'ºC'),
	(158994, 121, '2014-01-15 01:13:42.000000', 'temperatura', 582.0000, 'ºC'),
	(158995, 121, '2014-01-15 01:13:43.000000', 'temperatura', 114.0000, 'ºC'),
	(158996, 121, '2014-01-15 01:13:44.000000', 'temperatura', 25.0000, 'ºC'),
	(158997, 121, '2014-01-15 01:13:45.000000', 'temperatura', 982.0000, 'ºC'),
	(158998, 121, '2014-01-15 01:13:46.000000', 'temperatura', 38.0000, 'ºC'),
	(158999, 121, '2014-01-15 01:13:47.000000', 'temperatura', 842.0000, 'ºC'),
	(159000, 121, '2014-01-15 01:13:48.000000', 'temperatura', 496.0000, 'ºC'),
	(159001, 121, '2014-01-15 01:13:49.000000', 'temperatura', 1156.0000, 'ºC'),
	(159002, 121, '2014-01-15 01:13:50.000000', 'temperatura', 691.0000, 'ºC'),
	(159003, 121, '2014-01-15 01:13:51.000000', 'temperatura', 1188.0000, 'ºC'),
	(159004, 121, '2014-01-15 01:13:52.000000', 'temperatura', 267.0000, 'ºC'),
	(159005, 121, '2014-01-15 01:13:53.000000', 'temperatura', 172.0000, 'ºC'),
	(159006, 121, '2014-01-15 01:13:54.000000', 'temperatura', 59.0000, 'ºC'),
	(159007, 121, '2014-01-15 01:13:55.000000', 'temperatura', 982.0000, 'ºC'),
	(159008, 121, '2014-01-15 01:13:56.000000', 'temperatura', 1131.0000, 'ºC'),
	(159009, 121, '2014-01-15 01:13:57.000000', 'temperatura', 308.0000, 'ºC'),
	(159010, 121, '2014-01-15 01:13:58.000000', 'temperatura', 550.0000, 'ºC'),
	(159011, 121, '2014-01-15 01:13:59.000000', 'temperatura', 624.0000, 'ºC'),
	(159012, 121, '2014-01-15 01:14:00.000000', 'temperatura', 271.0000, 'ºC'),
	(159013, 121, '2014-01-15 01:14:01.000000', 'temperatura', 682.0000, 'ºC'),
	(159014, 121, '2014-01-15 01:14:02.000000', 'temperatura', 199.0000, 'ºC'),
	(159015, 121, '2014-01-15 01:14:03.000000', 'temperatura', 151.0000, 'ºC'),
	(159016, 121, '2014-01-15 01:14:04.000000', 'temperatura', 157.0000, 'ºC'),
	(159017, 121, '2014-01-15 01:14:05.000000', 'temperatura', 333.0000, 'ºC'),
	(159018, 121, '2014-01-15 01:14:06.000000', 'temperatura', 1194.0000, 'ºC'),
	(159019, 121, '2014-01-15 01:14:07.000000', 'temperatura', 173.0000, 'ºC'),
	(159020, 121, '2014-01-15 01:14:08.000000', 'temperatura', 882.0000, 'ºC'),
	(159021, 121, '2014-01-15 01:14:09.000000', 'temperatura', 292.0000, 'ºC'),
	(159022, 121, '2014-01-15 01:14:10.000000', 'temperatura', 13.0000, 'ºC'),
	(159023, 121, '2014-01-15 01:14:11.000000', 'temperatura', 390.0000, 'ºC'),
	(159024, 121, '2014-01-15 01:14:12.000000', 'temperatura', 711.0000, 'ºC'),
	(159025, 121, '2014-01-15 01:14:13.000000', 'temperatura', 1188.0000, 'ºC'),
	(159026, 121, '2014-01-15 01:14:14.000000', 'temperatura', 206.0000, 'ºC'),
	(159027, 121, '2014-01-15 01:14:15.000000', 'temperatura', 1069.0000, 'ºC'),
	(159028, 121, '2014-01-15 01:14:16.000000', 'temperatura', 1124.0000, 'ºC'),
	(159029, 121, '2014-01-15 01:14:17.000000', 'temperatura', 14.0000, 'ºC'),
	(159030, 121, '2014-01-15 01:14:18.000000', 'temperatura', 297.0000, 'ºC'),
	(159031, 121, '2014-01-15 01:14:19.000000', 'temperatura', 246.0000, 'ºC'),
	(159032, 121, '2014-01-15 01:14:20.000000', 'temperatura', 338.0000, 'ºC'),
	(159033, 121, '2014-01-15 01:14:21.000000', 'temperatura', 954.0000, 'ºC'),
	(159034, 121, '2014-01-15 01:14:22.000000', 'temperatura', 156.0000, 'ºC'),
	(159035, 121, '2014-01-15 01:14:23.000000', 'temperatura', 317.0000, 'ºC'),
	(159036, 121, '2014-01-15 01:14:24.000000', 'temperatura', 1120.0000, 'ºC'),
	(159037, 121, '2014-01-15 01:14:25.000000', 'temperatura', 1051.0000, 'ºC'),
	(159038, 121, '2014-01-15 01:14:26.000000', 'temperatura', 692.0000, 'ºC'),
	(159039, 121, '2014-01-15 01:14:27.000000', 'temperatura', 307.0000, 'ºC'),
	(159040, 121, '2014-01-15 01:14:28.000000', 'temperatura', 661.0000, 'ºC'),
	(159041, 121, '2014-01-15 01:14:29.000000', 'temperatura', 1186.0000, 'ºC'),
	(159042, 121, '2014-01-15 01:14:30.000000', 'temperatura', 346.0000, 'ºC'),
	(159043, 121, '2014-01-15 01:14:31.000000', 'temperatura', 572.0000, 'ºC'),
	(159044, 121, '2014-01-15 01:14:32.000000', 'temperatura', 624.0000, 'ºC'),
	(159045, 121, '2014-01-15 01:14:33.000000', 'temperatura', 203.0000, 'ºC'),
	(159046, 121, '2014-01-15 01:14:34.000000', 'temperatura', 344.0000, 'ºC'),
	(159047, 121, '2014-01-15 01:14:35.000000', 'temperatura', 1113.0000, 'ºC'),
	(159048, 121, '2014-01-15 01:14:36.000000', 'temperatura', 935.0000, 'ºC'),
	(159049, 121, '2014-01-15 01:14:37.000000', 'temperatura', 133.0000, 'ºC'),
	(159050, 121, '2014-01-15 01:14:38.000000', 'temperatura', 262.0000, 'ºC'),
	(159051, 121, '2014-01-15 01:14:39.000000', 'temperatura', 913.0000, 'ºC'),
	(159052, 121, '2014-01-15 01:14:40.000000', 'temperatura', 178.0000, 'ºC'),
	(159053, 121, '2014-01-15 01:14:41.000000', 'temperatura', 554.0000, 'ºC'),
	(159054, 121, '2014-01-15 01:14:42.000000', 'temperatura', 1034.0000, 'ºC'),
	(159055, 121, '2014-01-15 01:14:43.000000', 'temperatura', 1108.0000, 'ºC'),
	(159056, 121, '2014-01-15 01:14:44.000000', 'temperatura', 39.0000, 'ºC'),
	(159057, 121, '2014-01-15 01:14:45.000000', 'temperatura', 470.0000, 'ºC'),
	(159058, 121, '2014-01-15 01:14:46.000000', 'temperatura', 1033.0000, 'ºC'),
	(159059, 121, '2014-01-15 01:14:47.000000', 'temperatura', 157.0000, 'ºC'),
	(159060, 121, '2014-01-15 01:14:48.000000', 'temperatura', 84.0000, 'ºC'),
	(159061, 121, '2014-01-15 01:14:49.000000', 'temperatura', 1153.0000, 'ºC'),
	(159062, 121, '2014-01-15 01:14:50.000000', 'temperatura', 711.0000, 'ºC'),
	(159063, 121, '2014-01-15 01:14:51.000000', 'temperatura', 96.0000, 'ºC'),
	(159064, 121, '2014-01-15 01:14:52.000000', 'temperatura', 748.0000, 'ºC'),
	(159065, 121, '2014-01-15 01:14:53.000000', 'temperatura', 1052.0000, 'ºC'),
	(159066, 121, '2014-01-15 01:14:54.000000', 'temperatura', 615.0000, 'ºC'),
	(159067, 121, '2014-01-15 01:14:55.000000', 'temperatura', 1123.0000, 'ºC'),
	(159068, 121, '2014-01-15 01:14:56.000000', 'temperatura', 168.0000, 'ºC'),
	(159069, 121, '2014-01-15 01:14:57.000000', 'temperatura', 1070.0000, 'ºC'),
	(159070, 121, '2014-01-15 01:14:58.000000', 'temperatura', 49.0000, 'ºC'),
	(159071, 121, '2014-01-15 01:14:59.000000', 'temperatura', 634.0000, 'ºC'),
	(159072, 121, '2014-01-15 01:15:00.000000', 'temperatura', 624.0000, 'ºC'),
	(159073, 121, '2014-01-15 01:15:01.000000', 'temperatura', 19.0000, 'ºC'),
	(159074, 121, '2014-01-15 01:15:02.000000', 'temperatura', 624.0000, 'ºC'),
	(159075, 121, '2014-01-15 01:15:03.000000', 'temperatura', 665.0000, 'ºC'),
	(159076, 121, '2014-01-15 01:15:04.000000', 'temperatura', 251.0000, 'ºC'),
	(159077, 121, '2014-01-15 01:15:05.000000', 'temperatura', 461.0000, 'ºC'),
	(159078, 121, '2014-01-15 01:15:06.000000', 'temperatura', 354.0000, 'ºC'),
	(159079, 121, '2014-01-15 01:15:07.000000', 'temperatura', 388.0000, 'ºC'),
	(159080, 121, '2014-01-15 01:15:08.000000', 'temperatura', 879.0000, 'ºC'),
	(159081, 121, '2014-01-15 01:15:09.000000', 'temperatura', 831.0000, 'ºC'),
	(159082, 121, '2014-01-15 01:15:10.000000', 'temperatura', 318.0000, 'ºC'),
	(159083, 121, '2014-01-15 01:15:11.000000', 'temperatura', 296.0000, 'ºC'),
	(159084, 121, '2014-01-15 01:15:12.000000', 'temperatura', 526.0000, 'ºC'),
	(159085, 121, '2014-01-15 01:15:13.000000', 'temperatura', 543.0000, 'ºC'),
	(159086, 121, '2014-01-15 01:15:14.000000', 'temperatura', 1137.0000, 'ºC'),
	(159087, 121, '2014-01-15 01:15:15.000000', 'temperatura', 457.0000, 'ºC'),
	(159088, 121, '2014-01-15 01:15:16.000000', 'temperatura', 76.0000, 'ºC'),
	(159089, 121, '2014-01-15 01:15:17.000000', 'temperatura', 208.0000, 'ºC'),
	(159090, 121, '2014-01-15 01:15:18.000000', 'temperatura', 813.0000, 'ºC'),
	(159091, 121, '2014-01-15 01:15:19.000000', 'temperatura', 1043.0000, 'ºC'),
	(159092, 121, '2014-01-15 01:15:20.000000', 'temperatura', 377.0000, 'ºC'),
	(159093, 121, '2014-01-15 01:15:21.000000', 'temperatura', 1157.0000, 'ºC'),
	(159094, 121, '2014-01-15 01:15:22.000000', 'temperatura', 1052.0000, 'ºC'),
	(159095, 121, '2014-01-15 01:15:23.000000', 'temperatura', 591.0000, 'ºC'),
	(159096, 121, '2014-01-15 01:15:24.000000', 'temperatura', 999.0000, 'ºC'),
	(159097, 121, '2014-01-15 01:15:25.000000', 'temperatura', 823.0000, 'ºC'),
	(159098, 121, '2014-01-15 01:15:26.000000', 'temperatura', 1118.0000, 'ºC'),
	(159099, 121, '2014-01-15 01:15:27.000000', 'temperatura', 721.0000, 'ºC'),
	(159100, 121, '2014-01-15 01:15:28.000000', 'temperatura', 250.0000, 'ºC'),
	(159101, 121, '2014-01-15 01:15:29.000000', 'temperatura', 288.0000, 'ºC'),
	(159102, 121, '2014-01-15 01:15:30.000000', 'temperatura', 692.0000, 'ºC'),
	(159103, 121, '2014-01-15 01:15:31.000000', 'temperatura', 197.0000, 'ºC'),
	(159104, 121, '2014-01-15 01:15:32.000000', 'temperatura', 107.0000, 'ºC'),
	(159105, 121, '2014-01-15 01:15:33.000000', 'temperatura', 1145.0000, 'ºC'),
	(159106, 121, '2014-01-15 01:15:34.000000', 'temperatura', 604.0000, 'ºC'),
	(159107, 121, '2014-01-15 01:15:35.000000', 'temperatura', 785.0000, 'ºC'),
	(159108, 121, '2014-01-15 01:15:36.000000', 'temperatura', 916.0000, 'ºC'),
	(159109, 121, '2014-01-15 01:15:37.000000', 'temperatura', 1025.0000, 'ºC'),
	(159110, 121, '2014-01-15 01:15:38.000000', 'temperatura', 1177.0000, 'ºC'),
	(159111, 121, '2014-01-15 01:15:39.000000', 'temperatura', 409.0000, 'ºC'),
	(159112, 121, '2014-01-15 01:15:40.000000', 'temperatura', 916.0000, 'ºC'),
	(159113, 121, '2014-01-15 01:15:41.000000', 'temperatura', 954.0000, 'ºC'),
	(159114, 121, '2014-01-15 01:15:42.000000', 'temperatura', 823.0000, 'ºC'),
	(159115, 121, '2014-01-15 01:15:43.000000', 'temperatura', 55.0000, 'ºC'),
	(159116, 121, '2014-01-15 01:15:44.000000', 'temperatura', 204.0000, 'ºC'),
	(159117, 121, '2014-01-15 01:15:45.000000', 'temperatura', 855.0000, 'ºC'),
	(159118, 121, '2014-01-15 01:15:46.000000', 'temperatura', 63.0000, 'ºC'),
	(159119, 121, '2014-01-15 01:15:47.000000', 'temperatura', 150.0000, 'ºC'),
	(159120, 121, '2014-01-15 01:15:48.000000', 'temperatura', 563.0000, 'ºC'),
	(159121, 121, '2014-01-15 01:15:49.000000', 'temperatura', 1164.0000, 'ºC'),
	(159122, 121, '2014-01-15 01:15:50.000000', 'temperatura', 534.0000, 'ºC'),
	(159123, 121, '2014-01-15 01:15:51.000000', 'temperatura', 376.0000, 'ºC'),
	(159124, 121, '2014-01-15 01:15:52.000000', 'temperatura', 278.0000, 'ºC'),
	(159125, 121, '2014-01-15 01:15:53.000000', 'temperatura', 262.0000, 'ºC'),
	(159126, 121, '2014-01-15 01:15:54.000000', 'temperatura', 478.0000, 'ºC'),
	(159127, 121, '2014-01-15 01:15:55.000000', 'temperatura', 406.0000, 'ºC'),
	(159128, 121, '2014-01-15 01:15:56.000000', 'temperatura', 596.0000, 'ºC'),
	(159129, 121, '2014-01-15 01:15:57.000000', 'temperatura', 562.0000, 'ºC'),
	(159130, 121, '2014-01-15 01:15:58.000000', 'temperatura', 1021.0000, 'ºC'),
	(159131, 121, '2014-01-15 01:15:59.000000', 'temperatura', 1020.0000, 'ºC'),
	(159132, 121, '2014-01-15 01:16:00.000000', 'temperatura', 838.0000, 'ºC'),
	(159133, 121, '2014-01-15 01:16:01.000000', 'temperatura', 1132.0000, 'ºC'),
	(159134, 121, '2014-01-15 01:16:02.000000', 'temperatura', 744.0000, 'ºC'),
	(159135, 121, '2014-01-15 01:16:03.000000', 'temperatura', 326.0000, 'ºC'),
	(159136, 121, '2014-01-15 01:16:04.000000', 'temperatura', 597.0000, 'ºC'),
	(159137, 121, '2014-01-15 01:16:05.000000', 'temperatura', 808.0000, 'ºC'),
	(159138, 121, '2014-01-15 01:16:06.000000', 'temperatura', 1050.0000, 'ºC'),
	(159139, 121, '2014-01-15 01:16:07.000000', 'temperatura', 427.0000, 'ºC'),
	(159140, 121, '2014-01-15 01:16:08.000000', 'temperatura', 184.0000, 'ºC'),
	(159141, 121, '2014-01-15 01:16:09.000000', 'temperatura', 841.0000, 'ºC'),
	(159142, 121, '2014-01-15 01:16:10.000000', 'temperatura', 51.0000, 'ºC'),
	(159143, 121, '2014-01-15 01:16:11.000000', 'temperatura', 133.0000, 'ºC'),
	(159144, 121, '2014-01-15 01:16:12.000000', 'temperatura', 514.0000, 'ºC'),
	(159145, 121, '2014-01-15 01:16:13.000000', 'temperatura', 971.0000, 'ºC'),
	(159146, 121, '2014-01-15 01:16:14.000000', 'temperatura', 912.0000, 'ºC'),
	(159147, 121, '2014-01-15 01:16:15.000000', 'temperatura', 449.0000, 'ºC'),
	(159148, 121, '2014-01-15 01:16:16.000000', 'temperatura', 710.0000, 'ºC'),
	(159149, 121, '2014-01-15 01:16:17.000000', 'temperatura', 1003.0000, 'ºC'),
	(159150, 121, '2014-01-15 01:16:18.000000', 'temperatura', 486.0000, 'ºC'),
	(159151, 121, '2014-01-15 01:16:19.000000', 'temperatura', 621.0000, 'ºC'),
	(159152, 121, '2014-01-15 01:16:20.000000', 'temperatura', 446.0000, 'ºC'),
	(159153, 121, '2014-01-15 01:16:21.000000', 'temperatura', 368.0000, 'ºC'),
	(159154, 121, '2014-01-15 01:16:22.000000', 'temperatura', 502.0000, 'ºC'),
	(159155, 121, '2014-01-15 01:16:23.000000', 'temperatura', 209.0000, 'ºC'),
	(159156, 121, '2014-01-15 01:16:24.000000', 'temperatura', 737.0000, 'ºC'),
	(159157, 121, '2014-01-15 01:16:25.000000', 'temperatura', 660.0000, 'ºC'),
	(159158, 121, '2014-01-15 01:16:26.000000', 'temperatura', 1087.0000, 'ºC'),
	(159159, 121, '2014-01-15 01:16:27.000000', 'temperatura', 1057.0000, 'ºC'),
	(159160, 121, '2014-01-15 01:16:28.000000', 'temperatura', 823.0000, 'ºC'),
	(159161, 121, '2014-01-15 01:16:29.000000', 'temperatura', 946.0000, 'ºC'),
	(159162, 121, '2014-01-15 01:16:30.000000', 'temperatura', 1061.0000, 'ºC'),
	(159163, 121, '2014-01-15 01:16:31.000000', 'temperatura', 68.0000, 'ºC'),
	(159164, 121, '2014-01-15 01:16:32.000000', 'temperatura', 756.0000, 'ºC'),
	(159165, 121, '2014-01-15 01:16:33.000000', 'temperatura', 1177.0000, 'ºC'),
	(159166, 121, '2014-01-15 01:16:34.000000', 'temperatura', 19.0000, 'ºC'),
	(159167, 121, '2014-01-15 01:16:35.000000', 'temperatura', 162.0000, 'ºC'),
	(159168, 121, '2014-01-15 01:16:36.000000', 'temperatura', 754.0000, 'ºC'),
	(159169, 121, '2014-01-15 01:16:37.000000', 'temperatura', 886.0000, 'ºC'),
	(159170, 121, '2014-01-15 01:16:38.000000', 'temperatura', 969.0000, 'ºC'),
	(159171, 121, '2014-01-15 01:16:39.000000', 'temperatura', 989.0000, 'ºC'),
	(159172, 121, '2014-01-15 01:16:40.000000', 'temperatura', 836.0000, 'ºC'),
	(159173, 121, '2014-01-15 01:16:41.000000', 'temperatura', 13.0000, 'ºC'),
	(159174, 121, '2014-01-15 01:16:42.000000', 'temperatura', 1160.0000, 'ºC'),
	(159175, 121, '2014-01-15 01:16:43.000000', 'temperatura', 961.0000, 'ºC'),
	(159176, 121, '2014-01-15 01:16:44.000000', 'temperatura', 127.0000, 'ºC'),
	(159177, 121, '2014-01-15 01:16:45.000000', 'temperatura', 152.0000, 'ºC'),
	(159178, 121, '2014-01-15 01:16:46.000000', 'temperatura', 377.0000, 'ºC'),
	(159179, 121, '2014-01-15 01:16:47.000000', 'temperatura', 230.0000, 'ºC'),
	(159180, 121, '2014-01-15 01:16:48.000000', 'temperatura', 19.0000, 'ºC'),
	(159181, 121, '2014-01-15 01:16:49.000000', 'temperatura', 607.0000, 'ºC'),
	(159182, 121, '2014-01-15 01:16:50.000000', 'temperatura', 580.0000, 'ºC'),
	(159183, 121, '2014-01-15 01:16:51.000000', 'temperatura', 1077.0000, 'ºC'),
	(159184, 121, '2014-01-15 01:16:52.000000', 'temperatura', 46.0000, 'ºC'),
	(159185, 121, '2014-01-15 01:16:53.000000', 'temperatura', 600.0000, 'ºC'),
	(159186, 121, '2014-01-15 01:16:54.000000', 'temperatura', 462.0000, 'ºC'),
	(159187, 121, '2014-01-15 01:16:55.000000', 'temperatura', 509.0000, 'ºC'),
	(159188, 121, '2014-01-15 01:16:56.000000', 'temperatura', 1159.0000, 'ºC'),
	(159189, 121, '2014-01-15 01:16:57.000000', 'temperatura', 671.0000, 'ºC'),
	(159190, 121, '2014-01-15 01:16:58.000000', 'temperatura', 1076.0000, 'ºC'),
	(159191, 121, '2014-01-15 01:16:59.000000', 'temperatura', 968.0000, 'ºC'),
	(159192, 121, '2014-01-15 01:17:00.000000', 'temperatura', 412.0000, 'ºC'),
	(159193, 121, '2014-01-15 01:17:01.000000', 'temperatura', 357.0000, 'ºC'),
	(159194, 121, '2014-01-15 01:17:02.000000', 'temperatura', 551.0000, 'ºC'),
	(159195, 121, '2014-01-15 01:17:03.000000', 'temperatura', 484.0000, 'ºC'),
	(159196, 121, '2014-01-15 01:17:04.000000', 'temperatura', 765.0000, 'ºC'),
	(159197, 121, '2014-01-15 01:17:05.000000', 'temperatura', 1176.0000, 'ºC'),
	(159198, 121, '2014-01-15 01:17:06.000000', 'temperatura', 1185.0000, 'ºC'),
	(159199, 121, '2014-01-15 01:17:07.000000', 'temperatura', 1197.0000, 'ºC'),
	(159200, 121, '2014-01-15 01:17:08.000000', 'temperatura', 33.0000, 'ºC'),
	(159201, 121, '2014-01-15 01:17:09.000000', 'temperatura', 171.0000, 'ºC'),
	(159202, 121, '2014-01-15 01:17:10.000000', 'temperatura', 757.0000, 'ºC'),
	(159203, 121, '2014-01-15 01:17:11.000000', 'temperatura', 874.0000, 'ºC'),
	(159204, 121, '2014-01-15 01:17:12.000000', 'temperatura', 899.0000, 'ºC'),
	(159205, 121, '2014-01-15 01:17:13.000000', 'temperatura', 674.0000, 'ºC'),
	(159206, 121, '2014-01-15 01:17:14.000000', 'temperatura', 671.0000, 'ºC'),
	(159207, 121, '2014-01-15 01:17:15.000000', 'temperatura', 136.0000, 'ºC'),
	(159208, 121, '2014-01-15 01:17:16.000000', 'temperatura', 1067.0000, 'ºC'),
	(159209, 121, '2014-01-15 01:17:17.000000', 'temperatura', 129.0000, 'ºC'),
	(159210, 121, '2014-01-15 01:17:18.000000', 'temperatura', 1043.0000, 'ºC'),
	(159211, 121, '2014-01-15 01:17:19.000000', 'temperatura', 29.0000, 'ºC'),
	(159212, 121, '2014-01-15 01:17:20.000000', 'temperatura', 618.0000, 'ºC'),
	(159213, 121, '2014-01-15 01:17:21.000000', 'temperatura', 603.0000, 'ºC'),
	(159214, 121, '2014-01-15 01:17:22.000000', 'temperatura', 1161.0000, 'ºC'),
	(159215, 121, '2014-01-15 01:17:23.000000', 'temperatura', 398.0000, 'ºC'),
	(159216, 121, '2014-01-15 01:17:24.000000', 'temperatura', 906.0000, 'ºC'),
	(159217, 121, '2014-01-15 01:17:25.000000', 'temperatura', 939.0000, 'ºC'),
	(159218, 121, '2014-01-15 01:17:26.000000', 'temperatura', 775.0000, 'ºC'),
	(159219, 121, '2014-01-15 01:17:27.000000', 'temperatura', 1061.0000, 'ºC'),
	(159220, 121, '2014-01-15 01:17:28.000000', 'temperatura', 579.0000, 'ºC'),
	(159221, 121, '2014-01-15 01:17:29.000000', 'temperatura', 913.0000, 'ºC'),
	(159222, 121, '2014-01-15 01:17:30.000000', 'temperatura', 429.0000, 'ºC'),
	(159223, 121, '2014-01-15 01:17:31.000000', 'temperatura', 607.0000, 'ºC'),
	(159224, 121, '2014-01-15 01:17:32.000000', 'temperatura', 546.0000, 'ºC'),
	(159225, 121, '2014-01-15 01:17:33.000000', 'temperatura', 910.0000, 'ºC'),
	(159226, 121, '2014-01-15 01:17:34.000000', 'temperatura', 511.0000, 'ºC'),
	(159227, 121, '2014-01-15 01:17:35.000000', 'temperatura', 1027.0000, 'ºC'),
	(159228, 121, '2014-01-15 01:17:36.000000', 'temperatura', 2.0000, 'ºC'),
	(159229, 121, '2014-01-15 01:17:37.000000', 'temperatura', 530.0000, 'ºC'),
	(159230, 121, '2014-01-15 01:17:38.000000', 'temperatura', 246.0000, 'ºC'),
	(159231, 121, '2014-01-15 01:17:39.000000', 'temperatura', 841.0000, 'ºC'),
	(159232, 121, '2014-01-15 01:17:40.000000', 'temperatura', 1067.0000, 'ºC'),
	(159233, 121, '2014-01-15 01:17:41.000000', 'temperatura', 412.0000, 'ºC'),
	(159234, 121, '2014-01-15 01:17:42.000000', 'temperatura', 62.0000, 'ºC'),
	(159235, 121, '2014-01-15 01:17:43.000000', 'temperatura', 271.0000, 'ºC'),
	(159236, 121, '2014-01-15 01:17:44.000000', 'temperatura', 1170.0000, 'ºC'),
	(159237, 121, '2014-01-15 01:17:45.000000', 'temperatura', 236.0000, 'ºC'),
	(159238, 121, '2014-01-15 01:17:46.000000', 'temperatura', 72.0000, 'ºC'),
	(159239, 121, '2014-01-15 01:17:47.000000', 'temperatura', 852.0000, 'ºC'),
	(159240, 121, '2014-01-15 01:17:48.000000', 'temperatura', 443.0000, 'ºC'),
	(159241, 121, '2014-01-15 01:17:49.000000', 'temperatura', 860.0000, 'ºC'),
	(159242, 121, '2014-01-15 01:17:50.000000', 'temperatura', 571.0000, 'ºC'),
	(159243, 121, '2014-01-15 01:17:51.000000', 'temperatura', 275.0000, 'ºC'),
	(159244, 121, '2014-01-15 01:17:52.000000', 'temperatura', 862.0000, 'ºC'),
	(159245, 121, '2014-01-15 01:17:53.000000', 'temperatura', 1086.0000, 'ºC'),
	(159246, 121, '2014-01-15 01:17:54.000000', 'temperatura', 443.0000, 'ºC'),
	(159247, 121, '2014-01-15 01:17:55.000000', 'temperatura', 160.0000, 'ºC'),
	(159248, 121, '2014-01-15 01:17:56.000000', 'temperatura', 671.0000, 'ºC'),
	(159249, 121, '2014-01-15 01:17:57.000000', 'temperatura', 475.0000, 'ºC'),
	(159250, 121, '2014-01-15 01:17:58.000000', 'temperatura', 364.0000, 'ºC'),
	(159251, 121, '2014-01-15 01:17:59.000000', 'temperatura', 394.0000, 'ºC'),
	(159252, 121, '2014-01-15 01:18:00.000000', 'temperatura', 877.0000, 'ºC'),
	(159253, 121, '2014-01-15 01:18:01.000000', 'temperatura', 804.0000, 'ºC'),
	(159254, 121, '2014-01-15 01:18:02.000000', 'temperatura', 191.0000, 'ºC'),
	(159255, 121, '2014-01-15 01:18:03.000000', 'temperatura', 942.0000, 'ºC'),
	(159256, 121, '2014-01-15 01:18:04.000000', 'temperatura', 538.0000, 'ºC'),
	(159257, 121, '2014-01-15 01:18:05.000000', 'temperatura', 1064.0000, 'ºC'),
	(159258, 121, '2014-01-15 01:18:06.000000', 'temperatura', 108.0000, 'ºC'),
	(159259, 121, '2014-01-15 01:18:07.000000', 'temperatura', 946.0000, 'ºC'),
	(159260, 121, '2014-01-15 01:18:08.000000', 'temperatura', 808.0000, 'ºC'),
	(159261, 121, '2014-01-15 01:18:09.000000', 'temperatura', 3.0000, 'ºC'),
	(159262, 121, '2014-01-15 01:18:10.000000', 'temperatura', 1189.0000, 'ºC'),
	(159263, 121, '2014-01-15 01:18:11.000000', 'temperatura', 1138.0000, 'ºC'),
	(159264, 121, '2014-01-15 01:18:12.000000', 'temperatura', 924.0000, 'ºC'),
	(159265, 121, '2014-01-15 01:18:13.000000', 'temperatura', 7.0000, 'ºC'),
	(159266, 121, '2014-01-15 01:18:14.000000', 'temperatura', 861.0000, 'ºC'),
	(159267, 121, '2014-01-15 01:18:15.000000', 'temperatura', 688.0000, 'ºC'),
	(159268, 121, '2014-01-15 01:18:16.000000', 'temperatura', 854.0000, 'ºC'),
	(159269, 121, '2014-01-15 01:18:17.000000', 'temperatura', 1008.0000, 'ºC'),
	(159270, 121, '2014-01-15 01:18:18.000000', 'temperatura', 77.0000, 'ºC'),
	(159271, 121, '2014-01-15 01:18:19.000000', 'temperatura', 963.0000, 'ºC'),
	(159272, 121, '2014-01-15 01:18:20.000000', 'temperatura', 983.0000, 'ºC'),
	(159273, 121, '2014-01-15 01:18:21.000000', 'temperatura', 826.0000, 'ºC'),
	(159274, 121, '2014-01-15 01:18:22.000000', 'temperatura', 1181.0000, 'ºC'),
	(159275, 121, '2014-01-15 01:18:23.000000', 'temperatura', 1027.0000, 'ºC'),
	(159276, 121, '2014-01-15 01:18:24.000000', 'temperatura', 396.0000, 'ºC'),
	(159277, 121, '2014-01-15 01:18:25.000000', 'temperatura', 96.0000, 'ºC'),
	(159278, 121, '2014-01-15 01:18:26.000000', 'temperatura', 494.0000, 'ºC'),
	(159279, 121, '2014-01-15 01:18:27.000000', 'temperatura', 984.0000, 'ºC'),
	(159280, 121, '2014-01-15 01:18:28.000000', 'temperatura', 1036.0000, 'ºC'),
	(159281, 121, '2014-01-15 01:18:29.000000', 'temperatura', 1028.0000, 'ºC'),
	(159282, 121, '2014-01-15 01:18:30.000000', 'temperatura', 833.0000, 'ºC'),
	(159283, 121, '2014-01-15 01:18:31.000000', 'temperatura', 1082.0000, 'ºC'),
	(159284, 121, '2014-01-15 01:18:32.000000', 'temperatura', 511.0000, 'ºC'),
	(159285, 121, '2014-01-15 01:18:33.000000', 'temperatura', 510.0000, 'ºC'),
	(159286, 121, '2014-01-15 01:18:34.000000', 'temperatura', 1016.0000, 'ºC'),
	(159287, 121, '2014-01-15 01:18:35.000000', 'temperatura', 1151.0000, 'ºC'),
	(159288, 121, '2014-01-15 01:18:36.000000', 'temperatura', 309.0000, 'ºC'),
	(159289, 121, '2014-01-15 01:18:37.000000', 'temperatura', 493.0000, 'ºC'),
	(159290, 121, '2014-01-15 01:18:38.000000', 'temperatura', 338.0000, 'ºC'),
	(159291, 121, '2014-01-15 01:18:39.000000', 'temperatura', 211.0000, 'ºC'),
	(159292, 121, '2014-01-15 01:18:40.000000', 'temperatura', 43.0000, 'ºC'),
	(159293, 121, '2014-01-15 01:18:41.000000', 'temperatura', 782.0000, 'ºC'),
	(159294, 121, '2014-01-15 01:18:42.000000', 'temperatura', 181.0000, 'ºC'),
	(159295, 121, '2014-01-15 01:18:43.000000', 'temperatura', 960.0000, 'ºC'),
	(159296, 121, '2014-01-15 01:18:44.000000', 'temperatura', 656.0000, 'ºC'),
	(159297, 121, '2014-01-15 01:18:45.000000', 'temperatura', 401.0000, 'ºC'),
	(159298, 121, '2014-01-15 01:18:46.000000', 'temperatura', 40.0000, 'ºC'),
	(159299, 121, '2014-01-15 01:18:47.000000', 'temperatura', 195.0000, 'ºC'),
	(159300, 121, '2014-01-15 01:18:48.000000', 'temperatura', 857.0000, 'ºC'),
	(159301, 121, '2014-01-15 01:18:49.000000', 'temperatura', 99.0000, 'ºC'),
	(159302, 121, '2014-01-15 01:18:50.000000', 'temperatura', 325.0000, 'ºC'),
	(159303, 121, '2014-01-15 01:18:51.000000', 'temperatura', 128.0000, 'ºC'),
	(159304, 121, '2014-01-15 01:18:52.000000', 'temperatura', 864.0000, 'ºC'),
	(159305, 121, '2014-01-15 01:18:53.000000', 'temperatura', 337.0000, 'ºC'),
	(159306, 121, '2014-01-15 01:18:54.000000', 'temperatura', 294.0000, 'ºC'),
	(159307, 121, '2014-01-15 01:18:55.000000', 'temperatura', 458.0000, 'ºC'),
	(159308, 121, '2014-01-15 01:18:56.000000', 'temperatura', 208.0000, 'ºC'),
	(159309, 121, '2014-01-15 01:18:57.000000', 'temperatura', 867.0000, 'ºC'),
	(159310, 121, '2014-01-15 01:18:58.000000', 'temperatura', 113.0000, 'ºC'),
	(159311, 121, '2014-01-15 01:18:59.000000', 'temperatura', 364.0000, 'ºC'),
	(159312, 121, '2014-01-15 01:19:00.000000', 'temperatura', 281.0000, 'ºC'),
	(159313, 121, '2014-01-15 01:19:01.000000', 'temperatura', 313.0000, 'ºC'),
	(159314, 121, '2014-01-15 01:19:02.000000', 'temperatura', 725.0000, 'ºC'),
	(159315, 121, '2014-01-15 01:19:03.000000', 'temperatura', 283.0000, 'ºC'),
	(159316, 121, '2014-01-15 01:19:04.000000', 'temperatura', 443.0000, 'ºC'),
	(159317, 121, '2014-01-15 01:19:05.000000', 'temperatura', 167.0000, 'ºC'),
	(159318, 121, '2014-01-15 01:19:06.000000', 'temperatura', 704.0000, 'ºC'),
	(159319, 121, '2014-01-15 01:19:07.000000', 'temperatura', 622.0000, 'ºC'),
	(159320, 121, '2014-01-15 01:19:08.000000', 'temperatura', 999.0000, 'ºC'),
	(159321, 121, '2014-01-15 01:19:09.000000', 'temperatura', 727.0000, 'ºC'),
	(159322, 121, '2014-01-15 01:19:10.000000', 'temperatura', 639.0000, 'ºC'),
	(159323, 121, '2014-01-15 01:19:11.000000', 'temperatura', 1015.0000, 'ºC'),
	(159324, 121, '2014-01-15 01:19:12.000000', 'temperatura', 759.0000, 'ºC'),
	(159325, 121, '2014-01-15 01:19:13.000000', 'temperatura', 751.0000, 'ºC'),
	(159326, 121, '2014-01-15 01:19:14.000000', 'temperatura', 276.0000, 'ºC'),
	(159327, 121, '2014-01-15 01:19:15.000000', 'temperatura', 331.0000, 'ºC'),
	(159328, 121, '2014-01-15 01:19:16.000000', 'temperatura', 825.0000, 'ºC'),
	(159329, 121, '2014-01-15 01:19:17.000000', 'temperatura', 735.0000, 'ºC'),
	(159330, 121, '2014-01-15 01:19:18.000000', 'temperatura', 0.0000, 'ºC'),
	(159331, 121, '2014-01-15 01:19:19.000000', 'temperatura', 194.0000, 'ºC'),
	(159332, 121, '2014-01-15 01:19:20.000000', 'temperatura', 970.0000, 'ºC'),
	(159333, 121, '2014-01-15 01:19:21.000000', 'temperatura', 670.0000, 'ºC'),
	(159334, 121, '2014-01-15 01:19:22.000000', 'temperatura', 441.0000, 'ºC'),
	(159335, 121, '2014-01-15 01:19:23.000000', 'temperatura', 195.0000, 'ºC'),
	(159336, 121, '2014-01-15 01:19:24.000000', 'temperatura', 852.0000, 'ºC'),
	(159337, 121, '2014-01-15 01:19:25.000000', 'temperatura', 75.0000, 'ºC'),
	(159338, 121, '2014-01-15 01:19:26.000000', 'temperatura', 218.0000, 'ºC'),
	(159339, 121, '2014-01-15 01:19:27.000000', 'temperatura', 868.0000, 'ºC'),
	(159340, 121, '2014-01-15 01:19:28.000000', 'temperatura', 84.0000, 'ºC'),
	(159341, 121, '2014-01-15 01:19:29.000000', 'temperatura', 216.0000, 'ºC'),
	(159342, 121, '2014-01-15 01:19:30.000000', 'temperatura', 831.0000, 'ºC'),
	(159343, 121, '2014-01-15 01:19:31.000000', 'temperatura', 1106.0000, 'ºC'),
	(159344, 121, '2014-01-15 01:19:32.000000', 'temperatura', 638.0000, 'ºC'),
	(159345, 121, '2014-01-15 01:19:33.000000', 'temperatura', 1073.0000, 'ºC'),
	(159346, 121, '2014-01-15 01:19:34.000000', 'temperatura', 1050.0000, 'ºC'),
	(159347, 121, '2014-01-15 01:19:35.000000', 'temperatura', 830.0000, 'ºC'),
	(159348, 121, '2014-01-15 01:19:36.000000', 'temperatura', 1003.0000, 'ºC'),
	(159349, 121, '2014-01-15 01:19:37.000000', 'temperatura', 124.0000, 'ºC'),
	(159350, 121, '2014-01-15 01:19:38.000000', 'temperatura', 13.0000, 'ºC'),
	(159351, 121, '2014-01-15 01:19:39.000000', 'temperatura', 891.0000, 'ºC'),
	(159352, 121, '2014-01-15 01:19:40.000000', 'temperatura', 819.0000, 'ºC'),
	(159353, 121, '2014-01-15 01:19:41.000000', 'temperatura', 220.0000, 'ºC'),
	(159354, 121, '2014-01-15 01:19:42.000000', 'temperatura', 1047.0000, 'ºC'),
	(159355, 121, '2014-01-15 01:19:43.000000', 'temperatura', 972.0000, 'ºC'),
	(159356, 121, '2014-01-15 01:19:44.000000', 'temperatura', 521.0000, 'ºC'),
	(159357, 121, '2014-01-15 01:19:45.000000', 'temperatura', 889.0000, 'ºC'),
	(159358, 121, '2014-01-15 01:19:46.000000', 'temperatura', 484.0000, 'ºC'),
	(159359, 121, '2014-01-15 01:19:47.000000', 'temperatura', 952.0000, 'ºC'),
	(159360, 121, '2014-01-15 01:19:48.000000', 'temperatura', 908.0000, 'ºC'),
	(159361, 121, '2014-01-15 01:19:49.000000', 'temperatura', 485.0000, 'ºC'),
	(159362, 121, '2014-01-15 01:19:50.000000', 'temperatura', 903.0000, 'ºC'),
	(159363, 121, '2014-01-15 01:19:51.000000', 'temperatura', 659.0000, 'ºC'),
	(159364, 121, '2014-01-15 01:19:52.000000', 'temperatura', 587.0000, 'ºC'),
	(159365, 121, '2014-01-15 01:19:53.000000', 'temperatura', 959.0000, 'ºC'),
	(159366, 121, '2014-01-15 01:19:54.000000', 'temperatura', 633.0000, 'ºC'),
	(159367, 121, '2014-01-15 01:19:55.000000', 'temperatura', 289.0000, 'ºC'),
	(159368, 121, '2014-01-15 01:19:56.000000', 'temperatura', 747.0000, 'ºC'),
	(159369, 121, '2014-01-15 01:19:57.000000', 'temperatura', 469.0000, 'ºC'),
	(159370, 121, '2014-01-15 01:19:58.000000', 'temperatura', 105.0000, 'ºC'),
	(159371, 121, '2014-01-15 01:19:59.000000', 'temperatura', 317.0000, 'ºC'),
	(159372, 121, '2014-01-15 01:20:00.000000', 'temperatura', 71.0000, 'ºC'),
	(159373, 121, '2014-01-15 01:20:01.000000', 'temperatura', 603.0000, 'ºC'),
	(159374, 121, '2014-01-15 01:20:02.000000', 'temperatura', 402.0000, 'ºC'),
	(159375, 121, '2014-01-15 01:20:03.000000', 'temperatura', 202.0000, 'ºC'),
	(159376, 121, '2014-01-15 01:20:04.000000', 'temperatura', 1006.0000, 'ºC'),
	(159377, 121, '2014-01-15 01:20:05.000000', 'temperatura', 825.0000, 'ºC'),
	(159378, 121, '2014-01-15 01:20:06.000000', 'temperatura', 1108.0000, 'ºC'),
	(159379, 121, '2014-01-15 01:20:07.000000', 'temperatura', 667.0000, 'ºC'),
	(159380, 121, '2014-01-15 01:20:08.000000', 'temperatura', 8.0000, 'ºC'),
	(159381, 121, '2014-01-15 01:20:09.000000', 'temperatura', 439.0000, 'ºC'),
	(159382, 121, '2014-01-15 01:20:10.000000', 'temperatura', 974.0000, 'ºC'),
	(159383, 121, '2014-01-15 01:20:11.000000', 'temperatura', 1154.0000, 'ºC'),
	(159384, 121, '2014-01-15 01:20:12.000000', 'temperatura', 449.0000, 'ºC'),
	(159385, 121, '2014-01-15 01:20:13.000000', 'temperatura', 1182.0000, 'ºC'),
	(159386, 121, '2014-01-15 01:20:14.000000', 'temperatura', 963.0000, 'ºC'),
	(159387, 121, '2014-01-15 01:20:15.000000', 'temperatura', 71.0000, 'ºC'),
	(159388, 121, '2014-01-15 01:20:16.000000', 'temperatura', 1068.0000, 'ºC'),
	(159389, 121, '2014-01-15 01:20:17.000000', 'temperatura', 326.0000, 'ºC'),
	(159390, 121, '2014-01-15 01:20:18.000000', 'temperatura', 826.0000, 'ºC'),
	(159391, 121, '2014-01-15 01:20:19.000000', 'temperatura', 755.0000, 'ºC'),
	(159392, 121, '2014-01-15 01:20:20.000000', 'temperatura', 96.0000, 'ºC'),
	(159393, 121, '2014-01-15 01:20:21.000000', 'temperatura', 614.0000, 'ºC'),
	(159394, 121, '2014-01-15 01:20:22.000000', 'temperatura', 385.0000, 'ºC'),
	(159395, 121, '2014-01-15 01:20:23.000000', 'temperatura', 81.0000, 'ºC'),
	(159396, 121, '2014-01-15 01:20:24.000000', 'temperatura', 450.0000, 'ºC'),
	(159397, 121, '2014-01-15 01:20:25.000000', 'temperatura', 810.0000, 'ºC'),
	(159398, 121, '2014-01-15 01:20:26.000000', 'temperatura', 298.0000, 'ºC'),
	(159399, 121, '2014-01-15 01:20:27.000000', 'temperatura', 259.0000, 'ºC'),
	(159400, 121, '2014-01-15 01:20:28.000000', 'temperatura', 405.0000, 'ºC'),
	(159401, 121, '2014-01-15 01:20:29.000000', 'temperatura', 48.0000, 'ºC'),
	(159402, 121, '2014-01-15 01:20:30.000000', 'temperatura', 223.0000, 'ºC'),
	(159403, 121, '2014-01-15 01:20:31.000000', 'temperatura', 973.0000, 'ºC'),
	(159404, 121, '2014-01-15 01:20:32.000000', 'temperatura', 595.0000, 'ºC'),
	(159405, 121, '2014-01-15 01:20:33.000000', 'temperatura', 59.0000, 'ºC'),
	(159406, 121, '2014-01-15 01:20:34.000000', 'temperatura', 910.0000, 'ºC'),
	(159407, 121, '2014-01-15 01:20:35.000000', 'temperatura', 775.0000, 'ºC'),
	(159408, 121, '2014-01-15 01:20:36.000000', 'temperatura', 1144.0000, 'ºC'),
	(159409, 121, '2014-01-15 01:20:37.000000', 'temperatura', 994.0000, 'ºC'),
	(159410, 121, '2014-01-15 01:20:38.000000', 'temperatura', 341.0000, 'ºC'),
	(159411, 121, '2014-01-15 01:20:39.000000', 'temperatura', 1121.0000, 'ºC'),
	(159412, 121, '2014-01-15 01:20:40.000000', 'temperatura', 982.0000, 'ºC'),
	(159413, 121, '2014-01-15 01:20:41.000000', 'temperatura', 349.0000, 'ºC'),
	(159414, 121, '2014-01-15 01:20:42.000000', 'temperatura', 1198.0000, 'ºC'),
	(159415, 121, '2014-01-15 01:20:43.000000', 'temperatura', 146.0000, 'ºC'),
	(159416, 121, '2014-01-15 01:20:44.000000', 'temperatura', 735.0000, 'ºC'),
	(159417, 121, '2014-01-15 01:20:45.000000', 'temperatura', 836.0000, 'ºC'),
	(159418, 121, '2014-01-15 01:20:46.000000', 'temperatura', 779.0000, 'ºC'),
	(159419, 121, '2014-01-15 01:20:47.000000', 'temperatura', 185.0000, 'ºC'),
	(159420, 121, '2014-01-15 01:20:48.000000', 'temperatura', 989.0000, 'ºC'),
	(159421, 121, '2014-01-15 01:20:49.000000', 'temperatura', 790.0000, 'ºC'),
	(159422, 121, '2014-01-15 01:20:50.000000', 'temperatura', 982.0000, 'ºC'),
	(159423, 121, '2014-01-15 01:20:51.000000', 'temperatura', 141.0000, 'ºC'),
	(159424, 121, '2014-01-15 01:20:52.000000', 'temperatura', 162.0000, 'ºC'),
	(159425, 121, '2014-01-15 01:20:53.000000', 'temperatura', 384.0000, 'ºC'),
	(159426, 121, '2014-01-15 01:20:54.000000', 'temperatura', 238.0000, 'ºC'),
	(159427, 121, '2014-01-15 01:20:55.000000', 'temperatura', 36.0000, 'ºC'),
	(159428, 121, '2014-01-15 01:20:56.000000', 'temperatura', 667.0000, 'ºC'),
	(159429, 121, '2014-01-15 01:20:57.000000', 'temperatura', 827.0000, 'ºC'),
	(159430, 121, '2014-01-15 01:20:58.000000', 'temperatura', 936.0000, 'ºC'),
	(159431, 121, '2014-01-15 01:20:59.000000', 'temperatura', 999.0000, 'ºC'),
	(159432, 121, '2014-01-15 01:21:00.000000', 'temperatura', 987.0000, 'ºC'),
	(159433, 121, '2014-01-15 01:21:01.000000', 'temperatura', 737.0000, 'ºC'),
	(159434, 121, '2014-01-15 01:21:02.000000', 'temperatura', 728.0000, 'ºC'),
	(159435, 121, '2014-01-15 01:21:03.000000', 'temperatura', 227.0000, 'ºC'),
	(159436, 121, '2014-01-15 01:21:04.000000', 'temperatura', 151.0000, 'ºC'),
	(159437, 121, '2014-01-15 01:21:05.000000', 'temperatura', 76.0000, 'ºC'),
	(159438, 121, '2014-01-15 01:21:06.000000', 'temperatura', 1127.0000, 'ºC'),
	(159439, 121, '2014-01-15 01:21:07.000000', 'temperatura', 606.0000, 'ºC'),
	(159440, 121, '2014-01-15 01:21:08.000000', 'temperatura', 849.0000, 'ºC'),
	(159441, 121, '2014-01-15 01:21:09.000000', 'temperatura', 29.0000, 'ºC'),
	(159442, 121, '2014-01-15 01:21:10.000000', 'temperatura', 1198.0000, 'ºC'),
	(159443, 121, '2014-01-15 01:21:11.000000', 'temperatura', 1106.0000, 'ºC'),
	(159444, 121, '2014-01-15 01:21:12.000000', 'temperatura', 733.0000, 'ºC'),
	(159445, 121, '2014-01-15 01:21:13.000000', 'temperatura', 351.0000, 'ºC'),
	(159446, 121, '2014-01-15 01:21:14.000000', 'temperatura', 755.0000, 'ºC'),
	(159447, 121, '2014-01-15 01:21:15.000000', 'temperatura', 321.0000, 'ºC'),
	(159448, 121, '2014-01-15 01:21:16.000000', 'temperatura', 541.0000, 'ºC'),
	(159449, 121, '2014-01-15 01:21:17.000000', 'temperatura', 543.0000, 'ºC'),
	(159450, 121, '2014-01-15 01:21:18.000000', 'temperatura', 1093.0000, 'ºC'),
	(159451, 121, '2014-01-15 01:21:19.000000', 'temperatura', 238.0000, 'ºC'),
	(159452, 121, '2014-01-15 01:21:20.000000', 'temperatura', 310.0000, 'ºC'),
	(159453, 121, '2014-01-15 01:21:21.000000', 'temperatura', 838.0000, 'ºC'),
	(159454, 121, '2014-01-15 01:21:22.000000', 'temperatura', 861.0000, 'ºC'),
	(159455, 121, '2014-01-15 01:21:23.000000', 'temperatura', 589.0000, 'ºC'),
	(159456, 121, '2014-01-15 01:21:24.000000', 'temperatura', 363.0000, 'ºC'),
	(159457, 121, '2014-01-15 01:21:25.000000', 'temperatura', 47.0000, 'ºC'),
	(159458, 121, '2014-01-15 01:21:26.000000', 'temperatura', 347.0000, 'ºC'),
	(159459, 121, '2014-01-15 01:21:27.000000', 'temperatura', 397.0000, 'ºC'),
	(159460, 121, '2014-01-15 01:21:28.000000', 'temperatura', 944.0000, 'ºC'),
	(159461, 121, '2014-01-15 01:21:29.000000', 'temperatura', 1127.0000, 'ºC'),
	(159462, 121, '2014-01-15 01:21:30.000000', 'temperatura', 405.0000, 'ºC'),
	(159463, 121, '2014-01-15 01:21:31.000000', 'temperatura', 1045.0000, 'ºC'),
	(159464, 121, '2014-01-15 01:21:32.000000', 'temperatura', 409.0000, 'ºC'),
	(159465, 121, '2014-01-15 01:21:33.000000', 'temperatura', 113.0000, 'ºC'),
	(159466, 121, '2014-01-15 01:21:34.000000', 'temperatura', 536.0000, 'ºC'),
	(159467, 121, '2014-01-15 01:21:35.000000', 'temperatura', 1141.0000, 'ºC'),
	(159468, 121, '2014-01-15 01:21:36.000000', 'temperatura', 499.0000, 'ºC'),
	(159469, 121, '2014-01-15 01:21:37.000000', 'temperatura', 272.0000, 'ºC'),
	(159470, 121, '2014-01-15 01:21:38.000000', 'temperatura', 1063.0000, 'ºC'),
	(159471, 121, '2014-01-15 01:21:39.000000', 'temperatura', 899.0000, 'ºC'),
	(159472, 121, '2014-01-15 01:21:40.000000', 'temperatura', 106.0000, 'ºC'),
	(159473, 121, '2014-01-15 01:21:41.000000', 'temperatura', 235.0000, 'ºC'),
	(159474, 121, '2014-01-15 01:21:42.000000', 'temperatura', 857.0000, 'ºC'),
	(159475, 121, '2014-01-15 01:21:43.000000', 'temperatura', 1181.0000, 'ºC'),
	(159476, 121, '2014-01-15 01:21:44.000000', 'temperatura', 934.0000, 'ºC'),
	(159477, 121, '2014-01-15 01:21:45.000000', 'temperatura', 1129.0000, 'ºC'),
	(159478, 121, '2014-01-15 01:21:46.000000', 'temperatura', 444.0000, 'ºC'),
	(159479, 121, '2014-01-15 01:21:47.000000', 'temperatura', 32.0000, 'ºC'),
	(159480, 121, '2014-01-15 01:21:48.000000', 'temperatura', 29.0000, 'ºC'),
	(159481, 121, '2014-01-15 01:21:49.000000', 'temperatura', 48.0000, 'ºC'),
	(159482, 121, '2014-01-15 01:21:50.000000', 'temperatura', 153.0000, 'ºC'),
	(159483, 121, '2014-01-15 01:21:51.000000', 'temperatura', 622.0000, 'ºC'),
	(159484, 121, '2014-01-15 01:21:52.000000', 'temperatura', 251.0000, 'ºC'),
	(159485, 121, '2014-01-15 01:21:53.000000', 'temperatura', 589.0000, 'ºC'),
	(159486, 121, '2014-01-15 01:21:54.000000', 'temperatura', 992.0000, 'ºC'),
	(159487, 121, '2014-01-15 01:21:55.000000', 'temperatura', 796.0000, 'ºC'),
	(159488, 121, '2014-01-15 01:21:56.000000', 'temperatura', 1004.0000, 'ºC'),
	(159489, 121, '2014-01-15 01:21:57.000000', 'temperatura', 232.0000, 'ºC'),
	(159490, 121, '2014-01-15 01:21:58.000000', 'temperatura', 550.0000, 'ºC'),
	(159491, 121, '2014-01-15 01:21:59.000000', 'temperatura', 855.0000, 'ºC'),
	(159492, 121, '2014-01-15 01:22:00.000000', 'temperatura', 223.0000, 'ºC'),
	(159493, 121, '2014-01-15 01:22:01.000000', 'temperatura', 953.0000, 'ºC'),
	(159494, 121, '2014-01-15 01:22:02.000000', 'temperatura', 497.0000, 'ºC'),
	(159495, 121, '2014-01-15 01:22:03.000000', 'temperatura', 825.0000, 'ºC'),
	(159496, 121, '2014-01-15 01:22:04.000000', 'temperatura', 237.0000, 'ºC'),
	(159497, 121, '2014-01-15 01:22:05.000000', 'temperatura', 1107.0000, 'ºC'),
	(159498, 121, '2014-01-15 01:22:06.000000', 'temperatura', 26.0000, 'ºC'),
	(159499, 121, '2014-01-15 01:22:07.000000', 'temperatura', 411.0000, 'ºC'),
	(159500, 121, '2014-01-15 01:22:08.000000', 'temperatura', 778.0000, 'ºC'),
	(159501, 121, '2014-01-15 01:22:09.000000', 'temperatura', 257.0000, 'ºC'),
	(159502, 121, '2014-01-15 01:22:10.000000', 'temperatura', 150.0000, 'ºC'),
	(159503, 121, '2014-01-15 01:22:11.000000', 'temperatura', 1182.0000, 'ºC'),
	(159504, 121, '2014-01-15 01:22:12.000000', 'temperatura', 657.0000, 'ºC'),
	(159505, 121, '2014-01-15 01:22:13.000000', 'temperatura', 942.0000, 'ºC'),
	(159506, 121, '2014-01-15 01:22:14.000000', 'temperatura', 339.0000, 'ºC'),
	(159507, 121, '2014-01-15 01:22:15.000000', 'temperatura', 68.0000, 'ºC'),
	(159508, 121, '2014-01-15 01:22:16.000000', 'temperatura', 523.0000, 'ºC'),
	(159509, 121, '2014-01-15 01:22:17.000000', 'temperatura', 14.0000, 'ºC'),
	(159510, 121, '2014-01-15 01:22:18.000000', 'temperatura', 899.0000, 'ºC'),
	(159511, 121, '2014-01-15 01:22:19.000000', 'temperatura', 854.0000, 'ºC'),
	(159512, 121, '2014-01-15 01:22:20.000000', 'temperatura', 374.0000, 'ºC'),
	(159513, 121, '2014-01-15 01:22:21.000000', 'temperatura', 510.0000, 'ºC'),
	(159514, 121, '2014-01-15 01:22:22.000000', 'temperatura', 227.0000, 'ºC'),
	(159515, 121, '2014-01-15 01:22:23.000000', 'temperatura', 807.0000, 'ºC'),
	(159516, 121, '2014-01-15 01:22:24.000000', 'temperatura', 952.0000, 'ºC'),
	(159517, 121, '2014-01-15 01:22:25.000000', 'temperatura', 1140.0000, 'ºC'),
	(159518, 121, '2014-01-15 01:22:26.000000', 'temperatura', 445.0000, 'ºC'),
	(159519, 121, '2014-01-15 01:22:27.000000', 'temperatura', 4.0000, 'ºC'),
	(159520, 121, '2014-01-15 01:22:28.000000', 'temperatura', 1089.0000, 'ºC'),
	(159521, 121, '2014-01-15 01:22:29.000000', 'temperatura', 630.0000, 'ºC'),
	(159522, 121, '2014-01-15 01:22:30.000000', 'temperatura', 1085.0000, 'ºC'),
	(159523, 121, '2014-01-15 01:22:31.000000', 'temperatura', 1136.0000, 'ºC'),
	(159524, 121, '2014-01-15 01:22:32.000000', 'temperatura', 24.0000, 'ºC'),
	(159525, 121, '2014-01-15 01:22:33.000000', 'temperatura', 311.0000, 'ºC'),
	(159526, 121, '2014-01-15 01:22:34.000000', 'temperatura', 287.0000, 'ºC'),
	(159527, 121, '2014-01-15 01:22:35.000000', 'temperatura', 501.0000, 'ºC'),
	(159528, 121, '2014-01-15 01:22:36.000000', 'temperatura', 446.0000, 'ºC'),
	(159529, 121, '2014-01-15 01:22:37.000000', 'temperatura', 725.0000, 'ºC'),
	(159530, 121, '2014-01-15 01:22:38.000000', 'temperatura', 1087.0000, 'ºC'),
	(159531, 121, '2014-01-15 01:22:39.000000', 'temperatura', 863.0000, 'ºC'),
	(159532, 121, '2014-01-15 01:22:40.000000', 'temperatura', 1055.0000, 'ºC'),
	(159533, 121, '2014-01-15 01:22:41.000000', 'temperatura', 284.0000, 'ºC'),
	(159534, 121, '2014-01-15 01:22:42.000000', 'temperatura', 658.0000, 'ºC'),
	(159535, 121, '2014-01-15 01:22:43.000000', 'temperatura', 36.0000, 'ºC'),
	(159536, 121, '2014-01-15 01:22:44.000000', 'temperatura', 607.0000, 'ºC'),
	(159537, 121, '2014-01-15 01:22:45.000000', 'temperatura', 527.0000, 'ºC'),
	(159538, 121, '2014-01-15 01:22:46.000000', 'temperatura', 815.0000, 'ºC'),
	(159539, 121, '2014-01-15 01:22:47.000000', 'temperatura', 95.0000, 'ºC'),
	(159540, 121, '2014-01-15 01:22:48.000000', 'temperatura', 428.0000, 'ºC'),
	(159541, 121, '2014-01-15 01:22:49.000000', 'temperatura', 658.0000, 'ºC'),
	(159542, 121, '2014-01-15 01:22:50.000000', 'temperatura', 805.0000, 'ºC'),
	(159543, 121, '2014-01-15 01:22:51.000000', 'temperatura', 853.0000, 'ºC'),
	(159544, 121, '2014-01-15 01:22:52.000000', 'temperatura', 650.0000, 'ºC'),
	(159545, 121, '2014-01-15 01:22:53.000000', 'temperatura', 690.0000, 'ºC'),
	(159546, 121, '2014-01-15 01:22:54.000000', 'temperatura', 300.0000, 'ºC'),
	(159547, 121, '2014-01-15 01:22:55.000000', 'temperatura', 630.0000, 'ºC'),
	(159548, 121, '2014-01-15 01:22:56.000000', 'temperatura', 1052.0000, 'ºC'),
	(159549, 121, '2014-01-15 01:22:57.000000', 'temperatura', 972.0000, 'ºC'),
	(159550, 121, '2014-01-15 01:22:58.000000', 'temperatura', 502.0000, 'ºC'),
	(159551, 121, '2014-01-15 01:22:59.000000', 'temperatura', 794.0000, 'ºC'),
	(159552, 121, '2014-01-15 01:23:00.000000', 'temperatura', 65.0000, 'ºC'),
	(159553, 121, '2014-01-15 01:23:01.000000', 'temperatura', 342.0000, 'ºC'),
	(159554, 121, '2014-01-15 01:23:02.000000', 'temperatura', 316.0000, 'ºC'),
	(159555, 121, '2014-01-15 01:23:03.000000', 'temperatura', 556.0000, 'ºC'),
	(159556, 121, '2014-01-15 01:23:04.000000', 'temperatura', 631.0000, 'ºC'),
	(159557, 121, '2014-01-15 01:23:05.000000', 'temperatura', 287.0000, 'ºC'),
	(159558, 121, '2014-01-15 01:23:06.000000', 'temperatura', 744.0000, 'ºC'),
	(159559, 121, '2014-01-15 01:23:07.000000', 'temperatura', 461.0000, 'ºC'),
	(159560, 121, '2014-01-15 01:23:08.000000', 'temperatura', 72.0000, 'ºC'),
	(159561, 121, '2014-01-15 01:23:09.000000', 'temperatura', 179.0000, 'ºC'),
	(159562, 121, '2014-01-15 01:23:10.000000', 'temperatura', 678.0000, 'ºC'),
	(159563, 121, '2014-01-15 01:23:11.000000', 'temperatura', 455.0000, 'ºC'),
	(159564, 121, '2014-01-15 01:23:12.000000', 'temperatura', 241.0000, 'ºC'),
	(159565, 121, '2014-01-15 01:23:13.000000', 'temperatura', 1039.0000, 'ºC'),
	(159566, 121, '2014-01-15 01:23:14.000000', 'temperatura', 872.0000, 'ºC'),
	(159567, 121, '2014-01-15 01:23:15.000000', 'temperatura', 43.0000, 'ºC'),
	(159568, 121, '2014-01-15 01:23:16.000000', 'temperatura', 1.0000, 'ºC'),
	(159569, 121, '2014-01-15 01:23:17.000000', 'temperatura', 1077.0000, 'ºC'),
	(159570, 121, '2014-01-15 01:23:18.000000', 'temperatura', 584.0000, 'ºC'),
	(159571, 121, '2014-01-15 01:23:19.000000', 'temperatura', 887.0000, 'ºC'),
	(159572, 121, '2014-01-15 01:23:20.000000', 'temperatura', 285.0000, 'ºC'),
	(159573, 121, '2014-01-15 01:23:21.000000', 'temperatura', 1164.0000, 'ºC'),
	(159574, 121, '2014-01-15 01:23:22.000000', 'temperatura', 165.0000, 'ºC'),
	(159575, 121, '2014-01-15 01:23:23.000000', 'temperatura', 933.0000, 'ºC'),
	(159576, 121, '2014-01-15 01:23:24.000000', 'temperatura', 571.0000, 'ºC'),
	(159577, 121, '2014-01-15 01:23:25.000000', 'temperatura', 56.0000, 'ºC'),
	(159578, 121, '2014-01-15 01:23:26.000000', 'temperatura', 970.0000, 'ºC'),
	(159579, 121, '2014-01-15 01:23:27.000000', 'temperatura', 1079.0000, 'ºC'),
	(159580, 121, '2014-01-15 01:23:28.000000', 'temperatura', 89.0000, 'ºC'),
	(159581, 121, '2014-01-15 01:23:29.000000', 'temperatura', 806.0000, 'ºC'),
	(159582, 121, '2014-01-15 01:23:30.000000', 'temperatura', 163.0000, 'ºC'),
	(159583, 121, '2014-01-15 01:23:31.000000', 'temperatura', 797.0000, 'ºC'),
	(159584, 121, '2014-01-15 01:23:32.000000', 'temperatura', 1096.0000, 'ºC'),
	(159585, 121, '2014-01-15 01:23:33.000000', 'temperatura', 690.0000, 'ºC'),
	(159586, 121, '2014-01-15 01:23:34.000000', 'temperatura', 164.0000, 'ºC'),
	(159587, 121, '2014-01-15 01:23:35.000000', 'temperatura', 1150.0000, 'ºC'),
	(159588, 121, '2014-01-15 01:23:36.000000', 'temperatura', 458.0000, 'ºC'),
	(159589, 121, '2014-01-15 01:23:37.000000', 'temperatura', 40.0000, 'ºC'),
	(159590, 121, '2014-01-15 01:23:38.000000', 'temperatura', 27.0000, 'ºC'),
	(159591, 121, '2014-01-15 01:23:39.000000', 'temperatura', 15.0000, 'ºC'),
	(159592, 121, '2014-01-15 01:23:40.000000', 'temperatura', 1195.0000, 'ºC'),
	(159593, 121, '2014-01-15 01:23:41.000000', 'temperatura', 1129.0000, 'ºC'),
	(159594, 121, '2014-01-15 01:23:42.000000', 'temperatura', 861.0000, 'ºC'),
	(159595, 121, '2014-01-15 01:23:43.000000', 'temperatura', 920.0000, 'ºC'),
	(159596, 121, '2014-01-15 01:23:44.000000', 'temperatura', 818.0000, 'ºC'),
	(159597, 121, '2014-01-15 01:23:45.000000', 'temperatura', 131.0000, 'ºC'),
	(159598, 121, '2014-01-15 01:23:46.000000', 'temperatura', 600.0000, 'ºC'),
	(159599, 121, '2014-01-15 01:23:47.000000', 'temperatura', 207.0000, 'ºC'),
	(159600, 121, '2014-01-15 01:23:48.000000', 'temperatura', 437.0000, 'ºC'),
	(159601, 121, '2014-01-15 01:23:49.000000', 'temperatura', 364.0000, 'ºC'),
	(159602, 121, '2014-01-15 01:23:50.000000', 'temperatura', 511.0000, 'ºC'),
	(159603, 121, '2014-01-15 01:23:51.000000', 'temperatura', 263.0000, 'ºC'),
	(159604, 121, '2014-01-15 01:23:52.000000', 'temperatura', 984.0000, 'ºC'),
	(159605, 121, '2014-01-15 01:23:53.000000', 'temperatura', 531.0000, 'ºC'),
	(159606, 121, '2014-01-15 01:23:54.000000', 'temperatura', 902.0000, 'ºC'),
	(159607, 121, '2014-01-15 01:23:55.000000', 'temperatura', 519.0000, 'ºC'),
	(159608, 121, '2014-01-15 01:23:56.000000', 'temperatura', 1087.0000, 'ºC'),
	(159609, 121, '2014-01-15 01:23:57.000000', 'temperatura', 280.0000, 'ºC'),
	(159610, 121, '2014-01-15 01:23:58.000000', 'temperatura', 537.0000, 'ºC'),
	(159611, 121, '2014-01-15 01:23:59.000000', 'temperatura', 649.0000, 'ºC'),
	(159612, 121, '2014-01-15 01:24:00.000000', 'temperatura', 433.0000, 'ºC'),
	(159613, 121, '2014-01-15 01:24:01.000000', 'temperatura', 218.0000, 'ºC'),
	(159614, 121, '2014-01-15 01:24:02.000000', 'temperatura', 990.0000, 'ºC'),
	(159615, 121, '2014-01-15 01:24:03.000000', 'temperatura', 698.0000, 'ºC'),
	(159616, 121, '2014-01-15 01:24:04.000000', 'temperatura', 519.0000, 'ºC'),
	(159617, 121, '2014-01-15 01:24:05.000000', 'temperatura', 501.0000, 'ºC'),
	(159618, 121, '2014-01-15 01:24:06.000000', 'temperatura', 949.0000, 'ºC'),
	(159619, 121, '2014-01-15 01:24:07.000000', 'temperatura', 842.0000, 'ºC'),
	(159620, 121, '2014-01-15 01:24:08.000000', 'temperatura', 166.0000, 'ºC'),
	(159621, 121, '2014-01-15 01:24:09.000000', 'temperatura', 702.0000, 'ºC'),
	(159622, 121, '2014-01-15 01:24:10.000000', 'temperatura', 613.0000, 'ºC'),
	(159623, 121, '2014-01-15 01:24:11.000000', 'temperatura', 961.0000, 'ºC'),
	(159624, 121, '2014-01-15 01:24:12.000000', 'temperatura', 564.0000, 'ºC'),
	(159625, 121, '2014-01-15 01:24:13.000000', 'temperatura', 1138.0000, 'ºC'),
	(159626, 121, '2014-01-15 01:24:14.000000', 'temperatura', 400.0000, 'ºC'),
	(159627, 121, '2014-01-15 01:24:15.000000', 'temperatura', 987.0000, 'ºC'),
	(159628, 121, '2014-01-15 01:24:16.000000', 'temperatura', 134.0000, 'ºC'),
	(159629, 121, '2014-01-15 01:24:17.000000', 'temperatura', 111.0000, 'ºC'),
	(159630, 121, '2014-01-15 01:24:18.000000', 'temperatura', 152.0000, 'ºC'),
	(159631, 121, '2014-01-15 01:24:19.000000', 'temperatura', 429.0000, 'ºC'),
	(159632, 121, '2014-01-15 01:24:20.000000', 'temperatura', 488.0000, 'ºC'),
	(159633, 121, '2014-01-15 01:24:21.000000', 'temperatura', 1153.0000, 'ºC'),
	(159634, 121, '2014-01-15 01:24:22.000000', 'temperatura', 701.0000, 'ºC'),
	(159635, 121, '2014-01-15 01:24:23.000000', 'temperatura', 48.0000, 'ºC'),
	(159636, 121, '2014-01-15 01:24:24.000000', 'temperatura', 537.0000, 'ºC'),
	(159637, 121, '2014-01-15 01:24:25.000000', 'temperatura', 142.0000, 'ºC'),
	(159638, 121, '2014-01-15 01:24:26.000000', 'temperatura', 300.0000, 'ºC'),
	(159639, 121, '2014-01-15 01:24:27.000000', 'temperatura', 1074.0000, 'ºC'),
	(159640, 121, '2014-01-15 01:24:28.000000', 'temperatura', 869.0000, 'ºC'),
	(159641, 121, '2014-01-15 01:24:29.000000', 'temperatura', 1126.0000, 'ºC'),
	(159642, 121, '2014-01-15 01:24:30.000000', 'temperatura', 621.0000, 'ºC'),
	(159643, 121, '2014-01-15 01:24:31.000000', 'temperatura', 927.0000, 'ºC'),
	(159644, 121, '2014-01-15 01:24:32.000000', 'temperatura', 375.0000, 'ºC'),
	(159645, 121, '2014-01-15 01:24:33.000000', 'temperatura', 294.0000, 'ºC'),
	(159646, 121, '2014-01-15 01:24:34.000000', 'temperatura', 347.0000, 'ºC'),
	(159647, 121, '2014-01-15 01:24:35.000000', 'temperatura', 852.0000, 'ºC'),
	(159648, 121, '2014-01-15 01:24:36.000000', 'temperatura', 820.0000, 'ºC'),
	(159649, 121, '2014-01-15 01:24:37.000000', 'temperatura', 343.0000, 'ºC'),
	(159650, 121, '2014-01-15 01:24:38.000000', 'temperatura', 455.0000, 'ºC'),
	(159651, 121, '2014-01-15 01:24:39.000000', 'temperatura', 46.0000, 'ºC'),
	(159652, 121, '2014-01-15 01:24:40.000000', 'temperatura', 68.0000, 'ºC'),
	(159653, 121, '2014-01-15 01:24:41.000000', 'temperatura', 200.0000, 'ºC'),
	(159654, 121, '2014-01-15 01:24:42.000000', 'temperatura', 796.0000, 'ºC'),
	(159655, 121, '2014-01-15 01:24:43.000000', 'temperatura', 982.0000, 'ºC'),
	(159656, 121, '2014-01-15 01:24:44.000000', 'temperatura', 121.0000, 'ºC'),
	(159657, 121, '2014-01-15 01:24:45.000000', 'temperatura', 62.0000, 'ºC'),
	(159658, 121, '2014-01-15 01:24:46.000000', 'temperatura', 1146.0000, 'ºC'),
	(159659, 121, '2014-01-15 01:24:47.000000', 'temperatura', 746.0000, 'ºC'),
	(159660, 121, '2014-01-15 01:24:48.000000', 'temperatura', 290.0000, 'ºC'),
	(159661, 121, '2014-01-15 01:24:49.000000', 'temperatura', 415.0000, 'ºC'),
	(159662, 121, '2014-01-15 01:24:50.000000', 'temperatura', 4.0000, 'ºC'),
	(159663, 121, '2014-01-15 01:24:51.000000', 'temperatura', 1178.0000, 'ºC'),
	(159664, 121, '2014-01-15 01:24:52.000000', 'temperatura', 1076.0000, 'ºC'),
	(159665, 121, '2014-01-15 01:24:53.000000', 'temperatura', 647.0000, 'ºC'),
	(159666, 121, '2014-01-15 01:24:54.000000', 'temperatura', 6.0000, 'ºC'),
	(159667, 121, '2014-01-15 01:24:55.000000', 'temperatura', 491.0000, 'ºC'),
	(159668, 121, '2014-01-15 01:24:56.000000', 'temperatura', 37.0000, 'ºC'),
	(159669, 121, '2014-01-15 01:24:57.000000', 'temperatura', 1114.0000, 'ºC'),
	(159670, 121, '2014-01-15 01:24:58.000000', 'temperatura', 656.0000, 'ºC'),
	(159671, 121, '2014-01-15 01:24:59.000000', 'temperatura', 1142.0000, 'ºC'),
	(159672, 121, '2014-01-15 01:25:00.000000', 'temperatura', 142.0000, 'ºC'),
	(159673, 121, '2014-01-15 01:25:01.000000', 'temperatura', 885.0000, 'ºC'),
	(159674, 121, '2014-01-15 01:25:02.000000', 'temperatura', 400.0000, 'ºC'),
	(159675, 121, '2014-01-15 01:25:03.000000', 'temperatura', 545.0000, 'ºC'),
	(159676, 121, '2014-01-15 01:25:04.000000', 'temperatura', 327.0000, 'ºC'),
	(159677, 121, '2014-01-15 01:25:05.000000', 'temperatura', 1.0000, 'ºC'),
	(159678, 121, '2014-01-15 01:25:06.000000', 'temperatura', 222.0000, 'ºC'),
	(159679, 121, '2014-01-15 01:25:07.000000', 'temperatura', 1107.0000, 'ºC'),
	(159680, 121, '2014-01-15 01:25:08.000000', 'temperatura', 68.0000, 'ºC'),
	(159681, 121, '2014-01-15 01:25:09.000000', 'temperatura', 623.0000, 'ºC'),
	(159682, 121, '2014-01-15 01:25:10.000000', 'temperatura', 510.0000, 'ºC'),
	(159683, 121, '2014-01-15 01:25:11.000000', 'temperatura', 681.0000, 'ºC'),
	(159684, 121, '2014-01-15 01:25:12.000000', 'temperatura', 675.0000, 'ºC'),
	(159685, 121, '2014-01-15 01:25:13.000000', 'temperatura', 132.0000, 'ºC'),
	(159686, 121, '2014-01-15 01:25:14.000000', 'temperatura', 1035.0000, 'ºC'),
	(159687, 121, '2014-01-15 01:25:15.000000', 'temperatura', 1179.0000, 'ºC'),
	(159688, 121, '2014-01-15 01:25:16.000000', 'temperatura', 390.0000, 'ºC'),
	(159689, 121, '2014-01-15 01:25:17.000000', 'temperatura', 816.0000, 'ºC'),
	(159690, 121, '2014-01-15 01:25:18.000000', 'temperatura', 507.0000, 'ºC'),
	(159691, 121, '2014-01-15 01:25:19.000000', 'temperatura', 91.0000, 'ºC'),
	(159692, 121, '2014-01-15 01:25:20.000000', 'temperatura', 134.0000, 'ºC'),
	(159693, 121, '2014-01-15 01:25:21.000000', 'temperatura', 397.0000, 'ºC'),
	(159694, 121, '2014-01-15 01:25:22.000000', 'temperatura', 384.0000, 'ºC'),
	(159695, 121, '2014-01-15 01:25:23.000000', 'temperatura', 728.0000, 'ºC'),
	(159696, 121, '2014-01-15 01:25:24.000000', 'temperatura', 88.0000, 'ºC'),
	(159697, 121, '2014-01-15 01:25:25.000000', 'temperatura', 658.0000, 'ºC'),
	(159698, 121, '2014-01-15 01:25:26.000000', 'temperatura', 625.0000, 'ºC'),
	(159699, 121, '2014-01-15 01:25:27.000000', 'temperatura', 1154.0000, 'ºC'),
	(159700, 121, '2014-01-15 01:25:28.000000', 'temperatura', 294.0000, 'ºC'),
	(159701, 121, '2014-01-15 01:25:29.000000', 'temperatura', 409.0000, 'ºC'),
	(159702, 121, '2014-01-15 01:25:30.000000', 'temperatura', 1163.0000, 'ºC'),
	(159703, 121, '2014-01-15 01:25:31.000000', 'temperatura', 991.0000, 'ºC'),
	(159704, 121, '2014-01-15 01:25:32.000000', 'temperatura', 263.0000, 'ºC'),
	(159705, 121, '2014-01-15 01:25:33.000000', 'temperatura', 745.0000, 'ºC'),
	(159706, 121, '2014-01-15 01:25:34.000000', 'temperatura', 537.0000, 'ºC'),
	(159707, 121, '2014-01-15 01:25:35.000000', 'temperatura', 448.0000, 'ºC'),
	(159708, 121, '2014-01-15 01:25:36.000000', 'temperatura', 629.0000, 'ºC'),
	(159709, 121, '2014-01-15 01:25:37.000000', 'temperatura', 604.0000, 'ºC'),
	(159710, 121, '2014-01-15 01:25:38.000000', 'temperatura', 1131.0000, 'ºC'),
	(159711, 121, '2014-01-15 01:25:39.000000', 'temperatura', 246.0000, 'ºC'),
	(159712, 121, '2014-01-15 01:25:40.000000', 'temperatura', 237.0000, 'ºC'),
	(159713, 121, '2014-01-15 01:25:41.000000', 'temperatura', 449.0000, 'ºC'),
	(159714, 121, '2014-01-15 01:25:42.000000', 'temperatura', 332.0000, 'ºC'),
	(159715, 121, '2014-01-15 01:25:43.000000', 'temperatura', 316.0000, 'ºC'),
	(159716, 121, '2014-01-15 01:25:44.000000', 'temperatura', 582.0000, 'ºC'),
	(159717, 121, '2014-01-15 01:25:45.000000', 'temperatura', 764.0000, 'ºC'),
	(159718, 121, '2014-01-15 01:25:46.000000', 'temperatura', 876.0000, 'ºC'),
	(159719, 121, '2014-01-15 01:25:47.000000', 'temperatura', 885.0000, 'ºC'),
	(159720, 121, '2014-01-15 01:25:48.000000', 'temperatura', 599.0000, 'ºC'),
	(159721, 121, '2014-01-15 01:25:49.000000', 'temperatura', 341.0000, 'ºC'),
	(159722, 121, '2014-01-15 01:25:50.000000', 'temperatura', 1110.0000, 'ºC'),
	(159723, 121, '2014-01-15 01:25:51.000000', 'temperatura', 926.0000, 'ºC'),
	(159724, 121, '2014-01-15 01:25:52.000000', 'temperatura', 102.0000, 'ºC'),
	(159725, 121, '2014-01-15 01:25:53.000000', 'temperatura', 131.0000, 'ºC'),
	(159726, 121, '2014-01-15 01:25:54.000000', 'temperatura', 351.0000, 'ºC'),
	(159727, 121, '2014-01-15 01:25:55.000000', 'temperatura', 161.0000, 'ºC'),
	(159728, 121, '2014-01-15 01:25:56.000000', 'temperatura', 954.0000, 'ºC'),
	(159729, 121, '2014-01-15 01:25:57.000000', 'temperatura', 689.0000, 'ºC'),
	(159730, 121, '2014-01-15 01:25:58.000000', 'temperatura', 581.0000, 'ºC'),
	(159731, 121, '2014-01-15 01:25:59.000000', 'temperatura', 841.0000, 'ºC'),
	(159732, 121, '2014-01-15 01:26:00.000000', 'temperatura', 62.0000, 'ºC'),
	(159733, 121, '2014-01-15 01:26:01.000000', 'temperatura', 186.0000, 'ºC'),
	(159734, 121, '2014-01-15 01:26:02.000000', 'temperatura', 747.0000, 'ºC'),
	(159735, 121, '2014-01-15 01:26:03.000000', 'temperatura', 775.0000, 'ºC'),
	(159736, 121, '2014-01-15 01:26:04.000000', 'temperatura', 433.0000, 'ºC'),
	(159737, 121, '2014-01-15 01:26:05.000000', 'temperatura', 1043.0000, 'ºC'),
	(159738, 121, '2014-01-15 01:26:06.000000', 'temperatura', 316.0000, 'ºC'),
	(159739, 121, '2014-01-15 01:26:07.000000', 'temperatura', 851.0000, 'ºC'),
	(159740, 121, '2014-01-15 01:26:08.000000', 'temperatura', 909.0000, 'ºC'),
	(159741, 121, '2014-01-15 01:26:09.000000', 'temperatura', 792.0000, 'ºC'),
	(159742, 121, '2014-01-15 01:26:10.000000', 'temperatura', 34.0000, 'ºC'),
	(159743, 121, '2014-01-15 01:26:11.000000', 'temperatura', 196.0000, 'ºC'),
	(159744, 121, '2014-01-15 01:26:12.000000', 'temperatura', 876.0000, 'ºC'),
	(159745, 121, '2014-01-15 01:26:13.000000', 'temperatura', 191.0000, 'ºC'),
	(159746, 121, '2014-01-15 01:26:14.000000', 'temperatura', 731.0000, 'ºC'),
	(159747, 121, '2014-01-15 01:26:15.000000', 'temperatura', 680.0000, 'ºC'),
	(159748, 121, '2014-01-15 01:26:16.000000', 'temperatura', 8.0000, 'ºC'),
	(159749, 121, '2014-01-15 01:26:17.000000', 'temperatura', 400.0000, 'ºC'),
	(159750, 121, '2014-01-15 01:26:18.000000', 'temperatura', 778.0000, 'ºC'),
	(159751, 121, '2014-01-15 01:26:19.000000', 'temperatura', 289.0000, 'ºC'),
	(159752, 121, '2014-01-15 01:26:20.000000', 'temperatura', 311.0000, 'ºC'),
	(159753, 121, '2014-01-15 01:26:21.000000', 'temperatura', 689.0000, 'ºC'),
	(159754, 121, '2014-01-15 01:26:22.000000', 'temperatura', 111.0000, 'ºC'),
	(159755, 121, '2014-01-15 01:26:23.000000', 'temperatura', 891.0000, 'ºC'),
	(159756, 121, '2014-01-15 01:26:24.000000', 'temperatura', 523.0000, 'ºC'),
	(159757, 121, '2014-01-15 01:26:25.000000', 'temperatura', 1139.0000, 'ºC'),
	(159758, 121, '2014-01-15 01:26:26.000000', 'temperatura', 530.0000, 'ºC'),
	(159759, 121, '2014-01-15 01:26:27.000000', 'temperatura', 433.0000, 'ºC'),
	(159760, 121, '2014-01-15 01:26:28.000000', 'temperatura', 574.0000, 'ºC'),
	(159761, 121, '2014-01-15 01:26:29.000000', 'temperatura', 372.0000, 'ºC'),
	(159762, 121, '2014-01-15 01:26:30.000000', 'temperatura', 140.0000, 'ºC'),
	(159763, 121, '2014-01-15 01:26:31.000000', 'temperatura', 782.0000, 'ºC'),
	(159764, 121, '2014-01-15 01:26:32.000000', 'temperatura', 1092.0000, 'ºC'),
	(159765, 121, '2014-01-15 01:26:33.000000', 'temperatura', 712.0000, 'ºC'),
	(159766, 121, '2014-01-15 01:26:34.000000', 'temperatura', 287.0000, 'ºC'),
	(159767, 121, '2014-01-15 01:26:35.000000', 'temperatura', 500.0000, 'ºC'),
	(159768, 121, '2014-01-15 01:26:36.000000', 'temperatura', 440.0000, 'ºC'),
	(159769, 121, '2014-01-15 01:26:37.000000', 'temperatura', 698.0000, 'ºC'),
	(159770, 121, '2014-01-15 01:26:38.000000', 'temperatura', 970.0000, 'ºC'),
	(159771, 121, '2014-01-15 01:26:39.000000', 'temperatura', 359.0000, 'ºC'),
	(159772, 121, '2014-01-15 01:26:40.000000', 'temperatura', 84.0000, 'ºC'),
	(159773, 121, '2014-01-15 01:26:41.000000', 'temperatura', 543.0000, 'ºC'),
	(159774, 121, '2014-01-15 01:26:42.000000', 'temperatura', 62.0000, 'ºC'),
	(159775, 121, '2014-01-15 01:26:43.000000', 'temperatura', 1084.0000, 'ºC'),
	(159776, 121, '2014-01-15 01:26:44.000000', 'temperatura', 435.0000, 'ºC'),
	(159777, 121, '2014-01-15 01:26:45.000000', 'temperatura', 122.0000, 'ºC'),
	(159778, 121, '2014-01-15 01:26:46.000000', 'temperatura', 508.0000, 'ºC'),
	(159779, 121, '2014-01-15 01:26:47.000000', 'temperatura', 973.0000, 'ºC'),
	(159780, 121, '2014-01-15 01:26:48.000000', 'temperatura', 942.0000, 'ºC'),
	(159781, 121, '2014-01-15 01:26:49.000000', 'temperatura', 591.0000, 'ºC'),
	(159782, 121, '2014-01-15 01:26:50.000000', 'temperatura', 130.0000, 'ºC'),
	(159783, 121, '2014-01-15 01:26:51.000000', 'temperatura', 76.0000, 'ºC'),
	(159784, 121, '2014-01-15 01:26:52.000000', 'temperatura', 1189.0000, 'ºC'),
	(159785, 121, '2014-01-15 01:26:53.000000', 'temperatura', 920.0000, 'ºC'),
	(159786, 121, '2014-01-15 01:26:54.000000', 'temperatura', 1033.0000, 'ºC'),
	(159787, 121, '2014-01-15 01:26:55.000000', 'temperatura', 7.0000, 'ºC'),
	(159788, 121, '2014-01-15 01:26:56.000000', 'temperatura', 534.0000, 'ºC'),
	(159789, 121, '2014-01-15 01:26:57.000000', 'temperatura', 249.0000, 'ºC'),
	(159790, 121, '2014-01-15 01:26:58.000000', 'temperatura', 844.0000, 'ºC'),
	(159791, 121, '2014-01-15 01:26:59.000000', 'temperatura', 1076.0000, 'ºC'),
	(159792, 121, '2014-01-15 01:27:00.000000', 'temperatura', 445.0000, 'ºC'),
	(159793, 121, '2014-01-15 01:27:01.000000', 'temperatura', 199.0000, 'ºC'),
	(159794, 121, '2014-01-15 01:27:02.000000', 'temperatura', 859.0000, 'ºC'),
	(159795, 121, '2014-01-15 01:27:03.000000', 'temperatura', 101.0000, 'ºC'),
	(159796, 121, '2014-01-15 01:27:04.000000', 'temperatura', 328.0000, 'ºC'),
	(159797, 121, '2014-01-15 01:27:05.000000', 'temperatura', 136.0000, 'ºC'),
	(159798, 121, '2014-01-15 01:27:06.000000', 'temperatura', 898.0000, 'ºC'),
	(159799, 121, '2014-01-15 01:27:07.000000', 'temperatura', 481.0000, 'ºC'),
	(159800, 121, '2014-01-15 01:27:08.000000', 'temperatura', 913.0000, 'ºC'),
	(159801, 121, '2014-01-15 01:27:09.000000', 'temperatura', 720.0000, 'ºC'),
	(159802, 121, '2014-01-15 01:27:10.000000', 'temperatura', 862.0000, 'ºC'),
	(159803, 121, '2014-01-15 01:27:11.000000', 'temperatura', 951.0000, 'ºC'),
	(159804, 121, '2014-01-15 01:27:12.000000', 'temperatura', 971.0000, 'ºC'),
	(159805, 121, '2014-01-15 01:27:13.000000', 'temperatura', 801.0000, 'ºC'),
	(159806, 121, '2014-01-15 01:27:14.000000', 'temperatura', 1093.0000, 'ºC'),
	(159807, 121, '2014-01-15 01:27:15.000000', 'temperatura', 664.0000, 'ºC'),
	(159808, 121, '2014-01-15 01:27:16.000000', 'temperatura', 40.0000, 'ºC'),
	(159809, 121, '2014-01-15 01:27:17.000000', 'temperatura', 608.0000, 'ºC'),
	(159810, 121, '2014-01-15 01:27:18.000000', 'temperatura', 522.0000, 'ºC'),
	(159811, 121, '2014-01-15 01:27:19.000000', 'temperatura', 784.0000, 'ºC'),
	(159812, 121, '2014-01-15 01:27:20.000000', 'temperatura', 1156.0000, 'ºC'),
	(159813, 121, '2014-01-15 01:27:21.000000', 'temperatura', 1029.0000, 'ºC'),
	(159814, 121, '2014-01-15 01:27:22.000000', 'temperatura', 477.0000, 'ºC'),
	(159815, 121, '2014-01-15 01:27:23.000000', 'temperatura', 498.0000, 'ºC'),
	(159816, 121, '2014-01-15 01:27:24.000000', 'temperatura', 1060.0000, 'ºC'),
	(159817, 121, '2014-01-15 01:27:25.000000', 'temperatura', 208.0000, 'ºC'),
	(159818, 121, '2014-01-15 01:27:26.000000', 'temperatura', 261.0000, 'ºC'),
	(159819, 121, '2014-01-15 01:27:27.000000', 'temperatura', 679.0000, 'ºC'),
	(159820, 121, '2014-01-15 01:27:28.000000', 'temperatura', 215.0000, 'ºC'),
	(159821, 121, '2014-01-15 01:27:29.000000', 'temperatura', 239.0000, 'ºC'),
	(159822, 121, '2014-01-15 01:27:30.000000', 'temperatura', 548.0000, 'ºC'),
	(159823, 121, '2014-01-15 01:27:31.000000', 'temperatura', 823.0000, 'ºC'),
	(159824, 121, '2014-01-15 01:27:32.000000', 'temperatura', 72.0000, 'ºC'),
	(159825, 121, '2014-01-15 01:27:33.000000', 'temperatura', 294.0000, 'ºC'),
	(159826, 121, '2014-01-15 01:27:34.000000', 'temperatura', 52.0000, 'ºC'),
	(159827, 121, '2014-01-15 01:27:35.000000', 'temperatura', 577.0000, 'ºC'),
	(159828, 121, '2014-01-15 01:27:36.000000', 'temperatura', 333.0000, 'ºC'),
	(159829, 121, '2014-01-15 01:27:37.000000', 'temperatura', 1134.0000, 'ºC'),
	(159830, 121, '2014-01-15 01:27:38.000000', 'temperatura', 1070.0000, 'ºC'),
	(159831, 121, '2014-01-15 01:27:39.000000', 'temperatura', 749.0000, 'ºC'),
	(159832, 121, '2014-01-15 01:27:40.000000', 'temperatura', 537.0000, 'ºC'),
	(159833, 121, '2014-01-15 01:27:41.000000', 'temperatura', 439.0000, 'ºC'),
	(159834, 121, '2014-01-15 01:27:42.000000', 'temperatura', 581.0000, 'ºC'),
	(159835, 121, '2014-01-15 01:27:43.000000', 'temperatura', 392.0000, 'ºC'),
	(159836, 121, '2014-01-15 01:27:44.000000', 'temperatura', 216.0000, 'ºC'),
	(159837, 121, '2014-01-15 01:27:45.000000', 'temperatura', 1103.0000, 'ºC'),
	(159838, 121, '2014-01-15 01:27:46.000000', 'temperatura', 70.0000, 'ºC'),
	(159839, 121, '2014-01-15 01:27:47.000000', 'temperatura', 639.0000, 'ºC'),
	(159840, 121, '2014-01-15 01:27:48.000000', 'temperatura', 588.0000, 'ºC'),
	(159841, 121, '2014-01-15 01:27:49.000000', 'temperatura', 1023.0000, 'ºC'),
	(159842, 121, '2014-01-15 01:27:50.000000', 'temperatura', 951.0000, 'ºC'),
	(159843, 121, '2014-01-15 01:27:51.000000', 'temperatura', 488.0000, 'ºC'),
	(159844, 121, '2014-01-15 01:27:52.000000', 'temperatura', 788.0000, 'ºC'),
	(159845, 121, '2014-01-15 01:27:53.000000', 'temperatura', 74.0000, 'ºC'),
	(159846, 121, '2014-01-15 01:27:54.000000', 'temperatura', 410.0000, 'ºC'),
	(159847, 121, '2014-01-15 01:27:55.000000', 'temperatura', 625.0000, 'ºC'),
	(159848, 121, '2014-01-15 01:27:56.000000', 'temperatura', 696.0000, 'ºC'),
	(159849, 121, '2014-01-15 01:27:57.000000', 'temperatura', 407.0000, 'ºC'),
	(159850, 121, '2014-01-15 01:27:58.000000', 'temperatura', 1148.0000, 'ºC'),
	(159851, 121, '2014-01-15 01:27:59.000000', 'temperatura', 919.0000, 'ºC'),
	(159852, 121, '2014-01-15 01:28:00.000000', 'temperatura', 1153.0000, 'ºC'),
	(159853, 121, '2014-01-15 01:28:01.000000', 'temperatura', 605.0000, 'ºC'),
	(159854, 121, '2014-01-15 01:28:02.000000', 'temperatura', 769.0000, 'ºC'),
	(159855, 121, '2014-01-15 01:28:03.000000', 'temperatura', 832.0000, 'ºC'),
	(159856, 121, '2014-01-15 01:28:04.000000', 'temperatura', 651.0000, 'ºC'),
	(159857, 121, '2014-01-15 01:28:05.000000', 'temperatura', 759.0000, 'ºC'),
	(159858, 121, '2014-01-15 01:28:06.000000', 'temperatura', 644.0000, 'ºC'),
	(159859, 121, '2014-01-15 01:28:07.000000', 'temperatura', 942.0000, 'ºC'),
	(159860, 121, '2014-01-15 01:28:08.000000', 'temperatura', 377.0000, 'ºC'),
	(159861, 121, '2014-01-15 01:28:09.000000', 'temperatura', 262.0000, 'ºC'),
	(159862, 121, '2014-01-15 01:28:10.000000', 'temperatura', 181.0000, 'ºC'),
	(159863, 121, '2014-01-15 01:28:11.000000', 'temperatura', 117.0000, 'ºC'),
	(159864, 121, '2014-01-15 01:28:12.000000', 'temperatura', 44.0000, 'ºC'),
	(159865, 121, '2014-01-15 01:28:13.000000', 'temperatura', 1071.0000, 'ºC'),
	(159866, 121, '2014-01-15 01:28:14.000000', 'temperatura', 421.0000, 'ºC'),
	(159867, 121, '2014-01-15 01:28:15.000000', 'temperatura', 94.0000, 'ºC'),
	(159868, 121, '2014-01-15 01:28:16.000000', 'temperatura', 406.0000, 'ºC'),
	(159869, 121, '2014-01-15 01:28:17.000000', 'temperatura', 550.0000, 'ºC'),
	(159870, 121, '2014-01-15 01:28:18.000000', 'temperatura', 331.0000, 'ºC'),
	(159871, 121, '2014-01-15 01:28:19.000000', 'temperatura', 8.0000, 'ºC'),
	(159872, 121, '2014-01-15 01:28:20.000000', 'temperatura', 247.0000, 'ºC'),
	(159873, 121, '2014-01-15 01:28:21.000000', 'temperatura', 11.0000, 'ºC'),
	(159874, 121, '2014-01-15 01:28:22.000000', 'temperatura', 516.0000, 'ºC'),
	(159875, 121, '2014-01-15 01:28:23.000000', 'temperatura', 148.0000, 'ºC'),
	(159876, 121, '2014-01-15 01:28:24.000000', 'temperatura', 393.0000, 'ºC'),
	(159877, 121, '2014-01-15 01:28:25.000000', 'temperatura', 320.0000, 'ºC'),
	(159878, 121, '2014-01-15 01:28:26.000000', 'temperatura', 422.0000, 'ºC'),
	(159879, 121, '2014-01-15 01:28:27.000000', 'temperatura', 1149.0000, 'ºC'),
	(159880, 121, '2014-01-15 01:28:28.000000', 'temperatura', 880.0000, 'ºC'),
	(159881, 121, '2014-01-15 01:28:29.000000', 'temperatura', 955.0000, 'ºC'),
	(159882, 121, '2014-01-15 01:28:30.000000', 'temperatura', 933.0000, 'ºC'),
	(159883, 121, '2014-01-15 01:28:31.000000', 'temperatura', 603.0000, 'ºC'),
	(159884, 121, '2014-01-15 01:28:32.000000', 'temperatura', 217.0000, 'ºC'),
	(159885, 121, '2014-01-15 01:28:33.000000', 'temperatura', 475.0000, 'ºC'),
	(159886, 121, '2014-01-15 01:28:34.000000', 'temperatura', 523.0000, 'ºC'),
	(159887, 121, '2014-01-15 01:28:35.000000', 'temperatura', 1191.0000, 'ºC'),
	(159888, 121, '2014-01-15 01:28:36.000000', 'temperatura', 785.0000, 'ºC'),
	(159889, 121, '2014-01-15 01:28:37.000000', 'temperatura', 354.0000, 'ºC'),
	(159890, 121, '2014-01-15 01:28:38.000000', 'temperatura', 617.0000, 'ºC'),
	(159891, 121, '2014-01-15 01:28:39.000000', 'temperatura', 824.0000, 'ºC'),
	(159892, 121, '2014-01-15 01:28:40.000000', 'temperatura', 1068.0000, 'ºC'),
	(159893, 121, '2014-01-15 01:28:41.000000', 'temperatura', 469.0000, 'ºC'),
	(159894, 121, '2014-01-15 01:28:42.000000', 'temperatura', 342.0000, 'ºC'),
	(159895, 121, '2014-01-15 01:28:43.000000', 'temperatura', 305.0000, 'ºC'),
	(159896, 121, '2014-01-15 01:28:44.000000', 'temperatura', 499.0000, 'ºC'),
	(159897, 121, '2014-01-15 01:28:45.000000', 'temperatura', 379.0000, 'ºC'),
	(159898, 121, '2014-01-15 01:28:46.000000', 'temperatura', 398.0000, 'ºC'),
	(159899, 121, '2014-01-15 01:28:47.000000', 'temperatura', 853.0000, 'ºC'),
	(159900, 121, '2014-01-15 01:28:48.000000', 'temperatura', 674.0000, 'ºC'),
	(159901, 121, '2014-01-15 01:28:49.000000', 'temperatura', 811.0000, 'ºC'),
	(159902, 121, '2014-01-15 01:28:50.000000', 'temperatura', 833.0000, 'ºC'),
	(159903, 121, '2014-01-15 01:28:51.000000', 'temperatura', 534.0000, 'ºC'),
	(159904, 121, '2014-01-15 01:28:52.000000', 'temperatura', 169.0000, 'ºC'),
	(159905, 121, '2014-01-15 01:28:53.000000', 'temperatura', 444.0000, 'ºC'),
	(159906, 121, '2014-01-15 01:28:54.000000', 'temperatura', 514.0000, 'ºC'),
	(159907, 121, '2014-01-15 01:28:55.000000', 'temperatura', 38.0000, 'ºC'),
	(159908, 121, '2014-01-15 01:28:56.000000', 'temperatura', 1048.0000, 'ºC'),
	(159909, 121, '2014-01-15 01:28:57.000000', 'temperatura', 325.0000, 'ºC'),
	(159910, 121, '2014-01-15 01:28:58.000000', 'temperatura', 884.0000, 'ºC'),
	(159911, 121, '2014-01-15 01:28:59.000000', 'temperatura', 1047.0000, 'ºC'),
	(159912, 121, '2014-01-15 01:29:00.000000', 'temperatura', 180.0000, 'ºC'),
	(159913, 121, '2014-01-15 01:29:01.000000', 'temperatura', 160.0000, 'ºC'),
	(159914, 121, '2014-01-15 01:29:02.000000', 'temperatura', 262.0000, 'ºC'),
	(159915, 121, '2014-01-15 01:29:03.000000', 'temperatura', 832.0000, 'ºC'),
	(159916, 121, '2014-01-15 01:29:04.000000', 'temperatura', 972.0000, 'ºC'),
	(159917, 121, '2014-01-15 01:29:05.000000', 'temperatura', 1164.0000, 'ºC'),
	(159918, 121, '2014-01-15 01:29:06.000000', 'temperatura', 505.0000, 'ºC'),
	(159919, 121, '2014-01-15 01:29:07.000000', 'temperatura', 232.0000, 'ºC'),
	(159920, 121, '2014-01-15 01:29:08.000000', 'temperatura', 845.0000, 'ºC'),
	(159921, 121, '2014-01-15 01:29:09.000000', 'temperatura', 1133.0000, 'ºC'),
	(159922, 121, '2014-01-15 01:29:10.000000', 'temperatura', 727.0000, 'ºC'),
	(159923, 121, '2014-01-15 01:29:11.000000', 'temperatura', 238.0000, 'ºC'),
	(159924, 121, '2014-01-15 01:29:12.000000', 'temperatura', 211.0000, 'ºC'),
	(159925, 121, '2014-01-15 01:29:13.000000', 'temperatura', 341.0000, 'ºC'),
	(159926, 121, '2014-01-15 01:29:14.000000', 'temperatura', 1070.0000, 'ºC'),
	(159927, 121, '2014-01-15 01:29:15.000000', 'temperatura', 729.0000, 'ºC'),
	(159928, 121, '2014-01-15 01:29:16.000000', 'temperatura', 437.0000, 'ºC'),
	(159929, 121, '2014-01-15 01:29:17.000000', 'temperatura', 1198.0000, 'ºC'),
	(159930, 121, '2014-01-15 01:29:18.000000', 'temperatura', 1081.0000, 'ºC'),
	(159931, 121, '2014-01-15 01:29:19.000000', 'temperatura', 611.0000, 'ºC'),
	(159932, 121, '2014-01-15 01:29:20.000000', 'temperatura', 1012.0000, 'ºC'),
	(159933, 121, '2014-01-15 01:29:21.000000', 'temperatura', 828.0000, 'ºC'),
	(159934, 121, '2014-01-15 01:29:22.000000', 'temperatura', 1103.0000, 'ºC'),
	(159935, 121, '2014-01-15 01:29:23.000000', 'temperatura', 634.0000, 'ºC'),
	(159936, 121, '2014-01-15 01:29:24.000000', 'temperatura', 1062.0000, 'ºC'),
	(159937, 121, '2014-01-15 01:29:25.000000', 'temperatura', 1007.0000, 'ºC'),
	(159938, 121, '2014-01-15 01:29:26.000000', 'temperatura', 650.0000, 'ºC'),
	(159939, 121, '2014-01-15 01:29:27.000000', 'temperatura', 229.0000, 'ºC'),
	(159940, 121, '2014-01-15 01:29:28.000000', 'temperatura', 394.0000, 'ºC'),
	(159941, 121, '2014-01-15 01:29:29.000000', 'temperatura', 87.0000, 'ºC'),
	(159942, 121, '2014-01-15 01:29:30.000000', 'temperatura', 451.0000, 'ºC'),
	(159943, 121, '2014-01-15 01:29:31.000000', 'temperatura', 794.0000, 'ºC'),
	(159944, 121, '2014-01-15 01:29:32.000000', 'temperatura', 218.0000, 'ºC'),
	(159945, 121, '2014-01-15 01:29:33.000000', 'temperatura', 1107.0000, 'ºC'),
	(159946, 121, '2014-01-15 01:29:34.000000', 'temperatura', 82.0000, 'ºC'),
	(159947, 121, '2014-01-15 01:29:35.000000', 'temperatura', 689.0000, 'ºC'),
	(159948, 121, '2014-01-15 01:29:36.000000', 'temperatura', 800.0000, 'ºC'),
	(159949, 121, '2014-01-15 01:29:37.000000', 'temperatura', 736.0000, 'ºC'),
	(159950, 121, '2014-01-15 01:29:38.000000', 'temperatura', 77.0000, 'ºC'),
	(159951, 121, '2014-01-15 01:29:39.000000', 'temperatura', 581.0000, 'ºC'),
	(159952, 121, '2014-01-15 01:29:40.000000', 'temperatura', 271.0000, 'ºC'),
	(159953, 121, '2014-01-15 01:29:41.000000', 'temperatura', 813.0000, 'ºC'),
	(159954, 121, '2014-01-15 01:29:42.000000', 'temperatura', 853.0000, 'ºC'),
	(159955, 121, '2014-01-15 01:29:43.000000', 'temperatura', 628.0000, 'ºC'),
	(159956, 121, '2014-01-15 01:29:44.000000', 'temperatura', 580.0000, 'ºC'),
	(159957, 121, '2014-01-15 01:29:45.000000', 'temperatura', 1015.0000, 'ºC'),
	(159958, 121, '2014-01-15 01:29:46.000000', 'temperatura', 936.0000, 'ºC'),
	(159959, 121, '2014-01-15 01:29:47.000000', 'temperatura', 436.0000, 'ºC'),
	(159960, 121, '2014-01-15 01:29:48.000000', 'temperatura', 572.0000, 'ºC'),
	(159961, 121, '2014-01-15 01:29:49.000000', 'temperatura', 351.0000, 'ºC'),
	(159962, 121, '2014-01-15 01:29:50.000000', 'temperatura', 42.0000, 'ºC'),
	(159963, 121, '2014-01-15 01:29:51.000000', 'temperatura', 357.0000, 'ºC'),
	(159964, 121, '2014-01-15 01:29:52.000000', 'temperatura', 458.0000, 'ºC'),
	(159965, 121, '2014-01-15 01:29:53.000000', 'temperatura', 18.0000, 'ºC'),
	(159966, 121, '2014-01-15 01:29:54.000000', 'temperatura', 1120.0000, 'ºC'),
	(159967, 121, '2014-01-15 01:29:55.000000', 'temperatura', 745.0000, 'ºC'),
	(159968, 121, '2014-01-15 01:29:56.000000', 'temperatura', 364.0000, 'ºC'),
	(159969, 121, '2014-01-15 01:29:57.000000', 'temperatura', 788.0000, 'ºC'),
	(159970, 121, '2014-01-15 01:29:58.000000', 'temperatura', 449.0000, 'ºC'),
	(159971, 121, '2014-01-15 01:29:59.000000', 'temperatura', 1082.0000, 'ºC'),
	(159972, 121, '2014-01-15 01:30:00.000000', 'temperatura', 462.0000, 'ºC'),
	(159973, 121, '2014-01-15 01:30:01.000000', 'temperatura', 266.0000, 'ºC'),
	(159974, 121, '2014-01-15 01:30:02.000000', 'temperatura', 1145.0000, 'ºC'),
	(159975, 121, '2014-01-15 01:30:03.000000', 'temperatura', 127.0000, 'ºC'),
	(159976, 121, '2014-01-15 01:30:04.000000', 'temperatura', 802.0000, 'ºC'),
	(159977, 121, '2014-01-15 01:30:05.000000', 'temperatura', 29.0000, 'ºC'),
	(159978, 121, '2014-01-15 01:30:06.000000', 'temperatura', 139.0000, 'ºC'),
	(159979, 121, '2014-01-15 01:30:07.000000', 'temperatura', 608.0000, 'ºC'),
	(159980, 121, '2014-01-15 01:30:08.000000', 'temperatura', 223.0000, 'ºC'),
	(159981, 121, '2014-01-15 01:30:09.000000', 'temperatura', 494.0000, 'ºC'),
	(159982, 121, '2014-01-15 01:30:10.000000', 'temperatura', 598.0000, 'ºC'),
	(159983, 121, '2014-01-15 01:30:11.000000', 'temperatura', 310.0000, 'ºC'),
	(159984, 121, '2014-01-15 01:30:12.000000', 'temperatura', 958.0000, 'ºC'),
	(159985, 121, '2014-01-15 01:30:13.000000', 'temperatura', 262.0000, 'ºC'),
	(159986, 121, '2014-01-15 01:30:14.000000', 'temperatura', 833.0000, 'ºC'),
	(159987, 121, '2014-01-15 01:30:15.000000', 'temperatura', 980.0000, 'ºC'),
	(159988, 121, '2014-01-15 01:30:16.000000', 'temperatura', 1.0000, 'ºC'),
	(159989, 121, '2014-01-15 01:30:17.000000', 'temperatura', 667.0000, 'ºC'),
	(159990, 121, '2014-01-15 01:30:18.000000', 'temperatura', 930.0000, 'ºC'),
	(159991, 121, '2014-01-15 01:30:19.000000', 'temperatura', 252.0000, 'ºC'),
	(159992, 121, '2014-01-15 01:30:20.000000', 'temperatura', 871.0000, 'ºC'),
	(159993, 121, '2014-01-15 01:30:21.000000', 'temperatura', 1197.0000, 'ºC'),
	(159994, 121, '2014-01-15 01:30:22.000000', 'temperatura', 974.0000, 'ºC'),
	(159995, 121, '2014-01-15 01:30:23.000000', 'temperatura', 77.0000, 'ºC'),
	(159996, 121, '2014-01-15 01:30:24.000000', 'temperatura', 1067.0000, 'ºC'),
	(159997, 121, '2014-01-15 01:30:25.000000', 'temperatura', 301.0000, 'ºC'),
	(159998, 121, '2014-01-15 01:30:26.000000', 'temperatura', 708.0000, 'ºC'),
	(159999, 121, '2014-01-15 01:30:27.000000', 'temperatura', 234.0000, 'ºC'),
	(160000, 121, '2014-01-15 01:30:28.000000', 'temperatura', 249.0000, 'ºC'),
	(160001, 121, '2014-01-15 01:30:29.000000', 'temperatura', 542.0000, 'ºC'),
	(160002, 121, '2014-01-15 01:30:30.000000', 'temperatura', 766.0000, 'ºC'),
	(160003, 121, '2014-01-15 01:30:31.000000', 'temperatura', 1003.0000, 'ºC'),
	(160004, 121, '2014-01-15 01:30:32.000000', 'temperatura', 318.0000, 'ºC'),
	(160005, 121, '2014-01-15 01:30:33.000000', 'temperatura', 983.0000, 'ºC'),
	(160006, 121, '2014-01-15 01:30:34.000000', 'temperatura', 362.0000, 'ºC'),
	(160007, 121, '2014-01-15 01:30:35.000000', 'temperatura', 59.0000, 'ºC'),
	(160008, 121, '2014-01-15 01:30:36.000000', 'temperatura', 409.0000, 'ºC'),
	(160009, 121, '2014-01-15 01:30:37.000000', 'temperatura', 669.0000, 'ºC'),
	(160010, 121, '2014-01-15 01:30:38.000000', 'temperatura', 920.0000, 'ºC'),
	(160011, 121, '2014-01-15 01:30:39.000000', 'temperatura', 191.0000, 'ºC'),
	(160012, 121, '2014-01-15 01:30:40.000000', 'temperatura', 595.0000, 'ºC'),
	(160013, 121, '2014-01-15 01:30:41.000000', 'temperatura', 5.0000, 'ºC'),
	(160014, 121, '2014-01-15 01:30:42.000000', 'temperatura', 639.0000, 'ºC'),
	(160015, 121, '2014-01-15 01:30:43.000000', 'temperatura', 780.0000, 'ºC'),
	(160016, 121, '2014-01-15 01:30:44.000000', 'temperatura', 782.0000, 'ºC'),
	(160017, 121, '2014-01-15 01:30:45.000000', 'temperatura', 374.0000, 'ºC'),
	(160018, 121, '2014-01-15 01:30:46.000000', 'temperatura', 721.0000, 'ºC'),
	(160019, 121, '2014-01-15 01:30:47.000000', 'temperatura', 85.0000, 'ºC'),
	(160020, 121, '2014-01-15 01:30:48.000000', 'temperatura', 664.0000, 'ºC'),
	(160021, 121, '2014-01-15 01:30:49.000000', 'temperatura', 666.0000, 'ºC'),
	(160022, 121, '2014-01-15 01:30:50.000000', 'temperatura', 139.0000, 'ºC'),
	(160023, 121, '2014-01-15 01:30:51.000000', 'temperatura', 1098.0000, 'ºC'),
	(160024, 121, '2014-01-15 01:30:52.000000', 'temperatura', 273.0000, 'ºC'),
	(160025, 121, '2014-01-15 01:30:53.000000', 'temperatura', 471.0000, 'ºC'),
	(160026, 121, '2014-01-15 01:30:54.000000', 'temperatura', 337.0000, 'ºC'),
	(160027, 121, '2014-01-15 01:30:55.000000', 'temperatura', 273.0000, 'ºC'),
	(160028, 121, '2014-01-15 01:30:56.000000', 'temperatura', 354.0000, 'ºC'),
	(160029, 121, '2014-01-15 01:30:57.000000', 'temperatura', 950.0000, 'ºC'),
	(160030, 121, '2014-01-15 01:30:58.000000', 'temperatura', 91.0000, 'ºC'),
	(160031, 121, '2014-01-15 01:30:59.000000', 'temperatura', 6.0000, 'ºC'),
	(160032, 121, '2014-01-15 01:31:00.000000', 'temperatura', 955.0000, 'ºC'),
	(160033, 121, '2014-01-15 01:31:01.000000', 'temperatura', 1160.0000, 'ºC'),
	(160034, 121, '2014-01-15 01:31:02.000000', 'temperatura', 536.0000, 'ºC'),
	(160035, 121, '2014-01-15 01:31:03.000000', 'temperatura', 400.0000, 'ºC'),
	(160036, 121, '2014-01-15 01:31:04.000000', 'temperatura', 394.0000, 'ºC'),
	(160037, 121, '2014-01-15 01:31:05.000000', 'temperatura', 769.0000, 'ºC'),
	(160038, 121, '2014-01-15 01:31:06.000000', 'temperatura', 265.0000, 'ºC'),
	(160039, 121, '2014-01-15 01:31:07.000000', 'temperatura', 216.0000, 'ºC'),
	(160040, 121, '2014-01-15 01:31:08.000000', 'temperatura', 286.0000, 'ºC'),
	(160041, 121, '2014-01-15 01:31:09.000000', 'temperatura', 782.0000, 'ºC'),
	(160042, 121, '2014-01-15 01:31:10.000000', 'temperatura', 653.0000, 'ºC'),
	(160043, 121, '2014-01-15 01:31:11.000000', 'temperatura', 919.0000, 'ºC'),
	(160044, 121, '2014-01-15 01:31:12.000000', 'temperatura', 238.0000, 'ºC'),
	(160045, 121, '2014-01-15 01:31:13.000000', 'temperatura', 834.0000, 'ºC'),
	(160046, 121, '2014-01-15 01:31:14.000000', 'temperatura', 1057.0000, 'ºC'),
	(160047, 121, '2014-01-15 01:31:15.000000', 'temperatura', 383.0000, 'ºC'),
	(160048, 121, '2014-01-15 01:31:16.000000', 'temperatura', 1143.0000, 'ºC'),
	(160049, 121, '2014-01-15 01:31:17.000000', 'temperatura', 969.0000, 'ºC'),
	(160050, 121, '2014-01-15 01:31:18.000000', 'temperatura', 214.0000, 'ºC'),
	(160051, 121, '2014-01-15 01:31:19.000000', 'temperatura', 566.0000, 'ºC'),
	(160052, 121, '2014-01-15 01:31:20.000000', 'temperatura', 985.0000, 'ºC'),
	(160053, 121, '2014-01-15 01:31:21.000000', 'temperatura', 831.0000, 'ºC'),
	(160054, 121, '2014-01-15 01:31:22.000000', 'temperatura', 1198.0000, 'ºC'),
	(160055, 121, '2014-01-15 01:31:23.000000', 'temperatura', 1097.0000, 'ºC'),
	(160056, 121, '2014-01-15 01:31:24.000000', 'temperatura', 693.0000, 'ºC'),
	(160057, 121, '2014-01-15 01:31:25.000000', 'temperatura', 172.0000, 'ºC'),
	(160058, 121, '2014-01-15 01:31:26.000000', 'temperatura', 1184.0000, 'ºC'),
	(160059, 121, '2014-01-15 01:31:27.000000', 'temperatura', 604.0000, 'ºC'),
	(160060, 121, '2014-01-15 01:31:28.000000', 'temperatura', 670.0000, 'ºC'),
	(160061, 121, '2014-01-15 01:31:29.000000', 'temperatura', 336.0000, 'ºC'),
	(160062, 121, '2014-01-15 01:31:30.000000', 'temperatura', 871.0000, 'ºC'),
	(160063, 121, '2014-01-15 01:31:31.000000', 'temperatura', 949.0000, 'ºC'),
	(160064, 121, '2014-01-15 01:31:32.000000', 'temperatura', 933.0000, 'ºC'),
	(160065, 121, '2014-01-15 01:31:33.000000', 'temperatura', 617.0000, 'ºC'),
	(160066, 121, '2014-01-15 01:31:34.000000', 'temperatura', 285.0000, 'ºC'),
	(160067, 121, '2014-01-15 01:31:35.000000', 'temperatura', 777.0000, 'ºC'),
	(160068, 121, '2014-01-15 01:31:36.000000', 'temperatura', 632.0000, 'ºC'),
	(160069, 121, '2014-01-15 01:31:37.000000', 'temperatura', 827.0000, 'ºC'),
	(160070, 121, '2014-01-15 01:31:38.000000', 'temperatura', 1041.0000, 'ºC'),
	(160071, 121, '2014-01-15 01:31:39.000000', 'temperatura', 322.0000, 'ºC'),
	(160072, 121, '2014-01-15 01:31:40.000000', 'temperatura', 889.0000, 'ºC'),
	(160073, 121, '2014-01-15 01:31:41.000000', 'temperatura', 1080.0000, 'ºC'),
	(160074, 121, '2014-01-15 01:31:42.000000', 'temperatura', 332.0000, 'ºC'),
	(160075, 121, '2014-01-15 01:31:43.000000', 'temperatura', 819.0000, 'ºC'),
	(160076, 121, '2014-01-15 01:31:44.000000', 'temperatura', 703.0000, 'ºC'),
	(160077, 121, '2014-01-15 01:31:45.000000', 'temperatura', 1056.0000, 'ºC'),
	(160078, 121, '2014-01-15 01:31:46.000000', 'temperatura', 774.0000, 'ºC'),
	(160079, 121, '2014-01-15 01:31:47.000000', 'temperatura', 703.0000, 'ºC'),
	(160080, 121, '2014-01-15 01:31:48.000000', 'temperatura', 1191.0000, 'ºC'),
	(160081, 121, '2014-01-15 01:31:49.000000', 'temperatura', 247.0000, 'ºC'),
	(160082, 121, '2014-01-15 01:31:50.000000', 'temperatura', 65.0000, 'ºC'),
	(160083, 121, '2014-01-15 01:31:51.000000', 'temperatura', 782.0000, 'ºC'),
	(160084, 121, '2014-01-15 01:31:52.000000', 'temperatura', 115.0000, 'ºC'),
	(160085, 121, '2014-01-15 01:31:53.000000', 'temperatura', 630.0000, 'ºC'),
	(160086, 121, '2014-01-15 01:31:54.000000', 'temperatura', 404.0000, 'ºC'),
	(160087, 121, '2014-01-15 01:31:55.000000', 'temperatura', 133.0000, 'ºC'),
	(160088, 121, '2014-01-15 01:31:56.000000', 'temperatura', 653.0000, 'ºC'),
	(160089, 121, '2014-01-15 01:31:57.000000', 'temperatura', 466.0000, 'ºC'),
	(160090, 121, '2014-01-15 01:31:58.000000', 'temperatura', 372.0000, 'ºC'),
	(160091, 121, '2014-01-15 01:31:59.000000', 'temperatura', 460.0000, 'ºC'),
	(160092, 121, '2014-01-15 01:32:00.000000', 'temperatura', 1188.0000, 'ºC'),
	(160093, 121, '2014-01-15 01:32:01.000000', 'temperatura', 959.0000, 'ºC'),
	(160094, 121, '2014-01-15 01:32:02.000000', 'temperatura', 30.0000, 'ºC'),
	(160095, 121, '2014-01-15 01:32:03.000000', 'temperatura', 876.0000, 'ºC'),
	(160096, 121, '2014-01-15 01:32:04.000000', 'temperatura', 690.0000, 'ºC'),
	(160097, 121, '2014-01-15 01:32:05.000000', 'temperatura', 822.0000, 'ºC'),
	(160098, 121, '2014-01-15 01:32:06.000000', 'temperatura', 840.0000, 'ºC'),
	(160099, 121, '2014-01-15 01:32:07.000000', 'temperatura', 534.0000, 'ºC'),
	(160100, 121, '2014-01-15 01:32:08.000000', 'temperatura', 153.0000, 'ºC'),
	(160101, 121, '2014-01-15 01:32:09.000000', 'temperatura', 363.0000, 'ºC'),
	(160102, 121, '2014-01-15 01:32:10.000000', 'temperatura', 155.0000, 'ºC'),
	(160103, 121, '2014-01-15 01:32:11.000000', 'temperatura', 889.0000, 'ºC'),
	(160104, 121, '2014-01-15 01:32:12.000000', 'temperatura', 377.0000, 'ºC'),
	(160105, 121, '2014-01-15 01:32:13.000000', 'temperatura', 420.0000, 'ºC'),
	(160106, 121, '2014-01-15 01:32:14.000000', 'temperatura', 971.0000, 'ºC'),
	(160107, 121, '2014-01-15 01:32:15.000000', 'temperatura', 1196.0000, 'ºC'),
	(160108, 121, '2014-01-15 01:32:16.000000', 'temperatura', 666.0000, 'ºC'),
	(160109, 121, '2014-01-15 01:32:17.000000', 'temperatura', 945.0000, 'ºC'),
	(160110, 121, '2014-01-15 01:32:18.000000', 'temperatura', 324.0000, 'ºC'),
	(160111, 121, '2014-01-15 01:32:19.000000', 'temperatura', 1187.0000, 'ºC'),
	(160112, 121, '2014-01-15 01:32:20.000000', 'temperatura', 161.0000, 'ºC'),
	(160113, 121, '2014-01-15 01:32:21.000000', 'temperatura', 848.0000, 'ºC'),
	(160114, 121, '2014-01-15 01:32:22.000000', 'temperatura', 154.0000, 'ºC'),
	(160115, 121, '2014-01-15 01:32:23.000000', 'temperatura', 630.0000, 'ºC'),
	(160116, 121, '2014-01-15 01:32:24.000000', 'temperatura', 286.0000, 'ºC'),
	(160117, 121, '2014-01-15 01:32:25.000000', 'temperatura', 743.0000, 'ºC'),
	(160118, 121, '2014-01-15 01:32:26.000000', 'temperatura', 454.0000, 'ºC'),
	(160119, 121, '2014-01-15 01:32:27.000000', 'temperatura', 45.0000, 'ºC'),
	(160120, 121, '2014-01-15 01:32:28.000000', 'temperatura', 62.0000, 'ºC'),
	(160121, 121, '2014-01-15 01:32:29.000000', 'temperatura', 175.0000, 'ºC'),
	(160122, 121, '2014-01-15 01:32:30.000000', 'temperatura', 692.0000, 'ºC'),
	(160123, 121, '2014-01-15 01:32:31.000000', 'temperatura', 533.0000, 'ºC'),
	(160124, 121, '2014-01-15 01:32:32.000000', 'temperatura', 588.0000, 'ºC'),
	(160125, 121, '2014-01-15 01:32:33.000000', 'temperatura', 144.0000, 'ºC'),
	(160126, 121, '2014-01-15 01:32:34.000000', 'temperatura', 155.0000, 'ºC'),
	(160127, 121, '2014-01-15 01:32:35.000000', 'temperatura', 345.0000, 'ºC'),
	(160128, 121, '2014-01-15 01:32:36.000000', 'temperatura', 61.0000, 'ºC'),
	(160129, 121, '2014-01-15 01:32:37.000000', 'temperatura', 471.0000, 'ºC'),
	(160130, 121, '2014-01-15 01:32:38.000000', 'temperatura', 972.0000, 'ºC'),
	(160131, 121, '2014-01-15 01:32:39.000000', 'temperatura', 1047.0000, 'ºC'),
	(160132, 121, '2014-01-15 01:32:40.000000', 'temperatura', 1119.0000, 'ºC'),
	(160133, 121, '2014-01-15 01:32:41.000000', 'temperatura', 54.0000, 'ºC'),
	(160134, 121, '2014-01-15 01:32:42.000000', 'temperatura', 512.0000, 'ºC'),
	(160135, 121, '2014-01-15 01:32:43.000000', 'temperatura', 2.0000, 'ºC'),
	(160136, 121, '2014-01-15 01:32:44.000000', 'temperatura', 872.0000, 'ºC'),
	(160137, 121, '2014-01-15 01:32:45.000000', 'temperatura', 754.0000, 'ºC'),
	(160138, 121, '2014-01-15 01:32:46.000000', 'temperatura', 1157.0000, 'ºC'),
	(160139, 121, '2014-01-15 01:32:47.000000', 'temperatura', 1124.0000, 'ºC'),
	(160140, 121, '2014-01-15 01:32:48.000000', 'temperatura', 947.0000, 'ºC'),
	(160141, 121, '2014-01-15 01:32:49.000000', 'temperatura', 167.0000, 'ºC'),
	(160142, 121, '2014-01-15 01:32:50.000000', 'temperatura', 391.0000, 'ºC'),
	(160143, 121, '2014-01-15 01:32:51.000000', 'temperatura', 255.0000, 'ºC'),
	(160144, 121, '2014-01-15 01:32:52.000000', 'temperatura', 102.0000, 'ºC'),
	(160145, 121, '2014-01-15 01:32:53.000000', 'temperatura', 948.0000, 'ºC'),
	(160146, 121, '2014-01-15 01:32:54.000000', 'temperatura', 834.0000, 'ºC'),
	(160147, 121, '2014-01-15 01:32:55.000000', 'temperatura', 125.0000, 'ºC'),
	(160148, 121, '2014-01-15 01:32:56.000000', 'temperatura', 526.0000, 'ºC'),
	(160149, 121, '2014-01-15 01:32:57.000000', 'temperatura', 1055.0000, 'ºC'),
	(160150, 121, '2014-01-15 01:32:58.000000', 'temperatura', 98.0000, 'ºC'),
	(160151, 121, '2014-01-15 01:32:59.000000', 'temperatura', 923.0000, 'ºC'),
	(160152, 121, '2014-01-15 01:33:00.000000', 'temperatura', 723.0000, 'ºC'),
	(160153, 121, '2014-01-15 01:33:01.000000', 'temperatura', 845.0000, 'ºC'),
	(160154, 121, '2014-01-15 01:33:02.000000', 'temperatura', 858.0000, 'ºC'),
	(160155, 121, '2014-01-15 01:33:03.000000', 'temperatura', 555.0000, 'ºC'),
	(160156, 121, '2014-01-15 01:33:04.000000', 'temperatura', 201.0000, 'ºC'),
	(160157, 121, '2014-01-15 01:33:05.000000', 'temperatura', 540.0000, 'ºC'),
	(160158, 121, '2014-01-15 01:33:06.000000', 'temperatura', 899.0000, 'ºC'),
	(160159, 121, '2014-01-15 01:33:07.000000', 'temperatura', 476.0000, 'ºC'),
	(160160, 121, '2014-01-15 01:33:08.000000', 'temperatura', 884.0000, 'ºC'),
	(160161, 121, '2014-01-15 01:33:09.000000', 'temperatura', 593.0000, 'ºC'),
	(160162, 121, '2014-01-15 01:33:10.000000', 'temperatura', 314.0000, 'ºC'),
	(160163, 121, '2014-01-15 01:33:11.000000', 'temperatura', 991.0000, 'ºC'),
	(160164, 121, '2014-01-15 01:33:12.000000', 'temperatura', 413.0000, 'ºC'),
	(160165, 121, '2014-01-15 01:33:13.000000', 'temperatura', 292.0000, 'ºC'),
	(160166, 121, '2014-01-15 01:33:14.000000', 'temperatura', 222.0000, 'ºC'),
	(160167, 121, '2014-01-15 01:33:15.000000', 'temperatura', 235.0000, 'ºC'),
	(160168, 121, '2014-01-15 01:33:16.000000', 'temperatura', 511.0000, 'ºC'),
	(160169, 121, '2014-01-15 01:33:17.000000', 'temperatura', 649.0000, 'ºC'),
	(160170, 121, '2014-01-15 01:33:18.000000', 'temperatura', 514.0000, 'ºC'),
	(160171, 121, '2014-01-15 01:33:19.000000', 'temperatura', 621.0000, 'ºC'),
	(160172, 121, '2014-01-15 01:33:20.000000', 'temperatura', 365.0000, 'ºC'),
	(160173, 121, '2014-01-15 01:33:21.000000', 'temperatura', 1160.0000, 'ºC'),
	(160174, 121, '2014-01-15 01:33:22.000000', 'temperatura', 1108.0000, 'ºC'),
	(160175, 121, '2014-01-15 01:33:23.000000', 'temperatura', 860.0000, 'ºC'),
	(160176, 121, '2014-01-15 01:33:24.000000', 'temperatura', 976.0000, 'ºC'),
	(160177, 121, '2014-01-15 01:33:25.000000', 'temperatura', 1101.0000, 'ºC'),
	(160178, 121, '2014-01-15 01:33:26.000000', 'temperatura', 176.0000, 'ºC'),
	(160179, 121, '2014-01-15 01:33:27.000000', 'temperatura', 1180.0000, 'ºC'),
	(160180, 121, '2014-01-15 01:33:28.000000', 'temperatura', 572.0000, 'ºC'),
	(160181, 121, '2014-01-15 01:33:29.000000', 'temperatura', 521.0000, 'ºC'),
	(160182, 121, '2014-01-15 01:33:30.000000', 'temperatura', 890.0000, 'ºC'),
	(160183, 121, '2014-01-15 01:33:31.000000', 'temperatura', 487.0000, 'ºC'),
	(160184, 121, '2014-01-15 01:33:32.000000', 'temperatura', 967.0000, 'ºC'),
	(160185, 121, '2014-01-15 01:33:33.000000', 'temperatura', 972.0000, 'ºC'),
	(160186, 121, '2014-01-15 01:33:34.000000', 'temperatura', 761.0000, 'ºC'),
	(160187, 121, '2014-01-15 01:33:35.000000', 'temperatura', 890.0000, 'ºC'),
	(160188, 121, '2014-01-15 01:33:36.000000', 'temperatura', 968.0000, 'ºC'),
	(160189, 121, '2014-01-15 01:33:37.000000', 'temperatura', 968.0000, 'ºC'),
	(160190, 121, '2014-01-15 01:33:38.000000', 'temperatura', 738.0000, 'ºC'),
	(160191, 121, '2014-01-15 01:33:39.000000', 'temperatura', 788.0000, 'ºC'),
	(160192, 121, '2014-01-15 01:33:40.000000', 'temperatura', 523.0000, 'ºC'),
	(160193, 121, '2014-01-15 01:33:41.000000', 'temperatura', 255.0000, 'ºC'),
	(160194, 121, '2014-01-15 01:33:42.000000', 'temperatura', 905.0000, 'ºC'),
	(160195, 121, '2014-01-15 01:33:43.000000', 'temperatura', 159.0000, 'ºC'),
	(160196, 121, '2014-01-15 01:33:44.000000', 'temperatura', 481.0000, 'ºC'),
	(160197, 121, '2014-01-15 01:33:45.000000', 'temperatura', 730.0000, 'ºC'),
	(160198, 121, '2014-01-15 01:33:46.000000', 'temperatura', 1006.0000, 'ºC'),
	(160199, 121, '2014-01-15 01:33:47.000000', 'temperatura', 443.0000, 'ºC'),
	(160200, 121, '2014-01-15 01:33:48.000000', 'temperatura', 397.0000, 'ºC'),
	(160201, 121, '2014-01-15 01:33:49.000000', 'temperatura', 654.0000, 'ºC'),
	(160202, 121, '2014-01-15 01:33:50.000000', 'temperatura', 883.0000, 'ºC'),
	(160203, 121, '2014-01-15 01:33:51.000000', 'temperatura', 52.0000, 'ºC'),
	(160204, 121, '2014-01-15 01:33:52.000000', 'temperatura', 10.0000, 'ºC'),
	(160205, 121, '2014-01-15 01:33:53.000000', 'temperatura', 1097.0000, 'ºC'),
	(160206, 121, '2014-01-15 01:33:54.000000', 'temperatura', 655.0000, 'ºC'),
	(160207, 121, '2014-01-15 01:33:55.000000', 'temperatura', 1185.0000, 'ºC'),
	(160208, 121, '2014-01-15 01:33:56.000000', 'temperatura', 361.0000, 'ºC'),
	(160209, 121, '2014-01-15 01:33:57.000000', 'temperatura', 648.0000, 'ºC'),
	(160210, 121, '2014-01-15 01:33:58.000000', 'temperatura', 958.0000, 'ºC'),
	(160211, 121, '2014-01-15 01:33:59.000000', 'temperatura', 447.0000, 'ºC'),
	(160212, 121, '2014-01-15 01:34:00.000000', 'temperatura', 563.0000, 'ºC'),
	(160213, 121, '2014-01-15 01:34:01.000000', 'temperatura', 273.0000, 'ºC'),
	(160214, 121, '2014-01-15 01:34:02.000000', 'temperatura', 877.0000, 'ºC'),
	(160215, 121, '2014-01-15 01:34:03.000000', 'temperatura', 1166.0000, 'ºC'),
	(160216, 121, '2014-01-15 01:34:04.000000', 'temperatura', 801.0000, 'ºC'),
	(160217, 121, '2014-01-15 01:34:05.000000', 'temperatura', 506.0000, 'ºC'),
	(160218, 121, '2014-01-15 01:34:06.000000', 'temperatura', 128.0000, 'ºC'),
	(160219, 121, '2014-01-15 01:34:07.000000', 'temperatura', 321.0000, 'ºC'),
	(160220, 121, '2014-01-15 01:34:08.000000', 'temperatura', 20.0000, 'ºC'),
	(160221, 121, '2014-01-15 01:34:09.000000', 'temperatura', 341.0000, 'ºC'),
	(160222, 121, '2014-01-15 01:34:10.000000', 'temperatura', 444.0000, 'ºC'),
	(160223, 121, '2014-01-15 01:34:11.000000', 'temperatura', 1196.0000, 'ºC'),
	(160224, 121, '2014-01-15 01:34:12.000000', 'temperatura', 1049.0000, 'ºC'),
	(160225, 121, '2014-01-15 01:34:13.000000', 'temperatura', 459.0000, 'ºC'),
	(160226, 121, '2014-01-15 01:34:14.000000', 'temperatura', 347.0000, 'ºC'),
	(160227, 121, '2014-01-15 01:34:15.000000', 'temperatura', 357.0000, 'ºC'),
	(160228, 121, '2014-01-15 01:34:16.000000', 'temperatura', 746.0000, 'ºC'),
	(160229, 121, '2014-01-15 01:34:17.000000', 'temperatura', 257.0000, 'ºC'),
	(160230, 121, '2014-01-15 01:34:18.000000', 'temperatura', 251.0000, 'ºC'),
	(160231, 121, '2014-01-15 01:34:19.000000', 'temperatura', 482.0000, 'ºC'),
	(160232, 121, '2014-01-15 01:34:20.000000', 'temperatura', 456.0000, 'ºC'),
	(160233, 121, '2014-01-15 01:34:21.000000', 'temperatura', 838.0000, 'ºC'),
	(160234, 121, '2014-01-15 01:34:22.000000', 'temperatura', 419.0000, 'ºC'),
	(160235, 121, '2014-01-15 01:34:23.000000', 'temperatura', 785.0000, 'ºC'),
	(160236, 121, '2014-01-15 01:34:24.000000', 'temperatura', 266.0000, 'ºC'),
	(160237, 121, '2014-01-15 01:34:25.000000', 'temperatura', 176.0000, 'ºC'),
	(160238, 121, '2014-01-15 01:34:26.000000', 'temperatura', 83.0000, 'ºC'),
	(160239, 121, '2014-01-15 01:34:27.000000', 'temperatura', 1089.0000, 'ºC'),
	(160240, 121, '2014-01-15 01:34:28.000000', 'temperatura', 395.0000, 'ºC'),
	(160241, 121, '2014-01-15 01:34:29.000000', 'temperatura', 1107.0000, 'ºC'),
	(160242, 121, '2014-01-15 01:34:30.000000', 'temperatura', 752.0000, 'ºC'),
	(160243, 121, '2014-01-15 01:34:31.000000', 'temperatura', 440.0000, 'ºC'),
	(160244, 121, '2014-01-15 01:34:32.000000', 'temperatura', 1143.0000, 'ºC'),
	(160245, 121, '2014-01-15 01:34:33.000000', 'temperatura', 796.0000, 'ºC'),
	(160246, 121, '2014-01-15 01:34:34.000000', 'temperatura', 550.0000, 'ºC'),
	(160247, 121, '2014-01-15 01:34:35.000000', 'temperatura', 363.0000, 'ºC'),
	(160248, 121, '2014-01-15 01:34:36.000000', 'temperatura', 164.0000, 'ºC'),
	(160249, 121, '2014-01-15 01:34:37.000000', 'temperatura', 933.0000, 'ºC'),
	(160250, 121, '2014-01-15 01:34:38.000000', 'temperatura', 574.0000, 'ºC'),
	(160251, 121, '2014-01-15 01:34:39.000000', 'temperatura', 70.0000, 'ºC'),
	(160252, 121, '2014-01-15 01:34:40.000000', 'temperatura', 1031.0000, 'ºC'),
	(160253, 121, '2014-01-15 01:34:41.000000', 'temperatura', 143.0000, 'ºC'),
	(160254, 121, '2014-01-15 01:34:42.000000', 'temperatura', 23.0000, 'ºC'),
	(160255, 121, '2014-01-15 01:34:43.000000', 'temperatura', 887.0000, 'ºC'),
	(160256, 121, '2014-01-15 01:34:44.000000', 'temperatura', 767.0000, 'ºC'),
	(160257, 121, '2014-01-15 01:34:45.000000', 'temperatura', 1176.0000, 'ºC'),
	(160258, 121, '2014-01-15 01:34:46.000000', 'temperatura', 1178.0000, 'ºC'),
	(160259, 121, '2014-01-15 01:34:47.000000', 'temperatura', 1163.0000, 'ºC'),
	(160260, 121, '2014-01-15 01:34:48.000000', 'temperatura', 1081.0000, 'ºC'),
	(160261, 121, '2014-01-15 01:34:49.000000', 'temperatura', 717.0000, 'ºC'),
	(160262, 121, '2014-01-15 01:34:50.000000', 'temperatura', 343.0000, 'ºC'),
	(160263, 121, '2014-01-15 01:34:51.000000', 'temperatura', 763.0000, 'ºC'),
	(160264, 121, '2014-01-15 01:34:52.000000', 'temperatura', 387.0000, 'ºC'),
	(160265, 121, '2014-01-15 01:34:53.000000', 'temperatura', 848.0000, 'ºC'),
	(160266, 121, '2014-01-15 01:34:54.000000', 'temperatura', 678.0000, 'ºC'),
	(160267, 121, '2014-01-15 01:34:55.000000', 'temperatura', 847.0000, 'ºC'),
	(160268, 121, '2014-01-15 01:34:56.000000', 'temperatura', 1002.0000, 'ºC'),
	(160269, 121, '2014-01-15 01:34:57.000000', 'temperatura', 69.0000, 'ºC'),
	(160270, 121, '2014-01-15 01:34:58.000000', 'temperatura', 938.0000, 'ºC'),
	(160271, 121, '2014-01-15 01:34:59.000000', 'temperatura', 885.0000, 'ºC'),
	(160272, 121, '2014-01-15 01:35:00.000000', 'temperatura', 412.0000, 'ºC'),
	(160273, 121, '2014-01-15 01:35:01.000000', 'temperatura', 605.0000, 'ºC'),
	(160274, 121, '2014-01-15 01:35:02.000000', 'temperatura', 588.0000, 'ºC'),
	(160275, 121, '2014-01-15 01:35:03.000000', 'temperatura', 1127.0000, 'ºC'),
	(160276, 121, '2014-01-15 01:35:04.000000', 'temperatura', 270.0000, 'ºC'),
	(160277, 121, '2014-01-15 01:35:05.000000', 'temperatura', 369.0000, 'ºC'),
	(160278, 121, '2014-01-15 01:35:06.000000', 'temperatura', 1038.0000, 'ºC'),
	(160279, 121, '2014-01-15 01:35:07.000000', 'temperatura', 484.0000, 'ºC'),
	(160280, 121, '2014-01-15 01:35:08.000000', 'temperatura', 504.0000, 'ºC'),
	(160281, 121, '2014-01-15 01:35:09.000000', 'temperatura', 1069.0000, 'ºC'),
	(160282, 121, '2014-01-15 01:35:10.000000', 'temperatura', 233.0000, 'ºC'),
	(160283, 121, '2014-01-15 01:35:11.000000', 'temperatura', 359.0000, 'ºC'),
	(160284, 121, '2014-01-15 01:35:12.000000', 'temperatura', 1096.0000, 'ºC'),
	(160285, 121, '2014-01-15 01:35:13.000000', 'temperatura', 806.0000, 'ºC'),
	(160286, 121, '2014-01-15 01:35:14.000000', 'temperatura', 740.0000, 'ºC'),
	(160287, 121, '2014-01-15 01:35:15.000000', 'temperatura', 84.0000, 'ºC'),
	(160288, 121, '2014-01-15 01:35:16.000000', 'temperatura', 598.0000, 'ºC'),
	(160289, 121, '2014-01-15 01:35:17.000000', 'temperatura', 340.0000, 'ºC'),
	(160290, 121, '2014-01-15 01:35:18.000000', 'temperatura', 1105.0000, 'ºC'),
	(160291, 121, '2014-01-15 01:35:19.000000', 'temperatura', 907.0000, 'ºC'),
	(160292, 121, '2014-01-15 01:35:20.000000', 'temperatura', 21.0000, 'ºC'),
	(160293, 121, '2014-01-15 01:35:21.000000', 'temperatura', 983.0000, 'ºC'),
	(160294, 121, '2014-01-15 01:35:22.000000', 'temperatura', 52.0000, 'ºC'),
	(160295, 121, '2014-01-15 01:35:23.000000', 'temperatura', 912.0000, 'ºC'),
	(160296, 121, '2014-01-15 01:35:24.000000', 'temperatura', 803.0000, 'ºC'),
	(160297, 121, '2014-01-15 01:35:25.000000', 'temperatura', 83.0000, 'ºC'),
	(160298, 121, '2014-01-15 01:35:26.000000', 'temperatura', 403.0000, 'ºC'),
	(160299, 121, '2014-01-15 01:35:27.000000', 'temperatura', 570.0000, 'ºC'),
	(160300, 121, '2014-01-15 01:35:28.000000', 'temperatura', 440.0000, 'ºC'),
	(160301, 121, '2014-01-15 01:35:29.000000', 'temperatura', 489.0000, 'ºC'),
	(160302, 121, '2014-01-15 01:35:30.000000', 'temperatura', 1126.0000, 'ºC'),
	(160303, 121, '2014-01-15 01:35:31.000000', 'temperatura', 566.0000, 'ºC'),
	(160304, 121, '2014-01-15 01:35:32.000000', 'temperatura', 649.0000, 'ºC'),
	(160305, 121, '2014-01-15 01:35:33.000000', 'temperatura', 350.0000, 'ºC'),
	(160306, 121, '2014-01-15 01:35:34.000000', 'temperatura', 1002.0000, 'ºC'),
	(160307, 121, '2014-01-15 01:35:35.000000', 'temperatura', 362.0000, 'ºC'),
	(160308, 121, '2014-01-15 01:35:36.000000', 'temperatura', 6.0000, 'ºC'),
	(160309, 121, '2014-01-15 01:35:37.000000', 'temperatura', 142.0000, 'ºC'),
	(160310, 121, '2014-01-15 01:35:38.000000', 'temperatura', 693.0000, 'ºC'),
	(160311, 121, '2014-01-15 01:35:39.000000', 'temperatura', 639.0000, 'ºC'),
	(160312, 121, '2014-01-15 01:35:40.000000', 'temperatura', 1116.0000, 'ºC'),
	(160313, 121, '2014-01-15 01:35:41.000000', 'temperatura', 63.0000, 'ºC'),
	(160314, 121, '2014-01-15 01:35:42.000000', 'temperatura', 569.0000, 'ºC'),
	(160315, 121, '2014-01-15 01:35:43.000000', 'temperatura', 257.0000, 'ºC'),
	(160316, 121, '2014-01-15 01:35:44.000000', 'temperatura', 777.0000, 'ºC'),
	(160317, 121, '2014-01-15 01:35:45.000000', 'temperatura', 716.0000, 'ºC'),
	(160318, 121, '2014-01-15 01:35:46.000000', 'temperatura', 50.0000, 'ºC'),
	(160319, 121, '2014-01-15 01:35:47.000000', 'temperatura', 503.0000, 'ºC'),
	(160320, 121, '2014-01-15 01:35:48.000000', 'temperatura', 1164.0000, 'ºC'),
	(160321, 121, '2014-01-15 01:35:49.000000', 'temperatura', 712.0000, 'ºC'),
	(160322, 121, '2014-01-15 01:35:50.000000', 'temperatura', 68.0000, 'ºC'),
	(160323, 121, '2014-01-15 01:35:51.000000', 'temperatura', 607.0000, 'ºC'),
	(160324, 121, '2014-01-15 01:35:52.000000', 'temperatura', 428.0000, 'ºC'),
	(160325, 121, '2014-01-15 01:35:53.000000', 'temperatura', 321.0000, 'ºC'),
	(160326, 121, '2014-01-15 01:35:54.000000', 'temperatura', 321.0000, 'ºC'),
	(160327, 121, '2014-01-15 01:35:55.000000', 'temperatura', 642.0000, 'ºC'),
	(160328, 121, '2014-01-15 01:35:56.000000', 'temperatura', 1046.0000, 'ºC'),
	(160329, 121, '2014-01-15 01:35:57.000000', 'temperatura', 908.0000, 'ºC'),
	(160330, 121, '2014-01-15 01:35:58.000000', 'temperatura', 200.0000, 'ºC'),
	(160331, 121, '2014-01-15 01:35:59.000000', 'temperatura', 678.0000, 'ºC'),
	(160332, 121, '2014-01-15 01:36:00.000000', 'temperatura', 391.0000, 'ºC'),
	(160333, 121, '2014-01-15 01:36:01.000000', 'temperatura', 1120.0000, 'ºC'),
	(160334, 121, '2014-01-15 01:36:02.000000', 'temperatura', 828.0000, 'ºC'),
	(160335, 121, '2014-01-15 01:36:03.000000', 'temperatura', 780.0000, 'ºC'),
	(160336, 121, '2014-01-15 01:36:04.000000', 'temperatura', 217.0000, 'ºC'),
	(160337, 121, '2014-01-15 01:36:05.000000', 'temperatura', 1148.0000, 'ºC'),
	(160338, 121, '2014-01-15 01:36:06.000000', 'temperatura', 286.0000, 'ºC'),
	(160339, 121, '2014-01-15 01:36:07.000000', 'temperatura', 387.0000, 'ºC'),
	(160340, 121, '2014-01-15 01:36:08.000000', 'temperatura', 1077.0000, 'ºC'),
	(160341, 121, '2014-01-15 01:36:09.000000', 'temperatura', 625.0000, 'ºC'),
	(160342, 121, '2014-01-15 01:36:10.000000', 'temperatura', 1094.0000, 'ºC'),
	(160343, 121, '2014-01-15 01:36:11.000000', 'temperatura', 1196.0000, 'ºC'),
	(160344, 121, '2014-01-15 01:36:12.000000', 'temperatura', 301.0000, 'ºC'),
	(160345, 121, '2014-01-15 01:36:13.000000', 'temperatura', 314.0000, 'ºC'),
	(160346, 121, '2014-01-15 01:36:14.000000', 'temperatura', 668.0000, 'ºC'),
	(160347, 121, '2014-01-15 01:36:15.000000', 'temperatura', 1.0000, 'ºC'),
	(160348, 121, '2014-01-15 01:36:16.000000', 'temperatura', 399.0000, 'ºC'),
	(160349, 121, '2014-01-15 01:36:17.000000', 'temperatura', 793.0000, 'ºC'),
	(160350, 121, '2014-01-15 01:36:18.000000', 'temperatura', 368.0000, 'ºC'),
	(160351, 121, '2014-01-15 01:36:19.000000', 'temperatura', 661.0000, 'ºC'),
	(160352, 121, '2014-01-15 01:36:20.000000', 'temperatura', 1002.0000, 'ºC'),
	(160353, 121, '2014-01-15 01:36:21.000000', 'temperatura', 626.0000, 'ºC'),
	(160354, 121, '2014-01-15 01:36:22.000000', 'temperatura', 125.0000, 'ºC'),
	(160355, 121, '2014-01-15 01:36:23.000000', 'temperatura', 1149.0000, 'ºC'),
	(160356, 121, '2014-01-15 01:36:24.000000', 'temperatura', 568.0000, 'ºC'),
	(160357, 121, '2014-01-15 01:36:25.000000', 'temperatura', 594.0000, 'ºC'),
	(160358, 121, '2014-01-15 01:36:26.000000', 'temperatura', 67.0000, 'ºC'),
	(160359, 121, '2014-01-15 01:36:27.000000', 'temperatura', 953.0000, 'ºC'),
	(160360, 121, '2014-01-15 01:36:28.000000', 'temperatura', 964.0000, 'ºC'),
	(160361, 121, '2014-01-15 01:36:29.000000', 'temperatura', 761.0000, 'ºC'),
	(160362, 121, '2014-01-15 01:36:30.000000', 'temperatura', 915.0000, 'ºC'),
	(160363, 121, '2014-01-15 01:36:31.000000', 'temperatura', 1091.0000, 'ºC'),
	(160364, 121, '2014-01-15 01:36:32.000000', 'temperatura', 310.0000, 'ºC'),
	(160365, 121, '2014-01-15 01:36:33.000000', 'temperatura', 677.0000, 'ºC'),
	(160366, 121, '2014-01-15 01:36:34.000000', 'temperatura', 58.0000, 'ºC'),
	(160367, 121, '2014-01-15 01:36:35.000000', 'temperatura', 657.0000, 'ºC'),
	(160368, 121, '2014-01-15 01:36:36.000000', 'temperatura', 714.0000, 'ºC'),
	(160369, 121, '2014-01-15 01:36:37.000000', 'temperatura', 400.0000, 'ºC'),
	(160370, 121, '2014-01-15 01:36:38.000000', 'temperatura', 1057.0000, 'ºC'),
	(160371, 121, '2014-01-15 01:36:39.000000', 'temperatura', 484.0000, 'ºC'),
	(160372, 121, '2014-01-15 01:36:40.000000', 'temperatura', 450.0000, 'ºC'),
	(160373, 121, '2014-01-15 01:36:41.000000', 'temperatura', 798.0000, 'ºC'),
	(160374, 121, '2014-01-15 01:36:42.000000', 'temperatura', 242.0000, 'ºC'),
	(160375, 121, '2014-01-15 01:36:43.000000', 'temperatura', 14.0000, 'ºC'),
	(160376, 121, '2014-01-15 01:36:44.000000', 'temperatura', 548.0000, 'ºC'),
	(160377, 121, '2014-01-15 01:36:45.000000', 'temperatura', 297.0000, 'ºC'),
	(160378, 121, '2014-01-15 01:36:46.000000', 'temperatura', 1040.0000, 'ºC'),
	(160379, 121, '2014-01-15 01:36:47.000000', 'temperatura', 708.0000, 'ºC'),
	(160380, 121, '2014-01-15 01:36:48.000000', 'temperatura', 424.0000, 'ºC'),
	(160381, 121, '2014-01-15 01:36:49.000000', 'temperatura', 1196.0000, 'ºC'),
	(160382, 121, '2014-01-15 01:36:50.000000', 'temperatura', 1107.0000, 'ºC'),
	(160383, 121, '2014-01-15 01:36:51.000000', 'temperatura', 750.0000, 'ºC'),
	(160384, 121, '2014-01-15 01:36:52.000000', 'temperatura', 428.0000, 'ºC'),
	(160385, 121, '2014-01-15 01:36:53.000000', 'temperatura', 1091.0000, 'ºC'),
	(160386, 121, '2014-01-15 01:36:54.000000', 'temperatura', 571.0000, 'ºC'),
	(160387, 121, '2014-01-15 01:36:55.000000', 'temperatura', 783.0000, 'ºC'),
	(160388, 121, '2014-01-15 01:36:56.000000', 'temperatura', 1003.0000, 'ºC'),
	(160389, 121, '2014-01-15 01:36:57.000000', 'temperatura', 266.0000, 'ºC'),
	(160390, 121, '2014-01-15 01:36:58.000000', 'temperatura', 722.0000, 'ºC'),
	(160391, 121, '2014-01-15 01:36:59.000000', 'temperatura', 412.0000, 'ºC'),
	(160392, 121, '2014-01-15 01:37:00.000000', 'temperatura', 1094.0000, 'ºC'),
	(160393, 121, '2014-01-15 01:37:01.000000', 'temperatura', 634.0000, 'ºC'),
	(160394, 121, '2014-01-15 01:37:02.000000', 'temperatura', 1090.0000, 'ºC'),
	(160395, 121, '2014-01-15 01:37:03.000000', 'temperatura', 1150.0000, 'ºC'),
	(160396, 121, '2014-01-15 01:37:04.000000', 'temperatura', 78.0000, 'ºC'),
	(160397, 121, '2014-01-15 01:37:05.000000', 'temperatura', 542.0000, 'ºC'),
	(160398, 121, '2014-01-15 01:37:06.000000', 'temperatura', 76.0000, 'ºC'),
	(160399, 121, '2014-01-15 01:37:07.000000', 'temperatura', 1154.0000, 'ºC'),
	(160400, 121, '2014-01-15 01:37:08.000000', 'temperatura', 743.0000, 'ºC'),
	(160401, 121, '2014-01-15 01:37:09.000000', 'temperatura', 254.0000, 'ºC'),
	(160402, 121, '2014-01-15 01:37:10.000000', 'temperatura', 242.0000, 'ºC'),
	(160403, 121, '2014-01-15 01:37:11.000000', 'temperatura', 447.0000, 'ºC'),
	(160404, 121, '2014-01-15 01:37:12.000000', 'temperatura', 310.0000, 'ºC'),
	(160405, 121, '2014-01-15 01:37:13.000000', 'temperatura', 210.0000, 'ºC'),
	(160406, 121, '2014-01-15 01:37:14.000000', 'temperatura', 121.0000, 'ºC'),
	(160407, 121, '2014-01-15 01:37:15.000000', 'temperatura', 1177.0000, 'ºC'),
	(160408, 121, '2014-01-15 01:37:16.000000', 'temperatura', 719.0000, 'ºC'),
	(160409, 121, '2014-01-15 01:37:17.000000', 'temperatura', 68.0000, 'ºC'),
	(160410, 121, '2014-01-15 01:37:18.000000', 'temperatura', 582.0000, 'ºC'),
	(160411, 121, '2014-01-15 01:37:19.000000', 'temperatura', 306.0000, 'ºC'),
	(160412, 121, '2014-01-15 01:37:20.000000', 'temperatura', 987.0000, 'ºC'),
	(160413, 121, '2014-01-15 01:37:21.000000', 'temperatura', 416.0000, 'ºC'),
	(160414, 121, '2014-01-15 01:37:22.000000', 'temperatura', 320.0000, 'ºC'),
	(160415, 121, '2014-01-15 01:37:23.000000', 'temperatura', 353.0000, 'ºC'),
	(160416, 121, '2014-01-15 01:37:24.000000', 'temperatura', 804.0000, 'ºC'),
	(160417, 121, '2014-01-15 01:37:25.000000', 'temperatura', 561.0000, 'ºC'),
	(160418, 121, '2014-01-15 01:37:26.000000', 'temperatura', 395.0000, 'ºC'),
	(160419, 121, '2014-01-15 01:37:27.000000', 'temperatura', 293.0000, 'ºC'),
	(160420, 121, '2014-01-15 01:37:28.000000', 'temperatura', 280.0000, 'ºC'),
	(160421, 121, '2014-01-15 01:37:29.000000', 'temperatura', 522.0000, 'ºC'),
	(160422, 121, '2014-01-15 01:37:30.000000', 'temperatura', 571.0000, 'ºC'),
	(160423, 121, '2014-01-15 01:37:31.000000', 'temperatura', 89.0000, 'ºC'),
	(160424, 121, '2014-01-15 01:37:32.000000', 'temperatura', 1132.0000, 'ºC'),
	(160425, 121, '2014-01-15 01:37:33.000000', 'temperatura', 595.0000, 'ºC'),
	(160426, 121, '2014-01-15 01:37:34.000000', 'temperatura', 779.0000, 'ºC'),
	(160427, 121, '2014-01-15 01:37:35.000000', 'temperatura', 909.0000, 'ºC'),
	(160428, 121, '2014-01-15 01:37:36.000000', 'temperatura', 1008.0000, 'ºC'),
	(160429, 121, '2014-01-15 01:37:37.000000', 'temperatura', 1116.0000, 'ºC'),
	(160430, 121, '2014-01-15 01:37:38.000000', 'temperatura', 154.0000, 'ºC'),
	(160431, 121, '2014-01-15 01:37:39.000000', 'temperatura', 1023.0000, 'ºC'),
	(160432, 121, '2014-01-15 01:37:40.000000', 'temperatura', 1054.0000, 'ºC'),
	(160433, 121, '2014-01-15 01:37:41.000000', 'temperatura', 1003.0000, 'ºC'),
	(160434, 121, '2014-01-15 01:37:42.000000', 'temperatura', 654.0000, 'ºC'),
	(160435, 121, '2014-01-15 01:37:43.000000', 'temperatura', 260.0000, 'ºC'),
	(160436, 121, '2014-01-15 01:37:44.000000', 'temperatura', 540.0000, 'ºC'),
	(160437, 121, '2014-01-15 01:37:45.000000', 'temperatura', 718.0000, 'ºC'),
	(160438, 121, '2014-01-15 01:37:46.000000', 'temperatura', 772.0000, 'ºC'),
	(160439, 122, '2014-01-15 00:00:00.000000', 'temperatura', 223.0000, 'ºC'),
	(160440, 122, '2014-01-15 00:00:01.000000', 'temperatura', 794.0000, 'ºC'),
	(160441, 122, '2014-01-15 00:00:02.000000', 'temperatura', 899.0000, 'ºC'),
	(160442, 122, '2014-01-15 00:00:03.000000', 'temperatura', 913.0000, 'ºC'),
	(160443, 122, '2014-01-15 00:00:04.000000', 'temperatura', 669.0000, 'ºC'),
	(160444, 122, '2014-01-15 00:00:05.000000', 'temperatura', 605.0000, 'ºC'),
	(160445, 122, '2014-01-15 00:00:06.000000', 'temperatura', 1021.0000, 'ºC'),
	(160446, 122, '2014-01-15 00:00:07.000000', 'temperatura', 891.0000, 'ºC'),
	(160447, 122, '2014-01-15 00:00:08.000000', 'temperatura', 192.0000, 'ºC'),
	(160448, 122, '2014-01-15 00:00:09.000000', 'temperatura', 688.0000, 'ºC'),
	(160449, 122, '2014-01-15 00:00:10.000000', 'temperatura', 465.0000, 'ºC'),
	(160450, 122, '2014-01-15 00:00:11.000000', 'temperatura', 259.0000, 'ºC'),
	(160451, 122, '2014-01-15 00:00:12.000000', 'temperatura', 1103.0000, 'ºC'),
	(160452, 122, '2014-01-15 00:00:13.000000', 'temperatura', 1137.0000, 'ºC'),
	(160453, 122, '2014-01-15 00:00:14.000000', 'temperatura', 1177.0000, 'ºC'),
	(160454, 122, '2014-01-15 00:00:15.000000', 'temperatura', 74.0000, 'ºC'),
	(160455, 122, '2014-01-15 00:00:16.000000', 'temperatura', 441.0000, 'ºC'),
	(160456, 122, '2014-01-15 00:00:17.000000', 'temperatura', 781.0000, 'ºC'),
	(160457, 122, '2014-01-15 00:00:18.000000', 'temperatura', 182.0000, 'ºC'),
	(160458, 122, '2014-01-15 00:00:19.000000', 'temperatura', 970.0000, 'ºC'),
	(160459, 122, '2014-01-15 00:00:20.000000', 'temperatura', 702.0000, 'ºC'),
	(160460, 122, '2014-01-15 00:00:21.000000', 'temperatura', 600.0000, 'ºC'),
	(160461, 122, '2014-01-15 00:00:22.000000', 'temperatura', 897.0000, 'ºC'),
	(160462, 122, '2014-01-15 00:00:23.000000', 'temperatura', 283.0000, 'ºC'),
	(160463, 122, '2014-01-15 00:00:24.000000', 'temperatura', 1124.0000, 'ºC'),
	(160464, 122, '2014-01-15 00:00:25.000000', 'temperatura', 1174.0000, 'ºC'),
	(160465, 122, '2014-01-15 00:00:26.000000', 'temperatura', 96.0000, 'ºC'),
	(160466, 122, '2014-01-15 00:00:27.000000', 'temperatura', 558.0000, 'ºC'),
	(160467, 122, '2014-01-15 00:00:28.000000', 'temperatura', 103.0000, 'ºC'),
	(160468, 122, '2014-01-15 00:00:29.000000', 'temperatura', 42.0000, 'ºC'),
	(160469, 122, '2014-01-15 00:00:30.000000', 'temperatura', 1103.0000, 'ºC'),
	(160470, 122, '2014-01-15 00:00:31.000000', 'temperatura', 588.0000, 'ºC'),
	(160471, 122, '2014-01-15 00:00:32.000000', 'temperatura', 831.0000, 'ºC'),
	(160472, 122, '2014-01-15 00:00:33.000000', 'temperatura', 1190.0000, 'ºC'),
	(160473, 122, '2014-01-15 00:00:34.000000', 'temperatura', 1059.0000, 'ºC'),
	(160474, 122, '2014-01-15 00:00:35.000000', 'temperatura', 526.0000, 'ºC'),
	(160475, 122, '2014-01-15 00:00:36.000000', 'temperatura', 652.0000, 'ºC'),
	(160476, 122, '2014-01-15 00:00:37.000000', 'temperatura', 484.0000, 'ºC'),
	(160477, 122, '2014-01-15 00:00:38.000000', 'temperatura', 465.0000, 'ºC'),
	(160478, 122, '2014-01-15 00:00:39.000000', 'temperatura', 873.0000, 'ºC'),
	(160479, 122, '2014-01-15 00:00:40.000000', 'temperatura', 572.0000, 'ºC'),
	(160480, 122, '2014-01-15 00:00:41.000000', 'temperatura', 242.0000, 'ºC'),
	(160481, 122, '2014-01-15 00:00:42.000000', 'temperatura', 693.0000, 'ºC'),
	(160482, 122, '2014-01-15 00:00:43.000000', 'temperatura', 342.0000, 'ºC'),
	(160483, 122, '2014-01-15 00:00:44.000000', 'temperatura', 828.0000, 'ºC'),
	(160484, 122, '2014-01-15 00:00:45.000000', 'temperatura', 718.0000, 'ºC'),
	(160485, 122, '2014-01-15 00:00:46.000000', 'temperatura', 1105.0000, 'ºC'),
	(160486, 122, '2014-01-15 00:00:47.000000', 'temperatura', 969.0000, 'ºC'),
	(160487, 122, '2014-01-15 00:00:48.000000', 'temperatura', 334.0000, 'ºC'),
	(160488, 122, '2014-01-15 00:00:49.000000', 'temperatura', 1162.0000, 'ºC'),
	(160489, 122, '2014-01-15 00:00:50.000000', 'temperatura', 8.0000, 'ºC'),
	(160490, 122, '2014-01-15 00:00:51.000000', 'temperatura', 155.0000, 'ºC'),
	(160491, 122, '2014-01-15 00:00:52.000000', 'temperatura', 749.0000, 'ºC'),
	(160492, 122, '2014-01-15 00:00:53.000000', 'temperatura', 884.0000, 'ºC'),
	(160493, 122, '2014-01-15 00:00:54.000000', 'temperatura', 973.0000, 'ºC'),
	(160494, 122, '2014-01-15 00:00:55.000000', 'temperatura', 1014.0000, 'ºC'),
	(160495, 122, '2014-01-15 00:00:56.000000', 'temperatura', 952.0000, 'ºC'),
	(160496, 122, '2014-01-15 00:00:57.000000', 'temperatura', 519.0000, 'ºC'),
	(160497, 122, '2014-01-15 00:00:58.000000', 'temperatura', 938.0000, 'ºC'),
	(160498, 122, '2014-01-15 00:00:59.000000', 'temperatura', 734.0000, 'ºC'),
	(160499, 122, '2014-01-15 00:01:00.000000', 'temperatura', 857.0000, 'ºC'),
	(160500, 122, '2014-01-15 00:01:01.000000', 'temperatura', 884.0000, 'ºC'),
	(160501, 122, '2014-01-15 00:01:02.000000', 'temperatura', 647.0000, 'ºC'),
	(160502, 122, '2014-01-15 00:01:03.000000', 'temperatura', 585.0000, 'ºC'),
	(160503, 122, '2014-01-15 00:01:04.000000', 'temperatura', 985.0000, 'ºC'),
	(160504, 122, '2014-01-15 00:01:05.000000', 'temperatura', 772.0000, 'ºC'),
	(160505, 122, '2014-01-15 00:01:06.000000', 'temperatura', 903.0000, 'ºC'),
	(160506, 122, '2014-01-15 00:01:07.000000', 'temperatura', 999.0000, 'ºC'),
	(160507, 122, '2014-01-15 00:01:08.000000', 'temperatura', 1086.0000, 'ºC'),
	(160508, 122, '2014-01-15 00:01:09.000000', 'temperatura', 35.0000, 'ºC'),
	(160509, 122, '2014-01-15 00:01:10.000000', 'temperatura', 517.0000, 'ºC'),
	(160510, 122, '2014-01-15 00:01:11.000000', 'temperatura', 79.0000, 'ºC'),
	(160511, 122, '2014-01-15 00:01:12.000000', 'temperatura', 44.0000, 'ºC'),
	(160512, 122, '2014-01-15 00:01:13.000000', 'temperatura', 1185.0000, 'ºC'),
	(160513, 122, '2014-01-15 00:01:14.000000', 'temperatura', 992.0000, 'ºC'),
	(160514, 122, '2014-01-15 00:01:15.000000', 'temperatura', 206.0000, 'ºC'),
	(160515, 122, '2014-01-15 00:01:16.000000', 'temperatura', 455.0000, 'ºC'),
	(160516, 122, '2014-01-15 00:01:17.000000', 'temperatura', 459.0000, 'ºC'),
	(160517, 122, '2014-01-15 00:01:18.000000', 'temperatura', 931.0000, 'ºC'),
	(160518, 122, '2014-01-15 00:01:19.000000', 'temperatura', 877.0000, 'ºC'),
	(160519, 122, '2014-01-15 00:01:20.000000', 'temperatura', 394.0000, 'ºC'),
	(160520, 122, '2014-01-15 00:01:21.000000', 'temperatura', 538.0000, 'ºC'),
	(160521, 122, '2014-01-15 00:01:22.000000', 'temperatura', 310.0000, 'ºC'),
	(160522, 122, '2014-01-15 00:01:23.000000', 'temperatura', 1137.0000, 'ºC'),
	(160523, 122, '2014-01-15 00:01:24.000000', 'temperatura', 1153.0000, 'ºC'),
	(160524, 122, '2014-01-15 00:01:25.000000', 'temperatura', 1154.0000, 'ºC'),
	(160525, 122, '2014-01-15 00:01:26.000000', 'temperatura', 1112.0000, 'ºC'),
	(160526, 122, '2014-01-15 00:01:27.000000', 'temperatura', 900.0000, 'ºC'),
	(160527, 122, '2014-01-15 00:01:28.000000', 'temperatura', 1163.0000, 'ºC'),
	(160528, 122, '2014-01-15 00:01:29.000000', 'temperatura', 716.0000, 'ºC'),
	(160529, 122, '2014-01-15 00:01:30.000000', 'temperatura', 90.0000, 'ºC'),
	(160530, 122, '2014-01-15 00:01:31.000000', 'temperatura', 703.0000, 'ºC'),
	(160531, 122, '2014-01-15 00:01:32.000000', 'temperatura', 846.0000, 'ºC'),
	(160532, 122, '2014-01-15 00:01:33.000000', 'temperatura', 922.0000, 'ºC'),
	(160533, 122, '2014-01-15 00:01:34.000000', 'temperatura', 871.0000, 'ºC'),
	(160534, 122, '2014-01-15 00:01:35.000000', 'temperatura', 391.0000, 'ºC'),
	(160535, 122, '2014-01-15 00:01:36.000000', 'temperatura', 544.0000, 'ºC'),
	(160536, 122, '2014-01-15 00:01:37.000000', 'temperatura', 345.0000, 'ºC'),
	(160537, 122, '2014-01-15 00:01:38.000000', 'temperatura', 95.0000, 'ºC'),
	(160538, 122, '2014-01-15 00:01:39.000000', 'temperatura', 642.0000, 'ºC'),
	(160539, 122, '2014-01-15 00:01:40.000000', 'temperatura', 524.0000, 'ºC'),
	(160540, 122, '2014-01-15 00:01:41.000000', 'temperatura', 696.0000, 'ºC'),
	(160541, 122, '2014-01-15 00:01:42.000000', 'temperatura', 706.0000, 'ºC'),
	(160542, 122, '2014-01-15 00:01:43.000000', 'temperatura', 243.0000, 'ºC'),
	(160543, 122, '2014-01-15 00:01:44.000000', 'temperatura', 297.0000, 'ºC'),
	(160544, 122, '2014-01-15 00:01:45.000000', 'temperatura', 758.0000, 'ºC'),
	(160545, 122, '2014-01-15 00:01:46.000000', 'temperatura', 498.0000, 'ºC'),
	(160546, 122, '2014-01-15 00:01:47.000000', 'temperatura', 217.0000, 'ºC'),
	(160547, 122, '2014-01-15 00:01:48.000000', 'temperatura', 794.0000, 'ºC'),
	(160548, 122, '2014-01-15 00:01:49.000000', 'temperatura', 916.0000, 'ºC'),
	(160549, 122, '2014-01-15 00:01:50.000000', 'temperatura', 1001.0000, 'ºC'),
	(160550, 122, '2014-01-15 00:01:51.000000', 'temperatura', 1055.0000, 'ºC'),
	(160551, 122, '2014-01-15 00:01:52.000000', 'temperatura', 1073.0000, 'ºC'),
	(160552, 122, '2014-01-15 00:01:53.000000', 'temperatura', 999.0000, 'ºC'),
	(160553, 122, '2014-01-15 00:01:54.000000', 'temperatura', 580.0000, 'ºC'),
	(160554, 122, '2014-01-15 00:01:55.000000', 'temperatura', 1101.0000, 'ºC'),
	(160555, 122, '2014-01-15 00:01:56.000000', 'temperatura', 168.0000, 'ºC'),
	(160556, 122, '2014-01-15 00:01:57.000000', 'temperatura', 1137.0000, 'ºC'),
	(160557, 122, '2014-01-15 00:01:58.000000', 'temperatura', 382.0000, 'ºC'),
	(160558, 122, '2014-01-15 00:01:59.000000', 'temperatura', 900.0000, 'ºC'),
	(160559, 122, '2014-01-15 00:02:00.000000', 'temperatura', 954.0000, 'ºC'),
	(160560, 122, '2014-01-15 00:02:01.000000', 'temperatura', 871.0000, 'ºC'),
	(160561, 122, '2014-01-15 00:02:02.000000', 'temperatura', 293.0000, 'ºC'),
	(160562, 122, '2014-01-15 00:02:03.000000', 'temperatura', 52.0000, 'ºC'),
	(160563, 122, '2014-01-15 00:02:04.000000', 'temperatura', 581.0000, 'ºC'),
	(160564, 122, '2014-01-15 00:02:05.000000', 'temperatura', 352.0000, 'ºC'),
	(160565, 122, '2014-01-15 00:02:06.000000', 'temperatura', 17.0000, 'ºC'),
	(160566, 122, '2014-01-15 00:02:07.000000', 'temperatura', 227.0000, 'ºC'),
	(160567, 122, '2014-01-15 00:02:08.000000', 'temperatura', 1087.0000, 'ºC'),
	(160568, 122, '2014-01-15 00:02:09.000000', 'temperatura', 1155.0000, 'ºC'),
	(160569, 122, '2014-01-15 00:02:10.000000', 'temperatura', 115.0000, 'ºC'),
	(160570, 122, '2014-01-15 00:02:11.000000', 'temperatura', 710.0000, 'ºC'),
	(160571, 122, '2014-01-15 00:02:12.000000', 'temperatura', 806.0000, 'ºC'),
	(160572, 122, '2014-01-15 00:02:13.000000', 'temperatura', 702.0000, 'ºC'),
	(160573, 122, '2014-01-15 00:02:14.000000', 'temperatura', 1089.0000, 'ºC'),
	(160574, 122, '2014-01-15 00:02:15.000000', 'temperatura', 941.0000, 'ºC'),
	(160575, 122, '2014-01-15 00:02:16.000000', 'temperatura', 237.0000, 'ºC'),
	(160576, 122, '2014-01-15 00:02:17.000000', 'temperatura', 762.0000, 'ºC'),
	(160577, 122, '2014-01-15 00:02:18.000000', 'temperatura', 703.0000, 'ºC'),
	(160578, 122, '2014-01-15 00:02:19.000000', 'temperatura', 26.0000, 'ºC'),
	(160579, 122, '2014-01-15 00:02:20.000000', 'temperatura', 421.0000, 'ºC'),
	(160580, 122, '2014-01-15 00:02:21.000000', 'temperatura', 830.0000, 'ºC'),
	(160581, 122, '2014-01-15 00:02:22.000000', 'temperatura', 486.0000, 'ºC'),
	(160582, 122, '2014-01-15 00:02:23.000000', 'temperatura', 1142.0000, 'ºC'),
	(160583, 122, '2014-01-15 00:02:24.000000', 'temperatura', 650.0000, 'ºC'),
	(160584, 122, '2014-01-15 00:02:25.000000', 'temperatura', 1025.0000, 'ºC'),
	(160585, 122, '2014-01-15 00:02:26.000000', 'temperatura', 777.0000, 'ºC'),
	(160586, 122, '2014-01-15 00:02:27.000000', 'temperatura', 809.0000, 'ºC'),
	(160587, 122, '2014-01-15 00:02:28.000000', 'temperatura', 516.0000, 'ºC'),
	(160588, 122, '2014-01-15 00:02:29.000000', 'temperatura', 154.0000, 'ºC'),
	(160589, 122, '2014-01-15 00:02:30.000000', 'temperatura', 420.0000, 'ºC'),
	(160590, 122, '2014-01-15 00:02:31.000000', 'temperatura', 440.0000, 'ºC'),
	(160591, 122, '2014-01-15 00:02:32.000000', 'temperatura', 938.0000, 'ºC'),
	(160592, 122, '2014-01-15 00:02:33.000000', 'temperatura', 973.0000, 'ºC'),
	(160593, 122, '2014-01-15 00:02:34.000000', 'temperatura', 851.0000, 'ºC'),
	(160594, 122, '2014-01-15 00:02:35.000000', 'temperatura', 135.0000, 'ºC'),
	(160595, 122, '2014-01-15 00:02:36.000000', 'temperatura', 522.0000, 'ºC'),
	(160596, 122, '2014-01-15 00:02:37.000000', 'temperatura', 1008.0000, 'ºC'),
	(160597, 122, '2014-01-15 00:02:38.000000', 'temperatura', 1072.0000, 'ºC'),
	(160598, 122, '2014-01-15 00:02:39.000000', 'temperatura', 1138.0000, 'ºC'),
	(160599, 122, '2014-01-15 00:02:40.000000', 'temperatura', 72.0000, 'ºC'),
	(160600, 122, '2014-01-15 00:02:41.000000', 'temperatura', 550.0000, 'ºC'),
	(160601, 122, '2014-01-15 00:02:42.000000', 'temperatura', 132.0000, 'ºC'),
	(160602, 122, '2014-01-15 00:02:43.000000', 'temperatura', 210.0000, 'ºC'),
	(160603, 122, '2014-01-15 00:02:44.000000', 'temperatura', 657.0000, 'ºC'),
	(160604, 122, '2014-01-15 00:02:45.000000', 'temperatura', 254.0000, 'ºC'),
	(160605, 122, '2014-01-15 00:02:46.000000', 'temperatura', 502.0000, 'ºC'),
	(160606, 122, '2014-01-15 00:02:47.000000', 'temperatura', 545.0000, 'ºC'),
	(160607, 122, '2014-01-15 00:02:48.000000', 'temperatura', 21.0000, 'ºC'),
	(160608, 122, '2014-01-15 00:02:49.000000', 'temperatura', 871.0000, 'ºC'),
	(160609, 122, '2014-01-15 00:02:50.000000', 'temperatura', 694.0000, 'ºC'),
	(160610, 122, '2014-01-15 00:02:51.000000', 'temperatura', 854.0000, 'ºC'),
	(160611, 122, '2014-01-15 00:02:52.000000', 'temperatura', 991.0000, 'ºC'),
	(160612, 122, '2014-01-15 00:02:53.000000', 'temperatura', 1194.0000, 'ºC'),
	(160613, 122, '2014-01-15 00:02:54.000000', 'temperatura', 595.0000, 'ºC'),
	(160614, 122, '2014-01-15 00:02:55.000000', 'temperatura', 595.0000, 'ºC'),
	(160615, 122, '2014-01-15 00:02:56.000000', 'temperatura', 1189.0000, 'ºC'),
	(160616, 122, '2014-01-15 00:02:57.000000', 'temperatura', 561.0000, 'ºC'),
	(160617, 122, '2014-01-15 00:02:58.000000', 'temperatura', 439.0000, 'ºC'),
	(160618, 122, '2014-01-15 00:02:59.000000', 'temperatura', 512.0000, 'ºC'),
	(160619, 122, '2014-01-15 00:03:00.000000', 'temperatura', 45.0000, 'ºC'),
	(160620, 122, '2014-01-15 00:03:01.000000', 'temperatura', 1088.0000, 'ºC'),
	(160621, 122, '2014-01-15 00:03:02.000000', 'temperatura', 507.0000, 'ºC'),
	(160622, 122, '2014-01-15 00:03:03.000000', 'temperatura', 473.0000, 'ºC'),
	(160623, 122, '2014-01-15 00:03:04.000000', 'temperatura', 842.0000, 'ºC'),
	(160624, 122, '2014-01-15 00:03:05.000000', 'temperatura', 392.0000, 'ºC'),
	(160625, 122, '2014-01-15 00:03:06.000000', 'temperatura', 635.0000, 'ºC'),
	(160626, 122, '2014-01-15 00:03:07.000000', 'temperatura', 798.0000, 'ºC'),
	(160627, 122, '2014-01-15 00:03:08.000000', 'temperatura', 886.0000, 'ºC'),
	(160628, 122, '2014-01-15 00:03:09.000000', 'temperatura', 836.0000, 'ºC'),
	(160629, 122, '2014-01-15 00:03:10.000000', 'temperatura', 322.0000, 'ºC'),
	(160630, 122, '2014-01-15 00:03:11.000000', 'temperatura', 305.0000, 'ºC'),
	(160631, 122, '2014-01-15 00:03:12.000000', 'temperatura', 559.0000, 'ºC'),
	(160632, 122, '2014-01-15 00:03:13.000000', 'temperatura', 678.0000, 'ºC'),
	(160633, 122, '2014-01-15 00:03:14.000000', 'temperatura', 516.0000, 'ºC'),
	(160634, 122, '2014-01-15 00:03:15.000000', 'temperatura', 545.0000, 'ºC'),
	(160635, 122, '2014-01-15 00:03:16.000000', 'temperatura', 1179.0000, 'ºC'),
	(160636, 122, '2014-01-15 00:03:17.000000', 'temperatura', 662.0000, 'ºC'),
	(160637, 122, '2014-01-15 00:03:18.000000', 'temperatura', 970.0000, 'ºC'),
	(160638, 122, '2014-01-15 00:03:19.000000', 'temperatura', 466.0000, 'ºC'),
	(160639, 122, '2014-01-15 00:03:20.000000', 'temperatura', 622.0000, 'ºC'),
	(160640, 122, '2014-01-15 00:03:21.000000', 'temperatura', 509.0000, 'ºC'),
	(160641, 122, '2014-01-15 00:03:22.000000', 'temperatura', 683.0000, 'ºC'),
	(160642, 122, '2014-01-15 00:03:23.000000', 'temperatura', 686.0000, 'ºC'),
	(160643, 122, '2014-01-15 00:03:24.000000', 'temperatura', 183.0000, 'ºC'),
	(160644, 122, '2014-01-15 00:03:25.000000', 'temperatura', 57.0000, 'ºC'),
	(160645, 122, '2014-01-15 00:03:26.000000', 'temperatura', 938.0000, 'ºC'),
	(160646, 122, '2014-01-15 00:03:27.000000', 'temperatura', 917.0000, 'ºC'),
	(160647, 122, '2014-01-15 00:03:28.000000', 'temperatura', 571.0000, 'ºC'),
	(160648, 122, '2014-01-15 00:03:29.000000', 'temperatura', 106.0000, 'ºC'),
	(160649, 122, '2014-01-15 00:03:30.000000', 'temperatura', 17.0000, 'ºC'),
	(160650, 122, '2014-01-15 00:03:31.000000', 'temperatura', 970.0000, 'ºC'),
	(160651, 122, '2014-01-15 00:03:32.000000', 'temperatura', 1196.0000, 'ºC'),
	(160652, 122, '2014-01-15 00:03:33.000000', 'temperatura', 672.0000, 'ºC'),
	(160653, 122, '2014-01-15 00:03:34.000000', 'temperatura', 972.0000, 'ºC'),
	(160654, 122, '2014-01-15 00:03:35.000000', 'temperatura', 443.0000, 'ºC'),
	(160655, 122, '2014-01-15 00:03:36.000000', 'temperatura', 501.0000, 'ºC'),
	(160656, 122, '2014-01-15 00:03:37.000000', 'temperatura', 1176.0000, 'ºC'),
	(160657, 122, '2014-01-15 00:03:38.000000', 'temperatura', 777.0000, 'ºC'),
	(160658, 122, '2014-01-15 00:03:39.000000', 'temperatura', 360.0000, 'ºC'),
	(160659, 122, '2014-01-15 00:03:40.000000', 'temperatura', 667.0000, 'ºC'),
	(160660, 122, '2014-01-15 00:03:41.000000', 'temperatura', 1057.0000, 'ºC'),
	(160661, 122, '2014-01-15 00:03:42.000000', 'temperatura', 886.0000, 'ºC'),
	(160662, 122, '2014-01-15 00:03:43.000000', 'temperatura', 56.0000, 'ºC'),
	(160663, 122, '2014-01-15 00:03:44.000000', 'temperatura', 24.0000, 'ºC'),
	(160664, 122, '2014-01-15 00:03:45.000000', 'temperatura', 1153.0000, 'ºC'),
	(160665, 122, '2014-01-15 00:03:46.000000', 'temperatura', 893.0000, 'ºC'),
	(160666, 122, '2014-01-15 00:03:47.000000', 'temperatura', 1005.0000, 'ºC'),
	(160667, 122, '2014-01-15 00:03:48.000000', 'temperatura', 1147.0000, 'ºC'),
	(160668, 122, '2014-01-15 00:03:49.000000', 'temperatura', 322.0000, 'ºC'),
	(160669, 122, '2014-01-15 00:03:50.000000', 'temperatura', 571.0000, 'ºC'),
	(160670, 122, '2014-01-15 00:03:51.000000', 'temperatura', 686.0000, 'ºC'),
	(160671, 122, '2014-01-15 00:03:52.000000', 'temperatura', 521.0000, 'ºC'),
	(160672, 122, '2014-01-15 00:03:53.000000', 'temperatura', 544.0000, 'ºC'),
	(160673, 122, '2014-01-15 00:03:54.000000', 'temperatura', 1160.0000, 'ºC'),
	(160674, 122, '2014-01-15 00:03:55.000000', 'temperatura', 569.0000, 'ºC'),
	(160675, 122, '2014-01-15 00:03:56.000000', 'temperatura', 567.0000, 'ºC'),
	(160676, 122, '2014-01-15 00:03:57.000000', 'temperatura', 1125.0000, 'ºC'),
	(160677, 122, '2014-01-15 00:03:58.000000', 'temperatura', 324.0000, 'ºC'),
	(160678, 122, '2014-01-15 00:03:59.000000', 'temperatura', 649.0000, 'ºC'),
	(160679, 122, '2014-01-15 00:04:00.000000', 'temperatura', 1071.0000, 'ºC'),
	(160680, 122, '2014-01-15 00:04:01.000000', 'temperatura', 1011.0000, 'ºC'),
	(160681, 122, '2014-01-15 00:04:02.000000', 'temperatura', 640.0000, 'ºC'),
	(160682, 122, '2014-01-15 00:04:03.000000', 'temperatura', 167.0000, 'ºC'),
	(160683, 122, '2014-01-15 00:04:04.000000', 'temperatura', 118.0000, 'ºC'),
	(160684, 122, '2014-01-15 00:04:05.000000', 'temperatura', 87.0000, 'ºC'),
	(160685, 122, '2014-01-15 00:04:06.000000', 'temperatura', 81.0000, 'ºC'),
	(160686, 122, '2014-01-15 00:04:07.000000', 'temperatura', 146.0000, 'ºC'),
	(160687, 122, '2014-01-15 00:04:08.000000', 'temperatura', 489.0000, 'ºC'),
	(160688, 122, '2014-01-15 00:04:09.000000', 'temperatura', 805.0000, 'ºC'),
	(160689, 122, '2014-01-15 00:04:10.000000', 'temperatura', 160.0000, 'ºC'),
	(160690, 122, '2014-01-15 00:04:11.000000', 'temperatura', 783.0000, 'ºC'),
	(160691, 122, '2014-01-15 00:04:12.000000', 'temperatura', 1039.0000, 'ºC'),
	(160692, 122, '2014-01-15 00:04:13.000000', 'temperatura', 444.0000, 'ºC'),
	(160693, 122, '2014-01-15 00:04:14.000000', 'temperatura', 303.0000, 'ºC'),
	(160694, 122, '2014-01-15 00:04:15.000000', 'temperatura', 183.0000, 'ºC'),
	(160695, 122, '2014-01-15 00:04:16.000000', 'temperatura', 5.0000, 'ºC'),
	(160696, 122, '2014-01-15 00:04:17.000000', 'temperatura', 680.0000, 'ºC'),
	(160697, 122, '2014-01-15 00:04:18.000000', 'temperatura', 985.0000, 'ºC'),
	(160698, 122, '2014-01-15 00:04:19.000000', 'temperatura', 483.0000, 'ºC'),
	(160699, 122, '2014-01-15 00:04:20.000000', 'temperatura', 662.0000, 'ºC'),
	(160700, 122, '2014-01-15 00:04:21.000000', 'temperatura', 662.0000, 'ºC'),
	(160701, 122, '2014-01-15 00:04:22.000000', 'temperatura', 124.0000, 'ºC'),
	(160702, 122, '2014-01-15 00:04:23.000000', 'temperatura', 1035.0000, 'ºC'),
	(160703, 122, '2014-01-15 00:04:24.000000', 'temperatura', 2.0000, 'ºC'),
	(160704, 122, '2014-01-15 00:04:25.000000', 'temperatura', 506.0000, 'ºC'),
	(160705, 122, '2014-01-15 00:04:26.000000', 'temperatura', 126.0000, 'ºC'),
	(160706, 122, '2014-01-15 00:04:27.000000', 'temperatura', 310.0000, 'ºC'),
	(160707, 122, '2014-01-15 00:04:28.000000', 'temperatura', 1172.0000, 'ºC'),
	(160708, 122, '2014-01-15 00:04:29.000000', 'temperatura', 131.0000, 'ºC'),
	(160709, 122, '2014-01-15 00:04:30.000000', 'temperatura', 741.0000, 'ºC'),
	(160710, 122, '2014-01-15 00:04:31.000000', 'temperatura', 914.0000, 'ºC'),
	(160711, 122, '2014-01-15 00:04:32.000000', 'temperatura', 1144.0000, 'ºC'),
	(160712, 122, '2014-01-15 00:04:33.000000', 'temperatura', 581.0000, 'ºC'),
	(160713, 122, '2014-01-15 00:04:34.000000', 'temperatura', 671.0000, 'ºC'),
	(160714, 122, '2014-01-15 00:04:35.000000', 'temperatura', 412.0000, 'ºC'),
	(160715, 122, '2014-01-15 00:04:36.000000', 'temperatura', 50.0000, 'ºC'),
	(160716, 122, '2014-01-15 00:04:37.000000', 'temperatura', 215.0000, 'ºC'),
	(160717, 122, '2014-01-15 00:04:38.000000', 'temperatura', 926.0000, 'ºC'),
	(160718, 122, '2014-01-15 00:04:39.000000', 'temperatura', 386.0000, 'ºC'),
	(160719, 122, '2014-01-15 00:04:40.000000', 'temperatura', 351.0000, 'ºC'),
	(160720, 122, '2014-01-15 00:04:41.000000', 'temperatura', 596.0000, 'ºC'),
	(160721, 122, '2014-01-15 00:04:42.000000', 'temperatura', 729.0000, 'ºC'),
	(160722, 122, '2014-01-15 00:04:43.000000', 'temperatura', 658.0000, 'ºC'),
	(160723, 122, '2014-01-15 00:04:44.000000', 'temperatura', 1103.0000, 'ºC'),
	(160724, 122, '2014-01-15 00:04:45.000000', 'temperatura', 1142.0000, 'ºC'),
	(160725, 122, '2014-01-15 00:04:46.000000', 'temperatura', 1.0000, 'ºC'),
	(160726, 122, '2014-01-15 00:04:47.000000', 'temperatura', 178.0000, 'ºC'),
	(160727, 122, '2014-01-15 00:04:48.000000', 'temperatura', 888.0000, 'ºC'),
	(160728, 122, '2014-01-15 00:04:49.000000', 'temperatura', 308.0000, 'ºC'),
	(160729, 122, '2014-01-15 00:04:50.000000', 'temperatura', 75.0000, 'ºC'),
	(160730, 122, '2014-01-15 00:04:51.000000', 'temperatura', 653.0000, 'ºC'),
	(160731, 122, '2014-01-15 00:04:52.000000', 'temperatura', 640.0000, 'ºC'),
	(160732, 122, '2014-01-15 00:04:53.000000', 'temperatura', 42.0000, 'ºC'),
	(160733, 122, '2014-01-15 00:04:54.000000', 'temperatura', 689.0000, 'ºC'),
	(160734, 122, '2014-01-15 00:04:55.000000', 'temperatura', 920.0000, 'ºC'),
	(160735, 122, '2014-01-15 00:04:56.000000', 'temperatura', 135.0000, 'ºC'),
	(160736, 122, '2014-01-15 00:04:57.000000', 'temperatura', 312.0000, 'ºC'),
	(160737, 122, '2014-01-15 00:04:58.000000', 'temperatura', 1159.0000, 'ºC'),
	(160738, 122, '2014-01-15 00:04:59.000000', 'temperatura', 59.0000, 'ºC'),
	(160739, 122, '2014-01-15 00:05:00.000000', 'temperatura', 420.0000, 'ºC'),
	(160740, 122, '2014-01-15 00:05:01.000000', 'temperatura', 723.0000, 'ºC'),
	(160741, 122, '2014-01-15 00:05:02.000000', 'temperatura', 1154.0000, 'ºC'),
	(160742, 122, '2014-01-15 00:05:03.000000', 'temperatura', 3.0000, 'ºC'),
	(160743, 122, '2014-01-15 00:05:04.000000', 'temperatura', 152.0000, 'ºC'),
	(160744, 122, '2014-01-15 00:05:05.000000', 'temperatura', 750.0000, 'ºC'),
	(160745, 122, '2014-01-15 00:05:06.000000', 'temperatura', 898.0000, 'ºC'),
	(160746, 122, '2014-01-15 00:05:07.000000', 'temperatura', 1039.0000, 'ºC'),
	(160747, 122, '2014-01-15 00:05:08.000000', 'temperatura', 101.0000, 'ºC'),
	(160748, 122, '2014-01-15 00:05:09.000000', 'temperatura', 989.0000, 'ºC'),
	(160749, 122, '2014-01-15 00:05:10.000000', 'temperatura', 1043.0000, 'ºC'),
	(160750, 122, '2014-01-15 00:05:11.000000', 'temperatura', 1050.0000, 'ºC'),
	(160751, 122, '2014-01-15 00:05:12.000000', 'temperatura', 918.0000, 'ºC'),
	(160752, 122, '2014-01-15 00:05:13.000000', 'temperatura', 244.0000, 'ºC'),
	(160753, 122, '2014-01-15 00:05:14.000000', 'temperatura', 864.0000, 'ºC'),
	(160754, 122, '2014-01-15 00:05:15.000000', 'temperatura', 1191.0000, 'ºC'),
	(160755, 122, '2014-01-15 00:05:16.000000', 'temperatura', 963.0000, 'ºC'),
	(160756, 122, '2014-01-15 00:05:17.000000', 'temperatura', 41.0000, 'ºC'),
	(160757, 122, '2014-01-15 00:05:18.000000', 'temperatura', 919.0000, 'ºC'),
	(160758, 122, '2014-01-15 00:05:19.000000', 'temperatura', 873.0000, 'ºC'),
	(160759, 122, '2014-01-15 00:05:20.000000', 'temperatura', 406.0000, 'ºC'),
	(160760, 122, '2014-01-15 00:05:21.000000', 'temperatura', 613.0000, 'ºC'),
	(160761, 122, '2014-01-15 00:05:22.000000', 'temperatura', 647.0000, 'ºC'),
	(160762, 122, '2014-01-15 00:05:23.000000', 'temperatura', 196.0000, 'ºC'),
	(160763, 122, '2014-01-15 00:05:24.000000', 'temperatura', 240.0000, 'ºC'),
	(160764, 122, '2014-01-15 00:05:25.000000', 'temperatura', 611.0000, 'ºC'),
	(160765, 122, '2014-01-15 00:05:26.000000', 'temperatura', 1136.0000, 'ºC'),
	(160766, 122, '2014-01-15 00:05:27.000000', 'temperatura', 246.0000, 'ºC'),
	(160767, 122, '2014-01-15 00:05:28.000000', 'temperatura', 223.0000, 'ºC'),
	(160768, 122, '2014-01-15 00:05:29.000000', 'temperatura', 376.0000, 'ºC'),
	(160769, 122, '2014-01-15 00:05:30.000000', 'temperatura', 13.0000, 'ºC'),
	(160770, 122, '2014-01-15 00:05:31.000000', 'temperatura', 138.0000, 'ºC'),
	(160771, 122, '2014-01-15 00:05:32.000000', 'temperatura', 652.0000, 'ºC'),
	(160772, 122, '2014-01-15 00:05:33.000000', 'temperatura', 446.0000, 'ºC'),
	(160773, 122, '2014-01-15 00:05:34.000000', 'temperatura', 275.0000, 'ºC'),
	(160774, 122, '2014-01-15 00:05:35.000000', 'temperatura', 36.0000, 'ºC'),
	(160775, 122, '2014-01-15 00:05:36.000000', 'temperatura', 558.0000, 'ºC'),
	(160776, 122, '2014-01-15 00:05:37.000000', 'temperatura', 282.0000, 'ºC'),
	(160777, 122, '2014-01-15 00:05:38.000000', 'temperatura', 936.0000, 'ºC'),
	(160778, 122, '2014-01-15 00:05:39.000000', 'temperatura', 233.0000, 'ºC'),
	(160779, 122, '2014-01-15 00:05:40.000000', 'temperatura', 760.0000, 'ºC'),
	(160780, 122, '2014-01-15 00:05:41.000000', 'temperatura', 700.0000, 'ºC'),
	(160781, 122, '2014-01-15 00:05:42.000000', 'temperatura', 21.0000, 'ºC'),
	(160782, 122, '2014-01-15 00:05:43.000000', 'temperatura', 403.0000, 'ºC'),
	(160783, 122, '2014-01-15 00:05:44.000000', 'temperatura', 756.0000, 'ºC'),
	(160784, 122, '2014-01-15 00:05:45.000000', 'temperatura', 169.0000, 'ºC'),
	(160785, 122, '2014-01-15 00:05:46.000000', 'temperatura', 979.0000, 'ºC'),
	(160786, 122, '2014-01-15 00:05:47.000000', 'temperatura', 787.0000, 'ºC'),
	(160787, 122, '2014-01-15 00:05:48.000000', 'temperatura', 1001.0000, 'ºC'),
	(160788, 122, '2014-01-15 00:05:49.000000', 'temperatura', 242.0000, 'ºC'),
	(160789, 122, '2014-01-15 00:05:50.000000', 'temperatura', 608.0000, 'ºC'),
	(160790, 122, '2014-01-15 00:05:51.000000', 'temperatura', 1113.0000, 'ºC'),
	(160791, 122, '2014-01-15 00:05:52.000000', 'temperatura', 141.0000, 'ºC'),
	(160792, 122, '2014-01-15 00:05:53.000000', 'temperatura', 968.0000, 'ºC'),
	(160793, 122, '2014-01-15 00:05:54.000000', 'temperatura', 818.0000, 'ºC'),
	(160794, 122, '2014-01-15 00:05:55.000000', 'temperatura', 1184.0000, 'ºC'),
	(160795, 122, '2014-01-15 00:05:56.000000', 'temperatura', 1068.0000, 'ºC'),
	(160796, 122, '2014-01-15 00:05:57.000000', 'temperatura', 590.0000, 'ºC'),
	(160797, 122, '2014-01-15 00:05:58.000000', 'temperatura', 946.0000, 'ºC'),
	(160798, 122, '2014-01-15 00:05:59.000000', 'temperatura', 560.0000, 'ºC'),
	(160799, 122, '2014-01-15 00:06:00.000000', 'temperatura', 1163.0000, 'ºC'),
	(160800, 122, '2014-01-15 00:06:01.000000', 'temperatura', 537.0000, 'ºC'),
	(160801, 122, '2014-01-15 00:06:02.000000', 'temperatura', 395.0000, 'ºC'),
	(160802, 122, '2014-01-15 00:06:03.000000', 'temperatura', 365.0000, 'ºC'),
	(160803, 122, '2014-01-15 00:06:04.000000', 'temperatura', 638.0000, 'ºC'),
	(160804, 122, '2014-01-15 00:06:05.000000', 'temperatura', 899.0000, 'ºC'),
	(160805, 122, '2014-01-15 00:06:06.000000', 'temperatura', 179.0000, 'ºC'),
	(160806, 122, '2014-01-15 00:06:07.000000', 'temperatura', 601.0000, 'ºC'),
	(160807, 122, '2014-01-15 00:06:08.000000', 'temperatura', 68.0000, 'ºC'),
	(160808, 122, '2014-01-15 00:06:09.000000', 'temperatura', 936.0000, 'ºC'),
	(160809, 122, '2014-01-15 00:06:10.000000', 'temperatura', 876.0000, 'ºC'),
	(160810, 122, '2014-01-15 00:06:11.000000', 'temperatura', 371.0000, 'ºC'),
	(160811, 122, '2014-01-15 00:06:12.000000', 'temperatura', 430.0000, 'ºC'),
	(160812, 122, '2014-01-15 00:06:13.000000', 'temperatura', 1038.0000, 'ºC'),
	(160813, 122, '2014-01-15 00:06:14.000000', 'temperatura', 302.0000, 'ºC'),
	(160814, 122, '2014-01-15 00:06:15.000000', 'temperatura', 794.0000, 'ºC'),
	(160815, 122, '2014-01-15 00:06:16.000000', 'temperatura', 665.0000, 'ºC'),
	(160816, 122, '2014-01-15 00:06:17.000000', 'temperatura', 945.0000, 'ºC'),
	(160817, 122, '2014-01-15 00:06:18.000000', 'temperatura', 331.0000, 'ºC'),
	(160818, 122, '2014-01-15 00:06:19.000000', 'temperatura', 18.0000, 'ºC'),
	(160819, 122, '2014-01-15 00:06:20.000000', 'temperatura', 297.0000, 'ºC'),
	(160820, 122, '2014-01-15 00:06:21.000000', 'temperatura', 231.0000, 'ºC'),
	(160821, 122, '2014-01-15 00:06:22.000000', 'temperatura', 264.0000, 'ºC'),
	(160822, 122, '2014-01-15 00:06:23.000000', 'temperatura', 629.0000, 'ºC'),
	(160823, 122, '2014-01-15 00:06:24.000000', 'temperatura', 1155.0000, 'ºC'),
	(160824, 122, '2014-01-15 00:06:25.000000', 'temperatura', 288.0000, 'ºC'),
	(160825, 122, '2014-01-15 00:06:26.000000', 'temperatura', 375.0000, 'ºC'),
	(160826, 122, '2014-01-15 00:06:27.000000', 'temperatura', 1011.0000, 'ºC'),
	(160827, 122, '2014-01-15 00:06:28.000000', 'temperatura', 330.0000, 'ºC'),
	(160828, 122, '2014-01-15 00:06:29.000000', 'temperatura', 1018.0000, 'ºC'),
	(160829, 122, '2014-01-15 00:06:30.000000', 'temperatura', 502.0000, 'ºC'),
	(160830, 122, '2014-01-15 00:06:31.000000', 'temperatura', 656.0000, 'ºC'),
	(160831, 122, '2014-01-15 00:06:32.000000', 'temperatura', 572.0000, 'ºC'),
	(160832, 122, '2014-01-15 00:06:33.000000', 'temperatura', 895.0000, 'ºC'),
	(160833, 122, '2014-01-15 00:06:34.000000', 'temperatura', 360.0000, 'ºC'),
	(160834, 122, '2014-01-15 00:06:35.000000', 'temperatura', 315.0000, 'ºC'),
	(160835, 122, '2014-01-15 00:06:36.000000', 'temperatura', 494.0000, 'ºC'),
	(160836, 122, '2014-01-15 00:06:37.000000', 'temperatura', 328.0000, 'ºC'),
	(160837, 122, '2014-01-15 00:06:38.000000', 'temperatura', 156.0000, 'ºC'),
	(160838, 122, '2014-01-15 00:06:39.000000', 'temperatura', 999.0000, 'ºC'),
	(160839, 122, '2014-01-15 00:06:40.000000', 'temperatura', 926.0000, 'ºC'),
	(160840, 122, '2014-01-15 00:06:41.000000', 'temperatura', 433.0000, 'ºC'),
	(160841, 122, '2014-01-15 00:06:42.000000', 'temperatura', 589.0000, 'ºC'),
	(160842, 122, '2014-01-15 00:06:43.000000', 'temperatura', 445.0000, 'ºC'),
	(160843, 122, '2014-01-15 00:06:44.000000', 'temperatura', 457.0000, 'ºC'),
	(160844, 122, '2014-01-15 00:06:45.000000', 'temperatura', 953.0000, 'ºC'),
	(160845, 122, '2014-01-15 00:06:46.000000', 'temperatura', 992.0000, 'ºC'),
	(160846, 122, '2014-01-15 00:06:47.000000', 'temperatura', 905.0000, 'ºC'),
	(160847, 122, '2014-01-15 00:06:48.000000', 'temperatura', 347.0000, 'ºC'),
	(160848, 122, '2014-01-15 00:06:49.000000', 'temperatura', 219.0000, 'ºC'),
	(160849, 122, '2014-01-15 00:06:50.000000', 'temperatura', 56.0000, 'ºC'),
	(160850, 122, '2014-01-15 00:06:51.000000', 'temperatura', 825.0000, 'ºC'),
	(160851, 122, '2014-01-15 00:06:52.000000', 'temperatura', 356.0000, 'ºC'),
	(160852, 122, '2014-01-15 00:06:53.000000', 'temperatura', 506.0000, 'ºC'),
	(160853, 122, '2014-01-15 00:06:54.000000', 'temperatura', 263.0000, 'ºC'),
	(160854, 122, '2014-01-15 00:06:55.000000', 'temperatura', 999.0000, 'ºC'),
	(160855, 122, '2014-01-15 00:06:56.000000', 'temperatura', 604.0000, 'ºC'),
	(160856, 122, '2014-01-15 00:06:57.000000', 'temperatura', 25.0000, 'ºC'),
	(160857, 122, '2014-01-15 00:06:58.000000', 'temperatura', 714.0000, 'ºC'),
	(160858, 122, '2014-01-15 00:06:59.000000', 'temperatura', 1095.0000, 'ºC'),
	(160859, 122, '2014-01-15 00:07:00.000000', 'temperatura', 932.0000, 'ºC'),
	(160860, 122, '2014-01-15 00:07:01.000000', 'temperatura', 179.0000, 'ºC'),
	(160861, 122, '2014-01-15 00:07:02.000000', 'temperatura', 496.0000, 'ºC'),
	(160862, 122, '2014-01-15 00:07:03.000000', 'temperatura', 744.0000, 'ºC'),
	(160863, 122, '2014-01-15 00:07:04.000000', 'temperatura', 1034.0000, 'ºC'),
	(160864, 122, '2014-01-15 00:07:05.000000', 'temperatura', 536.0000, 'ºC'),
	(160865, 122, '2014-01-15 00:07:06.000000', 'temperatura', 782.0000, 'ºC'),
	(160866, 122, '2014-01-15 00:07:07.000000', 'temperatura', 1099.0000, 'ºC'),
	(160867, 122, '2014-01-15 00:07:08.000000', 'temperatura', 752.0000, 'ºC'),
	(160868, 122, '2014-01-15 00:07:09.000000', 'temperatura', 461.0000, 'ºC'),
	(160869, 122, '2014-01-15 00:07:10.000000', 'temperatura', 50.0000, 'ºC'),
	(160870, 122, '2014-01-15 00:07:11.000000', 'temperatura', 68.0000, 'ºC'),
	(160871, 122, '2014-01-15 00:07:12.000000', 'temperatura', 191.0000, 'ºC'),
	(160872, 122, '2014-01-15 00:07:13.000000', 'temperatura', 752.0000, 'ºC'),
	(160873, 122, '2014-01-15 00:07:14.000000', 'temperatura', 787.0000, 'ºC'),
	(160874, 122, '2014-01-15 00:07:15.000000', 'temperatura', 481.0000, 'ºC'),
	(160875, 122, '2014-01-15 00:07:16.000000', 'temperatura', 46.0000, 'ºC'),
	(160876, 122, '2014-01-15 00:07:17.000000', 'temperatura', 1184.0000, 'ºC'),
	(160877, 122, '2014-01-15 00:07:18.000000', 'temperatura', 982.0000, 'ºC'),
	(160878, 122, '2014-01-15 00:07:19.000000', 'temperatura', 160.0000, 'ºC'),
	(160879, 122, '2014-01-15 00:07:20.000000', 'temperatura', 255.0000, 'ºC'),
	(160880, 122, '2014-01-15 00:07:21.000000', 'temperatura', 797.0000, 'ºC'),
	(160881, 122, '2014-01-15 00:07:22.000000', 'temperatura', 819.0000, 'ºC'),
	(160882, 122, '2014-01-15 00:07:23.000000', 'temperatura', 505.0000, 'ºC'),
	(160883, 122, '2014-01-15 00:07:24.000000', 'temperatura', 68.0000, 'ºC'),
	(160884, 122, '2014-01-15 00:07:25.000000', 'temperatura', 24.0000, 'ºC'),
	(160885, 122, '2014-01-15 00:07:26.000000', 'temperatura', 1116.0000, 'ºC'),
	(160886, 122, '2014-01-15 00:07:27.000000', 'temperatura', 708.0000, 'ºC'),
	(160887, 122, '2014-01-15 00:07:28.000000', 'temperatura', 196.0000, 'ºC'),
	(160888, 122, '2014-01-15 00:07:29.000000', 'temperatura', 54.0000, 'ºC'),
	(160889, 122, '2014-01-15 00:07:30.000000', 'temperatura', 882.0000, 'ºC'),
	(160890, 122, '2014-01-15 00:07:31.000000', 'temperatura', 647.0000, 'ºC'),
	(160891, 122, '2014-01-15 00:07:32.000000', 'temperatura', 592.0000, 'ºC'),
	(160892, 122, '2014-01-15 00:07:33.000000', 'temperatura', 1020.0000, 'ºC'),
	(160893, 122, '2014-01-15 00:07:34.000000', 'temperatura', 925.0000, 'ºC'),
	(160894, 122, '2014-01-15 00:07:35.000000', 'temperatura', 365.0000, 'ºC'),
	(160895, 122, '2014-01-15 00:07:36.000000', 'temperatura', 251.0000, 'ºC'),
	(160896, 122, '2014-01-15 00:07:37.000000', 'temperatura', 161.0000, 'ºC'),
	(160897, 122, '2014-01-15 00:07:38.000000', 'temperatura', 52.0000, 'ºC'),
	(160898, 122, '2014-01-15 00:07:39.000000', 'temperatura', 976.0000, 'ºC'),
	(160899, 122, '2014-01-15 00:07:40.000000', 'temperatura', 1127.0000, 'ºC'),
	(160900, 122, '2014-01-15 00:07:41.000000', 'temperatura', 306.0000, 'ºC'),
	(160901, 122, '2014-01-15 00:07:42.000000', 'temperatura', 551.0000, 'ºC'),
	(160902, 122, '2014-01-15 00:07:43.000000', 'temperatura', 636.0000, 'ºC'),
	(160903, 122, '2014-01-15 00:07:44.000000', 'temperatura', 329.0000, 'ºC'),
	(160904, 122, '2014-01-15 00:07:45.000000', 'temperatura', 938.0000, 'ºC'),
	(160905, 122, '2014-01-15 00:07:46.000000', 'temperatura', 101.0000, 'ºC'),
	(160906, 122, '2014-01-15 00:07:47.000000', 'temperatura', 91.0000, 'ºC'),
	(160907, 122, '2014-01-15 00:07:48.000000', 'temperatura', 154.0000, 'ºC'),
	(160908, 122, '2014-01-15 00:07:49.000000', 'temperatura', 495.0000, 'ºC'),
	(160909, 122, '2014-01-15 00:07:50.000000', 'temperatura', 816.0000, 'ºC'),
	(160910, 122, '2014-01-15 00:07:51.000000', 'temperatura', 197.0000, 'ºC'),
	(160911, 122, '2014-01-15 00:07:52.000000', 'temperatura', 934.0000, 'ºC'),
	(160912, 122, '2014-01-15 00:07:53.000000', 'temperatura', 482.0000, 'ºC'),
	(160913, 122, '2014-01-15 00:07:54.000000', 'temperatura', 806.0000, 'ºC'),
	(160914, 122, '2014-01-15 00:07:55.000000', 'temperatura', 185.0000, 'ºC'),
	(160915, 122, '2014-01-15 00:07:56.000000', 'temperatura', 909.0000, 'ºC'),
	(160916, 122, '2014-01-15 00:07:57.000000', 'temperatura', 389.0000, 'ºC'),
	(160917, 122, '2014-01-15 00:07:58.000000', 'temperatura', 421.0000, 'ºC'),
	(160918, 122, '2014-01-15 00:07:59.000000', 'temperatura', 936.0000, 'ºC'),
	(160919, 122, '2014-01-15 00:08:00.000000', 'temperatura', 1018.0000, 'ºC'),
	(160920, 122, '2014-01-15 00:08:01.000000', 'temperatura', 1083.0000, 'ºC'),
	(160921, 122, '2014-01-15 00:08:02.000000', 'temperatura', 1163.0000, 'ºC'),
	(160922, 122, '2014-01-15 00:08:03.000000', 'temperatura', 166.0000, 'ºC'),
	(160923, 122, '2014-01-15 00:08:04.000000', 'temperatura', 943.0000, 'ºC'),
	(160924, 122, '2014-01-15 00:08:05.000000', 'temperatura', 615.0000, 'ºC'),
	(160925, 122, '2014-01-15 00:08:06.000000', 'temperatura', 249.0000, 'ºC'),
	(160926, 122, '2014-01-15 00:08:07.000000', 'temperatura', 600.0000, 'ºC'),
	(160927, 122, '2014-01-15 00:08:08.000000', 'temperatura', 1051.0000, 'ºC'),
	(160928, 122, '2014-01-15 00:08:09.000000', 'temperatura', 1056.0000, 'ºC'),
	(160929, 122, '2014-01-15 00:08:10.000000', 'temperatura', 930.0000, 'ºC'),
	(160930, 122, '2014-01-15 00:08:11.000000', 'temperatura', 280.0000, 'ºC'),
	(160931, 122, '2014-01-15 00:08:12.000000', 'temperatura', 1012.0000, 'ºC'),
	(160932, 122, '2014-01-15 00:08:13.000000', 'temperatura', 621.0000, 'ºC'),
	(160933, 122, '2014-01-15 00:08:14.000000', 'temperatura', 68.0000, 'ºC'),
	(160934, 122, '2014-01-15 00:08:15.000000', 'temperatura', 877.0000, 'ºC'),
	(160935, 122, '2014-01-15 00:08:16.000000', 'temperatura', 583.0000, 'ºC'),
	(160936, 122, '2014-01-15 00:08:17.000000', 'temperatura', 282.0000, 'ºC'),
	(160937, 122, '2014-01-15 00:08:18.000000', 'temperatura', 865.0000, 'ºC'),
	(160938, 122, '2014-01-15 00:08:19.000000', 'temperatura', 1078.0000, 'ºC'),
	(160939, 122, '2014-01-15 00:08:20.000000', 'temperatura', 395.0000, 'ºC'),
	(160940, 122, '2014-01-15 00:08:21.000000', 'temperatura', 1142.0000, 'ºC'),
	(160941, 122, '2014-01-15 00:08:22.000000', 'temperatura', 925.0000, 'ºC'),
	(160942, 122, '2014-01-15 00:08:23.000000', 'temperatura', 1.0000, 'ºC'),
	(160943, 122, '2014-01-15 00:08:24.000000', 'temperatura', 829.0000, 'ºC'),
	(160944, 122, '2014-01-15 00:08:25.000000', 'temperatura', 541.0000, 'ºC'),
	(160945, 122, '2014-01-15 00:08:26.000000', 'temperatura', 222.0000, 'ºC'),
	(160946, 122, '2014-01-15 00:08:27.000000', 'temperatura', 685.0000, 'ºC'),
	(160947, 122, '2014-01-15 00:08:28.000000', 'temperatura', 359.0000, 'ºC'),
	(160948, 122, '2014-01-15 00:08:29.000000', 'temperatura', 940.0000, 'ºC'),
	(160949, 122, '2014-01-15 00:08:30.000000', 'temperatura', 25.0000, 'ºC'),
	(160950, 122, '2014-01-15 00:08:31.000000', 'temperatura', 903.0000, 'ºC'),
	(160951, 122, '2014-01-15 00:08:32.000000', 'temperatura', 842.0000, 'ºC'),
	(160952, 122, '2014-01-15 00:08:33.000000', 'temperatura', 301.0000, 'ºC'),
	(160953, 122, '2014-01-15 00:08:34.000000', 'temperatura', 178.0000, 'ºC'),
	(160954, 122, '2014-01-15 00:08:35.000000', 'temperatura', 1189.0000, 'ºC'),
	(160955, 122, '2014-01-15 00:08:36.000000', 'temperatura', 611.0000, 'ºC'),
	(160956, 122, '2014-01-15 00:08:37.000000', 'temperatura', 690.0000, 'ºC'),
	(160957, 122, '2014-01-15 00:08:38.000000', 'temperatura', 416.0000, 'ºC'),
	(160958, 122, '2014-01-15 00:08:39.000000', 'temperatura', 11.0000, 'ºC'),
	(160959, 122, '2014-01-15 00:08:40.000000', 'temperatura', 5.0000, 'ºC'),
	(160960, 122, '2014-01-15 00:08:41.000000', 'temperatura', 1196.0000, 'ºC'),
	(160961, 122, '2014-01-15 00:08:42.000000', 'temperatura', 1163.0000, 'ºC'),
	(160962, 122, '2014-01-15 00:08:43.000000', 'temperatura', 1027.0000, 'ºC'),
	(160963, 122, '2014-01-15 00:08:44.000000', 'temperatura', 447.0000, 'ºC'),
	(160964, 122, '2014-01-15 00:08:45.000000', 'temperatura', 354.0000, 'ºC'),
	(160965, 122, '2014-01-15 00:08:46.000000', 'temperatura', 431.0000, 'ºC'),
	(160966, 122, '2014-01-15 00:08:47.000000', 'temperatura', 1091.0000, 'ºC'),
	(160967, 122, '2014-01-15 00:08:48.000000', 'temperatura', 565.0000, 'ºC'),
	(160968, 122, '2014-01-15 00:08:49.000000', 'temperatura', 753.0000, 'ºC'),
	(160969, 122, '2014-01-15 00:08:50.000000', 'temperatura', 868.0000, 'ºC'),
	(160970, 122, '2014-01-15 00:08:51.000000', 'temperatura', 884.0000, 'ºC'),
	(160971, 122, '2014-01-15 00:08:52.000000', 'temperatura', 618.0000, 'ºC'),
	(160972, 122, '2014-01-15 00:08:53.000000', 'temperatura', 435.0000, 'ºC'),
	(160973, 122, '2014-01-15 00:08:54.000000', 'temperatura', 323.0000, 'ºC'),
	(160974, 122, '2014-01-15 00:08:55.000000', 'temperatura', 311.0000, 'ºC'),
	(160975, 122, '2014-01-15 00:08:56.000000', 'temperatura', 587.0000, 'ºC'),
	(160976, 122, '2014-01-15 00:08:57.000000', 'temperatura', 802.0000, 'ºC'),
	(160977, 122, '2014-01-15 00:08:58.000000', 'temperatura', 1050.0000, 'ºC'),
	(160978, 122, '2014-01-15 00:08:59.000000', 'temperatura', 444.0000, 'ºC'),
	(160979, 122, '2014-01-15 00:09:00.000000', 'temperatura', 269.0000, 'ºC'),
	(160980, 122, '2014-01-15 00:09:01.000000', 'temperatura', 16.0000, 'ºC'),
	(160981, 122, '2014-01-15 00:09:02.000000', 'temperatura', 473.0000, 'ºC'),
	(160982, 122, '2014-01-15 00:09:03.000000', 'temperatura', 1119.0000, 'ºC'),
	(160983, 122, '2014-01-15 00:09:04.000000', 'temperatura', 574.0000, 'ºC'),
	(160984, 122, '2014-01-15 00:09:05.000000', 'temperatura', 715.0000, 'ºC'),
	(160985, 122, '2014-01-15 00:09:06.000000', 'temperatura', 655.0000, 'ºC'),
	(160986, 122, '2014-01-15 00:09:07.000000', 'temperatura', 1128.0000, 'ºC'),
	(160987, 122, '2014-01-15 00:09:08.000000', 'temperatura', 74.0000, 'ºC'),
	(160988, 122, '2014-01-15 00:09:09.000000', 'temperatura', 589.0000, 'ºC'),
	(160989, 122, '2014-01-15 00:09:10.000000', 'temperatura', 325.0000, 'ºC'),
	(160990, 122, '2014-01-15 00:09:11.000000', 'temperatura', 1056.0000, 'ºC'),
	(160991, 122, '2014-01-15 00:09:12.000000', 'temperatura', 708.0000, 'ºC'),
	(160992, 122, '2014-01-15 00:09:13.000000', 'temperatura', 372.0000, 'ºC'),
	(160993, 122, '2014-01-15 00:09:14.000000', 'temperatura', 934.0000, 'ºC'),
	(160994, 122, '2014-01-15 00:09:15.000000', 'temperatura', 1157.0000, 'ºC'),
	(160995, 122, '2014-01-15 00:09:16.000000', 'temperatura', 582.0000, 'ºC'),
	(160996, 122, '2014-01-15 00:09:17.000000', 'temperatura', 641.0000, 'ºC'),
	(160997, 122, '2014-01-15 00:09:18.000000', 'temperatura', 260.0000, 'ºC'),
	(160998, 122, '2014-01-15 00:09:19.000000', 'temperatura', 576.0000, 'ºC'),
	(160999, 122, '2014-01-15 00:09:20.000000', 'temperatura', 902.0000, 'ºC'),
	(161000, 122, '2014-01-15 00:09:21.000000', 'temperatura', 383.0000, 'ºC'),
	(161001, 122, '2014-01-15 00:09:22.000000', 'temperatura', 409.0000, 'ºC'),
	(161002, 122, '2014-01-15 00:09:23.000000', 'temperatura', 897.0000, 'ºC'),
	(161003, 122, '2014-01-15 00:09:24.000000', 'temperatura', 858.0000, 'ºC'),
	(161004, 122, '2014-01-15 00:09:25.000000', 'temperatura', 398.0000, 'ºC'),
	(161005, 122, '2014-01-15 00:09:26.000000', 'temperatura', 617.0000, 'ºC'),
	(161006, 122, '2014-01-15 00:09:27.000000', 'temperatura', 691.0000, 'ºC'),
	(161007, 122, '2014-01-15 00:09:28.000000', 'temperatura', 405.0000, 'ºC'),
	(161008, 122, '2014-01-15 00:09:29.000000', 'temperatura', 1152.0000, 'ºC'),
	(161009, 122, '2014-01-15 00:09:30.000000', 'temperatura', 945.0000, 'ºC'),
	(161010, 122, '2014-01-15 00:09:31.000000', 'temperatura', 72.0000, 'ºC'),
	(161011, 122, '2014-01-15 00:09:32.000000', 'temperatura', 1122.0000, 'ºC'),
	(161012, 122, '2014-01-15 00:09:33.000000', 'temperatura', 597.0000, 'ºC'),
	(161013, 122, '2014-01-15 00:09:34.000000', 'temperatura', 820.0000, 'ºC'),
	(161014, 122, '2014-01-15 00:09:35.000000', 'temperatura', 1109.0000, 'ºC'),
	(161015, 122, '2014-01-15 00:09:36.000000', 'temperatura', 684.0000, 'ºC'),
	(161016, 122, '2014-01-15 00:09:37.000000', 'temperatura', 94.0000, 'ºC'),
	(161017, 122, '2014-01-15 00:09:38.000000', 'temperatura', 820.0000, 'ºC'),
	(161018, 122, '2014-01-15 00:09:39.000000', 'temperatura', 218.0000, 'ºC'),
	(161019, 122, '2014-01-15 00:09:40.000000', 'temperatura', 1029.0000, 'ºC'),
	(161020, 122, '2014-01-15 00:09:41.000000', 'temperatura', 891.0000, 'ºC'),
	(161021, 122, '2014-01-15 00:09:42.000000', 'temperatura', 170.0000, 'ºC'),
	(161022, 122, '2014-01-15 00:09:43.000000', 'temperatura', 577.0000, 'ºC'),
	(161023, 122, '2014-01-15 00:09:44.000000', 'temperatura', 1177.0000, 'ºC'),
	(161024, 122, '2014-01-15 00:09:45.000000', 'temperatura', 554.0000, 'ºC'),
	(161025, 122, '2014-01-15 00:09:46.000000', 'temperatura', 439.0000, 'ºC'),
	(161026, 122, '2014-01-15 00:09:47.000000', 'temperatura', 535.0000, 'ºC'),
	(161027, 122, '2014-01-15 00:09:48.000000', 'temperatura', 159.0000, 'ºC'),
	(161028, 122, '2014-01-15 00:09:49.000000', 'temperatura', 390.0000, 'ºC'),
	(161029, 122, '2014-01-15 00:09:50.000000', 'temperatura', 273.0000, 'ºC'),
	(161030, 122, '2014-01-15 00:09:51.000000', 'temperatura', 195.0000, 'ºC'),
	(161031, 122, '2014-01-15 00:09:52.000000', 'temperatura', 156.0000, 'ºC'),
	(161032, 122, '2014-01-15 00:09:53.000000', 'temperatura', 196.0000, 'ºC'),
	(161033, 122, '2014-01-15 00:09:54.000000', 'temperatura', 513.0000, 'ºC'),
	(161034, 122, '2014-01-15 00:09:55.000000', 'temperatura', 778.0000, 'ºC'),
	(161035, 122, '2014-01-15 00:09:56.000000', 'temperatura', 1150.0000, 'ºC'),
	(161036, 122, '2014-01-15 00:09:57.000000', 'temperatura', 1015.0000, 'ºC'),
	(161037, 122, '2014-01-15 00:09:58.000000', 'temperatura', 429.0000, 'ºC'),
	(161038, 122, '2014-01-15 00:09:59.000000', 'temperatura', 299.0000, 'ºC'),
	(161039, 122, '2014-01-15 00:10:00.000000', 'temperatura', 209.0000, 'ºC'),
	(161040, 122, '2014-01-15 00:10:01.000000', 'temperatura', 148.0000, 'ºC'),
	(161041, 122, '2014-01-15 00:10:02.000000', 'temperatura', 115.0000, 'ºC'),
	(161042, 122, '2014-01-15 00:10:03.000000', 'temperatura', 129.0000, 'ºC'),
	(161043, 122, '2014-01-15 00:10:04.000000', 'temperatura', 302.0000, 'ºC'),
	(161044, 122, '2014-01-15 00:10:05.000000', 'temperatura', 1124.0000, 'ºC'),
	(161045, 122, '2014-01-15 00:10:06.000000', 'temperatura', 1113.0000, 'ºC'),
	(161046, 122, '2014-01-15 00:10:07.000000', 'temperatura', 993.0000, 'ºC'),
	(161047, 122, '2014-01-15 00:10:08.000000', 'temperatura', 429.0000, 'ºC'),
	(161048, 122, '2014-01-15 00:10:09.000000', 'temperatura', 364.0000, 'ºC'),
	(161049, 122, '2014-01-15 00:10:10.000000', 'temperatura', 535.0000, 'ºC'),
	(161050, 122, '2014-01-15 00:10:11.000000', 'temperatura', 383.0000, 'ºC'),
	(161051, 122, '2014-01-15 00:10:12.000000', 'temperatura', 311.0000, 'ºC'),
	(161052, 122, '2014-01-15 00:10:13.000000', 'temperatura', 406.0000, 'ºC'),
	(161053, 122, '2014-01-15 00:10:14.000000', 'temperatura', 1100.0000, 'ºC'),
	(161054, 122, '2014-01-15 00:10:15.000000', 'temperatura', 679.0000, 'ºC'),
	(161055, 122, '2014-01-15 00:10:16.000000', 'temperatura', 97.0000, 'ºC'),
	(161056, 122, '2014-01-15 00:10:17.000000', 'temperatura', 847.0000, 'ºC'),
	(161057, 122, '2014-01-15 00:10:18.000000', 'temperatura', 345.0000, 'ºC'),
	(161058, 122, '2014-01-15 00:10:19.000000', 'temperatura', 386.0000, 'ºC'),
	(161059, 122, '2014-01-15 00:10:20.000000', 'temperatura', 895.0000, 'ºC'),
	(161060, 122, '2014-01-15 00:10:21.000000', 'temperatura', 918.0000, 'ºC'),
	(161061, 122, '2014-01-15 00:10:22.000000', 'temperatura', 705.0000, 'ºC'),
	(161062, 122, '2014-01-15 00:10:23.000000', 'temperatura', 770.0000, 'ºC'),
	(161063, 122, '2014-01-15 00:10:24.000000', 'temperatura', 536.0000, 'ºC'),
	(161064, 122, '2014-01-15 00:10:25.000000', 'temperatura', 372.0000, 'ºC'),
	(161065, 122, '2014-01-15 00:10:26.000000', 'temperatura', 253.0000, 'ºC'),
	(161066, 122, '2014-01-15 00:10:27.000000', 'temperatura', 147.0000, 'ºC'),
	(161067, 122, '2014-01-15 00:10:28.000000', 'temperatura', 1180.0000, 'ºC'),
	(161068, 122, '2014-01-15 00:10:29.000000', 'temperatura', 656.0000, 'ºC'),
	(161069, 122, '2014-01-15 00:10:30.000000', 'temperatura', 943.0000, 'ºC'),
	(161070, 122, '2014-01-15 00:10:31.000000', 'temperatura', 345.0000, 'ºC'),
	(161071, 122, '2014-01-15 00:10:32.000000', 'temperatura', 98.0000, 'ºC'),
	(161072, 122, '2014-01-15 00:10:33.000000', 'temperatura', 655.0000, 'ºC'),
	(161073, 122, '2014-01-15 00:10:34.000000', 'temperatura', 582.0000, 'ºC'),
	(161074, 122, '2014-01-15 00:10:35.000000', 'temperatura', 944.0000, 'ºC'),
	(161075, 122, '2014-01-15 00:10:36.000000', 'temperatura', 575.0000, 'ºC'),
	(161076, 122, '2014-01-15 00:10:37.000000', 'temperatura', 43.0000, 'ºC'),
	(161077, 122, '2014-01-15 00:10:38.000000', 'temperatura', 891.0000, 'ºC'),
	(161078, 122, '2014-01-15 00:10:39.000000', 'temperatura', 726.0000, 'ºC'),
	(161079, 122, '2014-01-15 00:10:40.000000', 'temperatura', 958.0000, 'ºC'),
	(161080, 122, '2014-01-15 00:10:41.000000', 'temperatura', 211.0000, 'ºC'),
	(161081, 122, '2014-01-15 00:10:42.000000', 'temperatura', 581.0000, 'ºC'),
	(161082, 122, '2014-01-15 00:10:43.000000', 'temperatura', 1075.0000, 'ºC'),
	(161083, 122, '2014-01-15 00:10:44.000000', 'temperatura', 30.0000, 'ºC'),
	(161084, 122, '2014-01-15 00:10:45.000000', 'temperatura', 525.0000, 'ºC'),
	(161085, 122, '2014-01-15 00:10:46.000000', 'temperatura', 139.0000, 'ºC'),
	(161086, 122, '2014-01-15 00:10:47.000000', 'temperatura', 318.0000, 'ºC'),
	(161087, 122, '2014-01-15 00:10:48.000000', 'temperatura', 1172.0000, 'ºC'),
	(161088, 122, '2014-01-15 00:10:49.000000', 'temperatura', 108.0000, 'ºC'),
	(161089, 122, '2014-01-15 00:10:50.000000', 'temperatura', 623.0000, 'ºC'),
	(161090, 122, '2014-01-15 00:10:51.000000', 'temperatura', 394.0000, 'ºC'),
	(161091, 122, '2014-01-15 00:10:52.000000', 'temperatura', 100.0000, 'ºC'),
	(161092, 122, '2014-01-15 00:10:53.000000', 'temperatura', 520.0000, 'ºC'),
	(161093, 122, '2014-01-15 00:10:54.000000', 'temperatura', 1099.0000, 'ºC'),
	(161094, 122, '2014-01-15 00:10:55.000000', 'temperatura', 334.0000, 'ºC'),
	(161095, 122, '2014-01-15 00:10:56.000000', 'temperatura', 776.0000, 'ºC'),
	(161096, 122, '2014-01-15 00:10:57.000000', 'temperatura', 477.0000, 'ºC'),
	(161097, 122, '2014-01-15 00:10:58.000000', 'temperatura', 60.0000, 'ºC'),
	(161098, 122, '2014-01-15 00:10:59.000000', 'temperatura', 68.0000, 'ºC'),
	(161099, 122, '2014-01-15 00:11:00.000000', 'temperatura', 160.0000, 'ºC'),
	(161100, 122, '2014-01-15 00:11:01.000000', 'temperatura', 599.0000, 'ºC'),
	(161101, 122, '2014-01-15 00:11:02.000000', 'temperatura', 113.0000, 'ºC'),
	(161102, 122, '2014-01-15 00:11:03.000000', 'temperatura', 1170.0000, 'ºC'),
	(161103, 122, '2014-01-15 00:11:04.000000', 'temperatura', 712.0000, 'ºC'),
	(161104, 122, '2014-01-15 00:11:05.000000', 'temperatura', 50.0000, 'ºC'),
	(161105, 122, '2014-01-15 00:11:06.000000', 'temperatura', 514.0000, 'ºC'),
	(161106, 122, '2014-01-15 00:11:07.000000', 'temperatura', 20.0000, 'ºC'),
	(161107, 122, '2014-01-15 00:11:08.000000', 'temperatura', 958.0000, 'ºC'),
	(161108, 122, '2014-01-15 00:11:09.000000', 'temperatura', 1133.0000, 'ºC'),
	(161109, 122, '2014-01-15 00:11:10.000000', 'temperatura', 390.0000, 'ºC'),
	(161110, 122, '2014-01-15 00:11:11.000000', 'temperatura', 952.0000, 'ºC'),
	(161111, 122, '2014-01-15 00:11:12.000000', 'temperatura', 1188.0000, 'ºC'),
	(161112, 122, '2014-01-15 00:11:13.000000', 'temperatura', 687.0000, 'ºC'),
	(161113, 122, '2014-01-15 00:11:14.000000', 'temperatura', 1073.0000, 'ºC'),
	(161114, 122, '2014-01-15 00:11:15.000000', 'temperatura', 901.0000, 'ºC'),
	(161115, 122, '2014-01-15 00:11:16.000000', 'temperatura', 89.0000, 'ºC'),
	(161116, 122, '2014-01-15 00:11:17.000000', 'temperatura', 143.0000, 'ºC'),
	(161117, 122, '2014-01-15 00:11:18.000000', 'temperatura', 447.0000, 'ºC'),
	(161118, 122, '2014-01-15 00:11:19.000000', 'temperatura', 605.0000, 'ºC'),
	(161119, 122, '2014-01-15 00:11:20.000000', 'temperatura', 487.0000, 'ºC'),
	(161120, 122, '2014-01-15 00:11:21.000000', 'temperatura', 619.0000, 'ºC'),
	(161121, 122, '2014-01-15 00:11:22.000000', 'temperatura', 436.0000, 'ºC'),
	(161122, 122, '2014-01-15 00:11:23.000000', 'temperatura', 324.0000, 'ºC'),
	(161123, 122, '2014-01-15 00:11:24.000000', 'temperatura', 313.0000, 'ºC'),
	(161124, 122, '2014-01-15 00:11:25.000000', 'temperatura', 593.0000, 'ºC'),
	(161125, 122, '2014-01-15 00:11:26.000000', 'temperatura', 827.0000, 'ºC'),
	(161126, 122, '2014-01-15 00:11:27.000000', 'temperatura', 1158.0000, 'ºC'),
	(161127, 122, '2014-01-15 00:11:28.000000', 'temperatura', 908.0000, 'ºC'),
	(161128, 122, '2014-01-15 00:11:29.000000', 'temperatura', 1065.0000, 'ºC'),
	(161129, 122, '2014-01-15 00:11:30.000000', 'temperatura', 202.0000, 'ºC'),
	(161130, 122, '2014-01-15 00:11:31.000000', 'temperatura', 217.0000, 'ºC'),
	(161131, 122, '2014-01-15 00:11:32.000000', 'temperatura', 477.0000, 'ºC'),
	(161132, 122, '2014-01-15 00:11:33.000000', 'temperatura', 536.0000, 'ºC'),
	(161133, 122, '2014-01-15 00:11:34.000000', 'temperatura', 51.0000, 'ºC'),
	(161134, 122, '2014-01-15 00:11:35.000000', 'temperatura', 1045.0000, 'ºC'),
	(161135, 122, '2014-01-15 00:11:36.000000', 'temperatura', 274.0000, 'ºC'),
	(161136, 122, '2014-01-15 00:11:37.000000', 'temperatura', 633.0000, 'ºC'),
	(161137, 122, '2014-01-15 00:11:38.000000', 'temperatura', 1147.0000, 'ºC'),
	(161138, 122, '2014-01-15 00:11:39.000000', 'temperatura', 235.0000, 'ºC'),
	(161139, 122, '2014-01-15 00:11:40.000000', 'temperatura', 133.0000, 'ºC'),
	(161140, 122, '2014-01-15 00:11:41.000000', 'temperatura', 1160.0000, 'ºC'),
	(161141, 122, '2014-01-15 00:11:42.000000', 'temperatura', 605.0000, 'ºC'),
	(161142, 122, '2014-01-15 00:11:43.000000', 'temperatura', 743.0000, 'ºC'),
	(161143, 122, '2014-01-15 00:11:44.000000', 'temperatura', 700.0000, 'ºC'),
	(161144, 122, '2014-01-15 00:11:45.000000', 'temperatura', 70.0000, 'ºC'),
	(161145, 122, '2014-01-15 00:11:46.000000', 'temperatura', 654.0000, 'ºC'),
	(161146, 122, '2014-01-15 00:11:47.000000', 'temperatura', 658.0000, 'ºC'),
	(161147, 122, '2014-01-15 00:11:48.000000', 'temperatura', 129.0000, 'ºC'),
	(161148, 122, '2014-01-15 00:11:49.000000', 'temperatura', 1074.0000, 'ºC'),
	(161149, 122, '2014-01-15 00:11:50.000000', 'temperatura', 180.0000, 'ºC'),
	(161150, 122, '2014-01-15 00:11:51.000000', 'temperatura', 82.0000, 'ºC'),
	(161151, 122, '2014-01-15 00:11:52.000000', 'temperatura', 1068.0000, 'ºC'),
	(161152, 122, '2014-01-15 00:11:53.000000', 'temperatura', 295.0000, 'ºC'),
	(161153, 122, '2014-01-15 00:11:54.000000', 'temperatura', 670.0000, 'ºC'),
	(161154, 122, '2014-01-15 00:11:55.000000', 'temperatura', 66.0000, 'ºC'),
	(161155, 122, '2014-01-15 00:11:56.000000', 'temperatura', 722.0000, 'ºC'),
	(161156, 122, '2014-01-15 00:11:57.000000', 'temperatura', 1012.0000, 'ºC'),
	(161157, 122, '2014-01-15 00:11:58.000000', 'temperatura', 494.0000, 'ºC'),
	(161158, 122, '2014-01-15 00:11:59.000000', 'temperatura', 635.0000, 'ºC'),
	(161159, 122, '2014-01-15 00:12:00.000000', 'temperatura', 494.0000, 'ºC'),
	(161160, 122, '2014-01-15 00:12:01.000000', 'temperatura', 566.0000, 'ºC'),
	(161161, 122, '2014-01-15 00:12:02.000000', 'temperatura', 147.0000, 'ºC'),
	(161162, 122, '2014-01-15 00:12:03.000000', 'temperatura', 238.0000, 'ºC'),
	(161163, 122, '2014-01-15 00:12:04.000000', 'temperatura', 748.0000, 'ºC'),
	(161164, 122, '2014-01-15 00:12:05.000000', 'temperatura', 625.0000, 'ºC'),
	(161165, 122, '2014-01-15 00:12:06.000000', 'temperatura', 885.0000, 'ºC'),
	(161166, 122, '2014-01-15 00:12:07.000000', 'temperatura', 151.0000, 'ºC'),
	(161167, 122, '2014-01-15 00:12:08.000000', 'temperatura', 498.0000, 'ºC'),
	(161168, 122, '2014-01-15 00:12:09.000000', 'temperatura', 838.0000, 'ºC'),
	(161169, 122, '2014-01-15 00:12:10.000000', 'temperatura', 297.0000, 'ºC'),
	(161170, 122, '2014-01-15 00:12:11.000000', 'temperatura', 172.0000, 'ºC'),
	(161171, 122, '2014-01-15 00:12:12.000000', 'temperatura', 1169.0000, 'ºC'),
	(161172, 122, '2014-01-15 00:12:13.000000', 'temperatura', 528.0000, 'ºC'),
	(161173, 122, '2014-01-15 00:12:14.000000', 'temperatura', 336.0000, 'ºC'),
	(161174, 122, '2014-01-15 00:12:15.000000', 'temperatura', 94.0000, 'ºC'),
	(161175, 122, '2014-01-15 00:12:16.000000', 'temperatura', 664.0000, 'ºC'),
	(161176, 122, '2014-01-15 00:12:17.000000', 'temperatura', 637.0000, 'ºC'),
	(161177, 122, '2014-01-15 00:12:18.000000', 'temperatura', 1195.0000, 'ºC'),
	(161178, 122, '2014-01-15 00:12:19.000000', 'temperatura', 464.0000, 'ºC'),
	(161179, 122, '2014-01-15 00:12:20.000000', 'temperatura', 1136.0000, 'ºC'),
	(161180, 122, '2014-01-15 00:12:21.000000', 'temperatura', 690.0000, 'ºC'),
	(161181, 122, '2014-01-15 00:12:22.000000', 'temperatura', 40.0000, 'ºC'),
	(161182, 122, '2014-01-15 00:12:23.000000', 'temperatura', 531.0000, 'ºC'),
	(161183, 122, '2014-01-15 00:12:24.000000', 'temperatura', 137.0000, 'ºC'),
	(161184, 122, '2014-01-15 00:12:25.000000', 'temperatura', 291.0000, 'ºC'),
	(161185, 122, '2014-01-15 00:12:26.000000', 'temperatura', 1047.0000, 'ºC'),
	(161186, 122, '2014-01-15 00:12:27.000000', 'temperatura', 761.0000, 'ºC'),
	(161187, 122, '2014-01-15 00:12:28.000000', 'temperatura', 665.0000, 'ºC'),
	(161188, 122, '2014-01-15 00:12:29.000000', 'temperatura', 1041.0000, 'ºC'),
	(161189, 122, '2014-01-15 00:12:30.000000', 'temperatura', 810.0000, 'ºC'),
	(161190, 122, '2014-01-15 00:12:31.000000', 'temperatura', 928.0000, 'ºC'),
	(161191, 122, '2014-01-15 00:12:32.000000', 'temperatura', 1009.0000, 'ºC'),
	(161192, 122, '2014-01-15 00:12:33.000000', 'temperatura', 1062.0000, 'ºC'),
	(161193, 122, '2014-01-15 00:12:34.000000', 'temperatura', 1084.0000, 'ºC'),
	(161194, 122, '2014-01-15 00:12:35.000000', 'temperatura', 1035.0000, 'ºC'),
	(161195, 122, '2014-01-15 00:12:36.000000', 'temperatura', 723.0000, 'ºC'),
	(161196, 122, '2014-01-15 00:12:37.000000', 'temperatura', 509.0000, 'ºC'),
	(161197, 122, '2014-01-15 00:12:38.000000', 'temperatura', 378.0000, 'ºC'),
	(161198, 122, '2014-01-15 00:12:39.000000', 'temperatura', 363.0000, 'ºC'),
	(161199, 122, '2014-01-15 00:12:40.000000', 'temperatura', 683.0000, 'ºC'),
	(161200, 122, '2014-01-15 00:12:41.000000', 'temperatura', 1124.0000, 'ºC'),
	(161201, 122, '2014-01-15 00:12:42.000000', 'temperatura', 1174.0000, 'ºC'),
	(161202, 122, '2014-01-15 00:12:43.000000', 'temperatura', 95.0000, 'ºC'),
	(161203, 122, '2014-01-15 00:12:44.000000', 'temperatura', 557.0000, 'ºC'),
	(161204, 122, '2014-01-15 00:12:45.000000', 'temperatura', 100.0000, 'ºC'),
	(161205, 122, '2014-01-15 00:12:46.000000', 'temperatura', 27.0000, 'ºC'),
	(161206, 122, '2014-01-15 00:12:47.000000', 'temperatura', 1036.0000, 'ºC'),
	(161207, 122, '2014-01-15 00:12:48.000000', 'temperatura', 302.0000, 'ºC'),
	(161208, 122, '2014-01-15 00:12:49.000000', 'temperatura', 802.0000, 'ºC'),
	(161209, 122, '2014-01-15 00:12:50.000000', 'temperatura', 703.0000, 'ºC'),
	(161210, 122, '2014-01-15 00:12:51.000000', 'temperatura', 1112.0000, 'ºC'),
	(161211, 122, '2014-01-15 00:12:52.000000', 'temperatura', 1049.0000, 'ºC'),
	(161212, 122, '2014-01-15 00:12:53.000000', 'temperatura', 710.0000, 'ºC'),
	(161213, 122, '2014-01-15 00:12:54.000000', 'temperatura', 402.0000, 'ºC'),
	(161214, 122, '2014-01-15 00:12:55.000000', 'temperatura', 1083.0000, 'ºC'),
	(161215, 122, '2014-01-15 00:12:56.000000', 'temperatura', 607.0000, 'ºC'),
	(161216, 122, '2014-01-15 00:12:57.000000', 'temperatura', 988.0000, 'ºC'),
	(161217, 122, '2014-01-15 00:12:58.000000', 'temperatura', 719.0000, 'ºC'),
	(161218, 122, '2014-01-15 00:12:59.000000', 'temperatura', 631.0000, 'ºC'),
	(161219, 122, '2014-01-15 00:13:00.000000', 'temperatura', 1000.0000, 'ºC'),
	(161220, 122, '2014-01-15 00:13:01.000000', 'temperatura', 708.0000, 'ºC'),
	(161221, 122, '2014-01-15 00:13:02.000000', 'temperatura', 538.0000, 'ºC'),
	(161222, 122, '2014-01-15 00:13:03.000000', 'temperatura', 570.0000, 'ºC'),
	(161223, 122, '2014-01-15 00:13:04.000000', 'temperatura', 34.0000, 'ºC'),
	(161224, 122, '2014-01-15 00:13:05.000000', 'temperatura', 861.0000, 'ºC'),
	(161225, 122, '2014-01-15 00:13:06.000000', 'temperatura', 604.0000, 'ºC'),
	(161226, 122, '2014-01-15 00:13:07.000000', 'temperatura', 437.0000, 'ºC'),
	(161227, 122, '2014-01-15 00:13:08.000000', 'temperatura', 374.0000, 'ºC'),
	(161228, 122, '2014-01-15 00:13:09.000000', 'temperatura', 558.0000, 'ºC'),
	(161229, 122, '2014-01-15 00:13:10.000000', 'temperatura', 471.0000, 'ºC'),
	(161230, 122, '2014-01-15 00:13:11.000000', 'temperatura', 680.0000, 'ºC'),
	(161231, 122, '2014-01-15 00:13:12.000000', 'temperatura', 790.0000, 'ºC'),
	(161232, 122, '2014-01-15 00:13:13.000000', 'temperatura', 707.0000, 'ºC'),
	(161233, 122, '2014-01-15 00:13:14.000000', 'temperatura', 1167.0000, 'ºC'),
	(161234, 122, '2014-01-15 00:13:15.000000', 'temperatura', 114.0000, 'ºC'),
	(161235, 122, '2014-01-15 00:13:16.000000', 'temperatura', 668.0000, 'ºC'),
	(161236, 122, '2014-01-15 00:13:17.000000', 'temperatura', 601.0000, 'ºC'),
	(161237, 122, '2014-01-15 00:13:18.000000', 'temperatura', 999.0000, 'ºC'),
	(161238, 122, '2014-01-15 00:13:19.000000', 'temperatura', 795.0000, 'ºC'),
	(161239, 122, '2014-01-15 00:13:20.000000', 'temperatura', 979.0000, 'ºC'),
	(161240, 122, '2014-01-15 00:13:21.000000', 'temperatura', 109.0000, 'ºC'),
	(161241, 122, '2014-01-15 00:13:22.000000', 'temperatura', 10.0000, 'ºC'),
	(161242, 122, '2014-01-15 00:13:23.000000', 'temperatura', 924.0000, 'ºC'),
	(161243, 122, '2014-01-15 00:13:24.000000', 'temperatura', 988.0000, 'ºC'),
	(161244, 122, '2014-01-15 00:13:25.000000', 'temperatura', 972.0000, 'ºC'),
	(161245, 122, '2014-01-15 00:13:26.000000', 'temperatura', 693.0000, 'ºC'),
	(161246, 122, '2014-01-15 00:13:27.000000', 'temperatura', 552.0000, 'ºC'),
	(161247, 122, '2014-01-15 00:13:28.000000', 'temperatura', 680.0000, 'ºC'),
	(161248, 122, '2014-01-15 00:13:29.000000', 'temperatura', 546.0000, 'ºC'),
	(161249, 122, '2014-01-15 00:13:30.000000', 'temperatura', 688.0000, 'ºC'),
	(161250, 122, '2014-01-15 00:13:31.000000', 'temperatura', 604.0000, 'ºC'),
	(161251, 122, '2014-01-15 00:13:32.000000', 'temperatura', 955.0000, 'ºC'),
	(161252, 122, '2014-01-15 00:13:33.000000', 'temperatura', 565.0000, 'ºC'),
	(161253, 122, '2014-01-15 00:13:34.000000', 'temperatura', 1159.0000, 'ºC'),
	(161254, 122, '2014-01-15 00:13:35.000000', 'temperatura', 500.0000, 'ºC'),
	(161255, 122, '2014-01-15 00:13:36.000000', 'temperatura', 225.0000, 'ºC'),
	(161256, 122, '2014-01-15 00:13:37.000000', 'temperatura', 825.0000, 'ºC'),
	(161257, 122, '2014-01-15 00:13:38.000000', 'temperatura', 1049.0000, 'ºC'),
	(161258, 122, '2014-01-15 00:13:39.000000', 'temperatura', 373.0000, 'ºC'),
	(161259, 122, '2014-01-15 00:13:40.000000', 'temperatura', 1116.0000, 'ºC'),
	(161260, 122, '2014-01-15 00:13:41.000000', 'temperatura', 864.0000, 'ºC'),
	(161261, 122, '2014-01-15 00:13:42.000000', 'temperatura', 970.0000, 'ºC'),
	(161262, 122, '2014-01-15 00:13:43.000000', 'temperatura', 1061.0000, 'ºC'),
	(161263, 122, '2014-01-15 00:13:44.000000', 'temperatura', 1194.0000, 'ºC'),
	(161264, 122, '2014-01-15 00:13:45.000000', 'temperatura', 388.0000, 'ºC'),
	(161265, 122, '2014-01-15 00:13:46.000000', 'temperatura', 758.0000, 'ºC'),
	(161266, 122, '2014-01-15 00:13:47.000000', 'temperatura', 227.0000, 'ºC'),
	(161267, 122, '2014-01-15 00:13:48.000000', 'temperatura', 62.0000, 'ºC'),
	(161268, 122, '2014-01-15 00:13:49.000000', 'temperatura', 831.0000, 'ºC'),
	(161269, 122, '2014-01-15 00:13:50.000000', 'temperatura', 368.0000, 'ºC'),
	(161270, 122, '2014-01-15 00:13:51.000000', 'temperatura', 547.0000, 'ºC'),
	(161271, 122, '2014-01-15 00:13:52.000000', 'temperatura', 431.0000, 'ºC'),
	(161272, 122, '2014-01-15 00:13:53.000000', 'temperatura', 514.0000, 'ºC'),
	(161273, 122, '2014-01-15 00:13:54.000000', 'temperatura', 80.0000, 'ºC'),
	(161274, 122, '2014-01-15 00:13:55.000000', 'temperatura', 59.0000, 'ºC'),
	(161275, 122, '2014-01-15 00:13:56.000000', 'temperatura', 54.0000, 'ºC'),
	(161276, 122, '2014-01-15 00:13:57.000000', 'temperatura', 94.0000, 'ºC'),
	(161277, 122, '2014-01-15 00:13:58.000000', 'temperatura', 307.0000, 'ºC'),
	(161278, 122, '2014-01-15 00:13:59.000000', 'temperatura', 55.0000, 'ºC'),
	(161279, 122, '2014-01-15 00:14:00.000000', 'temperatura', 552.0000, 'ºC'),
	(161280, 122, '2014-01-15 00:14:01.000000', 'temperatura', 197.0000, 'ºC'),
	(161281, 122, '2014-01-15 00:14:02.000000', 'temperatura', 530.0000, 'ºC'),
	(161282, 122, '2014-01-15 00:14:03.000000', 'temperatura', 858.0000, 'ºC'),
	(161283, 122, '2014-01-15 00:14:04.000000', 'temperatura', 302.0000, 'ºC'),
	(161284, 122, '2014-01-15 00:14:05.000000', 'temperatura', 135.0000, 'ºC'),
	(161285, 122, '2014-01-15 00:14:06.000000', 'temperatura', 970.0000, 'ºC'),
	(161286, 122, '2014-01-15 00:14:07.000000', 'temperatura', 845.0000, 'ºC'),
	(161287, 122, '2014-01-15 00:14:08.000000', 'temperatura', 118.0000, 'ºC'),
	(161288, 122, '2014-01-15 00:14:09.000000', 'temperatura', 452.0000, 'ºC'),
	(161289, 122, '2014-01-15 00:14:10.000000', 'temperatura', 708.0000, 'ºC'),
	(161290, 122, '2014-01-15 00:14:11.000000', 'temperatura', 985.0000, 'ºC'),
	(161291, 122, '2014-01-15 00:14:12.000000', 'temperatura', 399.0000, 'ºC'),
	(161292, 122, '2014-01-15 00:14:13.000000', 'temperatura', 242.0000, 'ºC'),
	(161293, 122, '2014-01-15 00:14:14.000000', 'temperatura', 15.0000, 'ºC'),
	(161294, 122, '2014-01-15 00:14:15.000000', 'temperatura', 549.0000, 'ºC'),
	(161295, 122, '2014-01-15 00:14:16.000000', 'temperatura', 301.0000, 'ºC'),
	(161296, 122, '2014-01-15 00:14:17.000000', 'temperatura', 1056.0000, 'ºC'),
	(161297, 122, '2014-01-15 00:14:18.000000', 'temperatura', 779.0000, 'ºC'),
	(161298, 122, '2014-01-15 00:14:19.000000', 'temperatura', 727.0000, 'ºC'),
	(161299, 122, '2014-01-15 00:14:20.000000', 'temperatura', 100.0000, 'ºC'),
	(161300, 122, '2014-01-15 00:14:21.000000', 'temperatura', 717.0000, 'ºC'),
	(161301, 122, '2014-01-15 00:14:22.000000', 'temperatura', 885.0000, 'ºC'),
	(161302, 122, '2014-01-15 00:14:23.000000', 'temperatura', 1077.0000, 'ºC'),
	(161303, 122, '2014-01-15 00:14:24.000000', 'temperatura', 328.0000, 'ºC'),
	(161304, 122, '2014-01-15 00:14:25.000000', 'temperatura', 810.0000, 'ºC'),
	(161305, 122, '2014-01-15 00:14:26.000000', 'temperatura', 668.0000, 'ºC'),
	(161306, 122, '2014-01-15 00:14:27.000000', 'temperatura', 908.0000, 'ºC'),
	(161307, 122, '2014-01-15 00:14:28.000000', 'temperatura', 139.0000, 'ºC'),
	(161308, 122, '2014-01-15 00:14:29.000000', 'temperatura', 370.0000, 'ºC'),
	(161309, 122, '2014-01-15 00:14:30.000000', 'temperatura', 234.0000, 'ºC'),
	(161310, 122, '2014-01-15 00:14:31.000000', 'temperatura', 59.0000, 'ºC'),
	(161311, 122, '2014-01-15 00:14:32.000000', 'temperatura', 794.0000, 'ºC'),
	(161312, 122, '2014-01-15 00:14:33.000000', 'temperatura', 193.0000, 'ºC'),
	(161313, 122, '2014-01-15 00:14:34.000000', 'temperatura', 984.0000, 'ºC'),
	(161314, 122, '2014-01-15 00:14:35.000000', 'temperatura', 742.0000, 'ºC'),
	(161315, 122, '2014-01-15 00:14:36.000000', 'temperatura', 756.0000, 'ºC'),
	(161316, 122, '2014-01-15 00:14:37.000000', 'temperatura', 357.0000, 'ºC'),
	(161317, 122, '2014-01-15 00:14:38.000000', 'temperatura', 717.0000, 'ºC'),
	(161318, 122, '2014-01-15 00:14:39.000000', 'temperatura', 115.0000, 'ºC'),
	(161319, 122, '2014-01-15 00:14:40.000000', 'temperatura', 825.0000, 'ºC'),
	(161320, 122, '2014-01-15 00:14:41.000000', 'temperatura', 179.0000, 'ºC'),
	(161321, 122, '2014-01-15 00:14:42.000000', 'temperatura', 821.0000, 'ºC'),
	(161322, 122, '2014-01-15 00:14:43.000000', 'temperatura', 1167.0000, 'ºC'),
	(161323, 122, '2014-01-15 00:14:44.000000', 'temperatura', 974.0000, 'ºC'),
	(161324, 122, '2014-01-15 00:14:45.000000', 'temperatura', 170.0000, 'ºC'),
	(161325, 122, '2014-01-15 00:14:46.000000', 'temperatura', 330.0000, 'ºC'),
	(161326, 122, '2014-01-15 00:14:47.000000', 'temperatura', 1139.0000, 'ºC'),
	(161327, 122, '2014-01-15 00:14:48.000000', 'temperatura', 1104.0000, 'ºC'),
	(161328, 122, '2014-01-15 00:14:49.000000', 'temperatura', 906.0000, 'ºC'),
	(161329, 122, '2014-01-15 00:14:50.000000', 'temperatura', 17.0000, 'ºC'),
	(161330, 122, '2014-01-15 00:14:51.000000', 'temperatura', 969.0000, 'ºC'),
	(161331, 122, '2014-01-15 00:14:52.000000', 'temperatura', 1195.0000, 'ºC'),
	(161332, 122, '2014-01-15 00:14:53.000000', 'temperatura', 666.0000, 'ºC'),
	(161333, 122, '2014-01-15 00:14:54.000000', 'temperatura', 949.0000, 'ºC'),
	(161334, 122, '2014-01-15 00:14:55.000000', 'temperatura', 345.0000, 'ºC'),
	(161335, 122, '2014-01-15 00:14:56.000000', 'temperatura', 77.0000, 'ºC'),
	(161336, 122, '2014-01-15 00:14:57.000000', 'temperatura', 553.0000, 'ºC'),
	(161337, 122, '2014-01-15 00:14:58.000000', 'temperatura', 132.0000, 'ºC'),
	(161338, 122, '2014-01-15 00:14:59.000000', 'temperatura', 202.0000, 'ºC'),
	(161339, 122, '2014-01-15 00:15:00.000000', 'temperatura', 617.0000, 'ºC'),
	(161340, 122, '2014-01-15 00:15:01.000000', 'temperatura', 76.0000, 'ºC'),
	(161341, 122, '2014-01-15 00:15:02.000000', 'temperatura', 932.0000, 'ºC'),
	(161342, 122, '2014-01-15 00:15:03.000000', 'temperatura', 834.0000, 'ºC'),
	(161343, 122, '2014-01-15 00:15:04.000000', 'temperatura', 171.0000, 'ºC'),
	(161344, 122, '2014-01-15 00:15:05.000000', 'temperatura', 756.0000, 'ºC'),
	(161345, 122, '2014-01-15 00:15:06.000000', 'temperatura', 869.0000, 'ºC'),
	(161346, 122, '2014-01-15 00:15:07.000000', 'temperatura', 874.0000, 'ºC'),
	(161347, 122, '2014-01-15 00:15:08.000000', 'temperatura', 564.0000, 'ºC'),
	(161348, 122, '2014-01-15 00:15:09.000000', 'temperatura', 199.0000, 'ºC'),
	(161349, 122, '2014-01-15 00:15:10.000000', 'temperatura', 504.0000, 'ºC'),
	(161350, 122, '2014-01-15 00:15:11.000000', 'temperatura', 722.0000, 'ºC'),
	(161351, 122, '2014-01-15 00:15:12.000000', 'temperatura', 899.0000, 'ºC'),
	(161352, 122, '2014-01-15 00:15:13.000000', 'temperatura', 1132.0000, 'ºC'),
	(161353, 122, '2014-01-15 00:15:14.000000', 'temperatura', 560.0000, 'ºC'),
	(161354, 122, '2014-01-15 00:15:15.000000', 'temperatura', 606.0000, 'ºC'),
	(161355, 122, '2014-01-15 00:15:16.000000', 'temperatura', 152.0000, 'ºC'),
	(161356, 122, '2014-01-15 00:15:17.000000', 'temperatura', 140.0000, 'ºC'),
	(161357, 122, '2014-01-15 00:15:18.000000', 'temperatura', 244.0000, 'ºC'),
	(161358, 122, '2014-01-15 00:15:19.000000', 'temperatura', 801.0000, 'ºC'),
	(161359, 122, '2014-01-15 00:15:20.000000', 'temperatura', 875.0000, 'ºC'),
	(161360, 122, '2014-01-15 00:15:21.000000', 'temperatura', 770.0000, 'ºC'),
	(161361, 122, '2014-01-15 00:15:22.000000', 'temperatura', 29.0000, 'ºC'),
	(161362, 122, '2014-01-15 00:15:23.000000', 'temperatura', 232.0000, 'ºC'),
	(161363, 122, '2014-01-15 00:15:24.000000', 'temperatura', 1075.0000, 'ºC'),
	(161364, 122, '2014-01-15 00:15:25.000000', 'temperatura', 1080.0000, 'ºC'),
	(161365, 122, '2014-01-15 00:15:26.000000', 'temperatura', 976.0000, 'ºC'),
	(161366, 122, '2014-01-15 00:15:27.000000', 'temperatura', 440.0000, 'ºC'),
	(161367, 122, '2014-01-15 00:15:28.000000', 'temperatura', 470.0000, 'ºC'),
	(161368, 122, '2014-01-15 00:15:29.000000', 'temperatura', 1034.0000, 'ºC'),
	(161369, 122, '2014-01-15 00:15:30.000000', 'temperatura', 158.0000, 'ºC'),
	(161370, 122, '2014-01-15 00:15:31.000000', 'temperatura', 89.0000, 'ºC'),
	(161371, 122, '2014-01-15 00:15:32.000000', 'temperatura', 1172.0000, 'ºC'),
	(161372, 122, '2014-01-15 00:15:33.000000', 'temperatura', 794.0000, 'ºC'),
	(161373, 122, '2014-01-15 00:15:34.000000', 'temperatura', 454.0000, 'ºC'),
	(161374, 122, '2014-01-15 00:15:35.000000', 'temperatura', 1089.0000, 'ºC'),
	(161375, 122, '2014-01-15 00:15:36.000000', 'temperatura', 483.0000, 'ºC'),
	(161376, 122, '2014-01-15 00:15:37.000000', 'temperatura', 351.0000, 'ºC'),
	(161377, 122, '2014-01-15 00:15:38.000000', 'temperatura', 303.0000, 'ºC'),
	(161378, 122, '2014-01-15 00:15:39.000000', 'temperatura', 466.0000, 'ºC'),
	(161379, 122, '2014-01-15 00:15:40.000000', 'temperatura', 219.0000, 'ºC'),
	(161380, 122, '2014-01-15 00:15:41.000000', 'temperatura', 900.0000, 'ºC'),
	(161381, 122, '2014-01-15 00:15:42.000000', 'temperatura', 243.0000, 'ºC'),
	(161382, 122, '2014-01-15 00:15:43.000000', 'temperatura', 914.0000, 'ºC'),
	(161383, 122, '2014-01-15 00:15:44.000000', 'temperatura', 242.0000, 'ºC'),
	(161384, 122, '2014-01-15 00:15:45.000000', 'temperatura', 869.0000, 'ºC'),
	(161385, 122, '2014-01-15 00:15:46.000000', 'temperatura', 21.0000, 'ºC'),
	(161386, 122, '2014-01-15 00:15:47.000000', 'temperatura', 1096.0000, 'ºC'),
	(161387, 122, '2014-01-15 00:15:48.000000', 'temperatura', 619.0000, 'ºC'),
	(161388, 122, '2014-01-15 00:15:49.000000', 'temperatura', 1008.0000, 'ºC'),
	(161389, 122, '2014-01-15 00:15:50.000000', 'temperatura', 784.0000, 'ºC'),
	(161390, 122, '2014-01-15 00:15:51.000000', 'temperatura', 896.0000, 'ºC'),
	(161391, 122, '2014-01-15 00:15:52.000000', 'temperatura', 928.0000, 'ºC'),
	(161392, 122, '2014-01-15 00:15:53.000000', 'temperatura', 753.0000, 'ºC'),
	(161393, 122, '2014-01-15 00:15:54.000000', 'temperatura', 983.0000, 'ºC'),
	(161394, 122, '2014-01-15 00:15:55.000000', 'temperatura', 254.0000, 'ºC'),
	(161395, 122, '2014-01-15 00:15:56.000000', 'temperatura', 723.0000, 'ºC'),
	(161396, 122, '2014-01-15 00:15:57.000000', 'temperatura', 454.0000, 'ºC'),
	(161397, 122, '2014-01-15 00:15:58.000000', 'temperatura', 103.0000, 'ºC'),
	(161398, 122, '2014-01-15 00:15:59.000000', 'temperatura', 351.0000, 'ºC'),
	(161399, 122, '2014-01-15 00:16:00.000000', 'temperatura', 245.0000, 'ºC'),
	(161400, 122, '2014-01-15 00:16:01.000000', 'temperatura', 175.0000, 'ºC'),
	(161401, 122, '2014-01-15 00:16:02.000000', 'temperatura', 140.0000, 'ºC'),
	(161402, 122, '2014-01-15 00:16:03.000000', 'temperatura', 177.0000, 'ºC'),
	(161403, 122, '2014-01-15 00:16:04.000000', 'temperatura', 463.0000, 'ºC'),
	(161404, 122, '2014-01-15 00:16:05.000000', 'temperatura', 584.0000, 'ºC'),
	(161405, 122, '2014-01-15 00:16:06.000000', 'temperatura', 332.0000, 'ºC'),
	(161406, 122, '2014-01-15 00:16:07.000000', 'temperatura', 1110.0000, 'ºC'),
	(161407, 122, '2014-01-15 00:16:08.000000', 'temperatura', 954.0000, 'ºC'),
	(161408, 122, '2014-01-15 00:16:09.000000', 'temperatura', 242.0000, 'ºC'),
	(161409, 122, '2014-01-15 00:16:10.000000', 'temperatura', 749.0000, 'ºC'),
	(161410, 122, '2014-01-15 00:16:11.000000', 'temperatura', 617.0000, 'ºC'),
	(161411, 122, '2014-01-15 00:16:12.000000', 'temperatura', 841.0000, 'ºC'),
	(161412, 122, '2014-01-15 00:16:13.000000', 'temperatura', 1156.0000, 'ºC'),
	(161413, 122, '2014-01-15 00:16:14.000000', 'temperatura', 854.0000, 'ºC'),
	(161414, 122, '2014-01-15 00:16:15.000000', 'temperatura', 802.0000, 'ºC'),
	(161415, 122, '2014-01-15 00:16:16.000000', 'temperatura', 251.0000, 'ºC'),
	(161416, 122, '2014-01-15 00:16:17.000000', 'temperatura', 50.0000, 'ºC'),
	(161417, 122, '2014-01-15 00:16:18.000000', 'temperatura', 697.0000, 'ºC'),
	(161418, 122, '2014-01-15 00:16:19.000000', 'temperatura', 934.0000, 'ºC'),
	(161419, 122, '2014-01-15 00:16:20.000000', 'temperatura', 179.0000, 'ºC'),
	(161420, 122, '2014-01-15 00:16:21.000000', 'temperatura', 496.0000, 'ºC'),
	(161421, 122, '2014-01-15 00:16:22.000000', 'temperatura', 741.0000, 'ºC'),
	(161422, 122, '2014-01-15 00:16:23.000000', 'temperatura', 1018.0000, 'ºC'),
	(161423, 122, '2014-01-15 00:16:24.000000', 'temperatura', 469.0000, 'ºC'),
	(161424, 122, '2014-01-15 00:16:25.000000', 'temperatura', 490.0000, 'ºC'),
	(161425, 122, '2014-01-15 00:16:26.000000', 'temperatura', 1044.0000, 'ºC'),
	(161426, 122, '2014-01-15 00:16:27.000000', 'temperatura', 149.0000, 'ºC'),
	(161427, 122, '2014-01-15 00:16:28.000000', 'temperatura', 14.0000, 'ºC'),
	(161428, 122, '2014-01-15 00:16:29.000000', 'temperatura', 825.0000, 'ºC'),
	(161429, 122, '2014-01-15 00:16:30.000000', 'temperatura', 481.0000, 'ºC'),
	(161430, 122, '2014-01-15 00:16:31.000000', 'temperatura', 1131.0000, 'ºC'),
	(161431, 122, '2014-01-15 00:16:32.000000', 'temperatura', 615.0000, 'ºC'),
	(161432, 122, '2014-01-15 00:16:33.000000', 'temperatura', 882.0000, 'ºC'),
	(161433, 122, '2014-01-15 00:16:34.000000', 'temperatura', 163.0000, 'ºC'),
	(161434, 122, '2014-01-15 00:16:35.000000', 'temperatura', 570.0000, 'ºC'),
	(161435, 122, '2014-01-15 00:16:36.000000', 'temperatura', 1162.0000, 'ºC'),
	(161436, 122, '2014-01-15 00:16:37.000000', 'temperatura', 499.0000, 'ºC'),
	(161437, 122, '2014-01-15 00:16:38.000000', 'temperatura', 212.0000, 'ºC'),
	(161438, 122, '2014-01-15 00:16:39.000000', 'temperatura', 763.0000, 'ºC'),
	(161439, 122, '2014-01-15 00:16:40.000000', 'temperatura', 780.0000, 'ºC'),
	(161440, 122, '2014-01-15 00:16:41.000000', 'temperatura', 412.0000, 'ºC'),
	(161441, 122, '2014-01-15 00:16:42.000000', 'temperatura', 919.0000, 'ºC'),
	(161442, 122, '2014-01-15 00:16:43.000000', 'temperatura', 960.0000, 'ºC'),
	(161443, 122, '2014-01-15 00:16:44.000000', 'temperatura', 842.0000, 'ºC'),
	(161444, 122, '2014-01-15 00:16:45.000000', 'temperatura', 133.0000, 'ºC'),
	(161445, 122, '2014-01-15 00:16:46.000000', 'temperatura', 541.0000, 'ºC'),
	(161446, 122, '2014-01-15 00:16:47.000000', 'temperatura', 1103.0000, 'ºC'),
	(161447, 122, '2014-01-15 00:16:48.000000', 'temperatura', 293.0000, 'ºC'),
	(161448, 122, '2014-01-15 00:16:49.000000', 'temperatura', 557.0000, 'ºC'),
	(161449, 122, '2014-01-15 00:16:50.000000', 'temperatura', 708.0000, 'ºC'),
	(161450, 122, '2014-01-15 00:16:51.000000', 'temperatura', 668.0000, 'ºC'),
	(161451, 122, '2014-01-15 00:16:52.000000', 'temperatura', 18.0000, 'ºC'),
	(161452, 122, '2014-01-15 00:16:53.000000', 'temperatura', 485.0000, 'ºC'),
	(161453, 122, '2014-01-15 00:16:54.000000', 'temperatura', 1173.0000, 'ºC'),
	(161454, 122, '2014-01-15 00:16:55.000000', 'temperatura', 811.0000, 'ºC'),
	(161455, 122, '2014-01-15 00:16:56.000000', 'temperatura', 534.0000, 'ºC'),
	(161456, 122, '2014-01-15 00:16:57.000000', 'temperatura', 238.0000, 'ºC'),
	(161457, 122, '2014-01-15 00:16:58.000000', 'temperatura', 791.0000, 'ºC'),
	(161458, 122, '2014-01-15 00:16:59.000000', 'temperatura', 839.0000, 'ºC'),
	(161459, 122, '2014-01-15 00:17:00.000000', 'temperatura', 624.0000, 'ºC'),
	(161460, 122, '2014-01-15 00:17:01.000000', 'temperatura', 605.0000, 'ºC'),
	(161461, 122, '2014-01-15 00:17:02.000000', 'temperatura', 1151.0000, 'ºC'),
	(161462, 122, '2014-01-15 00:17:03.000000', 'temperatura', 342.0000, 'ºC'),
	(161463, 122, '2014-01-15 00:17:04.000000', 'temperatura', 656.0000, 'ºC'),
	(161464, 122, '2014-01-15 00:17:05.000000', 'temperatura', 1054.0000, 'ºC'),
	(161465, 122, '2014-01-15 00:17:06.000000', 'temperatura', 902.0000, 'ºC'),
	(161466, 122, '2014-01-15 00:17:07.000000', 'temperatura', 147.0000, 'ºC'),
	(161467, 122, '2014-01-15 00:17:08.000000', 'temperatura', 433.0000, 'ºC'),
	(161468, 122, '2014-01-15 00:17:09.000000', 'temperatura', 524.0000, 'ºC'),
	(161469, 122, '2014-01-15 00:17:10.000000', 'temperatura', 122.0000, 'ºC'),
	(161470, 122, '2014-01-15 00:17:11.000000', 'temperatura', 238.0000, 'ºC'),
	(161471, 122, '2014-01-15 00:17:12.000000', 'temperatura', 823.0000, 'ºC'),
	(161472, 122, '2014-01-15 00:17:13.000000', 'temperatura', 1004.0000, 'ºC'),
	(161473, 122, '2014-01-15 00:17:14.000000', 'temperatura', 152.0000, 'ºC'),
	(161474, 122, '2014-01-15 00:17:15.000000', 'temperatura', 146.0000, 'ºC'),
	(161475, 122, '2014-01-15 00:17:16.000000', 'temperatura', 274.0000, 'ºC'),
	(161476, 122, '2014-01-15 00:17:17.000000', 'temperatura', 933.0000, 'ºC'),
	(161477, 122, '2014-01-15 00:17:18.000000', 'temperatura', 243.0000, 'ºC'),
	(161478, 122, '2014-01-15 00:17:19.000000', 'temperatura', 817.0000, 'ºC'),
	(161479, 122, '2014-01-15 00:17:20.000000', 'temperatura', 955.0000, 'ºC'),
	(161480, 122, '2014-01-15 00:17:21.000000', 'temperatura', 1125.0000, 'ºC'),
	(161481, 122, '2014-01-15 00:17:22.000000', 'temperatura', 361.0000, 'ºC'),
	(161482, 122, '2014-01-15 00:17:23.000000', 'temperatura', 831.0000, 'ºC'),
	(161483, 122, '2014-01-15 00:17:24.000000', 'temperatura', 672.0000, 'ºC'),
	(161484, 122, '2014-01-15 00:17:25.000000', 'temperatura', 868.0000, 'ºC'),
	(161485, 122, '2014-01-15 00:17:26.000000', 'temperatura', 1123.0000, 'ºC'),
	(161486, 122, '2014-01-15 00:17:27.000000', 'temperatura', 614.0000, 'ºC'),
	(161487, 122, '2014-01-15 00:17:28.000000', 'temperatura', 900.0000, 'ºC'),
	(161488, 122, '2014-01-15 00:17:29.000000', 'temperatura', 258.0000, 'ºC'),
	(161489, 122, '2014-01-15 00:17:30.000000', 'temperatura', 992.0000, 'ºC'),
	(161490, 122, '2014-01-15 00:17:31.000000', 'temperatura', 588.0000, 'ºC'),
	(161491, 122, '2014-01-15 00:17:32.000000', 'temperatura', 1162.0000, 'ºC'),
	(161492, 122, '2014-01-15 00:17:33.000000', 'temperatura', 449.0000, 'ºC'),
	(161493, 122, '2014-01-15 00:17:34.000000', 'temperatura', 1158.0000, 'ºC'),
	(161494, 122, '2014-01-15 00:17:35.000000', 'temperatura', 845.0000, 'ºC'),
	(161495, 122, '2014-01-15 00:17:36.000000', 'temperatura', 753.0000, 'ºC'),
	(161496, 122, '2014-01-15 00:17:37.000000', 'temperatura', 27.0000, 'ºC'),
	(161497, 122, '2014-01-15 00:17:38.000000', 'temperatura', 277.0000, 'ºC'),
	(161498, 122, '2014-01-15 00:17:39.000000', 'temperatura', 105.0000, 'ºC'),
	(161499, 122, '2014-01-15 00:17:40.000000', 'temperatura', 897.0000, 'ºC'),
	(161500, 122, '2014-01-15 00:17:41.000000', 'temperatura', 567.0000, 'ºC'),
	(161501, 122, '2014-01-15 00:17:42.000000', 'temperatura', 146.0000, 'ºC'),
	(161502, 122, '2014-01-15 00:17:43.000000', 'temperatura', 227.0000, 'ºC'),
	(161503, 122, '2014-01-15 00:17:44.000000', 'temperatura', 700.0000, 'ºC'),
	(161504, 122, '2014-01-15 00:17:45.000000', 'temperatura', 419.0000, 'ºC'),
	(161505, 122, '2014-01-15 00:17:46.000000', 'temperatura', 1195.0000, 'ºC'),
	(161506, 122, '2014-01-15 00:17:47.000000', 'temperatura', 1117.0000, 'ºC'),
	(161507, 122, '2014-01-15 00:17:48.000000', 'temperatura', 804.0000, 'ºC'),
	(161508, 122, '2014-01-15 00:17:49.000000', 'temperatura', 666.0000, 'ºC'),
	(161509, 122, '2014-01-15 00:17:50.000000', 'temperatura', 921.0000, 'ºC'),
	(161510, 122, '2014-01-15 00:17:51.000000', 'temperatura', 206.0000, 'ºC'),
	(161511, 122, '2014-01-15 00:17:52.000000', 'temperatura', 670.0000, 'ºC'),
	(161512, 122, '2014-01-15 00:17:53.000000', 'temperatura', 330.0000, 'ºC'),
	(161513, 122, '2014-01-15 00:17:54.000000', 'temperatura', 839.0000, 'ºC'),
	(161514, 122, '2014-01-15 00:17:55.000000', 'temperatura', 808.0000, 'ºC'),
	(161515, 122, '2014-01-15 00:17:56.000000', 'temperatura', 324.0000, 'ºC'),
	(161516, 122, '2014-01-15 00:17:57.000000', 'temperatura', 397.0000, 'ºC'),
	(161517, 122, '2014-01-15 00:17:58.000000', 'temperatura', 1014.0000, 'ºC'),
	(161518, 122, '2014-01-15 00:17:59.000000', 'temperatura', 277.0000, 'ºC'),
	(161519, 122, '2014-01-15 00:18:00.000000', 'temperatura', 743.0000, 'ºC'),
	(161520, 122, '2014-01-15 00:18:01.000000', 'temperatura', 487.0000, 'ºC'),
	(161521, 122, '2014-01-15 00:18:02.000000', 'temperatura', 206.0000, 'ºC'),
	(161522, 122, '2014-01-15 00:18:03.000000', 'temperatura', 770.0000, 'ºC'),
	(161523, 122, '2014-01-15 00:18:04.000000', 'temperatura', 832.0000, 'ºC'),
	(161524, 122, '2014-01-15 00:18:05.000000', 'temperatura', 652.0000, 'ºC'),
	(161525, 122, '2014-01-15 00:18:06.000000', 'temperatura', 763.0000, 'ºC'),
	(161526, 122, '2014-01-15 00:18:07.000000', 'temperatura', 660.0000, 'ºC'),
	(161527, 122, '2014-01-15 00:18:08.000000', 'temperatura', 1011.0000, 'ºC'),
	(161528, 122, '2014-01-15 00:18:09.000000', 'temperatura', 676.0000, 'ºC'),
	(161529, 122, '2014-01-15 00:18:10.000000', 'temperatura', 347.0000, 'ºC'),
	(161530, 122, '2014-01-15 00:18:11.000000', 'temperatura', 910.0000, 'ºC'),
	(161531, 122, '2014-01-15 00:18:12.000000', 'temperatura', 1106.0000, 'ºC'),
	(161532, 122, '2014-01-15 00:18:13.000000', 'temperatura', 403.0000, 'ºC'),
	(161533, 122, '2014-01-15 00:18:14.000000', 'temperatura', 1098.0000, 'ºC'),
	(161534, 122, '2014-01-15 00:18:15.000000', 'temperatura', 679.0000, 'ºC'),
	(161535, 122, '2014-01-15 00:18:16.000000', 'temperatura', 101.0000, 'ºC'),
	(161536, 122, '2014-01-15 00:18:17.000000', 'temperatura', 868.0000, 'ºC'),
	(161537, 122, '2014-01-15 00:18:18.000000', 'temperatura', 437.0000, 'ºC'),
	(161538, 122, '2014-01-15 00:18:19.000000', 'temperatura', 784.0000, 'ºC'),
	(161539, 122, '2014-01-15 00:18:20.000000', 'temperatura', 208.0000, 'ºC'),
	(161540, 122, '2014-01-15 00:18:21.000000', 'temperatura', 1088.0000, 'ºC'),
	(161541, 122, '2014-01-15 00:18:22.000000', 'temperatura', 16.0000, 'ºC'),
	(161542, 122, '2014-01-15 00:18:23.000000', 'temperatura', 419.0000, 'ºC'),
	(161543, 122, '2014-01-15 00:18:24.000000', 'temperatura', 847.0000, 'ºC'),
	(161544, 122, '2014-01-15 00:18:25.000000', 'temperatura', 580.0000, 'ºC'),
	(161545, 122, '2014-01-15 00:18:26.000000', 'temperatura', 357.0000, 'ºC'),
	(161546, 122, '2014-01-15 00:18:27.000000', 'temperatura', 44.0000, 'ºC'),
	(161547, 122, '2014-01-15 00:18:28.000000', 'temperatura', 353.0000, 'ºC'),
	(161548, 122, '2014-01-15 00:18:29.000000', 'temperatura', 432.0000, 'ºC'),
	(161549, 122, '2014-01-15 00:18:30.000000', 'temperatura', 1101.0000, 'ºC'),
	(161550, 122, '2014-01-15 00:18:31.000000', 'temperatura', 609.0000, 'ºC'),
	(161551, 122, '2014-01-15 00:18:32.000000', 'temperatura', 942.0000, 'ºC'),
	(161552, 122, '2014-01-15 00:18:33.000000', 'temperatura', 484.0000, 'ºC'),
	(161553, 122, '2014-01-15 00:18:34.000000', 'temperatura', 794.0000, 'ºC'),
	(161554, 122, '2014-01-15 00:18:35.000000', 'temperatura', 119.0000, 'ºC'),
	(161555, 122, '2014-01-15 00:18:36.000000', 'temperatura', 615.0000, 'ºC'),
	(161556, 122, '2014-01-15 00:18:37.000000', 'temperatura', 316.0000, 'ºC'),
	(161557, 122, '2014-01-15 00:18:38.000000', 'temperatura', 937.0000, 'ºC'),
	(161558, 122, '2014-01-15 00:18:39.000000', 'temperatura', 138.0000, 'ºC'),
	(161559, 122, '2014-01-15 00:18:40.000000', 'temperatura', 278.0000, 'ºC'),
	(161560, 122, '2014-01-15 00:18:41.000000', 'temperatura', 978.0000, 'ºC'),
	(161561, 122, '2014-01-15 00:18:42.000000', 'temperatura', 455.0000, 'ºC'),
	(161562, 122, '2014-01-15 00:18:43.000000', 'temperatura', 542.0000, 'ºC'),
	(161563, 122, '2014-01-15 00:18:44.000000', 'temperatura', 145.0000, 'ºC'),
	(161564, 122, '2014-01-15 00:18:45.000000', 'temperatura', 299.0000, 'ºC'),
	(161565, 122, '2014-01-15 00:18:46.000000', 'temperatura', 1062.0000, 'ºC'),
	(161566, 122, '2014-01-15 00:18:47.000000', 'temperatura', 812.0000, 'ºC'),
	(161567, 122, '2014-01-15 00:18:48.000000', 'temperatura', 875.0000, 'ºC'),
	(161568, 122, '2014-01-15 00:18:49.000000', 'temperatura', 739.0000, 'ºC'),
	(161569, 122, '2014-01-15 00:18:50.000000', 'temperatura', 1070.0000, 'ºC'),
	(161570, 122, '2014-01-15 00:18:51.000000', 'temperatura', 732.0000, 'ºC'),
	(161571, 122, '2014-01-15 00:18:52.000000', 'temperatura', 454.0000, 'ºC'),
	(161572, 122, '2014-01-15 00:18:53.000000', 'temperatura', 71.0000, 'ºC'),
	(161573, 122, '2014-01-15 00:18:54.000000', 'temperatura', 197.0000, 'ºC'),
	(161574, 122, '2014-01-15 00:18:55.000000', 'temperatura', 771.0000, 'ºC'),
	(161575, 122, '2014-01-15 00:18:56.000000', 'temperatura', 865.0000, 'ºC'),
	(161576, 122, '2014-01-15 00:18:57.000000', 'temperatura', 812.0000, 'ºC'),
	(161577, 122, '2014-01-15 00:18:58.000000', 'temperatura', 267.0000, 'ºC'),
	(161578, 122, '2014-01-15 00:18:59.000000', 'temperatura', 97.0000, 'ºC'),
	(161579, 122, '2014-01-15 00:19:00.000000', 'temperatura', 888.0000, 'ºC'),
	(161580, 122, '2014-01-15 00:19:01.000000', 'temperatura', 546.0000, 'ºC'),
	(161581, 122, '2014-01-15 00:19:02.000000', 'temperatura', 67.0000, 'ºC'),
	(161582, 122, '2014-01-15 00:19:03.000000', 'temperatura', 1096.0000, 'ºC'),
	(161583, 122, '2014-01-15 00:19:04.000000', 'temperatura', 482.0000, 'ºC'),
	(161584, 122, '2014-01-15 00:19:05.000000', 'temperatura', 322.0000, 'ºC'),
	(161585, 122, '2014-01-15 00:19:06.000000', 'temperatura', 165.0000, 'ºC'),
	(161586, 122, '2014-01-15 00:19:07.000000', 'temperatura', 1057.0000, 'ºC'),
	(161587, 122, '2014-01-15 00:19:08.000000', 'temperatura', 1193.0000, 'ºC'),
	(161588, 122, '2014-01-15 00:19:09.000000', 'temperatura', 392.0000, 'ºC'),
	(161589, 122, '2014-01-15 00:19:10.000000', 'temperatura', 782.0000, 'ºC'),
	(161590, 122, '2014-01-15 00:19:11.000000', 'temperatura', 333.0000, 'ºC'),
	(161591, 122, '2014-01-15 00:19:12.000000', 'temperatura', 522.0000, 'ºC'),
	(161592, 122, '2014-01-15 00:19:13.000000', 'temperatura', 412.0000, 'ºC'),
	(161593, 122, '2014-01-15 00:19:14.000000', 'temperatura', 493.0000, 'ºC'),
	(161594, 122, '2014-01-15 00:19:15.000000', 'temperatura', 29.0000, 'ºC'),
	(161595, 122, '2014-01-15 00:19:16.000000', 'temperatura', 1065.0000, 'ºC'),
	(161596, 122, '2014-01-15 00:19:17.000000', 'temperatura', 442.0000, 'ºC'),
	(161597, 122, '2014-01-15 00:19:18.000000', 'temperatura', 214.0000, 'ºC'),
	(161598, 122, '2014-01-15 00:19:19.000000', 'temperatura', 943.0000, 'ºC'),
	(161599, 122, '2014-01-15 00:19:20.000000', 'temperatura', 474.0000, 'ºC'),
	(161600, 122, '2014-01-15 00:19:21.000000', 'temperatura', 741.0000, 'ºC'),
	(161601, 122, '2014-01-15 00:19:22.000000', 'temperatura', 1083.0000, 'ºC'),
	(161602, 122, '2014-01-15 00:19:23.000000', 'temperatura', 792.0000, 'ºC'),
	(161603, 122, '2014-01-15 00:19:24.000000', 'temperatura', 711.0000, 'ºC'),
	(161604, 122, '2014-01-15 00:19:25.000000', 'temperatura', 1181.0000, 'ºC'),
	(161605, 122, '2014-01-15 00:19:26.000000', 'temperatura', 170.0000, 'ºC'),
	(161606, 122, '2014-01-15 00:19:27.000000', 'temperatura', 911.0000, 'ºC'),
	(161607, 122, '2014-01-15 00:19:28.000000', 'temperatura', 444.0000, 'ºC'),
	(161608, 122, '2014-01-15 00:19:29.000000', 'temperatura', 686.0000, 'ºC'),
	(161609, 122, '2014-01-15 00:19:30.000000', 'temperatura', 899.0000, 'ºC'),
	(161610, 122, '2014-01-15 00:19:31.000000', 'temperatura', 38.0000, 'ºC'),
	(161611, 122, '2014-01-15 00:19:32.000000', 'temperatura', 1092.0000, 'ºC'),
	(161612, 122, '2014-01-15 00:19:33.000000', 'temperatura', 550.0000, 'ºC'),
	(161613, 122, '2014-01-15 00:19:34.000000', 'temperatura', 671.0000, 'ºC'),
	(161614, 122, '2014-01-15 00:19:35.000000', 'temperatura', 506.0000, 'ºC'),
	(161615, 122, '2014-01-15 00:19:36.000000', 'temperatura', 520.0000, 'ºC'),
	(161616, 122, '2014-01-15 00:19:37.000000', 'temperatura', 1079.0000, 'ºC'),
	(161617, 122, '2014-01-15 00:19:38.000000', 'temperatura', 238.0000, 'ºC'),
	(161618, 122, '2014-01-15 00:19:39.000000', 'temperatura', 351.0000, 'ºC'),
	(161619, 122, '2014-01-15 00:19:40.000000', 'temperatura', 1043.0000, 'ºC'),
	(161620, 122, '2014-01-15 00:19:41.000000', 'temperatura', 564.0000, 'ºC'),
	(161621, 122, '2014-01-15 00:19:42.000000', 'temperatura', 891.0000, 'ºC'),
	(161622, 122, '2014-01-15 00:19:43.000000', 'temperatura', 363.0000, 'ºC'),
	(161623, 122, '2014-01-15 00:19:44.000000', 'temperatura', 343.0000, 'ºC'),
	(161624, 122, '2014-01-15 00:19:45.000000', 'temperatura', 626.0000, 'ºC'),
	(161625, 122, '2014-01-15 00:19:46.000000', 'temperatura', 902.0000, 'ºC'),
	(161626, 122, '2014-01-15 00:19:47.000000', 'temperatura', 232.0000, 'ºC'),
	(161627, 122, '2014-01-15 00:19:48.000000', 'temperatura', 856.0000, 'ºC'),
	(161628, 122, '2014-01-15 00:19:49.000000', 'temperatura', 1184.0000, 'ºC'),
	(161629, 122, '2014-01-15 00:19:50.000000', 'temperatura', 953.0000, 'ºC'),
	(161630, 122, '2014-01-15 00:19:51.000000', 'temperatura', 15.0000, 'ºC'),
	(161631, 122, '2014-01-15 00:19:52.000000', 'temperatura', 815.0000, 'ºC'),
	(161632, 122, '2014-01-15 00:19:53.000000', 'temperatura', 430.0000, 'ºC'),
	(161633, 122, '2014-01-15 00:19:54.000000', 'temperatura', 907.0000, 'ºC'),
	(161634, 122, '2014-01-15 00:19:55.000000', 'temperatura', 846.0000, 'ºC'),
	(161635, 122, '2014-01-15 00:19:56.000000', 'temperatura', 307.0000, 'ºC'),
	(161636, 122, '2014-01-15 00:19:57.000000', 'temperatura', 198.0000, 'ºC'),
	(161637, 122, '2014-01-15 00:19:58.000000', 'temperatura', 68.0000, 'ºC'),
	(161638, 122, '2014-01-15 00:19:59.000000', 'temperatura', 948.0000, 'ºC'),
	(161639, 122, '2014-01-15 00:20:00.000000', 'temperatura', 935.0000, 'ºC'),
	(161640, 122, '2014-01-15 00:20:01.000000', 'temperatura', 632.0000, 'ºC'),
	(161641, 122, '2014-01-15 00:20:02.000000', 'temperatura', 357.0000, 'ºC'),
	(161642, 122, '2014-01-15 00:20:03.000000', 'temperatura', 1087.0000, 'ºC'),
	(161643, 122, '2014-01-15 00:20:04.000000', 'temperatura', 766.0000, 'ºC'),
	(161644, 122, '2014-01-15 00:20:05.000000', 'temperatura', 568.0000, 'ºC'),
	(161645, 122, '2014-01-15 00:20:06.000000', 'temperatura', 544.0000, 'ºC'),
	(161646, 122, '2014-01-15 00:20:07.000000', 'temperatura', 1015.0000, 'ºC'),
	(161647, 122, '2014-01-15 00:20:08.000000', 'temperatura', 1046.0000, 'ºC'),
	(161648, 122, '2014-01-15 00:20:09.000000', 'temperatura', 985.0000, 'ºC'),
	(161649, 122, '2014-01-15 00:20:10.000000', 'temperatura', 585.0000, 'ºC'),
	(161650, 122, '2014-01-15 00:20:11.000000', 'temperatura', 1171.0000, 'ºC'),
	(161651, 122, '2014-01-15 00:20:12.000000', 'temperatura', 502.0000, 'ºC'),
	(161652, 122, '2014-01-15 00:20:13.000000', 'temperatura', 199.0000, 'ºC'),
	(161653, 122, '2014-01-15 00:20:14.000000', 'temperatura', 688.0000, 'ºC'),
	(161654, 122, '2014-01-15 00:20:15.000000', 'temperatura', 444.0000, 'ºC'),
	(161655, 122, '2014-01-15 00:20:16.000000', 'temperatura', 155.0000, 'ºC'),
	(161656, 122, '2014-01-15 00:20:17.000000', 'temperatura', 646.0000, 'ºC'),
	(161657, 122, '2014-01-15 00:20:18.000000', 'temperatura', 363.0000, 'ºC'),
	(161658, 122, '2014-01-15 00:20:19.000000', 'temperatura', 1077.0000, 'ºC'),
	(161659, 122, '2014-01-15 00:20:20.000000', 'temperatura', 696.0000, 'ºC'),
	(161660, 122, '2014-01-15 00:20:21.000000', 'temperatura', 249.0000, 'ºC'),
	(161661, 122, '2014-01-15 00:20:22.000000', 'temperatura', 360.0000, 'ºC'),
	(161662, 122, '2014-01-15 00:20:23.000000', 'temperatura', 1053.0000, 'ºC'),
	(161663, 122, '2014-01-15 00:20:24.000000', 'temperatura', 584.0000, 'ºC'),
	(161664, 122, '2014-01-15 00:20:25.000000', 'temperatura', 962.0000, 'ºC'),
	(161665, 122, '2014-01-15 00:20:26.000000', 'temperatura', 657.0000, 'ºC'),
	(161666, 122, '2014-01-15 00:20:27.000000', 'temperatura', 402.0000, 'ºC'),
	(161667, 122, '2014-01-15 00:20:28.000000', 'temperatura', 38.0000, 'ºC'),
	(161668, 122, '2014-01-15 00:20:29.000000', 'temperatura', 184.0000, 'ºC'),
	(161669, 122, '2014-01-15 00:20:30.000000', 'temperatura', 808.0000, 'ºC'),
	(161670, 122, '2014-01-15 00:20:31.000000', 'temperatura', 1088.0000, 'ºC'),
	(161671, 122, '2014-01-15 00:20:32.000000', 'temperatura', 617.0000, 'ºC'),
	(161672, 122, '2014-01-15 00:20:33.000000', 'temperatura', 1021.0000, 'ºC'),
	(161673, 122, '2014-01-15 00:20:34.000000', 'temperatura', 853.0000, 'ºC'),
	(161674, 122, '2014-01-15 00:20:35.000000', 'temperatura', 4.0000, 'ºC'),
	(161675, 122, '2014-01-15 00:20:36.000000', 'temperatura', 1060.0000, 'ºC'),
	(161676, 122, '2014-01-15 00:20:37.000000', 'temperatura', 491.0000, 'ºC'),
	(161677, 122, '2014-01-15 00:20:38.000000', 'temperatura', 475.0000, 'ºC'),
	(161678, 122, '2014-01-15 00:20:39.000000', 'temperatura', 904.0000, 'ºC'),
	(161679, 122, '2014-01-15 00:20:40.000000', 'temperatura', 694.0000, 'ºC'),
	(161680, 122, '2014-01-15 00:20:41.000000', 'temperatura', 760.0000, 'ºC'),
	(161681, 122, '2014-01-15 00:20:42.000000', 'temperatura', 520.0000, 'ºC'),
	(161682, 122, '2014-01-15 00:20:43.000000', 'temperatura', 317.0000, 'ºC'),
	(161683, 122, '2014-01-15 00:20:44.000000', 'temperatura', 27.0000, 'ºC'),
	(161684, 122, '2014-01-15 00:20:45.000000', 'temperatura', 385.0000, 'ºC'),
	(161685, 122, '2014-01-15 00:20:46.000000', 'temperatura', 643.0000, 'ºC'),
	(161686, 122, '2014-01-15 00:20:47.000000', 'temperatura', 860.0000, 'ºC'),
	(161687, 122, '2014-01-15 00:20:48.000000', 'temperatura', 1172.0000, 'ºC'),
	(161688, 122, '2014-01-15 00:20:49.000000', 'temperatura', 881.0000, 'ºC'),
	(161689, 122, '2014-01-15 00:20:50.000000', 'temperatura', 889.0000, 'ºC'),
	(161690, 122, '2014-01-15 00:20:51.000000', 'temperatura', 604.0000, 'ºC'),
	(161691, 122, '2014-01-15 00:20:52.000000', 'temperatura', 351.0000, 'ºC'),
	(161692, 122, '2014-01-15 00:20:53.000000', 'temperatura', 1146.0000, 'ºC'),
	(161693, 122, '2014-01-15 00:20:54.000000', 'temperatura', 1074.0000, 'ºC'),
	(161694, 122, '2014-01-15 00:20:55.000000', 'temperatura', 736.0000, 'ºC'),
	(161695, 122, '2014-01-15 00:20:56.000000', 'temperatura', 459.0000, 'ºC'),
	(161696, 122, '2014-01-15 00:20:57.000000', 'temperatura', 85.0000, 'ºC'),
	(161697, 122, '2014-01-15 00:20:58.000000', 'temperatura', 250.0000, 'ºC'),
	(161698, 122, '2014-01-15 00:20:59.000000', 'temperatura', 995.0000, 'ºC'),
	(161699, 122, '2014-01-15 00:21:00.000000', 'temperatura', 626.0000, 'ºC'),
	(161700, 122, '2014-01-15 00:21:01.000000', 'temperatura', 147.0000, 'ºC'),
	(161701, 122, '2014-01-15 00:21:02.000000', 'temperatura', 57.0000, 'ºC'),
	(161702, 122, '2014-01-15 00:21:03.000000', 'temperatura', 1043.0000, 'ºC'),
	(161703, 122, '2014-01-15 00:21:04.000000', 'temperatura', 246.0000, 'ºC'),
	(161704, 122, '2014-01-15 00:21:05.000000', 'temperatura', 501.0000, 'ºC'),
	(161705, 122, '2014-01-15 00:21:06.000000', 'temperatura', 569.0000, 'ºC'),
	(161706, 122, '2014-01-15 00:21:07.000000', 'temperatura', 141.0000, 'ºC'),
	(161707, 122, '2014-01-15 00:21:08.000000', 'temperatura', 197.0000, 'ºC'),
	(161708, 122, '2014-01-15 00:21:09.000000', 'temperatura', 564.0000, 'ºC'),
	(161709, 122, '2014-01-15 00:21:10.000000', 'temperatura', 1030.0000, 'ºC'),
	(161710, 122, '2014-01-15 00:21:11.000000', 'temperatura', 1059.0000, 'ºC'),
	(161711, 122, '2014-01-15 00:21:12.000000', 'temperatura', 1006.0000, 'ºC'),
	(161712, 122, '2014-01-15 00:21:13.000000', 'temperatura', 654.0000, 'ºC'),
	(161713, 122, '2014-01-15 00:21:14.000000', 'temperatura', 253.0000, 'ºC'),
	(161714, 122, '2014-01-15 00:21:15.000000', 'temperatura', 503.0000, 'ºC'),
	(161715, 122, '2014-01-15 00:21:16.000000', 'temperatura', 557.0000, 'ºC'),
	(161716, 122, '2014-01-15 00:21:17.000000', 'temperatura', 78.0000, 'ºC'),
	(161717, 122, '2014-01-15 00:21:18.000000', 'temperatura', 1117.0000, 'ºC'),
	(161718, 122, '2014-01-15 00:21:19.000000', 'temperatura', 553.0000, 'ºC'),
	(161719, 122, '2014-01-15 00:21:20.000000', 'temperatura', 614.0000, 'ºC'),
	(161720, 122, '2014-01-15 00:21:21.000000', 'temperatura', 211.0000, 'ºC'),
	(161721, 122, '2014-01-15 00:21:22.000000', 'temperatura', 415.0000, 'ºC'),
	(161722, 122, '2014-01-15 00:21:23.000000', 'temperatura', 244.0000, 'ºC'),
	(161723, 122, '2014-01-15 00:21:24.000000', 'temperatura', 1172.0000, 'ºC'),
	(161724, 122, '2014-01-15 00:21:25.000000', 'temperatura', 330.0000, 'ºC'),
	(161725, 122, '2014-01-15 00:21:26.000000', 'temperatura', 532.0000, 'ºC'),
	(161726, 122, '2014-01-15 00:21:27.000000', 'temperatura', 474.0000, 'ºC'),
	(161727, 122, '2014-01-15 00:21:28.000000', 'temperatura', 773.0000, 'ºC'),
	(161728, 122, '2014-01-15 00:21:29.000000', 'temperatura', 46.0000, 'ºC'),
	(161729, 122, '2014-01-15 00:21:30.000000', 'temperatura', 309.0000, 'ºC'),
	(161730, 122, '2014-01-15 00:21:31.000000', 'temperatura', 206.0000, 'ºC'),
	(161731, 122, '2014-01-15 00:21:32.000000', 'temperatura', 105.0000, 'ºC'),
	(161732, 122, '2014-01-15 00:21:33.000000', 'temperatura', 1109.0000, 'ºC'),
	(161733, 122, '2014-01-15 00:21:34.000000', 'temperatura', 431.0000, 'ºC'),
	(161734, 122, '2014-01-15 00:21:35.000000', 'temperatura', 29.0000, 'ºC'),
	(161735, 122, '2014-01-15 00:21:36.000000', 'temperatura', 51.0000, 'ºC'),
	(161736, 122, '2014-01-15 00:21:37.000000', 'temperatura', 170.0000, 'ºC'),
	(161737, 122, '2014-01-15 00:21:38.000000', 'temperatura', 696.0000, 'ºC'),
	(161738, 122, '2014-01-15 00:21:39.000000', 'temperatura', 572.0000, 'ºC'),
	(161739, 122, '2014-01-15 00:21:40.000000', 'temperatura', 774.0000, 'ºC'),
	(161740, 122, '2014-01-15 00:21:41.000000', 'temperatura', 952.0000, 'ºC'),
	(161741, 122, '2014-01-15 00:21:42.000000', 'temperatura', 39.0000, 'ºC'),
	(161742, 122, '2014-01-15 00:21:43.000000', 'temperatura', 938.0000, 'ºC'),
	(161743, 122, '2014-01-15 00:21:44.000000', 'temperatura', 973.0000, 'ºC'),
	(161744, 122, '2014-01-15 00:21:45.000000', 'temperatura', 853.0000, 'ºC'),
	(161745, 122, '2014-01-15 00:21:46.000000', 'temperatura', 144.0000, 'ºC'),
	(161746, 122, '2014-01-15 00:21:47.000000', 'temperatura', 564.0000, 'ºC'),
	(161747, 122, '2014-01-15 00:21:48.000000', 'temperatura', 1188.0000, 'ºC'),
	(161748, 122, '2014-01-15 00:21:49.000000', 'temperatura', 649.0000, 'ºC'),
	(161749, 122, '2014-01-15 00:21:50.000000', 'temperatura', 879.0000, 'ºC'),
	(161750, 122, '2014-01-15 00:21:51.000000', 'temperatura', 52.0000, 'ºC'),
	(161751, 122, '2014-01-15 00:21:52.000000', 'temperatura', 20.0000, 'ºC'),
	(161752, 122, '2014-01-15 00:21:53.000000', 'temperatura', 1147.0000, 'ºC'),
	(161753, 122, '2014-01-15 00:21:54.000000', 'temperatura', 875.0000, 'ºC'),
	(161754, 122, '2014-01-15 00:21:55.000000', 'temperatura', 935.0000, 'ºC'),
	(161755, 122, '2014-01-15 00:21:56.000000', 'temperatura', 851.0000, 'ºC'),
	(161756, 122, '2014-01-15 00:21:57.000000', 'temperatura', 248.0000, 'ºC'),
	(161757, 122, '2014-01-15 00:21:58.000000', 'temperatura', 1088.0000, 'ºC'),
	(161758, 122, '2014-01-15 00:21:59.000000', 'temperatura', 1098.0000, 'ºC'),
	(161759, 122, '2014-01-15 00:22:00.000000', 'temperatura', 1024.0000, 'ºC'),
	(161760, 122, '2014-01-15 00:22:01.000000', 'temperatura', 627.0000, 'ºC'),
	(161761, 122, '2014-01-15 00:22:02.000000', 'temperatura', 63.0000, 'ºC'),
	(161762, 122, '2014-01-15 00:22:03.000000', 'temperatura', 836.0000, 'ºC'),
	(161763, 122, '2014-01-15 00:22:04.000000', 'temperatura', 389.0000, 'ºC'),
	(161764, 122, '2014-01-15 00:22:05.000000', 'temperatura', 641.0000, 'ºC'),
	(161765, 122, '2014-01-15 00:22:06.000000', 'temperatura', 836.0000, 'ºC'),
	(161766, 122, '2014-01-15 00:22:07.000000', 'temperatura', 1059.0000, 'ºC'),
	(161767, 122, '2014-01-15 00:22:08.000000', 'temperatura', 388.0000, 'ºC'),
	(161768, 122, '2014-01-15 00:22:09.000000', 'temperatura', 1164.0000, 'ºC'),
	(161769, 122, '2014-01-15 00:22:10.000000', 'temperatura', 1054.0000, 'ºC'),
	(161770, 122, '2014-01-15 00:22:11.000000', 'temperatura', 581.0000, 'ºC'),
	(161771, 122, '2014-01-15 00:22:12.000000', 'temperatura', 943.0000, 'ºC'),
	(161772, 122, '2014-01-15 00:22:13.000000', 'temperatura', 570.0000, 'ºC'),
	(161773, 122, '2014-01-15 00:22:14.000000', 'temperatura', 25.0000, 'ºC'),
	(161774, 122, '2014-01-15 00:22:15.000000', 'temperatura', 813.0000, 'ºC'),
	(161775, 122, '2014-01-15 00:22:16.000000', 'temperatura', 389.0000, 'ºC'),
	(161776, 122, '2014-01-15 00:22:17.000000', 'temperatura', 710.0000, 'ºC'),
	(161777, 122, '2014-01-15 00:22:18.000000', 'temperatura', 1182.0000, 'ºC'),
	(161778, 122, '2014-01-15 00:22:19.000000', 'temperatura', 180.0000, 'ºC'),
	(161779, 122, '2014-01-15 00:22:20.000000', 'temperatura', 953.0000, 'ºC'),
	(161780, 122, '2014-01-15 00:22:21.000000', 'temperatura', 627.0000, 'ºC'),
	(161781, 122, '2014-01-15 00:22:22.000000', 'temperatura', 274.0000, 'ºC'),
	(161782, 122, '2014-01-15 00:22:23.000000', 'temperatura', 692.0000, 'ºC'),
	(161783, 122, '2014-01-15 00:22:24.000000', 'temperatura', 240.0000, 'ºC'),
	(161784, 122, '2014-01-15 00:22:25.000000', 'temperatura', 323.0000, 'ºC'),
	(161785, 122, '2014-01-15 00:22:26.000000', 'temperatura', 895.0000, 'ºC'),
	(161786, 122, '2014-01-15 00:22:27.000000', 'temperatura', 1107.0000, 'ºC'),
	(161787, 122, '2014-01-15 00:22:28.000000', 'temperatura', 450.0000, 'ºC'),
	(161788, 122, '2014-01-15 00:22:29.000000', 'temperatura', 129.0000, 'ºC'),
	(161789, 122, '2014-01-15 00:22:30.000000', 'temperatura', 497.0000, 'ºC'),
	(161790, 122, '2014-01-15 00:22:31.000000', 'temperatura', 899.0000, 'ºC'),
	(161791, 122, '2014-01-15 00:22:32.000000', 'temperatura', 605.0000, 'ºC'),
	(161792, 122, '2014-01-15 00:22:33.000000', 'temperatura', 329.0000, 'ºC'),
	(161793, 122, '2014-01-15 00:22:34.000000', 'temperatura', 1030.0000, 'ºC'),
	(161794, 122, '2014-01-15 00:22:35.000000', 'temperatura', 562.0000, 'ºC'),
	(161795, 122, '2014-01-15 00:22:36.000000', 'temperatura', 920.0000, 'ºC'),
	(161796, 122, '2014-01-15 00:22:37.000000', 'temperatura', 514.0000, 'ºC'),
	(161797, 122, '2014-01-15 00:22:38.000000', 'temperatura', 1011.0000, 'ºC'),
	(161798, 122, '2014-01-15 00:22:39.000000', 'temperatura', 1115.0000, 'ºC'),
	(161799, 122, '2014-01-15 00:22:40.000000', 'temperatura', 143.0000, 'ºC'),
	(161800, 122, '2014-01-15 00:22:41.000000', 'temperatura', 971.0000, 'ºC'),
	(161801, 122, '2014-01-15 00:22:42.000000', 'temperatura', 828.0000, 'ºC'),
	(161802, 122, '2014-01-15 00:22:43.000000', 'temperatura', 24.0000, 'ºC'),
	(161803, 122, '2014-01-15 00:22:44.000000', 'temperatura', 38.0000, 'ºC'),
	(161804, 122, '2014-01-15 00:22:45.000000', 'temperatura', 117.0000, 'ºC'),
	(161805, 122, '2014-01-15 00:22:46.000000', 'temperatura', 474.0000, 'ºC'),
	(161806, 122, '2014-01-15 00:22:47.000000', 'temperatura', 818.0000, 'ºC'),
	(161807, 122, '2014-01-15 00:22:48.000000', 'temperatura', 270.0000, 'ºC'),
	(161808, 122, '2014-01-15 00:22:49.000000', 'temperatura', 98.0000, 'ºC'),
	(161809, 122, '2014-01-15 00:22:50.000000', 'temperatura', 877.0000, 'ºC'),
	(161810, 122, '2014-01-15 00:22:51.000000', 'temperatura', 492.0000, 'ºC'),
	(161811, 122, '2014-01-15 00:22:52.000000', 'temperatura', 1030.0000, 'ºC'),
	(161812, 122, '2014-01-15 00:22:53.000000', 'temperatura', 73.0000, 'ºC'),
	(161813, 122, '2014-01-15 00:22:54.000000', 'temperatura', 877.0000, 'ºC'),
	(161814, 122, '2014-01-15 00:22:55.000000', 'temperatura', 567.0000, 'ºC'),
	(161815, 122, '2014-01-15 00:22:56.000000', 'temperatura', 204.0000, 'ºC'),
	(161816, 122, '2014-01-15 00:22:57.000000', 'temperatura', 518.0000, 'ºC'),
	(161817, 122, '2014-01-15 00:22:58.000000', 'temperatura', 779.0000, 'ºC'),
	(161818, 122, '2014-01-15 00:22:59.000000', 'temperatura', 1143.0000, 'ºC'),
	(161819, 122, '2014-01-15 00:23:00.000000', 'temperatura', 978.0000, 'ºC'),
	(161820, 122, '2014-01-15 00:23:01.000000', 'temperatura', 261.0000, 'ºC'),
	(161821, 122, '2014-01-15 00:23:02.000000', 'temperatura', 772.0000, 'ºC'),
	(161822, 122, '2014-01-15 00:23:03.000000', 'temperatura', 677.0000, 'ºC'),
	(161823, 122, '2014-01-15 00:23:04.000000', 'temperatura', 1069.0000, 'ºC'),
	(161824, 122, '2014-01-15 00:23:05.000000', 'temperatura', 914.0000, 'ºC'),
	(161825, 122, '2014-01-15 00:23:06.000000', 'temperatura', 165.0000, 'ºC'),
	(161826, 122, '2014-01-15 00:23:07.000000', 'temperatura', 482.0000, 'ºC'),
	(161827, 122, '2014-01-15 00:23:08.000000', 'temperatura', 718.0000, 'ºC'),
	(161828, 122, '2014-01-15 00:23:09.000000', 'temperatura', 944.0000, 'ºC'),
	(161829, 122, '2014-01-15 00:23:10.000000', 'temperatura', 166.0000, 'ºC'),
	(161830, 122, '2014-01-15 00:23:11.000000', 'temperatura', 398.0000, 'ºC'),
	(161831, 122, '2014-01-15 00:23:12.000000', 'temperatura', 291.0000, 'ºC'),
	(161832, 122, '2014-01-15 00:23:13.000000', 'temperatura', 263.0000, 'ºC'),
	(161833, 122, '2014-01-15 00:23:14.000000', 'temperatura', 442.0000, 'ºC'),
	(161834, 122, '2014-01-15 00:23:15.000000', 'temperatura', 220.0000, 'ºC'),
	(161835, 122, '2014-01-15 00:23:16.000000', 'temperatura', 976.0000, 'ºC'),
	(161836, 122, '2014-01-15 00:23:17.000000', 'temperatura', 620.0000, 'ºC'),
	(161837, 122, '2014-01-15 00:23:18.000000', 'temperatura', 171.0000, 'ºC'),
	(161838, 122, '2014-01-15 00:23:19.000000', 'temperatura', 198.0000, 'ºC'),
	(161839, 122, '2014-01-15 00:23:20.000000', 'temperatura', 476.0000, 'ºC'),
	(161840, 122, '2014-01-15 00:23:21.000000', 'temperatura', 588.0000, 'ºC'),
	(161841, 122, '2014-01-15 00:23:22.000000', 'temperatura', 310.0000, 'ºC'),
	(161842, 122, '2014-01-15 00:23:23.000000', 'temperatura', 987.0000, 'ºC'),
	(161843, 122, '2014-01-15 00:23:24.000000', 'temperatura', 408.0000, 'ºC'),
	(161844, 122, '2014-01-15 00:23:25.000000', 'temperatura', 279.0000, 'ºC'),
	(161845, 122, '2014-01-15 00:23:26.000000', 'temperatura', 169.0000, 'ºC'),
	(161846, 122, '2014-01-15 00:23:27.000000', 'temperatura', 12.0000, 'ºC'),
	(161847, 122, '2014-01-15 00:23:28.000000', 'temperatura', 751.0000, 'ºC'),
	(161848, 122, '2014-01-15 00:23:29.000000', 'temperatura', 122.0000, 'ºC'),
	(161849, 122, '2014-01-15 00:23:30.000000', 'temperatura', 757.0000, 'ºC'),
	(161850, 122, '2014-01-15 00:23:31.000000', 'temperatura', 1018.0000, 'ºC'),
	(161851, 122, '2014-01-15 00:23:32.000000', 'temperatura', 421.0000, 'ºC'),
	(161852, 122, '2014-01-15 00:23:33.000000', 'temperatura', 250.0000, 'ºC'),
	(161853, 122, '2014-01-15 00:23:34.000000', 'temperatura', 1190.0000, 'ºC'),
	(161854, 122, '2014-01-15 00:23:35.000000', 'temperatura', 398.0000, 'ºC'),
	(161855, 122, '2014-01-15 00:23:36.000000', 'temperatura', 821.0000, 'ºC'),
	(161856, 122, '2014-01-15 00:23:37.000000', 'temperatura', 512.0000, 'ºC'),
	(161857, 122, '2014-01-15 00:23:38.000000', 'temperatura', 98.0000, 'ºC'),
	(161858, 122, '2014-01-15 00:23:39.000000', 'temperatura', 152.0000, 'ºC'),
	(161859, 122, '2014-01-15 00:23:40.000000', 'temperatura', 469.0000, 'ºC'),
	(161860, 122, '2014-01-15 00:23:41.000000', 'temperatura', 688.0000, 'ºC'),
	(161861, 122, '2014-01-15 00:23:42.000000', 'temperatura', 834.0000, 'ºC'),
	(161862, 122, '2014-01-15 00:23:43.000000', 'temperatura', 908.0000, 'ºC'),
	(161863, 122, '2014-01-15 00:23:44.000000', 'temperatura', 840.0000, 'ºC'),
	(161864, 122, '2014-01-15 00:23:45.000000', 'temperatura', 273.0000, 'ºC'),
	(161865, 122, '2014-01-15 00:23:46.000000', 'temperatura', 47.0000, 'ºC'),
	(161866, 122, '2014-01-15 00:23:47.000000', 'temperatura', 616.0000, 'ºC'),
	(161867, 122, '2014-01-15 00:23:48.000000', 'temperatura', 540.0000, 'ºC'),
	(161868, 122, '2014-01-15 00:23:49.000000', 'temperatura', 851.0000, 'ºC'),
	(161869, 122, '2014-01-15 00:23:50.000000', 'temperatura', 235.0000, 'ºC'),
	(161870, 122, '2014-01-15 00:23:51.000000', 'temperatura', 1025.0000, 'ºC'),
	(161871, 122, '2014-01-15 00:23:52.000000', 'temperatura', 818.0000, 'ºC'),
	(161872, 122, '2014-01-15 00:23:53.000000', 'temperatura', 1017.0000, 'ºC'),
	(161873, 122, '2014-01-15 00:23:54.000000', 'temperatura', 231.0000, 'ºC'),
	(161874, 122, '2014-01-15 00:23:55.000000', 'temperatura', 506.0000, 'ºC'),
	(161875, 122, '2014-01-15 00:23:56.000000', 'temperatura', 635.0000, 'ºC'),
	(161876, 122, '2014-01-15 00:23:57.000000', 'temperatura', 459.0000, 'ºC'),
	(161877, 122, '2014-01-15 00:23:58.000000', 'temperatura', 392.0000, 'ºC'),
	(161878, 122, '2014-01-15 00:23:59.000000', 'temperatura', 581.0000, 'ºC'),
	(161879, 122, '2014-01-15 00:24:00.000000', 'temperatura', 528.0000, 'ºC'),
	(161880, 122, '2014-01-15 00:24:01.000000', 'temperatura', 901.0000, 'ºC'),
	(161881, 122, '2014-01-15 00:24:02.000000', 'temperatura', 519.0000, 'ºC'),
	(161882, 122, '2014-01-15 00:24:03.000000', 'temperatura', 1095.0000, 'ºC'),
	(161883, 122, '2014-01-15 00:24:04.000000', 'temperatura', 318.0000, 'ºC'),
	(161884, 122, '2014-01-15 00:24:05.000000', 'temperatura', 706.0000, 'ºC'),
	(161885, 122, '2014-01-15 00:24:06.000000', 'temperatura', 175.0000, 'ºC'),
	(161886, 122, '2014-01-15 00:24:07.000000', 'temperatura', 1157.0000, 'ºC'),
	(161887, 122, '2014-01-15 00:24:08.000000', 'temperatura', 462.0000, 'ºC'),
	(161888, 122, '2014-01-15 00:24:09.000000', 'temperatura', 39.0000, 'ºC'),
	(161889, 122, '2014-01-15 00:24:10.000000', 'temperatura', 9.0000, 'ºC'),
	(161890, 122, '2014-01-15 00:24:11.000000', 'temperatura', 1127.0000, 'ºC'),
	(161891, 122, '2014-01-15 00:24:12.000000', 'temperatura', 811.0000, 'ºC'),
	(161892, 122, '2014-01-15 00:24:13.000000', 'temperatura', 673.0000, 'ºC'),
	(161893, 122, '2014-01-15 00:24:14.000000', 'temperatura', 934.0000, 'ºC'),
	(161894, 122, '2014-01-15 00:24:15.000000', 'temperatura', 250.0000, 'ºC'),
	(161895, 122, '2014-01-15 00:24:16.000000', 'temperatura', 850.0000, 'ºC'),
	(161896, 122, '2014-01-15 00:24:17.000000', 'temperatura', 1100.0000, 'ºC'),
	(161897, 122, '2014-01-15 00:24:18.000000', 'temperatura', 551.0000, 'ºC'),
	(161898, 122, '2014-01-15 00:24:19.000000', 'temperatura', 655.0000, 'ºC'),
	(161899, 122, '2014-01-15 00:24:20.000000', 'temperatura', 421.0000, 'ºC'),
	(161900, 122, '2014-01-15 00:24:21.000000', 'temperatura', 140.0000, 'ºC'),
	(161901, 122, '2014-01-15 00:24:22.000000', 'temperatura', 639.0000, 'ºC'),
	(161902, 122, '2014-01-15 00:24:23.000000', 'temperatura', 374.0000, 'ºC'),
	(161903, 122, '2014-01-15 00:24:24.000000', 'temperatura', 1155.0000, 'ºC'),
	(161904, 122, '2014-01-15 00:24:25.000000', 'temperatura', 1053.0000, 'ºC'),
	(161905, 122, '2014-01-15 00:24:26.000000', 'temperatura', 601.0000, 'ºC'),
	(161906, 122, '2014-01-15 00:24:27.000000', 'temperatura', 1047.0000, 'ºC'),
	(161907, 122, '2014-01-15 00:24:28.000000', 'temperatura', 1032.0000, 'ºC'),
	(161908, 122, '2014-01-15 00:24:29.000000', 'temperatura', 819.0000, 'ºC'),
	(161909, 122, '2014-01-15 00:24:30.000000', 'temperatura', 1002.0000, 'ºC'),
	(161910, 122, '2014-01-15 00:24:31.000000', 'temperatura', 151.0000, 'ºC'),
	(161911, 122, '2014-01-15 00:24:32.000000', 'temperatura', 151.0000, 'ºC'),
	(161912, 122, '2014-01-15 00:24:33.000000', 'temperatura', 302.0000, 'ºC'),
	(161913, 122, '2014-01-15 00:24:34.000000', 'temperatura', 1057.0000, 'ºC'),
	(161914, 122, '2014-01-15 00:24:35.000000', 'temperatura', 779.0000, 'ºC'),
	(161915, 122, '2014-01-15 00:24:36.000000', 'temperatura', 724.0000, 'ºC'),
	(161916, 122, '2014-01-15 00:24:37.000000', 'temperatura', 83.0000, 'ºC'),
	(161917, 122, '2014-01-15 00:24:38.000000', 'temperatura', 643.0000, 'ºC'),
	(161918, 122, '2014-01-15 00:24:39.000000', 'temperatura', 566.0000, 'ºC'),
	(161919, 122, '2014-01-15 00:24:40.000000', 'temperatura', 902.0000, 'ºC'),
	(161920, 122, '2014-01-15 00:24:41.000000', 'temperatura', 412.0000, 'ºC'),
	(161921, 122, '2014-01-15 00:24:42.000000', 'temperatura', 553.0000, 'ºC'),
	(161922, 122, '2014-01-15 00:24:43.000000', 'temperatura', 333.0000, 'ºC'),
	(161923, 122, '2014-01-15 00:24:44.000000', 'temperatura', 4.0000, 'ºC'),
	(161924, 122, '2014-01-15 00:24:45.000000', 'temperatura', 222.0000, 'ºC'),
	(161925, 122, '2014-01-15 00:24:46.000000', 'temperatura', 1100.0000, 'ºC'),
	(161926, 122, '2014-01-15 00:24:47.000000', 'temperatura', 34.0000, 'ºC'),
	(161927, 122, '2014-01-15 00:24:48.000000', 'temperatura', 470.0000, 'ºC'),
	(161928, 122, '2014-01-15 00:24:49.000000', 'temperatura', 1047.0000, 'ºC'),
	(161929, 122, '2014-01-15 00:24:50.000000', 'temperatura', 228.0000, 'ºC'),
	(161930, 122, '2014-01-15 00:24:51.000000', 'temperatura', 399.0000, 'ºC'),
	(161931, 122, '2014-01-15 00:24:52.000000', 'temperatura', 111.0000, 'ºC'),
	(161932, 122, '2014-01-15 00:24:53.000000', 'temperatura', 557.0000, 'ºC'),
	(161933, 122, '2014-01-15 00:24:54.000000', 'temperatura', 53.0000, 'ºC'),
	(161934, 122, '2014-01-15 00:24:55.000000', 'temperatura', 993.0000, 'ºC'),
	(161935, 122, '2014-01-15 00:24:56.000000', 'temperatura', 9.0000, 'ºC'),
	(161936, 122, '2014-01-15 00:24:57.000000', 'temperatura', 668.0000, 'ºC'),
	(161937, 122, '2014-01-15 00:24:58.000000', 'temperatura', 910.0000, 'ºC'),
	(161938, 122, '2014-01-15 00:24:59.000000', 'temperatura', 148.0000, 'ºC'),
	(161939, 122, '2014-01-15 00:25:00.000000', 'temperatura', 411.0000, 'ºC'),
	(161940, 122, '2014-01-15 00:25:01.000000', 'temperatura', 413.0000, 'ºC'),
	(161941, 122, '2014-01-15 00:25:02.000000', 'temperatura', 829.0000, 'ºC'),
	(161942, 122, '2014-01-15 00:25:03.000000', 'temperatura', 509.0000, 'ºC'),
	(161943, 122, '2014-01-15 00:25:04.000000', 'temperatura', 57.0000, 'ºC'),
	(161944, 122, '2014-01-15 00:25:05.000000', 'temperatura', 1159.0000, 'ºC'),
	(161945, 122, '2014-01-15 00:25:06.000000', 'temperatura', 825.0000, 'ºC'),
	(161946, 122, '2014-01-15 00:25:07.000000', 'temperatura', 650.0000, 'ºC'),
	(161947, 122, '2014-01-15 00:25:08.000000', 'temperatura', 774.0000, 'ºC'),
	(161948, 122, '2014-01-15 00:25:09.000000', 'temperatura', 720.0000, 'ºC'),
	(161949, 122, '2014-01-15 00:25:10.000000', 'temperatura', 80.0000, 'ºC'),
	(161950, 122, '2014-01-15 00:25:11.000000', 'temperatura', 641.0000, 'ºC'),
	(161951, 122, '2014-01-15 00:25:12.000000', 'temperatura', 565.0000, 'ºC'),
	(161952, 122, '2014-01-15 00:25:13.000000', 'temperatura', 903.0000, 'ºC'),
	(161953, 122, '2014-01-15 00:25:14.000000', 'temperatura', 418.0000, 'ºC'),
	(161954, 122, '2014-01-15 00:25:15.000000', 'temperatura', 584.0000, 'ºC'),
	(161955, 122, '2014-01-15 00:25:16.000000', 'temperatura', 466.0000, 'ºC'),
	(161956, 122, '2014-01-15 00:25:17.000000', 'temperatura', 579.0000, 'ºC'),
	(161957, 122, '2014-01-15 00:25:18.000000', 'temperatura', 296.0000, 'ºC'),
	(161958, 122, '2014-01-15 00:25:19.000000', 'temperatura', 945.0000, 'ºC'),
	(161959, 122, '2014-01-15 00:25:20.000000', 'temperatura', 235.0000, 'ºC'),
	(161960, 122, '2014-01-15 00:25:21.000000', 'temperatura', 744.0000, 'ºC'),
	(161961, 122, '2014-01-15 00:25:22.000000', 'temperatura', 612.0000, 'ºC'),
	(161962, 122, '2014-01-15 00:25:23.000000', 'temperatura', 830.0000, 'ºC'),
	(161963, 122, '2014-01-15 00:25:24.000000', 'temperatura', 1113.0000, 'ºC'),
	(161964, 122, '2014-01-15 00:25:25.000000', 'temperatura', 676.0000, 'ºC'),
	(161965, 122, '2014-01-15 00:25:26.000000', 'temperatura', 40.0000, 'ºC'),
	(161966, 122, '2014-01-15 00:25:27.000000', 'temperatura', 574.0000, 'ºC'),
	(161967, 122, '2014-01-15 00:25:28.000000', 'temperatura', 349.0000, 'ºC'),
	(161968, 122, '2014-01-15 00:25:29.000000', 'temperatura', 23.0000, 'ºC'),
	(161969, 122, '2014-01-15 00:25:30.000000', 'temperatura', 271.0000, 'ºC'),
	(161970, 122, '2014-01-15 00:25:31.000000', 'temperatura', 86.0000, 'ºC'),
	(161971, 122, '2014-01-15 00:25:32.000000', 'temperatura', 816.0000, 'ºC'),
	(161972, 122, '2014-01-15 00:25:33.000000', 'temperatura', 225.0000, 'ºC'),
	(161973, 122, '2014-01-15 00:25:34.000000', 'temperatura', 1075.0000, 'ºC'),
	(161974, 122, '2014-01-15 00:25:35.000000', 'temperatura', 1102.0000, 'ºC'),
	(161975, 122, '2014-01-15 00:25:36.000000', 'temperatura', 1087.0000, 'ºC'),
	(161976, 122, '2014-01-15 00:25:37.000000', 'temperatura', 927.0000, 'ºC'),
	(161977, 122, '2014-01-15 00:25:38.000000', 'temperatura', 174.0000, 'ºC'),
	(161978, 122, '2014-01-15 00:25:39.000000', 'temperatura', 488.0000, 'ºC'),
	(161979, 122, '2014-01-15 00:25:40.000000', 'temperatura', 722.0000, 'ºC'),
	(161980, 122, '2014-01-15 00:25:41.000000', 'temperatura', 945.0000, 'ºC'),
	(161981, 122, '2014-01-15 00:25:42.000000', 'temperatura', 158.0000, 'ºC'),
	(161982, 122, '2014-01-15 00:25:43.000000', 'temperatura', 358.0000, 'ºC'),
	(161983, 122, '2014-01-15 00:25:44.000000', 'temperatura', 117.0000, 'ºC'),
	(161984, 122, '2014-01-15 00:25:45.000000', 'temperatura', 710.0000, 'ºC'),
	(161985, 122, '2014-01-15 00:25:46.000000', 'temperatura', 801.0000, 'ºC'),
	(161986, 122, '2014-01-15 00:25:47.000000', 'temperatura', 675.0000, 'ºC'),
	(161987, 122, '2014-01-15 00:25:48.000000', 'temperatura', 974.0000, 'ºC'),
	(161988, 122, '2014-01-15 00:25:49.000000', 'temperatura', 445.0000, 'ºC'),
	(161989, 122, '2014-01-15 00:25:50.000000', 'temperatura', 505.0000, 'ºC'),
	(161990, 122, '2014-01-15 00:25:51.000000', 'temperatura', 1189.0000, 'ºC'),
	(161991, 122, '2014-01-15 00:25:52.000000', 'temperatura', 829.0000, 'ºC'),
	(161992, 122, '2014-01-15 00:25:53.000000', 'temperatura', 579.0000, 'ºC'),
	(161993, 122, '2014-01-15 00:25:54.000000', 'temperatura', 411.0000, 'ºC'),
	(161994, 122, '2014-01-15 00:25:55.000000', 'temperatura', 315.0000, 'ºC'),
	(161995, 122, '2014-01-15 00:25:56.000000', 'temperatura', 344.0000, 'ºC'),
	(161996, 122, '2014-01-15 00:25:57.000000', 'temperatura', 777.0000, 'ºC'),
	(161997, 122, '2014-01-15 00:25:58.000000', 'temperatura', 451.0000, 'ºC'),
	(161998, 122, '2014-01-15 00:25:59.000000', 'temperatura', 1124.0000, 'ºC'),
	(161999, 122, '2014-01-15 00:26:00.000000', 'temperatura', 669.0000, 'ºC'),
	(162000, 122, '2014-01-15 00:26:01.000000', 'temperatura', 1173.0000, 'ºC'),
	(162001, 122, '2014-01-15 00:26:02.000000', 'temperatura', 259.0000, 'ºC'),
	(162002, 122, '2014-01-15 00:26:03.000000', 'temperatura', 176.0000, 'ºC'),
	(162003, 122, '2014-01-15 00:26:04.000000', 'temperatura', 103.0000, 'ºC'),
	(162004, 122, '2014-01-15 00:26:05.000000', 'temperatura', 1188.0000, 'ºC'),
	(162005, 122, '2014-01-15 00:26:06.000000', 'temperatura', 833.0000, 'ºC'),
	(162006, 122, '2014-01-15 00:26:07.000000', 'temperatura', 602.0000, 'ºC'),
	(162007, 122, '2014-01-15 00:26:08.000000', 'temperatura', 510.0000, 'ºC'),
	(162008, 122, '2014-01-15 00:26:09.000000', 'temperatura', 747.0000, 'ºC'),
	(162009, 122, '2014-01-15 00:26:10.000000', 'temperatura', 1002.0000, 'ºC'),
	(162010, 122, '2014-01-15 00:26:11.000000', 'temperatura', 372.0000, 'ºC'),
	(162011, 122, '2014-01-15 00:26:12.000000', 'temperatura', 55.0000, 'ºC'),
	(162012, 122, '2014-01-15 00:26:13.000000', 'temperatura', 359.0000, 'ºC'),
	(162013, 122, '2014-01-15 00:26:14.000000', 'temperatura', 431.0000, 'ºC'),
	(162014, 122, '2014-01-15 00:26:15.000000', 'temperatura', 1079.0000, 'ºC'),
	(162015, 122, '2014-01-15 00:26:16.000000', 'temperatura', 500.0000, 'ºC'),
	(162016, 122, '2014-01-15 00:26:17.000000', 'temperatura', 467.0000, 'ºC'),
	(162017, 122, '2014-01-15 00:26:18.000000', 'temperatura', 833.0000, 'ºC'),
	(162018, 122, '2014-01-15 00:26:19.000000', 'temperatura', 366.0000, 'ºC'),
	(162019, 122, '2014-01-15 00:26:20.000000', 'temperatura', 531.0000, 'ºC'),
	(162020, 122, '2014-01-15 00:26:21.000000', 'temperatura', 356.0000, 'ºC'),
	(162021, 122, '2014-01-15 00:26:22.000000', 'temperatura', 190.0000, 'ºC'),
	(162022, 122, '2014-01-15 00:26:23.000000', 'temperatura', 1083.0000, 'ºC'),
	(162023, 122, '2014-01-15 00:26:24.000000', 'temperatura', 43.0000, 'ºC'),
	(162024, 122, '2014-01-15 00:26:25.000000', 'temperatura', 568.0000, 'ºC'),
	(162025, 122, '2014-01-15 00:26:26.000000', 'temperatura', 313.0000, 'ºC'),
	(162026, 122, '2014-01-15 00:26:27.000000', 'temperatura', 1058.0000, 'ºC'),
	(162027, 122, '2014-01-15 00:26:28.000000', 'temperatura', 754.0000, 'ºC'),
	(162028, 122, '2014-01-15 00:26:29.000000', 'temperatura', 594.0000, 'ºC'),
	(162029, 122, '2014-01-15 00:26:30.000000', 'temperatura', 710.0000, 'ºC'),
	(162030, 122, '2014-01-15 00:26:31.000000', 'temperatura', 569.0000, 'ºC'),
	(162031, 122, '2014-01-15 00:26:32.000000', 'temperatura', 717.0000, 'ºC'),
	(162032, 122, '2014-01-15 00:26:33.000000', 'temperatura', 676.0000, 'ºC'),
	(162033, 122, '2014-01-15 00:26:34.000000', 'temperatura', 31.0000, 'ºC'),
	(162034, 122, '2014-01-15 00:26:35.000000', 'temperatura', 529.0000, 'ºC'),
	(162035, 122, '2014-01-15 00:26:36.000000', 'temperatura', 151.0000, 'ºC'),
	(162036, 122, '2014-01-15 00:26:37.000000', 'temperatura', 368.0000, 'ºC'),
	(162037, 122, '2014-01-15 00:26:38.000000', 'temperatura', 190.0000, 'ºC'),
	(162038, 122, '2014-01-15 00:26:39.000000', 'temperatura', 1043.0000, 'ºC'),
	(162039, 122, '2014-01-15 00:26:40.000000', 'temperatura', 1047.0000, 'ºC'),
	(162040, 122, '2014-01-15 00:26:41.000000', 'temperatura', 907.0000, 'ºC'),
	(162041, 122, '2014-01-15 00:26:42.000000', 'temperatura', 192.0000, 'ºC'),
	(162042, 122, '2014-01-15 00:26:43.000000', 'temperatura', 643.0000, 'ºC'),
	(162043, 122, '2014-01-15 00:26:44.000000', 'temperatura', 238.0000, 'ºC'),
	(162044, 122, '2014-01-15 00:26:45.000000', 'temperatura', 462.0000, 'ºC'),
	(162045, 122, '2014-01-15 00:26:46.000000', 'temperatura', 395.0000, 'ºC'),
	(162046, 122, '2014-01-15 00:26:47.000000', 'temperatura', 590.0000, 'ºC'),
	(162047, 122, '2014-01-15 00:26:48.000000', 'temperatura', 568.0000, 'ºC'),
	(162048, 122, '2014-01-15 00:26:49.000000', 'temperatura', 1067.0000, 'ºC'),
	(162049, 122, '2014-01-15 00:26:50.000000', 'temperatura', 33.0000, 'ºC'),
	(162050, 122, '2014-01-15 00:26:51.000000', 'temperatura', 563.0000, 'ºC'),
	(162051, 122, '2014-01-15 00:26:52.000000', 'temperatura', 318.0000, 'ºC'),
	(162052, 122, '2014-01-15 00:26:53.000000', 'temperatura', 1103.0000, 'ºC'),
	(162053, 122, '2014-01-15 00:26:54.000000', 'temperatura', 961.0000, 'ºC'),
	(162054, 122, '2014-01-15 00:26:55.000000', 'temperatura', 294.0000, 'ºC'),
	(162055, 122, '2014-01-15 00:26:56.000000', 'temperatura', 990.0000, 'ºC'),
	(162056, 122, '2014-01-15 00:26:57.000000', 'temperatura', 468.0000, 'ºC'),
	(162057, 122, '2014-01-15 00:26:58.000000', 'temperatura', 571.0000, 'ºC'),
	(162058, 122, '2014-01-15 00:26:59.000000', 'temperatura', 252.0000, 'ºC'),
	(162059, 122, '2014-01-15 00:27:00.000000', 'temperatura', 748.0000, 'ºC'),
	(162060, 122, '2014-01-15 00:27:01.000000', 'temperatura', 585.0000, 'ºC'),
	(162061, 122, '2014-01-15 00:27:02.000000', 'temperatura', 681.0000, 'ºC'),
	(162062, 122, '2014-01-15 00:27:03.000000', 'temperatura', 452.0000, 'ºC'),
	(162063, 122, '2014-01-15 00:27:04.000000', 'temperatura', 217.0000, 'ºC'),
	(162064, 122, '2014-01-15 00:27:05.000000', 'temperatura', 927.0000, 'ºC'),
	(162065, 122, '2014-01-15 00:27:06.000000', 'temperatura', 387.0000, 'ºC'),
	(162066, 122, '2014-01-15 00:27:07.000000', 'temperatura', 355.0000, 'ºC'),
	(162067, 122, '2014-01-15 00:27:08.000000', 'temperatura', 614.0000, 'ºC'),
	(162068, 122, '2014-01-15 00:27:09.000000', 'temperatura', 805.0000, 'ºC'),
	(162069, 122, '2014-01-15 00:27:10.000000', 'temperatura', 983.0000, 'ºC'),
	(162070, 122, '2014-01-15 00:27:11.000000', 'temperatura', 101.0000, 'ºC'),
	(162071, 122, '2014-01-15 00:27:12.000000', 'temperatura', 1158.0000, 'ºC'),
	(162072, 122, '2014-01-15 00:27:13.000000', 'temperatura', 688.0000, 'ºC'),
	(162073, 122, '2014-01-15 00:27:14.000000', 'temperatura', 1166.0000, 'ºC'),
	(162074, 122, '2014-01-15 00:27:15.000000', 'temperatura', 168.0000, 'ºC'),
	(162075, 122, '2014-01-15 00:27:16.000000', 'temperatura', 940.0000, 'ºC'),
	(162076, 122, '2014-01-15 00:27:17.000000', 'temperatura', 596.0000, 'ºC'),
	(162077, 122, '2014-01-15 00:27:18.000000', 'temperatura', 160.0000, 'ºC'),
	(162078, 122, '2014-01-15 00:27:19.000000', 'temperatura', 214.0000, 'ºC'),
	(162079, 122, '2014-01-15 00:27:20.000000', 'temperatura', 588.0000, 'ºC'),
	(162080, 122, '2014-01-15 00:27:21.000000', 'temperatura', 1101.0000, 'ºC'),
	(162081, 122, '2014-01-15 00:27:22.000000', 'temperatura', 139.0000, 'ºC'),
	(162082, 122, '2014-01-15 00:27:23.000000', 'temperatura', 996.0000, 'ºC'),
	(162083, 122, '2014-01-15 00:27:24.000000', 'temperatura', 960.0000, 'ºC'),
	(162084, 122, '2014-01-15 00:27:25.000000', 'temperatura', 614.0000, 'ºC'),
	(162085, 122, '2014-01-15 00:27:26.000000', 'temperatura', 190.0000, 'ºC'),
	(162086, 122, '2014-01-15 00:27:27.000000', 'temperatura', 308.0000, 'ºC'),
	(162087, 122, '2014-01-15 00:27:28.000000', 'temperatura', 969.0000, 'ºC'),
	(162088, 122, '2014-01-15 00:27:29.000000', 'temperatura', 324.0000, 'ºC'),
	(162089, 122, '2014-01-15 00:27:30.000000', 'temperatura', 1113.0000, 'ºC'),
	(162090, 122, '2014-01-15 00:27:31.000000', 'temperatura', 994.0000, 'ºC'),
	(162091, 122, '2014-01-15 00:27:32.000000', 'temperatura', 432.0000, 'ºC'),
	(162092, 122, '2014-01-15 00:27:33.000000', 'temperatura', 377.0000, 'ºC'),
	(162093, 122, '2014-01-15 00:27:34.000000', 'temperatura', 589.0000, 'ºC'),
	(162094, 122, '2014-01-15 00:27:35.000000', 'temperatura', 615.0000, 'ºC'),
	(162095, 122, '2014-01-15 00:27:36.000000', 'temperatura', 107.0000, 'ºC'),
	(162096, 122, '2014-01-15 00:27:37.000000', 'temperatura', 1091.0000, 'ºC'),
	(162097, 122, '2014-01-15 00:27:38.000000', 'temperatura', 336.0000, 'ºC'),
	(162098, 122, '2014-01-15 00:27:39.000000', 'temperatura', 807.0000, 'ºC'),
	(162099, 122, '2014-01-15 00:27:40.000000', 'temperatura', 626.0000, 'ºC'),
	(162100, 122, '2014-01-15 00:27:41.000000', 'temperatura', 708.0000, 'ºC'),
	(162101, 122, '2014-01-15 00:27:42.000000', 'temperatura', 466.0000, 'ºC'),
	(162102, 122, '2014-01-15 00:27:43.000000', 'temperatura', 204.0000, 'ºC'),
	(162103, 122, '2014-01-15 00:27:44.000000', 'temperatura', 822.0000, 'ºC'),
	(162104, 122, '2014-01-15 00:27:45.000000', 'temperatura', 1098.0000, 'ºC'),
	(162105, 122, '2014-01-15 00:27:46.000000', 'temperatura', 625.0000, 'ºC'),
	(162106, 122, '2014-01-15 00:27:47.000000', 'temperatura', 1031.0000, 'ºC'),
	(162107, 122, '2014-01-15 00:27:48.000000', 'temperatura', 883.0000, 'ºC'),
	(162108, 122, '2014-01-15 00:27:49.000000', 'temperatura', 121.0000, 'ºC'),
	(162109, 122, '2014-01-15 00:27:50.000000', 'temperatura', 358.0000, 'ºC'),
	(162110, 122, '2014-01-15 00:27:51.000000', 'temperatura', 226.0000, 'ºC'),
	(162111, 122, '2014-01-15 00:27:52.000000', 'temperatura', 57.0000, 'ºC'),
	(162112, 122, '2014-01-15 00:27:53.000000', 'temperatura', 807.0000, 'ºC'),
	(162113, 122, '2014-01-15 00:27:54.000000', 'temperatura', 263.0000, 'ºC'),
	(162114, 122, '2014-01-15 00:27:55.000000', 'temperatura', 96.0000, 'ºC'),
	(162115, 122, '2014-01-15 00:27:56.000000', 'temperatura', 893.0000, 'ºC'),
	(162116, 122, '2014-01-15 00:27:57.000000', 'temperatura', 576.0000, 'ºC'),
	(162117, 122, '2014-01-15 00:27:58.000000', 'temperatura', 203.0000, 'ºC'),
	(162118, 122, '2014-01-15 00:27:59.000000', 'temperatura', 486.0000, 'ºC'),
	(162119, 122, '2014-01-15 00:28:00.000000', 'temperatura', 623.0000, 'ºC'),
	(162120, 122, '2014-01-15 00:28:01.000000', 'temperatura', 458.0000, 'ºC'),
	(162121, 122, '2014-01-15 00:28:02.000000', 'temperatura', 419.0000, 'ºC'),
	(162122, 122, '2014-01-15 00:28:03.000000', 'temperatura', 723.0000, 'ºC'),
	(162123, 122, '2014-01-15 00:28:04.000000', 'temperatura', 1157.0000, 'ºC'),
	(162124, 122, '2014-01-15 00:28:05.000000', 'temperatura', 15.0000, 'ºC'),
	(162125, 122, '2014-01-15 00:28:06.000000', 'temperatura', 208.0000, 'ºC'),
	(162126, 122, '2014-01-15 00:28:07.000000', 'temperatura', 994.0000, 'ºC'),
	(162127, 122, '2014-01-15 00:28:08.000000', 'temperatura', 749.0000, 'ºC'),
	(162128, 122, '2014-01-15 00:28:09.000000', 'temperatura', 761.0000, 'ºC'),
	(162129, 122, '2014-01-15 00:28:10.000000', 'temperatura', 359.0000, 'ºC'),
	(162130, 122, '2014-01-15 00:28:11.000000', 'temperatura', 712.0000, 'ºC'),
	(162131, 122, '2014-01-15 00:28:12.000000', 'temperatura', 85.0000, 'ºC'),
	(162132, 122, '2014-01-15 00:28:13.000000', 'temperatura', 689.0000, 'ºC'),
	(162133, 122, '2014-01-15 00:28:14.000000', 'temperatura', 790.0000, 'ºC'),
	(162134, 122, '2014-01-15 00:28:15.000000', 'temperatura', 684.0000, 'ºC'),
	(162135, 122, '2014-01-15 00:28:16.000000', 'temperatura', 1051.0000, 'ºC'),
	(162136, 122, '2014-01-15 00:28:17.000000', 'temperatura', 801.0000, 'ºC'),
	(162137, 122, '2014-01-15 00:28:18.000000', 'temperatura', 856.0000, 'ºC'),
	(162138, 122, '2014-01-15 00:28:19.000000', 'temperatura', 674.0000, 'ºC'),
	(162139, 122, '2014-01-15 00:28:20.000000', 'temperatura', 805.0000, 'ºC'),
	(162140, 122, '2014-01-15 00:28:21.000000', 'temperatura', 802.0000, 'ºC'),
	(162141, 122, '2014-01-15 00:28:22.000000', 'temperatura', 395.0000, 'ºC'),
	(162142, 122, '2014-01-15 00:28:23.000000', 'temperatura', 772.0000, 'ºC'),
	(162143, 122, '2014-01-15 00:28:24.000000', 'temperatura', 274.0000, 'ºC'),
	(162144, 122, '2014-01-15 00:28:25.000000', 'temperatura', 256.0000, 'ºC'),
	(162145, 122, '2014-01-15 00:28:26.000000', 'temperatura', 457.0000, 'ºC'),
	(162146, 122, '2014-01-15 00:28:27.000000', 'temperatura', 316.0000, 'ºC'),
	(162147, 122, '2014-01-15 00:28:28.000000', 'temperatura', 210.0000, 'ºC'),
	(162148, 122, '2014-01-15 00:28:29.000000', 'temperatura', 103.0000, 'ºC'),
	(162149, 122, '2014-01-15 00:28:30.000000', 'temperatura', 1085.0000, 'ºC'),
	(162150, 122, '2014-01-15 00:28:31.000000', 'temperatura', 317.0000, 'ºC'),
	(162151, 122, '2014-01-15 00:28:32.000000', 'temperatura', 732.0000, 'ºC'),
	(162152, 122, '2014-01-15 00:28:33.000000', 'temperatura', 308.0000, 'ºC'),
	(162153, 122, '2014-01-15 00:28:34.000000', 'temperatura', 545.0000, 'ºC'),
	(162154, 122, '2014-01-15 00:28:35.000000', 'temperatura', 602.0000, 'ºC'),
	(162155, 122, '2014-01-15 00:28:36.000000', 'temperatura', 176.0000, 'ºC'),
	(162156, 122, '2014-01-15 00:28:37.000000', 'temperatura', 275.0000, 'ºC'),
	(162157, 122, '2014-01-15 00:28:38.000000', 'temperatura', 848.0000, 'ºC'),
	(162158, 122, '2014-01-15 00:28:39.000000', 'temperatura', 1016.0000, 'ºC'),
	(162159, 122, '2014-01-15 00:28:40.000000', 'temperatura', 137.0000, 'ºC'),
	(162160, 122, '2014-01-15 00:28:41.000000', 'temperatura', 38.0000, 'ºC'),
	(162161, 122, '2014-01-15 00:28:42.000000', 'temperatura', 980.0000, 'ºC'),
	(162162, 122, '2014-01-15 00:28:43.000000', 'temperatura', 1187.0000, 'ºC'),
	(162163, 122, '2014-01-15 00:28:44.000000', 'temperatura', 594.0000, 'ºC'),
	(162164, 122, '2014-01-15 00:28:45.000000', 'temperatura', 610.0000, 'ºC'),
	(162165, 122, '2014-01-15 00:28:46.000000', 'temperatura', 70.0000, 'ºC'),
	(162166, 122, '2014-01-15 00:28:47.000000', 'temperatura', 920.0000, 'ºC'),
	(162167, 122, '2014-01-15 00:28:48.000000', 'temperatura', 789.0000, 'ºC'),
	(162168, 122, '2014-01-15 00:28:49.000000', 'temperatura', 1184.0000, 'ºC'),
	(162169, 122, '2014-01-15 00:28:50.000000', 'temperatura', 1156.0000, 'ºC'),
	(162170, 122, '2014-01-15 00:28:51.000000', 'temperatura', 1026.0000, 'ºC'),
	(162171, 122, '2014-01-15 00:28:52.000000', 'temperatura', 463.0000, 'ºC'),
	(162172, 122, '2014-01-15 00:28:53.000000', 'temperatura', 439.0000, 'ºC'),
	(162173, 122, '2014-01-15 00:28:54.000000', 'temperatura', 806.0000, 'ºC'),
	(162174, 122, '2014-01-15 00:28:55.000000', 'temperatura', 313.0000, 'ºC'),
	(162175, 122, '2014-01-15 00:28:56.000000', 'temperatura', 349.0000, 'ºC'),
	(162176, 122, '2014-01-15 00:28:57.000000', 'temperatura', 808.0000, 'ºC'),
	(162177, 122, '2014-01-15 00:28:58.000000', 'temperatura', 590.0000, 'ºC'),
	(162178, 122, '2014-01-15 00:28:59.000000', 'temperatura', 528.0000, 'ºC'),
	(162179, 122, '2014-01-15 00:29:00.000000', 'temperatura', 871.0000, 'ºC'),
	(162180, 122, '2014-01-15 00:29:01.000000', 'temperatura', 373.0000, 'ºC'),
	(162181, 122, '2014-01-15 00:29:02.000000', 'temperatura', 450.0000, 'ºC'),
	(162182, 122, '2014-01-15 00:29:03.000000', 'temperatura', 1134.0000, 'ºC'),
	(162183, 122, '2014-01-15 00:29:04.000000', 'temperatura', 720.0000, 'ºC'),
	(162184, 122, '2014-01-15 00:29:05.000000', 'temperatura', 196.0000, 'ºC'),
	(162185, 122, '2014-01-15 00:29:06.000000', 'temperatura', 23.0000, 'ºC'),
	(162186, 122, '2014-01-15 00:29:07.000000', 'temperatura', 726.0000, 'ºC'),
	(162187, 122, '2014-01-15 00:29:08.000000', 'temperatura', 1161.0000, 'ºC'),
	(162188, 122, '2014-01-15 00:29:09.000000', 'temperatura', 30.0000, 'ºC'),
	(162189, 122, '2014-01-15 00:29:10.000000', 'temperatura', 267.0000, 'ºC'),
	(162190, 122, '2014-01-15 00:29:11.000000', 'temperatura', 44.0000, 'ºC'),
	(162191, 122, '2014-01-15 00:29:12.000000', 'temperatura', 619.0000, 'ºC'),
	(162192, 122, '2014-01-15 00:29:13.000000', 'temperatura', 565.0000, 'ºC'),
	(162193, 122, '2014-01-15 00:29:14.000000', 'temperatura', 968.0000, 'ºC'),
	(162194, 122, '2014-01-15 00:29:15.000000', 'temperatura', 748.0000, 'ºC'),
	(162195, 122, '2014-01-15 00:29:16.000000', 'temperatura', 833.0000, 'ºC'),
	(162196, 122, '2014-01-15 00:29:17.000000', 'temperatura', 721.0000, 'ºC'),
	(162197, 122, '2014-01-15 00:29:18.000000', 'temperatura', 1109.0000, 'ºC'),
	(162198, 122, '2014-01-15 00:29:19.000000', 'temperatura', 980.0000, 'ºC'),
	(162199, 122, '2014-01-15 00:29:20.000000', 'temperatura', 373.0000, 'ºC'),
	(162200, 122, '2014-01-15 00:29:21.000000', 'temperatura', 127.0000, 'ºC'),
	(162201, 122, '2014-01-15 00:29:22.000000', 'temperatura', 715.0000, 'ºC'),
	(162202, 122, '2014-01-15 00:29:23.000000', 'temperatura', 794.0000, 'ºC'),
	(162203, 122, '2014-01-15 00:29:24.000000', 'temperatura', 624.0000, 'ºC'),
	(162204, 122, '2014-01-15 00:29:25.000000', 'temperatura', 742.0000, 'ºC'),
	(162205, 122, '2014-01-15 00:29:26.000000', 'temperatura', 638.0000, 'ºC'),
	(162206, 122, '2014-01-15 00:29:27.000000', 'temperatura', 965.0000, 'ºC'),
	(162207, 122, '2014-01-15 00:29:28.000000', 'temperatura', 511.0000, 'ºC'),
	(162208, 122, '2014-01-15 00:29:29.000000', 'temperatura', 859.0000, 'ºC'),
	(162209, 122, '2014-01-15 00:29:30.000000', 'temperatura', 362.0000, 'ºC'),
	(162210, 122, '2014-01-15 00:29:31.000000', 'temperatura', 435.0000, 'ºC'),
	(162211, 122, '2014-01-15 00:29:32.000000', 'temperatura', 1091.0000, 'ºC'),
	(162212, 122, '2014-01-15 00:29:33.000000', 'temperatura', 549.0000, 'ºC'),
	(162213, 122, '2014-01-15 00:29:34.000000', 'temperatura', 674.0000, 'ºC'),
	(162214, 122, '2014-01-15 00:29:35.000000', 'temperatura', 521.0000, 'ºC'),
	(162215, 122, '2014-01-15 00:29:36.000000', 'temperatura', 584.0000, 'ºC'),
	(162216, 122, '2014-01-15 00:29:37.000000', 'temperatura', 158.0000, 'ºC'),
	(162217, 122, '2014-01-15 00:29:38.000000', 'temperatura', 238.0000, 'ºC'),
	(162218, 122, '2014-01-15 00:29:39.000000', 'temperatura', 719.0000, 'ºC'),
	(162219, 122, '2014-01-15 00:29:40.000000', 'temperatura', 478.0000, 'ºC'),
	(162220, 122, '2014-01-15 00:29:41.000000', 'temperatura', 235.0000, 'ºC'),
	(162221, 122, '2014-01-15 00:29:42.000000', 'temperatura', 941.0000, 'ºC'),
	(162222, 122, '2014-01-15 00:29:43.000000', 'temperatura', 399.0000, 'ºC'),
	(162223, 122, '2014-01-15 00:29:44.000000', 'temperatura', 376.0000, 'ºC'),
	(162224, 122, '2014-01-15 00:29:45.000000', 'temperatura', 680.0000, 'ºC'),
	(162225, 122, '2014-01-15 00:29:46.000000', 'temperatura', 1076.0000, 'ºC'),
	(162226, 122, '2014-01-15 00:29:47.000000', 'temperatura', 937.0000, 'ºC'),
	(162227, 122, '2014-01-15 00:29:48.000000', 'temperatura', 261.0000, 'ºC'),
	(162228, 122, '2014-01-15 00:29:49.000000', 'temperatura', 892.0000, 'ºC'),
	(162229, 122, '2014-01-15 00:29:50.000000', 'temperatura', 77.0000, 'ºC'),
	(162230, 122, '2014-01-15 00:29:51.000000', 'temperatura', 111.0000, 'ºC'),
	(162231, 122, '2014-01-15 00:29:52.000000', 'temperatura', 325.0000, 'ºC'),
	(162232, 122, '2014-01-15 00:29:53.000000', 'temperatura', 91.0000, 'ºC'),
	(162233, 122, '2014-01-15 00:29:54.000000', 'temperatura', 683.0000, 'ºC'),
	(162234, 122, '2014-01-15 00:29:55.000000', 'temperatura', 742.0000, 'ºC'),
	(162235, 122, '2014-01-15 00:29:56.000000', 'temperatura', 461.0000, 'ºC'),
	(162236, 122, '2014-01-15 00:29:57.000000', 'temperatura', 79.0000, 'ºC'),
	(162237, 122, '2014-01-15 00:29:58.000000', 'temperatura', 214.0000, 'ºC'),
	(162238, 122, '2014-01-15 00:29:59.000000', 'temperatura', 832.0000, 'ºC'),
	(162239, 122, '2014-01-15 00:30:00.000000', 'temperatura', 1118.0000, 'ºC'),
	(162240, 122, '2014-01-15 00:30:01.000000', 'temperatura', 694.0000, 'ºC'),
	(162241, 122, '2014-01-15 00:30:02.000000', 'temperatura', 116.0000, 'ºC'),
	(162242, 122, '2014-01-15 00:30:03.000000', 'temperatura', 899.0000, 'ºC'),
	(162243, 122, '2014-01-15 00:30:04.000000', 'temperatura', 550.0000, 'ºC'),
	(162244, 122, '2014-01-15 00:30:05.000000', 'temperatura', 51.0000, 'ºC'),
	(162245, 122, '2014-01-15 00:30:06.000000', 'temperatura', 1007.0000, 'ºC'),
	(162246, 122, '2014-01-15 00:30:07.000000', 'temperatura', 83.0000, 'ºC'),
	(162247, 122, '2014-01-15 00:30:08.000000', 'temperatura', 995.0000, 'ºC'),
	(162248, 122, '2014-01-15 00:30:09.000000', 'temperatura', 1126.0000, 'ºC'),
	(162249, 122, '2014-01-15 00:30:10.000000', 'temperatura', 244.0000, 'ºC'),
	(162250, 122, '2014-01-15 00:30:11.000000', 'temperatura', 243.0000, 'ºC'),
	(162251, 122, '2014-01-15 00:30:12.000000', 'temperatura', 482.0000, 'ºC'),
	(162252, 122, '2014-01-15 00:30:13.000000', 'temperatura', 481.0000, 'ºC'),
	(162253, 122, '2014-01-15 00:30:14.000000', 'temperatura', 961.0000, 'ºC'),
	(162254, 122, '2014-01-15 00:30:15.000000', 'temperatura', 962.0000, 'ºC'),
	(162255, 122, '2014-01-15 00:30:16.000000', 'temperatura', 728.0000, 'ºC'),
	(162256, 122, '2014-01-15 00:30:17.000000', 'temperatura', 756.0000, 'ºC'),
	(162257, 122, '2014-01-15 00:30:18.000000', 'temperatura', 395.0000, 'ºC'),
	(162258, 122, '2014-01-15 00:30:19.000000', 'temperatura', 908.0000, 'ºC'),
	(162259, 122, '2014-01-15 00:30:20.000000', 'temperatura', 957.0000, 'ºC'),
	(162260, 122, '2014-01-15 00:30:21.000000', 'temperatura', 861.0000, 'ºC'),
	(162261, 122, '2014-01-15 00:30:22.000000', 'temperatura', 236.0000, 'ºC'),
	(162262, 122, '2014-01-15 00:30:23.000000', 'temperatura', 995.0000, 'ºC'),
	(162263, 122, '2014-01-15 00:30:24.000000', 'temperatura', 666.0000, 'ºC'),
	(162264, 122, '2014-01-15 00:30:25.000000', 'temperatura', 349.0000, 'ºC'),
	(162265, 122, '2014-01-15 00:30:26.000000', 'temperatura', 945.0000, 'ºC'),
	(162266, 122, '2014-01-15 00:30:27.000000', 'temperatura', 78.0000, 'ºC'),
	(162267, 122, '2014-01-15 00:30:28.000000', 'temperatura', 1156.0000, 'ºC'),
	(162268, 122, '2014-01-15 00:30:29.000000', 'temperatura', 745.0000, 'ºC'),
	(162269, 122, '2014-01-15 00:30:30.000000', 'temperatura', 259.0000, 'ºC'),
	(162270, 122, '2014-01-15 00:30:31.000000', 'temperatura', 261.0000, 'ºC'),
	(162271, 122, '2014-01-15 00:30:32.000000', 'temperatura', 528.0000, 'ºC'),
	(162272, 122, '2014-01-15 00:30:33.000000', 'temperatura', 659.0000, 'ºC'),
	(162273, 122, '2014-01-15 00:30:34.000000', 'temperatura', 510.0000, 'ºC'),
	(162274, 122, '2014-01-15 00:30:35.000000', 'temperatura', 573.0000, 'ºC'),
	(162275, 122, '2014-01-15 00:30:36.000000', 'temperatura', 134.0000, 'ºC'),
	(162276, 122, '2014-01-15 00:30:37.000000', 'temperatura', 155.0000, 'ºC'),
	(162277, 122, '2014-01-15 00:30:38.000000', 'temperatura', 371.0000, 'ºC'),
	(162278, 122, '2014-01-15 00:30:39.000000', 'temperatura', 192.0000, 'ºC'),
	(162279, 122, '2014-01-15 00:30:40.000000', 'temperatura', 1048.0000, 'ºC'),
	(162280, 122, '2014-01-15 00:30:41.000000', 'temperatura', 1064.0000, 'ºC'),
	(162281, 122, '2014-01-15 00:30:42.000000', 'temperatura', 977.0000, 'ºC'),
	(162282, 122, '2014-01-15 00:30:43.000000', 'temperatura', 493.0000, 'ºC'),
	(162283, 122, '2014-01-15 00:30:44.000000', 'temperatura', 736.0000, 'ºC'),
	(162284, 122, '2014-01-15 00:30:45.000000', 'temperatura', 1001.0000, 'ºC'),
	(162285, 122, '2014-01-15 00:30:46.000000', 'temperatura', 395.0000, 'ºC'),
	(162286, 122, '2014-01-15 00:30:47.000000', 'temperatura', 175.0000, 'ºC'),
	(162287, 122, '2014-01-15 00:30:48.000000', 'temperatura', 891.0000, 'ºC'),
	(162288, 122, '2014-01-15 00:30:49.000000', 'temperatura', 329.0000, 'ºC'),
	(162289, 122, '2014-01-15 00:30:50.000000', 'temperatura', 174.0000, 'ºC'),
	(162290, 122, '2014-01-15 00:30:51.000000', 'temperatura', 1081.0000, 'ºC'),
	(162291, 122, '2014-01-15 00:30:52.000000', 'temperatura', 84.0000, 'ºC'),
	(162292, 122, '2014-01-15 00:30:53.000000', 'temperatura', 778.0000, 'ºC'),
	(162293, 122, '2014-01-15 00:30:54.000000', 'temperatura', 39.0000, 'ºC'),
	(162294, 122, '2014-01-15 00:30:55.000000', 'temperatura', 262.0000, 'ºC'),
	(162295, 122, '2014-01-15 00:30:56.000000', 'temperatura', 1192.0000, 'ºC'),
	(162296, 122, '2014-01-15 00:30:57.000000', 'temperatura', 377.0000, 'ºC'),
	(162297, 122, '2014-01-15 00:30:58.000000', 'temperatura', 706.0000, 'ºC'),
	(162298, 122, '2014-01-15 00:30:59.000000', 'temperatura', 1.0000, 'ºC'),
	(162299, 122, '2014-01-15 00:31:00.000000', 'temperatura', 289.0000, 'ºC'),
	(162300, 122, '2014-01-15 00:31:01.000000', 'temperatura', 243.0000, 'ºC'),
	(162301, 122, '2014-01-15 00:31:02.000000', 'temperatura', 348.0000, 'ºC'),
	(162302, 122, '2014-01-15 00:31:03.000000', 'temperatura', 1012.0000, 'ºC'),
	(162303, 122, '2014-01-15 00:31:04.000000', 'temperatura', 414.0000, 'ºC'),
	(162304, 122, '2014-01-15 00:31:05.000000', 'temperatura', 235.0000, 'ºC'),
	(162305, 122, '2014-01-15 00:31:06.000000', 'temperatura', 1134.0000, 'ºC'),
	(162306, 122, '2014-01-15 00:31:07.000000', 'temperatura', 163.0000, 'ºC'),
	(162307, 122, '2014-01-15 00:31:08.000000', 'temperatura', 1017.0000, 'ºC'),
	(162308, 122, '2014-01-15 00:31:09.000000', 'temperatura', 995.0000, 'ºC'),
	(162309, 122, '2014-01-15 00:31:10.000000', 'temperatura', 726.0000, 'ºC'),
	(162310, 122, '2014-01-15 00:31:11.000000', 'temperatura', 644.0000, 'ºC'),
	(162311, 122, '2014-01-15 00:31:12.000000', 'temperatura', 1044.0000, 'ºC'),
	(162312, 122, '2014-01-15 00:31:13.000000', 'temperatura', 887.0000, 'ºC'),
	(162313, 122, '2014-01-15 00:31:14.000000', 'temperatura', 104.0000, 'ºC'),
	(162314, 122, '2014-01-15 00:31:15.000000', 'temperatura', 259.0000, 'ºC'),
	(162315, 122, '2014-01-15 00:31:16.000000', 'temperatura', 984.0000, 'ºC'),
	(162316, 122, '2014-01-15 00:31:17.000000', 'temperatura', 545.0000, 'ºC'),
	(162317, 122, '2014-01-15 00:31:18.000000', 'temperatura', 972.0000, 'ºC'),
	(162318, 122, '2014-01-15 00:31:19.000000', 'temperatura', 824.0000, 'ºC'),
	(162319, 122, '2014-01-15 00:31:20.000000', 'temperatura', 6.0000, 'ºC'),
	(162320, 122, '2014-01-15 00:31:21.000000', 'temperatura', 1159.0000, 'ºC'),
	(162321, 122, '2014-01-15 00:31:22.000000', 'temperatura', 979.0000, 'ºC'),
	(162322, 122, '2014-01-15 00:31:23.000000', 'temperatura', 218.0000, 'ºC'),
	(162323, 122, '2014-01-15 00:31:24.000000', 'temperatura', 551.0000, 'ºC'),
	(162324, 122, '2014-01-15 00:31:25.000000', 'temperatura', 903.0000, 'ºC'),
	(162325, 122, '2014-01-15 00:31:26.000000', 'temperatura', 462.0000, 'ºC'),
	(162326, 122, '2014-01-15 00:31:27.000000', 'temperatura', 800.0000, 'ºC'),
	(162327, 122, '2014-01-15 00:31:28.000000', 'temperatura', 216.0000, 'ºC'),
	(162328, 122, '2014-01-15 00:31:29.000000', 'temperatura', 1080.0000, 'ºC'),
	(162329, 122, '2014-01-15 00:31:30.000000', 'temperatura', 1153.0000, 'ºC'),
	(162330, 122, '2014-01-15 00:31:31.000000', 'temperatura', 124.0000, 'ºC'),
	(162331, 122, '2014-01-15 00:31:32.000000', 'temperatura', 764.0000, 'ºC'),
	(162332, 122, '2014-01-15 00:31:33.000000', 'temperatura', 1047.0000, 'ºC'),
	(162333, 122, '2014-01-15 00:31:34.000000', 'temperatura', 545.0000, 'ºC'),
	(162334, 122, '2014-01-15 00:31:35.000000', 'temperatura', 784.0000, 'ºC'),
	(162335, 122, '2014-01-15 00:31:36.000000', 'temperatura', 1086.0000, 'ºC'),
	(162336, 122, '2014-01-15 00:31:37.000000', 'temperatura', 680.0000, 'ºC'),
	(162337, 122, '2014-01-15 00:31:38.000000', 'temperatura', 141.0000, 'ºC'),
	(162338, 122, '2014-01-15 00:31:39.000000', 'temperatura', 1064.0000, 'ºC'),
	(162339, 122, '2014-01-15 00:31:40.000000', 'temperatura', 99.0000, 'ºC'),
	(162340, 122, '2014-01-15 00:31:41.000000', 'temperatura', 903.0000, 'ºC'),
	(162341, 122, '2014-01-15 00:31:42.000000', 'temperatura', 620.0000, 'ºC'),
	(162342, 122, '2014-01-15 00:31:43.000000', 'temperatura', 389.0000, 'ºC'),
	(162343, 122, '2014-01-15 00:31:44.000000', 'temperatura', 86.0000, 'ºC'),
	(162344, 122, '2014-01-15 00:31:45.000000', 'temperatura', 465.0000, 'ºC'),
	(162345, 122, '2014-01-15 00:31:46.000000', 'temperatura', 869.0000, 'ºC'),
	(162346, 122, '2014-01-15 00:31:47.000000', 'temperatura', 547.0000, 'ºC'),
	(162347, 122, '2014-01-15 00:31:48.000000', 'temperatura', 130.0000, 'ºC'),
	(162348, 122, '2014-01-15 00:31:49.000000', 'temperatura', 210.0000, 'ºC'),
	(162349, 122, '2014-01-15 00:31:50.000000', 'temperatura', 658.0000, 'ºC'),
	(162350, 122, '2014-01-15 00:31:51.000000', 'temperatura', 263.0000, 'ºC'),
	(162351, 122, '2014-01-15 00:31:52.000000', 'temperatura', 542.0000, 'ºC'),
	(162352, 122, '2014-01-15 00:31:53.000000', 'temperatura', 722.0000, 'ºC'),
	(162353, 122, '2014-01-15 00:31:54.000000', 'temperatura', 783.0000, 'ºC'),
	(162354, 122, '2014-01-15 00:31:55.000000', 'temperatura', 549.0000, 'ºC'),
	(162355, 122, '2014-01-15 00:31:56.000000', 'temperatura', 396.0000, 'ºC'),
	(162356, 122, '2014-01-15 00:31:57.000000', 'temperatura', 335.0000, 'ºC'),
	(162357, 122, '2014-01-15 00:31:58.000000', 'temperatura', 489.0000, 'ºC'),
	(162358, 122, '2014-01-15 00:31:59.000000', 'temperatura', 238.0000, 'ºC'),
	(162359, 122, '2014-01-15 00:32:00.000000', 'temperatura', 922.0000, 'ºC'),
	(162360, 122, '2014-01-15 00:32:01.000000', 'temperatura', 299.0000, 'ºC'),
	(162361, 122, '2014-01-15 00:32:02.000000', 'temperatura', 1128.0000, 'ºC'),
	(162362, 122, '2014-01-15 00:32:03.000000', 'temperatura', 1144.0000, 'ºC'),
	(162363, 122, '2014-01-15 00:32:04.000000', 'temperatura', 1135.0000, 'ºC'),
	(162364, 122, '2014-01-15 00:32:05.000000', 'temperatura', 1045.0000, 'ºC'),
	(162365, 122, '2014-01-15 00:32:06.000000', 'temperatura', 621.0000, 'ºC'),
	(162366, 122, '2014-01-15 00:32:07.000000', 'temperatura', 1169.0000, 'ºC'),
	(162367, 122, '2014-01-15 00:32:08.000000', 'temperatura', 382.0000, 'ºC'),
	(162368, 122, '2014-01-15 00:32:09.000000', 'temperatura', 805.0000, 'ºC'),
	(162369, 122, '2014-01-15 00:32:10.000000', 'temperatura', 481.0000, 'ºC'),
	(162370, 122, '2014-01-15 00:32:11.000000', 'temperatura', 1187.0000, 'ºC'),
	(162371, 122, '2014-01-15 00:32:12.000000', 'temperatura', 895.0000, 'ºC'),
	(162372, 122, '2014-01-15 00:32:13.000000', 'temperatura', 915.0000, 'ºC'),
	(162373, 122, '2014-01-15 00:32:14.000000', 'temperatura', 689.0000, 'ºC'),
	(162374, 122, '2014-01-15 00:32:15.000000', 'temperatura', 700.0000, 'ºC'),
	(162375, 122, '2014-01-15 00:32:16.000000', 'temperatura', 232.0000, 'ºC'),
	(162376, 122, '2014-01-15 00:32:17.000000', 'temperatura', 264.0000, 'ºC'),
	(162377, 122, '2014-01-15 00:32:18.000000', 'temperatura', 623.0000, 'ºC'),
	(162378, 122, '2014-01-15 00:32:19.000000', 'temperatura', 1125.0000, 'ºC'),
	(162379, 122, '2014-01-15 00:32:20.000000', 'temperatura', 154.0000, 'ºC'),
	(162380, 122, '2014-01-15 00:32:21.000000', 'temperatura', 997.0000, 'ºC'),
	(162381, 122, '2014-01-15 00:32:22.000000', 'temperatura', 924.0000, 'ºC'),
	(162382, 122, '2014-01-15 00:32:23.000000', 'temperatura', 429.0000, 'ºC'),
	(162383, 122, '2014-01-15 00:32:24.000000', 'temperatura', 575.0000, 'ºC'),
	(162384, 122, '2014-01-15 00:32:25.000000', 'temperatura', 388.0000, 'ºC'),
	(162385, 122, '2014-01-15 00:32:26.000000', 'temperatura', 216.0000, 'ºC'),
	(162386, 122, '2014-01-15 00:32:27.000000', 'temperatura', 1118.0000, 'ºC'),
	(162387, 122, '2014-01-15 00:32:28.000000', 'temperatura', 140.0000, 'ºC'),
	(162388, 122, '2014-01-15 00:32:29.000000', 'temperatura', 948.0000, 'ºC'),
	(162389, 122, '2014-01-15 00:32:30.000000', 'temperatura', 720.0000, 'ºC'),
	(162390, 122, '2014-01-15 00:32:31.000000', 'temperatura', 755.0000, 'ºC'),
	(162391, 122, '2014-01-15 00:32:32.000000', 'temperatura', 416.0000, 'ºC'),
	(162392, 122, '2014-01-15 00:32:33.000000', 'temperatura', 1016.0000, 'ºC'),
	(162393, 122, '2014-01-15 00:32:34.000000', 'temperatura', 230.0000, 'ºC'),
	(162394, 122, '2014-01-15 00:32:35.000000', 'temperatura', 506.0000, 'ºC'),
	(162395, 122, '2014-01-15 00:32:36.000000', 'temperatura', 637.0000, 'ºC'),
	(162396, 122, '2014-01-15 00:32:37.000000', 'temperatura', 470.0000, 'ºC'),
	(162397, 122, '2014-01-15 00:32:38.000000', 'temperatura', 437.0000, 'ºC'),
	(162398, 122, '2014-01-15 00:32:39.000000', 'temperatura', 776.0000, 'ºC'),
	(162399, 122, '2014-01-15 00:32:40.000000', 'temperatura', 168.0000, 'ºC'),
	(162400, 122, '2014-01-15 00:32:41.000000', 'temperatura', 914.0000, 'ºC'),
	(162401, 122, '2014-01-15 00:32:42.000000', 'temperatura', 465.0000, 'ºC'),
	(162402, 122, '2014-01-15 00:32:43.000000', 'temperatura', 786.0000, 'ºC'),
	(162403, 122, '2014-01-15 00:32:44.000000', 'temperatura', 133.0000, 'ºC'),
	(162404, 122, '2014-01-15 00:32:45.000000', 'temperatura', 708.0000, 'ºC'),
	(162405, 122, '2014-01-15 00:32:46.000000', 'temperatura', 742.0000, 'ºC'),
	(162406, 122, '2014-01-15 00:32:47.000000', 'temperatura', 388.0000, 'ºC'),
	(162407, 122, '2014-01-15 00:32:48.000000', 'temperatura', 913.0000, 'ºC'),
	(162408, 122, '2014-01-15 00:32:49.000000', 'temperatura', 1002.0000, 'ºC'),
	(162409, 122, '2014-01-15 00:32:50.000000', 'temperatura', 1072.0000, 'ºC'),
	(162410, 122, '2014-01-15 00:32:51.000000', 'temperatura', 1154.0000, 'ºC'),
	(162411, 122, '2014-01-15 00:32:52.000000', 'temperatura', 155.0000, 'ºC'),
	(162412, 122, '2014-01-15 00:32:53.000000', 'temperatura', 912.0000, 'ºC'),
	(162413, 122, '2014-01-15 00:32:54.000000', 'temperatura', 497.0000, 'ºC'),
	(162414, 122, '2014-01-15 00:32:55.000000', 'temperatura', 949.0000, 'ºC'),
	(162415, 122, '2014-01-15 00:32:56.000000', 'temperatura', 853.0000, 'ºC'),
	(162416, 122, '2014-01-15 00:32:57.000000', 'temperatura', 221.0000, 'ºC'),
	(162417, 122, '2014-01-15 00:32:58.000000', 'temperatura', 944.0000, 'ºC'),
	(162418, 122, '2014-01-15 00:32:59.000000', 'temperatura', 458.0000, 'ºC'),
	(162419, 122, '2014-01-15 00:33:00.000000', 'temperatura', 658.0000, 'ºC'),
	(162420, 122, '2014-01-15 00:33:01.000000', 'temperatura', 719.0000, 'ºC'),
	(162421, 122, '2014-01-15 00:33:02.000000', 'temperatura', 419.0000, 'ºC'),
	(162422, 122, '2014-01-15 00:33:03.000000', 'temperatura', 1141.0000, 'ºC'),
	(162423, 122, '2014-01-15 00:33:04.000000', 'temperatura', 845.0000, 'ºC'),
	(162424, 122, '2014-01-15 00:33:05.000000', 'temperatura', 805.0000, 'ºC'),
	(162425, 122, '2014-01-15 00:33:06.000000', 'temperatura', 291.0000, 'ºC'),
	(162426, 122, '2014-01-15 00:33:07.000000', 'temperatura', 239.0000, 'ºC'),
	(162427, 122, '2014-01-15 00:33:08.000000', 'temperatura', 322.0000, 'ºC'),
	(162428, 122, '2014-01-15 00:33:09.000000', 'temperatura', 896.0000, 'ºC'),
	(162429, 122, '2014-01-15 00:33:10.000000', 'temperatura', 1114.0000, 'ºC'),
	(162430, 122, '2014-01-15 00:33:11.000000', 'temperatura', 484.0000, 'ºC'),
	(162431, 122, '2014-01-15 00:33:12.000000', 'temperatura', 275.0000, 'ºC'),
	(162432, 122, '2014-01-15 00:33:13.000000', 'temperatura', 1126.0000, 'ºC'),
	(162433, 122, '2014-01-15 00:33:14.000000', 'temperatura', 4.0000, 'ºC'),
	(162434, 122, '2014-01-15 00:33:15.000000', 'temperatura', 245.0000, 'ºC'),
	(162435, 122, '2014-01-15 00:33:16.000000', 'temperatura', 12.0000, 'ºC'),
	(162436, 122, '2014-01-15 00:33:17.000000', 'temperatura', 526.0000, 'ºC'),
	(162437, 122, '2014-01-15 00:33:18.000000', 'temperatura', 196.0000, 'ºC'),
	(162438, 122, '2014-01-15 00:33:19.000000', 'temperatura', 602.0000, 'ºC'),
	(162439, 122, '2014-01-15 00:33:20.000000', 'temperatura', 21.0000, 'ºC'),
	(162440, 122, '2014-01-15 00:33:21.000000', 'temperatura', 700.0000, 'ºC'),
	(162441, 122, '2014-01-15 00:33:22.000000', 'temperatura', 1036.0000, 'ºC'),
	(162442, 122, '2014-01-15 00:33:23.000000', 'temperatura', 684.0000, 'ºC'),
	(162443, 122, '2014-01-15 00:33:24.000000', 'temperatura', 309.0000, 'ºC'),
	(162444, 122, '2014-01-15 00:33:25.000000', 'temperatura', 695.0000, 'ºC'),
	(162445, 122, '2014-01-15 00:33:26.000000', 'temperatura', 149.0000, 'ºC'),
	(162446, 122, '2014-01-15 00:33:27.000000', 'temperatura', 1062.0000, 'ºC'),
	(162447, 122, '2014-01-15 00:33:28.000000', 'temperatura', 62.0000, 'ºC'),
	(162448, 122, '2014-01-15 00:33:29.000000', 'temperatura', 724.0000, 'ºC'),
	(162449, 122, '2014-01-15 00:33:30.000000', 'temperatura', 1033.0000, 'ºC'),
	(162450, 122, '2014-01-15 00:33:31.000000', 'temperatura', 594.0000, 'ºC'),
	(162451, 122, '2014-01-15 00:33:32.000000', 'temperatura', 1073.0000, 'ºC'),
	(162452, 122, '2014-01-15 00:33:33.000000', 'temperatura', 1182.0000, 'ºC'),
	(162453, 122, '2014-01-15 00:33:34.000000', 'temperatura', 290.0000, 'ºC'),
	(162454, 122, '2014-01-15 00:33:35.000000', 'temperatura', 306.0000, 'ºC'),
	(162455, 122, '2014-01-15 00:33:36.000000', 'temperatura', 660.0000, 'ºC'),
	(162456, 122, '2014-01-15 00:33:37.000000', 'temperatura', 1185.0000, 'ºC'),
	(162457, 122, '2014-01-15 00:33:38.000000', 'temperatura', 343.0000, 'ºC'),
	(162458, 122, '2014-01-15 00:33:39.000000', 'temperatura', 563.0000, 'ºC'),
	(162459, 122, '2014-01-15 00:33:40.000000', 'temperatura', 584.0000, 'ºC'),
	(162460, 122, '2014-01-15 00:33:41.000000', 'temperatura', 34.0000, 'ºC'),
	(162461, 122, '2014-01-15 00:33:42.000000', 'temperatura', 816.0000, 'ºC'),
	(162462, 122, '2014-01-15 00:33:43.000000', 'temperatura', 378.0000, 'ºC'),
	(162463, 122, '2014-01-15 00:33:44.000000', 'temperatura', 644.0000, 'ºC'),
	(162464, 122, '2014-01-15 00:33:45.000000', 'temperatura', 885.0000, 'ºC'),
	(162465, 122, '2014-01-15 00:33:46.000000', 'temperatura', 94.0000, 'ºC'),
	(162466, 122, '2014-01-15 00:33:47.000000', 'temperatura', 217.0000, 'ºC'),
	(162467, 122, '2014-01-15 00:33:48.000000', 'temperatura', 804.0000, 'ºC'),
	(162468, 122, '2014-01-15 00:33:49.000000', 'temperatura', 968.0000, 'ºC'),
	(162469, 122, '2014-01-15 00:33:50.000000', 'temperatura', 30.0000, 'ºC'),
	(162470, 122, '2014-01-15 00:33:51.000000', 'temperatura', 844.0000, 'ºC'),
	(162471, 122, '2014-01-15 00:33:52.000000', 'temperatura', 533.0000, 'ºC'),
	(162472, 122, '2014-01-15 00:33:53.000000', 'temperatura', 134.0000, 'ºC'),
	(162473, 122, '2014-01-15 00:33:54.000000', 'temperatura', 269.0000, 'ºC'),
	(162474, 122, '2014-01-15 00:33:55.000000', 'temperatura', 942.0000, 'ºC'),
	(162475, 122, '2014-01-15 00:33:56.000000', 'temperatura', 307.0000, 'ºC'),
	(162476, 122, '2014-01-15 00:33:57.000000', 'temperatura', 1109.0000, 'ºC'),
	(162477, 122, '2014-01-15 00:33:58.000000', 'temperatura', 1022.0000, 'ºC'),
	(162478, 122, '2014-01-15 00:33:59.000000', 'temperatura', 586.0000, 'ºC'),
	(162479, 122, '2014-01-15 00:34:00.000000', 'temperatura', 1064.0000, 'ºC'),
	(162480, 122, '2014-01-15 00:34:01.000000', 'temperatura', 1163.0000, 'ºC'),
	(162481, 122, '2014-01-15 00:34:02.000000', 'temperatura', 222.0000, 'ºC'),
	(162482, 122, '2014-01-15 00:34:03.000000', 'temperatura', 20.0000, 'ºC'),
	(162483, 122, '2014-01-15 00:34:04.000000', 'temperatura', 637.0000, 'ºC'),
	(162484, 122, '2014-01-15 00:34:05.000000', 'temperatura', 727.0000, 'ºC'),
	(162485, 122, '2014-01-15 00:34:06.000000', 'temperatura', 521.0000, 'ºC'),
	(162486, 122, '2014-01-15 00:34:07.000000', 'temperatura', 427.0000, 'ºC'),
	(162487, 122, '2014-01-15 00:34:08.000000', 'temperatura', 572.0000, 'ºC'),
	(162488, 122, '2014-01-15 00:34:09.000000', 'temperatura', 380.0000, 'ºC'),
	(162489, 122, '2014-01-15 00:34:10.000000', 'temperatura', 185.0000, 'ºC'),
	(162490, 122, '2014-01-15 00:34:11.000000', 'temperatura', 986.0000, 'ºC'),
	(162491, 122, '2014-01-15 00:34:12.000000', 'temperatura', 774.0000, 'ºC'),
	(162492, 122, '2014-01-15 00:34:13.000000', 'temperatura', 913.0000, 'ºC'),
	(162493, 122, '2014-01-15 00:34:14.000000', 'temperatura', 1043.0000, 'ºC'),
	(162494, 122, '2014-01-15 00:34:15.000000', 'temperatura', 75.0000, 'ºC'),
	(162495, 122, '2014-01-15 00:34:16.000000', 'temperatura', 848.0000, 'ºC'),
	(162496, 122, '2014-01-15 00:34:17.000000', 'temperatura', 414.0000, 'ºC'),
	(162497, 122, '2014-01-15 00:34:18.000000', 'temperatura', 726.0000, 'ºC'),
	(162498, 122, '2014-01-15 00:34:19.000000', 'temperatura', 1188.0000, 'ºC'),
	(162499, 122, '2014-01-15 00:34:20.000000', 'temperatura', 165.0000, 'ºC'),
	(162500, 122, '2014-01-15 00:34:21.000000', 'temperatura', 860.0000, 'ºC'),
	(162501, 122, '2014-01-15 00:34:22.000000', 'temperatura', 205.0000, 'ºC'),
	(162502, 122, '2014-01-15 00:34:23.000000', 'temperatura', 845.0000, 'ºC'),
	(162503, 122, '2014-01-15 00:34:24.000000', 'temperatura', 12.0000, 'ºC'),
	(162504, 122, '2014-01-15 00:34:25.000000', 'temperatura', 1127.0000, 'ºC'),
	(162505, 122, '2014-01-15 00:34:26.000000', 'temperatura', 797.0000, 'ºC'),
	(162506, 122, '2014-01-15 00:34:27.000000', 'temperatura', 606.0000, 'ºC'),
	(162507, 122, '2014-01-15 00:34:28.000000', 'temperatura', 637.0000, 'ºC'),
	(162508, 122, '2014-01-15 00:34:29.000000', 'temperatura', 169.0000, 'ºC'),
	(162509, 122, '2014-01-15 00:34:30.000000', 'temperatura', 134.0000, 'ºC'),
	(162510, 122, '2014-01-15 00:34:31.000000', 'temperatura', 164.0000, 'ºC'),
	(162511, 122, '2014-01-15 00:34:32.000000', 'temperatura', 420.0000, 'ºC'),
	(162512, 122, '2014-01-15 00:34:33.000000', 'temperatura', 409.0000, 'ºC'),
	(162513, 122, '2014-01-15 00:34:34.000000', 'temperatura', 784.0000, 'ºC'),
	(162514, 122, '2014-01-15 00:34:35.000000', 'temperatura', 294.0000, 'ºC'),
	(162515, 122, '2014-01-15 00:34:36.000000', 'temperatura', 319.0000, 'ºC'),
	(162516, 122, '2014-01-15 00:34:37.000000', 'temperatura', 714.0000, 'ºC'),
	(162517, 122, '2014-01-15 00:34:38.000000', 'temperatura', 211.0000, 'ºC'),
	(162518, 122, '2014-01-15 00:34:39.000000', 'temperatura', 114.0000, 'ºC'),
	(162519, 122, '2014-01-15 00:34:40.000000', 'temperatura', 1139.0000, 'ºC'),
	(162520, 122, '2014-01-15 00:34:41.000000', 'temperatura', 553.0000, 'ºC'),
	(162521, 122, '2014-01-15 00:34:42.000000', 'temperatura', 549.0000, 'ºC'),
	(162522, 122, '2014-01-15 00:34:43.000000', 'temperatura', 1088.0000, 'ºC'),
	(162523, 122, '2014-01-15 00:34:44.000000', 'temperatura', 190.0000, 'ºC'),
	(162524, 122, '2014-01-15 00:34:45.000000', 'temperatura', 88.0000, 'ºC'),
	(162525, 122, '2014-01-15 00:34:46.000000', 'temperatura', 1071.0000, 'ºC'),
	(162526, 122, '2014-01-15 00:34:47.000000', 'temperatura', 290.0000, 'ºC'),
	(162527, 122, '2014-01-15 00:34:48.000000', 'temperatura', 637.0000, 'ºC'),
	(162528, 122, '2014-01-15 00:34:49.000000', 'temperatura', 1116.0000, 'ºC'),
	(162529, 122, '2014-01-15 00:34:50.000000', 'temperatura', 70.0000, 'ºC'),
	(162530, 122, '2014-01-15 00:34:51.000000', 'temperatura', 602.0000, 'ºC'),
	(162531, 122, '2014-01-15 00:34:52.000000', 'temperatura', 400.0000, 'ºC'),
	(162532, 122, '2014-01-15 00:34:53.000000', 'temperatura', 195.0000, 'ºC'),
	(162533, 122, '2014-01-15 00:34:54.000000', 'temperatura', 975.0000, 'ºC'),
	(162534, 122, '2014-01-15 00:34:55.000000', 'temperatura', 690.0000, 'ºC'),
	(162535, 122, '2014-01-15 00:34:56.000000', 'temperatura', 528.0000, 'ºC'),
	(162536, 122, '2014-01-15 00:34:57.000000', 'temperatura', 569.0000, 'ºC'),
	(162537, 122, '2014-01-15 00:34:58.000000', 'temperatura', 62.0000, 'ºC'),
	(162538, 122, '2014-01-15 00:34:59.000000', 'temperatura', 1003.0000, 'ºC'),
	(162539, 122, '2014-01-15 00:35:00.000000', 'temperatura', 29.0000, 'ºC'),
	(162540, 122, '2014-01-15 00:35:01.000000', 'temperatura', 738.0000, 'ºC'),
	(162541, 122, '2014-01-15 00:35:02.000000', 'temperatura', 3.0000, 'ºC'),
	(162542, 122, '2014-01-15 00:35:03.000000', 'temperatura', 202.0000, 'ºC'),
	(162543, 122, '2014-01-15 00:35:04.000000', 'temperatura', 1001.0000, 'ºC'),
	(162544, 122, '2014-01-15 00:35:05.000000', 'temperatura', 800.0000, 'ºC'),
	(162545, 122, '2014-01-15 00:35:06.000000', 'temperatura', 998.0000, 'ºC'),
	(162546, 122, '2014-01-15 00:35:07.000000', 'temperatura', 190.0000, 'ºC'),
	(162547, 122, '2014-01-15 00:35:08.000000', 'temperatura', 355.0000, 'ºC'),
	(162548, 122, '2014-01-15 00:35:09.000000', 'temperatura', 5.0000, 'ºC'),
	(162549, 122, '2014-01-15 00:35:10.000000', 'temperatura', 161.0000, 'ºC'),
	(162550, 122, '2014-01-15 00:35:11.000000', 'temperatura', 791.0000, 'ºC'),
	(162551, 122, '2014-01-15 00:35:12.000000', 'temperatura', 1071.0000, 'ºC'),
	(162552, 122, '2014-01-15 00:35:13.000000', 'temperatura', 583.0000, 'ºC'),
	(162553, 122, '2014-01-15 00:35:14.000000', 'temperatura', 904.0000, 'ºC'),
	(162554, 122, '2014-01-15 00:35:15.000000', 'temperatura', 373.0000, 'ºC'),
	(162555, 122, '2014-01-15 00:35:16.000000', 'temperatura', 351.0000, 'ºC'),
	(162556, 122, '2014-01-15 00:35:17.000000', 'temperatura', 636.0000, 'ºC'),
	(162557, 122, '2014-01-15 00:35:18.000000', 'temperatura', 928.0000, 'ºC'),
	(162558, 122, '2014-01-15 00:35:19.000000', 'temperatura', 332.0000, 'ºC'),
	(162559, 122, '2014-01-15 00:35:20.000000', 'temperatura', 75.0000, 'ºC'),
	(162560, 122, '2014-01-15 00:35:21.000000', 'temperatura', 581.0000, 'ºC'),
	(162561, 122, '2014-01-15 00:35:22.000000', 'temperatura', 282.0000, 'ºC'),
	(162562, 122, '2014-01-15 00:35:23.000000', 'temperatura', 868.0000, 'ºC'),
	(162563, 122, '2014-01-15 00:35:24.000000', 'temperatura', 1093.0000, 'ºC'),
	(162564, 122, '2014-01-15 00:35:25.000000', 'temperatura', 460.0000, 'ºC'),
	(162565, 122, '2014-01-15 00:35:26.000000', 'temperatura', 223.0000, 'ºC'),
	(162566, 122, '2014-01-15 00:35:27.000000', 'temperatura', 934.0000, 'ºC'),
	(162567, 122, '2014-01-15 00:35:28.000000', 'temperatura', 401.0000, 'ºC'),
	(162568, 122, '2014-01-15 00:35:29.000000', 'temperatura', 404.0000, 'ºC'),
	(162569, 122, '2014-01-15 00:35:30.000000', 'temperatura', 818.0000, 'ºC'),
	(162570, 122, '2014-01-15 00:35:31.000000', 'temperatura', 478.0000, 'ºC'),
	(162571, 122, '2014-01-15 00:35:32.000000', 'temperatura', 1136.0000, 'ºC'),
	(162572, 122, '2014-01-15 00:35:33.000000', 'temperatura', 649.0000, 'ºC'),
	(162573, 122, '2014-01-15 00:35:34.000000', 'temperatura', 1035.0000, 'ºC'),
	(162574, 122, '2014-01-15 00:35:35.000000', 'temperatura', 829.0000, 'ºC'),
	(162575, 122, '2014-01-15 00:35:36.000000', 'temperatura', 1041.0000, 'ºC'),
	(162576, 122, '2014-01-15 00:35:37.000000', 'temperatura', 320.0000, 'ºC'),
	(162577, 122, '2014-01-15 00:35:38.000000', 'temperatura', 874.0000, 'ºC'),
	(162578, 122, '2014-01-15 00:35:39.000000', 'temperatura', 1013.0000, 'ºC'),
	(162579, 122, '2014-01-15 00:35:40.000000', 'temperatura', 44.0000, 'ºC'),
	(162580, 122, '2014-01-15 00:35:41.000000', 'temperatura', 781.0000, 'ºC'),
	(162581, 122, '2014-01-15 00:35:42.000000', 'temperatura', 174.0000, 'ºC'),
	(162582, 122, '2014-01-15 00:35:43.000000', 'temperatura', 926.0000, 'ºC'),
	(162583, 122, '2014-01-15 00:35:44.000000', 'temperatura', 511.0000, 'ºC'),
	(162584, 122, '2014-01-15 00:35:45.000000', 'temperatura', 977.0000, 'ºC'),
	(162585, 122, '2014-01-15 00:35:46.000000', 'temperatura', 950.0000, 'ºC'),
	(162586, 122, '2014-01-15 00:35:47.000000', 'temperatura', 621.0000, 'ºC'),
	(162587, 122, '2014-01-15 00:35:48.000000', 'temperatura', 256.0000, 'ºC'),
	(162588, 122, '2014-01-15 00:35:49.000000', 'temperatura', 618.0000, 'ºC'),
	(162589, 122, '2014-01-15 00:35:50.000000', 'temperatura', 1121.0000, 'ºC'),
	(162590, 122, '2014-01-15 00:35:51.000000', 'temperatura', 153.0000, 'ºC'),
	(162591, 122, '2014-01-15 00:35:52.000000', 'temperatura', 1004.0000, 'ºC'),
	(162592, 122, '2014-01-15 00:35:53.000000', 'temperatura', 960.0000, 'ºC'),
	(162593, 122, '2014-01-15 00:35:54.000000', 'temperatura', 588.0000, 'ºC'),
	(162594, 122, '2014-01-15 00:35:55.000000', 'temperatura', 59.0000, 'ºC'),
	(162595, 122, '2014-01-15 00:35:56.000000', 'temperatura', 933.0000, 'ºC'),
	(162596, 122, '2014-01-15 00:35:57.000000', 'temperatura', 887.0000, 'ºC'),
	(162597, 122, '2014-01-15 00:35:58.000000', 'temperatura', 438.0000, 'ºC'),
	(162598, 122, '2014-01-15 00:35:59.000000', 'temperatura', 729.0000, 'ºC'),
	(162599, 122, '2014-01-15 00:36:00.000000', 'temperatura', 1132.0000, 'ºC'),
	(162600, 122, '2014-01-15 00:36:01.000000', 'temperatura', 1074.0000, 'ºC'),
	(162601, 122, '2014-01-15 00:36:02.000000', 'temperatura', 775.0000, 'ºC'),
	(162602, 122, '2014-01-15 00:36:03.000000', 'temperatura', 653.0000, 'ºC'),
	(162603, 122, '2014-01-15 00:36:04.000000', 'temperatura', 939.0000, 'ºC'),
	(162604, 122, '2014-01-15 00:36:05.000000', 'temperatura', 337.0000, 'ºC'),
	(162605, 122, '2014-01-15 00:36:06.000000', 'temperatura', 67.0000, 'ºC'),
	(162606, 122, '2014-01-15 00:36:07.000000', 'temperatura', 525.0000, 'ºC'),
	(162607, 122, '2014-01-15 00:36:08.000000', 'temperatura', 23.0000, 'ºC'),
	(162608, 122, '2014-01-15 00:36:09.000000', 'temperatura', 942.0000, 'ºC'),
	(162609, 122, '2014-01-15 00:36:10.000000', 'temperatura', 1041.0000, 'ºC'),
	(162610, 122, '2014-01-15 00:36:11.000000', 'temperatura', 1180.0000, 'ºC'),
	(162611, 122, '2014-01-15 00:36:12.000000', 'temperatura', 378.0000, 'ºC'),
	(162612, 122, '2014-01-15 00:36:13.000000', 'temperatura', 749.0000, 'ºC'),
	(162613, 122, '2014-01-15 00:36:14.000000', 'temperatura', 212.0000, 'ºC'),
	(162614, 122, '2014-01-15 00:36:15.000000', 'temperatura', 12.0000, 'ºC'),
	(162615, 122, '2014-01-15 00:36:16.000000', 'temperatura', 625.0000, 'ºC'),
	(162616, 122, '2014-01-15 00:36:17.000000', 'temperatura', 688.0000, 'ºC'),
	(162617, 122, '2014-01-15 00:36:18.000000', 'temperatura', 368.0000, 'ºC'),
	(162618, 122, '2014-01-15 00:36:19.000000', 'temperatura', 976.0000, 'ºC'),
	(162619, 122, '2014-01-15 00:36:20.000000', 'temperatura', 175.0000, 'ºC'),
	(162620, 122, '2014-01-15 00:36:21.000000', 'temperatura', 347.0000, 'ºC'),
	(162621, 122, '2014-01-15 00:36:22.000000', 'temperatura', 10.0000, 'ºC'),
	(162622, 122, '2014-01-15 00:36:23.000000', 'temperatura', 211.0000, 'ºC'),
	(162623, 122, '2014-01-15 00:36:24.000000', 'temperatura', 1027.0000, 'ºC'),
	(162624, 122, '2014-01-15 00:36:25.000000', 'temperatura', 899.0000, 'ºC'),
	(162625, 122, '2014-01-15 00:36:26.000000', 'temperatura', 217.0000, 'ºC'),
	(162626, 122, '2014-01-15 00:36:27.000000', 'temperatura', 790.0000, 'ºC'),
	(162627, 122, '2014-01-15 00:36:28.000000', 'temperatura', 896.0000, 'ºC'),
	(162628, 122, '2014-01-15 00:36:29.000000', 'temperatura', 912.0000, 'ºC'),
	(162629, 122, '2014-01-15 00:36:30.000000', 'temperatura', 671.0000, 'ºC'),
	(162630, 122, '2014-01-15 00:36:31.000000', 'temperatura', 620.0000, 'ºC'),
	(162631, 122, '2014-01-15 00:36:32.000000', 'temperatura', 1090.0000, 'ºC'),
	(162632, 122, '2014-01-15 00:36:33.000000', 'temperatura', 1187.0000, 'ºC'),
	(162633, 122, '2014-01-15 00:36:34.000000', 'temperatura', 268.0000, 'ºC'),
	(162634, 122, '2014-01-15 00:36:35.000000', 'temperatura', 180.0000, 'ºC'),
	(162635, 122, '2014-01-15 00:36:36.000000', 'temperatura', 95.0000, 'ºC'),
	(162636, 122, '2014-01-15 00:36:37.000000', 'temperatura', 1136.0000, 'ºC'),
	(162637, 122, '2014-01-15 00:36:38.000000', 'temperatura', 595.0000, 'ºC'),
	(162638, 122, '2014-01-15 00:36:39.000000', 'temperatura', 768.0000, 'ºC'),
	(162639, 122, '2014-01-15 00:36:40.000000', 'temperatura', 853.0000, 'ºC'),
	(162640, 122, '2014-01-15 00:36:41.000000', 'temperatura', 765.0000, 'ºC'),
	(162641, 122, '2014-01-15 00:36:42.000000', 'temperatura', 66.0000, 'ºC'),
	(162642, 122, '2014-01-15 00:36:43.000000', 'temperatura', 433.0000, 'ºC'),
	(162643, 122, '2014-01-15 00:36:44.000000', 'temperatura', 770.0000, 'ºC'),
	(162644, 122, '2014-01-15 00:36:45.000000', 'temperatura', 152.0000, 'ºC'),
	(162645, 122, '2014-01-15 00:36:46.000000', 'temperatura', 848.0000, 'ºC'),
	(162646, 122, '2014-01-15 00:36:47.000000', 'temperatura', 184.0000, 'ºC'),
	(162647, 122, '2014-01-15 00:36:48.000000', 'temperatura', 778.0000, 'ºC'),
	(162648, 122, '2014-01-15 00:36:49.000000', 'temperatura', 936.0000, 'ºC'),
	(162649, 122, '2014-01-15 00:36:50.000000', 'temperatura', 1149.0000, 'ºC'),
	(162650, 122, '2014-01-15 00:36:51.000000', 'temperatura', 537.0000, 'ºC'),
	(162651, 122, '2014-01-15 00:36:52.000000', 'temperatura', 440.0000, 'ºC'),
	(162652, 122, '2014-01-15 00:36:53.000000', 'temperatura', 588.0000, 'ºC'),
	(162653, 122, '2014-01-15 00:36:54.000000', 'temperatura', 421.0000, 'ºC'),
	(162654, 122, '2014-01-15 00:36:55.000000', 'temperatura', 343.0000, 'ºC'),
	(162655, 122, '2014-01-15 00:36:56.000000', 'temperatura', 452.0000, 'ºC'),
	(162656, 122, '2014-01-15 00:36:57.000000', 'temperatura', 30.0000, 'ºC'),
	(162657, 122, '2014-01-15 00:36:58.000000', 'temperatura', 1194.0000, 'ºC'),
	(162658, 122, '2014-01-15 00:36:59.000000', 'temperatura', 1083.0000, 'ºC'),
	(162659, 122, '2014-01-15 00:37:00.000000', 'temperatura', 634.0000, 'ºC'),
	(162660, 122, '2014-01-15 00:37:01.000000', 'temperatura', 1121.0000, 'ºC'),
	(162661, 122, '2014-01-15 00:37:02.000000', 'temperatura', 101.0000, 'ºC'),
	(162662, 122, '2014-01-15 00:37:03.000000', 'temperatura', 744.0000, 'ºC'),
	(162663, 122, '2014-01-15 00:37:04.000000', 'temperatura', 1016.0000, 'ºC'),
	(162664, 122, '2014-01-15 00:37:05.000000', 'temperatura', 451.0000, 'ºC'),
	(162665, 122, '2014-01-15 00:37:06.000000', 'temperatura', 405.0000, 'ºC'),
	(162666, 122, '2014-01-15 00:37:07.000000', 'temperatura', 673.0000, 'ºC'),
	(162667, 122, '2014-01-15 00:37:08.000000', 'temperatura', 949.0000, 'ºC'),
	(162668, 122, '2014-01-15 00:37:09.000000', 'temperatura', 328.0000, 'ºC'),
	(162669, 122, '2014-01-15 00:37:10.000000', 'temperatura', 1193.0000, 'ºC'),
	(162670, 122, '2014-01-15 00:37:11.000000', 'temperatura', 184.0000, 'ºC'),
	(162671, 122, '2014-01-15 00:37:12.000000', 'temperatura', 939.0000, 'ºC'),
	(162672, 122, '2014-01-15 00:37:13.000000', 'temperatura', 544.0000, 'ºC'),
	(162673, 122, '2014-01-15 00:37:14.000000', 'temperatura', 1106.0000, 'ºC'),
	(162674, 122, '2014-01-15 00:37:15.000000', 'temperatura', 295.0000, 'ºC'),
	(162675, 122, '2014-01-15 00:37:16.000000', 'temperatura', 559.0000, 'ºC'),
	(162676, 122, '2014-01-15 00:37:17.000000', 'temperatura', 710.0000, 'ºC'),
	(162677, 122, '2014-01-15 00:37:18.000000', 'temperatura', 673.0000, 'ºC'),
	(162678, 122, '2014-01-15 00:37:19.000000', 'temperatura', 34.0000, 'ºC'),
	(162679, 122, '2014-01-15 00:37:20.000000', 'temperatura', 553.0000, 'ºC'),
	(162680, 122, '2014-01-15 00:37:21.000000', 'temperatura', 263.0000, 'ºC'),
	(162681, 122, '2014-01-15 00:37:22.000000', 'temperatura', 857.0000, 'ºC'),
	(162682, 122, '2014-01-15 00:37:23.000000', 'temperatura', 1095.0000, 'ºC'),
	(162683, 122, '2014-01-15 00:37:24.000000', 'temperatura', 507.0000, 'ºC'),
	(162684, 122, '2014-01-15 00:37:25.000000', 'temperatura', 450.0000, 'ºC'),
	(162685, 122, '2014-01-15 00:37:26.000000', 'temperatura', 727.0000, 'ºC'),
	(162686, 122, '2014-01-15 00:37:27.000000', 'temperatura', 1088.0000, 'ºC'),
	(162687, 122, '2014-01-15 00:37:28.000000', 'temperatura', 857.0000, 'ºC'),
	(162688, 122, '2014-01-15 00:37:29.000000', 'temperatura', 1024.0000, 'ºC'),
	(162689, 122, '2014-01-15 00:37:30.000000', 'temperatura', 147.0000, 'ºC'),
	(162690, 122, '2014-01-15 00:37:31.000000', 'temperatura', 66.0000, 'ºC'),
	(162691, 122, '2014-01-15 00:37:32.000000', 'temperatura', 1087.0000, 'ºC'),
	(162692, 122, '2014-01-15 00:37:33.000000', 'temperatura', 439.0000, 'ºC'),
	(162693, 122, '2014-01-15 00:37:34.000000', 'temperatura', 136.0000, 'ºC'),
	(162694, 122, '2014-01-15 00:37:35.000000', 'temperatura', 562.0000, 'ºC'),
	(162695, 122, '2014-01-15 00:37:36.000000', 'temperatura', 2.0000, 'ºC'),
	(162696, 122, '2014-01-15 00:37:37.000000', 'temperatura', 727.0000, 'ºC'),
	(162697, 122, '2014-01-15 00:37:38.000000', 'temperatura', 28.0000, 'ºC'),
	(162698, 122, '2014-01-15 00:37:39.000000', 'temperatura', 359.0000, 'ºC'),
	(162699, 122, '2014-01-15 00:37:40.000000', 'temperatura', 511.0000, 'ºC'),
	(162700, 122, '2014-01-15 00:37:41.000000', 'temperatura', 281.0000, 'ºC'),
	(162701, 122, '2014-01-15 00:37:42.000000', 'temperatura', 1070.0000, 'ºC'),
	(162702, 122, '2014-01-15 00:37:43.000000', 'temperatura', 907.0000, 'ºC'),
	(162703, 122, '2014-01-15 00:37:44.000000', 'temperatura', 125.0000, 'ºC'),
	(162704, 122, '2014-01-15 00:37:45.000000', 'temperatura', 305.0000, 'ºC'),
	(162705, 122, '2014-01-15 00:37:46.000000', 'temperatura', 1151.0000, 'ºC'),
	(162706, 122, '2014-01-15 00:37:47.000000', 'temperatura', 41.0000, 'ºC'),
	(162707, 122, '2014-01-15 00:37:48.000000', 'temperatura', 353.0000, 'ºC'),
	(162708, 122, '2014-01-15 00:37:49.000000', 'temperatura', 440.0000, 'ºC'),
	(162709, 122, '2014-01-15 00:37:50.000000', 'temperatura', 1144.0000, 'ºC'),
	(162710, 122, '2014-01-15 00:37:51.000000', 'temperatura', 799.0000, 'ºC'),
	(162711, 122, '2014-01-15 00:37:52.000000', 'temperatura', 565.0000, 'ºC'),
	(162712, 122, '2014-01-15 00:37:53.000000', 'temperatura', 427.0000, 'ºC'),
	(162713, 122, '2014-01-15 00:37:54.000000', 'temperatura', 439.0000, 'ºC'),
	(162714, 122, '2014-01-15 00:37:55.000000', 'temperatura', 917.0000, 'ºC'),
	(162715, 122, '2014-01-15 00:37:56.000000', 'temperatura', 868.0000, 'ºC'),
	(162716, 122, '2014-01-15 00:37:57.000000', 'temperatura', 388.0000, 'ºC'),
	(162717, 122, '2014-01-15 00:37:58.000000', 'temperatura', 538.0000, 'ºC'),
	(162718, 122, '2014-01-15 00:37:59.000000', 'temperatura', 325.0000, 'ºC'),
	(162719, 122, '2014-01-15 00:38:00.000000', 'temperatura', 11.0000, 'ºC'),
	(162720, 122, '2014-01-15 00:38:01.000000', 'temperatura', 282.0000, 'ºC'),
	(162721, 122, '2014-01-15 00:38:02.000000', 'temperatura', 175.0000, 'ºC'),
	(162722, 122, '2014-01-15 00:38:03.000000', 'temperatura', 32.0000, 'ºC'),
	(162723, 122, '2014-01-15 00:38:04.000000', 'temperatura', 833.0000, 'ºC'),
	(162724, 122, '2014-01-15 00:38:05.000000', 'temperatura', 471.0000, 'ºC'),
	(162725, 122, '2014-01-15 00:38:06.000000', 'temperatura', 1055.0000, 'ºC'),
	(162726, 122, '2014-01-15 00:38:07.000000', 'temperatura', 262.0000, 'ºC'),
	(162727, 122, '2014-01-15 00:38:08.000000', 'temperatura', 547.0000, 'ºC'),
	(162728, 122, '2014-01-15 00:38:09.000000', 'temperatura', 748.0000, 'ºC'),
	(162729, 122, '2014-01-15 00:38:10.000000', 'temperatura', 901.0000, 'ºC'),
	(162730, 122, '2014-01-15 00:38:11.000000', 'temperatura', 1063.0000, 'ºC'),
	(162731, 122, '2014-01-15 00:38:12.000000', 'temperatura', 210.0000, 'ºC'),
	(162732, 122, '2014-01-15 00:38:13.000000', 'temperatura', 264.0000, 'ºC'),
	(162733, 122, '2014-01-15 00:38:14.000000', 'temperatura', 690.0000, 'ºC'),
	(162734, 122, '2014-01-15 00:38:15.000000', 'temperatura', 258.0000, 'ºC'),
	(162735, 122, '2014-01-15 00:38:16.000000', 'temperatura', 422.0000, 'ºC'),
	(162736, 122, '2014-01-15 00:38:17.000000', 'temperatura', 137.0000, 'ºC'),
	(162737, 122, '2014-01-15 00:38:18.000000', 'temperatura', 619.0000, 'ºC'),
	(162738, 122, '2014-01-15 00:38:19.000000', 'temperatura', 284.0000, 'ºC'),
	(162739, 122, '2014-01-15 00:38:20.000000', 'temperatura', 763.0000, 'ºC'),
	(162740, 122, '2014-01-15 00:38:21.000000', 'temperatura', 562.0000, 'ºC'),
	(162741, 122, '2014-01-15 00:38:22.000000', 'temperatura', 524.0000, 'ºC'),
	(162742, 122, '2014-01-15 00:38:23.000000', 'temperatura', 934.0000, 'ºC'),
	(162743, 122, '2014-01-15 00:38:24.000000', 'temperatura', 698.0000, 'ºC'),
	(162744, 122, '2014-01-15 00:38:25.000000', 'temperatura', 690.0000, 'ºC'),
	(162745, 122, '2014-01-15 00:38:26.000000', 'temperatura', 154.0000, 'ºC'),
	(162746, 122, '2014-01-15 00:38:27.000000', 'temperatura', 1100.0000, 'ºC'),
	(162747, 122, '2014-01-15 00:38:28.000000', 'temperatura', 240.0000, 'ºC'),
	(162748, 122, '2014-01-15 00:38:29.000000', 'temperatura', 298.0000, 'ºC'),
	(162749, 122, '2014-01-15 00:38:30.000000', 'temperatura', 774.0000, 'ºC'),
	(162750, 122, '2014-01-15 00:38:31.000000', 'temperatura', 574.0000, 'ºC'),
	(162751, 122, '2014-01-15 00:38:32.000000', 'temperatura', 548.0000, 'ºC'),
	(162752, 122, '2014-01-15 00:38:33.000000', 'temperatura', 1021.0000, 'ºC'),
	(162753, 122, '2014-01-15 00:38:34.000000', 'temperatura', 1059.0000, 'ºC'),
	(162754, 122, '2014-01-15 00:38:35.000000', 'temperatura', 1035.0000, 'ºC'),
	(162755, 122, '2014-01-15 00:38:36.000000', 'temperatura', 797.0000, 'ºC'),
	(162756, 122, '2014-01-15 00:38:37.000000', 'temperatura', 881.0000, 'ºC'),
	(162757, 122, '2014-01-15 00:38:38.000000', 'temperatura', 816.0000, 'ºC'),
	(162758, 122, '2014-01-15 00:38:39.000000', 'temperatura', 237.0000, 'ºC'),
	(162759, 122, '2014-01-15 00:38:40.000000', 'temperatura', 1138.0000, 'ºC'),
	(162760, 122, '2014-01-15 00:38:41.000000', 'temperatura', 180.0000, 'ºC'),
	(162761, 122, '2014-01-15 00:38:42.000000', 'temperatura', 1087.0000, 'ºC'),
	(162762, 122, '2014-01-15 00:38:43.000000', 'temperatura', 94.0000, 'ºC'),
	(162763, 122, '2014-01-15 00:38:44.000000', 'temperatura', 809.0000, 'ºC'),
	(162764, 122, '2014-01-15 00:38:45.000000', 'temperatura', 164.0000, 'ºC'),
	(162765, 122, '2014-01-15 00:38:46.000000', 'temperatura', 796.0000, 'ºC'),
	(162766, 122, '2014-01-15 00:38:47.000000', 'temperatura', 1085.0000, 'ºC'),
	(162767, 122, '2014-01-15 00:38:48.000000', 'temperatura', 638.0000, 'ºC'),
	(162768, 122, '2014-01-15 00:38:49.000000', 'temperatura', 1135.0000, 'ºC'),
	(162769, 122, '2014-01-15 00:38:50.000000', 'temperatura', 164.0000, 'ºC'),
	(162770, 122, '2014-01-15 00:38:51.000000', 'temperatura', 1016.0000, 'ºC'),
	(162771, 122, '2014-01-15 00:38:52.000000', 'temperatura', 985.0000, 'ºC'),
	(162772, 122, '2014-01-15 00:38:53.000000', 'temperatura', 681.0000, 'ºC'),
	(162773, 122, '2014-01-15 00:38:54.000000', 'temperatura', 448.0000, 'ºC'),
	(162774, 122, '2014-01-15 00:38:55.000000', 'temperatura', 196.0000, 'ºC'),
	(162775, 122, '2014-01-15 00:38:56.000000', 'temperatura', 839.0000, 'ºC'),
	(162776, 122, '2014-01-15 00:38:57.000000', 'temperatura', 8.0000, 'ºC'),
	(162777, 122, '2014-01-15 00:38:58.000000', 'temperatura', 1124.0000, 'ºC'),
	(162778, 122, '2014-01-15 00:38:59.000000', 'temperatura', 794.0000, 'ºC'),
	(162779, 122, '2014-01-15 00:39:00.000000', 'temperatura', 601.0000, 'ºC'),
	(162780, 122, '2014-01-15 00:39:01.000000', 'temperatura', 623.0000, 'ºC'),
	(162781, 122, '2014-01-15 00:39:02.000000', 'temperatura', 114.0000, 'ºC'),
	(162782, 122, '2014-01-15 00:39:03.000000', 'temperatura', 1101.0000, 'ºC'),
	(162783, 122, '2014-01-15 00:39:04.000000', 'temperatura', 362.0000, 'ºC'),
	(162784, 122, '2014-01-15 00:39:05.000000', 'temperatura', 910.0000, 'ºC'),
	(162785, 122, '2014-01-15 00:39:06.000000', 'temperatura', 1064.0000, 'ºC'),
	(162786, 122, '2014-01-15 00:39:07.000000', 'temperatura', 191.0000, 'ºC'),
	(162787, 122, '2014-01-15 00:39:08.000000', 'temperatura', 164.0000, 'ºC'),
	(162788, 122, '2014-01-15 00:39:09.000000', 'temperatura', 246.0000, 'ºC'),
	(162789, 122, '2014-01-15 00:39:10.000000', 'temperatura', 738.0000, 'ºC'),
	(162790, 122, '2014-01-15 00:39:11.000000', 'temperatura', 554.0000, 'ºC'),
	(162791, 122, '2014-01-15 00:39:12.000000', 'temperatura', 554.0000, 'ºC'),
	(162792, 122, '2014-01-15 00:39:13.000000', 'temperatura', 1110.0000, 'ºC'),
	(162793, 122, '2014-01-15 00:39:14.000000', 'temperatura', 291.0000, 'ºC'),
	(162794, 122, '2014-01-15 00:39:15.000000', 'temperatura', 522.0000, 'ºC'),
	(162795, 122, '2014-01-15 00:39:16.000000', 'temperatura', 537.0000, 'ºC'),
	(162796, 122, '2014-01-15 00:39:17.000000', 'temperatura', 1120.0000, 'ºC'),
	(162797, 122, '2014-01-15 00:39:18.000000', 'temperatura', 391.0000, 'ºC'),
	(162798, 122, '2014-01-15 00:39:19.000000', 'temperatura', 994.0000, 'ºC'),
	(162799, 122, '2014-01-15 00:39:20.000000', 'temperatura', 199.0000, 'ºC'),
	(162800, 122, '2014-01-15 00:39:21.000000', 'temperatura', 413.0000, 'ºC'),
	(162801, 122, '2014-01-15 00:39:22.000000', 'temperatura', 267.0000, 'ºC'),
	(162802, 122, '2014-01-15 00:39:23.000000', 'temperatura', 96.0000, 'ºC'),
	(162803, 122, '2014-01-15 00:39:24.000000', 'temperatura', 881.0000, 'ºC'),
	(162804, 122, '2014-01-15 00:39:25.000000', 'temperatura', 517.0000, 'ºC'),
	(162805, 122, '2014-01-15 00:39:26.000000', 'temperatura', 1143.0000, 'ºC'),
	(162806, 122, '2014-01-15 00:39:27.000000', 'temperatura', 565.0000, 'ºC'),
	(162807, 122, '2014-01-15 00:39:28.000000', 'temperatura', 596.0000, 'ºC'),
	(162808, 122, '2014-01-15 00:39:29.000000', 'temperatura', 87.0000, 'ºC'),
	(162809, 122, '2014-01-15 00:39:30.000000', 'temperatura', 1045.0000, 'ºC'),
	(162810, 122, '2014-01-15 00:39:31.000000', 'temperatura', 166.0000, 'ºC'),
	(162811, 122, '2014-01-15 00:39:32.000000', 'temperatura', 96.0000, 'ºC'),
	(162812, 122, '2014-01-15 00:39:33.000000', 'temperatura', 1180.0000, 'ºC'),
	(162813, 122, '2014-01-15 00:39:34.000000', 'temperatura', 815.0000, 'ºC'),
	(162814, 122, '2014-01-15 00:39:35.000000', 'temperatura', 533.0000, 'ºC'),
	(162815, 122, '2014-01-15 00:39:36.000000', 'temperatura', 220.0000, 'ºC'),
	(162816, 122, '2014-01-15 00:39:37.000000', 'temperatura', 704.0000, 'ºC'),
	(162817, 122, '2014-01-15 00:39:38.000000', 'temperatura', 461.0000, 'ºC'),
	(162818, 122, '2014-01-15 00:39:39.000000', 'temperatura', 193.0000, 'ºC'),
	(162819, 122, '2014-01-15 00:39:40.000000', 'temperatura', 781.0000, 'ºC'),
	(162820, 122, '2014-01-15 00:39:41.000000', 'temperatura', 929.0000, 'ºC'),
	(162821, 122, '2014-01-15 00:39:42.000000', 'temperatura', 1103.0000, 'ºC'),
	(162822, 122, '2014-01-15 00:39:43.000000', 'temperatura', 327.0000, 'ºC'),
	(162823, 122, '2014-01-15 00:39:44.000000', 'temperatura', 725.0000, 'ºC'),
	(162824, 122, '2014-01-15 00:39:45.000000', 'temperatura', 244.0000, 'ºC'),
	(162825, 122, '2014-01-15 00:39:46.000000', 'temperatura', 248.0000, 'ºC'),
	(162826, 122, '2014-01-15 00:39:47.000000', 'temperatura', 506.0000, 'ºC'),
	(162827, 122, '2014-01-15 00:39:48.000000', 'temperatura', 587.0000, 'ºC'),
	(162828, 122, '2014-01-15 00:39:49.000000', 'temperatura', 220.0000, 'ºC'),
	(162829, 122, '2014-01-15 00:39:50.000000', 'temperatura', 536.0000, 'ºC'),
	(162830, 122, '2014-01-15 00:39:51.000000', 'temperatura', 824.0000, 'ºC'),
	(162831, 122, '2014-01-15 00:39:52.000000', 'temperatura', 109.0000, 'ºC'),
	(162832, 122, '2014-01-15 00:39:53.000000', 'temperatura', 476.0000, 'ºC'),
	(162833, 122, '2014-01-15 00:39:54.000000', 'temperatura', 852.0000, 'ºC'),
	(162834, 122, '2014-01-15 00:39:55.000000', 'temperatura', 433.0000, 'ºC'),
	(162835, 122, '2014-01-15 00:39:56.000000', 'temperatura', 808.0000, 'ºC'),
	(162836, 122, '2014-01-15 00:39:57.000000', 'temperatura', 344.0000, 'ºC'),
	(162837, 122, '2014-01-15 00:39:58.000000', 'temperatura', 497.0000, 'ºC'),
	(162838, 122, '2014-01-15 00:39:59.000000', 'temperatura', 253.0000, 'ºC'),
	(162839, 122, '2014-01-15 00:40:00.000000', 'temperatura', 975.0000, 'ºC'),
	(162840, 122, '2014-01-15 00:40:01.000000', 'temperatura', 518.0000, 'ºC'),
	(162841, 122, '2014-01-15 00:40:02.000000', 'temperatura', 862.0000, 'ºC'),
	(162842, 122, '2014-01-15 00:40:03.000000', 'temperatura', 358.0000, 'ºC'),
	(162843, 122, '2014-01-15 00:40:04.000000', 'temperatura', 407.0000, 'ºC'),
	(162844, 122, '2014-01-15 00:40:05.000000', 'temperatura', 958.0000, 'ºC'),
	(162845, 122, '2014-01-15 00:40:06.000000', 'temperatura', 1170.0000, 'ºC'),
	(162846, 122, '2014-01-15 00:40:07.000000', 'temperatura', 577.0000, 'ºC'),
	(162847, 122, '2014-01-15 00:40:08.000000', 'temperatura', 577.0000, 'ºC'),
	(162848, 122, '2014-01-15 00:40:09.000000', 'temperatura', 1152.0000, 'ºC'),
	(162849, 122, '2014-01-15 00:40:10.000000', 'temperatura', 428.0000, 'ºC'),
	(162850, 122, '2014-01-15 00:40:11.000000', 'temperatura', 1088.0000, 'ºC'),
	(162851, 122, '2014-01-15 00:40:12.000000', 'temperatura', 557.0000, 'ºC'),
	(162852, 122, '2014-01-15 00:40:13.000000', 'temperatura', 719.0000, 'ºC'),
	(162853, 122, '2014-01-15 00:40:14.000000', 'temperatura', 724.0000, 'ºC'),
	(162854, 122, '2014-01-15 00:40:15.000000', 'temperatura', 266.0000, 'ºC'),
	(162855, 122, '2014-01-15 00:40:16.000000', 'temperatura', 358.0000, 'ºC'),
	(162856, 122, '2014-01-15 00:40:17.000000', 'temperatura', 991.0000, 'ºC'),
	(162857, 122, '2014-01-15 00:40:18.000000', 'temperatura', 283.0000, 'ºC'),
	(162858, 122, '2014-01-15 00:40:19.000000', 'temperatura', 844.0000, 'ºC'),
	(162859, 122, '2014-01-15 00:40:20.000000', 'temperatura', 971.0000, 'ºC'),
	(162860, 122, '2014-01-15 00:40:21.000000', 'temperatura', 1121.0000, 'ºC'),
	(162861, 122, '2014-01-15 00:40:22.000000', 'temperatura', 294.0000, 'ºC'),
	(162862, 122, '2014-01-15 00:40:23.000000', 'temperatura', 507.0000, 'ºC'),
	(162863, 122, '2014-01-15 00:40:24.000000', 'temperatura', 454.0000, 'ºC'),
	(162864, 122, '2014-01-15 00:40:25.000000', 'temperatura', 748.0000, 'ºC'),
	(162865, 122, '2014-01-15 00:40:26.000000', 'temperatura', 1179.0000, 'ºC'),
	(162866, 122, '2014-01-15 00:40:27.000000', 'temperatura', 50.0000, 'ºC'),
	(162867, 122, '2014-01-15 00:40:28.000000', 'temperatura', 315.0000, 'ºC'),
	(162868, 122, '2014-01-15 00:40:29.000000', 'temperatura', 225.0000, 'ºC'),
	(162869, 122, '2014-01-15 00:40:30.000000', 'temperatura', 181.0000, 'ºC'),
	(162870, 122, '2014-01-15 00:40:31.000000', 'temperatura', 229.0000, 'ºC'),
	(162871, 122, '2014-01-15 00:40:32.000000', 'temperatura', 604.0000, 'ºC'),
	(162872, 122, '2014-01-15 00:40:33.000000', 'temperatura', 1133.0000, 'ºC'),
	(162873, 122, '2014-01-15 00:40:34.000000', 'temperatura', 255.0000, 'ºC'),
	(162874, 122, '2014-01-15 00:40:35.000000', 'temperatura', 273.0000, 'ºC'),
	(162875, 122, '2014-01-15 00:40:36.000000', 'temperatura', 604.0000, 'ºC'),
	(162876, 122, '2014-01-15 00:40:37.000000', 'temperatura', 1000.0000, 'ºC'),
	(162877, 122, '2014-01-15 00:40:38.000000', 'temperatura', 790.0000, 'ºC'),
	(162878, 122, '2014-01-15 00:40:39.000000', 'temperatura', 951.0000, 'ºC'),
	(162879, 122, '2014-01-15 00:40:40.000000', 'temperatura', 1185.0000, 'ºC'),
	(162880, 122, '2014-01-15 00:40:41.000000', 'temperatura', 673.0000, 'ºC'),
	(162881, 122, '2014-01-15 00:40:42.000000', 'temperatura', 1012.0000, 'ºC'),
	(162882, 122, '2014-01-15 00:40:43.000000', 'temperatura', 640.0000, 'ºC'),
	(162883, 122, '2014-01-15 00:40:44.000000', 'temperatura', 164.0000, 'ºC'),
	(162884, 122, '2014-01-15 00:40:45.000000', 'temperatura', 101.0000, 'ºC'),
	(162885, 122, '2014-01-15 00:40:46.000000', 'temperatura', 15.0000, 'ºC'),
	(162886, 122, '2014-01-15 00:40:47.000000', 'temperatura', 971.0000, 'ºC'),
	(162887, 122, '2014-01-15 00:40:48.000000', 'temperatura', 10.0000, 'ºC'),
	(162888, 122, '2014-01-15 00:40:49.000000', 'temperatura', 739.0000, 'ºC'),
	(162889, 122, '2014-01-15 00:40:50.000000', 'temperatura', 66.0000, 'ºC'),
	(162890, 122, '2014-01-15 00:40:51.000000', 'temperatura', 512.0000, 'ºC'),
	(162891, 122, '2014-01-15 00:40:52.000000', 'temperatura', 1164.0000, 'ºC'),
	(162892, 122, '2014-01-15 00:40:53.000000', 'temperatura', 683.0000, 'ºC'),
	(162893, 122, '2014-01-15 00:40:54.000000', 'temperatura', 1125.0000, 'ºC'),
	(162894, 122, '2014-01-15 00:40:55.000000', 'temperatura', 1174.0000, 'ºC'),
	(162895, 122, '2014-01-15 00:40:56.000000', 'temperatura', 97.0000, 'ºC'),
	(162896, 122, '2014-01-15 00:40:57.000000', 'temperatura', 564.0000, 'ºC'),
	(162897, 122, '2014-01-15 00:40:58.000000', 'temperatura', 129.0000, 'ºC'),
	(162898, 122, '2014-01-15 00:40:59.000000', 'temperatura', 153.0000, 'ºC'),
	(162899, 122, '2014-01-15 00:41:00.000000', 'temperatura', 379.0000, 'ºC'),
	(162900, 122, '2014-01-15 00:41:01.000000', 'temperatura', 235.0000, 'ºC'),
	(162901, 122, '2014-01-15 00:41:02.000000', 'temperatura', 38.0000, 'ºC'),
	(162902, 122, '2014-01-15 00:41:03.000000', 'temperatura', 685.0000, 'ºC'),
	(162903, 122, '2014-01-15 00:41:04.000000', 'temperatura', 912.0000, 'ºC'),
	(162904, 122, '2014-01-15 00:41:05.000000', 'temperatura', 106.0000, 'ºC'),
	(162905, 122, '2014-01-15 00:41:06.000000', 'temperatura', 193.0000, 'ºC'),
	(162906, 122, '2014-01-15 00:41:07.000000', 'temperatura', 649.0000, 'ºC'),
	(162907, 122, '2014-01-15 00:41:08.000000', 'temperatura', 265.0000, 'ºC'),
	(162908, 122, '2014-01-15 00:41:09.000000', 'temperatura', 579.0000, 'ºC'),
	(162909, 122, '2014-01-15 00:41:10.000000', 'temperatura', 902.0000, 'ºC'),
	(162910, 122, '2014-01-15 00:41:11.000000', 'temperatura', 371.0000, 'ºC'),
	(162911, 122, '2014-01-15 00:41:12.000000', 'temperatura', 349.0000, 'ºC'),
	(162912, 122, '2014-01-15 00:41:13.000000', 'temperatura', 632.0000, 'ºC'),
	(162913, 122, '2014-01-15 00:41:14.000000', 'temperatura', 913.0000, 'ºC'),
	(162914, 122, '2014-01-15 00:41:15.000000', 'temperatura', 271.0000, 'ºC'),
	(162915, 122, '2014-01-15 00:41:16.000000', 'temperatura', 1018.0000, 'ºC'),
	(162916, 122, '2014-01-15 00:41:17.000000', 'temperatura', 677.0000, 'ºC'),
	(162917, 122, '2014-01-15 00:41:18.000000', 'temperatura', 329.0000, 'ºC'),
	(162918, 122, '2014-01-15 00:41:19.000000', 'temperatura', 816.0000, 'ºC'),
	(162919, 122, '2014-01-15 00:41:20.000000', 'temperatura', 692.0000, 'ºC'),
	(162920, 122, '2014-01-15 00:41:21.000000', 'temperatura', 1015.0000, 'ºC'),
	(162921, 122, '2014-01-15 00:41:22.000000', 'temperatura', 599.0000, 'ºC'),
	(162922, 122, '2014-01-15 00:41:23.000000', 'temperatura', 1150.0000, 'ºC'),
	(162923, 122, '2014-01-15 00:41:24.000000', 'temperatura', 353.0000, 'ºC'),
	(162924, 122, '2014-01-15 00:41:25.000000', 'temperatura', 714.0000, 'ºC'),
	(162925, 122, '2014-01-15 00:41:26.000000', 'temperatura', 114.0000, 'ºC'),
	(162926, 122, '2014-01-15 00:41:27.000000', 'temperatura', 828.0000, 'ºC'),
	(162927, 122, '2014-01-15 00:41:28.000000', 'temperatura', 200.0000, 'ºC'),
	(162928, 122, '2014-01-15 00:41:29.000000', 'temperatura', 916.0000, 'ºC'),
	(162929, 122, '2014-01-15 00:41:30.000000', 'temperatura', 380.0000, 'ºC'),
	(162930, 122, '2014-01-15 00:41:31.000000', 'temperatura', 352.0000, 'ºC'),
	(162931, 122, '2014-01-15 00:41:32.000000', 'temperatura', 622.0000, 'ºC'),
	(162932, 122, '2014-01-15 00:41:33.000000', 'temperatura', 852.0000, 'ºC'),
	(162933, 122, '2014-01-15 00:41:34.000000', 'temperatura', 1194.0000, 'ºC'),
	(162934, 122, '2014-01-15 00:41:35.000000', 'temperatura', 1015.0000, 'ºC'),
	(162935, 122, '2014-01-15 00:41:36.000000', 'temperatura', 295.0000, 'ºC'),
	(162936, 122, '2014-01-15 00:41:37.000000', 'temperatura', 828.0000, 'ºC'),
	(162937, 122, '2014-01-15 00:41:38.000000', 'temperatura', 856.0000, 'ºC'),
	(162938, 122, '2014-01-15 00:41:39.000000', 'temperatura', 597.0000, 'ºC'),
	(162939, 122, '2014-01-15 00:41:40.000000', 'temperatura', 418.0000, 'ºC'),
	(162940, 122, '2014-01-15 00:41:41.000000', 'temperatura', 300.0000, 'ºC'),
	(162941, 122, '2014-01-15 00:41:42.000000', 'temperatura', 248.0000, 'ºC'),
	(162942, 122, '2014-01-15 00:41:43.000000', 'temperatura', 337.0000, 'ºC'),
	(162943, 122, '2014-01-15 00:41:44.000000', 'temperatura', 943.0000, 'ºC'),
	(162944, 122, '2014-01-15 00:41:45.000000', 'temperatura', 103.0000, 'ºC'),
	(162945, 122, '2014-01-15 00:41:46.000000', 'temperatura', 87.0000, 'ºC'),
	(162946, 122, '2014-01-15 00:41:47.000000', 'temperatura', 126.0000, 'ºC'),
	(162947, 122, '2014-01-15 00:41:48.000000', 'temperatura', 372.0000, 'ºC'),
	(162948, 122, '2014-01-15 00:41:49.000000', 'temperatura', 279.0000, 'ºC'),
	(162949, 122, '2014-01-15 00:41:50.000000', 'temperatura', 283.0000, 'ºC'),
	(162950, 122, '2014-01-15 00:41:51.000000', 'temperatura', 576.0000, 'ºC'),
	(162951, 122, '2014-01-15 00:41:52.000000', 'temperatura', 831.0000, 'ºC'),
	(162952, 122, '2014-01-15 00:41:53.000000', 'temperatura', 29.0000, 'ºC'),
	(162953, 122, '2014-01-15 00:41:54.000000', 'temperatura', 52.0000, 'ºC'),
	(162954, 122, '2014-01-15 00:41:55.000000', 'temperatura', 175.0000, 'ºC'),
	(162955, 122, '2014-01-15 00:41:56.000000', 'temperatura', 719.0000, 'ºC'),
	(162956, 122, '2014-01-15 00:41:57.000000', 'temperatura', 669.0000, 'ºC'),
	(162957, 122, '2014-01-15 00:41:58.000000', 'temperatura', 1189.0000, 'ºC'),
	(162958, 122, '2014-01-15 00:41:59.000000', 'temperatura', 340.0000, 'ºC'),
	(162959, 122, '2014-01-15 00:42:00.000000', 'temperatura', 533.0000, 'ºC'),
	(162960, 122, '2014-01-15 00:42:01.000000', 'temperatura', 447.0000, 'ºC'),
	(162961, 122, '2014-01-15 00:42:02.000000', 'temperatura', 634.0000, 'ºC'),
	(162962, 122, '2014-01-15 00:42:03.000000', 'temperatura', 632.0000, 'ºC'),
	(162963, 122, '2014-01-15 00:42:04.000000', 'temperatura', 59.0000, 'ºC'),
	(162964, 122, '2014-01-15 00:42:05.000000', 'temperatura', 798.0000, 'ºC'),
	(162965, 122, '2014-01-15 00:42:06.000000', 'temperatura', 215.0000, 'ºC'),
	(162966, 122, '2014-01-15 00:42:07.000000', 'temperatura', 1082.0000, 'ºC'),
	(162967, 122, '2014-01-15 00:42:08.000000', 'temperatura', 1166.0000, 'ºC'),
	(162968, 122, '2014-01-15 00:42:09.000000', 'temperatura', 185.0000, 'ºC'),
	(162969, 122, '2014-01-15 00:42:10.000000', 'temperatura', 1027.0000, 'ºC'),
	(162970, 122, '2014-01-15 00:42:11.000000', 'temperatura', 980.0000, 'ºC'),
	(162971, 122, '2014-01-15 00:42:12.000000', 'temperatura', 620.0000, 'ºC'),
	(162972, 122, '2014-01-15 00:42:13.000000', 'temperatura', 158.0000, 'ºC'),
	(162973, 122, '2014-01-15 00:42:14.000000', 'temperatura', 134.0000, 'ºC'),
	(162974, 122, '2014-01-15 00:42:15.000000', 'temperatura', 196.0000, 'ºC'),
	(162975, 122, '2014-01-15 00:42:16.000000', 'temperatura', 576.0000, 'ºC'),
	(162976, 122, '2014-01-15 00:42:17.000000', 'temperatura', 1095.0000, 'ºC'),
	(162977, 122, '2014-01-15 00:42:18.000000', 'temperatura', 145.0000, 'ºC'),
	(162978, 122, '2014-01-15 00:42:19.000000', 'temperatura', 1040.0000, 'ºC'),
	(162979, 122, '2014-01-15 00:42:20.000000', 'temperatura', 1167.0000, 'ºC'),
	(162980, 122, '2014-01-15 00:42:21.000000', 'temperatura', 316.0000, 'ºC'),
	(162981, 122, '2014-01-15 00:42:22.000000', 'temperatura', 477.0000, 'ºC'),
	(162982, 122, '2014-01-15 00:42:23.000000', 'temperatura', 240.0000, 'ºC'),
	(162983, 122, '2014-01-15 00:42:24.000000', 'temperatura', 969.0000, 'ºC'),
	(162984, 122, '2014-01-15 00:42:25.000000', 'temperatura', 525.0000, 'ºC'),
	(162985, 122, '2014-01-15 00:42:26.000000', 'temperatura', 920.0000, 'ºC'),
	(162986, 122, '2014-01-15 00:42:27.000000', 'temperatura', 625.0000, 'ºC'),
	(162987, 122, '2014-01-15 00:42:28.000000', 'temperatura', 367.0000, 'ºC'),
	(162988, 122, '2014-01-15 00:42:29.000000', 'temperatura', 1159.0000, 'ºC'),
	(162989, 122, '2014-01-15 00:42:30.000000', 'temperatura', 1096.0000, 'ºC'),
	(162990, 122, '2014-01-15 00:42:31.000000', 'temperatura', 802.0000, 'ºC'),
	(162991, 122, '2014-01-15 00:42:32.000000', 'temperatura', 724.0000, 'ºC'),
	(162992, 122, '2014-01-15 00:42:33.000000', 'temperatura', 12.0000, 'ºC'),
	(162993, 122, '2014-01-15 00:42:34.000000', 'temperatura', 291.0000, 'ºC'),
	(162994, 122, '2014-01-15 00:42:35.000000', 'temperatura', 219.0000, 'ºC'),
	(162995, 122, '2014-01-15 00:42:36.000000', 'temperatura', 220.0000, 'ºC'),
	(162996, 122, '2014-01-15 00:42:37.000000', 'temperatura', 447.0000, 'ºC'),
	(162997, 122, '2014-01-15 00:42:38.000000', 'temperatura', 373.0000, 'ºC'),
	(162998, 122, '2014-01-15 00:42:39.000000', 'temperatura', 525.0000, 'ºC'),
	(162999, 122, '2014-01-15 00:42:40.000000', 'temperatura', 307.0000, 'ºC'),
	(163000, 122, '2014-01-15 00:42:41.000000', 'temperatura', 1160.0000, 'ºC'),
	(163001, 122, '2014-01-15 00:42:42.000000', 'temperatura', 78.0000, 'ºC'),
	(163002, 122, '2014-01-15 00:42:43.000000', 'temperatura', 512.0000, 'ºC'),
	(163003, 122, '2014-01-15 00:42:44.000000', 'temperatura', 1125.0000, 'ºC'),
	(163004, 122, '2014-01-15 00:42:45.000000', 'temperatura', 490.0000, 'ºC'),
	(163005, 122, '2014-01-15 00:42:46.000000', 'temperatura', 274.0000, 'ºC'),
	(163006, 122, '2014-01-15 00:42:47.000000', 'temperatura', 1102.0000, 'ºC'),
	(163007, 122, '2014-01-15 00:42:48.000000', 'temperatura', 1088.0000, 'ºC'),
	(163008, 122, '2014-01-15 00:42:49.000000', 'temperatura', 936.0000, 'ºC'),
	(163009, 122, '2014-01-15 00:42:50.000000', 'temperatura', 217.0000, 'ºC'),
	(163010, 122, '2014-01-15 00:42:51.000000', 'temperatura', 675.0000, 'ºC'),
	(163011, 122, '2014-01-15 00:42:52.000000', 'temperatura', 326.0000, 'ºC'),
	(163012, 122, '2014-01-15 00:42:53.000000', 'temperatura', 805.0000, 'ºC'),
	(163013, 122, '2014-01-15 00:42:54.000000', 'temperatura', 648.0000, 'ºC'),
	(163014, 122, '2014-01-15 00:42:55.000000', 'temperatura', 823.0000, 'ºC'),
	(163015, 122, '2014-01-15 00:42:56.000000', 'temperatura', 974.0000, 'ºC'),
	(163016, 122, '2014-01-15 00:42:57.000000', 'temperatura', 2.0000, 'ºC'),
	(163017, 122, '2014-01-15 00:42:58.000000', 'temperatura', 687.0000, 'ºC'),
	(163018, 122, '2014-01-15 00:42:59.000000', 'temperatura', 1028.0000, 'ºC'),
	(163019, 122, '2014-01-15 00:43:00.000000', 'temperatura', 682.0000, 'ºC'),
	(163020, 122, '2014-01-15 00:43:01.000000', 'temperatura', 324.0000, 'ºC'),
	(163021, 122, '2014-01-15 00:43:02.000000', 'temperatura', 778.0000, 'ºC'),
	(163022, 122, '2014-01-15 00:43:03.000000', 'temperatura', 516.0000, 'ºC'),
	(163023, 122, '2014-01-15 00:43:04.000000', 'temperatura', 245.0000, 'ºC'),
	(163024, 122, '2014-01-15 00:43:05.000000', 'temperatura', 880.0000, 'ºC'),
	(163025, 122, '2014-01-15 00:43:06.000000', 'temperatura', 65.0000, 'ºC'),
	(163026, 122, '2014-01-15 00:43:07.000000', 'temperatura', 86.0000, 'ºC'),
	(163027, 122, '2014-01-15 00:43:08.000000', 'temperatura', 237.0000, 'ºC'),
	(163028, 122, '2014-01-15 00:43:09.000000', 'temperatura', 926.0000, 'ºC'),
	(163029, 122, '2014-01-15 00:43:10.000000', 'temperatura', 321.0000, 'ºC'),
	(163030, 122, '2014-01-15 00:43:11.000000', 'temperatura', 25.0000, 'ºC'),
	(163031, 122, '2014-01-15 00:43:12.000000', 'temperatura', 363.0000, 'ºC'),
	(163032, 122, '2014-01-15 00:43:13.000000', 'temperatura', 542.0000, 'ºC'),
	(163033, 122, '2014-01-15 00:43:14.000000', 'temperatura', 421.0000, 'ºC'),
	(163034, 122, '2014-01-15 00:43:15.000000', 'temperatura', 480.0000, 'ºC'),
	(163035, 122, '2014-01-15 00:43:16.000000', 'temperatura', 1137.0000, 'ºC'),
	(163036, 122, '2014-01-15 00:43:17.000000', 'temperatura', 646.0000, 'ºC'),
	(163037, 122, '2014-01-15 00:43:18.000000', 'temperatura', 1019.0000, 'ºC'),
	(163038, 122, '2014-01-15 00:43:19.000000', 'temperatura', 759.0000, 'ºC'),
	(163039, 122, '2014-01-15 00:43:20.000000', 'temperatura', 736.0000, 'ºC'),
	(163040, 122, '2014-01-15 00:43:21.000000', 'temperatura', 205.0000, 'ºC'),
	(163041, 122, '2014-01-15 00:43:22.000000', 'temperatura', 19.0000, 'ºC'),
	(163042, 122, '2014-01-15 00:43:23.000000', 'temperatura', 679.0000, 'ºC'),
	(163043, 122, '2014-01-15 00:43:24.000000', 'temperatura', 940.0000, 'ºC'),
	(163044, 122, '2014-01-15 00:43:25.000000', 'temperatura', 264.0000, 'ºC'),
	(163045, 122, '2014-01-15 00:43:26.000000', 'temperatura', 900.0000, 'ºC'),
	(163046, 122, '2014-01-15 00:43:27.000000', 'temperatura', 110.0000, 'ºC'),
	(163047, 122, '2014-01-15 00:43:28.000000', 'temperatura', 250.0000, 'ºC'),
	(163048, 122, '2014-01-15 00:43:29.000000', 'temperatura', 920.0000, 'ºC'),
	(163049, 122, '2014-01-15 00:43:30.000000', 'temperatura', 249.0000, 'ºC'),
	(163050, 122, '2014-01-15 00:43:31.000000', 'temperatura', 885.0000, 'ºC'),
	(163051, 122, '2014-01-15 00:43:32.000000', 'temperatura', 80.0000, 'ºC'),
	(163052, 122, '2014-01-15 00:43:33.000000', 'temperatura', 144.0000, 'ºC'),
	(163053, 122, '2014-01-15 00:43:34.000000', 'temperatura', 480.0000, 'ºC'),
	(163054, 122, '2014-01-15 00:43:35.000000', 'temperatura', 769.0000, 'ºC'),
	(163055, 122, '2014-01-15 00:43:36.000000', 'temperatura', 7.0000, 'ºC'),
	(163056, 122, '2014-01-15 00:43:37.000000', 'temperatura', 128.0000, 'ºC'),
	(163057, 122, '2014-01-15 00:43:38.000000', 'temperatura', 618.0000, 'ºC'),
	(163058, 122, '2014-01-15 00:43:39.000000', 'temperatura', 306.0000, 'ºC'),
	(163059, 122, '2014-01-15 00:43:40.000000', 'temperatura', 879.0000, 'ºC'),
	(163060, 122, '2014-01-15 00:43:41.000000', 'temperatura', 1075.0000, 'ºC'),
	(163061, 122, '2014-01-15 00:43:42.000000', 'temperatura', 341.0000, 'ºC'),
	(163062, 122, '2014-01-15 00:43:43.000000', 'temperatura', 878.0000, 'ºC'),
	(163063, 122, '2014-01-15 00:43:44.000000', 'temperatura', 970.0000, 'ºC'),
	(163064, 122, '2014-01-15 00:43:45.000000', 'temperatura', 1014.0000, 'ºC'),
	(163065, 122, '2014-01-15 00:43:46.000000', 'temperatura', 960.0000, 'ºC'),
	(163066, 122, '2014-01-15 00:43:47.000000', 'temperatura', 561.0000, 'ºC'),
	(163067, 122, '2014-01-15 00:43:48.000000', 'temperatura', 1125.0000, 'ºC'),
	(163068, 122, '2014-01-15 00:43:49.000000', 'temperatura', 342.0000, 'ºC'),
	(163069, 122, '2014-01-15 00:43:50.000000', 'temperatura', 736.0000, 'ºC'),
	(163070, 122, '2014-01-15 00:43:51.000000', 'temperatura', 253.0000, 'ºC'),
	(163071, 122, '2014-01-15 00:43:52.000000', 'temperatura', 257.0000, 'ºC'),
	(163072, 122, '2014-01-15 00:43:53.000000', 'temperatura', 527.0000, 'ºC'),
	(163073, 122, '2014-01-15 00:43:54.000000', 'temperatura', 663.0000, 'ºC'),
	(163074, 122, '2014-01-15 00:43:55.000000', 'temperatura', 535.0000, 'ºC'),
	(163075, 122, '2014-01-15 00:43:56.000000', 'temperatura', 686.0000, 'ºC'),
	(163076, 122, '2014-01-15 00:43:57.000000', 'temperatura', 627.0000, 'ºC'),
	(163077, 122, '2014-01-15 00:43:58.000000', 'temperatura', 1078.0000, 'ºC'),
	(163078, 122, '2014-01-15 00:43:59.000000', 'temperatura', 1109.0000, 'ºC'),
	(163079, 122, '2014-01-15 00:44:00.000000', 'temperatura', 1113.0000, 'ºC'),
	(163080, 122, '2014-01-15 00:44:01.000000', 'temperatura', 1036.0000, 'ºC'),
	(163081, 122, '2014-01-15 00:44:02.000000', 'temperatura', 644.0000, 'ºC'),
	(163082, 122, '2014-01-15 00:44:03.000000', 'temperatura', 111.0000, 'ºC'),
	(163083, 122, '2014-01-15 00:44:04.000000', 'temperatura', 1025.0000, 'ºC'),
	(163084, 122, '2014-01-15 00:44:05.000000', 'temperatura', 1193.0000, 'ºC'),
	(163085, 122, '2014-01-15 00:44:06.000000', 'temperatura', 488.0000, 'ºC'),
	(163086, 122, '2014-01-15 00:44:07.000000', 'temperatura', 62.0000, 'ºC'),
	(163087, 122, '2014-01-15 00:44:08.000000', 'temperatura', 47.0000, 'ºC'),
	(163088, 122, '2014-01-15 00:44:09.000000', 'temperatura', 51.0000, 'ºC'),
	(163089, 122, '2014-01-15 00:44:10.000000', 'temperatura', 115.0000, 'ºC'),
	(163090, 122, '2014-01-15 00:44:11.000000', 'temperatura', 422.0000, 'ºC'),
	(163091, 122, '2014-01-15 00:44:12.000000', 'temperatura', 566.0000, 'ºC'),
	(163092, 122, '2014-01-15 00:44:13.000000', 'temperatura', 366.0000, 'ºC'),
	(163093, 122, '2014-01-15 00:44:14.000000', 'temperatura', 129.0000, 'ºC'),
	(163094, 122, '2014-01-15 00:44:15.000000', 'temperatura', 750.0000, 'ºC'),
	(163095, 122, '2014-01-15 00:44:16.000000', 'temperatura', 965.0000, 'ºC'),
	(163096, 122, '2014-01-15 00:44:17.000000', 'temperatura', 172.0000, 'ºC'),
	(163097, 122, '2014-01-15 00:44:18.000000', 'temperatura', 366.0000, 'ºC'),
	(163098, 122, '2014-01-15 00:44:19.000000', 'temperatura', 114.0000, 'ºC'),
	(163099, 122, '2014-01-15 00:44:20.000000', 'temperatura', 675.0000, 'ºC'),
	(163100, 122, '2014-01-15 00:44:21.000000', 'temperatura', 634.0000, 'ºC'),
	(163101, 122, '2014-01-15 00:44:22.000000', 'temperatura', 1143.0000, 'ºC'),
	(163102, 122, '2014-01-15 00:44:23.000000', 'temperatura', 213.0000, 'ºC'),
	(163103, 122, '2014-01-15 00:44:24.000000', 'temperatura', 38.0000, 'ºC'),
	(163104, 122, '2014-01-15 00:44:25.000000', 'temperatura', 751.0000, 'ºC'),
	(163105, 122, '2014-01-15 00:44:26.000000', 'temperatura', 42.0000, 'ºC'),
	(163106, 122, '2014-01-15 00:44:27.000000', 'temperatura', 356.0000, 'ºC'),
	(163107, 122, '2014-01-15 00:44:28.000000', 'temperatura', 456.0000, 'ºC'),
	(163108, 122, '2014-01-15 00:44:29.000000', 'temperatura', 12.0000, 'ºC'),
	(163109, 122, '2014-01-15 00:44:30.000000', 'temperatura', 1093.0000, 'ºC'),
	(163110, 122, '2014-01-15 00:44:31.000000', 'temperatura', 630.0000, 'ºC'),
	(163111, 122, '2014-01-15 00:44:32.000000', 'temperatura', 1072.0000, 'ºC'),
	(163112, 122, '2014-01-15 00:44:33.000000', 'temperatura', 1070.0000, 'ºC'),
	(163113, 122, '2014-01-15 00:44:34.000000', 'temperatura', 932.0000, 'ºC'),
	(163114, 122, '2014-01-15 00:44:35.000000', 'temperatura', 253.0000, 'ºC'),
	(163115, 122, '2014-01-15 00:44:36.000000', 'temperatura', 871.0000, 'ºC'),
	(163116, 122, '2014-01-15 00:44:37.000000', 'temperatura', 1193.0000, 'ºC'),
	(163117, 122, '2014-01-15 00:44:38.000000', 'temperatura', 956.0000, 'ºC'),
	(163118, 122, '2014-01-15 00:44:39.000000', 'temperatura', 0.0000, 'ºC'),
	(163119, 122, '2014-01-15 00:44:40.000000', 'temperatura', 731.0000, 'ºC'),
	(163120, 122, '2014-01-15 00:44:41.000000', 'temperatura', 58.0000, 'ºC'),
	(163121, 122, '2014-01-15 00:44:42.000000', 'temperatura', 496.0000, 'ºC'),
	(163122, 122, '2014-01-15 00:44:43.000000', 'temperatura', 1107.0000, 'ºC'),
	(163123, 122, '2014-01-15 00:44:44.000000', 'temperatura', 446.0000, 'ºC'),
	(163124, 122, '2014-01-15 00:44:45.000000', 'temperatura', 110.0000, 'ºC'),
	(163125, 122, '2014-01-15 00:44:46.000000', 'temperatura', 412.0000, 'ºC'),
	(163126, 122, '2014-01-15 00:44:47.000000', 'temperatura', 529.0000, 'ºC'),
	(163127, 122, '2014-01-15 00:44:48.000000', 'temperatura', 211.0000, 'ºC'),
	(163128, 122, '2014-01-15 00:44:49.000000', 'temperatura', 667.0000, 'ºC'),
	(163129, 122, '2014-01-15 00:44:50.000000', 'temperatura', 304.0000, 'ºC'),
	(163130, 122, '2014-01-15 00:44:51.000000', 'temperatura', 721.0000, 'ºC'),
	(163131, 122, '2014-01-15 00:44:52.000000', 'temperatura', 291.0000, 'ºC'),
	(163132, 122, '2014-01-15 00:44:53.000000', 'temperatura', 494.0000, 'ºC'),
	(163133, 122, '2014-01-15 00:44:54.000000', 'temperatura', 398.0000, 'ºC'),
	(163134, 122, '2014-01-15 00:44:55.000000', 'temperatura', 508.0000, 'ºC'),
	(163135, 122, '2014-01-15 00:44:56.000000', 'temperatura', 147.0000, 'ºC'),
	(163136, 122, '2014-01-15 00:44:57.000000', 'temperatura', 410.0000, 'ºC'),
	(163137, 122, '2014-01-15 00:44:58.000000', 'temperatura', 412.0000, 'ºC'),
	(163138, 122, '2014-01-15 00:44:59.000000', 'temperatura', 829.0000, 'ºC'),
	(163139, 122, '2014-01-15 00:45:00.000000', 'temperatura', 509.0000, 'ºC'),
	(163140, 122, '2014-01-15 00:45:01.000000', 'temperatura', 60.0000, 'ºC'),
	(163141, 122, '2014-01-15 00:45:02.000000', 'temperatura', 1172.0000, 'ºC'),
	(163142, 122, '2014-01-15 00:45:03.000000', 'temperatura', 883.0000, 'ºC'),
	(163143, 122, '2014-01-15 00:45:04.000000', 'temperatura', 896.0000, 'ºC'),
	(163144, 122, '2014-01-15 00:45:05.000000', 'temperatura', 633.0000, 'ºC'),
	(163145, 122, '2014-01-15 00:45:06.000000', 'temperatura', 479.0000, 'ºC'),
	(163146, 122, '2014-01-15 00:45:07.000000', 'temperatura', 494.0000, 'ºC'),
	(163147, 122, '2014-01-15 00:45:08.000000', 'temperatura', 1036.0000, 'ºC'),
	(163148, 122, '2014-01-15 00:45:09.000000', 'temperatura', 98.0000, 'ºC'),
	(163149, 122, '2014-01-15 00:45:10.000000', 'temperatura', 984.0000, 'ºC'),
	(163150, 122, '2014-01-15 00:45:11.000000', 'temperatura', 1024.0000, 'ºC'),
	(163151, 122, '2014-01-15 00:45:12.000000', 'temperatura', 969.0000, 'ºC'),
	(163152, 122, '2014-01-15 00:45:13.000000', 'temperatura', 574.0000, 'ºC'),
	(163153, 122, '2014-01-15 00:45:14.000000', 'temperatura', 1162.0000, 'ºC'),
	(163154, 122, '2014-01-15 00:45:15.000000', 'temperatura', 488.0000, 'ºC'),
	(163155, 122, '2014-01-15 00:45:16.000000', 'temperatura', 154.0000, 'ºC'),
	(163156, 122, '2014-01-15 00:45:17.000000', 'temperatura', 508.0000, 'ºC'),
	(163157, 122, '2014-01-15 00:45:18.000000', 'temperatura', 876.0000, 'ºC'),
	(163158, 122, '2014-01-15 00:45:19.000000', 'temperatura', 459.0000, 'ºC'),
	(163159, 122, '2014-01-15 00:45:20.000000', 'temperatura', 866.0000, 'ºC'),
	(163160, 122, '2014-01-15 00:45:21.000000', 'temperatura', 554.0000, 'ºC'),
	(163161, 122, '2014-01-15 00:45:22.000000', 'temperatura', 172.0000, 'ºC'),
	(163162, 122, '2014-01-15 00:45:23.000000', 'temperatura', 397.0000, 'ºC'),
	(163163, 122, '2014-01-15 00:45:24.000000', 'temperatura', 270.0000, 'ºC'),
	(163164, 122, '2014-01-15 00:45:25.000000', 'temperatura', 160.0000, 'ºC'),
	(163165, 122, '2014-01-15 00:45:26.000000', 'temperatura', 1189.0000, 'ºC'),
	(163166, 122, '2014-01-15 00:45:27.000000', 'temperatura', 667.0000, 'ºC'),
	(163167, 122, '2014-01-15 00:45:28.000000', 'temperatura', 967.0000, 'ºC'),
	(163168, 122, '2014-01-15 00:45:29.000000', 'temperatura', 434.0000, 'ºC'),
	(163169, 122, '2014-01-15 00:45:30.000000', 'temperatura', 472.0000, 'ºC'),
	(163170, 122, '2014-01-15 00:45:31.000000', 'temperatura', 1059.0000, 'ºC'),
	(163171, 122, '2014-01-15 00:45:32.000000', 'temperatura', 278.0000, 'ºC'),
	(163172, 122, '2014-01-15 00:45:33.000000', 'temperatura', 615.0000, 'ºC'),
	(163173, 122, '2014-01-15 00:45:34.000000', 'temperatura', 1042.0000, 'ºC'),
	(163174, 122, '2014-01-15 00:45:35.000000', 'temperatura', 965.0000, 'ºC'),
	(163175, 122, '2014-01-15 00:45:36.000000', 'temperatura', 500.0000, 'ºC'),
	(163176, 122, '2014-01-15 00:45:37.000000', 'temperatura', 803.0000, 'ºC'),
	(163177, 122, '2014-01-15 00:45:38.000000', 'temperatura', 117.0000, 'ºC'),
	(163178, 122, '2014-01-15 00:45:39.000000', 'temperatura', 576.0000, 'ºC'),
	(163179, 122, '2014-01-15 00:45:40.000000', 'temperatura', 130.0000, 'ºC'),
	(163180, 122, '2014-01-15 00:45:41.000000', 'temperatura', 124.0000, 'ºC'),
	(163181, 122, '2014-01-15 00:45:42.000000', 'temperatura', 229.0000, 'ºC'),
	(163182, 122, '2014-01-15 00:45:43.000000', 'temperatura', 775.0000, 'ºC'),
	(163183, 122, '2014-01-15 00:45:44.000000', 'temperatura', 789.0000, 'ºC'),
	(163184, 122, '2014-01-15 00:45:45.000000', 'temperatura', 420.0000, 'ºC'),
	(163185, 122, '2014-01-15 00:45:46.000000', 'temperatura', 932.0000, 'ºC'),
	(163186, 122, '2014-01-15 00:45:47.000000', 'temperatura', 1001.0000, 'ºC'),
	(163187, 122, '2014-01-15 00:45:48.000000', 'temperatura', 1009.0000, 'ºC'),
	(163188, 122, '2014-01-15 00:45:49.000000', 'temperatura', 843.0000, 'ºC'),
	(163189, 122, '2014-01-15 00:45:50.000000', 'temperatura', 1190.0000, 'ºC'),
	(163190, 122, '2014-01-15 00:45:51.000000', 'temperatura', 1022.0000, 'ºC'),
	(163191, 122, '2014-01-15 00:45:52.000000', 'temperatura', 338.0000, 'ºC'),
	(163192, 122, '2014-01-15 00:45:53.000000', 'temperatura', 1024.0000, 'ºC'),
	(163193, 122, '2014-01-15 00:45:54.000000', 'temperatura', 507.0000, 'ºC'),
	(163194, 122, '2014-01-15 00:45:55.000000', 'temperatura', 664.0000, 'ºC'),
	(163195, 122, '2014-01-15 00:45:56.000000', 'temperatura', 598.0000, 'ºC'),
	(163196, 122, '2014-01-15 00:45:57.000000', 'temperatura', 999.0000, 'ºC'),
	(163197, 122, '2014-01-15 00:45:58.000000', 'temperatura', 802.0000, 'ºC'),
	(163198, 122, '2014-01-15 00:45:59.000000', 'temperatura', 1012.0000, 'ºC'),
	(163199, 122, '2014-01-15 00:46:00.000000', 'temperatura', 254.0000, 'ºC'),
	(163200, 122, '2014-01-15 00:46:01.000000', 'temperatura', 635.0000, 'ºC'),
	(163201, 122, '2014-01-15 00:46:02.000000', 'temperatura', 13.0000, 'ºC'),
	(163202, 122, '2014-01-15 00:46:03.000000', 'temperatura', 561.0000, 'ºC'),
	(163203, 122, '2014-01-15 00:46:04.000000', 'temperatura', 367.0000, 'ºC'),
	(163204, 122, '2014-01-15 00:46:05.000000', 'temperatura', 153.0000, 'ºC'),
	(163205, 122, '2014-01-15 00:46:06.000000', 'temperatura', 866.0000, 'ºC'),
	(163206, 122, '2014-01-15 00:46:07.000000', 'temperatura', 268.0000, 'ºC'),
	(163207, 122, '2014-01-15 00:46:08.000000', 'temperatura', 1145.0000, 'ºC'),
	(163208, 122, '2014-01-15 00:46:09.000000', 'temperatura', 120.0000, 'ºC'),
	(163209, 122, '2014-01-15 00:46:10.000000', 'temperatura', 767.0000, 'ºC'),
	(163210, 122, '2014-01-15 00:46:11.000000', 'temperatura', 1073.0000, 'ºC'),
	(163211, 122, '2014-01-15 00:46:12.000000', 'temperatura', 665.0000, 'ºC'),
	(163212, 122, '2014-01-15 00:46:13.000000', 'temperatura', 106.0000, 'ºC'),
	(163213, 122, '2014-01-15 00:46:14.000000', 'temperatura', 938.0000, 'ºC'),
	(163214, 122, '2014-01-15 00:46:15.000000', 'temperatura', 771.0000, 'ºC'),
	(163215, 122, '2014-01-15 00:46:16.000000', 'temperatura', 1042.0000, 'ºC'),
	(163216, 122, '2014-01-15 00:46:17.000000', 'temperatura', 496.0000, 'ºC'),
	(163217, 122, '2014-01-15 00:46:18.000000', 'temperatura', 557.0000, 'ºC'),
	(163218, 122, '2014-01-15 00:46:19.000000', 'temperatura', 96.0000, 'ºC'),
	(163219, 122, '2014-01-15 00:46:20.000000', 'temperatura', 8.0000, 'ºC'),
	(163220, 122, '2014-01-15 00:46:21.000000', 'temperatura', 954.0000, 'ºC'),
	(163221, 122, '2014-01-15 00:46:22.000000', 'temperatura', 1148.0000, 'ºC'),
	(163222, 122, '2014-01-15 00:46:23.000000', 'temperatura', 476.0000, 'ºC'),
	(163223, 122, '2014-01-15 00:46:24.000000', 'temperatura', 139.0000, 'ºC'),
	(163224, 122, '2014-01-15 00:46:25.000000', 'temperatura', 465.0000, 'ºC'),
	(163225, 122, '2014-01-15 00:46:26.000000', 'temperatura', 712.0000, 'ºC'),
	(163226, 122, '2014-01-15 00:46:27.000000', 'temperatura', 962.0000, 'ºC'),
	(163227, 122, '2014-01-15 00:46:28.000000', 'temperatura', 274.0000, 'ºC'),
	(163228, 122, '2014-01-15 00:46:29.000000', 'temperatura', 887.0000, 'ºC'),
	(163229, 122, '2014-01-15 00:46:30.000000', 'temperatura', 13.0000, 'ºC'),
	(163230, 122, '2014-01-15 00:46:31.000000', 'temperatura', 1006.0000, 'ºC'),
	(163231, 122, '2014-01-15 00:46:32.000000', 'temperatura', 192.0000, 'ºC'),
	(163232, 122, '2014-01-15 00:46:33.000000', 'temperatura', 339.0000, 'ºC'),
	(163233, 122, '2014-01-15 00:46:34.000000', 'temperatura', 1123.0000, 'ºC'),
	(163234, 122, '2014-01-15 00:46:35.000000', 'temperatura', 997.0000, 'ºC'),
	(163235, 122, '2014-01-15 00:46:36.000000', 'temperatura', 418.0000, 'ºC'),
	(163236, 122, '2014-01-15 00:46:37.000000', 'temperatura', 300.0000, 'ºC'),
	(163237, 122, '2014-01-15 00:46:38.000000', 'temperatura', 246.0000, 'ºC'),
	(163238, 122, '2014-01-15 00:46:39.000000', 'temperatura', 332.0000, 'ºC'),
	(163239, 122, '2014-01-15 00:46:40.000000', 'temperatura', 920.0000, 'ºC'),
	(163240, 122, '2014-01-15 00:46:41.000000', 'temperatura', 5.0000, 'ºC'),
	(163241, 122, '2014-01-15 00:46:42.000000', 'temperatura', 866.0000, 'ºC'),
	(163242, 122, '2014-01-15 00:46:43.000000', 'temperatura', 715.0000, 'ºC'),
	(163243, 122, '2014-01-15 00:46:44.000000', 'temperatura', 976.0000, 'ºC'),
	(163244, 122, '2014-01-15 00:46:45.000000', 'temperatura', 339.0000, 'ºC'),
	(163245, 122, '2014-01-15 00:46:46.000000', 'temperatura', 1165.0000, 'ºC'),
	(163246, 122, '2014-01-15 00:46:47.000000', 'temperatura', 8.0000, 'ºC'),
	(163247, 122, '2014-01-15 00:46:48.000000', 'temperatura', 147.0000, 'ºC'),
	(163248, 122, '2014-01-15 00:46:49.000000', 'temperatura', 710.0000, 'ºC'),
	(163249, 122, '2014-01-15 00:46:50.000000', 'temperatura', 709.0000, 'ºC'),
	(163250, 122, '2014-01-15 00:46:51.000000', 'temperatura', 217.0000, 'ºC'),
	(163251, 122, '2014-01-15 00:46:52.000000', 'temperatura', 160.0000, 'ºC'),
	(163252, 122, '2014-01-15 00:46:53.000000', 'temperatura', 147.0000, 'ºC'),
	(163253, 122, '2014-01-15 00:46:54.000000', 'temperatura', 254.0000, 'ºC'),
	(163254, 122, '2014-01-15 00:46:55.000000', 'temperatura', 833.0000, 'ºC'),
	(163255, 122, '2014-01-15 00:46:56.000000', 'temperatura', 1002.0000, 'ºC'),
	(163256, 122, '2014-01-15 00:46:57.000000', 'temperatura', 111.0000, 'ºC'),
	(163257, 122, '2014-01-15 00:46:58.000000', 'temperatura', 1151.0000, 'ºC'),
	(163258, 122, '2014-01-15 00:46:59.000000', 'temperatura', 623.0000, 'ºC'),
	(163259, 122, '2014-01-15 00:47:00.000000', 'temperatura', 861.0000, 'ºC'),
	(163260, 122, '2014-01-15 00:47:01.000000', 'temperatura', 36.0000, 'ºC'),
	(163261, 122, '2014-01-15 00:47:02.000000', 'temperatura', 1199.0000, 'ºC'),
	(163262, 122, '2014-01-15 00:47:03.000000', 'temperatura', 1087.0000, 'ºC'),
	(163263, 122, '2014-01-15 00:47:04.000000', 'temperatura', 640.0000, 'ºC'),
	(163264, 122, '2014-01-15 00:47:05.000000', 'temperatura', 1138.0000, 'ºC'),
	(163265, 122, '2014-01-15 00:47:06.000000', 'temperatura', 170.0000, 'ºC'),
	(163266, 122, '2014-01-15 00:47:07.000000', 'temperatura', 1038.0000, 'ºC'),
	(163267, 122, '2014-01-15 00:47:08.000000', 'temperatura', 1080.0000, 'ºC'),
	(163268, 122, '2014-01-15 00:47:09.000000', 'temperatura', 1088.0000, 'ºC'),
	(163269, 122, '2014-01-15 00:47:10.000000', 'temperatura', 1001.0000, 'ºC'),
	(163270, 122, '2014-01-15 00:47:11.000000', 'temperatura', 541.0000, 'ºC'),
	(163271, 122, '2014-01-15 00:47:12.000000', 'temperatura', 904.0000, 'ºC'),
	(163272, 122, '2014-01-15 00:47:13.000000', 'temperatura', 496.0000, 'ºC'),
	(163273, 122, '2014-01-15 00:47:14.000000', 'temperatura', 967.0000, 'ºC'),
	(163274, 122, '2014-01-15 00:47:15.000000', 'temperatura', 950.0000, 'ºC'),
	(163275, 122, '2014-01-15 00:47:16.000000', 'temperatura', 648.0000, 'ºC'),
	(163276, 122, '2014-01-15 00:47:17.000000', 'temperatura', 391.0000, 'ºC'),
	(163277, 122, '2014-01-15 00:47:18.000000', 'temperatura', 13.0000, 'ºC'),
	(163278, 122, '2014-01-15 00:47:19.000000', 'temperatura', 91.0000, 'ºC'),
	(163279, 122, '2014-01-15 00:47:20.000000', 'temperatura', 415.0000, 'ºC'),
	(163280, 122, '2014-01-15 00:47:21.000000', 'temperatura', 606.0000, 'ºC'),
	(163281, 122, '2014-01-15 00:47:22.000000', 'temperatura', 583.0000, 'ºC'),
	(163282, 122, '2014-01-15 00:47:23.000000', 'temperatura', 1097.0000, 'ºC'),
	(163283, 122, '2014-01-15 00:47:24.000000', 'temperatura', 136.0000, 'ºC'),
	(163284, 122, '2014-01-15 00:47:25.000000', 'temperatura', 992.0000, 'ºC'),
	(163285, 122, '2014-01-15 00:47:26.000000', 'temperatura', 953.0000, 'ºC'),
	(163286, 122, '2014-01-15 00:47:27.000000', 'temperatura', 587.0000, 'ºC'),
	(163287, 122, '2014-01-15 00:47:28.000000', 'temperatura', 76.0000, 'ºC'),
	(163288, 122, '2014-01-15 00:47:29.000000', 'temperatura', 1020.0000, 'ºC'),
	(163289, 122, '2014-01-15 00:47:30.000000', 'temperatura', 71.0000, 'ºC'),
	(163290, 122, '2014-01-15 00:47:31.000000', 'temperatura', 896.0000, 'ºC'),
	(163291, 122, '2014-01-15 00:47:32.000000', 'temperatura', 667.0000, 'ºC'),
	(163292, 122, '2014-01-15 00:47:33.000000', 'temperatura', 649.0000, 'ºC'),
	(163293, 122, '2014-01-15 00:47:34.000000', 'temperatura', 43.0000, 'ºC'),
	(163294, 122, '2014-01-15 00:47:35.000000', 'temperatura', 668.0000, 'ºC'),
	(163295, 122, '2014-01-15 00:47:36.000000', 'temperatura', 811.0000, 'ºC'),
	(163296, 122, '2014-01-15 00:47:37.000000', 'temperatura', 853.0000, 'ºC'),
	(163297, 122, '2014-01-15 00:47:38.000000', 'temperatura', 631.0000, 'ºC'),
	(163298, 122, '2014-01-15 00:47:39.000000', 'temperatura', 598.0000, 'ºC'),
	(163299, 122, '2014-01-15 00:47:40.000000', 'temperatura', 1097.0000, 'ºC'),
	(163300, 122, '2014-01-15 00:47:41.000000', 'temperatura', 93.0000, 'ºC'),
	(163301, 122, '2014-01-15 00:47:42.000000', 'temperatura', 773.0000, 'ºC'),
	(163302, 122, '2014-01-15 00:47:43.000000', 'temperatura', 1187.0000, 'ºC'),
	(163303, 122, '2014-01-15 00:47:44.000000', 'temperatura', 15.0000, 'ºC'),
	(163304, 122, '2014-01-15 00:47:45.000000', 'temperatura', 118.0000, 'ºC'),
	(163305, 122, '2014-01-15 00:47:46.000000', 'temperatura', 542.0000, 'ºC'),
	(163306, 122, '2014-01-15 00:47:47.000000', 'temperatura', 1156.0000, 'ºC'),
	(163307, 122, '2014-01-15 00:47:48.000000', 'temperatura', 556.0000, 'ºC'),
	(163308, 122, '2014-01-15 00:47:49.000000', 'temperatura', 511.0000, 'ºC'),
	(163309, 122, '2014-01-15 00:47:50.000000', 'temperatura', 889.0000, 'ºC'),
	(163310, 122, '2014-01-15 00:47:51.000000', 'temperatura', 514.0000, 'ºC'),
	(163311, 122, '2014-01-15 00:47:52.000000', 'temperatura', 1100.0000, 'ºC'),
	(163312, 122, '2014-01-15 00:47:53.000000', 'temperatura', 361.0000, 'ºC'),
	(163313, 122, '2014-01-15 00:47:54.000000', 'temperatura', 905.0000, 'ºC'),
	(163314, 122, '2014-01-15 00:47:55.000000', 'temperatura', 1041.0000, 'ºC'),
	(163315, 122, '2014-01-15 00:47:56.000000', 'temperatura', 90.0000, 'ºC'),
	(163316, 122, '2014-01-15 00:47:57.000000', 'temperatura', 930.0000, 'ºC'),
	(163317, 122, '2014-01-15 00:47:58.000000', 'temperatura', 778.0000, 'ºC'),
	(163318, 122, '2014-01-15 00:47:59.000000', 'temperatura', 1101.0000, 'ºC'),
	(163319, 122, '2014-01-15 00:48:00.000000', 'temperatura', 772.0000, 'ºC'),
	(163320, 122, '2014-01-15 00:48:01.000000', 'temperatura', 556.0000, 'ºC'),
	(163321, 122, '2014-01-15 00:48:02.000000', 'temperatura', 465.0000, 'ºC'),
	(163322, 122, '2014-01-15 00:48:03.000000', 'temperatura', 658.0000, 'ºC'),
	(163323, 122, '2014-01-15 00:48:04.000000', 'temperatura', 695.0000, 'ºC'),
	(163324, 122, '2014-01-15 00:48:05.000000', 'temperatura', 301.0000, 'ºC'),
	(163325, 122, '2014-01-15 00:48:06.000000', 'temperatura', 621.0000, 'ºC'),
	(163326, 122, '2014-01-15 00:48:07.000000', 'temperatura', 1001.0000, 'ºC'),
	(163327, 122, '2014-01-15 00:48:08.000000', 'temperatura', 742.0000, 'ºC'),
	(163328, 122, '2014-01-15 00:48:09.000000', 'temperatura', 707.0000, 'ºC'),
	(163329, 122, '2014-01-15 00:48:10.000000', 'temperatura', 109.0000, 'ºC'),
	(163330, 122, '2014-01-15 00:48:11.000000', 'temperatura', 825.0000, 'ºC'),
	(163331, 122, '2014-01-15 00:48:12.000000', 'temperatura', 200.0000, 'ºC'),
	(163332, 122, '2014-01-15 00:48:13.000000', 'temperatura', 927.0000, 'ºC'),
	(163333, 122, '2014-01-15 00:48:14.000000', 'temperatura', 433.0000, 'ºC'),
	(163334, 122, '2014-01-15 00:48:15.000000', 'temperatura', 584.0000, 'ºC'),
	(163335, 122, '2014-01-15 00:48:16.000000', 'temperatura', 421.0000, 'ºC'),
	(163336, 122, '2014-01-15 00:48:17.000000', 'temperatura', 356.0000, 'ºC'),
	(163337, 122, '2014-01-15 00:48:18.000000', 'temperatura', 515.0000, 'ºC'),
	(163338, 122, '2014-01-15 00:48:19.000000', 'temperatura', 307.0000, 'ºC'),
	(163339, 122, '2014-01-15 00:48:20.000000', 'temperatura', 1192.0000, 'ºC'),
	(163340, 122, '2014-01-15 00:48:21.000000', 'temperatura', 239.0000, 'ºC'),
	(163341, 122, '2014-01-15 00:48:22.000000', 'temperatura', 22.0000, 'ºC'),
	(163342, 122, '2014-01-15 00:48:23.000000', 'temperatura', 590.0000, 'ºC'),
	(163343, 122, '2014-01-15 00:48:24.000000', 'temperatura', 486.0000, 'ºC'),
	(163344, 122, '2014-01-15 00:48:25.000000', 'temperatura', 662.0000, 'ºC'),
	(163345, 122, '2014-01-15 00:48:26.000000', 'temperatura', 652.0000, 'ºC'),
	(163346, 122, '2014-01-15 00:48:27.000000', 'temperatura', 74.0000, 'ºC'),
	(163347, 122, '2014-01-15 00:48:28.000000', 'temperatura', 816.0000, 'ºC'),
	(163348, 122, '2014-01-15 00:48:29.000000', 'temperatura', 256.0000, 'ºC'),
	(163349, 122, '2014-01-15 00:48:30.000000', 'temperatura', 32.0000, 'ºC'),
	(163350, 122, '2014-01-15 00:48:31.000000', 'temperatura', 595.0000, 'ºC'),
	(163351, 122, '2014-01-15 00:48:32.000000', 'temperatura', 478.0000, 'ºC'),
	(163352, 122, '2014-01-15 00:48:33.000000', 'temperatura', 607.0000, 'ºC'),
	(163353, 122, '2014-01-15 00:48:34.000000', 'temperatura', 400.0000, 'ºC'),
	(163354, 122, '2014-01-15 00:48:35.000000', 'temperatura', 179.0000, 'ºC'),
	(163355, 122, '2014-01-15 00:48:36.000000', 'temperatura', 898.0000, 'ºC'),
	(163356, 122, '2014-01-15 00:48:37.000000', 'temperatura', 352.0000, 'ºC'),
	(163357, 122, '2014-01-15 00:48:38.000000', 'temperatura', 265.0000, 'ºC'),
	(163358, 122, '2014-01-15 00:48:39.000000', 'temperatura', 272.0000, 'ºC'),
	(163359, 122, '2014-01-15 00:48:40.000000', 'temperatura', 563.0000, 'ºC'),
	(163360, 122, '2014-01-15 00:48:41.000000', 'temperatura', 801.0000, 'ºC'),
	(163361, 122, '2014-01-15 00:48:42.000000', 'temperatura', 1116.0000, 'ºC'),
	(163362, 122, '2014-01-15 00:48:43.000000', 'temperatura', 779.0000, 'ºC'),
	(163363, 122, '2014-01-15 00:48:44.000000', 'temperatura', 545.0000, 'ºC'),
	(163364, 122, '2014-01-15 00:48:45.000000', 'temperatura', 389.0000, 'ºC'),
	(163365, 122, '2014-01-15 00:48:46.000000', 'temperatura', 311.0000, 'ºC'),
	(163366, 122, '2014-01-15 00:48:47.000000', 'temperatura', 387.0000, 'ºC'),
	(163367, 122, '2014-01-15 00:48:48.000000', 'temperatura', 1005.0000, 'ºC'),
	(163368, 122, '2014-01-15 00:48:49.000000', 'temperatura', 263.0000, 'ºC'),
	(163369, 122, '2014-01-15 00:48:50.000000', 'temperatura', 701.0000, 'ºC'),
	(163370, 122, '2014-01-15 00:48:51.000000', 'temperatura', 318.0000, 'ºC'),
	(163371, 122, '2014-01-15 00:48:52.000000', 'temperatura', 686.0000, 'ºC'),
	(163372, 122, '2014-01-15 00:48:53.000000', 'temperatura', 78.0000, 'ºC'),
	(163373, 122, '2014-01-15 00:48:54.000000', 'temperatura', 732.0000, 'ºC'),
	(163374, 122, '2014-01-15 00:48:55.000000', 'temperatura', 1025.0000, 'ºC'),
	(163375, 122, '2014-01-15 00:48:56.000000', 'temperatura', 532.0000, 'ºC'),
	(163376, 122, '2014-01-15 00:48:57.000000', 'temperatura', 785.0000, 'ºC'),
	(163377, 122, '2014-01-15 00:48:58.000000', 'temperatura', 1129.0000, 'ºC'),
	(163378, 122, '2014-01-15 00:48:59.000000', 'temperatura', 891.0000, 'ºC'),
	(163379, 122, '2014-01-15 00:49:00.000000', 'temperatura', 1067.0000, 'ºC'),
	(163380, 122, '2014-01-15 00:49:01.000000', 'temperatura', 264.0000, 'ºC'),
	(163381, 122, '2014-01-15 00:49:02.000000', 'temperatura', 520.0000, 'ºC'),
	(163382, 122, '2014-01-15 00:49:03.000000', 'temperatura', 606.0000, 'ºC'),
	(163383, 122, '2014-01-15 00:49:04.000000', 'temperatura', 274.0000, 'ºC'),
	(163384, 122, '2014-01-15 00:49:05.000000', 'temperatura', 750.0000, 'ºC'),
	(163385, 122, '2014-01-15 00:49:06.000000', 'temperatura', 528.0000, 'ºC'),
	(163386, 122, '2014-01-15 00:49:07.000000', 'temperatura', 393.0000, 'ºC'),
	(163387, 122, '2014-01-15 00:49:08.000000', 'temperatura', 380.0000, 'ºC'),
	(163388, 122, '2014-01-15 00:49:09.000000', 'temperatura', 723.0000, 'ºC'),
	(163389, 122, '2014-01-15 00:49:10.000000', 'temperatura', 76.0000, 'ºC'),
	(163390, 122, '2014-01-15 00:49:11.000000', 'temperatura', 612.0000, 'ºC'),
	(163391, 122, '2014-01-15 00:49:12.000000', 'temperatura', 431.0000, 'ºC'),
	(163392, 122, '2014-01-15 00:49:13.000000', 'temperatura', 320.0000, 'ºC'),
	(163393, 122, '2014-01-15 00:49:14.000000', 'temperatura', 305.0000, 'ºC'),
	(163394, 122, '2014-01-15 00:49:15.000000', 'temperatura', 568.0000, 'ºC'),
	(163395, 122, '2014-01-15 00:49:16.000000', 'temperatura', 726.0000, 'ºC'),
	(163396, 122, '2014-01-15 00:49:17.000000', 'temperatura', 727.0000, 'ºC'),
	(163397, 122, '2014-01-15 00:49:18.000000', 'temperatura', 257.0000, 'ºC'),
	(163398, 122, '2014-01-15 00:49:19.000000', 'temperatura', 303.0000, 'ºC'),
	(163399, 122, '2014-01-15 00:49:20.000000', 'temperatura', 747.0000, 'ºC'),
	(163400, 122, '2014-01-15 00:49:21.000000', 'temperatura', 424.0000, 'ºC'),
	(163401, 122, '2014-01-15 00:49:22.000000', 'temperatura', 1081.0000, 'ºC'),
	(163402, 122, '2014-01-15 00:49:23.000000', 'temperatura', 533.0000, 'ºC'),
	(163403, 122, '2014-01-15 00:49:24.000000', 'temperatura', 623.0000, 'ºC'),
	(163404, 122, '2014-01-15 00:49:25.000000', 'temperatura', 316.0000, 'ºC'),
	(163405, 122, '2014-01-15 00:49:26.000000', 'temperatura', 911.0000, 'ºC'),
	(163406, 122, '2014-01-15 00:49:27.000000', 'temperatura', 9.0000, 'ºC'),
	(163407, 122, '2014-01-15 00:49:28.000000', 'temperatura', 912.0000, 'ºC'),
	(163408, 122, '2014-01-15 00:49:29.000000', 'temperatura', 932.0000, 'ºC'),
	(163409, 122, '2014-01-15 00:49:30.000000', 'temperatura', 726.0000, 'ºC'),
	(163410, 122, '2014-01-15 00:49:31.000000', 'temperatura', 834.0000, 'ºC'),
	(163411, 122, '2014-01-15 00:49:32.000000', 'temperatura', 793.0000, 'ºC'),
	(163412, 122, '2014-01-15 00:49:33.000000', 'temperatura', 263.0000, 'ºC'),
	(163413, 122, '2014-01-15 00:49:34.000000', 'temperatura', 138.0000, 'ºC'),
	(163414, 122, '2014-01-15 00:49:35.000000', 'temperatura', 1103.0000, 'ºC'),
	(163415, 122, '2014-01-15 00:49:36.000000', 'temperatura', 298.0000, 'ºC'),
	(163416, 122, '2014-01-15 00:49:37.000000', 'temperatura', 584.0000, 'ºC'),
	(163417, 122, '2014-01-15 00:49:38.000000', 'temperatura', 825.0000, 'ºC'),
	(163418, 122, '2014-01-15 00:49:39.000000', 'temperatura', 1175.0000, 'ºC'),
	(163419, 122, '2014-01-15 00:49:40.000000', 'temperatura', 1000.0000, 'ºC'),
	(163420, 122, '2014-01-15 00:49:41.000000', 'temperatura', 273.0000, 'ºC'),
	(163421, 122, '2014-01-15 00:49:42.000000', 'temperatura', 768.0000, 'ºC'),
	(163422, 122, '2014-01-15 00:49:43.000000', 'temperatura', 621.0000, 'ºC'),
	(163423, 122, '2014-01-15 00:49:44.000000', 'temperatura', 800.0000, 'ºC'),
	(163424, 122, '2014-01-15 00:49:45.000000', 'temperatura', 940.0000, 'ºC'),
	(163425, 122, '2014-01-15 00:49:46.000000', 'temperatura', 1100.0000, 'ºC'),
	(163426, 122, '2014-01-15 00:49:47.000000', 'temperatura', 281.0000, 'ºC'),
	(163427, 122, '2014-01-15 00:49:48.000000', 'temperatura', 506.0000, 'ºC'),
	(163428, 122, '2014-01-15 00:49:49.000000', 'temperatura', 486.0000, 'ºC'),
	(163429, 122, '2014-01-15 00:49:50.000000', 'temperatura', 913.0000, 'ºC'),
	(163430, 122, '2014-01-15 00:49:51.000000', 'temperatura', 707.0000, 'ºC'),
	(163431, 122, '2014-01-15 00:49:52.000000', 'temperatura', 796.0000, 'ºC'),
	(163432, 122, '2014-01-15 00:49:53.000000', 'temperatura', 662.0000, 'ºC'),
	(163433, 122, '2014-01-15 00:49:54.000000', 'temperatura', 921.0000, 'ºC'),
	(163434, 122, '2014-01-15 00:49:55.000000', 'temperatura', 219.0000, 'ºC'),
	(163435, 122, '2014-01-15 00:49:56.000000', 'temperatura', 735.0000, 'ºC'),
	(163436, 122, '2014-01-15 00:49:57.000000', 'temperatura', 616.0000, 'ºC'),
	(163437, 122, '2014-01-15 00:49:58.000000', 'temperatura', 875.0000, 'ºC'),
	(163438, 122, '2014-01-15 00:49:59.000000', 'temperatura', 127.0000, 'ºC'),
	(163439, 122, '2014-01-15 00:50:00.000000', 'temperatura', 412.0000, 'ºC'),
	(163440, 122, '2014-01-15 00:50:01.000000', 'temperatura', 477.0000, 'ºC'),
	(163441, 122, '2014-01-15 00:50:02.000000', 'temperatura', 1152.0000, 'ºC'),
	(163442, 122, '2014-01-15 00:50:03.000000', 'temperatura', 729.0000, 'ºC'),
	(163443, 122, '2014-01-15 00:50:04.000000', 'temperatura', 187.0000, 'ºC'),
	(163444, 122, '2014-01-15 00:50:05.000000', 'temperatura', 1151.0000, 'ºC'),
	(163445, 122, '2014-01-15 00:50:06.000000', 'temperatura', 395.0000, 'ºC'),
	(163446, 122, '2014-01-15 00:50:07.000000', 'temperatura', 922.0000, 'ºC'),
	(163447, 122, '2014-01-15 00:50:08.000000', 'temperatura', 1026.0000, 'ºC'),
	(163448, 122, '2014-01-15 00:50:09.000000', 'temperatura', 1164.0000, 'ºC'),
	(163449, 122, '2014-01-15 00:50:10.000000', 'temperatura', 341.0000, 'ºC'),
	(163450, 122, '2014-01-15 00:50:11.000000', 'temperatura', 614.0000, 'ºC'),
	(163451, 122, '2014-01-15 00:50:12.000000', 'temperatura', 847.0000, 'ºC'),
	(163452, 122, '2014-01-15 00:50:13.000000', 'temperatura', 1194.0000, 'ºC'),
	(163453, 122, '2014-01-15 00:50:14.000000', 'temperatura', 1028.0000, 'ºC'),
	(163454, 122, '2014-01-15 00:50:15.000000', 'temperatura', 359.0000, 'ºC'),
	(163455, 122, '2014-01-15 00:50:16.000000', 'temperatura', 1110.0000, 'ºC'),
	(163456, 122, '2014-01-15 00:50:17.000000', 'temperatura', 874.0000, 'ºC'),
	(163457, 122, '2014-01-15 00:50:18.000000', 'temperatura', 1043.0000, 'ºC'),
	(163458, 122, '2014-01-15 00:50:19.000000', 'temperatura', 191.0000, 'ºC'),
	(163459, 122, '2014-01-15 00:50:20.000000', 'temperatura', 227.0000, 'ºC'),
	(163460, 122, '2014-01-15 00:50:21.000000', 'temperatura', 565.0000, 'ºC'),
	(163461, 122, '2014-01-15 00:50:22.000000', 'temperatura', 941.0000, 'ºC'),
	(163462, 122, '2014-01-15 00:50:23.000000', 'temperatura', 613.0000, 'ºC'),
	(163463, 122, '2014-01-15 00:50:24.000000', 'temperatura', 243.0000, 'ºC'),
	(163464, 122, '2014-01-15 00:50:25.000000', 'temperatura', 577.0000, 'ºC'),
	(163465, 122, '2014-01-15 00:50:26.000000', 'temperatura', 956.0000, 'ºC'),
	(163466, 122, '2014-01-15 00:50:27.000000', 'temperatura', 649.0000, 'ºC'),
	(163467, 122, '2014-01-15 00:50:28.000000', 'temperatura', 379.0000, 'ºC'),
	(163468, 122, '2014-01-15 00:50:29.000000', 'temperatura', 1147.0000, 'ºC'),
	(163469, 122, '2014-01-15 00:50:30.000000', 'temperatura', 998.0000, 'ºC'),
	(163470, 122, '2014-01-15 00:50:31.000000', 'temperatura', 351.0000, 'ºC'),
	(163471, 122, '2014-01-15 00:50:32.000000', 'temperatura', 1162.0000, 'ºC'),
	(163472, 122, '2014-01-15 00:50:33.000000', 'temperatura', 1155.0000, 'ºC'),
	(163473, 122, '2014-01-15 00:50:34.000000', 'temperatura', 1090.0000, 'ºC'),
	(163474, 122, '2014-01-15 00:50:35.000000', 'temperatura', 787.0000, 'ºC'),
	(163475, 122, '2014-01-15 00:50:36.000000', 'temperatura', 666.0000, 'ºC'),
	(163476, 122, '2014-01-15 00:50:37.000000', 'temperatura', 968.0000, 'ºC'),
	(163477, 122, '2014-01-15 00:50:38.000000', 'temperatura', 442.0000, 'ºC'),
	(163478, 122, '2014-01-15 00:50:39.000000', 'temperatura', 509.0000, 'ºC'),
	(163479, 122, '2014-01-15 00:50:40.000000', 'temperatura', 16.0000, 'ºC'),
	(163480, 122, '2014-01-15 00:50:41.000000', 'temperatura', 957.0000, 'ºC'),
	(163481, 122, '2014-01-15 00:50:42.000000', 'temperatura', 1135.0000, 'ºC'),
	(163482, 122, '2014-01-15 00:50:43.000000', 'temperatura', 404.0000, 'ºC'),
	(163483, 122, '2014-01-15 00:50:44.000000', 'temperatura', 1017.0000, 'ºC'),
	(163484, 122, '2014-01-15 00:50:45.000000', 'temperatura', 272.0000, 'ºC'),
	(163485, 122, '2014-01-15 00:50:46.000000', 'temperatura', 712.0000, 'ºC'),
	(163486, 122, '2014-01-15 00:50:47.000000', 'temperatura', 345.0000, 'ºC'),
	(163487, 122, '2014-01-15 00:50:48.000000', 'temperatura', 786.0000, 'ºC'),
	(163488, 122, '2014-01-15 00:50:49.000000', 'temperatura', 499.0000, 'ºC'),
	(163489, 122, '2014-01-15 00:50:50.000000', 'temperatura', 136.0000, 'ºC'),
	(163490, 122, '2014-01-15 00:50:51.000000', 'temperatura', 382.0000, 'ºC'),
	(163491, 122, '2014-01-15 00:50:52.000000', 'temperatura', 305.0000, 'ºC'),
	(163492, 122, '2014-01-15 00:50:53.000000', 'temperatura', 380.0000, 'ºC'),
	(163493, 122, '2014-01-15 00:50:54.000000', 'temperatura', 983.0000, 'ºC'),
	(163494, 122, '2014-01-15 00:50:55.000000', 'temperatura', 176.0000, 'ºC'),
	(163495, 122, '2014-01-15 00:50:56.000000', 'temperatura', 331.0000, 'ºC'),
	(163496, 122, '2014-01-15 00:50:57.000000', 'temperatura', 1126.0000, 'ºC'),
	(163497, 122, '2014-01-15 00:50:58.000000', 'temperatura', 1039.0000, 'ºC'),
	(163498, 122, '2014-01-15 00:50:59.000000', 'temperatura', 617.0000, 'ºC'),
	(163499, 122, '2014-01-15 00:51:00.000000', 'temperatura', 1167.0000, 'ºC'),
	(163500, 122, '2014-01-15 00:51:01.000000', 'temperatura', 387.0000, 'ºC'),
	(163501, 122, '2014-01-15 00:51:02.000000', 'temperatura', 834.0000, 'ºC'),
	(163502, 122, '2014-01-15 00:51:03.000000', 'temperatura', 610.0000, 'ºC'),
	(163503, 122, '2014-01-15 00:51:04.000000', 'temperatura', 550.0000, 'ºC'),
	(163504, 122, '2014-01-15 00:51:05.000000', 'temperatura', 919.0000, 'ºC'),
	(163505, 122, '2014-01-15 00:51:06.000000', 'temperatura', 546.0000, 'ºC'),
	(163506, 122, '2014-01-15 00:51:07.000000', 'temperatura', 1173.0000, 'ºC'),
	(163507, 122, '2014-01-15 00:51:08.000000', 'temperatura', 626.0000, 'ºC'),
	(163508, 122, '2014-01-15 00:51:09.000000', 'temperatura', 811.0000, 'ºC'),
	(163509, 122, '2014-01-15 00:51:10.000000', 'temperatura', 981.0000, 'ºC'),
	(163510, 122, '2014-01-15 00:51:11.000000', 'temperatura', 69.0000, 'ºC'),
	(163511, 122, '2014-01-15 00:51:12.000000', 'temperatura', 1006.0000, 'ºC'),
	(163512, 122, '2014-01-15 00:51:13.000000', 'temperatura', 20.0000, 'ºC'),
	(163513, 122, '2014-01-15 00:51:14.000000', 'temperatura', 686.0000, 'ºC'),
	(163514, 122, '2014-01-15 00:51:15.000000', 'temperatura', 968.0000, 'ºC'),
	(163515, 122, '2014-01-15 00:51:16.000000', 'temperatura', 383.0000, 'ºC'),
	(163516, 122, '2014-01-15 00:51:17.000000', 'temperatura', 211.0000, 'ºC'),
	(163517, 122, '2014-01-15 00:51:18.000000', 'temperatura', 1108.0000, 'ºC'),
	(163518, 122, '2014-01-15 00:51:19.000000', 'temperatura', 109.0000, 'ºC'),
	(163519, 122, '2014-01-15 00:51:20.000000', 'temperatura', 818.0000, 'ºC'),
	(163520, 122, '2014-01-15 00:51:21.000000', 'temperatura', 166.0000, 'ºC'),
	(163521, 122, '2014-01-15 00:51:22.000000', 'temperatura', 776.0000, 'ºC'),
	(163522, 122, '2014-01-15 00:51:23.000000', 'temperatura', 984.0000, 'ºC'),
	(163523, 122, '2014-01-15 00:51:24.000000', 'temperatura', 193.0000, 'ºC'),
	(163524, 122, '2014-01-15 00:51:25.000000', 'temperatura', 412.0000, 'ºC'),
	(163525, 122, '2014-01-15 00:51:26.000000', 'temperatura', 282.0000, 'ºC'),
	(163526, 122, '2014-01-15 00:51:27.000000', 'temperatura', 174.0000, 'ºC'),
	(163527, 122, '2014-01-15 00:51:28.000000', 'temperatura', 25.0000, 'ºC'),
	(163528, 122, '2014-01-15 00:51:29.000000', 'temperatura', 803.0000, 'ºC'),
	(163529, 122, '2014-01-15 00:51:30.000000', 'temperatura', 340.0000, 'ºC'),
	(163530, 122, '2014-01-15 00:51:31.000000', 'temperatura', 493.0000, 'ºC'),
	(163531, 122, '2014-01-15 00:51:32.000000', 'temperatura', 246.0000, 'ºC'),
	(163532, 122, '2014-01-15 00:51:33.000000', 'temperatura', 949.0000, 'ºC'),
	(163533, 122, '2014-01-15 00:51:34.000000', 'temperatura', 408.0000, 'ºC'),
	(163534, 122, '2014-01-15 00:51:35.000000', 'temperatura', 394.0000, 'ºC'),
	(163535, 122, '2014-01-15 00:51:36.000000', 'temperatura', 748.0000, 'ºC'),
	(163536, 122, '2014-01-15 00:51:37.000000', 'temperatura', 157.0000, 'ºC'),
	(163537, 122, '2014-01-15 00:51:38.000000', 'temperatura', 942.0000, 'ºC'),
	(163538, 122, '2014-01-15 00:51:39.000000', 'temperatura', 638.0000, 'ºC'),
	(163539, 122, '2014-01-15 00:51:40.000000', 'temperatura', 366.0000, 'ºC'),
	(163540, 122, '2014-01-15 00:51:41.000000', 'temperatura', 1118.0000, 'ºC'),
	(163541, 122, '2014-01-15 00:51:42.000000', 'temperatura', 892.0000, 'ºC'),
	(163542, 122, '2014-01-15 00:51:43.000000', 'temperatura', 1105.0000, 'ºC'),
	(163543, 122, '2014-01-15 00:51:44.000000', 'temperatura', 449.0000, 'ºC'),
	(163544, 122, '2014-01-15 00:51:45.000000', 'temperatura', 131.0000, 'ºC'),
	(163545, 122, '2014-01-15 00:51:46.000000', 'temperatura', 507.0000, 'ºC'),
	(163546, 122, '2014-01-15 00:51:47.000000', 'temperatura', 946.0000, 'ºC'),
	(163547, 122, '2014-01-15 00:51:48.000000', 'temperatura', 807.0000, 'ºC'),
	(163548, 122, '2014-01-15 00:51:49.000000', 'temperatura', 1198.0000, 'ºC'),
	(163549, 122, '2014-01-15 00:51:50.000000', 'temperatura', 1169.0000, 'ºC'),
	(163550, 122, '2014-01-15 00:51:51.000000', 'temperatura', 1053.0000, 'ºC'),
	(163551, 122, '2014-01-15 00:51:52.000000', 'temperatura', 557.0000, 'ºC'),
	(163552, 122, '2014-01-15 00:51:53.000000', 'temperatura', 825.0000, 'ºC'),
	(163553, 122, '2014-01-15 00:51:54.000000', 'temperatura', 58.0000, 'ºC'),
	(163554, 122, '2014-01-15 00:51:55.000000', 'temperatura', 213.0000, 'ºC'),
	(163555, 122, '2014-01-15 00:51:56.000000', 'temperatura', 892.0000, 'ºC'),
	(163556, 122, '2014-01-15 00:51:57.000000', 'temperatura', 220.0000, 'ºC'),
	(163557, 122, '2014-01-15 00:51:58.000000', 'temperatura', 827.0000, 'ºC'),
	(163558, 122, '2014-01-15 00:51:59.000000', 'temperatura', 1076.0000, 'ºC'),
	(163559, 122, '2014-01-15 00:52:00.000000', 'temperatura', 499.0000, 'ºC'),
	(163560, 122, '2014-01-15 00:52:01.000000', 'temperatura', 467.0000, 'ºC'),
	(163561, 122, '2014-01-15 00:52:02.000000', 'temperatura', 841.0000, 'ºC'),
	(163562, 122, '2014-01-15 00:52:03.000000', 'temperatura', 401.0000, 'ºC'),
	(163563, 122, '2014-01-15 00:52:04.000000', 'temperatura', 684.0000, 'ºC'),
	(163564, 122, '2014-01-15 00:52:05.000000', 'temperatura', 1015.0000, 'ºC'),
	(163565, 122, '2014-01-15 00:52:06.000000', 'temperatura', 627.0000, 'ºC'),
	(163566, 122, '2014-01-15 00:52:07.000000', 'temperatura', 90.0000, 'ºC'),
	(163567, 122, '2014-01-15 00:52:08.000000', 'temperatura', 970.0000, 'ºC'),
	(163568, 122, '2014-01-15 00:52:09.000000', 'temperatura', 981.0000, 'ºC'),
	(163569, 122, '2014-01-15 00:52:10.000000', 'temperatura', 794.0000, 'ºC'),
	(163570, 122, '2014-01-15 00:52:11.000000', 'temperatura', 1026.0000, 'ºC'),
	(163571, 122, '2014-01-15 00:52:12.000000', 'temperatura', 351.0000, 'ºC'),
	(163572, 122, '2014-01-15 00:52:13.000000', 'temperatura', 1076.0000, 'ºC'),
	(163573, 122, '2014-01-15 00:52:14.000000', 'temperatura', 728.0000, 'ºC'),
	(163574, 122, '2014-01-15 00:52:15.000000', 'temperatura', 414.0000, 'ºC'),
	(163575, 122, '2014-01-15 00:52:16.000000', 'temperatura', 1084.0000, 'ºC'),
	(163576, 122, '2014-01-15 00:52:17.000000', 'temperatura', 578.0000, 'ºC'),
	(163577, 122, '2014-01-15 00:52:18.000000', 'temperatura', 841.0000, 'ºC'),
	(163578, 122, '2014-01-15 00:52:19.000000', 'temperatura', 69.0000, 'ºC'),
	(163579, 122, '2014-01-15 00:52:20.000000', 'temperatura', 223.0000, 'ºC'),
	(163580, 122, '2014-01-15 00:52:21.000000', 'temperatura', 908.0000, 'ºC'),
	(163581, 122, '2014-01-15 00:52:22.000000', 'temperatura', 274.0000, 'ºC'),
	(163582, 122, '2014-01-15 00:52:23.000000', 'temperatura', 1046.0000, 'ºC'),
	(163583, 122, '2014-01-15 00:52:24.000000', 'temperatura', 808.0000, 'ºC'),
	(163584, 122, '2014-01-15 00:52:25.000000', 'temperatura', 904.0000, 'ºC'),
	(163585, 122, '2014-01-15 00:52:26.000000', 'temperatura', 895.0000, 'ºC'),
	(163586, 122, '2014-01-15 00:52:27.000000', 'temperatura', 564.0000, 'ºC'),
	(163587, 122, '2014-01-15 00:52:28.000000', 'temperatura', 134.0000, 'ºC'),
	(163588, 122, '2014-01-15 00:52:29.000000', 'temperatura', 180.0000, 'ºC'),
	(163589, 122, '2014-01-15 00:52:30.000000', 'temperatura', 497.0000, 'ºC'),
	(163590, 122, '2014-01-15 00:52:31.000000', 'temperatura', 744.0000, 'ºC'),
	(163591, 122, '2014-01-15 00:52:32.000000', 'temperatura', 1032.0000, 'ºC'),
	(163592, 122, '2014-01-15 00:52:33.000000', 'temperatura', 527.0000, 'ºC'),
	(163593, 122, '2014-01-15 00:52:34.000000', 'temperatura', 739.0000, 'ºC'),
	(163594, 122, '2014-01-15 00:52:35.000000', 'temperatura', 916.0000, 'ºC'),
	(163595, 122, '2014-01-15 00:52:36.000000', 'temperatura', 1163.0000, 'ºC'),
	(163596, 122, '2014-01-15 00:52:37.000000', 'temperatura', 666.0000, 'ºC'),
	(163597, 122, '2014-01-15 00:52:38.000000', 'temperatura', 1043.0000, 'ºC'),
	(163598, 122, '2014-01-15 00:52:39.000000', 'temperatura', 817.0000, 'ºC'),
	(163599, 122, '2014-01-15 00:52:40.000000', 'temperatura', 956.0000, 'ºC'),
	(163600, 122, '2014-01-15 00:52:41.000000', 'temperatura', 1132.0000, 'ºC'),
	(163601, 122, '2014-01-15 00:52:42.000000', 'temperatura', 391.0000, 'ºC'),
	(163602, 122, '2014-01-15 00:52:43.000000', 'temperatura', 959.0000, 'ºC'),
	(163603, 122, '2014-01-15 00:52:44.000000', 'temperatura', 25.0000, 'ºC'),
	(163604, 122, '2014-01-15 00:52:45.000000', 'temperatura', 845.0000, 'ºC'),
	(163605, 122, '2014-01-15 00:52:46.000000', 'temperatura', 553.0000, 'ºC'),
	(163606, 122, '2014-01-15 00:52:47.000000', 'temperatura', 230.0000, 'ºC'),
	(163607, 122, '2014-01-15 00:52:48.000000', 'temperatura', 691.0000, 'ºC'),
	(163608, 122, '2014-01-15 00:52:49.000000', 'temperatura', 365.0000, 'ºC'),
	(163609, 122, '2014-01-15 00:52:50.000000', 'temperatura', 951.0000, 'ºC'),
	(163610, 122, '2014-01-15 00:52:51.000000', 'temperatura', 62.0000, 'ºC'),
	(163611, 122, '2014-01-15 00:52:52.000000', 'temperatura', 1056.0000, 'ºC'),
	(163612, 122, '2014-01-15 00:52:53.000000', 'temperatura', 294.0000, 'ºC'),
	(163613, 122, '2014-01-15 00:52:54.000000', 'temperatura', 702.0000, 'ºC'),
	(163614, 122, '2014-01-15 00:52:55.000000', 'temperatura', 231.0000, 'ºC'),
	(163615, 122, '2014-01-15 00:52:56.000000', 'temperatura', 249.0000, 'ºC'),
	(163616, 122, '2014-01-15 00:52:57.000000', 'temperatura', 553.0000, 'ºC'),
	(163617, 122, '2014-01-15 00:52:58.000000', 'temperatura', 816.0000, 'ºC'),
	(163618, 122, '2014-01-15 00:52:59.000000', 'temperatura', 22.0000, 'ºC'),
	(163619, 122, '2014-01-15 00:53:00.000000', 'temperatura', 63.0000, 'ºC'),
	(163620, 122, '2014-01-15 00:53:01.000000', 'temperatura', 248.0000, 'ºC'),
	(163621, 122, '2014-01-15 00:53:02.000000', 'temperatura', 1051.0000, 'ºC'),
	(163622, 122, '2014-01-15 00:53:03.000000', 'temperatura', 912.0000, 'ºC'),
	(163623, 122, '2014-01-15 00:53:04.000000', 'temperatura', 209.0000, 'ºC'),
	(163624, 122, '2014-01-15 00:53:05.000000', 'temperatura', 709.0000, 'ºC'),
	(163625, 122, '2014-01-15 00:53:06.000000', 'temperatura', 519.0000, 'ºC'),
	(163626, 122, '2014-01-15 00:53:07.000000', 'temperatura', 466.0000, 'ºC'),
	(163627, 122, '2014-01-15 00:53:08.000000', 'temperatura', 775.0000, 'ºC'),
	(163628, 122, '2014-01-15 00:53:09.000000', 'temperatura', 76.0000, 'ºC'),
	(163629, 122, '2014-01-15 00:53:10.000000', 'temperatura', 456.0000, 'ºC'),
	(163630, 122, '2014-01-15 00:53:11.000000', 'temperatura', 852.0000, 'ºC'),
	(163631, 122, '2014-01-15 00:53:12.000000', 'temperatura', 493.0000, 'ºC'),
	(163632, 122, '2014-01-15 00:53:13.000000', 'temperatura', 1109.0000, 'ºC'),
	(163633, 122, '2014-01-15 00:53:14.000000', 'temperatura', 469.0000, 'ºC'),
	(163634, 122, '2014-01-15 00:53:15.000000', 'temperatura', 217.0000, 'ºC'),
	(163635, 122, '2014-01-15 00:53:16.000000', 'temperatura', 879.0000, 'ºC'),
	(163636, 122, '2014-01-15 00:53:17.000000', 'temperatura', 143.0000, 'ºC'),
	(163637, 122, '2014-01-15 00:53:18.000000', 'temperatura', 478.0000, 'ºC'),
	(163638, 122, '2014-01-15 00:53:19.000000', 'temperatura', 764.0000, 'ºC'),
	(163639, 122, '2014-01-15 00:53:20.000000', 'temperatura', 1186.0000, 'ºC'),
	(163640, 122, '2014-01-15 00:53:21.000000', 'temperatura', 39.0000, 'ºC'),
	(163641, 122, '2014-01-15 00:53:22.000000', 'temperatura', 239.0000, 'ºC'),
	(163642, 122, '2014-01-15 00:53:23.000000', 'temperatura', 1075.0000, 'ºC'),
	(163643, 122, '2014-01-15 00:53:24.000000', 'temperatura', 1060.0000, 'ºC'),
	(163644, 122, '2014-01-15 00:53:25.000000', 'temperatura', 877.0000, 'ºC'),
	(163645, 122, '2014-01-15 00:53:26.000000', 'temperatura', 4.0000, 'ºC'),
	(163646, 122, '2014-01-15 00:53:27.000000', 'temperatura', 990.0000, 'ºC'),
	(163647, 122, '2014-01-15 00:53:28.000000', 'temperatura', 138.0000, 'ºC'),
	(163648, 122, '2014-01-15 00:53:29.000000', 'temperatura', 120.0000, 'ºC'),
	(163649, 122, '2014-01-15 00:53:30.000000', 'temperatura', 188.0000, 'ºC'),
	(163650, 122, '2014-01-15 00:53:31.000000', 'temperatura', 582.0000, 'ºC'),
	(163651, 122, '2014-01-15 00:53:32.000000', 'temperatura', 1144.0000, 'ºC'),
	(163652, 122, '2014-01-15 00:53:33.000000', 'temperatura', 376.0000, 'ºC'),
	(163653, 122, '2014-01-15 00:53:34.000000', 'temperatura', 849.0000, 'ºC'),
	(163654, 122, '2014-01-15 00:53:35.000000', 'temperatura', 718.0000, 'ºC'),
	(163655, 122, '2014-01-15 00:53:36.000000', 'temperatura', 1042.0000, 'ºC'),
	(163656, 122, '2014-01-15 00:53:37.000000', 'temperatura', 656.0000, 'ºC'),
	(163657, 122, '2014-01-15 00:53:38.000000', 'temperatura', 154.0000, 'ºC'),
	(163658, 122, '2014-01-15 00:53:39.000000', 'temperatura', 5.0000, 'ºC'),
	(163659, 122, '2014-01-15 00:53:40.000000', 'temperatura', 763.0000, 'ºC'),
	(163660, 122, '2014-01-15 00:53:41.000000', 'temperatura', 199.0000, 'ºC'),
	(163661, 122, '2014-01-15 00:53:42.000000', 'temperatura', 1107.0000, 'ºC'),
	(163662, 122, '2014-01-15 00:53:43.000000', 'temperatura', 139.0000, 'ºC'),
	(163663, 122, '2014-01-15 00:53:44.000000', 'temperatura', 973.0000, 'ºC'),
	(163664, 122, '2014-01-15 00:53:45.000000', 'temperatura', 849.0000, 'ºC'),
	(163665, 122, '2014-01-15 00:53:46.000000', 'temperatura', 129.0000, 'ºC'),
	(163666, 122, '2014-01-15 00:53:47.000000', 'temperatura', 496.0000, 'ºC'),
	(163667, 122, '2014-01-15 00:53:48.000000', 'temperatura', 895.0000, 'ºC'),
	(163668, 122, '2014-01-15 00:53:49.000000', 'temperatura', 588.0000, 'ºC'),
	(163669, 122, '2014-01-15 00:53:50.000000', 'temperatura', 254.0000, 'ºC'),
	(163670, 122, '2014-01-15 00:53:51.000000', 'temperatura', 707.0000, 'ºC'),
	(163671, 122, '2014-01-15 00:53:52.000000', 'temperatura', 373.0000, 'ºC'),
	(163672, 122, '2014-01-15 00:53:53.000000', 'temperatura', 943.0000, 'ºC'),
	(163673, 122, '2014-01-15 00:53:54.000000', 'temperatura', 1197.0000, 'ºC'),
	(163674, 122, '2014-01-15 00:53:55.000000', 'temperatura', 756.0000, 'ºC'),
	(163675, 122, '2014-01-15 00:53:56.000000', 'temperatura', 188.0000, 'ºC'),
	(163676, 122, '2014-01-15 00:53:57.000000', 'temperatura', 1075.0000, 'ºC'),
	(163677, 122, '2014-01-15 00:53:58.000000', 'temperatura', 9.0000, 'ºC'),
	(163678, 122, '2014-01-15 00:53:59.000000', 'temperatura', 421.0000, 'ºC'),
	(163679, 122, '2014-01-15 00:54:00.000000', 'temperatura', 877.0000, 'ºC'),
	(163680, 122, '2014-01-15 00:54:01.000000', 'temperatura', 724.0000, 'ºC'),
	(163681, 122, '2014-01-15 00:54:02.000000', 'temperatura', 990.0000, 'ºC'),
	(163682, 122, '2014-01-15 00:54:03.000000', 'temperatura', 378.0000, 'ºC'),
	(163683, 122, '2014-01-15 00:54:04.000000', 'temperatura', 122.0000, 'ºC'),
	(163684, 122, '2014-01-15 00:54:05.000000', 'temperatura', 675.0000, 'ºC'),
	(163685, 122, '2014-01-15 00:54:06.000000', 'temperatura', 610.0000, 'ºC'),
	(163686, 122, '2014-01-15 00:54:07.000000', 'temperatura', 1024.0000, 'ºC'),
	(163687, 122, '2014-01-15 00:54:08.000000', 'temperatura', 892.0000, 'ºC'),
	(163688, 122, '2014-01-15 00:54:09.000000', 'temperatura', 188.0000, 'ºC'),
	(163689, 122, '2014-01-15 00:54:10.000000', 'temperatura', 665.0000, 'ºC'),
	(163690, 122, '2014-01-15 00:54:11.000000', 'temperatura', 362.0000, 'ºC'),
	(163691, 122, '2014-01-15 00:54:12.000000', 'temperatura', 1014.0000, 'ºC'),
	(163692, 122, '2014-01-15 00:54:13.000000', 'temperatura', 387.0000, 'ºC'),
	(163693, 122, '2014-01-15 00:54:14.000000', 'temperatura', 92.0000, 'ºC'),
	(163694, 122, '2014-01-15 00:54:15.000000', 'temperatura', 500.0000, 'ºC'),
	(163695, 122, '2014-01-15 00:54:16.000000', 'temperatura', 1022.0000, 'ºC'),
	(163696, 122, '2014-01-15 00:54:17.000000', 'temperatura', 14.0000, 'ºC'),
	(163697, 122, '2014-01-15 00:54:18.000000', 'temperatura', 604.0000, 'ºC'),
	(163698, 122, '2014-01-15 00:54:19.000000', 'temperatura', 576.0000, 'ºC'),
	(163699, 122, '2014-01-15 00:54:20.000000', 'temperatura', 1070.0000, 'ºC'),
	(163700, 122, '2014-01-15 00:54:21.000000', 'temperatura', 22.0000, 'ºC'),
	(163701, 122, '2014-01-15 00:54:22.000000', 'temperatura', 501.0000, 'ºC'),
	(163702, 122, '2014-01-15 00:54:23.000000', 'temperatura', 39.0000, 'ºC'),
	(163703, 122, '2014-01-15 00:54:24.000000', 'temperatura', 1093.0000, 'ºC'),
	(163704, 122, '2014-01-15 00:54:25.000000', 'temperatura', 548.0000, 'ºC'),
	(163705, 122, '2014-01-15 00:54:26.000000', 'temperatura', 660.0000, 'ºC'),
	(163706, 122, '2014-01-15 00:54:27.000000', 'temperatura', 456.0000, 'ºC'),
	(163707, 122, '2014-01-15 00:54:28.000000', 'temperatura', 301.0000, 'ºC'),
	(163708, 122, '2014-01-15 00:54:29.000000', 'temperatura', 140.0000, 'ºC'),
	(163709, 122, '2014-01-15 00:54:30.000000', 'temperatura', 996.0000, 'ºC'),
	(163710, 122, '2014-01-15 00:54:31.000000', 'temperatura', 959.0000, 'ºC'),
	(163711, 122, '2014-01-15 00:54:32.000000', 'temperatura', 607.0000, 'ºC'),
	(163712, 122, '2014-01-15 00:54:33.000000', 'temperatura', 158.0000, 'ºC'),
	(163713, 122, '2014-01-15 00:54:34.000000', 'temperatura', 169.0000, 'ºC'),
	(163714, 122, '2014-01-15 00:54:35.000000', 'temperatura', 371.0000, 'ºC'),
	(163715, 122, '2014-01-15 00:54:36.000000', 'temperatura', 148.0000, 'ºC'),
	(163716, 122, '2014-01-15 00:54:37.000000', 'temperatura', 827.0000, 'ºC'),
	(163717, 122, '2014-01-15 00:54:38.000000', 'temperatura', 91.0000, 'ºC'),
	(163718, 122, '2014-01-15 00:54:39.000000', 'temperatura', 374.0000, 'ºC'),
	(163719, 122, '2014-01-15 00:54:40.000000', 'temperatura', 398.0000, 'ºC'),
	(163720, 122, '2014-01-15 00:54:41.000000', 'temperatura', 870.0000, 'ºC'),
	(163721, 122, '2014-01-15 00:54:42.000000', 'temperatura', 754.0000, 'ºC'),
	(163722, 122, '2014-01-15 00:54:43.000000', 'temperatura', 1162.0000, 'ºC'),
	(163723, 122, '2014-01-15 00:54:44.000000', 'temperatura', 1149.0000, 'ºC'),
	(163724, 122, '2014-01-15 00:54:45.000000', 'temperatura', 1059.0000, 'ºC'),
	(163725, 122, '2014-01-15 00:54:46.000000', 'temperatura', 649.0000, 'ºC'),
	(163726, 122, '2014-01-15 00:54:47.000000', 'temperatura', 68.0000, 'ºC'),
	(163727, 122, '2014-01-15 00:54:48.000000', 'temperatura', 793.0000, 'ºC'),
	(163728, 122, '2014-01-15 00:54:49.000000', 'temperatura', 164.0000, 'ºC'),
	(163729, 122, '2014-01-15 00:54:50.000000', 'temperatura', 839.0000, 'ºC'),
	(163730, 122, '2014-01-15 00:54:51.000000', 'temperatura', 104.0000, 'ºC'),
	(163731, 122, '2014-01-15 00:54:52.000000', 'temperatura', 405.0000, 'ºC'),
	(163732, 122, '2014-01-15 00:54:53.000000', 'temperatura', 513.0000, 'ºC'),
	(163733, 122, '2014-01-15 00:54:54.000000', 'temperatura', 152.0000, 'ºC'),
	(163734, 122, '2014-01-15 00:54:55.000000', 'temperatura', 420.0000, 'ºC'),
	(163735, 122, '2014-01-15 00:54:56.000000', 'temperatura', 446.0000, 'ºC'),
	(163736, 122, '2014-01-15 00:54:57.000000', 'temperatura', 968.0000, 'ºC'),
	(163737, 122, '2014-01-15 00:54:58.000000', 'temperatura', 1105.0000, 'ºC'),
	(163738, 122, '2014-01-15 00:54:59.000000', 'temperatura', 218.0000, 'ºC'),
	(163739, 122, '2014-01-15 00:55:00.000000', 'temperatura', 179.0000, 'ºC'),
	(163740, 122, '2014-01-15 00:55:01.000000', 'temperatura', 240.0000, 'ºC'),
	(163741, 122, '2014-01-15 00:55:02.000000', 'temperatura', 664.0000, 'ºC'),
	(163742, 122, '2014-01-15 00:55:03.000000', 'temperatura', 200.0000, 'ºC'),
	(163743, 122, '2014-01-15 00:55:04.000000', 'temperatura', 207.0000, 'ºC'),
	(163744, 122, '2014-01-15 00:55:05.000000', 'temperatura', 437.0000, 'ºC'),
	(163745, 122, '2014-01-15 00:55:06.000000', 'temperatura', 363.0000, 'ºC'),
	(163746, 122, '2014-01-15 00:55:07.000000', 'temperatura', 507.0000, 'ºC'),
	(163747, 122, '2014-01-15 00:55:08.000000', 'temperatura', 245.0000, 'ºC'),
	(163748, 122, '2014-01-15 00:55:09.000000', 'temperatura', 907.0000, 'ºC'),
	(163749, 122, '2014-01-15 00:55:10.000000', 'temperatura', 197.0000, 'ºC'),
	(163750, 122, '2014-01-15 00:55:11.000000', 'temperatura', 666.0000, 'ºC'),
	(163751, 122, '2014-01-15 00:55:12.000000', 'temperatura', 338.0000, 'ºC'),
	(163752, 122, '2014-01-15 00:55:13.000000', 'temperatura', 892.0000, 'ºC'),
	(163753, 122, '2014-01-15 00:55:14.000000', 'temperatura', 1045.0000, 'ºC'),
	(163754, 122, '2014-01-15 00:55:15.000000', 'temperatura', 153.0000, 'ºC'),
	(163755, 122, '2014-01-15 00:55:16.000000', 'temperatura', 29.0000, 'ºC'),
	(163756, 122, '2014-01-15 00:55:17.000000', 'temperatura', 888.0000, 'ºC'),
	(163757, 122, '2014-01-15 00:55:18.000000', 'temperatura', 754.0000, 'ºC'),
	(163758, 122, '2014-01-15 00:55:19.000000', 'temperatura', 1106.0000, 'ºC'),
	(163759, 122, '2014-01-15 00:55:20.000000', 'temperatura', 870.0000, 'ºC'),
	(163760, 122, '2014-01-15 00:55:21.000000', 'temperatura', 1032.0000, 'ºC'),
	(163761, 122, '2014-01-15 00:55:22.000000', 'temperatura', 151.0000, 'ºC'),
	(163762, 122, '2014-01-15 00:55:23.000000', 'temperatura', 57.0000, 'ºC'),
	(163763, 122, '2014-01-15 00:55:24.000000', 'temperatura', 1035.0000, 'ºC'),
	(163764, 122, '2014-01-15 00:55:25.000000', 'temperatura', 203.0000, 'ºC'),
	(163765, 122, '2014-01-15 00:55:26.000000', 'temperatura', 311.0000, 'ºC'),
	(163766, 122, '2014-01-15 00:55:27.000000', 'temperatura', 947.0000, 'ºC'),
	(163767, 122, '2014-01-15 00:55:28.000000', 'temperatura', 202.0000, 'ºC'),
	(163768, 122, '2014-01-15 00:55:29.000000', 'temperatura', 571.0000, 'ºC'),
	(163769, 122, '2014-01-15 00:55:30.000000', 'temperatura', 1047.0000, 'ºC'),
	(163770, 122, '2014-01-15 00:55:31.000000', 'temperatura', 1125.0000, 'ºC'),
	(163771, 122, '2014-01-15 00:55:32.000000', 'temperatura', 85.0000, 'ºC'),
	(163772, 122, '2014-01-15 00:55:33.000000', 'temperatura', 650.0000, 'ºC'),
	(163773, 122, '2014-01-15 00:55:34.000000', 'temperatura', 594.0000, 'ºC'),
	(163774, 122, '2014-01-15 00:55:35.000000', 'temperatura', 1020.0000, 'ºC'),
	(163775, 122, '2014-01-15 00:55:36.000000', 'temperatura', 920.0000, 'ºC'),
	(163776, 122, '2014-01-15 00:55:37.000000', 'temperatura', 341.0000, 'ºC'),
	(163777, 122, '2014-01-15 00:55:38.000000', 'temperatura', 146.0000, 'ºC'),
	(163778, 122, '2014-01-15 00:55:39.000000', 'temperatura', 907.0000, 'ºC'),
	(163779, 122, '2014-01-15 00:55:40.000000', 'temperatura', 497.0000, 'ºC'),
	(163780, 122, '2014-01-15 00:55:41.000000', 'temperatura', 967.0000, 'ºC'),
	(163781, 122, '2014-01-15 00:55:42.000000', 'temperatura', 942.0000, 'ºC'),
	(163782, 122, '2014-01-15 00:55:43.000000', 'temperatura', 609.0000, 'ºC'),
	(163783, 122, '2014-01-15 00:55:44.000000', 'temperatura', 220.0000, 'ºC'),
	(163784, 122, '2014-01-15 00:55:45.000000', 'temperatura', 475.0000, 'ºC'),
	(163785, 122, '2014-01-15 00:55:46.000000', 'temperatura', 513.0000, 'ºC'),
	(163786, 122, '2014-01-15 00:55:47.000000', 'temperatura', 1142.0000, 'ºC'),
	(163787, 122, '2014-01-15 00:55:48.000000', 'temperatura', 572.0000, 'ºC'),
	(163788, 122, '2014-01-15 00:55:49.000000', 'temperatura', 632.0000, 'ºC'),
	(163789, 122, '2014-01-15 00:55:50.000000', 'temperatura', 248.0000, 'ºC'),
	(163790, 122, '2014-01-15 00:55:51.000000', 'temperatura', 542.0000, 'ºC'),
	(163791, 122, '2014-01-15 00:55:52.000000', 'temperatura', 766.0000, 'ºC'),
	(163792, 122, '2014-01-15 00:55:53.000000', 'temperatura', 1005.0000, 'ºC'),
	(163793, 122, '2014-01-15 00:55:54.000000', 'temperatura', 328.0000, 'ºC'),
	(163794, 122, '2014-01-15 00:55:55.000000', 'temperatura', 1025.0000, 'ºC'),
	(163795, 122, '2014-01-15 00:55:56.000000', 'temperatura', 540.0000, 'ºC'),
	(163796, 122, '2014-01-15 00:55:57.000000', 'temperatura', 825.0000, 'ºC'),
	(163797, 122, '2014-01-15 00:55:58.000000', 'temperatura', 108.0000, 'ºC'),
	(163798, 122, '2014-01-15 00:55:59.000000', 'temperatura', 464.0000, 'ºC'),
	(163799, 122, '2014-01-15 00:56:00.000000', 'temperatura', 797.0000, 'ºC'),
	(163800, 122, '2014-01-15 00:56:01.000000', 'temperatura', 193.0000, 'ºC'),
	(163801, 122, '2014-01-15 00:56:02.000000', 'temperatura', 975.0000, 'ºC'),
	(163802, 122, '2014-01-15 00:56:03.000000', 'temperatura', 696.0000, 'ºC'),
	(163803, 122, '2014-01-15 00:56:04.000000', 'temperatura', 556.0000, 'ºC'),
	(163804, 122, '2014-01-15 00:56:05.000000', 'temperatura', 692.0000, 'ºC'),
	(163805, 122, '2014-01-15 00:56:06.000000', 'temperatura', 595.0000, 'ºC'),
	(163806, 122, '2014-01-15 00:56:07.000000', 'temperatura', 896.0000, 'ºC'),
	(163807, 122, '2014-01-15 00:56:08.000000', 'temperatura', 297.0000, 'ºC'),
	(163808, 122, '2014-01-15 00:56:09.000000', 'temperatura', 1199.0000, 'ºC'),
	(163809, 122, '2014-01-15 00:56:10.000000', 'temperatura', 304.0000, 'ºC'),
	(163810, 122, '2014-01-15 00:56:11.000000', 'temperatura', 324.0000, 'ºC'),
	(163811, 122, '2014-01-15 00:56:12.000000', 'temperatura', 709.0000, 'ºC'),
	(163812, 122, '2014-01-15 00:56:13.000000', 'temperatura', 173.0000, 'ºC'),
	(163813, 122, '2014-01-15 00:56:14.000000', 'temperatura', 1137.0000, 'ºC'),
	(163814, 122, '2014-01-15 00:56:15.000000', 'temperatura', 370.0000, 'ºC'),
	(163815, 122, '2014-01-15 00:56:16.000000', 'temperatura', 836.0000, 'ºC'),
	(163816, 122, '2014-01-15 00:56:17.000000', 'temperatura', 670.0000, 'ºC'),
	(163817, 122, '2014-01-15 00:56:18.000000', 'temperatura', 845.0000, 'ºC'),
	(163818, 122, '2014-01-15 00:56:19.000000', 'temperatura', 1017.0000, 'ºC'),
	(163819, 122, '2014-01-15 00:56:20.000000', 'temperatura', 148.0000, 'ºC'),
	(163820, 122, '2014-01-15 00:56:21.000000', 'temperatura', 88.0000, 'ºC'),
	(163821, 122, '2014-01-15 00:56:22.000000', 'temperatura', 1199.0000, 'ºC'),
	(163822, 122, '2014-01-15 00:56:23.000000', 'temperatura', 929.0000, 'ºC'),
	(163823, 122, '2014-01-15 00:56:24.000000', 'temperatura', 1052.0000, 'ºC'),
	(163824, 122, '2014-01-15 00:56:25.000000', 'temperatura', 70.0000, 'ºC'),
	(163825, 122, '2014-01-15 00:56:26.000000', 'temperatura', 797.0000, 'ºC'),
	(163826, 122, '2014-01-15 00:56:27.000000', 'temperatura', 175.0000, 'ºC'),
	(163827, 122, '2014-01-15 00:56:28.000000', 'temperatura', 883.0000, 'ºC'),
	(163828, 122, '2014-01-15 00:56:29.000000', 'temperatura', 290.0000, 'ºC'),
	(163829, 122, '2014-01-15 00:56:30.000000', 'temperatura', 4.0000, 'ºC'),
	(163830, 122, '2014-01-15 00:56:31.000000', 'temperatura', 350.0000, 'ºC'),
	(163831, 122, '2014-01-15 00:56:32.000000', 'temperatura', 537.0000, 'ºC'),
	(163832, 122, '2014-01-15 00:56:33.000000', 'temperatura', 438.0000, 'ºC'),
	(163833, 122, '2014-01-15 00:56:34.000000', 'temperatura', 578.0000, 'ºC'),
	(163834, 122, '2014-01-15 00:56:35.000000', 'temperatura', 378.0000, 'ºC'),
	(163835, 122, '2014-01-15 00:56:36.000000', 'temperatura', 157.0000, 'ºC'),
	(163836, 122, '2014-01-15 00:56:37.000000', 'temperatura', 848.0000, 'ºC'),
	(163837, 122, '2014-01-15 00:56:38.000000', 'temperatura', 173.0000, 'ºC'),
	(163838, 122, '2014-01-15 00:56:39.000000', 'temperatura', 721.0000, 'ºC'),
	(163839, 122, '2014-01-15 00:56:40.000000', 'temperatura', 687.0000, 'ºC'),
	(163840, 122, '2014-01-15 00:56:41.000000', 'temperatura', 73.0000, 'ºC'),
	(163841, 122, '2014-01-15 00:56:42.000000', 'temperatura', 706.0000, 'ºC'),
	(163842, 122, '2014-01-15 00:56:43.000000', 'temperatura', 908.0000, 'ºC'),
	(163843, 122, '2014-01-15 00:56:44.000000', 'temperatura', 24.0000, 'ºC'),
	(163844, 122, '2014-01-15 00:56:45.000000', 'temperatura', 995.0000, 'ºC'),
	(163845, 122, '2014-01-15 00:56:46.000000', 'temperatura', 106.0000, 'ºC'),
	(163846, 122, '2014-01-15 00:56:47.000000', 'temperatura', 1143.0000, 'ºC'),
	(163847, 122, '2014-01-15 00:56:48.000000', 'temperatura', 600.0000, 'ºC'),
	(163848, 122, '2014-01-15 00:56:49.000000', 'temperatura', 769.0000, 'ºC'),
	(163849, 122, '2014-01-15 00:56:50.000000', 'temperatura', 846.0000, 'ºC'),
	(163850, 122, '2014-01-15 00:56:51.000000', 'temperatura', 725.0000, 'ºC'),
	(163851, 122, '2014-01-15 00:56:52.000000', 'temperatura', 1089.0000, 'ºC'),
	(163852, 122, '2014-01-15 00:56:53.000000', 'temperatura', 868.0000, 'ºC'),
	(163853, 122, '2014-01-15 00:56:54.000000', 'temperatura', 1073.0000, 'ºC'),
	(163854, 122, '2014-01-15 00:56:55.000000', 'temperatura', 364.0000, 'ºC'),
	(163855, 122, '2014-01-15 00:56:56.000000', 'temperatura', 998.0000, 'ºC'),
	(163856, 122, '2014-01-15 00:56:57.000000', 'temperatura', 301.0000, 'ºC'),
	(163857, 122, '2014-01-15 00:56:58.000000', 'temperatura', 911.0000, 'ºC'),
	(163858, 122, '2014-01-15 00:56:59.000000', 'temperatura', 52.0000, 'ºC'),
	(163859, 122, '2014-01-15 00:57:00.000000', 'temperatura', 1126.0000, 'ºC'),
	(163860, 122, '2014-01-15 00:57:01.000000', 'temperatura', 676.0000, 'ºC'),
	(163861, 122, '2014-01-15 00:57:02.000000', 'temperatura', 3.0000, 'ºC'),
	(163862, 122, '2014-01-15 00:57:03.000000', 'temperatura', 389.0000, 'ºC'),
	(163863, 122, '2014-01-15 00:57:04.000000', 'temperatura', 735.0000, 'ºC'),
	(163864, 122, '2014-01-15 00:57:05.000000', 'temperatura', 108.0000, 'ºC'),
	(163865, 122, '2014-01-15 00:57:06.000000', 'temperatura', 736.0000, 'ºC'),
	(163866, 122, '2014-01-15 00:57:07.000000', 'temperatura', 958.0000, 'ºC'),
	(163867, 122, '2014-01-15 00:57:08.000000', 'temperatura', 180.0000, 'ºC'),
	(163868, 122, '2014-01-15 00:57:09.000000', 'temperatura', 425.0000, 'ºC'),
	(163869, 122, '2014-01-15 00:57:10.000000', 'temperatura', 389.0000, 'ºC'),
	(163870, 122, '2014-01-15 00:57:11.000000', 'temperatura', 668.0000, 'ºC'),
	(163871, 122, '2014-01-15 00:57:12.000000', 'temperatura', 974.0000, 'ºC'),
	(163872, 122, '2014-01-15 00:57:13.000000', 'temperatura', 466.0000, 'ºC'),
	(163873, 122, '2014-01-15 00:57:14.000000', 'temperatura', 611.0000, 'ºC'),
	(163874, 122, '2014-01-15 00:57:15.000000', 'temperatura', 457.0000, 'ºC'),
	(163875, 122, '2014-01-15 00:57:16.000000', 'temperatura', 450.0000, 'ºC'),
	(163876, 122, '2014-01-15 00:57:17.000000', 'temperatura', 881.0000, 'ºC'),
	(163877, 122, '2014-01-15 00:57:18.000000', 'temperatura', 654.0000, 'ºC'),
	(163878, 122, '2014-01-15 00:57:19.000000', 'temperatura', 629.0000, 'ºC'),
	(163879, 122, '2014-01-15 00:57:20.000000', 'temperatura', 1184.0000, 'ºC'),
	(163880, 122, '2014-01-15 00:57:21.000000', 'temperatura', 435.0000, 'ºC'),
	(163881, 122, '2014-01-15 00:57:22.000000', 'temperatura', 1021.0000, 'ºC'),
	(163882, 122, '2014-01-15 00:57:23.000000', 'temperatura', 200.0000, 'ºC'),
	(163883, 122, '2014-01-15 00:57:24.000000', 'temperatura', 338.0000, 'ºC'),
	(163884, 122, '2014-01-15 00:57:25.000000', 'temperatura', 1090.0000, 'ºC'),
	(163885, 122, '2014-01-15 00:57:26.000000', 'temperatura', 837.0000, 'ºC'),
	(163886, 122, '2014-01-15 00:57:27.000000', 'temperatura', 917.0000, 'ºC'),
	(163887, 122, '2014-01-15 00:57:28.000000', 'temperatura', 872.0000, 'ºC'),
	(163888, 122, '2014-01-15 00:57:29.000000', 'temperatura', 410.0000, 'ºC'),
	(163889, 122, '2014-01-15 00:57:30.000000', 'temperatura', 634.0000, 'ºC'),
	(163890, 122, '2014-01-15 00:57:31.000000', 'temperatura', 741.0000, 'ºC'),
	(163891, 122, '2014-01-15 00:57:32.000000', 'temperatura', 605.0000, 'ºC'),
	(163892, 122, '2014-01-15 00:57:33.000000', 'temperatura', 803.0000, 'ºC'),
	(163893, 122, '2014-01-15 00:57:34.000000', 'temperatura', 1001.0000, 'ºC'),
	(163894, 122, '2014-01-15 00:57:35.000000', 'temperatura', 196.0000, 'ºC'),
	(163895, 122, '2014-01-15 00:57:36.000000', 'temperatura', 379.0000, 'ºC'),
	(163896, 122, '2014-01-15 00:57:37.000000', 'temperatura', 107.0000, 'ºC'),
	(163897, 122, '2014-01-15 00:57:38.000000', 'temperatura', 599.0000, 'ºC'),
	(163898, 122, '2014-01-15 00:57:39.000000', 'temperatura', 272.0000, 'ºC'),
	(163899, 122, '2014-01-15 00:57:40.000000', 'temperatura', 765.0000, 'ºC'),
	(163900, 122, '2014-01-15 00:57:41.000000', 'temperatura', 608.0000, 'ºC'),
	(163901, 122, '2014-01-15 00:57:42.000000', 'temperatura', 745.0000, 'ºC'),
	(163902, 122, '2014-01-15 00:57:43.000000', 'temperatura', 702.0000, 'ºC'),
	(163903, 122, '2014-01-15 00:57:44.000000', 'temperatura', 75.0000, 'ºC'),
	(163904, 122, '2014-01-15 00:57:45.000000', 'temperatura', 671.0000, 'ºC'),
	(163905, 122, '2014-01-15 00:57:46.000000', 'temperatura', 731.0000, 'ºC'),
	(163906, 122, '2014-01-15 00:57:47.000000', 'temperatura', 442.0000, 'ºC'),
	(163907, 122, '2014-01-15 00:57:48.000000', 'temperatura', 16.0000, 'ºC'),
	(163908, 122, '2014-01-15 00:57:49.000000', 'temperatura', 1157.0000, 'ºC'),
	(163909, 122, '2014-01-15 00:57:50.000000', 'temperatura', 938.0000, 'ºC'),
	(163910, 122, '2014-01-15 00:57:51.000000', 'temperatura', 17.0000, 'ºC'),
	(163911, 122, '2014-01-15 00:57:52.000000', 'temperatura', 873.0000, 'ºC'),
	(163912, 122, '2014-01-15 00:57:53.000000', 'temperatura', 713.0000, 'ºC'),
	(163913, 122, '2014-01-15 00:57:54.000000', 'temperatura', 948.0000, 'ºC'),
	(163914, 122, '2014-01-15 00:57:55.000000', 'temperatura', 200.0000, 'ºC'),
	(163915, 122, '2014-01-15 00:57:56.000000', 'temperatura', 557.0000, 'ºC'),
	(163916, 122, '2014-01-15 00:57:57.000000', 'temperatura', 985.0000, 'ºC'),
	(163917, 122, '2014-01-15 00:57:58.000000', 'temperatura', 854.0000, 'ºC'),
	(163918, 122, '2014-01-15 00:57:59.000000', 'temperatura', 116.0000, 'ºC'),
	(163919, 122, '2014-01-15 00:58:00.000000', 'temperatura', 417.0000, 'ºC'),
	(163920, 122, '2014-01-15 00:58:01.000000', 'temperatura', 539.0000, 'ºC'),
	(163921, 122, '2014-01-15 00:58:02.000000', 'temperatura', 246.0000, 'ºC'),
	(163922, 122, '2014-01-15 00:58:03.000000', 'temperatura', 813.0000, 'ºC'),
	(163923, 122, '2014-01-15 00:58:04.000000', 'temperatura', 926.0000, 'ºC'),
	(163924, 122, '2014-01-15 00:58:05.000000', 'temperatura', 994.0000, 'ºC'),
	(163925, 122, '2014-01-15 00:58:06.000000', 'temperatura', 992.0000, 'ºC'),
	(163926, 122, '2014-01-15 00:58:07.000000', 'temperatura', 779.0000, 'ºC'),
	(163927, 122, '2014-01-15 00:58:08.000000', 'temperatura', 920.0000, 'ºC'),
	(163928, 122, '2014-01-15 00:58:09.000000', 'temperatura', 1065.0000, 'ºC'),
	(163929, 122, '2014-01-15 00:58:10.000000', 'temperatura', 162.0000, 'ºC'),
	(163930, 122, '2014-01-15 00:58:11.000000', 'temperatura', 16.0000, 'ºC'),
	(163931, 122, '2014-01-15 00:58:12.000000', 'temperatura', 794.0000, 'ºC'),
	(163932, 122, '2014-01-15 00:58:13.000000', 'temperatura', 321.0000, 'ºC'),
	(163933, 122, '2014-01-15 00:58:14.000000', 'temperatura', 427.0000, 'ºC'),
	(163934, 122, '2014-01-15 00:58:15.000000', 'temperatura', 1170.0000, 'ºC'),
	(163935, 122, '2014-01-15 00:58:16.000000', 'temperatura', 970.0000, 'ºC'),
	(163936, 122, '2014-01-15 00:58:17.000000', 'temperatura', 140.0000, 'ºC'),
	(163937, 122, '2014-01-15 00:58:18.000000', 'temperatura', 191.0000, 'ºC'),
	(163938, 122, '2014-01-15 00:58:19.000000', 'temperatura', 534.0000, 'ºC'),
	(163939, 122, '2014-01-15 00:58:20.000000', 'temperatura', 899.0000, 'ºC'),
	(163940, 122, '2014-01-15 00:58:21.000000', 'temperatura', 492.0000, 'ºC'),
	(163941, 122, '2014-01-15 00:58:22.000000', 'temperatura', 963.0000, 'ºC'),
	(163942, 122, '2014-01-15 00:58:23.000000', 'temperatura', 943.0000, 'ºC'),
	(163943, 122, '2014-01-15 00:58:24.000000', 'temperatura', 623.0000, 'ºC'),
	(163944, 122, '2014-01-15 00:58:25.000000', 'temperatura', 286.0000, 'ºC'),
	(163945, 122, '2014-01-15 00:58:26.000000', 'temperatura', 762.0000, 'ºC'),
	(163946, 122, '2014-01-15 00:58:27.000000', 'temperatura', 552.0000, 'ºC'),
	(163947, 122, '2014-01-15 00:58:28.000000', 'temperatura', 474.0000, 'ºC'),
	(163948, 122, '2014-01-15 00:58:29.000000', 'temperatura', 717.0000, 'ºC'),
	(163949, 122, '2014-01-15 00:58:30.000000', 'temperatura', 961.0000, 'ºC'),
	(163950, 122, '2014-01-15 00:58:31.000000', 'temperatura', 256.0000, 'ºC'),
	(163951, 122, '2014-01-15 00:58:32.000000', 'temperatura', 797.0000, 'ºC'),
	(163952, 122, '2014-01-15 00:58:33.000000', 'temperatura', 819.0000, 'ºC'),
	(163953, 122, '2014-01-15 00:58:34.000000', 'temperatura', 502.0000, 'ºC'),
	(163954, 122, '2014-01-15 00:58:35.000000', 'temperatura', 57.0000, 'ºC'),
	(163955, 122, '2014-01-15 00:58:36.000000', 'temperatura', 1176.0000, 'ºC'),
	(163956, 122, '2014-01-15 00:58:37.000000', 'temperatura', 912.0000, 'ºC'),
	(163957, 122, '2014-01-15 00:58:38.000000', 'temperatura', 1032.0000, 'ºC'),
	(163958, 122, '2014-01-15 00:58:39.000000', 'temperatura', 24.0000, 'ºC'),
	(163959, 122, '2014-01-15 00:58:40.000000', 'temperatura', 626.0000, 'ºC'),
	(163960, 122, '2014-01-15 00:58:41.000000', 'temperatura', 657.0000, 'ºC'),
	(163961, 122, '2014-01-15 00:58:42.000000', 'temperatura', 209.0000, 'ºC'),
	(163962, 122, '2014-01-15 00:58:43.000000', 'temperatura', 275.0000, 'ºC'),
	(163963, 122, '2014-01-15 00:58:44.000000', 'temperatura', 748.0000, 'ºC'),
	(163964, 122, '2014-01-15 00:58:45.000000', 'temperatura', 516.0000, 'ºC'),
	(163965, 122, '2014-01-15 00:58:46.000000', 'temperatura', 335.0000, 'ºC'),
	(163966, 122, '2014-01-15 00:58:47.000000', 'temperatura', 129.0000, 'ºC'),
	(163967, 122, '2014-01-15 00:58:48.000000', 'temperatura', 840.0000, 'ºC'),
	(163968, 122, '2014-01-15 00:58:49.000000', 'temperatura', 213.0000, 'ºC'),
	(163969, 122, '2014-01-15 00:58:50.000000', 'temperatura', 946.0000, 'ºC'),
	(163970, 122, '2014-01-15 00:58:51.000000', 'temperatura', 490.0000, 'ºC'),
	(163971, 122, '2014-01-15 00:58:52.000000', 'temperatura', 812.0000, 'ºC'),
	(163972, 122, '2014-01-15 00:58:53.000000', 'temperatura', 190.0000, 'ºC'),
	(163973, 122, '2014-01-15 00:58:54.000000', 'temperatura', 915.0000, 'ºC'),
	(163974, 122, '2014-01-15 00:58:55.000000', 'temperatura', 405.0000, 'ºC'),
	(163975, 122, '2014-01-15 00:58:56.000000', 'temperatura', 481.0000, 'ºC'),
	(163976, 122, '2014-01-15 00:58:57.000000', 'temperatura', 1188.0000, 'ºC'),
	(163977, 122, '2014-01-15 00:58:58.000000', 'temperatura', 901.0000, 'ºC'),
	(163978, 122, '2014-01-15 00:58:59.000000', 'temperatura', 942.0000, 'ºC'),
	(163979, 122, '2014-01-15 00:59:00.000000', 'temperatura', 805.0000, 'ºC'),
	(163980, 122, '2014-01-15 00:59:01.000000', 'temperatura', 1199.0000, 'ºC'),
	(163981, 122, '2014-01-15 00:59:02.000000', 'temperatura', 1180.0000, 'ºC'),
	(163982, 122, '2014-01-15 00:59:03.000000', 'temperatura', 1102.0000, 'ºC'),
	(163983, 122, '2014-01-15 00:59:04.000000', 'temperatura', 774.0000, 'ºC'),
	(163984, 122, '2014-01-15 00:59:05.000000', 'temperatura', 564.0000, 'ºC'),
	(163985, 122, '2014-01-15 00:59:06.000000', 'temperatura', 497.0000, 'ºC'),
	(163986, 122, '2014-01-15 00:59:07.000000', 'temperatura', 792.0000, 'ºC'),
	(163987, 122, '2014-01-15 00:59:08.000000', 'temperatura', 73.0000, 'ºC'),
	(163988, 122, '2014-01-15 00:59:09.000000', 'temperatura', 387.0000, 'ºC'),
	(163989, 122, '2014-01-15 00:59:10.000000', 'temperatura', 518.0000, 'ºC'),
	(163990, 122, '2014-01-15 00:59:11.000000', 'temperatura', 227.0000, 'ºC'),
	(163991, 122, '2014-01-15 00:59:12.000000', 'temperatura', 784.0000, 'ºC'),
	(163992, 122, '2014-01-15 00:59:13.000000', 'temperatura', 837.0000, 'ºC'),
	(163993, 122, '2014-01-15 00:59:14.000000', 'temperatura', 637.0000, 'ºC'),
	(163994, 122, '2014-01-15 00:59:15.000000', 'temperatura', 672.0000, 'ºC'),
	(163995, 122, '2014-01-15 00:59:16.000000', 'temperatura', 248.0000, 'ºC'),
	(163996, 122, '2014-01-15 00:59:17.000000', 'temperatura', 428.0000, 'ºC'),
	(163997, 122, '2014-01-15 00:59:18.000000', 'temperatura', 193.0000, 'ºC'),
	(163998, 122, '2014-01-15 00:59:19.000000', 'temperatura', 884.0000, 'ºC'),
	(163999, 122, '2014-01-15 00:59:20.000000', 'temperatura', 242.0000, 'ºC'),
	(164000, 122, '2014-01-15 00:59:21.000000', 'temperatura', 958.0000, 'ºC'),
	(164001, 122, '2014-01-15 00:59:22.000000', 'temperatura', 464.0000, 'ºC'),
	(164002, 122, '2014-01-15 00:59:23.000000', 'temperatura', 649.0000, 'ºC'),
	(164003, 122, '2014-01-15 00:59:24.000000', 'temperatura', 650.0000, 'ºC'),
	(164004, 122, '2014-01-15 00:59:25.000000', 'temperatura', 104.0000, 'ºC'),
	(164005, 122, '2014-01-15 00:59:26.000000', 'temperatura', 971.0000, 'ºC'),
	(164006, 122, '2014-01-15 00:59:27.000000', 'temperatura', 945.0000, 'ºC'),
	(164007, 122, '2014-01-15 00:59:28.000000', 'temperatura', 611.0000, 'ºC'),
	(164008, 122, '2014-01-15 00:59:29.000000', 'temperatura', 221.0000, 'ºC'),
	(164009, 122, '2014-01-15 00:59:30.000000', 'temperatura', 474.0000, 'ºC'),
	(164010, 122, '2014-01-15 00:59:31.000000', 'temperatura', 505.0000, 'ºC'),
	(164011, 122, '2014-01-15 00:59:32.000000', 'temperatura', 1104.0000, 'ºC'),
	(164012, 122, '2014-01-15 00:59:33.000000', 'temperatura', 407.0000, 'ºC'),
	(164013, 122, '2014-01-15 00:59:34.000000', 'temperatura', 1121.0000, 'ºC'),
	(164014, 122, '2014-01-15 00:59:35.000000', 'temperatura', 784.0000, 'ºC'),
	(164015, 122, '2014-01-15 00:59:36.000000', 'temperatura', 560.0000, 'ºC'),
	(164016, 122, '2014-01-15 00:59:37.000000', 'temperatura', 447.0000, 'ºC'),
	(164017, 122, '2014-01-15 00:59:38.000000', 'temperatura', 554.0000, 'ºC'),
	(164018, 122, '2014-01-15 00:59:39.000000', 'temperatura', 232.0000, 'ºC'),
	(164019, 122, '2014-01-15 00:59:40.000000', 'temperatura', 698.0000, 'ºC'),
	(164020, 122, '2014-01-15 00:59:41.000000', 'temperatura', 396.0000, 'ºC'),
	(164021, 122, '2014-01-15 00:59:42.000000', 'temperatura', 1086.0000, 'ºC'),
	(164022, 122, '2014-01-15 00:59:43.000000', 'temperatura', 643.0000, 'ºC'),
	(164023, 122, '2014-01-15 00:59:44.000000', 'temperatura', 1156.0000, 'ºC'),
	(164024, 122, '2014-01-15 00:59:45.000000', 'temperatura', 254.0000, 'ºC'),
	(164025, 122, '2014-01-15 00:59:46.000000', 'temperatura', 199.0000, 'ºC'),
	(164026, 122, '2014-01-15 00:59:47.000000', 'temperatura', 236.0000, 'ºC'),
	(164027, 122, '2014-01-15 00:59:48.000000', 'temperatura', 581.0000, 'ºC'),
	(164028, 122, '2014-01-15 00:59:49.000000', 'temperatura', 998.0000, 'ºC'),
	(164029, 122, '2014-01-15 00:59:50.000000', 'temperatura', 848.0000, 'ºC'),
	(164030, 122, '2014-01-15 00:59:51.000000', 'temperatura', 49.0000, 'ºC'),
	(164031, 122, '2014-01-15 00:59:52.000000', 'temperatura', 98.0000, 'ºC'),
	(164032, 122, '2014-01-15 00:59:53.000000', 'temperatura', 344.0000, 'ºC'),
	(164033, 122, '2014-01-15 00:59:54.000000', 'temperatura', 228.0000, 'ºC'),
	(164034, 122, '2014-01-15 00:59:55.000000', 'temperatura', 107.0000, 'ºC'),
	(164035, 122, '2014-01-15 00:59:56.000000', 'temperatura', 1052.0000, 'ºC'),
	(164036, 122, '2014-01-15 00:59:57.000000', 'temperatura', 138.0000, 'ºC'),
	(164037, 122, '2014-01-15 00:59:58.000000', 'temperatura', 1134.0000, 'ºC'),
	(164038, 122, '2014-01-15 00:59:59.000000', 'temperatura', 457.0000, 'ºC'),
	(164039, 122, '2014-01-15 01:00:00.000000', 'temperatura', 82.0000, 'ºC'),
	(164040, 122, '2014-01-15 01:00:01.000000', 'temperatura', 243.0000, 'ºC'),
	(164041, 122, '2014-01-15 01:00:02.000000', 'temperatura', 968.0000, 'ºC'),
	(164042, 122, '2014-01-15 01:00:03.000000', 'temperatura', 511.0000, 'ºC'),
	(164043, 122, '2014-01-15 01:00:04.000000', 'temperatura', 850.0000, 'ºC'),
	(164044, 122, '2014-01-15 01:00:05.000000', 'temperatura', 319.0000, 'ºC'),
	(164045, 122, '2014-01-15 01:00:06.000000', 'temperatura', 247.0000, 'ºC'),
	(164046, 122, '2014-01-15 01:00:07.000000', 'temperatura', 278.0000, 'ºC'),
	(164047, 122, '2014-01-15 01:00:08.000000', 'temperatura', 650.0000, 'ºC'),
	(164048, 122, '2014-01-15 01:00:09.000000', 'temperatura', 14.0000, 'ºC'),
	(164049, 122, '2014-01-15 01:00:10.000000', 'temperatura', 521.0000, 'ºC'),
	(164050, 122, '2014-01-15 01:00:11.000000', 'temperatura', 165.0000, 'ºC'),
	(164051, 122, '2014-01-15 01:00:12.000000', 'temperatura', 460.0000, 'ºC'),
	(164052, 122, '2014-01-15 01:00:13.000000', 'temperatura', 606.0000, 'ºC'),
	(164053, 122, '2014-01-15 01:00:14.000000', 'temperatura', 450.0000, 'ºC'),
	(164054, 122, '2014-01-15 01:00:15.000000', 'temperatura', 435.0000, 'ºC'),
	(164055, 122, '2014-01-15 01:00:16.000000', 'temperatura', 824.0000, 'ºC'),
	(164056, 122, '2014-01-15 01:00:17.000000', 'temperatura', 416.0000, 'ºC'),
	(164057, 122, '2014-01-15 01:00:18.000000', 'temperatura', 808.0000, 'ºC'),
	(164058, 122, '2014-01-15 01:00:19.000000', 'temperatura', 394.0000, 'ºC'),
	(164059, 122, '2014-01-15 01:00:20.000000', 'temperatura', 745.0000, 'ºC'),
	(164060, 122, '2014-01-15 01:00:21.000000', 'temperatura', 142.0000, 'ºC'),
	(164061, 122, '2014-01-15 01:00:22.000000', 'temperatura', 878.0000, 'ºC'),
	(164062, 122, '2014-01-15 01:00:23.000000', 'temperatura', 364.0000, 'ºC'),
	(164063, 122, '2014-01-15 01:00:24.000000', 'temperatura', 388.0000, 'ºC'),
	(164064, 122, '2014-01-15 01:00:25.000000', 'temperatura', 845.0000, 'ºC'),
	(164065, 122, '2014-01-15 01:00:26.000000', 'temperatura', 665.0000, 'ºC'),
	(164066, 122, '2014-01-15 01:00:27.000000', 'temperatura', 790.0000, 'ºC'),
	(164067, 122, '2014-01-15 01:00:28.000000', 'temperatura', 753.0000, 'ºC'),
	(164068, 122, '2014-01-15 01:00:29.000000', 'temperatura', 198.0000, 'ºC'),
	(164069, 122, '2014-01-15 01:00:30.000000', 'temperatura', 1131.0000, 'ºC'),
	(164070, 122, '2014-01-15 01:00:31.000000', 'temperatura', 261.0000, 'ºC'),
	(164071, 122, '2014-01-15 01:00:32.000000', 'temperatura', 314.0000, 'ºC'),
	(164072, 122, '2014-01-15 01:00:33.000000', 'temperatura', 785.0000, 'ºC'),
	(164073, 122, '2014-01-15 01:00:34.000000', 'temperatura', 587.0000, 'ºC'),
	(164074, 122, '2014-01-15 01:00:35.000000', 'temperatura', 577.0000, 'ºC'),
	(164075, 122, '2014-01-15 01:00:36.000000', 'temperatura', 1127.0000, 'ºC'),
	(164076, 122, '2014-01-15 01:00:37.000000', 'temperatura', 306.0000, 'ºC'),
	(164077, 122, '2014-01-15 01:00:38.000000', 'temperatura', 546.0000, 'ºC'),
	(164078, 122, '2014-01-15 01:00:39.000000', 'temperatura', 613.0000, 'ºC'),
	(164079, 122, '2014-01-15 01:00:40.000000', 'temperatura', 229.0000, 'ºC'),
	(164080, 122, '2014-01-15 01:00:41.000000', 'temperatura', 506.0000, 'ºC'),
	(164081, 122, '2014-01-15 01:00:42.000000', 'temperatura', 645.0000, 'ºC'),
	(164082, 122, '2014-01-15 01:00:43.000000', 'temperatura', 505.0000, 'ºC'),
	(164083, 122, '2014-01-15 01:00:44.000000', 'temperatura', 591.0000, 'ºC'),
	(164084, 122, '2014-01-15 01:00:45.000000', 'temperatura', 239.0000, 'ºC'),
	(164085, 122, '2014-01-15 01:00:46.000000', 'temperatura', 626.0000, 'ºC'),
	(164086, 122, '2014-01-15 01:00:47.000000', 'temperatura', 11.0000, 'ºC'),
	(164087, 122, '2014-01-15 01:00:48.000000', 'temperatura', 580.0000, 'ºC'),
	(164088, 122, '2014-01-15 01:00:49.000000', 'temperatura', 464.0000, 'ºC'),
	(164089, 122, '2014-01-15 01:00:50.000000', 'temperatura', 584.0000, 'ºC'),
	(164090, 122, '2014-01-15 01:00:51.000000', 'temperatura', 326.0000, 'ºC'),
	(164091, 122, '2014-01-15 01:00:52.000000', 'temperatura', 1081.0000, 'ºC'),
	(164092, 122, '2014-01-15 01:00:53.000000', 'temperatura', 827.0000, 'ºC'),
	(164093, 122, '2014-01-15 01:00:54.000000', 'temperatura', 892.0000, 'ºC'),
	(164094, 122, '2014-01-15 01:00:55.000000', 'temperatura', 781.0000, 'ºC'),
	(164095, 122, '2014-01-15 01:00:56.000000', 'temperatura', 28.0000, 'ºC'),
	(164096, 122, '2014-01-15 01:00:57.000000', 'temperatura', 199.0000, 'ºC'),
	(164097, 122, '2014-01-15 01:00:58.000000', 'temperatura', 912.0000, 'ºC'),
	(164098, 122, '2014-01-15 01:00:59.000000', 'temperatura', 362.0000, 'ºC'),
	(164099, 122, '2014-01-15 01:01:00.000000', 'temperatura', 273.0000, 'ºC'),
	(164100, 122, '2014-01-15 01:01:01.000000', 'temperatura', 280.0000, 'ºC'),
	(164101, 122, '2014-01-15 01:01:02.000000', 'temperatura', 583.0000, 'ºC'),
	(164102, 122, '2014-01-15 01:01:03.000000', 'temperatura', 876.0000, 'ºC'),
	(164103, 122, '2014-01-15 01:01:04.000000', 'temperatura', 229.0000, 'ºC'),
	(164104, 122, '2014-01-15 01:01:05.000000', 'temperatura', 917.0000, 'ºC'),
	(164105, 122, '2014-01-15 01:01:06.000000', 'temperatura', 301.0000, 'ºC'),
	(164106, 122, '2014-01-15 01:01:07.000000', 'temperatura', 1154.0000, 'ºC'),
	(164107, 122, '2014-01-15 01:01:08.000000', 'temperatura', 68.0000, 'ºC'),
	(164108, 122, '2014-01-15 01:01:09.000000', 'temperatura', 479.0000, 'ºC'),
	(164109, 122, '2014-01-15 01:01:10.000000', 'temperatura', 992.0000, 'ºC'),
	(164110, 122, '2014-01-15 01:01:11.000000', 'temperatura', 1124.0000, 'ºC'),
	(164111, 122, '2014-01-15 01:01:12.000000', 'temperatura', 244.0000, 'ºC'),
	(164112, 122, '2014-01-15 01:01:13.000000', 'temperatura', 249.0000, 'ºC'),
	(164113, 122, '2014-01-15 01:01:14.000000', 'temperatura', 511.0000, 'ºC'),
	(164114, 122, '2014-01-15 01:01:15.000000', 'temperatura', 612.0000, 'ºC'),
	(164115, 122, '2014-01-15 01:01:16.000000', 'temperatura', 325.0000, 'ºC'),
	(164116, 122, '2014-01-15 01:01:17.000000', 'temperatura', 992.0000, 'ºC'),
	(164117, 122, '2014-01-15 01:01:18.000000', 'temperatura', 385.0000, 'ºC'),
	(164118, 122, '2014-01-15 01:01:19.000000', 'temperatura', 150.0000, 'ºC'),
	(164119, 122, '2014-01-15 01:01:20.000000', 'temperatura', 795.0000, 'ºC'),
	(164120, 122, '2014-01-15 01:01:21.000000', 'temperatura', 1125.0000, 'ºC'),
	(164121, 122, '2014-01-15 01:01:22.000000', 'temperatura', 839.0000, 'ºC'),
	(164122, 122, '2014-01-15 01:01:23.000000', 'temperatura', 823.0000, 'ºC'),
	(164123, 122, '2014-01-15 01:01:24.000000', 'temperatura', 396.0000, 'ºC'),
	(164124, 122, '2014-01-15 01:01:25.000000', 'temperatura', 714.0000, 'ºC'),
	(164125, 122, '2014-01-15 01:01:26.000000', 'temperatura', 1182.0000, 'ºC'),
	(164126, 122, '2014-01-15 01:01:27.000000', 'temperatura', 169.0000, 'ºC'),
	(164127, 122, '2014-01-15 01:01:28.000000', 'temperatura', 900.0000, 'ºC'),
	(164128, 122, '2014-01-15 01:01:29.000000', 'temperatura', 391.0000, 'ºC'),
	(164129, 122, '2014-01-15 01:01:30.000000', 'temperatura', 457.0000, 'ºC'),
	(164130, 122, '2014-01-15 01:01:31.000000', 'temperatura', 1111.0000, 'ºC'),
	(164131, 122, '2014-01-15 01:01:32.000000', 'temperatura', 585.0000, 'ºC'),
	(164132, 122, '2014-01-15 01:01:33.000000', 'temperatura', 794.0000, 'ºC'),
	(164133, 122, '2014-01-15 01:01:34.000000', 'temperatura', 1015.0000, 'ºC'),
	(164134, 122, '2014-01-15 01:01:35.000000', 'temperatura', 293.0000, 'ºC'),
	(164135, 122, '2014-01-15 01:01:36.000000', 'temperatura', 821.0000, 'ºC'),
	(164136, 122, '2014-01-15 01:01:37.000000', 'temperatura', 825.0000, 'ºC'),
	(164137, 122, '2014-01-15 01:01:38.000000', 'temperatura', 465.0000, 'ºC'),
	(164138, 122, '2014-01-15 01:01:39.000000', 'temperatura', 1048.0000, 'ºC'),
	(164139, 122, '2014-01-15 01:01:40.000000', 'temperatura', 247.0000, 'ºC'),
	(164140, 122, '2014-01-15 01:01:41.000000', 'temperatura', 490.0000, 'ºC'),
	(164141, 122, '2014-01-15 01:01:42.000000', 'temperatura', 508.0000, 'ºC'),
	(164142, 122, '2014-01-15 01:01:43.000000', 'temperatura', 1074.0000, 'ºC'),
	(164143, 122, '2014-01-15 01:01:44.000000', 'temperatura', 245.0000, 'ºC'),
	(164144, 122, '2014-01-15 01:01:45.000000', 'temperatura', 403.0000, 'ºC'),
	(164145, 122, '2014-01-15 01:01:46.000000', 'temperatura', 81.0000, 'ºC'),
	(164146, 122, '2014-01-15 01:01:47.000000', 'temperatura', 397.0000, 'ºC'),
	(164147, 122, '2014-01-15 01:01:48.000000', 'temperatura', 543.0000, 'ºC'),
	(164148, 122, '2014-01-15 01:01:49.000000', 'temperatura', 326.0000, 'ºC'),
	(164149, 122, '2014-01-15 01:01:50.000000', 'temperatura', 1199.0000, 'ºC'),
	(164150, 122, '2014-01-15 01:01:51.000000', 'temperatura', 220.0000, 'ºC'),
	(164151, 122, '2014-01-15 01:01:52.000000', 'temperatura', 1103.0000, 'ºC'),
	(164152, 122, '2014-01-15 01:01:53.000000', 'temperatura', 55.0000, 'ºC'),
	(164153, 122, '2014-01-15 01:01:54.000000', 'temperatura', 567.0000, 'ºC'),
	(164154, 122, '2014-01-15 01:01:55.000000', 'temperatura', 270.0000, 'ºC'),
	(164155, 122, '2014-01-15 01:01:56.000000', 'temperatura', 850.0000, 'ºC'),
	(164156, 122, '2014-01-15 01:01:57.000000', 'temperatura', 1041.0000, 'ºC'),
	(164157, 122, '2014-01-15 01:01:58.000000', 'temperatura', 253.0000, 'ºC'),
	(164158, 122, '2014-01-15 01:01:59.000000', 'temperatura', 543.0000, 'ºC'),
	(164159, 122, '2014-01-15 01:02:00.000000', 'temperatura', 757.0000, 'ºC'),
	(164160, 122, '2014-01-15 01:02:01.000000', 'temperatura', 958.0000, 'ºC'),
	(164161, 122, '2014-01-15 01:02:02.000000', 'temperatura', 119.0000, 'ºC'),
	(164162, 122, '2014-01-15 01:02:03.000000', 'temperatura', 121.0000, 'ºC'),
	(164163, 122, '2014-01-15 01:02:04.000000', 'temperatura', 247.0000, 'ºC'),
	(164164, 122, '2014-01-15 01:02:05.000000', 'temperatura', 873.0000, 'ºC'),
	(164165, 122, '2014-01-15 01:02:06.000000', 'temperatura', 25.0000, 'ºC'),
	(164166, 122, '2014-01-15 01:02:07.000000', 'temperatura', 1107.0000, 'ºC'),
	(164167, 122, '2014-01-15 01:02:08.000000', 'temperatura', 661.0000, 'ºC'),
	(164168, 122, '2014-01-15 01:02:09.000000', 'temperatura', 1182.0000, 'ºC'),
	(164169, 122, '2014-01-15 01:02:10.000000', 'temperatura', 330.0000, 'ºC'),
	(164170, 122, '2014-01-15 01:02:11.000000', 'temperatura', 502.0000, 'ºC'),
	(164171, 122, '2014-01-15 01:02:12.000000', 'temperatura', 323.0000, 'ºC'),
	(164172, 122, '2014-01-15 01:02:13.000000', 'temperatura', 110.0000, 'ºC'),
	(164173, 122, '2014-01-15 01:02:14.000000', 'temperatura', 782.0000, 'ºC'),
	(164174, 122, '2014-01-15 01:02:15.000000', 'temperatura', 1178.0000, 'ºC'),
	(164175, 122, '2014-01-15 01:02:16.000000', 'temperatura', 1145.0000, 'ºC'),
	(164176, 122, '2014-01-15 01:02:17.000000', 'temperatura', 993.0000, 'ºC'),
	(164177, 122, '2014-01-15 01:02:18.000000', 'temperatura', 329.0000, 'ºC'),
	(164178, 122, '2014-01-15 01:02:19.000000', 'temperatura', 1066.0000, 'ºC'),
	(164179, 122, '2014-01-15 01:02:20.000000', 'temperatura', 743.0000, 'ºC'),
	(164180, 122, '2014-01-15 01:02:21.000000', 'temperatura', 519.0000, 'ºC'),
	(164181, 122, '2014-01-15 01:02:22.000000', 'temperatura', 366.0000, 'ºC'),
	(164182, 122, '2014-01-15 01:02:23.000000', 'temperatura', 274.0000, 'ºC'),
	(164183, 122, '2014-01-15 01:02:24.000000', 'temperatura', 271.0000, 'ºC'),
	(164184, 122, '2014-01-15 01:02:25.000000', 'temperatura', 535.0000, 'ºC'),
	(164185, 122, '2014-01-15 01:02:26.000000', 'temperatura', 661.0000, 'ºC'),
	(164186, 122, '2014-01-15 01:02:27.000000', 'temperatura', 501.0000, 'ºC'),
	(164187, 122, '2014-01-15 01:02:28.000000', 'temperatura', 522.0000, 'ºC'),
	(164188, 122, '2014-01-15 01:02:29.000000', 'temperatura', 1108.0000, 'ºC'),
	(164189, 122, '2014-01-15 01:02:30.000000', 'temperatura', 373.0000, 'ºC'),
	(164190, 122, '2014-01-15 01:02:31.000000', 'temperatura', 941.0000, 'ºC'),
	(164191, 122, '2014-01-15 01:02:32.000000', 'temperatura', 1187.0000, 'ºC'),
	(164192, 122, '2014-01-15 01:02:33.000000', 'temperatura', 711.0000, 'ºC'),
	(164193, 122, '2014-01-15 01:02:34.000000', 'temperatura', 1195.0000, 'ºC'),
	(164194, 122, '2014-01-15 01:02:35.000000', 'temperatura', 245.0000, 'ºC'),
	(164195, 122, '2014-01-15 01:02:36.000000', 'temperatura', 38.0000, 'ºC'),
	(164196, 122, '2014-01-15 01:02:37.000000', 'temperatura', 657.0000, 'ºC'),
	(164197, 122, '2014-01-15 01:02:38.000000', 'temperatura', 771.0000, 'ºC'),
	(164198, 122, '2014-01-15 01:02:39.000000', 'temperatura', 686.0000, 'ºC'),
	(164199, 122, '2014-01-15 01:02:40.000000', 'temperatura', 1116.0000, 'ºC'),
	(164200, 122, '2014-01-15 01:02:41.000000', 'temperatura', 1125.0000, 'ºC'),
	(164201, 122, '2014-01-15 01:02:42.000000', 'temperatura', 1076.0000, 'ºC'),
	(164202, 122, '2014-01-15 01:02:43.000000', 'temperatura', 804.0000, 'ºC'),
	(164203, 122, '2014-01-15 01:02:44.000000', 'temperatura', 794.0000, 'ºC'),
	(164204, 122, '2014-01-15 01:02:45.000000', 'temperatura', 360.0000, 'ºC'),
	(164205, 122, '2014-01-15 01:02:46.000000', 'temperatura', 616.0000, 'ºC'),
	(164206, 122, '2014-01-15 01:02:47.000000', 'temperatura', 802.0000, 'ºC'),
	(164207, 122, '2014-01-15 01:02:48.000000', 'temperatura', 962.0000, 'ºC'),
	(164208, 122, '2014-01-15 01:02:49.000000', 'temperatura', 3.0000, 'ºC'),
	(164209, 122, '2014-01-15 01:02:50.000000', 'temperatura', 731.0000, 'ºC'),
	(164210, 122, '2014-01-15 01:02:51.000000', 'temperatura', 47.0000, 'ºC'),
	(164211, 122, '2014-01-15 01:02:52.000000', 'temperatura', 444.0000, 'ºC'),
	(164212, 122, '2014-01-15 01:02:53.000000', 'temperatura', 877.0000, 'ºC'),
	(164213, 122, '2014-01-15 01:02:54.000000', 'temperatura', 654.0000, 'ºC'),
	(164214, 122, '2014-01-15 01:02:55.000000', 'temperatura', 638.0000, 'ºC'),
	(164215, 122, '2014-01-15 01:02:56.000000', 'temperatura', 28.0000, 'ºC'),
	(164216, 122, '2014-01-15 01:02:57.000000', 'temperatura', 627.0000, 'ºC'),
	(164217, 122, '2014-01-15 01:02:58.000000', 'temperatura', 650.0000, 'ºC'),
	(164218, 122, '2014-01-15 01:02:59.000000', 'temperatura', 172.0000, 'ºC'),
	(164219, 122, '2014-01-15 01:03:00.000000', 'temperatura', 110.0000, 'ºC'),
	(164220, 122, '2014-01-15 01:03:01.000000', 'temperatura', 36.0000, 'ºC'),
	(164221, 122, '2014-01-15 01:03:02.000000', 'temperatura', 1048.0000, 'ºC'),
	(164222, 122, '2014-01-15 01:03:03.000000', 'temperatura', 332.0000, 'ºC'),
	(164223, 122, '2014-01-15 01:03:04.000000', 'temperatura', 918.0000, 'ºC'),
	(164224, 122, '2014-01-15 01:03:05.000000', 'temperatura', 1192.0000, 'ºC'),
	(164225, 122, '2014-01-15 01:03:06.000000', 'temperatura', 808.0000, 'ºC'),
	(164226, 122, '2014-01-15 01:03:07.000000', 'temperatura', 466.0000, 'ºC'),
	(164227, 122, '2014-01-15 01:03:08.000000', 'temperatura', 1104.0000, 'ºC'),
	(164228, 122, '2014-01-15 01:03:09.000000', 'temperatura', 524.0000, 'ºC'),
	(164229, 122, '2014-01-15 01:03:10.000000', 'temperatura', 507.0000, 'ºC'),
	(164230, 122, '2014-01-15 01:03:11.000000', 'temperatura', 964.0000, 'ºC'),
	(164231, 122, '2014-01-15 01:03:12.000000', 'temperatura', 902.0000, 'ºC'),
	(164232, 122, '2014-01-15 01:03:13.000000', 'temperatura', 416.0000, 'ºC'),
	(164233, 122, '2014-01-15 01:03:14.000000', 'temperatura', 576.0000, 'ºC'),
	(164234, 122, '2014-01-15 01:03:15.000000', 'temperatura', 431.0000, 'ºC'),
	(164235, 122, '2014-01-15 01:03:16.000000', 'temperatura', 430.0000, 'ºC'),
	(164236, 122, '2014-01-15 01:03:17.000000', 'temperatura', 857.0000, 'ºC'),
	(164237, 122, '2014-01-15 01:03:18.000000', 'temperatura', 594.0000, 'ºC'),
	(164238, 122, '2014-01-15 01:03:19.000000', 'temperatura', 401.0000, 'ºC'),
	(164239, 122, '2014-01-15 01:03:20.000000', 'temperatura', 224.0000, 'ºC'),
	(164240, 122, '2014-01-15 01:03:21.000000', 'temperatura', 1118.0000, 'ºC'),
	(164241, 122, '2014-01-15 01:03:22.000000', 'temperatura', 116.0000, 'ºC'),
	(164242, 122, '2014-01-15 01:03:23.000000', 'temperatura', 827.0000, 'ºC'),
	(164243, 122, '2014-01-15 01:03:24.000000', 'temperatura', 190.0000, 'ºC'),
	(164244, 122, '2014-01-15 01:03:25.000000', 'temperatura', 867.0000, 'ºC'),
	(164245, 122, '2014-01-15 01:03:26.000000', 'temperatura', 166.0000, 'ºC'),
	(164246, 122, '2014-01-15 01:03:27.000000', 'temperatura', 629.0000, 'ºC'),
	(164247, 122, '2014-01-15 01:03:28.000000', 'temperatura', 250.0000, 'ºC'),
	(164248, 122, '2014-01-15 01:03:29.000000', 'temperatura', 560.0000, 'ºC'),
	(164249, 122, '2014-01-15 01:03:30.000000', 'temperatura', 852.0000, 'ºC'),
	(164250, 122, '2014-01-15 01:03:31.000000', 'temperatura', 183.0000, 'ºC'),
	(164251, 122, '2014-01-15 01:03:32.000000', 'temperatura', 756.0000, 'ºC'),
	(164252, 122, '2014-01-15 01:03:33.000000', 'temperatura', 831.0000, 'ºC'),
	(164253, 122, '2014-01-15 01:03:34.000000', 'temperatura', 690.0000, 'ºC'),
	(164254, 122, '2014-01-15 01:03:35.000000', 'temperatura', 955.0000, 'ºC'),
	(164255, 122, '2014-01-15 01:03:36.000000', 'temperatura', 306.0000, 'ºC'),
	(164256, 122, '2014-01-15 01:03:37.000000', 'temperatura', 1067.0000, 'ºC'),
	(164257, 122, '2014-01-15 01:03:38.000000', 'temperatura', 816.0000, 'ºC'),
	(164258, 122, '2014-01-15 01:03:39.000000', 'temperatura', 881.0000, 'ºC'),
	(164259, 122, '2014-01-15 01:03:40.000000', 'temperatura', 757.0000, 'ºC'),
	(164260, 122, '2014-01-15 01:03:41.000000', 'temperatura', 1142.0000, 'ºC'),
	(164261, 122, '2014-01-15 01:03:42.000000', 'temperatura', 1038.0000, 'ºC'),
	(164262, 122, '2014-01-15 01:03:43.000000', 'temperatura', 567.0000, 'ºC'),
	(164263, 122, '2014-01-15 01:03:44.000000', 'temperatura', 919.0000, 'ºC'),
	(164264, 122, '2014-01-15 01:03:45.000000', 'temperatura', 495.0000, 'ºC'),
	(164265, 122, '2014-01-15 01:03:46.000000', 'temperatura', 919.0000, 'ºC'),
	(164266, 122, '2014-01-15 01:03:47.000000', 'temperatura', 709.0000, 'ºC'),
	(164267, 122, '2014-01-15 01:03:48.000000', 'temperatura', 791.0000, 'ºC'),
	(164268, 122, '2014-01-15 01:03:49.000000', 'temperatura', 628.0000, 'ºC'),
	(164269, 122, '2014-01-15 01:03:50.000000', 'temperatura', 765.0000, 'ºC'),
	(164270, 122, '2014-01-15 01:03:51.000000', 'temperatura', 744.0000, 'ºC'),
	(164271, 122, '2014-01-15 01:03:52.000000', 'temperatura', 224.0000, 'ºC'),
	(164272, 122, '2014-01-15 01:03:53.000000', 'temperatura', 87.0000, 'ºC'),
	(164273, 122, '2014-01-15 01:03:54.000000', 'temperatura', 965.0000, 'ºC'),
	(164274, 122, '2014-01-15 01:03:55.000000', 'temperatura', 963.0000, 'ºC'),
	(164275, 122, '2014-01-15 01:03:56.000000', 'temperatura', 720.0000, 'ºC'),
	(164276, 122, '2014-01-15 01:03:57.000000', 'temperatura', 712.0000, 'ºC'),
	(164277, 122, '2014-01-15 01:03:58.000000', 'temperatura', 199.0000, 'ºC'),
	(164278, 122, '2014-01-15 01:03:59.000000', 'temperatura', 62.0000, 'ºC'),
	(164279, 122, '2014-01-15 01:04:00.000000', 'temperatura', 911.0000, 'ºC'),
	(164280, 122, '2014-01-15 01:04:01.000000', 'temperatura', 770.0000, 'ºC'),
	(164281, 122, '2014-01-15 01:04:02.000000', 'temperatura', 1118.0000, 'ºC'),
	(164282, 122, '2014-01-15 01:04:03.000000', 'temperatura', 879.0000, 'ºC'),
	(164283, 122, '2014-01-15 01:04:04.000000', 'temperatura', 1043.0000, 'ºC'),
	(164284, 122, '2014-01-15 01:04:05.000000', 'temperatura', 177.0000, 'ºC'),
	(164285, 122, '2014-01-15 01:04:06.000000', 'temperatura', 158.0000, 'ºC'),
	(164286, 122, '2014-01-15 01:04:07.000000', 'temperatura', 260.0000, 'ºC'),
	(164287, 122, '2014-01-15 01:04:08.000000', 'temperatura', 828.0000, 'ºC'),
	(164288, 122, '2014-01-15 01:04:09.000000', 'temperatura', 958.0000, 'ºC'),
	(164289, 122, '2014-01-15 01:04:10.000000', 'temperatura', 1109.0000, 'ºC'),
	(164290, 122, '2014-01-15 01:04:11.000000', 'temperatura', 269.0000, 'ºC'),
	(164291, 122, '2014-01-15 01:04:12.000000', 'temperatura', 419.0000, 'ºC'),
	(164292, 122, '2014-01-15 01:04:13.000000', 'temperatura', 87.0000, 'ºC'),
	(164293, 122, '2014-01-15 01:04:14.000000', 'temperatura', 382.0000, 'ºC'),
	(164294, 122, '2014-01-15 01:04:15.000000', 'temperatura', 446.0000, 'ºC'),
	(164295, 122, '2014-01-15 01:04:16.000000', 'temperatura', 1087.0000, 'ºC'),
	(164296, 122, '2014-01-15 01:04:17.000000', 'temperatura', 498.0000, 'ºC'),
	(164297, 122, '2014-01-15 01:04:18.000000', 'temperatura', 428.0000, 'ºC'),
	(164298, 122, '2014-01-15 01:04:19.000000', 'temperatura', 646.0000, 'ºC'),
	(164299, 122, '2014-01-15 01:04:20.000000', 'temperatura', 749.0000, 'ºC'),
	(164300, 122, '2014-01-15 01:04:21.000000', 'temperatura', 605.0000, 'ºC'),
	(164301, 122, '2014-01-15 01:04:22.000000', 'temperatura', 778.0000, 'ºC'),
	(164302, 122, '2014-01-15 01:04:23.000000', 'temperatura', 876.0000, 'ºC'),
	(164303, 122, '2014-01-15 01:04:24.000000', 'temperatura', 847.0000, 'ºC'),
	(164304, 122, '2014-01-15 01:04:25.000000', 'temperatura', 406.0000, 'ºC'),
	(164305, 122, '2014-01-15 01:04:26.000000', 'temperatura', 691.0000, 'ºC'),
	(164306, 122, '2014-01-15 01:04:27.000000', 'temperatura', 1036.0000, 'ºC'),
	(164307, 122, '2014-01-15 01:04:28.000000', 'temperatura', 709.0000, 'ºC'),
	(164308, 122, '2014-01-15 01:04:29.000000', 'temperatura', 438.0000, 'ºC'),
	(164309, 122, '2014-01-15 01:04:30.000000', 'temperatura', 65.0000, 'ºC'),
	(164310, 122, '2014-01-15 01:04:31.000000', 'temperatura', 208.0000, 'ºC'),
	(164311, 122, '2014-01-15 01:04:32.000000', 'temperatura', 847.0000, 'ºC'),
	(164312, 122, '2014-01-15 01:04:33.000000', 'temperatura', 10.0000, 'ºC'),
	(164313, 122, '2014-01-15 01:04:34.000000', 'temperatura', 1113.0000, 'ºC'),
	(164314, 122, '2014-01-15 01:04:35.000000', 'temperatura', 732.0000, 'ºC'),
	(164315, 122, '2014-01-15 01:04:36.000000', 'temperatura', 323.0000, 'ºC'),
	(164316, 122, '2014-01-15 01:04:37.000000', 'temperatura', 618.0000, 'ºC'),
	(164317, 122, '2014-01-15 01:04:38.000000', 'temperatura', 923.0000, 'ºC'),
	(164318, 122, '2014-01-15 01:04:39.000000', 'temperatura', 363.0000, 'ºC'),
	(164319, 122, '2014-01-15 01:04:40.000000', 'temperatura', 245.0000, 'ºC'),
	(164320, 122, '2014-01-15 01:04:41.000000', 'temperatura', 137.0000, 'ºC'),
	(164321, 122, '2014-01-15 01:04:42.000000', 'temperatura', 1151.0000, 'ºC'),
	(164322, 122, '2014-01-15 01:04:43.000000', 'temperatura', 543.0000, 'ºC'),
	(164323, 122, '2014-01-15 01:04:44.000000', 'temperatura', 463.0000, 'ºC'),
	(164324, 122, '2014-01-15 01:04:45.000000', 'temperatura', 687.0000, 'ºC'),
	(164325, 122, '2014-01-15 01:04:46.000000', 'temperatura', 846.0000, 'ºC'),
	(164326, 122, '2014-01-15 01:04:47.000000', 'temperatura', 970.0000, 'ºC'),
	(164327, 122, '2014-01-15 01:04:48.000000', 'temperatura', 1112.0000, 'ºC'),
	(164328, 122, '2014-01-15 01:04:49.000000', 'temperatura', 252.0000, 'ºC'),
	(164329, 122, '2014-01-15 01:04:50.000000', 'temperatura', 322.0000, 'ºC'),
	(164330, 122, '2014-01-15 01:04:51.000000', 'temperatura', 854.0000, 'ºC'),
	(164331, 122, '2014-01-15 01:04:52.000000', 'temperatura', 905.0000, 'ºC'),
	(164332, 122, '2014-01-15 01:04:53.000000', 'temperatura', 762.0000, 'ºC'),
	(164333, 122, '2014-01-15 01:04:54.000000', 'temperatura', 1098.0000, 'ºC'),
	(164334, 122, '2014-01-15 01:04:55.000000', 'temperatura', 806.0000, 'ºC'),
	(164335, 122, '2014-01-15 01:04:56.000000', 'temperatura', 733.0000, 'ºC'),
	(164336, 122, '2014-01-15 01:04:57.000000', 'temperatura', 50.0000, 'ºC'),
	(164337, 122, '2014-01-15 01:04:58.000000', 'temperatura', 452.0000, 'ºC'),
	(164338, 122, '2014-01-15 01:04:59.000000', 'temperatura', 908.0000, 'ºC'),
	(164339, 122, '2014-01-15 01:05:00.000000', 'temperatura', 784.0000, 'ºC'),
	(164340, 122, '2014-01-15 01:05:01.000000', 'temperatura', 1197.0000, 'ºC'),
	(164341, 122, '2014-01-15 01:05:02.000000', 'temperatura', 34.0000, 'ºC'),
	(164342, 122, '2014-01-15 01:05:03.000000', 'temperatura', 181.0000, 'ºC'),
	(164343, 122, '2014-01-15 01:05:04.000000', 'temperatura', 804.0000, 'ºC'),
	(164344, 122, '2014-01-15 01:05:05.000000', 'temperatura', 1077.0000, 'ºC'),
	(164345, 122, '2014-01-15 01:05:06.000000', 'temperatura', 575.0000, 'ºC'),
	(164346, 122, '2014-01-15 01:05:07.000000', 'temperatura', 843.0000, 'ºC'),
	(164347, 122, '2014-01-15 01:05:08.000000', 'temperatura', 92.0000, 'ºC'),
	(164348, 122, '2014-01-15 01:05:09.000000', 'temperatura', 329.0000, 'ºC'),
	(164349, 122, '2014-01-15 01:05:10.000000', 'temperatura', 172.0000, 'ºC'),
	(164350, 122, '2014-01-15 01:05:11.000000', 'temperatura', 1073.0000, 'ºC'),
	(164351, 122, '2014-01-15 01:05:12.000000', 'temperatura', 49.0000, 'ºC'),
	(164352, 122, '2014-01-15 01:05:13.000000', 'temperatura', 627.0000, 'ºC'),
	(164353, 122, '2014-01-15 01:05:14.000000', 'temperatura', 587.0000, 'ºC'),
	(164354, 122, '2014-01-15 01:05:15.000000', 'temperatura', 1054.0000, 'ºC'),
	(164355, 122, '2014-01-15 01:05:16.000000', 'temperatura', 1112.0000, 'ºC'),
	(164356, 122, '2014-01-15 01:05:17.000000', 'temperatura', 1196.0000, 'ºC'),
	(164357, 122, '2014-01-15 01:05:18.000000', 'temperatura', 246.0000, 'ºC'),
	(164358, 122, '2014-01-15 01:05:19.000000', 'temperatura', 42.0000, 'ºC'),
	(164359, 122, '2014-01-15 01:05:20.000000', 'temperatura', 672.0000, 'ºC'),
	(164360, 122, '2014-01-15 01:05:21.000000', 'temperatura', 835.0000, 'ºC'),
	(164361, 122, '2014-01-15 01:05:22.000000', 'temperatura', 959.0000, 'ºC'),
	(164362, 122, '2014-01-15 01:05:23.000000', 'temperatura', 1089.0000, 'ºC'),
	(164363, 122, '2014-01-15 01:05:24.000000', 'temperatura', 170.0000, 'ºC'),
	(164364, 122, '2014-01-15 01:05:25.000000', 'temperatura', 1183.0000, 'ºC'),
	(164365, 122, '2014-01-15 01:05:26.000000', 'temperatura', 608.0000, 'ºC'),
	(164366, 122, '2014-01-15 01:05:27.000000', 'temperatura', 688.0000, 'ºC'),
	(164367, 122, '2014-01-15 01:05:28.000000', 'temperatura', 418.0000, 'ºC'),
	(164368, 122, '2014-01-15 01:05:29.000000', 'temperatura', 27.0000, 'ºC'),
	(164369, 122, '2014-01-15 01:05:30.000000', 'temperatura', 82.0000, 'ºC'),
	(164370, 122, '2014-01-15 01:05:31.000000', 'temperatura', 330.0000, 'ºC'),
	(164371, 122, '2014-01-15 01:05:32.000000', 'temperatura', 206.0000, 'ºC'),
	(164372, 122, '2014-01-15 01:05:33.000000', 'temperatura', 37.0000, 'ºC'),
	(164373, 122, '2014-01-15 01:05:34.000000', 'temperatura', 768.0000, 'ºC'),
	(164374, 122, '2014-01-15 01:05:35.000000', 'temperatura', 131.0000, 'ºC'),
	(164375, 122, '2014-01-15 01:05:36.000000', 'temperatura', 751.0000, 'ºC'),
	(164376, 122, '2014-01-15 01:05:37.000000', 'temperatura', 960.0000, 'ºC'),
	(164377, 122, '2014-01-15 01:05:38.000000', 'temperatura', 151.0000, 'ºC'),
	(164378, 122, '2014-01-15 01:05:39.000000', 'temperatura', 273.0000, 'ºC'),
	(164379, 122, '2014-01-15 01:05:40.000000', 'temperatura', 914.0000, 'ºC'),
	(164380, 122, '2014-01-15 01:05:41.000000', 'temperatura', 153.0000, 'ºC'),
	(164381, 122, '2014-01-15 01:05:42.000000', 'temperatura', 420.0000, 'ºC'),
	(164382, 122, '2014-01-15 01:05:43.000000', 'temperatura', 443.0000, 'ºC'),
	(164383, 122, '2014-01-15 01:05:44.000000', 'temperatura', 957.0000, 'ºC'),
	(164384, 122, '2014-01-15 01:05:45.000000', 'temperatura', 1057.0000, 'ºC'),
	(164385, 122, '2014-01-15 01:05:46.000000', 'temperatura', 13.0000, 'ºC'),
	(164386, 122, '2014-01-15 01:05:47.000000', 'temperatura', 495.0000, 'ºC'),
	(164387, 122, '2014-01-15 01:05:48.000000', 'temperatura', 37.0000, 'ºC'),
	(164388, 122, '2014-01-15 01:05:49.000000', 'temperatura', 1099.0000, 'ºC'),
	(164389, 122, '2014-01-15 01:05:50.000000', 'temperatura', 587.0000, 'ºC'),
	(164390, 122, '2014-01-15 01:05:51.000000', 'temperatura', 838.0000, 'ºC'),
	(164391, 122, '2014-01-15 01:05:52.000000', 'temperatura', 27.0000, 'ºC'),
	(164392, 122, '2014-01-15 01:05:53.000000', 'temperatura', 22.0000, 'ºC'),
	(164393, 122, '2014-01-15 01:05:54.000000', 'temperatura', 32.0000, 'ºC'),
	(164394, 122, '2014-01-15 01:05:55.000000', 'temperatura', 93.0000, 'ºC'),
	(164395, 122, '2014-01-15 01:05:56.000000', 'temperatura', 369.0000, 'ºC'),
	(164396, 122, '2014-01-15 01:05:57.000000', 'temperatura', 366.0000, 'ºC'),
	(164397, 122, '2014-01-15 01:05:58.000000', 'temperatura', 726.0000, 'ºC'),
	(164398, 122, '2014-01-15 01:05:59.000000', 'temperatura', 132.0000, 'ºC'),
	(164399, 122, '2014-01-15 01:06:00.000000', 'temperatura', 882.0000, 'ºC'),
	(164400, 122, '2014-01-15 01:06:01.000000', 'temperatura', 415.0000, 'ºC'),
	(164401, 122, '2014-01-15 01:06:02.000000', 'temperatura', 629.0000, 'ºC'),
	(164402, 122, '2014-01-15 01:06:03.000000', 'temperatura', 702.0000, 'ºC'),
	(164403, 122, '2014-01-15 01:06:04.000000', 'temperatura', 424.0000, 'ºC'),
	(164404, 122, '2014-01-15 01:06:05.000000', 'temperatura', 13.0000, 'ºC'),
	(164405, 122, '2014-01-15 01:06:06.000000', 'temperatura', 1194.0000, 'ºC'),
	(164406, 122, '2014-01-15 01:06:07.000000', 'temperatura', 1131.0000, 'ºC'),
	(164407, 122, '2014-01-15 01:06:08.000000', 'temperatura', 874.0000, 'ºC'),
	(164408, 122, '2014-01-15 01:06:09.000000', 'temperatura', 979.0000, 'ºC'),
	(164409, 122, '2014-01-15 01:06:10.000000', 'temperatura', 1074.0000, 'ºC'),
	(164410, 122, '2014-01-15 01:06:11.000000', 'temperatura', 31.0000, 'ºC'),
	(164411, 122, '2014-01-15 01:06:12.000000', 'temperatura', 532.0000, 'ºC'),
	(164412, 122, '2014-01-15 01:06:13.000000', 'temperatura', 171.0000, 'ºC'),
	(164413, 122, '2014-01-15 01:06:14.000000', 'temperatura', 457.0000, 'ºC'),
	(164414, 122, '2014-01-15 01:06:15.000000', 'temperatura', 572.0000, 'ºC'),
	(164415, 122, '2014-01-15 01:06:16.000000', 'temperatura', 289.0000, 'ºC'),
	(164416, 122, '2014-01-15 01:06:17.000000', 'temperatura', 930.0000, 'ºC'),
	(164417, 122, '2014-01-15 01:06:18.000000', 'temperatura', 184.0000, 'ºC'),
	(164418, 122, '2014-01-15 01:06:19.000000', 'temperatura', 530.0000, 'ºC'),
	(164419, 122, '2014-01-15 01:06:20.000000', 'temperatura', 897.0000, 'ºC'),
	(164420, 122, '2014-01-15 01:06:21.000000', 'temperatura', 497.0000, 'ºC'),
	(164421, 122, '2014-01-15 01:06:22.000000', 'temperatura', 993.0000, 'ºC'),
	(164422, 122, '2014-01-15 01:06:23.000000', 'temperatura', 1075.0000, 'ºC'),
	(164423, 122, '2014-01-15 01:06:24.000000', 'temperatura', 1199.0000, 'ºC'),
	(164424, 122, '2014-01-15 01:06:25.000000', 'temperatura', 368.0000, 'ºC'),
	(164425, 122, '2014-01-15 01:06:26.000000', 'temperatura', 643.0000, 'ºC'),
	(164426, 122, '2014-01-15 01:06:27.000000', 'temperatura', 912.0000, 'ºC'),
	(164427, 122, '2014-01-15 01:06:28.000000', 'temperatura', 230.0000, 'ºC'),
	(164428, 122, '2014-01-15 01:06:29.000000', 'temperatura', 815.0000, 'ºC'),
	(164429, 122, '2014-01-15 01:06:30.000000', 'temperatura', 988.0000, 'ºC'),
	(164430, 122, '2014-01-15 01:06:31.000000', 'temperatura', 93.0000, 'ºC'),
	(164431, 122, '2014-01-15 01:06:32.000000', 'temperatura', 1104.0000, 'ºC'),
	(164432, 122, '2014-01-15 01:06:33.000000', 'temperatura', 441.0000, 'ºC'),
	(164433, 122, '2014-01-15 01:06:34.000000', 'temperatura', 94.0000, 'ºC'),
	(164434, 122, '2014-01-15 01:06:35.000000', 'temperatura', 345.0000, 'ºC'),
	(164435, 122, '2014-01-15 01:06:36.000000', 'temperatura', 245.0000, 'ºC'),
	(164436, 122, '2014-01-15 01:06:37.000000', 'temperatura', 191.0000, 'ºC'),
	(164437, 122, '2014-01-15 01:06:38.000000', 'temperatura', 219.0000, 'ºC'),
	(164438, 122, '2014-01-15 01:06:39.000000', 'temperatura', 525.0000, 'ºC'),
	(164439, 122, '2014-01-15 01:06:40.000000', 'temperatura', 768.0000, 'ºC'),
	(164440, 122, '2014-01-15 01:06:41.000000', 'temperatura', 1067.0000, 'ºC'),
	(164441, 122, '2014-01-15 01:06:42.000000', 'temperatura', 628.0000, 'ºC'),
	(164442, 122, '2014-01-15 01:06:43.000000', 'temperatura', 1142.0000, 'ºC'),
	(164443, 122, '2014-01-15 01:06:44.000000', 'temperatura', 225.0000, 'ºC'),
	(164444, 122, '2014-01-15 01:06:45.000000', 'temperatura', 100.0000, 'ºC'),
	(164445, 122, '2014-01-15 01:06:46.000000', 'temperatura', 1027.0000, 'ºC'),
	(164446, 122, '2014-01-15 01:06:47.000000', 'temperatura', 34.0000, 'ºC'),
	(164447, 122, '2014-01-15 01:06:48.000000', 'temperatura', 689.0000, 'ºC'),
	(164448, 122, '2014-01-15 01:06:49.000000', 'temperatura', 944.0000, 'ºC'),
	(164449, 122, '2014-01-15 01:06:50.000000', 'temperatura', 252.0000, 'ºC'),
	(164450, 122, '2014-01-15 01:06:51.000000', 'temperatura', 831.0000, 'ºC'),
	(164451, 122, '2014-01-15 01:06:52.000000', 'temperatura', 998.0000, 'ºC'),
	(164452, 122, '2014-01-15 01:06:53.000000', 'temperatura', 98.0000, 'ºC'),
	(164453, 122, '2014-01-15 01:06:54.000000', 'temperatura', 1095.0000, 'ºC'),
	(164454, 122, '2014-01-15 01:06:55.000000', 'temperatura', 381.0000, 'ºC'),
	(164455, 122, '2014-01-15 01:06:56.000000', 'temperatura', 1020.0000, 'ºC'),
	(164456, 122, '2014-01-15 01:06:57.000000', 'temperatura', 358.0000, 'ºC'),
	(164457, 122, '2014-01-15 01:06:58.000000', 'temperatura', 1130.0000, 'ºC'),
	(164458, 122, '2014-01-15 01:06:59.000000', 'temperatura', 976.0000, 'ºC'),
	(164459, 122, '2014-01-15 01:07:00.000000', 'temperatura', 290.0000, 'ºC'),
	(164460, 122, '2014-01-15 01:07:01.000000', 'temperatura', 924.0000, 'ºC'),
	(164461, 122, '2014-01-15 01:07:02.000000', 'temperatura', 151.0000, 'ºC'),
	(164462, 122, '2014-01-15 01:07:03.000000', 'temperatura', 385.0000, 'ºC'),
	(164463, 122, '2014-01-15 01:07:04.000000', 'temperatura', 271.0000, 'ºC'),
	(164464, 122, '2014-01-15 01:07:05.000000', 'temperatura', 200.0000, 'ºC'),
	(164465, 122, '2014-01-15 01:07:06.000000', 'temperatura', 186.0000, 'ºC'),
	(164466, 122, '2014-01-15 01:07:07.000000', 'temperatura', 333.0000, 'ºC'),
	(164467, 122, '2014-01-15 01:07:08.000000', 'temperatura', 1105.0000, 'ºC'),
	(164468, 122, '2014-01-15 01:07:09.000000', 'temperatura', 926.0000, 'ºC'),
	(164469, 122, '2014-01-15 01:07:10.000000', 'temperatura', 117.0000, 'ºC'),
	(164470, 122, '2014-01-15 01:07:11.000000', 'temperatura', 206.0000, 'ºC'),
	(164471, 122, '2014-01-15 01:07:12.000000', 'temperatura', 679.0000, 'ºC'),
	(164472, 122, '2014-01-15 01:07:13.000000', 'temperatura', 378.0000, 'ºC'),
	(164473, 122, '2014-01-15 01:07:14.000000', 'temperatura', 1054.0000, 'ºC'),
	(164474, 122, '2014-01-15 01:07:15.000000', 'temperatura', 537.0000, 'ºC'),
	(164475, 122, '2014-01-15 01:07:16.000000', 'temperatura', 721.0000, 'ºC'),
	(164476, 122, '2014-01-15 01:07:17.000000', 'temperatura', 797.0000, 'ºC'),
	(164477, 122, '2014-01-15 01:07:18.000000', 'temperatura', 623.0000, 'ºC'),
	(164478, 122, '2014-01-15 01:07:19.000000', 'temperatura', 722.0000, 'ºC'),
	(164479, 122, '2014-01-15 01:07:20.000000', 'temperatura', 542.0000, 'ºC'),
	(164480, 122, '2014-01-15 01:07:21.000000', 'temperatura', 545.0000, 'ºC'),
	(164481, 122, '2014-01-15 01:07:22.000000', 'temperatura', 1098.0000, 'ºC'),
	(164482, 122, '2014-01-15 01:07:23.000000', 'temperatura', 257.0000, 'ºC'),
	(164483, 122, '2014-01-15 01:07:24.000000', 'temperatura', 391.0000, 'ºC'),
	(164484, 122, '2014-01-15 01:07:25.000000', 'temperatura', 1185.0000, 'ºC'),
	(164485, 122, '2014-01-15 01:07:26.000000', 'temperatura', 1153.0000, 'ºC'),
	(164486, 122, '2014-01-15 01:07:27.000000', 'temperatura', 1012.0000, 'ºC'),
	(164487, 122, '2014-01-15 01:07:28.000000', 'temperatura', 400.0000, 'ºC'),
	(164488, 122, '2014-01-15 01:07:29.000000', 'temperatura', 165.0000, 'ºC'),
	(164489, 122, '2014-01-15 01:07:30.000000', 'temperatura', 824.0000, 'ºC'),
	(164490, 122, '2014-01-15 01:07:31.000000', 'temperatura', 25.0000, 'ºC'),
	(164491, 122, '2014-01-15 01:07:32.000000', 'temperatura', 55.0000, 'ºC'),
	(164492, 122, '2014-01-15 01:07:33.000000', 'temperatura', 202.0000, 'ºC'),
	(164493, 122, '2014-01-15 01:07:34.000000', 'temperatura', 845.0000, 'ºC'),
	(164494, 122, '2014-01-15 01:07:35.000000', 'temperatura', 18.0000, 'ºC'),
	(164495, 122, '2014-01-15 01:07:36.000000', 'temperatura', 1158.0000, 'ºC'),
	(164496, 122, '2014-01-15 01:07:37.000000', 'temperatura', 933.0000, 'ºC'),
	(164497, 122, '2014-01-15 01:07:38.000000', 'temperatura', 1194.0000, 'ºC'),
	(164498, 122, '2014-01-15 01:07:39.000000', 'temperatura', 771.0000, 'ºC'),
	(164499, 122, '2014-01-15 01:07:40.000000', 'temperatura', 273.0000, 'ºC'),
	(164500, 122, '2014-01-15 01:07:41.000000', 'temperatura', 251.0000, 'ºC'),
	(164501, 122, '2014-01-15 01:07:42.000000', 'temperatura', 440.0000, 'ºC'),
	(164502, 122, '2014-01-15 01:07:43.000000', 'temperatura', 244.0000, 'ºC'),
	(164503, 122, '2014-01-15 01:07:44.000000', 'temperatura', 1101.0000, 'ºC'),
	(164504, 122, '2014-01-15 01:07:45.000000', 'temperatura', 1175.0000, 'ºC'),
	(164505, 122, '2014-01-15 01:07:46.000000', 'temperatura', 174.0000, 'ºC'),
	(164506, 122, '2014-01-15 01:07:47.000000', 'temperatura', 943.0000, 'ºC'),
	(164507, 122, '2014-01-15 01:07:48.000000', 'temperatura', 593.0000, 'ºC'),
	(164508, 122, '2014-01-15 01:07:49.000000', 'temperatura', 136.0000, 'ºC'),
	(164509, 122, '2014-01-15 01:07:50.000000', 'temperatura', 103.0000, 'ºC'),
	(164510, 122, '2014-01-15 01:07:51.000000', 'temperatura', 109.0000, 'ºC'),
	(164511, 122, '2014-01-15 01:07:52.000000', 'temperatura', 235.0000, 'ºC'),
	(164512, 122, '2014-01-15 01:07:53.000000', 'temperatura', 847.0000, 'ºC'),
	(164513, 122, '2014-01-15 01:07:54.000000', 'temperatura', 1130.0000, 'ºC'),
	(164514, 122, '2014-01-15 01:07:55.000000', 'temperatura', 710.0000, 'ºC'),
	(164515, 122, '2014-01-15 01:07:56.000000', 'temperatura', 160.0000, 'ºC'),
	(164516, 122, '2014-01-15 01:07:57.000000', 'temperatura', 1072.0000, 'ºC'),
	(164517, 122, '2014-01-15 01:07:58.000000', 'temperatura', 80.0000, 'ºC'),
	(164518, 122, '2014-01-15 01:07:59.000000', 'temperatura', 782.0000, 'ºC'),
	(164519, 122, '2014-01-15 01:08:00.000000', 'temperatura', 74.0000, 'ºC'),
	(164520, 122, '2014-01-15 01:08:01.000000', 'temperatura', 421.0000, 'ºC'),
	(164521, 122, '2014-01-15 01:08:02.000000', 'temperatura', 686.0000, 'ºC'),
	(164522, 122, '2014-01-15 01:08:03.000000', 'temperatura', 967.0000, 'ºC'),
	(164523, 122, '2014-01-15 01:08:04.000000', 'temperatura', 378.0000, 'ºC'),
	(164524, 122, '2014-01-15 01:08:05.000000', 'temperatura', 191.0000, 'ºC'),
	(164525, 122, '2014-01-15 01:08:06.000000', 'temperatura', 1019.0000, 'ºC'),
	(164526, 122, '2014-01-15 01:08:07.000000', 'temperatura', 924.0000, 'ºC'),
	(164527, 122, '2014-01-15 01:08:08.000000', 'temperatura', 362.0000, 'ºC'),
	(164528, 122, '2014-01-15 01:08:09.000000', 'temperatura', 239.0000, 'ºC'),
	(164529, 122, '2014-01-15 01:08:10.000000', 'temperatura', 112.0000, 'ºC'),
	(164530, 122, '2014-01-15 01:08:11.000000', 'temperatura', 1040.0000, 'ºC'),
	(164531, 122, '2014-01-15 01:08:12.000000', 'temperatura', 66.0000, 'ºC'),
	(164532, 122, '2014-01-15 01:08:13.000000', 'temperatura', 812.0000, 'ºC'),
	(164533, 122, '2014-01-15 01:08:14.000000', 'temperatura', 261.0000, 'ºC'),
	(164534, 122, '2014-01-15 01:08:15.000000', 'temperatura', 70.0000, 'ºC'),
	(164535, 122, '2014-01-15 01:08:16.000000', 'temperatura', 768.0000, 'ºC'),
	(164536, 122, '2014-01-15 01:08:17.000000', 'temperatura', 29.0000, 'ºC'),
	(164537, 122, '2014-01-15 01:08:18.000000', 'temperatura', 244.0000, 'ºC'),
	(164538, 122, '2014-01-15 01:08:19.000000', 'temperatura', 1131.0000, 'ºC'),
	(164539, 122, '2014-01-15 01:08:20.000000', 'temperatura', 125.0000, 'ºC'),
	(164540, 122, '2014-01-15 01:08:21.000000', 'temperatura', 831.0000, 'ºC'),
	(164541, 122, '2014-01-15 01:08:22.000000', 'temperatura', 181.0000, 'ºC'),
	(164542, 122, '2014-01-15 01:08:23.000000', 'temperatura', 814.0000, 'ºC'),
	(164543, 122, '2014-01-15 01:08:24.000000', 'temperatura', 1128.0000, 'ºC'),
	(164544, 122, '2014-01-15 01:08:25.000000', 'temperatura', 798.0000, 'ºC'),
	(164545, 122, '2014-01-15 01:08:26.000000', 'temperatura', 606.0000, 'ºC'),
	(164546, 122, '2014-01-15 01:08:27.000000', 'temperatura', 637.0000, 'ºC'),
	(164547, 122, '2014-01-15 01:08:28.000000', 'temperatura', 168.0000, 'ºC'),
	(164548, 122, '2014-01-15 01:08:29.000000', 'temperatura', 128.0000, 'ºC'),
	(164549, 122, '2014-01-15 01:08:30.000000', 'temperatura', 138.0000, 'ºC'),
	(164550, 122, '2014-01-15 01:08:31.000000', 'temperatura', 306.0000, 'ºC'),
	(164551, 122, '2014-01-15 01:08:32.000000', 'temperatura', 1117.0000, 'ºC'),
	(164552, 122, '2014-01-15 01:08:33.000000', 'temperatura', 1065.0000, 'ºC'),
	(164553, 122, '2014-01-15 01:08:34.000000', 'temperatura', 778.0000, 'ºC'),
	(164554, 122, '2014-01-15 01:08:35.000000', 'temperatura', 692.0000, 'ºC'),
	(164555, 122, '2014-01-15 01:08:36.000000', 'temperatura', 1129.0000, 'ºC'),
	(164556, 122, '2014-01-15 01:08:37.000000', 'temperatura', 1170.0000, 'ºC'),
	(164557, 122, '2014-01-15 01:08:38.000000', 'temperatura', 64.0000, 'ºC'),
	(164558, 122, '2014-01-15 01:08:39.000000', 'temperatura', 411.0000, 'ºC'),
	(164559, 122, '2014-01-15 01:08:40.000000', 'temperatura', 662.0000, 'ºC'),
	(164560, 122, '2014-01-15 01:08:41.000000', 'temperatura', 876.0000, 'ºC'),
	(164561, 122, '2014-01-15 01:08:42.000000', 'temperatura', 1197.0000, 'ºC'),
	(164562, 122, '2014-01-15 01:08:43.000000', 'temperatura', 957.0000, 'ºC'),
	(164563, 122, '2014-01-15 01:08:44.000000', 'temperatura', 1195.0000, 'ºC'),
	(164564, 122, '2014-01-15 01:08:45.000000', 'temperatura', 702.0000, 'ºC'),
	(164565, 122, '2014-01-15 01:08:46.000000', 'temperatura', 1127.0000, 'ºC'),
	(164566, 122, '2014-01-15 01:08:47.000000', 'temperatura', 1130.0000, 'ºC'),
	(164567, 122, '2014-01-15 01:08:48.000000', 'temperatura', 1070.0000, 'ºC'),
	(164568, 122, '2014-01-15 01:08:49.000000', 'temperatura', 760.0000, 'ºC'),
	(164569, 122, '2014-01-15 01:08:50.000000', 'temperatura', 589.0000, 'ºC'),
	(164570, 122, '2014-01-15 01:08:51.000000', 'temperatura', 668.0000, 'ºC'),
	(164571, 122, '2014-01-15 01:08:52.000000', 'temperatura', 371.0000, 'ºC'),
	(164572, 122, '2014-01-15 01:08:53.000000', 'temperatura', 1051.0000, 'ºC'),
	(164573, 122, '2014-01-15 01:08:54.000000', 'temperatura', 542.0000, 'ºC'),
	(164574, 122, '2014-01-15 01:08:55.000000', 'temperatura', 758.0000, 'ºC'),
	(164575, 122, '2014-01-15 01:08:56.000000', 'temperatura', 965.0000, 'ºC'),
	(164576, 122, '2014-01-15 01:08:57.000000', 'temperatura', 153.0000, 'ºC'),
	(164577, 122, '2014-01-15 01:08:58.000000', 'temperatura', 268.0000, 'ºC'),
	(164578, 122, '2014-01-15 01:08:59.000000', 'temperatura', 881.0000, 'ºC'),
	(164579, 122, '2014-01-15 01:09:00.000000', 'temperatura', 4.0000, 'ºC'),
	(164580, 122, '2014-01-15 01:09:01.000000', 'temperatura', 975.0000, 'ºC'),
	(164581, 122, '2014-01-15 01:09:02.000000', 'temperatura', 66.0000, 'ºC'),
	(164582, 122, '2014-01-15 01:09:03.000000', 'temperatura', 1006.0000, 'ºC'),
	(164583, 122, '2014-01-15 01:09:04.000000', 'temperatura', 30.0000, 'ºC'),
	(164584, 122, '2014-01-15 01:09:05.000000', 'temperatura', 732.0000, 'ºC'),
	(164585, 122, '2014-01-15 01:09:06.000000', 'temperatura', 1172.0000, 'ºC'),
	(164586, 122, '2014-01-15 01:09:07.000000', 'temperatura', 64.0000, 'ºC'),
	(164587, 122, '2014-01-15 01:09:08.000000', 'temperatura', 404.0000, 'ºC'),
	(164588, 122, '2014-01-15 01:09:09.000000', 'temperatura', 631.0000, 'ºC'),
	(164589, 122, '2014-01-15 01:09:10.000000', 'temperatura', 741.0000, 'ºC'),
	(164590, 122, '2014-01-15 01:09:11.000000', 'temperatura', 612.0000, 'ºC'),
	(164591, 122, '2014-01-15 01:09:12.000000', 'temperatura', 838.0000, 'ºC'),
	(164592, 122, '2014-01-15 01:09:13.000000', 'temperatura', 1156.0000, 'ºC'),
	(164593, 122, '2014-01-15 01:09:14.000000', 'temperatura', 867.0000, 'ºC'),
	(164594, 122, '2014-01-15 01:09:15.000000', 'temperatura', 868.0000, 'ºC'),
	(164595, 122, '2014-01-15 01:09:16.000000', 'temperatura', 537.0000, 'ºC'),
	(164596, 122, '2014-01-15 01:09:17.000000', 'temperatura', 83.0000, 'ºC'),
	(164597, 122, '2014-01-15 01:09:18.000000', 'temperatura', 5.0000, 'ºC'),
	(164598, 122, '2014-01-15 01:09:19.000000', 'temperatura', 974.0000, 'ºC'),
	(164599, 122, '2014-01-15 01:09:20.000000', 'temperatura', 56.0000, 'ºC'),
	(164600, 122, '2014-01-15 01:09:21.000000', 'temperatura', 961.0000, 'ºC'),
	(164601, 122, '2014-01-15 01:09:22.000000', 'temperatura', 1034.0000, 'ºC'),
	(164602, 122, '2014-01-15 01:09:23.000000', 'temperatura', 1090.0000, 'ºC'),
	(164603, 122, '2014-01-15 01:09:24.000000', 'temperatura', 1148.0000, 'ºC'),
	(164604, 122, '2014-01-15 01:09:25.000000', 'temperatura', 71.0000, 'ºC'),
	(164605, 122, '2014-01-15 01:09:26.000000', 'temperatura', 510.0000, 'ºC'),
	(164606, 122, '2014-01-15 01:09:27.000000', 'temperatura', 1137.0000, 'ºC'),
	(164607, 122, '2014-01-15 01:09:28.000000', 'temperatura', 556.0000, 'ºC'),
	(164608, 122, '2014-01-15 01:09:29.000000', 'temperatura', 571.0000, 'ºC'),
	(164609, 122, '2014-01-15 01:09:30.000000', 'temperatura', 1186.0000, 'ºC'),
	(164610, 122, '2014-01-15 01:09:31.000000', 'temperatura', 619.0000, 'ºC'),
	(164611, 122, '2014-01-15 01:09:32.000000', 'temperatura', 735.0000, 'ºC'),
	(164612, 122, '2014-01-15 01:09:33.000000', 'temperatura', 621.0000, 'ºC'),
	(164613, 122, '2014-01-15 01:09:34.000000', 'temperatura', 900.0000, 'ºC'),
	(164614, 122, '2014-01-15 01:09:35.000000', 'temperatura', 237.0000, 'ºC'),
	(164615, 122, '2014-01-15 01:09:36.000000', 'temperatura', 886.0000, 'ºC'),
	(164616, 122, '2014-01-15 01:09:37.000000', 'temperatura', 118.0000, 'ºC'),
	(164617, 122, '2014-01-15 01:09:38.000000', 'temperatura', 333.0000, 'ºC'),
	(164618, 122, '2014-01-15 01:09:39.000000', 'temperatura', 113.0000, 'ºC'),
	(164619, 122, '2014-01-15 01:09:40.000000', 'temperatura', 767.0000, 'ºC'),
	(164620, 122, '2014-01-15 01:09:41.000000', 'temperatura', 1097.0000, 'ºC'),
	(164621, 122, '2014-01-15 01:09:42.000000', 'temperatura', 784.0000, 'ºC'),
	(164622, 122, '2014-01-15 01:09:43.000000', 'temperatura', 631.0000, 'ºC'),
	(164623, 122, '2014-01-15 01:09:44.000000', 'temperatura', 801.0000, 'ºC'),
	(164624, 122, '2014-01-15 01:09:45.000000', 'temperatura', 914.0000, 'ºC'),
	(164625, 122, '2014-01-15 01:09:46.000000', 'temperatura', 969.0000, 'ºC'),
	(164626, 122, '2014-01-15 01:09:47.000000', 'temperatura', 903.0000, 'ºC'),
	(164627, 122, '2014-01-15 01:09:48.000000', 'temperatura', 406.0000, 'ºC'),
	(164628, 122, '2014-01-15 01:09:49.000000', 'temperatura', 522.0000, 'ºC'),
	(164629, 122, '2014-01-15 01:09:50.000000', 'temperatura', 192.0000, 'ºC'),
	(164630, 122, '2014-01-15 01:09:51.000000', 'temperatura', 596.0000, 'ºC'),
	(164631, 122, '2014-01-15 01:09:52.000000', 'temperatura', 4.0000, 'ºC'),
	(164632, 122, '2014-01-15 01:09:53.000000', 'temperatura', 632.0000, 'ºC'),
	(164633, 122, '2014-01-15 01:09:54.000000', 'temperatura', 748.0000, 'ºC'),
	(164634, 122, '2014-01-15 01:09:55.000000', 'temperatura', 643.0000, 'ºC'),
	(164635, 122, '2014-01-15 01:09:56.000000', 'temperatura', 975.0000, 'ºC'),
	(164636, 122, '2014-01-15 01:09:57.000000', 'temperatura', 545.0000, 'ºC'),
	(164637, 122, '2014-01-15 01:09:58.000000', 'temperatura', 999.0000, 'ºC'),
	(164638, 122, '2014-01-15 01:09:59.000000', 'temperatura', 962.0000, 'ºC'),
	(164639, 122, '2014-01-15 01:10:00.000000', 'temperatura', 614.0000, 'ºC'),
	(164640, 122, '2014-01-15 01:10:01.000000', 'temperatura', 183.0000, 'ºC'),
	(164641, 122, '2014-01-15 01:10:02.000000', 'temperatura', 276.0000, 'ºC'),
	(164642, 122, '2014-01-15 01:10:03.000000', 'temperatura', 831.0000, 'ºC'),
	(164643, 122, '2014-01-15 01:10:04.000000', 'temperatura', 926.0000, 'ºC'),
	(164644, 122, '2014-01-15 01:10:05.000000', 'temperatura', 936.0000, 'ºC'),
	(164645, 122, '2014-01-15 01:10:06.000000', 'temperatura', 706.0000, 'ºC'),
	(164646, 122, '2014-01-15 01:10:07.000000', 'temperatura', 719.0000, 'ºC'),
	(164647, 122, '2014-01-15 01:10:08.000000', 'temperatura', 279.0000, 'ºC'),
	(164648, 122, '2014-01-15 01:10:09.000000', 'temperatura', 440.0000, 'ºC'),
	(164649, 122, '2014-01-15 01:10:10.000000', 'temperatura', 160.0000, 'ºC'),
	(164650, 122, '2014-01-15 01:10:11.000000', 'temperatura', 684.0000, 'ºC'),
	(164651, 122, '2014-01-15 01:10:12.000000', 'temperatura', 537.0000, 'ºC'),
	(164652, 122, '2014-01-15 01:10:13.000000', 'temperatura', 636.0000, 'ºC'),
	(164653, 122, '2014-01-15 01:10:14.000000', 'temperatura', 370.0000, 'ºC'),
	(164654, 122, '2014-01-15 01:10:15.000000', 'temperatura', 1144.0000, 'ºC'),
	(164655, 122, '2014-01-15 01:10:16.000000', 'temperatura', 1008.0000, 'ºC'),
	(164656, 122, '2014-01-15 01:10:17.000000', 'temperatura', 407.0000, 'ºC'),
	(164657, 122, '2014-01-15 01:10:18.000000', 'temperatura', 215.0000, 'ºC'),
	(164658, 122, '2014-01-15 01:10:19.000000', 'temperatura', 1052.0000, 'ºC'),
	(164659, 122, '2014-01-15 01:10:20.000000', 'temperatura', 1018.0000, 'ºC'),
	(164660, 122, '2014-01-15 01:10:21.000000', 'temperatura', 734.0000, 'ºC'),
	(164661, 122, '2014-01-15 01:10:22.000000', 'temperatura', 617.0000, 'ºC'),
	(164662, 122, '2014-01-15 01:10:23.000000', 'temperatura', 883.0000, 'ºC'),
	(164663, 122, '2014-01-15 01:10:24.000000', 'temperatura', 166.0000, 'ºC'),
	(164664, 122, '2014-01-15 01:10:25.000000', 'temperatura', 582.0000, 'ºC'),
	(164665, 122, '2014-01-15 01:10:26.000000', 'temperatura', 11.0000, 'ºC'),
	(164666, 122, '2014-01-15 01:10:27.000000', 'temperatura', 711.0000, 'ºC'),
	(164667, 122, '2014-01-15 01:10:28.000000', 'temperatura', 1120.0000, 'ºC'),
	(164668, 122, '2014-01-15 01:10:29.000000', 'temperatura', 1067.0000, 'ºC'),
	(164669, 122, '2014-01-15 01:10:30.000000', 'temperatura', 775.0000, 'ºC'),
	(164670, 122, '2014-01-15 01:10:31.000000', 'temperatura', 675.0000, 'ºC'),
	(164671, 122, '2014-01-15 01:10:32.000000', 'temperatura', 1052.0000, 'ºC'),
	(164672, 122, '2014-01-15 01:10:33.000000', 'temperatura', 835.0000, 'ºC'),
	(164673, 122, '2014-01-15 01:10:34.000000', 'temperatura', 1017.0000, 'ºC'),
	(164674, 122, '2014-01-15 01:10:35.000000', 'temperatura', 184.0000, 'ºC'),
	(164675, 122, '2014-01-15 01:10:36.000000', 'temperatura', 269.0000, 'ºC'),
	(164676, 122, '2014-01-15 01:10:37.000000', 'temperatura', 792.0000, 'ºC'),
	(164677, 122, '2014-01-15 01:10:38.000000', 'temperatura', 755.0000, 'ºC'),
	(164678, 122, '2014-01-15 01:10:39.000000', 'temperatura', 199.0000, 'ºC'),
	(164679, 122, '2014-01-15 01:10:40.000000', 'temperatura', 1130.0000, 'ºC'),
	(164680, 122, '2014-01-15 01:10:41.000000', 'temperatura', 252.0000, 'ºC'),
	(164681, 122, '2014-01-15 01:10:42.000000', 'temperatura', 271.0000, 'ºC'),
	(164682, 122, '2014-01-15 01:10:43.000000', 'temperatura', 598.0000, 'ºC'),
	(164683, 122, '2014-01-15 01:10:44.000000', 'temperatura', 981.0000, 'ºC'),
	(164684, 122, '2014-01-15 01:10:45.000000', 'temperatura', 709.0000, 'ºC'),
	(164685, 122, '2014-01-15 01:10:46.000000', 'temperatura', 603.0000, 'ºC'),
	(164686, 122, '2014-01-15 01:10:47.000000', 'temperatura', 890.0000, 'ºC'),
	(164687, 122, '2014-01-15 01:10:48.000000', 'temperatura', 241.0000, 'ºC'),
	(164688, 122, '2014-01-15 01:10:49.000000', 'temperatura', 935.0000, 'ºC'),
	(164689, 122, '2014-01-15 01:10:50.000000', 'temperatura', 353.0000, 'ºC'),
	(164690, 122, '2014-01-15 01:10:51.000000', 'temperatura', 162.0000, 'ºC'),
	(164691, 122, '2014-01-15 01:10:52.000000', 'temperatura', 952.0000, 'ºC'),
	(164692, 122, '2014-01-15 01:10:53.000000', 'temperatura', 673.0000, 'ºC'),
	(164693, 122, '2014-01-15 01:10:54.000000', 'temperatura', 508.0000, 'ºC'),
	(164694, 122, '2014-01-15 01:10:55.000000', 'temperatura', 523.0000, 'ºC'),
	(164695, 122, '2014-01-15 01:10:56.000000', 'temperatura', 1090.0000, 'ºC'),
	(164696, 122, '2014-01-15 01:10:57.000000', 'temperatura', 281.0000, 'ºC'),
	(164697, 122, '2014-01-15 01:10:58.000000', 'temperatura', 535.0000, 'ºC'),
	(164698, 122, '2014-01-15 01:10:59.000000', 'temperatura', 634.0000, 'ºC'),
	(164699, 122, '2014-01-15 01:11:00.000000', 'temperatura', 367.0000, 'ºC'),
	(164700, 122, '2014-01-15 01:11:01.000000', 'temperatura', 1133.0000, 'ºC'),
	(164701, 122, '2014-01-15 01:11:02.000000', 'temperatura', 966.0000, 'ºC'),
	(164702, 122, '2014-01-15 01:11:03.000000', 'temperatura', 230.0000, 'ºC'),
	(164703, 122, '2014-01-15 01:11:04.000000', 'temperatura', 654.0000, 'ºC'),
	(164704, 122, '2014-01-15 01:11:05.000000', 'temperatura', 178.0000, 'ºC'),
	(164705, 122, '2014-01-15 01:11:06.000000', 'temperatura', 131.0000, 'ºC'),
	(164706, 122, '2014-01-15 01:11:07.000000', 'temperatura', 119.0000, 'ºC'),
	(164707, 122, '2014-01-15 01:11:08.000000', 'temperatura', 204.0000, 'ºC'),
	(164708, 122, '2014-01-15 01:11:09.000000', 'temperatura', 661.0000, 'ºC'),
	(164709, 122, '2014-01-15 01:11:10.000000', 'temperatura', 295.0000, 'ºC'),
	(164710, 118, '2014-02-01 00:00:00.000000', 'temperatura', 185.0000, 'ºC'),
	(164711, 118, '2014-02-01 00:00:01.000000', 'temperatura', 45.0000, 'ºC'),
	(164712, 118, '2014-02-01 00:00:02.000000', 'temperatura', 868.0000, 'ºC'),
	(164713, 118, '2014-02-01 00:00:03.000000', 'temperatura', 606.0000, 'ºC'),
	(164714, 118, '2014-02-01 00:00:04.000000', 'temperatura', 429.0000, 'ºC'),
	(164715, 118, '2014-02-01 00:00:05.000000', 'temperatura', 325.0000, 'ºC'),
	(164716, 118, '2014-02-01 00:00:06.000000', 'temperatura', 338.0000, 'ºC'),
	(164717, 118, '2014-02-01 00:00:07.000000', 'temperatura', 715.0000, 'ºC'),
	(164718, 118, '2014-02-01 00:00:08.000000', 'temperatura', 163.0000, 'ºC'),
	(164719, 118, '2014-02-01 00:00:09.000000', 'temperatura', 1069.0000, 'ºC'),
	(164720, 118, '2014-02-01 00:00:10.000000', 'temperatura', 55.0000, 'ºC'),
	(164721, 118, '2014-02-01 00:00:11.000000', 'temperatura', 672.0000, 'ºC'),
	(164722, 118, '2014-02-01 00:00:12.000000', 'temperatura', 792.0000, 'ºC'),
	(164723, 118, '2014-02-01 00:00:13.000000', 'temperatura', 748.0000, 'ºC'),
	(164724, 118, '2014-02-01 00:00:14.000000', 'temperatura', 163.0000, 'ºC'),
	(164725, 118, '2014-02-01 00:00:15.000000', 'temperatura', 973.0000, 'ºC'),
	(164726, 118, '2014-02-01 00:00:16.000000', 'temperatura', 774.0000, 'ºC'),
	(164727, 118, '2014-02-01 00:00:17.000000', 'temperatura', 952.0000, 'ºC'),
	(164728, 118, '2014-02-01 00:00:18.000000', 'temperatura', 38.0000, 'ºC'),
	(164729, 118, '2014-02-01 00:00:19.000000', 'temperatura', 934.0000, 'ºC'),
	(164730, 118, '2014-02-01 00:00:20.000000', 'temperatura', 956.0000, 'ºC'),
	(164731, 118, '2014-02-01 00:00:21.000000', 'temperatura', 781.0000, 'ºC'),
	(164732, 118, '2014-02-01 00:00:22.000000', 'temperatura', 1037.0000, 'ºC'),
	(164733, 118, '2014-02-01 00:00:23.000000', 'temperatura', 441.0000, 'ºC'),
	(164734, 118, '2014-02-01 00:00:24.000000', 'temperatura', 295.0000, 'ºC'),
	(164735, 118, '2014-02-01 00:00:25.000000', 'temperatura', 153.0000, 'ºC'),
	(164736, 118, '2014-02-01 00:00:26.000000', 'temperatura', 1080.0000, 'ºC'),
	(164737, 118, '2014-02-01 00:00:27.000000', 'temperatura', 143.0000, 'ºC'),
	(164738, 118, '2014-02-01 00:00:28.000000', 'temperatura', 1076.0000, 'ºC'),
	(164739, 118, '2014-02-01 00:00:29.000000', 'temperatura', 152.0000, 'ºC'),
	(164740, 118, '2014-02-01 00:00:30.000000', 'temperatura', 1129.0000, 'ºC'),
	(164741, 118, '2014-02-01 00:00:31.000000', 'temperatura', 393.0000, 'ºC'),
	(164742, 118, '2014-02-01 00:00:32.000000', 'temperatura', 977.0000, 'ºC'),
	(164743, 118, '2014-02-01 00:00:33.000000', 'temperatura', 108.0000, 'ºC'),
	(164744, 118, '2014-02-01 00:00:34.000000', 'temperatura', 8.0000, 'ºC'),
	(164745, 118, '2014-02-01 00:00:35.000000', 'temperatura', 915.0000, 'ºC'),
	(164746, 118, '2014-02-01 00:00:36.000000', 'temperatura', 954.0000, 'ºC'),
	(164747, 118, '2014-02-01 00:00:37.000000', 'temperatura', 823.0000, 'ºC'),
	(164748, 118, '2014-02-01 00:00:38.000000', 'temperatura', 55.0000, 'ºC'),
	(164749, 118, '2014-02-01 00:00:39.000000', 'temperatura', 206.0000, 'ºC'),
	(164750, 118, '2014-02-01 00:00:40.000000', 'temperatura', 867.0000, 'ºC'),
	(164751, 118, '2014-02-01 00:00:41.000000', 'temperatura', 118.0000, 'ºC'),
	(164752, 118, '2014-02-01 00:00:42.000000', 'temperatura', 387.0000, 'ºC'),
	(164753, 118, '2014-02-01 00:00:43.000000', 'temperatura', 384.0000, 'ºC'),
	(164754, 118, '2014-02-01 00:00:44.000000', 'temperatura', 759.0000, 'ºC'),
	(164755, 118, '2014-02-01 00:00:45.000000', 'temperatura', 245.0000, 'ºC'),
	(164756, 118, '2014-02-01 00:00:46.000000', 'temperatura', 146.0000, 'ºC'),
	(164757, 118, '2014-02-01 00:00:47.000000', 'temperatura', 1195.0000, 'ºC'),
	(164758, 118, '2014-02-01 00:00:48.000000', 'temperatura', 740.0000, 'ºC'),
	(164759, 118, '2014-02-01 00:00:49.000000', 'temperatura', 113.0000, 'ºC'),
	(164760, 118, '2014-02-01 00:00:50.000000', 'temperatura', 745.0000, 'ºC'),
	(164761, 118, '2014-02-01 00:00:51.000000', 'temperatura', 988.0000, 'ºC'),
	(164762, 118, '2014-02-01 00:00:52.000000', 'temperatura', 304.0000, 'ºC'),
	(164763, 118, '2014-02-01 00:00:53.000000', 'temperatura', 959.0000, 'ºC'),
	(164764, 118, '2014-02-01 00:00:54.000000', 'temperatura', 283.0000, 'ºC'),
	(164765, 118, '2014-02-01 00:00:55.000000', 'temperatura', 937.0000, 'ºC'),
	(164766, 118, '2014-02-01 00:00:56.000000', 'temperatura', 235.0000, 'ºC'),
	(164767, 118, '2014-02-01 00:00:57.000000', 'temperatura', 768.0000, 'ºC'),
	(164768, 118, '2014-02-01 00:00:58.000000', 'temperatura', 732.0000, 'ºC'),
	(164769, 118, '2014-02-01 00:00:59.000000', 'temperatura', 160.0000, 'ºC'),
	(164770, 118, '2014-02-01 00:01:00.000000', 'temperatura', 1002.0000, 'ºC'),
	(164771, 118, '2014-02-01 00:01:01.000000', 'temperatura', 932.0000, 'ºC'),
	(164772, 118, '2014-02-01 00:01:02.000000', 'temperatura', 452.0000, 'ºC'),
	(164773, 118, '2014-02-01 00:01:03.000000', 'temperatura', 667.0000, 'ºC'),
	(164774, 118, '2014-02-01 00:01:04.000000', 'temperatura', 781.0000, 'ºC'),
	(164775, 118, '2014-02-01 00:01:05.000000', 'temperatura', 702.0000, 'ºC'),
	(164776, 118, '2014-02-01 00:01:06.000000', 'temperatura', 1169.0000, 'ºC'),
	(164777, 118, '2014-02-01 00:01:07.000000', 'temperatura', 140.0000, 'ºC'),
	(164778, 118, '2014-02-01 00:01:08.000000', 'temperatura', 793.0000, 'ºC'),
	(164779, 118, '2014-02-01 00:01:09.000000', 'temperatura', 1144.0000, 'ºC'),
	(164780, 118, '2014-02-01 00:01:10.000000', 'temperatura', 944.0000, 'ºC'),
	(164781, 118, '2014-02-01 00:01:11.000000', 'temperatura', 89.0000, 'ºC'),
	(164782, 118, '2014-02-01 00:01:12.000000', 'temperatura', 14.0000, 'ºC'),
	(164783, 118, '2014-02-01 00:01:13.000000', 'temperatura', 1004.0000, 'ºC'),
	(164784, 118, '2014-02-01 00:01:14.000000', 'temperatura', 179.0000, 'ºC'),
	(164785, 118, '2014-02-01 00:01:15.000000', 'temperatura', 281.0000, 'ºC'),
	(164786, 118, '2014-02-01 00:01:16.000000', 'temperatura', 869.0000, 'ºC'),
	(164787, 118, '2014-02-01 00:01:17.000000', 'temperatura', 1101.0000, 'ºC'),
	(164788, 118, '2014-02-01 00:01:18.000000', 'temperatura', 499.0000, 'ºC'),
	(164789, 118, '2014-02-01 00:01:19.000000', 'temperatura', 394.0000, 'ºC'),
	(164790, 118, '2014-02-01 00:01:20.000000', 'temperatura', 473.0000, 'ºC'),
	(164791, 118, '2014-02-01 00:01:21.000000', 'temperatura', 1183.0000, 'ºC'),
	(164792, 118, '2014-02-01 00:01:22.000000', 'temperatura', 898.0000, 'ºC'),
	(164793, 118, '2014-02-01 00:01:23.000000', 'temperatura', 941.0000, 'ºC'),
	(164794, 118, '2014-02-01 00:01:24.000000', 'temperatura', 813.0000, 'ºC'),
	(164795, 118, '2014-02-01 00:01:25.000000', 'temperatura', 41.0000, 'ºC'),
	(164796, 118, '2014-02-01 00:01:26.000000', 'temperatura', 167.0000, 'ºC'),
	(164797, 118, '2014-02-01 00:01:27.000000', 'temperatura', 712.0000, 'ºC'),
	(164798, 118, '2014-02-01 00:01:28.000000', 'temperatura', 662.0000, 'ºC'),
	(164799, 118, '2014-02-01 00:01:29.000000', 'temperatura', 1172.0000, 'ºC'),
	(164800, 118, '2014-02-01 00:01:30.000000', 'temperatura', 275.0000, 'ºC'),
	(164801, 118, '2014-02-01 00:01:31.000000', 'temperatura', 260.0000, 'ºC'),
	(164802, 118, '2014-02-01 00:01:32.000000', 'temperatura', 474.0000, 'ºC'),
	(164803, 118, '2014-02-01 00:01:33.000000', 'temperatura', 391.0000, 'ºC'),
	(164804, 118, '2014-02-01 00:01:34.000000', 'temperatura', 535.0000, 'ºC'),
	(164805, 118, '2014-02-01 00:01:35.000000', 'temperatura', 302.0000, 'ºC'),
	(164806, 118, '2014-02-01 00:01:36.000000', 'temperatura', 1106.0000, 'ºC'),
	(164807, 118, '2014-02-01 00:01:37.000000', 'temperatura', 1025.0000, 'ºC'),
	(164808, 118, '2014-02-01 00:01:38.000000', 'temperatura', 605.0000, 'ºC'),
	(164809, 118, '2014-02-01 00:01:39.000000', 'temperatura', 1151.0000, 'ºC'),
	(164810, 118, '2014-02-01 00:01:40.000000', 'temperatura', 339.0000, 'ºC'),
	(164811, 118, '2014-02-01 00:01:41.000000', 'temperatura', 644.0000, 'ºC'),
	(164812, 118, '2014-02-01 00:01:42.000000', 'temperatura', 1005.0000, 'ºC'),
	(164813, 118, '2014-02-01 00:01:43.000000', 'temperatura', 693.0000, 'ºC'),
	(164814, 118, '2014-02-01 00:01:44.000000', 'temperatura', 448.0000, 'ºC'),
	(164815, 118, '2014-02-01 00:01:45.000000', 'temperatura', 165.0000, 'ºC'),
	(164816, 118, '2014-02-01 00:01:46.000000', 'temperatura', 680.0000, 'ºC'),
	(164817, 118, '2014-02-01 00:01:47.000000', 'temperatura', 507.0000, 'ºC'),
	(164818, 118, '2014-02-01 00:01:48.000000', 'temperatura', 495.0000, 'ºC'),
	(164819, 118, '2014-02-01 00:01:49.000000', 'temperatura', 955.0000, 'ºC'),
	(164820, 118, '2014-02-01 00:01:50.000000', 'temperatura', 890.0000, 'ºC'),
	(164821, 118, '2014-02-01 00:01:51.000000', 'temperatura', 384.0000, 'ºC'),
	(164822, 118, '2014-02-01 00:01:52.000000', 'temperatura', 451.0000, 'ºC'),
	(164823, 118, '2014-02-01 00:01:53.000000', 'temperatura', 1102.0000, 'ºC'),
	(164824, 118, '2014-02-01 00:01:54.000000', 'temperatura', 560.0000, 'ºC'),
	(164825, 118, '2014-02-01 00:01:55.000000', 'temperatura', 696.0000, 'ºC'),
	(164826, 118, '2014-02-01 00:01:56.000000', 'temperatura', 598.0000, 'ºC'),
	(164827, 118, '2014-02-01 00:01:57.000000', 'temperatura', 902.0000, 'ºC'),
	(164828, 118, '2014-02-01 00:01:58.000000', 'temperatura', 319.0000, 'ºC'),
	(164829, 118, '2014-02-01 00:01:59.000000', 'temperatura', 88.0000, 'ºC'),
	(164830, 118, '2014-02-01 00:02:00.000000', 'temperatura', 685.0000, 'ºC'),
	(164831, 118, '2014-02-01 00:02:01.000000', 'temperatura', 759.0000, 'ºC'),
	(164832, 118, '2014-02-01 00:02:02.000000', 'temperatura', 542.0000, 'ºC'),
	(164833, 118, '2014-02-01 00:02:03.000000', 'temperatura', 433.0000, 'ºC'),
	(164834, 118, '2014-02-01 00:02:04.000000', 'temperatura', 540.0000, 'ºC'),
	(164835, 118, '2014-02-01 00:02:05.000000', 'temperatura', 200.0000, 'ºC'),
	(164836, 118, '2014-02-01 00:02:06.000000', 'temperatura', 583.0000, 'ºC'),
	(164837, 118, '2014-02-01 00:02:07.000000', 'temperatura', 1113.0000, 'ºC'),
	(164838, 118, '2014-02-01 00:02:08.000000', 'temperatura', 216.0000, 'ºC'),
	(164839, 118, '2014-02-01 00:02:09.000000', 'temperatura', 142.0000, 'ºC'),
	(164840, 118, '2014-02-01 00:02:10.000000', 'temperatura', 64.0000, 'ºC'),
	(164841, 118, '2014-02-01 00:02:11.000000', 'temperatura', 1095.0000, 'ºC'),
	(164842, 118, '2014-02-01 00:02:12.000000', 'temperatura', 484.0000, 'ºC'),
	(164843, 118, '2014-02-01 00:02:13.000000', 'temperatura', 335.0000, 'ºC'),
	(164844, 118, '2014-02-01 00:02:14.000000', 'temperatura', 223.0000, 'ºC'),
	(164845, 118, '2014-02-01 00:02:15.000000', 'temperatura', 111.0000, 'ºC'),
	(164846, 118, '2014-02-01 00:02:16.000000', 'temperatura', 1085.0000, 'ºC'),
	(164847, 118, '2014-02-01 00:02:17.000000', 'temperatura', 294.0000, 'ºC'),
	(164848, 118, '2014-02-01 00:02:18.000000', 'temperatura', 616.0000, 'ºC'),
	(164849, 118, '2014-02-01 00:02:19.000000', 'temperatura', 996.0000, 'ºC'),
	(164850, 118, '2014-02-01 00:02:20.000000', 'temperatura', 735.0000, 'ºC'),
	(164851, 118, '2014-02-01 00:02:21.000000', 'temperatura', 689.0000, 'ºC'),
	(164852, 118, '2014-02-01 00:02:22.000000', 'temperatura', 37.0000, 'ºC'),
	(164853, 118, '2014-02-01 00:02:23.000000', 'temperatura', 520.0000, 'ºC'),
	(164854, 118, '2014-02-01 00:02:24.000000', 'temperatura', 92.0000, 'ºC'),
	(164855, 118, '2014-02-01 00:02:25.000000', 'temperatura', 97.0000, 'ºC'),
	(164856, 118, '2014-02-01 00:02:26.000000', 'temperatura', 209.0000, 'ºC'),
	(164857, 118, '2014-02-01 00:02:27.000000', 'temperatura', 754.0000, 'ºC'),
	(164858, 118, '2014-02-01 00:02:28.000000', 'temperatura', 744.0000, 'ºC'),
	(164859, 118, '2014-02-01 00:02:29.000000', 'temperatura', 259.0000, 'ºC'),
	(164860, 118, '2014-02-01 00:02:30.000000', 'temperatura', 264.0000, 'ºC'),
	(164861, 118, '2014-02-01 00:02:31.000000', 'temperatura', 545.0000, 'ºC'),
	(164862, 118, '2014-02-01 00:02:32.000000', 'temperatura', 732.0000, 'ºC'),
	(164863, 118, '2014-02-01 00:02:33.000000', 'temperatura', 825.0000, 'ºC'),
	(164864, 118, '2014-02-01 00:02:34.000000', 'temperatura', 728.0000, 'ºC'),
	(164865, 118, '2014-02-01 00:02:35.000000', 'temperatura', 1168.0000, 'ºC'),
	(164866, 118, '2014-02-01 00:02:36.000000', 'temperatura', 54.0000, 'ºC'),
	(164867, 118, '2014-02-01 00:02:37.000000', 'temperatura', 369.0000, 'ºC'),
	(164868, 118, '2014-02-01 00:02:38.000000', 'temperatura', 482.0000, 'ºC'),
	(164869, 118, '2014-02-01 00:02:39.000000', 'temperatura', 104.0000, 'ºC'),
	(164870, 118, '2014-02-01 00:02:40.000000', 'temperatura', 276.0000, 'ºC'),
	(164871, 118, '2014-02-01 00:02:41.000000', 'temperatura', 1069.0000, 'ºC'),
	(164872, 118, '2014-02-01 00:02:42.000000', 'temperatura', 916.0000, 'ºC'),
	(164873, 118, '2014-02-01 00:02:43.000000', 'temperatura', 172.0000, 'ºC'),
	(164874, 118, '2014-02-01 00:02:44.000000', 'temperatura', 515.0000, 'ºC'),
	(164875, 118, '2014-02-01 00:02:45.000000', 'temperatura', 858.0000, 'ºC'),
	(164876, 118, '2014-02-01 00:02:46.000000', 'temperatura', 345.0000, 'ºC'),
	(164877, 118, '2014-02-01 00:02:47.000000', 'temperatura', 352.0000, 'ºC'),
	(164878, 118, '2014-02-01 00:02:48.000000', 'temperatura', 725.0000, 'ºC'),
	(164879, 118, '2014-02-01 00:02:49.000000', 'temperatura', 171.0000, 'ºC'),
	(164880, 118, '2014-02-01 00:02:50.000000', 'temperatura', 1078.0000, 'ºC'),
	(164881, 118, '2014-02-01 00:02:51.000000', 'temperatura', 79.0000, 'ºC'),
	(164882, 118, '2014-02-01 00:02:52.000000', 'temperatura', 760.0000, 'ºC'),
	(164883, 118, '2014-02-01 00:02:53.000000', 'temperatura', 1164.0000, 'ºC'),
	(164884, 118, '2014-02-01 00:02:54.000000', 'temperatura', 1139.0000, 'ºC'),
	(164885, 118, '2014-02-01 00:02:55.000000', 'temperatura', 1007.0000, 'ºC'),
	(164886, 118, '2014-02-01 00:02:56.000000', 'temperatura', 415.0000, 'ºC'),
	(164887, 118, '2014-02-01 00:02:57.000000', 'temperatura', 257.0000, 'ºC'),
	(164888, 118, '2014-02-01 00:02:58.000000', 'temperatura', 39.0000, 'ºC'),
	(164889, 118, '2014-02-01 00:02:59.000000', 'temperatura', 625.0000, 'ºC'),
	(164890, 118, '2014-02-01 00:03:00.000000', 'temperatura', 608.0000, 'ºC'),
	(164891, 118, '2014-02-01 00:03:01.000000', 'temperatura', 1168.0000, 'ºC'),
	(164892, 118, '2014-02-01 00:03:02.000000', 'temperatura', 413.0000, 'ºC'),
	(164893, 118, '2014-02-01 00:03:03.000000', 'temperatura', 964.0000, 'ºC'),
	(164894, 118, '2014-02-01 00:03:04.000000', 'temperatura', 1182.0000, 'ºC'),
	(164895, 118, '2014-02-01 00:03:05.000000', 'temperatura', 616.0000, 'ºC'),
	(164896, 118, '2014-02-01 00:03:06.000000', 'temperatura', 737.0000, 'ºC'),
	(164897, 118, '2014-02-01 00:03:07.000000', 'temperatura', 636.0000, 'ºC'),
	(164898, 118, '2014-02-01 00:03:08.000000', 'temperatura', 972.0000, 'ºC'),
	(164899, 118, '2014-02-01 00:03:09.000000', 'temperatura', 549.0000, 'ºC'),
	(164900, 118, '2014-02-01 00:03:10.000000', 'temperatura', 1031.0000, 'ºC'),
	(164901, 118, '2014-02-01 00:03:11.000000', 'temperatura', 1107.0000, 'ºC'),
	(164902, 118, '2014-02-01 00:03:12.000000', 'temperatura', 46.0000, 'ºC'),
	(164903, 118, '2014-02-01 00:03:13.000000', 'temperatura', 506.0000, 'ºC'),
	(164904, 118, '2014-02-01 00:03:14.000000', 'temperatura', 1194.0000, 'ºC'),
	(164905, 118, '2014-02-01 00:03:15.000000', 'temperatura', 853.0000, 'ºC'),
	(164906, 118, '2014-02-01 00:03:16.000000', 'temperatura', 684.0000, 'ºC'),
	(164907, 118, '2014-02-01 00:03:17.000000', 'temperatura', 860.0000, 'ºC'),
	(164908, 118, '2014-02-01 00:03:18.000000', 'temperatura', 1049.0000, 'ºC'),
	(164909, 118, '2014-02-01 00:03:19.000000', 'temperatura', 267.0000, 'ºC'),
	(164910, 118, '2014-02-01 00:03:20.000000', 'temperatura', 589.0000, 'ºC'),
	(164911, 118, '2014-02-01 00:03:21.000000', 'temperatura', 944.0000, 'ºC'),
	(164912, 118, '2014-02-01 00:03:22.000000', 'temperatura', 552.0000, 'ºC'),
	(164913, 118, '2014-02-01 00:03:23.000000', 'temperatura', 1131.0000, 'ºC'),
	(164914, 118, '2014-02-01 00:03:24.000000', 'temperatura', 400.0000, 'ºC'),
	(164915, 118, '2014-02-01 00:03:25.000000', 'temperatura', 1005.0000, 'ºC'),
	(164916, 118, '2014-02-01 00:03:26.000000', 'temperatura', 227.0000, 'ºC'),
	(164917, 118, '2014-02-01 00:03:27.000000', 'temperatura', 519.0000, 'ºC'),
	(164918, 118, '2014-02-01 00:03:28.000000', 'temperatura', 715.0000, 'ºC'),
	(164919, 118, '2014-02-01 00:03:29.000000', 'temperatura', 820.0000, 'ºC'),
	(164920, 118, '2014-02-01 00:03:30.000000', 'temperatura', 754.0000, 'ºC'),
	(164921, 118, '2014-02-01 00:03:31.000000', 'temperatura', 111.0000, 'ºC'),
	(164922, 118, '2014-02-01 00:03:32.000000', 'temperatura', 696.0000, 'ºC'),
	(164923, 118, '2014-02-01 00:03:33.000000', 'temperatura', 744.0000, 'ºC'),
	(164924, 118, '2014-02-01 00:03:34.000000', 'temperatura', 433.0000, 'ºC'),
	(164925, 118, '2014-02-01 00:03:35.000000', 'temperatura', 1135.0000, 'ºC'),
	(164926, 118, '2014-02-01 00:03:36.000000', 'temperatura', 777.0000, 'ºC'),
	(164927, 118, '2014-02-01 00:03:37.000000', 'temperatura', 479.0000, 'ºC'),
	(164928, 118, '2014-02-01 00:03:38.000000', 'temperatura', 64.0000, 'ºC'),
	(164929, 118, '2014-02-01 00:03:39.000000', 'temperatura', 85.0000, 'ºC'),
	(164930, 118, '2014-02-01 00:03:40.000000', 'temperatura', 235.0000, 'ºC'),
	(164931, 118, '2014-02-01 00:03:41.000000', 'temperatura', 919.0000, 'ºC'),
	(164932, 118, '2014-02-01 00:03:42.000000', 'temperatura', 290.0000, 'ºC'),
	(164933, 118, '2014-02-01 00:03:43.000000', 'temperatura', 1093.0000, 'ºC'),
	(164934, 118, '2014-02-01 00:03:44.000000', 'temperatura', 998.0000, 'ºC'),
	(164935, 118, '2014-02-01 00:03:45.000000', 'temperatura', 510.0000, 'ºC'),
	(164936, 118, '2014-02-01 00:03:46.000000', 'temperatura', 757.0000, 'ºC'),
	(164937, 118, '2014-02-01 00:03:47.000000', 'temperatura', 1057.0000, 'ºC'),
	(164938, 118, '2014-02-01 00:03:48.000000', 'temperatura', 613.0000, 'ºC'),
	(164939, 118, '2014-02-01 00:03:49.000000', 'temperatura', 1096.0000, 'ºC'),
	(164940, 118, '2014-02-01 00:03:50.000000', 'temperatura', 40.0000, 'ºC'),
	(164941, 118, '2014-02-01 00:03:51.000000', 'temperatura', 514.0000, 'ºC'),
	(164942, 118, '2014-02-01 00:03:52.000000', 'temperatura', 48.0000, 'ºC'),
	(164943, 118, '2014-02-01 00:03:53.000000', 'temperatura', 1099.0000, 'ºC'),
	(164944, 118, '2014-02-01 00:03:54.000000', 'temperatura', 553.0000, 'ºC'),
	(164945, 118, '2014-02-01 00:03:55.000000', 'temperatura', 669.0000, 'ºC'),
	(164946, 118, '2014-02-01 00:03:56.000000', 'temperatura', 487.0000, 'ºC'),
	(164947, 118, '2014-02-01 00:03:57.000000', 'temperatura', 427.0000, 'ºC'),
	(164948, 118, '2014-02-01 00:03:58.000000', 'temperatura', 673.0000, 'ºC'),
	(164949, 118, '2014-02-01 00:03:59.000000', 'temperatura', 886.0000, 'ºC'),
	(164950, 118, '2014-02-01 00:04:00.000000', 'temperatura', 11.0000, 'ºC'),
	(164951, 118, '2014-02-01 00:04:01.000000', 'temperatura', 997.0000, 'ºC'),
	(164952, 118, '2014-02-01 00:04:02.000000', 'temperatura', 154.0000, 'ºC'),
	(164953, 118, '2014-02-01 00:04:03.000000', 'temperatura', 177.0000, 'ºC'),
	(164954, 118, '2014-02-01 00:04:04.000000', 'temperatura', 424.0000, 'ºC'),
	(164955, 118, '2014-02-01 00:04:05.000000', 'temperatura', 392.0000, 'ºC'),
	(164956, 118, '2014-02-01 00:04:06.000000', 'temperatura', 688.0000, 'ºC'),
	(164957, 118, '2014-02-01 00:04:07.000000', 'temperatura', 1062.0000, 'ºC'),
	(164958, 118, '2014-02-01 00:04:08.000000', 'temperatura', 848.0000, 'ºC'),
	(164959, 118, '2014-02-01 00:04:09.000000', 'temperatura', 1054.0000, 'ºC'),
	(164960, 118, '2014-02-01 00:04:10.000000', 'temperatura', 327.0000, 'ºC'),
	(164961, 118, '2014-02-01 00:04:11.000000', 'temperatura', 872.0000, 'ºC'),
	(164962, 118, '2014-02-01 00:04:12.000000', 'temperatura', 982.0000, 'ºC'),
	(164963, 118, '2014-02-01 00:04:13.000000', 'temperatura', 1094.0000, 'ºC'),
	(164964, 118, '2014-02-01 00:04:14.000000', 'temperatura', 125.0000, 'ºC'),
	(164965, 118, '2014-02-01 00:04:15.000000', 'temperatura', 943.0000, 'ºC'),
	(164966, 118, '2014-02-01 00:04:16.000000', 'temperatura', 738.0000, 'ºC'),
	(164967, 118, '2014-02-01 00:04:17.000000', 'temperatura', 865.0000, 'ºC'),
	(164968, 118, '2014-02-01 00:04:18.000000', 'temperatura', 910.0000, 'ºC'),
	(164969, 118, '2014-02-01 00:04:19.000000', 'temperatura', 755.0000, 'ºC'),
	(164970, 118, '2014-02-01 00:04:20.000000', 'temperatura', 1046.0000, 'ºC'),
	(164971, 118, '2014-02-01 00:04:21.000000', 'temperatura', 565.0000, 'ºC'),
	(164972, 118, '2014-02-01 00:04:22.000000', 'temperatura', 886.0000, 'ºC'),
	(164973, 118, '2014-02-01 00:04:23.000000', 'temperatura', 337.0000, 'ºC'),
	(164974, 118, '2014-02-01 00:04:24.000000', 'temperatura', 229.0000, 'ºC'),
	(164975, 118, '2014-02-01 00:04:25.000000', 'temperatura', 134.0000, 'ºC'),
	(164976, 118, '2014-02-01 00:04:26.000000', 'temperatura', 1183.0000, 'ºC'),
	(164977, 118, '2014-02-01 00:04:27.000000', 'temperatura', 716.0000, 'ºC'),
	(164978, 118, '2014-02-01 00:04:28.000000', 'temperatura', 28.0000, 'ºC'),
	(164979, 118, '2014-02-01 00:04:29.000000', 'temperatura', 395.0000, 'ºC'),
	(164980, 118, '2014-02-01 00:04:30.000000', 'temperatura', 692.0000, 'ºC'),
	(164981, 118, '2014-02-01 00:04:31.000000', 'temperatura', 1075.0000, 'ºC'),
	(164982, 118, '2014-02-01 00:04:32.000000', 'temperatura', 901.0000, 'ºC'),
	(164983, 118, '2014-02-01 00:04:33.000000', 'temperatura', 80.0000, 'ºC'),
	(164984, 118, '2014-02-01 00:04:34.000000', 'temperatura', 97.0000, 'ºC'),
	(164985, 118, '2014-02-01 00:04:35.000000', 'temperatura', 245.0000, 'ºC'),
	(164986, 118, '2014-02-01 00:04:36.000000', 'temperatura', 934.0000, 'ºC'),
	(164987, 118, '2014-02-01 00:04:37.000000', 'temperatura', 334.0000, 'ºC'),
	(164988, 118, '2014-02-01 00:04:38.000000', 'temperatura', 72.0000, 'ºC'),
	(164989, 118, '2014-02-01 00:04:39.000000', 'temperatura', 556.0000, 'ºC'),
	(164990, 118, '2014-02-01 00:04:40.000000', 'temperatura', 165.0000, 'ºC'),
	(164991, 118, '2014-02-01 00:04:41.000000', 'temperatura', 359.0000, 'ºC'),
	(164992, 118, '2014-02-01 00:04:42.000000', 'temperatura', 100.0000, 'ºC'),
	(164993, 118, '2014-02-01 00:04:43.000000', 'temperatura', 622.0000, 'ºC'),
	(164994, 118, '2014-02-01 00:04:44.000000', 'temperatura', 410.0000, 'ºC'),
	(164995, 118, '2014-02-01 00:04:45.000000', 'temperatura', 185.0000, 'ºC'),
	(164996, 118, '2014-02-01 00:04:46.000000', 'temperatura', 897.0000, 'ºC'),
	(164997, 118, '2014-02-01 00:04:47.000000', 'temperatura', 330.0000, 'ºC'),
	(164998, 118, '2014-02-01 00:04:48.000000', 'temperatura', 161.0000, 'ºC'),
	(164999, 118, '2014-02-01 00:04:49.000000', 'temperatura', 1013.0000, 'ºC'),
	(165000, 118, '2014-02-01 00:04:50.000000', 'temperatura', 981.0000, 'ºC'),
	(165001, 118, '2014-02-01 00:04:51.000000', 'temperatura', 670.0000, 'ºC'),
	(165002, 118, '2014-02-01 00:04:52.000000', 'temperatura', 406.0000, 'ºC'),
	(165003, 118, '2014-02-01 00:04:53.000000', 'temperatura', 22.0000, 'ºC'),
	(165004, 118, '2014-02-01 00:04:54.000000', 'temperatura', 92.0000, 'ºC'),
	(165005, 118, '2014-02-01 00:04:55.000000', 'temperatura', 395.0000, 'ºC'),
	(165006, 118, '2014-02-01 00:04:56.000000', 'temperatura', 497.0000, 'ºC'),
	(165007, 118, '2014-02-01 00:04:57.000000', 'temperatura', 102.0000, 'ºC'),
	(165008, 118, '2014-02-01 00:04:58.000000', 'temperatura', 218.0000, 'ºC'),
	(165009, 118, '2014-02-01 00:04:59.000000', 'temperatura', 784.0000, 'ºC'),
	(165010, 118, '2014-02-01 00:05:00.000000', 'temperatura', 866.0000, 'ºC'),
	(165011, 118, '2014-02-01 00:05:01.000000', 'temperatura', 779.0000, 'ºC'),
	(165012, 118, '2014-02-01 00:05:02.000000', 'temperatura', 97.0000, 'ºC'),
	(165013, 118, '2014-02-01 00:05:03.000000', 'temperatura', 548.0000, 'ºC'),
	(165014, 118, '2014-02-01 00:05:04.000000', 'temperatura', 49.0000, 'ºC'),
	(165015, 118, '2014-02-01 00:05:05.000000', 'temperatura', 1003.0000, 'ºC'),
	(165016, 118, '2014-02-01 00:05:06.000000', 'temperatura', 67.0000, 'ºC'),
	(165017, 118, '2014-02-01 00:05:07.000000', 'temperatura', 929.0000, 'ºC'),
	(165018, 118, '2014-02-01 00:05:08.000000', 'temperatura', 844.0000, 'ºC'),
	(165019, 118, '2014-02-01 00:05:09.000000', 'temperatura', 231.0000, 'ºC'),
	(165020, 118, '2014-02-01 00:05:10.000000', 'temperatura', 1027.0000, 'ºC'),
	(165021, 118, '2014-02-01 00:05:11.000000', 'temperatura', 840.0000, 'ºC'),
	(165022, 118, '2014-02-01 00:05:12.000000', 'temperatura', 1122.0000, 'ºC'),
	(165023, 118, '2014-02-01 00:05:13.000000', 'temperatura', 687.0000, 'ºC'),
	(165024, 118, '2014-02-01 00:05:14.000000', 'temperatura', 72.0000, 'ºC'),
	(165025, 118, '2014-02-01 00:05:15.000000', 'temperatura', 699.0000, 'ºC'),
	(165026, 118, '2014-02-01 00:05:16.000000', 'temperatura', 881.0000, 'ºC'),
	(165027, 118, '2014-02-01 00:05:17.000000', 'temperatura', 1108.0000, 'ºC'),
	(165028, 118, '2014-02-01 00:05:18.000000', 'temperatura', 496.0000, 'ºC'),
	(165029, 118, '2014-02-01 00:05:19.000000', 'temperatura', 357.0000, 'ºC'),
	(165030, 118, '2014-02-01 00:05:20.000000', 'temperatura', 299.0000, 'ºC'),
	(165031, 118, '2014-02-01 00:05:21.000000', 'temperatura', 422.0000, 'ºC'),
	(165032, 118, '2014-02-01 00:05:22.000000', 'temperatura', 15.0000, 'ºC'),
	(165033, 118, '2014-02-01 00:05:23.000000', 'temperatura', 10.0000, 'ºC'),
	(165034, 118, '2014-02-01 00:05:24.000000', 'temperatura', 4.0000, 'ºC'),
	(165035, 118, '2014-02-01 00:05:25.000000', 'temperatura', 1191.0000, 'ºC'),
	(165036, 118, '2014-02-01 00:05:26.000000', 'temperatura', 1143.0000, 'ºC'),
	(165037, 118, '2014-02-01 00:05:27.000000', 'temperatura', 943.0000, 'ºC'),
	(165038, 118, '2014-02-01 00:05:28.000000', 'temperatura', 88.0000, 'ºC'),
	(165039, 118, '2014-02-01 00:05:29.000000', 'temperatura', 8.0000, 'ºC'),
	(165040, 118, '2014-02-01 00:05:30.000000', 'temperatura', 980.0000, 'ºC'),
	(165041, 118, '2014-02-01 00:05:31.000000', 'temperatura', 74.0000, 'ºC'),
	(165042, 118, '2014-02-01 00:05:32.000000', 'temperatura', 1032.0000, 'ºC'),
	(165043, 118, '2014-02-01 00:05:33.000000', 'temperatura', 139.0000, 'ºC'),
	(165044, 118, '2014-02-01 00:05:34.000000', 'temperatura', 1198.0000, 'ºC'),
	(165045, 118, '2014-02-01 00:05:35.000000', 'temperatura', 776.0000, 'ºC'),
	(165046, 118, '2014-02-01 00:05:36.000000', 'temperatura', 284.0000, 'ºC'),
	(165047, 118, '2014-02-01 00:05:37.000000', 'temperatura', 291.0000, 'ºC'),
	(165048, 118, '2014-02-01 00:05:38.000000', 'temperatura', 606.0000, 'ºC'),
	(165049, 118, '2014-02-01 00:05:39.000000', 'temperatura', 956.0000, 'ºC'),
	(165050, 118, '2014-02-01 00:05:40.000000', 'temperatura', 564.0000, 'ºC'),
	(165051, 118, '2014-02-01 00:05:41.000000', 'temperatura', 1151.0000, 'ºC'),
	(165052, 118, '2014-02-01 00:05:42.000000', 'temperatura', 463.0000, 'ºC'),
	(165053, 118, '2014-02-01 00:05:43.000000', 'temperatura', 65.0000, 'ºC'),
	(165054, 118, '2014-02-01 00:05:44.000000', 'temperatura', 136.0000, 'ºC'),
	(165055, 118, '2014-02-01 00:05:45.000000', 'temperatura', 483.0000, 'ºC'),
	(165056, 118, '2014-02-01 00:05:46.000000', 'temperatura', 810.0000, 'ºC'),
	(165057, 118, '2014-02-01 00:05:47.000000', 'temperatura', 200.0000, 'ºC'),
	(165058, 118, '2014-02-01 00:05:48.000000', 'temperatura', 970.0000, 'ºC'),
	(165059, 118, '2014-02-01 00:05:49.000000', 'temperatura', 652.0000, 'ºC'),
	(165060, 118, '2014-02-01 00:05:50.000000', 'temperatura', 351.0000, 'ºC'),
	(165061, 118, '2014-02-01 00:05:51.000000', 'temperatura', 1000.0000, 'ºC'),
	(165062, 118, '2014-02-01 00:05:52.000000', 'temperatura', 347.0000, 'ºC'),
	(165063, 118, '2014-02-01 00:05:53.000000', 'temperatura', 1137.0000, 'ºC'),
	(165064, 118, '2014-02-01 00:05:54.000000', 'temperatura', 1042.0000, 'ºC'),
	(165065, 118, '2014-02-01 00:05:55.000000', 'temperatura', 601.0000, 'ºC'),
	(165066, 118, '2014-02-01 00:05:56.000000', 'temperatura', 1078.0000, 'ºC'),
	(165067, 118, '2014-02-01 00:05:57.000000', 'temperatura', 1186.0000, 'ºC'),
	(165068, 118, '2014-02-01 00:05:58.000000', 'temperatura', 299.0000, 'ºC'),
	(165069, 118, '2014-02-01 00:05:59.000000', 'temperatura', 335.0000, 'ºC'),
	(165070, 118, '2014-02-01 00:06:00.000000', 'temperatura', 780.0000, 'ºC'),
	(165071, 118, '2014-02-01 00:06:01.000000', 'temperatura', 497.0000, 'ºC'),
	(165072, 118, '2014-02-01 00:06:02.000000', 'temperatura', 145.0000, 'ºC'),
	(165073, 118, '2014-02-01 00:06:03.000000', 'temperatura', 433.0000, 'ºC'),
	(165074, 118, '2014-02-01 00:06:04.000000', 'temperatura', 530.0000, 'ºC'),
	(165075, 118, '2014-02-01 00:06:05.000000', 'temperatura', 154.0000, 'ºC'),
	(165076, 118, '2014-02-01 00:06:06.000000', 'temperatura', 379.0000, 'ºC'),
	(165077, 118, '2014-02-01 00:06:07.000000', 'temperatura', 232.0000, 'ºC'),
	(165078, 118, '2014-02-01 00:06:08.000000', 'temperatura', 26.0000, 'ºC'),
	(165079, 118, '2014-02-01 00:06:09.000000', 'temperatura', 632.0000, 'ºC'),
	(165080, 118, '2014-02-01 00:06:10.000000', 'temperatura', 682.0000, 'ºC'),
	(165081, 118, '2014-02-01 00:06:11.000000', 'temperatura', 317.0000, 'ºC'),
	(165082, 118, '2014-02-01 00:06:12.000000', 'temperatura', 740.0000, 'ºC'),
	(165083, 118, '2014-02-01 00:06:13.000000', 'temperatura', 349.0000, 'ºC'),
	(165084, 118, '2014-02-01 00:06:14.000000', 'temperatura', 725.0000, 'ºC'),
	(165085, 118, '2014-02-01 00:06:15.000000', 'temperatura', 179.0000, 'ºC'),
	(165086, 118, '2014-02-01 00:06:16.000000', 'temperatura', 1122.0000, 'ºC'),
	(165087, 118, '2014-02-01 00:06:17.000000', 'temperatura', 270.0000, 'ºC'),
	(165088, 118, '2014-02-01 00:06:18.000000', 'temperatura', 388.0000, 'ºC'),
	(165089, 118, '2014-02-01 00:06:19.000000', 'temperatura', 1127.0000, 'ºC'),
	(165090, 118, '2014-02-01 00:06:20.000000', 'temperatura', 874.0000, 'ºC'),
	(165091, 118, '2014-02-01 00:06:21.000000', 'temperatura', 990.0000, 'ºC'),
	(165092, 118, '2014-02-01 00:06:22.000000', 'temperatura', 1128.0000, 'ºC'),
	(165093, 118, '2014-02-01 00:06:23.000000', 'temperatura', 270.0000, 'ºC'),
	(165094, 118, '2014-02-01 00:06:24.000000', 'temperatura', 368.0000, 'ºC'),
	(165095, 118, '2014-02-01 00:06:25.000000', 'temperatura', 1029.0000, 'ºC'),
	(165096, 118, '2014-02-01 00:06:26.000000', 'temperatura', 443.0000, 'ºC'),
	(165097, 118, '2014-02-01 00:06:27.000000', 'temperatura', 327.0000, 'ºC'),
	(165098, 118, '2014-02-01 00:06:28.000000', 'temperatura', 307.0000, 'ºC'),
	(165099, 118, '2014-02-01 00:06:29.000000', 'temperatura', 554.0000, 'ºC'),
	(165100, 118, '2014-02-01 00:06:30.000000', 'temperatura', 648.0000, 'ºC'),
	(165101, 118, '2014-02-01 00:06:31.000000', 'temperatura', 382.0000, 'ºC'),
	(165102, 118, '2014-02-01 00:06:32.000000', 'temperatura', 1164.0000, 'ºC'),
	(165103, 118, '2014-02-01 00:06:33.000000', 'temperatura', 1074.0000, 'ºC'),
	(165104, 118, '2014-02-01 00:06:34.000000', 'temperatura', 680.0000, 'ºC'),
	(165105, 118, '2014-02-01 00:06:35.000000', 'temperatura', 179.0000, 'ºC'),
	(165106, 118, '2014-02-01 00:06:36.000000', 'temperatura', 53.0000, 'ºC'),
	(165107, 118, '2014-02-01 00:06:37.000000', 'temperatura', 930.0000, 'ºC'),
	(165108, 118, '2014-02-01 00:06:38.000000', 'temperatura', 891.0000, 'ºC'),
	(165109, 118, '2014-02-01 00:06:39.000000', 'temperatura', 467.0000, 'ºC'),
	(165110, 118, '2014-02-01 00:06:40.000000', 'temperatura', 861.0000, 'ºC'),
	(165111, 118, '2014-02-01 00:06:41.000000', 'temperatura', 506.0000, 'ºC'),
	(165112, 118, '2014-02-01 00:06:42.000000', 'temperatura', 1147.0000, 'ºC'),
	(165113, 118, '2014-02-01 00:06:43.000000', 'temperatura', 619.0000, 'ºC'),
	(165114, 118, '2014-02-01 00:06:44.000000', 'temperatura', 854.0000, 'ºC'),
	(165115, 118, '2014-02-01 00:06:45.000000', 'temperatura', 12.0000, 'ºC'),
	(165116, 118, '2014-02-01 00:06:46.000000', 'temperatura', 1100.0000, 'ºC'),
	(165117, 118, '2014-02-01 00:06:47.000000', 'temperatura', 663.0000, 'ºC'),
	(165118, 118, '2014-02-01 00:06:48.000000', 'temperatura', 15.0000, 'ºC'),
	(165119, 118, '2014-02-01 00:06:49.000000', 'temperatura', 489.0000, 'ºC'),
	(165120, 118, '2014-02-01 00:06:50.000000', 'temperatura', 1199.0000, 'ºC'),
	(165121, 118, '2014-02-01 00:06:51.000000', 'temperatura', 929.0000, 'ºC'),
	(165122, 118, '2014-02-01 00:06:52.000000', 'temperatura', 1047.0000, 'ºC'),
	(165123, 118, '2014-02-01 00:06:53.000000', 'temperatura', 49.0000, 'ºC'),
	(165124, 118, '2014-02-01 00:06:54.000000', 'temperatura', 706.0000, 'ºC'),
	(165125, 118, '2014-02-01 00:06:55.000000', 'temperatura', 985.0000, 'ºC'),
	(165126, 118, '2014-02-01 00:06:56.000000', 'temperatura', 405.0000, 'ºC'),
	(165127, 118, '2014-02-01 00:06:57.000000', 'temperatura', 270.0000, 'ºC'),
	(165128, 118, '2014-02-01 00:06:58.000000', 'temperatura', 136.0000, 'ºC'),
	(165129, 118, '2014-02-01 00:06:59.000000', 'temperatura', 1072.0000, 'ºC'),
	(165130, 118, '2014-02-01 00:07:00.000000', 'temperatura', 151.0000, 'ºC'),
	(165131, 118, '2014-02-01 00:07:01.000000', 'temperatura', 1141.0000, 'ºC'),
	(165132, 118, '2014-02-01 00:07:02.000000', 'temperatura', 452.0000, 'ºC'),
	(165133, 118, '2014-02-01 00:07:03.000000', 'temperatura', 36.0000, 'ºC'),
	(165134, 118, '2014-02-01 00:07:04.000000', 'temperatura', 24.0000, 'ºC'),
	(165135, 118, '2014-02-01 00:07:05.000000', 'temperatura', 15.0000, 'ºC'),
	(165136, 118, '2014-02-01 00:07:06.000000', 'temperatura', 4.0000, 'ºC'),
	(165137, 118, '2014-02-01 00:07:07.000000', 'temperatura', 1173.0000, 'ºC'),
	(165138, 118, '2014-02-01 00:07:08.000000', 'temperatura', 1055.0000, 'ºC'),
	(165139, 118, '2014-02-01 00:07:09.000000', 'temperatura', 555.0000, 'ºC'),
	(165140, 118, '2014-02-01 00:07:10.000000', 'temperatura', 809.0000, 'ºC'),
	(165141, 118, '2014-02-01 00:07:11.000000', 'temperatura', 1183.0000, 'ºC'),
	(165142, 118, '2014-02-01 00:07:12.000000', 'temperatura', 1090.0000, 'ºC'),
	(165143, 118, '2014-02-01 00:07:13.000000', 'temperatura', 699.0000, 'ºC'),
	(165144, 118, '2014-02-01 00:07:14.000000', 'temperatura', 226.0000, 'ºC'),
	(165145, 118, '2014-02-01 00:07:15.000000', 'temperatura', 233.0000, 'ºC'),
	(165146, 118, '2014-02-01 00:07:16.000000', 'temperatura', 486.0000, 'ºC'),
	(165147, 118, '2014-02-01 00:07:17.000000', 'temperatura', 533.0000, 'ºC'),
	(165148, 118, '2014-02-01 00:07:18.000000', 'temperatura', 7.0000, 'ºC'),
	(165149, 118, '2014-02-01 00:07:19.000000', 'temperatura', 837.0000, 'ºC'),
	(165150, 118, '2014-02-01 00:07:20.000000', 'temperatura', 565.0000, 'ºC'),
	(165151, 118, '2014-02-01 00:07:21.000000', 'temperatura', 315.0000, 'ºC'),
	(165152, 118, '2014-02-01 00:07:22.000000', 'temperatura', 1080.0000, 'ºC'),
	(165153, 118, '2014-02-01 00:07:23.000000', 'temperatura', 857.0000, 'ºC'),
	(165154, 118, '2014-02-01 00:07:24.000000', 'temperatura', 1045.0000, 'ºC'),
	(165155, 118, '2014-02-01 00:07:25.000000', 'temperatura', 255.0000, 'ºC'),
	(165156, 118, '2014-02-01 00:07:26.000000', 'temperatura', 538.0000, 'ºC'),
	(165157, 118, '2014-02-01 00:07:27.000000', 'temperatura', 727.0000, 'ºC'),
	(165158, 118, '2014-02-01 00:07:28.000000', 'temperatura', 822.0000, 'ºC'),
	(165159, 118, '2014-02-01 00:07:29.000000', 'temperatura', 728.0000, 'ºC'),
	(165160, 118, '2014-02-01 00:07:30.000000', 'temperatura', 1177.0000, 'ºC'),
	(165161, 118, '2014-02-01 00:07:31.000000', 'temperatura', 98.0000, 'ºC'),
	(165162, 118, '2014-02-01 00:07:32.000000', 'temperatura', 562.0000, 'ºC'),
	(165163, 118, '2014-02-01 00:07:33.000000', 'temperatura', 117.0000, 'ºC'),
	(165164, 118, '2014-02-01 00:07:34.000000', 'temperatura', 99.0000, 'ºC'),
	(165165, 118, '2014-02-01 00:07:35.000000', 'temperatura', 143.0000, 'ºC'),
	(165166, 118, '2014-02-01 00:07:36.000000', 'temperatura', 420.0000, 'ºC'),
	(165167, 118, '2014-02-01 00:07:37.000000', 'temperatura', 473.0000, 'ºC'),
	(165168, 118, '2014-02-01 00:07:38.000000', 'temperatura', 1105.0000, 'ºC'),
	(165169, 118, '2014-02-01 00:07:39.000000', 'temperatura', 504.0000, 'ºC'),
	(165170, 118, '2014-02-01 00:07:40.000000', 'temperatura', 407.0000, 'ºC'),
	(165171, 118, '2014-02-01 00:07:41.000000', 'temperatura', 524.0000, 'ºC'),
	(165172, 118, '2014-02-01 00:07:42.000000', 'temperatura', 200.0000, 'ºC'),
	(165173, 118, '2014-02-01 00:07:43.000000', 'temperatura', 630.0000, 'ºC'),
	(165174, 118, '2014-02-01 00:07:44.000000', 'temperatura', 149.0000, 'ºC'),
	(165175, 118, '2014-02-01 00:07:45.000000', 'temperatura', 54.0000, 'ºC'),
	(165176, 118, '2014-02-01 00:07:46.000000', 'temperatura', 1025.0000, 'ºC'),
	(165177, 118, '2014-02-01 00:07:47.000000', 'temperatura', 162.0000, 'ºC'),
	(165178, 118, '2014-02-01 00:07:48.000000', 'temperatura', 138.0000, 'ºC'),
	(165179, 118, '2014-02-01 00:07:49.000000', 'temperatura', 205.0000, 'ºC'),
	(165180, 118, '2014-02-01 00:07:50.000000', 'temperatura', 611.0000, 'ºC'),
	(165181, 118, '2014-02-01 00:07:51.000000', 'temperatura', 40.0000, 'ºC'),
	(165182, 118, '2014-02-01 00:07:52.000000', 'temperatura', 767.0000, 'ºC'),
	(165183, 118, '2014-02-01 00:07:53.000000', 'temperatura', 117.0000, 'ºC'),
	(165184, 118, '2014-02-01 00:07:54.000000', 'temperatura', 682.0000, 'ºC'),
	(165185, 118, '2014-02-01 00:07:55.000000', 'temperatura', 659.0000, 'ºC'),
	(165186, 118, '2014-02-01 00:07:56.000000', 'temperatura', 50.0000, 'ºC'),
	(165187, 118, '2014-02-01 00:07:57.000000', 'temperatura', 675.0000, 'ºC'),
	(165188, 118, '2014-02-01 00:07:58.000000', 'temperatura', 823.0000, 'ºC'),
	(165189, 118, '2014-02-01 00:07:59.000000', 'temperatura', 892.0000, 'ºC'),
	(165190, 118, '2014-02-01 00:08:00.000000', 'temperatura', 792.0000, 'ºC'),
	(165191, 118, '2014-02-01 00:08:01.000000', 'temperatura', 86.0000, 'ºC'),
	(165192, 118, '2014-02-01 00:08:02.000000', 'temperatura', 454.0000, 'ºC'),
	(165193, 118, '2014-02-01 00:08:03.000000', 'temperatura', 811.0000, 'ºC'),
	(165194, 118, '2014-02-01 00:08:04.000000', 'temperatura', 294.0000, 'ºC'),
	(165195, 118, '2014-02-01 00:08:05.000000', 'temperatura', 236.0000, 'ºC'),
	(165196, 118, '2014-02-01 00:08:06.000000', 'temperatura', 300.0000, 'ºC'),
	(165197, 118, '2014-02-01 00:08:07.000000', 'temperatura', 791.0000, 'ºC'),
	(165198, 118, '2014-02-01 00:08:08.000000', 'temperatura', 656.0000, 'ºC'),
	(165199, 118, '2014-02-01 00:08:09.000000', 'temperatura', 906.0000, 'ºC'),
	(165200, 118, '2014-02-01 00:08:10.000000', 'temperatura', 164.0000, 'ºC'),
	(165201, 118, '2014-02-01 00:08:11.000000', 'temperatura', 501.0000, 'ºC'),
	(165202, 118, '2014-02-01 00:08:12.000000', 'temperatura', 816.0000, 'ºC'),
	(165203, 118, '2014-02-01 00:08:13.000000', 'temperatura', 178.0000, 'ºC'),
	(165204, 118, '2014-02-01 00:08:14.000000', 'temperatura', 840.0000, 'ºC'),
	(165205, 118, '2014-02-01 00:08:15.000000', 'temperatura', 70.0000, 'ºC'),
	(165206, 118, '2014-02-01 00:08:16.000000', 'temperatura', 227.0000, 'ºC'),
	(165207, 118, '2014-02-01 00:08:17.000000', 'temperatura', 926.0000, 'ºC'),
	(165208, 118, '2014-02-01 00:08:18.000000', 'temperatura', 351.0000, 'ºC'),
	(165209, 118, '2014-02-01 00:08:19.000000', 'temperatura', 176.0000, 'ºC'),
	(165210, 118, '2014-02-01 00:08:20.000000', 'temperatura', 1028.0000, 'ºC'),
	(165211, 118, '2014-02-01 00:08:21.000000', 'temperatura', 1012.0000, 'ºC'),
	(165212, 118, '2014-02-01 00:08:22.000000', 'temperatura', 777.0000, 'ºC'),
	(165213, 118, '2014-02-01 00:08:23.000000', 'temperatura', 850.0000, 'ºC'),
	(165214, 118, '2014-02-01 00:08:24.000000', 'temperatura', 720.0000, 'ºC'),
	(165215, 118, '2014-02-01 00:08:25.000000', 'temperatura', 1051.0000, 'ºC'),
	(165216, 118, '2014-02-01 00:08:26.000000', 'temperatura', 693.0000, 'ºC'),
	(165217, 118, '2014-02-01 00:08:27.000000', 'temperatura', 315.0000, 'ºC'),
	(165218, 118, '2014-02-01 00:08:28.000000', 'temperatura', 696.0000, 'ºC'),
	(165219, 118, '2014-02-01 00:08:29.000000', 'temperatura', 133.0000, 'ºC'),
	(165220, 118, '2014-02-01 00:08:30.000000', 'temperatura', 980.0000, 'ºC'),
	(165221, 118, '2014-02-01 00:08:31.000000', 'temperatura', 901.0000, 'ºC'),
	(165222, 118, '2014-02-01 00:08:32.000000', 'temperatura', 363.0000, 'ºC'),
	(165223, 118, '2014-02-01 00:08:33.000000', 'temperatura', 316.0000, 'ºC'),
	(165224, 118, '2014-02-01 00:08:34.000000', 'temperatura', 489.0000, 'ºC'),
	(165225, 118, '2014-02-01 00:08:35.000000', 'temperatura', 299.0000, 'ºC'),
	(165226, 118, '2014-02-01 00:08:36.000000', 'temperatura', 28.0000, 'ºC'),
	(165227, 118, '2014-02-01 00:08:37.000000', 'temperatura', 443.0000, 'ºC'),
	(165228, 118, '2014-02-01 00:08:38.000000', 'temperatura', 934.0000, 'ºC'),
	(165229, 118, '2014-02-01 00:08:39.000000', 'temperatura', 939.0000, 'ºC'),
	(165230, 118, '2014-02-01 00:08:40.000000', 'temperatura', 696.0000, 'ºC'),
	(165231, 118, '2014-02-01 00:08:41.000000', 'temperatura', 664.0000, 'ºC'),
	(165232, 118, '2014-02-01 00:08:42.000000', 'temperatura', 30.0000, 'ºC'),
	(165233, 118, '2014-02-01 00:08:43.000000', 'temperatura', 560.0000, 'ºC'),
	(165234, 118, '2014-02-01 00:08:44.000000', 'temperatura', 308.0000, 'ºC'),
	(165235, 118, '2014-02-01 00:08:45.000000', 'temperatura', 1063.0000, 'ºC'),
	(165236, 118, '2014-02-01 00:08:46.000000', 'temperatura', 789.0000, 'ºC'),
	(165237, 118, '2014-02-01 00:08:47.000000', 'temperatura', 759.0000, 'ºC'),
	(165238, 118, '2014-02-01 00:08:48.000000', 'temperatura', 228.0000, 'ºC'),
	(165239, 118, '2014-02-01 00:08:49.000000', 'temperatura', 64.0000, 'ºC'),
	(165240, 118, '2014-02-01 00:08:50.000000', 'temperatura', 834.0000, 'ºC'),
	(165241, 118, '2014-02-01 00:08:51.000000', 'temperatura', 381.0000, 'ºC'),
	(165242, 118, '2014-02-01 00:08:52.000000', 'temperatura', 601.0000, 'ºC'),
	(165243, 118, '2014-02-01 00:08:53.000000', 'temperatura', 664.0000, 'ºC'),
	(165244, 118, '2014-02-01 00:08:54.000000', 'temperatura', 316.0000, 'ºC'),
	(165245, 118, '2014-02-01 00:08:55.000000', 'temperatura', 790.0000, 'ºC'),
	(165246, 118, '2014-02-01 00:08:56.000000', 'temperatura', 604.0000, 'ºC'),
	(165247, 118, '2014-02-01 00:08:57.000000', 'temperatura', 649.0000, 'ºC'),
	(165248, 118, '2014-02-01 00:08:58.000000', 'temperatura', 235.0000, 'ºC'),
	(165249, 118, '2014-02-01 00:08:59.000000', 'temperatura', 426.0000, 'ºC'),
	(165250, 118, '2014-02-01 00:09:00.000000', 'temperatura', 226.0000, 'ºC'),
	(165251, 118, '2014-02-01 00:09:01.000000', 'temperatura', 1052.0000, 'ºC'),
	(165252, 118, '2014-02-01 00:09:02.000000', 'temperatura', 983.0000, 'ºC'),
	(165253, 118, '2014-02-01 00:09:03.000000', 'temperatura', 559.0000, 'ºC'),
	(165254, 118, '2014-02-01 00:09:04.000000', 'temperatura', 1049.0000, 'ºC'),
	(165255, 118, '2014-02-01 00:09:05.000000', 'temperatura', 1166.0000, 'ºC'),
	(165256, 118, '2014-02-01 00:09:06.000000', 'temperatura', 285.0000, 'ºC'),
	(165257, 118, '2014-02-01 00:09:07.000000', 'temperatura', 327.0000, 'ºC'),
	(165258, 118, '2014-02-01 00:09:08.000000', 'temperatura', 782.0000, 'ºC'),
	(165259, 118, '2014-02-01 00:09:09.000000', 'temperatura', 528.0000, 'ºC'),
	(165260, 118, '2014-02-01 00:09:10.000000', 'temperatura', 296.0000, 'ºC'),
	(165261, 118, '2014-02-01 00:09:11.000000', 'temperatura', 1094.0000, 'ºC'),
	(165262, 118, '2014-02-01 00:09:12.000000', 'temperatura', 984.0000, 'ºC'),
	(165263, 118, '2014-02-01 00:09:13.000000', 'temperatura', 440.0000, 'ºC'),
	(165264, 118, '2014-02-01 00:09:14.000000', 'temperatura', 445.0000, 'ºC'),
	(165265, 118, '2014-02-01 00:09:15.000000', 'temperatura', 909.0000, 'ºC'),
	(165266, 118, '2014-02-01 00:09:16.000000', 'temperatura', 808.0000, 'ºC'),
	(165267, 118, '2014-02-01 00:09:17.000000', 'temperatura', 112.0000, 'ºC'),
	(165268, 118, '2014-02-01 00:09:18.000000', 'temperatura', 539.0000, 'ºC'),
	(165269, 118, '2014-02-01 00:09:19.000000', 'temperatura', 1158.0000, 'ºC'),
	(165270, 118, '2014-02-01 00:09:20.000000', 'temperatura', 575.0000, 'ºC'),
	(165271, 118, '2014-02-01 00:09:21.000000', 'temperatura', 601.0000, 'ºC'),
	(165272, 118, '2014-02-01 00:09:22.000000', 'temperatura', 79.0000, 'ºC'),
	(165273, 118, '2014-02-01 00:09:23.000000', 'temperatura', 992.0000, 'ºC'),
	(165274, 118, '2014-02-01 00:09:24.000000', 'temperatura', 1124.0000, 'ºC'),
	(165275, 118, '2014-02-01 00:09:25.000000', 'temperatura', 246.0000, 'ºC'),
	(165276, 118, '2014-02-01 00:09:26.000000', 'temperatura', 259.0000, 'ºC'),
	(165277, 118, '2014-02-01 00:09:27.000000', 'temperatura', 558.0000, 'ºC'),
	(165278, 118, '2014-02-01 00:09:28.000000', 'temperatura', 812.0000, 'ºC'),
	(165279, 118, '2014-02-01 00:09:29.000000', 'temperatura', 1185.0000, 'ºC'),
	(165280, 118, '2014-02-01 00:09:30.000000', 'temperatura', 1093.0000, 'ºC'),
	(165281, 118, '2014-02-01 00:09:31.000000', 'temperatura', 707.0000, 'ºC'),
	(165282, 118, '2014-02-01 00:09:32.000000', 'temperatura', 258.0000, 'ºC'),
	(165283, 118, '2014-02-01 00:09:33.000000', 'temperatura', 371.0000, 'ºC'),
	(165284, 118, '2014-02-01 00:09:34.000000', 'temperatura', 1081.0000, 'ºC'),
	(165285, 118, '2014-02-01 00:09:35.000000', 'temperatura', 694.0000, 'ºC'),
	(165286, 118, '2014-02-01 00:09:36.000000', 'temperatura', 226.0000, 'ºC'),
	(165287, 118, '2014-02-01 00:09:37.000000', 'temperatura', 248.0000, 'ºC'),
	(165288, 118, '2014-02-01 00:09:38.000000', 'temperatura', 565.0000, 'ºC'),
	(165289, 118, '2014-02-01 00:09:39.000000', 'temperatura', 878.0000, 'ºC'),
	(165290, 118, '2014-02-01 00:09:40.000000', 'temperatura', 298.0000, 'ºC'),
	(165291, 118, '2014-02-01 00:09:41.000000', 'temperatura', 57.0000, 'ºC'),
	(165292, 118, '2014-02-01 00:09:42.000000', 'temperatura', 590.0000, 'ºC'),
	(165293, 118, '2014-02-01 00:09:43.000000', 'temperatura', 381.0000, 'ºC'),
	(165294, 118, '2014-02-01 00:09:44.000000', 'temperatura', 133.0000, 'ºC'),
	(165295, 118, '2014-02-01 00:09:45.000000', 'temperatura', 724.0000, 'ºC'),
	(165296, 118, '2014-02-01 00:09:46.000000', 'temperatura', 821.0000, 'ºC'),
	(165297, 118, '2014-02-01 00:09:47.000000', 'temperatura', 734.0000, 'ºC'),
	(165298, 118, '2014-02-01 00:09:48.000000', 'temperatura', 6.0000, 'ºC'),
	(165299, 118, '2014-02-01 00:09:49.000000', 'temperatura', 227.0000, 'ºC'),
	(165300, 118, '2014-02-01 00:09:50.000000', 'temperatura', 1120.0000, 'ºC'),
	(165301, 118, '2014-02-01 00:09:51.000000', 'temperatura', 121.0000, 'ºC'),
	(165302, 118, '2014-02-01 00:09:52.000000', 'temperatura', 844.0000, 'ºC'),
	(165303, 118, '2014-02-01 00:09:53.000000', 'temperatura', 256.0000, 'ºC'),
	(165304, 118, '2014-02-01 00:09:54.000000', 'temperatura', 1151.0000, 'ºC'),
	(165305, 118, '2014-02-01 00:09:55.000000', 'temperatura', 186.0000, 'ºC'),
	(165306, 118, '2014-02-01 00:09:56.000000', 'temperatura', 1079.0000, 'ºC'),
	(165307, 118, '2014-02-01 00:09:57.000000', 'temperatura', 35.0000, 'ºC'),
	(165308, 118, '2014-02-01 00:09:58.000000', 'temperatura', 542.0000, 'ºC'),
	(165309, 118, '2014-02-01 00:09:59.000000', 'temperatura', 203.0000, 'ºC'),
	(165310, 118, '2014-02-01 00:10:00.000000', 'temperatura', 590.0000, 'ºC'),
	(165311, 118, '2014-02-01 00:10:01.000000', 'temperatura', 1141.0000, 'ºC'),
	(165312, 118, '2014-02-01 00:10:02.000000', 'temperatura', 335.0000, 'ºC'),
	(165313, 118, '2014-02-01 00:10:03.000000', 'temperatura', 651.0000, 'ºC'),
	(165314, 118, '2014-02-01 00:10:04.000000', 'temperatura', 1053.0000, 'ºC'),
	(165315, 118, '2014-02-01 00:10:05.000000', 'temperatura', 914.0000, 'ºC'),
	(165316, 118, '2014-02-01 00:10:06.000000', 'temperatura', 209.0000, 'ºC'),
	(165317, 118, '2014-02-01 00:10:07.000000', 'temperatura', 705.0000, 'ºC'),
	(165318, 118, '2014-02-01 00:10:08.000000', 'temperatura', 498.0000, 'ºC'),
	(165319, 118, '2014-02-01 00:10:09.000000', 'temperatura', 378.0000, 'ºC'),
	(165320, 118, '2014-02-01 00:10:10.000000', 'temperatura', 393.0000, 'ºC'),
	(165321, 118, '2014-02-01 00:10:11.000000', 'temperatura', 831.0000, 'ºC'),
	(165322, 118, '2014-02-01 00:10:12.000000', 'temperatura', 579.0000, 'ºC'),
	(165323, 118, '2014-02-01 00:10:13.000000', 'temperatura', 401.0000, 'ºC'),
	(165324, 118, '2014-02-01 00:10:14.000000', 'temperatura', 271.0000, 'ºC'),
	(165325, 118, '2014-02-01 00:10:15.000000', 'temperatura', 150.0000, 'ºC'),
	(165326, 118, '2014-02-01 00:10:16.000000', 'temperatura', 1140.0000, 'ºC'),
	(165327, 118, '2014-02-01 00:10:17.000000', 'temperatura', 449.0000, 'ºC'),
	(165328, 118, '2014-02-01 00:10:18.000000', 'temperatura', 24.0000, 'ºC'),
	(165329, 118, '2014-02-01 00:10:19.000000', 'temperatura', 1175.0000, 'ºC'),
	(165330, 118, '2014-02-01 00:10:20.000000', 'temperatura', 1004.0000, 'ºC'),
	(165331, 118, '2014-02-01 00:10:21.000000', 'temperatura', 295.0000, 'ºC'),
	(165332, 118, '2014-02-01 00:10:22.000000', 'temperatura', 865.0000, 'ºC'),
	(165333, 118, '2014-02-01 00:10:23.000000', 'temperatura', 1038.0000, 'ºC'),
	(165334, 118, '2014-02-01 00:10:24.000000', 'temperatura', 198.0000, 'ºC'),
	(165335, 118, '2014-02-01 00:10:25.000000', 'temperatura', 275.0000, 'ºC'),
	(165336, 118, '2014-02-01 00:10:26.000000', 'temperatura', 782.0000, 'ºC'),
	(165337, 118, '2014-02-01 00:10:27.000000', 'temperatura', 686.0000, 'ºC'),
	(165338, 118, '2014-02-01 00:10:28.000000', 'temperatura', 1084.0000, 'ºC'),
	(165339, 118, '2014-02-01 00:10:29.000000', 'temperatura', 964.0000, 'ºC'),
	(165340, 118, '2014-02-01 00:10:30.000000', 'temperatura', 368.0000, 'ºC'),
	(165341, 118, '2014-02-01 00:10:31.000000', 'temperatura', 147.0000, 'ºC'),
	(165342, 118, '2014-02-01 00:10:32.000000', 'temperatura', 832.0000, 'ºC'),
	(165343, 118, '2014-02-01 00:10:33.000000', 'temperatura', 121.0000, 'ºC'),
	(165344, 118, '2014-02-01 00:10:34.000000', 'temperatura', 510.0000, 'ºC'),
	(165345, 118, '2014-02-01 00:10:35.000000', 'temperatura', 984.0000, 'ºC'),
	(165346, 118, '2014-02-01 00:10:36.000000', 'temperatura', 994.0000, 'ºC'),
	(165347, 118, '2014-02-01 00:10:37.000000', 'temperatura', 818.0000, 'ºC'),
	(165348, 118, '2014-02-01 00:10:38.000000', 'temperatura', 1106.0000, 'ºC'),
	(165349, 118, '2014-02-01 00:10:39.000000', 'temperatura', 679.0000, 'ºC'),
	(165350, 118, '2014-02-01 00:10:40.000000', 'temperatura', 78.0000, 'ºC'),
	(165351, 118, '2014-02-01 00:10:41.000000', 'temperatura', 751.0000, 'ºC'),
	(165352, 118, '2014-02-01 00:10:42.000000', 'temperatura', 1122.0000, 'ºC'),
	(165353, 118, '2014-02-01 00:10:43.000000', 'temperatura', 957.0000, 'ºC'),
	(165354, 118, '2014-02-01 00:10:44.000000', 'temperatura', 218.0000, 'ºC'),
	(165355, 118, '2014-02-01 00:10:45.000000', 'temperatura', 623.0000, 'ºC'),
	(165356, 118, '2014-02-01 00:10:46.000000', 'temperatura', 60.0000, 'ºC'),
	(165357, 118, '2014-02-01 00:10:47.000000', 'temperatura', 831.0000, 'ºC'),
	(165358, 118, '2014-02-01 00:10:48.000000', 'temperatura', 375.0000, 'ºC'),
	(165359, 118, '2014-02-01 00:10:49.000000', 'temperatura', 585.0000, 'ºC'),
	(165360, 118, '2014-02-01 00:10:50.000000', 'temperatura', 600.0000, 'ºC'),
	(165361, 118, '2014-02-01 00:10:51.000000', 'temperatura', 45.0000, 'ºC'),
	(165362, 118, '2014-02-01 00:10:52.000000', 'temperatura', 824.0000, 'ºC'),
	(165363, 118, '2014-02-01 00:10:53.000000', 'temperatura', 385.0000, 'ºC'),
	(165364, 118, '2014-02-01 00:10:54.000000', 'temperatura', 655.0000, 'ºC'),
	(165365, 118, '2014-02-01 00:10:55.000000', 'temperatura', 922.0000, 'ºC'),
	(165366, 118, '2014-02-01 00:10:56.000000', 'temperatura', 246.0000, 'ºC'),
	(165367, 118, '2014-02-01 00:10:57.000000', 'temperatura', 862.0000, 'ºC'),
	(165368, 118, '2014-02-01 00:10:58.000000', 'temperatura', 1172.0000, 'ºC'),
	(165369, 118, '2014-02-01 00:10:59.000000', 'temperatura', 877.0000, 'ºC'),
	(165370, 118, '2014-02-01 00:11:00.000000', 'temperatura', 870.0000, 'ºC'),
	(165371, 118, '2014-02-01 00:11:01.000000', 'temperatura', 521.0000, 'ºC'),
	(165372, 118, '2014-02-01 00:11:02.000000', 'temperatura', 1192.0000, 'ºC'),
	(165373, 118, '2014-02-01 00:11:03.000000', 'temperatura', 798.0000, 'ºC'),
	(165374, 118, '2014-02-01 00:11:04.000000', 'temperatura', 413.0000, 'ºC'),
	(165375, 118, '2014-02-01 00:11:05.000000', 'temperatura', 875.0000, 'ºC'),
	(165376, 118, '2014-02-01 00:11:06.000000', 'temperatura', 733.0000, 'ºC'),
	(165377, 118, '2014-02-01 00:11:07.000000', 'temperatura', 1042.0000, 'ºC'),
	(165378, 118, '2014-02-01 00:11:08.000000', 'temperatura', 613.0000, 'ºC'),
	(165379, 118, '2014-02-01 00:11:09.000000', 'temperatura', 1137.0000, 'ºC'),
	(165380, 118, '2014-02-01 00:11:10.000000', 'temperatura', 248.0000, 'ºC'),
	(165381, 118, '2014-02-01 00:11:11.000000', 'temperatura', 231.0000, 'ºC'),
	(165382, 118, '2014-02-01 00:11:12.000000', 'temperatura', 409.0000, 'ºC'),
	(165383, 118, '2014-02-01 00:11:13.000000', 'temperatura', 155.0000, 'ºC'),
	(165384, 118, '2014-02-01 00:11:14.000000', 'temperatura', 747.0000, 'ºC'),
	(165385, 118, '2014-02-01 00:11:15.000000', 'temperatura', 870.0000, 'ºC'),
	(165386, 118, '2014-02-01 00:11:16.000000', 'temperatura', 909.0000, 'ºC'),
	(165387, 118, '2014-02-01 00:11:17.000000', 'temperatura', 737.0000, 'ºC'),
	(165388, 118, '2014-02-01 00:11:18.000000', 'temperatura', 960.0000, 'ºC'),
	(165389, 118, '2014-02-01 00:11:19.000000', 'temperatura', 188.0000, 'ºC'),
	(165390, 118, '2014-02-01 00:11:20.000000', 'temperatura', 463.0000, 'ºC'),
	(165391, 118, '2014-02-01 00:11:21.000000', 'temperatura', 548.0000, 'ºC'),
	(165392, 118, '2014-02-01 00:11:22.000000', 'temperatura', 153.0000, 'ºC'),
	(165393, 118, '2014-02-01 00:11:23.000000', 'temperatura', 322.0000, 'ºC'),
	(165394, 118, '2014-02-01 00:11:24.000000', 'temperatura', 1149.0000, 'ºC'),
	(165395, 118, '2014-02-01 00:11:25.000000', 'temperatura', 1183.0000, 'ºC'),
	(165396, 118, '2014-02-01 00:11:26.000000', 'temperatura', 66.0000, 'ºC'),
	(165397, 118, '2014-02-01 00:11:27.000000', 'temperatura', 382.0000, 'ºC'),
	(165398, 118, '2014-02-01 00:11:28.000000', 'temperatura', 514.0000, 'ºC'),
	(165399, 118, '2014-02-01 00:11:29.000000', 'temperatura', 223.0000, 'ºC'),
	(165400, 118, '2014-02-01 00:11:30.000000', 'temperatura', 772.0000, 'ºC'),
	(165401, 118, '2014-02-01 00:11:31.000000', 'temperatura', 793.0000, 'ºC'),
	(165402, 118, '2014-02-01 00:11:32.000000', 'temperatura', 451.0000, 'ºC'),
	(165403, 118, '2014-02-01 00:11:33.000000', 'temperatura', 1076.0000, 'ºC'),
	(165404, 118, '2014-02-01 00:11:34.000000', 'temperatura', 427.0000, 'ºC'),
	(165405, 118, '2014-02-01 00:11:35.000000', 'temperatura', 108.0000, 'ºC'),
	(165406, 118, '2014-02-01 00:11:36.000000', 'temperatura', 461.0000, 'ºC'),
	(165407, 118, '2014-02-01 00:11:37.000000', 'temperatura', 781.0000, 'ºC'),
	(165408, 118, '2014-02-01 00:11:38.000000', 'temperatura', 121.0000, 'ºC'),
	(165409, 118, '2014-02-01 00:11:39.000000', 'temperatura', 664.0000, 'ºC'),
	(165410, 118, '2014-02-01 00:11:40.000000', 'temperatura', 558.0000, 'ºC'),
	(165411, 118, '2014-02-01 00:11:41.000000', 'temperatura', 796.0000, 'ºC'),
	(165412, 118, '2014-02-01 00:11:42.000000', 'temperatura', 1109.0000, 'ºC'),
	(165413, 118, '2014-02-01 00:11:43.000000', 'temperatura', 756.0000, 'ºC'),
	(165414, 118, '2014-02-01 00:11:44.000000', 'temperatura', 454.0000, 'ºC'),
	(165415, 118, '2014-02-01 00:11:45.000000', 'temperatura', 1.0000, 'ºC'),
	(165416, 118, '2014-02-01 00:11:46.000000', 'temperatura', 1046.0000, 'ºC'),
	(165417, 118, '2014-02-01 00:11:47.000000', 'temperatura', 426.0000, 'ºC'),
	(165418, 118, '2014-02-01 00:11:48.000000', 'temperatura', 193.0000, 'ºC'),
	(165419, 118, '2014-02-01 00:11:49.000000', 'temperatura', 888.0000, 'ºC'),
	(165420, 118, '2014-02-01 00:11:50.000000', 'temperatura', 262.0000, 'ºC'),
	(165421, 118, '2014-02-01 00:11:51.000000', 'temperatura', 1046.0000, 'ºC'),
	(165422, 118, '2014-02-01 00:11:52.000000', 'temperatura', 844.0000, 'ºC'),
	(165423, 118, '2014-02-01 00:11:53.000000', 'temperatura', 1082.0000, 'ºC'),
	(165424, 118, '2014-02-01 00:11:54.000000', 'temperatura', 478.0000, 'ºC'),
	(165425, 118, '2014-02-01 00:11:55.000000', 'temperatura', 344.0000, 'ºC'),
	(165426, 118, '2014-02-01 00:11:56.000000', 'temperatura', 286.0000, 'ºC'),
	(165427, 118, '2014-02-01 00:11:57.000000', 'temperatura', 401.0000, 'ºC'),
	(165428, 118, '2014-02-01 00:11:58.000000', 'temperatura', 1148.0000, 'ºC'),
	(165429, 118, '2014-02-01 00:11:59.000000', 'temperatura', 935.0000, 'ºC'),
	(165430, 118, '2014-02-01 00:12:00.000000', 'temperatura', 33.0000, 'ºC'),
	(165431, 118, '2014-02-01 00:12:01.000000', 'temperatura', 960.0000, 'ºC'),
	(165432, 118, '2014-02-01 00:12:02.000000', 'temperatura', 1101.0000, 'ºC'),
	(165433, 118, '2014-02-01 00:12:03.000000', 'temperatura', 224.0000, 'ºC'),
	(165434, 118, '2014-02-01 00:12:04.000000', 'temperatura', 220.0000, 'ºC'),
	(165435, 118, '2014-02-01 00:12:05.000000', 'temperatura', 426.0000, 'ºC'),
	(165436, 118, '2014-02-01 00:12:06.000000', 'temperatura', 274.0000, 'ºC'),
	(165437, 118, '2014-02-01 00:12:07.000000', 'temperatura', 90.0000, 'ºC'),
	(165438, 118, '2014-02-01 00:12:08.000000', 'temperatura', 827.0000, 'ºC'),
	(165439, 118, '2014-02-01 00:12:09.000000', 'temperatura', 267.0000, 'ºC'),
	(165440, 118, '2014-02-01 00:12:10.000000', 'temperatura', 54.0000, 'ºC'),
	(165441, 118, '2014-02-01 00:12:11.000000', 'temperatura', 671.0000, 'ºC'),
	(165442, 118, '2014-02-01 00:12:12.000000', 'temperatura', 794.0000, 'ºC'),
	(165443, 118, '2014-02-01 00:12:13.000000', 'temperatura', 758.0000, 'ºC'),
	(165444, 118, '2014-02-01 00:12:14.000000', 'temperatura', 209.0000, 'ºC'),
	(165445, 118, '2014-02-01 00:12:15.000000', 'temperatura', 1169.0000, 'ºC'),
	(165446, 118, '2014-02-01 00:12:16.000000', 'temperatura', 419.0000, 'ºC'),
	(165447, 118, '2014-02-01 00:12:17.000000', 'temperatura', 989.0000, 'ºC'),
	(165448, 118, '2014-02-01 00:12:18.000000', 'temperatura', 90.0000, 'ºC'),
	(165449, 118, '2014-02-01 00:12:19.000000', 'temperatura', 1084.0000, 'ºC'),
	(165450, 118, '2014-02-01 00:12:20.000000', 'temperatura', 349.0000, 'ºC'),
	(165451, 118, '2014-02-01 00:12:21.000000', 'temperatura', 893.0000, 'ºC'),
	(165452, 118, '2014-02-01 00:12:22.000000', 'temperatura', 1018.0000, 'ºC'),
	(165453, 118, '2014-02-01 00:12:23.000000', 'temperatura', 11.0000, 'ºC'),
	(165454, 118, '2014-02-01 00:12:24.000000', 'temperatura', 602.0000, 'ºC'),
	(165455, 118, '2014-02-01 00:12:25.000000', 'temperatura', 576.0000, 'ºC'),
	(165456, 118, '2014-02-01 00:12:26.000000', 'temperatura', 1076.0000, 'ºC'),
	(165457, 118, '2014-02-01 00:12:27.000000', 'temperatura', 54.0000, 'ºC'),
	(165458, 118, '2014-02-01 00:12:28.000000', 'temperatura', 642.0000, 'ºC'),
	(165459, 118, '2014-02-01 00:12:29.000000', 'temperatura', 646.0000, 'ºC'),
	(165460, 118, '2014-02-01 00:12:30.000000', 'temperatura', 106.0000, 'ºC'),
	(165461, 118, '2014-02-01 00:12:31.000000', 'temperatura', 991.0000, 'ºC'),
	(165462, 118, '2014-02-01 00:12:32.000000', 'temperatura', 1038.0000, 'ºC'),
	(165463, 118, '2014-02-01 00:12:33.000000', 'temperatura', 1017.0000, 'ºC'),
	(165464, 118, '2014-02-01 00:12:34.000000', 'temperatura', 773.0000, 'ºC'),
	(165465, 118, '2014-02-01 00:12:35.000000', 'temperatura', 814.0000, 'ºC'),
	(165466, 118, '2014-02-01 00:12:36.000000', 'temperatura', 552.0000, 'ºC'),
	(165467, 118, '2014-02-01 00:12:37.000000', 'temperatura', 319.0000, 'ºC'),
	(165468, 118, '2014-02-01 00:12:38.000000', 'temperatura', 1139.0000, 'ºC'),
	(165469, 118, '2014-02-01 00:12:39.000000', 'temperatura', 1138.0000, 'ºC'),
	(165470, 118, '2014-02-01 00:12:40.000000', 'temperatura', 1074.0000, 'ºC'),
	(165471, 118, '2014-02-01 00:12:41.000000', 'temperatura', 755.0000, 'ºC'),
	(165472, 118, '2014-02-01 00:12:42.000000', 'temperatura', 552.0000, 'ºC'),
	(165473, 118, '2014-02-01 00:12:43.000000', 'temperatura', 498.0000, 'ºC'),
	(165474, 118, '2014-02-01 00:12:44.000000', 'temperatura', 836.0000, 'ºC'),
	(165475, 118, '2014-02-01 00:12:45.000000', 'temperatura', 285.0000, 'ºC'),
	(165476, 118, '2014-02-01 00:12:46.000000', 'temperatura', 117.0000, 'ºC'),
	(165477, 118, '2014-02-01 00:12:47.000000', 'temperatura', 931.0000, 'ºC'),
	(165478, 118, '2014-02-01 00:12:48.000000', 'temperatura', 705.0000, 'ºC'),
	(165479, 118, '2014-02-01 00:12:49.000000', 'temperatura', 732.0000, 'ºC'),
	(165480, 118, '2014-02-01 00:12:50.000000', 'temperatura', 345.0000, 'ºC'),
	(165481, 118, '2014-02-01 00:12:51.000000', 'temperatura', 728.0000, 'ºC'),
	(165482, 118, '2014-02-01 00:12:52.000000', 'temperatura', 207.0000, 'ºC'),
	(165483, 118, '2014-02-01 00:12:53.000000', 'temperatura', 52.0000, 'ºC'),
	(165484, 118, '2014-02-01 00:12:54.000000', 'temperatura', 841.0000, 'ºC'),
	(165485, 118, '2014-02-01 00:12:55.000000', 'temperatura', 448.0000, 'ºC'),
	(165486, 118, '2014-02-01 00:12:56.000000', 'temperatura', 919.0000, 'ºC'),
	(165487, 118, '2014-02-01 00:12:57.000000', 'temperatura', 852.0000, 'ºC'),
	(165488, 118, '2014-02-01 00:12:58.000000', 'temperatura', 302.0000, 'ºC'),
	(165489, 118, '2014-02-01 00:12:59.000000', 'temperatura', 154.0000, 'ºC'),
	(165490, 118, '2014-02-01 00:13:00.000000', 'temperatura', 1066.0000, 'ºC'),
	(165491, 118, '2014-02-01 00:13:01.000000', 'temperatura', 67.0000, 'ºC'),
	(165492, 118, '2014-02-01 00:13:02.000000', 'temperatura', 738.0000, 'ºC'),
	(165493, 118, '2014-02-01 00:13:03.000000', 'temperatura', 1091.0000, 'ºC'),
	(165494, 118, '2014-02-01 00:13:04.000000', 'temperatura', 842.0000, 'ºC'),
	(165495, 118, '2014-02-01 00:13:05.000000', 'temperatura', 938.0000, 'ºC'),
	(165496, 118, '2014-02-01 00:13:06.000000', 'temperatura', 964.0000, 'ºC'),
	(165497, 118, '2014-02-01 00:13:07.000000', 'temperatura', 808.0000, 'ºC'),
	(165498, 118, '2014-02-01 00:13:08.000000', 'temperatura', 1147.0000, 'ºC'),
	(165499, 118, '2014-02-01 00:13:09.000000', 'temperatura', 914.0000, 'ºC'),
	(165500, 118, '2014-02-01 00:13:10.000000', 'temperatura', 1126.0000, 'ºC'),
	(165501, 118, '2014-02-01 00:13:11.000000', 'temperatura', 492.0000, 'ºC'),
	(165502, 118, '2014-02-01 00:13:12.000000', 'temperatura', 280.0000, 'ºC'),
	(165503, 118, '2014-02-01 00:13:13.000000', 'temperatura', 1123.0000, 'ºC'),
	(165504, 118, '2014-02-01 00:13:14.000000', 'temperatura', 1178.0000, 'ºC'),
	(165505, 118, '2014-02-01 00:13:15.000000', 'temperatura', 122.0000, 'ºC'),
	(165506, 118, '2014-02-01 00:13:16.000000', 'temperatura', 674.0000, 'ºC'),
	(165507, 118, '2014-02-01 00:13:17.000000', 'temperatura', 604.0000, 'ºC'),
	(165508, 118, '2014-02-01 00:13:18.000000', 'temperatura', 999.0000, 'ºC'),
	(165509, 118, '2014-02-01 00:13:19.000000', 'temperatura', 786.0000, 'ºC'),
	(165510, 118, '2014-02-01 00:13:20.000000', 'temperatura', 931.0000, 'ºC'),
	(165511, 118, '2014-02-01 00:13:21.000000', 'temperatura', 1097.0000, 'ºC'),
	(165512, 118, '2014-02-01 00:13:22.000000', 'temperatura', 294.0000, 'ºC'),
	(165513, 118, '2014-02-01 00:13:23.000000', 'temperatura', 579.0000, 'ºC'),
	(165514, 118, '2014-02-01 00:13:24.000000', 'temperatura', 813.0000, 'ºC'),
	(165515, 118, '2014-02-01 00:13:25.000000', 'temperatura', 1130.0000, 'ºC'),
	(165516, 118, '2014-02-01 00:13:26.000000', 'temperatura', 813.0000, 'ºC'),
	(165517, 118, '2014-02-01 00:13:27.000000', 'temperatura', 673.0000, 'ºC'),
	(165518, 118, '2014-02-01 00:13:28.000000', 'temperatura', 925.0000, 'ºC'),
	(165519, 118, '2014-02-01 00:13:29.000000', 'temperatura', 208.0000, 'ºC'),
	(165520, 118, '2014-02-01 00:13:30.000000', 'temperatura', 667.0000, 'ºC'),
	(165521, 118, '2014-02-01 00:13:31.000000', 'temperatura', 311.0000, 'ºC'),
	(165522, 118, '2014-02-01 00:13:32.000000', 'temperatura', 755.0000, 'ºC'),
	(165523, 118, '2014-02-01 00:13:33.000000', 'temperatura', 443.0000, 'ºC'),
	(165524, 118, '2014-02-01 00:13:34.000000', 'temperatura', 1150.0000, 'ºC'),
	(165525, 118, '2014-02-01 00:13:35.000000', 'temperatura', 822.0000, 'ºC'),
	(165526, 118, '2014-02-01 00:13:36.000000', 'temperatura', 660.0000, 'ºC'),
	(165527, 118, '2014-02-01 00:13:37.000000', 'temperatura', 836.0000, 'ºC'),
	(165528, 118, '2014-02-01 00:13:38.000000', 'temperatura', 1001.0000, 'ºC'),
	(165529, 118, '2014-02-01 00:13:39.000000', 'temperatura', 96.0000, 'ºC'),
	(165530, 118, '2014-02-01 00:13:40.000000', 'temperatura', 1077.0000, 'ºC'),
	(165531, 118, '2014-02-01 00:13:41.000000', 'temperatura', 297.0000, 'ºC'),
	(165532, 118, '2014-02-01 00:13:42.000000', 'temperatura', 654.0000, 'ºC'),
	(165533, 118, '2014-02-01 00:13:43.000000', 'temperatura', 1179.0000, 'ºC'),
	(165534, 118, '2014-02-01 00:13:44.000000', 'temperatura', 334.0000, 'ºC'),
	(165535, 118, '2014-02-01 00:13:45.000000', 'temperatura', 533.0000, 'ºC'),
	(165536, 118, '2014-02-01 00:13:46.000000', 'temperatura', 464.0000, 'ºC'),
	(165537, 118, '2014-02-01 00:13:47.000000', 'temperatura', 720.0000, 'ºC'),
	(165538, 118, '2014-02-01 00:13:48.000000', 'temperatura', 1009.0000, 'ºC'),
	(165539, 118, '2014-02-01 00:13:49.000000', 'temperatura', 484.0000, 'ºC'),
	(165540, 118, '2014-02-01 00:13:50.000000', 'temperatura', 596.0000, 'ºC'),
	(165541, 118, '2014-02-01 00:13:51.000000', 'temperatura', 326.0000, 'ºC'),
	(165542, 118, '2014-02-01 00:13:52.000000', 'temperatura', 1045.0000, 'ºC'),
	(165543, 118, '2014-02-01 00:13:53.000000', 'temperatura', 647.0000, 'ºC'),
	(165544, 118, '2014-02-01 00:13:54.000000', 'temperatura', 100.0000, 'ºC'),
	(165545, 118, '2014-02-01 00:13:55.000000', 'temperatura', 958.0000, 'ºC'),
	(165546, 118, '2014-02-01 00:13:56.000000', 'temperatura', 891.0000, 'ºC'),
	(165547, 118, '2014-02-01 00:13:57.000000', 'temperatura', 383.0000, 'ºC'),
	(165548, 118, '2014-02-01 00:13:58.000000', 'temperatura', 443.0000, 'ºC'),
	(165549, 118, '2014-02-01 00:13:59.000000', 'temperatura', 1068.0000, 'ºC'),
	(165550, 118, '2014-02-01 00:14:00.000000', 'temperatura', 408.0000, 'ºC'),
	(165551, 118, '2014-02-01 00:14:01.000000', 'temperatura', 38.0000, 'ºC'),
	(165552, 118, '2014-02-01 00:14:02.000000', 'temperatura', 168.0000, 'ºC'),
	(165553, 118, '2014-02-01 00:14:03.000000', 'temperatura', 725.0000, 'ºC'),
	(165554, 118, '2014-02-01 00:14:04.000000', 'temperatura', 722.0000, 'ºC'),
	(165555, 118, '2014-02-01 00:14:05.000000', 'temperatura', 237.0000, 'ºC'),
	(165556, 118, '2014-02-01 00:14:06.000000', 'temperatura', 218.0000, 'ºC'),
	(165557, 118, '2014-02-01 00:14:07.000000', 'temperatura', 379.0000, 'ºC'),
	(165558, 118, '2014-02-01 00:14:08.000000', 'temperatura', 40.0000, 'ºC'),
	(165559, 118, '2014-02-01 00:14:09.000000', 'temperatura', 265.0000, 'ºC'),
	(165560, 118, '2014-02-01 00:14:10.000000', 'temperatura', 7.0000, 'ºC'),
	(165561, 118, '2014-02-01 00:14:11.000000', 'temperatura', 438.0000, 'ºC'),
	(165562, 118, '2014-02-01 00:14:12.000000', 'temperatura', 969.0000, 'ºC'),
	(165563, 118, '2014-02-01 00:14:13.000000', 'temperatura', 1134.0000, 'ºC'),
	(165564, 118, '2014-02-01 00:14:14.000000', 'temperatura', 360.0000, 'ºC'),
	(165565, 118, '2014-02-01 00:14:15.000000', 'temperatura', 802.0000, 'ºC'),
	(165566, 118, '2014-02-01 00:14:16.000000', 'temperatura', 529.0000, 'ºC'),
	(165567, 118, '2014-02-01 00:14:17.000000', 'temperatura', 241.0000, 'ºC'),
	(165568, 118, '2014-02-01 00:14:18.000000', 'temperatura', 819.0000, 'ºC'),
	(165569, 118, '2014-02-01 00:14:19.000000', 'temperatura', 971.0000, 'ºC'),
	(165570, 118, '2014-02-01 00:14:20.000000', 'temperatura', 1198.0000, 'ºC'),
	(165571, 118, '2014-02-01 00:14:21.000000', 'temperatura', 680.0000, 'ºC'),
	(165572, 118, '2014-02-01 00:14:22.000000', 'temperatura', 1003.0000, 'ºC'),
	(165573, 118, '2014-02-01 00:14:23.000000', 'temperatura', 577.0000, 'ºC'),
	(165574, 118, '2014-02-01 00:14:24.000000', 'temperatura', 1078.0000, 'ºC'),
	(165575, 118, '2014-02-01 00:14:25.000000', 'temperatura', 60.0000, 'ºC'),
	(165576, 118, '2014-02-01 00:14:26.000000', 'temperatura', 664.0000, 'ºC'),
	(165577, 118, '2014-02-01 00:14:27.000000', 'temperatura', 742.0000, 'ºC'),
	(165578, 118, '2014-02-01 00:14:28.000000', 'temperatura', 517.0000, 'ºC'),
	(165579, 118, '2014-02-01 00:14:29.000000', 'temperatura', 361.0000, 'ºC'),
	(165580, 118, '2014-02-01 00:14:30.000000', 'temperatura', 252.0000, 'ºC'),
	(165581, 118, '2014-02-01 00:14:31.000000', 'temperatura', 180.0000, 'ºC'),
	(165582, 118, '2014-02-01 00:14:32.000000', 'temperatura', 143.0000, 'ºC'),
	(165583, 118, '2014-02-01 00:14:33.000000', 'temperatura', 176.0000, 'ºC'),
	(165584, 118, '2014-02-01 00:14:34.000000', 'temperatura', 453.0000, 'ºC'),
	(165585, 118, '2014-02-01 00:14:35.000000', 'temperatura', 535.0000, 'ºC'),
	(165586, 118, '2014-02-01 00:14:36.000000', 'temperatura', 116.0000, 'ºC'),
	(165587, 118, '2014-02-01 00:14:37.000000', 'temperatura', 175.0000, 'ºC'),
	(165588, 118, '2014-02-01 00:14:38.000000', 'temperatura', 527.0000, 'ºC'),
	(165589, 118, '2014-02-01 00:14:39.000000', 'temperatura', 910.0000, 'ºC'),
	(165590, 118, '2014-02-01 00:14:40.000000', 'temperatura', 573.0000, 'ºC'),
	(165591, 118, '2014-02-01 00:14:41.000000', 'temperatura', 132.0000, 'ºC'),
	(165592, 118, '2014-02-01 00:14:42.000000', 'temperatura', 143.0000, 'ºC'),
	(165593, 118, '2014-02-01 00:14:43.000000', 'temperatura', 320.0000, 'ºC'),
	(165594, 118, '2014-02-01 00:14:44.000000', 'temperatura', 1173.0000, 'ºC'),
	(165595, 118, '2014-02-01 00:14:45.000000', 'temperatura', 105.0000, 'ºC'),
	(165596, 118, '2014-02-01 00:14:46.000000', 'temperatura', 605.0000, 'ºC'),
	(165597, 118, '2014-02-01 00:14:47.000000', 'temperatura', 309.0000, 'ºC'),
	(165598, 118, '2014-02-01 00:14:48.000000', 'temperatura', 932.0000, 'ºC'),
	(165599, 118, '2014-02-01 00:14:49.000000', 'temperatura', 135.0000, 'ºC'),
	(165600, 118, '2014-02-01 00:14:50.000000', 'temperatura', 276.0000, 'ºC'),
	(165601, 118, '2014-02-01 00:14:51.000000', 'temperatura', 979.0000, 'ºC'),
	(165602, 118, '2014-02-01 00:14:52.000000', 'temperatura', 468.0000, 'ºC'),
	(165603, 118, '2014-02-01 00:14:53.000000', 'temperatura', 601.0000, 'ºC'),
	(165604, 118, '2014-02-01 00:14:54.000000', 'temperatura', 401.0000, 'ºC'),
	(165605, 118, '2014-02-01 00:14:55.000000', 'temperatura', 204.0000, 'ºC'),
	(165606, 118, '2014-02-01 00:14:56.000000', 'temperatura', 1015.0000, 'ºC'),
	(165607, 118, '2014-02-01 00:14:57.000000', 'temperatura', 866.0000, 'ºC'),
	(165608, 118, '2014-02-01 00:14:58.000000', 'temperatura', 83.0000, 'ºC'),
	(165609, 118, '2014-02-01 00:14:59.000000', 'temperatura', 219.0000, 'ºC'),
	(165610, 118, '2014-02-01 00:15:00.000000', 'temperatura', 846.0000, 'ºC'),
	(165611, 118, '2014-02-01 00:15:01.000000', 'temperatura', 1175.0000, 'ºC'),
	(165612, 118, '2014-02-01 00:15:02.000000', 'temperatura', 935.0000, 'ºC'),
	(165613, 118, '2014-02-01 00:15:03.000000', 'temperatura', 1151.0000, 'ºC'),
	(165614, 118, '2014-02-01 00:15:04.000000', 'temperatura', 553.0000, 'ºC'),
	(165615, 118, '2014-02-01 00:15:05.000000', 'temperatura', 509.0000, 'ºC'),
	(165616, 118, '2014-02-01 00:15:06.000000', 'temperatura', 889.0000, 'ºC'),
	(165617, 118, '2014-02-01 00:15:07.000000', 'temperatura', 518.0000, 'ºC'),
	(165618, 118, '2014-02-01 00:15:08.000000', 'temperatura', 1125.0000, 'ºC'),
	(165619, 118, '2014-02-01 00:15:09.000000', 'temperatura', 471.0000, 'ºC'),
	(165620, 118, '2014-02-01 00:15:10.000000', 'temperatura', 178.0000, 'ºC'),
	(165621, 118, '2014-02-01 00:15:11.000000', 'temperatura', 679.0000, 'ºC'),
	(165622, 118, '2014-02-01 00:15:12.000000', 'temperatura', 461.0000, 'ºC'),
	(165623, 118, '2014-02-01 00:15:13.000000', 'temperatura', 269.0000, 'ºC'),
	(165624, 118, '2014-02-01 00:15:14.000000', 'temperatura', 1164.0000, 'ºC'),
	(165625, 118, '2014-02-01 00:15:15.000000', 'temperatura', 214.0000, 'ºC'),
	(165626, 118, '2014-02-01 00:15:16.000000', 'temperatura', 1178.0000, 'ºC'),
	(165627, 118, '2014-02-01 00:15:17.000000', 'temperatura', 449.0000, 'ºC'),
	(165628, 118, '2014-02-01 00:15:18.000000', 'temperatura', 1112.0000, 'ºC'),
	(165629, 118, '2014-02-01 00:15:19.000000', 'temperatura', 614.0000, 'ºC'),
	(165630, 118, '2014-02-01 00:15:20.000000', 'temperatura', 934.0000, 'ºC'),
	(165631, 118, '2014-02-01 00:15:21.000000', 'temperatura', 428.0000, 'ºC'),
	(165632, 118, '2014-02-01 00:15:22.000000', 'temperatura', 540.0000, 'ºC'),
	(165633, 118, '2014-02-01 00:15:23.000000', 'temperatura', 217.0000, 'ºC'),
	(165634, 118, '2014-02-01 00:15:24.000000', 'temperatura', 665.0000, 'ºC'),
	(165635, 118, '2014-02-01 00:15:25.000000', 'temperatura', 276.0000, 'ºC'),
	(165636, 118, '2014-02-01 00:15:26.000000', 'temperatura', 583.0000, 'ºC'),
	(165637, 118, '2014-02-01 00:15:27.000000', 'temperatura', 890.0000, 'ºC'),
	(165638, 118, '2014-02-01 00:15:28.000000', 'temperatura', 300.0000, 'ºC'),
	(165639, 118, '2014-02-01 00:15:29.000000', 'temperatura', 30.0000, 'ºC'),
	(165640, 118, '2014-02-01 00:15:30.000000', 'temperatura', 450.0000, 'ºC'),
	(165641, 118, '2014-02-01 00:15:31.000000', 'temperatura', 960.0000, 'ºC'),
	(165642, 118, '2014-02-01 00:15:32.000000', 'temperatura', 1053.0000, 'ºC'),
	(165643, 118, '2014-02-01 00:15:33.000000', 'temperatura', 1186.0000, 'ºC'),
	(165644, 118, '2014-02-01 00:15:34.000000', 'temperatura', 371.0000, 'ºC'),
	(165645, 118, '2014-02-01 00:15:35.000000', 'temperatura', 698.0000, 'ºC'),
	(165646, 118, '2014-02-01 00:15:36.000000', 'temperatura', 1179.0000, 'ºC'),
	(165647, 118, '2014-02-01 00:15:37.000000', 'temperatura', 200.0000, 'ºC'),
	(165648, 118, '2014-02-01 00:15:38.000000', 'temperatura', 1062.0000, 'ºC'),
	(165649, 118, '2014-02-01 00:15:39.000000', 'temperatura', 1111.0000, 'ºC'),
	(165650, 118, '2014-02-01 00:15:40.000000', 'temperatura', 1170.0000, 'ºC'),
	(165651, 118, '2014-02-01 00:15:41.000000', 'temperatura', 119.0000, 'ºC'),
	(165652, 118, '2014-02-01 00:15:42.000000', 'temperatura', 686.0000, 'ºC'),
	(165653, 118, '2014-02-01 00:15:43.000000', 'temperatura', 671.0000, 'ºC'),
	(165654, 118, '2014-02-01 00:15:44.000000', 'temperatura', 99.0000, 'ºC'),
	(165655, 118, '2014-02-01 00:15:45.000000', 'temperatura', 883.0000, 'ºC'),
	(165656, 118, '2014-02-01 00:15:46.000000', 'temperatura', 518.0000, 'ºC'),
	(165657, 118, '2014-02-01 00:15:47.000000', 'temperatura', 1143.0000, 'ºC'),
	(165658, 118, '2014-02-01 00:15:48.000000', 'temperatura', 561.0000, 'ºC'),
	(165659, 118, '2014-02-01 00:15:49.000000', 'temperatura', 578.0000, 'ºC'),
	(165660, 118, '2014-02-01 00:15:50.000000', 'temperatura', 5.0000, 'ºC'),
	(165661, 118, '2014-02-01 00:15:51.000000', 'temperatura', 690.0000, 'ºC'),
	(165662, 118, '2014-02-01 00:15:52.000000', 'temperatura', 1039.0000, 'ºC'),
	(165663, 118, '2014-02-01 00:15:53.000000', 'temperatura', 723.0000, 'ºC'),
	(165664, 118, '2014-02-01 00:15:54.000000', 'temperatura', 500.0000, 'ºC'),
	(165665, 118, '2014-02-01 00:15:55.000000', 'temperatura', 330.0000, 'ºC'),
	(165666, 118, '2014-02-01 00:15:56.000000', 'temperatura', 151.0000, 'ºC'),
	(165667, 118, '2014-02-01 00:15:57.000000', 'temperatura', 965.0000, 'ºC'),
	(165668, 118, '2014-02-01 00:15:58.000000', 'temperatura', 775.0000, 'ºC'),
	(165669, 118, '2014-02-01 00:15:59.000000', 'temperatura', 979.0000, 'ºC'),
	(165670, 118, '2014-02-01 00:16:00.000000', 'temperatura', 171.0000, 'ºC'),
	(165671, 118, '2014-02-01 00:16:01.000000', 'temperatura', 318.0000, 'ºC'),
	(165672, 118, '2014-02-01 00:16:02.000000', 'temperatura', 1077.0000, 'ºC'),
	(165673, 118, '2014-02-01 00:16:03.000000', 'temperatura', 830.0000, 'ºC'),
	(165674, 118, '2014-02-01 00:16:04.000000', 'temperatura', 920.0000, 'ºC'),
	(165675, 118, '2014-02-01 00:16:05.000000', 'temperatura', 911.0000, 'ºC'),
	(165676, 118, '2014-02-01 00:16:06.000000', 'temperatura', 595.0000, 'ºC'),
	(165677, 118, '2014-02-01 00:16:07.000000', 'temperatura', 244.0000, 'ºC'),
	(165678, 118, '2014-02-01 00:16:08.000000', 'temperatura', 634.0000, 'ºC'),
	(165679, 118, '2014-02-01 00:16:09.000000', 'temperatura', 40.0000, 'ºC'),
	(165680, 118, '2014-02-01 00:16:10.000000', 'temperatura', 699.0000, 'ºC'),
	(165681, 118, '2014-02-01 00:16:11.000000', 'temperatura', 975.0000, 'ºC'),
	(165682, 118, '2014-02-01 00:16:12.000000', 'temperatura', 380.0000, 'ºC'),
	(165683, 118, '2014-02-01 00:16:13.000000', 'temperatura', 176.0000, 'ºC'),
	(165684, 118, '2014-02-01 00:16:14.000000', 'temperatura', 937.0000, 'ºC'),
	(165685, 118, '2014-02-01 00:16:15.000000', 'temperatura', 560.0000, 'ºC'),
	(165686, 118, '2014-02-01 00:16:16.000000', 'temperatura', 1189.0000, 'ºC'),
	(165687, 118, '2014-02-01 00:16:17.000000', 'temperatura', 664.0000, 'ºC'),
	(165688, 118, '2014-02-01 00:16:18.000000', 'temperatura', 955.0000, 'ºC'),
	(165689, 118, '2014-02-01 00:16:19.000000', 'temperatura', 384.0000, 'ºC'),
	(165690, 118, '2014-02-01 00:16:20.000000', 'temperatura', 255.0000, 'ºC'),
	(165691, 118, '2014-02-01 00:16:21.000000', 'temperatura', 123.0000, 'ºC'),
	(165692, 118, '2014-02-01 00:16:22.000000', 'temperatura', 1052.0000, 'ºC'),
	(165693, 118, '2014-02-01 00:16:23.000000', 'temperatura', 89.0000, 'ºC'),
	(165694, 118, '2014-02-01 00:16:24.000000', 'temperatura', 891.0000, 'ºC'),
	(165695, 118, '2014-02-01 00:16:25.000000', 'temperatura', 586.0000, 'ºC'),
	(165696, 118, '2014-02-01 00:16:26.000000', 'temperatura', 260.0000, 'ºC'),
	(165697, 118, '2014-02-01 00:16:27.000000', 'temperatura', 741.0000, 'ºC'),
	(165698, 118, '2014-02-01 00:16:28.000000', 'temperatura', 525.0000, 'ºC'),
	(165699, 118, '2014-02-01 00:16:29.000000', 'temperatura', 403.0000, 'ºC'),
	(165700, 118, '2014-02-01 00:16:30.000000', 'temperatura', 441.0000, 'ºC'),
	(165701, 118, '2014-02-01 00:16:31.000000', 'temperatura', 995.0000, 'ºC'),
	(165702, 118, '2014-02-01 00:16:32.000000', 'temperatura', 53.0000, 'ºC'),
	(165703, 118, '2014-02-01 00:16:33.000000', 'temperatura', 879.0000, 'ºC'),
	(165704, 118, '2014-02-01 00:16:34.000000', 'temperatura', 640.0000, 'ºC'),
	(165705, 118, '2014-02-01 00:16:35.000000', 'temperatura', 560.0000, 'ºC'),
	(165706, 118, '2014-02-01 00:16:36.000000', 'temperatura', 882.0000, 'ºC'),
	(165707, 118, '2014-02-01 00:16:37.000000', 'temperatura', 331.0000, 'ºC'),
	(165708, 118, '2014-02-01 00:16:38.000000', 'temperatura', 209.0000, 'ºC'),
	(165709, 118, '2014-02-01 00:16:39.000000', 'temperatura', 52.0000, 'ºC'),
	(165710, 118, '2014-02-01 00:16:40.000000', 'temperatura', 833.0000, 'ºC'),
	(165711, 118, '2014-02-01 00:16:41.000000', 'temperatura', 410.0000, 'ºC'),
	(165712, 118, '2014-02-01 00:16:42.000000', 'temperatura', 752.0000, 'ºC'),
	(165713, 118, '2014-02-01 00:16:43.000000', 'temperatura', 131.0000, 'ºC'),
	(165714, 118, '2014-02-01 00:16:44.000000', 'temperatura', 799.0000, 'ºC'),
	(165715, 118, '2014-02-01 00:16:45.000000', 'temperatura', 4.0000, 'ºC'),
	(165716, 118, '2014-02-01 00:16:46.000000', 'temperatura', 21.0000, 'ºC'),
	(165717, 118, '2014-02-01 00:16:47.000000', 'temperatura', 93.0000, 'ºC'),
	(165718, 118, '2014-02-01 00:16:48.000000', 'temperatura', 402.0000, 'ºC'),
	(165719, 118, '2014-02-01 00:16:49.000000', 'temperatura', 531.0000, 'ºC'),
	(165720, 118, '2014-02-01 00:16:50.000000', 'temperatura', 249.0000, 'ºC'),
	(165721, 118, '2014-02-01 00:16:51.000000', 'temperatura', 852.0000, 'ºC'),
	(165722, 118, '2014-02-01 00:16:52.000000', 'temperatura', 1113.0000, 'ºC'),
	(165723, 118, '2014-02-01 00:16:53.000000', 'temperatura', 612.0000, 'ºC'),
	(165724, 118, '2014-02-01 00:16:54.000000', 'temperatura', 922.0000, 'ºC'),
	(165725, 118, '2014-02-01 00:16:55.000000', 'temperatura', 373.0000, 'ºC'),
	(165726, 118, '2014-02-01 00:16:56.000000', 'temperatura', 302.0000, 'ºC'),
	(165727, 118, '2014-02-01 00:16:57.000000', 'temperatura', 390.0000, 'ºC'),
	(165728, 118, '2014-02-01 00:16:58.000000', 'temperatura', 1043.0000, 'ºC'),
	(165729, 118, '2014-02-01 00:16:59.000000', 'temperatura', 446.0000, 'ºC'),
	(165730, 118, '2014-02-01 00:17:00.000000', 'temperatura', 302.0000, 'ºC'),
	(165731, 118, '2014-02-01 00:17:01.000000', 'temperatura', 172.0000, 'ºC'),
	(165732, 118, '2014-02-01 00:17:02.000000', 'temperatura', 1154.0000, 'ºC'),
	(165733, 118, '2014-02-01 00:17:03.000000', 'temperatura', 457.0000, 'ºC'),
	(165734, 118, '2014-02-01 00:17:04.000000', 'temperatura', 21.0000, 'ºC'),
	(165735, 118, '2014-02-01 00:17:05.000000', 'temperatura', 1134.0000, 'ºC'),
	(165736, 118, '2014-02-01 00:17:06.000000', 'temperatura', 809.0000, 'ºC'),
	(165737, 118, '2014-02-01 00:17:07.000000', 'temperatura', 642.0000, 'ºC'),
	(165738, 118, '2014-02-01 00:17:08.000000', 'temperatura', 785.0000, 'ºC'),
	(165739, 118, '2014-02-01 00:17:09.000000', 'temperatura', 799.0000, 'ºC'),
	(165740, 118, '2014-02-01 00:17:10.000000', 'temperatura', 440.0000, 'ºC'),
	(165741, 118, '2014-02-01 00:17:11.000000', 'temperatura', 1004.0000, 'ºC'),
	(165742, 118, '2014-02-01 00:17:12.000000', 'temperatura', 100.0000, 'ºC'),
	(165743, 118, '2014-02-01 00:17:13.000000', 'temperatura', 1090.0000, 'ºC'),
	(165744, 118, '2014-02-01 00:17:14.000000', 'temperatura', 349.0000, 'ºC'),
	(165745, 118, '2014-02-01 00:17:15.000000', 'temperatura', 874.0000, 'ºC'),
	(165746, 118, '2014-02-01 00:17:16.000000', 'temperatura', 927.0000, 'ºC'),
	(165747, 118, '2014-02-01 00:17:17.000000', 'temperatura', 811.0000, 'ºC'),
	(165748, 118, '2014-02-01 00:17:18.000000', 'temperatura', 73.0000, 'ºC'),
	(165749, 118, '2014-02-01 00:17:19.000000', 'temperatura', 334.0000, 'ºC'),
	(165750, 118, '2014-02-01 00:17:20.000000', 'temperatura', 253.0000, 'ºC'),
	(165751, 118, '2014-02-01 00:17:21.000000', 'temperatura', 264.0000, 'ºC'),
	(165752, 118, '2014-02-01 00:17:22.000000', 'temperatura', 562.0000, 'ºC'),
	(165753, 118, '2014-02-01 00:17:23.000000', 'temperatura', 818.0000, 'ºC'),
	(165754, 118, '2014-02-01 00:17:24.000000', 'temperatura', 5.0000, 'ºC'),
	(165755, 118, '2014-02-01 00:17:25.000000', 'temperatura', 1169.0000, 'ºC'),
	(165756, 118, '2014-02-01 00:17:26.000000', 'temperatura', 1034.0000, 'ºC'),
	(165757, 118, '2014-02-01 00:17:27.000000', 'temperatura', 460.0000, 'ºC'),
	(165758, 118, '2014-02-01 00:17:28.000000', 'temperatura', 401.0000, 'ºC'),
	(165759, 118, '2014-02-01 00:17:29.000000', 'temperatura', 623.0000, 'ºC'),
	(165760, 118, '2014-02-01 00:17:30.000000', 'temperatura', 714.0000, 'ºC'),
	(165761, 118, '2014-02-01 00:17:31.000000', 'temperatura', 501.0000, 'ºC'),
	(165762, 118, '2014-02-01 00:17:32.000000', 'temperatura', 364.0000, 'ºC'),
	(165763, 118, '2014-02-01 00:17:33.000000', 'temperatura', 317.0000, 'ºC'),
	(165764, 118, '2014-02-01 00:17:34.000000', 'temperatura', 492.0000, 'ºC'),
	(165765, 118, '2014-02-01 00:17:35.000000', 'temperatura', 311.0000, 'ºC'),
	(165766, 118, '2014-02-01 00:17:36.000000', 'temperatura', 78.0000, 'ºC'),
	(165767, 118, '2014-02-01 00:17:37.000000', 'temperatura', 659.0000, 'ºC'),
	(165768, 118, '2014-02-01 00:17:38.000000', 'temperatura', 663.0000, 'ºC'),
	(165769, 118, '2014-02-01 00:17:39.000000', 'temperatura', 136.0000, 'ºC'),
	(165770, 118, '2014-02-01 00:17:40.000000', 'temperatura', 1091.0000, 'ºC'),
	(165771, 118, '2014-02-01 00:17:41.000000', 'temperatura', 248.0000, 'ºC'),
	(165772, 118, '2014-02-01 00:17:42.000000', 'temperatura', 369.0000, 'ºC'),
	(165773, 118, '2014-02-01 00:17:43.000000', 'temperatura', 1101.0000, 'ºC'),
	(165774, 118, '2014-02-01 00:17:44.000000', 'temperatura', 800.0000, 'ºC'),
	(165775, 118, '2014-02-01 00:17:45.000000', 'temperatura', 696.0000, 'ºC'),
	(165776, 118, '2014-02-01 00:17:46.000000', 'temperatura', 1080.0000, 'ºC'),
	(165777, 118, '2014-02-01 00:17:47.000000', 'temperatura', 914.0000, 'ºC'),
	(165778, 118, '2014-02-01 00:17:48.000000', 'temperatura', 131.0000, 'ºC'),
	(165779, 118, '2014-02-01 00:17:49.000000', 'temperatura', 314.0000, 'ºC'),
	(165780, 118, '2014-02-01 00:17:50.000000', 'temperatura', 1177.0000, 'ºC'),
	(165781, 118, '2014-02-01 00:17:51.000000', 'temperatura', 142.0000, 'ºC'),
	(165782, 118, '2014-02-01 00:17:52.000000', 'temperatura', 782.0000, 'ºC'),
	(165783, 118, '2014-02-01 00:17:53.000000', 'temperatura', 1084.0000, 'ºC'),
	(165784, 118, '2014-02-01 00:17:54.000000', 'temperatura', 674.0000, 'ºC'),
	(165785, 118, '2014-02-01 00:17:55.000000', 'temperatura', 117.0000, 'ºC'),
	(165786, 118, '2014-02-01 00:17:56.000000', 'temperatura', 965.0000, 'ºC'),
	(165787, 118, '2014-02-01 00:17:57.000000', 'temperatura', 872.0000, 'ºC'),
	(165788, 118, '2014-02-01 00:17:58.000000', 'temperatura', 268.0000, 'ºC'),
	(165789, 118, '2014-02-01 00:17:59.000000', 'temperatura', 1125.0000, 'ºC'),
	(165790, 118, '2014-02-01 00:18:00.000000', 'temperatura', 19.0000, 'ºC'),
	(165791, 118, '2014-02-01 00:18:01.000000', 'temperatura', 321.0000, 'ºC'),
	(165792, 118, '2014-02-01 00:18:02.000000', 'temperatura', 351.0000, 'ºC'),
	(165793, 118, '2014-02-01 00:18:03.000000', 'temperatura', 790.0000, 'ºC'),
	(165794, 118, '2014-02-01 00:18:04.000000', 'temperatura', 500.0000, 'ºC'),
	(165795, 118, '2014-02-01 00:18:05.000000', 'temperatura', 131.0000, 'ºC'),
	(165796, 118, '2014-02-01 00:18:06.000000', 'temperatura', 354.0000, 'ºC'),
	(165797, 118, '2014-02-01 00:18:07.000000', 'temperatura', 179.0000, 'ºC'),
	(165798, 118, '2014-02-01 00:18:08.000000', 'temperatura', 1032.0000, 'ºC'),
	(165799, 118, '2014-02-01 00:18:09.000000', 'temperatura', 1024.0000, 'ºC'),
	(165800, 118, '2014-02-01 00:18:10.000000', 'temperatura', 826.0000, 'ºC'),
	(165801, 118, '2014-02-01 00:18:11.000000', 'temperatura', 1059.0000, 'ºC'),
	(165802, 118, '2014-02-01 00:18:12.000000', 'temperatura', 418.0000, 'ºC'),
	(165803, 118, '2014-02-01 00:18:13.000000', 'temperatura', 114.0000, 'ºC'),
	(165804, 118, '2014-02-01 00:18:14.000000', 'temperatura', 517.0000, 'ºC'),
	(165805, 118, '2014-02-01 00:18:15.000000', 'temperatura', 1042.0000, 'ºC'),
	(165806, 118, '2014-02-01 00:18:16.000000', 'temperatura', 61.0000, 'ºC'),
	(165807, 118, '2014-02-01 00:18:17.000000', 'temperatura', 778.0000, 'ºC'),
	(165808, 118, '2014-02-01 00:18:18.000000', 'temperatura', 108.0000, 'ºC'),
	(165809, 118, '2014-02-01 00:18:19.000000', 'temperatura', 608.0000, 'ºC'),
	(165810, 118, '2014-02-01 00:18:20.000000', 'temperatura', 317.0000, 'ºC'),
	(165811, 118, '2014-02-01 00:18:21.000000', 'temperatura', 961.0000, 'ºC'),
	(165812, 118, '2014-02-01 00:18:22.000000', 'temperatura', 252.0000, 'ºC'),
	(165813, 118, '2014-02-01 00:18:23.000000', 'temperatura', 781.0000, 'ºC'),
	(165814, 118, '2014-02-01 00:18:24.000000', 'temperatura', 746.0000, 'ºC'),
	(165815, 118, '2014-02-01 00:18:25.000000', 'temperatura', 190.0000, 'ºC'),
	(165816, 118, '2014-02-01 00:18:26.000000', 'temperatura', 1113.0000, 'ºC'),
	(165817, 118, '2014-02-01 00:18:27.000000', 'temperatura', 194.0000, 'ºC'),
	(165818, 118, '2014-02-01 00:18:28.000000', 'temperatura', 32.0000, 'ºC'),
	(165819, 118, '2014-02-01 00:18:29.000000', 'temperatura', 777.0000, 'ºC'),
	(165820, 118, '2014-02-01 00:18:30.000000', 'temperatura', 191.0000, 'ºC'),
	(165821, 118, '2014-02-01 00:18:31.000000', 'temperatura', 1026.0000, 'ºC'),
	(165822, 118, '2014-02-01 00:18:32.000000', 'temperatura', 957.0000, 'ºC'),
	(165823, 118, '2014-02-01 00:18:33.000000', 'temperatura', 505.0000, 'ºC'),
	(165824, 118, '2014-02-01 00:18:34.000000', 'temperatura', 857.0000, 'ºC'),
	(165825, 118, '2014-02-01 00:18:35.000000', 'temperatura', 369.0000, 'ºC'),
	(165826, 118, '2014-02-01 00:18:36.000000', 'temperatura', 477.0000, 'ºC'),
	(165827, 118, '2014-02-01 00:18:37.000000', 'temperatura', 76.0000, 'ºC'),
	(165828, 118, '2014-02-01 00:18:38.000000', 'temperatura', 149.0000, 'ºC'),
	(165829, 118, '2014-02-01 00:18:39.000000', 'temperatura', 518.0000, 'ºC'),
	(165830, 118, '2014-02-01 00:18:40.000000', 'temperatura', 944.0000, 'ºC'),
	(165831, 118, '2014-02-01 00:18:41.000000', 'temperatura', 768.0000, 'ºC'),
	(165832, 118, '2014-02-01 00:18:42.000000', 'temperatura', 1009.0000, 'ºC'),
	(165833, 118, '2014-02-01 00:18:43.000000', 'temperatura', 341.0000, 'ºC'),
	(165834, 118, '2014-02-01 00:18:44.000000', 'temperatura', 1076.0000, 'ºC'),
	(165835, 118, '2014-02-01 00:18:45.000000', 'temperatura', 761.0000, 'ºC'),
	(165836, 118, '2014-02-01 00:18:46.000000', 'temperatura', 575.0000, 'ºC'),
	(165837, 118, '2014-02-01 00:18:47.000000', 'temperatura', 593.0000, 'ºC'),
	(165838, 118, '2014-02-01 00:18:48.000000', 'temperatura', 41.0000, 'ºC'),
	(165839, 118, '2014-02-01 00:18:49.000000', 'temperatura', 827.0000, 'ºC'),
	(165840, 118, '2014-02-01 00:18:50.000000', 'temperatura', 412.0000, 'ºC'),
	(165841, 118, '2014-02-01 00:18:51.000000', 'temperatura', 779.0000, 'ºC'),
	(165842, 118, '2014-02-01 00:18:52.000000', 'temperatura', 258.0000, 'ºC'),
	(165843, 118, '2014-02-01 00:18:53.000000', 'temperatura', 154.0000, 'ºC'),
	(165844, 118, '2014-02-01 00:18:54.000000', 'temperatura', 1199.0000, 'ºC'),
	(165845, 118, '2014-02-01 00:18:55.000000', 'temperatura', 730.0000, 'ºC'),
	(165846, 118, '2014-02-01 00:18:56.000000', 'temperatura', 55.0000, 'ºC'),
	(165847, 118, '2014-02-01 00:18:57.000000', 'temperatura', 487.0000, 'ºC'),
	(165848, 118, '2014-02-01 00:18:58.000000', 'temperatura', 1068.0000, 'ºC'),
	(165849, 118, '2014-02-01 00:18:59.000000', 'temperatura', 282.0000, 'ºC'),
	(165850, 118, '2014-02-01 00:19:00.000000', 'temperatura', 604.0000, 'ºC'),
	(165851, 118, '2014-02-01 00:19:01.000000', 'temperatura', 976.0000, 'ºC'),
	(165852, 118, '2014-02-01 00:19:02.000000', 'temperatura', 667.0000, 'ºC'),
	(165853, 118, '2014-02-01 00:19:03.000000', 'temperatura', 410.0000, 'ºC'),
	(165854, 118, '2014-02-01 00:19:04.000000', 'temperatura', 47.0000, 'ºC'),
	(165855, 118, '2014-02-01 00:19:05.000000', 'temperatura', 205.0000, 'ºC'),
	(165856, 118, '2014-02-01 00:19:06.000000', 'temperatura', 885.0000, 'ºC'),
	(165857, 118, '2014-02-01 00:19:07.000000', 'temperatura', 213.0000, 'ºC'),
	(165858, 118, '2014-02-01 00:19:08.000000', 'temperatura', 808.0000, 'ºC'),
	(165859, 118, '2014-02-01 00:19:09.000000', 'temperatura', 1001.0000, 'ºC'),
	(165860, 118, '2014-02-01 00:19:10.000000', 'temperatura', 183.0000, 'ºC'),
	(165861, 118, '2014-02-01 00:19:11.000000', 'temperatura', 314.0000, 'ºC'),
	(165862, 118, '2014-02-01 00:19:12.000000', 'temperatura', 1020.0000, 'ºC'),
	(165863, 118, '2014-02-01 00:19:13.000000', 'temperatura', 557.0000, 'ºC'),
	(165864, 118, '2014-02-01 00:19:14.000000', 'temperatura', 926.0000, 'ºC'),
	(165865, 118, '2014-02-01 00:19:15.000000', 'temperatura', 558.0000, 'ºC'),
	(165866, 118, '2014-02-01 00:19:16.000000', 'temperatura', 13.0000, 'ºC'),
	(165867, 118, '2014-02-01 00:19:17.000000', 'temperatura', 793.0000, 'ºC'),
	(165868, 118, '2014-02-01 00:19:18.000000', 'temperatura', 326.0000, 'ºC'),
	(165869, 118, '2014-02-01 00:19:19.000000', 'temperatura', 450.0000, 'ºC'),
	(165870, 118, '2014-02-01 00:19:20.000000', 'temperatura', 75.0000, 'ºC'),
	(165871, 118, '2014-02-01 00:19:21.000000', 'temperatura', 225.0000, 'ºC'),
	(165872, 118, '2014-02-01 00:19:22.000000', 'temperatura', 901.0000, 'ºC'),
	(165873, 118, '2014-02-01 00:19:23.000000', 'temperatura', 230.0000, 'ºC'),
	(165874, 118, '2014-02-01 00:19:24.000000', 'temperatura', 847.0000, 'ºC'),
	(165875, 118, '2014-02-01 00:19:25.000000', 'temperatura', 1147.0000, 'ºC'),
	(165876, 118, '2014-02-01 00:19:26.000000', 'temperatura', 792.0000, 'ºC'),
	(165877, 118, '2014-02-01 00:19:27.000000', 'temperatura', 523.0000, 'ºC'),
	(165878, 118, '2014-02-01 00:19:28.000000', 'temperatura', 237.0000, 'ºC'),
	(165879, 118, '2014-02-01 00:19:29.000000', 'temperatura', 817.0000, 'ºC'),
	(165880, 118, '2014-02-01 00:19:30.000000', 'temperatura', 975.0000, 'ºC'),
	(165881, 118, '2014-02-01 00:19:31.000000', 'temperatura', 24.0000, 'ºC'),
	(165882, 118, '2014-02-01 00:19:32.000000', 'temperatura', 796.0000, 'ºC'),
	(165883, 118, '2014-02-01 00:19:33.000000', 'temperatura', 306.0000, 'ºC'),
	(165884, 118, '2014-02-01 00:19:34.000000', 'temperatura', 346.0000, 'ºC'),
	(165885, 118, '2014-02-01 00:19:35.000000', 'temperatura', 811.0000, 'ºC'),
	(165886, 118, '2014-02-01 00:19:36.000000', 'temperatura', 617.0000, 'ºC'),
	(165887, 118, '2014-02-01 00:19:37.000000', 'temperatura', 654.0000, 'ºC'),
	(165888, 118, '2014-02-01 00:19:38.000000', 'temperatura', 219.0000, 'ºC'),
	(165889, 118, '2014-02-01 00:19:39.000000', 'temperatura', 334.0000, 'ºC'),
	(165890, 118, '2014-02-01 00:19:40.000000', 'temperatura', 1013.0000, 'ºC'),
	(165891, 118, '2014-02-01 00:19:41.000000', 'temperatura', 462.0000, 'ºC'),
	(165892, 118, '2014-02-01 00:19:42.000000', 'temperatura', 473.0000, 'ºC'),
	(165893, 118, '2014-02-01 00:19:43.000000', 'temperatura', 980.0000, 'ºC'),
	(165894, 118, '2014-02-01 00:19:44.000000', 'temperatura', 1081.0000, 'ºC'),
	(165895, 118, '2014-02-01 00:19:45.000000', 'temperatura', 67.0000, 'ºC'),
	(165896, 118, '2014-02-01 00:19:46.000000', 'temperatura', 691.0000, 'ºC'),
	(165897, 118, '2014-02-01 00:19:47.000000', 'temperatura', 855.0000, 'ºC'),
	(165898, 118, '2014-02-01 00:19:48.000000', 'temperatura', 1001.0000, 'ºC'),
	(165899, 118, '2014-02-01 00:19:49.000000', 'temperatura', 44.0000, 'ºC'),
	(165900, 118, '2014-02-01 00:19:50.000000', 'temperatura', 814.0000, 'ºC'),
	(165901, 118, '2014-02-01 00:19:51.000000', 'temperatura', 338.0000, 'ºC'),
	(165902, 118, '2014-02-01 00:19:52.000000', 'temperatura', 452.0000, 'ºC'),
	(165903, 118, '2014-02-01 00:19:53.000000', 'temperatura', 43.0000, 'ºC'),
	(165904, 118, '2014-02-01 00:19:54.000000', 'temperatura', 60.0000, 'ºC'),
	(165905, 118, '2014-02-01 00:19:55.000000', 'temperatura', 173.0000, 'ºC'),
	(165906, 118, '2014-02-01 00:19:56.000000', 'temperatura', 683.0000, 'ºC'),
	(165907, 118, '2014-02-01 00:19:57.000000', 'temperatura', 498.0000, 'ºC'),
	(165908, 118, '2014-02-01 00:19:58.000000', 'temperatura', 441.0000, 'ºC'),
	(165909, 118, '2014-02-01 00:19:59.000000', 'temperatura', 713.0000, 'ºC'),
	(165910, 118, '2014-02-01 00:20:00.000000', 'temperatura', 1040.0000, 'ºC'),
	(165911, 118, '2014-02-01 00:20:01.000000', 'temperatura', 663.0000, 'ºC'),
	(165912, 118, '2014-02-01 00:20:02.000000', 'temperatura', 194.0000, 'ºC'),
	(165913, 118, '2014-02-01 00:20:03.000000', 'temperatura', 183.0000, 'ºC'),
	(165914, 118, '2014-02-01 00:20:04.000000', 'temperatura', 333.0000, 'ºC'),
	(165915, 118, '2014-02-01 00:20:05.000000', 'temperatura', 1118.0000, 'ºC'),
	(165916, 118, '2014-02-01 00:20:06.000000', 'temperatura', 990.0000, 'ºC'),
	(165917, 118, '2014-02-01 00:20:07.000000', 'temperatura', 395.0000, 'ºC'),
	(165918, 118, '2014-02-01 00:20:08.000000', 'temperatura', 208.0000, 'ºC'),
	(165919, 118, '2014-02-01 00:20:09.000000', 'temperatura', 1053.0000, 'ºC'),
	(165920, 118, '2014-02-01 00:20:10.000000', 'temperatura', 1044.0000, 'ºC'),
	(165921, 118, '2014-02-01 00:20:11.000000', 'temperatura', 862.0000, 'ºC'),
	(165922, 118, '2014-02-01 00:20:12.000000', 'temperatura', 1179.0000, 'ºC'),
	(165923, 118, '2014-02-01 00:20:13.000000', 'temperatura', 907.0000, 'ºC'),
	(165924, 118, '2014-02-01 00:20:14.000000', 'temperatura', 998.0000, 'ºC'),
	(165925, 118, '2014-02-01 00:20:15.000000', 'temperatura', 1070.0000, 'ºC'),
	(165926, 118, '2014-02-01 00:20:16.000000', 'temperatura', 1158.0000, 'ºC'),
	(165927, 118, '2014-02-01 00:20:17.000000', 'temperatura', 181.0000, 'ºC'),
	(165928, 118, '2014-02-01 00:20:18.000000', 'temperatura', 1029.0000, 'ºC'),
	(165929, 118, '2014-02-01 00:20:19.000000', 'temperatura', 1005.0000, 'ºC'),
	(165930, 118, '2014-02-01 00:20:20.000000', 'temperatura', 737.0000, 'ºC'),
	(165931, 118, '2014-02-01 00:20:21.000000', 'temperatura', 672.0000, 'ºC'),
	(165932, 118, '2014-02-01 00:20:22.000000', 'temperatura', 1150.0000, 'ºC'),
	(165933, 118, '2014-02-01 00:20:23.000000', 'temperatura', 132.0000, 'ºC'),
	(165934, 118, '2014-02-01 00:20:24.000000', 'temperatura', 810.0000, 'ºC'),
	(165935, 118, '2014-02-01 00:20:25.000000', 'temperatura', 57.0000, 'ºC'),
	(165936, 118, '2014-02-01 00:20:26.000000', 'temperatura', 254.0000, 'ºC'),
	(165937, 118, '2014-02-01 00:20:27.000000', 'temperatura', 1100.0000, 'ºC'),
	(165938, 118, '2014-02-01 00:20:28.000000', 'temperatura', 1139.0000, 'ºC'),
	(165939, 118, '2014-02-01 00:20:29.000000', 'temperatura', 1197.0000, 'ºC'),
	(165940, 118, '2014-02-01 00:20:30.000000', 'temperatura', 166.0000, 'ºC'),
	(165941, 118, '2014-02-01 00:20:31.000000', 'temperatura', 842.0000, 'ºC'),
	(165942, 118, '2014-02-01 00:20:32.000000', 'temperatura', 111.0000, 'ºC'),
	(165943, 118, '2014-02-01 00:20:33.000000', 'temperatura', 431.0000, 'ºC'),
	(165944, 118, '2014-02-01 00:20:34.000000', 'temperatura', 622.0000, 'ºC'),
	(165945, 118, '2014-02-01 00:20:35.000000', 'temperatura', 617.0000, 'ºC'),
	(165946, 118, '2014-02-01 00:20:36.000000', 'temperatura', 22.0000, 'ºC'),
	(165947, 118, '2014-02-01 00:20:37.000000', 'temperatura', 656.0000, 'ºC'),
	(165948, 118, '2014-02-01 00:20:38.000000', 'temperatura', 815.0000, 'ºC'),
	(165949, 118, '2014-02-01 00:20:39.000000', 'temperatura', 909.0000, 'ºC'),
	(165950, 118, '2014-02-01 00:20:40.000000', 'temperatura', 899.0000, 'ºC'),
	(165951, 118, '2014-02-01 00:20:41.000000', 'temperatura', 569.0000, 'ºC'),
	(165952, 118, '2014-02-01 00:20:42.000000', 'temperatura', 149.0000, 'ºC'),
	(165953, 118, '2014-02-01 00:20:43.000000', 'temperatura', 239.0000, 'ºC'),
	(165954, 118, '2014-02-01 00:20:44.000000', 'temperatura', 746.0000, 'ºC'),
	(165955, 118, '2014-02-01 00:20:45.000000', 'temperatura', 615.0000, 'ºC'),
	(165956, 118, '2014-02-01 00:20:46.000000', 'temperatura', 836.0000, 'ºC'),
	(165957, 118, '2014-02-01 00:20:47.000000', 'temperatura', 1138.0000, 'ºC'),
	(165958, 118, '2014-02-01 00:20:48.000000', 'temperatura', 782.0000, 'ºC'),
	(165959, 118, '2014-02-01 00:20:49.000000', 'temperatura', 496.0000, 'ºC'),
	(165960, 118, '2014-02-01 00:20:50.000000', 'temperatura', 134.0000, 'ºC'),
	(165961, 118, '2014-02-01 00:20:51.000000', 'temperatura', 383.0000, 'ºC'),
	(165962, 118, '2014-02-01 00:20:52.000000', 'temperatura', 315.0000, 'ºC'),
	(165963, 118, '2014-02-01 00:20:53.000000', 'temperatura', 425.0000, 'ºC'),
	(165964, 118, '2014-02-01 00:20:54.000000', 'temperatura', 1180.0000, 'ºC'),
	(165965, 118, '2014-02-01 00:20:55.000000', 'temperatura', 1026.0000, 'ºC'),
	(165966, 118, '2014-02-01 00:20:56.000000', 'temperatura', 391.0000, 'ºC'),
	(165967, 118, '2014-02-01 00:20:57.000000', 'temperatura', 78.0000, 'ºC'),
	(165968, 118, '2014-02-01 00:20:58.000000', 'temperatura', 418.0000, 'ºC'),
	(165969, 118, '2014-02-01 00:20:59.000000', 'temperatura', 656.0000, 'ºC'),
	(165970, 118, '2014-02-01 00:21:00.000000', 'temperatura', 824.0000, 'ºC'),
	(165971, 118, '2014-02-01 00:21:01.000000', 'temperatura', 955.0000, 'ºC'),
	(165972, 118, '2014-02-01 00:21:02.000000', 'temperatura', 1103.0000, 'ºC'),
	(165973, 118, '2014-02-01 00:21:03.000000', 'temperatura', 251.0000, 'ºC'),
	(165974, 118, '2014-02-01 00:21:04.000000', 'temperatura', 347.0000, 'ºC'),
	(165975, 118, '2014-02-01 00:21:05.000000', 'temperatura', 980.0000, 'ºC'),
	(165976, 118, '2014-02-01 00:21:06.000000', 'temperatura', 261.0000, 'ºC'),
	(165977, 118, '2014-02-01 00:21:07.000000', 'temperatura', 767.0000, 'ºC'),
	(165978, 118, '2014-02-01 00:21:08.000000', 'temperatura', 653.0000, 'ºC'),
	(165979, 118, '2014-02-01 00:21:09.000000', 'temperatura', 965.0000, 'ºC'),
	(165980, 118, '2014-02-01 00:21:10.000000', 'temperatura', 466.0000, 'ºC'),
	(165981, 118, '2014-02-01 00:21:11.000000', 'temperatura', 635.0000, 'ºC'),
	(165982, 118, '2014-02-01 00:21:12.000000', 'temperatura', 577.0000, 'ºC'),
	(165983, 118, '2014-02-01 00:21:13.000000', 'temperatura', 982.0000, 'ºC'),
	(165984, 118, '2014-02-01 00:21:14.000000', 'temperatura', 780.0000, 'ºC'),
	(165985, 118, '2014-02-01 00:21:15.000000', 'temperatura', 954.0000, 'ºC'),
	(165986, 118, '2014-02-01 00:21:16.000000', 'temperatura', 32.0000, 'ºC'),
	(165987, 118, '2014-02-01 00:21:17.000000', 'temperatura', 896.0000, 'ºC'),
	(165988, 118, '2014-02-01 00:21:18.000000', 'temperatura', 787.0000, 'ºC'),
	(165989, 118, '2014-02-01 00:21:19.000000', 'temperatura', 48.0000, 'ºC'),
	(165990, 118, '2014-02-01 00:21:20.000000', 'temperatura', 277.0000, 'ºC'),
	(165991, 118, '2014-02-01 00:21:21.000000', 'temperatura', 42.0000, 'ºC'),
	(165992, 118, '2014-02-01 00:21:22.000000', 'temperatura', 580.0000, 'ºC'),
	(165993, 118, '2014-02-01 00:21:23.000000', 'temperatura', 373.0000, 'ºC'),
	(165994, 118, '2014-02-01 00:21:24.000000', 'temperatura', 126.0000, 'ºC'),
	(165995, 118, '2014-02-01 00:21:25.000000', 'temperatura', 711.0000, 'ºC'),
	(165996, 118, '2014-02-01 00:21:26.000000', 'temperatura', 780.0000, 'ºC'),
	(165997, 118, '2014-02-01 00:21:27.000000', 'temperatura', 567.0000, 'ºC'),
	(165998, 118, '2014-02-01 00:21:28.000000', 'temperatura', 494.0000, 'ºC'),
	(165999, 118, '2014-02-01 00:21:29.000000', 'temperatura', 771.0000, 'ºC'),
	(166000, 118, '2014-02-01 00:21:30.000000', 'temperatura', 1171.0000, 'ºC'),
	(166001, 118, '2014-02-01 00:21:31.000000', 'temperatura', 1143.0000, 'ºC'),
	(166002, 118, '2014-02-01 00:21:32.000000', 'temperatura', 1005.0000, 'ºC'),
	(166003, 118, '2014-02-01 00:21:33.000000', 'temperatura', 394.0000, 'ºC'),
	(166004, 118, '2014-02-01 00:21:34.000000', 'temperatura', 155.0000, 'ºC'),
	(166005, 118, '2014-02-01 00:21:35.000000', 'temperatura', 794.0000, 'ºC'),
	(166006, 118, '2014-02-01 00:21:36.000000', 'temperatura', 1106.0000, 'ºC'),
	(166007, 118, '2014-02-01 00:21:37.000000', 'temperatura', 747.0000, 'ºC'),
	(166008, 118, '2014-02-01 00:21:38.000000', 'temperatura', 417.0000, 'ºC'),
	(166009, 118, '2014-02-01 00:21:39.000000', 'temperatura', 1045.0000, 'ºC'),
	(166010, 118, '2014-02-01 00:21:40.000000', 'temperatura', 373.0000, 'ºC'),
	(166011, 118, '2014-02-01 00:21:41.000000', 'temperatura', 1134.0000, 'ºC'),
	(166012, 118, '2014-02-01 00:21:42.000000', 'temperatura', 949.0000, 'ºC'),
	(166013, 118, '2014-02-01 00:21:43.000000', 'temperatura', 142.0000, 'ºC'),
	(166014, 118, '2014-02-01 00:21:44.000000', 'temperatura', 266.0000, 'ºC'),
	(166015, 118, '2014-02-01 00:21:45.000000', 'temperatura', 903.0000, 'ºC'),
	(166016, 118, '2014-02-01 00:21:46.000000', 'temperatura', 120.0000, 'ºC'),
	(166017, 118, '2014-02-01 00:21:47.000000', 'temperatura', 289.0000, 'ºC'),
	(166018, 118, '2014-02-01 00:21:48.000000', 'temperatura', 1086.0000, 'ºC'),
	(166019, 118, '2014-02-01 00:21:49.000000', 'temperatura', 966.0000, 'ºC'),
	(166020, 118, '2014-02-01 00:21:50.000000', 'temperatura', 370.0000, 'ºC'),
	(166021, 118, '2014-02-01 00:21:51.000000', 'temperatura', 153.0000, 'ºC'),
	(166022, 118, '2014-02-01 00:21:52.000000', 'temperatura', 858.0000, 'ºC'),
	(166023, 118, '2014-02-01 00:21:53.000000', 'temperatura', 228.0000, 'ºC'),
	(166024, 118, '2014-02-01 00:21:54.000000', 'temperatura', 967.0000, 'ºC'),
	(166025, 118, '2014-02-01 00:21:55.000000', 'temperatura', 554.0000, 'ºC'),
	(166026, 118, '2014-02-01 00:21:56.000000', 'temperatura', 1068.0000, 'ºC'),
	(166027, 118, '2014-02-01 00:21:57.000000', 'temperatura', 78.0000, 'ºC'),
	(166028, 118, '2014-02-01 00:21:58.000000', 'temperatura', 785.0000, 'ºC'),
	(166029, 118, '2014-02-01 00:21:59.000000', 'temperatura', 93.0000, 'ºC'),
	(166030, 118, '2014-02-01 00:22:00.000000', 'temperatura', 509.0000, 'ºC'),
	(166031, 118, '2014-02-01 00:22:01.000000', 'temperatura', 1069.0000, 'ºC'),
	(166032, 118, '2014-02-01 00:22:02.000000', 'temperatura', 216.0000, 'ºC'),
	(166033, 118, '2014-02-01 00:22:03.000000', 'temperatura', 275.0000, 'ºC'),
	(166034, 118, '2014-02-01 00:22:04.000000', 'temperatura', 729.0000, 'ºC'),
	(166035, 118, '2014-02-01 00:22:05.000000', 'temperatura', 418.0000, 'ºC'),
	(166036, 118, '2014-02-01 00:22:06.000000', 'temperatura', 1106.0000, 'ºC'),
	(166037, 118, '2014-02-01 00:22:07.000000', 'temperatura', 677.0000, 'ºC'),
	(166038, 118, '2014-02-01 00:22:08.000000', 'temperatura', 65.0000, 'ºC'),
	(166039, 118, '2014-02-01 00:22:09.000000', 'temperatura', 697.0000, 'ºC'),
	(166040, 118, '2014-02-01 00:22:10.000000', 'temperatura', 890.0000, 'ºC'),
	(166041, 118, '2014-02-01 00:22:11.000000', 'temperatura', 1157.0000, 'ºC'),
	(166042, 118, '2014-02-01 00:22:12.000000', 'temperatura', 717.0000, 'ºC'),
	(166043, 118, '2014-02-01 00:22:13.000000', 'temperatura', 114.0000, 'ºC'),
	(166044, 118, '2014-02-01 00:22:14.000000', 'temperatura', 818.0000, 'ºC'),
	(166045, 118, '2014-02-01 00:22:15.000000', 'temperatura', 151.0000, 'ºC'),
	(166046, 118, '2014-02-01 00:22:16.000000', 'temperatura', 701.0000, 'ºC'),
	(166047, 118, '2014-02-01 00:22:17.000000', 'temperatura', 652.0000, 'ºC'),
	(166048, 118, '2014-02-01 00:22:18.000000', 'temperatura', 1156.0000, 'ºC'),
	(166049, 118, '2014-02-01 00:22:19.000000', 'temperatura', 227.0000, 'ºC'),
	(166050, 118, '2014-02-01 00:22:20.000000', 'temperatura', 67.0000, 'ºC'),
	(166051, 118, '2014-02-01 00:22:21.000000', 'temperatura', 853.0000, 'ºC'),
	(166052, 118, '2014-02-01 00:22:22.000000', 'temperatura', 465.0000, 'ºC'),
	(166053, 118, '2014-02-01 00:22:23.000000', 'temperatura', 967.0000, 'ºC'),
	(166054, 118, '2014-02-01 00:22:24.000000', 'temperatura', 1039.0000, 'ºC'),
	(166055, 118, '2014-02-01 00:22:25.000000', 'temperatura', 1094.0000, 'ºC'),
	(166056, 118, '2014-02-01 00:22:26.000000', 'temperatura', 1153.0000, 'ºC'),
	(166057, 118, '2014-02-01 00:22:27.000000', 'temperatura', 84.0000, 'ºC'),
	(166058, 118, '2014-02-01 00:22:28.000000', 'temperatura', 562.0000, 'ºC'),
	(166059, 118, '2014-02-01 00:22:29.000000', 'temperatura', 159.0000, 'ºC'),
	(166060, 118, '2014-02-01 00:22:30.000000', 'temperatura', 308.0000, 'ºC'),
	(166061, 118, '2014-02-01 00:22:31.000000', 'temperatura', 1066.0000, 'ºC'),
	(166062, 118, '2014-02-01 00:22:32.000000', 'temperatura', 804.0000, 'ºC'),
	(166063, 118, '2014-02-01 00:22:33.000000', 'temperatura', 822.0000, 'ºC'),
	(166064, 118, '2014-02-01 00:22:34.000000', 'temperatura', 497.0000, 'ºC'),
	(166065, 118, '2014-02-01 00:22:35.000000', 'temperatura', 23.0000, 'ºC'),
	(166066, 118, '2014-02-01 00:22:36.000000', 'temperatura', 1023.0000, 'ºC'),
	(166067, 118, '2014-02-01 00:22:37.000000', 'temperatura', 247.0000, 'ºC'),
	(166068, 118, '2014-02-01 00:22:38.000000', 'temperatura', 565.0000, 'ºC'),
	(166069, 118, '2014-02-01 00:22:39.000000', 'temperatura', 885.0000, 'ºC'),
	(166070, 118, '2014-02-01 00:22:40.000000', 'temperatura', 329.0000, 'ºC'),
	(166071, 118, '2014-02-01 00:22:41.000000', 'temperatura', 193.0000, 'ºC'),
	(166072, 118, '2014-02-01 00:22:42.000000', 'temperatura', 1176.0000, 'ºC'),
	(166073, 118, '2014-02-01 00:22:43.000000', 'temperatura', 502.0000, 'ºC'),
	(166074, 118, '2014-02-01 00:22:44.000000', 'temperatura', 181.0000, 'ºC'),
	(166075, 118, '2014-02-01 00:22:45.000000', 'temperatura', 602.0000, 'ºC'),
	(166076, 118, '2014-02-01 00:22:46.000000', 'temperatura', 68.0000, 'ºC'),
	(166077, 118, '2014-02-01 00:22:47.000000', 'temperatura', 934.0000, 'ºC'),
	(166078, 118, '2014-02-01 00:22:48.000000', 'temperatura', 865.0000, 'ºC'),
	(166079, 118, '2014-02-01 00:22:49.000000', 'temperatura', 325.0000, 'ºC'),
	(166080, 118, '2014-02-01 00:22:50.000000', 'temperatura', 231.0000, 'ºC'),
	(166081, 118, '2014-02-01 00:22:51.000000', 'temperatura', 178.0000, 'ºC'),
	(166082, 118, '2014-02-01 00:22:52.000000', 'temperatura', 198.0000, 'ºC'),
	(166083, 118, '2014-02-01 00:22:53.000000', 'temperatura', 456.0000, 'ºC'),
	(166084, 118, '2014-02-01 00:22:54.000000', 'temperatura', 485.0000, 'ºC'),
	(166085, 118, '2014-02-01 00:22:55.000000', 'temperatura', 1060.0000, 'ºC'),
	(166086, 118, '2014-02-01 00:22:56.000000', 'temperatura', 245.0000, 'ºC'),
	(166087, 118, '2014-02-01 00:22:57.000000', 'temperatura', 444.0000, 'ºC'),
	(166088, 118, '2014-02-01 00:22:58.000000', 'temperatura', 288.0000, 'ºC'),
	(166089, 118, '2014-02-01 00:22:59.000000', 'temperatura', 108.0000, 'ºC'),
	(166090, 118, '2014-02-01 00:23:00.000000', 'temperatura', 878.0000, 'ºC'),
	(166091, 118, '2014-02-01 00:23:01.000000', 'temperatura', 464.0000, 'ºC'),
	(166092, 118, '2014-02-01 00:23:02.000000', 'temperatura', 886.0000, 'ºC'),
	(166093, 118, '2014-02-01 00:23:03.000000', 'temperatura', 641.0000, 'ºC'),
	(166094, 118, '2014-02-01 00:23:04.000000', 'temperatura', 544.0000, 'ºC'),
	(166095, 118, '2014-02-01 00:23:05.000000', 'temperatura', 800.0000, 'ºC'),
	(166096, 118, '2014-02-01 00:23:06.000000', 'temperatura', 1170.0000, 'ºC'),
	(166097, 118, '2014-02-01 00:23:07.000000', 'temperatura', 1048.0000, 'ºC'),
	(166098, 118, '2014-02-01 00:23:08.000000', 'temperatura', 530.0000, 'ºC'),
	(166099, 118, '2014-02-01 00:23:09.000000', 'temperatura', 707.0000, 'ºC'),
	(166100, 118, '2014-02-01 00:23:10.000000', 'temperatura', 745.0000, 'ºC'),
	(166101, 118, '2014-02-01 00:23:11.000000', 'temperatura', 404.0000, 'ºC'),
	(166102, 118, '2014-02-01 00:23:12.000000', 'temperatura', 985.0000, 'ºC'),
	(166103, 118, '2014-02-01 00:23:13.000000', 'temperatura', 115.0000, 'ºC'),
	(166104, 118, '2014-02-01 00:23:14.000000', 'temperatura', 19.0000, 'ºC'),
	(166105, 118, '2014-02-01 00:23:15.000000', 'temperatura', 950.0000, 'ºC'),
	(166106, 118, '2014-02-01 00:23:16.000000', 'temperatura', 1095.0000, 'ºC'),
	(166107, 118, '2014-02-01 00:23:17.000000', 'temperatura', 226.0000, 'ºC'),
	(166108, 118, '2014-02-01 00:23:18.000000', 'temperatura', 245.0000, 'ºC'),
	(166109, 118, '2014-02-01 00:23:19.000000', 'temperatura', 549.0000, 'ºC'),
	(166110, 118, '2014-02-01 00:23:20.000000', 'temperatura', 809.0000, 'ºC'),
	(166111, 118, '2014-02-01 00:23:21.000000', 'temperatura', 1198.0000, 'ºC'),
	(166112, 118, '2014-02-01 00:23:22.000000', 'temperatura', 1163.0000, 'ºC'),
	(166113, 118, '2014-02-01 00:23:23.000000', 'temperatura', 1023.0000, 'ºC'),
	(166114, 118, '2014-02-01 00:23:24.000000', 'temperatura', 426.0000, 'ºC'),
	(166115, 118, '2014-02-01 00:23:25.000000', 'temperatura', 263.0000, 'ºC'),
	(166116, 118, '2014-02-01 00:23:26.000000', 'temperatura', 35.0000, 'ºC'),
	(166117, 118, '2014-02-01 00:23:27.000000', 'temperatura', 588.0000, 'ºC'),
	(166118, 118, '2014-02-01 00:23:28.000000', 'temperatura', 436.0000, 'ºC'),
	(166119, 118, '2014-02-01 00:23:29.000000', 'temperatura', 415.0000, 'ºC'),
	(166120, 118, '2014-02-01 00:23:30.000000', 'temperatura', 770.0000, 'ºC'),
	(166121, 118, '2014-02-01 00:23:31.000000', 'temperatura', 203.0000, 'ºC'),
	(166122, 118, '2014-02-01 00:23:32.000000', 'temperatura', 1108.0000, 'ºC'),
	(166123, 118, '2014-02-01 00:23:33.000000', 'temperatura', 131.0000, 'ºC'),
	(166124, 118, '2014-02-01 00:23:34.000000', 'temperatura', 932.0000, 'ºC'),
	(166125, 118, '2014-02-01 00:23:35.000000', 'temperatura', 667.0000, 'ºC'),
	(166126, 118, '2014-02-01 00:23:36.000000', 'temperatura', 541.0000, 'ºC'),
	(166127, 118, '2014-02-01 00:23:37.000000', 'temperatura', 702.0000, 'ºC'),
	(166128, 118, '2014-02-01 00:23:38.000000', 'temperatura', 690.0000, 'ºC'),
	(166129, 118, '2014-02-01 00:23:39.000000', 'temperatura', 143.0000, 'ºC'),
	(166130, 118, '2014-02-01 00:23:40.000000', 'temperatura', 1044.0000, 'ºC'),
	(166131, 118, '2014-02-01 00:23:41.000000', 'temperatura', 1192.0000, 'ºC'),
	(166132, 118, '2014-02-01 00:23:42.000000', 'temperatura', 428.0000, 'ºC'),
	(166133, 118, '2014-02-01 00:23:43.000000', 'temperatura', 967.0000, 'ºC'),
	(166134, 118, '2014-02-01 00:23:44.000000', 'temperatura', 1152.0000, 'ºC'),
	(166135, 118, '2014-02-01 00:23:45.000000', 'temperatura', 457.0000, 'ºC'),
	(166136, 118, '2014-02-01 00:23:46.000000', 'temperatura', 31.0000, 'ºC'),
	(166137, 118, '2014-02-01 00:23:47.000000', 'temperatura', 1185.0000, 'ºC'),
	(166138, 118, '2014-02-01 00:23:48.000000', 'temperatura', 1031.0000, 'ºC'),
	(166139, 118, '2014-02-01 00:23:49.000000', 'temperatura', 401.0000, 'ºC'),
	(166140, 118, '2014-02-01 00:23:50.000000', 'temperatura', 114.0000, 'ºC'),
	(166141, 118, '2014-02-01 00:23:51.000000', 'temperatura', 569.0000, 'ºC'),
	(166142, 118, '2014-02-01 00:23:52.000000', 'temperatura', 100.0000, 'ºC'),
	(166143, 118, '2014-02-01 00:23:53.000000', 'temperatura', 1195.0000, 'ºC'),
	(166144, 118, '2014-02-01 00:23:54.000000', 'temperatura', 874.0000, 'ºC'),
	(166145, 118, '2014-02-01 00:23:55.000000', 'temperatura', 787.0000, 'ºC'),
	(166146, 118, '2014-02-01 00:23:56.000000', 'temperatura', 115.0000, 'ºC'),
	(166147, 118, '2014-02-01 00:23:57.000000', 'temperatura', 614.0000, 'ºC'),
	(166148, 118, '2014-02-01 00:23:58.000000', 'temperatura', 325.0000, 'ºC'),
	(166149, 118, '2014-02-01 00:23:59.000000', 'temperatura', 985.0000, 'ºC'),
	(166150, 118, '2014-02-01 00:24:00.000000', 'temperatura', 348.0000, 'ºC'),
	(166151, 118, '2014-02-01 00:24:01.000000', 'temperatura', 1187.0000, 'ºC'),
	(166152, 118, '2014-02-01 00:24:02.000000', 'temperatura', 92.0000, 'ºC'),
	(166153, 118, '2014-02-01 00:24:03.000000', 'temperatura', 498.0000, 'ºC'),
	(166154, 118, '2014-02-01 00:24:04.000000', 'temperatura', 1016.0000, 'ºC'),
	(166155, 118, '2014-02-01 00:24:05.000000', 'temperatura', 1185.0000, 'ºC'),
	(166156, 118, '2014-02-01 00:24:06.000000', 'temperatura', 479.0000, 'ºC'),
	(166157, 118, '2014-02-01 00:24:07.000000', 'temperatura', 41.0000, 'ºC'),
	(166158, 118, '2014-02-01 00:24:08.000000', 'temperatura', 1168.0000, 'ºC'),
	(166159, 118, '2014-02-01 00:24:09.000000', 'temperatura', 916.0000, 'ºC'),
	(166160, 118, '2014-02-01 00:24:10.000000', 'temperatura', 1080.0000, 'ºC'),
	(166161, 118, '2014-02-01 00:24:11.000000', 'temperatura', 249.0000, 'ºC'),
	(166162, 118, '2014-02-01 00:24:12.000000', 'temperatura', 405.0000, 'ºC'),
	(166163, 118, '2014-02-01 00:24:13.000000', 'temperatura', 79.0000, 'ºC'),
	(166164, 118, '2014-02-01 00:24:14.000000', 'temperatura', 382.0000, 'ºC'),
	(166165, 118, '2014-02-01 00:24:15.000000', 'temperatura', 471.0000, 'ºC'),
	(166166, 118, '2014-02-01 00:24:16.000000', 'temperatura', 12.0000, 'ºC'),
	(166167, 118, '2014-02-01 00:24:17.000000', 'temperatura', 1048.0000, 'ºC'),
	(166168, 118, '2014-02-01 00:24:18.000000', 'temperatura', 405.0000, 'ºC'),
	(166169, 118, '2014-02-01 00:24:19.000000', 'temperatura', 81.0000, 'ºC'),
	(166170, 118, '2014-02-01 00:24:20.000000', 'temperatura', 390.0000, 'ºC'),
	(166171, 118, '2014-02-01 00:24:21.000000', 'temperatura', 510.0000, 'ºC'),
	(166172, 118, '2014-02-01 00:24:22.000000', 'temperatura', 177.0000, 'ºC'),
	(166173, 118, '2014-02-01 00:24:23.000000', 'temperatura', 558.0000, 'ºC'),
	(166174, 118, '2014-02-01 00:24:24.000000', 'temperatura', 1058.0000, 'ºC'),
	(166175, 118, '2014-02-01 00:24:25.000000', 'temperatura', 17.0000, 'ºC'),
	(166176, 118, '2014-02-01 00:24:26.000000', 'temperatura', 513.0000, 'ºC'),
	(166177, 118, '2014-02-01 00:24:27.000000', 'temperatura', 113.0000, 'ºC'),
	(166178, 118, '2014-02-01 00:24:28.000000', 'temperatura', 228.0000, 'ºC'),
	(166179, 118, '2014-02-01 00:24:29.000000', 'temperatura', 799.0000, 'ºC'),
	(166180, 118, '2014-02-01 00:24:30.000000', 'temperatura', 913.0000, 'ºC'),
	(166181, 118, '2014-02-01 00:24:31.000000', 'temperatura', 967.0000, 'ºC'),
	(166182, 118, '2014-02-01 00:24:32.000000', 'temperatura', 899.0000, 'ºC'),
	(166183, 118, '2014-02-01 00:24:33.000000', 'temperatura', 392.0000, 'ºC'),
	(166184, 118, '2014-02-01 00:24:34.000000', 'temperatura', 464.0000, 'ºC'),
	(166185, 118, '2014-02-01 00:24:35.000000', 'temperatura', 1146.0000, 'ºC'),
	(166186, 118, '2014-02-01 00:24:36.000000', 'temperatura', 739.0000, 'ºC'),
	(166187, 118, '2014-02-01 00:24:37.000000', 'temperatura', 259.0000, 'ºC'),
	(166188, 118, '2014-02-01 00:24:38.000000', 'temperatura', 275.0000, 'ºC'),
	(166189, 118, '2014-02-01 00:24:39.000000', 'temperatura', 598.0000, 'ºC'),
	(166190, 118, '2014-02-01 00:24:40.000000', 'temperatura', 968.0000, 'ºC'),
	(166191, 118, '2014-02-01 00:24:41.000000', 'temperatura', 646.0000, 'ºC'),
	(166192, 118, '2014-02-01 00:24:42.000000', 'temperatura', 325.0000, 'ºC'),
	(166193, 118, '2014-02-01 00:24:43.000000', 'temperatura', 889.0000, 'ºC'),
	(166194, 118, '2014-02-01 00:24:44.000000', 'temperatura', 1068.0000, 'ºC'),
	(166195, 118, '2014-02-01 00:24:45.000000', 'temperatura', 277.0000, 'ºC'),
	(166196, 118, '2014-02-01 00:24:46.000000', 'temperatura', 579.0000, 'ºC'),
	(166197, 118, '2014-02-01 00:24:47.000000', 'temperatura', 866.0000, 'ºC'),
	(166198, 118, '2014-02-01 00:24:48.000000', 'temperatura', 195.0000, 'ºC'),
	(166199, 118, '2014-02-01 00:24:49.000000', 'temperatura', 776.0000, 'ºC'),
	(166200, 118, '2014-02-01 00:24:50.000000', 'temperatura', 896.0000, 'ºC'),
	(166201, 118, '2014-02-01 00:24:51.000000', 'temperatura', 954.0000, 'ºC'),
	(166202, 118, '2014-02-01 00:24:52.000000', 'temperatura', 879.0000, 'ºC'),
	(166203, 118, '2014-02-01 00:24:53.000000', 'temperatura', 336.0000, 'ºC'),
	(166204, 118, '2014-02-01 00:24:54.000000', 'temperatura', 241.0000, 'ºC'),
	(166205, 118, '2014-02-01 00:24:55.000000', 'temperatura', 200.0000, 'ºC'),
	(166206, 118, '2014-02-01 00:24:56.000000', 'temperatura', 278.0000, 'ºC'),
	(166207, 118, '2014-02-01 00:24:57.000000', 'temperatura', 788.0000, 'ºC'),
	(166208, 118, '2014-02-01 00:24:58.000000', 'temperatura', 708.0000, 'ºC'),
	(166209, 118, '2014-02-01 00:24:59.000000', 'temperatura', 1176.0000, 'ºC'),
	(166210, 118, '2014-02-01 00:25:00.000000', 'temperatura', 158.0000, 'ºC'),
	(166211, 118, '2014-02-01 00:25:01.000000', 'temperatura', 861.0000, 'ºC'),
	(166212, 118, '2014-02-01 00:25:02.000000', 'temperatura', 231.0000, 'ºC'),
	(166213, 118, '2014-02-01 00:25:03.000000', 'temperatura', 972.0000, 'ºC'),
	(166214, 118, '2014-02-01 00:25:04.000000', 'temperatura', 570.0000, 'ºC'),
	(166215, 118, '2014-02-01 00:25:05.000000', 'temperatura', 1133.0000, 'ºC'),
	(166216, 118, '2014-02-01 00:25:06.000000', 'temperatura', 357.0000, 'ºC'),
	(166217, 118, '2014-02-01 00:25:07.000000', 'temperatura', 785.0000, 'ºC'),
	(166218, 118, '2014-02-01 00:25:08.000000', 'temperatura', 454.0000, 'ºC'),
	(166219, 118, '2014-02-01 00:25:09.000000', 'temperatura', 1118.0000, 'ºC'),
	(166220, 118, '2014-02-01 00:25:10.000000', 'temperatura', 625.0000, 'ºC'),
	(166221, 118, '2014-02-01 00:25:11.000000', 'temperatura', 973.0000, 'ºC'),
	(166222, 118, '2014-02-01 00:25:12.000000', 'temperatura', 592.0000, 'ºC'),
	(166223, 118, '2014-02-01 00:25:13.000000', 'temperatura', 39.0000, 'ºC'),
	(166224, 118, '2014-02-01 00:25:14.000000', 'temperatura', 820.0000, 'ºC'),
	(166225, 118, '2014-02-01 00:25:15.000000', 'temperatura', 386.0000, 'ºC'),
	(166226, 118, '2014-02-01 00:25:16.000000', 'temperatura', 668.0000, 'ºC'),
	(166227, 118, '2014-02-01 00:25:17.000000', 'temperatura', 984.0000, 'ºC'),
	(166228, 118, '2014-02-01 00:25:18.000000', 'temperatura', 514.0000, 'ºC'),
	(166229, 118, '2014-02-01 00:25:19.000000', 'temperatura', 822.0000, 'ºC'),
	(166230, 118, '2014-02-01 00:25:20.000000', 'temperatura', 166.0000, 'ºC'),
	(166231, 118, '2014-02-01 00:25:21.000000', 'temperatura', 765.0000, 'ºC'),
	(166232, 118, '2014-02-01 00:25:22.000000', 'temperatura', 929.0000, 'ºC'),
	(166233, 118, '2014-02-01 00:25:23.000000', 'temperatura', 1150.0000, 'ºC'),
	(166234, 118, '2014-02-01 00:25:24.000000', 'temperatura', 563.0000, 'ºC'),
	(166235, 118, '2014-02-01 00:25:25.000000', 'temperatura', 566.0000, 'ºC'),
	(166236, 118, '2014-02-01 00:25:26.000000', 'temperatura', 1140.0000, 'ºC'),
	(166237, 118, '2014-02-01 00:25:27.000000', 'temperatura', 403.0000, 'ºC'),
	(166238, 118, '2014-02-01 00:25:28.000000', 'temperatura', 995.0000, 'ºC'),
	(166239, 118, '2014-02-01 00:25:29.000000', 'temperatura', 168.0000, 'ºC'),
	(166240, 118, '2014-02-01 00:25:30.000000', 'temperatura', 254.0000, 'ºC'),
	(166241, 118, '2014-02-01 00:25:31.000000', 'temperatura', 768.0000, 'ºC'),
	(166242, 118, '2014-02-01 00:25:32.000000', 'temperatura', 676.0000, 'ºC'),
	(166243, 118, '2014-02-01 00:25:33.000000', 'temperatura', 1077.0000, 'ºC'),
	(166244, 118, '2014-02-01 00:25:34.000000', 'temperatura', 957.0000, 'ºC'),
	(166245, 118, '2014-02-01 00:25:35.000000', 'temperatura', 355.0000, 'ºC'),
	(166246, 118, '2014-02-01 00:25:36.000000', 'temperatura', 103.0000, 'ºC'),
	(166247, 118, '2014-02-01 00:25:37.000000', 'temperatura', 653.0000, 'ºC'),
	(166248, 118, '2014-02-01 00:25:38.000000', 'temperatura', 557.0000, 'ºC'),
	(166249, 118, '2014-02-01 00:25:39.000000', 'temperatura', 825.0000, 'ºC'),
	(166250, 118, '2014-02-01 00:25:40.000000', 'temperatura', 54.0000, 'ºC'),
	(166251, 118, '2014-02-01 00:25:41.000000', 'temperatura', 198.0000, 'ºC'),
	(166252, 118, '2014-02-01 00:25:42.000000', 'temperatura', 828.0000, 'ºC'),
	(166253, 118, '2014-02-01 00:25:43.000000', 'temperatura', 1145.0000, 'ºC'),
	(166254, 118, '2014-02-01 00:25:44.000000', 'temperatura', 841.0000, 'ºC'),
	(166255, 118, '2014-02-01 00:25:45.000000', 'temperatura', 773.0000, 'ºC'),
	(166256, 118, '2014-02-01 00:25:46.000000', 'temperatura', 142.0000, 'ºC'),
	(166257, 118, '2014-02-01 00:25:47.000000', 'temperatura', 791.0000, 'ºC'),
	(166258, 118, '2014-02-01 00:25:48.000000', 'temperatura', 1130.0000, 'ºC'),
	(166259, 118, '2014-02-01 00:25:49.000000', 'temperatura', 877.0000, 'ºC'),
	(166260, 118, '2014-02-01 00:25:50.000000', 'temperatura', 994.0000, 'ºC'),
	(166261, 118, '2014-02-01 00:25:51.000000', 'temperatura', 1141.0000, 'ºC'),
	(166262, 118, '2014-02-01 00:25:52.000000', 'temperatura', 324.0000, 'ºC'),
	(166263, 118, '2014-02-01 00:25:53.000000', 'temperatura', 595.0000, 'ºC'),
	(166264, 118, '2014-02-01 00:25:54.000000', 'temperatura', 805.0000, 'ºC'),
	(166265, 118, '2014-02-01 00:25:55.000000', 'temperatura', 1039.0000, 'ºC'),
	(166266, 118, '2014-02-01 00:25:56.000000', 'temperatura', 382.0000, 'ºC'),
	(166267, 118, '2014-02-01 00:25:57.000000', 'temperatura', 1195.0000, 'ºC'),
	(166268, 118, '2014-02-01 00:25:58.000000', 'temperatura', 26.0000, 'ºC'),
	(166269, 118, '2014-02-01 00:25:59.000000', 'temperatura', 149.0000, 'ºC'),
	(166270, 118, '2014-02-01 00:26:00.000000', 'temperatura', 665.0000, 'ºC'),
	(166271, 118, '2014-02-01 00:26:01.000000', 'temperatura', 477.0000, 'ºC'),
	(166272, 118, '2014-02-01 00:26:02.000000', 'temperatura', 394.0000, 'ºC'),
	(166273, 118, '2014-02-01 00:26:03.000000', 'temperatura', 539.0000, 'ºC'),
	(166274, 118, '2014-02-01 00:26:04.000000', 'temperatura', 313.0000, 'ºC'),
	(166275, 118, '2014-02-01 00:26:05.000000', 'temperatura', 1149.0000, 'ºC'),
	(166276, 118, '2014-02-01 00:26:06.000000', 'temperatura', 5.0000, 'ºC'),
	(166277, 118, '2014-02-01 00:26:07.000000', 'temperatura', 178.0000, 'ºC'),
	(166278, 118, '2014-02-01 00:26:08.000000', 'temperatura', 877.0000, 'ºC'),
	(166279, 118, '2014-02-01 00:26:09.000000', 'temperatura', 253.0000, 'ºC'),
	(166280, 118, '2014-02-01 00:26:10.000000', 'temperatura', 1034.0000, 'ºC'),
	(166281, 118, '2014-02-01 00:26:11.000000', 'temperatura', 809.0000, 'ºC'),
	(166282, 118, '2014-02-01 00:26:12.000000', 'temperatura', 944.0000, 'ºC'),
	(166283, 118, '2014-02-01 00:26:13.000000', 'temperatura', 1095.0000, 'ºC'),
	(166284, 118, '2014-02-01 00:26:14.000000', 'temperatura', 244.0000, 'ºC'),
	(166285, 118, '2014-02-01 00:26:15.000000', 'temperatura', 336.0000, 'ºC'),
	(166286, 118, '2014-02-01 00:26:16.000000', 'temperatura', 948.0000, 'ºC'),
	(166287, 118, '2014-02-01 00:26:17.000000', 'temperatura', 132.0000, 'ºC'),
	(166288, 118, '2014-02-01 00:26:18.000000', 'temperatura', 215.0000, 'ºC'),
	(166289, 118, '2014-02-01 00:26:19.000000', 'temperatura', 682.0000, 'ºC'),
	(166290, 118, '2014-02-01 00:26:20.000000', 'temperatura', 365.0000, 'ºC'),
	(166291, 118, '2014-02-01 00:26:21.000000', 'temperatura', 978.0000, 'ºC'),
	(166292, 118, '2014-02-01 00:26:22.000000', 'temperatura', 198.0000, 'ºC'),
	(166293, 118, '2014-02-01 00:26:23.000000', 'temperatura', 456.0000, 'ºC'),
	(166294, 118, '2014-02-01 00:26:24.000000', 'temperatura', 488.0000, 'ºC'),
	(166295, 118, '2014-02-01 00:26:25.000000', 'temperatura', 1070.0000, 'ºC'),
	(166296, 118, '2014-02-01 00:26:26.000000', 'temperatura', 287.0000, 'ºC'),
	(166297, 118, '2014-02-01 00:26:27.000000', 'temperatura', 626.0000, 'ºC'),
	(166298, 118, '2014-02-01 00:26:28.000000', 'temperatura', 1069.0000, 'ºC'),
	(166299, 118, '2014-02-01 00:26:29.000000', 'temperatura', 1069.0000, 'ºC'),
	(166300, 118, '2014-02-01 00:26:30.000000', 'temperatura', 937.0000, 'ºC'),
	(166301, 118, '2014-02-01 00:26:31.000000', 'temperatura', 279.0000, 'ºC'),
	(166302, 118, '2014-02-01 00:26:32.000000', 'temperatura', 986.0000, 'ºC'),
	(166303, 118, '2014-02-01 00:26:33.000000', 'temperatura', 491.0000, 'ºC'),
	(166304, 118, '2014-02-01 00:26:34.000000', 'temperatura', 700.0000, 'ºC'),
	(166305, 118, '2014-02-01 00:26:35.000000', 'temperatura', 826.0000, 'ºC'),
	(166306, 118, '2014-02-01 00:26:36.000000', 'temperatura', 830.0000, 'ºC'),
	(166307, 118, '2014-02-01 00:26:37.000000', 'temperatura', 471.0000, 'ºC'),
	(166308, 118, '2014-02-01 00:26:38.000000', 'temperatura', 1069.0000, 'ºC'),
	(166309, 118, '2014-02-01 00:26:39.000000', 'temperatura', 329.0000, 'ºC'),
	(166310, 118, '2014-02-01 00:26:40.000000', 'temperatura', 842.0000, 'ºC'),
	(166311, 118, '2014-02-01 00:26:41.000000', 'temperatura', 822.0000, 'ºC'),
	(166312, 118, '2014-02-01 00:26:42.000000', 'temperatura', 385.0000, 'ºC'),
	(166313, 118, '2014-02-01 00:26:43.000000', 'temperatura', 658.0000, 'ºC'),
	(166314, 118, '2014-02-01 00:26:44.000000', 'temperatura', 938.0000, 'ºC'),
	(166315, 118, '2014-02-01 00:26:45.000000', 'temperatura', 316.0000, 'ºC'),
	(166316, 118, '2014-02-01 00:26:46.000000', 'temperatura', 1167.0000, 'ºC'),
	(166317, 118, '2014-02-01 00:26:47.000000', 'temperatura', 86.0000, 'ºC'),
	(166318, 118, '2014-02-01 00:26:48.000000', 'temperatura', 530.0000, 'ºC'),
	(166319, 118, '2014-02-01 00:26:49.000000', 'temperatura', 1191.0000, 'ºC'),
	(166320, 118, '2014-02-01 00:26:50.000000', 'temperatura', 767.0000, 'ºC'),
	(166321, 118, '2014-02-01 00:26:51.000000', 'temperatura', 260.0000, 'ºC'),
	(166322, 118, '2014-02-01 00:26:52.000000', 'temperatura', 202.0000, 'ºC'),
	(166323, 118, '2014-02-01 00:26:53.000000', 'temperatura', 230.0000, 'ºC'),
	(166324, 118, '2014-02-01 00:26:54.000000', 'temperatura', 545.0000, 'ºC'),
	(166325, 118, '2014-02-01 00:26:55.000000', 'temperatura', 836.0000, 'ºC'),
	(166326, 118, '2014-02-01 00:26:56.000000', 'temperatura', 143.0000, 'ºC'),
	(166327, 118, '2014-02-01 00:26:57.000000', 'temperatura', 608.0000, 'ºC'),
	(166328, 118, '2014-02-01 00:26:58.000000', 'temperatura', 211.0000, 'ºC'),
	(166329, 118, '2014-02-01 00:26:59.000000', 'temperatura', 432.0000, 'ºC'),
	(166330, 118, '2014-02-01 00:27:00.000000', 'temperatura', 326.0000, 'ºC'),
	(166331, 118, '2014-02-01 00:27:01.000000', 'temperatura', 336.0000, 'ºC'),
	(166332, 118, '2014-02-01 00:27:02.000000', 'temperatura', 700.0000, 'ºC'),
	(166333, 118, '2014-02-01 00:27:03.000000', 'temperatura', 95.0000, 'ºC'),
	(166334, 118, '2014-02-01 00:27:04.000000', 'temperatura', 776.0000, 'ºC'),
	(166335, 118, '2014-02-01 00:27:05.000000', 'temperatura', 1194.0000, 'ºC'),
	(166336, 118, '2014-02-01 00:27:06.000000', 'temperatura', 42.0000, 'ºC'),
	(166337, 118, '2014-02-01 00:27:07.000000', 'temperatura', 231.0000, 'ºC'),
	(166338, 118, '2014-02-01 00:27:08.000000', 'temperatura', 1029.0000, 'ºC'),
	(166339, 118, '2014-02-01 00:27:09.000000', 'temperatura', 851.0000, 'ºC'),
	(166340, 118, '2014-02-01 00:27:10.000000', 'temperatura', 1167.0000, 'ºC'),
	(166341, 118, '2014-02-01 00:27:11.000000', 'temperatura', 886.0000, 'ºC'),
	(166342, 118, '2014-02-01 00:27:12.000000', 'temperatura', 927.0000, 'ºC'),
	(166343, 118, '2014-02-01 00:27:13.000000', 'temperatura', 779.0000, 'ºC'),
	(166344, 118, '2014-02-01 00:27:14.000000', 'temperatura', 1113.0000, 'ºC'),
	(166345, 118, '2014-02-01 00:27:15.000000', 'temperatura', 831.0000, 'ºC'),
	(166346, 118, '2014-02-01 00:27:16.000000', 'temperatura', 815.0000, 'ºC'),
	(166347, 118, '2014-02-01 00:27:17.000000', 'temperatura', 385.0000, 'ºC'),
	(166348, 118, '2014-02-01 00:27:18.000000', 'temperatura', 678.0000, 'ºC'),
	(166349, 118, '2014-02-01 00:27:19.000000', 'temperatura', 1036.0000, 'ºC'),
	(166350, 118, '2014-02-01 00:27:20.000000', 'temperatura', 748.0000, 'ºC'),
	(166351, 118, '2014-02-01 00:27:21.000000', 'temperatura', 630.0000, 'ºC'),
	(166352, 118, '2014-02-01 00:27:22.000000', 'temperatura', 909.0000, 'ºC'),
	(166353, 118, '2014-02-01 00:27:23.000000', 'temperatura', 253.0000, 'ºC'),
	(166354, 118, '2014-02-01 00:27:24.000000', 'temperatura', 940.0000, 'ºC'),
	(166355, 118, '2014-02-01 00:27:25.000000', 'temperatura', 340.0000, 'ºC'),
	(166356, 118, '2014-02-01 00:27:26.000000', 'temperatura', 81.0000, 'ºC'),
	(166357, 118, '2014-02-01 00:27:27.000000', 'temperatura', 584.0000, 'ºC'),
	(166358, 118, '2014-02-01 00:27:28.000000', 'temperatura', 278.0000, 'ºC'),
	(166359, 118, '2014-02-01 00:27:29.000000', 'temperatura', 839.0000, 'ºC'),
	(166360, 118, '2014-02-01 00:27:30.000000', 'temperatura', 960.0000, 'ºC'),
	(166361, 118, '2014-02-01 00:27:31.000000', 'temperatura', 1083.0000, 'ºC'),
	(166362, 118, '2014-02-01 00:27:32.000000', 'temperatura', 138.0000, 'ºC'),
	(166363, 118, '2014-02-01 00:27:33.000000', 'temperatura', 1043.0000, 'ºC'),
	(166364, 118, '2014-02-01 00:27:34.000000', 'temperatura', 1198.0000, 'ºC'),
	(166365, 118, '2014-02-01 00:27:35.000000', 'temperatura', 463.0000, 'ºC'),
	(166366, 118, '2014-02-01 00:27:36.000000', 'temperatura', 1120.0000, 'ºC'),
	(166367, 118, '2014-02-01 00:27:37.000000', 'temperatura', 613.0000, 'ºC'),
	(166368, 118, '2014-02-01 00:27:38.000000', 'temperatura', 906.0000, 'ºC'),
	(166369, 118, '2014-02-01 00:27:39.000000', 'temperatura', 289.0000, 'ºC'),
	(166370, 118, '2014-02-01 00:27:40.000000', 'temperatura', 1130.0000, 'ºC'),
	(166371, 118, '2014-02-01 00:27:41.000000', 'temperatura', 1183.0000, 'ºC'),
	(166372, 118, '2014-02-01 00:27:42.000000', 'temperatura', 125.0000, 'ºC'),
	(166373, 118, '2014-02-01 00:27:43.000000', 'temperatura', 676.0000, 'ºC'),
	(166374, 118, '2014-02-01 00:27:44.000000', 'temperatura', 606.0000, 'ºC'),
	(166375, 118, '2014-02-01 00:27:45.000000', 'temperatura', 1004.0000, 'ºC'),
	(166376, 118, '2014-02-01 00:27:46.000000', 'temperatura', 801.0000, 'ºC'),
	(166377, 118, '2014-02-01 00:27:47.000000', 'temperatura', 993.0000, 'ºC'),
	(166378, 118, '2014-02-01 00:27:48.000000', 'temperatura', 163.0000, 'ºC'),
	(166379, 118, '2014-02-01 00:27:49.000000', 'temperatura', 236.0000, 'ºC'),
	(166380, 118, '2014-02-01 00:27:50.000000', 'temperatura', 693.0000, 'ºC'),
	(166381, 118, '2014-02-01 00:27:51.000000', 'temperatura', 356.0000, 'ºC'),
	(166382, 118, '2014-02-01 00:27:52.000000', 'temperatura', 900.0000, 'ºC'),
	(166383, 118, '2014-02-01 00:27:53.000000', 'temperatura', 1036.0000, 'ºC'),
	(166384, 118, '2014-02-01 00:27:54.000000', 'temperatura', 78.0000, 'ºC'),
	(166385, 118, '2014-02-01 00:27:55.000000', 'temperatura', 883.0000, 'ºC'),
	(166386, 118, '2014-02-01 00:27:56.000000', 'temperatura', 582.0000, 'ºC'),
	(166387, 118, '2014-02-01 00:27:57.000000', 'temperatura', 261.0000, 'ºC'),
	(166388, 118, '2014-02-01 00:27:58.000000', 'temperatura', 759.0000, 'ºC'),
	(166389, 118, '2014-02-01 00:27:59.000000', 'temperatura', 612.0000, 'ºC'),
	(166390, 118, '2014-02-01 00:28:00.000000', 'temperatura', 783.0000, 'ºC'),
	(166391, 118, '2014-02-01 00:28:01.000000', 'temperatura', 880.0000, 'ºC'),
	(166392, 118, '2014-02-01 00:28:02.000000', 'temperatura', 851.0000, 'ºC'),
	(166393, 118, '2014-02-01 00:28:03.000000', 'temperatura', 416.0000, 'ºC'),
	(166394, 118, '2014-02-01 00:28:04.000000', 'temperatura', 728.0000, 'ºC'),
	(166395, 118, '2014-02-01 00:28:05.000000', 'temperatura', 1194.0000, 'ºC'),
	(166396, 118, '2014-02-01 00:28:06.000000', 'temperatura', 186.0000, 'ºC'),
	(166397, 118, '2014-02-01 00:28:07.000000', 'temperatura', 950.0000, 'ºC'),
	(166398, 118, '2014-02-01 00:28:08.000000', 'temperatura', 590.0000, 'ºC'),
	(166399, 118, '2014-02-01 00:28:09.000000', 'temperatura', 100.0000, 'ºC'),
	(166400, 118, '2014-02-01 00:28:10.000000', 'temperatura', 1133.0000, 'ºC'),
	(166401, 118, '2014-02-01 00:28:11.000000', 'temperatura', 566.0000, 'ºC'),
	(166402, 118, '2014-02-01 00:28:12.000000', 'temperatura', 629.0000, 'ºC'),
	(166403, 118, '2014-02-01 00:28:13.000000', 'temperatura', 247.0000, 'ºC'),
	(166404, 118, '2014-02-01 00:28:14.000000', 'temperatura', 548.0000, 'ºC'),
	(166405, 118, '2014-02-01 00:28:15.000000', 'temperatura', 801.0000, 'ºC'),
	(166406, 118, '2014-02-01 00:28:16.000000', 'temperatura', 1159.0000, 'ºC'),
	(166407, 118, '2014-02-01 00:28:17.000000', 'temperatura', 996.0000, 'ºC'),
	(166408, 118, '2014-02-01 00:28:18.000000', 'temperatura', 301.0000, 'ºC'),
	(166409, 118, '2014-02-01 00:28:19.000000', 'temperatura', 919.0000, 'ºC'),
	(166410, 118, '2014-02-01 00:28:20.000000', 'temperatura', 93.0000, 'ºC'),
	(166411, 118, '2014-02-01 00:28:21.000000', 'temperatura', 107.0000, 'ºC'),
	(166412, 118, '2014-02-01 00:28:22.000000', 'temperatura', 258.0000, 'ºC'),
	(166413, 118, '2014-02-01 00:28:23.000000', 'temperatura', 969.0000, 'ºC'),
	(166414, 118, '2014-02-01 00:28:24.000000', 'temperatura', 469.0000, 'ºC'),
	(166415, 118, '2014-02-01 00:28:25.000000', 'temperatura', 642.0000, 'ºC'),
	(166416, 118, '2014-02-01 00:28:26.000000', 'temperatura', 603.0000, 'ºC'),
	(166417, 118, '2014-02-01 00:28:27.000000', 'temperatura', 1090.0000, 'ºC'),
	(166418, 118, '2014-02-01 00:28:28.000000', 'temperatura', 42.0000, 'ºC'),
	(166419, 118, '2014-02-01 00:28:29.000000', 'temperatura', 541.0000, 'ºC'),
	(166420, 118, '2014-02-01 00:28:30.000000', 'temperatura', 180.0000, 'ºC'),
	(166421, 118, '2014-02-01 00:28:31.000000', 'temperatura', 476.0000, 'ºC'),
	(166422, 118, '2014-02-01 00:28:32.000000', 'temperatura', 642.0000, 'ºC'),
	(166423, 118, '2014-02-01 00:28:33.000000', 'temperatura', 583.0000, 'ºC'),
	(166424, 118, '2014-02-01 00:28:34.000000', 'temperatura', 988.0000, 'ºC'),
	(166425, 118, '2014-02-01 00:28:35.000000', 'temperatura', 793.0000, 'ºC'),
	(166426, 118, '2014-02-01 00:28:36.000000', 'temperatura', 999.0000, 'ºC'),
	(166427, 118, '2014-02-01 00:28:37.000000', 'temperatura', 219.0000, 'ºC'),
	(166428, 118, '2014-02-01 00:28:38.000000', 'temperatura', 497.0000, 'ºC'),
	(166429, 118, '2014-02-01 00:28:39.000000', 'temperatura', 627.0000, 'ºC'),
	(166430, 118, '2014-02-01 00:28:40.000000', 'temperatura', 445.0000, 'ºC'),
	(166431, 118, '2014-02-01 00:28:41.000000', 'temperatura', 345.0000, 'ºC'),
	(166432, 118, '2014-02-01 00:28:42.000000', 'temperatura', 390.0000, 'ºC'),
	(166433, 118, '2014-02-01 00:28:43.000000', 'temperatura', 917.0000, 'ºC'),
	(166434, 118, '2014-02-01 00:28:44.000000', 'temperatura', 1015.0000, 'ºC'),
	(166435, 118, '2014-02-01 00:28:45.000000', 'temperatura', 1123.0000, 'ºC'),
	(166436, 118, '2014-02-01 00:28:46.000000', 'temperatura', 172.0000, 'ºC'),
	(166437, 118, '2014-02-01 00:28:47.000000', 'temperatura', 1089.0000, 'ºC'),
	(166438, 118, '2014-02-01 00:28:48.000000', 'temperatura', 133.0000, 'ºC'),
	(166439, 118, '2014-02-01 00:28:49.000000', 'temperatura', 995.0000, 'ºC'),
	(166440, 118, '2014-02-01 00:28:50.000000', 'temperatura', 980.0000, 'ºC'),
	(166441, 118, '2014-02-01 00:28:51.000000', 'temperatura', 713.0000, 'ºC'),
	(166442, 118, '2014-02-01 00:28:52.000000', 'temperatura', 628.0000, 'ºC'),
	(166443, 118, '2014-02-01 00:28:53.000000', 'temperatura', 1000.0000, 'ºC'),
	(166444, 118, '2014-02-01 00:28:54.000000', 'temperatura', 716.0000, 'ºC'),
	(166445, 118, '2014-02-01 00:28:55.000000', 'temperatura', 581.0000, 'ºC'),
	(166446, 118, '2014-02-01 00:28:56.000000', 'temperatura', 756.0000, 'ºC'),
	(166447, 118, '2014-02-01 00:28:57.000000', 'temperatura', 836.0000, 'ºC'),
	(166448, 118, '2014-02-01 00:28:58.000000', 'temperatura', 716.0000, 'ºC'),
	(166449, 118, '2014-02-01 00:28:59.000000', 'temperatura', 1072.0000, 'ºC'),
	(166450, 118, '2014-02-01 00:29:00.000000', 'temperatura', 814.0000, 'ºC'),
	(166451, 118, '2014-02-01 00:29:01.000000', 'temperatura', 853.0000, 'ºC'),
	(166452, 118, '2014-02-01 00:29:02.000000', 'temperatura', 623.0000, 'ºC'),
	(166453, 118, '2014-02-01 00:29:03.000000', 'temperatura', 557.0000, 'ºC'),
	(166454, 118, '2014-02-01 00:29:04.000000', 'temperatura', 915.0000, 'ºC'),
	(166455, 118, '2014-02-01 00:29:05.000000', 'temperatura', 504.0000, 'ºC'),
	(166456, 118, '2014-02-01 00:29:06.000000', 'temperatura', 977.0000, 'ºC'),
	(166457, 118, '2014-02-01 00:29:07.000000', 'temperatura', 974.0000, 'ºC'),
	(166458, 118, '2014-02-01 00:29:08.000000', 'temperatura', 737.0000, 'ºC'),
	(166459, 118, '2014-02-01 00:29:09.000000', 'temperatura', 767.0000, 'ºC'),
	(166460, 118, '2014-02-01 00:29:10.000000', 'temperatura', 422.0000, 'ºC'),
	(166461, 118, '2014-02-01 00:29:11.000000', 'temperatura', 1012.0000, 'ºC'),
	(166462, 118, '2014-02-01 00:29:12.000000', 'temperatura', 195.0000, 'ºC'),
	(166463, 118, '2014-02-01 00:29:13.000000', 'temperatura', 337.0000, 'ºC'),
	(166464, 118, '2014-02-01 00:29:14.000000', 'temperatura', 1099.0000, 'ºC'),
	(166465, 118, '2014-02-01 00:29:15.000000', 'temperatura', 887.0000, 'ºC'),
	(166466, 118, '2014-02-01 00:29:16.000000', 'temperatura', 1140.0000, 'ºC'),
	(166467, 118, '2014-02-01 00:29:17.000000', 'temperatura', 637.0000, 'ºC'),
	(166468, 118, '2014-02-01 00:29:18.000000', 'temperatura', 967.0000, 'ºC'),
	(166469, 118, '2014-02-01 00:29:19.000000', 'temperatura', 523.0000, 'ºC'),
	(166470, 118, '2014-02-01 00:29:20.000000', 'temperatura', 915.0000, 'ºC'),
	(166471, 118, '2014-02-01 00:29:21.000000', 'temperatura', 605.0000, 'ºC'),
	(166472, 118, '2014-02-01 00:29:22.000000', 'temperatura', 283.0000, 'ºC'),
	(166473, 118, '2014-02-01 00:29:23.000000', 'temperatura', 798.0000, 'ºC'),
	(166474, 118, '2014-02-01 00:29:24.000000', 'temperatura', 743.0000, 'ºC'),
	(166475, 118, '2014-02-01 00:29:25.000000', 'temperatura', 121.0000, 'ºC'),
	(166476, 118, '2014-02-01 00:29:26.000000', 'temperatura', 779.0000, 'ºC'),
	(166477, 118, '2014-02-01 00:29:27.000000', 'temperatura', 1130.0000, 'ºC'),
	(166478, 118, '2014-02-01 00:29:28.000000', 'temperatura', 914.0000, 'ºC'),
	(166479, 118, '2014-02-01 00:29:29.000000', 'temperatura', 1179.0000, 'ºC'),
	(166480, 118, '2014-02-01 00:29:30.000000', 'temperatura', 755.0000, 'ºC'),
	(166481, 118, '2014-02-01 00:29:31.000000', 'temperatura', 239.0000, 'ºC'),
	(166482, 118, '2014-02-01 00:29:32.000000', 'temperatura', 130.0000, 'ºC'),
	(166483, 118, '2014-02-01 00:29:33.000000', 'temperatura', 1132.0000, 'ºC'),
	(166484, 118, '2014-02-01 00:29:34.000000', 'temperatura', 470.0000, 'ºC'),
	(166485, 118, '2014-02-01 00:29:35.000000', 'temperatura', 154.0000, 'ºC'),
	(166486, 118, '2014-02-01 00:29:36.000000', 'temperatura', 562.0000, 'ºC'),
	(166487, 118, '2014-02-01 00:29:37.000000', 'temperatura', 1149.0000, 'ºC'),
	(166488, 118, '2014-02-01 00:29:38.000000', 'temperatura', 459.0000, 'ºC'),
	(166489, 118, '2014-02-01 00:29:39.000000', 'temperatura', 48.0000, 'ºC'),
	(166490, 118, '2014-02-01 00:29:40.000000', 'temperatura', 62.0000, 'ºC'),
	(166491, 118, '2014-02-01 00:29:41.000000', 'temperatura', 169.0000, 'ºC'),
	(166492, 118, '2014-02-01 00:29:42.000000', 'temperatura', 659.0000, 'ºC'),
	(166493, 118, '2014-02-01 00:29:43.000000', 'temperatura', 388.0000, 'ºC'),
	(166494, 118, '2014-02-01 00:29:44.000000', 'temperatura', 1166.0000, 'ºC'),
	(166495, 118, '2014-02-01 00:29:45.000000', 'temperatura', 1063.0000, 'ºC'),
	(166496, 118, '2014-02-01 00:29:46.000000', 'temperatura', 621.0000, 'ºC'),
	(166497, 118, '2014-02-01 00:29:47.000000', 'temperatura', 1115.0000, 'ºC'),
	(166498, 118, '2014-02-01 00:29:48.000000', 'temperatura', 111.0000, 'ºC'),
	(166499, 118, '2014-02-01 00:29:49.000000', 'temperatura', 811.0000, 'ºC'),
	(166500, 118, '2014-02-01 00:29:50.000000', 'temperatura', 123.0000, 'ºC'),
	(166501, 118, '2014-02-01 00:29:51.000000', 'temperatura', 582.0000, 'ºC'),
	(166502, 118, '2014-02-01 00:29:52.000000', 'temperatura', 142.0000, 'ºC'),
	(166503, 118, '2014-02-01 00:29:53.000000', 'temperatura', 165.0000, 'ºC'),
	(166504, 118, '2014-02-01 00:29:54.000000', 'temperatura', 398.0000, 'ºC'),
	(166505, 118, '2014-02-01 00:29:55.000000', 'temperatura', 295.0000, 'ºC'),
	(166506, 118, '2014-02-01 00:29:56.000000', 'temperatura', 284.0000, 'ºC'),
	(166507, 118, '2014-02-01 00:29:57.000000', 'temperatura', 534.0000, 'ºC'),
	(166508, 118, '2014-02-01 00:29:58.000000', 'temperatura', 618.0000, 'ºC'),
	(166509, 118, '2014-02-01 00:29:59.000000', 'temperatura', 287.0000, 'ºC'),
	(166510, 118, '2014-02-01 00:30:00.000000', 'temperatura', 785.0000, 'ºC'),
	(166511, 118, '2014-02-01 00:30:01.000000', 'temperatura', 661.0000, 'ºC'),
	(166512, 118, '2014-02-01 00:30:02.000000', 'temperatura', 952.0000, 'ºC'),
	(166513, 118, '2014-02-01 00:30:03.000000', 'temperatura', 377.0000, 'ºC'),
	(166514, 118, '2014-02-01 00:30:04.000000', 'temperatura', 230.0000, 'ºC'),
	(166515, 118, '2014-02-01 00:30:05.000000', 'temperatura', 21.0000, 'ºC'),
	(166516, 118, '2014-02-01 00:30:06.000000', 'temperatura', 612.0000, 'ºC'),
	(166517, 118, '2014-02-01 00:30:07.000000', 'temperatura', 600.0000, 'ºC'),
	(166518, 118, '2014-02-01 00:30:08.000000', 'temperatura', 1165.0000, 'ºC'),
	(166519, 118, '2014-02-01 00:30:09.000000', 'temperatura', 426.0000, 'ºC'),
	(166520, 118, '2014-02-01 00:30:10.000000', 'temperatura', 1033.0000, 'ºC'),
	(166521, 118, '2014-02-01 00:30:11.000000', 'temperatura', 288.0000, 'ºC'),
	(166522, 118, '2014-02-01 00:30:12.000000', 'temperatura', 743.0000, 'ºC'),
	(166523, 118, '2014-02-01 00:30:13.000000', 'temperatura', 452.0000, 'ºC'),
	(166524, 118, '2014-02-01 00:30:14.000000', 'temperatura', 30.0000, 'ºC'),
	(166525, 118, '2014-02-01 00:30:15.000000', 'temperatura', 1193.0000, 'ºC'),
	(166526, 118, '2014-02-01 00:30:16.000000', 'temperatura', 1078.0000, 'ºC'),
	(166527, 118, '2014-02-01 00:30:17.000000', 'temperatura', 610.0000, 'ºC'),
	(166528, 118, '2014-02-01 00:30:18.000000', 'temperatura', 1015.0000, 'ºC'),
	(166529, 118, '2014-02-01 00:30:19.000000', 'temperatura', 848.0000, 'ºC'),
	(166530, 118, '2014-02-01 00:30:20.000000', 'temperatura', 1195.0000, 'ºC'),
	(166531, 118, '2014-02-01 00:30:21.000000', 'temperatura', 1029.0000, 'ºC'),
	(166532, 118, '2014-02-01 00:30:22.000000', 'temperatura', 363.0000, 'ºC'),
	(166533, 118, '2014-02-01 00:30:23.000000', 'temperatura', 1128.0000, 'ºC'),
	(166534, 118, '2014-02-01 00:30:24.000000', 'temperatura', 951.0000, 'ºC'),
	(166535, 118, '2014-02-01 00:30:25.000000', 'temperatura', 172.0000, 'ºC'),
	(166536, 118, '2014-02-01 00:30:26.000000', 'temperatura', 408.0000, 'ºC'),
	(166537, 118, '2014-02-01 00:30:27.000000', 'temperatura', 322.0000, 'ºC'),
	(166538, 118, '2014-02-01 00:30:28.000000', 'temperatura', 388.0000, 'ºC'),
	(166539, 118, '2014-02-01 00:30:29.000000', 'temperatura', 976.0000, 'ºC'),
	(166540, 118, '2014-02-01 00:30:30.000000', 'temperatura', 115.0000, 'ºC'),
	(166541, 118, '2014-02-01 00:30:31.000000', 'temperatura', 47.0000, 'ºC'),
	(166542, 118, '2014-02-01 00:30:32.000000', 'temperatura', 1091.0000, 'ºC'),
	(166543, 118, '2014-02-01 00:30:33.000000', 'temperatura', 517.0000, 'ºC'),
	(166544, 118, '2014-02-01 00:30:34.000000', 'temperatura', 509.0000, 'ºC'),
	(166545, 118, '2014-02-01 00:30:35.000000', 'temperatura', 995.0000, 'ºC'),
	(166546, 118, '2014-02-01 00:30:36.000000', 'temperatura', 1047.0000, 'ºC'),
	(166547, 118, '2014-02-01 00:30:37.000000', 'temperatura', 1053.0000, 'ºC'),
	(166548, 118, '2014-02-01 00:30:38.000000', 'temperatura', 925.0000, 'ºC'),
	(166549, 118, '2014-02-01 00:30:39.000000', 'temperatura', 264.0000, 'ºC'),
	(166550, 118, '2014-02-01 00:30:40.000000', 'temperatura', 949.0000, 'ºC'),
	(166551, 118, '2014-02-01 00:30:41.000000', 'temperatura', 350.0000, 'ºC'),
	(166552, 118, '2014-02-01 00:30:42.000000', 'temperatura', 106.0000, 'ºC'),
	(166553, 118, '2014-02-01 00:30:43.000000', 'temperatura', 681.0000, 'ºC'),
	(166554, 118, '2014-02-01 00:30:44.000000', 'temperatura', 687.0000, 'ºC'),
	(166555, 118, '2014-02-01 00:30:45.000000', 'temperatura', 190.0000, 'ºC'),
	(166556, 118, '2014-02-01 00:30:46.000000', 'temperatura', 93.0000, 'ºC'),
	(166557, 118, '2014-02-01 00:30:47.000000', 'temperatura', 1093.0000, 'ºC'),
	(166558, 118, '2014-02-01 00:30:48.000000', 'temperatura', 387.0000, 'ºC'),
	(166559, 118, '2014-02-01 00:30:49.000000', 'temperatura', 1056.0000, 'ºC'),
	(166560, 118, '2014-02-01 00:30:50.000000', 'temperatura', 521.0000, 'ºC'),
	(166561, 118, '2014-02-01 00:30:51.000000', 'temperatura', 638.0000, 'ºC'),
	(166562, 118, '2014-02-01 00:30:52.000000', 'temperatura', 425.0000, 'ºC'),
	(166563, 118, '2014-02-01 00:30:53.000000', 'temperatura', 213.0000, 'ºC'),
	(166564, 118, '2014-02-01 00:30:54.000000', 'temperatura', 989.0000, 'ºC'),
	(166565, 118, '2014-02-01 00:30:55.000000', 'temperatura', 709.0000, 'ºC'),
	(166566, 118, '2014-02-01 00:30:56.000000', 'temperatura', 579.0000, 'ºC'),
	(166567, 118, '2014-02-01 00:30:57.000000', 'temperatura', 767.0000, 'ºC'),
	(166568, 118, '2014-02-01 00:30:58.000000', 'temperatura', 897.0000, 'ºC'),
	(166569, 118, '2014-02-01 00:30:59.000000', 'temperatura', 986.0000, 'ºC'),
	(166570, 118, '2014-02-01 00:31:00.000000', 'temperatura', 1039.0000, 'ºC'),
	(166571, 118, '2014-02-01 00:31:01.000000', 'temperatura', 1038.0000, 'ºC'),
	(166572, 118, '2014-02-01 00:31:02.000000', 'temperatura', 875.0000, 'ºC'),
	(166573, 118, '2014-02-01 00:31:03.000000', 'temperatura', 61.0000, 'ºC'),
	(166574, 118, '2014-02-01 00:31:04.000000', 'temperatura', 80.0000, 'ºC'),
	(166575, 118, '2014-02-01 00:31:05.000000', 'temperatura', 218.0000, 'ºC'),
	(166576, 118, '2014-02-01 00:31:06.000000', 'temperatura', 849.0000, 'ºC'),
	(166577, 118, '2014-02-01 00:31:07.000000', 'temperatura', 1193.0000, 'ºC'),
	(166578, 118, '2014-02-01 00:31:08.000000', 'temperatura', 1020.0000, 'ºC'),
	(166579, 118, '2014-02-01 00:31:09.000000', 'temperatura', 318.0000, 'ºC'),
	(166580, 118, '2014-02-01 00:31:10.000000', 'temperatura', 934.0000, 'ºC'),
	(166581, 118, '2014-02-01 00:31:11.000000', 'temperatura', 113.0000, 'ºC'),
	(166582, 118, '2014-02-01 00:31:12.000000', 'temperatura', 167.0000, 'ºC'),
	(166583, 118, '2014-02-01 00:31:13.000000', 'temperatura', 495.0000, 'ºC'),
	(166584, 118, '2014-02-01 00:31:14.000000', 'temperatura', 773.0000, 'ºC'),
	(166585, 118, '2014-02-01 00:31:15.000000', 'temperatura', 1180.0000, 'ºC'),
	(166586, 118, '2014-02-01 00:31:16.000000', 'temperatura', 1182.0000, 'ºC'),
	(166587, 118, '2014-02-01 00:31:17.000000', 'temperatura', 1169.0000, 'ºC'),
	(166588, 118, '2014-02-01 00:31:18.000000', 'temperatura', 1102.0000, 'ºC'),
	(166589, 118, '2014-02-01 00:31:19.000000', 'temperatura', 803.0000, 'ºC'),
	(166590, 118, '2014-02-01 00:31:20.000000', 'temperatura', 707.0000, 'ºC'),
	(166591, 118, '2014-02-01 00:31:21.000000', 'temperatura', 1129.0000, 'ºC'),
	(166592, 118, '2014-02-01 00:31:22.000000', 'temperatura', 1123.0000, 'ºC'),
	(166593, 118, '2014-02-01 00:31:23.000000', 'temperatura', 1029.0000, 'ºC'),
	(166594, 118, '2014-02-01 00:31:24.000000', 'temperatura', 575.0000, 'ºC'),
	(166595, 118, '2014-02-01 00:31:25.000000', 'temperatura', 990.0000, 'ºC'),
	(166596, 118, '2014-02-01 00:31:26.000000', 'temperatura', 824.0000, 'ºC'),
	(166597, 118, '2014-02-01 00:31:27.000000', 'temperatura', 1152.0000, 'ºC'),
	(166598, 118, '2014-02-01 00:31:28.000000', 'temperatura', 889.0000, 'ºC'),
	(166599, 118, '2014-02-01 00:31:29.000000', 'temperatura', 988.0000, 'ºC'),
	(166600, 118, '2014-02-01 00:31:30.000000', 'temperatura', 1073.0000, 'ºC'),
	(166601, 118, '2014-02-01 00:31:31.000000', 'temperatura', 3.0000, 'ºC'),
	(166602, 118, '2014-02-01 00:31:32.000000', 'temperatura', 396.0000, 'ºC'),
	(166603, 118, '2014-02-01 00:31:33.000000', 'temperatura', 770.0000, 'ºC'),
	(166604, 118, '2014-02-01 00:31:34.000000', 'temperatura', 264.0000, 'ºC'),
	(166605, 118, '2014-02-01 00:31:35.000000', 'temperatura', 211.0000, 'ºC'),
	(166606, 118, '2014-02-01 00:31:36.000000', 'temperatura', 261.0000, 'ºC'),
	(166607, 118, '2014-02-01 00:31:37.000000', 'temperatura', 674.0000, 'ºC'),
	(166608, 118, '2014-02-01 00:31:38.000000', 'temperatura', 186.0000, 'ºC'),
	(166609, 118, '2014-02-01 00:31:39.000000', 'temperatura', 111.0000, 'ºC'),
	(166610, 118, '2014-02-01 00:31:40.000000', 'temperatura', 1195.0000, 'ºC'),
	(166611, 118, '2014-02-01 00:31:41.000000', 'temperatura', 843.0000, 'ºC'),
	(166612, 118, '2014-02-01 00:31:42.000000', 'temperatura', 629.0000, 'ºC'),
	(166613, 118, '2014-02-01 00:31:43.000000', 'temperatura', 620.0000, 'ºC'),
	(166614, 118, '2014-02-01 00:31:44.000000', 'temperatura', 11.0000, 'ºC'),
	(166615, 118, '2014-02-01 00:31:45.000000', 'temperatura', 597.0000, 'ºC'),
	(166616, 118, '2014-02-01 00:31:46.000000', 'temperatura', 550.0000, 'ºC'),
	(166617, 118, '2014-02-01 00:31:47.000000', 'temperatura', 961.0000, 'ºC'),
	(166618, 118, '2014-02-01 00:31:48.000000', 'temperatura', 756.0000, 'ºC'),
	(166619, 118, '2014-02-01 00:31:49.000000', 'temperatura', 898.0000, 'ºC'),
	(166620, 118, '2014-02-01 00:31:50.000000', 'temperatura', 1023.0000, 'ºC'),
	(166621, 118, '2014-02-01 00:31:51.000000', 'temperatura', 22.0000, 'ºC'),
	(166622, 118, '2014-02-01 00:31:52.000000', 'temperatura', 639.0000, 'ºC'),
	(166623, 118, '2014-02-01 00:31:53.000000', 'temperatura', 730.0000, 'ºC'),
	(166624, 118, '2014-02-01 00:31:54.000000', 'temperatura', 535.0000, 'ºC'),
	(166625, 118, '2014-02-01 00:31:55.000000', 'temperatura', 483.0000, 'ºC'),
	(166626, 118, '2014-02-01 00:31:56.000000', 'temperatura', 814.0000, 'ºC'),
	(166627, 118, '2014-02-01 00:31:57.000000', 'temperatura', 219.0000, 'ºC'),
	(166628, 118, '2014-02-01 00:31:58.000000', 'temperatura', 1054.0000, 'ºC'),
	(166629, 118, '2014-02-01 00:31:59.000000', 'temperatura', 1013.0000, 'ºC'),
	(166630, 118, '2014-02-01 00:32:00.000000', 'temperatura', 706.0000, 'ºC'),
	(166631, 118, '2014-02-01 00:32:01.000000', 'temperatura', 489.0000, 'ºC'),
	(166632, 118, '2014-02-01 00:32:02.000000', 'temperatura', 329.0000, 'ºC'),
	(166633, 118, '2014-02-01 00:32:03.000000', 'temperatura', 178.0000, 'ºC'),
	(166634, 118, '2014-02-01 00:32:04.000000', 'temperatura', 1102.0000, 'ºC'),
	(166635, 118, '2014-02-01 00:32:05.000000', 'temperatura', 178.0000, 'ºC'),
	(166636, 118, '2014-02-01 00:32:06.000000', 'temperatura', 1182.0000, 'ºC'),
	(166637, 118, '2014-02-01 00:32:07.000000', 'temperatura', 578.0000, 'ºC'),
	(166638, 118, '2014-02-01 00:32:08.000000', 'temperatura', 546.0000, 'ºC'),
	(166639, 118, '2014-02-01 00:32:09.000000', 'temperatura', 996.0000, 'ºC'),
	(166640, 118, '2014-02-01 00:32:10.000000', 'temperatura', 944.0000, 'ºC'),
	(166641, 118, '2014-02-01 00:32:11.000000', 'temperatura', 530.0000, 'ºC'),
	(166642, 118, '2014-02-01 00:32:12.000000', 'temperatura', 1021.0000, 'ºC'),
	(166643, 118, '2014-02-01 00:32:13.000000', 'temperatura', 1113.0000, 'ºC'),
	(166644, 118, '2014-02-01 00:32:14.000000', 'temperatura', 101.0000, 'ºC'),
	(166645, 118, '2014-02-01 00:32:15.000000', 'temperatura', 770.0000, 'ºC'),
	(166646, 118, '2014-02-01 00:32:16.000000', 'temperatura', 1147.0000, 'ºC'),
	(166647, 118, '2014-02-01 00:32:17.000000', 'temperatura', 1023.0000, 'ºC'),
	(166648, 118, '2014-02-01 00:32:18.000000', 'temperatura', 477.0000, 'ºC'),
	(166649, 118, '2014-02-01 00:32:19.000000', 'temperatura', 517.0000, 'ºC'),
	(166650, 118, '2014-02-01 00:32:20.000000', 'temperatura', 1155.0000, 'ºC'),
	(166651, 118, '2014-02-01 00:32:21.000000', 'temperatura', 621.0000, 'ºC'),
	(166652, 118, '2014-02-01 00:32:22.000000', 'temperatura', 844.0000, 'ºC'),
	(166653, 118, '2014-02-01 00:32:23.000000', 'temperatura', 1157.0000, 'ºC'),
	(166654, 118, '2014-02-01 00:32:24.000000', 'temperatura', 853.0000, 'ºC'),
	(166655, 118, '2014-02-01 00:32:25.000000', 'temperatura', 796.0000, 'ºC'),
	(166656, 118, '2014-02-01 00:32:26.000000', 'temperatura', 223.0000, 'ºC'),
	(166657, 118, '2014-02-01 00:32:27.000000', 'temperatura', 1124.0000, 'ºC'),
	(166658, 118, '2014-02-01 00:32:28.000000', 'temperatura', 153.0000, 'ºC'),
	(166659, 118, '2014-02-01 00:32:29.000000', 'temperatura', 992.0000, 'ºC'),
	(166660, 118, '2014-02-01 00:32:30.000000', 'temperatura', 902.0000, 'ºC'),
	(166661, 118, '2014-02-01 00:32:31.000000', 'temperatura', 333.0000, 'ºC'),
	(166662, 118, '2014-02-01 00:32:32.000000', 'temperatura', 160.0000, 'ºC'),
	(166663, 118, '2014-02-01 00:32:33.000000', 'temperatura', 1000.0000, 'ºC'),
	(166664, 118, '2014-02-01 00:32:34.000000', 'temperatura', 921.0000, 'ºC'),
	(166665, 118, '2014-02-01 00:32:35.000000', 'temperatura', 408.0000, 'ºC'),
	(166666, 118, '2014-02-01 00:32:36.000000', 'temperatura', 475.0000, 'ºC'),
	(166667, 118, '2014-02-01 00:32:37.000000', 'temperatura', 1154.0000, 'ºC'),
	(166668, 118, '2014-02-01 00:32:38.000000', 'temperatura', 744.0000, 'ºC'),
	(166669, 118, '2014-02-01 00:32:39.000000', 'temperatura', 257.0000, 'ºC'),
	(166670, 118, '2014-02-01 00:32:40.000000', 'temperatura', 253.0000, 'ºC'),
	(166671, 118, '2014-02-01 00:32:41.000000', 'temperatura', 496.0000, 'ºC'),
	(166672, 118, '2014-02-01 00:32:42.000000', 'temperatura', 521.0000, 'ºC'),
	(166673, 118, '2014-02-01 00:32:43.000000', 'temperatura', 1118.0000, 'ºC'),
	(166674, 118, '2014-02-01 00:32:44.000000', 'temperatura', 429.0000, 'ºC'),
	(166675, 118, '2014-02-01 00:32:45.000000', 'temperatura', 1192.0000, 'ºC'),
	(166676, 118, '2014-02-01 00:32:46.000000', 'temperatura', 1073.0000, 'ºC'),
	(166677, 118, '2014-02-01 00:32:47.000000', 'temperatura', 588.0000, 'ºC'),
	(166678, 118, '2014-02-01 00:32:48.000000', 'temperatura', 923.0000, 'ºC'),
	(166679, 118, '2014-02-01 00:32:49.000000', 'temperatura', 450.0000, 'ºC'),
	(166680, 118, '2014-02-01 00:32:50.000000', 'temperatura', 682.0000, 'ºC'),
	(166681, 118, '2014-02-01 00:32:51.000000', 'temperatura', 860.0000, 'ºC'),
	(166682, 118, '2014-02-01 00:32:52.000000', 'temperatura', 1055.0000, 'ºC'),
	(166683, 118, '2014-02-01 00:32:53.000000', 'temperatura', 295.0000, 'ºC'),
	(166684, 118, '2014-02-01 00:32:54.000000', 'temperatura', 709.0000, 'ºC'),
	(166685, 118, '2014-02-01 00:32:55.000000', 'temperatura', 263.0000, 'ºC'),
	(166686, 118, '2014-02-01 00:32:56.000000', 'temperatura', 388.0000, 'ºC'),
	(166687, 118, '2014-02-01 00:32:57.000000', 'temperatura', 1151.0000, 'ºC'),
	(166688, 118, '2014-02-01 00:32:58.000000', 'temperatura', 991.0000, 'ºC'),
	(166689, 118, '2014-02-01 00:32:59.000000', 'temperatura', 304.0000, 'ºC'),
	(166690, 118, '2014-02-01 00:33:00.000000', 'temperatura', 945.0000, 'ºC'),
	(166691, 118, '2014-02-01 00:33:01.000000', 'temperatura', 216.0000, 'ºC'),
	(166692, 118, '2014-02-01 00:33:02.000000', 'temperatura', 644.0000, 'ºC'),
	(166693, 118, '2014-02-01 00:33:03.000000', 'temperatura', 174.0000, 'ºC'),
	(166694, 118, '2014-02-01 00:33:04.000000', 'temperatura', 140.0000, 'ºC'),
	(166695, 118, '2014-02-01 00:33:05.000000', 'temperatura', 175.0000, 'ºC'),
	(166696, 118, '2014-02-01 00:33:06.000000', 'temperatura', 459.0000, 'ºC'),
	(166697, 118, '2014-02-01 00:33:07.000000', 'temperatura', 569.0000, 'ºC'),
	(166698, 118, '2014-02-01 00:33:08.000000', 'temperatura', 267.0000, 'ºC'),
	(166699, 118, '2014-02-01 00:33:09.000000', 'temperatura', 828.0000, 'ºC'),
	(166700, 118, '2014-02-01 00:33:10.000000', 'temperatura', 942.0000, 'ºC'),
	(166701, 118, '2014-02-01 00:33:11.000000', 'temperatura', 1024.0000, 'ºC'),
	(166702, 118, '2014-02-01 00:33:12.000000', 'temperatura', 1094.0000, 'ºC'),
	(166703, 118, '2014-02-01 00:33:13.000000', 'temperatura', 1.0000, 'ºC'),
	(166704, 118, '2014-02-01 00:33:14.000000', 'temperatura', 321.0000, 'ºC'),
	(166705, 118, '2014-02-01 00:33:15.000000', 'temperatura', 404.0000, 'ºC'),
	(166706, 118, '2014-02-01 00:33:16.000000', 'temperatura', 1059.0000, 'ºC'),
	(166707, 118, '2014-02-01 00:33:17.000000', 'temperatura', 480.0000, 'ºC'),
	(166708, 118, '2014-02-01 00:33:18.000000', 'temperatura', 427.0000, 'ºC'),
	(166709, 118, '2014-02-01 00:33:19.000000', 'temperatura', 692.0000, 'ºC'),
	(166710, 118, '2014-02-01 00:33:20.000000', 'temperatura', 981.0000, 'ºC'),
	(166711, 118, '2014-02-01 00:33:21.000000', 'temperatura', 430.0000, 'ºC'),
	(166712, 118, '2014-02-01 00:33:22.000000', 'temperatura', 408.0000, 'ºC'),
	(166713, 118, '2014-02-01 00:33:23.000000', 'temperatura', 750.0000, 'ºC'),
	(166714, 118, '2014-02-01 00:33:24.000000', 'temperatura', 127.0000, 'ºC'),
	(166715, 118, '2014-02-01 00:33:25.000000', 'temperatura', 785.0000, 'ºC'),
	(166716, 118, '2014-02-01 00:33:26.000000', 'temperatura', 1146.0000, 'ºC'),
	(166717, 118, '2014-02-01 00:33:27.000000', 'temperatura', 973.0000, 'ºC'),
	(166718, 118, '2014-02-01 00:33:28.000000', 'temperatura', 230.0000, 'ºC'),
	(166719, 118, '2014-02-01 00:33:29.000000', 'temperatura', 631.0000, 'ºC'),
	(166720, 118, '2014-02-01 00:33:30.000000', 'temperatura', 64.0000, 'ºC'),
	(166721, 118, '2014-02-01 00:33:31.000000', 'temperatura', 826.0000, 'ºC'),
	(166722, 118, '2014-02-01 00:33:32.000000', 'temperatura', 341.0000, 'ºC'),
	(166723, 118, '2014-02-01 00:33:33.000000', 'temperatura', 426.0000, 'ºC'),
	(166724, 118, '2014-02-01 00:33:34.000000', 'temperatura', 1110.0000, 'ºC'),
	(166725, 118, '2014-02-01 00:33:35.000000', 'temperatura', 672.0000, 'ºC'),
	(166726, 118, '2014-02-01 00:33:36.000000', 'temperatura', 31.0000, 'ºC'),
	(166727, 118, '2014-02-01 00:33:37.000000', 'temperatura', 539.0000, 'ºC'),
	(166728, 118, '2014-02-01 00:33:38.000000', 'temperatura', 202.0000, 'ºC'),
	(166729, 118, '2014-02-01 00:33:39.000000', 'temperatura', 594.0000, 'ºC'),
	(166730, 118, '2014-02-01 00:33:40.000000', 'temperatura', 1166.0000, 'ºC'),
	(166731, 118, '2014-02-01 00:33:41.000000', 'temperatura', 448.0000, 'ºC'),
	(166732, 118, '2014-02-01 00:33:42.000000', 'temperatura', 1142.0000, 'ºC'),
	(166733, 118, '2014-02-01 00:33:43.000000', 'temperatura', 768.0000, 'ºC'),
	(166734, 118, '2014-02-01 00:33:44.000000', 'temperatura', 414.0000, 'ºC'),
	(166735, 118, '2014-02-01 00:33:45.000000', 'temperatura', 965.0000, 'ºC'),
	(166736, 118, '2014-02-01 00:33:46.000000', 'temperatura', 1185.0000, 'ºC'),
	(166737, 118, '2014-02-01 00:33:47.000000', 'temperatura', 628.0000, 'ºC'),
	(166738, 118, '2014-02-01 00:33:48.000000', 'temperatura', 787.0000, 'ºC'),
	(166739, 118, '2014-02-01 00:33:49.000000', 'temperatura', 850.0000, 'ºC'),
	(166740, 118, '2014-02-01 00:33:50.000000', 'temperatura', 689.0000, 'ºC'),
	(166741, 118, '2014-02-01 00:33:51.000000', 'temperatura', 896.0000, 'ºC'),
	(166742, 118, '2014-02-01 00:33:52.000000', 'temperatura', 14.0000, 'ºC'),
	(166743, 118, '2014-02-01 00:33:53.000000', 'temperatura', 984.0000, 'ºC'),
	(166744, 118, '2014-02-01 00:33:54.000000', 'temperatura', 79.0000, 'ºC'),
	(166745, 118, '2014-02-01 00:33:55.000000', 'temperatura', 1043.0000, 'ºC'),
	(166746, 118, '2014-02-01 00:33:56.000000', 'temperatura', 179.0000, 'ºC'),
	(166747, 118, '2014-02-01 00:33:57.000000', 'temperatura', 165.0000, 'ºC'),
	(166748, 118, '2014-02-01 00:33:58.000000', 'temperatura', 287.0000, 'ºC'),
	(166749, 118, '2014-02-01 00:33:59.000000', 'temperatura', 944.0000, 'ºC'),
	(166750, 118, '2014-02-01 00:34:00.000000', 'temperatura', 256.0000, 'ºC'),
	(166751, 118, '2014-02-01 00:34:01.000000', 'temperatura', 850.0000, 'ºC'),
	(166752, 118, '2014-02-01 00:34:02.000000', 'temperatura', 1082.0000, 'ºC'),
	(166753, 118, '2014-02-01 00:34:03.000000', 'temperatura', 463.0000, 'ºC'),
	(166754, 118, '2014-02-01 00:34:04.000000', 'temperatura', 267.0000, 'ºC'),
	(166755, 118, '2014-02-01 00:34:05.000000', 'temperatura', 1149.0000, 'ºC'),
	(166756, 118, '2014-02-01 00:34:06.000000', 'temperatura', 141.0000, 'ºC'),
	(166757, 118, '2014-02-01 00:34:07.000000', 'temperatura', 861.0000, 'ºC'),
	(166758, 118, '2014-02-01 00:34:08.000000', 'temperatura', 283.0000, 'ºC'),
	(166759, 118, '2014-02-01 00:34:09.000000', 'temperatura', 32.0000, 'ºC'),
	(166760, 118, '2014-02-01 00:34:10.000000', 'temperatura', 513.0000, 'ºC'),
	(166761, 118, '2014-02-01 00:34:11.000000', 'temperatura', 66.0000, 'ºC'),
	(166762, 118, '2014-02-01 00:34:12.000000', 'temperatura', 1195.0000, 'ºC'),
	(166763, 118, '2014-02-01 00:34:13.000000', 'temperatura', 976.0000, 'ºC'),
	(166764, 118, '2014-02-01 00:34:14.000000', 'temperatura', 94.0000, 'ºC'),
	(166765, 118, '2014-02-01 00:34:15.000000', 'temperatura', 1146.0000, 'ºC'),
	(166766, 118, '2014-02-01 00:34:16.000000', 'temperatura', 645.0000, 'ºC'),
	(166767, 118, '2014-02-01 00:34:17.000000', 'temperatura', 988.0000, 'ºC'),
	(166768, 118, '2014-02-01 00:34:18.000000', 'temperatura', 606.0000, 'ºC'),
	(166769, 118, '2014-02-01 00:34:19.000000', 'temperatura', 66.0000, 'ºC'),
	(166770, 118, '2014-02-01 00:34:20.000000', 'temperatura', 913.0000, 'ºC'),
	(166771, 118, '2014-02-01 00:34:21.000000', 'temperatura', 766.0000, 'ºC'),
	(166772, 118, '2014-02-01 00:34:22.000000', 'temperatura', 1093.0000, 'ºC'),
	(166773, 118, '2014-02-01 00:34:23.000000', 'temperatura', 768.0000, 'ºC'),
	(166774, 118, '2014-02-01 00:34:24.000000', 'temperatura', 562.0000, 'ºC'),
	(166775, 118, '2014-02-01 00:34:25.000000', 'temperatura', 505.0000, 'ºC'),
	(166776, 118, '2014-02-01 00:34:26.000000', 'temperatura', 841.0000, 'ºC'),
	(166777, 118, '2014-02-01 00:34:27.000000', 'temperatura', 288.0000, 'ºC'),
	(166778, 118, '2014-02-01 00:34:28.000000', 'temperatura', 120.0000, 'ºC'),
	(166779, 118, '2014-02-01 00:34:29.000000', 'temperatura', 938.0000, 'ºC'),
	(166780, 118, '2014-02-01 00:34:30.000000', 'temperatura', 727.0000, 'ºC'),
	(166781, 118, '2014-02-01 00:34:31.000000', 'temperatura', 825.0000, 'ºC'),
	(166782, 118, '2014-02-01 00:34:32.000000', 'temperatura', 741.0000, 'ºC'),
	(166783, 118, '2014-02-01 00:34:33.000000', 'temperatura', 33.0000, 'ºC'),
	(166784, 118, '2014-02-01 00:34:34.000000', 'temperatura', 344.0000, 'ºC'),
	(166785, 118, '2014-02-01 00:34:35.000000', 'temperatura', 418.0000, 'ºC'),
	(166786, 118, '2014-02-01 00:34:36.000000', 'temperatura', 1059.0000, 'ºC'),
	(166787, 118, '2014-02-01 00:34:37.000000', 'temperatura', 442.0000, 'ºC'),
	(166788, 118, '2014-02-01 00:34:38.000000', 'temperatura', 235.0000, 'ºC'),
	(166789, 118, '2014-02-01 00:34:39.000000', 'temperatura', 1047.0000, 'ºC'),
	(166790, 118, '2014-02-01 00:34:40.000000', 'temperatura', 930.0000, 'ºC'),
	(166791, 118, '2014-02-01 00:34:41.000000', 'temperatura', 312.0000, 'ºC'),
	(166792, 118, '2014-02-01 00:34:42.000000', 'temperatura', 1170.0000, 'ºC'),
	(166793, 118, '2014-02-01 00:34:43.000000', 'temperatura', 114.0000, 'ºC'),
	(166794, 118, '2014-02-01 00:34:44.000000', 'temperatura', 663.0000, 'ºC'),
	(166795, 118, '2014-02-01 00:34:45.000000', 'temperatura', 570.0000, 'ºC'),
	(166796, 118, '2014-02-01 00:34:46.000000', 'temperatura', 863.0000, 'ºC'),
	(166797, 118, '2014-02-01 00:34:47.000000', 'temperatura', 205.0000, 'ºC'),
	(166798, 118, '2014-02-01 00:34:48.000000', 'temperatura', 836.0000, 'ºC'),
	(166799, 118, '2014-02-01 00:34:49.000000', 'temperatura', 1165.0000, 'ºC'),
	(166800, 118, '2014-02-01 00:34:50.000000', 'temperatura', 918.0000, 'ºC'),
	(166801, 118, '2014-02-01 00:34:51.000000', 'temperatura', 1095.0000, 'ºC'),
	(166802, 118, '2014-02-01 00:34:52.000000', 'temperatura', 321.0000, 'ºC'),
	(166803, 118, '2014-02-01 00:34:53.000000', 'temperatura', 721.0000, 'ºC'),
	(166804, 118, '2014-02-01 00:34:54.000000', 'temperatura', 243.0000, 'ºC'),
	(166805, 118, '2014-02-01 00:34:55.000000', 'temperatura', 251.0000, 'ºC'),
	(166806, 118, '2014-02-01 00:34:56.000000', 'temperatura', 528.0000, 'ºC'),
	(166807, 118, '2014-02-01 00:34:57.000000', 'temperatura', 686.0000, 'ºC'),
	(166808, 118, '2014-02-01 00:34:58.000000', 'temperatura', 649.0000, 'ºC'),
	(166809, 118, '2014-02-01 00:34:59.000000', 'temperatura', 1185.0000, 'ºC'),
	(166810, 118, '2014-02-01 00:35:00.000000', 'temperatura', 379.0000, 'ºC'),
	(166811, 118, '2014-02-01 00:35:01.000000', 'temperatura', 741.0000, 'ºC'),
	(166812, 118, '2014-02-01 00:35:02.000000', 'temperatura', 168.0000, 'ºC'),
	(166813, 118, '2014-02-01 00:35:03.000000', 'temperatura', 1019.0000, 'ºC'),
	(166814, 118, '2014-02-01 00:35:04.000000', 'temperatura', 991.0000, 'ºC'),
	(166815, 118, '2014-02-01 00:35:05.000000', 'temperatura', 697.0000, 'ºC'),
	(166816, 118, '2014-02-01 00:35:06.000000', 'temperatura', 513.0000, 'ºC'),
	(166817, 118, '2014-02-01 00:35:07.000000', 'temperatura', 474.0000, 'ºC'),
	(166818, 118, '2014-02-01 00:35:08.000000', 'temperatura', 831.0000, 'ºC'),
	(166819, 118, '2014-02-01 00:35:09.000000', 'temperatura', 334.0000, 'ºC'),
	(166820, 118, '2014-02-01 00:35:10.000000', 'temperatura', 377.0000, 'ºC'),
	(166821, 118, '2014-02-01 00:35:11.000000', 'temperatura', 885.0000, 'ºC'),
	(166822, 118, '2014-02-01 00:35:12.000000', 'temperatura', 893.0000, 'ºC'),
	(166823, 118, '2014-02-01 00:35:13.000000', 'temperatura', 611.0000, 'ºC'),
	(166824, 118, '2014-02-01 00:35:14.000000', 'temperatura', 377.0000, 'ºC'),
	(166825, 118, '2014-02-01 00:35:15.000000', 'temperatura', 54.0000, 'ºC'),
	(166826, 118, '2014-02-01 00:35:16.000000', 'temperatura', 339.0000, 'ºC'),
	(166827, 118, '2014-02-01 00:35:17.000000', 'temperatura', 334.0000, 'ºC'),
	(166828, 118, '2014-02-01 00:35:18.000000', 'temperatura', 655.0000, 'ºC'),
	(166829, 118, '2014-02-01 00:35:19.000000', 'temperatura', 1071.0000, 'ºC'),
	(166830, 118, '2014-02-01 00:35:20.000000', 'temperatura', 990.0000, 'ºC'),
	(166831, 118, '2014-02-01 00:35:21.000000', 'temperatura', 538.0000, 'ºC'),
	(166832, 118, '2014-02-01 00:35:22.000000', 'temperatura', 921.0000, 'ºC'),
	(166833, 118, '2014-02-01 00:35:23.000000', 'temperatura', 592.0000, 'ºC'),
	(166834, 118, '2014-02-01 00:35:24.000000', 'temperatura', 197.0000, 'ºC'),
	(166835, 118, '2014-02-01 00:35:25.000000', 'temperatura', 408.0000, 'ºC'),
	(166836, 118, '2014-02-01 00:35:26.000000', 'temperatura', 249.0000, 'ºC'),
	(166837, 118, '2014-02-01 00:35:27.000000', 'temperatura', 21.0000, 'ºC'),
	(166838, 118, '2014-02-01 00:35:28.000000', 'temperatura', 560.0000, 'ºC'),
	(166839, 118, '2014-02-01 00:35:29.000000', 'temperatura', 338.0000, 'ºC'),
	(166840, 118, '2014-02-01 00:35:30.000000', 'temperatura', 11.0000, 'ºC'),
	(166841, 118, '2014-02-01 00:35:31.000000', 'temperatura', 242.0000, 'ºC'),
	(166842, 118, '2014-02-01 00:35:32.000000', 'temperatura', 1178.0000, 'ºC'),
	(166843, 118, '2014-02-01 00:35:33.000000', 'temperatura', 362.0000, 'ºC'),
	(166844, 118, '2014-02-01 00:35:34.000000', 'temperatura', 679.0000, 'ºC'),
	(166845, 118, '2014-02-01 00:35:35.000000', 'temperatura', 1110.0000, 'ºC'),
	(166846, 118, '2014-02-01 00:35:36.000000', 'temperatura', 1112.0000, 'ºC'),
	(166847, 118, '2014-02-01 00:35:37.000000', 'temperatura', 1030.0000, 'ºC'),
	(166848, 118, '2014-02-01 00:35:38.000000', 'temperatura', 616.0000, 'ºC'),
	(166849, 118, '2014-02-01 00:35:39.000000', 'temperatura', 1190.0000, 'ºC'),
	(166850, 118, '2014-02-01 00:35:40.000000', 'temperatura', 502.0000, 'ºC'),
	(166851, 118, '2014-02-01 00:35:41.000000', 'temperatura', 141.0000, 'ºC'),
	(166852, 118, '2014-02-01 00:35:42.000000', 'temperatura', 397.0000, 'ºC'),
	(166853, 118, '2014-02-01 00:35:43.000000', 'temperatura', 365.0000, 'ºC'),
	(166854, 118, '2014-02-01 00:35:44.000000', 'temperatura', 634.0000, 'ºC'),
	(166855, 118, '2014-02-01 00:35:45.000000', 'temperatura', 875.0000, 'ºC'),
	(166856, 118, '2014-02-01 00:35:46.000000', 'temperatura', 72.0000, 'ºC'),
	(166857, 118, '2014-02-01 00:35:47.000000', 'temperatura', 137.0000, 'ºC'),
	(166858, 118, '2014-02-01 00:35:48.000000', 'temperatura', 469.0000, 'ºC'),
	(166859, 118, '2014-02-01 00:35:49.000000', 'temperatura', 735.0000, 'ºC'),
	(166860, 118, '2014-02-01 00:35:50.000000', 'temperatura', 1069.0000, 'ºC'),
	(166861, 118, '2014-02-01 00:35:51.000000', 'temperatura', 741.0000, 'ºC'),
	(166862, 118, '2014-02-01 00:35:52.000000', 'temperatura', 496.0000, 'ºC'),
	(166863, 118, '2014-02-01 00:35:53.000000', 'temperatura', 257.0000, 'ºC'),
	(166864, 118, '2014-02-01 00:35:54.000000', 'temperatura', 1001.0000, 'ºC'),
	(166865, 118, '2014-02-01 00:35:55.000000', 'temperatura', 632.0000, 'ºC'),
	(166866, 118, '2014-02-01 00:35:56.000000', 'temperatura', 158.0000, 'ºC'),
	(166867, 118, '2014-02-01 00:35:57.000000', 'temperatura', 96.0000, 'ºC'),
	(166868, 118, '2014-02-01 00:35:58.000000', 'temperatura', 5.0000, 'ºC'),
	(166869, 118, '2014-02-01 00:35:59.000000', 'temperatura', 940.0000, 'ºC'),
	(166870, 118, '2014-02-01 00:36:00.000000', 'temperatura', 1083.0000, 'ºC'),
	(166871, 118, '2014-02-01 00:36:01.000000', 'temperatura', 196.0000, 'ºC'),
	(166872, 118, '2014-02-01 00:36:02.000000', 'temperatura', 132.0000, 'ºC'),
	(166873, 118, '2014-02-01 00:36:03.000000', 'temperatura', 71.0000, 'ºC'),
	(166874, 118, '2014-02-01 00:36:04.000000', 'temperatura', 1160.0000, 'ºC'),
	(166875, 118, '2014-02-01 00:36:05.000000', 'temperatura', 788.0000, 'ºC'),
	(166876, 118, '2014-02-01 00:36:06.000000', 'temperatura', 459.0000, 'ºC'),
	(166877, 118, '2014-02-01 00:36:07.000000', 'temperatura', 1132.0000, 'ºC'),
	(166878, 118, '2014-02-01 00:36:08.000000', 'temperatura', 682.0000, 'ºC'),
	(166879, 118, '2014-02-01 00:36:09.000000', 'temperatura', 18.0000, 'ºC'),
	(166880, 118, '2014-02-01 00:36:10.000000', 'temperatura', 442.0000, 'ºC'),
	(166881, 118, '2014-02-01 00:36:11.000000', 'temperatura', 959.0000, 'ºC'),
	(166882, 118, '2014-02-01 00:36:12.000000', 'temperatura', 1067.0000, 'ºC'),
	(166883, 118, '2014-02-01 00:36:13.000000', 'temperatura', 59.0000, 'ºC'),
	(166884, 118, '2014-02-01 00:36:14.000000', 'temperatura', 696.0000, 'ºC'),
	(166885, 118, '2014-02-01 00:36:15.000000', 'temperatura', 904.0000, 'ºC'),
	(166886, 118, '2014-02-01 00:36:16.000000', 'temperatura', 32.0000, 'ºC'),
	(166887, 118, '2014-02-01 00:36:17.000000', 'temperatura', 1050.0000, 'ºC'),
	(166888, 118, '2014-02-01 00:36:18.000000', 'temperatura', 352.0000, 'ºC'),
	(166889, 118, '2014-02-01 00:36:19.000000', 'temperatura', 1012.0000, 'ºC'),
	(166890, 118, '2014-02-01 00:36:20.000000', 'temperatura', 405.0000, 'ºC'),
	(166891, 118, '2014-02-01 00:36:21.000000', 'temperatura', 187.0000, 'ºC'),
	(166892, 118, '2014-02-01 00:36:22.000000', 'temperatura', 922.0000, 'ºC'),
	(166893, 118, '2014-02-01 00:36:23.000000', 'temperatura', 450.0000, 'ºC'),
	(166894, 118, '2014-02-01 00:36:24.000000', 'temperatura', 683.0000, 'ºC'),
	(166895, 118, '2014-02-01 00:36:25.000000', 'temperatura', 864.0000, 'ºC'),
	(166896, 118, '2014-02-01 00:36:26.000000', 'temperatura', 1074.0000, 'ºC'),
	(166897, 118, '2014-02-01 00:36:27.000000', 'temperatura', 377.0000, 'ºC'),
	(166898, 118, '2014-02-01 00:36:28.000000', 'temperatura', 1062.0000, 'ºC'),
	(166899, 118, '2014-02-01 00:36:29.000000', 'temperatura', 582.0000, 'ºC'),
	(166900, 118, '2014-02-01 00:36:30.000000', 'temperatura', 924.0000, 'ºC'),
	(166901, 118, '2014-02-01 00:36:31.000000', 'temperatura', 473.0000, 'ºC'),
	(166902, 118, '2014-02-01 00:36:32.000000', 'temperatura', 794.0000, 'ºC'),
	(166903, 118, '2014-02-01 00:36:33.000000', 'temperatura', 150.0000, 'ºC'),
	(166904, 118, '2014-02-01 00:36:34.000000', 'temperatura', 769.0000, 'ºC'),
	(166905, 118, '2014-02-01 00:36:35.000000', 'temperatura', 994.0000, 'ºC'),
	(166906, 118, '2014-02-01 00:36:36.000000', 'temperatura', 265.0000, 'ºC'),
	(166907, 118, '2014-02-01 00:36:37.000000', 'temperatura', 743.0000, 'ºC'),
	(166908, 118, '2014-02-01 00:36:38.000000', 'temperatura', 521.0000, 'ºC'),
	(166909, 118, '2014-02-01 00:36:39.000000', 'temperatura', 375.0000, 'ºC'),
	(166910, 118, '2014-02-01 00:36:40.000000', 'temperatura', 312.0000, 'ºC'),
	(166911, 118, '2014-02-01 00:36:41.000000', 'temperatura', 439.0000, 'ºC'),
	(166912, 118, '2014-02-01 00:36:42.000000', 'temperatura', 56.0000, 'ºC'),
	(166913, 118, '2014-02-01 00:36:43.000000', 'temperatura', 163.0000, 'ºC'),
	(166914, 118, '2014-02-01 00:36:44.000000', 'temperatura', 650.0000, 'ºC'),
	(166915, 118, '2014-02-01 00:36:45.000000', 'temperatura', 360.0000, 'ºC'),
	(166916, 118, '2014-02-01 00:36:46.000000', 'temperatura', 1052.0000, 'ºC'),
	(166917, 118, '2014-02-01 00:36:47.000000', 'temperatura', 578.0000, 'ºC'),
	(166918, 118, '2014-02-01 00:36:48.000000', 'temperatura', 935.0000, 'ºC'),
	(166919, 118, '2014-02-01 00:36:49.000000', 'temperatura', 542.0000, 'ºC'),
	(166920, 118, '2014-02-01 00:36:50.000000', 'temperatura', 1104.0000, 'ºC'),
	(166921, 118, '2014-02-01 00:36:51.000000', 'temperatura', 297.0000, 'ºC'),
	(166922, 118, '2014-02-01 00:36:52.000000', 'temperatura', 572.0000, 'ºC'),
	(166923, 118, '2014-02-01 00:36:53.000000', 'temperatura', 770.0000, 'ºC'),
	(166924, 118, '2014-02-01 00:36:54.000000', 'temperatura', 933.0000, 'ºC'),
	(166925, 118, '2014-02-01 00:36:55.000000', 'temperatura', 1156.0000, 'ºC'),
	(166926, 118, '2014-02-01 00:36:56.000000', 'temperatura', 581.0000, 'ºC'),
	(166927, 118, '2014-02-01 00:36:57.000000', 'temperatura', 639.0000, 'ºC'),
	(166928, 118, '2014-02-01 00:36:58.000000', 'temperatura', 250.0000, 'ºC'),
	(166929, 118, '2014-02-01 00:36:59.000000', 'temperatura', 536.0000, 'ºC'),
	(166930, 118, '2014-02-01 00:37:00.000000', 'temperatura', 732.0000, 'ºC'),
	(166931, 118, '2014-02-01 00:37:01.000000', 'temperatura', 849.0000, 'ºC'),
	(166932, 118, '2014-02-01 00:37:02.000000', 'temperatura', 851.0000, 'ºC'),
	(166933, 118, '2014-02-01 00:37:03.000000', 'temperatura', 510.0000, 'ºC'),
	(166934, 118, '2014-02-01 00:37:04.000000', 'temperatura', 1195.0000, 'ºC'),
	(166935, 118, '2014-02-01 00:37:05.000000', 'temperatura', 844.0000, 'ºC'),
	(166936, 118, '2014-02-01 00:37:06.000000', 'temperatura', 639.0000, 'ºC'),
	(166937, 118, '2014-02-01 00:37:07.000000', 'temperatura', 663.0000, 'ºC'),
	(166938, 118, '2014-02-01 00:37:08.000000', 'temperatura', 196.0000, 'ºC'),
	(166939, 118, '2014-02-01 00:37:09.000000', 'temperatura', 194.0000, 'ºC'),
	(166940, 118, '2014-02-01 00:37:10.000000', 'temperatura', 382.0000, 'ºC'),
	(166941, 118, '2014-02-01 00:37:11.000000', 'temperatura', 129.0000, 'ºC'),
	(166942, 118, '2014-02-01 00:37:12.000000', 'temperatura', 698.0000, 'ºC'),
	(166943, 118, '2014-02-01 00:37:13.000000', 'temperatura', 705.0000, 'ºC'),
	(166944, 118, '2014-02-01 00:37:14.000000', 'temperatura', 230.0000, 'ºC'),
	(166945, 118, '2014-02-01 00:37:15.000000', 'temperatura', 236.0000, 'ºC'),
	(166946, 118, '2014-02-01 00:37:16.000000', 'temperatura', 491.0000, 'ºC'),
	(166947, 118, '2014-02-01 00:37:17.000000', 'temperatura', 545.0000, 'ºC'),
	(166948, 118, '2014-02-01 00:37:18.000000', 'temperatura', 56.0000, 'ºC'),
	(166949, 118, '2014-02-01 00:37:19.000000', 'temperatura', 1043.0000, 'ºC'),
	(166950, 118, '2014-02-01 00:37:20.000000', 'temperatura', 250.0000, 'ºC'),
	(166951, 118, '2014-02-01 00:37:21.000000', 'temperatura', 519.0000, 'ºC'),
	(166952, 118, '2014-02-01 00:37:22.000000', 'temperatura', 648.0000, 'ºC'),
	(166953, 118, '2014-02-01 00:37:23.000000', 'temperatura', 480.0000, 'ºC'),
	(166954, 118, '2014-02-01 00:37:24.000000', 'temperatura', 460.0000, 'ºC'),
	(166955, 118, '2014-02-01 00:37:25.000000', 'temperatura', 860.0000, 'ºC'),
	(166956, 118, '2014-02-01 00:37:26.000000', 'temperatura', 519.0000, 'ºC'),
	(166957, 118, '2014-02-01 00:37:27.000000', 'temperatura', 18.0000, 'ºC'),
	(166958, 118, '2014-02-01 00:37:28.000000', 'temperatura', 933.0000, 'ºC'),
	(166959, 118, '2014-02-01 00:37:29.000000', 'temperatura', 1010.0000, 'ºC'),
	(166960, 118, '2014-02-01 00:37:30.000000', 'temperatura', 1054.0000, 'ºC'),
	(166961, 118, '2014-02-01 00:37:31.000000', 'temperatura', 1040.0000, 'ºC'),
	(166962, 118, '2014-02-01 00:37:32.000000', 'temperatura', 837.0000, 'ºC'),
	(166963, 118, '2014-02-01 00:37:33.000000', 'temperatura', 1067.0000, 'ºC'),
	(166964, 118, '2014-02-01 00:37:34.000000', 'temperatura', 423.0000, 'ºC'),
	(166965, 118, '2014-02-01 00:37:35.000000', 'temperatura', 117.0000, 'ºC'),
	(166966, 118, '2014-02-01 00:37:36.000000', 'temperatura', 515.0000, 'ºC'),
	(166967, 118, '2014-02-01 00:37:37.000000', 'temperatura', 1026.0000, 'ºC'),
	(166968, 118, '2014-02-01 00:37:38.000000', 'temperatura', 1184.0000, 'ºC'),
	(166969, 118, '2014-02-01 00:37:39.000000', 'temperatura', 443.0000, 'ºC'),
	(166970, 118, '2014-02-01 00:37:40.000000', 'temperatura', 1063.0000, 'ºC'),
	(166971, 118, '2014-02-01 00:37:41.000000', 'temperatura', 386.0000, 'ºC'),
	(166972, 118, '2014-02-01 00:37:42.000000', 'temperatura', 1142.0000, 'ºC'),
	(166973, 118, '2014-02-01 00:37:43.000000', 'temperatura', 952.0000, 'ºC'),
	(166974, 118, '2014-02-01 00:37:44.000000', 'temperatura', 136.0000, 'ºC'),
	(166975, 118, '2014-02-01 00:37:45.000000', 'temperatura', 226.0000, 'ºC'),
	(166976, 118, '2014-02-01 00:37:46.000000', 'temperatura', 720.0000, 'ºC'),
	(166977, 118, '2014-02-01 00:37:47.000000', 'temperatura', 522.0000, 'ºC'),
	(166978, 118, '2014-02-01 00:37:48.000000', 'temperatura', 452.0000, 'ºC'),
	(166979, 118, '2014-02-01 00:37:49.000000', 'temperatura', 692.0000, 'ºC'),
	(166980, 118, '2014-02-01 00:37:50.000000', 'temperatura', 907.0000, 'ºC'),
	(166981, 118, '2014-02-01 00:37:51.000000', 'temperatura', 60.0000, 'ºC'),
	(166982, 118, '2014-02-01 00:37:52.000000', 'temperatura', 1180.0000, 'ºC'),
	(166983, 118, '2014-02-01 00:37:53.000000', 'temperatura', 920.0000, 'ºC'),
	(166984, 118, '2014-02-01 00:37:54.000000', 'temperatura', 1060.0000, 'ºC'),
	(166985, 118, '2014-02-01 00:37:55.000000', 'temperatura', 142.0000, 'ºC'),
	(166986, 118, '2014-02-01 00:37:56.000000', 'temperatura', 1131.0000, 'ºC'),
	(166987, 118, '2014-02-01 00:37:57.000000', 'temperatura', 430.0000, 'ºC'),
	(166988, 118, '2014-02-01 00:37:58.000000', 'temperatura', 1158.0000, 'ºC'),
	(166989, 118, '2014-02-01 00:37:59.000000', 'temperatura', 901.0000, 'ºC'),
	(166990, 118, '2014-02-01 00:38:00.000000', 'temperatura', 1030.0000, 'ºC'),
	(166991, 118, '2014-02-01 00:38:01.000000', 'temperatura', 46.0000, 'ºC'),
	(166992, 118, '2014-02-01 00:38:02.000000', 'temperatura', 740.0000, 'ºC'),
	(166993, 118, '2014-02-01 00:38:03.000000', 'temperatura', 1166.0000, 'ºC'),
	(166994, 118, '2014-02-01 00:38:04.000000', 'temperatura', 8.0000, 'ºC'),
	(166995, 118, '2014-02-01 00:38:05.000000', 'temperatura', 144.0000, 'ºC'),
	(166996, 118, '2014-02-01 00:38:06.000000', 'temperatura', 696.0000, 'ºC'),
	(166997, 118, '2014-02-01 00:38:07.000000', 'temperatura', 649.0000, 'ºC'),
	(166998, 118, '2014-02-01 00:38:08.000000', 'temperatura', 1158.0000, 'ºC'),
	(166999, 118, '2014-02-01 00:38:09.000000', 'temperatura', 241.0000, 'ºC'),
	(167000, 118, '2014-02-01 00:38:10.000000', 'temperatura', 133.0000, 'ºC'),
	(167001, 118, '2014-02-01 00:38:11.000000', 'temperatura', 1144.0000, 'ºC'),
	(167002, 118, '2014-02-01 00:38:12.000000', 'temperatura', 519.0000, 'ºC'),
	(167003, 118, '2014-02-01 00:38:13.000000', 'temperatura', 363.0000, 'ºC'),
	(167004, 118, '2014-02-01 00:38:14.000000', 'temperatura', 260.0000, 'ºC'),
	(167005, 118, '2014-02-01 00:38:15.000000', 'temperatura', 213.0000, 'ºC'),
	(167006, 118, '2014-02-01 00:38:16.000000', 'temperatura', 283.0000, 'ºC'),
	(167007, 118, '2014-02-01 00:38:17.000000', 'temperatura', 776.0000, 'ºC'),
	(167008, 118, '2014-02-01 00:38:18.000000', 'temperatura', 634.0000, 'ºC'),
	(167009, 118, '2014-02-01 00:38:19.000000', 'temperatura', 840.0000, 'ºC'),
	(167010, 118, '2014-02-01 00:38:20.000000', 'temperatura', 1098.0000, 'ºC'),
	(167011, 118, '2014-02-01 00:38:21.000000', 'temperatura', 571.0000, 'ºC'),
	(167012, 118, '2014-02-01 00:38:22.000000', 'temperatura', 764.0000, 'ºC'),
	(167013, 118, '2014-02-01 00:38:23.000000', 'temperatura', 904.0000, 'ºC'),
	(167014, 118, '2014-02-01 00:38:24.000000', 'temperatura', 1030.0000, 'ºC'),
	(167015, 118, '2014-02-01 00:38:25.000000', 'temperatura', 37.0000, 'ºC'),
	(167016, 118, '2014-02-01 00:38:26.000000', 'temperatura', 698.0000, 'ºC'),
	(167017, 118, '2014-02-01 00:38:27.000000', 'temperatura', 977.0000, 'ºC'),
	(167018, 118, '2014-02-01 00:38:28.000000', 'temperatura', 391.0000, 'ºC'),
	(167019, 118, '2014-02-01 00:38:29.000000', 'temperatura', 225.0000, 'ºC'),
	(167020, 118, '2014-02-01 00:38:30.000000', 'temperatura', 1154.0000, 'ºC'),
	(167021, 118, '2014-02-01 00:38:31.000000', 'temperatura', 297.0000, 'ºC'),
	(167022, 118, '2014-02-01 00:38:32.000000', 'temperatura', 421.0000, 'ºC'),
	(167023, 118, '2014-02-01 00:38:33.000000', 'temperatura', 16.0000, 'ºC'),
	(167024, 118, '2014-02-01 00:38:34.000000', 'temperatura', 16.0000, 'ºC'),
	(167025, 118, '2014-02-01 00:38:35.000000', 'temperatura', 35.0000, 'ºC'),
	(167026, 118, '2014-02-01 00:38:36.000000', 'temperatura', 124.0000, 'ºC'),
	(167027, 118, '2014-02-01 00:38:37.000000', 'temperatura', 518.0000, 'ºC'),
	(167028, 118, '2014-02-01 00:38:38.000000', 'temperatura', 1017.0000, 'ºC'),
	(167029, 118, '2014-02-01 00:38:39.000000', 'temperatura', 1133.0000, 'ºC'),
	(167030, 118, '2014-02-01 00:38:40.000000', 'temperatura', 213.0000, 'ºC'),
	(167031, 118, '2014-02-01 00:38:41.000000', 'temperatura', 66.0000, 'ºC'),
	(167032, 118, '2014-02-01 00:38:42.000000', 'temperatura', 892.0000, 'ºC'),
	(167033, 118, '2014-02-01 00:38:43.000000', 'temperatura', 664.0000, 'ºC'),
	(167034, 118, '2014-02-01 00:38:44.000000', 'temperatura', 644.0000, 'ºC'),
	(167035, 118, '2014-02-01 00:38:45.000000', 'temperatura', 29.0000, 'ºC'),
	(167036, 118, '2014-02-01 00:38:46.000000', 'temperatura', 613.0000, 'ºC'),
	(167037, 118, '2014-02-01 00:38:47.000000', 'temperatura', 580.0000, 'ºC'),
	(167038, 118, '2014-02-01 00:38:48.000000', 'temperatura', 1062.0000, 'ºC'),
	(167039, 118, '2014-02-01 00:38:49.000000', 'temperatura', 1170.0000, 'ºC'),
	(167040, 118, '2014-02-01 00:38:50.000000', 'temperatura', 266.0000, 'ºC'),
	(167041, 118, '2014-02-01 00:38:51.000000', 'temperatura', 217.0000, 'ºC'),
	(167042, 118, '2014-02-01 00:38:52.000000', 'temperatura', 291.0000, 'ºC'),
	(167043, 118, '2014-02-01 00:38:53.000000', 'temperatura', 802.0000, 'ºC'),
	(167044, 118, '2014-02-01 00:38:54.000000', 'temperatura', 738.0000, 'ºC'),
	(167045, 118, '2014-02-01 00:38:55.000000', 'temperatura', 85.0000, 'ºC'),
	(167046, 118, '2014-02-01 00:38:56.000000', 'temperatura', 612.0000, 'ºC'),
	(167047, 118, '2014-02-01 00:38:57.000000', 'temperatura', 405.0000, 'ºC'),
	(167048, 118, '2014-02-01 00:38:58.000000', 'temperatura', 188.0000, 'ºC'),
	(167049, 118, '2014-02-01 00:38:59.000000', 'temperatura', 925.0000, 'ºC'),
	(167050, 118, '2014-02-01 00:39:00.000000', 'temperatura', 461.0000, 'ºC'),
	(167051, 118, '2014-02-01 00:39:01.000000', 'temperatura', 733.0000, 'ºC'),
	(167052, 118, '2014-02-01 00:39:02.000000', 'temperatura', 1081.0000, 'ºC'),
	(167053, 118, '2014-02-01 00:39:03.000000', 'temperatura', 805.0000, 'ºC'),
	(167054, 118, '2014-02-01 00:39:04.000000', 'temperatura', 785.0000, 'ºC'),
	(167055, 118, '2014-02-01 00:39:05.000000', 'temperatura', 312.0000, 'ºC'),
	(167056, 118, '2014-02-01 00:39:06.000000', 'temperatura', 402.0000, 'ºC'),
	(167057, 118, '2014-02-01 00:39:07.000000', 'temperatura', 1075.0000, 'ºC'),
	(167058, 118, '2014-02-01 00:39:08.000000', 'temperatura', 571.0000, 'ºC'),
	(167059, 118, '2014-02-01 00:39:09.000000', 'temperatura', 830.0000, 'ºC'),
	(167060, 118, '2014-02-01 00:39:10.000000', 'temperatura', 39.0000, 'ºC'),
	(167061, 118, '2014-02-01 00:39:11.000000', 'temperatura', 103.0000, 'ºC'),
	(167062, 118, '2014-02-01 00:39:12.000000', 'temperatura', 400.0000, 'ºC'),
	(167063, 118, '2014-02-01 00:39:13.000000', 'temperatura', 491.0000, 'ºC'),
	(167064, 118, '2014-02-01 00:39:14.000000', 'temperatura', 58.0000, 'ºC'),
	(167065, 118, '2014-02-01 00:39:15.000000', 'temperatura', 14.0000, 'ºC'),
	(167066, 118, '2014-02-01 00:39:16.000000', 'temperatura', 1097.0000, 'ºC'),
	(167067, 118, '2014-02-01 00:39:17.000000', 'temperatura', 644.0000, 'ºC'),
	(167068, 118, '2014-02-01 00:39:18.000000', 'temperatura', 1130.0000, 'ºC'),
	(167069, 118, '2014-02-01 00:39:19.000000', 'temperatura', 119.0000, 'ºC'),
	(167070, 118, '2014-02-01 00:39:20.000000', 'temperatura', 804.0000, 'ºC'),
	(167071, 118, '2014-02-01 00:39:21.000000', 'temperatura', 63.0000, 'ºC'),
	(167072, 118, '2014-02-01 00:39:22.000000', 'temperatura', 303.0000, 'ºC'),
	(167073, 118, '2014-02-01 00:39:23.000000', 'temperatura', 129.0000, 'ºC'),
	(167074, 118, '2014-02-01 00:39:24.000000', 'temperatura', 937.0000, 'ºC'),
	(167075, 118, '2014-02-01 00:39:25.000000', 'temperatura', 695.0000, 'ºC'),
	(167076, 118, '2014-02-01 00:39:26.000000', 'temperatura', 668.0000, 'ºC'),
	(167077, 118, '2014-02-01 00:39:27.000000', 'temperatura', 53.0000, 'ºC'),
	(167078, 118, '2014-02-01 00:39:28.000000', 'temperatura', 661.0000, 'ºC'),
	(167079, 118, '2014-02-01 00:39:29.000000', 'temperatura', 748.0000, 'ºC'),
	(167080, 118, '2014-02-01 00:39:30.000000', 'temperatura', 557.0000, 'ºC'),
	(167081, 118, '2014-02-01 00:39:31.000000', 'temperatura', 542.0000, 'ºC'),
	(167082, 118, '2014-02-01 00:39:32.000000', 'temperatura', 1041.0000, 'ºC'),
	(167083, 118, '2014-02-01 00:39:33.000000', 'temperatura', 1177.0000, 'ºC'),
	(167084, 118, '2014-02-01 00:39:34.000000', 'temperatura', 361.0000, 'ºC'),
	(167085, 118, '2014-02-01 00:39:35.000000', 'temperatura', 678.0000, 'ºC'),
	(167086, 118, '2014-02-01 00:39:36.000000', 'temperatura', 1105.0000, 'ºC'),
	(167087, 118, '2014-02-01 00:39:37.000000', 'temperatura', 1093.0000, 'ºC'),
	(167088, 118, '2014-02-01 00:39:38.000000', 'temperatura', 949.0000, 'ºC'),
	(167089, 118, '2014-02-01 00:39:39.000000', 'temperatura', 267.0000, 'ºC'),
	(167090, 118, '2014-02-01 00:39:40.000000', 'temperatura', 887.0000, 'ºC'),
	(167091, 118, '2014-02-01 00:39:41.000000', 'temperatura', 35.0000, 'ºC'),
	(167092, 118, '2014-02-01 00:39:42.000000', 'temperatura', 1116.0000, 'ºC'),
	(167093, 118, '2014-02-01 00:39:43.000000', 'temperatura', 674.0000, 'ºC'),
	(167094, 118, '2014-02-01 00:39:44.000000', 'temperatura', 24.0000, 'ºC'),
	(167095, 118, '2014-02-01 00:39:45.000000', 'temperatura', 498.0000, 'ºC'),
	(167096, 118, '2014-02-01 00:39:46.000000', 'temperatura', 19.0000, 'ºC'),
	(167097, 118, '2014-02-01 00:39:47.000000', 'temperatura', 1002.0000, 'ºC'),
	(167098, 118, '2014-02-01 00:39:48.000000', 'temperatura', 152.0000, 'ºC'),
	(167099, 118, '2014-02-01 00:39:49.000000', 'temperatura', 157.0000, 'ºC'),
	(167100, 118, '2014-02-01 00:39:50.000000', 'temperatura', 327.0000, 'ºC'),
	(167101, 118, '2014-02-01 00:39:51.000000', 'temperatura', 1167.0000, 'ºC'),
	(167102, 118, '2014-02-01 00:39:52.000000', 'temperatura', 51.0000, 'ºC'),
	(167103, 118, '2014-02-01 00:39:53.000000', 'temperatura', 357.0000, 'ºC'),
	(167104, 118, '2014-02-01 00:39:54.000000', 'temperatura', 433.0000, 'ºC'),
	(167105, 118, '2014-02-01 00:39:55.000000', 'temperatura', 1092.0000, 'ºC'),
	(167106, 118, '2014-02-01 00:39:56.000000', 'temperatura', 563.0000, 'ºC'),
	(167107, 118, '2014-02-01 00:39:57.000000', 'temperatura', 740.0000, 'ºC'),
	(167108, 118, '2014-02-01 00:39:58.000000', 'temperatura', 812.0000, 'ºC'),
	(167109, 118, '2014-02-01 00:39:59.000000', 'temperatura', 640.0000, 'ºC'),
	(167110, 118, '2014-02-01 00:40:00.000000', 'temperatura', 765.0000, 'ºC'),
	(167111, 118, '2014-02-01 00:40:01.000000', 'temperatura', 707.0000, 'ºC'),
	(167112, 118, '2014-02-01 00:40:02.000000', 'temperatura', 39.0000, 'ºC'),
	(167113, 118, '2014-02-01 00:40:03.000000', 'temperatura', 474.0000, 'ºC'),
	(167114, 118, '2014-02-01 00:40:04.000000', 'temperatura', 1054.0000, 'ºC'),
	(167115, 118, '2014-02-01 00:40:05.000000', 'temperatura', 247.0000, 'ºC'),
	(167116, 118, '2014-02-01 00:40:06.000000', 'temperatura', 473.0000, 'ºC'),
	(167117, 118, '2014-02-01 00:40:07.000000', 'temperatura', 425.0000, 'ºC'),
	(167118, 118, '2014-02-01 00:40:08.000000', 'temperatura', 706.0000, 'ºC'),
	(167119, 118, '2014-02-01 00:40:09.000000', 'temperatura', 1055.0000, 'ºC'),
	(167120, 118, '2014-02-01 00:40:10.000000', 'temperatura', 756.0000, 'ºC'),
	(167121, 118, '2014-02-01 00:40:11.000000', 'temperatura', 618.0000, 'ºC'),
	(167122, 118, '2014-02-01 00:40:12.000000', 'temperatura', 823.0000, 'ºC'),
	(167123, 118, '2014-02-01 00:40:13.000000', 'temperatura', 1063.0000, 'ºC'),
	(167124, 118, '2014-02-01 00:40:14.000000', 'temperatura', 443.0000, 'ºC'),
	(167125, 118, '2014-02-01 00:40:15.000000', 'temperatura', 230.0000, 'ºC'),
	(167126, 118, '2014-02-01 00:40:16.000000', 'temperatura', 1020.0000, 'ºC'),
	(167127, 118, '2014-02-01 00:40:17.000000', 'temperatura', 810.0000, 'ºC'),
	(167128, 118, '2014-02-01 00:40:18.000000', 'temperatura', 991.0000, 'ºC'),
	(167129, 118, '2014-02-01 00:40:19.000000', 'temperatura', 124.0000, 'ºC'),
	(167130, 118, '2014-02-01 00:40:20.000000', 'temperatura', 48.0000, 'ºC'),
	(167131, 118, '2014-02-01 00:40:21.000000', 'temperatura', 1071.0000, 'ºC'),
	(167132, 118, '2014-02-01 00:40:22.000000', 'temperatura', 408.0000, 'ºC'),
	(167133, 118, '2014-02-01 00:40:23.000000', 'temperatura', 28.0000, 'ºC'),
	(167134, 118, '2014-02-01 00:40:24.000000', 'temperatura', 119.0000, 'ºC'),
	(167135, 118, '2014-02-01 00:40:25.000000', 'temperatura', 509.0000, 'ºC'),
	(167136, 118, '2014-02-01 00:40:26.000000', 'temperatura', 991.0000, 'ºC'),
	(167137, 118, '2014-02-01 00:40:27.000000', 'temperatura', 1029.0000, 'ºC'),
	(167138, 118, '2014-02-01 00:40:28.000000', 'temperatura', 970.0000, 'ºC'),
	(167139, 118, '2014-02-01 00:40:29.000000', 'temperatura', 563.0000, 'ºC'),
	(167140, 118, '2014-02-01 00:40:30.000000', 'temperatura', 1108.0000, 'ºC'),
	(167141, 118, '2014-02-01 00:40:31.000000', 'temperatura', 252.0000, 'ºC'),
	(167142, 118, '2014-02-01 00:40:32.000000', 'temperatura', 335.0000, 'ºC'),
	(167143, 118, '2014-02-01 00:40:33.000000', 'temperatura', 919.0000, 'ºC'),
	(167144, 118, '2014-02-01 00:40:34.000000', 'temperatura', 1193.0000, 'ºC'),
	(167145, 118, '2014-02-01 00:40:35.000000', 'temperatura', 805.0000, 'ºC'),
	(167146, 118, '2014-02-01 00:40:36.000000', 'temperatura', 448.0000, 'ºC'),
	(167147, 118, '2014-02-01 00:40:37.000000', 'temperatura', 1027.0000, 'ºC'),
	(167148, 118, '2014-02-01 00:40:38.000000', 'temperatura', 190.0000, 'ºC'),
	(167149, 118, '2014-02-01 00:40:39.000000', 'temperatura', 269.0000, 'ºC'),
	(167150, 118, '2014-02-01 00:40:40.000000', 'temperatura', 775.0000, 'ºC'),
	(167151, 118, '2014-02-01 00:40:41.000000', 'temperatura', 670.0000, 'ºC'),
	(167152, 118, '2014-02-01 00:40:42.000000', 'temperatura', 1026.0000, 'ºC'),
	(167153, 118, '2014-02-01 00:40:43.000000', 'temperatura', 718.0000, 'ºC'),
	(167154, 118, '2014-02-01 00:40:44.000000', 'temperatura', 514.0000, 'ºC'),
	(167155, 118, '2014-02-01 00:40:45.000000', 'temperatura', 416.0000, 'ºC'),
	(167156, 118, '2014-02-01 00:40:46.000000', 'temperatura', 540.0000, 'ºC'),
	(167157, 118, '2014-02-01 00:40:47.000000', 'temperatura', 254.0000, 'ºC'),
	(167158, 118, '2014-02-01 00:40:48.000000', 'temperatura', 848.0000, 'ºC'),
	(167159, 118, '2014-02-01 00:40:49.000000', 'temperatura', 1077.0000, 'ºC'),
	(167160, 118, '2014-02-01 00:40:50.000000', 'temperatura', 445.0000, 'ºC'),
	(167161, 118, '2014-02-01 00:40:51.000000', 'temperatura', 192.0000, 'ºC'),
	(167162, 118, '2014-02-01 00:40:52.000000', 'temperatura', 826.0000, 'ºC'),
	(167163, 118, '2014-02-01 00:40:53.000000', 'temperatura', 1155.0000, 'ºC'),
	(167164, 118, '2014-02-01 00:40:54.000000', 'temperatura', 898.0000, 'ºC'),
	(167165, 118, '2014-02-01 00:40:55.000000', 'temperatura', 1024.0000, 'ºC'),
	(167166, 118, '2014-02-01 00:40:56.000000', 'temperatura', 26.0000, 'ºC'),
	(167167, 118, '2014-02-01 00:40:57.000000', 'temperatura', 661.0000, 'ºC'),
	(167168, 118, '2014-02-01 00:40:58.000000', 'temperatura', 825.0000, 'ºC'),
	(167169, 118, '2014-02-01 00:40:59.000000', 'temperatura', 943.0000, 'ºC'),
	(167170, 118, '2014-02-01 00:41:00.000000', 'temperatura', 1040.0000, 'ºC'),
	(167171, 118, '2014-02-01 00:41:01.000000', 'temperatura', 1173.0000, 'ºC'),
	(167172, 118, '2014-02-01 00:41:02.000000', 'temperatura', 344.0000, 'ºC'),
	(167173, 118, '2014-02-01 00:41:03.000000', 'temperatura', 602.0000, 'ºC'),
	(167174, 118, '2014-02-01 00:41:04.000000', 'temperatura', 779.0000, 'ºC'),
	(167175, 118, '2014-02-01 00:41:05.000000', 'temperatura', 888.0000, 'ºC'),
	(167176, 118, '2014-02-01 00:41:06.000000', 'temperatura', 904.0000, 'ºC'),
	(167177, 118, '2014-02-01 00:41:07.000000', 'temperatura', 657.0000, 'ºC'),
	(167178, 118, '2014-02-01 00:41:08.000000', 'temperatura', 571.0000, 'ºC'),
	(167179, 118, '2014-02-01 00:41:09.000000', 'temperatura', 887.0000, 'ºC'),
	(167180, 118, '2014-02-01 00:41:10.000000', 'temperatura', 322.0000, 'ºC'),
	(167181, 118, '2014-02-01 00:41:11.000000', 'temperatura', 148.0000, 'ºC'),
	(167182, 118, '2014-02-01 00:41:12.000000', 'temperatura', 975.0000, 'ºC'),
	(167183, 118, '2014-02-01 00:41:13.000000', 'temperatura', 830.0000, 'ºC'),
	(167184, 118, '2014-02-01 00:41:14.000000', 'temperatura', 28.0000, 'ºC'),
	(167185, 118, '2014-02-01 00:41:15.000000', 'temperatura', 50.0000, 'ºC'),
	(167186, 118, '2014-02-01 00:41:16.000000', 'temperatura', 168.0000, 'ºC'),
	(167187, 118, '2014-02-01 00:41:17.000000', 'temperatura', 689.0000, 'ºC'),
	(167188, 118, '2014-02-01 00:41:18.000000', 'temperatura', 541.0000, 'ºC'),
	(167189, 118, '2014-02-01 00:41:19.000000', 'temperatura', 639.0000, 'ºC'),
	(167190, 118, '2014-02-01 00:41:20.000000', 'temperatura', 373.0000, 'ºC'),
	(167191, 118, '2014-02-01 00:41:21.000000', 'temperatura', 1148.0000, 'ºC'),
	(167192, 118, '2014-02-01 00:41:22.000000', 'temperatura', 1020.0000, 'ºC'),
	(167193, 118, '2014-02-01 00:41:23.000000', 'temperatura', 457.0000, 'ºC'),
	(167194, 118, '2014-02-01 00:41:24.000000', 'temperatura', 425.0000, 'ºC'),
	(167195, 118, '2014-02-01 00:41:25.000000', 'temperatura', 757.0000, 'ºC'),
	(167196, 118, '2014-02-01 00:41:26.000000', 'temperatura', 108.0000, 'ºC'),
	(167197, 118, '2014-02-01 00:41:27.000000', 'temperatura', 669.0000, 'ºC'),
	(167198, 118, '2014-02-01 00:41:28.000000', 'temperatura', 621.0000, 'ºC'),
	(167199, 118, '2014-02-01 00:41:29.000000', 'temperatura', 1100.0000, 'ºC'),
	(167200, 118, '2014-02-01 00:41:30.000000', 'temperatura', 36.0000, 'ºC'),
	(167201, 118, '2014-02-01 00:41:31.000000', 'temperatura', 479.0000, 'ºC'),
	(167202, 118, '2014-02-01 00:41:32.000000', 'temperatura', 1091.0000, 'ºC'),
	(167203, 118, '2014-02-01 00:41:33.000000', 'temperatura', 416.0000, 'ºC'),
	(167204, 118, '2014-02-01 00:41:34.000000', 'temperatura', 7.0000, 'ºC'),
	(167205, 118, '2014-02-01 00:41:35.000000', 'temperatura', 1186.0000, 'ºC'),
	(167206, 118, '2014-02-01 00:41:36.000000', 'temperatura', 1113.0000, 'ºC'),
	(167207, 118, '2014-02-01 00:41:37.000000', 'temperatura', 807.0000, 'ºC'),
	(167208, 118, '2014-02-01 00:41:38.000000', 'temperatura', 697.0000, 'ºC'),
	(167209, 118, '2014-02-01 00:41:39.000000', 'temperatura', 1063.0000, 'ºC'),
	(167210, 118, '2014-02-01 00:41:40.000000', 'temperatura', 827.0000, 'ºC'),
	(167211, 118, '2014-02-01 00:41:41.000000', 'temperatura', 946.0000, 'ºC'),
	(167212, 118, '2014-02-01 00:41:42.000000', 'temperatura', 1048.0000, 'ºC'),
	(167213, 118, '2014-02-01 00:41:43.000000', 'temperatura', 4.0000, 'ºC'),
	(167214, 118, '2014-02-01 00:41:44.000000', 'temperatura', 475.0000, 'ºC'),
	(167215, 118, '2014-02-01 00:41:45.000000', 'temperatura', 1164.0000, 'ºC'),
	(167216, 118, '2014-02-01 00:41:46.000000', 'temperatura', 795.0000, 'ºC'),
	(167217, 118, '2014-02-01 00:41:47.000000', 'temperatura', 483.0000, 'ºC'),
	(167218, 118, '2014-02-01 00:41:48.000000', 'temperatura', 33.0000, 'ºC'),
	(167219, 118, '2014-02-01 00:41:49.000000', 'temperatura', 1116.0000, 'ºC'),
	(167220, 118, '2014-02-01 00:41:50.000000', 'temperatura', 679.0000, 'ºC'),
	(167221, 118, '2014-02-01 00:41:51.000000', 'temperatura', 50.0000, 'ºC'),
	(167222, 118, '2014-02-01 00:41:52.000000', 'temperatura', 613.0000, 'ºC'),
	(167223, 118, '2014-02-01 00:41:53.000000', 'temperatura', 514.0000, 'ºC'),
	(167224, 118, '2014-02-01 00:41:54.000000', 'temperatura', 734.0000, 'ºC'),
	(167225, 118, '2014-02-01 00:41:55.000000', 'temperatura', 928.0000, 'ºC'),
	(167226, 118, '2014-02-01 00:41:56.000000', 'temperatura', 39.0000, 'ºC'),
	(167227, 118, '2014-02-01 00:41:57.000000', 'temperatura', 1010.0000, 'ºC'),
	(167228, 118, '2014-02-01 00:41:58.000000', 'temperatura', 133.0000, 'ºC'),
	(167229, 118, '2014-02-01 00:41:59.000000', 'temperatura', 36.0000, 'ºC'),
	(167230, 118, '2014-02-01 00:42:00.000000', 'temperatura', 981.0000, 'ºC'),
	(167231, 118, '2014-02-01 00:42:01.000000', 'temperatura', 0.0000, 'ºC'),
	(167232, 118, '2014-02-01 00:42:02.000000', 'temperatura', 655.0000, 'ºC'),
	(167233, 118, '2014-02-01 00:42:03.000000', 'temperatura', 878.0000, 'ºC'),
	(167234, 118, '2014-02-01 00:42:04.000000', 'temperatura', 23.0000, 'ºC'),
	(167235, 118, '2014-02-01 00:42:05.000000', 'temperatura', 1083.0000, 'ºC'),
	(167236, 118, '2014-02-01 00:42:06.000000', 'temperatura', 548.0000, 'ºC'),
	(167237, 118, '2014-02-01 00:42:07.000000', 'temperatura', 688.0000, 'ºC'),
	(167238, 118, '2014-02-01 00:42:08.000000', 'temperatura', 598.0000, 'ºC'),
	(167239, 118, '2014-02-01 00:42:09.000000', 'temperatura', 928.0000, 'ºC'),
	(167240, 118, '2014-02-01 00:42:10.000000', 'temperatura', 444.0000, 'ºC'),
	(167241, 118, '2014-02-01 00:42:11.000000', 'temperatura', 637.0000, 'ºC'),
	(167242, 118, '2014-02-01 00:42:12.000000', 'temperatura', 655.0000, 'ºC'),
	(167243, 118, '2014-02-01 00:42:13.000000', 'temperatura', 163.0000, 'ºC'),
	(167244, 118, '2014-02-01 00:42:14.000000', 'temperatura', 51.0000, 'ºC'),
	(167245, 118, '2014-02-01 00:42:15.000000', 'temperatura', 969.0000, 'ºC'),
	(167246, 118, '2014-02-01 00:42:16.000000', 'temperatura', 1089.0000, 'ºC'),
	(167247, 118, '2014-02-01 00:42:17.000000', 'temperatura', 139.0000, 'ºC'),
	(167248, 118, '2014-02-01 00:42:18.000000', 'temperatura', 1028.0000, 'ºC'),
	(167249, 118, '2014-02-01 00:42:19.000000', 'temperatura', 1123.0000, 'ºC'),
	(167250, 118, '2014-02-01 00:42:20.000000', 'temperatura', 132.0000, 'ºC'),
	(167251, 118, '2014-02-01 00:42:21.000000', 'temperatura', 893.0000, 'ºC'),
	(167252, 118, '2014-02-01 00:42:22.000000', 'temperatura', 470.0000, 'ºC'),
	(167253, 118, '2014-02-01 00:42:23.000000', 'temperatura', 873.0000, 'ºC'),
	(167254, 118, '2014-02-01 00:42:24.000000', 'temperatura', 552.0000, 'ºC'),
	(167255, 118, '2014-02-01 00:42:25.000000', 'temperatura', 141.0000, 'ºC'),
	(167256, 118, '2014-02-01 00:42:26.000000', 'temperatura', 253.0000, 'ºC'),
	(167257, 118, '2014-02-01 00:42:27.000000', 'temperatura', 840.0000, 'ºC'),
	(167258, 118, '2014-02-01 00:42:28.000000', 'temperatura', 1043.0000, 'ºC'),
	(167259, 118, '2014-02-01 00:42:29.000000', 'temperatura', 295.0000, 'ºC'),
	(167260, 118, '2014-02-01 00:42:30.000000', 'temperatura', 744.0000, 'ºC'),
	(167261, 118, '2014-02-01 00:42:31.000000', 'temperatura', 439.0000, 'ºC'),
	(167262, 118, '2014-02-01 00:42:32.000000', 'temperatura', 1161.0000, 'ºC'),
	(167263, 118, '2014-02-01 00:42:33.000000', 'temperatura', 889.0000, 'ºC'),
	(167264, 118, '2014-02-01 00:42:34.000000', 'temperatura', 961.0000, 'ºC'),
	(167265, 118, '2014-02-01 00:42:35.000000', 'temperatura', 941.0000, 'ºC'),
	(167266, 118, '2014-02-01 00:42:36.000000', 'temperatura', 624.0000, 'ºC'),
	(167267, 118, '2014-02-01 00:42:37.000000', 'temperatura', 295.0000, 'ºC'),
	(167268, 118, '2014-02-01 00:42:38.000000', 'temperatura', 803.0000, 'ºC'),
	(167269, 118, '2014-02-01 00:42:39.000000', 'temperatura', 730.0000, 'ºC'),
	(167270, 118, '2014-02-01 00:42:40.000000', 'temperatura', 43.0000, 'ºC'),
	(167271, 118, '2014-02-01 00:42:41.000000', 'temperatura', 424.0000, 'ºC'),
	(167272, 118, '2014-02-01 00:42:42.000000', 'temperatura', 793.0000, 'ºC'),
	(167273, 118, '2014-02-01 00:42:43.000000', 'temperatura', 292.0000, 'ºC'),
	(167274, 118, '2014-02-01 00:42:44.000000', 'temperatura', 283.0000, 'ºC'),
	(167275, 118, '2014-02-01 00:42:45.000000', 'temperatura', 540.0000, 'ºC'),
	(167276, 118, '2014-02-01 00:42:46.000000', 'temperatura', 653.0000, 'ºC'),
	(167277, 118, '2014-02-01 00:42:47.000000', 'temperatura', 442.0000, 'ºC'),
	(167278, 118, '2014-02-01 00:42:48.000000', 'temperatura', 253.0000, 'ºC'),
	(167279, 118, '2014-02-01 00:42:49.000000', 'temperatura', 1139.0000, 'ºC'),
	(167280, 118, '2014-02-01 00:42:50.000000', 'temperatura', 138.0000, 'ºC'),
	(167281, 118, '2014-02-01 00:42:51.000000', 'temperatura', 871.0000, 'ºC'),
	(167282, 118, '2014-02-01 00:42:52.000000', 'temperatura', 343.0000, 'ºC'),
	(167283, 118, '2014-02-01 00:42:53.000000', 'temperatura', 303.0000, 'ºC'),
	(167284, 118, '2014-02-01 00:42:54.000000', 'temperatura', 487.0000, 'ºC'),
	(167285, 118, '2014-02-01 00:42:55.000000', 'temperatura', 324.0000, 'ºC'),
	(167286, 118, '2014-02-01 00:42:56.000000', 'temperatura', 160.0000, 'ºC'),
	(167287, 118, '2014-02-01 00:42:57.000000', 'temperatura', 1029.0000, 'ºC'),
	(167288, 118, '2014-02-01 00:42:58.000000', 'temperatura', 1066.0000, 'ºC'),
	(167289, 118, '2014-02-01 00:42:59.000000', 'temperatura', 1043.0000, 'ºC'),
	(167290, 118, '2014-02-01 00:43:00.000000', 'temperatura', 816.0000, 'ºC'),
	(167291, 118, '2014-02-01 00:43:01.000000', 'temperatura', 952.0000, 'ºC'),
	(167292, 118, '2014-02-01 00:43:02.000000', 'temperatura', 1113.0000, 'ºC'),
	(167293, 118, '2014-02-01 00:43:03.000000', 'temperatura', 309.0000, 'ºC'),
	(167294, 118, '2014-02-01 00:43:04.000000', 'temperatura', 607.0000, 'ºC'),
	(167295, 118, '2014-02-01 00:43:05.000000', 'temperatura', 909.0000, 'ºC'),
	(167296, 118, '2014-02-01 00:43:06.000000', 'temperatura', 324.0000, 'ºC'),
	(167297, 118, '2014-02-01 00:43:07.000000', 'temperatura', 92.0000, 'ºC'),
	(167298, 118, '2014-02-01 00:43:08.000000', 'temperatura', 688.0000, 'ºC'),
	(167299, 118, '2014-02-01 00:43:09.000000', 'temperatura', 766.0000, 'ºC'),
	(167300, 118, '2014-02-01 00:43:10.000000', 'temperatura', 568.0000, 'ºC'),
	(167301, 118, '2014-02-01 00:43:11.000000', 'temperatura', 543.0000, 'ºC'),
	(167302, 118, '2014-02-01 00:43:12.000000', 'temperatura', 1009.0000, 'ºC'),
	(167303, 118, '2014-02-01 00:43:13.000000', 'temperatura', 1015.0000, 'ºC'),
	(167304, 118, '2014-02-01 00:43:14.000000', 'temperatura', 851.0000, 'ºC'),
	(167305, 118, '2014-02-01 00:43:15.000000', 'temperatura', 11.0000, 'ºC'),
	(167306, 118, '2014-02-01 00:43:16.000000', 'temperatura', 1103.0000, 'ºC'),
	(167307, 118, '2014-02-01 00:43:17.000000', 'temperatura', 680.0000, 'ºC'),
	(167308, 118, '2014-02-01 00:43:18.000000', 'temperatura', 94.0000, 'ºC'),
	(167309, 118, '2014-02-01 00:43:19.000000', 'temperatura', 829.0000, 'ºC'),
	(167310, 118, '2014-02-01 00:43:20.000000', 'temperatura', 266.0000, 'ºC'),
	(167311, 118, '2014-02-01 00:43:21.000000', 'temperatura', 40.0000, 'ºC'),
	(167312, 118, '2014-02-01 00:43:22.000000', 'temperatura', 605.0000, 'ºC'),
	(167313, 118, '2014-02-01 00:43:23.000000', 'temperatura', 506.0000, 'ºC'),
	(167314, 118, '2014-02-01 00:43:24.000000', 'temperatura', 715.0000, 'ºC'),
	(167315, 118, '2014-02-01 00:43:25.000000', 'temperatura', 859.0000, 'ºC'),
	(167316, 118, '2014-02-01 00:43:26.000000', 'temperatura', 948.0000, 'ºC'),
	(167317, 118, '2014-02-01 00:43:27.000000', 'temperatura', 963.0000, 'ºC'),
	(167318, 118, '2014-02-01 00:43:28.000000', 'temperatura', 771.0000, 'ºC'),
	(167319, 118, '2014-02-01 00:43:29.000000', 'temperatura', 967.0000, 'ºC'),
	(167320, 118, '2014-02-01 00:43:30.000000', 'temperatura', 125.0000, 'ºC'),
	(167321, 118, '2014-02-01 00:43:31.000000', 'temperatura', 122.0000, 'ºC'),
	(167322, 118, '2014-02-01 00:43:32.000000', 'temperatura', 237.0000, 'ºC'),
	(167323, 118, '2014-02-01 00:43:33.000000', 'temperatura', 819.0000, 'ºC'),
	(167324, 118, '2014-02-01 00:43:34.000000', 'temperatura', 983.0000, 'ºC'),
	(167325, 118, '2014-02-01 00:43:35.000000', 'temperatura', 59.0000, 'ºC'),
	(167326, 118, '2014-02-01 00:43:36.000000', 'temperatura', 945.0000, 'ºC'),
	(167327, 118, '2014-02-01 00:43:37.000000', 'temperatura', 950.0000, 'ºC'),
	(167328, 118, '2014-02-01 00:43:38.000000', 'temperatura', 716.0000, 'ºC'),
	(167329, 118, '2014-02-01 00:43:39.000000', 'temperatura', 731.0000, 'ºC'),
	(167330, 118, '2014-02-01 00:43:40.000000', 'temperatura', 306.0000, 'ºC'),
	(167331, 118, '2014-02-01 00:43:41.000000', 'temperatura', 538.0000, 'ºC'),
	(167332, 118, '2014-02-01 00:43:42.000000', 'temperatura', 574.0000, 'ºC'),
	(167333, 118, '2014-02-01 00:43:43.000000', 'temperatura', 56.0000, 'ºC'),
	(167334, 118, '2014-02-01 00:43:44.000000', 'temperatura', 958.0000, 'ºC'),
	(167335, 118, '2014-02-01 00:43:45.000000', 'temperatura', 1021.0000, 'ºC'),
	(167336, 118, '2014-02-01 00:43:46.000000', 'temperatura', 1034.0000, 'ºC'),
	(167337, 118, '2014-02-01 00:43:47.000000', 'temperatura', 908.0000, 'ºC'),
	(167338, 118, '2014-02-01 00:43:48.000000', 'temperatura', 236.0000, 'ºC'),
	(167339, 118, '2014-02-01 00:43:49.000000', 'temperatura', 856.0000, 'ºC'),
	(167340, 118, '2014-02-01 00:43:50.000000', 'temperatura', 1175.0000, 'ºC'),
	(167341, 118, '2014-02-01 00:43:51.000000', 'temperatura', 906.0000, 'ºC'),
	(167342, 118, '2014-02-01 00:43:52.000000', 'temperatura', 1006.0000, 'ºC'),
	(167343, 118, '2014-02-01 00:43:53.000000', 'temperatura', 1113.0000, 'ºC'),
	(167344, 118, '2014-02-01 00:43:54.000000', 'temperatura', 147.0000, 'ºC'),
	(167345, 118, '2014-02-01 00:43:55.000000', 'temperatura', 997.0000, 'ºC'),
	(167346, 118, '2014-02-01 00:43:56.000000', 'temperatura', 945.0000, 'ºC'),
	(167347, 118, '2014-02-01 00:43:57.000000', 'temperatura', 533.0000, 'ºC'),
	(167348, 118, '2014-02-01 00:43:58.000000', 'temperatura', 1030.0000, 'ºC'),
	(167349, 118, '2014-02-01 00:43:59.000000', 'temperatura', 1152.0000, 'ºC'),
	(167350, 118, '2014-02-01 00:44:00.000000', 'temperatura', 269.0000, 'ºC'),
	(167351, 118, '2014-02-01 00:44:01.000000', 'temperatura', 293.0000, 'ºC'),
	(167352, 118, '2014-02-01 00:44:02.000000', 'temperatura', 656.0000, 'ºC'),
	(167353, 118, '2014-02-01 00:44:03.000000', 'temperatura', 1.0000, 'ºC'),
	(167354, 118, '2014-02-01 00:44:04.000000', 'temperatura', 440.0000, 'ºC'),
	(167355, 118, '2014-02-01 00:44:05.000000', 'temperatura', 995.0000, 'ºC'),
	(167356, 118, '2014-02-01 00:44:06.000000', 'temperatura', 54.0000, 'ºC'),
	(167357, 118, '2014-02-01 00:44:07.000000', 'temperatura', 889.0000, 'ºC'),
	(167358, 118, '2014-02-01 00:44:08.000000', 'temperatura', 683.0000, 'ºC'),
	(167359, 118, '2014-02-01 00:44:09.000000', 'temperatura', 747.0000, 'ºC'),
	(167360, 118, '2014-02-01 00:44:10.000000', 'temperatura', 488.0000, 'ºC'),
	(167361, 118, '2014-02-01 00:44:11.000000', 'temperatura', 197.0000, 'ºC'),
	(167362, 118, '2014-02-01 00:44:12.000000', 'temperatura', 724.0000, 'ºC'),
	(167363, 118, '2014-02-01 00:44:13.000000', 'temperatura', 630.0000, 'ºC'),
	(167364, 118, '2014-02-01 00:44:14.000000', 'temperatura', 977.0000, 'ºC'),
	(167365, 118, '2014-02-01 00:44:15.000000', 'temperatura', 597.0000, 'ºC'),
	(167366, 118, '2014-02-01 00:44:16.000000', 'temperatura', 53.0000, 'ºC'),
	(167367, 118, '2014-02-01 00:44:17.000000', 'temperatura', 874.0000, 'ºC'),
	(167368, 118, '2014-02-01 00:44:18.000000', 'temperatura', 610.0000, 'ºC'),
	(167369, 118, '2014-02-01 00:44:19.000000', 'temperatura', 431.0000, 'ºC'),
	(167370, 118, '2014-02-01 00:44:20.000000', 'temperatura', 326.0000, 'ºC'),
	(167371, 118, '2014-02-01 00:44:21.000000', 'temperatura', 338.0000, 'ºC'),
	(167372, 118, '2014-02-01 00:44:22.000000', 'temperatura', 713.0000, 'ºC'),
	(167373, 118, '2014-02-01 00:44:23.000000', 'temperatura', 150.0000, 'ºC'),
	(167374, 118, '2014-02-01 00:44:24.000000', 'temperatura', 1011.0000, 'ºC'),
	(167375, 118, '2014-02-01 00:44:25.000000', 'temperatura', 1006.0000, 'ºC'),
	(167376, 118, '2014-02-01 00:44:26.000000', 'temperatura', 798.0000, 'ºC'),
	(167377, 118, '2014-02-01 00:44:27.000000', 'temperatura', 971.0000, 'ºC'),
	(167378, 118, '2014-02-01 00:44:28.000000', 'temperatura', 63.0000, 'ºC'),
	(167379, 118, '2014-02-01 00:44:29.000000', 'temperatura', 1002.0000, 'ºC'),
	(167380, 118, '2014-02-01 00:44:30.000000', 'temperatura', 21.0000, 'ºC'),
	(167381, 118, '2014-02-01 00:44:31.000000', 'temperatura', 700.0000, 'ºC'),
	(167382, 118, '2014-02-01 00:44:32.000000', 'temperatura', 1038.0000, 'ºC'),
	(167383, 118, '2014-02-01 00:44:33.000000', 'temperatura', 691.0000, 'ºC'),
	(167384, 118, '2014-02-01 00:44:34.000000', 'temperatura', 340.0000, 'ºC'),
	(167385, 118, '2014-02-01 00:44:35.000000', 'temperatura', 826.0000, 'ºC'),
	(167386, 118, '2014-02-01 00:44:36.000000', 'temperatura', 713.0000, 'ºC'),
	(167387, 118, '2014-02-01 00:44:37.000000', 'temperatura', 1089.0000, 'ºC'),
	(167388, 118, '2014-02-01 00:44:38.000000', 'temperatura', 903.0000, 'ºC'),
	(167389, 118, '2014-02-01 00:44:39.000000', 'temperatura', 50.0000, 'ºC'),
	(167390, 118, '2014-02-01 00:44:40.000000', 'temperatura', 1141.0000, 'ºC'),
	(167391, 118, '2014-02-01 00:44:41.000000', 'temperatura', 755.0000, 'ºC'),
	(167392, 118, '2014-02-01 00:44:42.000000', 'temperatura', 354.0000, 'ºC'),
	(167393, 118, '2014-02-01 00:44:43.000000', 'temperatura', 707.0000, 'ºC'),
	(167394, 118, '2014-02-01 00:44:44.000000', 'temperatura', 70.0000, 'ºC'),
	(167395, 118, '2014-02-01 00:44:45.000000', 'temperatura', 632.0000, 'ºC'),
	(167396, 118, '2014-02-01 00:44:46.000000', 'temperatura', 550.0000, 'ºC'),
	(167397, 118, '2014-02-01 00:44:47.000000', 'temperatura', 855.0000, 'ºC'),
	(167398, 118, '2014-02-01 00:44:48.000000', 'temperatura', 225.0000, 'ºC'),
	(167399, 118, '2014-02-01 00:44:49.000000', 'temperatura', 962.0000, 'ºC'),
	(167400, 118, '2014-02-01 00:44:50.000000', 'temperatura', 535.0000, 'ºC'),
	(167401, 118, '2014-02-01 00:44:51.000000', 'temperatura', 989.0000, 'ºC'),
	(167402, 118, '2014-02-01 00:44:52.000000', 'temperatura', 938.0000, 'ºC'),
	(167403, 118, '2014-02-01 00:44:53.000000', 'temperatura', 527.0000, 'ºC'),
	(167404, 118, '2014-02-01 00:44:54.000000', 'temperatura', 1021.0000, 'ºC'),
	(167405, 118, '2014-02-01 00:44:55.000000', 'temperatura', 1126.0000, 'ºC'),
	(167406, 118, '2014-02-01 00:44:56.000000', 'temperatura', 164.0000, 'ºC'),
	(167407, 118, '2014-02-01 00:44:57.000000', 'temperatura', 1046.0000, 'ºC'),
	(167408, 118, '2014-02-01 00:44:58.000000', 'temperatura', 1136.0000, 'ºC'),
	(167409, 118, '2014-02-01 00:44:59.000000', 'temperatura', 142.0000, 'ºC'),
	(167410, 118, '2014-02-01 00:45:00.000000', 'temperatura', 902.0000, 'ºC'),
	(167411, 118, '2014-02-01 00:45:01.000000', 'temperatura', 484.0000, 'ºC'),
	(167412, 118, '2014-02-01 00:45:02.000000', 'temperatura', 915.0000, 'ºC'),
	(167413, 118, '2014-02-01 00:45:03.000000', 'temperatura', 723.0000, 'ºC'),
	(167414, 118, '2014-02-01 00:45:04.000000', 'temperatura', 871.0000, 'ºC'),
	(167415, 118, '2014-02-01 00:45:05.000000', 'temperatura', 986.0000, 'ºC'),
	(167416, 118, '2014-02-01 00:45:06.000000', 'temperatura', 1117.0000, 'ºC'),
	(167417, 118, '2014-02-01 00:45:07.000000', 'temperatura', 226.0000, 'ºC'),
	(167418, 118, '2014-02-01 00:45:08.000000', 'temperatura', 181.0000, 'ºC'),
	(167419, 118, '2014-02-01 00:45:09.000000', 'temperatura', 230.0000, 'ºC'),
	(167420, 118, '2014-02-01 00:45:10.000000', 'temperatura', 604.0000, 'ºC'),
	(167421, 118, '2014-02-01 00:45:11.000000', 'temperatura', 1130.0000, 'ºC'),
	(167422, 118, '2014-02-01 00:45:12.000000', 'temperatura', 240.0000, 'ºC'),
	(167423, 118, '2014-02-01 00:45:13.000000', 'temperatura', 212.0000, 'ºC'),
	(167424, 118, '2014-02-01 00:45:14.000000', 'temperatura', 340.0000, 'ºC'),
	(167425, 118, '2014-02-01 00:45:15.000000', 'temperatura', 1065.0000, 'ºC'),
	(167426, 118, '2014-02-01 00:45:16.000000', 'temperatura', 705.0000, 'ºC'),
	(167427, 118, '2014-02-01 00:45:17.000000', 'temperatura', 331.0000, 'ºC'),
	(167428, 118, '2014-02-01 00:45:18.000000', 'temperatura', 740.0000, 'ºC'),
	(167429, 118, '2014-02-01 00:45:19.000000', 'temperatura', 308.0000, 'ºC'),
	(167430, 118, '2014-02-01 00:45:20.000000', 'temperatura', 520.0000, 'ºC'),
	(167431, 118, '2014-02-01 00:45:21.000000', 'temperatura', 475.0000, 'ºC'),
	(167432, 118, '2014-02-01 00:45:22.000000', 'temperatura', 818.0000, 'ºC'),
	(167433, 118, '2014-02-01 00:45:23.000000', 'temperatura', 263.0000, 'ºC'),
	(167434, 118, '2014-02-01 00:45:24.000000', 'temperatura', 64.0000, 'ºC'),
	(167435, 118, '2014-02-01 00:45:25.000000', 'temperatura', 732.0000, 'ºC'),
	(167436, 118, '2014-02-01 00:45:26.000000', 'temperatura', 1067.0000, 'ºC'),
	(167437, 118, '2014-02-01 00:45:27.000000', 'temperatura', 740.0000, 'ºC'),
	(167438, 118, '2014-02-01 00:45:28.000000', 'temperatura', 501.0000, 'ºC'),
	(167439, 118, '2014-02-01 00:45:29.000000', 'temperatura', 286.0000, 'ºC'),
	(167440, 118, '2014-02-01 00:45:30.000000', 'temperatura', 1127.0000, 'ºC'),
	(167441, 118, '2014-02-01 00:45:31.000000', 'temperatura', 1176.0000, 'ºC'),
	(167442, 118, '2014-02-01 00:45:32.000000', 'temperatura', 102.0000, 'ºC'),
	(167443, 118, '2014-02-01 00:45:33.000000', 'temperatura', 581.0000, 'ºC'),
	(167444, 118, '2014-02-01 00:45:34.000000', 'temperatura', 199.0000, 'ºC'),
	(167445, 118, '2014-02-01 00:45:35.000000', 'temperatura', 455.0000, 'ºC'),
	(167446, 118, '2014-02-01 00:45:36.000000', 'temperatura', 477.0000, 'ºC'),
	(167447, 118, '2014-02-01 00:45:37.000000', 'temperatura', 1019.0000, 'ºC'),
	(167448, 118, '2014-02-01 00:45:38.000000', 'temperatura', 66.0000, 'ºC'),
	(167449, 118, '2014-02-01 00:45:39.000000', 'temperatura', 873.0000, 'ºC'),
	(167450, 118, '2014-02-01 00:45:40.000000', 'temperatura', 567.0000, 'ºC'),
	(167451, 118, '2014-02-01 00:45:41.000000', 'temperatura', 218.0000, 'ºC'),
	(167452, 118, '2014-02-01 00:45:42.000000', 'temperatura', 587.0000, 'ºC'),
	(167453, 118, '2014-02-01 00:45:43.000000', 'temperatura', 1085.0000, 'ºC'),
	(167454, 118, '2014-02-01 00:45:44.000000', 'temperatura', 61.0000, 'ºC'),
	(167455, 118, '2014-02-01 00:45:45.000000', 'temperatura', 652.0000, 'ºC'),
	(167456, 118, '2014-02-01 00:45:46.000000', 'temperatura', 679.0000, 'ºC'),
	(167457, 118, '2014-02-01 00:45:47.000000', 'temperatura', 239.0000, 'ºC'),
	(167458, 118, '2014-02-01 00:45:48.000000', 'temperatura', 360.0000, 'ºC'),
	(167459, 118, '2014-02-01 00:45:49.000000', 'temperatura', 1081.0000, 'ºC'),
	(167460, 118, '2014-02-01 00:45:50.000000', 'temperatura', 727.0000, 'ºC'),
	(167461, 118, '2014-02-01 00:45:51.000000', 'temperatura', 393.0000, 'ºC'),
	(167462, 118, '2014-02-01 00:45:52.000000', 'temperatura', 983.0000, 'ºC'),
	(167463, 118, '2014-02-01 00:45:53.000000', 'temperatura', 139.0000, 'ºC'),
	(167464, 118, '2014-02-01 00:45:54.000000', 'temperatura', 144.0000, 'ºC'),
	(167465, 118, '2014-02-01 00:45:55.000000', 'temperatura', 304.0000, 'ºC'),
	(167466, 118, '2014-02-01 00:45:56.000000', 'temperatura', 1090.0000, 'ºC'),
	(167467, 118, '2014-02-01 00:45:57.000000', 'temperatura', 937.0000, 'ºC'),
	(167468, 118, '2014-02-01 00:45:58.000000', 'temperatura', 217.0000, 'ºC'),
	(167469, 118, '2014-02-01 00:45:59.000000', 'temperatura', 673.0000, 'ºC'),
	(167470, 118, '2014-02-01 00:46:00.000000', 'temperatura', 317.0000, 'ºC'),
	(167471, 118, '2014-02-01 00:46:01.000000', 'temperatura', 765.0000, 'ºC'),
	(167472, 118, '2014-02-01 00:46:02.000000', 'temperatura', 474.0000, 'ºC'),
	(167473, 118, '2014-02-01 00:46:03.000000', 'temperatura', 75.0000, 'ºC'),
	(167474, 118, '2014-02-01 00:46:04.000000', 'temperatura', 152.0000, 'ºC'),
	(167475, 118, '2014-02-01 00:46:05.000000', 'temperatura', 538.0000, 'ºC'),
	(167476, 118, '2014-02-01 00:46:06.000000', 'temperatura', 1032.0000, 'ºC'),
	(167477, 118, '2014-02-01 00:46:07.000000', 'temperatura', 1150.0000, 'ºC'),
	(167478, 118, '2014-02-01 00:46:08.000000', 'temperatura', 252.0000, 'ºC'),
	(167479, 118, '2014-02-01 00:46:09.000000', 'temperatura', 211.0000, 'ºC'),
	(167480, 118, '2014-02-01 00:46:10.000000', 'temperatura', 301.0000, 'ºC'),
	(167481, 118, '2014-02-01 00:46:11.000000', 'temperatura', 873.0000, 'ºC'),
	(167482, 118, '2014-02-01 00:46:12.000000', 'temperatura', 1063.0000, 'ºC'),
	(167483, 118, '2014-02-01 00:46:13.000000', 'temperatura', 295.0000, 'ºC'),
	(167484, 118, '2014-02-01 00:46:14.000000', 'temperatura', 685.0000, 'ºC'),
	(167485, 118, '2014-02-01 00:46:15.000000', 'temperatura', 141.0000, 'ºC'),
	(167486, 118, '2014-02-01 00:46:16.000000', 'temperatura', 1052.0000, 'ºC'),
	(167487, 118, '2014-02-01 00:46:17.000000', 'temperatura', 35.0000, 'ºC'),
	(167488, 118, '2014-02-01 00:46:18.000000', 'temperatura', 621.0000, 'ºC'),
	(167489, 118, '2014-02-01 00:46:19.000000', 'temperatura', 599.0000, 'ºC'),
	(167490, 118, '2014-02-01 00:46:20.000000', 'temperatura', 1134.0000, 'ºC'),
	(167491, 118, '2014-02-01 00:46:21.000000', 'temperatura', 272.0000, 'ºC'),
	(167492, 118, '2014-02-01 00:46:22.000000', 'temperatura', 359.0000, 'ºC'),
	(167493, 118, '2014-02-01 00:46:23.000000', 'temperatura', 981.0000, 'ºC'),
	(167494, 118, '2014-02-01 00:46:24.000000', 'temperatura', 228.0000, 'ºC'),
	(167495, 118, '2014-02-01 00:46:25.000000', 'temperatura', 596.0000, 'ºC'),
	(167496, 118, '2014-02-01 00:46:26.000000', 'temperatura', 1097.0000, 'ºC'),
	(167497, 118, '2014-02-01 00:46:27.000000', 'temperatura', 99.0000, 'ºC'),
	(167498, 118, '2014-02-01 00:46:28.000000', 'temperatura', 802.0000, 'ºC'),
	(167499, 118, '2014-02-01 00:46:29.000000', 'temperatura', 117.0000, 'ºC'),
	(167500, 118, '2014-02-01 00:46:30.000000', 'temperatura', 577.0000, 'ºC'),
	(167501, 118, '2014-02-01 00:46:31.000000', 'temperatura', 134.0000, 'ºC'),
	(167502, 118, '2014-02-01 00:46:32.000000', 'temperatura', 139.0000, 'ºC'),
	(167503, 118, '2014-02-01 00:46:33.000000', 'temperatura', 292.0000, 'ºC'),
	(167504, 118, '2014-02-01 00:46:34.000000', 'temperatura', 1047.0000, 'ºC'),
	(167505, 118, '2014-02-01 00:46:35.000000', 'temperatura', 758.0000, 'ºC'),
	(167506, 118, '2014-02-01 00:46:36.000000', 'temperatura', 648.0000, 'ºC'),
	(167507, 118, '2014-02-01 00:46:37.000000', 'temperatura', 969.0000, 'ºC'),
	(167508, 118, '2014-02-01 00:46:38.000000', 'temperatura', 500.0000, 'ºC'),
	(167509, 118, '2014-02-01 00:46:39.000000', 'temperatura', 793.0000, 'ºC'),
	(167510, 118, '2014-02-01 00:46:40.000000', 'temperatura', 67.0000, 'ºC'),
	(167511, 118, '2014-02-01 00:46:41.000000', 'temperatura', 358.0000, 'ºC'),
	(167512, 118, '2014-02-01 00:46:42.000000', 'temperatura', 388.0000, 'ºC'),
	(167513, 118, '2014-02-01 00:46:43.000000', 'temperatura', 867.0000, 'ºC'),
	(167514, 118, '2014-02-01 00:46:44.000000', 'temperatura', 771.0000, 'ºC'),
	(167515, 118, '2014-02-01 00:46:45.000000', 'temperatura', 53.0000, 'ºC'),
	(167516, 118, '2014-02-01 00:46:46.000000', 'temperatura', 354.0000, 'ºC'),
	(167517, 118, '2014-02-01 00:46:47.000000', 'temperatura', 413.0000, 'ºC'),
	(167518, 118, '2014-02-01 00:46:48.000000', 'temperatura', 1000.0000, 'ºC'),
	(167519, 118, '2014-02-01 00:46:49.000000', 'temperatura', 164.0000, 'ºC'),
	(167520, 118, '2014-02-01 00:46:50.000000', 'temperatura', 219.0000, 'ºC'),
	(167521, 118, '2014-02-01 00:46:51.000000', 'temperatura', 606.0000, 'ºC'),
	(167522, 118, '2014-02-01 00:46:52.000000', 'temperatura', 1173.0000, 'ºC'),
	(167523, 118, '2014-02-01 00:46:53.000000', 'temperatura', 446.0000, 'ºC'),
	(167524, 118, '2014-02-01 00:46:54.000000', 'temperatura', 1111.0000, 'ºC'),
	(167525, 118, '2014-02-01 00:46:55.000000', 'temperatura', 617.0000, 'ºC'),
	(167526, 118, '2014-02-01 00:46:56.000000', 'temperatura', 953.0000, 'ºC'),
	(167527, 118, '2014-02-01 00:46:57.000000', 'temperatura', 513.0000, 'ºC'),
	(167528, 118, '2014-02-01 00:46:58.000000', 'temperatura', 908.0000, 'ºC'),
	(167529, 118, '2014-02-01 00:46:59.000000', 'temperatura', 599.0000, 'ºC'),
	(167530, 118, '2014-02-01 00:47:00.000000', 'temperatura', 274.0000, 'ºC'),
	(167531, 118, '2014-02-01 00:47:01.000000', 'temperatura', 774.0000, 'ºC'),
	(167532, 118, '2014-02-01 00:47:02.000000', 'temperatura', 649.0000, 'ºC'),
	(167533, 118, '2014-02-01 00:47:03.000000', 'temperatura', 921.0000, 'ºC'),
	(167534, 118, '2014-02-01 00:47:04.000000', 'temperatura', 260.0000, 'ºC'),
	(167535, 118, '2014-02-01 00:47:05.000000', 'temperatura', 936.0000, 'ºC'),
	(167536, 118, '2014-02-01 00:47:06.000000', 'temperatura', 303.0000, 'ºC'),
	(167537, 118, '2014-02-01 00:47:07.000000', 'temperatura', 1106.0000, 'ºC'),
	(167538, 118, '2014-02-01 00:47:08.000000', 'temperatura', 1021.0000, 'ºC'),
	(167539, 118, '2014-02-01 00:47:09.000000', 'temperatura', 589.0000, 'ºC'),
	(167540, 118, '2014-02-01 00:47:10.000000', 'temperatura', 1084.0000, 'ºC'),
	(167541, 118, '2014-02-01 00:47:11.000000', 'temperatura', 50.0000, 'ºC'),
	(167542, 118, '2014-02-01 00:47:12.000000', 'temperatura', 601.0000, 'ºC'),
	(167543, 118, '2014-02-01 00:47:13.000000', 'temperatura', 457.0000, 'ºC'),
	(167544, 118, '2014-02-01 00:47:14.000000', 'temperatura', 480.0000, 'ºC'),
	(167545, 118, '2014-02-01 00:47:15.000000', 'temperatura', 1031.0000, 'ºC'),
	(167546, 118, '2014-02-01 00:47:16.000000', 'temperatura', 114.0000, 'ºC'),
	(167547, 118, '2014-02-01 00:47:17.000000', 'temperatura', 1078.0000, 'ºC'),
	(167548, 118, '2014-02-01 00:47:18.000000', 'temperatura', 247.0000, 'ºC'),
	(167549, 118, '2014-02-01 00:47:19.000000', 'temperatura', 404.0000, 'ºC'),
	(167550, 118, '2014-02-01 00:47:20.000000', 'temperatura', 79.0000, 'ºC'),
	(167551, 118, '2014-02-01 00:47:21.000000', 'temperatura', 383.0000, 'ºC'),
	(167552, 118, '2014-02-01 00:47:22.000000', 'temperatura', 480.0000, 'ºC'),
	(167553, 118, '2014-02-01 00:47:23.000000', 'temperatura', 52.0000, 'ºC'),
	(167554, 118, '2014-02-01 00:47:24.000000', 'temperatura', 20.0000, 'ºC'),
	(167555, 118, '2014-02-01 00:47:25.000000', 'temperatura', 1145.0000, 'ºC'),
	(167556, 118, '2014-02-01 00:47:26.000000', 'temperatura', 867.0000, 'ºC'),
	(167557, 118, '2014-02-01 00:47:27.000000', 'temperatura', 899.0000, 'ºC'),
	(167558, 118, '2014-02-01 00:47:28.000000', 'temperatura', 692.0000, 'ºC'),
	(167559, 118, '2014-02-01 00:47:29.000000', 'temperatura', 767.0000, 'ºC'),
	(167560, 118, '2014-02-01 00:47:30.000000', 'temperatura', 558.0000, 'ºC'),
	(167561, 118, '2014-02-01 00:47:31.000000', 'temperatura', 491.0000, 'ºC'),
	(167562, 118, '2014-02-01 00:47:32.000000', 'temperatura', 782.0000, 'ºC'),
	(167563, 118, '2014-02-01 00:47:33.000000', 'temperatura', 36.0000, 'ºC'),
	(167564, 118, '2014-02-01 00:47:34.000000', 'temperatura', 237.0000, 'ºC'),
	(167565, 118, '2014-02-01 00:47:35.000000', 'temperatura', 1076.0000, 'ºC'),
	(167566, 118, '2014-02-01 00:47:36.000000', 'temperatura', 1068.0000, 'ºC'),
	(167567, 118, '2014-02-01 00:47:37.000000', 'temperatura', 915.0000, 'ºC'),
	(167568, 118, '2014-02-01 00:47:38.000000', 'temperatura', 169.0000, 'ºC'),
	(167569, 118, '2014-02-01 00:47:39.000000', 'temperatura', 504.0000, 'ºC'),
	(167570, 118, '2014-02-01 00:47:40.000000', 'temperatura', 810.0000, 'ºC'),
	(167571, 118, '2014-02-01 00:47:41.000000', 'temperatura', 141.0000, 'ºC'),
	(167572, 118, '2014-02-01 00:47:42.000000', 'temperatura', 673.0000, 'ºC'),
	(167573, 118, '2014-02-01 00:47:43.000000', 'temperatura', 542.0000, 'ºC'),
	(167574, 118, '2014-02-01 00:47:44.000000', 'temperatura', 692.0000, 'ºC'),
	(167575, 118, '2014-02-01 00:47:45.000000', 'temperatura', 637.0000, 'ºC'),
	(167576, 118, '2014-02-01 00:47:46.000000', 'temperatura', 1108.0000, 'ºC'),
	(167577, 118, '2014-02-01 00:47:47.000000', 'temperatura', 29.0000, 'ºC'),
	(167578, 118, '2014-02-01 00:47:48.000000', 'temperatura', 424.0000, 'ºC'),
	(167579, 118, '2014-02-01 00:47:49.000000', 'temperatura', 832.0000, 'ºC'),
	(167580, 118, '2014-02-01 00:47:50.000000', 'temperatura', 488.0000, 'ºC'),
	(167581, 118, '2014-02-01 00:47:51.000000', 'temperatura', 1146.0000, 'ºC'),
	(167582, 118, '2014-02-01 00:47:52.000000', 'temperatura', 665.0000, 'ºC'),
	(167583, 118, '2014-02-01 00:47:53.000000', 'temperatura', 1087.0000, 'ºC'),
	(167584, 118, '2014-02-01 00:47:54.000000', 'temperatura', 1041.0000, 'ºC'),
	(167585, 118, '2014-02-01 00:47:55.000000', 'temperatura', 746.0000, 'ºC'),
	(167586, 118, '2014-02-01 00:47:56.000000', 'temperatura', 608.0000, 'ºC'),
	(167587, 118, '2014-02-01 00:47:57.000000', 'temperatura', 803.0000, 'ºC'),
	(167588, 118, '2014-02-01 00:47:58.000000', 'temperatura', 991.0000, 'ºC'),
	(167589, 118, '2014-02-01 00:47:59.000000', 'temperatura', 146.0000, 'ºC'),
	(167590, 118, '2014-02-01 00:48:00.000000', 'temperatura', 158.0000, 'ºC'),
	(167591, 118, '2014-02-01 00:48:01.000000', 'temperatura', 351.0000, 'ºC'),
	(167592, 118, '2014-02-01 00:48:02.000000', 'temperatura', 84.0000, 'ºC'),
	(167593, 118, '2014-02-01 00:48:03.000000', 'temperatura', 568.0000, 'ºC'),
	(167594, 118, '2014-02-01 00:48:04.000000', 'temperatura', 189.0000, 'ºC'),
	(167595, 118, '2014-02-01 00:48:05.000000', 'temperatura', 440.0000, 'ºC'),
	(167596, 118, '2014-02-01 00:48:06.000000', 'temperatura', 433.0000, 'ºC'),
	(167597, 118, '2014-02-01 00:48:07.000000', 'temperatura', 846.0000, 'ºC'),
	(167598, 118, '2014-02-01 00:48:08.000000', 'temperatura', 533.0000, 'ºC'),
	(167599, 118, '2014-02-01 00:48:09.000000', 'temperatura', 125.0000, 'ºC'),
	(167600, 118, '2014-02-01 00:48:10.000000', 'temperatura', 226.0000, 'ºC'),
	(167601, 118, '2014-02-01 00:48:11.000000', 'temperatura', 755.0000, 'ºC'),
	(167602, 118, '2014-02-01 00:48:12.000000', 'temperatura', 697.0000, 'ºC'),
	(167603, 118, '2014-02-01 00:48:13.000000', 'temperatura', 22.0000, 'ºC'),
	(167604, 118, '2014-02-01 00:48:14.000000', 'temperatura', 420.0000, 'ºC'),
	(167605, 118, '2014-02-01 00:48:15.000000', 'temperatura', 832.0000, 'ºC'),
	(167606, 118, '2014-02-01 00:48:16.000000', 'temperatura', 501.0000, 'ºC'),
	(167607, 118, '2014-02-01 00:48:17.000000', 'temperatura', 11.0000, 'ºC'),
	(167608, 118, '2014-02-01 00:48:18.000000', 'temperatura', 953.0000, 'ºC'),
	(167609, 118, '2014-02-01 00:48:19.000000', 'temperatura', 1133.0000, 'ºC'),
	(167610, 118, '2014-02-01 00:48:20.000000', 'temperatura', 404.0000, 'ºC'),
	(167611, 118, '2014-02-01 00:48:21.000000', 'temperatura', 1022.0000, 'ºC'),
	(167612, 118, '2014-02-01 00:48:22.000000', 'temperatura', 301.0000, 'ºC'),
	(167613, 118, '2014-02-01 00:48:23.000000', 'temperatura', 836.0000, 'ºC'),
	(167614, 118, '2014-02-01 00:48:24.000000', 'temperatura', 879.0000, 'ºC'),
	(167615, 118, '2014-02-01 00:48:25.000000', 'temperatura', 690.0000, 'ºC'),
	(167616, 118, '2014-02-01 00:48:26.000000', 'temperatura', 810.0000, 'ºC'),
	(167617, 118, '2014-02-01 00:48:27.000000', 'temperatura', 781.0000, 'ºC'),
	(167618, 118, '2014-02-01 00:48:28.000000', 'temperatura', 276.0000, 'ºC'),
	(167619, 118, '2014-02-01 00:48:29.000000', 'temperatura', 237.0000, 'ºC'),
	(167620, 118, '2014-02-01 00:48:30.000000', 'temperatura', 359.0000, 'ºC'),
	(167621, 118, '2014-02-01 00:48:31.000000', 'temperatura', 1085.0000, 'ºC'),
	(167622, 118, '2014-02-01 00:48:32.000000', 'temperatura', 747.0000, 'ºC'),
	(167623, 118, '2014-02-01 00:48:33.000000', 'temperatura', 481.0000, 'ºC'),
	(167624, 118, '2014-02-01 00:48:34.000000', 'temperatura', 165.0000, 'ºC'),
	(167625, 118, '2014-02-01 00:48:35.000000', 'temperatura', 580.0000, 'ºC'),
	(167626, 118, '2014-02-01 00:48:36.000000', 'temperatura', 9.0000, 'ºC'),
	(167627, 118, '2014-02-01 00:48:37.000000', 'temperatura', 704.0000, 'ºC'),
	(167628, 118, '2014-02-01 00:48:38.000000', 'temperatura', 1094.0000, 'ºC'),
	(167629, 118, '2014-02-01 00:48:39.000000', 'temperatura', 959.0000, 'ºC'),
	(167630, 118, '2014-02-01 00:48:40.000000', 'temperatura', 312.0000, 'ºC'),
	(167631, 118, '2014-02-01 00:48:41.000000', 'temperatura', 1086.0000, 'ºC'),
	(167632, 118, '2014-02-01 00:48:42.000000', 'temperatura', 893.0000, 'ºC'),
	(167633, 118, '2014-02-01 00:48:43.000000', 'temperatura', 9.0000, 'ºC'),
	(167634, 118, '2014-02-01 00:48:44.000000', 'temperatura', 968.0000, 'ºC'),
	(167635, 118, '2014-02-01 00:48:45.000000', 'temperatura', 10.0000, 'ºC'),
	(167636, 118, '2014-02-01 00:48:46.000000', 'temperatura', 747.0000, 'ºC'),
	(167637, 118, '2014-02-01 00:48:47.000000', 'temperatura', 107.0000, 'ºC'),
	(167638, 118, '2014-02-01 00:48:48.000000', 'temperatura', 696.0000, 'ºC'),
	(167639, 118, '2014-02-01 00:48:49.000000', 'temperatura', 756.0000, 'ºC'),
	(167640, 118, '2014-02-01 00:48:50.000000', 'temperatura', 495.0000, 'ºC'),
	(167641, 118, '2014-02-01 00:48:51.000000', 'temperatura', 208.0000, 'ºC'),
	(167642, 118, '2014-02-01 00:48:52.000000', 'temperatura', 753.0000, 'ºC'),
	(167643, 118, '2014-02-01 00:48:53.000000', 'temperatura', 742.0000, 'ºC'),
	(167644, 118, '2014-02-01 00:48:54.000000', 'temperatura', 252.0000, 'ºC'),
	(167645, 118, '2014-02-01 00:48:55.000000', 'temperatura', 236.0000, 'ºC'),
	(167646, 118, '2014-02-01 00:48:56.000000', 'temperatura', 422.0000, 'ºC'),
	(167647, 118, '2014-02-01 00:48:57.000000', 'temperatura', 204.0000, 'ºC'),
	(167648, 118, '2014-02-01 00:48:58.000000', 'temperatura', 954.0000, 'ºC'),
	(167649, 118, '2014-02-01 00:48:59.000000', 'temperatura', 558.0000, 'ºC'),
	(167650, 118, '2014-02-01 00:49:00.000000', 'temperatura', 1129.0000, 'ºC'),
	(167651, 118, '2014-02-01 00:49:01.000000', 'temperatura', 372.0000, 'ºC'),
	(167652, 118, '2014-02-01 00:49:02.000000', 'temperatura', 873.0000, 'ºC'),
	(167653, 118, '2014-02-01 00:49:03.000000', 'temperatura', 851.0000, 'ºC'),
	(167654, 118, '2014-02-01 00:49:04.000000', 'temperatura', 435.0000, 'ºC'),
	(167655, 118, '2014-02-01 00:49:05.000000', 'temperatura', 823.0000, 'ºC'),
	(167656, 118, '2014-02-01 00:49:06.000000', 'temperatura', 409.0000, 'ºC'),
	(167657, 118, '2014-02-01 00:49:07.000000', 'temperatura', 779.0000, 'ºC'),
	(167658, 118, '2014-02-01 00:49:08.000000', 'temperatura', 266.0000, 'ºC'),
	(167659, 118, '2014-02-01 00:49:09.000000', 'temperatura', 194.0000, 'ºC'),
	(167660, 118, '2014-02-01 00:49:10.000000', 'temperatura', 175.0000, 'ºC'),
	(167661, 118, '2014-02-01 00:49:11.000000', 'temperatura', 290.0000, 'ºC'),
	(167662, 118, '2014-02-01 00:49:12.000000', 'temperatura', 927.0000, 'ºC'),
	(167663, 118, '2014-02-01 00:49:13.000000', 'temperatura', 165.0000, 'ºC'),
	(167664, 118, '2014-02-01 00:49:14.000000', 'temperatura', 445.0000, 'ºC'),
	(167665, 118, '2014-02-01 00:49:15.000000', 'temperatura', 531.0000, 'ºC'),
	(167666, 118, '2014-02-01 00:49:16.000000', 'temperatura', 118.0000, 'ºC'),
	(167667, 118, '2014-02-01 00:49:17.000000', 'temperatura', 199.0000, 'ºC'),
	(167668, 118, '2014-02-01 00:49:18.000000', 'temperatura', 642.0000, 'ºC'),
	(167669, 118, '2014-02-01 00:49:19.000000', 'temperatura', 213.0000, 'ºC'),
	(167670, 118, '2014-02-01 00:49:20.000000', 'temperatura', 341.0000, 'ºC'),
	(167671, 118, '2014-02-01 00:49:21.000000', 'temperatura', 1067.0000, 'ºC'),
	(167672, 118, '2014-02-01 00:49:22.000000', 'temperatura', 710.0000, 'ºC'),
	(167673, 118, '2014-02-01 00:49:23.000000', 'temperatura', 351.0000, 'ºC'),
	(167674, 118, '2014-02-01 00:49:24.000000', 'temperatura', 826.0000, 'ºC'),
	(167675, 118, '2014-02-01 00:49:25.000000', 'temperatura', 675.0000, 'ºC'),
	(167676, 118, '2014-02-01 00:49:26.000000', 'temperatura', 900.0000, 'ºC'),
	(167677, 118, '2014-02-01 00:49:27.000000', 'temperatura', 76.0000, 'ºC'),
	(167678, 118, '2014-02-01 00:49:28.000000', 'temperatura', 79.0000, 'ºC'),
	(167679, 118, '2014-02-01 00:49:29.000000', 'temperatura', 167.0000, 'ºC'),
	(167680, 118, '2014-02-01 00:49:30.000000', 'temperatura', 599.0000, 'ºC'),
	(167681, 118, '2014-02-01 00:49:31.000000', 'temperatura', 94.0000, 'ºC'),
	(167682, 118, '2014-02-01 00:49:32.000000', 'temperatura', 1074.0000, 'ºC'),
	(167683, 118, '2014-02-01 00:49:33.000000', 'temperatura', 286.0000, 'ºC'),
	(167684, 118, '2014-02-01 00:49:34.000000', 'temperatura', 612.0000, 'ºC'),
	(167685, 118, '2014-02-01 00:49:35.000000', 'temperatura', 1001.0000, 'ºC'),
	(167686, 118, '2014-02-01 00:49:36.000000', 'temperatura', 770.0000, 'ºC'),
	(167687, 118, '2014-02-01 00:49:37.000000', 'temperatura', 846.0000, 'ºC'),
	(167688, 118, '2014-02-01 00:49:38.000000', 'temperatura', 720.0000, 'ºC'),
	(167689, 118, '2014-02-01 00:49:39.000000', 'temperatura', 1064.0000, 'ºC'),
	(167690, 118, '2014-02-01 00:49:40.000000', 'temperatura', 762.0000, 'ºC'),
	(167691, 118, '2014-02-01 00:49:41.000000', 'temperatura', 616.0000, 'ºC'),
	(167692, 118, '2014-02-01 00:49:42.000000', 'temperatura', 795.0000, 'ºC'),
	(167693, 118, '2014-02-01 00:49:43.000000', 'temperatura', 927.0000, 'ºC'),
	(167694, 118, '2014-02-01 00:49:44.000000', 'temperatura', 1051.0000, 'ºC'),
	(167695, 118, '2014-02-01 00:49:45.000000', 'temperatura', 72.0000, 'ºC'),
	(167696, 118, '2014-02-01 00:49:46.000000', 'temperatura', 811.0000, 'ºC'),
	(167697, 118, '2014-02-01 00:49:47.000000', 'temperatura', 239.0000, 'ºC'),
	(167698, 118, '2014-02-01 00:49:48.000000', 'temperatura', 1162.0000, 'ºC'),
	(167699, 118, '2014-02-01 00:49:49.000000', 'temperatura', 292.0000, 'ºC'),
	(167700, 118, '2014-02-01 00:49:50.000000', 'temperatura', 376.0000, 'ºC'),
	(167701, 118, '2014-02-01 00:49:51.000000', 'temperatura', 1006.0000, 'ºC'),
	(167702, 118, '2014-02-01 00:49:52.000000', 'temperatura', 302.0000, 'ºC'),
	(167703, 118, '2014-02-01 00:49:53.000000', 'temperatura', 891.0000, 'ºC'),
	(167704, 118, '2014-02-01 00:49:54.000000', 'temperatura', 1150.0000, 'ºC'),
	(167705, 118, '2014-02-01 00:49:55.000000', 'temperatura', 677.0000, 'ºC'),
	(167706, 118, '2014-02-01 00:49:56.000000', 'temperatura', 1136.0000, 'ºC'),
	(167707, 118, '2014-02-01 00:49:57.000000', 'temperatura', 48.0000, 'ºC'),
	(167708, 118, '2014-02-01 00:49:58.000000', 'temperatura', 434.0000, 'ºC'),
	(167709, 118, '2014-02-01 00:49:59.000000', 'temperatura', 824.0000, 'ºC'),
	(167710, 118, '2014-02-01 00:50:00.000000', 'temperatura', 421.0000, 'ºC'),
	(167711, 118, '2014-02-01 00:50:01.000000', 'temperatura', 833.0000, 'ºC'),
	(167712, 118, '2014-02-01 00:50:02.000000', 'temperatura', 502.0000, 'ºC'),
	(167713, 118, '2014-02-01 00:50:03.000000', 'temperatura', 14.0000, 'ºC'),
	(167714, 118, '2014-02-01 00:50:04.000000', 'temperatura', 962.0000, 'ºC'),
	(167715, 118, '2014-02-01 00:50:05.000000', 'temperatura', 1170.0000, 'ºC'),
	(167716, 118, '2014-02-01 00:50:06.000000', 'temperatura', 564.0000, 'ºC'),
	(167717, 118, '2014-02-01 00:50:07.000000', 'temperatura', 509.0000, 'ºC'),
	(167718, 118, '2014-02-01 00:50:08.000000', 'temperatura', 856.0000, 'ºC'),
	(167719, 118, '2014-02-01 00:50:09.000000', 'temperatura', 353.0000, 'ºC'),
	(167720, 118, '2014-02-01 00:50:10.000000', 'temperatura', 397.0000, 'ºC'),
	(167721, 118, '2014-02-01 00:50:11.000000', 'temperatura', 926.0000, 'ºC'),
	(167722, 118, '2014-02-01 00:50:12.000000', 'temperatura', 1042.0000, 'ºC'),
	(167723, 118, '2014-02-01 00:50:13.000000', 'temperatura', 29.0000, 'ºC'),
	(167724, 118, '2014-02-01 00:50:14.000000', 'temperatura', 623.0000, 'ºC'),
	(167725, 118, '2014-02-01 00:50:15.000000', 'temperatura', 626.0000, 'ºC'),
	(167726, 118, '2014-02-01 00:50:16.000000', 'temperatura', 61.0000, 'ºC'),
	(167727, 118, '2014-02-01 00:50:17.000000', 'temperatura', 826.0000, 'ºC'),
	(167728, 118, '2014-02-01 00:50:18.000000', 'temperatura', 351.0000, 'ºC'),
	(167729, 118, '2014-02-01 00:50:19.000000', 'temperatura', 476.0000, 'ºC'),
	(167730, 118, '2014-02-01 00:50:20.000000', 'temperatura', 126.0000, 'ºC'),
	(167731, 118, '2014-02-01 00:50:21.000000', 'temperatura', 404.0000, 'ºC'),
	(167732, 118, '2014-02-01 00:50:22.000000', 'temperatura', 442.0000, 'ºC'),
	(167733, 118, '2014-02-01 00:50:23.000000', 'temperatura', 998.0000, 'ºC'),
	(167734, 118, '2014-02-01 00:50:24.000000', 'temperatura', 63.0000, 'ºC'),
	(167735, 118, '2014-02-01 00:50:25.000000', 'temperatura', 923.0000, 'ºC'),
	(167736, 118, '2014-02-01 00:50:26.000000', 'temperatura', 827.0000, 'ºC'),
	(167737, 118, '2014-02-01 00:50:27.000000', 'temperatura', 167.0000, 'ºC'),
	(167738, 118, '2014-02-01 00:50:28.000000', 'temperatura', 755.0000, 'ºC'),
	(167739, 118, '2014-02-01 00:50:29.000000', 'temperatura', 874.0000, 'ºC'),
	(167740, 118, '2014-02-01 00:50:30.000000', 'temperatura', 905.0000, 'ºC'),
	(167741, 118, '2014-02-01 00:50:31.000000', 'temperatura', 702.0000, 'ºC'),
	(167742, 118, '2014-02-01 00:50:32.000000', 'temperatura', 798.0000, 'ºC'),
	(167743, 118, '2014-02-01 00:50:33.000000', 'temperatura', 683.0000, 'ºC'),
	(167744, 118, '2014-02-01 00:50:34.000000', 'temperatura', 1020.0000, 'ºC'),
	(167745, 118, '2014-02-01 00:50:35.000000', 'temperatura', 655.0000, 'ºC'),
	(167746, 118, '2014-02-01 00:50:36.000000', 'temperatura', 212.0000, 'ºC'),
	(167747, 118, '2014-02-01 00:50:37.000000', 'temperatura', 297.0000, 'ºC'),
	(167748, 118, '2014-02-01 00:50:38.000000', 'temperatura', 852.0000, 'ºC'),
	(167749, 118, '2014-02-01 00:50:39.000000', 'temperatura', 966.0000, 'ºC'),
	(167750, 118, '2014-02-01 00:50:40.000000', 'temperatura', 1074.0000, 'ºC'),
	(167751, 118, '2014-02-01 00:50:41.000000', 'temperatura', 75.0000, 'ºC'),
	(167752, 118, '2014-02-01 00:50:42.000000', 'temperatura', 752.0000, 'ºC'),
	(167753, 118, '2014-02-01 00:50:43.000000', 'temperatura', 1136.0000, 'ºC'),
	(167754, 118, '2014-02-01 00:50:44.000000', 'temperatura', 1023.0000, 'ºC'),
	(167755, 118, '2014-02-01 00:50:45.000000', 'temperatura', 507.0000, 'ºC'),
	(167756, 118, '2014-02-01 00:50:46.000000', 'temperatura', 668.0000, 'ºC'),
	(167757, 118, '2014-02-01 00:50:47.000000', 'temperatura', 618.0000, 'ºC'),
	(167758, 118, '2014-02-01 00:50:48.000000', 'temperatura', 1089.0000, 'ºC'),
	(167759, 118, '2014-02-01 00:50:49.000000', 'temperatura', 1192.0000, 'ºC'),
	(167760, 118, '2014-02-01 00:50:50.000000', 'temperatura', 293.0000, 'ºC'),
	(167761, 118, '2014-02-01 00:50:51.000000', 'temperatura', 291.0000, 'ºC'),
	(167762, 118, '2014-02-01 00:50:52.000000', 'temperatura', 574.0000, 'ºC'),
	(167763, 118, '2014-02-01 00:50:53.000000', 'temperatura', 800.0000, 'ºC'),
	(167764, 118, '2014-02-01 00:50:54.000000', 'temperatura', 1077.0000, 'ºC'),
	(167765, 118, '2014-02-01 00:50:55.000000', 'temperatura', 586.0000, 'ºC'),
	(167766, 118, '2014-02-01 00:50:56.000000', 'temperatura', 900.0000, 'ºC'),
	(167767, 118, '2014-02-01 00:50:57.000000', 'temperatura', 340.0000, 'ºC'),
	(167768, 118, '2014-02-01 00:50:58.000000', 'temperatura', 203.0000, 'ºC'),
	(167769, 118, '2014-02-01 00:50:59.000000', 'temperatura', 1193.0000, 'ºC'),
	(167770, 118, '2014-02-01 00:51:00.000000', 'temperatura', 557.0000, 'ºC'),
	(167771, 118, '2014-02-01 00:51:01.000000', 'temperatura', 406.0000, 'ºC'),
	(167772, 118, '2014-02-01 00:51:02.000000', 'temperatura', 361.0000, 'ºC'),
	(167773, 118, '2014-02-01 00:51:03.000000', 'temperatura', 589.0000, 'ºC'),
	(167774, 118, '2014-02-01 00:51:04.000000', 'temperatura', 661.0000, 'ºC'),
	(167775, 118, '2014-02-01 00:51:05.000000', 'temperatura', 340.0000, 'ºC'),
	(167776, 118, '2014-02-01 00:51:06.000000', 'temperatura', 918.0000, 'ºC'),
	(167777, 118, '2014-02-01 00:51:07.000000', 'temperatura', 1169.0000, 'ºC'),
	(167778, 118, '2014-02-01 00:51:08.000000', 'temperatura', 694.0000, 'ºC'),
	(167779, 118, '2014-02-01 00:51:09.000000', 'temperatura', 1160.0000, 'ºC'),
	(167780, 118, '2014-02-01 00:51:10.000000', 'temperatura', 120.0000, 'ºC'),
	(167781, 118, '2014-02-01 00:51:11.000000', 'temperatura', 722.0000, 'ºC'),
	(167782, 118, '2014-02-01 00:51:12.000000', 'temperatura', 850.0000, 'ºC'),
	(167783, 118, '2014-02-01 00:51:13.000000', 'temperatura', 884.0000, 'ºC'),
	(167784, 118, '2014-02-01 00:51:14.000000', 'temperatura', 671.0000, 'ºC'),
	(167785, 118, '2014-02-01 00:51:15.000000', 'temperatura', 704.0000, 'ºC'),
	(167786, 118, '2014-02-01 00:51:16.000000', 'temperatura', 308.0000, 'ºC'),
	(167787, 118, '2014-02-01 00:51:17.000000', 'temperatura', 627.0000, 'ºC'),
	(167788, 118, '2014-02-01 00:51:18.000000', 'temperatura', 1012.0000, 'ºC'),
	(167789, 118, '2014-02-01 00:51:19.000000', 'temperatura', 781.0000, 'ºC'),
	(167790, 118, '2014-02-01 00:51:20.000000', 'temperatura', 870.0000, 'ºC'),
	(167791, 118, '2014-02-01 00:51:21.000000', 'temperatura', 808.0000, 'ºC'),
	(167792, 118, '2014-02-01 00:51:22.000000', 'temperatura', 231.0000, 'ºC'),
	(167793, 118, '2014-02-01 00:51:23.000000', 'temperatura', 1129.0000, 'ºC'),
	(167794, 118, '2014-02-01 00:51:24.000000', 'temperatura', 154.0000, 'ºC'),
	(167795, 118, '2014-02-01 00:51:25.000000', 'temperatura', 981.0000, 'ºC'),
	(167796, 118, '2014-02-01 00:51:26.000000', 'temperatura', 846.0000, 'ºC'),
	(167797, 118, '2014-02-01 00:51:27.000000', 'temperatura', 88.0000, 'ºC'),
	(167798, 118, '2014-02-01 00:51:28.000000', 'temperatura', 300.0000, 'ºC'),
	(167799, 118, '2014-02-01 00:51:29.000000', 'temperatura', 39.0000, 'ºC'),
	(167800, 118, '2014-02-01 00:51:30.000000', 'temperatura', 494.0000, 'ºC'),
	(167801, 118, '2014-02-01 00:51:31.000000', 'temperatura', 1154.0000, 'ºC'),
	(167802, 118, '2014-02-01 00:51:32.000000', 'temperatura', 689.0000, 'ºC'),
	(167803, 118, '2014-02-01 00:51:33.000000', 'temperatura', 1182.0000, 'ºC'),
	(167804, 118, '2014-02-01 00:51:34.000000', 'temperatura', 246.0000, 'ºC'),
	(167805, 118, '2014-02-01 00:51:35.000000', 'temperatura', 83.0000, 'ºC'),
	(167806, 118, '2014-02-01 00:51:36.000000', 'temperatura', 878.0000, 'ºC'),
	(167807, 118, '2014-02-01 00:51:37.000000', 'temperatura', 539.0000, 'ºC'),
	(167808, 118, '2014-02-01 00:51:38.000000', 'temperatura', 65.0000, 'ºC'),
	(167809, 118, '2014-02-01 00:51:39.000000', 'temperatura', 1106.0000, 'ºC'),
	(167810, 118, '2014-02-01 00:51:40.000000', 'temperatura', 536.0000, 'ºC'),
	(167811, 118, '2014-02-01 00:51:41.000000', 'temperatura', 563.0000, 'ºC'),
	(167812, 118, '2014-02-01 00:51:42.000000', 'temperatura', 7.0000, 'ºC'),
	(167813, 118, '2014-02-01 00:51:43.000000', 'temperatura', 745.0000, 'ºC'),
	(167814, 118, '2014-02-01 00:51:44.000000', 'temperatura', 106.0000, 'ºC'),
	(167815, 118, '2014-02-01 00:51:45.000000', 'temperatura', 697.0000, 'ºC'),
	(167816, 118, '2014-02-01 00:51:46.000000', 'temperatura', 766.0000, 'ºC'),
	(167817, 118, '2014-02-01 00:51:47.000000', 'temperatura', 541.0000, 'ºC'),
	(167818, 118, '2014-02-01 00:51:48.000000', 'temperatura', 406.0000, 'ºC'),
	(167819, 118, '2014-02-01 00:51:49.000000', 'temperatura', 410.0000, 'ºC'),
	(167820, 118, '2014-02-01 00:51:50.000000', 'temperatura', 831.0000, 'ºC'),
	(167821, 118, '2014-02-01 00:51:51.000000', 'temperatura', 526.0000, 'ºC'),
	(167822, 118, '2014-02-01 00:51:52.000000', 'temperatura', 139.0000, 'ºC'),
	(167823, 118, '2014-02-01 00:51:53.000000', 'temperatura', 314.0000, 'ºC'),
	(167824, 118, '2014-02-01 00:51:54.000000', 'temperatura', 1157.0000, 'ºC'),
	(167825, 118, '2014-02-01 00:51:55.000000', 'temperatura', 40.0000, 'ºC'),
	(167826, 118, '2014-02-01 00:51:56.000000', 'temperatura', 333.0000, 'ºC'),
	(167827, 118, '2014-02-01 00:51:57.000000', 'temperatura', 343.0000, 'ºC'),
	(167828, 118, '2014-02-01 00:51:58.000000', 'temperatura', 716.0000, 'ºC'),
	(167829, 118, '2014-02-01 00:51:59.000000', 'temperatura', 150.0000, 'ºC'),
	(167830, 118, '2014-02-01 00:52:00.000000', 'temperatura', 1006.0000, 'ºC'),
	(167831, 118, '2014-02-01 00:52:01.000000', 'temperatura', 980.0000, 'ºC'),
	(167832, 118, '2014-02-01 00:52:02.000000', 'temperatura', 683.0000, 'ºC'),
	(167833, 118, '2014-02-01 00:52:03.000000', 'temperatura', 473.0000, 'ºC'),
	(167834, 118, '2014-02-01 00:52:04.000000', 'temperatura', 320.0000, 'ºC'),
	(167835, 118, '2014-02-01 00:52:05.000000', 'temperatura', 179.0000, 'ºC'),
	(167836, 118, '2014-02-01 00:52:06.000000', 'temperatura', 1136.0000, 'ºC'),
	(167837, 118, '2014-02-01 00:52:07.000000', 'temperatura', 341.0000, 'ºC'),
	(167838, 118, '2014-02-01 00:52:08.000000', 'temperatura', 701.0000, 'ºC'),
	(167839, 118, '2014-02-01 00:52:09.000000', 'temperatura', 83.0000, 'ºC'),
	(167840, 118, '2014-02-01 00:52:10.000000', 'temperatura', 709.0000, 'ºC'),
	(167841, 118, '2014-02-01 00:52:11.000000', 'temperatura', 900.0000, 'ºC'),
	(167842, 118, '2014-02-01 00:52:12.000000', 'temperatura', 1173.0000, 'ºC'),
	(167843, 118, '2014-02-01 00:52:13.000000', 'temperatura', 766.0000, 'ºC'),
	(167844, 118, '2014-02-01 00:52:14.000000', 'temperatura', 310.0000, 'ºC'),
	(167845, 118, '2014-02-01 00:52:15.000000', 'temperatura', 453.0000, 'ºC'),
	(167846, 118, '2014-02-01 00:52:16.000000', 'temperatura', 134.0000, 'ºC'),
	(167847, 118, '2014-02-01 00:52:17.000000', 'temperatura', 511.0000, 'ºC'),
	(167848, 118, '2014-02-01 00:52:18.000000', 'temperatura', 954.0000, 'ºC'),
	(167849, 118, '2014-02-01 00:52:19.000000', 'temperatura', 838.0000, 'ºC'),
	(167850, 118, '2014-02-01 00:52:20.000000', 'temperatura', 131.0000, 'ºC'),
	(167851, 118, '2014-02-01 00:52:21.000000', 'temperatura', 538.0000, 'ºC'),
	(167852, 118, '2014-02-01 00:52:22.000000', 'temperatura', 1098.0000, 'ºC'),
	(167853, 118, '2014-02-01 00:52:23.000000', 'temperatura', 276.0000, 'ºC'),
	(167854, 118, '2014-02-01 00:52:24.000000', 'temperatura', 486.0000, 'ºC'),
	(167855, 118, '2014-02-01 00:52:25.000000', 'temperatura', 402.0000, 'ºC'),
	(167856, 118, '2014-02-01 00:52:26.000000', 'temperatura', 555.0000, 'ºC'),
	(167857, 118, '2014-02-01 00:52:27.000000', 'temperatura', 369.0000, 'ºC'),
	(167858, 118, '2014-02-01 00:52:28.000000', 'temperatura', 181.0000, 'ºC'),
	(167859, 118, '2014-02-01 00:52:29.000000', 'temperatura', 997.0000, 'ºC'),
	(167860, 118, '2014-02-01 00:52:30.000000', 'temperatura', 844.0000, 'ºC'),
	(167861, 118, '2014-02-01 00:52:31.000000', 'temperatura', 28.0000, 'ºC'),
	(167862, 118, '2014-02-01 00:52:32.000000', 'temperatura', 9.0000, 'ºC'),
	(167863, 118, '2014-02-01 00:52:33.000000', 'temperatura', 1161.0000, 'ºC'),
	(167864, 118, '2014-02-01 00:52:34.000000', 'temperatura', 979.0000, 'ºC'),
	(167865, 118, '2014-02-01 00:52:35.000000', 'temperatura', 212.0000, 'ºC'),
	(167866, 118, '2014-02-01 00:52:36.000000', 'temperatura', 526.0000, 'ºC'),
	(167867, 118, '2014-02-01 00:52:37.000000', 'temperatura', 793.0000, 'ºC'),
	(167868, 118, '2014-02-01 00:52:38.000000', 'temperatura', 1186.0000, 'ºC'),
	(167869, 118, '2014-02-01 00:52:39.000000', 'temperatura', 1153.0000, 'ºC'),
	(167870, 118, '2014-02-01 00:52:40.000000', 'temperatura', 1009.0000, 'ºC'),
	(167871, 118, '2014-02-01 00:52:41.000000', 'temperatura', 385.0000, 'ºC'),
	(167872, 118, '2014-02-01 00:52:42.000000', 'temperatura', 100.0000, 'ºC'),
	(167873, 118, '2014-02-01 00:52:43.000000', 'temperatura', 546.0000, 'ºC'),
	(167874, 118, '2014-02-01 00:52:44.000000', 'temperatura', 31.0000, 'ºC'),
	(167875, 118, '2014-02-01 00:52:45.000000', 'temperatura', 915.0000, 'ºC'),
	(167876, 118, '2014-02-01 00:52:46.000000', 'temperatura', 882.0000, 'ºC'),
	(167877, 118, '2014-02-01 00:52:47.000000', 'temperatura', 465.0000, 'ºC'),
	(167878, 118, '2014-02-01 00:52:48.000000', 'temperatura', 879.0000, 'ºC'),
	(167879, 118, '2014-02-01 00:52:49.000000', 'temperatura', 601.0000, 'ºC'),
	(167880, 118, '2014-02-01 00:52:50.000000', 'temperatura', 368.0000, 'ºC'),
	(167881, 118, '2014-02-01 00:52:51.000000', 'temperatura', 39.0000, 'ºC'),
	(167882, 118, '2014-02-01 00:52:52.000000', 'temperatura', 293.0000, 'ºC'),
	(167883, 118, '2014-02-01 00:52:53.000000', 'temperatura', 147.0000, 'ºC'),
	(167884, 118, '2014-02-01 00:52:54.000000', 'temperatura', 1056.0000, 'ºC'),
	(167885, 118, '2014-02-01 00:52:55.000000', 'temperatura', 38.0000, 'ºC'),
	(167886, 118, '2014-02-01 00:52:56.000000', 'temperatura', 626.0000, 'ºC'),
	(167887, 118, '2014-02-01 00:52:57.000000', 'temperatura', 613.0000, 'ºC'),
	(167888, 118, '2014-02-01 00:52:58.000000', 'temperatura', 1189.0000, 'ºC'),
	(167889, 118, '2014-02-01 00:52:59.000000', 'temperatura', 507.0000, 'ºC'),
	(167890, 118, '2014-02-01 00:53:00.000000', 'temperatura', 166.0000, 'ºC'),
	(167891, 118, '2014-02-01 00:53:01.000000', 'temperatura', 513.0000, 'ºC'),
	(167892, 118, '2014-02-01 00:53:02.000000', 'temperatura', 865.0000, 'ºC'),
	(167893, 118, '2014-02-01 00:53:03.000000', 'temperatura', 385.0000, 'ºC'),
	(167894, 118, '2014-02-01 00:53:04.000000', 'temperatura', 534.0000, 'ºC'),
	(167895, 118, '2014-02-01 00:53:05.000000', 'temperatura', 312.0000, 'ºC'),
	(167896, 118, '2014-02-01 00:53:06.000000', 'temperatura', 1162.0000, 'ºC'),
	(167897, 118, '2014-02-01 00:53:07.000000', 'temperatura', 71.0000, 'ºC'),
	(167898, 118, '2014-02-01 00:53:08.000000', 'temperatura', 473.0000, 'ºC'),
	(167899, 118, '2014-02-01 00:53:09.000000', 'temperatura', 949.0000, 'ºC'),
	(167900, 118, '2014-02-01 00:53:10.000000', 'temperatura', 928.0000, 'ºC'),
	(167901, 118, '2014-02-01 00:53:11.000000', 'temperatura', 593.0000, 'ºC'),
	(167902, 118, '2014-02-01 00:53:12.000000', 'temperatura', 180.0000, 'ºC'),
	(167903, 118, '2014-02-01 00:53:13.000000', 'temperatura', 323.0000, 'ºC'),
	(167904, 118, '2014-02-01 00:53:14.000000', 'temperatura', 1075.0000, 'ºC'),
	(167905, 118, '2014-02-01 00:53:15.000000', 'temperatura', 805.0000, 'ºC'),
	(167906, 118, '2014-02-01 00:53:16.000000', 'temperatura', 802.0000, 'ºC'),
	(167907, 118, '2014-02-01 00:53:17.000000', 'temperatura', 396.0000, 'ºC'),
	(167908, 118, '2014-02-01 00:53:18.000000', 'temperatura', 776.0000, 'ºC'),
	(167909, 118, '2014-02-01 00:53:19.000000', 'temperatura', 291.0000, 'ºC'),
	(167910, 118, '2014-02-01 00:53:20.000000', 'temperatura', 326.0000, 'ºC'),
	(167911, 118, '2014-02-01 00:53:21.000000', 'temperatura', 757.0000, 'ºC'),
	(167912, 118, '2014-02-01 00:53:22.000000', 'temperatura', 409.0000, 'ºC'),
	(167913, 118, '2014-02-01 00:53:23.000000', 'temperatura', 976.0000, 'ºC'),
	(167914, 118, '2014-02-01 00:53:24.000000', 'temperatura', 53.0000, 'ºC'),
	(167915, 118, '2014-02-01 00:53:25.000000', 'temperatura', 937.0000, 'ºC'),
	(167916, 118, '2014-02-01 00:53:26.000000', 'temperatura', 927.0000, 'ºC'),
	(167917, 118, '2014-02-01 00:53:27.000000', 'temperatura', 624.0000, 'ºC'),
	(167918, 118, '2014-02-01 00:53:28.000000', 'temperatura', 341.0000, 'ºC'),
	(167919, 118, '2014-02-01 00:53:29.000000', 'temperatura', 1031.0000, 'ºC'),
	(167920, 118, '2014-02-01 00:53:30.000000', 'temperatura', 531.0000, 'ºC'),
	(167921, 118, '2014-02-01 00:53:31.000000', 'temperatura', 766.0000, 'ºC'),
	(167922, 118, '2014-02-01 00:53:32.000000', 'temperatura', 1037.0000, 'ºC'),
	(167923, 118, '2014-02-01 00:53:33.000000', 'temperatura', 487.0000, 'ºC'),
	(167924, 118, '2014-02-01 00:53:34.000000', 'temperatura', 524.0000, 'ºC'),
	(167925, 118, '2014-02-01 00:53:35.000000', 'temperatura', 1162.0000, 'ºC'),
	(167926, 118, '2014-02-01 00:53:36.000000', 'temperatura', 637.0000, 'ºC'),
	(167927, 118, '2014-02-01 00:53:37.000000', 'temperatura', 899.0000, 'ºC'),
	(167928, 118, '2014-02-01 00:53:38.000000', 'temperatura', 185.0000, 'ºC'),
	(167929, 118, '2014-02-01 00:53:39.000000', 'temperatura', 627.0000, 'ºC'),
	(167930, 118, '2014-02-01 00:53:40.000000', 'temperatura', 179.0000, 'ºC'),
	(167931, 118, '2014-02-01 00:53:41.000000', 'temperatura', 218.0000, 'ºC'),
	(167932, 118, '2014-02-01 00:53:42.000000', 'temperatura', 553.0000, 'ºC'),
	(167933, 118, '2014-02-01 00:53:43.000000', 'temperatura', 910.0000, 'ºC'),
	(167934, 118, '2014-02-01 00:53:44.000000', 'temperatura', 493.0000, 'ºC'),
	(167935, 118, '2014-02-01 00:53:45.000000', 'temperatura', 936.0000, 'ºC'),
	(167936, 118, '2014-02-01 00:53:46.000000', 'temperatura', 800.0000, 'ºC'),
	(167937, 118, '2014-02-01 00:53:47.000000', 'temperatura', 1192.0000, 'ºC'),
	(167938, 118, '2014-02-01 00:53:48.000000', 'temperatura', 1162.0000, 'ºC'),
	(167939, 118, '2014-02-01 00:53:49.000000', 'temperatura', 1034.0000, 'ºC'),
	(167940, 118, '2014-02-01 00:53:50.000000', 'temperatura', 483.0000, 'ºC'),
	(167941, 118, '2014-02-01 00:53:51.000000', 'temperatura', 516.0000, 'ºC'),
	(167942, 118, '2014-02-01 00:53:52.000000', 'temperatura', 1130.0000, 'ºC'),
	(167943, 118, '2014-02-01 00:53:53.000000', 'temperatura', 502.0000, 'ºC'),
	(167944, 118, '2014-02-01 00:53:54.000000', 'temperatura', 320.0000, 'ºC'),
	(167945, 118, '2014-02-01 00:53:55.000000', 'temperatura', 93.0000, 'ºC'),
	(167946, 118, '2014-02-01 00:53:56.000000', 'temperatura', 709.0000, 'ºC'),
	(167947, 118, '2014-02-01 00:53:57.000000', 'temperatura', 865.0000, 'ºC'),
	(167948, 118, '2014-02-01 00:53:58.000000', 'temperatura', 997.0000, 'ºC'),
	(167949, 118, '2014-02-01 00:53:59.000000', 'temperatura', 1191.0000, 'ºC'),
	(167950, 118, '2014-02-01 00:54:00.000000', 'temperatura', 565.0000, 'ºC'),
	(167951, 118, '2014-02-01 00:54:01.000000', 'temperatura', 453.0000, 'ºC'),
	(167952, 118, '2014-02-01 00:54:02.000000', 'temperatura', 568.0000, 'ºC'),
	(167953, 118, '2014-02-01 00:54:03.000000', 'temperatura', 283.0000, 'ºC'),
	(167954, 118, '2014-02-01 00:54:04.000000', 'temperatura', 913.0000, 'ºC'),
	(167955, 118, '2014-02-01 00:54:05.000000', 'temperatura', 113.0000, 'ºC'),
	(167956, 118, '2014-02-01 00:54:06.000000', 'temperatura', 230.0000, 'ºC'),
	(167957, 118, '2014-02-01 00:54:07.000000', 'temperatura', 810.0000, 'ºC'),
	(167958, 118, '2014-02-01 00:54:08.000000', 'temperatura', 959.0000, 'ºC'),
	(167959, 118, '2014-02-01 00:54:09.000000', 'temperatura', 1165.0000, 'ºC'),
	(167960, 118, '2014-02-01 00:54:10.000000', 'temperatura', 549.0000, 'ºC'),
	(167961, 118, '2014-02-01 00:54:11.000000', 'temperatura', 453.0000, 'ºC'),
	(167962, 118, '2014-02-01 00:54:12.000000', 'temperatura', 617.0000, 'ºC'),
	(167963, 118, '2014-02-01 00:54:13.000000', 'temperatura', 528.0000, 'ºC'),
	(167964, 118, '2014-02-01 00:54:14.000000', 'temperatura', 789.0000, 'ºC'),
	(167965, 118, '2014-02-01 00:54:15.000000', 'temperatura', 1161.0000, 'ºC'),
	(167966, 118, '2014-02-01 00:54:16.000000', 'temperatura', 1039.0000, 'ºC'),
	(167967, 118, '2014-02-01 00:54:17.000000', 'temperatura', 512.0000, 'ºC'),
	(167968, 118, '2014-02-01 00:54:18.000000', 'temperatura', 643.0000, 'ºC'),
	(167969, 118, '2014-02-01 00:54:19.000000', 'temperatura', 478.0000, 'ºC'),
	(167970, 118, '2014-02-01 00:54:20.000000', 'temperatura', 464.0000, 'ºC'),
	(167971, 118, '2014-02-01 00:54:21.000000', 'temperatura', 887.0000, 'ºC'),
	(167972, 118, '2014-02-01 00:54:22.000000', 'temperatura', 641.0000, 'ºC'),
	(167973, 118, '2014-02-01 00:54:23.000000', 'temperatura', 544.0000, 'ºC'),
	(167974, 118, '2014-02-01 00:54:24.000000', 'temperatura', 799.0000, 'ºC'),
	(167975, 118, '2014-02-01 00:54:25.000000', 'temperatura', 1165.0000, 'ºC'),
	(167976, 118, '2014-02-01 00:54:26.000000', 'temperatura', 1027.0000, 'ºC'),
	(167977, 118, '2014-02-01 00:54:27.000000', 'temperatura', 442.0000, 'ºC'),
	(167978, 118, '2014-02-01 00:54:28.000000', 'temperatura', 327.0000, 'ºC'),
	(167979, 118, '2014-02-01 00:54:29.000000', 'temperatura', 309.0000, 'ºC'),
	(167980, 118, '2014-02-01 00:54:30.000000', 'temperatura', 566.0000, 'ºC'),
	(167981, 118, '2014-02-01 00:54:31.000000', 'temperatura', 702.0000, 'ºC'),
	(167982, 118, '2014-02-01 00:54:32.000000', 'temperatura', 615.0000, 'ºC'),
	(167983, 118, '2014-02-01 00:54:33.000000', 'temperatura', 969.0000, 'ºC'),
	(167984, 118, '2014-02-01 00:54:34.000000', 'temperatura', 600.0000, 'ºC'),
	(167985, 118, '2014-02-01 00:54:35.000000', 'temperatura', 93.0000, 'ºC'),
	(167986, 118, '2014-02-01 00:54:36.000000', 'temperatura', 1066.0000, 'ºC'),
	(167987, 118, '2014-02-01 00:54:37.000000', 'temperatura', 250.0000, 'ºC'),
	(167988, 118, '2014-02-01 00:54:38.000000', 'temperatura', 455.0000, 'ºC'),
	(167989, 118, '2014-02-01 00:54:39.000000', 'temperatura', 325.0000, 'ºC'),
	(167990, 118, '2014-02-01 00:54:40.000000', 'temperatura', 258.0000, 'ºC'),
	(167991, 118, '2014-02-01 00:54:41.000000', 'temperatura', 318.0000, 'ºC'),
	(167992, 118, '2014-02-01 00:54:42.000000', 'temperatura', 816.0000, 'ºC'),
	(167993, 118, '2014-02-01 00:54:43.000000', 'temperatura', 728.0000, 'ºC'),
	(167994, 118, '2014-02-01 00:54:44.000000', 'temperatura', 1191.0000, 'ºC'),
	(167995, 118, '2014-02-01 00:54:45.000000', 'temperatura', 173.0000, 'ºC'),
	(167996, 118, '2014-02-01 00:54:46.000000', 'temperatura', 890.0000, 'ºC'),
	(167997, 118, '2014-02-01 00:54:47.000000', 'temperatura', 331.0000, 'ºC'),
	(167998, 118, '2014-02-01 00:54:48.000000', 'temperatura', 188.0000, 'ºC'),
	(167999, 118, '2014-02-01 00:54:49.000000', 'temperatura', 1145.0000, 'ºC'),
	(168000, 118, '2014-02-01 00:54:50.000000', 'temperatura', 364.0000, 'ºC'),
	(168001, 118, '2014-02-01 00:54:51.000000', 'temperatura', 784.0000, 'ºC'),
	(168002, 118, '2014-02-01 00:54:52.000000', 'temperatura', 429.0000, 'ºC'),
	(168003, 118, '2014-02-01 00:54:53.000000', 'temperatura', 995.0000, 'ºC'),
	(168004, 118, '2014-02-01 00:54:54.000000', 'temperatura', 87.0000, 'ºC'),
	(168005, 118, '2014-02-01 00:54:55.000000', 'temperatura', 1050.0000, 'ºC'),
	(168006, 118, '2014-02-01 00:54:56.000000', 'temperatura', 188.0000, 'ºC'),
	(168007, 118, '2014-02-01 00:54:57.000000', 'temperatura', 194.0000, 'ºC'),
	(168008, 118, '2014-02-01 00:54:58.000000', 'temperatura', 405.0000, 'ºC'),
	(168009, 118, '2014-02-01 00:54:59.000000', 'temperatura', 243.0000, 'ºC'),
	(168010, 118, '2014-02-01 00:55:00.000000', 'temperatura', 0.0000, 'ºC'),
	(168011, 118, '2014-02-01 00:55:01.000000', 'temperatura', 470.0000, 'ºC'),
	(168012, 118, '2014-02-01 00:55:02.000000', 'temperatura', 1153.0000, 'ºC'),
	(168013, 118, '2014-02-01 00:55:03.000000', 'temperatura', 754.0000, 'ºC'),
	(168014, 118, '2014-02-01 00:55:04.000000', 'temperatura', 313.0000, 'ºC'),
	(168015, 118, '2014-02-01 00:55:05.000000', 'temperatura', 503.0000, 'ºC'),
	(168016, 118, '2014-02-01 00:55:06.000000', 'temperatura', 377.0000, 'ºC'),
	(168017, 118, '2014-02-01 00:55:07.000000', 'temperatura', 377.0000, 'ºC'),
	(168018, 118, '2014-02-01 00:55:08.000000', 'temperatura', 752.0000, 'ºC'),
	(168019, 118, '2014-02-01 00:55:09.000000', 'temperatura', 233.0000, 'ºC'),
	(168020, 118, '2014-02-01 00:55:10.000000', 'temperatura', 107.0000, 'ºC'),
	(168021, 118, '2014-02-01 00:55:11.000000', 'temperatura', 1036.0000, 'ºC'),
	(168022, 118, '2014-02-01 00:55:12.000000', 'temperatura', 61.0000, 'ºC'),
	(168023, 118, '2014-02-01 00:55:13.000000', 'temperatura', 796.0000, 'ºC'),
	(168024, 118, '2014-02-01 00:55:14.000000', 'temperatura', 199.0000, 'ºC'),
	(168025, 118, '2014-02-01 00:55:15.000000', 'temperatura', 1007.0000, 'ºC'),
	(168026, 118, '2014-02-01 00:55:16.000000', 'temperatura', 838.0000, 'ºC'),
	(168027, 118, '2014-02-01 00:55:17.000000', 'temperatura', 1169.0000, 'ºC'),
	(168028, 118, '2014-02-01 00:55:18.000000', 'temperatura', 932.0000, 'ºC'),
	(168029, 118, '2014-02-01 00:55:19.000000', 'temperatura', 1153.0000, 'ºC'),
	(168030, 118, '2014-02-01 00:55:20.000000', 'temperatura', 570.0000, 'ºC'),
	(168031, 118, '2014-02-01 00:55:21.000000', 'temperatura', 592.0000, 'ºC'),
	(168032, 118, '2014-02-01 00:55:22.000000', 'temperatura', 50.0000, 'ºC'),
	(168033, 118, '2014-02-01 00:55:23.000000', 'temperatura', 872.0000, 'ºC'),
	(168034, 118, '2014-02-01 00:55:24.000000', 'temperatura', 614.0000, 'ºC'),
	(168035, 118, '2014-02-01 00:55:25.000000', 'temperatura', 455.0000, 'ºC'),
	(168036, 118, '2014-02-01 00:55:26.000000', 'temperatura', 431.0000, 'ºC'),
	(168037, 118, '2014-02-01 00:55:27.000000', 'temperatura', 790.0000, 'ºC'),
	(168038, 118, '2014-02-01 00:55:28.000000', 'temperatura', 258.0000, 'ºC'),
	(168039, 118, '2014-02-01 00:55:29.000000', 'temperatura', 120.0000, 'ºC'),
	(168040, 118, '2014-02-01 00:55:30.000000', 'temperatura', 1028.0000, 'ºC'),
	(168041, 118, '2014-02-01 00:55:31.000000', 'temperatura', 1178.0000, 'ºC'),
	(168042, 118, '2014-02-01 00:55:32.000000', 'temperatura', 407.0000, 'ºC'),
	(168043, 118, '2014-02-01 00:55:33.000000', 'temperatura', 903.0000, 'ºC'),
	(168044, 118, '2014-02-01 00:55:34.000000', 'temperatura', 894.0000, 'ºC'),
	(168045, 118, '2014-02-01 00:55:35.000000', 'temperatura', 562.0000, 'ºC'),
	(168046, 118, '2014-02-01 00:55:36.000000', 'temperatura', 130.0000, 'ºC'),
	(168047, 118, '2014-02-01 00:55:37.000000', 'temperatura', 164.0000, 'ºC'),
	(168048, 118, '2014-02-01 00:55:38.000000', 'temperatura', 428.0000, 'ºC'),
	(168049, 118, '2014-02-01 00:55:39.000000', 'temperatura', 451.0000, 'ºC'),
	(168050, 118, '2014-02-01 00:55:40.000000', 'temperatura', 969.0000, 'ºC'),
	(168051, 118, '2014-02-01 00:55:41.000000', 'temperatura', 1093.0000, 'ºC'),
	(168052, 118, '2014-02-01 00:55:42.000000', 'temperatura', 157.0000, 'ºC'),
	(168053, 118, '2014-02-01 00:55:43.000000', 'temperatura', 1108.0000, 'ºC'),
	(168054, 118, '2014-02-01 00:55:44.000000', 'temperatura', 272.0000, 'ºC'),
	(168055, 118, '2014-02-01 00:55:45.000000', 'temperatura', 433.0000, 'ºC'),
	(168056, 118, '2014-02-01 00:55:46.000000', 'temperatura', 150.0000, 'ºC'),
	(168057, 118, '2014-02-01 00:55:47.000000', 'temperatura', 650.0000, 'ºC'),
	(168058, 118, '2014-02-01 00:55:48.000000', 'temperatura', 402.0000, 'ºC'),
	(168059, 118, '2014-02-01 00:55:49.000000', 'temperatura', 62.0000, 'ºC'),
	(168060, 118, '2014-02-01 00:55:50.000000', 'temperatura', 301.0000, 'ºC'),
	(168061, 118, '2014-02-01 00:55:51.000000', 'temperatura', 123.0000, 'ºC'),
	(168062, 118, '2014-02-01 00:55:52.000000', 'temperatura', 910.0000, 'ºC'),
	(168063, 118, '2014-02-01 00:55:53.000000', 'temperatura', 582.0000, 'ºC'),
	(168064, 118, '2014-02-01 00:55:54.000000', 'temperatura', 179.0000, 'ºC'),
	(168065, 118, '2014-02-01 00:55:55.000000', 'temperatura', 350.0000, 'ºC'),
	(168066, 118, '2014-02-01 00:55:56.000000', 'temperatura', 13.0000, 'ºC'),
	(168067, 118, '2014-02-01 00:55:57.000000', 'temperatura', 214.0000, 'ºC'),
	(168068, 118, '2014-02-01 00:55:58.000000', 'temperatura', 1034.0000, 'ºC'),
	(168069, 118, '2014-02-01 00:55:59.000000', 'temperatura', 929.0000, 'ºC'),
	(168070, 118, '2014-02-01 00:56:00.000000', 'temperatura', 341.0000, 'ºC'),
	(168071, 118, '2014-02-01 00:56:01.000000', 'temperatura', 118.0000, 'ºC'),
	(168072, 118, '2014-02-01 00:56:02.000000', 'temperatura', 769.0000, 'ºC'),
	(168073, 118, '2014-02-01 00:56:03.000000', 'temperatura', 1092.0000, 'ºC'),
	(168074, 118, '2014-02-01 00:56:04.000000', 'temperatura', 754.0000, 'ºC'),
	(168075, 118, '2014-02-01 00:56:05.000000', 'temperatura', 494.0000, 'ºC'),
	(168076, 118, '2014-02-01 00:56:06.000000', 'temperatura', 207.0000, 'ºC'),
	(168077, 118, '2014-02-01 00:56:07.000000', 'temperatura', 754.0000, 'ºC'),
	(168078, 118, '2014-02-01 00:56:08.000000', 'temperatura', 748.0000, 'ºC'),
	(168079, 118, '2014-02-01 00:56:09.000000', 'temperatura', 279.0000, 'ºC'),
	(168080, 118, '2014-02-01 00:56:10.000000', 'temperatura', 350.0000, 'ºC'),
	(168081, 118, '2014-02-01 00:56:11.000000', 'temperatura', 916.0000, 'ºC'),
	(168082, 118, '2014-02-01 00:56:12.000000', 'temperatura', 1128.0000, 'ºC'),
	(168083, 118, '2014-02-01 00:56:13.000000', 'temperatura', 494.0000, 'ºC'),
	(168084, 118, '2014-02-01 00:56:14.000000', 'temperatura', 286.0000, 'ºC'),
	(168085, 118, '2014-02-01 00:56:15.000000', 'temperatura', 1148.0000, 'ºC'),
	(168086, 118, '2014-02-01 00:56:16.000000', 'temperatura', 82.0000, 'ºC'),
	(168087, 118, '2014-02-01 00:56:17.000000', 'temperatura', 565.0000, 'ºC'),
	(168088, 118, '2014-02-01 00:56:18.000000', 'temperatura', 183.0000, 'ºC'),
	(168089, 118, '2014-02-01 00:56:19.000000', 'temperatura', 419.0000, 'ºC'),
	(168090, 118, '2014-02-01 00:56:20.000000', 'temperatura', 349.0000, 'ºC'),
	(168091, 118, '2014-02-01 00:56:21.000000', 'temperatura', 485.0000, 'ºC'),
	(168092, 118, '2014-02-01 00:56:22.000000', 'temperatura', 180.0000, 'ºC'),
	(168093, 118, '2014-02-01 00:56:23.000000', 'temperatura', 644.0000, 'ºC'),
	(168094, 118, '2014-02-01 00:56:24.000000', 'temperatura', 283.0000, 'ºC'),
	(168095, 118, '2014-02-01 00:56:25.000000', 'temperatura', 683.0000, 'ºC'),
	(168096, 118, '2014-02-01 00:56:26.000000', 'temperatura', 165.0000, 'ºC'),
	(168097, 118, '2014-02-01 00:56:27.000000', 'temperatura', 1175.0000, 'ºC'),
	(168098, 118, '2014-02-01 00:56:28.000000', 'temperatura', 583.0000, 'ºC'),
	(168099, 118, '2014-02-01 00:56:29.000000', 'temperatura', 590.0000, 'ºC'),
	(168100, 118, '2014-02-01 00:56:30.000000', 'temperatura', 0.0000, 'ºC'),
	(168101, 118, '2014-02-01 00:56:31.000000', 'temperatura', 633.0000, 'ºC'),
	(168102, 118, '2014-02-01 00:56:32.000000', 'temperatura', 765.0000, 'ºC'),
	(168103, 118, '2014-02-01 00:56:33.000000', 'temperatura', 726.0000, 'ºC'),
	(168104, 118, '2014-02-01 00:56:34.000000', 'temperatura', 135.0000, 'ºC'),
	(168105, 118, '2014-02-01 00:56:35.000000', 'temperatura', 898.0000, 'ºC'),
	(168106, 118, '2014-02-01 00:56:36.000000', 'temperatura', 486.0000, 'ºC'),
	(168107, 118, '2014-02-01 00:56:37.000000', 'temperatura', 935.0000, 'ºC'),
	(168108, 118, '2014-02-01 00:56:38.000000', 'temperatura', 817.0000, 'ºC'),
	(168109, 118, '2014-02-01 00:56:39.000000', 'temperatura', 83.0000, 'ºC'),
	(168110, 118, '2014-02-01 00:56:40.000000', 'temperatura', 363.0000, 'ºC'),
	(168111, 118, '2014-02-01 00:56:41.000000', 'temperatura', 367.0000, 'ºC'),
	(168112, 118, '2014-02-01 00:56:42.000000', 'temperatura', 748.0000, 'ºC'),
	(168113, 118, '2014-02-01 00:56:43.000000', 'temperatura', 238.0000, 'ºC'),
	(168114, 118, '2014-02-01 00:56:44.000000', 'temperatura', 147.0000, 'ºC'),
	(168115, 118, '2014-02-01 00:56:45.000000', 'temperatura', 19.0000, 'ºC'),
	(168116, 118, '2014-02-01 00:56:46.000000', 'temperatura', 858.0000, 'ºC'),
	(168117, 118, '2014-02-01 00:56:47.000000', 'temperatura', 630.0000, 'ºC'),
	(168118, 118, '2014-02-01 00:56:48.000000', 'temperatura', 578.0000, 'ºC'),
	(168119, 118, '2014-02-01 00:56:49.000000', 'temperatura', 1002.0000, 'ºC'),
	(168120, 118, '2014-02-01 00:56:50.000000', 'temperatura', 874.0000, 'ºC'),
	(168121, 118, '2014-02-01 00:56:51.000000', 'temperatura', 167.0000, 'ºC'),
	(168122, 118, '2014-02-01 00:56:52.000000', 'temperatura', 611.0000, 'ºC'),
	(168123, 118, '2014-02-01 00:56:53.000000', 'temperatura', 154.0000, 'ºC'),
	(168124, 118, '2014-02-01 00:56:54.000000', 'temperatura', 138.0000, 'ºC'),
	(168125, 118, '2014-02-01 00:56:55.000000', 'temperatura', 227.0000, 'ºC'),
	(168126, 118, '2014-02-01 00:56:56.000000', 'temperatura', 724.0000, 'ºC'),
	(168127, 118, '2014-02-01 00:56:57.000000', 'temperatura', 538.0000, 'ºC'),
	(168128, 118, '2014-02-01 00:56:58.000000', 'temperatura', 519.0000, 'ºC'),
	(168129, 118, '2014-02-01 00:56:59.000000', 'temperatura', 984.0000, 'ºC'),
	(168130, 118, '2014-02-01 00:57:00.000000', 'temperatura', 960.0000, 'ºC'),
	(168131, 118, '2014-02-01 00:57:01.000000', 'temperatura', 648.0000, 'ºC'),
	(168132, 118, '2014-02-01 00:57:02.000000', 'temperatura', 362.0000, 'ºC'),
	(168133, 118, '2014-02-01 00:57:03.000000', 'temperatura', 1065.0000, 'ºC'),
	(168134, 118, '2014-02-01 00:57:04.000000', 'temperatura', 639.0000, 'ºC'),
	(168135, 118, '2014-02-01 00:57:05.000000', 'temperatura', 2.0000, 'ºC'),
	(168136, 118, '2014-02-01 00:57:06.000000', 'temperatura', 494.0000, 'ºC'),
	(168137, 118, '2014-02-01 00:57:07.000000', 'temperatura', 63.0000, 'ºC'),
	(168138, 118, '2014-02-01 00:57:08.000000', 'temperatura', 35.0000, 'ºC'),
	(168139, 118, '2014-02-01 00:57:09.000000', 'temperatura', 1187.0000, 'ºC'),
	(168140, 118, '2014-02-01 00:57:10.000000', 'temperatura', 1028.0000, 'ºC'),
	(168141, 118, '2014-02-01 00:57:11.000000', 'temperatura', 381.0000, 'ºC'),
	(168142, 118, '2014-02-01 00:57:12.000000', 'temperatura', 20.0000, 'ºC'),
	(168143, 118, '2014-02-01 00:57:13.000000', 'temperatura', 158.0000, 'ºC'),
	(168144, 118, '2014-02-01 00:57:14.000000', 'temperatura', 732.0000, 'ºC'),
	(168145, 118, '2014-02-01 00:57:15.000000', 'temperatura', 786.0000, 'ºC'),
	(168146, 118, '2014-02-01 00:57:16.000000', 'temperatura', 533.0000, 'ºC'),
	(168147, 118, '2014-02-01 00:57:17.000000', 'temperatura', 307.0000, 'ºC'),
	(168148, 118, '2014-02-01 00:57:18.000000', 'temperatura', 1138.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(168149, 118, '2014-02-01 00:57:19.000000', 'temperatura', 1168.0000, 'ºC'),
	(168150, 118, '2014-02-01 00:57:20.000000', 'temperatura', 26.0000, 'ºC'),
	(168151, 118, '2014-02-01 00:57:21.000000', 'temperatura', 228.0000, 'ºC'),
	(168152, 118, '2014-02-01 00:57:22.000000', 'temperatura', 1061.0000, 'ºC'),
	(168153, 118, '2014-02-01 00:57:23.000000', 'temperatura', 1022.0000, 'ºC'),
	(168154, 118, '2014-02-01 00:57:24.000000', 'temperatura', 729.0000, 'ºC'),
	(168155, 118, '2014-02-01 00:57:25.000000', 'temperatura', 578.0000, 'ºC'),
	(168156, 118, '2014-02-01 00:57:26.000000', 'temperatura', 702.0000, 'ºC'),
	(168157, 118, '2014-02-01 00:57:27.000000', 'temperatura', 578.0000, 'ºC'),
	(168158, 118, '2014-02-01 00:57:28.000000', 'temperatura', 786.0000, 'ºC'),
	(168159, 118, '2014-02-01 00:57:29.000000', 'temperatura', 997.0000, 'ºC'),
	(168160, 118, '2014-02-01 00:57:30.000000', 'temperatura', 227.0000, 'ºC'),
	(168161, 118, '2014-02-01 00:57:31.000000', 'temperatura', 543.0000, 'ºC'),
	(168162, 118, '2014-02-01 00:57:32.000000', 'temperatura', 837.0000, 'ºC'),
	(168163, 118, '2014-02-01 00:57:33.000000', 'temperatura', 154.0000, 'ºC'),
	(168164, 118, '2014-02-01 00:57:34.000000', 'temperatura', 658.0000, 'ºC'),
	(168165, 118, '2014-02-01 00:57:35.000000', 'temperatura', 431.0000, 'ºC'),
	(168166, 118, '2014-02-01 00:57:36.000000', 'temperatura', 182.0000, 'ºC'),
	(168167, 118, '2014-02-01 00:57:37.000000', 'temperatura', 817.0000, 'ºC'),
	(168168, 118, '2014-02-01 00:57:38.000000', 'temperatura', 1138.0000, 'ºC'),
	(168169, 118, '2014-02-01 00:57:39.000000', 'temperatura', 838.0000, 'ºC'),
	(168170, 118, '2014-02-01 00:57:40.000000', 'temperatura', 780.0000, 'ºC'),
	(168171, 118, '2014-02-01 00:57:41.000000', 'temperatura', 186.0000, 'ºC'),
	(168172, 118, '2014-02-01 00:57:42.000000', 'temperatura', 991.0000, 'ºC'),
	(168173, 118, '2014-02-01 00:57:43.000000', 'temperatura', 798.0000, 'ºC'),
	(168174, 118, '2014-02-01 00:57:44.000000', 'temperatura', 1016.0000, 'ºC'),
	(168175, 118, '2014-02-01 00:57:45.000000', 'temperatura', 287.0000, 'ºC'),
	(168176, 118, '2014-02-01 00:57:46.000000', 'temperatura', 788.0000, 'ºC'),
	(168177, 118, '2014-02-01 00:57:47.000000', 'temperatura', 678.0000, 'ºC'),
	(168178, 118, '2014-02-01 00:57:48.000000', 'temperatura', 1028.0000, 'ºC'),
	(168179, 118, '2014-02-01 00:57:49.000000', 'temperatura', 707.0000, 'ºC'),
	(168180, 118, '2014-02-01 00:57:50.000000', 'temperatura', 451.0000, 'ºC'),
	(168181, 118, '2014-02-01 00:57:51.000000', 'temperatura', 133.0000, 'ºC'),
	(168182, 118, '2014-02-01 00:57:52.000000', 'temperatura', 514.0000, 'ºC'),
	(168183, 118, '2014-02-01 00:57:53.000000', 'temperatura', 970.0000, 'ºC'),
	(168184, 118, '2014-02-01 00:57:54.000000', 'temperatura', 911.0000, 'ºC'),
	(168185, 118, '2014-02-01 00:57:55.000000', 'temperatura', 446.0000, 'ºC'),
	(168186, 118, '2014-02-01 00:57:56.000000', 'temperatura', 696.0000, 'ºC'),
	(168187, 118, '2014-02-01 00:57:57.000000', 'temperatura', 944.0000, 'ºC'),
	(168188, 118, '2014-02-01 00:57:58.000000', 'temperatura', 230.0000, 'ºC'),
	(168189, 118, '2014-02-01 00:57:59.000000', 'temperatura', 721.0000, 'ºC'),
	(168190, 118, '2014-02-01 00:58:00.000000', 'temperatura', 515.0000, 'ºC'),
	(168191, 118, '2014-02-01 00:58:01.000000', 'temperatura', 411.0000, 'ºC'),
	(168192, 118, '2014-02-01 00:58:02.000000', 'temperatura', 511.0000, 'ºC'),
	(168193, 118, '2014-02-01 00:58:03.000000', 'temperatura', 123.0000, 'ºC'),
	(168194, 118, '2014-02-01 00:58:04.000000', 'temperatura', 284.0000, 'ºC'),
	(168195, 118, '2014-02-01 00:58:05.000000', 'temperatura', 1050.0000, 'ºC'),
	(168196, 118, '2014-02-01 00:58:06.000000', 'temperatura', 798.0000, 'ºC'),
	(168197, 118, '2014-02-01 00:58:07.000000', 'temperatura', 839.0000, 'ºC'),
	(168198, 118, '2014-02-01 00:58:08.000000', 'temperatura', 603.0000, 'ºC'),
	(168199, 118, '2014-02-01 00:58:09.000000', 'temperatura', 497.0000, 'ºC'),
	(168200, 118, '2014-02-01 00:58:10.000000', 'temperatura', 676.0000, 'ºC'),
	(168201, 118, '2014-02-01 00:58:11.000000', 'temperatura', 692.0000, 'ºC'),
	(168202, 118, '2014-02-01 00:58:12.000000', 'temperatura', 233.0000, 'ºC'),
	(168203, 118, '2014-02-01 00:58:13.000000', 'temperatura', 290.0000, 'ºC'),
	(168204, 118, '2014-02-01 00:58:14.000000', 'temperatura', 750.0000, 'ºC'),
	(168205, 118, '2014-02-01 00:58:15.000000', 'temperatura', 480.0000, 'ºC'),
	(168206, 118, '2014-02-01 00:58:16.000000', 'temperatura', 153.0000, 'ºC'),
	(168207, 118, '2014-02-01 00:58:17.000000', 'temperatura', 522.0000, 'ºC'),
	(168208, 118, '2014-02-01 00:58:18.000000', 'temperatura', 955.0000, 'ºC'),
	(168209, 118, '2014-02-01 00:58:19.000000', 'temperatura', 807.0000, 'ºC'),
	(168210, 118, '2014-02-01 00:58:20.000000', 'temperatura', 1172.0000, 'ºC'),
	(168211, 118, '2014-02-01 00:58:21.000000', 'temperatura', 1039.0000, 'ºC'),
	(168212, 118, '2014-02-01 00:58:22.000000', 'temperatura', 480.0000, 'ºC'),
	(168213, 118, '2014-02-01 00:58:23.000000', 'temperatura', 482.0000, 'ºC'),
	(168214, 118, '2014-02-01 00:58:24.000000', 'temperatura', 970.0000, 'ºC'),
	(168215, 118, '2014-02-01 00:58:25.000000', 'temperatura', 1007.0000, 'ºC'),
	(168216, 118, '2014-02-01 00:58:26.000000', 'temperatura', 923.0000, 'ºC'),
	(168217, 118, '2014-02-01 00:58:27.000000', 'temperatura', 396.0000, 'ºC'),
	(168218, 118, '2014-02-01 00:58:28.000000', 'temperatura', 413.0000, 'ºC'),
	(168219, 118, '2014-02-01 00:58:29.000000', 'temperatura', 877.0000, 'ºC'),
	(168220, 118, '2014-02-01 00:58:30.000000', 'temperatura', 747.0000, 'ºC'),
	(168221, 118, '2014-02-01 00:58:31.000000', 'temperatura', 1104.0000, 'ºC'),
	(168222, 118, '2014-02-01 00:58:32.000000', 'temperatura', 880.0000, 'ºC'),
	(168223, 118, '2014-02-01 00:58:33.000000', 'temperatura', 1087.0000, 'ºC'),
	(168224, 118, '2014-02-01 00:58:34.000000', 'temperatura', 397.0000, 'ºC'),
	(168225, 118, '2014-02-01 00:58:35.000000', 'temperatura', 1125.0000, 'ºC'),
	(168226, 118, '2014-02-01 00:58:36.000000', 'temperatura', 834.0000, 'ºC'),
	(168227, 118, '2014-02-01 00:58:37.000000', 'temperatura', 797.0000, 'ºC'),
	(168228, 118, '2014-02-01 00:58:38.000000', 'temperatura', 280.0000, 'ºC'),
	(168229, 118, '2014-02-01 00:58:39.000000', 'temperatura', 212.0000, 'ºC'),
	(168230, 118, '2014-02-01 00:58:40.000000', 'temperatura', 220.0000, 'ºC'),
	(168231, 118, '2014-02-01 00:58:41.000000', 'temperatura', 464.0000, 'ºC'),
	(168232, 118, '2014-02-01 00:58:42.000000', 'temperatura', 459.0000, 'ºC'),
	(168233, 118, '2014-02-01 00:58:43.000000', 'temperatura', 905.0000, 'ºC'),
	(168234, 118, '2014-02-01 00:58:44.000000', 'temperatura', 748.0000, 'ºC'),
	(168235, 118, '2014-02-01 00:58:45.000000', 'temperatura', 1024.0000, 'ºC'),
	(168236, 118, '2014-02-01 00:58:46.000000', 'temperatura', 477.0000, 'ºC'),
	(168237, 118, '2014-02-01 00:58:47.000000', 'temperatura', 512.0000, 'ºC'),
	(168238, 118, '2014-02-01 00:58:48.000000', 'temperatura', 1132.0000, 'ºC'),
	(168239, 118, '2014-02-01 00:58:49.000000', 'temperatura', 525.0000, 'ºC'),
	(168240, 118, '2014-02-01 00:58:50.000000', 'temperatura', 430.0000, 'ºC'),
	(168241, 118, '2014-02-01 00:58:51.000000', 'temperatura', 576.0000, 'ºC'),
	(168242, 118, '2014-02-01 00:58:52.000000', 'temperatura', 388.0000, 'ºC'),
	(168243, 118, '2014-02-01 00:58:53.000000', 'temperatura', 214.0000, 'ºC'),
	(168244, 118, '2014-02-01 00:58:54.000000', 'temperatura', 1107.0000, 'ºC'),
	(168245, 118, '2014-02-01 00:58:55.000000', 'temperatura', 94.0000, 'ºC'),
	(168246, 118, '2014-02-01 00:58:56.000000', 'temperatura', 751.0000, 'ºC'),
	(168247, 118, '2014-02-01 00:58:57.000000', 'temperatura', 1070.0000, 'ºC'),
	(168248, 118, '2014-02-01 00:58:58.000000', 'temperatura', 699.0000, 'ºC'),
	(168249, 118, '2014-02-01 00:58:59.000000', 'temperatura', 286.0000, 'ºC'),
	(168250, 118, '2014-02-01 00:59:00.000000', 'temperatura', 533.0000, 'ºC'),
	(168251, 118, '2014-02-01 00:59:01.000000', 'temperatura', 607.0000, 'ºC'),
	(168252, 118, '2014-02-01 00:59:02.000000', 'temperatura', 236.0000, 'ºC'),
	(168253, 118, '2014-02-01 00:59:03.000000', 'temperatura', 561.0000, 'ºC'),
	(168254, 118, '2014-02-01 00:59:04.000000', 'temperatura', 897.0000, 'ºC'),
	(168255, 118, '2014-02-01 00:59:05.000000', 'temperatura', 401.0000, 'ºC'),
	(168256, 118, '2014-02-01 00:59:06.000000', 'temperatura', 515.0000, 'ºC'),
	(168257, 118, '2014-02-01 00:59:07.000000', 'temperatura', 175.0000, 'ºC'),
	(168258, 118, '2014-02-01 00:59:08.000000', 'temperatura', 528.0000, 'ºC'),
	(168259, 118, '2014-02-01 00:59:09.000000', 'temperatura', 918.0000, 'ºC'),
	(168260, 118, '2014-02-01 00:59:10.000000', 'temperatura', 606.0000, 'ºC'),
	(168261, 118, '2014-02-01 00:59:11.000000', 'temperatura', 275.0000, 'ºC'),
	(168262, 118, '2014-02-01 00:59:12.000000', 'temperatura', 758.0000, 'ºC'),
	(168263, 118, '2014-02-01 00:59:13.000000', 'temperatura', 567.0000, 'ºC'),
	(168264, 118, '2014-02-01 00:59:14.000000', 'temperatura', 562.0000, 'ºC'),
	(168265, 118, '2014-02-01 00:59:15.000000', 'temperatura', 1109.0000, 'ºC'),
	(168266, 118, '2014-02-01 00:59:16.000000', 'temperatura', 258.0000, 'ºC'),
	(168267, 118, '2014-02-01 00:59:17.000000', 'temperatura', 363.0000, 'ºC'),
	(168268, 118, '2014-02-01 00:59:18.000000', 'temperatura', 1041.0000, 'ºC'),
	(168269, 118, '2014-02-01 00:59:19.000000', 'temperatura', 519.0000, 'ºC'),
	(168270, 118, '2014-02-01 00:59:20.000000', 'temperatura', 672.0000, 'ºC'),
	(168271, 118, '2014-02-01 00:59:21.000000', 'temperatura', 604.0000, 'ºC'),
	(168272, 118, '2014-02-01 00:59:22.000000', 'temperatura', 1002.0000, 'ºC'),
	(168273, 118, '2014-02-01 00:59:23.000000', 'temperatura', 800.0000, 'ºC'),
	(168274, 118, '2014-02-01 00:59:24.000000', 'temperatura', 993.0000, 'ºC'),
	(168275, 118, '2014-02-01 00:59:25.000000', 'temperatura', 168.0000, 'ºC'),
	(168276, 118, '2014-02-01 00:59:26.000000', 'temperatura', 259.0000, 'ºC'),
	(168277, 118, '2014-02-01 00:59:27.000000', 'temperatura', 792.0000, 'ºC'),
	(168278, 118, '2014-02-01 00:59:28.000000', 'temperatura', 783.0000, 'ºC'),
	(168279, 118, '2014-02-01 00:59:29.000000', 'temperatura', 339.0000, 'ºC'),
	(168280, 118, '2014-02-01 00:59:30.000000', 'temperatura', 546.0000, 'ºC'),
	(168281, 118, '2014-02-01 00:59:31.000000', 'temperatura', 516.0000, 'ºC'),
	(168282, 118, '2014-02-01 00:59:32.000000', 'temperatura', 941.0000, 'ºC'),
	(168283, 118, '2014-02-01 00:59:33.000000', 'temperatura', 760.0000, 'ºC'),
	(168284, 118, '2014-02-01 00:59:34.000000', 'temperatura', 974.0000, 'ºC'),
	(168285, 118, '2014-02-01 00:59:35.000000', 'temperatura', 192.0000, 'ºC'),
	(168286, 118, '2014-02-01 00:59:36.000000', 'temperatura', 439.0000, 'ºC'),
	(168287, 118, '2014-02-01 00:59:37.000000', 'temperatura', 421.0000, 'ºC'),
	(168288, 118, '2014-02-01 00:59:38.000000', 'temperatura', 787.0000, 'ºC'),
	(168289, 118, '2014-02-01 00:59:39.000000', 'temperatura', 274.0000, 'ºC'),
	(168290, 118, '2014-02-01 00:59:40.000000', 'temperatura', 210.0000, 'ºC'),
	(168291, 118, '2014-02-01 00:59:41.000000', 'temperatura', 226.0000, 'ºC'),
	(168292, 118, '2014-02-01 00:59:42.000000', 'temperatura', 503.0000, 'ºC'),
	(168293, 118, '2014-02-01 00:59:43.000000', 'temperatura', 639.0000, 'ºC'),
	(168294, 118, '2014-02-01 00:59:44.000000', 'temperatura', 483.0000, 'ºC'),
	(168295, 118, '2014-02-01 00:59:45.000000', 'temperatura', 499.0000, 'ºC'),
	(168296, 118, '2014-02-01 00:59:46.000000', 'temperatura', 1047.0000, 'ºC'),
	(168297, 118, '2014-02-01 00:59:47.000000', 'temperatura', 137.0000, 'ºC'),
	(168298, 118, '2014-02-01 00:59:48.000000', 'temperatura', 1145.0000, 'ºC'),
	(168299, 118, '2014-02-01 00:59:49.000000', 'temperatura', 516.0000, 'ºC'),
	(168300, 118, '2014-02-01 00:59:50.000000', 'temperatura', 344.0000, 'ºC'),
	(168301, 118, '2014-02-01 00:59:51.000000', 'temperatura', 172.0000, 'ºC'),
	(168302, 118, '2014-02-01 00:59:52.000000', 'temperatura', 1028.0000, 'ºC'),
	(168303, 118, '2014-02-01 00:59:53.000000', 'temperatura', 1025.0000, 'ºC'),
	(168304, 118, '2014-02-01 00:59:54.000000', 'temperatura', 843.0000, 'ºC'),
	(168305, 118, '2014-02-01 00:59:55.000000', 'temperatura', 1142.0000, 'ºC'),
	(168306, 118, '2014-02-01 00:59:56.000000', 'temperatura', 778.0000, 'ºC'),
	(168307, 118, '2014-02-01 00:59:57.000000', 'temperatura', 467.0000, 'ºC'),
	(168308, 118, '2014-02-01 00:59:58.000000', 'temperatura', 0.0000, 'ºC'),
	(168309, 118, '2014-02-01 00:59:59.000000', 'temperatura', 1001.0000, 'ºC'),
	(168310, 118, '2014-02-01 01:00:00.000000', 'temperatura', 204.0000, 'ºC'),
	(168311, 118, '2014-02-01 01:00:01.000000', 'temperatura', 417.0000, 'ºC'),
	(168312, 118, '2014-02-01 01:00:02.000000', 'temperatura', 273.0000, 'ºC'),
	(168313, 118, '2014-02-01 01:00:03.000000', 'temperatura', 113.0000, 'ºC'),
	(168314, 118, '2014-02-01 01:00:04.000000', 'temperatura', 950.0000, 'ºC'),
	(168315, 118, '2014-02-01 01:00:05.000000', 'temperatura', 810.0000, 'ºC'),
	(168316, 118, '2014-02-01 01:00:06.000000', 'temperatura', 1.0000, 'ºC'),
	(168317, 118, '2014-02-01 01:00:07.000000', 'temperatura', 1176.0000, 'ºC'),
	(168318, 118, '2014-02-01 01:00:08.000000', 'temperatura', 1076.0000, 'ºC'),
	(168319, 118, '2014-02-01 01:00:09.000000', 'temperatura', 652.0000, 'ºC'),
	(168320, 118, '2014-02-01 01:00:10.000000', 'temperatura', 33.0000, 'ºC'),
	(168321, 118, '2014-02-01 01:00:11.000000', 'temperatura', 610.0000, 'ºC'),
	(168322, 118, '2014-02-01 01:00:12.000000', 'temperatura', 551.0000, 'ºC'),
	(168323, 118, '2014-02-01 01:00:13.000000', 'temperatura', 925.0000, 'ºC'),
	(168324, 118, '2014-02-01 01:00:14.000000', 'temperatura', 574.0000, 'ºC'),
	(168325, 118, '2014-02-01 01:00:15.000000', 'temperatura', 97.0000, 'ºC'),
	(168326, 118, '2014-02-01 01:00:16.000000', 'temperatura', 1161.0000, 'ºC'),
	(168327, 118, '2014-02-01 01:00:17.000000', 'temperatura', 716.0000, 'ºC'),
	(168328, 118, '2014-02-01 01:00:18.000000', 'temperatura', 96.0000, 'ºC'),
	(168329, 118, '2014-02-01 01:00:19.000000', 'temperatura', 733.0000, 'ºC'),
	(168330, 118, '2014-02-01 01:00:20.000000', 'temperatura', 977.0000, 'ºC'),
	(168331, 118, '2014-02-01 01:00:21.000000', 'temperatura', 287.0000, 'ºC'),
	(168332, 118, '2014-02-01 01:00:22.000000', 'temperatura', 904.0000, 'ºC'),
	(168333, 118, '2014-02-01 01:00:23.000000', 'temperatura', 62.0000, 'ºC'),
	(168334, 118, '2014-02-01 01:00:24.000000', 'temperatura', 1196.0000, 'ºC'),
	(168335, 118, '2014-02-01 01:00:25.000000', 'temperatura', 997.0000, 'ºC'),
	(168336, 118, '2014-02-01 01:00:26.000000', 'temperatura', 195.0000, 'ºC'),
	(168337, 118, '2014-02-01 01:00:27.000000', 'temperatura', 384.0000, 'ºC'),
	(168338, 118, '2014-02-01 01:00:28.000000', 'temperatura', 136.0000, 'ºC'),
	(168339, 118, '2014-02-01 01:00:29.000000', 'temperatura', 728.0000, 'ºC'),
	(168340, 118, '2014-02-01 01:00:30.000000', 'temperatura', 832.0000, 'ºC'),
	(168341, 118, '2014-02-01 01:00:31.000000', 'temperatura', 776.0000, 'ºC'),
	(168342, 118, '2014-02-01 01:00:32.000000', 'temperatura', 185.0000, 'ºC'),
	(168343, 118, '2014-02-01 01:00:33.000000', 'temperatura', 1000.0000, 'ºC'),
	(168344, 118, '2014-02-01 01:00:34.000000', 'temperatura', 842.0000, 'ºC'),
	(168345, 118, '2014-02-01 01:00:35.000000', 'temperatura', 13.0000, 'ºC'),
	(168346, 118, '2014-02-01 01:00:36.000000', 'temperatura', 1140.0000, 'ºC'),
	(168347, 118, '2014-02-01 01:00:37.000000', 'temperatura', 861.0000, 'ºC'),
	(168348, 118, '2014-02-01 01:00:38.000000', 'temperatura', 884.0000, 'ºC'),
	(168349, 118, '2014-02-01 01:00:39.000000', 'temperatura', 640.0000, 'ºC'),
	(168350, 118, '2014-02-01 01:00:40.000000', 'temperatura', 548.0000, 'ºC'),
	(168351, 118, '2014-02-01 01:00:41.000000', 'temperatura', 822.0000, 'ºC'),
	(168352, 118, '2014-02-01 01:00:42.000000', 'temperatura', 66.0000, 'ºC'),
	(168353, 118, '2014-02-01 01:00:43.000000', 'temperatura', 263.0000, 'ºC'),
	(168354, 118, '2014-02-01 01:00:44.000000', 'temperatura', 1119.0000, 'ºC'),
	(168355, 118, '2014-02-01 01:00:45.000000', 'temperatura', 5.0000, 'ºC'),
	(168356, 118, '2014-02-01 01:00:46.000000', 'temperatura', 267.0000, 'ºC'),
	(168357, 118, '2014-02-01 01:00:47.000000', 'temperatura', 123.0000, 'ºC'),
	(168358, 118, '2014-02-01 01:00:48.000000', 'temperatura', 1013.0000, 'ºC'),
	(168359, 118, '2014-02-01 01:00:49.000000', 'temperatura', 1098.0000, 'ºC'),
	(168360, 118, '2014-02-01 01:00:50.000000', 'temperatura', 51.0000, 'ºC'),
	(168361, 118, '2014-02-01 01:00:51.000000', 'temperatura', 563.0000, 'ºC'),
	(168362, 118, '2014-02-01 01:00:52.000000', 'temperatura', 262.0000, 'ºC'),
	(168363, 118, '2014-02-01 01:00:53.000000', 'temperatura', 819.0000, 'ºC'),
	(168364, 118, '2014-02-01 01:00:54.000000', 'temperatura', 911.0000, 'ºC'),
	(168365, 118, '2014-02-01 01:00:55.000000', 'temperatura', 900.0000, 'ºC'),
	(168366, 118, '2014-02-01 01:00:56.000000', 'temperatura', 565.0000, 'ºC'),
	(168367, 118, '2014-02-01 01:00:57.000000', 'temperatura', 125.0000, 'ºC'),
	(168368, 118, '2014-02-01 01:00:58.000000', 'temperatura', 131.0000, 'ºC'),
	(168369, 118, '2014-02-01 01:00:59.000000', 'temperatura', 279.0000, 'ºC'),
	(168370, 118, '2014-02-01 01:01:00.000000', 'temperatura', 1003.0000, 'ºC'),
	(168371, 118, '2014-02-01 01:01:01.000000', 'temperatura', 579.0000, 'ºC'),
	(168372, 118, '2014-02-01 01:01:02.000000', 'temperatura', 1086.0000, 'ºC'),
	(168373, 118, '2014-02-01 01:01:03.000000', 'temperatura', 94.0000, 'ºC'),
	(168374, 118, '2014-02-01 01:01:04.000000', 'temperatura', 814.0000, 'ºC'),
	(168375, 118, '2014-02-01 01:01:05.000000', 'temperatura', 189.0000, 'ºC'),
	(168376, 118, '2014-02-01 01:01:06.000000', 'temperatura', 903.0000, 'ºC'),
	(168377, 118, '2014-02-01 01:01:07.000000', 'temperatura', 349.0000, 'ºC'),
	(168378, 118, '2014-02-01 01:01:08.000000', 'temperatura', 237.0000, 'ºC'),
	(168379, 118, '2014-02-01 01:01:09.000000', 'temperatura', 136.0000, 'ºC'),
	(168380, 118, '2014-02-01 01:01:10.000000', 'temperatura', 1171.0000, 'ºC'),
	(168381, 118, '2014-02-01 01:01:11.000000', 'temperatura', 649.0000, 'ºC'),
	(168382, 118, '2014-02-01 01:01:12.000000', 'temperatura', 931.0000, 'ºC'),
	(168383, 118, '2014-02-01 01:01:13.000000', 'temperatura', 309.0000, 'ºC'),
	(168384, 118, '2014-02-01 01:01:14.000000', 'temperatura', 1151.0000, 'ºC'),
	(168385, 118, '2014-02-01 01:01:15.000000', 'temperatura', 31.0000, 'ºC'),
	(168386, 118, '2014-02-01 01:01:16.000000', 'temperatura', 303.0000, 'ºC'),
	(168387, 118, '2014-02-01 01:01:17.000000', 'temperatura', 222.0000, 'ºC'),
	(168388, 118, '2014-02-01 01:01:18.000000', 'temperatura', 201.0000, 'ºC'),
	(168389, 118, '2014-02-01 01:01:19.000000', 'temperatura', 341.0000, 'ºC'),
	(168390, 118, '2014-02-01 01:01:20.000000', 'temperatura', 1102.0000, 'ºC'),
	(168391, 118, '2014-02-01 01:01:21.000000', 'temperatura', 889.0000, 'ºC'),
	(168392, 118, '2014-02-01 01:01:22.000000', 'temperatura', 1137.0000, 'ºC'),
	(168393, 118, '2014-02-01 01:01:23.000000', 'temperatura', 621.0000, 'ºC'),
	(168394, 118, '2014-02-01 01:01:24.000000', 'temperatura', 892.0000, 'ºC'),
	(168395, 118, '2014-02-01 01:01:25.000000', 'temperatura', 197.0000, 'ºC'),
	(168396, 118, '2014-02-01 01:01:26.000000', 'temperatura', 711.0000, 'ºC'),
	(168397, 118, '2014-02-01 01:01:27.000000', 'temperatura', 563.0000, 'ºC'),
	(168398, 118, '2014-02-01 01:01:28.000000', 'temperatura', 685.0000, 'ºC'),
	(168399, 118, '2014-02-01 01:01:29.000000', 'temperatura', 536.0000, 'ºC'),
	(168400, 118, '2014-02-01 01:01:30.000000', 'temperatura', 625.0000, 'ºC'),
	(168401, 118, '2014-02-01 01:01:31.000000', 'temperatura', 317.0000, 'ºC'),
	(168402, 118, '2014-02-01 01:01:32.000000', 'temperatura', 910.0000, 'ºC'),
	(168403, 118, '2014-02-01 01:01:33.000000', 'temperatura', 1199.0000, 'ºC'),
	(168404, 118, '2014-02-01 01:01:34.000000', 'temperatura', 865.0000, 'ºC'),
	(168405, 118, '2014-02-01 01:01:35.000000', 'temperatura', 728.0000, 'ºC'),
	(168406, 118, '2014-02-01 01:01:36.000000', 'temperatura', 1048.0000, 'ºC'),
	(168407, 118, '2014-02-01 01:01:37.000000', 'temperatura', 656.0000, 'ºC'),
	(168408, 118, '2014-02-01 01:01:38.000000', 'temperatura', 134.0000, 'ºC'),
	(168409, 118, '2014-02-01 01:01:39.000000', 'temperatura', 1104.0000, 'ºC'),
	(168410, 118, '2014-02-01 01:01:40.000000', 'temperatura', 320.0000, 'ºC'),
	(168411, 118, '2014-02-01 01:01:41.000000', 'temperatura', 687.0000, 'ºC'),
	(168412, 118, '2014-02-01 01:01:42.000000', 'temperatura', 76.0000, 'ºC'),
	(168413, 118, '2014-02-01 01:01:43.000000', 'temperatura', 721.0000, 'ºC'),
	(168414, 118, '2014-02-01 01:01:44.000000', 'temperatura', 975.0000, 'ºC'),
	(168415, 118, '2014-02-01 01:01:45.000000', 'temperatura', 313.0000, 'ºC'),
	(168416, 118, '2014-02-01 01:01:46.000000', 'temperatura', 1040.0000, 'ºC'),
	(168417, 118, '2014-02-01 01:01:47.000000', 'temperatura', 664.0000, 'ºC'),
	(168418, 118, '2014-02-01 01:01:48.000000', 'temperatura', 199.0000, 'ºC'),
	(168419, 118, '2014-02-01 01:01:49.000000', 'temperatura', 205.0000, 'ºC'),
	(168420, 118, '2014-02-01 01:01:50.000000', 'temperatura', 426.0000, 'ºC'),
	(168421, 118, '2014-02-01 01:01:51.000000', 'temperatura', 318.0000, 'ºC'),
	(168422, 118, '2014-02-01 01:01:52.000000', 'temperatura', 310.0000, 'ºC'),
	(168423, 118, '2014-02-01 01:01:53.000000', 'temperatura', 599.0000, 'ºC'),
	(168424, 118, '2014-02-01 01:01:54.000000', 'temperatura', 866.0000, 'ºC'),
	(168425, 118, '2014-02-01 01:01:55.000000', 'temperatura', 134.0000, 'ºC'),
	(168426, 118, '2014-02-01 01:01:56.000000', 'temperatura', 470.0000, 'ºC'),
	(168427, 118, '2014-02-01 01:01:57.000000', 'temperatura', 749.0000, 'ºC'),
	(168428, 118, '2014-02-01 01:01:58.000000', 'temperatura', 1138.0000, 'ºC'),
	(168429, 118, '2014-02-01 01:01:59.000000', 'temperatura', 1042.0000, 'ºC'),
	(168430, 118, '2014-02-01 01:02:00.000000', 'temperatura', 595.0000, 'ºC'),
	(168431, 118, '2014-02-01 01:02:01.000000', 'temperatura', 1050.0000, 'ºC'),
	(168432, 118, '2014-02-01 01:02:02.000000', 'temperatura', 1068.0000, 'ºC'),
	(168433, 118, '2014-02-01 01:02:03.000000', 'temperatura', 988.0000, 'ºC'),
	(168434, 118, '2014-02-01 01:02:04.000000', 'temperatura', 536.0000, 'ºC'),
	(168435, 118, '2014-02-01 01:02:05.000000', 'temperatura', 919.0000, 'ºC'),
	(168436, 118, '2014-02-01 01:02:06.000000', 'temperatura', 586.0000, 'ºC'),
	(168437, 118, '2014-02-01 01:02:07.000000', 'temperatura', 173.0000, 'ºC'),
	(168438, 118, '2014-02-01 01:02:08.000000', 'temperatura', 309.0000, 'ºC'),
	(168439, 118, '2014-02-01 01:02:09.000000', 'temperatura', 1024.0000, 'ºC'),
	(168440, 118, '2014-02-01 01:02:10.000000', 'temperatura', 595.0000, 'ºC'),
	(168441, 118, '2014-02-01 01:02:11.000000', 'temperatura', 1102.0000, 'ºC'),
	(168442, 118, '2014-02-01 01:02:12.000000', 'temperatura', 129.0000, 'ºC'),
	(168443, 118, '2014-02-01 01:02:13.000000', 'temperatura', 936.0000, 'ºC'),
	(168444, 118, '2014-02-01 01:02:14.000000', 'temperatura', 694.0000, 'ºC'),
	(168445, 118, '2014-02-01 01:02:15.000000', 'temperatura', 664.0000, 'ºC'),
	(168446, 118, '2014-02-01 01:02:16.000000', 'temperatura', 37.0000, 'ºC'),
	(168447, 118, '2014-02-01 01:02:17.000000', 'temperatura', 592.0000, 'ºC'),
	(168448, 118, '2014-02-01 01:02:18.000000', 'temperatura', 451.0000, 'ºC'),
	(168449, 118, '2014-02-01 01:02:19.000000', 'temperatura', 480.0000, 'ºC'),
	(168450, 118, '2014-02-01 01:02:20.000000', 'temperatura', 1049.0000, 'ºC'),
	(168451, 118, '2014-02-01 01:02:21.000000', 'temperatura', 204.0000, 'ºC'),
	(168452, 118, '2014-02-01 01:02:22.000000', 'temperatura', 273.0000, 'ºC'),
	(168453, 118, '2014-02-01 01:02:23.000000', 'temperatura', 754.0000, 'ºC'),
	(168454, 118, '2014-02-01 01:02:24.000000', 'temperatura', 551.0000, 'ºC'),
	(168455, 118, '2014-02-01 01:02:25.000000', 'temperatura', 493.0000, 'ºC'),
	(168456, 118, '2014-02-01 01:02:26.000000', 'temperatura', 812.0000, 'ºC'),
	(168457, 118, '2014-02-01 01:02:27.000000', 'temperatura', 181.0000, 'ºC'),
	(168458, 118, '2014-02-01 01:02:28.000000', 'temperatura', 869.0000, 'ºC'),
	(168459, 118, '2014-02-01 01:02:29.000000', 'temperatura', 202.0000, 'ºC'),
	(168460, 118, '2014-02-01 01:02:30.000000', 'temperatura', 805.0000, 'ºC'),
	(168461, 118, '2014-02-01 01:02:31.000000', 'temperatura', 1018.0000, 'ºC'),
	(168462, 118, '2014-02-01 01:02:32.000000', 'temperatura', 278.0000, 'ºC'),
	(168463, 118, '2014-02-01 01:02:33.000000', 'temperatura', 736.0000, 'ºC'),
	(168464, 118, '2014-02-01 01:02:34.000000', 'temperatura', 448.0000, 'ºC'),
	(168465, 118, '2014-02-01 01:02:35.000000', 'temperatura', 32.0000, 'ºC'),
	(168466, 118, '2014-02-01 01:02:36.000000', 'temperatura', 15.0000, 'ºC'),
	(168467, 118, '2014-02-01 01:02:37.000000', 'temperatura', 1180.0000, 'ºC'),
	(168468, 118, '2014-02-01 01:02:38.000000', 'temperatura', 1058.0000, 'ºC'),
	(168469, 118, '2014-02-01 01:02:39.000000', 'temperatura', 547.0000, 'ºC'),
	(168470, 118, '2014-02-01 01:02:40.000000', 'temperatura', 764.0000, 'ºC'),
	(168471, 118, '2014-02-01 01:02:41.000000', 'temperatura', 979.0000, 'ºC'),
	(168472, 118, '2014-02-01 01:02:42.000000', 'temperatura', 203.0000, 'ºC'),
	(168473, 118, '2014-02-01 01:02:43.000000', 'temperatura', 477.0000, 'ºC'),
	(168474, 118, '2014-02-01 01:02:44.000000', 'temperatura', 577.0000, 'ºC'),
	(168475, 118, '2014-02-01 01:02:45.000000', 'temperatura', 254.0000, 'ºC'),
	(168476, 118, '2014-02-01 01:02:46.000000', 'temperatura', 741.0000, 'ºC'),
	(168477, 118, '2014-02-01 01:02:47.000000', 'temperatura', 544.0000, 'ºC'),
	(168478, 118, '2014-02-01 01:02:48.000000', 'temperatura', 497.0000, 'ºC'),
	(168479, 118, '2014-02-01 01:02:49.000000', 'temperatura', 854.0000, 'ºC'),
	(168480, 118, '2014-02-01 01:02:50.000000', 'temperatura', 380.0000, 'ºC'),
	(168481, 118, '2014-02-01 01:02:51.000000', 'temperatura', 539.0000, 'ºC'),
	(168482, 118, '2014-02-01 01:02:52.000000', 'temperatura', 355.0000, 'ºC'),
	(168483, 118, '2014-02-01 01:02:53.000000', 'temperatura', 158.0000, 'ºC'),
	(168484, 118, '2014-02-01 01:02:54.000000', 'temperatura', 924.0000, 'ºC'),
	(168485, 118, '2014-02-01 01:02:55.000000', 'temperatura', 549.0000, 'ºC'),
	(168486, 118, '2014-02-01 01:02:56.000000', 'temperatura', 1171.0000, 'ºC'),
	(168487, 118, '2014-02-01 01:02:57.000000', 'temperatura', 612.0000, 'ºC'),
	(168488, 118, '2014-02-01 01:02:58.000000', 'temperatura', 744.0000, 'ºC'),
	(168489, 118, '2014-02-01 01:02:59.000000', 'temperatura', 686.0000, 'ºC'),
	(168490, 118, '2014-02-01 01:03:00.000000', 'temperatura', 0.0000, 'ºC'),
	(168491, 118, '2014-02-01 01:03:01.000000', 'temperatura', 340.0000, 'ºC'),
	(168492, 118, '2014-02-01 01:03:02.000000', 'temperatura', 499.0000, 'ºC'),
	(168493, 118, '2014-02-01 01:03:03.000000', 'temperatura', 278.0000, 'ºC'),
	(168494, 118, '2014-02-01 01:03:04.000000', 'temperatura', 1095.0000, 'ºC'),
	(168495, 118, '2014-02-01 01:03:05.000000', 'temperatura', 1040.0000, 'ºC'),
	(168496, 118, '2014-02-01 01:03:06.000000', 'temperatura', 716.0000, 'ºC'),
	(168497, 118, '2014-02-01 01:03:07.000000', 'temperatura', 461.0000, 'ºC'),
	(168498, 118, '2014-02-01 01:03:08.000000', 'temperatura', 159.0000, 'ºC'),
	(168499, 118, '2014-02-01 01:03:09.000000', 'temperatura', 610.0000, 'ºC'),
	(168500, 118, '2014-02-01 01:03:10.000000', 'temperatura', 172.0000, 'ºC'),
	(168501, 118, '2014-02-01 01:03:11.000000', 'temperatura', 234.0000, 'ºC'),
	(168502, 118, '2014-02-01 01:03:12.000000', 'temperatura', 651.0000, 'ºC'),
	(168503, 118, '2014-02-01 01:03:13.000000', 'temperatura', 157.0000, 'ºC'),
	(168504, 118, '2014-02-01 01:03:14.000000', 'temperatura', 31.0000, 'ºC'),
	(168505, 118, '2014-02-01 01:03:15.000000', 'temperatura', 886.0000, 'ºC'),
	(168506, 118, '2014-02-01 01:03:16.000000', 'temperatura', 736.0000, 'ºC'),
	(168507, 118, '2014-02-01 01:03:17.000000', 'temperatura', 1022.0000, 'ºC'),
	(168508, 118, '2014-02-01 01:03:18.000000', 'temperatura', 504.0000, 'ºC'),
	(168509, 118, '2014-02-01 01:03:19.000000', 'temperatura', 655.0000, 'ºC'),
	(168510, 118, '2014-02-01 01:03:20.000000', 'temperatura', 561.0000, 'ºC'),
	(168511, 118, '2014-02-01 01:03:21.000000', 'temperatura', 842.0000, 'ºC'),
	(168512, 118, '2014-02-01 01:03:22.000000', 'temperatura', 128.0000, 'ºC'),
	(168513, 118, '2014-02-01 01:03:23.000000', 'temperatura', 516.0000, 'ºC'),
	(168514, 118, '2014-02-01 01:03:24.000000', 'temperatura', 995.0000, 'ºC'),
	(168515, 118, '2014-02-01 01:03:25.000000', 'temperatura', 1028.0000, 'ºC'),
	(168516, 118, '2014-02-01 01:03:26.000000', 'temperatura', 953.0000, 'ºC'),
	(168517, 118, '2014-02-01 01:03:27.000000', 'temperatura', 485.0000, 'ºC'),
	(168518, 118, '2014-02-01 01:03:28.000000', 'temperatura', 766.0000, 'ºC'),
	(168519, 118, '2014-02-01 01:03:29.000000', 'temperatura', 1173.0000, 'ºC'),
	(168520, 118, '2014-02-01 01:03:30.000000', 'temperatura', 1168.0000, 'ºC'),
	(168521, 118, '2014-02-01 01:03:31.000000', 'temperatura', 1124.0000, 'ºC'),
	(168522, 118, '2014-02-01 01:03:32.000000', 'temperatura', 916.0000, 'ºC'),
	(168523, 118, '2014-02-01 01:03:33.000000', 'temperatura', 6.0000, 'ºC'),
	(168524, 118, '2014-02-01 01:03:34.000000', 'temperatura', 885.0000, 'ºC'),
	(168525, 118, '2014-02-01 01:03:35.000000', 'temperatura', 807.0000, 'ºC'),
	(168526, 118, '2014-02-01 01:03:36.000000', 'temperatura', 181.0000, 'ºC'),
	(168527, 118, '2014-02-01 01:03:37.000000', 'temperatura', 885.0000, 'ºC'),
	(168528, 118, '2014-02-01 01:03:38.000000', 'temperatura', 284.0000, 'ºC'),
	(168529, 118, '2014-02-01 01:03:39.000000', 'temperatura', 1163.0000, 'ºC'),
	(168530, 118, '2014-02-01 01:03:40.000000', 'temperatura', 164.0000, 'ºC'),
	(168531, 118, '2014-02-01 01:03:41.000000', 'temperatura', 930.0000, 'ºC'),
	(168532, 118, '2014-02-01 01:03:42.000000', 'temperatura', 560.0000, 'ºC'),
	(168533, 118, '2014-02-01 01:03:43.000000', 'temperatura', 8.0000, 'ºC'),
	(168534, 118, '2014-02-01 01:03:44.000000', 'temperatura', 763.0000, 'ºC'),
	(168535, 118, '2014-02-01 01:03:45.000000', 'temperatura', 191.0000, 'ºC'),
	(168536, 118, '2014-02-01 01:03:46.000000', 'temperatura', 1066.0000, 'ºC'),
	(168537, 118, '2014-02-01 01:03:47.000000', 'temperatura', 1156.0000, 'ºC'),
	(168538, 118, '2014-02-01 01:03:48.000000', 'temperatura', 182.0000, 'ºC'),
	(168539, 118, '2014-02-01 01:03:49.000000', 'temperatura', 1045.0000, 'ºC'),
	(168540, 118, '2014-02-01 01:03:50.000000', 'temperatura', 1080.0000, 'ºC'),
	(168541, 118, '2014-02-01 01:03:51.000000', 'temperatura', 1064.0000, 'ºC'),
	(168542, 118, '2014-02-01 01:03:52.000000', 'temperatura', 883.0000, 'ºC'),
	(168543, 118, '2014-02-01 01:03:53.000000', 'temperatura', 22.0000, 'ºC'),
	(168544, 118, '2014-02-01 01:03:54.000000', 'temperatura', 1061.0000, 'ºC'),
	(168545, 118, '2014-02-01 01:03:55.000000', 'temperatura', 440.0000, 'ºC'),
	(168546, 118, '2014-02-01 01:03:56.000000', 'temperatura', 219.0000, 'ºC'),
	(168547, 118, '2014-02-01 01:03:57.000000', 'temperatura', 975.0000, 'ºC'),
	(168548, 118, '2014-02-01 01:03:58.000000', 'temperatura', 618.0000, 'ºC'),
	(168549, 118, '2014-02-01 01:03:59.000000', 'temperatura', 166.0000, 'ºC'),
	(168550, 118, '2014-02-01 01:04:00.000000', 'temperatura', 176.0000, 'ºC'),
	(168551, 118, '2014-02-01 01:04:01.000000', 'temperatura', 383.0000, 'ºC'),
	(168552, 118, '2014-02-01 01:04:02.000000', 'temperatura', 188.0000, 'ºC'),
	(168553, 118, '2014-02-01 01:04:03.000000', 'temperatura', 991.0000, 'ºC'),
	(168554, 118, '2014-02-01 01:04:04.000000', 'temperatura', 792.0000, 'ºC'),
	(168555, 118, '2014-02-01 01:04:05.000000', 'temperatura', 988.0000, 'ºC'),
	(168556, 118, '2014-02-01 01:04:06.000000', 'temperatura', 163.0000, 'ºC'),
	(168557, 118, '2014-02-01 01:04:07.000000', 'temperatura', 253.0000, 'ºC'),
	(168558, 118, '2014-02-01 01:04:08.000000', 'temperatura', 775.0000, 'ºC'),
	(168559, 118, '2014-02-01 01:04:09.000000', 'temperatura', 716.0000, 'ºC'),
	(168560, 118, '2014-02-01 01:04:10.000000', 'temperatura', 57.0000, 'ºC'),
	(168561, 118, '2014-02-01 01:04:11.000000', 'temperatura', 535.0000, 'ºC'),
	(168562, 118, '2014-02-01 01:04:12.000000', 'temperatura', 108.0000, 'ºC'),
	(168563, 118, '2014-02-01 01:04:13.000000', 'temperatura', 132.0000, 'ºC'),
	(168564, 118, '2014-02-01 01:04:14.000000', 'temperatura', 340.0000, 'ºC'),
	(168565, 118, '2014-02-01 01:04:15.000000', 'temperatura', 103.0000, 'ºC'),
	(168566, 118, '2014-02-01 01:04:16.000000', 'temperatura', 694.0000, 'ºC'),
	(168567, 118, '2014-02-01 01:04:17.000000', 'temperatura', 762.0000, 'ºC'),
	(168568, 118, '2014-02-01 01:04:18.000000', 'temperatura', 529.0000, 'ºC'),
	(168569, 118, '2014-02-01 01:04:19.000000', 'temperatura', 358.0000, 'ºC'),
	(168570, 118, '2014-02-01 01:04:20.000000', 'temperatura', 205.0000, 'ºC'),
	(168571, 118, '2014-02-01 01:04:21.000000', 'temperatura', 1152.0000, 'ºC'),
	(168572, 118, '2014-02-01 01:04:22.000000', 'temperatura', 344.0000, 'ºC'),
	(168573, 118, '2014-02-01 01:04:23.000000', 'temperatura', 665.0000, 'ºC'),
	(168574, 118, '2014-02-01 01:04:24.000000', 'temperatura', 1094.0000, 'ºC'),
	(168575, 118, '2014-02-01 01:04:25.000000', 'temperatura', 1075.0000, 'ºC'),
	(168576, 118, '2014-02-01 01:04:26.000000', 'temperatura', 892.0000, 'ºC'),
	(168577, 118, '2014-02-01 01:04:27.000000', 'temperatura', 37.0000, 'ºC'),
	(168578, 118, '2014-02-01 01:04:28.000000', 'temperatura', 1110.0000, 'ºC'),
	(168579, 118, '2014-02-01 01:04:29.000000', 'temperatura', 638.0000, 'ºC'),
	(168580, 118, '2014-02-01 01:04:30.000000', 'temperatura', 1063.0000, 'ºC'),
	(168581, 118, '2014-02-01 01:04:31.000000', 'temperatura', 1000.0000, 'ºC'),
	(168582, 118, '2014-02-01 01:04:32.000000', 'temperatura', 613.0000, 'ºC'),
	(168583, 118, '2014-02-01 01:04:33.000000', 'temperatura', 65.0000, 'ºC'),
	(168584, 118, '2014-02-01 01:04:34.000000', 'temperatura', 888.0000, 'ºC'),
	(168585, 118, '2014-02-01 01:04:35.000000', 'temperatura', 645.0000, 'ºC'),
	(168586, 118, '2014-02-01 01:04:36.000000', 'temperatura', 560.0000, 'ºC'),
	(168587, 118, '2014-02-01 01:04:37.000000', 'temperatura', 865.0000, 'ºC'),
	(168588, 118, '2014-02-01 01:04:38.000000', 'temperatura', 247.0000, 'ºC'),
	(168589, 118, '2014-02-01 01:04:39.000000', 'temperatura', 1042.0000, 'ºC'),
	(168590, 118, '2014-02-01 01:04:40.000000', 'temperatura', 866.0000, 'ºC'),
	(168591, 118, '2014-02-01 01:04:41.000000', 'temperatura', 7.0000, 'ºC'),
	(168592, 118, '2014-02-01 01:04:42.000000', 'temperatura', 1038.0000, 'ºC'),
	(168593, 118, '2014-02-01 01:04:43.000000', 'temperatura', 367.0000, 'ºC'),
	(168594, 118, '2014-02-01 01:04:44.000000', 'temperatura', 1123.0000, 'ºC'),
	(168595, 118, '2014-02-01 01:04:45.000000', 'temperatura', 915.0000, 'ºC'),
	(168596, 118, '2014-02-01 01:04:46.000000', 'temperatura', 7.0000, 'ºC'),
	(168597, 118, '2014-02-01 01:04:47.000000', 'temperatura', 888.0000, 'ºC'),
	(168598, 118, '2014-02-01 01:04:48.000000', 'temperatura', 823.0000, 'ºC'),
	(168599, 118, '2014-02-01 01:04:49.000000', 'temperatura', 249.0000, 'ºC'),
	(168600, 118, '2014-02-01 01:04:50.000000', 'temperatura', 1176.0000, 'ºC'),
	(168601, 118, '2014-02-01 01:04:51.000000', 'temperatura', 334.0000, 'ºC'),
	(168602, 118, '2014-02-01 01:04:52.000000', 'temperatura', 542.0000, 'ºC'),
	(168603, 118, '2014-02-01 01:04:53.000000', 'temperatura', 509.0000, 'ºC'),
	(168604, 118, '2014-02-01 01:04:54.000000', 'temperatura', 918.0000, 'ºC'),
	(168605, 118, '2014-02-01 01:04:55.000000', 'temperatura', 663.0000, 'ºC'),
	(168606, 118, '2014-02-01 01:04:56.000000', 'temperatura', 565.0000, 'ºC'),
	(168607, 118, '2014-02-01 01:04:57.000000', 'temperatura', 833.0000, 'ºC'),
	(168608, 118, '2014-02-01 01:04:58.000000', 'temperatura', 72.0000, 'ºC'),
	(168609, 118, '2014-02-01 01:04:59.000000', 'temperatura', 260.0000, 'ºC'),
	(168610, 118, '2014-02-01 01:05:00.000000', 'temperatura', 1085.0000, 'ºC'),
	(168611, 118, '2014-02-01 01:05:01.000000', 'temperatura', 1045.0000, 'ºC'),
	(168612, 118, '2014-02-01 01:05:02.000000', 'temperatura', 771.0000, 'ºC'),
	(168613, 118, '2014-02-01 01:05:03.000000', 'temperatura', 721.0000, 'ºC'),
	(168614, 118, '2014-02-01 01:05:04.000000', 'temperatura', 93.0000, 'ºC'),
	(168615, 118, '2014-02-01 01:05:05.000000', 'temperatura', 701.0000, 'ºC'),
	(168616, 118, '2014-02-01 01:05:06.000000', 'temperatura', 828.0000, 'ºC'),
	(168617, 118, '2014-02-01 01:05:07.000000', 'temperatura', 838.0000, 'ºC'),
	(168618, 118, '2014-02-01 01:05:08.000000', 'temperatura', 505.0000, 'ºC'),
	(168619, 118, '2014-02-01 01:05:09.000000', 'temperatura', 14.0000, 'ºC'),
	(168620, 118, '2014-02-01 01:05:10.000000', 'temperatura', 952.0000, 'ºC'),
	(168621, 118, '2014-02-01 01:05:11.000000', 'temperatura', 1122.0000, 'ºC'),
	(168622, 118, '2014-02-01 01:05:12.000000', 'temperatura', 352.0000, 'ºC'),
	(168623, 118, '2014-02-01 01:05:13.000000', 'temperatura', 795.0000, 'ºC'),
	(168624, 118, '2014-02-01 01:05:14.000000', 'temperatura', 519.0000, 'ºC'),
	(168625, 118, '2014-02-01 01:05:15.000000', 'temperatura', 212.0000, 'ºC'),
	(168626, 118, '2014-02-01 01:05:16.000000', 'temperatura', 704.0000, 'ºC'),
	(168627, 118, '2014-02-01 01:05:17.000000', 'temperatura', 483.0000, 'ºC'),
	(168628, 118, '2014-02-01 01:05:18.000000', 'temperatura', 306.0000, 'ºC'),
	(168629, 118, '2014-02-01 01:05:19.000000', 'temperatura', 79.0000, 'ºC'),
	(168630, 118, '2014-02-01 01:05:20.000000', 'temperatura', 678.0000, 'ºC'),
	(168631, 118, '2014-02-01 01:05:21.000000', 'temperatura', 752.0000, 'ºC'),
	(168632, 118, '2014-02-01 01:05:22.000000', 'temperatura', 529.0000, 'ºC'),
	(168633, 118, '2014-02-01 01:05:23.000000', 'temperatura', 389.0000, 'ºC'),
	(168634, 118, '2014-02-01 01:05:24.000000', 'temperatura', 359.0000, 'ºC'),
	(168635, 118, '2014-02-01 01:05:25.000000', 'temperatura', 627.0000, 'ºC'),
	(168636, 118, '2014-02-01 01:05:26.000000', 'temperatura', 859.0000, 'ºC'),
	(168637, 118, '2014-02-01 01:05:27.000000', 'temperatura', 17.0000, 'ºC'),
	(168638, 118, '2014-02-01 01:05:28.000000', 'temperatura', 1105.0000, 'ºC'),
	(168639, 118, '2014-02-01 01:05:29.000000', 'temperatura', 677.0000, 'ºC'),
	(168640, 118, '2014-02-01 01:05:30.000000', 'temperatura', 69.0000, 'ºC'),
	(168641, 118, '2014-02-01 01:05:31.000000', 'temperatura', 714.0000, 'ºC'),
	(168642, 118, '2014-02-01 01:05:32.000000', 'temperatura', 964.0000, 'ºC'),
	(168643, 118, '2014-02-01 01:05:33.000000', 'temperatura', 277.0000, 'ºC'),
	(168644, 118, '2014-02-01 01:05:34.000000', 'temperatura', 893.0000, 'ºC'),
	(168645, 118, '2014-02-01 01:05:35.000000', 'temperatura', 34.0000, 'ºC'),
	(168646, 118, '2014-02-01 01:05:36.000000', 'temperatura', 1093.0000, 'ºC'),
	(168647, 118, '2014-02-01 01:05:37.000000', 'temperatura', 563.0000, 'ºC'),
	(168648, 118, '2014-02-01 01:05:38.000000', 'temperatura', 735.0000, 'ºC'),
	(168649, 118, '2014-02-01 01:05:39.000000', 'temperatura', 788.0000, 'ºC'),
	(168650, 118, '2014-02-01 01:05:40.000000', 'temperatura', 534.0000, 'ºC'),
	(168651, 118, '2014-02-01 01:05:41.000000', 'temperatura', 307.0000, 'ºC'),
	(168652, 118, '2014-02-01 01:05:42.000000', 'temperatura', 1132.0000, 'ºC'),
	(168653, 118, '2014-02-01 01:05:43.000000', 'temperatura', 1139.0000, 'ºC'),
	(168654, 118, '2014-02-01 01:05:44.000000', 'temperatura', 1103.0000, 'ºC'),
	(168655, 118, '2014-02-01 01:05:45.000000', 'temperatura', 895.0000, 'ºC'),
	(168656, 118, '2014-02-01 01:05:46.000000', 'temperatura', 1169.0000, 'ºC'),
	(168657, 118, '2014-02-01 01:05:47.000000', 'temperatura', 758.0000, 'ºC'),
	(168658, 118, '2014-02-01 01:05:48.000000', 'temperatura', 283.0000, 'ºC'),
	(168659, 118, '2014-02-01 01:05:49.000000', 'temperatura', 343.0000, 'ºC'),
	(168660, 118, '2014-02-01 01:05:50.000000', 'temperatura', 868.0000, 'ºC'),
	(168661, 118, '2014-02-01 01:05:51.000000', 'temperatura', 909.0000, 'ºC'),
	(168662, 118, '2014-02-01 01:05:52.000000', 'temperatura', 744.0000, 'ºC'),
	(168663, 118, '2014-02-01 01:05:53.000000', 'temperatura', 991.0000, 'ºC'),
	(168664, 118, '2014-02-01 01:05:54.000000', 'temperatura', 326.0000, 'ºC'),
	(168665, 118, '2014-02-01 01:05:55.000000', 'temperatura', 1057.0000, 'ºC'),
	(168666, 118, '2014-02-01 01:05:56.000000', 'temperatura', 706.0000, 'ºC'),
	(168667, 118, '2014-02-01 01:05:57.000000', 'temperatura', 361.0000, 'ºC'),
	(168668, 118, '2014-02-01 01:05:58.000000', 'temperatura', 889.0000, 'ºC'),
	(168669, 118, '2014-02-01 01:05:59.000000', 'temperatura', 962.0000, 'ºC'),
	(168670, 118, '2014-02-01 01:06:00.000000', 'temperatura', 941.0000, 'ºC'),
	(168671, 118, '2014-02-01 01:06:01.000000', 'temperatura', 622.0000, 'ºC'),
	(168672, 118, '2014-02-01 01:06:02.000000', 'temperatura', 288.0000, 'ºC'),
	(168673, 118, '2014-02-01 01:06:03.000000', 'temperatura', 774.0000, 'ºC'),
	(168674, 118, '2014-02-01 01:06:04.000000', 'temperatura', 605.0000, 'ºC'),
	(168675, 118, '2014-02-01 01:06:05.000000', 'temperatura', 706.0000, 'ºC'),
	(168676, 118, '2014-02-01 01:06:06.000000', 'temperatura', 514.0000, 'ºC'),
	(168677, 118, '2014-02-01 01:06:07.000000', 'temperatura', 454.0000, 'ºC'),
	(168678, 118, '2014-02-01 01:06:08.000000', 'temperatura', 729.0000, 'ºC'),
	(168679, 118, '2014-02-01 01:06:09.000000', 'temperatura', 1084.0000, 'ºC'),
	(168680, 118, '2014-02-01 01:06:10.000000', 'temperatura', 834.0000, 'ºC'),
	(168681, 118, '2014-02-01 01:06:11.000000', 'temperatura', 917.0000, 'ºC'),
	(168682, 118, '2014-02-01 01:06:12.000000', 'temperatura', 886.0000, 'ºC'),
	(168683, 118, '2014-02-01 01:06:13.000000', 'temperatura', 476.0000, 'ºC'),
	(168684, 118, '2014-02-01 01:06:14.000000', 'temperatura', 925.0000, 'ºC'),
	(168685, 118, '2014-02-01 01:06:15.000000', 'temperatura', 797.0000, 'ºC'),
	(168686, 118, '2014-02-01 01:06:16.000000', 'temperatura', 11.0000, 'ºC'),
	(168687, 118, '2014-02-01 01:06:17.000000', 'temperatura', 64.0000, 'ºC'),
	(168688, 118, '2014-02-01 01:06:18.000000', 'temperatura', 289.0000, 'ºC'),
	(168689, 118, '2014-02-01 01:06:19.000000', 'temperatura', 51.0000, 'ºC'),
	(168690, 118, '2014-02-01 01:06:20.000000', 'temperatura', 590.0000, 'ºC'),
	(168691, 118, '2014-02-01 01:06:21.000000', 'temperatura', 399.0000, 'ºC'),
	(168692, 118, '2014-02-01 01:06:22.000000', 'temperatura', 223.0000, 'ºC'),
	(168693, 118, '2014-02-01 01:06:23.000000', 'temperatura', 1120.0000, 'ºC'),
	(168694, 118, '2014-02-01 01:06:24.000000', 'temperatura', 130.0000, 'ºC'),
	(168695, 118, '2014-02-01 01:06:25.000000', 'temperatura', 893.0000, 'ºC'),
	(168696, 118, '2014-02-01 01:06:26.000000', 'temperatura', 473.0000, 'ºC'),
	(168697, 118, '2014-02-01 01:06:27.000000', 'temperatura', 888.0000, 'ºC'),
	(168698, 118, '2014-02-01 01:06:28.000000', 'temperatura', 621.0000, 'ºC'),
	(168699, 118, '2014-02-01 01:06:29.000000', 'temperatura', 440.0000, 'ºC'),
	(168700, 118, '2014-02-01 01:06:30.000000', 'temperatura', 337.0000, 'ºC'),
	(168701, 118, '2014-02-01 01:06:31.000000', 'temperatura', 367.0000, 'ºC'),
	(168702, 118, '2014-02-01 01:06:32.000000', 'temperatura', 824.0000, 'ºC'),
	(168703, 118, '2014-02-01 01:06:33.000000', 'temperatura', 618.0000, 'ºC'),
	(168704, 118, '2014-02-01 01:06:34.000000', 'temperatura', 621.0000, 'ºC'),
	(168705, 118, '2014-02-01 01:06:35.000000', 'temperatura', 49.0000, 'ºC'),
	(168706, 118, '2014-02-01 01:06:36.000000', 'temperatura', 782.0000, 'ºC'),
	(168707, 118, '2014-02-01 01:06:37.000000', 'temperatura', 165.0000, 'ºC'),
	(168708, 118, '2014-02-01 01:06:38.000000', 'temperatura', 879.0000, 'ºC'),
	(168709, 118, '2014-02-01 01:06:39.000000', 'temperatura', 302.0000, 'ºC'),
	(168710, 118, '2014-02-01 01:06:40.000000', 'temperatura', 72.0000, 'ºC'),
	(168711, 118, '2014-02-01 01:06:41.000000', 'temperatura', 653.0000, 'ºC'),
	(168712, 118, '2014-02-01 01:06:42.000000', 'temperatura', 651.0000, 'ºC'),
	(168713, 118, '2014-02-01 01:06:43.000000', 'temperatura', 97.0000, 'ºC'),
	(168714, 118, '2014-02-01 01:06:44.000000', 'temperatura', 933.0000, 'ºC'),
	(168715, 118, '2014-02-01 01:06:45.000000', 'temperatura', 773.0000, 'ºC'),
	(168716, 118, '2014-02-01 01:06:46.000000', 'temperatura', 1067.0000, 'ºC'),
	(168717, 118, '2014-02-01 01:06:47.000000', 'temperatura', 617.0000, 'ºC'),
	(168718, 118, '2014-02-01 01:06:48.000000', 'temperatura', 1083.0000, 'ºC'),
	(168719, 118, '2014-02-01 01:06:49.000000', 'temperatura', 1167.0000, 'ºC'),
	(168720, 118, '2014-02-01 01:06:50.000000', 'temperatura', 187.0000, 'ºC'),
	(168721, 118, '2014-02-01 01:06:51.000000', 'temperatura', 1035.0000, 'ºC'),
	(168722, 118, '2014-02-01 01:06:52.000000', 'temperatura', 1011.0000, 'ºC'),
	(168723, 118, '2014-02-01 01:06:53.000000', 'temperatura', 753.0000, 'ºC'),
	(168724, 118, '2014-02-01 01:06:54.000000', 'temperatura', 732.0000, 'ºC'),
	(168725, 118, '2014-02-01 01:06:55.000000', 'temperatura', 203.0000, 'ºC'),
	(168726, 118, '2014-02-01 01:06:56.000000', 'temperatura', 20.0000, 'ºC'),
	(168727, 118, '2014-02-01 01:06:57.000000', 'temperatura', 691.0000, 'ºC'),
	(168728, 118, '2014-02-01 01:06:58.000000', 'temperatura', 993.0000, 'ºC'),
	(168729, 118, '2014-02-01 01:06:59.000000', 'temperatura', 495.0000, 'ºC'),
	(168730, 118, '2014-02-01 01:07:00.000000', 'temperatura', 695.0000, 'ºC'),
	(168731, 118, '2014-02-01 01:07:01.000000', 'temperatura', 790.0000, 'ºC'),
	(168732, 118, '2014-02-01 01:07:02.000000', 'temperatura', 667.0000, 'ºC'),
	(168733, 118, '2014-02-01 01:07:03.000000', 'temperatura', 966.0000, 'ºC'),
	(168734, 118, '2014-02-01 01:07:04.000000', 'temperatura', 430.0000, 'ºC'),
	(168735, 118, '2014-02-01 01:07:05.000000', 'temperatura', 453.0000, 'ºC'),
	(168736, 118, '2014-02-01 01:07:06.000000', 'temperatura', 975.0000, 'ºC'),
	(168737, 118, '2014-02-01 01:07:07.000000', 'temperatura', 1116.0000, 'ºC'),
	(168738, 118, '2014-02-01 01:07:08.000000', 'temperatura', 254.0000, 'ºC'),
	(168739, 118, '2014-02-01 01:07:09.000000', 'temperatura', 324.0000, 'ºC'),
	(168740, 118, '2014-02-01 01:07:10.000000', 'temperatura', 857.0000, 'ºC'),
	(168741, 118, '2014-02-01 01:07:11.000000', 'temperatura', 916.0000, 'ºC'),
	(168742, 118, '2014-02-01 01:07:12.000000', 'temperatura', 808.0000, 'ºC'),
	(168743, 118, '2014-02-01 01:07:13.000000', 'temperatura', 91.0000, 'ºC'),
	(168744, 118, '2014-02-01 01:07:14.000000', 'temperatura', 433.0000, 'ºC'),
	(168745, 118, '2014-02-01 01:07:15.000000', 'temperatura', 693.0000, 'ºC'),
	(168746, 118, '2014-02-01 01:07:16.000000', 'temperatura', 967.0000, 'ºC'),
	(168747, 118, '2014-02-01 01:07:17.000000', 'temperatura', 356.0000, 'ºC'),
	(168748, 118, '2014-02-01 01:07:18.000000', 'temperatura', 78.0000, 'ºC'),
	(168749, 118, '2014-02-01 01:07:19.000000', 'temperatura', 522.0000, 'ºC'),
	(168750, 118, '2014-02-01 01:07:20.000000', 'temperatura', 1176.0000, 'ºC'),
	(168751, 118, '2014-02-01 01:07:21.000000', 'temperatura', 714.0000, 'ºC'),
	(168752, 118, '2014-02-01 01:07:22.000000', 'temperatura', 43.0000, 'ºC'),
	(168753, 118, '2014-02-01 01:07:23.000000', 'temperatura', 474.0000, 'ºC'),
	(168754, 118, '2014-02-01 01:07:24.000000', 'temperatura', 1043.0000, 'ºC'),
	(168755, 118, '2014-02-01 01:07:25.000000', 'temperatura', 194.0000, 'ºC'),
	(168756, 118, '2014-02-01 01:07:26.000000', 'temperatura', 240.0000, 'ºC'),
	(168757, 118, '2014-02-01 01:07:27.000000', 'temperatura', 617.0000, 'ºC'),
	(168758, 118, '2014-02-01 01:07:28.000000', 'temperatura', 1166.0000, 'ºC'),
	(168759, 118, '2014-02-01 01:07:29.000000', 'temperatura', 382.0000, 'ºC'),
	(168760, 118, '2014-02-01 01:07:30.000000', 'temperatura', 809.0000, 'ºC'),
	(168761, 118, '2014-02-01 01:07:31.000000', 'temperatura', 502.0000, 'ºC'),
	(168762, 118, '2014-02-01 01:07:32.000000', 'temperatura', 85.0000, 'ºC'),
	(168763, 118, '2014-02-01 01:07:33.000000', 'temperatura', 116.0000, 'ºC'),
	(168764, 118, '2014-02-01 01:07:34.000000', 'temperatura', 327.0000, 'ºC'),
	(168765, 118, '2014-02-01 01:07:35.000000', 'temperatura', 89.0000, 'ºC'),
	(168766, 118, '2014-02-01 01:07:36.000000', 'temperatura', 663.0000, 'ºC'),
	(168767, 118, '2014-02-01 01:07:37.000000', 'temperatura', 650.0000, 'ºC'),
	(168768, 118, '2014-02-01 01:07:38.000000', 'temperatura', 60.0000, 'ºC'),
	(168769, 118, '2014-02-01 01:07:39.000000', 'temperatura', 751.0000, 'ºC'),
	(168770, 118, '2014-02-01 01:07:40.000000', 'temperatura', 1174.0000, 'ºC'),
	(168771, 118, '2014-02-01 01:07:41.000000', 'temperatura', 20.0000, 'ºC'),
	(168772, 118, '2014-02-01 01:07:42.000000', 'temperatura', 180.0000, 'ºC'),
	(168773, 118, '2014-02-01 01:07:43.000000', 'temperatura', 837.0000, 'ºC'),
	(168774, 118, '2014-02-01 01:07:44.000000', 'temperatura', 45.0000, 'ºC'),
	(168775, 118, '2014-02-01 01:07:45.000000', 'temperatura', 118.0000, 'ºC'),
	(168776, 118, '2014-02-01 01:07:46.000000', 'temperatura', 453.0000, 'ºC'),
	(168777, 118, '2014-02-01 01:07:47.000000', 'temperatura', 710.0000, 'ºC'),
	(168778, 118, '2014-02-01 01:07:48.000000', 'temperatura', 993.0000, 'ºC'),
	(168779, 118, '2014-02-01 01:07:49.000000', 'temperatura', 436.0000, 'ºC'),
	(168780, 118, '2014-02-01 01:07:50.000000', 'temperatura', 402.0000, 'ºC'),
	(168781, 118, '2014-02-01 01:07:51.000000', 'temperatura', 703.0000, 'ºC'),
	(168782, 118, '2014-02-01 01:07:52.000000', 'temperatura', 1108.0000, 'ºC'),
	(168783, 118, '2014-02-01 01:07:53.000000', 'temperatura', 1032.0000, 'ºC'),
	(168784, 118, '2014-02-01 01:07:54.000000', 'temperatura', 635.0000, 'ºC'),
	(168785, 118, '2014-02-01 01:07:55.000000', 'temperatura', 82.0000, 'ºC'),
	(168786, 118, '2014-02-01 01:07:56.000000', 'temperatura', 904.0000, 'ºC'),
	(168787, 118, '2014-02-01 01:07:57.000000', 'temperatura', 676.0000, 'ºC'),
	(168788, 118, '2014-02-01 01:07:58.000000', 'temperatura', 669.0000, 'ºC'),
	(168789, 118, '2014-02-01 01:07:59.000000', 'temperatura', 118.0000, 'ºC'),
	(168790, 118, '2014-02-01 01:08:00.000000', 'temperatura', 982.0000, 'ºC'),
	(168791, 118, '2014-02-01 01:08:01.000000', 'temperatura', 958.0000, 'ºC'),
	(168792, 118, '2014-02-01 01:08:02.000000', 'temperatura', 644.0000, 'ºC'),
	(168793, 118, '2014-02-01 01:08:03.000000', 'temperatura', 347.0000, 'ºC'),
	(168794, 118, '2014-02-01 01:08:04.000000', 'temperatura', 1001.0000, 'ºC'),
	(168795, 118, '2014-02-01 01:08:05.000000', 'temperatura', 367.0000, 'ºC'),
	(168796, 118, '2014-02-01 01:08:06.000000', 'temperatura', 31.0000, 'ºC'),
	(168797, 118, '2014-02-01 01:08:07.000000', 'temperatura', 254.0000, 'ºC'),
	(168798, 118, '2014-02-01 01:08:08.000000', 'temperatura', 1178.0000, 'ºC'),
	(168799, 118, '2014-02-01 01:08:09.000000', 'temperatura', 328.0000, 'ºC'),
	(168800, 118, '2014-02-01 01:08:10.000000', 'temperatura', 507.0000, 'ºC'),
	(168801, 118, '2014-02-01 01:08:11.000000', 'temperatura', 353.0000, 'ºC'),
	(168802, 118, '2014-02-01 01:08:12.000000', 'temperatura', 243.0000, 'ºC'),
	(168803, 118, '2014-02-01 01:08:13.000000', 'temperatura', 157.0000, 'ºC'),
	(168804, 118, '2014-02-01 01:08:14.000000', 'temperatura', 55.0000, 'ºC'),
	(168805, 118, '2014-02-01 01:08:15.000000', 'temperatura', 1007.0000, 'ºC'),
	(168806, 118, '2014-02-01 01:08:16.000000', 'temperatura', 69.0000, 'ºC'),
	(168807, 118, '2014-02-01 01:08:17.000000', 'temperatura', 923.0000, 'ºC'),
	(168808, 118, '2014-02-01 01:08:18.000000', 'temperatura', 812.0000, 'ºC'),
	(168809, 118, '2014-02-01 01:08:19.000000', 'temperatura', 89.0000, 'ºC'),
	(168810, 118, '2014-02-01 01:08:20.000000', 'temperatura', 410.0000, 'ºC'),
	(168811, 118, '2014-02-01 01:08:21.000000', 'temperatura', 582.0000, 'ºC'),
	(168812, 118, '2014-02-01 01:08:22.000000', 'temperatura', 483.0000, 'ºC'),
	(168813, 118, '2014-02-01 01:08:23.000000', 'temperatura', 670.0000, 'ºC'),
	(168814, 118, '2014-02-01 01:08:24.000000', 'temperatura', 702.0000, 'ºC'),
	(168815, 118, '2014-02-01 01:08:25.000000', 'temperatura', 301.0000, 'ºC'),
	(168816, 118, '2014-02-01 01:08:26.000000', 'temperatura', 600.0000, 'ºC'),
	(168817, 118, '2014-02-01 01:08:27.000000', 'temperatura', 896.0000, 'ºC'),
	(168818, 118, '2014-02-01 01:08:28.000000', 'temperatura', 281.0000, 'ºC'),
	(168819, 118, '2014-02-01 01:08:29.000000', 'temperatura', 1118.0000, 'ºC'),
	(168820, 118, '2014-02-01 01:08:30.000000', 'temperatura', 1148.0000, 'ºC'),
	(168821, 118, '2014-02-01 01:08:31.000000', 'temperatura', 1187.0000, 'ºC'),
	(168822, 118, '2014-02-01 01:08:32.000000', 'temperatura', 91.0000, 'ºC'),
	(168823, 118, '2014-02-01 01:08:33.000000', 'temperatura', 493.0000, 'ºC'),
	(168824, 118, '2014-02-01 01:08:34.000000', 'temperatura', 992.0000, 'ºC'),
	(168825, 118, '2014-02-01 01:08:35.000000', 'temperatura', 1082.0000, 'ºC'),
	(168826, 118, '2014-02-01 01:08:36.000000', 'temperatura', 36.0000, 'ºC'),
	(168827, 118, '2014-02-01 01:08:37.000000', 'temperatura', 532.0000, 'ºC'),
	(168828, 118, '2014-02-01 01:08:38.000000', 'temperatura', 154.0000, 'ºC'),
	(168829, 118, '2014-02-01 01:08:39.000000', 'temperatura', 372.0000, 'ºC'),
	(168830, 118, '2014-02-01 01:08:40.000000', 'temperatura', 201.0000, 'ºC'),
	(168831, 118, '2014-02-01 01:08:41.000000', 'temperatura', 1090.0000, 'ºC'),
	(168832, 118, '2014-02-01 01:08:42.000000', 'temperatura', 45.0000, 'ºC'),
	(168833, 118, '2014-02-01 01:08:43.000000', 'temperatura', 556.0000, 'ºC'),
	(168834, 118, '2014-02-01 01:08:44.000000', 'temperatura', 244.0000, 'ºC'),
	(168835, 118, '2014-02-01 01:08:45.000000', 'temperatura', 754.0000, 'ºC'),
	(168836, 118, '2014-02-01 01:08:46.000000', 'temperatura', 640.0000, 'ºC'),
	(168837, 118, '2014-02-01 01:08:47.000000', 'temperatura', 936.0000, 'ºC'),
	(168838, 118, '2014-02-01 01:08:48.000000', 'temperatura', 361.0000, 'ºC'),
	(168839, 118, '2014-02-01 01:08:49.000000', 'temperatura', 196.0000, 'ºC'),
	(168840, 118, '2014-02-01 01:08:50.000000', 'temperatura', 1099.0000, 'ºC'),
	(168841, 118, '2014-02-01 01:08:51.000000', 'temperatura', 108.0000, 'ºC'),
	(168842, 118, '2014-02-01 01:08:52.000000', 'temperatura', 841.0000, 'ºC'),
	(168843, 118, '2014-02-01 01:08:53.000000', 'temperatura', 284.0000, 'ºC'),
	(168844, 118, '2014-02-01 01:08:54.000000', 'temperatura', 95.0000, 'ºC'),
	(168845, 118, '2014-02-01 01:08:55.000000', 'temperatura', 826.0000, 'ºC'),
	(168846, 118, '2014-02-01 01:08:56.000000', 'temperatura', 244.0000, 'ºC'),
	(168847, 118, '2014-02-01 01:08:57.000000', 'temperatura', 1142.0000, 'ºC'),
	(168848, 118, '2014-02-01 01:08:58.000000', 'temperatura', 177.0000, 'ºC'),
	(168849, 118, '2014-02-01 01:08:59.000000', 'temperatura', 1062.0000, 'ºC'),
	(168850, 118, '2014-02-01 01:09:00.000000', 'temperatura', 1180.0000, 'ºC'),
	(168851, 118, '2014-02-01 01:09:01.000000', 'temperatura', 316.0000, 'ºC'),
	(168852, 118, '2014-02-01 01:09:02.000000', 'temperatura', 438.0000, 'ºC'),
	(168853, 118, '2014-02-01 01:09:03.000000', 'temperatura', 43.0000, 'ºC'),
	(168854, 118, '2014-02-01 01:09:04.000000', 'temperatura', 100.0000, 'ºC'),
	(168855, 118, '2014-02-01 01:09:05.000000', 'temperatura', 373.0000, 'ºC'),
	(168856, 118, '2014-02-01 01:09:06.000000', 'temperatura', 364.0000, 'ºC'),
	(168857, 118, '2014-02-01 01:09:07.000000', 'temperatura', 704.0000, 'ºC'),
	(168858, 118, '2014-02-01 01:09:08.000000', 'temperatura', 29.0000, 'ºC'),
	(168859, 118, '2014-02-01 01:09:09.000000', 'temperatura', 432.0000, 'ºC'),
	(168860, 118, '2014-02-01 01:09:10.000000', 'temperatura', 873.0000, 'ºC'),
	(168861, 118, '2014-02-01 01:09:11.000000', 'temperatura', 671.0000, 'ºC'),
	(168862, 118, '2014-02-01 01:09:12.000000', 'temperatura', 736.0000, 'ºC'),
	(168863, 118, '2014-02-01 01:09:13.000000', 'temperatura', 466.0000, 'ºC'),
	(168864, 118, '2014-02-01 01:09:14.000000', 'temperatura', 123.0000, 'ºC'),
	(168865, 118, '2014-02-01 01:09:15.000000', 'temperatura', 420.0000, 'ºC'),
	(168866, 118, '2014-02-01 01:09:16.000000', 'temperatura', 529.0000, 'ºC'),
	(168867, 118, '2014-02-01 01:09:17.000000', 'temperatura', 186.0000, 'ºC'),
	(168868, 118, '2014-02-01 01:09:18.000000', 'temperatura', 545.0000, 'ºC'),
	(168869, 118, '2014-02-01 01:09:19.000000', 'temperatura', 967.0000, 'ºC'),
	(168870, 118, '2014-02-01 01:09:20.000000', 'temperatura', 801.0000, 'ºC'),
	(168871, 118, '2014-02-01 01:09:21.000000', 'temperatura', 1103.0000, 'ºC'),
	(168872, 118, '2014-02-01 01:09:22.000000', 'temperatura', 715.0000, 'ºC'),
	(168873, 118, '2014-02-01 01:09:23.000000', 'temperatura', 263.0000, 'ºC'),
	(168874, 118, '2014-02-01 01:09:24.000000', 'temperatura', 374.0000, 'ºC'),
	(168875, 118, '2014-02-01 01:09:25.000000', 'temperatura', 1079.0000, 'ºC'),
	(168876, 118, '2014-02-01 01:09:26.000000', 'temperatura', 676.0000, 'ºC'),
	(168877, 118, '2014-02-01 01:09:27.000000', 'temperatura', 143.0000, 'ºC'),
	(168878, 118, '2014-02-01 01:09:28.000000', 'temperatura', 1088.0000, 'ºC'),
	(168879, 118, '2014-02-01 01:09:29.000000', 'temperatura', 211.0000, 'ºC'),
	(168880, 118, '2014-02-01 01:09:30.000000', 'temperatura', 192.0000, 'ºC'),
	(168881, 118, '2014-02-01 01:09:31.000000', 'temperatura', 325.0000, 'ºC'),
	(168882, 118, '2014-02-01 01:09:32.000000', 'temperatura', 1052.0000, 'ºC'),
	(168883, 118, '2014-02-01 01:09:33.000000', 'temperatura', 685.0000, 'ºC'),
	(168884, 118, '2014-02-01 01:09:34.000000', 'temperatura', 271.0000, 'ºC'),
	(168885, 118, '2014-02-01 01:09:35.000000', 'temperatura', 499.0000, 'ºC'),
	(168886, 118, '2014-02-01 01:09:36.000000', 'temperatura', 484.0000, 'ºC'),
	(168887, 118, '2014-02-01 01:09:37.000000', 'temperatura', 922.0000, 'ºC'),
	(168888, 118, '2014-02-01 01:09:38.000000', 'temperatura', 758.0000, 'ºC'),
	(168889, 118, '2014-02-01 01:09:39.000000', 'temperatura', 1023.0000, 'ºC'),
	(168890, 118, '2014-02-01 01:09:40.000000', 'temperatura', 445.0000, 'ºC'),
	(168891, 118, '2014-02-01 01:09:41.000000', 'temperatura', 356.0000, 'ºC'),
	(168892, 118, '2014-02-01 01:09:42.000000', 'temperatura', 443.0000, 'ºC'),
	(168893, 118, '2014-02-01 01:09:43.000000', 'temperatura', 1150.0000, 'ºC'),
	(168894, 118, '2014-02-01 01:09:44.000000', 'temperatura', 823.0000, 'ºC'),
	(168895, 118, '2014-02-01 01:09:45.000000', 'temperatura', 663.0000, 'ºC'),
	(168896, 118, '2014-02-01 01:09:46.000000', 'temperatura', 847.0000, 'ºC'),
	(168897, 118, '2014-02-01 01:09:47.000000', 'temperatura', 1047.0000, 'ºC'),
	(168898, 118, '2014-02-01 01:09:48.000000', 'temperatura', 293.0000, 'ºC'),
	(168899, 118, '2014-02-01 01:09:49.000000', 'temperatura', 727.0000, 'ºC'),
	(168900, 118, '2014-02-01 01:09:50.000000', 'temperatura', 354.0000, 'ºC'),
	(168901, 118, '2014-02-01 01:09:51.000000', 'temperatura', 791.0000, 'ºC'),
	(168902, 118, '2014-02-01 01:09:52.000000', 'temperatura', 494.0000, 'ºC'),
	(168903, 118, '2014-02-01 01:09:53.000000', 'temperatura', 95.0000, 'ºC'),
	(168904, 118, '2014-02-01 01:09:54.000000', 'temperatura', 196.0000, 'ºC'),
	(168905, 118, '2014-02-01 01:09:55.000000', 'temperatura', 693.0000, 'ºC'),
	(168906, 118, '2014-02-01 01:09:56.000000', 'temperatura', 478.0000, 'ºC'),
	(168907, 118, '2014-02-01 01:09:57.000000', 'temperatura', 311.0000, 'ºC'),
	(168908, 118, '2014-02-01 01:09:58.000000', 'temperatura', 123.0000, 'ºC'),
	(168909, 118, '2014-02-01 01:09:59.000000', 'temperatura', 883.0000, 'ºC'),
	(168910, 118, '2014-02-01 01:10:00.000000', 'temperatura', 444.0000, 'ºC'),
	(168911, 118, '2014-02-01 01:10:01.000000', 'temperatura', 774.0000, 'ºC'),
	(168912, 118, '2014-02-01 01:10:02.000000', 'temperatura', 136.0000, 'ºC'),
	(168913, 118, '2014-02-01 01:10:03.000000', 'temperatura', 761.0000, 'ºC'),
	(168914, 118, '2014-02-01 01:10:04.000000', 'temperatura', 996.0000, 'ºC'),
	(168915, 118, '2014-02-01 01:10:05.000000', 'temperatura', 297.0000, 'ºC'),
	(168916, 118, '2014-02-01 01:10:06.000000', 'temperatura', 898.0000, 'ºC'),
	(168917, 118, '2014-02-01 01:10:07.000000', 'temperatura', 1.0000, 'ºC'),
	(168918, 118, '2014-02-01 01:10:08.000000', 'temperatura', 910.0000, 'ºC'),
	(168919, 118, '2014-02-01 01:10:09.000000', 'temperatura', 949.0000, 'ºC'),
	(168920, 118, '2014-02-01 01:10:10.000000', 'temperatura', 814.0000, 'ºC'),
	(168921, 118, '2014-02-01 01:10:11.000000', 'temperatura', 26.0000, 'ºC'),
	(168922, 118, '2014-02-01 01:10:12.000000', 'temperatura', 86.0000, 'ºC'),
	(168923, 118, '2014-02-01 01:10:13.000000', 'temperatura', 351.0000, 'ºC'),
	(168924, 118, '2014-02-01 01:10:14.000000', 'temperatura', 300.0000, 'ºC'),
	(168925, 118, '2014-02-01 01:10:15.000000', 'temperatura', 446.0000, 'ºC'),
	(168926, 118, '2014-02-01 01:10:16.000000', 'temperatura', 131.0000, 'ºC'),
	(168927, 118, '2014-02-01 01:10:17.000000', 'temperatura', 518.0000, 'ºC'),
	(168928, 118, '2014-02-01 01:10:18.000000', 'temperatura', 996.0000, 'ºC'),
	(168929, 118, '2014-02-01 01:10:19.000000', 'temperatura', 1025.0000, 'ºC'),
	(168930, 118, '2014-02-01 01:10:20.000000', 'temperatura', 941.0000, 'ºC'),
	(168931, 118, '2014-02-01 01:10:21.000000', 'temperatura', 429.0000, 'ºC'),
	(168932, 118, '2014-02-01 01:10:22.000000', 'temperatura', 521.0000, 'ºC'),
	(168933, 118, '2014-02-01 01:10:23.000000', 'temperatura', 120.0000, 'ºC'),
	(168934, 118, '2014-02-01 01:10:24.000000', 'temperatura', 238.0000, 'ºC'),
	(168935, 118, '2014-02-01 01:10:25.000000', 'temperatura', 830.0000, 'ºC'),
	(168936, 118, '2014-02-01 01:10:26.000000', 'temperatura', 1037.0000, 'ºC'),
	(168937, 118, '2014-02-01 01:10:27.000000', 'temperatura', 294.0000, 'ºC'),
	(168938, 118, '2014-02-01 01:10:28.000000', 'temperatura', 762.0000, 'ºC'),
	(168939, 118, '2014-02-01 01:10:29.000000', 'temperatura', 527.0000, 'ºC'),
	(168940, 118, '2014-02-01 01:10:30.000000', 'temperatura', 351.0000, 'ºC'),
	(168941, 118, '2014-02-01 01:10:31.000000', 'temperatura', 173.0000, 'ºC'),
	(168942, 118, '2014-02-01 01:10:32.000000', 'temperatura', 1015.0000, 'ºC'),
	(168943, 118, '2014-02-01 01:10:33.000000', 'temperatura', 953.0000, 'ºC'),
	(168944, 118, '2014-02-01 01:10:34.000000', 'temperatura', 524.0000, 'ºC'),
	(168945, 118, '2014-02-01 01:10:35.000000', 'temperatura', 959.0000, 'ºC'),
	(168946, 118, '2014-02-01 01:10:36.000000', 'temperatura', 826.0000, 'ºC'),
	(168947, 118, '2014-02-01 01:10:37.000000', 'temperatura', 53.0000, 'ºC'),
	(168948, 118, '2014-02-01 01:10:38.000000', 'temperatura', 186.0000, 'ºC'),
	(168949, 118, '2014-02-01 01:10:39.000000', 'temperatura', 773.0000, 'ºC'),
	(168950, 118, '2014-02-01 01:10:40.000000', 'temperatura', 905.0000, 'ºC'),
	(168951, 118, '2014-02-01 01:10:41.000000', 'temperatura', 1008.0000, 'ºC'),
	(168952, 118, '2014-02-01 01:10:42.000000', 'temperatura', 1123.0000, 'ºC'),
	(168953, 118, '2014-02-01 01:10:43.000000', 'temperatura', 195.0000, 'ºC'),
	(168954, 118, '2014-02-01 01:10:44.000000', 'temperatura', 7.0000, 'ºC'),
	(168955, 118, '2014-02-01 01:10:45.000000', 'temperatura', 648.0000, 'ºC'),
	(168956, 118, '2014-02-01 01:10:46.000000', 'temperatura', 818.0000, 'ºC'),
	(168957, 118, '2014-02-01 01:10:47.000000', 'temperatura', 950.0000, 'ºC'),
	(168958, 118, '2014-02-01 01:10:48.000000', 'temperatura', 1095.0000, 'ºC'),
	(168959, 118, '2014-02-01 01:10:49.000000', 'temperatura', 226.0000, 'ºC'),
	(168960, 118, '2014-02-01 01:10:50.000000', 'temperatura', 245.0000, 'ºC'),
	(168961, 118, '2014-02-01 01:10:51.000000', 'temperatura', 547.0000, 'ºC'),
	(168962, 118, '2014-02-01 01:10:52.000000', 'temperatura', 803.0000, 'ºC'),
	(168963, 118, '2014-02-01 01:10:53.000000', 'temperatura', 1172.0000, 'ºC'),
	(168964, 118, '2014-02-01 01:10:54.000000', 'temperatura', 1054.0000, 'ºC'),
	(168965, 118, '2014-02-01 01:10:55.000000', 'temperatura', 552.0000, 'ºC'),
	(168966, 118, '2014-02-01 01:10:56.000000', 'temperatura', 799.0000, 'ºC'),
	(168967, 118, '2014-02-01 01:10:57.000000', 'temperatura', 1138.0000, 'ºC'),
	(168968, 118, '2014-02-01 01:10:58.000000', 'temperatura', 894.0000, 'ºC'),
	(168969, 118, '2014-02-01 01:10:59.000000', 'temperatura', 1059.0000, 'ºC'),
	(168970, 118, '2014-02-01 01:11:00.000000', 'temperatura', 210.0000, 'ºC'),
	(168971, 118, '2014-02-01 01:11:01.000000', 'temperatura', 275.0000, 'ºC'),
	(168972, 118, '2014-02-01 01:11:02.000000', 'temperatura', 747.0000, 'ºC'),
	(168973, 118, '2014-02-01 01:11:03.000000', 'temperatura', 508.0000, 'ºC'),
	(168974, 118, '2014-02-01 01:11:04.000000', 'temperatura', 301.0000, 'ºC'),
	(168975, 118, '2014-02-01 01:11:05.000000', 'temperatura', 1181.0000, 'ºC'),
	(168976, 118, '2014-02-01 01:11:06.000000', 'temperatura', 202.0000, 'ºC'),
	(168977, 118, '2014-02-01 01:11:07.000000', 'temperatura', 1068.0000, 'ºC'),
	(168978, 118, '2014-02-01 01:11:08.000000', 'temperatura', 1134.0000, 'ºC'),
	(168979, 118, '2014-02-01 01:11:09.000000', 'temperatura', 67.0000, 'ºC'),
	(168980, 118, '2014-02-01 01:11:10.000000', 'temperatura', 533.0000, 'ºC'),
	(168981, 118, '2014-02-01 01:11:11.000000', 'temperatura', 63.0000, 'ºC'),
	(168982, 118, '2014-02-01 01:11:12.000000', 'temperatura', 1118.0000, 'ºC'),
	(168983, 118, '2014-02-01 01:11:13.000000', 'temperatura', 599.0000, 'ºC'),
	(168984, 118, '2014-02-01 01:11:14.000000', 'temperatura', 844.0000, 'ºC'),
	(168985, 118, '2014-02-01 01:11:15.000000', 'temperatura', 23.0000, 'ºC'),
	(168986, 118, '2014-02-01 01:11:16.000000', 'temperatura', 1185.0000, 'ºC'),
	(168987, 118, '2014-02-01 01:11:17.000000', 'temperatura', 1054.0000, 'ºC'),
	(168988, 118, '2014-02-01 01:11:18.000000', 'temperatura', 518.0000, 'ºC'),
	(168989, 118, '2014-02-01 01:11:19.000000', 'temperatura', 627.0000, 'ºC'),
	(168990, 118, '2014-02-01 01:11:20.000000', 'temperatura', 382.0000, 'ºC'),
	(168991, 118, '2014-02-01 01:11:21.000000', 'temperatura', 30.0000, 'ºC'),
	(168992, 118, '2014-02-01 01:11:22.000000', 'temperatura', 204.0000, 'ºC'),
	(168993, 118, '2014-02-01 01:11:23.000000', 'temperatura', 932.0000, 'ºC'),
	(168994, 118, '2014-02-01 01:11:24.000000', 'temperatura', 446.0000, 'ºC'),
	(168995, 118, '2014-02-01 01:11:25.000000', 'temperatura', 637.0000, 'ºC'),
	(168996, 118, '2014-02-01 01:11:26.000000', 'temperatura', 645.0000, 'ºC'),
	(168997, 118, '2014-02-01 01:11:27.000000', 'temperatura', 118.0000, 'ºC'),
	(168998, 118, '2014-02-01 01:11:28.000000', 'temperatura', 1052.0000, 'ºC'),
	(168999, 118, '2014-02-01 01:11:29.000000', 'temperatura', 107.0000, 'ºC'),
	(169000, 118, '2014-02-01 01:11:30.000000', 'temperatura', 980.0000, 'ºC'),
	(169001, 118, '2014-02-01 01:11:31.000000', 'temperatura', 978.0000, 'ºC'),
	(169002, 118, '2014-02-01 01:11:32.000000', 'temperatura', 752.0000, 'ºC'),
	(169003, 118, '2014-02-01 01:11:33.000000', 'temperatura', 827.0000, 'ºC'),
	(169004, 118, '2014-02-01 01:11:34.000000', 'temperatura', 680.0000, 'ºC'),
	(169005, 118, '2014-02-01 01:11:35.000000', 'temperatura', 919.0000, 'ºC'),
	(169006, 118, '2014-02-01 01:11:36.000000', 'temperatura', 156.0000, 'ºC'),
	(169007, 118, '2014-02-01 01:11:37.000000', 'temperatura', 425.0000, 'ºC'),
	(169008, 118, '2014-02-01 01:11:38.000000', 'temperatura', 455.0000, 'ºC'),
	(169009, 118, '2014-02-01 01:11:39.000000', 'temperatura', 1001.0000, 'ºC'),
	(169010, 118, '2014-02-01 01:11:40.000000', 'temperatura', 40.0000, 'ºC'),
	(169011, 118, '2014-02-01 01:11:41.000000', 'temperatura', 799.0000, 'ºC'),
	(169012, 118, '2014-02-01 01:11:42.000000', 'temperatura', 276.0000, 'ºC'),
	(169013, 118, '2014-02-01 01:11:43.000000', 'temperatura', 184.0000, 'ºC'),
	(169014, 118, '2014-02-01 01:11:44.000000', 'temperatura', 90.0000, 'ºC'),
	(169015, 118, '2014-02-01 01:11:45.000000', 'temperatura', 1098.0000, 'ºC'),
	(169016, 118, '2014-02-01 01:11:46.000000', 'temperatura', 421.0000, 'ºC'),
	(169017, 118, '2014-02-01 01:11:47.000000', 'temperatura', 12.0000, 'ºC'),
	(169018, 118, '2014-02-01 01:11:48.000000', 'temperatura', 0.0000, 'ºC'),
	(169019, 118, '2014-02-01 01:11:49.000000', 'temperatura', 1161.0000, 'ºC'),
	(169020, 118, '2014-02-01 01:11:50.000000', 'temperatura', 1005.0000, 'ºC'),
	(169021, 118, '2014-02-01 01:11:51.000000', 'temperatura', 343.0000, 'ºC'),
	(169022, 118, '2014-02-01 01:11:52.000000', 'temperatura', 1103.0000, 'ºC'),
	(169023, 118, '2014-02-01 01:11:53.000000', 'temperatura', 884.0000, 'ºC'),
	(169024, 118, '2014-02-01 01:11:54.000000', 'temperatura', 1112.0000, 'ºC'),
	(169025, 118, '2014-02-01 01:11:55.000000', 'temperatura', 510.0000, 'ºC'),
	(169026, 118, '2014-02-01 01:11:56.000000', 'temperatura', 413.0000, 'ºC'),
	(169027, 118, '2014-02-01 01:11:57.000000', 'temperatura', 536.0000, 'ºC'),
	(169028, 118, '2014-02-01 01:11:58.000000', 'temperatura', 242.0000, 'ºC'),
	(169029, 118, '2014-02-01 01:11:59.000000', 'temperatura', 802.0000, 'ºC'),
	(169030, 118, '2014-02-01 01:12:00.000000', 'temperatura', 883.0000, 'ºC'),
	(169031, 118, '2014-02-01 01:12:01.000000', 'temperatura', 810.0000, 'ºC'),
	(169032, 118, '2014-02-01 01:12:02.000000', 'temperatura', 203.0000, 'ºC'),
	(169033, 118, '2014-02-01 01:12:03.000000', 'temperatura', 984.0000, 'ºC'),
	(169034, 118, '2014-02-01 01:12:04.000000', 'temperatura', 712.0000, 'ºC'),
	(169035, 118, '2014-02-01 01:12:05.000000', 'temperatura', 610.0000, 'ºC'),
	(169036, 118, '2014-02-01 01:12:06.000000', 'temperatura', 915.0000, 'ºC'),
	(169037, 118, '2014-02-01 01:12:07.000000', 'temperatura', 342.0000, 'ºC'),
	(169038, 118, '2014-02-01 01:12:08.000000', 'temperatura', 169.0000, 'ºC'),
	(169039, 118, '2014-02-01 01:12:09.000000', 'temperatura', 1018.0000, 'ºC'),
	(169040, 118, '2014-02-01 01:12:10.000000', 'temperatura', 982.0000, 'ºC'),
	(169041, 118, '2014-02-01 01:12:11.000000', 'temperatura', 656.0000, 'ºC'),
	(169042, 118, '2014-02-01 01:12:12.000000', 'temperatura', 337.0000, 'ºC'),
	(169043, 118, '2014-02-01 01:12:13.000000', 'temperatura', 917.0000, 'ºC'),
	(169044, 118, '2014-02-01 01:12:14.000000', 'temperatura', 1176.0000, 'ºC'),
	(169045, 118, '2014-02-01 01:12:15.000000', 'temperatura', 726.0000, 'ºC'),
	(169046, 118, '2014-02-01 01:12:16.000000', 'temperatura', 106.0000, 'ºC'),
	(169047, 118, '2014-02-01 01:12:17.000000', 'temperatura', 751.0000, 'ºC'),
	(169048, 118, '2014-02-01 01:12:18.000000', 'temperatura', 1039.0000, 'ºC'),
	(169049, 118, '2014-02-01 01:12:19.000000', 'temperatura', 542.0000, 'ºC'),
	(169050, 118, '2014-02-01 01:12:20.000000', 'temperatura', 792.0000, 'ºC'),
	(169051, 118, '2014-02-01 01:12:21.000000', 'temperatura', 1134.0000, 'ºC'),
	(169052, 118, '2014-02-01 01:12:22.000000', 'temperatura', 894.0000, 'ºC'),
	(169053, 118, '2014-02-01 01:12:23.000000', 'temperatura', 1071.0000, 'ºC'),
	(169054, 118, '2014-02-01 01:12:24.000000', 'temperatura', 274.0000, 'ºC'),
	(169055, 118, '2014-02-01 01:12:25.000000', 'temperatura', 558.0000, 'ºC'),
	(169056, 118, '2014-02-01 01:12:26.000000', 'temperatura', 768.0000, 'ºC'),
	(169057, 118, '2014-02-01 01:12:27.000000', 'temperatura', 965.0000, 'ºC'),
	(169058, 118, '2014-02-01 01:12:28.000000', 'temperatura', 122.0000, 'ºC'),
	(169059, 118, '2014-02-01 01:12:29.000000', 'temperatura', 115.0000, 'ºC'),
	(169060, 118, '2014-02-01 01:12:30.000000', 'temperatura', 211.0000, 'ºC'),
	(169061, 118, '2014-02-01 01:12:31.000000', 'temperatura', 709.0000, 'ºC'),
	(169062, 118, '2014-02-01 01:12:32.000000', 'temperatura', 511.0000, 'ºC'),
	(169063, 118, '2014-02-01 01:12:33.000000', 'temperatura', 431.0000, 'ºC'),
	(169064, 118, '2014-02-01 01:12:34.000000', 'temperatura', 623.0000, 'ºC'),
	(169065, 118, '2014-02-01 01:12:35.000000', 'temperatura', 623.0000, 'ºC'),
	(169066, 118, '2014-02-01 01:12:36.000000', 'temperatura', 47.0000, 'ºC'),
	(169067, 118, '2014-02-01 01:12:37.000000', 'temperatura', 764.0000, 'ºC'),
	(169068, 118, '2014-02-01 01:12:38.000000', 'temperatura', 82.0000, 'ºC'),
	(169069, 118, '2014-02-01 01:12:39.000000', 'temperatura', 518.0000, 'ºC'),
	(169070, 118, '2014-02-01 01:12:40.000000', 'temperatura', 1143.0000, 'ºC'),
	(169071, 118, '2014-02-01 01:12:41.000000', 'temperatura', 560.0000, 'ºC'),
	(169072, 118, '2014-02-01 01:12:42.000000', 'temperatura', 575.0000, 'ºC'),
	(169073, 118, '2014-02-01 01:12:43.000000', 'temperatura', 1193.0000, 'ºC'),
	(169074, 118, '2014-02-01 01:12:44.000000', 'temperatura', 639.0000, 'ºC'),
	(169075, 118, '2014-02-01 01:12:45.000000', 'temperatura', 819.0000, 'ºC'),
	(169076, 118, '2014-02-01 01:12:46.000000', 'temperatura', 978.0000, 'ºC'),
	(169077, 118, '2014-02-01 01:12:47.000000', 'temperatura', 33.0000, 'ºC'),
	(169078, 118, '2014-02-01 01:12:48.000000', 'temperatura', 831.0000, 'ºC'),
	(169079, 118, '2014-02-01 01:12:49.000000', 'temperatura', 457.0000, 'ºC'),
	(169080, 118, '2014-02-01 01:12:50.000000', 'temperatura', 994.0000, 'ºC'),
	(169081, 118, '2014-02-01 01:12:51.000000', 'temperatura', 1199.0000, 'ºC'),
	(169082, 118, '2014-02-01 01:12:52.000000', 'temperatura', 612.0000, 'ºC'),
	(169083, 118, '2014-02-01 01:12:53.000000', 'temperatura', 665.0000, 'ºC'),
	(169084, 118, '2014-02-01 01:12:54.000000', 'temperatura', 290.0000, 'ºC'),
	(169085, 118, '2014-02-01 01:12:55.000000', 'temperatura', 656.0000, 'ºC'),
	(169086, 118, '2014-02-01 01:12:56.000000', 'temperatura', 8.0000, 'ºC'),
	(169087, 118, '2014-02-01 01:12:57.000000', 'temperatura', 472.0000, 'ºC'),
	(169088, 118, '2014-02-01 01:12:58.000000', 'temperatura', 1139.0000, 'ºC'),
	(169089, 118, '2014-02-01 01:12:59.000000', 'temperatura', 680.0000, 'ºC'),
	(169090, 118, '2014-02-01 01:13:00.000000', 'temperatura', 1182.0000, 'ºC'),
	(169091, 118, '2014-02-01 01:13:01.000000', 'temperatura', 269.0000, 'ºC'),
	(169092, 118, '2014-02-01 01:13:02.000000', 'temperatura', 203.0000, 'ºC'),
	(169093, 118, '2014-02-01 01:13:03.000000', 'temperatura', 206.0000, 'ºC'),
	(169094, 118, '2014-02-01 01:13:04.000000', 'temperatura', 424.0000, 'ºC'),
	(169095, 118, '2014-02-01 01:13:05.000000', 'temperatura', 300.0000, 'ºC'),
	(169096, 118, '2014-02-01 01:13:06.000000', 'temperatura', 230.0000, 'ºC'),
	(169097, 118, '2014-02-01 01:13:07.000000', 'temperatura', 248.0000, 'ºC'),
	(169098, 118, '2014-02-01 01:13:08.000000', 'temperatura', 553.0000, 'ºC'),
	(169099, 118, '2014-02-01 01:13:09.000000', 'temperatura', 819.0000, 'ºC'),
	(169100, 118, '2014-02-01 01:13:10.000000', 'temperatura', 36.0000, 'ºC'),
	(169101, 118, '2014-02-01 01:13:11.000000', 'temperatura', 126.0000, 'ºC'),
	(169102, 118, '2014-02-01 01:13:12.000000', 'temperatura', 521.0000, 'ºC'),
	(169103, 118, '2014-02-01 01:13:13.000000', 'temperatura', 1027.0000, 'ºC'),
	(169104, 118, '2014-02-01 01:13:14.000000', 'temperatura', 1171.0000, 'ºC'),
	(169105, 118, '2014-02-01 01:13:15.000000', 'temperatura', 377.0000, 'ºC'),
	(169106, 118, '2014-02-01 01:13:16.000000', 'temperatura', 771.0000, 'ºC'),
	(169107, 118, '2014-02-01 01:13:17.000000', 'temperatura', 325.0000, 'ºC'),
	(169108, 118, '2014-02-01 01:13:18.000000', 'temperatura', 514.0000, 'ºC'),
	(169109, 118, '2014-02-01 01:13:19.000000', 'temperatura', 395.0000, 'ºC'),
	(169110, 118, '2014-02-01 01:13:20.000000', 'temperatura', 435.0000, 'ºC'),
	(169111, 118, '2014-02-01 01:13:21.000000', 'temperatura', 990.0000, 'ºC'),
	(169112, 118, '2014-02-01 01:13:22.000000', 'temperatura', 44.0000, 'ºC'),
	(169113, 118, '2014-02-01 01:13:23.000000', 'temperatura', 852.0000, 'ºC'),
	(169114, 118, '2014-02-01 01:13:24.000000', 'temperatura', 530.0000, 'ºC'),
	(169115, 118, '2014-02-01 01:13:25.000000', 'temperatura', 91.0000, 'ºC'),
	(169116, 118, '2014-02-01 01:13:26.000000', 'temperatura', 68.0000, 'ºC'),
	(169117, 118, '2014-02-01 01:13:27.000000', 'temperatura', 67.0000, 'ºC'),
	(169118, 118, '2014-02-01 01:13:28.000000', 'temperatura', 133.0000, 'ºC'),
	(169119, 118, '2014-02-01 01:13:29.000000', 'temperatura', 465.0000, 'ºC'),
	(169120, 118, '2014-02-01 01:13:30.000000', 'temperatura', 724.0000, 'ºC'),
	(169121, 118, '2014-02-01 01:13:31.000000', 'temperatura', 1026.0000, 'ºC'),
	(169122, 118, '2014-02-01 01:13:32.000000', 'temperatura', 558.0000, 'ºC'),
	(169123, 118, '2014-02-01 01:13:33.000000', 'temperatura', 914.0000, 'ºC'),
	(169124, 118, '2014-02-01 01:13:34.000000', 'temperatura', 495.0000, 'ºC'),
	(169125, 118, '2014-02-01 01:13:35.000000', 'temperatura', 933.0000, 'ºC'),
	(169126, 118, '2014-02-01 01:13:36.000000', 'temperatura', 780.0000, 'ºC'),
	(169127, 118, '2014-02-01 01:13:37.000000', 'temperatura', 1102.0000, 'ºC'),
	(169128, 118, '2014-02-01 01:13:38.000000', 'temperatura', 772.0000, 'ºC'),
	(169129, 118, '2014-02-01 01:13:39.000000', 'temperatura', 552.0000, 'ºC'),
	(169130, 118, '2014-02-01 01:13:40.000000', 'temperatura', 446.0000, 'ºC'),
	(169131, 118, '2014-02-01 01:13:41.000000', 'temperatura', 573.0000, 'ºC'),
	(169132, 118, '2014-02-01 01:13:42.000000', 'temperatura', 329.0000, 'ºC'),
	(169133, 118, '2014-02-01 01:13:43.000000', 'temperatura', 1127.0000, 'ºC'),
	(169134, 118, '2014-02-01 01:13:44.000000', 'temperatura', 1047.0000, 'ºC'),
	(169135, 118, '2014-02-01 01:13:45.000000', 'temperatura', 653.0000, 'ºC'),
	(169136, 118, '2014-02-01 01:13:46.000000', 'temperatura', 127.0000, 'ºC'),
	(169137, 118, '2014-02-01 01:13:47.000000', 'temperatura', 1077.0000, 'ºC'),
	(169138, 118, '2014-02-01 01:13:48.000000', 'temperatura', 206.0000, 'ºC'),
	(169139, 118, '2014-02-01 01:13:49.000000', 'temperatura', 196.0000, 'ºC'),
	(169140, 118, '2014-02-01 01:13:50.000000', 'temperatura', 365.0000, 'ºC'),
	(169141, 118, '2014-02-01 01:13:51.000000', 'temperatura', 38.0000, 'ºC'),
	(169142, 118, '2014-02-01 01:13:52.000000', 'temperatura', 294.0000, 'ºC'),
	(169143, 118, '2014-02-01 01:13:53.000000', 'temperatura', 159.0000, 'ºC'),
	(169144, 118, '2014-02-01 01:13:54.000000', 'temperatura', 1111.0000, 'ºC'),
	(169145, 118, '2014-02-01 01:13:55.000000', 'temperatura', 279.0000, 'ºC'),
	(169146, 118, '2014-02-01 01:13:56.000000', 'temperatura', 464.0000, 'ºC'),
	(169147, 118, '2014-02-01 01:13:57.000000', 'temperatura', 283.0000, 'ºC'),
	(169148, 118, '2014-02-01 01:13:58.000000', 'temperatura', 23.0000, 'ºC'),
	(169149, 118, '2014-02-01 01:13:59.000000', 'temperatura', 466.0000, 'ºC'),
	(169150, 118, '2014-02-01 01:14:00.000000', 'temperatura', 1062.0000, 'ºC'),
	(169151, 118, '2014-02-01 01:14:01.000000', 'temperatura', 313.0000, 'ºC'),
	(169152, 118, '2014-02-01 01:14:02.000000', 'temperatura', 781.0000, 'ºC'),
	(169153, 118, '2014-02-01 01:14:03.000000', 'temperatura', 565.0000, 'ºC'),
	(169154, 118, '2014-02-01 01:14:04.000000', 'temperatura', 481.0000, 'ºC'),
	(169155, 118, '2014-02-01 01:14:05.000000', 'temperatura', 713.0000, 'ºC'),
	(169156, 118, '2014-02-01 01:14:06.000000', 'temperatura', 924.0000, 'ºC'),
	(169157, 118, '2014-02-01 01:14:07.000000', 'temperatura', 78.0000, 'ºC'),
	(169158, 118, '2014-02-01 01:14:08.000000', 'temperatura', 22.0000, 'ºC'),
	(169159, 118, '2014-02-01 01:14:09.000000', 'temperatura', 1073.0000, 'ºC'),
	(169160, 118, '2014-02-01 01:14:10.000000', 'temperatura', 503.0000, 'ºC'),
	(169161, 118, '2014-02-01 01:14:11.000000', 'temperatura', 495.0000, 'ºC'),
	(169162, 118, '2014-02-01 01:14:12.000000', 'temperatura', 965.0000, 'ºC'),
	(169163, 118, '2014-02-01 01:14:13.000000', 'temperatura', 940.0000, 'ºC'),
	(169164, 118, '2014-02-01 01:14:14.000000', 'temperatura', 607.0000, 'ºC'),
	(169165, 118, '2014-02-01 01:14:15.000000', 'temperatura', 214.0000, 'ºC'),
	(169166, 118, '2014-02-01 01:14:16.000000', 'temperatura', 451.0000, 'ºC'),
	(169167, 118, '2014-02-01 01:14:17.000000', 'temperatura', 415.0000, 'ºC'),
	(169168, 118, '2014-02-01 01:14:18.000000', 'temperatura', 722.0000, 'ºC'),
	(169169, 118, '2014-02-01 01:14:19.000000', 'temperatura', 1164.0000, 'ºC'),
	(169170, 118, '2014-02-01 01:14:20.000000', 'temperatura', 54.0000, 'ºC'),
	(169171, 118, '2014-02-01 01:14:21.000000', 'temperatura', 381.0000, 'ºC'),
	(169172, 118, '2014-02-01 01:14:22.000000', 'temperatura', 542.0000, 'ºC'),
	(169173, 118, '2014-02-01 01:14:23.000000', 'temperatura', 368.0000, 'ºC'),
	(169174, 118, '2014-02-01 01:14:24.000000', 'temperatura', 215.0000, 'ºC'),
	(169175, 118, '2014-02-01 01:14:25.000000', 'temperatura', 1171.0000, 'ºC'),
	(169176, 118, '2014-02-01 01:14:26.000000', 'temperatura', 410.0000, 'ºC'),
	(169177, 118, '2014-02-01 01:14:27.000000', 'temperatura', 939.0000, 'ºC'),
	(169178, 118, '2014-02-01 01:14:28.000000', 'temperatura', 1064.0000, 'ºC'),
	(169179, 118, '2014-02-01 01:14:29.000000', 'temperatura', 103.0000, 'ºC'),
	(169180, 118, '2014-02-01 01:14:30.000000', 'temperatura', 923.0000, 'ºC'),
	(169181, 118, '2014-02-01 01:14:31.000000', 'temperatura', 705.0000, 'ºC'),
	(169182, 118, '2014-02-01 01:14:32.000000', 'temperatura', 759.0000, 'ºC'),
	(169183, 118, '2014-02-01 01:14:33.000000', 'temperatura', 481.0000, 'ºC'),
	(169184, 118, '2014-02-01 01:14:34.000000', 'temperatura', 127.0000, 'ºC'),
	(169185, 118, '2014-02-01 01:14:35.000000', 'temperatura', 391.0000, 'ºC'),
	(169186, 118, '2014-02-01 01:14:36.000000', 'temperatura', 376.0000, 'ºC'),
	(169187, 118, '2014-02-01 01:14:37.000000', 'temperatura', 708.0000, 'ºC'),
	(169188, 118, '2014-02-01 01:14:38.000000', 'temperatura', 11.0000, 'ºC'),
	(169189, 118, '2014-02-01 01:14:39.000000', 'temperatura', 331.0000, 'ºC'),
	(169190, 118, '2014-02-01 01:14:40.000000', 'temperatura', 423.0000, 'ºC'),
	(169191, 118, '2014-02-01 01:14:41.000000', 'temperatura', 1122.0000, 'ºC'),
	(169192, 118, '2014-02-01 01:14:42.000000', 'temperatura', 740.0000, 'ºC'),
	(169193, 118, '2014-02-01 01:14:43.000000', 'temperatura', 337.0000, 'ºC'),
	(169194, 118, '2014-02-01 01:14:44.000000', 'temperatura', 666.0000, 'ºC'),
	(169195, 118, '2014-02-01 01:14:45.000000', 'temperatura', 1119.0000, 'ºC'),
	(169196, 118, '2014-02-01 01:14:46.000000', 'temperatura', 1199.0000, 'ºC'),
	(169197, 118, '2014-02-01 01:14:47.000000', 'temperatura', 238.0000, 'ºC'),
	(169198, 118, '2014-02-01 01:14:48.000000', 'temperatura', 1195.0000, 'ºC'),
	(169199, 118, '2014-02-01 01:14:49.000000', 'temperatura', 459.0000, 'ºC'),
	(169200, 118, '2014-02-01 01:14:50.000000', 'temperatura', 1113.0000, 'ºC'),
	(169201, 118, '2014-02-01 01:14:51.000000', 'temperatura', 587.0000, 'ºC'),
	(169202, 118, '2014-02-01 01:14:52.000000', 'temperatura', 797.0000, 'ºC'),
	(169203, 118, '2014-02-01 01:14:53.000000', 'temperatura', 1022.0000, 'ºC'),
	(169204, 118, '2014-02-01 01:14:54.000000', 'temperatura', 322.0000, 'ºC'),
	(169205, 118, '2014-02-01 01:14:55.000000', 'temperatura', 944.0000, 'ºC'),
	(169206, 118, '2014-02-01 01:14:56.000000', 'temperatura', 155.0000, 'ºC'),
	(169207, 118, '2014-02-01 01:14:57.000000', 'temperatura', 345.0000, 'ºC'),
	(169208, 118, '2014-02-01 01:14:58.000000', 'temperatura', 58.0000, 'ºC'),
	(169209, 118, '2014-02-01 01:14:59.000000', 'temperatura', 456.0000, 'ºC'),
	(169210, 118, '2014-02-01 01:15:00.000000', 'temperatura', 908.0000, 'ºC'),
	(169211, 118, '2014-02-01 01:15:01.000000', 'temperatura', 771.0000, 'ºC'),
	(169212, 118, '2014-02-01 01:15:02.000000', 'temperatura', 1132.0000, 'ºC'),
	(169213, 118, '2014-02-01 01:15:03.000000', 'temperatura', 947.0000, 'ºC'),
	(169214, 118, '2014-02-01 01:15:04.000000', 'temperatura', 139.0000, 'ºC'),
	(169215, 118, '2014-02-01 01:15:05.000000', 'temperatura', 257.0000, 'ºC'),
	(169216, 118, '2014-02-01 01:15:06.000000', 'temperatura', 868.0000, 'ºC'),
	(169217, 118, '2014-02-01 01:15:07.000000', 'temperatura', 1167.0000, 'ºC'),
	(169218, 118, '2014-02-01 01:15:08.000000', 'temperatura', 832.0000, 'ºC'),
	(169219, 118, '2014-02-01 01:15:09.000000', 'temperatura', 661.0000, 'ºC'),
	(169220, 118, '2014-02-01 01:15:10.000000', 'temperatura', 807.0000, 'ºC'),
	(169221, 118, '2014-02-01 01:15:11.000000', 'temperatura', 854.0000, 'ºC'),
	(169222, 118, '2014-02-01 01:15:12.000000', 'temperatura', 649.0000, 'ºC'),
	(169223, 118, '2014-02-01 01:15:13.000000', 'temperatura', 686.0000, 'ºC'),
	(169224, 118, '2014-02-01 01:15:14.000000', 'temperatura', 281.0000, 'ºC'),
	(169225, 118, '2014-02-01 01:15:15.000000', 'temperatura', 550.0000, 'ºC'),
	(169226, 118, '2014-02-01 01:15:16.000000', 'temperatura', 706.0000, 'ºC'),
	(169227, 118, '2014-02-01 01:15:17.000000', 'temperatura', 681.0000, 'ºC'),
	(169228, 118, '2014-02-01 01:15:18.000000', 'temperatura', 86.0000, 'ºC'),
	(169229, 118, '2014-02-01 01:15:19.000000', 'temperatura', 790.0000, 'ºC'),
	(169230, 118, '2014-02-01 01:15:20.000000', 'temperatura', 93.0000, 'ºC'),
	(169231, 118, '2014-02-01 01:15:21.000000', 'temperatura', 493.0000, 'ºC'),
	(169232, 118, '2014-02-01 01:15:22.000000', 'temperatura', 988.0000, 'ºC'),
	(169233, 118, '2014-02-01 01:15:23.000000', 'temperatura', 1061.0000, 'ºC'),
	(169234, 118, '2014-02-01 01:15:24.000000', 'temperatura', 1143.0000, 'ºC'),
	(169235, 118, '2014-02-01 01:15:25.000000', 'temperatura', 132.0000, 'ºC'),
	(169236, 118, '2014-02-01 01:15:26.000000', 'temperatura', 832.0000, 'ºC'),
	(169237, 118, '2014-02-01 01:15:27.000000', 'temperatura', 166.0000, 'ºC'),
	(169238, 118, '2014-02-01 01:15:28.000000', 'temperatura', 733.0000, 'ºC'),
	(169239, 118, '2014-02-01 01:15:29.000000', 'temperatura', 769.0000, 'ºC'),
	(169240, 118, '2014-02-01 01:15:30.000000', 'temperatura', 445.0000, 'ºC'),
	(169241, 118, '2014-02-01 01:15:31.000000', 'temperatura', 1117.0000, 'ºC'),
	(169242, 118, '2014-02-01 01:15:32.000000', 'temperatura', 651.0000, 'ºC'),
	(169243, 118, '2014-02-01 01:15:33.000000', 'temperatura', 1103.0000, 'ºC'),
	(169244, 118, '2014-02-01 01:15:34.000000', 'temperatura', 1165.0000, 'ºC'),
	(169245, 118, '2014-02-01 01:15:35.000000', 'temperatura', 115.0000, 'ºC'),
	(169246, 118, '2014-02-01 01:15:36.000000', 'temperatura', 681.0000, 'ºC'),
	(169247, 118, '2014-02-01 01:15:37.000000', 'temperatura', 662.0000, 'ºC'),
	(169248, 118, '2014-02-01 01:15:38.000000', 'temperatura', 67.0000, 'ºC'),
	(169249, 118, '2014-02-01 01:15:39.000000', 'temperatura', 749.0000, 'ºC'),
	(169250, 118, '2014-02-01 01:15:40.000000', 'temperatura', 1145.0000, 'ºC'),
	(169251, 118, '2014-02-01 01:15:41.000000', 'temperatura', 1080.0000, 'ºC'),
	(169252, 118, '2014-02-01 01:15:42.000000', 'temperatura', 766.0000, 'ºC'),
	(169253, 118, '2014-02-01 01:15:43.000000', 'temperatura', 588.0000, 'ºC'),
	(169254, 118, '2014-02-01 01:15:44.000000', 'temperatura', 644.0000, 'ºC'),
	(169255, 118, '2014-02-01 01:15:45.000000', 'temperatura', 254.0000, 'ºC'),
	(169256, 118, '2014-02-01 01:15:46.000000', 'temperatura', 541.0000, 'ºC'),
	(169257, 118, '2014-02-01 01:15:47.000000', 'temperatura', 741.0000, 'ºC'),
	(169258, 118, '2014-02-01 01:15:48.000000', 'temperatura', 885.0000, 'ºC'),
	(169259, 118, '2014-02-01 01:15:49.000000', 'temperatura', 1002.0000, 'ºC'),
	(169260, 118, '2014-02-01 01:15:50.000000', 'temperatura', 1156.0000, 'ºC'),
	(169261, 118, '2014-02-01 01:15:51.000000', 'temperatura', 375.0000, 'ºC'),
	(169262, 118, '2014-02-01 01:15:52.000000', 'temperatura', 805.0000, 'ºC'),
	(169263, 118, '2014-02-01 01:15:53.000000', 'temperatura', 502.0000, 'ºC'),
	(169264, 118, '2014-02-01 01:15:54.000000', 'temperatura', 95.0000, 'ºC'),
	(169265, 118, '2014-02-01 01:15:55.000000', 'temperatura', 172.0000, 'ºC'),
	(169266, 118, '2014-02-01 01:15:56.000000', 'temperatura', 572.0000, 'ºC'),
	(169267, 118, '2014-02-01 01:15:57.000000', 'temperatura', 1147.0000, 'ºC'),
	(169268, 118, '2014-02-01 01:15:58.000000', 'temperatura', 418.0000, 'ºC'),
	(169269, 118, '2014-02-01 01:15:59.000000', 'temperatura', 1052.0000, 'ºC'),
	(169270, 118, '2014-02-01 01:16:00.000000', 'temperatura', 405.0000, 'ºC'),
	(169271, 118, '2014-02-01 01:16:01.000000', 'temperatura', 70.0000, 'ºC'),
	(169272, 118, '2014-02-01 01:16:02.000000', 'temperatura', 335.0000, 'ºC'),
	(169273, 118, '2014-02-01 01:16:03.000000', 'temperatura', 267.0000, 'ºC'),
	(169274, 118, '2014-02-01 01:16:04.000000', 'temperatura', 329.0000, 'ºC'),
	(169275, 118, '2014-02-01 01:16:05.000000', 'temperatura', 843.0000, 'ºC'),
	(169276, 118, '2014-02-01 01:16:06.000000', 'temperatura', 830.0000, 'ºC'),
	(169277, 118, '2014-02-01 01:16:07.000000', 'temperatura', 421.0000, 'ºC'),
	(169278, 118, '2014-02-01 01:16:08.000000', 'temperatura', 818.0000, 'ºC'),
	(169279, 118, '2014-02-01 01:16:09.000000', 'temperatura', 425.0000, 'ºC'),
	(169280, 118, '2014-02-01 01:16:10.000000', 'temperatura', 871.0000, 'ºC'),
	(169281, 118, '2014-02-01 01:16:11.000000', 'temperatura', 682.0000, 'ºC'),
	(169282, 118, '2014-02-01 01:16:12.000000', 'temperatura', 798.0000, 'ºC'),
	(169283, 118, '2014-02-01 01:16:13.000000', 'temperatura', 745.0000, 'ºC'),
	(169284, 118, '2014-02-01 01:16:14.000000', 'temperatura', 129.0000, 'ºC'),
	(169285, 118, '2014-02-01 01:16:15.000000', 'temperatura', 811.0000, 'ºC'),
	(169286, 118, '2014-02-01 01:16:16.000000', 'temperatura', 71.0000, 'ºC'),
	(169287, 118, '2014-02-01 01:16:17.000000', 'temperatura', 321.0000, 'ºC'),
	(169288, 118, '2014-02-01 01:16:18.000000', 'temperatura', 192.0000, 'ºC'),
	(169289, 118, '2014-02-01 01:16:19.000000', 'temperatura', 1198.0000, 'ºC'),
	(169290, 118, '2014-02-01 01:16:20.000000', 'temperatura', 616.0000, 'ºC'),
	(169291, 118, '2014-02-01 01:16:21.000000', 'temperatura', 684.0000, 'ºC'),
	(169292, 118, '2014-02-01 01:16:22.000000', 'temperatura', 373.0000, 'ºC'),
	(169293, 118, '2014-02-01 01:16:23.000000', 'temperatura', 1013.0000, 'ºC'),
	(169294, 118, '2014-02-01 01:16:24.000000', 'temperatura', 346.0000, 'ºC'),
	(169295, 118, '2014-02-01 01:16:25.000000', 'temperatura', 1092.0000, 'ºC'),
	(169296, 118, '2014-02-01 01:16:26.000000', 'temperatura', 823.0000, 'ºC'),
	(169297, 118, '2014-02-01 01:16:27.000000', 'temperatura', 837.0000, 'ºC'),
	(169298, 118, '2014-02-01 01:16:28.000000', 'temperatura', 520.0000, 'ºC'),
	(169299, 118, '2014-02-01 01:16:29.000000', 'temperatura', 87.0000, 'ºC'),
	(169300, 118, '2014-02-01 01:16:30.000000', 'temperatura', 75.0000, 'ºC'),
	(169301, 118, '2014-02-01 01:16:31.000000', 'temperatura', 116.0000, 'ºC'),
	(169302, 118, '2014-02-01 01:16:32.000000', 'temperatura', 356.0000, 'ºC'),
	(169303, 118, '2014-02-01 01:16:33.000000', 'temperatura', 232.0000, 'ºC'),
	(169304, 118, '2014-02-01 01:16:34.000000', 'temperatura', 93.0000, 'ºC'),
	(169305, 118, '2014-02-01 01:16:35.000000', 'temperatura', 968.0000, 'ºC'),
	(169306, 118, '2014-02-01 01:16:36.000000', 'temperatura', 961.0000, 'ºC'),
	(169307, 118, '2014-02-01 01:16:37.000000', 'temperatura', 700.0000, 'ºC'),
	(169308, 118, '2014-02-01 01:16:38.000000', 'temperatura', 621.0000, 'ºC'),
	(169309, 118, '2014-02-01 01:16:39.000000', 'temperatura', 1005.0000, 'ºC'),
	(169310, 118, '2014-02-01 01:16:40.000000', 'temperatura', 763.0000, 'ºC'),
	(169311, 118, '2014-02-01 01:16:41.000000', 'temperatura', 801.0000, 'ºC'),
	(169312, 118, '2014-02-01 01:16:42.000000', 'temperatura', 517.0000, 'ºC'),
	(169313, 118, '2014-02-01 01:16:43.000000', 'temperatura', 181.0000, 'ºC'),
	(169314, 118, '2014-02-01 01:16:44.000000', 'temperatura', 554.0000, 'ºC'),
	(169315, 118, '2014-02-01 01:16:45.000000', 'temperatura', 1027.0000, 'ºC'),
	(169316, 118, '2014-02-01 01:16:46.000000', 'temperatura', 1074.0000, 'ºC'),
	(169317, 118, '2014-02-01 01:16:47.000000', 'temperatura', 1090.0000, 'ºC'),
	(169318, 118, '2014-02-01 01:16:48.000000', 'temperatura', 1029.0000, 'ºC'),
	(169319, 118, '2014-02-01 01:16:49.000000', 'temperatura', 675.0000, 'ºC'),
	(169320, 118, '2014-02-01 01:16:50.000000', 'temperatura', 288.0000, 'ºC'),
	(169321, 118, '2014-02-01 01:16:51.000000', 'temperatura', 614.0000, 'ºC'),
	(169322, 118, '2014-02-01 01:16:52.000000', 'temperatura', 1009.0000, 'ºC'),
	(169323, 118, '2014-02-01 01:16:53.000000', 'temperatura', 803.0000, 'ºC'),
	(169324, 118, '2014-02-01 01:16:54.000000', 'temperatura', 986.0000, 'ºC'),
	(169325, 118, '2014-02-01 01:16:55.000000', 'temperatura', 124.0000, 'ºC'),
	(169326, 118, '2014-02-01 01:16:56.000000', 'temperatura', 61.0000, 'ºC'),
	(169327, 118, '2014-02-01 01:16:57.000000', 'temperatura', 1132.0000, 'ºC'),
	(169328, 118, '2014-02-01 01:16:58.000000', 'temperatura', 680.0000, 'ºC'),
	(169329, 118, '2014-02-01 01:16:59.000000', 'temperatura', 2.0000, 'ºC'),
	(169330, 118, '2014-02-01 01:17:00.000000', 'temperatura', 373.0000, 'ºC'),
	(169331, 118, '2014-02-01 01:17:01.000000', 'temperatura', 659.0000, 'ºC'),
	(169332, 118, '2014-02-01 01:17:02.000000', 'temperatura', 974.0000, 'ºC'),
	(169333, 118, '2014-02-01 01:17:03.000000', 'temperatura', 497.0000, 'ºC'),
	(169334, 118, '2014-02-01 01:17:04.000000', 'temperatura', 761.0000, 'ºC'),
	(169335, 118, '2014-02-01 01:17:05.000000', 'temperatura', 1114.0000, 'ºC'),
	(169336, 118, '2014-02-01 01:17:06.000000', 'temperatura', 889.0000, 'ºC'),
	(169337, 118, '2014-02-01 01:17:07.000000', 'temperatura', 1102.0000, 'ºC'),
	(169338, 118, '2014-02-01 01:17:08.000000', 'temperatura', 443.0000, 'ºC'),
	(169339, 118, '2014-02-01 01:17:09.000000', 'temperatura', 109.0000, 'ºC'),
	(169340, 118, '2014-02-01 01:17:10.000000', 'temperatura', 417.0000, 'ºC'),
	(169341, 118, '2014-02-01 01:17:11.000000', 'temperatura', 560.0000, 'ºC'),
	(169342, 118, '2014-02-01 01:17:12.000000', 'temperatura', 347.0000, 'ºC'),
	(169343, 118, '2014-02-01 01:17:13.000000', 'temperatura', 57.0000, 'ºC'),
	(169344, 118, '2014-02-01 01:17:14.000000', 'temperatura', 444.0000, 'ºC'),
	(169345, 118, '2014-02-01 01:17:15.000000', 'temperatura', 849.0000, 'ºC'),
	(169346, 118, '2014-02-01 01:17:16.000000', 'temperatura', 512.0000, 'ºC'),
	(169347, 118, '2014-02-01 01:17:17.000000', 'temperatura', 16.0000, 'ºC'),
	(169348, 118, '2014-02-01 01:17:18.000000', 'temperatura', 945.0000, 'ºC'),
	(169349, 118, '2014-02-01 01:17:19.000000', 'temperatura', 1075.0000, 'ºC'),
	(169350, 118, '2014-02-01 01:17:20.000000', 'temperatura', 140.0000, 'ºC'),
	(169351, 118, '2014-02-01 01:17:21.000000', 'temperatura', 1079.0000, 'ºC'),
	(169352, 118, '2014-02-01 01:17:22.000000', 'temperatura', 173.0000, 'ºC'),
	(169353, 118, '2014-02-01 01:17:23.000000', 'temperatura', 27.0000, 'ºC'),
	(169354, 118, '2014-02-01 01:17:24.000000', 'temperatura', 819.0000, 'ºC'),
	(169355, 118, '2014-02-01 01:17:25.000000', 'temperatura', 413.0000, 'ºC'),
	(169356, 118, '2014-02-01 01:17:26.000000', 'temperatura', 809.0000, 'ºC'),
	(169357, 118, '2014-02-01 01:17:27.000000', 'temperatura', 408.0000, 'ºC'),
	(169358, 118, '2014-02-01 01:17:28.000000', 'temperatura', 814.0000, 'ºC'),
	(169359, 118, '2014-02-01 01:17:29.000000', 'temperatura', 445.0000, 'ºC'),
	(169360, 118, '2014-02-01 01:17:30.000000', 'temperatura', 982.0000, 'ºC'),
	(169361, 118, '2014-02-01 01:17:31.000000', 'temperatura', 1176.0000, 'ºC'),
	(169362, 118, '2014-02-01 01:17:32.000000', 'temperatura', 534.0000, 'ºC'),
	(169363, 118, '2014-02-01 01:17:33.000000', 'temperatura', 342.0000, 'ºC'),
	(169364, 118, '2014-02-01 01:17:34.000000', 'temperatura', 111.0000, 'ºC'),
	(169365, 118, '2014-02-01 01:17:35.000000', 'temperatura', 730.0000, 'ºC'),
	(169366, 118, '2014-02-01 01:17:36.000000', 'temperatura', 915.0000, 'ºC'),
	(169367, 118, '2014-02-01 01:17:37.000000', 'temperatura', 1188.0000, 'ºC'),
	(169368, 118, '2014-02-01 01:17:38.000000', 'temperatura', 795.0000, 'ºC'),
	(169369, 118, '2014-02-01 01:17:39.000000', 'temperatura', 411.0000, 'ºC'),
	(169370, 118, '2014-02-01 01:17:40.000000', 'temperatura', 872.0000, 'ºC'),
	(169371, 118, '2014-02-01 01:17:41.000000', 'temperatura', 727.0000, 'ºC'),
	(169372, 118, '2014-02-01 01:17:42.000000', 'temperatura', 1017.0000, 'ºC'),
	(169373, 118, '2014-02-01 01:17:43.000000', 'temperatura', 507.0000, 'ºC'),
	(169374, 118, '2014-02-01 01:17:44.000000', 'temperatura', 684.0000, 'ºC'),
	(169375, 118, '2014-02-01 01:17:45.000000', 'temperatura', 701.0000, 'ºC'),
	(169376, 118, '2014-02-01 01:17:46.000000', 'temperatura', 253.0000, 'ºC'),
	(169377, 118, '2014-02-01 01:17:47.000000', 'temperatura', 362.0000, 'ºC'),
	(169378, 118, '2014-02-01 01:17:48.000000', 'temperatura', 1051.0000, 'ºC'),
	(169379, 118, '2014-02-01 01:17:49.000000', 'temperatura', 572.0000, 'ºC'),
	(169380, 118, '2014-02-01 01:17:50.000000', 'temperatura', 904.0000, 'ºC'),
	(169381, 118, '2014-02-01 01:17:51.000000', 'temperatura', 406.0000, 'ºC'),
	(169382, 118, '2014-02-01 01:17:52.000000', 'temperatura', 519.0000, 'ºC'),
	(169383, 118, '2014-02-01 01:17:53.000000', 'temperatura', 178.0000, 'ºC'),
	(169384, 118, '2014-02-01 01:17:54.000000', 'temperatura', 531.0000, 'ºC'),
	(169385, 118, '2014-02-01 01:17:55.000000', 'temperatura', 922.0000, 'ºC'),
	(169386, 118, '2014-02-01 01:17:56.000000', 'temperatura', 619.0000, 'ºC'),
	(169387, 118, '2014-02-01 01:17:57.000000', 'temperatura', 328.0000, 'ºC'),
	(169388, 118, '2014-02-01 01:17:58.000000', 'temperatura', 985.0000, 'ºC'),
	(169389, 118, '2014-02-01 01:17:59.000000', 'temperatura', 339.0000, 'ºC'),
	(169390, 118, '2014-02-01 01:18:00.000000', 'temperatura', 1143.0000, 'ºC'),
	(169391, 118, '2014-02-01 01:18:01.000000', 'temperatura', 1097.0000, 'ºC'),
	(169392, 118, '2014-02-01 01:18:02.000000', 'temperatura', 856.0000, 'ºC'),
	(169393, 118, '2014-02-01 01:18:03.000000', 'temperatura', 992.0000, 'ºC'),
	(169394, 118, '2014-02-01 01:18:04.000000', 'temperatura', 1190.0000, 'ºC'),
	(169395, 118, '2014-02-01 01:18:05.000000', 'temperatura', 576.0000, 'ºC'),
	(169396, 118, '2014-02-01 01:18:06.000000', 'temperatura', 509.0000, 'ºC'),
	(169397, 118, '2014-02-01 01:18:07.000000', 'temperatura', 819.0000, 'ºC'),
	(169398, 118, '2014-02-01 01:18:08.000000', 'temperatura', 168.0000, 'ºC'),
	(169399, 118, '2014-02-01 01:18:09.000000', 'temperatura', 783.0000, 'ºC'),
	(169400, 118, '2014-02-01 01:18:10.000000', 'temperatura', 1011.0000, 'ºC'),
	(169401, 118, '2014-02-01 01:18:11.000000', 'temperatura', 309.0000, 'ºC'),
	(169402, 118, '2014-02-01 01:18:12.000000', 'temperatura', 909.0000, 'ºC'),
	(169403, 118, '2014-02-01 01:18:13.000000', 'temperatura', 21.0000, 'ºC'),
	(169404, 118, '2014-02-01 01:18:14.000000', 'temperatura', 977.0000, 'ºC'),
	(169405, 118, '2014-02-01 01:18:15.000000', 'temperatura', 23.0000, 'ºC'),
	(169406, 118, '2014-02-01 01:18:16.000000', 'temperatura', 783.0000, 'ºC'),
	(169407, 118, '2014-02-01 01:18:17.000000', 'temperatura', 249.0000, 'ºC'),
	(169408, 118, '2014-02-01 01:18:18.000000', 'temperatura', 97.0000, 'ºC'),
	(169409, 118, '2014-02-01 01:18:19.000000', 'temperatura', 938.0000, 'ºC'),
	(169410, 118, '2014-02-01 01:18:20.000000', 'temperatura', 798.0000, 'ºC'),
	(169411, 118, '2014-02-01 01:18:21.000000', 'temperatura', 1177.0000, 'ºC'),
	(169412, 118, '2014-02-01 01:18:22.000000', 'temperatura', 1093.0000, 'ºC'),
	(169413, 118, '2014-02-01 01:18:23.000000', 'temperatura', 735.0000, 'ºC'),
	(169414, 118, '2014-02-01 01:18:24.000000', 'temperatura', 397.0000, 'ºC'),
	(169415, 118, '2014-02-01 01:18:25.000000', 'temperatura', 978.0000, 'ºC'),
	(169416, 118, '2014-02-01 01:18:26.000000', 'temperatura', 101.0000, 'ºC'),
	(169417, 118, '2014-02-01 01:18:27.000000', 'temperatura', 1171.0000, 'ºC'),
	(169418, 118, '2014-02-01 01:18:28.000000', 'temperatura', 755.0000, 'ºC'),
	(169419, 118, '2014-02-01 01:18:29.000000', 'temperatura', 259.0000, 'ºC'),
	(169420, 118, '2014-02-01 01:18:30.000000', 'temperatura', 233.0000, 'ºC'),
	(169421, 118, '2014-02-01 01:18:31.000000', 'temperatura', 386.0000, 'ºC'),
	(169422, 118, '2014-02-01 01:18:32.000000', 'temperatura', 31.0000, 'ºC'),
	(169423, 118, '2014-02-01 01:18:33.000000', 'temperatura', 197.0000, 'ºC'),
	(169424, 118, '2014-02-01 01:18:34.000000', 'temperatura', 894.0000, 'ºC'),
	(169425, 118, '2014-02-01 01:18:35.000000', 'temperatura', 278.0000, 'ºC'),
	(169426, 118, '2014-02-01 01:18:36.000000', 'temperatura', 1109.0000, 'ºC'),
	(169427, 118, '2014-02-01 01:18:37.000000', 'temperatura', 1113.0000, 'ºC'),
	(169428, 118, '2014-02-01 01:18:38.000000', 'temperatura', 1036.0000, 'ºC'),
	(169429, 118, '2014-02-01 01:18:39.000000', 'temperatura', 641.0000, 'ºC'),
	(169430, 118, '2014-02-01 01:18:40.000000', 'temperatura', 99.0000, 'ºC'),
	(169431, 118, '2014-02-01 01:18:41.000000', 'temperatura', 972.0000, 'ºC'),
	(169432, 118, '2014-02-01 01:18:42.000000', 'temperatura', 962.0000, 'ºC'),
	(169433, 118, '2014-02-01 01:18:43.000000', 'temperatura', 698.0000, 'ºC'),
	(169434, 118, '2014-02-01 01:18:44.000000', 'temperatura', 601.0000, 'ºC'),
	(169435, 118, '2014-02-01 01:18:45.000000', 'temperatura', 912.0000, 'ºC'),
	(169436, 118, '2014-02-01 01:18:46.000000', 'temperatura', 358.0000, 'ºC'),
	(169437, 118, '2014-02-01 01:18:47.000000', 'temperatura', 255.0000, 'ºC'),
	(169438, 118, '2014-02-01 01:18:48.000000', 'temperatura', 203.0000, 'ºC'),
	(169439, 118, '2014-02-01 01:18:49.000000', 'temperatura', 250.0000, 'ºC'),
	(169440, 118, '2014-02-01 01:18:50.000000', 'temperatura', 640.0000, 'ºC'),
	(169441, 118, '2014-02-01 01:18:51.000000', 'temperatura', 50.0000, 'ºC'),
	(169442, 118, '2014-02-01 01:18:52.000000', 'temperatura', 732.0000, 'ºC'),
	(169443, 118, '2014-02-01 01:18:53.000000', 'temperatura', 1109.0000, 'ºC'),
	(169444, 118, '2014-02-01 01:18:54.000000', 'temperatura', 950.0000, 'ºC'),
	(169445, 118, '2014-02-01 01:18:55.000000', 'temperatura', 222.0000, 'ºC'),
	(169446, 119, '2014-02-01 00:00:00.000000', 'temperatura', 241.0000, 'ºC'),
	(169447, 119, '2014-02-01 00:00:01.000000', 'temperatura', 424.0000, 'ºC'),
	(169448, 119, '2014-02-01 00:00:02.000000', 'temperatura', 194.0000, 'ºC'),
	(169449, 119, '2014-02-01 00:00:03.000000', 'temperatura', 901.0000, 'ºC'),
	(169450, 119, '2014-02-01 00:00:04.000000', 'temperatura', 324.0000, 'ºC'),
	(169451, 119, '2014-02-01 00:00:05.000000', 'temperatura', 115.0000, 'ºC'),
	(169452, 119, '2014-02-01 00:00:06.000000', 'temperatura', 804.0000, 'ºC'),
	(169453, 119, '2014-02-01 00:00:07.000000', 'temperatura', 77.0000, 'ºC'),
	(169454, 119, '2014-02-01 00:00:08.000000', 'temperatura', 373.0000, 'ºC'),
	(169455, 119, '2014-02-01 00:00:09.000000', 'temperatura', 432.0000, 'ºC'),
	(169456, 119, '2014-02-01 00:00:10.000000', 'temperatura', 1044.0000, 'ºC'),
	(169457, 119, '2014-02-01 00:00:11.000000', 'temperatura', 323.0000, 'ºC'),
	(169458, 119, '2014-02-01 00:00:12.000000', 'temperatura', 886.0000, 'ºC'),
	(169459, 119, '2014-02-01 00:00:13.000000', 'temperatura', 1061.0000, 'ºC'),
	(169460, 119, '2014-02-01 00:00:14.000000', 'temperatura', 248.0000, 'ºC'),
	(169461, 119, '2014-02-01 00:00:15.000000', 'temperatura', 459.0000, 'ºC'),
	(169462, 119, '2014-02-01 00:00:16.000000', 'temperatura', 348.0000, 'ºC'),
	(169463, 119, '2014-02-01 00:00:17.000000', 'temperatura', 366.0000, 'ºC'),
	(169464, 119, '2014-02-01 00:00:18.000000', 'temperatura', 784.0000, 'ºC'),
	(169465, 119, '2014-02-01 00:00:19.000000', 'temperatura', 422.0000, 'ºC'),
	(169466, 119, '2014-02-01 00:00:20.000000', 'temperatura', 961.0000, 'ºC'),
	(169467, 119, '2014-02-01 00:00:21.000000', 'temperatura', 1138.0000, 'ºC'),
	(169468, 119, '2014-02-01 00:00:22.000000', 'temperatura', 406.0000, 'ºC'),
	(169469, 119, '2014-02-01 00:00:23.000000', 'temperatura', 1018.0000, 'ºC'),
	(169470, 119, '2014-02-01 00:00:24.000000', 'temperatura', 272.0000, 'ºC'),
	(169471, 119, '2014-02-01 00:00:25.000000', 'temperatura', 707.0000, 'ºC'),
	(169472, 119, '2014-02-01 00:00:26.000000', 'temperatura', 318.0000, 'ºC'),
	(169473, 119, '2014-02-01 00:00:27.000000', 'temperatura', 671.0000, 'ºC'),
	(169474, 119, '2014-02-01 00:00:28.000000', 'temperatura', 1199.0000, 'ºC'),
	(169475, 119, '2014-02-01 00:00:29.000000', 'temperatura', 384.0000, 'ºC'),
	(169476, 119, '2014-02-01 00:00:30.000000', 'temperatura', 724.0000, 'ºC'),
	(169477, 119, '2014-02-01 00:00:31.000000', 'temperatura', 69.0000, 'ºC'),
	(169478, 119, '2014-02-01 00:00:32.000000', 'temperatura', 573.0000, 'ºC'),
	(169479, 119, '2014-02-01 00:00:33.000000', 'temperatura', 260.0000, 'ºC'),
	(169480, 119, '2014-02-01 00:00:34.000000', 'temperatura', 780.0000, 'ºC'),
	(169481, 119, '2014-02-01 00:00:35.000000', 'temperatura', 722.0000, 'ºC'),
	(169482, 119, '2014-02-01 00:00:36.000000', 'temperatura', 71.0000, 'ºC'),
	(169483, 119, '2014-02-01 00:00:37.000000', 'temperatura', 590.0000, 'ºC'),
	(169484, 119, '2014-02-01 00:00:38.000000', 'temperatura', 335.0000, 'ºC'),
	(169485, 119, '2014-02-01 00:00:39.000000', 'temperatura', 1108.0000, 'ºC'),
	(169486, 119, '2014-02-01 00:00:40.000000', 'temperatura', 934.0000, 'ºC'),
	(169487, 119, '2014-02-01 00:00:41.000000', 'temperatura', 146.0000, 'ºC'),
	(169488, 119, '2014-02-01 00:00:42.000000', 'temperatura', 328.0000, 'ºC'),
	(169489, 119, '2014-02-01 00:00:43.000000', 'temperatura', 2.0000, 'ºC'),
	(169490, 119, '2014-02-01 00:00:44.000000', 'temperatura', 228.0000, 'ºC'),
	(169491, 119, '2014-02-01 00:00:45.000000', 'temperatura', 1136.0000, 'ºC'),
	(169492, 119, '2014-02-01 00:00:46.000000', 'temperatura', 193.0000, 'ºC'),
	(169493, 119, '2014-02-01 00:00:47.000000', 'temperatura', 1161.0000, 'ºC'),
	(169494, 119, '2014-02-01 00:00:48.000000', 'temperatura', 425.0000, 'ºC'),
	(169495, 119, '2014-02-01 00:00:49.000000', 'temperatura', 1041.0000, 'ºC'),
	(169496, 119, '2014-02-01 00:00:50.000000', 'temperatura', 334.0000, 'ºC'),
	(169497, 119, '2014-02-01 00:00:51.000000', 'temperatura', 944.0000, 'ºC'),
	(169498, 119, '2014-02-01 00:00:52.000000', 'temperatura', 120.0000, 'ºC'),
	(169499, 119, '2014-02-01 00:00:53.000000', 'temperatura', 166.0000, 'ºC'),
	(169500, 119, '2014-02-01 00:00:54.000000', 'temperatura', 474.0000, 'ºC'),
	(169501, 119, '2014-02-01 00:00:55.000000', 'temperatura', 669.0000, 'ºC'),
	(169502, 119, '2014-02-01 00:00:56.000000', 'temperatura', 726.0000, 'ºC'),
	(169503, 119, '2014-02-01 00:00:57.000000', 'temperatura', 422.0000, 'ºC'),
	(169504, 119, '2014-02-01 00:00:58.000000', 'temperatura', 1133.0000, 'ºC'),
	(169505, 119, '2014-02-01 00:00:59.000000', 'temperatura', 798.0000, 'ºC'),
	(169506, 119, '2014-02-01 00:01:00.000000', 'temperatura', 593.0000, 'ºC'),
	(169507, 119, '2014-02-01 00:01:01.000000', 'temperatura', 573.0000, 'ºC'),
	(169508, 119, '2014-02-01 00:01:02.000000', 'temperatura', 1086.0000, 'ºC'),
	(169509, 119, '2014-02-01 00:01:03.000000', 'temperatura', 109.0000, 'ºC'),
	(169510, 119, '2014-02-01 00:01:04.000000', 'temperatura', 888.0000, 'ºC'),
	(169511, 119, '2014-02-01 00:01:05.000000', 'temperatura', 516.0000, 'ºC'),
	(169512, 119, '2014-02-01 00:01:06.000000', 'temperatura', 1114.0000, 'ºC'),
	(169513, 119, '2014-02-01 00:01:07.000000', 'temperatura', 422.0000, 'ºC'),
	(169514, 119, '2014-02-01 00:01:08.000000', 'temperatura', 1171.0000, 'ºC'),
	(169515, 119, '2014-02-01 00:01:09.000000', 'temperatura', 988.0000, 'ºC'),
	(169516, 119, '2014-02-01 00:01:10.000000', 'temperatura', 228.0000, 'ºC'),
	(169517, 119, '2014-02-01 00:01:11.000000', 'temperatura', 576.0000, 'ºC'),
	(169518, 119, '2014-02-01 00:01:12.000000', 'temperatura', 998.0000, 'ºC'),
	(169519, 119, '2014-02-01 00:01:13.000000', 'temperatura', 861.0000, 'ºC'),
	(169520, 119, '2014-02-01 00:01:14.000000', 'temperatura', 113.0000, 'ºC'),
	(169521, 119, '2014-02-01 00:01:15.000000', 'temperatura', 383.0000, 'ºC'),
	(169522, 119, '2014-02-01 00:01:16.000000', 'temperatura', 374.0000, 'ºC'),
	(169523, 119, '2014-02-01 00:01:17.000000', 'temperatura', 723.0000, 'ºC'),
	(169524, 119, '2014-02-01 00:01:18.000000', 'temperatura', 93.0000, 'ºC'),
	(169525, 119, '2014-02-01 00:01:19.000000', 'temperatura', 696.0000, 'ºC'),
	(169526, 119, '2014-02-01 00:01:20.000000', 'temperatura', 803.0000, 'ºC'),
	(169527, 119, '2014-02-01 00:01:21.000000', 'temperatura', 726.0000, 'ºC'),
	(169528, 119, '2014-02-01 00:01:22.000000', 'temperatura', 21.0000, 'ºC'),
	(169529, 119, '2014-02-01 00:01:23.000000', 'temperatura', 329.0000, 'ºC'),
	(169530, 119, '2014-02-01 00:01:24.000000', 'temperatura', 382.0000, 'ºC'),
	(169531, 119, '2014-02-01 00:01:25.000000', 'temperatura', 922.0000, 'ºC'),
	(169532, 119, '2014-02-01 00:01:26.000000', 'temperatura', 1064.0000, 'ºC'),
	(169533, 119, '2014-02-01 00:01:27.000000', 'temperatura', 157.0000, 'ºC'),
	(169534, 119, '2014-02-01 00:01:28.000000', 'temperatura', 1194.0000, 'ºC'),
	(169535, 119, '2014-02-01 00:01:29.000000', 'temperatura', 698.0000, 'ºC'),
	(169536, 119, '2014-02-01 00:01:30.000000', 'temperatura', 1108.0000, 'ºC'),
	(169537, 119, '2014-02-01 00:01:31.000000', 'temperatura', 1049.0000, 'ºC'),
	(169538, 119, '2014-02-01 00:01:32.000000', 'temperatura', 719.0000, 'ºC'),
	(169539, 119, '2014-02-01 00:01:33.000000', 'temperatura', 451.0000, 'ºC'),
	(169540, 119, '2014-02-01 00:01:34.000000', 'temperatura', 97.0000, 'ºC'),
	(169541, 119, '2014-02-01 00:01:35.000000', 'temperatura', 332.0000, 'ºC'),
	(169542, 119, '2014-02-01 00:01:36.000000', 'temperatura', 168.0000, 'ºC'),
	(169543, 119, '2014-02-01 00:01:37.000000', 'temperatura', 1048.0000, 'ºC'),
	(169544, 119, '2014-02-01 00:01:38.000000', 'temperatura', 1135.0000, 'ºC'),
	(169545, 119, '2014-02-01 00:01:39.000000', 'temperatura', 132.0000, 'ºC'),
	(169546, 119, '2014-02-01 00:01:40.000000', 'temperatura', 855.0000, 'ºC'),
	(169547, 119, '2014-02-01 00:01:41.000000', 'temperatura', 278.0000, 'ºC'),
	(169548, 119, '2014-02-01 00:01:42.000000', 'temperatura', 28.0000, 'ºC'),
	(169549, 119, '2014-02-01 00:01:43.000000', 'temperatura', 506.0000, 'ºC'),
	(169550, 119, '2014-02-01 00:01:44.000000', 'temperatura', 45.0000, 'ºC'),
	(169551, 119, '2014-02-01 00:01:45.000000', 'temperatura', 1109.0000, 'ºC'),
	(169552, 119, '2014-02-01 00:01:46.000000', 'temperatura', 610.0000, 'ºC'),
	(169553, 119, '2014-02-01 00:01:47.000000', 'temperatura', 924.0000, 'ºC'),
	(169554, 119, '2014-02-01 00:01:48.000000', 'temperatura', 389.0000, 'ºC'),
	(169555, 119, '2014-02-01 00:01:49.000000', 'temperatura', 373.0000, 'ºC'),
	(169556, 119, '2014-02-01 00:01:50.000000', 'temperatura', 698.0000, 'ºC'),
	(169557, 119, '2014-02-01 00:01:51.000000', 'temperatura', 1175.0000, 'ºC'),
	(169558, 119, '2014-02-01 00:01:52.000000', 'temperatura', 178.0000, 'ºC'),
	(169559, 119, '2014-02-01 00:01:53.000000', 'temperatura', 965.0000, 'ºC'),
	(169560, 119, '2014-02-01 00:01:54.000000', 'temperatura', 694.0000, 'ºC'),
	(169561, 119, '2014-02-01 00:01:55.000000', 'temperatura', 576.0000, 'ºC'),
	(169562, 119, '2014-02-01 00:01:56.000000', 'temperatura', 797.0000, 'ºC'),
	(169563, 119, '2014-02-01 00:01:57.000000', 'temperatura', 1059.0000, 'ºC'),
	(169564, 119, '2014-02-01 00:01:58.000000', 'temperatura', 503.0000, 'ºC'),
	(169565, 119, '2014-02-01 00:01:59.000000', 'temperatura', 537.0000, 'ºC'),
	(169566, 119, '2014-02-01 00:02:00.000000', 'temperatura', 1180.0000, 'ºC'),
	(169567, 119, '2014-02-01 00:02:01.000000', 'temperatura', 688.0000, 'ºC'),
	(169568, 119, '2014-02-01 00:02:02.000000', 'temperatura', 1101.0000, 'ºC'),
	(169569, 119, '2014-02-01 00:02:03.000000', 'temperatura', 1040.0000, 'ºC'),
	(169570, 119, '2014-02-01 00:02:04.000000', 'temperatura', 698.0000, 'ºC'),
	(169571, 119, '2014-02-01 00:02:05.000000', 'temperatura', 370.0000, 'ºC'),
	(169572, 119, '2014-02-01 00:02:06.000000', 'temperatura', 958.0000, 'ºC'),
	(169573, 119, '2014-02-01 00:02:07.000000', 'temperatura', 79.0000, 'ºC'),
	(169574, 119, '2014-02-01 00:02:08.000000', 'temperatura', 1120.0000, 'ºC'),
	(169575, 119, '2014-02-01 00:02:09.000000', 'temperatura', 566.0000, 'ºC'),
	(169576, 119, '2014-02-01 00:02:10.000000', 'temperatura', 670.0000, 'ºC'),
	(169577, 119, '2014-02-01 00:02:11.000000', 'temperatura', 452.0000, 'ºC'),
	(169578, 119, '2014-02-01 00:02:12.000000', 'temperatura', 252.0000, 'ºC'),
	(169579, 119, '2014-02-01 00:02:13.000000', 'temperatura', 1104.0000, 'ºC'),
	(169580, 119, '2014-02-01 00:02:14.000000', 'temperatura', 1164.0000, 'ºC'),
	(169581, 119, '2014-02-01 00:02:15.000000', 'temperatura', 107.0000, 'ºC'),
	(169582, 119, '2014-02-01 00:02:16.000000', 'temperatura', 647.0000, 'ºC'),
	(169583, 119, '2014-02-01 00:02:17.000000', 'temperatura', 511.0000, 'ºC'),
	(169584, 119, '2014-02-01 00:02:18.000000', 'temperatura', 617.0000, 'ºC'),
	(169585, 119, '2014-02-01 00:02:19.000000', 'temperatura', 352.0000, 'ºC'),
	(169586, 119, '2014-02-01 00:02:20.000000', 'temperatura', 1108.0000, 'ºC'),
	(169587, 119, '2014-02-01 00:02:21.000000', 'temperatura', 886.0000, 'ºC'),
	(169588, 119, '2014-02-01 00:02:22.000000', 'temperatura', 1105.0000, 'ºC'),
	(169589, 119, '2014-02-01 00:02:23.000000', 'temperatura', 470.0000, 'ºC'),
	(169590, 119, '2014-02-01 00:02:24.000000', 'temperatura', 233.0000, 'ºC'),
	(169591, 119, '2014-02-01 00:02:25.000000', 'temperatura', 956.0000, 'ºC'),
	(169592, 119, '2014-02-01 00:02:26.000000', 'temperatura', 481.0000, 'ºC'),
	(169593, 119, '2014-02-01 00:02:27.000000', 'temperatura', 739.0000, 'ºC'),
	(169594, 119, '2014-02-01 00:02:28.000000', 'temperatura', 1052.0000, 'ºC'),
	(169595, 119, '2014-02-01 00:02:29.000000', 'temperatura', 642.0000, 'ºC'),
	(169596, 119, '2014-02-01 00:02:30.000000', 'temperatura', 55.0000, 'ºC'),
	(169597, 119, '2014-02-01 00:02:31.000000', 'temperatura', 749.0000, 'ºC'),
	(169598, 119, '2014-02-01 00:02:32.000000', 'temperatura', 1183.0000, 'ºC'),
	(169599, 119, '2014-02-01 00:02:33.000000', 'temperatura', 68.0000, 'ºC'),
	(169600, 119, '2014-02-01 00:02:34.000000', 'temperatura', 391.0000, 'ºC'),
	(169601, 119, '2014-02-01 00:02:35.000000', 'temperatura', 551.0000, 'ºC'),
	(169602, 119, '2014-02-01 00:02:36.000000', 'temperatura', 381.0000, 'ºC'),
	(169603, 119, '2014-02-01 00:02:37.000000', 'temperatura', 254.0000, 'ºC'),
	(169604, 119, '2014-02-01 00:02:38.000000', 'temperatura', 129.0000, 'ºC'),
	(169605, 119, '2014-02-01 00:02:39.000000', 'temperatura', 1080.0000, 'ºC'),
	(169606, 119, '2014-02-01 00:02:40.000000', 'temperatura', 216.0000, 'ºC'),
	(169607, 119, '2014-02-01 00:02:41.000000', 'temperatura', 242.0000, 'ºC'),
	(169608, 119, '2014-02-01 00:02:42.000000', 'temperatura', 559.0000, 'ºC'),
	(169609, 119, '2014-02-01 00:02:43.000000', 'temperatura', 872.0000, 'ºC'),
	(169610, 119, '2014-02-01 00:02:44.000000', 'temperatura', 285.0000, 'ºC'),
	(169611, 119, '2014-02-01 00:02:45.000000', 'temperatura', 7.0000, 'ºC'),
	(169612, 119, '2014-02-01 00:02:46.000000', 'temperatura', 379.0000, 'ºC'),
	(169613, 119, '2014-02-01 00:02:47.000000', 'temperatura', 676.0000, 'ºC'),
	(169614, 119, '2014-02-01 00:02:48.000000', 'temperatura', 1044.0000, 'ºC'),
	(169615, 119, '2014-02-01 00:02:49.000000', 'temperatura', 794.0000, 'ºC'),
	(169616, 119, '2014-02-01 00:02:50.000000', 'temperatura', 835.0000, 'ºC'),
	(169617, 119, '2014-02-01 00:02:51.000000', 'temperatura', 597.0000, 'ºC'),
	(169618, 119, '2014-02-01 00:02:52.000000', 'temperatura', 478.0000, 'ºC'),
	(169619, 119, '2014-02-01 00:02:53.000000', 'temperatura', 600.0000, 'ºC'),
	(169620, 119, '2014-02-01 00:02:54.000000', 'temperatura', 366.0000, 'ºC'),
	(169621, 119, '2014-02-01 00:02:55.000000', 'temperatura', 33.0000, 'ºC'),
	(169622, 119, '2014-02-01 00:02:56.000000', 'temperatura', 267.0000, 'ºC'),
	(169623, 119, '2014-02-01 00:02:57.000000', 'temperatura', 34.0000, 'ºC'),
	(169624, 119, '2014-02-01 00:02:58.000000', 'temperatura', 572.0000, 'ºC'),
	(169625, 119, '2014-02-01 00:02:59.000000', 'temperatura', 356.0000, 'ºC'),
	(169626, 119, '2014-02-01 00:03:00.000000', 'temperatura', 67.0000, 'ºC'),
	(169627, 119, '2014-02-01 00:03:01.000000', 'temperatura', 468.0000, 'ºC'),
	(169628, 119, '2014-02-01 00:03:02.000000', 'temperatura', 939.0000, 'ºC'),
	(169629, 119, '2014-02-01 00:03:03.000000', 'temperatura', 893.0000, 'ºC'),
	(169630, 119, '2014-02-01 00:03:04.000000', 'temperatura', 448.0000, 'ºC'),
	(169631, 119, '2014-02-01 00:03:05.000000', 'temperatura', 760.0000, 'ºC'),
	(169632, 119, '2014-02-01 00:03:06.000000', 'temperatura', 58.0000, 'ºC'),
	(169633, 119, '2014-02-01 00:03:07.000000', 'temperatura', 410.0000, 'ºC'),
	(169634, 119, '2014-02-01 00:03:08.000000', 'temperatura', 676.0000, 'ºC'),
	(169635, 119, '2014-02-01 00:03:09.000000', 'temperatura', 951.0000, 'ºC'),
	(169636, 119, '2014-02-01 00:03:10.000000', 'temperatura', 329.0000, 'ºC'),
	(169637, 119, '2014-02-01 00:03:11.000000', 'temperatura', 1192.0000, 'ºC'),
	(169638, 119, '2014-02-01 00:03:12.000000', 'temperatura', 174.0000, 'ºC'),
	(169639, 119, '2014-02-01 00:03:13.000000', 'temperatura', 895.0000, 'ºC'),
	(169640, 119, '2014-02-01 00:03:14.000000', 'temperatura', 352.0000, 'ºC'),
	(169641, 119, '2014-02-01 00:03:15.000000', 'temperatura', 275.0000, 'ºC'),
	(169642, 119, '2014-02-01 00:03:16.000000', 'temperatura', 318.0000, 'ºC'),
	(169643, 119, '2014-02-01 00:03:17.000000', 'temperatura', 768.0000, 'ºC'),
	(169644, 119, '2014-02-01 00:03:18.000000', 'temperatura', 486.0000, 'ºC'),
	(169645, 119, '2014-02-01 00:03:19.000000', 'temperatura', 128.0000, 'ºC'),
	(169646, 119, '2014-02-01 00:03:20.000000', 'temperatura', 382.0000, 'ºC'),
	(169647, 119, '2014-02-01 00:03:21.000000', 'temperatura', 325.0000, 'ºC'),
	(169648, 119, '2014-02-01 00:03:22.000000', 'temperatura', 482.0000, 'ºC'),
	(169649, 119, '2014-02-01 00:03:23.000000', 'temperatura', 232.0000, 'ºC'),
	(169650, 119, '2014-02-01 00:03:24.000000', 'temperatura', 917.0000, 'ºC'),
	(169651, 119, '2014-02-01 00:03:25.000000', 'temperatura', 288.0000, 'ºC'),
	(169652, 119, '2014-02-01 00:03:26.000000', 'temperatura', 1091.0000, 'ºC'),
	(169653, 119, '2014-02-01 00:03:27.000000', 'temperatura', 990.0000, 'ºC'),
	(169654, 119, '2014-02-01 00:03:28.000000', 'temperatura', 477.0000, 'ºC'),
	(169655, 119, '2014-02-01 00:03:29.000000', 'temperatura', 618.0000, 'ºC'),
	(169656, 119, '2014-02-01 00:03:30.000000', 'temperatura', 460.0000, 'ºC'),
	(169657, 119, '2014-02-01 00:03:31.000000', 'temperatura', 444.0000, 'ºC'),
	(169658, 119, '2014-02-01 00:03:32.000000', 'temperatura', 839.0000, 'ºC'),
	(169659, 119, '2014-02-01 00:03:33.000000', 'temperatura', 467.0000, 'ºC'),
	(169660, 119, '2014-02-01 00:03:34.000000', 'temperatura', 1015.0000, 'ºC'),
	(169661, 119, '2014-02-01 00:03:35.000000', 'temperatura', 78.0000, 'ºC'),
	(169662, 119, '2014-02-01 00:03:36.000000', 'temperatura', 945.0000, 'ºC'),
	(169663, 119, '2014-02-01 00:03:37.000000', 'temperatura', 889.0000, 'ºC'),
	(169664, 119, '2014-02-01 00:03:38.000000', 'temperatura', 413.0000, 'ºC'),
	(169665, 119, '2014-02-01 00:03:39.000000', 'temperatura', 597.0000, 'ºC'),
	(169666, 119, '2014-02-01 00:03:40.000000', 'temperatura', 548.0000, 'ºC'),
	(169667, 119, '2014-02-01 00:03:41.000000', 'temperatura', 947.0000, 'ºC'),
	(169668, 119, '2014-02-01 00:03:42.000000', 'temperatura', 692.0000, 'ºC'),
	(169669, 119, '2014-02-01 00:03:43.000000', 'temperatura', 618.0000, 'ºC'),
	(169670, 119, '2014-02-01 00:03:44.000000', 'temperatura', 1016.0000, 'ºC'),
	(169671, 119, '2014-02-01 00:03:45.000000', 'temperatura', 828.0000, 'ºC'),
	(169672, 119, '2014-02-01 00:03:46.000000', 'temperatura', 1093.0000, 'ºC'),
	(169673, 119, '2014-02-01 00:03:47.000000', 'temperatura', 580.0000, 'ºC'),
	(169674, 119, '2014-02-01 00:03:48.000000', 'temperatura', 820.0000, 'ºC'),
	(169675, 119, '2014-02-01 00:03:49.000000', 'temperatura', 1161.0000, 'ºC'),
	(169676, 119, '2014-02-01 00:03:50.000000', 'temperatura', 947.0000, 'ºC'),
	(169677, 119, '2014-02-01 00:03:51.000000', 'temperatura', 50.0000, 'ºC'),
	(169678, 119, '2014-02-01 00:03:52.000000', 'temperatura', 1011.0000, 'ºC'),
	(169679, 119, '2014-02-01 00:03:53.000000', 'temperatura', 104.0000, 'ºC'),
	(169680, 119, '2014-02-01 00:03:54.000000', 'temperatura', 1089.0000, 'ºC'),
	(169681, 119, '2014-02-01 00:03:55.000000', 'temperatura', 335.0000, 'ºC'),
	(169682, 119, '2014-02-01 00:03:56.000000', 'temperatura', 806.0000, 'ºC'),
	(169683, 119, '2014-02-01 00:03:57.000000', 'temperatura', 628.0000, 'ºC'),
	(169684, 119, '2014-02-01 00:03:58.000000', 'temperatura', 720.0000, 'ºC'),
	(169685, 119, '2014-02-01 00:03:59.000000', 'temperatura', 517.0000, 'ºC'),
	(169686, 119, '2014-02-01 00:04:00.000000', 'temperatura', 425.0000, 'ºC'),
	(169687, 119, '2014-02-01 00:04:01.000000', 'temperatura', 574.0000, 'ºC'),
	(169688, 119, '2014-02-01 00:04:02.000000', 'temperatura', 395.0000, 'ºC'),
	(169689, 119, '2014-02-01 00:04:03.000000', 'temperatura', 254.0000, 'ºC'),
	(169690, 119, '2014-02-01 00:04:04.000000', 'temperatura', 87.0000, 'ºC'),
	(169691, 119, '2014-02-01 00:04:05.000000', 'temperatura', 872.0000, 'ºC'),
	(169692, 119, '2014-02-01 00:04:06.000000', 'temperatura', 500.0000, 'ºC'),
	(169693, 119, '2014-02-01 00:04:07.000000', 'temperatura', 1083.0000, 'ºC'),
	(169694, 119, '2014-02-01 00:04:08.000000', 'temperatura', 316.0000, 'ºC'),
	(169695, 119, '2014-02-01 00:04:09.000000', 'temperatura', 733.0000, 'ºC'),
	(169696, 119, '2014-02-01 00:04:10.000000', 'temperatura', 317.0000, 'ºC'),
	(169697, 119, '2014-02-01 00:04:11.000000', 'temperatura', 587.0000, 'ºC'),
	(169698, 119, '2014-02-01 00:04:12.000000', 'temperatura', 785.0000, 'ºC'),
	(169699, 119, '2014-02-01 00:04:13.000000', 'temperatura', 965.0000, 'ºC'),
	(169700, 119, '2014-02-01 00:04:14.000000', 'temperatura', 69.0000, 'ºC'),
	(169701, 119, '2014-02-01 00:04:15.000000', 'temperatura', 1049.0000, 'ºC'),
	(169702, 119, '2014-02-01 00:04:16.000000', 'temperatura', 241.0000, 'ºC'),
	(169703, 119, '2014-02-01 00:04:17.000000', 'temperatura', 459.0000, 'ºC'),
	(169704, 119, '2014-02-01 00:04:18.000000', 'temperatura', 371.0000, 'ºC'),
	(169705, 119, '2014-02-01 00:04:19.000000', 'temperatura', 477.0000, 'ºC'),
	(169706, 119, '2014-02-01 00:04:20.000000', 'temperatura', 74.0000, 'ºC'),
	(169707, 119, '2014-02-01 00:04:21.000000', 'temperatura', 139.0000, 'ºC'),
	(169708, 119, '2014-02-01 00:04:22.000000', 'temperatura', 474.0000, 'ºC'),
	(169709, 119, '2014-02-01 00:04:23.000000', 'temperatura', 752.0000, 'ºC'),
	(169710, 119, '2014-02-01 00:04:24.000000', 'temperatura', 1139.0000, 'ºC'),
	(169711, 119, '2014-02-01 00:04:25.000000', 'temperatura', 1039.0000, 'ºC'),
	(169712, 119, '2014-02-01 00:04:26.000000', 'temperatura', 581.0000, 'ºC'),
	(169713, 119, '2014-02-01 00:04:27.000000', 'temperatura', 986.0000, 'ºC'),
	(169714, 119, '2014-02-01 00:04:28.000000', 'temperatura', 788.0000, 'ºC'),
	(169715, 119, '2014-02-01 00:04:29.000000', 'temperatura', 982.0000, 'ºC'),
	(169716, 119, '2014-02-01 00:04:30.000000', 'temperatura', 145.0000, 'ºC'),
	(169717, 119, '2014-02-01 00:04:31.000000', 'temperatura', 182.0000, 'ºC'),
	(169718, 119, '2014-02-01 00:04:32.000000', 'temperatura', 476.0000, 'ºC'),
	(169719, 119, '2014-02-01 00:04:33.000000', 'temperatura', 636.0000, 'ºC'),
	(169720, 119, '2014-02-01 00:04:34.000000', 'temperatura', 549.0000, 'ºC'),
	(169721, 119, '2014-02-01 00:04:35.000000', 'temperatura', 838.0000, 'ºC'),
	(169722, 119, '2014-02-01 00:04:36.000000', 'temperatura', 144.0000, 'ºC'),
	(169723, 119, '2014-02-01 00:04:37.000000', 'temperatura', 607.0000, 'ºC'),
	(169724, 119, '2014-02-01 00:04:38.000000', 'temperatura', 204.0000, 'ºC'),
	(169725, 119, '2014-02-01 00:04:39.000000', 'temperatura', 399.0000, 'ºC'),
	(169726, 119, '2014-02-01 00:04:40.000000', 'temperatura', 185.0000, 'ºC'),
	(169727, 119, '2014-02-01 00:04:41.000000', 'temperatura', 927.0000, 'ºC'),
	(169728, 119, '2014-02-01 00:04:42.000000', 'temperatura', 479.0000, 'ºC'),
	(169729, 119, '2014-02-01 00:04:43.000000', 'temperatura', 816.0000, 'ºC'),
	(169730, 119, '2014-02-01 00:04:44.000000', 'temperatura', 243.0000, 'ºC'),
	(169731, 119, '2014-02-01 00:04:45.000000', 'temperatura', 1167.0000, 'ºC'),
	(169732, 119, '2014-02-01 00:04:46.000000', 'temperatura', 306.0000, 'ºC'),
	(169733, 119, '2014-02-01 00:04:47.000000', 'temperatura', 432.0000, 'ºC'),
	(169734, 119, '2014-02-01 00:04:48.000000', 'temperatura', 43.0000, 'ºC'),
	(169735, 119, '2014-02-01 00:04:49.000000', 'temperatura', 117.0000, 'ºC'),
	(169736, 119, '2014-02-01 00:04:50.000000', 'temperatura', 456.0000, 'ºC'),
	(169737, 119, '2014-02-01 00:04:51.000000', 'temperatura', 730.0000, 'ºC'),
	(169738, 119, '2014-02-01 00:04:52.000000', 'temperatura', 1085.0000, 'ºC'),
	(169739, 119, '2014-02-01 00:04:53.000000', 'temperatura', 834.0000, 'ºC'),
	(169740, 119, '2014-02-01 00:04:54.000000', 'temperatura', 915.0000, 'ºC'),
	(169741, 119, '2014-02-01 00:04:55.000000', 'temperatura', 872.0000, 'ºC'),
	(169742, 119, '2014-02-01 00:04:56.000000', 'temperatura', 416.0000, 'ºC'),
	(169743, 119, '2014-02-01 00:04:57.000000', 'temperatura', 665.0000, 'ºC'),
	(169744, 119, '2014-02-01 00:04:58.000000', 'temperatura', 877.0000, 'ºC'),
	(169745, 119, '2014-02-01 00:04:59.000000', 'temperatura', 1189.0000, 'ºC'),
	(169746, 119, '2014-02-01 00:05:00.000000', 'temperatura', 917.0000, 'ºC'),
	(169747, 119, '2014-02-01 00:05:01.000000', 'temperatura', 1017.0000, 'ºC'),
	(169748, 119, '2014-02-01 00:05:02.000000', 'temperatura', 1136.0000, 'ºC'),
	(169749, 119, '2014-02-01 00:05:03.000000', 'temperatura', 227.0000, 'ºC'),
	(169750, 119, '2014-02-01 00:05:04.000000', 'temperatura', 128.0000, 'ºC'),
	(169751, 119, '2014-02-01 00:05:05.000000', 'temperatura', 1160.0000, 'ºC'),
	(169752, 119, '2014-02-01 00:05:06.000000', 'temperatura', 617.0000, 'ºC'),
	(169753, 119, '2014-02-01 00:05:07.000000', 'temperatura', 807.0000, 'ºC'),
	(169754, 119, '2014-02-01 00:05:08.000000', 'temperatura', 981.0000, 'ºC'),
	(169755, 119, '2014-02-01 00:05:09.000000', 'temperatura', 88.0000, 'ºC'),
	(169756, 119, '2014-02-01 00:05:10.000000', 'temperatura', 1096.0000, 'ºC'),
	(169757, 119, '2014-02-01 00:05:11.000000', 'temperatura', 415.0000, 'ºC'),
	(169758, 119, '2014-02-01 00:05:12.000000', 'temperatura', 1189.0000, 'ºC'),
	(169759, 119, '2014-02-01 00:05:13.000000', 'temperatura', 1101.0000, 'ºC'),
	(169760, 119, '2014-02-01 00:05:14.000000', 'temperatura', 737.0000, 'ºC'),
	(169761, 119, '2014-02-01 00:05:15.000000', 'temperatura', 385.0000, 'ºC'),
	(169762, 119, '2014-02-01 00:05:16.000000', 'temperatura', 914.0000, 'ºC'),
	(169763, 119, '2014-02-01 00:05:17.000000', 'temperatura', 1016.0000, 'ºC'),
	(169764, 119, '2014-02-01 00:05:18.000000', 'temperatura', 1137.0000, 'ºC'),
	(169765, 119, '2014-02-01 00:05:19.000000', 'temperatura', 236.0000, 'ºC'),
	(169766, 119, '2014-02-01 00:05:20.000000', 'temperatura', 171.0000, 'ºC'),
	(169767, 119, '2014-02-01 00:05:21.000000', 'temperatura', 147.0000, 'ºC'),
	(169768, 119, '2014-02-01 00:05:22.000000', 'temperatura', 224.0000, 'ºC'),
	(169769, 119, '2014-02-01 00:05:23.000000', 'temperatura', 680.0000, 'ºC'),
	(169770, 119, '2014-02-01 00:05:24.000000', 'temperatura', 326.0000, 'ºC'),
	(169771, 119, '2014-02-01 00:05:25.000000', 'temperatura', 793.0000, 'ºC'),
	(169772, 119, '2014-02-01 00:05:26.000000', 'temperatura', 586.0000, 'ºC'),
	(169773, 119, '2014-02-01 00:05:27.000000', 'temperatura', 554.0000, 'ºC'),
	(169774, 119, '2014-02-01 00:05:28.000000', 'temperatura', 1009.0000, 'ºC'),
	(169775, 119, '2014-02-01 00:05:29.000000', 'temperatura', 986.0000, 'ºC'),
	(169776, 119, '2014-02-01 00:05:30.000000', 'temperatura', 702.0000, 'ºC'),
	(169777, 119, '2014-02-01 00:05:31.000000', 'temperatura', 555.0000, 'ºC'),
	(169778, 119, '2014-02-01 00:05:32.000000', 'temperatura', 667.0000, 'ºC'),
	(169779, 119, '2014-02-01 00:05:33.000000', 'temperatura', 473.0000, 'ºC'),
	(169780, 119, '2014-02-01 00:05:34.000000', 'temperatura', 363.0000, 'ºC'),
	(169781, 119, '2014-02-01 00:05:35.000000', 'temperatura', 396.0000, 'ºC'),
	(169782, 119, '2014-02-01 00:05:36.000000', 'temperatura', 890.0000, 'ºC'),
	(169783, 119, '2014-02-01 00:05:37.000000', 'temperatura', 864.0000, 'ºC'),
	(169784, 119, '2014-02-01 00:05:38.000000', 'temperatura', 450.0000, 'ºC'),
	(169785, 119, '2014-02-01 00:05:39.000000', 'temperatura', 859.0000, 'ºC'),
	(169786, 119, '2014-02-01 00:05:40.000000', 'temperatura', 548.0000, 'ºC'),
	(169787, 119, '2014-02-01 00:05:41.000000', 'temperatura', 160.0000, 'ºC'),
	(169788, 119, '2014-02-01 00:05:42.000000', 'temperatura', 356.0000, 'ºC'),
	(169789, 119, '2014-02-01 00:05:43.000000', 'temperatura', 100.0000, 'ºC'),
	(169790, 119, '2014-02-01 00:05:44.000000', 'temperatura', 632.0000, 'ºC'),
	(169791, 119, '2014-02-01 00:05:45.000000', 'temperatura', 463.0000, 'ºC'),
	(169792, 119, '2014-02-01 00:05:46.000000', 'temperatura', 417.0000, 'ºC'),
	(169793, 119, '2014-02-01 00:05:47.000000', 'temperatura', 699.0000, 'ºC'),
	(169794, 119, '2014-02-01 00:05:48.000000', 'temperatura', 1042.0000, 'ºC'),
	(169795, 119, '2014-02-01 00:05:49.000000', 'temperatura', 713.0000, 'ºC'),
	(169796, 119, '2014-02-01 00:05:50.000000', 'temperatura', 439.0000, 'ºC'),
	(169797, 119, '2014-02-01 00:05:51.000000', 'temperatura', 56.0000, 'ºC'),
	(169798, 119, '2014-02-01 00:05:52.000000', 'temperatura', 163.0000, 'ºC'),
	(169799, 119, '2014-02-01 00:05:53.000000', 'temperatura', 647.0000, 'ºC'),
	(169800, 119, '2014-02-01 00:05:54.000000', 'temperatura', 347.0000, 'ºC'),
	(169801, 119, '2014-02-01 00:05:55.000000', 'temperatura', 996.0000, 'ºC'),
	(169802, 119, '2014-02-01 00:05:56.000000', 'temperatura', 337.0000, 'ºC'),
	(169803, 119, '2014-02-01 00:05:57.000000', 'temperatura', 1099.0000, 'ºC'),
	(169804, 119, '2014-02-01 00:05:58.000000', 'temperatura', 884.0000, 'ºC'),
	(169805, 119, '2014-02-01 00:05:59.000000', 'temperatura', 1122.0000, 'ºC'),
	(169806, 119, '2014-02-01 00:06:00.000000', 'temperatura', 559.0000, 'ºC'),
	(169807, 119, '2014-02-01 00:06:01.000000', 'temperatura', 631.0000, 'ºC'),
	(169808, 119, '2014-02-01 00:06:02.000000', 'temperatura', 278.0000, 'ºC'),
	(169809, 119, '2014-02-01 00:06:03.000000', 'temperatura', 696.0000, 'ºC'),
	(169810, 119, '2014-02-01 00:06:04.000000', 'temperatura', 250.0000, 'ºC'),
	(169811, 119, '2014-02-01 00:06:05.000000', 'temperatura', 359.0000, 'ºC'),
	(169812, 119, '2014-02-01 00:06:06.000000', 'temperatura', 1046.0000, 'ºC'),
	(169813, 119, '2014-02-01 00:06:07.000000', 'temperatura', 553.0000, 'ºC'),
	(169814, 119, '2014-02-01 00:06:08.000000', 'temperatura', 830.0000, 'ºC'),
	(169815, 119, '2014-02-01 00:06:09.000000', 'temperatura', 90.0000, 'ºC'),
	(169816, 119, '2014-02-01 00:06:10.000000', 'temperatura', 361.0000, 'ºC'),
	(169817, 119, '2014-02-01 00:06:11.000000', 'temperatura', 337.0000, 'ºC'),
	(169818, 119, '2014-02-01 00:06:12.000000', 'temperatura', 601.0000, 'ºC'),
	(169819, 119, '2014-02-01 00:06:13.000000', 'temperatura', 793.0000, 'ºC'),
	(169820, 119, '2014-02-01 00:06:14.000000', 'temperatura', 963.0000, 'ºC'),
	(169821, 119, '2014-02-01 00:06:15.000000', 'temperatura', 37.0000, 'ºC'),
	(169822, 119, '2014-02-01 00:06:16.000000', 'temperatura', 896.0000, 'ºC'),
	(169823, 119, '2014-02-01 00:06:17.000000', 'temperatura', 771.0000, 'ºC'),
	(169824, 119, '2014-02-01 00:06:18.000000', 'temperatura', 1166.0000, 'ºC'),
	(169825, 119, '2014-02-01 00:06:19.000000', 'temperatura', 1119.0000, 'ºC'),
	(169826, 119, '2014-02-01 00:06:20.000000', 'temperatura', 896.0000, 'ºC'),
	(169827, 119, '2014-02-01 00:06:21.000000', 'temperatura', 1125.0000, 'ºC'),
	(169828, 119, '2014-02-01 00:06:22.000000', 'temperatura', 535.0000, 'ºC'),
	(169829, 119, '2014-02-01 00:06:23.000000', 'temperatura', 503.0000, 'ºC'),
	(169830, 119, '2014-02-01 00:06:24.000000', 'temperatura', 909.0000, 'ºC'),
	(169831, 119, '2014-02-01 00:06:25.000000', 'temperatura', 636.0000, 'ºC'),
	(169832, 119, '2014-02-01 00:06:26.000000', 'temperatura', 453.0000, 'ºC'),
	(169833, 119, '2014-02-01 00:06:27.000000', 'temperatura', 360.0000, 'ºC'),
	(169834, 119, '2014-02-01 00:06:28.000000', 'temperatura', 441.0000, 'ºC'),
	(169835, 119, '2014-02-01 00:06:29.000000', 'temperatura', 1127.0000, 'ºC'),
	(169836, 119, '2014-02-01 00:06:30.000000', 'temperatura', 710.0000, 'ºC'),
	(169837, 119, '2014-02-01 00:06:31.000000', 'temperatura', 171.0000, 'ºC'),
	(169838, 119, '2014-02-01 00:06:32.000000', 'temperatura', 1125.0000, 'ºC'),
	(169839, 119, '2014-02-01 00:06:33.000000', 'temperatura', 311.0000, 'ºC'),
	(169840, 119, '2014-02-01 00:06:34.000000', 'temperatura', 581.0000, 'ºC'),
	(169841, 119, '2014-02-01 00:06:35.000000', 'temperatura', 771.0000, 'ºC'),
	(169842, 119, '2014-02-01 00:06:36.000000', 'temperatura', 913.0000, 'ºC'),
	(169843, 119, '2014-02-01 00:06:37.000000', 'temperatura', 1055.0000, 'ºC'),
	(169844, 119, '2014-02-01 00:06:38.000000', 'temperatura', 136.0000, 'ºC'),
	(169845, 119, '2014-02-01 00:06:39.000000', 'temperatura', 1115.0000, 'ºC'),
	(169846, 119, '2014-02-01 00:06:40.000000', 'temperatura', 366.0000, 'ºC'),
	(169847, 119, '2014-02-01 00:06:41.000000', 'temperatura', 888.0000, 'ºC'),
	(169848, 119, '2014-02-01 00:06:42.000000', 'temperatura', 941.0000, 'ºC'),
	(169849, 119, '2014-02-01 00:06:43.000000', 'temperatura', 843.0000, 'ºC'),
	(169850, 119, '2014-02-01 00:06:44.000000', 'temperatura', 192.0000, 'ºC'),
	(169851, 119, '2014-02-01 00:06:45.000000', 'temperatura', 831.0000, 'ºC'),
	(169852, 119, '2014-02-01 00:06:46.000000', 'temperatura', 1179.0000, 'ºC'),
	(169853, 119, '2014-02-01 00:06:47.000000', 'temperatura', 1004.0000, 'ºC'),
	(169854, 119, '2014-02-01 00:06:48.000000', 'temperatura', 283.0000, 'ºC'),
	(169855, 119, '2014-02-01 00:06:49.000000', 'temperatura', 804.0000, 'ºC'),
	(169856, 119, '2014-02-01 00:06:50.000000', 'temperatura', 771.0000, 'ºC'),
	(169857, 119, '2014-02-01 00:06:51.000000', 'temperatura', 245.0000, 'ºC'),
	(169858, 119, '2014-02-01 00:06:52.000000', 'temperatura', 110.0000, 'ºC'),
	(169859, 119, '2014-02-01 00:06:53.000000', 'temperatura', 1017.0000, 'ºC'),
	(169860, 119, '2014-02-01 00:06:54.000000', 'temperatura', 1155.0000, 'ºC'),
	(169861, 119, '2014-02-01 00:06:55.000000', 'temperatura', 325.0000, 'ºC'),
	(169862, 119, '2014-02-01 00:06:56.000000', 'temperatura', 558.0000, 'ºC'),
	(169863, 119, '2014-02-01 00:06:57.000000', 'temperatura', 618.0000, 'ºC'),
	(169864, 119, '2014-02-01 00:06:58.000000', 'temperatura', 214.0000, 'ºC'),
	(169865, 119, '2014-02-01 00:06:59.000000', 'temperatura', 418.0000, 'ºC'),
	(169866, 119, '2014-02-01 00:07:00.000000', 'temperatura', 248.0000, 'ºC'),
	(169867, 119, '2014-02-01 00:07:01.000000', 'temperatura', 1186.0000, 'ºC'),
	(169868, 119, '2014-02-01 00:07:02.000000', 'temperatura', 385.0000, 'ºC'),
	(169869, 119, '2014-02-01 00:07:03.000000', 'temperatura', 770.0000, 'ºC'),
	(169870, 119, '2014-02-01 00:07:04.000000', 'temperatura', 293.0000, 'ºC'),
	(169871, 119, '2014-02-01 00:07:05.000000', 'temperatura', 358.0000, 'ºC'),
	(169872, 119, '2014-02-01 00:07:06.000000', 'temperatura', 911.0000, 'ºC'),
	(169873, 119, '2014-02-01 00:07:07.000000', 'temperatura', 1081.0000, 'ºC'),
	(169874, 119, '2014-02-01 00:07:08.000000', 'temperatura', 272.0000, 'ºC'),
	(169875, 119, '2014-02-01 00:07:09.000000', 'temperatura', 520.0000, 'ºC'),
	(169876, 119, '2014-02-01 00:07:10.000000', 'temperatura', 582.0000, 'ºC'),
	(169877, 119, '2014-02-01 00:07:11.000000', 'temperatura', 151.0000, 'ºC'),
	(169878, 119, '2014-02-01 00:07:12.000000', 'temperatura', 210.0000, 'ºC'),
	(169879, 119, '2014-02-01 00:07:13.000000', 'temperatura', 597.0000, 'ºC'),
	(169880, 119, '2014-02-01 00:07:14.000000', 'temperatura', 1157.0000, 'ºC'),
	(169881, 119, '2014-02-01 00:07:15.000000', 'temperatura', 395.0000, 'ºC'),
	(169882, 119, '2014-02-01 00:07:16.000000', 'temperatura', 902.0000, 'ºC'),
	(169883, 119, '2014-02-01 00:07:17.000000', 'temperatura', 927.0000, 'ºC'),
	(169884, 119, '2014-02-01 00:07:18.000000', 'temperatura', 730.0000, 'ºC'),
	(169885, 119, '2014-02-01 00:07:19.000000', 'temperatura', 867.0000, 'ºC'),
	(169886, 119, '2014-02-01 00:07:20.000000', 'temperatura', 949.0000, 'ºC'),
	(169887, 119, '2014-02-01 00:07:21.000000', 'temperatura', 942.0000, 'ºC'),
	(169888, 119, '2014-02-01 00:07:22.000000', 'temperatura', 662.0000, 'ºC'),
	(169889, 119, '2014-02-01 00:07:23.000000', 'temperatura', 486.0000, 'ºC'),
	(169890, 119, '2014-02-01 00:07:24.000000', 'temperatura', 446.0000, 'ºC'),
	(169891, 119, '2014-02-01 00:07:25.000000', 'temperatura', 772.0000, 'ºC'),
	(169892, 119, '2014-02-01 00:07:26.000000', 'temperatura', 121.0000, 'ºC'),
	(169893, 119, '2014-02-01 00:07:27.000000', 'temperatura', 690.0000, 'ºC'),
	(169894, 119, '2014-02-01 00:07:28.000000', 'temperatura', 687.0000, 'ºC'),
	(169895, 119, '2014-02-01 00:07:29.000000', 'temperatura', 164.0000, 'ºC'),
	(169896, 119, '2014-02-01 00:07:30.000000', 'temperatura', 1163.0000, 'ºC'),
	(169897, 119, '2014-02-01 00:07:31.000000', 'temperatura', 522.0000, 'ºC'),
	(169898, 119, '2014-02-01 00:07:32.000000', 'temperatura', 321.0000, 'ºC'),
	(169899, 119, '2014-02-01 00:07:33.000000', 'temperatura', 39.0000, 'ºC'),
	(169900, 119, '2014-02-01 00:07:34.000000', 'temperatura', 431.0000, 'ºC'),
	(169901, 119, '2014-02-01 00:07:35.000000', 'temperatura', 840.0000, 'ºC'),
	(169902, 119, '2014-02-01 00:07:36.000000', 'temperatura', 508.0000, 'ºC'),
	(169903, 119, '2014-02-01 00:07:37.000000', 'temperatura', 20.0000, 'ºC'),
	(169904, 119, '2014-02-01 00:07:38.000000', 'temperatura', 978.0000, 'ºC'),
	(169905, 119, '2014-02-01 00:07:39.000000', 'temperatura', 28.0000, 'ºC'),
	(169906, 119, '2014-02-01 00:07:40.000000', 'temperatura', 809.0000, 'ºC'),
	(169907, 119, '2014-02-01 00:07:41.000000', 'temperatura', 361.0000, 'ºC'),
	(169908, 119, '2014-02-01 00:07:42.000000', 'temperatura', 579.0000, 'ºC'),
	(169909, 119, '2014-02-01 00:07:43.000000', 'temperatura', 611.0000, 'ºC'),
	(169910, 119, '2014-02-01 00:07:44.000000', 'temperatura', 118.0000, 'ºC'),
	(169911, 119, '2014-02-01 00:07:45.000000', 'temperatura', 1157.0000, 'ºC'),
	(169912, 119, '2014-02-01 00:07:46.000000', 'temperatura', 631.0000, 'ºC'),
	(169913, 119, '2014-02-01 00:07:47.000000', 'temperatura', 886.0000, 'ºC'),
	(169914, 119, '2014-02-01 00:07:48.000000', 'temperatura', 139.0000, 'ºC'),
	(169915, 119, '2014-02-01 00:07:49.000000', 'temperatura', 437.0000, 'ºC'),
	(169916, 119, '2014-02-01 00:07:50.000000', 'temperatura', 567.0000, 'ºC'),
	(169917, 119, '2014-02-01 00:07:51.000000', 'temperatura', 325.0000, 'ºC'),
	(169918, 119, '2014-02-01 00:07:52.000000', 'temperatura', 1123.0000, 'ºC'),
	(169919, 119, '2014-02-01 00:07:53.000000', 'temperatura', 1040.0000, 'ºC'),
	(169920, 119, '2014-02-01 00:07:54.000000', 'temperatura', 631.0000, 'ºC'),
	(169921, 119, '2014-02-01 00:07:55.000000', 'temperatura', 36.0000, 'ºC'),
	(169922, 119, '2014-02-01 00:07:56.000000', 'temperatura', 687.0000, 'ºC'),
	(169923, 119, '2014-02-01 00:07:57.000000', 'temperatura', 927.0000, 'ºC'),
	(169924, 119, '2014-02-01 00:07:58.000000', 'temperatura', 176.0000, 'ºC'),
	(169925, 119, '2014-02-01 00:07:59.000000', 'temperatura', 501.0000, 'ºC'),
	(169926, 119, '2014-02-01 00:08:00.000000', 'temperatura', 775.0000, 'ºC'),
	(169927, 119, '2014-02-01 00:08:01.000000', 'temperatura', 1171.0000, 'ºC'),
	(169928, 119, '2014-02-01 00:08:02.000000', 'temperatura', 1134.0000, 'ºC'),
	(169929, 119, '2014-02-01 00:08:03.000000', 'temperatura', 955.0000, 'ºC'),
	(169930, 119, '2014-02-01 00:08:04.000000', 'temperatura', 173.0000, 'ºC'),
	(169931, 119, '2014-02-01 00:08:05.000000', 'temperatura', 403.0000, 'ºC'),
	(169932, 119, '2014-02-01 00:08:06.000000', 'temperatura', 294.0000, 'ºC'),
	(169933, 119, '2014-02-01 00:08:07.000000', 'temperatura', 262.0000, 'ºC'),
	(169934, 119, '2014-02-01 00:08:08.000000', 'temperatura', 430.0000, 'ºC'),
	(169935, 119, '2014-02-01 00:08:09.000000', 'temperatura', 162.0000, 'ºC'),
	(169936, 119, '2014-02-01 00:08:10.000000', 'temperatura', 724.0000, 'ºC'),
	(169937, 119, '2014-02-01 00:08:11.000000', 'temperatura', 731.0000, 'ºC'),
	(169938, 119, '2014-02-01 00:08:12.000000', 'temperatura', 284.0000, 'ºC'),
	(169939, 119, '2014-02-01 00:08:13.000000', 'temperatura', 427.0000, 'ºC'),
	(169940, 119, '2014-02-01 00:08:14.000000', 'temperatura', 85.0000, 'ºC'),
	(169941, 119, '2014-02-01 00:08:15.000000', 'temperatura', 345.0000, 'ºC'),
	(169942, 119, '2014-02-01 00:08:16.000000', 'temperatura', 271.0000, 'ºC'),
	(169943, 119, '2014-02-01 00:08:17.000000', 'temperatura', 322.0000, 'ºC'),
	(169944, 119, '2014-02-01 00:08:18.000000', 'temperatura', 794.0000, 'ºC'),
	(169945, 119, '2014-02-01 00:08:19.000000', 'temperatura', 605.0000, 'ºC'),
	(169946, 119, '2014-02-01 00:08:20.000000', 'temperatura', 644.0000, 'ºC'),
	(169947, 119, '2014-02-01 00:08:21.000000', 'temperatura', 204.0000, 'ºC'),
	(169948, 119, '2014-02-01 00:08:22.000000', 'temperatura', 288.0000, 'ºC'),
	(169949, 119, '2014-02-01 00:08:23.000000', 'temperatura', 830.0000, 'ºC'),
	(169950, 119, '2014-02-01 00:08:24.000000', 'temperatura', 887.0000, 'ºC'),
	(169951, 119, '2014-02-01 00:08:25.000000', 'temperatura', 744.0000, 'ºC'),
	(169952, 119, '2014-02-01 00:08:26.000000', 'temperatura', 1060.0000, 'ºC'),
	(169953, 119, '2014-02-01 00:08:27.000000', 'temperatura', 667.0000, 'ºC'),
	(169954, 119, '2014-02-01 00:08:28.000000', 'temperatura', 155.0000, 'ºC'),
	(169955, 119, '2014-02-01 00:08:29.000000', 'temperatura', 1176.0000, 'ºC'),
	(169956, 119, '2014-02-01 00:08:30.000000', 'temperatura', 617.0000, 'ºC'),
	(169957, 119, '2014-02-01 00:08:31.000000', 'temperatura', 757.0000, 'ºC'),
	(169958, 119, '2014-02-01 00:08:32.000000', 'temperatura', 735.0000, 'ºC'),
	(169959, 119, '2014-02-01 00:08:33.000000', 'temperatura', 202.0000, 'ºC'),
	(169960, 119, '2014-02-01 00:08:34.000000', 'temperatura', 6.0000, 'ºC'),
	(169961, 119, '2014-02-01 00:08:35.000000', 'temperatura', 624.0000, 'ºC'),
	(169962, 119, '2014-02-01 00:08:36.000000', 'temperatura', 701.0000, 'ºC'),
	(169963, 119, '2014-02-01 00:08:37.000000', 'temperatura', 436.0000, 'ºC'),
	(169964, 119, '2014-02-01 00:08:38.000000', 'temperatura', 75.0000, 'ºC'),
	(169965, 119, '2014-02-01 00:08:39.000000', 'temperatura', 269.0000, 'ºC'),
	(169966, 119, '2014-02-01 00:08:40.000000', 'temperatura', 1122.0000, 'ºC'),
	(169967, 119, '2014-02-01 00:08:41.000000', 'temperatura', 2.0000, 'ºC'),
	(169968, 119, '2014-02-01 00:08:42.000000', 'temperatura', 244.0000, 'ºC'),
	(169969, 119, '2014-02-01 00:08:43.000000', 'temperatura', 14.0000, 'ºC'),
	(169970, 119, '2014-02-01 00:08:44.000000', 'temperatura', 540.0000, 'ºC'),
	(169971, 119, '2014-02-01 00:08:45.000000', 'temperatura', 260.0000, 'ºC'),
	(169972, 119, '2014-02-01 00:08:46.000000', 'temperatura', 878.0000, 'ºC'),
	(169973, 119, '2014-02-01 00:08:47.000000', 'temperatura', 13.0000, 'ºC'),
	(169974, 119, '2014-02-01 00:08:48.000000', 'temperatura', 1029.0000, 'ºC'),
	(169975, 119, '2014-02-01 00:08:49.000000', 'temperatura', 308.0000, 'ºC'),
	(169976, 119, '2014-02-01 00:08:50.000000', 'temperatura', 852.0000, 'ºC'),
	(169977, 119, '2014-02-01 00:08:51.000000', 'temperatura', 939.0000, 'ºC'),
	(169978, 119, '2014-02-01 00:08:52.000000', 'temperatura', 937.0000, 'ºC'),
	(169979, 119, '2014-02-01 00:08:53.000000', 'temperatura', 670.0000, 'ºC'),
	(169980, 119, '2014-02-01 00:08:54.000000', 'temperatura', 538.0000, 'ºC'),
	(169981, 119, '2014-02-01 00:08:55.000000', 'temperatura', 680.0000, 'ºC'),
	(169982, 119, '2014-02-01 00:08:56.000000', 'temperatura', 587.0000, 'ºC'),
	(169983, 119, '2014-02-01 00:08:57.000000', 'temperatura', 894.0000, 'ºC'),
	(169984, 119, '2014-02-01 00:08:58.000000', 'temperatura', 311.0000, 'ºC'),
	(169985, 119, '2014-02-01 00:08:59.000000', 'temperatura', 75.0000, 'ºC'),
	(169986, 119, '2014-02-01 00:09:00.000000', 'temperatura', 641.0000, 'ºC'),
	(169987, 119, '2014-02-01 00:09:01.000000', 'temperatura', 582.0000, 'ºC'),
	(169988, 119, '2014-02-01 00:09:02.000000', 'temperatura', 987.0000, 'ºC'),
	(169989, 119, '2014-02-01 00:09:03.000000', 'temperatura', 789.0000, 'ºC'),
	(169990, 119, '2014-02-01 00:09:04.000000', 'temperatura', 984.0000, 'ºC'),
	(169991, 119, '2014-02-01 00:09:05.000000', 'temperatura', 154.0000, 'ºC'),
	(169992, 119, '2014-02-01 00:09:06.000000', 'temperatura', 220.0000, 'ºC'),
	(169993, 119, '2014-02-01 00:09:07.000000', 'temperatura', 637.0000, 'ºC'),
	(169994, 119, '2014-02-01 00:09:08.000000', 'temperatura', 127.0000, 'ºC'),
	(169995, 119, '2014-02-01 00:09:09.000000', 'temperatura', 1125.0000, 'ºC'),
	(169996, 119, '2014-02-01 00:09:10.000000', 'temperatura', 442.0000, 'ºC'),
	(169997, 119, '2014-02-01 00:09:11.000000', 'temperatura', 35.0000, 'ºC'),
	(169998, 119, '2014-02-01 00:09:12.000000', 'temperatura', 51.0000, 'ºC'),
	(169999, 119, '2014-02-01 00:09:13.000000', 'temperatura', 151.0000, 'ºC'),
	(170000, 119, '2014-02-01 00:09:14.000000', 'temperatura', 602.0000, 'ºC'),
	(170001, 119, '2014-02-01 00:09:15.000000', 'temperatura', 157.0000, 'ºC'),
	(170002, 119, '2014-02-01 00:09:16.000000', 'temperatura', 180.0000, 'ºC'),
	(170003, 119, '2014-02-01 00:09:17.000000', 'temperatura', 428.0000, 'ºC'),
	(170004, 119, '2014-02-01 00:09:18.000000', 'temperatura', 399.0000, 'ºC'),
	(170005, 119, '2014-02-01 00:09:19.000000', 'temperatura', 715.0000, 'ºC'),
	(170006, 119, '2014-02-01 00:09:20.000000', 'temperatura', 1178.0000, 'ºC'),
	(170007, 119, '2014-02-01 00:09:21.000000', 'temperatura', 145.0000, 'ºC'),
	(170008, 119, '2014-02-01 00:09:22.000000', 'temperatura', 792.0000, 'ºC'),
	(170009, 119, '2014-02-01 00:09:23.000000', 'temperatura', 1124.0000, 'ºC'),
	(170010, 119, '2014-02-01 00:09:24.000000', 'temperatura', 846.0000, 'ºC'),
	(170011, 119, '2014-02-01 00:09:25.000000', 'temperatura', 860.0000, 'ºC'),
	(170012, 119, '2014-02-01 00:09:26.000000', 'temperatura', 561.0000, 'ºC'),
	(170013, 119, '2014-02-01 00:09:27.000000', 'temperatura', 224.0000, 'ºC'),
	(170014, 119, '2014-02-01 00:09:28.000000', 'temperatura', 638.0000, 'ºC'),
	(170015, 119, '2014-02-01 00:09:29.000000', 'temperatura', 120.0000, 'ºC'),
	(170016, 119, '2014-02-01 00:09:30.000000', 'temperatura', 1084.0000, 'ºC'),
	(170017, 119, '2014-02-01 00:09:31.000000', 'temperatura', 261.0000, 'ºC'),
	(170018, 119, '2014-02-01 00:09:32.000000', 'temperatura', 454.0000, 'ºC'),
	(170019, 119, '2014-02-01 00:09:33.000000', 'temperatura', 287.0000, 'ºC'),
	(170020, 119, '2014-02-01 00:09:34.000000', 'temperatura', 75.0000, 'ºC'),
	(170021, 119, '2014-02-01 00:09:35.000000', 'temperatura', 715.0000, 'ºC'),
	(170022, 119, '2014-02-01 00:09:36.000000', 'temperatura', 952.0000, 'ºC'),
	(170023, 119, '2014-02-01 00:09:37.000000', 'temperatura', 212.0000, 'ºC'),
	(170024, 119, '2014-02-01 00:09:38.000000', 'temperatura', 606.0000, 'ºC'),
	(170025, 119, '2014-02-01 00:09:39.000000', 'temperatura', 1194.0000, 'ºC'),
	(170026, 119, '2014-02-01 00:09:40.000000', 'temperatura', 553.0000, 'ºC'),
	(170027, 119, '2014-02-01 00:09:41.000000', 'temperatura', 382.0000, 'ºC'),
	(170028, 119, '2014-02-01 00:09:42.000000', 'temperatura', 252.0000, 'ºC'),
	(170029, 119, '2014-02-01 00:09:43.000000', 'temperatura', 116.0000, 'ºC'),
	(170030, 119, '2014-02-01 00:09:44.000000', 'temperatura', 1023.0000, 'ºC'),
	(170031, 119, '2014-02-01 00:09:45.000000', 'temperatura', 1167.0000, 'ºC'),
	(170032, 119, '2014-02-01 00:09:46.000000', 'temperatura', 367.0000, 'ºC'),
	(170033, 119, '2014-02-01 00:09:47.000000', 'temperatura', 736.0000, 'ºC'),
	(170034, 119, '2014-02-01 00:09:48.000000', 'temperatura', 181.0000, 'ºC'),
	(170035, 119, '2014-02-01 00:09:49.000000', 'temperatura', 1094.0000, 'ºC'),
	(170036, 119, '2014-02-01 00:09:50.000000', 'temperatura', 130.0000, 'ºC'),
	(170037, 119, '2014-02-01 00:09:51.000000', 'temperatura', 967.0000, 'ºC'),
	(170038, 119, '2014-02-01 00:09:52.000000', 'temperatura', 844.0000, 'ºC'),
	(170039, 119, '2014-02-01 00:09:53.000000', 'temperatura', 121.0000, 'ºC'),
	(170040, 119, '2014-02-01 00:09:54.000000', 'temperatura', 475.0000, 'ºC'),
	(170041, 119, '2014-02-01 00:09:55.000000', 'temperatura', 811.0000, 'ºC'),
	(170042, 119, '2014-02-01 00:09:56.000000', 'temperatura', 232.0000, 'ºC'),
	(170043, 119, '2014-02-01 00:09:57.000000', 'temperatura', 1125.0000, 'ºC'),
	(170044, 119, '2014-02-01 00:09:58.000000', 'temperatura', 132.0000, 'ºC'),
	(170045, 119, '2014-02-01 00:09:59.000000', 'temperatura', 884.0000, 'ºC'),
	(170046, 119, '2014-02-01 00:10:00.000000', 'temperatura', 426.0000, 'ºC'),
	(170047, 119, '2014-02-01 00:10:01.000000', 'temperatura', 679.0000, 'ºC'),
	(170048, 119, '2014-02-01 00:10:02.000000', 'temperatura', 918.0000, 'ºC'),
	(170049, 119, '2014-02-01 00:10:03.000000', 'temperatura', 153.0000, 'ºC'),
	(170050, 119, '2014-02-01 00:10:04.000000', 'temperatura', 411.0000, 'ºC'),
	(170051, 119, '2014-02-01 00:10:05.000000', 'temperatura', 397.0000, 'ºC'),
	(170052, 119, '2014-02-01 00:10:06.000000', 'temperatura', 751.0000, 'ºC'),
	(170053, 119, '2014-02-01 00:10:07.000000', 'temperatura', 165.0000, 'ºC'),
	(170054, 119, '2014-02-01 00:10:08.000000', 'temperatura', 972.0000, 'ºC'),
	(170055, 119, '2014-02-01 00:10:09.000000', 'temperatura', 767.0000, 'ºC'),
	(170056, 119, '2014-02-01 00:10:10.000000', 'temperatura', 919.0000, 'ºC'),
	(170057, 119, '2014-02-01 00:10:11.000000', 'temperatura', 1096.0000, 'ºC'),
	(170058, 119, '2014-02-01 00:10:12.000000', 'temperatura', 322.0000, 'ºC'),
	(170059, 119, '2014-02-01 00:10:13.000000', 'temperatura', 721.0000, 'ºC'),
	(170060, 119, '2014-02-01 00:10:14.000000', 'temperatura', 240.0000, 'ºC'),
	(170061, 119, '2014-02-01 00:10:15.000000', 'temperatura', 240.0000, 'ºC'),
	(170062, 119, '2014-02-01 00:10:16.000000', 'temperatura', 478.0000, 'ºC'),
	(170063, 119, '2014-02-01 00:10:17.000000', 'temperatura', 470.0000, 'ºC'),
	(170064, 119, '2014-02-01 00:10:18.000000', 'temperatura', 916.0000, 'ºC'),
	(170065, 119, '2014-02-01 00:10:19.000000', 'temperatura', 771.0000, 'ºC'),
	(170066, 119, '2014-02-01 00:10:20.000000', 'temperatura', 1110.0000, 'ºC'),
	(170067, 119, '2014-02-01 00:10:21.000000', 'temperatura', 834.0000, 'ºC'),
	(170068, 119, '2014-02-01 00:10:22.000000', 'temperatura', 841.0000, 'ºC'),
	(170069, 119, '2014-02-01 00:10:23.000000', 'temperatura', 505.0000, 'ºC'),
	(170070, 119, '2014-02-01 00:10:24.000000', 'temperatura', 4.0000, 'ºC'),
	(170071, 119, '2014-02-01 00:10:25.000000', 'temperatura', 902.0000, 'ºC'),
	(170072, 119, '2014-02-01 00:10:26.000000', 'temperatura', 899.0000, 'ºC'),
	(170073, 119, '2014-02-01 00:10:27.000000', 'temperatura', 592.0000, 'ºC'),
	(170074, 119, '2014-02-01 00:10:28.000000', 'temperatura', 262.0000, 'ºC'),
	(170075, 119, '2014-02-01 00:10:29.000000', 'temperatura', 737.0000, 'ºC'),
	(170076, 119, '2014-02-01 00:10:30.000000', 'temperatura', 496.0000, 'ºC'),
	(170077, 119, '2014-02-01 00:10:31.000000', 'temperatura', 273.0000, 'ºC'),
	(170078, 119, '2014-02-01 00:10:32.000000', 'temperatura', 1075.0000, 'ºC'),
	(170079, 119, '2014-02-01 00:10:33.000000', 'temperatura', 957.0000, 'ºC'),
	(170080, 119, '2014-02-01 00:10:34.000000', 'temperatura', 359.0000, 'ºC'),
	(170081, 119, '2014-02-01 00:10:35.000000', 'temperatura', 128.0000, 'ºC'),
	(170082, 119, '2014-02-01 00:10:36.000000', 'temperatura', 760.0000, 'ºC'),
	(170083, 119, '2014-02-01 00:10:37.000000', 'temperatura', 1018.0000, 'ºC'),
	(170084, 119, '2014-02-01 00:10:38.000000', 'temperatura', 410.0000, 'ºC'),
	(170085, 119, '2014-02-01 00:10:39.000000', 'temperatura', 196.0000, 'ºC'),
	(170086, 119, '2014-02-01 00:10:40.000000', 'temperatura', 951.0000, 'ºC'),
	(170087, 119, '2014-02-01 00:10:41.000000', 'temperatura', 570.0000, 'ºC'),
	(170088, 119, '2014-02-01 00:10:42.000000', 'temperatura', 1194.0000, 'ºC'),
	(170089, 119, '2014-02-01 00:10:43.000000', 'temperatura', 661.0000, 'ºC'),
	(170090, 119, '2014-02-01 00:10:44.000000', 'temperatura', 923.0000, 'ºC'),
	(170091, 119, '2014-02-01 00:10:45.000000', 'temperatura', 234.0000, 'ºC'),
	(170092, 119, '2014-02-01 00:10:46.000000', 'temperatura', 802.0000, 'ºC'),
	(170093, 119, '2014-02-01 00:10:47.000000', 'temperatura', 909.0000, 'ºC'),
	(170094, 119, '2014-02-01 00:10:48.000000', 'temperatura', 939.0000, 'ºC'),
	(170095, 119, '2014-02-01 00:10:49.000000', 'temperatura', 768.0000, 'ºC'),
	(170096, 119, '2014-02-01 00:10:50.000000', 'temperatura', 1022.0000, 'ºC'),
	(170097, 119, '2014-02-01 00:10:51.000000', 'temperatura', 406.0000, 'ºC'),
	(170098, 119, '2014-02-01 00:10:52.000000', 'temperatura', 164.0000, 'ºC'),
	(170099, 119, '2014-02-01 00:10:53.000000', 'temperatura', 804.0000, 'ºC'),
	(170100, 119, '2014-02-01 00:10:54.000000', 'temperatura', 1127.0000, 'ºC'),
	(170101, 119, '2014-02-01 00:10:55.000000', 'temperatura', 826.0000, 'ºC'),
	(170102, 119, '2014-02-01 00:10:56.000000', 'temperatura', 749.0000, 'ºC'),
	(170103, 119, '2014-02-01 00:10:57.000000', 'temperatura', 69.0000, 'ºC'),
	(170104, 119, '2014-02-01 00:10:58.000000', 'temperatura', 496.0000, 'ºC'),
	(170105, 119, '2014-02-01 00:10:59.000000', 'temperatura', 1074.0000, 'ºC'),
	(170106, 119, '2014-02-01 00:11:00.000000', 'temperatura', 285.0000, 'ºC'),
	(170107, 119, '2014-02-01 00:11:01.000000', 'temperatura', 601.0000, 'ºC'),
	(170108, 119, '2014-02-01 00:11:02.000000', 'temperatura', 950.0000, 'ºC'),
	(170109, 119, '2014-02-01 00:11:03.000000', 'temperatura', 548.0000, 'ºC'),
	(170110, 119, '2014-02-01 00:11:04.000000', 'temperatura', 1090.0000, 'ºC'),
	(170111, 119, '2014-02-01 00:11:05.000000', 'temperatura', 209.0000, 'ºC'),
	(170112, 119, '2014-02-01 00:11:06.000000', 'temperatura', 174.0000, 'ºC'),
	(170113, 119, '2014-02-01 00:11:07.000000', 'temperatura', 244.0000, 'ºC'),
	(170114, 119, '2014-02-01 00:11:08.000000', 'temperatura', 698.0000, 'ºC'),
	(170115, 119, '2014-02-01 00:11:09.000000', 'temperatura', 357.0000, 'ºC'),
	(170116, 119, '2014-02-01 00:11:10.000000', 'temperatura', 892.0000, 'ºC'),
	(170117, 119, '2014-02-01 00:11:11.000000', 'temperatura', 991.0000, 'ºC'),
	(170118, 119, '2014-02-01 00:11:12.000000', 'temperatura', 1080.0000, 'ºC'),
	(170119, 119, '2014-02-01 00:11:13.000000', 'temperatura', 28.0000, 'ºC'),
	(170120, 119, '2014-02-01 00:11:14.000000', 'temperatura', 500.0000, 'ºC'),
	(170121, 119, '2014-02-01 00:11:15.000000', 'temperatura', 16.0000, 'ºC'),
	(170122, 119, '2014-02-01 00:11:16.000000', 'temperatura', 983.0000, 'ºC'),
	(170123, 119, '2014-02-01 00:11:17.000000', 'temperatura', 65.0000, 'ºC'),
	(170124, 119, '2014-02-01 00:11:18.000000', 'temperatura', 975.0000, 'ºC'),
	(170125, 119, '2014-02-01 00:11:19.000000', 'temperatura', 1084.0000, 'ºC'),
	(170126, 119, '2014-02-01 00:11:20.000000', 'temperatura', 93.0000, 'ºC'),
	(170127, 119, '2014-02-01 00:11:21.000000', 'temperatura', 813.0000, 'ºC'),
	(170128, 119, '2014-02-01 00:11:22.000000', 'temperatura', 189.0000, 'ºC'),
	(170129, 119, '2014-02-01 00:11:23.000000', 'temperatura', 903.0000, 'ºC'),
	(170130, 119, '2014-02-01 00:11:24.000000', 'temperatura', 352.0000, 'ºC'),
	(170131, 119, '2014-02-01 00:11:25.000000', 'temperatura', 251.0000, 'ºC'),
	(170132, 119, '2014-02-01 00:11:26.000000', 'temperatura', 197.0000, 'ºC'),
	(170133, 119, '2014-02-01 00:11:27.000000', 'temperatura', 233.0000, 'ºC'),
	(170134, 119, '2014-02-01 00:11:28.000000', 'temperatura', 576.0000, 'ºC'),
	(170135, 119, '2014-02-01 00:11:29.000000', 'temperatura', 981.0000, 'ºC'),
	(170136, 119, '2014-02-01 00:11:30.000000', 'temperatura', 778.0000, 'ºC'),
	(170137, 119, '2014-02-01 00:11:31.000000', 'temperatura', 949.0000, 'ºC'),
	(170138, 119, '2014-02-01 00:11:32.000000', 'temperatura', 9.0000, 'ºC'),
	(170139, 119, '2014-02-01 00:11:33.000000', 'temperatura', 797.0000, 'ºC'),
	(170140, 119, '2014-02-01 00:11:34.000000', 'temperatura', 362.0000, 'ºC'),
	(170141, 119, '2014-02-01 00:11:35.000000', 'temperatura', 618.0000, 'ºC'),
	(170142, 119, '2014-02-01 00:11:36.000000', 'temperatura', 807.0000, 'ºC'),
	(170143, 119, '2014-02-01 00:11:37.000000', 'temperatura', 978.0000, 'ºC'),
	(170144, 119, '2014-02-01 00:11:38.000000', 'temperatura', 71.0000, 'ºC'),
	(170145, 119, '2014-02-01 00:11:39.000000', 'temperatura', 1021.0000, 'ºC'),
	(170146, 119, '2014-02-01 00:11:40.000000', 'temperatura', 92.0000, 'ºC'),
	(170147, 119, '2014-02-01 00:11:41.000000', 'temperatura', 1000.0000, 'ºC'),
	(170148, 119, '2014-02-01 00:11:42.000000', 'temperatura', 1122.0000, 'ºC'),
	(170149, 119, '2014-02-01 00:11:43.000000', 'temperatura', 210.0000, 'ºC'),
	(170150, 119, '2014-02-01 00:11:44.000000', 'temperatura', 86.0000, 'ºC'),
	(170151, 119, '2014-02-01 00:11:45.000000', 'temperatura', 1000.0000, 'ºC'),
	(170152, 119, '2014-02-01 00:11:46.000000', 'temperatura', 1142.0000, 'ºC'),
	(170153, 119, '2014-02-01 00:11:47.000000', 'temperatura', 310.0000, 'ºC'),
	(170154, 119, '2014-02-01 00:11:48.000000', 'temperatura', 527.0000, 'ºC'),
	(170155, 119, '2014-02-01 00:11:49.000000', 'temperatura', 503.0000, 'ºC'),
	(170156, 119, '2014-02-01 00:11:50.000000', 'temperatura', 936.0000, 'ºC'),
	(170157, 119, '2014-02-01 00:11:51.000000', 'temperatura', 771.0000, 'ºC'),
	(170158, 119, '2014-02-01 00:11:52.000000', 'temperatura', 1047.0000, 'ºC'),
	(170159, 119, '2014-02-01 00:11:53.000000', 'temperatura', 523.0000, 'ºC'),
	(170160, 119, '2014-02-01 00:11:54.000000', 'temperatura', 674.0000, 'ºC'),
	(170161, 119, '2014-02-01 00:11:55.000000', 'temperatura', 602.0000, 'ºC'),
	(170162, 119, '2014-02-01 00:11:56.000000', 'temperatura', 987.0000, 'ºC'),
	(170163, 119, '2014-02-01 00:11:57.000000', 'temperatura', 730.0000, 'ºC'),
	(170164, 119, '2014-02-01 00:11:58.000000', 'temperatura', 688.0000, 'ºC'),
	(170165, 119, '2014-02-01 00:11:59.000000', 'temperatura', 51.0000, 'ºC'),
	(170166, 119, '2014-02-01 00:12:00.000000', 'temperatura', 592.0000, 'ºC'),
	(170167, 119, '2014-02-01 00:12:01.000000', 'temperatura', 408.0000, 'ºC'),
	(170168, 119, '2014-02-01 00:12:02.000000', 'temperatura', 266.0000, 'ºC'),
	(170169, 119, '2014-02-01 00:12:03.000000', 'temperatura', 103.0000, 'ºC'),
	(170170, 119, '2014-02-01 00:12:04.000000', 'temperatura', 921.0000, 'ºC'),
	(170171, 119, '2014-02-01 00:12:05.000000', 'temperatura', 695.0000, 'ºC'),
	(170172, 119, '2014-02-01 00:12:06.000000', 'temperatura', 711.0000, 'ºC'),
	(170173, 119, '2014-02-01 00:12:07.000000', 'temperatura', 273.0000, 'ºC'),
	(170174, 119, '2014-02-01 00:12:08.000000', 'temperatura', 433.0000, 'ºC'),
	(170175, 119, '2014-02-01 00:12:09.000000', 'temperatura', 145.0000, 'ºC'),
	(170176, 119, '2014-02-01 00:12:10.000000', 'temperatura', 625.0000, 'ºC'),
	(170177, 119, '2014-02-01 00:12:11.000000', 'temperatura', 293.0000, 'ºC'),
	(170178, 119, '2014-02-01 00:12:12.000000', 'temperatura', 791.0000, 'ºC'),
	(170179, 119, '2014-02-01 00:12:13.000000', 'temperatura', 674.0000, 'ºC'),
	(170180, 119, '2014-02-01 00:12:14.000000', 'temperatura', 997.0000, 'ºC'),
	(170181, 119, '2014-02-01 00:12:15.000000', 'temperatura', 564.0000, 'ºC'),
	(170182, 119, '2014-02-01 00:12:16.000000', 'temperatura', 1029.0000, 'ºC'),
	(170183, 119, '2014-02-01 00:12:17.000000', 'temperatura', 1055.0000, 'ºC'),
	(170184, 119, '2014-02-01 00:12:18.000000', 'temperatura', 986.0000, 'ºC'),
	(170185, 119, '2014-02-01 00:12:19.000000', 'temperatura', 566.0000, 'ºC'),
	(170186, 119, '2014-02-01 00:12:20.000000', 'temperatura', 1075.0000, 'ºC'),
	(170187, 119, '2014-02-01 00:12:21.000000', 'temperatura', 77.0000, 'ºC'),
	(170188, 119, '2014-02-01 00:12:22.000000', 'temperatura', 758.0000, 'ºC'),
	(170189, 119, '2014-02-01 00:12:23.000000', 'temperatura', 1163.0000, 'ºC'),
	(170190, 119, '2014-02-01 00:12:24.000000', 'temperatura', 1139.0000, 'ºC'),
	(170191, 119, '2014-02-01 00:12:25.000000', 'temperatura', 1006.0000, 'ºC'),
	(170192, 119, '2014-02-01 00:12:26.000000', 'temperatura', 413.0000, 'ºC'),
	(170193, 119, '2014-02-01 00:12:27.000000', 'temperatura', 246.0000, 'ºC'),
	(170194, 119, '2014-02-01 00:12:28.000000', 'temperatura', 1195.0000, 'ºC'),
	(170195, 119, '2014-02-01 00:12:29.000000', 'temperatura', 438.0000, 'ºC'),
	(170196, 119, '2014-02-01 00:12:30.000000', 'temperatura', 1003.0000, 'ºC'),
	(170197, 119, '2014-02-01 00:12:31.000000', 'temperatura', 100.0000, 'ºC'),
	(170198, 119, '2014-02-01 00:12:32.000000', 'temperatura', 1095.0000, 'ºC'),
	(170199, 119, '2014-02-01 00:12:33.000000', 'temperatura', 373.0000, 'ºC'),
	(170200, 119, '2014-02-01 00:12:34.000000', 'temperatura', 983.0000, 'ºC'),
	(170201, 119, '2014-02-01 00:12:35.000000', 'temperatura', 196.0000, 'ºC'),
	(170202, 119, '2014-02-01 00:12:36.000000', 'temperatura', 433.0000, 'ºC'),
	(170203, 119, '2014-02-01 00:12:37.000000', 'temperatura', 376.0000, 'ºC'),
	(170204, 119, '2014-02-01 00:12:38.000000', 'temperatura', 581.0000, 'ºC'),
	(170205, 119, '2014-02-01 00:12:39.000000', 'temperatura', 579.0000, 'ºC'),
	(170206, 119, '2014-02-01 00:12:40.000000', 'temperatura', 1152.0000, 'ºC'),
	(170207, 119, '2014-02-01 00:12:41.000000', 'temperatura', 425.0000, 'ºC'),
	(170208, 119, '2014-02-01 00:12:42.000000', 'temperatura', 1070.0000, 'ºC'),
	(170209, 119, '2014-02-01 00:12:43.000000', 'temperatura', 473.0000, 'ºC'),
	(170210, 119, '2014-02-01 00:12:44.000000', 'temperatura', 358.0000, 'ºC'),
	(170211, 119, '2014-02-01 00:12:45.000000', 'temperatura', 369.0000, 'ºC'),
	(170212, 119, '2014-02-01 00:12:46.000000', 'temperatura', 772.0000, 'ºC'),
	(170213, 119, '2014-02-01 00:12:47.000000', 'temperatura', 355.0000, 'ºC'),
	(170214, 119, '2014-02-01 00:12:48.000000', 'temperatura', 659.0000, 'ºC'),
	(170215, 119, '2014-02-01 00:12:49.000000', 'temperatura', 1032.0000, 'ºC'),
	(170216, 119, '2014-02-01 00:12:50.000000', 'temperatura', 782.0000, 'ºC'),
	(170217, 119, '2014-02-01 00:12:51.000000', 'temperatura', 814.0000, 'ºC'),
	(170218, 119, '2014-02-01 00:12:52.000000', 'temperatura', 523.0000, 'ºC'),
	(170219, 119, '2014-02-01 00:12:53.000000', 'temperatura', 175.0000, 'ºC'),
	(170220, 119, '2014-02-01 00:12:54.000000', 'temperatura', 508.0000, 'ºC'),
	(170221, 119, '2014-02-01 00:12:55.000000', 'temperatura', 816.0000, 'ºC'),
	(170222, 119, '2014-02-01 00:12:56.000000', 'temperatura', 157.0000, 'ºC'),
	(170223, 119, '2014-02-01 00:12:57.000000', 'temperatura', 736.0000, 'ºC'),
	(170224, 119, '2014-02-01 00:12:58.000000', 'temperatura', 809.0000, 'ºC'),
	(170225, 119, '2014-02-01 00:12:59.000000', 'temperatura', 640.0000, 'ºC'),
	(170226, 119, '2014-02-01 00:13:00.000000', 'temperatura', 772.0000, 'ºC'),
	(170227, 119, '2014-02-01 00:13:01.000000', 'temperatura', 742.0000, 'ºC'),
	(170228, 119, '2014-02-01 00:13:02.000000', 'temperatura', 193.0000, 'ºC'),
	(170229, 119, '2014-02-01 00:13:03.000000', 'temperatura', 1139.0000, 'ºC'),
	(170230, 119, '2014-02-01 00:13:04.000000', 'temperatura', 316.0000, 'ºC'),
	(170231, 119, '2014-02-01 00:13:05.000000', 'temperatura', 566.0000, 'ºC'),
	(170232, 119, '2014-02-01 00:13:06.000000', 'temperatura', 682.0000, 'ºC'),
	(170233, 119, '2014-02-01 00:13:07.000000', 'temperatura', 512.0000, 'ºC'),
	(170234, 119, '2014-02-01 00:13:08.000000', 'temperatura', 516.0000, 'ºC'),
	(170235, 119, '2014-02-01 00:13:09.000000', 'temperatura', 1044.0000, 'ºC'),
	(170236, 119, '2014-02-01 00:13:10.000000', 'temperatura', 71.0000, 'ºC'),
	(170237, 119, '2014-02-01 00:13:11.000000', 'temperatura', 824.0000, 'ºC'),
	(170238, 119, '2014-02-01 00:13:12.000000', 'temperatura', 310.0000, 'ºC'),
	(170239, 119, '2014-02-01 00:13:13.000000', 'temperatura', 276.0000, 'ºC'),
	(170240, 119, '2014-02-01 00:13:14.000000', 'temperatura', 450.0000, 'ºC'),
	(170241, 119, '2014-02-01 00:13:15.000000', 'temperatura', 225.0000, 'ºC'),
	(170242, 119, '2014-02-01 00:13:16.000000', 'temperatura', 975.0000, 'ºC'),
	(170243, 119, '2014-02-01 00:13:17.000000', 'temperatura', 602.0000, 'ºC'),
	(170244, 119, '2014-02-01 00:13:18.000000', 'temperatura', 85.0000, 'ºC'),
	(170245, 119, '2014-02-01 00:13:19.000000', 'temperatura', 1018.0000, 'ºC'),
	(170246, 119, '2014-02-01 00:13:20.000000', 'temperatura', 35.0000, 'ºC'),
	(170247, 119, '2014-02-01 00:13:21.000000', 'temperatura', 724.0000, 'ºC'),
	(170248, 119, '2014-02-01 00:13:22.000000', 'temperatura', 1114.0000, 'ºC'),
	(170249, 119, '2014-02-01 00:13:23.000000', 'temperatura', 998.0000, 'ºC'),
	(170250, 119, '2014-02-01 00:13:24.000000', 'temperatura', 449.0000, 'ºC'),
	(170251, 119, '2014-02-01 00:13:25.000000', 'temperatura', 452.0000, 'ºC'),
	(170252, 119, '2014-02-01 00:13:26.000000', 'temperatura', 913.0000, 'ºC'),
	(170253, 119, '2014-02-01 00:13:27.000000', 'temperatura', 810.0000, 'ºC'),
	(170254, 119, '2014-02-01 00:13:28.000000', 'temperatura', 112.0000, 'ºC'),
	(170255, 119, '2014-02-01 00:13:29.000000', 'temperatura', 531.0000, 'ºC'),
	(170256, 119, '2014-02-01 00:13:30.000000', 'temperatura', 1118.0000, 'ºC'),
	(170257, 119, '2014-02-01 00:13:31.000000', 'temperatura', 397.0000, 'ºC'),
	(170258, 119, '2014-02-01 00:13:32.000000', 'temperatura', 1031.0000, 'ºC'),
	(170259, 119, '2014-02-01 00:13:33.000000', 'temperatura', 366.0000, 'ºC'),
	(170260, 119, '2014-02-01 00:13:34.000000', 'temperatura', 1136.0000, 'ºC'),
	(170261, 119, '2014-02-01 00:13:35.000000', 'temperatura', 985.0000, 'ºC'),
	(170262, 119, '2014-02-01 00:13:36.000000', 'temperatura', 315.0000, 'ºC'),
	(170263, 119, '2014-02-01 00:13:37.000000', 'temperatura', 1023.0000, 'ºC'),
	(170264, 119, '2014-02-01 00:13:38.000000', 'temperatura', 571.0000, 'ºC'),
	(170265, 119, '2014-02-01 00:13:39.000000', 'temperatura', 987.0000, 'ºC'),
	(170266, 119, '2014-02-01 00:13:40.000000', 'temperatura', 823.0000, 'ºC'),
	(170267, 119, '2014-02-01 00:13:41.000000', 'temperatura', 1154.0000, 'ºC'),
	(170268, 119, '2014-02-01 00:13:42.000000', 'temperatura', 902.0000, 'ºC'),
	(170269, 119, '2014-02-01 00:13:43.000000', 'temperatura', 1048.0000, 'ºC'),
	(170270, 119, '2014-02-01 00:13:44.000000', 'temperatura', 133.0000, 'ºC'),
	(170271, 119, '2014-02-01 00:13:45.000000', 'temperatura', 1123.0000, 'ºC'),
	(170272, 119, '2014-02-01 00:13:46.000000', 'temperatura', 415.0000, 'ºC'),
	(170273, 119, '2014-02-01 00:13:47.000000', 'temperatura', 1106.0000, 'ºC'),
	(170274, 119, '2014-02-01 00:13:48.000000', 'temperatura', 687.0000, 'ºC'),
	(170275, 119, '2014-02-01 00:13:49.000000', 'temperatura', 118.0000, 'ºC'),
	(170276, 119, '2014-02-01 00:13:50.000000', 'temperatura', 930.0000, 'ºC'),
	(170277, 119, '2014-02-01 00:13:51.000000', 'temperatura', 696.0000, 'ºC'),
	(170278, 119, '2014-02-01 00:13:52.000000', 'temperatura', 690.0000, 'ºC'),
	(170279, 119, '2014-02-01 00:13:53.000000', 'temperatura', 163.0000, 'ºC'),
	(170280, 119, '2014-02-01 00:13:54.000000', 'temperatura', 1147.0000, 'ºC'),
	(170281, 119, '2014-02-01 00:13:55.000000', 'temperatura', 446.0000, 'ºC'),
	(170282, 119, '2014-02-01 00:13:56.000000', 'temperatura', 1187.0000, 'ºC'),
	(170283, 119, '2014-02-01 00:13:57.000000', 'temperatura', 1000.0000, 'ºC'),
	(170284, 119, '2014-02-01 00:13:58.000000', 'temperatura', 237.0000, 'ºC'),
	(170285, 119, '2014-02-01 00:13:59.000000', 'temperatura', 587.0000, 'ºC'),
	(170286, 119, '2014-02-01 00:14:00.000000', 'temperatura', 1023.0000, 'ºC'),
	(170287, 119, '2014-02-01 00:14:01.000000', 'temperatura', 953.0000, 'ºC'),
	(170288, 119, '2014-02-01 00:14:02.000000', 'temperatura', 500.0000, 'ºC'),
	(170289, 119, '2014-02-01 00:14:03.000000', 'temperatura', 840.0000, 'ºC'),
	(170290, 119, '2014-02-01 00:14:04.000000', 'temperatura', 300.0000, 'ºC'),
	(170291, 119, '2014-02-01 00:14:05.000000', 'temperatura', 182.0000, 'ºC'),
	(170292, 119, '2014-02-01 00:14:06.000000', 'temperatura', 11.0000, 'ºC'),
	(170293, 119, '2014-02-01 00:14:07.000000', 'temperatura', 708.0000, 'ºC'),
	(170294, 119, '2014-02-01 00:14:08.000000', 'temperatura', 1109.0000, 'ºC'),
	(170295, 119, '2014-02-01 00:14:09.000000', 'temperatura', 1021.0000, 'ºC'),
	(170296, 119, '2014-02-01 00:14:10.000000', 'temperatura', 580.0000, 'ºC'),
	(170297, 119, '2014-02-01 00:14:11.000000', 'temperatura', 1036.0000, 'ºC'),
	(170298, 119, '2014-02-01 00:14:12.000000', 'temperatura', 1040.0000, 'ºC'),
	(170299, 119, '2014-02-01 00:14:13.000000', 'temperatura', 894.0000, 'ºC'),
	(170300, 119, '2014-02-01 00:14:14.000000', 'temperatura', 148.0000, 'ºC'),
	(170301, 119, '2014-02-01 00:14:15.000000', 'temperatura', 460.0000, 'ºC'),
	(170302, 119, '2014-02-01 00:14:16.000000', 'temperatura', 655.0000, 'ºC'),
	(170303, 119, '2014-02-01 00:14:17.000000', 'temperatura', 697.0000, 'ºC'),
	(170304, 119, '2014-02-01 00:14:18.000000', 'temperatura', 318.0000, 'ºC'),
	(170305, 119, '2014-02-01 00:14:19.000000', 'temperatura', 703.0000, 'ºC'),
	(170306, 119, '2014-02-01 00:14:20.000000', 'temperatura', 160.0000, 'ºC'),
	(170307, 119, '2014-02-01 00:14:21.000000', 'temperatura', 1089.0000, 'ºC'),
	(170308, 119, '2014-02-01 00:14:22.000000', 'temperatura', 169.0000, 'ºC'),
	(170309, 119, '2014-02-01 00:14:23.000000', 'temperatura', 1178.0000, 'ºC'),
	(170310, 119, '2014-02-01 00:14:24.000000', 'temperatura', 583.0000, 'ºC'),
	(170311, 119, '2014-02-01 00:14:25.000000', 'temperatura', 581.0000, 'ºC'),
	(170312, 119, '2014-02-01 00:14:26.000000', 'temperatura', 1158.0000, 'ºC'),
	(170313, 119, '2014-02-01 00:14:27.000000', 'temperatura', 448.0000, 'ºC'),
	(170314, 119, '2014-02-01 00:14:28.000000', 'temperatura', 1166.0000, 'ºC'),
	(170315, 119, '2014-02-01 00:14:29.000000', 'temperatura', 886.0000, 'ºC'),
	(170316, 119, '2014-02-01 00:14:30.000000', 'temperatura', 933.0000, 'ºC'),
	(170317, 119, '2014-02-01 00:14:31.000000', 'temperatura', 809.0000, 'ºC'),
	(170318, 119, '2014-02-01 00:14:32.000000', 'temperatura', 45.0000, 'ºC'),
	(170319, 119, '2014-02-01 00:14:33.000000', 'temperatura', 198.0000, 'ºC'),
	(170320, 119, '2014-02-01 00:14:34.000000', 'temperatura', 857.0000, 'ºC'),
	(170321, 119, '2014-02-01 00:14:35.000000', 'temperatura', 93.0000, 'ºC'),
	(170322, 119, '2014-02-01 00:14:36.000000', 'temperatura', 292.0000, 'ºC'),
	(170323, 119, '2014-02-01 00:14:37.000000', 'temperatura', 1182.0000, 'ºC'),
	(170324, 119, '2014-02-01 00:14:38.000000', 'temperatura', 233.0000, 'ºC'),
	(170325, 119, '2014-02-01 00:14:39.000000', 'temperatura', 23.0000, 'ºC'),
	(170326, 119, '2014-02-01 00:14:40.000000', 'temperatura', 613.0000, 'ºC'),
	(170327, 119, '2014-02-01 00:14:41.000000', 'temperatura', 599.0000, 'ºC'),
	(170328, 119, '2014-02-01 00:14:42.000000', 'temperatura', 1154.0000, 'ºC'),
	(170329, 119, '2014-02-01 00:14:43.000000', 'temperatura', 376.0000, 'ºC'),
	(170330, 119, '2014-02-01 00:14:44.000000', 'temperatura', 816.0000, 'ºC'),
	(170331, 119, '2014-02-01 00:14:45.000000', 'temperatura', 552.0000, 'ºC'),
	(170332, 119, '2014-02-01 00:14:46.000000', 'temperatura', 312.0000, 'ºC'),
	(170333, 119, '2014-02-01 00:14:47.000000', 'temperatura', 1105.0000, 'ºC'),
	(170334, 119, '2014-02-01 00:14:48.000000', 'temperatura', 991.0000, 'ºC'),
	(170335, 119, '2014-02-01 00:14:49.000000', 'temperatura', 441.0000, 'ºC'),
	(170336, 119, '2014-02-01 00:14:50.000000', 'temperatura', 430.0000, 'ºC'),
	(170337, 119, '2014-02-01 00:14:51.000000', 'temperatura', 828.0000, 'ºC'),
	(170338, 119, '2014-02-01 00:14:52.000000', 'temperatura', 453.0000, 'ºC'),
	(170339, 119, '2014-02-01 00:14:53.000000', 'temperatura', 980.0000, 'ºC'),
	(170340, 119, '2014-02-01 00:14:54.000000', 'temperatura', 1141.0000, 'ºC'),
	(170341, 119, '2014-02-01 00:14:55.000000', 'temperatura', 365.0000, 'ºC'),
	(170342, 119, '2014-02-01 00:14:56.000000', 'temperatura', 802.0000, 'ºC'),
	(170343, 119, '2014-02-01 00:14:57.000000', 'temperatura', 515.0000, 'ºC'),
	(170344, 119, '2014-02-01 00:14:58.000000', 'temperatura', 168.0000, 'ºC'),
	(170345, 119, '2014-02-01 00:14:59.000000', 'temperatura', 499.0000, 'ºC'),
	(170346, 119, '2014-02-01 00:15:00.000000', 'temperatura', 791.0000, 'ºC'),
	(170347, 119, '2014-02-01 00:15:01.000000', 'temperatura', 57.0000, 'ºC'),
	(170348, 119, '2014-02-01 00:15:02.000000', 'temperatura', 315.0000, 'ºC'),
	(170349, 119, '2014-02-01 00:15:03.000000', 'temperatura', 201.0000, 'ºC'),
	(170350, 119, '2014-02-01 00:15:04.000000', 'temperatura', 63.0000, 'ºC'),
	(170351, 119, '2014-02-01 00:15:05.000000', 'temperatura', 911.0000, 'ºC'),
	(170352, 119, '2014-02-01 00:15:06.000000', 'temperatura', 769.0000, 'ºC'),
	(170353, 119, '2014-02-01 00:15:07.000000', 'temperatura', 1111.0000, 'ºC'),
	(170354, 119, '2014-02-01 00:15:08.000000', 'temperatura', 849.0000, 'ºC'),
	(170355, 119, '2014-02-01 00:15:09.000000', 'temperatura', 912.0000, 'ºC'),
	(170356, 119, '2014-02-01 00:15:10.000000', 'temperatura', 815.0000, 'ºC'),
	(170357, 119, '2014-02-01 00:15:11.000000', 'temperatura', 137.0000, 'ºC'),
	(170358, 119, '2014-02-01 00:15:12.000000', 'temperatura', 641.0000, 'ºC'),
	(170359, 119, '2014-02-01 00:15:13.000000', 'temperatura', 393.0000, 'ºC'),
	(170360, 119, '2014-02-01 00:15:14.000000', 'temperatura', 45.0000, 'ºC'),
	(170361, 119, '2014-02-01 00:15:15.000000', 'temperatura', 245.0000, 'ºC'),
	(170362, 119, '2014-02-01 00:15:16.000000', 'temperatura', 1090.0000, 'ºC'),
	(170363, 119, '2014-02-01 00:15:17.000000', 'temperatura', 1117.0000, 'ºC'),
	(170364, 119, '2014-02-01 00:15:18.000000', 'temperatura', 1116.0000, 'ºC'),
	(170365, 119, '2014-02-01 00:15:19.000000', 'temperatura', 1028.0000, 'ºC'),
	(170366, 119, '2014-02-01 00:15:20.000000', 'temperatura', 591.0000, 'ºC'),
	(170367, 119, '2014-02-01 00:15:21.000000', 'temperatura', 1074.0000, 'ºC'),
	(170368, 119, '2014-02-01 00:15:22.000000', 'temperatura', 1197.0000, 'ºC'),
	(170369, 119, '2014-02-01 00:15:23.000000', 'temperatura', 362.0000, 'ºC'),
	(170370, 119, '2014-02-01 00:15:24.000000', 'temperatura', 621.0000, 'ºC'),
	(170371, 119, '2014-02-01 00:15:25.000000', 'temperatura', 820.0000, 'ºC'),
	(170372, 119, '2014-02-01 00:15:26.000000', 'temperatura', 1035.0000, 'ºC'),
	(170373, 119, '2014-02-01 00:15:27.000000', 'temperatura', 318.0000, 'ºC'),
	(170374, 119, '2014-02-01 00:15:28.000000', 'temperatura', 885.0000, 'ºC'),
	(170375, 119, '2014-02-01 00:15:29.000000', 'temperatura', 1073.0000, 'ºC'),
	(170376, 119, '2014-02-01 00:15:30.000000', 'temperatura', 308.0000, 'ºC'),
	(170377, 119, '2014-02-01 00:15:31.000000', 'temperatura', 722.0000, 'ºC'),
	(170378, 119, '2014-02-01 00:15:32.000000', 'temperatura', 288.0000, 'ºC'),
	(170379, 119, '2014-02-01 00:15:33.000000', 'temperatura', 474.0000, 'ºC'),
	(170380, 119, '2014-02-01 00:15:34.000000', 'temperatura', 306.0000, 'ºC'),
	(170381, 119, '2014-02-01 00:15:35.000000', 'temperatura', 107.0000, 'ºC'),
	(170382, 119, '2014-02-01 00:15:36.000000', 'temperatura', 820.0000, 'ºC'),
	(170383, 119, '2014-02-01 00:15:37.000000', 'temperatura', 180.0000, 'ºC'),
	(170384, 119, '2014-02-01 00:15:38.000000', 'temperatura', 839.0000, 'ºC'),
	(170385, 119, '2014-02-01 00:15:39.000000', 'temperatura', 55.0000, 'ºC'),
	(170386, 119, '2014-02-01 00:15:40.000000', 'temperatura', 157.0000, 'ºC'),
	(170387, 119, '2014-02-01 00:15:41.000000', 'temperatura', 622.0000, 'ºC'),
	(170388, 119, '2014-02-01 00:15:42.000000', 'temperatura', 239.0000, 'ºC'),
	(170389, 119, '2014-02-01 00:15:43.000000', 'temperatura', 529.0000, 'ºC'),
	(170390, 119, '2014-02-01 00:15:44.000000', 'temperatura', 728.0000, 'ºC'),
	(170391, 119, '2014-02-01 00:15:45.000000', 'temperatura', 855.0000, 'ºC'),
	(170392, 119, '2014-02-01 00:15:46.000000', 'temperatura', 890.0000, 'ºC'),
	(170393, 119, '2014-02-01 00:15:47.000000', 'temperatura', 688.0000, 'ºC'),
	(170394, 119, '2014-02-01 00:15:48.000000', 'temperatura', 767.0000, 'ºC'),
	(170395, 119, '2014-02-01 00:15:49.000000', 'temperatura', 574.0000, 'ºC'),
	(170396, 119, '2014-02-01 00:15:50.000000', 'temperatura', 570.0000, 'ºC'),
	(170397, 119, '2014-02-01 00:15:51.000000', 'temperatura', 1126.0000, 'ºC'),
	(170398, 119, '2014-02-01 00:15:52.000000', 'temperatura', 321.0000, 'ºC'),
	(170399, 119, '2014-02-01 00:15:53.000000', 'temperatura', 629.0000, 'ºC'),
	(170400, 119, '2014-02-01 00:15:54.000000', 'temperatura', 982.0000, 'ºC'),
	(170401, 119, '2014-02-01 00:15:55.000000', 'temperatura', 625.0000, 'ºC'),
	(170402, 119, '2014-02-01 00:15:56.000000', 'temperatura', 176.0000, 'ºC'),
	(170403, 119, '2014-02-01 00:15:57.000000', 'temperatura', 209.0000, 'ºC'),
	(170404, 119, '2014-02-01 00:15:58.000000', 'temperatura', 514.0000, 'ºC'),
	(170405, 119, '2014-02-01 00:15:59.000000', 'temperatura', 745.0000, 'ºC'),
	(170406, 119, '2014-02-01 00:16:00.000000', 'temperatura', 985.0000, 'ºC'),
	(170407, 119, '2014-02-01 00:16:01.000000', 'temperatura', 291.0000, 'ºC'),
	(170408, 119, '2014-02-01 00:16:02.000000', 'temperatura', 901.0000, 'ºC'),
	(170409, 119, '2014-02-01 00:16:03.000000', 'temperatura', 32.0000, 'ºC'),
	(170410, 119, '2014-02-01 00:16:04.000000', 'temperatura', 1058.0000, 'ºC'),
	(170411, 119, '2014-02-01 00:16:05.000000', 'temperatura', 392.0000, 'ºC'),
	(170412, 119, '2014-02-01 00:16:06.000000', 'temperatura', 1189.0000, 'ºC'),
	(170413, 119, '2014-02-01 00:16:07.000000', 'temperatura', 1169.0000, 'ºC'),
	(170414, 119, '2014-02-01 00:16:08.000000', 'temperatura', 1080.0000, 'ºC'),
	(170415, 119, '2014-02-01 00:16:09.000000', 'temperatura', 691.0000, 'ºC'),
	(170416, 119, '2014-02-01 00:16:10.000000', 'temperatura', 214.0000, 'ºC'),
	(170417, 119, '2014-02-01 00:16:11.000000', 'temperatura', 201.0000, 'ºC'),
	(170418, 119, '2014-02-01 00:16:12.000000', 'temperatura', 363.0000, 'ºC'),
	(170419, 119, '2014-02-01 00:16:13.000000', 'temperatura', 10.0000, 'ºC'),
	(170420, 119, '2014-02-01 00:16:14.000000', 'temperatura', 163.0000, 'ºC'),
	(170421, 119, '2014-02-01 00:16:15.000000', 'temperatura', 786.0000, 'ºC'),
	(170422, 119, '2014-02-01 00:16:16.000000', 'temperatura', 1041.0000, 'ºC'),
	(170423, 119, '2014-02-01 00:16:17.000000', 'temperatura', 447.0000, 'ºC'),
	(170424, 119, '2014-02-01 00:16:18.000000', 'temperatura', 311.0000, 'ºC'),
	(170425, 119, '2014-02-01 00:16:19.000000', 'temperatura', 216.0000, 'ºC'),
	(170426, 119, '2014-02-01 00:16:20.000000', 'temperatura', 148.0000, 'ºC'),
	(170427, 119, '2014-02-01 00:16:21.000000', 'temperatura', 94.0000, 'ºC'),
	(170428, 119, '2014-02-01 00:16:22.000000', 'temperatura', 24.0000, 'ºC'),
	(170429, 119, '2014-02-01 00:16:23.000000', 'temperatura', 1038.0000, 'ºC'),
	(170430, 119, '2014-02-01 00:16:24.000000', 'temperatura', 318.0000, 'ºC'),
	(170431, 119, '2014-02-01 00:16:25.000000', 'temperatura', 878.0000, 'ºC'),
	(170432, 119, '2014-02-01 00:16:26.000000', 'temperatura', 1035.0000, 'ºC'),
	(170433, 119, '2014-02-01 00:16:27.000000', 'temperatura', 144.0000, 'ºC'),
	(170434, 119, '2014-02-01 00:16:28.000000', 'temperatura', 15.0000, 'ºC'),
	(170435, 119, '2014-02-01 00:16:29.000000', 'temperatura', 841.0000, 'ºC'),
	(170436, 119, '2014-02-01 00:16:30.000000', 'temperatura', 564.0000, 'ºC'),
	(170437, 119, '2014-02-01 00:16:31.000000', 'temperatura', 295.0000, 'ºC'),
	(170438, 119, '2014-02-01 00:16:32.000000', 'temperatura', 984.0000, 'ºC'),
	(170439, 119, '2014-02-01 00:16:33.000000', 'temperatura', 436.0000, 'ºC'),
	(170440, 119, '2014-02-01 00:16:34.000000', 'temperatura', 428.0000, 'ºC'),
	(170441, 119, '2014-02-01 00:16:35.000000', 'temperatura', 833.0000, 'ºC'),
	(170442, 119, '2014-02-01 00:16:36.000000', 'temperatura', 479.0000, 'ºC'),
	(170443, 119, '2014-02-01 00:16:37.000000', 'temperatura', 1099.0000, 'ºC'),
	(170444, 119, '2014-02-01 00:16:38.000000', 'temperatura', 459.0000, 'ºC'),
	(170445, 119, '2014-02-01 00:16:39.000000', 'temperatura', 196.0000, 'ºC'),
	(170446, 119, '2014-02-01 00:16:40.000000', 'temperatura', 807.0000, 'ºC'),
	(170447, 119, '2014-02-01 00:16:41.000000', 'temperatura', 1044.0000, 'ºC'),
	(170448, 119, '2014-02-01 00:16:42.000000', 'temperatura', 401.0000, 'ºC'),
	(170449, 119, '2014-02-01 00:16:43.000000', 'temperatura', 74.0000, 'ºC'),
	(170450, 119, '2014-02-01 00:16:44.000000', 'temperatura', 368.0000, 'ºC'),
	(170451, 119, '2014-02-01 00:16:45.000000', 'temperatura', 419.0000, 'ºC'),
	(170452, 119, '2014-02-01 00:16:46.000000', 'temperatura', 989.0000, 'ºC'),
	(170453, 119, '2014-02-01 00:16:47.000000', 'temperatura', 89.0000, 'ºC'),
	(170454, 119, '2014-02-01 00:16:48.000000', 'temperatura', 1077.0000, 'ºC'),
	(170455, 119, '2014-02-01 00:16:49.000000', 'temperatura', 321.0000, 'ºC'),
	(170456, 119, '2014-02-01 00:16:50.000000', 'temperatura', 773.0000, 'ºC'),
	(170457, 119, '2014-02-01 00:16:51.000000', 'temperatura', 504.0000, 'ºC'),
	(170458, 119, '2014-02-01 00:16:52.000000', 'temperatura', 201.0000, 'ºC'),
	(170459, 119, '2014-02-01 00:16:53.000000', 'temperatura', 695.0000, 'ºC'),
	(170460, 119, '2014-02-01 00:16:54.000000', 'temperatura', 472.0000, 'ºC'),
	(170461, 119, '2014-02-01 00:16:55.000000', 'temperatura', 276.0000, 'ºC'),
	(170462, 119, '2014-02-01 00:16:56.000000', 'temperatura', 1164.0000, 'ºC'),
	(170463, 119, '2014-02-01 00:16:57.000000', 'temperatura', 191.0000, 'ºC'),
	(170464, 119, '2014-02-01 00:16:58.000000', 'temperatura', 1064.0000, 'ºC'),
	(170465, 119, '2014-02-01 00:16:59.000000', 'temperatura', 1147.0000, 'ºC'),
	(170466, 119, '2014-02-01 00:17:00.000000', 'temperatura', 144.0000, 'ºC'),
	(170467, 119, '2014-02-01 00:17:01.000000', 'temperatura', 879.0000, 'ºC'),
	(170468, 119, '2014-02-01 00:17:02.000000', 'temperatura', 366.0000, 'ºC'),
	(170469, 119, '2014-02-01 00:17:03.000000', 'temperatura', 392.0000, 'ºC'),
	(170470, 119, '2014-02-01 00:17:04.000000', 'temperatura', 861.0000, 'ºC'),
	(170471, 119, '2014-02-01 00:17:05.000000', 'temperatura', 729.0000, 'ºC'),
	(170472, 119, '2014-02-01 00:17:06.000000', 'temperatura', 1062.0000, 'ºC'),
	(170473, 119, '2014-02-01 00:17:07.000000', 'temperatura', 723.0000, 'ºC'),
	(170474, 119, '2014-02-01 00:17:08.000000', 'temperatura', 432.0000, 'ºC'),
	(170475, 119, '2014-02-01 00:17:09.000000', 'temperatura', 1190.0000, 'ºC'),
	(170476, 119, '2014-02-01 00:17:10.000000', 'temperatura', 1056.0000, 'ºC'),
	(170477, 119, '2014-02-01 00:17:11.000000', 'temperatura', 508.0000, 'ºC'),
	(170478, 119, '2014-02-01 00:17:12.000000', 'temperatura', 575.0000, 'ºC'),
	(170479, 119, '2014-02-01 00:17:13.000000', 'temperatura', 149.0000, 'ºC'),
	(170480, 119, '2014-02-01 00:17:14.000000', 'temperatura', 221.0000, 'ºC'),
	(170481, 119, '2014-02-01 00:17:15.000000', 'temperatura', 659.0000, 'ºC'),
	(170482, 119, '2014-02-01 00:17:16.000000', 'temperatura', 231.0000, 'ºC'),
	(170483, 119, '2014-02-01 00:17:17.000000', 'temperatura', 381.0000, 'ºC'),
	(170484, 119, '2014-02-01 00:17:18.000000', 'temperatura', 11.0000, 'ºC'),
	(170485, 119, '2014-02-01 00:17:19.000000', 'temperatura', 114.0000, 'ºC'),
	(170486, 119, '2014-02-01 00:17:20.000000', 'temperatura', 535.0000, 'ºC'),
	(170487, 119, '2014-02-01 00:17:21.000000', 'temperatura', 1133.0000, 'ºC'),
	(170488, 119, '2014-02-01 00:17:22.000000', 'temperatura', 461.0000, 'ºC'),
	(170489, 119, '2014-02-01 00:17:23.000000', 'temperatura', 106.0000, 'ºC'),
	(170490, 119, '2014-02-01 00:17:24.000000', 'temperatura', 348.0000, 'ºC'),
	(170491, 119, '2014-02-01 00:17:25.000000', 'temperatura', 225.0000, 'ºC'),
	(170492, 119, '2014-02-01 00:17:26.000000', 'temperatura', 78.0000, 'ºC'),
	(170493, 119, '2014-02-01 00:17:27.000000', 'temperatura', 916.0000, 'ºC'),
	(170494, 119, '2014-02-01 00:17:28.000000', 'temperatura', 746.0000, 'ºC'),
	(170495, 119, '2014-02-01 00:17:29.000000', 'temperatura', 983.0000, 'ºC'),
	(170496, 119, '2014-02-01 00:17:30.000000', 'temperatura', 276.0000, 'ºC'),
	(170497, 119, '2014-02-01 00:17:31.000000', 'temperatura', 831.0000, 'ºC'),
	(170498, 119, '2014-02-01 00:17:32.000000', 'temperatura', 929.0000, 'ºC'),
	(170499, 119, '2014-02-01 00:17:33.000000', 'temperatura', 954.0000, 'ºC'),
	(170500, 119, '2014-02-01 00:17:34.000000', 'temperatura', 780.0000, 'ºC'),
	(170501, 119, '2014-02-01 00:17:35.000000', 'temperatura', 1042.0000, 'ºC'),
	(170502, 119, '2014-02-01 00:17:36.000000', 'temperatura', 467.0000, 'ºC'),
	(170503, 119, '2014-02-01 00:17:37.000000', 'temperatura', 412.0000, 'ºC'),
	(170504, 119, '2014-02-01 00:17:38.000000', 'temperatura', 659.0000, 'ºC'),
	(170505, 119, '2014-02-01 00:17:39.000000', 'temperatura', 859.0000, 'ºC'),
	(170506, 119, '2014-02-01 00:17:40.000000', 'temperatura', 1120.0000, 'ºC'),
	(170507, 119, '2014-02-01 00:17:41.000000', 'temperatura', 621.0000, 'ºC'),
	(170508, 119, '2014-02-01 00:17:42.000000', 'temperatura', 947.0000, 'ºC'),
	(170509, 119, '2014-02-01 00:17:43.000000', 'temperatura', 470.0000, 'ºC'),
	(170510, 119, '2014-02-01 00:17:44.000000', 'temperatura', 713.0000, 'ºC'),
	(170511, 119, '2014-02-01 00:17:45.000000', 'temperatura', 955.0000, 'ºC'),
	(170512, 119, '2014-02-01 00:17:46.000000', 'temperatura', 236.0000, 'ºC'),
	(170513, 119, '2014-02-01 00:17:47.000000', 'temperatura', 714.0000, 'ºC'),
	(170514, 119, '2014-02-01 00:17:48.000000', 'temperatura', 465.0000, 'ºC'),
	(170515, 119, '2014-02-01 00:17:49.000000', 'temperatura', 181.0000, 'ºC'),
	(170516, 119, '2014-02-01 00:17:50.000000', 'temperatura', 711.0000, 'ºC'),
	(170517, 119, '2014-02-01 00:17:51.000000', 'temperatura', 613.0000, 'ºC'),
	(170518, 119, '2014-02-01 00:17:52.000000', 'temperatura', 931.0000, 'ºC'),
	(170519, 119, '2014-02-01 00:17:53.000000', 'temperatura', 419.0000, 'ºC'),
	(170520, 119, '2014-02-01 00:17:54.000000', 'temperatura', 503.0000, 'ºC'),
	(170521, 119, '2014-02-01 00:17:55.000000', 'temperatura', 59.0000, 'ºC'),
	(170522, 119, '2014-02-01 00:17:56.000000', 'temperatura', 1184.0000, 'ºC'),
	(170523, 119, '2014-02-01 00:17:57.000000', 'temperatura', 944.0000, 'ºC'),
	(170524, 119, '2014-02-01 00:17:58.000000', 'temperatura', 1171.0000, 'ºC'),
	(170525, 119, '2014-02-01 00:17:59.000000', 'temperatura', 621.0000, 'ºC'),
	(170526, 119, '2014-02-01 00:18:00.000000', 'temperatura', 793.0000, 'ºC'),
	(170527, 119, '2014-02-01 00:18:01.000000', 'temperatura', 902.0000, 'ºC'),
	(170528, 119, '2014-02-01 00:18:02.000000', 'temperatura', 932.0000, 'ºC'),
	(170529, 119, '2014-02-01 00:18:03.000000', 'temperatura', 754.0000, 'ºC'),
	(170530, 119, '2014-02-01 00:18:04.000000', 'temperatura', 977.0000, 'ºC'),
	(170531, 119, '2014-02-01 00:18:05.000000', 'temperatura', 221.0000, 'ºC'),
	(170532, 119, '2014-02-01 00:18:06.000000', 'temperatura', 573.0000, 'ºC'),
	(170533, 119, '2014-02-01 00:18:07.000000', 'temperatura', 1005.0000, 'ºC'),
	(170534, 119, '2014-02-01 00:18:08.000000', 'temperatura', 905.0000, 'ºC'),
	(170535, 119, '2014-02-01 00:18:09.000000', 'temperatura', 313.0000, 'ºC'),
	(170536, 119, '2014-02-01 00:18:10.000000', 'temperatura', 50.0000, 'ºC'),
	(170537, 119, '2014-02-01 00:18:11.000000', 'temperatura', 511.0000, 'ºC'),
	(170538, 119, '2014-02-01 00:18:12.000000', 'temperatura', 7.0000, 'ºC'),
	(170539, 119, '2014-02-01 00:18:13.000000', 'temperatura', 899.0000, 'ºC'),
	(170540, 119, '2014-02-01 00:18:14.000000', 'temperatura', 878.0000, 'ºC'),
	(170541, 119, '2014-02-01 00:18:15.000000', 'temperatura', 491.0000, 'ºC'),
	(170542, 119, '2014-02-01 00:18:16.000000', 'temperatura', 1022.0000, 'ºC'),
	(170543, 119, '2014-02-01 00:18:17.000000', 'temperatura', 36.0000, 'ºC'),
	(170544, 119, '2014-02-01 00:18:18.000000', 'temperatura', 717.0000, 'ºC'),
	(170545, 119, '2014-02-01 00:18:19.000000', 'temperatura', 1076.0000, 'ºC'),
	(170546, 119, '2014-02-01 00:18:20.000000', 'temperatura', 830.0000, 'ºC'),
	(170547, 119, '2014-02-01 00:18:21.000000', 'temperatura', 921.0000, 'ºC'),
	(170548, 119, '2014-02-01 00:18:22.000000', 'temperatura', 917.0000, 'ºC'),
	(170549, 119, '2014-02-01 00:18:23.000000', 'temperatura', 621.0000, 'ºC'),
	(170550, 119, '2014-02-01 00:18:24.000000', 'temperatura', 353.0000, 'ºC'),
	(170551, 119, '2014-02-01 00:18:25.000000', 'temperatura', 1105.0000, 'ºC'),
	(170552, 119, '2014-02-01 00:18:26.000000', 'temperatura', 867.0000, 'ºC'),
	(170553, 119, '2014-02-01 00:18:27.000000', 'temperatura', 1019.0000, 'ºC'),
	(170554, 119, '2014-02-01 00:18:28.000000', 'temperatura', 96.0000, 'ºC'),
	(170555, 119, '2014-02-01 00:18:29.000000', 'temperatura', 1022.0000, 'ºC'),
	(170556, 119, '2014-02-01 00:18:30.000000', 'temperatura', 21.0000, 'ºC'),
	(170557, 119, '2014-02-01 00:18:31.000000', 'temperatura', 643.0000, 'ºC'),
	(170558, 119, '2014-02-01 00:18:32.000000', 'temperatura', 751.0000, 'ºC'),
	(170559, 119, '2014-02-01 00:18:33.000000', 'temperatura', 625.0000, 'ºC'),
	(170560, 119, '2014-02-01 00:18:34.000000', 'temperatura', 873.0000, 'ºC'),
	(170561, 119, '2014-02-01 00:18:35.000000', 'temperatura', 90.0000, 'ºC'),
	(170562, 119, '2014-02-01 00:18:36.000000', 'temperatura', 230.0000, 'ºC'),
	(170563, 119, '2014-02-01 00:18:37.000000', 'temperatura', 883.0000, 'ºC'),
	(170564, 119, '2014-02-01 00:18:38.000000', 'temperatura', 127.0000, 'ºC'),
	(170565, 119, '2014-02-01 00:18:39.000000', 'temperatura', 384.0000, 'ºC'),
	(170566, 119, '2014-02-01 00:18:40.000000', 'temperatura', 340.0000, 'ºC'),
	(170567, 119, '2014-02-01 00:18:41.000000', 'temperatura', 549.0000, 'ºC'),
	(170568, 119, '2014-02-01 00:18:42.000000', 'temperatura', 525.0000, 'ºC'),
	(170569, 119, '2014-02-01 00:18:43.000000', 'temperatura', 980.0000, 'ºC'),
	(170570, 119, '2014-02-01 00:18:44.000000', 'temperatura', 925.0000, 'ºC'),
	(170571, 119, '2014-02-01 00:18:45.000000', 'temperatura', 485.0000, 'ºC'),
	(170572, 119, '2014-02-01 00:18:46.000000', 'temperatura', 852.0000, 'ºC'),
	(170573, 119, '2014-02-01 00:18:47.000000', 'temperatura', 404.0000, 'ºC'),
	(170574, 119, '2014-02-01 00:18:48.000000', 'temperatura', 664.0000, 'ºC'),
	(170575, 119, '2014-02-01 00:18:49.000000', 'temperatura', 910.0000, 'ºC'),
	(170576, 119, '2014-02-01 00:18:50.000000', 'temperatura', 157.0000, 'ºC'),
	(170577, 119, '2014-02-01 00:18:51.000000', 'temperatura', 457.0000, 'ºC'),
	(170578, 119, '2014-02-01 00:18:52.000000', 'temperatura', 615.0000, 'ºC'),
	(170579, 119, '2014-02-01 00:18:53.000000', 'temperatura', 503.0000, 'ºC'),
	(170580, 119, '2014-02-01 00:18:54.000000', 'temperatura', 669.0000, 'ºC'),
	(170581, 119, '2014-02-01 00:18:55.000000', 'temperatura', 640.0000, 'ºC'),
	(170582, 119, '2014-02-01 00:18:56.000000', 'temperatura', 1192.0000, 'ºC'),
	(170583, 119, '2014-02-01 00:18:57.000000', 'temperatura', 439.0000, 'ºC'),
	(170584, 119, '2014-02-01 00:18:58.000000', 'temperatura', 1020.0000, 'ºC'),
	(170585, 119, '2014-02-01 00:18:59.000000', 'temperatura', 184.0000, 'ºC'),
	(170586, 119, '2014-02-01 00:19:00.000000', 'temperatura', 259.0000, 'ºC'),
	(170587, 119, '2014-02-01 00:19:01.000000', 'temperatura', 745.0000, 'ºC'),
	(170588, 119, '2014-02-01 00:19:02.000000', 'temperatura', 549.0000, 'ºC'),
	(170589, 119, '2014-02-01 00:19:03.000000', 'temperatura', 508.0000, 'ºC'),
	(170590, 119, '2014-02-01 00:19:04.000000', 'temperatura', 897.0000, 'ºC'),
	(170591, 119, '2014-02-01 00:19:05.000000', 'temperatura', 559.0000, 'ºC'),
	(170592, 119, '2014-02-01 00:19:06.000000', 'temperatura', 107.0000, 'ºC'),
	(170593, 119, '2014-02-01 00:19:07.000000', 'temperatura', 55.0000, 'ºC'),
	(170594, 119, '2014-02-01 00:19:08.000000', 'temperatura', 1157.0000, 'ºC'),
	(170595, 119, '2014-02-01 00:19:09.000000', 'temperatura', 819.0000, 'ºC'),
	(170596, 119, '2014-02-01 00:19:10.000000', 'temperatura', 627.0000, 'ºC'),
	(170597, 119, '2014-02-01 00:19:11.000000', 'temperatura', 677.0000, 'ºC'),
	(170598, 119, '2014-02-01 00:19:12.000000', 'temperatura', 304.0000, 'ºC'),
	(170599, 119, '2014-02-01 00:19:13.000000', 'temperatura', 690.0000, 'ºC'),
	(170600, 119, '2014-02-01 00:19:14.000000', 'temperatura', 137.0000, 'ºC'),
	(170601, 119, '2014-02-01 00:19:15.000000', 'temperatura', 1016.0000, 'ºC'),
	(170602, 119, '2014-02-01 00:19:16.000000', 'temperatura', 1071.0000, 'ºC'),
	(170603, 119, '2014-02-01 00:19:17.000000', 'temperatura', 1108.0000, 'ºC'),
	(170604, 119, '2014-02-01 00:19:18.000000', 'temperatura', 1125.0000, 'ºC'),
	(170605, 119, '2014-02-01 00:19:19.000000', 'temperatura', 1102.0000, 'ºC'),
	(170606, 119, '2014-02-01 00:19:20.000000', 'temperatura', 936.0000, 'ºC'),
	(170607, 119, '2014-02-01 00:19:21.000000', 'temperatura', 176.0000, 'ºC'),
	(170608, 119, '2014-02-01 00:19:22.000000', 'temperatura', 470.0000, 'ºC'),
	(170609, 119, '2014-02-01 00:19:23.000000', 'temperatura', 624.0000, 'ºC'),
	(170610, 119, '2014-02-01 00:19:24.000000', 'temperatura', 510.0000, 'ºC'),
	(170611, 119, '2014-02-01 00:19:25.000000', 'temperatura', 678.0000, 'ºC'),
	(170612, 119, '2014-02-01 00:19:26.000000', 'temperatura', 663.0000, 'ºC'),
	(170613, 119, '2014-02-01 00:19:27.000000', 'temperatura', 78.0000, 'ºC'),
	(170614, 119, '2014-02-01 00:19:28.000000', 'temperatura', 805.0000, 'ºC'),
	(170615, 119, '2014-02-01 00:19:29.000000', 'temperatura', 190.0000, 'ºC'),
	(170616, 119, '2014-02-01 00:19:30.000000', 'temperatura', 935.0000, 'ºC'),
	(170617, 119, '2014-02-01 00:19:31.000000', 'temperatura', 504.0000, 'ºC'),
	(170618, 119, '2014-02-01 00:19:32.000000', 'temperatura', 916.0000, 'ºC'),
	(170619, 119, '2014-02-01 00:19:33.000000', 'temperatura', 668.0000, 'ºC'),
	(170620, 119, '2014-02-01 00:19:34.000000', 'temperatura', 593.0000, 'ºC'),
	(170621, 119, '2014-02-01 00:19:35.000000', 'temperatura', 962.0000, 'ºC'),
	(170622, 119, '2014-02-01 00:19:36.000000', 'temperatura', 633.0000, 'ºC'),
	(170623, 119, '2014-02-01 00:19:37.000000', 'temperatura', 277.0000, 'ºC'),
	(170624, 119, '2014-02-01 00:19:38.000000', 'temperatura', 688.0000, 'ºC'),
	(170625, 119, '2014-02-01 00:19:39.000000', 'temperatura', 209.0000, 'ºC'),
	(170626, 119, '2014-02-01 00:19:40.000000', 'temperatura', 183.0000, 'ºC'),
	(170627, 119, '2014-02-01 00:19:41.000000', 'temperatura', 288.0000, 'ºC'),
	(170628, 119, '2014-02-01 00:19:42.000000', 'temperatura', 891.0000, 'ºC'),
	(170629, 119, '2014-02-01 00:19:43.000000', 'temperatura', 1190.0000, 'ºC'),
	(170630, 119, '2014-02-01 00:19:44.000000', 'temperatura', 878.0000, 'ºC'),
	(170631, 119, '2014-02-01 00:19:45.000000', 'temperatura', 819.0000, 'ºC'),
	(170632, 119, '2014-02-01 00:19:46.000000', 'temperatura', 263.0000, 'ºC'),
	(170633, 119, '2014-02-01 00:19:47.000000', 'temperatura', 59.0000, 'ºC'),
	(170634, 119, '2014-02-01 00:19:48.000000', 'temperatura', 707.0000, 'ºC'),
	(170635, 119, '2014-02-01 00:19:49.000000', 'temperatura', 958.0000, 'ºC'),
	(170636, 119, '2014-02-01 00:19:50.000000', 'temperatura', 270.0000, 'ºC'),
	(170637, 119, '2014-02-01 00:19:51.000000', 'temperatura', 876.0000, 'ºC'),
	(170638, 119, '2014-02-01 00:19:52.000000', 'temperatura', 1170.0000, 'ºC'),
	(170639, 119, '2014-02-01 00:19:53.000000', 'temperatura', 825.0000, 'ºC'),
	(170640, 119, '2014-02-01 00:19:54.000000', 'temperatura', 614.0000, 'ºC'),
	(170641, 119, '2014-02-01 00:19:55.000000', 'temperatura', 594.0000, 'ºC'),
	(170642, 119, '2014-02-01 00:19:56.000000', 'temperatura', 1131.0000, 'ºC'),
	(170643, 119, '2014-02-01 00:19:57.000000', 'temperatura', 273.0000, 'ºC'),
	(170644, 119, '2014-02-01 00:19:58.000000', 'temperatura', 370.0000, 'ºC'),
	(170645, 119, '2014-02-01 00:19:59.000000', 'temperatura', 1034.0000, 'ºC'),
	(170646, 119, '2014-02-01 00:20:00.000000', 'temperatura', 458.0000, 'ºC'),
	(170647, 119, '2014-02-01 00:20:01.000000', 'temperatura', 391.0000, 'ºC'),
	(170648, 119, '2014-02-01 00:20:02.000000', 'temperatura', 579.0000, 'ºC'),
	(170649, 119, '2014-02-01 00:20:03.000000', 'temperatura', 526.0000, 'ºC'),
	(170650, 119, '2014-02-01 00:20:04.000000', 'temperatura', 891.0000, 'ºC'),
	(170651, 119, '2014-02-01 00:20:05.000000', 'temperatura', 477.0000, 'ºC'),
	(170652, 119, '2014-02-01 00:20:06.000000', 'temperatura', 912.0000, 'ºC'),
	(170653, 119, '2014-02-01 00:20:07.000000', 'temperatura', 729.0000, 'ºC'),
	(170654, 119, '2014-02-01 00:20:08.000000', 'temperatura', 912.0000, 'ºC'),
	(170655, 119, '2014-02-01 00:20:09.000000', 'temperatura', 1171.0000, 'ºC'),
	(170656, 119, '2014-02-01 00:20:10.000000', 'temperatura', 720.0000, 'ºC'),
	(170657, 119, '2014-02-01 00:20:11.000000', 'temperatura', 86.0000, 'ºC'),
	(170658, 119, '2014-02-01 00:20:12.000000', 'temperatura', 674.0000, 'ºC'),
	(170659, 119, '2014-02-01 00:20:13.000000', 'temperatura', 709.0000, 'ºC'),
	(170660, 119, '2014-02-01 00:20:14.000000', 'temperatura', 326.0000, 'ºC'),
	(170661, 119, '2014-02-01 00:20:15.000000', 'temperatura', 704.0000, 'ºC'),
	(170662, 119, '2014-02-01 00:20:16.000000', 'temperatura', 143.0000, 'ºC'),
	(170663, 119, '2014-02-01 00:20:17.000000', 'temperatura', 1001.0000, 'ºC'),
	(170664, 119, '2014-02-01 00:20:18.000000', 'temperatura', 977.0000, 'ºC'),
	(170665, 119, '2014-02-01 00:20:19.000000', 'temperatura', 683.0000, 'ºC'),
	(170666, 119, '2014-02-01 00:20:20.000000', 'temperatura', 483.0000, 'ºC'),
	(170667, 119, '2014-02-01 00:20:21.000000', 'temperatura', 368.0000, 'ºC'),
	(170668, 119, '2014-02-01 00:20:22.000000', 'temperatura', 392.0000, 'ºC'),
	(170669, 119, '2014-02-01 00:20:23.000000', 'temperatura', 854.0000, 'ºC'),
	(170670, 119, '2014-02-01 00:20:24.000000', 'temperatura', 696.0000, 'ºC'),
	(170671, 119, '2014-02-01 00:20:25.000000', 'temperatura', 917.0000, 'ºC'),
	(170672, 119, '2014-02-01 00:20:26.000000', 'temperatura', 98.0000, 'ºC'),
	(170673, 119, '2014-02-01 00:20:27.000000', 'temperatura', 141.0000, 'ºC'),
	(170674, 119, '2014-02-01 00:20:28.000000', 'temperatura', 411.0000, 'ºC'),
	(170675, 119, '2014-02-01 00:20:29.000000', 'temperatura', 432.0000, 'ºC'),
	(170676, 119, '2014-02-01 00:20:30.000000', 'temperatura', 928.0000, 'ºC'),
	(170677, 119, '2014-02-01 00:20:31.000000', 'temperatura', 944.0000, 'ºC'),
	(170678, 119, '2014-02-01 00:20:32.000000', 'temperatura', 736.0000, 'ºC'),
	(170679, 119, '2014-02-01 00:20:33.000000', 'temperatura', 850.0000, 'ºC'),
	(170680, 119, '2014-02-01 00:20:34.000000', 'temperatura', 840.0000, 'ºC'),
	(170681, 119, '2014-02-01 00:20:35.000000', 'temperatura', 453.0000, 'ºC'),
	(170682, 119, '2014-02-01 00:20:36.000000', 'temperatura', 944.0000, 'ºC'),
	(170683, 119, '2014-02-01 00:20:37.000000', 'temperatura', 963.0000, 'ºC'),
	(170684, 119, '2014-02-01 00:20:38.000000', 'temperatura', 784.0000, 'ºC'),
	(170685, 119, '2014-02-01 00:20:39.000000', 'temperatura', 1028.0000, 'ºC'),
	(170686, 119, '2014-02-01 00:20:40.000000', 'temperatura', 392.0000, 'ºC'),
	(170687, 119, '2014-02-01 00:20:41.000000', 'temperatura', 77.0000, 'ºC'),
	(170688, 119, '2014-02-01 00:20:42.000000', 'temperatura', 410.0000, 'ºC'),
	(170689, 119, '2014-02-01 00:20:43.000000', 'temperatura', 619.0000, 'ºC'),
	(170690, 119, '2014-02-01 00:20:44.000000', 'temperatura', 666.0000, 'ºC'),
	(170691, 119, '2014-02-01 00:20:45.000000', 'temperatura', 274.0000, 'ºC'),
	(170692, 119, '2014-02-01 00:20:46.000000', 'temperatura', 572.0000, 'ºC'),
	(170693, 119, '2014-02-01 00:20:47.000000', 'temperatura', 839.0000, 'ºC'),
	(170694, 119, '2014-02-01 00:20:48.000000', 'temperatura', 80.0000, 'ºC'),
	(170695, 119, '2014-02-01 00:20:49.000000', 'temperatura', 283.0000, 'ºC'),
	(170696, 119, '2014-02-01 00:20:50.000000', 'temperatura', 1176.0000, 'ºC'),
	(170697, 119, '2014-02-01 00:20:51.000000', 'temperatura', 231.0000, 'ºC'),
	(170698, 119, '2014-02-01 00:20:52.000000', 'temperatura', 29.0000, 'ºC'),
	(170699, 119, '2014-02-01 00:20:53.000000', 'temperatura', 649.0000, 'ºC'),
	(170700, 119, '2014-02-01 00:20:54.000000', 'temperatura', 762.0000, 'ºC'),
	(170701, 119, '2014-02-01 00:20:55.000000', 'temperatura', 661.0000, 'ºC'),
	(170702, 119, '2014-02-01 00:20:56.000000', 'temperatura', 1020.0000, 'ºC'),
	(170703, 119, '2014-02-01 00:20:57.000000', 'temperatura', 718.0000, 'ºC'),
	(170704, 119, '2014-02-01 00:20:58.000000', 'temperatura', 529.0000, 'ºC'),
	(170705, 119, '2014-02-01 00:20:59.000000', 'temperatura', 493.0000, 'ºC'),
	(170706, 119, '2014-02-01 00:21:00.000000', 'temperatura', 877.0000, 'ºC'),
	(170707, 119, '2014-02-01 00:21:01.000000', 'temperatura', 507.0000, 'ºC'),
	(170708, 119, '2014-02-01 00:21:02.000000', 'temperatura', 1104.0000, 'ºC'),
	(170709, 119, '2014-02-01 00:21:03.000000', 'temperatura', 400.0000, 'ºC'),
	(170710, 119, '2014-02-01 00:21:04.000000', 'temperatura', 1089.0000, 'ºC'),
	(170711, 119, '2014-02-01 00:21:05.000000', 'temperatura', 645.0000, 'ºC'),
	(170712, 119, '2014-02-01 00:21:06.000000', 'temperatura', 1157.0000, 'ºC'),
	(170713, 119, '2014-02-01 00:21:07.000000', 'temperatura', 250.0000, 'ºC'),
	(170714, 119, '2014-02-01 00:21:08.000000', 'temperatura', 181.0000, 'ºC'),
	(170715, 119, '2014-02-01 00:21:09.000000', 'temperatura', 155.0000, 'ºC'),
	(170716, 119, '2014-02-01 00:21:10.000000', 'temperatura', 235.0000, 'ºC'),
	(170717, 119, '2014-02-01 00:21:11.000000', 'temperatura', 708.0000, 'ºC'),
	(170718, 119, '2014-02-01 00:21:12.000000', 'temperatura', 436.0000, 'ºC'),
	(170719, 119, '2014-02-01 00:21:13.000000', 'temperatura', 58.0000, 'ºC'),
	(170720, 119, '2014-02-01 00:21:14.000000', 'temperatura', 182.0000, 'ºC'),
	(170721, 119, '2014-02-01 00:21:15.000000', 'temperatura', 737.0000, 'ºC'),
	(170722, 119, '2014-02-01 00:21:16.000000', 'temperatura', 740.0000, 'ºC'),
	(170723, 119, '2014-02-01 00:21:17.000000', 'temperatura', 288.0000, 'ºC'),
	(170724, 119, '2014-02-01 00:21:18.000000', 'temperatura', 420.0000, 'ºC'),
	(170725, 119, '2014-02-01 00:21:19.000000', 'temperatura', 35.0000, 'ºC'),
	(170726, 119, '2014-02-01 00:21:20.000000', 'temperatura', 118.0000, 'ºC'),
	(170727, 119, '2014-02-01 00:21:21.000000', 'temperatura', 485.0000, 'ºC'),
	(170728, 119, '2014-02-01 00:21:22.000000', 'temperatura', 873.0000, 'ºC'),
	(170729, 119, '2014-02-01 00:21:23.000000', 'temperatura', 508.0000, 'ºC'),
	(170730, 119, '2014-02-01 00:21:24.000000', 'temperatura', 1121.0000, 'ºC'),
	(170731, 119, '2014-02-01 00:21:25.000000', 'temperatura', 483.0000, 'ºC'),
	(170732, 119, '2014-02-01 00:21:26.000000', 'temperatura', 252.0000, 'ºC'),
	(170733, 119, '2014-02-01 00:21:27.000000', 'temperatura', 1011.0000, 'ºC'),
	(170734, 119, '2014-02-01 00:21:28.000000', 'temperatura', 699.0000, 'ºC'),
	(170735, 119, '2014-02-01 00:21:29.000000', 'temperatura', 463.0000, 'ºC'),
	(170736, 119, '2014-02-01 00:21:30.000000', 'temperatura', 220.0000, 'ºC'),
	(170737, 119, '2014-02-01 00:21:31.000000', 'temperatura', 910.0000, 'ºC'),
	(170738, 119, '2014-02-01 00:21:32.000000', 'temperatura', 293.0000, 'ºC'),
	(170739, 119, '2014-02-01 00:21:33.000000', 'temperatura', 1133.0000, 'ºC'),
	(170740, 119, '2014-02-01 00:21:34.000000', 'temperatura', 1188.0000, 'ºC'),
	(170741, 119, '2014-02-01 00:21:35.000000', 'temperatura', 141.0000, 'ºC'),
	(170742, 119, '2014-02-01 00:21:36.000000', 'temperatura', 740.0000, 'ºC'),
	(170743, 119, '2014-02-01 00:21:37.000000', 'temperatura', 878.0000, 'ºC'),
	(170744, 119, '2014-02-01 00:21:38.000000', 'temperatura', 969.0000, 'ºC'),
	(170745, 119, '2014-02-01 00:21:39.000000', 'temperatura', 1013.0000, 'ºC'),
	(170746, 119, '2014-02-01 00:21:40.000000', 'temperatura', 960.0000, 'ºC'),
	(170747, 119, '2014-02-01 00:21:41.000000', 'temperatura', 561.0000, 'ºC'),
	(170748, 119, '2014-02-01 00:21:42.000000', 'temperatura', 1125.0000, 'ºC'),
	(170749, 119, '2014-02-01 00:21:43.000000', 'temperatura', 344.0000, 'ºC'),
	(170750, 119, '2014-02-01 00:21:44.000000', 'temperatura', 746.0000, 'ºC'),
	(170751, 119, '2014-02-01 00:21:45.000000', 'temperatura', 297.0000, 'ºC'),
	(170752, 119, '2014-02-01 00:21:46.000000', 'temperatura', 447.0000, 'ºC'),
	(170753, 119, '2014-02-01 00:21:47.000000', 'temperatura', 147.0000, 'ºC'),
	(170754, 119, '2014-02-01 00:21:48.000000', 'temperatura', 592.0000, 'ºC'),
	(170755, 119, '2014-02-01 00:21:49.000000', 'temperatura', 121.0000, 'ºC'),
	(170756, 119, '2014-02-01 00:21:50.000000', 'temperatura', 30.0000, 'ºC'),
	(170757, 119, '2014-02-01 00:21:51.000000', 'temperatura', 987.0000, 'ºC'),
	(170758, 119, '2014-02-01 00:21:52.000000', 'temperatura', 46.0000, 'ºC'),
	(170759, 119, '2014-02-01 00:21:53.000000', 'temperatura', 869.0000, 'ºC'),
	(170760, 119, '2014-02-01 00:21:54.000000', 'temperatura', 607.0000, 'ºC'),
	(170761, 119, '2014-02-01 00:21:55.000000', 'temperatura', 427.0000, 'ºC'),
	(170762, 119, '2014-02-01 00:21:56.000000', 'temperatura', 316.0000, 'ºC'),
	(170763, 119, '2014-02-01 00:21:57.000000', 'temperatura', 301.0000, 'ºC'),
	(170764, 119, '2014-02-01 00:21:58.000000', 'temperatura', 556.0000, 'ºC'),
	(170765, 119, '2014-02-01 00:21:59.000000', 'temperatura', 679.0000, 'ºC'),
	(170766, 119, '2014-02-01 00:22:00.000000', 'temperatura', 527.0000, 'ºC'),
	(170767, 119, '2014-02-01 00:22:01.000000', 'temperatura', 596.0000, 'ºC'),
	(170768, 119, '2014-02-01 00:22:02.000000', 'temperatura', 202.0000, 'ºC'),
	(170769, 119, '2014-02-01 00:22:03.000000', 'temperatura', 420.0000, 'ºC'),
	(170770, 119, '2014-02-01 00:22:04.000000', 'temperatura', 298.0000, 'ºC'),
	(170771, 119, '2014-02-01 00:22:05.000000', 'temperatura', 227.0000, 'ºC'),
	(170772, 119, '2014-02-01 00:22:06.000000', 'temperatura', 243.0000, 'ºC'),
	(170773, 119, '2014-02-01 00:22:07.000000', 'temperatura', 534.0000, 'ºC'),
	(170774, 119, '2014-02-01 00:22:08.000000', 'temperatura', 743.0000, 'ºC'),
	(170775, 119, '2014-02-01 00:22:09.000000', 'temperatura', 911.0000, 'ºC'),
	(170776, 119, '2014-02-01 00:22:10.000000', 'temperatura', 1129.0000, 'ºC'),
	(170777, 119, '2014-02-01 00:22:11.000000', 'temperatura', 511.0000, 'ºC'),
	(170778, 119, '2014-02-01 00:22:12.000000', 'temperatura', 370.0000, 'ºC'),
	(170779, 119, '2014-02-01 00:22:13.000000', 'temperatura', 317.0000, 'ºC'),
	(170780, 119, '2014-02-01 00:22:14.000000', 'temperatura', 476.0000, 'ºC'),
	(170781, 119, '2014-02-01 00:22:15.000000', 'temperatura', 229.0000, 'ºC'),
	(170782, 119, '2014-02-01 00:22:16.000000', 'temperatura', 918.0000, 'ºC'),
	(170783, 119, '2014-02-01 00:22:17.000000', 'temperatura', 304.0000, 'ºC'),
	(170784, 119, '2014-02-01 00:22:18.000000', 'temperatura', 1168.0000, 'ºC'),
	(170785, 119, '2014-02-01 00:22:19.000000', 'temperatura', 127.0000, 'ºC'),
	(170786, 119, '2014-02-01 00:22:20.000000', 'temperatura', 732.0000, 'ºC'),
	(170787, 119, '2014-02-01 00:22:21.000000', 'temperatura', 878.0000, 'ºC'),
	(170788, 119, '2014-02-01 00:22:22.000000', 'temperatura', 996.0000, 'ºC'),
	(170789, 119, '2014-02-01 00:22:23.000000', 'temperatura', 1146.0000, 'ºC'),
	(170790, 119, '2014-02-01 00:22:24.000000', 'temperatura', 344.0000, 'ºC'),
	(170791, 119, '2014-02-01 00:22:25.000000', 'temperatura', 681.0000, 'ºC'),
	(170792, 119, '2014-02-01 00:22:26.000000', 'temperatura', 1173.0000, 'ºC'),
	(170793, 119, '2014-02-01 00:22:27.000000', 'temperatura', 222.0000, 'ºC'),
	(170794, 119, '2014-02-01 00:22:28.000000', 'temperatura', 1191.0000, 'ºC'),
	(170795, 119, '2014-02-01 00:22:29.000000', 'temperatura', 489.0000, 'ºC'),
	(170796, 119, '2014-02-01 00:22:30.000000', 'temperatura', 74.0000, 'ºC'),
	(170797, 119, '2014-02-01 00:22:31.000000', 'temperatura', 105.0000, 'ºC'),
	(170798, 119, '2014-02-01 00:22:32.000000', 'temperatura', 301.0000, 'ºC'),
	(170799, 119, '2014-02-01 00:22:33.000000', 'temperatura', 1190.0000, 'ºC'),
	(170800, 119, '2014-02-01 00:22:34.000000', 'temperatura', 249.0000, 'ºC'),
	(170801, 119, '2014-02-01 00:22:35.000000', 'temperatura', 77.0000, 'ºC'),
	(170802, 119, '2014-02-01 00:22:36.000000', 'temperatura', 838.0000, 'ºC'),
	(170803, 119, '2014-02-01 00:22:37.000000', 'temperatura', 359.0000, 'ºC'),
	(170804, 119, '2014-02-01 00:22:38.000000', 'temperatura', 480.0000, 'ºC'),
	(170805, 119, '2014-02-01 00:22:39.000000', 'temperatura', 126.0000, 'ºC'),
	(170806, 119, '2014-02-01 00:22:40.000000', 'temperatura', 390.0000, 'ºC'),
	(170807, 119, '2014-02-01 00:22:41.000000', 'temperatura', 374.0000, 'ºC'),
	(170808, 119, '2014-02-01 00:22:42.000000', 'temperatura', 698.0000, 'ºC'),
	(170809, 119, '2014-02-01 00:22:43.000000', 'temperatura', 1171.0000, 'ºC'),
	(170810, 119, '2014-02-01 00:22:44.000000', 'temperatura', 162.0000, 'ºC'),
	(170811, 119, '2014-02-01 00:22:45.000000', 'temperatura', 895.0000, 'ºC'),
	(170812, 119, '2014-02-01 00:22:46.000000', 'temperatura', 390.0000, 'ºC'),
	(170813, 119, '2014-02-01 00:22:47.000000', 'temperatura', 466.0000, 'ºC'),
	(170814, 119, '2014-02-01 00:22:48.000000', 'temperatura', 1158.0000, 'ºC'),
	(170815, 119, '2014-02-01 00:22:49.000000', 'temperatura', 795.0000, 'ºC'),
	(170816, 119, '2014-02-01 00:22:50.000000', 'temperatura', 502.0000, 'ºC'),
	(170817, 119, '2014-02-01 00:22:51.000000', 'temperatura', 126.0000, 'ºC'),
	(170818, 119, '2014-02-01 00:22:52.000000', 'temperatura', 323.0000, 'ºC'),
	(170819, 119, '2014-02-01 00:22:53.000000', 'temperatura', 37.0000, 'ºC'),
	(170820, 119, '2014-02-01 00:22:54.000000', 'temperatura', 416.0000, 'ºC'),
	(170821, 119, '2014-02-01 00:22:55.000000', 'temperatura', 769.0000, 'ºC'),
	(170822, 119, '2014-02-01 00:22:56.000000', 'temperatura', 196.0000, 'ºC'),
	(170823, 119, '2014-02-01 00:22:57.000000', 'temperatura', 1077.0000, 'ºC'),
	(170824, 119, '2014-02-01 00:22:58.000000', 'temperatura', 1196.0000, 'ºC'),
	(170825, 119, '2014-02-01 00:22:59.000000', 'temperatura', 349.0000, 'ºC'),
	(170826, 119, '2014-02-01 00:23:00.000000', 'temperatura', 557.0000, 'ºC'),
	(170827, 119, '2014-02-01 00:23:01.000000', 'temperatura', 537.0000, 'ºC'),
	(170828, 119, '2014-02-01 00:23:02.000000', 'temperatura', 1018.0000, 'ºC'),
	(170829, 119, '2014-02-01 00:23:03.000000', 'temperatura', 1078.0000, 'ºC'),
	(170830, 119, '2014-02-01 00:23:04.000000', 'temperatura', 1138.0000, 'ºC'),
	(170831, 119, '2014-02-01 00:23:05.000000', 'temperatura', 54.0000, 'ºC'),
	(170832, 119, '2014-02-01 00:23:06.000000', 'temperatura', 458.0000, 'ºC'),
	(170833, 119, '2014-02-01 00:23:07.000000', 'temperatura', 930.0000, 'ºC'),
	(170834, 119, '2014-02-01 00:23:08.000000', 'temperatura', 875.0000, 'ºC'),
	(170835, 119, '2014-02-01 00:23:09.000000', 'temperatura', 384.0000, 'ºC'),
	(170836, 119, '2014-02-01 00:23:10.000000', 'temperatura', 497.0000, 'ºC'),
	(170837, 119, '2014-02-01 00:23:11.000000', 'temperatura', 132.0000, 'ºC'),
	(170838, 119, '2014-02-01 00:23:12.000000', 'temperatura', 369.0000, 'ºC'),
	(170839, 119, '2014-02-01 00:23:13.000000', 'temperatura', 251.0000, 'ºC'),
	(170840, 119, '2014-02-01 00:23:14.000000', 'temperatura', 146.0000, 'ºC'),
	(170841, 119, '2014-02-01 00:23:15.000000', 'temperatura', 1179.0000, 'ºC'),
	(170842, 119, '2014-02-01 00:23:16.000000', 'temperatura', 657.0000, 'ºC'),
	(170843, 119, '2014-02-01 00:23:17.000000', 'temperatura', 950.0000, 'ºC'),
	(170844, 119, '2014-02-01 00:23:18.000000', 'temperatura', 378.0000, 'ºC'),
	(170845, 119, '2014-02-01 00:23:19.000000', 'temperatura', 239.0000, 'ºC'),
	(170846, 119, '2014-02-01 00:23:20.000000', 'temperatura', 64.0000, 'ºC'),
	(170847, 119, '2014-02-01 00:23:21.000000', 'temperatura', 803.0000, 'ºC'),
	(170848, 119, '2014-02-01 00:23:22.000000', 'temperatura', 223.0000, 'ºC'),
	(170849, 119, '2014-02-01 00:23:23.000000', 'temperatura', 1106.0000, 'ºC'),
	(170850, 119, '2014-02-01 00:23:24.000000', 'temperatura', 61.0000, 'ºC'),
	(170851, 119, '2014-02-01 00:23:25.000000', 'temperatura', 588.0000, 'ºC'),
	(170852, 119, '2014-02-01 00:23:26.000000', 'temperatura', 358.0000, 'ºC'),
	(170853, 119, '2014-02-01 00:23:27.000000', 'temperatura', 28.0000, 'ºC'),
	(170854, 119, '2014-02-01 00:23:28.000000', 'temperatura', 266.0000, 'ºC'),
	(170855, 119, '2014-02-01 00:23:29.000000', 'temperatura', 44.0000, 'ºC'),
	(170856, 119, '2014-02-01 00:23:30.000000', 'temperatura', 624.0000, 'ºC'),
	(170857, 119, '2014-02-01 00:23:31.000000', 'temperatura', 589.0000, 'ºC'),
	(170858, 119, '2014-02-01 00:23:32.000000', 'temperatura', 1074.0000, 'ºC'),
	(170859, 119, '2014-02-01 00:23:33.000000', 'temperatura', 5.0000, 'ºC'),
	(170860, 119, '2014-02-01 00:23:34.000000', 'temperatura', 402.0000, 'ºC'),
	(170861, 119, '2014-02-01 00:23:35.000000', 'temperatura', 794.0000, 'ºC'),
	(170862, 119, '2014-02-01 00:23:36.000000', 'temperatura', 367.0000, 'ºC'),
	(170863, 119, '2014-02-01 00:23:37.000000', 'temperatura', 652.0000, 'ºC'),
	(170864, 119, '2014-02-01 00:23:38.000000', 'temperatura', 961.0000, 'ºC'),
	(170865, 119, '2014-02-01 00:23:39.000000', 'temperatura', 447.0000, 'ºC'),
	(170866, 119, '2014-02-01 00:23:40.000000', 'temperatura', 554.0000, 'ºC'),
	(170867, 119, '2014-02-01 00:23:41.000000', 'temperatura', 230.0000, 'ºC'),
	(170868, 119, '2014-02-01 00:23:42.000000', 'temperatura', 690.0000, 'ºC'),
	(170869, 119, '2014-02-01 00:23:43.000000', 'temperatura', 358.0000, 'ºC'),
	(170870, 119, '2014-02-01 00:23:44.000000', 'temperatura', 923.0000, 'ºC'),
	(170871, 119, '2014-02-01 00:23:45.000000', 'temperatura', 1139.0000, 'ºC'),
	(170872, 119, '2014-02-01 00:23:46.000000', 'temperatura', 528.0000, 'ºC'),
	(170873, 119, '2014-02-01 00:23:47.000000', 'temperatura', 423.0000, 'ºC'),
	(170874, 119, '2014-02-01 00:23:48.000000', 'temperatura', 533.0000, 'ºC'),
	(170875, 119, '2014-02-01 00:23:49.000000', 'temperatura', 196.0000, 'ºC'),
	(170876, 119, '2014-02-01 00:23:50.000000', 'temperatura', 580.0000, 'ºC'),
	(170877, 119, '2014-02-01 00:23:51.000000', 'temperatura', 1114.0000, 'ºC'),
	(170878, 119, '2014-02-01 00:23:52.000000', 'temperatura', 232.0000, 'ºC'),
	(170879, 119, '2014-02-01 00:23:53.000000', 'temperatura', 215.0000, 'ºC'),
	(170880, 119, '2014-02-01 00:23:54.000000', 'temperatura', 383.0000, 'ºC'),
	(170881, 119, '2014-02-01 00:23:55.000000', 'temperatura', 67.0000, 'ºC'),
	(170882, 119, '2014-02-01 00:23:56.000000', 'temperatura', 388.0000, 'ºC'),
	(170883, 119, '2014-02-01 00:23:57.000000', 'temperatura', 541.0000, 'ºC'),
	(170884, 119, '2014-02-01 00:23:58.000000', 'temperatura', 340.0000, 'ºC'),
	(170885, 119, '2014-02-01 00:23:59.000000', 'temperatura', 78.0000, 'ºC'),
	(170886, 119, '2014-02-01 00:24:00.000000', 'temperatura', 569.0000, 'ºC'),
	(170887, 119, '2014-02-01 00:24:01.000000', 'temperatura', 213.0000, 'ºC'),
	(170888, 119, '2014-02-01 00:24:02.000000', 'temperatura', 556.0000, 'ºC'),
	(170889, 119, '2014-02-01 00:24:03.000000', 'temperatura', 945.0000, 'ºC'),
	(170890, 119, '2014-02-01 00:24:04.000000', 'temperatura', 656.0000, 'ºC'),
	(170891, 119, '2014-02-01 00:24:05.000000', 'temperatura', 444.0000, 'ºC'),
	(170892, 119, '2014-02-01 00:24:06.000000', 'temperatura', 254.0000, 'ºC'),
	(170893, 119, '2014-02-01 00:24:07.000000', 'temperatura', 1136.0000, 'ºC'),
	(170894, 119, '2014-02-01 00:24:08.000000', 'temperatura', 120.0000, 'ºC'),
	(170895, 119, '2014-02-01 00:24:09.000000', 'temperatura', 794.0000, 'ºC'),
	(170896, 119, '2014-02-01 00:24:10.000000', 'temperatura', 11.0000, 'ºC'),
	(170897, 119, '2014-02-01 00:24:11.000000', 'temperatura', 72.0000, 'ºC'),
	(170898, 119, '2014-02-01 00:24:12.000000', 'temperatura', 329.0000, 'ºC'),
	(170899, 119, '2014-02-01 00:24:13.000000', 'temperatura', 229.0000, 'ºC'),
	(170900, 119, '2014-02-01 00:24:14.000000', 'temperatura', 158.0000, 'ºC'),
	(170901, 119, '2014-02-01 00:24:15.000000', 'temperatura', 104.0000, 'ºC'),
	(170902, 119, '2014-02-01 00:24:16.000000', 'temperatura', 47.0000, 'ºC'),
	(170903, 119, '2014-02-01 00:24:17.000000', 'temperatura', 1122.0000, 'ºC'),
	(170904, 119, '2014-02-01 00:24:18.000000', 'temperatura', 670.0000, 'ºC'),
	(170905, 119, '2014-02-01 00:24:19.000000', 'temperatura', 1186.0000, 'ºC'),
	(170906, 119, '2014-02-01 00:24:20.000000', 'temperatura', 322.0000, 'ºC'),
	(170907, 119, '2014-02-01 00:24:21.000000', 'temperatura', 449.0000, 'ºC'),
	(170908, 119, '2014-02-01 00:24:22.000000', 'temperatura', 82.0000, 'ºC'),
	(170909, 119, '2014-02-01 00:24:23.000000', 'temperatura', 261.0000, 'ºC'),
	(170910, 119, '2014-02-01 00:24:24.000000', 'temperatura', 1059.0000, 'ºC'),
	(170911, 119, '2014-02-01 00:24:25.000000', 'temperatura', 913.0000, 'ºC'),
	(170912, 119, '2014-02-01 00:24:26.000000', 'temperatura', 188.0000, 'ºC'),
	(170913, 119, '2014-02-01 00:24:27.000000', 'temperatura', 604.0000, 'ºC'),
	(170914, 119, '2014-02-01 00:24:28.000000', 'temperatura', 53.0000, 'ºC'),
	(170915, 119, '2014-02-01 00:24:29.000000', 'temperatura', 857.0000, 'ºC'),
	(170916, 119, '2014-02-01 00:24:30.000000', 'temperatura', 524.0000, 'ºC'),
	(170917, 119, '2014-02-01 00:24:31.000000', 'temperatura', 48.0000, 'ºC'),
	(170918, 119, '2014-02-01 00:24:32.000000', 'temperatura', 1071.0000, 'ºC'),
	(170919, 119, '2014-02-01 00:24:33.000000', 'temperatura', 413.0000, 'ºC'),
	(170920, 119, '2014-02-01 00:24:34.000000', 'temperatura', 49.0000, 'ºC'),
	(170921, 119, '2014-02-01 00:24:35.000000', 'temperatura', 209.0000, 'ºC'),
	(170922, 119, '2014-02-01 00:24:36.000000', 'temperatura', 896.0000, 'ºC'),
	(170923, 119, '2014-02-01 00:24:37.000000', 'temperatura', 254.0000, 'ºC'),
	(170924, 119, '2014-02-01 00:24:38.000000', 'temperatura', 984.0000, 'ºC'),
	(170925, 119, '2014-02-01 00:24:39.000000', 'temperatura', 556.0000, 'ºC'),
	(170926, 119, '2014-02-01 00:24:40.000000', 'temperatura', 1030.0000, 'ºC'),
	(170927, 119, '2014-02-01 00:24:41.000000', 'temperatura', 1084.0000, 'ºC'),
	(170928, 119, '2014-02-01 00:24:42.000000', 'temperatura', 1129.0000, 'ºC'),
	(170929, 119, '2014-02-01 00:24:43.000000', 'temperatura', 1194.0000, 'ºC'),
	(170930, 119, '2014-02-01 00:24:44.000000', 'temperatura', 183.0000, 'ºC'),
	(170931, 119, '2014-02-01 00:24:45.000000', 'temperatura', 932.0000, 'ºC'),
	(170932, 119, '2014-02-01 00:24:46.000000', 'temperatura', 512.0000, 'ºC'),
	(170933, 119, '2014-02-01 00:24:47.000000', 'temperatura', 966.0000, 'ºC'),
	(170934, 119, '2014-02-01 00:24:48.000000', 'temperatura', 896.0000, 'ºC'),
	(170935, 119, '2014-02-01 00:24:49.000000', 'temperatura', 381.0000, 'ºC'),
	(170936, 119, '2014-02-01 00:24:50.000000', 'temperatura', 415.0000, 'ºC'),
	(170937, 119, '2014-02-01 00:24:51.000000', 'temperatura', 936.0000, 'ºC'),
	(170938, 119, '2014-02-01 00:24:52.000000', 'temperatura', 1035.0000, 'ºC'),
	(170939, 119, '2014-02-01 00:24:53.000000', 'temperatura', 1167.0000, 'ºC'),
	(170940, 119, '2014-02-01 00:24:54.000000', 'temperatura', 329.0000, 'ºC'),
	(170941, 119, '2014-02-01 00:24:55.000000', 'temperatura', 544.0000, 'ºC'),
	(170942, 119, '2014-02-01 00:24:56.000000', 'temperatura', 534.0000, 'ºC'),
	(170943, 119, '2014-02-01 00:24:57.000000', 'temperatura', 1040.0000, 'ºC'),
	(170944, 119, '2014-02-01 00:24:58.000000', 'temperatura', 1197.0000, 'ºC'),
	(170945, 119, '2014-02-01 00:24:59.000000', 'temperatura', 464.0000, 'ºC'),
	(170946, 119, '2014-02-01 00:25:00.000000', 'temperatura', 1131.0000, 'ºC'),
	(170947, 119, '2014-02-01 00:25:01.000000', 'temperatura', 663.0000, 'ºC'),
	(170948, 119, '2014-02-01 00:25:02.000000', 'temperatura', 1124.0000, 'ºC'),
	(170949, 119, '2014-02-01 00:25:03.000000', 'temperatura', 32.0000, 'ºC'),
	(170950, 119, '2014-02-01 00:25:04.000000', 'temperatura', 387.0000, 'ºC'),
	(170951, 119, '2014-02-01 00:25:05.000000', 'temperatura', 639.0000, 'ºC'),
	(170952, 119, '2014-02-01 00:25:06.000000', 'temperatura', 836.0000, 'ºC'),
	(170953, 119, '2014-02-01 00:25:07.000000', 'temperatura', 1065.0000, 'ºC'),
	(170954, 119, '2014-02-01 00:25:08.000000', 'temperatura', 415.0000, 'ºC'),
	(170955, 119, '2014-02-01 00:25:09.000000', 'temperatura', 83.0000, 'ºC'),
	(170956, 119, '2014-02-01 00:25:10.000000', 'temperatura', 369.0000, 'ºC'),
	(170957, 119, '2014-02-01 00:25:11.000000', 'temperatura', 398.0000, 'ºC'),
	(170958, 119, '2014-02-01 00:25:12.000000', 'temperatura', 881.0000, 'ºC'),
	(170959, 119, '2014-02-01 00:25:13.000000', 'temperatura', 813.0000, 'ºC'),
	(170960, 119, '2014-02-01 00:25:14.000000', 'temperatura', 221.0000, 'ºC'),
	(170961, 119, '2014-02-01 00:25:15.000000', 'temperatura', 1069.0000, 'ºC'),
	(170962, 119, '2014-02-01 00:25:16.000000', 'temperatura', 1082.0000, 'ºC'),
	(170963, 119, '2014-02-01 00:25:17.000000', 'temperatura', 1004.0000, 'ºC'),
	(170964, 119, '2014-02-01 00:25:18.000000', 'temperatura', 573.0000, 'ºC'),
	(170965, 119, '2014-02-01 00:25:19.000000', 'temperatura', 1054.0000, 'ºC'),
	(170966, 119, '2014-02-01 00:25:20.000000', 'temperatura', 1150.0000, 'ºC'),
	(170967, 119, '2014-02-01 00:25:21.000000', 'temperatura', 188.0000, 'ºC'),
	(170968, 119, '2014-02-01 00:25:22.000000', 'temperatura', 1090.0000, 'ºC'),
	(170969, 119, '2014-02-01 00:25:23.000000', 'temperatura', 90.0000, 'ºC'),
	(170970, 119, '2014-02-01 00:25:24.000000', 'temperatura', 777.0000, 'ºC'),
	(170971, 119, '2014-02-01 00:25:25.000000', 'temperatura', 18.0000, 'ºC'),
	(170972, 119, '2014-02-01 00:25:26.000000', 'temperatura', 159.0000, 'ºC'),
	(170973, 119, '2014-02-01 00:25:27.000000', 'temperatura', 740.0000, 'ºC'),
	(170974, 119, '2014-02-01 00:25:28.000000', 'temperatura', 825.0000, 'ºC'),
	(170975, 119, '2014-02-01 00:25:29.000000', 'temperatura', 707.0000, 'ºC'),
	(170976, 119, '2014-02-01 00:25:30.000000', 'temperatura', 1060.0000, 'ºC'),
	(170977, 119, '2014-02-01 00:25:31.000000', 'temperatura', 779.0000, 'ºC'),
	(170978, 119, '2014-02-01 00:25:32.000000', 'temperatura', 714.0000, 'ºC'),
	(170979, 119, '2014-02-01 00:25:33.000000', 'temperatura', 32.0000, 'ºC'),
	(170980, 119, '2014-02-01 00:25:34.000000', 'temperatura', 422.0000, 'ºC'),
	(170981, 119, '2014-02-01 00:25:35.000000', 'temperatura', 815.0000, 'ºC'),
	(170982, 119, '2014-02-01 00:25:36.000000', 'temperatura', 407.0000, 'ºC'),
	(170983, 119, '2014-02-01 00:25:37.000000', 'temperatura', 790.0000, 'ºC'),
	(170984, 119, '2014-02-01 00:25:38.000000', 'temperatura', 332.0000, 'ºC'),
	(170985, 119, '2014-02-01 00:25:39.000000', 'temperatura', 491.0000, 'ºC'),
	(170986, 119, '2014-02-01 00:25:40.000000', 'temperatura', 257.0000, 'ºC'),
	(170987, 119, '2014-02-01 00:25:41.000000', 'temperatura', 1012.0000, 'ºC'),
	(170988, 119, '2014-02-01 00:25:42.000000', 'temperatura', 689.0000, 'ºC'),
	(170989, 119, '2014-02-01 00:25:43.000000', 'temperatura', 409.0000, 'ºC'),
	(170990, 119, '2014-02-01 00:25:44.000000', 'temperatura', 1181.0000, 'ºC'),
	(170991, 119, '2014-02-01 00:25:45.000000', 'temperatura', 1076.0000, 'ºC'),
	(170992, 119, '2014-02-01 00:25:46.000000', 'temperatura', 640.0000, 'ºC'),
	(170993, 119, '2014-02-01 00:25:47.000000', 'temperatura', 1171.0000, 'ºC'),
	(170994, 119, '2014-02-01 00:25:48.000000', 'temperatura', 338.0000, 'ºC'),
	(170995, 119, '2014-02-01 00:25:49.000000', 'temperatura', 575.0000, 'ºC'),
	(170996, 119, '2014-02-01 00:25:50.000000', 'temperatura', 662.0000, 'ºC'),
	(170997, 119, '2014-02-01 00:25:51.000000', 'temperatura', 384.0000, 'ºC'),
	(170998, 119, '2014-02-01 00:25:52.000000', 'temperatura', 1134.0000, 'ºC'),
	(170999, 119, '2014-02-01 00:25:53.000000', 'temperatura', 920.0000, 'ºC'),
	(171000, 119, '2014-02-01 00:25:54.000000', 'temperatura', 1198.0000, 'ºC'),
	(171001, 119, '2014-02-01 00:25:55.000000', 'temperatura', 831.0000, 'ºC'),
	(171002, 119, '2014-02-01 00:25:56.000000', 'temperatura', 563.0000, 'ºC'),
	(171003, 119, '2014-02-01 00:25:57.000000', 'temperatura', 321.0000, 'ºC'),
	(171004, 119, '2014-02-01 00:25:58.000000', 'temperatura', 1116.0000, 'ºC'),
	(171005, 119, '2014-02-01 00:25:59.000000', 'temperatura', 1020.0000, 'ºC'),
	(171006, 119, '2014-02-01 00:26:00.000000', 'temperatura', 552.0000, 'ºC'),
	(171007, 119, '2014-02-01 00:26:01.000000', 'temperatura', 898.0000, 'ºC'),
	(171008, 119, '2014-02-01 00:26:02.000000', 'temperatura', 437.0000, 'ºC'),
	(171009, 119, '2014-02-01 00:26:03.000000', 'temperatura', 689.0000, 'ºC'),
	(171010, 119, '2014-02-01 00:26:04.000000', 'temperatura', 936.0000, 'ºC'),
	(171011, 119, '2014-02-01 00:26:05.000000', 'temperatura', 213.0000, 'ºC'),
	(171012, 119, '2014-02-01 00:26:06.000000', 'temperatura', 656.0000, 'ºC'),
	(171013, 119, '2014-02-01 00:26:07.000000', 'temperatura', 241.0000, 'ºC'),
	(171014, 119, '2014-02-01 00:26:08.000000', 'temperatura', 440.0000, 'ºC'),
	(171015, 119, '2014-02-01 00:26:09.000000', 'temperatura', 277.0000, 'ºC'),
	(171016, 119, '2014-02-01 00:26:10.000000', 'temperatura', 67.0000, 'ºC'),
	(171017, 119, '2014-02-01 00:26:11.000000', 'temperatura', 703.0000, 'ºC'),
	(171018, 119, '2014-02-01 00:26:12.000000', 'temperatura', 913.0000, 'ºC'),
	(171019, 119, '2014-02-01 00:26:13.000000', 'temperatura', 57.0000, 'ºC'),
	(171020, 119, '2014-02-01 00:26:14.000000', 'temperatura', 1147.0000, 'ºC'),
	(171021, 119, '2014-02-01 00:26:15.000000', 'temperatura', 762.0000, 'ºC'),
	(171022, 119, '2014-02-01 00:26:16.000000', 'temperatura', 373.0000, 'ºC'),
	(171023, 119, '2014-02-01 00:26:17.000000', 'temperatura', 779.0000, 'ºC'),
	(171024, 119, '2014-02-01 00:26:18.000000', 'temperatura', 378.0000, 'ºC'),
	(171025, 119, '2014-02-01 00:26:19.000000', 'temperatura', 752.0000, 'ºC'),
	(171026, 119, '2014-02-01 00:26:20.000000', 'temperatura', 228.0000, 'ºC'),
	(171027, 119, '2014-02-01 00:26:21.000000', 'temperatura', 86.0000, 'ºC'),
	(171028, 119, '2014-02-01 00:26:22.000000', 'temperatura', 943.0000, 'ºC'),
	(171029, 119, '2014-02-01 00:26:23.000000', 'temperatura', 859.0000, 'ºC'),
	(171030, 119, '2014-02-01 00:26:24.000000', 'temperatura', 267.0000, 'ºC'),
	(171031, 119, '2014-02-01 00:26:25.000000', 'temperatura', 1159.0000, 'ºC'),
	(171032, 119, '2014-02-01 00:26:26.000000', 'temperatura', 195.0000, 'ºC'),
	(171033, 119, '2014-02-01 00:26:27.000000', 'temperatura', 1096.0000, 'ºC'),
	(171034, 119, '2014-02-01 00:26:28.000000', 'temperatura', 96.0000, 'ºC'),
	(171035, 119, '2014-02-01 00:26:29.000000', 'temperatura', 792.0000, 'ºC'),
	(171036, 119, '2014-02-01 00:26:30.000000', 'temperatura', 74.0000, 'ºC'),
	(171037, 119, '2014-02-01 00:26:31.000000', 'temperatura', 392.0000, 'ºC'),
	(171038, 119, '2014-02-01 00:26:32.000000', 'temperatura', 542.0000, 'ºC'),
	(171039, 119, '2014-02-01 00:26:33.000000', 'temperatura', 332.0000, 'ºC'),
	(171040, 119, '2014-02-01 00:26:34.000000', 'temperatura', 34.0000, 'ºC'),
	(171041, 119, '2014-02-01 00:26:35.000000', 'temperatura', 377.0000, 'ºC'),
	(171042, 119, '2014-02-01 00:26:36.000000', 'temperatura', 583.0000, 'ºC'),
	(171043, 119, '2014-02-01 00:26:37.000000', 'temperatura', 584.0000, 'ºC'),
	(171044, 119, '2014-02-01 00:26:38.000000', 'temperatura', 1170.0000, 'ºC'),
	(171045, 119, '2014-02-01 00:26:39.000000', 'temperatura', 498.0000, 'ºC'),
	(171046, 119, '2014-02-01 00:26:40.000000', 'temperatura', 180.0000, 'ºC'),
	(171047, 119, '2014-02-01 00:26:41.000000', 'temperatura', 605.0000, 'ºC'),
	(171048, 119, '2014-02-01 00:26:42.000000', 'temperatura', 89.0000, 'ºC'),
	(171049, 119, '2014-02-01 00:26:43.000000', 'temperatura', 1031.0000, 'ºC'),
	(171050, 119, '2014-02-01 00:26:44.000000', 'temperatura', 87.0000, 'ºC'),
	(171051, 119, '2014-02-01 00:26:45.000000', 'temperatura', 945.0000, 'ºC'),
	(171052, 119, '2014-02-01 00:26:46.000000', 'temperatura', 861.0000, 'ºC'),
	(171053, 119, '2014-02-01 00:26:47.000000', 'temperatura', 272.0000, 'ºC'),
	(171054, 119, '2014-02-01 00:26:48.000000', 'temperatura', 1178.0000, 'ºC'),
	(171055, 119, '2014-02-01 00:26:49.000000', 'temperatura', 276.0000, 'ºC'),
	(171056, 119, '2014-02-01 00:26:50.000000', 'temperatura', 245.0000, 'ºC'),
	(171057, 119, '2014-02-01 00:26:51.000000', 'temperatura', 399.0000, 'ºC'),
	(171058, 119, '2014-02-01 00:26:52.000000', 'temperatura', 61.0000, 'ºC'),
	(171059, 119, '2014-02-01 00:26:53.000000', 'temperatura', 308.0000, 'ºC'),
	(171060, 119, '2014-02-01 00:26:54.000000', 'temperatura', 156.0000, 'ºC'),
	(171061, 119, '2014-02-01 00:26:55.000000', 'temperatura', 1057.0000, 'ºC'),
	(171062, 119, '2014-02-01 00:26:56.000000', 'temperatura', 18.0000, 'ºC'),
	(171063, 119, '2014-02-01 00:26:57.000000', 'temperatura', 521.0000, 'ºC'),
	(171064, 119, '2014-02-01 00:26:58.000000', 'temperatura', 152.0000, 'ºC'),
	(171065, 119, '2014-02-01 00:26:59.000000', 'temperatura', 396.0000, 'ºC'),
	(171066, 119, '2014-02-01 00:27:00.000000', 'temperatura', 324.0000, 'ºC'),
	(171067, 119, '2014-02-01 00:27:01.000000', 'temperatura', 432.0000, 'ºC'),
	(171068, 119, '2014-02-01 00:27:02.000000', 'temperatura', 1187.0000, 'ºC'),
	(171069, 119, '2014-02-01 00:27:03.000000', 'temperatura', 1043.0000, 'ºC'),
	(171070, 119, '2014-02-01 00:27:04.000000', 'temperatura', 452.0000, 'ºC'),
	(171071, 119, '2014-02-01 00:27:05.000000', 'temperatura', 330.0000, 'ºC'),
	(171072, 119, '2014-02-01 00:27:06.000000', 'temperatura', 297.0000, 'ºC'),
	(171073, 119, '2014-02-01 00:27:07.000000', 'temperatura', 496.0000, 'ºC'),
	(171074, 119, '2014-02-01 00:27:08.000000', 'temperatura', 390.0000, 'ºC'),
	(171075, 119, '2014-02-01 00:27:09.000000', 'temperatura', 461.0000, 'ºC'),
	(171076, 119, '2014-02-01 00:27:10.000000', 'temperatura', 1138.0000, 'ºC'),
	(171077, 119, '2014-02-01 00:27:11.000000', 'temperatura', 706.0000, 'ºC'),
	(171078, 119, '2014-02-01 00:27:12.000000', 'temperatura', 117.0000, 'ºC'),
	(171079, 119, '2014-02-01 00:27:13.000000', 'temperatura', 867.0000, 'ºC'),
	(171080, 119, '2014-02-01 00:27:14.000000', 'temperatura', 386.0000, 'ºC'),
	(171081, 119, '2014-02-01 00:27:15.000000', 'temperatura', 528.0000, 'ºC'),
	(171082, 119, '2014-02-01 00:27:16.000000', 'temperatura', 283.0000, 'ºC'),
	(171083, 119, '2014-02-01 00:27:17.000000', 'temperatura', 1030.0000, 'ºC'),
	(171084, 119, '2014-02-01 00:27:18.000000', 'temperatura', 700.0000, 'ºC'),
	(171085, 119, '2014-02-01 00:27:19.000000', 'temperatura', 414.0000, 'ºC'),
	(171086, 119, '2014-02-01 00:27:20.000000', 'temperatura', 1169.0000, 'ºC'),
	(171087, 119, '2014-02-01 00:27:21.000000', 'temperatura', 1002.0000, 'ºC'),
	(171088, 119, '2014-02-01 00:27:22.000000', 'temperatura', 306.0000, 'ºC'),
	(171089, 119, '2014-02-01 00:27:23.000000', 'temperatura', 925.0000, 'ºC'),
	(171090, 119, '2014-02-01 00:27:24.000000', 'temperatura', 105.0000, 'ºC'),
	(171091, 119, '2014-02-01 00:27:25.000000', 'temperatura', 153.0000, 'ºC'),
	(171092, 119, '2014-02-01 00:27:26.000000', 'temperatura', 451.0000, 'ºC'),
	(171093, 119, '2014-02-01 00:27:27.000000', 'temperatura', 594.0000, 'ºC'),
	(171094, 119, '2014-02-01 00:27:28.000000', 'temperatura', 419.0000, 'ºC'),
	(171095, 119, '2014-02-01 00:27:29.000000', 'temperatura', 312.0000, 'ºC'),
	(171096, 119, '2014-02-01 00:27:30.000000', 'temperatura', 305.0000, 'ºC'),
	(171097, 119, '2014-02-01 00:27:31.000000', 'temperatura', 589.0000, 'ºC'),
	(171098, 119, '2014-02-01 00:27:32.000000', 'temperatura', 832.0000, 'ºC'),
	(171099, 119, '2014-02-01 00:27:33.000000', 'temperatura', 1194.0000, 'ºC'),
	(171100, 119, '2014-02-01 00:27:34.000000', 'temperatura', 1071.0000, 'ºC'),
	(171101, 119, '2014-02-01 00:27:35.000000', 'temperatura', 577.0000, 'ºC'),
	(171102, 119, '2014-02-01 00:27:36.000000', 'temperatura', 871.0000, 'ºC'),
	(171103, 119, '2014-02-01 00:27:37.000000', 'temperatura', 225.0000, 'ºC'),
	(171104, 119, '2014-02-01 00:27:38.000000', 'temperatura', 912.0000, 'ºC'),
	(171105, 119, '2014-02-01 00:27:39.000000', 'temperatura', 288.0000, 'ºC'),
	(171106, 119, '2014-02-01 00:27:40.000000', 'temperatura', 1102.0000, 'ºC'),
	(171107, 119, '2014-02-01 00:27:41.000000', 'temperatura', 1047.0000, 'ºC'),
	(171108, 119, '2014-02-01 00:27:42.000000', 'temperatura', 730.0000, 'ºC'),
	(171109, 119, '2014-02-01 00:27:43.000000', 'temperatura', 511.0000, 'ºC'),
	(171110, 119, '2014-02-01 00:27:44.000000', 'temperatura', 364.0000, 'ºC'),
	(171111, 119, '2014-02-01 00:27:45.000000', 'temperatura', 288.0000, 'ºC'),
	(171112, 119, '2014-02-01 00:27:46.000000', 'temperatura', 349.0000, 'ºC'),
	(171113, 119, '2014-02-01 00:27:47.000000', 'temperatura', 879.0000, 'ºC'),
	(171114, 119, '2014-02-01 00:27:48.000000', 'temperatura', 951.0000, 'ºC'),
	(171115, 119, '2014-02-01 00:27:49.000000', 'temperatura', 916.0000, 'ºC'),
	(171116, 119, '2014-02-01 00:27:50.000000', 'temperatura', 528.0000, 'ºC'),
	(171117, 119, '2014-02-01 00:27:51.000000', 'temperatura', 1094.0000, 'ºC'),
	(171118, 119, '2014-02-01 00:27:52.000000', 'temperatura', 284.0000, 'ºC'),
	(171119, 119, '2014-02-01 00:27:53.000000', 'temperatura', 539.0000, 'ºC'),
	(171120, 119, '2014-02-01 00:27:54.000000', 'temperatura', 642.0000, 'ºC'),
	(171121, 119, '2014-02-01 00:27:55.000000', 'temperatura', 394.0000, 'ºC'),
	(171122, 119, '2014-02-01 00:27:56.000000', 'temperatura', 47.0000, 'ºC'),
	(171123, 119, '2014-02-01 00:27:57.000000', 'temperatura', 252.0000, 'ºC'),
	(171124, 119, '2014-02-01 00:27:58.000000', 'temperatura', 1121.0000, 'ºC'),
	(171125, 119, '2014-02-01 00:27:59.000000', 'temperatura', 48.0000, 'ºC'),
	(171126, 119, '2014-02-01 00:28:00.000000', 'temperatura', 480.0000, 'ºC'),
	(171127, 119, '2014-02-01 00:28:01.000000', 'temperatura', 1055.0000, 'ºC'),
	(171128, 119, '2014-02-01 00:28:02.000000', 'temperatura', 234.0000, 'ºC'),
	(171129, 119, '2014-02-01 00:28:03.000000', 'temperatura', 405.0000, 'ºC'),
	(171130, 119, '2014-02-01 00:28:04.000000', 'temperatura', 126.0000, 'ºC'),
	(171131, 119, '2014-02-01 00:28:05.000000', 'temperatura', 615.0000, 'ºC'),
	(171132, 119, '2014-02-01 00:28:06.000000', 'temperatura', 298.0000, 'ºC'),
	(171133, 119, '2014-02-01 00:28:07.000000', 'temperatura', 846.0000, 'ºC'),
	(171134, 119, '2014-02-01 00:28:08.000000', 'temperatura', 937.0000, 'ºC'),
	(171135, 119, '2014-02-01 00:28:09.000000', 'temperatura', 948.0000, 'ºC'),
	(171136, 119, '2014-02-01 00:28:10.000000', 'temperatura', 729.0000, 'ºC'),
	(171137, 119, '2014-02-01 00:28:11.000000', 'temperatura', 800.0000, 'ºC'),
	(171138, 119, '2014-02-01 00:28:12.000000', 'temperatura', 616.0000, 'ºC'),
	(171139, 119, '2014-02-01 00:28:13.000000', 'temperatura', 681.0000, 'ºC'),
	(171140, 119, '2014-02-01 00:28:14.000000', 'temperatura', 356.0000, 'ºC'),
	(171141, 119, '2014-02-01 00:28:15.000000', 'temperatura', 937.0000, 'ºC'),
	(171142, 119, '2014-02-01 00:28:16.000000', 'temperatura', 16.0000, 'ºC'),
	(171143, 119, '2014-02-01 00:28:17.000000', 'temperatura', 873.0000, 'ºC'),
	(171144, 119, '2014-02-01 00:28:18.000000', 'temperatura', 716.0000, 'ºC'),
	(171145, 119, '2014-02-01 00:28:19.000000', 'temperatura', 961.0000, 'ºC'),
	(171146, 119, '2014-02-01 00:28:20.000000', 'temperatura', 259.0000, 'ºC'),
	(171147, 119, '2014-02-01 00:28:21.000000', 'temperatura', 813.0000, 'ºC'),
	(171148, 119, '2014-02-01 00:28:22.000000', 'temperatura', 889.0000, 'ºC'),
	(171149, 119, '2014-02-01 00:28:23.000000', 'temperatura', 806.0000, 'ºC'),
	(171150, 119, '2014-02-01 00:28:24.000000', 'temperatura', 163.0000, 'ºC'),
	(171151, 119, '2014-02-01 00:28:25.000000', 'temperatura', 798.0000, 'ºC'),
	(171152, 119, '2014-02-01 00:28:26.000000', 'temperatura', 1103.0000, 'ºC'),
	(171153, 119, '2014-02-01 00:28:27.000000', 'temperatura', 720.0000, 'ºC'),
	(171154, 119, '2014-02-01 00:28:28.000000', 'temperatura', 293.0000, 'ºC'),
	(171155, 119, '2014-02-01 00:28:29.000000', 'temperatura', 504.0000, 'ºC'),
	(171156, 119, '2014-02-01 00:28:30.000000', 'temperatura', 443.0000, 'ºC'),
	(171157, 119, '2014-02-01 00:28:31.000000', 'temperatura', 703.0000, 'ºC'),
	(171158, 119, '2014-02-01 00:28:32.000000', 'temperatura', 988.0000, 'ºC'),
	(171159, 119, '2014-02-01 00:28:33.000000', 'temperatura', 432.0000, 'ºC'),
	(171160, 119, '2014-02-01 00:28:34.000000', 'temperatura', 394.0000, 'ºC'),
	(171161, 119, '2014-02-01 00:28:35.000000', 'temperatura', 677.0000, 'ºC'),
	(171162, 119, '2014-02-01 00:28:36.000000', 'temperatura', 1003.0000, 'ºC'),
	(171163, 119, '2014-02-01 00:28:37.000000', 'temperatura', 585.0000, 'ºC'),
	(171164, 119, '2014-02-01 00:28:38.000000', 'temperatura', 1115.0000, 'ºC'),
	(171165, 119, '2014-02-01 00:28:39.000000', 'temperatura', 221.0000, 'ºC'),
	(171166, 119, '2014-02-01 00:28:40.000000', 'temperatura', 162.0000, 'ºC'),
	(171167, 119, '2014-02-01 00:28:41.000000', 'temperatura', 145.0000, 'ºC'),
	(171168, 119, '2014-02-01 00:28:42.000000', 'temperatura', 242.0000, 'ºC'),
	(171169, 119, '2014-02-01 00:28:43.000000', 'temperatura', 773.0000, 'ºC'),
	(171170, 119, '2014-02-01 00:28:44.000000', 'temperatura', 739.0000, 'ºC'),
	(171171, 119, '2014-02-01 00:28:45.000000', 'temperatura', 179.0000, 'ºC'),
	(171172, 119, '2014-02-01 00:28:46.000000', 'temperatura', 1076.0000, 'ºC'),
	(171173, 119, '2014-02-01 00:28:47.000000', 'temperatura', 46.0000, 'ºC'),
	(171174, 119, '2014-02-01 00:28:48.000000', 'temperatura', 600.0000, 'ºC'),
	(171175, 119, '2014-02-01 00:28:49.000000', 'temperatura', 464.0000, 'ºC'),
	(171176, 119, '2014-02-01 00:28:50.000000', 'temperatura', 520.0000, 'ºC'),
	(171177, 119, '2014-02-01 00:28:51.000000', 'temperatura', 10.0000, 'ºC'),
	(171178, 119, '2014-02-01 00:28:52.000000', 'temperatura', 889.0000, 'ºC'),
	(171179, 119, '2014-02-01 00:28:53.000000', 'temperatura', 817.0000, 'ºC'),
	(171180, 119, '2014-02-01 00:28:54.000000', 'temperatura', 216.0000, 'ºC'),
	(171181, 119, '2014-02-01 00:28:55.000000', 'temperatura', 1030.0000, 'ºC'),
	(171182, 119, '2014-02-01 00:28:56.000000', 'temperatura', 901.0000, 'ºC'),
	(171183, 119, '2014-02-01 00:28:57.000000', 'temperatura', 217.0000, 'ºC'),
	(171184, 119, '2014-02-01 00:28:58.000000', 'temperatura', 783.0000, 'ºC'),
	(171185, 119, '2014-02-01 00:28:59.000000', 'temperatura', 864.0000, 'ºC'),
	(171186, 119, '2014-02-01 00:29:00.000000', 'temperatura', 773.0000, 'ºC'),
	(171187, 119, '2014-02-01 00:29:01.000000', 'temperatura', 71.0000, 'ºC'),
	(171188, 119, '2014-02-01 00:29:02.000000', 'temperatura', 436.0000, 'ºC'),
	(171189, 119, '2014-02-01 00:29:03.000000', 'temperatura', 769.0000, 'ºC'),
	(171190, 119, '2014-02-01 00:29:04.000000', 'temperatura', 138.0000, 'ºC'),
	(171191, 119, '2014-02-01 00:29:05.000000', 'temperatura', 783.0000, 'ºC'),
	(171192, 119, '2014-02-01 00:29:06.000000', 'temperatura', 1103.0000, 'ºC'),
	(171193, 119, '2014-02-01 00:29:07.000000', 'temperatura', 764.0000, 'ºC'),
	(171194, 119, '2014-02-01 00:29:08.000000', 'temperatura', 514.0000, 'ºC'),
	(171195, 119, '2014-02-01 00:29:09.000000', 'temperatura', 277.0000, 'ºC'),
	(171196, 119, '2014-02-01 00:29:10.000000', 'temperatura', 1045.0000, 'ºC'),
	(171197, 119, '2014-02-01 00:29:11.000000', 'temperatura', 793.0000, 'ºC'),
	(171198, 119, '2014-02-01 00:29:12.000000', 'temperatura', 833.0000, 'ºC'),
	(171199, 119, '2014-02-01 00:29:13.000000', 'temperatura', 583.0000, 'ºC'),
	(171200, 119, '2014-02-01 00:29:14.000000', 'temperatura', 418.0000, 'ºC'),
	(171201, 119, '2014-02-01 00:29:15.000000', 'temperatura', 343.0000, 'ºC'),
	(171202, 119, '2014-02-01 00:29:16.000000', 'temperatura', 458.0000, 'ºC'),
	(171203, 119, '2014-02-01 00:29:17.000000', 'temperatura', 65.0000, 'ºC'),
	(171204, 119, '2014-02-01 00:29:18.000000', 'temperatura', 149.0000, 'ºC'),
	(171205, 119, '2014-02-01 00:29:19.000000', 'temperatura', 550.0000, 'ºC'),
	(171206, 119, '2014-02-01 00:29:20.000000', 'temperatura', 1106.0000, 'ºC'),
	(171207, 119, '2014-02-01 00:29:21.000000', 'temperatura', 279.0000, 'ºC'),
	(171208, 119, '2014-02-01 00:29:22.000000', 'temperatura', 479.0000, 'ºC'),
	(171209, 119, '2014-02-01 00:29:23.000000', 'temperatura', 356.0000, 'ºC'),
	(171210, 119, '2014-02-01 00:29:24.000000', 'temperatura', 343.0000, 'ºC'),
	(171211, 119, '2014-02-01 00:29:25.000000', 'temperatura', 650.0000, 'ºC'),
	(171212, 119, '2014-02-01 00:29:26.000000', 'temperatura', 1019.0000, 'ºC'),
	(171213, 119, '2014-02-01 00:29:27.000000', 'temperatura', 745.0000, 'ºC'),
	(171214, 119, '2014-02-01 00:29:28.000000', 'temperatura', 671.0000, 'ºC'),
	(171215, 119, '2014-02-01 00:29:29.000000', 'temperatura', 1120.0000, 'ºC'),
	(171216, 119, '2014-02-01 00:29:30.000000', 'temperatura', 1187.0000, 'ºC'),
	(171217, 119, '2014-02-01 00:29:31.000000', 'temperatura', 177.0000, 'ºC'),
	(171218, 119, '2014-02-01 00:29:32.000000', 'temperatura', 923.0000, 'ºC'),
	(171219, 119, '2014-02-01 00:29:33.000000', 'temperatura', 486.0000, 'ºC'),
	(171220, 119, '2014-02-01 00:29:34.000000', 'temperatura', 859.0000, 'ºC'),
	(171221, 119, '2014-02-01 00:29:35.000000', 'temperatura', 439.0000, 'ºC'),
	(171222, 119, '2014-02-01 00:29:36.000000', 'temperatura', 817.0000, 'ºC'),
	(171223, 119, '2014-02-01 00:29:37.000000', 'temperatura', 369.0000, 'ºC'),
	(171224, 119, '2014-02-01 00:29:38.000000', 'temperatura', 593.0000, 'ºC'),
	(171225, 119, '2014-02-01 00:29:39.000000', 'temperatura', 661.0000, 'ºC'),
	(171226, 119, '2014-02-01 00:29:40.000000', 'temperatura', 324.0000, 'ºC'),
	(171227, 119, '2014-02-01 00:29:41.000000', 'temperatura', 841.0000, 'ºC'),
	(171228, 119, '2014-02-01 00:29:42.000000', 'temperatura', 831.0000, 'ºC'),
	(171229, 119, '2014-02-01 00:29:43.000000', 'temperatura', 431.0000, 'ºC'),
	(171230, 119, '2014-02-01 00:29:44.000000', 'temperatura', 865.0000, 'ºC'),
	(171231, 119, '2014-02-01 00:29:45.000000', 'temperatura', 631.0000, 'ºC'),
	(171232, 119, '2014-02-01 00:29:46.000000', 'temperatura', 562.0000, 'ºC'),
	(171233, 119, '2014-02-01 00:29:47.000000', 'temperatura', 915.0000, 'ºC'),
	(171234, 119, '2014-02-01 00:29:48.000000', 'temperatura', 490.0000, 'ºC'),
	(171235, 119, '2014-02-01 00:29:49.000000', 'temperatura', 907.0000, 'ºC'),
	(171236, 119, '2014-02-01 00:29:50.000000', 'temperatura', 663.0000, 'ºC'),
	(171237, 119, '2014-02-01 00:29:51.000000', 'temperatura', 597.0000, 'ºC'),
	(171238, 119, '2014-02-01 00:29:52.000000', 'temperatura', 996.0000, 'ºC'),
	(171239, 119, '2014-02-01 00:29:53.000000', 'temperatura', 789.0000, 'ºC'),
	(171240, 119, '2014-02-01 00:29:54.000000', 'temperatura', 956.0000, 'ºC'),
	(171241, 119, '2014-02-01 00:29:55.000000', 'temperatura', 16.0000, 'ºC'),
	(171242, 119, '2014-02-01 00:29:56.000000', 'temperatura', 813.0000, 'ºC'),
	(171243, 119, '2014-02-01 00:29:57.000000', 'temperatura', 418.0000, 'ºC'),
	(171244, 119, '2014-02-01 00:29:58.000000', 'temperatura', 850.0000, 'ºC'),
	(171245, 119, '2014-02-01 00:29:59.000000', 'temperatura', 596.0000, 'ºC'),
	(171246, 119, '2014-02-01 00:30:00.000000', 'temperatura', 431.0000, 'ºC'),
	(171247, 119, '2014-02-01 00:30:01.000000', 'temperatura', 367.0000, 'ºC'),
	(171248, 119, '2014-02-01 00:30:02.000000', 'temperatura', 545.0000, 'ºC'),
	(171249, 119, '2014-02-01 00:30:03.000000', 'temperatura', 422.0000, 'ºC'),
	(171250, 119, '2014-02-01 00:30:04.000000', 'temperatura', 476.0000, 'ºC'),
	(171251, 119, '2014-02-01 00:30:05.000000', 'temperatura', 1117.0000, 'ºC'),
	(171252, 119, '2014-02-01 00:30:06.000000', 'temperatura', 555.0000, 'ºC'),
	(171253, 119, '2014-02-01 00:30:07.000000', 'temperatura', 624.0000, 'ºC'),
	(171254, 119, '2014-02-01 00:30:08.000000', 'temperatura', 255.0000, 'ºC'),
	(171255, 119, '2014-02-01 00:30:09.000000', 'temperatura', 604.0000, 'ºC'),
	(171256, 119, '2014-02-01 00:30:10.000000', 'temperatura', 1056.0000, 'ºC'),
	(171257, 119, '2014-02-01 00:30:11.000000', 'temperatura', 1070.0000, 'ºC'),
	(171258, 119, '2014-02-01 00:30:12.000000', 'temperatura', 980.0000, 'ºC'),
	(171259, 119, '2014-02-01 00:30:13.000000', 'temperatura', 492.0000, 'ºC'),
	(171260, 119, '2014-02-01 00:30:14.000000', 'temperatura', 721.0000, 'ºC'),
	(171261, 119, '2014-02-01 00:30:15.000000', 'temperatura', 931.0000, 'ºC'),
	(171262, 119, '2014-02-01 00:30:16.000000', 'temperatura', 90.0000, 'ºC'),
	(171263, 119, '2014-02-01 00:30:17.000000', 'temperatura', 59.0000, 'ºC'),
	(171264, 119, '2014-02-01 00:30:18.000000', 'temperatura', 23.0000, 'ºC'),
	(171265, 119, '2014-02-01 00:30:19.000000', 'temperatura', 1140.0000, 'ºC'),
	(171266, 119, '2014-02-01 00:30:20.000000', 'temperatura', 833.0000, 'ºC'),
	(171267, 119, '2014-02-01 00:30:21.000000', 'temperatura', 743.0000, 'ºC'),
	(171268, 119, '2014-02-01 00:30:22.000000', 'temperatura', 19.0000, 'ºC'),
	(171269, 119, '2014-02-01 00:30:23.000000', 'temperatura', 264.0000, 'ºC'),
	(171270, 119, '2014-02-01 00:30:24.000000', 'temperatura', 66.0000, 'ºC'),
	(171271, 119, '2014-02-01 00:30:25.000000', 'temperatura', 737.0000, 'ºC'),
	(171272, 119, '2014-02-01 00:30:26.000000', 'temperatura', 1087.0000, 'ºC'),
	(171273, 119, '2014-02-01 00:30:27.000000', 'temperatura', 827.0000, 'ºC'),
	(171274, 119, '2014-02-01 00:30:28.000000', 'temperatura', 874.0000, 'ºC'),
	(171275, 119, '2014-02-01 00:30:29.000000', 'temperatura', 687.0000, 'ºC'),
	(171276, 119, '2014-02-01 00:30:30.000000', 'temperatura', 815.0000, 'ºC'),
	(171277, 119, '2014-02-01 00:30:31.000000', 'temperatura', 816.0000, 'ºC'),
	(171278, 119, '2014-02-01 00:30:32.000000', 'temperatura', 433.0000, 'ºC'),
	(171279, 119, '2014-02-01 00:30:33.000000', 'temperatura', 919.0000, 'ºC'),
	(171280, 119, '2014-02-01 00:30:34.000000', 'temperatura', 896.0000, 'ºC'),
	(171281, 119, '2014-02-01 00:30:35.000000', 'temperatura', 524.0000, 'ºC'),
	(171282, 119, '2014-02-01 00:30:36.000000', 'temperatura', 1131.0000, 'ºC'),
	(171283, 119, '2014-02-01 00:30:37.000000', 'temperatura', 483.0000, 'ºC'),
	(171284, 119, '2014-02-01 00:30:38.000000', 'temperatura', 223.0000, 'ºC'),
	(171285, 119, '2014-02-01 00:30:39.000000', 'temperatura', 868.0000, 'ºC'),
	(171286, 119, '2014-02-01 00:30:40.000000', 'temperatura', 71.0000, 'ºC'),
	(171287, 119, '2014-02-01 00:30:41.000000', 'temperatura', 152.0000, 'ºC'),
	(171288, 119, '2014-02-01 00:30:42.000000', 'temperatura', 547.0000, 'ºC'),
	(171289, 119, '2014-02-01 00:30:43.000000', 'temperatura', 1082.0000, 'ºC'),
	(171290, 119, '2014-02-01 00:30:44.000000', 'temperatura', 166.0000, 'ºC'),
	(171291, 119, '2014-02-01 00:30:45.000000', 'temperatura', 1186.0000, 'ºC'),
	(171292, 119, '2014-02-01 00:30:46.000000', 'temperatura', 633.0000, 'ºC'),
	(171293, 119, '2014-02-01 00:30:47.000000', 'temperatura', 806.0000, 'ºC'),
	(171294, 119, '2014-02-01 00:30:48.000000', 'temperatura', 933.0000, 'ºC'),
	(171295, 119, '2014-02-01 00:30:49.000000', 'temperatura', 1049.0000, 'ºC'),
	(171296, 119, '2014-02-01 00:30:50.000000', 'temperatura', 44.0000, 'ºC'),
	(171297, 119, '2014-02-01 00:30:51.000000', 'temperatura', 675.0000, 'ºC'),
	(171298, 119, '2014-02-01 00:30:52.000000', 'temperatura', 844.0000, 'ºC'),
	(171299, 119, '2014-02-01 00:30:53.000000', 'temperatura', 997.0000, 'ºC'),
	(171300, 119, '2014-02-01 00:30:54.000000', 'temperatura', 50.0000, 'ºC'),
	(171301, 119, '2014-02-01 00:30:55.000000', 'temperatura', 861.0000, 'ºC'),
	(171302, 119, '2014-02-01 00:30:56.000000', 'temperatura', 554.0000, 'ºC'),
	(171303, 119, '2014-02-01 00:30:57.000000', 'temperatura', 190.0000, 'ºC'),
	(171304, 119, '2014-02-01 00:30:58.000000', 'temperatura', 489.0000, 'ºC'),
	(171305, 119, '2014-02-01 00:30:59.000000', 'temperatura', 673.0000, 'ºC'),
	(171306, 119, '2014-02-01 00:31:00.000000', 'temperatura', 701.0000, 'ºC'),
	(171307, 119, '2014-02-01 00:31:01.000000', 'temperatura', 286.0000, 'ºC'),
	(171308, 119, '2014-02-01 00:31:02.000000', 'temperatura', 529.0000, 'ºC'),
	(171309, 119, '2014-02-01 00:31:03.000000', 'temperatura', 586.0000, 'ºC'),
	(171310, 119, '2014-02-01 00:31:04.000000', 'temperatura', 142.0000, 'ºC'),
	(171311, 119, '2014-02-01 00:31:05.000000', 'temperatura', 155.0000, 'ºC'),
	(171312, 119, '2014-02-01 00:31:06.000000', 'temperatura', 347.0000, 'ºC'),
	(171313, 119, '2014-02-01 00:31:07.000000', 'temperatura', 74.0000, 'ºC'),
	(171314, 119, '2014-02-01 00:31:08.000000', 'temperatura', 526.0000, 'ºC'),
	(171315, 119, '2014-02-01 00:31:09.000000', 'temperatura', 9.0000, 'ºC'),
	(171316, 119, '2014-02-01 00:31:10.000000', 'temperatura', 868.0000, 'ºC'),
	(171317, 119, '2014-02-01 00:31:11.000000', 'temperatura', 713.0000, 'ºC'),
	(171318, 119, '2014-02-01 00:31:12.000000', 'temperatura', 960.0000, 'ºC'),
	(171319, 119, '2014-02-01 00:31:13.000000', 'temperatura', 264.0000, 'ºC'),
	(171320, 119, '2014-02-01 00:31:14.000000', 'temperatura', 838.0000, 'ºC'),
	(171321, 119, '2014-02-01 00:31:15.000000', 'temperatura', 998.0000, 'ºC'),
	(171322, 119, '2014-02-01 00:31:16.000000', 'temperatura', 78.0000, 'ºC'),
	(171323, 119, '2014-02-01 00:31:17.000000', 'temperatura', 996.0000, 'ºC'),
	(171324, 119, '2014-02-01 00:31:18.000000', 'temperatura', 1147.0000, 'ºC'),
	(171325, 119, '2014-02-01 00:31:19.000000', 'temperatura', 346.0000, 'ºC'),
	(171326, 119, '2014-02-01 00:31:20.000000', 'temperatura', 689.0000, 'ºC'),
	(171327, 119, '2014-02-01 00:31:21.000000', 'temperatura', 9.0000, 'ºC'),
	(171328, 119, '2014-02-01 00:31:22.000000', 'temperatura', 376.0000, 'ºC'),
	(171329, 119, '2014-02-01 00:31:23.000000', 'temperatura', 656.0000, 'ºC'),
	(171330, 119, '2014-02-01 00:31:24.000000', 'temperatura', 951.0000, 'ºC'),
	(171331, 119, '2014-02-01 00:31:25.000000', 'temperatura', 386.0000, 'ºC'),
	(171332, 119, '2014-02-01 00:31:26.000000', 'temperatura', 280.0000, 'ºC'),
	(171333, 119, '2014-02-01 00:31:27.000000', 'temperatura', 244.0000, 'ºC'),
	(171334, 119, '2014-02-01 00:31:28.000000', 'temperatura', 377.0000, 'ºC'),
	(171335, 119, '2014-02-01 00:31:29.000000', 'temperatura', 1155.0000, 'ºC'),
	(171336, 119, '2014-02-01 00:31:30.000000', 'temperatura', 1044.0000, 'ºC'),
	(171337, 119, '2014-02-01 00:31:31.000000', 'temperatura', 557.0000, 'ºC'),
	(171338, 119, '2014-02-01 00:31:32.000000', 'temperatura', 854.0000, 'ºC'),
	(171339, 119, '2014-02-01 00:31:33.000000', 'temperatura', 201.0000, 'ºC'),
	(171340, 119, '2014-02-01 00:31:34.000000', 'temperatura', 840.0000, 'ºC'),
	(171341, 119, '2014-02-01 00:31:35.000000', 'temperatura', 1199.0000, 'ºC'),
	(171342, 119, '2014-02-01 00:31:36.000000', 'temperatura', 1076.0000, 'ºC'),
	(171343, 119, '2014-02-01 00:31:37.000000', 'temperatura', 581.0000, 'ºC'),
	(171344, 119, '2014-02-01 00:31:38.000000', 'temperatura', 879.0000, 'ºC'),
	(171345, 119, '2014-02-01 00:31:39.000000', 'temperatura', 252.0000, 'ºC'),
	(171346, 119, '2014-02-01 00:31:40.000000', 'temperatura', 1024.0000, 'ºC'),
	(171347, 119, '2014-02-01 00:31:41.000000', 'temperatura', 766.0000, 'ºC'),
	(171348, 119, '2014-02-01 00:31:42.000000', 'temperatura', 757.0000, 'ºC'),
	(171349, 119, '2014-02-01 00:31:43.000000', 'temperatura', 287.0000, 'ºC'),
	(171350, 119, '2014-02-01 00:31:44.000000', 'temperatura', 364.0000, 'ºC'),
	(171351, 119, '2014-02-01 00:31:45.000000', 'temperatura', 961.0000, 'ºC'),
	(171352, 119, '2014-02-01 00:31:46.000000', 'temperatura', 112.0000, 'ºC'),
	(171353, 119, '2014-02-01 00:31:47.000000', 'temperatura', 79.0000, 'ºC'),
	(171354, 119, '2014-02-01 00:31:48.000000', 'temperatura', 57.0000, 'ºC'),
	(171355, 119, '2014-02-01 00:31:49.000000', 'temperatura', 49.0000, 'ºC'),
	(171356, 119, '2014-02-01 00:31:50.000000', 'temperatura', 76.0000, 'ºC'),
	(171357, 119, '2014-02-01 00:31:51.000000', 'temperatura', 235.0000, 'ºC'),
	(171358, 119, '2014-02-01 00:31:52.000000', 'temperatura', 944.0000, 'ºC'),
	(171359, 119, '2014-02-01 00:31:53.000000', 'temperatura', 419.0000, 'ºC'),
	(171360, 119, '2014-02-01 00:31:54.000000', 'temperatura', 461.0000, 'ºC'),
	(171361, 119, '2014-02-01 00:31:55.000000', 'temperatura', 1050.0000, 'ºC'),
	(171362, 119, '2014-02-01 00:31:56.000000', 'temperatura', 268.0000, 'ºC'),
	(171363, 119, '2014-02-01 00:31:57.000000', 'temperatura', 591.0000, 'ºC'),
	(171364, 119, '2014-02-01 00:31:58.000000', 'temperatura', 950.0000, 'ºC'),
	(171365, 119, '2014-02-01 00:31:59.000000', 'temperatura', 580.0000, 'ºC'),
	(171366, 119, '2014-02-01 00:32:00.000000', 'temperatura', 48.0000, 'ºC'),
	(171367, 119, '2014-02-01 00:32:01.000000', 'temperatura', 903.0000, 'ºC'),
	(171368, 119, '2014-02-01 00:32:02.000000', 'temperatura', 769.0000, 'ºC'),
	(171369, 119, '2014-02-01 00:32:03.000000', 'temperatura', 1138.0000, 'ºC'),
	(171370, 119, '2014-02-01 00:32:04.000000', 'temperatura', 984.0000, 'ºC'),
	(171371, 119, '2014-02-01 00:32:05.000000', 'temperatura', 306.0000, 'ºC'),
	(171372, 119, '2014-02-01 00:32:06.000000', 'temperatura', 977.0000, 'ºC'),
	(171373, 119, '2014-02-01 00:32:07.000000', 'temperatura', 368.0000, 'ºC'),
	(171374, 119, '2014-02-01 00:32:08.000000', 'temperatura', 111.0000, 'ºC'),
	(171375, 119, '2014-02-01 00:32:09.000000', 'temperatura', 651.0000, 'ºC'),
	(171376, 119, '2014-02-01 00:32:10.000000', 'temperatura', 523.0000, 'ºC'),
	(171377, 119, '2014-02-01 00:32:11.000000', 'temperatura', 660.0000, 'ºC'),
	(171378, 119, '2014-02-01 00:32:12.000000', 'temperatura', 534.0000, 'ºC'),
	(171379, 119, '2014-02-01 00:32:13.000000', 'temperatura', 690.0000, 'ºC'),
	(171380, 119, '2014-02-01 00:32:14.000000', 'temperatura', 649.0000, 'ºC'),
	(171381, 119, '2014-02-01 00:32:15.000000', 'temperatura', 1173.0000, 'ºC'),
	(171382, 119, '2014-02-01 00:32:16.000000', 'temperatura', 321.0000, 'ºC'),
	(171383, 119, '2014-02-01 00:32:17.000000', 'temperatura', 487.0000, 'ºC'),
	(171384, 119, '2014-02-01 00:32:18.000000', 'temperatura', 273.0000, 'ºC'),
	(171385, 119, '2014-02-01 00:32:19.000000', 'temperatura', 1103.0000, 'ºC'),
	(171386, 119, '2014-02-01 00:32:20.000000', 'temperatura', 1098.0000, 'ºC'),
	(171387, 119, '2014-02-01 00:32:21.000000', 'temperatura', 980.0000, 'ºC'),
	(171388, 119, '2014-02-01 00:32:22.000000', 'temperatura', 405.0000, 'ºC'),
	(171389, 119, '2014-02-01 00:32:23.000000', 'temperatura', 288.0000, 'ºC'),
	(171390, 119, '2014-02-01 00:32:24.000000', 'temperatura', 224.0000, 'ºC'),
	(171391, 119, '2014-02-01 00:32:25.000000', 'temperatura', 256.0000, 'ºC'),
	(171392, 119, '2014-02-01 00:32:26.000000', 'temperatura', 608.0000, 'ºC'),
	(171393, 119, '2014-02-01 00:32:27.000000', 'temperatura', 1075.0000, 'ºC'),
	(171394, 119, '2014-02-01 00:32:28.000000', 'temperatura', 1152.0000, 'ºC'),
	(171395, 119, '2014-02-01 00:32:29.000000', 'temperatura', 133.0000, 'ºC'),
	(171396, 119, '2014-02-01 00:32:30.000000', 'temperatura', 811.0000, 'ºC'),
	(171397, 119, '2014-02-01 00:32:31.000000', 'temperatura', 55.0000, 'ºC'),
	(171398, 119, '2014-02-01 00:32:32.000000', 'temperatura', 243.0000, 'ºC'),
	(171399, 119, '2014-02-01 00:32:33.000000', 'temperatura', 1049.0000, 'ºC'),
	(171400, 119, '2014-02-01 00:32:34.000000', 'temperatura', 918.0000, 'ºC'),
	(171401, 119, '2014-02-01 00:32:35.000000', 'temperatura', 242.0000, 'ºC'),
	(171402, 119, '2014-02-01 00:32:36.000000', 'temperatura', 859.0000, 'ºC'),
	(171403, 119, '2014-02-01 00:32:37.000000', 'temperatura', 1169.0000, 'ºC'),
	(171404, 119, '2014-02-01 00:32:38.000000', 'temperatura', 868.0000, 'ºC'),
	(171405, 119, '2014-02-01 00:32:39.000000', 'temperatura', 835.0000, 'ºC'),
	(171406, 119, '2014-02-01 00:32:40.000000', 'temperatura', 368.0000, 'ºC'),
	(171407, 119, '2014-02-01 00:32:41.000000', 'temperatura', 539.0000, 'ºC'),
	(171408, 119, '2014-02-01 00:32:42.000000', 'temperatura', 391.0000, 'ºC'),
	(171409, 119, '2014-02-01 00:32:43.000000', 'temperatura', 339.0000, 'ºC'),
	(171410, 119, '2014-02-01 00:32:44.000000', 'temperatura', 522.0000, 'ºC'),
	(171411, 119, '2014-02-01 00:32:45.000000', 'temperatura', 393.0000, 'ºC'),
	(171412, 119, '2014-02-01 00:32:46.000000', 'temperatura', 400.0000, 'ºC'),
	(171413, 119, '2014-02-01 00:32:47.000000', 'temperatura', 820.0000, 'ºC'),
	(171414, 119, '2014-02-01 00:32:48.000000', 'temperatura', 503.0000, 'ºC'),
	(171415, 119, '2014-02-01 00:32:49.000000', 'temperatura', 53.0000, 'ºC'),
	(171416, 119, '2014-02-01 00:32:50.000000', 'temperatura', 1156.0000, 'ºC'),
	(171417, 119, '2014-02-01 00:32:51.000000', 'temperatura', 823.0000, 'ºC'),
	(171418, 119, '2014-02-01 00:32:52.000000', 'temperatura', 648.0000, 'ºC'),
	(171419, 119, '2014-02-01 00:32:53.000000', 'temperatura', 770.0000, 'ºC'),
	(171420, 119, '2014-02-01 00:32:54.000000', 'temperatura', 706.0000, 'ºC'),
	(171421, 119, '2014-02-01 00:32:55.000000', 'temperatura', 22.0000, 'ºC'),
	(171422, 119, '2014-02-01 00:32:56.000000', 'temperatura', 392.0000, 'ºC'),
	(171423, 119, '2014-02-01 00:32:57.000000', 'temperatura', 694.0000, 'ºC'),
	(171424, 119, '2014-02-01 00:32:58.000000', 'temperatura', 1094.0000, 'ºC'),
	(171425, 119, '2014-02-01 00:32:59.000000', 'temperatura', 990.0000, 'ºC'),
	(171426, 119, '2014-02-01 00:33:00.000000', 'temperatura', 467.0000, 'ºC'),
	(171427, 119, '2014-02-01 00:33:01.000000', 'temperatura', 565.0000, 'ºC'),
	(171428, 119, '2014-02-01 00:33:02.000000', 'temperatura', 226.0000, 'ºC'),
	(171429, 119, '2014-02-01 00:33:03.000000', 'temperatura', 633.0000, 'ºC'),
	(171430, 119, '2014-02-01 00:33:04.000000', 'temperatura', 89.0000, 'ºC'),
	(171431, 119, '2014-02-01 00:33:05.000000', 'temperatura', 947.0000, 'ºC'),
	(171432, 119, '2014-02-01 00:33:06.000000', 'temperatura', 869.0000, 'ºC'),
	(171433, 119, '2014-02-01 00:33:07.000000', 'temperatura', 305.0000, 'ºC'),
	(171434, 119, '2014-02-01 00:33:08.000000', 'temperatura', 117.0000, 'ºC'),
	(171435, 119, '2014-02-01 00:33:09.000000', 'temperatura', 870.0000, 'ºC'),
	(171436, 119, '2014-02-01 00:33:10.000000', 'temperatura', 402.0000, 'ºC'),
	(171437, 119, '2014-02-01 00:33:11.000000', 'temperatura', 598.0000, 'ºC'),
	(171438, 119, '2014-02-01 00:33:12.000000', 'temperatura', 584.0000, 'ºC'),
	(171439, 119, '2014-02-01 00:33:13.000000', 'temperatura', 1126.0000, 'ºC'),
	(171440, 119, '2014-02-01 00:33:14.000000', 'temperatura', 279.0000, 'ºC'),
	(171441, 119, '2014-02-01 00:33:15.000000', 'temperatura', 417.0000, 'ºC'),
	(171442, 119, '2014-02-01 00:33:16.000000', 'temperatura', 49.0000, 'ºC'),
	(171443, 119, '2014-02-01 00:33:17.000000', 'temperatura', 193.0000, 'ºC'),
	(171444, 119, '2014-02-01 00:33:18.000000', 'temperatura', 818.0000, 'ºC'),
	(171445, 119, '2014-02-01 00:33:19.000000', 'temperatura', 1113.0000, 'ºC'),
	(171446, 119, '2014-02-01 00:33:20.000000', 'temperatura', 709.0000, 'ºC'),
	(171447, 119, '2014-02-01 00:33:21.000000', 'temperatura', 209.0000, 'ºC'),
	(171448, 119, '2014-02-01 00:33:22.000000', 'temperatura', 119.0000, 'ºC'),
	(171449, 119, '2014-02-01 00:33:23.000000', 'temperatura', 1169.0000, 'ºC'),
	(171450, 119, '2014-02-01 00:33:24.000000', 'temperatura', 689.0000, 'ºC'),
	(171451, 119, '2014-02-01 00:33:25.000000', 'temperatura', 1138.0000, 'ºC'),
	(171452, 119, '2014-02-01 00:33:26.000000', 'temperatura', 21.0000, 'ºC'),
	(171453, 119, '2014-02-01 00:33:27.000000', 'temperatura', 294.0000, 'ºC'),
	(171454, 119, '2014-02-01 00:33:28.000000', 'temperatura', 207.0000, 'ºC'),
	(171455, 119, '2014-02-01 00:33:29.000000', 'temperatura', 155.0000, 'ºC'),
	(171456, 119, '2014-02-01 00:33:30.000000', 'temperatura', 153.0000, 'ºC'),
	(171457, 119, '2014-02-01 00:33:31.000000', 'temperatura', 299.0000, 'ºC'),
	(171458, 119, '2014-02-01 00:33:32.000000', 'temperatura', 1037.0000, 'ºC'),
	(171459, 119, '2014-02-01 00:33:33.000000', 'temperatura', 691.0000, 'ºC'),
	(171460, 119, '2014-02-01 00:33:34.000000', 'temperatura', 343.0000, 'ºC'),
	(171461, 119, '2014-02-01 00:33:35.000000', 'temperatura', 843.0000, 'ºC'),
	(171462, 119, '2014-02-01 00:33:36.000000', 'temperatura', 785.0000, 'ºC'),
	(171463, 119, '2014-02-01 00:33:37.000000', 'temperatura', 198.0000, 'ºC'),
	(171464, 119, '2014-02-01 00:33:38.000000', 'temperatura', 1033.0000, 'ºC'),
	(171465, 119, '2014-02-01 00:33:39.000000', 'temperatura', 973.0000, 'ºC'),
	(171466, 119, '2014-02-01 00:33:40.000000', 'temperatura', 567.0000, 'ºC'),
	(171467, 119, '2014-02-01 00:33:41.000000', 'temperatura', 1116.0000, 'ºC'),
	(171468, 119, '2014-02-01 00:33:42.000000', 'temperatura', 280.0000, 'ºC'),
	(171469, 119, '2014-02-01 00:33:43.000000', 'temperatura', 451.0000, 'ºC'),
	(171470, 119, '2014-02-01 00:33:44.000000', 'temperatura', 214.0000, 'ºC'),
	(171471, 119, '2014-02-01 00:33:45.000000', 'temperatura', 921.0000, 'ºC'),
	(171472, 119, '2014-02-01 00:33:46.000000', 'temperatura', 363.0000, 'ºC'),
	(171473, 119, '2014-02-01 00:33:47.000000', 'temperatura', 251.0000, 'ºC'),
	(171474, 119, '2014-02-01 00:33:48.000000', 'temperatura', 169.0000, 'ºC'),
	(171475, 119, '2014-02-01 00:33:49.000000', 'temperatura', 89.0000, 'ºC'),
	(171476, 119, '2014-02-01 00:33:50.000000', 'temperatura', 1141.0000, 'ºC'),
	(171477, 119, '2014-02-01 00:33:51.000000', 'temperatura', 637.0000, 'ºC'),
	(171478, 119, '2014-02-01 00:33:52.000000', 'temperatura', 964.0000, 'ºC'),
	(171479, 119, '2014-02-01 00:33:53.000000', 'temperatura', 508.0000, 'ºC'),
	(171480, 119, '2014-02-01 00:33:54.000000', 'temperatura', 848.0000, 'ºC'),
	(171481, 119, '2014-02-01 00:33:55.000000', 'temperatura', 316.0000, 'ºC'),
	(171482, 119, '2014-02-01 00:33:56.000000', 'temperatura', 236.0000, 'ºC'),
	(171483, 119, '2014-02-01 00:33:57.000000', 'temperatura', 236.0000, 'ºC'),
	(171484, 119, '2014-02-01 00:33:58.000000', 'temperatura', 469.0000, 'ºC'),
	(171485, 119, '2014-02-01 00:33:59.000000', 'temperatura', 437.0000, 'ºC'),
	(171486, 119, '2014-02-01 00:34:00.000000', 'temperatura', 780.0000, 'ºC'),
	(171487, 119, '2014-02-01 00:34:01.000000', 'temperatura', 188.0000, 'ºC'),
	(171488, 119, '2014-02-01 00:34:02.000000', 'temperatura', 1002.0000, 'ºC'),
	(171489, 119, '2014-02-01 00:34:03.000000', 'temperatura', 847.0000, 'ºC'),
	(171490, 119, '2014-02-01 00:34:04.000000', 'temperatura', 29.0000, 'ºC'),
	(171491, 119, '2014-02-01 00:34:05.000000', 'temperatura', 6.0000, 'ºC'),
	(171492, 119, '2014-02-01 00:34:06.000000', 'temperatura', 1143.0000, 'ºC'),
	(171493, 119, '2014-02-01 00:34:07.000000', 'temperatura', 897.0000, 'ºC'),
	(171494, 119, '2014-02-01 00:34:08.000000', 'temperatura', 1059.0000, 'ºC'),
	(171495, 119, '2014-02-01 00:34:09.000000', 'temperatura', 201.0000, 'ºC'),
	(171496, 119, '2014-02-01 00:34:10.000000', 'temperatura', 229.0000, 'ºC'),
	(171497, 119, '2014-02-01 00:34:11.000000', 'temperatura', 542.0000, 'ºC'),
	(171498, 119, '2014-02-01 00:34:12.000000', 'temperatura', 825.0000, 'ºC'),
	(171499, 119, '2014-02-01 00:34:13.000000', 'temperatura', 99.0000, 'ºC'),
	(171500, 119, '2014-02-01 00:34:14.000000', 'temperatura', 420.0000, 'ºC'),
	(171501, 119, '2014-02-01 00:34:15.000000', 'temperatura', 602.0000, 'ºC'),
	(171502, 119, '2014-02-01 00:34:16.000000', 'temperatura', 553.0000, 'ºC'),
	(171503, 119, '2014-02-01 00:34:17.000000', 'temperatura', 960.0000, 'ºC'),
	(171504, 119, '2014-02-01 00:34:18.000000', 'temperatura', 739.0000, 'ºC'),
	(171505, 119, '2014-02-01 00:34:19.000000', 'temperatura', 815.0000, 'ºC'),
	(171506, 119, '2014-02-01 00:34:20.000000', 'temperatura', 660.0000, 'ºC'),
	(171507, 119, '2014-02-01 00:34:21.000000', 'temperatura', 855.0000, 'ºC'),
	(171508, 119, '2014-02-01 00:34:22.000000', 'temperatura', 1094.0000, 'ºC'),
	(171509, 119, '2014-02-01 00:34:23.000000', 'temperatura', 506.0000, 'ºC'),
	(171510, 119, '2014-02-01 00:34:24.000000', 'temperatura', 450.0000, 'ºC'),
	(171511, 119, '2014-02-01 00:34:25.000000', 'temperatura', 732.0000, 'ºC'),
	(171512, 119, '2014-02-01 00:34:26.000000', 'temperatura', 1109.0000, 'ºC'),
	(171513, 119, '2014-02-01 00:34:27.000000', 'temperatura', 951.0000, 'ºC'),
	(171514, 119, '2014-02-01 00:34:28.000000', 'temperatura', 230.0000, 'ºC'),
	(171515, 119, '2014-02-01 00:34:29.000000', 'temperatura', 697.0000, 'ºC'),
	(171516, 119, '2014-02-01 00:34:30.000000', 'temperatura', 395.0000, 'ºC'),
	(171517, 119, '2014-02-01 00:34:31.000000', 'temperatura', 1085.0000, 'ºC'),
	(171518, 119, '2014-02-01 00:34:32.000000', 'temperatura', 640.0000, 'ºC'),
	(171519, 119, '2014-02-01 00:34:33.000000', 'temperatura', 1146.0000, 'ºC'),
	(171520, 119, '2014-02-01 00:34:34.000000', 'temperatura', 212.0000, 'ºC'),
	(171521, 119, '2014-02-01 00:34:35.000000', 'temperatura', 22.0000, 'ºC'),
	(171522, 119, '2014-02-01 00:34:36.000000', 'temperatura', 673.0000, 'ºC'),
	(171523, 119, '2014-02-01 00:34:37.000000', 'temperatura', 899.0000, 'ºC'),
	(171524, 119, '2014-02-01 00:34:38.000000', 'temperatura', 78.0000, 'ºC'),
	(171525, 119, '2014-02-01 00:34:39.000000', 'temperatura', 91.0000, 'ºC'),
	(171526, 119, '2014-02-01 00:34:40.000000', 'temperatura', 222.0000, 'ºC'),
	(171527, 119, '2014-02-01 00:34:41.000000', 'temperatura', 840.0000, 'ºC'),
	(171528, 119, '2014-02-01 00:34:42.000000', 'temperatura', 1134.0000, 'ºC'),
	(171529, 119, '2014-02-01 00:34:43.000000', 'temperatura', 752.0000, 'ºC'),
	(171530, 119, '2014-02-01 00:34:44.000000', 'temperatura', 356.0000, 'ºC'),
	(171531, 119, '2014-02-01 00:34:45.000000', 'temperatura', 723.0000, 'ºC'),
	(171532, 119, '2014-02-01 00:34:46.000000', 'temperatura', 151.0000, 'ºC'),
	(171533, 119, '2014-02-01 00:34:47.000000', 'temperatura', 986.0000, 'ºC'),
	(171534, 119, '2014-02-01 00:34:48.000000', 'temperatura', 877.0000, 'ºC'),
	(171535, 119, '2014-02-01 00:34:49.000000', 'temperatura', 227.0000, 'ºC'),
	(171536, 119, '2014-02-01 00:34:50.000000', 'temperatura', 906.0000, 'ºC'),
	(171537, 119, '2014-02-01 00:34:51.000000', 'temperatura', 247.0000, 'ºC'),
	(171538, 119, '2014-02-01 00:34:52.000000', 'temperatura', 918.0000, 'ºC'),
	(171539, 119, '2014-02-01 00:34:53.000000', 'temperatura', 249.0000, 'ºC'),
	(171540, 119, '2014-02-01 00:34:54.000000', 'temperatura', 893.0000, 'ºC'),
	(171541, 119, '2014-02-01 00:34:55.000000', 'temperatura', 119.0000, 'ºC'),
	(171542, 119, '2014-02-01 00:34:56.000000', 'temperatura', 318.0000, 'ºC'),
	(171543, 119, '2014-02-01 00:34:57.000000', 'temperatura', 30.0000, 'ºC'),
	(171544, 119, '2014-02-01 00:34:58.000000', 'temperatura', 399.0000, 'ºC'),
	(171545, 119, '2014-02-01 00:34:59.000000', 'temperatura', 704.0000, 'ºC'),
	(171546, 119, '2014-02-01 00:35:00.000000', 'temperatura', 1125.0000, 'ºC'),
	(171547, 119, '2014-02-01 00:35:01.000000', 'temperatura', 1114.0000, 'ºC'),
	(171548, 119, '2014-02-01 00:35:02.000000', 'temperatura', 996.0000, 'ºC'),
	(171549, 119, '2014-02-01 00:35:03.000000', 'temperatura', 437.0000, 'ºC'),
	(171550, 119, '2014-02-01 00:35:04.000000', 'temperatura', 398.0000, 'ºC'),
	(171551, 119, '2014-02-01 00:35:05.000000', 'temperatura', 680.0000, 'ºC'),
	(171552, 119, '2014-02-01 00:35:06.000000', 'temperatura', 1007.0000, 'ºC'),
	(171553, 119, '2014-02-01 00:35:07.000000', 'temperatura', 594.0000, 'ºC'),
	(171554, 119, '2014-02-01 00:35:08.000000', 'temperatura', 1151.0000, 'ºC'),
	(171555, 119, '2014-02-01 00:35:09.000000', 'temperatura', 373.0000, 'ºC'),
	(171556, 119, '2014-02-01 00:35:10.000000', 'temperatura', 811.0000, 'ºC'),
	(171557, 119, '2014-02-01 00:35:11.000000', 'temperatura', 539.0000, 'ºC'),
	(171558, 119, '2014-02-01 00:35:12.000000', 'temperatura', 262.0000, 'ºC'),
	(171559, 119, '2014-02-01 00:35:13.000000', 'temperatura', 893.0000, 'ºC'),
	(171560, 119, '2014-02-01 00:35:14.000000', 'temperatura', 82.0000, 'ºC'),
	(171561, 119, '2014-02-01 00:35:15.000000', 'temperatura', 128.0000, 'ºC'),
	(171562, 119, '2014-02-01 00:35:16.000000', 'temperatura', 398.0000, 'ºC'),
	(171563, 119, '2014-02-01 00:35:17.000000', 'temperatura', 404.0000, 'ºC'),
	(171564, 119, '2014-02-01 00:35:18.000000', 'temperatura', 826.0000, 'ºC'),
	(171565, 119, '2014-02-01 00:35:19.000000', 'temperatura', 520.0000, 'ºC'),
	(171566, 119, '2014-02-01 00:35:20.000000', 'temperatura', 122.0000, 'ºC'),
	(171567, 119, '2014-02-01 00:35:21.000000', 'temperatura', 252.0000, 'ºC'),
	(171568, 119, '2014-02-01 00:35:22.000000', 'temperatura', 894.0000, 'ºC'),
	(171569, 119, '2014-02-01 00:35:23.000000', 'temperatura', 113.0000, 'ºC'),
	(171570, 119, '2014-02-01 00:35:24.000000', 'temperatura', 283.0000, 'ºC'),
	(171571, 119, '2014-02-01 00:35:25.000000', 'temperatura', 1076.0000, 'ºC'),
	(171572, 119, '2014-02-01 00:35:26.000000', 'temperatura', 933.0000, 'ºC'),
	(171573, 119, '2014-02-01 00:35:27.000000', 'temperatura', 237.0000, 'ºC'),
	(171574, 119, '2014-02-01 00:35:28.000000', 'temperatura', 788.0000, 'ºC'),
	(171575, 119, '2014-02-01 00:35:29.000000', 'temperatura', 829.0000, 'ºC'),
	(171576, 119, '2014-02-01 00:35:30.000000', 'temperatura', 580.0000, 'ºC'),
	(171577, 119, '2014-02-01 00:35:31.000000', 'temperatura', 413.0000, 'ºC'),
	(171578, 119, '2014-02-01 00:35:32.000000', 'temperatura', 325.0000, 'ºC'),
	(171579, 119, '2014-02-01 00:35:33.000000', 'temperatura', 388.0000, 'ºC'),
	(171580, 119, '2014-02-01 00:35:34.000000', 'temperatura', 966.0000, 'ºC'),
	(171581, 119, '2014-02-01 00:35:35.000000', 'temperatura', 66.0000, 'ºC'),
	(171582, 119, '2014-02-01 00:35:36.000000', 'temperatura', 1034.0000, 'ºC'),
	(171583, 119, '2014-02-01 00:35:37.000000', 'temperatura', 172.0000, 'ºC'),
	(171584, 119, '2014-02-01 00:35:38.000000', 'temperatura', 158.0000, 'ºC'),
	(171585, 119, '2014-02-01 00:35:39.000000', 'temperatura', 273.0000, 'ºC'),
	(171586, 119, '2014-02-01 00:35:40.000000', 'temperatura', 895.0000, 'ºC'),
	(171587, 119, '2014-02-01 00:35:41.000000', 'temperatura', 53.0000, 'ºC'),
	(171588, 119, '2014-02-01 00:35:42.000000', 'temperatura', 1183.0000, 'ºC'),
	(171589, 119, '2014-02-01 00:35:43.000000', 'temperatura', 958.0000, 'ºC'),
	(171590, 119, '2014-02-01 00:35:44.000000', 'temperatura', 38.0000, 'ºC'),
	(171591, 119, '2014-02-01 00:35:45.000000', 'temperatura', 919.0000, 'ºC'),
	(171592, 119, '2014-02-01 00:35:46.000000', 'temperatura', 879.0000, 'ºC'),
	(171593, 119, '2014-02-01 00:35:47.000000', 'temperatura', 439.0000, 'ºC'),
	(171594, 119, '2014-02-01 00:35:48.000000', 'temperatura', 761.0000, 'ºC'),
	(171595, 119, '2014-02-01 00:35:49.000000', 'temperatura', 85.0000, 'ºC'),
	(171596, 119, '2014-02-01 00:35:50.000000', 'temperatura', 544.0000, 'ºC'),
	(171597, 119, '2014-02-01 00:35:51.000000', 'temperatura', 66.0000, 'ºC'),
	(171598, 119, '2014-02-01 00:35:52.000000', 'temperatura', 1100.0000, 'ºC'),
	(171599, 119, '2014-02-01 00:35:53.000000', 'temperatura', 502.0000, 'ºC'),
	(171600, 119, '2014-02-01 00:35:54.000000', 'temperatura', 409.0000, 'ºC'),
	(171601, 119, '2014-02-01 00:35:55.000000', 'temperatura', 539.0000, 'ºC'),
	(171602, 119, '2014-02-01 00:35:56.000000', 'temperatura', 271.0000, 'ºC'),
	(171603, 119, '2014-02-01 00:35:57.000000', 'temperatura', 938.0000, 'ºC'),
	(171604, 119, '2014-02-01 00:35:58.000000', 'temperatura', 277.0000, 'ºC'),
	(171605, 119, '2014-02-01 00:35:59.000000', 'temperatura', 971.0000, 'ºC'),
	(171606, 119, '2014-02-01 00:36:00.000000', 'temperatura', 423.0000, 'ºC'),
	(171607, 119, '2014-02-01 00:36:01.000000', 'temperatura', 405.0000, 'ºC'),
	(171608, 119, '2014-02-01 00:36:02.000000', 'temperatura', 758.0000, 'ºC'),
	(171609, 119, '2014-02-01 00:36:03.000000', 'temperatura', 173.0000, 'ºC'),
	(171610, 119, '2014-02-01 00:36:04.000000', 'temperatura', 990.0000, 'ºC'),
	(171611, 119, '2014-02-01 00:36:05.000000', 'temperatura', 835.0000, 'ºC'),
	(171612, 119, '2014-02-01 00:36:06.000000', 'temperatura', 2.0000, 'ºC'),
	(171613, 119, '2014-02-01 00:36:07.000000', 'temperatura', 1108.0000, 'ºC'),
	(171614, 119, '2014-02-01 00:36:08.000000', 'temperatura', 734.0000, 'ºC'),
	(171615, 119, '2014-02-01 00:36:09.000000', 'temperatura', 346.0000, 'ºC'),
	(171616, 119, '2014-02-01 00:36:10.000000', 'temperatura', 729.0000, 'ºC'),
	(171617, 119, '2014-02-01 00:36:11.000000', 'temperatura', 207.0000, 'ºC'),
	(171618, 119, '2014-02-01 00:36:12.000000', 'temperatura', 49.0000, 'ºC'),
	(171619, 119, '2014-02-01 00:36:13.000000', 'temperatura', 824.0000, 'ºC'),
	(171620, 119, '2014-02-01 00:36:14.000000', 'temperatura', 374.0000, 'ºC'),
	(171621, 119, '2014-02-01 00:36:15.000000', 'temperatura', 597.0000, 'ºC'),
	(171622, 119, '2014-02-01 00:36:16.000000', 'temperatura', 666.0000, 'ºC'),
	(171623, 119, '2014-02-01 00:36:17.000000', 'temperatura', 338.0000, 'ºC'),
	(171624, 119, '2014-02-01 00:36:18.000000', 'temperatura', 891.0000, 'ºC'),
	(171625, 119, '2014-02-01 00:36:19.000000', 'temperatura', 1041.0000, 'ºC'),
	(171626, 119, '2014-02-01 00:36:20.000000', 'temperatura', 135.0000, 'ºC'),
	(171627, 119, '2014-02-01 00:36:21.000000', 'temperatura', 1152.0000, 'ºC'),
	(171628, 119, '2014-02-01 00:36:22.000000', 'temperatura', 554.0000, 'ºC'),
	(171629, 119, '2014-02-01 00:36:23.000000', 'temperatura', 514.0000, 'ºC'),
	(171630, 119, '2014-02-01 00:36:24.000000', 'temperatura', 908.0000, 'ºC'),
	(171631, 119, '2014-02-01 00:36:25.000000', 'temperatura', 602.0000, 'ºC'),
	(171632, 119, '2014-02-01 00:36:26.000000', 'temperatura', 283.0000, 'ºC'),
	(171633, 119, '2014-02-01 00:36:27.000000', 'temperatura', 811.0000, 'ºC'),
	(171634, 119, '2014-02-01 00:36:28.000000', 'temperatura', 806.0000, 'ºC'),
	(171635, 119, '2014-02-01 00:36:29.000000', 'temperatura', 397.0000, 'ºC'),
	(171636, 119, '2014-02-01 00:36:30.000000', 'temperatura', 768.0000, 'ºC'),
	(171637, 119, '2014-02-01 00:36:31.000000', 'temperatura', 251.0000, 'ºC'),
	(171638, 119, '2014-02-01 00:36:32.000000', 'temperatura', 149.0000, 'ºC'),
	(171639, 119, '2014-02-01 00:36:33.000000', 'temperatura', 1195.0000, 'ºC'),
	(171640, 119, '2014-02-01 00:36:34.000000', 'temperatura', 728.0000, 'ºC'),
	(171641, 119, '2014-02-01 00:36:35.000000', 'temperatura', 57.0000, 'ºC'),
	(171642, 119, '2014-02-01 00:36:36.000000', 'temperatura', 499.0000, 'ºC'),
	(171643, 119, '2014-02-01 00:36:37.000000', 'temperatura', 1125.0000, 'ºC'),
	(171644, 119, '2014-02-01 00:36:38.000000', 'temperatura', 528.0000, 'ºC'),
	(171645, 119, '2014-02-01 00:36:39.000000', 'temperatura', 467.0000, 'ºC'),
	(171646, 119, '2014-02-01 00:36:40.000000', 'temperatura', 750.0000, 'ºC'),
	(171647, 119, '2014-02-01 00:36:41.000000', 'temperatura', 1150.0000, 'ºC'),
	(171648, 119, '2014-02-01 00:36:42.000000', 'temperatura', 1102.0000, 'ºC'),
	(171649, 119, '2014-02-01 00:36:43.000000', 'temperatura', 861.0000, 'ºC'),
	(171650, 119, '2014-02-01 00:36:44.000000', 'temperatura', 997.0000, 'ºC'),
	(171651, 119, '2014-02-01 00:36:45.000000', 'temperatura', 4.0000, 'ºC'),
	(171652, 119, '2014-02-01 00:36:46.000000', 'temperatura', 630.0000, 'ºC'),
	(171653, 119, '2014-02-01 00:36:47.000000', 'temperatura', 739.0000, 'ºC'),
	(171654, 119, '2014-02-01 00:36:48.000000', 'temperatura', 603.0000, 'ºC'),
	(171655, 119, '2014-02-01 00:36:49.000000', 'temperatura', 802.0000, 'ºC'),
	(171656, 119, '2014-02-01 00:36:50.000000', 'temperatura', 999.0000, 'ºC'),
	(171657, 119, '2014-02-01 00:36:51.000000', 'temperatura', 188.0000, 'ºC'),
	(171658, 119, '2014-02-01 00:36:52.000000', 'temperatura', 346.0000, 'ºC'),
	(171659, 119, '2014-02-01 00:36:53.000000', 'temperatura', 1164.0000, 'ºC'),
	(171660, 119, '2014-02-01 00:36:54.000000', 'temperatura', 1185.0000, 'ºC'),
	(171661, 119, '2014-02-01 00:36:55.000000', 'temperatura', 32.0000, 'ºC'),
	(171662, 119, '2014-02-01 00:36:56.000000', 'temperatura', 204.0000, 'ºC'),
	(171663, 119, '2014-02-01 00:36:57.000000', 'temperatura', 928.0000, 'ºC'),
	(171664, 119, '2014-02-01 00:36:58.000000', 'temperatura', 426.0000, 'ºC'),
	(171665, 119, '2014-02-01 00:36:59.000000', 'temperatura', 547.0000, 'ºC'),
	(171666, 119, '2014-02-01 00:37:00.000000', 'temperatura', 258.0000, 'ºC'),
	(171667, 119, '2014-02-01 00:37:01.000000', 'temperatura', 849.0000, 'ºC'),
	(171668, 119, '2014-02-01 00:37:02.000000', 'temperatura', 1072.0000, 'ºC'),
	(171669, 119, '2014-02-01 00:37:03.000000', 'temperatura', 414.0000, 'ºC'),
	(171670, 119, '2014-02-01 00:37:04.000000', 'temperatura', 54.0000, 'ºC'),
	(171671, 119, '2014-02-01 00:37:05.000000', 'temperatura', 230.0000, 'ºC'),
	(171672, 119, '2014-02-01 00:37:06.000000', 'temperatura', 988.0000, 'ºC'),
	(171673, 119, '2014-02-01 00:37:07.000000', 'temperatura', 648.0000, 'ºC'),
	(171674, 119, '2014-02-01 00:37:08.000000', 'temperatura', 279.0000, 'ºC'),
	(171675, 119, '2014-02-01 00:37:09.000000', 'temperatura', 652.0000, 'ºC'),
	(171676, 119, '2014-02-01 00:37:10.000000', 'temperatura', 22.0000, 'ºC'),
	(171677, 119, '2014-02-01 00:37:11.000000', 'temperatura', 554.0000, 'ºC'),
	(171678, 119, '2014-02-01 00:37:12.000000', 'temperatura', 305.0000, 'ºC'),
	(171679, 119, '2014-02-01 00:37:13.000000', 'temperatura', 1062.0000, 'ºC'),
	(171680, 119, '2014-02-01 00:37:14.000000', 'temperatura', 799.0000, 'ºC'),
	(171681, 119, '2014-02-01 00:37:15.000000', 'temperatura', 806.0000, 'ºC'),
	(171682, 119, '2014-02-01 00:37:16.000000', 'temperatura', 434.0000, 'ºC'),
	(171683, 119, '2014-02-01 00:37:17.000000', 'temperatura', 955.0000, 'ºC'),
	(171684, 119, '2014-02-01 00:37:18.000000', 'temperatura', 1073.0000, 'ºC'),
	(171685, 119, '2014-02-01 00:37:19.000000', 'temperatura', 100.0000, 'ºC'),
	(171686, 119, '2014-02-01 00:37:20.000000', 'temperatura', 880.0000, 'ºC'),
	(171687, 119, '2014-02-01 00:37:21.000000', 'temperatura', 500.0000, 'ºC'),
	(171688, 119, '2014-02-01 00:37:22.000000', 'temperatura', 1062.0000, 'ºC'),
	(171689, 119, '2014-02-01 00:37:23.000000', 'temperatura', 210.0000, 'ºC'),
	(171690, 119, '2014-02-01 00:37:24.000000', 'temperatura', 265.0000, 'ºC'),
	(171691, 119, '2014-02-01 00:37:25.000000', 'temperatura', 694.0000, 'ºC'),
	(171692, 119, '2014-02-01 00:37:26.000000', 'temperatura', 278.0000, 'ºC'),
	(171693, 119, '2014-02-01 00:37:27.000000', 'temperatura', 508.0000, 'ºC'),
	(171694, 119, '2014-02-01 00:37:28.000000', 'temperatura', 506.0000, 'ºC'),
	(171695, 119, '2014-02-01 00:37:29.000000', 'temperatura', 1007.0000, 'ºC'),
	(171696, 119, '2014-02-01 00:37:30.000000', 'temperatura', 1116.0000, 'ºC'),
	(171697, 119, '2014-02-01 00:37:31.000000', 'temperatura', 159.0000, 'ºC'),
	(171698, 119, '2014-02-01 00:37:32.000000', 'temperatura', 1050.0000, 'ºC'),
	(171699, 119, '2014-02-01 00:37:33.000000', 'temperatura', 1171.0000, 'ºC'),
	(171700, 119, '2014-02-01 00:37:34.000000', 'temperatura', 307.0000, 'ºC'),
	(171701, 119, '2014-02-01 00:37:35.000000', 'temperatura', 423.0000, 'ºC'),
	(171702, 119, '2014-02-01 00:37:36.000000', 'temperatura', 1194.0000, 'ºC'),
	(171703, 119, '2014-02-01 00:37:37.000000', 'temperatura', 1102.0000, 'ºC'),
	(171704, 119, '2014-02-01 00:37:38.000000', 'temperatura', 730.0000, 'ºC'),
	(171705, 119, '2014-02-01 00:37:39.000000', 'temperatura', 343.0000, 'ºC'),
	(171706, 119, '2014-02-01 00:37:40.000000', 'temperatura', 725.0000, 'ºC'),
	(171707, 119, '2014-02-01 00:37:41.000000', 'temperatura', 196.0000, 'ºC'),
	(171708, 119, '2014-02-01 00:37:42.000000', 'temperatura', 8.0000, 'ºC'),
	(171709, 119, '2014-02-01 00:37:43.000000', 'temperatura', 649.0000, 'ºC'),
	(171710, 119, '2014-02-01 00:37:44.000000', 'temperatura', 823.0000, 'ºC'),
	(171711, 119, '2014-02-01 00:37:45.000000', 'temperatura', 970.0000, 'ºC'),
	(171712, 119, '2014-02-01 00:37:46.000000', 'temperatura', 1181.0000, 'ºC'),
	(171713, 119, '2014-02-01 00:37:47.000000', 'temperatura', 594.0000, 'ºC'),
	(171714, 119, '2014-02-01 00:37:48.000000', 'temperatura', 627.0000, 'ºC'),
	(171715, 119, '2014-02-01 00:37:49.000000', 'temperatura', 156.0000, 'ºC'),
	(171716, 119, '2014-02-01 00:37:50.000000', 'temperatura', 98.0000, 'ºC'),
	(171717, 119, '2014-02-01 00:37:51.000000', 'temperatura', 24.0000, 'ºC'),
	(171718, 119, '2014-02-01 00:37:52.000000', 'temperatura', 1026.0000, 'ºC'),
	(171719, 119, '2014-02-01 00:37:53.000000', 'temperatura', 260.0000, 'ºC'),
	(171720, 119, '2014-02-01 00:37:54.000000', 'temperatura', 623.0000, 'ºC'),
	(171721, 119, '2014-02-01 00:37:55.000000', 'temperatura', 1134.0000, 'ºC'),
	(171722, 119, '2014-02-01 00:37:56.000000', 'temperatura', 200.0000, 'ºC'),
	(171723, 119, '2014-02-01 00:37:57.000000', 'temperatura', 1.0000, 'ºC'),
	(171724, 119, '2014-02-01 00:37:58.000000', 'temperatura', 603.0000, 'ºC'),
	(171725, 119, '2014-02-01 00:37:59.000000', 'temperatura', 612.0000, 'ºC'),
	(171726, 119, '2014-02-01 00:38:00.000000', 'temperatura', 52.0000, 'ºC'),
	(171727, 119, '2014-02-01 00:38:01.000000', 'temperatura', 823.0000, 'ºC'),
	(171728, 119, '2014-02-01 00:38:02.000000', 'temperatura', 362.0000, 'ºC'),
	(171729, 119, '2014-02-01 00:38:03.000000', 'temperatura', 542.0000, 'ºC'),
	(171730, 119, '2014-02-01 00:38:04.000000', 'temperatura', 426.0000, 'ºC'),
	(171731, 119, '2014-02-01 00:38:05.000000', 'temperatura', 501.0000, 'ºC'),
	(171732, 119, '2014-02-01 00:38:06.000000', 'temperatura', 28.0000, 'ºC'),
	(171733, 119, '2014-02-01 00:38:07.000000', 'temperatura', 1037.0000, 'ºC'),
	(171734, 119, '2014-02-01 00:38:08.000000', 'temperatura', 301.0000, 'ºC'),
	(171735, 119, '2014-02-01 00:38:09.000000', 'temperatura', 795.0000, 'ºC'),
	(171736, 119, '2014-02-01 00:38:10.000000', 'temperatura', 673.0000, 'ºC'),
	(171737, 119, '2014-02-01 00:38:11.000000', 'temperatura', 979.0000, 'ºC'),
	(171738, 119, '2014-02-01 00:38:12.000000', 'temperatura', 478.0000, 'ºC'),
	(171739, 119, '2014-02-01 00:38:13.000000', 'temperatura', 654.0000, 'ºC'),
	(171740, 119, '2014-02-01 00:38:14.000000', 'temperatura', 637.0000, 'ºC'),
	(171741, 119, '2014-02-01 00:38:15.000000', 'temperatura', 22.0000, 'ºC'),
	(171742, 119, '2014-02-01 00:38:16.000000', 'temperatura', 601.0000, 'ºC'),
	(171743, 119, '2014-02-01 00:38:17.000000', 'temperatura', 538.0000, 'ºC'),
	(171744, 119, '2014-02-01 00:38:18.000000', 'temperatura', 887.0000, 'ºC'),
	(171745, 119, '2014-02-01 00:38:19.000000', 'temperatura', 423.0000, 'ºC'),
	(171746, 119, '2014-02-01 00:38:20.000000', 'temperatura', 653.0000, 'ºC'),
	(171747, 119, '2014-02-01 00:38:21.000000', 'temperatura', 797.0000, 'ºC'),
	(171748, 119, '2014-02-01 00:38:22.000000', 'temperatura', 825.0000, 'ºC'),
	(171749, 119, '2014-02-01 00:38:23.000000', 'temperatura', 538.0000, 'ºC'),
	(171750, 119, '2014-02-01 00:38:24.000000', 'temperatura', 213.0000, 'ºC'),
	(171751, 119, '2014-02-01 00:38:25.000000', 'temperatura', 650.0000, 'ºC'),
	(171752, 119, '2014-02-01 00:38:26.000000', 'temperatura', 214.0000, 'ºC'),
	(171753, 119, '2014-02-01 00:38:27.000000', 'temperatura', 318.0000, 'ºC'),
	(171754, 119, '2014-02-01 00:38:28.000000', 'temperatura', 950.0000, 'ºC'),
	(171755, 119, '2014-02-01 00:38:29.000000', 'temperatura', 194.0000, 'ºC'),
	(171756, 119, '2014-02-01 00:38:30.000000', 'temperatura', 523.0000, 'ºC'),
	(171757, 119, '2014-02-01 00:38:31.000000', 'temperatura', 833.0000, 'ºC'),
	(171758, 119, '2014-02-01 00:38:32.000000', 'temperatura', 196.0000, 'ºC'),
	(171759, 119, '2014-02-01 00:38:33.000000', 'temperatura', 883.0000, 'ºC'),
	(171760, 119, '2014-02-01 00:38:34.000000', 'temperatura', 226.0000, 'ºC'),
	(171761, 119, '2014-02-01 00:38:35.000000', 'temperatura', 881.0000, 'ºC'),
	(171762, 119, '2014-02-01 00:38:36.000000', 'temperatura', 129.0000, 'ºC'),
	(171763, 119, '2014-02-01 00:38:37.000000', 'temperatura', 403.0000, 'ºC'),
	(171764, 119, '2014-02-01 00:38:38.000000', 'temperatura', 427.0000, 'ºC'),
	(171765, 119, '2014-02-01 00:38:39.000000', 'temperatura', 929.0000, 'ºC'),
	(171766, 119, '2014-02-01 00:38:40.000000', 'temperatura', 963.0000, 'ºC'),
	(171767, 119, '2014-02-01 00:38:41.000000', 'temperatura', 829.0000, 'ºC'),
	(171768, 119, '2014-02-01 00:38:42.000000', 'temperatura', 56.0000, 'ºC'),
	(171769, 119, '2014-02-01 00:38:43.000000', 'temperatura', 192.0000, 'ºC'),
	(171770, 119, '2014-02-01 00:38:44.000000', 'temperatura', 793.0000, 'ºC'),
	(171771, 119, '2014-02-01 00:38:45.000000', 'temperatura', 989.0000, 'ºC'),
	(171772, 119, '2014-02-01 00:38:46.000000', 'temperatura', 166.0000, 'ºC'),
	(171773, 119, '2014-02-01 00:38:47.000000', 'temperatura', 264.0000, 'ºC'),
	(171774, 119, '2014-02-01 00:38:48.000000', 'temperatura', 824.0000, 'ºC'),
	(171775, 119, '2014-02-01 00:38:49.000000', 'temperatura', 930.0000, 'ºC'),
	(171776, 119, '2014-02-01 00:38:50.000000', 'temperatura', 976.0000, 'ºC'),
	(171777, 119, '2014-02-01 00:38:51.000000', 'temperatura', 890.0000, 'ºC'),
	(171778, 119, '2014-02-01 00:38:52.000000', 'temperatura', 322.0000, 'ºC'),
	(171779, 119, '2014-02-01 00:38:53.000000', 'temperatura', 143.0000, 'ºC'),
	(171780, 119, '2014-02-01 00:38:54.000000', 'temperatura', 949.0000, 'ºC'),
	(171781, 119, '2014-02-01 00:38:55.000000', 'temperatura', 716.0000, 'ºC'),
	(171782, 119, '2014-02-01 00:38:56.000000', 'temperatura', 733.0000, 'ºC'),
	(171783, 119, '2014-02-01 00:38:57.000000', 'temperatura', 319.0000, 'ºC'),
	(171784, 119, '2014-02-01 00:38:58.000000', 'temperatura', 597.0000, 'ºC'),
	(171785, 119, '2014-02-01 00:38:59.000000', 'temperatura', 828.0000, 'ºC'),
	(171786, 119, '2014-02-01 00:39:00.000000', 'temperatura', 1150.0000, 'ºC'),
	(171787, 119, '2014-02-01 00:39:01.000000', 'temperatura', 868.0000, 'ºC'),
	(171788, 119, '2014-02-01 00:39:02.000000', 'temperatura', 887.0000, 'ºC'),
	(171789, 119, '2014-02-01 00:39:03.000000', 'temperatura', 634.0000, 'ºC'),
	(171790, 119, '2014-02-01 00:39:04.000000', 'temperatura', 509.0000, 'ºC'),
	(171791, 119, '2014-02-01 00:39:05.000000', 'temperatura', 641.0000, 'ºC'),
	(171792, 119, '2014-02-01 00:39:06.000000', 'temperatura', 482.0000, 'ºC'),
	(171793, 119, '2014-02-01 00:39:07.000000', 'temperatura', 484.0000, 'ºC'),
	(171794, 119, '2014-02-01 00:39:08.000000', 'temperatura', 978.0000, 'ºC'),
	(171795, 119, '2014-02-01 00:39:09.000000', 'temperatura', 1036.0000, 'ºC'),
	(171796, 119, '2014-02-01 00:39:10.000000', 'temperatura', 1047.0000, 'ºC'),
	(171797, 119, '2014-02-01 00:39:11.000000', 'temperatura', 926.0000, 'ºC'),
	(171798, 119, '2014-02-01 00:39:12.000000', 'temperatura', 293.0000, 'ºC'),
	(171799, 119, '2014-02-01 00:39:13.000000', 'temperatura', 1084.0000, 'ºC'),
	(171800, 119, '2014-02-01 00:39:14.000000', 'temperatura', 942.0000, 'ºC'),
	(171801, 119, '2014-02-01 00:39:15.000000', 'temperatura', 261.0000, 'ºC'),
	(171802, 119, '2014-02-01 00:39:16.000000', 'temperatura', 878.0000, 'ºC'),
	(171803, 119, '2014-02-01 00:39:17.000000', 'temperatura', 6.0000, 'ºC'),
	(171804, 119, '2014-02-01 00:39:18.000000', 'temperatura', 997.0000, 'ºC'),
	(171805, 119, '2014-02-01 00:39:19.000000', 'temperatura', 170.0000, 'ºC'),
	(171806, 119, '2014-02-01 00:39:20.000000', 'temperatura', 257.0000, 'ºC'),
	(171807, 119, '2014-02-01 00:39:21.000000', 'temperatura', 774.0000, 'ºC'),
	(171808, 119, '2014-02-01 00:39:22.000000', 'temperatura', 702.0000, 'ºC'),
	(171809, 119, '2014-02-01 00:39:23.000000', 'temperatura', 1187.0000, 'ºC'),
	(171810, 119, '2014-02-01 00:39:24.000000', 'temperatura', 229.0000, 'ºC'),
	(171811, 119, '2014-02-01 00:39:25.000000', 'temperatura', 1187.0000, 'ºC'),
	(171812, 119, '2014-02-01 00:39:26.000000', 'temperatura', 446.0000, 'ºC'),
	(171813, 119, '2014-02-01 00:39:27.000000', 'temperatura', 1070.0000, 'ºC'),
	(171814, 119, '2014-02-01 00:39:28.000000', 'temperatura', 411.0000, 'ºC'),
	(171815, 119, '2014-02-01 00:39:29.000000', 'temperatura', 47.0000, 'ºC'),
	(171816, 119, '2014-02-01 00:39:30.000000', 'temperatura', 203.0000, 'ºC'),
	(171817, 119, '2014-02-01 00:39:31.000000', 'temperatura', 872.0000, 'ºC'),
	(171818, 119, '2014-02-01 00:39:32.000000', 'temperatura', 153.0000, 'ºC'),
	(171819, 119, '2014-02-01 00:39:33.000000', 'temperatura', 550.0000, 'ºC'),
	(171820, 119, '2014-02-01 00:39:34.000000', 'temperatura', 1089.0000, 'ºC'),
	(171821, 119, '2014-02-01 00:39:35.000000', 'temperatura', 198.0000, 'ºC'),
	(171822, 119, '2014-02-01 00:39:36.000000', 'temperatura', 124.0000, 'ºC'),
	(171823, 119, '2014-02-01 00:39:37.000000', 'temperatura', 25.0000, 'ºC'),
	(171824, 119, '2014-02-01 00:39:38.000000', 'temperatura', 954.0000, 'ºC'),
	(171825, 119, '2014-02-01 00:39:39.000000', 'temperatura', 1094.0000, 'ºC'),
	(171826, 119, '2014-02-01 00:39:40.000000', 'temperatura', 211.0000, 'ºC'),
	(171827, 119, '2014-02-01 00:39:41.000000', 'temperatura', 171.0000, 'ºC'),
	(171828, 119, '2014-02-01 00:39:42.000000', 'temperatura', 225.0000, 'ºC'),
	(171829, 119, '2014-02-01 00:39:43.000000', 'temperatura', 610.0000, 'ºC'),
	(171830, 119, '2014-02-01 00:39:44.000000', 'temperatura', 1177.0000, 'ºC'),
	(171831, 119, '2014-02-01 00:39:45.000000', 'temperatura', 454.0000, 'ºC'),
	(171832, 119, '2014-02-01 00:39:46.000000', 'temperatura', 1141.0000, 'ºC'),
	(171833, 119, '2014-02-01 00:39:47.000000', 'temperatura', 742.0000, 'ºC'),
	(171834, 119, '2014-02-01 00:39:48.000000', 'temperatura', 288.0000, 'ºC'),
	(171835, 119, '2014-02-01 00:39:49.000000', 'temperatura', 415.0000, 'ºC'),
	(171836, 119, '2014-02-01 00:39:50.000000', 'temperatura', 10.0000, 'ºC'),
	(171837, 119, '2014-02-01 00:39:51.000000', 'temperatura', 6.0000, 'ºC'),
	(171838, 119, '2014-02-01 00:39:52.000000', 'temperatura', 0.0000, 'ºC'),
	(171839, 119, '2014-02-01 00:39:53.000000', 'temperatura', 1184.0000, 'ºC'),
	(171840, 119, '2014-02-01 00:39:54.000000', 'temperatura', 1121.0000, 'ºC'),
	(171841, 119, '2014-02-01 00:39:55.000000', 'temperatura', 853.0000, 'ºC'),
	(171842, 119, '2014-02-01 00:39:56.000000', 'temperatura', 901.0000, 'ºC'),
	(171843, 119, '2014-02-01 00:39:57.000000', 'temperatura', 748.0000, 'ºC'),
	(171844, 119, '2014-02-01 00:39:58.000000', 'temperatura', 1035.0000, 'ºC'),
	(171845, 119, '2014-02-01 00:39:59.000000', 'temperatura', 534.0000, 'ºC'),
	(171846, 119, '2014-02-01 00:40:00.000000', 'temperatura', 766.0000, 'ºC'),
	(171847, 119, '2014-02-01 00:40:01.000000', 'temperatura', 1027.0000, 'ºC'),
	(171848, 119, '2014-02-01 00:40:02.000000', 'temperatura', 438.0000, 'ºC'),
	(171849, 119, '2014-02-01 00:40:03.000000', 'temperatura', 308.0000, 'ºC'),
	(171850, 119, '2014-02-01 00:40:04.000000', 'temperatura', 229.0000, 'ºC'),
	(171851, 119, '2014-02-01 00:40:05.000000', 'temperatura', 221.0000, 'ºC'),
	(171852, 119, '2014-02-01 00:40:06.000000', 'temperatura', 417.0000, 'ºC'),
	(171853, 119, '2014-02-01 00:40:07.000000', 'temperatura', 225.0000, 'ºC'),
	(171854, 119, '2014-02-01 00:40:08.000000', 'temperatura', 1074.0000, 'ºC'),
	(171855, 119, '2014-02-01 00:40:09.000000', 'temperatura', 1095.0000, 'ºC'),
	(171856, 119, '2014-02-01 00:40:10.000000', 'temperatura', 1055.0000, 'ºC'),
	(171857, 119, '2014-02-01 00:40:11.000000', 'temperatura', 790.0000, 'ºC'),
	(171858, 119, '2014-02-01 00:40:12.000000', 'temperatura', 787.0000, 'ºC'),
	(171859, 119, '2014-02-01 00:40:13.000000', 'temperatura', 364.0000, 'ºC'),
	(171860, 119, '2014-02-01 00:40:14.000000', 'temperatura', 658.0000, 'ºC'),
	(171861, 119, '2014-02-01 00:40:15.000000', 'temperatura', 1000.0000, 'ºC'),
	(171862, 119, '2014-02-01 00:40:16.000000', 'temperatura', 627.0000, 'ºC'),
	(171863, 119, '2014-02-01 00:40:17.000000', 'temperatura', 136.0000, 'ºC'),
	(171864, 119, '2014-02-01 00:40:18.000000', 'temperatura', 1199.0000, 'ºC'),
	(171865, 119, '2014-02-01 00:40:19.000000', 'temperatura', 787.0000, 'ºC'),
	(171866, 119, '2014-02-01 00:40:20.000000', 'temperatura', 340.0000, 'ºC'),
	(171867, 119, '2014-02-01 00:40:21.000000', 'temperatura', 539.0000, 'ºC'),
	(171868, 119, '2014-02-01 00:40:22.000000', 'temperatura', 475.0000, 'ºC'),
	(171869, 119, '2014-02-01 00:40:23.000000', 'temperatura', 758.0000, 'ºC'),
	(171870, 119, '2014-02-01 00:40:24.000000', 'temperatura', 1165.0000, 'ºC'),
	(171871, 119, '2014-02-01 00:40:25.000000', 'temperatura', 1154.0000, 'ºC'),
	(171872, 119, '2014-02-01 00:40:26.000000', 'temperatura', 1075.0000, 'ºC'),
	(171873, 119, '2014-02-01 00:40:27.000000', 'temperatura', 711.0000, 'ºC'),
	(171874, 119, '2014-02-01 00:40:28.000000', 'temperatura', 332.0000, 'ºC'),
	(171875, 119, '2014-02-01 00:40:29.000000', 'temperatura', 727.0000, 'ºC'),
	(171876, 119, '2014-02-01 00:40:30.000000', 'temperatura', 242.0000, 'ºC'),
	(171877, 119, '2014-02-01 00:40:31.000000', 'temperatura', 227.0000, 'ºC'),
	(171878, 119, '2014-02-01 00:40:32.000000', 'temperatura', 412.0000, 'ºC'),
	(171879, 119, '2014-02-01 00:40:33.000000', 'temperatura', 177.0000, 'ºC'),
	(171880, 119, '2014-02-01 00:40:34.000000', 'temperatura', 850.0000, 'ºC'),
	(171881, 119, '2014-02-01 00:40:35.000000', 'temperatura', 122.0000, 'ºC'),
	(171882, 119, '2014-02-01 00:40:36.000000', 'temperatura', 457.0000, 'ºC'),
	(171883, 119, '2014-02-01 00:40:37.000000', 'temperatura', 720.0000, 'ºC'),
	(171884, 119, '2014-02-01 00:40:38.000000', 'temperatura', 1030.0000, 'ºC'),
	(171885, 119, '2014-02-01 00:40:39.000000', 'temperatura', 592.0000, 'ºC'),
	(171886, 119, '2014-02-01 00:40:40.000000', 'temperatura', 1068.0000, 'ºC'),
	(171887, 119, '2014-02-01 00:40:41.000000', 'temperatura', 1166.0000, 'ºC'),
	(171888, 119, '2014-02-01 00:40:42.000000', 'temperatura', 228.0000, 'ºC'),
	(171889, 119, '2014-02-01 00:40:43.000000', 'temperatura', 42.0000, 'ºC'),
	(171890, 119, '2014-02-01 00:40:44.000000', 'temperatura', 725.0000, 'ºC'),
	(171891, 119, '2014-02-01 00:40:45.000000', 'temperatura', 1098.0000, 'ºC'),
	(171892, 119, '2014-02-01 00:40:46.000000', 'temperatura', 919.0000, 'ºC'),
	(171893, 119, '2014-02-01 00:40:47.000000', 'temperatura', 99.0000, 'ºC'),
	(171894, 119, '2014-02-01 00:40:48.000000', 'temperatura', 139.0000, 'ºC'),
	(171895, 119, '2014-02-01 00:40:49.000000', 'temperatura', 399.0000, 'ºC'),
	(171896, 119, '2014-02-01 00:40:50.000000', 'temperatura', 378.0000, 'ºC'),
	(171897, 119, '2014-02-01 00:40:51.000000', 'temperatura', 692.0000, 'ºC'),
	(171898, 119, '2014-02-01 00:40:52.000000', 'temperatura', 1128.0000, 'ºC'),
	(171899, 119, '2014-02-01 00:40:53.000000', 'temperatura', 1165.0000, 'ºC'),
	(171900, 119, '2014-02-01 00:40:54.000000', 'temperatura', 42.0000, 'ºC'),
	(171901, 119, '2014-02-01 00:40:55.000000', 'temperatura', 313.0000, 'ºC'),
	(171902, 119, '2014-02-01 00:40:56.000000', 'temperatura', 242.0000, 'ºC'),
	(171903, 119, '2014-02-01 00:40:57.000000', 'temperatura', 270.0000, 'ºC'),
	(171904, 119, '2014-02-01 00:40:58.000000', 'temperatura', 625.0000, 'ºC'),
	(171905, 119, '2014-02-01 00:40:59.000000', 'temperatura', 1115.0000, 'ºC'),
	(171906, 119, '2014-02-01 00:41:00.000000', 'temperatura', 103.0000, 'ºC'),
	(171907, 119, '2014-02-01 00:41:01.000000', 'temperatura', 768.0000, 'ºC'),
	(171908, 119, '2014-02-01 00:41:02.000000', 'temperatura', 1132.0000, 'ºC'),
	(171909, 119, '2014-02-01 00:41:03.000000', 'temperatura', 959.0000, 'ºC'),
	(171910, 119, '2014-02-01 00:41:04.000000', 'temperatura', 197.0000, 'ºC'),
	(171911, 119, '2014-02-01 00:41:05.000000', 'temperatura', 507.0000, 'ºC'),
	(171912, 119, '2014-02-01 00:41:06.000000', 'temperatura', 747.0000, 'ºC'),
	(171913, 119, '2014-02-01 00:41:07.000000', 'temperatura', 1015.0000, 'ºC'),
	(171914, 119, '2014-02-01 00:41:08.000000', 'temperatura', 435.0000, 'ºC'),
	(171915, 119, '2014-02-01 00:41:09.000000', 'temperatura', 332.0000, 'ºC'),
	(171916, 119, '2014-02-01 00:41:10.000000', 'temperatura', 352.0000, 'ºC'),
	(171917, 119, '2014-02-01 00:41:11.000000', 'temperatura', 765.0000, 'ºC'),
	(171918, 119, '2014-02-01 00:41:12.000000', 'temperatura', 369.0000, 'ºC'),
	(171919, 119, '2014-02-01 00:41:13.000000', 'temperatura', 753.0000, 'ºC'),
	(171920, 119, '2014-02-01 00:41:14.000000', 'temperatura', 258.0000, 'ºC'),
	(171921, 119, '2014-02-01 00:41:15.000000', 'temperatura', 230.0000, 'ºC'),
	(171922, 119, '2014-02-01 00:41:16.000000', 'temperatura', 376.0000, 'ºC'),
	(171923, 119, '2014-02-01 00:41:17.000000', 'temperatura', 1191.0000, 'ºC'),
	(171924, 119, '2014-02-01 00:41:18.000000', 'temperatura', 28.0000, 'ºC'),
	(171925, 119, '2014-02-01 00:41:19.000000', 'temperatura', 167.0000, 'ºC'),
	(171926, 119, '2014-02-01 00:41:20.000000', 'temperatura', 754.0000, 'ºC'),
	(171927, 119, '2014-02-01 00:41:21.000000', 'temperatura', 867.0000, 'ºC'),
	(171928, 119, '2014-02-01 00:41:22.000000', 'temperatura', 872.0000, 'ºC'),
	(171929, 119, '2014-02-01 00:41:23.000000', 'temperatura', 562.0000, 'ºC'),
	(171930, 119, '2014-02-01 00:41:24.000000', 'temperatura', 193.0000, 'ºC'),
	(171931, 119, '2014-02-01 00:41:25.000000', 'temperatura', 479.0000, 'ºC'),
	(171932, 119, '2014-02-01 00:41:26.000000', 'temperatura', 617.0000, 'ºC'),
	(171933, 119, '2014-02-01 00:41:27.000000', 'temperatura', 448.0000, 'ºC'),
	(171934, 119, '2014-02-01 00:41:28.000000', 'temperatura', 392.0000, 'ºC'),
	(171935, 119, '2014-02-01 00:41:29.000000', 'temperatura', 613.0000, 'ºC'),
	(171936, 119, '2014-02-01 00:41:30.000000', 'temperatura', 692.0000, 'ºC'),
	(171937, 119, '2014-02-01 00:41:31.000000', 'temperatura', 423.0000, 'ºC'),
	(171938, 119, '2014-02-01 00:41:32.000000', 'temperatura', 37.0000, 'ºC'),
	(171939, 119, '2014-02-01 00:41:33.000000', 'temperatura', 116.0000, 'ºC'),
	(171940, 119, '2014-02-01 00:41:34.000000', 'temperatura', 472.0000, 'ºC'),
	(171941, 119, '2014-02-01 00:41:35.000000', 'temperatura', 812.0000, 'ºC'),
	(171942, 119, '2014-02-01 00:41:36.000000', 'temperatura', 245.0000, 'ºC'),
	(171943, 119, '2014-02-01 00:41:37.000000', 'temperatura', 1189.0000, 'ºC'),
	(171944, 119, '2014-02-01 00:41:38.000000', 'temperatura', 409.0000, 'ºC'),
	(171945, 119, '2014-02-01 00:41:39.000000', 'temperatura', 880.0000, 'ºC'),
	(171946, 119, '2014-02-01 00:41:40.000000', 'temperatura', 772.0000, 'ºC'),
	(171947, 119, '2014-02-01 00:41:41.000000', 'temperatura', 23.0000, 'ºC'),
	(171948, 119, '2014-02-01 00:41:42.000000', 'temperatura', 200.0000, 'ºC'),
	(171949, 119, '2014-02-01 00:41:43.000000', 'temperatura', 930.0000, 'ºC'),
	(171950, 119, '2014-02-01 00:41:44.000000', 'temperatura', 451.0000, 'ºC'),
	(171951, 119, '2014-02-01 00:41:45.000000', 'temperatura', 665.0000, 'ºC'),
	(171952, 119, '2014-02-01 00:41:46.000000', 'temperatura', 774.0000, 'ºC'),
	(171953, 119, '2014-02-01 00:41:47.000000', 'temperatura', 676.0000, 'ºC'),
	(171954, 119, '2014-02-01 00:41:48.000000', 'temperatura', 1057.0000, 'ºC'),
	(171955, 119, '2014-02-01 00:41:49.000000', 'temperatura', 858.0000, 'ºC'),
	(171956, 119, '2014-02-01 00:41:50.000000', 'temperatura', 1118.0000, 'ºC'),
	(171957, 119, '2014-02-01 00:41:51.000000', 'temperatura', 617.0000, 'ºC'),
	(171958, 119, '2014-02-01 00:41:52.000000', 'temperatura', 932.0000, 'ºC'),
	(171959, 119, '2014-02-01 00:41:53.000000', 'temperatura', 410.0000, 'ºC'),
	(171960, 119, '2014-02-01 00:41:54.000000', 'temperatura', 453.0000, 'ºC'),
	(171961, 119, '2014-02-01 00:41:55.000000', 'temperatura', 1035.0000, 'ºC'),
	(171962, 119, '2014-02-01 00:41:56.000000', 'temperatura', 216.0000, 'ºC'),
	(171963, 119, '2014-02-01 00:41:57.000000', 'temperatura', 376.0000, 'ºC'),
	(171964, 119, '2014-02-01 00:41:58.000000', 'temperatura', 34.0000, 'ºC'),
	(171965, 119, '2014-02-01 00:41:59.000000', 'temperatura', 240.0000, 'ºC'),
	(171966, 119, '2014-02-01 00:42:00.000000', 'temperatura', 1101.0000, 'ºC'),
	(171967, 119, '2014-02-01 00:42:01.000000', 'temperatura', 1183.0000, 'ºC'),
	(171968, 119, '2014-02-01 00:42:02.000000', 'temperatura', 212.0000, 'ºC'),
	(171969, 119, '2014-02-01 00:42:03.000000', 'temperatura', 1113.0000, 'ºC'),
	(171970, 119, '2014-02-01 00:42:04.000000', 'temperatura', 129.0000, 'ºC'),
	(171971, 119, '2014-02-01 00:42:05.000000', 'temperatura', 908.0000, 'ºC'),
	(171972, 119, '2014-02-01 00:42:06.000000', 'temperatura', 550.0000, 'ºC'),
	(171973, 119, '2014-02-01 00:42:07.000000', 'temperatura', 30.0000, 'ºC'),
	(171974, 119, '2014-02-01 00:42:08.000000', 'temperatura', 900.0000, 'ºC'),
	(171975, 119, '2014-02-01 00:42:09.000000', 'temperatura', 810.0000, 'ºC'),
	(171976, 119, '2014-02-01 00:42:10.000000', 'temperatura', 151.0000, 'ºC'),
	(171977, 119, '2014-02-01 00:42:11.000000', 'temperatura', 726.0000, 'ºC'),
	(171978, 119, '2014-02-01 00:42:12.000000', 'temperatura', 778.0000, 'ºC'),
	(171979, 119, '2014-02-01 00:42:13.000000', 'temperatura', 510.0000, 'ºC'),
	(171980, 119, '2014-02-01 00:42:14.000000', 'temperatura', 219.0000, 'ºC'),
	(171981, 119, '2014-02-01 00:42:15.000000', 'temperatura', 764.0000, 'ºC'),
	(171982, 119, '2014-02-01 00:42:16.000000', 'temperatura', 762.0000, 'ºC'),
	(171983, 119, '2014-02-01 00:42:17.000000', 'temperatura', 319.0000, 'ºC'),
	(171984, 119, '2014-02-01 00:42:18.000000', 'temperatura', 512.0000, 'ºC'),
	(171985, 119, '2014-02-01 00:42:19.000000', 'temperatura', 403.0000, 'ºC'),
	(171986, 119, '2014-02-01 00:42:20.000000', 'temperatura', 479.0000, 'ºC'),
	(171987, 119, '2014-02-01 00:42:21.000000', 'temperatura', 1188.0000, 'ºC'),
	(171988, 119, '2014-02-01 00:42:22.000000', 'temperatura', 903.0000, 'ºC'),
	(171989, 119, '2014-02-01 00:42:23.000000', 'temperatura', 953.0000, 'ºC'),
	(171990, 119, '2014-02-01 00:42:24.000000', 'temperatura', 853.0000, 'ºC'),
	(171991, 119, '2014-02-01 00:42:25.000000', 'temperatura', 209.0000, 'ºC'),
	(171992, 119, '2014-02-01 00:42:26.000000', 'temperatura', 884.0000, 'ºC'),
	(171993, 119, '2014-02-01 00:42:27.000000', 'temperatura', 193.0000, 'ºC'),
	(171994, 119, '2014-02-01 00:42:28.000000', 'temperatura', 717.0000, 'ºC'),
	(171995, 119, '2014-02-01 00:42:29.000000', 'temperatura', 604.0000, 'ºC'),
	(171996, 119, '2014-02-01 00:42:30.000000', 'temperatura', 869.0000, 'ºC'),
	(171997, 119, '2014-02-01 00:42:31.000000', 'temperatura', 134.0000, 'ºC'),
	(171998, 119, '2014-02-01 00:42:32.000000', 'temperatura', 465.0000, 'ºC'),
	(171999, 119, '2014-02-01 00:42:33.000000', 'temperatura', 723.0000, 'ºC'),
	(172000, 119, '2014-02-01 00:42:34.000000', 'temperatura', 1020.0000, 'ºC'),
	(172001, 119, '2014-02-01 00:42:35.000000', 'temperatura', 530.0000, 'ºC'),
	(172002, 119, '2014-02-01 00:42:36.000000', 'temperatura', 793.0000, 'ºC'),
	(172003, 119, '2014-02-01 00:42:37.000000', 'temperatura', 1176.0000, 'ºC'),
	(172004, 119, '2014-02-01 00:42:38.000000', 'temperatura', 1099.0000, 'ºC'),
	(172005, 119, '2014-02-01 00:42:39.000000', 'temperatura', 770.0000, 'ºC'),
	(172006, 119, '2014-02-01 00:42:40.000000', 'temperatura', 553.0000, 'ºC'),
	(172007, 119, '2014-02-01 00:42:41.000000', 'temperatura', 457.0000, 'ºC'),
	(172008, 119, '2014-02-01 00:42:42.000000', 'temperatura', 626.0000, 'ºC'),
	(172009, 119, '2014-02-01 00:42:43.000000', 'temperatura', 561.0000, 'ºC'),
	(172010, 119, '2014-02-01 00:42:44.000000', 'temperatura', 924.0000, 'ºC'),
	(172011, 119, '2014-02-01 00:42:45.000000', 'temperatura', 540.0000, 'ºC'),
	(172012, 119, '2014-02-01 00:42:46.000000', 'temperatura', 1129.0000, 'ºC'),
	(172013, 119, '2014-02-01 00:42:47.000000', 'temperatura', 423.0000, 'ºC'),
	(172014, 119, '2014-02-01 00:42:48.000000', 'temperatura', 1129.0000, 'ºC'),
	(172015, 119, '2014-02-01 00:42:49.000000', 'temperatura', 777.0000, 'ºC'),
	(172016, 119, '2014-02-01 00:42:50.000000', 'temperatura', 497.0000, 'ºC'),
	(172017, 119, '2014-02-01 00:42:51.000000', 'temperatura', 155.0000, 'ºC'),
	(172018, 119, '2014-02-01 00:42:52.000000', 'temperatura', 486.0000, 'ºC'),
	(172019, 119, '2014-02-01 00:42:53.000000', 'temperatura', 765.0000, 'ºC'),
	(172020, 119, '2014-02-01 00:42:54.000000', 'temperatura', 1169.0000, 'ºC'),
	(172021, 119, '2014-02-01 00:42:55.000000', 'temperatura', 1150.0000, 'ºC'),
	(172022, 119, '2014-02-01 00:42:56.000000', 'temperatura', 1042.0000, 'ºC'),
	(172023, 119, '2014-02-01 00:42:57.000000', 'temperatura', 560.0000, 'ºC'),
	(172024, 119, '2014-02-01 00:42:58.000000', 'temperatura', 875.0000, 'ºC'),
	(172025, 119, '2014-02-01 00:42:59.000000', 'temperatura', 294.0000, 'ºC'),
	(172026, 119, '2014-02-01 00:43:00.000000', 'temperatura', 47.0000, 'ºC'),
	(172027, 119, '2014-02-01 00:43:01.000000', 'temperatura', 552.0000, 'ºC'),
	(172028, 119, '2014-02-01 00:43:02.000000', 'temperatura', 219.0000, 'ºC'),
	(172029, 119, '2014-02-01 00:43:03.000000', 'temperatura', 641.0000, 'ºC'),
	(172030, 119, '2014-02-01 00:43:04.000000', 'temperatura', 147.0000, 'ºC'),
	(172031, 119, '2014-02-01 00:43:05.000000', 'temperatura', 15.0000, 'ºC'),
	(172032, 119, '2014-02-01 00:43:06.000000', 'temperatura', 834.0000, 'ºC'),
	(172033, 119, '2014-02-01 00:43:07.000000', 'temperatura', 525.0000, 'ºC'),
	(172034, 119, '2014-02-01 00:43:08.000000', 'temperatura', 124.0000, 'ºC'),
	(172035, 119, '2014-02-01 00:43:09.000000', 'temperatura', 246.0000, 'ºC'),
	(172036, 119, '2014-02-01 00:43:10.000000', 'temperatura', 857.0000, 'ºC'),
	(172037, 119, '2014-02-01 00:43:11.000000', 'temperatura', 1150.0000, 'ºC'),
	(172038, 119, '2014-02-01 00:43:12.000000', 'temperatura', 778.0000, 'ºC'),
	(172039, 119, '2014-02-01 00:43:13.000000', 'temperatura', 441.0000, 'ºC'),
	(172040, 119, '2014-02-01 00:43:14.000000', 'temperatura', 1069.0000, 'ºC'),
	(172041, 119, '2014-02-01 00:43:15.000000', 'temperatura', 425.0000, 'ºC'),
	(172042, 119, '2014-02-01 00:43:16.000000', 'temperatura', 118.0000, 'ºC'),
	(172043, 119, '2014-02-01 00:43:17.000000', 'temperatura', 514.0000, 'ºC'),
	(172044, 119, '2014-02-01 00:43:18.000000', 'temperatura', 1017.0000, 'ºC'),
	(172045, 119, '2014-02-01 00:43:19.000000', 'temperatura', 1143.0000, 'ºC'),
	(172046, 119, '2014-02-01 00:43:20.000000', 'temperatura', 265.0000, 'ºC'),
	(172047, 119, '2014-02-01 00:43:21.000000', 'temperatura', 296.0000, 'ºC'),
	(172048, 119, '2014-02-01 00:43:22.000000', 'temperatura', 686.0000, 'ºC'),
	(172049, 119, '2014-02-01 00:43:23.000000', 'temperatura', 142.0000, 'ºC'),
	(172050, 119, '2014-02-01 00:43:24.000000', 'temperatura', 1052.0000, 'ºC'),
	(172051, 119, '2014-02-01 00:43:25.000000', 'temperatura', 37.0000, 'ºC'),
	(172052, 119, '2014-02-01 00:43:26.000000', 'temperatura', 627.0000, 'ºC'),
	(172053, 119, '2014-02-01 00:43:27.000000', 'temperatura', 624.0000, 'ºC'),
	(172054, 119, '2014-02-01 00:43:28.000000', 'temperatura', 38.0000, 'ºC'),
	(172055, 119, '2014-02-01 00:43:29.000000', 'temperatura', 722.0000, 'ºC'),
	(172056, 119, '2014-02-01 00:43:30.000000', 'temperatura', 1096.0000, 'ºC'),
	(172057, 119, '2014-02-01 00:43:31.000000', 'temperatura', 912.0000, 'ºC'),
	(172058, 119, '2014-02-01 00:43:32.000000', 'temperatura', 75.0000, 'ºC'),
	(172059, 119, '2014-02-01 00:43:33.000000', 'temperatura', 39.0000, 'ºC'),
	(172060, 119, '2014-02-01 00:43:34.000000', 'temperatura', 1172.0000, 'ºC'),
	(172061, 119, '2014-02-01 00:43:35.000000', 'temperatura', 943.0000, 'ºC'),
	(172062, 119, '2014-02-01 00:43:36.000000', 'temperatura', 1199.0000, 'ºC'),
	(172063, 119, '2014-02-01 00:43:37.000000', 'temperatura', 768.0000, 'ºC'),
	(172064, 119, '2014-02-01 00:43:38.000000', 'temperatura', 243.0000, 'ºC'),
	(172065, 119, '2014-02-01 00:43:39.000000', 'temperatura', 110.0000, 'ºC'),
	(172066, 119, '2014-02-01 00:43:40.000000', 'temperatura', 1024.0000, 'ºC'),
	(172067, 119, '2014-02-01 00:43:41.000000', 'temperatura', 1191.0000, 'ºC'),
	(172068, 119, '2014-02-01 00:43:42.000000', 'temperatura', 482.0000, 'ºC'),
	(172069, 119, '2014-02-01 00:43:43.000000', 'temperatura', 39.0000, 'ºC'),
	(172070, 119, '2014-02-01 00:43:44.000000', 'temperatura', 1150.0000, 'ºC'),
	(172071, 119, '2014-02-01 00:43:45.000000', 'temperatura', 830.0000, 'ºC'),
	(172072, 119, '2014-02-01 00:43:46.000000', 'temperatura', 704.0000, 'ºC'),
	(172073, 119, '2014-02-01 00:43:47.000000', 'temperatura', 1029.0000, 'ºC'),
	(172074, 119, '2014-02-01 00:43:48.000000', 'temperatura', 634.0000, 'ºC'),
	(172075, 119, '2014-02-01 00:43:49.000000', 'temperatura', 82.0000, 'ºC'),
	(172076, 119, '2014-02-01 00:43:50.000000', 'temperatura', 909.0000, 'ºC'),
	(172077, 119, '2014-02-01 00:43:51.000000', 'temperatura', 701.0000, 'ºC'),
	(172078, 119, '2014-02-01 00:43:52.000000', 'temperatura', 778.0000, 'ºC'),
	(172079, 119, '2014-02-01 00:43:53.000000', 'temperatura', 588.0000, 'ºC'),
	(172080, 119, '2014-02-01 00:43:54.000000', 'temperatura', 607.0000, 'ºC'),
	(172081, 119, '2014-02-01 00:43:55.000000', 'temperatura', 71.0000, 'ºC'),
	(172082, 119, '2014-02-01 00:43:56.000000', 'temperatura', 933.0000, 'ºC'),
	(172083, 119, '2014-02-01 00:43:57.000000', 'temperatura', 852.0000, 'ºC'),
	(172084, 119, '2014-02-01 00:43:58.000000', 'temperatura', 262.0000, 'ºC'),
	(172085, 119, '2014-02-01 00:43:59.000000', 'temperatura', 1156.0000, 'ºC'),
	(172086, 119, '2014-02-01 00:44:00.000000', 'temperatura', 193.0000, 'ºC'),
	(172087, 119, '2014-02-01 00:44:01.000000', 'temperatura', 1099.0000, 'ºC'),
	(172088, 119, '2014-02-01 00:44:02.000000', 'temperatura', 117.0000, 'ºC'),
	(172089, 119, '2014-02-01 00:44:03.000000', 'temperatura', 890.0000, 'ºC'),
	(172090, 119, '2014-02-01 00:44:04.000000', 'temperatura', 496.0000, 'ºC'),
	(172091, 119, '2014-02-01 00:44:05.000000', 'temperatura', 1012.0000, 'ºC'),
	(172092, 119, '2014-02-01 00:44:06.000000', 'temperatura', 1173.0000, 'ºC'),
	(172093, 119, '2014-02-01 00:44:07.000000', 'temperatura', 429.0000, 'ºC'),
	(172094, 119, '2014-02-01 00:44:08.000000', 'temperatura', 1028.0000, 'ºC'),
	(172095, 119, '2014-02-01 00:44:09.000000', 'temperatura', 254.0000, 'ºC'),
	(172096, 119, '2014-02-01 00:44:10.000000', 'temperatura', 586.0000, 'ºC'),
	(172097, 119, '2014-02-01 00:44:11.000000', 'temperatura', 968.0000, 'ºC'),
	(172098, 119, '2014-02-01 00:44:12.000000', 'temperatura', 681.0000, 'ºC'),
	(172099, 119, '2014-02-01 00:44:13.000000', 'temperatura', 504.0000, 'ºC'),
	(172100, 119, '2014-02-01 00:44:14.000000', 'temperatura', 477.0000, 'ºC'),
	(172101, 119, '2014-02-01 00:44:15.000000', 'temperatura', 875.0000, 'ºC'),
	(172102, 119, '2014-02-01 00:44:16.000000', 'temperatura', 543.0000, 'ºC'),
	(172103, 119, '2014-02-01 00:44:17.000000', 'temperatura', 90.0000, 'ºC'),
	(172104, 119, '2014-02-01 00:44:18.000000', 'temperatura', 20.0000, 'ºC'),
	(172105, 119, '2014-02-01 00:44:19.000000', 'temperatura', 1034.0000, 'ºC'),
	(172106, 119, '2014-02-01 00:44:20.000000', 'temperatura', 307.0000, 'ºC'),
	(172107, 119, '2014-02-01 00:44:21.000000', 'temperatura', 835.0000, 'ºC'),
	(172108, 119, '2014-02-01 00:44:22.000000', 'temperatura', 855.0000, 'ºC'),
	(172109, 119, '2014-02-01 00:44:23.000000', 'temperatura', 571.0000, 'ºC'),
	(172110, 119, '2014-02-01 00:44:24.000000', 'temperatura', 289.0000, 'ºC'),
	(172111, 119, '2014-02-01 00:44:25.000000', 'temperatura', 935.0000, 'ºC'),
	(172112, 119, '2014-02-01 00:44:26.000000', 'temperatura', 208.0000, 'ºC'),
	(172113, 119, '2014-02-01 00:44:27.000000', 'temperatura', 634.0000, 'ºC'),
	(172114, 119, '2014-02-01 00:44:28.000000', 'temperatura', 147.0000, 'ºC'),
	(172115, 119, '2014-02-01 00:44:29.000000', 'temperatura', 36.0000, 'ºC'),
	(172116, 119, '2014-02-01 00:44:30.000000', 'temperatura', 936.0000, 'ºC'),
	(172117, 119, '2014-02-01 00:44:31.000000', 'temperatura', 974.0000, 'ºC'),
	(172118, 119, '2014-02-01 00:44:32.000000', 'temperatura', 862.0000, 'ºC'),
	(172119, 119, '2014-02-01 00:44:33.000000', 'temperatura', 190.0000, 'ºC'),
	(172120, 119, '2014-02-01 00:44:34.000000', 'temperatura', 765.0000, 'ºC'),
	(172121, 119, '2014-02-01 00:44:35.000000', 'temperatura', 854.0000, 'ºC'),
	(172122, 119, '2014-02-01 00:44:36.000000', 'temperatura', 777.0000, 'ºC'),
	(172123, 119, '2014-02-01 00:44:37.000000', 'temperatura', 121.0000, 'ºC'),
	(172124, 119, '2014-02-01 00:44:38.000000', 'temperatura', 676.0000, 'ºC'),
	(172125, 119, '2014-02-01 00:44:39.000000', 'temperatura', 617.0000, 'ºC'),
	(172126, 119, '2014-02-01 00:44:40.000000', 'temperatura', 1059.0000, 'ºC'),
	(172127, 119, '2014-02-01 00:44:41.000000', 'temperatura', 1044.0000, 'ºC'),
	(172128, 119, '2014-02-01 00:44:42.000000', 'temperatura', 843.0000, 'ºC'),
	(172129, 119, '2014-02-01 00:44:43.000000', 'temperatura', 1083.0000, 'ºC'),
	(172130, 119, '2014-02-01 00:44:44.000000', 'temperatura', 486.0000, 'ºC'),
	(172131, 119, '2014-02-01 00:44:45.000000', 'temperatura', 382.0000, 'ºC'),
	(172132, 119, '2014-02-01 00:44:46.000000', 'temperatura', 454.0000, 'ºC'),
	(172133, 119, '2014-02-01 00:44:47.000000', 'temperatura', 1122.0000, 'ºC'),
	(172134, 119, '2014-02-01 00:44:48.000000', 'temperatura', 649.0000, 'ºC'),
	(172135, 119, '2014-02-01 00:44:49.000000', 'temperatura', 1082.0000, 'ºC'),
	(172136, 119, '2014-02-01 00:44:50.000000', 'temperatura', 1060.0000, 'ºC'),
	(172137, 119, '2014-02-01 00:44:51.000000', 'temperatura', 858.0000, 'ºC'),
	(172138, 119, '2014-02-01 00:44:52.000000', 'temperatura', 1109.0000, 'ºC'),
	(172139, 119, '2014-02-01 00:44:53.000000', 'temperatura', 571.0000, 'ºC'),
	(172140, 119, '2014-02-01 00:44:54.000000', 'temperatura', 731.0000, 'ºC'),
	(172141, 119, '2014-02-01 00:44:55.000000', 'temperatura', 740.0000, 'ºC'),
	(172142, 119, '2014-02-01 00:44:56.000000', 'temperatura', 309.0000, 'ºC'),
	(172143, 119, '2014-02-01 00:44:57.000000', 'temperatura', 526.0000, 'ºC'),
	(172144, 119, '2014-02-01 00:44:58.000000', 'temperatura', 505.0000, 'ºC'),
	(172145, 119, '2014-02-01 00:44:59.000000', 'temperatura', 945.0000, 'ºC'),
	(172146, 119, '2014-02-01 00:45:00.000000', 'temperatura', 812.0000, 'ºC'),
	(172147, 119, '2014-02-01 00:45:01.000000', 'temperatura', 24.0000, 'ºC'),
	(172148, 119, '2014-02-01 00:45:02.000000', 'temperatura', 85.0000, 'ºC'),
	(172149, 119, '2014-02-01 00:45:03.000000', 'temperatura', 354.0000, 'ºC'),
	(172150, 119, '2014-02-01 00:45:04.000000', 'temperatura', 314.0000, 'ºC'),
	(172151, 119, '2014-02-01 00:45:05.000000', 'temperatura', 510.0000, 'ºC'),
	(172152, 119, '2014-02-01 00:45:06.000000', 'temperatura', 408.0000, 'ºC'),
	(172153, 119, '2014-02-01 00:45:07.000000', 'temperatura', 510.0000, 'ºC'),
	(172154, 119, '2014-02-01 00:45:08.000000', 'temperatura', 126.0000, 'ºC'),
	(172155, 119, '2014-02-01 00:45:09.000000', 'temperatura', 303.0000, 'ºC'),
	(172156, 119, '2014-02-01 00:45:10.000000', 'temperatura', 1135.0000, 'ºC'),
	(172157, 119, '2014-02-01 00:45:11.000000', 'temperatura', 1169.0000, 'ºC'),
	(172158, 119, '2014-02-01 00:45:12.000000', 'temperatura', 40.0000, 'ºC'),
	(172159, 119, '2014-02-01 00:45:13.000000', 'temperatura', 294.0000, 'ºC'),
	(172160, 119, '2014-02-01 00:45:14.000000', 'temperatura', 151.0000, 'ºC'),
	(172161, 119, '2014-02-01 00:45:15.000000', 'temperatura', 1074.0000, 'ºC'),
	(172162, 119, '2014-02-01 00:45:16.000000', 'temperatura', 116.0000, 'ºC'),
	(172163, 119, '2014-02-01 00:45:17.000000', 'temperatura', 958.0000, 'ºC'),
	(172164, 119, '2014-02-01 00:45:18.000000', 'temperatura', 842.0000, 'ºC'),
	(172165, 119, '2014-02-01 00:45:19.000000', 'temperatura', 139.0000, 'ºC'),
	(172166, 119, '2014-02-01 00:45:20.000000', 'temperatura', 569.0000, 'ºC'),
	(172167, 119, '2014-02-01 00:45:21.000000', 'temperatura', 30.0000, 'ºC'),
	(172168, 119, '2014-02-01 00:45:22.000000', 'temperatura', 842.0000, 'ºC'),
	(172169, 119, '2014-02-01 00:45:23.000000', 'temperatura', 519.0000, 'ºC'),
	(172170, 119, '2014-02-01 00:45:24.000000', 'temperatura', 70.0000, 'ºC'),
	(172171, 119, '2014-02-01 00:45:25.000000', 'temperatura', 1196.0000, 'ºC'),
	(172172, 119, '2014-02-01 00:45:26.000000', 'temperatura', 969.0000, 'ºC'),
	(172173, 119, '2014-02-01 00:45:27.000000', 'temperatura', 59.0000, 'ºC'),
	(172174, 119, '2014-02-01 00:45:28.000000', 'temperatura', 985.0000, 'ºC'),
	(172175, 119, '2014-02-01 00:45:29.000000', 'temperatura', 1152.0000, 'ºC'),
	(172176, 119, '2014-02-01 00:45:30.000000', 'temperatura', 404.0000, 'ºC'),
	(172177, 119, '2014-02-01 00:45:31.000000', 'temperatura', 966.0000, 'ºC'),
	(172178, 119, '2014-02-01 00:45:32.000000', 'temperatura', 20.0000, 'ºC'),
	(172179, 119, '2014-02-01 00:45:33.000000', 'temperatura', 799.0000, 'ºC'),
	(172180, 119, '2014-02-01 00:45:34.000000', 'temperatura', 336.0000, 'ºC'),
	(172181, 119, '2014-02-01 00:45:35.000000', 'temperatura', 484.0000, 'ºC'),
	(172182, 119, '2014-02-01 00:45:36.000000', 'temperatura', 213.0000, 'ºC'),
	(172183, 119, '2014-02-01 00:45:37.000000', 'temperatura', 812.0000, 'ºC'),
	(172184, 119, '2014-02-01 00:45:38.000000', 'temperatura', 1021.0000, 'ºC'),
	(172185, 119, '2014-02-01 00:45:39.000000', 'temperatura', 272.0000, 'ºC'),
	(172186, 119, '2014-02-01 00:45:40.000000', 'temperatura', 698.0000, 'ºC'),
	(172187, 119, '2014-02-01 00:45:41.000000', 'temperatura', 274.0000, 'ºC'),
	(172188, 119, '2014-02-01 00:45:42.000000', 'temperatura', 475.0000, 'ºC'),
	(172189, 119, '2014-02-01 00:45:43.000000', 'temperatura', 352.0000, 'ºC'),
	(172190, 119, '2014-02-01 00:45:44.000000', 'temperatura', 339.0000, 'ºC'),
	(172191, 119, '2014-02-01 00:45:45.000000', 'temperatura', 638.0000, 'ºC'),
	(172192, 119, '2014-02-01 00:45:46.000000', 'temperatura', 973.0000, 'ºC'),
	(172193, 119, '2014-02-01 00:45:47.000000', 'temperatura', 552.0000, 'ºC'),
	(172194, 119, '2014-02-01 00:45:48.000000', 'temperatura', 1039.0000, 'ºC'),
	(172195, 119, '2014-02-01 00:45:49.000000', 'temperatura', 1143.0000, 'ºC'),
	(172196, 119, '2014-02-01 00:45:50.000000', 'temperatura', 199.0000, 'ºC'),
	(172197, 119, '2014-02-01 00:45:51.000000', 'temperatura', 1164.0000, 'ºC'),
	(172198, 119, '2014-02-01 00:45:52.000000', 'temperatura', 423.0000, 'ºC'),
	(172199, 119, '2014-02-01 00:45:53.000000', 'temperatura', 1026.0000, 'ºC'),
	(172200, 119, '2014-02-01 00:45:54.000000', 'temperatura', 261.0000, 'ºC'),
	(172201, 119, '2014-02-01 00:45:55.000000', 'temperatura', 626.0000, 'ºC'),
	(172202, 119, '2014-02-01 00:45:56.000000', 'temperatura', 1149.0000, 'ºC'),
	(172203, 119, '2014-02-01 00:45:57.000000', 'temperatura', 267.0000, 'ºC'),
	(172204, 119, '2014-02-01 00:45:58.000000', 'temperatura', 290.0000, 'ºC'),
	(172205, 119, '2014-02-01 00:45:59.000000', 'temperatura', 648.0000, 'ºC'),
	(172206, 119, '2014-02-01 00:46:00.000000', 'temperatura', 1172.0000, 'ºC'),
	(172207, 119, '2014-02-01 00:46:01.000000', 'temperatura', 314.0000, 'ºC'),
	(172208, 119, '2014-02-01 00:46:02.000000', 'temperatura', 455.0000, 'ºC'),
	(172209, 119, '2014-02-01 00:46:03.000000', 'temperatura', 133.0000, 'ºC'),
	(172210, 119, '2014-02-01 00:46:04.000000', 'temperatura', 500.0000, 'ºC'),
	(172211, 119, '2014-02-01 00:46:05.000000', 'temperatura', 903.0000, 'ºC'),
	(172212, 119, '2014-02-01 00:46:06.000000', 'temperatura', 614.0000, 'ºC'),
	(172213, 119, '2014-02-01 00:46:07.000000', 'temperatura', 363.0000, 'ºC'),
	(172214, 119, '2014-02-01 00:46:08.000000', 'temperatura', 1171.0000, 'ºC'),
	(172215, 119, '2014-02-01 00:46:09.000000', 'temperatura', 1167.0000, 'ºC'),
	(172216, 119, '2014-02-01 00:46:10.000000', 'temperatura', 1125.0000, 'ºC'),
	(172217, 119, '2014-02-01 00:46:11.000000', 'temperatura', 922.0000, 'ºC'),
	(172218, 119, '2014-02-01 00:46:12.000000', 'temperatura', 37.0000, 'ºC'),
	(172219, 119, '2014-02-01 00:46:13.000000', 'temperatura', 1018.0000, 'ºC'),
	(172220, 119, '2014-02-01 00:46:14.000000', 'temperatura', 180.0000, 'ºC'),
	(172221, 119, '2014-02-01 00:46:15.000000', 'temperatura', 248.0000, 'ºC'),
	(172222, 119, '2014-02-01 00:46:16.000000', 'temperatura', 699.0000, 'ºC'),
	(172223, 119, '2014-02-01 00:46:17.000000', 'temperatura', 351.0000, 'ºC'),
	(172224, 119, '2014-02-01 00:46:18.000000', 'temperatura', 861.0000, 'ºC'),
	(172225, 119, '2014-02-01 00:46:19.000000', 'temperatura', 850.0000, 'ºC'),
	(172226, 119, '2014-02-01 00:46:20.000000', 'temperatura', 469.0000, 'ºC'),
	(172227, 119, '2014-02-01 00:46:21.000000', 'temperatura', 997.0000, 'ºC'),
	(172228, 119, '2014-02-01 00:46:22.000000', 'temperatura', 1177.0000, 'ºC'),
	(172229, 119, '2014-02-01 00:46:23.000000', 'temperatura', 494.0000, 'ºC'),
	(172230, 119, '2014-02-01 00:46:24.000000', 'temperatura', 139.0000, 'ºC'),
	(172231, 119, '2014-02-01 00:46:25.000000', 'temperatura', 415.0000, 'ºC'),
	(172232, 119, '2014-02-01 00:46:26.000000', 'temperatura', 457.0000, 'ºC'),
	(172233, 119, '2014-02-01 00:46:27.000000', 'temperatura', 1041.0000, 'ºC'),
	(172234, 119, '2014-02-01 00:46:28.000000', 'temperatura', 235.0000, 'ºC'),
	(172235, 119, '2014-02-01 00:46:29.000000', 'temperatura', 452.0000, 'ºC'),
	(172236, 119, '2014-02-01 00:46:30.000000', 'temperatura', 356.0000, 'ºC'),
	(172237, 119, '2014-02-01 00:46:31.000000', 'temperatura', 426.0000, 'ºC'),
	(172238, 119, '2014-02-01 00:46:32.000000', 'temperatura', 1060.0000, 'ºC'),
	(172239, 119, '2014-02-01 00:46:33.000000', 'temperatura', 423.0000, 'ºC'),
	(172240, 119, '2014-02-01 00:46:34.000000', 'temperatura', 134.0000, 'ºC'),
	(172241, 119, '2014-02-01 00:46:35.000000', 'temperatura', 602.0000, 'ºC'),
	(172242, 119, '2014-02-01 00:46:36.000000', 'temperatura', 210.0000, 'ºC'),
	(172243, 119, '2014-02-01 00:46:37.000000', 'temperatura', 445.0000, 'ºC'),
	(172244, 119, '2014-02-01 00:46:38.000000', 'temperatura', 393.0000, 'ºC'),
	(172245, 119, '2014-02-01 00:46:39.000000', 'temperatura', 632.0000, 'ºC'),
	(172246, 119, '2014-02-01 00:46:40.000000', 'temperatura', 783.0000, 'ºC'),
	(172247, 119, '2014-02-01 00:46:41.000000', 'temperatura', 818.0000, 'ºC'),
	(172248, 119, '2014-02-01 00:46:42.000000', 'temperatura', 543.0000, 'ºC'),
	(172249, 119, '2014-02-01 00:46:43.000000', 'temperatura', 260.0000, 'ºC'),
	(172250, 119, '2014-02-01 00:46:44.000000', 'temperatura', 872.0000, 'ºC'),
	(172251, 119, '2014-02-01 00:46:45.000000', 'temperatura', 1182.0000, 'ºC'),
	(172252, 119, '2014-02-01 00:46:46.000000', 'temperatura', 893.0000, 'ºC'),
	(172253, 119, '2014-02-01 00:46:47.000000', 'temperatura', 918.0000, 'ºC'),
	(172254, 119, '2014-02-01 00:46:48.000000', 'temperatura', 714.0000, 'ºC'),
	(172255, 119, '2014-02-01 00:46:49.000000', 'temperatura', 816.0000, 'ºC'),
	(172256, 119, '2014-02-01 00:46:50.000000', 'temperatura', 738.0000, 'ºC'),
	(172257, 119, '2014-02-01 00:46:51.000000', 'temperatura', 44.0000, 'ºC'),
	(172258, 119, '2014-02-01 00:46:52.000000', 'temperatura', 404.0000, 'ºC'),
	(172259, 119, '2014-02-01 00:46:53.000000', 'temperatura', 689.0000, 'ºC'),
	(172260, 119, '2014-02-01 00:46:54.000000', 'temperatura', 1032.0000, 'ºC'),
	(172261, 119, '2014-02-01 00:46:55.000000', 'temperatura', 696.0000, 'ºC'),
	(172262, 119, '2014-02-01 00:46:56.000000', 'temperatura', 382.0000, 'ºC'),
	(172263, 119, '2014-02-01 00:46:57.000000', 'temperatura', 1025.0000, 'ºC'),
	(172264, 119, '2014-02-01 00:46:58.000000', 'temperatura', 377.0000, 'ºC'),
	(172265, 119, '2014-02-01 00:46:59.000000', 'temperatura', 12.0000, 'ºC'),
	(172266, 119, '2014-02-01 00:47:00.000000', 'temperatura', 131.0000, 'ºC'),
	(172267, 119, '2014-02-01 00:47:01.000000', 'temperatura', 617.0000, 'ºC'),
	(172268, 119, '2014-02-01 00:47:02.000000', 'temperatura', 293.0000, 'ºC'),
	(172269, 119, '2014-02-01 00:47:03.000000', 'temperatura', 814.0000, 'ºC'),
	(172270, 119, '2014-02-01 00:47:04.000000', 'temperatura', 790.0000, 'ºC'),
	(172271, 119, '2014-02-01 00:47:05.000000', 'temperatura', 311.0000, 'ºC'),
	(172272, 119, '2014-02-01 00:47:06.000000', 'temperatura', 386.0000, 'ºC'),
	(172273, 119, '2014-02-01 00:47:07.000000', 'temperatura', 996.0000, 'ºC'),
	(172274, 119, '2014-02-01 00:47:08.000000', 'temperatura', 223.0000, 'ºC'),
	(172275, 119, '2014-02-01 00:47:09.000000', 'temperatura', 528.0000, 'ºC'),
	(172276, 119, '2014-02-01 00:47:10.000000', 'temperatura', 772.0000, 'ºC'),
	(172277, 119, '2014-02-01 00:47:11.000000', 'temperatura', 1078.0000, 'ºC'),
	(172278, 119, '2014-02-01 00:47:12.000000', 'temperatura', 672.0000, 'ºC'),
	(172279, 119, '2014-02-01 00:47:13.000000', 'temperatura', 128.0000, 'ºC'),
	(172280, 119, '2014-02-01 00:47:14.000000', 'temperatura', 1024.0000, 'ºC'),
	(172281, 119, '2014-02-01 00:47:15.000000', 'temperatura', 1138.0000, 'ºC'),
	(172282, 119, '2014-02-01 00:47:16.000000', 'temperatura', 217.0000, 'ºC'),
	(172283, 119, '2014-02-01 00:47:17.000000', 'temperatura', 73.0000, 'ºC'),
	(172284, 119, '2014-02-01 00:47:18.000000', 'temperatura', 914.0000, 'ºC'),
	(172285, 119, '2014-02-01 00:47:19.000000', 'temperatura', 750.0000, 'ºC'),
	(172286, 119, '2014-02-01 00:47:20.000000', 'temperatura', 1011.0000, 'ºC'),
	(172287, 119, '2014-02-01 00:47:21.000000', 'temperatura', 404.0000, 'ºC'),
	(172288, 119, '2014-02-01 00:47:22.000000', 'temperatura', 188.0000, 'ºC'),
	(172289, 119, '2014-02-01 00:47:23.000000', 'temperatura', 927.0000, 'ºC'),
	(172290, 119, '2014-02-01 00:47:24.000000', 'temperatura', 472.0000, 'ºC'),
	(172291, 119, '2014-02-01 00:47:25.000000', 'temperatura', 779.0000, 'ºC'),
	(172292, 119, '2014-02-01 00:47:26.000000', 'temperatura', 78.0000, 'ºC'),
	(172293, 119, '2014-02-01 00:47:27.000000', 'temperatura', 456.0000, 'ºC'),
	(172294, 119, '2014-02-01 00:47:28.000000', 'temperatura', 846.0000, 'ºC'),
	(172295, 119, '2014-02-01 00:47:29.000000', 'temperatura', 462.0000, 'ºC'),
	(172296, 119, '2014-02-01 00:47:30.000000', 'temperatura', 975.0000, 'ºC'),
	(172297, 119, '2014-02-01 00:47:31.000000', 'temperatura', 1087.0000, 'ºC'),
	(172298, 119, '2014-02-01 00:47:32.000000', 'temperatura', 109.0000, 'ºC'),
	(172299, 119, '2014-02-01 00:47:33.000000', 'temperatura', 887.0000, 'ºC'),
	(172300, 119, '2014-02-01 00:47:34.000000', 'temperatura', 508.0000, 'ºC'),
	(172301, 119, '2014-02-01 00:47:35.000000', 'temperatura', 1080.0000, 'ºC'),
	(172302, 119, '2014-02-01 00:47:36.000000', 'temperatura', 277.0000, 'ºC'),
	(172303, 119, '2014-02-01 00:47:37.000000', 'temperatura', 544.0000, 'ºC'),
	(172304, 119, '2014-02-01 00:47:38.000000', 'temperatura', 690.0000, 'ºC'),
	(172305, 119, '2014-02-01 00:47:39.000000', 'temperatura', 620.0000, 'ºC'),
	(172306, 119, '2014-02-01 00:47:40.000000', 'temperatura', 1029.0000, 'ºC'),
	(172307, 119, '2014-02-01 00:47:41.000000', 'temperatura', 886.0000, 'ºC'),
	(172308, 119, '2014-02-01 00:47:42.000000', 'temperatura', 144.0000, 'ºC'),
	(172309, 119, '2014-02-01 00:47:43.000000', 'temperatura', 461.0000, 'ºC'),
	(172310, 119, '2014-02-01 00:47:44.000000', 'temperatura', 674.0000, 'ºC'),
	(172311, 119, '2014-02-01 00:47:45.000000', 'temperatura', 787.0000, 'ºC'),
	(172312, 119, '2014-02-01 00:47:46.000000', 'temperatura', 714.0000, 'ºC'),
	(172313, 119, '2014-02-01 00:47:47.000000', 'temperatura', 10.0000, 'ºC'),
	(172314, 119, '2014-02-01 00:47:48.000000', 'temperatura', 309.0000, 'ºC'),
	(172315, 119, '2014-02-01 00:47:49.000000', 'temperatura', 314.0000, 'ºC'),
	(172316, 119, '2014-02-01 00:47:50.000000', 'temperatura', 646.0000, 'ºC'),
	(172317, 119, '2014-02-01 00:47:51.000000', 'temperatura', 1086.0000, 'ºC'),
	(172318, 119, '2014-02-01 00:47:52.000000', 'temperatura', 1093.0000, 'ºC'),
	(172319, 119, '2014-02-01 00:47:53.000000', 'temperatura', 1009.0000, 'ºC'),
	(172320, 119, '2014-02-01 00:47:54.000000', 'temperatura', 564.0000, 'ºC'),
	(172321, 119, '2014-02-01 00:47:55.000000', 'temperatura', 996.0000, 'ºC'),
	(172322, 119, '2014-02-01 00:47:56.000000', 'temperatura', 889.0000, 'ºC'),
	(172323, 119, '2014-02-01 00:47:57.000000', 'temperatura', 258.0000, 'ºC'),
	(172324, 119, '2014-02-01 00:47:58.000000', 'temperatura', 1023.0000, 'ºC'),
	(172325, 119, '2014-02-01 00:47:59.000000', 'temperatura', 742.0000, 'ºC'),
	(172326, 119, '2014-02-01 00:48:00.000000', 'temperatura', 640.0000, 'ºC'),
	(172327, 119, '2014-02-01 00:48:01.000000', 'temperatura', 973.0000, 'ºC'),
	(172328, 119, '2014-02-01 00:48:02.000000', 'temperatura', 549.0000, 'ºC'),
	(172329, 119, '2014-02-01 00:48:03.000000', 'temperatura', 1023.0000, 'ºC'),
	(172330, 119, '2014-02-01 00:48:04.000000', 'temperatura', 1072.0000, 'ºC'),
	(172331, 119, '2014-02-01 00:48:05.000000', 'temperatura', 1089.0000, 'ºC'),
	(172332, 119, '2014-02-01 00:48:06.000000', 'temperatura', 1032.0000, 'ºC'),
	(172333, 119, '2014-02-01 00:48:07.000000', 'temperatura', 693.0000, 'ºC'),
	(172334, 119, '2014-02-01 00:48:08.000000', 'temperatura', 369.0000, 'ºC'),
	(172335, 119, '2014-02-01 00:48:09.000000', 'temperatura', 965.0000, 'ºC'),
	(172336, 119, '2014-02-01 00:48:10.000000', 'temperatura', 121.0000, 'ºC'),
	(172337, 119, '2014-02-01 00:48:11.000000', 'temperatura', 112.0000, 'ºC'),
	(172338, 119, '2014-02-01 00:48:12.000000', 'temperatura', 194.0000, 'ºC'),
	(172339, 119, '2014-02-01 00:48:13.000000', 'temperatura', 635.0000, 'ºC'),
	(172340, 119, '2014-02-01 00:48:14.000000', 'temperatura', 193.0000, 'ºC'),
	(172341, 119, '2014-02-01 00:48:15.000000', 'temperatura', 263.0000, 'ºC'),
	(172342, 119, '2014-02-01 00:48:16.000000', 'temperatura', 734.0000, 'ºC'),
	(172343, 119, '2014-02-01 00:48:17.000000', 'temperatura', 482.0000, 'ºC'),
	(172344, 119, '2014-02-01 00:48:18.000000', 'temperatura', 209.0000, 'ºC'),
	(172345, 119, '2014-02-01 00:48:19.000000', 'temperatura', 800.0000, 'ºC'),
	(172346, 119, '2014-02-01 00:48:20.000000', 'temperatura', 973.0000, 'ºC'),
	(172347, 119, '2014-02-01 00:48:21.000000', 'temperatura', 65.0000, 'ºC'),
	(172348, 119, '2014-02-01 00:48:22.000000', 'temperatura', 1009.0000, 'ºC'),
	(172349, 119, '2014-02-01 00:48:23.000000', 'temperatura', 48.0000, 'ºC'),
	(172350, 119, '2014-02-01 00:48:24.000000', 'temperatura', 816.0000, 'ºC'),
	(172351, 119, '2014-02-01 00:48:25.000000', 'temperatura', 334.0000, 'ºC'),
	(172352, 119, '2014-02-01 00:48:26.000000', 'temperatura', 421.0000, 'ºC'),
	(172353, 119, '2014-02-01 00:48:27.000000', 'temperatura', 1106.0000, 'ºC'),
	(172354, 119, '2014-02-01 00:48:28.000000', 'temperatura', 669.0000, 'ºC'),
	(172355, 119, '2014-02-01 00:48:29.000000', 'temperatura', 26.0000, 'ºC'),
	(172356, 119, '2014-02-01 00:48:30.000000', 'temperatura', 523.0000, 'ºC'),
	(172357, 119, '2014-02-01 00:48:31.000000', 'temperatura', 139.0000, 'ºC'),
	(172358, 119, '2014-02-01 00:48:32.000000', 'temperatura', 325.0000, 'ºC'),
	(172359, 119, '2014-02-01 00:48:33.000000', 'temperatura', 11.0000, 'ºC'),
	(172360, 119, '2014-02-01 00:48:34.000000', 'temperatura', 278.0000, 'ºC'),
	(172361, 119, '2014-02-01 00:48:35.000000', 'temperatura', 158.0000, 'ºC'),
	(172362, 119, '2014-02-01 00:48:36.000000', 'temperatura', 1155.0000, 'ºC'),
	(172363, 119, '2014-02-01 00:48:37.000000', 'temperatura', 502.0000, 'ºC'),
	(172364, 119, '2014-02-01 00:48:38.000000', 'temperatura', 245.0000, 'ºC'),
	(172365, 119, '2014-02-01 00:48:39.000000', 'temperatura', 921.0000, 'ºC'),
	(172366, 119, '2014-02-01 00:48:40.000000', 'temperatura', 270.0000, 'ºC'),
	(172367, 119, '2014-02-01 00:48:41.000000', 'temperatura', 989.0000, 'ºC'),
	(172368, 119, '2014-02-01 00:48:42.000000', 'temperatura', 535.0000, 'ºC'),
	(172369, 119, '2014-02-01 00:48:43.000000', 'temperatura', 908.0000, 'ºC'),
	(172370, 119, '2014-02-01 00:48:44.000000', 'temperatura', 534.0000, 'ºC'),
	(172371, 119, '2014-02-01 00:48:45.000000', 'temperatura', 1147.0000, 'ºC'),
	(172372, 119, '2014-02-01 00:48:46.000000', 'temperatura', 535.0000, 'ºC'),
	(172373, 119, '2014-02-01 00:48:47.000000', 'temperatura', 432.0000, 'ºC'),
	(172374, 119, '2014-02-01 00:48:48.000000', 'temperatura', 556.0000, 'ºC'),
	(172375, 119, '2014-02-01 00:48:49.000000', 'temperatura', 286.0000, 'ºC'),
	(172376, 119, '2014-02-01 00:48:50.000000', 'temperatura', 961.0000, 'ºC'),
	(172377, 119, '2014-02-01 00:48:51.000000', 'temperatura', 348.0000, 'ºC'),
	(172378, 119, '2014-02-01 00:48:52.000000', 'temperatura', 58.0000, 'ºC'),
	(172379, 119, '2014-02-01 00:48:53.000000', 'temperatura', 447.0000, 'ºC'),
	(172380, 119, '2014-02-01 00:48:54.000000', 'temperatura', 860.0000, 'ºC'),
	(172381, 119, '2014-02-01 00:48:55.000000', 'temperatura', 558.0000, 'ºC'),
	(172382, 119, '2014-02-01 00:48:56.000000', 'temperatura', 213.0000, 'ºC'),
	(172383, 119, '2014-02-01 00:48:57.000000', 'temperatura', 590.0000, 'ºC'),
	(172384, 119, '2014-02-01 00:48:58.000000', 'temperatura', 1113.0000, 'ºC'),
	(172385, 119, '2014-02-01 00:48:59.000000', 'temperatura', 196.0000, 'ºC'),
	(172386, 119, '2014-02-01 00:49:00.000000', 'temperatura', 41.0000, 'ºC'),
	(172387, 119, '2014-02-01 00:49:01.000000', 'temperatura', 817.0000, 'ºC'),
	(172388, 119, '2014-02-01 00:49:02.000000', 'temperatura', 364.0000, 'ºC'),
	(172389, 119, '2014-02-01 00:49:03.000000', 'temperatura', 569.0000, 'ºC'),
	(172390, 119, '2014-02-01 00:49:04.000000', 'temperatura', 552.0000, 'ºC'),
	(172391, 119, '2014-02-01 00:49:05.000000', 'temperatura', 1053.0000, 'ºC'),
	(172392, 119, '2014-02-01 00:49:06.000000', 'temperatura', 11.0000, 'ºC'),
	(172393, 119, '2014-02-01 00:49:07.000000', 'temperatura', 497.0000, 'ºC'),
	(172394, 119, '2014-02-01 00:49:08.000000', 'temperatura', 53.0000, 'ºC'),
	(172395, 119, '2014-02-01 00:49:09.000000', 'temperatura', 1172.0000, 'ºC'),
	(172396, 119, '2014-02-01 00:49:10.000000', 'temperatura', 904.0000, 'ºC'),
	(172397, 119, '2014-02-01 00:49:11.000000', 'temperatura', 1003.0000, 'ºC'),
	(172398, 119, '2014-02-01 00:49:12.000000', 'temperatura', 1106.0000, 'ºC'),
	(172399, 119, '2014-02-01 00:49:13.000000', 'temperatura', 119.0000, 'ºC'),
	(172400, 119, '2014-02-01 00:49:14.000000', 'temperatura', 878.0000, 'ºC'),
	(172401, 119, '2014-02-01 00:49:15.000000', 'temperatura', 432.0000, 'ºC'),
	(172402, 119, '2014-02-01 00:49:16.000000', 'temperatura', 728.0000, 'ºC'),
	(172403, 119, '2014-02-01 00:49:17.000000', 'temperatura', 1144.0000, 'ºC'),
	(172404, 119, '2014-02-01 00:49:18.000000', 'temperatura', 1137.0000, 'ºC'),
	(172405, 119, '2014-02-01 00:49:19.000000', 'temperatura', 1053.0000, 'ºC'),
	(172406, 119, '2014-02-01 00:49:20.000000', 'temperatura', 657.0000, 'ºC'),
	(172407, 119, '2014-02-01 00:49:21.000000', 'temperatura', 124.0000, 'ºC'),
	(172408, 119, '2014-02-01 00:49:22.000000', 'temperatura', 1048.0000, 'ºC'),
	(172409, 119, '2014-02-01 00:49:23.000000', 'temperatura', 72.0000, 'ºC'),
	(172410, 119, '2014-02-01 00:49:24.000000', 'temperatura', 814.0000, 'ºC'),
	(172411, 119, '2014-02-01 00:49:25.000000', 'temperatura', 254.0000, 'ºC'),
	(172412, 119, '2014-02-01 00:49:26.000000', 'temperatura', 28.0000, 'ºC'),
	(172413, 119, '2014-02-01 00:49:27.000000', 'temperatura', 578.0000, 'ºC'),
	(172414, 119, '2014-02-01 00:49:28.000000', 'temperatura', 409.0000, 'ºC'),
	(172415, 119, '2014-02-01 00:49:29.000000', 'temperatura', 309.0000, 'ºC'),
	(172416, 119, '2014-02-01 00:49:30.000000', 'temperatura', 318.0000, 'ºC'),
	(172417, 119, '2014-02-01 00:49:31.000000', 'temperatura', 665.0000, 'ºC'),
	(172418, 119, '2014-02-01 00:49:32.000000', 'temperatura', 1171.0000, 'ºC'),
	(172419, 119, '2014-02-01 00:49:33.000000', 'temperatura', 261.0000, 'ºC'),
	(172420, 119, '2014-02-01 00:49:34.000000', 'temperatura', 193.0000, 'ºC'),
	(172421, 119, '2014-02-01 00:49:35.000000', 'temperatura', 181.0000, 'ºC'),
	(172422, 119, '2014-02-01 00:49:36.000000', 'temperatura', 329.0000, 'ºC'),
	(172423, 119, '2014-02-01 00:49:37.000000', 'temperatura', 1102.0000, 'ºC'),
	(172424, 119, '2014-02-01 00:49:38.000000', 'temperatura', 924.0000, 'ºC'),
	(172425, 119, '2014-02-01 00:49:39.000000', 'temperatura', 112.0000, 'ºC'),
	(172426, 119, '2014-02-01 00:49:40.000000', 'temperatura', 188.0000, 'ºC'),
	(172427, 119, '2014-02-01 00:49:41.000000', 'temperatura', 608.0000, 'ºC'),
	(172428, 119, '2014-02-01 00:49:42.000000', 'temperatura', 73.0000, 'ºC'),
	(172429, 119, '2014-02-01 00:49:43.000000', 'temperatura', 944.0000, 'ºC'),
	(172430, 119, '2014-02-01 00:49:44.000000', 'temperatura', 902.0000, 'ºC'),
	(172431, 119, '2014-02-01 00:49:45.000000', 'temperatura', 479.0000, 'ºC'),
	(172432, 119, '2014-02-01 00:49:46.000000', 'temperatura', 887.0000, 'ºC'),
	(172433, 119, '2014-02-01 00:49:47.000000', 'temperatura', 599.0000, 'ºC'),
	(172434, 119, '2014-02-01 00:49:48.000000', 'temperatura', 333.0000, 'ºC'),
	(172435, 119, '2014-02-01 00:49:49.000000', 'temperatura', 1069.0000, 'ºC'),
	(172436, 119, '2014-02-01 00:49:50.000000', 'temperatura', 747.0000, 'ºC'),
	(172437, 119, '2014-02-01 00:49:51.000000', 'temperatura', 528.0000, 'ºC'),
	(172438, 119, '2014-02-01 00:49:52.000000', 'temperatura', 399.0000, 'ºC'),
	(172439, 119, '2014-02-01 00:49:53.000000', 'temperatura', 414.0000, 'ºC'),
	(172440, 119, '2014-02-01 00:49:54.000000', 'temperatura', 873.0000, 'ºC'),
	(172441, 119, '2014-02-01 00:49:55.000000', 'temperatura', 723.0000, 'ºC'),
	(172442, 119, '2014-02-01 00:49:56.000000', 'temperatura', 997.0000, 'ºC'),
	(172443, 119, '2014-02-01 00:49:57.000000', 'temperatura', 415.0000, 'ºC'),
	(172444, 119, '2014-02-01 00:49:58.000000', 'temperatura', 286.0000, 'ºC'),
	(172445, 119, '2014-02-01 00:49:59.000000', 'temperatura', 186.0000, 'ºC'),
	(172446, 119, '2014-02-01 00:50:00.000000', 'temperatura', 73.0000, 'ºC'),
	(172447, 119, '2014-02-01 00:50:01.000000', 'temperatura', 1007.0000, 'ºC'),
	(172448, 119, '2014-02-01 00:50:02.000000', 'temperatura', 17.0000, 'ºC'),
	(172449, 119, '2014-02-01 00:50:03.000000', 'temperatura', 665.0000, 'ºC'),
	(172450, 119, '2014-02-01 00:50:04.000000', 'temperatura', 875.0000, 'ºC'),
	(172451, 119, '2014-02-01 00:50:05.000000', 'temperatura', 1181.0000, 'ºC'),
	(172452, 119, '2014-02-01 00:50:06.000000', 'temperatura', 880.0000, 'ºC'),
	(172453, 119, '2014-02-01 00:50:07.000000', 'temperatura', 856.0000, 'ºC'),
	(172454, 119, '2014-02-01 00:50:08.000000', 'temperatura', 442.0000, 'ºC'),
	(172455, 119, '2014-02-01 00:50:09.000000', 'temperatura', 844.0000, 'ºC'),
	(172456, 119, '2014-02-01 00:50:10.000000', 'temperatura', 493.0000, 'ºC'),
	(172457, 119, '2014-02-01 00:50:11.000000', 'temperatura', 1134.0000, 'ºC'),
	(172458, 119, '2014-02-01 00:50:12.000000', 'temperatura', 593.0000, 'ºC'),
	(172459, 119, '2014-02-01 00:50:13.000000', 'temperatura', 760.0000, 'ºC'),
	(172460, 119, '2014-02-01 00:50:14.000000', 'temperatura', 825.0000, 'ºC'),
	(172461, 119, '2014-02-01 00:50:15.000000', 'temperatura', 643.0000, 'ºC'),
	(172462, 119, '2014-02-01 00:50:16.000000', 'temperatura', 739.0000, 'ºC'),
	(172463, 119, '2014-02-01 00:50:17.000000', 'temperatura', 569.0000, 'ºC'),
	(172464, 119, '2014-02-01 00:50:18.000000', 'temperatura', 627.0000, 'ºC'),
	(172465, 119, '2014-02-01 00:50:19.000000', 'temperatura', 229.0000, 'ºC'),
	(172466, 119, '2014-02-01 00:50:20.000000', 'temperatura', 466.0000, 'ºC'),
	(172467, 119, '2014-02-01 00:50:21.000000', 'temperatura', 443.0000, 'ºC'),
	(172468, 119, '2014-02-01 00:50:22.000000', 'temperatura', 815.0000, 'ºC'),
	(172469, 119, '2014-02-01 00:50:23.000000', 'temperatura', 348.0000, 'ºC'),
	(172470, 119, '2014-02-01 00:50:24.000000', 'temperatura', 498.0000, 'ºC'),
	(172471, 119, '2014-02-01 00:50:25.000000', 'temperatura', 243.0000, 'ºC'),
	(172472, 119, '2014-02-01 00:50:26.000000', 'temperatura', 922.0000, 'ºC'),
	(172473, 119, '2014-02-01 00:50:27.000000', 'temperatura', 282.0000, 'ºC'),
	(172474, 119, '2014-02-01 00:50:28.000000', 'temperatura', 1046.0000, 'ºC'),
	(172475, 119, '2014-02-01 00:50:29.000000', 'temperatura', 783.0000, 'ºC'),
	(172476, 119, '2014-02-01 00:50:30.000000', 'temperatura', 776.0000, 'ºC'),
	(172477, 119, '2014-02-01 00:50:31.000000', 'temperatura', 334.0000, 'ºC'),
	(172478, 119, '2014-02-01 00:50:32.000000', 'temperatura', 543.0000, 'ºC'),
	(172479, 119, '2014-02-01 00:50:33.000000', 'temperatura', 514.0000, 'ºC'),
	(172480, 119, '2014-02-01 00:50:34.000000', 'temperatura', 939.0000, 'ºC'),
	(172481, 119, '2014-02-01 00:50:35.000000', 'temperatura', 754.0000, 'ºC'),
	(172482, 119, '2014-02-01 00:50:36.000000', 'temperatura', 955.0000, 'ºC'),
	(172483, 119, '2014-02-01 00:50:37.000000', 'temperatura', 111.0000, 'ºC'),
	(172484, 119, '2014-02-01 00:50:38.000000', 'temperatura', 91.0000, 'ºC'),
	(172485, 119, '2014-02-01 00:50:39.000000', 'temperatura', 122.0000, 'ºC'),
	(172486, 119, '2014-02-01 00:50:40.000000', 'temperatura', 339.0000, 'ºC'),
	(172487, 119, '2014-02-01 00:50:41.000000', 'temperatura', 130.0000, 'ºC'),
	(172488, 119, '2014-02-01 00:50:42.000000', 'temperatura', 834.0000, 'ºC'),
	(172489, 119, '2014-02-01 00:50:43.000000', 'temperatura', 179.0000, 'ºC'),
	(172490, 119, '2014-02-01 00:50:44.000000', 'temperatura', 792.0000, 'ºC'),
	(172491, 119, '2014-02-01 00:50:45.000000', 'temperatura', 1026.0000, 'ºC'),
	(172492, 119, '2014-02-01 00:50:46.000000', 'temperatura', 352.0000, 'ºC'),
	(172493, 119, '2014-02-01 00:50:47.000000', 'temperatura', 1082.0000, 'ºC'),
	(172494, 119, '2014-02-01 00:50:48.000000', 'temperatura', 755.0000, 'ºC'),
	(172495, 119, '2014-02-01 00:50:49.000000', 'temperatura', 531.0000, 'ºC'),
	(172496, 119, '2014-02-01 00:50:50.000000', 'temperatura', 388.0000, 'ºC'),
	(172497, 119, '2014-02-01 00:50:51.000000', 'temperatura', 349.0000, 'ºC'),
	(172498, 119, '2014-02-01 00:50:52.000000', 'temperatura', 580.0000, 'ºC'),
	(172499, 119, '2014-02-01 00:50:53.000000', 'temperatura', 654.0000, 'ºC'),
	(172500, 119, '2014-02-01 00:50:54.000000', 'temperatura', 330.0000, 'ºC'),
	(172501, 119, '2014-02-01 00:50:55.000000', 'temperatura', 888.0000, 'ºC'),
	(172502, 119, '2014-02-01 00:50:56.000000', 'temperatura', 1049.0000, 'ºC'),
	(172503, 119, '2014-02-01 00:50:57.000000', 'temperatura', 184.0000, 'ºC'),
	(172504, 119, '2014-02-01 00:50:58.000000', 'temperatura', 171.0000, 'ºC'),
	(172505, 119, '2014-02-01 00:50:59.000000', 'temperatura', 305.0000, 'ºC'),
	(172506, 119, '2014-02-01 00:51:00.000000', 'temperatura', 1011.0000, 'ºC'),
	(172507, 119, '2014-02-01 00:51:01.000000', 'temperatura', 543.0000, 'ºC'),
	(172508, 119, '2014-02-01 00:51:02.000000', 'temperatura', 880.0000, 'ºC'),
	(172509, 119, '2014-02-01 00:51:03.000000', 'temperatura', 374.0000, 'ºC'),
	(172510, 119, '2014-02-01 00:51:04.000000', 'temperatura', 429.0000, 'ºC'),
	(172511, 119, '2014-02-01 00:51:05.000000', 'temperatura', 1024.0000, 'ºC'),
	(172512, 119, '2014-02-01 00:51:06.000000', 'temperatura', 233.0000, 'ºC'),
	(172513, 119, '2014-02-01 00:51:07.000000', 'temperatura', 492.0000, 'ºC'),
	(172514, 119, '2014-02-01 00:51:08.000000', 'temperatura', 562.0000, 'ºC'),
	(172515, 119, '2014-02-01 00:51:09.000000', 'temperatura', 137.0000, 'ºC'),
	(172516, 119, '2014-02-01 00:51:10.000000', 'temperatura', 197.0000, 'ºC'),
	(172517, 119, '2014-02-01 00:51:11.000000', 'temperatura', 574.0000, 'ºC'),
	(172518, 119, '2014-02-01 00:51:12.000000', 'temperatura', 1081.0000, 'ºC'),
	(172519, 119, '2014-02-01 00:51:13.000000', 'temperatura', 82.0000, 'ºC'),
	(172520, 119, '2014-02-01 00:51:14.000000', 'temperatura', 770.0000, 'ºC'),
	(172521, 119, '2014-02-01 00:51:15.000000', 'temperatura', 3.0000, 'ºC'),
	(172522, 119, '2014-02-01 00:51:16.000000', 'temperatura', 107.0000, 'ºC'),
	(172523, 119, '2014-02-01 00:51:17.000000', 'temperatura', 527.0000, 'ºC'),
	(172524, 119, '2014-02-01 00:51:18.000000', 'temperatura', 1115.0000, 'ºC'),
	(172525, 119, '2014-02-01 00:51:19.000000', 'temperatura', 392.0000, 'ºC'),
	(172526, 119, '2014-02-01 00:51:20.000000', 'temperatura', 1015.0000, 'ºC'),
	(172527, 119, '2014-02-01 00:51:21.000000', 'temperatura', 302.0000, 'ºC'),
	(172528, 119, '2014-02-01 00:51:22.000000', 'temperatura', 867.0000, 'ºC'),
	(172529, 119, '2014-02-01 00:51:23.000000', 'temperatura', 1026.0000, 'ºC'),
	(172530, 119, '2014-02-01 00:51:24.000000', 'temperatura', 131.0000, 'ºC'),
	(172531, 119, '2014-02-01 00:51:25.000000', 'temperatura', 1176.0000, 'ºC'),
	(172532, 119, '2014-02-01 00:51:26.000000', 'temperatura', 690.0000, 'ºC'),
	(172533, 119, '2014-02-01 00:51:27.000000', 'temperatura', 1121.0000, 'ºC'),
	(172534, 119, '2014-02-01 00:51:28.000000', 'temperatura', 1136.0000, 'ºC'),
	(172535, 119, '2014-02-01 00:51:29.000000', 'temperatura', 1116.0000, 'ºC'),
	(172536, 119, '2014-02-01 00:51:30.000000', 'temperatura', 974.0000, 'ºC'),
	(172537, 119, '2014-02-01 00:51:31.000000', 'temperatura', 323.0000, 'ºC'),
	(172538, 119, '2014-02-01 00:51:32.000000', 'temperatura', 1093.0000, 'ºC'),
	(172539, 119, '2014-02-01 00:51:33.000000', 'temperatura', 895.0000, 'ºC'),
	(172540, 119, '2014-02-01 00:51:34.000000', 'temperatura', 1197.0000, 'ºC'),
	(172541, 119, '2014-02-01 00:51:35.000000', 'temperatura', 899.0000, 'ºC'),
	(172542, 119, '2014-02-01 00:51:36.000000', 'temperatura', 906.0000, 'ºC'),
	(172543, 119, '2014-02-01 00:51:37.000000', 'temperatura', 635.0000, 'ºC'),
	(172544, 119, '2014-02-01 00:51:38.000000', 'temperatura', 455.0000, 'ºC'),
	(172545, 119, '2014-02-01 00:51:39.000000', 'temperatura', 372.0000, 'ºC'),
	(172546, 119, '2014-02-01 00:51:40.000000', 'temperatura', 495.0000, 'ºC'),
	(172547, 119, '2014-02-01 00:51:41.000000', 'temperatura', 162.0000, 'ºC'),
	(172548, 119, '2014-02-01 00:51:42.000000', 'temperatura', 523.0000, 'ºC'),
	(172549, 119, '2014-02-01 00:51:43.000000', 'temperatura', 928.0000, 'ºC'),
	(172550, 119, '2014-02-01 00:51:44.000000', 'temperatura', 673.0000, 'ºC'),
	(172551, 119, '2014-02-01 00:51:45.000000', 'temperatura', 580.0000, 'ºC'),
	(172552, 119, '2014-02-01 00:51:46.000000', 'temperatura', 885.0000, 'ºC'),
	(172553, 119, '2014-02-01 00:51:47.000000', 'temperatura', 282.0000, 'ºC'),
	(172554, 119, '2014-02-01 00:51:48.000000', 'temperatura', 1156.0000, 'ºC'),
	(172555, 119, '2014-02-01 00:51:49.000000', 'temperatura', 137.0000, 'ºC'),
	(172556, 119, '2014-02-01 00:51:50.000000', 'temperatura', 816.0000, 'ºC'),
	(172557, 119, '2014-02-01 00:51:51.000000', 'temperatura', 70.0000, 'ºC'),
	(172558, 119, '2014-02-01 00:51:52.000000', 'temperatura', 304.0000, 'ºC'),
	(172559, 119, '2014-02-01 00:51:53.000000', 'temperatura', 110.0000, 'ºC'),
	(172560, 119, '2014-02-01 00:51:54.000000', 'temperatura', 839.0000, 'ºC'),
	(172561, 119, '2014-02-01 00:51:55.000000', 'temperatura', 266.0000, 'ºC'),
	(172562, 119, '2014-02-01 00:51:56.000000', 'temperatura', 14.0000, 'ºC'),
	(172563, 119, '2014-02-01 00:51:57.000000', 'temperatura', 472.0000, 'ºC'),
	(172564, 119, '2014-02-01 00:51:58.000000', 'temperatura', 1119.0000, 'ºC'),
	(172565, 119, '2014-02-01 00:51:59.000000', 'temperatura', 580.0000, 'ºC'),
	(172566, 119, '2014-02-01 00:52:00.000000', 'temperatura', 741.0000, 'ºC'),
	(172567, 119, '2014-02-01 00:52:01.000000', 'temperatura', 766.0000, 'ºC'),
	(172568, 119, '2014-02-01 00:52:02.000000', 'temperatura', 406.0000, 'ºC'),
	(172569, 119, '2014-02-01 00:52:03.000000', 'temperatura', 934.0000, 'ºC'),
	(172570, 119, '2014-02-01 00:52:04.000000', 'temperatura', 1051.0000, 'ºC'),
	(172571, 119, '2014-02-01 00:52:05.000000', 'temperatura', 53.0000, 'ºC'),
	(172572, 119, '2014-02-01 00:52:06.000000', 'temperatura', 712.0000, 'ºC'),
	(172573, 119, '2014-02-01 00:52:07.000000', 'temperatura', 1002.0000, 'ºC'),
	(172574, 119, '2014-02-01 00:52:08.000000', 'temperatura', 476.0000, 'ºC'),
	(172575, 119, '2014-02-01 00:52:09.000000', 'temperatura', 573.0000, 'ºC'),
	(172576, 119, '2014-02-01 00:52:10.000000', 'temperatura', 237.0000, 'ºC'),
	(172577, 119, '2014-02-01 00:52:11.000000', 'temperatura', 668.0000, 'ºC'),
	(172578, 119, '2014-02-01 00:52:12.000000', 'temperatura', 229.0000, 'ºC'),
	(172579, 119, '2014-02-01 00:52:13.000000', 'temperatura', 343.0000, 'ºC'),
	(172580, 119, '2014-02-01 00:52:14.000000', 'temperatura', 1027.0000, 'ºC'),
	(172581, 119, '2014-02-01 00:52:15.000000', 'temperatura', 509.0000, 'ºC'),
	(172582, 119, '2014-02-01 00:52:16.000000', 'temperatura', 663.0000, 'ºC'),
	(172583, 119, '2014-02-01 00:52:17.000000', 'temperatura', 587.0000, 'ºC'),
	(172584, 119, '2014-02-01 00:52:18.000000', 'temperatura', 947.0000, 'ºC'),
	(172585, 119, '2014-02-01 00:52:19.000000', 'temperatura', 575.0000, 'ºC'),
	(172586, 119, '2014-02-01 00:52:20.000000', 'temperatura', 33.0000, 'ºC'),
	(172587, 119, '2014-02-01 00:52:21.000000', 'temperatura', 843.0000, 'ºC'),
	(172588, 119, '2014-02-01 00:52:22.000000', 'temperatura', 514.0000, 'ºC'),
	(172589, 119, '2014-02-01 00:52:23.000000', 'temperatura', 41.0000, 'ºC'),
	(172590, 119, '2014-02-01 00:52:24.000000', 'temperatura', 1065.0000, 'ºC'),
	(172591, 119, '2014-02-01 00:52:25.000000', 'temperatura', 401.0000, 'ºC'),
	(172592, 119, '2014-02-01 00:52:26.000000', 'temperatura', 11.0000, 'ºC'),
	(172593, 119, '2014-02-01 00:52:27.000000', 'temperatura', 53.0000, 'ºC'),
	(172594, 119, '2014-02-01 00:52:28.000000', 'temperatura', 234.0000, 'ºC'),
	(172595, 119, '2014-02-01 00:52:29.000000', 'temperatura', 1009.0000, 'ºC'),
	(172596, 119, '2014-02-01 00:52:30.000000', 'temperatura', 743.0000, 'ºC'),
	(172597, 119, '2014-02-01 00:52:31.000000', 'temperatura', 691.0000, 'ºC'),
	(172598, 119, '2014-02-01 00:52:32.000000', 'temperatura', 27.0000, 'ºC'),
	(172599, 119, '2014-02-01 00:52:33.000000', 'temperatura', 462.0000, 'ºC'),
	(172600, 119, '2014-02-01 00:52:34.000000', 'temperatura', 1029.0000, 'ºC'),
	(172601, 119, '2014-02-01 00:52:35.000000', 'temperatura', 160.0000, 'ºC'),
	(172602, 119, '2014-02-01 00:52:36.000000', 'temperatura', 115.0000, 'ºC'),
	(172603, 119, '2014-02-01 00:52:37.000000', 'temperatura', 92.0000, 'ºC'),
	(172604, 119, '2014-02-01 00:52:38.000000', 'temperatura', 119.0000, 'ºC'),
	(172605, 119, '2014-02-01 00:52:39.000000', 'temperatura', 318.0000, 'ºC'),
	(172606, 119, '2014-02-01 00:52:40.000000', 'temperatura', 33.0000, 'ºC'),
	(172607, 119, '2014-02-01 00:52:41.000000', 'temperatura', 412.0000, 'ºC'),
	(172608, 119, '2014-02-01 00:52:42.000000', 'temperatura', 761.0000, 'ºC'),
	(172609, 119, '2014-02-01 00:52:43.000000', 'temperatura', 168.0000, 'ºC'),
	(172610, 119, '2014-02-01 00:52:44.000000', 'temperatura', 960.0000, 'ºC'),
	(172611, 119, '2014-02-01 00:52:45.000000', 'temperatura', 695.0000, 'ºC'),
	(172612, 119, '2014-02-01 00:52:46.000000', 'temperatura', 594.0000, 'ºC'),
	(172613, 119, '2014-02-01 00:52:47.000000', 'temperatura', 888.0000, 'ºC'),
	(172614, 119, '2014-02-01 00:52:48.000000', 'temperatura', 259.0000, 'ºC'),
	(172615, 119, '2014-02-01 00:52:49.000000', 'temperatura', 1029.0000, 'ºC'),
	(172616, 119, '2014-02-01 00:52:50.000000', 'temperatura', 769.0000, 'ºC'),
	(172617, 119, '2014-02-01 00:52:51.000000', 'temperatura', 758.0000, 'ºC'),
	(172618, 119, '2014-02-01 00:52:52.000000', 'temperatura', 286.0000, 'ºC'),
	(172619, 119, '2014-02-01 00:52:53.000000', 'temperatura', 356.0000, 'ºC'),
	(172620, 119, '2014-02-01 00:52:54.000000', 'temperatura', 921.0000, 'ºC'),
	(172621, 119, '2014-02-01 00:52:55.000000', 'temperatura', 1139.0000, 'ºC'),
	(172622, 119, '2014-02-01 00:52:56.000000', 'temperatura', 532.0000, 'ºC'),
	(172623, 119, '2014-02-01 00:52:57.000000', 'temperatura', 444.0000, 'ºC'),
	(172624, 119, '2014-02-01 00:52:58.000000', 'temperatura', 622.0000, 'ºC'),
	(172625, 119, '2014-02-01 00:52:59.000000', 'temperatura', 581.0000, 'ºC'),
	(172626, 119, '2014-02-01 00:53:00.000000', 'temperatura', 1037.0000, 'ºC'),
	(172627, 119, '2014-02-01 00:53:01.000000', 'temperatura', 1044.0000, 'ºC'),
	(172628, 119, '2014-02-01 00:53:02.000000', 'temperatura', 911.0000, 'ºC'),
	(172629, 119, '2014-02-01 00:53:03.000000', 'temperatura', 221.0000, 'ºC'),
	(172630, 119, '2014-02-01 00:53:04.000000', 'temperatura', 775.0000, 'ºC'),
	(172631, 119, '2014-02-01 00:53:05.000000', 'temperatura', 811.0000, 'ºC'),
	(172632, 119, '2014-02-01 00:53:06.000000', 'temperatura', 532.0000, 'ºC'),
	(172633, 119, '2014-02-01 00:53:07.000000', 'temperatura', 228.0000, 'ºC'),
	(172634, 119, '2014-02-01 00:53:08.000000', 'temperatura', 744.0000, 'ºC'),
	(172635, 119, '2014-02-01 00:53:09.000000', 'temperatura', 636.0000, 'ºC'),
	(172636, 119, '2014-02-01 00:53:10.000000', 'temperatura', 950.0000, 'ºC'),
	(172637, 119, '2014-02-01 00:53:11.000000', 'temperatura', 441.0000, 'ºC'),
	(172638, 119, '2014-02-01 00:53:12.000000', 'temperatura', 557.0000, 'ºC'),
	(172639, 119, '2014-02-01 00:53:13.000000', 'temperatura', 263.0000, 'ºC'),
	(172640, 119, '2014-02-01 00:53:14.000000', 'temperatura', 843.0000, 'ºC'),
	(172641, 119, '2014-02-01 00:53:15.000000', 'temperatura', 1026.0000, 'ºC'),
	(172642, 119, '2014-02-01 00:53:16.000000', 'temperatura', 203.0000, 'ºC'),
	(172643, 119, '2014-02-01 00:53:17.000000', 'temperatura', 339.0000, 'ºC'),
	(172644, 119, '2014-02-01 00:53:18.000000', 'temperatura', 1083.0000, 'ºC'),
	(172645, 119, '2014-02-01 00:53:19.000000', 'temperatura', 800.0000, 'ºC'),
	(172646, 119, '2014-02-01 00:53:20.000000', 'temperatura', 754.0000, 'ºC'),
	(172647, 119, '2014-02-01 00:53:21.000000', 'temperatura', 167.0000, 'ºC'),
	(172648, 119, '2014-02-01 00:53:22.000000', 'temperatura', 974.0000, 'ºC'),
	(172649, 119, '2014-02-01 00:53:23.000000', 'temperatura', 769.0000, 'ºC'),
	(172650, 119, '2014-02-01 00:53:24.000000', 'temperatura', 926.0000, 'ºC'),
	(172651, 119, '2014-02-01 00:53:25.000000', 'temperatura', 1121.0000, 'ºC'),
	(172652, 119, '2014-02-01 00:53:26.000000', 'temperatura', 429.0000, 'ºC'),
	(172653, 119, '2014-02-01 00:53:27.000000', 'temperatura', 1181.0000, 'ºC'),
	(172654, 119, '2014-02-01 00:53:28.000000', 'temperatura', 1018.0000, 'ºC'),
	(172655, 119, '2014-02-01 00:53:29.000000', 'temperatura', 350.0000, 'ºC'),
	(172656, 119, '2014-02-01 00:53:30.000000', 'temperatura', 1095.0000, 'ºC'),
	(172657, 119, '2014-02-01 00:53:31.000000', 'temperatura', 828.0000, 'ºC'),
	(172658, 119, '2014-02-01 00:53:32.000000', 'temperatura', 853.0000, 'ºC'),
	(172659, 119, '2014-02-01 00:53:33.000000', 'temperatura', 580.0000, 'ºC'),
	(172660, 119, '2014-02-01 00:53:34.000000', 'temperatura', 345.0000, 'ºC'),
	(172661, 119, '2014-02-01 00:53:35.000000', 'temperatura', 1183.0000, 'ºC'),
	(172662, 119, '2014-02-01 00:53:36.000000', 'temperatura', 83.0000, 'ºC'),
	(172663, 119, '2014-02-01 00:53:37.000000', 'temperatura', 466.0000, 'ºC'),
	(172664, 119, '2014-02-01 00:53:38.000000', 'temperatura', 880.0000, 'ºC'),
	(172665, 119, '2014-02-01 00:53:39.000000', 'temperatura', 602.0000, 'ºC'),
	(172666, 119, '2014-02-01 00:53:40.000000', 'temperatura', 369.0000, 'ºC'),
	(172667, 119, '2014-02-01 00:53:41.000000', 'temperatura', 43.0000, 'ºC'),
	(172668, 119, '2014-02-01 00:53:42.000000', 'temperatura', 306.0000, 'ºC'),
	(172669, 119, '2014-02-01 00:53:43.000000', 'temperatura', 203.0000, 'ºC'),
	(172670, 119, '2014-02-01 00:53:44.000000', 'temperatura', 97.0000, 'ºC'),
	(172671, 119, '2014-02-01 00:53:45.000000', 'temperatura', 1075.0000, 'ºC'),
	(172672, 119, '2014-02-01 00:53:46.000000', 'temperatura', 284.0000, 'ºC'),
	(172673, 119, '2014-02-01 00:53:47.000000', 'temperatura', 596.0000, 'ºC'),
	(172674, 119, '2014-02-01 00:53:48.000000', 'temperatura', 927.0000, 'ºC'),
	(172675, 119, '2014-02-01 00:53:49.000000', 'temperatura', 450.0000, 'ºC'),
	(172676, 119, '2014-02-01 00:53:50.000000', 'temperatura', 670.0000, 'ºC'),
	(172677, 119, '2014-02-01 00:53:51.000000', 'temperatura', 799.0000, 'ºC'),
	(172678, 119, '2014-02-01 00:53:52.000000', 'temperatura', 787.0000, 'ºC'),
	(172679, 119, '2014-02-01 00:53:53.000000', 'temperatura', 339.0000, 'ºC'),
	(172680, 119, '2014-02-01 00:53:54.000000', 'temperatura', 534.0000, 'ºC'),
	(172681, 119, '2014-02-01 00:53:55.000000', 'temperatura', 455.0000, 'ºC'),
	(172682, 119, '2014-02-01 00:53:56.000000', 'temperatura', 673.0000, 'ºC'),
	(172683, 119, '2014-02-01 00:53:57.000000', 'temperatura', 798.0000, 'ºC'),
	(172684, 119, '2014-02-01 00:53:58.000000', 'temperatura', 772.0000, 'ºC'),
	(172685, 119, '2014-02-01 00:53:59.000000', 'temperatura', 268.0000, 'ºC'),
	(172686, 119, '2014-02-01 00:54:00.000000', 'temperatura', 225.0000, 'ºC'),
	(172687, 119, '2014-02-01 00:54:01.000000', 'temperatura', 319.0000, 'ºC'),
	(172688, 119, '2014-02-01 00:54:02.000000', 'temperatura', 923.0000, 'ºC'),
	(172689, 119, '2014-02-01 00:54:03.000000', 'temperatura', 56.0000, 'ºC'),
	(172690, 119, '2014-02-01 00:54:04.000000', 'temperatura', 1111.0000, 'ºC'),
	(172691, 119, '2014-02-01 00:54:05.000000', 'temperatura', 588.0000, 'ºC'),
	(172692, 119, '2014-02-01 00:54:06.000000', 'temperatura', 810.0000, 'ºC'),
	(172693, 119, '2014-02-01 00:54:07.000000', 'temperatura', 1084.0000, 'ºC'),
	(172694, 119, '2014-02-01 00:54:08.000000', 'temperatura', 592.0000, 'ºC'),
	(172695, 119, '2014-02-01 00:54:09.000000', 'temperatura', 907.0000, 'ºC'),
	(172696, 119, '2014-02-01 00:54:10.000000', 'temperatura', 361.0000, 'ºC'),
	(172697, 119, '2014-02-01 00:54:11.000000', 'temperatura', 285.0000, 'ºC'),
	(172698, 119, '2014-02-01 00:54:12.000000', 'temperatura', 343.0000, 'ºC'),
	(172699, 119, '2014-02-01 00:54:13.000000', 'temperatura', 860.0000, 'ºC'),
	(172700, 119, '2014-02-01 00:54:14.000000', 'temperatura', 869.0000, 'ºC'),
	(172701, 119, '2014-02-01 00:54:15.000000', 'temperatura', 568.0000, 'ºC'),
	(172702, 119, '2014-02-01 00:54:16.000000', 'temperatura', 231.0000, 'ºC'),
	(172703, 119, '2014-02-01 00:54:17.000000', 'temperatura', 655.0000, 'ºC'),
	(172704, 119, '2014-02-01 00:54:18.000000', 'temperatura', 179.0000, 'ºC'),
	(172705, 119, '2014-02-01 00:54:19.000000', 'temperatura', 132.0000, 'ºC'),
	(172706, 119, '2014-02-01 00:54:20.000000', 'temperatura', 122.0000, 'ºC'),
	(172707, 119, '2014-02-01 00:54:21.000000', 'temperatura', 217.0000, 'ºC'),
	(172708, 119, '2014-02-01 00:54:22.000000', 'temperatura', 717.0000, 'ºC'),
	(172709, 119, '2014-02-01 00:54:23.000000', 'temperatura', 535.0000, 'ºC'),
	(172710, 119, '2014-02-01 00:54:24.000000', 'temperatura', 526.0000, 'ºC'),
	(172711, 119, '2014-02-01 00:54:25.000000', 'temperatura', 1024.0000, 'ºC'),
	(172712, 119, '2014-02-01 00:54:26.000000', 'temperatura', 1143.0000, 'ºC'),
	(172713, 119, '2014-02-01 00:54:27.000000', 'temperatura', 242.0000, 'ºC'),
	(172714, 119, '2014-02-01 00:54:28.000000', 'temperatura', 182.0000, 'ºC'),
	(172715, 119, '2014-02-01 00:54:29.000000', 'temperatura', 186.0000, 'ºC'),
	(172716, 119, '2014-02-01 00:54:30.000000', 'temperatura', 382.0000, 'ºC'),
	(172717, 119, '2014-02-01 00:54:31.000000', 'temperatura', 153.0000, 'ºC'),
	(172718, 119, '2014-02-01 00:54:32.000000', 'temperatura', 818.0000, 'ºC'),
	(172719, 119, '2014-02-01 00:54:33.000000', 'temperatura', 34.0000, 'ºC'),
	(172720, 119, '2014-02-01 00:54:34.000000', 'temperatura', 117.0000, 'ºC'),
	(172721, 119, '2014-02-01 00:54:35.000000', 'temperatura', 481.0000, 'ºC'),
	(172722, 119, '2014-02-01 00:54:36.000000', 'temperatura', 857.0000, 'ºC'),
	(172723, 119, '2014-02-01 00:54:37.000000', 'temperatura', 443.0000, 'ºC'),
	(172724, 119, '2014-02-01 00:54:38.000000', 'temperatura', 842.0000, 'ºC'),
	(172725, 119, '2014-02-01 00:54:39.000000', 'temperatura', 481.0000, 'ºC'),
	(172726, 119, '2014-02-01 00:54:40.000000', 'temperatura', 1080.0000, 'ºC'),
	(172727, 119, '2014-02-01 00:54:41.000000', 'temperatura', 360.0000, 'ºC'),
	(172728, 119, '2014-02-01 00:54:42.000000', 'temperatura', 959.0000, 'ºC'),
	(172729, 119, '2014-02-01 00:54:43.000000', 'temperatura', 114.0000, 'ºC'),
	(172730, 119, '2014-02-01 00:54:44.000000', 'temperatura', 94.0000, 'ºC'),
	(172731, 119, '2014-02-01 00:54:45.000000', 'temperatura', 129.0000, 'ºC'),
	(172732, 119, '2014-02-01 00:54:46.000000', 'temperatura', 365.0000, 'ºC'),
	(172733, 119, '2014-02-01 00:54:47.000000', 'temperatura', 238.0000, 'ºC'),
	(172734, 119, '2014-02-01 00:54:48.000000', 'temperatura', 97.0000, 'ºC'),
	(172735, 119, '2014-02-01 00:54:49.000000', 'temperatura', 971.0000, 'ºC'),
	(172736, 119, '2014-02-01 00:54:50.000000', 'temperatura', 963.0000, 'ºC'),
	(172737, 119, '2014-02-01 00:54:51.000000', 'temperatura', 705.0000, 'ºC'),
	(172738, 119, '2014-02-01 00:54:52.000000', 'temperatura', 633.0000, 'ºC'),
	(172739, 119, '2014-02-01 00:54:53.000000', 'temperatura', 1054.0000, 'ºC'),
	(172740, 119, '2014-02-01 00:54:54.000000', 'temperatura', 970.0000, 'ºC'),
	(172741, 119, '2014-02-01 00:54:55.000000', 'temperatura', 490.0000, 'ºC'),
	(172742, 119, '2014-02-01 00:54:56.000000', 'temperatura', 742.0000, 'ºC'),
	(172743, 119, '2014-02-01 00:54:57.000000', 'temperatura', 1037.0000, 'ºC'),
	(172744, 119, '2014-02-01 00:54:58.000000', 'temperatura', 561.0000, 'ºC'),
	(172745, 119, '2014-02-01 00:54:59.000000', 'temperatura', 894.0000, 'ºC'),
	(172746, 119, '2014-02-01 00:55:00.000000', 'temperatura', 387.0000, 'ºC'),
	(172747, 119, '2014-02-01 00:55:01.000000', 'temperatura', 455.0000, 'ºC'),
	(172748, 119, '2014-02-01 00:55:02.000000', 'temperatura', 1114.0000, 'ºC'),
	(172749, 119, '2014-02-01 00:55:03.000000', 'temperatura', 604.0000, 'ºC'),
	(172750, 119, '2014-02-01 00:55:04.000000', 'temperatura', 878.0000, 'ºC'),
	(172751, 119, '2014-02-01 00:55:05.000000', 'temperatura', 178.0000, 'ºC'),
	(172752, 119, '2014-02-01 00:55:06.000000', 'temperatura', 659.0000, 'ºC'),
	(172753, 119, '2014-02-01 00:55:07.000000', 'temperatura', 360.0000, 'ºC'),
	(172754, 119, '2014-02-01 00:55:08.000000', 'temperatura', 1025.0000, 'ºC'),
	(172755, 119, '2014-02-01 00:55:09.000000', 'temperatura', 444.0000, 'ºC'),
	(172756, 119, '2014-02-01 00:55:10.000000', 'temperatura', 345.0000, 'ºC'),
	(172757, 119, '2014-02-01 00:55:11.000000', 'temperatura', 392.0000, 'ºC'),
	(172758, 119, '2014-02-01 00:55:12.000000', 'temperatura', 929.0000, 'ºC'),
	(172759, 119, '2014-02-01 00:55:13.000000', 'temperatura', 1069.0000, 'ºC'),
	(172760, 119, '2014-02-01 00:55:14.000000', 'temperatura', 157.0000, 'ºC'),
	(172761, 119, '2014-02-01 00:55:15.000000', 'temperatura', 1178.0000, 'ºC'),
	(172762, 119, '2014-02-01 00:55:16.000000', 'temperatura', 620.0000, 'ºC'),
	(172763, 119, '2014-02-01 00:55:17.000000', 'temperatura', 768.0000, 'ºC'),
	(172764, 119, '2014-02-01 00:55:18.000000', 'temperatura', 781.0000, 'ºC'),
	(172765, 119, '2014-02-01 00:55:19.000000', 'temperatura', 401.0000, 'ºC'),
	(172766, 119, '2014-02-01 00:55:20.000000', 'temperatura', 861.0000, 'ºC'),
	(172767, 119, '2014-02-01 00:55:21.000000', 'temperatura', 702.0000, 'ºC'),
	(172768, 119, '2014-02-01 00:55:22.000000', 'temperatura', 926.0000, 'ºC'),
	(172769, 119, '2014-02-01 00:55:23.000000', 'temperatura', 128.0000, 'ºC'),
	(172770, 119, '2014-02-01 00:55:24.000000', 'temperatura', 261.0000, 'ºC'),
	(172771, 119, '2014-02-01 00:55:25.000000', 'temperatura', 922.0000, 'ºC'),
	(172772, 119, '2014-02-01 00:55:26.000000', 'temperatura', 228.0000, 'ºC'),
	(172773, 119, '2014-02-01 00:55:27.000000', 'temperatura', 774.0000, 'ºC'),
	(172774, 119, '2014-02-01 00:55:28.000000', 'temperatura', 785.0000, 'ºC'),
	(172775, 119, '2014-02-01 00:55:29.000000', 'temperatura', 403.0000, 'ºC'),
	(172776, 119, '2014-02-01 00:55:30.000000', 'temperatura', 864.0000, 'ºC'),
	(172777, 119, '2014-02-01 00:55:31.000000', 'temperatura', 708.0000, 'ºC'),
	(172778, 119, '2014-02-01 00:55:32.000000', 'temperatura', 950.0000, 'ºC'),
	(172779, 119, '2014-02-01 00:55:33.000000', 'temperatura', 225.0000, 'ºC'),
	(172780, 119, '2014-02-01 00:55:34.000000', 'temperatura', 678.0000, 'ºC'),
	(172781, 119, '2014-02-01 00:55:35.000000', 'temperatura', 313.0000, 'ºC'),
	(172782, 119, '2014-02-01 00:55:36.000000', 'temperatura', 730.0000, 'ºC'),
	(172783, 119, '2014-02-01 00:55:37.000000', 'temperatura', 315.0000, 'ºC'),
	(172784, 119, '2014-02-01 00:55:38.000000', 'temperatura', 585.0000, 'ºC'),
	(172785, 119, '2014-02-01 00:55:39.000000', 'temperatura', 780.0000, 'ºC'),
	(172786, 119, '2014-02-01 00:55:40.000000', 'temperatura', 945.0000, 'ºC'),
	(172787, 119, '2014-02-01 00:55:41.000000', 'temperatura', 1187.0000, 'ºC'),
	(172788, 119, '2014-02-01 00:55:42.000000', 'temperatura', 700.0000, 'ºC'),
	(172789, 119, '2014-02-01 00:55:43.000000', 'temperatura', 1139.0000, 'ºC'),
	(172790, 119, '2014-02-01 00:55:44.000000', 'temperatura', 1195.0000, 'ºC'),
	(172791, 119, '2014-02-01 00:55:45.000000', 'temperatura', 158.0000, 'ºC'),
	(172792, 119, '2014-02-01 00:55:46.000000', 'temperatura', 806.0000, 'ºC'),
	(172793, 119, '2014-02-01 00:55:47.000000', 'temperatura', 1156.0000, 'ºC'),
	(172794, 119, '2014-02-01 00:55:48.000000', 'temperatura', 965.0000, 'ºC'),
	(172795, 119, '2014-02-01 00:55:49.000000', 'temperatura', 156.0000, 'ºC'),
	(172796, 119, '2014-02-01 00:55:50.000000', 'temperatura', 287.0000, 'ºC'),
	(172797, 119, '2014-02-01 00:55:51.000000', 'temperatura', 967.0000, 'ºC'),
	(172798, 119, '2014-02-01 00:55:52.000000', 'temperatura', 372.0000, 'ºC'),
	(172799, 119, '2014-02-01 00:55:53.000000', 'temperatura', 163.0000, 'ºC'),
	(172800, 119, '2014-02-01 00:55:54.000000', 'temperatura', 897.0000, 'ºC'),
	(172801, 119, '2014-02-01 00:55:55.000000', 'temperatura', 395.0000, 'ºC'),
	(172802, 119, '2014-02-01 00:55:56.000000', 'temperatura', 487.0000, 'ºC'),
	(172803, 119, '2014-02-01 00:55:57.000000', 'temperatura', 52.0000, 'ºC'),
	(172804, 119, '2014-02-01 00:55:58.000000', 'temperatura', 1197.0000, 'ºC'),
	(172805, 119, '2014-02-01 00:55:59.000000', 'temperatura', 1030.0000, 'ºC'),
	(172806, 119, '2014-02-01 00:56:00.000000', 'temperatura', 360.0000, 'ºC'),
	(172807, 119, '2014-02-01 00:56:01.000000', 'temperatura', 1109.0000, 'ºC'),
	(172808, 119, '2014-02-01 00:56:02.000000', 'temperatura', 866.0000, 'ºC'),
	(172809, 119, '2014-02-01 00:56:03.000000', 'temperatura', 1005.0000, 'ºC'),
	(172810, 119, '2014-02-01 00:56:04.000000', 'temperatura', 26.0000, 'ºC'),
	(172811, 119, '2014-02-01 00:56:05.000000', 'temperatura', 714.0000, 'ºC'),
	(172812, 119, '2014-02-01 00:56:06.000000', 'temperatura', 1096.0000, 'ºC'),
	(172813, 119, '2014-02-01 00:56:07.000000', 'temperatura', 936.0000, 'ºC'),
	(172814, 119, '2014-02-01 00:56:08.000000', 'temperatura', 195.0000, 'ºC'),
	(172815, 119, '2014-02-01 00:56:09.000000', 'temperatura', 566.0000, 'ºC'),
	(172816, 119, '2014-02-01 00:56:10.000000', 'temperatura', 1048.0000, 'ºC'),
	(172817, 119, '2014-02-01 00:56:11.000000', 'temperatura', 1139.0000, 'ºC'),
	(172818, 119, '2014-02-01 00:56:12.000000', 'temperatura', 152.0000, 'ºC'),
	(172819, 119, '2014-02-01 00:56:13.000000', 'temperatura', 943.0000, 'ºC'),
	(172820, 119, '2014-02-01 00:56:14.000000', 'temperatura', 662.0000, 'ºC'),
	(172821, 119, '2014-02-01 00:56:15.000000', 'temperatura', 481.0000, 'ºC'),
	(172822, 119, '2014-02-01 00:56:16.000000', 'temperatura', 419.0000, 'ºC'),
	(172823, 119, '2014-02-01 00:56:17.000000', 'temperatura', 653.0000, 'ºC'),
	(172824, 119, '2014-02-01 00:56:18.000000', 'temperatura', 807.0000, 'ºC'),
	(172825, 119, '2014-02-01 00:56:19.000000', 'temperatura', 876.0000, 'ºC'),
	(172826, 119, '2014-02-01 00:56:20.000000', 'temperatura', 761.0000, 'ºC'),
	(172827, 119, '2014-02-01 00:56:21.000000', 'temperatura', 1179.0000, 'ºC'),
	(172828, 119, '2014-02-01 00:56:22.000000', 'temperatura', 11.0000, 'ºC'),
	(172829, 119, '2014-02-01 00:56:23.000000', 'temperatura', 118.0000, 'ºC'),
	(172830, 119, '2014-02-01 00:56:24.000000', 'temperatura', 557.0000, 'ºC'),
	(172831, 119, '2014-02-01 00:56:25.000000', 'temperatura', 31.0000, 'ºC'),
	(172832, 119, '2014-02-01 00:56:26.000000', 'temperatura', 885.0000, 'ºC'),
	(172833, 119, '2014-02-01 00:56:27.000000', 'temperatura', 734.0000, 'ºC'),
	(172834, 119, '2014-02-01 00:56:28.000000', 'temperatura', 1017.0000, 'ºC'),
	(172835, 119, '2014-02-01 00:56:29.000000', 'temperatura', 480.0000, 'ºC'),
	(172836, 119, '2014-02-01 00:56:30.000000', 'temperatura', 551.0000, 'ºC'),
	(172837, 119, '2014-02-01 00:56:31.000000', 'temperatura', 117.0000, 'ºC'),
	(172838, 119, '2014-02-01 00:56:32.000000', 'temperatura', 133.0000, 'ºC'),
	(172839, 119, '2014-02-01 00:56:33.000000', 'temperatura', 314.0000, 'ºC'),
	(172840, 119, '2014-02-01 00:56:34.000000', 'temperatura', 1171.0000, 'ºC'),
	(172841, 119, '2014-02-01 00:56:35.000000', 'temperatura', 115.0000, 'ºC'),
	(172842, 119, '2014-02-01 00:56:36.000000', 'temperatura', 661.0000, 'ºC'),
	(172843, 119, '2014-02-01 00:56:37.000000', 'temperatura', 559.0000, 'ºC'),
	(172844, 119, '2014-02-01 00:56:38.000000', 'temperatura', 813.0000, 'ºC'),
	(172845, 119, '2014-02-01 00:56:39.000000', 'temperatura', 1191.0000, 'ºC'),
	(172846, 119, '2014-02-01 00:56:40.000000', 'temperatura', 1114.0000, 'ºC'),
	(172847, 119, '2014-02-01 00:56:41.000000', 'temperatura', 800.0000, 'ºC'),
	(172848, 119, '2014-02-01 00:56:42.000000', 'temperatura', 657.0000, 'ºC'),
	(172849, 119, '2014-02-01 00:56:43.000000', 'temperatura', 886.0000, 'ºC'),
	(172850, 119, '2014-02-01 00:56:44.000000', 'temperatura', 58.0000, 'ºC'),
	(172851, 119, '2014-02-01 00:56:45.000000', 'temperatura', 32.0000, 'ºC'),
	(172852, 119, '2014-02-01 00:56:46.000000', 'temperatura', 1188.0000, 'ºC'),
	(172853, 119, '2014-02-01 00:56:47.000000', 'temperatura', 1043.0000, 'ºC'),
	(172854, 119, '2014-02-01 00:56:48.000000', 'temperatura', 452.0000, 'ºC'),
	(172855, 119, '2014-02-01 00:56:49.000000', 'temperatura', 332.0000, 'ºC'),
	(172856, 119, '2014-02-01 00:56:50.000000', 'temperatura', 305.0000, 'ºC'),
	(172857, 119, '2014-02-01 00:56:51.000000', 'temperatura', 530.0000, 'ºC'),
	(172858, 119, '2014-02-01 00:56:52.000000', 'temperatura', 533.0000, 'ºC'),
	(172859, 119, '2014-02-01 00:56:53.000000', 'temperatura', 1078.0000, 'ºC'),
	(172860, 119, '2014-02-01 00:56:54.000000', 'temperatura', 191.0000, 'ºC'),
	(172861, 119, '2014-02-01 00:56:55.000000', 'temperatura', 121.0000, 'ºC'),
	(172862, 119, '2014-02-01 00:56:56.000000', 'temperatura', 32.0000, 'ºC'),
	(172863, 119, '2014-02-01 00:56:57.000000', 'temperatura', 1000.0000, 'ºC'),
	(172864, 119, '2014-02-01 00:56:58.000000', 'temperatura', 102.0000, 'ºC'),
	(172865, 119, '2014-02-01 00:56:59.000000', 'temperatura', 1112.0000, 'ºC'),
	(172866, 119, '2014-02-01 00:57:00.000000', 'temperatura', 454.0000, 'ºC'),
	(172867, 119, '2014-02-01 00:57:01.000000', 'temperatura', 137.0000, 'ºC'),
	(172868, 119, '2014-02-01 00:57:02.000000', 'temperatura', 520.0000, 'ºC'),
	(172869, 119, '2014-02-01 00:57:03.000000', 'temperatura', 991.0000, 'ºC'),
	(172870, 119, '2014-02-01 00:57:04.000000', 'temperatura', 997.0000, 'ºC'),
	(172871, 119, '2014-02-01 00:57:05.000000', 'temperatura', 811.0000, 'ºC'),
	(172872, 119, '2014-02-01 00:57:06.000000', 'temperatura', 1065.0000, 'ºC'),
	(172873, 119, '2014-02-01 00:57:07.000000', 'temperatura', 494.0000, 'ºC'),
	(172874, 119, '2014-02-01 00:57:08.000000', 'temperatura', 473.0000, 'ºC'),
	(172875, 119, '2014-02-01 00:57:09.000000', 'temperatura', 885.0000, 'ºC'),
	(172876, 119, '2014-02-01 00:57:10.000000', 'temperatura', 608.0000, 'ºC'),
	(172877, 119, '2014-02-01 00:57:11.000000', 'temperatura', 385.0000, 'ºC'),
	(172878, 119, '2014-02-01 00:57:12.000000', 'temperatura', 102.0000, 'ºC'),
	(172879, 119, '2014-02-01 00:57:13.000000', 'temperatura', 554.0000, 'ºC'),
	(172880, 119, '2014-02-01 00:57:14.000000', 'temperatura', 63.0000, 'ºC'),
	(172881, 119, '2014-02-01 00:57:15.000000', 'temperatura', 1055.0000, 'ºC'),
	(172882, 119, '2014-02-01 00:57:16.000000', 'temperatura', 285.0000, 'ºC'),
	(172883, 119, '2014-02-01 00:57:17.000000', 'temperatura', 661.0000, 'ºC'),
	(172884, 119, '2014-02-01 00:57:18.000000', 'temperatura', 53.0000, 'ºC'),
	(172885, 119, '2014-02-01 00:57:19.000000', 'temperatura', 681.0000, 'ºC'),
	(172886, 119, '2014-02-01 00:57:20.000000', 'temperatura', 845.0000, 'ºC'),
	(172887, 119, '2014-02-01 00:57:21.000000', 'temperatura', 983.0000, 'ºC'),
	(172888, 119, '2014-02-01 00:57:22.000000', 'temperatura', 1179.0000, 'ºC'),
	(172889, 119, '2014-02-01 00:57:23.000000', 'temperatura', 550.0000, 'ºC'),
	(172890, 119, '2014-02-01 00:57:24.000000', 'temperatura', 412.0000, 'ºC'),
	(172891, 119, '2014-02-01 00:57:25.000000', 'temperatura', 409.0000, 'ºC'),
	(172892, 119, '2014-02-01 00:57:26.000000', 'temperatura', 812.0000, 'ºC'),
	(172893, 119, '2014-02-01 00:57:27.000000', 'temperatura', 432.0000, 'ºC'),
	(172894, 119, '2014-02-01 00:57:28.000000', 'temperatura', 924.0000, 'ºC'),
	(172895, 119, '2014-02-01 00:57:29.000000', 'temperatura', 925.0000, 'ºC'),
	(172896, 119, '2014-02-01 00:57:30.000000', 'temperatura', 653.0000, 'ºC'),
	(172897, 119, '2014-02-01 00:57:31.000000', 'temperatura', 489.0000, 'ºC'),
	(172898, 119, '2014-02-01 00:57:32.000000', 'temperatura', 488.0000, 'ºC'),
	(172899, 119, '2014-02-01 00:57:33.000000', 'temperatura', 974.0000, 'ºC'),
	(172900, 119, '2014-02-01 00:57:34.000000', 'temperatura', 1006.0000, 'ºC'),
	(172901, 119, '2014-02-01 00:57:35.000000', 'temperatura', 910.0000, 'ºC'),
	(172902, 119, '2014-02-01 00:57:36.000000', 'temperatura', 330.0000, 'ºC'),
	(172903, 119, '2014-02-01 00:57:37.000000', 'temperatura', 122.0000, 'ºC'),
	(172904, 119, '2014-02-01 00:57:38.000000', 'temperatura', 822.0000, 'ºC'),
	(172905, 119, '2014-02-01 00:57:39.000000', 'temperatura', 141.0000, 'ºC'),
	(172906, 119, '2014-02-01 00:57:40.000000', 'temperatura', 642.0000, 'ºC'),
	(172907, 119, '2014-02-01 00:57:41.000000', 'temperatura', 386.0000, 'ºC'),
	(172908, 119, '2014-02-01 00:57:42.000000', 'temperatura', 4.0000, 'ºC'),
	(172909, 119, '2014-02-01 00:57:43.000000', 'temperatura', 64.0000, 'ºC'),
	(172910, 119, '2014-02-01 00:57:44.000000', 'temperatura', 309.0000, 'ºC'),
	(172911, 119, '2014-02-01 00:57:45.000000', 'temperatura', 152.0000, 'ºC'),
	(172912, 119, '2014-02-01 00:57:46.000000', 'temperatura', 1035.0000, 'ºC'),
	(172913, 119, '2014-02-01 00:57:47.000000', 'temperatura', 1118.0000, 'ºC'),
	(172914, 119, '2014-02-01 00:57:48.000000', 'temperatura', 86.0000, 'ºC'),
	(172915, 119, '2014-02-01 00:57:49.000000', 'temperatura', 676.0000, 'ºC'),
	(172916, 119, '2014-02-01 00:57:50.000000', 'temperatura', 723.0000, 'ºC'),
	(172917, 119, '2014-02-01 00:57:51.000000', 'temperatura', 386.0000, 'ºC'),
	(172918, 119, '2014-02-01 00:57:52.000000', 'temperatura', 961.0000, 'ºC'),
	(172919, 119, '2014-02-01 00:57:53.000000', 'temperatura', 47.0000, 'ºC'),
	(172920, 119, '2014-02-01 00:57:54.000000', 'temperatura', 953.0000, 'ºC'),
	(172921, 119, '2014-02-01 00:57:55.000000', 'temperatura', 1023.0000, 'ºC'),
	(172922, 119, '2014-02-01 00:57:56.000000', 'temperatura', 1058.0000, 'ºC'),
	(172923, 119, '2014-02-01 00:57:57.000000', 'temperatura', 1022.0000, 'ºC'),
	(172924, 119, '2014-02-01 00:57:58.000000', 'temperatura', 736.0000, 'ºC'),
	(172925, 119, '2014-02-01 00:57:59.000000', 'temperatura', 614.0000, 'ºC'),
	(172926, 119, '2014-02-01 00:58:00.000000', 'temperatura', 862.0000, 'ºC'),
	(172927, 119, '2014-02-01 00:58:01.000000', 'temperatura', 69.0000, 'ºC'),
	(172928, 119, '2014-02-01 00:58:02.000000', 'temperatura', 161.0000, 'ºC'),
	(172929, 119, '2014-02-01 00:58:03.000000', 'temperatura', 599.0000, 'ºC'),
	(172930, 119, '2014-02-01 00:58:04.000000', 'temperatura', 112.0000, 'ºC'),
	(172931, 119, '2014-02-01 00:58:05.000000', 'temperatura', 1164.0000, 'ºC'),
	(172932, 119, '2014-02-01 00:58:06.000000', 'temperatura', 682.0000, 'ºC'),
	(172933, 119, '2014-02-01 00:58:07.000000', 'temperatura', 1120.0000, 'ºC'),
	(172934, 119, '2014-02-01 00:58:08.000000', 'temperatura', 1154.0000, 'ºC'),
	(172935, 119, '2014-02-01 00:58:09.000000', 'temperatura', 10.0000, 'ºC'),
	(172936, 119, '2014-02-01 00:58:10.000000', 'temperatura', 187.0000, 'ºC'),
	(172937, 119, '2014-02-01 00:58:11.000000', 'temperatura', 907.0000, 'ºC'),
	(172938, 119, '2014-02-01 00:58:12.000000', 'temperatura', 375.0000, 'ºC'),
	(172939, 119, '2014-02-01 00:58:13.000000', 'temperatura', 353.0000, 'ºC'),
	(172940, 119, '2014-02-01 00:58:14.000000', 'temperatura', 640.0000, 'ºC'),
	(172941, 119, '2014-02-01 00:58:15.000000', 'temperatura', 943.0000, 'ºC'),
	(172942, 119, '2014-02-01 00:58:16.000000', 'temperatura', 395.0000, 'ºC'),
	(172943, 119, '2014-02-01 00:58:17.000000', 'temperatura', 348.0000, 'ºC'),
	(172944, 119, '2014-02-01 00:58:18.000000', 'temperatura', 556.0000, 'ºC'),
	(172945, 119, '2014-02-01 00:58:19.000000', 'temperatura', 534.0000, 'ºC'),
	(172946, 119, '2014-02-01 00:58:20.000000', 'temperatura', 1002.0000, 'ºC'),
	(172947, 119, '2014-02-01 00:58:21.000000', 'temperatura', 1011.0000, 'ºC'),
	(172948, 119, '2014-02-01 00:58:22.000000', 'temperatura', 850.0000, 'ºC'),
	(172949, 119, '2014-02-01 00:58:23.000000', 'temperatura', 17.0000, 'ºC'),
	(172950, 119, '2014-02-01 00:58:24.000000', 'temperatura', 1136.0000, 'ºC'),
	(172951, 119, '2014-02-01 00:58:25.000000', 'temperatura', 827.0000, 'ºC'),
	(172952, 119, '2014-02-01 00:58:26.000000', 'temperatura', 729.0000, 'ºC'),
	(172953, 119, '2014-02-01 00:58:27.000000', 'temperatura', 1163.0000, 'ºC'),
	(172954, 119, '2014-02-01 00:58:28.000000', 'temperatura', 31.0000, 'ºC'),
	(172955, 119, '2014-02-01 00:58:29.000000', 'temperatura', 264.0000, 'ºC'),
	(172956, 119, '2014-02-01 00:58:30.000000', 'temperatura', 27.0000, 'ºC'),
	(172957, 119, '2014-02-01 00:58:31.000000', 'temperatura', 545.0000, 'ºC'),
	(172958, 119, '2014-02-01 00:58:32.000000', 'temperatura', 244.0000, 'ºC'),
	(172959, 119, '2014-02-01 00:58:33.000000', 'temperatura', 784.0000, 'ºC'),
	(172960, 119, '2014-02-01 00:58:34.000000', 'temperatura', 790.0000, 'ºC'),
	(172961, 119, '2014-02-01 00:58:35.000000', 'temperatura', 397.0000, 'ºC'),
	(172962, 119, '2014-02-01 00:58:36.000000', 'temperatura', 817.0000, 'ºC'),
	(172963, 119, '2014-02-01 00:58:37.000000', 'temperatura', 496.0000, 'ºC'),
	(172964, 119, '2014-02-01 00:58:38.000000', 'temperatura', 28.0000, 'ºC'),
	(172965, 119, '2014-02-01 00:58:39.000000', 'temperatura', 1051.0000, 'ºC'),
	(172966, 119, '2014-02-01 00:58:40.000000', 'temperatura', 374.0000, 'ºC'),
	(172967, 119, '2014-02-01 00:58:41.000000', 'temperatura', 1118.0000, 'ºC'),
	(172968, 119, '2014-02-01 00:58:42.000000', 'temperatura', 868.0000, 'ºC'),
	(172969, 119, '2014-02-01 00:58:43.000000', 'temperatura', 986.0000, 'ºC'),
	(172970, 119, '2014-02-01 00:58:44.000000', 'temperatura', 1126.0000, 'ºC'),
	(172971, 119, '2014-02-01 00:58:45.000000', 'temperatura', 271.0000, 'ºC'),
	(172972, 119, '2014-02-01 00:58:46.000000', 'temperatura', 379.0000, 'ºC'),
	(172973, 119, '2014-02-01 00:58:47.000000', 'temperatura', 1084.0000, 'ºC'),
	(172974, 119, '2014-02-01 00:58:48.000000', 'temperatura', 682.0000, 'ºC'),
	(172975, 119, '2014-02-01 00:58:49.000000', 'temperatura', 159.0000, 'ºC'),
	(172976, 119, '2014-02-01 00:58:50.000000', 'temperatura', 1147.0000, 'ºC'),
	(172977, 119, '2014-02-01 00:58:51.000000', 'temperatura', 462.0000, 'ºC'),
	(172978, 119, '2014-02-01 00:58:52.000000', 'temperatura', 68.0000, 'ºC'),
	(172979, 119, '2014-02-01 00:58:53.000000', 'temperatura', 155.0000, 'ºC'),
	(172980, 119, '2014-02-01 00:58:54.000000', 'temperatura', 571.0000, 'ºC'),
	(172981, 119, '2014-02-01 00:58:55.000000', 'temperatura', 1191.0000, 'ºC'),
	(172982, 119, '2014-02-01 00:58:56.000000', 'temperatura', 640.0000, 'ºC'),
	(172983, 119, '2014-02-01 00:58:57.000000', 'temperatura', 831.0000, 'ºC'),
	(172984, 119, '2014-02-01 00:58:58.000000', 'temperatura', 1032.0000, 'ºC'),
	(172985, 119, '2014-02-01 00:58:59.000000', 'temperatura', 270.0000, 'ºC'),
	(172986, 119, '2014-02-01 00:59:00.000000', 'temperatura', 654.0000, 'ºC'),
	(172987, 119, '2014-02-01 00:59:01.000000', 'temperatura', 60.0000, 'ºC'),
	(172988, 119, '2014-02-01 00:59:02.000000', 'temperatura', 738.0000, 'ºC'),
	(172989, 119, '2014-02-01 00:59:03.000000', 'temperatura', 1112.0000, 'ºC'),
	(172990, 119, '2014-02-01 00:59:04.000000', 'temperatura', 947.0000, 'ºC'),
	(172991, 119, '2014-02-01 00:59:05.000000', 'temperatura', 198.0000, 'ºC'),
	(172992, 119, '2014-02-01 00:59:06.000000', 'temperatura', 550.0000, 'ºC'),
	(172993, 119, '2014-02-01 00:59:07.000000', 'temperatura', 955.0000, 'ºC'),
	(172994, 119, '2014-02-01 00:59:08.000000', 'temperatura', 725.0000, 'ºC'),
	(172995, 119, '2014-02-01 00:59:09.000000', 'temperatura', 759.0000, 'ºC'),
	(172996, 119, '2014-02-01 00:59:10.000000', 'temperatura', 424.0000, 'ºC'),
	(172997, 119, '2014-02-01 00:59:11.000000', 'temperatura', 1044.0000, 'ºC'),
	(172998, 119, '2014-02-01 00:59:12.000000', 'temperatura', 347.0000, 'ºC'),
	(172999, 119, '2014-02-01 00:59:13.000000', 'temperatura', 1005.0000, 'ºC'),
	(173000, 119, '2014-02-01 00:59:14.000000', 'temperatura', 384.0000, 'ºC'),
	(173001, 119, '2014-02-01 00:59:15.000000', 'temperatura', 104.0000, 'ºC'),
	(173002, 119, '2014-02-01 00:59:16.000000', 'temperatura', 568.0000, 'ºC'),
	(173003, 119, '2014-02-01 00:59:17.000000', 'temperatura', 128.0000, 'ºC'),
	(173004, 119, '2014-02-01 00:59:18.000000', 'temperatura', 138.0000, 'ºC'),
	(173005, 119, '2014-02-01 00:59:19.000000', 'temperatura', 306.0000, 'ºC'),
	(173006, 119, '2014-02-01 00:59:20.000000', 'temperatura', 1117.0000, 'ºC'),
	(173007, 119, '2014-02-01 00:59:21.000000', 'temperatura', 1068.0000, 'ºC'),
	(173008, 119, '2014-02-01 00:59:22.000000', 'temperatura', 787.0000, 'ºC'),
	(173009, 119, '2014-02-01 00:59:23.000000', 'temperatura', 735.0000, 'ºC'),
	(173010, 119, '2014-02-01 00:59:24.000000', 'temperatura', 112.0000, 'ºC'),
	(173011, 119, '2014-02-01 00:59:25.000000', 'temperatura', 758.0000, 'ºC'),
	(173012, 119, '2014-02-01 00:59:26.000000', 'temperatura', 1053.0000, 'ºC'),
	(173013, 119, '2014-02-01 00:59:27.000000', 'temperatura', 590.0000, 'ºC'),
	(173014, 119, '2014-02-01 00:59:28.000000', 'temperatura', 994.0000, 'ºC'),
	(173015, 119, '2014-02-01 00:59:29.000000', 'temperatura', 801.0000, 'ºC'),
	(173016, 119, '2014-02-01 00:59:30.000000', 'temperatura', 1024.0000, 'ºC'),
	(173017, 119, '2014-02-01 00:59:31.000000', 'temperatura', 319.0000, 'ºC'),
	(173018, 119, '2014-02-01 00:59:32.000000', 'temperatura', 920.0000, 'ºC'),
	(173019, 119, '2014-02-01 00:59:33.000000', 'temperatura', 45.0000, 'ºC'),
	(173020, 119, '2014-02-01 00:59:34.000000', 'temperatura', 1064.0000, 'ºC'),
	(173021, 119, '2014-02-01 00:59:35.000000', 'temperatura', 389.0000, 'ºC'),
	(173022, 119, '2014-02-01 00:59:36.000000', 'temperatura', 1150.0000, 'ºC'),
	(173023, 119, '2014-02-01 00:59:37.000000', 'temperatura', 983.0000, 'ºC'),
	(173024, 119, '2014-02-01 00:59:38.000000', 'temperatura', 269.0000, 'ºC'),
	(173025, 119, '2014-02-01 00:59:39.000000', 'temperatura', 793.0000, 'ºC'),
	(173026, 119, '2014-02-01 00:59:40.000000', 'temperatura', 761.0000, 'ºC'),
	(173027, 119, '2014-02-01 00:59:41.000000', 'temperatura', 224.0000, 'ºC'),
	(173028, 119, '2014-02-01 00:59:42.000000', 'temperatura', 41.0000, 'ºC'),
	(173029, 119, '2014-02-01 00:59:43.000000', 'temperatura', 731.0000, 'ºC'),
	(173030, 119, '2014-02-01 00:59:44.000000', 'temperatura', 1133.0000, 'ºC'),
	(173031, 119, '2014-02-01 00:59:45.000000', 'temperatura', 1073.0000, 'ºC'),
	(173032, 119, '2014-02-01 00:59:46.000000', 'temperatura', 765.0000, 'ºC'),
	(173033, 119, '2014-02-01 00:59:47.000000', 'temperatura', 607.0000, 'ºC'),
	(173034, 119, '2014-02-01 00:59:48.000000', 'temperatura', 742.0000, 'ºC'),
	(173035, 119, '2014-02-01 00:59:49.000000', 'temperatura', 687.0000, 'ºC'),
	(173036, 119, '2014-02-01 00:59:50.000000', 'temperatura', 9.0000, 'ºC'),
	(173037, 119, '2014-02-01 00:59:51.000000', 'temperatura', 384.0000, 'ºC'),
	(173038, 119, '2014-02-01 00:59:52.000000', 'temperatura', 696.0000, 'ºC'),
	(173039, 119, '2014-02-01 00:59:53.000000', 'temperatura', 1129.0000, 'ºC'),
	(173040, 119, '2014-02-01 00:59:54.000000', 'temperatura', 1155.0000, 'ºC'),
	(173041, 119, '2014-02-01 00:59:55.000000', 'temperatura', 1192.0000, 'ºC'),
	(173042, 119, '2014-02-01 00:59:56.000000', 'temperatura', 92.0000, 'ºC'),
	(173043, 119, '2014-02-01 00:59:57.000000', 'temperatura', 487.0000, 'ºC'),
	(173044, 119, '2014-02-01 00:59:58.000000', 'temperatura', 959.0000, 'ºC'),
	(173045, 119, '2014-02-01 00:59:59.000000', 'temperatura', 936.0000, 'ºC'),
	(173046, 119, '2014-02-01 01:00:00.000000', 'temperatura', 601.0000, 'ºC'),
	(173047, 119, '2014-02-01 01:00:01.000000', 'temperatura', 199.0000, 'ºC'),
	(173048, 119, '2014-02-01 01:00:02.000000', 'temperatura', 393.0000, 'ºC'),
	(173049, 119, '2014-02-01 01:00:03.000000', 'temperatura', 168.0000, 'ºC'),
	(173050, 119, '2014-02-01 01:00:04.000000', 'temperatura', 860.0000, 'ºC'),
	(173051, 119, '2014-02-01 01:00:05.000000', 'temperatura', 199.0000, 'ºC'),
	(173052, 119, '2014-02-01 01:00:06.000000', 'temperatura', 814.0000, 'ºC'),
	(173053, 119, '2014-02-01 01:00:07.000000', 'temperatura', 1074.0000, 'ºC'),
	(173054, 119, '2014-02-01 01:00:08.000000', 'temperatura', 526.0000, 'ºC'),
	(173055, 119, '2014-02-01 01:00:09.000000', 'temperatura', 611.0000, 'ºC'),
	(173056, 119, '2014-02-01 01:00:10.000000', 'temperatura', 279.0000, 'ºC'),
	(173057, 119, '2014-02-01 01:00:11.000000', 'temperatura', 760.0000, 'ºC'),
	(173058, 119, '2014-02-01 01:00:12.000000', 'temperatura', 565.0000, 'ºC'),
	(173059, 119, '2014-02-01 01:00:13.000000', 'temperatura', 544.0000, 'ºC'),
	(173060, 119, '2014-02-01 01:00:14.000000', 'temperatura', 1025.0000, 'ºC'),
	(173061, 119, '2014-02-01 01:00:15.000000', 'temperatura', 1094.0000, 'ºC'),
	(173062, 119, '2014-02-01 01:00:16.000000', 'temperatura', 1197.0000, 'ºC'),
	(173063, 119, '2014-02-01 01:00:17.000000', 'temperatura', 301.0000, 'ºC'),
	(173064, 119, '2014-02-01 01:00:18.000000', 'temperatura', 316.0000, 'ºC'),
	(173065, 119, '2014-02-01 01:00:19.000000', 'temperatura', 678.0000, 'ºC'),
	(173066, 119, '2014-02-01 01:00:20.000000', 'temperatura', 40.0000, 'ºC'),
	(173067, 119, '2014-02-01 01:00:21.000000', 'temperatura', 569.0000, 'ºC'),
	(173068, 119, '2014-02-01 01:00:22.000000', 'temperatura', 325.0000, 'ºC'),
	(173069, 119, '2014-02-01 01:00:23.000000', 'temperatura', 1120.0000, 'ºC'),
	(173070, 119, '2014-02-01 01:00:24.000000', 'temperatura', 1024.0000, 'ºC'),
	(173071, 119, '2014-02-01 01:00:25.000000', 'temperatura', 561.0000, 'ºC'),
	(173072, 119, '2014-02-01 01:00:26.000000', 'temperatura', 932.0000, 'ºC'),
	(173073, 119, '2014-02-01 01:00:27.000000', 'temperatura', 578.0000, 'ºC'),
	(173074, 119, '2014-02-01 01:00:28.000000', 'temperatura', 93.0000, 'ºC'),
	(173075, 119, '2014-02-01 01:00:29.000000', 'temperatura', 1132.0000, 'ºC'),
	(173076, 119, '2014-02-01 01:00:30.000000', 'temperatura', 581.0000, 'ºC'),
	(173077, 119, '2014-02-01 01:00:31.000000', 'temperatura', 710.0000, 'ºC'),
	(173078, 119, '2014-02-01 01:00:32.000000', 'temperatura', 607.0000, 'ºC'),
	(173079, 119, '2014-02-01 01:00:33.000000', 'temperatura', 907.0000, 'ºC'),
	(173080, 119, '2014-02-01 01:00:34.000000', 'temperatura', 316.0000, 'ºC'),
	(173081, 119, '2014-02-01 01:00:35.000000', 'temperatura', 56.0000, 'ºC'),
	(173082, 119, '2014-02-01 01:00:36.000000', 'temperatura', 533.0000, 'ºC'),
	(173083, 119, '2014-02-01 01:00:37.000000', 'temperatura', 99.0000, 'ºC'),
	(173084, 119, '2014-02-01 01:00:38.000000', 'temperatura', 95.0000, 'ºC'),
	(173085, 119, '2014-02-01 01:00:39.000000', 'temperatura', 181.0000, 'ºC'),
	(173086, 119, '2014-02-01 01:00:40.000000', 'temperatura', 620.0000, 'ºC'),
	(173087, 119, '2014-02-01 01:00:41.000000', 'temperatura', 157.0000, 'ºC'),
	(173088, 119, '2014-02-01 01:00:42.000000', 'temperatura', 127.0000, 'ºC'),
	(173089, 119, '2014-02-01 01:00:43.000000', 'temperatura', 164.0000, 'ºC'),
	(173090, 119, '2014-02-01 01:00:44.000000', 'temperatura', 441.0000, 'ºC'),
	(173091, 119, '2014-02-01 01:00:45.000000', 'temperatura', 512.0000, 'ºC'),
	(173092, 119, '2014-02-01 01:00:46.000000', 'temperatura', 36.0000, 'ºC'),
	(173093, 119, '2014-02-01 01:00:47.000000', 'temperatura', 1044.0000, 'ºC'),
	(173094, 119, '2014-02-01 01:00:48.000000', 'temperatura', 315.0000, 'ºC'),
	(173095, 119, '2014-02-01 01:00:49.000000', 'temperatura', 842.0000, 'ºC'),
	(173096, 119, '2014-02-01 01:00:50.000000', 'temperatura', 864.0000, 'ºC'),
	(173097, 119, '2014-02-01 01:00:51.000000', 'temperatura', 597.0000, 'ºC'),
	(173098, 119, '2014-02-01 01:00:52.000000', 'temperatura', 394.0000, 'ºC'),
	(173099, 119, '2014-02-01 01:00:53.000000', 'temperatura', 179.0000, 'ºC'),
	(173100, 119, '2014-02-01 01:00:54.000000', 'temperatura', 912.0000, 'ºC'),
	(173101, 119, '2014-02-01 01:00:55.000000', 'temperatura', 425.0000, 'ºC'),
	(173102, 119, '2014-02-01 01:00:56.000000', 'temperatura', 588.0000, 'ºC'),
	(173103, 119, '2014-02-01 01:00:57.000000', 'temperatura', 464.0000, 'ºC'),
	(173104, 119, '2014-02-01 01:00:58.000000', 'temperatura', 558.0000, 'ºC'),
	(173105, 119, '2014-02-01 01:00:59.000000', 'temperatura', 200.0000, 'ºC'),
	(173106, 119, '2014-02-01 01:01:00.000000', 'temperatura', 526.0000, 'ºC'),
	(173107, 119, '2014-02-01 01:01:01.000000', 'temperatura', 831.0000, 'ºC'),
	(173108, 119, '2014-02-01 01:01:02.000000', 'temperatura', 177.0000, 'ºC'),
	(173109, 119, '2014-02-01 01:01:03.000000', 'temperatura', 791.0000, 'ºC'),
	(173110, 119, '2014-02-01 01:01:04.000000', 'temperatura', 1027.0000, 'ºC'),
	(173111, 119, '2014-02-01 01:01:05.000000', 'temperatura', 363.0000, 'ºC'),
	(173112, 119, '2014-02-01 01:01:06.000000', 'temperatura', 1136.0000, 'ºC'),
	(173113, 119, '2014-02-01 01:01:07.000000', 'temperatura', 988.0000, 'ºC'),
	(173114, 119, '2014-02-01 01:01:08.000000', 'temperatura', 333.0000, 'ºC'),
	(173115, 119, '2014-02-01 01:01:09.000000', 'temperatura', 1102.0000, 'ºC'),
	(173116, 119, '2014-02-01 01:01:10.000000', 'temperatura', 911.0000, 'ºC'),
	(173117, 119, '2014-02-01 01:01:11.000000', 'temperatura', 51.0000, 'ºC'),
	(173118, 119, '2014-02-01 01:01:12.000000', 'temperatura', 1123.0000, 'ºC'),
	(173119, 119, '2014-02-01 01:01:13.000000', 'temperatura', 664.0000, 'ºC'),
	(173120, 119, '2014-02-01 01:01:14.000000', 'temperatura', 1148.0000, 'ºC'),
	(173121, 119, '2014-02-01 01:01:15.000000', 'temperatura', 149.0000, 'ºC'),
	(173122, 119, '2014-02-01 01:01:16.000000', 'temperatura', 901.0000, 'ºC'),
	(173123, 119, '2014-02-01 01:01:17.000000', 'temperatura', 459.0000, 'ºC'),
	(173124, 119, '2014-02-01 01:01:18.000000', 'temperatura', 792.0000, 'ºC'),
	(173125, 119, '2014-02-01 01:01:19.000000', 'temperatura', 183.0000, 'ºC'),
	(173126, 119, '2014-02-01 01:01:20.000000', 'temperatura', 940.0000, 'ºC'),
	(173127, 119, '2014-02-01 01:01:21.000000', 'temperatura', 550.0000, 'ºC'),
	(173128, 119, '2014-02-01 01:01:22.000000', 'temperatura', 1133.0000, 'ºC'),
	(173129, 119, '2014-02-01 01:01:23.000000', 'temperatura', 413.0000, 'ºC'),
	(173130, 119, '2014-02-01 01:01:24.000000', 'temperatura', 1068.0000, 'ºC'),
	(173131, 119, '2014-02-01 01:01:25.000000', 'temperatura', 499.0000, 'ºC'),
	(173132, 119, '2014-02-01 01:01:26.000000', 'temperatura', 495.0000, 'ºC'),
	(173133, 119, '2014-02-01 01:01:27.000000', 'temperatura', 975.0000, 'ºC'),
	(173134, 119, '2014-02-01 01:01:28.000000', 'temperatura', 992.0000, 'ºC'),
	(173135, 119, '2014-02-01 01:01:29.000000', 'temperatura', 837.0000, 'ºC'),
	(173136, 119, '2014-02-01 01:01:30.000000', 'temperatura', 7.0000, 'ºC'),
	(173137, 119, '2014-02-01 01:01:31.000000', 'temperatura', 1127.0000, 'ºC'),
	(173138, 119, '2014-02-01 01:01:32.000000', 'temperatura', 812.0000, 'ºC'),
	(173139, 119, '2014-02-01 01:01:33.000000', 'temperatura', 679.0000, 'ºC'),
	(173140, 119, '2014-02-01 01:01:34.000000', 'temperatura', 962.0000, 'ºC'),
	(173141, 119, '2014-02-01 01:01:35.000000', 'temperatura', 372.0000, 'ºC'),
	(173142, 119, '2014-02-01 01:01:36.000000', 'temperatura', 175.0000, 'ºC'),
	(173143, 119, '2014-02-01 01:01:37.000000', 'temperatura', 958.0000, 'ºC'),
	(173144, 119, '2014-02-01 01:01:38.000000', 'temperatura', 665.0000, 'ºC'),
	(173145, 119, '2014-02-01 01:01:39.000000', 'temperatura', 451.0000, 'ºC'),
	(173146, 119, '2014-02-01 01:01:40.000000', 'temperatura', 262.0000, 'ºC'),
	(173147, 119, '2014-02-01 01:01:41.000000', 'temperatura', 1158.0000, 'ºC'),
	(173148, 119, '2014-02-01 01:01:42.000000', 'temperatura', 205.0000, 'ºC'),
	(173149, 119, '2014-02-01 01:01:43.000000', 'temperatura', 1151.0000, 'ºC'),
	(173150, 119, '2014-02-01 01:01:44.000000', 'temperatura', 341.0000, 'ºC'),
	(173151, 119, '2014-02-01 01:01:45.000000', 'temperatura', 653.0000, 'ºC'),
	(173152, 119, '2014-02-01 01:01:46.000000', 'temperatura', 1041.0000, 'ºC'),
	(173153, 119, '2014-02-01 01:01:47.000000', 'temperatura', 846.0000, 'ºC'),
	(173154, 119, '2014-02-01 01:01:48.000000', 'temperatura', 1106.0000, 'ºC'),
	(173155, 119, '2014-02-01 01:01:49.000000', 'temperatura', 595.0000, 'ºC'),
	(173156, 119, '2014-02-01 01:01:50.000000', 'temperatura', 858.0000, 'ºC'),
	(173157, 119, '2014-02-01 01:01:51.000000', 'temperatura', 103.0000, 'ºC'),
	(173158, 119, '2014-02-01 01:01:52.000000', 'temperatura', 344.0000, 'ºC'),
	(173159, 119, '2014-02-01 01:01:53.000000', 'temperatura', 212.0000, 'ºC'),
	(173160, 119, '2014-02-01 01:01:54.000000', 'temperatura', 29.0000, 'ºC'),
	(173161, 119, '2014-02-01 01:01:55.000000', 'temperatura', 708.0000, 'ºC'),
	(173162, 119, '2014-02-01 01:01:56.000000', 'temperatura', 1055.0000, 'ºC'),
	(173163, 119, '2014-02-01 01:01:57.000000', 'temperatura', 752.0000, 'ºC'),
	(173164, 119, '2014-02-01 01:01:58.000000', 'temperatura', 597.0000, 'ºC'),
	(173165, 119, '2014-02-01 01:01:59.000000', 'temperatura', 726.0000, 'ºC'),
	(173166, 119, '2014-02-01 01:02:00.000000', 'temperatura', 643.0000, 'ºC'),
	(173167, 119, '2014-02-01 01:02:01.000000', 'temperatura', 1034.0000, 'ºC'),
	(173168, 119, '2014-02-01 01:02:02.000000', 'temperatura', 843.0000, 'ºC'),
	(173169, 119, '2014-02-01 01:02:03.000000', 'temperatura', 1114.0000, 'ºC'),
	(173170, 119, '2014-02-01 01:02:04.000000', 'temperatura', 642.0000, 'ºC'),
	(173171, 119, '2014-02-01 01:02:05.000000', 'temperatura', 1068.0000, 'ºC'),
	(173172, 119, '2014-02-01 01:02:06.000000', 'temperatura', 1012.0000, 'ºC'),
	(173173, 119, '2014-02-01 01:02:07.000000', 'temperatura', 660.0000, 'ºC'),
	(173174, 119, '2014-02-01 01:02:08.000000', 'temperatura', 264.0000, 'ºC'),
	(173175, 119, '2014-02-01 01:02:09.000000', 'temperatura', 541.0000, 'ºC'),
	(173176, 119, '2014-02-01 01:02:10.000000', 'temperatura', 713.0000, 'ºC'),
	(173177, 119, '2014-02-01 01:02:11.000000', 'temperatura', 741.0000, 'ºC'),
	(173178, 119, '2014-02-01 01:02:12.000000', 'temperatura', 366.0000, 'ºC'),
	(173179, 119, '2014-02-01 01:02:13.000000', 'temperatura', 809.0000, 'ºC'),
	(173180, 119, '2014-02-01 01:02:14.000000', 'temperatura', 545.0000, 'ºC'),
	(173181, 119, '2014-02-01 01:02:15.000000', 'temperatura', 300.0000, 'ºC'),
	(173182, 119, '2014-02-01 01:02:16.000000', 'temperatura', 1066.0000, 'ºC'),
	(173183, 119, '2014-02-01 01:02:17.000000', 'temperatura', 832.0000, 'ºC'),
	(173184, 119, '2014-02-01 01:02:18.000000', 'temperatura', 960.0000, 'ºC'),
	(173185, 119, '2014-02-01 01:02:19.000000', 'temperatura', 1107.0000, 'ºC'),
	(173186, 119, '2014-02-01 01:02:20.000000', 'temperatura', 256.0000, 'ºC'),
	(173187, 119, '2014-02-01 01:02:21.000000', 'temperatura', 360.0000, 'ºC'),
	(173188, 119, '2014-02-01 01:02:22.000000', 'temperatura', 1031.0000, 'ºC'),
	(173189, 119, '2014-02-01 01:02:23.000000', 'temperatura', 475.0000, 'ºC'),
	(173190, 119, '2014-02-01 01:02:24.000000', 'temperatura', 484.0000, 'ºC'),
	(173191, 119, '2014-02-01 01:02:25.000000', 'temperatura', 996.0000, 'ºC'),
	(173192, 119, '2014-02-01 01:02:26.000000', 'temperatura', 1127.0000, 'ºC'),
	(173193, 119, '2014-02-01 01:02:27.000000', 'temperatura', 250.0000, 'ºC'),
	(173194, 119, '2014-02-01 01:02:28.000000', 'temperatura', 266.0000, 'ºC'),
	(173195, 119, '2014-02-01 01:02:29.000000', 'temperatura', 583.0000, 'ºC'),
	(173196, 119, '2014-02-01 01:02:30.000000', 'temperatura', 918.0000, 'ºC'),
	(173197, 119, '2014-02-01 01:02:31.000000', 'temperatura', 439.0000, 'ºC'),
	(173198, 119, '2014-02-01 01:02:32.000000', 'temperatura', 645.0000, 'ºC'),
	(173199, 119, '2014-02-01 01:02:33.000000', 'temperatura', 706.0000, 'ºC'),
	(173200, 119, '2014-02-01 01:02:34.000000', 'temperatura', 395.0000, 'ºC'),
	(173201, 119, '2014-02-01 01:02:35.000000', 'temperatura', 1058.0000, 'ºC'),
	(173202, 119, '2014-02-01 01:02:36.000000', 'temperatura', 505.0000, 'ºC'),
	(173203, 119, '2014-02-01 01:02:37.000000', 'temperatura', 553.0000, 'ºC'),
	(173204, 119, '2014-02-01 01:02:38.000000', 'temperatura', 52.0000, 'ºC'),
	(173205, 119, '2014-02-01 01:02:39.000000', 'temperatura', 999.0000, 'ºC'),
	(173206, 119, '2014-02-01 01:02:40.000000', 'temperatura', 38.0000, 'ºC'),
	(173207, 119, '2014-02-01 01:02:41.000000', 'temperatura', 795.0000, 'ºC'),
	(173208, 119, '2014-02-01 01:02:42.000000', 'temperatura', 263.0000, 'ºC'),
	(173209, 119, '2014-02-01 01:02:43.000000', 'temperatura', 130.0000, 'ºC'),
	(173210, 119, '2014-02-01 01:02:44.000000', 'temperatura', 1063.0000, 'ºC'),
	(173211, 119, '2014-02-01 01:02:45.000000', 'temperatura', 122.0000, 'ºC'),
	(173212, 119, '2014-02-01 01:02:46.000000', 'temperatura', 1024.0000, 'ºC'),
	(173213, 119, '2014-02-01 01:02:47.000000', 'temperatura', 1152.0000, 'ºC'),
	(173214, 119, '2014-02-01 01:02:48.000000', 'temperatura', 290.0000, 'ºC'),
	(173215, 119, '2014-02-01 01:02:49.000000', 'temperatura', 395.0000, 'ºC'),
	(173216, 119, '2014-02-01 01:02:50.000000', 'temperatura', 1107.0000, 'ºC'),
	(173217, 119, '2014-02-01 01:02:51.000000', 'temperatura', 749.0000, 'ºC'),
	(173218, 119, '2014-02-01 01:02:52.000000', 'temperatura', 423.0000, 'ºC'),
	(173219, 119, '2014-02-01 01:02:53.000000', 'temperatura', 1069.0000, 'ºC'),
	(173220, 119, '2014-02-01 01:02:54.000000', 'temperatura', 476.0000, 'ºC'),
	(173221, 119, '2014-02-01 01:02:55.000000', 'temperatura', 374.0000, 'ºC'),
	(173222, 119, '2014-02-01 01:02:56.000000', 'temperatura', 443.0000, 'ºC'),
	(173223, 119, '2014-02-01 01:02:57.000000', 'temperatura', 1094.0000, 'ºC'),
	(173224, 119, '2014-02-01 01:02:58.000000', 'temperatura', 541.0000, 'ºC'),
	(173225, 119, '2014-02-01 01:02:59.000000', 'temperatura', 622.0000, 'ºC'),
	(173226, 119, '2014-02-01 01:03:00.000000', 'temperatura', 289.0000, 'ºC'),
	(173227, 119, '2014-02-01 01:03:01.000000', 'temperatura', 780.0000, 'ºC'),
	(173228, 119, '2014-02-01 01:03:02.000000', 'temperatura', 634.0000, 'ºC'),
	(173229, 119, '2014-02-01 01:03:03.000000', 'temperatura', 830.0000, 'ºC'),
	(173230, 119, '2014-02-01 01:03:04.000000', 'temperatura', 1048.0000, 'ºC'),
	(173231, 119, '2014-02-01 01:03:05.000000', 'temperatura', 349.0000, 'ºC'),
	(173232, 119, '2014-02-01 01:03:06.000000', 'temperatura', 1003.0000, 'ºC'),
	(173233, 119, '2014-02-01 01:03:07.000000', 'temperatura', 367.0000, 'ºC'),
	(173234, 119, '2014-02-01 01:03:08.000000', 'temperatura', 26.0000, 'ºC'),
	(173235, 119, '2014-02-01 01:03:09.000000', 'temperatura', 230.0000, 'ºC'),
	(173236, 119, '2014-02-01 01:03:10.000000', 'temperatura', 1072.0000, 'ºC'),
	(173237, 119, '2014-02-01 01:03:11.000000', 'temperatura', 1071.0000, 'ºC'),
	(173238, 119, '2014-02-01 01:03:12.000000', 'temperatura', 940.0000, 'ºC'),
	(173239, 119, '2014-02-01 01:03:13.000000', 'temperatura', 286.0000, 'ºC'),
	(173240, 119, '2014-02-01 01:03:14.000000', 'temperatura', 1009.0000, 'ºC'),
	(173241, 119, '2014-02-01 01:03:15.000000', 'temperatura', 591.0000, 'ºC'),
	(173242, 119, '2014-02-01 01:03:16.000000', 'temperatura', 1126.0000, 'ºC'),
	(173243, 119, '2014-02-01 01:03:17.000000', 'temperatura', 258.0000, 'ºC'),
	(173244, 119, '2014-02-01 01:03:18.000000', 'temperatura', 313.0000, 'ºC'),
	(173245, 119, '2014-02-01 01:03:19.000000', 'temperatura', 789.0000, 'ºC'),
	(173246, 119, '2014-02-01 01:03:20.000000', 'temperatura', 609.0000, 'ºC'),
	(173247, 119, '2014-02-01 01:03:21.000000', 'temperatura', 677.0000, 'ºC'),
	(173248, 119, '2014-02-01 01:03:22.000000', 'temperatura', 361.0000, 'ºC'),
	(173249, 119, '2014-02-01 01:03:23.000000', 'temperatura', 971.0000, 'ºC'),
	(173250, 119, '2014-02-01 01:03:24.000000', 'temperatura', 176.0000, 'ºC'),
	(173251, 119, '2014-02-01 01:03:25.000000', 'temperatura', 365.0000, 'ºC'),
	(173252, 119, '2014-02-01 01:03:26.000000', 'temperatura', 100.0000, 'ºC'),
	(173253, 119, '2014-02-01 01:03:27.000000', 'temperatura', 604.0000, 'ºC'),
	(173254, 119, '2014-02-01 01:03:28.000000', 'temperatura', 321.0000, 'ºC'),
	(173255, 119, '2014-02-01 01:03:29.000000', 'temperatura', 993.0000, 'ºC'),
	(173256, 119, '2014-02-01 01:03:30.000000', 'temperatura', 403.0000, 'ºC'),
	(173257, 119, '2014-02-01 01:03:31.000000', 'temperatura', 237.0000, 'ºC'),
	(173258, 119, '2014-02-01 01:03:32.000000', 'temperatura', 1174.0000, 'ºC'),
	(173259, 119, '2014-02-01 01:03:33.000000', 'temperatura', 361.0000, 'ºC'),
	(173260, 119, '2014-02-01 01:03:34.000000', 'temperatura', 682.0000, 'ºC'),
	(173261, 119, '2014-02-01 01:03:35.000000', 'temperatura', 1128.0000, 'ºC'),
	(173262, 119, '2014-02-01 01:03:36.000000', 'temperatura', 1195.0000, 'ºC'),
	(173263, 119, '2014-02-01 01:03:37.000000', 'temperatura', 192.0000, 'ºC'),
	(173264, 119, '2014-02-01 01:03:38.000000', 'temperatura', 974.0000, 'ºC'),
	(173265, 119, '2014-02-01 01:03:39.000000', 'temperatura', 694.0000, 'ºC'),
	(173266, 119, '2014-02-01 01:03:40.000000', 'temperatura', 550.0000, 'ºC'),
	(173267, 119, '2014-02-01 01:03:41.000000', 'temperatura', 670.0000, 'ºC'),
	(173268, 119, '2014-02-01 01:03:42.000000', 'temperatura', 497.0000, 'ºC'),
	(173269, 119, '2014-02-01 01:03:43.000000', 'temperatura', 479.0000, 'ºC'),
	(173270, 119, '2014-02-01 01:03:44.000000', 'temperatura', 903.0000, 'ºC'),
	(173271, 119, '2014-02-01 01:03:45.000000', 'temperatura', 680.0000, 'ºC'),
	(173272, 119, '2014-02-01 01:03:46.000000', 'temperatura', 691.0000, 'ºC'),
	(173273, 119, '2014-02-01 01:03:47.000000', 'temperatura', 215.0000, 'ºC'),
	(173274, 119, '2014-02-01 01:03:48.000000', 'temperatura', 203.0000, 'ºC'),
	(173275, 119, '2014-02-01 01:03:49.000000', 'temperatura', 369.0000, 'ºC'),
	(173276, 119, '2014-02-01 01:03:50.000000', 'temperatura', 37.0000, 'ºC'),
	(173277, 119, '2014-02-01 01:03:51.000000', 'temperatura', 278.0000, 'ºC'),
	(173278, 119, '2014-02-01 01:03:52.000000', 'temperatura', 79.0000, 'ºC'),
	(173279, 119, '2014-02-01 01:03:53.000000', 'temperatura', 764.0000, 'ºC'),
	(173280, 119, '2014-02-01 01:03:54.000000', 'temperatura', 1184.0000, 'ºC'),
	(173281, 119, '2014-02-01 01:03:55.000000', 'temperatura', 26.0000, 'ºC'),
	(173282, 119, '2014-02-01 01:03:56.000000', 'temperatura', 179.0000, 'ºC'),
	(173283, 119, '2014-02-01 01:03:57.000000', 'temperatura', 818.0000, 'ºC'),
	(173284, 119, '2014-02-01 01:03:58.000000', 'temperatura', 1154.0000, 'ºC'),
	(173285, 119, '2014-02-01 01:03:59.000000', 'temperatura', 917.0000, 'ºC'),
	(173286, 119, '2014-02-01 01:04:00.000000', 'temperatura', 1124.0000, 'ºC'),
	(173287, 119, '2014-02-01 01:04:01.000000', 'temperatura', 470.0000, 'ºC'),
	(173288, 119, '2014-02-01 01:04:02.000000', 'temperatura', 176.0000, 'ºC'),
	(173289, 119, '2014-02-01 01:04:03.000000', 'temperatura', 674.0000, 'ºC'),
	(173290, 119, '2014-02-01 01:04:04.000000', 'temperatura', 439.0000, 'ºC'),
	(173291, 119, '2014-02-01 01:04:05.000000', 'temperatura', 176.0000, 'ºC'),
	(173292, 119, '2014-02-01 01:04:06.000000', 'temperatura', 764.0000, 'ºC'),
	(173293, 119, '2014-02-01 01:04:07.000000', 'temperatura', 890.0000, 'ºC'),
	(173294, 119, '2014-02-01 01:04:08.000000', 'temperatura', 958.0000, 'ºC'),
	(173295, 119, '2014-02-01 01:04:09.000000', 'temperatura', 921.0000, 'ºC'),
	(173296, 119, '2014-02-01 01:04:10.000000', 'temperatura', 530.0000, 'ºC'),
	(173297, 119, '2014-02-01 01:04:11.000000', 'temperatura', 1090.0000, 'ºC'),
	(173298, 119, '2014-02-01 01:04:12.000000', 'temperatura', 260.0000, 'ºC'),
	(173299, 119, '2014-02-01 01:04:13.000000', 'temperatura', 432.0000, 'ºC'),
	(173300, 119, '2014-02-01 01:04:14.000000', 'temperatura', 179.0000, 'ºC'),
	(173301, 119, '2014-02-01 01:04:15.000000', 'temperatura', 799.0000, 'ºC'),
	(173302, 119, '2014-02-01 01:04:16.000000', 'temperatura', 1060.0000, 'ºC'),
	(173303, 119, '2014-02-01 01:04:17.000000', 'temperatura', 501.0000, 'ºC'),
	(173304, 119, '2014-02-01 01:04:18.000000', 'temperatura', 528.0000, 'ºC'),
	(173305, 119, '2014-02-01 01:04:19.000000', 'temperatura', 1138.0000, 'ºC'),
	(173306, 119, '2014-02-01 01:04:20.000000', 'temperatura', 506.0000, 'ºC'),
	(173307, 119, '2014-02-01 01:04:21.000000', 'temperatura', 317.0000, 'ºC'),
	(173308, 119, '2014-02-01 01:04:22.000000', 'temperatura', 68.0000, 'ºC'),
	(173309, 119, '2014-02-01 01:04:23.000000', 'temperatura', 587.0000, 'ºC'),
	(173310, 119, '2014-02-01 01:04:24.000000', 'temperatura', 332.0000, 'ºC'),
	(173311, 119, '2014-02-01 01:04:25.000000', 'temperatura', 1101.0000, 'ºC'),
	(173312, 119, '2014-02-01 01:04:26.000000', 'temperatura', 908.0000, 'ºC'),
	(173313, 119, '2014-02-01 01:04:27.000000', 'temperatura', 37.0000, 'ºC'),
	(173314, 119, '2014-02-01 01:04:28.000000', 'temperatura', 1062.0000, 'ºC'),
	(173315, 119, '2014-02-01 01:04:29.000000', 'temperatura', 401.0000, 'ºC'),
	(173316, 119, '2014-02-01 01:04:30.000000', 'temperatura', 19.0000, 'ºC'),
	(173317, 119, '2014-02-01 01:04:31.000000', 'temperatura', 91.0000, 'ºC'),
	(173318, 119, '2014-02-01 01:04:32.000000', 'temperatura', 399.0000, 'ºC'),
	(173319, 119, '2014-02-01 01:04:33.000000', 'temperatura', 522.0000, 'ºC'),
	(173320, 119, '2014-02-01 01:04:34.000000', 'temperatura', 214.0000, 'ºC'),
	(173321, 119, '2014-02-01 01:04:35.000000', 'temperatura', 706.0000, 'ºC'),
	(173322, 119, '2014-02-01 01:04:36.000000', 'temperatura', 485.0000, 'ºC'),
	(173323, 119, '2014-02-01 01:04:37.000000', 'temperatura', 311.0000, 'ºC'),
	(173324, 119, '2014-02-01 01:04:38.000000', 'temperatura', 99.0000, 'ºC'),
	(173325, 119, '2014-02-01 01:04:39.000000', 'temperatura', 763.0000, 'ºC'),
	(173326, 119, '2014-02-01 01:04:40.000000', 'temperatura', 1118.0000, 'ºC'),
	(173327, 119, '2014-02-01 01:04:41.000000', 'temperatura', 901.0000, 'ºC'),
	(173328, 119, '2014-02-01 01:04:42.000000', 'temperatura', 1151.0000, 'ºC'),
	(173329, 119, '2014-02-01 01:04:43.000000', 'temperatura', 653.0000, 'ºC'),
	(173330, 119, '2014-02-01 01:04:44.000000', 'temperatura', 1014.0000, 'ºC'),
	(173331, 119, '2014-02-01 01:04:45.000000', 'temperatura', 711.0000, 'ºC'),
	(173332, 119, '2014-02-01 01:04:46.000000', 'temperatura', 512.0000, 'ºC'),
	(173333, 119, '2014-02-01 01:04:47.000000', 'temperatura', 429.0000, 'ºC'),
	(173334, 119, '2014-02-01 01:04:48.000000', 'temperatura', 611.0000, 'ºC'),
	(173335, 119, '2014-02-01 01:04:49.000000', 'temperatura', 567.0000, 'ºC'),
	(173336, 119, '2014-02-01 01:04:50.000000', 'temperatura', 1003.0000, 'ºC'),
	(173337, 119, '2014-02-01 01:04:51.000000', 'temperatura', 913.0000, 'ºC'),
	(173338, 119, '2014-02-01 01:04:52.000000', 'temperatura', 358.0000, 'ºC'),
	(173339, 119, '2014-02-01 01:04:53.000000', 'temperatura', 250.0000, 'ºC'),
	(173340, 119, '2014-02-01 01:04:54.000000', 'temperatura', 179.0000, 'ºC'),
	(173341, 119, '2014-02-01 01:04:55.000000', 'temperatura', 144.0000, 'ºC'),
	(173342, 119, '2014-02-01 01:04:56.000000', 'temperatura', 182.0000, 'ºC'),
	(173343, 119, '2014-02-01 01:04:57.000000', 'temperatura', 481.0000, 'ºC'),
	(173344, 119, '2014-02-01 01:04:58.000000', 'temperatura', 659.0000, 'ºC'),
	(173345, 119, '2014-02-01 01:04:59.000000', 'temperatura', 653.0000, 'ºC'),
	(173346, 119, '2014-02-01 01:05:00.000000', 'temperatura', 88.0000, 'ºC'),
	(173347, 119, '2014-02-01 01:05:01.000000', 'temperatura', 881.0000, 'ºC'),
	(173348, 119, '2014-02-01 01:05:02.000000', 'temperatura', 540.0000, 'ºC'),
	(173349, 119, '2014-02-01 01:05:03.000000', 'temperatura', 59.0000, 'ºC'),
	(173350, 119, '2014-02-01 01:05:04.000000', 'temperatura', 1076.0000, 'ºC'),
	(173351, 119, '2014-02-01 01:05:05.000000', 'temperatura', 402.0000, 'ºC'),
	(173352, 119, '2014-02-01 01:05:06.000000', 'temperatura', 1182.0000, 'ºC'),
	(173353, 119, '2014-02-01 01:05:07.000000', 'temperatura', 1106.0000, 'ºC'),
	(173354, 119, '2014-02-01 01:05:08.000000', 'temperatura', 786.0000, 'ºC'),
	(173355, 119, '2014-02-01 01:05:09.000000', 'temperatura', 610.0000, 'ºC'),
	(173356, 119, '2014-02-01 01:05:10.000000', 'temperatura', 695.0000, 'ºC'),
	(173357, 119, '2014-02-01 01:05:11.000000', 'temperatura', 445.0000, 'ºC'),
	(173358, 119, '2014-02-01 01:05:12.000000', 'temperatura', 140.0000, 'ºC'),
	(173359, 119, '2014-02-01 01:05:13.000000', 'temperatura', 565.0000, 'ºC'),
	(173360, 119, '2014-02-01 01:05:14.000000', 'temperatura', 6.0000, 'ºC'),
	(173361, 119, '2014-02-01 01:05:15.000000', 'temperatura', 735.0000, 'ºC'),
	(173362, 119, '2014-02-01 01:05:16.000000', 'temperatura', 59.0000, 'ºC'),
	(173363, 119, '2014-02-01 01:05:17.000000', 'temperatura', 488.0000, 'ºC'),
	(173364, 119, '2014-02-01 01:05:18.000000', 'temperatura', 1066.0000, 'ºC'),
	(173365, 119, '2014-02-01 01:05:19.000000', 'temperatura', 265.0000, 'ºC'),
	(173366, 119, '2014-02-01 01:05:20.000000', 'temperatura', 527.0000, 'ºC'),
	(173367, 119, '2014-02-01 01:05:21.000000', 'temperatura', 642.0000, 'ºC'),
	(173368, 119, '2014-02-01 01:05:22.000000', 'temperatura', 429.0000, 'ºC'),
	(173369, 119, '2014-02-01 01:05:23.000000', 'temperatura', 218.0000, 'ºC'),
	(173370, 119, '2014-02-01 01:05:24.000000', 'temperatura', 1005.0000, 'ºC'),
	(173371, 119, '2014-02-01 01:05:25.000000', 'temperatura', 771.0000, 'ºC'),
	(173372, 119, '2014-02-01 01:05:26.000000', 'temperatura', 839.0000, 'ºC'),
	(173373, 119, '2014-02-01 01:05:27.000000', 'temperatura', 683.0000, 'ºC'),
	(173374, 119, '2014-02-01 01:05:28.000000', 'temperatura', 900.0000, 'ºC'),
	(173375, 119, '2014-02-01 01:05:29.000000', 'temperatura', 49.0000, 'ºC'),
	(173376, 119, '2014-02-01 01:05:30.000000', 'temperatura', 1146.0000, 'ºC'),
	(173377, 119, '2014-02-01 01:05:31.000000', 'temperatura', 783.0000, 'ºC'),
	(173378, 119, '2014-02-01 01:05:32.000000', 'temperatura', 479.0000, 'ºC'),
	(173379, 119, '2014-02-01 01:05:33.000000', 'temperatura', 48.0000, 'ºC'),
	(173380, 119, '2014-02-01 01:05:34.000000', 'temperatura', 2.0000, 'ºC'),
	(173381, 119, '2014-02-01 01:05:35.000000', 'temperatura', 1068.0000, 'ºC'),
	(173382, 119, '2014-02-01 01:05:36.000000', 'temperatura', 532.0000, 'ºC'),
	(173383, 119, '2014-02-01 01:05:37.000000', 'temperatura', 657.0000, 'ºC'),
	(173384, 119, '2014-02-01 01:05:38.000000', 'temperatura', 490.0000, 'ºC'),
	(173385, 119, '2014-02-01 01:05:39.000000', 'temperatura', 478.0000, 'ºC'),
	(173386, 119, '2014-02-01 01:05:40.000000', 'temperatura', 923.0000, 'ºC'),
	(173387, 119, '2014-02-01 01:05:41.000000', 'temperatura', 782.0000, 'ºC'),
	(173388, 119, '2014-02-01 01:05:42.000000', 'temperatura', 1139.0000, 'ºC'),
	(173389, 119, '2014-02-01 01:05:43.000000', 'temperatura', 949.0000, 'ºC'),
	(173390, 119, '2014-02-01 01:05:44.000000', 'temperatura', 131.0000, 'ºC'),
	(173391, 119, '2014-02-01 01:05:45.000000', 'temperatura', 208.0000, 'ºC'),
	(173392, 119, '2014-02-01 01:05:46.000000', 'temperatura', 646.0000, 'ºC'),
	(173393, 119, '2014-02-01 01:05:47.000000', 'temperatura', 207.0000, 'ºC'),
	(173394, 119, '2014-02-01 01:05:48.000000', 'temperatura', 300.0000, 'ºC'),
	(173395, 119, '2014-02-01 01:05:49.000000', 'temperatura', 877.0000, 'ºC'),
	(173396, 119, '2014-02-01 01:05:50.000000', 'temperatura', 1086.0000, 'ºC'),
	(173397, 119, '2014-02-01 01:05:51.000000', 'temperatura', 398.0000, 'ºC'),
	(173398, 119, '2014-02-01 01:05:52.000000', 'temperatura', 1133.0000, 'ºC'),
	(173399, 119, '2014-02-01 01:05:53.000000', 'temperatura', 872.0000, 'ºC'),
	(173400, 119, '2014-02-01 01:05:54.000000', 'temperatura', 960.0000, 'ºC'),
	(173401, 119, '2014-02-01 01:05:55.000000', 'temperatura', 987.0000, 'ºC'),
	(173402, 119, '2014-02-01 01:05:56.000000', 'temperatura', 856.0000, 'ºC'),
	(173403, 119, '2014-02-01 01:05:57.000000', 'temperatura', 118.0000, 'ºC'),
	(173404, 119, '2014-02-01 01:05:58.000000', 'temperatura', 424.0000, 'ºC'),
	(173405, 119, '2014-02-01 01:05:59.000000', 'temperatura', 565.0000, 'ºC'),
	(173406, 119, '2014-02-01 01:06:00.000000', 'temperatura', 354.0000, 'ºC'),
	(173407, 119, '2014-02-01 01:06:01.000000', 'temperatura', 76.0000, 'ºC'),
	(173408, 119, '2014-02-01 01:06:02.000000', 'temperatura', 518.0000, 'ºC'),
	(173409, 119, '2014-02-01 01:06:03.000000', 'temperatura', 1161.0000, 'ºC'),
	(173410, 119, '2014-02-01 01:06:04.000000', 'temperatura', 651.0000, 'ºC'),
	(173411, 119, '2014-02-01 01:06:05.000000', 'temperatura', 972.0000, 'ºC'),
	(173412, 119, '2014-02-01 01:06:06.000000', 'temperatura', 509.0000, 'ºC'),
	(173413, 119, '2014-02-01 01:06:07.000000', 'temperatura', 829.0000, 'ºC'),
	(173414, 119, '2014-02-01 01:06:08.000000', 'temperatura', 221.0000, 'ºC'),
	(173415, 119, '2014-02-01 01:06:09.000000', 'temperatura', 1016.0000, 'ºC'),
	(173416, 119, '2014-02-01 01:06:10.000000', 'temperatura', 818.0000, 'ºC'),
	(173417, 119, '2014-02-01 01:06:11.000000', 'temperatura', 1042.0000, 'ºC'),
	(173418, 119, '2014-02-01 01:06:12.000000', 'temperatura', 356.0000, 'ºC'),
	(173419, 119, '2014-02-01 01:06:13.000000', 'temperatura', 1057.0000, 'ºC'),
	(173420, 119, '2014-02-01 01:06:14.000000', 'temperatura', 617.0000, 'ºC'),
	(173421, 119, '2014-02-01 01:06:15.000000', 'temperatura', 1114.0000, 'ºC'),
	(173422, 119, '2014-02-01 01:06:16.000000', 'temperatura', 119.0000, 'ºC'),
	(173423, 119, '2014-02-01 01:06:17.000000', 'temperatura', 853.0000, 'ºC'),
	(173424, 119, '2014-02-01 01:06:18.000000', 'temperatura', 311.0000, 'ºC'),
	(173425, 119, '2014-02-01 01:06:19.000000', 'temperatura', 195.0000, 'ºC'),
	(173426, 119, '2014-02-01 01:06:20.000000', 'temperatura', 42.0000, 'ºC'),
	(173427, 119, '2014-02-01 01:06:21.000000', 'temperatura', 827.0000, 'ºC'),
	(173428, 119, '2014-02-01 01:06:22.000000', 'temperatura', 409.0000, 'ºC'),
	(173429, 119, '2014-02-01 01:06:23.000000', 'temperatura', 766.0000, 'ºC'),
	(173430, 119, '2014-02-01 01:06:24.000000', 'temperatura', 204.0000, 'ºC'),
	(173431, 119, '2014-02-01 01:06:25.000000', 'temperatura', 1123.0000, 'ºC'),
	(173432, 119, '2014-02-01 01:06:26.000000', 'temperatura', 202.0000, 'ºC'),
	(173433, 119, '2014-02-01 01:06:27.000000', 'temperatura', 43.0000, 'ºC'),
	(173434, 119, '2014-02-01 01:06:28.000000', 'temperatura', 807.0000, 'ºC'),
	(173435, 119, '2014-02-01 01:06:29.000000', 'temperatura', 309.0000, 'ºC'),
	(173436, 119, '2014-02-01 01:06:30.000000', 'temperatura', 325.0000, 'ºC'),
	(173437, 119, '2014-02-01 01:06:31.000000', 'temperatura', 698.0000, 'ºC'),
	(173438, 119, '2014-02-01 01:06:32.000000', 'temperatura', 116.0000, 'ºC'),
	(173439, 119, '2014-02-01 01:06:33.000000', 'temperatura', 884.0000, 'ºC'),
	(173440, 119, '2014-02-01 01:06:34.000000', 'temperatura', 475.0000, 'ºC'),
	(173441, 119, '2014-02-01 01:06:35.000000', 'temperatura', 923.0000, 'ºC'),
	(173442, 119, '2014-02-01 01:06:36.000000', 'temperatura', 790.0000, 'ºC'),
	(173443, 119, '2014-02-01 01:06:37.000000', 'temperatura', 1181.0000, 'ºC'),
	(173444, 119, '2014-02-01 01:06:38.000000', 'temperatura', 1138.0000, 'ºC'),
	(173445, 119, '2014-02-01 01:06:39.000000', 'temperatura', 944.0000, 'ºC'),
	(173446, 119, '2014-02-01 01:06:40.000000', 'temperatura', 109.0000, 'ºC'),
	(173447, 119, '2014-02-01 01:06:41.000000', 'temperatura', 112.0000, 'ºC'),
	(173448, 119, '2014-02-01 01:06:42.000000', 'temperatura', 233.0000, 'ºC'),
	(173449, 119, '2014-02-01 01:06:43.000000', 'temperatura', 830.0000, 'ºC'),
	(173450, 119, '2014-02-01 01:06:44.000000', 'temperatura', 1054.0000, 'ºC'),
	(173451, 119, '2014-02-01 01:06:45.000000', 'temperatura', 377.0000, 'ºC'),
	(173452, 119, '2014-02-01 01:06:46.000000', 'temperatura', 1124.0000, 'ºC'),
	(173453, 119, '2014-02-01 01:06:47.000000', 'temperatura', 889.0000, 'ºC'),
	(173454, 119, '2014-02-01 01:06:48.000000', 'temperatura', 1076.0000, 'ºC'),
	(173455, 119, '2014-02-01 01:06:49.000000', 'temperatura', 313.0000, 'ºC'),
	(173456, 119, '2014-02-01 01:06:50.000000', 'temperatura', 737.0000, 'ºC'),
	(173457, 119, '2014-02-01 01:06:51.000000', 'temperatura', 344.0000, 'ºC'),
	(173458, 119, '2014-02-01 01:06:52.000000', 'temperatura', 713.0000, 'ºC'),
	(173459, 119, '2014-02-01 01:06:53.000000', 'temperatura', 133.0000, 'ºC'),
	(173460, 119, '2014-02-01 01:06:54.000000', 'temperatura', 925.0000, 'ºC'),
	(173461, 119, '2014-02-01 01:06:55.000000', 'temperatura', 625.0000, 'ºC'),
	(173462, 119, '2014-02-01 01:06:56.000000', 'temperatura', 353.0000, 'ºC'),
	(173463, 119, '2014-02-01 01:06:57.000000', 'temperatura', 1090.0000, 'ºC'),
	(173464, 119, '2014-02-01 01:06:58.000000', 'temperatura', 789.0000, 'ºC'),
	(173465, 119, '2014-02-01 01:06:59.000000', 'temperatura', 678.0000, 'ºC'),
	(173466, 119, '2014-02-01 01:07:00.000000', 'temperatura', 1024.0000, 'ºC'),
	(173467, 119, '2014-02-01 01:07:01.000000', 'temperatura', 686.0000, 'ºC'),
	(173468, 119, '2014-02-01 01:07:02.000000', 'temperatura', 356.0000, 'ºC'),
	(173469, 119, '2014-02-01 01:07:03.000000', 'temperatura', 926.0000, 'ºC'),
	(173470, 119, '2014-02-01 01:07:04.000000', 'temperatura', 1161.0000, 'ºC'),
	(173471, 119, '2014-02-01 01:07:05.000000', 'temperatura', 626.0000, 'ºC'),
	(173472, 119, '2014-02-01 01:07:06.000000', 'temperatura', 847.0000, 'ºC'),
	(173473, 119, '2014-02-01 01:07:07.000000', 'temperatura', 1157.0000, 'ºC'),
	(173474, 119, '2014-02-01 01:07:08.000000', 'temperatura', 845.0000, 'ºC'),
	(173475, 119, '2014-02-01 01:07:09.000000', 'temperatura', 757.0000, 'ºC'),
	(173476, 119, '2014-02-01 01:07:10.000000', 'temperatura', 48.0000, 'ºC'),
	(173477, 119, '2014-02-01 01:07:11.000000', 'temperatura', 371.0000, 'ºC'),
	(173478, 119, '2014-02-01 01:07:12.000000', 'temperatura', 512.0000, 'ºC'),
	(173479, 119, '2014-02-01 01:07:13.000000', 'temperatura', 249.0000, 'ºC'),
	(173480, 119, '2014-02-01 01:07:14.000000', 'temperatura', 907.0000, 'ºC'),
	(173481, 119, '2014-02-01 01:07:15.000000', 'temperatura', 190.0000, 'ºC'),
	(173482, 119, '2014-02-01 01:07:16.000000', 'temperatura', 631.0000, 'ºC'),
	(173483, 119, '2014-02-01 01:07:17.000000', 'temperatura', 183.0000, 'ºC'),
	(173484, 119, '2014-02-01 01:07:18.000000', 'temperatura', 221.0000, 'ºC'),
	(173485, 119, '2014-02-01 01:07:19.000000', 'temperatura', 558.0000, 'ºC'),
	(173486, 119, '2014-02-01 01:07:20.000000', 'temperatura', 930.0000, 'ºC'),
	(173487, 119, '2014-02-01 01:07:21.000000', 'temperatura', 573.0000, 'ºC'),
	(173488, 119, '2014-02-01 01:07:22.000000', 'temperatura', 78.0000, 'ºC'),
	(173489, 119, '2014-02-01 01:07:23.000000', 'temperatura', 1071.0000, 'ºC'),
	(173490, 119, '2014-02-01 01:07:24.000000', 'temperatura', 323.0000, 'ºC'),
	(173491, 119, '2014-02-01 01:07:25.000000', 'temperatura', 801.0000, 'ºC'),
	(173492, 119, '2014-02-01 01:07:26.000000', 'temperatura', 638.0000, 'ºC'),
	(173493, 119, '2014-02-01 01:07:27.000000', 'temperatura', 787.0000, 'ºC'),
	(173494, 119, '2014-02-01 01:07:28.000000', 'temperatura', 823.0000, 'ºC'),
	(173495, 119, '2014-02-01 01:07:29.000000', 'temperatura', 553.0000, 'ºC'),
	(173496, 119, '2014-02-01 01:07:30.000000', 'temperatura', 297.0000, 'ºC'),
	(173497, 119, '2014-02-01 01:07:31.000000', 'temperatura', 1027.0000, 'ºC'),
	(173498, 119, '2014-02-01 01:07:32.000000', 'temperatura', 642.0000, 'ºC'),
	(173499, 119, '2014-02-01 01:07:33.000000', 'temperatura', 131.0000, 'ºC'),
	(173500, 119, '2014-02-01 01:07:34.000000', 'temperatura', 1130.0000, 'ºC'),
	(173501, 119, '2014-02-01 01:07:35.000000', 'temperatura', 458.0000, 'ºC'),
	(173502, 119, '2014-02-01 01:07:36.000000', 'temperatura', 100.0000, 'ºC'),
	(173503, 119, '2014-02-01 01:07:37.000000', 'temperatura', 326.0000, 'ºC'),
	(173504, 119, '2014-02-01 01:07:38.000000', 'temperatura', 132.0000, 'ºC'),
	(173505, 119, '2014-02-01 01:07:39.000000', 'temperatura', 884.0000, 'ºC'),
	(173506, 119, '2014-02-01 01:07:40.000000', 'temperatura', 422.0000, 'ºC'),
	(173507, 119, '2014-02-01 01:07:41.000000', 'temperatura', 659.0000, 'ºC'),
	(173508, 119, '2014-02-01 01:07:42.000000', 'temperatura', 828.0000, 'ºC'),
	(173509, 119, '2014-02-01 01:07:43.000000', 'temperatura', 964.0000, 'ºC'),
	(173510, 119, '2014-02-01 01:07:44.000000', 'temperatura', 1136.0000, 'ºC'),
	(173511, 119, '2014-02-01 01:07:45.000000', 'temperatura', 389.0000, 'ºC'),
	(173512, 119, '2014-02-01 01:07:46.000000', 'temperatura', 938.0000, 'ºC'),
	(173513, 119, '2014-02-01 01:07:47.000000', 'temperatura', 1122.0000, 'ºC'),
	(173514, 119, '2014-02-01 01:07:48.000000', 'temperatura', 399.0000, 'ºC'),
	(173515, 119, '2014-02-01 01:07:49.000000', 'temperatura', 1030.0000, 'ºC'),
	(173516, 119, '2014-02-01 01:07:50.000000', 'temperatura', 352.0000, 'ºC'),
	(173517, 119, '2014-02-01 01:07:51.000000', 'temperatura', 1073.0000, 'ºC'),
	(173518, 119, '2014-02-01 01:07:52.000000', 'temperatura', 706.0000, 'ºC'),
	(173519, 119, '2014-02-01 01:07:53.000000', 'temperatura', 313.0000, 'ºC'),
	(173520, 119, '2014-02-01 01:07:54.000000', 'temperatura', 648.0000, 'ºC'),
	(173521, 119, '2014-02-01 01:07:55.000000', 'temperatura', 1101.0000, 'ºC'),
	(173522, 119, '2014-02-01 01:07:56.000000', 'temperatura', 1161.0000, 'ºC'),
	(173523, 119, '2014-02-01 01:07:57.000000', 'temperatura', 102.0000, 'ºC'),
	(173524, 119, '2014-02-01 01:07:58.000000', 'temperatura', 627.0000, 'ºC'),
	(173525, 119, '2014-02-01 01:07:59.000000', 'temperatura', 430.0000, 'ºC'),
	(173526, 119, '2014-02-01 01:08:00.000000', 'temperatura', 270.0000, 'ºC'),
	(173527, 119, '2014-02-01 01:08:01.000000', 'temperatura', 62.0000, 'ºC'),
	(173528, 119, '2014-02-01 01:08:02.000000', 'temperatura', 699.0000, 'ºC'),
	(173529, 119, '2014-02-01 01:08:03.000000', 'temperatura', 911.0000, 'ºC'),
	(173530, 119, '2014-02-01 01:08:04.000000', 'temperatura', 60.0000, 'ºC'),
	(173531, 119, '2014-02-01 01:08:05.000000', 'temperatura', 1164.0000, 'ºC'),
	(173532, 119, '2014-02-01 01:08:06.000000', 'temperatura', 843.0000, 'ºC'),
	(173533, 119, '2014-02-01 01:08:07.000000', 'temperatura', 724.0000, 'ºC'),
	(173534, 119, '2014-02-01 01:08:08.000000', 'temperatura', 1091.0000, 'ºC'),
	(173535, 119, '2014-02-01 01:08:09.000000', 'temperatura', 883.0000, 'ºC'),
	(173536, 119, '2014-02-01 01:08:10.000000', 'temperatura', 1144.0000, 'ºC'),
	(173537, 119, '2014-02-01 01:08:11.000000', 'temperatura', 670.0000, 'ºC'),
	(173538, 119, '2014-02-01 01:08:12.000000', 'temperatura', 1118.0000, 'ºC'),
	(173539, 119, '2014-02-01 01:08:13.000000', 'temperatura', 1180.0000, 'ºC'),
	(173540, 119, '2014-02-01 01:08:14.000000', 'temperatura', 149.0000, 'ºC'),
	(173541, 119, '2014-02-01 01:08:15.000000', 'temperatura', 803.0000, 'ºC'),
	(173542, 119, '2014-02-01 01:08:16.000000', 'temperatura', 1170.0000, 'ºC'),
	(173543, 119, '2014-02-01 01:08:17.000000', 'temperatura', 1040.0000, 'ºC'),
	(173544, 119, '2014-02-01 01:08:18.000000', 'temperatura', 489.0000, 'ºC'),
	(173545, 119, '2014-02-01 01:08:19.000000', 'temperatura', 529.0000, 'ºC'),
	(173546, 119, '2014-02-01 01:08:20.000000', 'temperatura', 1178.0000, 'ºC'),
	(173547, 119, '2014-02-01 01:08:21.000000', 'temperatura', 701.0000, 'ºC'),
	(173548, 119, '2014-02-01 01:08:22.000000', 'temperatura', 1175.0000, 'ºC'),
	(173549, 119, '2014-02-01 01:08:23.000000', 'temperatura', 169.0000, 'ºC'),
	(173550, 119, '2014-02-01 01:08:24.000000', 'temperatura', 923.0000, 'ºC'),
	(173551, 119, '2014-02-01 01:08:25.000000', 'temperatura', 508.0000, 'ºC'),
	(173552, 119, '2014-02-01 01:08:26.000000', 'temperatura', 973.0000, 'ºC'),
	(173553, 119, '2014-02-01 01:08:27.000000', 'temperatura', 940.0000, 'ºC'),
	(173554, 119, '2014-02-01 01:08:28.000000', 'temperatura', 583.0000, 'ºC'),
	(173555, 119, '2014-02-01 01:08:29.000000', 'temperatura', 96.0000, 'ºC'),
	(173556, 119, '2014-02-01 01:08:30.000000', 'temperatura', 1131.0000, 'ºC'),
	(173557, 119, '2014-02-01 01:08:31.000000', 'temperatura', 566.0000, 'ºC'),
	(173558, 119, '2014-02-01 01:08:32.000000', 'temperatura', 638.0000, 'ºC'),
	(173559, 119, '2014-02-01 01:08:33.000000', 'temperatura', 293.0000, 'ºC'),
	(173560, 119, '2014-02-01 01:08:34.000000', 'temperatura', 750.0000, 'ºC'),
	(173561, 119, '2014-02-01 01:08:35.000000', 'temperatura', 471.0000, 'ºC'),
	(173562, 119, '2014-02-01 01:08:36.000000', 'temperatura', 108.0000, 'ºC'),
	(173563, 119, '2014-02-01 01:08:37.000000', 'temperatura', 325.0000, 'ºC'),
	(173564, 119, '2014-02-01 01:08:38.000000', 'temperatura', 102.0000, 'ºC'),
	(173565, 119, '2014-02-01 01:08:39.000000', 'temperatura', 734.0000, 'ºC'),
	(173566, 119, '2014-02-01 01:08:40.000000', 'temperatura', 967.0000, 'ºC'),
	(173567, 119, '2014-02-01 01:08:41.000000', 'temperatura', 232.0000, 'ºC'),
	(173568, 119, '2014-02-01 01:08:42.000000', 'temperatura', 658.0000, 'ºC'),
	(173569, 119, '2014-02-01 01:08:43.000000', 'temperatura', 196.0000, 'ºC'),
	(173570, 119, '2014-02-01 01:08:44.000000', 'temperatura', 204.0000, 'ºC'),
	(173571, 119, '2014-02-01 01:08:45.000000', 'temperatura', 436.0000, 'ºC'),
	(173572, 119, '2014-02-01 01:08:46.000000', 'temperatura', 367.0000, 'ºC'),
	(173573, 119, '2014-02-01 01:08:47.000000', 'temperatura', 526.0000, 'ºC'),
	(173574, 119, '2014-02-01 01:08:48.000000', 'temperatura', 330.0000, 'ºC'),
	(173575, 119, '2014-02-01 01:08:49.000000', 'temperatura', 74.0000, 'ºC'),
	(173576, 119, '2014-02-01 01:08:50.000000', 'temperatura', 578.0000, 'ºC'),
	(173577, 119, '2014-02-01 01:08:51.000000', 'temperatura', 271.0000, 'ºC'),
	(173578, 119, '2014-02-01 01:08:52.000000', 'temperatura', 820.0000, 'ºC'),
	(173579, 119, '2014-02-01 01:08:53.000000', 'temperatura', 890.0000, 'ºC'),
	(173580, 119, '2014-02-01 01:08:54.000000', 'temperatura', 788.0000, 'ºC'),
	(173581, 119, '2014-02-01 01:08:55.000000', 'temperatura', 73.0000, 'ºC'),
	(173582, 119, '2014-02-01 01:08:56.000000', 'temperatura', 399.0000, 'ºC'),
	(173583, 119, '2014-02-01 01:08:57.000000', 'temperatura', 579.0000, 'ºC'),
	(173584, 119, '2014-02-01 01:08:58.000000', 'temperatura', 496.0000, 'ºC'),
	(173585, 119, '2014-02-01 01:08:59.000000', 'temperatura', 746.0000, 'ºC'),
	(173586, 119, '2014-02-01 01:09:00.000000', 'temperatura', 1043.0000, 'ºC'),
	(173587, 119, '2014-02-01 01:09:01.000000', 'temperatura', 578.0000, 'ºC'),
	(173588, 119, '2014-02-01 01:09:02.000000', 'temperatura', 960.0000, 'ºC'),
	(173589, 119, '2014-02-01 01:09:03.000000', 'temperatura', 667.0000, 'ºC'),
	(173590, 119, '2014-02-01 01:09:04.000000', 'temperatura', 456.0000, 'ºC'),
	(173591, 119, '2014-02-01 01:09:05.000000', 'temperatura', 281.0000, 'ºC'),
	(173592, 119, '2014-02-01 01:09:06.000000', 'temperatura', 36.0000, 'ºC'),
	(173593, 119, '2014-02-01 01:09:07.000000', 'temperatura', 539.0000, 'ºC'),
	(173594, 119, '2014-02-01 01:09:08.000000', 'temperatura', 185.0000, 'ºC'),
	(173595, 119, '2014-02-01 01:09:09.000000', 'temperatura', 509.0000, 'ºC'),
	(173596, 119, '2014-02-01 01:09:10.000000', 'temperatura', 791.0000, 'ºC'),
	(173597, 119, '2014-02-01 01:09:11.000000', 'temperatura', 29.0000, 'ºC'),
	(173598, 119, '2014-02-01 01:09:12.000000', 'temperatura', 170.0000, 'ºC'),
	(173599, 119, '2014-02-01 01:09:13.000000', 'temperatura', 766.0000, 'ºC'),
	(173600, 119, '2014-02-01 01:09:14.000000', 'temperatura', 919.0000, 'ºC'),
	(173601, 119, '2014-02-01 01:09:15.000000', 'temperatura', 1097.0000, 'ºC'),
	(173602, 119, '2014-02-01 01:09:16.000000', 'temperatura', 328.0000, 'ºC'),
	(173603, 119, '2014-02-01 01:09:17.000000', 'temperatura', 749.0000, 'ºC'),
	(173604, 119, '2014-02-01 01:09:18.000000', 'temperatura', 362.0000, 'ºC'),
	(173605, 119, '2014-02-01 01:09:19.000000', 'temperatura', 763.0000, 'ºC'),
	(173606, 119, '2014-02-01 01:09:20.000000', 'temperatura', 332.0000, 'ºC'),
	(173607, 119, '2014-02-01 01:09:21.000000', 'temperatura', 569.0000, 'ºC'),
	(173608, 119, '2014-02-01 01:09:22.000000', 'temperatura', 649.0000, 'ºC'),
	(173609, 119, '2014-02-01 01:09:23.000000', 'temperatura', 340.0000, 'ºC'),
	(173610, 119, '2014-02-01 01:09:24.000000', 'temperatura', 952.0000, 'ºC'),
	(173611, 119, '2014-02-01 01:09:25.000000', 'temperatura', 142.0000, 'ºC'),
	(173612, 119, '2014-02-01 01:09:26.000000', 'temperatura', 252.0000, 'ºC'),
	(173613, 119, '2014-02-01 01:09:27.000000', 'temperatura', 836.0000, 'ºC'),
	(173614, 119, '2014-02-01 01:09:28.000000', 'temperatura', 1025.0000, 'ºC'),
	(173615, 119, '2014-02-01 01:09:29.000000', 'temperatura', 218.0000, 'ºC'),
	(173616, 119, '2014-02-01 01:09:30.000000', 'temperatura', 416.0000, 'ºC'),
	(173617, 119, '2014-02-01 01:09:31.000000', 'temperatura', 226.0000, 'ºC'),
	(173618, 119, '2014-02-01 01:09:32.000000', 'temperatura', 1083.0000, 'ºC'),
	(173619, 119, '2014-02-01 01:09:33.000000', 'temperatura', 1136.0000, 'ºC'),
	(173620, 119, '2014-02-01 01:09:34.000000', 'temperatura', 31.0000, 'ºC'),
	(173621, 119, '2014-02-01 01:09:35.000000', 'temperatura', 349.0000, 'ºC'),
	(173622, 119, '2014-02-01 01:09:36.000000', 'temperatura', 450.0000, 'ºC'),
	(173623, 119, '2014-02-01 01:09:37.000000', 'temperatura', 7.0000, 'ºC'),
	(173624, 119, '2014-02-01 01:09:38.000000', 'temperatura', 1083.0000, 'ºC'),
	(173625, 119, '2014-02-01 01:09:39.000000', 'temperatura', 595.0000, 'ºC'),
	(173626, 119, '2014-02-01 01:09:40.000000', 'temperatura', 928.0000, 'ºC'),
	(173627, 119, '2014-02-01 01:09:41.000000', 'temperatura', 457.0000, 'ºC'),
	(173628, 119, '2014-02-01 01:09:42.000000', 'temperatura', 698.0000, 'ºC'),
	(173629, 119, '2014-02-01 01:09:43.000000', 'temperatura', 922.0000, 'ºC'),
	(173630, 119, '2014-02-01 01:09:44.000000', 'temperatura', 113.0000, 'ºC'),
	(173631, 119, '2014-02-01 01:09:45.000000', 'temperatura', 203.0000, 'ºC'),
	(173632, 119, '2014-02-01 01:09:46.000000', 'temperatura', 677.0000, 'ºC'),
	(173633, 119, '2014-02-01 01:09:47.000000', 'temperatura', 377.0000, 'ºC'),
	(173634, 119, '2014-02-01 01:09:48.000000', 'temperatura', 1054.0000, 'ºC'),
	(173635, 119, '2014-02-01 01:09:49.000000', 'temperatura', 540.0000, 'ºC'),
	(173636, 119, '2014-02-01 01:09:50.000000', 'temperatura', 737.0000, 'ºC'),
	(173637, 119, '2014-02-01 01:09:51.000000', 'temperatura', 868.0000, 'ºC'),
	(173638, 119, '2014-02-01 01:09:52.000000', 'temperatura', 929.0000, 'ºC'),
	(173639, 119, '2014-02-01 01:09:53.000000', 'temperatura', 840.0000, 'ºC'),
	(173640, 119, '2014-02-01 01:09:54.000000', 'temperatura', 214.0000, 'ºC'),
	(173641, 119, '2014-02-01 01:09:55.000000', 'temperatura', 950.0000, 'ºC'),
	(173642, 119, '2014-02-01 01:09:56.000000', 'temperatura', 510.0000, 'ºC'),
	(173643, 119, '2014-02-01 01:09:57.000000', 'temperatura', 898.0000, 'ºC'),
	(173644, 119, '2014-02-01 01:09:58.000000', 'temperatura', 563.0000, 'ºC'),
	(173645, 119, '2014-02-01 01:09:59.000000', 'temperatura', 119.0000, 'ºC'),
	(173646, 119, '2014-02-01 01:10:00.000000', 'temperatura', 109.0000, 'ºC'),
	(173647, 119, '2014-02-01 01:10:01.000000', 'temperatura', 189.0000, 'ºC'),
	(173648, 119, '2014-02-01 01:10:02.000000', 'temperatura', 617.0000, 'ºC'),
	(173649, 119, '2014-02-01 01:10:03.000000', 'temperatura', 118.0000, 'ºC'),
	(173650, 119, '2014-02-01 01:10:04.000000', 'temperatura', 1141.0000, 'ºC'),
	(173651, 119, '2014-02-01 01:10:05.000000', 'temperatura', 549.0000, 'ºC'),
	(173652, 119, '2014-02-01 01:10:06.000000', 'temperatura', 524.0000, 'ºC'),
	(173653, 119, '2014-02-01 01:10:07.000000', 'temperatura', 972.0000, 'ºC'),
	(173654, 119, '2014-02-01 01:10:08.000000', 'temperatura', 888.0000, 'ºC'),
	(173655, 119, '2014-02-01 01:10:09.000000', 'temperatura', 327.0000, 'ºC'),
	(173656, 119, '2014-02-01 01:10:10.000000', 'temperatura', 169.0000, 'ºC'),
	(173657, 119, '2014-02-01 01:10:11.000000', 'temperatura', 1066.0000, 'ºC'),
	(173658, 119, '2014-02-01 01:10:12.000000', 'temperatura', 24.0000, 'ºC'),
	(173659, 119, '2014-02-01 01:10:13.000000', 'temperatura', 523.0000, 'ºC'),
	(173660, 119, '2014-02-01 01:10:14.000000', 'temperatura', 143.0000, 'ºC'),
	(173661, 119, '2014-02-01 01:10:15.000000', 'temperatura', 345.0000, 'ºC'),
	(173662, 119, '2014-02-01 01:10:16.000000', 'temperatura', 98.0000, 'ºC'),
	(173663, 119, '2014-02-01 01:10:17.000000', 'temperatura', 657.0000, 'ºC'),
	(173664, 119, '2014-02-01 01:10:18.000000', 'temperatura', 589.0000, 'ºC'),
	(173665, 119, '2014-02-01 01:10:19.000000', 'temperatura', 975.0000, 'ºC'),
	(173666, 119, '2014-02-01 01:10:20.000000', 'temperatura', 708.0000, 'ºC'),
	(173667, 119, '2014-02-01 01:10:21.000000', 'temperatura', 615.0000, 'ºC'),
	(173668, 119, '2014-02-01 01:10:22.000000', 'temperatura', 953.0000, 'ºC'),
	(173669, 119, '2014-02-01 01:10:23.000000', 'temperatura', 522.0000, 'ºC'),
	(173670, 119, '2014-02-01 01:10:24.000000', 'temperatura', 948.0000, 'ºC'),
	(173671, 119, '2014-02-01 01:10:25.000000', 'temperatura', 777.0000, 'ºC'),
	(173672, 119, '2014-02-01 01:10:26.000000', 'temperatura', 1040.0000, 'ºC'),
	(173673, 119, '2014-02-01 01:10:27.000000', 'temperatura', 469.0000, 'ºC'),
	(173674, 119, '2014-02-01 01:10:28.000000', 'temperatura', 424.0000, 'ºC'),
	(173675, 119, '2014-02-01 01:10:29.000000', 'temperatura', 716.0000, 'ºC'),
	(173676, 119, '2014-02-01 01:10:30.000000', 'temperatura', 1109.0000, 'ºC'),
	(173677, 119, '2014-02-01 01:10:31.000000', 'temperatura', 999.0000, 'ºC'),
	(173678, 119, '2014-02-01 01:10:32.000000', 'temperatura', 466.0000, 'ºC'),
	(173679, 119, '2014-02-01 01:10:33.000000', 'temperatura', 534.0000, 'ºC'),
	(173680, 119, '2014-02-01 01:10:34.000000', 'temperatura', 73.0000, 'ºC'),
	(173681, 119, '2014-02-01 01:10:35.000000', 'temperatura', 1162.0000, 'ºC'),
	(173682, 119, '2014-02-01 01:10:36.000000', 'temperatura', 792.0000, 'ºC'),
	(173683, 119, '2014-02-01 01:10:37.000000', 'temperatura', 475.0000, 'ºC'),
	(173684, 119, '2014-02-01 01:10:38.000000', 'temperatura', 0.0000, 'ºC'),
	(173685, 119, '2014-02-01 01:10:39.000000', 'temperatura', 974.0000, 'ºC'),
	(173686, 119, '2014-02-01 01:10:40.000000', 'temperatura', 69.0000, 'ºC'),
	(173687, 119, '2014-02-01 01:10:41.000000', 'temperatura', 1027.0000, 'ºC'),
	(173688, 119, '2014-02-01 01:10:42.000000', 'temperatura', 126.0000, 'ºC'),
	(173689, 119, '2014-02-01 01:10:43.000000', 'temperatura', 1148.0000, 'ºC'),
	(173690, 119, '2014-02-01 01:10:44.000000', 'temperatura', 566.0000, 'ºC'),
	(173691, 119, '2014-02-01 01:10:45.000000', 'temperatura', 586.0000, 'ºC'),
	(173692, 119, '2014-02-01 01:10:46.000000', 'temperatura', 31.0000, 'ºC'),
	(173693, 119, '2014-02-01 01:10:47.000000', 'temperatura', 798.0000, 'ºC'),
	(173694, 119, '2014-02-01 01:10:48.000000', 'temperatura', 299.0000, 'ºC'),
	(173695, 119, '2014-02-01 01:10:49.000000', 'temperatura', 299.0000, 'ºC'),
	(173696, 119, '2014-02-01 01:10:50.000000', 'temperatura', 599.0000, 'ºC'),
	(173697, 119, '2014-02-01 01:10:51.000000', 'temperatura', 898.0000, 'ºC'),
	(173698, 119, '2014-02-01 01:10:52.000000', 'temperatura', 293.0000, 'ºC'),
	(173699, 119, '2014-02-01 01:10:53.000000', 'temperatura', 1171.0000, 'ºC'),
	(173700, 119, '2014-02-01 01:10:54.000000', 'temperatura', 176.0000, 'ºC'),
	(173701, 119, '2014-02-01 01:10:55.000000', 'temperatura', 970.0000, 'ºC'),
	(173702, 119, '2014-02-01 01:10:56.000000', 'temperatura', 719.0000, 'ºC'),
	(173703, 119, '2014-02-01 01:10:57.000000', 'temperatura', 689.0000, 'ºC'),
	(173704, 119, '2014-02-01 01:10:58.000000', 'temperatura', 86.0000, 'ºC'),
	(173705, 119, '2014-02-01 01:10:59.000000', 'temperatura', 764.0000, 'ºC'),
	(173706, 119, '2014-02-01 01:11:00.000000', 'temperatura', 1161.0000, 'ºC'),
	(173707, 119, '2014-02-01 01:11:01.000000', 'temperatura', 1114.0000, 'ºC'),
	(173708, 119, '2014-02-01 01:11:02.000000', 'temperatura', 887.0000, 'ºC'),
	(173709, 119, '2014-02-01 01:11:03.000000', 'temperatura', 1094.0000, 'ºC'),
	(173710, 119, '2014-02-01 01:11:04.000000', 'temperatura', 408.0000, 'ºC'),
	(173711, 119, '2014-02-01 01:11:05.000000', 'temperatura', 1160.0000, 'ºC'),
	(173712, 119, '2014-02-01 01:11:06.000000', 'temperatura', 977.0000, 'ºC'),
	(173713, 119, '2014-02-01 01:11:07.000000', 'temperatura', 205.0000, 'ºC'),
	(173714, 119, '2014-02-01 01:11:08.000000', 'temperatura', 496.0000, 'ºC'),
	(173715, 119, '2014-02-01 01:11:09.000000', 'temperatura', 666.0000, 'ºC'),
	(173716, 119, '2014-02-01 01:11:10.000000', 'temperatura', 641.0000, 'ºC'),
	(173717, 119, '2014-02-01 01:11:11.000000', 'temperatura', 7.0000, 'ºC'),
	(173718, 119, '2014-02-01 01:11:12.000000', 'temperatura', 511.0000, 'ºC'),
	(173719, 119, '2014-02-01 01:11:13.000000', 'temperatura', 136.0000, 'ºC'),
	(173720, 119, '2014-02-01 01:11:14.000000', 'temperatura', 349.0000, 'ºC'),
	(173721, 119, '2014-02-01 01:11:15.000000', 'temperatura', 136.0000, 'ºC'),
	(173722, 119, '2014-02-01 01:11:16.000000', 'temperatura', 834.0000, 'ºC'),
	(173723, 119, '2014-02-01 01:11:17.000000', 'temperatura', 162.0000, 'ºC'),
	(173724, 119, '2014-02-01 01:11:18.000000', 'temperatura', 711.0000, 'ºC'),
	(173725, 119, '2014-02-01 01:11:19.000000', 'temperatura', 666.0000, 'ºC'),
	(173726, 119, '2014-02-01 01:11:20.000000', 'temperatura', 1199.0000, 'ºC'),
	(173727, 119, '2014-02-01 01:11:21.000000', 'temperatura', 396.0000, 'ºC'),
	(173728, 119, '2014-02-01 01:11:22.000000', 'temperatura', 782.0000, 'ºC'),
	(173729, 119, '2014-02-01 01:11:23.000000', 'temperatura', 326.0000, 'ºC'),
	(173730, 119, '2014-02-01 01:11:24.000000', 'temperatura', 483.0000, 'ºC'),
	(173731, 119, '2014-02-01 01:11:25.000000', 'temperatura', 237.0000, 'ºC'),
	(173732, 119, '2014-02-01 01:11:26.000000', 'temperatura', 935.0000, 'ºC'),
	(173733, 119, '2014-02-01 01:11:27.000000', 'temperatura', 366.0000, 'ºC'),
	(173734, 119, '2014-02-01 01:11:28.000000', 'temperatura', 227.0000, 'ºC'),
	(173735, 119, '2014-02-01 01:11:29.000000', 'temperatura', 37.0000, 'ºC'),
	(173736, 119, '2014-02-01 01:11:30.000000', 'temperatura', 704.0000, 'ºC'),
	(173737, 119, '2014-02-01 01:11:31.000000', 'temperatura', 1010.0000, 'ºC'),
	(173738, 119, '2014-02-01 01:11:32.000000', 'temperatura', 537.0000, 'ºC'),
	(173739, 119, '2014-02-01 01:11:33.000000', 'temperatura', 856.0000, 'ºC'),
	(173740, 119, '2014-02-01 01:11:34.000000', 'temperatura', 271.0000, 'ºC'),
	(173741, 119, '2014-02-01 01:11:35.000000', 'temperatura', 1186.0000, 'ºC'),
	(173742, 119, '2014-02-01 01:11:36.000000', 'temperatura', 319.0000, 'ºC'),
	(173743, 119, '2014-02-01 01:11:37.000000', 'temperatura', 435.0000, 'ºC'),
	(173744, 119, '2014-02-01 01:11:38.000000', 'temperatura', 21.0000, 'ºC'),
	(173745, 119, '2014-02-01 01:11:39.000000', 'temperatura', 0.0000, 'ºC'),
	(173746, 119, '2014-02-01 01:11:40.000000', 'temperatura', 1139.0000, 'ºC'),
	(173747, 119, '2014-02-01 01:11:41.000000', 'temperatura', 892.0000, 'ºC'),
	(173748, 119, '2014-02-01 01:11:42.000000', 'temperatura', 1046.0000, 'ºC'),
	(173749, 119, '2014-02-01 01:11:43.000000', 'temperatura', 154.0000, 'ºC'),
	(173750, 119, '2014-02-01 01:11:44.000000', 'temperatura', 34.0000, 'ºC'),
	(173751, 119, '2014-02-01 01:11:45.000000', 'temperatura', 905.0000, 'ºC'),
	(173752, 119, '2014-02-01 01:11:46.000000', 'temperatura', 827.0000, 'ºC'),
	(173753, 119, '2014-02-01 01:11:47.000000', 'temperatura', 218.0000, 'ºC'),
	(173754, 119, '2014-02-01 01:11:48.000000', 'temperatura', 1012.0000, 'ºC'),
	(173755, 119, '2014-02-01 01:11:49.000000', 'temperatura', 804.0000, 'ºC'),
	(173756, 119, '2014-02-01 01:11:50.000000', 'temperatura', 984.0000, 'ºC'),
	(173757, 119, '2014-02-01 01:11:51.000000', 'temperatura', 108.0000, 'ºC'),
	(173758, 119, '2014-02-01 01:11:52.000000', 'temperatura', 1191.0000, 'ºC'),
	(173759, 119, '2014-02-01 01:11:53.000000', 'temperatura', 832.0000, 'ºC'),
	(173760, 119, '2014-02-01 01:11:54.000000', 'temperatura', 586.0000, 'ºC'),
	(173761, 119, '2014-02-01 01:11:55.000000', 'temperatura', 433.0000, 'ºC'),
	(173762, 119, '2014-02-01 01:11:56.000000', 'temperatura', 411.0000, 'ºC'),
	(173763, 119, '2014-02-01 01:11:57.000000', 'temperatura', 753.0000, 'ºC'),
	(173764, 119, '2014-02-01 01:11:58.000000', 'temperatura', 134.0000, 'ºC'),
	(173765, 119, '2014-02-01 01:11:59.000000', 'temperatura', 812.0000, 'ºC'),
	(173766, 119, '2014-02-01 01:12:00.000000', 'temperatura', 58.0000, 'ºC'),
	(173767, 119, '2014-02-01 01:12:01.000000', 'temperatura', 253.0000, 'ºC'),
	(173768, 119, '2014-02-01 01:12:02.000000', 'temperatura', 1094.0000, 'ºC'),
	(173769, 119, '2014-02-01 01:12:03.000000', 'temperatura', 1111.0000, 'ºC'),
	(173770, 119, '2014-02-01 01:12:04.000000', 'temperatura', 1071.0000, 'ºC'),
	(173771, 119, '2014-02-01 01:12:05.000000', 'temperatura', 825.0000, 'ºC'),
	(173772, 119, '2014-02-01 01:12:06.000000', 'temperatura', 912.0000, 'ºC'),
	(173773, 119, '2014-02-01 01:12:07.000000', 'temperatura', 886.0000, 'ºC'),
	(173774, 119, '2014-02-01 01:12:08.000000', 'temperatura', 496.0000, 'ºC'),
	(173775, 119, '2014-02-01 01:12:09.000000', 'temperatura', 1021.0000, 'ºC'),
	(173776, 119, '2014-02-01 01:12:10.000000', 'temperatura', 16.0000, 'ºC'),
	(173777, 119, '2014-02-01 01:12:11.000000', 'temperatura', 616.0000, 'ºC'),
	(173778, 119, '2014-02-01 01:12:12.000000', 'temperatura', 636.0000, 'ºC'),
	(173779, 119, '2014-02-01 01:12:13.000000', 'temperatura', 133.0000, 'ºC'),
	(173780, 119, '2014-02-01 01:12:14.000000', 'temperatura', 1157.0000, 'ºC'),
	(173781, 119, '2014-02-01 01:12:15.000000', 'temperatura', 585.0000, 'ºC'),
	(173782, 119, '2014-02-01 01:12:16.000000', 'temperatura', 655.0000, 'ºC'),
	(173783, 119, '2014-02-01 01:12:17.000000', 'temperatura', 320.0000, 'ºC'),
	(173784, 119, '2014-02-01 01:12:18.000000', 'temperatura', 835.0000, 'ºC'),
	(173785, 119, '2014-02-01 01:12:19.000000', 'temperatura', 815.0000, 'ºC'),
	(173786, 119, '2014-02-01 01:12:20.000000', 'temperatura', 373.0000, 'ºC'),
	(173787, 119, '2014-02-01 01:12:21.000000', 'temperatura', 621.0000, 'ºC'),
	(173788, 119, '2014-02-01 01:12:22.000000', 'temperatura', 786.0000, 'ºC'),
	(173789, 119, '2014-02-01 01:12:23.000000', 'temperatura', 868.0000, 'ºC'),
	(173790, 119, '2014-02-01 01:12:24.000000', 'temperatura', 782.0000, 'ºC'),
	(173791, 119, '2014-02-01 01:12:25.000000', 'temperatura', 105.0000, 'ºC'),
	(173792, 119, '2014-02-01 01:12:26.000000', 'temperatura', 580.0000, 'ºC'),
	(173793, 119, '2014-02-01 01:12:27.000000', 'temperatura', 186.0000, 'ºC'),
	(173794, 119, '2014-02-01 01:12:28.000000', 'temperatura', 390.0000, 'ºC'),
	(173795, 119, '2014-02-01 01:12:29.000000', 'temperatura', 194.0000, 'ºC'),
	(173796, 119, '2014-02-01 01:12:30.000000', 'temperatura', 1000.0000, 'ºC'),
	(173797, 119, '2014-02-01 01:12:31.000000', 'temperatura', 817.0000, 'ºC'),
	(173798, 119, '2014-02-01 01:12:32.000000', 'temperatura', 1085.0000, 'ºC'),
	(173799, 119, '2014-02-01 01:12:33.000000', 'temperatura', 576.0000, 'ºC'),
	(173800, 119, '2014-02-01 01:12:34.000000', 'temperatura', 823.0000, 'ºC'),
	(173801, 119, '2014-02-01 01:12:35.000000', 'temperatura', 1190.0000, 'ºC'),
	(173802, 119, '2014-02-01 01:12:36.000000', 'temperatura', 1083.0000, 'ºC'),
	(173803, 119, '2014-02-01 01:12:37.000000', 'temperatura', 644.0000, 'ºC'),
	(173804, 119, '2014-02-01 01:12:38.000000', 'temperatura', 1169.0000, 'ºC'),
	(173805, 119, '2014-02-01 01:12:39.000000', 'temperatura', 317.0000, 'ºC'),
	(173806, 119, '2014-02-01 01:12:40.000000', 'temperatura', 477.0000, 'ºC'),
	(173807, 119, '2014-02-01 01:12:41.000000', 'temperatura', 236.0000, 'ºC'),
	(173808, 119, '2014-02-01 01:12:42.000000', 'temperatura', 951.0000, 'ºC'),
	(173809, 119, '2014-02-01 01:12:43.000000', 'temperatura', 444.0000, 'ºC'),
	(173810, 119, '2014-02-01 01:12:44.000000', 'temperatura', 570.0000, 'ºC'),
	(173811, 119, '2014-02-01 01:12:45.000000', 'temperatura', 317.0000, 'ºC'),
	(173812, 119, '2014-02-01 01:12:46.000000', 'temperatura', 1075.0000, 'ºC'),
	(173813, 119, '2014-02-01 01:12:47.000000', 'temperatura', 825.0000, 'ºC'),
	(173814, 119, '2014-02-01 01:12:48.000000', 'temperatura', 901.0000, 'ºC'),
	(173815, 119, '2014-02-01 01:12:49.000000', 'temperatura', 832.0000, 'ºC'),
	(173816, 119, '2014-02-01 01:12:50.000000', 'temperatura', 255.0000, 'ºC'),
	(173817, 119, '2014-02-01 01:12:51.000000', 'temperatura', 1181.0000, 'ºC'),
	(173818, 119, '2014-02-01 01:12:52.000000', 'temperatura', 340.0000, 'ºC'),
	(173819, 119, '2014-02-01 01:12:53.000000', 'temperatura', 556.0000, 'ºC'),
	(173820, 119, '2014-02-01 01:12:54.000000', 'temperatura', 559.0000, 'ºC'),
	(173821, 119, '2014-02-01 01:12:55.000000', 'temperatura', 1131.0000, 'ºC'),
	(173822, 119, '2014-02-01 01:12:56.000000', 'temperatura', 379.0000, 'ºC'),
	(173823, 119, '2014-02-01 01:12:57.000000', 'temperatura', 900.0000, 'ºC'),
	(173824, 119, '2014-02-01 01:12:58.000000', 'temperatura', 964.0000, 'ºC'),
	(173825, 119, '2014-02-01 01:12:59.000000', 'temperatura', 922.0000, 'ºC'),
	(173826, 119, '2014-02-01 01:13:00.000000', 'temperatura', 518.0000, 'ºC'),
	(173827, 119, '2014-02-01 01:13:01.000000', 'temperatura', 1022.0000, 'ºC'),
	(173828, 119, '2014-02-01 01:13:02.000000', 'temperatura', 1159.0000, 'ºC'),
	(173829, 119, '2014-02-01 01:13:03.000000', 'temperatura', 329.0000, 'ºC'),
	(173830, 119, '2014-02-01 01:13:04.000000', 'temperatura', 567.0000, 'ºC'),
	(173831, 119, '2014-02-01 01:13:05.000000', 'temperatura', 650.0000, 'ºC'),
	(173832, 119, '2014-02-01 01:13:06.000000', 'temperatura', 350.0000, 'ºC'),
	(173833, 119, '2014-02-01 01:13:07.000000', 'temperatura', 998.0000, 'ºC'),
	(173834, 119, '2014-02-01 01:13:08.000000', 'temperatura', 343.0000, 'ºC'),
	(173835, 119, '2014-02-01 01:13:09.000000', 'temperatura', 1121.0000, 'ºC'),
	(173836, 119, '2014-02-01 01:13:10.000000', 'temperatura', 975.0000, 'ºC'),
	(173837, 119, '2014-02-01 01:13:11.000000', 'temperatura', 315.0000, 'ºC'),
	(173838, 119, '2014-02-01 01:13:12.000000', 'temperatura', 1049.0000, 'ºC'),
	(173839, 119, '2014-02-01 01:13:13.000000', 'temperatura', 701.0000, 'ºC'),
	(173840, 119, '2014-02-01 01:13:14.000000', 'temperatura', 359.0000, 'ºC'),
	(173841, 119, '2014-02-01 01:13:15.000000', 'temperatura', 892.0000, 'ºC'),
	(173842, 119, '2014-02-01 01:13:16.000000', 'temperatura', 983.0000, 'ºC'),
	(173843, 119, '2014-02-01 01:13:17.000000', 'temperatura', 1041.0000, 'ºC'),
	(173844, 119, '2014-02-01 01:13:18.000000', 'temperatura', 1055.0000, 'ºC'),
	(173845, 119, '2014-02-01 01:13:19.000000', 'temperatura', 953.0000, 'ºC'),
	(173846, 119, '2014-02-01 01:13:20.000000', 'temperatura', 401.0000, 'ºC'),
	(173847, 119, '2014-02-01 01:13:21.000000', 'temperatura', 348.0000, 'ºC'),
	(173848, 119, '2014-02-01 01:13:22.000000', 'temperatura', 535.0000, 'ºC'),
	(173849, 119, '2014-02-01 01:13:23.000000', 'temperatura', 433.0000, 'ºC'),
	(173850, 119, '2014-02-01 01:13:24.000000', 'temperatura', 560.0000, 'ºC'),
	(173851, 119, '2014-02-01 01:13:25.000000', 'temperatura', 302.0000, 'ºC'),
	(173852, 119, '2014-02-01 01:13:26.000000', 'temperatura', 1032.0000, 'ºC'),
	(173853, 119, '2014-02-01 01:13:27.000000', 'temperatura', 654.0000, 'ºC'),
	(173854, 119, '2014-02-01 01:13:28.000000', 'temperatura', 176.0000, 'ºC'),
	(173855, 119, '2014-02-01 01:13:29.000000', 'temperatura', 115.0000, 'ºC'),
	(173856, 119, '2014-02-01 01:13:30.000000', 'temperatura', 50.0000, 'ºC'),
	(173857, 119, '2014-02-01 01:13:31.000000', 'temperatura', 1106.0000, 'ºC'),
	(173858, 119, '2014-02-01 01:13:32.000000', 'temperatura', 579.0000, 'ºC'),
	(173859, 119, '2014-02-01 01:13:33.000000', 'temperatura', 779.0000, 'ºC'),
	(173860, 119, '2014-02-01 01:13:34.000000', 'temperatura', 957.0000, 'ºC'),
	(173861, 119, '2014-02-01 01:13:35.000000', 'temperatura', 49.0000, 'ºC'),
	(173862, 119, '2014-02-01 01:13:36.000000', 'temperatura', 973.0000, 'ºC'),
	(173863, 119, '2014-02-01 01:13:37.000000', 'temperatura', 1121.0000, 'ºC'),
	(173864, 119, '2014-02-01 01:13:38.000000', 'temperatura', 286.0000, 'ºC'),
	(173865, 119, '2014-02-01 01:13:39.000000', 'temperatura', 467.0000, 'ºC'),
	(173866, 119, '2014-02-01 01:13:40.000000', 'temperatura', 278.0000, 'ºC'),
	(173867, 119, '2014-02-01 01:13:41.000000', 'temperatura', 1190.0000, 'ºC'),
	(173868, 119, '2014-02-01 01:13:42.000000', 'temperatura', 316.0000, 'ºC'),
	(173869, 119, '2014-02-01 01:13:43.000000', 'temperatura', 411.0000, 'ºC'),
	(173870, 119, '2014-02-01 01:13:44.000000', 'temperatura', 1107.0000, 'ºC'),
	(173871, 119, '2014-02-01 01:13:45.000000', 'temperatura', 701.0000, 'ºC'),
	(173872, 119, '2014-02-01 01:13:46.000000', 'temperatura', 187.0000, 'ºC'),
	(173873, 119, '2014-02-01 01:13:47.000000', 'temperatura', 29.0000, 'ºC'),
	(173874, 119, '2014-02-01 01:13:48.000000', 'temperatura', 788.0000, 'ºC'),
	(173875, 119, '2014-02-01 01:13:49.000000', 'temperatura', 254.0000, 'ºC'),
	(173876, 119, '2014-02-01 01:13:50.000000', 'temperatura', 105.0000, 'ºC'),
	(173877, 119, '2014-02-01 01:13:51.000000', 'temperatura', 964.0000, 'ºC'),
	(173878, 119, '2014-02-01 01:13:52.000000', 'temperatura', 905.0000, 'ºC'),
	(173879, 119, '2014-02-01 01:13:53.000000', 'temperatura', 434.0000, 'ºC'),
	(173880, 119, '2014-02-01 01:13:54.000000', 'temperatura', 655.0000, 'ºC'),
	(173881, 119, '2014-02-01 01:13:55.000000', 'temperatura', 772.0000, 'ºC'),
	(173882, 119, '2014-02-01 01:13:56.000000', 'temperatura', 697.0000, 'ºC'),
	(173883, 119, '2014-02-01 01:13:57.000000', 'temperatura', 1169.0000, 'ºC'),
	(173884, 119, '2014-02-01 01:13:58.000000', 'temperatura', 157.0000, 'ºC'),
	(173885, 119, '2014-02-01 01:13:59.000000', 'temperatura', 875.0000, 'ºC'),
	(173886, 119, '2014-02-01 01:14:00.000000', 'temperatura', 306.0000, 'ºC'),
	(173887, 119, '2014-02-01 01:14:01.000000', 'temperatura', 105.0000, 'ºC'),
	(173888, 119, '2014-02-01 01:14:02.000000', 'temperatura', 807.0000, 'ºC'),
	(173889, 119, '2014-02-01 01:14:03.000000', 'temperatura', 119.0000, 'ºC'),
	(173890, 119, '2014-02-01 01:14:04.000000', 'temperatura', 578.0000, 'ºC'),
	(173891, 119, '2014-02-01 01:14:05.000000', 'temperatura', 131.0000, 'ºC'),
	(173892, 119, '2014-02-01 01:14:06.000000', 'temperatura', 122.0000, 'ºC'),
	(173893, 119, '2014-02-01 01:14:07.000000', 'temperatura', 217.0000, 'ºC'),
	(173894, 119, '2014-02-01 01:14:08.000000', 'temperatura', 720.0000, 'ºC'),
	(173895, 119, '2014-02-01 01:14:09.000000', 'temperatura', 548.0000, 'ºC'),
	(173896, 119, '2014-02-01 01:14:10.000000', 'temperatura', 580.0000, 'ºC'),
	(173897, 119, '2014-02-01 01:14:11.000000', 'temperatura', 58.0000, 'ºC'),
	(173898, 119, '2014-02-01 01:14:12.000000', 'temperatura', 951.0000, 'ºC'),
	(173899, 119, '2014-02-01 01:14:13.000000', 'temperatura', 980.0000, 'ºC'),
	(173900, 119, '2014-02-01 01:14:14.000000', 'temperatura', 849.0000, 'ºC'),
	(173901, 119, '2014-02-01 01:14:15.000000', 'temperatura', 103.0000, 'ºC'),
	(173902, 119, '2014-02-01 01:14:16.000000', 'temperatura', 370.0000, 'ºC'),
	(173903, 119, '2014-02-01 01:14:17.000000', 'temperatura', 343.0000, 'ºC'),
	(173904, 119, '2014-02-01 01:14:18.000000', 'temperatura', 604.0000, 'ºC'),
	(173905, 119, '2014-02-01 01:14:19.000000', 'temperatura', 790.0000, 'ºC'),
	(173906, 119, '2014-02-01 01:14:20.000000', 'temperatura', 939.0000, 'ºC'),
	(173907, 119, '2014-02-01 01:14:21.000000', 'temperatura', 1126.0000, 'ºC'),
	(173908, 119, '2014-02-01 01:14:22.000000', 'temperatura', 413.0000, 'ºC'),
	(173909, 119, '2014-02-01 01:14:23.000000', 'temperatura', 1090.0000, 'ºC'),
	(173910, 119, '2014-02-01 01:14:24.000000', 'temperatura', 609.0000, 'ºC'),
	(173911, 119, '2014-02-01 01:14:25.000000', 'temperatura', 975.0000, 'ºC'),
	(173912, 119, '2014-02-01 01:14:26.000000', 'temperatura', 648.0000, 'ºC'),
	(173913, 119, '2014-02-01 01:14:27.000000', 'temperatura', 317.0000, 'ºC'),
	(173914, 119, '2014-02-01 01:14:28.000000', 'temperatura', 840.0000, 'ºC'),
	(173915, 119, '2014-02-01 01:14:29.000000', 'temperatura', 852.0000, 'ºC'),
	(173916, 119, '2014-02-01 01:14:30.000000', 'temperatura', 540.0000, 'ºC'),
	(173917, 119, '2014-02-01 01:14:31.000000', 'temperatura', 144.0000, 'ºC'),
	(173918, 119, '2014-02-01 01:14:32.000000', 'temperatura', 302.0000, 'ºC'),
	(173919, 119, '2014-02-01 01:14:33.000000', 'temperatura', 1078.0000, 'ºC'),
	(173920, 119, '2014-02-01 01:14:34.000000', 'temperatura', 882.0000, 'ºC'),
	(173921, 119, '2014-02-01 01:14:35.000000', 'temperatura', 1179.0000, 'ºC'),
	(173922, 119, '2014-02-01 01:14:36.000000', 'temperatura', 847.0000, 'ºC'),
	(173923, 119, '2014-02-01 01:14:37.000000', 'temperatura', 701.0000, 'ºC'),
	(173924, 119, '2014-02-01 01:14:38.000000', 'temperatura', 963.0000, 'ºC'),
	(173925, 119, '2014-02-01 01:14:39.000000', 'temperatura', 314.0000, 'ºC'),
	(173926, 119, '2014-02-01 01:14:40.000000', 'temperatura', 1081.0000, 'ºC'),
	(173927, 119, '2014-02-01 01:14:41.000000', 'temperatura', 863.0000, 'ºC'),
	(173928, 119, '2014-02-01 01:14:42.000000', 'temperatura', 1075.0000, 'ºC'),
	(173929, 119, '2014-02-01 01:14:43.000000', 'temperatura', 383.0000, 'ºC'),
	(173930, 119, '2014-02-01 01:14:44.000000', 'temperatura', 1093.0000, 'ºC'),
	(173931, 119, '2014-02-01 01:14:45.000000', 'temperatura', 715.0000, 'ºC'),
	(173932, 119, '2014-02-01 01:14:46.000000', 'temperatura', 297.0000, 'ºC'),
	(173933, 119, '2014-02-01 01:14:47.000000', 'temperatura', 540.0000, 'ºC'),
	(173934, 119, '2014-02-01 01:14:48.000000', 'temperatura', 610.0000, 'ºC'),
	(173935, 119, '2014-02-01 01:14:49.000000', 'temperatura', 229.0000, 'ºC'),
	(173936, 119, '2014-02-01 01:14:50.000000', 'temperatura', 518.0000, 'ºC'),
	(173937, 119, '2014-02-01 01:14:51.000000', 'temperatura', 700.0000, 'ºC'),
	(173938, 119, '2014-02-01 01:14:52.000000', 'temperatura', 749.0000, 'ºC'),
	(173939, 119, '2014-02-01 01:14:53.000000', 'temperatura', 447.0000, 'ºC'),
	(173940, 119, '2014-02-01 01:14:54.000000', 'temperatura', 1186.0000, 'ºC'),
	(173941, 119, '2014-02-01 01:14:55.000000', 'temperatura', 991.0000, 'ºC'),
	(173942, 119, '2014-02-01 01:14:56.000000', 'temperatura', 195.0000, 'ºC'),
	(173943, 119, '2014-02-01 01:14:57.000000', 'temperatura', 403.0000, 'ºC'),
	(173944, 119, '2014-02-01 01:14:58.000000', 'temperatura', 232.0000, 'ºC'),
	(173945, 119, '2014-02-01 01:14:59.000000', 'temperatura', 1151.0000, 'ºC'),
	(173946, 119, '2014-02-01 01:15:00.000000', 'temperatura', 261.0000, 'ºC'),
	(173947, 119, '2014-02-01 01:15:01.000000', 'temperatura', 253.0000, 'ºC'),
	(173948, 119, '2014-02-01 01:15:02.000000', 'temperatura', 480.0000, 'ºC'),
	(173949, 119, '2014-02-01 01:15:03.000000', 'temperatura', 444.0000, 'ºC'),
	(173950, 119, '2014-02-01 01:15:04.000000', 'temperatura', 779.0000, 'ºC'),
	(173951, 119, '2014-02-01 01:15:05.000000', 'temperatura', 163.0000, 'ºC'),
	(173952, 119, '2014-02-01 01:15:06.000000', 'temperatura', 880.0000, 'ºC'),
	(173953, 119, '2014-02-01 01:15:07.000000', 'temperatura', 310.0000, 'ºC'),
	(173954, 119, '2014-02-01 01:15:08.000000', 'temperatura', 110.0000, 'ºC'),
	(173955, 119, '2014-02-01 01:15:09.000000', 'temperatura', 821.0000, 'ºC'),
	(173956, 119, '2014-02-01 01:15:10.000000', 'temperatura', 176.0000, 'ºC'),
	(173957, 119, '2014-02-01 01:15:11.000000', 'temperatura', 819.0000, 'ºC'),
	(173958, 119, '2014-02-01 01:15:12.000000', 'temperatura', 1166.0000, 'ºC'),
	(173959, 119, '2014-02-01 01:15:13.000000', 'temperatura', 975.0000, 'ºC'),
	(173960, 119, '2014-02-01 01:15:14.000000', 'temperatura', 177.0000, 'ºC'),
	(173961, 119, '2014-02-01 01:15:15.000000', 'temperatura', 360.0000, 'ºC'),
	(173962, 119, '2014-02-01 01:15:16.000000', 'temperatura', 70.0000, 'ºC'),
	(173963, 119, '2014-02-01 01:15:17.000000', 'temperatura', 471.0000, 'ºC'),
	(173964, 119, '2014-02-01 01:15:18.000000', 'temperatura', 945.0000, 'ºC'),
	(173965, 119, '2014-02-01 01:15:19.000000', 'temperatura', 914.0000, 'ºC'),
	(173966, 119, '2014-02-01 01:15:20.000000', 'temperatura', 536.0000, 'ºC'),
	(173967, 119, '2014-02-01 01:15:21.000000', 'temperatura', 1138.0000, 'ºC'),
	(173968, 119, '2014-02-01 01:15:22.000000', 'temperatura', 481.0000, 'ºC'),
	(173969, 119, '2014-02-01 01:15:23.000000', 'temperatura', 194.0000, 'ºC'),
	(173970, 119, '2014-02-01 01:15:24.000000', 'temperatura', 727.0000, 'ºC'),
	(173971, 119, '2014-02-01 01:15:25.000000', 'temperatura', 655.0000, 'ºC'),
	(173972, 119, '2014-02-01 01:15:26.000000', 'temperatura', 1092.0000, 'ºC'),
	(173973, 119, '2014-02-01 01:15:27.000000', 'temperatura', 1098.0000, 'ºC'),
	(173974, 119, '2014-02-01 01:15:28.000000', 'temperatura', 1014.0000, 'ºC'),
	(173975, 119, '2014-02-01 01:15:29.000000', 'temperatura', 578.0000, 'ºC'),
	(173976, 119, '2014-02-01 01:15:30.000000', 'temperatura', 1048.0000, 'ºC'),
	(173977, 119, '2014-02-01 01:15:31.000000', 'temperatura', 1104.0000, 'ºC'),
	(173978, 119, '2014-02-01 01:15:32.000000', 'temperatura', 1178.0000, 'ºC'),
	(173979, 119, '2014-02-01 01:15:33.000000', 'temperatura', 178.0000, 'ºC'),
	(173980, 119, '2014-02-01 01:15:34.000000', 'temperatura', 958.0000, 'ºC'),
	(173981, 119, '2014-02-01 01:15:35.000000', 'temperatura', 655.0000, 'ºC'),
	(173982, 119, '2014-02-01 01:15:36.000000', 'temperatura', 404.0000, 'ºC'),
	(173983, 119, '2014-02-01 01:15:37.000000', 'temperatura', 54.0000, 'ºC'),
	(173984, 119, '2014-02-01 01:15:38.000000', 'temperatura', 260.0000, 'ºC'),
	(173985, 119, '2014-02-01 01:15:39.000000', 'temperatura', 1139.0000, 'ºC'),
	(173986, 119, '2014-02-01 01:15:40.000000', 'temperatura', 116.0000, 'ºC'),
	(173987, 119, '2014-02-01 01:15:41.000000', 'temperatura', 764.0000, 'ºC'),
	(173988, 119, '2014-02-01 01:15:42.000000', 'temperatura', 1070.0000, 'ºC'),
	(173989, 119, '2014-02-01 01:15:43.000000', 'temperatura', 658.0000, 'ºC'),
	(173990, 119, '2014-02-01 01:15:44.000000', 'temperatura', 82.0000, 'ºC'),
	(173991, 119, '2014-02-01 01:15:45.000000', 'temperatura', 834.0000, 'ºC'),
	(173992, 119, '2014-02-01 01:15:46.000000', 'temperatura', 326.0000, 'ºC'),
	(173993, 119, '2014-02-01 01:15:47.000000', 'temperatura', 329.0000, 'ºC'),
	(173994, 119, '2014-02-01 01:15:48.000000', 'temperatura', 668.0000, 'ºC'),
	(173995, 119, '2014-02-01 01:15:49.000000', 'temperatura', 1154.0000, 'ºC'),
	(173996, 119, '2014-02-01 01:15:50.000000', 'temperatura', 166.0000, 'ºC'),
	(173997, 119, '2014-02-01 01:15:51.000000', 'temperatura', 967.0000, 'ºC'),
	(173998, 119, '2014-02-01 01:15:52.000000', 'temperatura', 736.0000, 'ºC'),
	(173999, 119, '2014-02-01 01:15:53.000000', 'temperatura', 783.0000, 'ºC'),
	(174000, 119, '2014-02-01 01:15:54.000000', 'temperatura', 506.0000, 'ºC'),
	(174001, 119, '2014-02-01 01:15:55.000000', 'temperatura', 181.0000, 'ºC'),
	(174002, 119, '2014-02-01 01:15:56.000000', 'temperatura', 589.0000, 'ºC'),
	(174003, 119, '2014-02-01 01:15:57.000000', 'temperatura', 0.0000, 'ºC'),
	(174004, 119, '2014-02-01 01:15:58.000000', 'temperatura', 635.0000, 'ºC'),
	(174005, 119, '2014-02-01 01:15:59.000000', 'temperatura', 773.0000, 'ºC'),
	(174006, 119, '2014-02-01 01:16:00.000000', 'temperatura', 763.0000, 'ºC'),
	(174007, 119, '2014-02-01 01:16:01.000000', 'temperatura', 298.0000, 'ºC'),
	(174008, 119, '2014-02-01 01:16:02.000000', 'temperatura', 399.0000, 'ºC'),
	(174009, 119, '2014-02-01 01:16:03.000000', 'temperatura', 1101.0000, 'ºC'),
	(174010, 119, '2014-02-01 01:16:04.000000', 'temperatura', 709.0000, 'ºC'),
	(174011, 119, '2014-02-01 01:16:05.000000', 'temperatura', 244.0000, 'ºC'),
	(174012, 119, '2014-02-01 01:16:06.000000', 'temperatura', 293.0000, 'ºC'),
	(174013, 119, '2014-02-01 01:16:07.000000', 'temperatura', 731.0000, 'ºC'),
	(174014, 119, '2014-02-01 01:16:08.000000', 'temperatura', 378.0000, 'ºC'),
	(174015, 119, '2014-02-01 01:16:09.000000', 'temperatura', 900.0000, 'ºC'),
	(174016, 119, '2014-02-01 01:16:10.000000', 'temperatura', 963.0000, 'ºC'),
	(174017, 119, '2014-02-01 01:16:11.000000', 'temperatura', 919.0000, 'ºC'),
	(174018, 119, '2014-02-01 01:16:12.000000', 'temperatura', 504.0000, 'ºC'),
	(174019, 119, '2014-02-01 01:16:13.000000', 'temperatura', 962.0000, 'ºC'),
	(174020, 119, '2014-02-01 01:16:14.000000', 'temperatura', 902.0000, 'ºC'),
	(174021, 119, '2014-02-01 01:16:15.000000', 'temperatura', 423.0000, 'ºC'),
	(174022, 119, '2014-02-01 01:16:16.000000', 'temperatura', 610.0000, 'ºC'),
	(174023, 119, '2014-02-01 01:16:17.000000', 'temperatura', 581.0000, 'ºC'),
	(174024, 119, '2014-02-01 01:16:18.000000', 'temperatura', 1078.0000, 'ºC'),
	(174025, 119, '2014-02-01 01:16:19.000000', 'temperatura', 44.0000, 'ºC'),
	(174026, 119, '2014-02-01 01:16:20.000000', 'temperatura', 589.0000, 'ºC'),
	(174027, 119, '2014-02-01 01:16:21.000000', 'temperatura', 413.0000, 'ºC'),
	(174028, 119, '2014-02-01 01:16:22.000000', 'temperatura', 296.0000, 'ºC'),
	(174029, 119, '2014-02-01 01:16:23.000000', 'temperatura', 245.0000, 'ºC'),
	(174030, 119, '2014-02-01 01:16:24.000000', 'temperatura', 335.0000, 'ºC'),
	(174031, 119, '2014-02-01 01:16:25.000000', 'temperatura', 942.0000, 'ºC'),
	(174032, 119, '2014-02-01 01:16:26.000000', 'temperatura', 107.0000, 'ºC'),
	(174033, 119, '2014-02-01 01:16:27.000000', 'temperatura', 107.0000, 'ºC'),
	(174034, 119, '2014-02-01 01:16:28.000000', 'temperatura', 217.0000, 'ºC'),
	(174035, 119, '2014-02-01 01:16:29.000000', 'temperatura', 762.0000, 'ºC'),
	(174036, 119, '2014-02-01 01:16:30.000000', 'temperatura', 761.0000, 'ºC'),
	(174037, 119, '2014-02-01 01:16:31.000000', 'temperatura', 319.0000, 'ºC'),
	(174038, 119, '2014-02-01 01:16:32.000000', 'temperatura', 512.0000, 'ºC'),
	(174039, 119, '2014-02-01 01:16:33.000000', 'temperatura', 404.0000, 'ºC'),
	(174040, 119, '2014-02-01 01:16:34.000000', 'temperatura', 486.0000, 'ºC'),
	(174041, 119, '2014-02-01 01:16:35.000000', 'temperatura', 16.0000, 'ºC'),
	(174042, 119, '2014-02-01 01:16:36.000000', 'temperatura', 1024.0000, 'ºC'),
	(174043, 119, '2014-02-01 01:16:37.000000', 'temperatura', 271.0000, 'ºC'),
	(174044, 119, '2014-02-01 01:16:38.000000', 'temperatura', 684.0000, 'ºC'),
	(174045, 119, '2014-02-01 01:16:39.000000', 'temperatura', 210.0000, 'ºC'),
	(174046, 119, '2014-02-01 01:16:40.000000', 'temperatura', 195.0000, 'ºC'),
	(174047, 119, '2014-02-01 01:16:41.000000', 'temperatura', 347.0000, 'ºC'),
	(174048, 119, '2014-02-01 01:16:42.000000', 'temperatura', 1151.0000, 'ºC'),
	(174049, 119, '2014-02-01 01:16:43.000000', 'temperatura', 1113.0000, 'ºC'),
	(174050, 119, '2014-02-01 01:16:44.000000', 'temperatura', 911.0000, 'ºC'),
	(174051, 119, '2014-02-01 01:16:45.000000', 'temperatura', 19.0000, 'ºC'),
	(174052, 119, '2014-02-01 01:16:46.000000', 'temperatura', 962.0000, 'ºC'),
	(174053, 119, '2014-02-01 01:16:47.000000', 'temperatura', 1153.0000, 'ºC'),
	(174054, 119, '2014-02-01 01:16:48.000000', 'temperatura', 479.0000, 'ºC'),
	(174055, 119, '2014-02-01 01:16:49.000000', 'temperatura', 136.0000, 'ºC'),
	(174056, 119, '2014-02-01 01:16:50.000000', 'temperatura', 446.0000, 'ºC'),
	(174057, 119, '2014-02-01 01:16:51.000000', 'temperatura', 622.0000, 'ºC'),
	(174058, 119, '2014-02-01 01:16:52.000000', 'temperatura', 574.0000, 'ºC'),
	(174059, 119, '2014-02-01 01:16:53.000000', 'temperatura', 1001.0000, 'ºC'),
	(174060, 119, '2014-02-01 01:16:54.000000', 'temperatura', 885.0000, 'ºC'),
	(174061, 119, '2014-02-01 01:16:55.000000', 'temperatura', 224.0000, 'ºC'),
	(174062, 119, '2014-02-01 01:16:56.000000', 'temperatura', 863.0000, 'ºC'),
	(174063, 119, '2014-02-01 01:16:57.000000', 'temperatura', 44.0000, 'ºC'),
	(174064, 119, '2014-02-01 01:16:58.000000', 'temperatura', 34.0000, 'ºC'),
	(174065, 119, '2014-02-01 01:16:59.000000', 'temperatura', 36.0000, 'ºC'),
	(174066, 119, '2014-02-01 01:17:00.000000', 'temperatura', 77.0000, 'ºC'),
	(174067, 119, '2014-02-01 01:17:01.000000', 'temperatura', 280.0000, 'ºC'),
	(174068, 119, '2014-02-01 01:17:02.000000', 'temperatura', 1168.0000, 'ºC'),
	(174069, 119, '2014-02-01 01:17:03.000000', 'temperatura', 203.0000, 'ºC'),
	(174070, 119, '2014-02-01 01:17:04.000000', 'temperatura', 1108.0000, 'ºC'),
	(174071, 119, '2014-02-01 01:17:05.000000', 'temperatura', 135.0000, 'ºC'),
	(174072, 119, '2014-02-01 01:17:06.000000', 'temperatura', 949.0000, 'ºC'),
	(174073, 119, '2014-02-01 01:17:07.000000', 'temperatura', 740.0000, 'ºC'),
	(174074, 119, '2014-02-01 01:17:08.000000', 'temperatura', 854.0000, 'ºC'),
	(174075, 119, '2014-02-01 01:17:09.000000', 'temperatura', 851.0000, 'ºC'),
	(174076, 119, '2014-02-01 01:17:10.000000', 'temperatura', 491.0000, 'ºC'),
	(174077, 119, '2014-02-01 01:17:11.000000', 'temperatura', 1106.0000, 'ºC'),
	(174078, 119, '2014-02-01 01:17:12.000000', 'temperatura', 456.0000, 'ºC'),
	(174079, 119, '2014-02-01 01:17:13.000000', 'temperatura', 161.0000, 'ºC'),
	(174080, 119, '2014-02-01 01:17:14.000000', 'temperatura', 637.0000, 'ºC'),
	(174081, 119, '2014-02-01 01:17:15.000000', 'temperatura', 302.0000, 'ºC'),
	(174082, 119, '2014-02-01 01:17:16.000000', 'temperatura', 803.0000, 'ºC'),
	(174083, 119, '2014-02-01 01:17:17.000000', 'temperatura', 706.0000, 'ºC'),
	(174084, 119, '2014-02-01 01:17:18.000000', 'temperatura', 1124.0000, 'ºC'),
	(174085, 119, '2014-02-01 01:17:19.000000', 'temperatura', 1103.0000, 'ºC'),
	(174086, 119, '2014-02-01 01:17:20.000000', 'temperatura', 944.0000, 'ºC'),
	(174087, 119, '2014-02-01 01:17:21.000000', 'temperatura', 211.0000, 'ºC'),
	(174088, 119, '2014-02-01 01:17:22.000000', 'temperatura', 624.0000, 'ºC'),
	(174089, 119, '2014-02-01 01:17:23.000000', 'temperatura', 87.0000, 'ºC'),
	(174090, 119, '2014-02-01 01:17:24.000000', 'temperatura', 965.0000, 'ºC'),
	(174091, 119, '2014-02-01 01:17:25.000000', 'temperatura', 965.0000, 'ºC'),
	(174092, 119, '2014-02-01 01:17:26.000000', 'temperatura', 730.0000, 'ºC'),
	(174093, 119, '2014-02-01 01:17:27.000000', 'temperatura', 756.0000, 'ºC'),
	(174094, 119, '2014-02-01 01:17:28.000000', 'temperatura', 388.0000, 'ºC'),
	(174095, 119, '2014-02-01 01:17:29.000000', 'temperatura', 874.0000, 'ºC'),
	(174096, 119, '2014-02-01 01:17:30.000000', 'temperatura', 808.0000, 'ºC'),
	(174097, 119, '2014-02-01 01:17:31.000000', 'temperatura', 218.0000, 'ºC'),
	(174098, 119, '2014-02-01 01:17:32.000000', 'temperatura', 1066.0000, 'ºC'),
	(174099, 119, '2014-02-01 01:17:33.000000', 'temperatura', 1077.0000, 'ºC'),
	(174100, 120, '2014-02-01 00:00:00.000000', 'temperatura', 499.0000, 'ºC'),
	(174101, 120, '2014-02-01 00:00:01.000000', 'temperatura', 737.0000, 'ºC'),
	(174102, 120, '2014-02-01 00:00:02.000000', 'temperatura', 987.0000, 'ºC'),
	(174103, 120, '2014-02-01 00:00:03.000000', 'temperatura', 328.0000, 'ºC'),
	(174104, 120, '2014-02-01 00:00:04.000000', 'temperatura', 1080.0000, 'ºC'),
	(174105, 120, '2014-02-01 00:00:05.000000', 'temperatura', 815.0000, 'ºC'),
	(174106, 120, '2014-02-01 00:00:06.000000', 'temperatura', 836.0000, 'ºC'),
	(174107, 120, '2014-02-01 00:00:07.000000', 'temperatura', 534.0000, 'ºC'),
	(174108, 120, '2014-02-01 00:00:08.000000', 'temperatura', 164.0000, 'ºC'),
	(174109, 120, '2014-02-01 00:00:09.000000', 'temperatura', 420.0000, 'ºC'),
	(174110, 120, '2014-02-01 00:00:10.000000', 'temperatura', 407.0000, 'ºC'),
	(174111, 120, '2014-02-01 00:00:11.000000', 'temperatura', 776.0000, 'ºC'),
	(174112, 120, '2014-02-01 00:00:12.000000', 'temperatura', 259.0000, 'ºC'),
	(174113, 120, '2014-02-01 00:00:13.000000', 'temperatura', 168.0000, 'ºC'),
	(174114, 120, '2014-02-01 00:00:14.000000', 'temperatura', 65.0000, 'ºC'),
	(174115, 120, '2014-02-01 00:00:15.000000', 'temperatura', 1021.0000, 'ºC'),
	(174116, 120, '2014-02-01 00:00:16.000000', 'temperatura', 112.0000, 'ºC'),
	(174117, 120, '2014-02-01 00:00:17.000000', 'temperatura', 1096.0000, 'ºC'),
	(174118, 120, '2014-02-01 00:00:18.000000', 'temperatura', 343.0000, 'ºC'),
	(174119, 120, '2014-02-01 00:00:19.000000', 'temperatura', 829.0000, 'ºC'),
	(174120, 120, '2014-02-01 00:00:20.000000', 'temperatura', 718.0000, 'ºC'),
	(174121, 120, '2014-02-01 00:00:21.000000', 'temperatura', 1102.0000, 'ºC'),
	(174122, 120, '2014-02-01 00:00:22.000000', 'temperatura', 958.0000, 'ºC'),
	(174123, 120, '2014-02-01 00:00:23.000000', 'temperatura', 285.0000, 'ºC'),
	(174124, 120, '2014-02-01 00:00:24.000000', 'temperatura', 949.0000, 'ºC'),
	(174125, 120, '2014-02-01 00:00:25.000000', 'temperatura', 289.0000, 'ºC'),
	(174126, 120, '2014-02-01 00:00:26.000000', 'temperatura', 1002.0000, 'ºC'),
	(174127, 120, '2014-02-01 00:00:27.000000', 'temperatura', 543.0000, 'ºC'),
	(174128, 120, '2014-02-01 00:00:28.000000', 'temperatura', 907.0000, 'ºC'),
	(174129, 120, '2014-02-01 00:00:29.000000', 'temperatura', 509.0000, 'ºC'),
	(174130, 120, '2014-02-01 00:00:30.000000', 'temperatura', 1026.0000, 'ºC'),
	(174131, 120, '2014-02-01 00:00:31.000000', 'temperatura', 0.0000, 'ºC'),
	(174132, 120, '2014-02-01 00:00:32.000000', 'temperatura', 526.0000, 'ºC'),
	(174133, 120, '2014-02-01 00:00:33.000000', 'temperatura', 228.0000, 'ºC'),
	(174134, 120, '2014-02-01 00:00:34.000000', 'temperatura', 763.0000, 'ºC'),
	(174135, 120, '2014-02-01 00:00:35.000000', 'temperatura', 732.0000, 'ºC'),
	(174136, 120, '2014-02-01 00:00:36.000000', 'temperatura', 170.0000, 'ºC'),
	(174137, 120, '2014-02-01 00:00:37.000000', 'temperatura', 1054.0000, 'ºC'),
	(174138, 120, '2014-02-01 00:00:38.000000', 'temperatura', 1161.0000, 'ºC'),
	(174139, 120, '2014-02-01 00:00:39.000000', 'temperatura', 242.0000, 'ºC'),
	(174140, 120, '2014-02-01 00:00:40.000000', 'temperatura', 128.0000, 'ºC'),
	(174141, 120, '2014-02-01 00:00:41.000000', 'temperatura', 1117.0000, 'ºC'),
	(174142, 120, '2014-02-01 00:00:42.000000', 'temperatura', 399.0000, 'ºC'),
	(174143, 120, '2014-02-01 00:00:43.000000', 'temperatura', 1044.0000, 'ºC'),
	(174144, 120, '2014-02-01 00:00:44.000000', 'temperatura', 422.0000, 'ºC'),
	(174145, 120, '2014-02-01 00:00:45.000000', 'temperatura', 182.0000, 'ºC'),
	(174146, 120, '2014-02-01 00:00:46.000000', 'temperatura', 841.0000, 'ºC'),
	(174147, 120, '2014-02-01 00:00:47.000000', 'temperatura', 62.0000, 'ºC'),
	(174148, 120, '2014-02-01 00:00:48.000000', 'temperatura', 188.0000, 'ºC'),
	(174149, 120, '2014-02-01 00:00:49.000000', 'temperatura', 753.0000, 'ºC'),
	(174150, 120, '2014-02-01 00:00:50.000000', 'temperatura', 803.0000, 'ºC'),
	(174151, 120, '2014-02-01 00:00:51.000000', 'temperatura', 556.0000, 'ºC'),
	(174152, 120, '2014-02-01 00:00:52.000000', 'temperatura', 372.0000, 'ºC'),
	(174153, 120, '2014-02-01 00:00:53.000000', 'temperatura', 192.0000, 'ºC'),
	(174154, 120, '2014-02-01 00:00:54.000000', 'temperatura', 1047.0000, 'ºC'),
	(174155, 120, '2014-02-01 00:00:55.000000', 'temperatura', 1056.0000, 'ºC'),
	(174156, 120, '2014-02-01 00:00:56.000000', 'temperatura', 942.0000, 'ºC'),
	(174157, 120, '2014-02-01 00:00:57.000000', 'temperatura', 341.0000, 'ºC'),
	(174158, 120, '2014-02-01 00:00:58.000000', 'temperatura', 80.0000, 'ºC'),
	(174159, 120, '2014-02-01 00:00:59.000000', 'temperatura', 579.0000, 'ºC'),
	(174160, 120, '2014-02-01 00:01:00.000000', 'temperatura', 254.0000, 'ºC'),
	(174161, 120, '2014-02-01 00:01:01.000000', 'temperatura', 734.0000, 'ºC'),
	(174162, 120, '2014-02-01 00:01:02.000000', 'temperatura', 507.0000, 'ºC'),
	(174163, 120, '2014-02-01 00:01:03.000000', 'temperatura', 336.0000, 'ºC'),
	(174164, 120, '2014-02-01 00:01:04.000000', 'temperatura', 160.0000, 'ºC'),
	(174165, 120, '2014-02-01 00:01:05.000000', 'temperatura', 990.0000, 'ºC'),
	(174166, 120, '2014-02-01 00:01:06.000000', 'temperatura', 873.0000, 'ºC'),
	(174167, 120, '2014-02-01 00:01:07.000000', 'temperatura', 196.0000, 'ºC'),
	(174168, 120, '2014-02-01 00:01:08.000000', 'temperatura', 762.0000, 'ºC'),
	(174169, 120, '2014-02-01 00:01:09.000000', 'temperatura', 821.0000, 'ºC'),
	(174170, 120, '2014-02-01 00:01:10.000000', 'temperatura', 621.0000, 'ºC'),
	(174171, 120, '2014-02-01 00:01:11.000000', 'temperatura', 640.0000, 'ºC'),
	(174172, 120, '2014-02-01 00:01:12.000000', 'temperatura', 139.0000, 'ºC'),
	(174173, 120, '2014-02-01 00:01:13.000000', 'temperatura', 1177.0000, 'ºC'),
	(174174, 120, '2014-02-01 00:01:14.000000', 'temperatura', 667.0000, 'ºC'),
	(174175, 120, '2014-02-01 00:01:15.000000', 'temperatura', 1006.0000, 'ºC'),
	(174176, 120, '2014-02-01 00:01:16.000000', 'temperatura', 629.0000, 'ºC'),
	(174177, 120, '2014-02-01 00:01:17.000000', 'temperatura', 126.0000, 'ºC'),
	(174178, 120, '2014-02-01 00:01:18.000000', 'temperatura', 1143.0000, 'ºC'),
	(174179, 120, '2014-02-01 00:01:19.000000', 'temperatura', 538.0000, 'ºC'),
	(174180, 120, '2014-02-01 00:01:20.000000', 'temperatura', 461.0000, 'ºC'),
	(174181, 120, '2014-02-01 00:01:21.000000', 'temperatura', 690.0000, 'ºC'),
	(174182, 120, '2014-02-01 00:01:22.000000', 'temperatura', 869.0000, 'ºC'),
	(174183, 120, '2014-02-01 00:01:23.000000', 'temperatura', 1075.0000, 'ºC'),
	(174184, 120, '2014-02-01 00:01:24.000000', 'temperatura', 368.0000, 'ºC'),
	(174185, 120, '2014-02-01 00:01:25.000000', 'temperatura', 1016.0000, 'ºC'),
	(174186, 120, '2014-02-01 00:01:26.000000', 'temperatura', 378.0000, 'ºC'),
	(174187, 120, '2014-02-01 00:01:27.000000', 'temperatura', 43.0000, 'ºC'),
	(174188, 120, '2014-02-01 00:01:28.000000', 'temperatura', 280.0000, 'ºC'),
	(174189, 120, '2014-02-01 00:01:29.000000', 'temperatura', 73.0000, 'ºC'),
	(174190, 120, '2014-02-01 00:01:30.000000', 'temperatura', 725.0000, 'ºC'),
	(174191, 120, '2014-02-01 00:01:31.000000', 'temperatura', 1006.0000, 'ºC'),
	(174192, 120, '2014-02-01 00:01:32.000000', 'temperatura', 454.0000, 'ºC'),
	(174193, 120, '2014-02-01 00:01:33.000000', 'temperatura', 453.0000, 'ºC'),
	(174194, 120, '2014-02-01 00:01:34.000000', 'temperatura', 906.0000, 'ºC'),
	(174195, 120, '2014-02-01 00:01:35.000000', 'temperatura', 769.0000, 'ºC'),
	(174196, 120, '2014-02-01 00:01:36.000000', 'temperatura', 1127.0000, 'ºC'),
	(174197, 120, '2014-02-01 00:01:37.000000', 'temperatura', 930.0000, 'ºC'),
	(174198, 120, '2014-02-01 00:01:38.000000', 'temperatura', 68.0000, 'ºC'),
	(174199, 120, '2014-02-01 00:01:39.000000', 'temperatura', 1150.0000, 'ºC'),
	(174200, 120, '2014-02-01 00:01:40.000000', 'temperatura', 749.0000, 'ºC'),
	(174201, 120, '2014-02-01 00:01:41.000000', 'temperatura', 293.0000, 'ºC'),
	(174202, 120, '2014-02-01 00:01:42.000000', 'temperatura', 419.0000, 'ºC'),
	(174203, 120, '2014-02-01 00:01:43.000000', 'temperatura', 17.0000, 'ºC'),
	(174204, 120, '2014-02-01 00:01:44.000000', 'temperatura', 27.0000, 'ºC'),
	(174205, 120, '2014-02-01 00:01:45.000000', 'temperatura', 86.0000, 'ºC'),
	(174206, 120, '2014-02-01 00:01:46.000000', 'temperatura', 349.0000, 'ºC'),
	(174207, 120, '2014-02-01 00:01:47.000000', 'temperatura', 288.0000, 'ºC'),
	(174208, 120, '2014-02-01 00:01:48.000000', 'temperatura', 394.0000, 'ºC'),
	(174209, 120, '2014-02-01 00:01:49.000000', 'temperatura', 1106.0000, 'ºC'),
	(174210, 120, '2014-02-01 00:01:50.000000', 'temperatura', 748.0000, 'ºC'),
	(174211, 120, '2014-02-01 00:01:51.000000', 'temperatura', 422.0000, 'ºC'),
	(174212, 120, '2014-02-01 00:01:52.000000', 'temperatura', 1067.0000, 'ºC'),
	(174213, 120, '2014-02-01 00:01:53.000000', 'temperatura', 469.0000, 'ºC'),
	(174214, 120, '2014-02-01 00:01:54.000000', 'temperatura', 347.0000, 'ºC'),
	(174215, 120, '2014-02-01 00:01:55.000000', 'temperatura', 326.0000, 'ºC'),
	(174216, 120, '2014-02-01 00:01:56.000000', 'temperatura', 591.0000, 'ºC'),
	(174217, 120, '2014-02-01 00:01:57.000000', 'temperatura', 777.0000, 'ºC'),
	(174218, 120, '2014-02-01 00:01:58.000000', 'temperatura', 912.0000, 'ºC'),
	(174219, 120, '2014-02-01 00:01:59.000000', 'temperatura', 1028.0000, 'ºC'),
	(174220, 120, '2014-02-01 00:02:00.000000', 'temperatura', 7.0000, 'ºC'),
	(174221, 120, '2014-02-01 00:02:01.000000', 'temperatura', 550.0000, 'ºC'),
	(174222, 120, '2014-02-01 00:02:02.000000', 'temperatura', 328.0000, 'ºC'),
	(174223, 120, '2014-02-01 00:02:03.000000', 'temperatura', 1193.0000, 'ºC'),
	(174224, 120, '2014-02-01 00:02:04.000000', 'temperatura', 179.0000, 'ºC'),
	(174225, 120, '2014-02-01 00:02:05.000000', 'temperatura', 917.0000, 'ºC'),
	(174226, 120, '2014-02-01 00:02:06.000000', 'temperatura', 448.0000, 'ºC'),
	(174227, 120, '2014-02-01 00:02:07.000000', 'temperatura', 691.0000, 'ºC'),
	(174228, 120, '2014-02-01 00:02:08.000000', 'temperatura', 912.0000, 'ºC'),
	(174229, 120, '2014-02-01 00:02:09.000000', 'temperatura', 89.0000, 'ºC'),
	(174230, 120, '2014-02-01 00:02:10.000000', 'temperatura', 107.0000, 'ºC'),
	(174231, 120, '2014-02-01 00:02:11.000000', 'temperatura', 267.0000, 'ºC'),
	(174232, 120, '2014-02-01 00:02:12.000000', 'temperatura', 1017.0000, 'ºC'),
	(174233, 120, '2014-02-01 00:02:13.000000', 'temperatura', 684.0000, 'ºC'),
	(174234, 120, '2014-02-01 00:02:14.000000', 'temperatura', 368.0000, 'ºC'),
	(174235, 120, '2014-02-01 00:02:15.000000', 'temperatura', 991.0000, 'ºC'),
	(174236, 120, '2014-02-01 00:02:16.000000', 'temperatura', 251.0000, 'ºC'),
	(174237, 120, '2014-02-01 00:02:17.000000', 'temperatura', 684.0000, 'ºC'),
	(174238, 120, '2014-02-01 00:02:18.000000', 'temperatura', 266.0000, 'ºC'),
	(174239, 120, '2014-02-01 00:02:19.000000', 'temperatura', 477.0000, 'ºC'),
	(174240, 120, '2014-02-01 00:02:20.000000', 'temperatura', 391.0000, 'ºC'),
	(174241, 120, '2014-02-01 00:02:21.000000', 'temperatura', 522.0000, 'ºC'),
	(174242, 120, '2014-02-01 00:02:22.000000', 'temperatura', 236.0000, 'ºC'),
	(174243, 120, '2014-02-01 00:02:23.000000', 'temperatura', 817.0000, 'ºC'),
	(174244, 120, '2014-02-01 00:02:24.000000', 'temperatura', 977.0000, 'ºC'),
	(174245, 120, '2014-02-01 00:02:25.000000', 'temperatura', 33.0000, 'ºC'),
	(174246, 120, '2014-02-01 00:02:26.000000', 'temperatura', 837.0000, 'ºC'),
	(174247, 120, '2014-02-01 00:02:27.000000', 'temperatura', 484.0000, 'ºC'),
	(174248, 120, '2014-02-01 00:02:28.000000', 'temperatura', 1109.0000, 'ºC'),
	(174249, 120, '2014-02-01 00:02:29.000000', 'temperatura', 495.0000, 'ºC'),
	(174250, 120, '2014-02-01 00:02:30.000000', 'temperatura', 349.0000, 'ºC'),
	(174251, 120, '2014-02-01 00:02:31.000000', 'temperatura', 262.0000, 'ºC'),
	(174252, 120, '2014-02-01 00:02:32.000000', 'temperatura', 262.0000, 'ºC'),
	(174253, 120, '2014-02-01 00:02:33.000000', 'temperatura', 523.0000, 'ºC'),
	(174254, 120, '2014-02-01 00:02:34.000000', 'temperatura', 630.0000, 'ºC'),
	(174255, 120, '2014-02-01 00:02:35.000000', 'temperatura', 381.0000, 'ºC'),
	(174256, 120, '2014-02-01 00:02:36.000000', 'temperatura', 15.0000, 'ºC'),
	(174257, 120, '2014-02-01 00:02:37.000000', 'temperatura', 131.0000, 'ºC'),
	(174258, 120, '2014-02-01 00:02:38.000000', 'temperatura', 614.0000, 'ºC'),
	(174259, 120, '2014-02-01 00:02:39.000000', 'temperatura', 274.0000, 'ºC'),
	(174260, 120, '2014-02-01 00:02:40.000000', 'temperatura', 732.0000, 'ºC'),
	(174261, 120, '2014-02-01 00:02:41.000000', 'temperatura', 437.0000, 'ºC'),
	(174262, 120, '2014-02-01 00:02:42.000000', 'temperatura', 1189.0000, 'ºC'),
	(174263, 120, '2014-02-01 00:02:43.000000', 'temperatura', 1036.0000, 'ºC'),
	(174264, 120, '2014-02-01 00:02:44.000000', 'temperatura', 412.0000, 'ºC'),
	(174265, 120, '2014-02-01 00:02:45.000000', 'temperatura', 154.0000, 'ºC'),
	(174266, 120, '2014-02-01 00:02:46.000000', 'temperatura', 736.0000, 'ºC'),
	(174267, 120, '2014-02-01 00:02:47.000000', 'temperatura', 816.0000, 'ºC'),
	(174268, 120, '2014-02-01 00:02:48.000000', 'temperatura', 674.0000, 'ºC'),
	(174269, 120, '2014-02-01 00:02:49.000000', 'temperatura', 922.0000, 'ºC'),
	(174270, 120, '2014-02-01 00:02:50.000000', 'temperatura', 188.0000, 'ºC'),
	(174271, 120, '2014-02-01 00:02:51.000000', 'temperatura', 576.0000, 'ºC'),
	(174272, 120, '2014-02-01 00:02:52.000000', 'temperatura', 1114.0000, 'ºC'),
	(174273, 120, '2014-02-01 00:02:53.000000', 'temperatura', 242.0000, 'ºC'),
	(174274, 120, '2014-02-01 00:02:54.000000', 'temperatura', 271.0000, 'ºC'),
	(174275, 120, '2014-02-01 00:02:55.000000', 'temperatura', 630.0000, 'ºC'),
	(174276, 120, '2014-02-01 00:02:56.000000', 'temperatura', 1138.0000, 'ºC'),
	(174277, 120, '2014-02-01 00:02:57.000000', 'temperatura', 199.0000, 'ºC'),
	(174278, 120, '2014-02-01 00:02:58.000000', 'temperatura', 1180.0000, 'ºC'),
	(174279, 120, '2014-02-01 00:02:59.000000', 'temperatura', 505.0000, 'ºC'),
	(174280, 120, '2014-02-01 00:03:00.000000', 'temperatura', 187.0000, 'ºC'),
	(174281, 120, '2014-02-01 00:03:01.000000', 'temperatura', 617.0000, 'ºC'),
	(174282, 120, '2014-02-01 00:03:02.000000', 'temperatura', 127.0000, 'ºC'),
	(174283, 120, '2014-02-01 00:03:03.000000', 'temperatura', 1185.0000, 'ºC'),
	(174284, 120, '2014-02-01 00:03:04.000000', 'temperatura', 744.0000, 'ºC'),
	(174285, 120, '2014-02-01 00:03:05.000000', 'temperatura', 164.0000, 'ºC'),
	(174286, 120, '2014-02-01 00:03:06.000000', 'temperatura', 990.0000, 'ºC'),
	(174287, 120, '2014-02-01 00:03:07.000000', 'temperatura', 860.0000, 'ºC'),
	(174288, 120, '2014-02-01 00:03:08.000000', 'temperatura', 129.0000, 'ºC'),
	(174289, 120, '2014-02-01 00:03:09.000000', 'temperatura', 467.0000, 'ºC'),
	(174290, 120, '2014-02-01 00:03:10.000000', 'temperatura', 748.0000, 'ºC'),
	(174291, 120, '2014-02-01 00:03:11.000000', 'temperatura', 1140.0000, 'ºC'),
	(174292, 120, '2014-02-01 00:03:12.000000', 'temperatura', 1056.0000, 'ºC'),
	(174293, 120, '2014-02-01 00:03:13.000000', 'temperatura', 660.0000, 'ºC'),
	(174294, 120, '2014-02-01 00:03:14.000000', 'temperatura', 134.0000, 'ºC'),
	(174295, 120, '2014-02-01 00:03:15.000000', 'temperatura', 1089.0000, 'ºC'),
	(174296, 120, '2014-02-01 00:03:16.000000', 'temperatura', 243.0000, 'ºC'),
	(174297, 120, '2014-02-01 00:03:17.000000', 'temperatura', 347.0000, 'ºC'),
	(174298, 120, '2014-02-01 00:03:18.000000', 'temperatura', 1009.0000, 'ºC'),
	(174299, 120, '2014-02-01 00:03:19.000000', 'temperatura', 405.0000, 'ºC'),
	(174300, 120, '2014-02-01 00:03:20.000000', 'temperatura', 199.0000, 'ºC'),
	(174301, 120, '2014-02-01 00:03:21.000000', 'temperatura', 978.0000, 'ºC'),
	(174302, 120, '2014-02-01 00:03:22.000000', 'temperatura', 697.0000, 'ºC'),
	(174303, 120, '2014-02-01 00:03:23.000000', 'temperatura', 548.0000, 'ºC'),
	(174304, 120, '2014-02-01 00:03:24.000000', 'temperatura', 651.0000, 'ºC'),
	(174305, 120, '2014-02-01 00:03:25.000000', 'temperatura', 410.0000, 'ºC'),
	(174306, 120, '2014-02-01 00:03:26.000000', 'temperatura', 99.0000, 'ºC'),
	(174307, 120, '2014-02-01 00:03:27.000000', 'temperatura', 466.0000, 'ºC'),
	(174308, 120, '2014-02-01 00:03:28.000000', 'temperatura', 834.0000, 'ºC'),
	(174309, 120, '2014-02-01 00:03:29.000000', 'temperatura', 371.0000, 'ºC'),
	(174310, 120, '2014-02-01 00:03:30.000000', 'temperatura', 556.0000, 'ºC'),
	(174311, 120, '2014-02-01 00:03:31.000000', 'temperatura', 465.0000, 'ºC'),
	(174312, 120, '2014-02-01 00:03:32.000000', 'temperatura', 660.0000, 'ºC'),
	(174313, 120, '2014-02-01 00:03:33.000000', 'temperatura', 703.0000, 'ºC'),
	(174314, 120, '2014-02-01 00:03:34.000000', 'temperatura', 335.0000, 'ºC'),
	(174315, 120, '2014-02-01 00:03:35.000000', 'temperatura', 766.0000, 'ºC'),
	(174316, 120, '2014-02-01 00:03:36.000000', 'temperatura', 427.0000, 'ºC'),
	(174317, 120, '2014-02-01 00:03:37.000000', 'temperatura', 1036.0000, 'ºC'),
	(174318, 120, '2014-02-01 00:03:38.000000', 'temperatura', 299.0000, 'ºC'),
	(174319, 120, '2014-02-01 00:03:39.000000', 'temperatura', 788.0000, 'ºC'),
	(174320, 120, '2014-02-01 00:03:40.000000', 'temperatura', 643.0000, 'ºC'),
	(174321, 120, '2014-02-01 00:03:41.000000', 'temperatura', 854.0000, 'ºC'),
	(174322, 120, '2014-02-01 00:03:42.000000', 'temperatura', 1139.0000, 'ºC'),
	(174323, 120, '2014-02-01 00:03:43.000000', 'temperatura', 735.0000, 'ºC'),
	(174324, 120, '2014-02-01 00:03:44.000000', 'temperatura', 258.0000, 'ºC'),
	(174325, 120, '2014-02-01 00:03:45.000000', 'temperatura', 284.0000, 'ºC'),
	(174326, 120, '2014-02-01 00:03:46.000000', 'temperatura', 646.0000, 'ºC'),
	(174327, 120, '2014-02-01 00:03:47.000000', 'temperatura', 1177.0000, 'ºC'),
	(174328, 120, '2014-02-01 00:03:48.000000', 'temperatura', 351.0000, 'ºC'),
	(174329, 120, '2014-02-01 00:03:49.000000', 'temperatura', 625.0000, 'ºC'),
	(174330, 120, '2014-02-01 00:03:50.000000', 'temperatura', 869.0000, 'ºC'),
	(174331, 120, '2014-02-01 00:03:51.000000', 'temperatura', 74.0000, 'ºC'),
	(174332, 120, '2014-02-01 00:03:52.000000', 'temperatura', 163.0000, 'ºC'),
	(174333, 120, '2014-02-01 00:03:53.000000', 'temperatura', 592.0000, 'ºC'),
	(174334, 120, '2014-02-01 00:03:54.000000', 'temperatura', 73.0000, 'ºC'),
	(174335, 120, '2014-02-01 00:03:55.000000', 'temperatura', 990.0000, 'ºC'),
	(174336, 120, '2014-02-01 00:03:56.000000', 'temperatura', 1130.0000, 'ºC'),
	(174337, 120, '2014-02-01 00:03:57.000000', 'temperatura', 283.0000, 'ºC'),
	(174338, 120, '2014-02-01 00:03:58.000000', 'temperatura', 423.0000, 'ºC'),
	(174339, 120, '2014-02-01 00:03:59.000000', 'temperatura', 67.0000, 'ºC'),
	(174340, 120, '2014-02-01 00:04:00.000000', 'temperatura', 267.0000, 'ºC'),
	(174341, 120, '2014-02-01 00:04:01.000000', 'temperatura', 1136.0000, 'ºC'),
	(174342, 120, '2014-02-01 00:04:02.000000', 'temperatura', 77.0000, 'ºC'),
	(174343, 120, '2014-02-01 00:04:03.000000', 'temperatura', 578.0000, 'ºC'),
	(174344, 120, '2014-02-01 00:04:04.000000', 'temperatura', 262.0000, 'ºC'),
	(174345, 120, '2014-02-01 00:04:05.000000', 'temperatura', 774.0000, 'ºC'),
	(174346, 120, '2014-02-01 00:04:06.000000', 'temperatura', 685.0000, 'ºC'),
	(174347, 120, '2014-02-01 00:04:07.000000', 'temperatura', 1103.0000, 'ºC'),
	(174348, 120, '2014-02-01 00:04:08.000000', 'temperatura', 1060.0000, 'ºC'),
	(174349, 120, '2014-02-01 00:04:09.000000', 'temperatura', 790.0000, 'ºC'),
	(174350, 120, '2014-02-01 00:04:10.000000', 'temperatura', 773.0000, 'ºC'),
	(174351, 120, '2014-02-01 00:04:11.000000', 'temperatura', 293.0000, 'ºC'),
	(174352, 120, '2014-02-01 00:04:12.000000', 'temperatura', 348.0000, 'ºC'),
	(174353, 120, '2014-02-01 00:04:13.000000', 'temperatura', 861.0000, 'ºC'),
	(174354, 120, '2014-02-01 00:04:14.000000', 'temperatura', 860.0000, 'ºC'),
	(174355, 120, '2014-02-01 00:04:15.000000', 'temperatura', 517.0000, 'ºC'),
	(174356, 120, '2014-02-01 00:04:16.000000', 'temperatura', 8.0000, 'ºC'),
	(174357, 120, '2014-02-01 00:04:17.000000', 'temperatura', 888.0000, 'ºC'),
	(174358, 120, '2014-02-01 00:04:18.000000', 'temperatura', 815.0000, 'ºC'),
	(174359, 120, '2014-02-01 00:04:19.000000', 'temperatura', 214.0000, 'ºC'),
	(174360, 120, '2014-02-01 00:04:20.000000', 'temperatura', 1024.0000, 'ºC'),
	(174361, 120, '2014-02-01 00:04:21.000000', 'temperatura', 880.0000, 'ºC'),
	(174362, 120, '2014-02-01 00:04:22.000000', 'temperatura', 127.0000, 'ºC'),
	(174363, 120, '2014-02-01 00:04:23.000000', 'temperatura', 397.0000, 'ºC'),
	(174364, 120, '2014-02-01 00:04:24.000000', 'temperatura', 402.0000, 'ºC'),
	(174365, 120, '2014-02-01 00:04:25.000000', 'temperatura', 821.0000, 'ºC'),
	(174366, 120, '2014-02-01 00:04:26.000000', 'temperatura', 501.0000, 'ºC'),
	(174367, 120, '2014-02-01 00:04:27.000000', 'temperatura', 40.0000, 'ºC'),
	(174368, 120, '2014-02-01 00:04:28.000000', 'temperatura', 1100.0000, 'ºC'),
	(174369, 120, '2014-02-01 00:04:29.000000', 'temperatura', 579.0000, 'ºC'),
	(174370, 120, '2014-02-01 00:04:30.000000', 'temperatura', 798.0000, 'ºC'),
	(174371, 120, '2014-02-01 00:04:31.000000', 'temperatura', 1051.0000, 'ºC'),
	(174372, 120, '2014-02-01 00:04:32.000000', 'temperatura', 464.0000, 'ºC'),
	(174373, 120, '2014-02-01 00:04:33.000000', 'temperatura', 365.0000, 'ºC'),
	(174374, 120, '2014-02-01 00:04:34.000000', 'temperatura', 436.0000, 'ºC'),
	(174375, 120, '2014-02-01 00:04:35.000000', 'temperatura', 1083.0000, 'ºC'),
	(174376, 120, '2014-02-01 00:04:36.000000', 'temperatura', 507.0000, 'ºC'),
	(174377, 120, '2014-02-01 00:04:37.000000', 'temperatura', 488.0000, 'ºC'),
	(174378, 120, '2014-02-01 00:04:38.000000', 'temperatura', 919.0000, 'ºC'),
	(174379, 120, '2014-02-01 00:04:39.000000', 'temperatura', 731.0000, 'ºC'),
	(174380, 120, '2014-02-01 00:04:40.000000', 'temperatura', 899.0000, 'ºC'),
	(174381, 120, '2014-02-01 00:04:41.000000', 'temperatura', 1101.0000, 'ºC'),
	(174382, 120, '2014-02-01 00:04:42.000000', 'temperatura', 409.0000, 'ºC'),
	(174383, 120, '2014-02-01 00:04:43.000000', 'temperatura', 1142.0000, 'ºC'),
	(174384, 120, '2014-02-01 00:04:44.000000', 'temperatura', 886.0000, 'ºC'),
	(174385, 120, '2014-02-01 00:04:45.000000', 'temperatura', 1003.0000, 'ºC'),
	(174386, 120, '2014-02-01 00:04:46.000000', 'temperatura', 1159.0000, 'ºC'),
	(174387, 120, '2014-02-01 00:04:47.000000', 'temperatura', 387.0000, 'ºC'),
	(174388, 120, '2014-02-01 00:04:48.000000', 'temperatura', 857.0000, 'ºC'),
	(174389, 120, '2014-02-01 00:04:49.000000', 'temperatura', 727.0000, 'ºC'),
	(174390, 120, '2014-02-01 00:04:50.000000', 'temperatura', 1063.0000, 'ºC'),
	(174391, 120, '2014-02-01 00:04:51.000000', 'temperatura', 734.0000, 'ºC'),
	(174392, 120, '2014-02-01 00:04:52.000000', 'temperatura', 481.0000, 'ºC'),
	(174393, 120, '2014-02-01 00:04:53.000000', 'temperatura', 203.0000, 'ºC'),
	(174394, 120, '2014-02-01 00:04:54.000000', 'temperatura', 775.0000, 'ºC'),
	(174395, 120, '2014-02-01 00:04:55.000000', 'temperatura', 865.0000, 'ºC'),
	(174396, 120, '2014-02-01 00:04:56.000000', 'temperatura', 800.0000, 'ºC'),
	(174397, 120, '2014-02-01 00:04:57.000000', 'temperatura', 207.0000, 'ºC'),
	(174398, 120, '2014-02-01 00:04:58.000000', 'temperatura', 1035.0000, 'ºC'),
	(174399, 120, '2014-02-01 00:04:59.000000', 'temperatura', 954.0000, 'ºC'),
	(174400, 120, '2014-02-01 00:05:00.000000', 'temperatura', 468.0000, 'ºC'),
	(174401, 120, '2014-02-01 00:05:01.000000', 'temperatura', 675.0000, 'ºC'),
	(174402, 120, '2014-02-01 00:05:02.000000', 'temperatura', 773.0000, 'ºC'),
	(174403, 120, '2014-02-01 00:05:03.000000', 'temperatura', 640.0000, 'ºC'),
	(174404, 120, '2014-02-01 00:05:04.000000', 'temperatura', 884.0000, 'ºC'),
	(174405, 120, '2014-02-01 00:05:05.000000', 'temperatura', 98.0000, 'ºC'),
	(174406, 120, '2014-02-01 00:05:06.000000', 'temperatura', 240.0000, 'ºC'),
	(174407, 120, '2014-02-01 00:05:07.000000', 'temperatura', 904.0000, 'ºC'),
	(174408, 120, '2014-02-01 00:05:08.000000', 'temperatura', 203.0000, 'ºC'),
	(174409, 120, '2014-02-01 00:05:09.000000', 'temperatura', 703.0000, 'ºC'),
	(174410, 120, '2014-02-01 00:05:10.000000', 'temperatura', 505.0000, 'ºC'),
	(174411, 120, '2014-02-01 00:05:11.000000', 'temperatura', 417.0000, 'ºC'),
	(174412, 120, '2014-02-01 00:05:12.000000', 'temperatura', 572.0000, 'ºC'),
	(174413, 120, '2014-02-01 00:05:13.000000', 'temperatura', 408.0000, 'ºC'),
	(174414, 120, '2014-02-01 00:05:14.000000', 'temperatura', 325.0000, 'ºC'),
	(174415, 120, '2014-02-01 00:05:15.000000', 'temperatura', 399.0000, 'ºC'),
	(174416, 120, '2014-02-01 00:05:16.000000', 'temperatura', 1024.0000, 'ºC'),
	(174417, 120, '2014-02-01 00:05:17.000000', 'temperatura', 321.0000, 'ºC'),
	(174418, 120, '2014-02-01 00:05:18.000000', 'temperatura', 936.0000, 'ºC'),
	(174419, 120, '2014-02-01 00:05:19.000000', 'temperatura', 114.0000, 'ºC'),
	(174420, 120, '2014-02-01 00:05:20.000000', 'temperatura', 165.0000, 'ºC'),
	(174421, 120, '2014-02-01 00:05:21.000000', 'temperatura', 484.0000, 'ºC'),
	(174422, 120, '2014-02-01 00:05:22.000000', 'temperatura', 723.0000, 'ºC'),
	(174423, 120, '2014-02-01 00:05:23.000000', 'temperatura', 964.0000, 'ºC'),
	(174424, 120, '2014-02-01 00:05:24.000000', 'temperatura', 250.0000, 'ºC'),
	(174425, 120, '2014-02-01 00:05:25.000000', 'temperatura', 761.0000, 'ºC'),
	(174426, 120, '2014-02-01 00:05:26.000000', 'temperatura', 656.0000, 'ºC'),
	(174427, 120, '2014-02-01 00:05:27.000000', 'temperatura', 995.0000, 'ºC'),
	(174428, 120, '2014-02-01 00:05:28.000000', 'temperatura', 608.0000, 'ºC'),
	(174429, 120, '2014-02-01 00:05:29.000000', 'temperatura', 56.0000, 'ºC'),
	(174430, 120, '2014-02-01 00:05:30.000000', 'temperatura', 856.0000, 'ºC'),
	(174431, 120, '2014-02-01 00:05:31.000000', 'temperatura', 512.0000, 'ºC'),
	(174432, 120, '2014-02-01 00:05:32.000000', 'temperatura', 1195.0000, 'ºC'),
	(174433, 120, '2014-02-01 00:05:33.000000', 'temperatura', 839.0000, 'ºC'),
	(174434, 120, '2014-02-01 00:05:34.000000', 'temperatura', 608.0000, 'ºC'),
	(174435, 120, '2014-02-01 00:05:35.000000', 'temperatura', 525.0000, 'ºC'),
	(174436, 120, '2014-02-01 00:05:36.000000', 'temperatura', 803.0000, 'ºC'),
	(174437, 120, '2014-02-01 00:05:37.000000', 'temperatura', 41.0000, 'ºC'),
	(174438, 120, '2014-02-01 00:05:38.000000', 'temperatura', 195.0000, 'ºC'),
	(174439, 120, '2014-02-01 00:05:39.000000', 'temperatura', 854.0000, 'ºC'),
	(174440, 120, '2014-02-01 00:05:40.000000', 'temperatura', 83.0000, 'ºC'),
	(174441, 120, '2014-02-01 00:05:41.000000', 'temperatura', 255.0000, 'ºC'),
	(174442, 120, '2014-02-01 00:05:42.000000', 'temperatura', 1027.0000, 'ºC'),
	(174443, 120, '2014-02-01 00:05:43.000000', 'temperatura', 770.0000, 'ºC'),
	(174444, 120, '2014-02-01 00:05:44.000000', 'temperatura', 770.0000, 'ºC'),
	(174445, 120, '2014-02-01 00:05:45.000000', 'temperatura', 341.0000, 'ºC'),
	(174446, 120, '2014-02-01 00:05:46.000000', 'temperatura', 597.0000, 'ºC'),
	(174447, 120, '2014-02-01 00:05:47.000000', 'temperatura', 760.0000, 'ºC'),
	(174448, 120, '2014-02-01 00:05:48.000000', 'temperatura', 811.0000, 'ºC'),
	(174449, 120, '2014-02-01 00:05:49.000000', 'temperatura', 574.0000, 'ºC'),
	(174450, 120, '2014-02-01 00:05:50.000000', 'temperatura', 439.0000, 'ºC'),
	(174451, 120, '2014-02-01 00:05:51.000000', 'temperatura', 473.0000, 'ºC'),
	(174452, 120, '2014-02-01 00:05:52.000000', 'temperatura', 1047.0000, 'ºC'),
	(174453, 120, '2014-02-01 00:05:53.000000', 'temperatura', 217.0000, 'ºC'),
	(174454, 120, '2014-02-01 00:05:54.000000', 'temperatura', 344.0000, 'ºC'),
	(174455, 120, '2014-02-01 00:05:55.000000', 'temperatura', 1069.0000, 'ºC'),
	(174456, 120, '2014-02-01 00:05:56.000000', 'temperatura', 715.0000, 'ºC'),
	(174457, 120, '2014-02-01 00:05:57.000000', 'temperatura', 369.0000, 'ºC'),
	(174458, 120, '2014-02-01 00:05:58.000000', 'temperatura', 901.0000, 'ºC'),
	(174459, 120, '2014-02-01 00:05:59.000000', 'temperatura', 999.0000, 'ºC'),
	(174460, 120, '2014-02-01 00:06:00.000000', 'temperatura', 1093.0000, 'ºC'),
	(174461, 120, '2014-02-01 00:06:01.000000', 'temperatura', 68.0000, 'ºC'),
	(174462, 120, '2014-02-01 00:06:02.000000', 'temperatura', 662.0000, 'ºC'),
	(174463, 120, '2014-02-01 00:06:03.000000', 'temperatura', 704.0000, 'ºC'),
	(174464, 120, '2014-02-01 00:06:04.000000', 'temperatura', 337.0000, 'ºC'),
	(174465, 120, '2014-02-01 00:06:05.000000', 'temperatura', 774.0000, 'ºC'),
	(174466, 120, '2014-02-01 00:06:06.000000', 'temperatura', 458.0000, 'ºC'),
	(174467, 120, '2014-02-01 00:06:07.000000', 'temperatura', 1171.0000, 'ºC'),
	(174468, 120, '2014-02-01 00:06:08.000000', 'temperatura', 880.0000, 'ºC'),
	(174469, 120, '2014-02-01 00:06:09.000000', 'temperatura', 887.0000, 'ºC'),
	(174470, 120, '2014-02-01 00:06:10.000000', 'temperatura', 595.0000, 'ºC'),
	(174471, 120, '2014-02-01 00:06:11.000000', 'temperatura', 315.0000, 'ºC'),
	(174472, 120, '2014-02-01 00:06:12.000000', 'temperatura', 988.0000, 'ºC'),
	(174473, 120, '2014-02-01 00:06:13.000000', 'temperatura', 399.0000, 'ºC'),
	(174474, 120, '2014-02-01 00:06:14.000000', 'temperatura', 231.0000, 'ºC'),
	(174475, 120, '2014-02-01 00:06:15.000000', 'temperatura', 1158.0000, 'ºC'),
	(174476, 120, '2014-02-01 00:06:16.000000', 'temperatura', 297.0000, 'ºC'),
	(174477, 120, '2014-02-01 00:06:17.000000', 'temperatura', 410.0000, 'ºC'),
	(174478, 120, '2014-02-01 00:06:18.000000', 'temperatura', 1161.0000, 'ºC'),
	(174479, 120, '2014-02-01 00:06:19.000000', 'temperatura', 976.0000, 'ºC'),
	(174480, 120, '2014-02-01 00:06:20.000000', 'temperatura', 199.0000, 'ºC'),
	(174481, 120, '2014-02-01 00:06:21.000000', 'temperatura', 466.0000, 'ºC'),
	(174482, 120, '2014-02-01 00:06:22.000000', 'temperatura', 532.0000, 'ºC'),
	(174483, 120, '2014-02-01 00:06:23.000000', 'temperatura', 66.0000, 'ºC'),
	(174484, 120, '2014-02-01 00:06:24.000000', 'temperatura', 1131.0000, 'ºC'),
	(174485, 120, '2014-02-01 00:06:25.000000', 'temperatura', 661.0000, 'ºC'),
	(174486, 120, '2014-02-01 00:06:26.000000', 'temperatura', 1111.0000, 'ºC'),
	(174487, 120, '2014-02-01 00:06:27.000000', 'temperatura', 1171.0000, 'ºC'),
	(174488, 120, '2014-02-01 00:06:28.000000', 'temperatura', 122.0000, 'ºC'),
	(174489, 120, '2014-02-01 00:06:29.000000', 'temperatura', 698.0000, 'ºC'),
	(174490, 120, '2014-02-01 00:06:30.000000', 'temperatura', 727.0000, 'ºC'),
	(174491, 120, '2014-02-01 00:06:31.000000', 'temperatura', 338.0000, 'ºC'),
	(174492, 120, '2014-02-01 00:06:32.000000', 'temperatura', 712.0000, 'ºC'),
	(174493, 120, '2014-02-01 00:06:33.000000', 'temperatura', 147.0000, 'ºC'),
	(174494, 120, '2014-02-01 00:06:34.000000', 'temperatura', 1000.0000, 'ºC'),
	(174495, 120, '2014-02-01 00:06:35.000000', 'temperatura', 957.0000, 'ºC'),
	(174496, 120, '2014-02-01 00:06:36.000000', 'temperatura', 585.0000, 'ºC'),
	(174497, 120, '2014-02-01 00:06:37.000000', 'temperatura', 57.0000, 'ºC'),
	(174498, 120, '2014-02-01 00:06:38.000000', 'temperatura', 930.0000, 'ºC'),
	(174499, 120, '2014-02-01 00:06:39.000000', 'temperatura', 878.0000, 'ºC'),
	(174500, 120, '2014-02-01 00:06:40.000000', 'temperatura', 401.0000, 'ºC'),
	(174501, 120, '2014-02-01 00:06:41.000000', 'temperatura', 573.0000, 'ºC'),
	(174502, 120, '2014-02-01 00:06:42.000000', 'temperatura', 461.0000, 'ºC'),
	(174503, 120, '2014-02-01 00:06:43.000000', 'temperatura', 587.0000, 'ºC'),
	(174504, 120, '2014-02-01 00:06:44.000000', 'temperatura', 352.0000, 'ºC'),
	(174505, 120, '2014-02-01 00:06:45.000000', 'temperatura', 1199.0000, 'ºC'),
	(174506, 120, '2014-02-01 00:06:46.000000', 'temperatura', 142.0000, 'ºC'),
	(174507, 120, '2014-02-01 00:06:47.000000', 'temperatura', 713.0000, 'ºC'),
	(174508, 120, '2014-02-01 00:06:48.000000', 'temperatura', 739.0000, 'ºC'),
	(174509, 120, '2014-02-01 00:06:49.000000', 'temperatura', 358.0000, 'ºC'),
	(174510, 120, '2014-02-01 00:06:50.000000', 'temperatura', 770.0000, 'ºC'),
	(174511, 120, '2014-02-01 00:06:51.000000', 'temperatura', 379.0000, 'ºC'),
	(174512, 120, '2014-02-01 00:06:52.000000', 'temperatura', 786.0000, 'ºC'),
	(174513, 120, '2014-02-01 00:06:53.000000', 'temperatura', 394.0000, 'ºC'),
	(174514, 120, '2014-02-01 00:06:54.000000', 'temperatura', 812.0000, 'ºC'),
	(174515, 120, '2014-02-01 00:06:55.000000', 'temperatura', 476.0000, 'ºC'),
	(174516, 120, '2014-02-01 00:06:56.000000', 'temperatura', 1147.0000, 'ºC'),
	(174517, 120, '2014-02-01 00:06:57.000000', 'temperatura', 706.0000, 'ºC'),
	(174518, 120, '2014-02-01 00:06:58.000000', 'temperatura', 88.0000, 'ºC'),
	(174519, 120, '2014-02-01 00:06:59.000000', 'temperatura', 725.0000, 'ºC'),
	(174520, 120, '2014-02-01 00:07:00.000000', 'temperatura', 960.0000, 'ºC'),
	(174521, 120, '2014-02-01 00:07:01.000000', 'temperatura', 228.0000, 'ºC'),
	(174522, 120, '2014-02-01 00:07:02.000000', 'temperatura', 658.0000, 'ºC'),
	(174523, 120, '2014-02-01 00:07:03.000000', 'temperatura', 206.0000, 'ºC'),
	(174524, 120, '2014-02-01 00:07:04.000000', 'temperatura', 257.0000, 'ºC'),
	(174525, 120, '2014-02-01 00:07:05.000000', 'temperatura', 668.0000, 'ºC'),
	(174526, 120, '2014-02-01 00:07:06.000000', 'temperatura', 169.0000, 'ºC'),
	(174527, 120, '2014-02-01 00:07:07.000000', 'temperatura', 42.0000, 'ºC'),
	(174528, 120, '2014-02-01 00:07:08.000000', 'temperatura', 904.0000, 'ºC'),
	(174529, 120, '2014-02-01 00:07:09.000000', 'temperatura', 795.0000, 'ºC'),
	(174530, 120, '2014-02-01 00:07:10.000000', 'temperatura', 61.0000, 'ºC'),
	(174531, 120, '2014-02-01 00:07:11.000000', 'temperatura', 321.0000, 'ºC'),
	(174532, 120, '2014-02-01 00:07:12.000000', 'temperatura', 221.0000, 'ºC'),
	(174533, 120, '2014-02-01 00:07:13.000000', 'temperatura', 144.0000, 'ºC'),
	(174534, 120, '2014-02-01 00:07:14.000000', 'temperatura', 56.0000, 'ºC'),
	(174535, 120, '2014-02-01 00:07:15.000000', 'temperatura', 1050.0000, 'ºC'),
	(174536, 120, '2014-02-01 00:07:16.000000', 'temperatura', 281.0000, 'ºC'),
	(174537, 120, '2014-02-01 00:07:17.000000', 'temperatura', 658.0000, 'ºC'),
	(174538, 120, '2014-02-01 00:07:18.000000', 'temperatura', 48.0000, 'ºC'),
	(174539, 120, '2014-02-01 00:07:19.000000', 'temperatura', 666.0000, 'ºC'),
	(174540, 120, '2014-02-01 00:07:20.000000', 'temperatura', 788.0000, 'ºC'),
	(174541, 120, '2014-02-01 00:07:21.000000', 'temperatura', 742.0000, 'ºC'),
	(174542, 120, '2014-02-01 00:07:22.000000', 'temperatura', 145.0000, 'ºC'),
	(174543, 120, '2014-02-01 00:07:23.000000', 'temperatura', 898.0000, 'ºC'),
	(174544, 120, '2014-02-01 00:07:24.000000', 'temperatura', 458.0000, 'ºC'),
	(174545, 120, '2014-02-01 00:07:25.000000', 'temperatura', 797.0000, 'ºC'),
	(174546, 120, '2014-02-01 00:07:26.000000', 'temperatura', 213.0000, 'ºC'),
	(174547, 120, '2014-02-01 00:07:27.000000', 'temperatura', 1071.0000, 'ºC'),
	(174548, 120, '2014-02-01 00:07:28.000000', 'temperatura', 1119.0000, 'ºC'),
	(174549, 120, '2014-02-01 00:07:29.000000', 'temperatura', 1180.0000, 'ºC'),
	(174550, 120, '2014-02-01 00:07:30.000000', 'temperatura', 146.0000, 'ºC'),
	(174551, 120, '2014-02-01 00:07:31.000000', 'temperatura', 789.0000, 'ºC'),
	(174552, 120, '2014-02-01 00:07:32.000000', 'temperatura', 1108.0000, 'ºC'),
	(174553, 120, '2014-02-01 00:07:33.000000', 'temperatura', 776.0000, 'ºC'),
	(174554, 120, '2014-02-01 00:07:34.000000', 'temperatura', 553.0000, 'ºC'),
	(174555, 120, '2014-02-01 00:07:35.000000', 'temperatura', 438.0000, 'ºC'),
	(174556, 120, '2014-02-01 00:07:36.000000', 'temperatura', 533.0000, 'ºC'),
	(174557, 120, '2014-02-01 00:07:37.000000', 'temperatura', 149.0000, 'ºC'),
	(174558, 120, '2014-02-01 00:07:38.000000', 'temperatura', 348.0000, 'ºC'),
	(174559, 120, '2014-02-01 00:07:39.000000', 'temperatura', 94.0000, 'ºC'),
	(174560, 120, '2014-02-01 00:07:40.000000', 'temperatura', 625.0000, 'ºC'),
	(174561, 120, '2014-02-01 00:07:41.000000', 'temperatura', 443.0000, 'ºC'),
	(174562, 120, '2014-02-01 00:07:42.000000', 'temperatura', 339.0000, 'ºC'),
	(174563, 120, '2014-02-01 00:07:43.000000', 'temperatura', 370.0000, 'ºC'),
	(174564, 120, '2014-02-01 00:07:44.000000', 'temperatura', 833.0000, 'ºC'),
	(174565, 120, '2014-02-01 00:07:45.000000', 'temperatura', 654.0000, 'ºC'),
	(174566, 120, '2014-02-01 00:07:46.000000', 'temperatura', 774.0000, 'ºC'),
	(174567, 120, '2014-02-01 00:07:47.000000', 'temperatura', 707.0000, 'ºC'),
	(174568, 120, '2014-02-01 00:07:48.000000', 'temperatura', 14.0000, 'ºC'),
	(174569, 120, '2014-02-01 00:07:49.000000', 'temperatura', 349.0000, 'ºC'),
	(174570, 120, '2014-02-01 00:07:50.000000', 'temperatura', 505.0000, 'ºC'),
	(174571, 120, '2014-02-01 00:07:51.000000', 'temperatura', 279.0000, 'ºC'),
	(174572, 120, '2014-02-01 00:07:52.000000', 'temperatura', 1080.0000, 'ºC'),
	(174573, 120, '2014-02-01 00:07:53.000000', 'temperatura', 964.0000, 'ºC'),
	(174574, 120, '2014-02-01 00:07:54.000000', 'temperatura', 380.0000, 'ºC'),
	(174575, 120, '2014-02-01 00:07:55.000000', 'temperatura', 207.0000, 'ºC'),
	(174576, 120, '2014-02-01 00:07:56.000000', 'temperatura', 1096.0000, 'ºC'),
	(174577, 120, '2014-02-01 00:07:57.000000', 'temperatura', 59.0000, 'ºC'),
	(174578, 120, '2014-02-01 00:07:58.000000', 'temperatura', 607.0000, 'ºC'),
	(174579, 120, '2014-02-01 00:07:59.000000', 'temperatura', 460.0000, 'ºC'),
	(174580, 120, '2014-02-01 00:08:00.000000', 'temperatura', 479.0000, 'ºC'),
	(174581, 120, '2014-02-01 00:08:01.000000', 'temperatura', 1016.0000, 'ºC'),
	(174582, 120, '2014-02-01 00:08:02.000000', 'temperatura', 42.0000, 'ºC'),
	(174583, 120, '2014-02-01 00:08:03.000000', 'temperatura', 762.0000, 'ºC'),
	(174584, 120, '2014-02-01 00:08:04.000000', 'temperatura', 86.0000, 'ºC'),
	(174585, 120, '2014-02-01 00:08:05.000000', 'temperatura', 545.0000, 'ºC'),
	(174586, 120, '2014-02-01 00:08:06.000000', 'temperatura', 69.0000, 'ºC'),
	(174587, 120, '2014-02-01 00:08:07.000000', 'temperatura', 1107.0000, 'ºC'),
	(174588, 120, '2014-02-01 00:08:08.000000', 'temperatura', 532.0000, 'ºC'),
	(174589, 120, '2014-02-01 00:08:09.000000', 'temperatura', 537.0000, 'ºC'),
	(174590, 120, '2014-02-01 00:08:10.000000', 'temperatura', 1090.0000, 'ºC'),
	(174591, 120, '2014-02-01 00:08:11.000000', 'temperatura', 241.0000, 'ºC'),
	(174592, 120, '2014-02-01 00:08:12.000000', 'temperatura', 335.0000, 'ºC'),
	(174593, 120, '2014-02-01 00:08:13.000000', 'temperatura', 950.0000, 'ºC'),
	(174594, 120, '2014-02-01 00:08:14.000000', 'temperatura', 148.0000, 'ºC'),
	(174595, 120, '2014-02-01 00:08:15.000000', 'temperatura', 289.0000, 'ºC'),
	(174596, 120, '2014-02-01 00:08:16.000000', 'temperatura', 1003.0000, 'ºC'),
	(174597, 120, '2014-02-01 00:08:17.000000', 'temperatura', 549.0000, 'ºC'),
	(174598, 120, '2014-02-01 00:08:18.000000', 'temperatura', 936.0000, 'ºC'),
	(174599, 120, '2014-02-01 00:08:19.000000', 'temperatura', 632.0000, 'ºC'),
	(174600, 120, '2014-02-01 00:08:20.000000', 'temperatura', 353.0000, 'ºC'),
	(174601, 120, '2014-02-01 00:08:21.000000', 'temperatura', 1071.0000, 'ºC'),
	(174602, 120, '2014-02-01 00:08:22.000000', 'temperatura', 696.0000, 'ºC'),
	(174603, 120, '2014-02-01 00:08:23.000000', 'temperatura', 265.0000, 'ºC'),
	(174604, 120, '2014-02-01 00:08:24.000000', 'temperatura', 441.0000, 'ºC'),
	(174605, 120, '2014-02-01 00:08:25.000000', 'temperatura', 209.0000, 'ºC'),
	(174606, 120, '2014-02-01 00:08:26.000000', 'temperatura', 921.0000, 'ºC'),
	(174607, 120, '2014-02-01 00:08:27.000000', 'temperatura', 377.0000, 'ºC'),
	(174608, 120, '2014-02-01 00:08:28.000000', 'temperatura', 326.0000, 'ºC'),
	(174609, 120, '2014-02-01 00:08:29.000000', 'temperatura', 500.0000, 'ºC'),
	(174610, 120, '2014-02-01 00:08:30.000000', 'temperatura', 322.0000, 'ºC'),
	(174611, 120, '2014-02-01 00:08:31.000000', 'temperatura', 109.0000, 'ºC'),
	(174612, 120, '2014-02-01 00:08:32.000000', 'temperatura', 782.0000, 'ºC'),
	(174613, 120, '2014-02-01 00:08:33.000000', 'temperatura', 1181.0000, 'ºC'),
	(174614, 120, '2014-02-01 00:08:34.000000', 'temperatura', 1158.0000, 'ºC'),
	(174615, 120, '2014-02-01 00:08:35.000000', 'temperatura', 1051.0000, 'ºC'),
	(174616, 120, '2014-02-01 00:08:36.000000', 'temperatura', 580.0000, 'ºC'),
	(174617, 120, '2014-02-01 00:08:37.000000', 'temperatura', 946.0000, 'ºC'),
	(174618, 120, '2014-02-01 00:08:38.000000', 'temperatura', 593.0000, 'ºC'),
	(174619, 120, '2014-02-01 00:08:39.000000', 'temperatura', 128.0000, 'ºC'),
	(174620, 120, '2014-02-01 00:08:40.000000', 'temperatura', 61.0000, 'ºC'),
	(174621, 120, '2014-02-01 00:08:41.000000', 'temperatura', 1120.0000, 'ºC'),
	(174622, 120, '2014-02-01 00:08:42.000000', 'temperatura', 618.0000, 'ºC'),
	(174623, 120, '2014-02-01 00:08:43.000000', 'temperatura', 930.0000, 'ºC'),
	(174624, 120, '2014-02-01 00:08:44.000000', 'temperatura', 399.0000, 'ºC'),
	(174625, 120, '2014-02-01 00:08:45.000000', 'temperatura', 403.0000, 'ºC'),
	(174626, 120, '2014-02-01 00:08:46.000000', 'temperatura', 817.0000, 'ºC'),
	(174627, 120, '2014-02-01 00:08:47.000000', 'temperatura', 480.0000, 'ºC'),
	(174628, 120, '2014-02-01 00:08:48.000000', 'temperatura', 1148.0000, 'ºC'),
	(174629, 120, '2014-02-01 00:08:49.000000', 'temperatura', 702.0000, 'ºC'),
	(174630, 120, '2014-02-01 00:08:50.000000', 'temperatura', 66.0000, 'ºC'),
	(174631, 120, '2014-02-01 00:08:51.000000', 'temperatura', 622.0000, 'ºC'),
	(174632, 120, '2014-02-01 00:08:52.000000', 'temperatura', 515.0000, 'ºC'),
	(174633, 120, '2014-02-01 00:08:53.000000', 'temperatura', 707.0000, 'ºC'),
	(174634, 120, '2014-02-01 00:08:54.000000', 'temperatura', 791.0000, 'ºC'),
	(174635, 120, '2014-02-01 00:08:55.000000', 'temperatura', 633.0000, 'ºC'),
	(174636, 120, '2014-02-01 00:08:56.000000', 'temperatura', 793.0000, 'ºC'),
	(174637, 120, '2014-02-01 00:08:57.000000', 'temperatura', 869.0000, 'ºC'),
	(174638, 120, '2014-02-01 00:08:58.000000', 'temperatura', 765.0000, 'ºC'),
	(174639, 120, '2014-02-01 00:08:59.000000', 'temperatura', 18.0000, 'ºC'),
	(174640, 120, '2014-02-01 00:09:00.000000', 'temperatura', 196.0000, 'ºC'),
	(174641, 120, '2014-02-01 00:09:01.000000', 'temperatura', 928.0000, 'ºC'),
	(174642, 120, '2014-02-01 00:09:02.000000', 'temperatura', 452.0000, 'ºC'),
	(174643, 120, '2014-02-01 00:09:03.000000', 'temperatura', 678.0000, 'ºC'),
	(174644, 120, '2014-02-01 00:09:04.000000', 'temperatura', 833.0000, 'ºC'),
	(174645, 120, '2014-02-01 00:09:05.000000', 'temperatura', 932.0000, 'ºC'),
	(174646, 120, '2014-02-01 00:09:06.000000', 'temperatura', 962.0000, 'ºC'),
	(174647, 120, '2014-02-01 00:09:07.000000', 'temperatura', 815.0000, 'ºC'),
	(174648, 120, '2014-02-01 00:09:08.000000', 'temperatura', 1189.0000, 'ºC'),
	(174649, 120, '2014-02-01 00:09:09.000000', 'temperatura', 1100.0000, 'ºC'),
	(174650, 120, '2014-02-01 00:09:10.000000', 'temperatura', 733.0000, 'ºC'),
	(174651, 120, '2014-02-01 00:09:11.000000', 'temperatura', 366.0000, 'ºC'),
	(174652, 120, '2014-02-01 00:09:12.000000', 'temperatura', 833.0000, 'ºC'),
	(174653, 120, '2014-02-01 00:09:13.000000', 'temperatura', 665.0000, 'ºC'),
	(174654, 120, '2014-02-01 00:09:14.000000', 'temperatura', 829.0000, 'ºC'),
	(174655, 120, '2014-02-01 00:09:15.000000', 'temperatura', 949.0000, 'ºC'),
	(174656, 120, '2014-02-01 00:09:16.000000', 'temperatura', 1059.0000, 'ºC'),
	(174657, 120, '2014-02-01 00:09:17.000000', 'temperatura', 46.0000, 'ºC'),
	(174658, 120, '2014-02-01 00:09:18.000000', 'temperatura', 657.0000, 'ºC'),
	(174659, 120, '2014-02-01 00:09:19.000000', 'temperatura', 746.0000, 'ºC'),
	(174660, 120, '2014-02-01 00:09:20.000000', 'temperatura', 559.0000, 'ºC'),
	(174661, 120, '2014-02-01 00:09:21.000000', 'temperatura', 556.0000, 'ºC'),
	(174662, 120, '2014-02-01 00:09:22.000000', 'temperatura', 1104.0000, 'ºC'),
	(174663, 120, '2014-02-01 00:09:23.000000', 'temperatura', 255.0000, 'ºC'),
	(174664, 120, '2014-02-01 00:09:24.000000', 'temperatura', 363.0000, 'ºC'),
	(174665, 120, '2014-02-01 00:09:25.000000', 'temperatura', 1049.0000, 'ºC'),
	(174666, 120, '2014-02-01 00:09:26.000000', 'temperatura', 559.0000, 'ºC'),
	(174667, 120, '2014-02-01 00:09:27.000000', 'temperatura', 848.0000, 'ºC'),
	(174668, 120, '2014-02-01 00:09:28.000000', 'temperatura', 164.0000, 'ºC'),
	(174669, 120, '2014-02-01 00:09:29.000000', 'temperatura', 676.0000, 'ºC'),
	(174670, 120, '2014-02-01 00:09:30.000000', 'temperatura', 489.0000, 'ºC'),
	(174671, 120, '2014-02-01 00:09:31.000000', 'temperatura', 417.0000, 'ºC'),
	(174672, 120, '2014-02-01 00:09:32.000000', 'temperatura', 618.0000, 'ºC'),
	(174673, 120, '2014-02-01 00:09:33.000000', 'temperatura', 639.0000, 'ºC'),
	(174674, 120, '2014-02-01 00:09:34.000000', 'temperatura', 142.0000, 'ºC'),
	(174675, 120, '2014-02-01 00:09:35.000000', 'temperatura', 1193.0000, 'ºC'),
	(174676, 120, '2014-02-01 00:09:36.000000', 'temperatura', 739.0000, 'ºC'),
	(174677, 120, '2014-02-01 00:09:37.000000', 'temperatura', 119.0000, 'ºC'),
	(174678, 120, '2014-02-01 00:09:38.000000', 'temperatura', 776.0000, 'ºC'),
	(174679, 120, '2014-02-01 00:09:39.000000', 'temperatura', 1123.0000, 'ºC'),
	(174680, 120, '2014-02-01 00:09:40.000000', 'temperatura', 888.0000, 'ºC'),
	(174681, 120, '2014-02-01 00:09:41.000000', 'temperatura', 1071.0000, 'ºC'),
	(174682, 120, '2014-02-01 00:09:42.000000', 'temperatura', 291.0000, 'ºC'),
	(174683, 120, '2014-02-01 00:09:43.000000', 'temperatura', 645.0000, 'ºC'),
	(174684, 120, '2014-02-01 00:09:44.000000', 'temperatura', 1151.0000, 'ºC'),
	(174685, 120, '2014-02-01 00:09:45.000000', 'temperatura', 219.0000, 'ºC'),
	(174686, 120, '2014-02-01 00:09:46.000000', 'temperatura', 42.0000, 'ºC'),
	(174687, 120, '2014-02-01 00:09:47.000000', 'temperatura', 754.0000, 'ºC'),
	(174688, 120, '2014-02-01 00:09:48.000000', 'temperatura', 46.0000, 'ºC'),
	(174689, 120, '2014-02-01 00:09:49.000000', 'temperatura', 367.0000, 'ºC'),
	(174690, 120, '2014-02-01 00:09:50.000000', 'temperatura', 496.0000, 'ºC'),
	(174691, 120, '2014-02-01 00:09:51.000000', 'temperatura', 182.0000, 'ºC'),
	(174692, 120, '2014-02-01 00:09:52.000000', 'temperatura', 620.0000, 'ºC'),
	(174693, 120, '2014-02-01 00:09:53.000000', 'temperatura', 156.0000, 'ºC'),
	(174694, 120, '2014-02-01 00:09:54.000000', 'temperatura', 119.0000, 'ºC'),
	(174695, 120, '2014-02-01 00:09:55.000000', 'temperatura', 130.0000, 'ºC'),
	(174696, 120, '2014-02-01 00:09:56.000000', 'temperatura', 291.0000, 'ºC'),
	(174697, 120, '2014-02-01 00:09:57.000000', 'temperatura', 1065.0000, 'ºC'),
	(174698, 120, '2014-02-01 00:09:58.000000', 'temperatura', 852.0000, 'ºC'),
	(174699, 120, '2014-02-01 00:09:59.000000', 'temperatura', 1065.0000, 'ºC'),
	(174700, 120, '2014-02-01 00:10:00.000000', 'temperatura', 369.0000, 'ºC'),
	(174701, 120, '2014-02-01 00:10:01.000000', 'temperatura', 1051.0000, 'ºC'),
	(174702, 120, '2014-02-01 00:10:02.000000', 'temperatura', 548.0000, 'ºC'),
	(174703, 120, '2014-02-01 00:10:03.000000', 'temperatura', 790.0000, 'ºC'),
	(174704, 120, '2014-02-01 00:10:04.000000', 'temperatura', 1105.0000, 'ºC'),
	(174705, 120, '2014-02-01 00:10:05.000000', 'temperatura', 754.0000, 'ºC'),
	(174706, 120, '2014-02-01 00:10:06.000000', 'temperatura', 455.0000, 'ºC'),
	(174707, 120, '2014-02-01 00:10:07.000000', 'temperatura', 13.0000, 'ºC'),
	(174708, 120, '2014-02-01 00:10:08.000000', 'temperatura', 1101.0000, 'ºC'),
	(174709, 120, '2014-02-01 00:10:09.000000', 'temperatura', 666.0000, 'ºC'),
	(174710, 120, '2014-02-01 00:10:10.000000', 'temperatura', 29.0000, 'ºC'),
	(174711, 120, '2014-02-01 00:10:11.000000', 'temperatura', 549.0000, 'ºC'),
	(174712, 120, '2014-02-01 00:10:12.000000', 'temperatura', 256.0000, 'ºC'),
	(174713, 120, '2014-02-01 00:10:13.000000', 'temperatura', 834.0000, 'ºC'),
	(174714, 120, '2014-02-01 00:10:14.000000', 'temperatura', 1004.0000, 'ºC'),
	(174715, 120, '2014-02-01 00:10:15.000000', 'temperatura', 117.0000, 'ºC'),
	(174716, 120, '2014-02-01 00:10:16.000000', 'temperatura', 1173.0000, 'ºC'),
	(174717, 120, '2014-02-01 00:10:17.000000', 'temperatura', 713.0000, 'ºC'),
	(174718, 120, '2014-02-01 00:10:18.000000', 'temperatura', 48.0000, 'ºC'),
	(174719, 120, '2014-02-01 00:10:19.000000', 'temperatura', 502.0000, 'ºC'),
	(174720, 120, '2014-02-01 00:10:20.000000', 'temperatura', 1167.0000, 'ºC'),
	(174721, 120, '2014-02-01 00:10:21.000000', 'temperatura', 731.0000, 'ºC'),
	(174722, 120, '2014-02-01 00:10:22.000000', 'temperatura', 151.0000, 'ºC'),
	(174723, 120, '2014-02-01 00:10:23.000000', 'temperatura', 966.0000, 'ºC'),
	(174724, 120, '2014-02-01 00:10:24.000000', 'temperatura', 775.0000, 'ºC'),
	(174725, 120, '2014-02-01 00:10:25.000000', 'temperatura', 979.0000, 'ºC'),
	(174726, 120, '2014-02-01 00:10:26.000000', 'temperatura', 172.0000, 'ºC'),
	(174727, 120, '2014-02-01 00:10:27.000000', 'temperatura', 321.0000, 'ºC'),
	(174728, 120, '2014-02-01 00:10:28.000000', 'temperatura', 1091.0000, 'ºC'),
	(174729, 120, '2014-02-01 00:10:29.000000', 'temperatura', 893.0000, 'ºC'),
	(174730, 120, '2014-02-01 00:10:30.000000', 'temperatura', 1190.0000, 'ºC'),
	(174731, 120, '2014-02-01 00:10:31.000000', 'temperatura', 872.0000, 'ºC'),
	(174732, 120, '2014-02-01 00:10:32.000000', 'temperatura', 792.0000, 'ºC'),
	(174733, 120, '2014-02-01 00:10:33.000000', 'temperatura', 143.0000, 'ºC'),
	(174734, 120, '2014-02-01 00:10:34.000000', 'temperatura', 741.0000, 'ºC'),
	(174735, 120, '2014-02-01 00:10:35.000000', 'temperatura', 877.0000, 'ºC'),
	(174736, 120, '2014-02-01 00:10:36.000000', 'temperatura', 960.0000, 'ºC'),
	(174737, 120, '2014-02-01 00:10:37.000000', 'temperatura', 970.0000, 'ºC'),
	(174738, 120, '2014-02-01 00:10:38.000000', 'temperatura', 771.0000, 'ºC'),
	(174739, 120, '2014-02-01 00:10:39.000000', 'temperatura', 945.0000, 'ºC'),
	(174740, 120, '2014-02-01 00:10:40.000000', 'temperatura', 14.0000, 'ºC'),
	(174741, 120, '2014-02-01 00:10:41.000000', 'temperatura', 834.0000, 'ºC'),
	(174742, 120, '2014-02-01 00:10:42.000000', 'temperatura', 529.0000, 'ºC'),
	(174743, 120, '2014-02-01 00:10:43.000000', 'temperatura', 145.0000, 'ºC'),
	(174744, 120, '2014-02-01 00:10:44.000000', 'temperatura', 339.0000, 'ºC'),
	(174745, 120, '2014-02-01 00:10:45.000000', 'temperatura', 61.0000, 'ºC'),
	(174746, 120, '2014-02-01 00:10:46.000000', 'temperatura', 489.0000, 'ºC'),
	(174747, 120, '2014-02-01 00:10:47.000000', 'temperatura', 1062.0000, 'ºC'),
	(174748, 120, '2014-02-01 00:10:48.000000', 'temperatura', 244.0000, 'ºC'),
	(174749, 120, '2014-02-01 00:10:49.000000', 'temperatura', 433.0000, 'ºC'),
	(174750, 120, '2014-02-01 00:10:50.000000', 'temperatura', 233.0000, 'ºC'),
	(174751, 120, '2014-02-01 00:10:51.000000', 'temperatura', 1066.0000, 'ºC'),
	(174752, 120, '2014-02-01 00:10:52.000000', 'temperatura', 1031.0000, 'ºC'),
	(174753, 120, '2014-02-01 00:10:53.000000', 'temperatura', 758.0000, 'ºC'),
	(174754, 120, '2014-02-01 00:10:54.000000', 'temperatura', 699.0000, 'ºC'),
	(174755, 120, '2014-02-01 00:10:55.000000', 'temperatura', 21.0000, 'ºC'),
	(174756, 120, '2014-02-01 00:10:56.000000', 'temperatura', 407.0000, 'ºC'),
	(174757, 120, '2014-02-01 00:10:57.000000', 'temperatura', 774.0000, 'ºC'),
	(174758, 120, '2014-02-01 00:10:58.000000', 'temperatura', 247.0000, 'ºC'),
	(174759, 120, '2014-02-01 00:10:59.000000', 'temperatura', 116.0000, 'ºC'),
	(174760, 120, '2014-02-01 00:11:00.000000', 'temperatura', 1040.0000, 'ºC'),
	(174761, 120, '2014-02-01 00:11:01.000000', 'temperatura', 50.0000, 'ºC'),
	(174762, 120, '2014-02-01 00:11:02.000000', 'temperatura', 731.0000, 'ºC'),
	(174763, 120, '2014-02-01 00:11:03.000000', 'temperatura', 1105.0000, 'ºC'),
	(174764, 120, '2014-02-01 00:11:04.000000', 'temperatura', 932.0000, 'ºC'),
	(174765, 120, '2014-02-01 00:11:05.000000', 'temperatura', 147.0000, 'ºC'),
	(174766, 120, '2014-02-01 00:11:06.000000', 'temperatura', 339.0000, 'ºC'),
	(174767, 120, '2014-02-01 00:11:07.000000', 'temperatura', 54.0000, 'ºC'),
	(174768, 120, '2014-02-01 00:11:08.000000', 'temperatura', 453.0000, 'ºC'),
	(174769, 120, '2014-02-01 00:11:09.000000', 'temperatura', 904.0000, 'ºC'),
	(174770, 120, '2014-02-01 00:11:10.000000', 'temperatura', 760.0000, 'ºC'),
	(174771, 120, '2014-02-01 00:11:11.000000', 'temperatura', 1089.0000, 'ºC'),
	(174772, 120, '2014-02-01 00:11:12.000000', 'temperatura', 766.0000, 'ºC'),
	(174773, 120, '2014-02-01 00:11:13.000000', 'temperatura', 562.0000, 'ºC'),
	(174774, 120, '2014-02-01 00:11:14.000000', 'temperatura', 512.0000, 'ºC'),
	(174775, 120, '2014-02-01 00:11:15.000000', 'temperatura', 877.0000, 'ºC'),
	(174776, 120, '2014-02-01 00:11:16.000000', 'temperatura', 449.0000, 'ºC'),
	(174777, 120, '2014-02-01 00:11:17.000000', 'temperatura', 816.0000, 'ºC'),
	(174778, 120, '2014-02-01 00:11:18.000000', 'temperatura', 332.0000, 'ºC'),
	(174779, 120, '2014-02-01 00:11:19.000000', 'temperatura', 412.0000, 'ºC'),
	(174780, 120, '2014-02-01 00:11:20.000000', 'temperatura', 1065.0000, 'ºC'),
	(174781, 120, '2014-02-01 00:11:21.000000', 'temperatura', 488.0000, 'ºC'),
	(174782, 120, '2014-02-01 00:11:22.000000', 'temperatura', 448.0000, 'ºC'),
	(174783, 120, '2014-02-01 00:11:23.000000', 'temperatura', 778.0000, 'ºC'),
	(174784, 120, '2014-02-01 00:11:24.000000', 'temperatura', 143.0000, 'ºC'),
	(174785, 120, '2014-02-01 00:11:25.000000', 'temperatura', 781.0000, 'ºC'),
	(174786, 120, '2014-02-01 00:11:26.000000', 'temperatura', 1078.0000, 'ºC'),
	(174787, 120, '2014-02-01 00:11:27.000000', 'temperatura', 646.0000, 'ºC'),
	(174788, 120, '2014-02-01 00:11:28.000000', 'temperatura', 1199.0000, 'ºC'),
	(174789, 120, '2014-02-01 00:11:29.000000', 'temperatura', 456.0000, 'ºC'),
	(174790, 120, '2014-02-01 00:11:30.000000', 'temperatura', 1085.0000, 'ºC'),
	(174791, 120, '2014-02-01 00:11:31.000000', 'temperatura', 458.0000, 'ºC'),
	(174792, 120, '2014-02-01 00:11:32.000000', 'temperatura', 233.0000, 'ºC'),
	(174793, 120, '2014-02-01 00:11:33.000000', 'temperatura', 994.0000, 'ºC'),
	(174794, 120, '2014-02-01 00:11:34.000000', 'temperatura', 672.0000, 'ºC'),
	(174795, 120, '2014-02-01 00:11:35.000000', 'temperatura', 378.0000, 'ºC'),
	(174796, 120, '2014-02-01 00:11:36.000000', 'temperatura', 1076.0000, 'ºC'),
	(174797, 120, '2014-02-01 00:11:37.000000', 'temperatura', 643.0000, 'ºC'),
	(174798, 120, '2014-02-01 00:11:38.000000', 'temperatura', 1190.0000, 'ºC'),
	(174799, 120, '2014-02-01 00:11:39.000000', 'temperatura', 419.0000, 'ºC'),
	(174800, 120, '2014-02-01 00:11:40.000000', 'temperatura', 926.0000, 'ºC'),
	(174801, 120, '2014-02-01 00:11:41.000000', 'temperatura', 975.0000, 'ºC'),
	(174802, 120, '2014-02-01 00:11:42.000000', 'temperatura', 895.0000, 'ºC'),
	(174803, 120, '2014-02-01 00:11:43.000000', 'temperatura', 353.0000, 'ºC'),
	(174804, 120, '2014-02-01 00:11:44.000000', 'temperatura', 281.0000, 'ºC'),
	(174805, 120, '2014-02-01 00:11:45.000000', 'temperatura', 345.0000, 'ºC'),
	(174806, 120, '2014-02-01 00:11:46.000000', 'temperatura', 883.0000, 'ºC'),
	(174807, 120, '2014-02-01 00:11:47.000000', 'temperatura', 980.0000, 'ºC'),
	(174808, 120, '2014-02-01 00:11:48.000000', 'temperatura', 1053.0000, 'ºC'),
	(174809, 120, '2014-02-01 00:11:49.000000', 'temperatura', 1127.0000, 'ºC'),
	(174810, 120, '2014-02-01 00:11:50.000000', 'temperatura', 73.0000, 'ºC'),
	(174811, 120, '2014-02-01 00:11:51.000000', 'temperatura', 587.0000, 'ºC'),
	(174812, 120, '2014-02-01 00:11:52.000000', 'temperatura', 317.0000, 'ºC'),
	(174813, 120, '2014-02-01 00:11:53.000000', 'temperatura', 1023.0000, 'ºC'),
	(174814, 120, '2014-02-01 00:11:54.000000', 'temperatura', 565.0000, 'ºC'),
	(174815, 120, '2014-02-01 00:11:55.000000', 'temperatura', 957.0000, 'ºC'),
	(174816, 120, '2014-02-01 00:11:56.000000', 'temperatura', 691.0000, 'ºC'),
	(174817, 120, '2014-02-01 00:11:57.000000', 'temperatura', 583.0000, 'ºC'),
	(174818, 120, '2014-02-01 00:11:58.000000', 'temperatura', 841.0000, 'ºC'),
	(174819, 120, '2014-02-01 00:11:59.000000', 'temperatura', 58.0000, 'ºC'),
	(174820, 120, '2014-02-01 00:12:00.000000', 'temperatura', 168.0000, 'ºC'),
	(174821, 120, '2014-02-01 00:12:01.000000', 'temperatura', 664.0000, 'ºC'),
	(174822, 120, '2014-02-01 00:12:02.000000', 'temperatura', 420.0000, 'ºC'),
	(174823, 120, '2014-02-01 00:12:03.000000', 'temperatura', 106.0000, 'ºC'),
	(174824, 120, '2014-02-01 00:12:04.000000', 'temperatura', 472.0000, 'ºC'),
	(174825, 120, '2014-02-01 00:12:05.000000', 'temperatura', 840.0000, 'ºC'),
	(174826, 120, '2014-02-01 00:12:06.000000', 'temperatura', 387.0000, 'ºC'),
	(174827, 120, '2014-02-01 00:12:07.000000', 'temperatura', 613.0000, 'ºC'),
	(174828, 120, '2014-02-01 00:12:08.000000', 'temperatura', 706.0000, 'ºC'),
	(174829, 120, '2014-02-01 00:12:09.000000', 'temperatura', 491.0000, 'ºC'),
	(174830, 120, '2014-02-01 00:12:10.000000', 'temperatura', 339.0000, 'ºC'),
	(174831, 120, '2014-02-01 00:12:11.000000', 'temperatura', 221.0000, 'ºC'),
	(174832, 120, '2014-02-01 00:12:12.000000', 'temperatura', 88.0000, 'ºC'),
	(174833, 120, '2014-02-01 00:12:13.000000', 'temperatura', 977.0000, 'ºC'),
	(174834, 120, '2014-02-01 00:12:14.000000', 'temperatura', 1021.0000, 'ºC'),
	(174835, 120, '2014-02-01 00:12:15.000000', 'temperatura', 977.0000, 'ºC'),
	(174836, 120, '2014-02-01 00:12:16.000000', 'temperatura', 623.0000, 'ºC'),
	(174837, 120, '2014-02-01 00:12:17.000000', 'temperatura', 184.0000, 'ºC'),
	(174838, 120, '2014-02-01 00:12:18.000000', 'temperatura', 250.0000, 'ºC'),
	(174839, 120, '2014-02-01 00:12:19.000000', 'temperatura', 701.0000, 'ºC'),
	(174840, 120, '2014-02-01 00:12:20.000000', 'temperatura', 352.0000, 'ºC'),
	(174841, 120, '2014-02-01 00:12:21.000000', 'temperatura', 860.0000, 'ºC'),
	(174842, 120, '2014-02-01 00:12:22.000000', 'temperatura', 842.0000, 'ºC'),
	(174843, 120, '2014-02-01 00:12:23.000000', 'temperatura', 434.0000, 'ºC'),
	(174844, 120, '2014-02-01 00:12:24.000000', 'temperatura', 842.0000, 'ºC'),
	(174845, 120, '2014-02-01 00:12:25.000000', 'temperatura', 509.0000, 'ºC'),
	(174846, 120, '2014-02-01 00:12:26.000000', 'temperatura', 18.0000, 'ºC'),
	(174847, 120, '2014-02-01 00:12:27.000000', 'temperatura', 965.0000, 'ºC'),
	(174848, 120, '2014-02-01 00:12:28.000000', 'temperatura', 1170.0000, 'ºC'),
	(174849, 120, '2014-02-01 00:12:29.000000', 'temperatura', 558.0000, 'ºC'),
	(174850, 120, '2014-02-01 00:12:30.000000', 'temperatura', 479.0000, 'ºC'),
	(174851, 120, '2014-02-01 00:12:31.000000', 'temperatura', 723.0000, 'ºC'),
	(174852, 120, '2014-02-01 00:12:32.000000', 'temperatura', 977.0000, 'ºC'),
	(174853, 120, '2014-02-01 00:12:33.000000', 'temperatura', 317.0000, 'ºC'),
	(174854, 120, '2014-02-01 00:12:34.000000', 'temperatura', 1054.0000, 'ºC'),
	(174855, 120, '2014-02-01 00:12:35.000000', 'temperatura', 718.0000, 'ºC'),
	(174856, 120, '2014-02-01 00:12:36.000000', 'temperatura', 431.0000, 'ºC'),
	(174857, 120, '2014-02-01 00:12:37.000000', 'temperatura', 1199.0000, 'ºC'),
	(174858, 120, '2014-02-01 00:12:38.000000', 'temperatura', 1103.0000, 'ºC'),
	(174859, 120, '2014-02-01 00:12:39.000000', 'temperatura', 718.0000, 'ºC'),
	(174860, 120, '2014-02-01 00:12:40.000000', 'temperatura', 282.0000, 'ºC'),
	(174861, 120, '2014-02-01 00:12:41.000000', 'temperatura', 456.0000, 'ºC'),
	(174862, 120, '2014-02-01 00:12:42.000000', 'temperatura', 235.0000, 'ºC'),
	(174863, 120, '2014-02-01 00:12:43.000000', 'temperatura', 1006.0000, 'ºC'),
	(174864, 120, '2014-02-01 00:12:44.000000', 'temperatura', 725.0000, 'ºC'),
	(174865, 120, '2014-02-01 00:12:45.000000', 'temperatura', 610.0000, 'ºC'),
	(174866, 120, '2014-02-01 00:12:46.000000', 'temperatura', 875.0000, 'ºC'),
	(174867, 120, '2014-02-01 00:12:47.000000', 'temperatura', 143.0000, 'ºC'),
	(174868, 120, '2014-02-01 00:12:48.000000', 'temperatura', 493.0000, 'ºC'),
	(174869, 120, '2014-02-01 00:12:49.000000', 'temperatura', 838.0000, 'ºC'),
	(174870, 120, '2014-02-01 00:12:50.000000', 'temperatura', 310.0000, 'ºC'),
	(174871, 120, '2014-02-01 00:12:51.000000', 'temperatura', 235.0000, 'ºC'),
	(174872, 120, '2014-02-01 00:12:52.000000', 'temperatura', 246.0000, 'ºC'),
	(174873, 120, '2014-02-01 00:12:53.000000', 'temperatura', 525.0000, 'ºC'),
	(174874, 120, '2014-02-01 00:12:54.000000', 'temperatura', 686.0000, 'ºC'),
	(174875, 120, '2014-02-01 00:12:55.000000', 'temperatura', 657.0000, 'ºC'),
	(174876, 120, '2014-02-01 00:12:56.000000', 'temperatura', 27.0000, 'ºC'),
	(174877, 120, '2014-02-01 00:12:57.000000', 'temperatura', 566.0000, 'ºC'),
	(174878, 120, '2014-02-01 00:12:58.000000', 'temperatura', 347.0000, 'ºC'),
	(174879, 120, '2014-02-01 00:12:59.000000', 'temperatura', 39.0000, 'ºC'),
	(174880, 120, '2014-02-01 00:13:00.000000', 'temperatura', 355.0000, 'ºC'),
	(174881, 120, '2014-02-01 00:13:01.000000', 'temperatura', 460.0000, 'ºC'),
	(174882, 120, '2014-02-01 00:13:02.000000', 'temperatura', 33.0000, 'ºC'),
	(174883, 120, '2014-02-01 00:13:03.000000', 'temperatura', 1188.0000, 'ºC'),
	(174884, 120, '2014-02-01 00:13:04.000000', 'temperatura', 1038.0000, 'ºC'),
	(174885, 120, '2014-02-01 00:13:05.000000', 'temperatura', 429.0000, 'ºC'),
	(174886, 120, '2014-02-01 00:13:06.000000', 'temperatura', 232.0000, 'ºC'),
	(174887, 120, '2014-02-01 00:13:07.000000', 'temperatura', 1073.0000, 'ºC'),
	(174888, 120, '2014-02-01 00:13:08.000000', 'temperatura', 1069.0000, 'ºC'),
	(174889, 120, '2014-02-01 00:13:09.000000', 'temperatura', 926.0000, 'ºC'),
	(174890, 120, '2014-02-01 00:13:10.000000', 'temperatura', 225.0000, 'ºC'),
	(174891, 120, '2014-02-01 00:13:11.000000', 'temperatura', 746.0000, 'ºC'),
	(174892, 120, '2014-02-01 00:13:12.000000', 'temperatura', 658.0000, 'ºC'),
	(174893, 120, '2014-02-01 00:13:13.000000', 'temperatura', 1050.0000, 'ºC'),
	(174894, 120, '2014-02-01 00:13:14.000000', 'temperatura', 877.0000, 'ºC'),
	(174895, 120, '2014-02-01 00:13:15.000000', 'temperatura', 34.0000, 'ºC'),
	(174896, 120, '2014-02-01 00:13:16.000000', 'temperatura', 1139.0000, 'ºC'),
	(174897, 120, '2014-02-01 00:13:17.000000', 'temperatura', 796.0000, 'ºC'),
	(174898, 120, '2014-02-01 00:13:18.000000', 'temperatura', 562.0000, 'ºC'),
	(174899, 120, '2014-02-01 00:13:19.000000', 'temperatura', 422.0000, 'ºC'),
	(174900, 120, '2014-02-01 00:13:20.000000', 'temperatura', 427.0000, 'ºC'),
	(174901, 120, '2014-02-01 00:13:21.000000', 'temperatura', 866.0000, 'ºC'),
	(174902, 120, '2014-02-01 00:13:22.000000', 'temperatura', 652.0000, 'ºC'),
	(174903, 120, '2014-02-01 00:13:23.000000', 'temperatura', 663.0000, 'ºC'),
	(174904, 120, '2014-02-01 00:13:24.000000', 'temperatura', 159.0000, 'ºC'),
	(174905, 120, '2014-02-01 00:13:25.000000', 'temperatura', 6.0000, 'ºC'),
	(174906, 120, '2014-02-01 00:13:26.000000', 'temperatura', 753.0000, 'ºC'),
	(174907, 120, '2014-02-01 00:13:27.000000', 'temperatura', 147.0000, 'ºC'),
	(174908, 120, '2014-02-01 00:13:28.000000', 'temperatura', 875.0000, 'ºC'),
	(174909, 120, '2014-02-01 00:13:29.000000', 'temperatura', 338.0000, 'ºC'),
	(174910, 120, '2014-02-01 00:13:30.000000', 'temperatura', 262.0000, 'ºC'),
	(174911, 120, '2014-02-01 00:13:31.000000', 'temperatura', 299.0000, 'ºC'),
	(174912, 120, '2014-02-01 00:13:32.000000', 'temperatura', 709.0000, 'ºC'),
	(174913, 120, '2014-02-01 00:13:33.000000', 'temperatura', 248.0000, 'ºC'),
	(174914, 120, '2014-02-01 00:13:34.000000', 'temperatura', 314.0000, 'ºC'),
	(174915, 120, '2014-02-01 00:13:35.000000', 'temperatura', 827.0000, 'ºC'),
	(174916, 120, '2014-02-01 00:13:36.000000', 'temperatura', 794.0000, 'ºC'),
	(174917, 120, '2014-02-01 00:13:37.000000', 'temperatura', 287.0000, 'ºC'),
	(174918, 120, '2014-02-01 00:13:38.000000', 'temperatura', 256.0000, 'ºC'),
	(174919, 120, '2014-02-01 00:13:39.000000', 'temperatura', 419.0000, 'ºC'),
	(174920, 120, '2014-02-01 00:13:40.000000', 'temperatura', 129.0000, 'ºC'),
	(174921, 120, '2014-02-01 00:13:41.000000', 'temperatura', 586.0000, 'ºC'),
	(174922, 120, '2014-02-01 00:13:42.000000', 'temperatura', 144.0000, 'ºC'),
	(174923, 120, '2014-02-01 00:13:43.000000', 'temperatura', 161.0000, 'ºC'),
	(174924, 120, '2014-02-01 00:13:44.000000', 'temperatura', 373.0000, 'ºC'),
	(174925, 120, '2014-02-01 00:13:45.000000', 'temperatura', 184.0000, 'ºC'),
	(174926, 120, '2014-02-01 00:13:46.000000', 'temperatura', 1003.0000, 'ºC'),
	(174927, 120, '2014-02-01 00:13:47.000000', 'temperatura', 861.0000, 'ºC'),
	(174928, 120, '2014-02-01 00:13:48.000000', 'temperatura', 99.0000, 'ºC'),
	(174929, 120, '2014-02-01 00:13:49.000000', 'temperatura', 311.0000, 'ºC'),
	(174930, 120, '2014-02-01 00:13:50.000000', 'temperatura', 60.0000, 'ºC'),
	(174931, 120, '2014-02-01 00:13:51.000000', 'temperatura', 567.0000, 'ºC'),
	(174932, 120, '2014-02-01 00:13:52.000000', 'temperatura', 253.0000, 'ºC'),
	(174933, 120, '2014-02-01 00:13:53.000000', 'temperatura', 767.0000, 'ºC'),
	(174934, 120, '2014-02-01 00:13:54.000000', 'temperatura', 677.0000, 'ºC'),
	(174935, 120, '2014-02-01 00:13:55.000000', 'temperatura', 1085.0000, 'ºC'),
	(174936, 120, '2014-02-01 00:13:56.000000', 'temperatura', 996.0000, 'ºC'),
	(174937, 120, '2014-02-01 00:13:57.000000', 'temperatura', 522.0000, 'ºC'),
	(174938, 120, '2014-02-01 00:13:58.000000', 'temperatura', 824.0000, 'ºC'),
	(174939, 120, '2014-02-01 00:13:59.000000', 'temperatura', 153.0000, 'ºC'),
	(174940, 120, '2014-02-01 00:14:00.000000', 'temperatura', 692.0000, 'ºC'),
	(174941, 120, '2014-02-01 00:14:01.000000', 'temperatura', 605.0000, 'ºC'),
	(174942, 120, '2014-02-01 00:14:02.000000', 'temperatura', 947.0000, 'ºC'),
	(174943, 120, '2014-02-01 00:14:03.000000', 'temperatura', 520.0000, 'ºC'),
	(174944, 120, '2014-02-01 00:14:04.000000', 'temperatura', 958.0000, 'ºC'),
	(174945, 120, '2014-02-01 00:14:05.000000', 'temperatura', 834.0000, 'ºC'),
	(174946, 120, '2014-02-01 00:14:06.000000', 'temperatura', 96.0000, 'ºC'),
	(174947, 120, '2014-02-01 00:14:07.000000', 'temperatura', 377.0000, 'ºC'),
	(174948, 120, '2014-02-01 00:14:08.000000', 'temperatura', 398.0000, 'ºC'),
	(174949, 120, '2014-02-01 00:14:09.000000', 'temperatura', 861.0000, 'ºC'),
	(174950, 120, '2014-02-01 00:14:10.000000', 'temperatura', 711.0000, 'ºC'),
	(174951, 120, '2014-02-01 00:14:11.000000', 'temperatura', 973.0000, 'ºC'),
	(174952, 120, '2014-02-01 00:14:12.000000', 'temperatura', 334.0000, 'ºC'),
	(174953, 120, '2014-02-01 00:14:13.000000', 'temperatura', 1150.0000, 'ºC'),
	(174954, 120, '2014-02-01 00:14:14.000000', 'temperatura', 1149.0000, 'ºC'),
	(174955, 120, '2014-02-01 00:14:15.000000', 'temperatura', 1095.0000, 'ºC'),
	(174956, 120, '2014-02-01 00:14:16.000000', 'temperatura', 827.0000, 'ºC'),
	(174957, 120, '2014-02-01 00:14:17.000000', 'temperatura', 854.0000, 'ºC'),
	(174958, 120, '2014-02-01 00:14:18.000000', 'temperatura', 587.0000, 'ºC'),
	(174959, 120, '2014-02-01 00:14:19.000000', 'temperatura', 373.0000, 'ºC'),
	(174960, 120, '2014-02-01 00:14:20.000000', 'temperatura', 106.0000, 'ºC'),
	(174961, 120, '2014-02-01 00:14:21.000000', 'temperatura', 613.0000, 'ºC'),
	(174962, 120, '2014-02-01 00:14:22.000000', 'temperatura', 346.0000, 'ºC'),
	(174963, 120, '2014-02-01 00:14:23.000000', 'temperatura', 1091.0000, 'ºC'),
	(174964, 120, '2014-02-01 00:14:24.000000', 'temperatura', 816.0000, 'ºC'),
	(174965, 120, '2014-02-01 00:14:25.000000', 'temperatura', 808.0000, 'ºC'),
	(174966, 120, '2014-02-01 00:14:26.000000', 'temperatura', 393.0000, 'ºC'),
	(174967, 120, '2014-02-01 00:14:27.000000', 'temperatura', 741.0000, 'ºC'),
	(174968, 120, '2014-02-01 00:14:28.000000', 'temperatura', 127.0000, 'ºC'),
	(174969, 120, '2014-02-01 00:14:29.000000', 'temperatura', 813.0000, 'ºC'),
	(174970, 120, '2014-02-01 00:14:30.000000', 'temperatura', 86.0000, 'ºC'),
	(174971, 120, '2014-02-01 00:14:31.000000', 'temperatura', 391.0000, 'ºC'),
	(174972, 120, '2014-02-01 00:14:32.000000', 'temperatura', 497.0000, 'ºC'),
	(174973, 120, '2014-02-01 00:14:33.000000', 'temperatura', 111.0000, 'ºC'),
	(174974, 120, '2014-02-01 00:14:34.000000', 'temperatura', 268.0000, 'ºC'),
	(174975, 120, '2014-02-01 00:14:35.000000', 'temperatura', 1004.0000, 'ºC'),
	(174976, 120, '2014-02-01 00:14:36.000000', 'temperatura', 617.0000, 'ºC'),
	(174977, 120, '2014-02-01 00:14:37.000000', 'temperatura', 72.0000, 'ºC'),
	(174978, 120, '2014-02-01 00:14:38.000000', 'temperatura', 912.0000, 'ºC'),
	(174979, 120, '2014-02-01 00:14:39.000000', 'temperatura', 745.0000, 'ºC'),
	(174980, 120, '2014-02-01 00:14:40.000000', 'temperatura', 989.0000, 'ºC'),
	(174981, 120, '2014-02-01 00:14:41.000000', 'temperatura', 312.0000, 'ºC'),
	(174982, 120, '2014-02-01 00:14:42.000000', 'temperatura', 991.0000, 'ºC'),
	(174983, 120, '2014-02-01 00:14:43.000000', 'temperatura', 422.0000, 'ºC'),
	(174984, 120, '2014-02-01 00:14:44.000000', 'temperatura', 339.0000, 'ºC'),
	(174985, 120, '2014-02-01 00:14:45.000000', 'temperatura', 426.0000, 'ºC'),
	(174986, 120, '2014-02-01 00:14:46.000000', 'temperatura', 1113.0000, 'ºC'),
	(174987, 120, '2014-02-01 00:14:47.000000', 'temperatura', 687.0000, 'ºC'),
	(174988, 120, '2014-02-01 00:14:48.000000', 'temperatura', 100.0000, 'ºC'),
	(174989, 120, '2014-02-01 00:14:49.000000', 'temperatura', 836.0000, 'ºC'),
	(174990, 120, '2014-02-01 00:14:50.000000', 'temperatura', 283.0000, 'ºC'),
	(174991, 120, '2014-02-01 00:14:51.000000', 'temperatura', 107.0000, 'ºC'),
	(174992, 120, '2014-02-01 00:14:52.000000', 'temperatura', 885.0000, 'ºC'),
	(174993, 120, '2014-02-01 00:14:53.000000', 'temperatura', 505.0000, 'ºC'),
	(174994, 120, '2014-02-01 00:14:54.000000', 'temperatura', 1072.0000, 'ºC'),
	(174995, 120, '2014-02-01 00:14:55.000000', 'temperatura', 244.0000, 'ºC'),
	(174996, 120, '2014-02-01 00:14:56.000000', 'temperatura', 404.0000, 'ºC'),
	(174997, 120, '2014-02-01 00:14:57.000000', 'temperatura', 91.0000, 'ºC'),
	(174998, 120, '2014-02-01 00:14:58.000000', 'temperatura', 441.0000, 'ºC'),
	(174999, 120, '2014-02-01 00:14:59.000000', 'temperatura', 735.0000, 'ºC'),
	(175000, 120, '2014-02-01 00:15:00.000000', 'temperatura', 1153.0000, 'ºC'),
	(175001, 120, '2014-02-01 00:15:01.000000', 'temperatura', 1160.0000, 'ºC'),
	(175002, 120, '2014-02-01 00:15:02.000000', 'temperatura', 1142.0000, 'ºC'),
	(175003, 120, '2014-02-01 00:15:03.000000', 'temperatura', 1030.0000, 'ºC'),
	(175004, 120, '2014-02-01 00:15:04.000000', 'temperatura', 525.0000, 'ºC'),
	(175005, 120, '2014-02-01 00:15:05.000000', 'temperatura', 734.0000, 'ºC'),
	(175006, 120, '2014-02-01 00:15:06.000000', 'temperatura', 897.0000, 'ºC'),
	(175007, 120, '2014-02-01 00:15:07.000000', 'temperatura', 1083.0000, 'ºC'),
	(175008, 120, '2014-02-01 00:15:08.000000', 'temperatura', 323.0000, 'ºC'),
	(175009, 120, '2014-02-01 00:15:09.000000', 'temperatura', 767.0000, 'ºC'),
	(175010, 120, '2014-02-01 00:15:10.000000', 'temperatura', 467.0000, 'ºC'),
	(175011, 120, '2014-02-01 00:15:11.000000', 'temperatura', 33.0000, 'ºC'),
	(175012, 120, '2014-02-01 00:15:12.000000', 'temperatura', 1167.0000, 'ºC'),
	(175013, 120, '2014-02-01 00:15:13.000000', 'temperatura', 935.0000, 'ºC'),
	(175014, 120, '2014-02-01 00:15:14.000000', 'temperatura', 1175.0000, 'ºC'),
	(175015, 120, '2014-02-01 00:15:15.000000', 'temperatura', 670.0000, 'ºC'),
	(175016, 120, '2014-02-01 00:15:16.000000', 'temperatura', 1027.0000, 'ºC'),
	(175017, 120, '2014-02-01 00:15:17.000000', 'temperatura', 725.0000, 'ºC'),
	(175018, 120, '2014-02-01 00:15:18.000000', 'temperatura', 544.0000, 'ºC'),
	(175019, 120, '2014-02-01 00:15:19.000000', 'temperatura', 546.0000, 'ºC'),
	(175020, 120, '2014-02-01 00:15:20.000000', 'temperatura', 1100.0000, 'ºC'),
	(175021, 120, '2014-02-01 00:15:21.000000', 'temperatura', 260.0000, 'ºC'),
	(175022, 120, '2014-02-01 00:15:22.000000', 'temperatura', 402.0000, 'ºC'),
	(175023, 120, '2014-02-01 00:15:23.000000', 'temperatura', 30.0000, 'ºC'),
	(175024, 120, '2014-02-01 00:15:24.000000', 'temperatura', 145.0000, 'ºC'),
	(175025, 120, '2014-02-01 00:15:25.000000', 'temperatura', 634.0000, 'ºC'),
	(175026, 120, '2014-02-01 00:15:26.000000', 'temperatura', 336.0000, 'ºC'),
	(175027, 120, '2014-02-01 00:15:27.000000', 'temperatura', 979.0000, 'ºC'),
	(175028, 120, '2014-02-01 00:15:28.000000', 'temperatura', 286.0000, 'ºC'),
	(175029, 120, '2014-02-01 00:15:29.000000', 'temperatura', 895.0000, 'ºC'),
	(175030, 120, '2014-02-01 00:15:30.000000', 'temperatura', 17.0000, 'ºC'),
	(175031, 120, '2014-02-01 00:15:31.000000', 'temperatura', 1001.0000, 'ºC'),
	(175032, 120, '2014-02-01 00:15:32.000000', 'temperatura', 155.0000, 'ºC'),
	(175033, 120, '2014-02-01 00:15:33.000000', 'temperatura', 174.0000, 'ºC'),
	(175034, 120, '2014-02-01 00:15:34.000000', 'temperatura', 403.0000, 'ºC'),
	(175035, 120, '2014-02-01 00:15:35.000000', 'temperatura', 294.0000, 'ºC'),
	(175036, 120, '2014-02-01 00:15:36.000000', 'temperatura', 262.0000, 'ºC'),
	(175037, 120, '2014-02-01 00:15:37.000000', 'temperatura', 429.0000, 'ºC'),
	(175038, 120, '2014-02-01 00:15:38.000000', 'temperatura', 159.0000, 'ºC'),
	(175039, 120, '2014-02-01 00:15:39.000000', 'temperatura', 708.0000, 'ºC'),
	(175040, 120, '2014-02-01 00:15:40.000000', 'temperatura', 663.0000, 'ºC'),
	(175041, 120, '2014-02-01 00:15:41.000000', 'temperatura', 1191.0000, 'ºC'),
	(175042, 120, '2014-02-01 00:15:42.000000', 'temperatura', 367.0000, 'ºC'),
	(175043, 120, '2014-02-01 00:15:43.000000', 'temperatura', 664.0000, 'ºC'),
	(175044, 120, '2014-02-01 00:15:44.000000', 'temperatura', 1018.0000, 'ºC'),
	(175045, 120, '2014-02-01 00:15:45.000000', 'temperatura', 698.0000, 'ºC'),
	(175046, 120, '2014-02-01 00:15:46.000000', 'temperatura', 438.0000, 'ºC'),
	(175047, 120, '2014-02-01 00:15:47.000000', 'temperatura', 97.0000, 'ºC'),
	(175048, 120, '2014-02-01 00:15:48.000000', 'temperatura', 371.0000, 'ºC'),
	(175049, 120, '2014-02-01 00:15:49.000000', 'temperatura', 365.0000, 'ºC'),
	(175050, 120, '2014-02-01 00:15:50.000000', 'temperatura', 712.0000, 'ºC'),
	(175051, 120, '2014-02-01 00:15:51.000000', 'temperatura', 67.0000, 'ºC'),
	(175052, 120, '2014-02-01 00:15:52.000000', 'temperatura', 597.0000, 'ºC'),
	(175053, 120, '2014-02-01 00:15:53.000000', 'temperatura', 387.0000, 'ºC'),
	(175054, 120, '2014-02-01 00:15:54.000000', 'temperatura', 142.0000, 'ºC'),
	(175055, 120, '2014-02-01 00:15:55.000000', 'temperatura', 752.0000, 'ºC'),
	(175056, 120, '2014-02-01 00:15:56.000000', 'temperatura', 935.0000, 'ºC'),
	(175057, 120, '2014-02-01 00:15:57.000000', 'temperatura', 17.0000, 'ºC'),
	(175058, 120, '2014-02-01 00:15:58.000000', 'temperatura', 880.0000, 'ºC'),
	(175059, 120, '2014-02-01 00:15:59.000000', 'temperatura', 749.0000, 'ºC'),
	(175060, 120, '2014-02-01 00:16:00.000000', 'temperatura', 1108.0000, 'ºC'),
	(175061, 120, '2014-02-01 00:16:01.000000', 'temperatura', 892.0000, 'ºC'),
	(175062, 120, '2014-02-01 00:16:02.000000', 'temperatura', 1136.0000, 'ºC'),
	(175063, 120, '2014-02-01 00:16:03.000000', 'temperatura', 606.0000, 'ºC'),
	(175064, 120, '2014-02-01 00:16:04.000000', 'temperatura', 820.0000, 'ºC'),
	(175065, 120, '2014-02-01 00:16:05.000000', 'temperatura', 1084.0000, 'ºC'),
	(175066, 120, '2014-02-01 00:16:06.000000', 'temperatura', 562.0000, 'ºC'),
	(175067, 120, '2014-02-01 00:16:07.000000', 'temperatura', 757.0000, 'ºC'),
	(175068, 120, '2014-02-01 00:16:08.000000', 'temperatura', 900.0000, 'ºC'),
	(175069, 120, '2014-02-01 00:16:09.000000', 'temperatura', 1031.0000, 'ºC'),
	(175070, 120, '2014-02-01 00:16:10.000000', 'temperatura', 56.0000, 'ºC'),
	(175071, 120, '2014-02-01 00:16:11.000000', 'temperatura', 785.0000, 'ºC'),
	(175072, 120, '2014-02-01 00:16:12.000000', 'temperatura', 159.0000, 'ºC'),
	(175073, 120, '2014-02-01 00:16:13.000000', 'temperatura', 842.0000, 'ºC'),
	(175074, 120, '2014-02-01 00:16:14.000000', 'temperatura', 130.0000, 'ºC'),
	(175075, 120, '2014-02-01 00:16:15.000000', 'temperatura', 527.0000, 'ºC'),
	(175076, 120, '2014-02-01 00:16:16.000000', 'temperatura', 1044.0000, 'ºC'),
	(175077, 120, '2014-02-01 00:16:17.000000', 'temperatura', 40.0000, 'ºC'),
	(175078, 120, '2014-02-01 00:16:18.000000', 'temperatura', 670.0000, 'ºC'),
	(175079, 120, '2014-02-01 00:16:19.000000', 'temperatura', 831.0000, 'ºC'),
	(175080, 120, '2014-02-01 00:16:20.000000', 'temperatura', 943.0000, 'ºC'),
	(175081, 120, '2014-02-01 00:16:21.000000', 'temperatura', 1025.0000, 'ºC'),
	(175082, 120, '2014-02-01 00:16:22.000000', 'temperatura', 1095.0000, 'ºC'),
	(175083, 120, '2014-02-01 00:16:23.000000', 'temperatura', 1.0000, 'ºC'),
	(175084, 120, '2014-02-01 00:16:24.000000', 'temperatura', 321.0000, 'ºC'),
	(175085, 120, '2014-02-01 00:16:25.000000', 'temperatura', 400.0000, 'ºC'),
	(175086, 120, '2014-02-01 00:16:26.000000', 'temperatura', 1039.0000, 'ºC'),
	(175087, 120, '2014-02-01 00:16:27.000000', 'temperatura', 395.0000, 'ºC'),
	(175088, 120, '2014-02-01 00:16:28.000000', 'temperatura', 60.0000, 'ºC'),
	(175089, 120, '2014-02-01 00:16:29.000000', 'temperatura', 314.0000, 'ºC'),
	(175090, 120, '2014-02-01 00:16:30.000000', 'temperatura', 192.0000, 'ºC'),
	(175091, 120, '2014-02-01 00:16:31.000000', 'temperatura', 17.0000, 'ºC'),
	(175092, 120, '2014-02-01 00:16:32.000000', 'temperatura', 709.0000, 'ºC'),
	(175093, 120, '2014-02-01 00:16:33.000000', 'temperatura', 1094.0000, 'ºC'),
	(175094, 120, '2014-02-01 00:16:34.000000', 'temperatura', 945.0000, 'ºC'),
	(175095, 120, '2014-02-01 00:16:35.000000', 'temperatura', 244.0000, 'ºC'),
	(175096, 120, '2014-02-01 00:16:36.000000', 'temperatura', 783.0000, 'ºC'),
	(175097, 120, '2014-02-01 00:16:37.000000', 'temperatura', 786.0000, 'ºC'),
	(175098, 120, '2014-02-01 00:16:38.000000', 'temperatura', 379.0000, 'ºC'),
	(175099, 120, '2014-02-01 00:16:39.000000', 'temperatura', 738.0000, 'ºC'),
	(175100, 120, '2014-02-01 00:16:40.000000', 'temperatura', 154.0000, 'ºC'),
	(175101, 120, '2014-02-01 00:16:41.000000', 'temperatura', 958.0000, 'ºC'),
	(175102, 120, '2014-02-01 00:16:42.000000', 'temperatura', 726.0000, 'ºC'),
	(175103, 120, '2014-02-01 00:16:43.000000', 'temperatura', 759.0000, 'ºC'),
	(175104, 120, '2014-02-01 00:16:44.000000', 'temperatura', 418.0000, 'ºC'),
	(175105, 120, '2014-02-01 00:16:45.000000', 'temperatura', 1014.0000, 'ºC'),
	(175106, 120, '2014-02-01 00:16:46.000000', 'temperatura', 217.0000, 'ºC'),
	(175107, 120, '2014-02-01 00:16:47.000000', 'temperatura', 442.0000, 'ºC'),
	(175108, 120, '2014-02-01 00:16:48.000000', 'temperatura', 362.0000, 'ºC'),
	(175109, 120, '2014-02-01 00:16:49.000000', 'temperatura', 482.0000, 'ºC'),
	(175110, 120, '2014-02-01 00:16:50.000000', 'temperatura', 124.0000, 'ºC'),
	(175111, 120, '2014-02-01 00:16:51.000000', 'temperatura', 376.0000, 'ºC'),
	(175112, 120, '2014-02-01 00:16:52.000000', 'temperatura', 308.0000, 'ºC'),
	(175113, 120, '2014-02-01 00:16:53.000000', 'temperatura', 411.0000, 'ºC'),
	(175114, 120, '2014-02-01 00:16:54.000000', 'temperatura', 1131.0000, 'ºC'),
	(175115, 120, '2014-02-01 00:16:55.000000', 'temperatura', 822.0000, 'ºC'),
	(175116, 120, '2014-02-01 00:16:56.000000', 'temperatura', 718.0000, 'ºC'),
	(175117, 120, '2014-02-01 00:16:57.000000', 'temperatura', 1124.0000, 'ºC'),
	(175118, 120, '2014-02-01 00:16:58.000000', 'temperatura', 1066.0000, 'ºC'),
	(175119, 120, '2014-02-01 00:16:59.000000', 'temperatura', 758.0000, 'ºC'),
	(175120, 120, '2014-02-01 00:17:00.000000', 'temperatura', 592.0000, 'ºC'),
	(175121, 120, '2014-02-01 00:17:01.000000', 'temperatura', 687.0000, 'ºC'),
	(175122, 120, '2014-02-01 00:17:02.000000', 'temperatura', 462.0000, 'ºC'),
	(175123, 120, '2014-02-01 00:17:03.000000', 'temperatura', 247.0000, 'ºC'),
	(175124, 120, '2014-02-01 00:17:04.000000', 'temperatura', 1052.0000, 'ºC'),
	(175125, 120, '2014-02-01 00:17:05.000000', 'temperatura', 918.0000, 'ºC'),
	(175126, 120, '2014-02-01 00:17:06.000000', 'temperatura', 235.0000, 'ºC'),
	(175127, 120, '2014-02-01 00:17:07.000000', 'temperatura', 821.0000, 'ºC'),
	(175128, 120, '2014-02-01 00:17:08.000000', 'temperatura', 1001.0000, 'ºC'),
	(175129, 120, '2014-02-01 00:17:09.000000', 'temperatura', 144.0000, 'ºC'),
	(175130, 120, '2014-02-01 00:17:10.000000', 'temperatura', 115.0000, 'ºC'),
	(175131, 120, '2014-02-01 00:17:11.000000', 'temperatura', 144.0000, 'ºC'),
	(175132, 120, '2014-02-01 00:17:12.000000', 'temperatura', 377.0000, 'ºC'),
	(175133, 120, '2014-02-01 00:17:13.000000', 'temperatura', 253.0000, 'ºC'),
	(175134, 120, '2014-02-01 00:17:14.000000', 'temperatura', 135.0000, 'ºC'),
	(175135, 120, '2014-02-01 00:17:15.000000', 'temperatura', 1118.0000, 'ºC'),
	(175136, 120, '2014-02-01 00:17:16.000000', 'temperatura', 384.0000, 'ºC'),
	(175137, 120, '2014-02-01 00:17:17.000000', 'temperatura', 966.0000, 'ºC'),
	(175138, 120, '2014-02-01 00:17:18.000000', 'temperatura', 78.0000, 'ºC'),
	(175139, 120, '2014-02-01 00:17:19.000000', 'temperatura', 1095.0000, 'ºC'),
	(175140, 120, '2014-02-01 00:17:20.000000', 'temperatura', 438.0000, 'ºC'),
	(175141, 120, '2014-02-01 00:17:21.000000', 'temperatura', 108.0000, 'ºC'),
	(175142, 120, '2014-02-01 00:17:22.000000', 'temperatura', 428.0000, 'ºC'),
	(175143, 120, '2014-02-01 00:17:23.000000', 'temperatura', 614.0000, 'ºC'),
	(175144, 120, '2014-02-01 00:17:24.000000', 'temperatura', 587.0000, 'ºC'),
	(175145, 120, '2014-02-01 00:17:25.000000', 'temperatura', 1095.0000, 'ºC'),
	(175146, 120, '2014-02-01 00:17:26.000000', 'temperatura', 115.0000, 'ºC'),
	(175147, 120, '2014-02-01 00:17:27.000000', 'temperatura', 888.0000, 'ºC'),
	(175148, 120, '2014-02-01 00:17:28.000000', 'temperatura', 497.0000, 'ºC'),
	(175149, 120, '2014-02-01 00:17:29.000000', 'temperatura', 1021.0000, 'ºC'),
	(175150, 120, '2014-02-01 00:17:30.000000', 'temperatura', 13.0000, 'ºC'),
	(175151, 120, '2014-02-01 00:17:31.000000', 'temperatura', 606.0000, 'ºC'),
	(175152, 120, '2014-02-01 00:17:32.000000', 'temperatura', 588.0000, 'ºC'),
	(175153, 120, '2014-02-01 00:17:33.000000', 'temperatura', 1124.0000, 'ºC'),
	(175154, 120, '2014-02-01 00:17:34.000000', 'temperatura', 256.0000, 'ºC'),
	(175155, 120, '2014-02-01 00:17:35.000000', 'temperatura', 308.0000, 'ºC'),
	(175156, 120, '2014-02-01 00:17:36.000000', 'temperatura', 775.0000, 'ºC'),
	(175157, 120, '2014-02-01 00:17:37.000000', 'temperatura', 549.0000, 'ºC'),
	(175158, 120, '2014-02-01 00:17:38.000000', 'temperatura', 423.0000, 'ºC'),
	(175159, 120, '2014-02-01 00:17:39.000000', 'temperatura', 468.0000, 'ºC'),
	(175160, 120, '2014-02-01 00:17:40.000000', 'temperatura', 1070.0000, 'ºC'),
	(175161, 120, '2014-02-01 00:17:41.000000', 'temperatura', 346.0000, 'ºC'),
	(175162, 120, '2014-02-01 00:17:42.000000', 'temperatura', 921.0000, 'ºC'),
	(175163, 120, '2014-02-01 00:17:43.000000', 'temperatura', 1168.0000, 'ºC'),
	(175164, 120, '2014-02-01 00:17:44.000000', 'temperatura', 679.0000, 'ºC'),
	(175165, 120, '2014-02-01 00:17:45.000000', 'temperatura', 1088.0000, 'ºC'),
	(175166, 120, '2014-02-01 00:17:46.000000', 'temperatura', 1007.0000, 'ºC'),
	(175167, 120, '2014-02-01 00:17:47.000000', 'temperatura', 569.0000, 'ºC'),
	(175168, 120, '2014-02-01 00:17:48.000000', 'temperatura', 1024.0000, 'ºC'),
	(175169, 120, '2014-02-01 00:17:49.000000', 'temperatura', 1016.0000, 'ºC'),
	(175170, 120, '2014-02-01 00:17:50.000000', 'temperatura', 809.0000, 'ºC'),
	(175171, 120, '2014-02-01 00:17:51.000000', 'temperatura', 997.0000, 'ºC'),
	(175172, 120, '2014-02-01 00:17:52.000000', 'temperatura', 157.0000, 'ºC'),
	(175173, 120, '2014-02-01 00:17:53.000000', 'temperatura', 194.0000, 'ºC'),
	(175174, 120, '2014-02-01 00:17:54.000000', 'temperatura', 502.0000, 'ºC'),
	(175175, 120, '2014-02-01 00:17:55.000000', 'temperatura', 729.0000, 'ºC'),
	(175176, 120, '2014-02-01 00:17:56.000000', 'temperatura', 937.0000, 'ºC'),
	(175177, 120, '2014-02-01 00:17:57.000000', 'temperatura', 98.0000, 'ºC'),
	(175178, 120, '2014-02-01 00:17:58.000000', 'temperatura', 79.0000, 'ºC'),
	(175179, 120, '2014-02-01 00:17:59.000000', 'temperatura', 104.0000, 'ºC'),
	(175180, 120, '2014-02-01 00:18:00.000000', 'temperatura', 283.0000, 'ºC'),
	(175181, 120, '2014-02-01 00:18:01.000000', 'temperatura', 1102.0000, 'ºC'),
	(175182, 120, '2014-02-01 00:18:02.000000', 'temperatura', 1063.0000, 'ºC'),
	(175183, 120, '2014-02-01 00:18:03.000000', 'temperatura', 810.0000, 'ºC'),
	(175184, 120, '2014-02-01 00:18:04.000000', 'temperatura', 862.0000, 'ºC'),
	(175185, 120, '2014-02-01 00:18:05.000000', 'temperatura', 678.0000, 'ºC'),
	(175186, 120, '2014-02-01 00:18:06.000000', 'temperatura', 806.0000, 'ºC'),
	(175187, 120, '2014-02-01 00:18:07.000000', 'temperatura', 796.0000, 'ºC'),
	(175188, 120, '2014-02-01 00:18:08.000000', 'temperatura', 361.0000, 'ºC'),
	(175189, 120, '2014-02-01 00:18:09.000000', 'temperatura', 618.0000, 'ºC'),
	(175190, 120, '2014-02-01 00:18:10.000000', 'temperatura', 808.0000, 'ºC'),
	(175191, 120, '2014-02-01 00:18:11.000000', 'temperatura', 988.0000, 'ºC'),
	(175192, 120, '2014-02-01 00:18:12.000000', 'temperatura', 115.0000, 'ºC'),
	(175193, 120, '2014-02-01 00:18:13.000000', 'temperatura', 11.0000, 'ºC'),
	(175194, 120, '2014-02-01 00:18:14.000000', 'temperatura', 910.0000, 'ºC'),
	(175195, 120, '2014-02-01 00:18:15.000000', 'temperatura', 918.0000, 'ºC'),
	(175196, 120, '2014-02-01 00:18:16.000000', 'temperatura', 662.0000, 'ºC'),
	(175197, 120, '2014-02-01 00:18:17.000000', 'temperatura', 555.0000, 'ºC'),
	(175198, 120, '2014-02-01 00:18:18.000000', 'temperatura', 791.0000, 'ºC'),
	(175199, 120, '2014-02-01 00:18:19.000000', 'temperatura', 1090.0000, 'ºC'),
	(175200, 120, '2014-02-01 00:18:20.000000', 'temperatura', 676.0000, 'ºC'),
	(175201, 120, '2014-02-01 00:18:21.000000', 'temperatura', 113.0000, 'ºC'),
	(175202, 120, '2014-02-01 00:18:22.000000', 'temperatura', 935.0000, 'ºC'),
	(175203, 120, '2014-02-01 00:18:23.000000', 'temperatura', 737.0000, 'ºC'),
	(175204, 120, '2014-02-01 00:18:24.000000', 'temperatura', 882.0000, 'ºC'),
	(175205, 120, '2014-02-01 00:18:25.000000', 'temperatura', 1001.0000, 'ºC'),
	(175206, 120, '2014-02-01 00:18:26.000000', 'temperatura', 1157.0000, 'ºC'),
	(175207, 120, '2014-02-01 00:18:27.000000', 'temperatura', 381.0000, 'ºC'),
	(175208, 120, '2014-02-01 00:18:28.000000', 'temperatura', 837.0000, 'ºC'),
	(175209, 120, '2014-02-01 00:18:29.000000', 'temperatura', 642.0000, 'ºC'),
	(175210, 120, '2014-02-01 00:18:30.000000', 'temperatura', 701.0000, 'ºC'),
	(175211, 120, '2014-02-01 00:18:31.000000', 'temperatura', 380.0000, 'ºC'),
	(175212, 120, '2014-02-01 00:18:32.000000', 'temperatura', 995.0000, 'ºC'),
	(175213, 120, '2014-02-01 00:18:33.000000', 'temperatura', 235.0000, 'ºC'),
	(175214, 120, '2014-02-01 00:18:34.000000', 'temperatura', 590.0000, 'ºC'),
	(175215, 120, '2014-02-01 00:18:35.000000', 'temperatura', 1045.0000, 'ºC'),
	(175216, 120, '2014-02-01 00:18:36.000000', 'temperatura', 1059.0000, 'ºC'),
	(175217, 120, '2014-02-01 00:18:37.000000', 'temperatura', 958.0000, 'ºC'),
	(175218, 120, '2014-02-01 00:18:38.000000', 'temperatura', 412.0000, 'ºC'),
	(175219, 120, '2014-02-01 00:18:39.000000', 'temperatura', 389.0000, 'ºC'),
	(175220, 120, '2014-02-01 00:18:40.000000', 'temperatura', 707.0000, 'ºC'),
	(175221, 120, '2014-02-01 00:18:41.000000', 'temperatura', 1169.0000, 'ºC'),
	(175222, 120, '2014-02-01 00:18:42.000000', 'temperatura', 124.0000, 'ºC'),
	(175223, 120, '2014-02-01 00:18:43.000000', 'temperatura', 716.0000, 'ºC'),
	(175224, 120, '2014-02-01 00:18:44.000000', 'temperatura', 805.0000, 'ºC'),
	(175225, 120, '2014-02-01 00:18:45.000000', 'temperatura', 680.0000, 'ºC'),
	(175226, 120, '2014-02-01 00:18:46.000000', 'temperatura', 985.0000, 'ºC'),
	(175227, 120, '2014-02-01 00:18:47.000000', 'temperatura', 485.0000, 'ºC'),
	(175228, 120, '2014-02-01 00:18:48.000000', 'temperatura', 672.0000, 'ºC'),
	(175229, 120, '2014-02-01 00:18:49.000000', 'temperatura', 704.0000, 'ºC'),
	(175230, 120, '2014-02-01 00:18:50.000000', 'temperatura', 303.0000, 'ºC'),
	(175231, 120, '2014-02-01 00:18:51.000000', 'temperatura', 605.0000, 'ºC'),
	(175232, 120, '2014-02-01 00:18:52.000000', 'temperatura', 916.0000, 'ºC'),
	(175233, 120, '2014-02-01 00:18:53.000000', 'temperatura', 365.0000, 'ºC'),
	(175234, 120, '2014-02-01 00:18:54.000000', 'temperatura', 279.0000, 'ºC'),
	(175235, 120, '2014-02-01 00:18:55.000000', 'temperatura', 302.0000, 'ºC'),
	(175236, 120, '2014-02-01 00:18:56.000000', 'temperatura', 671.0000, 'ºC'),
	(175237, 120, '2014-02-01 00:18:57.000000', 'temperatura', 52.0000, 'ºC'),
	(175238, 120, '2014-02-01 00:18:58.000000', 'temperatura', 645.0000, 'ºC'),
	(175239, 120, '2014-02-01 00:18:59.000000', 'temperatura', 672.0000, 'ºC'),
	(175240, 120, '2014-02-01 00:19:00.000000', 'temperatura', 225.0000, 'ºC'),
	(175241, 120, '2014-02-01 00:19:01.000000', 'temperatura', 311.0000, 'ºC'),
	(175242, 120, '2014-02-01 00:19:02.000000', 'temperatura', 877.0000, 'ºC'),
	(175243, 120, '2014-02-01 00:19:03.000000', 'temperatura', 1056.0000, 'ºC'),
	(175244, 120, '2014-02-01 00:19:04.000000', 'temperatura', 249.0000, 'ºC'),
	(175245, 120, '2014-02-01 00:19:05.000000', 'temperatura', 475.0000, 'ºC'),
	(175246, 120, '2014-02-01 00:19:06.000000', 'temperatura', 431.0000, 'ºC'),
	(175247, 120, '2014-02-01 00:19:07.000000', 'temperatura', 730.0000, 'ºC'),
	(175248, 120, '2014-02-01 00:19:08.000000', 'temperatura', 1158.0000, 'ºC'),
	(175249, 120, '2014-02-01 00:19:09.000000', 'temperatura', 0.0000, 'ºC'),
	(175250, 120, '2014-02-01 00:19:10.000000', 'temperatura', 125.0000, 'ºC'),
	(175251, 120, '2014-02-01 00:19:11.000000', 'temperatura', 627.0000, 'ºC'),
	(175252, 120, '2014-02-01 00:19:12.000000', 'temperatura', 362.0000, 'ºC'),
	(175253, 120, '2014-02-01 00:19:13.000000', 'temperatura', 1126.0000, 'ºC'),
	(175254, 120, '2014-02-01 00:19:14.000000', 'temperatura', 947.0000, 'ºC'),
	(175255, 120, '2014-02-01 00:19:15.000000', 'temperatura', 157.0000, 'ºC'),
	(175256, 120, '2014-02-01 00:19:16.000000', 'temperatura', 343.0000, 'ºC'),
	(175257, 120, '2014-02-01 00:19:17.000000', 'temperatura', 47.0000, 'ºC'),
	(175258, 120, '2014-02-01 00:19:18.000000', 'temperatura', 405.0000, 'ºC'),
	(175259, 120, '2014-02-01 00:19:19.000000', 'temperatura', 687.0000, 'ºC'),
	(175260, 120, '2014-02-01 00:19:20.000000', 'temperatura', 1017.0000, 'ºC'),
	(175261, 120, '2014-02-01 00:19:21.000000', 'temperatura', 628.0000, 'ºC'),
	(175262, 120, '2014-02-01 00:19:22.000000', 'temperatura', 88.0000, 'ºC'),
	(175263, 120, '2014-02-01 00:19:23.000000', 'temperatura', 957.0000, 'ºC'),
	(175264, 120, '2014-02-01 00:19:24.000000', 'temperatura', 921.0000, 'ºC'),
	(175265, 120, '2014-02-01 00:19:25.000000', 'temperatura', 535.0000, 'ºC'),
	(175266, 120, '2014-02-01 00:19:26.000000', 'temperatura', 1112.0000, 'ºC'),
	(175267, 120, '2014-02-01 00:19:27.000000', 'temperatura', 357.0000, 'ºC'),
	(175268, 120, '2014-02-01 00:19:28.000000', 'temperatura', 850.0000, 'ºC'),
	(175269, 120, '2014-02-01 00:19:29.000000', 'temperatura', 780.0000, 'ºC'),
	(175270, 120, '2014-02-01 00:19:30.000000', 'temperatura', 147.0000, 'ºC'),
	(175271, 120, '2014-02-01 00:19:31.000000', 'temperatura', 799.0000, 'ºC'),
	(175272, 120, '2014-02-01 00:19:32.000000', 'temperatura', 1152.0000, 'ºC'),
	(175273, 120, '2014-02-01 00:19:33.000000', 'temperatura', 962.0000, 'ºC'),
	(175274, 120, '2014-02-01 00:19:34.000000', 'temperatura', 158.0000, 'ºC'),
	(175275, 120, '2014-02-01 00:19:35.000000', 'temperatura', 304.0000, 'ºC'),
	(175276, 120, '2014-02-01 00:19:36.000000', 'temperatura', 1044.0000, 'ºC'),
	(175277, 120, '2014-02-01 00:19:37.000000', 'temperatura', 710.0000, 'ºC'),
	(175278, 120, '2014-02-01 00:19:38.000000', 'temperatura', 417.0000, 'ºC'),
	(175279, 120, '2014-02-01 00:19:39.000000', 'temperatura', 1158.0000, 'ºC'),
	(175280, 120, '2014-02-01 00:19:40.000000', 'temperatura', 937.0000, 'ºC'),
	(175281, 120, '2014-02-01 00:19:41.000000', 'temperatura', 14.0000, 'ºC'),
	(175282, 120, '2014-02-01 00:19:42.000000', 'temperatura', 858.0000, 'ºC'),
	(175283, 120, '2014-02-01 00:19:43.000000', 'temperatura', 650.0000, 'ºC'),
	(175284, 120, '2014-02-01 00:19:44.000000', 'temperatura', 677.0000, 'ºC'),
	(175285, 120, '2014-02-01 00:19:45.000000', 'temperatura', 235.0000, 'ºC'),
	(175286, 120, '2014-02-01 00:19:46.000000', 'temperatura', 344.0000, 'ºC'),
	(175287, 120, '2014-02-01 00:19:47.000000', 'temperatura', 1017.0000, 'ºC'),
	(175288, 120, '2014-02-01 00:19:48.000000', 'temperatura', 451.0000, 'ºC'),
	(175289, 120, '2014-02-01 00:19:49.000000', 'temperatura', 404.0000, 'ºC'),
	(175290, 120, '2014-02-01 00:19:50.000000', 'temperatura', 671.0000, 'ºC'),
	(175291, 120, '2014-02-01 00:19:51.000000', 'temperatura', 940.0000, 'ºC'),
	(175292, 120, '2014-02-01 00:19:52.000000', 'temperatura', 288.0000, 'ºC'),
	(175293, 120, '2014-02-01 00:19:53.000000', 'temperatura', 1023.0000, 'ºC'),
	(175294, 120, '2014-02-01 00:19:54.000000', 'temperatura', 650.0000, 'ºC'),
	(175295, 120, '2014-02-01 00:19:55.000000', 'temperatura', 180.0000, 'ºC'),
	(175296, 120, '2014-02-01 00:19:56.000000', 'temperatura', 153.0000, 'ºC'),
	(175297, 120, '2014-02-01 00:19:57.000000', 'temperatura', 226.0000, 'ºC'),
	(175298, 120, '2014-02-01 00:19:58.000000', 'temperatura', 669.0000, 'ºC'),
	(175299, 120, '2014-02-01 00:19:59.000000', 'temperatura', 268.0000, 'ºC'),
	(175300, 120, '2014-02-01 00:20:00.000000', 'temperatura', 533.0000, 'ºC'),
	(175301, 120, '2014-02-01 00:20:01.000000', 'temperatura', 662.0000, 'ºC'),
	(175302, 120, '2014-02-01 00:20:02.000000', 'temperatura', 510.0000, 'ºC'),
	(175303, 120, '2014-02-01 00:20:03.000000', 'temperatura', 564.0000, 'ºC'),
	(175304, 120, '2014-02-01 00:20:04.000000', 'temperatura', 91.0000, 'ºC'),
	(175305, 120, '2014-02-01 00:20:05.000000', 'temperatura', 1165.0000, 'ºC'),
	(175306, 120, '2014-02-01 00:20:06.000000', 'temperatura', 751.0000, 'ºC'),
	(175307, 120, '2014-02-01 00:20:07.000000', 'temperatura', 262.0000, 'ºC'),
	(175308, 120, '2014-02-01 00:20:08.000000', 'temperatura', 257.0000, 'ºC'),
	(175309, 120, '2014-02-01 00:20:09.000000', 'temperatura', 498.0000, 'ºC'),
	(175310, 120, '2014-02-01 00:20:10.000000', 'temperatura', 519.0000, 'ºC'),
	(175311, 120, '2014-02-01 00:20:11.000000', 'temperatura', 1102.0000, 'ºC'),
	(175312, 120, '2014-02-01 00:20:12.000000', 'temperatura', 354.0000, 'ºC'),
	(175313, 120, '2014-02-01 00:20:13.000000', 'temperatura', 864.0000, 'ºC'),
	(175314, 120, '2014-02-01 00:20:14.000000', 'temperatura', 858.0000, 'ºC'),
	(175315, 120, '2014-02-01 00:20:15.000000', 'temperatura', 499.0000, 'ºC'),
	(175316, 120, '2014-02-01 00:20:16.000000', 'temperatura', 1121.0000, 'ºC'),
	(175317, 120, '2014-02-01 00:20:17.000000', 'temperatura', 509.0000, 'ºC'),
	(175318, 120, '2014-02-01 00:20:18.000000', 'temperatura', 381.0000, 'ºC'),
	(175319, 120, '2014-02-01 00:20:19.000000', 'temperatura', 378.0000, 'ºC'),
	(175320, 120, '2014-02-01 00:20:20.000000', 'temperatura', 748.0000, 'ºC'),
	(175321, 120, '2014-02-01 00:20:21.000000', 'temperatura', 205.0000, 'ºC'),
	(175322, 120, '2014-02-01 00:20:22.000000', 'temperatura', 1185.0000, 'ºC'),
	(175323, 120, '2014-02-01 00:20:23.000000', 'temperatura', 508.0000, 'ºC'),
	(175324, 120, '2014-02-01 00:20:24.000000', 'temperatura', 184.0000, 'ºC'),
	(175325, 120, '2014-02-01 00:20:25.000000', 'temperatura', 598.0000, 'ºC'),
	(175326, 120, '2014-02-01 00:20:26.000000', 'temperatura', 39.0000, 'ºC'),
	(175327, 120, '2014-02-01 00:20:27.000000', 'temperatura', 802.0000, 'ºC'),
	(175328, 120, '2014-02-01 00:20:28.000000', 'temperatura', 292.0000, 'ºC'),
	(175329, 120, '2014-02-01 00:20:29.000000', 'temperatura', 253.0000, 'ºC'),
	(175330, 120, '2014-02-01 00:20:30.000000', 'temperatura', 393.0000, 'ºC'),
	(175331, 120, '2014-02-01 00:20:31.000000', 'temperatura', 5.0000, 'ºC'),
	(175332, 120, '2014-02-01 00:20:32.000000', 'temperatura', 45.0000, 'ºC'),
	(175333, 120, '2014-02-01 00:20:33.000000', 'temperatura', 211.0000, 'ºC'),
	(175334, 120, '2014-02-01 00:20:34.000000', 'temperatura', 919.0000, 'ºC'),
	(175335, 120, '2014-02-01 00:20:35.000000', 'temperatura', 363.0000, 'ºC'),
	(175336, 120, '2014-02-01 00:20:36.000000', 'temperatura', 261.0000, 'ºC'),
	(175337, 120, '2014-02-01 00:20:37.000000', 'temperatura', 214.0000, 'ºC'),
	(175338, 120, '2014-02-01 00:20:38.000000', 'temperatura', 288.0000, 'ºC'),
	(175339, 120, '2014-02-01 00:20:39.000000', 'temperatura', 797.0000, 'ºC'),
	(175340, 120, '2014-02-01 00:20:40.000000', 'temperatura', 723.0000, 'ºC'),
	(175341, 120, '2014-02-01 00:20:41.000000', 'temperatura', 24.0000, 'ºC'),
	(175342, 120, '2014-02-01 00:20:42.000000', 'temperatura', 353.0000, 'ºC'),
	(175343, 120, '2014-02-01 00:20:43.000000', 'temperatura', 495.0000, 'ºC'),
	(175344, 120, '2014-02-01 00:20:44.000000', 'temperatura', 213.0000, 'ºC'),
	(175345, 120, '2014-02-01 00:20:45.000000', 'temperatura', 783.0000, 'ºC'),
	(175346, 120, '2014-02-01 00:20:46.000000', 'temperatura', 874.0000, 'ºC'),
	(175347, 120, '2014-02-01 00:20:47.000000', 'temperatura', 821.0000, 'ºC'),
	(175348, 120, '2014-02-01 00:20:48.000000', 'temperatura', 284.0000, 'ºC'),
	(175349, 120, '2014-02-01 00:20:49.000000', 'temperatura', 156.0000, 'ºC'),
	(175350, 120, '2014-02-01 00:20:50.000000', 'temperatura', 1130.0000, 'ºC'),
	(175351, 120, '2014-02-01 00:20:51.000000', 'temperatura', 385.0000, 'ºC'),
	(175352, 120, '2014-02-01 00:20:52.000000', 'temperatura', 932.0000, 'ºC'),
	(175353, 120, '2014-02-01 00:20:53.000000', 'temperatura', 1105.0000, 'ºC'),
	(175354, 120, '2014-02-01 00:20:54.000000', 'temperatura', 330.0000, 'ºC'),
	(175355, 120, '2014-02-01 00:20:55.000000', 'temperatura', 735.0000, 'ºC'),
	(175356, 120, '2014-02-01 00:20:56.000000', 'temperatura', 285.0000, 'ºC'),
	(175357, 120, '2014-02-01 00:20:57.000000', 'temperatura', 423.0000, 'ºC'),
	(175358, 120, '2014-02-01 00:20:58.000000', 'temperatura', 59.0000, 'ºC'),
	(175359, 120, '2014-02-01 00:20:59.000000', 'temperatura', 227.0000, 'ºC'),
	(175360, 120, '2014-02-01 00:21:00.000000', 'temperatura', 957.0000, 'ºC'),
	(175361, 120, '2014-02-01 00:21:01.000000', 'temperatura', 504.0000, 'ºC'),
	(175362, 120, '2014-02-01 00:21:02.000000', 'temperatura', 850.0000, 'ºC'),
	(175363, 120, '2014-02-01 00:21:03.000000', 'temperatura', 337.0000, 'ºC'),
	(175364, 120, '2014-02-01 00:21:04.000000', 'temperatura', 338.0000, 'ºC'),
	(175365, 120, '2014-02-01 00:21:05.000000', 'temperatura', 680.0000, 'ºC'),
	(175366, 120, '2014-02-01 00:21:06.000000', 'temperatura', 1186.0000, 'ºC'),
	(175367, 120, '2014-02-01 00:21:07.000000', 'temperatura', 289.0000, 'ºC'),
	(175368, 120, '2014-02-01 00:21:08.000000', 'temperatura', 287.0000, 'ºC'),
	(175369, 120, '2014-02-01 00:21:09.000000', 'temperatura', 567.0000, 'ºC'),
	(175370, 120, '2014-02-01 00:21:10.000000', 'temperatura', 778.0000, 'ºC'),
	(175371, 120, '2014-02-01 00:21:11.000000', 'temperatura', 988.0000, 'ºC'),
	(175372, 120, '2014-02-01 00:21:12.000000', 'temperatura', 206.0000, 'ºC'),
	(175373, 120, '2014-02-01 00:21:13.000000', 'temperatura', 468.0000, 'ºC'),
	(175374, 120, '2014-02-01 00:21:14.000000', 'temperatura', 523.0000, 'ºC'),
	(175375, 120, '2014-02-01 00:21:15.000000', 'temperatura', 11.0000, 'ºC'),
	(175376, 120, '2014-02-01 00:21:16.000000', 'temperatura', 886.0000, 'ºC'),
	(175377, 120, '2014-02-01 00:21:17.000000', 'temperatura', 799.0000, 'ºC'),
	(175378, 120, '2014-02-01 00:21:18.000000', 'temperatura', 139.0000, 'ºC'),
	(175379, 120, '2014-02-01 00:21:19.000000', 'temperatura', 695.0000, 'ºC'),
	(175380, 120, '2014-02-01 00:21:20.000000', 'temperatura', 659.0000, 'ºC'),
	(175381, 120, '2014-02-01 00:21:21.000000', 'temperatura', 10.0000, 'ºC'),
	(175382, 120, '2014-02-01 00:21:22.000000', 'temperatura', 473.0000, 'ºC'),
	(175383, 120, '2014-02-01 00:21:23.000000', 'temperatura', 1135.0000, 'ºC'),
	(175384, 120, '2014-02-01 00:21:24.000000', 'temperatura', 657.0000, 'ºC'),
	(175385, 120, '2014-02-01 00:21:25.000000', 'temperatura', 1083.0000, 'ºC'),
	(175386, 120, '2014-02-01 00:21:26.000000', 'temperatura', 1042.0000, 'ºC'),
	(175387, 120, '2014-02-01 00:21:27.000000', 'temperatura', 764.0000, 'ºC'),
	(175388, 120, '2014-02-01 00:21:28.000000', 'temperatura', 691.0000, 'ºC'),
	(175389, 120, '2014-02-01 00:21:29.000000', 'temperatura', 1167.0000, 'ºC'),
	(175390, 120, '2014-02-01 00:21:30.000000', 'temperatura', 162.0000, 'ºC'),
	(175391, 120, '2014-02-01 00:21:31.000000', 'temperatura', 908.0000, 'ºC'),
	(175392, 120, '2014-02-01 00:21:32.000000', 'temperatura', 456.0000, 'ºC'),
	(175393, 120, '2014-02-01 00:21:33.000000', 'temperatura', 756.0000, 'ºC'),
	(175394, 120, '2014-02-01 00:21:34.000000', 'temperatura', 13.0000, 'ºC'),
	(175395, 120, '2014-02-01 00:21:35.000000', 'temperatura', 197.0000, 'ºC'),
	(175396, 120, '2014-02-01 00:21:36.000000', 'temperatura', 946.0000, 'ºC'),
	(175397, 120, '2014-02-01 00:21:37.000000', 'temperatura', 539.0000, 'ºC'),
	(175398, 120, '2014-02-01 00:21:38.000000', 'temperatura', 1059.0000, 'ºC'),
	(175399, 120, '2014-02-01 00:21:39.000000', 'temperatura', 76.0000, 'ºC'),
	(175400, 120, '2014-02-01 00:21:40.000000', 'temperatura', 805.0000, 'ºC'),
	(175401, 120, '2014-02-01 00:21:41.000000', 'temperatura', 198.0000, 'ºC'),
	(175402, 120, '2014-02-01 00:21:42.000000', 'temperatura', 974.0000, 'ºC'),
	(175403, 120, '2014-02-01 00:21:43.000000', 'temperatura', 679.0000, 'ºC'),
	(175404, 120, '2014-02-01 00:21:44.000000', 'temperatura', 471.0000, 'ºC'),
	(175405, 120, '2014-02-01 00:21:45.000000', 'temperatura', 318.0000, 'ºC'),
	(175406, 120, '2014-02-01 00:21:46.000000', 'temperatura', 180.0000, 'ºC'),
	(175407, 120, '2014-02-01 00:21:47.000000', 'temperatura', 1144.0000, 'ºC'),
	(175408, 120, '2014-02-01 00:21:48.000000', 'temperatura', 381.0000, 'ºC'),
	(175409, 120, '2014-02-01 00:21:49.000000', 'temperatura', 873.0000, 'ºC'),
	(175410, 120, '2014-02-01 00:21:50.000000', 'temperatura', 824.0000, 'ºC'),
	(175411, 120, '2014-02-01 00:21:51.000000', 'temperatura', 302.0000, 'ºC'),
	(175412, 120, '2014-02-01 00:21:52.000000', 'temperatura', 237.0000, 'ºC'),
	(175413, 120, '2014-02-01 00:21:53.000000', 'temperatura', 278.0000, 'ºC'),
	(175414, 120, '2014-02-01 00:21:54.000000', 'temperatura', 683.0000, 'ºC'),
	(175415, 120, '2014-02-01 00:21:55.000000', 'temperatura', 179.0000, 'ºC'),
	(175416, 120, '2014-02-01 00:21:56.000000', 'temperatura', 47.0000, 'ºC'),
	(175417, 120, '2014-02-01 00:21:57.000000', 'temperatura', 900.0000, 'ºC'),
	(175418, 120, '2014-02-01 00:21:58.000000', 'temperatura', 758.0000, 'ºC'),
	(175419, 120, '2014-02-01 00:21:59.000000', 'temperatura', 1090.0000, 'ºC'),
	(175420, 120, '2014-02-01 00:22:00.000000', 'temperatura', 776.0000, 'ºC'),
	(175421, 120, '2014-02-01 00:22:01.000000', 'temperatura', 611.0000, 'ºC'),
	(175422, 120, '2014-02-01 00:22:02.000000', 'temperatura', 727.0000, 'ºC'),
	(175423, 120, '2014-02-01 00:22:03.000000', 'temperatura', 602.0000, 'ºC'),
	(175424, 120, '2014-02-01 00:22:04.000000', 'temperatura', 831.0000, 'ºC'),
	(175425, 120, '2014-02-01 00:22:05.000000', 'temperatura', 1147.0000, 'ºC'),
	(175426, 120, '2014-02-01 00:22:06.000000', 'temperatura', 846.0000, 'ºC'),
	(175427, 120, '2014-02-01 00:22:07.000000', 'temperatura', 788.0000, 'ºC'),
	(175428, 120, '2014-02-01 00:22:08.000000', 'temperatura', 201.0000, 'ºC'),
	(175429, 120, '2014-02-01 00:22:09.000000', 'temperatura', 1044.0000, 'ºC'),
	(175430, 120, '2014-02-01 00:22:10.000000', 'temperatura', 1015.0000, 'ºC'),
	(175431, 120, '2014-02-01 00:22:11.000000', 'temperatura', 746.0000, 'ºC'),
	(175432, 120, '2014-02-01 00:22:12.000000', 'temperatura', 685.0000, 'ºC'),
	(175433, 120, '2014-02-01 00:22:13.000000', 'temperatura', 1186.0000, 'ºC'),
	(175434, 120, '2014-02-01 00:22:14.000000', 'temperatura', 277.0000, 'ºC'),
	(175435, 120, '2014-02-01 00:22:15.000000', 'temperatura', 226.0000, 'ºC'),
	(175436, 120, '2014-02-01 00:22:16.000000', 'temperatura', 301.0000, 'ºC'),
	(175437, 120, '2014-02-01 00:22:17.000000', 'temperatura', 826.0000, 'ºC'),
	(175438, 120, '2014-02-01 00:22:18.000000', 'temperatura', 830.0000, 'ºC'),
	(175439, 120, '2014-02-01 00:22:19.000000', 'temperatura', 472.0000, 'ºC'),
	(175440, 120, '2014-02-01 00:22:20.000000', 'temperatura', 1070.0000, 'ºC'),
	(175441, 120, '2014-02-01 00:22:21.000000', 'temperatura', 335.0000, 'ºC'),
	(175442, 120, '2014-02-01 00:22:22.000000', 'temperatura', 864.0000, 'ºC'),
	(175443, 120, '2014-02-01 00:22:23.000000', 'temperatura', 916.0000, 'ºC'),
	(175444, 120, '2014-02-01 00:22:24.000000', 'temperatura', 787.0000, 'ºC'),
	(175445, 120, '2014-02-01 00:22:25.000000', 'temperatura', 1188.0000, 'ºC'),
	(175446, 120, '2014-02-01 00:22:26.000000', 'temperatura', 1180.0000, 'ºC'),
	(175447, 120, '2014-02-01 00:22:27.000000', 'temperatura', 1135.0000, 'ºC'),
	(175448, 120, '2014-02-01 00:22:28.000000', 'temperatura', 936.0000, 'ºC'),
	(175449, 120, '2014-02-01 00:22:29.000000', 'temperatura', 74.0000, 'ºC'),
	(175450, 120, '2014-02-01 00:22:30.000000', 'temperatura', 1163.0000, 'ºC'),
	(175451, 120, '2014-02-01 00:22:31.000000', 'temperatura', 795.0000, 'ºC'),
	(175452, 120, '2014-02-01 00:22:32.000000', 'temperatura', 487.0000, 'ºC'),
	(175453, 120, '2014-02-01 00:22:33.000000', 'temperatura', 48.0000, 'ºC'),
	(175454, 120, '2014-02-01 00:22:34.000000', 'temperatura', 1181.0000, 'ºC'),
	(175455, 120, '2014-02-01 00:22:35.000000', 'temperatura', 960.0000, 'ºC'),
	(175456, 120, '2014-02-01 00:22:36.000000', 'temperatura', 59.0000, 'ºC'),
	(175457, 120, '2014-02-01 00:22:37.000000', 'temperatura', 1016.0000, 'ºC'),
	(175458, 120, '2014-02-01 00:22:38.000000', 'temperatura', 103.0000, 'ºC'),
	(175459, 120, '2014-02-01 00:22:39.000000', 'temperatura', 1068.0000, 'ºC'),
	(175460, 120, '2014-02-01 00:22:40.000000', 'temperatura', 229.0000, 'ºC'),
	(175461, 120, '2014-02-01 00:22:41.000000', 'temperatura', 344.0000, 'ºC'),
	(175462, 120, '2014-02-01 00:22:42.000000', 'temperatura', 1034.0000, 'ºC'),
	(175463, 120, '2014-02-01 00:22:43.000000', 'temperatura', 538.0000, 'ºC'),
	(175464, 120, '2014-02-01 00:22:44.000000', 'temperatura', 787.0000, 'ºC'),
	(175465, 120, '2014-02-01 00:22:45.000000', 'temperatura', 1122.0000, 'ºC'),
	(175466, 120, '2014-02-01 00:22:46.000000', 'temperatura', 851.0000, 'ºC'),
	(175467, 120, '2014-02-01 00:22:47.000000', 'temperatura', 890.0000, 'ºC'),
	(175468, 120, '2014-02-01 00:22:48.000000', 'temperatura', 696.0000, 'ºC'),
	(175469, 120, '2014-02-01 00:22:49.000000', 'temperatura', 812.0000, 'ºC'),
	(175470, 120, '2014-02-01 00:22:50.000000', 'temperatura', 771.0000, 'ºC'),
	(175471, 120, '2014-02-01 00:22:51.000000', 'temperatura', 222.0000, 'ºC'),
	(175472, 120, '2014-02-01 00:22:52.000000', 'temperatura', 1197.0000, 'ºC'),
	(175473, 120, '2014-02-01 00:22:53.000000', 'temperatura', 517.0000, 'ºC'),
	(175474, 120, '2014-02-01 00:22:54.000000', 'temperatura', 196.0000, 'ºC'),
	(175475, 120, '2014-02-01 00:22:55.000000', 'temperatura', 628.0000, 'ºC'),
	(175476, 120, '2014-02-01 00:22:56.000000', 'temperatura', 152.0000, 'ºC'),
	(175477, 120, '2014-02-01 00:22:57.000000', 'temperatura', 76.0000, 'ºC'),
	(175478, 120, '2014-02-01 00:22:58.000000', 'temperatura', 1125.0000, 'ºC'),
	(175479, 120, '2014-02-01 00:22:59.000000', 'temperatura', 598.0000, 'ºC'),
	(175480, 120, '2014-02-01 00:23:00.000000', 'temperatura', 816.0000, 'ºC'),
	(175481, 120, '2014-02-01 00:23:01.000000', 'temperatura', 1084.0000, 'ºC'),
	(175482, 120, '2014-02-01 00:23:02.000000', 'temperatura', 574.0000, 'ºC'),
	(175483, 120, '2014-02-01 00:23:03.000000', 'temperatura', 818.0000, 'ºC'),
	(175484, 120, '2014-02-01 00:23:04.000000', 'temperatura', 1168.0000, 'ºC'),
	(175485, 120, '2014-02-01 00:23:05.000000', 'temperatura', 987.0000, 'ºC'),
	(175486, 120, '2014-02-01 00:23:06.000000', 'temperatura', 230.0000, 'ºC'),
	(175487, 120, '2014-02-01 00:23:07.000000', 'temperatura', 592.0000, 'ºC'),
	(175488, 120, '2014-02-01 00:23:08.000000', 'temperatura', 1071.0000, 'ºC'),
	(175489, 120, '2014-02-01 00:23:09.000000', 'temperatura', 1179.0000, 'ºC'),
	(175490, 120, '2014-02-01 00:23:10.000000', 'temperatura', 284.0000, 'ºC'),
	(175491, 120, '2014-02-01 00:23:11.000000', 'temperatura', 283.0000, 'ºC'),
	(175492, 120, '2014-02-01 00:23:12.000000', 'temperatura', 564.0000, 'ºC'),
	(175493, 120, '2014-02-01 00:23:13.000000', 'temperatura', 772.0000, 'ºC'),
	(175494, 120, '2014-02-01 00:23:14.000000', 'temperatura', 967.0000, 'ºC'),
	(175495, 120, '2014-02-01 00:23:15.000000', 'temperatura', 118.0000, 'ºC'),
	(175496, 120, '2014-02-01 00:23:16.000000', 'temperatura', 90.0000, 'ºC'),
	(175497, 120, '2014-02-01 00:23:17.000000', 'temperatura', 97.0000, 'ºC'),
	(175498, 120, '2014-02-01 00:23:18.000000', 'temperatura', 217.0000, 'ºC'),
	(175499, 120, '2014-02-01 00:23:19.000000', 'temperatura', 793.0000, 'ºC'),
	(175500, 120, '2014-02-01 00:23:20.000000', 'temperatura', 915.0000, 'ºC'),
	(175501, 120, '2014-02-01 00:23:21.000000', 'temperatura', 998.0000, 'ºC'),
	(175502, 120, '2014-02-01 00:23:22.000000', 'temperatura', 1044.0000, 'ºC'),
	(175503, 120, '2014-02-01 00:23:23.000000', 'temperatura', 1025.0000, 'ºC'),
	(175504, 120, '2014-02-01 00:23:24.000000', 'temperatura', 795.0000, 'ºC'),
	(175505, 120, '2014-02-01 00:23:25.000000', 'temperatura', 902.0000, 'ºC'),
	(175506, 120, '2014-02-01 00:23:26.000000', 'temperatura', 925.0000, 'ºC'),
	(175507, 120, '2014-02-01 00:23:27.000000', 'temperatura', 721.0000, 'ºC'),
	(175508, 120, '2014-02-01 00:23:28.000000', 'temperatura', 828.0000, 'ºC'),
	(175509, 120, '2014-02-01 00:23:29.000000', 'temperatura', 780.0000, 'ºC'),
	(175510, 120, '2014-02-01 00:23:30.000000', 'temperatura', 216.0000, 'ºC'),
	(175511, 120, '2014-02-01 00:23:31.000000', 'temperatura', 1140.0000, 'ºC'),
	(175512, 120, '2014-02-01 00:23:32.000000', 'temperatura', 252.0000, 'ºC'),
	(175513, 120, '2014-02-01 00:23:33.000000', 'temperatura', 240.0000, 'ºC'),
	(175514, 120, '2014-02-01 00:23:34.000000', 'temperatura', 446.0000, 'ºC'),
	(175515, 120, '2014-02-01 00:23:35.000000', 'temperatura', 308.0000, 'ºC'),
	(175516, 120, '2014-02-01 00:23:36.000000', 'temperatura', 205.0000, 'ºC'),
	(175517, 120, '2014-02-01 00:23:37.000000', 'temperatura', 100.0000, 'ºC'),
	(175518, 120, '2014-02-01 00:23:38.000000', 'temperatura', 1087.0000, 'ºC'),
	(175519, 120, '2014-02-01 00:23:39.000000', 'temperatura', 335.0000, 'ºC'),
	(175520, 120, '2014-02-01 00:23:40.000000', 'temperatura', 814.0000, 'ºC'),
	(175521, 120, '2014-02-01 00:23:41.000000', 'temperatura', 664.0000, 'ºC'),
	(175522, 120, '2014-02-01 00:23:42.000000', 'temperatura', 879.0000, 'ºC'),
	(175523, 120, '2014-02-01 00:23:43.000000', 'temperatura', 5.0000, 'ºC'),
	(175524, 120, '2014-02-01 00:23:44.000000', 'temperatura', 987.0000, 'ºC'),
	(175525, 120, '2014-02-01 00:23:45.000000', 'temperatura', 121.0000, 'ºC'),
	(175526, 120, '2014-02-01 00:23:46.000000', 'temperatura', 46.0000, 'ºC'),
	(175527, 120, '2014-02-01 00:23:47.000000', 'temperatura', 1068.0000, 'ºC'),
	(175528, 120, '2014-02-01 00:23:48.000000', 'temperatura', 403.0000, 'ºC'),
	(175529, 120, '2014-02-01 00:23:49.000000', 'temperatura', 11.0000, 'ºC'),
	(175530, 120, '2014-02-01 00:23:50.000000', 'temperatura', 47.0000, 'ºC'),
	(175531, 120, '2014-02-01 00:23:51.000000', 'temperatura', 201.0000, 'ºC'),
	(175532, 120, '2014-02-01 00:23:52.000000', 'temperatura', 864.0000, 'ºC'),
	(175533, 120, '2014-02-01 00:23:53.000000', 'temperatura', 119.0000, 'ºC'),
	(175534, 120, '2014-02-01 00:23:54.000000', 'temperatura', 402.0000, 'ºC'),
	(175535, 120, '2014-02-01 00:23:55.000000', 'temperatura', 453.0000, 'ºC'),
	(175536, 120, '2014-02-01 00:23:56.000000', 'temperatura', 1059.0000, 'ºC'),
	(175537, 120, '2014-02-01 00:23:57.000000', 'temperatura', 339.0000, 'ºC'),
	(175538, 120, '2014-02-01 00:23:58.000000', 'temperatura', 915.0000, 'ºC'),
	(175539, 120, '2014-02-01 00:23:59.000000', 'temperatura', 1162.0000, 'ºC'),
	(175540, 120, '2014-02-01 00:24:00.000000', 'temperatura', 664.0000, 'ºC'),
	(175541, 120, '2014-02-01 00:24:01.000000', 'temperatura', 1036.0000, 'ºC'),
	(175542, 120, '2014-02-01 00:24:02.000000', 'temperatura', 787.0000, 'ºC'),
	(175543, 120, '2014-02-01 00:24:03.000000', 'temperatura', 829.0000, 'ºC'),
	(175544, 120, '2014-02-01 00:24:04.000000', 'temperatura', 585.0000, 'ºC'),
	(175545, 120, '2014-02-01 00:24:05.000000', 'temperatura', 436.0000, 'ºC'),
	(175546, 120, '2014-02-01 00:24:06.000000', 'temperatura', 426.0000, 'ºC'),
	(175547, 120, '2014-02-01 00:24:07.000000', 'temperatura', 821.0000, 'ºC'),
	(175548, 120, '2014-02-01 00:24:08.000000', 'temperatura', 430.0000, 'ºC'),
	(175549, 120, '2014-02-01 00:24:09.000000', 'temperatura', 886.0000, 'ºC'),
	(175550, 120, '2014-02-01 00:24:10.000000', 'temperatura', 740.0000, 'ºC'),
	(175551, 120, '2014-02-01 00:24:11.000000', 'temperatura', 1044.0000, 'ºC'),
	(175552, 120, '2014-02-01 00:24:12.000000', 'temperatura', 601.0000, 'ºC'),
	(175553, 120, '2014-02-01 00:24:13.000000', 'temperatura', 1072.0000, 'ºC'),
	(175554, 120, '2014-02-01 00:24:14.000000', 'temperatura', 1157.0000, 'ºC'),
	(175555, 120, '2014-02-01 00:24:15.000000', 'temperatura', 171.0000, 'ºC'),
	(175556, 120, '2014-02-01 00:24:16.000000', 'temperatura', 982.0000, 'ºC'),
	(175557, 120, '2014-02-01 00:24:17.000000', 'temperatura', 799.0000, 'ºC'),
	(175558, 120, '2014-02-01 00:24:18.000000', 'temperatura', 1047.0000, 'ºC'),
	(175559, 120, '2014-02-01 00:24:19.000000', 'temperatura', 442.0000, 'ºC'),
	(175560, 120, '2014-02-01 00:24:20.000000', 'temperatura', 267.0000, 'ºC'),
	(175561, 120, '2014-02-01 00:24:21.000000', 'temperatura', 11.0000, 'ºC'),
	(175562, 120, '2014-02-01 00:24:22.000000', 'temperatura', 452.0000, 'ºC'),
	(175563, 120, '2014-02-01 00:24:23.000000', 'temperatura', 1029.0000, 'ºC'),
	(175564, 120, '2014-02-01 00:24:24.000000', 'temperatura', 189.0000, 'ºC'),
	(175565, 120, '2014-02-01 00:24:25.000000', 'temperatura', 259.0000, 'ºC'),
	(175566, 120, '2014-02-01 00:24:26.000000', 'temperatura', 730.0000, 'ºC'),
	(175567, 120, '2014-02-01 00:24:27.000000', 'temperatura', 473.0000, 'ºC'),
	(175568, 120, '2014-02-01 00:24:28.000000', 'temperatura', 175.0000, 'ºC'),
	(175569, 120, '2014-02-01 00:24:29.000000', 'temperatura', 656.0000, 'ºC'),
	(175570, 120, '2014-02-01 00:24:30.000000', 'temperatura', 355.0000, 'ºC'),
	(175571, 120, '2014-02-01 00:24:31.000000', 'temperatura', 1008.0000, 'ºC'),
	(175572, 120, '2014-02-01 00:24:32.000000', 'temperatura', 374.0000, 'ºC'),
	(175573, 120, '2014-02-01 00:24:33.000000', 'temperatura', 46.0000, 'ºC'),
	(175574, 120, '2014-02-01 00:24:34.000000', 'temperatura', 310.0000, 'ºC'),
	(175575, 120, '2014-02-01 00:24:35.000000', 'temperatura', 211.0000, 'ºC'),
	(175576, 120, '2014-02-01 00:24:36.000000', 'temperatura', 127.0000, 'ºC'),
	(175577, 120, '2014-02-01 00:24:37.000000', 'temperatura', 4.0000, 'ºC'),
	(175578, 120, '2014-02-01 00:24:38.000000', 'temperatura', 839.0000, 'ºC'),
	(175579, 120, '2014-02-01 00:24:39.000000', 'temperatura', 581.0000, 'ºC'),
	(175580, 120, '2014-02-01 00:24:40.000000', 'temperatura', 389.0000, 'ºC'),
	(175581, 120, '2014-02-01 00:24:41.000000', 'temperatura', 202.0000, 'ºC'),
	(175582, 120, '2014-02-01 00:24:42.000000', 'temperatura', 1046.0000, 'ºC'),
	(175583, 120, '2014-02-01 00:24:43.000000', 'temperatura', 1021.0000, 'ºC'),
	(175584, 120, '2014-02-01 00:24:44.000000', 'temperatura', 771.0000, 'ºC'),
	(175585, 120, '2014-02-01 00:24:45.000000', 'temperatura', 791.0000, 'ºC'),
	(175586, 120, '2014-02-01 00:24:46.000000', 'temperatura', 444.0000, 'ºC'),
	(175587, 120, '2014-02-01 00:24:47.000000', 'temperatura', 1046.0000, 'ºC'),
	(175588, 120, '2014-02-01 00:24:48.000000', 'temperatura', 298.0000, 'ºC'),
	(175589, 120, '2014-02-01 00:24:49.000000', 'temperatura', 755.0000, 'ºC'),
	(175590, 120, '2014-02-01 00:24:50.000000', 'temperatura', 479.0000, 'ºC'),
	(175591, 120, '2014-02-01 00:24:51.000000', 'temperatura', 131.0000, 'ºC'),
	(175592, 120, '2014-02-01 00:24:52.000000', 'temperatura', 420.0000, 'ºC'),
	(175593, 120, '2014-02-01 00:24:53.000000', 'temperatura', 506.0000, 'ºC'),
	(175594, 120, '2014-02-01 00:24:54.000000', 'temperatura', 70.0000, 'ºC'),
	(175595, 120, '2014-02-01 00:24:55.000000', 'temperatura', 32.0000, 'ºC'),
	(175596, 120, '2014-02-01 00:24:56.000000', 'temperatura', 1152.0000, 'ºC'),
	(175597, 120, '2014-02-01 00:24:57.000000', 'temperatura', 862.0000, 'ºC'),
	(175598, 120, '2014-02-01 00:24:58.000000', 'temperatura', 856.0000, 'ºC'),
	(175599, 120, '2014-02-01 00:24:59.000000', 'temperatura', 494.0000, 'ºC'),
	(175600, 120, '2014-02-01 00:25:00.000000', 'temperatura', 1104.0000, 'ºC'),
	(175601, 120, '2014-02-01 00:25:01.000000', 'temperatura', 436.0000, 'ºC'),
	(175602, 120, '2014-02-01 00:25:02.000000', 'temperatura', 69.0000, 'ºC'),
	(175603, 120, '2014-02-01 00:25:03.000000', 'temperatura', 239.0000, 'ºC'),
	(175604, 120, '2014-02-01 00:25:04.000000', 'temperatura', 990.0000, 'ºC'),
	(175605, 120, '2014-02-01 00:25:05.000000', 'temperatura', 631.0000, 'ºC'),
	(175606, 120, '2014-02-01 00:25:06.000000', 'temperatura', 186.0000, 'ºC'),
	(175607, 120, '2014-02-01 00:25:07.000000', 'temperatura', 238.0000, 'ºC'),
	(175608, 120, '2014-02-01 00:25:08.000000', 'temperatura', 633.0000, 'ºC'),
	(175609, 120, '2014-02-01 00:25:09.000000', 'temperatura', 51.0000, 'ºC'),
	(175610, 120, '2014-02-01 00:25:10.000000', 'temperatura', 755.0000, 'ºC'),
	(175611, 120, '2014-02-01 00:25:11.000000', 'temperatura', 21.0000, 'ºC'),
	(175612, 120, '2014-02-01 00:25:12.000000', 'temperatura', 244.0000, 'ºC'),
	(175613, 120, '2014-02-01 00:25:13.000000', 'temperatura', 1158.0000, 'ºC'),
	(175614, 120, '2014-02-01 00:25:14.000000', 'temperatura', 257.0000, 'ºC'),
	(175615, 120, '2014-02-01 00:25:15.000000', 'temperatura', 210.0000, 'ºC'),
	(175616, 120, '2014-02-01 00:25:16.000000', 'temperatura', 283.0000, 'ºC'),
	(175617, 120, '2014-02-01 00:25:17.000000', 'temperatura', 783.0000, 'ºC'),
	(175618, 120, '2014-02-01 00:25:18.000000', 'temperatura', 667.0000, 'ºC'),
	(175619, 120, '2014-02-01 00:25:19.000000', 'temperatura', 986.0000, 'ºC'),
	(175620, 120, '2014-02-01 00:25:20.000000', 'temperatura', 531.0000, 'ºC'),
	(175621, 120, '2014-02-01 00:25:21.000000', 'temperatura', 897.0000, 'ºC'),
	(175622, 120, '2014-02-01 00:25:22.000000', 'temperatura', 492.0000, 'ºC'),
	(175623, 120, '2014-02-01 00:25:23.000000', 'temperatura', 969.0000, 'ºC'),
	(175624, 120, '2014-02-01 00:25:24.000000', 'temperatura', 970.0000, 'ºC'),
	(175625, 120, '2014-02-01 00:25:25.000000', 'temperatura', 744.0000, 'ºC'),
	(175626, 120, '2014-02-01 00:25:26.000000', 'temperatura', 811.0000, 'ºC'),
	(175627, 120, '2014-02-01 00:25:27.000000', 'temperatura', 621.0000, 'ºC'),
	(175628, 120, '2014-02-01 00:25:28.000000', 'temperatura', 674.0000, 'ºC'),
	(175629, 120, '2014-02-01 00:25:29.000000', 'temperatura', 306.0000, 'ºC'),
	(175630, 120, '2014-02-01 00:25:30.000000', 'temperatura', 710.0000, 'ºC'),
	(175631, 120, '2014-02-01 00:25:31.000000', 'temperatura', 232.0000, 'ºC'),
	(175632, 120, '2014-02-01 00:25:32.000000', 'temperatura', 230.0000, 'ºC'),
	(175633, 120, '2014-02-01 00:25:33.000000', 'temperatura', 456.0000, 'ºC'),
	(175634, 120, '2014-02-01 00:25:34.000000', 'temperatura', 391.0000, 'ºC'),
	(175635, 120, '2014-02-01 00:25:35.000000', 'temperatura', 585.0000, 'ºC'),
	(175636, 120, '2014-02-01 00:25:36.000000', 'temperatura', 554.0000, 'ºC'),
	(175637, 120, '2014-02-01 00:25:37.000000', 'temperatura', 1013.0000, 'ºC'),
	(175638, 120, '2014-02-01 00:25:38.000000', 'temperatura', 1007.0000, 'ºC'),
	(175639, 120, '2014-02-01 00:25:39.000000', 'temperatura', 794.0000, 'ºC'),
	(175640, 120, '2014-02-01 00:25:40.000000', 'temperatura', 950.0000, 'ºC'),
	(175641, 120, '2014-02-01 00:25:41.000000', 'temperatura', 1171.0000, 'ºC'),
	(175642, 120, '2014-02-01 00:25:42.000000', 'temperatura', 603.0000, 'ºC'),
	(175643, 120, '2014-02-01 00:25:43.000000', 'temperatura', 704.0000, 'ºC'),
	(175644, 120, '2014-02-01 00:25:44.000000', 'temperatura', 509.0000, 'ºC'),
	(175645, 120, '2014-02-01 00:25:45.000000', 'temperatura', 435.0000, 'ºC'),
	(175646, 120, '2014-02-01 00:25:46.000000', 'temperatura', 649.0000, 'ºC'),
	(175647, 120, '2014-02-01 00:25:47.000000', 'temperatura', 739.0000, 'ºC'),
	(175648, 120, '2014-02-01 00:25:48.000000', 'temperatura', 548.0000, 'ºC'),
	(175649, 120, '2014-02-01 00:25:49.000000', 'temperatura', 525.0000, 'ºC'),
	(175650, 120, '2014-02-01 00:25:50.000000', 'temperatura', 980.0000, 'ºC'),
	(175651, 120, '2014-02-01 00:25:51.000000', 'temperatura', 928.0000, 'ºC'),
	(175652, 120, '2014-02-01 00:25:52.000000', 'temperatura', 498.0000, 'ºC'),
	(175653, 120, '2014-02-01 00:25:53.000000', 'temperatura', 906.0000, 'ºC'),
	(175654, 120, '2014-02-01 00:25:54.000000', 'temperatura', 638.0000, 'ºC'),
	(175655, 120, '2014-02-01 00:25:55.000000', 'temperatura', 470.0000, 'ºC'),
	(175656, 120, '2014-02-01 00:25:56.000000', 'temperatura', 439.0000, 'ºC'),
	(175657, 120, '2014-02-01 00:25:57.000000', 'temperatura', 784.0000, 'ºC'),
	(175658, 120, '2014-02-01 00:25:58.000000', 'temperatura', 206.0000, 'ºC'),
	(175659, 120, '2014-02-01 00:25:59.000000', 'temperatura', 1076.0000, 'ºC'),
	(175660, 120, '2014-02-01 00:26:00.000000', 'temperatura', 1162.0000, 'ºC'),
	(175661, 120, '2014-02-01 00:26:01.000000', 'temperatura', 184.0000, 'ºC'),
	(175662, 120, '2014-02-01 00:26:02.000000', 'temperatura', 1034.0000, 'ºC'),
	(175663, 120, '2014-02-01 00:26:03.000000', 'temperatura', 1019.0000, 'ºC'),
	(175664, 120, '2014-02-01 00:26:04.000000', 'temperatura', 793.0000, 'ºC'),
	(175665, 120, '2014-02-01 00:26:05.000000', 'temperatura', 909.0000, 'ºC'),
	(175666, 120, '2014-02-01 00:26:06.000000', 'temperatura', 967.0000, 'ºC'),
	(175667, 120, '2014-02-01 00:26:07.000000', 'temperatura', 907.0000, 'ºC'),
	(175668, 120, '2014-02-01 00:26:08.000000', 'temperatura', 433.0000, 'ºC'),
	(175669, 120, '2014-02-01 00:26:09.000000', 'temperatura', 647.0000, 'ºC'),
	(175670, 120, '2014-02-01 00:26:10.000000', 'temperatura', 734.0000, 'ºC'),
	(175671, 120, '2014-02-01 00:26:11.000000', 'temperatura', 533.0000, 'ºC'),
	(175672, 120, '2014-02-01 00:26:12.000000', 'temperatura', 460.0000, 'ºC'),
	(175673, 120, '2014-02-01 00:26:13.000000', 'temperatura', 704.0000, 'ºC'),
	(175674, 120, '2014-02-01 00:26:14.000000', 'temperatura', 941.0000, 'ºC'),
	(175675, 120, '2014-02-01 00:26:15.000000', 'temperatura', 192.0000, 'ºC'),
	(175676, 120, '2014-02-01 00:26:16.000000', 'temperatura', 537.0000, 'ºC'),
	(175677, 120, '2014-02-01 00:26:17.000000', 'temperatura', 909.0000, 'ºC'),
	(175678, 120, '2014-02-01 00:26:18.000000', 'temperatura', 534.0000, 'ºC'),
	(175679, 120, '2014-02-01 00:26:19.000000', 'temperatura', 1144.0000, 'ºC'),
	(175680, 120, '2014-02-01 00:26:20.000000', 'temperatura', 519.0000, 'ºC'),
	(175681, 120, '2014-02-01 00:26:21.000000', 'temperatura', 361.0000, 'ºC'),
	(175682, 120, '2014-02-01 00:26:22.000000', 'temperatura', 251.0000, 'ºC'),
	(175683, 120, '2014-02-01 00:26:23.000000', 'temperatura', 172.0000, 'ºC'),
	(175684, 120, '2014-02-01 00:26:24.000000', 'temperatura', 109.0000, 'ºC'),
	(175685, 120, '2014-02-01 00:26:25.000000', 'temperatura', 28.0000, 'ºC'),
	(175686, 120, '2014-02-01 00:26:26.000000', 'temperatura', 1014.0000, 'ºC'),
	(175687, 120, '2014-02-01 00:26:27.000000', 'temperatura', 185.0000, 'ºC'),
	(175688, 120, '2014-02-01 00:26:28.000000', 'temperatura', 286.0000, 'ºC'),
	(175689, 120, '2014-02-01 00:26:29.000000', 'temperatura', 873.0000, 'ºC'),
	(175690, 120, '2014-02-01 00:26:30.000000', 'temperatura', 1107.0000, 'ºC'),
	(175691, 120, '2014-02-01 00:26:31.000000', 'temperatura', 517.0000, 'ºC'),
	(175692, 120, '2014-02-01 00:26:32.000000', 'temperatura', 463.0000, 'ºC'),
	(175693, 120, '2014-02-01 00:26:33.000000', 'temperatura', 766.0000, 'ºC'),
	(175694, 120, '2014-02-01 00:26:34.000000', 'temperatura', 41.0000, 'ºC'),
	(175695, 120, '2014-02-01 00:26:35.000000', 'temperatura', 309.0000, 'ºC'),
	(175696, 120, '2014-02-01 00:26:36.000000', 'temperatura', 221.0000, 'ºC'),
	(175697, 120, '2014-02-01 00:26:37.000000', 'temperatura', 181.0000, 'ºC'),
	(175698, 120, '2014-02-01 00:26:38.000000', 'temperatura', 239.0000, 'ºC'),
	(175699, 120, '2014-02-01 00:26:39.000000', 'temperatura', 656.0000, 'ºC'),
	(175700, 120, '2014-02-01 00:26:40.000000', 'temperatura', 161.0000, 'ºC'),
	(175701, 120, '2014-02-01 00:26:41.000000', 'temperatura', 39.0000, 'ºC'),
	(175702, 120, '2014-02-01 00:26:42.000000', 'temperatura', 911.0000, 'ºC'),
	(175703, 120, '2014-02-01 00:26:43.000000', 'temperatura', 840.0000, 'ºC'),
	(175704, 120, '2014-02-01 00:26:44.000000', 'temperatura', 268.0000, 'ºC'),
	(175705, 120, '2014-02-01 00:26:45.000000', 'temperatura', 20.0000, 'ºC'),
	(175706, 120, '2014-02-01 00:26:46.000000', 'temperatura', 497.0000, 'ºC'),
	(175707, 120, '2014-02-01 00:26:47.000000', 'temperatura', 24.0000, 'ºC'),
	(175708, 120, '2014-02-01 00:26:48.000000', 'temperatura', 1032.0000, 'ºC'),
	(175709, 120, '2014-02-01 00:26:49.000000', 'temperatura', 286.0000, 'ºC'),
	(175710, 120, '2014-02-01 00:26:50.000000', 'temperatura', 734.0000, 'ºC'),
	(175711, 120, '2014-02-01 00:26:51.000000', 'temperatura', 415.0000, 'ºC'),
	(175712, 120, '2014-02-01 00:26:52.000000', 'temperatura', 1073.0000, 'ºC'),
	(175713, 120, '2014-02-01 00:26:53.000000', 'temperatura', 521.0000, 'ºC'),
	(175714, 120, '2014-02-01 00:26:54.000000', 'temperatura', 585.0000, 'ºC'),
	(175715, 120, '2014-02-01 00:26:55.000000', 'temperatura', 161.0000, 'ºC'),
	(175716, 120, '2014-02-01 00:26:56.000000', 'temperatura', 254.0000, 'ºC'),
	(175717, 120, '2014-02-01 00:26:57.000000', 'temperatura', 785.0000, 'ºC'),
	(175718, 120, '2014-02-01 00:26:58.000000', 'temperatura', 764.0000, 'ºC'),
	(175719, 120, '2014-02-01 00:26:59.000000', 'temperatura', 265.0000, 'ºC'),
	(175720, 120, '2014-02-01 00:27:00.000000', 'temperatura', 233.0000, 'ºC'),
	(175721, 120, '2014-02-01 00:27:01.000000', 'temperatura', 372.0000, 'ºC'),
	(175722, 120, '2014-02-01 00:27:02.000000', 'temperatura', 1160.0000, 'ºC'),
	(175723, 120, '2014-02-01 00:27:03.000000', 'temperatura', 1084.0000, 'ºC'),
	(175724, 120, '2014-02-01 00:27:04.000000', 'temperatura', 741.0000, 'ºC'),
	(175725, 120, '2014-02-01 00:27:05.000000', 'temperatura', 456.0000, 'ºC'),
	(175726, 120, '2014-02-01 00:27:06.000000', 'temperatura', 55.0000, 'ºC'),
	(175727, 120, '2014-02-01 00:27:07.000000', 'temperatura', 109.0000, 'ºC'),
	(175728, 120, '2014-02-01 00:27:08.000000', 'temperatura', 380.0000, 'ºC'),
	(175729, 120, '2014-02-01 00:27:09.000000', 'temperatura', 372.0000, 'ºC'),
	(175730, 120, '2014-02-01 00:27:10.000000', 'temperatura', 719.0000, 'ºC'),
	(175731, 120, '2014-02-01 00:27:11.000000', 'temperatura', 83.0000, 'ºC'),
	(175732, 120, '2014-02-01 00:27:12.000000', 'temperatura', 659.0000, 'ºC'),
	(175733, 120, '2014-02-01 00:27:13.000000', 'temperatura', 644.0000, 'ºC'),
	(175734, 120, '2014-02-01 00:27:14.000000', 'temperatura', 44.0000, 'ºC'),
	(175735, 120, '2014-02-01 00:27:15.000000', 'temperatura', 690.0000, 'ºC'),
	(175736, 120, '2014-02-01 00:27:16.000000', 'temperatura', 918.0000, 'ºC'),
	(175737, 120, '2014-02-01 00:27:17.000000', 'temperatura', 119.0000, 'ºC'),
	(175738, 120, '2014-02-01 00:27:18.000000', 'temperatura', 241.0000, 'ºC'),
	(175739, 120, '2014-02-01 00:27:19.000000', 'temperatura', 848.0000, 'ºC'),
	(175740, 120, '2014-02-01 00:27:20.000000', 'temperatura', 1118.0000, 'ºC'),
	(175741, 120, '2014-02-01 00:27:21.000000', 'temperatura', 647.0000, 'ºC'),
	(175742, 120, '2014-02-01 00:27:22.000000', 'temperatura', 1080.0000, 'ºC'),
	(175743, 120, '2014-02-01 00:27:23.000000', 'temperatura', 1060.0000, 'ºC'),
	(175744, 120, '2014-02-01 00:27:24.000000', 'temperatura', 859.0000, 'ºC'),
	(175745, 120, '2014-02-01 00:27:25.000000', 'temperatura', 1117.0000, 'ºC'),
	(175746, 120, '2014-02-01 00:27:26.000000', 'temperatura', 609.0000, 'ºC'),
	(175747, 120, '2014-02-01 00:27:27.000000', 'temperatura', 892.0000, 'ºC'),
	(175748, 120, '2014-02-01 00:27:28.000000', 'temperatura', 236.0000, 'ºC'),
	(175749, 120, '2014-02-01 00:27:29.000000', 'temperatura', 903.0000, 'ºC'),
	(175750, 120, '2014-02-01 00:27:30.000000', 'temperatura', 209.0000, 'ºC'),
	(175751, 120, '2014-02-01 00:27:31.000000', 'temperatura', 737.0000, 'ºC'),
	(175752, 120, '2014-02-01 00:27:32.000000', 'temperatura', 656.0000, 'ºC'),
	(175753, 120, '2014-02-01 00:27:33.000000', 'temperatura', 1073.0000, 'ºC'),
	(175754, 120, '2014-02-01 00:27:34.000000', 'temperatura', 995.0000, 'ºC'),
	(175755, 120, '2014-02-01 00:27:35.000000', 'temperatura', 556.0000, 'ºC'),
	(175756, 120, '2014-02-01 00:27:36.000000', 'temperatura', 998.0000, 'ºC'),
	(175757, 120, '2014-02-01 00:27:37.000000', 'temperatura', 921.0000, 'ºC'),
	(175758, 120, '2014-02-01 00:27:38.000000', 'temperatura', 413.0000, 'ºC'),
	(175759, 120, '2014-02-01 00:27:39.000000', 'temperatura', 501.0000, 'ºC'),
	(175760, 120, '2014-02-01 00:27:40.000000', 'temperatura', 67.0000, 'ºC'),
	(175761, 120, '2014-02-01 00:27:41.000000', 'temperatura', 31.0000, 'ºC'),
	(175762, 120, '2014-02-01 00:27:42.000000', 'temperatura', 1156.0000, 'ºC'),
	(175763, 120, '2014-02-01 00:27:43.000000', 'temperatura', 885.0000, 'ºC'),
	(175764, 120, '2014-02-01 00:27:44.000000', 'temperatura', 959.0000, 'ºC'),
	(175765, 120, '2014-02-01 00:27:45.000000', 'temperatura', 942.0000, 'ºC'),
	(175766, 120, '2014-02-01 00:27:46.000000', 'temperatura', 631.0000, 'ºC'),
	(175767, 120, '2014-02-01 00:27:47.000000', 'temperatura', 331.0000, 'ºC'),
	(175768, 120, '2014-02-01 00:27:48.000000', 'temperatura', 963.0000, 'ºC'),
	(175769, 120, '2014-02-01 00:27:49.000000', 'temperatura', 222.0000, 'ºC'),
	(175770, 120, '2014-02-01 00:27:50.000000', 'temperatura', 622.0000, 'ºC'),
	(175771, 120, '2014-02-01 00:27:51.000000', 'temperatura', 44.0000, 'ºC'),
	(175772, 120, '2014-02-01 00:27:52.000000', 'temperatura', 753.0000, 'ºC'),
	(175773, 120, '2014-02-01 00:27:53.000000', 'temperatura', 34.0000, 'ºC'),
	(175774, 120, '2014-02-01 00:27:54.000000', 'temperatura', 312.0000, 'ºC'),
	(175775, 120, '2014-02-01 00:27:55.000000', 'temperatura', 256.0000, 'ºC'),
	(175776, 120, '2014-02-01 00:27:56.000000', 'temperatura', 348.0000, 'ºC'),
	(175777, 120, '2014-02-01 00:27:57.000000', 'temperatura', 971.0000, 'ºC'),
	(175778, 120, '2014-02-01 00:27:58.000000', 'temperatura', 214.0000, 'ºC'),
	(175779, 120, '2014-02-01 00:27:59.000000', 'temperatura', 554.0000, 'ºC'),
	(175780, 120, '2014-02-01 00:28:00.000000', 'temperatura', 931.0000, 'ºC'),
	(175781, 120, '2014-02-01 00:28:01.000000', 'temperatura', 595.0000, 'ºC'),
	(175782, 120, '2014-02-01 00:28:02.000000', 'temperatura', 180.0000, 'ºC'),
	(175783, 120, '2014-02-01 00:28:03.000000', 'temperatura', 316.0000, 'ºC'),
	(175784, 120, '2014-02-01 00:28:04.000000', 'temperatura', 1042.0000, 'ºC'),
	(175785, 120, '2014-02-01 00:28:05.000000', 'temperatura', 662.0000, 'ºC'),
	(175786, 120, '2014-02-01 00:28:06.000000', 'temperatura', 183.0000, 'ºC'),
	(175787, 120, '2014-02-01 00:28:07.000000', 'temperatura', 131.0000, 'ºC'),
	(175788, 120, '2014-02-01 00:28:08.000000', 'temperatura', 105.0000, 'ºC'),
	(175789, 120, '2014-02-01 00:28:09.000000', 'temperatura', 134.0000, 'ºC'),
	(175790, 120, '2014-02-01 00:28:10.000000', 'temperatura', 354.0000, 'ºC'),
	(175791, 120, '2014-02-01 00:28:11.000000', 'temperatura', 170.0000, 'ºC'),
	(175792, 120, '2014-02-01 00:28:12.000000', 'temperatura', 986.0000, 'ºC'),
	(175793, 120, '2014-02-01 00:28:13.000000', 'temperatura', 824.0000, 'ºC'),
	(175794, 120, '2014-02-01 00:28:14.000000', 'temperatura', 1159.0000, 'ºC'),
	(175795, 120, '2014-02-01 00:28:15.000000', 'temperatura', 925.0000, 'ºC'),
	(175796, 120, '2014-02-01 00:28:16.000000', 'temperatura', 1150.0000, 'ºC'),
	(175797, 120, '2014-02-01 00:28:17.000000', 'temperatura', 572.0000, 'ºC'),
	(175798, 120, '2014-02-01 00:28:18.000000', 'temperatura', 613.0000, 'ºC'),
	(175799, 120, '2014-02-01 00:28:19.000000', 'temperatura', 150.0000, 'ºC'),
	(175800, 120, '2014-02-01 00:28:20.000000', 'temperatura', 112.0000, 'ºC'),
	(175801, 120, '2014-02-01 00:28:21.000000', 'temperatura', 109.0000, 'ºC'),
	(175802, 120, '2014-02-01 00:28:22.000000', 'temperatura', 210.0000, 'ºC'),
	(175803, 120, '2014-02-01 00:28:23.000000', 'temperatura', 725.0000, 'ºC'),
	(175804, 120, '2014-02-01 00:28:24.000000', 'temperatura', 595.0000, 'ºC'),
	(175805, 120, '2014-02-01 00:28:25.000000', 'temperatura', 798.0000, 'ºC'),
	(175806, 120, '2014-02-01 00:28:26.000000', 'temperatura', 1007.0000, 'ºC'),
	(175807, 120, '2014-02-01 00:28:27.000000', 'temperatura', 243.0000, 'ºC'),
	(175808, 120, '2014-02-01 00:28:28.000000', 'temperatura', 593.0000, 'ºC'),
	(175809, 120, '2014-02-01 00:28:29.000000', 'temperatura', 1037.0000, 'ºC'),
	(175810, 120, '2014-02-01 00:28:30.000000', 'temperatura', 1007.0000, 'ºC'),
	(175811, 120, '2014-02-01 00:28:31.000000', 'temperatura', 724.0000, 'ºC'),
	(175812, 120, '2014-02-01 00:28:32.000000', 'temperatura', 598.0000, 'ºC'),
	(175813, 120, '2014-02-01 00:28:33.000000', 'temperatura', 820.0000, 'ºC'),
	(175814, 120, '2014-02-01 00:28:34.000000', 'temperatura', 1104.0000, 'ºC'),
	(175815, 120, '2014-02-01 00:28:35.000000', 'temperatura', 662.0000, 'ºC'),
	(175816, 120, '2014-02-01 00:28:36.000000', 'temperatura', 0.0000, 'ºC'),
	(175817, 120, '2014-02-01 00:28:37.000000', 'temperatura', 415.0000, 'ºC'),
	(175818, 120, '2014-02-01 00:28:38.000000', 'temperatura', 873.0000, 'ºC'),
	(175819, 120, '2014-02-01 00:28:39.000000', 'temperatura', 724.0000, 'ºC'),
	(175820, 120, '2014-02-01 00:28:40.000000', 'temperatura', 998.0000, 'ºC'),
	(175821, 120, '2014-02-01 00:28:41.000000', 'temperatura', 419.0000, 'ºC'),
	(175822, 120, '2014-02-01 00:28:42.000000', 'temperatura', 301.0000, 'ºC'),
	(175823, 120, '2014-02-01 00:28:43.000000', 'temperatura', 250.0000, 'ºC'),
	(175824, 120, '2014-02-01 00:28:44.000000', 'temperatura', 349.0000, 'ºC'),
	(175825, 120, '2014-02-01 00:28:45.000000', 'temperatura', 992.0000, 'ºC'),
	(175826, 120, '2014-02-01 00:28:46.000000', 'temperatura', 316.0000, 'ºC'),
	(175827, 120, '2014-02-01 00:28:47.000000', 'temperatura', 1003.0000, 'ºC'),
	(175828, 120, '2014-02-01 00:28:48.000000', 'temperatura', 467.0000, 'ºC'),
	(175829, 120, '2014-02-01 00:28:49.000000', 'temperatura', 529.0000, 'ºC'),
	(175830, 120, '2014-02-01 00:28:50.000000', 'temperatura', 45.0000, 'ºC'),
	(175831, 120, '2014-02-01 00:28:51.000000', 'temperatura', 1036.0000, 'ºC'),
	(175832, 120, '2014-02-01 00:28:52.000000', 'temperatura', 246.0000, 'ºC'),
	(175833, 120, '2014-02-01 00:28:53.000000', 'temperatura', 522.0000, 'ºC'),
	(175834, 120, '2014-02-01 00:28:54.000000', 'temperatura', 673.0000, 'ºC'),
	(175835, 120, '2014-02-01 00:28:55.000000', 'temperatura', 600.0000, 'ºC'),
	(175836, 120, '2014-02-01 00:28:56.000000', 'temperatura', 983.0000, 'ºC'),
	(175837, 120, '2014-02-01 00:28:57.000000', 'temperatura', 713.0000, 'ºC'),
	(175838, 120, '2014-02-01 00:28:58.000000', 'temperatura', 618.0000, 'ºC'),
	(175839, 120, '2014-02-01 00:28:59.000000', 'temperatura', 951.0000, 'ºC'),
	(175840, 120, '2014-02-01 00:29:00.000000', 'temperatura', 502.0000, 'ºC'),
	(175841, 120, '2014-02-01 00:29:01.000000', 'temperatura', 857.0000, 'ºC'),
	(175842, 120, '2014-02-01 00:29:02.000000', 'temperatura', 379.0000, 'ºC'),
	(175843, 120, '2014-02-01 00:29:03.000000', 'temperatura', 523.0000, 'ºC'),
	(175844, 120, '2014-02-01 00:29:04.000000', 'temperatura', 280.0000, 'ºC'),
	(175845, 120, '2014-02-01 00:29:05.000000', 'temperatura', 1032.0000, 'ºC'),
	(175846, 120, '2014-02-01 00:29:06.000000', 'temperatura', 721.0000, 'ºC'),
	(175847, 120, '2014-02-01 00:29:07.000000', 'temperatura', 508.0000, 'ºC'),
	(175848, 120, '2014-02-01 00:29:08.000000', 'temperatura', 380.0000, 'ºC'),
	(175849, 120, '2014-02-01 00:29:09.000000', 'temperatura', 374.0000, 'ºC'),
	(175850, 120, '2014-02-01 00:29:10.000000', 'temperatura', 733.0000, 'ºC'),
	(175851, 120, '2014-02-01 00:29:11.000000', 'temperatura', 143.0000, 'ºC'),
	(175852, 120, '2014-02-01 00:29:12.000000', 'temperatura', 915.0000, 'ºC'),
	(175853, 120, '2014-02-01 00:29:13.000000', 'temperatura', 546.0000, 'ºC'),
	(175854, 120, '2014-02-01 00:29:14.000000', 'temperatura', 1184.0000, 'ºC'),
	(175855, 120, '2014-02-01 00:29:15.000000', 'temperatura', 686.0000, 'ºC'),
	(175856, 120, '2014-02-01 00:29:16.000000', 'temperatura', 1077.0000, 'ºC'),
	(175857, 120, '2014-02-01 00:29:17.000000', 'temperatura', 929.0000, 'ºC'),
	(175858, 120, '2014-02-01 00:29:18.000000', 'temperatura', 215.0000, 'ºC'),
	(175859, 120, '2014-02-01 00:29:19.000000', 'temperatura', 688.0000, 'ºC'),
	(175860, 120, '2014-02-01 00:29:20.000000', 'temperatura', 394.0000, 'ºC'),
	(175861, 120, '2014-02-01 00:29:21.000000', 'temperatura', 1107.0000, 'ºC'),
	(175862, 120, '2014-02-01 00:29:22.000000', 'temperatura', 755.0000, 'ºC'),
	(175863, 120, '2014-02-01 00:29:23.000000', 'temperatura', 452.0000, 'ºC'),
	(175864, 120, '2014-02-01 00:29:24.000000', 'temperatura', 1195.0000, 'ºC'),
	(175865, 120, '2014-02-01 00:29:25.000000', 'temperatura', 1022.0000, 'ºC'),
	(175866, 120, '2014-02-01 00:29:26.000000', 'temperatura', 326.0000, 'ºC'),
	(175867, 120, '2014-02-01 00:29:27.000000', 'temperatura', 964.0000, 'ºC'),
	(175868, 120, '2014-02-01 00:29:28.000000', 'temperatura', 241.0000, 'ºC'),
	(175869, 120, '2014-02-01 00:29:29.000000', 'temperatura', 716.0000, 'ºC'),
	(175870, 120, '2014-02-01 00:29:30.000000', 'temperatura', 456.0000, 'ºC'),
	(175871, 120, '2014-02-01 00:29:31.000000', 'temperatura', 132.0000, 'ºC'),
	(175872, 120, '2014-02-01 00:29:32.000000', 'temperatura', 494.0000, 'ºC'),
	(175873, 120, '2014-02-01 00:29:33.000000', 'temperatura', 873.0000, 'ºC'),
	(175874, 120, '2014-02-01 00:29:34.000000', 'temperatura', 485.0000, 'ºC'),
	(175875, 120, '2014-02-01 00:29:35.000000', 'temperatura', 1004.0000, 'ºC'),
	(175876, 120, '2014-02-01 00:29:36.000000', 'temperatura', 1168.0000, 'ºC'),
	(175877, 120, '2014-02-01 00:29:37.000000', 'temperatura', 427.0000, 'ºC'),
	(175878, 120, '2014-02-01 00:29:38.000000', 'temperatura', 1033.0000, 'ºC'),
	(175879, 120, '2014-02-01 00:29:39.000000', 'temperatura', 284.0000, 'ºC'),
	(175880, 120, '2014-02-01 00:29:40.000000', 'temperatura', 721.0000, 'ºC'),
	(175881, 120, '2014-02-01 00:29:41.000000', 'temperatura', 353.0000, 'ºC'),
	(175882, 120, '2014-02-01 00:29:42.000000', 'temperatura', 802.0000, 'ºC'),
	(175883, 120, '2014-02-01 00:29:43.000000', 'temperatura', 552.0000, 'ºC'),
	(175884, 120, '2014-02-01 00:29:44.000000', 'temperatura', 353.0000, 'ºC'),
	(175885, 120, '2014-02-01 00:29:45.000000', 'temperatura', 112.0000, 'ºC'),
	(175886, 120, '2014-02-01 00:29:46.000000', 'temperatura', 701.0000, 'ºC'),
	(175887, 120, '2014-02-01 00:29:47.000000', 'temperatura', 767.0000, 'ºC'),
	(175888, 120, '2014-02-01 00:29:48.000000', 'temperatura', 536.0000, 'ºC'),
	(175889, 120, '2014-02-01 00:29:49.000000', 'temperatura', 376.0000, 'ºC'),
	(175890, 120, '2014-02-01 00:29:50.000000', 'temperatura', 276.0000, 'ºC'),
	(175891, 120, '2014-02-01 00:29:51.000000', 'temperatura', 250.0000, 'ºC'),
	(175892, 120, '2014-02-01 00:29:52.000000', 'temperatura', 424.0000, 'ºC'),
	(175893, 120, '2014-02-01 00:29:53.000000', 'temperatura', 169.0000, 'ºC'),
	(175894, 120, '2014-02-01 00:29:54.000000', 'temperatura', 773.0000, 'ºC'),
	(175895, 120, '2014-02-01 00:29:55.000000', 'temperatura', 960.0000, 'ºC'),
	(175896, 120, '2014-02-01 00:29:56.000000', 'temperatura', 81.0000, 'ºC'),
	(175897, 120, '2014-02-01 00:29:57.000000', 'temperatura', 1128.0000, 'ºC'),
	(175898, 120, '2014-02-01 00:29:58.000000', 'temperatura', 594.0000, 'ºC'),
	(175899, 120, '2014-02-01 00:29:59.000000', 'temperatura', 789.0000, 'ºC'),
	(175900, 120, '2014-02-01 00:30:00.000000', 'temperatura', 961.0000, 'ºC'),
	(175901, 120, '2014-02-01 00:30:01.000000', 'temperatura', 38.0000, 'ºC'),
	(175902, 120, '2014-02-01 00:30:02.000000', 'temperatura', 911.0000, 'ºC'),
	(175903, 120, '2014-02-01 00:30:03.000000', 'temperatura', 838.0000, 'ºC'),
	(175904, 120, '2014-02-01 00:30:04.000000', 'temperatura', 259.0000, 'ºC'),
	(175905, 120, '2014-02-01 00:30:05.000000', 'temperatura', 1182.0000, 'ºC'),
	(175906, 120, '2014-02-01 00:30:06.000000', 'temperatura', 331.0000, 'ºC'),
	(175907, 120, '2014-02-01 00:30:07.000000', 'temperatura', 512.0000, 'ºC'),
	(175908, 120, '2014-02-01 00:30:08.000000', 'temperatura', 369.0000, 'ºC'),
	(175909, 120, '2014-02-01 00:30:09.000000', 'temperatura', 307.0000, 'ºC'),
	(175910, 120, '2014-02-01 00:30:10.000000', 'temperatura', 430.0000, 'ºC'),
	(175911, 120, '2014-02-01 00:30:11.000000', 'temperatura', 27.0000, 'ºC'),
	(175912, 120, '2014-02-01 00:30:12.000000', 'temperatura', 47.0000, 'ºC'),
	(175913, 120, '2014-02-01 00:30:13.000000', 'temperatura', 154.0000, 'ºC'),
	(175914, 120, '2014-02-01 00:30:14.000000', 'temperatura', 628.0000, 'ºC'),
	(175915, 120, '2014-02-01 00:30:15.000000', 'temperatura', 279.0000, 'ºC'),
	(175916, 120, '2014-02-01 00:30:16.000000', 'temperatura', 713.0000, 'ºC'),
	(175917, 120, '2014-02-01 00:30:17.000000', 'temperatura', 327.0000, 'ºC'),
	(175918, 120, '2014-02-01 00:30:18.000000', 'temperatura', 698.0000, 'ºC'),
	(175919, 120, '2014-02-01 00:30:19.000000', 'temperatura', 108.0000, 'ºC'),
	(175920, 120, '2014-02-01 00:30:20.000000', 'temperatura', 847.0000, 'ºC'),
	(175921, 120, '2014-02-01 00:30:21.000000', 'temperatura', 310.0000, 'ºC'),
	(175922, 120, '2014-02-01 00:30:22.000000', 'temperatura', 211.0000, 'ºC'),
	(175923, 120, '2014-02-01 00:30:23.000000', 'temperatura', 127.0000, 'ºC'),
	(175924, 120, '2014-02-01 00:30:24.000000', 'temperatura', 1199.0000, 'ºC'),
	(175925, 120, '2014-02-01 00:30:25.000000', 'temperatura', 817.0000, 'ºC'),
	(175926, 120, '2014-02-01 00:30:26.000000', 'temperatura', 488.0000, 'ºC'),
	(175927, 120, '2014-02-01 00:30:27.000000', 'temperatura', 1188.0000, 'ºC'),
	(175928, 120, '2014-02-01 00:30:28.000000', 'temperatura', 876.0000, 'ºC'),
	(175929, 120, '2014-02-01 00:30:29.000000', 'temperatura', 817.0000, 'ºC'),
	(175930, 120, '2014-02-01 00:30:30.000000', 'temperatura', 256.0000, 'ºC'),
	(175931, 120, '2014-02-01 00:30:31.000000', 'temperatura', 31.0000, 'ºC'),
	(175932, 120, '2014-02-01 00:30:32.000000', 'temperatura', 588.0000, 'ºC'),
	(175933, 120, '2014-02-01 00:30:33.000000', 'temperatura', 446.0000, 'ºC'),
	(175934, 120, '2014-02-01 00:30:34.000000', 'temperatura', 469.0000, 'ºC'),
	(175935, 120, '2014-02-01 00:30:35.000000', 'temperatura', 1007.0000, 'ºC'),
	(175936, 120, '2014-02-01 00:30:36.000000', 'temperatura', 30.0000, 'ºC'),
	(175937, 120, '2014-02-01 00:30:37.000000', 'temperatura', 726.0000, 'ºC'),
	(175938, 120, '2014-02-01 00:30:38.000000', 'temperatura', 1143.0000, 'ºC'),
	(175939, 120, '2014-02-01 00:30:39.000000', 'temperatura', 1136.0000, 'ºC'),
	(175940, 120, '2014-02-01 00:30:40.000000', 'temperatura', 1054.0000, 'ºC'),
	(175941, 120, '2014-02-01 00:30:41.000000', 'temperatura', 661.0000, 'ºC'),
	(175942, 120, '2014-02-01 00:30:42.000000', 'temperatura', 142.0000, 'ºC'),
	(175943, 120, '2014-02-01 00:30:43.000000', 'temperatura', 1129.0000, 'ºC'),
	(175944, 120, '2014-02-01 00:30:44.000000', 'temperatura', 417.0000, 'ºC'),
	(175945, 120, '2014-02-01 00:30:45.000000', 'temperatura', 1101.0000, 'ºC'),
	(175946, 120, '2014-02-01 00:30:46.000000', 'temperatura', 652.0000, 'ºC'),
	(175947, 120, '2014-02-01 00:30:47.000000', 'temperatura', 1158.0000, 'ºC'),
	(175948, 120, '2014-02-01 00:30:48.000000', 'temperatura', 236.0000, 'ºC'),
	(175949, 120, '2014-02-01 00:30:49.000000', 'temperatura', 106.0000, 'ºC'),
	(175950, 120, '2014-02-01 00:30:50.000000', 'temperatura', 1020.0000, 'ºC'),
	(175951, 120, '2014-02-01 00:30:51.000000', 'temperatura', 1186.0000, 'ºC'),
	(175952, 120, '2014-02-01 00:30:52.000000', 'temperatura', 469.0000, 'ºC'),
	(175953, 120, '2014-02-01 00:30:53.000000', 'temperatura', 1186.0000, 'ºC'),
	(175954, 120, '2014-02-01 00:30:54.000000', 'temperatura', 927.0000, 'ºC'),
	(175955, 120, '2014-02-01 00:30:55.000000', 'temperatura', 1074.0000, 'ºC'),
	(175956, 120, '2014-02-01 00:30:56.000000', 'temperatura', 192.0000, 'ºC'),
	(175957, 120, '2014-02-01 00:30:57.000000', 'temperatura', 136.0000, 'ºC'),
	(175958, 120, '2014-02-01 00:30:58.000000', 'temperatura', 107.0000, 'ºC'),
	(175959, 120, '2014-02-01 00:30:59.000000', 'temperatura', 125.0000, 'ºC'),
	(175960, 120, '2014-02-01 00:31:00.000000', 'temperatura', 306.0000, 'ºC'),
	(175961, 120, '2014-02-01 00:31:01.000000', 'temperatura', 1155.0000, 'ºC'),
	(175962, 120, '2014-02-01 00:31:02.000000', 'temperatura', 57.0000, 'ºC'),
	(175963, 120, '2014-02-01 00:31:03.000000', 'temperatura', 420.0000, 'ºC'),
	(175964, 120, '2014-02-01 00:31:04.000000', 'temperatura', 729.0000, 'ºC'),
	(175965, 120, '2014-02-01 00:31:05.000000', 'temperatura', 1187.0000, 'ºC'),
	(175966, 120, '2014-02-01 00:31:06.000000', 'temperatura', 149.0000, 'ºC'),
	(175967, 120, '2014-02-01 00:31:07.000000', 'temperatura', 785.0000, 'ºC'),
	(175968, 120, '2014-02-01 00:31:08.000000', 'temperatura', 1077.0000, 'ºC'),
	(175969, 120, '2014-02-01 00:31:09.000000', 'temperatura', 630.0000, 'ºC'),
	(175970, 120, '2014-02-01 00:31:10.000000', 'temperatura', 1120.0000, 'ºC'),
	(175971, 120, '2014-02-01 00:31:11.000000', 'temperatura', 112.0000, 'ºC'),
	(175972, 120, '2014-02-01 00:31:12.000000', 'temperatura', 799.0000, 'ºC'),
	(175973, 120, '2014-02-01 00:31:13.000000', 'temperatura', 59.0000, 'ºC'),
	(175974, 120, '2014-02-01 00:31:14.000000', 'temperatura', 298.0000, 'ºC'),
	(175975, 120, '2014-02-01 00:31:15.000000', 'temperatura', 115.0000, 'ºC'),
	(175976, 120, '2014-02-01 00:31:16.000000', 'temperatura', 883.0000, 'ºC'),
	(175977, 120, '2014-02-01 00:31:17.000000', 'temperatura', 468.0000, 'ºC'),
	(175978, 120, '2014-02-01 00:31:18.000000', 'temperatura', 894.0000, 'ºC'),
	(175979, 120, '2014-02-01 00:31:19.000000', 'temperatura', 667.0000, 'ºC'),
	(175980, 120, '2014-02-01 00:31:20.000000', 'temperatura', 652.0000, 'ºC'),
	(175981, 120, '2014-02-01 00:31:21.000000', 'temperatura', 59.0000, 'ºC'),
	(175982, 120, '2014-02-01 00:31:22.000000', 'temperatura', 742.0000, 'ºC'),
	(175983, 120, '2014-02-01 00:31:23.000000', 'temperatura', 1132.0000, 'ºC'),
	(175984, 120, '2014-02-01 00:31:24.000000', 'temperatura', 1033.0000, 'ºC'),
	(175985, 120, '2014-02-01 00:31:25.000000', 'temperatura', 572.0000, 'ºC'),
	(175986, 120, '2014-02-01 00:31:26.000000', 'temperatura', 961.0000, 'ºC'),
	(175987, 120, '2014-02-01 00:31:27.000000', 'temperatura', 689.0000, 'ºC'),
	(175988, 120, '2014-02-01 00:31:28.000000', 'temperatura', 564.0000, 'ºC'),
	(175989, 120, '2014-02-01 00:31:29.000000', 'temperatura', 754.0000, 'ºC'),
	(175990, 120, '2014-02-01 00:31:30.000000', 'temperatura', 877.0000, 'ºC'),
	(175991, 120, '2014-02-01 00:31:31.000000', 'temperatura', 923.0000, 'ºC'),
	(175992, 120, '2014-02-01 00:31:32.000000', 'temperatura', 787.0000, 'ºC'),
	(175993, 120, '2014-02-01 00:31:33.000000', 'temperatura', 1165.0000, 'ºC'),
	(175994, 120, '2014-02-01 00:31:34.000000', 'temperatura', 1065.0000, 'ºC'),
	(175995, 120, '2014-02-01 00:31:35.000000', 'temperatura', 632.0000, 'ºC'),
	(175996, 120, '2014-02-01 00:31:36.000000', 'temperatura', 1164.0000, 'ºC'),
	(175997, 120, '2014-02-01 00:31:37.000000', 'temperatura', 324.0000, 'ºC'),
	(175998, 120, '2014-02-01 00:31:38.000000', 'temperatura', 527.0000, 'ºC'),
	(175999, 120, '2014-02-01 00:31:39.000000', 'temperatura', 464.0000, 'ºC'),
	(176000, 120, '2014-02-01 00:31:40.000000', 'temperatura', 742.0000, 'ºC'),
	(176001, 120, '2014-02-01 00:31:41.000000', 'temperatura', 1116.0000, 'ºC'),
	(176002, 120, '2014-02-01 00:31:42.000000', 'temperatura', 956.0000, 'ºC'),
	(176003, 120, '2014-02-01 00:31:43.000000', 'temperatura', 234.0000, 'ºC'),
	(176004, 120, '2014-02-01 00:31:44.000000', 'temperatura', 701.0000, 'ºC'),
	(176005, 120, '2014-02-01 00:31:45.000000', 'temperatura', 404.0000, 'ºC'),
	(176006, 120, '2014-02-01 00:31:46.000000', 'temperatura', 1116.0000, 'ºC'),
	(176007, 120, '2014-02-01 00:31:47.000000', 'temperatura', 767.0000, 'ºC'),
	(176008, 120, '2014-02-01 00:31:48.000000', 'temperatura', 490.0000, 'ºC'),
	(176009, 120, '2014-02-01 00:31:49.000000', 'temperatura', 149.0000, 'ºC'),
	(176010, 120, '2014-02-01 00:31:50.000000', 'temperatura', 477.0000, 'ºC'),
	(176011, 120, '2014-02-01 00:31:51.000000', 'temperatura', 736.0000, 'ºC'),
	(176012, 120, '2014-02-01 00:31:52.000000', 'temperatura', 1051.0000, 'ºC'),
	(176013, 120, '2014-02-01 00:31:53.000000', 'temperatura', 645.0000, 'ºC'),
	(176014, 120, '2014-02-01 00:31:54.000000', 'temperatura', 76.0000, 'ºC'),
	(176015, 120, '2014-02-01 00:31:55.000000', 'temperatura', 843.0000, 'ºC'),
	(176016, 120, '2014-02-01 00:31:56.000000', 'temperatura', 390.0000, 'ºC'),
	(176017, 120, '2014-02-01 00:31:57.000000', 'temperatura', 619.0000, 'ºC'),
	(176018, 120, '2014-02-01 00:31:58.000000', 'temperatura', 727.0000, 'ºC'),
	(176019, 120, '2014-02-01 00:31:59.000000', 'temperatura', 580.0000, 'ºC'),
	(176020, 120, '2014-02-01 00:32:00.000000', 'temperatura', 718.0000, 'ºC'),
	(176021, 120, '2014-02-01 00:32:01.000000', 'temperatura', 649.0000, 'ºC'),
	(176022, 120, '2014-02-01 00:32:02.000000', 'temperatura', 1093.0000, 'ºC'),
	(176023, 120, '2014-02-01 00:32:03.000000', 'temperatura', 1120.0000, 'ºC'),
	(176024, 120, '2014-02-01 00:32:04.000000', 'temperatura', 1121.0000, 'ºC'),
	(176025, 120, '2014-02-01 00:32:05.000000', 'temperatura', 1045.0000, 'ºC'),
	(176026, 120, '2014-02-01 00:32:06.000000', 'temperatura', 664.0000, 'ºC'),
	(176027, 120, '2014-02-01 00:32:07.000000', 'temperatura', 183.0000, 'ºC'),
	(176028, 120, '2014-02-01 00:32:08.000000', 'temperatura', 124.0000, 'ºC'),
	(176029, 120, '2014-02-01 00:32:09.000000', 'temperatura', 70.0000, 'ºC'),
	(176030, 120, '2014-02-01 00:32:10.000000', 'temperatura', 1179.0000, 'ºC'),
	(176031, 120, '2014-02-01 00:32:11.000000', 'temperatura', 886.0000, 'ºC'),
	(176032, 120, '2014-02-01 00:32:12.000000', 'temperatura', 895.0000, 'ºC'),
	(176033, 120, '2014-02-01 00:32:13.000000', 'temperatura', 617.0000, 'ºC'),
	(176034, 120, '2014-02-01 00:32:14.000000', 'temperatura', 401.0000, 'ºC'),
	(176035, 120, '2014-02-01 00:32:15.000000', 'temperatura', 156.0000, 'ºC'),
	(176036, 120, '2014-02-01 00:32:16.000000', 'temperatura', 774.0000, 'ºC'),
	(176037, 120, '2014-02-01 00:32:17.000000', 'temperatura', 1005.0000, 'ºC'),
	(176038, 120, '2014-02-01 00:32:18.000000', 'temperatura', 304.0000, 'ºC'),
	(176039, 120, '2014-02-01 00:32:19.000000', 'temperatura', 904.0000, 'ºC'),
	(176040, 120, '2014-02-01 00:32:20.000000', 'temperatura', 9.0000, 'ºC'),
	(176041, 120, '2014-02-01 00:32:21.000000', 'temperatura', 934.0000, 'ºC'),
	(176042, 120, '2014-02-01 00:32:22.000000', 'temperatura', 1043.0000, 'ºC'),
	(176043, 120, '2014-02-01 00:32:23.000000', 'temperatura', 12.0000, 'ºC'),
	(176044, 120, '2014-02-01 00:32:24.000000', 'temperatura', 534.0000, 'ºC'),
	(176045, 120, '2014-02-01 00:32:25.000000', 'temperatura', 236.0000, 'ºC'),
	(176046, 120, '2014-02-01 00:32:26.000000', 'temperatura', 775.0000, 'ºC'),
	(176047, 120, '2014-02-01 00:32:27.000000', 'temperatura', 770.0000, 'ºC'),
	(176048, 120, '2014-02-01 00:32:28.000000', 'temperatura', 323.0000, 'ºC'),
	(176049, 120, '2014-02-01 00:32:29.000000', 'temperatura', 507.0000, 'ºC'),
	(176050, 120, '2014-02-01 00:32:30.000000', 'temperatura', 366.0000, 'ºC'),
	(176051, 120, '2014-02-01 00:32:31.000000', 'temperatura', 312.0000, 'ºC'),
	(176052, 120, '2014-02-01 00:32:32.000000', 'temperatura', 459.0000, 'ºC'),
	(176053, 120, '2014-02-01 00:32:33.000000', 'temperatura', 161.0000, 'ºC'),
	(176054, 120, '2014-02-01 00:32:34.000000', 'temperatura', 627.0000, 'ºC'),
	(176055, 120, '2014-02-01 00:32:35.000000', 'temperatura', 253.0000, 'ºC'),
	(176056, 120, '2014-02-01 00:32:36.000000', 'temperatura', 585.0000, 'ºC'),
	(176057, 120, '2014-02-01 00:32:37.000000', 'temperatura', 965.0000, 'ºC'),
	(176058, 120, '2014-02-01 00:32:38.000000', 'temperatura', 672.0000, 'ºC'),
	(176059, 120, '2014-02-01 00:32:39.000000', 'temperatura', 466.0000, 'ºC'),
	(176060, 120, '2014-02-01 00:32:40.000000', 'temperatura', 316.0000, 'ºC'),
	(176061, 120, '2014-02-01 00:32:41.000000', 'temperatura', 180.0000, 'ºC'),
	(176062, 120, '2014-02-01 00:32:42.000000', 'temperatura', 1154.0000, 'ºC'),
	(176063, 120, '2014-02-01 00:32:43.000000', 'temperatura', 429.0000, 'ºC'),
	(176064, 120, '2014-02-01 00:32:44.000000', 'temperatura', 1083.0000, 'ºC'),
	(176065, 120, '2014-02-01 00:32:45.000000', 'temperatura', 530.0000, 'ºC'),
	(176066, 120, '2014-02-01 00:32:46.000000', 'temperatura', 601.0000, 'ºC'),
	(176067, 120, '2014-02-01 00:32:47.000000', 'temperatura', 215.0000, 'ºC'),
	(176068, 120, '2014-02-01 00:32:48.000000', 'temperatura', 471.0000, 'ºC'),
	(176069, 120, '2014-02-01 00:32:49.000000', 'temperatura', 512.0000, 'ºC'),
	(176070, 120, '2014-02-01 00:32:50.000000', 'temperatura', 1146.0000, 'ºC'),
	(176071, 120, '2014-02-01 00:32:51.000000', 'temperatura', 595.0000, 'ºC'),
	(176072, 120, '2014-02-01 00:32:52.000000', 'temperatura', 737.0000, 'ºC'),
	(176073, 120, '2014-02-01 00:32:53.000000', 'temperatura', 702.0000, 'ºC'),
	(176074, 120, '2014-02-01 00:32:54.000000', 'temperatura', 100.0000, 'ºC'),
	(176075, 120, '2014-02-01 00:32:55.000000', 'temperatura', 794.0000, 'ºC'),
	(176076, 120, '2014-02-01 00:32:56.000000', 'temperatura', 70.0000, 'ºC'),
	(176077, 120, '2014-02-01 00:32:57.000000', 'temperatura', 368.0000, 'ºC'),
	(176078, 120, '2014-02-01 00:32:58.000000', 'temperatura', 429.0000, 'ºC'),
	(176079, 120, '2014-02-01 00:32:59.000000', 'temperatura', 1042.0000, 'ºC'),
	(176080, 120, '2014-02-01 00:33:00.000000', 'temperatura', 325.0000, 'ºC'),
	(176081, 120, '2014-02-01 00:33:01.000000', 'temperatura', 900.0000, 'ºC'),
	(176082, 120, '2014-02-01 00:33:02.000000', 'temperatura', 1124.0000, 'ºC'),
	(176083, 120, '2014-02-01 00:33:03.000000', 'temperatura', 520.0000, 'ºC'),
	(176084, 120, '2014-02-01 00:33:04.000000', 'temperatura', 430.0000, 'ºC'),
	(176085, 120, '2014-02-01 00:33:05.000000', 'temperatura', 589.0000, 'ºC'),
	(176086, 120, '2014-02-01 00:33:06.000000', 'temperatura', 456.0000, 'ºC'),
	(176087, 120, '2014-02-01 00:33:07.000000', 'temperatura', 513.0000, 'ºC'),
	(176088, 120, '2014-02-01 00:33:08.000000', 'temperatura', 1198.0000, 'ºC'),
	(176089, 120, '2014-02-01 00:33:09.000000', 'temperatura', 851.0000, 'ºC'),
	(176090, 120, '2014-02-01 00:33:10.000000', 'temperatura', 662.0000, 'ºC'),
	(176091, 120, '2014-02-01 00:33:11.000000', 'temperatura', 756.0000, 'ºC'),
	(176092, 120, '2014-02-01 00:33:12.000000', 'temperatura', 596.0000, 'ºC'),
	(176093, 120, '2014-02-01 00:33:13.000000', 'temperatura', 712.0000, 'ºC'),
	(176094, 120, '2014-02-01 00:33:14.000000', 'temperatura', 574.0000, 'ºC'),
	(176095, 120, '2014-02-01 00:33:15.000000', 'temperatura', 734.0000, 'ºC'),
	(176096, 120, '2014-02-01 00:33:16.000000', 'temperatura', 750.0000, 'ºC'),
	(176097, 120, '2014-02-01 00:33:17.000000', 'temperatura', 348.0000, 'ºC'),
	(176098, 120, '2014-02-01 00:33:18.000000', 'temperatura', 690.0000, 'ºC'),
	(176099, 120, '2014-02-01 00:33:19.000000', 'temperatura', 5.0000, 'ºC'),
	(176100, 120, '2014-02-01 00:33:20.000000', 'temperatura', 358.0000, 'ºC'),
	(176101, 120, '2014-02-01 00:33:21.000000', 'temperatura', 574.0000, 'ºC'),
	(176102, 120, '2014-02-01 00:33:22.000000', 'temperatura', 595.0000, 'ºC'),
	(176103, 120, '2014-02-01 00:33:23.000000', 'temperatura', 56.0000, 'ºC'),
	(176104, 120, '2014-02-01 00:33:24.000000', 'temperatura', 894.0000, 'ºC'),
	(176105, 120, '2014-02-01 00:33:25.000000', 'temperatura', 703.0000, 'ºC'),
	(176106, 120, '2014-02-01 00:33:26.000000', 'temperatura', 832.0000, 'ºC'),
	(176107, 120, '2014-02-01 00:33:27.000000', 'temperatura', 852.0000, 'ºC'),
	(176108, 120, '2014-02-01 00:33:28.000000', 'temperatura', 566.0000, 'ºC'),
	(176109, 120, '2014-02-01 00:33:29.000000', 'temperatura', 272.0000, 'ºC'),
	(176110, 120, '2014-02-01 00:33:30.000000', 'temperatura', 865.0000, 'ºC'),
	(176111, 120, '2014-02-01 00:33:31.000000', 'temperatura', 1109.0000, 'ºC'),
	(176112, 120, '2014-02-01 00:33:32.000000', 'temperatura', 551.0000, 'ºC'),
	(176113, 120, '2014-02-01 00:33:33.000000', 'temperatura', 629.0000, 'ºC'),
	(176114, 120, '2014-02-01 00:33:34.000000', 'temperatura', 292.0000, 'ºC'),
	(176115, 120, '2014-02-01 00:33:35.000000', 'temperatura', 772.0000, 'ºC'),
	(176116, 120, '2014-02-01 00:33:36.000000', 'temperatura', 587.0000, 'ºC'),
	(176117, 120, '2014-02-01 00:33:37.000000', 'temperatura', 618.0000, 'ºC'),
	(176118, 120, '2014-02-01 00:33:38.000000', 'temperatura', 130.0000, 'ºC'),
	(176119, 120, '2014-02-01 00:33:39.000000', 'temperatura', 1198.0000, 'ºC'),
	(176120, 120, '2014-02-01 00:33:40.000000', 'temperatura', 801.0000, 'ºC'),
	(176121, 120, '2014-02-01 00:33:41.000000', 'temperatura', 410.0000, 'ºC'),
	(176122, 120, '2014-02-01 00:33:42.000000', 'temperatura', 848.0000, 'ºC'),
	(176123, 120, '2014-02-01 00:33:43.000000', 'temperatura', 610.0000, 'ºC'),
	(176124, 120, '2014-02-01 00:33:44.000000', 'temperatura', 506.0000, 'ºC'),
	(176125, 120, '2014-02-01 00:33:45.000000', 'temperatura', 700.0000, 'ºC'),
	(176126, 120, '2014-02-01 00:33:46.000000', 'temperatura', 784.0000, 'ºC'),
	(176127, 120, '2014-02-01 00:33:47.000000', 'temperatura', 619.0000, 'ºC'),
	(176128, 120, '2014-02-01 00:33:48.000000', 'temperatura', 744.0000, 'ºC'),
	(176129, 120, '2014-02-01 00:33:49.000000', 'temperatura', 664.0000, 'ºC'),
	(176130, 120, '2014-02-01 00:33:50.000000', 'temperatura', 1088.0000, 'ºC'),
	(176131, 120, '2014-02-01 00:33:51.000000', 'temperatura', 1047.0000, 'ºC'),
	(176132, 120, '2014-02-01 00:33:52.000000', 'temperatura', 771.0000, 'ºC'),
	(176133, 120, '2014-02-01 00:33:53.000000', 'temperatura', 716.0000, 'ºC'),
	(176134, 120, '2014-02-01 00:33:54.000000', 'temperatura', 68.0000, 'ºC'),
	(176135, 120, '2014-02-01 00:33:55.000000', 'temperatura', 593.0000, 'ºC'),
	(176136, 120, '2014-02-01 00:33:56.000000', 'temperatura', 361.0000, 'ºC'),
	(176137, 120, '2014-02-01 00:33:57.000000', 'temperatura', 28.0000, 'ºC'),
	(176138, 120, '2014-02-01 00:33:58.000000', 'temperatura', 258.0000, 'ºC'),
	(176139, 120, '2014-02-01 00:33:59.000000', 'temperatura', 5.0000, 'ºC'),
	(176140, 120, '2014-02-01 00:34:00.000000', 'temperatura', 450.0000, 'ºC'),
	(176141, 120, '2014-02-01 00:34:01.000000', 'temperatura', 1038.0000, 'ºC'),
	(176142, 120, '2014-02-01 00:34:02.000000', 'temperatura', 238.0000, 'ºC'),
	(176143, 120, '2014-02-01 00:34:03.000000', 'temperatura', 479.0000, 'ºC'),
	(176144, 120, '2014-02-01 00:34:04.000000', 'temperatura', 480.0000, 'ºC'),
	(176145, 120, '2014-02-01 00:34:05.000000', 'temperatura', 962.0000, 'ºC'),
	(176146, 120, '2014-02-01 00:34:06.000000', 'temperatura', 973.0000, 'ºC'),
	(176147, 120, '2014-02-01 00:34:07.000000', 'temperatura', 779.0000, 'ºC'),
	(176148, 120, '2014-02-01 00:34:08.000000', 'temperatura', 977.0000, 'ºC'),
	(176149, 120, '2014-02-01 00:34:09.000000', 'temperatura', 149.0000, 'ºC'),
	(176150, 120, '2014-02-01 00:34:10.000000', 'temperatura', 216.0000, 'ºC'),
	(176151, 120, '2014-02-01 00:34:11.000000', 'temperatura', 631.0000, 'ºC'),
	(176152, 120, '2014-02-01 00:34:12.000000', 'temperatura', 109.0000, 'ºC'),
	(176153, 120, '2014-02-01 00:34:13.000000', 'temperatura', 1052.0000, 'ºC'),
	(176154, 120, '2014-02-01 00:34:14.000000', 'temperatura', 133.0000, 'ºC'),
	(176155, 120, '2014-02-01 00:34:15.000000', 'temperatura', 1108.0000, 'ºC'),
	(176156, 120, '2014-02-01 00:34:16.000000', 'temperatura', 342.0000, 'ºC'),
	(176157, 120, '2014-02-01 00:34:17.000000', 'temperatura', 788.0000, 'ºC'),
	(176158, 120, '2014-02-01 00:34:18.000000', 'temperatura', 513.0000, 'ºC'),
	(176159, 120, '2014-02-01 00:34:19.000000', 'temperatura', 203.0000, 'ºC'),
	(176160, 120, '2014-02-01 00:34:20.000000', 'temperatura', 678.0000, 'ºC'),
	(176161, 120, '2014-02-01 00:34:21.000000', 'temperatura', 379.0000, 'ºC'),
	(176162, 120, '2014-02-01 00:34:22.000000', 'temperatura', 1062.0000, 'ºC'),
	(176163, 120, '2014-02-01 00:34:23.000000', 'temperatura', 574.0000, 'ºC'),
	(176164, 120, '2014-02-01 00:34:24.000000', 'temperatura', 883.0000, 'ºC'),
	(176165, 120, '2014-02-01 00:34:25.000000', 'temperatura', 294.0000, 'ºC'),
	(176166, 120, '2014-02-01 00:34:26.000000', 'temperatura', 21.0000, 'ºC'),
	(176167, 120, '2014-02-01 00:34:27.000000', 'temperatura', 426.0000, 'ºC'),
	(176168, 120, '2014-02-01 00:34:28.000000', 'temperatura', 867.0000, 'ºC'),
	(176169, 120, '2014-02-01 00:34:29.000000', 'temperatura', 656.0000, 'ºC'),
	(176170, 120, '2014-02-01 00:34:30.000000', 'temperatura', 679.0000, 'ºC'),
	(176171, 120, '2014-02-01 00:34:31.000000', 'temperatura', 230.0000, 'ºC'),
	(176172, 120, '2014-02-01 00:34:32.000000', 'temperatura', 313.0000, 'ºC'),
	(176173, 120, '2014-02-01 00:34:33.000000', 'temperatura', 877.0000, 'ºC'),
	(176174, 120, '2014-02-01 00:34:34.000000', 'temperatura', 1045.0000, 'ºC'),
	(176175, 120, '2014-02-01 00:34:35.000000', 'temperatura', 197.0000, 'ºC'),
	(176176, 120, '2014-02-01 00:34:36.000000', 'temperatura', 247.0000, 'ºC'),
	(176177, 120, '2014-02-01 00:34:37.000000', 'temperatura', 644.0000, 'ºC'),
	(176178, 120, '2014-02-01 00:34:38.000000', 'temperatura', 83.0000, 'ºC'),
	(176179, 120, '2014-02-01 00:34:39.000000', 'temperatura', 880.0000, 'ºC'),
	(176180, 120, '2014-02-01 00:34:40.000000', 'temperatura', 555.0000, 'ºC'),
	(176181, 120, '2014-02-01 00:34:41.000000', 'temperatura', 133.0000, 'ºC'),
	(176182, 120, '2014-02-01 00:34:42.000000', 'temperatura', 202.0000, 'ºC'),
	(176183, 120, '2014-02-01 00:34:43.000000', 'temperatura', 613.0000, 'ºC'),
	(176184, 120, '2014-02-01 00:34:44.000000', 'temperatura', 58.0000, 'ºC'),
	(176185, 120, '2014-02-01 00:34:45.000000', 'temperatura', 852.0000, 'ºC'),
	(176186, 120, '2014-02-01 00:34:46.000000', 'temperatura', 486.0000, 'ºC'),
	(176187, 120, '2014-02-01 00:34:47.000000', 'temperatura', 1075.0000, 'ºC'),
	(176188, 120, '2014-02-01 00:34:48.000000', 'temperatura', 319.0000, 'ºC'),
	(176189, 120, '2014-02-01 00:34:49.000000', 'temperatura', 770.0000, 'ºC'),
	(176190, 120, '2014-02-01 00:34:50.000000', 'temperatura', 494.0000, 'ºC'),
	(176191, 120, '2014-02-01 00:34:51.000000', 'temperatura', 161.0000, 'ºC'),
	(176192, 120, '2014-02-01 00:34:52.000000', 'temperatura', 524.0000, 'ºC'),
	(176193, 120, '2014-02-01 00:34:53.000000', 'temperatura', 937.0000, 'ºC'),
	(176194, 120, '2014-02-01 00:34:54.000000', 'temperatura', 713.0000, 'ºC'),
	(176195, 120, '2014-02-01 00:34:55.000000', 'temperatura', 757.0000, 'ºC'),
	(176196, 120, '2014-02-01 00:34:56.000000', 'temperatura', 443.0000, 'ºC'),
	(176197, 120, '2014-02-01 00:34:57.000000', 'temperatura', 1147.0000, 'ºC'),
	(176198, 120, '2014-02-01 00:34:58.000000', 'temperatura', 804.0000, 'ºC'),
	(176199, 120, '2014-02-01 00:34:59.000000', 'temperatura', 581.0000, 'ºC'),
	(176200, 120, '2014-02-01 00:35:00.000000', 'temperatura', 493.0000, 'ºC'),
	(176201, 120, '2014-02-01 00:35:01.000000', 'temperatura', 722.0000, 'ºC'),
	(176202, 120, '2014-02-01 00:35:02.000000', 'temperatura', 934.0000, 'ºC'),
	(176203, 120, '2014-02-01 00:35:03.000000', 'temperatura', 103.0000, 'ºC'),
	(176204, 120, '2014-02-01 00:35:04.000000', 'temperatura', 112.0000, 'ºC'),
	(176205, 120, '2014-02-01 00:35:05.000000', 'temperatura', 252.0000, 'ºC'),
	(176206, 120, '2014-02-01 00:35:06.000000', 'temperatura', 927.0000, 'ºC'),
	(176207, 120, '2014-02-01 00:35:07.000000', 'temperatura', 276.0000, 'ºC'),
	(176208, 120, '2014-02-01 00:35:08.000000', 'temperatura', 1001.0000, 'ºC'),
	(176209, 120, '2014-02-01 00:35:09.000000', 'temperatura', 578.0000, 'ºC'),
	(176210, 120, '2014-02-01 00:35:10.000000', 'temperatura', 1089.0000, 'ºC'),
	(176211, 120, '2014-02-01 00:35:11.000000', 'temperatura', 110.0000, 'ºC'),
	(176212, 120, '2014-02-01 00:35:12.000000', 'temperatura', 882.0000, 'ºC'),
	(176213, 120, '2014-02-01 00:35:13.000000', 'temperatura', 483.0000, 'ºC'),
	(176214, 120, '2014-02-01 00:35:14.000000', 'temperatura', 967.0000, 'ºC'),
	(176215, 120, '2014-02-01 00:35:15.000000', 'temperatura', 988.0000, 'ºC'),
	(176216, 120, '2014-02-01 00:35:16.000000', 'temperatura', 840.0000, 'ºC'),
	(176217, 120, '2014-02-01 00:35:17.000000', 'temperatura', 37.0000, 'ºC'),
	(176218, 120, '2014-02-01 00:35:18.000000', 'temperatura', 63.0000, 'ºC'),
	(176219, 120, '2014-02-01 00:35:19.000000', 'temperatura', 206.0000, 'ºC'),
	(176220, 120, '2014-02-01 00:35:20.000000', 'temperatura', 841.0000, 'ºC'),
	(176221, 120, '2014-02-01 00:35:21.000000', 'temperatura', 1189.0000, 'ºC'),
	(176222, 120, '2014-02-01 00:35:22.000000', 'temperatura', 1022.0000, 'ºC'),
	(176223, 120, '2014-02-01 00:35:23.000000', 'temperatura', 341.0000, 'ºC'),
	(176224, 120, '2014-02-01 00:35:24.000000', 'temperatura', 1043.0000, 'ºC'),
	(176225, 120, '2014-02-01 00:35:25.000000', 'temperatura', 591.0000, 'ºC'),
	(176226, 120, '2014-02-01 00:35:26.000000', 'temperatura', 1026.0000, 'ºC'),
	(176227, 120, '2014-02-01 00:35:27.000000', 'temperatura', 959.0000, 'ºC'),
	(176228, 120, '2014-02-01 00:35:28.000000', 'temperatura', 516.0000, 'ºC'),
	(176229, 120, '2014-02-01 00:35:29.000000', 'temperatura', 904.0000, 'ºC'),
	(176230, 120, '2014-02-01 00:35:30.000000', 'temperatura', 572.0000, 'ºC'),
	(176231, 120, '2014-02-01 00:35:31.000000', 'temperatura', 148.0000, 'ºC'),
	(176232, 120, '2014-02-01 00:35:32.000000', 'temperatura', 224.0000, 'ºC'),
	(176233, 120, '2014-02-01 00:35:33.000000', 'temperatura', 679.0000, 'ºC'),
	(176234, 120, '2014-02-01 00:35:34.000000', 'temperatura', 320.0000, 'ºC'),
	(176235, 120, '2014-02-01 00:35:35.000000', 'temperatura', 766.0000, 'ºC'),
	(176236, 120, '2014-02-01 00:35:36.000000', 'temperatura', 472.0000, 'ºC'),
	(176237, 120, '2014-02-01 00:35:37.000000', 'temperatura', 59.0000, 'ºC'),
	(176238, 120, '2014-02-01 00:35:38.000000', 'temperatura', 83.0000, 'ºC'),
	(176239, 120, '2014-02-01 00:35:39.000000', 'temperatura', 237.0000, 'ºC'),
	(176240, 120, '2014-02-01 00:35:40.000000', 'temperatura', 936.0000, 'ºC'),
	(176241, 120, '2014-02-01 00:35:41.000000', 'temperatura', 370.0000, 'ºC'),
	(176242, 120, '2014-02-01 00:35:42.000000', 'temperatura', 244.0000, 'ºC'),
	(176243, 120, '2014-02-01 00:35:43.000000', 'temperatura', 108.0000, 'ºC'),
	(176244, 120, '2014-02-01 00:35:44.000000', 'temperatura', 1008.0000, 'ºC'),
	(176245, 120, '2014-02-01 00:35:45.000000', 'temperatura', 1116.0000, 'ºC'),
	(176246, 120, '2014-02-01 00:35:46.000000', 'temperatura', 156.0000, 'ºC'),
	(176247, 120, '2014-02-01 00:35:47.000000', 'temperatura', 1034.0000, 'ºC'),
	(176248, 120, '2014-02-01 00:35:48.000000', 'temperatura', 1100.0000, 'ºC'),
	(176249, 120, '2014-02-01 00:35:49.000000', 'temperatura', 1.0000, 'ºC'),
	(176250, 120, '2014-02-01 00:35:50.000000', 'temperatura', 304.0000, 'ºC'),
	(176251, 120, '2014-02-01 00:35:51.000000', 'temperatura', 319.0000, 'ºC'),
	(176252, 120, '2014-02-01 00:35:52.000000', 'temperatura', 681.0000, 'ºC'),
	(176253, 120, '2014-02-01 00:35:53.000000', 'temperatura', 51.0000, 'ºC'),
	(176254, 120, '2014-02-01 00:35:54.000000', 'temperatura', 612.0000, 'ºC'),
	(176255, 120, '2014-02-01 00:35:55.000000', 'temperatura', 507.0000, 'ºC'),
	(176256, 120, '2014-02-01 00:35:56.000000', 'temperatura', 699.0000, 'ºC'),
	(176257, 120, '2014-02-01 00:35:57.000000', 'temperatura', 777.0000, 'ºC'),
	(176258, 120, '2014-02-01 00:35:58.000000', 'temperatura', 587.0000, 'ºC'),
	(176259, 120, '2014-02-01 00:35:59.000000', 'temperatura', 606.0000, 'ºC'),
	(176260, 120, '2014-02-01 00:36:00.000000', 'temperatura', 69.0000, 'ºC'),
	(176261, 120, '2014-02-01 00:36:01.000000', 'temperatura', 925.0000, 'ºC'),
	(176262, 120, '2014-02-01 00:36:02.000000', 'temperatura', 821.0000, 'ºC'),
	(176263, 120, '2014-02-01 00:36:03.000000', 'temperatura', 128.0000, 'ºC'),
	(176264, 120, '2014-02-01 00:36:04.000000', 'temperatura', 579.0000, 'ºC'),
	(176265, 120, '2014-02-01 00:36:05.000000', 'temperatura', 112.0000, 'ºC'),
	(176266, 120, '2014-02-01 00:36:06.000000', 'temperatura', 21.0000, 'ºC'),
	(176267, 120, '2014-02-01 00:36:07.000000', 'temperatura', 972.0000, 'ºC'),
	(176268, 120, '2014-02-01 00:36:08.000000', 'temperatura', 1197.0000, 'ºC'),
	(176269, 120, '2014-02-01 00:36:09.000000', 'temperatura', 671.0000, 'ºC'),
	(176270, 120, '2014-02-01 00:36:10.000000', 'temperatura', 964.0000, 'ºC'),
	(176271, 120, '2014-02-01 00:36:11.000000', 'temperatura', 408.0000, 'ºC'),
	(176272, 120, '2014-02-01 00:36:12.000000', 'temperatura', 349.0000, 'ºC'),
	(176273, 120, '2014-02-01 00:36:13.000000', 'temperatura', 519.0000, 'ºC'),
	(176274, 120, '2014-02-01 00:36:14.000000', 'temperatura', 352.0000, 'ºC'),
	(176275, 120, '2014-02-01 00:36:15.000000', 'temperatura', 201.0000, 'ºC'),
	(176276, 120, '2014-02-01 00:36:16.000000', 'temperatura', 1150.0000, 'ºC'),
	(176277, 120, '2014-02-01 00:36:17.000000', 'temperatura', 348.0000, 'ºC'),
	(176278, 120, '2014-02-01 00:36:18.000000', 'temperatura', 691.0000, 'ºC'),
	(176279, 120, '2014-02-01 00:36:19.000000', 'temperatura', 10.0000, 'ºC'),
	(176280, 120, '2014-02-01 00:36:20.000000', 'temperatura', 378.0000, 'ºC'),
	(176281, 120, '2014-02-01 00:36:21.000000', 'temperatura', 660.0000, 'ºC'),
	(176282, 120, '2014-02-01 00:36:22.000000', 'temperatura', 965.0000, 'ºC'),
	(176283, 120, '2014-02-01 00:36:23.000000', 'temperatura', 447.0000, 'ºC'),
	(176284, 120, '2014-02-01 00:36:24.000000', 'temperatura', 541.0000, 'ºC'),
	(176285, 120, '2014-02-01 00:36:25.000000', 'temperatura', 162.0000, 'ºC'),
	(176286, 120, '2014-02-01 00:36:26.000000', 'temperatura', 390.0000, 'ºC'),
	(176287, 120, '2014-02-01 00:36:27.000000', 'temperatura', 265.0000, 'ºC'),
	(176288, 120, '2014-02-01 00:36:28.000000', 'temperatura', 154.0000, 'ºC'),
	(176289, 120, '2014-02-01 00:36:29.000000', 'temperatura', 1176.0000, 'ºC'),
	(176290, 120, '2014-02-01 00:36:30.000000', 'temperatura', 620.0000, 'ºC'),
	(176291, 120, '2014-02-01 00:36:31.000000', 'temperatura', 772.0000, 'ºC'),
	(176292, 120, '2014-02-01 00:36:32.000000', 'temperatura', 801.0000, 'ºC'),
	(176293, 120, '2014-02-01 00:36:33.000000', 'temperatura', 488.0000, 'ºC'),
	(176294, 120, '2014-02-01 00:36:34.000000', 'temperatura', 39.0000, 'ºC'),
	(176295, 120, '2014-02-01 00:36:35.000000', 'temperatura', 1131.0000, 'ºC'),
	(176296, 120, '2014-02-01 00:36:36.000000', 'temperatura', 739.0000, 'ºC'),
	(176297, 120, '2014-02-01 00:36:37.000000', 'temperatura', 302.0000, 'ºC'),
	(176298, 120, '2014-02-01 00:36:38.000000', 'temperatura', 492.0000, 'ºC'),
	(176299, 120, '2014-02-01 00:36:39.000000', 'temperatura', 357.0000, 'ºC'),
	(176300, 120, '2014-02-01 00:36:40.000000', 'temperatura', 307.0000, 'ºC'),
	(176301, 120, '2014-02-01 00:36:41.000000', 'temperatura', 464.0000, 'ºC'),
	(176302, 120, '2014-02-01 00:36:42.000000', 'temperatura', 200.0000, 'ºC'),
	(176303, 120, '2014-02-01 00:36:43.000000', 'temperatura', 810.0000, 'ºC'),
	(176304, 120, '2014-02-01 00:36:44.000000', 'temperatura', 1048.0000, 'ºC'),
	(176305, 120, '2014-02-01 00:36:45.000000', 'temperatura', 411.0000, 'ºC'),
	(176306, 120, '2014-02-01 00:36:46.000000', 'temperatura', 111.0000, 'ºC'),
	(176307, 120, '2014-02-01 00:36:47.000000', 'temperatura', 523.0000, 'ºC'),
	(176308, 120, '2014-02-01 00:36:48.000000', 'temperatura', 1083.0000, 'ºC'),
	(176309, 120, '2014-02-01 00:36:49.000000', 'temperatura', 245.0000, 'ºC'),
	(176310, 120, '2014-02-01 00:36:50.000000', 'temperatura', 377.0000, 'ºC'),
	(176311, 120, '2014-02-01 00:36:51.000000', 'temperatura', 1152.0000, 'ºC'),
	(176312, 120, '2014-02-01 00:36:52.000000', 'temperatura', 1027.0000, 'ºC'),
	(176313, 120, '2014-02-01 00:36:53.000000', 'temperatura', 479.0000, 'ºC'),
	(176314, 120, '2014-02-01 00:36:54.000000', 'temperatura', 515.0000, 'ºC'),
	(176315, 120, '2014-02-01 00:36:55.000000', 'temperatura', 1139.0000, 'ºC'),
	(176316, 120, '2014-02-01 00:36:56.000000', 'temperatura', 551.0000, 'ºC'),
	(176317, 120, '2014-02-01 00:36:57.000000', 'temperatura', 540.0000, 'ºC'),
	(176318, 120, '2014-02-01 00:36:58.000000', 'temperatura', 1044.0000, 'ºC'),
	(176319, 120, '2014-02-01 00:36:59.000000', 'temperatura', 2.0000, 'ºC'),
	(176320, 120, '2014-02-01 00:37:00.000000', 'temperatura', 480.0000, 'ºC'),
	(176321, 120, '2014-02-01 00:37:01.000000', 'temperatura', 1193.0000, 'ºC'),
	(176322, 120, '2014-02-01 00:37:02.000000', 'temperatura', 926.0000, 'ºC'),
	(176323, 120, '2014-02-01 00:37:03.000000', 'temperatura', 1050.0000, 'ºC'),
	(176324, 120, '2014-02-01 00:37:04.000000', 'temperatura', 71.0000, 'ºC'),
	(176325, 120, '2014-02-01 00:37:05.000000', 'temperatura', 809.0000, 'ºC'),
	(176326, 120, '2014-02-01 00:37:06.000000', 'temperatura', 232.0000, 'ºC'),
	(176327, 120, '2014-02-01 00:37:07.000000', 'temperatura', 1135.0000, 'ºC'),
	(176328, 120, '2014-02-01 00:37:08.000000', 'temperatura', 178.0000, 'ºC'),
	(176329, 120, '2014-02-01 00:37:09.000000', 'temperatura', 1085.0000, 'ºC'),
	(176330, 120, '2014-02-01 00:37:10.000000', 'temperatura', 94.0000, 'ºC'),
	(176331, 120, '2014-02-01 00:37:11.000000', 'temperatura', 814.0000, 'ºC'),
	(176332, 120, '2014-02-01 00:37:12.000000', 'temperatura', 189.0000, 'ºC'),
	(176333, 120, '2014-02-01 00:37:13.000000', 'temperatura', 904.0000, 'ºC'),
	(176334, 120, '2014-02-01 00:37:14.000000', 'temperatura', 352.0000, 'ºC'),
	(176335, 120, '2014-02-01 00:37:15.000000', 'temperatura', 247.0000, 'ºC'),
	(176336, 120, '2014-02-01 00:37:16.000000', 'temperatura', 182.0000, 'ºC'),
	(176337, 120, '2014-02-01 00:37:17.000000', 'temperatura', 170.0000, 'ºC'),
	(176338, 120, '2014-02-01 00:37:18.000000', 'temperatura', 303.0000, 'ºC'),
	(176339, 120, '2014-02-01 00:37:19.000000', 'temperatura', 1004.0000, 'ºC'),
	(176340, 120, '2014-02-01 00:37:20.000000', 'temperatura', 515.0000, 'ºC'),
	(176341, 120, '2014-02-01 00:37:21.000000', 'temperatura', 761.0000, 'ºC'),
	(176342, 120, '2014-02-01 00:37:22.000000', 'temperatura', 1061.0000, 'ºC'),
	(176343, 120, '2014-02-01 00:37:23.000000', 'temperatura', 624.0000, 'ºC'),
	(176344, 120, '2014-02-01 00:37:24.000000', 'temperatura', 1135.0000, 'ºC'),
	(176345, 120, '2014-02-01 00:37:25.000000', 'temperatura', 206.0000, 'ºC'),
	(176346, 120, '2014-02-01 00:37:26.000000', 'temperatura', 24.0000, 'ºC'),
	(176347, 120, '2014-02-01 00:37:27.000000', 'temperatura', 703.0000, 'ºC'),
	(176348, 120, '2014-02-01 00:37:28.000000', 'temperatura', 1044.0000, 'ºC'),
	(176349, 120, '2014-02-01 00:37:29.000000', 'temperatura', 710.0000, 'ºC'),
	(176350, 120, '2014-02-01 00:37:30.000000', 'temperatura', 420.0000, 'ºC'),
	(176351, 120, '2014-02-01 00:37:31.000000', 'temperatura', 1171.0000, 'ºC'),
	(176352, 120, '2014-02-01 00:37:32.000000', 'temperatura', 994.0000, 'ºC'),
	(176353, 120, '2014-02-01 00:37:33.000000', 'temperatura', 259.0000, 'ºC'),
	(176354, 120, '2014-02-01 00:37:34.000000', 'temperatura', 711.0000, 'ºC'),
	(176355, 120, '2014-02-01 00:37:35.000000', 'temperatura', 382.0000, 'ºC'),
	(176356, 120, '2014-02-01 00:37:36.000000', 'temperatura', 974.0000, 'ºC'),
	(176357, 120, '2014-02-01 00:37:37.000000', 'temperatura', 128.0000, 'ºC'),
	(176358, 120, '2014-02-01 00:37:38.000000', 'temperatura', 116.0000, 'ºC'),
	(176359, 120, '2014-02-01 00:37:39.000000', 'temperatura', 197.0000, 'ºC'),
	(176360, 120, '2014-02-01 00:37:40.000000', 'temperatura', 636.0000, 'ºC'),
	(176361, 120, '2014-02-01 00:37:41.000000', 'temperatura', 190.0000, 'ºC'),
	(176362, 120, '2014-02-01 00:37:42.000000', 'temperatura', 244.0000, 'ºC'),
	(176363, 120, '2014-02-01 00:37:43.000000', 'temperatura', 648.0000, 'ºC'),
	(176364, 120, '2014-02-01 00:37:44.000000', 'temperatura', 111.0000, 'ºC'),
	(176365, 120, '2014-02-01 00:37:45.000000', 'temperatura', 1012.0000, 'ºC'),
	(176366, 120, '2014-02-01 00:37:46.000000', 'temperatura', 1128.0000, 'ºC'),
	(176367, 120, '2014-02-01 00:37:47.000000', 'temperatura', 205.0000, 'ºC'),
	(176368, 120, '2014-02-01 00:37:48.000000', 'temperatura', 40.0000, 'ºC'),
	(176369, 120, '2014-02-01 00:37:49.000000', 'temperatura', 788.0000, 'ºC'),
	(176370, 120, '2014-02-01 00:37:50.000000', 'temperatura', 218.0000, 'ºC'),
	(176371, 120, '2014-02-01 00:37:51.000000', 'temperatura', 1126.0000, 'ºC'),
	(176372, 120, '2014-02-01 00:37:52.000000', 'temperatura', 176.0000, 'ºC'),
	(176373, 120, '2014-02-01 00:37:53.000000', 'temperatura', 1102.0000, 'ºC'),
	(176374, 120, '2014-02-01 00:37:54.000000', 'temperatura', 184.0000, 'ºC'),
	(176375, 120, '2014-02-01 00:37:55.000000', 'temperatura', 15.0000, 'ºC'),
	(176376, 120, '2014-02-01 00:37:56.000000', 'temperatura', 721.0000, 'ºC'),
	(176377, 120, '2014-02-01 00:37:57.000000', 'temperatura', 1162.0000, 'ºC'),
	(176378, 120, '2014-02-01 00:37:58.000000', 'temperatura', 46.0000, 'ºC'),
	(176379, 120, '2014-02-01 00:37:59.000000', 'temperatura', 345.0000, 'ºC'),
	(176380, 120, '2014-02-01 00:38:00.000000', 'temperatura', 389.0000, 'ºC'),
	(176381, 120, '2014-02-01 00:38:01.000000', 'temperatura', 911.0000, 'ºC'),
	(176382, 120, '2014-02-01 00:38:02.000000', 'temperatura', 989.0000, 'ºC'),
	(176383, 120, '2014-02-01 00:38:03.000000', 'temperatura', 1010.0000, 'ºC'),
	(176384, 120, '2014-02-01 00:38:04.000000', 'temperatura', 884.0000, 'ºC'),
	(176385, 120, '2014-02-01 00:38:05.000000', 'temperatura', 191.0000, 'ºC'),
	(176386, 120, '2014-02-01 00:38:06.000000', 'temperatura', 702.0000, 'ºC'),
	(176387, 120, '2014-02-01 00:38:07.000000', 'temperatura', 538.0000, 'ºC'),
	(176388, 120, '2014-02-01 00:38:08.000000', 'temperatura', 583.0000, 'ºC'),
	(176389, 120, '2014-02-01 00:38:09.000000', 'temperatura', 104.0000, 'ºC'),
	(176390, 120, '2014-02-01 00:38:10.000000', 'temperatura', 1172.0000, 'ºC'),
	(176391, 120, '2014-02-01 00:38:11.000000', 'temperatura', 750.0000, 'ºC'),
	(176392, 120, '2014-02-01 00:38:12.000000', 'temperatura', 231.0000, 'ºC'),
	(176393, 120, '2014-02-01 00:38:13.000000', 'temperatura', 109.0000, 'ºC'),
	(176394, 120, '2014-02-01 00:38:14.000000', 'temperatura', 1050.0000, 'ºC'),
	(176395, 120, '2014-02-01 00:38:15.000000', 'temperatura', 124.0000, 'ºC'),
	(176396, 120, '2014-02-01 00:38:16.000000', 'temperatura', 1071.0000, 'ºC'),
	(176397, 120, '2014-02-01 00:38:17.000000', 'temperatura', 184.0000, 'ºC'),
	(176398, 120, '2014-02-01 00:38:18.000000', 'temperatura', 106.0000, 'ºC'),
	(176399, 120, '2014-02-01 00:38:19.000000', 'temperatura', 1179.0000, 'ºC'),
	(176400, 120, '2014-02-01 00:38:20.000000', 'temperatura', 778.0000, 'ºC'),
	(176401, 120, '2014-02-01 00:38:21.000000', 'temperatura', 353.0000, 'ºC'),
	(176402, 120, '2014-02-01 00:38:22.000000', 'temperatura', 631.0000, 'ºC'),
	(176403, 120, '2014-02-01 00:38:23.000000', 'temperatura', 897.0000, 'ºC'),
	(176404, 120, '2014-02-01 00:38:24.000000', 'temperatura', 193.0000, 'ºC'),
	(176405, 120, '2014-02-01 00:38:25.000000', 'temperatura', 672.0000, 'ºC'),
	(176406, 120, '2014-02-01 00:38:26.000000', 'temperatura', 385.0000, 'ºC'),
	(176407, 120, '2014-02-01 00:38:27.000000', 'temperatura', 1107.0000, 'ºC'),
	(176408, 120, '2014-02-01 00:38:28.000000', 'temperatura', 780.0000, 'ºC'),
	(176409, 120, '2014-02-01 00:38:29.000000', 'temperatura', 579.0000, 'ºC'),
	(176410, 120, '2014-02-01 00:38:30.000000', 'temperatura', 556.0000, 'ºC'),
	(176411, 120, '2014-02-01 00:38:31.000000', 'temperatura', 1045.0000, 'ºC'),
	(176412, 120, '2014-02-01 00:38:32.000000', 'temperatura', 1156.0000, 'ºC'),
	(176413, 120, '2014-02-01 00:38:33.000000', 'temperatura', 248.0000, 'ºC'),
	(176414, 120, '2014-02-01 00:38:34.000000', 'temperatura', 171.0000, 'ºC'),
	(176415, 120, '2014-02-01 00:38:35.000000', 'temperatura', 109.0000, 'ºC'),
	(176416, 120, '2014-02-01 00:38:36.000000', 'temperatura', 36.0000, 'ºC'),
	(176417, 120, '2014-02-01 00:38:37.000000', 'temperatura', 1054.0000, 'ºC'),
	(176418, 120, '2014-02-01 00:38:38.000000', 'temperatura', 360.0000, 'ºC'),
	(176419, 120, '2014-02-01 00:38:39.000000', 'temperatura', 1041.0000, 'ºC'),
	(176420, 120, '2014-02-01 00:38:40.000000', 'temperatura', 525.0000, 'ºC'),
	(176421, 120, '2014-02-01 00:38:41.000000', 'temperatura', 702.0000, 'ºC'),
	(176422, 120, '2014-02-01 00:38:42.000000', 'temperatura', 735.0000, 'ºC'),
	(176423, 120, '2014-02-01 00:38:43.000000', 'temperatura', 371.0000, 'ºC'),
	(176424, 120, '2014-02-01 00:38:44.000000', 'temperatura', 848.0000, 'ºC'),
	(176425, 120, '2014-02-01 00:38:45.000000', 'temperatura', 727.0000, 'ºC'),
	(176426, 120, '2014-02-01 00:38:46.000000', 'temperatura', 1095.0000, 'ºC'),
	(176427, 120, '2014-02-01 00:38:47.000000', 'temperatura', 892.0000, 'ºC'),
	(176428, 120, '2014-02-01 00:38:48.000000', 'temperatura', 1175.0000, 'ºC'),
	(176429, 120, '2014-02-01 00:38:49.000000', 'temperatura', 802.0000, 'ºC'),
	(176430, 120, '2014-02-01 00:38:50.000000', 'temperatura', 484.0000, 'ºC'),
	(176431, 120, '2014-02-01 00:38:51.000000', 'temperatura', 14.0000, 'ºC'),
	(176432, 120, '2014-02-01 00:38:52.000000', 'temperatura', 1019.0000, 'ºC'),
	(176433, 120, '2014-02-01 00:38:53.000000', 'temperatura', 252.0000, 'ºC'),
	(176434, 120, '2014-02-01 00:38:54.000000', 'temperatura', 603.0000, 'ºC'),
	(176435, 120, '2014-02-01 00:38:55.000000', 'temperatura', 1059.0000, 'ºC'),
	(176436, 120, '2014-02-01 00:38:56.000000', 'temperatura', 1087.0000, 'ºC'),
	(176437, 120, '2014-02-01 00:38:57.000000', 'temperatura', 1060.0000, 'ºC'),
	(176438, 120, '2014-02-01 00:38:58.000000', 'temperatura', 837.0000, 'ºC'),
	(176439, 120, '2014-02-01 00:38:59.000000', 'temperatura', 1007.0000, 'ºC'),
	(176440, 120, '2014-02-01 00:39:00.000000', 'temperatura', 124.0000, 'ºC'),
	(176441, 120, '2014-02-01 00:39:01.000000', 'temperatura', 1199.0000, 'ºC'),
	(176442, 120, '2014-02-01 00:39:02.000000', 'temperatura', 824.0000, 'ºC'),
	(176443, 120, '2014-02-01 00:39:03.000000', 'temperatura', 525.0000, 'ºC'),
	(176444, 120, '2014-02-01 00:39:04.000000', 'temperatura', 152.0000, 'ºC'),
	(176445, 120, '2014-02-01 00:39:05.000000', 'temperatura', 384.0000, 'ºC'),
	(176446, 120, '2014-02-01 00:39:06.000000', 'temperatura', 266.0000, 'ºC'),
	(176447, 120, '2014-02-01 00:39:07.000000', 'temperatura', 180.0000, 'ºC'),
	(176448, 120, '2014-02-01 00:39:08.000000', 'temperatura', 102.0000, 'ºC'),
	(176449, 120, '2014-02-01 00:39:09.000000', 'temperatura', 1171.0000, 'ºC'),
	(176450, 120, '2014-02-01 00:39:10.000000', 'temperatura', 749.0000, 'ºC'),
	(176451, 120, '2014-02-01 00:39:11.000000', 'temperatura', 234.0000, 'ºC'),
	(176452, 120, '2014-02-01 00:39:12.000000', 'temperatura', 123.0000, 'ºC'),
	(176453, 120, '2014-02-01 00:39:13.000000', 'temperatura', 1115.0000, 'ºC'),
	(176454, 120, '2014-02-01 00:39:14.000000', 'temperatura', 405.0000, 'ºC'),
	(176455, 120, '2014-02-01 00:39:15.000000', 'temperatura', 1081.0000, 'ºC'),
	(176456, 120, '2014-02-01 00:39:16.000000', 'temperatura', 589.0000, 'ºC'),
	(176457, 120, '2014-02-01 00:39:17.000000', 'temperatura', 903.0000, 'ºC'),
	(176458, 120, '2014-02-01 00:39:18.000000', 'temperatura', 351.0000, 'ºC'),
	(176459, 120, '2014-02-01 00:39:19.000000', 'temperatura', 244.0000, 'ºC'),
	(176460, 120, '2014-02-01 00:39:20.000000', 'temperatura', 169.0000, 'ºC'),
	(176461, 120, '2014-02-01 00:39:21.000000', 'temperatura', 115.0000, 'ºC'),
	(176462, 120, '2014-02-01 00:39:22.000000', 'temperatura', 67.0000, 'ºC'),
	(176463, 120, '2014-02-01 00:39:23.000000', 'temperatura', 1191.0000, 'ºC'),
	(176464, 120, '2014-02-01 00:39:24.000000', 'temperatura', 954.0000, 'ºC'),
	(176465, 120, '2014-02-01 00:39:25.000000', 'temperatura', 1196.0000, 'ºC'),
	(176466, 120, '2014-02-01 00:39:26.000000', 'temperatura', 720.0000, 'ºC'),
	(176467, 120, '2014-02-01 00:39:27.000000', 'temperatura', 13.0000, 'ºC'),
	(176468, 120, '2014-02-01 00:39:28.000000', 'temperatura', 303.0000, 'ºC'),
	(176469, 120, '2014-02-01 00:39:29.000000', 'temperatura', 278.0000, 'ºC'),
	(176470, 120, '2014-02-01 00:39:30.000000', 'temperatura', 481.0000, 'ºC'),
	(176471, 120, '2014-02-01 00:39:31.000000', 'temperatura', 373.0000, 'ºC'),
	(176472, 120, '2014-02-01 00:39:32.000000', 'temperatura', 420.0000, 'ºC'),
	(176473, 120, '2014-02-01 00:39:33.000000', 'temperatura', 984.0000, 'ºC'),
	(176474, 120, '2014-02-01 00:39:34.000000', 'temperatura', 61.0000, 'ºC'),
	(176475, 120, '2014-02-01 00:39:35.000000', 'temperatura', 951.0000, 'ºC'),
	(176476, 120, '2014-02-01 00:39:36.000000', 'temperatura', 974.0000, 'ºC'),
	(176477, 120, '2014-02-01 00:39:37.000000', 'temperatura', 818.0000, 'ºC'),
	(176478, 120, '2014-02-01 00:39:38.000000', 'temperatura', 1168.0000, 'ºC'),
	(176479, 120, '2014-02-01 00:39:39.000000', 'temperatura', 985.0000, 'ºC'),
	(176480, 120, '2014-02-01 00:39:40.000000', 'temperatura', 223.0000, 'ºC'),
	(176481, 120, '2014-02-01 00:39:41.000000', 'temperatura', 561.0000, 'ºC'),
	(176482, 120, '2014-02-01 00:39:42.000000', 'temperatura', 937.0000, 'ºC'),
	(176483, 120, '2014-02-01 00:39:43.000000', 'temperatura', 604.0000, 'ºC'),
	(176484, 120, '2014-02-01 00:39:44.000000', 'temperatura', 207.0000, 'ºC'),
	(176485, 120, '2014-02-01 00:39:45.000000', 'temperatura', 423.0000, 'ºC'),
	(176486, 120, '2014-02-01 00:39:46.000000', 'temperatura', 297.0000, 'ºC'),
	(176487, 120, '2014-02-01 00:39:47.000000', 'temperatura', 215.0000, 'ºC'),
	(176488, 120, '2014-02-01 00:39:48.000000', 'temperatura', 183.0000, 'ºC'),
	(176489, 120, '2014-02-01 00:39:49.000000', 'temperatura', 272.0000, 'ºC'),
	(176490, 120, '2014-02-01 00:39:50.000000', 'temperatura', 811.0000, 'ºC'),
	(176491, 120, '2014-02-01 00:39:51.000000', 'temperatura', 840.0000, 'ºC'),
	(176492, 120, '2014-02-01 00:39:52.000000', 'temperatura', 567.0000, 'ºC'),
	(176493, 120, '2014-02-01 00:39:53.000000', 'temperatura', 314.0000, 'ºC'),
	(176494, 120, '2014-02-01 00:39:54.000000', 'temperatura', 1069.0000, 'ºC'),
	(176495, 120, '2014-02-01 00:39:55.000000', 'temperatura', 804.0000, 'ºC'),
	(176496, 120, '2014-02-01 00:39:56.000000', 'temperatura', 814.0000, 'ºC'),
	(176497, 120, '2014-02-01 00:39:57.000000', 'temperatura', 459.0000, 'ºC'),
	(176498, 120, '2014-02-01 00:39:58.000000', 'temperatura', 1055.0000, 'ºC'),
	(176499, 120, '2014-02-01 00:39:59.000000', 'temperatura', 295.0000, 'ºC'),
	(176500, 120, '2014-02-01 00:40:00.000000', 'temperatura', 713.0000, 'ºC'),
	(176501, 120, '2014-02-01 00:40:01.000000', 'temperatura', 281.0000, 'ºC'),
	(176502, 120, '2014-02-01 00:40:02.000000', 'temperatura', 468.0000, 'ºC'),
	(176503, 120, '2014-02-01 00:40:03.000000', 'temperatura', 294.0000, 'ºC'),
	(176504, 120, '2014-02-01 00:40:04.000000', 'temperatura', 67.0000, 'ºC'),
	(176505, 120, '2014-02-01 00:40:05.000000', 'temperatura', 655.0000, 'ºC'),
	(176506, 120, '2014-02-01 00:40:06.000000', 'temperatura', 672.0000, 'ºC'),
	(176507, 120, '2014-02-01 00:40:07.000000', 'temperatura', 197.0000, 'ºC'),
	(176508, 120, '2014-02-01 00:40:08.000000', 'temperatura', 171.0000, 'ºC'),
	(176509, 120, '2014-02-01 00:40:09.000000', 'temperatura', 264.0000, 'ºC'),
	(176510, 120, '2014-02-01 00:40:10.000000', 'temperatura', 809.0000, 'ºC'),
	(176511, 120, '2014-02-01 00:40:11.000000', 'temperatura', 851.0000, 'ºC'),
	(176512, 120, '2014-02-01 00:40:12.000000', 'temperatura', 630.0000, 'ºC'),
	(176513, 120, '2014-02-01 00:40:13.000000', 'temperatura', 596.0000, 'ºC'),
	(176514, 120, '2014-02-01 00:40:14.000000', 'temperatura', 1090.0000, 'ºC'),
	(176515, 120, '2014-02-01 00:40:15.000000', 'temperatura', 62.0000, 'ºC'),
	(176516, 120, '2014-02-01 00:40:16.000000', 'temperatura', 640.0000, 'ºC'),
	(176517, 120, '2014-02-01 00:40:17.000000', 'temperatura', 615.0000, 'ºC'),
	(176518, 120, '2014-02-01 00:40:18.000000', 'temperatura', 1156.0000, 'ºC'),
	(176519, 120, '2014-02-01 00:40:19.000000', 'temperatura', 337.0000, 'ºC'),
	(176520, 120, '2014-02-01 00:40:20.000000', 'temperatura', 616.0000, 'ºC'),
	(176521, 120, '2014-02-01 00:40:21.000000', 'temperatura', 870.0000, 'ºC'),
	(176522, 120, '2014-02-01 00:40:22.000000', 'temperatura', 104.0000, 'ºC'),
	(176523, 120, '2014-02-01 00:40:23.000000', 'temperatura', 310.0000, 'ºC'),
	(176524, 120, '2014-02-01 00:40:24.000000', 'temperatura', 39.0000, 'ºC'),
	(176525, 120, '2014-02-01 00:40:25.000000', 'temperatura', 465.0000, 'ºC'),
	(176526, 120, '2014-02-01 00:40:26.000000', 'temperatura', 1007.0000, 'ºC'),
	(176527, 120, '2014-02-01 00:40:27.000000', 'temperatura', 41.0000, 'ºC'),
	(176528, 120, '2014-02-01 00:40:28.000000', 'temperatura', 786.0000, 'ºC'),
	(176529, 120, '2014-02-01 00:40:29.000000', 'temperatura', 205.0000, 'ºC'),
	(176530, 120, '2014-02-01 00:40:30.000000', 'temperatura', 1069.0000, 'ºC'),
	(176531, 120, '2014-02-01 00:40:31.000000', 'temperatura', 1131.0000, 'ºC'),
	(176532, 120, '2014-02-01 00:40:32.000000', 'temperatura', 48.0000, 'ºC'),
	(176533, 120, '2014-02-01 00:40:33.000000', 'temperatura', 447.0000, 'ºC'),
	(176534, 120, '2014-02-01 00:40:34.000000', 'temperatura', 892.0000, 'ºC'),
	(176535, 120, '2014-02-01 00:40:35.000000', 'temperatura', 720.0000, 'ºC'),
	(176536, 120, '2014-02-01 00:40:36.000000', 'temperatura', 925.0000, 'ºC'),
	(176537, 120, '2014-02-01 00:40:37.000000', 'temperatura', 66.0000, 'ºC'),
	(176538, 120, '2014-02-01 00:40:38.000000', 'temperatura', 1157.0000, 'ºC'),
	(176539, 120, '2014-02-01 00:40:39.000000', 'temperatura', 784.0000, 'ºC'),
	(176540, 120, '2014-02-01 00:40:40.000000', 'temperatura', 451.0000, 'ºC'),
	(176541, 120, '2014-02-01 00:40:41.000000', 'temperatura', 1104.0000, 'ºC'),
	(176542, 120, '2014-02-01 00:40:42.000000', 'temperatura', 567.0000, 'ºC'),
	(176543, 120, '2014-02-01 00:40:43.000000', 'temperatura', 724.0000, 'ºC'),
	(176544, 120, '2014-02-01 00:40:44.000000', 'temperatura', 720.0000, 'ºC'),
	(176545, 120, '2014-02-01 00:40:45.000000', 'temperatura', 228.0000, 'ºC'),
	(176546, 120, '2014-02-01 00:40:46.000000', 'temperatura', 179.0000, 'ºC'),
	(176547, 120, '2014-02-01 00:40:47.000000', 'temperatura', 210.0000, 'ºC'),
	(176548, 120, '2014-02-01 00:40:48.000000', 'temperatura', 517.0000, 'ºC'),
	(176549, 120, '2014-02-01 00:40:49.000000', 'temperatura', 755.0000, 'ºC'),
	(176550, 120, '2014-02-01 00:40:50.000000', 'temperatura', 1025.0000, 'ºC'),
	(176551, 120, '2014-02-01 00:40:51.000000', 'temperatura', 461.0000, 'ºC'),
	(176552, 120, '2014-02-01 00:40:52.000000', 'temperatura', 432.0000, 'ºC'),
	(176553, 120, '2014-02-01 00:40:53.000000', 'temperatura', 774.0000, 'ºC'),
	(176554, 120, '2014-02-01 00:40:54.000000', 'temperatura', 176.0000, 'ºC'),
	(176555, 120, '2014-02-01 00:40:55.000000', 'temperatura', 959.0000, 'ºC'),
	(176556, 120, '2014-02-01 00:40:56.000000', 'temperatura', 667.0000, 'ºC'),
	(176557, 120, '2014-02-01 00:40:57.000000', 'temperatura', 457.0000, 'ºC'),
	(176558, 120, '2014-02-01 00:40:58.000000', 'temperatura', 287.0000, 'ºC'),
	(176559, 120, '2014-02-01 00:40:59.000000', 'temperatura', 65.0000, 'ºC'),
	(176560, 120, '2014-02-01 00:41:00.000000', 'temperatura', 665.0000, 'ºC'),
	(176561, 120, '2014-02-01 00:41:01.000000', 'temperatura', 729.0000, 'ºC'),
	(176562, 120, '2014-02-01 00:41:02.000000', 'temperatura', 453.0000, 'ºC'),
	(176563, 120, '2014-02-01 00:41:03.000000', 'temperatura', 75.0000, 'ºC'),
	(176564, 120, '2014-02-01 00:41:04.000000', 'temperatura', 219.0000, 'ºC'),
	(176565, 120, '2014-02-01 00:41:05.000000', 'temperatura', 868.0000, 'ºC'),
	(176566, 120, '2014-02-01 00:41:06.000000', 'temperatura', 85.0000, 'ºC'),
	(176567, 120, '2014-02-01 00:41:07.000000', 'temperatura', 220.0000, 'ºC'),
	(176568, 120, '2014-02-01 00:41:08.000000', 'temperatura', 847.0000, 'ºC'),
	(176569, 120, '2014-02-01 00:41:09.000000', 'temperatura', 1175.0000, 'ºC'),
	(176570, 120, '2014-02-01 00:41:10.000000', 'temperatura', 936.0000, 'ºC'),
	(176571, 120, '2014-02-01 00:41:11.000000', 'temperatura', 1153.0000, 'ºC'),
	(176572, 120, '2014-02-01 00:41:12.000000', 'temperatura', 559.0000, 'ºC'),
	(176573, 120, '2014-02-01 00:41:13.000000', 'temperatura', 534.0000, 'ºC'),
	(176574, 120, '2014-02-01 00:41:14.000000', 'temperatura', 995.0000, 'ºC'),
	(176575, 120, '2014-02-01 00:41:15.000000', 'temperatura', 974.0000, 'ºC'),
	(176576, 120, '2014-02-01 00:41:16.000000', 'temperatura', 686.0000, 'ºC'),
	(176577, 120, '2014-02-01 00:41:17.000000', 'temperatura', 508.0000, 'ºC'),
	(176578, 120, '2014-02-01 00:41:18.000000', 'temperatura', 484.0000, 'ºC'),
	(176579, 120, '2014-02-01 00:41:19.000000', 'temperatura', 894.0000, 'ºC'),
	(176580, 120, '2014-02-01 00:41:20.000000', 'temperatura', 620.0000, 'ºC'),
	(176581, 120, '2014-02-01 00:41:21.000000', 'temperatura', 417.0000, 'ºC'),
	(176582, 120, '2014-02-01 00:41:22.000000', 'temperatura', 227.0000, 'ºC'),
	(176583, 120, '2014-02-01 00:41:23.000000', 'temperatura', 1084.0000, 'ºC'),
	(176584, 120, '2014-02-01 00:41:24.000000', 'temperatura', 1139.0000, 'ºC'),
	(176585, 120, '2014-02-01 00:41:25.000000', 'temperatura', 46.0000, 'ºC'),
	(176586, 120, '2014-02-01 00:41:26.000000', 'temperatura', 411.0000, 'ºC'),
	(176587, 120, '2014-02-01 00:41:27.000000', 'temperatura', 719.0000, 'ºC'),
	(176588, 120, '2014-02-01 00:41:28.000000', 'temperatura', 1160.0000, 'ºC'),
	(176589, 120, '2014-02-01 00:41:29.000000', 'temperatura', 45.0000, 'ºC'),
	(176590, 120, '2014-02-01 00:41:30.000000', 'temperatura', 346.0000, 'ºC'),
	(176591, 120, '2014-02-01 00:41:31.000000', 'temperatura', 396.0000, 'ºC'),
	(176592, 120, '2014-02-01 00:41:32.000000', 'temperatura', 943.0000, 'ºC'),
	(176593, 120, '2014-02-01 00:41:33.000000', 'temperatura', 1128.0000, 'ºC'),
	(176594, 120, '2014-02-01 00:41:34.000000', 'temperatura', 410.0000, 'ºC'),
	(176595, 120, '2014-02-01 00:41:35.000000', 'temperatura', 1066.0000, 'ºC'),
	(176596, 120, '2014-02-01 00:41:36.000000', 'temperatura', 499.0000, 'ºC'),
	(176597, 120, '2014-02-01 00:41:37.000000', 'temperatura', 500.0000, 'ºC'),
	(176598, 120, '2014-02-01 00:41:38.000000', 'temperatura', 1002.0000, 'ºC'),
	(176599, 120, '2014-02-01 00:41:39.000000', 'temperatura', 1113.0000, 'ºC'),
	(176600, 120, '2014-02-01 00:41:40.000000', 'temperatura', 157.0000, 'ºC'),
	(176601, 120, '2014-02-01 00:41:41.000000', 'temperatura', 1048.0000, 'ºC'),
	(176602, 120, '2014-02-01 00:41:42.000000', 'temperatura', 1168.0000, 'ºC'),
	(176603, 120, '2014-02-01 00:41:43.000000', 'temperatura', 299.0000, 'ºC'),
	(176604, 120, '2014-02-01 00:41:44.000000', 'temperatura', 390.0000, 'ºC'),
	(176605, 120, '2014-02-01 00:41:45.000000', 'temperatura', 1055.0000, 'ºC'),
	(176606, 120, '2014-02-01 00:41:46.000000', 'temperatura', 505.0000, 'ºC'),
	(176607, 120, '2014-02-01 00:41:47.000000', 'temperatura', 560.0000, 'ºC'),
	(176608, 120, '2014-02-01 00:41:48.000000', 'temperatura', 87.0000, 'ºC'),
	(176609, 120, '2014-02-01 00:41:49.000000', 'temperatura', 1156.0000, 'ºC'),
	(176610, 120, '2014-02-01 00:41:50.000000', 'temperatura', 719.0000, 'ºC'),
	(176611, 120, '2014-02-01 00:41:51.000000', 'temperatura', 126.0000, 'ºC'),
	(176612, 120, '2014-02-01 00:41:52.000000', 'temperatura', 874.0000, 'ºC'),
	(176613, 120, '2014-02-01 00:41:53.000000', 'temperatura', 393.0000, 'ºC'),
	(176614, 120, '2014-02-01 00:41:54.000000', 'temperatura', 543.0000, 'ºC'),
	(176615, 120, '2014-02-01 00:41:55.000000', 'temperatura', 337.0000, 'ºC'),
	(176616, 120, '2014-02-01 00:41:56.000000', 'temperatura', 54.0000, 'ºC'),
	(176617, 120, '2014-02-01 00:41:57.000000', 'temperatura', 462.0000, 'ºC'),
	(176618, 120, '2014-02-01 00:41:58.000000', 'temperatura', 949.0000, 'ºC'),
	(176619, 120, '2014-02-01 00:41:59.000000', 'temperatura', 959.0000, 'ºC'),
	(176620, 120, '2014-02-01 00:42:00.000000', 'temperatura', 750.0000, 'ºC'),
	(176621, 120, '2014-02-01 00:42:01.000000', 'temperatura', 871.0000, 'ºC'),
	(176622, 120, '2014-02-01 00:42:02.000000', 'temperatura', 905.0000, 'ºC'),
	(176623, 120, '2014-02-01 00:42:03.000000', 'temperatura', 715.0000, 'ºC'),
	(176624, 120, '2014-02-01 00:42:04.000000', 'temperatura', 860.0000, 'ºC'),
	(176625, 120, '2014-02-01 00:42:05.000000', 'temperatura', 955.0000, 'ºC'),
	(176626, 120, '2014-02-01 00:42:06.000000', 'temperatura', 997.0000, 'ºC'),
	(176627, 120, '2014-02-01 00:42:07.000000', 'temperatura', 921.0000, 'ºC'),
	(176628, 120, '2014-02-01 00:42:08.000000', 'temperatura', 413.0000, 'ºC'),
	(176629, 120, '2014-02-01 00:42:09.000000', 'temperatura', 505.0000, 'ºC'),
	(176630, 120, '2014-02-01 00:42:10.000000', 'temperatura', 85.0000, 'ºC'),
	(176631, 120, '2014-02-01 00:42:11.000000', 'temperatura', 109.0000, 'ºC'),
	(176632, 120, '2014-02-01 00:42:12.000000', 'temperatura', 292.0000, 'ºC'),
	(176633, 120, '2014-02-01 00:42:13.000000', 'temperatura', 1133.0000, 'ºC'),
	(176634, 120, '2014-02-01 00:42:14.000000', 'temperatura', 1188.0000, 'ºC'),
	(176635, 120, '2014-02-01 00:42:15.000000', 'temperatura', 143.0000, 'ºC'),
	(176636, 120, '2014-02-01 00:42:16.000000', 'temperatura', 752.0000, 'ºC'),
	(176637, 120, '2014-02-01 00:42:17.000000', 'temperatura', 930.0000, 'ºC'),
	(176638, 120, '2014-02-01 00:42:18.000000', 'temperatura', 1194.0000, 'ºC'),
	(176639, 120, '2014-02-01 00:42:19.000000', 'temperatura', 783.0000, 'ºC'),
	(176640, 120, '2014-02-01 00:42:20.000000', 'temperatura', 333.0000, 'ºC'),
	(176641, 120, '2014-02-01 00:42:21.000000', 'temperatura', 516.0000, 'ºC'),
	(176642, 120, '2014-02-01 00:42:22.000000', 'temperatura', 383.0000, 'ºC'),
	(176643, 120, '2014-02-01 00:42:23.000000', 'temperatura', 367.0000, 'ºC'),
	(176644, 120, '2014-02-01 00:42:24.000000', 'temperatura', 688.0000, 'ºC'),
	(176645, 120, '2014-02-01 00:42:25.000000', 'temperatura', 1138.0000, 'ºC'),
	(176646, 120, '2014-02-01 00:42:26.000000', 'temperatura', 28.0000, 'ºC'),
	(176647, 120, '2014-02-01 00:42:27.000000', 'temperatura', 326.0000, 'ºC'),
	(176648, 120, '2014-02-01 00:42:28.000000', 'temperatura', 344.0000, 'ºC'),
	(176649, 120, '2014-02-01 00:42:29.000000', 'temperatura', 746.0000, 'ºC'),
	(176650, 120, '2014-02-01 00:42:30.000000', 'temperatura', 295.0000, 'ºC'),
	(176651, 120, '2014-02-01 00:42:31.000000', 'temperatura', 440.0000, 'ºC'),
	(176652, 120, '2014-02-01 00:42:32.000000', 'temperatura', 114.0000, 'ºC'),
	(176653, 120, '2014-02-01 00:42:33.000000', 'temperatura', 449.0000, 'ºC'),
	(176654, 120, '2014-02-01 00:42:34.000000', 'temperatura', 706.0000, 'ºC'),
	(176655, 120, '2014-02-01 00:42:35.000000', 'temperatura', 983.0000, 'ºC'),
	(176656, 120, '2014-02-01 00:42:36.000000', 'temperatura', 398.0000, 'ºC'),
	(176657, 120, '2014-02-01 00:42:37.000000', 'temperatura', 243.0000, 'ºC'),
	(176658, 120, '2014-02-01 00:42:38.000000', 'temperatura', 18.0000, 'ºC'),
	(176659, 120, '2014-02-01 00:42:39.000000', 'temperatura', 565.0000, 'ºC'),
	(176660, 120, '2014-02-01 00:42:40.000000', 'temperatura', 368.0000, 'ºC'),
	(176661, 120, '2014-02-01 00:42:41.000000', 'temperatura', 147.0000, 'ºC'),
	(176662, 120, '2014-02-01 00:42:42.000000', 'temperatura', 830.0000, 'ºC'),
	(176663, 120, '2014-02-01 00:42:43.000000', 'temperatura', 112.0000, 'ºC'),
	(176664, 120, '2014-02-01 00:42:44.000000', 'temperatura', 471.0000, 'ºC'),
	(176665, 120, '2014-02-01 00:42:45.000000', 'temperatura', 818.0000, 'ºC'),
	(176666, 120, '2014-02-01 00:42:46.000000', 'temperatura', 276.0000, 'ºC'),
	(176667, 120, '2014-02-01 00:42:47.000000', 'temperatura', 129.0000, 'ºC'),
	(176668, 120, '2014-02-01 00:42:48.000000', 'temperatura', 1017.0000, 'ºC'),
	(176669, 120, '2014-02-01 00:42:49.000000', 'temperatura', 1099.0000, 'ºC'),
	(176670, 120, '2014-02-01 00:42:50.000000', 'temperatura', 43.0000, 'ºC'),
	(176671, 120, '2014-02-01 00:42:51.000000', 'temperatura', 518.0000, 'ºC'),
	(176672, 120, '2014-02-01 00:42:52.000000', 'temperatura', 61.0000, 'ºC'),
	(176673, 120, '2014-02-01 00:42:53.000000', 'temperatura', 1154.0000, 'ºC'),
	(176674, 120, '2014-02-01 00:42:54.000000', 'temperatura', 785.0000, 'ºC'),
	(176675, 120, '2014-02-01 00:42:55.000000', 'temperatura', 463.0000, 'ºC'),
	(176676, 120, '2014-02-01 00:42:56.000000', 'temperatura', 1163.0000, 'ºC'),
	(176677, 120, '2014-02-01 00:42:57.000000', 'temperatura', 824.0000, 'ºC'),
	(176678, 120, '2014-02-01 00:42:58.000000', 'temperatura', 633.0000, 'ºC'),
	(176679, 120, '2014-02-01 00:42:59.000000', 'temperatura', 695.0000, 'ºC'),
	(176680, 120, '2014-02-01 00:43:00.000000', 'temperatura', 376.0000, 'ºC'),
	(176681, 120, '2014-02-01 00:43:01.000000', 'temperatura', 996.0000, 'ºC'),
	(176682, 120, '2014-02-01 00:43:02.000000', 'temperatura', 250.0000, 'ºC'),
	(176683, 120, '2014-02-01 00:43:03.000000', 'temperatura', 664.0000, 'ºC'),
	(176684, 120, '2014-02-01 00:43:04.000000', 'temperatura', 170.0000, 'ºC'),
	(176685, 120, '2014-02-01 00:43:05.000000', 'temperatura', 60.0000, 'ºC'),
	(176686, 120, '2014-02-01 00:43:06.000000', 'temperatura', 990.0000, 'ºC'),
	(176687, 120, '2014-02-01 00:43:07.000000', 'temperatura', 1172.0000, 'ºC'),
	(176688, 120, '2014-02-01 00:43:08.000000', 'temperatura', 489.0000, 'ºC'),
	(176689, 120, '2014-02-01 00:43:09.000000', 'temperatura', 131.0000, 'ºC'),
	(176690, 120, '2014-02-01 00:43:10.000000', 'temperatura', 387.0000, 'ºC'),
	(176691, 120, '2014-02-01 00:43:11.000000', 'temperatura', 342.0000, 'ºC'),
	(176692, 120, '2014-02-01 00:43:12.000000', 'temperatura', 548.0000, 'ºC'),
	(176693, 120, '2014-02-01 00:43:13.000000', 'temperatura', 518.0000, 'ºC'),
	(176694, 120, '2014-02-01 00:43:14.000000', 'temperatura', 944.0000, 'ºC'),
	(176695, 120, '2014-02-01 00:43:15.000000', 'temperatura', 766.0000, 'ºC'),
	(176696, 120, '2014-02-01 00:43:16.000000', 'temperatura', 1000.0000, 'ºC'),
	(176697, 120, '2014-02-01 00:43:17.000000', 'temperatura', 302.0000, 'ºC'),
	(176698, 120, '2014-02-01 00:43:18.000000', 'temperatura', 909.0000, 'ºC'),
	(176699, 120, '2014-02-01 00:43:19.000000', 'temperatura', 42.0000, 'ºC'),
	(176700, 120, '2014-02-01 00:43:20.000000', 'temperatura', 1082.0000, 'ºC'),
	(176701, 120, '2014-02-01 00:43:21.000000', 'temperatura', 485.0000, 'ºC'),
	(176702, 120, '2014-02-01 00:43:22.000000', 'temperatura', 381.0000, 'ºC'),
	(176703, 120, '2014-02-01 00:43:23.000000', 'temperatura', 448.0000, 'ºC'),
	(176704, 120, '2014-02-01 00:43:24.000000', 'temperatura', 1097.0000, 'ºC'),
	(176705, 120, '2014-02-01 00:43:25.000000', 'temperatura', 544.0000, 'ºC'),
	(176706, 120, '2014-02-01 00:43:26.000000', 'temperatura', 630.0000, 'ºC'),
	(176707, 120, '2014-02-01 00:43:27.000000', 'temperatura', 319.0000, 'ºC'),
	(176708, 120, '2014-02-01 00:43:28.000000', 'temperatura', 906.0000, 'ºC'),
	(176709, 120, '2014-02-01 00:43:29.000000', 'temperatura', 1172.0000, 'ºC'),
	(176710, 120, '2014-02-01 00:43:30.000000', 'temperatura', 744.0000, 'ºC'),
	(176711, 120, '2014-02-01 00:43:31.000000', 'temperatura', 204.0000, 'ºC'),
	(176712, 120, '2014-02-01 00:43:32.000000', 'temperatura', 1190.0000, 'ºC'),
	(176713, 120, '2014-02-01 00:43:33.000000', 'temperatura', 536.0000, 'ºC'),
	(176714, 120, '2014-02-01 00:43:34.000000', 'temperatura', 310.0000, 'ºC'),
	(176715, 120, '2014-02-01 00:43:35.000000', 'temperatura', 1144.0000, 'ºC'),
	(176716, 120, '2014-02-01 00:43:36.000000', 'temperatura', 1190.0000, 'ºC'),
	(176717, 120, '2014-02-01 00:43:37.000000', 'temperatura', 117.0000, 'ºC'),
	(176718, 120, '2014-02-01 00:43:38.000000', 'temperatura', 616.0000, 'ºC'),
	(176719, 120, '2014-02-01 00:43:39.000000', 'temperatura', 331.0000, 'ºC'),
	(176720, 120, '2014-02-01 00:43:40.000000', 'temperatura', 1006.0000, 'ºC'),
	(176721, 120, '2014-02-01 00:43:41.000000', 'temperatura', 440.0000, 'ºC'),
	(176722, 120, '2014-02-01 00:43:42.000000', 'temperatura', 379.0000, 'ºC'),
	(176723, 120, '2014-02-01 00:43:43.000000', 'temperatura', 578.0000, 'ºC'),
	(176724, 120, '2014-02-01 00:43:44.000000', 'temperatura', 553.0000, 'ºC'),
	(176725, 120, '2014-02-01 00:43:45.000000', 'temperatura', 1032.0000, 'ºC'),
	(176726, 120, '2014-02-01 00:43:46.000000', 'temperatura', 1099.0000, 'ºC'),
	(176727, 120, '2014-02-01 00:43:47.000000', 'temperatura', 1.0000, 'ºC'),
	(176728, 120, '2014-02-01 00:43:48.000000', 'temperatura', 310.0000, 'ºC'),
	(176729, 120, '2014-02-01 00:43:49.000000', 'temperatura', 344.0000, 'ºC'),
	(176730, 120, '2014-02-01 00:43:50.000000', 'temperatura', 794.0000, 'ºC'),
	(176731, 120, '2014-02-01 00:43:51.000000', 'temperatura', 536.0000, 'ºC'),
	(176732, 120, '2014-02-01 00:43:52.000000', 'temperatura', 298.0000, 'ºC'),
	(176733, 120, '2014-02-01 00:43:53.000000', 'temperatura', 1082.0000, 'ºC'),
	(176734, 120, '2014-02-01 00:43:54.000000', 'temperatura', 916.0000, 'ºC'),
	(176735, 120, '2014-02-01 00:43:55.000000', 'temperatura', 137.0000, 'ºC'),
	(176736, 120, '2014-02-01 00:43:56.000000', 'temperatura', 338.0000, 'ºC'),
	(176737, 120, '2014-02-01 00:43:57.000000', 'temperatura', 77.0000, 'ºC'),
	(176738, 120, '2014-02-01 00:43:58.000000', 'temperatura', 571.0000, 'ºC'),
	(176739, 120, '2014-02-01 00:43:59.000000', 'temperatura', 224.0000, 'ºC'),
	(176740, 120, '2014-02-01 00:44:00.000000', 'temperatura', 607.0000, 'ºC'),
	(176741, 120, '2014-02-01 00:44:01.000000', 'temperatura', 1164.0000, 'ºC'),
	(176742, 120, '2014-02-01 00:44:02.000000', 'temperatura', 401.0000, 'ºC'),
	(176743, 120, '2014-02-01 00:44:03.000000', 'temperatura', 915.0000, 'ºC'),
	(176744, 120, '2014-02-01 00:44:04.000000', 'temperatura', 969.0000, 'ºC'),
	(176745, 120, '2014-02-01 00:44:05.000000', 'temperatura', 904.0000, 'ºC'),
	(176746, 120, '2014-02-01 00:44:06.000000', 'temperatura', 411.0000, 'ºC'),
	(176747, 120, '2014-02-01 00:44:07.000000', 'temperatura', 543.0000, 'ºC'),
	(176748, 120, '2014-02-01 00:44:08.000000', 'temperatura', 283.0000, 'ºC'),
	(176749, 120, '2014-02-01 00:44:09.000000', 'temperatura', 986.0000, 'ºC'),
	(176750, 120, '2014-02-01 00:44:10.000000', 'temperatura', 482.0000, 'ºC'),
	(176751, 120, '2014-02-01 00:44:11.000000', 'temperatura', 655.0000, 'ºC'),
	(176752, 120, '2014-02-01 00:44:12.000000', 'temperatura', 626.0000, 'ºC'),
	(176753, 120, '2014-02-01 00:44:13.000000', 'temperatura', 1165.0000, 'ºC'),
	(176754, 120, '2014-02-01 00:44:14.000000', 'temperatura', 350.0000, 'ºC'),
	(176755, 120, '2014-02-01 00:44:15.000000', 'temperatura', 654.0000, 'ºC'),
	(176756, 120, '2014-02-01 00:44:16.000000', 'temperatura', 1022.0000, 'ºC'),
	(176757, 120, '2014-02-01 00:44:17.000000', 'temperatura', 747.0000, 'ºC'),
	(176758, 120, '2014-02-01 00:44:18.000000', 'temperatura', 668.0000, 'ºC'),
	(176759, 120, '2014-02-01 00:44:19.000000', 'temperatura', 1102.0000, 'ºC'),
	(176760, 120, '2014-02-01 00:44:20.000000', 'temperatura', 1104.0000, 'ºC'),
	(176761, 120, '2014-02-01 00:44:21.000000', 'temperatura', 1017.0000, 'ºC'),
	(176762, 120, '2014-02-01 00:44:22.000000', 'temperatura', 571.0000, 'ºC'),
	(176763, 120, '2014-02-01 00:44:23.000000', 'temperatura', 1006.0000, 'ºC'),
	(176764, 120, '2014-02-01 00:44:24.000000', 'temperatura', 919.0000, 'ºC'),
	(176765, 120, '2014-02-01 00:44:25.000000', 'temperatura', 375.0000, 'ºC'),
	(176766, 120, '2014-02-01 00:44:26.000000', 'temperatura', 321.0000, 'ºC'),
	(176767, 120, '2014-02-01 00:44:27.000000', 'temperatura', 480.0000, 'ºC'),
	(176768, 120, '2014-02-01 00:44:28.000000', 'temperatura', 237.0000, 'ºC'),
	(176769, 120, '2014-02-01 00:44:29.000000', 'temperatura', 945.0000, 'ºC'),
	(176770, 120, '2014-02-01 00:44:30.000000', 'temperatura', 413.0000, 'ºC'),
	(176771, 120, '2014-02-01 00:44:31.000000', 'temperatura', 432.0000, 'ºC'),
	(176772, 120, '2014-02-01 00:44:32.000000', 'temperatura', 923.0000, 'ºC'),
	(176773, 120, '2014-02-01 00:44:33.000000', 'temperatura', 918.0000, 'ºC'),
	(176774, 120, '2014-02-01 00:44:34.000000', 'temperatura', 624.0000, 'ºC'),
	(176775, 120, '2014-02-01 00:44:35.000000', 'temperatura', 364.0000, 'ºC'),
	(176776, 120, '2014-02-01 00:44:36.000000', 'temperatura', 1147.0000, 'ºC'),
	(176777, 120, '2014-02-01 00:44:37.000000', 'temperatura', 1047.0000, 'ºC'),
	(176778, 120, '2014-02-01 00:44:38.000000', 'temperatura', 592.0000, 'ºC'),
	(176779, 120, '2014-02-01 00:44:39.000000', 'temperatura', 1021.0000, 'ºC'),
	(176780, 120, '2014-02-01 00:44:40.000000', 'temperatura', 928.0000, 'ºC'),
	(176781, 120, '2014-02-01 00:44:41.000000', 'temperatura', 378.0000, 'ºC'),
	(176782, 120, '2014-02-01 00:44:42.000000', 'temperatura', 306.0000, 'ºC'),
	(176783, 120, '2014-02-01 00:44:43.000000', 'temperatura', 397.0000, 'ºC'),
	(176784, 120, '2014-02-01 00:44:44.000000', 'temperatura', 1069.0000, 'ºC'),
	(176785, 120, '2014-02-01 00:44:45.000000', 'temperatura', 552.0000, 'ºC'),
	(176786, 120, '2014-02-01 00:44:46.000000', 'temperatura', 753.0000, 'ºC'),
	(176787, 120, '2014-02-01 00:44:47.000000', 'temperatura', 911.0000, 'ºC'),
	(176788, 120, '2014-02-01 00:44:48.000000', 'temperatura', 1098.0000, 'ºC'),
	(176789, 120, '2014-02-01 00:44:49.000000', 'temperatura', 357.0000, 'ºC'),
	(176790, 120, '2014-02-01 00:44:50.000000', 'temperatura', 892.0000, 'ºC'),
	(176791, 120, '2014-02-01 00:44:51.000000', 'temperatura', 987.0000, 'ºC'),
	(176792, 120, '2014-02-01 00:44:52.000000', 'temperatura', 1060.0000, 'ºC'),
	(176793, 120, '2014-02-01 00:44:53.000000', 'temperatura', 1140.0000, 'ºC'),
	(176794, 120, '2014-02-01 00:44:54.000000', 'temperatura', 120.0000, 'ºC'),
	(176795, 120, '2014-02-01 00:44:55.000000', 'temperatura', 780.0000, 'ºC'),
	(176796, 120, '2014-02-01 00:44:56.000000', 'temperatura', 1139.0000, 'ºC'),
	(176797, 120, '2014-02-01 00:44:57.000000', 'temperatura', 959.0000, 'ºC'),
	(176798, 120, '2014-02-01 00:44:58.000000', 'temperatura', 177.0000, 'ºC'),
	(176799, 120, '2014-02-01 00:44:59.000000', 'temperatura', 408.0000, 'ºC'),
	(176800, 120, '2014-02-01 00:45:00.000000', 'temperatura', 308.0000, 'ºC'),
	(176801, 120, '2014-02-01 00:45:01.000000', 'temperatura', 320.0000, 'ºC'),
	(176802, 120, '2014-02-01 00:45:02.000000', 'temperatura', 674.0000, 'ºC'),
	(176803, 120, '2014-02-01 00:45:03.000000', 'temperatura', 10.0000, 'ºC'),
	(176804, 120, '2014-02-01 00:45:04.000000', 'temperatura', 428.0000, 'ºC'),
	(176805, 120, '2014-02-01 00:45:05.000000', 'temperatura', 912.0000, 'ºC'),
	(176806, 120, '2014-02-01 00:45:06.000000', 'temperatura', 877.0000, 'ºC'),
	(176807, 120, '2014-02-01 00:45:07.000000', 'temperatura', 450.0000, 'ºC'),
	(176808, 120, '2014-02-01 00:45:08.000000', 'temperatura', 820.0000, 'ºC'),
	(176809, 120, '2014-02-01 00:45:09.000000', 'temperatura', 350.0000, 'ºC'),
	(176810, 120, '2014-02-01 00:45:10.000000', 'temperatura', 490.0000, 'ºC'),
	(176811, 120, '2014-02-01 00:45:11.000000', 'temperatura', 202.0000, 'ºC'),
	(176812, 120, '2014-02-01 00:45:12.000000', 'temperatura', 741.0000, 'ºC'),
	(176813, 120, '2014-02-01 00:45:13.000000', 'temperatura', 699.0000, 'ºC'),
	(176814, 120, '2014-02-01 00:45:14.000000', 'temperatura', 72.0000, 'ºC'),
	(176815, 120, '2014-02-01 00:45:15.000000', 'temperatura', 663.0000, 'ºC'),
	(176816, 120, '2014-02-01 00:45:16.000000', 'temperatura', 699.0000, 'ºC'),
	(176817, 120, '2014-02-01 00:45:17.000000', 'temperatura', 309.0000, 'ºC'),
	(176818, 120, '2014-02-01 00:45:18.000000', 'temperatura', 648.0000, 'ºC'),
	(176819, 120, '2014-02-01 00:45:19.000000', 'temperatura', 1114.0000, 'ºC'),
	(176820, 120, '2014-02-01 00:45:20.000000', 'temperatura', 28.0000, 'ºC'),
	(176821, 120, '2014-02-01 00:45:21.000000', 'temperatura', 396.0000, 'ºC'),
	(176822, 120, '2014-02-01 00:45:22.000000', 'temperatura', 695.0000, 'ºC'),
	(176823, 120, '2014-02-01 00:45:23.000000', 'temperatura', 1089.0000, 'ºC'),
	(176824, 120, '2014-02-01 00:45:24.000000', 'temperatura', 962.0000, 'ºC'),
	(176825, 120, '2014-02-01 00:45:25.000000', 'temperatura', 343.0000, 'ºC'),
	(176826, 120, '2014-02-01 00:45:26.000000', 'temperatura', 31.0000, 'ºC'),
	(176827, 120, '2014-02-01 00:45:27.000000', 'temperatura', 325.0000, 'ºC'),
	(176828, 120, '2014-02-01 00:45:28.000000', 'temperatura', 333.0000, 'ºC'),
	(176829, 120, '2014-02-01 00:45:29.000000', 'temperatura', 689.0000, 'ºC'),
	(176830, 120, '2014-02-01 00:45:30.000000', 'temperatura', 47.0000, 'ºC'),
	(176831, 120, '2014-02-01 00:45:31.000000', 'temperatura', 568.0000, 'ºC'),
	(176832, 120, '2014-02-01 00:45:32.000000', 'temperatura', 299.0000, 'ºC'),
	(176833, 120, '2014-02-01 00:45:33.000000', 'temperatura', 994.0000, 'ºC'),
	(176834, 120, '2014-02-01 00:45:34.000000', 'temperatura', 471.0000, 'ºC'),
	(176835, 120, '2014-02-01 00:45:35.000000', 'temperatura', 574.0000, 'ºC'),
	(176836, 120, '2014-02-01 00:45:36.000000', 'temperatura', 259.0000, 'ºC'),
	(176837, 120, '2014-02-01 00:45:37.000000', 'temperatura', 774.0000, 'ºC'),
	(176838, 120, '2014-02-01 00:45:38.000000', 'temperatura', 692.0000, 'ºC'),
	(176839, 120, '2014-02-01 00:45:39.000000', 'temperatura', 1138.0000, 'ºC'),
	(176840, 120, '2014-02-01 00:45:40.000000', 'temperatura', 17.0000, 'ºC'),
	(176841, 120, '2014-02-01 00:45:41.000000', 'temperatura', 269.0000, 'ºC'),
	(176842, 120, '2014-02-01 00:45:42.000000', 'temperatura', 94.0000, 'ºC'),
	(176843, 120, '2014-02-01 00:45:43.000000', 'temperatura', 862.0000, 'ºC'),
	(176844, 120, '2014-02-01 00:45:44.000000', 'temperatura', 432.0000, 'ºC'),
	(176845, 120, '2014-02-01 00:45:45.000000', 'temperatura', 774.0000, 'ºC'),
	(176846, 120, '2014-02-01 00:45:46.000000', 'temperatura', 172.0000, 'ºC'),
	(176847, 120, '2014-02-01 00:45:47.000000', 'temperatura', 941.0000, 'ºC'),
	(176848, 120, '2014-02-01 00:45:48.000000', 'temperatura', 590.0000, 'ºC'),
	(176849, 120, '2014-02-01 00:45:49.000000', 'temperatura', 128.0000, 'ºC'),
	(176850, 120, '2014-02-01 00:45:50.000000', 'temperatura', 70.0000, 'ºC'),
	(176851, 120, '2014-02-01 00:45:51.000000', 'temperatura', 1168.0000, 'ºC'),
	(176852, 120, '2014-02-01 00:45:52.000000', 'temperatura', 827.0000, 'ºC'),
	(176853, 120, '2014-02-01 00:45:53.000000', 'temperatura', 635.0000, 'ºC'),
	(176854, 120, '2014-02-01 00:45:54.000000', 'temperatura', 691.0000, 'ºC'),
	(176855, 120, '2014-02-01 00:45:55.000000', 'temperatura', 354.0000, 'ºC'),
	(176856, 120, '2014-02-01 00:45:56.000000', 'temperatura', 895.0000, 'ºC'),
	(176857, 120, '2014-02-01 00:45:57.000000', 'temperatura', 1012.0000, 'ºC'),
	(176858, 120, '2014-02-01 00:45:58.000000', 'temperatura', 1178.0000, 'ºC'),
	(176859, 120, '2014-02-01 00:45:59.000000', 'temperatura', 455.0000, 'ºC'),
	(176860, 120, '2014-02-01 00:46:00.000000', 'temperatura', 1140.0000, 'ºC'),
	(176861, 120, '2014-02-01 00:46:01.000000', 'temperatura', 737.0000, 'ºC'),
	(176862, 120, '2014-02-01 00:46:02.000000', 'temperatura', 264.0000, 'ºC'),
	(176863, 120, '2014-02-01 00:46:03.000000', 'temperatura', 310.0000, 'ºC'),
	(176864, 120, '2014-02-01 00:46:04.000000', 'temperatura', 760.0000, 'ºC'),
	(176865, 120, '2014-02-01 00:46:05.000000', 'temperatura', 470.0000, 'ºC'),
	(176866, 120, '2014-02-01 00:46:06.000000', 'temperatura', 68.0000, 'ºC'),
	(176867, 120, '2014-02-01 00:46:07.000000', 'temperatura', 132.0000, 'ºC'),
	(176868, 120, '2014-02-01 00:46:08.000000', 'temperatura', 458.0000, 'ºC'),
	(176869, 120, '2014-02-01 00:46:09.000000', 'temperatura', 693.0000, 'ºC'),
	(176870, 120, '2014-02-01 00:46:10.000000', 'temperatura', 891.0000, 'ºC'),
	(176871, 120, '2014-02-01 00:46:11.000000', 'temperatura', 1177.0000, 'ºC'),
	(176872, 120, '2014-02-01 00:46:12.000000', 'temperatura', 814.0000, 'ºC'),
	(176873, 120, '2014-02-01 00:46:13.000000', 'temperatura', 538.0000, 'ºC'),
	(176874, 120, '2014-02-01 00:46:14.000000', 'temperatura', 250.0000, 'ºC'),
	(176875, 120, '2014-02-01 00:46:15.000000', 'temperatura', 834.0000, 'ºC'),
	(176876, 120, '2014-02-01 00:46:16.000000', 'temperatura', 1020.0000, 'ºC'),
	(176877, 120, '2014-02-01 00:46:17.000000', 'temperatura', 202.0000, 'ºC'),
	(176878, 120, '2014-02-01 00:46:18.000000', 'temperatura', 347.0000, 'ºC'),
	(176879, 120, '2014-02-01 00:46:19.000000', 'temperatura', 1130.0000, 'ºC'),
	(176880, 120, '2014-02-01 00:46:20.000000', 'temperatura', 1011.0000, 'ºC'),
	(176881, 120, '2014-02-01 00:46:21.000000', 'temperatura', 463.0000, 'ºC'),
	(176882, 120, '2014-02-01 00:46:22.000000', 'temperatura', 484.0000, 'ºC'),
	(176883, 120, '2014-02-01 00:46:23.000000', 'temperatura', 1030.0000, 'ºC'),
	(176884, 120, '2014-02-01 00:46:24.000000', 'temperatura', 98.0000, 'ºC'),
	(176885, 120, '2014-02-01 00:46:25.000000', 'temperatura', 1002.0000, 'ºC'),
	(176886, 120, '2014-02-01 00:46:26.000000', 'temperatura', 1117.0000, 'ºC'),
	(176887, 120, '2014-02-01 00:46:27.000000', 'temperatura', 177.0000, 'ºC'),
	(176888, 120, '2014-02-01 00:46:28.000000', 'temperatura', 1138.0000, 'ºC'),
	(176889, 120, '2014-02-01 00:46:29.000000', 'temperatura', 358.0000, 'ºC'),
	(176890, 120, '2014-02-01 00:46:30.000000', 'temperatura', 776.0000, 'ºC'),
	(176891, 120, '2014-02-01 00:46:31.000000', 'temperatura', 406.0000, 'ºC'),
	(176892, 120, '2014-02-01 00:46:32.000000', 'temperatura', 901.0000, 'ºC'),
	(176893, 120, '2014-02-01 00:46:33.000000', 'temperatura', 890.0000, 'ºC'),
	(176894, 120, '2014-02-01 00:46:34.000000', 'temperatura', 546.0000, 'ºC'),
	(176895, 120, '2014-02-01 00:46:35.000000', 'temperatura', 62.0000, 'ºC'),
	(176896, 120, '2014-02-01 00:46:36.000000', 'temperatura', 1070.0000, 'ºC'),
	(176897, 120, '2014-02-01 00:46:37.000000', 'temperatura', 364.0000, 'ºC'),
	(176898, 120, '2014-02-01 00:46:38.000000', 'temperatura', 1014.0000, 'ºC'),
	(176899, 120, '2014-02-01 00:46:39.000000', 'temperatura', 375.0000, 'ºC'),
	(176900, 120, '2014-02-01 00:46:40.000000', 'temperatura', 35.0000, 'ºC'),
	(176901, 120, '2014-02-01 00:46:41.000000', 'temperatura', 252.0000, 'ºC'),
	(176902, 120, '2014-02-01 00:46:42.000000', 'temperatura', 1154.0000, 'ºC'),
	(176903, 120, '2014-02-01 00:46:43.000000', 'temperatura', 216.0000, 'ºC'),
	(176904, 120, '2014-02-01 00:46:44.000000', 'temperatura', 16.0000, 'ºC'),
	(176905, 120, '2014-02-01 00:46:45.000000', 'temperatura', 636.0000, 'ºC'),
	(176906, 120, '2014-02-01 00:46:46.000000', 'temperatura', 729.0000, 'ºC'),
	(176907, 120, '2014-02-01 00:46:47.000000', 'temperatura', 541.0000, 'ºC'),
	(176908, 120, '2014-02-01 00:46:48.000000', 'temperatura', 516.0000, 'ºC'),
	(176909, 120, '2014-02-01 00:46:49.000000', 'temperatura', 958.0000, 'ºC'),
	(176910, 120, '2014-02-01 00:46:50.000000', 'temperatura', 844.0000, 'ºC'),
	(176911, 120, '2014-02-01 00:46:51.000000', 'temperatura', 146.0000, 'ºC'),
	(176912, 120, '2014-02-01 00:46:52.000000', 'temperatura', 600.0000, 'ºC'),
	(176913, 120, '2014-02-01 00:46:53.000000', 'temperatura', 161.0000, 'ºC'),
	(176914, 120, '2014-02-01 00:46:54.000000', 'temperatura', 204.0000, 'ºC'),
	(176915, 120, '2014-02-01 00:46:55.000000', 'temperatura', 537.0000, 'ºC'),
	(176916, 120, '2014-02-01 00:46:56.000000', 'temperatura', 874.0000, 'ºC'),
	(176917, 120, '2014-02-01 00:46:57.000000', 'temperatura', 362.0000, 'ºC'),
	(176918, 120, '2014-02-01 00:46:58.000000', 'temperatura', 386.0000, 'ºC'),
	(176919, 120, '2014-02-01 00:46:59.000000', 'temperatura', 847.0000, 'ºC'),
	(176920, 120, '2014-02-01 00:47:00.000000', 'temperatura', 676.0000, 'ºC'),
	(176921, 120, '2014-02-01 00:47:01.000000', 'temperatura', 841.0000, 'ºC'),
	(176922, 120, '2014-02-01 00:47:02.000000', 'temperatura', 976.0000, 'ºC'),
	(176923, 120, '2014-02-01 00:47:03.000000', 'temperatura', 1159.0000, 'ºC'),
	(176924, 120, '2014-02-01 00:47:04.000000', 'temperatura', 468.0000, 'ºC'),
	(176925, 120, '2014-02-01 00:47:05.000000', 'temperatura', 63.0000, 'ºC'),
	(176926, 120, '2014-02-01 00:47:06.000000', 'temperatura', 111.0000, 'ºC'),
	(176927, 120, '2014-02-01 00:47:07.000000', 'temperatura', 367.0000, 'ºC'),
	(176928, 120, '2014-02-01 00:47:08.000000', 'temperatura', 302.0000, 'ºC'),
	(176929, 120, '2014-02-01 00:47:09.000000', 'temperatura', 409.0000, 'ºC'),
	(176930, 120, '2014-02-01 00:47:10.000000', 'temperatura', 1139.0000, 'ºC'),
	(176931, 120, '2014-02-01 00:47:11.000000', 'temperatura', 869.0000, 'ºC'),
	(176932, 120, '2014-02-01 00:47:12.000000', 'temperatura', 930.0000, 'ºC'),
	(176933, 120, '2014-02-01 00:47:13.000000', 'temperatura', 842.0000, 'ºC'),
	(176934, 120, '2014-02-01 00:47:14.000000', 'temperatura', 222.0000, 'ºC'),
	(176935, 120, '2014-02-01 00:47:15.000000', 'temperatura', 984.0000, 'ºC'),
	(176936, 120, '2014-02-01 00:47:16.000000', 'temperatura', 654.0000, 'ºC'),
	(176937, 120, '2014-02-01 00:47:17.000000', 'temperatura', 318.0000, 'ºC'),
	(176938, 120, '2014-02-01 00:47:18.000000', 'temperatura', 829.0000, 'ºC'),
	(176939, 120, '2014-02-01 00:47:19.000000', 'temperatura', 791.0000, 'ºC'),
	(176940, 120, '2014-02-01 00:47:20.000000', 'temperatura', 271.0000, 'ºC'),
	(176941, 120, '2014-02-01 00:47:21.000000', 'temperatura', 181.0000, 'ºC'),
	(176942, 120, '2014-02-01 00:47:22.000000', 'temperatura', 92.0000, 'ºC'),
	(176943, 120, '2014-02-01 00:47:23.000000', 'temperatura', 1119.0000, 'ºC'),
	(176944, 120, '2014-02-01 00:47:24.000000', 'temperatura', 517.0000, 'ºC'),
	(176945, 120, '2014-02-01 00:47:25.000000', 'temperatura', 432.0000, 'ºC'),
	(176946, 120, '2014-02-01 00:47:26.000000', 'temperatura', 606.0000, 'ºC'),
	(176947, 120, '2014-02-01 00:47:27.000000', 'temperatura', 535.0000, 'ºC'),
	(176948, 120, '2014-02-01 00:47:28.000000', 'temperatura', 857.0000, 'ºC'),
	(176949, 120, '2014-02-01 00:47:29.000000', 'temperatura', 280.0000, 'ºC'),
	(176950, 120, '2014-02-01 00:47:30.000000', 'temperatura', 32.0000, 'ºC'),
	(176951, 120, '2014-02-01 00:47:31.000000', 'temperatura', 519.0000, 'ºC'),
	(176952, 120, '2014-02-01 00:47:32.000000', 'temperatura', 98.0000, 'ºC'),
	(176953, 120, '2014-02-01 00:47:33.000000', 'temperatura', 134.0000, 'ºC'),
	(176954, 120, '2014-02-01 00:47:34.000000', 'temperatura', 377.0000, 'ºC'),
	(176955, 120, '2014-02-01 00:47:35.000000', 'temperatura', 285.0000, 'ºC'),
	(176956, 120, '2014-02-01 00:47:36.000000', 'temperatura', 292.0000, 'ºC'),
	(176957, 120, '2014-02-01 00:47:37.000000', 'temperatura', 606.0000, 'ºC'),
	(176958, 120, '2014-02-01 00:47:38.000000', 'temperatura', 953.0000, 'ºC'),
	(176959, 120, '2014-02-01 00:47:39.000000', 'temperatura', 548.0000, 'ºC'),
	(176960, 120, '2014-02-01 00:47:40.000000', 'temperatura', 1080.0000, 'ºC'),
	(176961, 120, '2014-02-01 00:47:41.000000', 'temperatura', 159.0000, 'ºC'),
	(176962, 120, '2014-02-01 00:47:42.000000', 'temperatura', 1153.0000, 'ºC'),
	(176963, 120, '2014-02-01 00:47:43.000000', 'temperatura', 489.0000, 'ºC'),
	(176964, 120, '2014-02-01 00:47:44.000000', 'temperatura', 188.0000, 'ºC'),
	(176965, 120, '2014-02-01 00:47:45.000000', 'temperatura', 672.0000, 'ºC'),
	(176966, 120, '2014-02-01 00:47:46.000000', 'temperatura', 395.0000, 'ºC'),
	(176967, 120, '2014-02-01 00:47:47.000000', 'temperatura', 1162.0000, 'ºC'),
	(176968, 120, '2014-02-01 00:47:48.000000', 'temperatura', 1024.0000, 'ºC'),
	(176969, 120, '2014-02-01 00:47:49.000000', 'temperatura', 435.0000, 'ºC'),
	(176970, 120, '2014-02-01 00:47:50.000000', 'temperatura', 305.0000, 'ºC'),
	(176971, 120, '2014-02-01 00:47:51.000000', 'temperatura', 218.0000, 'ºC'),
	(176972, 120, '2014-02-01 00:47:52.000000', 'temperatura', 176.0000, 'ºC'),
	(176973, 120, '2014-02-01 00:47:53.000000', 'temperatura', 229.0000, 'ºC'),
	(176974, 120, '2014-02-01 00:47:54.000000', 'temperatura', 615.0000, 'ºC'),
	(176975, 120, '2014-02-01 00:47:55.000000', 'temperatura', 1190.0000, 'ºC'),
	(176976, 120, '2014-02-01 00:47:56.000000', 'temperatura', 506.0000, 'ºC'),
	(176977, 120, '2014-02-01 00:47:57.000000', 'temperatura', 159.0000, 'ºC'),
	(176978, 120, '2014-02-01 00:47:58.000000', 'temperatura', 480.0000, 'ºC'),
	(176979, 120, '2014-02-01 00:47:59.000000', 'temperatura', 723.0000, 'ºC'),
	(176980, 120, '2014-02-01 00:48:00.000000', 'temperatura', 973.0000, 'ºC'),
	(176981, 120, '2014-02-01 00:48:01.000000', 'temperatura', 300.0000, 'ºC'),
	(176982, 120, '2014-02-01 00:48:02.000000', 'temperatura', 979.0000, 'ºC'),
	(176983, 120, '2014-02-01 00:48:03.000000', 'temperatura', 397.0000, 'ºC'),
	(176984, 120, '2014-02-01 00:48:04.000000', 'temperatura', 248.0000, 'ºC'),
	(176985, 120, '2014-02-01 00:48:05.000000', 'temperatura', 47.0000, 'ºC'),
	(176986, 120, '2014-02-01 00:48:06.000000', 'temperatura', 695.0000, 'ºC'),
	(176987, 120, '2014-02-01 00:48:07.000000', 'temperatura', 934.0000, 'ºC'),
	(176988, 120, '2014-02-01 00:48:08.000000', 'temperatura', 186.0000, 'ºC'),
	(176989, 120, '2014-02-01 00:48:09.000000', 'temperatura', 526.0000, 'ºC'),
	(176990, 120, '2014-02-01 00:48:10.000000', 'temperatura', 873.0000, 'ºC'),
	(176991, 120, '2014-02-01 00:48:11.000000', 'temperatura', 390.0000, 'ºC'),
	(176992, 120, '2014-02-01 00:48:12.000000', 'temperatura', 530.0000, 'ºC'),
	(176993, 120, '2014-02-01 00:48:13.000000', 'temperatura', 281.0000, 'ºC'),
	(176994, 120, '2014-02-01 00:48:14.000000', 'temperatura', 1017.0000, 'ºC'),
	(176995, 120, '2014-02-01 00:48:15.000000', 'temperatura', 642.0000, 'ºC'),
	(176996, 120, '2014-02-01 00:48:16.000000', 'temperatura', 159.0000, 'ºC'),
	(176997, 120, '2014-02-01 00:48:17.000000', 'temperatura', 68.0000, 'ºC'),
	(176998, 120, '2014-02-01 00:48:18.000000', 'temperatura', 1065.0000, 'ºC'),
	(176999, 120, '2014-02-01 00:48:19.000000', 'temperatura', 320.0000, 'ºC'),
	(177000, 120, '2014-02-01 00:48:20.000000', 'temperatura', 808.0000, 'ºC'),
	(177001, 120, '2014-02-01 00:48:21.000000', 'temperatura', 679.0000, 'ºC'),
	(177002, 120, '2014-02-01 00:48:22.000000', 'temperatura', 970.0000, 'ºC'),
	(177003, 120, '2014-02-01 00:48:23.000000', 'temperatura', 416.0000, 'ºC'),
	(177004, 120, '2014-02-01 00:48:24.000000', 'temperatura', 368.0000, 'ºC'),
	(177005, 120, '2014-02-01 00:48:25.000000', 'temperatura', 593.0000, 'ºC'),
	(177006, 120, '2014-02-01 00:48:26.000000', 'temperatura', 660.0000, 'ºC'),
	(177007, 120, '2014-02-01 00:48:27.000000', 'temperatura', 324.0000, 'ºC'),
	(177008, 120, '2014-02-01 00:48:28.000000', 'temperatura', 841.0000, 'ºC'),
	(177009, 120, '2014-02-01 00:48:29.000000', 'temperatura', 832.0000, 'ºC'),
	(177010, 120, '2014-02-01 00:48:30.000000', 'temperatura', 436.0000, 'ºC'),
	(177011, 120, '2014-02-01 00:48:31.000000', 'temperatura', 888.0000, 'ºC'),
	(177012, 120, '2014-02-01 00:48:32.000000', 'temperatura', 729.0000, 'ºC'),
	(177013, 120, '2014-02-01 00:48:33.000000', 'temperatura', 983.0000, 'ºC'),
	(177014, 120, '2014-02-01 00:48:34.000000', 'temperatura', 330.0000, 'ºC'),
	(177015, 120, '2014-02-01 00:48:35.000000', 'temperatura', 1099.0000, 'ºC'),
	(177016, 120, '2014-02-01 00:48:36.000000', 'temperatura', 906.0000, 'ºC'),
	(177017, 120, '2014-02-01 00:48:37.000000', 'temperatura', 33.0000, 'ºC'),
	(177018, 120, '2014-02-01 00:48:38.000000', 'temperatura', 1046.0000, 'ºC'),
	(177019, 120, '2014-02-01 00:48:39.000000', 'temperatura', 334.0000, 'ºC'),
	(177020, 120, '2014-02-01 00:48:40.000000', 'temperatura', 931.0000, 'ºC'),
	(177021, 120, '2014-02-01 00:48:41.000000', 'temperatura', 54.0000, 'ºC'),
	(177022, 120, '2014-02-01 00:48:42.000000', 'temperatura', 1077.0000, 'ºC'),
	(177023, 120, '2014-02-01 00:48:43.000000', 'temperatura', 425.0000, 'ºC'),
	(177024, 120, '2014-02-01 00:48:44.000000', 'temperatura', 93.0000, 'ºC'),
	(177025, 120, '2014-02-01 00:48:45.000000', 'temperatura', 389.0000, 'ºC'),
	(177026, 120, '2014-02-01 00:48:46.000000', 'temperatura', 470.0000, 'ºC'),
	(177027, 120, '2014-02-01 00:48:47.000000', 'temperatura', 1182.0000, 'ºC'),
	(177028, 120, '2014-02-01 00:48:48.000000', 'temperatura', 901.0000, 'ºC'),
	(177029, 120, '2014-02-01 00:48:49.000000', 'temperatura', 958.0000, 'ºC'),
	(177030, 120, '2014-02-01 00:48:50.000000', 'temperatura', 887.0000, 'ºC'),
	(177031, 120, '2014-02-01 00:48:51.000000', 'temperatura', 362.0000, 'ºC'),
	(177032, 120, '2014-02-01 00:48:52.000000', 'temperatura', 352.0000, 'ºC'),
	(177033, 120, '2014-02-01 00:48:53.000000', 'temperatura', 671.0000, 'ºC'),
	(177034, 120, '2014-02-01 00:48:54.000000', 'temperatura', 1102.0000, 'ºC'),
	(177035, 120, '2014-02-01 00:48:55.000000', 'temperatura', 1096.0000, 'ºC'),
	(177036, 120, '2014-02-01 00:48:56.000000', 'temperatura', 976.0000, 'ºC'),
	(177037, 120, '2014-02-01 00:48:57.000000', 'temperatura', 390.0000, 'ºC'),
	(177038, 120, '2014-02-01 00:48:58.000000', 'temperatura', 224.0000, 'ºC'),
	(177039, 120, '2014-02-01 00:48:59.000000', 'temperatura', 1151.0000, 'ºC'),
	(177040, 120, '2014-02-01 00:49:00.000000', 'temperatura', 285.0000, 'ºC'),
	(177041, 120, '2014-02-01 00:49:01.000000', 'temperatura', 372.0000, 'ºC'),
	(177042, 120, '2014-02-01 00:49:02.000000', 'temperatura', 1004.0000, 'ºC'),
	(177043, 120, '2014-02-01 00:49:03.000000', 'temperatura', 306.0000, 'ºC'),
	(177044, 120, '2014-02-01 00:49:04.000000', 'temperatura', 917.0000, 'ºC'),
	(177045, 120, '2014-02-01 00:49:05.000000', 'temperatura', 66.0000, 'ºC'),
	(177046, 120, '2014-02-01 00:49:06.000000', 'temperatura', 1183.0000, 'ºC'),
	(177047, 120, '2014-02-01 00:49:07.000000', 'temperatura', 916.0000, 'ºC'),
	(177048, 120, '2014-02-01 00:49:08.000000', 'temperatura', 1034.0000, 'ºC'),
	(177049, 120, '2014-02-01 00:49:09.000000', 'temperatura', 19.0000, 'ºC'),
	(177050, 120, '2014-02-01 00:49:10.000000', 'temperatura', 596.0000, 'ºC'),
	(177051, 120, '2014-02-01 00:49:11.000000', 'temperatura', 524.0000, 'ºC'),
	(177052, 120, '2014-02-01 00:49:12.000000', 'temperatura', 832.0000, 'ºC'),
	(177053, 120, '2014-02-01 00:49:13.000000', 'temperatura', 190.0000, 'ºC'),
	(177054, 120, '2014-02-01 00:49:14.000000', 'temperatura', 852.0000, 'ºC'),
	(177055, 120, '2014-02-01 00:49:15.000000', 'temperatura', 92.0000, 'ºC'),
	(177056, 120, '2014-02-01 00:49:16.000000', 'temperatura', 302.0000, 'ºC'),
	(177057, 120, '2014-02-01 00:49:17.000000', 'temperatura', 37.0000, 'ºC'),
	(177058, 120, '2014-02-01 00:49:18.000000', 'temperatura', 480.0000, 'ºC'),
	(177059, 120, '2014-02-01 00:49:19.000000', 'temperatura', 1090.0000, 'ºC'),
	(177060, 120, '2014-02-01 00:49:20.000000', 'temperatura', 408.0000, 'ºC'),
	(177061, 120, '2014-02-01 00:49:21.000000', 'temperatura', 1171.0000, 'ºC'),
	(177062, 120, '2014-02-01 00:49:22.000000', 'temperatura', 1031.0000, 'ºC'),
	(177063, 120, '2014-02-01 00:49:23.000000', 'temperatura', 443.0000, 'ºC'),
	(177064, 120, '2014-02-01 00:49:24.000000', 'temperatura', 323.0000, 'ºC'),
	(177065, 120, '2014-02-01 00:49:25.000000', 'temperatura', 286.0000, 'ºC'),
	(177066, 120, '2014-02-01 00:49:26.000000', 'temperatura', 461.0000, 'ºC'),
	(177067, 120, '2014-02-01 00:49:27.000000', 'temperatura', 248.0000, 'ºC'),
	(177068, 120, '2014-02-01 00:49:28.000000', 'temperatura', 1059.0000, 'ºC'),
	(177069, 120, '2014-02-01 00:49:29.000000', 'temperatura', 949.0000, 'ºC'),
	(177070, 120, '2014-02-01 00:49:30.000000', 'temperatura', 370.0000, 'ºC'),
	(177071, 120, '2014-02-01 00:49:31.000000', 'temperatura', 204.0000, 'ºC'),
	(177072, 120, '2014-02-01 00:49:32.000000', 'temperatura', 1111.0000, 'ºC'),
	(177073, 120, '2014-02-01 00:49:33.000000', 'temperatura', 144.0000, 'ºC'),
	(177074, 120, '2014-02-01 00:49:34.000000', 'temperatura', 988.0000, 'ºC'),
	(177075, 120, '2014-02-01 00:49:35.000000', 'temperatura', 906.0000, 'ºC'),
	(177076, 120, '2014-02-01 00:49:36.000000', 'temperatura', 369.0000, 'ºC'),
	(177077, 120, '2014-02-01 00:49:37.000000', 'temperatura', 327.0000, 'ºC'),
	(177078, 120, '2014-02-01 00:49:38.000000', 'temperatura', 527.0000, 'ºC'),
	(177079, 120, '2014-02-01 00:49:39.000000', 'temperatura', 456.0000, 'ºC'),
	(177080, 120, '2014-02-01 00:49:40.000000', 'temperatura', 698.0000, 'ºC'),
	(177081, 120, '2014-02-01 00:49:41.000000', 'temperatura', 925.0000, 'ºC'),
	(177082, 120, '2014-02-01 00:49:42.000000', 'temperatura', 128.0000, 'ºC'),
	(177083, 120, '2014-02-01 00:49:43.000000', 'temperatura', 268.0000, 'ºC'),
	(177084, 120, '2014-02-01 00:49:44.000000', 'temperatura', 957.0000, 'ºC'),
	(177085, 120, '2014-02-01 00:49:45.000000', 'temperatura', 382.0000, 'ºC'),
	(177086, 120, '2014-02-01 00:49:46.000000', 'temperatura', 240.0000, 'ºC'),
	(177087, 120, '2014-02-01 00:49:47.000000', 'temperatura', 52.0000, 'ºC'),
	(177088, 120, '2014-02-01 00:49:48.000000', 'temperatura', 742.0000, 'ºC'),
	(177089, 120, '2014-02-01 00:49:49.000000', 'temperatura', 1155.0000, 'ºC'),
	(177090, 120, '2014-02-01 00:49:50.000000', 'temperatura', 1149.0000, 'ºC'),
	(177091, 120, '2014-02-01 00:49:51.000000', 'temperatura', 1080.0000, 'ºC'),
	(177092, 120, '2014-02-01 00:49:52.000000', 'temperatura', 752.0000, 'ºC'),
	(177093, 120, '2014-02-01 00:49:53.000000', 'temperatura', 522.0000, 'ºC'),
	(177094, 120, '2014-02-01 00:49:54.000000', 'temperatura', 356.0000, 'ºC'),
	(177095, 120, '2014-02-01 00:49:55.000000', 'temperatura', 213.0000, 'ºC'),
	(177096, 120, '2014-02-01 00:49:56.000000', 'temperatura', 1199.0000, 'ºC'),
	(177097, 120, '2014-02-01 00:49:57.000000', 'temperatura', 556.0000, 'ºC'),
	(177098, 120, '2014-02-01 00:49:58.000000', 'temperatura', 385.0000, 'ºC'),
	(177099, 120, '2014-02-01 00:49:59.000000', 'temperatura', 255.0000, 'ºC'),
	(177100, 120, '2014-02-01 00:50:00.000000', 'temperatura', 120.0000, 'ºC'),
	(177101, 120, '2014-02-01 00:50:01.000000', 'temperatura', 1038.0000, 'ºC'),
	(177102, 120, '2014-02-01 00:50:02.000000', 'temperatura', 30.0000, 'ºC'),
	(177103, 120, '2014-02-01 00:50:03.000000', 'temperatura', 638.0000, 'ºC'),
	(177104, 120, '2014-02-01 00:50:04.000000', 'temperatura', 700.0000, 'ºC'),
	(177105, 120, '2014-02-01 00:50:05.000000', 'temperatura', 385.0000, 'ºC'),
	(177106, 120, '2014-02-01 00:50:06.000000', 'temperatura', 1026.0000, 'ºC'),
	(177107, 120, '2014-02-01 00:50:07.000000', 'temperatura', 376.0000, 'ºC'),
	(177108, 120, '2014-02-01 00:50:08.000000', 'temperatura', 0.0000, 'ºC'),
	(177109, 120, '2014-02-01 00:50:09.000000', 'temperatura', 75.0000, 'ºC'),
	(177110, 120, '2014-02-01 00:50:10.000000', 'temperatura', 373.0000, 'ºC'),
	(177111, 120, '2014-02-01 00:50:11.000000', 'temperatura', 442.0000, 'ºC'),
	(177112, 120, '2014-02-01 00:50:12.000000', 'temperatura', 1091.0000, 'ºC'),
	(177113, 120, '2014-02-01 00:50:13.000000', 'temperatura', 532.0000, 'ºC'),
	(177114, 120, '2014-02-01 00:50:14.000000', 'temperatura', 584.0000, 'ºC'),
	(177115, 120, '2014-02-01 00:50:15.000000', 'temperatura', 126.0000, 'ºC'),
	(177116, 120, '2014-02-01 00:50:16.000000', 'temperatura', 78.0000, 'ºC'),
	(177117, 120, '2014-02-01 00:50:17.000000', 'temperatura', 15.0000, 'ºC'),
	(177118, 120, '2014-02-01 00:50:18.000000', 'temperatura', 1039.0000, 'ºC'),
	(177119, 120, '2014-02-01 00:50:19.000000', 'temperatura', 350.0000, 'ºC'),
	(177120, 120, '2014-02-01 00:50:20.000000', 'temperatura', 1036.0000, 'ºC'),
	(177121, 120, '2014-02-01 00:50:21.000000', 'temperatura', 530.0000, 'ºC'),
	(177122, 120, '2014-02-01 00:50:22.000000', 'temperatura', 742.0000, 'ºC'),
	(177123, 120, '2014-02-01 00:50:23.000000', 'temperatura', 919.0000, 'ºC'),
	(177124, 120, '2014-02-01 00:50:24.000000', 'temperatura', 1172.0000, 'ºC'),
	(177125, 120, '2014-02-01 00:50:25.000000', 'temperatura', 701.0000, 'ºC'),
	(177126, 120, '2014-02-01 00:50:26.000000', 'temperatura', 1190.0000, 'ºC'),
	(177127, 120, '2014-02-01 00:50:27.000000', 'temperatura', 249.0000, 'ºC'),
	(177128, 120, '2014-02-01 00:50:28.000000', 'temperatura', 73.0000, 'ºC'),
	(177129, 120, '2014-02-01 00:50:29.000000', 'temperatura', 821.0000, 'ºC'),
	(177130, 120, '2014-02-01 00:50:30.000000', 'temperatura', 286.0000, 'ºC'),
	(177131, 120, '2014-02-01 00:50:31.000000', 'temperatura', 166.0000, 'ºC'),
	(177132, 120, '2014-02-01 00:50:32.000000', 'temperatura', 1171.0000, 'ºC'),
	(177133, 120, '2014-02-01 00:50:33.000000', 'temperatura', 561.0000, 'ºC'),
	(177134, 120, '2014-02-01 00:50:34.000000', 'temperatura', 492.0000, 'ºC'),
	(177135, 120, '2014-02-01 00:50:35.000000', 'temperatura', 778.0000, 'ºC'),
	(177136, 120, '2014-02-01 00:50:36.000000', 'temperatura', 15.0000, 'ºC'),
	(177137, 120, '2014-02-01 00:50:37.000000', 'temperatura', 142.0000, 'ºC'),
	(177138, 120, '2014-02-01 00:50:38.000000', 'temperatura', 663.0000, 'ºC'),
	(177139, 120, '2014-02-01 00:50:39.000000', 'temperatura', 492.0000, 'ºC'),
	(177140, 120, '2014-02-01 00:50:40.000000', 'temperatura', 469.0000, 'ºC'),
	(177141, 120, '2014-02-01 00:50:41.000000', 'temperatura', 871.0000, 'ºC'),
	(177142, 120, '2014-02-01 00:50:42.000000', 'temperatura', 547.0000, 'ºC'),
	(177143, 120, '2014-02-01 00:50:43.000000', 'temperatura', 125.0000, 'ºC'),
	(177144, 120, '2014-02-01 00:50:44.000000', 'temperatura', 181.0000, 'ºC'),
	(177145, 120, '2014-02-01 00:50:45.000000', 'temperatura', 533.0000, 'ºC'),
	(177146, 120, '2014-02-01 00:50:46.000000', 'temperatura', 923.0000, 'ºC'),
	(177147, 120, '2014-02-01 00:50:47.000000', 'temperatura', 617.0000, 'ºC'),
	(177148, 120, '2014-02-01 00:50:48.000000', 'temperatura', 314.0000, 'ºC'),
	(177149, 120, '2014-02-01 00:50:49.000000', 'temperatura', 921.0000, 'ºC'),
	(177150, 120, '2014-02-01 00:50:50.000000', 'temperatura', 62.0000, 'ºC'),
	(177151, 120, '2014-02-01 00:50:51.000000', 'temperatura', 1147.0000, 'ºC'),
	(177152, 120, '2014-02-01 00:50:52.000000', 'temperatura', 752.0000, 'ºC'),
	(177153, 120, '2014-02-01 00:50:53.000000', 'temperatura', 320.0000, 'ºC'),
	(177154, 120, '2014-02-01 00:50:54.000000', 'temperatura', 543.0000, 'ºC'),
	(177155, 120, '2014-02-01 00:50:55.000000', 'temperatura', 556.0000, 'ºC'),
	(177156, 120, '2014-02-01 00:50:56.000000', 'temperatura', 1150.0000, 'ºC'),
	(177157, 120, '2014-02-01 00:50:57.000000', 'temperatura', 485.0000, 'ºC'),
	(177158, 120, '2014-02-01 00:50:58.000000', 'temperatura', 173.0000, 'ºC'),
	(177159, 120, '2014-02-01 00:50:59.000000', 'temperatura', 612.0000, 'ºC'),
	(177160, 120, '2014-02-01 00:51:00.000000', 'temperatura', 139.0000, 'ºC'),
	(177161, 120, '2014-02-01 00:51:01.000000', 'temperatura', 61.0000, 'ºC'),
	(177162, 120, '2014-02-01 00:51:02.000000', 'temperatura', 1089.0000, 'ºC'),
	(177163, 120, '2014-02-01 00:51:03.000000', 'temperatura', 464.0000, 'ºC'),
	(177164, 120, '2014-02-01 00:51:04.000000', 'temperatura', 252.0000, 'ºC'),
	(177165, 120, '2014-02-01 00:51:05.000000', 'temperatura', 1067.0000, 'ºC'),
	(177166, 120, '2014-02-01 00:51:06.000000', 'temperatura', 981.0000, 'ºC'),
	(177167, 120, '2014-02-01 00:51:07.000000', 'temperatura', 504.0000, 'ºC'),
	(177168, 120, '2014-02-01 00:51:08.000000', 'temperatura', 779.0000, 'ºC'),
	(177169, 120, '2014-02-01 00:51:09.000000', 'temperatura', 1181.0000, 'ºC'),
	(177170, 120, '2014-02-01 00:51:10.000000', 'temperatura', 1170.0000, 'ºC'),
	(177171, 120, '2014-02-01 00:51:11.000000', 'temperatura', 1108.0000, 'ºC'),
	(177172, 120, '2014-02-01 00:51:12.000000', 'temperatura', 828.0000, 'ºC'),
	(177173, 120, '2014-02-01 00:51:13.000000', 'temperatura', 818.0000, 'ºC'),
	(177174, 120, '2014-02-01 00:51:14.000000', 'temperatura', 408.0000, 'ºC'),
	(177175, 120, '2014-02-01 00:51:15.000000', 'temperatura', 784.0000, 'ºC'),
	(177176, 120, '2014-02-01 00:51:16.000000', 'temperatura', 298.0000, 'ºC'),
	(177177, 120, '2014-02-01 00:51:17.000000', 'temperatura', 337.0000, 'ºC'),
	(177178, 120, '2014-02-01 00:51:18.000000', 'temperatura', 791.0000, 'ºC'),
	(177179, 120, '2014-02-01 00:51:19.000000', 'temperatura', 545.0000, 'ºC'),
	(177180, 120, '2014-02-01 00:51:20.000000', 'temperatura', 354.0000, 'ºC'),
	(177181, 120, '2014-02-01 00:51:21.000000', 'temperatura', 134.0000, 'ºC'),
	(177182, 120, '2014-02-01 00:51:22.000000', 'temperatura', 811.0000, 'ºC'),
	(177183, 120, '2014-02-01 00:51:23.000000', 'temperatura', 50.0000, 'ºC'),
	(177184, 120, '2014-02-01 00:51:24.000000', 'temperatura', 219.0000, 'ºC'),
	(177185, 120, '2014-02-01 00:51:25.000000', 'temperatura', 947.0000, 'ºC'),
	(177186, 120, '2014-02-01 00:51:26.000000', 'temperatura', 479.0000, 'ºC'),
	(177187, 120, '2014-02-01 00:51:27.000000', 'temperatura', 753.0000, 'ºC'),
	(177188, 120, '2014-02-01 00:51:28.000000', 'temperatura', 1127.0000, 'ºC'),
	(177189, 120, '2014-02-01 00:51:29.000000', 'temperatura', 979.0000, 'ºC'),
	(177190, 120, '2014-02-01 00:51:30.000000', 'temperatura', 313.0000, 'ºC'),
	(177191, 120, '2014-02-01 00:51:31.000000', 'temperatura', 1030.0000, 'ºC'),
	(177192, 120, '2014-02-01 00:51:32.000000', 'temperatura', 612.0000, 'ºC'),
	(177193, 120, '2014-02-01 00:51:33.000000', 'temperatura', 1168.0000, 'ºC'),
	(177194, 120, '2014-02-01 00:51:34.000000', 'temperatura', 407.0000, 'ºC'),
	(177195, 120, '2014-02-01 00:51:35.000000', 'temperatura', 932.0000, 'ºC'),
	(177196, 120, '2014-02-01 00:51:36.000000', 'temperatura', 1037.0000, 'ºC'),
	(177197, 120, '2014-02-01 00:51:37.000000', 'temperatura', 1189.0000, 'ºC'),
	(177198, 120, '2014-02-01 00:51:38.000000', 'temperatura', 437.0000, 'ºC'),
	(177199, 120, '2014-02-01 00:51:39.000000', 'temperatura', 1020.0000, 'ºC'),
	(177200, 120, '2014-02-01 00:51:40.000000', 'temperatura', 186.0000, 'ºC'),
	(177201, 120, '2014-02-01 00:51:41.000000', 'temperatura', 272.0000, 'ºC'),
	(177202, 120, '2014-02-01 00:51:42.000000', 'temperatura', 802.0000, 'ºC'),
	(177203, 120, '2014-02-01 00:51:43.000000', 'temperatura', 793.0000, 'ºC'),
	(177204, 120, '2014-02-01 00:51:44.000000', 'temperatura', 361.0000, 'ºC'),
	(177205, 120, '2014-02-01 00:51:45.000000', 'temperatura', 624.0000, 'ºC'),
	(177206, 120, '2014-02-01 00:51:46.000000', 'temperatura', 841.0000, 'ºC'),
	(177207, 120, '2014-02-01 00:51:47.000000', 'temperatura', 1132.0000, 'ºC'),
	(177208, 120, '2014-02-01 00:51:48.000000', 'temperatura', 736.0000, 'ºC'),
	(177209, 120, '2014-02-01 00:51:49.000000', 'temperatura', 284.0000, 'ºC'),
	(177210, 120, '2014-02-01 00:51:50.000000', 'temperatura', 412.0000, 'ºC'),
	(177211, 120, '2014-02-01 00:51:51.000000', 'temperatura', 8.0000, 'ºC'),
	(177212, 120, '2014-02-01 00:51:52.000000', 'temperatura', 5.0000, 'ºC'),
	(177213, 120, '2014-02-01 00:51:53.000000', 'temperatura', 1.0000, 'ºC'),
	(177214, 120, '2014-02-01 00:51:54.000000', 'temperatura', 1190.0000, 'ºC'),
	(177215, 120, '2014-02-01 00:51:55.000000', 'temperatura', 1150.0000, 'ºC'),
	(177216, 120, '2014-02-01 00:51:56.000000', 'temperatura', 980.0000, 'ºC'),
	(177217, 120, '2014-02-01 00:51:57.000000', 'temperatura', 252.0000, 'ºC'),
	(177218, 120, '2014-02-01 00:51:58.000000', 'temperatura', 718.0000, 'ºC'),
	(177219, 120, '2014-02-01 00:51:59.000000', 'temperatura', 437.0000, 'ºC'),
	(177220, 120, '2014-02-01 00:52:00.000000', 'temperatura', 29.0000, 'ºC'),
	(177221, 120, '2014-02-01 00:52:01.000000', 'temperatura', 34.0000, 'ºC'),
	(177222, 120, '2014-02-01 00:52:02.000000', 'temperatura', 83.0000, 'ºC'),
	(177223, 120, '2014-02-01 00:52:03.000000', 'temperatura', 314.0000, 'ºC'),
	(177224, 120, '2014-02-01 00:52:04.000000', 'temperatura', 120.0000, 'ºC'),
	(177225, 120, '2014-02-01 00:52:05.000000', 'temperatura', 862.0000, 'ºC'),
	(177226, 120, '2014-02-01 00:52:06.000000', 'temperatura', 347.0000, 'ºC'),
	(177227, 120, '2014-02-01 00:52:07.000000', 'temperatura', 352.0000, 'ºC'),
	(177228, 120, '2014-02-01 00:52:08.000000', 'temperatura', 718.0000, 'ºC'),
	(177229, 120, '2014-02-01 00:52:09.000000', 'temperatura', 134.0000, 'ºC'),
	(177230, 120, '2014-02-01 00:52:10.000000', 'temperatura', 918.0000, 'ºC'),
	(177231, 120, '2014-02-01 00:52:11.000000', 'temperatura', 588.0000, 'ºC'),
	(177232, 120, '2014-02-01 00:52:12.000000', 'temperatura', 186.0000, 'ºC'),
	(177233, 120, '2014-02-01 00:52:13.000000', 'temperatura', 366.0000, 'ºC'),
	(177234, 120, '2014-02-01 00:52:14.000000', 'temperatura', 75.0000, 'ºC'),
	(177235, 120, '2014-02-01 00:52:15.000000', 'temperatura', 475.0000, 'ºC'),
	(177236, 120, '2014-02-01 00:52:16.000000', 'temperatura', 950.0000, 'ºC'),
	(177237, 120, '2014-02-01 00:52:17.000000', 'temperatura', 924.0000, 'ºC'),
	(177238, 120, '2014-02-01 00:52:18.000000', 'temperatura', 574.0000, 'ºC'),
	(177239, 120, '2014-02-01 00:52:19.000000', 'temperatura', 97.0000, 'ºC'),
	(177240, 120, '2014-02-01 00:52:20.000000', 'temperatura', 1162.0000, 'ºC'),
	(177241, 120, '2014-02-01 00:52:21.000000', 'temperatura', 723.0000, 'ºC'),
	(177242, 120, '2014-02-01 00:52:22.000000', 'temperatura', 127.0000, 'ºC'),
	(177243, 120, '2014-02-01 00:52:23.000000', 'temperatura', 865.0000, 'ºC'),
	(177244, 120, '2014-02-01 00:52:24.000000', 'temperatura', 346.0000, 'ºC'),
	(177245, 120, '2014-02-01 00:52:25.000000', 'temperatura', 335.0000, 'ºC'),
	(177246, 120, '2014-02-01 00:52:26.000000', 'temperatura', 637.0000, 'ºC'),
	(177247, 120, '2014-02-01 00:52:27.000000', 'temperatura', 982.0000, 'ºC'),
	(177248, 120, '2014-02-01 00:52:28.000000', 'temperatura', 597.0000, 'ºC'),
	(177249, 120, '2014-02-01 00:52:29.000000', 'temperatura', 41.0000, 'ºC'),
	(177250, 120, '2014-02-01 00:52:30.000000', 'temperatura', 816.0000, 'ºC'),
	(177251, 120, '2014-02-01 00:52:31.000000', 'temperatura', 355.0000, 'ºC'),
	(177252, 120, '2014-02-01 00:52:32.000000', 'temperatura', 529.0000, 'ºC'),
	(177253, 120, '2014-02-01 00:52:33.000000', 'temperatura', 381.0000, 'ºC'),
	(177254, 120, '2014-02-01 00:52:34.000000', 'temperatura', 318.0000, 'ºC'),
	(177255, 120, '2014-02-01 00:52:35.000000', 'temperatura', 449.0000, 'ºC'),
	(177256, 120, '2014-02-01 00:52:36.000000', 'temperatura', 91.0000, 'ºC'),
	(177257, 120, '2014-02-01 00:52:37.000000', 'temperatura', 306.0000, 'ºC'),
	(177258, 120, '2014-02-01 00:52:38.000000', 'temperatura', 60.0000, 'ºC'),
	(177259, 120, '2014-02-01 00:52:39.000000', 'temperatura', 581.0000, 'ºC'),
	(177260, 120, '2014-02-01 00:52:40.000000', 'temperatura', 326.0000, 'ºC'),
	(177261, 120, '2014-02-01 00:52:41.000000', 'temperatura', 1088.0000, 'ºC'),
	(177262, 120, '2014-02-01 00:52:42.000000', 'temperatura', 860.0000, 'ºC'),
	(177263, 120, '2014-02-01 00:52:43.000000', 'temperatura', 1040.0000, 'ºC'),
	(177264, 120, '2014-02-01 00:52:44.000000', 'temperatura', 217.0000, 'ºC'),
	(177265, 120, '2014-02-01 00:52:45.000000', 'temperatura', 369.0000, 'ºC'),
	(177266, 120, '2014-02-01 00:52:46.000000', 'temperatura', 1194.0000, 'ºC'),
	(177267, 120, '2014-02-01 00:52:47.000000', 'temperatura', 61.0000, 'ºC'),
	(177268, 120, '2014-02-01 00:52:48.000000', 'temperatura', 324.0000, 'ºC'),
	(177269, 120, '2014-02-01 00:52:49.000000', 'temperatura', 239.0000, 'ºC'),
	(177270, 120, '2014-02-01 00:52:50.000000', 'temperatura', 221.0000, 'ºC'),
	(177271, 120, '2014-02-01 00:52:51.000000', 'temperatura', 389.0000, 'ºC'),
	(177272, 120, '2014-02-01 00:52:52.000000', 'temperatura', 82.0000, 'ºC'),
	(177273, 120, '2014-02-01 00:52:53.000000', 'temperatura', 446.0000, 'ºC'),
	(177274, 120, '2014-02-01 00:52:54.000000', 'temperatura', 783.0000, 'ºC'),
	(177275, 120, '2014-02-01 00:52:55.000000', 'temperatura', 178.0000, 'ºC'),
	(177276, 120, '2014-02-01 00:52:56.000000', 'temperatura', 943.0000, 'ºC'),
	(177277, 120, '2014-02-01 00:52:57.000000', 'temperatura', 579.0000, 'ºC'),
	(177278, 120, '2014-02-01 00:52:58.000000', 'temperatura', 66.0000, 'ºC'),
	(177279, 120, '2014-02-01 00:52:59.000000', 'temperatura', 993.0000, 'ºC'),
	(177280, 120, '2014-02-01 00:53:00.000000', 'temperatura', 1167.0000, 'ºC'),
	(177281, 120, '2014-02-01 00:53:01.000000', 'temperatura', 456.0000, 'ºC'),
	(177282, 120, '2014-02-01 00:53:02.000000', 'temperatura', 1180.0000, 'ºC'),
	(177283, 120, '2014-02-01 00:53:03.000000', 'temperatura', 932.0000, 'ºC'),
	(177284, 120, '2014-02-01 00:53:04.000000', 'temperatura', 1119.0000, 'ºC'),
	(177285, 120, '2014-02-01 00:53:05.000000', 'temperatura', 402.0000, 'ºC'),
	(177286, 120, '2014-02-01 00:53:06.000000', 'temperatura', 1053.0000, 'ºC'),
	(177287, 120, '2014-02-01 00:53:07.000000', 'temperatura', 459.0000, 'ºC'),
	(177288, 120, '2014-02-01 00:53:08.000000', 'temperatura', 336.0000, 'ºC'),
	(177289, 120, '2014-02-01 00:53:09.000000', 'temperatura', 302.0000, 'ºC'),
	(177290, 120, '2014-02-01 00:53:10.000000', 'temperatura', 505.0000, 'ºC'),
	(177291, 120, '2014-02-01 00:53:11.000000', 'temperatura', 420.0000, 'ºC'),
	(177292, 120, '2014-02-01 00:53:12.000000', 'temperatura', 584.0000, 'ºC'),
	(177293, 120, '2014-02-01 00:53:13.000000', 'temperatura', 462.0000, 'ºC'),
	(177294, 120, '2014-02-01 00:53:14.000000', 'temperatura', 559.0000, 'ºC'),
	(177295, 120, '2014-02-01 00:53:15.000000', 'temperatura', 210.0000, 'ºC'),
	(177296, 120, '2014-02-01 00:53:16.000000', 'temperatura', 573.0000, 'ºC'),
	(177297, 120, '2014-02-01 00:53:17.000000', 'temperatura', 1037.0000, 'ºC'),
	(177298, 120, '2014-02-01 00:53:18.000000', 'temperatura', 1066.0000, 'ºC'),
	(177299, 120, '2014-02-01 00:53:19.000000', 'temperatura', 1020.0000, 'ºC'),
	(177300, 120, '2014-02-01 00:53:20.000000', 'temperatura', 702.0000, 'ºC'),
	(177301, 120, '2014-02-01 00:53:21.000000', 'temperatura', 451.0000, 'ºC'),
	(177302, 120, '2014-02-01 00:53:22.000000', 'temperatura', 148.0000, 'ºC'),
	(177303, 120, '2014-02-01 00:53:23.000000', 'temperatura', 587.0000, 'ºC'),
	(177304, 120, '2014-02-01 00:53:24.000000', 'temperatura', 94.0000, 'ºC'),
	(177305, 120, '2014-02-01 00:53:25.000000', 'temperatura', 1110.0000, 'ºC'),
	(177306, 120, '2014-02-01 00:53:26.000000', 'temperatura', 466.0000, 'ºC'),
	(177307, 120, '2014-02-01 00:53:27.000000', 'temperatura', 202.0000, 'ºC'),
	(177308, 120, '2014-02-01 00:53:28.000000', 'temperatura', 812.0000, 'ºC'),
	(177309, 120, '2014-02-01 00:53:29.000000', 'temperatura', 1055.0000, 'ºC'),
	(177310, 120, '2014-02-01 00:53:30.000000', 'temperatura', 441.0000, 'ºC'),
	(177311, 120, '2014-02-01 00:53:31.000000', 'temperatura', 240.0000, 'ºC'),
	(177312, 120, '2014-02-01 00:53:32.000000', 'temperatura', 1078.0000, 'ºC'),
	(177313, 120, '2014-02-01 00:53:33.000000', 'temperatura', 1070.0000, 'ºC'),
	(177314, 120, '2014-02-01 00:53:34.000000', 'temperatura', 917.0000, 'ºC'),
	(177315, 120, '2014-02-01 00:53:35.000000', 'temperatura', 175.0000, 'ºC'),
	(177316, 120, '2014-02-01 00:53:36.000000', 'temperatura', 523.0000, 'ºC'),
	(177317, 120, '2014-02-01 00:53:37.000000', 'temperatura', 893.0000, 'ºC'),
	(177318, 120, '2014-02-01 00:53:38.000000', 'temperatura', 497.0000, 'ºC'),
	(177319, 120, '2014-02-01 00:53:39.000000', 'temperatura', 1004.0000, 'ºC'),
	(177320, 120, '2014-02-01 00:53:40.000000', 'temperatura', 1132.0000, 'ºC'),
	(177321, 120, '2014-02-01 00:53:41.000000', 'temperatura', 247.0000, 'ºC'),
	(177322, 120, '2014-02-01 00:53:42.000000', 'temperatura', 241.0000, 'ºC'),
	(177323, 120, '2014-02-01 00:53:43.000000', 'temperatura', 463.0000, 'ºC'),
	(177324, 120, '2014-02-01 00:53:44.000000', 'temperatura', 391.0000, 'ºC'),
	(177325, 120, '2014-02-01 00:53:45.000000', 'temperatura', 569.0000, 'ºC'),
	(177326, 120, '2014-02-01 00:53:46.000000', 'temperatura', 472.0000, 'ºC'),
	(177327, 120, '2014-02-01 00:53:47.000000', 'temperatura', 655.0000, 'ºC'),
	(177328, 120, '2014-02-01 00:53:48.000000', 'temperatura', 657.0000, 'ºC'),
	(177329, 120, '2014-02-01 00:53:49.000000', 'temperatura', 122.0000, 'ºC'),
	(177330, 120, '2014-02-01 00:53:50.000000', 'temperatura', 1038.0000, 'ºC'),
	(177331, 120, '2014-02-01 00:53:51.000000', 'temperatura', 26.0000, 'ºC'),
	(177332, 120, '2014-02-01 00:53:52.000000', 'temperatura', 617.0000, 'ºC'),
	(177333, 120, '2014-02-01 00:53:53.000000', 'temperatura', 607.0000, 'ºC'),
	(177334, 120, '2014-02-01 00:53:54.000000', 'temperatura', 1182.0000, 'ºC'),
	(177335, 120, '2014-02-01 00:53:55.000000', 'temperatura', 493.0000, 'ºC'),
	(177336, 120, '2014-02-01 00:53:56.000000', 'temperatura', 117.0000, 'ºC'),
	(177337, 120, '2014-02-01 00:53:57.000000', 'temperatura', 309.0000, 'ºC'),
	(177338, 120, '2014-02-01 00:53:58.000000', 'temperatura', 1195.0000, 'ºC'),
	(177339, 120, '2014-02-01 00:53:59.000000', 'temperatura', 249.0000, 'ºC'),
	(177340, 120, '2014-02-01 00:54:00.000000', 'temperatura', 59.0000, 'ºC'),
	(177341, 120, '2014-02-01 00:54:01.000000', 'temperatura', 749.0000, 'ºC'),
	(177342, 120, '2014-02-01 00:54:02.000000', 'temperatura', 1167.0000, 'ºC'),
	(177343, 120, '2014-02-01 00:54:03.000000', 'temperatura', 1188.0000, 'ºC'),
	(177344, 120, '2014-02-01 00:54:04.000000', 'temperatura', 41.0000, 'ºC'),
	(177345, 120, '2014-02-01 00:54:05.000000', 'temperatura', 243.0000, 'ºC'),
	(177346, 120, '2014-02-01 00:54:06.000000', 'temperatura', 1090.0000, 'ºC'),
	(177347, 120, '2014-02-01 00:54:07.000000', 'temperatura', 1120.0000, 'ºC'),
	(177348, 120, '2014-02-01 00:54:08.000000', 'temperatura', 1133.0000, 'ºC'),
	(177349, 120, '2014-02-01 00:54:09.000000', 'temperatura', 1105.0000, 'ºC'),
	(177350, 120, '2014-02-01 00:54:10.000000', 'temperatura', 927.0000, 'ºC'),
	(177351, 120, '2014-02-01 00:54:11.000000', 'temperatura', 121.0000, 'ºC'),
	(177352, 120, '2014-02-01 00:54:12.000000', 'temperatura', 225.0000, 'ºC'),
	(177353, 120, '2014-02-01 00:54:13.000000', 'temperatura', 763.0000, 'ºC'),
	(177354, 120, '2014-02-01 00:54:14.000000', 'temperatura', 741.0000, 'ºC'),
	(177355, 120, '2014-02-01 00:54:15.000000', 'temperatura', 215.0000, 'ºC'),
	(177356, 120, '2014-02-01 00:54:16.000000', 'temperatura', 55.0000, 'ºC'),
	(177357, 120, '2014-02-01 00:54:17.000000', 'temperatura', 827.0000, 'ºC'),
	(177358, 120, '2014-02-01 00:54:18.000000', 'temperatura', 373.0000, 'ºC'),
	(177359, 120, '2014-02-01 00:54:19.000000', 'temperatura', 585.0000, 'ºC'),
	(177360, 120, '2014-02-01 00:54:20.000000', 'temperatura', 605.0000, 'ºC'),
	(177361, 120, '2014-02-01 00:54:21.000000', 'temperatura', 70.0000, 'ºC'),
	(177362, 120, '2014-02-01 00:54:22.000000', 'temperatura', 935.0000, 'ºC'),
	(177363, 120, '2014-02-01 00:54:23.000000', 'temperatura', 867.0000, 'ºC'),
	(177364, 120, '2014-02-01 00:54:24.000000', 'temperatura', 331.0000, 'ºC'),
	(177365, 120, '2014-02-01 00:54:25.000000', 'temperatura', 253.0000, 'ºC'),
	(177366, 120, '2014-02-01 00:54:26.000000', 'temperatura', 275.0000, 'ºC'),
	(177367, 120, '2014-02-01 00:54:27.000000', 'temperatura', 615.0000, 'ºC'),
	(177368, 120, '2014-02-01 00:54:28.000000', 'temperatura', 1050.0000, 'ºC'),
	(177369, 120, '2014-02-01 00:54:29.000000', 'temperatura', 1004.0000, 'ºC'),
	(177370, 120, '2014-02-01 00:54:30.000000', 'temperatura', 674.0000, 'ºC'),
	(177371, 120, '2014-02-01 00:54:31.000000', 'temperatura', 355.0000, 'ºC'),
	(177372, 120, '2014-02-01 00:54:32.000000', 'temperatura', 957.0000, 'ºC'),
	(177373, 120, '2014-02-01 00:54:33.000000', 'temperatura', 118.0000, 'ºC'),
	(177374, 120, '2014-02-01 00:54:34.000000', 'temperatura', 121.0000, 'ºC'),
	(177375, 120, '2014-02-01 00:54:35.000000', 'temperatura', 253.0000, 'ºC'),
	(177376, 120, '2014-02-01 00:54:36.000000', 'temperatura', 901.0000, 'ºC'),
	(177377, 120, '2014-02-01 00:54:37.000000', 'temperatura', 146.0000, 'ºC'),
	(177378, 120, '2014-02-01 00:54:38.000000', 'temperatura', 428.0000, 'ºC'),
	(177379, 120, '2014-02-01 00:54:39.000000', 'temperatura', 503.0000, 'ºC'),
	(177380, 120, '2014-02-01 00:54:40.000000', 'temperatura', 32.0000, 'ºC'),
	(177381, 120, '2014-02-01 00:54:41.000000', 'temperatura', 1052.0000, 'ºC'),
	(177382, 120, '2014-02-01 00:54:42.000000', 'temperatura', 364.0000, 'ºC'),
	(177383, 120, '2014-02-01 00:54:43.000000', 'temperatura', 1065.0000, 'ºC'),
	(177384, 120, '2014-02-01 00:54:44.000000', 'temperatura', 635.0000, 'ºC'),
	(177385, 120, '2014-02-01 00:54:45.000000', 'temperatura', 1178.0000, 'ºC'),
	(177386, 120, '2014-02-01 00:54:46.000000', 'temperatura', 387.0000, 'ºC'),
	(177387, 120, '2014-02-01 00:54:47.000000', 'temperatura', 799.0000, 'ºC'),
	(177388, 120, '2014-02-01 00:54:48.000000', 'temperatura', 436.0000, 'ºC'),
	(177389, 120, '2014-02-01 00:54:49.000000', 'temperatura', 983.0000, 'ºC'),
	(177390, 120, '2014-02-01 00:54:50.000000', 'temperatura', 6.0000, 'ºC'),
	(177391, 120, '2014-02-01 00:54:51.000000', 'temperatura', 684.0000, 'ºC'),
	(177392, 120, '2014-02-01 00:54:52.000000', 'temperatura', 1002.0000, 'ºC'),
	(177393, 120, '2014-02-01 00:54:53.000000', 'temperatura', 557.0000, 'ºC'),
	(177394, 120, '2014-02-01 00:54:54.000000', 'temperatura', 980.0000, 'ºC'),
	(177395, 120, '2014-02-01 00:54:55.000000', 'temperatura', 830.0000, 'ºC'),
	(177396, 120, '2014-02-01 00:54:56.000000', 'temperatura', 10.0000, 'ºC'),
	(177397, 120, '2014-02-01 00:54:57.000000', 'temperatura', 1160.0000, 'ºC'),
	(177398, 120, '2014-02-01 00:54:58.000000', 'temperatura', 972.0000, 'ºC'),
	(177399, 120, '2014-02-01 00:54:59.000000', 'temperatura', 181.0000, 'ºC'),
	(177400, 120, '2014-02-01 00:55:00.000000', 'temperatura', 387.0000, 'ºC'),
	(177401, 120, '2014-02-01 00:55:01.000000', 'temperatura', 194.0000, 'ºC'),
	(177402, 120, '2014-02-01 00:55:02.000000', 'temperatura', 1009.0000, 'ºC'),
	(177403, 120, '2014-02-01 00:55:03.000000', 'temperatura', 862.0000, 'ºC'),
	(177404, 120, '2014-02-01 00:55:04.000000', 'temperatura', 84.0000, 'ºC'),
	(177405, 120, '2014-02-01 00:55:05.000000', 'temperatura', 233.0000, 'ºC'),
	(177406, 120, '2014-02-01 00:55:06.000000', 'temperatura', 916.0000, 'ºC'),
	(177407, 120, '2014-02-01 00:55:07.000000', 'temperatura', 280.0000, 'ºC'),
	(177408, 120, '2014-02-01 00:55:08.000000', 'temperatura', 1054.0000, 'ºC'),
	(177409, 120, '2014-02-01 00:55:09.000000', 'temperatura', 829.0000, 'ºC'),
	(177410, 120, '2014-02-01 00:55:10.000000', 'temperatura', 986.0000, 'ºC'),
	(177411, 120, '2014-02-01 00:55:11.000000', 'temperatura', 41.0000, 'ºC'),
	(177412, 120, '2014-02-01 00:55:12.000000', 'temperatura', 849.0000, 'ºC'),
	(177413, 120, '2014-02-01 00:55:13.000000', 'temperatura', 521.0000, 'ºC'),
	(177414, 120, '2014-02-01 00:55:14.000000', 'temperatura', 58.0000, 'ºC'),
	(177415, 120, '2014-02-01 00:55:15.000000', 'temperatura', 1129.0000, 'ºC'),
	(177416, 120, '2014-02-01 00:55:16.000000', 'temperatura', 672.0000, 'ºC'),
	(177417, 120, '2014-02-01 00:55:17.000000', 'temperatura', 1174.0000, 'ºC'),
	(177418, 120, '2014-02-01 00:55:18.000000', 'temperatura', 252.0000, 'ºC'),
	(177419, 120, '2014-02-01 00:55:19.000000', 'temperatura', 141.0000, 'ºC'),
	(177420, 120, '2014-02-01 00:55:20.000000', 'temperatura', 1149.0000, 'ºC'),
	(177421, 120, '2014-02-01 00:55:21.000000', 'temperatura', 524.0000, 'ºC'),
	(177422, 120, '2014-02-01 00:55:22.000000', 'temperatura', 370.0000, 'ºC'),
	(177423, 120, '2014-02-01 00:55:23.000000', 'temperatura', 281.0000, 'ºC'),
	(177424, 120, '2014-02-01 00:55:24.000000', 'temperatura', 293.0000, 'ºC'),
	(177425, 120, '2014-02-01 00:55:25.000000', 'temperatura', 623.0000, 'ºC'),
	(177426, 120, '2014-02-01 00:55:26.000000', 'temperatura', 1035.0000, 'ºC'),
	(177427, 120, '2014-02-01 00:55:27.000000', 'temperatura', 908.0000, 'ºC'),
	(177428, 120, '2014-02-01 00:55:28.000000', 'temperatura', 233.0000, 'ºC'),
	(177429, 120, '2014-02-01 00:55:29.000000', 'temperatura', 845.0000, 'ºC'),
	(177430, 120, '2014-02-01 00:55:30.000000', 'temperatura', 1124.0000, 'ºC'),
	(177431, 120, '2014-02-01 00:55:31.000000', 'temperatura', 686.0000, 'ºC'),
	(177432, 120, '2014-02-01 00:55:32.000000', 'temperatura', 59.0000, 'ºC'),
	(177433, 120, '2014-02-01 00:55:33.000000', 'temperatura', 636.0000, 'ºC'),
	(177434, 120, '2014-02-01 00:55:34.000000', 'temperatura', 606.0000, 'ºC'),
	(177435, 120, '2014-02-01 00:55:35.000000', 'temperatura', 1119.0000, 'ºC'),
	(177436, 120, '2014-02-01 00:55:36.000000', 'temperatura', 180.0000, 'ºC'),
	(177437, 120, '2014-02-01 00:55:37.000000', 'temperatura', 1144.0000, 'ºC'),
	(177438, 120, '2014-02-01 00:55:38.000000', 'temperatura', 381.0000, 'ºC'),
	(177439, 120, '2014-02-01 00:55:39.000000', 'temperatura', 871.0000, 'ºC'),
	(177440, 120, '2014-02-01 00:55:40.000000', 'temperatura', 812.0000, 'ºC'),
	(177441, 120, '2014-02-01 00:55:41.000000', 'temperatura', 249.0000, 'ºC'),
	(177442, 120, '2014-02-01 00:55:42.000000', 'temperatura', 10.0000, 'ºC'),
	(177443, 120, '2014-02-01 00:55:43.000000', 'temperatura', 505.0000, 'ºC'),
	(177444, 120, '2014-02-01 00:55:44.000000', 'temperatura', 95.0000, 'ºC'),
	(177445, 120, '2014-02-01 00:55:45.000000', 'temperatura', 158.0000, 'ºC'),
	(177446, 120, '2014-02-01 00:55:46.000000', 'temperatura', 507.0000, 'ºC'),
	(177447, 120, '2014-02-01 00:55:47.000000', 'temperatura', 861.0000, 'ºC'),
	(177448, 120, '2014-02-01 00:55:48.000000', 'temperatura', 385.0000, 'ºC'),
	(177449, 120, '2014-02-01 00:55:49.000000', 'temperatura', 543.0000, 'ºC'),
	(177450, 120, '2014-02-01 00:55:50.000000', 'temperatura', 361.0000, 'ºC'),
	(177451, 120, '2014-02-01 00:55:51.000000', 'temperatura', 176.0000, 'ºC'),
	(177452, 120, '2014-02-01 00:55:52.000000', 'temperatura', 998.0000, 'ºC'),
	(177453, 120, '2014-02-01 00:55:53.000000', 'temperatura', 862.0000, 'ºC'),
	(177454, 120, '2014-02-01 00:55:54.000000', 'temperatura', 116.0000, 'ºC'),
	(177455, 120, '2014-02-01 00:55:55.000000', 'temperatura', 394.0000, 'ºC'),
	(177456, 120, '2014-02-01 00:55:56.000000', 'temperatura', 425.0000, 'ºC'),
	(177457, 120, '2014-02-01 00:55:57.000000', 'temperatura', 941.0000, 'ºC'),
	(177458, 120, '2014-02-01 00:55:58.000000', 'temperatura', 1032.0000, 'ºC'),
	(177459, 120, '2014-02-01 00:55:59.000000', 'temperatura', 1138.0000, 'ºC'),
	(177460, 120, '2014-02-01 00:56:00.000000', 'temperatura', 193.0000, 'ºC'),
	(177461, 120, '2014-02-01 00:56:01.000000', 'temperatura', 1150.0000, 'ºC'),
	(177462, 120, '2014-02-01 00:56:02.000000', 'temperatura', 375.0000, 'ºC'),
	(177463, 120, '2014-02-01 00:56:03.000000', 'temperatura', 823.0000, 'ºC'),
	(177464, 120, '2014-02-01 00:56:04.000000', 'temperatura', 591.0000, 'ºC'),
	(177465, 120, '2014-02-01 00:56:05.000000', 'temperatura', 486.0000, 'ºC'),
	(177466, 120, '2014-02-01 00:56:06.000000', 'temperatura', 658.0000, 'ºC'),
	(177467, 120, '2014-02-01 00:56:07.000000', 'temperatura', 632.0000, 'ºC'),
	(177468, 120, '2014-02-01 00:56:08.000000', 'temperatura', 1186.0000, 'ºC'),
	(177469, 120, '2014-02-01 00:56:09.000000', 'temperatura', 433.0000, 'ºC'),
	(177470, 120, '2014-02-01 00:56:10.000000', 'temperatura', 1009.0000, 'ºC'),
	(177471, 120, '2014-02-01 00:56:11.000000', 'temperatura', 146.0000, 'ºC'),
	(177472, 120, '2014-02-01 00:56:12.000000', 'temperatura', 102.0000, 'ºC'),
	(177473, 120, '2014-02-01 00:56:13.000000', 'temperatura', 74.0000, 'ºC'),
	(177474, 120, '2014-02-01 00:56:14.000000', 'temperatura', 66.0000, 'ºC'),
	(177475, 120, '2014-02-01 00:56:15.000000', 'temperatura', 106.0000, 'ºC'),
	(177476, 120, '2014-02-01 00:56:16.000000', 'temperatura', 334.0000, 'ºC'),
	(177477, 120, '2014-02-01 00:56:17.000000', 'temperatura', 152.0000, 'ºC'),
	(177478, 120, '2014-02-01 00:56:18.000000', 'temperatura', 957.0000, 'ºC'),
	(177479, 120, '2014-02-01 00:56:19.000000', 'temperatura', 733.0000, 'ºC'),
	(177480, 120, '2014-02-01 00:56:20.000000', 'temperatura', 791.0000, 'ºC'),
	(177481, 120, '2014-02-01 00:56:21.000000', 'temperatura', 559.0000, 'ºC'),
	(177482, 120, '2014-02-01 00:56:22.000000', 'temperatura', 420.0000, 'ºC'),
	(177483, 120, '2014-02-01 00:56:23.000000', 'temperatura', 423.0000, 'ºC'),
	(177484, 120, '2014-02-01 00:56:24.000000', 'temperatura', 859.0000, 'ºC'),
	(177485, 120, '2014-02-01 00:56:25.000000', 'temperatura', 624.0000, 'ºC'),
	(177486, 120, '2014-02-01 00:56:26.000000', 'temperatura', 543.0000, 'ºC'),
	(177487, 120, '2014-02-01 00:56:27.000000', 'temperatura', 845.0000, 'ºC'),
	(177488, 120, '2014-02-01 00:56:28.000000', 'temperatura', 197.0000, 'ºC'),
	(177489, 120, '2014-02-01 00:56:29.000000', 'temperatura', 850.0000, 'ºC'),
	(177490, 120, '2014-02-01 00:56:30.000000', 'temperatura', 58.0000, 'ºC'),
	(177491, 120, '2014-02-01 00:56:31.000000', 'temperatura', 142.0000, 'ºC'),
	(177492, 120, '2014-02-01 00:56:32.000000', 'temperatura', 536.0000, 'ºC'),
	(177493, 120, '2014-02-01 00:56:33.000000', 'temperatura', 1054.0000, 'ºC'),
	(177494, 120, '2014-02-01 00:56:34.000000', 'temperatura', 63.0000, 'ºC'),
	(177495, 120, '2014-02-01 00:56:35.000000', 'temperatura', 755.0000, 'ºC'),
	(177496, 120, '2014-02-01 00:56:36.000000', 'temperatura', 1185.0000, 'ºC'),
	(177497, 120, '2014-02-01 00:56:37.000000', 'temperatura', 63.0000, 'ºC'),
	(177498, 120, '2014-02-01 00:56:38.000000', 'temperatura', 358.0000, 'ºC'),
	(177499, 120, '2014-02-01 00:56:39.000000', 'temperatura', 404.0000, 'ºC'),
	(177500, 120, '2014-02-01 00:56:40.000000', 'temperatura', 944.0000, 'ºC'),
	(177501, 120, '2014-02-01 00:56:41.000000', 'temperatura', 1108.0000, 'ºC'),
	(177502, 120, '2014-02-01 00:56:42.000000', 'temperatura', 310.0000, 'ºC'),
	(177503, 120, '2014-02-01 00:56:43.000000', 'temperatura', 626.0000, 'ºC'),
	(177504, 120, '2014-02-01 00:56:44.000000', 'temperatura', 1003.0000, 'ºC'),
	(177505, 120, '2014-02-01 00:56:45.000000', 'temperatura', 734.0000, 'ºC'),
	(177506, 120, '2014-02-01 00:56:46.000000', 'temperatura', 662.0000, 'ºC'),
	(177507, 120, '2014-02-01 00:56:47.000000', 'temperatura', 1108.0000, 'ºC'),
	(177508, 120, '2014-02-01 00:56:48.000000', 'temperatura', 1155.0000, 'ºC'),
	(177509, 120, '2014-02-01 00:56:49.000000', 'temperatura', 50.0000, 'ºC'),
	(177510, 120, '2014-02-01 00:56:50.000000', 'temperatura', 388.0000, 'ºC'),
	(177511, 120, '2014-02-01 00:56:51.000000', 'temperatura', 589.0000, 'ºC'),
	(177512, 120, '2014-02-01 00:56:52.000000', 'temperatura', 583.0000, 'ºC'),
	(177513, 120, '2014-02-01 00:56:53.000000', 'temperatura', 1147.0000, 'ºC'),
	(177514, 120, '2014-02-01 00:56:54.000000', 'temperatura', 385.0000, 'ºC'),
	(177515, 120, '2014-02-01 00:56:55.000000', 'temperatura', 888.0000, 'ºC'),
	(177516, 120, '2014-02-01 00:56:56.000000', 'temperatura', 882.0000, 'ºC'),
	(177517, 120, '2014-02-01 00:56:57.000000', 'temperatura', 549.0000, 'ºC'),
	(177518, 120, '2014-02-01 00:56:58.000000', 'temperatura', 100.0000, 'ºC'),
	(177519, 120, '2014-02-01 00:56:59.000000', 'temperatura', 51.0000, 'ºC'),
	(177520, 120, '2014-02-01 00:57:00.000000', 'temperatura', 1156.0000, 'ºC'),
	(177521, 120, '2014-02-01 00:57:01.000000', 'temperatura', 828.0000, 'ºC'),
	(177522, 120, '2014-02-01 00:57:02.000000', 'temperatura', 671.0000, 'ºC'),
	(177523, 120, '2014-02-01 00:57:03.000000', 'temperatura', 871.0000, 'ºC'),
	(177524, 120, '2014-02-01 00:57:04.000000', 'temperatura', 1142.0000, 'ºC'),
	(177525, 120, '2014-02-01 00:57:05.000000', 'temperatura', 700.0000, 'ºC'),
	(177526, 120, '2014-02-01 00:57:06.000000', 'temperatura', 75.0000, 'ºC'),
	(177527, 120, '2014-02-01 00:57:07.000000', 'temperatura', 676.0000, 'ºC'),
	(177528, 120, '2014-02-01 00:57:08.000000', 'temperatura', 754.0000, 'ºC'),
	(177529, 120, '2014-02-01 00:57:09.000000', 'temperatura', 544.0000, 'ºC'),
	(177530, 120, '2014-02-01 00:57:10.000000', 'temperatura', 457.0000, 'ºC'),
	(177531, 120, '2014-02-01 00:57:11.000000', 'temperatura', 656.0000, 'ºC'),
	(177532, 120, '2014-02-01 00:57:12.000000', 'temperatura', 708.0000, 'ºC'),
	(177533, 120, '2014-02-01 00:57:13.000000', 'temperatura', 374.0000, 'ºC'),
	(177534, 120, '2014-02-01 00:57:14.000000', 'temperatura', 945.0000, 'ºC'),
	(177535, 120, '2014-02-01 00:57:15.000000', 'temperatura', 3.0000, 'ºC'),
	(177536, 120, '2014-02-01 00:57:16.000000', 'temperatura', 780.0000, 'ºC'),
	(177537, 120, '2014-02-01 00:57:17.000000', 'temperatura', 290.0000, 'ºC'),
	(177538, 120, '2014-02-01 00:57:18.000000', 'temperatura', 313.0000, 'ºC'),
	(177539, 120, '2014-02-01 00:57:19.000000', 'temperatura', 695.0000, 'ºC'),
	(177540, 120, '2014-02-01 00:57:20.000000', 'temperatura', 138.0000, 'ºC'),
	(177541, 120, '2014-02-01 00:57:21.000000', 'temperatura', 1003.0000, 'ºC'),
	(177542, 120, '2014-02-01 00:57:22.000000', 'temperatura', 1002.0000, 'ºC'),
	(177543, 120, '2014-02-01 00:57:23.000000', 'temperatura', 803.0000, 'ºC'),
	(177544, 120, '2014-02-01 00:57:24.000000', 'temperatura', 1009.0000, 'ºC'),
	(177545, 120, '2014-02-01 00:57:25.000000', 'temperatura', 237.0000, 'ºC'),
	(177546, 120, '2014-02-01 00:57:26.000000', 'temperatura', 557.0000, 'ºC'),
	(177547, 120, '2014-02-01 00:57:27.000000', 'temperatura', 876.0000, 'ºC'),
	(177548, 120, '2014-02-01 00:57:28.000000', 'temperatura', 310.0000, 'ºC'),
	(177549, 120, '2014-02-01 00:57:29.000000', 'temperatura', 122.0000, 'ºC'),
	(177550, 120, '2014-02-01 00:57:30.000000', 'temperatura', 882.0000, 'ºC'),
	(177551, 120, '2014-02-01 00:57:31.000000', 'temperatura', 444.0000, 'ºC'),
	(177552, 120, '2014-02-01 00:57:32.000000', 'temperatura', 776.0000, 'ºC'),
	(177553, 120, '2014-02-01 00:57:33.000000', 'temperatura', 146.0000, 'ºC'),
	(177554, 120, '2014-02-01 00:57:34.000000', 'temperatura', 803.0000, 'ºC'),
	(177555, 120, '2014-02-01 00:57:35.000000', 'temperatura', 1177.0000, 'ºC'),
	(177556, 120, '2014-02-01 00:57:36.000000', 'temperatura', 1078.0000, 'ºC'),
	(177557, 120, '2014-02-01 00:57:37.000000', 'temperatura', 660.0000, 'ºC'),
	(177558, 120, '2014-02-01 00:57:38.000000', 'temperatura', 65.0000, 'ºC'),
	(177559, 120, '2014-02-01 00:57:39.000000', 'temperatura', 746.0000, 'ºC'),
	(177560, 120, '2014-02-01 00:57:40.000000', 'temperatura', 1134.0000, 'ºC'),
	(177561, 120, '2014-02-01 00:57:41.000000', 'temperatura', 1034.0000, 'ºC'),
	(177562, 120, '2014-02-01 00:57:42.000000', 'temperatura', 569.0000, 'ºC'),
	(177563, 120, '2014-02-01 00:57:43.000000', 'temperatura', 941.0000, 'ºC'),
	(177564, 120, '2014-02-01 00:57:44.000000', 'temperatura', 601.0000, 'ºC'),
	(177565, 120, '2014-02-01 00:57:45.000000', 'temperatura', 182.0000, 'ºC'),
	(177566, 120, '2014-02-01 00:57:46.000000', 'temperatura', 309.0000, 'ºC'),
	(177567, 120, '2014-02-01 00:57:47.000000', 'temperatura', 1000.0000, 'ºC'),
	(177568, 120, '2014-02-01 00:57:48.000000', 'temperatura', 471.0000, 'ºC'),
	(177569, 120, '2014-02-01 00:57:49.000000', 'temperatura', 556.0000, 'ºC'),
	(177570, 120, '2014-02-01 00:57:50.000000', 'temperatura', 169.0000, 'ºC'),
	(177571, 120, '2014-02-01 00:57:51.000000', 'temperatura', 378.0000, 'ºC'),
	(177572, 120, '2014-02-01 00:57:52.000000', 'temperatura', 184.0000, 'ºC'),
	(177573, 120, '2014-02-01 00:57:53.000000', 'temperatura', 988.0000, 'ºC'),
	(177574, 120, '2014-02-01 00:57:54.000000', 'temperatura', 785.0000, 'ºC'),
	(177575, 120, '2014-02-01 00:57:55.000000', 'temperatura', 962.0000, 'ºC'),
	(177576, 120, '2014-02-01 00:57:56.000000', 'temperatura', 58.0000, 'ºC'),
	(177577, 120, '2014-02-01 00:57:57.000000', 'temperatura', 1004.0000, 'ºC'),
	(177578, 120, '2014-02-01 00:57:58.000000', 'temperatura', 45.0000, 'ºC'),
	(177579, 120, '2014-02-01 00:57:59.000000', 'temperatura', 813.0000, 'ºC'),
	(177580, 120, '2014-02-01 00:58:00.000000', 'temperatura', 330.0000, 'ºC'),
	(177581, 120, '2014-02-01 00:58:01.000000', 'temperatura', 414.0000, 'ºC'),
	(177582, 120, '2014-02-01 00:58:02.000000', 'temperatura', 1079.0000, 'ºC'),
	(177583, 120, '2014-02-01 00:58:03.000000', 'temperatura', 553.0000, 'ºC'),
	(177584, 120, '2014-02-01 00:58:04.000000', 'temperatura', 729.0000, 'ºC'),
	(177585, 120, '2014-02-01 00:58:05.000000', 'temperatura', 785.0000, 'ºC'),
	(177586, 120, '2014-02-01 00:58:06.000000', 'temperatura', 540.0000, 'ºC'),
	(177587, 120, '2014-02-01 00:58:07.000000', 'temperatura', 345.0000, 'ºC'),
	(177588, 120, '2014-02-01 00:58:08.000000', 'temperatura', 106.0000, 'ºC'),
	(177589, 120, '2014-02-01 00:58:09.000000', 'temperatura', 693.0000, 'ºC'),
	(177590, 120, '2014-02-01 00:58:10.000000', 'temperatura', 750.0000, 'ºC'),
	(177591, 120, '2014-02-01 00:58:11.000000', 'temperatura', 472.0000, 'ºC'),
	(177592, 120, '2014-02-01 00:58:12.000000', 'temperatura', 112.0000, 'ºC'),
	(177593, 120, '2014-02-01 00:58:13.000000', 'temperatura', 341.0000, 'ºC'),
	(177594, 120, '2014-02-01 00:58:14.000000', 'temperatura', 173.0000, 'ºC'),
	(177595, 120, '2014-02-01 00:58:15.000000', 'temperatura', 1040.0000, 'ºC'),
	(177596, 120, '2014-02-01 00:58:16.000000', 'temperatura', 1082.0000, 'ºC'),
	(177597, 120, '2014-02-01 00:58:17.000000', 'temperatura', 1091.0000, 'ºC'),
	(177598, 120, '2014-02-01 00:58:18.000000', 'temperatura', 1009.0000, 'ºC'),
	(177599, 120, '2014-02-01 00:58:19.000000', 'temperatura', 573.0000, 'ºC'),
	(177600, 120, '2014-02-01 00:58:20.000000', 'temperatura', 1037.0000, 'ºC'),
	(177601, 120, '2014-02-01 00:58:21.000000', 'temperatura', 1069.0000, 'ºC'),
	(177602, 120, '2014-02-01 00:58:22.000000', 'temperatura', 1035.0000, 'ºC'),
	(177603, 120, '2014-02-01 00:58:23.000000', 'temperatura', 766.0000, 'ºC'),
	(177604, 120, '2014-02-01 00:58:24.000000', 'temperatura', 724.0000, 'ºC'),
	(177605, 120, '2014-02-01 00:58:25.000000', 'temperatura', 126.0000, 'ºC'),
	(177606, 120, '2014-02-01 00:58:26.000000', 'temperatura', 856.0000, 'ºC'),
	(177607, 120, '2014-02-01 00:58:27.000000', 'temperatura', 304.0000, 'ºC'),
	(177608, 120, '2014-02-01 00:58:28.000000', 'temperatura', 151.0000, 'ºC'),
	(177609, 120, '2014-02-01 00:58:29.000000', 'temperatura', 1046.0000, 'ºC'),
	(177610, 120, '2014-02-01 00:58:30.000000', 'temperatura', 1174.0000, 'ºC'),
	(177611, 120, '2014-02-01 00:58:31.000000', 'temperatura', 335.0000, 'ºC'),
	(177612, 120, '2014-02-01 00:58:32.000000', 'temperatura', 553.0000, 'ºC'),
	(177613, 120, '2014-02-01 00:58:33.000000', 'temperatura', 558.0000, 'ºC'),
	(177614, 120, '2014-02-01 00:58:34.000000', 'temperatura', 1135.0000, 'ºC'),
	(177615, 120, '2014-02-01 00:58:35.000000', 'temperatura', 399.0000, 'ºC'),
	(177616, 120, '2014-02-01 00:58:36.000000', 'temperatura', 991.0000, 'ºC'),
	(177617, 120, '2014-02-01 00:58:37.000000', 'temperatura', 157.0000, 'ºC'),
	(177618, 120, '2014-02-01 00:58:38.000000', 'temperatura', 215.0000, 'ºC'),
	(177619, 120, '2014-02-01 00:58:39.000000', 'temperatura', 602.0000, 'ºC'),
	(177620, 120, '2014-02-01 00:58:40.000000', 'temperatura', 1167.0000, 'ºC'),
	(177621, 120, '2014-02-01 00:58:41.000000', 'temperatura', 428.0000, 'ºC'),
	(177622, 120, '2014-02-01 00:58:42.000000', 'temperatura', 1039.0000, 'ºC'),
	(177623, 120, '2014-02-01 00:58:43.000000', 'temperatura', 312.0000, 'ºC'),
	(177624, 120, '2014-02-01 00:58:44.000000', 'temperatura', 846.0000, 'ºC'),
	(177625, 120, '2014-02-01 00:58:45.000000', 'temperatura', 892.0000, 'ºC'),
	(177626, 120, '2014-02-01 00:58:46.000000', 'temperatura', 725.0000, 'ºC'),
	(177627, 120, '2014-02-01 00:58:47.000000', 'temperatura', 948.0000, 'ºC'),
	(177628, 120, '2014-02-01 00:58:48.000000', 'temperatura', 164.0000, 'ºC'),
	(177629, 120, '2014-02-01 00:58:49.000000', 'temperatura', 379.0000, 'ºC'),
	(177630, 120, '2014-02-01 00:58:50.000000', 'temperatura', 204.0000, 'ºC'),
	(177631, 120, '2014-02-01 00:58:51.000000', 'temperatura', 1081.0000, 'ºC'),
	(177632, 120, '2014-02-01 00:58:52.000000', 'temperatura', 1195.0000, 'ºC'),
	(177633, 120, '2014-02-01 00:58:53.000000', 'temperatura', 334.0000, 'ºC'),
	(177634, 120, '2014-02-01 00:58:54.000000', 'temperatura', 484.0000, 'ºC'),
	(177635, 120, '2014-02-01 00:58:55.000000', 'temperatura', 219.0000, 'ºC'),
	(177636, 120, '2014-02-01 00:58:56.000000', 'temperatura', 845.0000, 'ºC'),
	(177637, 120, '2014-02-01 00:58:57.000000', 'temperatura', 1167.0000, 'ºC'),
	(177638, 120, '2014-02-01 00:58:58.000000', 'temperatura', 903.0000, 'ºC'),
	(177639, 120, '2014-02-01 00:58:59.000000', 'temperatura', 1012.0000, 'ºC'),
	(177640, 120, '2014-02-01 00:59:00.000000', 'temperatura', 1152.0000, 'ºC'),
	(177641, 120, '2014-02-01 00:59:01.000000', 'temperatura', 323.0000, 'ºC'),
	(177642, 120, '2014-02-01 00:59:02.000000', 'temperatura', 560.0000, 'ºC'),
	(177643, 120, '2014-02-01 00:59:03.000000', 'temperatura', 630.0000, 'ºC'),
	(177644, 120, '2014-02-01 00:59:04.000000', 'temperatura', 271.0000, 'ºC'),
	(177645, 120, '2014-02-01 00:59:05.000000', 'temperatura', 667.0000, 'ºC'),
	(177646, 120, '2014-02-01 00:59:06.000000', 'temperatura', 121.0000, 'ºC'),
	(177647, 120, '2014-02-01 00:59:07.000000', 'temperatura', 1004.0000, 'ºC'),
	(177648, 120, '2014-02-01 00:59:08.000000', 'temperatura', 1059.0000, 'ºC'),
	(177649, 120, '2014-02-01 00:59:09.000000', 'temperatura', 1084.0000, 'ºC'),
	(177650, 120, '2014-02-01 00:59:10.000000', 'temperatura', 1045.0000, 'ºC'),
	(177651, 120, '2014-02-01 00:59:11.000000', 'temperatura', 770.0000, 'ºC'),
	(177652, 120, '2014-02-01 00:59:12.000000', 'temperatura', 717.0000, 'ºC'),
	(177653, 120, '2014-02-01 00:59:13.000000', 'temperatura', 77.0000, 'ºC'),
	(177654, 120, '2014-02-01 00:59:14.000000', 'temperatura', 633.0000, 'ºC'),
	(177655, 120, '2014-02-01 00:59:15.000000', 'temperatura', 535.0000, 'ºC'),
	(177656, 120, '2014-02-01 00:59:16.000000', 'temperatura', 775.0000, 'ºC'),
	(177657, 120, '2014-02-01 00:59:17.000000', 'temperatura', 1070.0000, 'ºC'),
	(177658, 120, '2014-02-01 00:59:18.000000', 'temperatura', 626.0000, 'ºC'),
	(177659, 120, '2014-02-01 00:59:19.000000', 'temperatura', 1121.0000, 'ºC'),
	(177660, 120, '2014-02-01 00:59:20.000000', 'temperatura', 127.0000, 'ºC'),
	(177661, 120, '2014-02-01 00:59:21.000000', 'temperatura', 872.0000, 'ºC'),
	(177662, 120, '2014-02-01 00:59:22.000000', 'temperatura', 379.0000, 'ºC'),
	(177663, 120, '2014-02-01 00:59:23.000000', 'temperatura', 479.0000, 'ºC'),
	(177664, 120, '2014-02-01 00:59:24.000000', 'temperatura', 61.0000, 'ºC'),
	(177665, 120, '2014-02-01 00:59:25.000000', 'temperatura', 67.0000, 'ºC'),
	(177666, 120, '2014-02-01 00:59:26.000000', 'temperatura', 152.0000, 'ºC'),
	(177667, 120, '2014-02-01 00:59:27.000000', 'temperatura', 562.0000, 'ºC'),
	(177668, 120, '2014-02-01 00:59:28.000000', 'temperatura', 1154.0000, 'ºC'),
	(177669, 120, '2014-02-01 00:59:29.000000', 'temperatura', 483.0000, 'ºC'),
	(177670, 120, '2014-02-01 00:59:30.000000', 'temperatura', 155.0000, 'ºC'),
	(177671, 120, '2014-02-01 00:59:31.000000', 'temperatura', 527.0000, 'ºC'),
	(177672, 120, '2014-02-01 00:59:32.000000', 'temperatura', 969.0000, 'ºC'),
	(177673, 120, '2014-02-01 00:59:33.000000', 'temperatura', 866.0000, 'ºC'),
	(177674, 120, '2014-02-01 00:59:34.000000', 'temperatura', 225.0000, 'ºC'),
	(177675, 120, '2014-02-01 00:59:35.000000', 'temperatura', 924.0000, 'ºC'),
	(177676, 120, '2014-02-01 00:59:36.000000', 'temperatura', 347.0000, 'ºC'),
	(177677, 120, '2014-02-01 00:59:37.000000', 'temperatura', 162.0000, 'ºC'),
	(177678, 120, '2014-02-01 00:59:38.000000', 'temperatura', 969.0000, 'ºC'),
	(177679, 120, '2014-02-01 00:59:39.000000', 'temperatura', 759.0000, 'ºC'),
	(177680, 120, '2014-02-01 00:59:40.000000', 'temperatura', 891.0000, 'ºC'),
	(177681, 120, '2014-02-01 00:59:41.000000', 'temperatura', 978.0000, 'ºC'),
	(177682, 120, '2014-02-01 00:59:42.000000', 'temperatura', 1018.0000, 'ºC'),
	(177683, 120, '2014-02-01 00:59:43.000000', 'temperatura', 958.0000, 'ºC'),
	(177684, 120, '2014-02-01 00:59:44.000000', 'temperatura', 535.0000, 'ºC'),
	(177685, 120, '2014-02-01 00:59:45.000000', 'temperatura', 1000.0000, 'ºC'),
	(177686, 120, '2014-02-01 00:59:46.000000', 'temperatura', 998.0000, 'ºC'),
	(177687, 120, '2014-02-01 00:59:47.000000', 'temperatura', 792.0000, 'ºC'),
	(177688, 120, '2014-02-01 00:59:48.000000', 'temperatura', 963.0000, 'ºC'),
	(177689, 120, '2014-02-01 00:59:49.000000', 'temperatura', 42.0000, 'ºC'),
	(177690, 120, '2014-02-01 00:59:50.000000', 'temperatura', 920.0000, 'ºC'),
	(177691, 120, '2014-02-01 00:59:51.000000', 'temperatura', 875.0000, 'ºC'),
	(177692, 120, '2014-02-01 00:59:52.000000', 'temperatura', 414.0000, 'ºC'),
	(177693, 120, '2014-02-01 00:59:53.000000', 'temperatura', 646.0000, 'ºC'),
	(177694, 120, '2014-02-01 00:59:54.000000', 'temperatura', 788.0000, 'ºC'),
	(177695, 120, '2014-02-01 00:59:55.000000', 'temperatura', 803.0000, 'ºC'),
	(177696, 120, '2014-02-01 00:59:56.000000', 'temperatura', 451.0000, 'ºC'),
	(177697, 120, '2014-02-01 00:59:57.000000', 'temperatura', 1045.0000, 'ºC'),
	(177698, 120, '2014-02-01 00:59:58.000000', 'temperatura', 273.0000, 'ºC'),
	(177699, 120, '2014-02-01 00:59:59.000000', 'temperatura', 632.0000, 'ºC'),
	(177700, 120, '2014-02-01 01:00:00.000000', 'temperatura', 1139.0000, 'ºC'),
	(177701, 120, '2014-02-01 01:00:01.000000', 'temperatura', 200.0000, 'ºC'),
	(177702, 120, '2014-02-01 01:00:02.000000', 'temperatura', 1183.0000, 'ºC'),
	(177703, 120, '2014-02-01 01:00:03.000000', 'temperatura', 515.0000, 'ºC'),
	(177704, 120, '2014-02-01 01:00:04.000000', 'temperatura', 228.0000, 'ºC'),
	(177705, 120, '2014-02-01 01:00:05.000000', 'temperatura', 793.0000, 'ºC'),
	(177706, 120, '2014-02-01 01:00:06.000000', 'temperatura', 883.0000, 'ºC'),
	(177707, 120, '2014-02-01 01:00:07.000000', 'temperatura', 838.0000, 'ºC'),
	(177708, 120, '2014-02-01 01:00:08.000000', 'temperatura', 341.0000, 'ºC'),
	(177709, 120, '2014-02-01 01:00:09.000000', 'temperatura', 393.0000, 'ºC'),
	(177710, 120, '2014-02-01 01:00:10.000000', 'temperatura', 940.0000, 'ºC'),
	(177711, 120, '2014-02-01 01:00:11.000000', 'temperatura', 1123.0000, 'ºC'),
	(177712, 120, '2014-02-01 01:00:12.000000', 'temperatura', 395.0000, 'ºC'),
	(177713, 120, '2014-02-01 01:00:13.000000', 'temperatura', 1008.0000, 'ºC'),
	(177714, 120, '2014-02-01 01:00:14.000000', 'temperatura', 254.0000, 'ºC'),
	(177715, 120, '2014-02-01 01:00:15.000000', 'temperatura', 649.0000, 'ºC'),
	(177716, 120, '2014-02-01 01:00:16.000000', 'temperatura', 81.0000, 'ºC'),
	(177717, 120, '2014-02-01 01:00:17.000000', 'temperatura', 859.0000, 'ºC'),
	(177718, 120, '2014-02-01 01:00:18.000000', 'temperatura', 451.0000, 'ºC'),
	(177719, 120, '2014-02-01 01:00:19.000000', 'temperatura', 879.0000, 'ºC'),
	(177720, 120, '2014-02-01 01:00:20.000000', 'temperatura', 642.0000, 'ºC'),
	(177721, 120, '2014-02-01 01:00:21.000000', 'temperatura', 574.0000, 'ºC'),
	(177722, 120, '2014-02-01 01:00:22.000000', 'temperatura', 943.0000, 'ºC'),
	(177723, 120, '2014-02-01 01:00:23.000000', 'temperatura', 593.0000, 'ºC'),
	(177724, 120, '2014-02-01 01:00:24.000000', 'temperatura', 137.0000, 'ºC'),
	(177725, 120, '2014-02-01 01:00:25.000000', 'temperatura', 107.0000, 'ºC'),
	(177726, 120, '2014-02-01 01:00:26.000000', 'temperatura', 126.0000, 'ºC'),
	(177727, 120, '2014-02-01 01:00:27.000000', 'temperatura', 309.0000, 'ºC'),
	(177728, 120, '2014-02-01 01:00:28.000000', 'temperatura', 1169.0000, 'ºC'),
	(177729, 120, '2014-02-01 01:00:29.000000', 'temperatura', 118.0000, 'ºC'),
	(177730, 120, '2014-02-01 01:00:30.000000', 'temperatura', 683.0000, 'ºC'),
	(177731, 120, '2014-02-01 01:00:31.000000', 'temperatura', 663.0000, 'ºC'),
	(177732, 120, '2014-02-01 01:00:32.000000', 'temperatura', 68.0000, 'ºC'),
	(177733, 120, '2014-02-01 01:00:33.000000', 'temperatura', 748.0000, 'ºC'),
	(177734, 120, '2014-02-01 01:00:34.000000', 'temperatura', 1137.0000, 'ºC'),
	(177735, 120, '2014-02-01 01:00:35.000000', 'temperatura', 1041.0000, 'ºC'),
	(177736, 120, '2014-02-01 01:00:36.000000', 'temperatura', 594.0000, 'ºC'),
	(177737, 120, '2014-02-01 01:00:37.000000', 'temperatura', 1047.0000, 'ºC'),
	(177738, 120, '2014-02-01 01:00:38.000000', 'temperatura', 1054.0000, 'ºC'),
	(177739, 120, '2014-02-01 01:00:39.000000', 'temperatura', 931.0000, 'ºC'),
	(177740, 120, '2014-02-01 01:00:40.000000', 'temperatura', 294.0000, 'ºC'),
	(177741, 120, '2014-02-01 01:00:41.000000', 'temperatura', 1077.0000, 'ºC'),
	(177742, 120, '2014-02-01 01:00:42.000000', 'temperatura', 904.0000, 'ºC'),
	(177743, 120, '2014-02-01 01:00:43.000000', 'temperatura', 88.0000, 'ºC'),
	(177744, 120, '2014-02-01 01:00:44.000000', 'temperatura', 129.0000, 'ºC'),
	(177745, 120, '2014-02-01 01:00:45.000000', 'temperatura', 382.0000, 'ºC'),
	(177746, 120, '2014-02-01 01:00:46.000000', 'temperatura', 325.0000, 'ºC'),
	(177747, 120, '2014-02-01 01:00:47.000000', 'temperatura', 477.0000, 'ºC'),
	(177748, 120, '2014-02-01 01:00:48.000000', 'temperatura', 211.0000, 'ºC'),
	(177749, 120, '2014-02-01 01:00:49.000000', 'temperatura', 826.0000, 'ºC'),
	(177750, 120, '2014-02-01 01:00:50.000000', 'temperatura', 1097.0000, 'ºC'),
	(177751, 120, '2014-02-01 01:00:51.000000', 'temperatura', 606.0000, 'ºC'),
	(177752, 120, '2014-02-01 01:00:52.000000', 'temperatura', 940.0000, 'ºC'),
	(177753, 120, '2014-02-01 01:00:53.000000', 'temperatura', 482.0000, 'ºC'),
	(177754, 120, '2014-02-01 01:00:54.000000', 'temperatura', 790.0000, 'ºC'),
	(177755, 120, '2014-02-01 01:00:55.000000', 'temperatura', 107.0000, 'ºC'),
	(177756, 120, '2014-02-01 01:00:56.000000', 'temperatura', 563.0000, 'ºC'),
	(177757, 120, '2014-02-01 01:00:57.000000', 'temperatura', 96.0000, 'ºC'),
	(177758, 120, '2014-02-01 01:00:58.000000', 'temperatura', 1193.0000, 'ºC'),
	(177759, 120, '2014-02-01 01:00:59.000000', 'temperatura', 875.0000, 'ºC'),
	(177760, 120, '2014-02-01 01:01:00.000000', 'temperatura', 799.0000, 'ºC'),
	(177761, 120, '2014-02-01 01:01:01.000000', 'temperatura', 168.0000, 'ºC'),
	(177762, 120, '2014-02-01 01:01:02.000000', 'temperatura', 845.0000, 'ºC'),
	(177763, 120, '2014-02-01 01:01:03.000000', 'temperatura', 123.0000, 'ºC'),
	(177764, 120, '2014-02-01 01:01:04.000000', 'temperatura', 480.0000, 'ºC'),
	(177765, 120, '2014-02-01 01:01:05.000000', 'temperatura', 830.0000, 'ºC'),
	(177766, 120, '2014-02-01 01:01:06.000000', 'temperatura', 310.0000, 'ºC'),
	(177767, 120, '2014-02-01 01:01:07.000000', 'temperatura', 263.0000, 'ºC'),
	(177768, 120, '2014-02-01 01:01:08.000000', 'temperatura', 385.0000, 'ºC'),
	(177769, 120, '2014-02-01 01:01:09.000000', 'temperatura', 1138.0000, 'ºC'),
	(177770, 120, '2014-02-01 01:01:10.000000', 'temperatura', 934.0000, 'ºC'),
	(177771, 120, '2014-02-01 01:01:11.000000', 'temperatura', 57.0000, 'ºC'),
	(177772, 120, '2014-02-01 01:01:12.000000', 'temperatura', 1085.0000, 'ºC'),
	(177773, 120, '2014-02-01 01:01:13.000000', 'temperatura', 454.0000, 'ºC'),
	(177774, 120, '2014-02-01 01:01:14.000000', 'temperatura', 215.0000, 'ºC'),
	(177775, 120, '2014-02-01 01:01:15.000000', 'temperatura', 915.0000, 'ºC'),
	(177776, 120, '2014-02-01 01:01:16.000000', 'temperatura', 331.0000, 'ºC'),
	(177777, 120, '2014-02-01 01:01:17.000000', 'temperatura', 109.0000, 'ºC'),
	(177778, 120, '2014-02-01 01:01:18.000000', 'temperatura', 754.0000, 'ºC'),
	(177779, 120, '2014-02-01 01:01:19.000000', 'temperatura', 1043.0000, 'ºC'),
	(177780, 120, '2014-02-01 01:01:20.000000', 'temperatura', 555.0000, 'ºC'),
	(177781, 120, '2014-02-01 01:01:21.000000', 'temperatura', 844.0000, 'ºC'),
	(177782, 120, '2014-02-01 01:01:22.000000', 'temperatura', 156.0000, 'ºC'),
	(177783, 120, '2014-02-01 01:01:23.000000', 'temperatura', 648.0000, 'ºC'),
	(177784, 120, '2014-02-01 01:01:24.000000', 'temperatura', 373.0000, 'ºC'),
	(177785, 120, '2014-02-01 01:01:25.000000', 'temperatura', 1122.0000, 'ºC'),
	(177786, 120, '2014-02-01 01:01:26.000000', 'temperatura', 891.0000, 'ºC'),
	(177787, 120, '2014-02-01 01:01:27.000000', 'temperatura', 1091.0000, 'ºC'),
	(177788, 120, '2014-02-01 01:01:28.000000', 'temperatura', 380.0000, 'ºC'),
	(177789, 120, '2014-02-01 01:01:29.000000', 'temperatura', 1030.0000, 'ºC'),
	(177790, 120, '2014-02-01 01:01:30.000000', 'temperatura', 409.0000, 'ºC'),
	(177791, 120, '2014-02-01 01:01:31.000000', 'temperatura', 155.0000, 'ºC'),
	(177792, 120, '2014-02-01 01:01:32.000000', 'temperatura', 748.0000, 'ºC'),
	(177793, 120, '2014-02-01 01:01:33.000000', 'temperatura', 875.0000, 'ºC'),
	(177794, 120, '2014-02-01 01:01:34.000000', 'temperatura', 932.0000, 'ºC'),
	(177795, 120, '2014-02-01 01:01:35.000000', 'temperatura', 834.0000, 'ºC'),
	(177796, 120, '2014-02-01 01:01:36.000000', 'temperatura', 177.0000, 'ºC'),
	(177797, 120, '2014-02-01 01:01:37.000000', 'temperatura', 784.0000, 'ºC'),
	(177798, 120, '2014-02-01 01:01:38.000000', 'temperatura', 991.0000, 'ºC'),
	(177799, 120, '2014-02-01 01:01:39.000000', 'temperatura', 200.0000, 'ºC'),
	(177800, 120, '2014-02-01 01:01:40.000000', 'temperatura', 429.0000, 'ºC'),
	(177801, 120, '2014-02-01 01:01:41.000000', 'temperatura', 345.0000, 'ºC'),
	(177802, 120, '2014-02-01 01:01:42.000000', 'temperatura', 439.0000, 'ºC'),
	(177803, 120, '2014-02-01 01:01:43.000000', 'temperatura', 1162.0000, 'ºC'),
	(177804, 120, '2014-02-01 01:01:44.000000', 'temperatura', 892.0000, 'ºC'),
	(177805, 120, '2014-02-01 01:01:45.000000', 'temperatura', 974.0000, 'ºC'),
	(177806, 120, '2014-02-01 01:01:46.000000', 'temperatura', 995.0000, 'ºC'),
	(177807, 120, '2014-02-01 01:01:47.000000', 'temperatura', 852.0000, 'ºC'),
	(177808, 120, '2014-02-01 01:01:48.000000', 'temperatura', 78.0000, 'ºC'),
	(177809, 120, '2014-02-01 01:01:49.000000', 'temperatura', 232.0000, 'ºC'),
	(177810, 120, '2014-02-01 01:01:50.000000', 'temperatura', 928.0000, 'ºC'),
	(177811, 120, '2014-02-01 01:01:51.000000', 'temperatura', 344.0000, 'ºC'),
	(177812, 120, '2014-02-01 01:01:52.000000', 'temperatura', 137.0000, 'ºC'),
	(177813, 120, '2014-02-01 01:01:53.000000', 'temperatura', 851.0000, 'ºC'),
	(177814, 120, '2014-02-01 01:01:54.000000', 'temperatura', 247.0000, 'ºC'),
	(177815, 120, '2014-02-01 01:01:55.000000', 'temperatura', 1083.0000, 'ºC'),
	(177816, 120, '2014-02-01 01:01:56.000000', 'temperatura', 1073.0000, 'ºC'),
	(177817, 120, '2014-02-01 01:01:57.000000', 'temperatura', 917.0000, 'ºC'),
	(177818, 120, '2014-02-01 01:01:58.000000', 'temperatura', 169.0000, 'ºC'),
	(177819, 120, '2014-02-01 01:01:59.000000', 'temperatura', 491.0000, 'ºC'),
	(177820, 120, '2014-02-01 01:02:00.000000', 'temperatura', 749.0000, 'ºC'),
	(177821, 120, '2014-02-01 01:02:01.000000', 'temperatura', 1073.0000, 'ºC'),
	(177822, 120, '2014-02-01 01:02:02.000000', 'temperatura', 720.0000, 'ºC'),
	(177823, 120, '2014-02-01 01:02:03.000000', 'temperatura', 379.0000, 'ºC'),
	(177824, 120, '2014-02-01 01:02:04.000000', 'temperatura', 937.0000, 'ºC'),
	(177825, 120, '2014-02-01 01:02:05.000000', 'temperatura', 1146.0000, 'ºC'),
	(177826, 120, '2014-02-01 01:02:06.000000', 'temperatura', 522.0000, 'ºC'),
	(177827, 120, '2014-02-01 01:02:07.000000', 'temperatura', 372.0000, 'ºC'),
	(177828, 120, '2014-02-01 01:02:08.000000', 'temperatura', 293.0000, 'ºC'),
	(177829, 120, '2014-02-01 01:02:09.000000', 'temperatura', 348.0000, 'ºC'),
	(177830, 120, '2014-02-01 01:02:10.000000', 'temperatura', 865.0000, 'ºC'),
	(177831, 120, '2014-02-01 01:02:11.000000', 'temperatura', 878.0000, 'ºC'),
	(177832, 120, '2014-02-01 01:02:12.000000', 'temperatura', 599.0000, 'ºC'),
	(177833, 120, '2014-02-01 01:02:13.000000', 'temperatura', 360.0000, 'ºC'),
	(177834, 120, '2014-02-01 01:02:14.000000', 'temperatura', 3.0000, 'ºC'),
	(177835, 120, '2014-02-01 01:02:15.000000', 'temperatura', 135.0000, 'ºC'),
	(177836, 120, '2014-02-01 01:02:16.000000', 'temperatura', 668.0000, 'ºC'),
	(177837, 120, '2014-02-01 01:02:17.000000', 'temperatura', 536.0000, 'ºC'),
	(177838, 120, '2014-02-01 01:02:18.000000', 'temperatura', 676.0000, 'ºC'),
	(177839, 120, '2014-02-01 01:02:19.000000', 'temperatura', 572.0000, 'ºC'),
	(177840, 120, '2014-02-01 01:02:20.000000', 'temperatura', 833.0000, 'ºC'),
	(177841, 120, '2014-02-01 01:02:21.000000', 'temperatura', 49.0000, 'ºC'),
	(177842, 120, '2014-02-01 01:02:22.000000', 'temperatura', 145.0000, 'ºC'),
	(177843, 120, '2014-02-01 01:02:23.000000', 'temperatura', 579.0000, 'ºC'),
	(177844, 120, '2014-02-01 01:02:24.000000', 'temperatura', 59.0000, 'ºC'),
	(177845, 120, '2014-02-01 01:02:25.000000', 'temperatura', 960.0000, 'ºC'),
	(177846, 120, '2014-02-01 01:02:26.000000', 'temperatura', 1021.0000, 'ºC'),
	(177847, 120, '2014-02-01 01:02:27.000000', 'temperatura', 1028.0000, 'ºC'),
	(177848, 120, '2014-02-01 01:02:28.000000', 'temperatura', 879.0000, 'ºC'),
	(177849, 120, '2014-02-01 01:02:29.000000', 'temperatura', 109.0000, 'ºC'),
	(177850, 120, '2014-02-01 01:02:30.000000', 'temperatura', 308.0000, 'ºC'),
	(177851, 120, '2014-02-01 01:02:31.000000', 'temperatura', 12.0000, 'ºC'),
	(177852, 120, '2014-02-01 01:02:32.000000', 'temperatura', 340.0000, 'ºC'),
	(177853, 120, '2014-02-01 01:02:33.000000', 'temperatura', 461.0000, 'ºC'),
	(177854, 120, '2014-02-01 01:02:34.000000', 'temperatura', 88.0000, 'ºC'),
	(177855, 120, '2014-02-01 01:02:35.000000', 'temperatura', 255.0000, 'ºC'),
	(177856, 120, '2014-02-01 01:02:36.000000', 'temperatura', 1012.0000, 'ºC'),
	(177857, 120, '2014-02-01 01:02:37.000000', 'temperatura', 696.0000, 'ºC'),
	(177858, 120, '2014-02-01 01:02:38.000000', 'temperatura', 445.0000, 'ºC'),
	(177859, 120, '2014-02-01 01:02:39.000000', 'temperatura', 137.0000, 'ºC'),
	(177860, 120, '2014-02-01 01:02:40.000000', 'temperatura', 552.0000, 'ºC'),
	(177861, 120, '2014-02-01 01:02:41.000000', 'temperatura', 1147.0000, 'ºC'),
	(177862, 120, '2014-02-01 01:02:42.000000', 'temperatura', 483.0000, 'ºC'),
	(177863, 120, '2014-02-01 01:02:43.000000', 'temperatura', 171.0000, 'ºC'),
	(177864, 120, '2014-02-01 01:02:44.000000', 'temperatura', 609.0000, 'ºC'),
	(177865, 120, '2014-02-01 01:02:45.000000', 'temperatura', 131.0000, 'ºC'),
	(177866, 120, '2014-02-01 01:02:46.000000', 'temperatura', 30.0000, 'ºC'),
	(177867, 120, '2014-02-01 01:02:47.000000', 'temperatura', 956.0000, 'ºC'),
	(177868, 120, '2014-02-01 01:02:48.000000', 'temperatura', 1090.0000, 'ºC'),
	(177869, 120, '2014-02-01 01:02:49.000000', 'temperatura', 185.0000, 'ºC'),
	(177870, 120, '2014-02-01 01:02:50.000000', 'temperatura', 54.0000, 'ºC'),
	(177871, 120, '2014-02-01 01:02:51.000000', 'temperatura', 917.0000, 'ºC'),
	(177872, 120, '2014-02-01 01:02:52.000000', 'temperatura', 822.0000, 'ºC'),
	(177873, 120, '2014-02-01 01:02:53.000000', 'temperatura', 162.0000, 'ºC'),
	(177874, 120, '2014-02-01 01:02:54.000000', 'temperatura', 741.0000, 'ºC'),
	(177875, 120, '2014-02-01 01:02:55.000000', 'temperatura', 823.0000, 'ºC'),
	(177876, 120, '2014-02-01 01:02:56.000000', 'temperatura', 690.0000, 'ºC'),
	(177877, 120, '2014-02-01 01:02:57.000000', 'temperatura', 983.0000, 'ºC'),
	(177878, 120, '2014-02-01 01:02:58.000000', 'temperatura', 443.0000, 'ºC'),
	(177879, 120, '2014-02-01 01:02:59.000000', 'temperatura', 470.0000, 'ºC'),
	(177880, 120, '2014-02-01 01:03:00.000000', 'temperatura', 1019.0000, 'ºC'),
	(177881, 120, '2014-02-01 01:03:01.000000', 'temperatura', 87.0000, 'ºC'),
	(177882, 120, '2014-02-01 01:03:02.000000', 'temperatura', 979.0000, 'ºC'),
	(177883, 120, '2014-02-01 01:03:03.000000', 'temperatura', 1033.0000, 'ºC'),
	(177884, 120, '2014-02-01 01:03:04.000000', 'temperatura', 1030.0000, 'ºC'),
	(177885, 120, '2014-02-01 01:03:05.000000', 'temperatura', 852.0000, 'ºC'),
	(177886, 120, '2014-02-01 01:03:06.000000', 'temperatura', 1172.0000, 'ºC'),
	(177887, 120, '2014-02-01 01:03:07.000000', 'temperatura', 901.0000, 'ºC'),
	(177888, 120, '2014-02-01 01:03:08.000000', 'temperatura', 990.0000, 'ºC'),
	(177889, 120, '2014-02-01 01:03:09.000000', 'temperatura', 1047.0000, 'ºC'),
	(177890, 120, '2014-02-01 01:03:10.000000', 'temperatura', 1068.0000, 'ºC'),
	(177891, 120, '2014-02-01 01:03:11.000000', 'temperatura', 1000.0000, 'ºC'),
	(177892, 120, '2014-02-01 01:03:12.000000', 'temperatura', 595.0000, 'ºC'),
	(177893, 120, '2014-02-01 01:03:13.000000', 'temperatura', 1175.0000, 'ºC'),
	(177894, 120, '2014-02-01 01:03:14.000000', 'temperatura', 489.0000, 'ºC'),
	(177895, 120, '2014-02-01 01:03:15.000000', 'temperatura', 121.0000, 'ºC'),
	(177896, 120, '2014-02-01 01:03:16.000000', 'temperatura', 341.0000, 'ºC'),
	(177897, 120, '2014-02-01 01:03:17.000000', 'temperatura', 140.0000, 'ºC'),
	(177898, 120, '2014-02-01 01:03:18.000000', 'temperatura', 878.0000, 'ºC'),
	(177899, 120, '2014-02-01 01:03:19.000000', 'temperatura', 369.0000, 'ºC'),
	(177900, 120, '2014-02-01 01:03:20.000000', 'temperatura', 413.0000, 'ºC'),
	(177901, 120, '2014-02-01 01:03:21.000000', 'temperatura', 957.0000, 'ºC'),
	(177902, 120, '2014-02-01 01:03:22.000000', 'temperatura', 1146.0000, 'ºC'),
	(177903, 120, '2014-02-01 01:03:23.000000', 'temperatura', 462.0000, 'ºC'),
	(177904, 120, '2014-02-01 01:03:24.000000', 'temperatura', 70.0000, 'ºC'),
	(177905, 120, '2014-02-01 01:03:25.000000', 'temperatura', 165.0000, 'ºC'),
	(177906, 120, '2014-02-01 01:03:26.000000', 'temperatura', 616.0000, 'ºC'),
	(177907, 120, '2014-02-01 01:03:27.000000', 'temperatura', 187.0000, 'ºC'),
	(177908, 120, '2014-02-01 01:03:28.000000', 'temperatura', 288.0000, 'ºC'),
	(177909, 120, '2014-02-01 01:03:29.000000', 'temperatura', 879.0000, 'ºC'),
	(177910, 120, '2014-02-01 01:03:30.000000', 'temperatura', 1133.0000, 'ºC'),
	(177911, 120, '2014-02-01 01:03:31.000000', 'temperatura', 627.0000, 'ºC'),
	(177912, 120, '2014-02-01 01:03:32.000000', 'temperatura', 938.0000, 'ºC'),
	(177913, 120, '2014-02-01 01:03:33.000000', 'temperatura', 408.0000, 'ºC'),
	(177914, 120, '2014-02-01 01:03:34.000000', 'temperatura', 429.0000, 'ºC'),
	(177915, 120, '2014-02-01 01:03:35.000000', 'temperatura', 918.0000, 'ºC'),
	(177916, 120, '2014-02-01 01:03:36.000000', 'temperatura', 907.0000, 'ºC'),
	(177917, 120, '2014-02-01 01:03:37.000000', 'temperatura', 579.0000, 'ºC'),
	(177918, 120, '2014-02-01 01:03:38.000000', 'temperatura', 177.0000, 'ºC'),
	(177919, 120, '2014-02-01 01:03:39.000000', 'temperatura', 345.0000, 'ºC'),
	(177920, 120, '2014-02-01 01:03:40.000000', 'temperatura', 1197.0000, 'ºC'),
	(177921, 120, '2014-02-01 01:03:41.000000', 'temperatura', 152.0000, 'ºC'),
	(177922, 120, '2014-02-01 01:03:42.000000', 'temperatura', 766.0000, 'ºC'),
	(177923, 120, '2014-02-01 01:03:43.000000', 'temperatura', 975.0000, 'ºC'),
	(177924, 120, '2014-02-01 01:03:44.000000', 'temperatura', 180.0000, 'ºC'),
	(177925, 120, '2014-02-01 01:03:45.000000', 'temperatura', 372.0000, 'ºC'),
	(177926, 120, '2014-02-01 01:03:46.000000', 'temperatura', 123.0000, 'ºC'),
	(177927, 120, '2014-02-01 01:03:47.000000', 'temperatura', 697.0000, 'ºC'),
	(177928, 120, '2014-02-01 01:03:48.000000', 'temperatura', 720.0000, 'ºC'),
	(177929, 120, '2014-02-01 01:03:49.000000', 'temperatura', 307.0000, 'ºC'),
	(177930, 120, '2014-02-01 01:03:50.000000', 'temperatura', 575.0000, 'ºC'),
	(177931, 120, '2014-02-01 01:03:51.000000', 'temperatura', 755.0000, 'ºC'),
	(177932, 120, '2014-02-01 01:03:52.000000', 'temperatura', 851.0000, 'ºC'),
	(177933, 120, '2014-02-01 01:03:53.000000', 'temperatura', 791.0000, 'ºC'),
	(177934, 120, '2014-02-01 01:03:54.000000', 'temperatura', 201.0000, 'ºC'),
	(177935, 120, '2014-02-01 01:03:55.000000', 'temperatura', 1033.0000, 'ºC'),
	(177936, 120, '2014-02-01 01:03:56.000000', 'temperatura', 965.0000, 'ºC'),
	(177937, 120, '2014-02-01 01:03:57.000000', 'temperatura', 523.0000, 'ºC'),
	(177938, 120, '2014-02-01 01:03:58.000000', 'temperatura', 922.0000, 'ºC'),
	(177939, 120, '2014-02-01 01:03:59.000000', 'temperatura', 642.0000, 'ºC'),
	(177940, 120, '2014-02-01 01:04:00.000000', 'temperatura', 442.0000, 'ºC'),
	(177941, 120, '2014-02-01 01:04:01.000000', 'temperatura', 286.0000, 'ºC'),
	(177942, 120, '2014-02-01 01:04:02.000000', 'temperatura', 104.0000, 'ºC'),
	(177943, 120, '2014-02-01 01:04:03.000000', 'temperatura', 861.0000, 'ºC'),
	(177944, 120, '2014-02-01 01:04:04.000000', 'temperatura', 396.0000, 'ºC'),
	(177945, 120, '2014-02-01 01:04:05.000000', 'temperatura', 597.0000, 'ºC'),
	(177946, 120, '2014-02-01 01:04:06.000000', 'temperatura', 598.0000, 'ºC'),
	(177947, 120, '2014-02-01 01:04:07.000000', 'temperatura', 1199.0000, 'ºC'),
	(177948, 120, '2014-02-01 01:04:08.000000', 'temperatura', 603.0000, 'ºC'),
	(177949, 120, '2014-02-01 01:04:09.000000', 'temperatura', 619.0000, 'ºC'),
	(177950, 120, '2014-02-01 01:04:10.000000', 'temperatura', 87.0000, 'ºC'),
	(177951, 120, '2014-02-01 01:04:11.000000', 'temperatura', 979.0000, 'ºC'),
	(177952, 120, '2014-02-01 01:04:12.000000', 'temperatura', 1035.0000, 'ºC'),
	(177953, 120, '2014-02-01 01:04:13.000000', 'temperatura', 1037.0000, 'ºC'),
	(177954, 120, '2014-02-01 01:04:14.000000', 'temperatura', 880.0000, 'ºC'),
	(177955, 120, '2014-02-01 01:04:15.000000', 'temperatura', 90.0000, 'ºC'),
	(177956, 120, '2014-02-01 01:04:16.000000', 'temperatura', 211.0000, 'ºC'),
	(177957, 120, '2014-02-01 01:04:17.000000', 'temperatura', 785.0000, 'ºC'),
	(177958, 120, '2014-02-01 01:04:18.000000', 'temperatura', 893.0000, 'ºC'),
	(177959, 120, '2014-02-01 01:04:19.000000', 'temperatura', 909.0000, 'ºC'),
	(177960, 120, '2014-02-01 01:04:20.000000', 'temperatura', 666.0000, 'ºC'),
	(177961, 120, '2014-02-01 01:04:21.000000', 'temperatura', 602.0000, 'ºC'),
	(177962, 120, '2014-02-01 01:04:22.000000', 'temperatura', 1016.0000, 'ºC'),
	(177963, 120, '2014-02-01 01:04:23.000000', 'temperatura', 874.0000, 'ºC'),
	(177964, 120, '2014-02-01 01:04:24.000000', 'temperatura', 123.0000, 'ºC'),
	(177965, 120, '2014-02-01 01:04:25.000000', 'temperatura', 391.0000, 'ºC'),
	(177966, 120, '2014-02-01 01:04:26.000000', 'temperatura', 387.0000, 'ºC'),
	(177967, 120, '2014-02-01 01:04:27.000000', 'temperatura', 761.0000, 'ºC'),
	(177968, 120, '2014-02-01 01:04:28.000000', 'temperatura', 245.0000, 'ºC'),
	(177969, 120, '2014-02-01 01:04:29.000000', 'temperatura', 145.0000, 'ºC'),
	(177970, 120, '2014-02-01 01:04:30.000000', 'temperatura', 1189.0000, 'ºC'),
	(177971, 120, '2014-02-01 01:04:31.000000', 'temperatura', 709.0000, 'ºC'),
	(177972, 120, '2014-02-01 01:04:32.000000', 'temperatura', 1180.0000, 'ºC'),
	(177973, 120, '2014-02-01 01:04:33.000000', 'temperatura', 173.0000, 'ºC'),
	(177974, 120, '2014-02-01 01:04:34.000000', 'temperatura', 924.0000, 'ºC'),
	(177975, 120, '2014-02-01 01:04:35.000000', 'temperatura', 504.0000, 'ºC'),
	(177976, 120, '2014-02-01 01:04:36.000000', 'temperatura', 946.0000, 'ºC'),
	(177977, 120, '2014-02-01 01:04:37.000000', 'temperatura', 819.0000, 'ºC'),
	(177978, 120, '2014-02-01 01:04:38.000000', 'temperatura', 59.0000, 'ºC'),
	(177979, 120, '2014-02-01 01:04:39.000000', 'temperatura', 236.0000, 'ºC'),
	(177980, 120, '2014-02-01 01:04:40.000000', 'temperatura', 1004.0000, 'ºC'),
	(177981, 120, '2014-02-01 01:04:41.000000', 'temperatura', 713.0000, 'ºC'),
	(177982, 120, '2014-02-01 01:04:42.000000', 'temperatura', 555.0000, 'ºC'),
	(177983, 120, '2014-02-01 01:04:43.000000', 'temperatura', 637.0000, 'ºC'),
	(177984, 120, '2014-02-01 01:04:44.000000', 'temperatura', 321.0000, 'ºC'),
	(177985, 120, '2014-02-01 01:04:45.000000', 'temperatura', 895.0000, 'ºC'),
	(177986, 120, '2014-02-01 01:04:46.000000', 'temperatura', 1111.0000, 'ºC'),
	(177987, 120, '2014-02-01 01:04:47.000000', 'temperatura', 472.0000, 'ºC'),
	(177988, 120, '2014-02-01 01:04:48.000000', 'temperatura', 225.0000, 'ºC'),
	(177989, 120, '2014-02-01 01:04:49.000000', 'temperatura', 910.0000, 'ºC'),
	(177990, 120, '2014-02-01 01:04:50.000000', 'temperatura', 275.0000, 'ºC'),
	(177991, 120, '2014-02-01 01:04:51.000000', 'temperatura', 1048.0000, 'ºC'),
	(177992, 120, '2014-02-01 01:04:52.000000', 'temperatura', 815.0000, 'ºC'),
	(177993, 120, '2014-02-01 01:04:53.000000', 'temperatura', 933.0000, 'ºC'),
	(177994, 120, '2014-02-01 01:04:54.000000', 'temperatura', 1017.0000, 'ºC'),
	(177995, 120, '2014-02-01 01:04:55.000000', 'temperatura', 1088.0000, 'ºC'),
	(177996, 120, '2014-02-01 01:04:56.000000', 'temperatura', 1188.0000, 'ºC'),
	(177997, 120, '2014-02-01 01:04:57.000000', 'temperatura', 277.0000, 'ºC'),
	(177998, 120, '2014-02-01 01:04:58.000000', 'temperatura', 221.0000, 'ºC'),
	(177999, 120, '2014-02-01 01:04:59.000000', 'temperatura', 275.0000, 'ºC'),
	(178000, 120, '2014-02-01 01:05:00.000000', 'temperatura', 711.0000, 'ºC'),
	(178001, 120, '2014-02-01 01:05:01.000000', 'temperatura', 331.0000, 'ºC'),
	(178002, 120, '2014-02-01 01:05:02.000000', 'temperatura', 723.0000, 'ºC'),
	(178003, 120, '2014-02-01 01:05:03.000000', 'temperatura', 224.0000, 'ºC'),
	(178004, 120, '2014-02-01 01:05:04.000000', 'temperatura', 152.0000, 'ºC'),
	(178005, 120, '2014-02-01 01:05:05.000000', 'temperatura', 89.0000, 'ºC'),
	(178006, 120, '2014-02-01 01:05:06.000000', 'temperatura', 1189.0000, 'ºC'),
	(178007, 120, '2014-02-01 01:05:07.000000', 'temperatura', 877.0000, 'ºC'),
	(178008, 120, '2014-02-01 01:05:08.000000', 'temperatura', 817.0000, 'ºC'),
	(178009, 120, '2014-02-01 01:05:09.000000', 'temperatura', 257.0000, 'ºC'),
	(178010, 120, '2014-02-01 01:05:10.000000', 'temperatura', 33.0000, 'ºC'),
	(178011, 120, '2014-02-01 01:05:11.000000', 'temperatura', 594.0000, 'ºC'),
	(178012, 120, '2014-02-01 01:05:12.000000', 'temperatura', 471.0000, 'ºC'),
	(178013, 120, '2014-02-01 01:05:13.000000', 'temperatura', 574.0000, 'ºC'),
	(178014, 120, '2014-02-01 01:05:14.000000', 'temperatura', 258.0000, 'ºC'),
	(178015, 120, '2014-02-01 01:05:15.000000', 'temperatura', 770.0000, 'ºC'),
	(178016, 120, '2014-02-01 01:05:16.000000', 'temperatura', 677.0000, 'ºC'),
	(178017, 120, '2014-02-01 01:05:17.000000', 'temperatura', 1073.0000, 'ºC'),
	(178018, 120, '2014-02-01 01:05:18.000000', 'temperatura', 933.0000, 'ºC'),
	(178019, 120, '2014-02-01 01:05:19.000000', 'temperatura', 250.0000, 'ºC'),
	(178020, 120, '2014-02-01 01:05:20.000000', 'temperatura', 851.0000, 'ºC'),
	(178021, 120, '2014-02-01 01:05:21.000000', 'temperatura', 1106.0000, 'ºC'),
	(178022, 120, '2014-02-01 01:05:22.000000', 'temperatura', 575.0000, 'ºC'),
	(178023, 120, '2014-02-01 01:05:23.000000', 'temperatura', 761.0000, 'ºC'),
	(178024, 120, '2014-02-01 01:05:24.000000', 'temperatura', 878.0000, 'ºC'),
	(178025, 120, '2014-02-01 01:05:25.000000', 'temperatura', 909.0000, 'ºC'),
	(178026, 120, '2014-02-01 01:05:26.000000', 'temperatura', 711.0000, 'ºC'),
	(178027, 120, '2014-02-01 01:05:27.000000', 'temperatura', 830.0000, 'ºC'),
	(178028, 120, '2014-02-01 01:05:28.000000', 'temperatura', 817.0000, 'ºC'),
	(178029, 120, '2014-02-01 01:05:29.000000', 'temperatura', 397.0000, 'ºC'),
	(178030, 120, '2014-02-01 01:05:30.000000', 'temperatura', 734.0000, 'ºC'),
	(178031, 120, '2014-02-01 01:05:31.000000', 'temperatura', 77.0000, 'ºC'),
	(178032, 120, '2014-02-01 01:05:32.000000', 'temperatura', 585.0000, 'ºC'),
	(178033, 120, '2014-02-01 01:05:33.000000', 'temperatura', 294.0000, 'ºC'),
	(178034, 120, '2014-02-01 01:05:34.000000', 'temperatura', 916.0000, 'ºC'),
	(178035, 120, '2014-02-01 01:05:35.000000', 'temperatura', 97.0000, 'ºC'),
	(178036, 120, '2014-02-01 01:05:36.000000', 'temperatura', 138.0000, 'ºC'),
	(178037, 120, '2014-02-01 01:05:37.000000', 'temperatura', 400.0000, 'ºC'),
	(178038, 120, '2014-02-01 01:05:38.000000', 'temperatura', 388.0000, 'ºC'),
	(178039, 120, '2014-02-01 01:05:39.000000', 'temperatura', 738.0000, 'ºC'),
	(178040, 120, '2014-02-01 01:05:40.000000', 'temperatura', 127.0000, 'ºC'),
	(178041, 120, '2014-02-01 01:05:41.000000', 'temperatura', 821.0000, 'ºC'),
	(178042, 120, '2014-02-01 01:05:42.000000', 'temperatura', 127.0000, 'ºC'),
	(178043, 120, '2014-02-01 01:05:43.000000', 'temperatura', 569.0000, 'ºC'),
	(178044, 120, '2014-02-01 01:05:44.000000', 'temperatura', 68.0000, 'ºC'),
	(178045, 120, '2014-02-01 01:05:45.000000', 'temperatura', 1031.0000, 'ºC'),
	(178046, 120, '2014-02-01 01:05:46.000000', 'temperatura', 152.0000, 'ºC'),
	(178047, 120, '2014-02-01 01:05:47.000000', 'temperatura', 68.0000, 'ºC'),
	(178048, 120, '2014-02-01 01:05:48.000000', 'temperatura', 1082.0000, 'ºC'),
	(178049, 120, '2014-02-01 01:05:49.000000', 'temperatura', 410.0000, 'ºC'),
	(178050, 120, '2014-02-01 01:05:50.000000', 'temperatura', 4.0000, 'ºC'),
	(178051, 120, '2014-02-01 01:05:51.000000', 'temperatura', 1190.0000, 'ºC'),
	(178052, 120, '2014-02-01 01:05:52.000000', 'temperatura', 1137.0000, 'ºC'),
	(178053, 120, '2014-02-01 01:05:53.000000', 'temperatura', 917.0000, 'ºC'),
	(178054, 120, '2014-02-01 01:05:54.000000', 'temperatura', 1176.0000, 'ºC'),
	(178055, 120, '2014-02-01 01:05:55.000000', 'temperatura', 729.0000, 'ºC'),
	(178056, 120, '2014-02-01 01:05:56.000000', 'temperatura', 118.0000, 'ºC'),
	(178057, 120, '2014-02-01 01:05:57.000000', 'temperatura', 801.0000, 'ºC'),
	(178058, 120, '2014-02-01 01:05:58.000000', 'temperatura', 54.0000, 'ºC'),
	(178059, 120, '2014-02-01 01:05:59.000000', 'temperatura', 268.0000, 'ºC'),
	(178060, 120, '2014-02-01 01:06:00.000000', 'temperatura', 1177.0000, 'ºC'),
	(178061, 120, '2014-02-01 01:06:01.000000', 'temperatura', 283.0000, 'ºC'),
	(178062, 120, '2014-02-01 01:06:02.000000', 'temperatura', 285.0000, 'ºC'),
	(178063, 120, '2014-02-01 01:06:03.000000', 'temperatura', 577.0000, 'ºC'),
	(178064, 120, '2014-02-01 01:06:04.000000', 'temperatura', 827.0000, 'ºC'),
	(178065, 120, '2014-02-01 01:06:05.000000', 'temperatura', 8.0000, 'ºC'),
	(178066, 120, '2014-02-01 01:06:06.000000', 'temperatura', 1158.0000, 'ºC'),
	(178067, 120, '2014-02-01 01:06:07.000000', 'temperatura', 968.0000, 'ºC'),
	(178068, 120, '2014-02-01 01:06:08.000000', 'temperatura', 167.0000, 'ºC'),
	(178069, 120, '2014-02-01 01:06:09.000000', 'temperatura', 330.0000, 'ºC'),
	(178070, 120, '2014-02-01 01:06:10.000000', 'temperatura', 1148.0000, 'ºC'),
	(178071, 120, '2014-02-01 01:06:11.000000', 'temperatura', 1151.0000, 'ºC'),
	(178072, 120, '2014-02-01 01:06:12.000000', 'temperatura', 1113.0000, 'ºC'),
	(178073, 120, '2014-02-01 01:06:13.000000', 'temperatura', 913.0000, 'ºC'),
	(178074, 120, '2014-02-01 01:06:14.000000', 'temperatura', 25.0000, 'ºC'),
	(178075, 120, '2014-02-01 01:06:15.000000', 'temperatura', 986.0000, 'ºC'),
	(178076, 120, '2014-02-01 01:06:16.000000', 'temperatura', 58.0000, 'ºC'),
	(178077, 120, '2014-02-01 01:06:17.000000', 'temperatura', 929.0000, 'ºC'),
	(178078, 120, '2014-02-01 01:06:18.000000', 'temperatura', 874.0000, 'ºC'),
	(178079, 120, '2014-02-01 01:06:19.000000', 'temperatura', 382.0000, 'ºC'),
	(178080, 120, '2014-02-01 01:06:20.000000', 'temperatura', 489.0000, 'ºC'),
	(178081, 120, '2014-02-01 01:06:21.000000', 'temperatura', 101.0000, 'ºC'),
	(178082, 120, '2014-02-01 01:06:22.000000', 'temperatura', 237.0000, 'ºC'),
	(178083, 120, '2014-02-01 01:06:23.000000', 'temperatura', 881.0000, 'ºC'),
	(178084, 120, '2014-02-01 01:06:24.000000', 'temperatura', 96.0000, 'ºC'),
	(178085, 120, '2014-02-01 01:06:25.000000', 'temperatura', 237.0000, 'ºC'),
	(178086, 120, '2014-02-01 01:06:26.000000', 'temperatura', 897.0000, 'ºC'),
	(178087, 120, '2014-02-01 01:06:27.000000', 'temperatura', 177.0000, 'ºC'),
	(178088, 120, '2014-02-01 01:06:28.000000', 'temperatura', 594.0000, 'ºC'),
	(178089, 120, '2014-02-01 01:06:29.000000', 'temperatura', 37.0000, 'ºC'),
	(178090, 120, '2014-02-01 01:06:30.000000', 'temperatura', 807.0000, 'ºC'),
	(178091, 120, '2014-02-01 01:06:31.000000', 'temperatura', 321.0000, 'ºC'),
	(178092, 120, '2014-02-01 01:06:32.000000', 'temperatura', 385.0000, 'ºC'),
	(178093, 120, '2014-02-01 01:06:33.000000', 'temperatura', 965.0000, 'ºC'),
	(178094, 120, '2014-02-01 01:06:34.000000', 'temperatura', 70.0000, 'ºC'),
	(178095, 120, '2014-02-01 01:06:35.000000', 'temperatura', 1055.0000, 'ºC'),
	(178096, 120, '2014-02-01 01:06:36.000000', 'temperatura', 265.0000, 'ºC'),
	(178097, 120, '2014-02-01 01:06:37.000000', 'temperatura', 562.0000, 'ºC'),
	(178098, 120, '2014-02-01 01:06:38.000000', 'temperatura', 814.0000, 'ºC'),
	(178099, 120, '2014-02-01 01:06:39.000000', 'temperatura', 1186.0000, 'ºC'),
	(178100, 120, '2014-02-01 01:06:40.000000', 'temperatura', 1088.0000, 'ºC'),
	(178101, 120, '2014-02-01 01:06:41.000000', 'temperatura', 684.0000, 'ºC'),
	(178102, 120, '2014-02-01 01:06:42.000000', 'temperatura', 154.0000, 'ºC'),
	(178103, 120, '2014-02-01 01:06:43.000000', 'temperatura', 1120.0000, 'ºC'),
	(178104, 120, '2014-02-01 01:06:44.000000', 'temperatura', 339.0000, 'ºC'),
	(178105, 120, '2014-02-01 01:06:45.000000', 'temperatura', 737.0000, 'ºC'),
	(178106, 120, '2014-02-01 01:06:46.000000', 'temperatura', 265.0000, 'ºC'),
	(178107, 120, '2014-02-01 01:06:47.000000', 'temperatura', 317.0000, 'ºC'),
	(178108, 120, '2014-02-01 01:06:48.000000', 'temperatura', 790.0000, 'ºC'),
	(178109, 120, '2014-02-01 01:06:49.000000', 'temperatura', 599.0000, 'ºC'),
	(178110, 120, '2014-02-01 01:06:50.000000', 'temperatura', 626.0000, 'ºC'),
	(178111, 120, '2014-02-01 01:06:51.000000', 'temperatura', 131.0000, 'ºC'),
	(178112, 120, '2014-02-01 01:06:52.000000', 'temperatura', 1181.0000, 'ºC'),
	(178113, 120, '2014-02-01 01:06:53.000000', 'temperatura', 711.0000, 'ºC'),
	(178114, 120, '2014-02-01 01:06:54.000000', 'temperatura', 14.0000, 'ºC'),
	(178115, 120, '2014-02-01 01:06:55.000000', 'temperatura', 336.0000, 'ºC'),
	(178116, 120, '2014-02-01 01:06:56.000000', 'temperatura', 440.0000, 'ºC'),
	(178117, 120, '2014-02-01 01:06:57.000000', 'temperatura', 1191.0000, 'ºC'),
	(178118, 120, '2014-02-01 01:06:58.000000', 'temperatura', 1037.0000, 'ºC'),
	(178119, 120, '2014-02-01 01:06:59.000000', 'temperatura', 413.0000, 'ºC'),
	(178120, 120, '2014-02-01 01:07:00.000000', 'temperatura', 155.0000, 'ºC'),
	(178121, 120, '2014-02-01 01:07:01.000000', 'temperatura', 734.0000, 'ºC'),
	(178122, 120, '2014-02-01 01:07:02.000000', 'temperatura', 808.0000, 'ºC'),
	(178123, 120, '2014-02-01 01:07:03.000000', 'temperatura', 639.0000, 'ºC'),
	(178124, 120, '2014-02-01 01:07:04.000000', 'temperatura', 770.0000, 'ºC'),
	(178125, 120, '2014-02-01 01:07:05.000000', 'temperatura', 734.0000, 'ºC'),
	(178126, 120, '2014-02-01 01:07:06.000000', 'temperatura', 162.0000, 'ºC'),
	(178127, 120, '2014-02-01 01:07:07.000000', 'temperatura', 1006.0000, 'ºC'),
	(178128, 120, '2014-02-01 01:07:08.000000', 'temperatura', 946.0000, 'ºC'),
	(178129, 120, '2014-02-01 01:07:09.000000', 'temperatura', 514.0000, 'ºC'),
	(178130, 120, '2014-02-01 01:07:10.000000', 'temperatura', 930.0000, 'ºC'),
	(178131, 120, '2014-02-01 01:07:11.000000', 'temperatura', 709.0000, 'ºC'),
	(178132, 120, '2014-02-01 01:07:12.000000', 'temperatura', 754.0000, 'ºC'),
	(178133, 120, '2014-02-01 01:07:13.000000', 'temperatura', 444.0000, 'ºC'),
	(178134, 120, '2014-02-01 01:07:14.000000', 'temperatura', 1159.0000, 'ºC'),
	(178135, 120, '2014-02-01 01:07:15.000000', 'temperatura', 864.0000, 'ºC'),
	(178136, 120, '2014-02-01 01:07:16.000000', 'temperatura', 842.0000, 'ºC'),
	(178137, 120, '2014-02-01 01:07:17.000000', 'temperatura', 421.0000, 'ºC'),
	(178138, 120, '2014-02-01 01:07:18.000000', 'temperatura', 779.0000, 'ºC'),
	(178139, 120, '2014-02-01 01:07:19.000000', 'temperatura', 230.0000, 'ºC'),
	(178140, 120, '2014-02-01 01:07:20.000000', 'temperatura', 16.0000, 'ºC'),
	(178141, 120, '2014-02-01 01:07:21.000000', 'temperatura', 589.0000, 'ºC'),
	(178142, 120, '2014-02-01 01:07:22.000000', 'temperatura', 499.0000, 'ºC'),
	(178143, 120, '2014-02-01 01:07:23.000000', 'temperatura', 726.0000, 'ºC'),
	(178144, 120, '2014-02-01 01:07:24.000000', 'temperatura', 936.0000, 'ºC'),
	(178145, 120, '2014-02-01 01:07:25.000000', 'temperatura', 103.0000, 'ºC'),
	(178146, 120, '2014-02-01 01:07:26.000000', 'temperatura', 108.0000, 'ºC'),
	(178147, 120, '2014-02-01 01:07:27.000000', 'temperatura', 230.0000, 'ºC'),
	(178148, 120, '2014-02-01 01:07:28.000000', 'temperatura', 829.0000, 'ºC'),
	(178149, 120, '2014-02-01 01:07:29.000000', 'temperatura', 1052.0000, 'ºC'),
	(178150, 120, '2014-02-01 01:07:30.000000', 'temperatura', 376.0000, 'ºC'),
	(178151, 120, '2014-02-01 01:07:31.000000', 'temperatura', 1122.0000, 'ºC'),
	(178152, 120, '2014-02-01 01:07:32.000000', 'temperatura', 885.0000, 'ºC'),
	(178153, 120, '2014-02-01 01:07:33.000000', 'temperatura', 1057.0000, 'ºC'),
	(178154, 120, '2014-02-01 01:07:34.000000', 'temperatura', 232.0000, 'ºC'),
	(178155, 120, '2014-02-01 01:07:35.000000', 'temperatura', 391.0000, 'ºC'),
	(178156, 120, '2014-02-01 01:07:36.000000', 'temperatura', 56.0000, 'ºC'),
	(178157, 120, '2014-02-01 01:07:37.000000', 'temperatura', 311.0000, 'ºC'),
	(178158, 120, '2014-02-01 01:07:38.000000', 'temperatura', 186.0000, 'ºC'),
	(178159, 120, '2014-02-01 01:07:39.000000', 'temperatura', 1197.0000, 'ºC'),
	(178160, 120, '2014-02-01 01:07:40.000000', 'temperatura', 628.0000, 'ºC'),
	(178161, 120, '2014-02-01 01:07:41.000000', 'temperatura', 748.0000, 'ºC'),
	(178162, 120, '2014-02-01 01:07:42.000000', 'temperatura', 659.0000, 'ºC'),
	(178163, 120, '2014-02-01 01:07:43.000000', 'temperatura', 1049.0000, 'ºC'),
	(178164, 120, '2014-02-01 01:07:44.000000', 'temperatura', 868.0000, 'ºC'),
	(178165, 120, '2014-02-01 01:07:45.000000', 'temperatura', 1194.0000, 'ºC'),
	(178166, 120, '2014-02-01 01:07:46.000000', 'temperatura', 967.0000, 'ºC'),
	(178167, 120, '2014-02-01 01:07:47.000000', 'temperatura', 53.0000, 'ºC'),
	(178168, 120, '2014-02-01 01:07:48.000000', 'temperatura', 966.0000, 'ºC'),
	(178169, 120, '2014-02-01 01:07:49.000000', 'temperatura', 1073.0000, 'ºC'),
	(178170, 120, '2014-02-01 01:07:50.000000', 'temperatura', 64.0000, 'ºC'),
	(178171, 120, '2014-02-01 01:07:51.000000', 'temperatura', 702.0000, 'ºC'),
	(178172, 120, '2014-02-01 01:07:52.000000', 'temperatura', 918.0000, 'ºC'),
	(178173, 120, '2014-02-01 01:07:53.000000', 'temperatura', 85.0000, 'ºC'),
	(178174, 120, '2014-02-01 01:07:54.000000', 'temperatura', 70.0000, 'ºC'),
	(178175, 120, '2014-02-01 01:07:55.000000', 'temperatura', 99.0000, 'ºC'),
	(178176, 120, '2014-02-01 01:07:56.000000', 'temperatura', 283.0000, 'ºC'),
	(178177, 120, '2014-02-01 01:07:57.000000', 'temperatura', 1117.0000, 'ºC'),
	(178178, 120, '2014-02-01 01:07:58.000000', 'temperatura', 1139.0000, 'ºC'),
	(178179, 120, '2014-02-01 01:07:59.000000', 'temperatura', 1146.0000, 'ºC'),
	(178180, 120, '2014-02-01 01:08:00.000000', 'temperatura', 1110.0000, 'ºC'),
	(178181, 120, '2014-02-01 01:08:01.000000', 'temperatura', 915.0000, 'ºC'),
	(178182, 120, '2014-02-01 01:08:02.000000', 'temperatura', 45.0000, 'ºC'),
	(178183, 120, '2014-02-01 01:08:03.000000', 'temperatura', 1081.0000, 'ºC'),
	(178184, 120, '2014-02-01 01:08:04.000000', 'temperatura', 470.0000, 'ºC'),
	(178185, 120, '2014-02-01 01:08:05.000000', 'temperatura', 307.0000, 'ºC'),
	(178186, 120, '2014-02-01 01:08:06.000000', 'temperatura', 124.0000, 'ºC'),
	(178187, 120, '2014-02-01 01:08:07.000000', 'temperatura', 900.0000, 'ºC'),
	(178188, 120, '2014-02-01 01:08:08.000000', 'temperatura', 529.0000, 'ºC'),
	(178189, 120, '2014-02-01 01:08:09.000000', 'temperatura', 1145.0000, 'ºC'),
	(178190, 120, '2014-02-01 01:08:10.000000', 'temperatura', 539.0000, 'ºC'),
	(178191, 120, '2014-02-01 01:08:11.000000', 'temperatura', 462.0000, 'ºC'),
	(178192, 120, '2014-02-01 01:08:12.000000', 'temperatura', 694.0000, 'ºC'),
	(178193, 120, '2014-02-01 01:08:13.000000', 'temperatura', 883.0000, 'ºC'),
	(178194, 120, '2014-02-01 01:08:14.000000', 'temperatura', 1135.0000, 'ºC'),
	(178195, 120, '2014-02-01 01:08:15.000000', 'temperatura', 627.0000, 'ºC'),
	(178196, 120, '2014-02-01 01:08:16.000000', 'temperatura', 931.0000, 'ºC'),
	(178197, 120, '2014-02-01 01:08:17.000000', 'temperatura', 373.0000, 'ºC'),
	(178198, 120, '2014-02-01 01:08:18.000000', 'temperatura', 271.0000, 'ºC'),
	(178199, 120, '2014-02-01 01:08:19.000000', 'temperatura', 237.0000, 'ºC'),
	(178200, 120, '2014-02-01 01:08:20.000000', 'temperatura', 374.0000, 'ºC'),
	(178201, 120, '2014-02-01 01:08:21.000000', 'temperatura', 1160.0000, 'ºC'),
	(178202, 120, '2014-02-01 01:08:22.000000', 'temperatura', 1079.0000, 'ºC'),
	(178203, 120, '2014-02-01 01:08:23.000000', 'temperatura', 713.0000, 'ºC'),
	(178204, 120, '2014-02-01 01:08:24.000000', 'temperatura', 330.0000, 'ºC'),
	(178205, 120, '2014-02-01 01:08:25.000000', 'temperatura', 712.0000, 'ºC'),
	(178206, 120, '2014-02-01 01:08:26.000000', 'temperatura', 168.0000, 'ºC'),
	(178207, 120, '2014-02-01 01:08:27.000000', 'temperatura', 1108.0000, 'ºC'),
	(178208, 120, '2014-02-01 01:08:28.000000', 'temperatura', 235.0000, 'ºC'),
	(178209, 120, '2014-02-01 01:08:29.000000', 'temperatura', 251.0000, 'ºC'),
	(178210, 120, '2014-02-01 01:08:30.000000', 'temperatura', 550.0000, 'ºC'),
	(178211, 120, '2014-02-01 01:08:31.000000', 'temperatura', 797.0000, 'ºC'),
	(178212, 120, '2014-02-01 01:08:32.000000', 'temperatura', 1137.0000, 'ºC'),
	(178213, 120, '2014-02-01 01:08:33.000000', 'temperatura', 893.0000, 'ºC'),
	(178214, 120, '2014-02-01 01:08:34.000000', 'temperatura', 1057.0000, 'ºC'),
	(178215, 120, '2014-02-01 01:08:35.000000', 'temperatura', 206.0000, 'ºC'),
	(178216, 120, '2014-02-01 01:08:36.000000', 'temperatura', 260.0000, 'ºC'),
	(178217, 120, '2014-02-01 01:08:37.000000', 'temperatura', 680.0000, 'ºC'),
	(178218, 120, '2014-02-01 01:08:38.000000', 'temperatura', 221.0000, 'ºC'),
	(178219, 120, '2014-02-01 01:08:39.000000', 'temperatura', 267.0000, 'ºC'),
	(178220, 120, '2014-02-01 01:08:40.000000', 'temperatura', 674.0000, 'ºC'),
	(178221, 120, '2014-02-01 01:08:41.000000', 'temperatura', 167.0000, 'ºC'),
	(178222, 120, '2014-02-01 01:08:42.000000', 'temperatura', 13.0000, 'ºC'),
	(178223, 120, '2014-02-01 01:08:43.000000', 'temperatura', 764.0000, 'ºC'),
	(178224, 120, '2014-02-01 01:08:44.000000', 'temperatura', 181.0000, 'ºC'),
	(178225, 120, '2014-02-01 01:08:45.000000', 'temperatura', 1016.0000, 'ºC'),
	(178226, 120, '2014-02-01 01:08:46.000000', 'temperatura', 937.0000, 'ºC'),
	(178227, 120, '2014-02-01 01:08:47.000000', 'temperatura', 437.0000, 'ºC'),
	(178228, 120, '2014-02-01 01:08:48.000000', 'temperatura', 577.0000, 'ºC'),
	(178229, 120, '2014-02-01 01:08:49.000000', 'temperatura', 372.0000, 'ºC'),
	(178230, 120, '2014-02-01 01:08:50.000000', 'temperatura', 128.0000, 'ºC'),
	(178231, 120, '2014-02-01 01:08:51.000000', 'temperatura', 727.0000, 'ºC'),
	(178232, 120, '2014-02-01 01:08:52.000000', 'temperatura', 849.0000, 'ºC'),
	(178233, 120, '2014-02-01 01:08:53.000000', 'temperatura', 866.0000, 'ºC'),
	(178234, 120, '2014-02-01 01:08:54.000000', 'temperatura', 584.0000, 'ºC'),
	(178235, 120, '2014-02-01 01:08:55.000000', 'temperatura', 321.0000, 'ºC'),
	(178236, 120, '2014-02-01 01:08:56.000000', 'temperatura', 1054.0000, 'ºC'),
	(178237, 120, '2014-02-01 01:08:57.000000', 'temperatura', 709.0000, 'ºC'),
	(178238, 120, '2014-02-01 01:08:58.000000', 'temperatura', 384.0000, 'ºC'),
	(178239, 120, '2014-02-01 01:08:59.000000', 'temperatura', 992.0000, 'ºC'),
	(178240, 120, '2014-02-01 01:09:00.000000', 'temperatura', 208.0000, 'ºC'),
	(178241, 120, '2014-02-01 01:09:01.000000', 'temperatura', 465.0000, 'ºC'),
	(178242, 120, '2014-02-01 01:09:02.000000', 'temperatura', 502.0000, 'ºC'),
	(178243, 120, '2014-02-01 01:09:03.000000', 'temperatura', 1115.0000, 'ºC'),
	(178244, 120, '2014-02-01 01:09:04.000000', 'temperatura', 469.0000, 'ºC'),
	(178245, 120, '2014-02-01 01:09:05.000000', 'temperatura', 200.0000, 'ºC'),
	(178246, 120, '2014-02-01 01:09:06.000000', 'temperatura', 794.0000, 'ºC'),
	(178247, 120, '2014-02-01 01:09:07.000000', 'temperatura', 970.0000, 'ºC'),
	(178248, 120, '2014-02-01 01:09:08.000000', 'temperatura', 67.0000, 'ºC'),
	(178249, 120, '2014-02-01 01:09:09.000000', 'temperatura', 1026.0000, 'ºC'),
	(178250, 120, '2014-02-01 01:09:10.000000', 'temperatura', 132.0000, 'ºC'),
	(178251, 120, '2014-02-01 01:09:11.000000', 'temperatura', 1180.0000, 'ºC'),
	(178252, 120, '2014-02-01 01:09:12.000000', 'temperatura', 706.0000, 'ºC'),
	(178253, 120, '2014-02-01 01:09:13.000000', 'temperatura', 1188.0000, 'ºC'),
	(178254, 120, '2014-02-01 01:09:14.000000', 'temperatura', 225.0000, 'ºC'),
	(178255, 120, '2014-02-01 01:09:15.000000', 'temperatura', 1160.0000, 'ºC'),
	(178256, 120, '2014-02-01 01:09:16.000000', 'temperatura', 326.0000, 'ºC'),
	(178257, 120, '2014-02-01 01:09:17.000000', 'temperatura', 552.0000, 'ºC'),
	(178258, 120, '2014-02-01 01:09:18.000000', 'temperatura', 582.0000, 'ºC'),
	(178259, 120, '2014-02-01 01:09:19.000000', 'temperatura', 56.0000, 'ºC'),
	(178260, 120, '2014-02-01 01:09:20.000000', 'temperatura', 933.0000, 'ºC'),
	(178261, 120, '2014-02-01 01:09:21.000000', 'temperatura', 900.0000, 'ºC'),
	(178262, 120, '2014-02-01 01:09:22.000000', 'temperatura', 498.0000, 'ºC'),
	(178263, 120, '2014-02-01 01:09:23.000000', 'temperatura', 991.0000, 'ºC'),
	(178264, 120, '2014-02-01 01:09:24.000000', 'temperatura', 1061.0000, 'ºC'),
	(178265, 120, '2014-02-01 01:09:25.000000', 'temperatura', 1135.0000, 'ºC'),
	(178266, 120, '2014-02-01 01:09:26.000000', 'temperatura', 90.0000, 'ºC'),
	(178267, 120, '2014-02-01 01:09:27.000000', 'temperatura', 646.0000, 'ºC'),
	(178268, 120, '2014-02-01 01:09:28.000000', 'temperatura', 559.0000, 'ºC'),
	(178269, 120, '2014-02-01 01:09:29.000000', 'temperatura', 859.0000, 'ºC'),
	(178270, 120, '2014-02-01 01:09:30.000000', 'temperatura', 217.0000, 'ºC'),
	(178271, 120, '2014-02-01 01:09:31.000000', 'temperatura', 911.0000, 'ºC'),
	(178272, 120, '2014-02-01 01:09:32.000000', 'temperatura', 302.0000, 'ºC'),
	(178273, 120, '2014-02-01 01:09:33.000000', 'temperatura', 1179.0000, 'ºC'),
	(178274, 120, '2014-02-01 01:09:34.000000', 'temperatura', 190.0000, 'ºC'),
	(178275, 120, '2014-02-01 01:09:35.000000', 'temperatura', 1012.0000, 'ºC'),
	(178276, 120, '2014-02-01 01:09:36.000000', 'temperatura', 890.0000, 'ºC'),
	(178277, 120, '2014-02-01 01:09:37.000000', 'temperatura', 214.0000, 'ºC'),
	(178278, 120, '2014-02-01 01:09:38.000000', 'temperatura', 801.0000, 'ºC'),
	(178279, 120, '2014-02-01 01:09:39.000000', 'temperatura', 966.0000, 'ºC'),
	(178280, 120, '2014-02-01 01:09:40.000000', 'temperatura', 25.0000, 'ºC'),
	(178281, 120, '2014-02-01 01:09:41.000000', 'temperatura', 830.0000, 'ºC'),
	(178282, 120, '2014-02-01 01:09:42.000000', 'temperatura', 473.0000, 'ºC'),
	(178283, 120, '2014-02-01 01:09:43.000000', 'temperatura', 1078.0000, 'ºC'),
	(178284, 120, '2014-02-01 01:09:44.000000', 'temperatura', 372.0000, 'ºC'),
	(178285, 120, '2014-02-01 01:09:45.000000', 'temperatura', 1023.0000, 'ºC'),
	(178286, 120, '2014-02-01 01:09:46.000000', 'temperatura', 403.0000, 'ºC'),
	(178287, 120, '2014-02-01 01:09:47.000000', 'temperatura', 144.0000, 'ºC'),
	(178288, 120, '2014-02-01 01:09:48.000000', 'temperatura', 711.0000, 'ºC'),
	(178289, 120, '2014-02-01 01:09:49.000000', 'temperatura', 723.0000, 'ºC'),
	(178290, 120, '2014-02-01 01:09:50.000000', 'temperatura', 283.0000, 'ºC'),
	(178291, 120, '2014-02-01 01:09:51.000000', 'temperatura', 448.0000, 'ºC'),
	(178292, 120, '2014-02-01 01:09:52.000000', 'temperatura', 190.0000, 'ºC'),
	(178293, 120, '2014-02-01 01:09:53.000000', 'temperatura', 807.0000, 'ºC'),
	(178294, 120, '2014-02-01 01:09:54.000000', 'temperatura', 1066.0000, 'ºC'),
	(178295, 120, '2014-02-01 01:09:55.000000', 'temperatura', 510.0000, 'ºC'),
	(178296, 120, '2014-02-01 01:09:56.000000', 'temperatura', 550.0000, 'ºC'),
	(178297, 120, '2014-02-01 01:09:57.000000', 'temperatura', 22.0000, 'ºC'),
	(178298, 120, '2014-02-01 01:09:58.000000', 'temperatura', 859.0000, 'ºC'),
	(178299, 120, '2014-02-01 01:09:59.000000', 'temperatura', 629.0000, 'ºC'),
	(178300, 120, '2014-02-01 01:10:00.000000', 'temperatura', 570.0000, 'ºC'),
	(178301, 120, '2014-02-01 01:10:01.000000', 'temperatura', 961.0000, 'ºC'),
	(178302, 120, '2014-02-01 01:10:02.000000', 'temperatura', 698.0000, 'ºC'),
	(178303, 120, '2014-02-01 01:10:03.000000', 'temperatura', 605.0000, 'ºC'),
	(178304, 120, '2014-02-01 01:10:04.000000', 'temperatura', 933.0000, 'ºC'),
	(178305, 120, '2014-02-01 01:10:05.000000', 'temperatura', 449.0000, 'ºC'),
	(178306, 120, '2014-02-01 01:10:06.000000', 'temperatura', 648.0000, 'ºC'),
	(178307, 120, '2014-02-01 01:10:07.000000', 'temperatura', 694.0000, 'ºC'),
	(178308, 120, '2014-02-01 01:10:08.000000', 'temperatura', 324.0000, 'ºC'),
	(178309, 120, '2014-02-01 01:10:09.000000', 'temperatura', 739.0000, 'ºC'),
	(178310, 120, '2014-02-01 01:10:10.000000', 'temperatura', 325.0000, 'ºC'),
	(178311, 120, '2014-02-01 01:10:11.000000', 'temperatura', 606.0000, 'ºC'),
	(178312, 120, '2014-02-01 01:10:12.000000', 'temperatura', 858.0000, 'ºC'),
	(178313, 120, '2014-02-01 01:10:13.000000', 'temperatura', 72.0000, 'ºC'),
	(178314, 120, '2014-02-01 01:10:14.000000', 'temperatura', 185.0000, 'ºC'),
	(178315, 120, '2014-02-01 01:10:15.000000', 'temperatura', 710.0000, 'ºC'),
	(178316, 120, '2014-02-01 01:10:16.000000', 'temperatura', 598.0000, 'ºC'),
	(178317, 120, '2014-02-01 01:10:17.000000', 'temperatura', 858.0000, 'ºC'),
	(178318, 120, '2014-02-01 01:10:18.000000', 'temperatura', 95.0000, 'ºC'),
	(178319, 120, '2014-02-01 01:10:19.000000', 'temperatura', 305.0000, 'ºC'),
	(178320, 120, '2014-02-01 01:10:20.000000', 'temperatura', 39.0000, 'ºC'),
	(178321, 120, '2014-02-01 01:10:21.000000', 'temperatura', 483.0000, 'ºC'),
	(178322, 120, '2014-02-01 01:10:22.000000', 'temperatura', 1095.0000, 'ºC'),
	(178323, 120, '2014-02-01 01:10:23.000000', 'temperatura', 429.0000, 'ºC'),
	(178324, 120, '2014-02-01 01:10:24.000000', 'temperatura', 61.0000, 'ºC'),
	(178325, 120, '2014-02-01 01:10:25.000000', 'temperatura', 219.0000, 'ºC'),
	(178326, 120, '2014-02-01 01:10:26.000000', 'temperatura', 910.0000, 'ºC'),
	(178327, 120, '2014-02-01 01:10:27.000000', 'temperatura', 295.0000, 'ºC'),
	(178328, 120, '2014-02-01 01:10:28.000000', 'temperatura', 1146.0000, 'ºC'),
	(178329, 120, '2014-02-01 01:10:29.000000', 'temperatura', 45.0000, 'ºC'),
	(178330, 120, '2014-02-01 01:10:30.000000', 'temperatura', 385.0000, 'ºC'),
	(178331, 120, '2014-02-01 01:10:31.000000', 'temperatura', 594.0000, 'ºC'),
	(178332, 120, '2014-02-01 01:10:32.000000', 'temperatura', 613.0000, 'ºC'),
	(178333, 120, '2014-02-01 01:10:33.000000', 'temperatura', 84.0000, 'ºC'),
	(178334, 120, '2014-02-01 01:10:34.000000', 'temperatura', 980.0000, 'ºC'),
	(178335, 120, '2014-02-01 01:10:35.000000', 'temperatura', 1050.0000, 'ºC'),
	(178336, 120, '2014-02-01 01:10:36.000000', 'temperatura', 1111.0000, 'ºC'),
	(178337, 120, '2014-02-01 01:10:37.000000', 'temperatura', 7.0000, 'ºC'),
	(178338, 120, '2014-02-01 01:10:38.000000', 'temperatura', 302.0000, 'ºC'),
	(178339, 120, '2014-02-01 01:10:39.000000', 'temperatura', 288.0000, 'ºC'),
	(178340, 120, '2014-02-01 01:10:40.000000', 'temperatura', 535.0000, 'ºC'),
	(178341, 120, '2014-02-01 01:10:41.000000', 'temperatura', 612.0000, 'ºC'),
	(178342, 120, '2014-02-01 01:10:42.000000', 'temperatura', 255.0000, 'ºC'),
	(178343, 120, '2014-02-01 01:10:43.000000', 'temperatura', 638.0000, 'ºC'),
	(178344, 120, '2014-02-01 01:10:44.000000', 'temperatura', 27.0000, 'ºC'),
	(178345, 120, '2014-02-01 01:10:45.000000', 'temperatura', 623.0000, 'ºC'),
	(178346, 120, '2014-02-01 01:10:46.000000', 'temperatura', 632.0000, 'ºC'),
	(178347, 120, '2014-02-01 01:10:47.000000', 'temperatura', 93.0000, 'ºC'),
	(178348, 120, '2014-02-01 01:10:48.000000', 'temperatura', 971.0000, 'ºC'),
	(178349, 120, '2014-02-01 01:10:49.000000', 'temperatura', 973.0000, 'ºC'),
	(178350, 120, '2014-02-01 01:10:50.000000', 'temperatura', 754.0000, 'ºC'),
	(178351, 120, '2014-02-01 01:10:51.000000', 'temperatura', 852.0000, 'ºC'),
	(178352, 120, '2014-02-01 01:10:52.000000', 'temperatura', 798.0000, 'ºC'),
	(178353, 120, '2014-02-01 01:10:53.000000', 'temperatura', 235.0000, 'ºC'),
	(178354, 120, '2014-02-01 01:10:54.000000', 'temperatura', 1179.0000, 'ºC'),
	(178355, 120, '2014-02-01 01:10:55.000000', 'temperatura', 392.0000, 'ºC'),
	(178356, 120, '2014-02-01 01:10:56.000000', 'temperatura', 825.0000, 'ºC'),
	(178357, 120, '2014-02-01 01:10:57.000000', 'temperatura', 551.0000, 'ºC'),
	(178358, 120, '2014-02-01 01:10:58.000000', 'temperatura', 277.0000, 'ºC'),
	(178359, 120, '2014-02-01 01:10:59.000000', 'temperatura', 933.0000, 'ºC'),
	(178360, 120, '2014-02-01 01:11:00.000000', 'temperatura', 235.0000, 'ºC'),
	(178361, 120, '2014-02-01 01:11:01.000000', 'temperatura', 779.0000, 'ºC'),
	(178362, 120, '2014-02-01 01:11:02.000000', 'temperatura', 787.0000, 'ºC'),
	(178363, 120, '2014-02-01 01:11:03.000000', 'temperatura', 400.0000, 'ºC'),
	(178364, 120, '2014-02-01 01:11:04.000000', 'temperatura', 841.0000, 'ºC'),
	(178365, 120, '2014-02-01 01:11:05.000000', 'temperatura', 603.0000, 'ºC'),
	(178366, 120, '2014-02-01 01:11:06.000000', 'temperatura', 493.0000, 'ºC'),
	(178367, 120, '2014-02-01 01:11:07.000000', 'temperatura', 657.0000, 'ºC'),
	(178368, 120, '2014-02-01 01:11:08.000000', 'temperatura', 607.0000, 'ºC'),
	(178369, 120, '2014-02-01 01:11:09.000000', 'temperatura', 1066.0000, 'ºC'),
	(178370, 120, '2014-02-01 01:11:10.000000', 'temperatura', 1108.0000, 'ºC'),
	(178371, 120, '2014-02-01 01:11:11.000000', 'temperatura', 1142.0000, 'ºC'),
	(178372, 120, '2014-02-01 01:11:12.000000', 'temperatura', 1185.0000, 'ºC'),
	(178373, 120, '2014-02-01 01:11:13.000000', 'temperatura', 100.0000, 'ºC'),
	(178374, 120, '2014-02-01 01:11:14.000000', 'temperatura', 546.0000, 'ºC'),
	(178375, 120, '2014-02-01 01:11:15.000000', 'temperatura', 30.0000, 'ºC'),
	(178376, 120, '2014-02-01 01:11:16.000000', 'temperatura', 912.0000, 'ºC'),
	(178377, 120, '2014-02-01 01:11:17.000000', 'temperatura', 871.0000, 'ºC'),
	(178378, 120, '2014-02-01 01:11:18.000000', 'temperatura', 418.0000, 'ºC'),
	(178379, 120, '2014-02-01 01:11:19.000000', 'temperatura', 680.0000, 'ºC'),
	(178380, 120, '2014-02-01 01:11:20.000000', 'temperatura', 946.0000, 'ºC'),
	(178381, 120, '2014-02-01 01:11:21.000000', 'temperatura', 292.0000, 'ºC'),
	(178382, 120, '2014-02-01 01:11:22.000000', 'temperatura', 1020.0000, 'ºC'),
	(178383, 120, '2014-02-01 01:11:23.000000', 'temperatura', 627.0000, 'ºC'),
	(178384, 120, '2014-02-01 01:11:24.000000', 'temperatura', 73.0000, 'ºC'),
	(178385, 120, '2014-02-01 01:11:25.000000', 'temperatura', 886.0000, 'ºC'),
	(178386, 120, '2014-02-01 01:11:26.000000', 'temperatura', 611.0000, 'ºC'),
	(178387, 120, '2014-02-01 01:11:27.000000', 'temperatura', 397.0000, 'ºC'),
	(178388, 120, '2014-02-01 01:11:28.000000', 'temperatura', 152.0000, 'ºC'),
	(178389, 120, '2014-02-01 01:11:29.000000', 'temperatura', 769.0000, 'ºC'),
	(178390, 120, '2014-02-01 01:11:30.000000', 'temperatura', 991.0000, 'ºC'),
	(178391, 120, '2014-02-01 01:11:31.000000', 'temperatura', 249.0000, 'ºC'),
	(178392, 120, '2014-02-01 01:11:32.000000', 'temperatura', 671.0000, 'ºC'),
	(178393, 120, '2014-02-01 01:11:33.000000', 'temperatura', 207.0000, 'ºC'),
	(178394, 120, '2014-02-01 01:11:34.000000', 'temperatura', 225.0000, 'ºC'),
	(178395, 120, '2014-02-01 01:11:35.000000', 'temperatura', 505.0000, 'ºC'),
	(178396, 120, '2014-02-01 01:11:36.000000', 'temperatura', 651.0000, 'ºC'),
	(178397, 120, '2014-02-01 01:11:37.000000', 'temperatura', 538.0000, 'ºC'),
	(178398, 120, '2014-02-01 01:11:38.000000', 'temperatura', 738.0000, 'ºC'),
	(178399, 120, '2014-02-01 01:11:39.000000', 'temperatura', 877.0000, 'ºC'),
	(178400, 120, '2014-02-01 01:11:40.000000', 'temperatura', 970.0000, 'ºC'),
	(178401, 120, '2014-02-01 01:11:41.000000', 'temperatura', 1022.0000, 'ºC'),
	(178402, 120, '2014-02-01 01:11:42.000000', 'temperatura', 1000.0000, 'ºC'),
	(178403, 120, '2014-02-01 01:11:43.000000', 'temperatura', 734.0000, 'ºC'),
	(178404, 120, '2014-02-01 01:11:44.000000', 'temperatura', 669.0000, 'ºC'),
	(178405, 120, '2014-02-01 01:11:45.000000', 'temperatura', 1143.0000, 'ºC'),
	(178406, 120, '2014-02-01 01:11:46.000000', 'temperatura', 109.0000, 'ºC'),
	(178407, 120, '2014-02-01 01:11:47.000000', 'temperatura', 716.0000, 'ºC'),
	(178408, 120, '2014-02-01 01:11:48.000000', 'temperatura', 855.0000, 'ºC'),
	(178409, 120, '2014-02-01 01:11:49.000000', 'temperatura', 926.0000, 'ºC'),
	(178410, 120, '2014-02-01 01:11:50.000000', 'temperatura', 867.0000, 'ºC'),
	(178411, 120, '2014-02-01 01:11:51.000000', 'temperatura', 358.0000, 'ºC'),
	(178412, 120, '2014-02-01 01:11:52.000000', 'temperatura', 390.0000, 'ºC'),
	(178413, 120, '2014-02-01 01:11:53.000000', 'temperatura', 878.0000, 'ºC'),
	(178414, 120, '2014-02-01 01:11:54.000000', 'temperatura', 818.0000, 'ºC'),
	(178415, 120, '2014-02-01 01:11:55.000000', 'temperatura', 256.0000, 'ºC'),
	(178416, 120, '2014-02-01 01:11:56.000000', 'temperatura', 27.0000, 'ºC'),
	(178417, 120, '2014-02-01 01:11:57.000000', 'temperatura', 566.0000, 'ºC'),
	(178418, 120, '2014-02-01 01:11:58.000000', 'temperatura', 353.0000, 'ºC'),
	(178419, 120, '2014-02-01 01:11:59.000000', 'temperatura', 65.0000, 'ºC'),
	(178420, 120, '2014-02-01 01:12:00.000000', 'temperatura', 466.0000, 'ºC'),
	(178421, 120, '2014-02-01 01:12:01.000000', 'temperatura', 937.0000, 'ºC'),
	(178422, 120, '2014-02-01 01:12:02.000000', 'temperatura', 888.0000, 'ºC'),
	(178423, 120, '2014-02-01 01:12:03.000000', 'temperatura', 431.0000, 'ºC'),
	(178424, 120, '2014-02-01 01:12:04.000000', 'temperatura', 688.0000, 'ºC'),
	(178425, 120, '2014-02-01 01:12:05.000000', 'temperatura', 951.0000, 'ºC'),
	(178426, 120, '2014-02-01 01:12:06.000000', 'temperatura', 289.0000, 'ºC'),
	(178427, 120, '2014-02-01 01:12:07.000000', 'temperatura', 993.0000, 'ºC'),
	(178428, 120, '2014-02-01 01:12:08.000000', 'temperatura', 497.0000, 'ºC'),
	(178429, 120, '2014-02-01 01:12:09.000000', 'temperatura', 708.0000, 'ºC'),
	(178430, 120, '2014-02-01 01:12:10.000000', 'temperatura', 850.0000, 'ºC'),
	(178431, 120, '2014-02-01 01:12:11.000000', 'temperatura', 926.0000, 'ºC'),
	(178432, 120, '2014-02-01 01:12:12.000000', 'temperatura', 879.0000, 'ºC'),
	(178433, 120, '2014-02-01 01:12:13.000000', 'temperatura', 419.0000, 'ºC'),
	(178434, 120, '2014-02-01 01:12:14.000000', 'temperatura', 659.0000, 'ºC'),
	(178435, 120, '2014-02-01 01:12:15.000000', 'temperatura', 836.0000, 'ºC'),
	(178436, 120, '2014-02-01 01:12:16.000000', 'temperatura', 1007.0000, 'ºC'),
	(178437, 120, '2014-02-01 01:12:17.000000', 'temperatura', 126.0000, 'ºC'),
	(178438, 120, '2014-02-01 01:12:18.000000', 'temperatura', 9.0000, 'ºC'),
	(178439, 120, '2014-02-01 01:12:19.000000', 'temperatura', 867.0000, 'ºC'),
	(178440, 120, '2014-02-01 01:12:20.000000', 'temperatura', 709.0000, 'ºC'),
	(178441, 120, '2014-02-01 01:12:21.000000', 'temperatura', 944.0000, 'ºC'),
	(178442, 120, '2014-02-01 01:12:22.000000', 'temperatura', 196.0000, 'ºC'),
	(178443, 120, '2014-02-01 01:12:23.000000', 'temperatura', 546.0000, 'ºC'),
	(178444, 120, '2014-02-01 01:12:24.000000', 'temperatura', 945.0000, 'ºC'),
	(178445, 120, '2014-02-01 01:12:25.000000', 'temperatura', 685.0000, 'ºC'),
	(178446, 120, '2014-02-01 01:12:26.000000', 'temperatura', 593.0000, 'ºC'),
	(178447, 120, '2014-02-01 01:12:27.000000', 'temperatura', 910.0000, 'ºC'),
	(178448, 120, '2014-02-01 01:12:28.000000', 'temperatura', 370.0000, 'ºC'),
	(178449, 120, '2014-02-01 01:12:29.000000', 'temperatura', 323.0000, 'ºC'),
	(178450, 120, '2014-02-01 01:12:30.000000', 'temperatura', 505.0000, 'ºC'),
	(178451, 120, '2014-02-01 01:12:31.000000', 'temperatura', 358.0000, 'ºC'),
	(178452, 120, '2014-02-01 01:12:32.000000', 'temperatura', 273.0000, 'ºC'),
	(178453, 120, '2014-02-01 01:12:33.000000', 'temperatura', 292.0000, 'ºC'),
	(178454, 120, '2014-02-01 01:12:34.000000', 'temperatura', 643.0000, 'ºC'),
	(178455, 120, '2014-02-01 01:12:35.000000', 'temperatura', 1137.0000, 'ºC'),
	(178456, 120, '2014-02-01 01:12:36.000000', 'temperatura', 158.0000, 'ºC'),
	(178457, 120, '2014-02-01 01:12:37.000000', 'temperatura', 980.0000, 'ºC'),
	(178458, 120, '2014-02-01 01:12:38.000000', 'temperatura', 825.0000, 'ºC'),
	(178459, 120, '2014-02-01 01:12:39.000000', 'temperatura', 1186.0000, 'ºC'),
	(178460, 120, '2014-02-01 01:12:40.000000', 'temperatura', 1057.0000, 'ºC'),
	(178461, 120, '2014-02-01 01:12:41.000000', 'temperatura', 528.0000, 'ºC'),
	(178462, 120, '2014-02-01 01:12:42.000000', 'temperatura', 670.0000, 'ºC'),
	(178463, 120, '2014-02-01 01:12:43.000000', 'temperatura', 566.0000, 'ºC'),
	(178464, 120, '2014-02-01 01:12:44.000000', 'temperatura', 819.0000, 'ºC'),
	(178465, 120, '2014-02-01 01:12:45.000000', 'temperatura', 0.0000, 'ºC'),
	(178466, 120, '2014-02-01 01:12:46.000000', 'temperatura', 1144.0000, 'ºC'),
	(178467, 120, '2014-02-01 01:12:47.000000', 'temperatura', 918.0000, 'ºC'),
	(178468, 120, '2014-02-01 01:12:48.000000', 'temperatura', 1160.0000, 'ºC'),
	(178469, 120, '2014-02-01 01:12:49.000000', 'temperatura', 645.0000, 'ºC'),
	(178470, 120, '2014-02-01 01:12:50.000000', 'temperatura', 947.0000, 'ºC'),
	(178471, 120, '2014-02-01 01:12:51.000000', 'temperatura', 399.0000, 'ºC'),
	(178472, 120, '2014-02-01 01:12:52.000000', 'temperatura', 355.0000, 'ºC'),
	(178473, 120, '2014-02-01 01:12:53.000000', 'temperatura', 580.0000, 'ºC'),
	(178474, 120, '2014-02-01 01:12:54.000000', 'temperatura', 634.0000, 'ºC'),
	(178475, 120, '2014-02-01 01:12:55.000000', 'temperatura', 230.0000, 'ºC'),
	(178476, 120, '2014-02-01 01:12:56.000000', 'temperatura', 450.0000, 'ºC'),
	(178477, 120, '2014-02-01 01:12:57.000000', 'temperatura', 362.0000, 'ºC'),
	(178478, 120, '2014-02-01 01:12:58.000000', 'temperatura', 457.0000, 'ºC'),
	(178479, 120, '2014-02-01 01:12:59.000000', 'temperatura', 2.0000, 'ºC'),
	(178480, 120, '2014-02-01 01:13:00.000000', 'temperatura', 1039.0000, 'ºC'),
	(178481, 120, '2014-02-01 01:13:01.000000', 'temperatura', 388.0000, 'ºC'),
	(178482, 120, '2014-02-01 01:13:02.000000', 'temperatura', 23.0000, 'ºC'),
	(178483, 120, '2014-02-01 01:13:03.000000', 'temperatura', 153.0000, 'ºC'),
	(178484, 120, '2014-02-01 01:13:04.000000', 'temperatura', 698.0000, 'ºC'),
	(178485, 120, '2014-02-01 01:13:05.000000', 'temperatura', 629.0000, 'ºC'),
	(178486, 120, '2014-02-01 01:13:06.000000', 'temperatura', 1053.0000, 'ºC'),
	(178487, 120, '2014-02-01 01:13:07.000000', 'temperatura', 976.0000, 'ºC'),
	(178488, 120, '2014-02-01 01:13:08.000000', 'temperatura', 523.0000, 'ºC'),
	(178489, 120, '2014-02-01 01:13:09.000000', 'temperatura', 889.0000, 'ºC'),
	(178490, 120, '2014-02-01 01:13:10.000000', 'temperatura', 473.0000, 'ºC'),
	(178491, 120, '2014-02-01 01:13:11.000000', 'temperatura', 902.0000, 'ºC'),
	(178492, 120, '2014-02-01 01:13:12.000000', 'temperatura', 690.0000, 'ºC'),
	(178493, 120, '2014-02-01 01:13:13.000000', 'temperatura', 746.0000, 'ºC'),
	(178494, 120, '2014-02-01 01:13:14.000000', 'temperatura', 460.0000, 'ºC'),
	(178495, 120, '2014-02-01 01:13:15.000000', 'temperatura', 62.0000, 'ºC'),
	(178496, 120, '2014-02-01 01:13:16.000000', 'temperatura', 132.0000, 'ºC'),
	(178497, 120, '2014-02-01 01:13:17.000000', 'temperatura', 473.0000, 'ºC'),
	(178498, 120, '2014-02-01 01:13:18.000000', 'temperatura', 771.0000, 'ºC'),
	(178499, 120, '2014-02-01 01:13:19.000000', 'temperatura', 36.0000, 'ºC'),
	(178500, 120, '2014-02-01 01:13:20.000000', 'temperatura', 266.0000, 'ºC'),
	(178501, 120, '2014-02-01 01:13:21.000000', 'temperatura', 24.0000, 'ºC'),
	(178502, 120, '2014-02-01 01:13:22.000000', 'temperatura', 523.0000, 'ºC'),
	(178503, 120, '2014-02-01 01:13:23.000000', 'temperatura', 143.0000, 'ºC'),
	(178504, 120, '2014-02-01 01:13:24.000000', 'temperatura', 347.0000, 'ºC'),
	(178505, 120, '2014-02-01 01:13:25.000000', 'temperatura', 107.0000, 'ºC'),
	(178506, 120, '2014-02-01 01:13:26.000000', 'temperatura', 694.0000, 'ºC'),
	(178507, 120, '2014-02-01 01:13:27.000000', 'temperatura', 749.0000, 'ºC'),
	(178508, 120, '2014-02-01 01:13:28.000000', 'temperatura', 466.0000, 'ºC'),
	(178509, 120, '2014-02-01 01:13:29.000000', 'temperatura', 81.0000, 'ºC'),
	(178510, 120, '2014-02-01 01:13:30.000000', 'temperatura', 207.0000, 'ºC'),
	(178511, 120, '2014-02-01 01:13:31.000000', 'temperatura', 791.0000, 'ºC'),
	(178512, 120, '2014-02-01 01:13:32.000000', 'temperatura', 937.0000, 'ºC'),
	(178513, 120, '2014-02-01 01:13:33.000000', 'temperatura', 1114.0000, 'ºC'),
	(178514, 120, '2014-02-01 01:13:34.000000', 'temperatura', 356.0000, 'ºC'),
	(178515, 120, '2014-02-01 01:13:35.000000', 'temperatura', 841.0000, 'ºC'),
	(178516, 120, '2014-02-01 01:13:36.000000', 'temperatura', 736.0000, 'ºC'),
	(178517, 120, '2014-02-01 01:13:37.000000', 'temperatura', 1156.0000, 'ºC'),
	(178518, 120, '2014-02-01 01:13:38.000000', 'temperatura', 1175.0000, 'ºC'),
	(178519, 120, '2014-02-01 01:13:39.000000', 'temperatura', 6.0000, 'ºC'),
	(178520, 120, '2014-02-01 01:13:40.000000', 'temperatura', 106.0000, 'ºC'),
	(178521, 120, '2014-02-01 01:13:41.000000', 'temperatura', 515.0000, 'ºC'),
	(178522, 120, '2014-02-01 01:13:42.000000', 'temperatura', 1054.0000, 'ºC'),
	(178523, 120, '2014-02-01 01:13:43.000000', 'temperatura', 128.0000, 'ºC'),
	(178524, 120, '2014-02-01 01:13:44.000000', 'temperatura', 1076.0000, 'ºC'),
	(178525, 120, '2014-02-01 01:13:45.000000', 'temperatura', 200.0000, 'ºC'),
	(178526, 120, '2014-02-01 01:13:46.000000', 'temperatura', 170.0000, 'ºC'),
	(178527, 120, '2014-02-01 01:13:47.000000', 'temperatura', 250.0000, 'ºC'),
	(178528, 120, '2014-02-01 01:13:48.000000', 'temperatura', 741.0000, 'ºC'),
	(178529, 120, '2014-02-01 01:13:49.000000', 'temperatura', 554.0000, 'ºC'),
	(178530, 120, '2014-02-01 01:13:50.000000', 'temperatura', 548.0000, 'ºC'),
	(178531, 120, '2014-02-01 01:13:51.000000', 'temperatura', 1078.0000, 'ºC'),
	(178532, 120, '2014-02-01 01:13:52.000000', 'temperatura', 149.0000, 'ºC'),
	(178533, 120, '2014-02-01 01:13:53.000000', 'temperatura', 1108.0000, 'ºC'),
	(178534, 120, '2014-02-01 01:13:54.000000', 'temperatura', 296.0000, 'ºC'),
	(178535, 120, '2014-02-01 01:13:55.000000', 'temperatura', 555.0000, 'ºC'),
	(178536, 120, '2014-02-01 01:13:56.000000', 'temperatura', 686.0000, 'ºC'),
	(178537, 120, '2014-02-01 01:13:57.000000', 'temperatura', 569.0000, 'ºC'),
	(178538, 120, '2014-02-01 01:13:58.000000', 'temperatura', 784.0000, 'ºC'),
	(178539, 120, '2014-02-01 01:13:59.000000', 'temperatura', 1017.0000, 'ºC'),
	(178540, 120, '2014-02-01 01:14:00.000000', 'temperatura', 332.0000, 'ºC'),
	(178541, 120, '2014-02-01 01:14:01.000000', 'temperatura', 1010.0000, 'ºC'),
	(178542, 120, '2014-02-01 01:14:02.000000', 'temperatura', 456.0000, 'ºC'),
	(178543, 120, '2014-02-01 01:14:03.000000', 'temperatura', 448.0000, 'ºC'),
	(178544, 120, '2014-02-01 01:14:04.000000', 'temperatura', 875.0000, 'ºC'),
	(178545, 120, '2014-02-01 01:14:05.000000', 'temperatura', 629.0000, 'ºC'),
	(178546, 120, '2014-02-01 01:14:06.000000', 'temperatura', 523.0000, 'ºC'),
	(178547, 120, '2014-02-01 01:14:07.000000', 'temperatura', 729.0000, 'ºC'),
	(178548, 120, '2014-02-01 01:14:08.000000', 'temperatura', 875.0000, 'ºC'),
	(178549, 120, '2014-02-01 01:14:09.000000', 'temperatura', 988.0000, 'ºC'),
	(178550, 120, '2014-02-01 01:14:10.000000', 'temperatura', 1116.0000, 'ºC'),
	(178551, 120, '2014-02-01 01:14:11.000000', 'temperatura', 215.0000, 'ºC'),
	(178552, 120, '2014-02-01 01:14:12.000000', 'temperatura', 130.0000, 'ºC'),
	(178553, 120, '2014-02-01 01:14:13.000000', 'temperatura', 2.0000, 'ºC'),
	(178554, 120, '2014-02-01 01:14:14.000000', 'temperatura', 824.0000, 'ºC'),
	(178555, 120, '2014-02-01 01:14:15.000000', 'temperatura', 514.0000, 'ºC'),
	(178556, 120, '2014-02-01 01:14:16.000000', 'temperatura', 100.0000, 'ºC'),
	(178557, 120, '2014-02-01 01:14:17.000000', 'temperatura', 155.0000, 'ºC'),
	(178558, 120, '2014-02-01 01:14:18.000000', 'temperatura', 478.0000, 'ºC'),
	(178559, 120, '2014-02-01 01:14:19.000000', 'temperatura', 725.0000, 'ºC'),
	(178560, 120, '2014-02-01 01:14:20.000000', 'temperatura', 993.0000, 'ºC'),
	(178561, 120, '2014-02-01 01:14:21.000000', 'temperatura', 388.0000, 'ºC'),
	(178562, 120, '2014-02-01 01:14:22.000000', 'temperatura', 161.0000, 'ºC'),
	(178563, 120, '2014-02-01 01:14:23.000000', 'temperatura', 841.0000, 'ºC'),
	(178564, 120, '2014-02-01 01:14:24.000000', 'temperatura', 124.0000, 'ºC'),
	(178565, 120, '2014-02-01 01:14:25.000000', 'temperatura', 496.0000, 'ºC'),
	(178566, 120, '2014-02-01 01:14:26.000000', 'temperatura', 910.0000, 'ºC'),
	(178567, 120, '2014-02-01 01:14:27.000000', 'temperatura', 661.0000, 'ºC'),
	(178568, 120, '2014-02-01 01:14:28.000000', 'temperatura', 574.0000, 'ºC'),
	(178569, 120, '2014-02-01 01:14:29.000000', 'temperatura', 889.0000, 'ºC'),
	(178570, 120, '2014-02-01 01:14:30.000000', 'temperatura', 325.0000, 'ºC'),
	(178571, 120, '2014-02-01 01:14:31.000000', 'temperatura', 158.0000, 'ºC'),
	(178572, 120, '2014-02-01 01:14:32.000000', 'temperatura', 1015.0000, 'ºC'),
	(178573, 120, '2014-02-01 01:14:33.000000', 'temperatura', 999.0000, 'ºC'),
	(178574, 120, '2014-02-01 01:14:34.000000', 'temperatura', 754.0000, 'ºC'),
	(178575, 120, '2014-02-01 01:14:35.000000', 'temperatura', 774.0000, 'ºC'),
	(178576, 120, '2014-02-01 01:14:36.000000', 'temperatura', 406.0000, 'ºC'),
	(178577, 120, '2014-02-01 01:14:37.000000', 'temperatura', 910.0000, 'ºC'),
	(178578, 120, '2014-02-01 01:14:38.000000', 'temperatura', 931.0000, 'ºC'),
	(178579, 120, '2014-02-01 01:14:39.000000', 'temperatura', 728.0000, 'ºC'),
	(178580, 120, '2014-02-01 01:14:40.000000', 'temperatura', 845.0000, 'ºC'),
	(178581, 120, '2014-02-01 01:14:41.000000', 'temperatura', 844.0000, 'ºC'),
	(178582, 120, '2014-02-01 01:14:42.000000', 'temperatura', 483.0000, 'ºC'),
	(178583, 120, '2014-02-01 01:14:43.000000', 'temperatura', 1083.0000, 'ºC'),
	(178584, 120, '2014-02-01 01:14:44.000000', 'temperatura', 367.0000, 'ºC'),
	(178585, 120, '2014-02-01 01:14:45.000000', 'temperatura', 988.0000, 'ºC'),
	(178586, 120, '2014-02-01 01:14:46.000000', 'temperatura', 238.0000, 'ºC'),
	(178587, 120, '2014-02-01 01:14:47.000000', 'temperatura', 626.0000, 'ºC'),
	(178588, 120, '2014-02-01 01:14:48.000000', 'temperatura', 19.0000, 'ºC'),
	(178589, 120, '2014-02-01 01:14:49.000000', 'temperatura', 617.0000, 'ºC'),
	(178590, 120, '2014-02-01 01:14:50.000000', 'temperatura', 628.0000, 'ºC'),
	(178591, 120, '2014-02-01 01:14:51.000000', 'temperatura', 88.0000, 'ºC'),
	(178592, 120, '2014-02-01 01:14:52.000000', 'temperatura', 960.0000, 'ºC'),
	(178593, 120, '2014-02-01 01:14:53.000000', 'temperatura', 933.0000, 'ºC'),
	(178594, 120, '2014-02-01 01:14:54.000000', 'temperatura', 588.0000, 'ºC'),
	(178595, 120, '2014-02-01 01:14:55.000000', 'temperatura', 142.0000, 'ºC'),
	(178596, 120, '2014-02-01 01:14:56.000000', 'temperatura', 146.0000, 'ºC'),
	(178597, 120, '2014-02-01 01:14:57.000000', 'temperatura', 305.0000, 'ºC'),
	(178598, 120, '2014-02-01 01:14:58.000000', 'temperatura', 1085.0000, 'ºC'),
	(178599, 120, '2014-02-01 01:14:59.000000', 'temperatura', 912.0000, 'ºC'),
	(178600, 120, '2014-02-01 01:15:00.000000', 'temperatura', 106.0000, 'ºC'),
	(178601, 120, '2014-02-01 01:15:01.000000', 'temperatura', 194.0000, 'ºC'),
	(178602, 120, '2014-02-01 01:15:02.000000', 'temperatura', 651.0000, 'ºC'),
	(178603, 120, '2014-02-01 01:15:03.000000', 'temperatura', 273.0000, 'ºC'),
	(178604, 120, '2014-02-01 01:15:04.000000', 'temperatura', 614.0000, 'ºC'),
	(178605, 120, '2014-02-01 01:15:05.000000', 'temperatura', 1049.0000, 'ºC'),
	(178606, 120, '2014-02-01 01:15:06.000000', 'temperatura', 1007.0000, 'ºC'),
	(178607, 120, '2014-02-01 01:15:07.000000', 'temperatura', 686.0000, 'ºC'),
	(178608, 120, '2014-02-01 01:15:08.000000', 'temperatura', 410.0000, 'ºC'),
	(178609, 120, '2014-02-01 01:15:09.000000', 'temperatura', 1192.0000, 'ºC'),
	(178610, 120, '2014-02-01 01:15:10.000000', 'temperatura', 1132.0000, 'ºC'),
	(178611, 120, '2014-02-01 01:15:11.000000', 'temperatura', 885.0000, 'ºC'),
	(178612, 120, '2014-02-01 01:15:12.000000', 'temperatura', 1029.0000, 'ºC'),
	(178613, 120, '2014-02-01 01:15:13.000000', 'temperatura', 92.0000, 'ºC'),
	(178614, 120, '2014-02-01 01:15:14.000000', 'temperatura', 973.0000, 'ºC'),
	(178615, 120, '2014-02-01 01:15:15.000000', 'temperatura', 991.0000, 'ºC'),
	(178616, 120, '2014-02-01 01:15:16.000000', 'temperatura', 835.0000, 'ºC'),
	(178617, 120, '2014-02-01 01:15:17.000000', 'temperatura', 1.0000, 'ºC'),
	(178618, 120, '2014-02-01 01:15:18.000000', 'temperatura', 1100.0000, 'ºC'),
	(178619, 120, '2014-02-01 01:15:19.000000', 'temperatura', 700.0000, 'ºC'),
	(178620, 120, '2014-02-01 01:15:20.000000', 'temperatura', 200.0000, 'ºC'),
	(178621, 120, '2014-02-01 01:15:21.000000', 'temperatura', 100.0000, 'ºC'),
	(178622, 120, '2014-02-01 01:15:22.000000', 'temperatura', 1102.0000, 'ºC'),
	(178623, 120, '2014-02-01 01:15:23.000000', 'temperatura', 409.0000, 'ºC'),
	(178624, 120, '2014-02-01 01:15:24.000000', 'temperatura', 1140.0000, 'ºC'),
	(178625, 120, '2014-02-01 01:15:25.000000', 'temperatura', 875.0000, 'ºC'),
	(178626, 120, '2014-02-01 01:15:26.000000', 'temperatura', 956.0000, 'ºC'),
	(178627, 120, '2014-02-01 01:15:27.000000', 'temperatura', 954.0000, 'ºC'),
	(178628, 120, '2014-02-01 01:15:28.000000', 'temperatura', 703.0000, 'ºC'),
	(178629, 120, '2014-02-01 01:15:29.000000', 'temperatura', 653.0000, 'ºC'),
	(178630, 120, '2014-02-01 01:15:30.000000', 'temperatura', 1156.0000, 'ºC'),
	(178631, 120, '2014-02-01 01:15:31.000000', 'temperatura', 221.0000, 'ºC'),
	(178632, 120, '2014-02-01 01:15:32.000000', 'temperatura', 37.0000, 'ºC'),
	(178633, 120, '2014-02-01 01:15:33.000000', 'temperatura', 725.0000, 'ºC'),
	(178634, 120, '2014-02-01 01:15:34.000000', 'temperatura', 1114.0000, 'ºC'),
	(178635, 120, '2014-02-01 01:15:35.000000', 'temperatura', 994.0000, 'ºC'),
	(178636, 120, '2014-02-01 01:15:36.000000', 'temperatura', 430.0000, 'ºC'),
	(178637, 120, '2014-02-01 01:15:37.000000', 'temperatura', 368.0000, 'ºC'),
	(178638, 120, '2014-02-01 01:15:38.000000', 'temperatura', 550.0000, 'ºC'),
	(178639, 120, '2014-02-01 01:15:39.000000', 'temperatura', 449.0000, 'ºC'),
	(178640, 120, '2014-02-01 01:15:40.000000', 'temperatura', 593.0000, 'ºC'),
	(178641, 120, '2014-02-01 01:15:41.000000', 'temperatura', 421.0000, 'ºC'),
	(178642, 120, '2014-02-01 01:15:42.000000', 'temperatura', 323.0000, 'ºC'),
	(178643, 120, '2014-02-01 01:15:43.000000', 'temperatura', 354.0000, 'ºC'),
	(178644, 120, '2014-02-01 01:15:44.000000', 'temperatura', 804.0000, 'ºC'),
	(178645, 120, '2014-02-01 01:15:45.000000', 'temperatura', 555.0000, 'ºC'),
	(178646, 120, '2014-02-01 01:15:46.000000', 'temperatura', 364.0000, 'ºC'),
	(178647, 120, '2014-02-01 01:15:47.000000', 'temperatura', 155.0000, 'ºC'),
	(178648, 120, '2014-02-01 01:15:48.000000', 'temperatura', 884.0000, 'ºC'),
	(178649, 120, '2014-02-01 01:15:49.000000', 'temperatura', 355.0000, 'ºC'),
	(178650, 120, '2014-02-01 01:15:50.000000', 'temperatura', 325.0000, 'ºC'),
	(178651, 120, '2014-02-01 01:15:51.000000', 'temperatura', 560.0000, 'ºC'),
	(178652, 120, '2014-02-01 01:15:52.000000', 'temperatura', 625.0000, 'ºC'),
	(178653, 120, '2014-02-01 01:15:53.000000', 'temperatura', 247.0000, 'ºC'),
	(178654, 120, '2014-02-01 01:15:54.000000', 'temperatura', 561.0000, 'ºC'),
	(178655, 120, '2014-02-01 01:15:55.000000', 'temperatura', 864.0000, 'ºC'),
	(178656, 120, '2014-02-01 01:15:56.000000', 'temperatura', 238.0000, 'ºC'),
	(178657, 120, '2014-02-01 01:15:57.000000', 'temperatura', 996.0000, 'ºC'),
	(178658, 120, '2014-02-01 01:15:58.000000', 'temperatura', 669.0000, 'ºC'),
	(178659, 120, '2014-02-01 01:15:59.000000', 'temperatura', 356.0000, 'ºC'),
	(178660, 120, '2014-02-01 01:16:00.000000', 'temperatura', 975.0000, 'ºC'),
	(178661, 120, '2014-02-01 01:16:01.000000', 'temperatura', 205.0000, 'ºC'),
	(178662, 120, '2014-02-01 01:16:02.000000', 'temperatura', 501.0000, 'ºC'),
	(178663, 120, '2014-02-01 01:16:03.000000', 'temperatura', 689.0000, 'ºC'),
	(178664, 120, '2014-02-01 01:16:04.000000', 'temperatura', 745.0000, 'ºC'),
	(178665, 120, '2014-02-01 01:16:05.000000', 'temperatura', 459.0000, 'ºC'),
	(178666, 120, '2014-02-01 01:16:06.000000', 'temperatura', 58.0000, 'ºC'),
	(178667, 120, '2014-02-01 01:16:07.000000', 'temperatura', 115.0000, 'ºC'),
	(178668, 120, '2014-02-01 01:16:08.000000', 'temperatura', 401.0000, 'ºC'),
	(178669, 120, '2014-02-01 01:16:09.000000', 'temperatura', 461.0000, 'ºC'),
	(178670, 120, '2014-02-01 01:16:10.000000', 'temperatura', 1101.0000, 'ºC'),
	(178671, 120, '2014-02-01 01:16:11.000000', 'temperatura', 525.0000, 'ºC'),
	(178672, 120, '2014-02-01 01:16:12.000000', 'temperatura', 521.0000, 'ºC'),
	(178673, 120, '2014-02-01 01:16:13.000000', 'temperatura', 1030.0000, 'ºC'),
	(178674, 120, '2014-02-01 01:16:14.000000', 'temperatura', 1189.0000, 'ºC'),
	(178675, 120, '2014-02-01 01:16:15.000000', 'temperatura', 456.0000, 'ºC'),
	(178676, 120, '2014-02-01 01:16:16.000000', 'temperatura', 1112.0000, 'ºC'),
	(178677, 120, '2014-02-01 01:16:17.000000', 'temperatura', 591.0000, 'ºC'),
	(178678, 120, '2014-02-01 01:16:18.000000', 'temperatura', 822.0000, 'ºC'),
	(178679, 120, '2014-02-01 01:16:19.000000', 'temperatura', 1138.0000, 'ºC'),
	(178680, 120, '2014-02-01 01:16:20.000000', 'temperatura', 823.0000, 'ºC'),
	(178681, 120, '2014-02-01 01:16:21.000000', 'temperatura', 704.0000, 'ºC'),
	(178682, 120, '2014-02-01 01:16:22.000000', 'temperatura', 1048.0000, 'ºC'),
	(178683, 120, '2014-02-01 01:16:23.000000', 'temperatura', 731.0000, 'ºC'),
	(178684, 120, '2014-02-01 01:16:24.000000', 'temperatura', 511.0000, 'ºC'),
	(178685, 120, '2014-02-01 01:16:25.000000', 'temperatura', 364.0000, 'ºC'),
	(178686, 120, '2014-02-01 01:16:26.000000', 'temperatura', 286.0000, 'ºC'),
	(178687, 120, '2014-02-01 01:16:27.000000', 'temperatura', 340.0000, 'ºC'),
	(178688, 120, '2014-02-01 01:16:28.000000', 'temperatura', 842.0000, 'ºC'),
	(178689, 120, '2014-02-01 01:16:29.000000', 'temperatura', 792.0000, 'ºC'),
	(178690, 120, '2014-02-01 01:16:30.000000', 'temperatura', 235.0000, 'ºC'),
	(178691, 120, '2014-02-01 01:16:31.000000', 'temperatura', 1196.0000, 'ºC'),
	(178692, 120, '2014-02-01 01:16:32.000000', 'temperatura', 479.0000, 'ºC'),
	(178693, 120, '2014-02-01 01:16:33.000000', 'temperatura', 7.0000, 'ºC'),
	(178694, 120, '2014-02-01 01:16:34.000000', 'temperatura', 997.0000, 'ºC'),
	(178695, 120, '2014-02-01 01:16:35.000000', 'temperatura', 165.0000, 'ºC'),
	(178696, 120, '2014-02-01 01:16:36.000000', 'temperatura', 234.0000, 'ºC'),
	(178697, 120, '2014-02-01 01:16:37.000000', 'temperatura', 678.0000, 'ºC'),
	(178698, 120, '2014-02-01 01:16:38.000000', 'temperatura', 287.0000, 'ºC'),
	(178699, 120, '2014-02-01 01:16:39.000000', 'temperatura', 600.0000, 'ºC'),
	(178700, 120, '2014-02-01 01:16:40.000000', 'temperatura', 941.0000, 'ºC'),
	(178701, 120, '2014-02-01 01:16:41.000000', 'temperatura', 507.0000, 'ºC'),
	(178702, 120, '2014-02-01 01:16:42.000000', 'temperatura', 912.0000, 'ºC'),
	(178703, 120, '2014-02-01 01:16:43.000000', 'temperatura', 640.0000, 'ºC'),
	(178704, 120, '2014-02-01 01:16:44.000000', 'temperatura', 462.0000, 'ºC'),
	(178705, 120, '2014-02-01 01:16:45.000000', 'temperatura', 391.0000, 'ºC'),
	(178706, 120, '2014-02-01 01:16:46.000000', 'temperatura', 572.0000, 'ºC'),
	(178707, 120, '2014-02-01 01:16:47.000000', 'temperatura', 484.0000, 'ºC'),
	(178708, 120, '2014-02-01 01:16:48.000000', 'temperatura', 708.0000, 'ºC'),
	(178709, 120, '2014-02-01 01:16:49.000000', 'temperatura', 887.0000, 'ºC'),
	(178710, 120, '2014-02-01 01:16:50.000000', 'temperatura', 1110.0000, 'ºC'),
	(178711, 120, '2014-02-01 01:16:51.000000', 'temperatura', 491.0000, 'ºC'),
	(178712, 120, '2014-02-01 01:16:52.000000', 'temperatura', 323.0000, 'ºC'),
	(178713, 120, '2014-02-01 01:16:53.000000', 'temperatura', 144.0000, 'ºC'),
	(178714, 120, '2014-02-01 01:16:54.000000', 'temperatura', 953.0000, 'ºC'),
	(178715, 120, '2014-02-01 01:16:55.000000', 'temperatura', 732.0000, 'ºC'),
	(178716, 120, '2014-02-01 01:16:56.000000', 'temperatura', 802.0000, 'ºC'),
	(178717, 120, '2014-02-01 01:16:57.000000', 'temperatura', 616.0000, 'ºC'),
	(178718, 120, '2014-02-01 01:16:58.000000', 'temperatura', 675.0000, 'ºC'),
	(178719, 120, '2014-02-01 01:16:59.000000', 'temperatura', 328.0000, 'ºC'),
	(178720, 120, '2014-02-01 01:17:00.000000', 'temperatura', 816.0000, 'ºC'),
	(178721, 120, '2014-02-01 01:17:01.000000', 'temperatura', 697.0000, 'ºC'),
	(178722, 120, '2014-02-01 01:17:02.000000', 'temperatura', 1035.0000, 'ºC'),
	(178723, 120, '2014-02-01 01:17:03.000000', 'temperatura', 687.0000, 'ºC'),
	(178724, 120, '2014-02-01 01:17:04.000000', 'temperatura', 329.0000, 'ºC'),
	(178725, 120, '2014-02-01 01:17:05.000000', 'temperatura', 783.0000, 'ºC'),
	(178726, 120, '2014-02-01 01:17:06.000000', 'temperatura', 529.0000, 'ºC'),
	(178727, 120, '2014-02-01 01:17:07.000000', 'temperatura', 297.0000, 'ºC'),
	(178728, 120, '2014-02-01 01:17:08.000000', 'temperatura', 1097.0000, 'ºC'),
	(178729, 120, '2014-02-01 01:17:09.000000', 'temperatura', 996.0000, 'ºC'),
	(178730, 120, '2014-02-01 01:17:10.000000', 'temperatura', 489.0000, 'ºC'),
	(178731, 120, '2014-02-01 01:17:11.000000', 'temperatura', 656.0000, 'ºC'),
	(178732, 120, '2014-02-01 01:17:12.000000', 'temperatura', 614.0000, 'ºC'),
	(178733, 120, '2014-02-01 01:17:13.000000', 'temperatura', 1104.0000, 'ºC'),
	(178734, 120, '2014-02-01 01:17:14.000000', 'temperatura', 76.0000, 'ºC'),
	(178735, 120, '2014-02-01 01:17:15.000000', 'temperatura', 671.0000, 'ºC'),
	(178736, 120, '2014-02-01 01:17:16.000000', 'temperatura', 726.0000, 'ºC'),
	(178737, 120, '2014-02-01 01:17:17.000000', 'temperatura', 417.0000, 'ºC'),
	(178738, 120, '2014-02-01 01:17:18.000000', 'temperatura', 1109.0000, 'ºC'),
	(178739, 120, '2014-02-01 01:17:19.000000', 'temperatura', 696.0000, 'ºC'),
	(178740, 120, '2014-02-01 01:17:20.000000', 'temperatura', 152.0000, 'ºC'),
	(178741, 120, '2014-02-01 01:17:21.000000', 'temperatura', 1071.0000, 'ºC'),
	(178742, 120, '2014-02-01 01:17:22.000000', 'temperatura', 101.0000, 'ºC'),
	(178743, 120, '2014-02-01 01:17:23.000000', 'temperatura', 893.0000, 'ºC'),
	(178744, 120, '2014-02-01 01:17:24.000000', 'temperatura', 561.0000, 'ºC'),
	(178745, 120, '2014-02-01 01:17:25.000000', 'temperatura', 129.0000, 'ºC'),
	(178746, 120, '2014-02-01 01:17:26.000000', 'temperatura', 160.0000, 'ºC'),
	(178747, 120, '2014-02-01 01:17:27.000000', 'temperatura', 413.0000, 'ºC'),
	(178748, 120, '2014-02-01 01:17:28.000000', 'temperatura', 386.0000, 'ºC'),
	(178749, 120, '2014-02-01 01:17:29.000000', 'temperatura', 692.0000, 'ºC'),
	(178750, 120, '2014-02-01 01:17:30.000000', 'temperatura', 1104.0000, 'ºC'),
	(178751, 120, '2014-02-01 01:17:31.000000', 'temperatura', 1045.0000, 'ºC'),
	(178752, 120, '2014-02-01 01:17:32.000000', 'temperatura', 710.0000, 'ºC'),
	(178753, 120, '2014-02-01 01:17:33.000000', 'temperatura', 418.0000, 'ºC'),
	(178754, 120, '2014-02-01 01:17:34.000000', 'temperatura', 1162.0000, 'ºC'),
	(178755, 120, '2014-02-01 01:17:35.000000', 'temperatura', 953.0000, 'ºC'),
	(178756, 120, '2014-02-01 01:17:36.000000', 'temperatura', 81.0000, 'ºC'),
	(178757, 120, '2014-02-01 01:17:37.000000', 'temperatura', 1146.0000, 'ºC'),
	(178758, 120, '2014-02-01 01:17:38.000000', 'temperatura', 686.0000, 'ºC'),
	(178759, 120, '2014-02-01 01:17:39.000000', 'temperatura', 1195.0000, 'ºC'),
	(178760, 120, '2014-02-01 01:17:40.000000', 'temperatura', 319.0000, 'ºC'),
	(178761, 120, '2014-02-01 01:17:41.000000', 'temperatura', 408.0000, 'ºC'),
	(178762, 120, '2014-02-01 01:17:42.000000', 'temperatura', 1083.0000, 'ºC'),
	(178763, 120, '2014-02-01 01:17:43.000000', 'temperatura', 594.0000, 'ºC'),
	(178764, 120, '2014-02-01 01:17:44.000000', 'temperatura', 918.0000, 'ºC'),
	(178765, 120, '2014-02-01 01:17:45.000000', 'temperatura', 411.0000, 'ºC'),
	(178766, 120, '2014-02-01 01:17:46.000000', 'temperatura', 501.0000, 'ºC'),
	(178767, 120, '2014-02-01 01:17:47.000000', 'temperatura', 71.0000, 'ºC'),
	(178768, 120, '2014-02-01 01:17:48.000000', 'temperatura', 54.0000, 'ºC'),
	(178769, 120, '2014-02-01 01:17:49.000000', 'temperatura', 59.0000, 'ºC'),
	(178770, 120, '2014-02-01 01:17:50.000000', 'temperatura', 132.0000, 'ºC'),
	(178771, 120, '2014-02-01 01:17:51.000000', 'temperatura', 485.0000, 'ºC'),
	(178772, 120, '2014-02-01 01:17:52.000000', 'temperatura', 828.0000, 'ºC'),
	(178773, 120, '2014-02-01 01:17:53.000000', 'temperatura', 284.0000, 'ºC'),
	(178774, 120, '2014-02-01 01:17:54.000000', 'temperatura', 140.0000, 'ºC'),
	(178775, 120, '2014-02-01 01:17:55.000000', 'temperatura', 1046.0000, 'ºC'),
	(178776, 120, '2014-02-01 01:17:56.000000', 'temperatura', 12.0000, 'ºC'),
	(178777, 120, '2014-02-01 01:17:57.000000', 'temperatura', 522.0000, 'ºC'),
	(178778, 120, '2014-02-01 01:17:58.000000', 'temperatura', 175.0000, 'ºC'),
	(178779, 120, '2014-02-01 01:17:59.000000', 'temperatura', 510.0000, 'ºC'),
	(178780, 120, '2014-02-01 01:18:00.000000', 'temperatura', 824.0000, 'ºC'),
	(178781, 120, '2014-02-01 01:18:01.000000', 'temperatura', 193.0000, 'ºC'),
	(178782, 120, '2014-02-01 01:18:02.000000', 'temperatura', 893.0000, 'ºC'),
	(178783, 120, '2014-02-01 01:18:03.000000', 'temperatura', 287.0000, 'ºC'),
	(178784, 120, '2014-02-01 01:18:04.000000', 'temperatura', 1157.0000, 'ºC'),
	(178785, 120, '2014-02-01 01:18:05.000000', 'temperatura', 124.0000, 'ºC'),
	(178786, 120, '2014-02-01 01:18:06.000000', 'temperatura', 750.0000, 'ºC'),
	(178787, 120, '2014-02-01 01:18:07.000000', 'temperatura', 977.0000, 'ºC'),
	(178788, 120, '2014-02-01 01:18:08.000000', 'temperatura', 238.0000, 'ºC'),
	(178789, 120, '2014-02-01 01:18:09.000000', 'temperatura', 659.0000, 'ºC'),
	(178790, 120, '2014-02-01 01:18:10.000000', 'temperatura', 183.0000, 'ºC'),
	(178791, 120, '2014-02-01 01:18:11.000000', 'temperatura', 135.0000, 'ºC'),
	(178792, 120, '2014-02-01 01:18:12.000000', 'temperatura', 129.0000, 'ºC'),
	(178793, 120, '2014-02-01 01:18:13.000000', 'temperatura', 242.0000, 'ºC'),
	(178794, 120, '2014-02-01 01:18:14.000000', 'temperatura', 821.0000, 'ºC'),
	(178795, 120, '2014-02-01 01:18:15.000000', 'temperatura', 979.0000, 'ºC'),
	(178796, 120, '2014-02-01 01:18:16.000000', 'temperatura', 32.0000, 'ºC'),
	(178797, 120, '2014-02-01 01:18:17.000000', 'temperatura', 823.0000, 'ºC'),
	(178798, 120, '2014-02-01 01:18:18.000000', 'temperatura', 421.0000, 'ºC'),
	(178799, 120, '2014-02-01 01:18:19.000000', 'temperatura', 837.0000, 'ºC'),
	(178800, 120, '2014-02-01 01:18:20.000000', 'temperatura', 522.0000, 'ºC'),
	(178801, 120, '2014-02-01 01:18:21.000000', 'temperatura', 101.0000, 'ºC'),
	(178802, 120, '2014-02-01 01:18:22.000000', 'temperatura', 137.0000, 'ºC'),
	(178803, 120, '2014-02-01 01:18:23.000000', 'temperatura', 381.0000, 'ºC'),
	(178804, 120, '2014-02-01 01:18:24.000000', 'temperatura', 298.0000, 'ºC'),
	(178805, 120, '2014-02-01 01:18:25.000000', 'temperatura', 348.0000, 'ºC'),
	(178806, 120, '2014-02-01 01:18:26.000000', 'temperatura', 845.0000, 'ºC'),
	(178807, 120, '2014-02-01 01:18:27.000000', 'temperatura', 781.0000, 'ºC'),
	(178808, 120, '2014-02-01 01:18:28.000000', 'temperatura', 171.0000, 'ºC'),
	(178809, 120, '2014-02-01 01:18:29.000000', 'temperatura', 913.0000, 'ºC'),
	(178810, 120, '2014-02-01 01:18:30.000000', 'temperatura', 451.0000, 'ºC'),
	(178811, 120, '2014-02-01 01:18:31.000000', 'temperatura', 716.0000, 'ºC'),
	(178812, 120, '2014-02-01 01:18:32.000000', 'temperatura', 1029.0000, 'ºC'),
	(178813, 120, '2014-02-01 01:18:33.000000', 'temperatura', 596.0000, 'ºC'),
	(178814, 120, '2014-02-01 01:18:34.000000', 'temperatura', 1094.0000, 'ºC'),
	(178815, 120, '2014-02-01 01:18:35.000000', 'temperatura', 82.0000, 'ºC'),
	(178816, 120, '2014-02-01 01:18:36.000000', 'temperatura', 727.0000, 'ºC'),
	(178817, 120, '2014-02-01 01:18:37.000000', 'temperatura', 991.0000, 'ºC'),
	(178818, 120, '2014-02-01 01:18:38.000000', 'temperatura', 373.0000, 'ºC'),
	(178819, 120, '2014-02-01 01:18:39.000000', 'temperatura', 92.0000, 'ºC'),
	(178820, 120, '2014-02-01 01:18:40.000000', 'temperatura', 542.0000, 'ºC'),
	(178821, 120, '2014-02-01 01:18:41.000000', 'temperatura', 36.0000, 'ºC'),
	(178822, 120, '2014-02-01 01:18:42.000000', 'temperatura', 952.0000, 'ºC'),
	(178823, 120, '2014-02-01 01:18:43.000000', 'temperatura', 1052.0000, 'ºC'),
	(178824, 120, '2014-02-01 01:18:44.000000', 'temperatura', 7.0000, 'ºC'),
	(178825, 120, '2014-02-01 01:18:45.000000', 'temperatura', 477.0000, 'ºC'),
	(178826, 120, '2014-02-01 01:18:46.000000', 'temperatura', 1166.0000, 'ºC'),
	(178827, 120, '2014-02-01 01:18:47.000000', 'temperatura', 801.0000, 'ºC'),
	(178828, 120, '2014-02-01 01:18:48.000000', 'temperatura', 507.0000, 'ºC'),
	(178829, 120, '2014-02-01 01:18:49.000000', 'temperatura', 130.0000, 'ºC'),
	(178830, 120, '2014-02-01 01:18:50.000000', 'temperatura', 331.0000, 'ºC'),
	(178831, 120, '2014-02-01 01:18:51.000000', 'temperatura', 67.0000, 'ºC'),
	(178832, 120, '2014-02-01 01:18:52.000000', 'temperatura', 540.0000, 'ºC'),
	(178833, 120, '2014-02-01 01:18:53.000000', 'temperatura', 102.0000, 'ºC'),
	(178834, 120, '2014-02-01 01:18:54.000000', 'temperatura', 91.0000, 'ºC'),
	(178835, 120, '2014-02-01 01:18:55.000000', 'temperatura', 146.0000, 'ºC'),
	(178836, 120, '2014-02-01 01:18:56.000000', 'temperatura', 461.0000, 'ºC'),
	(178837, 120, '2014-02-01 01:18:57.000000', 'temperatura', 665.0000, 'ºC'),
	(178838, 120, '2014-02-01 01:18:58.000000', 'temperatura', 742.0000, 'ºC'),
	(178839, 120, '2014-02-01 01:18:59.000000', 'temperatura', 518.0000, 'ºC'),
	(178840, 120, '2014-02-01 01:19:00.000000', 'temperatura', 365.0000, 'ºC'),
	(178841, 120, '2014-02-01 01:19:01.000000', 'temperatura', 272.0000, 'ºC'),
	(178842, 120, '2014-02-01 01:19:02.000000', 'temperatura', 263.0000, 'ºC'),
	(178843, 120, '2014-02-01 01:19:03.000000', 'temperatura', 501.0000, 'ºC'),
	(178844, 120, '2014-02-01 01:19:04.000000', 'temperatura', 514.0000, 'ºC'),
	(178845, 120, '2014-02-01 01:19:05.000000', 'temperatura', 1069.0000, 'ºC'),
	(178846, 120, '2014-02-01 01:19:06.000000', 'temperatura', 205.0000, 'ºC'),
	(178847, 120, '2014-02-01 01:19:07.000000', 'temperatura', 217.0000, 'ºC'),
	(178848, 120, '2014-02-01 01:19:08.000000', 'temperatura', 471.0000, 'ºC'),
	(178849, 120, '2014-02-01 01:19:09.000000', 'temperatura', 502.0000, 'ºC'),
	(178850, 120, '2014-02-01 01:19:10.000000', 'temperatura', 1100.0000, 'ºC'),
	(178851, 120, '2014-02-01 01:19:11.000000', 'temperatura', 394.0000, 'ºC'),
	(178852, 120, '2014-02-01 01:19:12.000000', 'temperatura', 1072.0000, 'ºC'),
	(178853, 120, '2014-02-01 01:19:13.000000', 'temperatura', 578.0000, 'ºC'),
	(178854, 120, '2014-02-01 01:19:14.000000', 'temperatura', 873.0000, 'ºC'),
	(178855, 120, '2014-02-01 01:19:15.000000', 'temperatura', 232.0000, 'ºC'),
	(178856, 120, '2014-02-01 01:19:16.000000', 'temperatura', 940.0000, 'ºC'),
	(178857, 120, '2014-02-01 01:19:17.000000', 'temperatura', 406.0000, 'ºC'),
	(178858, 120, '2014-02-01 01:19:18.000000', 'temperatura', 411.0000, 'ºC'),
	(178859, 120, '2014-02-01 01:19:19.000000', 'temperatura', 837.0000, 'ºC'),
	(178860, 120, '2014-02-01 01:19:20.000000', 'temperatura', 554.0000, 'ºC'),
	(178861, 120, '2014-02-01 01:19:21.000000', 'temperatura', 258.0000, 'ºC'),
	(178862, 120, '2014-02-01 01:19:22.000000', 'temperatura', 827.0000, 'ºC'),
	(178863, 120, '2014-02-01 01:19:23.000000', 'temperatura', 964.0000, 'ºC'),
	(178864, 120, '2014-02-01 01:19:24.000000', 'temperatura', 1138.0000, 'ºC'),
	(178865, 120, '2014-02-01 01:19:25.000000', 'temperatura', 400.0000, 'ºC'),
	(178866, 120, '2014-02-01 01:19:26.000000', 'temperatura', 985.0000, 'ºC'),
	(178867, 120, '2014-02-01 01:19:27.000000', 'temperatura', 124.0000, 'ºC'),
	(178868, 120, '2014-02-01 01:19:28.000000', 'temperatura', 67.0000, 'ºC'),
	(178869, 120, '2014-02-01 01:19:29.000000', 'temperatura', 1164.0000, 'ºC'),
	(178870, 120, '2014-02-01 01:19:30.000000', 'temperatura', 817.0000, 'ºC'),
	(178871, 120, '2014-02-01 01:19:31.000000', 'temperatura', 596.0000, 'ºC'),
	(178872, 120, '2014-02-01 01:19:32.000000', 'temperatura', 530.0000, 'ºC'),
	(178873, 120, '2014-02-01 01:19:33.000000', 'temperatura', 863.0000, 'ºC'),
	(178874, 120, '2014-02-01 01:19:34.000000', 'temperatura', 324.0000, 'ºC'),
	(178875, 120, '2014-02-01 01:19:35.000000', 'temperatura', 231.0000, 'ºC'),
	(178876, 120, '2014-02-01 01:19:36.000000', 'temperatura', 185.0000, 'ºC'),
	(178877, 120, '2014-02-01 01:19:37.000000', 'temperatura', 232.0000, 'ºC'),
	(178878, 120, '2014-02-01 01:19:38.000000', 'temperatura', 604.0000, 'ºC'),
	(178879, 120, '2014-02-01 01:19:39.000000', 'temperatura', 1123.0000, 'ºC'),
	(178880, 120, '2014-02-01 01:19:40.000000', 'temperatura', 207.0000, 'ºC'),
	(178881, 120, '2014-02-01 01:19:41.000000', 'temperatura', 66.0000, 'ºC'),
	(178882, 120, '2014-02-01 01:19:42.000000', 'temperatura', 908.0000, 'ºC'),
	(178883, 120, '2014-02-01 01:19:43.000000', 'temperatura', 744.0000, 'ºC'),
	(178884, 120, '2014-02-01 01:19:44.000000', 'temperatura', 996.0000, 'ºC'),
	(178885, 120, '2014-02-01 01:19:45.000000', 'temperatura', 349.0000, 'ºC'),
	(178886, 120, '2014-02-01 01:19:46.000000', 'temperatura', 1155.0000, 'ºC'),
	(178887, 120, '2014-02-01 01:19:47.000000', 'temperatura', 1131.0000, 'ºC'),
	(178888, 120, '2014-02-01 01:19:48.000000', 'temperatura', 991.0000, 'ºC'),
	(178889, 120, '2014-02-01 01:19:49.000000', 'temperatura', 361.0000, 'ºC'),
	(178890, 120, '2014-02-01 01:19:50.000000', 'temperatura', 31.0000, 'ºC'),
	(178891, 120, '2014-02-01 01:19:51.000000', 'temperatura', 275.0000, 'ºC'),
	(178892, 120, '2014-02-01 01:19:52.000000', 'temperatura', 81.0000, 'ºC'),
	(178893, 120, '2014-02-01 01:19:53.000000', 'temperatura', 780.0000, 'ºC'),
	(178894, 120, '2014-02-01 01:19:54.000000', 'temperatura', 59.0000, 'ºC'),
	(178895, 120, '2014-02-01 01:19:55.000000', 'temperatura', 354.0000, 'ºC'),
	(178896, 120, '2014-02-01 01:19:56.000000', 'temperatura', 395.0000, 'ºC'),
	(178897, 120, '2014-02-01 01:19:57.000000', 'temperatura', 911.0000, 'ºC'),
	(178898, 120, '2014-02-01 01:19:58.000000', 'temperatura', 971.0000, 'ºC'),
	(178899, 120, '2014-02-01 01:19:59.000000', 'temperatura', 925.0000, 'ºC'),
	(178900, 120, '2014-02-01 01:20:00.000000', 'temperatura', 510.0000, 'ºC'),
	(178901, 120, '2014-02-01 01:20:01.000000', 'temperatura', 978.0000, 'ºC'),
	(178902, 120, '2014-02-01 01:20:02.000000', 'temperatura', 958.0000, 'ºC'),
	(178903, 120, '2014-02-01 01:20:03.000000', 'temperatura', 656.0000, 'ºC'),
	(178904, 120, '2014-02-01 01:20:04.000000', 'temperatura', 407.0000, 'ºC'),
	(178905, 120, '2014-02-01 01:20:05.000000', 'temperatura', 69.0000, 'ºC'),
	(178906, 120, '2014-02-01 01:20:06.000000', 'temperatura', 323.0000, 'ºC'),
	(178907, 120, '2014-02-01 01:20:07.000000', 'temperatura', 210.0000, 'ºC'),
	(178908, 120, '2014-02-01 01:20:08.000000', 'temperatura', 82.0000, 'ºC'),
	(178909, 120, '2014-02-01 01:20:09.000000', 'temperatura', 978.0000, 'ºC'),
	(178910, 120, '2014-02-01 01:20:10.000000', 'temperatura', 1046.0000, 'ºC'),
	(178911, 120, '2014-02-01 01:20:11.000000', 'temperatura', 1094.0000, 'ºC'),
	(178912, 120, '2014-02-01 01:20:12.000000', 'temperatura', 1136.0000, 'ºC'),
	(178913, 120, '2014-02-01 01:20:13.000000', 'temperatura', 1196.0000, 'ºC'),
	(178914, 120, '2014-02-01 01:20:14.000000', 'temperatura', 173.0000, 'ºC'),
	(178915, 120, '2014-02-01 01:20:15.000000', 'temperatura', 876.0000, 'ºC'),
	(178916, 120, '2014-02-01 01:20:16.000000', 'temperatura', 261.0000, 'ºC'),
	(178917, 120, '2014-02-01 01:20:17.000000', 'temperatura', 1079.0000, 'ºC'),
	(178918, 120, '2014-02-01 01:20:18.000000', 'temperatura', 1013.0000, 'ºC'),
	(178919, 120, '2014-02-01 01:20:19.000000', 'temperatura', 628.0000, 'ºC'),
	(178920, 120, '2014-02-01 01:20:20.000000', 'temperatura', 103.0000, 'ºC'),
	(178921, 120, '2014-02-01 01:20:21.000000', 'temperatura', 1029.0000, 'ºC'),
	(178922, 120, '2014-02-01 01:20:22.000000', 'temperatura', 39.0000, 'ºC'),
	(178923, 120, '2014-02-01 01:20:23.000000', 'temperatura', 709.0000, 'ºC'),
	(178924, 120, '2014-02-01 01:20:24.000000', 'temperatura', 1029.0000, 'ºC'),
	(178925, 120, '2014-02-01 01:20:25.000000', 'temperatura', 615.0000, 'ºC'),
	(178926, 120, '2014-02-01 01:20:26.000000', 'temperatura', 1192.0000, 'ºC'),
	(178927, 120, '2014-02-01 01:20:27.000000', 'temperatura', 513.0000, 'ºC'),
	(178928, 120, '2014-02-01 01:20:28.000000', 'temperatura', 191.0000, 'ºC'),
	(178929, 120, '2014-02-01 01:20:29.000000', 'temperatura', 616.0000, 'ºC'),
	(178930, 120, '2014-02-01 01:20:30.000000', 'temperatura', 106.0000, 'ºC'),
	(178931, 120, '2014-02-01 01:20:31.000000', 'temperatura', 1085.0000, 'ºC'),
	(178932, 120, '2014-02-01 01:20:32.000000', 'temperatura', 308.0000, 'ºC'),
	(178933, 120, '2014-02-01 01:20:33.000000', 'temperatura', 683.0000, 'ºC'),
	(178934, 120, '2014-02-01 01:20:34.000000', 'temperatura', 93.0000, 'ºC'),
	(178935, 120, '2014-02-01 01:20:35.000000', 'temperatura', 816.0000, 'ºC'),
	(178936, 120, '2014-02-01 01:20:36.000000', 'temperatura', 201.0000, 'ºC'),
	(178937, 120, '2014-02-01 01:20:37.000000', 'temperatura', 958.0000, 'ºC'),
	(178938, 120, '2014-02-01 01:20:38.000000', 'temperatura', 586.0000, 'ºC'),
	(178939, 120, '2014-02-01 01:20:39.000000', 'temperatura', 60.0000, 'ºC'),
	(178940, 120, '2014-02-01 01:20:40.000000', 'temperatura', 939.0000, 'ºC'),
	(178941, 120, '2014-02-01 01:20:41.000000', 'temperatura', 918.0000, 'ºC'),
	(178942, 120, '2014-02-01 01:20:42.000000', 'temperatura', 572.0000, 'ºC'),
	(178943, 120, '2014-02-01 01:20:43.000000', 'temperatura', 109.0000, 'ºC'),
	(178944, 120, '2014-02-01 01:20:44.000000', 'temperatura', 26.0000, 'ºC'),
	(178945, 120, '2014-02-01 01:20:45.000000', 'temperatura', 1005.0000, 'ºC'),
	(178946, 120, '2014-02-01 01:20:46.000000', 'temperatura', 146.0000, 'ºC'),
	(178947, 120, '2014-02-01 01:20:47.000000', 'temperatura', 116.0000, 'ºC'),
	(178948, 120, '2014-02-01 01:20:48.000000', 'temperatura', 142.0000, 'ºC'),
	(178949, 120, '2014-02-01 01:20:49.000000', 'temperatura', 365.0000, 'ºC'),
	(178950, 120, '2014-02-01 01:20:50.000000', 'temperatura', 197.0000, 'ºC'),
	(178951, 120, '2014-02-01 01:20:51.000000', 'temperatura', 1089.0000, 'ºC'),
	(178952, 120, '2014-02-01 01:20:52.000000', 'temperatura', 58.0000, 'ºC'),
	(178953, 120, '2014-02-01 01:20:53.000000', 'temperatura', 621.0000, 'ºC'),
	(178954, 120, '2014-02-01 01:20:54.000000', 'temperatura', 532.0000, 'ºC'),
	(178955, 120, '2014-02-01 01:20:55.000000', 'temperatura', 797.0000, 'ºC'),
	(178956, 120, '2014-02-01 01:20:56.000000', 'temperatura', 1192.0000, 'ºC'),
	(178957, 120, '2014-02-01 01:20:57.000000', 'temperatura', 1168.0000, 'ºC'),
	(178958, 120, '2014-02-01 01:20:58.000000', 'temperatura', 1066.0000, 'ºC'),
	(178959, 120, '2014-02-01 01:20:59.000000', 'temperatura', 624.0000, 'ºC'),
	(178960, 120, '2014-02-01 01:21:00.000000', 'temperatura', 1122.0000, 'ºC'),
	(178961, 120, '2014-02-01 01:21:01.000000', 'temperatura', 140.0000, 'ºC'),
	(178962, 120, '2014-02-01 01:21:02.000000', 'temperatura', 936.0000, 'ºC'),
	(178963, 120, '2014-02-01 01:21:03.000000', 'temperatura', 657.0000, 'ºC'),
	(178964, 120, '2014-02-01 01:21:04.000000', 'temperatura', 480.0000, 'ºC'),
	(178965, 120, '2014-02-01 01:21:05.000000', 'temperatura', 428.0000, 'ºC'),
	(178966, 120, '2014-02-01 01:21:06.000000', 'temperatura', 701.0000, 'ºC'),
	(178967, 120, '2014-02-01 01:21:07.000000', 'temperatura', 1024.0000, 'ºC'),
	(178968, 120, '2014-02-01 01:21:08.000000', 'temperatura', 614.0000, 'ºC'),
	(178969, 120, '2014-02-01 01:21:09.000000', 'temperatura', 2.0000, 'ºC'),
	(178970, 120, '2014-02-01 01:21:10.000000', 'temperatura', 566.0000, 'ºC'),
	(178971, 120, '2014-02-01 01:21:11.000000', 'temperatura', 425.0000, 'ºC'),
	(178972, 120, '2014-02-01 01:21:12.000000', 'temperatura', 428.0000, 'ºC'),
	(178973, 120, '2014-02-01 01:21:13.000000', 'temperatura', 864.0000, 'ºC'),
	(178974, 120, '2014-02-01 01:21:14.000000', 'temperatura', 636.0000, 'ºC'),
	(178975, 120, '2014-02-01 01:21:15.000000', 'temperatura', 589.0000, 'ºC'),
	(178976, 120, '2014-02-01 01:21:16.000000', 'temperatura', 1038.0000, 'ºC'),
	(178977, 120, '2014-02-01 01:21:17.000000', 'temperatura', 1023.0000, 'ºC'),
	(178978, 120, '2014-02-01 01:21:18.000000', 'temperatura', 801.0000, 'ºC'),
	(178979, 120, '2014-02-01 01:21:19.000000', 'temperatura', 939.0000, 'ºC'),
	(178980, 120, '2014-02-01 01:21:20.000000', 'temperatura', 1090.0000, 'ºC'),
	(178981, 120, '2014-02-01 01:21:21.000000', 'temperatura', 234.0000, 'ºC'),
	(178982, 120, '2014-02-01 01:21:22.000000', 'temperatura', 301.0000, 'ºC'),
	(178983, 120, '2014-02-01 01:21:23.000000', 'temperatura', 802.0000, 'ºC'),
	(178984, 120, '2014-02-01 01:21:24.000000', 'temperatura', 710.0000, 'ºC'),
	(178985, 120, '2014-02-01 01:21:25.000000', 'temperatura', 1144.0000, 'ºC'),
	(178986, 120, '2014-02-01 01:21:26.000000', 'temperatura', 1191.0000, 'ºC'),
	(178987, 120, '2014-02-01 01:21:27.000000', 'temperatura', 124.0000, 'ºC'),
	(178988, 120, '2014-02-01 01:21:28.000000', 'temperatura', 648.0000, 'ºC'),
	(178989, 120, '2014-02-01 01:21:29.000000', 'temperatura', 466.0000, 'ºC'),
	(178990, 120, '2014-02-01 01:21:30.000000', 'temperatura', 387.0000, 'ºC'),
	(178991, 120, '2014-02-01 01:21:31.000000', 'temperatura', 538.0000, 'ºC'),
	(178992, 120, '2014-02-01 01:21:32.000000', 'temperatura', 331.0000, 'ºC'),
	(178993, 120, '2014-02-01 01:21:33.000000', 'temperatura', 39.0000, 'ºC'),
	(178994, 120, '2014-02-01 01:21:34.000000', 'temperatura', 403.0000, 'ºC'),
	(178995, 120, '2014-02-01 01:21:35.000000', 'temperatura', 699.0000, 'ºC'),
	(178996, 120, '2014-02-01 01:21:36.000000', 'temperatura', 1087.0000, 'ºC'),
	(178997, 120, '2014-02-01 01:21:37.000000', 'temperatura', 939.0000, 'ºC'),
	(178998, 120, '2014-02-01 01:21:38.000000', 'temperatura', 232.0000, 'ºC'),
	(178999, 120, '2014-02-01 01:21:39.000000', 'temperatura', 746.0000, 'ºC'),
	(179000, 120, '2014-02-01 01:21:40.000000', 'temperatura', 632.0000, 'ºC'),
	(179001, 120, '2014-02-01 01:21:41.000000', 'temperatura', 922.0000, 'ºC'),
	(179002, 120, '2014-02-01 01:21:42.000000', 'temperatura', 316.0000, 'ºC'),
	(179003, 120, '2014-02-01 01:21:43.000000', 'temperatura', 15.0000, 'ºC'),
	(179004, 120, '2014-02-01 01:21:44.000000', 'temperatura', 325.0000, 'ºC'),
	(179005, 120, '2014-02-01 01:21:45.000000', 'temperatura', 383.0000, 'ºC'),
	(179006, 120, '2014-02-01 01:21:46.000000', 'temperatura', 938.0000, 'ºC'),
	(179007, 120, '2014-02-01 01:21:47.000000', 'temperatura', 1142.0000, 'ºC'),
	(179008, 120, '2014-02-01 01:21:48.000000', 'temperatura', 495.0000, 'ºC'),
	(179009, 120, '2014-02-01 01:21:49.000000', 'temperatura', 252.0000, 'ºC'),
	(179010, 120, '2014-02-01 01:21:50.000000', 'temperatura', 975.0000, 'ºC'),
	(179011, 120, '2014-02-01 01:21:51.000000', 'temperatura', 521.0000, 'ºC'),
	(179012, 120, '2014-02-01 01:21:52.000000', 'temperatura', 879.0000, 'ºC'),
	(179013, 120, '2014-02-01 01:21:53.000000', 'temperatura', 433.0000, 'ºC'),
	(179014, 120, '2014-02-01 01:21:54.000000', 'temperatura', 730.0000, 'ºC'),
	(179015, 120, '2014-02-01 01:21:55.000000', 'temperatura', 1152.0000, 'ºC'),
	(179016, 120, '2014-02-01 01:21:56.000000', 'temperatura', 1169.0000, 'ºC'),
	(179017, 120, '2014-02-01 01:21:57.000000', 'temperatura', 1190.0000, 'ºC'),
	(179018, 120, '2014-02-01 01:21:58.000000', 'temperatura', 42.0000, 'ºC'),
	(179019, 120, '2014-02-01 01:21:59.000000', 'temperatura', 241.0000, 'ºC'),
	(179020, 120, '2014-02-01 01:22:00.000000', 'temperatura', 1079.0000, 'ºC'),
	(179021, 120, '2014-02-01 01:22:01.000000', 'temperatura', 1074.0000, 'ºC'),
	(179022, 120, '2014-02-01 01:22:02.000000', 'temperatura', 933.0000, 'ºC'),
	(179023, 120, '2014-02-01 01:22:03.000000', 'temperatura', 244.0000, 'ºC'),
	(179024, 120, '2014-02-01 01:22:04.000000', 'temperatura', 822.0000, 'ºC'),
	(179025, 120, '2014-02-01 01:22:05.000000', 'temperatura', 980.0000, 'ºC'),
	(179026, 120, '2014-02-01 01:22:06.000000', 'temperatura', 32.0000, 'ºC'),
	(179027, 120, '2014-02-01 01:22:07.000000', 'temperatura', 821.0000, 'ºC'),
	(179028, 120, '2014-02-01 01:22:08.000000', 'temperatura', 408.0000, 'ºC'),
	(179029, 120, '2014-02-01 01:22:09.000000', 'temperatura', 780.0000, 'ºC'),
	(179030, 120, '2014-02-01 01:22:10.000000', 'temperatura', 275.0000, 'ºC'),
	(179031, 120, '2014-02-01 01:22:11.000000', 'temperatura', 237.0000, 'ºC'),
	(179032, 120, '2014-02-01 01:22:12.000000', 'temperatura', 361.0000, 'ºC'),
	(179033, 120, '2014-02-01 01:22:13.000000', 'temperatura', 1094.0000, 'ºC'),
	(179034, 120, '2014-02-01 01:22:14.000000', 'temperatura', 789.0000, 'ºC'),
	(179035, 120, '2014-02-01 01:22:15.000000', 'temperatura', 662.0000, 'ºC'),
	(179036, 120, '2014-02-01 01:22:16.000000', 'temperatura', 944.0000, 'ºC'),
	(179037, 120, '2014-02-01 01:22:17.000000', 'temperatura', 336.0000, 'ºC'),
	(179038, 120, '2014-02-01 01:22:18.000000', 'temperatura', 49.0000, 'ºC'),
	(179039, 120, '2014-02-01 01:22:19.000000', 'temperatura', 436.0000, 'ºC'),
	(179040, 120, '2014-02-01 01:22:20.000000', 'temperatura', 835.0000, 'ºC'),
	(179041, 120, '2014-02-01 01:22:21.000000', 'temperatura', 465.0000, 'ºC'),
	(179042, 120, '2014-02-01 01:22:22.000000', 'temperatura', 1024.0000, 'ºC'),
	(179043, 120, '2014-02-01 01:22:23.000000', 'temperatura', 122.0000, 'ºC'),
	(179044, 120, '2014-02-01 01:22:24.000000', 'temperatura', 1138.0000, 'ºC'),
	(179045, 120, '2014-02-01 01:22:25.000000', 'temperatura', 528.0000, 'ºC'),
	(179046, 120, '2014-02-01 01:22:26.000000', 'temperatura', 424.0000, 'ºC'),
	(179047, 120, '2014-02-01 01:22:27.000000', 'temperatura', 535.0000, 'ºC'),
	(179048, 120, '2014-02-01 01:22:28.000000', 'temperatura', 207.0000, 'ºC'),
	(179049, 120, '2014-02-01 01:22:29.000000', 'temperatura', 628.0000, 'ºC'),
	(179050, 120, '2014-02-01 01:22:30.000000', 'temperatura', 121.0000, 'ºC'),
	(179051, 120, '2014-02-01 01:22:31.000000', 'temperatura', 1120.0000, 'ºC'),
	(179052, 120, '2014-02-01 01:22:32.000000', 'temperatura', 438.0000, 'ºC'),
	(179053, 120, '2014-02-01 01:22:33.000000', 'temperatura', 32.0000, 'ºC'),
	(179054, 120, '2014-02-01 01:22:34.000000', 'temperatura', 43.0000, 'ºC'),
	(179055, 120, '2014-02-01 01:22:35.000000', 'temperatura', 123.0000, 'ºC'),
	(179056, 120, '2014-02-01 01:22:36.000000', 'temperatura', 487.0000, 'ºC'),
	(179057, 120, '2014-02-01 01:22:37.000000', 'temperatura', 866.0000, 'ºC'),
	(179058, 120, '2014-02-01 01:22:38.000000', 'temperatura', 468.0000, 'ºC'),
	(179059, 120, '2014-02-01 01:22:39.000000', 'temperatura', 945.0000, 'ºC'),
	(179060, 120, '2014-02-01 01:22:40.000000', 'temperatura', 919.0000, 'ºC'),
	(179061, 120, '2014-02-01 01:22:41.000000', 'temperatura', 559.0000, 'ºC'),
	(179062, 120, '2014-02-01 01:22:42.000000', 'temperatura', 41.0000, 'ºC'),
	(179063, 120, '2014-02-01 01:22:43.000000', 'temperatura', 929.0000, 'ºC'),
	(179064, 120, '2014-02-01 01:22:44.000000', 'temperatura', 921.0000, 'ºC'),
	(179065, 120, '2014-02-01 01:22:45.000000', 'temperatura', 619.0000, 'ºC'),
	(179066, 120, '2014-02-01 01:22:46.000000', 'temperatura', 332.0000, 'ºC'),
	(179067, 120, '2014-02-01 01:22:47.000000', 'temperatura', 1006.0000, 'ºC'),
	(179068, 120, '2014-02-01 01:22:48.000000', 'temperatura', 433.0000, 'ºC'),
	(179069, 120, '2014-02-01 01:22:49.000000', 'temperatura', 347.0000, 'ºC'),
	(179070, 120, '2014-02-01 01:22:50.000000', 'temperatura', 436.0000, 'ºC'),
	(179071, 120, '2014-02-01 01:22:51.000000', 'temperatura', 1140.0000, 'ºC'),
	(179072, 120, '2014-02-01 01:22:52.000000', 'temperatura', 791.0000, 'ºC'),
	(179073, 120, '2014-02-01 01:22:53.000000', 'temperatura', 535.0000, 'ºC'),
	(179074, 120, '2014-02-01 01:22:54.000000', 'temperatura', 303.0000, 'ºC'),
	(179075, 120, '2014-02-01 01:22:55.000000', 'temperatura', 1111.0000, 'ºC'),
	(179076, 120, '2014-02-01 01:22:56.000000', 'temperatura', 1044.0000, 'ºC'),
	(179077, 120, '2014-02-01 01:22:57.000000', 'temperatura', 691.0000, 'ºC'),
	(179078, 120, '2014-02-01 01:22:58.000000', 'temperatura', 321.0000, 'ºC'),
	(179079, 120, '2014-02-01 01:22:59.000000', 'temperatura', 732.0000, 'ºC'),
	(179080, 120, '2014-02-01 01:23:00.000000', 'temperatura', 299.0000, 'ºC'),
	(179081, 120, '2014-02-01 01:23:01.000000', 'temperatura', 501.0000, 'ºC'),
	(179082, 120, '2014-02-01 01:23:02.000000', 'temperatura', 408.0000, 'ºC'),
	(179083, 120, '2014-02-01 01:23:03.000000', 'temperatura', 535.0000, 'ºC'),
	(179084, 120, '2014-02-01 01:23:04.000000', 'temperatura', 253.0000, 'ºC'),
	(179085, 120, '2014-02-01 01:23:05.000000', 'temperatura', 859.0000, 'ºC'),
	(179086, 120, '2014-02-01 01:23:06.000000', 'temperatura', 1137.0000, 'ºC'),
	(179087, 120, '2014-02-01 01:23:07.000000', 'temperatura', 710.0000, 'ºC'),
	(179088, 120, '2014-02-01 01:23:08.000000', 'temperatura', 140.0000, 'ºC'),
	(179089, 120, '2014-02-01 01:23:09.000000', 'temperatura', 969.0000, 'ºC'),
	(179090, 120, '2014-02-01 01:23:10.000000', 'temperatura', 828.0000, 'ºC'),
	(179091, 120, '2014-02-01 01:23:11.000000', 'temperatura', 31.0000, 'ºC'),
	(179092, 120, '2014-02-01 01:23:12.000000', 'temperatura', 74.0000, 'ºC'),
	(179093, 120, '2014-02-01 01:23:13.000000', 'temperatura', 274.0000, 'ºC'),
	(179094, 120, '2014-02-01 01:23:14.000000', 'temperatura', 1152.0000, 'ºC'),
	(179095, 120, '2014-02-01 01:23:15.000000', 'temperatura', 136.0000, 'ºC'),
	(179096, 120, '2014-02-01 01:23:16.000000', 'temperatura', 826.0000, 'ºC'),
	(179097, 120, '2014-02-01 01:23:17.000000', 'temperatura', 123.0000, 'ºC'),
	(179098, 120, '2014-02-01 01:23:18.000000', 'temperatura', 536.0000, 'ºC'),
	(179099, 120, '2014-02-01 01:23:19.000000', 'temperatura', 1114.0000, 'ºC'),
	(179100, 120, '2014-02-01 01:23:20.000000', 'temperatura', 359.0000, 'ºC'),
	(179101, 120, '2014-02-01 01:23:21.000000', 'temperatura', 857.0000, 'ºC'),
	(179102, 120, '2014-02-01 01:23:22.000000', 'temperatura', 806.0000, 'ºC'),
	(179103, 120, '2014-02-01 01:23:23.000000', 'temperatura', 259.0000, 'ºC'),
	(179104, 120, '2014-02-01 01:23:24.000000', 'temperatura', 77.0000, 'ºC'),
	(179105, 120, '2014-02-01 01:23:25.000000', 'temperatura', 811.0000, 'ºC'),
	(179106, 120, '2014-02-01 01:23:26.000000', 'temperatura', 223.0000, 'ºC'),
	(179107, 120, '2014-02-01 01:23:27.000000', 'temperatura', 1082.0000, 'ºC'),
	(179108, 120, '2014-02-01 01:23:28.000000', 'temperatura', 1142.0000, 'ºC'),
	(179109, 120, '2014-02-01 01:23:29.000000', 'temperatura', 65.0000, 'ºC'),
	(179110, 120, '2014-02-01 01:23:30.000000', 'temperatura', 499.0000, 'ºC'),
	(179111, 120, '2014-02-01 01:23:31.000000', 'temperatura', 1100.0000, 'ºC'),
	(179112, 120, '2014-02-01 01:23:32.000000', 'temperatura', 404.0000, 'ºC'),
	(179113, 120, '2014-02-01 01:23:33.000000', 'temperatura', 1119.0000, 'ºC'),
	(179114, 120, '2014-02-01 01:23:34.000000', 'temperatura', 785.0000, 'ºC'),
	(179115, 120, '2014-02-01 01:23:35.000000', 'temperatura', 568.0000, 'ºC'),
	(179116, 120, '2014-02-01 01:23:36.000000', 'temperatura', 488.0000, 'ºC'),
	(179117, 120, '2014-02-01 01:23:37.000000', 'temperatura', 733.0000, 'ºC'),
	(179118, 120, '2014-02-01 01:23:38.000000', 'temperatura', 1005.0000, 'ºC'),
	(179119, 120, '2014-02-01 01:23:39.000000', 'temperatura', 424.0000, 'ºC'),
	(179120, 120, '2014-02-01 01:23:40.000000', 'temperatura', 306.0000, 'ºC'),
	(179121, 120, '2014-02-01 01:23:41.000000', 'temperatura', 259.0000, 'ºC'),
	(179122, 120, '2014-02-01 01:23:42.000000', 'temperatura', 377.0000, 'ºC'),
	(179123, 120, '2014-02-01 01:23:43.000000', 'temperatura', 1108.0000, 'ºC'),
	(179124, 120, '2014-02-01 01:23:44.000000', 'temperatura', 810.0000, 'ºC'),
	(179125, 120, '2014-02-01 01:23:45.000000', 'temperatura', 728.0000, 'ºC'),
	(179126, 120, '2014-02-01 01:23:46.000000', 'temperatura', 11.0000, 'ºC'),
	(179127, 120, '2014-02-01 01:23:47.000000', 'temperatura', 271.0000, 'ºC'),
	(179128, 120, '2014-02-01 01:23:48.000000', 'temperatura', 122.0000, 'ºC'),
	(179129, 120, '2014-02-01 01:23:49.000000', 'temperatura', 996.0000, 'ºC'),
	(179130, 120, '2014-02-01 01:23:50.000000', 'temperatura', 1016.0000, 'ºC'),
	(179131, 120, '2014-02-01 01:23:51.000000', 'temperatura', 893.0000, 'ºC'),
	(179132, 120, '2014-02-01 01:23:52.000000', 'temperatura', 217.0000, 'ºC'),
	(179133, 120, '2014-02-01 01:23:53.000000', 'temperatura', 805.0000, 'ºC'),
	(179134, 120, '2014-02-01 01:23:54.000000', 'temperatura', 976.0000, 'ºC'),
	(179135, 120, '2014-02-01 01:23:55.000000', 'temperatura', 64.0000, 'ºC'),
	(179136, 120, '2014-02-01 01:23:56.000000', 'temperatura', 993.0000, 'ºC'),
	(179137, 120, '2014-02-01 01:23:57.000000', 'temperatura', 1174.0000, 'ºC'),
	(179138, 120, '2014-02-01 01:23:58.000000', 'temperatura', 491.0000, 'ºC'),
	(179139, 120, '2014-02-01 01:23:59.000000', 'temperatura', 133.0000, 'ºC'),
	(179140, 120, '2014-02-01 01:24:00.000000', 'temperatura', 394.0000, 'ºC'),
	(179141, 120, '2014-02-01 01:24:01.000000', 'temperatura', 371.0000, 'ºC'),
	(179142, 120, '2014-02-01 01:24:02.000000', 'temperatura', 673.0000, 'ºC'),
	(179143, 120, '2014-02-01 01:24:03.000000', 'temperatura', 1054.0000, 'ºC'),
	(179144, 120, '2014-02-01 01:24:04.000000', 'temperatura', 853.0000, 'ºC'),
	(179145, 120, '2014-02-01 01:24:05.000000', 'temperatura', 1100.0000, 'ºC'),
	(179146, 120, '2014-02-01 01:24:06.000000', 'temperatura', 544.0000, 'ºC'),
	(179147, 120, '2014-02-01 01:24:07.000000', 'temperatura', 618.0000, 'ºC'),
	(179148, 120, '2014-02-01 01:24:08.000000', 'temperatura', 262.0000, 'ºC'),
	(179149, 120, '2014-02-01 01:24:09.000000', 'temperatura', 654.0000, 'ºC'),
	(179150, 120, '2014-02-01 01:24:10.000000', 'temperatura', 84.0000, 'ºC'),
	(179151, 120, '2014-02-01 01:24:11.000000', 'temperatura', 859.0000, 'ºC'),
	(179152, 120, '2014-02-01 01:24:12.000000', 'temperatura', 443.0000, 'ºC'),
	(179153, 120, '2014-02-01 01:24:13.000000', 'temperatura', 838.0000, 'ºC'),
	(179154, 120, '2014-02-01 01:24:14.000000', 'temperatura', 460.0000, 'ºC'),
	(179155, 120, '2014-02-01 01:24:15.000000', 'temperatura', 989.0000, 'ºC'),
	(179156, 120, '2014-02-01 01:24:16.000000', 'temperatura', 1167.0000, 'ºC'),
	(179157, 120, '2014-02-01 01:24:17.000000', 'temperatura', 465.0000, 'ºC'),
	(179158, 120, '2014-02-01 01:24:18.000000', 'temperatura', 25.0000, 'ºC'),
	(179159, 120, '2014-02-01 01:24:19.000000', 'temperatura', 1132.0000, 'ºC'),
	(179160, 120, '2014-02-01 01:24:20.000000', 'temperatura', 784.0000, 'ºC'),
	(179161, 120, '2014-02-01 01:24:21.000000', 'temperatura', 527.0000, 'ºC'),
	(179162, 120, '2014-02-01 01:24:22.000000', 'temperatura', 281.0000, 'ºC'),
	(179163, 120, '2014-02-01 01:24:23.000000', 'temperatura', 1023.0000, 'ºC'),
	(179164, 120, '2014-02-01 01:24:24.000000', 'temperatura', 676.0000, 'ºC'),
	(179165, 120, '2014-02-01 01:24:25.000000', 'temperatura', 311.0000, 'ºC'),
	(179166, 120, '2014-02-01 01:24:26.000000', 'temperatura', 727.0000, 'ºC'),
	(179167, 120, '2014-02-01 01:24:27.000000', 'temperatura', 302.0000, 'ºC'),
	(179168, 120, '2014-02-01 01:24:28.000000', 'temperatura', 532.0000, 'ºC'),
	(179169, 120, '2014-02-01 01:24:29.000000', 'temperatura', 553.0000, 'ºC'),
	(179170, 120, '2014-02-01 01:24:30.000000', 'temperatura', 1169.0000, 'ºC'),
	(179171, 120, '2014-02-01 01:24:31.000000', 'temperatura', 585.0000, 'ºC'),
	(179172, 120, '2014-02-01 01:24:32.000000', 'temperatura', 621.0000, 'ºC'),
	(179173, 120, '2014-02-01 01:24:33.000000', 'temperatura', 151.0000, 'ºC'),
	(179174, 120, '2014-02-01 01:24:34.000000', 'temperatura', 94.0000, 'ºC'),
	(179175, 120, '2014-02-01 01:24:35.000000', 'temperatura', 14.0000, 'ºC'),
	(179176, 120, '2014-02-01 01:24:36.000000', 'temperatura', 991.0000, 'ºC'),
	(179177, 120, '2014-02-01 01:24:37.000000', 'temperatura', 115.0000, 'ºC'),
	(179178, 120, '2014-02-01 01:24:38.000000', 'temperatura', 0.0000, 'ºC'),
	(179179, 120, '2014-02-01 01:24:39.000000', 'temperatura', 854.0000, 'ºC'),
	(179180, 120, '2014-02-01 01:24:40.000000', 'temperatura', 673.0000, 'ºC'),
	(179181, 120, '2014-02-01 01:24:41.000000', 'temperatura', 804.0000, 'ºC'),
	(179182, 120, '2014-02-01 01:24:42.000000', 'temperatura', 799.0000, 'ºC'),
	(179183, 120, '2014-02-01 01:24:43.000000', 'temperatura', 386.0000, 'ºC'),
	(179184, 120, '2014-02-01 01:24:44.000000', 'temperatura', 731.0000, 'ºC'),
	(179185, 120, '2014-02-01 01:24:45.000000', 'temperatura', 100.0000, 'ºC'),
	(179186, 120, '2014-02-01 01:24:46.000000', 'temperatura', 706.0000, 'ºC'),
	(179187, 120, '2014-02-01 01:24:47.000000', 'temperatura', 832.0000, 'ºC'),
	(179188, 120, '2014-02-01 01:24:48.000000', 'temperatura', 841.0000, 'ºC'),
	(179189, 120, '2014-02-01 01:24:49.000000', 'temperatura', 511.0000, 'ºC'),
	(179190, 120, '2014-02-01 01:24:50.000000', 'temperatura', 32.0000, 'ºC'),
	(179191, 120, '2014-02-01 01:24:51.000000', 'temperatura', 1027.0000, 'ºC'),
	(179192, 120, '2014-02-01 01:24:52.000000', 'temperatura', 239.0000, 'ºC'),
	(179193, 120, '2014-02-01 01:24:53.000000', 'temperatura', 517.0000, 'ºC'),
	(179194, 120, '2014-02-01 01:24:54.000000', 'temperatura', 668.0000, 'ºC'),
	(179195, 120, '2014-02-01 01:24:55.000000', 'temperatura', 588.0000, 'ºC'),
	(179196, 120, '2014-02-01 01:24:56.000000', 'temperatura', 937.0000, 'ºC'),
	(179197, 120, '2014-02-01 01:24:57.000000', 'temperatura', 523.0000, 'ºC'),
	(179198, 120, '2014-02-01 01:24:58.000000', 'temperatura', 1003.0000, 'ºC'),
	(179199, 120, '2014-02-01 01:24:59.000000', 'temperatura', 1048.0000, 'ºC'),
	(179200, 120, '2014-02-01 01:25:00.000000', 'temperatura', 1030.0000, 'ºC'),
	(179201, 120, '2014-02-01 01:25:01.000000', 'temperatura', 809.0000, 'ºC'),
	(179202, 120, '2014-02-01 01:25:02.000000', 'temperatura', 953.0000, 'ºC'),
	(179203, 120, '2014-02-01 01:25:03.000000', 'temperatura', 1141.0000, 'ºC'),
	(179204, 120, '2014-02-01 01:25:04.000000', 'temperatura', 446.0000, 'ºC'),
	(179205, 120, '2014-02-01 01:25:05.000000', 'temperatura', 6.0000, 'ºC'),
	(179206, 120, '2014-02-01 01:25:06.000000', 'temperatura', 1091.0000, 'ºC'),
	(179207, 120, '2014-02-01 01:25:07.000000', 'temperatura', 640.0000, 'ºC'),
	(179208, 120, '2014-02-01 01:25:08.000000', 'temperatura', 1128.0000, 'ºC'),
	(179209, 120, '2014-02-01 01:25:09.000000', 'temperatura', 118.0000, 'ºC'),
	(179210, 120, '2014-02-01 01:25:10.000000', 'temperatura', 809.0000, 'ºC'),
	(179211, 120, '2014-02-01 01:25:11.000000', 'temperatura', 89.0000, 'ºC'),
	(179212, 120, '2014-02-01 01:25:12.000000', 'temperatura', 421.0000, 'ºC'),
	(179213, 120, '2014-02-01 01:25:13.000000', 'temperatura', 637.0000, 'ºC'),
	(179214, 120, '2014-02-01 01:25:14.000000', 'temperatura', 723.0000, 'ºC'),
	(179215, 120, '2014-02-01 01:25:15.000000', 'temperatura', 506.0000, 'ºC'),
	(179216, 120, '2014-02-01 01:25:16.000000', 'temperatura', 360.0000, 'ºC'),
	(179217, 120, '2014-02-01 01:25:17.000000', 'temperatura', 283.0000, 'ºC'),
	(179218, 120, '2014-02-01 01:25:18.000000', 'temperatura', 335.0000, 'ºC'),
	(179219, 120, '2014-02-01 01:25:19.000000', 'temperatura', 825.0000, 'ºC'),
	(179220, 120, '2014-02-01 01:25:20.000000', 'temperatura', 721.0000, 'ºC'),
	(179221, 120, '2014-02-01 01:25:21.000000', 'temperatura', 1133.0000, 'ºC'),
	(179222, 120, '2014-02-01 01:25:22.000000', 'temperatura', 1100.0000, 'ºC'),
	(179223, 120, '2014-02-01 01:25:23.000000', 'temperatura', 901.0000, 'ºC'),
	(179224, 120, '2014-02-01 01:25:24.000000', 'temperatura', 6.0000, 'ºC'),
	(179225, 120, '2014-02-01 01:25:25.000000', 'temperatura', 928.0000, 'ºC'),
	(179226, 120, '2014-02-01 01:25:26.000000', 'temperatura', 1022.0000, 'ºC'),
	(179227, 120, '2014-02-01 01:25:27.000000', 'temperatura', 1127.0000, 'ºC'),
	(179228, 120, '2014-02-01 01:25:28.000000', 'temperatura', 168.0000, 'ºC'),
	(179229, 120, '2014-02-01 01:25:29.000000', 'temperatura', 1061.0000, 'ºC'),
	(179230, 120, '2014-02-01 01:25:30.000000', 'temperatura', 0.0000, 'ºC'),
	(179231, 120, '2014-02-01 01:25:31.000000', 'temperatura', 418.0000, 'ºC'),
	(179232, 120, '2014-02-01 01:25:32.000000', 'temperatura', 889.0000, 'ºC'),
	(179233, 120, '2014-02-01 01:25:33.000000', 'temperatura', 791.0000, 'ºC'),
	(179234, 120, '2014-02-01 01:25:34.000000', 'temperatura', 89.0000, 'ºC'),
	(179235, 120, '2014-02-01 01:25:35.000000', 'temperatura', 475.0000, 'ºC'),
	(179236, 120, '2014-02-01 01:25:36.000000', 'temperatura', 907.0000, 'ºC'),
	(179237, 120, '2014-02-01 01:25:37.000000', 'temperatura', 711.0000, 'ºC'),
	(179238, 120, '2014-02-01 01:25:38.000000', 'temperatura', 835.0000, 'ºC'),
	(179239, 120, '2014-02-01 01:25:39.000000', 'temperatura', 843.0000, 'ºC'),
	(179240, 120, '2014-02-01 01:25:40.000000', 'temperatura', 510.0000, 'ºC'),
	(179241, 120, '2014-02-01 01:25:41.000000', 'temperatura', 22.0000, 'ºC'),
	(179242, 120, '2014-02-01 01:25:42.000000', 'temperatura', 980.0000, 'ºC'),
	(179243, 120, '2014-02-01 01:25:43.000000', 'temperatura', 33.0000, 'ºC'),
	(179244, 120, '2014-02-01 01:25:44.000000', 'temperatura', 825.0000, 'ºC'),
	(179245, 120, '2014-02-01 01:25:45.000000', 'temperatura', 427.0000, 'ºC'),
	(179246, 120, '2014-02-01 01:25:46.000000', 'temperatura', 863.0000, 'ºC'),
	(179247, 120, '2014-02-01 01:25:47.000000', 'temperatura', 633.0000, 'ºC'),
	(179248, 120, '2014-02-01 01:25:48.000000', 'temperatura', 575.0000, 'ºC'),
	(179249, 120, '2014-02-01 01:25:49.000000', 'temperatura', 978.0000, 'ºC'),
	(179250, 120, '2014-02-01 01:25:50.000000', 'temperatura', 764.0000, 'ºC'),
	(179251, 120, '2014-02-01 01:25:51.000000', 'temperatura', 886.0000, 'ºC'),
	(179252, 120, '2014-02-01 01:25:52.000000', 'temperatura', 941.0000, 'ºC'),
	(179253, 120, '2014-02-01 01:25:53.000000', 'temperatura', 848.0000, 'ºC'),
	(179254, 120, '2014-02-01 01:25:54.000000', 'temperatura', 218.0000, 'ºC'),
	(179255, 120, '2014-02-01 01:25:55.000000', 'temperatura', 945.0000, 'ºC'),
	(179256, 120, '2014-02-01 01:25:56.000000', 'temperatura', 471.0000, 'ºC'),
	(179257, 120, '2014-02-01 01:25:57.000000', 'temperatura', 719.0000, 'ºC'),
	(179258, 120, '2014-02-01 01:25:58.000000', 'temperatura', 986.0000, 'ºC'),
	(179259, 120, '2014-02-01 01:25:59.000000', 'temperatura', 371.0000, 'ºC'),
	(179260, 120, '2014-02-01 01:26:00.000000', 'temperatura', 96.0000, 'ºC'),
	(179261, 120, '2014-02-01 01:26:01.000000', 'temperatura', 570.0000, 'ºC'),
	(179262, 120, '2014-02-01 01:26:02.000000', 'temperatura', 161.0000, 'ºC'),
	(179263, 120, '2014-02-01 01:26:03.000000', 'temperatura', 295.0000, 'ºC'),
	(179264, 120, '2014-02-01 01:26:04.000000', 'temperatura', 994.0000, 'ºC'),
	(179265, 120, '2014-02-01 01:26:05.000000', 'temperatura', 486.0000, 'ºC'),
	(179266, 120, '2014-02-01 01:26:06.000000', 'temperatura', 650.0000, 'ºC'),
	(179267, 120, '2014-02-01 01:26:07.000000', 'temperatura', 589.0000, 'ºC'),
	(179268, 120, '2014-02-01 01:26:08.000000', 'temperatura', 998.0000, 'ºC'),
	(179269, 120, '2014-02-01 01:26:09.000000', 'temperatura', 821.0000, 'ºC'),
	(179270, 120, '2014-02-01 01:26:10.000000', 'temperatura', 1114.0000, 'ºC'),
	(179271, 120, '2014-02-01 01:26:11.000000', 'temperatura', 705.0000, 'ºC'),
	(179272, 120, '2014-02-01 01:26:12.000000', 'temperatura', 187.0000, 'ºC'),
	(179273, 120, '2014-02-01 01:26:13.000000', 'temperatura', 18.0000, 'ºC'),
	(179274, 120, '2014-02-01 01:26:14.000000', 'temperatura', 728.0000, 'ºC'),
	(179275, 120, '2014-02-01 01:26:15.000000', 'temperatura', 1190.0000, 'ºC'),
	(179276, 120, '2014-02-01 01:26:16.000000', 'temperatura', 164.0000, 'ºC'),
	(179277, 120, '2014-02-01 01:26:17.000000', 'temperatura', 853.0000, 'ºC'),
	(179278, 120, '2014-02-01 01:26:18.000000', 'temperatura', 172.0000, 'ºC'),
	(179279, 120, '2014-02-01 01:26:19.000000', 'temperatura', 700.0000, 'ºC'),
	(179280, 120, '2014-02-01 01:26:20.000000', 'temperatura', 587.0000, 'ºC'),
	(179281, 120, '2014-02-01 01:26:21.000000', 'temperatura', 834.0000, 'ºC'),
	(179282, 120, '2014-02-01 01:26:22.000000', 'temperatura', 8.0000, 'ºC'),
	(179283, 120, '2014-02-01 01:26:23.000000', 'temperatura', 1141.0000, 'ºC'),
	(179284, 120, '2014-02-01 01:26:24.000000', 'temperatura', 880.0000, 'ºC'),
	(179285, 120, '2014-02-01 01:26:25.000000', 'temperatura', 977.0000, 'ºC'),
	(179286, 120, '2014-02-01 01:26:26.000000', 'temperatura', 1045.0000, 'ºC'),
	(179287, 120, '2014-02-01 01:26:27.000000', 'temperatura', 1094.0000, 'ºC'),
	(179288, 120, '2014-02-01 01:26:28.000000', 'temperatura', 1135.0000, 'ºC'),
	(179289, 120, '2014-02-01 01:26:29.000000', 'temperatura', 1193.0000, 'ºC'),
	(179290, 120, '2014-02-01 01:26:30.000000', 'temperatura', 162.0000, 'ºC'),
	(179291, 120, '2014-02-01 01:26:31.000000', 'temperatura', 830.0000, 'ºC'),
	(179292, 120, '2014-02-01 01:26:32.000000', 'temperatura', 67.0000, 'ºC'),
	(179293, 120, '2014-02-01 01:26:33.000000', 'temperatura', 242.0000, 'ºC'),
	(179294, 120, '2014-02-01 01:26:34.000000', 'temperatura', 1012.0000, 'ºC'),
	(179295, 120, '2014-02-01 01:26:35.000000', 'temperatura', 735.0000, 'ºC'),
	(179296, 120, '2014-02-01 01:26:36.000000', 'temperatura', 640.0000, 'ºC'),
	(179297, 120, '2014-02-01 01:26:37.000000', 'temperatura', 992.0000, 'ºC'),
	(179298, 120, '2014-02-01 01:26:38.000000', 'temperatura', 644.0000, 'ºC'),
	(179299, 120, '2014-02-01 01:26:39.000000', 'temperatura', 245.0000, 'ºC'),
	(179300, 120, '2014-02-01 01:26:40.000000', 'temperatura', 491.0000, 'ºC'),
	(179301, 120, '2014-02-01 01:26:41.000000', 'temperatura', 523.0000, 'ºC'),
	(179302, 120, '2014-02-01 01:26:42.000000', 'temperatura', 1139.0000, 'ºC'),
	(179303, 120, '2014-02-01 01:26:43.000000', 'temperatura', 529.0000, 'ºC'),
	(179304, 120, '2014-02-01 01:26:44.000000', 'temperatura', 430.0000, 'ºC'),
	(179305, 120, '2014-02-01 01:26:45.000000', 'temperatura', 561.0000, 'ºC'),
	(179306, 120, '2014-02-01 01:26:46.000000', 'temperatura', 318.0000, 'ºC'),
	(179307, 120, '2014-02-01 01:26:47.000000', 'temperatura', 1107.0000, 'ºC'),
	(179308, 120, '2014-02-01 01:26:48.000000', 'temperatura', 982.0000, 'ºC'),
	(179309, 120, '2014-02-01 01:26:49.000000', 'temperatura', 387.0000, 'ºC'),
	(179310, 120, '2014-02-01 01:26:50.000000', 'temperatura', 191.0000, 'ºC'),
	(179311, 120, '2014-02-01 01:26:51.000000', 'temperatura', 994.0000, 'ºC'),
	(179312, 120, '2014-02-01 01:26:52.000000', 'temperatura', 799.0000, 'ºC'),
	(179313, 120, '2014-02-01 01:26:53.000000', 'temperatura', 1013.0000, 'ºC'),
	(179314, 120, '2014-02-01 01:26:54.000000', 'temperatura', 268.0000, 'ºC'),
	(179315, 120, '2014-02-01 01:26:55.000000', 'temperatura', 700.0000, 'ºC'),
	(179316, 120, '2014-02-01 01:26:56.000000', 'temperatura', 298.0000, 'ºC'),
	(179317, 120, '2014-02-01 01:26:57.000000', 'temperatura', 589.0000, 'ºC'),
	(179318, 120, '2014-02-01 01:26:58.000000', 'temperatura', 850.0000, 'ºC'),
	(179319, 120, '2014-02-01 01:26:59.000000', 'temperatura', 87.0000, 'ºC'),
	(179320, 120, '2014-02-01 01:27:00.000000', 'temperatura', 282.0000, 'ºC'),
	(179321, 120, '2014-02-01 01:27:01.000000', 'temperatura', 1152.0000, 'ºC'),
	(179322, 120, '2014-02-01 01:27:02.000000', 'temperatura', 113.0000, 'ºC'),
	(179323, 120, '2014-02-01 01:27:03.000000', 'temperatura', 711.0000, 'ºC'),
	(179324, 120, '2014-02-01 01:27:04.000000', 'temperatura', 817.0000, 'ºC'),
	(179325, 120, '2014-02-01 01:27:05.000000', 'temperatura', 752.0000, 'ºC'),
	(179326, 120, '2014-02-01 01:27:06.000000', 'temperatura', 108.0000, 'ºC'),
	(179327, 120, '2014-02-01 01:27:07.000000', 'temperatura', 684.0000, 'ºC'),
	(179328, 120, '2014-02-01 01:27:08.000000', 'temperatura', 697.0000, 'ºC'),
	(179329, 120, '2014-02-01 01:27:09.000000', 'temperatura', 233.0000, 'ºC'),
	(179330, 120, '2014-02-01 01:27:10.000000', 'temperatura', 276.0000, 'ºC'),
	(179331, 120, '2014-02-01 01:27:11.000000', 'temperatura', 680.0000, 'ºC'),
	(179332, 120, '2014-02-01 01:27:12.000000', 'temperatura', 172.0000, 'ºC'),
	(179333, 120, '2014-02-01 01:27:13.000000', 'temperatura', 21.0000, 'ºC'),
	(179334, 120, '2014-02-01 01:27:14.000000', 'temperatura', 788.0000, 'ºC'),
	(179335, 120, '2014-02-01 01:27:15.000000', 'temperatura', 281.0000, 'ºC'),
	(179336, 120, '2014-02-01 01:27:16.000000', 'temperatura', 238.0000, 'ºC'),
	(179337, 120, '2014-02-01 01:27:17.000000', 'temperatura', 348.0000, 'ºC'),
	(179338, 120, '2014-02-01 01:27:18.000000', 'temperatura', 1027.0000, 'ºC'),
	(179339, 120, '2014-02-01 01:27:19.000000', 'temperatura', 493.0000, 'ºC'),
	(179340, 120, '2014-02-01 01:27:20.000000', 'temperatura', 583.0000, 'ºC'),
	(179341, 120, '2014-02-01 01:27:21.000000', 'temperatura', 239.0000, 'ºC'),
	(179342, 120, '2014-02-01 01:27:22.000000', 'temperatura', 645.0000, 'ºC'),
	(179343, 120, '2014-02-01 01:27:23.000000', 'temperatura', 107.0000, 'ºC'),
	(179344, 120, '2014-02-01 01:27:24.000000', 'temperatura', 1000.0000, 'ºC'),
	(179345, 120, '2014-02-01 01:27:25.000000', 'temperatura', 1079.0000, 'ºC'),
	(179346, 120, '2014-02-01 01:27:26.000000', 'temperatura', 1196.0000, 'ºC'),
	(179347, 120, '2014-02-01 01:27:27.000000', 'temperatura', 346.0000, 'ºC'),
	(179348, 120, '2014-02-01 01:27:28.000000', 'temperatura', 540.0000, 'ºC'),
	(179349, 120, '2014-02-01 01:27:29.000000', 'temperatura', 464.0000, 'ºC'),
	(179350, 120, '2014-02-01 01:27:30.000000', 'temperatura', 700.0000, 'ºC'),
	(179351, 120, '2014-02-01 01:27:31.000000', 'temperatura', 907.0000, 'ºC'),
	(179352, 120, '2014-02-01 01:27:32.000000', 'temperatura', 35.0000, 'ºC'),
	(179353, 120, '2014-02-01 01:27:33.000000', 'temperatura', 1054.0000, 'ºC'),
	(179354, 120, '2014-02-01 01:27:34.000000', 'temperatura', 365.0000, 'ºC'),
	(179355, 120, '2014-02-01 01:27:35.000000', 'temperatura', 1066.0000, 'ºC'),
	(179356, 120, '2014-02-01 01:27:36.000000', 'temperatura', 636.0000, 'ºC'),
	(179357, 120, '2014-02-01 01:27:37.000000', 'temperatura', 1180.0000, 'ºC'),
	(179358, 120, '2014-02-01 01:27:38.000000', 'temperatura', 394.0000, 'ºC'),
	(179359, 120, '2014-02-01 01:27:39.000000', 'temperatura', 831.0000, 'ºC'),
	(179360, 120, '2014-02-01 01:27:40.000000', 'temperatura', 574.0000, 'ºC'),
	(179361, 120, '2014-02-01 01:27:41.000000', 'temperatura', 379.0000, 'ºC'),
	(179362, 120, '2014-02-01 01:27:42.000000', 'temperatura', 170.0000, 'ºC'),
	(179363, 120, '2014-02-01 01:27:43.000000', 'temperatura', 916.0000, 'ºC'),
	(179364, 120, '2014-02-01 01:27:44.000000', 'temperatura', 471.0000, 'ºC'),
	(179365, 120, '2014-02-01 01:27:45.000000', 'temperatura', 806.0000, 'ºC'),
	(179366, 120, '2014-02-01 01:27:46.000000', 'temperatura', 216.0000, 'ºC'),
	(179367, 120, '2014-02-01 01:27:47.000000', 'temperatura', 1063.0000, 'ºC'),
	(179368, 120, '2014-02-01 01:27:48.000000', 'temperatura', 1068.0000, 'ºC'),
	(179369, 120, '2014-02-01 01:27:49.000000', 'temperatura', 952.0000, 'ºC'),
	(179370, 120, '2014-02-01 01:27:50.000000', 'temperatura', 356.0000, 'ºC'),
	(179371, 120, '2014-02-01 01:27:51.000000', 'temperatura', 124.0000, 'ºC'),
	(179372, 120, '2014-02-01 01:27:52.000000', 'temperatura', 751.0000, 'ºC'),
	(179373, 120, '2014-02-01 01:27:53.000000', 'temperatura', 986.0000, 'ºC'),
	(179374, 120, '2014-02-01 01:27:54.000000', 'temperatura', 278.0000, 'ºC'),
	(179375, 120, '2014-02-01 01:27:55.000000', 'temperatura', 831.0000, 'ºC'),
	(179376, 120, '2014-02-01 01:27:56.000000', 'temperatura', 921.0000, 'ºC'),
	(179377, 120, '2014-02-01 01:27:57.000000', 'temperatura', 914.0000, 'ºC'),
	(179378, 120, '2014-02-01 01:27:58.000000', 'temperatura', 608.0000, 'ºC'),
	(179379, 120, '2014-02-01 01:27:59.000000', 'temperatura', 297.0000, 'ºC'),
	(179380, 120, '2014-02-01 01:28:00.000000', 'temperatura', 863.0000, 'ºC'),
	(179381, 120, '2014-02-01 01:28:01.000000', 'temperatura', 1025.0000, 'ºC'),
	(179382, 120, '2014-02-01 01:28:02.000000', 'temperatura', 134.0000, 'ºC'),
	(179383, 120, '2014-02-01 01:28:03.000000', 'temperatura', 1199.0000, 'ºC'),
	(179384, 120, '2014-02-01 01:28:04.000000', 'temperatura', 791.0000, 'ºC'),
	(179385, 120, '2014-02-01 01:28:05.000000', 'temperatura', 359.0000, 'ºC'),
	(179386, 120, '2014-02-01 01:28:06.000000', 'temperatura', 623.0000, 'ºC'),
	(179387, 120, '2014-02-01 01:28:07.000000', 'temperatura', 836.0000, 'ºC'),
	(179388, 120, '2014-02-01 01:28:08.000000', 'temperatura', 1115.0000, 'ºC'),
	(179389, 120, '2014-02-01 01:28:09.000000', 'temperatura', 666.0000, 'ºC'),
	(179390, 120, '2014-02-01 01:28:10.000000', 'temperatura', 1187.0000, 'ºC'),
	(179391, 120, '2014-02-01 01:28:11.000000', 'temperatura', 336.0000, 'ºC'),
	(179392, 120, '2014-02-01 01:28:12.000000', 'temperatura', 521.0000, 'ºC'),
	(179393, 120, '2014-02-01 01:28:13.000000', 'temperatura', 395.0000, 'ºC'),
	(179394, 120, '2014-02-01 01:28:14.000000', 'temperatura', 415.0000, 'ºC'),
	(179395, 120, '2014-02-01 01:28:15.000000', 'temperatura', 890.0000, 'ºC'),
	(179396, 120, '2014-02-01 01:28:16.000000', 'temperatura', 805.0000, 'ºC'),
	(179397, 120, '2014-02-01 01:28:17.000000', 'temperatura', 155.0000, 'ºC'),
	(179398, 120, '2014-02-01 01:28:18.000000', 'temperatura', 759.0000, 'ºC'),
	(179399, 120, '2014-02-01 01:28:19.000000', 'temperatura', 931.0000, 'ºC'),
	(179400, 120, '2014-02-01 01:28:20.000000', 'temperatura', 1179.0000, 'ºC'),
	(179401, 120, '2014-02-01 01:28:21.000000', 'temperatura', 704.0000, 'ºC'),
	(179402, 120, '2014-02-01 01:28:22.000000', 'temperatura', 1184.0000, 'ºC'),
	(179403, 120, '2014-02-01 01:28:23.000000', 'temperatura', 209.0000, 'ºC'),
	(179404, 120, '2014-02-01 01:28:24.000000', 'temperatura', 1093.0000, 'ºC'),
	(179405, 120, '2014-02-01 01:28:25.000000', 'temperatura', 37.0000, 'ºC'),
	(179406, 120, '2014-02-01 01:28:26.000000', 'temperatura', 506.0000, 'ºC'),
	(179407, 120, '2014-02-01 01:28:27.000000', 'temperatura', 22.0000, 'ºC'),
	(179408, 120, '2014-02-01 01:28:28.000000', 'temperatura', 992.0000, 'ºC'),
	(179409, 120, '2014-02-01 01:28:29.000000', 'temperatura', 93.0000, 'ºC'),
	(179410, 120, '2014-02-01 01:28:30.000000', 'temperatura', 1089.0000, 'ºC'),
	(179411, 120, '2014-02-01 01:28:31.000000', 'temperatura', 369.0000, 'ºC'),
	(179412, 120, '2014-02-01 01:28:32.000000', 'temperatura', 977.0000, 'ºC'),
	(179413, 120, '2014-02-01 01:28:33.000000', 'temperatura', 180.0000, 'ºC'),
	(179414, 120, '2014-02-01 01:28:34.000000', 'temperatura', 370.0000, 'ºC'),
	(179415, 120, '2014-02-01 01:28:35.000000', 'temperatura', 110.0000, 'ºC'),
	(179416, 120, '2014-02-01 01:28:36.000000', 'temperatura', 640.0000, 'ºC'),
	(179417, 120, '2014-02-01 01:28:37.000000', 'temperatura', 472.0000, 'ºC'),
	(179418, 120, '2014-02-01 01:28:38.000000', 'temperatura', 438.0000, 'ºC'),
	(179419, 120, '2014-02-01 01:28:39.000000', 'temperatura', 776.0000, 'ºC'),
	(179420, 120, '2014-02-01 01:28:40.000000', 'temperatura', 164.0000, 'ºC'),
	(179421, 120, '2014-02-01 01:28:41.000000', 'temperatura', 894.0000, 'ºC'),
	(179422, 120, '2014-02-01 01:28:42.000000', 'temperatura', 380.0000, 'ºC'),
	(179423, 120, '2014-02-01 01:28:43.000000', 'temperatura', 418.0000, 'ºC'),
	(179424, 120, '2014-02-01 01:28:44.000000', 'temperatura', 948.0000, 'ºC'),
	(179425, 120, '2014-02-01 01:28:45.000000', 'temperatura', 1089.0000, 'ºC'),
	(179426, 120, '2014-02-01 01:28:46.000000', 'temperatura', 200.0000, 'ºC'),
	(179427, 120, '2014-02-01 01:28:47.000000', 'temperatura', 134.0000, 'ºC'),
	(179428, 120, '2014-02-01 01:28:48.000000', 'temperatura', 70.0000, 'ºC'),
	(179429, 120, '2014-02-01 01:28:49.000000', 'temperatura', 1149.0000, 'ºC'),
	(179430, 120, '2014-02-01 01:28:50.000000', 'temperatura', 737.0000, 'ºC'),
	(179431, 120, '2014-02-01 01:28:51.000000', 'temperatura', 236.0000, 'ºC'),
	(179432, 120, '2014-02-01 01:28:52.000000', 'temperatura', 170.0000, 'ºC'),
	(179433, 120, '2014-02-01 01:28:53.000000', 'temperatura', 143.0000, 'ºC'),
	(179434, 120, '2014-02-01 01:28:54.000000', 'temperatura', 204.0000, 'ºC'),
	(179435, 120, '2014-02-01 01:28:55.000000', 'temperatura', 592.0000, 'ºC'),
	(179436, 120, '2014-02-01 01:28:56.000000', 'temperatura', 1147.0000, 'ºC'),
	(179437, 120, '2014-02-01 01:28:57.000000', 'temperatura', 362.0000, 'ºC'),
	(179438, 120, '2014-02-01 01:28:58.000000', 'temperatura', 770.0000, 'ºC'),
	(179439, 120, '2014-02-01 01:28:59.000000', 'temperatura', 363.0000, 'ºC'),
	(179440, 120, '2014-02-01 01:29:00.000000', 'temperatura', 708.0000, 'ºC'),
	(179441, 120, '2014-02-01 01:29:01.000000', 'temperatura', 48.0000, 'ºC'),
	(179442, 120, '2014-02-01 01:29:02.000000', 'temperatura', 520.0000, 'ºC'),
	(179443, 120, '2014-02-01 01:29:03.000000', 'temperatura', 55.0000, 'ºC'),
	(179444, 120, '2014-02-01 01:29:04.000000', 'temperatura', 1114.0000, 'ºC'),
	(179445, 120, '2014-02-01 01:29:05.000000', 'temperatura', 608.0000, 'ºC'),
	(179446, 120, '2014-02-01 01:29:06.000000', 'temperatura', 899.0000, 'ºC'),
	(179447, 120, '2014-02-01 01:29:07.000000', 'temperatura', 270.0000, 'ºC'),
	(179448, 120, '2014-02-01 01:29:08.000000', 'temperatura', 1054.0000, 'ºC'),
	(179449, 120, '2014-02-01 01:29:09.000000', 'temperatura', 861.0000, 'ºC'),
	(179450, 120, '2014-02-01 01:29:10.000000', 'temperatura', 1142.0000, 'ºC'),
	(179451, 120, '2014-02-01 01:29:11.000000', 'temperatura', 729.0000, 'ºC'),
	(179452, 120, '2014-02-01 01:29:12.000000', 'temperatura', 218.0000, 'ºC'),
	(179453, 120, '2014-02-01 01:29:13.000000', 'temperatura', 105.0000, 'ºC'),
	(179454, 120, '2014-02-01 01:29:14.000000', 'temperatura', 1069.0000, 'ºC'),
	(179455, 120, '2014-02-01 01:29:15.000000', 'temperatura', 233.0000, 'ºC'),
	(179456, 120, '2014-02-01 01:29:16.000000', 'temperatura', 357.0000, 'ºC'),
	(179457, 120, '2014-02-01 01:29:17.000000', 'temperatura', 1087.0000, 'ºC'),
	(179458, 120, '2014-02-01 01:29:18.000000', 'temperatura', 764.0000, 'ºC'),
	(179459, 120, '2014-02-01 01:29:19.000000', 'temperatura', 561.0000, 'ºC'),
	(179460, 120, '2014-02-01 01:29:20.000000', 'temperatura', 513.0000, 'ºC'),
	(179461, 120, '2014-02-01 01:29:21.000000', 'temperatura', 884.0000, 'ºC'),
	(179462, 120, '2014-02-01 01:29:22.000000', 'temperatura', 480.0000, 'ºC'),
	(179463, 120, '2014-02-01 01:29:23.000000', 'temperatura', 947.0000, 'ºC'),
	(179464, 120, '2014-02-01 01:29:24.000000', 'temperatura', 898.0000, 'ºC'),
	(179465, 120, '2014-02-01 01:29:25.000000', 'temperatura', 448.0000, 'ºC'),
	(179466, 120, '2014-02-01 01:29:26.000000', 'temperatura', 747.0000, 'ºC'),
	(179467, 120, '2014-02-01 01:29:27.000000', 'temperatura', 1193.0000, 'ºC'),
	(179468, 120, '2014-02-01 01:29:28.000000', 'temperatura', 126.0000, 'ºC'),
	(179469, 120, '2014-02-01 01:29:29.000000', 'temperatura', 648.0000, 'ºC'),
	(179470, 120, '2014-02-01 01:29:30.000000', 'temperatura', 462.0000, 'ºC'),
	(179471, 120, '2014-02-01 01:29:31.000000', 'temperatura', 369.0000, 'ºC'),
	(179472, 120, '2014-02-01 01:29:32.000000', 'temperatura', 458.0000, 'ºC'),
	(179473, 120, '2014-02-01 01:29:33.000000', 'temperatura', 1182.0000, 'ºC'),
	(179474, 120, '2014-02-01 01:29:34.000000', 'temperatura', 938.0000, 'ºC'),
	(179475, 120, '2014-02-01 01:29:35.000000', 'temperatura', 1143.0000, 'ºC'),
	(179476, 120, '2014-02-01 01:29:36.000000', 'temperatura', 501.0000, 'ºC'),
	(179477, 120, '2014-02-01 01:29:37.000000', 'temperatura', 279.0000, 'ºC'),
	(179478, 120, '2014-02-01 01:29:38.000000', 'temperatura', 1092.0000, 'ºC'),
	(179479, 120, '2014-02-01 01:29:39.000000', 'temperatura', 1021.0000, 'ºC'),
	(179480, 120, '2014-02-01 01:29:40.000000', 'temperatura', 632.0000, 'ºC'),
	(179481, 120, '2014-02-01 01:29:41.000000', 'temperatura', 97.0000, 'ºC'),
	(179482, 120, '2014-02-01 01:29:42.000000', 'temperatura', 991.0000, 'ºC'),
	(179483, 120, '2014-02-01 01:29:43.000000', 'temperatura', 1063.0000, 'ºC'),
	(179484, 120, '2014-02-01 01:29:44.000000', 'temperatura', 1141.0000, 'ºC'),
	(179485, 120, '2014-02-01 01:29:45.000000', 'temperatura', 118.0000, 'ºC'),
	(179486, 120, '2014-02-01 01:29:46.000000', 'temperatura', 767.0000, 'ºC'),
	(179487, 120, '2014-02-01 01:29:47.000000', 'temperatura', 1082.0000, 'ºC'),
	(179488, 120, '2014-02-01 01:29:48.000000', 'temperatura', 709.0000, 'ºC'),
	(179489, 120, '2014-02-01 01:29:49.000000', 'temperatura', 298.0000, 'ºC'),
	(179490, 120, '2014-02-01 01:29:50.000000', 'temperatura', 566.0000, 'ºC'),
	(179491, 120, '2014-02-01 01:29:51.000000', 'temperatura', 734.0000, 'ºC'),
	(179492, 120, '2014-02-01 01:29:52.000000', 'temperatura', 775.0000, 'ºC'),
	(179493, 120, '2014-02-01 01:29:53.000000', 'temperatura', 471.0000, 'ºC'),
	(179494, 120, '2014-02-01 01:29:54.000000', 'temperatura', 31.0000, 'ºC'),
	(179495, 120, '2014-02-01 01:29:55.000000', 'temperatura', 1144.0000, 'ºC'),
	(179496, 120, '2014-02-01 01:29:56.000000', 'temperatura', 827.0000, 'ºC'),
	(179497, 120, '2014-02-01 01:29:57.000000', 'temperatura', 702.0000, 'ºC'),
	(179498, 120, '2014-02-01 01:29:58.000000', 'temperatura', 1030.0000, 'ºC'),
	(179499, 120, '2014-02-01 01:29:59.000000', 'temperatura', 643.0000, 'ºC'),
	(179500, 120, '2014-02-01 01:30:00.000000', 'temperatura', 127.0000, 'ºC'),
	(179501, 120, '2014-02-01 01:30:01.000000', 'temperatura', 1106.0000, 'ºC'),
	(179502, 120, '2014-02-01 01:30:02.000000', 'temperatura', 350.0000, 'ºC'),
	(179503, 120, '2014-02-01 01:30:03.000000', 'temperatura', 830.0000, 'ºC'),
	(179504, 120, '2014-02-01 01:30:04.000000', 'temperatura', 703.0000, 'ºC'),
	(179505, 120, '2014-02-01 01:30:05.000000', 'temperatura', 1026.0000, 'ºC'),
	(179506, 120, '2014-02-01 01:30:06.000000', 'temperatura', 621.0000, 'ºC'),
	(179507, 120, '2014-02-01 01:30:07.000000', 'temperatura', 26.0000, 'ºC'),
	(179508, 120, '2014-02-01 01:30:08.000000', 'temperatura', 671.0000, 'ºC'),
	(179509, 120, '2014-02-01 01:30:09.000000', 'temperatura', 874.0000, 'ºC'),
	(179510, 120, '2014-02-01 01:30:10.000000', 'temperatura', 1158.0000, 'ºC'),
	(179511, 120, '2014-02-01 01:30:11.000000', 'temperatura', 768.0000, 'ºC'),
	(179512, 120, '2014-02-01 01:30:12.000000', 'temperatura', 366.0000, 'ºC'),
	(179513, 120, '2014-02-01 01:30:13.000000', 'temperatura', 729.0000, 'ºC'),
	(179514, 120, '2014-02-01 01:30:14.000000', 'temperatura', 148.0000, 'ºC'),
	(179515, 120, '2014-02-01 01:30:15.000000', 'temperatura', 954.0000, 'ºC'),
	(179516, 120, '2014-02-01 01:30:16.000000', 'temperatura', 724.0000, 'ºC'),
	(179517, 120, '2014-02-01 01:30:17.000000', 'temperatura', 760.0000, 'ºC'),
	(179518, 120, '2014-02-01 01:30:18.000000', 'temperatura', 429.0000, 'ºC'),
	(179519, 120, '2014-02-01 01:30:19.000000', 'temperatura', 1066.0000, 'ºC'),
	(179520, 120, '2014-02-01 01:30:20.000000', 'temperatura', 443.0000, 'ºC'),
	(179521, 120, '2014-02-01 01:30:21.000000', 'temperatura', 218.0000, 'ºC'),
	(179522, 120, '2014-02-01 01:30:22.000000', 'temperatura', 961.0000, 'ºC'),
	(179523, 120, '2014-02-01 01:30:23.000000', 'temperatura', 550.0000, 'ºC'),
	(179524, 120, '2014-02-01 01:30:24.000000', 'temperatura', 1068.0000, 'ºC'),
	(179525, 120, '2014-02-01 01:30:25.000000', 'temperatura', 93.0000, 'ºC'),
	(179526, 120, '2014-02-01 01:30:26.000000', 'temperatura', 860.0000, 'ºC'),
	(179527, 120, '2014-02-01 01:30:27.000000', 'temperatura', 420.0000, 'ºC'),
	(179528, 120, '2014-02-01 01:30:28.000000', 'temperatura', 724.0000, 'ºC'),
	(179529, 120, '2014-02-01 01:30:29.000000', 'temperatura', 1157.0000, 'ºC'),
	(179530, 120, '2014-02-01 01:30:30.000000', 'temperatura', 14.0000, 'ºC'),
	(179531, 120, '2014-02-01 01:30:31.000000', 'temperatura', 199.0000, 'ºC'),
	(179532, 120, '2014-02-01 01:30:32.000000', 'temperatura', 955.0000, 'ºC'),
	(179533, 120, '2014-02-01 01:30:33.000000', 'temperatura', 576.0000, 'ºC'),
	(179534, 120, '2014-02-01 01:30:34.000000', 'temperatura', 19.0000, 'ºC'),
	(179535, 120, '2014-02-01 01:30:35.000000', 'temperatura', 765.0000, 'ºC'),
	(179536, 120, '2014-02-01 01:30:36.000000', 'temperatura', 170.0000, 'ºC'),
	(179537, 120, '2014-02-01 01:30:37.000000', 'temperatura', 955.0000, 'ºC'),
	(179538, 120, '2014-02-01 01:30:38.000000', 'temperatura', 664.0000, 'ºC'),
	(179539, 120, '2014-02-01 01:30:39.000000', 'temperatura', 455.0000, 'ºC'),
	(179540, 120, '2014-02-01 01:30:40.000000', 'temperatura', 285.0000, 'ºC'),
	(179541, 120, '2014-02-01 01:30:41.000000', 'temperatura', 58.0000, 'ºC'),
	(179542, 120, '2014-02-01 01:30:42.000000', 'temperatura', 638.0000, 'ºC'),
	(179543, 120, '2014-02-01 01:30:43.000000', 'temperatura', 616.0000, 'ºC'),
	(179544, 120, '2014-02-01 01:30:44.000000', 'temperatura', 1166.0000, 'ºC'),
	(179545, 120, '2014-02-01 01:30:45.000000', 'temperatura', 383.0000, 'ºC'),
	(179546, 120, '2014-02-01 01:30:46.000000', 'temperatura', 819.0000, 'ºC'),
	(179547, 120, '2014-02-01 01:30:47.000000', 'temperatura', 547.0000, 'ºC'),
	(179548, 120, '2014-02-01 01:30:48.000000', 'temperatura', 279.0000, 'ºC'),
	(179549, 120, '2014-02-01 01:30:49.000000', 'temperatura', 953.0000, 'ºC'),
	(179550, 120, '2014-02-01 01:30:50.000000', 'temperatura', 329.0000, 'ºC'),
	(179551, 120, '2014-02-01 01:30:51.000000', 'temperatura', 1187.0000, 'ºC'),
	(179552, 120, '2014-02-01 01:30:52.000000', 'temperatura', 149.0000, 'ºC'),
	(179553, 120, '2014-02-01 01:30:53.000000', 'temperatura', 783.0000, 'ºC'),
	(179554, 120, '2014-02-01 01:30:54.000000', 'temperatura', 1067.0000, 'ºC'),
	(179555, 120, '2014-02-01 01:30:55.000000', 'temperatura', 588.0000, 'ºC'),
	(179556, 120, '2014-02-01 01:30:56.000000', 'temperatura', 938.0000, 'ºC'),
	(179557, 120, '2014-02-01 01:30:57.000000', 'temperatura', 527.0000, 'ºC'),
	(179558, 120, '2014-02-01 01:30:58.000000', 'temperatura', 1021.0000, 'ºC'),
	(179559, 120, '2014-02-01 01:30:59.000000', 'temperatura', 1124.0000, 'ºC'),
	(179560, 120, '2014-02-01 01:31:00.000000', 'temperatura', 157.0000, 'ºC'),
	(179561, 120, '2014-02-01 01:31:01.000000', 'temperatura', 1014.0000, 'ºC'),
	(179562, 120, '2014-02-01 01:31:02.000000', 'temperatura', 1000.0000, 'ºC'),
	(179563, 120, '2014-02-01 01:31:03.000000', 'temperatura', 756.0000, 'ºC'),
	(179564, 120, '2014-02-01 01:31:04.000000', 'temperatura', 784.0000, 'ºC'),
	(179565, 121, '2014-02-01 00:00:00.000000', 'temperatura', 1095.0000, 'ºC'),
	(179566, 121, '2014-02-01 00:00:01.000000', 'temperatura', 530.0000, 'ºC'),
	(179567, 121, '2014-02-01 00:00:02.000000', 'temperatura', 566.0000, 'ºC'),
	(179568, 121, '2014-02-01 00:00:03.000000', 'temperatura', 38.0000, 'ºC'),
	(179569, 121, '2014-02-01 00:00:04.000000', 'temperatura', 892.0000, 'ºC'),
	(179570, 121, '2014-02-01 00:00:05.000000', 'temperatura', 747.0000, 'ºC'),
	(179571, 121, '2014-02-01 00:00:06.000000', 'temperatura', 1061.0000, 'ºC'),
	(179572, 121, '2014-02-01 00:00:07.000000', 'temperatura', 664.0000, 'ºC'),
	(179573, 121, '2014-02-01 00:00:08.000000', 'temperatura', 139.0000, 'ºC'),
	(179574, 121, '2014-02-01 00:00:09.000000', 'temperatura', 1104.0000, 'ºC'),
	(179575, 121, '2014-02-01 00:00:10.000000', 'temperatura', 303.0000, 'ºC'),
	(179576, 121, '2014-02-01 00:00:11.000000', 'temperatura', 605.0000, 'ºC'),
	(179577, 121, '2014-02-01 00:00:12.000000', 'temperatura', 916.0000, 'ºC'),
	(179578, 121, '2014-02-01 00:00:13.000000', 'temperatura', 363.0000, 'ºC'),
	(179579, 121, '2014-02-01 00:00:14.000000', 'temperatura', 270.0000, 'ºC'),
	(179580, 121, '2014-02-01 00:00:15.000000', 'temperatura', 261.0000, 'ºC'),
	(179581, 121, '2014-02-01 00:00:16.000000', 'temperatura', 493.0000, 'ºC'),
	(179582, 121, '2014-02-01 00:00:17.000000', 'temperatura', 485.0000, 'ºC'),
	(179583, 121, '2014-02-01 00:00:18.000000', 'temperatura', 947.0000, 'ºC'),
	(179584, 121, '2014-02-01 00:00:19.000000', 'temperatura', 880.0000, 'ºC'),
	(179585, 121, '2014-02-01 00:00:20.000000', 'temperatura', 358.0000, 'ºC'),
	(179586, 121, '2014-02-01 00:00:21.000000', 'temperatura', 352.0000, 'ºC'),
	(179587, 121, '2014-02-01 00:00:22.000000', 'temperatura', 687.0000, 'ºC'),
	(179588, 121, '2014-02-01 00:00:23.000000', 'temperatura', 1181.0000, 'ºC'),
	(179589, 121, '2014-02-01 00:00:24.000000', 'temperatura', 241.0000, 'ºC'),
	(179590, 121, '2014-02-01 00:00:25.000000', 'temperatura', 65.0000, 'ºC'),
	(179591, 121, '2014-02-01 00:00:26.000000', 'temperatura', 803.0000, 'ºC'),
	(179592, 121, '2014-02-01 00:00:27.000000', 'temperatura', 219.0000, 'ºC'),
	(179593, 121, '2014-02-01 00:00:28.000000', 'temperatura', 1085.0000, 'ºC'),
	(179594, 121, '2014-02-01 00:00:29.000000', 'temperatura', 1170.0000, 'ºC'),
	(179595, 121, '2014-02-01 00:00:30.000000', 'temperatura', 194.0000, 'ºC'),
	(179596, 121, '2014-02-01 00:00:31.000000', 'temperatura', 1060.0000, 'ºC'),
	(179597, 121, '2014-02-01 00:00:32.000000', 'temperatura', 1119.0000, 'ºC'),
	(179598, 121, '2014-02-01 00:00:33.000000', 'temperatura', 17.0000, 'ºC'),
	(179599, 121, '2014-02-01 00:00:34.000000', 'temperatura', 326.0000, 'ºC'),
	(179600, 121, '2014-02-01 00:00:35.000000', 'temperatura', 381.0000, 'ºC'),
	(179601, 121, '2014-02-01 00:00:36.000000', 'temperatura', 926.0000, 'ºC'),
	(179602, 121, '2014-02-01 00:00:37.000000', 'temperatura', 1089.0000, 'ºC'),
	(179603, 121, '2014-02-01 00:00:38.000000', 'temperatura', 268.0000, 'ºC'),
	(179604, 121, '2014-02-01 00:00:39.000000', 'temperatura', 472.0000, 'ºC'),
	(179605, 121, '2014-02-01 00:00:40.000000', 'temperatura', 357.0000, 'ºC'),
	(179606, 121, '2014-02-01 00:00:41.000000', 'temperatura', 369.0000, 'ºC'),
	(179607, 121, '2014-02-01 00:00:42.000000', 'temperatura', 776.0000, 'ºC'),
	(179608, 121, '2014-02-01 00:00:43.000000', 'temperatura', 373.0000, 'ºC'),
	(179609, 121, '2014-02-01 00:00:44.000000', 'temperatura', 736.0000, 'ºC'),
	(179610, 121, '2014-02-01 00:00:45.000000', 'temperatura', 164.0000, 'ºC'),
	(179611, 121, '2014-02-01 00:00:46.000000', 'temperatura', 1012.0000, 'ºC'),
	(179612, 121, '2014-02-01 00:00:47.000000', 'temperatura', 966.0000, 'ºC'),
	(179613, 121, '2014-02-01 00:00:48.000000', 'temperatura', 598.0000, 'ºC'),
	(179614, 121, '2014-02-01 00:00:49.000000', 'temperatura', 90.0000, 'ºC'),
	(179615, 121, '2014-02-01 00:00:50.000000', 'temperatura', 1056.0000, 'ºC'),
	(179616, 121, '2014-02-01 00:00:51.000000', 'temperatura', 210.0000, 'ºC'),
	(179617, 121, '2014-02-01 00:00:52.000000', 'temperatura', 285.0000, 'ºC'),
	(179618, 121, '2014-02-01 00:00:53.000000', 'temperatura', 796.0000, 'ºC'),
	(179619, 121, '2014-02-01 00:00:54.000000', 'temperatura', 726.0000, 'ºC'),
	(179620, 121, '2014-02-01 00:00:55.000000', 'temperatura', 42.0000, 'ºC'),
	(179621, 121, '2014-02-01 00:00:56.000000', 'temperatura', 434.0000, 'ºC'),
	(179622, 121, '2014-02-01 00:00:57.000000', 'temperatura', 843.0000, 'ºC'),
	(179623, 121, '2014-02-01 00:00:58.000000', 'temperatura', 513.0000, 'ºC'),
	(179624, 121, '2014-02-01 00:00:59.000000', 'temperatura', 37.0000, 'ºC'),
	(179625, 121, '2014-02-01 00:01:00.000000', 'temperatura', 1045.0000, 'ºC'),
	(179626, 121, '2014-02-01 00:01:01.000000', 'temperatura', 314.0000, 'ºC'),
	(179627, 121, '2014-02-01 00:01:02.000000', 'temperatura', 837.0000, 'ºC'),
	(179628, 121, '2014-02-01 00:01:03.000000', 'temperatura', 842.0000, 'ºC'),
	(179629, 121, '2014-02-01 00:01:04.000000', 'temperatura', 500.0000, 'ºC'),
	(179630, 121, '2014-02-01 00:01:05.000000', 'temperatura', 1174.0000, 'ºC'),
	(179631, 121, '2014-02-01 00:01:06.000000', 'temperatura', 771.0000, 'ºC'),
	(179632, 121, '2014-02-01 00:01:07.000000', 'temperatura', 333.0000, 'ºC'),
	(179633, 121, '2014-02-01 00:01:08.000000', 'temperatura', 553.0000, 'ºC'),
	(179634, 121, '2014-02-01 00:01:09.000000', 'temperatura', 567.0000, 'ºC'),
	(179635, 121, '2014-02-01 00:01:10.000000', 'temperatura', 1175.0000, 'ºC'),
	(179636, 121, '2014-02-01 00:01:11.000000', 'temperatura', 574.0000, 'ºC'),
	(179637, 121, '2014-02-01 00:01:12.000000', 'temperatura', 548.0000, 'ºC'),
	(179638, 121, '2014-02-01 00:01:13.000000', 'temperatura', 1016.0000, 'ºC'),
	(179639, 121, '2014-02-01 00:01:14.000000', 'temperatura', 1039.0000, 'ºC'),
	(179640, 121, '2014-02-01 00:01:15.000000', 'temperatura', 948.0000, 'ºC'),
	(179641, 121, '2014-02-01 00:01:16.000000', 'temperatura', 424.0000, 'ºC'),
	(179642, 121, '2014-02-01 00:01:17.000000', 'temperatura', 475.0000, 'ºC'),
	(179643, 121, '2014-02-01 00:01:18.000000', 'temperatura', 1103.0000, 'ºC'),
	(179644, 121, '2014-02-01 00:01:19.000000', 'temperatura', 490.0000, 'ºC'),
	(179645, 121, '2014-02-01 00:01:20.000000', 'temperatura', 341.0000, 'ºC'),
	(179646, 121, '2014-02-01 00:01:21.000000', 'temperatura', 238.0000, 'ºC'),
	(179647, 121, '2014-02-01 00:01:22.000000', 'temperatura', 165.0000, 'ºC'),
	(179648, 121, '2014-02-01 00:01:23.000000', 'temperatura', 111.0000, 'ºC'),
	(179649, 121, '2014-02-01 00:01:24.000000', 'temperatura', 64.0000, 'ºC'),
	(179650, 121, '2014-02-01 00:01:25.000000', 'temperatura', 1184.0000, 'ºC'),
	(179651, 121, '2014-02-01 00:01:26.000000', 'temperatura', 929.0000, 'ºC'),
	(179652, 121, '2014-02-01 00:01:27.000000', 'temperatura', 1095.0000, 'ºC'),
	(179653, 121, '2014-02-01 00:01:28.000000', 'temperatura', 287.0000, 'ºC'),
	(179654, 121, '2014-02-01 00:01:29.000000', 'temperatura', 549.0000, 'ºC'),
	(179655, 121, '2014-02-01 00:01:30.000000', 'temperatura', 688.0000, 'ºC'),
	(179656, 121, '2014-02-01 00:01:31.000000', 'temperatura', 592.0000, 'ºC'),
	(179657, 121, '2014-02-01 00:01:32.000000', 'temperatura', 895.0000, 'ºC'),
	(179658, 121, '2014-02-01 00:01:33.000000', 'temperatura', 299.0000, 'ºC'),
	(179659, 121, '2014-02-01 00:01:34.000000', 'temperatura', 10.0000, 'ºC'),
	(179660, 121, '2014-02-01 00:01:35.000000', 'temperatura', 353.0000, 'ºC'),
	(179661, 121, '2014-02-01 00:01:36.000000', 'temperatura', 538.0000, 'ºC'),
	(179662, 121, '2014-02-01 00:01:37.000000', 'temperatura', 430.0000, 'ºC'),
	(179663, 121, '2014-02-01 00:01:38.000000', 'temperatura', 538.0000, 'ºC'),
	(179664, 121, '2014-02-01 00:01:39.000000', 'temperatura', 201.0000, 'ºC'),
	(179665, 121, '2014-02-01 00:01:40.000000', 'temperatura', 592.0000, 'ºC'),
	(179666, 121, '2014-02-01 00:01:41.000000', 'temperatura', 1157.0000, 'ºC'),
	(179667, 121, '2014-02-01 00:01:42.000000', 'temperatura', 410.0000, 'ºC'),
	(179668, 121, '2014-02-01 00:01:43.000000', 'temperatura', 980.0000, 'ºC'),
	(179669, 121, '2014-02-01 00:01:44.000000', 'temperatura', 68.0000, 'ºC'),
	(179670, 121, '2014-02-01 00:01:45.000000', 'temperatura', 1002.0000, 'ºC'),
	(179671, 121, '2014-02-01 00:01:46.000000', 'temperatura', 5.0000, 'ºC'),
	(179672, 121, '2014-02-01 00:01:47.000000', 'temperatura', 621.0000, 'ºC'),
	(179673, 121, '2014-02-01 00:01:48.000000', 'temperatura', 692.0000, 'ºC'),
	(179674, 121, '2014-02-01 00:01:49.000000', 'temperatura', 396.0000, 'ºC'),
	(179675, 121, '2014-02-01 00:01:50.000000', 'temperatura', 1103.0000, 'ºC'),
	(179676, 121, '2014-02-01 00:01:51.000000', 'temperatura', 727.0000, 'ºC'),
	(179677, 121, '2014-02-01 00:01:52.000000', 'temperatura', 326.0000, 'ºC'),
	(179678, 121, '2014-02-01 00:01:53.000000', 'temperatura', 652.0000, 'ºC'),
	(179679, 121, '2014-02-01 00:01:54.000000', 'temperatura', 1083.0000, 'ºC'),
	(179680, 121, '2014-02-01 00:01:55.000000', 'temperatura', 1060.0000, 'ºC'),
	(179681, 121, '2014-02-01 00:01:56.000000', 'temperatura', 852.0000, 'ºC'),
	(179682, 121, '2014-02-01 00:01:57.000000', 'temperatura', 1079.0000, 'ºC'),
	(179683, 121, '2014-02-01 00:01:58.000000', 'temperatura', 439.0000, 'ºC'),
	(179684, 121, '2014-02-01 00:01:59.000000', 'temperatura', 159.0000, 'ºC'),
	(179685, 121, '2014-02-01 00:02:00.000000', 'temperatura', 679.0000, 'ºC'),
	(179686, 121, '2014-02-01 00:02:01.000000', 'temperatura', 518.0000, 'ºC'),
	(179687, 121, '2014-02-01 00:02:02.000000', 'temperatura', 552.0000, 'ºC'),
	(179688, 121, '2014-02-01 00:02:03.000000', 'temperatura', 6.0000, 'ºC'),
	(179689, 121, '2014-02-01 00:02:04.000000', 'temperatura', 777.0000, 'ºC'),
	(179690, 121, '2014-02-01 00:02:05.000000', 'temperatura', 265.0000, 'ºC'),
	(179691, 121, '2014-02-01 00:02:06.000000', 'temperatura', 197.0000, 'ºC'),
	(179692, 121, '2014-02-01 00:02:07.000000', 'temperatura', 190.0000, 'ºC'),
	(179693, 121, '2014-02-01 00:02:08.000000', 'temperatura', 361.0000, 'ºC'),
	(179694, 121, '2014-02-01 00:02:09.000000', 'temperatura', 35.0000, 'ºC'),
	(179695, 121, '2014-02-01 00:02:10.000000', 'temperatura', 291.0000, 'ºC'),
	(179696, 121, '2014-02-01 00:02:11.000000', 'temperatura', 152.0000, 'ºC'),
	(179697, 121, '2014-02-01 00:02:12.000000', 'temperatura', 1089.0000, 'ºC'),
	(179698, 121, '2014-02-01 00:02:13.000000', 'temperatura', 187.0000, 'ºC'),
	(179699, 121, '2014-02-01 00:02:14.000000', 'temperatura', 68.0000, 'ºC'),
	(179700, 121, '2014-02-01 00:02:15.000000', 'temperatura', 981.0000, 'ºC'),
	(179701, 121, '2014-02-01 00:02:16.000000', 'temperatura', 1101.0000, 'ºC'),
	(179702, 121, '2014-02-01 00:02:17.000000', 'temperatura', 165.0000, 'ºC'),
	(179703, 121, '2014-02-01 00:02:18.000000', 'temperatura', 1119.0000, 'ºC'),
	(179704, 121, '2014-02-01 00:02:19.000000', 'temperatura', 303.0000, 'ºC'),
	(179705, 121, '2014-02-01 00:02:20.000000', 'temperatura', 559.0000, 'ºC'),
	(179706, 121, '2014-02-01 00:02:21.000000', 'temperatura', 684.0000, 'ºC'),
	(179707, 121, '2014-02-01 00:02:22.000000', 'temperatura', 543.0000, 'ºC'),
	(179708, 121, '2014-02-01 00:02:23.000000', 'temperatura', 663.0000, 'ºC'),
	(179709, 121, '2014-02-01 00:02:24.000000', 'temperatura', 487.0000, 'ºC'),
	(179710, 121, '2014-02-01 00:02:25.000000', 'temperatura', 447.0000, 'ºC'),
	(179711, 121, '2014-02-01 00:02:26.000000', 'temperatura', 773.0000, 'ºC'),
	(179712, 121, '2014-02-01 00:02:27.000000', 'temperatura', 124.0000, 'ºC'),
	(179713, 121, '2014-02-01 00:02:28.000000', 'temperatura', 704.0000, 'ºC'),
	(179714, 121, '2014-02-01 00:02:29.000000', 'temperatura', 746.0000, 'ºC'),
	(179715, 121, '2014-02-01 00:02:30.000000', 'temperatura', 420.0000, 'ºC'),
	(179716, 121, '2014-02-01 00:02:31.000000', 'temperatura', 1063.0000, 'ºC'),
	(179717, 121, '2014-02-01 00:02:32.000000', 'temperatura', 456.0000, 'ºC'),
	(179718, 121, '2014-02-01 00:02:33.000000', 'temperatura', 290.0000, 'ºC'),
	(179719, 121, '2014-02-01 00:02:34.000000', 'temperatura', 82.0000, 'ºC'),
	(179720, 121, '2014-02-01 00:02:35.000000', 'temperatura', 743.0000, 'ºC'),
	(179721, 121, '2014-02-01 00:02:36.000000', 'temperatura', 1069.0000, 'ºC'),
	(179722, 121, '2014-02-01 00:02:37.000000', 'temperatura', 716.0000, 'ºC'),
	(179723, 121, '2014-02-01 00:02:38.000000', 'temperatura', 375.0000, 'ºC'),
	(179724, 121, '2014-02-01 00:02:39.000000', 'temperatura', 928.0000, 'ºC'),
	(179725, 121, '2014-02-01 00:02:40.000000', 'temperatura', 1113.0000, 'ºC'),
	(179726, 121, '2014-02-01 00:02:41.000000', 'temperatura', 382.0000, 'ºC'),
	(179727, 121, '2014-02-01 00:02:42.000000', 'temperatura', 974.0000, 'ºC'),
	(179728, 121, '2014-02-01 00:02:43.000000', 'temperatura', 121.0000, 'ºC'),
	(179729, 121, '2014-02-01 00:02:44.000000', 'temperatura', 86.0000, 'ºC'),
	(179730, 121, '2014-02-01 00:02:45.000000', 'temperatura', 65.0000, 'ºC'),
	(179731, 121, '2014-02-01 00:02:46.000000', 'temperatura', 70.0000, 'ºC'),
	(179732, 121, '2014-02-01 00:02:47.000000', 'temperatura', 152.0000, 'ºC'),
	(179733, 121, '2014-02-01 00:02:48.000000', 'temperatura', 554.0000, 'ºC'),
	(179734, 121, '2014-02-01 00:02:49.000000', 'temperatura', 1115.0000, 'ºC'),
	(179735, 121, '2014-02-01 00:02:50.000000', 'temperatura', 313.0000, 'ºC'),
	(179736, 121, '2014-02-01 00:02:51.000000', 'temperatura', 619.0000, 'ºC'),
	(179737, 121, '2014-02-01 00:02:52.000000', 'temperatura', 956.0000, 'ºC'),
	(179738, 121, '2014-02-01 00:02:53.000000', 'temperatura', 525.0000, 'ºC'),
	(179739, 121, '2014-02-01 00:02:54.000000', 'temperatura', 956.0000, 'ºC'),
	(179740, 121, '2014-02-01 00:02:55.000000', 'temperatura', 805.0000, 'ºC'),
	(179741, 121, '2014-02-01 00:02:56.000000', 'temperatura', 1159.0000, 'ºC'),
	(179742, 121, '2014-02-01 00:02:57.000000', 'temperatura', 981.0000, 'ºC'),
	(179743, 121, '2014-02-01 00:02:58.000000', 'temperatura', 227.0000, 'ºC'),
	(179744, 121, '2014-02-01 00:02:59.000000', 'temperatura', 591.0000, 'ºC'),
	(179745, 121, '2014-02-01 00:03:00.000000', 'temperatura', 1077.0000, 'ºC'),
	(179746, 121, '2014-02-01 00:03:01.000000', 'temperatura', 10.0000, 'ºC'),
	(179747, 121, '2014-02-01 00:03:02.000000', 'temperatura', 421.0000, 'ºC'),
	(179748, 121, '2014-02-01 00:03:03.000000', 'temperatura', 875.0000, 'ºC'),
	(179749, 121, '2014-02-01 00:03:04.000000', 'temperatura', 714.0000, 'ºC'),
	(179750, 121, '2014-02-01 00:03:05.000000', 'temperatura', 945.0000, 'ºC'),
	(179751, 121, '2014-02-01 00:03:06.000000', 'temperatura', 183.0000, 'ºC'),
	(179752, 121, '2014-02-01 00:03:07.000000', 'temperatura', 481.0000, 'ºC'),
	(179753, 121, '2014-02-01 00:03:08.000000', 'temperatura', 658.0000, 'ºC'),
	(179754, 121, '2014-02-01 00:03:09.000000', 'temperatura', 645.0000, 'ºC'),
	(179755, 121, '2014-02-01 00:03:10.000000', 'temperatura', 52.0000, 'ºC'),
	(179756, 121, '2014-02-01 00:03:11.000000', 'temperatura', 727.0000, 'ºC'),
	(179757, 121, '2014-02-01 00:03:12.000000', 'temperatura', 1079.0000, 'ºC'),
	(179758, 121, '2014-02-01 00:03:13.000000', 'temperatura', 813.0000, 'ºC'),
	(179759, 121, '2014-02-01 00:03:14.000000', 'temperatura', 829.0000, 'ºC'),
	(179760, 121, '2014-02-01 00:03:15.000000', 'temperatura', 508.0000, 'ºC'),
	(179761, 121, '2014-02-01 00:03:16.000000', 'temperatura', 55.0000, 'ºC'),
	(179762, 121, '2014-02-01 00:03:17.000000', 'temperatura', 1148.0000, 'ºC'),
	(179763, 121, '2014-02-01 00:03:18.000000', 'temperatura', 776.0000, 'ºC'),
	(179764, 121, '2014-02-01 00:03:19.000000', 'temperatura', 435.0000, 'ºC'),
	(179765, 121, '2014-02-01 00:03:20.000000', 'temperatura', 1049.0000, 'ºC'),
	(179766, 121, '2014-02-01 00:03:21.000000', 'temperatura', 339.0000, 'ºC'),
	(179767, 121, '2014-02-01 00:03:22.000000', 'temperatura', 951.0000, 'ºC'),
	(179768, 121, '2014-02-01 00:03:23.000000', 'temperatura', 136.0000, 'ºC'),
	(179769, 121, '2014-02-01 00:03:24.000000', 'temperatura', 229.0000, 'ºC'),
	(179770, 121, '2014-02-01 00:03:25.000000', 'temperatura', 735.0000, 'ºC'),
	(179771, 121, '2014-02-01 00:03:26.000000', 'temperatura', 592.0000, 'ºC'),
	(179772, 121, '2014-02-01 00:03:27.000000', 'temperatura', 754.0000, 'ºC'),
	(179773, 121, '2014-02-01 00:03:28.000000', 'temperatura', 796.0000, 'ºC'),
	(179774, 121, '2014-02-01 00:03:29.000000', 'temperatura', 517.0000, 'ºC'),
	(179775, 121, '2014-02-01 00:03:30.000000', 'temperatura', 197.0000, 'ºC'),
	(179776, 121, '2014-02-01 00:03:31.000000', 'temperatura', 634.0000, 'ºC'),
	(179777, 121, '2014-02-01 00:03:32.000000', 'temperatura', 182.0000, 'ºC'),
	(179778, 121, '2014-02-01 00:03:33.000000', 'temperatura', 207.0000, 'ºC'),
	(179779, 121, '2014-02-01 00:03:34.000000', 'temperatura', 490.0000, 'ºC'),
	(179780, 121, '2014-02-01 00:03:35.000000', 'temperatura', 628.0000, 'ºC'),
	(179781, 121, '2014-02-01 00:03:36.000000', 'temperatura', 470.0000, 'ºC'),
	(179782, 121, '2014-02-01 00:03:37.000000', 'temperatura', 469.0000, 'ºC'),
	(179783, 121, '2014-02-01 00:03:38.000000', 'temperatura', 934.0000, 'ºC'),
	(179784, 121, '2014-02-01 00:03:39.000000', 'temperatura', 865.0000, 'ºC'),
	(179785, 121, '2014-02-01 00:03:40.000000', 'temperatura', 324.0000, 'ºC'),
	(179786, 121, '2014-02-01 00:03:41.000000', 'temperatura', 224.0000, 'ºC'),
	(179787, 121, '2014-02-01 00:03:42.000000', 'temperatura', 149.0000, 'ºC'),
	(179788, 121, '2014-02-01 00:03:43.000000', 'temperatura', 72.0000, 'ºC'),
	(179789, 121, '2014-02-01 00:03:44.000000', 'temperatura', 1114.0000, 'ºC'),
	(179790, 121, '2014-02-01 00:03:45.000000', 'temperatura', 554.0000, 'ºC'),
	(179791, 121, '2014-02-01 00:03:46.000000', 'temperatura', 630.0000, 'ºC'),
	(179792, 121, '2014-02-01 00:03:47.000000', 'temperatura', 289.0000, 'ºC'),
	(179793, 121, '2014-02-01 00:03:48.000000', 'temperatura', 755.0000, 'ºC'),
	(179794, 121, '2014-02-01 00:03:49.000000', 'temperatura', 508.0000, 'ºC'),
	(179795, 121, '2014-02-01 00:03:50.000000', 'temperatura', 277.0000, 'ºC'),
	(179796, 121, '2014-02-01 00:03:51.000000', 'temperatura', 1060.0000, 'ºC'),
	(179797, 121, '2014-02-01 00:03:52.000000', 'temperatura', 871.0000, 'ºC'),
	(179798, 121, '2014-02-01 00:03:53.000000', 'temperatura', 1175.0000, 'ºC'),
	(179799, 121, '2014-02-01 00:03:54.000000', 'temperatura', 863.0000, 'ºC'),
	(179800, 121, '2014-02-01 00:03:55.000000', 'temperatura', 789.0000, 'ºC'),
	(179801, 121, '2014-02-01 00:03:56.000000', 'temperatura', 156.0000, 'ºC'),
	(179802, 121, '2014-02-01 00:03:57.000000', 'temperatura', 814.0000, 'ºC'),
	(179803, 121, '2014-02-01 00:03:58.000000', 'temperatura', 4.0000, 'ºC'),
	(179804, 121, '2014-02-01 00:03:59.000000', 'temperatura', 1179.0000, 'ºC'),
	(179805, 121, '2014-02-01 00:04:00.000000', 'temperatura', 1083.0000, 'ºC'),
	(179806, 121, '2014-02-01 00:04:01.000000', 'temperatura', 678.0000, 'ºC'),
	(179807, 121, '2014-02-01 00:04:02.000000', 'temperatura', 141.0000, 'ºC'),
	(179808, 121, '2014-02-01 00:04:03.000000', 'temperatura', 1073.0000, 'ºC'),
	(179809, 121, '2014-02-01 00:04:04.000000', 'temperatura', 143.0000, 'ºC'),
	(179810, 121, '2014-02-01 00:04:05.000000', 'temperatura', 1095.0000, 'ºC'),
	(179811, 121, '2014-02-01 00:04:06.000000', 'temperatura', 249.0000, 'ºC'),
	(179812, 121, '2014-02-01 00:04:07.000000', 'temperatura', 359.0000, 'ºC'),
	(179813, 121, '2014-02-01 00:04:08.000000', 'temperatura', 1048.0000, 'ºC'),
	(179814, 121, '2014-02-01 00:04:09.000000', 'temperatura', 565.0000, 'ºC'),
	(179815, 121, '2014-02-01 00:04:10.000000', 'temperatura', 879.0000, 'ºC'),
	(179816, 121, '2014-02-01 00:04:11.000000', 'temperatura', 304.0000, 'ºC'),
	(179817, 121, '2014-02-01 00:04:12.000000', 'temperatura', 81.0000, 'ºC'),
	(179818, 121, '2014-02-01 00:04:13.000000', 'temperatura', 695.0000, 'ºC'),
	(179819, 121, '2014-02-01 00:04:14.000000', 'temperatura', 832.0000, 'ºC'),
	(179820, 121, '2014-02-01 00:04:15.000000', 'temperatura', 874.0000, 'ºC'),
	(179821, 121, '2014-02-01 00:04:16.000000', 'temperatura', 674.0000, 'ºC'),
	(179822, 121, '2014-02-01 00:04:17.000000', 'temperatura', 750.0000, 'ºC'),
	(179823, 121, '2014-02-01 00:04:18.000000', 'temperatura', 529.0000, 'ºC'),
	(179824, 121, '2014-02-01 00:04:19.000000', 'temperatura', 395.0000, 'ºC'),
	(179825, 121, '2014-02-01 00:04:20.000000', 'temperatura', 390.0000, 'ºC'),
	(179826, 121, '2014-02-01 00:04:21.000000', 'temperatura', 764.0000, 'ºC'),
	(179827, 121, '2014-02-01 00:04:22.000000', 'temperatura', 249.0000, 'ºC'),
	(179828, 121, '2014-02-01 00:04:23.000000', 'temperatura', 156.0000, 'ºC'),
	(179829, 121, '2014-02-01 00:04:24.000000', 'temperatura', 35.0000, 'ºC'),
	(179830, 121, '2014-02-01 00:04:25.000000', 'temperatura', 905.0000, 'ºC'),
	(179831, 121, '2014-02-01 00:04:26.000000', 'temperatura', 820.0000, 'ºC'),
	(179832, 121, '2014-02-01 00:04:27.000000', 'temperatura', 188.0000, 'ºC'),
	(179833, 121, '2014-02-01 00:04:28.000000', 'temperatura', 879.0000, 'ºC'),
	(179834, 121, '2014-02-01 00:04:29.000000', 'temperatura', 233.0000, 'ºC'),
	(179835, 121, '2014-02-01 00:04:30.000000', 'temperatura', 926.0000, 'ºC'),
	(179836, 121, '2014-02-01 00:04:31.000000', 'temperatura', 333.0000, 'ºC'),
	(179837, 121, '2014-02-01 00:04:32.000000', 'temperatura', 85.0000, 'ºC'),
	(179838, 121, '2014-02-01 00:04:33.000000', 'temperatura', 630.0000, 'ºC'),
	(179839, 121, '2014-02-01 00:04:34.000000', 'temperatura', 492.0000, 'ºC'),
	(179840, 121, '2014-02-01 00:04:35.000000', 'temperatura', 574.0000, 'ºC'),
	(179841, 121, '2014-02-01 00:04:36.000000', 'temperatura', 192.0000, 'ºC'),
	(179842, 121, '2014-02-01 00:04:37.000000', 'temperatura', 439.0000, 'ºC'),
	(179843, 121, '2014-02-01 00:04:38.000000', 'temperatura', 420.0000, 'ºC'),
	(179844, 121, '2014-02-01 00:04:39.000000', 'temperatura', 781.0000, 'ºC'),
	(179845, 121, '2014-02-01 00:04:40.000000', 'temperatura', 248.0000, 'ºC'),
	(179846, 121, '2014-02-01 00:04:41.000000', 'temperatura', 97.0000, 'ºC'),
	(179847, 121, '2014-02-01 00:04:42.000000', 'temperatura', 941.0000, 'ºC'),
	(179848, 121, '2014-02-01 00:04:43.000000', 'temperatura', 817.0000, 'ºC'),
	(179849, 121, '2014-02-01 00:04:44.000000', 'temperatura', 60.0000, 'ºC'),
	(179850, 121, '2014-02-01 00:04:45.000000', 'temperatura', 248.0000, 'ºC'),
	(179851, 121, '2014-02-01 00:04:46.000000', 'temperatura', 1063.0000, 'ºC'),
	(179852, 121, '2014-02-01 00:04:47.000000', 'temperatura', 970.0000, 'ºC'),
	(179853, 121, '2014-02-01 00:04:48.000000', 'temperatura', 464.0000, 'ºC'),
	(179854, 121, '2014-02-01 00:04:49.000000', 'temperatura', 609.0000, 'ºC'),
	(179855, 121, '2014-02-01 00:04:50.000000', 'temperatura', 455.0000, 'ºC'),
	(179856, 121, '2014-02-01 00:04:51.000000', 'temperatura', 449.0000, 'ºC'),
	(179857, 121, '2014-02-01 00:04:52.000000', 'temperatura', 877.0000, 'ºC'),
	(179858, 121, '2014-02-01 00:04:53.000000', 'temperatura', 642.0000, 'ºC'),
	(179859, 121, '2014-02-01 00:04:54.000000', 'temperatura', 577.0000, 'ºC'),
	(179860, 121, '2014-02-01 00:04:55.000000', 'temperatura', 961.0000, 'ºC'),
	(179861, 121, '2014-02-01 00:04:56.000000', 'temperatura', 675.0000, 'ºC'),
	(179862, 121, '2014-02-01 00:04:57.000000', 'temperatura', 494.0000, 'ºC'),
	(179863, 121, '2014-02-01 00:04:58.000000', 'temperatura', 442.0000, 'ºC'),
	(179864, 121, '2014-02-01 00:04:59.000000', 'temperatura', 731.0000, 'ºC'),
	(179865, 121, '2014-02-01 00:05:00.000000', 'temperatura', 1129.0000, 'ºC'),
	(179866, 121, '2014-02-01 00:05:01.000000', 'temperatura', 1051.0000, 'ºC'),
	(179867, 121, '2014-02-01 00:05:02.000000', 'temperatura', 668.0000, 'ºC'),
	(179868, 121, '2014-02-01 00:05:03.000000', 'temperatura', 190.0000, 'ºC'),
	(179869, 121, '2014-02-01 00:05:04.000000', 'temperatura', 147.0000, 'ºC'),
	(179870, 121, '2014-02-01 00:05:05.000000', 'temperatura', 165.0000, 'ºC'),
	(179871, 121, '2014-02-01 00:05:06.000000', 'temperatura', 383.0000, 'ºC'),
	(179872, 121, '2014-02-01 00:05:07.000000', 'temperatura', 223.0000, 'ºC'),
	(179873, 121, '2014-02-01 00:05:08.000000', 'temperatura', 1163.0000, 'ºC'),
	(179874, 121, '2014-02-01 00:05:09.000000', 'temperatura', 349.0000, 'ºC'),
	(179875, 121, '2014-02-01 00:05:10.000000', 'temperatura', 655.0000, 'ºC'),
	(179876, 121, '2014-02-01 00:05:11.000000', 'temperatura', 1030.0000, 'ºC'),
	(179877, 121, '2014-02-01 00:05:12.000000', 'temperatura', 787.0000, 'ºC'),
	(179878, 121, '2014-02-01 00:05:13.000000', 'temperatura', 844.0000, 'ºC'),
	(179879, 121, '2014-02-01 00:05:14.000000', 'temperatura', 660.0000, 'ºC'),
	(179880, 121, '2014-02-01 00:05:15.000000', 'temperatura', 766.0000, 'ºC'),
	(179881, 121, '2014-02-01 00:05:16.000000', 'temperatura', 654.0000, 'ºC'),
	(179882, 121, '2014-02-01 00:05:17.000000', 'temperatura', 969.0000, 'ºC'),
	(179883, 121, '2014-02-01 00:05:18.000000', 'temperatura', 487.0000, 'ºC'),
	(179884, 121, '2014-02-01 00:05:19.000000', 'temperatura', 727.0000, 'ºC'),
	(179885, 121, '2014-02-01 00:05:20.000000', 'temperatura', 974.0000, 'ºC'),
	(179886, 121, '2014-02-01 00:05:21.000000', 'temperatura', 292.0000, 'ºC'),
	(179887, 121, '2014-02-01 00:05:22.000000', 'temperatura', 937.0000, 'ºC'),
	(179888, 121, '2014-02-01 00:05:23.000000', 'temperatura', 209.0000, 'ºC'),
	(179889, 121, '2014-02-01 00:05:24.000000', 'temperatura', 636.0000, 'ºC'),
	(179890, 121, '2014-02-01 00:05:25.000000', 'temperatura', 154.0000, 'ºC'),
	(179891, 121, '2014-02-01 00:05:26.000000', 'temperatura', 63.0000, 'ºC'),
	(179892, 121, '2014-02-01 00:05:27.000000', 'temperatura', 1054.0000, 'ºC'),
	(179893, 121, '2014-02-01 00:05:28.000000', 'temperatura', 281.0000, 'ºC'),
	(179894, 121, '2014-02-01 00:05:29.000000', 'temperatura', 645.0000, 'ºC'),
	(179895, 121, '2014-02-01 00:05:30.000000', 'temperatura', 1180.0000, 'ºC'),
	(179896, 121, '2014-02-01 00:05:31.000000', 'temperatura', 365.0000, 'ºC'),
	(179897, 121, '2014-02-01 00:05:32.000000', 'temperatura', 686.0000, 'ºC'),
	(179898, 121, '2014-02-01 00:05:33.000000', 'temperatura', 1134.0000, 'ºC'),
	(179899, 121, '2014-02-01 00:05:34.000000', 'temperatura', 16.0000, 'ºC'),
	(179900, 121, '2014-02-01 00:05:35.000000', 'temperatura', 275.0000, 'ºC'),
	(179901, 121, '2014-02-01 00:05:36.000000', 'temperatura', 129.0000, 'ºC'),
	(179902, 121, '2014-02-01 00:05:37.000000', 'temperatura', 1022.0000, 'ºC'),
	(179903, 121, '2014-02-01 00:05:38.000000', 'temperatura', 1122.0000, 'ºC'),
	(179904, 121, '2014-02-01 00:05:39.000000', 'temperatura', 146.0000, 'ºC'),
	(179905, 121, '2014-02-01 00:05:40.000000', 'temperatura', 966.0000, 'ºC'),
	(179906, 121, '2014-02-01 00:05:41.000000', 'temperatura', 790.0000, 'ºC'),
	(179907, 121, '2014-02-01 00:05:42.000000', 'temperatura', 1052.0000, 'ºC'),
	(179908, 121, '2014-02-01 00:05:43.000000', 'temperatura', 493.0000, 'ºC'),
	(179909, 121, '2014-02-01 00:05:44.000000', 'temperatura', 509.0000, 'ºC'),
	(179910, 121, '2014-02-01 00:05:45.000000', 'temperatura', 1064.0000, 'ºC'),
	(179911, 121, '2014-02-01 00:05:46.000000', 'temperatura', 196.0000, 'ºC'),
	(179912, 121, '2014-02-01 00:05:47.000000', 'temperatura', 188.0000, 'ºC'),
	(179913, 121, '2014-02-01 00:05:48.000000', 'temperatura', 351.0000, 'ºC'),
	(179914, 121, '2014-02-01 00:05:49.000000', 'temperatura', 1193.0000, 'ºC'),
	(179915, 121, '2014-02-01 00:05:50.000000', 'temperatura', 111.0000, 'ºC'),
	(179916, 121, '2014-02-01 00:05:51.000000', 'temperatura', 577.0000, 'ºC'),
	(179917, 121, '2014-02-01 00:05:52.000000', 'temperatura', 155.0000, 'ºC'),
	(179918, 121, '2014-02-01 00:05:53.000000', 'temperatura', 241.0000, 'ºC'),
	(179919, 121, '2014-02-01 00:05:54.000000', 'temperatura', 742.0000, 'ºC'),
	(179920, 121, '2014-02-01 00:05:55.000000', 'temperatura', 587.0000, 'ºC'),
	(179921, 121, '2014-02-01 00:05:56.000000', 'temperatura', 711.0000, 'ºC'),
	(179922, 121, '2014-02-01 00:05:57.000000', 'temperatura', 596.0000, 'ºC'),
	(179923, 121, '2014-02-01 00:05:58.000000', 'temperatura', 845.0000, 'ºC'),
	(179924, 121, '2014-02-01 00:05:59.000000', 'temperatura', 37.0000, 'ºC'),
	(179925, 121, '2014-02-01 00:06:00.000000', 'temperatura', 51.0000, 'ºC'),
	(179926, 121, '2014-02-01 00:06:01.000000', 'temperatura', 143.0000, 'ºC'),
	(179927, 121, '2014-02-01 00:06:02.000000', 'temperatura', 565.0000, 'ºC'),
	(179928, 121, '2014-02-01 00:06:03.000000', 'temperatura', 1195.0000, 'ºC'),
	(179929, 121, '2014-02-01 00:06:04.000000', 'temperatura', 683.0000, 'ºC'),
	(179930, 121, '2014-02-01 00:06:05.000000', 'temperatura', 1028.0000, 'ºC'),
	(179931, 121, '2014-02-01 00:06:06.000000', 'temperatura', 691.0000, 'ºC'),
	(179932, 121, '2014-02-01 00:06:07.000000', 'temperatura', 371.0000, 'ºC'),
	(179933, 121, '2014-02-01 00:06:08.000000', 'temperatura', 983.0000, 'ºC'),
	(179934, 121, '2014-02-01 00:06:09.000000', 'temperatura', 202.0000, 'ºC'),
	(179935, 121, '2014-02-01 00:06:10.000000', 'temperatura', 464.0000, 'ºC'),
	(179936, 121, '2014-02-01 00:06:11.000000', 'temperatura', 512.0000, 'ºC'),
	(179937, 121, '2014-02-01 00:06:12.000000', 'temperatura', 1170.0000, 'ºC'),
	(179938, 121, '2014-02-01 00:06:13.000000', 'temperatura', 715.0000, 'ºC'),
	(179939, 121, '2014-02-01 00:06:14.000000', 'temperatura', 67.0000, 'ºC'),
	(179940, 121, '2014-02-01 00:06:15.000000', 'temperatura', 589.0000, 'ºC'),
	(179941, 121, '2014-02-01 00:06:16.000000', 'temperatura', 343.0000, 'ºC'),
	(179942, 121, '2014-02-01 00:06:17.000000', 'temperatura', 1148.0000, 'ºC'),
	(179943, 121, '2014-02-01 00:06:18.000000', 'temperatura', 1114.0000, 'ºC'),
	(179944, 121, '2014-02-01 00:06:19.000000', 'temperatura', 925.0000, 'ºC'),
	(179945, 121, '2014-02-01 00:06:20.000000', 'temperatura', 85.0000, 'ºC'),
	(179946, 121, '2014-02-01 00:06:21.000000', 'temperatura', 50.0000, 'ºC'),
	(179947, 121, '2014-02-01 00:06:22.000000', 'temperatura', 1195.0000, 'ºC'),
	(179948, 121, '2014-02-01 00:06:23.000000', 'temperatura', 1025.0000, 'ºC'),
	(179949, 121, '2014-02-01 00:06:24.000000', 'temperatura', 342.0000, 'ºC'),
	(179950, 121, '2014-02-01 00:06:25.000000', 'temperatura', 1033.0000, 'ºC'),
	(179951, 121, '2014-02-01 00:06:26.000000', 'temperatura', 539.0000, 'ºC'),
	(179952, 121, '2014-02-01 00:06:27.000000', 'temperatura', 800.0000, 'ºC'),
	(179953, 121, '2014-02-01 00:06:28.000000', 'temperatura', 1181.0000, 'ºC'),
	(179954, 121, '2014-02-01 00:06:29.000000', 'temperatura', 1104.0000, 'ºC'),
	(179955, 121, '2014-02-01 00:06:30.000000', 'temperatura', 780.0000, 'ºC'),
	(179956, 121, '2014-02-01 00:06:31.000000', 'temperatura', 586.0000, 'ºC'),
	(179957, 121, '2014-02-01 00:06:32.000000', 'temperatura', 593.0000, 'ºC'),
	(179958, 121, '2014-02-01 00:06:33.000000', 'temperatura', 8.0000, 'ºC'),
	(179959, 121, '2014-02-01 00:06:34.000000', 'temperatura', 659.0000, 'ºC'),
	(179960, 121, '2014-02-01 00:06:35.000000', 'temperatura', 873.0000, 'ºC'),
	(179961, 121, '2014-02-01 00:06:36.000000', 'temperatura', 1190.0000, 'ºC'),
	(179962, 121, '2014-02-01 00:06:37.000000', 'temperatura', 929.0000, 'ºC'),
	(179963, 121, '2014-02-01 00:06:38.000000', 'temperatura', 1075.0000, 'ºC'),
	(179964, 121, '2014-02-01 00:06:39.000000', 'temperatura', 190.0000, 'ºC'),
	(179965, 121, '2014-02-01 00:06:40.000000', 'temperatura', 126.0000, 'ºC'),
	(179966, 121, '2014-02-01 00:06:41.000000', 'temperatura', 60.0000, 'ºC'),
	(179967, 121, '2014-02-01 00:06:42.000000', 'temperatura', 1122.0000, 'ºC'),
	(179968, 121, '2014-02-01 00:06:43.000000', 'temperatura', 630.0000, 'ºC'),
	(179969, 121, '2014-02-01 00:06:44.000000', 'temperatura', 986.0000, 'ºC'),
	(179970, 121, '2014-02-01 00:06:45.000000', 'temperatura', 641.0000, 'ºC'),
	(179971, 121, '2014-02-01 00:06:46.000000', 'temperatura', 248.0000, 'ºC'),
	(179972, 121, '2014-02-01 00:06:47.000000', 'temperatura', 516.0000, 'ºC'),
	(179973, 121, '2014-02-01 00:06:48.000000', 'temperatura', 637.0000, 'ºC'),
	(179974, 121, '2014-02-01 00:06:49.000000', 'temperatura', 438.0000, 'ºC'),
	(179975, 121, '2014-02-01 00:06:50.000000', 'temperatura', 281.0000, 'ºC'),
	(179976, 121, '2014-02-01 00:06:51.000000', 'temperatura', 89.0000, 'ºC'),
	(179977, 121, '2014-02-01 00:06:52.000000', 'temperatura', 803.0000, 'ºC'),
	(179978, 121, '2014-02-01 00:06:53.000000', 'temperatura', 148.0000, 'ºC'),
	(179979, 121, '2014-02-01 00:06:54.000000', 'temperatura', 731.0000, 'ºC'),
	(179980, 121, '2014-02-01 00:06:55.000000', 'temperatura', 812.0000, 'ºC'),
	(179981, 121, '2014-02-01 00:06:56.000000', 'temperatura', 667.0000, 'ºC'),
	(179982, 121, '2014-02-01 00:06:57.000000', 'temperatura', 898.0000, 'ºC'),
	(179983, 121, '2014-02-01 00:06:58.000000', 'temperatura', 90.0000, 'ºC'),
	(179984, 121, '2014-02-01 00:06:59.000000', 'temperatura', 159.0000, 'ºC'),
	(179985, 121, '2014-02-01 00:07:00.000000', 'temperatura', 523.0000, 'ºC'),
	(179986, 121, '2014-02-01 00:07:01.000000', 'temperatura', 941.0000, 'ºC'),
	(179987, 121, '2014-02-01 00:07:02.000000', 'temperatura', 735.0000, 'ºC'),
	(179988, 121, '2014-02-01 00:07:03.000000', 'temperatura', 855.0000, 'ºC'),
	(179989, 121, '2014-02-01 00:07:04.000000', 'temperatura', 867.0000, 'ºC'),
	(179990, 121, '2014-02-01 00:07:05.000000', 'temperatura', 572.0000, 'ºC'),
	(179991, 121, '2014-02-01 00:07:06.000000', 'temperatura', 260.0000, 'ºC'),
	(179992, 121, '2014-02-01 00:07:07.000000', 'temperatura', 784.0000, 'ºC'),
	(179993, 121, '2014-02-01 00:07:08.000000', 'temperatura', 739.0000, 'ºC'),
	(179994, 121, '2014-02-01 00:07:09.000000', 'temperatura', 146.0000, 'ºC'),
	(179995, 121, '2014-02-01 00:07:10.000000', 'temperatura', 912.0000, 'ºC'),
	(179996, 121, '2014-02-01 00:07:11.000000', 'temperatura', 521.0000, 'ºC'),
	(179997, 121, '2014-02-01 00:07:12.000000', 'temperatura', 1072.0000, 'ºC'),
	(179998, 121, '2014-02-01 00:07:13.000000', 'temperatura', 198.0000, 'ºC'),
	(179999, 121, '2014-02-01 00:07:14.000000', 'temperatura', 172.0000, 'ºC'),
	(180000, 121, '2014-02-01 00:07:15.000000', 'temperatura', 268.0000, 'ºC'),
	(180001, 121, '2014-02-01 00:07:16.000000', 'temperatura', 822.0000, 'ºC'),
	(180002, 121, '2014-02-01 00:07:17.000000', 'temperatura', 908.0000, 'ºC'),
	(180003, 121, '2014-02-01 00:07:18.000000', 'temperatura', 876.0000, 'ºC'),
	(180004, 121, '2014-02-01 00:07:19.000000', 'temperatura', 457.0000, 'ºC'),
	(180005, 121, '2014-02-01 00:07:20.000000', 'temperatura', 856.0000, 'ºC'),
	(180006, 121, '2014-02-01 00:07:21.000000', 'temperatura', 511.0000, 'ºC'),
	(180007, 121, '2014-02-01 00:07:22.000000', 'temperatura', 1186.0000, 'ºC'),
	(180008, 121, '2014-02-01 00:07:23.000000', 'temperatura', 800.0000, 'ºC'),
	(180009, 121, '2014-02-01 00:07:24.000000', 'temperatura', 440.0000, 'ºC'),
	(180010, 121, '2014-02-01 00:07:25.000000', 'temperatura', 1003.0000, 'ºC'),
	(180011, 121, '2014-02-01 00:07:26.000000', 'temperatura', 95.0000, 'ºC'),
	(180012, 121, '2014-02-01 00:07:27.000000', 'temperatura', 1067.0000, 'ºC'),
	(180013, 121, '2014-02-01 00:07:28.000000', 'temperatura', 248.0000, 'ºC'),
	(180014, 121, '2014-02-01 00:07:29.000000', 'temperatura', 441.0000, 'ºC'),
	(180015, 121, '2014-02-01 00:07:30.000000', 'temperatura', 262.0000, 'ºC'),
	(180016, 121, '2014-02-01 00:07:31.000000', 'temperatura', 1188.0000, 'ºC'),
	(180017, 121, '2014-02-01 00:07:32.000000', 'temperatura', 354.0000, 'ºC'),
	(180018, 121, '2014-02-01 00:07:33.000000', 'temperatura', 606.0000, 'ºC'),
	(180019, 121, '2014-02-01 00:07:34.000000', 'temperatura', 768.0000, 'ºC'),
	(180020, 121, '2014-02-01 00:07:35.000000', 'temperatura', 825.0000, 'ºC'),
	(180021, 121, '2014-02-01 00:07:36.000000', 'temperatura', 620.0000, 'ºC'),
	(180022, 121, '2014-02-01 00:07:37.000000', 'temperatura', 624.0000, 'ºC'),
	(180023, 121, '2014-02-01 00:07:38.000000', 'temperatura', 60.0000, 'ºC'),
	(180024, 121, '2014-02-01 00:07:39.000000', 'temperatura', 828.0000, 'ºC'),
	(180025, 121, '2014-02-01 00:07:40.000000', 'temperatura', 361.0000, 'ºC'),
	(180026, 121, '2014-02-01 00:07:41.000000', 'temperatura', 521.0000, 'ºC'),
	(180027, 121, '2014-02-01 00:07:42.000000', 'temperatura', 321.0000, 'ºC'),
	(180028, 121, '2014-02-01 00:07:43.000000', 'temperatura', 45.0000, 'ºC'),
	(180029, 121, '2014-02-01 00:07:44.000000', 'temperatura', 461.0000, 'ºC'),
	(180030, 121, '2014-02-01 00:07:45.000000', 'temperatura', 971.0000, 'ºC'),
	(180031, 121, '2014-02-01 00:07:46.000000', 'temperatura', 1073.0000, 'ºC'),
	(180032, 121, '2014-02-01 00:07:47.000000', 'temperatura', 50.0000, 'ºC'),
	(180033, 121, '2014-02-01 00:07:48.000000', 'temperatura', 634.0000, 'ºC'),
	(180034, 121, '2014-02-01 00:07:49.000000', 'temperatura', 619.0000, 'ºC'),
	(180035, 121, '2014-02-01 00:07:50.000000', 'temperatura', 1192.0000, 'ºC'),
	(180036, 121, '2014-02-01 00:07:51.000000', 'temperatura', 507.0000, 'ºC'),
	(180037, 121, '2014-02-01 00:07:52.000000', 'temperatura', 158.0000, 'ºC'),
	(180038, 121, '2014-02-01 00:07:53.000000', 'temperatura', 471.0000, 'ºC'),
	(180039, 121, '2014-02-01 00:07:54.000000', 'temperatura', 681.0000, 'ºC'),
	(180040, 121, '2014-02-01 00:07:55.000000', 'temperatura', 794.0000, 'ºC'),
	(180041, 121, '2014-02-01 00:07:56.000000', 'temperatura', 725.0000, 'ºC'),
	(180042, 121, '2014-02-01 00:07:57.000000', 'temperatura', 44.0000, 'ºC'),
	(180043, 121, '2014-02-01 00:07:58.000000', 'temperatura', 448.0000, 'ºC'),
	(180044, 121, '2014-02-01 00:07:59.000000', 'temperatura', 906.0000, 'ºC'),
	(180045, 121, '2014-02-01 00:08:00.000000', 'temperatura', 789.0000, 'ºC'),
	(180046, 121, '2014-02-01 00:08:01.000000', 'temperatura', 26.0000, 'ºC'),
	(180047, 121, '2014-02-01 00:08:02.000000', 'temperatura', 165.0000, 'ºC'),
	(180048, 121, '2014-02-01 00:08:03.000000', 'temperatura', 746.0000, 'ºC'),
	(180049, 121, '2014-02-01 00:08:04.000000', 'temperatura', 835.0000, 'ºC'),
	(180050, 121, '2014-02-01 00:08:05.000000', 'temperatura', 740.0000, 'ºC'),
	(180051, 121, '2014-02-01 00:08:06.000000', 'temperatura', 1192.0000, 'ºC'),
	(180052, 121, '2014-02-01 00:08:07.000000', 'temperatura', 144.0000, 'ºC'),
	(180053, 121, '2014-02-01 00:08:08.000000', 'temperatura', 744.0000, 'ºC'),
	(180054, 121, '2014-02-01 00:08:09.000000', 'temperatura', 886.0000, 'ºC'),
	(180055, 121, '2014-02-01 00:08:10.000000', 'temperatura', 1001.0000, 'ºC'),
	(180056, 121, '2014-02-01 00:08:11.000000', 'temperatura', 1148.0000, 'ºC'),
	(180057, 121, '2014-02-01 00:08:12.000000', 'temperatura', 339.0000, 'ºC'),
	(180058, 121, '2014-02-01 00:08:13.000000', 'temperatura', 648.0000, 'ºC'),
	(180059, 121, '2014-02-01 00:08:14.000000', 'temperatura', 1027.0000, 'ºC'),
	(180060, 121, '2014-02-01 00:08:15.000000', 'temperatura', 789.0000, 'ºC'),
	(180061, 121, '2014-02-01 00:08:16.000000', 'temperatura', 864.0000, 'ºC'),
	(180062, 121, '2014-02-01 00:08:17.000000', 'temperatura', 756.0000, 'ºC'),
	(180063, 121, '2014-02-01 00:08:18.000000', 'temperatura', 1188.0000, 'ºC'),
	(180064, 121, '2014-02-01 00:08:19.000000', 'temperatura', 73.0000, 'ºC'),
	(180065, 121, '2014-02-01 00:08:20.000000', 'temperatura', 402.0000, 'ºC'),
	(180066, 121, '2014-02-01 00:08:21.000000', 'temperatura', 589.0000, 'ºC'),
	(180067, 121, '2014-02-01 00:08:22.000000', 'temperatura', 542.0000, 'ºC'),
	(180068, 121, '2014-02-01 00:08:23.000000', 'temperatura', 943.0000, 'ºC'),
	(180069, 121, '2014-02-01 00:08:24.000000', 'temperatura', 688.0000, 'ºC'),
	(180070, 121, '2014-02-01 00:08:25.000000', 'temperatura', 612.0000, 'ºC'),
	(180071, 121, '2014-02-01 00:08:26.000000', 'temperatura', 996.0000, 'ºC'),
	(180072, 121, '2014-02-01 00:08:27.000000', 'temperatura', 746.0000, 'ºC'),
	(180073, 121, '2014-02-01 00:08:28.000000', 'temperatura', 740.0000, 'ºC'),
	(180074, 121, '2014-02-01 00:08:29.000000', 'temperatura', 265.0000, 'ºC'),
	(180075, 121, '2014-02-01 00:08:30.000000', 'temperatura', 303.0000, 'ºC'),
	(180076, 121, '2014-02-01 00:08:31.000000', 'temperatura', 720.0000, 'ºC'),
	(180077, 121, '2014-02-01 00:08:32.000000', 'temperatura', 292.0000, 'ºC'),
	(180078, 121, '2014-02-01 00:08:33.000000', 'temperatura', 502.0000, 'ºC'),
	(180079, 121, '2014-02-01 00:08:34.000000', 'temperatura', 433.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(180080, 121, '2014-02-01 00:08:35.000000', 'temperatura', 660.0000, 'ºC'),
	(180081, 121, '2014-02-01 00:08:36.000000', 'temperatura', 803.0000, 'ºC'),
	(180082, 121, '2014-02-01 00:08:37.000000', 'temperatura', 835.0000, 'ºC'),
	(180083, 121, '2014-02-01 00:08:38.000000', 'temperatura', 566.0000, 'ºC'),
	(180084, 121, '2014-02-01 00:08:39.000000', 'temperatura', 327.0000, 'ºC'),
	(180085, 121, '2014-02-01 00:08:40.000000', 'temperatura', 1136.0000, 'ºC'),
	(180086, 121, '2014-02-01 00:08:41.000000', 'temperatura', 1098.0000, 'ºC'),
	(180087, 121, '2014-02-01 00:08:42.000000', 'temperatura', 883.0000, 'ºC'),
	(180088, 121, '2014-02-01 00:08:43.000000', 'temperatura', 1121.0000, 'ºC'),
	(180089, 121, '2014-02-01 00:08:44.000000', 'temperatura', 557.0000, 'ºC'),
	(180090, 121, '2014-02-01 00:08:45.000000', 'temperatura', 622.0000, 'ºC'),
	(180091, 121, '2014-02-01 00:08:46.000000', 'temperatura', 240.0000, 'ºC'),
	(180092, 121, '2014-02-01 00:08:47.000000', 'temperatura', 535.0000, 'ºC'),
	(180093, 121, '2014-02-01 00:08:48.000000', 'temperatura', 753.0000, 'ºC'),
	(180094, 121, '2014-02-01 00:08:49.000000', 'temperatura', 964.0000, 'ºC'),
	(180095, 121, '2014-02-01 00:08:50.000000', 'temperatura', 160.0000, 'ºC'),
	(180096, 121, '2014-02-01 00:08:51.000000', 'temperatura', 307.0000, 'ºC'),
	(180097, 121, '2014-02-01 00:08:52.000000', 'temperatura', 1055.0000, 'ºC'),
	(180098, 121, '2014-02-01 00:08:53.000000', 'temperatura', 755.0000, 'ºC'),
	(180099, 121, '2014-02-01 00:08:54.000000', 'temperatura', 611.0000, 'ºC'),
	(180100, 121, '2014-02-01 00:08:55.000000', 'temperatura', 791.0000, 'ºC'),
	(180101, 121, '2014-02-01 00:08:56.000000', 'temperatura', 921.0000, 'ºC'),
	(180102, 121, '2014-02-01 00:08:57.000000', 'temperatura', 1033.0000, 'ºC'),
	(180103, 121, '2014-02-01 00:08:58.000000', 'temperatura', 4.0000, 'ºC'),
	(180104, 121, '2014-02-01 00:08:59.000000', 'temperatura', 519.0000, 'ºC'),
	(180105, 121, '2014-02-01 00:09:00.000000', 'temperatura', 182.0000, 'ºC'),
	(180106, 121, '2014-02-01 00:09:01.000000', 'temperatura', 557.0000, 'ºC'),
	(180107, 121, '2014-02-01 00:09:02.000000', 'temperatura', 1040.0000, 'ºC'),
	(180108, 121, '2014-02-01 00:09:03.000000', 'temperatura', 1127.0000, 'ºC'),
	(180109, 121, '2014-02-01 00:09:04.000000', 'temperatura', 116.0000, 'ºC'),
	(180110, 121, '2014-02-01 00:09:05.000000', 'temperatura', 799.0000, 'ºC'),
	(180111, 121, '2014-02-01 00:09:06.000000', 'temperatura', 47.0000, 'ºC'),
	(180112, 121, '2014-02-01 00:09:07.000000', 'temperatura', 238.0000, 'ºC'),
	(180113, 121, '2014-02-01 00:09:08.000000', 'temperatura', 1051.0000, 'ºC'),
	(180114, 121, '2014-02-01 00:09:09.000000', 'temperatura', 940.0000, 'ºC'),
	(180115, 121, '2014-02-01 00:09:10.000000', 'temperatura', 349.0000, 'ºC'),
	(180116, 121, '2014-02-01 00:09:11.000000', 'temperatura', 127.0000, 'ºC'),
	(180117, 121, '2014-02-01 00:09:12.000000', 'temperatura', 788.0000, 'ºC'),
	(180118, 121, '2014-02-01 00:09:13.000000', 'temperatura', 1157.0000, 'ºC'),
	(180119, 121, '2014-02-01 00:09:14.000000', 'temperatura', 1022.0000, 'ºC'),
	(180120, 121, '2014-02-01 00:09:15.000000', 'temperatura', 439.0000, 'ºC'),
	(180121, 121, '2014-02-01 00:09:16.000000', 'temperatura', 332.0000, 'ºC'),
	(180122, 121, '2014-02-01 00:09:17.000000', 'temperatura', 340.0000, 'ºC'),
	(180123, 121, '2014-02-01 00:09:18.000000', 'temperatura', 707.0000, 'ºC'),
	(180124, 121, '2014-02-01 00:09:19.000000', 'temperatura', 116.0000, 'ºC'),
	(180125, 121, '2014-02-01 00:09:20.000000', 'temperatura', 861.0000, 'ºC'),
	(180126, 121, '2014-02-01 00:09:21.000000', 'temperatura', 355.0000, 'ºC'),
	(180127, 121, '2014-02-01 00:09:22.000000', 'temperatura', 394.0000, 'ºC'),
	(180128, 121, '2014-02-01 00:09:23.000000', 'temperatura', 905.0000, 'ºC'),
	(180129, 121, '2014-02-01 00:09:24.000000', 'temperatura', 943.0000, 'ºC'),
	(180130, 121, '2014-02-01 00:09:25.000000', 'temperatura', 799.0000, 'ºC'),
	(180131, 121, '2014-02-01 00:09:26.000000', 'temperatura', 1168.0000, 'ºC'),
	(180132, 121, '2014-02-01 00:09:27.000000', 'temperatura', 1043.0000, 'ºC'),
	(180133, 121, '2014-02-01 00:09:28.000000', 'temperatura', 512.0000, 'ºC'),
	(180134, 121, '2014-02-01 00:09:29.000000', 'temperatura', 630.0000, 'ºC'),
	(180135, 121, '2014-02-01 00:09:30.000000', 'temperatura', 416.0000, 'ºC'),
	(180136, 121, '2014-02-01 00:09:31.000000', 'temperatura', 190.0000, 'ºC'),
	(180137, 121, '2014-02-01 00:09:32.000000', 'temperatura', 901.0000, 'ºC'),
	(180138, 121, '2014-02-01 00:09:33.000000', 'temperatura', 338.0000, 'ºC'),
	(180139, 121, '2014-02-01 00:09:34.000000', 'temperatura', 186.0000, 'ºC'),
	(180140, 121, '2014-02-01 00:09:35.000000', 'temperatura', 1118.0000, 'ºC'),
	(180141, 121, '2014-02-01 00:09:36.000000', 'temperatura', 232.0000, 'ºC'),
	(180142, 121, '2014-02-01 00:09:37.000000', 'temperatura', 208.0000, 'ºC'),
	(180143, 121, '2014-02-01 00:09:38.000000', 'temperatura', 344.0000, 'ºC'),
	(180144, 121, '2014-02-01 00:09:39.000000', 'temperatura', 1097.0000, 'ºC'),
	(180145, 121, '2014-02-01 00:09:40.000000', 'temperatura', 851.0000, 'ºC'),
	(180146, 121, '2014-02-01 00:09:41.000000', 'temperatura', 965.0000, 'ºC'),
	(180147, 121, '2014-02-01 00:09:42.000000', 'temperatura', 1073.0000, 'ºC'),
	(180148, 121, '2014-02-01 00:09:43.000000', 'temperatura', 69.0000, 'ºC'),
	(180149, 121, '2014-02-01 00:09:44.000000', 'temperatura', 727.0000, 'ºC'),
	(180150, 121, '2014-02-01 00:09:45.000000', 'temperatura', 1029.0000, 'ºC'),
	(180151, 121, '2014-02-01 00:09:46.000000', 'temperatura', 564.0000, 'ºC'),
	(180152, 121, '2014-02-01 00:09:47.000000', 'temperatura', 935.0000, 'ºC'),
	(180153, 121, '2014-02-01 00:09:48.000000', 'temperatura', 582.0000, 'ºC'),
	(180154, 121, '2014-02-01 00:09:49.000000', 'temperatura', 106.0000, 'ºC'),
	(180155, 121, '2014-02-01 00:09:50.000000', 'temperatura', 1184.0000, 'ºC'),
	(180156, 121, '2014-02-01 00:09:51.000000', 'temperatura', 804.0000, 'ºC'),
	(180157, 121, '2014-02-01 00:09:52.000000', 'temperatura', 467.0000, 'ºC'),
	(180158, 121, '2014-02-01 00:09:53.000000', 'temperatura', 1123.0000, 'ºC'),
	(180159, 121, '2014-02-01 00:09:54.000000', 'temperatura', 616.0000, 'ºC'),
	(180160, 121, '2014-02-01 00:09:55.000000', 'temperatura', 911.0000, 'ºC'),
	(180161, 121, '2014-02-01 00:09:56.000000', 'temperatura', 306.0000, 'ºC'),
	(180162, 121, '2014-02-01 00:09:57.000000', 'temperatura', 0.0000, 'ºC'),
	(180163, 121, '2014-02-01 00:09:58.000000', 'temperatura', 283.0000, 'ºC'),
	(180164, 121, '2014-02-01 00:09:59.000000', 'temperatura', 214.0000, 'ºC'),
	(180165, 121, '2014-02-01 00:10:00.000000', 'temperatura', 222.0000, 'ºC'),
	(180166, 121, '2014-02-01 00:10:01.000000', 'temperatura', 470.0000, 'ºC'),
	(180167, 121, '2014-02-01 00:10:02.000000', 'temperatura', 482.0000, 'ºC'),
	(180168, 121, '2014-02-01 00:10:03.000000', 'temperatura', 1001.0000, 'ºC'),
	(180169, 121, '2014-02-01 00:10:04.000000', 'temperatura', 1161.0000, 'ºC'),
	(180170, 121, '2014-02-01 00:10:05.000000', 'temperatura', 404.0000, 'ºC'),
	(180171, 121, '2014-02-01 00:10:06.000000', 'temperatura', 935.0000, 'ºC'),
	(180172, 121, '2014-02-01 00:10:07.000000', 'temperatura', 1064.0000, 'ºC'),
	(180173, 121, '2014-02-01 00:10:08.000000', 'temperatura', 116.0000, 'ºC'),
	(180174, 121, '2014-02-01 00:10:09.000000', 'temperatura', 989.0000, 'ºC'),
	(180175, 121, '2014-02-01 00:10:10.000000', 'temperatura', 999.0000, 'ºC'),
	(180176, 121, '2014-02-01 00:10:11.000000', 'temperatura', 826.0000, 'ºC'),
	(180177, 121, '2014-02-01 00:10:12.000000', 'temperatura', 1133.0000, 'ºC'),
	(180178, 121, '2014-02-01 00:10:13.000000', 'temperatura', 790.0000, 'ºC'),
	(180179, 121, '2014-02-01 00:10:14.000000', 'temperatura', 550.0000, 'ºC'),
	(180180, 121, '2014-02-01 00:10:15.000000', 'temperatura', 379.0000, 'ºC'),
	(180181, 121, '2014-02-01 00:10:16.000000', 'temperatura', 247.0000, 'ºC'),
	(180182, 121, '2014-02-01 00:10:17.000000', 'temperatura', 98.0000, 'ºC'),
	(180183, 121, '2014-02-01 00:10:18.000000', 'temperatura', 950.0000, 'ºC'),
	(180184, 121, '2014-02-01 00:10:19.000000', 'temperatura', 855.0000, 'ºC'),
	(180185, 121, '2014-02-01 00:10:20.000000', 'temperatura', 227.0000, 'ºC'),
	(180186, 121, '2014-02-01 00:10:21.000000', 'temperatura', 971.0000, 'ºC'),
	(180187, 121, '2014-02-01 00:10:22.000000', 'temperatura', 573.0000, 'ºC'),
	(180188, 121, '2014-02-01 00:10:23.000000', 'temperatura', 1152.0000, 'ºC'),
	(180189, 121, '2014-02-01 00:10:24.000000', 'temperatura', 441.0000, 'ºC'),
	(180190, 121, '2014-02-01 00:10:25.000000', 'temperatura', 1150.0000, 'ºC'),
	(180191, 121, '2014-02-01 00:10:26.000000', 'temperatura', 827.0000, 'ºC'),
	(180192, 121, '2014-02-01 00:10:27.000000', 'temperatura', 686.0000, 'ºC'),
	(180193, 121, '2014-02-01 00:10:28.000000', 'temperatura', 951.0000, 'ºC'),
	(180194, 121, '2014-02-01 00:10:29.000000', 'temperatura', 298.0000, 'ºC'),
	(180195, 121, '2014-02-01 00:10:30.000000', 'temperatura', 1036.0000, 'ºC'),
	(180196, 121, '2014-02-01 00:10:31.000000', 'temperatura', 687.0000, 'ºC'),
	(180197, 121, '2014-02-01 00:10:32.000000', 'temperatura', 327.0000, 'ºC'),
	(180198, 121, '2014-02-01 00:10:33.000000', 'temperatura', 774.0000, 'ºC'),
	(180199, 121, '2014-02-01 00:10:34.000000', 'temperatura', 490.0000, 'ºC'),
	(180200, 121, '2014-02-01 00:10:35.000000', 'temperatura', 131.0000, 'ºC'),
	(180201, 121, '2014-02-01 00:10:36.000000', 'temperatura', 382.0000, 'ºC'),
	(180202, 121, '2014-02-01 00:10:37.000000', 'temperatura', 319.0000, 'ºC'),
	(180203, 121, '2014-02-01 00:10:38.000000', 'temperatura', 451.0000, 'ºC'),
	(180204, 121, '2014-02-01 00:10:39.000000', 'temperatura', 98.0000, 'ºC'),
	(180205, 121, '2014-02-01 00:10:40.000000', 'temperatura', 338.0000, 'ºC'),
	(180206, 121, '2014-02-01 00:10:41.000000', 'temperatura', 197.0000, 'ºC'),
	(180207, 121, '2014-02-01 00:10:42.000000', 'temperatura', 1170.0000, 'ºC'),
	(180208, 121, '2014-02-01 00:10:43.000000', 'temperatura', 458.0000, 'ºC'),
	(180209, 121, '2014-02-01 00:10:44.000000', 'temperatura', 1182.0000, 'ºC'),
	(180210, 121, '2014-02-01 00:10:45.000000', 'temperatura', 938.0000, 'ºC'),
	(180211, 121, '2014-02-01 00:10:46.000000', 'temperatura', 1142.0000, 'ºC'),
	(180212, 121, '2014-02-01 00:10:47.000000', 'temperatura', 496.0000, 'ºC'),
	(180213, 121, '2014-02-01 00:10:48.000000', 'temperatura', 256.0000, 'ºC'),
	(180214, 121, '2014-02-01 00:10:49.000000', 'temperatura', 994.0000, 'ºC'),
	(180215, 121, '2014-02-01 00:10:50.000000', 'temperatura', 602.0000, 'ºC'),
	(180216, 121, '2014-02-01 00:10:51.000000', 'temperatura', 29.0000, 'ºC'),
	(180217, 121, '2014-02-01 00:10:52.000000', 'temperatura', 739.0000, 'ºC'),
	(180218, 121, '2014-02-01 00:10:53.000000', 'temperatura', 9.0000, 'ºC'),
	(180219, 121, '2014-02-01 00:10:54.000000', 'temperatura', 228.0000, 'ºC'),
	(180220, 121, '2014-02-01 00:10:55.000000', 'temperatura', 1115.0000, 'ºC'),
	(180221, 121, '2014-02-01 00:10:56.000000', 'temperatura', 90.0000, 'ºC'),
	(180222, 121, '2014-02-01 00:10:57.000000', 'temperatura', 705.0000, 'ºC'),
	(180223, 121, '2014-02-01 00:10:58.000000', 'temperatura', 857.0000, 'ºC'),
	(180224, 121, '2014-02-01 00:10:59.000000', 'temperatura', 972.0000, 'ºC'),
	(180225, 121, '2014-02-01 00:11:00.000000', 'temperatura', 1088.0000, 'ºC'),
	(180226, 121, '2014-02-01 00:11:01.000000', 'temperatura', 123.0000, 'ºC'),
	(180227, 121, '2014-02-01 00:11:02.000000', 'temperatura', 954.0000, 'ºC'),
	(180228, 121, '2014-02-01 00:11:03.000000', 'temperatura', 799.0000, 'ºC'),
	(180229, 121, '2014-02-01 00:11:04.000000', 'temperatura', 1133.0000, 'ºC'),
	(180230, 121, '2014-02-01 00:11:05.000000', 'temperatura', 870.0000, 'ºC'),
	(180231, 121, '2014-02-01 00:11:06.000000', 'temperatura', 952.0000, 'ºC'),
	(180232, 121, '2014-02-01 00:11:07.000000', 'temperatura', 950.0000, 'ºC'),
	(180233, 121, '2014-02-01 00:11:08.000000', 'temperatura', 695.0000, 'ºC'),
	(180234, 121, '2014-02-01 00:11:09.000000', 'temperatura', 624.0000, 'ºC'),
	(180235, 121, '2014-02-01 00:11:10.000000', 'temperatura', 1038.0000, 'ºC'),
	(180236, 121, '2014-02-01 00:11:11.000000', 'temperatura', 917.0000, 'ºC'),
	(180237, 121, '2014-02-01 00:11:12.000000', 'temperatura', 271.0000, 'ºC'),
	(180238, 121, '2014-02-01 00:11:13.000000', 'temperatura', 1006.0000, 'ºC'),
	(180239, 121, '2014-02-01 00:11:14.000000', 'temperatura', 615.0000, 'ºC'),
	(180240, 121, '2014-02-01 00:11:15.000000', 'temperatura', 59.0000, 'ºC'),
	(180241, 121, '2014-02-01 00:11:16.000000', 'temperatura', 849.0000, 'ºC'),
	(180242, 121, '2014-02-01 00:11:17.000000', 'temperatura', 469.0000, 'ºC'),
	(180243, 121, '2014-02-01 00:11:18.000000', 'temperatura', 1001.0000, 'ºC'),
	(180244, 121, '2014-02-01 00:11:19.000000', 'temperatura', 1195.0000, 'ºC'),
	(180245, 121, '2014-02-01 00:11:20.000000', 'temperatura', 574.0000, 'ºC'),
	(180246, 121, '2014-02-01 00:11:21.000000', 'temperatura', 483.0000, 'ºC'),
	(180247, 121, '2014-02-01 00:11:22.000000', 'temperatura', 697.0000, 'ºC'),
	(180248, 121, '2014-02-01 00:11:23.000000', 'temperatura', 835.0000, 'ºC'),
	(180249, 121, '2014-02-01 00:11:24.000000', 'temperatura', 886.0000, 'ºC'),
	(180250, 121, '2014-02-01 00:11:25.000000', 'temperatura', 723.0000, 'ºC'),
	(180251, 121, '2014-02-01 00:11:26.000000', 'temperatura', 960.0000, 'ºC'),
	(180252, 121, '2014-02-01 00:11:27.000000', 'temperatura', 233.0000, 'ºC'),
	(180253, 121, '2014-02-01 00:11:28.000000', 'temperatura', 682.0000, 'ºC'),
	(180254, 121, '2014-02-01 00:11:29.000000', 'temperatura', 312.0000, 'ºC'),
	(180255, 121, '2014-02-01 00:11:30.000000', 'temperatura', 717.0000, 'ºC'),
	(180256, 121, '2014-02-01 00:11:31.000000', 'temperatura', 248.0000, 'ºC'),
	(180257, 121, '2014-02-01 00:11:32.000000', 'temperatura', 289.0000, 'ºC'),
	(180258, 121, '2014-02-01 00:11:33.000000', 'temperatura', 703.0000, 'ºC'),
	(180259, 121, '2014-02-01 00:11:34.000000', 'temperatura', 247.0000, 'ºC'),
	(180260, 121, '2014-02-01 00:11:35.000000', 'temperatura', 329.0000, 'ºC'),
	(180261, 121, '2014-02-01 00:11:36.000000', 'temperatura', 901.0000, 'ºC'),
	(180262, 121, '2014-02-01 00:11:37.000000', 'temperatura', 1121.0000, 'ºC'),
	(180263, 121, '2014-02-01 00:11:38.000000', 'temperatura', 504.0000, 'ºC'),
	(180264, 121, '2014-02-01 00:11:39.000000', 'temperatura', 355.0000, 'ºC'),
	(180265, 121, '2014-02-01 00:11:40.000000', 'temperatura', 263.0000, 'ºC'),
	(180266, 121, '2014-02-01 00:11:41.000000', 'temperatura', 249.0000, 'ºC'),
	(180267, 121, '2014-02-01 00:11:42.000000', 'temperatura', 459.0000, 'ºC'),
	(180268, 121, '2014-02-01 00:11:43.000000', 'temperatura', 349.0000, 'ºC'),
	(180269, 121, '2014-02-01 00:11:44.000000', 'temperatura', 368.0000, 'ºC'),
	(180270, 121, '2014-02-01 00:11:45.000000', 'temperatura', 793.0000, 'ºC'),
	(180271, 121, '2014-02-01 00:11:46.000000', 'temperatura', 464.0000, 'ºC'),
	(180272, 121, '2014-02-01 00:11:47.000000', 'temperatura', 1139.0000, 'ºC'),
	(180273, 121, '2014-02-01 00:11:48.000000', 'temperatura', 703.0000, 'ºC'),
	(180274, 121, '2014-02-01 00:11:49.000000', 'temperatura', 101.0000, 'ºC'),
	(180275, 121, '2014-02-01 00:11:50.000000', 'temperatura', 794.0000, 'ºC'),
	(180276, 121, '2014-02-01 00:11:51.000000', 'temperatura', 67.0000, 'ºC'),
	(180277, 121, '2014-02-01 00:11:52.000000', 'temperatura', 353.0000, 'ºC'),
	(180278, 121, '2014-02-01 00:11:53.000000', 'temperatura', 364.0000, 'ºC'),
	(180279, 121, '2014-02-01 00:11:54.000000', 'temperatura', 764.0000, 'ºC'),
	(180280, 121, '2014-02-01 00:11:55.000000', 'temperatura', 326.0000, 'ºC'),
	(180281, 121, '2014-02-01 00:11:56.000000', 'temperatura', 541.0000, 'ºC'),
	(180282, 121, '2014-02-01 00:11:57.000000', 'temperatura', 526.0000, 'ºC'),
	(180283, 121, '2014-02-01 00:11:58.000000', 'temperatura', 1006.0000, 'ºC'),
	(180284, 121, '2014-02-01 00:11:59.000000', 'temperatura', 1055.0000, 'ºC'),
	(180285, 121, '2014-02-01 00:12:00.000000', 'temperatura', 1057.0000, 'ºC'),
	(180286, 121, '2014-02-01 00:12:01.000000', 'temperatura', 921.0000, 'ºC'),
	(180287, 121, '2014-02-01 00:12:02.000000', 'temperatura', 235.0000, 'ºC'),
	(180288, 121, '2014-02-01 00:12:03.000000', 'temperatura', 813.0000, 'ºC'),
	(180289, 121, '2014-02-01 00:12:04.000000', 'temperatura', 962.0000, 'ºC'),
	(180290, 121, '2014-02-01 00:12:05.000000', 'temperatura', 1168.0000, 'ºC'),
	(180291, 121, '2014-02-01 00:12:06.000000', 'temperatura', 556.0000, 'ºC'),
	(180292, 121, '2014-02-01 00:12:07.000000', 'temperatura', 478.0000, 'ºC'),
	(180293, 121, '2014-02-01 00:12:08.000000', 'temperatura', 723.0000, 'ºC'),
	(180294, 121, '2014-02-01 00:12:09.000000', 'temperatura', 981.0000, 'ºC'),
	(180295, 121, '2014-02-01 00:12:10.000000', 'temperatura', 334.0000, 'ºC'),
	(180296, 121, '2014-02-01 00:12:11.000000', 'temperatura', 1130.0000, 'ºC'),
	(180297, 121, '2014-02-01 00:12:12.000000', 'temperatura', 1048.0000, 'ºC'),
	(180298, 121, '2014-02-01 00:12:13.000000', 'temperatura', 649.0000, 'ºC'),
	(180299, 121, '2014-02-01 00:12:14.000000', 'temperatura', 103.0000, 'ºC'),
	(180300, 121, '2014-02-01 00:12:15.000000', 'temperatura', 968.0000, 'ºC'),
	(180301, 121, '2014-02-01 00:12:16.000000', 'temperatura', 932.0000, 'ºC'),
	(180302, 121, '2014-02-01 00:12:17.000000', 'temperatura', 555.0000, 'ºC'),
	(180303, 121, '2014-02-01 00:12:18.000000', 'temperatura', 1180.0000, 'ºC'),
	(180304, 121, '2014-02-01 00:12:19.000000', 'temperatura', 635.0000, 'ºC'),
	(180305, 121, '2014-02-01 00:12:20.000000', 'temperatura', 837.0000, 'ºC'),
	(180306, 121, '2014-02-01 00:12:21.000000', 'temperatura', 1082.0000, 'ºC'),
	(180307, 121, '2014-02-01 00:12:22.000000', 'temperatura', 498.0000, 'ºC'),
	(180308, 121, '2014-02-01 00:12:23.000000', 'temperatura', 444.0000, 'ºC'),
	(180309, 121, '2014-02-01 00:12:24.000000', 'temperatura', 725.0000, 'ºC'),
	(180310, 121, '2014-02-01 00:12:25.000000', 'temperatura', 1096.0000, 'ºC'),
	(180311, 121, '2014-02-01 00:12:26.000000', 'temperatura', 905.0000, 'ºC'),
	(180312, 121, '2014-02-01 00:12:27.000000', 'temperatura', 36.0000, 'ºC'),
	(180313, 121, '2014-02-01 00:12:28.000000', 'temperatura', 1067.0000, 'ºC'),
	(180314, 121, '2014-02-01 00:12:29.000000', 'temperatura', 428.0000, 'ºC'),
	(180315, 121, '2014-02-01 00:12:30.000000', 'temperatura', 140.0000, 'ºC'),
	(180316, 121, '2014-02-01 00:12:31.000000', 'temperatura', 617.0000, 'ºC'),
	(180317, 121, '2014-02-01 00:12:32.000000', 'temperatura', 264.0000, 'ºC'),
	(180318, 121, '2014-02-01 00:12:33.000000', 'temperatura', 668.0000, 'ºC'),
	(180319, 121, '2014-02-01 00:12:34.000000', 'temperatura', 149.0000, 'ºC'),
	(180320, 121, '2014-02-01 00:12:35.000000', 'temperatura', 1143.0000, 'ºC'),
	(180321, 121, '2014-02-01 00:12:36.000000', 'temperatura', 467.0000, 'ºC'),
	(180322, 121, '2014-02-01 00:12:37.000000', 'temperatura', 109.0000, 'ºC'),
	(180323, 121, '2014-02-01 00:12:38.000000', 'temperatura', 342.0000, 'ºC'),
	(180324, 121, '2014-02-01 00:12:39.000000', 'temperatura', 183.0000, 'ºC'),
	(180325, 121, '2014-02-01 00:12:40.000000', 'temperatura', 1092.0000, 'ºC'),
	(180326, 121, '2014-02-01 00:12:41.000000', 'temperatura', 110.0000, 'ºC'),
	(180327, 121, '2014-02-01 00:12:42.000000', 'temperatura', 874.0000, 'ºC'),
	(180328, 121, '2014-02-01 00:12:43.000000', 'temperatura', 442.0000, 'ºC'),
	(180329, 121, '2014-02-01 00:12:44.000000', 'temperatura', 787.0000, 'ºC'),
	(180330, 121, '2014-02-01 00:12:45.000000', 'temperatura', 210.0000, 'ºC'),
	(180331, 121, '2014-02-01 00:12:46.000000', 'temperatura', 1092.0000, 'ºC'),
	(180332, 121, '2014-02-01 00:12:47.000000', 'temperatura', 27.0000, 'ºC'),
	(180333, 121, '2014-02-01 00:12:48.000000', 'temperatura', 460.0000, 'ºC'),
	(180334, 121, '2014-02-01 00:12:49.000000', 'temperatura', 1022.0000, 'ºC'),
	(180335, 121, '2014-02-01 00:12:50.000000', 'temperatura', 127.0000, 'ºC'),
	(180336, 121, '2014-02-01 00:12:51.000000', 'temperatura', 1171.0000, 'ºC'),
	(180337, 121, '2014-02-01 00:12:52.000000', 'temperatura', 674.0000, 'ºC'),
	(180338, 121, '2014-02-01 00:12:53.000000', 'temperatura', 1058.0000, 'ºC'),
	(180339, 121, '2014-02-01 00:12:54.000000', 'temperatura', 870.0000, 'ºC'),
	(180340, 121, '2014-02-01 00:12:55.000000', 'temperatura', 1174.0000, 'ºC'),
	(180341, 121, '2014-02-01 00:12:56.000000', 'temperatura', 863.0000, 'ºC'),
	(180342, 121, '2014-02-01 00:12:57.000000', 'temperatura', 793.0000, 'ºC'),
	(180343, 121, '2014-02-01 00:12:58.000000', 'temperatura', 175.0000, 'ºC'),
	(180344, 121, '2014-02-01 00:12:59.000000', 'temperatura', 897.0000, 'ºC'),
	(180345, 121, '2014-02-01 00:13:00.000000', 'temperatura', 362.0000, 'ºC'),
	(180346, 121, '2014-02-01 00:13:01.000000', 'temperatura', 320.0000, 'ºC'),
	(180347, 121, '2014-02-01 00:13:02.000000', 'temperatura', 512.0000, 'ºC'),
	(180348, 121, '2014-02-01 00:13:03.000000', 'temperatura', 401.0000, 'ºC'),
	(180349, 121, '2014-02-01 00:13:04.000000', 'temperatura', 470.0000, 'ºC'),
	(180350, 121, '2014-02-01 00:13:05.000000', 'temperatura', 1148.0000, 'ºC'),
	(180351, 121, '2014-02-01 00:13:06.000000', 'temperatura', 730.0000, 'ºC'),
	(180352, 121, '2014-02-01 00:13:07.000000', 'temperatura', 207.0000, 'ºC'),
	(180353, 121, '2014-02-01 00:13:08.000000', 'temperatura', 44.0000, 'ºC'),
	(180354, 121, '2014-02-01 00:13:09.000000', 'temperatura', 800.0000, 'ºC'),
	(180355, 121, '2014-02-01 00:13:10.000000', 'temperatura', 271.0000, 'ºC'),
	(180356, 121, '2014-02-01 00:13:11.000000', 'temperatura', 153.0000, 'ºC'),
	(180357, 121, '2014-02-01 00:13:12.000000', 'temperatura', 1153.0000, 'ºC'),
	(180358, 121, '2014-02-01 00:13:13.000000', 'temperatura', 508.0000, 'ºC'),
	(180359, 121, '2014-02-01 00:13:14.000000', 'temperatura', 280.0000, 'ºC'),
	(180360, 121, '2014-02-01 00:13:15.000000', 'temperatura', 1078.0000, 'ºC'),
	(180361, 121, '2014-02-01 00:13:16.000000', 'temperatura', 950.0000, 'ºC'),
	(180362, 121, '2014-02-01 00:13:17.000000', 'temperatura', 315.0000, 'ºC'),
	(180363, 121, '2014-02-01 00:13:18.000000', 'temperatura', 1128.0000, 'ºC'),
	(180364, 121, '2014-02-01 00:13:19.000000', 'temperatura', 1094.0000, 'ºC'),
	(180365, 121, '2014-02-01 00:13:20.000000', 'temperatura', 887.0000, 'ºC'),
	(180366, 121, '2014-02-01 00:13:21.000000', 'temperatura', 1153.0000, 'ºC'),
	(180367, 121, '2014-02-01 00:13:22.000000', 'temperatura', 705.0000, 'ºC'),
	(180368, 121, '2014-02-01 00:13:23.000000', 'temperatura', 67.0000, 'ºC'),
	(180369, 121, '2014-02-01 00:13:24.000000', 'temperatura', 618.0000, 'ºC'),
	(180370, 121, '2014-02-01 00:13:25.000000', 'temperatura', 492.0000, 'ºC'),
	(180371, 121, '2014-02-01 00:13:26.000000', 'temperatura', 605.0000, 'ºC'),
	(180372, 121, '2014-02-01 00:13:27.000000', 'temperatura', 351.0000, 'ºC'),
	(180373, 121, '2014-02-01 00:13:28.000000', 'temperatura', 1140.0000, 'ºC'),
	(180374, 121, '2014-02-01 00:13:29.000000', 'temperatura', 1047.0000, 'ºC'),
	(180375, 121, '2014-02-01 00:13:30.000000', 'temperatura', 614.0000, 'ºC'),
	(180376, 121, '2014-02-01 00:13:31.000000', 'temperatura', 1131.0000, 'ºC'),
	(180377, 121, '2014-02-01 00:13:32.000000', 'temperatura', 212.0000, 'ºC'),
	(180378, 121, '2014-02-01 00:13:33.000000', 'temperatura', 66.0000, 'ºC'),
	(180379, 121, '2014-02-01 00:13:34.000000', 'temperatura', 898.0000, 'ºC'),
	(180380, 121, '2014-02-01 00:13:35.000000', 'temperatura', 693.0000, 'ºC'),
	(180381, 121, '2014-02-01 00:13:36.000000', 'temperatura', 768.0000, 'ºC'),
	(180382, 121, '2014-02-01 00:13:37.000000', 'temperatura', 564.0000, 'ºC'),
	(180383, 121, '2014-02-01 00:13:38.000000', 'temperatura', 514.0000, 'ºC'),
	(180384, 121, '2014-02-01 00:13:39.000000', 'temperatura', 881.0000, 'ºC'),
	(180385, 121, '2014-02-01 00:13:40.000000', 'temperatura', 462.0000, 'ºC'),
	(180386, 121, '2014-02-01 00:13:41.000000', 'temperatura', 867.0000, 'ºC'),
	(180387, 121, '2014-02-01 00:13:42.000000', 'temperatura', 548.0000, 'ºC'),
	(180388, 121, '2014-02-01 00:13:43.000000', 'temperatura', 141.0000, 'ºC'),
	(180389, 121, '2014-02-01 00:13:44.000000', 'temperatura', 263.0000, 'ºC'),
	(180390, 121, '2014-02-01 00:13:45.000000', 'temperatura', 891.0000, 'ºC'),
	(180391, 121, '2014-02-01 00:13:46.000000', 'temperatura', 66.0000, 'ºC'),
	(180392, 121, '2014-02-01 00:13:47.000000', 'temperatura', 58.0000, 'ºC'),
	(180393, 121, '2014-02-01 00:13:48.000000', 'temperatura', 94.0000, 'ºC'),
	(180394, 121, '2014-02-01 00:13:49.000000', 'temperatura', 296.0000, 'ºC'),
	(180395, 121, '2014-02-01 00:13:50.000000', 'temperatura', 1198.0000, 'ºC'),
	(180396, 121, '2014-02-01 00:13:51.000000', 'temperatura', 303.0000, 'ºC'),
	(180397, 121, '2014-02-01 00:13:52.000000', 'temperatura', 321.0000, 'ºC'),
	(180398, 121, '2014-02-01 00:13:53.000000', 'temperatura', 697.0000, 'ºC'),
	(180399, 121, '2014-02-01 00:13:54.000000', 'temperatura', 123.0000, 'ºC'),
	(180400, 121, '2014-02-01 00:13:55.000000', 'temperatura', 925.0000, 'ºC'),
	(180401, 121, '2014-02-01 00:13:56.000000', 'temperatura', 658.0000, 'ºC'),
	(180402, 121, '2014-02-01 00:13:57.000000', 'temperatura', 514.0000, 'ºC'),
	(180403, 121, '2014-02-01 00:13:58.000000', 'temperatura', 595.0000, 'ºC'),
	(180404, 121, '2014-02-01 00:13:59.000000', 'temperatura', 235.0000, 'ºC'),
	(180405, 121, '2014-02-01 00:14:00.000000', 'temperatura', 589.0000, 'ºC'),
	(180406, 121, '2014-02-01 00:14:01.000000', 'temperatura', 1043.0000, 'ºC'),
	(180407, 121, '2014-02-01 00:14:02.000000', 'temperatura', 1047.0000, 'ºC'),
	(180408, 121, '2014-02-01 00:14:03.000000', 'temperatura', 908.0000, 'ºC'),
	(180409, 121, '2014-02-01 00:14:04.000000', 'temperatura', 196.0000, 'ºC'),
	(180410, 121, '2014-02-01 00:14:05.000000', 'temperatura', 660.0000, 'ºC'),
	(180411, 121, '2014-02-01 00:14:06.000000', 'temperatura', 313.0000, 'ºC'),
	(180412, 121, '2014-02-01 00:14:07.000000', 'temperatura', 784.0000, 'ºC'),
	(180413, 121, '2014-02-01 00:14:08.000000', 'temperatura', 584.0000, 'ºC'),
	(180414, 121, '2014-02-01 00:14:09.000000', 'temperatura', 566.0000, 'ºC'),
	(180415, 121, '2014-02-01 00:14:10.000000', 'temperatura', 1079.0000, 'ºC'),
	(180416, 121, '2014-02-01 00:14:11.000000', 'temperatura', 97.0000, 'ºC'),
	(180417, 121, '2014-02-01 00:14:12.000000', 'temperatura', 847.0000, 'ºC'),
	(180418, 121, '2014-02-01 00:14:13.000000', 'temperatura', 348.0000, 'ºC'),
	(180419, 121, '2014-02-01 00:14:14.000000', 'temperatura', 397.0000, 'ºC'),
	(180420, 121, '2014-02-01 00:14:15.000000', 'temperatura', 940.0000, 'ºC'),
	(180421, 121, '2014-02-01 00:14:16.000000', 'temperatura', 1112.0000, 'ºC'),
	(180422, 121, '2014-02-01 00:14:17.000000', 'temperatura', 341.0000, 'ºC'),
	(180423, 121, '2014-02-01 00:14:18.000000', 'temperatura', 769.0000, 'ºC'),
	(180424, 121, '2014-02-01 00:14:19.000000', 'temperatura', 424.0000, 'ºC'),
	(180425, 121, '2014-02-01 00:14:20.000000', 'temperatura', 1010.0000, 'ºC'),
	(180426, 121, '2014-02-01 00:14:21.000000', 'temperatura', 182.0000, 'ºC'),
	(180427, 121, '2014-02-01 00:14:22.000000', 'temperatura', 279.0000, 'ºC'),
	(180428, 121, '2014-02-01 00:14:23.000000', 'temperatura', 851.0000, 'ºC'),
	(180429, 121, '2014-02-01 00:14:24.000000', 'temperatura', 1018.0000, 'ºC'),
	(180430, 121, '2014-02-01 00:14:25.000000', 'temperatura', 136.0000, 'ºC'),
	(180431, 121, '2014-02-01 00:14:26.000000', 'temperatura', 28.0000, 'ºC'),
	(180432, 121, '2014-02-01 00:14:27.000000', 'temperatura', 931.0000, 'ºC'),
	(180433, 121, '2014-02-01 00:14:28.000000', 'temperatura', 973.0000, 'ºC'),
	(180434, 121, '2014-02-01 00:14:29.000000', 'temperatura', 872.0000, 'ºC'),
	(180435, 121, '2014-02-01 00:14:30.000000', 'temperatura', 243.0000, 'ºC'),
	(180436, 121, '2014-02-01 00:14:31.000000', 'temperatura', 997.0000, 'ºC'),
	(180437, 121, '2014-02-01 00:14:32.000000', 'temperatura', 659.0000, 'ºC'),
	(180438, 121, '2014-02-01 00:14:33.000000', 'temperatura', 305.0000, 'ºC'),
	(180439, 121, '2014-02-01 00:14:34.000000', 'temperatura', 749.0000, 'ºC'),
	(180440, 121, '2014-02-01 00:14:35.000000', 'temperatura', 428.0000, 'ºC'),
	(180441, 121, '2014-02-01 00:14:36.000000', 'temperatura', 1094.0000, 'ºC'),
	(180442, 121, '2014-02-01 00:14:37.000000', 'temperatura', 588.0000, 'ºC'),
	(180443, 121, '2014-02-01 00:14:38.000000', 'temperatura', 859.0000, 'ºC'),
	(180444, 121, '2014-02-01 00:14:39.000000', 'temperatura', 131.0000, 'ºC'),
	(180445, 121, '2014-02-01 00:14:40.000000', 'temperatura', 480.0000, 'ºC'),
	(180446, 121, '2014-02-01 00:14:41.000000', 'temperatura', 807.0000, 'ºC'),
	(180447, 121, '2014-02-01 00:14:42.000000', 'temperatura', 197.0000, 'ºC'),
	(180448, 121, '2014-02-01 00:14:43.000000', 'temperatura', 962.0000, 'ºC'),
	(180449, 121, '2014-02-01 00:14:44.000000', 'temperatura', 620.0000, 'ºC'),
	(180450, 121, '2014-02-01 00:14:45.000000', 'temperatura', 213.0000, 'ºC'),
	(180451, 121, '2014-02-01 00:14:46.000000', 'temperatura', 406.0000, 'ºC'),
	(180452, 121, '2014-02-01 00:14:47.000000', 'temperatura', 193.0000, 'ºC'),
	(180453, 121, '2014-02-01 00:14:48.000000', 'temperatura', 947.0000, 'ºC'),
	(180454, 121, '2014-02-01 00:14:49.000000', 'temperatura', 557.0000, 'ºC'),
	(180455, 121, '2014-02-01 00:14:50.000000', 'temperatura', 1143.0000, 'ºC'),
	(180456, 121, '2014-02-01 00:14:51.000000', 'temperatura', 444.0000, 'ºC'),
	(180457, 121, '2014-02-01 00:14:52.000000', 'temperatura', 1193.0000, 'ºC'),
	(180458, 121, '2014-02-01 00:14:53.000000', 'temperatura', 1032.0000, 'ºC'),
	(180459, 121, '2014-02-01 00:14:54.000000', 'temperatura', 381.0000, 'ºC'),
	(180460, 121, '2014-02-01 00:14:55.000000', 'temperatura', 8.0000, 'ºC'),
	(180461, 121, '2014-02-01 00:14:56.000000', 'temperatura', 100.0000, 'ºC'),
	(180462, 121, '2014-02-01 00:14:57.000000', 'temperatura', 478.0000, 'ºC'),
	(180463, 121, '2014-02-01 00:14:58.000000', 'temperatura', 888.0000, 'ºC'),
	(180464, 121, '2014-02-01 00:14:59.000000', 'temperatura', 609.0000, 'ºC'),
	(180465, 121, '2014-02-01 00:15:00.000000', 'temperatura', 381.0000, 'ºC'),
	(180466, 121, '2014-02-01 00:15:01.000000', 'temperatura', 78.0000, 'ºC'),
	(180467, 121, '2014-02-01 00:15:02.000000', 'temperatura', 446.0000, 'ºC'),
	(180468, 121, '2014-02-01 00:15:03.000000', 'temperatura', 797.0000, 'ºC'),
	(180469, 121, '2014-02-01 00:15:04.000000', 'temperatura', 247.0000, 'ºC'),
	(180470, 121, '2014-02-01 00:15:05.000000', 'temperatura', 45.0000, 'ºC'),
	(180471, 121, '2014-02-01 00:15:06.000000', 'temperatura', 686.0000, 'ºC'),
	(180472, 121, '2014-02-01 00:15:07.000000', 'temperatura', 894.0000, 'ºC'),
	(180473, 121, '2014-02-01 00:15:08.000000', 'temperatura', 13.0000, 'ºC'),
	(180474, 121, '2014-02-01 00:15:09.000000', 'temperatura', 985.0000, 'ºC'),
	(180475, 121, '2014-02-01 00:15:10.000000', 'temperatura', 87.0000, 'ºC'),
	(180476, 121, '2014-02-01 00:15:11.000000', 'temperatura', 1080.0000, 'ºC'),
	(180477, 121, '2014-02-01 00:15:12.000000', 'temperatura', 338.0000, 'ºC'),
	(180478, 121, '2014-02-01 00:15:13.000000', 'temperatura', 853.0000, 'ºC'),
	(180479, 121, '2014-02-01 00:15:14.000000', 'temperatura', 851.0000, 'ºC'),
	(180480, 121, '2014-02-01 00:15:15.000000', 'temperatura', 497.0000, 'ºC'),
	(180481, 121, '2014-02-01 00:15:16.000000', 'temperatura', 1131.0000, 'ºC'),
	(180482, 121, '2014-02-01 00:15:17.000000', 'temperatura', 564.0000, 'ºC'),
	(180483, 121, '2014-02-01 00:15:18.000000', 'temperatura', 628.0000, 'ºC'),
	(180484, 121, '2014-02-01 00:15:19.000000', 'temperatura', 249.0000, 'ºC'),
	(180485, 121, '2014-02-01 00:15:20.000000', 'temperatura', 563.0000, 'ºC'),
	(180486, 121, '2014-02-01 00:15:21.000000', 'temperatura', 866.0000, 'ºC'),
	(180487, 121, '2014-02-01 00:15:22.000000', 'temperatura', 240.0000, 'ºC'),
	(180488, 121, '2014-02-01 00:15:23.000000', 'temperatura', 1006.0000, 'ºC'),
	(180489, 121, '2014-02-01 00:15:24.000000', 'temperatura', 709.0000, 'ºC'),
	(180490, 121, '2014-02-01 00:15:25.000000', 'temperatura', 528.0000, 'ºC'),
	(180491, 121, '2014-02-01 00:15:26.000000', 'temperatura', 514.0000, 'ºC'),
	(180492, 121, '2014-02-01 00:15:27.000000', 'temperatura', 986.0000, 'ºC'),
	(180493, 121, '2014-02-01 00:15:28.000000', 'temperatura', 986.0000, 'ºC'),
	(180494, 121, '2014-02-01 00:15:29.000000', 'temperatura', 776.0000, 'ºC'),
	(180495, 121, '2014-02-01 00:15:30.000000', 'temperatura', 921.0000, 'ºC'),
	(180496, 121, '2014-02-01 00:15:31.000000', 'temperatura', 1080.0000, 'ºC'),
	(180497, 121, '2014-02-01 00:15:32.000000', 'temperatura', 234.0000, 'ºC'),
	(180498, 121, '2014-02-01 00:15:33.000000', 'temperatura', 333.0000, 'ºC'),
	(180499, 121, '2014-02-01 00:15:34.000000', 'temperatura', 962.0000, 'ºC'),
	(180500, 121, '2014-02-01 00:15:35.000000', 'temperatura', 212.0000, 'ºC'),
	(180501, 121, '2014-02-01 00:15:36.000000', 'temperatura', 576.0000, 'ºC'),
	(180502, 121, '2014-02-01 00:15:37.000000', 'temperatura', 1043.0000, 'ºC'),
	(180503, 121, '2014-02-01 00:15:38.000000', 'temperatura', 1087.0000, 'ºC'),
	(180504, 121, '2014-02-01 00:15:39.000000', 'temperatura', 1108.0000, 'ºC'),
	(180505, 121, '2014-02-01 00:15:40.000000', 'temperatura', 1080.0000, 'ºC'),
	(180506, 121, '2014-02-01 00:15:41.000000', 'temperatura', 877.0000, 'ºC'),
	(180507, 121, '2014-02-01 00:15:42.000000', 'temperatura', 1146.0000, 'ºC'),
	(180508, 121, '2014-02-01 00:15:43.000000', 'temperatura', 699.0000, 'ºC'),
	(180509, 121, '2014-02-01 00:15:44.000000', 'temperatura', 55.0000, 'ºC'),
	(180510, 121, '2014-02-01 00:15:45.000000', 'temperatura', 581.0000, 'ºC'),
	(180511, 121, '2014-02-01 00:15:46.000000', 'temperatura', 341.0000, 'ºC'),
	(180512, 121, '2014-02-01 00:15:47.000000', 'temperatura', 1160.0000, 'ºC'),
	(180513, 121, '2014-02-01 00:15:48.000000', 'temperatura', 1179.0000, 'ºC'),
	(180514, 121, '2014-02-01 00:15:49.000000', 'temperatura', 15.0000, 'ºC'),
	(180515, 121, '2014-02-01 00:15:50.000000', 'temperatura', 137.0000, 'ºC'),
	(180516, 121, '2014-02-01 00:15:51.000000', 'temperatura', 642.0000, 'ºC'),
	(180517, 121, '2014-02-01 00:15:52.000000', 'temperatura', 400.0000, 'ºC'),
	(180518, 121, '2014-02-01 00:15:53.000000', 'temperatura', 76.0000, 'ºC'),
	(180519, 121, '2014-02-01 00:15:54.000000', 'temperatura', 377.0000, 'ºC'),
	(180520, 121, '2014-02-01 00:15:55.000000', 'temperatura', 460.0000, 'ºC'),
	(180521, 121, '2014-02-01 00:15:56.000000', 'temperatura', 1170.0000, 'ºC'),
	(180522, 121, '2014-02-01 00:15:57.000000', 'temperatura', 871.0000, 'ºC'),
	(180523, 121, '2014-02-01 00:15:58.000000', 'temperatura', 845.0000, 'ºC'),
	(180524, 121, '2014-02-01 00:15:59.000000', 'temperatura', 414.0000, 'ºC'),
	(180525, 121, '2014-02-01 00:16:00.000000', 'temperatura', 733.0000, 'ºC'),
	(180526, 121, '2014-02-01 00:16:01.000000', 'temperatura', 23.0000, 'ºC'),
	(180527, 121, '2014-02-01 00:16:02.000000', 'temperatura', 316.0000, 'ºC'),
	(180528, 121, '2014-02-01 00:16:03.000000', 'temperatura', 314.0000, 'ºC'),
	(180529, 121, '2014-02-01 00:16:04.000000', 'temperatura', 622.0000, 'ºC'),
	(180530, 121, '2014-02-01 00:16:05.000000', 'temperatura', 970.0000, 'ºC'),
	(180531, 121, '2014-02-01 00:16:06.000000', 'temperatura', 581.0000, 'ºC'),
	(180532, 121, '2014-02-01 00:16:07.000000', 'temperatura', 1197.0000, 'ºC'),
	(180533, 121, '2014-02-01 00:16:08.000000', 'temperatura', 644.0000, 'ºC'),
	(180534, 121, '2014-02-01 00:16:09.000000', 'temperatura', 828.0000, 'ºC'),
	(180535, 121, '2014-02-01 00:16:10.000000', 'temperatura', 1010.0000, 'ºC'),
	(180536, 121, '2014-02-01 00:16:11.000000', 'temperatura', 166.0000, 'ºC'),
	(180537, 121, '2014-02-01 00:16:12.000000', 'temperatura', 200.0000, 'ºC'),
	(180538, 121, '2014-02-01 00:16:13.000000', 'temperatura', 502.0000, 'ºC'),
	(180539, 121, '2014-02-01 00:16:14.000000', 'temperatura', 711.0000, 'ºC'),
	(180540, 121, '2014-02-01 00:16:15.000000', 'temperatura', 847.0000, 'ºC'),
	(180541, 121, '2014-02-01 00:16:16.000000', 'temperatura', 906.0000, 'ºC'),
	(180542, 121, '2014-02-01 00:16:17.000000', 'temperatura', 790.0000, 'ºC'),
	(180543, 121, '2014-02-01 00:16:18.000000', 'temperatura', 30.0000, 'ºC'),
	(180544, 121, '2014-02-01 00:16:19.000000', 'temperatura', 181.0000, 'ºC'),
	(180545, 121, '2014-02-01 00:16:20.000000', 'temperatura', 816.0000, 'ºC'),
	(180546, 121, '2014-02-01 00:16:21.000000', 'temperatura', 1137.0000, 'ºC'),
	(180547, 121, '2014-02-01 00:16:22.000000', 'temperatura', 836.0000, 'ºC'),
	(180548, 121, '2014-02-01 00:16:23.000000', 'temperatura', 771.0000, 'ºC'),
	(180549, 121, '2014-02-01 00:16:24.000000', 'temperatura', 146.0000, 'ºC'),
	(180550, 121, '2014-02-01 00:16:25.000000', 'temperatura', 817.0000, 'ºC'),
	(180551, 121, '2014-02-01 00:16:26.000000', 'temperatura', 47.0000, 'ºC'),
	(180552, 121, '2014-02-01 00:16:27.000000', 'temperatura', 185.0000, 'ºC'),
	(180553, 121, '2014-02-01 00:16:28.000000', 'temperatura', 785.0000, 'ºC'),
	(180554, 121, '2014-02-01 00:16:29.000000', 'temperatura', 969.0000, 'ºC'),
	(180555, 121, '2014-02-01 00:16:30.000000', 'temperatura', 93.0000, 'ºC'),
	(180556, 121, '2014-02-01 00:16:31.000000', 'temperatura', 1158.0000, 'ºC'),
	(180557, 121, '2014-02-01 00:16:32.000000', 'temperatura', 709.0000, 'ºC'),
	(180558, 121, '2014-02-01 00:16:33.000000', 'temperatura', 73.0000, 'ºC'),
	(180559, 121, '2014-02-01 00:16:34.000000', 'temperatura', 639.0000, 'ºC'),
	(180560, 121, '2014-02-01 00:16:35.000000', 'temperatura', 575.0000, 'ºC'),
	(180561, 121, '2014-02-01 00:16:36.000000', 'temperatura', 961.0000, 'ºC'),
	(180562, 121, '2014-02-01 00:16:37.000000', 'temperatura', 677.0000, 'ºC'),
	(180563, 121, '2014-02-01 00:16:38.000000', 'temperatura', 505.0000, 'ºC'),
	(180564, 121, '2014-02-01 00:16:39.000000', 'temperatura', 496.0000, 'ºC'),
	(180565, 121, '2014-02-01 00:16:40.000000', 'temperatura', 963.0000, 'ºC'),
	(180566, 121, '2014-02-01 00:16:41.000000', 'temperatura', 930.0000, 'ºC'),
	(180567, 121, '2014-02-01 00:16:42.000000', 'temperatura', 559.0000, 'ºC'),
	(180568, 121, '2014-02-01 00:16:43.000000', 'temperatura', 9.0000, 'ºC'),
	(180569, 121, '2014-02-01 00:16:44.000000', 'temperatura', 765.0000, 'ºC'),
	(180570, 121, '2014-02-01 00:16:45.000000', 'temperatura', 198.0000, 'ºC'),
	(180571, 121, '2014-02-01 00:16:46.000000', 'temperatura', 1096.0000, 'ºC'),
	(180572, 121, '2014-02-01 00:16:47.000000', 'temperatura', 88.0000, 'ºC'),
	(180573, 121, '2014-02-01 00:16:48.000000', 'temperatura', 752.0000, 'ºC'),
	(180574, 121, '2014-02-01 00:16:49.000000', 'temperatura', 1095.0000, 'ºC'),
	(180575, 121, '2014-02-01 00:16:50.000000', 'temperatura', 822.0000, 'ºC'),
	(180576, 121, '2014-02-01 00:16:51.000000', 'temperatura', 826.0000, 'ºC'),
	(180577, 121, '2014-02-01 00:16:52.000000', 'temperatura', 462.0000, 'ºC'),
	(180578, 121, '2014-02-01 00:16:53.000000', 'temperatura', 1032.0000, 'ºC'),
	(180579, 121, '2014-02-01 00:16:54.000000', 'temperatura', 176.0000, 'ºC'),
	(180580, 121, '2014-02-01 00:16:55.000000', 'temperatura', 185.0000, 'ºC'),
	(180581, 121, '2014-02-01 00:16:56.000000', 'temperatura', 396.0000, 'ºC'),
	(180582, 121, '2014-02-01 00:16:57.000000', 'temperatura', 228.0000, 'ºC'),
	(180583, 121, '2014-02-01 00:16:58.000000', 'temperatura', 1152.0000, 'ºC'),
	(180584, 121, '2014-02-01 00:16:59.000000', 'temperatura', 278.0000, 'ºC'),
	(180585, 121, '2014-02-01 00:17:00.000000', 'temperatura', 332.0000, 'ºC'),
	(180586, 121, '2014-02-01 00:17:01.000000', 'temperatura', 826.0000, 'ºC'),
	(180587, 121, '2014-02-01 00:17:02.000000', 'temperatura', 735.0000, 'ºC'),
	(180588, 121, '2014-02-01 00:17:03.000000', 'temperatura', 1199.0000, 'ºC'),
	(180589, 121, '2014-02-01 00:17:04.000000', 'temperatura', 190.0000, 'ºC'),
	(180590, 121, '2014-02-01 00:17:05.000000', 'temperatura', 951.0000, 'ºC'),
	(180591, 121, '2014-02-01 00:17:06.000000', 'temperatura', 588.0000, 'ºC'),
	(180592, 121, '2014-02-01 00:17:07.000000', 'temperatura', 85.0000, 'ºC'),
	(180593, 121, '2014-02-01 00:17:08.000000', 'temperatura', 1063.0000, 'ºC'),
	(180594, 121, '2014-02-01 00:17:09.000000', 'temperatura', 261.0000, 'ºC'),
	(180595, 121, '2014-02-01 00:17:10.000000', 'temperatura', 514.0000, 'ºC'),
	(180596, 121, '2014-02-01 00:17:11.000000', 'temperatura', 590.0000, 'ºC'),
	(180597, 121, '2014-02-01 00:17:12.000000', 'temperatura', 206.0000, 'ºC'),
	(180598, 121, '2014-02-01 00:17:13.000000', 'temperatura', 461.0000, 'ºC'),
	(180599, 121, '2014-02-01 00:17:14.000000', 'temperatura', 490.0000, 'ºC'),
	(180600, 121, '2014-02-01 00:17:15.000000', 'temperatura', 1065.0000, 'ºC'),
	(180601, 121, '2014-02-01 00:17:16.000000', 'temperatura', 256.0000, 'ºC'),
	(180602, 121, '2014-02-01 00:17:17.000000', 'temperatura', 484.0000, 'ºC'),
	(180603, 121, '2014-02-01 00:17:18.000000', 'temperatura', 454.0000, 'ºC'),
	(180604, 121, '2014-02-01 00:17:19.000000', 'temperatura', 820.0000, 'ºC'),
	(180605, 121, '2014-02-01 00:17:20.000000', 'temperatura', 337.0000, 'ºC'),
	(180606, 121, '2014-02-01 00:17:21.000000', 'temperatura', 426.0000, 'ºC'),
	(180607, 121, '2014-02-01 00:17:22.000000', 'temperatura', 1120.0000, 'ºC'),
	(180608, 121, '2014-02-01 00:17:23.000000', 'temperatura', 723.0000, 'ºC'),
	(180609, 121, '2014-02-01 00:17:24.000000', 'temperatura', 255.0000, 'ºC'),
	(180610, 121, '2014-02-01 00:17:25.000000', 'temperatura', 308.0000, 'ºC'),
	(180611, 121, '2014-02-01 00:17:26.000000', 'temperatura', 776.0000, 'ºC'),
	(180612, 121, '2014-02-01 00:17:27.000000', 'temperatura', 557.0000, 'ºC'),
	(180613, 121, '2014-02-01 00:17:28.000000', 'temperatura', 457.0000, 'ºC'),
	(180614, 121, '2014-02-01 00:17:29.000000', 'temperatura', 612.0000, 'ºC'),
	(180615, 121, '2014-02-01 00:17:30.000000', 'temperatura', 493.0000, 'ºC'),
	(180616, 121, '2014-02-01 00:17:31.000000', 'temperatura', 628.0000, 'ºC'),
	(180617, 121, '2014-02-01 00:17:32.000000', 'temperatura', 461.0000, 'ºC'),
	(180618, 121, '2014-02-01 00:17:33.000000', 'temperatura', 423.0000, 'ºC'),
	(180619, 121, '2014-02-01 00:17:34.000000', 'temperatura', 731.0000, 'ºC'),
	(180620, 121, '2014-02-01 00:17:35.000000', 'temperatura', 1188.0000, 'ºC'),
	(180621, 121, '2014-02-01 00:17:36.000000', 'temperatura', 148.0000, 'ºC'),
	(180622, 121, '2014-02-01 00:17:37.000000', 'temperatura', 775.0000, 'ºC'),
	(180623, 121, '2014-02-01 00:17:38.000000', 'temperatura', 1033.0000, 'ºC'),
	(180624, 121, '2014-02-01 00:17:39.000000', 'temperatura', 438.0000, 'ºC'),
	(180625, 121, '2014-02-01 00:17:40.000000', 'temperatura', 293.0000, 'ºC'),
	(180626, 121, '2014-02-01 00:17:41.000000', 'temperatura', 150.0000, 'ºC'),
	(180627, 121, '2014-02-01 00:17:42.000000', 'temperatura', 1073.0000, 'ºC'),
	(180628, 121, '2014-02-01 00:17:43.000000', 'temperatura', 115.0000, 'ºC'),
	(180629, 121, '2014-02-01 00:17:44.000000', 'temperatura', 956.0000, 'ºC'),
	(180630, 121, '2014-02-01 00:17:45.000000', 'temperatura', 834.0000, 'ºC'),
	(180631, 121, '2014-02-01 00:17:46.000000', 'temperatura', 105.0000, 'ºC'),
	(180632, 121, '2014-02-01 00:17:47.000000', 'temperatura', 425.0000, 'ºC'),
	(180633, 121, '2014-02-01 00:17:48.000000', 'temperatura', 608.0000, 'ºC'),
	(180634, 121, '2014-02-01 00:17:49.000000', 'temperatura', 564.0000, 'ºC'),
	(180635, 121, '2014-02-01 00:17:50.000000', 'temperatura', 1000.0000, 'ºC'),
	(180636, 121, '2014-02-01 00:17:51.000000', 'temperatura', 906.0000, 'ºC'),
	(180637, 121, '2014-02-01 00:17:52.000000', 'temperatura', 330.0000, 'ºC'),
	(180638, 121, '2014-02-01 00:17:53.000000', 'temperatura', 135.0000, 'ºC'),
	(180639, 121, '2014-02-01 00:17:54.000000', 'temperatura', 885.0000, 'ºC'),
	(180640, 121, '2014-02-01 00:17:55.000000', 'temperatura', 419.0000, 'ºC'),
	(180641, 121, '2014-02-01 00:17:56.000000', 'temperatura', 643.0000, 'ºC'),
	(180642, 121, '2014-02-01 00:17:57.000000', 'temperatura', 757.0000, 'ºC'),
	(180643, 121, '2014-02-01 00:17:58.000000', 'temperatura', 658.0000, 'ºC'),
	(180644, 121, '2014-02-01 00:17:59.000000', 'temperatura', 1016.0000, 'ºC'),
	(180645, 121, '2014-02-01 00:18:00.000000', 'temperatura', 710.0000, 'ºC'),
	(180646, 121, '2014-02-01 00:18:01.000000', 'temperatura', 503.0000, 'ºC'),
	(180647, 121, '2014-02-01 00:18:02.000000', 'temperatura', 385.0000, 'ºC'),
	(180648, 121, '2014-02-01 00:18:03.000000', 'temperatura', 414.0000, 'ºC'),
	(180649, 121, '2014-02-01 00:18:04.000000', 'temperatura', 917.0000, 'ºC'),
	(180650, 121, '2014-02-01 00:18:05.000000', 'temperatura', 943.0000, 'ºC'),
	(180651, 121, '2014-02-01 00:18:06.000000', 'temperatura', 765.0000, 'ºC'),
	(180652, 121, '2014-02-01 00:18:07.000000', 'temperatura', 997.0000, 'ºC'),
	(180653, 121, '2014-02-01 00:18:08.000000', 'temperatura', 291.0000, 'ºC'),
	(180654, 121, '2014-02-01 00:18:09.000000', 'temperatura', 862.0000, 'ºC'),
	(180655, 121, '2014-02-01 00:18:10.000000', 'temperatura', 1041.0000, 'ºC'),
	(180656, 121, '2014-02-01 00:18:11.000000', 'temperatura', 217.0000, 'ºC'),
	(180657, 121, '2014-02-01 00:18:12.000000', 'temperatura', 363.0000, 'ºC'),
	(180658, 121, '2014-02-01 00:18:13.000000', 'temperatura', 1166.0000, 'ºC'),
	(180659, 121, '2014-02-01 00:18:14.000000', 'temperatura', 1139.0000, 'ºC'),
	(180660, 121, '2014-02-01 00:18:15.000000', 'temperatura', 1001.0000, 'ºC'),
	(180661, 121, '2014-02-01 00:18:16.000000', 'temperatura', 385.0000, 'ºC'),
	(180662, 121, '2014-02-01 00:18:17.000000', 'temperatura', 123.0000, 'ºC'),
	(180663, 121, '2014-02-01 00:18:18.000000', 'temperatura', 662.0000, 'ºC'),
	(180664, 121, '2014-02-01 00:18:19.000000', 'temperatura', 540.0000, 'ºC'),
	(180665, 121, '2014-02-01 00:18:20.000000', 'temperatura', 717.0000, 'ºC'),
	(180666, 121, '2014-02-01 00:18:21.000000', 'temperatura', 763.0000, 'ºC'),
	(180667, 121, '2014-02-01 00:18:22.000000', 'temperatura', 464.0000, 'ºC'),
	(180668, 121, '2014-02-01 00:18:23.000000', 'temperatura', 34.0000, 'ºC'),
	(180669, 121, '2014-02-01 00:18:24.000000', 'temperatura', 1178.0000, 'ºC'),
	(180670, 121, '2014-02-01 00:18:25.000000', 'temperatura', 989.0000, 'ºC'),
	(180671, 121, '2014-02-01 00:18:26.000000', 'temperatura', 212.0000, 'ºC'),
	(180672, 121, '2014-02-01 00:18:27.000000', 'temperatura', 494.0000, 'ºC'),
	(180673, 121, '2014-02-01 00:18:28.000000', 'temperatura', 632.0000, 'ºC'),
	(180674, 121, '2014-02-01 00:18:29.000000', 'temperatura', 482.0000, 'ºC'),
	(180675, 121, '2014-02-01 00:18:30.000000', 'temperatura', 511.0000, 'ºC'),
	(180676, 121, '2014-02-01 00:18:31.000000', 'temperatura', 1113.0000, 'ºC'),
	(180677, 121, '2014-02-01 00:18:32.000000', 'temperatura', 430.0000, 'ºC'),
	(180678, 121, '2014-02-01 00:18:33.000000', 'temperatura', 11.0000, 'ºC'),
	(180679, 121, '2014-02-01 00:18:34.000000', 'temperatura', 1166.0000, 'ºC'),
	(180680, 121, '2014-02-01 00:18:35.000000', 'temperatura', 996.0000, 'ºC'),
	(180681, 121, '2014-02-01 00:18:36.000000', 'temperatura', 286.0000, 'ºC'),
	(180682, 121, '2014-02-01 00:18:37.000000', 'temperatura', 839.0000, 'ºC'),
	(180683, 121, '2014-02-01 00:18:38.000000', 'temperatura', 940.0000, 'ºC'),
	(180684, 121, '2014-02-01 00:18:39.000000', 'temperatura', 982.0000, 'ºC'),
	(180685, 121, '2014-02-01 00:18:40.000000', 'temperatura', 890.0000, 'ºC'),
	(180686, 121, '2014-02-01 00:18:41.000000', 'temperatura', 305.0000, 'ºC'),
	(180687, 121, '2014-02-01 00:18:42.000000', 'temperatura', 55.0000, 'ºC'),
	(180688, 121, '2014-02-01 00:18:43.000000', 'temperatura', 562.0000, 'ºC'),
	(180689, 121, '2014-02-01 00:18:44.000000', 'temperatura', 244.0000, 'ºC'),
	(180690, 121, '2014-02-01 00:18:45.000000', 'temperatura', 735.0000, 'ºC'),
	(180691, 121, '2014-02-01 00:18:46.000000', 'temperatura', 543.0000, 'ºC'),
	(180692, 121, '2014-02-01 00:18:47.000000', 'temperatura', 510.0000, 'ºC'),
	(180693, 121, '2014-02-01 00:18:48.000000', 'temperatura', 923.0000, 'ºC'),
	(180694, 121, '2014-02-01 00:18:49.000000', 'temperatura', 687.0000, 'ºC'),
	(180695, 121, '2014-02-01 00:18:50.000000', 'temperatura', 665.0000, 'ºC'),
	(180696, 121, '2014-02-01 00:18:51.000000', 'temperatura', 63.0000, 'ºC'),
	(180697, 121, '2014-02-01 00:18:52.000000', 'temperatura', 723.0000, 'ºC'),
	(180698, 121, '2014-02-01 00:18:53.000000', 'temperatura', 1025.0000, 'ºC'),
	(180699, 121, '2014-02-01 00:18:54.000000', 'temperatura', 557.0000, 'ºC'),
	(180700, 121, '2014-02-01 00:18:55.000000', 'temperatura', 909.0000, 'ºC'),
	(180701, 121, '2014-02-01 00:18:56.000000', 'temperatura', 477.0000, 'ºC'),
	(180702, 121, '2014-02-01 00:18:57.000000', 'temperatura', 857.0000, 'ºC'),
	(180703, 121, '2014-02-01 00:18:58.000000', 'temperatura', 453.0000, 'ºC'),
	(180704, 121, '2014-02-01 00:18:59.000000', 'temperatura', 896.0000, 'ºC'),
	(180705, 121, '2014-02-01 00:19:00.000000', 'temperatura', 723.0000, 'ºC'),
	(180706, 121, '2014-02-01 00:19:01.000000', 'temperatura', 928.0000, 'ºC'),
	(180707, 121, '2014-02-01 00:19:02.000000', 'temperatura', 72.0000, 'ºC'),
	(180708, 121, '2014-02-01 00:19:03.000000', 'temperatura', 1175.0000, 'ºC'),
	(180709, 121, '2014-02-01 00:19:04.000000', 'temperatura', 861.0000, 'ºC'),
	(180710, 121, '2014-02-01 00:19:05.000000', 'temperatura', 781.0000, 'ºC'),
	(180711, 121, '2014-02-01 00:19:06.000000', 'temperatura', 121.0000, 'ºC'),
	(180712, 121, '2014-02-01 00:19:07.000000', 'temperatura', 663.0000, 'ºC'),
	(180713, 121, '2014-02-01 00:19:08.000000', 'temperatura', 550.0000, 'ºC'),
	(180714, 121, '2014-02-01 00:19:09.000000', 'temperatura', 765.0000, 'ºC'),
	(180715, 121, '2014-02-01 00:19:10.000000', 'temperatura', 976.0000, 'ºC'),
	(180716, 121, '2014-02-01 00:19:11.000000', 'temperatura', 182.0000, 'ºC'),
	(180717, 121, '2014-02-01 00:19:12.000000', 'temperatura', 386.0000, 'ºC'),
	(180718, 121, '2014-02-01 00:19:13.000000', 'temperatura', 182.0000, 'ºC'),
	(180719, 121, '2014-02-01 00:19:14.000000', 'temperatura', 952.0000, 'ºC'),
	(180720, 121, '2014-02-01 00:19:15.000000', 'temperatura', 616.0000, 'ºC'),
	(180721, 121, '2014-02-01 00:19:16.000000', 'temperatura', 223.0000, 'ºC'),
	(180722, 121, '2014-02-01 00:19:17.000000', 'temperatura', 466.0000, 'ºC'),
	(180723, 121, '2014-02-01 00:19:18.000000', 'temperatura', 464.0000, 'ºC'),
	(180724, 121, '2014-02-01 00:19:19.000000', 'temperatura', 921.0000, 'ºC'),
	(180725, 121, '2014-02-01 00:19:20.000000', 'temperatura', 815.0000, 'ºC'),
	(180726, 121, '2014-02-01 00:19:21.000000', 'temperatura', 112.0000, 'ºC'),
	(180727, 121, '2014-02-01 00:19:22.000000', 'temperatura', 515.0000, 'ºC'),
	(180728, 121, '2014-02-01 00:19:23.000000', 'temperatura', 1039.0000, 'ºC'),
	(180729, 121, '2014-02-01 00:19:24.000000', 'temperatura', 50.0000, 'ºC'),
	(180730, 121, '2014-02-01 00:19:25.000000', 'temperatura', 736.0000, 'ºC'),
	(180731, 121, '2014-02-01 00:19:26.000000', 'temperatura', 1128.0000, 'ºC'),
	(180732, 121, '2014-02-01 00:19:27.000000', 'temperatura', 1033.0000, 'ºC'),
	(180733, 121, '2014-02-01 00:19:28.000000', 'temperatura', 582.0000, 'ºC'),
	(180734, 121, '2014-02-01 00:19:29.000000', 'temperatura', 1011.0000, 'ºC'),
	(180735, 121, '2014-02-01 00:19:30.000000', 'temperatura', 912.0000, 'ºC'),
	(180736, 121, '2014-02-01 00:19:31.000000', 'temperatura', 324.0000, 'ºC'),
	(180737, 121, '2014-02-01 00:19:32.000000', 'temperatura', 88.0000, 'ºC'),
	(180738, 121, '2014-02-01 00:19:33.000000', 'temperatura', 666.0000, 'ºC'),
	(180739, 121, '2014-02-01 00:19:34.000000', 'temperatura', 668.0000, 'ºC'),
	(180740, 121, '2014-02-01 00:19:35.000000', 'temperatura', 140.0000, 'ºC'),
	(180741, 121, '2014-02-01 00:19:36.000000', 'temperatura', 1098.0000, 'ºC'),
	(180742, 121, '2014-02-01 00:19:37.000000', 'temperatura', 272.0000, 'ºC'),
	(180743, 121, '2014-02-01 00:19:38.000000', 'temperatura', 464.0000, 'ºC'),
	(180744, 121, '2014-02-01 00:19:39.000000', 'temperatura', 306.0000, 'ºC'),
	(180745, 121, '2014-02-01 00:19:40.000000', 'temperatura', 139.0000, 'ºC'),
	(180746, 121, '2014-02-01 00:19:41.000000', 'temperatura', 977.0000, 'ºC'),
	(180747, 121, '2014-02-01 00:19:42.000000', 'temperatura', 868.0000, 'ºC'),
	(180748, 121, '2014-02-01 00:19:43.000000', 'temperatura', 208.0000, 'ºC'),
	(180749, 121, '2014-02-01 00:19:44.000000', 'temperatura', 839.0000, 'ºC'),
	(180750, 121, '2014-02-01 00:19:45.000000', 'temperatura', 1169.0000, 'ºC'),
	(180751, 121, '2014-02-01 00:19:46.000000', 'temperatura', 932.0000, 'ºC'),
	(180752, 121, '2014-02-01 00:19:47.000000', 'temperatura', 1150.0000, 'ºC'),
	(180753, 121, '2014-02-01 00:19:48.000000', 'temperatura', 555.0000, 'ºC'),
	(180754, 121, '2014-02-01 00:19:49.000000', 'temperatura', 526.0000, 'ºC'),
	(180755, 121, '2014-02-01 00:19:50.000000', 'temperatura', 964.0000, 'ºC'),
	(180756, 121, '2014-02-01 00:19:51.000000', 'temperatura', 844.0000, 'ºC'),
	(180757, 121, '2014-02-01 00:19:52.000000', 'temperatura', 126.0000, 'ºC'),
	(180758, 121, '2014-02-01 00:19:53.000000', 'temperatura', 501.0000, 'ºC'),
	(180759, 121, '2014-02-01 00:19:54.000000', 'temperatura', 927.0000, 'ºC'),
	(180760, 121, '2014-02-01 00:19:55.000000', 'temperatura', 731.0000, 'ºC'),
	(180761, 121, '2014-02-01 00:19:56.000000', 'temperatura', 877.0000, 'ºC'),
	(180762, 121, '2014-02-01 00:19:57.000000', 'temperatura', 991.0000, 'ºC'),
	(180763, 121, '2014-02-01 00:19:58.000000', 'temperatura', 1123.0000, 'ºC'),
	(180764, 121, '2014-02-01 00:19:59.000000', 'temperatura', 244.0000, 'ºC'),
	(180765, 121, '2014-02-01 00:20:00.000000', 'temperatura', 252.0000, 'ºC'),
	(180766, 121, '2014-02-01 00:20:01.000000', 'temperatura', 526.0000, 'ºC'),
	(180767, 121, '2014-02-01 00:20:02.000000', 'temperatura', 677.0000, 'ºC'),
	(180768, 121, '2014-02-01 00:20:03.000000', 'temperatura', 606.0000, 'ºC'),
	(180769, 121, '2014-02-01 00:20:04.000000', 'temperatura', 1000.0000, 'ºC'),
	(180770, 121, '2014-02-01 00:20:05.000000', 'temperatura', 783.0000, 'ºC'),
	(180771, 121, '2014-02-01 00:20:06.000000', 'temperatura', 916.0000, 'ºC'),
	(180772, 121, '2014-02-01 00:20:07.000000', 'temperatura', 1033.0000, 'ºC'),
	(180773, 121, '2014-02-01 00:20:08.000000', 'temperatura', 16.0000, 'ºC'),
	(180774, 121, '2014-02-01 00:20:09.000000', 'temperatura', 580.0000, 'ºC'),
	(180775, 121, '2014-02-01 00:20:10.000000', 'temperatura', 455.0000, 'ºC'),
	(180776, 121, '2014-02-01 00:20:11.000000', 'temperatura', 535.0000, 'ºC'),
	(180777, 121, '2014-02-01 00:20:12.000000', 'temperatura', 111.0000, 'ºC'),
	(180778, 121, '2014-02-01 00:20:13.000000', 'temperatura', 150.0000, 'ºC'),
	(180779, 121, '2014-02-01 00:20:14.000000', 'temperatura', 416.0000, 'ºC'),
	(180780, 121, '2014-02-01 00:20:15.000000', 'temperatura', 433.0000, 'ºC'),
	(180781, 121, '2014-02-01 00:20:16.000000', 'temperatura', 915.0000, 'ºC'),
	(180782, 121, '2014-02-01 00:20:17.000000', 'temperatura', 879.0000, 'ºC'),
	(180783, 121, '2014-02-01 00:20:18.000000', 'temperatura', 449.0000, 'ºC'),
	(180784, 121, '2014-02-01 00:20:19.000000', 'temperatura', 809.0000, 'ºC'),
	(180785, 121, '2014-02-01 00:20:20.000000', 'temperatura', 300.0000, 'ºC'),
	(180786, 121, '2014-02-01 00:20:21.000000', 'temperatura', 273.0000, 'ºC'),
	(180787, 121, '2014-02-01 00:20:22.000000', 'temperatura', 467.0000, 'ºC'),
	(180788, 121, '2014-02-01 00:20:23.000000', 'temperatura', 313.0000, 'ºC'),
	(180789, 121, '2014-02-01 00:20:24.000000', 'temperatura', 166.0000, 'ºC'),
	(180790, 121, '2014-02-01 00:20:25.000000', 'temperatura', 1093.0000, 'ºC'),
	(180791, 121, '2014-02-01 00:20:26.000000', 'temperatura', 167.0000, 'ºC'),
	(180792, 121, '2014-02-01 00:20:27.000000', 'temperatura', 1155.0000, 'ºC'),
	(180793, 121, '2014-02-01 00:20:28.000000', 'temperatura', 474.0000, 'ºC'),
	(180794, 121, '2014-02-01 00:20:29.000000', 'temperatura', 105.0000, 'ºC'),
	(180795, 121, '2014-02-01 00:20:30.000000', 'temperatura', 305.0000, 'ºC'),
	(180796, 121, '2014-02-01 00:20:31.000000', 'temperatura', 12.0000, 'ºC'),
	(180797, 121, '2014-02-01 00:20:32.000000', 'temperatura', 343.0000, 'ºC'),
	(180798, 121, '2014-02-01 00:20:33.000000', 'temperatura', 481.0000, 'ºC'),
	(180799, 121, '2014-02-01 00:20:34.000000', 'temperatura', 176.0000, 'ºC'),
	(180800, 121, '2014-02-01 00:20:35.000000', 'temperatura', 637.0000, 'ºC'),
	(180801, 121, '2014-02-01 00:20:36.000000', 'temperatura', 257.0000, 'ºC'),
	(180802, 121, '2014-02-01 00:20:37.000000', 'temperatura', 576.0000, 'ºC'),
	(180803, 121, '2014-02-01 00:20:38.000000', 'temperatura', 909.0000, 'ºC'),
	(180804, 121, '2014-02-01 00:20:39.000000', 'temperatura', 417.0000, 'ºC'),
	(180805, 121, '2014-02-01 00:20:40.000000', 'temperatura', 559.0000, 'ºC'),
	(180806, 121, '2014-02-01 00:20:41.000000', 'temperatura', 343.0000, 'ºC'),
	(180807, 121, '2014-02-01 00:20:42.000000', 'temperatura', 39.0000, 'ºC'),
	(180808, 121, '2014-02-01 00:20:43.000000', 'temperatura', 369.0000, 'ºC'),
	(180809, 121, '2014-02-01 00:20:44.000000', 'temperatura', 526.0000, 'ºC'),
	(180810, 121, '2014-02-01 00:20:45.000000', 'temperatura', 325.0000, 'ºC'),
	(180811, 121, '2014-02-01 00:20:46.000000', 'temperatura', 46.0000, 'ºC'),
	(180812, 121, '2014-02-01 00:20:47.000000', 'temperatura', 456.0000, 'ºC'),
	(180813, 121, '2014-02-01 00:20:48.000000', 'temperatura', 943.0000, 'ºC'),
	(180814, 121, '2014-02-01 00:20:49.000000', 'temperatura', 945.0000, 'ºC'),
	(180815, 121, '2014-02-01 00:20:50.000000', 'temperatura', 700.0000, 'ºC'),
	(180816, 121, '2014-02-01 00:20:51.000000', 'temperatura', 663.0000, 'ºC'),
	(180817, 121, '2014-02-01 00:20:52.000000', 'temperatura', 18.0000, 'ºC'),
	(180818, 121, '2014-02-01 00:20:53.000000', 'temperatura', 499.0000, 'ºC'),
	(180819, 121, '2014-02-01 00:20:54.000000', 'temperatura', 42.0000, 'ºC'),
	(180820, 121, '2014-02-01 00:20:55.000000', 'temperatura', 1113.0000, 'ºC'),
	(180821, 121, '2014-02-01 00:20:56.000000', 'temperatura', 640.0000, 'ºC'),
	(180822, 121, '2014-02-01 00:20:57.000000', 'temperatura', 1060.0000, 'ºC'),
	(180823, 121, '2014-02-01 00:20:58.000000', 'temperatura', 980.0000, 'ºC'),
	(180824, 121, '2014-02-01 00:20:59.000000', 'temperatura', 520.0000, 'ºC'),
	(180825, 121, '2014-02-01 00:21:00.000000', 'temperatura', 861.0000, 'ºC'),
	(180826, 121, '2014-02-01 00:21:01.000000', 'temperatura', 344.0000, 'ºC'),
	(180827, 121, '2014-02-01 00:21:02.000000', 'temperatura', 340.0000, 'ºC'),
	(180828, 121, '2014-02-01 00:21:03.000000', 'temperatura', 669.0000, 'ºC'),
	(180829, 121, '2014-02-01 00:21:04.000000', 'temperatura', 1124.0000, 'ºC'),
	(180830, 121, '2014-02-01 00:21:05.000000', 'temperatura', 13.0000, 'ºC'),
	(180831, 121, '2014-02-01 00:21:06.000000', 'temperatura', 294.0000, 'ºC'),
	(180832, 121, '2014-02-01 00:21:07.000000', 'temperatura', 232.0000, 'ºC'),
	(180833, 121, '2014-02-01 00:21:08.000000', 'temperatura', 277.0000, 'ºC'),
	(180834, 121, '2014-02-01 00:21:09.000000', 'temperatura', 692.0000, 'ºC'),
	(180835, 121, '2014-02-01 00:21:10.000000', 'temperatura', 228.0000, 'ºC'),
	(180836, 121, '2014-02-01 00:21:11.000000', 'temperatura', 265.0000, 'ºC'),
	(180837, 121, '2014-02-01 00:21:12.000000', 'temperatura', 640.0000, 'ºC'),
	(180838, 121, '2014-02-01 00:21:13.000000', 'temperatura', 6.0000, 'ºC'),
	(180839, 121, '2014-02-01 00:21:14.000000', 'temperatura', 511.0000, 'ºC'),
	(180840, 121, '2014-02-01 00:21:15.000000', 'temperatura', 138.0000, 'ºC'),
	(180841, 121, '2014-02-01 00:21:16.000000', 'temperatura', 356.0000, 'ºC'),
	(180842, 121, '2014-02-01 00:21:17.000000', 'temperatura', 169.0000, 'ºC'),
	(180843, 121, '2014-02-01 00:21:18.000000', 'temperatura', 975.0000, 'ºC'),
	(180844, 121, '2014-02-01 00:21:19.000000', 'temperatura', 771.0000, 'ºC'),
	(180845, 121, '2014-02-01 00:21:20.000000', 'temperatura', 929.0000, 'ºC'),
	(180846, 121, '2014-02-01 00:21:21.000000', 'temperatura', 1132.0000, 'ºC'),
	(180847, 121, '2014-02-01 00:21:22.000000', 'temperatura', 474.0000, 'ºC'),
	(180848, 121, '2014-02-01 00:21:23.000000', 'temperatura', 174.0000, 'ºC'),
	(180849, 121, '2014-02-01 00:21:24.000000', 'temperatura', 651.0000, 'ºC'),
	(180850, 121, '2014-02-01 00:21:25.000000', 'temperatura', 332.0000, 'ºC'),
	(180851, 121, '2014-02-01 00:21:26.000000', 'temperatura', 907.0000, 'ºC'),
	(180852, 121, '2014-02-01 00:21:27.000000', 'temperatura', 1142.0000, 'ºC'),
	(180853, 121, '2014-02-01 00:21:28.000000', 'temperatura', 587.0000, 'ºC'),
	(180854, 121, '2014-02-01 00:21:29.000000', 'temperatura', 711.0000, 'ºC'),
	(180855, 121, '2014-02-01 00:21:30.000000', 'temperatura', 594.0000, 'ºC'),
	(180856, 121, '2014-02-01 00:21:31.000000', 'temperatura', 839.0000, 'ºC'),
	(180857, 121, '2014-02-01 00:21:32.000000', 'temperatura', 11.0000, 'ºC'),
	(180858, 121, '2014-02-01 00:21:33.000000', 'temperatura', 1138.0000, 'ºC'),
	(180859, 121, '2014-02-01 00:21:34.000000', 'temperatura', 857.0000, 'ºC'),
	(180860, 121, '2014-02-01 00:21:35.000000', 'temperatura', 874.0000, 'ºC'),
	(180861, 121, '2014-02-01 00:21:36.000000', 'temperatura', 600.0000, 'ºC'),
	(180862, 121, '2014-02-01 00:21:37.000000', 'temperatura', 377.0000, 'ºC'),
	(180863, 121, '2014-02-01 00:21:38.000000', 'temperatura', 87.0000, 'ºC'),
	(180864, 121, '2014-02-01 00:21:39.000000', 'temperatura', 505.0000, 'ºC'),
	(180865, 121, '2014-02-01 00:21:40.000000', 'temperatura', 1065.0000, 'ºC'),
	(180866, 121, '2014-02-01 00:21:41.000000', 'temperatura', 208.0000, 'ºC'),
	(180867, 121, '2014-02-01 00:21:42.000000', 'temperatura', 248.0000, 'ºC'),
	(180868, 121, '2014-02-01 00:21:43.000000', 'temperatura', 614.0000, 'ºC'),
	(180869, 121, '2014-02-01 00:21:44.000000', 'temperatura', 1127.0000, 'ºC'),
	(180870, 121, '2014-02-01 00:21:45.000000', 'temperatura', 193.0000, 'ºC'),
	(180871, 121, '2014-02-01 00:21:46.000000', 'temperatura', 1184.0000, 'ºC'),
	(180872, 121, '2014-02-01 00:21:47.000000', 'temperatura', 542.0000, 'ºC'),
	(180873, 121, '2014-02-01 00:21:48.000000', 'temperatura', 358.0000, 'ºC'),
	(180874, 121, '2014-02-01 00:21:49.000000', 'temperatura', 167.0000, 'ºC'),
	(180875, 121, '2014-02-01 00:21:50.000000', 'temperatura', 960.0000, 'ºC'),
	(180876, 121, '2014-02-01 00:21:51.000000', 'temperatura', 698.0000, 'ºC'),
	(180877, 121, '2014-02-01 00:21:52.000000', 'temperatura', 614.0000, 'ºC'),
	(180878, 121, '2014-02-01 00:21:53.000000', 'temperatura', 973.0000, 'ºC'),
	(180879, 121, '2014-02-01 00:21:54.000000', 'temperatura', 623.0000, 'ºC'),
	(180880, 121, '2014-02-01 00:21:55.000000', 'temperatura', 200.0000, 'ºC'),
	(180881, 121, '2014-02-01 00:21:56.000000', 'temperatura', 329.0000, 'ºC'),
	(180882, 121, '2014-02-01 00:21:57.000000', 'temperatura', 1046.0000, 'ºC'),
	(180883, 121, '2014-02-01 00:21:58.000000', 'temperatura', 643.0000, 'ºC'),
	(180884, 121, '2014-02-01 00:21:59.000000', 'temperatura', 79.0000, 'ºC'),
	(180885, 121, '2014-02-01 00:22:00.000000', 'temperatura', 867.0000, 'ºC'),
	(180886, 121, '2014-02-01 00:22:01.000000', 'temperatura', 496.0000, 'ºC'),
	(180887, 121, '2014-02-01 00:22:02.000000', 'temperatura', 1082.0000, 'ºC'),
	(180888, 121, '2014-02-01 00:22:03.000000', 'temperatura', 320.0000, 'ºC'),
	(180889, 121, '2014-02-01 00:22:04.000000', 'temperatura', 756.0000, 'ºC'),
	(180890, 121, '2014-02-01 00:22:05.000000', 'temperatura', 418.0000, 'ºC'),
	(180891, 121, '2014-02-01 00:22:06.000000', 'temperatura', 1025.0000, 'ºC'),
	(180892, 121, '2014-02-01 00:22:07.000000', 'temperatura', 271.0000, 'ºC'),
	(180893, 121, '2014-02-01 00:22:08.000000', 'temperatura', 681.0000, 'ºC'),
	(180894, 121, '2014-02-01 00:22:09.000000', 'temperatura', 191.0000, 'ºC'),
	(180895, 121, '2014-02-01 00:22:10.000000', 'temperatura', 112.0000, 'ºC'),
	(180896, 121, '2014-02-01 00:22:11.000000', 'temperatura', 1188.0000, 'ºC'),
	(180897, 121, '2014-02-01 00:22:12.000000', 'temperatura', 804.0000, 'ºC'),
	(180898, 121, '2014-02-01 00:22:13.000000', 'temperatura', 458.0000, 'ºC'),
	(180899, 121, '2014-02-01 00:22:14.000000', 'temperatura', 1078.0000, 'ºC'),
	(180900, 121, '2014-02-01 00:22:15.000000', 'temperatura', 418.0000, 'ºC'),
	(180901, 121, '2014-02-01 00:22:16.000000', 'temperatura', 54.0000, 'ºC'),
	(180902, 121, '2014-02-01 00:22:17.000000', 'temperatura', 217.0000, 'ºC'),
	(180903, 121, '2014-02-01 00:22:18.000000', 'temperatura', 923.0000, 'ºC'),
	(180904, 121, '2014-02-01 00:22:19.000000', 'temperatura', 364.0000, 'ºC'),
	(180905, 121, '2014-02-01 00:22:20.000000', 'temperatura', 253.0000, 'ºC'),
	(180906, 121, '2014-02-01 00:22:21.000000', 'temperatura', 174.0000, 'ºC'),
	(180907, 121, '2014-02-01 00:22:22.000000', 'temperatura', 113.0000, 'ºC'),
	(180908, 121, '2014-02-01 00:22:23.000000', 'temperatura', 41.0000, 'ºC'),
	(180909, 121, '2014-02-01 00:22:24.000000', 'temperatura', 1069.0000, 'ºC'),
	(180910, 121, '2014-02-01 00:22:25.000000', 'temperatura', 421.0000, 'ºC'),
	(180911, 121, '2014-02-01 00:22:26.000000', 'temperatura', 97.0000, 'ºC'),
	(180912, 121, '2014-02-01 00:22:27.000000', 'temperatura', 424.0000, 'ºC'),
	(180913, 121, '2014-02-01 00:22:28.000000', 'temperatura', 631.0000, 'ºC'),
	(180914, 121, '2014-02-01 00:22:29.000000', 'temperatura', 683.0000, 'ºC'),
	(180915, 121, '2014-02-01 00:22:30.000000', 'temperatura', 322.0000, 'ºC'),
	(180916, 121, '2014-02-01 00:22:31.000000', 'temperatura', 761.0000, 'ºC'),
	(180917, 121, '2014-02-01 00:22:32.000000', 'temperatura', 441.0000, 'ºC'),
	(180918, 121, '2014-02-01 00:22:33.000000', 'temperatura', 1122.0000, 'ºC'),
	(180919, 121, '2014-02-01 00:22:34.000000', 'temperatura', 689.0000, 'ºC'),
	(180920, 121, '2014-02-01 00:22:35.000000', 'temperatura', 77.0000, 'ºC'),
	(180921, 121, '2014-02-01 00:22:36.000000', 'temperatura', 720.0000, 'ºC'),
	(180922, 121, '2014-02-01 00:22:37.000000', 'temperatura', 967.0000, 'ºC'),
	(180923, 121, '2014-02-01 00:22:38.000000', 'temperatura', 279.0000, 'ºC'),
	(180924, 121, '2014-02-01 00:22:39.000000', 'temperatura', 893.0000, 'ºC'),
	(180925, 121, '2014-02-01 00:22:40.000000', 'temperatura', 27.0000, 'ºC'),
	(180926, 121, '2014-02-01 00:22:41.000000', 'temperatura', 1057.0000, 'ºC'),
	(180927, 121, '2014-02-01 00:22:42.000000', 'temperatura', 404.0000, 'ºC'),
	(180928, 121, '2014-02-01 00:22:43.000000', 'temperatura', 48.0000, 'ºC'),
	(180929, 121, '2014-02-01 00:22:44.000000', 'temperatura', 231.0000, 'ºC'),
	(180930, 121, '2014-02-01 00:22:45.000000', 'temperatura', 1011.0000, 'ºC'),
	(180931, 121, '2014-02-01 00:22:46.000000', 'temperatura', 760.0000, 'ºC'),
	(180932, 121, '2014-02-01 00:22:47.000000', 'temperatura', 770.0000, 'ºC'),
	(180933, 121, '2014-02-01 00:22:48.000000', 'temperatura', 371.0000, 'ºC'),
	(180934, 121, '2014-02-01 00:22:49.000000', 'temperatura', 745.0000, 'ºC'),
	(180935, 121, '2014-02-01 00:22:50.000000', 'temperatura', 211.0000, 'ºC'),
	(180936, 121, '2014-02-01 00:22:51.000000', 'temperatura', 22.0000, 'ºC'),
	(180937, 121, '2014-02-01 00:22:52.000000', 'temperatura', 679.0000, 'ºC'),
	(180938, 121, '2014-02-01 00:22:53.000000', 'temperatura', 928.0000, 'ºC'),
	(180939, 121, '2014-02-01 00:22:54.000000', 'temperatura', 204.0000, 'ºC'),
	(180940, 121, '2014-02-01 00:22:55.000000', 'temperatura', 636.0000, 'ºC'),
	(180941, 121, '2014-02-01 00:22:56.000000', 'temperatura', 169.0000, 'ºC'),
	(180942, 121, '2014-02-01 00:22:57.000000', 'temperatura', 139.0000, 'ºC'),
	(180943, 121, '2014-02-01 00:22:58.000000', 'temperatura', 188.0000, 'ºC'),
	(180944, 121, '2014-02-01 00:22:59.000000', 'temperatura', 525.0000, 'ºC'),
	(180945, 121, '2014-02-01 00:23:00.000000', 'temperatura', 859.0000, 'ºC'),
	(180946, 121, '2014-02-01 00:23:01.000000', 'temperatura', 319.0000, 'ºC'),
	(180947, 121, '2014-02-01 00:23:02.000000', 'temperatura', 222.0000, 'ºC'),
	(180948, 121, '2014-02-01 00:23:03.000000', 'temperatura', 153.0000, 'ºC'),
	(180949, 121, '2014-02-01 00:23:04.000000', 'temperatura', 100.0000, 'ºC'),
	(180950, 121, '2014-02-01 00:23:05.000000', 'temperatura', 39.0000, 'ºC'),
	(180951, 121, '2014-02-01 00:23:06.000000', 'temperatura', 1098.0000, 'ºC'),
	(180952, 121, '2014-02-01 00:23:07.000000', 'temperatura', 571.0000, 'ºC'),
	(180953, 121, '2014-02-01 00:23:08.000000', 'temperatura', 761.0000, 'ºC'),
	(180954, 121, '2014-02-01 00:23:09.000000', 'temperatura', 894.0000, 'ºC'),
	(180955, 121, '2014-02-01 00:23:10.000000', 'temperatura', 988.0000, 'ºC'),
	(180956, 121, '2014-02-01 00:23:11.000000', 'temperatura', 1056.0000, 'ºC'),
	(180957, 121, '2014-02-01 00:23:12.000000', 'temperatura', 1120.0000, 'ºC'),
	(180958, 121, '2014-02-01 00:23:13.000000', 'temperatura', 29.0000, 'ºC'),
	(180959, 121, '2014-02-01 00:23:14.000000', 'temperatura', 388.0000, 'ºC'),
	(180960, 121, '2014-02-01 00:23:15.000000', 'temperatura', 653.0000, 'ºC'),
	(180961, 121, '2014-02-01 00:23:16.000000', 'temperatura', 902.0000, 'ºC'),
	(180962, 121, '2014-02-01 00:23:17.000000', 'temperatura', 152.0000, 'ºC'),
	(180963, 121, '2014-02-01 00:23:18.000000', 'temperatura', 454.0000, 'ºC'),
	(180964, 121, '2014-02-01 00:23:19.000000', 'temperatura', 614.0000, 'ºC'),
	(180965, 121, '2014-02-01 00:23:20.000000', 'temperatura', 508.0000, 'ºC'),
	(180966, 121, '2014-02-01 00:23:21.000000', 'temperatura', 700.0000, 'ºC'),
	(180967, 121, '2014-02-01 00:23:22.000000', 'temperatura', 775.0000, 'ºC'),
	(180968, 121, '2014-02-01 00:23:23.000000', 'temperatura', 574.0000, 'ºC'),
	(180969, 121, '2014-02-01 00:23:24.000000', 'temperatura', 548.0000, 'ºC'),
	(180970, 121, '2014-02-01 00:23:25.000000', 'temperatura', 1017.0000, 'ºC'),
	(180971, 121, '2014-02-01 00:23:26.000000', 'temperatura', 1041.0000, 'ºC'),
	(180972, 121, '2014-02-01 00:23:27.000000', 'temperatura', 956.0000, 'ºC'),
	(180973, 121, '2014-02-01 00:23:28.000000', 'temperatura', 456.0000, 'ºC'),
	(180974, 121, '2014-02-01 00:23:29.000000', 'temperatura', 613.0000, 'ºC'),
	(180975, 121, '2014-02-01 00:23:30.000000', 'temperatura', 497.0000, 'ºC'),
	(180976, 121, '2014-02-01 00:23:31.000000', 'temperatura', 645.0000, 'ºC'),
	(180977, 121, '2014-02-01 00:23:32.000000', 'temperatura', 536.0000, 'ºC'),
	(180978, 121, '2014-02-01 00:23:33.000000', 'temperatura', 745.0000, 'ºC'),
	(180979, 121, '2014-02-01 00:23:34.000000', 'temperatura', 919.0000, 'ºC'),
	(180980, 121, '2014-02-01 00:23:35.000000', 'temperatura', 1158.0000, 'ºC'),
	(180981, 121, '2014-02-01 00:23:36.000000', 'temperatura', 635.0000, 'ºC'),
	(180982, 121, '2014-02-01 00:23:37.000000', 'temperatura', 900.0000, 'ºC'),
	(180983, 121, '2014-02-01 00:23:38.000000', 'temperatura', 198.0000, 'ºC'),
	(180984, 121, '2014-02-01 00:23:39.000000', 'temperatura', 689.0000, 'ºC'),
	(180985, 121, '2014-02-01 00:23:40.000000', 'temperatura', 451.0000, 'ºC'),
	(180986, 121, '2014-02-01 00:23:41.000000', 'temperatura', 190.0000, 'ºC'),
	(180987, 121, '2014-02-01 00:23:42.000000', 'temperatura', 797.0000, 'ºC'),
	(180988, 121, '2014-02-01 00:23:43.000000', 'temperatura', 1017.0000, 'ºC'),
	(180989, 121, '2014-02-01 00:23:44.000000', 'temperatura', 295.0000, 'ºC'),
	(180990, 121, '2014-02-01 00:23:45.000000', 'temperatura', 825.0000, 'ºC'),
	(180991, 121, '2014-02-01 00:23:46.000000', 'temperatura', 837.0000, 'ºC'),
	(180992, 121, '2014-02-01 00:23:47.000000', 'temperatura', 514.0000, 'ºC'),
	(180993, 121, '2014-02-01 00:23:48.000000', 'temperatura', 57.0000, 'ºC'),
	(180994, 121, '2014-02-01 00:23:49.000000', 'temperatura', 1146.0000, 'ºC'),
	(180995, 121, '2014-02-01 00:23:50.000000', 'temperatura', 758.0000, 'ºC'),
	(180996, 121, '2014-02-01 00:23:51.000000', 'temperatura', 352.0000, 'ºC'),
	(180997, 121, '2014-02-01 00:23:52.000000', 'temperatura', 688.0000, 'ºC'),
	(180998, 121, '2014-02-01 00:23:53.000000', 'temperatura', 1186.0000, 'ºC'),
	(180999, 121, '2014-02-01 00:23:54.000000', 'temperatura', 264.0000, 'ºC'),
	(181000, 121, '2014-02-01 00:23:55.000000', 'temperatura', 163.0000, 'ºC'),
	(181001, 121, '2014-02-01 00:23:56.000000', 'temperatura', 26.0000, 'ºC'),
	(181002, 121, '2014-02-01 00:23:57.000000', 'temperatura', 838.0000, 'ºC'),
	(181003, 121, '2014-02-01 00:23:58.000000', 'temperatura', 515.0000, 'ºC'),
	(181004, 121, '2014-02-01 00:23:59.000000', 'temperatura', 60.0000, 'ºC'),
	(181005, 121, '2014-02-01 00:24:00.000000', 'temperatura', 1156.0000, 'ºC'),
	(181006, 121, '2014-02-01 00:24:01.000000', 'temperatura', 798.0000, 'ºC'),
	(181007, 121, '2014-02-01 00:24:02.000000', 'temperatura', 526.0000, 'ºC'),
	(181008, 121, '2014-02-01 00:24:03.000000', 'temperatura', 235.0000, 'ºC'),
	(181009, 121, '2014-02-01 00:24:04.000000', 'temperatura', 797.0000, 'ºC'),
	(181010, 121, '2014-02-01 00:24:05.000000', 'temperatura', 880.0000, 'ºC'),
	(181011, 121, '2014-02-01 00:24:06.000000', 'temperatura', 810.0000, 'ºC'),
	(181012, 121, '2014-02-01 00:24:07.000000', 'temperatura', 212.0000, 'ºC'),
	(181013, 121, '2014-02-01 00:24:08.000000', 'temperatura', 1032.0000, 'ºC'),
	(181014, 121, '2014-02-01 00:24:09.000000', 'temperatura', 921.0000, 'ºC'),
	(181015, 121, '2014-02-01 00:24:10.000000', 'temperatura', 311.0000, 'ºC'),
	(181016, 121, '2014-02-01 00:24:11.000000', 'temperatura', 1192.0000, 'ºC'),
	(181017, 121, '2014-02-01 00:24:12.000000', 'temperatura', 226.0000, 'ºC'),
	(181018, 121, '2014-02-01 00:24:13.000000', 'temperatura', 1155.0000, 'ºC'),
	(181019, 121, '2014-02-01 00:24:14.000000', 'temperatura', 298.0000, 'ºC'),
	(181020, 121, '2014-02-01 00:24:15.000000', 'temperatura', 426.0000, 'ºC'),
	(181021, 121, '2014-02-01 00:24:16.000000', 'temperatura', 36.0000, 'ºC'),
	(181022, 121, '2014-02-01 00:24:17.000000', 'temperatura', 103.0000, 'ºC'),
	(181023, 121, '2014-02-01 00:24:18.000000', 'temperatura', 407.0000, 'ºC'),
	(181024, 121, '2014-02-01 00:24:19.000000', 'temperatura', 527.0000, 'ºC'),
	(181025, 121, '2014-02-01 00:24:20.000000', 'temperatura', 214.0000, 'ºC'),
	(181026, 121, '2014-02-01 00:24:21.000000', 'temperatura', 688.0000, 'ºC'),
	(181027, 121, '2014-02-01 00:24:22.000000', 'temperatura', 398.0000, 'ºC'),
	(181028, 121, '2014-02-01 00:24:23.000000', 'temperatura', 1128.0000, 'ºC'),
	(181029, 121, '2014-02-01 00:24:24.000000', 'temperatura', 847.0000, 'ºC'),
	(181030, 121, '2014-02-01 00:24:25.000000', 'temperatura', 849.0000, 'ºC'),
	(181031, 121, '2014-02-01 00:24:26.000000', 'temperatura', 506.0000, 'ºC'),
	(181032, 121, '2014-02-01 00:24:27.000000', 'temperatura', 1185.0000, 'ºC'),
	(181033, 121, '2014-02-01 00:24:28.000000', 'temperatura', 807.0000, 'ºC'),
	(181034, 121, '2014-02-01 00:24:29.000000', 'temperatura', 480.0000, 'ºC'),
	(181035, 121, '2014-02-01 00:24:30.000000', 'temperatura', 1181.0000, 'ºC'),
	(181036, 121, '2014-02-01 00:24:31.000000', 'temperatura', 865.0000, 'ºC'),
	(181037, 121, '2014-02-01 00:24:32.000000', 'temperatura', 782.0000, 'ºC'),
	(181038, 121, '2014-02-01 00:24:33.000000', 'temperatura', 118.0000, 'ºC'),
	(181039, 121, '2014-02-01 00:24:34.000000', 'temperatura', 642.0000, 'ºC'),
	(181040, 121, '2014-02-01 00:24:35.000000', 'temperatura', 456.0000, 'ºC'),
	(181041, 121, '2014-02-01 00:24:36.000000', 'temperatura', 355.0000, 'ºC'),
	(181042, 121, '2014-02-01 00:24:37.000000', 'temperatura', 406.0000, 'ºC'),
	(181043, 121, '2014-02-01 00:24:38.000000', 'temperatura', 968.0000, 'ºC'),
	(181044, 121, '2014-02-01 00:24:39.000000', 'temperatura', 20.0000, 'ºC'),
	(181045, 121, '2014-02-01 00:24:40.000000', 'temperatura', 798.0000, 'ºC'),
	(181046, 121, '2014-02-01 00:24:41.000000', 'temperatura', 330.0000, 'ºC'),
	(181047, 121, '2014-02-01 00:24:42.000000', 'temperatura', 458.0000, 'ºC'),
	(181048, 121, '2014-02-01 00:24:43.000000', 'temperatura', 99.0000, 'ºC'),
	(181049, 121, '2014-02-01 00:24:44.000000', 'temperatura', 321.0000, 'ºC'),
	(181050, 121, '2014-02-01 00:24:45.000000', 'temperatura', 111.0000, 'ºC'),
	(181051, 121, '2014-02-01 00:24:46.000000', 'temperatura', 791.0000, 'ºC'),
	(181052, 121, '2014-02-01 00:24:47.000000', 'temperatura', 22.0000, 'ºC'),
	(181053, 121, '2014-02-01 00:24:48.000000', 'temperatura', 137.0000, 'ºC'),
	(181054, 121, '2014-02-01 00:24:49.000000', 'temperatura', 620.0000, 'ºC'),
	(181055, 121, '2014-02-01 00:24:50.000000', 'temperatura', 289.0000, 'ºC'),
	(181056, 121, '2014-02-01 00:24:51.000000', 'temperatura', 788.0000, 'ºC'),
	(181057, 121, '2014-02-01 00:24:52.000000', 'temperatura', 672.0000, 'ºC'),
	(181058, 121, '2014-02-01 00:24:53.000000', 'temperatura', 995.0000, 'ºC'),
	(181059, 121, '2014-02-01 00:24:54.000000', 'temperatura', 559.0000, 'ºC'),
	(181060, 121, '2014-02-01 00:24:55.000000', 'temperatura', 1012.0000, 'ºC'),
	(181061, 121, '2014-02-01 00:24:56.000000', 'temperatura', 982.0000, 'ºC'),
	(181062, 121, '2014-02-01 00:24:57.000000', 'temperatura', 676.0000, 'ºC'),
	(181063, 121, '2014-02-01 00:24:58.000000', 'temperatura', 435.0000, 'ºC'),
	(181064, 121, '2014-02-01 00:24:59.000000', 'temperatura', 147.0000, 'ºC'),
	(181065, 121, '2014-02-01 00:25:00.000000', 'temperatura', 630.0000, 'ºC'),
	(181066, 121, '2014-02-01 00:25:01.000000', 'temperatura', 309.0000, 'ºC'),
	(181067, 121, '2014-02-01 00:25:02.000000', 'temperatura', 856.0000, 'ºC'),
	(181068, 121, '2014-02-01 00:25:03.000000', 'temperatura', 952.0000, 'ºC'),
	(181069, 121, '2014-02-01 00:25:04.000000', 'temperatura', 994.0000, 'ºC'),
	(181070, 121, '2014-02-01 00:25:05.000000', 'temperatura', 912.0000, 'ºC'),
	(181071, 121, '2014-02-01 00:25:06.000000', 'temperatura', 382.0000, 'ºC'),
	(181072, 121, '2014-02-01 00:25:07.000000', 'temperatura', 373.0000, 'ºC'),
	(181073, 121, '2014-02-01 00:25:08.000000', 'temperatura', 717.0000, 'ºC'),
	(181074, 121, '2014-02-01 00:25:09.000000', 'temperatura', 70.0000, 'ºC'),
	(181075, 121, '2014-02-01 00:25:10.000000', 'temperatura', 600.0000, 'ºC'),
	(181076, 121, '2014-02-01 00:25:11.000000', 'temperatura', 389.0000, 'ºC'),
	(181077, 121, '2014-02-01 00:25:12.000000', 'temperatura', 145.0000, 'ºC'),
	(181078, 121, '2014-02-01 00:25:13.000000', 'temperatura', 761.0000, 'ºC'),
	(181079, 121, '2014-02-01 00:25:14.000000', 'temperatura', 970.0000, 'ºC'),
	(181080, 121, '2014-02-01 00:25:15.000000', 'temperatura', 165.0000, 'ºC'),
	(181081, 121, '2014-02-01 00:25:16.000000', 'temperatura', 317.0000, 'ºC'),
	(181082, 121, '2014-02-01 00:25:17.000000', 'temperatura', 1089.0000, 'ºC'),
	(181083, 121, '2014-02-01 00:25:18.000000', 'temperatura', 896.0000, 'ºC'),
	(181084, 121, '2014-02-01 00:25:19.000000', 'temperatura', 13.0000, 'ºC'),
	(181085, 121, '2014-02-01 00:25:20.000000', 'temperatura', 976.0000, 'ºC'),
	(181086, 121, '2014-02-01 00:25:21.000000', 'temperatura', 42.0000, 'ºC'),
	(181087, 121, '2014-02-01 00:25:22.000000', 'temperatura', 882.0000, 'ºC'),
	(181088, 121, '2014-02-01 00:25:23.000000', 'temperatura', 684.0000, 'ºC'),
	(181089, 121, '2014-02-01 00:25:24.000000', 'temperatura', 774.0000, 'ºC'),
	(181090, 121, '2014-02-01 00:25:25.000000', 'temperatura', 620.0000, 'ºC'),
	(181091, 121, '2014-02-01 00:25:26.000000', 'temperatura', 780.0000, 'ºC'),
	(181092, 121, '2014-02-01 00:25:27.000000', 'temperatura', 839.0000, 'ºC'),
	(181093, 121, '2014-02-01 00:25:28.000000', 'temperatura', 656.0000, 'ºC'),
	(181094, 121, '2014-02-01 00:25:29.000000', 'temperatura', 761.0000, 'ºC'),
	(181095, 121, '2014-02-01 00:25:30.000000', 'temperatura', 641.0000, 'ºC'),
	(181096, 121, '2014-02-01 00:25:31.000000', 'temperatura', 921.0000, 'ºC'),
	(181097, 121, '2014-02-01 00:25:32.000000', 'temperatura', 283.0000, 'ºC'),
	(181098, 121, '2014-02-01 00:25:33.000000', 'temperatura', 1051.0000, 'ºC'),
	(181099, 121, '2014-02-01 00:25:34.000000', 'temperatura', 807.0000, 'ºC'),
	(181100, 121, '2014-02-01 00:25:35.000000', 'temperatura', 885.0000, 'ºC'),
	(181101, 121, '2014-02-01 00:25:36.000000', 'temperatura', 801.0000, 'ºC'),
	(181102, 121, '2014-02-01 00:25:37.000000', 'temperatura', 154.0000, 'ºC'),
	(181103, 121, '2014-02-01 00:25:38.000000', 'temperatura', 765.0000, 'ºC'),
	(181104, 121, '2014-02-01 00:25:39.000000', 'temperatura', 965.0000, 'ºC'),
	(181105, 121, '2014-02-01 00:25:40.000000', 'temperatura', 130.0000, 'ºC'),
	(181106, 121, '2014-02-01 00:25:41.000000', 'temperatura', 154.0000, 'ºC'),
	(181107, 121, '2014-02-01 00:25:42.000000', 'temperatura', 380.0000, 'ºC'),
	(181108, 121, '2014-02-01 00:25:43.000000', 'temperatura', 238.0000, 'ºC'),
	(181109, 121, '2014-02-01 00:25:44.000000', 'temperatura', 53.0000, 'ºC'),
	(181110, 121, '2014-02-01 00:25:45.000000', 'temperatura', 752.0000, 'ºC'),
	(181111, 121, '2014-02-01 00:25:46.000000', 'temperatura', 2.0000, 'ºC'),
	(181112, 121, '2014-02-01 00:25:47.000000', 'temperatura', 152.0000, 'ºC'),
	(181113, 121, '2014-02-01 00:25:48.000000', 'temperatura', 757.0000, 'ºC'),
	(181114, 121, '2014-02-01 00:25:49.000000', 'temperatura', 929.0000, 'ºC'),
	(181115, 121, '2014-02-01 00:25:50.000000', 'temperatura', 1175.0000, 'ºC'),
	(181116, 121, '2014-02-01 00:25:51.000000', 'temperatura', 687.0000, 'ºC'),
	(181117, 121, '2014-02-01 00:25:52.000000', 'temperatura', 1112.0000, 'ºC'),
	(181118, 121, '2014-02-01 00:25:53.000000', 'temperatura', 1099.0000, 'ºC'),
	(181119, 121, '2014-02-01 00:25:54.000000', 'temperatura', 957.0000, 'ºC'),
	(181120, 121, '2014-02-01 00:25:55.000000', 'temperatura', 292.0000, 'ºC'),
	(181121, 121, '2014-02-01 00:25:56.000000', 'temperatura', 987.0000, 'ºC'),
	(181122, 121, '2014-02-01 00:25:57.000000', 'temperatura', 462.0000, 'ºC'),
	(181123, 121, '2014-02-01 00:25:58.000000', 'temperatura', 547.0000, 'ºC'),
	(181124, 121, '2014-02-01 00:25:59.000000', 'temperatura', 150.0000, 'ºC'),
	(181125, 121, '2014-02-01 00:26:00.000000', 'temperatura', 309.0000, 'ºC'),
	(181126, 121, '2014-02-01 00:26:01.000000', 'temperatura', 1097.0000, 'ºC'),
	(181127, 121, '2014-02-01 00:26:02.000000', 'temperatura', 957.0000, 'ºC'),
	(181128, 121, '2014-02-01 00:26:03.000000', 'temperatura', 293.0000, 'ºC'),
	(181129, 121, '2014-02-01 00:26:04.000000', 'temperatura', 997.0000, 'ºC'),
	(181130, 121, '2014-02-01 00:26:05.000000', 'temperatura', 506.0000, 'ºC'),
	(181131, 121, '2014-02-01 00:26:06.000000', 'temperatura', 740.0000, 'ºC'),
	(181132, 121, '2014-02-01 00:26:07.000000', 'temperatura', 983.0000, 'ºC'),
	(181133, 121, '2014-02-01 00:26:08.000000', 'temperatura', 296.0000, 'ºC'),
	(181134, 121, '2014-02-01 00:26:09.000000', 'temperatura', 932.0000, 'ºC'),
	(181135, 121, '2014-02-01 00:26:10.000000', 'temperatura', 170.0000, 'ºC'),
	(181136, 121, '2014-02-01 00:26:11.000000', 'temperatura', 456.0000, 'ºC'),
	(181137, 121, '2014-02-01 00:26:12.000000', 'temperatura', 571.0000, 'ºC'),
	(181138, 121, '2014-02-01 00:26:13.000000', 'temperatura', 288.0000, 'ºC'),
	(181139, 121, '2014-02-01 00:26:14.000000', 'temperatura', 927.0000, 'ºC'),
	(181140, 121, '2014-02-01 00:26:15.000000', 'temperatura', 172.0000, 'ºC'),
	(181141, 121, '2014-02-01 00:26:16.000000', 'temperatura', 478.0000, 'ºC'),
	(181142, 121, '2014-02-01 00:26:17.000000', 'temperatura', 677.0000, 'ºC'),
	(181143, 121, '2014-02-01 00:26:18.000000', 'temperatura', 752.0000, 'ºC'),
	(181144, 121, '2014-02-01 00:26:19.000000', 'temperatura', 528.0000, 'ºC'),
	(181145, 121, '2014-02-01 00:26:20.000000', 'temperatura', 383.0000, 'ºC'),
	(181146, 121, '2014-02-01 00:26:21.000000', 'temperatura', 334.0000, 'ºC'),
	(181147, 121, '2014-02-01 00:26:22.000000', 'temperatura', 520.0000, 'ºC'),
	(181148, 121, '2014-02-01 00:26:23.000000', 'temperatura', 397.0000, 'ºC'),
	(181149, 121, '2014-02-01 00:26:24.000000', 'temperatura', 429.0000, 'ºC'),
	(181150, 121, '2014-02-01 00:26:25.000000', 'temperatura', 952.0000, 'ºC'),
	(181151, 121, '2014-02-01 00:26:26.000000', 'temperatura', 1072.0000, 'ºC'),
	(181152, 121, '2014-02-01 00:26:27.000000', 'temperatura', 108.0000, 'ºC'),
	(181153, 121, '2014-02-01 00:26:28.000000', 'temperatura', 923.0000, 'ºC'),
	(181154, 121, '2014-02-01 00:26:29.000000', 'temperatura', 692.0000, 'ºC'),
	(181155, 121, '2014-02-01 00:26:30.000000', 'temperatura', 693.0000, 'ºC'),
	(181156, 121, '2014-02-01 00:26:31.000000', 'temperatura', 188.0000, 'ºC'),
	(181157, 121, '2014-02-01 00:26:32.000000', 'temperatura', 63.0000, 'ºC'),
	(181158, 121, '2014-02-01 00:26:33.000000', 'temperatura', 951.0000, 'ºC'),
	(181159, 121, '2014-02-01 00:26:34.000000', 'temperatura', 968.0000, 'ºC'),
	(181160, 121, '2014-02-01 00:26:35.000000', 'temperatura', 787.0000, 'ºC'),
	(181161, 121, '2014-02-01 00:26:36.000000', 'temperatura', 1031.0000, 'ºC'),
	(181162, 121, '2014-02-01 00:26:37.000000', 'temperatura', 396.0000, 'ºC'),
	(181163, 121, '2014-02-01 00:26:38.000000', 'temperatura', 88.0000, 'ºC'),
	(181164, 121, '2014-02-01 00:26:39.000000', 'temperatura', 452.0000, 'ºC'),
	(181165, 121, '2014-02-01 00:26:40.000000', 'temperatura', 796.0000, 'ºC'),
	(181166, 121, '2014-02-01 00:26:41.000000', 'temperatura', 225.0000, 'ºC'),
	(181167, 121, '2014-02-01 00:26:42.000000', 'temperatura', 1135.0000, 'ºC'),
	(181168, 121, '2014-02-01 00:26:43.000000', 'temperatura', 203.0000, 'ºC'),
	(181169, 121, '2014-02-01 00:26:44.000000', 'temperatura', 10.0000, 'ºC'),
	(181170, 121, '2014-02-01 00:26:45.000000', 'temperatura', 641.0000, 'ºC'),
	(181171, 121, '2014-02-01 00:26:46.000000', 'temperatura', 776.0000, 'ºC'),
	(181172, 121, '2014-02-01 00:26:47.000000', 'temperatura', 756.0000, 'ºC'),
	(181173, 121, '2014-02-01 00:26:48.000000', 'temperatura', 255.0000, 'ºC'),
	(181174, 121, '2014-02-01 00:26:49.000000', 'temperatura', 205.0000, 'ºC'),
	(181175, 121, '2014-02-01 00:26:50.000000', 'temperatura', 263.0000, 'ºC'),
	(181176, 121, '2014-02-01 00:26:51.000000', 'temperatura', 701.0000, 'ºC'),
	(181177, 121, '2014-02-01 00:26:52.000000', 'temperatura', 316.0000, 'ºC'),
	(181178, 121, '2014-02-01 00:26:53.000000', 'temperatura', 677.0000, 'ºC'),
	(181179, 121, '2014-02-01 00:26:54.000000', 'temperatura', 39.0000, 'ºC'),
	(181180, 121, '2014-02-01 00:26:55.000000', 'temperatura', 565.0000, 'ºC'),
	(181181, 121, '2014-02-01 00:26:56.000000', 'temperatura', 309.0000, 'ºC'),
	(181182, 121, '2014-02-01 00:26:57.000000', 'temperatura', 1047.0000, 'ºC'),
	(181183, 121, '2014-02-01 00:26:58.000000', 'temperatura', 712.0000, 'ºC'),
	(181184, 121, '2014-02-01 00:26:59.000000', 'temperatura', 416.0000, 'ºC'),
	(181185, 121, '2014-02-01 00:27:00.000000', 'temperatura', 1147.0000, 'ºC'),
	(181186, 121, '2014-02-01 00:27:01.000000', 'temperatura', 887.0000, 'ºC'),
	(181187, 121, '2014-02-01 00:27:02.000000', 'temperatura', 993.0000, 'ºC'),
	(181188, 121, '2014-02-01 00:27:03.000000', 'temperatura', 1107.0000, 'ºC'),
	(181189, 121, '2014-02-01 00:27:04.000000', 'temperatura', 157.0000, 'ºC'),
	(181190, 121, '2014-02-01 00:27:05.000000', 'temperatura', 1063.0000, 'ºC'),
	(181191, 121, '2014-02-01 00:27:06.000000', 'temperatura', 44.0000, 'ºC'),
	(181192, 121, '2014-02-01 00:27:07.000000', 'temperatura', 634.0000, 'ºC'),
	(181193, 121, '2014-02-01 00:27:08.000000', 'temperatura', 636.0000, 'ºC'),
	(181194, 121, '2014-02-01 00:27:09.000000', 'temperatura', 81.0000, 'ºC'),
	(181195, 121, '2014-02-01 00:27:10.000000', 'temperatura', 897.0000, 'ºC'),
	(181196, 121, '2014-02-01 00:27:11.000000', 'temperatura', 642.0000, 'ºC'),
	(181197, 121, '2014-02-01 00:27:12.000000', 'temperatura', 520.0000, 'ºC'),
	(181198, 121, '2014-02-01 00:27:13.000000', 'temperatura', 675.0000, 'ºC'),
	(181199, 121, '2014-02-01 00:27:14.000000', 'temperatura', 616.0000, 'ºC'),
	(181200, 121, '2014-02-01 00:27:15.000000', 'temperatura', 1057.0000, 'ºC'),
	(181201, 121, '2014-02-01 00:27:16.000000', 'temperatura', 1035.0000, 'ºC'),
	(181202, 121, '2014-02-01 00:27:17.000000', 'temperatura', 803.0000, 'ºC'),
	(181203, 121, '2014-02-01 00:27:18.000000', 'temperatura', 913.0000, 'ºC'),
	(181204, 121, '2014-02-01 00:27:19.000000', 'temperatura', 954.0000, 'ºC'),
	(181205, 121, '2014-02-01 00:27:20.000000', 'temperatura', 834.0000, 'ºC'),
	(181206, 121, '2014-02-01 00:27:21.000000', 'temperatura', 108.0000, 'ºC'),
	(181207, 121, '2014-02-01 00:27:22.000000', 'temperatura', 438.0000, 'ºC'),
	(181208, 121, '2014-02-01 00:27:23.000000', 'temperatura', 666.0000, 'ºC'),
	(181209, 121, '2014-02-01 00:27:24.000000', 'temperatura', 816.0000, 'ºC'),
	(181210, 121, '2014-02-01 00:27:25.000000', 'temperatura', 884.0000, 'ºC'),
	(181211, 121, '2014-02-01 00:27:26.000000', 'temperatura', 772.0000, 'ºC'),
	(181212, 121, '2014-02-01 00:27:27.000000', 'temperatura', 7.0000, 'ºC'),
	(181213, 121, '2014-02-01 00:27:28.000000', 'temperatura', 122.0000, 'ºC'),
	(181214, 121, '2014-02-01 00:27:29.000000', 'temperatura', 590.0000, 'ºC'),
	(181215, 121, '2014-02-01 00:27:30.000000', 'temperatura', 184.0000, 'ºC'),
	(181216, 121, '2014-02-01 00:27:31.000000', 'temperatura', 351.0000, 'ºC'),
	(181217, 121, '2014-02-01 00:27:32.000000', 'temperatura', 3.0000, 'ºC'),
	(181218, 121, '2014-02-01 00:27:33.000000', 'temperatura', 164.0000, 'ºC'),
	(181219, 121, '2014-02-01 00:27:34.000000', 'temperatura', 812.0000, 'ºC'),
	(181220, 121, '2014-02-01 00:27:35.000000', 'temperatura', 1167.0000, 'ºC'),
	(181221, 121, '2014-02-01 00:27:36.000000', 'temperatura', 1001.0000, 'ºC'),
	(181222, 121, '2014-02-01 00:27:37.000000', 'temperatura', 303.0000, 'ºC'),
	(181223, 121, '2014-02-01 00:27:38.000000', 'temperatura', 911.0000, 'ºC'),
	(181224, 121, '2014-02-01 00:27:39.000000', 'temperatura', 47.0000, 'ºC'),
	(181225, 121, '2014-02-01 00:27:40.000000', 'temperatura', 1104.0000, 'ºC'),
	(181226, 121, '2014-02-01 00:27:41.000000', 'temperatura', 580.0000, 'ºC'),
	(181227, 121, '2014-02-01 00:27:42.000000', 'temperatura', 786.0000, 'ºC'),
	(181228, 121, '2014-02-01 00:27:43.000000', 'temperatura', 993.0000, 'ºC'),
	(181229, 121, '2014-02-01 00:27:44.000000', 'temperatura', 208.0000, 'ºC'),
	(181230, 121, '2014-02-01 00:27:45.000000', 'temperatura', 458.0000, 'ºC'),
	(181231, 121, '2014-02-01 00:27:46.000000', 'temperatura', 470.0000, 'ºC'),
	(181232, 121, '2014-02-01 00:27:47.000000', 'temperatura', 976.0000, 'ºC'),
	(181233, 121, '2014-02-01 00:27:48.000000', 'temperatura', 1068.0000, 'ºC'),
	(181234, 121, '2014-02-01 00:27:49.000000', 'temperatura', 16.0000, 'ºC'),
	(181235, 121, '2014-02-01 00:27:50.000000', 'temperatura', 474.0000, 'ºC'),
	(181236, 121, '2014-02-01 00:27:51.000000', 'temperatura', 1125.0000, 'ºC'),
	(181237, 121, '2014-02-01 00:27:52.000000', 'temperatura', 603.0000, 'ºC'),
	(181238, 121, '2014-02-01 00:27:53.000000', 'temperatura', 841.0000, 'ºC'),
	(181239, 121, '2014-02-01 00:27:54.000000', 'temperatura', 1197.0000, 'ºC'),
	(181240, 121, '2014-02-01 00:27:55.000000', 'temperatura', 1063.0000, 'ºC'),
	(181241, 121, '2014-02-01 00:27:56.000000', 'temperatura', 522.0000, 'ºC'),
	(181242, 121, '2014-02-01 00:27:57.000000', 'temperatura', 621.0000, 'ºC'),
	(181243, 121, '2014-02-01 00:27:58.000000', 'temperatura', 339.0000, 'ºC'),
	(181244, 121, '2014-02-01 00:27:59.000000', 'temperatura', 1034.0000, 'ºC'),
	(181245, 121, '2014-02-01 00:28:00.000000', 'temperatura', 553.0000, 'ºC'),
	(181246, 121, '2014-02-01 00:28:01.000000', 'temperatura', 866.0000, 'ºC'),
	(181247, 121, '2014-02-01 00:28:02.000000', 'temperatura', 269.0000, 'ºC'),
	(181248, 121, '2014-02-01 00:28:03.000000', 'temperatura', 1148.0000, 'ºC'),
	(181249, 121, '2014-02-01 00:28:04.000000', 'temperatura', 132.0000, 'ºC'),
	(181250, 121, '2014-02-01 00:28:05.000000', 'temperatura', 817.0000, 'ºC'),
	(181251, 121, '2014-02-01 00:28:06.000000', 'temperatura', 89.0000, 'ºC'),
	(181252, 121, '2014-02-01 00:28:07.000000', 'temperatura', 394.0000, 'ºC'),
	(181253, 121, '2014-02-01 00:28:08.000000', 'temperatura', 505.0000, 'ºC'),
	(181254, 121, '2014-02-01 00:28:09.000000', 'temperatura', 143.0000, 'ºC'),
	(181255, 121, '2014-02-01 00:28:10.000000', 'temperatura', 401.0000, 'ºC'),
	(181256, 121, '2014-02-01 00:28:11.000000', 'temperatura', 376.0000, 'ºC'),
	(181257, 121, '2014-02-01 00:28:12.000000', 'temperatura', 679.0000, 'ºC'),
	(181258, 121, '2014-02-01 00:28:13.000000', 'temperatura', 1065.0000, 'ºC'),
	(181259, 121, '2014-02-01 00:28:14.000000', 'temperatura', 888.0000, 'ºC'),
	(181260, 121, '2014-02-01 00:28:15.000000', 'temperatura', 48.0000, 'ºC'),
	(181261, 121, '2014-02-01 00:28:16.000000', 'temperatura', 1177.0000, 'ºC'),
	(181262, 121, '2014-02-01 00:28:17.000000', 'temperatura', 939.0000, 'ºC'),
	(181263, 121, '2014-02-01 00:28:18.000000', 'temperatura', 1167.0000, 'ºC'),
	(181264, 121, '2014-02-01 00:28:19.000000', 'temperatura', 619.0000, 'ºC'),
	(181265, 121, '2014-02-01 00:28:20.000000', 'temperatura', 794.0000, 'ºC'),
	(181266, 121, '2014-02-01 00:28:21.000000', 'temperatura', 912.0000, 'ºC'),
	(181267, 121, '2014-02-01 00:28:22.000000', 'temperatura', 981.0000, 'ºC'),
	(181268, 121, '2014-02-01 00:28:23.000000', 'temperatura', 968.0000, 'ºC'),
	(181269, 121, '2014-02-01 00:28:24.000000', 'temperatura', 696.0000, 'ºC'),
	(181270, 121, '2014-02-01 00:28:25.000000', 'temperatura', 576.0000, 'ºC'),
	(181271, 121, '2014-02-01 00:28:26.000000', 'temperatura', 794.0000, 'ºC'),
	(181272, 121, '2014-02-01 00:28:27.000000', 'temperatura', 1043.0000, 'ºC'),
	(181273, 121, '2014-02-01 00:28:28.000000', 'temperatura', 434.0000, 'ºC'),
	(181274, 121, '2014-02-01 00:28:29.000000', 'temperatura', 242.0000, 'ºC'),
	(181275, 121, '2014-02-01 00:28:30.000000', 'temperatura', 1110.0000, 'ºC'),
	(181276, 121, '2014-02-01 00:28:31.000000', 'temperatura', 22.0000, 'ºC'),
	(181277, 121, '2014-02-01 00:28:32.000000', 'temperatura', 379.0000, 'ºC'),
	(181278, 121, '2014-02-01 00:28:33.000000', 'temperatura', 631.0000, 'ºC'),
	(181279, 121, '2014-02-01 00:28:34.000000', 'temperatura', 819.0000, 'ºC'),
	(181280, 121, '2014-02-01 00:28:35.000000', 'temperatura', 1002.0000, 'ºC'),
	(181281, 121, '2014-02-01 00:28:36.000000', 'temperatura', 152.0000, 'ºC'),
	(181282, 121, '2014-02-01 00:28:37.000000', 'temperatura', 155.0000, 'ºC'),
	(181283, 121, '2014-02-01 00:28:38.000000', 'temperatura', 320.0000, 'ºC'),
	(181284, 121, '2014-02-01 00:28:39.000000', 'temperatura', 1134.0000, 'ºC'),
	(181285, 121, '2014-02-01 00:28:40.000000', 'temperatura', 1110.0000, 'ºC'),
	(181286, 121, '2014-02-01 00:28:41.000000', 'temperatura', 948.0000, 'ºC'),
	(181287, 121, '2014-02-01 00:28:42.000000', 'temperatura', 212.0000, 'ºC'),
	(181288, 121, '2014-02-01 00:28:43.000000', 'temperatura', 617.0000, 'ºC'),
	(181289, 121, '2014-02-01 00:28:44.000000', 'temperatura', 47.0000, 'ºC'),
	(181290, 121, '2014-02-01 00:28:45.000000', 'temperatura', 786.0000, 'ºC'),
	(181291, 121, '2014-02-01 00:28:46.000000', 'temperatura', 190.0000, 'ºC'),
	(181292, 121, '2014-02-01 00:28:47.000000', 'temperatura', 993.0000, 'ºC'),
	(181293, 121, '2014-02-01 00:28:48.000000', 'temperatura', 796.0000, 'ºC'),
	(181294, 121, '2014-02-01 00:28:49.000000', 'temperatura', 1001.0000, 'ºC'),
	(181295, 121, '2014-02-01 00:28:50.000000', 'temperatura', 219.0000, 'ºC'),
	(181296, 121, '2014-02-01 00:28:51.000000', 'temperatura', 489.0000, 'ºC'),
	(181297, 121, '2014-02-01 00:28:52.000000', 'temperatura', 591.0000, 'ºC'),
	(181298, 121, '2014-02-01 00:28:53.000000', 'temperatura', 290.0000, 'ºC'),
	(181299, 121, '2014-02-01 00:28:54.000000', 'temperatura', 874.0000, 'ºC'),
	(181300, 121, '2014-02-01 00:28:55.000000', 'temperatura', 1101.0000, 'ºC'),
	(181301, 121, '2014-02-01 00:28:56.000000', 'temperatura', 486.0000, 'ºC'),
	(181302, 121, '2014-02-01 00:28:57.000000', 'temperatura', 325.0000, 'ºC'),
	(181303, 121, '2014-02-01 00:28:58.000000', 'temperatura', 168.0000, 'ºC'),
	(181304, 121, '2014-02-01 00:28:59.000000', 'temperatura', 1065.0000, 'ºC'),
	(181305, 121, '2014-02-01 00:29:00.000000', 'temperatura', 24.0000, 'ºC'),
	(181306, 121, '2014-02-01 00:29:01.000000', 'temperatura', 524.0000, 'ºC'),
	(181307, 121, '2014-02-01 00:29:02.000000', 'temperatura', 150.0000, 'ºC'),
	(181308, 121, '2014-02-01 00:29:03.000000', 'temperatura', 377.0000, 'ºC'),
	(181309, 121, '2014-02-01 00:29:04.000000', 'temperatura', 238.0000, 'ºC'),
	(181310, 121, '2014-02-01 00:29:05.000000', 'temperatura', 56.0000, 'ºC'),
	(181311, 121, '2014-02-01 00:29:06.000000', 'temperatura', 767.0000, 'ºC'),
	(181312, 121, '2014-02-01 00:29:07.000000', 'temperatura', 70.0000, 'ºC'),
	(181313, 121, '2014-02-01 00:29:08.000000', 'temperatura', 447.0000, 'ºC'),
	(181314, 121, '2014-02-01 00:29:09.000000', 'temperatura', 828.0000, 'ºC'),
	(181315, 121, '2014-02-01 00:29:10.000000', 'temperatura', 400.0000, 'ºC'),
	(181316, 121, '2014-02-01 00:29:11.000000', 'temperatura', 714.0000, 'ºC'),
	(181317, 121, '2014-02-01 00:29:12.000000', 'temperatura', 1171.0000, 'ºC'),
	(181318, 121, '2014-02-01 00:29:13.000000', 'temperatura', 113.0000, 'ºC'),
	(181319, 121, '2014-02-01 00:29:14.000000', 'temperatura', 652.0000, 'ºC'),
	(181320, 121, '2014-02-01 00:29:15.000000', 'temperatura', 523.0000, 'ºC'),
	(181321, 121, '2014-02-01 00:29:16.000000', 'temperatura', 659.0000, 'ºC'),
	(181322, 121, '2014-02-01 00:29:17.000000', 'temperatura', 528.0000, 'ºC'),
	(181323, 121, '2014-02-01 00:29:18.000000', 'temperatura', 661.0000, 'ºC'),
	(181324, 121, '2014-02-01 00:29:19.000000', 'temperatura', 522.0000, 'ºC'),
	(181325, 121, '2014-02-01 00:29:20.000000', 'temperatura', 628.0000, 'ºC'),
	(181326, 121, '2014-02-01 00:29:21.000000', 'temperatura', 375.0000, 'ºC'),
	(181327, 121, '2014-02-01 00:29:22.000000', 'temperatura', 1189.0000, 'ºC'),
	(181328, 121, '2014-02-01 00:29:23.000000', 'temperatura', 24.0000, 'ºC'),
	(181329, 121, '2014-02-01 00:29:24.000000', 'temperatura', 150.0000, 'ºC'),
	(181330, 121, '2014-02-01 00:29:25.000000', 'temperatura', 681.0000, 'ºC'),
	(181331, 121, '2014-02-01 00:29:26.000000', 'temperatura', 553.0000, 'ºC'),
	(181332, 121, '2014-02-01 00:29:27.000000', 'temperatura', 725.0000, 'ºC'),
	(181333, 121, '2014-02-01 00:29:28.000000', 'temperatura', 766.0000, 'ºC'),
	(181334, 121, '2014-02-01 00:29:29.000000', 'temperatura', 456.0000, 'ºC'),
	(181335, 121, '2014-02-01 00:29:30.000000', 'temperatura', 1180.0000, 'ºC'),
	(181336, 121, '2014-02-01 00:29:31.000000', 'temperatura', 935.0000, 'ºC'),
	(181337, 121, '2014-02-01 00:29:32.000000', 'temperatura', 1136.0000, 'ºC'),
	(181338, 121, '2014-02-01 00:29:33.000000', 'temperatura', 476.0000, 'ºC'),
	(181339, 121, '2014-02-01 00:29:34.000000', 'temperatura', 170.0000, 'ºC'),
	(181340, 121, '2014-02-01 00:29:35.000000', 'temperatura', 622.0000, 'ºC'),
	(181341, 121, '2014-02-01 00:29:36.000000', 'temperatura', 199.0000, 'ºC'),
	(181342, 121, '2014-02-01 00:29:37.000000', 'temperatura', 333.0000, 'ºC'),
	(181343, 121, '2014-02-01 00:29:38.000000', 'temperatura', 1069.0000, 'ºC'),
	(181344, 121, '2014-02-01 00:29:39.000000', 'temperatura', 744.0000, 'ºC'),
	(181345, 121, '2014-02-01 00:29:40.000000', 'temperatura', 515.0000, 'ºC'),
	(181346, 121, '2014-02-01 00:29:41.000000', 'temperatura', 343.0000, 'ºC'),
	(181347, 121, '2014-02-01 00:29:42.000000', 'temperatura', 169.0000, 'ºC'),
	(181348, 121, '2014-02-01 00:29:43.000000', 'temperatura', 1018.0000, 'ºC'),
	(181349, 121, '2014-02-01 00:29:44.000000', 'temperatura', 981.0000, 'ºC'),
	(181350, 121, '2014-02-01 00:29:45.000000', 'temperatura', 654.0000, 'ºC'),
	(181351, 121, '2014-02-01 00:29:46.000000', 'temperatura', 328.0000, 'ºC'),
	(181352, 121, '2014-02-01 00:29:47.000000', 'temperatura', 877.0000, 'ºC'),
	(181353, 121, '2014-02-01 00:29:48.000000', 'temperatura', 1002.0000, 'ºC'),
	(181354, 121, '2014-02-01 00:29:49.000000', 'temperatura', 1181.0000, 'ºC'),
	(181355, 121, '2014-02-01 00:29:50.000000', 'temperatura', 499.0000, 'ºC'),
	(181356, 121, '2014-02-01 00:29:51.000000', 'temperatura', 154.0000, 'ºC'),
	(181357, 121, '2014-02-01 00:29:52.000000', 'temperatura', 472.0000, 'ºC'),
	(181358, 121, '2014-02-01 00:29:53.000000', 'temperatura', 698.0000, 'ºC'),
	(181359, 121, '2014-02-01 00:29:54.000000', 'temperatura', 876.0000, 'ºC'),
	(181360, 121, '2014-02-01 00:29:55.000000', 'temperatura', 1084.0000, 'ºC'),
	(181361, 121, '2014-02-01 00:29:56.000000', 'temperatura', 395.0000, 'ºC'),
	(181362, 121, '2014-02-01 00:29:57.000000', 'temperatura', 1122.0000, 'ºC'),
	(181363, 121, '2014-02-01 00:29:58.000000', 'temperatura', 827.0000, 'ºC'),
	(181364, 121, '2014-02-01 00:29:59.000000', 'temperatura', 767.0000, 'ºC'),
	(181365, 121, '2014-02-01 00:30:00.000000', 'temperatura', 154.0000, 'ºC'),
	(181366, 121, '2014-02-01 00:30:01.000000', 'temperatura', 872.0000, 'ºC'),
	(181367, 121, '2014-02-01 00:30:02.000000', 'temperatura', 297.0000, 'ºC'),
	(181368, 121, '2014-02-01 00:30:03.000000', 'temperatura', 72.0000, 'ºC'),
	(181369, 121, '2014-02-01 00:30:04.000000', 'temperatura', 666.0000, 'ºC'),
	(181370, 121, '2014-02-01 00:30:05.000000', 'temperatura', 716.0000, 'ºC'),
	(181371, 121, '2014-02-01 00:30:06.000000', 'temperatura', 383.0000, 'ºC'),
	(181372, 121, '2014-02-01 00:30:07.000000', 'temperatura', 966.0000, 'ºC'),
	(181373, 121, '2014-02-01 00:30:08.000000', 'temperatura', 81.0000, 'ºC'),
	(181374, 121, '2014-02-01 00:30:09.000000', 'temperatura', 1107.0000, 'ºC'),
	(181375, 121, '2014-02-01 00:30:10.000000', 'temperatura', 495.0000, 'ºC'),
	(181376, 121, '2014-02-01 00:30:11.000000', 'temperatura', 353.0000, 'ºC'),
	(181377, 121, '2014-02-01 00:30:12.000000', 'temperatura', 280.0000, 'ºC'),
	(181378, 121, '2014-02-01 00:30:13.000000', 'temperatura', 342.0000, 'ºC'),
	(181379, 121, '2014-02-01 00:30:14.000000', 'temperatura', 870.0000, 'ºC'),
	(181380, 121, '2014-02-01 00:30:15.000000', 'temperatura', 926.0000, 'ºC'),
	(181381, 121, '2014-02-01 00:30:16.000000', 'temperatura', 819.0000, 'ºC'),
	(181382, 121, '2014-02-01 00:30:17.000000', 'temperatura', 119.0000, 'ºC'),
	(181383, 121, '2014-02-01 00:30:18.000000', 'temperatura', 538.0000, 'ºC'),
	(181384, 121, '2014-02-01 00:30:19.000000', 'temperatura', 1134.0000, 'ºC'),
	(181385, 121, '2014-02-01 00:30:20.000000', 'temperatura', 456.0000, 'ºC'),
	(181386, 121, '2014-02-01 00:30:21.000000', 'temperatura', 80.0000, 'ºC'),
	(181387, 121, '2014-02-01 00:30:22.000000', 'temperatura', 232.0000, 'ºC'),
	(181388, 121, '2014-02-01 00:30:23.000000', 'temperatura', 920.0000, 'ºC'),
	(181389, 121, '2014-02-01 00:30:24.000000', 'temperatura', 305.0000, 'ºC'),
	(181390, 121, '2014-02-01 00:30:25.000000', 'temperatura', 1165.0000, 'ºC'),
	(181391, 121, '2014-02-01 00:30:26.000000', 'temperatura', 110.0000, 'ºC'),
	(181392, 121, '2014-02-01 00:30:27.000000', 'temperatura', 657.0000, 'ºC'),
	(181393, 121, '2014-02-01 00:30:28.000000', 'temperatura', 553.0000, 'ºC'),
	(181394, 121, '2014-02-01 00:30:29.000000', 'temperatura', 795.0000, 'ºC'),
	(181395, 121, '2014-02-01 00:30:30.000000', 'temperatura', 1116.0000, 'ºC'),
	(181396, 121, '2014-02-01 00:30:31.000000', 'temperatura', 796.0000, 'ºC'),
	(181397, 121, '2014-02-01 00:30:32.000000', 'temperatura', 635.0000, 'ºC'),
	(181398, 121, '2014-02-01 00:30:33.000000', 'temperatura', 784.0000, 'ºC'),
	(181399, 121, '2014-02-01 00:30:34.000000', 'temperatura', 817.0000, 'ºC'),
	(181400, 121, '2014-02-01 00:30:35.000000', 'temperatura', 531.0000, 'ºC'),
	(181401, 121, '2014-02-01 00:30:36.000000', 'temperatura', 207.0000, 'ºC'),
	(181402, 121, '2014-02-01 00:30:37.000000', 'temperatura', 643.0000, 'ºC'),
	(181403, 121, '2014-02-01 00:30:38.000000', 'temperatura', 196.0000, 'ºC'),
	(181404, 121, '2014-02-01 00:30:39.000000', 'temperatura', 249.0000, 'ºC'),
	(181405, 121, '2014-02-01 00:30:40.000000', 'temperatura', 656.0000, 'ºC'),
	(181406, 121, '2014-02-01 00:30:41.000000', 'temperatura', 137.0000, 'ºC'),
	(181407, 121, '2014-02-01 00:30:42.000000', 'temperatura', 1115.0000, 'ºC'),
	(181408, 121, '2014-02-01 00:30:43.000000', 'temperatura', 365.0000, 'ºC'),
	(181409, 121, '2014-02-01 00:30:44.000000', 'temperatura', 879.0000, 'ºC'),
	(181410, 121, '2014-02-01 00:30:45.000000', 'temperatura', 901.0000, 'ºC'),
	(181411, 121, '2014-02-01 00:30:46.000000', 'temperatura', 671.0000, 'ºC'),
	(181412, 121, '2014-02-01 00:30:47.000000', 'temperatura', 650.0000, 'ºC'),
	(181413, 121, '2014-02-01 00:30:48.000000', 'temperatura', 36.0000, 'ºC'),
	(181414, 121, '2014-02-01 00:30:49.000000', 'temperatura', 634.0000, 'ºC'),
	(181415, 121, '2014-02-01 00:30:50.000000', 'temperatura', 659.0000, 'ºC'),
	(181416, 121, '2014-02-01 00:30:51.000000', 'temperatura', 196.0000, 'ºC'),
	(181417, 121, '2014-02-01 00:30:52.000000', 'temperatura', 202.0000, 'ºC'),
	(181418, 121, '2014-02-01 00:30:53.000000', 'temperatura', 425.0000, 'ºC'),
	(181419, 121, '2014-02-01 00:30:54.000000', 'temperatura', 318.0000, 'ºC'),
	(181420, 121, '2014-02-01 00:30:55.000000', 'temperatura', 315.0000, 'ºC'),
	(181421, 121, '2014-02-01 00:30:56.000000', 'temperatura', 621.0000, 'ºC'),
	(181422, 121, '2014-02-01 00:30:57.000000', 'temperatura', 959.0000, 'ºC'),
	(181423, 121, '2014-02-01 00:30:58.000000', 'temperatura', 535.0000, 'ºC'),
	(181424, 121, '2014-02-01 00:30:59.000000', 'temperatura', 998.0000, 'ºC'),
	(181425, 121, '2014-02-01 00:31:00.000000', 'temperatura', 987.0000, 'ºC'),
	(181426, 121, '2014-02-01 00:31:01.000000', 'temperatura', 742.0000, 'ºC'),
	(181427, 121, '2014-02-01 00:31:02.000000', 'temperatura', 748.0000, 'ºC'),
	(181428, 121, '2014-02-01 00:31:03.000000', 'temperatura', 313.0000, 'ºC'),
	(181429, 121, '2014-02-01 00:31:04.000000', 'temperatura', 521.0000, 'ºC'),
	(181430, 121, '2014-02-01 00:31:05.000000', 'temperatura', 468.0000, 'ºC'),
	(181431, 121, '2014-02-01 00:31:06.000000', 'temperatura', 777.0000, 'ºC'),
	(181432, 121, '2014-02-01 00:31:07.000000', 'temperatura', 82.0000, 'ºC'),
	(181433, 121, '2014-02-01 00:31:08.000000', 'temperatura', 481.0000, 'ºC'),
	(181434, 121, '2014-02-01 00:31:09.000000', 'temperatura', 957.0000, 'ºC'),
	(181435, 121, '2014-02-01 00:31:10.000000', 'temperatura', 945.0000, 'ºC'),
	(181436, 121, '2014-02-01 00:31:11.000000', 'temperatura', 653.0000, 'ºC'),
	(181437, 121, '2014-02-01 00:31:12.000000', 'temperatura', 432.0000, 'ºC'),
	(181438, 121, '2014-02-01 00:31:13.000000', 'temperatura', 199.0000, 'ºC'),
	(181439, 121, '2014-02-01 00:31:14.000000', 'temperatura', 902.0000, 'ºC'),
	(181440, 121, '2014-02-01 00:31:15.000000', 'temperatura', 314.0000, 'ºC'),
	(181441, 121, '2014-02-01 00:31:16.000000', 'temperatura', 64.0000, 'ºC'),
	(181442, 121, '2014-02-01 00:31:17.000000', 'temperatura', 576.0000, 'ºC'),
	(181443, 121, '2014-02-01 00:31:18.000000', 'temperatura', 292.0000, 'ºC'),
	(181444, 121, '2014-02-01 00:31:19.000000', 'temperatura', 930.0000, 'ºC'),
	(181445, 121, '2014-02-01 00:31:20.000000', 'temperatura', 174.0000, 'ºC'),
	(181446, 121, '2014-02-01 00:31:21.000000', 'temperatura', 482.0000, 'ºC'),
	(181447, 121, '2014-02-01 00:31:22.000000', 'temperatura', 689.0000, 'ºC'),
	(181448, 121, '2014-02-01 00:31:23.000000', 'temperatura', 799.0000, 'ºC'),
	(181449, 121, '2014-02-01 00:31:24.000000', 'temperatura', 729.0000, 'ºC'),
	(181450, 121, '2014-02-01 00:31:25.000000', 'temperatura', 49.0000, 'ºC'),
	(181451, 121, '2014-02-01 00:31:26.000000', 'temperatura', 457.0000, 'ºC'),
	(181452, 121, '2014-02-01 00:31:27.000000', 'temperatura', 941.0000, 'ºC'),
	(181453, 121, '2014-02-01 00:31:28.000000', 'temperatura', 931.0000, 'ºC'),
	(181454, 121, '2014-02-01 00:31:29.000000', 'temperatura', 634.0000, 'ºC'),
	(181455, 121, '2014-02-01 00:31:30.000000', 'temperatura', 378.0000, 'ºC'),
	(181456, 121, '2014-02-01 00:31:31.000000', 'temperatura', 1189.0000, 'ºC'),
	(181457, 121, '2014-02-01 00:31:32.000000', 'temperatura', 10.0000, 'ºC'),
	(181458, 121, '2014-02-01 00:31:33.000000', 'temperatura', 84.0000, 'ºC'),
	(181459, 121, '2014-02-01 00:31:34.000000', 'temperatura', 391.0000, 'ºC'),
	(181460, 121, '2014-02-01 00:31:35.000000', 'temperatura', 504.0000, 'ºC'),
	(181461, 121, '2014-02-01 00:31:36.000000', 'temperatura', 146.0000, 'ºC'),
	(181462, 121, '2014-02-01 00:31:37.000000', 'temperatura', 420.0000, 'ºC'),
	(181463, 121, '2014-02-01 00:31:38.000000', 'temperatura', 463.0000, 'ºC'),
	(181464, 121, '2014-02-01 00:31:39.000000', 'temperatura', 1057.0000, 'ºC'),
	(181465, 121, '2014-02-01 00:31:40.000000', 'temperatura', 293.0000, 'ºC'),
	(181466, 121, '2014-02-01 00:31:41.000000', 'temperatura', 696.0000, 'ºC'),
	(181467, 121, '2014-02-01 00:31:42.000000', 'temperatura', 202.0000, 'ºC'),
	(181468, 121, '2014-02-01 00:31:43.000000', 'temperatura', 122.0000, 'ºC'),
	(181469, 121, '2014-02-01 00:31:44.000000', 'temperatura', 6.0000, 'ºC'),
	(181470, 121, '2014-02-01 00:31:45.000000', 'temperatura', 864.0000, 'ºC'),
	(181471, 121, '2014-02-01 00:31:46.000000', 'temperatura', 702.0000, 'ºC'),
	(181472, 121, '2014-02-01 00:31:47.000000', 'temperatura', 920.0000, 'ºC'),
	(181473, 121, '2014-02-01 00:31:48.000000', 'temperatura', 93.0000, 'ºC'),
	(181474, 121, '2014-02-01 00:31:49.000000', 'temperatura', 108.0000, 'ºC'),
	(181475, 121, '2014-02-01 00:31:50.000000', 'temperatura', 259.0000, 'ºC'),
	(181476, 121, '2014-02-01 00:31:51.000000', 'temperatura', 971.0000, 'ºC'),
	(181477, 121, '2014-02-01 00:31:52.000000', 'temperatura', 479.0000, 'ºC'),
	(181478, 121, '2014-02-01 00:31:53.000000', 'temperatura', 684.0000, 'ºC'),
	(181479, 121, '2014-02-01 00:31:54.000000', 'temperatura', 783.0000, 'ºC'),
	(181480, 121, '2014-02-01 00:31:55.000000', 'temperatura', 661.0000, 'ºC'),
	(181481, 121, '2014-02-01 00:31:56.000000', 'temperatura', 959.0000, 'ºC'),
	(181482, 121, '2014-02-01 00:31:57.000000', 'temperatura', 412.0000, 'ºC'),
	(181483, 121, '2014-02-01 00:31:58.000000', 'temperatura', 381.0000, 'ºC'),
	(181484, 121, '2014-02-01 00:31:59.000000', 'temperatura', 673.0000, 'ºC'),
	(181485, 121, '2014-02-01 00:32:00.000000', 'temperatura', 1022.0000, 'ºC'),
	(181486, 121, '2014-02-01 00:32:01.000000', 'temperatura', 690.0000, 'ºC'),
	(181487, 121, '2014-02-01 00:32:02.000000', 'temperatura', 384.0000, 'ºC'),
	(181488, 121, '2014-02-01 00:32:03.000000', 'temperatura', 1052.0000, 'ºC'),
	(181489, 121, '2014-02-01 00:32:04.000000', 'temperatura', 507.0000, 'ºC'),
	(181490, 121, '2014-02-01 00:32:05.000000', 'temperatura', 580.0000, 'ºC'),
	(181491, 121, '2014-02-01 00:32:06.000000', 'temperatura', 178.0000, 'ºC'),
	(181492, 121, '2014-02-01 00:32:07.000000', 'temperatura', 354.0000, 'ºC'),
	(181493, 121, '2014-02-01 00:32:08.000000', 'temperatura', 33.0000, 'ºC'),
	(181494, 121, '2014-02-01 00:32:09.000000', 'temperatura', 304.0000, 'ºC'),
	(181495, 121, '2014-02-01 00:32:10.000000', 'temperatura', 223.0000, 'ºC'),
	(181496, 121, '2014-02-01 00:32:11.000000', 'temperatura', 202.0000, 'ºC'),
	(181497, 121, '2014-02-01 00:32:12.000000', 'temperatura', 341.0000, 'ºC'),
	(181498, 121, '2014-02-01 00:32:13.000000', 'temperatura', 1102.0000, 'ºC'),
	(181499, 121, '2014-02-01 00:32:14.000000', 'temperatura', 886.0000, 'ºC'),
	(181500, 121, '2014-02-01 00:32:15.000000', 'temperatura', 1123.0000, 'ºC'),
	(181501, 121, '2014-02-01 00:32:16.000000', 'temperatura', 560.0000, 'ºC'),
	(181502, 121, '2014-02-01 00:32:17.000000', 'temperatura', 631.0000, 'ºC'),
	(181503, 121, '2014-02-01 00:32:18.000000', 'temperatura', 275.0000, 'ºC'),
	(181504, 121, '2014-02-01 00:32:19.000000', 'temperatura', 683.0000, 'ºC'),
	(181505, 121, '2014-02-01 00:32:20.000000', 'temperatura', 191.0000, 'ºC'),
	(181506, 121, '2014-02-01 00:32:21.000000', 'temperatura', 105.0000, 'ºC'),
	(181507, 121, '2014-02-01 00:32:22.000000', 'temperatura', 1154.0000, 'ºC'),
	(181508, 121, '2014-02-01 00:32:23.000000', 'temperatura', 657.0000, 'ºC'),
	(181509, 121, '2014-02-01 00:32:24.000000', 'temperatura', 1022.0000, 'ºC'),
	(181510, 121, '2014-02-01 00:32:25.000000', 'temperatura', 740.0000, 'ºC'),
	(181511, 121, '2014-02-01 00:32:26.000000', 'temperatura', 632.0000, 'ºC'),
	(181512, 121, '2014-02-01 00:32:27.000000', 'temperatura', 944.0000, 'ºC'),
	(181513, 121, '2014-02-01 00:32:28.000000', 'temperatura', 423.0000, 'ºC'),
	(181514, 121, '2014-02-01 00:32:29.000000', 'temperatura', 485.0000, 'ºC'),
	(181515, 121, '2014-02-01 00:32:30.000000', 'temperatura', 1157.0000, 'ºC'),
	(181516, 121, '2014-02-01 00:32:31.000000', 'temperatura', 730.0000, 'ºC'),
	(181517, 121, '2014-02-01 00:32:32.000000', 'temperatura', 180.0000, 'ºC'),
	(181518, 121, '2014-02-01 00:32:33.000000', 'temperatura', 1108.0000, 'ºC'),
	(181519, 121, '2014-02-01 00:32:34.000000', 'temperatura', 202.0000, 'ºC'),
	(181520, 121, '2014-02-01 00:32:35.000000', 'temperatura', 87.0000, 'ºC'),
	(181521, 121, '2014-02-01 00:32:36.000000', 'temperatura', 1028.0000, 'ºC'),
	(181522, 121, '2014-02-01 00:32:37.000000', 'temperatura', 79.0000, 'ºC'),
	(181523, 121, '2014-02-01 00:32:38.000000', 'temperatura', 914.0000, 'ºC'),
	(181524, 121, '2014-02-01 00:32:39.000000', 'temperatura', 731.0000, 'ºC'),
	(181525, 121, '2014-02-01 00:32:40.000000', 'temperatura', 915.0000, 'ºC'),
	(181526, 121, '2014-02-01 00:32:41.000000', 'temperatura', 1184.0000, 'ºC'),
	(181527, 121, '2014-02-01 00:32:42.000000', 'temperatura', 773.0000, 'ºC'),
	(181528, 121, '2014-02-01 00:32:43.000000', 'temperatura', 313.0000, 'ºC'),
	(181529, 121, '2014-02-01 00:32:44.000000', 'temperatura', 447.0000, 'ºC'),
	(181530, 121, '2014-02-01 00:32:45.000000', 'temperatura', 97.0000, 'ºC'),
	(181531, 121, '2014-02-01 00:32:46.000000', 'temperatura', 346.0000, 'ºC'),
	(181532, 121, '2014-02-01 00:32:47.000000', 'temperatura', 237.0000, 'ºC'),
	(181533, 121, '2014-02-01 00:32:48.000000', 'temperatura', 148.0000, 'ºC'),
	(181534, 121, '2014-02-01 00:32:49.000000', 'temperatura', 30.0000, 'ºC'),
	(181535, 121, '2014-02-01 00:32:50.000000', 'temperatura', 908.0000, 'ºC'),
	(181536, 121, '2014-02-01 00:32:51.000000', 'temperatura', 851.0000, 'ºC'),
	(181537, 121, '2014-02-01 00:32:52.000000', 'temperatura', 329.0000, 'ºC'),
	(181538, 121, '2014-02-01 00:32:53.000000', 'temperatura', 295.0000, 'ºC'),
	(181539, 121, '2014-02-01 00:32:54.000000', 'temperatura', 487.0000, 'ºC'),
	(181540, 121, '2014-02-01 00:32:55.000000', 'temperatura', 352.0000, 'ºC'),
	(181541, 121, '2014-02-01 00:32:56.000000', 'temperatura', 299.0000, 'ºC'),
	(181542, 121, '2014-02-01 00:32:57.000000', 'temperatura', 440.0000, 'ºC'),
	(181543, 121, '2014-02-01 00:32:58.000000', 'temperatura', 102.0000, 'ºC'),
	(181544, 121, '2014-02-01 00:32:59.000000', 'temperatura', 389.0000, 'ºC'),
	(181545, 121, '2014-02-01 00:33:00.000000', 'temperatura', 441.0000, 'ºC'),
	(181546, 121, '2014-02-01 00:33:01.000000', 'temperatura', 1039.0000, 'ºC'),
	(181547, 121, '2014-02-01 00:33:02.000000', 'temperatura', 274.0000, 'ºC'),
	(181548, 121, '2014-02-01 00:33:03.000000', 'temperatura', 650.0000, 'ºC'),
	(181549, 121, '2014-02-01 00:33:04.000000', 'temperatura', 32.0000, 'ºC'),
	(181550, 121, '2014-02-01 00:33:05.000000', 'temperatura', 607.0000, 'ºC'),
	(181551, 121, '2014-02-01 00:33:06.000000', 'temperatura', 541.0000, 'ºC'),
	(181552, 121, '2014-02-01 00:33:07.000000', 'temperatura', 884.0000, 'ºC'),
	(181553, 121, '2014-02-01 00:33:08.000000', 'temperatura', 400.0000, 'ºC'),
	(181554, 121, '2014-02-01 00:33:09.000000', 'temperatura', 545.0000, 'ºC'),
	(181555, 121, '2014-02-01 00:33:10.000000', 'temperatura', 329.0000, 'ºC'),
	(181556, 121, '2014-02-01 00:33:11.000000', 'temperatura', 9.0000, 'ºC'),
	(181557, 121, '2014-02-01 00:33:12.000000', 'temperatura', 259.0000, 'ºC'),
	(181558, 121, '2014-02-01 00:33:13.000000', 'temperatura', 70.0000, 'ºC'),
	(181559, 121, '2014-02-01 00:33:14.000000', 'temperatura', 772.0000, 'ºC'),
	(181560, 121, '2014-02-01 00:33:15.000000', 'temperatura', 49.0000, 'ºC'),
	(181561, 121, '2014-02-01 00:33:16.000000', 'temperatura', 330.0000, 'ºC'),
	(181562, 121, '2014-02-01 00:33:17.000000', 'temperatura', 306.0000, 'ºC'),
	(181563, 121, '2014-02-01 00:33:18.000000', 'temperatura', 537.0000, 'ºC'),
	(181564, 121, '2014-02-01 00:33:19.000000', 'temperatura', 569.0000, 'ºC'),
	(181565, 121, '2014-02-01 00:33:20.000000', 'temperatura', 34.0000, 'ºC'),
	(181566, 121, '2014-02-01 00:33:21.000000', 'temperatura', 863.0000, 'ºC'),
	(181567, 121, '2014-02-01 00:33:22.000000', 'temperatura', 616.0000, 'ºC'),
	(181568, 121, '2014-02-01 00:33:23.000000', 'temperatura', 490.0000, 'ºC'),
	(181569, 121, '2014-02-01 00:33:24.000000', 'temperatura', 602.0000, 'ºC'),
	(181570, 121, '2014-02-01 00:33:25.000000', 'temperatura', 341.0000, 'ºC'),
	(181571, 121, '2014-02-01 00:33:26.000000', 'temperatura', 1099.0000, 'ºC'),
	(181572, 121, '2014-02-01 00:33:27.000000', 'temperatura', 874.0000, 'ºC'),
	(181573, 121, '2014-02-01 00:33:28.000000', 'temperatura', 1074.0000, 'ºC'),
	(181574, 121, '2014-02-01 00:33:29.000000', 'temperatura', 349.0000, 'ºC'),
	(181575, 121, '2014-02-01 00:33:30.000000', 'temperatura', 923.0000, 'ºC'),
	(181576, 121, '2014-02-01 00:33:31.000000', 'temperatura', 1169.0000, 'ºC'),
	(181577, 121, '2014-02-01 00:33:32.000000', 'temperatura', 674.0000, 'ºC'),
	(181578, 121, '2014-02-01 00:33:33.000000', 'temperatura', 1067.0000, 'ºC'),
	(181579, 121, '2014-02-01 00:33:34.000000', 'temperatura', 911.0000, 'ºC'),
	(181580, 121, '2014-02-01 00:33:35.000000', 'temperatura', 156.0000, 'ºC'),
	(181581, 121, '2014-02-01 00:33:36.000000', 'temperatura', 448.0000, 'ºC'),
	(181582, 121, '2014-02-01 00:33:37.000000', 'temperatura', 571.0000, 'ºC'),
	(181583, 121, '2014-02-01 00:33:38.000000', 'temperatura', 313.0000, 'ºC'),
	(181584, 121, '2014-02-01 00:33:39.000000', 'temperatura', 1052.0000, 'ºC'),
	(181585, 121, '2014-02-01 00:33:40.000000', 'temperatura', 719.0000, 'ºC'),
	(181586, 121, '2014-02-01 00:33:41.000000', 'temperatura', 443.0000, 'ºC'),
	(181587, 121, '2014-02-01 00:33:42.000000', 'temperatura', 57.0000, 'ºC'),
	(181588, 121, '2014-02-01 00:33:43.000000', 'temperatura', 158.0000, 'ºC'),
	(181589, 121, '2014-02-01 00:33:44.000000', 'temperatura', 619.0000, 'ºC'),
	(181590, 121, '2014-02-01 00:33:45.000000', 'temperatura', 222.0000, 'ºC'),
	(181591, 121, '2014-02-01 00:33:46.000000', 'temperatura', 451.0000, 'ºC'),
	(181592, 121, '2014-02-01 00:33:47.000000', 'temperatura', 391.0000, 'ºC'),
	(181593, 121, '2014-02-01 00:33:48.000000', 'temperatura', 604.0000, 'ºC'),
	(181594, 121, '2014-02-01 00:33:49.000000', 'temperatura', 645.0000, 'ºC'),
	(181595, 121, '2014-02-01 00:33:50.000000', 'temperatura', 215.0000, 'ºC'),
	(181596, 121, '2014-02-01 00:33:51.000000', 'temperatura', 340.0000, 'ºC'),
	(181597, 121, '2014-02-01 00:33:52.000000', 'temperatura', 1058.0000, 'ºC'),
	(181598, 121, '2014-02-01 00:33:53.000000', 'temperatura', 667.0000, 'ºC'),
	(181599, 121, '2014-02-01 00:33:54.000000', 'temperatura', 164.0000, 'ºC'),
	(181600, 121, '2014-02-01 00:33:55.000000', 'temperatura', 20.0000, 'ºC'),
	(181601, 121, '2014-02-01 00:33:56.000000', 'temperatura', 808.0000, 'ºC'),
	(181602, 121, '2014-02-01 00:33:57.000000', 'temperatura', 382.0000, 'ºC'),
	(181603, 121, '2014-02-01 00:33:58.000000', 'temperatura', 684.0000, 'ºC'),
	(181604, 121, '2014-02-01 00:33:59.000000', 'temperatura', 1074.0000, 'ºC'),
	(181605, 121, '2014-02-01 00:34:00.000000', 'temperatura', 918.0000, 'ºC'),
	(181606, 121, '2014-02-01 00:34:01.000000', 'temperatura', 168.0000, 'ºC'),
	(181607, 121, '2014-02-01 00:34:02.000000', 'temperatura', 488.0000, 'ºC'),
	(181608, 121, '2014-02-01 00:34:03.000000', 'temperatura', 734.0000, 'ºC'),
	(181609, 121, '2014-02-01 00:34:04.000000', 'temperatura', 1009.0000, 'ºC'),
	(181610, 121, '2014-02-01 00:34:05.000000', 'temperatura', 443.0000, 'ºC'),
	(181611, 121, '2014-02-01 00:34:06.000000', 'temperatura', 390.0000, 'ºC'),
	(181612, 121, '2014-02-01 00:34:07.000000', 'temperatura', 621.0000, 'ºC'),
	(181613, 121, '2014-02-01 00:34:08.000000', 'temperatura', 735.0000, 'ºC'),
	(181614, 121, '2014-02-01 00:34:09.000000', 'temperatura', 612.0000, 'ºC'),
	(181615, 121, '2014-02-01 00:34:10.000000', 'temperatura', 855.0000, 'ºC'),
	(181616, 121, '2014-02-01 00:34:11.000000', 'temperatura', 40.0000, 'ºC'),
	(181617, 121, '2014-02-01 00:34:12.000000', 'temperatura', 35.0000, 'ºC'),
	(181618, 121, '2014-02-01 00:34:13.000000', 'temperatura', 57.0000, 'ºC'),
	(181619, 121, '2014-02-01 00:34:14.000000', 'temperatura', 178.0000, 'ºC'),
	(181620, 121, '2014-02-01 00:34:15.000000', 'temperatura', 722.0000, 'ºC'),
	(181621, 121, '2014-02-01 00:34:16.000000', 'temperatura', 676.0000, 'ºC'),
	(181622, 121, '2014-02-01 00:34:17.000000', 'temperatura', 15.0000, 'ºC'),
	(181623, 121, '2014-02-01 00:34:18.000000', 'temperatura', 445.0000, 'ºC'),
	(181624, 121, '2014-02-01 00:34:19.000000', 'temperatura', 984.0000, 'ºC'),
	(181625, 121, '2014-02-01 00:34:20.000000', 'temperatura', 1184.0000, 'ºC'),
	(181626, 121, '2014-02-01 00:34:21.000000', 'temperatura', 567.0000, 'ºC'),
	(181627, 121, '2014-02-01 00:34:22.000000', 'temperatura', 485.0000, 'ºC'),
	(181628, 121, '2014-02-01 00:34:23.000000', 'temperatura', 723.0000, 'ºC'),
	(181629, 121, '2014-02-01 00:34:24.000000', 'temperatura', 962.0000, 'ºC'),
	(181630, 121, '2014-02-01 00:34:25.000000', 'temperatura', 240.0000, 'ºC'),
	(181631, 121, '2014-02-01 00:34:26.000000', 'temperatura', 717.0000, 'ºC'),
	(181632, 121, '2014-02-01 00:34:27.000000', 'temperatura', 465.0000, 'ºC'),
	(181633, 121, '2014-02-01 00:34:28.000000', 'temperatura', 176.0000, 'ºC'),
	(181634, 121, '2014-02-01 00:34:29.000000', 'temperatura', 683.0000, 'ºC'),
	(181635, 121, '2014-02-01 00:34:30.000000', 'temperatura', 490.0000, 'ºC'),
	(181636, 121, '2014-02-01 00:34:31.000000', 'temperatura', 401.0000, 'ºC'),
	(181637, 121, '2014-02-01 00:34:32.000000', 'temperatura', 536.0000, 'ºC'),
	(181638, 121, '2014-02-01 00:34:33.000000', 'temperatura', 275.0000, 'ºC'),
	(181639, 121, '2014-02-01 00:34:34.000000', 'temperatura', 970.0000, 'ºC'),
	(181640, 121, '2014-02-01 00:34:35.000000', 'temperatura', 425.0000, 'ºC'),
	(181641, 121, '2014-02-01 00:34:36.000000', 'temperatura', 414.0000, 'ºC'),
	(181642, 121, '2014-02-01 00:34:37.000000', 'temperatura', 797.0000, 'ºC'),
	(181643, 121, '2014-02-01 00:34:38.000000', 'temperatura', 345.0000, 'ºC'),
	(181644, 121, '2014-02-01 00:34:39.000000', 'temperatura', 531.0000, 'ºC'),
	(181645, 121, '2014-02-01 00:34:40.000000', 'temperatura', 423.0000, 'ºC'),
	(181646, 121, '2014-02-01 00:34:41.000000', 'temperatura', 523.0000, 'ºC'),
	(181647, 121, '2014-02-01 00:34:42.000000', 'temperatura', 148.0000, 'ºC'),
	(181648, 121, '2014-02-01 00:34:43.000000', 'temperatura', 369.0000, 'ºC'),
	(181649, 121, '2014-02-01 00:34:44.000000', 'temperatura', 201.0000, 'ºC'),
	(181650, 121, '2014-02-01 00:34:45.000000', 'temperatura', 1099.0000, 'ºC'),
	(181651, 121, '2014-02-01 00:34:46.000000', 'temperatura', 93.0000, 'ºC'),
	(181652, 121, '2014-02-01 00:34:47.000000', 'temperatura', 769.0000, 'ºC'),
	(181653, 121, '2014-02-01 00:34:48.000000', 'temperatura', 1165.0000, 'ºC'),
	(181654, 121, '2014-02-01 00:34:49.000000', 'temperatura', 1117.0000, 'ºC'),
	(181655, 121, '2014-02-01 00:34:50.000000', 'temperatura', 893.0000, 'ºC'),
	(181656, 121, '2014-02-01 00:34:51.000000', 'temperatura', 1113.0000, 'ºC'),
	(181657, 121, '2014-02-01 00:34:52.000000', 'temperatura', 487.0000, 'ºC'),
	(181658, 121, '2014-02-01 00:34:53.000000', 'temperatura', 295.0000, 'ºC'),
	(181659, 121, '2014-02-01 00:34:54.000000', 'temperatura', 15.0000, 'ºC'),
	(181660, 121, '2014-02-01 00:34:55.000000', 'temperatura', 391.0000, 'ºC'),
	(181661, 121, '2014-02-01 00:34:56.000000', 'temperatura', 710.0000, 'ºC'),
	(181662, 121, '2014-02-01 00:34:57.000000', 'temperatura', 1177.0000, 'ºC'),
	(181663, 121, '2014-02-01 00:34:58.000000', 'temperatura', 154.0000, 'ºC'),
	(181664, 121, '2014-02-01 00:34:59.000000', 'temperatura', 843.0000, 'ºC'),
	(181665, 121, '2014-02-01 00:35:00.000000', 'temperatura', 151.0000, 'ºC'),
	(181666, 121, '2014-02-01 00:35:01.000000', 'temperatura', 626.0000, 'ºC'),
	(181667, 121, '2014-02-01 00:35:02.000000', 'temperatura', 277.0000, 'ºC'),
	(181668, 121, '2014-02-01 00:35:03.000000', 'temperatura', 709.0000, 'ºC'),
	(181669, 121, '2014-02-01 00:35:04.000000', 'temperatura', 313.0000, 'ºC'),
	(181670, 121, '2014-02-01 00:35:05.000000', 'temperatura', 641.0000, 'ºC'),
	(181671, 121, '2014-02-01 00:35:06.000000', 'temperatura', 1066.0000, 'ºC'),
	(181672, 121, '2014-02-01 00:35:07.000000', 'temperatura', 1006.0000, 'ºC'),
	(181673, 121, '2014-02-01 00:35:08.000000', 'temperatura', 633.0000, 'ºC'),
	(181674, 121, '2014-02-01 00:35:09.000000', 'temperatura', 146.0000, 'ºC'),
	(181675, 121, '2014-02-01 00:35:10.000000', 'temperatura', 32.0000, 'ºC'),
	(181676, 121, '2014-02-01 00:35:11.000000', 'temperatura', 925.0000, 'ºC'),
	(181677, 121, '2014-02-01 00:35:12.000000', 'temperatura', 927.0000, 'ºC'),
	(181678, 121, '2014-02-01 00:35:13.000000', 'temperatura', 660.0000, 'ºC'),
	(181679, 121, '2014-02-01 00:35:14.000000', 'temperatura', 522.0000, 'ºC'),
	(181680, 121, '2014-02-01 00:35:15.000000', 'temperatura', 630.0000, 'ºC'),
	(181681, 121, '2014-02-01 00:35:16.000000', 'temperatura', 383.0000, 'ºC'),
	(181682, 121, '2014-02-01 00:35:17.000000', 'temperatura', 27.0000, 'ºC'),
	(181683, 121, '2014-02-01 00:35:18.000000', 'temperatura', 184.0000, 'ºC'),
	(181684, 121, '2014-02-01 00:35:19.000000', 'temperatura', 842.0000, 'ºC'),
	(181685, 121, '2014-02-01 00:35:20.000000', 'temperatura', 59.0000, 'ºC'),
	(181686, 121, '2014-02-01 00:35:21.000000', 'temperatura', 169.0000, 'ºC'),
	(181687, 121, '2014-02-01 00:35:22.000000', 'temperatura', 668.0000, 'ºC'),
	(181688, 121, '2014-02-01 00:35:23.000000', 'temperatura', 433.0000, 'ºC'),
	(181689, 121, '2014-02-01 00:35:24.000000', 'temperatura', 161.0000, 'ºC'),
	(181690, 121, '2014-02-01 00:35:25.000000', 'temperatura', 707.0000, 'ºC'),
	(181691, 121, '2014-02-01 00:35:26.000000', 'temperatura', 651.0000, 'ºC'),
	(181692, 121, '2014-02-01 00:35:27.000000', 'temperatura', 1136.0000, 'ºC'),
	(181693, 121, '2014-02-01 00:35:28.000000', 'temperatura', 127.0000, 'ºC'),
	(181694, 121, '2014-02-01 00:35:29.000000', 'temperatura', 826.0000, 'ºC'),
	(181695, 121, '2014-02-01 00:35:30.000000', 'temperatura', 152.0000, 'ºC'),
	(181696, 121, '2014-02-01 00:35:31.000000', 'temperatura', 680.0000, 'ºC'),
	(181697, 121, '2014-02-01 00:35:32.000000', 'temperatura', 547.0000, 'ºC'),
	(181698, 121, '2014-02-01 00:35:33.000000', 'temperatura', 693.0000, 'ºC'),
	(181699, 121, '2014-02-01 00:35:34.000000', 'temperatura', 627.0000, 'ºC'),
	(181700, 121, '2014-02-01 00:35:35.000000', 'temperatura', 1057.0000, 'ºC'),
	(181701, 121, '2014-02-01 00:35:36.000000', 'temperatura', 1005.0000, 'ºC'),
	(181702, 121, '2014-02-01 00:35:37.000000', 'temperatura', 653.0000, 'ºC'),
	(181703, 121, '2014-02-01 00:35:38.000000', 'temperatura', 252.0000, 'ºC'),
	(181704, 121, '2014-02-01 00:35:39.000000', 'temperatura', 500.0000, 'ºC'),
	(181705, 121, '2014-02-01 00:35:40.000000', 'temperatura', 545.0000, 'ºC'),
	(181706, 121, '2014-02-01 00:35:41.000000', 'temperatura', 26.0000, 'ºC'),
	(181707, 121, '2014-02-01 00:35:42.000000', 'temperatura', 896.0000, 'ºC'),
	(181708, 121, '2014-02-01 00:35:43.000000', 'temperatura', 802.0000, 'ºC'),
	(181709, 121, '2014-02-01 00:35:44.000000', 'temperatura', 122.0000, 'ºC'),
	(181710, 121, '2014-02-01 00:35:45.000000', 'temperatura', 604.0000, 'ºC'),
	(181711, 121, '2014-02-01 00:35:46.000000', 'temperatura', 255.0000, 'ºC'),
	(181712, 121, '2014-02-01 00:35:47.000000', 'temperatura', 662.0000, 'ºC'),
	(181713, 121, '2014-02-01 00:35:48.000000', 'temperatura', 145.0000, 'ºC'),
	(181714, 121, '2014-02-01 00:35:49.000000', 'temperatura', 1139.0000, 'ºC'),
	(181715, 121, '2014-02-01 00:35:50.000000', 'temperatura', 461.0000, 'ºC'),
	(181716, 121, '2014-02-01 00:35:51.000000', 'temperatura', 90.0000, 'ºC'),
	(181717, 121, '2014-02-01 00:35:52.000000', 'temperatura', 268.0000, 'ºC'),
	(181718, 121, '2014-02-01 00:35:53.000000', 'temperatura', 1069.0000, 'ºC'),
	(181719, 121, '2014-02-01 00:35:54.000000', 'temperatura', 944.0000, 'ºC'),
	(181720, 121, '2014-02-01 00:35:55.000000', 'temperatura', 311.0000, 'ºC'),
	(181721, 121, '2014-02-01 00:35:56.000000', 'temperatura', 1122.0000, 'ºC'),
	(181722, 121, '2014-02-01 00:35:57.000000', 'temperatura', 1081.0000, 'ºC'),
	(181723, 121, '2014-02-01 00:35:58.000000', 'temperatura', 838.0000, 'ºC'),
	(181724, 121, '2014-02-01 00:35:59.000000', 'temperatura', 946.0000, 'ºC'),
	(181725, 121, '2014-02-01 00:36:00.000000', 'temperatura', 1017.0000, 'ºC'),
	(181726, 121, '2014-02-01 00:36:01.000000', 'temperatura', 1049.0000, 'ºC'),
	(181727, 121, '2014-02-01 00:36:02.000000', 'temperatura', 992.0000, 'ºC'),
	(181728, 121, '2014-02-01 00:36:03.000000', 'temperatura', 615.0000, 'ºC'),
	(181729, 121, '2014-02-01 00:36:04.000000', 'temperatura', 99.0000, 'ºC'),
	(181730, 121, '2014-02-01 00:36:05.000000', 'temperatura', 1051.0000, 'ºC'),
	(181731, 121, '2014-02-01 00:36:06.000000', 'temperatura', 158.0000, 'ºC'),
	(181732, 121, '2014-02-01 00:36:07.000000', 'temperatura', 40.0000, 'ºC'),
	(181733, 121, '2014-02-01 00:36:08.000000', 'temperatura', 923.0000, 'ºC'),
	(181734, 121, '2014-02-01 00:36:09.000000', 'temperatura', 897.0000, 'ºC'),
	(181735, 121, '2014-02-01 00:36:10.000000', 'temperatura', 515.0000, 'ºC'),
	(181736, 121, '2014-02-01 00:36:11.000000', 'temperatura', 1085.0000, 'ºC'),
	(181737, 121, '2014-02-01 00:36:12.000000', 'temperatura', 282.0000, 'ºC'),
	(181738, 121, '2014-02-01 00:36:13.000000', 'temperatura', 554.0000, 'ºC'),
	(181739, 121, '2014-02-01 00:36:14.000000', 'temperatura', 723.0000, 'ºC'),
	(181740, 121, '2014-02-01 00:36:15.000000', 'temperatura', 755.0000, 'ºC'),
	(181741, 121, '2014-02-01 00:36:16.000000', 'temperatura', 406.0000, 'ºC'),
	(181742, 121, '2014-02-01 00:36:17.000000', 'temperatura', 966.0000, 'ºC'),
	(181743, 121, '2014-02-01 00:36:18.000000', 'temperatura', 11.0000, 'ºC'),
	(181744, 121, '2014-02-01 00:36:19.000000', 'temperatura', 756.0000, 'ºC'),
	(181745, 121, '2014-02-01 00:36:20.000000', 'temperatura', 151.0000, 'ºC'),
	(181746, 121, '2014-02-01 00:36:21.000000', 'temperatura', 885.0000, 'ºC'),
	(181747, 121, '2014-02-01 00:36:22.000000', 'temperatura', 375.0000, 'ºC'),
	(181748, 121, '2014-02-01 00:36:23.000000', 'temperatura', 419.0000, 'ºC'),
	(181749, 121, '2014-02-01 00:36:24.000000', 'temperatura', 970.0000, 'ºC'),
	(181750, 121, '2014-02-01 00:36:25.000000', 'temperatura', 1196.0000, 'ºC'),
	(181751, 121, '2014-02-01 00:36:26.000000', 'temperatura', 670.0000, 'ºC'),
	(181752, 121, '2014-02-01 00:36:27.000000', 'temperatura', 961.0000, 'ºC'),
	(181753, 121, '2014-02-01 00:36:28.000000', 'temperatura', 397.0000, 'ºC'),
	(181754, 121, '2014-02-01 00:36:29.000000', 'temperatura', 302.0000, 'ºC'),
	(181755, 121, '2014-02-01 00:36:30.000000', 'temperatura', 318.0000, 'ºC'),
	(181756, 121, '2014-02-01 00:36:31.000000', 'temperatura', 687.0000, 'ºC'),
	(181757, 121, '2014-02-01 00:36:32.000000', 'temperatura', 80.0000, 'ºC'),
	(181758, 121, '2014-02-01 00:36:33.000000', 'temperatura', 741.0000, 'ºC'),
	(181759, 121, '2014-02-01 00:36:34.000000', 'temperatura', 1065.0000, 'ºC'),
	(181760, 121, '2014-02-01 00:36:35.000000', 'temperatura', 702.0000, 'ºC'),
	(181761, 121, '2014-02-01 00:36:36.000000', 'temperatura', 316.0000, 'ºC'),
	(181762, 121, '2014-02-01 00:36:37.000000', 'temperatura', 676.0000, 'ºC'),
	(181763, 121, '2014-02-01 00:36:38.000000', 'temperatura', 30.0000, 'ºC'),
	(181764, 121, '2014-02-01 00:36:39.000000', 'temperatura', 525.0000, 'ºC'),
	(181765, 121, '2014-02-01 00:36:40.000000', 'temperatura', 133.0000, 'ºC'),
	(181766, 121, '2014-02-01 00:36:41.000000', 'temperatura', 291.0000, 'ºC'),
	(181767, 121, '2014-02-01 00:36:42.000000', 'temperatura', 1055.0000, 'ºC'),
	(181768, 121, '2014-02-01 00:36:43.000000', 'temperatura', 805.0000, 'ºC'),
	(181769, 121, '2014-02-01 00:36:44.000000', 'temperatura', 862.0000, 'ºC'),
	(181770, 121, '2014-02-01 00:36:45.000000', 'temperatura', 692.0000, 'ºC'),
	(181771, 121, '2014-02-01 00:36:46.000000', 'temperatura', 875.0000, 'ºC'),
	(181772, 121, '2014-02-01 00:36:47.000000', 'temperatura', 1100.0000, 'ºC'),
	(181773, 121, '2014-02-01 00:36:48.000000', 'temperatura', 475.0000, 'ºC'),
	(181774, 121, '2014-02-01 00:36:49.000000', 'temperatura', 275.0000, 'ºC'),
	(181775, 121, '2014-02-01 00:36:50.000000', 'temperatura', 1153.0000, 'ºC'),
	(181776, 121, '2014-02-01 00:36:51.000000', 'temperatura', 138.0000, 'ºC'),
	(181777, 121, '2014-02-01 00:36:52.000000', 'temperatura', 831.0000, 'ºC'),
	(181778, 121, '2014-02-01 00:36:53.000000', 'temperatura', 144.0000, 'ºC'),
	(181779, 121, '2014-02-01 00:36:54.000000', 'temperatura', 625.0000, 'ºC'),
	(181780, 121, '2014-02-01 00:36:55.000000', 'temperatura', 294.0000, 'ºC'),
	(181781, 121, '2014-02-01 00:36:56.000000', 'temperatura', 795.0000, 'ºC'),
	(181782, 121, '2014-02-01 00:36:57.000000', 'temperatura', 695.0000, 'ºC'),
	(181783, 121, '2014-02-01 00:36:58.000000', 'temperatura', 1088.0000, 'ºC'),
	(181784, 121, '2014-02-01 00:36:59.000000', 'temperatura', 957.0000, 'ºC'),
	(181785, 121, '2014-02-01 00:37:00.000000', 'temperatura', 321.0000, 'ºC'),
	(181786, 121, '2014-02-01 00:37:01.000000', 'temperatura', 1135.0000, 'ºC'),
	(181787, 121, '2014-02-01 00:37:02.000000', 'temperatura', 1110.0000, 'ºC'),
	(181788, 121, '2014-02-01 00:37:03.000000', 'temperatura', 949.0000, 'ºC'),
	(181789, 121, '2014-02-01 00:37:04.000000', 'temperatura', 213.0000, 'ºC'),
	(181790, 121, '2014-02-01 00:37:05.000000', 'temperatura', 618.0000, 'ºC'),
	(181791, 121, '2014-02-01 00:37:06.000000', 'temperatura', 51.0000, 'ºC'),
	(181792, 121, '2014-02-01 00:37:07.000000', 'temperatura', 804.0000, 'ºC'),
	(181793, 121, '2014-02-01 00:37:08.000000', 'temperatura', 268.0000, 'ºC'),
	(181794, 121, '2014-02-01 00:37:09.000000', 'temperatura', 128.0000, 'ºC'),
	(181795, 121, '2014-02-01 00:37:10.000000', 'temperatura', 1034.0000, 'ºC'),
	(181796, 121, '2014-02-01 00:37:11.000000', 'temperatura', 1190.0000, 'ºC'),
	(181797, 121, '2014-02-01 00:37:12.000000', 'temperatura', 448.0000, 'ºC'),
	(181798, 121, '2014-02-01 00:37:13.000000', 'temperatura', 1068.0000, 'ºC'),
	(181799, 121, '2014-02-01 00:37:14.000000', 'temperatura', 397.0000, 'ºC'),
	(181800, 121, '2014-02-01 00:37:15.000000', 'temperatura', 1183.0000, 'ºC'),
	(181801, 121, '2014-02-01 00:37:16.000000', 'temperatura', 1123.0000, 'ºC'),
	(181802, 121, '2014-02-01 00:37:17.000000', 'temperatura', 866.0000, 'ºC'),
	(181803, 121, '2014-02-01 00:37:18.000000', 'temperatura', 964.0000, 'ºC'),
	(181804, 121, '2014-02-01 00:37:19.000000', 'temperatura', 1020.0000, 'ºC'),
	(181805, 121, '2014-02-01 00:37:20.000000', 'temperatura', 1010.0000, 'ºC'),
	(181806, 121, '2014-02-01 00:37:21.000000', 'temperatura', 791.0000, 'ºC'),
	(181807, 121, '2014-02-01 00:37:22.000000', 'temperatura', 926.0000, 'ºC'),
	(181808, 121, '2014-02-01 00:37:23.000000', 'temperatura', 1057.0000, 'ºC'),
	(181809, 121, '2014-02-01 00:37:24.000000', 'temperatura', 109.0000, 'ºC'),
	(181810, 121, '2014-02-01 00:37:25.000000', 'temperatura', 973.0000, 'ºC'),
	(181811, 121, '2014-02-01 00:37:26.000000', 'temperatura', 939.0000, 'ºC'),
	(181812, 121, '2014-02-01 00:37:27.000000', 'temperatura', 576.0000, 'ºC'),
	(181813, 121, '2014-02-01 00:37:28.000000', 'temperatura', 64.0000, 'ºC'),
	(181814, 121, '2014-02-01 00:37:29.000000', 'temperatura', 993.0000, 'ºC'),
	(181815, 121, '2014-02-01 00:37:30.000000', 'temperatura', 1173.0000, 'ºC'),
	(181816, 121, '2014-02-01 00:37:31.000000', 'temperatura', 489.0000, 'ºC'),
	(181817, 121, '2014-02-01 00:37:32.000000', 'temperatura', 123.0000, 'ºC'),
	(181818, 121, '2014-02-01 00:37:33.000000', 'temperatura', 349.0000, 'ºC'),
	(181819, 121, '2014-02-01 00:37:34.000000', 'temperatura', 178.0000, 'ºC'),
	(181820, 121, '2014-02-01 00:37:35.000000', 'temperatura', 1045.0000, 'ºC'),
	(181821, 121, '2014-02-01 00:37:36.000000', 'temperatura', 1088.0000, 'ºC'),
	(181822, 121, '2014-02-01 00:37:37.000000', 'temperatura', 1107.0000, 'ºC'),
	(181823, 121, '2014-02-01 00:37:38.000000', 'temperatura', 1073.0000, 'ºC'),
	(181824, 121, '2014-02-01 00:37:39.000000', 'temperatura', 843.0000, 'ºC'),
	(181825, 121, '2014-02-01 00:37:40.000000', 'temperatura', 996.0000, 'ºC'),
	(181826, 121, '2014-02-01 00:37:41.000000', 'temperatura', 50.0000, 'ºC'),
	(181827, 121, '2014-02-01 00:37:42.000000', 'temperatura', 866.0000, 'ºC'),
	(181828, 121, '2014-02-01 00:37:43.000000', 'temperatura', 579.0000, 'ºC'),
	(181829, 121, '2014-02-01 00:37:44.000000', 'temperatura', 296.0000, 'ºC'),
	(181830, 121, '2014-02-01 00:37:45.000000', 'temperatura', 944.0000, 'ºC'),
	(181831, 121, '2014-02-01 00:37:46.000000', 'temperatura', 231.0000, 'ºC'),
	(181832, 121, '2014-02-01 00:37:47.000000', 'temperatura', 726.0000, 'ºC'),
	(181833, 121, '2014-02-01 00:37:48.000000', 'temperatura', 536.0000, 'ºC'),
	(181834, 121, '2014-02-01 00:37:49.000000', 'temperatura', 501.0000, 'ºC'),
	(181835, 121, '2014-02-01 00:37:50.000000', 'temperatura', 901.0000, 'ºC'),
	(181836, 121, '2014-02-01 00:37:51.000000', 'temperatura', 600.0000, 'ºC'),
	(181837, 121, '2014-02-01 00:37:52.000000', 'temperatura', 296.0000, 'ºC'),
	(181838, 121, '2014-02-01 00:37:53.000000', 'temperatura', 883.0000, 'ºC'),
	(181839, 121, '2014-02-01 00:37:54.000000', 'temperatura', 1126.0000, 'ºC'),
	(181840, 121, '2014-02-01 00:37:55.000000', 'temperatura', 582.0000, 'ºC'),
	(181841, 121, '2014-02-01 00:37:56.000000', 'temperatura', 733.0000, 'ºC'),
	(181842, 121, '2014-02-01 00:37:57.000000', 'temperatura', 720.0000, 'ºC'),
	(181843, 121, '2014-02-01 00:37:58.000000', 'temperatura', 199.0000, 'ºC'),
	(181844, 121, '2014-02-01 00:37:59.000000', 'temperatura', 36.0000, 'ºC'),
	(181845, 121, '2014-02-01 00:38:00.000000', 'temperatura', 784.0000, 'ºC'),
	(181846, 121, '2014-02-01 00:38:01.000000', 'temperatura', 213.0000, 'ºC'),
	(181847, 121, '2014-02-01 00:38:02.000000', 'temperatura', 1111.0000, 'ºC'),
	(181848, 121, '2014-02-01 00:38:03.000000', 'temperatura', 119.0000, 'ºC'),
	(181849, 121, '2014-02-01 00:38:04.000000', 'temperatura', 860.0000, 'ºC'),
	(181850, 121, '2014-02-01 00:38:05.000000', 'temperatura', 344.0000, 'ºC'),
	(181851, 121, '2014-02-01 00:38:06.000000', 'temperatura', 343.0000, 'ºC'),
	(181852, 121, '2014-02-01 00:38:07.000000', 'temperatura', 681.0000, 'ºC'),
	(181853, 121, '2014-02-01 00:38:08.000000', 'temperatura', 1176.0000, 'ºC'),
	(181854, 121, '2014-02-01 00:38:09.000000', 'temperatura', 240.0000, 'ºC'),
	(181855, 121, '2014-02-01 00:38:10.000000', 'temperatura', 73.0000, 'ºC'),
	(181856, 121, '2014-02-01 00:38:11.000000', 'temperatura', 845.0000, 'ºC'),
	(181857, 121, '2014-02-01 00:38:12.000000', 'temperatura', 406.0000, 'ºC'),
	(181858, 121, '2014-02-01 00:38:13.000000', 'temperatura', 695.0000, 'ºC'),
	(181859, 121, '2014-02-01 00:38:14.000000', 'temperatura', 1058.0000, 'ºC'),
	(181860, 121, '2014-02-01 00:38:15.000000', 'temperatura', 806.0000, 'ºC'),
	(181861, 121, '2014-02-01 00:38:16.000000', 'temperatura', 858.0000, 'ºC'),
	(181862, 121, '2014-02-01 00:38:17.000000', 'temperatura', 670.0000, 'ºC'),
	(181863, 121, '2014-02-01 00:38:18.000000', 'temperatura', 777.0000, 'ºC'),
	(181864, 121, '2014-02-01 00:38:19.000000', 'temperatura', 676.0000, 'ºC'),
	(181865, 121, '2014-02-01 00:38:20.000000', 'temperatura', 1049.0000, 'ºC'),
	(181866, 121, '2014-02-01 00:38:21.000000', 'temperatura', 818.0000, 'ºC'),
	(181867, 121, '2014-02-01 00:38:22.000000', 'temperatura', 943.0000, 'ºC'),
	(181868, 121, '2014-02-01 00:38:23.000000', 'temperatura', 1063.0000, 'ºC'),
	(181869, 121, '2014-02-01 00:38:24.000000', 'temperatura', 84.0000, 'ºC'),
	(181870, 121, '2014-02-01 00:38:25.000000', 'temperatura', 832.0000, 'ºC'),
	(181871, 121, '2014-02-01 00:38:26.000000', 'temperatura', 307.0000, 'ºC'),
	(181872, 121, '2014-02-01 00:38:27.000000', 'temperatura', 243.0000, 'ºC'),
	(181873, 121, '2014-02-01 00:38:28.000000', 'temperatura', 291.0000, 'ºC'),
	(181874, 121, '2014-02-01 00:38:29.000000', 'temperatura', 729.0000, 'ºC'),
	(181875, 121, '2014-02-01 00:38:30.000000', 'temperatura', 372.0000, 'ºC'),
	(181876, 121, '2014-02-01 00:38:31.000000', 'temperatura', 873.0000, 'ºC'),
	(181877, 121, '2014-02-01 00:38:32.000000', 'temperatura', 849.0000, 'ºC'),
	(181878, 121, '2014-02-01 00:38:33.000000', 'temperatura', 427.0000, 'ºC'),
	(181879, 121, '2014-02-01 00:38:34.000000', 'temperatura', 790.0000, 'ºC'),
	(181880, 121, '2014-02-01 00:38:35.000000', 'temperatura', 267.0000, 'ºC'),
	(181881, 121, '2014-02-01 00:38:36.000000', 'temperatura', 166.0000, 'ºC'),
	(181882, 121, '2014-02-01 00:38:37.000000', 'temperatura', 30.0000, 'ºC'),
	(181883, 121, '2014-02-01 00:38:38.000000', 'temperatura', 854.0000, 'ºC'),
	(181884, 121, '2014-02-01 00:38:39.000000', 'temperatura', 581.0000, 'ºC'),
	(181885, 121, '2014-02-01 00:38:40.000000', 'temperatura', 341.0000, 'ºC'),
	(181886, 121, '2014-02-01 00:38:41.000000', 'temperatura', 1164.0000, 'ºC'),
	(181887, 121, '2014-02-01 00:38:42.000000', 'temperatura', 1199.0000, 'ºC'),
	(181888, 121, '2014-02-01 00:38:43.000000', 'temperatura', 103.0000, 'ºC'),
	(181889, 121, '2014-02-01 00:38:44.000000', 'temperatura', 518.0000, 'ºC'),
	(181890, 121, '2014-02-01 00:38:45.000000', 'temperatura', 1084.0000, 'ºC'),
	(181891, 121, '2014-02-01 00:38:46.000000', 'temperatura', 263.0000, 'ºC'),
	(181892, 121, '2014-02-01 00:38:47.000000', 'temperatura', 464.0000, 'ºC'),
	(181893, 121, '2014-02-01 00:38:48.000000', 'temperatura', 333.0000, 'ºC'),
	(181894, 121, '2014-02-01 00:38:49.000000', 'temperatura', 272.0000, 'ºC'),
	(181895, 121, '2014-02-01 00:38:50.000000', 'temperatura', 364.0000, 'ºC'),
	(181896, 121, '2014-02-01 00:38:51.000000', 'temperatura', 1002.0000, 'ºC'),
	(181897, 121, '2014-02-01 00:38:52.000000', 'temperatura', 318.0000, 'ºC'),
	(181898, 121, '2014-02-01 00:38:53.000000', 'temperatura', 984.0000, 'ºC'),
	(181899, 121, '2014-02-01 00:38:54.000000', 'temperatura', 368.0000, 'ºC'),
	(181900, 121, '2014-02-01 00:38:55.000000', 'temperatura', 87.0000, 'ºC'),
	(181901, 121, '2014-02-01 00:38:56.000000', 'temperatura', 534.0000, 'ºC'),
	(181902, 121, '2014-02-01 00:38:57.000000', 'temperatura', 6.0000, 'ºC'),
	(181903, 121, '2014-02-01 00:38:58.000000', 'temperatura', 831.0000, 'ºC'),
	(181904, 121, '2014-02-01 00:38:59.000000', 'temperatura', 539.0000, 'ºC'),
	(181905, 121, '2014-02-01 00:39:00.000000', 'temperatura', 201.0000, 'ºC'),
	(181906, 121, '2014-02-01 00:39:01.000000', 'temperatura', 586.0000, 'ºC'),
	(181907, 121, '2014-02-01 00:39:02.000000', 'temperatura', 1131.0000, 'ºC'),
	(181908, 121, '2014-02-01 00:39:03.000000', 'temperatura', 297.0000, 'ºC'),
	(181909, 121, '2014-02-01 00:39:04.000000', 'temperatura', 493.0000, 'ºC'),
	(181910, 121, '2014-02-01 00:39:05.000000', 'temperatura', 374.0000, 'ºC'),
	(181911, 121, '2014-02-01 00:39:06.000000', 'temperatura', 390.0000, 'ºC'),
	(181912, 121, '2014-02-01 00:39:07.000000', 'temperatura', 828.0000, 'ºC'),
	(181913, 121, '2014-02-01 00:39:08.000000', 'temperatura', 572.0000, 'ºC'),
	(181914, 121, '2014-02-01 00:39:09.000000', 'temperatura', 378.0000, 'ºC'),
	(181915, 121, '2014-02-01 00:39:10.000000', 'temperatura', 172.0000, 'ºC'),
	(181916, 121, '2014-02-01 00:39:11.000000', 'temperatura', 926.0000, 'ºC'),
	(181917, 121, '2014-02-01 00:39:12.000000', 'temperatura', 516.0000, 'ºC'),
	(181918, 121, '2014-02-01 00:39:13.000000', 'temperatura', 1003.0000, 'ºC'),
	(181919, 121, '2014-02-01 00:39:14.000000', 'temperatura', 1069.0000, 'ºC'),
	(181920, 121, '2014-02-01 00:39:15.000000', 'temperatura', 1133.0000, 'ºC'),
	(181921, 121, '2014-02-01 00:39:16.000000', 'temperatura', 59.0000, 'ºC'),
	(181922, 121, '2014-02-01 00:39:17.000000', 'temperatura', 499.0000, 'ºC'),
	(181923, 121, '2014-02-01 00:39:18.000000', 'temperatura', 1117.0000, 'ºC'),
	(181924, 121, '2014-02-01 00:39:19.000000', 'temperatura', 490.0000, 'ºC'),
	(181925, 121, '2014-02-01 00:39:20.000000', 'temperatura', 298.0000, 'ºC'),
	(181926, 121, '2014-02-01 00:39:21.000000', 'temperatura', 20.0000, 'ºC'),
	(181927, 121, '2014-02-01 00:39:22.000000', 'temperatura', 407.0000, 'ºC'),
	(181928, 121, '2014-02-01 00:39:23.000000', 'temperatura', 778.0000, 'ºC'),
	(181929, 121, '2014-02-01 00:39:24.000000', 'temperatura', 266.0000, 'ºC'),
	(181930, 121, '2014-02-01 00:39:25.000000', 'temperatura', 198.0000, 'ºC'),
	(181931, 121, '2014-02-01 00:39:26.000000', 'temperatura', 191.0000, 'ºC'),
	(181932, 121, '2014-02-01 00:39:27.000000', 'temperatura', 362.0000, 'ºC'),
	(181933, 121, '2014-02-01 00:39:28.000000', 'temperatura', 38.0000, 'ºC'),
	(181934, 121, '2014-02-01 00:39:29.000000', 'temperatura', 305.0000, 'ºC'),
	(181935, 121, '2014-02-01 00:39:30.000000', 'temperatura', 209.0000, 'ºC'),
	(181936, 121, '2014-02-01 00:39:31.000000', 'temperatura', 133.0000, 'ºC'),
	(181937, 121, '2014-02-01 00:39:32.000000', 'temperatura', 37.0000, 'ºC'),
	(181938, 121, '2014-02-01 00:39:33.000000', 'temperatura', 988.0000, 'ºC'),
	(181939, 121, '2014-02-01 00:39:34.000000', 'temperatura', 28.0000, 'ºC'),
	(181940, 121, '2014-02-01 00:39:35.000000', 'temperatura', 776.0000, 'ºC'),
	(181941, 121, '2014-02-01 00:39:36.000000', 'temperatura', 196.0000, 'ºC'),
	(181942, 121, '2014-02-01 00:39:37.000000', 'temperatura', 1054.0000, 'ºC'),
	(181943, 121, '2014-02-01 00:39:38.000000', 'temperatura', 1083.0000, 'ºC'),
	(181944, 121, '2014-02-01 00:39:39.000000', 'temperatura', 1054.0000, 'ºC'),
	(181945, 121, '2014-02-01 00:39:40.000000', 'temperatura', 822.0000, 'ºC'),
	(181946, 121, '2014-02-01 00:39:41.000000', 'temperatura', 948.0000, 'ºC'),
	(181947, 121, '2014-02-01 00:39:42.000000', 'temperatura', 1074.0000, 'ºC'),
	(181948, 121, '2014-02-01 00:39:43.000000', 'temperatura', 128.0000, 'ºC'),
	(181949, 121, '2014-02-01 00:39:44.000000', 'temperatura', 1020.0000, 'ºC'),
	(181950, 121, '2014-02-01 00:39:45.000000', 'temperatura', 1113.0000, 'ºC'),
	(181951, 121, '2014-02-01 00:39:46.000000', 'temperatura', 108.0000, 'ºC'),
	(181952, 121, '2014-02-01 00:39:47.000000', 'temperatura', 799.0000, 'ºC'),
	(181953, 121, '2014-02-01 00:39:48.000000', 'temperatura', 73.0000, 'ºC'),
	(181954, 121, '2014-02-01 00:39:49.000000', 'temperatura', 367.0000, 'ºC'),
	(181955, 121, '2014-02-01 00:39:50.000000', 'temperatura', 419.0000, 'ºC'),
	(181956, 121, '2014-02-01 00:39:51.000000', 'temperatura', 992.0000, 'ºC'),
	(181957, 121, '2014-02-01 00:39:52.000000', 'temperatura', 103.0000, 'ºC'),
	(181958, 121, '2014-02-01 00:39:53.000000', 'temperatura', 1139.0000, 'ºC'),
	(181959, 121, '2014-02-01 00:39:54.000000', 'temperatura', 587.0000, 'ºC'),
	(181960, 121, '2014-02-01 00:39:55.000000', 'temperatura', 720.0000, 'ºC'),
	(181961, 121, '2014-02-01 00:39:56.000000', 'temperatura', 640.0000, 'ºC'),
	(181962, 121, '2014-02-01 00:39:57.000000', 'temperatura', 1039.0000, 'ºC'),
	(181963, 121, '2014-02-01 00:39:58.000000', 'temperatura', 878.0000, 'ºC'),
	(181964, 121, '2014-02-01 00:39:59.000000', 'temperatura', 70.0000, 'ºC'),
	(181965, 121, '2014-02-01 00:40:00.000000', 'temperatura', 119.0000, 'ºC'),
	(181966, 121, '2014-02-01 00:40:01.000000', 'temperatura', 386.0000, 'ºC'),
	(181967, 121, '2014-02-01 00:40:02.000000', 'temperatura', 375.0000, 'ºC'),
	(181968, 121, '2014-02-01 00:40:03.000000', 'temperatura', 715.0000, 'ºC'),
	(181969, 121, '2014-02-01 00:40:04.000000', 'temperatura', 50.0000, 'ºC'),
	(181970, 121, '2014-02-01 00:40:05.000000', 'temperatura', 505.0000, 'ºC'),
	(181971, 121, '2014-02-01 00:40:06.000000', 'temperatura', 1177.0000, 'ºC'),
	(181972, 121, '2014-02-01 00:40:07.000000', 'temperatura', 770.0000, 'ºC'),
	(181973, 121, '2014-02-01 00:40:08.000000', 'temperatura', 321.0000, 'ºC'),
	(181974, 121, '2014-02-01 00:40:09.000000', 'temperatura', 493.0000, 'ºC'),
	(181975, 121, '2014-02-01 00:40:10.000000', 'temperatura', 305.0000, 'ºC'),
	(181976, 121, '2014-02-01 00:40:11.000000', 'temperatura', 47.0000, 'ºC'),
	(181977, 121, '2014-02-01 00:40:12.000000', 'temperatura', 519.0000, 'ºC'),
	(181978, 121, '2014-02-01 00:40:13.000000', 'temperatura', 54.0000, 'ºC'),
	(181979, 121, '2014-02-01 00:40:14.000000', 'temperatura', 1116.0000, 'ºC'),
	(181980, 121, '2014-02-01 00:40:15.000000', 'temperatura', 618.0000, 'ºC'),
	(181981, 121, '2014-02-01 00:40:16.000000', 'temperatura', 940.0000, 'ºC'),
	(181982, 121, '2014-02-01 00:40:17.000000', 'temperatura', 449.0000, 'ºC'),
	(181983, 121, '2014-02-01 00:40:18.000000', 'temperatura', 623.0000, 'ºC'),
	(181984, 121, '2014-02-01 00:40:19.000000', 'temperatura', 571.0000, 'ºC'),
	(181985, 121, '2014-02-01 00:40:20.000000', 'temperatura', 984.0000, 'ºC'),
	(181986, 121, '2014-02-01 00:40:21.000000', 'temperatura', 810.0000, 'ºC'),
	(181987, 121, '2014-02-01 00:40:22.000000', 'temperatura', 1098.0000, 'ºC'),
	(181988, 121, '2014-02-01 00:40:23.000000', 'temperatura', 661.0000, 'ºC'),
	(181989, 121, '2014-02-01 00:40:24.000000', 'temperatura', 11.0000, 'ºC'),
	(181990, 121, '2014-02-01 00:40:25.000000', 'temperatura', 471.0000, 'ºC'),
	(181991, 121, '2014-02-01 00:40:26.000000', 'temperatura', 1122.0000, 'ºC'),
	(181992, 121, '2014-02-01 00:40:27.000000', 'temperatura', 599.0000, 'ºC'),
	(181993, 121, '2014-02-01 00:40:28.000000', 'temperatura', 830.0000, 'ºC'),
	(181994, 121, '2014-02-01 00:40:29.000000', 'temperatura', 1154.0000, 'ºC'),
	(181995, 121, '2014-02-01 00:40:30.000000', 'temperatura', 881.0000, 'ºC'),
	(181996, 121, '2014-02-01 00:40:31.000000', 'temperatura', 942.0000, 'ºC'),
	(181997, 121, '2014-02-01 00:40:32.000000', 'temperatura', 868.0000, 'ºC'),
	(181998, 121, '2014-02-01 00:40:33.000000', 'temperatura', 314.0000, 'ºC'),
	(181999, 121, '2014-02-01 00:40:34.000000', 'temperatura', 168.0000, 'ºC'),
	(182000, 121, '2014-02-01 00:40:35.000000', 'temperatura', 1099.0000, 'ºC'),
	(182001, 121, '2014-02-01 00:40:36.000000', 'temperatura', 189.0000, 'ºC'),
	(182002, 121, '2014-02-01 00:40:37.000000', 'temperatura', 51.0000, 'ºC'),
	(182003, 121, '2014-02-01 00:40:38.000000', 'temperatura', 886.0000, 'ºC'),
	(182004, 121, '2014-02-01 00:40:39.000000', 'temperatura', 677.0000, 'ºC'),
	(182005, 121, '2014-02-01 00:40:40.000000', 'temperatura', 726.0000, 'ºC'),
	(182006, 121, '2014-02-01 00:40:41.000000', 'temperatura', 403.0000, 'ºC'),
	(182007, 121, '2014-02-01 00:40:42.000000', 'temperatura', 1038.0000, 'ºC'),
	(182008, 121, '2014-02-01 00:40:43.000000', 'temperatura', 379.0000, 'ºC'),
	(182009, 121, '2014-02-01 00:40:44.000000', 'temperatura', 1182.0000, 'ºC'),
	(182010, 121, '2014-02-01 00:40:45.000000', 'temperatura', 1173.0000, 'ºC'),
	(182011, 121, '2014-02-01 00:40:46.000000', 'temperatura', 1122.0000, 'ºC'),
	(182012, 121, '2014-02-01 00:40:47.000000', 'temperatura', 891.0000, 'ºC'),
	(182013, 121, '2014-02-01 00:40:48.000000', 'temperatura', 1088.0000, 'ºC'),
	(182014, 121, '2014-02-01 00:40:49.000000', 'temperatura', 366.0000, 'ºC'),
	(182015, 121, '2014-02-01 00:40:50.000000', 'temperatura', 969.0000, 'ºC'),
	(182016, 121, '2014-02-01 00:40:51.000000', 'temperatura', 146.0000, 'ºC'),
	(182017, 121, '2014-02-01 00:40:52.000000', 'temperatura', 224.0000, 'ºC'),
	(182018, 121, '2014-02-01 00:40:53.000000', 'temperatura', 681.0000, 'ºC'),
	(182019, 121, '2014-02-01 00:40:54.000000', 'temperatura', 335.0000, 'ºC'),
	(182020, 121, '2014-02-01 00:40:55.000000', 'temperatura', 831.0000, 'ºC'),
	(182021, 121, '2014-02-01 00:40:56.000000', 'temperatura', 750.0000, 'ºC'),
	(182022, 121, '2014-02-01 00:40:57.000000', 'temperatura', 57.0000, 'ºC'),
	(182023, 121, '2014-02-01 00:40:58.000000', 'temperatura', 435.0000, 'ºC'),
	(182024, 121, '2014-02-01 00:40:59.000000', 'temperatura', 805.0000, 'ºC'),
	(182025, 121, '2014-02-01 00:41:00.000000', 'temperatura', 321.0000, 'ºC'),
	(182026, 121, '2014-02-01 00:41:01.000000', 'temperatura', 389.0000, 'ºC'),
	(182027, 121, '2014-02-01 00:41:02.000000', 'temperatura', 984.0000, 'ºC'),
	(182028, 121, '2014-02-01 00:41:03.000000', 'temperatura', 152.0000, 'ºC'),
	(182029, 121, '2014-02-01 00:41:04.000000', 'temperatura', 209.0000, 'ºC'),
	(182030, 121, '2014-02-01 00:41:05.000000', 'temperatura', 589.0000, 'ºC'),
	(182031, 121, '2014-02-01 00:41:06.000000', 'temperatura', 1120.0000, 'ºC'),
	(182032, 121, '2014-02-01 00:41:07.000000', 'temperatura', 232.0000, 'ºC'),
	(182033, 121, '2014-02-01 00:41:08.000000', 'temperatura', 199.0000, 'ºC'),
	(182034, 121, '2014-02-01 00:41:09.000000', 'temperatura', 301.0000, 'ºC'),
	(182035, 121, '2014-02-01 00:41:10.000000', 'temperatura', 909.0000, 'ºC'),
	(182036, 121, '2014-02-01 00:41:11.000000', 'temperatura', 41.0000, 'ºC'),
	(182037, 121, '2014-02-01 00:41:12.000000', 'temperatura', 1078.0000, 'ºC'),
	(182038, 121, '2014-02-01 00:41:13.000000', 'temperatura', 468.0000, 'ºC'),
	(182039, 121, '2014-02-01 00:41:14.000000', 'temperatura', 308.0000, 'ºC'),
	(182040, 121, '2014-02-01 00:41:15.000000', 'temperatura', 134.0000, 'ºC'),
	(182041, 121, '2014-02-01 00:41:16.000000', 'temperatura', 947.0000, 'ºC'),
	(182042, 121, '2014-02-01 00:41:17.000000', 'temperatura', 735.0000, 'ºC'),
	(182043, 121, '2014-02-01 00:41:18.000000', 'temperatura', 836.0000, 'ºC'),
	(182044, 121, '2014-02-01 00:41:19.000000', 'temperatura', 773.0000, 'ºC'),
	(182045, 121, '2014-02-01 00:41:20.000000', 'temperatura', 158.0000, 'ºC'),
	(182046, 121, '2014-02-01 00:41:21.000000', 'temperatura', 872.0000, 'ºC'),
	(182047, 121, '2014-02-01 00:41:22.000000', 'temperatura', 288.0000, 'ºC'),
	(182048, 121, '2014-02-01 00:41:23.000000', 'temperatura', 21.0000, 'ºC'),
	(182049, 121, '2014-02-01 00:41:24.000000', 'temperatura', 444.0000, 'ºC'),
	(182050, 121, '2014-02-01 00:41:25.000000', 'temperatura', 959.0000, 'ºC'),
	(182051, 121, '2014-02-01 00:41:26.000000', 'temperatura', 1061.0000, 'ºC'),
	(182052, 121, '2014-02-01 00:41:27.000000', 'temperatura', 30.0000, 'ºC'),
	(182053, 121, '2014-02-01 00:41:28.000000', 'temperatura', 566.0000, 'ºC'),
	(182054, 121, '2014-02-01 00:41:29.000000', 'temperatura', 341.0000, 'ºC'),
	(182055, 121, '2014-02-01 00:41:30.000000', 'temperatura', 7.0000, 'ºC'),
	(182056, 121, '2014-02-01 00:41:31.000000', 'temperatura', 213.0000, 'ºC'),
	(182057, 121, '2014-02-01 00:41:32.000000', 'temperatura', 1046.0000, 'ºC'),
	(182058, 121, '2014-02-01 00:41:33.000000', 'temperatura', 989.0000, 'ºC'),
	(182059, 121, '2014-02-01 00:41:34.000000', 'temperatura', 609.0000, 'ºC'),
	(182060, 121, '2014-02-01 00:41:35.000000', 'temperatura', 77.0000, 'ºC'),
	(182061, 121, '2014-02-01 00:41:36.000000', 'temperatura', 959.0000, 'ºC'),
	(182062, 121, '2014-02-01 00:41:37.000000', 'temperatura', 965.0000, 'ºC'),
	(182063, 121, '2014-02-01 00:41:38.000000', 'temperatura', 748.0000, 'ºC'),
	(182064, 121, '2014-02-01 00:41:39.000000', 'temperatura', 846.0000, 'ºC'),
	(182065, 121, '2014-02-01 00:41:40.000000', 'temperatura', 785.0000, 'ºC'),
	(182066, 121, '2014-02-01 00:41:41.000000', 'temperatura', 189.0000, 'ºC'),
	(182067, 121, '2014-02-01 00:41:42.000000', 'temperatura', 988.0000, 'ºC'),
	(182068, 121, '2014-02-01 00:41:43.000000', 'temperatura', 776.0000, 'ºC'),
	(182069, 121, '2014-02-01 00:41:44.000000', 'temperatura', 915.0000, 'ºC'),
	(182070, 121, '2014-02-01 00:41:45.000000', 'temperatura', 1050.0000, 'ºC'),
	(182071, 121, '2014-02-01 00:41:46.000000', 'temperatura', 103.0000, 'ºC'),
	(182072, 121, '2014-02-01 00:41:47.000000', 'temperatura', 968.0000, 'ºC'),
	(182073, 121, '2014-02-01 00:41:48.000000', 'temperatura', 930.0000, 'ºC'),
	(182074, 121, '2014-02-01 00:41:49.000000', 'temperatura', 545.0000, 'ºC'),
	(182075, 121, '2014-02-01 00:41:50.000000', 'temperatura', 1138.0000, 'ºC'),
	(182076, 121, '2014-02-01 00:41:51.000000', 'temperatura', 456.0000, 'ºC'),
	(182077, 121, '2014-02-01 00:41:52.000000', 'temperatura', 68.0000, 'ºC'),
	(182078, 121, '2014-02-01 00:41:53.000000', 'temperatura', 169.0000, 'ºC'),
	(182079, 121, '2014-02-01 00:41:54.000000', 'temperatura', 643.0000, 'ºC'),
	(182080, 121, '2014-02-01 00:41:55.000000', 'temperatura', 307.0000, 'ºC'),
	(182081, 121, '2014-02-01 00:41:56.000000', 'temperatura', 809.0000, 'ºC'),
	(182082, 121, '2014-02-01 00:41:57.000000', 'temperatura', 723.0000, 'ºC'),
	(182083, 121, '2014-02-01 00:41:58.000000', 'temperatura', 1190.0000, 'ºC'),
	(182084, 121, '2014-02-01 00:41:59.000000', 'temperatura', 181.0000, 'ºC'),
	(182085, 121, '2014-02-01 00:42:00.000000', 'temperatura', 937.0000, 'ºC'),
	(182086, 121, '2014-02-01 00:42:01.000000', 'temperatura', 542.0000, 'ºC'),
	(182087, 121, '2014-02-01 00:42:02.000000', 'temperatura', 1099.0000, 'ºC'),
	(182088, 121, '2014-02-01 00:42:03.000000', 'temperatura', 269.0000, 'ºC'),
	(182089, 121, '2014-02-01 00:42:04.000000', 'temperatura', 447.0000, 'ºC'),
	(182090, 121, '2014-02-01 00:42:05.000000', 'temperatura', 230.0000, 'ºC'),
	(182091, 121, '2014-02-01 00:42:06.000000', 'temperatura', 1008.0000, 'ºC'),
	(182092, 121, '2014-02-01 00:42:07.000000', 'temperatura', 750.0000, 'ºC'),
	(182093, 121, '2014-02-01 00:42:08.000000', 'temperatura', 728.0000, 'ºC'),
	(182094, 121, '2014-02-01 00:42:09.000000', 'temperatura', 190.0000, 'ºC'),
	(182095, 121, '2014-02-01 00:42:10.000000', 'temperatura', 1166.0000, 'ºC'),
	(182096, 121, '2014-02-01 00:42:11.000000', 'temperatura', 461.0000, 'ºC'),
	(182097, 121, '2014-02-01 00:42:12.000000', 'temperatura', 9.0000, 'ºC'),
	(182098, 121, '2014-02-01 00:42:13.000000', 'temperatura', 1061.0000, 'ºC'),
	(182099, 121, '2014-02-01 00:42:14.000000', 'temperatura', 478.0000, 'ºC'),
	(182100, 121, '2014-02-01 00:42:15.000000', 'temperatura', 409.0000, 'ºC'),
	(182101, 121, '2014-02-01 00:42:16.000000', 'temperatura', 610.0000, 'ºC'),
	(182102, 121, '2014-02-01 00:42:17.000000', 'temperatura', 626.0000, 'ºC'),
	(182103, 121, '2014-02-01 00:42:18.000000', 'temperatura', 100.0000, 'ºC'),
	(182104, 121, '2014-02-01 00:42:19.000000', 'temperatura', 1021.0000, 'ºC'),
	(182105, 121, '2014-02-01 00:42:20.000000', 'temperatura', 5.0000, 'ºC'),
	(182106, 121, '2014-02-01 00:42:21.000000', 'temperatura', 565.0000, 'ºC'),
	(182107, 121, '2014-02-01 00:42:22.000000', 'temperatura', 408.0000, 'ºC'),
	(182108, 121, '2014-02-01 00:42:23.000000', 'temperatura', 347.0000, 'ºC'),
	(182109, 121, '2014-02-01 00:42:24.000000', 'temperatura', 509.0000, 'ºC'),
	(182110, 121, '2014-02-01 00:42:25.000000', 'temperatura', 307.0000, 'ºC'),
	(182111, 121, '2014-02-01 00:42:26.000000', 'temperatura', 8.0000, 'ºC'),
	(182112, 121, '2014-02-01 00:42:27.000000', 'temperatura', 321.0000, 'ºC'),
	(182113, 121, '2014-02-01 00:42:28.000000', 'temperatura', 381.0000, 'ºC'),
	(182114, 121, '2014-02-01 00:42:29.000000', 'temperatura', 941.0000, 'ºC'),
	(182115, 121, '2014-02-01 00:42:30.000000', 'temperatura', 1161.0000, 'ºC'),
	(182116, 121, '2014-02-01 00:42:31.000000', 'temperatura', 586.0000, 'ºC'),
	(182117, 121, '2014-02-01 00:42:32.000000', 'temperatura', 645.0000, 'ºC'),
	(182118, 121, '2014-02-01 00:42:33.000000', 'temperatura', 270.0000, 'ºC'),
	(182119, 121, '2014-02-01 00:42:34.000000', 'temperatura', 616.0000, 'ºC'),
	(182120, 121, '2014-02-01 00:42:35.000000', 'temperatura', 1070.0000, 'ºC'),
	(182121, 121, '2014-02-01 00:42:36.000000', 'temperatura', 1103.0000, 'ºC'),
	(182122, 121, '2014-02-01 00:42:37.000000', 'temperatura', 1106.0000, 'ºC'),
	(182123, 121, '2014-02-01 00:42:38.000000', 'temperatura', 1021.0000, 'ºC'),
	(182124, 121, '2014-02-01 00:42:39.000000', 'temperatura', 588.0000, 'ºC'),
	(182125, 121, '2014-02-01 00:42:40.000000', 'temperatura', 1078.0000, 'ºC'),
	(182126, 121, '2014-02-01 00:42:41.000000', 'temperatura', 26.0000, 'ºC'),
	(182127, 121, '2014-02-01 00:42:42.000000', 'temperatura', 495.0000, 'ºC'),
	(182128, 121, '2014-02-01 00:42:43.000000', 'temperatura', 1199.0000, 'ºC'),
	(182129, 121, '2014-02-01 00:42:44.000000', 'temperatura', 911.0000, 'ºC'),
	(182130, 121, '2014-02-01 00:42:45.000000', 'temperatura', 957.0000, 'ºC'),
	(182131, 121, '2014-02-01 00:42:46.000000', 'temperatura', 855.0000, 'ºC'),
	(182132, 121, '2014-02-01 00:42:47.000000', 'temperatura', 204.0000, 'ºC'),
	(182133, 121, '2014-02-01 00:42:48.000000', 'temperatura', 854.0000, 'ºC'),
	(182134, 121, '2014-02-01 00:42:49.000000', 'temperatura', 57.0000, 'ºC'),
	(182135, 121, '2014-02-01 00:42:50.000000', 'temperatura', 125.0000, 'ºC'),
	(182136, 121, '2014-02-01 00:42:51.000000', 'temperatura', 456.0000, 'ºC'),
	(182137, 121, '2014-02-01 00:42:52.000000', 'temperatura', 704.0000, 'ºC'),
	(182138, 121, '2014-02-01 00:42:53.000000', 'temperatura', 951.0000, 'ºC'),
	(182139, 121, '2014-02-01 00:42:54.000000', 'temperatura', 244.0000, 'ºC'),
	(182140, 121, '2014-02-01 00:42:55.000000', 'temperatura', 766.0000, 'ºC'),
	(182141, 121, '2014-02-01 00:42:56.000000', 'temperatura', 701.0000, 'ºC'),
	(182142, 121, '2014-02-01 00:42:57.000000', 'temperatura', 6.0000, 'ºC'),
	(182143, 121, '2014-02-01 00:42:58.000000', 'temperatura', 329.0000, 'ºC'),
	(182144, 121, '2014-02-01 00:42:59.000000', 'temperatura', 428.0000, 'ºC'),
	(182145, 121, '2014-02-01 00:43:00.000000', 'temperatura', 1151.0000, 'ºC'),
	(182146, 121, '2014-02-01 00:43:01.000000', 'temperatura', 875.0000, 'ºC'),
	(182147, 121, '2014-02-01 00:43:02.000000', 'temperatura', 919.0000, 'ºC'),
	(182148, 121, '2014-02-01 00:43:03.000000', 'temperatura', 773.0000, 'ºC'),
	(182149, 121, '2014-02-01 00:43:04.000000', 'temperatura', 1106.0000, 'ºC'),
	(182150, 121, '2014-02-01 00:43:05.000000', 'temperatura', 812.0000, 'ºC'),
	(182151, 121, '2014-02-01 00:43:06.000000', 'temperatura', 741.0000, 'ºC'),
	(182152, 121, '2014-02-01 00:43:07.000000', 'temperatura', 72.0000, 'ºC'),
	(182153, 121, '2014-02-01 00:43:08.000000', 'temperatura', 535.0000, 'ºC'),
	(182154, 121, '2014-02-01 00:43:09.000000', 'temperatura', 62.0000, 'ºC'),
	(182155, 121, '2014-02-01 00:43:10.000000', 'temperatura', 1104.0000, 'ºC'),
	(182156, 121, '2014-02-01 00:43:11.000000', 'temperatura', 534.0000, 'ºC'),
	(182157, 121, '2014-02-01 00:43:12.000000', 'temperatura', 559.0000, 'ºC'),
	(182158, 121, '2014-02-01 00:43:13.000000', 'temperatura', 1195.0000, 'ºC'),
	(182159, 121, '2014-02-01 00:43:14.000000', 'temperatura', 699.0000, 'ºC'),
	(182160, 121, '2014-02-01 00:43:15.000000', 'temperatura', 1110.0000, 'ºC'),
	(182161, 121, '2014-02-01 00:43:16.000000', 'temperatura', 1053.0000, 'ºC'),
	(182162, 121, '2014-02-01 00:43:17.000000', 'temperatura', 735.0000, 'ºC'),
	(182163, 121, '2014-02-01 00:43:18.000000', 'temperatura', 518.0000, 'ºC'),
	(182164, 121, '2014-02-01 00:43:19.000000', 'temperatura', 385.0000, 'ºC'),
	(182165, 121, '2014-02-01 00:43:20.000000', 'temperatura', 372.0000, 'ºC'),
	(182166, 121, '2014-02-01 00:43:21.000000', 'temperatura', 706.0000, 'ºC'),
	(182167, 121, '2014-02-01 00:43:22.000000', 'temperatura', 14.0000, 'ºC'),
	(182168, 121, '2014-02-01 00:43:23.000000', 'temperatura', 353.0000, 'ºC'),
	(182169, 121, '2014-02-01 00:43:24.000000', 'temperatura', 524.0000, 'ºC'),
	(182170, 121, '2014-02-01 00:43:25.000000', 'temperatura', 360.0000, 'ºC'),
	(182171, 121, '2014-02-01 00:43:26.000000', 'temperatura', 229.0000, 'ºC'),
	(182172, 121, '2014-02-01 00:43:27.000000', 'temperatura', 66.0000, 'ºC'),
	(182173, 121, '2014-02-01 00:43:28.000000', 'temperatura', 842.0000, 'ºC'),
	(182174, 121, '2014-02-01 00:43:29.000000', 'temperatura', 414.0000, 'ºC'),
	(182175, 121, '2014-02-01 00:43:30.000000', 'temperatura', 742.0000, 'ºC'),
	(182176, 121, '2014-02-01 00:43:31.000000', 'temperatura', 70.0000, 'ºC'),
	(182177, 121, '2014-02-01 00:43:32.000000', 'temperatura', 526.0000, 'ºC'),
	(182178, 121, '2014-02-01 00:43:33.000000', 'temperatura', 21.0000, 'ºC'),
	(182179, 121, '2014-02-01 00:43:34.000000', 'temperatura', 924.0000, 'ºC'),
	(182180, 121, '2014-02-01 00:43:35.000000', 'temperatura', 960.0000, 'ºC'),
	(182181, 121, '2014-02-01 00:43:36.000000', 'temperatura', 829.0000, 'ºC'),
	(182182, 121, '2014-02-01 00:43:37.000000', 'temperatura', 65.0000, 'ºC'),
	(182183, 121, '2014-02-01 00:43:38.000000', 'temperatura', 239.0000, 'ºC'),
	(182184, 121, '2014-02-01 00:43:39.000000', 'temperatura', 998.0000, 'ºC'),
	(182185, 121, '2014-02-01 00:43:40.000000', 'temperatura', 676.0000, 'ºC'),
	(182186, 121, '2014-02-01 00:43:41.000000', 'temperatura', 387.0000, 'ºC'),
	(182187, 121, '2014-02-01 00:43:42.000000', 'temperatura', 1107.0000, 'ºC'),
	(182188, 121, '2014-02-01 00:43:43.000000', 'temperatura', 775.0000, 'ºC'),
	(182189, 121, '2014-02-01 00:43:44.000000', 'temperatura', 554.0000, 'ºC'),
	(182190, 121, '2014-02-01 00:43:45.000000', 'temperatura', 446.0000, 'ºC'),
	(182191, 121, '2014-02-01 00:43:46.000000', 'temperatura', 569.0000, 'ºC'),
	(182192, 121, '2014-02-01 00:43:47.000000', 'temperatura', 306.0000, 'ºC'),
	(182193, 121, '2014-02-01 00:43:48.000000', 'temperatura', 1024.0000, 'ºC'),
	(182194, 121, '2014-02-01 00:43:49.000000', 'temperatura', 605.0000, 'ºC'),
	(182195, 121, '2014-02-01 00:43:50.000000', 'temperatura', 1150.0000, 'ºC'),
	(182196, 121, '2014-02-01 00:43:51.000000', 'temperatura', 336.0000, 'ºC'),
	(182197, 121, '2014-02-01 00:43:52.000000', 'temperatura', 630.0000, 'ºC'),
	(182198, 121, '2014-02-01 00:43:53.000000', 'temperatura', 944.0000, 'ºC'),
	(182199, 121, '2014-02-01 00:43:54.000000', 'temperatura', 430.0000, 'ºC'),
	(182200, 121, '2014-02-01 00:43:55.000000', 'temperatura', 518.0000, 'ºC'),
	(182201, 121, '2014-02-01 00:43:56.000000', 'temperatura', 101.0000, 'ºC'),
	(182202, 121, '2014-02-01 00:43:57.000000', 'temperatura', 153.0000, 'ºC'),
	(182203, 121, '2014-02-01 00:43:58.000000', 'temperatura', 461.0000, 'ºC'),
	(182204, 121, '2014-02-01 00:43:59.000000', 'temperatura', 647.0000, 'ºC'),
	(182205, 121, '2014-02-01 00:44:00.000000', 'temperatura', 654.0000, 'ºC'),
	(182206, 121, '2014-02-01 00:44:01.000000', 'temperatura', 130.0000, 'ºC'),
	(182207, 121, '2014-02-01 00:44:02.000000', 'temperatura', 1086.0000, 'ºC'),
	(182208, 121, '2014-02-01 00:44:03.000000', 'temperatura', 242.0000, 'ºC'),
	(182209, 121, '2014-02-01 00:44:04.000000', 'temperatura', 354.0000, 'ºC'),
	(182210, 121, '2014-02-01 00:44:05.000000', 'temperatura', 1044.0000, 'ºC'),
	(182211, 121, '2014-02-01 00:44:06.000000', 'temperatura', 558.0000, 'ºC'),
	(182212, 121, '2014-02-01 00:44:07.000000', 'temperatura', 860.0000, 'ºC'),
	(182213, 121, '2014-02-01 00:44:08.000000', 'temperatura', 227.0000, 'ºC'),
	(182214, 121, '2014-02-01 00:44:09.000000', 'temperatura', 956.0000, 'ºC'),
	(182215, 121, '2014-02-01 00:44:10.000000', 'temperatura', 498.0000, 'ºC'),
	(182216, 121, '2014-02-01 00:44:11.000000', 'temperatura', 823.0000, 'ºC'),
	(182217, 121, '2014-02-01 00:44:12.000000', 'temperatura', 223.0000, 'ºC'),
	(182218, 121, '2014-02-01 00:44:13.000000', 'temperatura', 1046.0000, 'ºC'),
	(182219, 121, '2014-02-01 00:44:14.000000', 'temperatura', 963.0000, 'ºC'),
	(182220, 121, '2014-02-01 00:44:15.000000', 'temperatura', 475.0000, 'ºC'),
	(182221, 121, '2014-02-01 00:44:16.000000', 'temperatura', 688.0000, 'ºC'),
	(182222, 121, '2014-02-01 00:44:17.000000', 'temperatura', 817.0000, 'ºC'),
	(182223, 121, '2014-02-01 00:44:18.000000', 'temperatura', 820.0000, 'ºC'),
	(182224, 121, '2014-02-01 00:44:19.000000', 'temperatura', 448.0000, 'ºC'),
	(182225, 121, '2014-02-01 00:44:20.000000', 'temperatura', 982.0000, 'ºC'),
	(182226, 121, '2014-02-01 00:44:21.000000', 'temperatura', 1164.0000, 'ºC'),
	(182227, 121, '2014-02-01 00:44:22.000000', 'temperatura', 476.0000, 'ºC'),
	(182228, 121, '2014-02-01 00:44:23.000000', 'temperatura', 91.0000, 'ºC'),
	(182229, 121, '2014-02-01 00:44:24.000000', 'temperatura', 224.0000, 'ºC'),
	(182230, 121, '2014-02-01 00:44:25.000000', 'temperatura', 847.0000, 'ºC'),
	(182231, 121, '2014-02-01 00:44:26.000000', 'temperatura', 1166.0000, 'ºC'),
	(182232, 121, '2014-02-01 00:44:27.000000', 'temperatura', 891.0000, 'ºC'),
	(182233, 121, '2014-02-01 00:44:28.000000', 'temperatura', 954.0000, 'ºC'),
	(182234, 121, '2014-02-01 00:44:29.000000', 'temperatura', 901.0000, 'ºC'),
	(182235, 121, '2014-02-01 00:44:30.000000', 'temperatura', 440.0000, 'ºC'),
	(182236, 121, '2014-02-01 00:44:31.000000', 'temperatura', 700.0000, 'ºC'),
	(182237, 121, '2014-02-01 00:44:32.000000', 'temperatura', 980.0000, 'ºC'),
	(182238, 121, '2014-02-01 00:44:33.000000', 'temperatura', 399.0000, 'ºC'),
	(182239, 121, '2014-02-01 00:44:34.000000', 'temperatura', 256.0000, 'ºC'),
	(182240, 121, '2014-02-01 00:44:35.000000', 'temperatura', 83.0000, 'ºC'),
	(182241, 121, '2014-02-01 00:44:36.000000', 'temperatura', 847.0000, 'ºC'),
	(182242, 121, '2014-02-01 00:44:37.000000', 'temperatura', 387.0000, 'ºC'),
	(182243, 121, '2014-02-01 00:44:38.000000', 'temperatura', 596.0000, 'ºC'),
	(182244, 121, '2014-02-01 00:44:39.000000', 'temperatura', 619.0000, 'ºC'),
	(182245, 121, '2014-02-01 00:44:40.000000', 'temperatura', 106.0000, 'ºC'),
	(182246, 121, '2014-02-01 00:44:41.000000', 'temperatura', 1076.0000, 'ºC'),
	(182247, 121, '2014-02-01 00:44:42.000000', 'temperatura', 260.0000, 'ºC'),
	(182248, 121, '2014-02-01 00:44:43.000000', 'temperatura', 472.0000, 'ºC'),
	(182249, 121, '2014-02-01 00:44:44.000000', 'temperatura', 383.0000, 'ºC'),
	(182250, 121, '2014-02-01 00:44:45.000000', 'temperatura', 498.0000, 'ºC'),
	(182251, 121, '2014-02-01 00:44:46.000000', 'temperatura', 141.0000, 'ºC'),
	(182252, 121, '2014-02-01 00:44:47.000000', 'temperatura', 414.0000, 'ºC'),
	(182253, 121, '2014-02-01 00:44:48.000000', 'temperatura', 445.0000, 'ºC'),
	(182254, 121, '2014-02-01 00:44:49.000000', 'temperatura', 985.0000, 'ºC'),
	(182255, 121, '2014-02-01 00:44:50.000000', 'temperatura', 1192.0000, 'ºC'),
	(182256, 121, '2014-02-01 00:44:51.000000', 'temperatura', 602.0000, 'ºC'),
	(182257, 121, '2014-02-01 00:44:52.000000', 'temperatura', 636.0000, 'ºC'),
	(182258, 121, '2014-02-01 00:44:53.000000', 'temperatura', 174.0000, 'ºC'),
	(182259, 121, '2014-02-01 00:44:54.000000', 'temperatura', 162.0000, 'ºC'),
	(182260, 121, '2014-02-01 00:44:55.000000', 'temperatura', 289.0000, 'ºC'),
	(182261, 121, '2014-02-01 00:44:56.000000', 'temperatura', 960.0000, 'ºC'),
	(182262, 121, '2014-02-01 00:44:57.000000', 'temperatura', 331.0000, 'ºC'),
	(182263, 121, '2014-02-01 00:44:58.000000', 'temperatura', 1178.0000, 'ºC'),
	(182264, 121, '2014-02-01 00:44:59.000000', 'temperatura', 95.0000, 'ºC'),
	(182265, 121, '2014-02-01 00:45:00.000000', 'temperatura', 543.0000, 'ºC'),
	(182266, 121, '2014-02-01 00:45:01.000000', 'temperatura', 29.0000, 'ºC'),
	(182267, 121, '2014-02-01 00:45:02.000000', 'temperatura', 917.0000, 'ºC'),
	(182268, 121, '2014-02-01 00:45:03.000000', 'temperatura', 899.0000, 'ºC'),
	(182269, 121, '2014-02-01 00:45:04.000000', 'temperatura', 545.0000, 'ºC'),
	(182270, 121, '2014-02-01 00:45:05.000000', 'temperatura', 29.0000, 'ºC'),
	(182271, 121, '2014-02-01 00:45:06.000000', 'temperatura', 908.0000, 'ºC'),
	(182272, 121, '2014-02-01 00:45:07.000000', 'temperatura', 854.0000, 'ºC'),
	(182273, 121, '2014-02-01 00:45:08.000000', 'temperatura', 348.0000, 'ºC'),
	(182274, 121, '2014-02-01 00:45:09.000000', 'temperatura', 376.0000, 'ºC'),
	(182275, 121, '2014-02-01 00:45:10.000000', 'temperatura', 839.0000, 'ºC'),
	(182276, 121, '2014-02-01 00:45:11.000000', 'temperatura', 666.0000, 'ºC'),
	(182277, 121, '2014-02-01 00:45:12.000000', 'temperatura', 813.0000, 'ºC'),
	(182278, 121, '2014-02-01 00:45:13.000000', 'temperatura', 869.0000, 'ºC'),
	(182279, 121, '2014-02-01 00:45:14.000000', 'temperatura', 704.0000, 'ºC'),
	(182280, 121, '2014-02-01 00:45:15.000000', 'temperatura', 916.0000, 'ºC'),
	(182281, 121, '2014-02-01 00:45:16.000000', 'temperatura', 67.0000, 'ºC'),
	(182282, 121, '2014-02-01 00:45:17.000000', 'temperatura', 1187.0000, 'ºC'),
	(182283, 121, '2014-02-01 00:45:18.000000', 'temperatura', 935.0000, 'ºC'),
	(182284, 121, '2014-02-01 00:45:19.000000', 'temperatura', 1115.0000, 'ºC'),
	(182285, 121, '2014-02-01 00:45:20.000000', 'temperatura', 372.0000, 'ºC'),
	(182286, 121, '2014-02-01 00:45:21.000000', 'temperatura', 916.0000, 'ºC'),
	(182287, 121, '2014-02-01 00:45:22.000000', 'temperatura', 1061.0000, 'ºC'),
	(182288, 121, '2014-02-01 00:45:23.000000', 'temperatura', 161.0000, 'ºC'),
	(182289, 121, '2014-02-01 00:45:24.000000', 'temperatura', 22.0000, 'ºC'),
	(182290, 121, '2014-02-01 00:45:25.000000', 'temperatura', 826.0000, 'ºC'),
	(182291, 121, '2014-02-01 00:45:26.000000', 'temperatura', 466.0000, 'ºC'),
	(182292, 121, '2014-02-01 00:45:27.000000', 'temperatura', 1053.0000, 'ºC'),
	(182293, 121, '2014-02-01 00:45:28.000000', 'temperatura', 265.0000, 'ºC'),
	(182294, 121, '2014-02-01 00:45:29.000000', 'temperatura', 566.0000, 'ºC'),
	(182295, 121, '2014-02-01 00:45:30.000000', 'temperatura', 838.0000, 'ºC'),
	(182296, 121, '2014-02-01 00:45:31.000000', 'temperatura', 93.0000, 'ºC'),
	(182297, 121, '2014-02-01 00:45:32.000000', 'temperatura', 348.0000, 'ºC'),
	(182298, 121, '2014-02-01 00:45:33.000000', 'temperatura', 265.0000, 'ºC'),
	(182299, 121, '2014-02-01 00:45:34.000000', 'temperatura', 280.0000, 'ºC'),
	(182300, 121, '2014-02-01 00:45:35.000000', 'temperatura', 607.0000, 'ºC'),
	(182301, 121, '2014-02-01 00:45:36.000000', 'temperatura', 994.0000, 'ºC'),
	(182302, 121, '2014-02-01 00:45:37.000000', 'temperatura', 750.0000, 'ºC'),
	(182303, 121, '2014-02-01 00:45:38.000000', 'temperatura', 770.0000, 'ºC'),
	(182304, 121, '2014-02-01 00:45:39.000000', 'temperatura', 399.0000, 'ºC'),
	(182305, 121, '2014-02-01 00:45:40.000000', 'temperatura', 886.0000, 'ºC'),
	(182306, 121, '2014-02-01 00:45:41.000000', 'temperatura', 832.0000, 'ºC'),
	(182307, 121, '2014-02-01 00:45:42.000000', 'temperatura', 303.0000, 'ºC'),
	(182308, 121, '2014-02-01 00:45:43.000000', 'temperatura', 222.0000, 'ºC'),
	(182309, 121, '2014-02-01 00:45:44.000000', 'temperatura', 200.0000, 'ºC'),
	(182310, 121, '2014-02-01 00:45:45.000000', 'temperatura', 333.0000, 'ºC'),
	(182311, 121, '2014-02-01 00:45:46.000000', 'temperatura', 1065.0000, 'ºC'),
	(182312, 121, '2014-02-01 00:45:47.000000', 'temperatura', 729.0000, 'ºC'),
	(182313, 121, '2014-02-01 00:45:48.000000', 'temperatura', 449.0000, 'ºC'),
	(182314, 121, '2014-02-01 00:45:49.000000', 'temperatura', 57.0000, 'ºC'),
	(182315, 121, '2014-02-01 00:45:50.000000', 'temperatura', 139.0000, 'ºC'),
	(182316, 121, '2014-02-01 00:45:51.000000', 'temperatura', 524.0000, 'ºC'),
	(182317, 121, '2014-02-01 00:45:52.000000', 'temperatura', 1004.0000, 'ºC'),
	(182318, 121, '2014-02-01 00:45:53.000000', 'temperatura', 1050.0000, 'ºC'),
	(182319, 121, '2014-02-01 00:45:54.000000', 'temperatura', 1037.0000, 'ºC'),
	(182320, 121, '2014-02-01 00:45:55.000000', 'temperatura', 835.0000, 'ºC'),
	(182321, 121, '2014-02-01 00:45:56.000000', 'temperatura', 1066.0000, 'ºC'),
	(182322, 121, '2014-02-01 00:45:57.000000', 'temperatura', 424.0000, 'ºC'),
	(182323, 121, '2014-02-01 00:45:58.000000', 'temperatura', 123.0000, 'ºC'),
	(182324, 121, '2014-02-01 00:45:59.000000', 'temperatura', 543.0000, 'ºC'),
	(182325, 121, '2014-02-01 00:46:00.000000', 'temperatura', 1146.0000, 'ºC'),
	(182326, 121, '2014-02-01 00:46:01.000000', 'temperatura', 502.0000, 'ºC'),
	(182327, 121, '2014-02-01 00:46:02.000000', 'temperatura', 271.0000, 'ºC'),
	(182328, 121, '2014-02-01 00:46:03.000000', 'temperatura', 1049.0000, 'ºC'),
	(182329, 121, '2014-02-01 00:46:04.000000', 'temperatura', 835.0000, 'ºC'),
	(182330, 121, '2014-02-01 00:46:05.000000', 'temperatura', 1028.0000, 'ºC'),
	(182331, 121, '2014-02-01 00:46:06.000000', 'temperatura', 234.0000, 'ºC'),
	(182332, 121, '2014-02-01 00:46:07.000000', 'temperatura', 486.0000, 'ºC'),
	(182333, 121, '2014-02-01 00:46:08.000000', 'temperatura', 530.0000, 'ºC'),
	(182334, 121, '2014-02-01 00:46:09.000000', 'temperatura', 1193.0000, 'ºC'),
	(182335, 121, '2014-02-01 00:46:10.000000', 'temperatura', 773.0000, 'ºC'),
	(182336, 121, '2014-02-01 00:46:11.000000', 'temperatura', 288.0000, 'ºC'),
	(182337, 121, '2014-02-01 00:46:12.000000', 'temperatura', 320.0000, 'ºC'),
	(182338, 121, '2014-02-01 00:46:13.000000', 'temperatura', 736.0000, 'ºC'),
	(182339, 121, '2014-02-01 00:46:14.000000', 'temperatura', 321.0000, 'ºC'),
	(182340, 121, '2014-02-01 00:46:15.000000', 'temperatura', 598.0000, 'ºC'),
	(182341, 121, '2014-02-01 00:46:16.000000', 'temperatura', 826.0000, 'ºC'),
	(182342, 121, '2014-02-01 00:46:17.000000', 'temperatura', 1137.0000, 'ºC'),
	(182343, 121, '2014-02-01 00:46:18.000000', 'temperatura', 809.0000, 'ºC'),
	(182344, 121, '2014-02-01 00:46:19.000000', 'temperatura', 634.0000, 'ºC'),
	(182345, 121, '2014-02-01 00:46:20.000000', 'temperatura', 741.0000, 'ºC'),
	(182346, 121, '2014-02-01 00:46:21.000000', 'temperatura', 606.0000, 'ºC'),
	(182347, 121, '2014-02-01 00:46:22.000000', 'temperatura', 808.0000, 'ºC'),
	(182348, 121, '2014-02-01 00:46:23.000000', 'temperatura', 1021.0000, 'ºC'),
	(182349, 121, '2014-02-01 00:46:24.000000', 'temperatura', 280.0000, 'ºC'),
	(182350, 121, '2014-02-01 00:46:25.000000', 'temperatura', 741.0000, 'ºC'),
	(182351, 121, '2014-02-01 00:46:26.000000', 'temperatura', 462.0000, 'ºC'),
	(182352, 121, '2014-02-01 00:46:27.000000', 'temperatura', 89.0000, 'ºC'),
	(182353, 121, '2014-02-01 00:46:28.000000', 'temperatura', 260.0000, 'ºC'),
	(182354, 121, '2014-02-01 00:46:29.000000', 'temperatura', 1034.0000, 'ºC'),
	(182355, 121, '2014-02-01 00:46:30.000000', 'temperatura', 790.0000, 'ºC'),
	(182356, 121, '2014-02-01 00:46:31.000000', 'temperatura', 848.0000, 'ºC'),
	(182357, 121, '2014-02-01 00:46:32.000000', 'temperatura', 669.0000, 'ºC'),
	(182358, 121, '2014-02-01 00:46:33.000000', 'temperatura', 802.0000, 'ºC'),
	(182359, 121, '2014-02-01 00:46:34.000000', 'temperatura', 803.0000, 'ºC'),
	(182360, 121, '2014-02-01 00:46:35.000000', 'temperatura', 412.0000, 'ºC'),
	(182361, 121, '2014-02-01 00:46:36.000000', 'temperatura', 849.0000, 'ºC'),
	(182362, 121, '2014-02-01 00:46:37.000000', 'temperatura', 611.0000, 'ºC'),
	(182363, 121, '2014-02-01 00:46:38.000000', 'temperatura', 510.0000, 'ºC'),
	(182364, 121, '2014-02-01 00:46:39.000000', 'temperatura', 716.0000, 'ºC'),
	(182365, 121, '2014-02-01 00:46:40.000000', 'temperatura', 849.0000, 'ºC'),
	(182366, 121, '2014-02-01 00:46:41.000000', 'temperatura', 900.0000, 'ºC'),
	(182367, 121, '2014-02-01 00:46:42.000000', 'temperatura', 754.0000, 'ºC'),
	(182368, 121, '2014-02-01 00:46:43.000000', 'temperatura', 1068.0000, 'ºC'),
	(182369, 121, '2014-02-01 00:46:44.000000', 'temperatura', 680.0000, 'ºC'),
	(182370, 121, '2014-02-01 00:46:45.000000', 'temperatura', 197.0000, 'ºC'),
	(182371, 121, '2014-02-01 00:46:46.000000', 'temperatura', 147.0000, 'ºC'),
	(182372, 121, '2014-02-01 00:46:47.000000', 'temperatura', 143.0000, 'ºC'),
	(182373, 121, '2014-02-01 00:46:48.000000', 'temperatura', 275.0000, 'ºC'),
	(182374, 121, '2014-02-01 00:46:49.000000', 'temperatura', 947.0000, 'ºC'),
	(182375, 121, '2014-02-01 00:46:50.000000', 'temperatura', 312.0000, 'ºC'),
	(182376, 121, '2014-02-01 00:46:51.000000', 'temperatura', 1118.0000, 'ºC'),
	(182377, 121, '2014-02-01 00:46:52.000000', 'temperatura', 1055.0000, 'ºC'),
	(182378, 121, '2014-02-01 00:46:53.000000', 'temperatura', 723.0000, 'ºC'),
	(182379, 121, '2014-02-01 00:46:54.000000', 'temperatura', 451.0000, 'ºC'),
	(182380, 121, '2014-02-01 00:46:55.000000', 'temperatura', 84.0000, 'ºC'),
	(182381, 121, '2014-02-01 00:46:56.000000', 'temperatura', 267.0000, 'ºC'),
	(182382, 121, '2014-02-01 00:46:57.000000', 'temperatura', 1084.0000, 'ºC'),
	(182383, 121, '2014-02-01 00:46:58.000000', 'temperatura', 1021.0000, 'ºC'),
	(182384, 121, '2014-02-01 00:46:59.000000', 'temperatura', 653.0000, 'ºC'),
	(182385, 121, '2014-02-01 00:47:00.000000', 'temperatura', 202.0000, 'ºC'),
	(182386, 121, '2014-02-01 00:47:01.000000', 'temperatura', 251.0000, 'ºC'),
	(182387, 121, '2014-02-01 00:47:02.000000', 'temperatura', 650.0000, 'ºC'),
	(182388, 121, '2014-02-01 00:47:03.000000', 'temperatura', 97.0000, 'ºC'),
	(182389, 121, '2014-02-01 00:47:04.000000', 'temperatura', 934.0000, 'ºC'),
	(182390, 121, '2014-02-01 00:47:05.000000', 'temperatura', 783.0000, 'ºC'),
	(182391, 121, '2014-02-01 00:47:06.000000', 'temperatura', 1111.0000, 'ºC'),
	(182392, 121, '2014-02-01 00:47:07.000000', 'temperatura', 806.0000, 'ºC'),
	(182393, 121, '2014-02-01 00:47:08.000000', 'temperatura', 699.0000, 'ºC'),
	(182394, 121, '2014-02-01 00:47:09.000000', 'temperatura', 1078.0000, 'ºC'),
	(182395, 121, '2014-02-01 00:47:10.000000', 'temperatura', 893.0000, 'ºC'),
	(182396, 121, '2014-02-01 00:47:11.000000', 'temperatura', 33.0000, 'ºC'),
	(182397, 121, '2014-02-01 00:47:12.000000', 'temperatura', 1087.0000, 'ºC'),
	(182398, 121, '2014-02-01 00:47:13.000000', 'temperatura', 535.0000, 'ºC'),
	(182399, 121, '2014-02-01 00:47:14.000000', 'temperatura', 614.0000, 'ºC'),
	(182400, 121, '2014-02-01 00:47:15.000000', 'temperatura', 266.0000, 'ºC'),
	(182401, 121, '2014-02-01 00:47:16.000000', 'temperatura', 687.0000, 'ºC'),
	(182402, 121, '2014-02-01 00:47:17.000000', 'temperatura', 237.0000, 'ºC'),
	(182403, 121, '2014-02-01 00:47:18.000000', 'temperatura', 326.0000, 'ºC'),
	(182404, 121, '2014-02-01 00:47:19.000000', 'temperatura', 921.0000, 'ºC'),
	(182405, 121, '2014-02-01 00:47:20.000000', 'temperatura', 24.0000, 'ºC'),
	(182406, 121, '2014-02-01 00:47:21.000000', 'temperatura', 960.0000, 'ºC'),
	(182407, 121, '2014-02-01 00:47:22.000000', 'temperatura', 1128.0000, 'ºC'),
	(182408, 121, '2014-02-01 00:47:23.000000', 'temperatura', 361.0000, 'ºC'),
	(182409, 121, '2014-02-01 00:47:24.000000', 'temperatura', 823.0000, 'ºC'),
	(182410, 121, '2014-02-01 00:47:25.000000', 'temperatura', 630.0000, 'ºC'),
	(182411, 121, '2014-02-01 00:47:26.000000', 'temperatura', 682.0000, 'ºC'),
	(182412, 121, '2014-02-01 00:47:27.000000', 'temperatura', 320.0000, 'ºC'),
	(182413, 121, '2014-02-01 00:47:28.000000', 'temperatura', 754.0000, 'ºC'),
	(182414, 121, '2014-02-01 00:47:29.000000', 'temperatura', 410.0000, 'ºC'),
	(182415, 121, '2014-02-01 00:47:30.000000', 'temperatura', 989.0000, 'ºC'),
	(182416, 121, '2014-02-01 00:47:31.000000', 'temperatura', 115.0000, 'ºC'),
	(182417, 121, '2014-02-01 00:47:32.000000', 'temperatura', 11.0000, 'ºC'),
	(182418, 121, '2014-02-01 00:47:33.000000', 'temperatura', 907.0000, 'ºC'),
	(182419, 121, '2014-02-01 00:47:34.000000', 'temperatura', 905.0000, 'ºC'),
	(182420, 121, '2014-02-01 00:47:35.000000', 'temperatura', 605.0000, 'ºC'),
	(182421, 121, '2014-02-01 00:47:36.000000', 'temperatura', 308.0000, 'ºC'),
	(182422, 121, '2014-02-01 00:47:37.000000', 'temperatura', 926.0000, 'ºC'),
	(182423, 121, '2014-02-01 00:47:38.000000', 'temperatura', 105.0000, 'ºC'),
	(182424, 121, '2014-02-01 00:47:39.000000', 'temperatura', 150.0000, 'ºC'),
	(182425, 121, '2014-02-01 00:47:40.000000', 'temperatura', 436.0000, 'ºC'),
	(182426, 121, '2014-02-01 00:47:41.000000', 'temperatura', 529.0000, 'ºC'),
	(182427, 121, '2014-02-01 00:47:42.000000', 'temperatura', 138.0000, 'ºC'),
	(182428, 121, '2014-02-01 00:47:43.000000', 'temperatura', 305.0000, 'ºC'),
	(182429, 121, '2014-02-01 00:47:44.000000', 'temperatura', 1108.0000, 'ºC'),
	(182430, 121, '2014-02-01 00:47:45.000000', 'temperatura', 1029.0000, 'ºC'),
	(182431, 121, '2014-02-01 00:47:46.000000', 'temperatura', 619.0000, 'ºC'),
	(182432, 121, '2014-02-01 00:47:47.000000', 'temperatura', 10.0000, 'ºC'),
	(182433, 121, '2014-02-01 00:47:48.000000', 'temperatura', 593.0000, 'ºC'),
	(182434, 121, '2014-02-01 00:47:49.000000', 'temperatura', 534.0000, 'ºC'),
	(182435, 121, '2014-02-01 00:47:50.000000', 'temperatura', 893.0000, 'ºC'),
	(182436, 121, '2014-02-01 00:47:51.000000', 'temperatura', 464.0000, 'ºC'),
	(182437, 121, '2014-02-01 00:47:52.000000', 'temperatura', 840.0000, 'ºC'),
	(182438, 121, '2014-02-01 00:47:53.000000', 'temperatura', 407.0000, 'ºC'),
	(182439, 121, '2014-02-01 00:47:54.000000', 'temperatura', 718.0000, 'ºC'),
	(182440, 121, '2014-02-01 00:47:55.000000', 'temperatura', 1168.0000, 'ºC'),
	(182441, 121, '2014-02-01 00:47:56.000000', 'temperatura', 88.0000, 'ºC'),
	(182442, 121, '2014-02-01 00:47:57.000000', 'temperatura', 536.0000, 'ºC'),
	(182443, 121, '2014-02-01 00:47:58.000000', 'temperatura', 18.0000, 'ºC'),
	(182444, 121, '2014-02-01 00:47:59.000000', 'temperatura', 883.0000, 'ºC'),
	(182445, 121, '2014-02-01 00:48:00.000000', 'temperatura', 761.0000, 'ºC'),
	(182446, 121, '2014-02-01 00:48:01.000000', 'temperatura', 1156.0000, 'ºC'),
	(182447, 121, '2014-02-01 00:48:02.000000', 'temperatura', 1098.0000, 'ºC'),
	(182448, 121, '2014-02-01 00:48:03.000000', 'temperatura', 822.0000, 'ºC'),
	(182449, 121, '2014-02-01 00:48:04.000000', 'temperatura', 815.0000, 'ºC'),
	(182450, 121, '2014-02-01 00:48:05.000000', 'temperatura', 412.0000, 'ºC'),
	(182451, 121, '2014-02-01 00:48:06.000000', 'temperatura', 815.0000, 'ºC'),
	(182452, 121, '2014-02-01 00:48:07.000000', 'temperatura', 440.0000, 'ºC'),
	(182453, 121, '2014-02-01 00:48:08.000000', 'temperatura', 956.0000, 'ºC'),
	(182454, 121, '2014-02-01 00:48:09.000000', 'temperatura', 1059.0000, 'ºC'),
	(182455, 121, '2014-02-01 00:48:10.000000', 'temperatura', 26.0000, 'ºC'),
	(182456, 121, '2014-02-01 00:48:11.000000', 'temperatura', 555.0000, 'ºC'),
	(182457, 121, '2014-02-01 00:48:12.000000', 'temperatura', 297.0000, 'ºC'),
	(182458, 121, '2014-02-01 00:48:13.000000', 'temperatura', 1022.0000, 'ºC'),
	(182459, 121, '2014-02-01 00:48:14.000000', 'temperatura', 618.0000, 'ºC'),
	(182460, 121, '2014-02-01 00:48:15.000000', 'temperatura', 27.0000, 'ºC'),
	(182461, 121, '2014-02-01 00:48:16.000000', 'temperatura', 680.0000, 'ºC'),
	(182462, 121, '2014-02-01 00:48:17.000000', 'temperatura', 921.0000, 'ºC'),
	(182463, 121, '2014-02-01 00:48:18.000000', 'temperatura', 163.0000, 'ºC'),
	(182464, 121, '2014-02-01 00:48:19.000000', 'temperatura', 456.0000, 'ºC'),
	(182465, 121, '2014-02-01 00:48:20.000000', 'temperatura', 588.0000, 'ºC'),
	(182466, 121, '2014-02-01 00:48:21.000000', 'temperatura', 375.0000, 'ºC'),
	(182467, 121, '2014-02-01 00:48:22.000000', 'temperatura', 112.0000, 'ºC'),
	(182468, 121, '2014-02-01 00:48:23.000000', 'temperatura', 636.0000, 'ºC'),
	(182469, 121, '2014-02-01 00:48:24.000000', 'temperatura', 444.0000, 'ºC'),
	(182470, 121, '2014-02-01 00:48:25.000000', 'temperatura', 312.0000, 'ºC'),
	(182471, 121, '2014-02-01 00:48:26.000000', 'temperatura', 228.0000, 'ºC'),
	(182472, 121, '2014-02-01 00:48:27.000000', 'temperatura', 204.0000, 'ºC'),
	(182473, 121, '2014-02-01 00:48:28.000000', 'temperatura', 337.0000, 'ºC'),
	(182474, 121, '2014-02-01 00:48:29.000000', 'temperatura', 1074.0000, 'ºC'),
	(182475, 121, '2014-02-01 00:48:30.000000', 'temperatura', 757.0000, 'ºC'),
	(182476, 121, '2014-02-01 00:48:31.000000', 'temperatura', 566.0000, 'ºC'),
	(182477, 121, '2014-02-01 00:48:32.000000', 'temperatura', 559.0000, 'ºC'),
	(182478, 121, '2014-02-01 00:48:33.000000', 'temperatura', 1095.0000, 'ºC'),
	(182479, 121, '2014-02-01 00:48:34.000000', 'temperatura', 202.0000, 'ºC'),
	(182480, 121, '2014-02-01 00:48:35.000000', 'temperatura', 123.0000, 'ºC'),
	(182481, 121, '2014-02-01 00:48:36.000000', 'temperatura', 12.0000, 'ºC'),
	(182482, 121, '2014-02-01 00:48:37.000000', 'temperatura', 891.0000, 'ºC'),
	(182483, 121, '2014-02-01 00:48:38.000000', 'temperatura', 819.0000, 'ºC'),
	(182484, 121, '2014-02-01 00:48:39.000000', 'temperatura', 221.0000, 'ºC'),
	(182485, 121, '2014-02-01 00:48:40.000000', 'temperatura', 1049.0000, 'ºC'),
	(182486, 121, '2014-02-01 00:48:41.000000', 'temperatura', 983.0000, 'ºC'),
	(182487, 121, '2014-02-01 00:48:42.000000', 'temperatura', 566.0000, 'ºC'),
	(182488, 121, '2014-02-01 00:48:43.000000', 'temperatura', 1085.0000, 'ºC'),
	(182489, 121, '2014-02-01 00:48:44.000000', 'temperatura', 127.0000, 'ºC'),
	(182490, 121, '2014-02-01 00:48:45.000000', 'temperatura', 982.0000, 'ºC'),
	(182491, 121, '2014-02-01 00:48:46.000000', 'temperatura', 927.0000, 'ºC'),
	(182492, 121, '2014-02-01 00:48:47.000000', 'temperatura', 492.0000, 'ºC'),
	(182493, 121, '2014-02-01 00:48:48.000000', 'temperatura', 879.0000, 'ºC'),
	(182494, 121, '2014-02-01 00:48:49.000000', 'temperatura', 518.0000, 'ºC'),
	(182495, 121, '2014-02-01 00:48:50.000000', 'temperatura', 1155.0000, 'ºC'),
	(182496, 121, '2014-02-01 00:48:51.000000', 'temperatura', 622.0000, 'ºC'),
	(182497, 121, '2014-02-01 00:48:52.000000', 'temperatura', 843.0000, 'ºC'),
	(182498, 121, '2014-02-01 00:48:53.000000', 'temperatura', 1152.0000, 'ºC'),
	(182499, 121, '2014-02-01 00:48:54.000000', 'temperatura', 830.0000, 'ºC'),
	(182500, 121, '2014-02-01 00:48:55.000000', 'temperatura', 694.0000, 'ºC'),
	(182501, 121, '2014-02-01 00:48:56.000000', 'temperatura', 980.0000, 'ºC'),
	(182502, 121, '2014-02-01 00:48:57.000000', 'temperatura', 417.0000, 'ºC'),
	(182503, 121, '2014-02-01 00:48:58.000000', 'temperatura', 349.0000, 'ºC'),
	(182504, 121, '2014-02-01 00:48:59.000000', 'temperatura', 492.0000, 'ºC'),
	(182505, 121, '2014-02-01 00:49:00.000000', 'temperatura', 216.0000, 'ºC'),
	(182506, 121, '2014-02-01 00:49:01.000000', 'temperatura', 803.0000, 'ºC'),
	(182507, 121, '2014-02-01 00:49:02.000000', 'temperatura', 970.0000, 'ºC'),
	(182508, 121, '2014-02-01 00:49:03.000000', 'temperatura', 39.0000, 'ºC'),
	(182509, 121, '2014-02-01 00:49:04.000000', 'temperatura', 885.0000, 'ºC'),
	(182510, 121, '2014-02-01 00:49:05.000000', 'temperatura', 708.0000, 'ºC'),
	(182511, 121, '2014-02-01 00:49:06.000000', 'temperatura', 886.0000, 'ºC'),
	(182512, 121, '2014-02-01 00:49:07.000000', 'temperatura', 1106.0000, 'ºC'),
	(182513, 121, '2014-02-01 00:49:08.000000', 'temperatura', 473.0000, 'ºC'),
	(182514, 121, '2014-02-01 00:49:09.000000', 'temperatura', 246.0000, 'ºC'),
	(182515, 121, '2014-02-01 00:49:10.000000', 'temperatura', 1014.0000, 'ºC'),
	(182516, 121, '2014-02-01 00:49:11.000000', 'temperatura', 733.0000, 'ºC'),
	(182517, 121, '2014-02-01 00:49:12.000000', 'temperatura', 621.0000, 'ºC'),
	(182518, 121, '2014-02-01 00:49:13.000000', 'temperatura', 907.0000, 'ºC'),
	(182519, 121, '2014-02-01 00:49:14.000000', 'temperatura', 272.0000, 'ºC'),
	(182520, 121, '2014-02-01 00:49:15.000000', 'temperatura', 1039.0000, 'ºC'),
	(182521, 121, '2014-02-01 00:49:16.000000', 'temperatura', 782.0000, 'ºC'),
	(182522, 121, '2014-02-01 00:49:17.000000', 'temperatura', 793.0000, 'ºC'),
	(182523, 121, '2014-02-01 00:49:18.000000', 'temperatura', 420.0000, 'ºC'),
	(182524, 121, '2014-02-01 00:49:19.000000', 'temperatura', 920.0000, 'ºC'),
	(182525, 121, '2014-02-01 00:49:20.000000', 'temperatura', 943.0000, 'ºC'),
	(182526, 121, '2014-02-01 00:49:21.000000', 'temperatura', 754.0000, 'ºC'),
	(182527, 121, '2014-02-01 00:49:22.000000', 'temperatura', 941.0000, 'ºC'),
	(182528, 121, '2014-02-01 00:49:23.000000', 'temperatura', 45.0000, 'ºC'),
	(182529, 121, '2014-02-01 00:49:24.000000', 'temperatura', 1000.0000, 'ºC'),
	(182530, 121, '2014-02-01 00:49:25.000000', 'temperatura', 69.0000, 'ºC'),
	(182531, 121, '2014-02-01 00:49:26.000000', 'temperatura', 943.0000, 'ºC'),
	(182532, 121, '2014-02-01 00:49:27.000000', 'temperatura', 910.0000, 'ºC'),
	(182533, 121, '2014-02-01 00:49:28.000000', 'temperatura', 521.0000, 'ºC'),
	(182534, 121, '2014-02-01 00:49:29.000000', 'temperatura', 1076.0000, 'ºC'),
	(182535, 121, '2014-02-01 00:49:30.000000', 'temperatura', 216.0000, 'ºC'),
	(182536, 121, '2014-02-01 00:49:31.000000', 'temperatura', 255.0000, 'ºC'),
	(182537, 121, '2014-02-01 00:49:32.000000', 'temperatura', 627.0000, 'ºC'),
	(182538, 121, '2014-02-01 00:49:33.000000', 'temperatura', 1171.0000, 'ºC'),
	(182539, 121, '2014-02-01 00:49:34.000000', 'temperatura', 375.0000, 'ºC'),
	(182540, 121, '2014-02-01 00:49:35.000000', 'temperatura', 763.0000, 'ºC'),
	(182541, 121, '2014-02-01 00:49:36.000000', 'temperatura', 289.0000, 'ºC'),
	(182542, 121, '2014-02-01 00:49:37.000000', 'temperatura', 355.0000, 'ºC'),
	(182543, 121, '2014-02-01 00:49:38.000000', 'temperatura', 911.0000, 'ºC'),
	(182544, 121, '2014-02-01 00:49:39.000000', 'temperatura', 1091.0000, 'ºC'),
	(182545, 121, '2014-02-01 00:49:40.000000', 'temperatura', 324.0000, 'ºC'),
	(182546, 121, '2014-02-01 00:49:41.000000', 'temperatura', 744.0000, 'ºC'),
	(182547, 121, '2014-02-01 00:49:42.000000', 'temperatura', 349.0000, 'ºC'),
	(182548, 121, '2014-02-01 00:49:43.000000', 'temperatura', 713.0000, 'ºC'),
	(182549, 121, '2014-02-01 00:49:44.000000', 'temperatura', 119.0000, 'ºC'),
	(182550, 121, '2014-02-01 00:49:45.000000', 'temperatura', 858.0000, 'ºC'),
	(182551, 121, '2014-02-01 00:49:46.000000', 'temperatura', 333.0000, 'ºC'),
	(182552, 121, '2014-02-01 00:49:47.000000', 'temperatura', 289.0000, 'ºC'),
	(182553, 121, '2014-02-01 00:49:48.000000', 'temperatura', 450.0000, 'ºC'),
	(182554, 121, '2014-02-01 00:49:49.000000', 'temperatura', 182.0000, 'ºC'),
	(182555, 121, '2014-02-01 00:49:50.000000', 'temperatura', 761.0000, 'ºC'),
	(182556, 121, '2014-02-01 00:49:51.000000', 'temperatura', 860.0000, 'ºC'),
	(182557, 121, '2014-02-01 00:49:52.000000', 'temperatura', 818.0000, 'ºC'),
	(182558, 121, '2014-02-01 00:49:53.000000', 'temperatura', 310.0000, 'ºC'),
	(182559, 121, '2014-02-01 00:49:54.000000', 'temperatura', 296.0000, 'ºC'),
	(182560, 121, '2014-02-01 00:49:55.000000', 'temperatura', 552.0000, 'ºC'),
	(182561, 121, '2014-02-01 00:49:56.000000', 'temperatura', 672.0000, 'ºC'),
	(182562, 121, '2014-02-01 00:49:57.000000', 'temperatura', 504.0000, 'ºC'),
	(182563, 121, '2014-02-01 00:49:58.000000', 'temperatura', 505.0000, 'ºC'),
	(182564, 121, '2014-02-01 00:49:59.000000', 'temperatura', 1013.0000, 'ºC'),
	(182565, 121, '2014-02-01 00:50:00.000000', 'temperatura', 1151.0000, 'ºC'),
	(182566, 121, '2014-02-01 00:50:01.000000', 'temperatura', 315.0000, 'ºC'),
	(182567, 121, '2014-02-01 00:50:02.000000', 'temperatura', 522.0000, 'ºC'),
	(182568, 121, '2014-02-01 00:50:03.000000', 'temperatura', 465.0000, 'ºC'),
	(182569, 121, '2014-02-01 00:50:04.000000', 'temperatura', 761.0000, 'ºC'),
	(182570, 121, '2014-02-01 00:50:05.000000', 'temperatura', 9.0000, 'ºC'),
	(182571, 121, '2014-02-01 00:50:06.000000', 'temperatura', 163.0000, 'ºC'),
	(182572, 121, '2014-02-01 00:50:07.000000', 'temperatura', 789.0000, 'ºC'),
	(182573, 121, '2014-02-01 00:50:08.000000', 'temperatura', 1056.0000, 'ºC'),
	(182574, 121, '2014-02-01 00:50:09.000000', 'temperatura', 514.0000, 'ºC'),
	(182575, 121, '2014-02-01 00:50:10.000000', 'temperatura', 604.0000, 'ºC'),
	(182576, 121, '2014-02-01 00:50:11.000000', 'temperatura', 276.0000, 'ºC'),
	(182577, 121, '2014-02-01 00:50:12.000000', 'temperatura', 768.0000, 'ºC'),
	(182578, 121, '2014-02-01 00:50:13.000000', 'temperatura', 614.0000, 'ºC'),
	(182579, 121, '2014-02-01 00:50:14.000000', 'temperatura', 766.0000, 'ºC'),
	(182580, 121, '2014-02-01 00:50:15.000000', 'temperatura', 790.0000, 'ºC'),
	(182581, 121, '2014-02-01 00:50:16.000000', 'temperatura', 452.0000, 'ºC'),
	(182582, 121, '2014-02-01 00:50:17.000000', 'temperatura', 1089.0000, 'ºC'),
	(182583, 121, '2014-02-01 00:50:18.000000', 'temperatura', 490.0000, 'ºC'),
	(182584, 121, '2014-02-01 00:50:19.000000', 'temperatura', 382.0000, 'ºC'),
	(182585, 121, '2014-02-01 00:50:20.000000', 'temperatura', 441.0000, 'ºC'),
	(182586, 121, '2014-02-01 00:50:21.000000', 'temperatura', 1060.0000, 'ºC'),
	(182587, 121, '2014-02-01 00:50:22.000000', 'temperatura', 376.0000, 'ºC'),
	(182588, 121, '2014-02-01 00:50:23.000000', 'temperatura', 1101.0000, 'ºC'),
	(182589, 121, '2014-02-01 00:50:24.000000', 'temperatura', 777.0000, 'ºC'),
	(182590, 121, '2014-02-01 00:50:25.000000', 'temperatura', 585.0000, 'ºC'),
	(182591, 121, '2014-02-01 00:50:26.000000', 'temperatura', 592.0000, 'ºC'),
	(182592, 121, '2014-02-01 00:50:27.000000', 'temperatura', 7.0000, 'ºC'),
	(182593, 121, '2014-02-01 00:50:28.000000', 'temperatura', 660.0000, 'ºC'),
	(182594, 121, '2014-02-01 00:50:29.000000', 'temperatura', 877.0000, 'ºC'),
	(182595, 121, '2014-02-01 00:50:30.000000', 'temperatura', 7.0000, 'ºC'),
	(182596, 121, '2014-02-01 00:50:31.000000', 'temperatura', 1002.0000, 'ºC'),
	(182597, 121, '2014-02-01 00:50:32.000000', 'temperatura', 192.0000, 'ºC'),
	(182598, 121, '2014-02-01 00:50:33.000000', 'temperatura', 355.0000, 'ºC'),
	(182599, 121, '2014-02-01 00:50:34.000000', 'temperatura', 1197.0000, 'ºC'),
	(182600, 121, '2014-02-01 00:50:35.000000', 'temperatura', 123.0000, 'ºC'),
	(182601, 121, '2014-02-01 00:50:36.000000', 'temperatura', 622.0000, 'ºC'),
	(182602, 121, '2014-02-01 00:50:37.000000', 'temperatura', 342.0000, 'ºC'),
	(182603, 121, '2014-02-01 00:50:38.000000', 'temperatura', 1044.0000, 'ºC'),
	(182604, 121, '2014-02-01 00:50:39.000000', 'temperatura', 596.0000, 'ºC'),
	(182605, 121, '2014-02-01 00:50:40.000000', 'temperatura', 1046.0000, 'ºC'),
	(182606, 121, '2014-02-01 00:50:41.000000', 'temperatura', 1043.0000, 'ºC'),
	(182607, 121, '2014-02-01 00:50:42.000000', 'temperatura', 877.0000, 'ºC'),
	(182608, 121, '2014-02-01 00:50:43.000000', 'temperatura', 58.0000, 'ºC'),
	(182609, 121, '2014-02-01 00:50:44.000000', 'temperatura', 58.0000, 'ºC'),
	(182610, 121, '2014-02-01 00:50:45.000000', 'temperatura', 116.0000, 'ºC'),
	(182611, 121, '2014-02-01 00:50:46.000000', 'temperatura', 408.0000, 'ºC'),
	(182612, 121, '2014-02-01 00:50:47.000000', 'temperatura', 493.0000, 'ºC'),
	(182613, 121, '2014-02-01 00:50:48.000000', 'temperatura', 39.0000, 'ºC'),
	(182614, 121, '2014-02-01 00:50:49.000000', 'temperatura', 1116.0000, 'ºC'),
	(182615, 121, '2014-02-01 00:50:50.000000', 'temperatura', 667.0000, 'ºC'),
	(182616, 121, '2014-02-01 00:50:51.000000', 'temperatura', 1185.0000, 'ºC'),
	(182617, 121, '2014-02-01 00:50:52.000000', 'temperatura', 323.0000, 'ºC'),
	(182618, 121, '2014-02-01 00:50:53.000000', 'temperatura', 463.0000, 'ºC'),
	(182619, 121, '2014-02-01 00:50:54.000000', 'temperatura', 148.0000, 'ºC'),
	(182620, 121, '2014-02-01 00:50:55.000000', 'temperatura', 549.0000, 'ºC'),
	(182621, 121, '2014-02-01 00:50:56.000000', 'temperatura', 1104.0000, 'ºC'),
	(182622, 121, '2014-02-01 00:50:57.000000', 'temperatura', 270.0000, 'ºC'),
	(182623, 121, '2014-02-01 00:50:58.000000', 'temperatura', 441.0000, 'ºC'),
	(182624, 121, '2014-02-01 00:50:59.000000', 'temperatura', 196.0000, 'ºC'),
	(182625, 121, '2014-02-01 00:51:00.000000', 'temperatura', 856.0000, 'ºC'),
	(182626, 121, '2014-02-01 00:51:01.000000', 'temperatura', 92.0000, 'ºC'),
	(182627, 121, '2014-02-01 00:51:02.000000', 'temperatura', 292.0000, 'ºC'),
	(182628, 121, '2014-02-01 00:51:03.000000', 'temperatura', 1184.0000, 'ºC'),
	(182629, 121, '2014-02-01 00:51:04.000000', 'temperatura', 247.0000, 'ºC'),
	(182630, 121, '2014-02-01 00:51:05.000000', 'temperatura', 81.0000, 'ºC'),
	(182631, 121, '2014-02-01 00:51:06.000000', 'temperatura', 866.0000, 'ºC'),
	(182632, 121, '2014-02-01 00:51:07.000000', 'temperatura', 485.0000, 'ºC'),
	(182633, 121, '2014-02-01 00:51:08.000000', 'temperatura', 1030.0000, 'ºC'),
	(182634, 121, '2014-02-01 00:51:09.000000', 'temperatura', 94.0000, 'ºC'),
	(182635, 121, '2014-02-01 00:51:10.000000', 'temperatura', 980.0000, 'ºC'),
	(182636, 121, '2014-02-01 00:51:11.000000', 'temperatura', 1018.0000, 'ºC'),
	(182637, 121, '2014-02-01 00:51:12.000000', 'temperatura', 950.0000, 'ºC'),
	(182638, 121, '2014-02-01 00:51:13.000000', 'temperatura', 499.0000, 'ºC'),
	(182639, 121, '2014-02-01 00:51:14.000000', 'temperatura', 846.0000, 'ºC'),
	(182640, 121, '2014-02-01 00:51:15.000000', 'temperatura', 333.0000, 'ºC'),
	(182641, 121, '2014-02-01 00:51:16.000000', 'temperatura', 327.0000, 'ºC'),
	(182642, 121, '2014-02-01 00:51:17.000000', 'temperatura', 636.0000, 'ºC'),
	(182643, 121, '2014-02-01 00:51:18.000000', 'temperatura', 998.0000, 'ºC'),
	(182644, 121, '2014-02-01 00:51:19.000000', 'temperatura', 683.0000, 'ºC'),
	(182645, 121, '2014-02-01 00:51:20.000000', 'temperatura', 424.0000, 'ºC'),
	(182646, 121, '2014-02-01 00:51:21.000000', 'temperatura', 70.0000, 'ºC'),
	(182647, 121, '2014-02-01 00:51:22.000000', 'temperatura', 277.0000, 'ºC'),
	(182648, 121, '2014-02-01 00:51:23.000000', 'temperatura', 1177.0000, 'ºC'),
	(182649, 121, '2014-02-01 00:51:24.000000', 'temperatura', 256.0000, 'ºC'),
	(182650, 121, '2014-02-01 00:51:25.000000', 'temperatura', 148.0000, 'ºC'),
	(182651, 121, '2014-02-01 00:51:26.000000', 'temperatura', 1174.0000, 'ºC'),
	(182652, 121, '2014-02-01 00:51:27.000000', 'temperatura', 627.0000, 'ºC'),
	(182653, 121, '2014-02-01 00:51:28.000000', 'temperatura', 812.0000, 'ºC'),
	(182654, 121, '2014-02-01 00:51:29.000000', 'temperatura', 981.0000, 'ºC'),
	(182655, 121, '2014-02-01 00:51:30.000000', 'temperatura', 67.0000, 'ºC'),
	(182656, 121, '2014-02-01 00:51:31.000000', 'temperatura', 994.0000, 'ºC'),
	(182657, 121, '2014-02-01 00:51:32.000000', 'temperatura', 1169.0000, 'ºC'),
	(182658, 121, '2014-02-01 00:51:33.000000', 'temperatura', 464.0000, 'ºC'),
	(182659, 121, '2014-02-01 00:51:34.000000', 'temperatura', 15.0000, 'ºC'),
	(182660, 121, '2014-02-01 00:51:35.000000', 'temperatura', 1082.0000, 'ºC'),
	(182661, 121, '2014-02-01 00:51:36.000000', 'temperatura', 566.0000, 'ºC'),
	(182662, 121, '2014-02-01 00:51:37.000000', 'temperatura', 785.0000, 'ºC'),
	(182663, 121, '2014-02-01 00:51:38.000000', 'temperatura', 1029.0000, 'ºC'),
	(182664, 121, '2014-02-01 00:51:39.000000', 'temperatura', 389.0000, 'ºC'),
	(182665, 121, '2014-02-01 00:51:40.000000', 'temperatura', 57.0000, 'ºC'),
	(182666, 121, '2014-02-01 00:51:41.000000', 'temperatura', 322.0000, 'ºC'),
	(182667, 121, '2014-02-01 00:51:42.000000', 'temperatura', 236.0000, 'ºC'),
	(182668, 121, '2014-02-01 00:51:43.000000', 'temperatura', 217.0000, 'ºC'),
	(182669, 121, '2014-02-01 00:51:44.000000', 'temperatura', 376.0000, 'ºC'),
	(182670, 121, '2014-02-01 00:51:45.000000', 'temperatura', 29.0000, 'ºC'),
	(182671, 121, '2014-02-01 00:51:46.000000', 'temperatura', 220.0000, 'ºC'),
	(182672, 121, '2014-02-01 00:51:47.000000', 'temperatura', 1012.0000, 'ºC'),
	(182673, 121, '2014-02-01 00:51:48.000000', 'temperatura', 800.0000, 'ºC'),
	(182674, 121, '2014-02-01 00:51:49.000000', 'temperatura', 967.0000, 'ºC'),
	(182675, 121, '2014-02-01 00:51:50.000000', 'temperatura', 34.0000, 'ºC'),
	(182676, 121, '2014-02-01 00:51:51.000000', 'temperatura', 869.0000, 'ºC'),
	(182677, 121, '2014-02-01 00:51:52.000000', 'temperatura', 646.0000, 'ºC'),
	(182678, 121, '2014-02-01 00:51:53.000000', 'temperatura', 621.0000, 'ºC'),
	(182679, 121, '2014-02-01 00:51:54.000000', 'temperatura', 1169.0000, 'ºC'),
	(182680, 121, '2014-02-01 00:51:55.000000', 'temperatura', 382.0000, 'ºC'),
	(182681, 121, '2014-02-01 00:51:56.000000', 'temperatura', 802.0000, 'ºC'),
	(182682, 121, '2014-02-01 00:51:57.000000', 'temperatura', 467.0000, 'ºC'),
	(182683, 121, '2014-02-01 00:51:58.000000', 'temperatura', 1130.0000, 'ºC'),
	(182684, 121, '2014-02-01 00:51:59.000000', 'temperatura', 650.0000, 'ºC'),
	(182685, 121, '2014-02-01 00:52:00.000000', 'temperatura', 1061.0000, 'ºC'),
	(182686, 121, '2014-02-01 00:52:01.000000', 'temperatura', 956.0000, 'ºC'),
	(182687, 121, '2014-02-01 00:52:02.000000', 'temperatura', 395.0000, 'ºC'),
	(182688, 121, '2014-02-01 00:52:03.000000', 'temperatura', 307.0000, 'ºC'),
	(182689, 121, '2014-02-01 00:52:04.000000', 'temperatura', 353.0000, 'ºC'),
	(182690, 121, '2014-02-01 00:52:05.000000', 'temperatura', 843.0000, 'ºC'),
	(182691, 121, '2014-02-01 00:52:06.000000', 'temperatura', 755.0000, 'ºC'),
	(182692, 121, '2014-02-01 00:52:07.000000', 'temperatura', 47.0000, 'ºC'),
	(182693, 121, '2014-02-01 00:52:08.000000', 'temperatura', 369.0000, 'ºC'),
	(182694, 121, '2014-02-01 00:52:09.000000', 'temperatura', 507.0000, 'ºC'),
	(182695, 121, '2014-02-01 00:52:10.000000', 'temperatura', 226.0000, 'ºC'),
	(182696, 121, '2014-02-01 00:52:11.000000', 'temperatura', 810.0000, 'ºC'),
	(182697, 121, '2014-02-01 00:52:12.000000', 'temperatura', 972.0000, 'ºC'),
	(182698, 121, '2014-02-01 00:52:13.000000', 'temperatura', 31.0000, 'ºC'),
	(182699, 121, '2014-02-01 00:52:14.000000', 'temperatura', 840.0000, 'ºC'),
	(182700, 121, '2014-02-01 00:52:15.000000', 'temperatura', 505.0000, 'ºC'),
	(182701, 121, '2014-02-01 00:52:16.000000', 'temperatura', 9.0000, 'ºC'),
	(182702, 121, '2014-02-01 00:52:17.000000', 'temperatura', 928.0000, 'ºC'),
	(182703, 121, '2014-02-01 00:52:18.000000', 'temperatura', 1015.0000, 'ºC'),
	(182704, 121, '2014-02-01 00:52:19.000000', 'temperatura', 1089.0000, 'ºC'),
	(182705, 121, '2014-02-01 00:52:20.000000', 'temperatura', 1.0000, 'ºC'),
	(182706, 121, '2014-02-01 00:52:21.000000', 'temperatura', 341.0000, 'ºC'),
	(182707, 121, '2014-02-01 00:52:22.000000', 'temperatura', 502.0000, 'ºC'),
	(182708, 121, '2014-02-01 00:52:23.000000', 'temperatura', 285.0000, 'ºC'),
	(182709, 121, '2014-02-01 00:52:24.000000', 'temperatura', 1122.0000, 'ºC'),
	(182710, 121, '2014-02-01 00:52:25.000000', 'temperatura', 1154.0000, 'ºC'),
	(182711, 121, '2014-02-01 00:52:26.000000', 'temperatura', 3.0000, 'ºC'),
	(182712, 121, '2014-02-01 00:52:27.000000', 'temperatura', 157.0000, 'ºC'),
	(182713, 121, '2014-02-01 00:52:28.000000', 'temperatura', 775.0000, 'ºC'),
	(182714, 121, '2014-02-01 00:52:29.000000', 'temperatura', 1003.0000, 'ºC'),
	(182715, 121, '2014-02-01 00:52:30.000000', 'temperatura', 290.0000, 'ºC'),
	(182716, 121, '2014-02-01 00:52:31.000000', 'temperatura', 842.0000, 'ºC'),
	(182717, 121, '2014-02-01 00:52:32.000000', 'temperatura', 942.0000, 'ºC'),
	(182718, 121, '2014-02-01 00:52:33.000000', 'temperatura', 985.0000, 'ºC'),
	(182719, 121, '2014-02-01 00:52:34.000000', 'temperatura', 899.0000, 'ºC'),
	(182720, 121, '2014-02-01 00:52:35.000000', 'temperatura', 340.0000, 'ºC'),
	(182721, 121, '2014-02-01 00:52:36.000000', 'temperatura', 206.0000, 'ºC'),
	(182722, 121, '2014-02-01 00:52:37.000000', 'temperatura', 7.0000, 'ºC'),
	(182723, 121, '2014-02-01 00:52:38.000000', 'temperatura', 618.0000, 'ºC'),
	(182724, 121, '2014-02-01 00:52:39.000000', 'temperatura', 670.0000, 'ºC'),
	(182725, 121, '2014-02-01 00:52:40.000000', 'temperatura', 296.0000, 'ºC'),
	(182726, 121, '2014-02-01 00:52:41.000000', 'temperatura', 669.0000, 'ºC'),
	(182727, 121, '2014-02-01 00:52:42.000000', 'temperatura', 59.0000, 'ºC'),
	(182728, 121, '2014-02-01 00:52:43.000000', 'temperatura', 686.0000, 'ºC'),
	(182729, 121, '2014-02-01 00:52:44.000000', 'temperatura', 856.0000, 'ºC'),
	(182730, 121, '2014-02-01 00:52:45.000000', 'temperatura', 1023.0000, 'ºC'),
	(182731, 121, '2014-02-01 00:52:46.000000', 'temperatura', 145.0000, 'ºC'),
	(182732, 121, '2014-02-01 00:52:47.000000', 'temperatura', 56.0000, 'ºC'),
	(182733, 121, '2014-02-01 00:52:48.000000', 'temperatura', 1049.0000, 'ºC'),
	(182734, 121, '2014-02-01 00:52:49.000000', 'temperatura', 275.0000, 'ºC'),
	(182735, 121, '2014-02-01 00:52:50.000000', 'temperatura', 629.0000, 'ºC'),
	(182736, 121, '2014-02-01 00:52:51.000000', 'temperatura', 1119.0000, 'ºC'),
	(182737, 121, '2014-02-01 00:52:52.000000', 'temperatura', 111.0000, 'ºC'),
	(182738, 121, '2014-02-01 00:52:53.000000', 'temperatura', 798.0000, 'ºC'),
	(182739, 121, '2014-02-01 00:52:54.000000', 'temperatura', 59.0000, 'ºC'),
	(182740, 121, '2014-02-01 00:52:55.000000', 'temperatura', 300.0000, 'ºC'),
	(182741, 121, '2014-02-01 00:52:56.000000', 'temperatura', 122.0000, 'ºC'),
	(182742, 121, '2014-02-01 00:52:57.000000', 'temperatura', 912.0000, 'ºC'),
	(182743, 121, '2014-02-01 00:52:58.000000', 'temperatura', 593.0000, 'ºC'),
	(182744, 121, '2014-02-01 00:52:59.000000', 'temperatura', 231.0000, 'ºC'),
	(182745, 121, '2014-02-01 00:53:00.000000', 'temperatura', 576.0000, 'ºC'),
	(182746, 121, '2014-02-01 00:53:01.000000', 'temperatura', 986.0000, 'ºC'),
	(182747, 121, '2014-02-01 00:53:02.000000', 'temperatura', 805.0000, 'ºC'),
	(182748, 121, '2014-02-01 00:53:03.000000', 'temperatura', 1066.0000, 'ºC'),
	(182749, 121, '2014-02-01 00:53:04.000000', 'temperatura', 516.0000, 'ºC'),
	(182750, 121, '2014-02-01 00:53:05.000000', 'temperatura', 584.0000, 'ºC'),
	(182751, 121, '2014-02-01 00:53:06.000000', 'temperatura', 171.0000, 'ºC'),
	(182752, 121, '2014-02-01 00:53:07.000000', 'temperatura', 304.0000, 'ºC'),
	(182753, 121, '2014-02-01 00:53:08.000000', 'temperatura', 1007.0000, 'ºC'),
	(182754, 121, '2014-02-01 00:53:09.000000', 'temperatura', 523.0000, 'ºC'),
	(182755, 121, '2014-02-01 00:53:10.000000', 'temperatura', 795.0000, 'ºC'),
	(182756, 121, '2014-02-01 00:53:11.000000', 'temperatura', 5.0000, 'ºC'),
	(182757, 121, '2014-02-01 00:53:12.000000', 'temperatura', 42.0000, 'ºC'),
	(182758, 121, '2014-02-01 00:53:13.000000', 'temperatura', 193.0000, 'ºC'),
	(182759, 121, '2014-02-01 00:53:14.000000', 'temperatura', 841.0000, 'ºC'),
	(182760, 121, '2014-02-01 00:53:15.000000', 'temperatura', 29.0000, 'ºC'),
	(182761, 121, '2014-02-01 00:53:16.000000', 'temperatura', 19.0000, 'ºC'),
	(182762, 121, '2014-02-01 00:53:17.000000', 'temperatura', 9.0000, 'ºC'),
	(182763, 121, '2014-02-01 00:53:18.000000', 'temperatura', 1191.0000, 'ºC'),
	(182764, 121, '2014-02-01 00:53:19.000000', 'temperatura', 1127.0000, 'ºC'),
	(182765, 121, '2014-02-01 00:53:20.000000', 'temperatura', 863.0000, 'ºC'),
	(182766, 121, '2014-02-01 00:53:21.000000', 'temperatura', 934.0000, 'ºC'),
	(182767, 121, '2014-02-01 00:53:22.000000', 'temperatura', 882.0000, 'ºC'),
	(182768, 121, '2014-02-01 00:53:23.000000', 'temperatura', 410.0000, 'ºC'),
	(182769, 121, '2014-02-01 00:53:24.000000', 'temperatura', 602.0000, 'ºC'),
	(182770, 121, '2014-02-01 00:53:25.000000', 'temperatura', 580.0000, 'ºC'),
	(182771, 121, '2014-02-01 00:53:26.000000', 'temperatura', 1095.0000, 'ºC'),
	(182772, 121, '2014-02-01 00:53:27.000000', 'temperatura', 134.0000, 'ºC'),
	(182773, 121, '2014-02-01 00:53:28.000000', 'temperatura', 988.0000, 'ºC'),
	(182774, 121, '2014-02-01 00:53:29.000000', 'temperatura', 939.0000, 'ºC'),
	(182775, 121, '2014-02-01 00:53:30.000000', 'temperatura', 529.0000, 'ºC'),
	(182776, 121, '2014-02-01 00:53:31.000000', 'temperatura', 1031.0000, 'ºC'),
	(182777, 121, '2014-02-01 00:53:32.000000', 'temperatura', 1169.0000, 'ºC'),
	(182778, 121, '2014-02-01 00:53:33.000000', 'temperatura', 350.0000, 'ºC'),
	(182779, 121, '2014-02-01 00:53:34.000000', 'temperatura', 643.0000, 'ºC'),
	(182780, 121, '2014-02-01 00:53:35.000000', 'temperatura', 966.0000, 'ºC'),
	(182781, 121, '2014-02-01 00:53:36.000000', 'temperatura', 504.0000, 'ºC'),
	(182782, 121, '2014-02-01 00:53:37.000000', 'temperatura', 819.0000, 'ºC'),
	(182783, 121, '2014-02-01 00:53:38.000000', 'temperatura', 186.0000, 'ºC'),
	(182784, 121, '2014-02-01 00:53:39.000000', 'temperatura', 872.0000, 'ºC'),
	(182785, 121, '2014-02-01 00:53:40.000000', 'temperatura', 204.0000, 'ºC'),
	(182786, 121, '2014-02-01 00:53:41.000000', 'temperatura', 804.0000, 'ºC'),
	(182787, 121, '2014-02-01 00:53:42.000000', 'temperatura', 1007.0000, 'ºC'),
	(182788, 121, '2014-02-01 00:53:43.000000', 'temperatura', 223.0000, 'ºC'),
	(182789, 121, '2014-02-01 00:53:44.000000', 'temperatura', 497.0000, 'ºC'),
	(182790, 121, '2014-02-01 00:53:45.000000', 'temperatura', 616.0000, 'ºC'),
	(182791, 121, '2014-02-01 00:53:46.000000', 'temperatura', 391.0000, 'ºC'),
	(182792, 121, '2014-02-01 00:53:47.000000', 'temperatura', 107.0000, 'ºC'),
	(182793, 121, '2014-02-01 00:53:48.000000', 'temperatura', 562.0000, 'ºC'),
	(182794, 121, '2014-02-01 00:53:49.000000', 'temperatura', 91.0000, 'ºC'),
	(182795, 121, '2014-02-01 00:53:50.000000', 'temperatura', 1170.0000, 'ºC'),
	(182796, 121, '2014-02-01 00:53:51.000000', 'temperatura', 775.0000, 'ºC'),
	(182797, 121, '2014-02-01 00:53:52.000000', 'temperatura', 368.0000, 'ºC'),
	(182798, 121, '2014-02-01 00:53:53.000000', 'temperatura', 716.0000, 'ºC'),
	(182799, 121, '2014-02-01 00:53:54.000000', 'temperatura', 74.0000, 'ºC'),
	(182800, 121, '2014-02-01 00:53:55.000000', 'temperatura', 623.0000, 'ºC'),
	(182801, 121, '2014-02-01 00:53:56.000000', 'temperatura', 493.0000, 'ºC'),
	(182802, 121, '2014-02-01 00:53:57.000000', 'temperatura', 596.0000, 'ºC'),
	(182803, 121, '2014-02-01 00:53:58.000000', 'temperatura', 304.0000, 'ºC'),
	(182804, 121, '2014-02-01 00:53:59.000000', 'temperatura', 931.0000, 'ºC'),
	(182805, 121, '2014-02-01 00:54:00.000000', 'temperatura', 143.0000, 'ºC'),
	(182806, 121, '2014-02-01 00:54:01.000000', 'temperatura', 324.0000, 'ºC'),
	(182807, 121, '2014-02-01 00:54:02.000000', 'temperatura', 1191.0000, 'ºC'),
	(182808, 121, '2014-02-01 00:54:03.000000', 'temperatura', 182.0000, 'ºC'),
	(182809, 121, '2014-02-01 00:54:04.000000', 'temperatura', 940.0000, 'ºC'),
	(182810, 121, '2014-02-01 00:54:05.000000', 'temperatura', 553.0000, 'ºC'),
	(182811, 121, '2014-02-01 00:54:06.000000', 'temperatura', 1145.0000, 'ºC'),
	(182812, 121, '2014-02-01 00:54:07.000000', 'temperatura', 465.0000, 'ºC'),
	(182813, 121, '2014-02-01 00:54:08.000000', 'temperatura', 92.0000, 'ºC'),
	(182814, 121, '2014-02-01 00:54:09.000000', 'temperatura', 267.0000, 'ºC'),
	(182815, 121, '2014-02-01 00:54:10.000000', 'temperatura', 1059.0000, 'ºC'),
	(182816, 121, '2014-02-01 00:54:11.000000', 'temperatura', 895.0000, 'ºC'),
	(182817, 121, '2014-02-01 00:54:12.000000', 'temperatura', 99.0000, 'ºC'),
	(182818, 121, '2014-02-01 00:54:13.000000', 'temperatura', 211.0000, 'ºC'),
	(182819, 121, '2014-02-01 00:54:14.000000', 'temperatura', 758.0000, 'ºC'),
	(182820, 121, '2014-02-01 00:54:15.000000', 'temperatura', 755.0000, 'ºC'),
	(182821, 121, '2014-02-01 00:54:16.000000', 'temperatura', 304.0000, 'ºC'),
	(182822, 121, '2014-02-01 00:54:17.000000', 'temperatura', 455.0000, 'ºC'),
	(182823, 121, '2014-02-01 00:54:18.000000', 'temperatura', 162.0000, 'ºC'),
	(182824, 121, '2014-02-01 00:54:19.000000', 'temperatura', 647.0000, 'ºC'),
	(182825, 121, '2014-02-01 00:54:20.000000', 'temperatura', 348.0000, 'ºC'),
	(182826, 121, '2014-02-01 00:54:21.000000', 'temperatura', 1002.0000, 'ºC'),
	(182827, 121, '2014-02-01 00:54:22.000000', 'temperatura', 365.0000, 'ºC'),
	(182828, 121, '2014-02-01 00:54:23.000000', 'temperatura', 18.0000, 'ºC'),
	(182829, 121, '2014-02-01 00:54:24.000000', 'temperatura', 195.0000, 'ºC'),
	(182830, 121, '2014-02-01 00:54:25.000000', 'temperatura', 923.0000, 'ºC'),
	(182831, 121, '2014-02-01 00:54:26.000000', 'temperatura', 429.0000, 'ºC'),
	(182832, 121, '2014-02-01 00:54:27.000000', 'temperatura', 576.0000, 'ºC'),
	(182833, 121, '2014-02-01 00:54:28.000000', 'temperatura', 394.0000, 'ºC'),
	(182834, 121, '2014-02-01 00:54:29.000000', 'temperatura', 241.0000, 'ºC'),
	(182835, 121, '2014-02-01 00:54:30.000000', 'temperatura', 25.0000, 'ºC'),
	(182836, 121, '2014-02-01 00:54:31.000000', 'temperatura', 603.0000, 'ºC'),
	(182837, 121, '2014-02-01 00:54:32.000000', 'temperatura', 539.0000, 'ºC'),
	(182838, 121, '2014-02-01 00:54:33.000000', 'temperatura', 888.0000, 'ºC'),
	(182839, 121, '2014-02-01 00:54:34.000000', 'temperatura', 422.0000, 'ºC'),
	(182840, 121, '2014-02-01 00:54:35.000000', 'temperatura', 649.0000, 'ºC'),
	(182841, 121, '2014-02-01 00:54:36.000000', 'temperatura', 779.0000, 'ºC'),
	(182842, 121, '2014-02-01 00:54:37.000000', 'temperatura', 746.0000, 'ºC'),
	(182843, 121, '2014-02-01 00:54:38.000000', 'temperatura', 196.0000, 'ºC'),
	(182844, 121, '2014-02-01 00:54:39.000000', 'temperatura', 1142.0000, 'ºC'),
	(182845, 121, '2014-02-01 00:54:40.000000', 'temperatura', 322.0000, 'ºC'),
	(182846, 121, '2014-02-01 00:54:41.000000', 'temperatura', 585.0000, 'ºC'),
	(182847, 121, '2014-02-01 00:54:42.000000', 'temperatura', 760.0000, 'ºC'),
	(182848, 121, '2014-02-01 00:54:43.000000', 'temperatura', 843.0000, 'ºC'),
	(182849, 121, '2014-02-01 00:54:44.000000', 'temperatura', 737.0000, 'ºC'),
	(182850, 121, '2014-02-01 00:54:45.000000', 'temperatura', 1155.0000, 'ºC'),
	(182851, 121, '2014-02-01 00:54:46.000000', 'temperatura', 1164.0000, 'ºC'),
	(182852, 121, '2014-02-01 00:54:47.000000', 'temperatura', 1155.0000, 'ºC'),
	(182853, 121, '2014-02-01 00:54:48.000000', 'temperatura', 1084.0000, 'ºC'),
	(182854, 121, '2014-02-01 00:54:49.000000', 'temperatura', 758.0000, 'ºC'),
	(182855, 121, '2014-02-01 00:54:50.000000', 'temperatura', 537.0000, 'ºC'),
	(182856, 121, '2014-02-01 00:54:51.000000', 'temperatura', 411.0000, 'ºC'),
	(182857, 121, '2014-02-01 00:54:52.000000', 'temperatura', 446.0000, 'ºC'),
	(182858, 121, '2014-02-01 00:54:53.000000', 'temperatura', 997.0000, 'ºC'),
	(182859, 121, '2014-02-01 00:54:54.000000', 'temperatura', 48.0000, 'ºC'),
	(182860, 121, '2014-02-01 00:54:55.000000', 'temperatura', 850.0000, 'ºC'),
	(182861, 121, '2014-02-01 00:54:56.000000', 'temperatura', 505.0000, 'ºC'),
	(182862, 121, '2014-02-01 00:54:57.000000', 'temperatura', 1177.0000, 'ºC'),
	(182863, 121, '2014-02-01 00:54:58.000000', 'temperatura', 768.0000, 'ºC'),
	(182864, 121, '2014-02-01 00:54:59.000000', 'temperatura', 312.0000, 'ºC'),
	(182865, 121, '2014-02-01 00:55:00.000000', 'temperatura', 456.0000, 'ºC'),
	(182866, 121, '2014-02-01 00:55:01.000000', 'temperatura', 144.0000, 'ºC'),
	(182867, 121, '2014-02-01 00:55:02.000000', 'temperatura', 553.0000, 'ºC'),
	(182868, 121, '2014-02-01 00:55:03.000000', 'temperatura', 1133.0000, 'ºC'),
	(182869, 121, '2014-02-01 00:55:04.000000', 'temperatura', 407.0000, 'ºC'),
	(182870, 121, '2014-02-01 00:55:05.000000', 'temperatura', 1037.0000, 'ºC'),
	(182871, 121, '2014-02-01 00:55:06.000000', 'temperatura', 363.0000, 'ºC'),
	(182872, 121, '2014-02-01 00:55:07.000000', 'temperatura', 1106.0000, 'ºC'),
	(182873, 121, '2014-02-01 00:55:08.000000', 'temperatura', 842.0000, 'ºC'),
	(182874, 121, '2014-02-01 00:55:09.000000', 'temperatura', 890.0000, 'ºC'),
	(182875, 121, '2014-02-01 00:55:10.000000', 'temperatura', 727.0000, 'ºC'),
	(182876, 121, '2014-02-01 00:55:11.000000', 'temperatura', 966.0000, 'ºC'),
	(182877, 121, '2014-02-01 00:55:12.000000', 'temperatura', 250.0000, 'ºC'),
	(182878, 121, '2014-02-01 00:55:13.000000', 'temperatura', 753.0000, 'ºC'),
	(182879, 121, '2014-02-01 00:55:14.000000', 'temperatura', 616.0000, 'ºC'),
	(182880, 121, '2014-02-01 00:55:15.000000', 'temperatura', 819.0000, 'ºC'),
	(182881, 121, '2014-02-01 00:55:16.000000', 'temperatura', 1048.0000, 'ºC'),
	(182882, 121, '2014-02-01 00:55:17.000000', 'temperatura', 382.0000, 'ºC'),
	(182883, 121, '2014-02-01 00:55:18.000000', 'temperatura', 1167.0000, 'ºC'),
	(182884, 121, '2014-02-01 00:55:19.000000', 'temperatura', 1090.0000, 'ºC'),
	(182885, 121, '2014-02-01 00:55:20.000000', 'temperatura', 751.0000, 'ºC'),
	(182886, 121, '2014-02-01 00:55:21.000000', 'temperatura', 483.0000, 'ºC'),
	(182887, 121, '2014-02-01 00:55:22.000000', 'temperatura', 162.0000, 'ºC'),
	(182888, 121, '2014-02-01 00:55:23.000000', 'temperatura', 565.0000, 'ºC'),
	(182889, 121, '2014-02-01 00:55:24.000000', 'temperatura', 1137.0000, 'ºC'),
	(182890, 121, '2014-02-01 00:55:25.000000', 'temperatura', 389.0000, 'ºC'),
	(182891, 121, '2014-02-01 00:55:26.000000', 'temperatura', 936.0000, 'ºC'),
	(182892, 121, '2014-02-01 00:55:27.000000', 'temperatura', 1115.0000, 'ºC'),
	(182893, 121, '2014-02-01 00:55:28.000000', 'temperatura', 368.0000, 'ºC'),
	(182894, 121, '2014-02-01 00:55:29.000000', 'temperatura', 894.0000, 'ºC'),
	(182895, 121, '2014-02-01 00:55:30.000000', 'temperatura', 969.0000, 'ºC'),
	(182896, 121, '2014-02-01 00:55:31.000000', 'temperatura', 960.0000, 'ºC'),
	(182897, 121, '2014-02-01 00:55:32.000000', 'temperatura', 696.0000, 'ºC'),
	(182898, 121, '2014-02-01 00:55:33.000000', 'temperatura', 601.0000, 'ºC'),
	(182899, 121, '2014-02-01 00:55:34.000000', 'temperatura', 917.0000, 'ºC'),
	(182900, 121, '2014-02-01 00:55:35.000000', 'temperatura', 381.0000, 'ºC'),
	(182901, 121, '2014-02-01 00:55:36.000000', 'temperatura', 357.0000, 'ºC'),
	(182902, 121, '2014-02-01 00:55:37.000000', 'temperatura', 641.0000, 'ºC'),
	(182903, 121, '2014-02-01 00:55:38.000000', 'temperatura', 935.0000, 'ºC'),
	(182904, 121, '2014-02-01 00:55:39.000000', 'temperatura', 350.0000, 'ºC'),
	(182905, 121, '2014-02-01 00:55:40.000000', 'temperatura', 149.0000, 'ºC'),
	(182906, 121, '2014-02-01 00:55:41.000000', 'temperatura', 894.0000, 'ºC'),
	(182907, 121, '2014-02-01 00:55:42.000000', 'temperatura', 424.0000, 'ºC'),
	(182908, 121, '2014-02-01 00:55:43.000000', 'temperatura', 637.0000, 'ºC'),
	(182909, 121, '2014-02-01 00:55:44.000000', 'temperatura', 715.0000, 'ºC'),
	(182910, 121, '2014-02-01 00:55:45.000000', 'temperatura', 465.0000, 'ºC'),
	(182911, 121, '2014-02-01 00:55:46.000000', 'temperatura', 179.0000, 'ºC'),
	(182912, 121, '2014-02-01 00:55:47.000000', 'temperatura', 701.0000, 'ºC'),
	(182913, 121, '2014-02-01 00:55:48.000000', 'temperatura', 568.0000, 'ºC'),
	(182914, 121, '2014-02-01 00:55:49.000000', 'temperatura', 737.0000, 'ºC'),
	(182915, 121, '2014-02-01 00:55:50.000000', 'temperatura', 781.0000, 'ºC'),
	(182916, 121, '2014-02-01 00:55:51.000000', 'temperatura', 497.0000, 'ºC'),
	(182917, 121, '2014-02-01 00:55:52.000000', 'temperatura', 139.0000, 'ºC'),
	(182918, 121, '2014-02-01 00:55:53.000000', 'temperatura', 407.0000, 'ºC'),
	(182919, 121, '2014-02-01 00:55:54.000000', 'temperatura', 420.0000, 'ºC'),
	(182920, 121, '2014-02-01 00:55:55.000000', 'temperatura', 876.0000, 'ºC'),
	(182921, 121, '2014-02-01 00:55:56.000000', 'temperatura', 722.0000, 'ºC'),
	(182922, 121, '2014-02-01 00:55:57.000000', 'temperatura', 984.0000, 'ºC'),
	(182923, 121, '2014-02-01 00:55:58.000000', 'temperatura', 351.0000, 'ºC'),
	(182924, 121, '2014-02-01 00:55:59.000000', 'temperatura', 7.0000, 'ºC'),
	(182925, 121, '2014-02-01 00:56:00.000000', 'temperatura', 180.0000, 'ºC'),
	(182926, 121, '2014-02-01 00:56:01.000000', 'temperatura', 880.0000, 'ºC'),
	(182927, 121, '2014-02-01 00:56:02.000000', 'temperatura', 259.0000, 'ºC'),
	(182928, 121, '2014-02-01 00:56:03.000000', 'temperatura', 1056.0000, 'ºC'),
	(182929, 121, '2014-02-01 00:56:04.000000', 'temperatura', 903.0000, 'ºC'),
	(182930, 121, '2014-02-01 00:56:05.000000', 'temperatura', 147.0000, 'ºC'),
	(182931, 121, '2014-02-01 00:56:06.000000', 'temperatura', 428.0000, 'ºC'),
	(182932, 121, '2014-02-01 00:56:07.000000', 'temperatura', 500.0000, 'ºC'),
	(182933, 121, '2014-02-01 00:56:08.000000', 'temperatura', 14.0000, 'ºC'),
	(182934, 121, '2014-02-01 00:56:09.000000', 'temperatura', 970.0000, 'ºC'),
	(182935, 121, '2014-02-01 00:56:10.000000', 'temperatura', 12.0000, 'ºC'),
	(182936, 121, '2014-02-01 00:56:11.000000', 'temperatura', 748.0000, 'ºC'),
	(182937, 121, '2014-02-01 00:56:12.000000', 'temperatura', 105.0000, 'ºC'),
	(182938, 121, '2014-02-01 00:56:13.000000', 'temperatura', 683.0000, 'ºC'),
	(182939, 121, '2014-02-01 00:56:14.000000', 'temperatura', 698.0000, 'ºC'),
	(182940, 121, '2014-02-01 00:56:15.000000', 'temperatura', 241.0000, 'ºC'),
	(182941, 121, '2014-02-01 00:56:16.000000', 'temperatura', 312.0000, 'ºC'),
	(182942, 121, '2014-02-01 00:56:17.000000', 'temperatura', 838.0000, 'ºC'),
	(182943, 121, '2014-02-01 00:56:18.000000', 'temperatura', 853.0000, 'ºC'),
	(182944, 121, '2014-02-01 00:56:19.000000', 'temperatura', 553.0000, 'ºC'),
	(182945, 121, '2014-02-01 00:56:20.000000', 'temperatura', 206.0000, 'ºC'),
	(182946, 121, '2014-02-01 00:56:21.000000', 'temperatura', 570.0000, 'ºC'),
	(182947, 121, '2014-02-01 00:56:22.000000', 'temperatura', 1032.0000, 'ºC'),
	(182948, 121, '2014-02-01 00:56:23.000000', 'temperatura', 1051.0000, 'ºC'),
	(182949, 121, '2014-02-01 00:56:24.000000', 'temperatura', 959.0000, 'ºC'),
	(182950, 121, '2014-02-01 00:56:25.000000', 'temperatura', 444.0000, 'ºC'),
	(182951, 121, '2014-02-01 00:56:26.000000', 'temperatura', 543.0000, 'ºC'),
	(182952, 121, '2014-02-01 00:56:27.000000', 'temperatura', 185.0000, 'ºC'),
	(182953, 121, '2014-02-01 00:56:28.000000', 'temperatura', 494.0000, 'ºC'),
	(182954, 121, '2014-02-01 00:56:29.000000', 'temperatura', 716.0000, 'ºC'),
	(182955, 121, '2014-02-01 00:56:30.000000', 'temperatura', 899.0000, 'ºC'),
	(182956, 121, '2014-02-01 00:56:31.000000', 'temperatura', 1147.0000, 'ºC'),
	(182957, 121, '2014-02-01 00:56:32.000000', 'temperatura', 639.0000, 'ºC'),
	(182958, 121, '2014-02-01 00:56:33.000000', 'temperatura', 953.0000, 'ºC'),
	(182959, 121, '2014-02-01 00:56:34.000000', 'temperatura', 451.0000, 'ºC'),
	(182960, 121, '2014-02-01 00:56:35.000000', 'temperatura', 594.0000, 'ºC'),
	(182961, 121, '2014-02-01 00:56:36.000000', 'temperatura', 418.0000, 'ºC'),
	(182962, 121, '2014-02-01 00:56:37.000000', 'temperatura', 309.0000, 'ºC'),
	(182963, 121, '2014-02-01 00:56:38.000000', 'temperatura', 293.0000, 'ºC'),
	(182964, 121, '2014-02-01 00:56:39.000000', 'temperatura', 537.0000, 'ºC'),
	(182965, 121, '2014-02-01 00:56:40.000000', 'temperatura', 607.0000, 'ºC'),
	(182966, 121, '2014-02-01 00:56:41.000000', 'temperatura', 223.0000, 'ºC'),
	(182967, 121, '2014-02-01 00:56:42.000000', 'temperatura', 494.0000, 'ºC'),
	(182968, 121, '2014-02-01 00:56:43.000000', 'temperatura', 603.0000, 'ºC'),
	(182969, 121, '2014-02-01 00:56:44.000000', 'temperatura', 331.0000, 'ºC'),
	(182970, 121, '2014-02-01 00:56:45.000000', 'temperatura', 1048.0000, 'ºC'),
	(182971, 121, '2014-02-01 00:56:46.000000', 'temperatura', 648.0000, 'ºC'),
	(182972, 121, '2014-02-01 00:56:47.000000', 'temperatura', 96.0000, 'ºC'),
	(182973, 121, '2014-02-01 00:56:48.000000', 'temperatura', 934.0000, 'ºC'),
	(182974, 121, '2014-02-01 00:56:49.000000', 'temperatura', 786.0000, 'ºC'),
	(182975, 121, '2014-02-01 00:56:50.000000', 'temperatura', 1129.0000, 'ºC'),
	(182976, 121, '2014-02-01 00:56:51.000000', 'temperatura', 885.0000, 'ºC'),
	(182977, 121, '2014-02-01 00:56:52.000000', 'temperatura', 1040.0000, 'ºC'),
	(182978, 121, '2014-02-01 00:56:53.000000', 'temperatura', 145.0000, 'ºC'),
	(182979, 121, '2014-02-01 00:56:54.000000', 'temperatura', 5.0000, 'ºC'),
	(182980, 121, '2014-02-01 00:56:55.000000', 'temperatura', 792.0000, 'ºC'),
	(182981, 121, '2014-02-01 00:56:56.000000', 'temperatura', 344.0000, 'ºC'),
	(182982, 121, '2014-02-01 00:56:57.000000', 'temperatura', 543.0000, 'ºC'),
	(182983, 121, '2014-02-01 00:56:58.000000', 'temperatura', 487.0000, 'ºC'),
	(182984, 121, '2014-02-01 00:56:59.000000', 'temperatura', 804.0000, 'ºC'),
	(182985, 121, '2014-02-01 00:57:00.000000', 'temperatura', 160.0000, 'ºC'),
	(182986, 121, '2014-02-01 00:57:01.000000', 'temperatura', 789.0000, 'ºC'),
	(182987, 121, '2014-02-01 00:57:02.000000', 'temperatura', 1064.0000, 'ºC'),
	(182988, 121, '2014-02-01 00:57:03.000000', 'temperatura', 553.0000, 'ºC'),
	(182989, 121, '2014-02-01 00:57:04.000000', 'temperatura', 773.0000, 'ºC'),
	(182990, 121, '2014-02-01 00:57:05.000000', 'temperatura', 1007.0000, 'ºC'),
	(182991, 121, '2014-02-01 00:57:06.000000', 'temperatura', 315.0000, 'ºC'),
	(182992, 121, '2014-02-01 00:57:07.000000', 'temperatura', 958.0000, 'ºC'),
	(182993, 121, '2014-02-01 00:57:08.000000', 'temperatura', 242.0000, 'ºC'),
	(182994, 121, '2014-02-01 00:57:09.000000', 'temperatura', 737.0000, 'ºC'),
	(182995, 121, '2014-02-01 00:57:10.000000', 'temperatura', 562.0000, 'ºC'),
	(182996, 121, '2014-02-01 00:57:11.000000', 'temperatura', 597.0000, 'ºC'),
	(182997, 121, '2014-02-01 00:57:12.000000', 'temperatura', 100.0000, 'ºC'),
	(182998, 121, '2014-02-01 00:57:13.000000', 'temperatura', 1108.0000, 'ºC'),
	(182999, 121, '2014-02-01 00:57:14.000000', 'temperatura', 442.0000, 'ºC'),
	(183000, 121, '2014-02-01 00:57:15.000000', 'temperatura', 87.0000, 'ºC'),
	(183001, 121, '2014-02-01 00:57:16.000000', 'temperatura', 311.0000, 'ºC'),
	(183002, 121, '2014-02-01 00:57:17.000000', 'temperatura', 93.0000, 'ºC'),
	(183003, 121, '2014-02-01 00:57:18.000000', 'temperatura', 732.0000, 'ºC'),
	(183004, 121, '2014-02-01 00:57:19.000000', 'temperatura', 982.0000, 'ºC'),
	(183005, 121, '2014-02-01 00:57:20.000000', 'temperatura', 314.0000, 'ºC'),
	(183006, 121, '2014-02-01 00:57:21.000000', 'temperatura', 1024.0000, 'ºC'),
	(183007, 121, '2014-02-01 00:57:22.000000', 'temperatura', 579.0000, 'ºC'),
	(183008, 121, '2014-02-01 00:57:23.000000', 'temperatura', 1024.0000, 'ºC'),
	(183009, 121, '2014-02-01 00:57:24.000000', 'temperatura', 982.0000, 'ºC'),
	(183010, 121, '2014-02-01 00:57:25.000000', 'temperatura', 639.0000, 'ºC'),
	(183011, 121, '2014-02-01 00:57:26.000000', 'temperatura', 251.0000, 'ºC'),
	(183012, 121, '2014-02-01 00:57:27.000000', 'temperatura', 537.0000, 'ºC'),
	(183013, 121, '2014-02-01 00:57:28.000000', 'temperatura', 735.0000, 'ºC'),
	(183014, 121, '2014-02-01 00:57:29.000000', 'temperatura', 861.0000, 'ºC'),
	(183015, 121, '2014-02-01 00:57:30.000000', 'temperatura', 902.0000, 'ºC'),
	(183016, 121, '2014-02-01 00:57:31.000000', 'temperatura', 726.0000, 'ºC'),
	(183017, 121, '2014-02-01 00:57:32.000000', 'temperatura', 924.0000, 'ºC'),
	(183018, 121, '2014-02-01 00:57:33.000000', 'temperatura', 43.0000, 'ºC'),
	(183019, 121, '2014-02-01 00:57:34.000000', 'temperatura', 1042.0000, 'ºC'),
	(183020, 121, '2014-02-01 00:57:35.000000', 'temperatura', 282.0000, 'ºC'),
	(183021, 121, '2014-02-01 00:57:36.000000', 'temperatura', 687.0000, 'ºC'),
	(183022, 121, '2014-02-01 00:57:37.000000', 'temperatura', 188.0000, 'ºC'),
	(183023, 121, '2014-02-01 00:57:38.000000', 'temperatura', 81.0000, 'ºC'),
	(183024, 121, '2014-02-01 00:57:39.000000', 'temperatura', 1042.0000, 'ºC'),
	(183025, 121, '2014-02-01 00:57:40.000000', 'temperatura', 165.0000, 'ºC'),
	(183026, 121, '2014-02-01 00:57:41.000000', 'temperatura', 99.0000, 'ºC'),
	(183027, 121, '2014-02-01 00:57:42.000000', 'temperatura', 2.0000, 'ºC'),
	(183028, 121, '2014-02-01 00:57:43.000000', 'temperatura', 911.0000, 'ºC'),
	(183029, 121, '2014-02-01 00:57:44.000000', 'temperatura', 952.0000, 'ºC'),
	(183030, 121, '2014-02-01 00:57:45.000000', 'temperatura', 825.0000, 'ºC'),
	(183031, 121, '2014-02-01 00:57:46.000000', 'temperatura', 72.0000, 'ºC'),
	(183032, 121, '2014-02-01 00:57:47.000000', 'temperatura', 283.0000, 'ºC'),
	(183033, 121, '2014-02-01 00:57:48.000000', 'temperatura', 0.0000, 'ºC'),
	(183034, 121, '2014-02-01 00:57:49.000000', 'temperatura', 353.0000, 'ºC'),
	(183035, 121, '2014-02-01 00:57:50.000000', 'temperatura', 566.0000, 'ºC'),
	(183036, 121, '2014-02-01 00:57:51.000000', 'temperatura', 572.0000, 'ºC'),
	(183037, 121, '2014-02-01 00:57:52.000000', 'temperatura', 1161.0000, 'ºC'),
	(183038, 121, '2014-02-01 00:57:53.000000', 'temperatura', 491.0000, 'ºC'),
	(183039, 121, '2014-02-01 00:57:54.000000', 'temperatura', 173.0000, 'ºC'),
	(183040, 121, '2014-02-01 00:57:55.000000', 'temperatura', 590.0000, 'ºC'),
	(183041, 121, '2014-02-01 00:57:56.000000', 'temperatura', 31.0000, 'ºC'),
	(183042, 121, '2014-02-01 00:57:57.000000', 'temperatura', 786.0000, 'ºC'),
	(183043, 121, '2014-02-01 00:57:58.000000', 'temperatura', 240.0000, 'ºC'),
	(183044, 121, '2014-02-01 00:57:59.000000', 'temperatura', 41.0000, 'ºC'),
	(183045, 121, '2014-02-01 00:58:00.000000', 'temperatura', 687.0000, 'ºC'),
	(183046, 121, '2014-02-01 00:58:01.000000', 'temperatura', 912.0000, 'ºC'),
	(183047, 121, '2014-02-01 00:58:02.000000', 'temperatura', 100.0000, 'ºC'),
	(183048, 121, '2014-02-01 00:58:03.000000', 'temperatura', 162.0000, 'ºC'),
	(183049, 121, '2014-02-01 00:58:04.000000', 'temperatura', 514.0000, 'ºC'),
	(183050, 121, '2014-02-01 00:58:05.000000', 'temperatura', 882.0000, 'ºC'),
	(183051, 121, '2014-02-01 00:58:06.000000', 'temperatura', 470.0000, 'ºC'),
	(183052, 121, '2014-02-01 00:58:07.000000', 'temperatura', 905.0000, 'ºC'),
	(183053, 121, '2014-02-01 00:58:08.000000', 'temperatura', 713.0000, 'ºC'),
	(183054, 121, '2014-02-01 00:58:09.000000', 'temperatura', 853.0000, 'ºC'),
	(183055, 121, '2014-02-01 00:58:10.000000', 'temperatura', 926.0000, 'ºC'),
	(183056, 121, '2014-02-01 00:58:11.000000', 'temperatura', 873.0000, 'ºC'),
	(183057, 121, '2014-02-01 00:58:12.000000', 'temperatura', 386.0000, 'ºC'),
	(183058, 121, '2014-02-01 00:58:13.000000', 'temperatura', 511.0000, 'ºC'),
	(183059, 121, '2014-02-01 00:58:14.000000', 'temperatura', 197.0000, 'ºC'),
	(183060, 121, '2014-02-01 00:58:15.000000', 'temperatura', 655.0000, 'ºC'),
	(183061, 121, '2014-02-01 00:58:16.000000', 'temperatura', 284.0000, 'ºC'),
	(183062, 121, '2014-02-01 00:58:17.000000', 'temperatura', 657.0000, 'ºC'),
	(183063, 121, '2014-02-01 00:58:18.000000', 'temperatura', 31.0000, 'ºC'),
	(183064, 121, '2014-02-01 00:58:19.000000', 'temperatura', 585.0000, 'ºC'),
	(183065, 121, '2014-02-01 00:58:20.000000', 'temperatura', 432.0000, 'ºC'),
	(183066, 121, '2014-02-01 00:58:21.000000', 'temperatura', 404.0000, 'ºC'),
	(183067, 121, '2014-02-01 00:58:22.000000', 'temperatura', 728.0000, 'ºC'),
	(183068, 121, '2014-02-01 00:58:23.000000', 'temperatura', 25.0000, 'ºC'),
	(183069, 121, '2014-02-01 00:58:24.000000', 'temperatura', 344.0000, 'ºC'),
	(183070, 121, '2014-02-01 00:58:25.000000', 'temperatura', 444.0000, 'ºC'),
	(183071, 121, '2014-02-01 00:58:26.000000', 'temperatura', 1187.0000, 'ºC'),
	(183072, 121, '2014-02-01 00:58:27.000000', 'temperatura', 1006.0000, 'ºC'),
	(183073, 121, '2014-02-01 00:58:28.000000', 'temperatura', 269.0000, 'ºC'),
	(183074, 121, '2014-02-01 00:58:29.000000', 'temperatura', 726.0000, 'ºC'),
	(183075, 121, '2014-02-01 00:58:30.000000', 'temperatura', 424.0000, 'ºC'),
	(183076, 121, '2014-02-01 00:58:31.000000', 'temperatura', 1142.0000, 'ºC'),
	(183077, 121, '2014-02-01 00:58:32.000000', 'temperatura', 838.0000, 'ºC'),
	(183078, 121, '2014-02-01 00:58:33.000000', 'temperatura', 763.0000, 'ºC'),
	(183079, 121, '2014-02-01 00:58:34.000000', 'temperatura', 105.0000, 'ºC'),
	(183080, 121, '2014-02-01 00:58:35.000000', 'temperatura', 636.0000, 'ºC'),
	(183081, 121, '2014-02-01 00:58:36.000000', 'temperatura', 465.0000, 'ºC'),
	(183082, 121, '2014-02-01 00:58:37.000000', 'temperatura', 416.0000, 'ºC'),
	(183083, 121, '2014-02-01 00:58:38.000000', 'temperatura', 689.0000, 'ºC'),
	(183084, 121, '2014-02-01 00:58:39.000000', 'temperatura', 994.0000, 'ºC'),
	(183085, 121, '2014-02-01 00:58:40.000000', 'temperatura', 505.0000, 'ºC'),
	(183086, 121, '2014-02-01 00:58:41.000000', 'temperatura', 743.0000, 'ºC'),
	(183087, 121, '2014-02-01 00:58:42.000000', 'temperatura', 999.0000, 'ºC'),
	(183088, 121, '2014-02-01 00:58:43.000000', 'temperatura', 370.0000, 'ºC'),
	(183089, 121, '2014-02-01 00:58:44.000000', 'temperatura', 50.0000, 'ºC'),
	(183090, 121, '2014-02-01 00:58:45.000000', 'temperatura', 344.0000, 'ºC'),
	(183091, 121, '2014-02-01 00:58:46.000000', 'temperatura', 368.0000, 'ºC'),
	(183092, 121, '2014-02-01 00:58:47.000000', 'temperatura', 810.0000, 'ºC'),
	(183093, 121, '2014-02-01 00:58:48.000000', 'temperatura', 546.0000, 'ºC'),
	(183094, 121, '2014-02-01 00:58:49.000000', 'temperatura', 300.0000, 'ºC'),
	(183095, 121, '2014-02-01 00:58:50.000000', 'temperatura', 1061.0000, 'ºC'),
	(183096, 121, '2014-02-01 00:58:51.000000', 'temperatura', 808.0000, 'ºC'),
	(183097, 121, '2014-02-01 00:58:52.000000', 'temperatura', 858.0000, 'ºC'),
	(183098, 121, '2014-02-01 00:58:53.000000', 'temperatura', 664.0000, 'ºC'),
	(183099, 121, '2014-02-01 00:58:54.000000', 'temperatura', 748.0000, 'ºC'),
	(183100, 121, '2014-02-01 00:58:55.000000', 'temperatura', 547.0000, 'ºC'),
	(183101, 121, '2014-02-01 00:58:56.000000', 'temperatura', 494.0000, 'ºC'),
	(183102, 121, '2014-02-01 00:58:57.000000', 'temperatura', 829.0000, 'ºC'),
	(183103, 121, '2014-02-01 00:58:58.000000', 'temperatura', 264.0000, 'ºC'),
	(183104, 121, '2014-02-01 00:58:59.000000', 'temperatura', 32.0000, 'ºC'),
	(183105, 121, '2014-02-01 00:59:00.000000', 'temperatura', 570.0000, 'ºC'),
	(183106, 121, '2014-02-01 00:59:01.000000', 'temperatura', 354.0000, 'ºC'),
	(183107, 121, '2014-02-01 00:59:02.000000', 'temperatura', 60.0000, 'ºC'),
	(183108, 121, '2014-02-01 00:59:03.000000', 'temperatura', 438.0000, 'ºC'),
	(183109, 121, '2014-02-01 00:59:04.000000', 'temperatura', 810.0000, 'ºC'),
	(183110, 121, '2014-02-01 00:59:05.000000', 'temperatura', 336.0000, 'ºC'),
	(183111, 121, '2014-02-01 00:59:06.000000', 'temperatura', 450.0000, 'ºC'),
	(183112, 121, '2014-02-01 00:59:07.000000', 'temperatura', 44.0000, 'ºC'),
	(183113, 121, '2014-02-01 00:59:08.000000', 'temperatura', 69.0000, 'ºC'),
	(183114, 121, '2014-02-01 00:59:09.000000', 'temperatura', 215.0000, 'ºC'),
	(183115, 121, '2014-02-01 00:59:10.000000', 'temperatura', 867.0000, 'ºC'),
	(183116, 121, '2014-02-01 00:59:11.000000', 'temperatura', 90.0000, 'ºC'),
	(183117, 121, '2014-02-01 00:59:12.000000', 'temperatura', 251.0000, 'ºC'),
	(183118, 121, '2014-02-01 00:59:13.000000', 'temperatura', 983.0000, 'ºC'),
	(183119, 121, '2014-02-01 00:59:14.000000', 'temperatura', 565.0000, 'ºC'),
	(183120, 121, '2014-02-01 00:59:15.000000', 'temperatura', 1077.0000, 'ºC'),
	(183121, 121, '2014-02-01 00:59:16.000000', 'temperatura', 92.0000, 'ºC'),
	(183122, 121, '2014-02-01 00:59:17.000000', 'temperatura', 827.0000, 'ºC'),
	(183123, 121, '2014-02-01 00:59:18.000000', 'temperatura', 259.0000, 'ºC'),
	(183124, 121, '2014-02-01 00:59:19.000000', 'temperatura', 15.0000, 'ºC'),
	(183125, 121, '2014-02-01 00:59:20.000000', 'temperatura', 500.0000, 'ºC'),
	(183126, 121, '2014-02-01 00:59:21.000000', 'temperatura', 56.0000, 'ºC'),
	(183127, 121, '2014-02-01 00:59:22.000000', 'temperatura', 1179.0000, 'ºC'),
	(183128, 121, '2014-02-01 00:59:23.000000', 'temperatura', 929.0000, 'ºC'),
	(183129, 121, '2014-02-01 00:59:24.000000', 'temperatura', 1106.0000, 'ºC'),
	(183130, 121, '2014-02-01 00:59:25.000000', 'temperatura', 343.0000, 'ºC'),
	(183131, 121, '2014-02-01 00:59:26.000000', 'temperatura', 800.0000, 'ºC'),
	(183132, 121, '2014-02-01 00:59:27.000000', 'temperatura', 569.0000, 'ºC'),
	(183133, 121, '2014-02-01 00:59:28.000000', 'temperatura', 447.0000, 'ºC'),
	(183134, 121, '2014-02-01 00:59:29.000000', 'temperatura', 529.0000, 'ºC'),
	(183135, 121, '2014-02-01 00:59:30.000000', 'temperatura', 104.0000, 'ºC'),
	(183136, 121, '2014-02-01 00:59:31.000000', 'temperatura', 133.0000, 'ºC'),
	(183137, 121, '2014-02-01 00:59:32.000000', 'temperatura', 352.0000, 'ºC'),
	(183138, 121, '2014-02-01 00:59:33.000000', 'temperatura', 164.0000, 'ºC'),
	(183139, 121, '2014-02-01 00:59:34.000000', 'temperatura', 964.0000, 'ºC'),
	(183140, 121, '2014-02-01 00:59:35.000000', 'temperatura', 730.0000, 'ºC'),
	(183141, 121, '2014-02-01 00:59:36.000000', 'temperatura', 759.0000, 'ºC'),
	(183142, 121, '2014-02-01 00:59:37.000000', 'temperatura', 404.0000, 'ºC'),
	(183143, 121, '2014-02-01 00:59:38.000000', 'temperatura', 944.0000, 'ºC'),
	(183144, 121, '2014-02-01 00:59:39.000000', 'temperatura', 1106.0000, 'ºC'),
	(183145, 121, '2014-02-01 00:59:40.000000', 'temperatura', 301.0000, 'ºC'),
	(183146, 121, '2014-02-01 00:59:41.000000', 'temperatura', 587.0000, 'ºC'),
	(183147, 121, '2014-02-01 00:59:42.000000', 'temperatura', 831.0000, 'ºC'),
	(183148, 121, '2014-02-01 00:59:43.000000', 'temperatura', 1196.0000, 'ºC'),
	(183149, 121, '2014-02-01 00:59:44.000000', 'temperatura', 1089.0000, 'ºC'),
	(183150, 121, '2014-02-01 00:59:45.000000', 'temperatura', 655.0000, 'ºC'),
	(183151, 121, '2014-02-01 00:59:46.000000', 'temperatura', 8.0000, 'ºC'),
	(183152, 121, '2014-02-01 00:59:47.000000', 'temperatura', 478.0000, 'ºC'),
	(183153, 121, '2014-02-01 00:59:48.000000', 'temperatura', 1167.0000, 'ºC'),
	(183154, 121, '2014-02-01 00:59:49.000000', 'temperatura', 801.0000, 'ºC'),
	(183155, 121, '2014-02-01 00:59:50.000000', 'temperatura', 505.0000, 'ºC'),
	(183156, 121, '2014-02-01 00:59:51.000000', 'temperatura', 121.0000, 'ºC'),
	(183157, 121, '2014-02-01 00:59:52.000000', 'temperatura', 292.0000, 'ºC'),
	(183158, 121, '2014-02-01 00:59:53.000000', 'temperatura', 1098.0000, 'ºC'),
	(183159, 121, '2014-02-01 00:59:54.000000', 'temperatura', 1014.0000, 'ºC'),
	(183160, 121, '2014-02-01 00:59:55.000000', 'temperatura', 578.0000, 'ºC'),
	(183161, 121, '2014-02-01 00:59:56.000000', 'temperatura', 1047.0000, 'ºC'),
	(183162, 121, '2014-02-01 00:59:57.000000', 'temperatura', 1101.0000, 'ºC'),
	(183163, 121, '2014-02-01 00:59:58.000000', 'temperatura', 1167.0000, 'ºC'),
	(183164, 121, '2014-02-01 00:59:59.000000', 'temperatura', 129.0000, 'ºC'),
	(183165, 121, '2014-02-01 01:00:00.000000', 'temperatura', 747.0000, 'ºC'),
	(183166, 121, '2014-02-01 01:00:01.000000', 'temperatura', 947.0000, 'ºC'),
	(183167, 121, '2014-02-01 01:00:02.000000', 'temperatura', 94.0000, 'ºC'),
	(183168, 121, '2014-02-01 01:00:03.000000', 'temperatura', 28.0000, 'ºC'),
	(183169, 121, '2014-02-01 01:00:04.000000', 'temperatura', 1062.0000, 'ºC'),
	(183170, 121, '2014-02-01 01:00:05.000000', 'temperatura', 423.0000, 'ºC'),
	(183171, 121, '2014-02-01 01:00:06.000000', 'temperatura', 132.0000, 'ºC'),
	(183172, 121, '2014-02-01 01:00:07.000000', 'temperatura', 592.0000, 'ºC'),
	(183173, 121, '2014-02-01 01:00:08.000000', 'temperatura', 165.0000, 'ºC'),
	(183174, 121, '2014-02-01 01:00:09.000000', 'temperatura', 250.0000, 'ºC'),
	(183175, 121, '2014-02-01 01:00:10.000000', 'temperatura', 756.0000, 'ºC'),
	(183176, 121, '2014-02-01 01:00:11.000000', 'temperatura', 632.0000, 'ºC'),
	(183177, 121, '2014-02-01 01:00:12.000000', 'temperatura', 889.0000, 'ºC'),
	(183178, 121, '2014-02-01 01:00:13.000000', 'temperatura', 150.0000, 'ºC'),
	(183179, 121, '2014-02-01 01:00:14.000000', 'temperatura', 486.0000, 'ºC'),
	(183180, 121, '2014-02-01 01:00:15.000000', 'temperatura', 779.0000, 'ºC'),
	(183181, 121, '2014-02-01 01:00:16.000000', 'temperatura', 39.0000, 'ºC'),
	(183182, 121, '2014-02-01 01:00:17.000000', 'temperatura', 259.0000, 'ºC'),
	(183183, 121, '2014-02-01 01:00:18.000000', 'temperatura', 1178.0000, 'ºC'),
	(183184, 121, '2014-02-01 01:00:19.000000', 'temperatura', 311.0000, 'ºC'),
	(183185, 121, '2014-02-01 01:00:20.000000', 'temperatura', 423.0000, 'ºC'),
	(183186, 121, '2014-02-01 01:00:21.000000', 'temperatura', 1183.0000, 'ºC'),
	(183187, 121, '2014-02-01 01:00:22.000000', 'temperatura', 1044.0000, 'ºC'),
	(183188, 121, '2014-02-01 01:00:23.000000', 'temperatura', 473.0000, 'ºC'),
	(183189, 121, '2014-02-01 01:00:24.000000', 'temperatura', 434.0000, 'ºC'),
	(183190, 121, '2014-02-01 01:00:25.000000', 'temperatura', 752.0000, 'ºC'),
	(183191, 121, '2014-02-01 01:00:26.000000', 'temperatura', 57.0000, 'ºC'),
	(183192, 121, '2014-02-01 01:00:27.000000', 'temperatura', 429.0000, 'ºC'),
	(183193, 121, '2014-02-01 01:00:28.000000', 'temperatura', 774.0000, 'ºC'),
	(183194, 121, '2014-02-01 01:00:29.000000', 'temperatura', 184.0000, 'ºC'),
	(183195, 121, '2014-02-01 01:00:30.000000', 'temperatura', 998.0000, 'ºC'),
	(183196, 121, '2014-02-01 01:00:31.000000', 'temperatura', 838.0000, 'ºC'),
	(183197, 121, '2014-02-01 01:00:32.000000', 'temperatura', 1198.0000, 'ºC'),
	(183198, 121, '2014-02-01 01:00:33.000000', 'temperatura', 1074.0000, 'ºC'),
	(183199, 121, '2014-02-01 01:00:34.000000', 'temperatura', 579.0000, 'ºC'),
	(183200, 121, '2014-02-01 01:00:35.000000', 'temperatura', 874.0000, 'ºC'),
	(183201, 121, '2014-02-01 01:00:36.000000', 'temperatura', 232.0000, 'ºC'),
	(183202, 121, '2014-02-01 01:00:37.000000', 'temperatura', 939.0000, 'ºC'),
	(183203, 121, '2014-02-01 01:00:38.000000', 'temperatura', 397.0000, 'ºC'),
	(183204, 121, '2014-02-01 01:00:39.000000', 'temperatura', 372.0000, 'ºC'),
	(183205, 121, '2014-02-01 01:00:40.000000', 'temperatura', 668.0000, 'ºC'),
	(183206, 121, '2014-02-01 01:00:41.000000', 'temperatura', 1024.0000, 'ºC'),
	(183207, 121, '2014-02-01 01:00:42.000000', 'temperatura', 719.0000, 'ºC'),
	(183208, 121, '2014-02-01 01:00:43.000000', 'temperatura', 522.0000, 'ºC'),
	(183209, 121, '2014-02-01 01:00:44.000000', 'temperatura', 451.0000, 'ºC'),
	(183210, 121, '2014-02-01 01:00:45.000000', 'temperatura', 693.0000, 'ºC'),
	(183211, 121, '2014-02-01 01:00:46.000000', 'temperatura', 913.0000, 'ºC'),
	(183212, 121, '2014-02-01 01:00:47.000000', 'temperatura', 83.0000, 'ºC'),
	(183213, 121, '2014-02-01 01:00:48.000000', 'temperatura', 80.0000, 'ºC'),
	(183214, 121, '2014-02-01 01:00:49.000000', 'temperatura', 149.0000, 'ºC'),
	(183215, 121, '2014-02-01 01:00:50.000000', 'temperatura', 506.0000, 'ºC'),
	(183216, 121, '2014-02-01 01:00:51.000000', 'temperatura', 885.0000, 'ºC'),
	(183217, 121, '2014-02-01 01:00:52.000000', 'temperatura', 508.0000, 'ºC'),
	(183218, 121, '2014-02-01 01:00:53.000000', 'temperatura', 1085.0000, 'ºC'),
	(183219, 121, '2014-02-01 01:00:54.000000', 'temperatura', 301.0000, 'ºC'),
	(183220, 121, '2014-02-01 01:00:55.000000', 'temperatura', 652.0000, 'ºC'),
	(183221, 121, '2014-02-01 01:00:56.000000', 'temperatura', 1155.0000, 'ºC'),
	(183222, 121, '2014-02-01 01:00:57.000000', 'temperatura', 222.0000, 'ºC'),
	(183223, 121, '2014-02-01 01:00:58.000000', 'temperatura', 45.0000, 'ºC'),
	(183224, 121, '2014-02-01 01:00:59.000000', 'temperatura', 758.0000, 'ºC'),
	(183225, 121, '2014-02-01 01:01:00.000000', 'temperatura', 54.0000, 'ºC'),
	(183226, 121, '2014-02-01 01:01:01.000000', 'temperatura', 400.0000, 'ºC'),
	(183227, 121, '2014-02-01 01:01:02.000000', 'temperatura', 636.0000, 'ºC'),
	(183228, 121, '2014-02-01 01:01:03.000000', 'temperatura', 783.0000, 'ºC'),
	(183229, 121, '2014-02-01 01:01:04.000000', 'temperatura', 806.0000, 'ºC'),
	(183230, 121, '2014-02-01 01:01:05.000000', 'temperatura', 482.0000, 'ºC'),
	(183231, 121, '2014-02-01 01:01:06.000000', 'temperatura', 1191.0000, 'ºC'),
	(183232, 121, '2014-02-01 01:01:07.000000', 'temperatura', 911.0000, 'ºC'),
	(183233, 121, '2014-02-01 01:01:08.000000', 'temperatura', 981.0000, 'ºC'),
	(183234, 121, '2014-02-01 01:01:09.000000', 'temperatura', 972.0000, 'ºC'),
	(183235, 121, '2014-02-01 01:01:10.000000', 'temperatura', 718.0000, 'ºC'),
	(183236, 121, '2014-02-01 01:01:11.000000', 'temperatura', 676.0000, 'ºC'),
	(183237, 121, '2014-02-01 01:01:12.000000', 'temperatura', 25.0000, 'ºC'),
	(183238, 121, '2014-02-01 01:01:13.000000', 'temperatura', 500.0000, 'ºC'),
	(183239, 121, '2014-02-01 01:01:14.000000', 'temperatura', 24.0000, 'ºC'),
	(183240, 121, '2014-02-01 01:01:15.000000', 'temperatura', 1019.0000, 'ºC'),
	(183241, 121, '2014-02-01 01:01:16.000000', 'temperatura', 226.0000, 'ºC'),
	(183242, 121, '2014-02-01 01:01:17.000000', 'temperatura', 474.0000, 'ºC'),
	(183243, 121, '2014-02-01 01:01:18.000000', 'temperatura', 490.0000, 'ºC'),
	(183244, 121, '2014-02-01 01:01:19.000000', 'temperatura', 1027.0000, 'ºC'),
	(183245, 121, '2014-02-01 01:01:20.000000', 'temperatura', 69.0000, 'ºC'),
	(183246, 121, '2014-02-01 01:01:21.000000', 'temperatura', 864.0000, 'ºC'),
	(183247, 121, '2014-02-01 01:01:22.000000', 'temperatura', 513.0000, 'ºC'),
	(183248, 121, '2014-02-01 01:01:23.000000', 'temperatura', 1171.0000, 'ºC'),
	(183249, 121, '2014-02-01 01:01:24.000000', 'temperatura', 720.0000, 'ºC'),
	(183250, 121, '2014-02-01 01:01:25.000000', 'temperatura', 86.0000, 'ºC'),
	(183251, 121, '2014-02-01 01:01:26.000000', 'temperatura', 670.0000, 'ºC'),
	(183252, 121, '2014-02-01 01:01:27.000000', 'temperatura', 693.0000, 'ºC'),
	(183253, 121, '2014-02-01 01:01:28.000000', 'temperatura', 257.0000, 'ºC'),
	(183254, 121, '2014-02-01 01:01:29.000000', 'temperatura', 407.0000, 'ºC'),
	(183255, 121, '2014-02-01 01:01:30.000000', 'temperatura', 62.0000, 'ºC'),
	(183256, 121, '2014-02-01 01:01:31.000000', 'temperatura', 291.0000, 'ºC'),
	(183257, 121, '2014-02-01 01:01:32.000000', 'temperatura', 69.0000, 'ºC'),
	(183258, 121, '2014-02-01 01:01:33.000000', 'temperatura', 671.0000, 'ºC'),
	(183259, 121, '2014-02-01 01:01:34.000000', 'temperatura', 751.0000, 'ºC'),
	(183260, 121, '2014-02-01 01:01:35.000000', 'temperatura', 541.0000, 'ºC'),
	(183261, 121, '2014-02-01 01:01:36.000000', 'temperatura', 454.0000, 'ºC'),
	(183262, 121, '2014-02-01 01:01:37.000000', 'temperatura', 646.0000, 'ºC'),
	(183263, 121, '2014-02-01 01:01:38.000000', 'temperatura', 669.0000, 'ºC'),
	(183264, 121, '2014-02-01 01:01:39.000000', 'temperatura', 207.0000, 'ºC'),
	(183265, 121, '2014-02-01 01:01:40.000000', 'temperatura', 227.0000, 'ºC'),
	(183266, 121, '2014-02-01 01:01:41.000000', 'temperatura', 515.0000, 'ºC'),
	(183267, 121, '2014-02-01 01:01:42.000000', 'temperatura', 694.0000, 'ºC'),
	(183268, 121, '2014-02-01 01:01:43.000000', 'temperatura', 728.0000, 'ºC'),
	(183269, 121, '2014-02-01 01:01:44.000000', 'temperatura', 357.0000, 'ºC'),
	(183270, 121, '2014-02-01 01:01:45.000000', 'temperatura', 802.0000, 'ºC'),
	(183271, 121, '2014-02-01 01:01:46.000000', 'temperatura', 541.0000, 'ºC'),
	(183272, 121, '2014-02-01 01:01:47.000000', 'temperatura', 298.0000, 'ºC'),
	(183273, 121, '2014-02-01 01:01:48.000000', 'temperatura', 1067.0000, 'ºC'),
	(183274, 121, '2014-02-01 01:01:49.000000', 'temperatura', 842.0000, 'ºC'),
	(183275, 121, '2014-02-01 01:01:50.000000', 'temperatura', 1011.0000, 'ºC'),
	(183276, 121, '2014-02-01 01:01:51.000000', 'temperatura', 129.0000, 'ºC'),
	(183277, 121, '2014-02-01 01:01:52.000000', 'temperatura', 11.0000, 'ºC'),
	(183278, 121, '2014-02-01 01:01:53.000000', 'temperatura', 869.0000, 'ºC'),
	(183279, 121, '2014-02-01 01:01:54.000000', 'temperatura', 711.0000, 'ºC'),
	(183280, 121, '2014-02-01 01:01:55.000000', 'temperatura', 948.0000, 'ºC'),
	(183281, 121, '2014-02-01 01:01:56.000000', 'temperatura', 208.0000, 'ºC'),
	(183282, 121, '2014-02-01 01:01:57.000000', 'temperatura', 598.0000, 'ºC'),
	(183283, 121, '2014-02-01 01:01:58.000000', 'temperatura', 1168.0000, 'ºC'),
	(183284, 121, '2014-02-01 01:01:59.000000', 'temperatura', 443.0000, 'ºC'),
	(183285, 121, '2014-02-01 01:02:00.000000', 'temperatura', 1114.0000, 'ºC'),
	(183286, 121, '2014-02-01 01:02:01.000000', 'temperatura', 641.0000, 'ºC'),
	(183287, 121, '2014-02-01 01:02:02.000000', 'temperatura', 1064.0000, 'ºC'),
	(183288, 121, '2014-02-01 01:02:03.000000', 'temperatura', 997.0000, 'ºC'),
	(183289, 121, '2014-02-01 01:02:04.000000', 'temperatura', 592.0000, 'ºC'),
	(183290, 121, '2014-02-01 01:02:05.000000', 'temperatura', 1172.0000, 'ºC'),
	(183291, 121, '2014-02-01 01:02:06.000000', 'temperatura', 485.0000, 'ºC'),
	(183292, 121, '2014-02-01 01:02:07.000000', 'temperatura', 108.0000, 'ºC'),
	(183293, 121, '2014-02-01 01:02:08.000000', 'temperatura', 287.0000, 'ºC'),
	(183294, 121, '2014-02-01 01:02:09.000000', 'temperatura', 1111.0000, 'ºC'),
	(183295, 121, '2014-02-01 01:02:10.000000', 'temperatura', 1093.0000, 'ºC'),
	(183296, 121, '2014-02-01 01:02:11.000000', 'temperatura', 934.0000, 'ºC'),
	(183297, 121, '2014-02-01 01:02:12.000000', 'temperatura', 191.0000, 'ºC'),
	(183298, 121, '2014-02-01 01:02:13.000000', 'temperatura', 552.0000, 'ºC'),
	(183299, 121, '2014-02-01 01:02:14.000000', 'temperatura', 987.0000, 'ºC'),
	(183300, 121, '2014-02-01 01:02:15.000000', 'temperatura', 879.0000, 'ºC'),
	(183301, 121, '2014-02-01 01:02:16.000000', 'temperatura', 236.0000, 'ºC'),
	(183302, 121, '2014-02-01 01:02:17.000000', 'temperatura', 944.0000, 'ºC'),
	(183303, 121, '2014-02-01 01:02:18.000000', 'temperatura', 411.0000, 'ºC'),
	(183304, 121, '2014-02-01 01:02:19.000000', 'temperatura', 425.0000, 'ºC'),
	(183305, 121, '2014-02-01 01:02:20.000000', 'temperatura', 894.0000, 'ºC'),
	(183306, 121, '2014-02-01 01:02:21.000000', 'temperatura', 794.0000, 'ºC'),
	(183307, 121, '2014-02-01 01:02:22.000000', 'temperatura', 88.0000, 'ºC'),
	(183308, 121, '2014-02-01 01:02:23.000000', 'temperatura', 457.0000, 'ºC'),
	(183309, 121, '2014-02-01 01:02:24.000000', 'temperatura', 822.0000, 'ºC'),
	(183310, 121, '2014-02-01 01:02:25.000000', 'temperatura', 340.0000, 'ºC'),
	(183311, 121, '2014-02-01 01:02:26.000000', 'temperatura', 435.0000, 'ºC'),
	(183312, 121, '2014-02-01 01:02:27.000000', 'temperatura', 1157.0000, 'ºC'),
	(183313, 121, '2014-02-01 01:02:28.000000', 'temperatura', 878.0000, 'ºC'),
	(183314, 121, '2014-02-01 01:02:29.000000', 'temperatura', 921.0000, 'ºC'),
	(183315, 121, '2014-02-01 01:02:30.000000', 'temperatura', 771.0000, 'ºC'),
	(183316, 121, '2014-02-01 01:02:31.000000', 'temperatura', 1091.0000, 'ºC'),
	(183317, 121, '2014-02-01 01:02:32.000000', 'temperatura', 743.0000, 'ºC'),
	(183318, 121, '2014-02-01 01:02:33.000000', 'temperatura', 443.0000, 'ºC'),
	(183319, 121, '2014-02-01 01:02:34.000000', 'temperatura', 1186.0000, 'ºC'),
	(183320, 121, '2014-02-01 01:02:35.000000', 'temperatura', 1002.0000, 'ºC'),
	(183321, 121, '2014-02-01 01:02:36.000000', 'temperatura', 252.0000, 'ºC'),
	(183322, 121, '2014-02-01 01:02:37.000000', 'temperatura', 656.0000, 'ºC'),
	(183323, 121, '2014-02-01 01:02:38.000000', 'temperatura', 123.0000, 'ºC'),
	(183324, 121, '2014-02-01 01:02:39.000000', 'temperatura', 1050.0000, 'ºC'),
	(183325, 121, '2014-02-01 01:02:40.000000', 'temperatura', 80.0000, 'ºC'),
	(183326, 121, '2014-02-01 01:02:41.000000', 'temperatura', 850.0000, 'ºC'),
	(183327, 121, '2014-02-01 01:02:42.000000', 'temperatura', 412.0000, 'ºC'),
	(183328, 121, '2014-02-01 01:02:43.000000', 'temperatura', 710.0000, 'ºC'),
	(183329, 121, '2014-02-01 01:02:44.000000', 'temperatura', 1115.0000, 'ºC'),
	(183330, 121, '2014-02-01 01:02:45.000000', 'temperatura', 1044.0000, 'ºC'),
	(183331, 121, '2014-02-01 01:02:46.000000', 'temperatura', 678.0000, 'ºC'),
	(183332, 121, '2014-02-01 01:02:47.000000', 'temperatura', 258.0000, 'ºC'),
	(183333, 121, '2014-02-01 01:02:48.000000', 'temperatura', 456.0000, 'ºC'),
	(183334, 121, '2014-02-01 01:02:49.000000', 'temperatura', 307.0000, 'ºC'),
	(183335, 121, '2014-02-01 01:02:50.000000', 'temperatura', 168.0000, 'ºC'),
	(183336, 121, '2014-02-01 01:02:51.000000', 'temperatura', 1117.0000, 'ºC'),
	(183337, 121, '2014-02-01 01:02:52.000000', 'temperatura', 283.0000, 'ºC'),
	(183338, 121, '2014-02-01 01:02:53.000000', 'temperatura', 463.0000, 'ºC'),
	(183339, 121, '2014-02-01 01:02:54.000000', 'temperatura', 268.0000, 'ºC'),
	(183340, 121, '2014-02-01 01:02:55.000000', 'temperatura', 1152.0000, 'ºC'),
	(183341, 121, '2014-02-01 01:02:56.000000', 'temperatura', 155.0000, 'ºC'),
	(183342, 121, '2014-02-01 01:02:57.000000', 'temperatura', 920.0000, 'ºC'),
	(183343, 121, '2014-02-01 01:02:58.000000', 'temperatura', 538.0000, 'ºC'),
	(183344, 121, '2014-02-01 01:02:59.000000', 'temperatura', 1127.0000, 'ºC'),
	(183345, 121, '2014-02-01 01:03:00.000000', 'temperatura', 421.0000, 'ºC'),
	(183346, 121, '2014-02-01 01:03:01.000000', 'temperatura', 1128.0000, 'ºC'),
	(183347, 121, '2014-02-01 01:03:02.000000', 'temperatura', 774.0000, 'ºC'),
	(183348, 121, '2014-02-01 01:03:03.000000', 'temperatura', 489.0000, 'ºC'),
	(183349, 121, '2014-02-01 01:03:04.000000', 'temperatura', 124.0000, 'ºC'),
	(183350, 121, '2014-02-01 01:03:05.000000', 'temperatura', 351.0000, 'ºC'),
	(183351, 121, '2014-02-01 01:03:06.000000', 'temperatura', 185.0000, 'ºC'),
	(183352, 121, '2014-02-01 01:03:07.000000', 'temperatura', 1073.0000, 'ºC'),
	(183353, 121, '2014-02-01 01:03:08.000000', 'temperatura', 10.0000, 'ºC'),
	(183354, 121, '2014-02-01 01:03:09.000000', 'temperatura', 433.0000, 'ºC'),
	(183355, 121, '2014-02-01 01:03:10.000000', 'temperatura', 936.0000, 'ºC'),
	(183356, 121, '2014-02-01 01:03:11.000000', 'temperatura', 979.0000, 'ºC'),
	(183357, 121, '2014-02-01 01:03:12.000000', 'temperatura', 887.0000, 'ºC'),
	(183358, 121, '2014-02-01 01:03:13.000000', 'temperatura', 298.0000, 'ºC'),
	(183359, 121, '2014-02-01 01:03:14.000000', 'temperatura', 30.0000, 'ºC'),
	(183360, 121, '2014-02-01 01:03:15.000000', 'temperatura', 457.0000, 'ºC'),
	(183361, 121, '2014-02-01 01:03:16.000000', 'temperatura', 994.0000, 'ºC'),
	(183362, 121, '2014-02-01 01:03:17.000000', 'temperatura', 0.0000, 'ºC'),
	(183363, 121, '2014-02-01 01:03:18.000000', 'temperatura', 620.0000, 'ºC'),
	(183364, 121, '2014-02-01 01:03:19.000000', 'temperatura', 701.0000, 'ºC'),
	(183365, 121, '2014-02-01 01:03:20.000000', 'temperatura', 447.0000, 'ºC'),
	(183366, 121, '2014-02-01 01:03:21.000000', 'temperatura', 130.0000, 'ºC'),
	(183367, 121, '2014-02-01 01:03:22.000000', 'temperatura', 509.0000, 'ºC'),
	(183368, 121, '2014-02-01 01:03:23.000000', 'temperatura', 954.0000, 'ºC'),
	(183369, 121, '2014-02-01 01:03:24.000000', 'temperatura', 846.0000, 'ºC'),
	(183370, 121, '2014-02-01 01:03:25.000000', 'temperatura', 166.0000, 'ºC'),
	(183371, 121, '2014-02-01 01:03:26.000000', 'temperatura', 694.0000, 'ºC'),
	(183372, 121, '2014-02-01 01:03:27.000000', 'temperatura', 570.0000, 'ºC'),
	(183373, 121, '2014-02-01 01:03:28.000000', 'temperatura', 772.0000, 'ºC'),
	(183374, 121, '2014-02-01 01:03:29.000000', 'temperatura', 949.0000, 'ºC'),
	(183375, 121, '2014-02-01 01:03:30.000000', 'temperatura', 30.0000, 'ºC'),
	(183376, 121, '2014-02-01 01:03:31.000000', 'temperatura', 903.0000, 'ºC'),
	(183377, 121, '2014-02-01 01:03:32.000000', 'temperatura', 826.0000, 'ºC'),
	(183378, 121, '2014-02-01 01:03:33.000000', 'temperatura', 222.0000, 'ºC'),
	(183379, 121, '2014-02-01 01:03:34.000000', 'temperatura', 1031.0000, 'ºC'),
	(183380, 121, '2014-02-01 01:03:35.000000', 'temperatura', 890.0000, 'ºC'),
	(183381, 121, '2014-02-01 01:03:36.000000', 'temperatura', 159.0000, 'ºC'),
	(183382, 121, '2014-02-01 01:03:37.000000', 'temperatura', 523.0000, 'ºC'),
	(183383, 121, '2014-02-01 01:03:38.000000', 'temperatura', 940.0000, 'ºC'),
	(183384, 121, '2014-02-01 01:03:39.000000', 'temperatura', 733.0000, 'ºC'),
	(183385, 121, '2014-02-01 01:03:40.000000', 'temperatura', 845.0000, 'ºC'),
	(183386, 121, '2014-02-01 01:03:41.000000', 'temperatura', 826.0000, 'ºC'),
	(183387, 121, '2014-02-01 01:03:42.000000', 'temperatura', 397.0000, 'ºC'),
	(183388, 121, '2014-02-01 01:03:43.000000', 'temperatura', 705.0000, 'ºC'),
	(183389, 121, '2014-02-01 01:03:44.000000', 'temperatura', 1135.0000, 'ºC'),
	(183390, 121, '2014-02-01 01:03:45.000000', 'temperatura', 1159.0000, 'ºC'),
	(183391, 121, '2014-02-01 01:03:46.000000', 'temperatura', 1192.0000, 'ºC'),
	(183392, 121, '2014-02-01 01:03:47.000000', 'temperatura', 81.0000, 'ºC'),
	(183393, 121, '2014-02-01 01:03:48.000000', 'temperatura', 433.0000, 'ºC'),
	(183394, 121, '2014-02-01 01:03:49.000000', 'temperatura', 721.0000, 'ºC'),
	(183395, 121, '2014-02-01 01:03:50.000000', 'temperatura', 1108.0000, 'ºC'),
	(183396, 121, '2014-02-01 01:03:51.000000', 'temperatura', 975.0000, 'ºC'),
	(183397, 121, '2014-02-01 01:03:52.000000', 'temperatura', 354.0000, 'ºC'),
	(183398, 121, '2014-02-01 01:03:53.000000', 'temperatura', 45.0000, 'ºC'),
	(183399, 121, '2014-02-01 01:03:54.000000', 'temperatura', 365.0000, 'ºC'),
	(183400, 121, '2014-02-01 01:03:55.000000', 'temperatura', 490.0000, 'ºC'),
	(183401, 121, '2014-02-01 01:03:56.000000', 'temperatura', 156.0000, 'ºC'),
	(183402, 121, '2014-02-01 01:03:57.000000', 'temperatura', 509.0000, 'ºC'),
	(183403, 121, '2014-02-01 01:03:58.000000', 'temperatura', 877.0000, 'ºC'),
	(183404, 121, '2014-02-01 01:03:59.000000', 'temperatura', 458.0000, 'ºC'),
	(183405, 121, '2014-02-01 01:04:00.000000', 'temperatura', 862.0000, 'ºC'),
	(183406, 121, '2014-02-01 01:04:01.000000', 'temperatura', 536.0000, 'ºC'),
	(183407, 121, '2014-02-01 01:04:02.000000', 'temperatura', 93.0000, 'ºC'),
	(183408, 121, '2014-02-01 01:04:03.000000', 'temperatura', 57.0000, 'ºC'),
	(183409, 121, '2014-02-01 01:04:04.000000', 'temperatura', 9.0000, 'ºC'),
	(183410, 121, '2014-02-01 01:04:05.000000', 'temperatura', 1073.0000, 'ºC'),
	(183411, 121, '2014-02-01 01:04:06.000000', 'temperatura', 538.0000, 'ºC'),
	(183412, 121, '2014-02-01 01:04:07.000000', 'temperatura', 671.0000, 'ºC'),
	(183413, 121, '2014-02-01 01:04:08.000000', 'temperatura', 542.0000, 'ºC'),
	(183414, 121, '2014-02-01 01:04:09.000000', 'temperatura', 698.0000, 'ºC'),
	(183415, 121, '2014-02-01 01:04:10.000000', 'temperatura', 665.0000, 'ºC'),
	(183416, 121, '2014-02-01 01:04:11.000000', 'temperatura', 32.0000, 'ºC'),
	(183417, 121, '2014-02-01 01:04:12.000000', 'temperatura', 565.0000, 'ºC'),
	(183418, 121, '2014-02-01 01:04:13.000000', 'temperatura', 328.0000, 'ºC'),
	(183419, 121, '2014-02-01 01:04:14.000000', 'temperatura', 1146.0000, 'ºC'),
	(183420, 121, '2014-02-01 01:04:15.000000', 'temperatura', 1146.0000, 'ºC'),
	(183421, 121, '2014-02-01 01:04:16.000000', 'temperatura', 1095.0000, 'ºC'),
	(183422, 121, '2014-02-01 01:04:17.000000', 'temperatura', 836.0000, 'ºC'),
	(183423, 121, '2014-02-01 01:04:18.000000', 'temperatura', 896.0000, 'ºC'),
	(183424, 121, '2014-02-01 01:04:19.000000', 'temperatura', 773.0000, 'ºC'),
	(183425, 121, '2014-02-01 01:04:20.000000', 'temperatura', 1175.0000, 'ºC'),
	(183426, 121, '2014-02-01 01:04:21.000000', 'temperatura', 1159.0000, 'ºC'),
	(183427, 121, '2014-02-01 01:04:22.000000', 'temperatura', 1069.0000, 'ºC'),
	(183428, 121, '2014-02-01 01:04:23.000000', 'temperatura', 668.0000, 'ºC'),
	(183429, 121, '2014-02-01 01:04:24.000000', 'temperatura', 135.0000, 'ºC'),
	(183430, 121, '2014-02-01 01:04:25.000000', 'temperatura', 1073.0000, 'ºC'),
	(183431, 121, '2014-02-01 01:04:26.000000', 'temperatura', 159.0000, 'ºC'),
	(183432, 121, '2014-02-01 01:04:27.000000', 'temperatura', 1177.0000, 'ºC'),
	(183433, 121, '2014-02-01 01:04:28.000000', 'temperatura', 607.0000, 'ºC'),
	(183434, 121, '2014-02-01 01:04:29.000000', 'temperatura', 705.0000, 'ºC'),
	(183435, 121, '2014-02-01 01:04:30.000000', 'temperatura', 506.0000, 'ºC'),
	(183436, 121, '2014-02-01 01:04:31.000000', 'temperatura', 413.0000, 'ºC'),
	(183437, 121, '2014-02-01 01:04:32.000000', 'temperatura', 547.0000, 'ºC'),
	(183438, 121, '2014-02-01 01:04:33.000000', 'temperatura', 296.0000, 'ºC'),
	(183439, 121, '2014-02-01 01:04:34.000000', 'temperatura', 1041.0000, 'ºC'),
	(183440, 121, '2014-02-01 01:04:35.000000', 'temperatura', 716.0000, 'ºC'),
	(183441, 121, '2014-02-01 01:04:36.000000', 'temperatura', 459.0000, 'ºC'),
	(183442, 121, '2014-02-01 01:04:37.000000', 'temperatura', 147.0000, 'ºC'),
	(183443, 121, '2014-02-01 01:04:38.000000', 'temperatura', 557.0000, 'ºC'),
	(183444, 121, '2014-02-01 01:04:39.000000', 'temperatura', 1146.0000, 'ºC'),
	(183445, 121, '2014-02-01 01:04:40.000000', 'temperatura', 461.0000, 'ºC'),
	(183446, 121, '2014-02-01 01:04:41.000000', 'temperatura', 66.0000, 'ºC'),
	(183447, 121, '2014-02-01 01:04:42.000000', 'temperatura', 149.0000, 'ºC'),
	(183448, 121, '2014-02-01 01:04:43.000000', 'temperatura', 548.0000, 'ºC'),
	(183449, 121, '2014-02-01 01:04:44.000000', 'temperatura', 1092.0000, 'ºC'),
	(183450, 121, '2014-02-01 01:04:45.000000', 'temperatura', 219.0000, 'ºC'),
	(183451, 121, '2014-02-01 01:04:46.000000', 'temperatura', 216.0000, 'ºC'),
	(183452, 121, '2014-02-01 01:04:47.000000', 'temperatura', 427.0000, 'ºC'),
	(183453, 121, '2014-02-01 01:04:48.000000', 'temperatura', 284.0000, 'ºC'),
	(183454, 121, '2014-02-01 01:04:49.000000', 'temperatura', 141.0000, 'ºC'),
	(183455, 121, '2014-02-01 01:04:50.000000', 'temperatura', 1053.0000, 'ºC'),
	(183456, 121, '2014-02-01 01:04:51.000000', 'temperatura', 45.0000, 'ºC'),
	(183457, 121, '2014-02-01 01:04:52.000000', 'temperatura', 663.0000, 'ºC'),
	(183458, 121, '2014-02-01 01:04:53.000000', 'temperatura', 783.0000, 'ºC'),
	(183459, 121, '2014-02-01 01:04:54.000000', 'temperatura', 725.0000, 'ºC'),
	(183460, 121, '2014-02-01 01:04:55.000000', 'temperatura', 75.0000, 'ºC'),
	(183461, 121, '2014-02-01 01:04:56.000000', 'temperatura', 603.0000, 'ºC'),
	(183462, 121, '2014-02-01 01:04:57.000000', 'temperatura', 391.0000, 'ºC'),
	(183463, 121, '2014-02-01 01:04:58.000000', 'temperatura', 145.0000, 'ºC'),
	(183464, 121, '2014-02-01 01:04:59.000000', 'temperatura', 755.0000, 'ºC'),
	(183465, 121, '2014-02-01 01:05:00.000000', 'temperatura', 939.0000, 'ºC'),
	(183466, 121, '2014-02-01 01:05:01.000000', 'temperatura', 29.0000, 'ºC'),
	(183467, 121, '2014-02-01 01:05:02.000000', 'temperatura', 930.0000, 'ºC'),
	(183468, 121, '2014-02-01 01:05:03.000000', 'temperatura', 964.0000, 'ºC'),
	(183469, 121, '2014-02-01 01:05:04.000000', 'temperatura', 832.0000, 'ºC'),
	(183470, 121, '2014-02-01 01:05:05.000000', 'temperatura', 66.0000, 'ºC'),
	(183471, 121, '2014-02-01 01:05:06.000000', 'temperatura', 236.0000, 'ºC'),
	(183472, 121, '2014-02-01 01:05:07.000000', 'temperatura', 981.0000, 'ºC'),
	(183473, 121, '2014-02-01 01:05:08.000000', 'temperatura', 596.0000, 'ºC'),
	(183474, 121, '2014-02-01 01:05:09.000000', 'temperatura', 39.0000, 'ºC'),
	(183475, 121, '2014-02-01 01:05:10.000000', 'temperatura', 808.0000, 'ºC'),
	(183476, 121, '2014-02-01 01:05:11.000000', 'temperatura', 325.0000, 'ºC'),
	(183477, 121, '2014-02-01 01:05:12.000000', 'temperatura', 401.0000, 'ºC'),
	(183478, 121, '2014-02-01 01:05:13.000000', 'temperatura', 1029.0000, 'ºC'),
	(183479, 121, '2014-02-01 01:05:14.000000', 'temperatura', 342.0000, 'ºC'),
	(183480, 121, '2014-02-01 01:05:15.000000', 'temperatura', 1024.0000, 'ºC'),
	(183481, 121, '2014-02-01 01:05:16.000000', 'temperatura', 494.0000, 'ºC'),
	(183482, 121, '2014-02-01 01:05:17.000000', 'temperatura', 601.0000, 'ºC'),
	(183483, 121, '2014-02-01 01:05:18.000000', 'temperatura', 320.0000, 'ºC'),
	(183484, 121, '2014-02-01 01:05:19.000000', 'temperatura', 1000.0000, 'ºC'),
	(183485, 121, '2014-02-01 01:05:20.000000', 'temperatura', 441.0000, 'ºC'),
	(183486, 121, '2014-02-01 01:05:21.000000', 'temperatura', 406.0000, 'ºC'),
	(183487, 121, '2014-02-01 01:05:22.000000', 'temperatura', 707.0000, 'ºC'),
	(183488, 121, '2014-02-01 01:05:23.000000', 'temperatura', 1118.0000, 'ºC'),
	(183489, 121, '2014-02-01 01:05:24.000000', 'temperatura', 1068.0000, 'ºC'),
	(183490, 121, '2014-02-01 01:05:25.000000', 'temperatura', 786.0000, 'ºC'),
	(183491, 121, '2014-02-01 01:05:26.000000', 'temperatura', 726.0000, 'ºC'),
	(183492, 121, '2014-02-01 01:05:27.000000', 'temperatura', 72.0000, 'ºC'),
	(183493, 121, '2014-02-01 01:05:28.000000', 'temperatura', 584.0000, 'ºC'),
	(183494, 121, '2014-02-01 01:05:29.000000', 'temperatura', 305.0000, 'ºC'),
	(183495, 121, '2014-02-01 01:05:30.000000', 'temperatura', 974.0000, 'ºC'),
	(183496, 121, '2014-02-01 01:05:31.000000', 'temperatura', 353.0000, 'ºC'),
	(183497, 121, '2014-02-01 01:05:32.000000', 'temperatura', 46.0000, 'ºC'),
	(183498, 121, '2014-02-01 01:05:33.000000', 'temperatura', 372.0000, 'ºC'),
	(183499, 121, '2014-02-01 01:05:34.000000', 'temperatura', 520.0000, 'ºC'),
	(183500, 121, '2014-02-01 01:05:35.000000', 'temperatura', 287.0000, 'ºC'),
	(183501, 121, '2014-02-01 01:05:36.000000', 'temperatura', 1076.0000, 'ºC'),
	(183502, 121, '2014-02-01 01:05:37.000000', 'temperatura', 917.0000, 'ºC'),
	(183503, 121, '2014-02-01 01:05:38.000000', 'temperatura', 158.0000, 'ºC'),
	(183504, 121, '2014-02-01 01:05:39.000000', 'temperatura', 438.0000, 'ºC'),
	(183505, 121, '2014-02-01 01:05:40.000000', 'temperatura', 519.0000, 'ºC'),
	(183506, 121, '2014-02-01 01:05:41.000000', 'temperatura', 82.0000, 'ºC'),
	(183507, 121, '2014-02-01 01:05:42.000000', 'temperatura', 51.0000, 'ºC'),
	(183508, 121, '2014-02-01 01:05:43.000000', 'temperatura', 10.0000, 'ºC'),
	(183509, 121, '2014-02-01 01:05:44.000000', 'temperatura', 1099.0000, 'ºC'),
	(183510, 121, '2014-02-01 01:05:45.000000', 'temperatura', 666.0000, 'ºC'),
	(183511, 121, '2014-02-01 01:05:46.000000', 'temperatura', 31.0000, 'ºC'),
	(183512, 121, '2014-02-01 01:05:47.000000', 'temperatura', 558.0000, 'ºC'),
	(183513, 121, '2014-02-01 01:05:48.000000', 'temperatura', 299.0000, 'ºC'),
	(183514, 121, '2014-02-01 01:05:49.000000', 'temperatura', 1020.0000, 'ºC'),
	(183515, 121, '2014-02-01 01:05:50.000000', 'temperatura', 603.0000, 'ºC'),
	(183516, 121, '2014-02-01 01:05:51.000000', 'temperatura', 1157.0000, 'ºC'),
	(183517, 121, '2014-02-01 01:05:52.000000', 'temperatura', 374.0000, 'ºC'),
	(183518, 121, '2014-02-01 01:05:53.000000', 'temperatura', 802.0000, 'ºC'),
	(183519, 121, '2014-02-01 01:05:54.000000', 'temperatura', 489.0000, 'ºC'),
	(183520, 121, '2014-02-01 01:05:55.000000', 'temperatura', 39.0000, 'ºC'),
	(183521, 121, '2014-02-01 01:05:56.000000', 'temperatura', 1128.0000, 'ºC'),
	(183522, 121, '2014-02-01 01:05:57.000000', 'temperatura', 726.0000, 'ºC'),
	(183523, 121, '2014-02-01 01:05:58.000000', 'temperatura', 243.0000, 'ºC'),
	(183524, 121, '2014-02-01 01:05:59.000000', 'temperatura', 239.0000, 'ºC'),
	(183525, 121, '2014-02-01 01:06:00.000000', 'temperatura', 466.0000, 'ºC'),
	(183526, 121, '2014-02-01 01:06:01.000000', 'temperatura', 413.0000, 'ºC'),
	(183527, 121, '2014-02-01 01:06:02.000000', 'temperatura', 668.0000, 'ºC'),
	(183528, 121, '2014-02-01 01:06:03.000000', 'temperatura', 903.0000, 'ºC'),
	(183529, 121, '2014-02-01 01:06:04.000000', 'temperatura', 111.0000, 'ºC'),
	(183530, 121, '2014-02-01 01:06:05.000000', 'temperatura', 247.0000, 'ºC'),
	(183531, 121, '2014-02-01 01:06:06.000000', 'temperatura', 903.0000, 'ºC'),
	(183532, 121, '2014-02-01 01:06:07.000000', 'temperatura', 174.0000, 'ºC'),
	(183533, 121, '2014-02-01 01:06:08.000000', 'temperatura', 562.0000, 'ºC'),
	(183534, 121, '2014-02-01 01:06:09.000000', 'temperatura', 1087.0000, 'ºC'),
	(183535, 121, '2014-02-01 01:06:10.000000', 'temperatura', 151.0000, 'ºC'),
	(183536, 121, '2014-02-01 01:06:11.000000', 'temperatura', 1093.0000, 'ºC'),
	(183537, 121, '2014-02-01 01:06:12.000000', 'temperatura', 212.0000, 'ºC'),
	(183538, 121, '2014-02-01 01:06:13.000000', 'temperatura', 182.0000, 'ºC'),
	(183539, 121, '2014-02-01 01:06:14.000000', 'temperatura', 276.0000, 'ºC'),
	(183540, 121, '2014-02-01 01:06:15.000000', 'temperatura', 834.0000, 'ºC'),
	(183541, 121, '2014-02-01 01:06:16.000000', 'temperatura', 944.0000, 'ºC'),
	(183542, 121, '2014-02-01 01:06:17.000000', 'temperatura', 1015.0000, 'ºC'),
	(183543, 121, '2014-02-01 01:06:18.000000', 'temperatura', 1047.0000, 'ºC'),
	(183544, 121, '2014-02-01 01:06:19.000000', 'temperatura', 988.0000, 'ºC'),
	(183545, 121, '2014-02-01 01:06:20.000000', 'temperatura', 600.0000, 'ºC'),
	(183546, 121, '2014-02-01 01:06:21.000000', 'temperatura', 37.0000, 'ºC'),
	(183547, 121, '2014-02-01 01:06:22.000000', 'temperatura', 784.0000, 'ºC'),
	(183548, 121, '2014-02-01 01:06:23.000000', 'temperatura', 211.0000, 'ºC'),
	(183549, 121, '2014-02-01 01:06:24.000000', 'temperatura', 1101.0000, 'ºC'),
	(183550, 121, '2014-02-01 01:06:25.000000', 'temperatura', 76.0000, 'ºC'),
	(183551, 121, '2014-02-01 01:06:26.000000', 'temperatura', 676.0000, 'ºC'),
	(183552, 121, '2014-02-01 01:06:27.000000', 'temperatura', 754.0000, 'ºC'),
	(183553, 121, '2014-02-01 01:06:28.000000', 'temperatura', 540.0000, 'ºC'),
	(183554, 121, '2014-02-01 01:06:29.000000', 'temperatura', 438.0000, 'ºC'),
	(183555, 121, '2014-02-01 01:06:30.000000', 'temperatura', 573.0000, 'ºC'),
	(183556, 121, '2014-02-01 01:06:31.000000', 'temperatura', 352.0000, 'ºC'),
	(183557, 121, '2014-02-01 01:06:32.000000', 'temperatura', 39.0000, 'ºC'),
	(183558, 121, '2014-02-01 01:06:33.000000', 'temperatura', 339.0000, 'ºC'),
	(183559, 121, '2014-02-01 01:06:34.000000', 'temperatura', 379.0000, 'ºC'),
	(183560, 121, '2014-02-01 01:06:35.000000', 'temperatura', 878.0000, 'ºC'),
	(183561, 121, '2014-02-01 01:06:36.000000', 'temperatura', 856.0000, 'ºC'),
	(183562, 121, '2014-02-01 01:06:37.000000', 'temperatura', 446.0000, 'ºC'),
	(183563, 121, '2014-02-01 01:06:38.000000', 'temperatura', 861.0000, 'ºC'),
	(183564, 121, '2014-02-01 01:06:39.000000', 'temperatura', 566.0000, 'ºC'),
	(183565, 121, '2014-02-01 01:06:40.000000', 'temperatura', 251.0000, 'ºC'),
	(183566, 121, '2014-02-01 01:06:41.000000', 'temperatura', 756.0000, 'ºC'),
	(183567, 121, '2014-02-01 01:06:42.000000', 'temperatura', 627.0000, 'ºC'),
	(183568, 121, '2014-02-01 01:06:43.000000', 'temperatura', 867.0000, 'ºC'),
	(183569, 121, '2014-02-01 01:06:44.000000', 'temperatura', 55.0000, 'ºC'),
	(183570, 121, '2014-02-01 01:06:45.000000', 'temperatura', 75.0000, 'ºC'),
	(183571, 121, '2014-02-01 01:06:46.000000', 'temperatura', 210.0000, 'ºC'),
	(183572, 121, '2014-02-01 01:06:47.000000', 'temperatura', 827.0000, 'ºC'),
	(183573, 121, '2014-02-01 01:06:48.000000', 'temperatura', 1105.0000, 'ºC'),
	(183574, 121, '2014-02-01 01:06:49.000000', 'temperatura', 645.0000, 'ºC'),
	(183575, 121, '2014-02-01 01:06:50.000000', 'temperatura', 1110.0000, 'ºC'),
	(183576, 121, '2014-02-01 01:06:51.000000', 'temperatura', 14.0000, 'ºC'),
	(183577, 121, '2014-02-01 01:06:52.000000', 'temperatura', 344.0000, 'ºC'),
	(183578, 121, '2014-02-01 01:06:53.000000', 'temperatura', 475.0000, 'ºC'),
	(183579, 121, '2014-02-01 01:06:54.000000', 'temperatura', 146.0000, 'ºC'),
	(183580, 121, '2014-02-01 01:06:55.000000', 'temperatura', 505.0000, 'ºC'),
	(183581, 121, '2014-02-01 01:06:56.000000', 'temperatura', 885.0000, 'ºC'),
	(183582, 121, '2014-02-01 01:06:57.000000', 'temperatura', 513.0000, 'ºC'),
	(183583, 121, '2014-02-01 01:06:58.000000', 'temperatura', 1109.0000, 'ºC'),
	(183584, 121, '2014-02-01 01:06:59.000000', 'temperatura', 406.0000, 'ºC'),
	(183585, 121, '2014-02-01 01:07:00.000000', 'temperatura', 1104.0000, 'ºC'),
	(183586, 121, '2014-02-01 01:07:01.000000', 'temperatura', 701.0000, 'ºC'),
	(183587, 121, '2014-02-01 01:07:02.000000', 'temperatura', 197.0000, 'ºC'),
	(183588, 121, '2014-02-01 01:07:03.000000', 'temperatura', 79.0000, 'ºC'),
	(183589, 121, '2014-02-01 01:07:04.000000', 'temperatura', 1005.0000, 'ºC'),
	(183590, 121, '2014-02-01 01:07:05.000000', 'temperatura', 1189.0000, 'ºC'),
	(183591, 121, '2014-02-01 01:07:06.000000', 'temperatura', 529.0000, 'ºC'),
	(183592, 121, '2014-02-01 01:07:07.000000', 'temperatura', 280.0000, 'ºC'),
	(183593, 121, '2014-02-01 01:07:08.000000', 'temperatura', 1014.0000, 'ºC'),
	(183594, 121, '2014-02-01 01:07:09.000000', 'temperatura', 631.0000, 'ºC'),
	(183595, 121, '2014-02-01 01:07:10.000000', 'temperatura', 112.0000, 'ºC'),
	(183596, 121, '2014-02-01 01:07:11.000000', 'temperatura', 1068.0000, 'ºC'),
	(183597, 121, '2014-02-01 01:07:12.000000', 'temperatura', 206.0000, 'ºC'),
	(183598, 121, '2014-02-01 01:07:13.000000', 'temperatura', 223.0000, 'ºC'),
	(183599, 121, '2014-02-01 01:07:14.000000', 'temperatura', 501.0000, 'ºC'),
	(183600, 121, '2014-02-01 01:07:15.000000', 'temperatura', 635.0000, 'ºC'),
	(183601, 121, '2014-02-01 01:07:16.000000', 'temperatura', 474.0000, 'ºC'),
	(183602, 121, '2014-02-01 01:07:17.000000', 'temperatura', 463.0000, 'ºC'),
	(183603, 121, '2014-02-01 01:07:18.000000', 'temperatura', 895.0000, 'ºC'),
	(183604, 121, '2014-02-01 01:07:19.000000', 'temperatura', 686.0000, 'ºC'),
	(183605, 121, '2014-02-01 01:07:20.000000', 'temperatura', 746.0000, 'ºC'),
	(183606, 121, '2014-02-01 01:07:21.000000', 'temperatura', 472.0000, 'ºC'),
	(183607, 121, '2014-02-01 01:07:22.000000', 'temperatura', 121.0000, 'ºC'),
	(183608, 121, '2014-02-01 01:07:23.000000', 'temperatura', 389.0000, 'ºC'),
	(183609, 121, '2014-02-01 01:07:24.000000', 'temperatura', 383.0000, 'ºC'),
	(183610, 121, '2014-02-01 01:07:25.000000', 'temperatura', 749.0000, 'ºC'),
	(183611, 121, '2014-02-01 01:07:26.000000', 'temperatura', 196.0000, 'ºC'),
	(183612, 121, '2014-02-01 01:07:27.000000', 'temperatura', 1132.0000, 'ºC'),
	(183613, 121, '2014-02-01 01:07:28.000000', 'temperatura', 274.0000, 'ºC'),
	(183614, 121, '2014-02-01 01:07:29.000000', 'temperatura', 376.0000, 'ºC'),
	(183615, 121, '2014-02-01 01:07:30.000000', 'temperatura', 1056.0000, 'ºC'),
	(183616, 121, '2014-02-01 01:07:31.000000', 'temperatura', 553.0000, 'ºC'),
	(183617, 121, '2014-02-01 01:07:32.000000', 'temperatura', 796.0000, 'ºC'),
	(183618, 121, '2014-02-01 01:07:33.000000', 'temperatura', 1122.0000, 'ºC'),
	(183619, 121, '2014-02-01 01:07:34.000000', 'temperatura', 821.0000, 'ºC'),
	(183620, 121, '2014-02-01 01:07:35.000000', 'temperatura', 742.0000, 'ºC'),
	(183621, 121, '2014-02-01 01:07:36.000000', 'temperatura', 45.0000, 'ºC'),
	(183622, 121, '2014-02-01 01:07:37.000000', 'temperatura', 401.0000, 'ºC'),
	(183623, 121, '2014-02-01 01:07:38.000000', 'temperatura', 670.0000, 'ºC'),
	(183624, 121, '2014-02-01 01:07:39.000000', 'temperatura', 948.0000, 'ºC'),
	(183625, 121, '2014-02-01 01:07:40.000000', 'temperatura', 330.0000, 'ºC'),
	(183626, 121, '2014-02-01 01:07:41.000000', 'temperatura', 5.0000, 'ºC'),
	(183627, 121, '2014-02-01 01:07:42.000000', 'temperatura', 235.0000, 'ºC'),
	(183628, 121, '2014-02-01 01:07:43.000000', 'temperatura', 1162.0000, 'ºC'),
	(183629, 121, '2014-02-01 01:07:44.000000', 'temperatura', 306.0000, 'ºC'),
	(183630, 121, '2014-02-01 01:07:45.000000', 'temperatura', 446.0000, 'ºC'),
	(183631, 121, '2014-02-01 01:07:46.000000', 'temperatura', 111.0000, 'ºC'),
	(183632, 121, '2014-02-01 01:07:47.000000', 'temperatura', 418.0000, 'ºC'),
	(183633, 121, '2014-02-01 01:07:48.000000', 'temperatura', 557.0000, 'ºC'),
	(183634, 121, '2014-02-01 01:07:49.000000', 'temperatura', 331.0000, 'ºC'),
	(183635, 121, '2014-02-01 01:07:50.000000', 'temperatura', 1185.0000, 'ºC'),
	(183636, 121, '2014-02-01 01:07:51.000000', 'temperatura', 134.0000, 'ºC'),
	(183637, 121, '2014-02-01 01:07:52.000000', 'temperatura', 714.0000, 'ºC'),
	(183638, 121, '2014-02-01 01:07:53.000000', 'temperatura', 771.0000, 'ºC'),
	(183639, 121, '2014-02-01 01:07:54.000000', 'temperatura', 510.0000, 'ºC'),
	(183640, 121, '2014-02-01 01:07:55.000000', 'temperatura', 240.0000, 'ºC'),
	(183641, 121, '2014-02-01 01:07:56.000000', 'temperatura', 870.0000, 'ºC'),
	(183642, 121, '2014-02-01 01:07:57.000000', 'temperatura', 29.0000, 'ºC'),
	(183643, 121, '2014-02-01 01:07:58.000000', 'temperatura', 1138.0000, 'ºC'),
	(183644, 121, '2014-02-01 01:07:59.000000', 'temperatura', 801.0000, 'ºC'),
	(183645, 121, '2014-02-01 01:08:00.000000', 'temperatura', 595.0000, 'ºC'),
	(183646, 121, '2014-02-01 01:08:01.000000', 'temperatura', 569.0000, 'ºC'),
	(183647, 121, '2014-02-01 01:08:02.000000', 'temperatura', 1060.0000, 'ºC'),
	(183648, 121, '2014-02-01 01:08:03.000000', 'temperatura', 1196.0000, 'ºC'),
	(183649, 121, '2014-02-01 01:08:04.000000', 'temperatura', 401.0000, 'ºC'),
	(183650, 121, '2014-02-01 01:08:05.000000', 'temperatura', 815.0000, 'ºC'),
	(183651, 121, '2014-02-01 01:08:06.000000', 'temperatura', 472.0000, 'ºC'),
	(183652, 121, '2014-02-01 01:08:07.000000', 'temperatura', 1118.0000, 'ºC'),
	(183653, 121, '2014-02-01 01:08:08.000000', 'temperatura', 573.0000, 'ºC'),
	(183654, 121, '2014-02-01 01:08:09.000000', 'temperatura', 712.0000, 'ºC'),
	(183655, 121, '2014-02-01 01:08:10.000000', 'temperatura', 640.0000, 'ºC'),
	(183656, 121, '2014-02-01 01:08:11.000000', 'temperatura', 1066.0000, 'ºC'),
	(183657, 121, '2014-02-01 01:08:12.000000', 'temperatura', 1008.0000, 'ºC'),
	(183658, 121, '2014-02-01 01:08:13.000000', 'temperatura', 644.0000, 'ºC'),
	(183659, 121, '2014-02-01 01:08:14.000000', 'temperatura', 196.0000, 'ºC'),
	(183660, 121, '2014-02-01 01:08:15.000000', 'temperatura', 250.0000, 'ºC'),
	(183661, 121, '2014-02-01 01:08:16.000000', 'temperatura', 661.0000, 'ºC'),
	(183662, 121, '2014-02-01 01:08:17.000000', 'temperatura', 155.0000, 'ºC'),
	(183663, 121, '2014-02-01 01:08:18.000000', 'temperatura', 1193.0000, 'ºC'),
	(183664, 121, '2014-02-01 01:08:19.000000', 'temperatura', 702.0000, 'ºC'),
	(183665, 121, '2014-02-01 01:08:20.000000', 'temperatura', 1132.0000, 'ºC'),
	(183666, 121, '2014-02-01 01:08:21.000000', 'temperatura', 1154.0000, 'ºC'),
	(183667, 121, '2014-02-01 01:08:22.000000', 'temperatura', 1173.0000, 'ºC'),
	(183668, 121, '2014-02-01 01:08:23.000000', 'temperatura', 3.0000, 'ºC'),
	(183669, 121, '2014-02-01 01:08:24.000000', 'temperatura', 99.0000, 'ºC'),
	(183670, 121, '2014-02-01 01:08:25.000000', 'temperatura', 484.0000, 'ºC'),
	(183671, 121, '2014-02-01 01:08:26.000000', 'temperatura', 926.0000, 'ºC'),
	(183672, 121, '2014-02-01 01:08:27.000000', 'temperatura', 779.0000, 'ºC'),
	(183673, 121, '2014-02-01 01:08:28.000000', 'temperatura', 1114.0000, 'ºC'),
	(183674, 121, '2014-02-01 01:08:29.000000', 'temperatura', 837.0000, 'ºC'),
	(183675, 121, '2014-02-01 01:08:30.000000', 'temperatura', 842.0000, 'ºC'),
	(183676, 121, '2014-02-01 01:08:31.000000', 'temperatura', 499.0000, 'ºC'),
	(183677, 121, '2014-02-01 01:08:32.000000', 'temperatura', 1172.0000, 'ºC'),
	(183678, 121, '2014-02-01 01:08:33.000000', 'temperatura', 762.0000, 'ºC'),
	(183679, 121, '2014-02-01 01:08:34.000000', 'temperatura', 295.0000, 'ºC'),
	(183680, 121, '2014-02-01 01:08:35.000000', 'temperatura', 390.0000, 'ºC'),
	(183681, 121, '2014-02-01 01:08:36.000000', 'temperatura', 1063.0000, 'ºC'),
	(183682, 121, '2014-02-01 01:08:37.000000', 'temperatura', 548.0000, 'ºC'),
	(183683, 121, '2014-02-01 01:08:38.000000', 'temperatura', 750.0000, 'ºC'),
	(183684, 121, '2014-02-01 01:08:39.000000', 'temperatura', 906.0000, 'ºC'),
	(183685, 121, '2014-02-01 01:08:40.000000', 'temperatura', 1082.0000, 'ºC'),
	(183686, 121, '2014-02-01 01:08:41.000000', 'temperatura', 292.0000, 'ºC'),
	(183687, 121, '2014-02-01 01:08:42.000000', 'temperatura', 614.0000, 'ºC'),
	(183688, 122, '2014-02-01 00:00:00.000000', 'temperatura', 732.0000, 'ºC'),
	(183689, 122, '2014-02-01 00:00:01.000000', 'temperatura', 677.0000, 'ºC'),
	(183690, 122, '2014-02-01 00:00:02.000000', 'temperatura', 1190.0000, 'ºC'),
	(183691, 122, '2014-02-01 00:00:03.000000', 'temperatura', 320.0000, 'ºC'),
	(183692, 122, '2014-02-01 00:00:04.000000', 'temperatura', 429.0000, 'ºC'),
	(183693, 122, '2014-02-01 00:00:05.000000', 'temperatura', 1186.0000, 'ºC'),
	(183694, 122, '2014-02-01 00:00:06.000000', 'temperatura', 1042.0000, 'ºC'),
	(183695, 122, '2014-02-01 00:00:07.000000', 'temperatura', 454.0000, 'ºC'),
	(183696, 122, '2014-02-01 00:00:08.000000', 'temperatura', 346.0000, 'ºC'),
	(183697, 122, '2014-02-01 00:00:09.000000', 'temperatura', 365.0000, 'ºC'),
	(183698, 122, '2014-02-01 00:00:10.000000', 'temperatura', 790.0000, 'ºC'),
	(183699, 122, '2014-02-01 00:00:11.000000', 'temperatura', 457.0000, 'ºC'),
	(183700, 122, '2014-02-01 00:00:12.000000', 'temperatura', 1112.0000, 'ºC'),
	(183701, 122, '2014-02-01 00:00:13.000000', 'temperatura', 593.0000, 'ºC'),
	(183702, 122, '2014-02-01 00:00:14.000000', 'temperatura', 827.0000, 'ºC'),
	(183703, 122, '2014-02-01 00:00:15.000000', 'temperatura', 1158.0000, 'ºC'),
	(183704, 122, '2014-02-01 00:00:16.000000', 'temperatura', 909.0000, 'ºC'),
	(183705, 122, '2014-02-01 00:00:17.000000', 'temperatura', 1070.0000, 'ºC'),
	(183706, 122, '2014-02-01 00:00:18.000000', 'temperatura', 225.0000, 'ºC'),
	(183707, 122, '2014-02-01 00:00:19.000000', 'temperatura', 314.0000, 'ºC'),
	(183708, 122, '2014-02-01 00:00:20.000000', 'temperatura', 897.0000, 'ºC'),
	(183709, 122, '2014-02-01 00:00:21.000000', 'temperatura', 1142.0000, 'ºC'),
	(183710, 122, '2014-02-01 00:00:22.000000', 'temperatura', 620.0000, 'ºC'),
	(183711, 122, '2014-02-01 00:00:23.000000', 'temperatura', 875.0000, 'ºC'),
	(183712, 122, '2014-02-01 00:00:24.000000', 'temperatura', 115.0000, 'ºC'),
	(183713, 122, '2014-02-01 00:00:25.000000', 'temperatura', 349.0000, 'ºC'),
	(183714, 122, '2014-02-01 00:00:26.000000', 'temperatura', 201.0000, 'ºC'),
	(183715, 122, '2014-02-01 00:00:27.000000', 'temperatura', 1158.0000, 'ºC'),
	(183716, 122, '2014-02-01 00:00:28.000000', 'temperatura', 387.0000, 'ºC'),
	(183717, 122, '2014-02-01 00:00:29.000000', 'temperatura', 862.0000, 'ºC'),
	(183718, 122, '2014-02-01 00:00:30.000000', 'temperatura', 750.0000, 'ºC'),
	(183719, 122, '2014-02-01 00:00:31.000000', 'temperatura', 1166.0000, 'ºC'),
	(183720, 122, '2014-02-01 00:00:32.000000', 'temperatura', 1178.0000, 'ºC'),
	(183721, 122, '2014-02-01 00:00:33.000000', 'temperatura', 1195.0000, 'ºC'),
	(183722, 122, '2014-02-01 00:00:34.000000', 'temperatura', 39.0000, 'ºC'),
	(183723, 122, '2014-02-01 00:00:35.000000', 'temperatura', 213.0000, 'ºC'),
	(183724, 122, '2014-02-01 00:00:36.000000', 'temperatura', 948.0000, 'ºC'),
	(183725, 122, '2014-02-01 00:00:37.000000', 'temperatura', 502.0000, 'ºC'),
	(183726, 122, '2014-02-01 00:00:38.000000', 'temperatura', 867.0000, 'ºC'),
	(183727, 122, '2014-02-01 00:00:39.000000', 'temperatura', 427.0000, 'ºC'),
	(183728, 122, '2014-02-01 00:00:40.000000', 'temperatura', 735.0000, 'ºC'),
	(183729, 122, '2014-02-01 00:00:41.000000', 'temperatura', 1195.0000, 'ºC'),
	(183730, 122, '2014-02-01 00:00:42.000000', 'temperatura', 172.0000, 'ºC'),
	(183731, 122, '2014-02-01 00:00:43.000000', 'temperatura', 874.0000, 'ºC'),
	(183732, 122, '2014-02-01 00:00:44.000000', 'temperatura', 253.0000, 'ºC'),
	(183733, 122, '2014-02-01 00:00:45.000000', 'temperatura', 1046.0000, 'ºC'),
	(183734, 122, '2014-02-01 00:00:46.000000', 'temperatura', 871.0000, 'ºC'),
	(183735, 122, '2014-02-01 00:00:47.000000', 'temperatura', 19.0000, 'ºC'),
	(183736, 122, '2014-02-01 00:00:48.000000', 'temperatura', 1082.0000, 'ºC'),
	(183737, 122, '2014-02-01 00:00:49.000000', 'temperatura', 555.0000, 'ºC'),
	(183738, 122, '2014-02-01 00:00:50.000000', 'temperatura', 727.0000, 'ºC'),
	(183739, 122, '2014-02-01 00:00:51.000000', 'temperatura', 771.0000, 'ºC'),
	(183740, 122, '2014-02-01 00:00:52.000000', 'temperatura', 476.0000, 'ºC'),
	(183741, 122, '2014-02-01 00:00:53.000000', 'temperatura', 67.0000, 'ºC'),
	(183742, 122, '2014-02-01 00:00:54.000000', 'temperatura', 108.0000, 'ºC'),
	(183743, 122, '2014-02-01 00:00:55.000000', 'temperatura', 341.0000, 'ºC'),
	(183744, 122, '2014-02-01 00:00:56.000000', 'temperatura', 179.0000, 'ºC'),
	(183745, 122, '2014-02-01 00:00:57.000000', 'temperatura', 1074.0000, 'ºC'),
	(183746, 122, '2014-02-01 00:00:58.000000', 'temperatura', 32.0000, 'ºC'),
	(183747, 122, '2014-02-01 00:00:59.000000', 'temperatura', 538.0000, 'ºC'),
	(183748, 122, '2014-02-01 00:01:00.000000', 'temperatura', 195.0000, 'ºC'),
	(183749, 122, '2014-02-01 00:01:01.000000', 'temperatura', 561.0000, 'ºC'),
	(183750, 122, '2014-02-01 00:01:02.000000', 'temperatura', 1020.0000, 'ºC'),
	(183751, 122, '2014-02-01 00:01:03.000000', 'temperatura', 1018.0000, 'ºC'),
	(183752, 122, '2014-02-01 00:01:04.000000', 'temperatura', 829.0000, 'ºC'),
	(183753, 122, '2014-02-01 00:01:05.000000', 'temperatura', 1093.0000, 'ºC'),
	(183754, 122, '2014-02-01 00:01:06.000000', 'temperatura', 578.0000, 'ºC'),
	(183755, 122, '2014-02-01 00:01:07.000000', 'temperatura', 812.0000, 'ºC'),
	(183756, 122, '2014-02-01 00:01:08.000000', 'temperatura', 1127.0000, 'ºC'),
	(183757, 122, '2014-02-01 00:01:09.000000', 'temperatura', 801.0000, 'ºC'),
	(183758, 122, '2014-02-01 00:01:10.000000', 'temperatura', 623.0000, 'ºC'),
	(183759, 122, '2014-02-01 00:01:11.000000', 'temperatura', 711.0000, 'ºC'),
	(183760, 122, '2014-02-01 00:01:12.000000', 'temperatura', 489.0000, 'ºC'),
	(183761, 122, '2014-02-01 00:01:13.000000', 'temperatura', 313.0000, 'ºC'),
	(183762, 122, '2014-02-01 00:01:14.000000', 'temperatura', 98.0000, 'ºC'),
	(183763, 122, '2014-02-01 00:01:15.000000', 'temperatura', 750.0000, 'ºC'),
	(183764, 122, '2014-02-01 00:01:16.000000', 'temperatura', 1056.0000, 'ºC'),
	(183765, 122, '2014-02-01 00:01:17.000000', 'temperatura', 634.0000, 'ºC'),
	(183766, 122, '2014-02-01 00:01:18.000000', 'temperatura', 1199.0000, 'ºC'),
	(183767, 122, '2014-02-01 00:01:19.000000', 'temperatura', 493.0000, 'ºC'),
	(183768, 122, '2014-02-01 00:01:20.000000', 'temperatura', 70.0000, 'ºC'),
	(183769, 122, '2014-02-01 00:01:21.000000', 'temperatura', 70.0000, 'ºC'),
	(183770, 122, '2014-02-01 00:01:22.000000', 'temperatura', 141.0000, 'ºC'),
	(183771, 122, '2014-02-01 00:01:23.000000', 'temperatura', 495.0000, 'ºC'),
	(183772, 122, '2014-02-01 00:01:24.000000', 'temperatura', 853.0000, 'ºC'),
	(183773, 122, '2014-02-01 00:01:25.000000', 'temperatura', 379.0000, 'ºC'),
	(183774, 122, '2014-02-01 00:01:26.000000', 'temperatura', 537.0000, 'ºC'),
	(183775, 122, '2014-02-01 00:01:27.000000', 'temperatura', 350.0000, 'ºC'),
	(183776, 122, '2014-02-01 00:01:28.000000', 'temperatura', 140.0000, 'ºC'),
	(183777, 122, '2014-02-01 00:01:29.000000', 'temperatura', 848.0000, 'ºC'),
	(183778, 122, '2014-02-01 00:01:30.000000', 'temperatura', 221.0000, 'ºC'),
	(183779, 122, '2014-02-01 00:01:31.000000', 'temperatura', 963.0000, 'ºC'),
	(183780, 122, '2014-02-01 00:01:32.000000', 'temperatura', 553.0000, 'ºC'),
	(183781, 122, '2014-02-01 00:01:33.000000', 'temperatura', 1074.0000, 'ºC'),
	(183782, 122, '2014-02-01 00:01:34.000000', 'temperatura', 111.0000, 'ºC'),
	(183783, 122, '2014-02-01 00:01:35.000000', 'temperatura', 935.0000, 'ºC'),
	(183784, 122, '2014-02-01 00:01:36.000000', 'temperatura', 741.0000, 'ºC'),
	(183785, 122, '2014-02-01 00:01:37.000000', 'temperatura', 903.0000, 'ºC'),
	(183786, 122, '2014-02-01 00:01:38.000000', 'temperatura', 1092.0000, 'ºC'),
	(183787, 122, '2014-02-01 00:01:39.000000', 'temperatura', 353.0000, 'ºC'),
	(183788, 122, '2014-02-01 00:01:40.000000', 'temperatura', 887.0000, 'ºC'),
	(183789, 122, '2014-02-01 00:01:41.000000', 'temperatura', 976.0000, 'ºC'),
	(183790, 122, '2014-02-01 00:01:42.000000', 'temperatura', 1019.0000, 'ºC'),
	(183791, 122, '2014-02-01 00:01:43.000000', 'temperatura', 970.0000, 'ºC'),
	(183792, 122, '2014-02-01 00:01:44.000000', 'temperatura', 592.0000, 'ºC'),
	(183793, 122, '2014-02-01 00:01:45.000000', 'temperatura', 51.0000, 'ºC'),
	(183794, 122, '2014-02-01 00:01:46.000000', 'temperatura', 877.0000, 'ºC'),
	(183795, 122, '2014-02-01 00:01:47.000000', 'temperatura', 635.0000, 'ºC'),
	(183796, 122, '2014-02-01 00:01:48.000000', 'temperatura', 546.0000, 'ºC'),
	(183797, 122, '2014-02-01 00:01:49.000000', 'temperatura', 822.0000, 'ºC'),
	(183798, 122, '2014-02-01 00:01:50.000000', 'temperatura', 74.0000, 'ºC'),
	(183799, 122, '2014-02-01 00:01:51.000000', 'temperatura', 303.0000, 'ºC'),
	(183800, 122, '2014-02-01 00:01:52.000000', 'temperatura', 95.0000, 'ºC'),
	(183801, 122, '2014-02-01 00:01:53.000000', 'temperatura', 768.0000, 'ºC'),
	(183802, 122, '2014-02-01 00:01:54.000000', 'temperatura', 1154.0000, 'ºC'),
	(183803, 122, '2014-02-01 00:01:55.000000', 'temperatura', 1068.0000, 'ºC'),
	(183804, 122, '2014-02-01 00:01:56.000000', 'temperatura', 676.0000, 'ºC'),
	(183805, 122, '2014-02-01 00:01:57.000000', 'temperatura', 178.0000, 'ºC'),
	(183806, 122, '2014-02-01 00:01:58.000000', 'temperatura', 63.0000, 'ºC'),
	(183807, 122, '2014-02-01 00:01:59.000000', 'temperatura', 979.0000, 'ºC'),
	(183808, 122, '2014-02-01 00:02:00.000000', 'temperatura', 1109.0000, 'ºC'),
	(183809, 122, '2014-02-01 00:02:01.000000', 'temperatura', 209.0000, 'ºC'),
	(183810, 122, '2014-02-01 00:02:02.000000', 'temperatura', 118.0000, 'ºC'),
	(183811, 122, '2014-02-01 00:02:03.000000', 'temperatura', 1164.0000, 'ºC'),
	(183812, 122, '2014-02-01 00:02:04.000000', 'temperatura', 666.0000, 'ºC'),
	(183813, 122, '2014-02-01 00:02:05.000000', 'temperatura', 1038.0000, 'ºC'),
	(183814, 122, '2014-02-01 00:02:06.000000', 'temperatura', 794.0000, 'ºC'),
	(183815, 122, '2014-02-01 00:02:07.000000', 'temperatura', 858.0000, 'ºC'),
	(183816, 122, '2014-02-01 00:02:08.000000', 'temperatura', 706.0000, 'ºC'),
	(183817, 122, '2014-02-01 00:02:09.000000', 'temperatura', 955.0000, 'ºC'),
	(183818, 122, '2014-02-01 00:02:10.000000', 'temperatura', 260.0000, 'ºC'),
	(183819, 122, '2014-02-01 00:02:11.000000', 'temperatura', 834.0000, 'ºC'),
	(183820, 122, '2014-02-01 00:02:12.000000', 'temperatura', 993.0000, 'ºC'),
	(183821, 122, '2014-02-01 00:02:13.000000', 'temperatura', 61.0000, 'ºC'),
	(183822, 122, '2014-02-01 00:02:14.000000', 'temperatura', 926.0000, 'ºC'),
	(183823, 122, '2014-02-01 00:02:15.000000', 'temperatura', 850.0000, 'ºC'),
	(183824, 122, '2014-02-01 00:02:16.000000', 'temperatura', 272.0000, 'ºC'),
	(183825, 122, '2014-02-01 00:02:17.000000', 'temperatura', 10.0000, 'ºC'),
	(183826, 122, '2014-02-01 00:02:18.000000', 'temperatura', 433.0000, 'ºC'),
	(183827, 122, '2014-02-01 00:02:19.000000', 'temperatura', 935.0000, 'ºC'),
	(183828, 122, '2014-02-01 00:02:20.000000', 'temperatura', 977.0000, 'ºC'),
	(183829, 122, '2014-02-01 00:02:21.000000', 'temperatura', 879.0000, 'ºC'),
	(183830, 122, '2014-02-01 00:02:22.000000', 'temperatura', 266.0000, 'ºC'),
	(183831, 122, '2014-02-01 00:02:23.000000', 'temperatura', 1094.0000, 'ºC'),
	(183832, 122, '2014-02-01 00:02:24.000000', 'temperatura', 1073.0000, 'ºC'),
	(183833, 122, '2014-02-01 00:02:25.000000', 'temperatura', 882.0000, 'ºC'),
	(183834, 122, '2014-02-01 00:02:26.000000', 'temperatura', 1192.0000, 'ºC'),
	(183835, 122, '2014-02-01 00:02:27.000000', 'temperatura', 914.0000, 'ºC'),
	(183836, 122, '2014-02-01 00:02:28.000000', 'temperatura', 996.0000, 'ºC'),
	(183837, 122, '2014-02-01 00:02:29.000000', 'temperatura', 1040.0000, 'ºC'),
	(183838, 122, '2014-02-01 00:02:30.000000', 'temperatura', 1010.0000, 'ºC'),
	(183839, 122, '2014-02-01 00:02:31.000000', 'temperatura', 729.0000, 'ºC'),
	(183840, 122, '2014-02-01 00:02:32.000000', 'temperatura', 618.0000, 'ºC'),
	(183841, 122, '2014-02-01 00:02:33.000000', 'temperatura', 901.0000, 'ºC'),
	(183842, 122, '2014-02-01 00:02:34.000000', 'temperatura', 254.0000, 'ºC'),
	(183843, 122, '2014-02-01 00:02:35.000000', 'temperatura', 967.0000, 'ºC'),
	(183844, 122, '2014-02-01 00:02:36.000000', 'temperatura', 472.0000, 'ºC'),
	(183845, 122, '2014-02-01 00:02:37.000000', 'temperatura', 659.0000, 'ºC'),
	(183846, 122, '2014-02-01 00:02:38.000000', 'temperatura', 681.0000, 'ºC'),
	(183847, 122, '2014-02-01 00:02:39.000000', 'temperatura', 230.0000, 'ºC'),
	(183848, 122, '2014-02-01 00:02:40.000000', 'temperatura', 306.0000, 'ºC'),
	(183849, 122, '2014-02-01 00:02:41.000000', 'temperatura', 841.0000, 'ºC'),
	(183850, 122, '2014-02-01 00:02:42.000000', 'temperatura', 887.0000, 'ºC'),
	(183851, 122, '2014-02-01 00:02:43.000000', 'temperatura', 713.0000, 'ºC'),
	(183852, 122, '2014-02-01 00:02:44.000000', 'temperatura', 903.0000, 'ºC'),
	(183853, 122, '2014-02-01 00:02:45.000000', 'temperatura', 1177.0000, 'ºC'),
	(183854, 122, '2014-02-01 00:02:46.000000', 'temperatura', 779.0000, 'ºC'),
	(183855, 122, '2014-02-01 00:02:47.000000', 'temperatura', 363.0000, 'ºC'),
	(183856, 122, '2014-02-01 00:02:48.000000', 'temperatura', 676.0000, 'ºC'),
	(183857, 122, '2014-02-01 00:02:49.000000', 'temperatura', 1095.0000, 'ºC'),
	(183858, 122, '2014-02-01 00:02:50.000000', 'temperatura', 1047.0000, 'ºC'),
	(183859, 122, '2014-02-01 00:02:51.000000', 'temperatura', 750.0000, 'ºC'),
	(183860, 122, '2014-02-01 00:02:52.000000', 'temperatura', 610.0000, 'ºC'),
	(183861, 122, '2014-02-01 00:02:53.000000', 'temperatura', 800.0000, 'ºC'),
	(183862, 122, '2014-02-01 00:02:54.000000', 'temperatura', 969.0000, 'ºC'),
	(183863, 122, '2014-02-01 00:02:55.000000', 'temperatura', 48.0000, 'ºC'),
	(183864, 122, '2014-02-01 00:02:56.000000', 'temperatura', 931.0000, 'ºC'),
	(183865, 122, '2014-02-01 00:02:57.000000', 'temperatura', 912.0000, 'ºC'),
	(183866, 122, '2014-02-01 00:02:58.000000', 'temperatura', 567.0000, 'ºC'),
	(183867, 122, '2014-02-01 00:02:59.000000', 'temperatura', 100.0000, 'ºC'),
	(183868, 122, '2014-02-01 00:03:00.000000', 'temperatura', 0.0000, 'ºC'),
	(183869, 122, '2014-02-01 00:03:01.000000', 'temperatura', 902.0000, 'ºC'),
	(183870, 122, '2014-02-01 00:03:02.000000', 'temperatura', 910.0000, 'ºC'),
	(183871, 122, '2014-02-01 00:03:03.000000', 'temperatura', 643.0000, 'ºC'),
	(183872, 122, '2014-02-01 00:03:04.000000', 'temperatura', 486.0000, 'ºC'),
	(183873, 122, '2014-02-01 00:03:05.000000', 'temperatura', 501.0000, 'ºC'),
	(183874, 122, '2014-02-01 00:03:06.000000', 'temperatura', 1046.0000, 'ºC'),
	(183875, 122, '2014-02-01 00:03:07.000000', 'temperatura', 129.0000, 'ºC'),
	(183876, 122, '2014-02-01 00:03:08.000000', 'temperatura', 1109.0000, 'ºC'),
	(183877, 122, '2014-02-01 00:03:09.000000', 'temperatura', 359.0000, 'ºC'),
	(183878, 122, '2014-02-01 00:03:10.000000', 'temperatura', 865.0000, 'ºC'),
	(183879, 122, '2014-02-01 00:03:11.000000', 'temperatura', 852.0000, 'ºC'),
	(183880, 122, '2014-02-01 00:03:12.000000', 'temperatura', 463.0000, 'ºC'),
	(183881, 122, '2014-02-01 00:03:13.000000', 'temperatura', 959.0000, 'ºC'),
	(183882, 122, '2014-02-01 00:03:14.000000', 'temperatura', 1009.0000, 'ºC'),
	(183883, 122, '2014-02-01 00:03:15.000000', 'temperatura', 967.0000, 'ºC'),
	(183884, 122, '2014-02-01 00:03:16.000000', 'temperatura', 607.0000, 'ºC'),
	(183885, 122, '2014-02-01 00:03:17.000000', 'temperatura', 136.0000, 'ºC'),
	(183886, 122, '2014-02-01 00:03:18.000000', 'temperatura', 60.0000, 'ºC'),
	(183887, 122, '2014-02-01 00:03:19.000000', 'temperatura', 1090.0000, 'ºC'),
	(183888, 122, '2014-02-01 00:03:20.000000', 'temperatura', 474.0000, 'ºC'),
	(183889, 122, '2014-02-01 00:03:21.000000', 'temperatura', 298.0000, 'ºC'),
	(183890, 122, '2014-02-01 00:03:22.000000', 'temperatura', 71.0000, 'ºC'),
	(183891, 122, '2014-02-01 00:03:23.000000', 'temperatura', 661.0000, 'ºC'),
	(183892, 122, '2014-02-01 00:03:24.000000', 'temperatura', 693.0000, 'ºC'),
	(183893, 122, '2014-02-01 00:03:25.000000', 'temperatura', 281.0000, 'ºC'),
	(183894, 122, '2014-02-01 00:03:26.000000', 'temperatura', 526.0000, 'ºC'),
	(183895, 122, '2014-02-01 00:03:27.000000', 'temperatura', 589.0000, 'ºC'),
	(183896, 122, '2014-02-01 00:03:28.000000', 'temperatura', 168.0000, 'ºC'),
	(183897, 122, '2014-02-01 00:03:29.000000', 'temperatura', 275.0000, 'ºC'),
	(183898, 122, '2014-02-01 00:03:30.000000', 'temperatura', 868.0000, 'ºC'),
	(183899, 122, '2014-02-01 00:03:31.000000', 'temperatura', 1119.0000, 'ºC'),
	(183900, 122, '2014-02-01 00:03:32.000000', 'temperatura', 590.0000, 'ºC'),
	(183901, 122, '2014-02-01 00:03:33.000000', 'temperatura', 794.0000, 'ºC'),
	(183902, 122, '2014-02-01 00:03:34.000000', 'temperatura', 999.0000, 'ºC'),
	(183903, 122, '2014-02-01 00:03:35.000000', 'temperatura', 214.0000, 'ºC'),
	(183904, 122, '2014-02-01 00:03:36.000000', 'temperatura', 473.0000, 'ºC'),
	(183905, 122, '2014-02-01 00:03:37.000000', 'temperatura', 522.0000, 'ºC'),
	(183906, 122, '2014-02-01 00:03:38.000000', 'temperatura', 1193.0000, 'ºC'),
	(183907, 122, '2014-02-01 00:03:39.000000', 'temperatura', 799.0000, 'ºC'),
	(183908, 122, '2014-02-01 00:03:40.000000', 'temperatura', 416.0000, 'ºC'),
	(183909, 122, '2014-02-01 00:03:41.000000', 'temperatura', 885.0000, 'ºC'),
	(183910, 122, '2014-02-01 00:03:42.000000', 'temperatura', 776.0000, 'ºC'),
	(183911, 122, '2014-02-01 00:03:43.000000', 'temperatura', 26.0000, 'ºC'),
	(183912, 122, '2014-02-01 00:03:44.000000', 'temperatura', 204.0000, 'ºC'),
	(183913, 122, '2014-02-01 00:03:45.000000', 'temperatura', 943.0000, 'ºC'),
	(183914, 122, '2014-02-01 00:03:46.000000', 'temperatura', 501.0000, 'ºC'),
	(183915, 122, '2014-02-01 00:03:47.000000', 'temperatura', 879.0000, 'ºC'),
	(183916, 122, '2014-02-01 00:03:48.000000', 'temperatura', 493.0000, 'ºC'),
	(183917, 122, '2014-02-01 00:03:49.000000', 'temperatura', 1026.0000, 'ºC'),
	(183918, 122, '2014-02-01 00:03:50.000000', 'temperatura', 54.0000, 'ºC'),
	(183919, 122, '2014-02-01 00:03:51.000000', 'temperatura', 790.0000, 'ºC'),
	(183920, 122, '2014-02-01 00:03:52.000000', 'temperatura', 190.0000, 'ºC'),
	(183921, 122, '2014-02-01 00:03:53.000000', 'temperatura', 978.0000, 'ºC'),
	(183922, 122, '2014-02-01 00:03:54.000000', 'temperatura', 722.0000, 'ºC'),
	(183923, 122, '2014-02-01 00:03:55.000000', 'temperatura', 677.0000, 'ºC'),
	(183924, 122, '2014-02-01 00:03:56.000000', 'temperatura', 20.0000, 'ºC'),
	(183925, 122, '2014-02-01 00:03:57.000000', 'temperatura', 467.0000, 'ºC'),
	(183926, 122, '2014-02-01 00:03:58.000000', 'temperatura', 1078.0000, 'ºC'),
	(183927, 122, '2014-02-01 00:03:59.000000', 'temperatura', 388.0000, 'ºC'),
	(183928, 122, '2014-02-01 00:04:00.000000', 'temperatura', 1108.0000, 'ºC'),
	(183929, 122, '2014-02-01 00:04:01.000000', 'temperatura', 776.0000, 'ºC'),
	(183930, 122, '2014-02-01 00:04:02.000000', 'temperatura', 558.0000, 'ºC'),
	(183931, 122, '2014-02-01 00:04:03.000000', 'temperatura', 462.0000, 'ºC'),
	(183932, 122, '2014-02-01 00:04:04.000000', 'temperatura', 636.0000, 'ºC'),
	(183933, 122, '2014-02-01 00:04:05.000000', 'temperatura', 595.0000, 'ºC'),
	(183934, 122, '2014-02-01 00:04:06.000000', 'temperatura', 1066.0000, 'ºC'),
	(183935, 122, '2014-02-01 00:04:07.000000', 'temperatura', 1147.0000, 'ºC'),
	(183936, 122, '2014-02-01 00:04:08.000000', 'temperatura', 138.0000, 'ºC'),
	(183937, 122, '2014-02-01 00:04:09.000000', 'temperatura', 850.0000, 'ºC'),
	(183938, 122, '2014-02-01 00:04:10.000000', 'temperatura', 235.0000, 'ºC'),
	(183939, 122, '2014-02-01 00:04:11.000000', 'temperatura', 1025.0000, 'ºC'),
	(183940, 122, '2014-02-01 00:04:12.000000', 'temperatura', 820.0000, 'ºC'),
	(183941, 122, '2014-02-01 00:04:13.000000', 'temperatura', 1025.0000, 'ºC'),
	(183942, 122, '2014-02-01 00:04:14.000000', 'temperatura', 269.0000, 'ºC'),
	(183943, 122, '2014-02-01 00:04:15.000000', 'temperatura', 667.0000, 'ºC'),
	(183944, 122, '2014-02-01 00:04:16.000000', 'temperatura', 128.0000, 'ºC'),
	(183945, 122, '2014-02-01 00:04:17.000000', 'temperatura', 1040.0000, 'ºC'),
	(183946, 122, '2014-02-01 00:04:18.000000', 'temperatura', 17.0000, 'ºC'),
	(183947, 122, '2014-02-01 00:04:19.000000', 'temperatura', 563.0000, 'ºC'),
	(183948, 122, '2014-02-01 00:04:20.000000', 'temperatura', 368.0000, 'ºC'),
	(183949, 122, '2014-02-01 00:04:21.000000', 'temperatura', 149.0000, 'ºC'),
	(183950, 122, '2014-02-01 00:04:22.000000', 'temperatura', 843.0000, 'ºC'),
	(183951, 122, '2014-02-01 00:04:23.000000', 'temperatura', 166.0000, 'ºC'),
	(183952, 122, '2014-02-01 00:04:24.000000', 'temperatura', 705.0000, 'ºC'),
	(183953, 122, '2014-02-01 00:04:25.000000', 'temperatura', 625.0000, 'ºC'),
	(183954, 122, '2014-02-01 00:04:26.000000', 'temperatura', 1011.0000, 'ºC'),
	(183955, 122, '2014-02-01 00:04:27.000000', 'temperatura', 780.0000, 'ºC'),
	(183956, 122, '2014-02-01 00:04:28.000000', 'temperatura', 868.0000, 'ºC'),
	(183957, 122, '2014-02-01 00:04:29.000000', 'temperatura', 801.0000, 'ºC'),
	(183958, 122, '2014-02-01 00:04:30.000000', 'temperatura', 201.0000, 'ºC'),
	(183959, 122, '2014-02-01 00:04:31.000000', 'temperatura', 1001.0000, 'ºC'),
	(183960, 122, '2014-02-01 00:04:32.000000', 'temperatura', 802.0000, 'ºC'),
	(183961, 122, '2014-02-01 00:04:33.000000', 'temperatura', 1009.0000, 'ºC'),
	(183962, 122, '2014-02-01 00:04:34.000000', 'temperatura', 239.0000, 'ºC'),
	(183963, 122, '2014-02-01 00:04:35.000000', 'temperatura', 567.0000, 'ºC'),
	(183964, 122, '2014-02-01 00:04:36.000000', 'temperatura', 918.0000, 'ºC'),
	(183965, 122, '2014-02-01 00:04:37.000000', 'temperatura', 491.0000, 'ºC'),
	(183966, 122, '2014-02-01 00:04:38.000000', 'temperatura', 902.0000, 'ºC'),
	(183967, 122, '2014-02-01 00:04:39.000000', 'temperatura', 637.0000, 'ºC'),
	(183968, 122, '2014-02-01 00:04:40.000000', 'temperatura', 481.0000, 'ºC'),
	(183969, 122, '2014-02-01 00:04:41.000000', 'temperatura', 492.0000, 'ºC'),
	(183970, 122, '2014-02-01 00:04:42.000000', 'temperatura', 1017.0000, 'ºC'),
	(183971, 122, '2014-02-01 00:04:43.000000', 'temperatura', 9.0000, 'ºC'),
	(183972, 122, '2014-02-01 00:04:44.000000', 'temperatura', 595.0000, 'ºC'),
	(183973, 122, '2014-02-01 00:04:45.000000', 'temperatura', 548.0000, 'ºC'),
	(183974, 122, '2014-02-01 00:04:46.000000', 'temperatura', 955.0000, 'ºC'),
	(183975, 122, '2014-02-01 00:04:47.000000', 'temperatura', 734.0000, 'ºC'),
	(183976, 122, '2014-02-01 00:04:48.000000', 'temperatura', 803.0000, 'ºC'),
	(183977, 122, '2014-02-01 00:04:49.000000', 'temperatura', 614.0000, 'ºC'),
	(183978, 122, '2014-02-01 00:04:50.000000', 'temperatura', 663.0000, 'ºC'),
	(183979, 122, '2014-02-01 00:04:51.000000', 'temperatura', 271.0000, 'ºC'),
	(183980, 122, '2014-02-01 00:04:52.000000', 'temperatura', 568.0000, 'ºC'),
	(183981, 122, '2014-02-01 00:04:53.000000', 'temperatura', 828.0000, 'ºC'),
	(183982, 122, '2014-02-01 00:04:54.000000', 'temperatura', 37.0000, 'ºC'),
	(183983, 122, '2014-02-01 00:04:55.000000', 'temperatura', 99.0000, 'ºC'),
	(183984, 122, '2014-02-01 00:04:56.000000', 'temperatura', 387.0000, 'ºC'),
	(183985, 122, '2014-02-01 00:04:57.000000', 'temperatura', 436.0000, 'ºC'),
	(183986, 122, '2014-02-01 00:04:58.000000', 'temperatura', 1022.0000, 'ºC'),
	(183987, 122, '2014-02-01 00:04:59.000000', 'temperatura', 200.0000, 'ºC'),
	(183988, 122, '2014-02-01 00:05:00.000000', 'temperatura', 337.0000, 'ºC'),
	(183989, 122, '2014-02-01 00:05:01.000000', 'temperatura', 1083.0000, 'ºC'),
	(183990, 122, '2014-02-01 00:05:02.000000', 'temperatura', 804.0000, 'ºC'),
	(183991, 122, '2014-02-01 00:05:03.000000', 'temperatura', 772.0000, 'ºC'),
	(183992, 122, '2014-02-01 00:05:04.000000', 'temperatura', 248.0000, 'ºC'),
	(183993, 122, '2014-02-01 00:05:05.000000', 'temperatura', 124.0000, 'ºC'),
	(183994, 122, '2014-02-01 00:05:06.000000', 'temperatura', 1079.0000, 'ºC'),
	(183995, 122, '2014-02-01 00:05:07.000000', 'temperatura', 223.0000, 'ºC'),
	(183996, 122, '2014-02-01 00:05:08.000000', 'temperatura', 278.0000, 'ºC'),
	(183997, 122, '2014-02-01 00:05:09.000000', 'temperatura', 720.0000, 'ºC'),
	(183998, 122, '2014-02-01 00:05:10.000000', 'temperatura', 366.0000, 'ºC'),
	(183999, 122, '2014-02-01 00:05:11.000000', 'temperatura', 872.0000, 'ºC'),
	(184000, 122, '2014-02-01 00:05:12.000000', 'temperatura', 864.0000, 'ºC'),
	(184001, 122, '2014-02-01 00:05:13.000000', 'temperatura', 503.0000, 'ºC'),
	(184002, 122, '2014-02-01 00:05:14.000000', 'temperatura', 1125.0000, 'ºC'),
	(184003, 122, '2014-02-01 00:05:15.000000', 'temperatura', 516.0000, 'ºC'),
	(184004, 122, '2014-02-01 00:05:16.000000', 'temperatura', 403.0000, 'ºC'),
	(184005, 122, '2014-02-01 00:05:17.000000', 'temperatura', 471.0000, 'ºC'),
	(184006, 122, '2014-02-01 00:05:18.000000', 'temperatura', 1144.0000, 'ºC'),
	(184007, 122, '2014-02-01 00:05:19.000000', 'temperatura', 707.0000, 'ºC'),
	(184008, 122, '2014-02-01 00:05:20.000000', 'temperatura', 106.0000, 'ºC'),
	(184009, 122, '2014-02-01 00:05:21.000000', 'temperatura', 809.0000, 'ºC'),
	(184010, 122, '2014-02-01 00:05:22.000000', 'temperatura', 129.0000, 'ºC'),
	(184011, 122, '2014-02-01 00:05:23.000000', 'temperatura', 615.0000, 'ºC'),
	(184012, 122, '2014-02-01 00:05:24.000000', 'temperatura', 290.0000, 'ºC'),
	(184013, 122, '2014-02-01 00:05:25.000000', 'temperatura', 807.0000, 'ºC'),
	(184014, 122, '2014-02-01 00:05:26.000000', 'temperatura', 766.0000, 'ºC'),
	(184015, 122, '2014-02-01 00:05:27.000000', 'temperatura', 207.0000, 'ºC'),
	(184016, 122, '2014-02-01 00:05:28.000000', 'temperatura', 1140.0000, 'ºC'),
	(184017, 122, '2014-02-01 00:05:29.000000', 'temperatura', 278.0000, 'ºC'),
	(184018, 122, '2014-02-01 00:05:30.000000', 'temperatura', 370.0000, 'ºC'),
	(184019, 122, '2014-02-01 00:05:31.000000', 'temperatura', 1017.0000, 'ºC'),
	(184020, 122, '2014-02-01 00:05:32.000000', 'temperatura', 373.0000, 'ºC'),
	(184021, 122, '2014-02-01 00:05:33.000000', 'temperatura', 18.0000, 'ºC'),
	(184022, 122, '2014-02-01 00:05:34.000000', 'temperatura', 171.0000, 'ºC'),
	(184023, 122, '2014-02-01 00:05:35.000000', 'temperatura', 803.0000, 'ºC'),
	(184024, 122, '2014-02-01 00:05:36.000000', 'temperatura', 1099.0000, 'ºC'),
	(184025, 122, '2014-02-01 00:05:37.000000', 'temperatura', 689.0000, 'ºC'),
	(184026, 122, '2014-02-01 00:05:38.000000', 'temperatura', 148.0000, 'ºC'),
	(184027, 122, '2014-02-01 00:05:39.000000', 'temperatura', 1074.0000, 'ºC'),
	(184028, 122, '2014-02-01 00:05:40.000000', 'temperatura', 125.0000, 'ºC'),
	(184029, 122, '2014-02-01 00:05:41.000000', 'temperatura', 1004.0000, 'ºC'),
	(184030, 122, '2014-02-01 00:05:42.000000', 'temperatura', 1046.0000, 'ºC'),
	(184031, 122, '2014-02-01 00:05:43.000000', 'temperatura', 1016.0000, 'ºC'),
	(184032, 122, '2014-02-01 00:05:44.000000', 'temperatura', 745.0000, 'ºC'),
	(184033, 122, '2014-02-01 00:05:45.000000', 'temperatura', 675.0000, 'ºC'),
	(184034, 122, '2014-02-01 00:05:46.000000', 'temperatura', 1142.0000, 'ºC'),
	(184035, 122, '2014-02-01 00:05:47.000000', 'temperatura', 84.0000, 'ºC'),
	(184036, 122, '2014-02-01 00:05:48.000000', 'temperatura', 597.0000, 'ºC'),
	(184037, 122, '2014-02-01 00:05:49.000000', 'temperatura', 331.0000, 'ºC'),
	(184038, 122, '2014-02-01 00:05:50.000000', 'temperatura', 1067.0000, 'ºC'),
	(184039, 122, '2014-02-01 00:05:51.000000', 'temperatura', 740.0000, 'ºC'),
	(184040, 122, '2014-02-01 00:05:52.000000', 'temperatura', 501.0000, 'ºC'),
	(184041, 122, '2014-02-01 00:05:53.000000', 'temperatura', 287.0000, 'ºC'),
	(184042, 122, '2014-02-01 00:05:54.000000', 'temperatura', 1130.0000, 'ºC'),
	(184043, 122, '2014-02-01 00:05:55.000000', 'temperatura', 1189.0000, 'ºC'),
	(184044, 122, '2014-02-01 00:05:56.000000', 'temperatura', 157.0000, 'ºC'),
	(184045, 122, '2014-02-01 00:05:57.000000', 'temperatura', 816.0000, 'ºC'),
	(184046, 122, '2014-02-01 00:05:58.000000', 'temperatura', 12.0000, 'ºC'),
	(184047, 122, '2014-02-01 00:05:59.000000', 'temperatura', 13.0000, 'ºC'),
	(184048, 122, '2014-02-01 00:06:00.000000', 'temperatura', 30.0000, 'ºC'),
	(184049, 122, '2014-02-01 00:06:01.000000', 'temperatura', 110.0000, 'ºC'),
	(184050, 122, '2014-02-01 00:06:02.000000', 'temperatura', 460.0000, 'ºC'),
	(184051, 122, '2014-02-01 00:06:03.000000', 'temperatura', 773.0000, 'ºC'),
	(184052, 122, '2014-02-01 00:06:04.000000', 'temperatura', 82.0000, 'ºC'),
	(184053, 122, '2014-02-01 00:06:05.000000', 'temperatura', 494.0000, 'ºC'),
	(184054, 122, '2014-02-01 00:06:06.000000', 'temperatura', 1024.0000, 'ºC'),
	(184055, 122, '2014-02-01 00:06:07.000000', 'temperatura', 37.0000, 'ºC'),
	(184056, 122, '2014-02-01 00:06:08.000000', 'temperatura', 716.0000, 'ºC'),
	(184057, 122, '2014-02-01 00:06:09.000000', 'temperatura', 1069.0000, 'ºC'),
	(184058, 122, '2014-02-01 00:06:10.000000', 'temperatura', 796.0000, 'ºC'),
	(184059, 122, '2014-02-01 00:06:11.000000', 'temperatura', 774.0000, 'ºC'),
	(184060, 122, '2014-02-01 00:06:12.000000', 'temperatura', 283.0000, 'ºC'),
	(184061, 122, '2014-02-01 00:06:13.000000', 'temperatura', 292.0000, 'ºC'),
	(184062, 122, '2014-02-01 00:06:14.000000', 'temperatura', 611.0000, 'ºC'),
	(184063, 122, '2014-02-01 00:06:15.000000', 'temperatura', 979.0000, 'ºC'),
	(184064, 122, '2014-02-01 00:06:16.000000', 'temperatura', 662.0000, 'ºC'),
	(184065, 122, '2014-02-01 00:06:17.000000', 'temperatura', 374.0000, 'ºC'),
	(184066, 122, '2014-02-01 00:06:18.000000', 'temperatura', 1086.0000, 'ºC'),
	(184067, 122, '2014-02-01 00:06:19.000000', 'temperatura', 708.0000, 'ºC'),
	(184068, 122, '2014-02-01 00:06:20.000000', 'temperatura', 281.0000, 'ºC'),
	(184069, 122, '2014-02-01 00:06:21.000000', 'temperatura', 482.0000, 'ºC'),
	(184070, 122, '2014-02-01 00:06:22.000000', 'temperatura', 368.0000, 'ºC'),
	(184071, 122, '2014-02-01 00:06:23.000000', 'temperatura', 396.0000, 'ºC'),
	(184072, 122, '2014-02-01 00:06:24.000000', 'temperatura', 877.0000, 'ºC'),
	(184073, 122, '2014-02-01 00:06:25.000000', 'temperatura', 796.0000, 'ºC'),
	(184074, 122, '2014-02-01 00:06:26.000000', 'temperatura', 150.0000, 'ºC'),
	(184075, 122, '2014-02-01 00:06:27.000000', 'temperatura', 761.0000, 'ºC'),
	(184076, 122, '2014-02-01 00:06:28.000000', 'temperatura', 955.0000, 'ºC'),
	(184077, 122, '2014-02-01 00:06:29.000000', 'temperatura', 93.0000, 'ºC'),
	(184078, 122, '2014-02-01 00:06:30.000000', 'temperatura', 0.0000, 'ºC'),
	(184079, 122, '2014-02-01 00:06:31.000000', 'temperatura', 924.0000, 'ºC'),
	(184080, 122, '2014-02-01 00:06:32.000000', 'temperatura', 1020.0000, 'ºC'),
	(184081, 122, '2014-02-01 00:06:33.000000', 'temperatura', 1128.0000, 'ºC'),
	(184082, 122, '2014-02-01 00:06:34.000000', 'temperatura', 182.0000, 'ºC'),
	(184083, 122, '2014-02-01 00:06:35.000000', 'temperatura', 1126.0000, 'ºC'),
	(184084, 122, '2014-02-01 00:06:36.000000', 'temperatura', 283.0000, 'ºC'),
	(184085, 122, '2014-02-01 00:06:37.000000', 'temperatura', 438.0000, 'ºC'),
	(184086, 122, '2014-02-01 00:06:38.000000', 'temperatura', 143.0000, 'ºC'),
	(184087, 122, '2014-02-01 00:06:39.000000', 'temperatura', 602.0000, 'ºC'),
	(184088, 122, '2014-02-01 00:06:40.000000', 'temperatura', 181.0000, 'ºC'),
	(184089, 122, '2014-02-01 00:06:41.000000', 'temperatura', 297.0000, 'ºC'),
	(184090, 122, '2014-02-01 00:06:42.000000', 'temperatura', 944.0000, 'ºC'),
	(184091, 122, '2014-02-01 00:06:43.000000', 'temperatura', 231.0000, 'ºC'),
	(184092, 122, '2014-02-01 00:06:44.000000', 'temperatura', 723.0000, 'ºC'),
	(184093, 122, '2014-02-01 00:06:45.000000', 'temperatura', 521.0000, 'ºC'),
	(184094, 122, '2014-02-01 00:06:46.000000', 'temperatura', 439.0000, 'ºC'),
	(184095, 122, '2014-02-01 00:06:47.000000', 'temperatura', 630.0000, 'ºC'),
	(184096, 122, '2014-02-01 00:06:48.000000', 'temperatura', 636.0000, 'ºC'),
	(184097, 122, '2014-02-01 00:06:49.000000', 'temperatura', 91.0000, 'ºC'),
	(184098, 122, '2014-02-01 00:06:50.000000', 'temperatura', 948.0000, 'ºC'),
	(184099, 122, '2014-02-01 00:06:51.000000', 'temperatura', 868.0000, 'ºC'),
	(184100, 122, '2014-02-01 00:06:52.000000', 'temperatura', 294.0000, 'ºC'),
	(184101, 122, '2014-02-01 00:06:53.000000', 'temperatura', 68.0000, 'ºC'),
	(184102, 122, '2014-02-01 00:06:54.000000', 'temperatura', 658.0000, 'ºC'),
	(184103, 122, '2014-02-01 00:06:55.000000', 'temperatura', 687.0000, 'ºC'),
	(184104, 122, '2014-02-01 00:06:56.000000', 'temperatura', 261.0000, 'ºC'),
	(184105, 122, '2014-02-01 00:06:57.000000', 'temperatura', 445.0000, 'ºC'),
	(184106, 122, '2014-02-01 00:06:58.000000', 'temperatura', 243.0000, 'ºC'),
	(184107, 122, '2014-02-01 00:06:59.000000', 'temperatura', 1079.0000, 'ºC'),
	(184108, 122, '2014-02-01 00:07:00.000000', 'temperatura', 1067.0000, 'ºC'),
	(184109, 122, '2014-02-01 00:07:01.000000', 'temperatura', 897.0000, 'ºC'),
	(184110, 122, '2014-02-01 00:07:02.000000', 'temperatura', 84.0000, 'ºC'),
	(184111, 122, '2014-02-01 00:07:03.000000', 'temperatura', 133.0000, 'ºC'),
	(184112, 122, '2014-02-01 00:07:04.000000', 'temperatura', 411.0000, 'ºC'),
	(184113, 122, '2014-02-01 00:07:05.000000', 'temperatura', 457.0000, 'ºC'),
	(184114, 122, '2014-02-01 00:07:06.000000', 'temperatura', 1051.0000, 'ºC'),
	(184115, 122, '2014-02-01 00:07:07.000000', 'temperatura', 286.0000, 'ºC'),
	(184116, 122, '2014-02-01 00:07:08.000000', 'temperatura', 677.0000, 'ºC'),
	(184117, 122, '2014-02-01 00:07:09.000000', 'temperatura', 127.0000, 'ºC'),
	(184118, 122, '2014-02-01 00:07:10.000000', 'temperatura', 1005.0000, 'ºC'),
	(184119, 122, '2014-02-01 00:07:11.000000', 'temperatura', 1043.0000, 'ºC'),
	(184120, 122, '2014-02-01 00:07:12.000000', 'temperatura', 1000.0000, 'ºC'),
	(184121, 122, '2014-02-01 00:07:13.000000', 'temperatura', 673.0000, 'ºC'),
	(184122, 122, '2014-02-01 00:07:14.000000', 'temperatura', 364.0000, 'ºC'),
	(184123, 122, '2014-02-01 00:07:15.000000', 'temperatura', 1002.0000, 'ºC'),
	(184124, 122, '2014-02-01 00:07:16.000000', 'temperatura', 317.0000, 'ºC'),
	(184125, 122, '2014-02-01 00:07:17.000000', 'temperatura', 979.0000, 'ºC'),
	(184126, 122, '2014-02-01 00:07:18.000000', 'temperatura', 345.0000, 'ºC'),
	(184127, 122, '2014-02-01 00:07:19.000000', 'temperatura', 1191.0000, 'ºC'),
	(184128, 122, '2014-02-01 00:07:20.000000', 'temperatura', 119.0000, 'ºC'),
	(184129, 122, '2014-02-01 00:07:21.000000', 'temperatura', 623.0000, 'ºC'),
	(184130, 122, '2014-02-01 00:07:22.000000', 'temperatura', 358.0000, 'ºC'),
	(184131, 122, '2014-02-01 00:07:23.000000', 'temperatura', 1120.0000, 'ºC'),
	(184132, 122, '2014-02-01 00:07:24.000000', 'temperatura', 929.0000, 'ºC'),
	(184133, 122, '2014-02-01 00:07:25.000000', 'temperatura', 85.0000, 'ºC'),
	(184134, 122, '2014-02-01 00:07:26.000000', 'temperatura', 39.0000, 'ºC'),
	(184135, 122, '2014-02-01 00:07:27.000000', 'temperatura', 1140.0000, 'ºC'),
	(184136, 122, '2014-02-01 00:07:28.000000', 'temperatura', 783.0000, 'ºC'),
	(184137, 122, '2014-02-01 00:07:29.000000', 'temperatura', 495.0000, 'ºC'),
	(184138, 122, '2014-02-01 00:07:30.000000', 'temperatura', 128.0000, 'ºC'),
	(184139, 122, '2014-02-01 00:07:31.000000', 'temperatura', 354.0000, 'ºC'),
	(184140, 122, '2014-02-01 00:07:32.000000', 'temperatura', 188.0000, 'ºC'),
	(184141, 122, '2014-02-01 00:07:33.000000', 'temperatura', 1078.0000, 'ºC'),
	(184142, 122, '2014-02-01 00:07:34.000000', 'temperatura', 28.0000, 'ºC'),
	(184143, 122, '2014-02-01 00:07:35.000000', 'temperatura', 505.0000, 'ºC'),
	(184144, 122, '2014-02-01 00:07:36.000000', 'temperatura', 42.0000, 'ºC'),
	(184145, 122, '2014-02-01 00:07:37.000000', 'temperatura', 1094.0000, 'ºC'),
	(184146, 122, '2014-02-01 00:07:38.000000', 'temperatura', 545.0000, 'ºC'),
	(184147, 122, '2014-02-01 00:07:39.000000', 'temperatura', 644.0000, 'ºC'),
	(184148, 122, '2014-02-01 00:07:40.000000', 'temperatura', 386.0000, 'ºC'),
	(184149, 122, '2014-02-01 00:07:41.000000', 'temperatura', 1198.0000, 'ºC'),
	(184150, 122, '2014-02-01 00:07:42.000000', 'temperatura', 32.0000, 'ºC'),
	(184151, 122, '2014-02-01 00:07:43.000000', 'temperatura', 168.0000, 'ºC'),
	(184152, 122, '2014-02-01 00:07:44.000000', 'temperatura', 742.0000, 'ºC'),
	(184153, 122, '2014-02-01 00:07:45.000000', 'temperatura', 810.0000, 'ºC'),
	(184154, 122, '2014-02-01 00:07:46.000000', 'temperatura', 622.0000, 'ºC'),
	(184155, 122, '2014-02-01 00:07:47.000000', 'temperatura', 680.0000, 'ºC'),
	(184156, 122, '2014-02-01 00:07:48.000000', 'temperatura', 335.0000, 'ºC'),
	(184157, 122, '2014-02-01 00:07:49.000000', 'temperatura', 838.0000, 'ºC'),
	(184158, 122, '2014-02-01 00:07:50.000000', 'temperatura', 782.0000, 'ºC'),
	(184159, 122, '2014-02-01 00:07:51.000000', 'temperatura', 199.0000, 'ºC'),
	(184160, 122, '2014-02-01 00:07:52.000000', 'temperatura', 1050.0000, 'ºC'),
	(184161, 122, '2014-02-01 00:07:53.000000', 'temperatura', 1053.0000, 'ºC'),
	(184162, 122, '2014-02-01 00:07:54.000000', 'temperatura', 917.0000, 'ºC'),
	(184163, 122, '2014-02-01 00:07:55.000000', 'temperatura', 225.0000, 'ºC'),
	(184164, 122, '2014-02-01 00:07:56.000000', 'temperatura', 773.0000, 'ºC'),
	(184165, 122, '2014-02-01 00:07:57.000000', 'temperatura', 793.0000, 'ºC'),
	(184166, 122, '2014-02-01 00:07:58.000000', 'temperatura', 444.0000, 'ºC'),
	(184167, 122, '2014-02-01 00:07:59.000000', 'temperatura', 1041.0000, 'ºC'),
	(184168, 122, '2014-02-01 00:08:00.000000', 'temperatura', 274.0000, 'ºC'),
	(184169, 122, '2014-02-01 00:08:01.000000', 'temperatura', 647.0000, 'ºC'),
	(184170, 122, '2014-02-01 00:08:02.000000', 'temperatura', 12.0000, 'ºC'),
	(184171, 122, '2014-02-01 00:08:03.000000', 'temperatura', 522.0000, 'ºC'),
	(184172, 122, '2014-02-01 00:08:04.000000', 'temperatura', 173.0000, 'ºC'),
	(184173, 122, '2014-02-01 00:08:05.000000', 'temperatura', 499.0000, 'ºC'),
	(184174, 122, '2014-02-01 00:08:06.000000', 'temperatura', 779.0000, 'ºC'),
	(184175, 122, '2014-02-01 00:08:07.000000', 'temperatura', 1198.0000, 'ºC'),
	(184176, 122, '2014-02-01 00:08:08.000000', 'temperatura', 53.0000, 'ºC'),
	(184177, 122, '2014-02-01 00:08:09.000000', 'temperatura', 271.0000, 'ºC'),
	(184178, 122, '2014-02-01 00:08:10.000000', 'temperatura', 1198.0000, 'ºC'),
	(184179, 122, '2014-02-01 00:08:11.000000', 'temperatura', 379.0000, 'ºC'),
	(184180, 122, '2014-02-01 00:08:12.000000', 'temperatura', 698.0000, 'ºC'),
	(184181, 122, '2014-02-01 00:08:13.000000', 'temperatura', 1156.0000, 'ºC'),
	(184182, 122, '2014-02-01 00:08:14.000000', 'temperatura', 87.0000, 'ºC'),
	(184183, 122, '2014-02-01 00:08:15.000000', 'temperatura', 567.0000, 'ºC'),
	(184184, 122, '2014-02-01 00:08:16.000000', 'temperatura', 173.0000, 'ºC'),
	(184185, 122, '2014-02-01 00:08:17.000000', 'temperatura', 367.0000, 'ºC'),
	(184186, 122, '2014-02-01 00:08:18.000000', 'temperatura', 115.0000, 'ºC'),
	(184187, 122, '2014-02-01 00:08:19.000000', 'temperatura', 674.0000, 'ºC'),
	(184188, 122, '2014-02-01 00:08:20.000000', 'temperatura', 627.0000, 'ºC'),
	(184189, 122, '2014-02-01 00:08:21.000000', 'temperatura', 1114.0000, 'ºC'),
	(184190, 122, '2014-02-01 00:08:22.000000', 'temperatura', 88.0000, 'ºC'),
	(184191, 122, '2014-02-01 00:08:23.000000', 'temperatura', 698.0000, 'ºC'),
	(184192, 122, '2014-02-01 00:08:24.000000', 'temperatura', 826.0000, 'ºC'),
	(184193, 122, '2014-02-01 00:08:25.000000', 'temperatura', 836.0000, 'ºC'),
	(184194, 122, '2014-02-01 00:08:26.000000', 'temperatura', 504.0000, 'ºC'),
	(184195, 122, '2014-02-01 00:08:27.000000', 'temperatura', 14.0000, 'ºC'),
	(184196, 122, '2014-02-01 00:08:28.000000', 'temperatura', 956.0000, 'ºC'),
	(184197, 122, '2014-02-01 00:08:29.000000', 'temperatura', 1141.0000, 'ºC'),
	(184198, 122, '2014-02-01 00:08:30.000000', 'temperatura', 438.0000, 'ºC'),
	(184199, 122, '2014-02-01 00:08:31.000000', 'temperatura', 1165.0000, 'ºC'),
	(184200, 122, '2014-02-01 00:08:32.000000', 'temperatura', 911.0000, 'ºC'),
	(184201, 122, '2014-02-01 00:08:33.000000', 'temperatura', 1062.0000, 'ºC'),
	(184202, 122, '2014-02-01 00:08:34.000000', 'temperatura', 179.0000, 'ºC'),
	(184203, 122, '2014-02-01 00:08:35.000000', 'temperatura', 107.0000, 'ºC'),
	(184204, 122, '2014-02-01 00:08:36.000000', 'temperatura', 1198.0000, 'ºC'),
	(184205, 122, '2014-02-01 00:08:37.000000', 'temperatura', 870.0000, 'ºC'),
	(184206, 122, '2014-02-01 00:08:38.000000', 'temperatura', 759.0000, 'ºC'),
	(184207, 122, '2014-02-01 00:08:39.000000', 'temperatura', 1183.0000, 'ºC'),
	(184208, 122, '2014-02-01 00:08:40.000000', 'temperatura', 38.0000, 'ºC'),
	(184209, 122, '2014-02-01 00:08:41.000000', 'temperatura', 241.0000, 'ºC'),
	(184210, 122, '2014-02-01 00:08:42.000000', 'temperatura', 1094.0000, 'ºC'),
	(184211, 122, '2014-02-01 00:08:43.000000', 'temperatura', 1145.0000, 'ºC'),
	(184212, 122, '2014-02-01 00:08:44.000000', 'temperatura', 43.0000, 'ºC'),
	(184213, 122, '2014-02-01 00:08:45.000000', 'temperatura', 382.0000, 'ºC'),
	(184214, 122, '2014-02-01 00:08:46.000000', 'temperatura', 580.0000, 'ºC'),
	(184215, 122, '2014-02-01 00:08:47.000000', 'temperatura', 556.0000, 'ºC'),
	(184216, 122, '2014-02-01 00:08:48.000000', 'temperatura', 1041.0000, 'ºC'),
	(184217, 122, '2014-02-01 00:08:49.000000', 'temperatura', 1135.0000, 'ºC'),
	(184218, 122, '2014-02-01 00:08:50.000000', 'temperatura', 154.0000, 'ºC'),
	(184219, 122, '2014-02-01 00:08:51.000000', 'temperatura', 963.0000, 'ºC'),
	(184220, 122, '2014-02-01 00:08:52.000000', 'temperatura', 757.0000, 'ºC'),
	(184221, 122, '2014-02-01 00:08:53.000000', 'temperatura', 893.0000, 'ºC'),
	(184222, 122, '2014-02-01 00:08:54.000000', 'temperatura', 997.0000, 'ºC'),
	(184223, 122, '2014-02-01 00:08:55.000000', 'temperatura', 1105.0000, 'ºC'),
	(184224, 122, '2014-02-01 00:08:56.000000', 'temperatura', 134.0000, 'ºC'),
	(184225, 122, '2014-02-01 00:08:57.000000', 'temperatura', 957.0000, 'ºC'),
	(184226, 122, '2014-02-01 00:08:58.000000', 'temperatura', 784.0000, 'ºC'),
	(184227, 122, '2014-02-01 00:08:59.000000', 'temperatura', 1047.0000, 'ºC'),
	(184228, 122, '2014-02-01 00:09:00.000000', 'temperatura', 483.0000, 'ºC'),
	(184229, 122, '2014-02-01 00:09:01.000000', 'temperatura', 477.0000, 'ºC'),
	(184230, 122, '2014-02-01 00:09:02.000000', 'temperatura', 934.0000, 'ºC'),
	(184231, 122, '2014-02-01 00:09:03.000000', 'temperatura', 842.0000, 'ºC'),
	(184232, 122, '2014-02-01 00:09:04.000000', 'temperatura', 209.0000, 'ºC'),
	(184233, 122, '2014-02-01 00:09:05.000000', 'temperatura', 917.0000, 'ºC'),
	(184234, 122, '2014-02-01 00:09:06.000000', 'temperatura', 360.0000, 'ºC'),
	(184235, 122, '2014-02-01 00:09:07.000000', 'temperatura', 248.0000, 'ºC'),
	(184236, 122, '2014-02-01 00:09:08.000000', 'temperatura', 160.0000, 'ºC'),
	(184237, 122, '2014-02-01 00:09:09.000000', 'temperatura', 58.0000, 'ºC'),
	(184238, 122, '2014-02-01 00:09:10.000000', 'temperatura', 1011.0000, 'ºC'),
	(184239, 122, '2014-02-01 00:09:11.000000', 'temperatura', 81.0000, 'ºC'),
	(184240, 122, '2014-02-01 00:09:12.000000', 'temperatura', 971.0000, 'ºC'),
	(184241, 122, '2014-02-01 00:09:13.000000', 'temperatura', 1015.0000, 'ºC'),
	(184242, 122, '2014-02-01 00:09:14.000000', 'temperatura', 960.0000, 'ºC'),
	(184243, 122, '2014-02-01 00:09:15.000000', 'temperatura', 557.0000, 'ºC'),
	(184244, 122, '2014-02-01 00:09:16.000000', 'temperatura', 1104.0000, 'ºC'),
	(184245, 122, '2014-02-01 00:09:17.000000', 'temperatura', 249.0000, 'ºC'),
	(184246, 122, '2014-02-01 00:09:18.000000', 'temperatura', 332.0000, 'ºC'),
	(184247, 122, '2014-02-01 00:09:19.000000', 'temperatura', 917.0000, 'ºC'),
	(184248, 122, '2014-02-01 00:09:20.000000', 'temperatura', 1187.0000, 'ºC'),
	(184249, 122, '2014-02-01 00:09:21.000000', 'temperatura', 787.0000, 'ºC'),
	(184250, 122, '2014-02-01 00:09:22.000000', 'temperatura', 375.0000, 'ºC'),
	(184251, 122, '2014-02-01 00:09:23.000000', 'temperatura', 712.0000, 'ºC'),
	(184252, 122, '2014-02-01 00:09:24.000000', 'temperatura', 38.0000, 'ºC'),
	(184253, 122, '2014-02-01 00:09:25.000000', 'temperatura', 455.0000, 'ºC'),
	(184254, 122, '2014-02-01 00:09:26.000000', 'temperatura', 958.0000, 'ºC'),
	(184255, 122, '2014-02-01 00:09:27.000000', 'temperatura', 1028.0000, 'ºC'),
	(184256, 122, '2014-02-01 00:09:28.000000', 'temperatura', 1068.0000, 'ºC'),
	(184257, 122, '2014-02-01 00:09:29.000000', 'temperatura', 1055.0000, 'ºC'),
	(184258, 122, '2014-02-01 00:09:30.000000', 'temperatura', 871.0000, 'ºC'),
	(184259, 122, '2014-02-01 00:09:31.000000', 'temperatura', 1190.0000, 'ºC'),
	(184260, 122, '2014-02-01 00:09:32.000000', 'temperatura', 938.0000, 'ºC'),
	(184261, 122, '2014-02-01 00:09:33.000000', 'temperatura', 1122.0000, 'ºC'),
	(184262, 122, '2014-02-01 00:09:34.000000', 'temperatura', 397.0000, 'ºC'),
	(184263, 122, '2014-02-01 00:09:35.000000', 'temperatura', 1016.0000, 'ºC'),
	(184264, 122, '2014-02-01 00:09:36.000000', 'temperatura', 293.0000, 'ºC'),
	(184265, 122, '2014-02-01 00:09:37.000000', 'temperatura', 815.0000, 'ºC'),
	(184266, 122, '2014-02-01 00:09:38.000000', 'temperatura', 798.0000, 'ºC'),
	(184267, 122, '2014-02-01 00:09:39.000000', 'temperatura', 345.0000, 'ºC'),
	(184268, 122, '2014-02-01 00:09:40.000000', 'temperatura', 533.0000, 'ºC'),
	(184269, 122, '2014-02-01 00:09:41.000000', 'temperatura', 428.0000, 'ºC'),
	(184270, 122, '2014-02-01 00:09:42.000000', 'temperatura', 544.0000, 'ºC'),
	(184271, 122, '2014-02-01 00:09:43.000000', 'temperatura', 234.0000, 'ºC'),
	(184272, 122, '2014-02-01 00:09:44.000000', 'temperatura', 741.0000, 'ºC'),
	(184273, 122, '2014-02-01 00:09:45.000000', 'temperatura', 603.0000, 'ºC'),
	(184274, 122, '2014-02-01 00:09:46.000000', 'temperatura', 791.0000, 'ºC'),
	(184275, 122, '2014-02-01 00:09:47.000000', 'temperatura', 949.0000, 'ºC'),
	(184276, 122, '2014-02-01 00:09:48.000000', 'temperatura', 1171.0000, 'ºC'),
	(184277, 122, '2014-02-01 00:09:49.000000', 'temperatura', 609.0000, 'ºC'),
	(184278, 122, '2014-02-01 00:09:50.000000', 'temperatura', 731.0000, 'ºC'),
	(184279, 122, '2014-02-01 00:09:51.000000', 'temperatura', 629.0000, 'ºC'),
	(184280, 122, '2014-02-01 00:09:52.000000', 'temperatura', 952.0000, 'ºC'),
	(184281, 122, '2014-02-01 00:09:53.000000', 'temperatura', 475.0000, 'ºC'),
	(184282, 122, '2014-02-01 00:09:54.000000', 'temperatura', 720.0000, 'ºC'),
	(184283, 122, '2014-02-01 00:09:55.000000', 'temperatura', 973.0000, 'ºC'),
	(184284, 122, '2014-02-01 00:09:56.000000', 'temperatura', 308.0000, 'ºC'),
	(184285, 122, '2014-02-01 00:09:57.000000', 'temperatura', 1022.0000, 'ºC'),
	(184286, 122, '2014-02-01 00:09:58.000000', 'temperatura', 583.0000, 'ºC'),
	(184287, 122, '2014-02-01 00:09:59.000000', 'temperatura', 1053.0000, 'ºC'),
	(184288, 122, '2014-02-01 00:10:00.000000', 'temperatura', 1116.0000, 'ºC'),
	(184289, 122, '2014-02-01 00:10:01.000000', 'temperatura', 19.0000, 'ºC'),
	(184290, 122, '2014-02-01 00:10:02.000000', 'temperatura', 350.0000, 'ºC'),
	(184291, 122, '2014-02-01 00:10:03.000000', 'temperatura', 494.0000, 'ºC'),
	(184292, 122, '2014-02-01 00:10:04.000000', 'temperatura', 221.0000, 'ºC'),
	(184293, 122, '2014-02-01 00:10:05.000000', 'temperatura', 822.0000, 'ºC'),
	(184294, 122, '2014-02-01 00:10:06.000000', 'temperatura', 1047.0000, 'ºC'),
	(184295, 122, '2014-02-01 00:10:07.000000', 'temperatura', 372.0000, 'ºC'),
	(184296, 122, '2014-02-01 00:10:08.000000', 'temperatura', 1118.0000, 'ºC'),
	(184297, 122, '2014-02-01 00:10:09.000000', 'temperatura', 875.0000, 'ºC'),
	(184298, 122, '2014-02-01 00:10:10.000000', 'temperatura', 1023.0000, 'ºC'),
	(184299, 122, '2014-02-01 00:10:11.000000', 'temperatura', 88.0000, 'ºC'),
	(184300, 122, '2014-02-01 00:10:12.000000', 'temperatura', 971.0000, 'ºC'),
	(184301, 122, '2014-02-01 00:10:13.000000', 'temperatura', 994.0000, 'ºC'),
	(184302, 122, '2014-02-01 00:10:14.000000', 'temperatura', 856.0000, 'ºC'),
	(184303, 122, '2014-02-01 00:10:15.000000', 'temperatura', 97.0000, 'ºC'),
	(184304, 122, '2014-02-01 00:10:16.000000', 'temperatura', 320.0000, 'ºC'),
	(184305, 122, '2014-02-01 00:10:17.000000', 'temperatura', 109.0000, 'ºC'),
	(184306, 122, '2014-02-01 00:10:18.000000', 'temperatura', 785.0000, 'ºC'),
	(184307, 122, '2014-02-01 00:10:19.000000', 'temperatura', 1197.0000, 'ºC'),
	(184308, 122, '2014-02-01 00:10:20.000000', 'temperatura', 31.0000, 'ºC'),
	(184309, 122, '2014-02-01 00:10:21.000000', 'temperatura', 167.0000, 'ºC'),
	(184310, 122, '2014-02-01 00:10:22.000000', 'temperatura', 740.0000, 'ºC'),
	(184311, 122, '2014-02-01 00:10:23.000000', 'temperatura', 801.0000, 'ºC'),
	(184312, 122, '2014-02-01 00:10:24.000000', 'temperatura', 584.0000, 'ºC'),
	(184313, 122, '2014-02-01 00:10:25.000000', 'temperatura', 517.0000, 'ºC'),
	(184314, 122, '2014-02-01 00:10:26.000000', 'temperatura', 834.0000, 'ºC'),
	(184315, 122, '2014-02-01 00:10:27.000000', 'temperatura', 218.0000, 'ºC'),
	(184316, 122, '2014-02-01 00:10:28.000000', 'temperatura', 988.0000, 'ºC'),
	(184317, 122, '2014-02-01 00:10:29.000000', 'temperatura', 690.0000, 'ºC'),
	(184318, 122, '2014-02-01 00:10:30.000000', 'temperatura', 484.0000, 'ºC'),
	(184319, 122, '2014-02-01 00:10:31.000000', 'temperatura', 350.0000, 'ºC'),
	(184320, 122, '2014-02-01 00:10:32.000000', 'temperatura', 301.0000, 'ºC'),
	(184321, 122, '2014-02-01 00:10:33.000000', 'temperatura', 455.0000, 'ºC'),
	(184322, 122, '2014-02-01 00:10:34.000000', 'temperatura', 171.0000, 'ºC'),
	(184323, 122, '2014-02-01 00:10:35.000000', 'temperatura', 690.0000, 'ºC'),
	(184324, 122, '2014-02-01 00:10:36.000000', 'temperatura', 538.0000, 'ºC'),
	(184325, 122, '2014-02-01 00:10:37.000000', 'temperatura', 619.0000, 'ºC'),
	(184326, 122, '2014-02-01 00:10:38.000000', 'temperatura', 283.0000, 'ºC'),
	(184327, 122, '2014-02-01 00:10:39.000000', 'temperatura', 757.0000, 'ºC'),
	(184328, 122, '2014-02-01 00:10:40.000000', 'temperatura', 539.0000, 'ºC'),
	(184329, 122, '2014-02-01 00:10:41.000000', 'temperatura', 422.0000, 'ºC'),
	(184330, 122, '2014-02-01 00:10:42.000000', 'temperatura', 496.0000, 'ºC'),
	(184331, 122, '2014-02-01 00:10:43.000000', 'temperatura', 12.0000, 'ºC'),
	(184332, 122, '2014-02-01 00:10:44.000000', 'temperatura', 974.0000, 'ºC'),
	(184333, 122, '2014-02-01 00:10:45.000000', 'temperatura', 36.0000, 'ºC'),
	(184334, 122, '2014-02-01 00:10:46.000000', 'temperatura', 857.0000, 'ºC'),
	(184335, 122, '2014-02-01 00:10:47.000000', 'temperatura', 577.0000, 'ºC'),
	(184336, 122, '2014-02-01 00:10:48.000000', 'temperatura', 317.0000, 'ºC'),
	(184337, 122, '2014-02-01 00:10:49.000000', 'temperatura', 1051.0000, 'ºC'),
	(184338, 122, '2014-02-01 00:10:50.000000', 'temperatura', 706.0000, 'ºC'),
	(184339, 122, '2014-02-01 00:10:51.000000', 'temperatura', 379.0000, 'ºC'),
	(184340, 122, '2014-02-01 00:10:52.000000', 'temperatura', 978.0000, 'ºC'),
	(184341, 122, '2014-02-01 00:10:53.000000', 'temperatura', 154.0000, 'ºC'),
	(184342, 122, '2014-02-01 00:10:54.000000', 'temperatura', 233.0000, 'ºC'),
	(184343, 122, '2014-02-01 00:10:55.000000', 'temperatura', 707.0000, 'ºC'),
	(184344, 122, '2014-02-01 00:10:56.000000', 'temperatura', 435.0000, 'ºC'),
	(184345, 122, '2014-02-01 00:10:57.000000', 'temperatura', 53.0000, 'ºC'),
	(184346, 122, '2014-02-01 00:10:58.000000', 'temperatura', 161.0000, 'ºC'),
	(184347, 122, '2014-02-01 00:10:59.000000', 'temperatura', 647.0000, 'ºC'),
	(184348, 122, '2014-02-01 00:11:00.000000', 'temperatura', 353.0000, 'ºC'),
	(184349, 122, '2014-02-01 00:11:01.000000', 'temperatura', 1024.0000, 'ºC'),
	(184350, 122, '2014-02-01 00:11:02.000000', 'temperatura', 461.0000, 'ºC'),
	(184351, 122, '2014-02-01 00:11:03.000000', 'temperatura', 434.0000, 'ºC'),
	(184352, 122, '2014-02-01 00:11:04.000000', 'temperatura', 788.0000, 'ºC'),
	(184353, 122, '2014-02-01 00:11:05.000000', 'temperatura', 236.0000, 'ºC'),
	(184354, 122, '2014-02-01 00:11:06.000000', 'temperatura', 19.0000, 'ºC'),
	(184355, 122, '2014-02-01 00:11:07.000000', 'temperatura', 588.0000, 'ºC'),
	(184356, 122, '2014-02-01 00:11:08.000000', 'temperatura', 482.0000, 'ºC'),
	(184357, 122, '2014-02-01 00:11:09.000000', 'temperatura', 645.0000, 'ºC'),
	(184358, 122, '2014-02-01 00:11:10.000000', 'temperatura', 582.0000, 'ºC'),
	(184359, 122, '2014-02-01 00:11:11.000000', 'temperatura', 974.0000, 'ºC'),
	(184360, 122, '2014-02-01 00:11:12.000000', 'temperatura', 723.0000, 'ºC'),
	(184361, 122, '2014-02-01 00:11:13.000000', 'temperatura', 696.0000, 'ºC'),
	(184362, 122, '2014-02-01 00:11:14.000000', 'temperatura', 110.0000, 'ºC'),
	(184363, 122, '2014-02-01 00:11:15.000000', 'temperatura', 862.0000, 'ºC'),
	(184364, 122, '2014-02-01 00:11:16.000000', 'temperatura', 383.0000, 'ºC'),
	(184365, 122, '2014-02-01 00:11:17.000000', 'temperatura', 526.0000, 'ºC'),
	(184366, 122, '2014-02-01 00:11:18.000000', 'temperatura', 284.0000, 'ºC'),
	(184367, 122, '2014-02-01 00:11:19.000000', 'temperatura', 1042.0000, 'ºC'),
	(184368, 122, '2014-02-01 00:11:20.000000', 'temperatura', 756.0000, 'ºC'),
	(184369, 122, '2014-02-01 00:11:21.000000', 'temperatura', 658.0000, 'ºC'),
	(184370, 122, '2014-02-01 00:11:22.000000', 'temperatura', 1022.0000, 'ºC'),
	(184371, 122, '2014-02-01 00:11:23.000000', 'temperatura', 737.0000, 'ºC'),
	(184372, 122, '2014-02-01 00:11:24.000000', 'temperatura', 620.0000, 'ºC'),
	(184373, 122, '2014-02-01 00:11:25.000000', 'temperatura', 889.0000, 'ºC'),
	(184374, 122, '2014-02-01 00:11:26.000000', 'temperatura', 185.0000, 'ºC'),
	(184375, 122, '2014-02-01 00:11:27.000000', 'temperatura', 657.0000, 'ºC'),
	(184376, 122, '2014-02-01 00:11:28.000000', 'temperatura', 330.0000, 'ºC'),
	(184377, 122, '2014-02-01 00:11:29.000000', 'temperatura', 882.0000, 'ºC'),
	(184378, 122, '2014-02-01 00:11:30.000000', 'temperatura', 1022.0000, 'ºC'),
	(184379, 122, '2014-02-01 00:11:31.000000', 'temperatura', 61.0000, 'ºC'),
	(184380, 122, '2014-02-01 00:11:32.000000', 'temperatura', 842.0000, 'ºC'),
	(184381, 122, '2014-02-01 00:11:33.000000', 'temperatura', 428.0000, 'ºC'),
	(184382, 122, '2014-02-01 00:11:34.000000', 'temperatura', 815.0000, 'ºC'),
	(184383, 122, '2014-02-01 00:11:35.000000', 'temperatura', 390.0000, 'ºC'),
	(184384, 122, '2014-02-01 00:11:36.000000', 'temperatura', 706.0000, 'ºC'),
	(184385, 122, '2014-02-01 00:11:37.000000', 'temperatura', 1162.0000, 'ºC'),
	(184386, 122, '2014-02-01 00:11:38.000000', 'temperatura', 90.0000, 'ºC'),
	(184387, 122, '2014-02-01 00:11:39.000000', 'temperatura', 565.0000, 'ºC'),
	(184388, 122, '2014-02-01 00:11:40.000000', 'temperatura', 156.0000, 'ºC'),
	(184389, 122, '2014-02-01 00:11:41.000000', 'temperatura', 284.0000, 'ºC'),
	(184390, 122, '2014-02-01 00:11:42.000000', 'temperatura', 955.0000, 'ºC'),
	(184391, 122, '2014-02-01 00:11:43.000000', 'temperatura', 323.0000, 'ºC'),
	(184392, 122, '2014-02-01 00:11:44.000000', 'temperatura', 1148.0000, 'ºC'),
	(184393, 122, '2014-02-01 00:11:45.000000', 'temperatura', 1174.0000, 'ºC'),
	(184394, 122, '2014-02-01 00:11:46.000000', 'temperatura', 28.0000, 'ºC'),
	(184395, 122, '2014-02-01 00:11:47.000000', 'temperatura', 216.0000, 'ºC'),
	(184396, 122, '2014-02-01 00:11:48.000000', 'temperatura', 997.0000, 'ºC'),
	(184397, 122, '2014-02-01 00:11:49.000000', 'temperatura', 739.0000, 'ºC'),
	(184398, 122, '2014-02-01 00:11:50.000000', 'temperatura', 702.0000, 'ºC'),
	(184399, 122, '2014-02-01 00:11:51.000000', 'temperatura', 96.0000, 'ºC'),
	(184400, 122, '2014-02-01 00:11:52.000000', 'temperatura', 772.0000, 'ºC'),
	(184401, 122, '2014-02-01 00:11:53.000000', 'temperatura', 1174.0000, 'ºC'),
	(184402, 122, '2014-02-01 00:11:54.000000', 'temperatura', 1155.0000, 'ºC'),
	(184403, 122, '2014-02-01 00:11:55.000000', 'temperatura', 1052.0000, 'ºC'),
	(184404, 122, '2014-02-01 00:11:56.000000', 'temperatura', 596.0000, 'ºC'),
	(184405, 122, '2014-02-01 00:11:57.000000', 'temperatura', 1023.0000, 'ºC'),
	(184406, 122, '2014-02-01 00:11:58.000000', 'temperatura', 930.0000, 'ºC'),
	(184407, 122, '2014-02-01 00:11:59.000000', 'temperatura', 382.0000, 'ºC'),
	(184408, 122, '2014-02-01 00:12:00.000000', 'temperatura', 320.0000, 'ºC'),
	(184409, 122, '2014-02-01 00:12:01.000000', 'temperatura', 456.0000, 'ºC'),
	(184410, 122, '2014-02-01 00:12:02.000000', 'temperatura', 119.0000, 'ºC'),
	(184411, 122, '2014-02-01 00:12:03.000000', 'temperatura', 428.0000, 'ºC'),
	(184412, 122, '2014-02-01 00:12:04.000000', 'temperatura', 582.0000, 'ºC'),
	(184413, 122, '2014-02-01 00:12:05.000000', 'temperatura', 426.0000, 'ºC'),
	(184414, 122, '2014-02-01 00:12:06.000000', 'temperatura', 385.0000, 'ºC'),
	(184415, 122, '2014-02-01 00:12:07.000000', 'temperatura', 650.0000, 'ºC'),
	(184416, 122, '2014-02-01 00:12:08.000000', 'temperatura', 893.0000, 'ºC'),
	(184417, 122, '2014-02-01 00:12:09.000000', 'temperatura', 118.0000, 'ºC'),
	(184418, 122, '2014-02-01 00:12:10.000000', 'temperatura', 311.0000, 'ºC'),
	(184419, 122, '2014-02-01 00:12:11.000000', 'temperatura', 2.0000, 'ºC'),
	(184420, 122, '2014-02-01 00:12:12.000000', 'temperatura', 276.0000, 'ºC'),
	(184421, 122, '2014-02-01 00:12:13.000000', 'temperatura', 173.0000, 'ºC'),
	(184422, 122, '2014-02-01 00:12:14.000000', 'temperatura', 39.0000, 'ºC'),
	(184423, 122, '2014-02-01 00:12:15.000000', 'temperatura', 877.0000, 'ºC'),
	(184424, 122, '2014-02-01 00:12:16.000000', 'temperatura', 669.0000, 'ºC'),
	(184425, 122, '2014-02-01 00:12:17.000000', 'temperatura', 714.0000, 'ºC'),
	(184426, 122, '2014-02-01 00:12:18.000000', 'temperatura', 362.0000, 'ºC'),
	(184427, 122, '2014-02-01 00:12:19.000000', 'temperatura', 869.0000, 'ºC'),
	(184428, 122, '2014-02-01 00:12:20.000000', 'temperatura', 858.0000, 'ºC'),
	(184429, 122, '2014-02-01 00:12:21.000000', 'temperatura', 484.0000, 'ºC'),
	(184430, 122, '2014-02-01 00:12:22.000000', 'temperatura', 1045.0000, 'ºC'),
	(184431, 122, '2014-02-01 00:12:23.000000', 'temperatura', 177.0000, 'ºC'),
	(184432, 122, '2014-02-01 00:12:24.000000', 'temperatura', 147.0000, 'ºC'),
	(184433, 122, '2014-02-01 00:12:25.000000', 'temperatura', 207.0000, 'ºC'),
	(184434, 122, '2014-02-01 00:12:26.000000', 'temperatura', 596.0000, 'ºC'),
	(184435, 122, '2014-02-01 00:12:27.000000', 'temperatura', 1158.0000, 'ºC'),
	(184436, 122, '2014-02-01 00:12:28.000000', 'temperatura', 400.0000, 'ºC'),
	(184437, 122, '2014-02-01 00:12:29.000000', 'temperatura', 930.0000, 'ºC'),
	(184438, 122, '2014-02-01 00:12:30.000000', 'temperatura', 1048.0000, 'ºC'),
	(184439, 122, '2014-02-01 00:12:31.000000', 'temperatura', 52.0000, 'ºC'),
	(184440, 122, '2014-02-01 00:12:32.000000', 'temperatura', 714.0000, 'ºC'),
	(184441, 122, '2014-02-01 00:12:33.000000', 'temperatura', 1016.0000, 'ºC'),
	(184442, 122, '2014-02-01 00:12:34.000000', 'temperatura', 540.0000, 'ºC'),
	(184443, 122, '2014-02-01 00:12:35.000000', 'temperatura', 854.0000, 'ºC'),
	(184444, 122, '2014-02-01 00:12:36.000000', 'temperatura', 247.0000, 'ºC'),
	(184445, 122, '2014-02-01 00:12:37.000000', 'temperatura', 1073.0000, 'ºC'),
	(184446, 122, '2014-02-01 00:12:38.000000', 'temperatura', 1027.0000, 'ºC'),
	(184447, 122, '2014-02-01 00:12:39.000000', 'temperatura', 714.0000, 'ºC'),
	(184448, 122, '2014-02-01 00:12:40.000000', 'temperatura', 489.0000, 'ºC'),
	(184449, 122, '2014-02-01 00:12:41.000000', 'temperatura', 304.0000, 'ºC'),
	(184450, 122, '2014-02-01 00:12:42.000000', 'temperatura', 53.0000, 'ºC'),
	(184451, 122, '2014-02-01 00:12:43.000000', 'temperatura', 553.0000, 'ºC'),
	(184452, 122, '2014-02-01 00:12:44.000000', 'temperatura', 205.0000, 'ºC'),
	(184453, 122, '2014-02-01 00:12:45.000000', 'temperatura', 569.0000, 'ºC'),
	(184454, 122, '2014-02-01 00:12:46.000000', 'temperatura', 1029.0000, 'ºC'),
	(184455, 122, '2014-02-01 00:12:47.000000', 'temperatura', 1039.0000, 'ºC'),
	(184456, 122, '2014-02-01 00:12:48.000000', 'temperatura', 909.0000, 'ºC'),
	(184457, 122, '2014-02-01 00:12:49.000000', 'temperatura', 230.0000, 'ºC'),
	(184458, 122, '2014-02-01 00:12:50.000000', 'temperatura', 823.0000, 'ºC'),
	(184459, 122, '2014-02-01 00:12:51.000000', 'temperatura', 1026.0000, 'ºC'),
	(184460, 122, '2014-02-01 00:12:52.000000', 'temperatura', 259.0000, 'ºC'),
	(184461, 122, '2014-02-01 00:12:53.000000', 'temperatura', 617.0000, 'ºC'),
	(184462, 122, '2014-02-01 00:12:54.000000', 'temperatura', 1112.0000, 'ºC'),
	(184463, 122, '2014-02-01 00:12:55.000000', 'temperatura', 107.0000, 'ºC'),
	(184464, 122, '2014-02-01 00:12:56.000000', 'temperatura', 800.0000, 'ºC'),
	(184465, 122, '2014-02-01 00:12:57.000000', 'temperatura', 78.0000, 'ºC'),
	(184466, 122, '2014-02-01 00:12:58.000000', 'temperatura', 394.0000, 'ºC'),
	(184467, 122, '2014-02-01 00:12:59.000000', 'temperatura', 534.0000, 'ºC'),
	(184468, 122, '2014-02-01 00:13:00.000000', 'temperatura', 288.0000, 'ºC'),
	(184469, 122, '2014-02-01 00:13:01.000000', 'temperatura', 1040.0000, 'ºC'),
	(184470, 122, '2014-02-01 00:13:02.000000', 'temperatura', 736.0000, 'ºC'),
	(184471, 122, '2014-02-01 00:13:03.000000', 'temperatura', 562.0000, 'ºC'),
	(184472, 122, '2014-02-01 00:13:04.000000', 'temperatura', 602.0000, 'ºC'),
	(184473, 122, '2014-02-01 00:13:05.000000', 'temperatura', 124.0000, 'ºC'),
	(184474, 122, '2014-02-01 00:13:06.000000', 'temperatura', 15.0000, 'ºC'),
	(184475, 122, '2014-02-01 00:13:07.000000', 'temperatura', 904.0000, 'ºC'),
	(184476, 122, '2014-02-01 00:13:08.000000', 'temperatura', 875.0000, 'ºC'),
	(184477, 122, '2014-02-01 00:13:09.000000', 'temperatura', 465.0000, 'ºC'),
	(184478, 122, '2014-02-01 00:13:10.000000', 'temperatura', 900.0000, 'ºC'),
	(184479, 122, '2014-02-01 00:13:11.000000', 'temperatura', 703.0000, 'ºC'),
	(184480, 122, '2014-02-01 00:13:12.000000', 'temperatura', 817.0000, 'ºC'),
	(184481, 122, '2014-02-01 00:13:13.000000', 'temperatura', 777.0000, 'ºC'),
	(184482, 122, '2014-02-01 00:13:14.000000', 'temperatura', 233.0000, 'ºC'),
	(184483, 122, '2014-02-01 00:13:15.000000', 'temperatura', 36.0000, 'ºC'),
	(184484, 122, '2014-02-01 00:13:16.000000', 'temperatura', 682.0000, 'ºC'),
	(184485, 122, '2014-02-01 00:13:17.000000', 'temperatura', 900.0000, 'ºC'),
	(184486, 122, '2014-02-01 00:13:18.000000', 'temperatura', 57.0000, 'ºC'),
	(184487, 122, '2014-02-01 00:13:19.000000', 'temperatura', 1184.0000, 'ºC'),
	(184488, 122, '2014-02-01 00:13:20.000000', 'temperatura', 950.0000, 'ºC'),
	(184489, 122, '2014-02-01 00:13:21.000000', 'temperatura', 1198.0000, 'ºC'),
	(184490, 122, '2014-02-01 00:13:22.000000', 'temperatura', 742.0000, 'ºC'),
	(184491, 122, '2014-02-01 00:13:23.000000', 'temperatura', 114.0000, 'ºC'),
	(184492, 122, '2014-02-01 00:13:24.000000', 'temperatura', 744.0000, 'ºC'),
	(184493, 122, '2014-02-01 00:13:25.000000', 'temperatura', 979.0000, 'ºC'),
	(184494, 122, '2014-02-01 00:13:26.000000', 'temperatura', 263.0000, 'ºC'),
	(184495, 122, '2014-02-01 00:13:27.000000', 'temperatura', 778.0000, 'ºC'),
	(184496, 122, '2014-02-01 00:13:28.000000', 'temperatura', 703.0000, 'ºC'),
	(184497, 122, '2014-02-01 00:13:29.000000', 'temperatura', 1179.0000, 'ºC'),
	(184498, 122, '2014-02-01 00:13:30.000000', 'temperatura', 189.0000, 'ºC'),
	(184499, 122, '2014-02-01 00:13:31.000000', 'temperatura', 1009.0000, 'ºC'),
	(184500, 122, '2014-02-01 00:13:32.000000', 'temperatura', 879.0000, 'ºC'),
	(184501, 122, '2014-02-01 00:13:33.000000', 'temperatura', 168.0000, 'ºC'),
	(184502, 122, '2014-02-01 00:13:34.000000', 'temperatura', 603.0000, 'ºC'),
	(184503, 122, '2014-02-01 00:13:35.000000', 'temperatura', 110.0000, 'ºC'),
	(184504, 122, '2014-02-01 00:13:36.000000', 'temperatura', 1142.0000, 'ºC'),
	(184505, 122, '2014-02-01 00:13:37.000000', 'temperatura', 579.0000, 'ºC'),
	(184506, 122, '2014-02-01 00:13:38.000000', 'temperatura', 673.0000, 'ºC'),
	(184507, 122, '2014-02-01 00:13:39.000000', 'temperatura', 425.0000, 'ºC'),
	(184508, 122, '2014-02-01 00:13:40.000000', 'temperatura', 110.0000, 'ºC'),
	(184509, 122, '2014-02-01 00:13:41.000000', 'temperatura', 472.0000, 'ºC'),
	(184510, 122, '2014-02-01 00:13:42.000000', 'temperatura', 833.0000, 'ºC'),
	(184511, 122, '2014-02-01 00:13:43.000000', 'temperatura', 348.0000, 'ºC'),
	(184512, 122, '2014-02-01 00:13:44.000000', 'temperatura', 440.0000, 'ºC'),
	(184513, 122, '2014-02-01 00:13:45.000000', 'temperatura', 1159.0000, 'ºC'),
	(184514, 122, '2014-02-01 00:13:46.000000', 'temperatura', 875.0000, 'ºC'),
	(184515, 122, '2014-02-01 00:13:47.000000', 'temperatura', 900.0000, 'ºC'),
	(184516, 122, '2014-02-01 00:13:48.000000', 'temperatura', 674.0000, 'ºC'),
	(184517, 122, '2014-02-01 00:13:49.000000', 'temperatura', 669.0000, 'ºC'),
	(184518, 122, '2014-02-01 00:13:50.000000', 'temperatura', 126.0000, 'ºC'),
	(184519, 122, '2014-02-01 00:13:51.000000', 'temperatura', 1021.0000, 'ºC'),
	(184520, 122, '2014-02-01 00:13:52.000000', 'temperatura', 1130.0000, 'ºC'),
	(184521, 122, '2014-02-01 00:13:53.000000', 'temperatura', 188.0000, 'ºC'),
	(184522, 122, '2014-02-01 00:13:54.000000', 'temperatura', 1151.0000, 'ºC'),
	(184523, 122, '2014-02-01 00:13:55.000000', 'temperatura', 388.0000, 'ºC'),
	(184524, 122, '2014-02-01 00:13:56.000000', 'temperatura', 891.0000, 'ºC'),
	(184525, 122, '2014-02-01 00:13:57.000000', 'temperatura', 889.0000, 'ºC'),
	(184526, 122, '2014-02-01 00:13:58.000000', 'temperatura', 573.0000, 'ºC'),
	(184527, 122, '2014-02-01 00:13:59.000000', 'temperatura', 200.0000, 'ºC'),
	(184528, 122, '2014-02-01 00:14:00.000000', 'temperatura', 480.0000, 'ºC'),
	(184529, 122, '2014-02-01 00:14:01.000000', 'temperatura', 600.0000, 'ºC'),
	(184530, 122, '2014-02-01 00:14:02.000000', 'temperatura', 363.0000, 'ºC'),
	(184531, 122, '2014-02-01 00:14:03.000000', 'temperatura', 15.0000, 'ºC'),
	(184532, 122, '2014-02-01 00:14:04.000000', 'temperatura', 188.0000, 'ºC'),
	(184533, 122, '2014-02-01 00:14:05.000000', 'temperatura', 893.0000, 'ºC'),
	(184534, 122, '2014-02-01 00:14:06.000000', 'temperatura', 304.0000, 'ºC'),
	(184535, 122, '2014-02-01 00:14:07.000000', 'temperatura', 42.0000, 'ºC'),
	(184536, 122, '2014-02-01 00:14:08.000000', 'temperatura', 496.0000, 'ºC'),
	(184537, 122, '2014-02-01 00:14:09.000000', 'temperatura', 1155.0000, 'ºC'),
	(184538, 122, '2014-02-01 00:14:10.000000', 'temperatura', 686.0000, 'ºC'),
	(184539, 122, '2014-02-01 00:14:11.000000', 'temperatura', 1166.0000, 'ºC'),
	(184540, 122, '2014-02-01 00:14:12.000000', 'temperatura', 174.0000, 'ºC'),
	(184541, 122, '2014-02-01 00:14:13.000000', 'temperatura', 971.0000, 'ºC'),
	(184542, 122, '2014-02-01 00:14:14.000000', 'temperatura', 734.0000, 'ºC'),
	(184543, 122, '2014-02-01 00:14:15.000000', 'temperatura', 758.0000, 'ºC'),
	(184544, 122, '2014-02-01 00:14:16.000000', 'temperatura', 389.0000, 'ºC'),
	(184545, 122, '2014-02-01 00:14:17.000000', 'temperatura', 873.0000, 'ºC'),
	(184546, 122, '2014-02-01 00:14:18.000000', 'temperatura', 797.0000, 'ºC'),
	(184547, 122, '2014-02-01 00:14:19.000000', 'temperatura', 167.0000, 'ºC'),
	(184548, 122, '2014-02-01 00:14:20.000000', 'temperatura', 845.0000, 'ºC'),
	(184549, 122, '2014-02-01 00:14:21.000000', 'temperatura', 124.0000, 'ºC'),
	(184550, 122, '2014-02-01 00:14:22.000000', 'temperatura', 485.0000, 'ºC'),
	(184551, 122, '2014-02-01 00:14:23.000000', 'temperatura', 855.0000, 'ºC'),
	(184552, 122, '2014-02-01 00:14:24.000000', 'temperatura', 420.0000, 'ºC'),
	(184553, 122, '2014-02-01 00:14:25.000000', 'temperatura', 737.0000, 'ºC'),
	(184554, 122, '2014-02-01 00:14:26.000000', 'temperatura', 23.0000, 'ºC'),
	(184555, 122, '2014-02-01 00:14:27.000000', 'temperatura', 306.0000, 'ºC'),
	(184556, 122, '2014-02-01 00:14:28.000000', 'temperatura', 262.0000, 'ºC'),
	(184557, 122, '2014-02-01 00:14:29.000000', 'temperatura', 390.0000, 'ºC'),
	(184558, 122, '2014-02-01 00:14:30.000000', 'temperatura', 1166.0000, 'ºC'),
	(184559, 122, '2014-02-01 00:14:31.000000', 'temperatura', 1059.0000, 'ºC'),
	(184560, 122, '2014-02-01 00:14:32.000000', 'temperatura', 598.0000, 'ºC'),
	(184561, 122, '2014-02-01 00:14:33.000000', 'temperatura', 1012.0000, 'ºC'),
	(184562, 122, '2014-02-01 00:14:34.000000', 'temperatura', 867.0000, 'ºC'),
	(184563, 122, '2014-02-01 00:14:35.000000', 'temperatura', 102.0000, 'ºC'),
	(184564, 122, '2014-02-01 00:14:36.000000', 'temperatura', 308.0000, 'ºC'),
	(184565, 122, '2014-02-01 00:14:37.000000', 'temperatura', 36.0000, 'ºC'),
	(184566, 122, '2014-02-01 00:14:38.000000', 'temperatura', 455.0000, 'ºC'),
	(184567, 122, '2014-02-01 00:14:39.000000', 'temperatura', 968.0000, 'ºC'),
	(184568, 122, '2014-02-01 00:14:40.000000', 'temperatura', 1077.0000, 'ºC'),
	(184569, 122, '2014-02-01 00:14:41.000000', 'temperatura', 82.0000, 'ºC'),
	(184570, 122, '2014-02-01 00:14:42.000000', 'temperatura', 779.0000, 'ºC'),
	(184571, 122, '2014-02-01 00:14:43.000000', 'temperatura', 48.0000, 'ºC'),
	(184572, 122, '2014-02-01 00:14:44.000000', 'temperatura', 306.0000, 'ºC'),
	(184573, 122, '2014-02-01 00:14:45.000000', 'temperatura', 186.0000, 'ºC'),
	(184574, 122, '2014-02-01 00:14:46.000000', 'temperatura', 12.0000, 'ºC'),
	(184575, 122, '2014-02-01 00:14:47.000000', 'temperatura', 702.0000, 'ºC'),
	(184576, 122, '2014-02-01 00:14:48.000000', 'temperatura', 1074.0000, 'ºC'),
	(184577, 122, '2014-02-01 00:14:49.000000', 'temperatura', 866.0000, 'ºC'),
	(184578, 122, '2014-02-01 00:14:50.000000', 'temperatura', 1106.0000, 'ºC'),
	(184579, 122, '2014-02-01 00:14:51.000000', 'temperatura', 534.0000, 'ºC'),
	(184580, 122, '2014-02-01 00:14:52.000000', 'temperatura', 551.0000, 'ºC'),
	(184581, 122, '2014-02-01 00:14:53.000000', 'temperatura', 1153.0000, 'ºC'),
	(184582, 122, '2014-02-01 00:14:54.000000', 'temperatura', 514.0000, 'ºC'),
	(184583, 122, '2014-02-01 00:14:55.000000', 'temperatura', 313.0000, 'ºC'),
	(184584, 122, '2014-02-01 00:14:56.000000', 'temperatura', 20.0000, 'ºC'),
	(184585, 122, '2014-02-01 00:14:57.000000', 'temperatura', 364.0000, 'ºC'),
	(184586, 122, '2014-02-01 00:14:58.000000', 'temperatura', 562.0000, 'ºC'),
	(184587, 122, '2014-02-01 00:14:59.000000', 'temperatura', 516.0000, 'ºC'),
	(184588, 122, '2014-02-01 00:15:00.000000', 'temperatura', 896.0000, 'ºC'),
	(184589, 122, '2014-02-01 00:15:01.000000', 'temperatura', 533.0000, 'ºC'),
	(184590, 122, '2014-02-01 00:15:02.000000', 'temperatura', 1178.0000, 'ºC'),
	(184591, 122, '2014-02-01 00:15:03.000000', 'temperatura', 691.0000, 'ºC'),
	(184592, 122, '2014-02-01 00:15:04.000000', 'temperatura', 1122.0000, 'ºC'),
	(184593, 122, '2014-02-01 00:15:05.000000', 'temperatura', 1136.0000, 'ºC'),
	(184594, 122, '2014-02-01 00:15:06.000000', 'temperatura', 1117.0000, 'ºC'),
	(184595, 122, '2014-02-01 00:15:07.000000', 'temperatura', 977.0000, 'ºC'),
	(184596, 122, '2014-02-01 00:15:08.000000', 'temperatura', 333.0000, 'ºC'),
	(184597, 122, '2014-02-01 00:15:09.000000', 'temperatura', 1137.0000, 'ºC'),
	(184598, 122, '2014-02-01 00:15:10.000000', 'temperatura', 1084.0000, 'ºC'),
	(184599, 122, '2014-02-01 00:15:11.000000', 'temperatura', 811.0000, 'ºC'),
	(184600, 122, '2014-02-01 00:15:12.000000', 'temperatura', 804.0000, 'ºC'),
	(184601, 122, '2014-02-01 00:15:13.000000', 'temperatura', 389.0000, 'ºC'),
	(184602, 122, '2014-02-01 00:15:14.000000', 'temperatura', 732.0000, 'ºC'),
	(184603, 122, '2014-02-01 00:15:15.000000', 'temperatura', 93.0000, 'ºC'),
	(184604, 122, '2014-02-01 00:15:16.000000', 'temperatura', 668.0000, 'ºC'),
	(184605, 122, '2014-02-01 00:15:17.000000', 'temperatura', 663.0000, 'ºC'),
	(184606, 122, '2014-02-01 00:15:18.000000', 'temperatura', 113.0000, 'ºC'),
	(184607, 122, '2014-02-01 00:15:19.000000', 'temperatura', 977.0000, 'ºC'),
	(184608, 122, '2014-02-01 00:15:20.000000', 'temperatura', 945.0000, 'ºC'),
	(184609, 122, '2014-02-01 00:15:21.000000', 'temperatura', 597.0000, 'ºC'),
	(184610, 122, '2014-02-01 00:15:22.000000', 'temperatura', 148.0000, 'ºC'),
	(184611, 122, '2014-02-01 00:15:23.000000', 'temperatura', 150.0000, 'ºC'),
	(184612, 122, '2014-02-01 00:15:24.000000', 'temperatura', 305.0000, 'ºC'),
	(184613, 122, '2014-02-01 00:15:25.000000', 'temperatura', 1075.0000, 'ºC'),
	(184614, 122, '2014-02-01 00:15:26.000000', 'temperatura', 863.0000, 'ºC'),
	(184615, 122, '2014-02-01 00:15:27.000000', 'temperatura', 1090.0000, 'ºC'),
	(184616, 122, '2014-02-01 00:15:28.000000', 'temperatura', 461.0000, 'ºC'),
	(184617, 122, '2014-02-01 00:15:29.000000', 'temperatura', 236.0000, 'ºC'),
	(184618, 122, '2014-02-01 00:15:30.000000', 'temperatura', 996.0000, 'ºC'),
	(184619, 122, '2014-02-01 00:15:31.000000', 'temperatura', 675.0000, 'ºC'),
	(184620, 122, '2014-02-01 00:15:32.000000', 'temperatura', 385.0000, 'ºC'),
	(184621, 122, '2014-02-01 00:15:33.000000', 'temperatura', 1101.0000, 'ºC'),
	(184622, 122, '2014-02-01 00:15:34.000000', 'temperatura', 750.0000, 'ºC'),
	(184623, 122, '2014-02-01 00:15:35.000000', 'temperatura', 450.0000, 'ºC'),
	(184624, 122, '2014-02-01 00:15:36.000000', 'temperatura', 1197.0000, 'ºC'),
	(184625, 122, '2014-02-01 00:15:37.000000', 'temperatura', 1037.0000, 'ºC'),
	(184626, 122, '2014-02-01 00:15:38.000000', 'temperatura', 395.0000, 'ºC'),
	(184627, 122, '2014-02-01 00:15:39.000000', 'temperatura', 65.0000, 'ºC'),
	(184628, 122, '2014-02-01 00:15:40.000000', 'temperatura', 340.0000, 'ºC'),
	(184629, 122, '2014-02-01 00:15:41.000000', 'temperatura', 306.0000, 'ºC'),
	(184630, 122, '2014-02-01 00:15:42.000000', 'temperatura', 512.0000, 'ºC'),
	(184631, 122, '2014-02-01 00:15:43.000000', 'temperatura', 439.0000, 'ºC'),
	(184632, 122, '2014-02-01 00:15:44.000000', 'temperatura', 662.0000, 'ºC'),
	(184633, 122, '2014-02-01 00:15:45.000000', 'temperatura', 795.0000, 'ºC'),
	(184634, 122, '2014-02-01 00:15:46.000000', 'temperatura', 787.0000, 'ºC'),
	(184635, 122, '2014-02-01 00:15:47.000000', 'temperatura', 352.0000, 'ºC'),
	(184636, 122, '2014-02-01 00:15:48.000000', 'temperatura', 598.0000, 'ºC'),
	(184637, 122, '2014-02-01 00:15:49.000000', 'temperatura', 734.0000, 'ºC'),
	(184638, 122, '2014-02-01 00:15:50.000000', 'temperatura', 676.0000, 'ºC'),
	(184639, 122, '2014-02-01 00:15:51.000000', 'temperatura', 1178.0000, 'ºC'),
	(184640, 122, '2014-02-01 00:15:52.000000', 'temperatura', 262.0000, 'ºC'),
	(184641, 122, '2014-02-01 00:15:53.000000', 'temperatura', 177.0000, 'ºC'),
	(184642, 122, '2014-02-01 00:15:54.000000', 'temperatura', 102.0000, 'ºC'),
	(184643, 122, '2014-02-01 00:15:55.000000', 'temperatura', 1178.0000, 'ºC'),
	(184644, 122, '2014-02-01 00:15:56.000000', 'temperatura', 783.0000, 'ºC'),
	(184645, 122, '2014-02-01 00:15:57.000000', 'temperatura', 384.0000, 'ºC'),
	(184646, 122, '2014-02-01 00:15:58.000000', 'temperatura', 769.0000, 'ºC'),
	(184647, 122, '2014-02-01 00:15:59.000000', 'temperatura', 294.0000, 'ºC'),
	(184648, 122, '2014-02-01 00:16:00.000000', 'temperatura', 362.0000, 'ºC'),
	(184649, 122, '2014-02-01 00:16:01.000000', 'temperatura', 931.0000, 'ºC'),
	(184650, 122, '2014-02-01 00:16:02.000000', 'temperatura', 1169.0000, 'ºC'),
	(184651, 122, '2014-02-01 00:16:03.000000', 'temperatura', 653.0000, 'ºC'),
	(184652, 122, '2014-02-01 00:16:04.000000', 'temperatura', 957.0000, 'ºC'),
	(184653, 122, '2014-02-01 00:16:05.000000', 'temperatura', 427.0000, 'ºC'),
	(184654, 122, '2014-02-01 00:16:06.000000', 'temperatura', 464.0000, 'ºC'),
	(184655, 122, '2014-02-01 00:16:07.000000', 'temperatura', 1039.0000, 'ºC'),
	(184656, 122, '2014-02-01 00:16:08.000000', 'temperatura', 205.0000, 'ºC'),
	(184657, 122, '2014-02-01 00:16:09.000000', 'temperatura', 308.0000, 'ºC'),
	(184658, 122, '2014-02-01 00:16:10.000000', 'temperatura', 924.0000, 'ºC'),
	(184659, 122, '2014-02-01 00:16:11.000000', 'temperatura', 97.0000, 'ºC'),
	(184660, 122, '2014-02-01 00:16:12.000000', 'temperatura', 113.0000, 'ºC'),
	(184661, 122, '2014-02-01 00:16:13.000000', 'temperatura', 273.0000, 'ºC'),
	(184662, 122, '2014-02-01 00:16:14.000000', 'temperatura', 1028.0000, 'ºC'),
	(184663, 122, '2014-02-01 00:16:15.000000', 'temperatura', 723.0000, 'ºC'),
	(184664, 122, '2014-02-01 00:16:16.000000', 'temperatura', 531.0000, 'ºC'),
	(184665, 122, '2014-02-01 00:16:17.000000', 'temperatura', 484.0000, 'ºC'),
	(184666, 122, '2014-02-01 00:16:18.000000', 'temperatura', 830.0000, 'ºC'),
	(184667, 122, '2014-02-01 00:16:19.000000', 'temperatura', 298.0000, 'ºC'),
	(184668, 122, '2014-02-01 00:16:20.000000', 'temperatura', 202.0000, 'ºC'),
	(184669, 122, '2014-02-01 00:16:21.000000', 'temperatura', 117.0000, 'ºC'),
	(184670, 122, '2014-02-01 00:16:22.000000', 'temperatura', 1180.0000, 'ºC'),
	(184671, 122, '2014-02-01 00:16:23.000000', 'temperatura', 749.0000, 'ºC'),
	(184672, 122, '2014-02-01 00:16:24.000000', 'temperatura', 205.0000, 'ºC'),
	(184673, 122, '2014-02-01 00:16:25.000000', 'temperatura', 1179.0000, 'ºC'),
	(184674, 122, '2014-02-01 00:16:26.000000', 'temperatura', 480.0000, 'ºC'),
	(184675, 122, '2014-02-01 00:16:27.000000', 'temperatura', 61.0000, 'ºC'),
	(184676, 122, '2014-02-01 00:16:28.000000', 'temperatura', 69.0000, 'ºC'),
	(184677, 122, '2014-02-01 00:16:29.000000', 'temperatura', 163.0000, 'ºC'),
	(184678, 122, '2014-02-01 00:16:30.000000', 'temperatura', 608.0000, 'ºC'),
	(184679, 122, '2014-02-01 00:16:31.000000', 'temperatura', 150.0000, 'ºC'),
	(184680, 122, '2014-02-01 00:16:32.000000', 'temperatura', 129.0000, 'ºC'),
	(184681, 122, '2014-02-01 00:16:33.000000', 'temperatura', 194.0000, 'ºC'),
	(184682, 122, '2014-02-01 00:16:34.000000', 'temperatura', 582.0000, 'ºC'),
	(184683, 122, '2014-02-01 00:16:35.000000', 'temperatura', 1128.0000, 'ºC'),
	(184684, 122, '2014-02-01 00:16:36.000000', 'temperatura', 295.0000, 'ºC'),
	(184685, 122, '2014-02-01 00:16:37.000000', 'temperatura', 494.0000, 'ºC'),
	(184686, 122, '2014-02-01 00:16:38.000000', 'temperatura', 383.0000, 'ºC'),
	(184687, 122, '2014-02-01 00:16:39.000000', 'temperatura', 432.0000, 'ºC'),
	(184688, 122, '2014-02-01 00:16:40.000000', 'temperatura', 1014.0000, 'ºC'),
	(184689, 122, '2014-02-01 00:16:41.000000', 'temperatura', 173.0000, 'ºC'),
	(184690, 122, '2014-02-01 00:16:42.000000', 'temperatura', 225.0000, 'ºC'),
	(184691, 122, '2014-02-01 00:16:43.000000', 'temperatura', 607.0000, 'ºC'),
	(184692, 122, '2014-02-01 00:16:44.000000', 'temperatura', 1161.0000, 'ºC'),
	(184693, 122, '2014-02-01 00:16:45.000000', 'temperatura', 384.0000, 'ºC'),
	(184694, 122, '2014-02-01 00:16:46.000000', 'temperatura', 835.0000, 'ºC'),
	(184695, 122, '2014-02-01 00:16:47.000000', 'temperatura', 627.0000, 'ºC'),
	(184696, 122, '2014-02-01 00:16:48.000000', 'temperatura', 629.0000, 'ºC'),
	(184697, 122, '2014-02-01 00:16:49.000000', 'temperatura', 65.0000, 'ºC'),
	(184698, 122, '2014-02-01 00:16:50.000000', 'temperatura', 839.0000, 'ºC'),
	(184699, 122, '2014-02-01 00:16:51.000000', 'temperatura', 402.0000, 'ºC'),
	(184700, 122, '2014-02-01 00:16:52.000000', 'temperatura', 693.0000, 'ºC'),
	(184701, 122, '2014-02-01 00:16:53.000000', 'temperatura', 1057.0000, 'ºC'),
	(184702, 122, '2014-02-01 00:16:54.000000', 'temperatura', 807.0000, 'ºC'),
	(184703, 122, '2014-02-01 00:16:55.000000', 'temperatura', 866.0000, 'ºC'),
	(184704, 122, '2014-02-01 00:16:56.000000', 'temperatura', 707.0000, 'ºC'),
	(184705, 122, '2014-02-01 00:16:57.000000', 'temperatura', 938.0000, 'ºC'),
	(184706, 122, '2014-02-01 00:16:58.000000', 'temperatura', 171.0000, 'ºC'),
	(184707, 122, '2014-02-01 00:16:59.000000', 'temperatura', 441.0000, 'ºC'),
	(184708, 122, '2014-02-01 00:17:00.000000', 'temperatura', 493.0000, 'ºC'),
	(184709, 122, '2014-02-01 00:17:01.000000', 'temperatura', 1144.0000, 'ºC'),
	(184710, 122, '2014-02-01 00:17:02.000000', 'temperatura', 639.0000, 'ºC'),
	(184711, 122, '2014-02-01 00:17:03.000000', 'temperatura', 965.0000, 'ºC'),
	(184712, 122, '2014-02-01 00:17:04.000000', 'temperatura', 508.0000, 'ºC'),
	(184713, 122, '2014-02-01 00:17:05.000000', 'temperatura', 847.0000, 'ºC'),
	(184714, 122, '2014-02-01 00:17:06.000000', 'temperatura', 311.0000, 'ºC'),
	(184715, 122, '2014-02-01 00:17:07.000000', 'temperatura', 213.0000, 'ºC'),
	(184716, 122, '2014-02-01 00:17:08.000000', 'temperatura', 134.0000, 'ºC'),
	(184717, 122, '2014-02-01 00:17:09.000000', 'temperatura', 31.0000, 'ºC'),
	(184718, 122, '2014-02-01 00:17:10.000000', 'temperatura', 952.0000, 'ºC'),
	(184719, 122, '2014-02-01 00:17:11.000000', 'temperatura', 1069.0000, 'ºC'),
	(184720, 122, '2014-02-01 00:17:12.000000', 'temperatura', 89.0000, 'ºC'),
	(184721, 122, '2014-02-01 00:17:13.000000', 'temperatura', 840.0000, 'ºC'),
	(184722, 122, '2014-02-01 00:17:14.000000', 'temperatura', 332.0000, 'ºC'),
	(184723, 122, '2014-02-01 00:17:15.000000', 'temperatura', 341.0000, 'ºC'),
	(184724, 122, '2014-02-01 00:17:16.000000', 'temperatura', 710.0000, 'ºC'),
	(184725, 122, '2014-02-01 00:17:17.000000', 'temperatura', 126.0000, 'ºC'),
	(184726, 122, '2014-02-01 00:17:18.000000', 'temperatura', 902.0000, 'ºC'),
	(184727, 122, '2014-02-01 00:17:19.000000', 'temperatura', 531.0000, 'ºC'),
	(184728, 122, '2014-02-01 00:17:20.000000', 'temperatura', 1151.0000, 'ºC'),
	(184729, 122, '2014-02-01 00:17:21.000000', 'temperatura', 563.0000, 'ºC'),
	(184730, 122, '2014-02-01 00:17:22.000000', 'temperatura', 564.0000, 'ºC'),
	(184731, 122, '2014-02-01 00:17:23.000000', 'temperatura', 1129.0000, 'ºC'),
	(184732, 122, '2014-02-01 00:17:24.000000', 'temperatura', 354.0000, 'ºC'),
	(184733, 122, '2014-02-01 00:17:25.000000', 'temperatura', 783.0000, 'ºC'),
	(184734, 122, '2014-02-01 00:17:26.000000', 'temperatura', 454.0000, 'ºC'),
	(184735, 122, '2014-02-01 00:17:27.000000', 'temperatura', 1124.0000, 'ºC'),
	(184736, 122, '2014-02-01 00:17:28.000000', 'temperatura', 655.0000, 'ºC'),
	(184737, 122, '2014-02-01 00:17:29.000000', 'temperatura', 1104.0000, 'ºC'),
	(184738, 122, '2014-02-01 00:17:30.000000', 'temperatura', 1158.0000, 'ºC'),
	(184739, 122, '2014-02-01 00:17:31.000000', 'temperatura', 76.0000, 'ºC'),
	(184740, 122, '2014-02-01 00:17:32.000000', 'temperatura', 509.0000, 'ºC'),
	(184741, 122, '2014-02-01 00:17:33.000000', 'temperatura', 1118.0000, 'ºC'),
	(184742, 122, '2014-02-01 00:17:34.000000', 'temperatura', 463.0000, 'ºC'),
	(184743, 122, '2014-02-01 00:17:35.000000', 'temperatura', 159.0000, 'ºC'),
	(184744, 122, '2014-02-01 00:17:36.000000', 'temperatura', 609.0000, 'ºC'),
	(184745, 122, '2014-02-01 00:17:37.000000', 'temperatura', 169.0000, 'ºC'),
	(184746, 122, '2014-02-01 00:17:38.000000', 'temperatura', 217.0000, 'ºC'),
	(184747, 122, '2014-02-01 00:17:39.000000', 'temperatura', 579.0000, 'ºC'),
	(184748, 122, '2014-02-01 00:17:40.000000', 'temperatura', 1045.0000, 'ºC'),
	(184749, 122, '2014-02-01 00:17:41.000000', 'temperatura', 1088.0000, 'ºC'),
	(184750, 122, '2014-02-01 00:17:42.000000', 'temperatura', 1106.0000, 'ºC'),
	(184751, 122, '2014-02-01 00:17:43.000000', 'temperatura', 1067.0000, 'ºC'),
	(184752, 122, '2014-02-01 00:17:44.000000', 'temperatura', 817.0000, 'ºC'),
	(184753, 122, '2014-02-01 00:17:45.000000', 'temperatura', 883.0000, 'ºC'),
	(184754, 122, '2014-02-01 00:17:46.000000', 'temperatura', 765.0000, 'ºC'),
	(184755, 122, '2014-02-01 00:17:47.000000', 'temperatura', 1177.0000, 'ºC'),
	(184756, 122, '2014-02-01 00:17:48.000000', 'temperatura', 1191.0000, 'ºC'),
	(184757, 122, '2014-02-01 00:17:49.000000', 'temperatura', 22.0000, 'ºC'),
	(184758, 122, '2014-02-01 00:17:50.000000', 'temperatura', 140.0000, 'ºC'),
	(184759, 122, '2014-02-01 00:17:51.000000', 'temperatura', 635.0000, 'ºC'),
	(184760, 122, '2014-02-01 00:17:52.000000', 'temperatura', 356.0000, 'ºC'),
	(184761, 122, '2014-02-01 00:17:53.000000', 'temperatura', 1075.0000, 'ºC'),
	(184762, 122, '2014-02-01 00:17:54.000000', 'temperatura', 707.0000, 'ºC'),
	(184763, 122, '2014-02-01 00:17:55.000000', 'temperatura', 309.0000, 'ºC'),
	(184764, 122, '2014-02-01 00:17:56.000000', 'temperatura', 625.0000, 'ºC'),
	(184765, 122, '2014-02-01 00:17:57.000000', 'temperatura', 1001.0000, 'ºC'),
	(184766, 122, '2014-02-01 00:17:58.000000', 'temperatura', 728.0000, 'ºC'),
	(184767, 122, '2014-02-01 00:17:59.000000', 'temperatura', 639.0000, 'ºC'),
	(184768, 122, '2014-02-01 00:18:00.000000', 'temperatura', 1013.0000, 'ºC'),
	(184769, 122, '2014-02-01 00:18:01.000000', 'temperatura', 747.0000, 'ºC'),
	(184770, 122, '2014-02-01 00:18:02.000000', 'temperatura', 695.0000, 'ºC'),
	(184771, 122, '2014-02-01 00:18:03.000000', 'temperatura', 35.0000, 'ºC'),
	(184772, 122, '2014-02-01 00:18:04.000000', 'temperatura', 491.0000, 'ºC'),
	(184773, 122, '2014-02-01 00:18:05.000000', 'temperatura', 1150.0000, 'ºC'),
	(184774, 122, '2014-02-01 00:18:06.000000', 'temperatura', 676.0000, 'ºC'),
	(184775, 122, '2014-02-01 00:18:07.000000', 'temperatura', 1132.0000, 'ºC'),
	(184776, 122, '2014-02-01 00:18:08.000000', 'temperatura', 34.0000, 'ºC'),
	(184777, 122, '2014-02-01 00:18:09.000000', 'temperatura', 374.0000, 'ºC'),
	(184778, 122, '2014-02-01 00:18:10.000000', 'temperatura', 567.0000, 'ºC'),
	(184779, 122, '2014-02-01 00:18:11.000000', 'temperatura', 512.0000, 'ºC'),
	(184780, 122, '2014-02-01 00:18:12.000000', 'temperatura', 861.0000, 'ºC'),
	(184781, 122, '2014-02-01 00:18:13.000000', 'temperatura', 371.0000, 'ºC'),
	(184782, 122, '2014-02-01 00:18:14.000000', 'temperatura', 473.0000, 'ºC'),
	(184783, 122, '2014-02-01 00:18:15.000000', 'temperatura', 50.0000, 'ºC'),
	(184784, 122, '2014-02-01 00:18:16.000000', 'temperatura', 33.0000, 'ºC'),
	(184785, 122, '2014-02-01 00:18:17.000000', 'temperatura', 14.0000, 'ºC'),
	(184786, 122, '2014-02-01 00:18:18.000000', 'temperatura', 1171.0000, 'ºC'),
	(184787, 122, '2014-02-01 00:18:19.000000', 'temperatura', 1013.0000, 'ºC'),
	(184788, 122, '2014-02-01 00:18:20.000000', 'temperatura', 356.0000, 'ºC'),
	(184789, 122, '2014-02-01 00:18:21.000000', 'temperatura', 1138.0000, 'ºC'),
	(184790, 122, '2014-02-01 00:18:22.000000', 'temperatura', 1023.0000, 'ºC'),
	(184791, 122, '2014-02-01 00:18:23.000000', 'temperatura', 504.0000, 'ºC'),
	(184792, 122, '2014-02-01 00:18:24.000000', 'temperatura', 649.0000, 'ºC'),
	(184793, 122, '2014-02-01 00:18:25.000000', 'temperatura', 532.0000, 'ºC'),
	(184794, 122, '2014-02-01 00:18:26.000000', 'temperatura', 717.0000, 'ºC'),
	(184795, 122, '2014-02-01 00:18:27.000000', 'temperatura', 786.0000, 'ºC'),
	(184796, 122, '2014-02-01 00:18:28.000000', 'temperatura', 582.0000, 'ºC'),
	(184797, 122, '2014-02-01 00:18:29.000000', 'temperatura', 553.0000, 'ºC'),
	(184798, 122, '2014-02-01 00:18:30.000000', 'temperatura', 1021.0000, 'ºC'),
	(184799, 122, '2014-02-01 00:18:31.000000', 'temperatura', 1044.0000, 'ºC'),
	(184800, 122, '2014-02-01 00:18:32.000000', 'temperatura', 958.0000, 'ºC'),
	(184801, 122, '2014-02-01 00:18:33.000000', 'temperatura', 459.0000, 'ºC'),
	(184802, 122, '2014-02-01 00:18:34.000000', 'temperatura', 622.0000, 'ºC'),
	(184803, 122, '2014-02-01 00:18:35.000000', 'temperatura', 533.0000, 'ºC'),
	(184804, 122, '2014-02-01 00:18:36.000000', 'temperatura', 801.0000, 'ºC'),
	(184805, 122, '2014-02-01 00:18:37.000000', 'temperatura', 7.0000, 'ºC'),
	(184806, 122, '2014-02-01 00:18:38.000000', 'temperatura', 30.0000, 'ºC'),
	(184807, 122, '2014-02-01 00:18:39.000000', 'temperatura', 132.0000, 'ºC'),
	(184808, 122, '2014-02-01 00:18:40.000000', 'temperatura', 569.0000, 'ºC'),
	(184809, 122, '2014-02-01 00:18:41.000000', 'temperatura', 52.0000, 'ºC'),
	(184810, 122, '2014-02-01 00:18:42.000000', 'temperatura', 950.0000, 'ºC'),
	(184811, 122, '2014-02-01 00:18:43.000000', 'temperatura', 996.0000, 'ºC'),
	(184812, 122, '2014-02-01 00:18:44.000000', 'temperatura', 930.0000, 'ºC'),
	(184813, 122, '2014-02-01 00:18:45.000000', 'temperatura', 465.0000, 'ºC'),
	(184814, 122, '2014-02-01 00:18:46.000000', 'temperatura', 734.0000, 'ºC'),
	(184815, 122, '2014-02-01 00:18:47.000000', 'temperatura', 1074.0000, 'ºC'),
	(184816, 122, '2014-02-01 00:18:48.000000', 'temperatura', 768.0000, 'ºC'),
	(184817, 122, '2014-02-01 00:18:49.000000', 'temperatura', 618.0000, 'ºC'),
	(184818, 122, '2014-02-01 00:18:50.000000', 'temperatura', 786.0000, 'ºC'),
	(184819, 122, '2014-02-01 00:18:51.000000', 'temperatura', 877.0000, 'ºC'),
	(184820, 122, '2014-02-01 00:18:52.000000', 'temperatura', 829.0000, 'ºC'),
	(184821, 122, '2014-02-01 00:18:53.000000', 'temperatura', 315.0000, 'ºC'),
	(184822, 122, '2014-02-01 00:18:54.000000', 'temperatura', 286.0000, 'ºC'),
	(184823, 122, '2014-02-01 00:18:55.000000', 'temperatura', 486.0000, 'ºC'),
	(184824, 122, '2014-02-01 00:18:56.000000', 'temperatura', 372.0000, 'ºC'),
	(184825, 122, '2014-02-01 00:18:57.000000', 'temperatura', 404.0000, 'ºC'),
	(184826, 122, '2014-02-01 00:18:58.000000', 'temperatura', 903.0000, 'ºC'),
	(184827, 122, '2014-02-01 00:18:59.000000', 'temperatura', 905.0000, 'ºC'),
	(184828, 122, '2014-02-01 00:19:00.000000', 'temperatura', 614.0000, 'ºC'),
	(184829, 122, '2014-02-01 00:19:01.000000', 'temperatura', 357.0000, 'ºC'),
	(184830, 122, '2014-02-01 00:19:02.000000', 'temperatura', 1142.0000, 'ºC'),
	(184831, 122, '2014-02-01 00:19:03.000000', 'temperatura', 1041.0000, 'ºC'),
	(184832, 122, '2014-02-01 00:19:04.000000', 'temperatura', 578.0000, 'ºC'),
	(184833, 122, '2014-02-01 00:19:05.000000', 'temperatura', 970.0000, 'ºC'),
	(184834, 122, '2014-02-01 00:19:06.000000', 'temperatura', 715.0000, 'ºC'),
	(184835, 122, '2014-02-01 00:19:07.000000', 'temperatura', 666.0000, 'ºC'),
	(184836, 122, '2014-02-01 00:19:08.000000', 'temperatura', 1185.0000, 'ºC'),
	(184837, 122, '2014-02-01 00:19:09.000000', 'temperatura', 326.0000, 'ºC'),
	(184838, 122, '2014-02-01 00:19:10.000000', 'temperatura', 475.0000, 'ºC'),
	(184839, 122, '2014-02-01 00:19:11.000000', 'temperatura', 201.0000, 'ºC'),
	(184840, 122, '2014-02-01 00:19:12.000000', 'temperatura', 777.0000, 'ºC'),
	(184841, 122, '2014-02-01 00:19:13.000000', 'temperatura', 884.0000, 'ºC'),
	(184842, 122, '2014-02-01 00:19:14.000000', 'temperatura', 890.0000, 'ºC'),
	(184843, 122, '2014-02-01 00:19:15.000000', 'temperatura', 599.0000, 'ºC'),
	(184844, 122, '2014-02-01 00:19:16.000000', 'temperatura', 325.0000, 'ºC'),
	(184845, 122, '2014-02-01 00:19:17.000000', 'temperatura', 1027.0000, 'ºC'),
	(184846, 122, '2014-02-01 00:19:18.000000', 'temperatura', 561.0000, 'ºC'),
	(184847, 122, '2014-02-01 00:19:19.000000', 'temperatura', 923.0000, 'ºC'),
	(184848, 122, '2014-02-01 00:19:20.000000', 'temperatura', 535.0000, 'ºC'),
	(184849, 122, '2014-02-01 00:19:21.000000', 'temperatura', 1107.0000, 'ºC'),
	(184850, 122, '2014-02-01 00:19:22.000000', 'temperatura', 329.0000, 'ºC'),
	(184851, 122, '2014-02-01 00:19:23.000000', 'temperatura', 724.0000, 'ºC'),
	(184852, 122, '2014-02-01 00:19:24.000000', 'temperatura', 236.0000, 'ºC'),
	(184853, 122, '2014-02-01 00:19:25.000000', 'temperatura', 208.0000, 'ºC'),
	(184854, 122, '2014-02-01 00:19:26.000000', 'temperatura', 331.0000, 'ºC'),
	(184855, 122, '2014-02-01 00:19:27.000000', 'temperatura', 1033.0000, 'ºC'),
	(184856, 122, '2014-02-01 00:19:28.000000', 'temperatura', 570.0000, 'ºC'),
	(184857, 122, '2014-02-01 00:19:29.000000', 'temperatura', 952.0000, 'ºC'),
	(184858, 122, '2014-02-01 00:19:30.000000', 'temperatura', 652.0000, 'ºC'),
	(184859, 122, '2014-02-01 00:19:31.000000', 'temperatura', 405.0000, 'ºC'),
	(184860, 122, '2014-02-01 00:19:32.000000', 'temperatura', 68.0000, 'ºC'),
	(184861, 122, '2014-02-01 00:19:33.000000', 'temperatura', 328.0000, 'ºC'),
	(184862, 122, '2014-02-01 00:19:34.000000', 'temperatura', 234.0000, 'ºC'),
	(184863, 122, '2014-02-01 00:19:35.000000', 'temperatura', 187.0000, 'ºC'),
	(184864, 122, '2014-02-01 00:19:36.000000', 'temperatura', 232.0000, 'ºC'),
	(184865, 122, '2014-02-01 00:19:37.000000', 'temperatura', 600.0000, 'ºC'),
	(184866, 122, '2014-02-01 00:19:38.000000', 'temperatura', 1105.0000, 'ºC'),
	(184867, 122, '2014-02-01 00:19:39.000000', 'temperatura', 125.0000, 'ºC'),
	(184868, 122, '2014-02-01 00:19:40.000000', 'temperatura', 912.0000, 'ºC'),
	(184869, 122, '2014-02-01 00:19:41.000000', 'temperatura', 586.0000, 'ºC'),
	(184870, 122, '2014-02-01 00:19:42.000000', 'temperatura', 194.0000, 'ºC'),
	(184871, 122, '2014-02-01 00:19:43.000000', 'temperatura', 414.0000, 'ºC'),
	(184872, 122, '2014-02-01 00:19:44.000000', 'temperatura', 287.0000, 'ºC'),
	(184873, 122, '2014-02-01 00:19:45.000000', 'temperatura', 196.0000, 'ºC'),
	(184874, 122, '2014-02-01 00:19:46.000000', 'temperatura', 117.0000, 'ºC'),
	(184875, 122, '2014-02-01 00:19:47.000000', 'temperatura', 1198.0000, 'ºC'),
	(184876, 122, '2014-02-01 00:19:48.000000', 'temperatura', 837.0000, 'ºC'),
	(184877, 122, '2014-02-01 00:19:49.000000', 'temperatura', 595.0000, 'ºC'),
	(184878, 122, '2014-02-01 00:19:50.000000', 'temperatura', 465.0000, 'ºC'),
	(184879, 122, '2014-02-01 00:19:51.000000', 'temperatura', 539.0000, 'ºC'),
	(184880, 122, '2014-02-01 00:19:52.000000', 'temperatura', 99.0000, 'ºC'),
	(184881, 122, '2014-02-01 00:19:53.000000', 'temperatura', 81.0000, 'ºC'),
	(184882, 122, '2014-02-01 00:19:54.000000', 'temperatura', 106.0000, 'ºC'),
	(184883, 122, '2014-02-01 00:19:55.000000', 'temperatura', 288.0000, 'ºC'),
	(184884, 122, '2014-02-01 00:19:56.000000', 'temperatura', 1123.0000, 'ºC'),
	(184885, 122, '2014-02-01 00:19:57.000000', 'temperatura', 1151.0000, 'ºC'),
	(184886, 122, '2014-02-01 00:19:58.000000', 'temperatura', 1185.0000, 'ºC'),
	(184887, 122, '2014-02-01 00:19:59.000000', 'temperatura', 73.0000, 'ºC'),
	(184888, 122, '2014-02-01 00:20:00.000000', 'temperatura', 410.0000, 'ºC'),
	(184889, 122, '2014-02-01 00:20:01.000000', 'temperatura', 632.0000, 'ºC'),
	(184890, 122, '2014-02-01 00:20:02.000000', 'temperatura', 732.0000, 'ºC'),
	(184891, 122, '2014-02-01 00:20:03.000000', 'temperatura', 564.0000, 'ºC'),
	(184892, 122, '2014-02-01 00:20:04.000000', 'temperatura', 626.0000, 'ºC'),
	(184893, 122, '2014-02-01 00:20:05.000000', 'temperatura', 239.0000, 'ºC'),
	(184894, 122, '2014-02-01 00:20:06.000000', 'temperatura', 515.0000, 'ºC'),
	(184895, 122, '2014-02-01 00:20:07.000000', 'temperatura', 659.0000, 'ºC'),
	(184896, 122, '2014-02-01 00:20:08.000000', 'temperatura', 550.0000, 'ºC'),
	(184897, 122, '2014-02-01 00:20:09.000000', 'temperatura', 775.0000, 'ºC'),
	(184898, 122, '2014-02-01 00:20:10.000000', 'temperatura', 1024.0000, 'ºC'),
	(184899, 122, '2014-02-01 00:20:11.000000', 'temperatura', 395.0000, 'ºC'),
	(184900, 122, '2014-02-01 00:20:12.000000', 'temperatura', 106.0000, 'ºC'),
	(184901, 122, '2014-02-01 00:20:13.000000', 'temperatura', 543.0000, 'ºC'),
	(184902, 122, '2014-02-01 00:20:14.000000', 'temperatura', 0.0000, 'ºC'),
	(184903, 122, '2014-02-01 00:20:15.000000', 'temperatura', 769.0000, 'ºC'),
	(184904, 122, '2014-02-01 00:20:16.000000', 'temperatura', 247.0000, 'ºC'),
	(184905, 122, '2014-02-01 00:20:17.000000', 'temperatura', 129.0000, 'ºC'),
	(184906, 122, '2014-02-01 00:20:18.000000', 'temperatura', 1105.0000, 'ºC'),
	(184907, 122, '2014-02-01 00:20:19.000000', 'temperatura', 336.0000, 'ºC'),
	(184908, 122, '2014-02-01 00:20:20.000000', 'temperatura', 766.0000, 'ºC'),
	(184909, 122, '2014-02-01 00:20:21.000000', 'temperatura', 422.0000, 'ºC'),
	(184910, 122, '2014-02-01 00:20:22.000000', 'temperatura', 1014.0000, 'ºC'),
	(184911, 122, '2014-02-01 00:20:23.000000', 'temperatura', 202.0000, 'ºC'),
	(184912, 122, '2014-02-01 00:20:24.000000', 'temperatura', 370.0000, 'ºC'),
	(184913, 122, '2014-02-01 00:20:25.000000', 'temperatura', 45.0000, 'ºC'),
	(184914, 122, '2014-02-01 00:20:26.000000', 'temperatura', 313.0000, 'ºC'),
	(184915, 122, '2014-02-01 00:20:27.000000', 'temperatura', 233.0000, 'ºC'),
	(184916, 122, '2014-02-01 00:20:28.000000', 'temperatura', 227.0000, 'ºC'),
	(184917, 122, '2014-02-01 00:20:29.000000', 'temperatura', 434.0000, 'ºC'),
	(184918, 122, '2014-02-01 00:20:30.000000', 'temperatura', 291.0000, 'ºC'),
	(184919, 122, '2014-02-01 00:20:31.000000', 'temperatura', 151.0000, 'ºC'),
	(184920, 122, '2014-02-01 00:20:32.000000', 'temperatura', 1086.0000, 'ºC'),
	(184921, 122, '2014-02-01 00:20:33.000000', 'temperatura', 174.0000, 'ºC'),
	(184922, 122, '2014-02-01 00:20:34.000000', 'temperatura', 14.0000, 'ºC'),
	(184923, 122, '2014-02-01 00:20:35.000000', 'temperatura', 751.0000, 'ºC'),
	(184924, 122, '2014-02-01 00:20:36.000000', 'temperatura', 110.0000, 'ºC'),
	(184925, 122, '2014-02-01 00:20:37.000000', 'temperatura', 698.0000, 'ºC'),
	(184926, 122, '2014-02-01 00:20:38.000000', 'temperatura', 761.0000, 'ºC'),
	(184927, 122, '2014-02-01 00:20:39.000000', 'temperatura', 512.0000, 'ºC'),
	(184928, 122, '2014-02-01 00:20:40.000000', 'temperatura', 275.0000, 'ºC'),
	(184929, 122, '2014-02-01 00:20:41.000000', 'temperatura', 1042.0000, 'ºC'),
	(184930, 122, '2014-02-01 00:20:42.000000', 'temperatura', 784.0000, 'ºC'),
	(184931, 122, '2014-02-01 00:20:43.000000', 'temperatura', 793.0000, 'ºC'),
	(184932, 122, '2014-02-01 00:20:44.000000', 'temperatura', 415.0000, 'ºC'),
	(184933, 122, '2014-02-01 00:20:45.000000', 'temperatura', 896.0000, 'ºC'),
	(184934, 122, '2014-02-01 00:20:46.000000', 'temperatura', 834.0000, 'ºC'),
	(184935, 122, '2014-02-01 00:20:47.000000', 'temperatura', 284.0000, 'ºC'),
	(184936, 122, '2014-02-01 00:20:48.000000', 'temperatura', 118.0000, 'ºC'),
	(184937, 122, '2014-02-01 00:20:49.000000', 'temperatura', 938.0000, 'ºC'),
	(184938, 122, '2014-02-01 00:20:50.000000', 'temperatura', 738.0000, 'ºC'),
	(184939, 122, '2014-02-01 00:20:51.000000', 'temperatura', 877.0000, 'ºC'),
	(184940, 122, '2014-02-01 00:20:52.000000', 'temperatura', 971.0000, 'ºC'),
	(184941, 122, '2014-02-01 00:20:53.000000', 'temperatura', 1025.0000, 'ºC'),
	(184942, 122, '2014-02-01 00:20:54.000000', 'temperatura', 1010.0000, 'ºC'),
	(184943, 122, '2014-02-01 00:20:55.000000', 'temperatura', 778.0000, 'ºC'),
	(184944, 122, '2014-02-01 00:20:56.000000', 'temperatura', 861.0000, 'ºC'),
	(184945, 122, '2014-02-01 00:20:57.000000', 'temperatura', 772.0000, 'ºC'),
	(184946, 122, '2014-02-01 00:20:58.000000', 'temperatura', 78.0000, 'ºC'),
	(184947, 122, '2014-02-01 00:20:59.000000', 'temperatura', 472.0000, 'ºC'),
	(184948, 122, '2014-02-01 00:21:00.000000', 'temperatura', 929.0000, 'ºC'),
	(184949, 122, '2014-02-01 00:21:01.000000', 'temperatura', 828.0000, 'ºC'),
	(184950, 122, '2014-02-01 00:21:02.000000', 'temperatura', 152.0000, 'ºC'),
	(184951, 122, '2014-02-01 00:21:03.000000', 'temperatura', 679.0000, 'ºC'),
	(184952, 122, '2014-02-01 00:21:04.000000', 'temperatura', 541.0000, 'ºC'),
	(184953, 122, '2014-02-01 00:21:05.000000', 'temperatura', 665.0000, 'ºC'),
	(184954, 122, '2014-02-01 00:21:06.000000', 'temperatura', 505.0000, 'ºC'),
	(184955, 122, '2014-02-01 00:21:07.000000', 'temperatura', 529.0000, 'ºC'),
	(184956, 122, '2014-02-01 00:21:08.000000', 'temperatura', 1132.0000, 'ºC'),
	(184957, 122, '2014-02-01 00:21:09.000000', 'temperatura', 473.0000, 'ºC'),
	(184958, 122, '2014-02-01 00:21:10.000000', 'temperatura', 171.0000, 'ºC'),
	(184959, 122, '2014-02-01 00:21:11.000000', 'temperatura', 636.0000, 'ºC'),
	(184960, 122, '2014-02-01 00:21:12.000000', 'temperatura', 269.0000, 'ºC'),
	(184961, 122, '2014-02-01 00:21:13.000000', 'temperatura', 637.0000, 'ºC'),
	(184962, 122, '2014-02-01 00:21:14.000000', 'temperatura', 1176.0000, 'ºC'),
	(184963, 122, '2014-02-01 00:21:15.000000', 'temperatura', 372.0000, 'ºC'),
	(184964, 122, '2014-02-01 00:21:16.000000', 'temperatura', 732.0000, 'ºC'),
	(184965, 122, '2014-02-01 00:21:17.000000', 'temperatura', 146.0000, 'ºC'),
	(184966, 122, '2014-02-01 00:21:18.000000', 'temperatura', 932.0000, 'ºC'),
	(184967, 122, '2014-02-01 00:21:19.000000', 'temperatura', 622.0000, 'ºC'),
	(184968, 122, '2014-02-01 00:21:20.000000', 'temperatura', 314.0000, 'ºC'),
	(184969, 122, '2014-02-01 00:21:21.000000', 'temperatura', 907.0000, 'ºC'),
	(184970, 122, '2014-02-01 00:21:22.000000', 'temperatura', 1191.0000, 'ºC'),
	(184971, 122, '2014-02-01 00:21:23.000000', 'temperatura', 834.0000, 'ºC'),
	(184972, 122, '2014-02-01 00:21:24.000000', 'temperatura', 597.0000, 'ºC'),
	(184973, 122, '2014-02-01 00:21:25.000000', 'temperatura', 483.0000, 'ºC'),
	(184974, 122, '2014-02-01 00:21:26.000000', 'temperatura', 626.0000, 'ºC'),
	(184975, 122, '2014-02-01 00:21:27.000000', 'temperatura', 481.0000, 'ºC'),
	(184976, 122, '2014-02-01 00:21:28.000000', 'temperatura', 530.0000, 'ºC'),
	(184977, 122, '2014-02-01 00:21:29.000000', 'temperatura', 5.0000, 'ºC'),
	(184978, 122, '2014-02-01 00:21:30.000000', 'temperatura', 834.0000, 'ºC'),
	(184979, 122, '2014-02-01 00:21:31.000000', 'temperatura', 558.0000, 'ºC'),
	(184980, 122, '2014-02-01 00:21:32.000000', 'temperatura', 289.0000, 'ºC'),
	(184981, 122, '2014-02-01 00:21:33.000000', 'temperatura', 971.0000, 'ºC'),
	(184982, 122, '2014-02-01 00:21:34.000000', 'temperatura', 386.0000, 'ºC'),
	(184983, 122, '2014-02-01 00:21:35.000000', 'temperatura', 220.0000, 'ºC'),
	(184984, 122, '2014-02-01 00:21:36.000000', 'temperatura', 1141.0000, 'ºC'),
	(184985, 122, '2014-02-01 00:21:37.000000', 'temperatura', 248.0000, 'ºC'),
	(184986, 122, '2014-02-01 00:21:38.000000', 'temperatura', 217.0000, 'ºC'),
	(184987, 122, '2014-02-01 00:21:39.000000', 'temperatura', 341.0000, 'ºC'),
	(184988, 122, '2014-02-01 00:21:40.000000', 'temperatura', 1054.0000, 'ºC'),
	(184989, 122, '2014-02-01 00:21:41.000000', 'temperatura', 648.0000, 'ºC'),
	(184990, 122, '2014-02-01 00:21:42.000000', 'temperatura', 79.0000, 'ºC'),
	(184991, 122, '2014-02-01 00:21:43.000000', 'temperatura', 850.0000, 'ºC'),
	(184992, 122, '2014-02-01 00:21:44.000000', 'temperatura', 415.0000, 'ºC'),
	(184993, 122, '2014-02-01 00:21:45.000000', 'temperatura', 725.0000, 'ºC'),
	(184994, 122, '2014-02-01 00:21:46.000000', 'temperatura', 1181.0000, 'ºC'),
	(184995, 122, '2014-02-01 00:21:47.000000', 'temperatura', 131.0000, 'ºC'),
	(184996, 122, '2014-02-01 00:21:48.000000', 'temperatura', 710.0000, 'ºC'),
	(184997, 122, '2014-02-01 00:21:49.000000', 'temperatura', 759.0000, 'ºC'),
	(184998, 122, '2014-02-01 00:21:50.000000', 'temperatura', 467.0000, 'ºC'),
	(184999, 122, '2014-02-01 00:21:51.000000', 'temperatura', 58.0000, 'ºC'),
	(185000, 122, '2014-02-01 00:21:52.000000', 'temperatura', 87.0000, 'ºC'),
	(185001, 122, '2014-02-01 00:21:53.000000', 'temperatura', 265.0000, 'ºC'),
	(185002, 122, '2014-02-01 00:21:54.000000', 'temperatura', 1062.0000, 'ºC'),
	(185003, 122, '2014-02-01 00:21:55.000000', 'temperatura', 915.0000, 'ºC'),
	(185004, 122, '2014-02-01 00:21:56.000000', 'temperatura', 190.0000, 'ºC'),
	(185005, 122, '2014-02-01 00:21:57.000000', 'temperatura', 605.0000, 'ºC'),
	(185006, 122, '2014-02-01 00:21:58.000000', 'temperatura', 54.0000, 'ºC'),
	(185007, 122, '2014-02-01 00:21:59.000000', 'temperatura', 857.0000, 'ºC'),
	(185008, 122, '2014-02-01 00:22:00.000000', 'temperatura', 524.0000, 'ºC'),
	(185009, 122, '2014-02-01 00:22:01.000000', 'temperatura', 47.0000, 'ºC'),
	(185010, 122, '2014-02-01 00:22:02.000000', 'temperatura', 1066.0000, 'ºC'),
	(185011, 122, '2014-02-01 00:22:03.000000', 'temperatura', 389.0000, 'ºC'),
	(185012, 122, '2014-02-01 00:22:04.000000', 'temperatura', 1146.0000, 'ºC'),
	(185013, 122, '2014-02-01 00:22:05.000000', 'temperatura', 963.0000, 'ºC'),
	(185014, 122, '2014-02-01 00:22:06.000000', 'temperatura', 179.0000, 'ºC'),
	(185015, 122, '2014-02-01 00:22:07.000000', 'temperatura', 405.0000, 'ºC'),
	(185016, 122, '2014-02-01 00:22:08.000000', 'temperatura', 291.0000, 'ºC'),
	(185017, 122, '2014-02-01 00:22:09.000000', 'temperatura', 241.0000, 'ºC'),
	(185018, 122, '2014-02-01 00:22:10.000000', 'temperatura', 329.0000, 'ºC'),
	(185019, 122, '2014-02-01 00:22:11.000000', 'temperatura', 925.0000, 'ºC'),
	(185020, 122, '2014-02-01 00:22:12.000000', 'temperatura', 38.0000, 'ºC'),
	(185021, 122, '2014-02-01 00:22:13.000000', 'temperatura', 1016.0000, 'ºC'),
	(185022, 122, '2014-02-01 00:22:14.000000', 'temperatura', 167.0000, 'ºC'),
	(185023, 122, '2014-02-01 00:22:15.000000', 'temperatura', 188.0000, 'ºC'),
	(185024, 122, '2014-02-01 00:22:16.000000', 'temperatura', 437.0000, 'ºC'),
	(185025, 122, '2014-02-01 00:22:17.000000', 'temperatura', 421.0000, 'ºC'),
	(185026, 122, '2014-02-01 00:22:18.000000', 'temperatura', 795.0000, 'ºC'),
	(185027, 122, '2014-02-01 00:22:19.000000', 'temperatura', 314.0000, 'ºC'),
	(185028, 122, '2014-02-01 00:22:20.000000', 'temperatura', 383.0000, 'ºC'),
	(185029, 122, '2014-02-01 00:22:21.000000', 'temperatura', 977.0000, 'ºC'),
	(185030, 122, '2014-02-01 00:22:22.000000', 'temperatura', 134.0000, 'ºC'),
	(185031, 122, '2014-02-01 00:22:23.000000', 'temperatura', 139.0000, 'ºC'),
	(185032, 122, '2014-02-01 00:22:24.000000', 'temperatura', 294.0000, 'ºC'),
	(185033, 122, '2014-02-01 00:22:25.000000', 'temperatura', 1055.0000, 'ºC'),
	(185034, 122, '2014-02-01 00:22:26.000000', 'temperatura', 791.0000, 'ºC'),
	(185035, 122, '2014-02-01 00:22:27.000000', 'temperatura', 793.0000, 'ºC'),
	(185036, 122, '2014-02-01 00:22:28.000000', 'temperatura', 392.0000, 'ºC'),
	(185037, 122, '2014-02-01 00:22:29.000000', 'temperatura', 783.0000, 'ºC'),
	(185038, 122, '2014-02-01 00:22:30.000000', 'temperatura', 339.0000, 'ºC'),
	(185039, 122, '2014-02-01 00:22:31.000000', 'temperatura', 547.0000, 'ºC'),
	(185040, 122, '2014-02-01 00:22:32.000000', 'temperatura', 517.0000, 'ºC'),
	(185041, 122, '2014-02-01 00:22:33.000000', 'temperatura', 946.0000, 'ºC'),
	(185042, 122, '2014-02-01 00:22:34.000000', 'temperatura', 780.0000, 'ºC'),
	(185043, 122, '2014-02-01 00:22:35.000000', 'temperatura', 1063.0000, 'ºC'),
	(185044, 122, '2014-02-01 00:22:36.000000', 'temperatura', 577.0000, 'ºC'),
	(185045, 122, '2014-02-01 00:22:37.000000', 'temperatura', 893.0000, 'ºC'),
	(185046, 122, '2014-02-01 00:22:38.000000', 'temperatura', 335.0000, 'ºC'),
	(185047, 122, '2014-02-01 00:22:39.000000', 'temperatura', 195.0000, 'ºC'),
	(185048, 122, '2014-02-01 00:22:40.000000', 'temperatura', 1173.0000, 'ºC'),
	(185049, 122, '2014-02-01 00:22:41.000000', 'temperatura', 482.0000, 'ºC'),
	(185050, 122, '2014-02-01 00:22:42.000000', 'temperatura', 89.0000, 'ºC'),
	(185051, 122, '2014-02-01 00:22:43.000000', 'temperatura', 199.0000, 'ºC'),
	(185052, 122, '2014-02-01 00:22:44.000000', 'temperatura', 731.0000, 'ºC'),
	(185053, 122, '2014-02-01 00:22:45.000000', 'temperatura', 655.0000, 'ºC'),
	(185054, 122, '2014-02-01 00:22:46.000000', 'temperatura', 1086.0000, 'ºC'),
	(185055, 122, '2014-02-01 00:22:47.000000', 'temperatura', 1065.0000, 'ºC'),
	(185056, 122, '2014-02-01 00:22:48.000000', 'temperatura', 868.0000, 'ºC'),
	(185057, 122, '2014-02-01 00:22:49.000000', 'temperatura', 1144.0000, 'ºC'),
	(185058, 122, '2014-02-01 00:22:50.000000', 'temperatura', 718.0000, 'ºC'),
	(185059, 122, '2014-02-01 00:22:51.000000', 'temperatura', 156.0000, 'ºC'),
	(185060, 122, '2014-02-01 00:22:52.000000', 'temperatura', 1028.0000, 'ºC'),
	(185061, 122, '2014-02-01 00:22:53.000000', 'temperatura', 1072.0000, 'ºC'),
	(185062, 122, '2014-02-01 00:22:54.000000', 'temperatura', 1077.0000, 'ºC'),
	(185063, 122, '2014-02-01 00:22:55.000000', 'temperatura', 968.0000, 'ºC'),
	(185064, 122, '2014-02-01 00:22:56.000000', 'temperatura', 410.0000, 'ºC'),
	(185065, 122, '2014-02-01 00:22:57.000000', 'temperatura', 346.0000, 'ºC'),
	(185066, 122, '2014-02-01 00:22:58.000000', 'temperatura', 503.0000, 'ºC'),
	(185067, 122, '2014-02-01 00:22:59.000000', 'temperatura', 276.0000, 'ºC'),
	(185068, 122, '2014-02-01 00:23:00.000000', 'temperatura', 1071.0000, 'ºC'),
	(185069, 122, '2014-02-01 00:23:01.000000', 'temperatura', 927.0000, 'ºC'),
	(185070, 122, '2014-02-01 00:23:02.000000', 'temperatura', 224.0000, 'ºC'),
	(185071, 122, '2014-02-01 00:23:03.000000', 'temperatura', 739.0000, 'ºC'),
	(185072, 122, '2014-02-01 00:23:04.000000', 'temperatura', 623.0000, 'ºC'),
	(185073, 122, '2014-02-01 00:23:05.000000', 'temperatura', 900.0000, 'ºC'),
	(185074, 122, '2014-02-01 00:23:06.000000', 'temperatura', 230.0000, 'ºC'),
	(185075, 122, '2014-02-01 00:23:07.000000', 'temperatura', 852.0000, 'ºC'),
	(185076, 122, '2014-02-01 00:23:08.000000', 'temperatura', 1170.0000, 'ºC'),
	(185077, 122, '2014-02-01 00:23:09.000000', 'temperatura', 896.0000, 'ºC'),
	(185078, 122, '2014-02-01 00:23:10.000000', 'temperatura', 969.0000, 'ºC'),
	(185079, 122, '2014-02-01 00:23:11.000000', 'temperatura', 959.0000, 'ºC'),
	(185080, 122, '2014-02-01 00:23:12.000000', 'temperatura', 688.0000, 'ºC'),
	(185081, 122, '2014-02-01 00:23:13.000000', 'temperatura', 565.0000, 'ºC'),
	(185082, 122, '2014-02-01 00:23:14.000000', 'temperatura', 759.0000, 'ºC'),
	(185083, 122, '2014-02-01 00:23:15.000000', 'temperatura', 903.0000, 'ºC'),
	(185084, 122, '2014-02-01 00:23:16.000000', 'temperatura', 1038.0000, 'ºC'),
	(185085, 122, '2014-02-01 00:23:17.000000', 'temperatura', 83.0000, 'ºC'),
	(185086, 122, '2014-02-01 00:23:18.000000', 'temperatura', 899.0000, 'ºC'),
	(185087, 122, '2014-02-01 00:23:19.000000', 'temperatura', 646.0000, 'ºC'),
	(185088, 122, '2014-02-01 00:23:20.000000', 'temperatura', 536.0000, 'ºC'),
	(185089, 122, '2014-02-01 00:23:21.000000', 'temperatura', 743.0000, 'ºC'),
	(185090, 122, '2014-02-01 00:23:22.000000', 'temperatura', 907.0000, 'ºC'),
	(185091, 122, '2014-02-01 00:23:23.000000', 'temperatura', 1107.0000, 'ºC'),
	(185092, 122, '2014-02-01 00:23:24.000000', 'temperatura', 416.0000, 'ºC'),
	(185093, 122, '2014-02-01 00:23:25.000000', 'temperatura', 1157.0000, 'ºC'),
	(185094, 122, '2014-02-01 00:23:26.000000', 'temperatura', 937.0000, 'ºC'),
	(185095, 122, '2014-02-01 00:23:27.000000', 'temperatura', 16.0000, 'ºC'),
	(185096, 122, '2014-02-01 00:23:28.000000', 'temperatura', 869.0000, 'ºC'),
	(185097, 122, '2014-02-01 00:23:29.000000', 'temperatura', 698.0000, 'ºC'),
	(185098, 122, '2014-02-01 00:23:30.000000', 'temperatura', 885.0000, 'ºC'),
	(185099, 122, '2014-02-01 00:23:31.000000', 'temperatura', 1131.0000, 'ºC'),
	(185100, 122, '2014-02-01 00:23:32.000000', 'temperatura', 598.0000, 'ºC'),
	(185101, 122, '2014-02-01 00:23:33.000000', 'temperatura', 799.0000, 'ºC'),
	(185102, 122, '2014-02-01 00:23:34.000000', 'temperatura', 1003.0000, 'ºC'),
	(185103, 122, '2014-02-01 00:23:35.000000', 'temperatura', 217.0000, 'ºC'),
	(185104, 122, '2014-02-01 00:23:36.000000', 'temperatura', 478.0000, 'ºC'),
	(185105, 122, '2014-02-01 00:23:37.000000', 'temperatura', 538.0000, 'ºC'),
	(185106, 122, '2014-02-01 00:23:38.000000', 'temperatura', 55.0000, 'ºC'),
	(185107, 122, '2014-02-01 00:23:39.000000', 'temperatura', 1063.0000, 'ºC'),
	(185108, 122, '2014-02-01 00:23:40.000000', 'temperatura', 350.0000, 'ºC'),
	(185109, 122, '2014-02-01 00:23:41.000000', 'temperatura', 963.0000, 'ºC'),
	(185110, 122, '2014-02-01 00:23:42.000000', 'temperatura', 165.0000, 'ºC'),
	(185111, 122, '2014-02-01 00:23:43.000000', 'temperatura', 337.0000, 'ºC'),
	(185112, 122, '2014-02-01 00:23:44.000000', 'temperatura', 1191.0000, 'ºC'),
	(185113, 122, '2014-02-01 00:23:45.000000', 'temperatura', 144.0000, 'ºC'),
	(185114, 122, '2014-02-01 00:23:46.000000', 'temperatura', 747.0000, 'ºC'),
	(185115, 122, '2014-02-01 00:23:47.000000', 'temperatura', 902.0000, 'ºC'),
	(185116, 122, '2014-02-01 00:23:48.000000', 'temperatura', 1072.0000, 'ºC'),
	(185117, 122, '2014-02-01 00:23:49.000000', 'temperatura', 254.0000, 'ºC'),
	(185118, 122, '2014-02-01 00:23:50.000000', 'temperatura', 454.0000, 'ºC'),
	(185119, 122, '2014-02-01 00:23:51.000000', 'temperatura', 308.0000, 'ºC'),
	(185120, 122, '2014-02-01 00:23:52.000000', 'temperatura', 181.0000, 'ºC'),
	(185121, 122, '2014-02-01 00:23:53.000000', 'temperatura', 1178.0000, 'ºC'),
	(185122, 122, '2014-02-01 00:23:54.000000', 'temperatura', 550.0000, 'ºC'),
	(185123, 122, '2014-02-01 00:23:55.000000', 'temperatura', 416.0000, 'ºC'),
	(185124, 122, '2014-02-01 00:23:56.000000', 'temperatura', 430.0000, 'ºC'),
	(185125, 122, '2014-02-01 00:23:57.000000', 'temperatura', 904.0000, 'ºC'),
	(185126, 122, '2014-02-01 00:23:58.000000', 'temperatura', 829.0000, 'ºC'),
	(185127, 122, '2014-02-01 00:23:59.000000', 'temperatura', 235.0000, 'ºC'),
	(185128, 122, '2014-02-01 00:24:00.000000', 'temperatura', 1090.0000, 'ºC'),
	(185129, 122, '2014-02-01 00:24:01.000000', 'temperatura', 1143.0000, 'ºC'),
	(185130, 122, '2014-02-01 00:24:02.000000', 'temperatura', 46.0000, 'ºC'),
	(185131, 122, '2014-02-01 00:24:03.000000', 'temperatura', 401.0000, 'ºC'),
	(185132, 122, '2014-02-01 00:24:04.000000', 'temperatura', 670.0000, 'ºC'),
	(185133, 122, '2014-02-01 00:24:05.000000', 'temperatura', 945.0000, 'ºC'),
	(185134, 122, '2014-02-01 00:24:06.000000', 'temperatura', 318.0000, 'ºC'),
	(185135, 122, '2014-02-01 00:24:07.000000', 'temperatura', 1154.0000, 'ºC'),
	(185136, 122, '2014-02-01 00:24:08.000000', 'temperatura', 17.0000, 'ºC'),
	(185137, 122, '2014-02-01 00:24:09.000000', 'temperatura', 221.0000, 'ºC'),
	(185138, 122, '2014-02-01 00:24:10.000000', 'temperatura', 1057.0000, 'ºC'),
	(185139, 122, '2014-02-01 00:24:11.000000', 'temperatura', 1022.0000, 'ºC'),
	(185140, 122, '2014-02-01 00:24:12.000000', 'temperatura', 741.0000, 'ºC'),
	(185141, 122, '2014-02-01 00:24:13.000000', 'temperatura', 640.0000, 'ºC'),
	(185142, 122, '2014-02-01 00:24:14.000000', 'temperatura', 975.0000, 'ºC'),
	(185143, 122, '2014-02-01 00:24:15.000000', 'temperatura', 558.0000, 'ºC'),
	(185144, 122, '2014-02-01 00:24:16.000000', 'temperatura', 1066.0000, 'ºC'),
	(185145, 122, '2014-02-01 00:24:17.000000', 'temperatura', 57.0000, 'ºC'),
	(185146, 122, '2014-02-01 00:24:18.000000', 'temperatura', 686.0000, 'ºC'),
	(185147, 122, '2014-02-01 00:24:19.000000', 'temperatura', 860.0000, 'ºC'),
	(185148, 122, '2014-02-01 00:24:20.000000', 'temperatura', 1044.0000, 'ºC'),
	(185149, 122, '2014-02-01 00:24:21.000000', 'temperatura', 237.0000, 'ºC'),
	(185150, 122, '2014-02-01 00:24:22.000000', 'temperatura', 457.0000, 'ºC'),
	(185151, 122, '2014-02-01 00:24:23.000000', 'temperatura', 372.0000, 'ºC'),
	(185152, 122, '2014-02-01 00:24:24.000000', 'temperatura', 490.0000, 'ºC'),
	(185153, 122, '2014-02-01 00:24:25.000000', 'temperatura', 136.0000, 'ºC'),
	(185154, 122, '2014-02-01 00:24:26.000000', 'temperatura', 409.0000, 'ºC'),
	(185155, 122, '2014-02-01 00:24:27.000000', 'temperatura', 438.0000, 'ºC'),
	(185156, 122, '2014-02-01 00:24:28.000000', 'temperatura', 965.0000, 'ºC'),
	(185157, 122, '2014-02-01 00:24:29.000000', 'temperatura', 1111.0000, 'ºC'),
	(185158, 122, '2014-02-01 00:24:30.000000', 'temperatura', 262.0000, 'ºC'),
	(185159, 122, '2014-02-01 00:24:31.000000', 'temperatura', 375.0000, 'ºC'),
	(185160, 122, '2014-02-01 00:24:32.000000', 'temperatura', 1091.0000, 'ºC'),
	(185161, 122, '2014-02-01 00:24:33.000000', 'temperatura', 729.0000, 'ºC'),
	(185162, 122, '2014-02-01 00:24:34.000000', 'temperatura', 375.0000, 'ºC'),
	(185163, 122, '2014-02-01 00:24:35.000000', 'temperatura', 887.0000, 'ºC'),
	(185164, 122, '2014-02-01 00:24:36.000000', 'temperatura', 912.0000, 'ºC'),
	(185165, 122, '2014-02-01 00:24:37.000000', 'temperatura', 697.0000, 'ºC'),
	(185166, 122, '2014-02-01 00:24:38.000000', 'temperatura', 751.0000, 'ºC'),
	(185167, 122, '2014-02-01 00:24:39.000000', 'temperatura', 463.0000, 'ºC'),
	(185168, 122, '2014-02-01 00:24:40.000000', 'temperatura', 65.0000, 'ºC'),
	(185169, 122, '2014-02-01 00:24:41.000000', 'temperatura', 135.0000, 'ºC'),
	(185170, 122, '2014-02-01 00:24:42.000000', 'temperatura', 480.0000, 'ºC'),
	(185171, 122, '2014-02-01 00:24:43.000000', 'temperatura', 797.0000, 'ºC'),
	(185172, 122, '2014-02-01 00:24:44.000000', 'temperatura', 144.0000, 'ºC'),
	(185173, 122, '2014-02-01 00:24:45.000000', 'temperatura', 729.0000, 'ºC'),
	(185174, 122, '2014-02-01 00:24:46.000000', 'temperatura', 812.0000, 'ºC'),
	(185175, 122, '2014-02-01 00:24:47.000000', 'temperatura', 677.0000, 'ºC'),
	(185176, 122, '2014-02-01 00:24:48.000000', 'temperatura', 948.0000, 'ºC'),
	(185177, 122, '2014-02-01 00:24:49.000000', 'temperatura', 310.0000, 'ºC'),
	(185178, 122, '2014-02-01 00:24:50.000000', 'temperatura', 1108.0000, 'ºC'),
	(185179, 122, '2014-02-01 00:24:51.000000', 'temperatura', 1010.0000, 'ºC'),
	(185180, 122, '2014-02-01 00:24:52.000000', 'temperatura', 528.0000, 'ºC'),
	(185181, 122, '2014-02-01 00:24:53.000000', 'temperatura', 807.0000, 'ºC'),
	(185182, 122, '2014-02-01 00:24:54.000000', 'temperatura', 53.0000, 'ºC'),
	(185183, 122, '2014-02-01 00:24:55.000000', 'temperatura', 246.0000, 'ºC'),
	(185184, 122, '2014-02-01 00:24:56.000000', 'temperatura', 1069.0000, 'ºC'),
	(185185, 122, '2014-02-01 00:24:57.000000', 'temperatura', 1008.0000, 'ºC'),
	(185186, 122, '2014-02-01 00:24:58.000000', 'temperatura', 635.0000, 'ºC'),
	(185187, 122, '2014-02-01 00:24:59.000000', 'temperatura', 151.0000, 'ºC'),
	(185188, 122, '2014-02-01 00:25:00.000000', 'temperatura', 50.0000, 'ºC'),
	(185189, 122, '2014-02-01 00:25:01.000000', 'temperatura', 1000.0000, 'ºC'),
	(185190, 122, '2014-02-01 00:25:02.000000', 'temperatura', 47.0000, 'ºC'),
	(185191, 122, '2014-02-01 00:25:03.000000', 'temperatura', 838.0000, 'ºC'),
	(185192, 122, '2014-02-01 00:25:04.000000', 'temperatura', 448.0000, 'ºC'),
	(185193, 122, '2014-02-01 00:25:05.000000', 'temperatura', 926.0000, 'ºC'),
	(185194, 122, '2014-02-01 00:25:06.000000', 'temperatura', 886.0000, 'ºC'),
	(185195, 122, '2014-02-01 00:25:07.000000', 'temperatura', 452.0000, 'ºC'),
	(185196, 122, '2014-02-01 00:25:08.000000', 'temperatura', 805.0000, 'ºC'),
	(185197, 122, '2014-02-01 00:25:09.000000', 'temperatura', 268.0000, 'ºC'),
	(185198, 122, '2014-02-01 00:25:10.000000', 'temperatura', 127.0000, 'ºC'),
	(185199, 122, '2014-02-01 00:25:11.000000', 'temperatura', 1032.0000, 'ºC'),
	(185200, 122, '2014-02-01 00:25:12.000000', 'temperatura', 1180.0000, 'ºC'),
	(185201, 122, '2014-02-01 00:25:13.000000', 'temperatura', 405.0000, 'ºC'),
	(185202, 122, '2014-02-01 00:25:14.000000', 'temperatura', 884.0000, 'ºC'),
	(185203, 122, '2014-02-01 00:25:15.000000', 'temperatura', 806.0000, 'ºC'),
	(185204, 122, '2014-02-01 00:25:16.000000', 'temperatura', 177.0000, 'ºC'),
	(185205, 122, '2014-02-01 00:25:17.000000', 'temperatura', 868.0000, 'ºC'),
	(185206, 122, '2014-02-01 00:25:18.000000', 'temperatura', 212.0000, 'ºC'),
	(185207, 122, '2014-02-01 00:25:19.000000', 'temperatura', 854.0000, 'ºC'),
	(185208, 122, '2014-02-01 00:25:20.000000', 'temperatura', 36.0000, 'ºC'),
	(185209, 122, '2014-02-01 00:25:21.000000', 'temperatura', 19.0000, 'ºC'),
	(185210, 122, '2014-02-01 00:25:22.000000', 'temperatura', 1187.0000, 'ºC'),
	(185211, 122, '2014-02-01 00:25:23.000000', 'temperatura', 1079.0000, 'ºC'),
	(185212, 122, '2014-02-01 00:25:24.000000', 'temperatura', 634.0000, 'ºC'),
	(185213, 122, '2014-02-01 00:25:25.000000', 'temperatura', 1132.0000, 'ºC'),
	(185214, 122, '2014-02-01 00:25:26.000000', 'temperatura', 158.0000, 'ºC'),
	(185215, 122, '2014-02-01 00:25:27.000000', 'temperatura', 997.0000, 'ºC'),
	(185216, 122, '2014-02-01 00:25:28.000000', 'temperatura', 913.0000, 'ºC'),
	(185217, 122, '2014-02-01 00:25:29.000000', 'temperatura', 371.0000, 'ºC'),
	(185218, 122, '2014-02-01 00:25:30.000000', 'temperatura', 317.0000, 'ºC'),
	(185219, 122, '2014-02-01 00:25:31.000000', 'temperatura', 474.0000, 'ºC'),
	(185220, 122, '2014-02-01 00:25:32.000000', 'temperatura', 219.0000, 'ºC'),
	(185221, 122, '2014-02-01 00:25:33.000000', 'temperatura', 873.0000, 'ºC'),
	(185222, 122, '2014-02-01 00:25:34.000000', 'temperatura', 108.0000, 'ºC'),
	(185223, 122, '2014-02-01 00:25:35.000000', 'temperatura', 323.0000, 'ºC'),
	(185224, 122, '2014-02-01 00:25:36.000000', 'temperatura', 89.0000, 'ºC'),
	(185225, 122, '2014-02-01 00:25:37.000000', 'temperatura', 677.0000, 'ºC'),
	(185226, 122, '2014-02-01 00:25:38.000000', 'temperatura', 718.0000, 'ºC'),
	(185227, 122, '2014-02-01 00:25:39.000000', 'temperatura', 358.0000, 'ºC'),
	(185228, 122, '2014-02-01 00:25:40.000000', 'temperatura', 839.0000, 'ºC'),
	(185229, 122, '2014-02-01 00:25:41.000000', 'temperatura', 720.0000, 'ºC'),
	(185230, 122, '2014-02-01 00:25:42.000000', 'temperatura', 1083.0000, 'ºC'),
	(185231, 122, '2014-02-01 00:25:43.000000', 'temperatura', 858.0000, 'ºC'),
	(185232, 122, '2014-02-01 00:25:44.000000', 'temperatura', 1039.0000, 'ºC'),
	(185233, 122, '2014-02-01 00:25:45.000000', 'temperatura', 221.0000, 'ºC'),
	(185234, 122, '2014-02-01 00:25:46.000000', 'temperatura', 390.0000, 'ºC'),
	(185235, 122, '2014-02-01 00:25:47.000000', 'temperatura', 89.0000, 'ºC'),
	(185236, 122, '2014-02-01 00:25:48.000000', 'temperatura', 472.0000, 'ºC'),
	(185237, 122, '2014-02-01 00:25:49.000000', 'temperatura', 896.0000, 'ºC'),
	(185238, 122, '2014-02-01 00:25:50.000000', 'temperatura', 665.0000, 'ºC'),
	(185239, 122, '2014-02-01 00:25:51.000000', 'temperatura', 638.0000, 'ºC'),
	(185240, 122, '2014-02-01 00:25:52.000000', 'temperatura', 1193.0000, 'ºC'),
	(185241, 122, '2014-02-01 00:25:53.000000', 'temperatura', 452.0000, 'ºC'),
	(185242, 122, '2014-02-01 00:25:54.000000', 'temperatura', 1082.0000, 'ºC'),
	(185243, 122, '2014-02-01 00:25:55.000000', 'temperatura', 452.0000, 'ºC'),
	(185244, 122, '2014-02-01 00:25:56.000000', 'temperatura', 218.0000, 'ºC'),
	(185245, 122, '2014-02-01 00:25:57.000000', 'temperatura', 934.0000, 'ºC'),
	(185246, 122, '2014-02-01 00:25:58.000000', 'temperatura', 414.0000, 'ºC'),
	(185247, 122, '2014-02-01 00:25:59.000000', 'temperatura', 470.0000, 'ºC'),
	(185248, 122, '2014-02-01 00:26:00.000000', 'temperatura', 1106.0000, 'ºC'),
	(185249, 122, '2014-02-01 00:26:01.000000', 'temperatura', 524.0000, 'ºC'),
	(185250, 122, '2014-02-01 00:26:02.000000', 'temperatura', 501.0000, 'ºC'),
	(185251, 122, '2014-02-01 00:26:03.000000', 'temperatura', 934.0000, 'ºC'),
	(185252, 122, '2014-02-01 00:26:04.000000', 'temperatura', 769.0000, 'ºC'),
	(185253, 122, '2014-02-01 00:26:05.000000', 'temperatura', 1044.0000, 'ºC'),
	(185254, 122, '2014-02-01 00:26:06.000000', 'temperatura', 510.0000, 'ºC'),
	(185255, 122, '2014-02-01 00:26:07.000000', 'temperatura', 622.0000, 'ºC'),
	(185256, 122, '2014-02-01 00:26:08.000000', 'temperatura', 378.0000, 'ºC'),
	(185257, 122, '2014-02-01 00:26:09.000000', 'temperatura', 26.0000, 'ºC'),
	(185258, 122, '2014-02-01 00:26:10.000000', 'temperatura', 194.0000, 'ºC'),
	(185259, 122, '2014-02-01 00:26:11.000000', 'temperatura', 895.0000, 'ºC'),
	(185260, 122, '2014-02-01 00:26:12.000000', 'temperatura', 292.0000, 'ºC'),
	(185261, 122, '2014-02-01 00:26:13.000000', 'temperatura', 1174.0000, 'ºC'),
	(185262, 122, '2014-02-01 00:26:14.000000', 'temperatura', 196.0000, 'ºC'),
	(185263, 122, '2014-02-01 00:26:15.000000', 'temperatura', 1059.0000, 'ºC'),
	(185264, 122, '2014-02-01 00:26:16.000000', 'temperatura', 1107.0000, 'ºC'),
	(185265, 122, '2014-02-01 00:26:17.000000', 'temperatura', 1160.0000, 'ºC'),
	(185266, 122, '2014-02-01 00:26:18.000000', 'temperatura', 79.0000, 'ºC'),
	(185267, 122, '2014-02-01 00:26:19.000000', 'temperatura', 515.0000, 'ºC'),
	(185268, 122, '2014-02-01 00:26:20.000000', 'temperatura', 1139.0000, 'ºC'),
	(185269, 122, '2014-02-01 00:26:21.000000', 'temperatura', 551.0000, 'ºC'),
	(185270, 122, '2014-02-01 00:26:22.000000', 'temperatura', 538.0000, 'ºC'),
	(185271, 122, '2014-02-01 00:26:23.000000', 'temperatura', 1037.0000, 'ºC'),
	(185272, 122, '2014-02-01 00:26:24.000000', 'temperatura', 1172.0000, 'ºC'),
	(185273, 122, '2014-02-01 00:26:25.000000', 'temperatura', 351.0000, 'ºC'),
	(185274, 122, '2014-02-01 00:26:26.000000', 'temperatura', 639.0000, 'ºC'),
	(185275, 122, '2014-02-01 00:26:27.000000', 'temperatura', 944.0000, 'ºC'),
	(185276, 122, '2014-02-01 00:26:28.000000', 'temperatura', 402.0000, 'ºC'),
	(185277, 122, '2014-02-01 00:26:29.000000', 'temperatura', 379.0000, 'ºC'),
	(185278, 122, '2014-02-01 00:26:30.000000', 'temperatura', 688.0000, 'ºC'),
	(185279, 122, '2014-02-01 00:26:31.000000', 'temperatura', 1103.0000, 'ºC'),
	(185280, 122, '2014-02-01 00:26:32.000000', 'temperatura', 1053.0000, 'ºC'),
	(185281, 122, '2014-02-01 00:26:33.000000', 'temperatura', 755.0000, 'ºC'),
	(185282, 122, '2014-02-01 00:26:34.000000', 'temperatura', 616.0000, 'ºC'),
	(185283, 122, '2014-02-01 00:26:35.000000', 'temperatura', 818.0000, 'ºC'),
	(185284, 122, '2014-02-01 00:26:36.000000', 'temperatura', 1042.0000, 'ºC'),
	(185285, 122, '2014-02-01 00:26:37.000000', 'temperatura', 358.0000, 'ºC'),
	(185286, 122, '2014-02-01 00:26:38.000000', 'temperatura', 1063.0000, 'ºC'),
	(185287, 122, '2014-02-01 00:26:39.000000', 'temperatura', 643.0000, 'ºC'),
	(185288, 122, '2014-02-01 00:26:40.000000', 'temperatura', 27.0000, 'ºC'),
	(185289, 122, '2014-02-01 00:26:41.000000', 'temperatura', 605.0000, 'ºC'),
	(185290, 122, '2014-02-01 00:26:42.000000', 'temperatura', 547.0000, 'ºC'),
	(185291, 122, '2014-02-01 00:26:43.000000', 'temperatura', 918.0000, 'ºC'),
	(185292, 122, '2014-02-01 00:26:44.000000', 'temperatura', 549.0000, 'ºC'),
	(185293, 122, '2014-02-01 00:26:45.000000', 'temperatura', 1191.0000, 'ºC'),
	(185294, 122, '2014-02-01 00:26:46.000000', 'temperatura', 709.0000, 'ºC'),
	(185295, 122, '2014-02-01 00:26:47.000000', 'temperatura', 1172.0000, 'ºC'),
	(185296, 122, '2014-02-01 00:26:48.000000', 'temperatura', 135.0000, 'ºC'),
	(185297, 122, '2014-02-01 00:26:49.000000', 'temperatura', 759.0000, 'ºC'),
	(185298, 122, '2014-02-01 00:26:50.000000', 'temperatura', 992.0000, 'ºC'),
	(185299, 122, '2014-02-01 00:26:51.000000', 'temperatura', 281.0000, 'ºC'),
	(185300, 122, '2014-02-01 00:26:52.000000', 'temperatura', 831.0000, 'ºC'),
	(185301, 122, '2014-02-01 00:26:53.000000', 'temperatura', 914.0000, 'ºC'),
	(185302, 122, '2014-02-01 00:26:54.000000', 'temperatura', 876.0000, 'ºC'),
	(185303, 122, '2014-02-01 00:26:55.000000', 'temperatura', 440.0000, 'ºC'),
	(185304, 122, '2014-02-01 00:26:56.000000', 'temperatura', 773.0000, 'ºC'),
	(185305, 122, '2014-02-01 00:26:57.000000', 'temperatura', 145.0000, 'ºC'),
	(185306, 122, '2014-02-01 00:26:58.000000', 'temperatura', 807.0000, 'ºC'),
	(185307, 122, '2014-02-01 00:26:59.000000', 'temperatura', 1199.0000, 'ºC'),
	(185308, 122, '2014-02-01 00:27:00.000000', 'temperatura', 1177.0000, 'ºC'),
	(185309, 122, '2014-02-01 00:27:01.000000', 'temperatura', 1086.0000, 'ºC'),
	(185310, 122, '2014-02-01 00:27:02.000000', 'temperatura', 702.0000, 'ºC'),
	(185311, 122, '2014-02-01 00:27:03.000000', 'temperatura', 251.0000, 'ºC'),
	(185312, 122, '2014-02-01 00:27:04.000000', 'temperatura', 351.0000, 'ºC'),
	(185313, 122, '2014-02-01 00:27:05.000000', 'temperatura', 1003.0000, 'ºC'),
	(185314, 122, '2014-02-01 00:27:06.000000', 'temperatura', 362.0000, 'ºC'),
	(185315, 122, '2014-02-01 00:27:07.000000', 'temperatura', 0.0000, 'ºC'),
	(185316, 122, '2014-02-01 00:27:08.000000', 'temperatura', 116.0000, 'ºC'),
	(185317, 122, '2014-02-01 00:27:09.000000', 'temperatura', 578.0000, 'ºC'),
	(185318, 122, '2014-02-01 00:27:10.000000', 'temperatura', 145.0000, 'ºC'),
	(185319, 122, '2014-02-01 00:27:11.000000', 'temperatura', 190.0000, 'ºC'),
	(185320, 122, '2014-02-01 00:27:12.000000', 'temperatura', 515.0000, 'ºC'),
	(185321, 122, '2014-02-01 00:27:13.000000', 'temperatura', 804.0000, 'ºC'),
	(185322, 122, '2014-02-01 00:27:14.000000', 'temperatura', 79.0000, 'ºC'),
	(185323, 122, '2014-02-01 00:27:15.000000', 'temperatura', 380.0000, 'ºC'),
	(185324, 122, '2014-02-01 00:27:16.000000', 'temperatura', 467.0000, 'ºC'),
	(185325, 122, '2014-02-01 00:27:17.000000', 'temperatura', 1193.0000, 'ºC'),
	(185326, 122, '2014-02-01 00:27:18.000000', 'temperatura', 966.0000, 'ºC'),
	(185327, 122, '2014-02-01 00:27:19.000000', 'temperatura', 52.0000, 'ºC'),
	(185328, 122, '2014-02-01 00:27:20.000000', 'temperatura', 962.0000, 'ºC'),
	(185329, 122, '2014-02-01 00:27:21.000000', 'temperatura', 1053.0000, 'ºC'),
	(185330, 122, '2014-02-01 00:27:22.000000', 'temperatura', 1178.0000, 'ºC'),
	(185331, 122, '2014-02-01 00:27:23.000000', 'temperatura', 335.0000, 'ºC'),
	(185332, 122, '2014-02-01 00:27:24.000000', 'temperatura', 538.0000, 'ºC'),
	(185333, 122, '2014-02-01 00:27:25.000000', 'temperatura', 489.0000, 'ºC'),
	(185334, 122, '2014-02-01 00:27:26.000000', 'temperatura', 831.0000, 'ºC'),
	(185335, 122, '2014-02-01 00:27:27.000000', 'temperatura', 287.0000, 'ºC'),
	(185336, 122, '2014-02-01 00:27:28.000000', 'temperatura', 144.0000, 'ºC'),
	(185337, 122, '2014-02-01 00:27:29.000000', 'temperatura', 1058.0000, 'ºC'),
	(185338, 122, '2014-02-01 00:27:30.000000', 'temperatura', 58.0000, 'ºC'),
	(185339, 122, '2014-02-01 00:27:31.000000', 'temperatura', 717.0000, 'ºC'),
	(185340, 122, '2014-02-01 00:27:32.000000', 'temperatura', 1012.0000, 'ºC'),
	(185341, 122, '2014-02-01 00:27:33.000000', 'temperatura', 511.0000, 'ºC'),
	(185342, 122, '2014-02-01 00:27:34.000000', 'temperatura', 717.0000, 'ºC'),
	(185343, 122, '2014-02-01 00:27:35.000000', 'temperatura', 852.0000, 'ºC'),
	(185344, 122, '2014-02-01 00:27:36.000000', 'temperatura', 909.0000, 'ºC'),
	(185345, 122, '2014-02-01 00:27:37.000000', 'temperatura', 789.0000, 'ºC'),
	(185346, 122, '2014-02-01 00:27:38.000000', 'temperatura', 19.0000, 'ºC'),
	(185347, 122, '2014-02-01 00:27:39.000000', 'temperatura', 128.0000, 'ºC'),
	(185348, 122, '2014-02-01 00:27:40.000000', 'temperatura', 582.0000, 'ºC'),
	(185349, 122, '2014-02-01 00:27:41.000000', 'temperatura', 128.0000, 'ºC'),
	(185350, 122, '2014-02-01 00:27:42.000000', 'temperatura', 95.0000, 'ºC'),
	(185351, 122, '2014-02-01 00:27:43.000000', 'temperatura', 92.0000, 'ºC'),
	(185352, 122, '2014-02-01 00:27:44.000000', 'temperatura', 177.0000, 'ºC'),
	(185353, 122, '2014-02-01 00:27:45.000000', 'temperatura', 607.0000, 'ºC'),
	(185354, 122, '2014-02-01 00:27:46.000000', 'temperatura', 104.0000, 'ºC'),
	(185355, 122, '2014-02-01 00:27:47.000000', 'temperatura', 1101.0000, 'ºC'),
	(185356, 122, '2014-02-01 00:27:48.000000', 'temperatura', 393.0000, 'ºC'),
	(185357, 122, '2014-02-01 00:27:49.000000', 'temperatura', 1061.0000, 'ºC'),
	(185358, 122, '2014-02-01 00:27:50.000000', 'temperatura', 529.0000, 'ºC'),
	(185359, 122, '2014-02-01 00:27:51.000000', 'temperatura', 662.0000, 'ºC'),
	(185360, 122, '2014-02-01 00:27:52.000000', 'temperatura', 523.0000, 'ºC'),
	(185361, 122, '2014-02-01 00:27:53.000000', 'temperatura', 631.0000, 'ºC'),
	(185362, 122, '2014-02-01 00:27:54.000000', 'temperatura', 387.0000, 'ºC'),
	(185363, 122, '2014-02-01 00:27:55.000000', 'temperatura', 41.0000, 'ºC'),
	(185364, 122, '2014-02-01 00:27:56.000000', 'temperatura', 246.0000, 'ºC'),
	(185365, 122, '2014-02-01 00:27:57.000000', 'temperatura', 1108.0000, 'ºC'),
	(185366, 122, '2014-02-01 00:27:58.000000', 'temperatura', 3.0000, 'ºC'),
	(185367, 122, '2014-02-01 00:27:59.000000', 'temperatura', 289.0000, 'ºC'),
	(185368, 122, '2014-02-01 00:28:00.000000', 'temperatura', 239.0000, 'ºC'),
	(185369, 122, '2014-02-01 00:28:01.000000', 'temperatura', 326.0000, 'ºC'),
	(185370, 122, '2014-02-01 00:28:02.000000', 'temperatura', 913.0000, 'ºC'),
	(185371, 122, '2014-02-01 00:28:03.000000', 'temperatura', 1187.0000, 'ºC'),
	(185372, 122, '2014-02-01 00:28:04.000000', 'temperatura', 798.0000, 'ºC'),
	(185373, 122, '2014-02-01 00:28:05.000000', 'temperatura', 428.0000, 'ºC'),
	(185374, 122, '2014-02-01 00:28:06.000000', 'temperatura', 949.0000, 'ºC'),
	(185375, 122, '2014-02-01 00:28:07.000000', 'temperatura', 1059.0000, 'ºC'),
	(185376, 122, '2014-02-01 00:28:08.000000', 'temperatura', 49.0000, 'ºC'),
	(185377, 122, '2014-02-01 00:28:09.000000', 'temperatura', 671.0000, 'ºC'),
	(185378, 122, '2014-02-01 00:28:10.000000', 'temperatura', 806.0000, 'ºC'),
	(185379, 122, '2014-02-01 00:28:11.000000', 'temperatura', 816.0000, 'ºC'),
	(185380, 122, '2014-02-01 00:28:12.000000', 'temperatura', 465.0000, 'ºC'),
	(185381, 122, '2014-02-01 00:28:13.000000', 'temperatura', 1077.0000, 'ºC'),
	(185382, 122, '2014-02-01 00:28:14.000000', 'temperatura', 389.0000, 'ºC'),
	(185383, 122, '2014-02-01 00:28:15.000000', 'temperatura', 1116.0000, 'ºC'),
	(185384, 122, '2014-02-01 00:28:16.000000', 'temperatura', 811.0000, 'ºC'),
	(185385, 122, '2014-02-01 00:28:17.000000', 'temperatura', 711.0000, 'ºC'),
	(185386, 122, '2014-02-01 00:28:18.000000', 'temperatura', 1120.0000, 'ºC'),
	(185387, 122, '2014-02-01 00:28:19.000000', 'temperatura', 1068.0000, 'ºC'),
	(185388, 122, '2014-02-01 00:28:20.000000', 'temperatura', 781.0000, 'ºC'),
	(185389, 122, '2014-02-01 00:28:21.000000', 'temperatura', 701.0000, 'ºC'),
	(185390, 122, '2014-02-01 00:28:22.000000', 'temperatura', 1164.0000, 'ºC'),
	(185391, 122, '2014-02-01 00:28:23.000000', 'temperatura', 116.0000, 'ºC'),
	(185392, 122, '2014-02-01 00:28:24.000000', 'temperatura', 688.0000, 'ºC'),
	(185393, 122, '2014-02-01 00:28:25.000000', 'temperatura', 692.0000, 'ºC'),
	(185394, 122, '2014-02-01 00:28:26.000000', 'temperatura', 199.0000, 'ºC'),
	(185395, 122, '2014-02-01 00:28:27.000000', 'temperatura', 117.0000, 'ºC'),
	(185396, 122, '2014-02-01 00:28:28.000000', 'temperatura', 1188.0000, 'ºC'),
	(185397, 122, '2014-02-01 00:28:29.000000', 'temperatura', 793.0000, 'ºC'),
	(185398, 122, '2014-02-01 00:28:30.000000', 'temperatura', 398.0000, 'ºC'),
	(185399, 122, '2014-02-01 00:28:31.000000', 'temperatura', 813.0000, 'ºC'),
	(185400, 122, '2014-02-01 00:28:32.000000', 'temperatura', 473.0000, 'ºC'),
	(185401, 122, '2014-02-01 00:28:33.000000', 'temperatura', 1124.0000, 'ºC'),
	(185402, 122, '2014-02-01 00:28:34.000000', 'temperatura', 601.0000, 'ºC'),
	(185403, 122, '2014-02-01 00:28:35.000000', 'temperatura', 836.0000, 'ºC'),
	(185404, 122, '2014-02-01 00:28:36.000000', 'temperatura', 1178.0000, 'ºC'),
	(185405, 122, '2014-02-01 00:28:37.000000', 'temperatura', 980.0000, 'ºC'),
	(185406, 122, '2014-02-01 00:28:38.000000', 'temperatura', 169.0000, 'ºC'),
	(185407, 122, '2014-02-01 00:28:39.000000', 'temperatura', 306.0000, 'ºC'),
	(185408, 122, '2014-02-01 00:28:40.000000', 'temperatura', 1024.0000, 'ºC'),
	(185409, 122, '2014-02-01 00:28:41.000000', 'temperatura', 600.0000, 'ºC'),
	(185410, 122, '2014-02-01 00:28:42.000000', 'temperatura', 1131.0000, 'ºC'),
	(185411, 122, '2014-02-01 00:28:43.000000', 'temperatura', 254.0000, 'ºC'),
	(185412, 122, '2014-02-01 00:28:44.000000', 'temperatura', 279.0000, 'ºC'),
	(185413, 122, '2014-02-01 00:28:45.000000', 'temperatura', 635.0000, 'ºC'),
	(185414, 122, '2014-02-01 00:28:46.000000', 'temperatura', 1135.0000, 'ºC'),
	(185415, 122, '2014-02-01 00:28:47.000000', 'temperatura', 172.0000, 'ºC'),
	(185416, 122, '2014-02-01 00:28:48.000000', 'temperatura', 1056.0000, 'ºC'),
	(185417, 122, '2014-02-01 00:28:49.000000', 'temperatura', 1165.0000, 'ºC'),
	(185418, 122, '2014-02-01 00:28:50.000000', 'temperatura', 258.0000, 'ºC'),
	(185419, 122, '2014-02-01 00:28:51.000000', 'temperatura', 195.0000, 'ºC'),
	(185420, 122, '2014-02-01 00:28:52.000000', 'temperatura', 199.0000, 'ºC'),
	(185421, 122, '2014-02-01 00:28:53.000000', 'temperatura', 414.0000, 'ºC'),
	(185422, 122, '2014-02-01 00:28:54.000000', 'temperatura', 273.0000, 'ºC'),
	(185423, 122, '2014-02-01 00:28:55.000000', 'temperatura', 124.0000, 'ºC'),
	(185424, 122, '2014-02-01 00:28:56.000000', 'temperatura', 1000.0000, 'ºC'),
	(185425, 122, '2014-02-01 00:28:57.000000', 'temperatura', 1028.0000, 'ºC'),
	(185426, 122, '2014-02-01 00:28:58.000000', 'temperatura', 943.0000, 'ºC'),
	(185427, 122, '2014-02-01 00:28:59.000000', 'temperatura', 429.0000, 'ºC'),
	(185428, 122, '2014-02-01 00:29:00.000000', 'temperatura', 515.0000, 'ºC'),
	(185429, 122, '2014-02-01 00:29:01.000000', 'temperatura', 92.0000, 'ºC'),
	(185430, 122, '2014-02-01 00:29:02.000000', 'temperatura', 115.0000, 'ºC'),
	(185431, 122, '2014-02-01 00:29:03.000000', 'temperatura', 300.0000, 'ºC'),
	(185432, 122, '2014-02-01 00:29:04.000000', 'temperatura', 1157.0000, 'ºC'),
	(185433, 122, '2014-02-01 00:29:05.000000', 'temperatura', 82.0000, 'ºC'),
	(185434, 122, '2014-02-01 00:29:06.000000', 'temperatura', 540.0000, 'ºC'),
	(185435, 122, '2014-02-01 00:29:07.000000', 'temperatura', 57.0000, 'ºC'),
	(185436, 122, '2014-02-01 00:29:08.000000', 'temperatura', 1063.0000, 'ºC'),
	(185437, 122, '2014-02-01 00:29:09.000000', 'temperatura', 346.0000, 'ºC'),
	(185438, 122, '2014-02-01 00:29:10.000000', 'temperatura', 939.0000, 'ºC'),
	(185439, 122, '2014-02-01 00:29:11.000000', 'temperatura', 60.0000, 'ºC'),
	(185440, 122, '2014-02-01 00:29:12.000000', 'temperatura', 1084.0000, 'ºC'),
	(185441, 122, '2014-02-01 00:29:13.000000', 'temperatura', 438.0000, 'ºC'),
	(185442, 122, '2014-02-01 00:29:14.000000', 'temperatura', 140.0000, 'ºC'),
	(185443, 122, '2014-02-01 00:29:15.000000', 'temperatura', 584.0000, 'ºC'),
	(185444, 122, '2014-02-01 00:29:16.000000', 'temperatura', 104.0000, 'ºC'),
	(185445, 122, '2014-02-01 00:29:17.000000', 'temperatura', 1167.0000, 'ºC'),
	(185446, 122, '2014-02-01 00:29:18.000000', 'temperatura', 726.0000, 'ºC'),
	(185447, 122, '2014-02-01 00:29:19.000000', 'temperatura', 126.0000, 'ºC'),
	(185448, 122, '2014-02-01 00:29:20.000000', 'temperatura', 855.0000, 'ºC'),
	(185449, 122, '2014-02-01 00:29:21.000000', 'temperatura', 297.0000, 'ºC'),
	(185450, 122, '2014-02-01 00:29:22.000000', 'temperatura', 122.0000, 'ºC'),
	(185451, 122, '2014-02-01 00:29:23.000000', 'temperatura', 917.0000, 'ºC'),
	(185452, 122, '2014-02-01 00:29:24.000000', 'temperatura', 622.0000, 'ºC'),
	(185453, 122, '2014-02-01 00:29:25.000000', 'temperatura', 360.0000, 'ºC'),
	(185454, 122, '2014-02-01 00:29:26.000000', 'temperatura', 1133.0000, 'ºC'),
	(185455, 122, '2014-02-01 00:29:27.000000', 'temperatura', 986.0000, 'ºC'),
	(185456, 122, '2014-02-01 00:29:28.000000', 'temperatura', 333.0000, 'ºC'),
	(185457, 122, '2014-02-01 00:29:29.000000', 'temperatura', 1108.0000, 'ºC'),
	(185458, 122, '2014-02-01 00:29:30.000000', 'temperatura', 941.0000, 'ºC'),
	(185459, 122, '2014-02-01 00:29:31.000000', 'temperatura', 183.0000, 'ºC'),
	(185460, 122, '2014-02-01 00:29:32.000000', 'temperatura', 490.0000, 'ºC'),
	(185461, 122, '2014-02-01 00:29:33.000000', 'temperatura', 703.0000, 'ºC'),
	(185462, 122, '2014-02-01 00:29:34.000000', 'temperatura', 847.0000, 'ºC'),
	(185463, 122, '2014-02-01 00:29:35.000000', 'temperatura', 925.0000, 'ºC'),
	(185464, 122, '2014-02-01 00:29:36.000000', 'temperatura', 884.0000, 'ºC'),
	(185465, 122, '2014-02-01 00:29:37.000000', 'temperatura', 447.0000, 'ºC'),
	(185466, 122, '2014-02-01 00:29:38.000000', 'temperatura', 783.0000, 'ºC'),
	(185467, 122, '2014-02-01 00:29:39.000000', 'temperatura', 174.0000, 'ºC'),
	(185468, 122, '2014-02-01 00:29:40.000000', 'temperatura', 922.0000, 'ºC'),
	(185469, 122, '2014-02-01 00:29:41.000000', 'temperatura', 489.0000, 'ºC'),
	(185470, 122, '2014-02-01 00:29:42.000000', 'temperatura', 878.0000, 'ºC'),
	(185471, 122, '2014-02-01 00:29:43.000000', 'temperatura', 523.0000, 'ºC'),
	(185472, 122, '2014-02-01 00:29:44.000000', 'temperatura', 1181.0000, 'ºC'),
	(185473, 122, '2014-02-01 00:29:45.000000', 'temperatura', 738.0000, 'ºC'),
	(185474, 122, '2014-02-01 00:29:46.000000', 'temperatura', 147.0000, 'ºC'),
	(185475, 122, '2014-02-01 00:29:47.000000', 'temperatura', 922.0000, 'ºC'),
	(185476, 122, '2014-02-01 00:29:48.000000', 'temperatura', 571.0000, 'ºC'),
	(185477, 122, '2014-02-01 00:29:49.000000', 'temperatura', 89.0000, 'ºC'),
	(185478, 122, '2014-02-01 00:29:50.000000', 'temperatura', 1132.0000, 'ºC'),
	(185479, 122, '2014-02-01 00:29:51.000000', 'temperatura', 594.0000, 'ºC'),
	(185480, 122, '2014-02-01 00:29:52.000000', 'temperatura', 774.0000, 'ºC'),
	(185481, 122, '2014-02-01 00:29:53.000000', 'temperatura', 889.0000, 'ºC'),
	(185482, 122, '2014-02-01 00:29:54.000000', 'temperatura', 922.0000, 'ºC'),
	(185483, 122, '2014-02-01 00:29:55.000000', 'temperatura', 746.0000, 'ºC'),
	(185484, 122, '2014-02-01 00:29:56.000000', 'temperatura', 965.0000, 'ºC'),
	(185485, 122, '2014-02-01 00:29:57.000000', 'temperatura', 187.0000, 'ºC'),
	(185486, 122, '2014-02-01 00:29:58.000000', 'temperatura', 438.0000, 'ºC'),
	(185487, 122, '2014-02-01 00:29:59.000000', 'temperatura', 433.0000, 'ºC'),
	(185488, 122, '2014-02-01 00:30:00.000000', 'temperatura', 848.0000, 'ºC'),
	(185489, 122, '2014-02-01 00:30:01.000000', 'temperatura', 543.0000, 'ºC'),
	(185490, 122, '2014-02-01 00:30:02.000000', 'temperatura', 169.0000, 'ºC'),
	(185491, 122, '2014-02-01 00:30:03.000000', 'temperatura', 420.0000, 'ºC'),
	(185492, 122, '2014-02-01 00:30:04.000000', 'temperatura', 393.0000, 'ºC'),
	(185493, 122, '2014-02-01 00:30:05.000000', 'temperatura', 705.0000, 'ºC'),
	(185494, 122, '2014-02-01 00:30:06.000000', 'temperatura', 1148.0000, 'ºC'),
	(185495, 122, '2014-02-01 00:30:07.000000', 'temperatura', 23.0000, 'ºC'),
	(185496, 122, '2014-02-01 00:30:08.000000', 'temperatura', 272.0000, 'ºC'),
	(185497, 122, '2014-02-01 00:30:09.000000', 'temperatura', 94.0000, 'ºC'),
	(185498, 122, '2014-02-01 00:30:10.000000', 'temperatura', 853.0000, 'ºC'),
	(185499, 122, '2014-02-01 00:30:11.000000', 'temperatura', 383.0000, 'ºC'),
	(185500, 122, '2014-02-01 00:30:12.000000', 'temperatura', 557.0000, 'ºC'),
	(185501, 122, '2014-02-01 00:30:13.000000', 'temperatura', 437.0000, 'ºC'),
	(185502, 122, '2014-02-01 00:30:14.000000', 'temperatura', 515.0000, 'ºC'),
	(185503, 122, '2014-02-01 00:30:15.000000', 'temperatura', 64.0000, 'ºC'),
	(185504, 122, '2014-02-01 00:30:16.000000', 'temperatura', 1176.0000, 'ºC'),
	(185505, 122, '2014-02-01 00:30:17.000000', 'temperatura', 888.0000, 'ºC'),
	(185506, 122, '2014-02-01 00:30:18.000000', 'temperatura', 914.0000, 'ºC'),
	(185507, 122, '2014-02-01 00:30:19.000000', 'temperatura', 705.0000, 'ºC'),
	(185508, 122, '2014-02-01 00:30:20.000000', 'temperatura', 782.0000, 'ºC'),
	(185509, 122, '2014-02-01 00:30:21.000000', 'temperatura', 599.0000, 'ºC'),
	(185510, 122, '2014-02-01 00:30:22.000000', 'temperatura', 647.0000, 'ºC'),
	(185511, 122, '2014-02-01 00:30:23.000000', 'temperatura', 241.0000, 'ºC'),
	(185512, 122, '2014-02-01 00:30:24.000000', 'temperatura', 464.0000, 'ºC'),
	(185513, 122, '2014-02-01 00:30:25.000000', 'temperatura', 399.0000, 'ºC'),
	(185514, 122, '2014-02-01 00:30:26.000000', 'temperatura', 602.0000, 'ºC'),
	(185515, 122, '2014-02-01 00:30:27.000000', 'temperatura', 613.0000, 'ºC'),
	(185516, 122, '2014-02-01 00:30:28.000000', 'temperatura', 62.0000, 'ºC'),
	(185517, 122, '2014-02-01 00:30:29.000000', 'temperatura', 869.0000, 'ºC'),
	(185518, 122, '2014-02-01 00:30:30.000000', 'temperatura', 561.0000, 'ºC'),
	(185519, 122, '2014-02-01 00:30:31.000000', 'temperatura', 200.0000, 'ºC'),
	(185520, 122, '2014-02-01 00:30:32.000000', 'temperatura', 515.0000, 'ºC'),
	(185521, 122, '2014-02-01 00:30:33.000000', 'temperatura', 777.0000, 'ºC'),
	(185522, 122, '2014-02-01 00:30:34.000000', 'temperatura', 1138.0000, 'ºC'),
	(185523, 122, '2014-02-01 00:30:35.000000', 'temperatura', 963.0000, 'ºC'),
	(185524, 122, '2014-02-01 00:30:36.000000', 'temperatura', 199.0000, 'ºC'),
	(185525, 122, '2014-02-01 00:30:37.000000', 'temperatura', 507.0000, 'ºC'),
	(185526, 122, '2014-02-01 00:30:38.000000', 'temperatura', 738.0000, 'ºC'),
	(185527, 122, '2014-02-01 00:30:39.000000', 'temperatura', 970.0000, 'ºC'),
	(185528, 122, '2014-02-01 00:30:40.000000', 'temperatura', 238.0000, 'ºC'),
	(185529, 122, '2014-02-01 00:30:41.000000', 'temperatura', 681.0000, 'ºC'),
	(185530, 122, '2014-02-01 00:30:42.000000', 'temperatura', 290.0000, 'ºC'),
	(185531, 122, '2014-02-01 00:30:43.000000', 'temperatura', 607.0000, 'ºC'),
	(185532, 122, '2014-02-01 00:30:44.000000', 'temperatura', 965.0000, 'ºC'),
	(185533, 122, '2014-02-01 00:30:45.000000', 'temperatura', 606.0000, 'ºC'),
	(185534, 122, '2014-02-01 00:30:46.000000', 'temperatura', 133.0000, 'ºC'),
	(185535, 122, '2014-02-01 00:30:47.000000', 'temperatura', 50.0000, 'ºC'),
	(185536, 122, '2014-02-01 00:30:48.000000', 'temperatura', 1052.0000, 'ºC'),
	(185537, 122, '2014-02-01 00:30:49.000000', 'temperatura', 309.0000, 'ºC'),
	(185538, 122, '2014-02-01 00:30:50.000000', 'temperatura', 792.0000, 'ºC'),
	(185539, 122, '2014-02-01 00:30:51.000000', 'temperatura', 632.0000, 'ºC'),
	(185540, 122, '2014-02-01 00:30:52.000000', 'temperatura', 785.0000, 'ºC'),
	(185541, 122, '2014-02-01 00:30:53.000000', 'temperatura', 827.0000, 'ºC'),
	(185542, 122, '2014-02-01 00:30:54.000000', 'temperatura', 583.0000, 'ºC'),
	(185543, 122, '2014-02-01 00:30:55.000000', 'temperatura', 435.0000, 'ºC'),
	(185544, 122, '2014-02-01 00:30:56.000000', 'temperatura', 424.0000, 'ºC'),
	(185545, 122, '2014-02-01 00:30:57.000000', 'temperatura', 815.0000, 'ºC'),
	(185546, 122, '2014-02-01 00:30:58.000000', 'temperatura', 403.0000, 'ºC'),
	(185547, 122, '2014-02-01 00:30:59.000000', 'temperatura', 773.0000, 'ºC'),
	(185548, 122, '2014-02-01 00:31:00.000000', 'temperatura', 255.0000, 'ºC'),
	(185549, 122, '2014-02-01 00:31:01.000000', 'temperatura', 158.0000, 'ºC'),
	(185550, 122, '2014-02-01 00:31:02.000000', 'temperatura', 26.0000, 'ºC'),
	(185551, 122, '2014-02-01 00:31:03.000000', 'temperatura', 856.0000, 'ºC'),
	(185552, 122, '2014-02-01 00:31:04.000000', 'temperatura', 600.0000, 'ºC'),
	(185553, 122, '2014-02-01 00:31:05.000000', 'temperatura', 436.0000, 'ºC'),
	(185554, 122, '2014-02-01 00:31:06.000000', 'temperatura', 379.0000, 'ºC'),
	(185555, 122, '2014-02-01 00:31:07.000000', 'temperatura', 588.0000, 'ºC'),
	(185556, 122, '2014-02-01 00:31:08.000000', 'temperatura', 603.0000, 'ºC'),
	(185557, 122, '2014-02-01 00:31:09.000000', 'temperatura', 54.0000, 'ºC'),
	(185558, 122, '2014-02-01 00:31:10.000000', 'temperatura', 859.0000, 'ºC'),
	(185559, 122, '2014-02-01 00:31:11.000000', 'temperatura', 532.0000, 'ºC'),
	(185560, 122, '2014-02-01 00:31:12.000000', 'temperatura', 86.0000, 'ºC'),
	(185561, 122, '2014-02-01 00:31:13.000000', 'temperatura', 32.0000, 'ºC'),
	(185562, 122, '2014-02-01 00:31:14.000000', 'temperatura', 1103.0000, 'ºC'),
	(185563, 122, '2014-02-01 00:31:15.000000', 'temperatura', 619.0000, 'ºC'),
	(185564, 122, '2014-02-01 00:31:16.000000', 'temperatura', 989.0000, 'ºC'),
	(185565, 122, '2014-02-01 00:31:17.000000', 'temperatura', 687.0000, 'ºC'),
	(185566, 122, '2014-02-01 00:31:18.000000', 'temperatura', 468.0000, 'ºC'),
	(185567, 122, '2014-02-01 00:31:19.000000', 'temperatura', 279.0000, 'ºC'),
	(185568, 122, '2014-02-01 00:31:20.000000', 'temperatura', 1194.0000, 'ºC'),
	(185569, 122, '2014-02-01 00:31:21.000000', 'temperatura', 331.0000, 'ºC'),
	(185570, 122, '2014-02-01 00:31:22.000000', 'temperatura', 475.0000, 'ºC'),
	(185571, 122, '2014-02-01 00:31:23.000000', 'temperatura', 184.0000, 'ºC'),
	(185572, 122, '2014-02-01 00:31:24.000000', 'temperatura', 693.0000, 'ºC'),
	(185573, 122, '2014-02-01 00:31:25.000000', 'temperatura', 513.0000, 'ºC'),
	(185574, 122, '2014-02-01 00:31:26.000000', 'temperatura', 486.0000, 'ºC'),
	(185575, 122, '2014-02-01 00:31:27.000000', 'temperatura', 894.0000, 'ºC'),
	(185576, 122, '2014-02-01 00:31:28.000000', 'temperatura', 612.0000, 'ºC'),
	(185577, 122, '2014-02-01 00:31:29.000000', 'temperatura', 377.0000, 'ºC'),
	(185578, 122, '2014-02-01 00:31:30.000000', 'temperatura', 51.0000, 'ºC'),
	(185579, 122, '2014-02-01 00:31:31.000000', 'temperatura', 323.0000, 'ºC'),
	(185580, 122, '2014-02-01 00:31:32.000000', 'temperatura', 262.0000, 'ºC'),
	(185581, 122, '2014-02-01 00:31:33.000000', 'temperatura', 342.0000, 'ºC'),
	(185582, 122, '2014-02-01 00:31:34.000000', 'temperatura', 925.0000, 'ºC'),
	(185583, 122, '2014-02-01 00:31:35.000000', 'temperatura', 1198.0000, 'ºC'),
	(185584, 122, '2014-02-01 00:31:36.000000', 'temperatura', 816.0000, 'ºC'),
	(185585, 122, '2014-02-01 00:31:37.000000', 'temperatura', 486.0000, 'ºC'),
	(185586, 122, '2014-02-01 00:31:38.000000', 'temperatura', 1184.0000, 'ºC'),
	(185587, 122, '2014-02-01 00:31:39.000000', 'temperatura', 862.0000, 'ºC'),
	(185588, 122, '2014-02-01 00:31:40.000000', 'temperatura', 758.0000, 'ºC'),
	(185589, 122, '2014-02-01 00:31:41.000000', 'temperatura', 6.0000, 'ºC'),
	(185590, 122, '2014-02-01 00:31:42.000000', 'temperatura', 156.0000, 'ºC'),
	(185591, 122, '2014-02-01 00:31:43.000000', 'temperatura', 762.0000, 'ºC'),
	(185592, 122, '2014-02-01 00:31:44.000000', 'temperatura', 944.0000, 'ºC'),
	(185593, 122, '2014-02-01 00:31:45.000000', 'temperatura', 32.0000, 'ºC'),
	(185594, 122, '2014-02-01 00:31:46.000000', 'temperatura', 930.0000, 'ºC'),
	(185595, 122, '2014-02-01 00:31:47.000000', 'temperatura', 956.0000, 'ºC'),
	(185596, 122, '2014-02-01 00:31:48.000000', 'temperatura', 790.0000, 'ºC'),
	(185597, 122, '2014-02-01 00:31:49.000000', 'temperatura', 1082.0000, 'ºC'),
	(185598, 122, '2014-02-01 00:31:50.000000', 'temperatura', 641.0000, 'ºC'),
	(185599, 122, '2014-02-01 00:31:51.000000', 'temperatura', 1159.0000, 'ºC'),
	(185600, 122, '2014-02-01 00:31:52.000000', 'temperatura', 271.0000, 'ºC'),
	(185601, 122, '2014-02-01 00:31:53.000000', 'temperatura', 281.0000, 'ºC'),
	(185602, 122, '2014-02-01 00:31:54.000000', 'temperatura', 592.0000, 'ºC'),
	(185603, 122, '2014-02-01 00:31:55.000000', 'temperatura', 917.0000, 'ºC'),
	(185604, 122, '2014-02-01 00:31:56.000000', 'temperatura', 412.0000, 'ºC'),
	(185605, 122, '2014-02-01 00:31:57.000000', 'temperatura', 507.0000, 'ºC'),
	(185606, 122, '2014-02-01 00:31:58.000000', 'temperatura', 99.0000, 'ºC'),
	(185607, 122, '2014-02-01 00:31:59.000000', 'temperatura', 176.0000, 'ºC'),
	(185608, 122, '2014-02-01 00:32:00.000000', 'temperatura', 582.0000, 'ºC'),
	(185609, 122, '2014-02-01 00:32:01.000000', 'temperatura', 1182.0000, 'ºC'),
	(185610, 122, '2014-02-01 00:32:02.000000', 'temperatura', 565.0000, 'ºC'),
	(185611, 122, '2014-02-01 00:32:03.000000', 'temperatura', 479.0000, 'ºC'),
	(185612, 122, '2014-02-01 00:32:04.000000', 'temperatura', 700.0000, 'ºC'),
	(185613, 122, '2014-02-01 00:32:05.000000', 'temperatura', 866.0000, 'ºC'),
	(185614, 122, '2014-02-01 00:32:06.000000', 'temperatura', 1030.0000, 'ºC'),
	(185615, 122, '2014-02-01 00:32:07.000000', 'temperatura', 153.0000, 'ºC'),
	(185616, 122, '2014-02-01 00:32:08.000000', 'temperatura', 74.0000, 'ºC'),
	(185617, 122, '2014-02-01 00:32:09.000000', 'temperatura', 1114.0000, 'ºC'),
	(185618, 122, '2014-02-01 00:32:10.000000', 'temperatura', 548.0000, 'ºC'),
	(185619, 122, '2014-02-01 00:32:11.000000', 'temperatura', 597.0000, 'ºC'),
	(185620, 122, '2014-02-01 00:32:12.000000', 'temperatura', 143.0000, 'ºC'),
	(185621, 122, '2014-02-01 00:32:13.000000', 'temperatura', 123.0000, 'ºC'),
	(185622, 122, '2014-02-01 00:32:14.000000', 'temperatura', 188.0000, 'ºC'),
	(185623, 122, '2014-02-01 00:32:15.000000', 'temperatura', 570.0000, 'ºC'),
	(185624, 122, '2014-02-01 00:32:16.000000', 'temperatura', 1089.0000, 'ºC'),
	(185625, 122, '2014-02-01 00:32:17.000000', 'temperatura', 135.0000, 'ºC'),
	(185626, 122, '2014-02-01 00:32:18.000000', 'temperatura', 1006.0000, 'ºC'),
	(185627, 122, '2014-02-01 00:32:19.000000', 'temperatura', 1026.0000, 'ºC'),
	(185628, 122, '2014-02-01 00:32:20.000000', 'temperatura', 914.0000, 'ºC'),
	(185629, 122, '2014-02-01 00:32:21.000000', 'temperatura', 291.0000, 'ºC'),
	(185630, 122, '2014-02-01 00:32:22.000000', 'temperatura', 1114.0000, 'ºC'),
	(185631, 122, '2014-02-01 00:32:23.000000', 'temperatura', 1098.0000, 'ºC'),
	(185632, 122, '2014-02-01 00:32:24.000000', 'temperatura', 949.0000, 'ºC'),
	(185633, 122, '2014-02-01 00:32:25.000000', 'temperatura', 250.0000, 'ºC'),
	(185634, 122, '2014-02-01 00:32:26.000000', 'temperatura', 803.0000, 'ºC'),
	(185635, 122, '2014-02-01 00:32:27.000000', 'temperatura', 867.0000, 'ºC'),
	(185636, 122, '2014-02-01 00:32:28.000000', 'temperatura', 728.0000, 'ºC'),
	(185637, 122, '2014-02-01 00:32:29.000000', 'temperatura', 1036.0000, 'ºC'),
	(185638, 122, '2014-02-01 00:32:30.000000', 'temperatura', 598.0000, 'ºC'),
	(185639, 122, '2014-02-01 00:32:31.000000', 'temperatura', 1084.0000, 'ºC'),
	(185640, 122, '2014-02-01 00:32:32.000000', 'temperatura', 26.0000, 'ºC'),
	(185641, 122, '2014-02-01 00:32:33.000000', 'temperatura', 476.0000, 'ºC'),
	(185642, 122, '2014-02-01 00:32:34.000000', 'temperatura', 1106.0000, 'ºC'),
	(185643, 122, '2014-02-01 00:32:35.000000', 'temperatura', 500.0000, 'ºC'),
	(185644, 122, '2014-02-01 00:32:36.000000', 'temperatura', 385.0000, 'ºC'),
	(185645, 122, '2014-02-01 00:32:37.000000', 'temperatura', 426.0000, 'ºC'),
	(185646, 122, '2014-02-01 00:32:38.000000', 'temperatura', 973.0000, 'ºC'),
	(185647, 122, '2014-02-01 00:32:39.000000', 'temperatura', 1188.0000, 'ºC'),
	(185648, 122, '2014-02-01 00:32:40.000000', 'temperatura', 623.0000, 'ºC'),
	(185649, 122, '2014-02-01 00:32:41.000000', 'temperatura', 751.0000, 'ºC'),
	(185650, 122, '2014-02-01 00:32:42.000000', 'temperatura', 687.0000, 'ºC'),
	(185651, 122, '2014-02-01 00:32:43.000000', 'temperatura', 1180.0000, 'ºC'),
	(185652, 122, '2014-02-01 00:32:44.000000', 'temperatura', 241.0000, 'ºC'),
	(185653, 122, '2014-02-01 00:32:45.000000', 'temperatura', 66.0000, 'ºC'),
	(185654, 122, '2014-02-01 00:32:46.000000', 'temperatura', 805.0000, 'ºC'),
	(185655, 122, '2014-02-01 00:32:47.000000', 'temperatura', 230.0000, 'ºC'),
	(185656, 122, '2014-02-01 00:32:48.000000', 'temperatura', 1136.0000, 'ºC'),
	(185657, 122, '2014-02-01 00:32:49.000000', 'temperatura', 191.0000, 'ºC'),
	(185658, 122, '2014-02-01 00:32:50.000000', 'temperatura', 1146.0000, 'ºC'),
	(185659, 122, '2014-02-01 00:32:51.000000', 'temperatura', 358.0000, 'ºC'),
	(185660, 122, '2014-02-01 00:32:52.000000', 'temperatura', 751.0000, 'ºC'),
	(185661, 122, '2014-02-01 00:32:53.000000', 'temperatura', 285.0000, 'ºC'),
	(185662, 122, '2014-02-01 00:32:54.000000', 'temperatura', 369.0000, 'ºC'),
	(185663, 122, '2014-02-01 00:32:55.000000', 'temperatura', 993.0000, 'ºC'),
	(185664, 122, '2014-02-01 00:32:56.000000', 'temperatura', 256.0000, 'ºC'),
	(185665, 122, '2014-02-01 00:32:57.000000', 'temperatura', 701.0000, 'ºC'),
	(185666, 122, '2014-02-01 00:32:58.000000', 'temperatura', 338.0000, 'ºC'),
	(185667, 122, '2014-02-01 00:32:59.000000', 'temperatura', 787.0000, 'ºC'),
	(185668, 122, '2014-02-01 00:33:00.000000', 'temperatura', 521.0000, 'ºC'),
	(185669, 122, '2014-02-01 00:33:01.000000', 'temperatura', 247.0000, 'ºC'),
	(185670, 122, '2014-02-01 00:33:02.000000', 'temperatura', 871.0000, 'ºC'),
	(185671, 122, '2014-02-01 00:33:03.000000', 'temperatura', 16.0000, 'ºC'),
	(185672, 122, '2014-02-01 00:33:04.000000', 'temperatura', 1066.0000, 'ºC'),
	(185673, 122, '2014-02-01 00:33:05.000000', 'temperatura', 482.0000, 'ºC'),
	(185674, 122, '2014-02-01 00:33:06.000000', 'temperatura', 413.0000, 'ºC'),
	(185675, 122, '2014-02-01 00:33:07.000000', 'temperatura', 620.0000, 'ºC'),
	(185676, 122, '2014-02-01 00:33:08.000000', 'temperatura', 661.0000, 'ºC'),
	(185677, 122, '2014-02-01 00:33:09.000000', 'temperatura', 247.0000, 'ºC'),
	(185678, 122, '2014-02-01 00:33:10.000000', 'temperatura', 452.0000, 'ºC'),
	(185679, 122, '2014-02-01 00:33:11.000000', 'temperatura', 321.0000, 'ºC'),
	(185680, 122, '2014-02-01 00:33:12.000000', 'temperatura', 248.0000, 'ºC'),
	(185681, 122, '2014-02-01 00:33:13.000000', 'temperatura', 276.0000, 'ºC'),
	(185682, 122, '2014-02-01 00:33:14.000000', 'temperatura', 638.0000, 'ºC'),
	(185683, 122, '2014-02-01 00:33:15.000000', 'temperatura', 1160.0000, 'ºC'),
	(185684, 122, '2014-02-01 00:33:16.000000', 'temperatura', 290.0000, 'ºC'),
	(185685, 122, '2014-02-01 00:33:17.000000', 'temperatura', 370.0000, 'ºC'),
	(185686, 122, '2014-02-01 00:33:18.000000', 'temperatura', 980.0000, 'ºC'),
	(185687, 122, '2014-02-01 00:33:19.000000', 'temperatura', 190.0000, 'ºC'),
	(185688, 122, '2014-02-01 00:33:20.000000', 'temperatura', 411.0000, 'ºC'),
	(185689, 122, '2014-02-01 00:33:21.000000', 'temperatura', 284.0000, 'ºC'),
	(185690, 122, '2014-02-01 00:33:22.000000', 'temperatura', 187.0000, 'ºC'),
	(185691, 122, '2014-02-01 00:33:23.000000', 'temperatura', 86.0000, 'ºC'),
	(185692, 122, '2014-02-01 00:33:24.000000', 'temperatura', 1070.0000, 'ºC'),
	(185693, 122, '2014-02-01 00:33:25.000000', 'temperatura', 291.0000, 'ºC'),
	(185694, 122, '2014-02-01 00:33:26.000000', 'temperatura', 646.0000, 'ºC'),
	(185695, 122, '2014-02-01 00:33:27.000000', 'temperatura', 1160.0000, 'ºC'),
	(185696, 122, '2014-02-01 00:33:28.000000', 'temperatura', 259.0000, 'ºC'),
	(185697, 122, '2014-02-01 00:33:29.000000', 'temperatura', 215.0000, 'ºC'),
	(185698, 122, '2014-02-01 00:33:30.000000', 'temperatura', 298.0000, 'ºC'),
	(185699, 122, '2014-02-01 00:33:31.000000', 'temperatura', 847.0000, 'ºC'),
	(185700, 122, '2014-02-01 00:33:32.000000', 'temperatura', 939.0000, 'ºC'),
	(185701, 122, '2014-02-01 00:33:33.000000', 'temperatura', 957.0000, 'ºC'),
	(185702, 122, '2014-02-01 00:33:34.000000', 'temperatura', 769.0000, 'ºC'),
	(185703, 122, '2014-02-01 00:33:35.000000', 'temperatura', 975.0000, 'ºC'),
	(185704, 122, '2014-02-01 00:33:36.000000', 'temperatura', 169.0000, 'ºC'),
	(185705, 122, '2014-02-01 00:33:37.000000', 'temperatura', 319.0000, 'ºC'),
	(185706, 122, '2014-02-01 00:33:38.000000', 'temperatura', 1088.0000, 'ºC'),
	(185707, 122, '2014-02-01 00:33:39.000000', 'temperatura', 885.0000, 'ºC'),
	(185708, 122, '2014-02-01 00:33:40.000000', 'temperatura', 1159.0000, 'ºC'),
	(185709, 122, '2014-02-01 00:33:41.000000', 'temperatura', 743.0000, 'ºC'),
	(185710, 122, '2014-02-01 00:33:42.000000', 'temperatura', 237.0000, 'ºC'),
	(185711, 122, '2014-02-01 00:33:43.000000', 'temperatura', 157.0000, 'ºC'),
	(185712, 122, '2014-02-01 00:33:44.000000', 'temperatura', 74.0000, 'ºC'),
	(185713, 122, '2014-02-01 00:33:45.000000', 'temperatura', 1098.0000, 'ºC'),
	(185714, 122, '2014-02-01 00:33:46.000000', 'temperatura', 472.0000, 'ºC'),
	(185715, 122, '2014-02-01 00:33:47.000000', 'temperatura', 263.0000, 'ºC'),
	(185716, 122, '2014-02-01 00:33:48.000000', 'temperatura', 1101.0000, 'ºC'),
	(185717, 122, '2014-02-01 00:33:49.000000', 'temperatura', 1118.0000, 'ºC'),
	(185718, 122, '2014-02-01 00:33:50.000000', 'temperatura', 1088.0000, 'ºC'),
	(185719, 122, '2014-02-01 00:33:51.000000', 'temperatura', 884.0000, 'ºC'),
	(185720, 122, '2014-02-01 00:33:52.000000', 'temperatura', 1159.0000, 'ºC'),
	(185721, 122, '2014-02-01 00:33:53.000000', 'temperatura', 742.0000, 'ºC'),
	(185722, 122, '2014-02-01 00:33:54.000000', 'temperatura', 235.0000, 'ºC'),
	(185723, 122, '2014-02-01 00:33:55.000000', 'temperatura', 150.0000, 'ºC'),
	(185724, 122, '2014-02-01 00:33:56.000000', 'temperatura', 45.0000, 'ºC'),
	(185725, 122, '2014-02-01 00:33:57.000000', 'temperatura', 977.0000, 'ºC'),
	(185726, 122, '2014-02-01 00:33:58.000000', 'temperatura', 1150.0000, 'ºC'),
	(185727, 122, '2014-02-01 00:33:59.000000', 'temperatura', 418.0000, 'ºC'),
	(185728, 122, '2014-02-01 00:34:00.000000', 'temperatura', 1041.0000, 'ºC'),
	(185729, 122, '2014-02-01 00:34:01.000000', 'temperatura', 351.0000, 'ºC'),
	(185730, 122, '2014-02-01 00:34:02.000000', 'temperatura', 1034.0000, 'ºC'),
	(185731, 122, '2014-02-01 00:34:03.000000', 'temperatura', 516.0000, 'ºC'),
	(185732, 122, '2014-02-01 00:34:04.000000', 'temperatura', 680.0000, 'ºC'),
	(185733, 122, '2014-02-01 00:34:05.000000', 'temperatura', 653.0000, 'ºC'),
	(185734, 122, '2014-02-01 00:34:06.000000', 'temperatura', 25.0000, 'ºC'),
	(185735, 122, '2014-02-01 00:34:07.000000', 'temperatura', 564.0000, 'ºC'),
	(185736, 122, '2014-02-01 00:34:08.000000', 'temperatura', 348.0000, 'ºC'),
	(185737, 122, '2014-02-01 00:34:09.000000', 'temperatura', 48.0000, 'ºC'),
	(185738, 122, '2014-02-01 00:34:10.000000', 'temperatura', 395.0000, 'ºC'),
	(185739, 122, '2014-02-01 00:34:11.000000', 'temperatura', 633.0000, 'ºC'),
	(185740, 122, '2014-02-01 00:34:12.000000', 'temperatura', 782.0000, 'ºC'),
	(185741, 122, '2014-02-01 00:34:13.000000', 'temperatura', 808.0000, 'ºC'),
	(185742, 122, '2014-02-01 00:34:14.000000', 'temperatura', 497.0000, 'ºC'),
	(185743, 122, '2014-02-01 00:34:15.000000', 'temperatura', 62.0000, 'ºC'),
	(185744, 122, '2014-02-01 00:34:16.000000', 'temperatura', 17.0000, 'ºC'),
	(185745, 122, '2014-02-01 00:34:17.000000', 'temperatura', 1101.0000, 'ºC'),
	(185746, 122, '2014-02-01 00:34:18.000000', 'temperatura', 655.0000, 'ºC'),
	(185747, 122, '2014-02-01 00:34:19.000000', 'temperatura', 1170.0000, 'ºC'),
	(185748, 122, '2014-02-01 00:34:20.000000', 'temperatura', 287.0000, 'ºC'),
	(185749, 122, '2014-02-01 00:34:21.000000', 'temperatura', 327.0000, 'ºC'),
	(185750, 122, '2014-02-01 00:34:22.000000', 'temperatura', 774.0000, 'ºC'),
	(185751, 122, '2014-02-01 00:34:23.000000', 'temperatura', 490.0000, 'ºC'),
	(185752, 122, '2014-02-01 00:34:24.000000', 'temperatura', 129.0000, 'ºC'),
	(185753, 122, '2014-02-01 00:34:25.000000', 'temperatura', 376.0000, 'ºC'),
	(185754, 122, '2014-02-01 00:34:26.000000', 'temperatura', 291.0000, 'ºC'),
	(185755, 122, '2014-02-01 00:34:27.000000', 'temperatura', 328.0000, 'ºC'),
	(185756, 122, '2014-02-01 00:34:28.000000', 'temperatura', 769.0000, 'ºC'),
	(185757, 122, '2014-02-01 00:34:29.000000', 'temperatura', 463.0000, 'ºC'),
	(185758, 122, '2014-02-01 00:34:30.000000', 'temperatura', 5.0000, 'ºC'),
	(185759, 122, '2014-02-01 00:34:31.000000', 'temperatura', 1038.0000, 'ºC'),
	(185760, 122, '2014-02-01 00:34:32.000000', 'temperatura', 376.0000, 'ºC'),
	(185761, 122, '2014-02-01 00:34:33.000000', 'temperatura', 1168.0000, 'ºC'),
	(185762, 122, '2014-02-01 00:34:34.000000', 'temperatura', 1111.0000, 'ºC'),
	(185763, 122, '2014-02-01 00:34:35.000000', 'temperatura', 853.0000, 'ºC'),
	(185764, 122, '2014-02-01 00:34:36.000000', 'temperatura', 931.0000, 'ºC'),
	(185765, 122, '2014-02-01 00:34:37.000000', 'temperatura', 897.0000, 'ºC'),
	(185766, 122, '2014-02-01 00:34:38.000000', 'temperatura', 493.0000, 'ºC'),
	(185767, 122, '2014-02-01 00:34:39.000000', 'temperatura', 975.0000, 'ºC'),
	(185768, 122, '2014-02-01 00:34:40.000000', 'temperatura', 997.0000, 'ºC'),
	(185769, 122, '2014-02-01 00:34:41.000000', 'temperatura', 861.0000, 'ºC'),
	(185770, 122, '2014-02-01 00:34:42.000000', 'temperatura', 116.0000, 'ºC'),
	(185771, 122, '2014-02-01 00:34:43.000000', 'temperatura', 395.0000, 'ºC'),
	(185772, 122, '2014-02-01 00:34:44.000000', 'temperatura', 427.0000, 'ºC'),
	(185773, 122, '2014-02-01 00:34:45.000000', 'temperatura', 951.0000, 'ºC'),
	(185774, 122, '2014-02-01 00:34:46.000000', 'temperatura', 1073.0000, 'ºC'),
	(185775, 122, '2014-02-01 00:34:47.000000', 'temperatura', 112.0000, 'ºC'),
	(185776, 122, '2014-02-01 00:34:48.000000', 'temperatura', 942.0000, 'ºC'),
	(185777, 122, '2014-02-01 00:34:49.000000', 'temperatura', 776.0000, 'ºC'),
	(185778, 122, '2014-02-01 00:34:50.000000', 'temperatura', 1052.0000, 'ºC'),
	(185779, 122, '2014-02-01 00:34:51.000000', 'temperatura', 533.0000, 'ºC'),
	(185780, 122, '2014-02-01 00:34:52.000000', 'temperatura', 712.0000, 'ºC'),
	(185781, 122, '2014-02-01 00:34:53.000000', 'temperatura', 759.0000, 'ºC'),
	(185782, 122, '2014-02-01 00:34:54.000000', 'temperatura', 461.0000, 'ºC'),
	(185783, 122, '2014-02-01 00:34:55.000000', 'temperatura', 29.0000, 'ºC'),
	(185784, 122, '2014-02-01 00:34:56.000000', 'temperatura', 1160.0000, 'ºC'),
	(185785, 122, '2014-02-01 00:34:57.000000', 'temperatura', 916.0000, 'ºC'),
	(185786, 122, '2014-02-01 00:34:58.000000', 'temperatura', 1098.0000, 'ºC'),
	(185787, 122, '2014-02-01 00:34:59.000000', 'temperatura', 346.0000, 'ºC'),
	(185788, 122, '2014-02-01 00:35:00.000000', 'temperatura', 834.0000, 'ºC'),
	(185789, 122, '2014-02-01 00:35:01.000000', 'temperatura', 732.0000, 'ºC'),
	(185790, 122, '2014-02-01 00:35:02.000000', 'temperatura', 1157.0000, 'ºC'),
	(185791, 122, '2014-02-01 00:35:03.000000', 'temperatura', 1192.0000, 'ºC'),
	(185792, 122, '2014-02-01 00:35:04.000000', 'temperatura', 87.0000, 'ºC'),
	(185793, 122, '2014-02-01 00:35:05.000000', 'temperatura', 463.0000, 'ºC'),
	(185794, 122, '2014-02-01 00:35:06.000000', 'temperatura', 852.0000, 'ºC'),
	(185795, 122, '2014-02-01 00:35:07.000000', 'temperatura', 473.0000, 'ºC'),
	(185796, 122, '2014-02-01 00:35:08.000000', 'temperatura', 1008.0000, 'ºC'),
	(185797, 122, '2014-02-01 00:35:09.000000', 'temperatura', 24.0000, 'ºC'),
	(185798, 122, '2014-02-01 00:35:10.000000', 'temperatura', 695.0000, 'ºC'),
	(185799, 122, '2014-02-01 00:35:11.000000', 'temperatura', 1004.0000, 'ºC'),
	(185800, 122, '2014-02-01 00:35:12.000000', 'temperatura', 536.0000, 'ºC'),
	(185801, 122, '2014-02-01 00:35:13.000000', 'temperatura', 870.0000, 'ºC'),
	(185802, 122, '2014-02-01 00:35:14.000000', 'temperatura', 342.0000, 'ºC'),
	(185803, 122, '2014-02-01 00:35:15.000000', 'temperatura', 298.0000, 'ºC'),
	(185804, 122, '2014-02-01 00:35:16.000000', 'temperatura', 465.0000, 'ºC'),
	(185805, 122, '2014-02-01 00:35:17.000000', 'temperatura', 232.0000, 'ºC'),
	(185806, 122, '2014-02-01 00:35:18.000000', 'temperatura', 967.0000, 'ºC'),
	(185807, 122, '2014-02-01 00:35:19.000000', 'temperatura', 538.0000, 'ºC'),
	(185808, 122, '2014-02-01 00:35:20.000000', 'temperatura', 991.0000, 'ºC'),
	(185809, 122, '2014-02-01 00:35:21.000000', 'temperatura', 940.0000, 'ºC'),
	(185810, 122, '2014-02-01 00:35:22.000000', 'temperatura', 527.0000, 'ºC'),
	(185811, 122, '2014-02-01 00:35:23.000000', 'temperatura', 1016.0000, 'ºC'),
	(185812, 122, '2014-02-01 00:35:24.000000', 'temperatura', 1098.0000, 'ºC'),
	(185813, 122, '2014-02-01 00:35:25.000000', 'temperatura', 45.0000, 'ºC'),
	(185814, 122, '2014-02-01 00:35:26.000000', 'temperatura', 529.0000, 'ºC'),
	(185815, 122, '2014-02-01 00:35:27.000000', 'temperatura', 112.0000, 'ºC'),
	(185816, 122, '2014-02-01 00:35:28.000000', 'temperatura', 173.0000, 'ºC'),
	(185817, 122, '2014-02-01 00:35:29.000000', 'temperatura', 530.0000, 'ºC'),
	(185818, 122, '2014-02-01 00:35:30.000000', 'temperatura', 931.0000, 'ºC'),
	(185819, 122, '2014-02-01 00:35:31.000000', 'temperatura', 666.0000, 'ºC'),
	(185820, 122, '2014-02-01 00:35:32.000000', 'temperatura', 537.0000, 'ºC'),
	(185821, 122, '2014-02-01 00:35:33.000000', 'temperatura', 686.0000, 'ºC'),
	(185822, 122, '2014-02-01 00:35:34.000000', 'temperatura', 622.0000, 'ºC'),
	(185823, 122, '2014-02-01 00:35:35.000000', 'temperatura', 1051.0000, 'ºC'),
	(185824, 122, '2014-02-01 00:35:36.000000', 'temperatura', 991.0000, 'ºC'),
	(185825, 122, '2014-02-01 00:35:37.000000', 'temperatura', 600.0000, 'ºC'),
	(185826, 122, '2014-02-01 00:35:38.000000', 'temperatura', 27.0000, 'ºC'),
	(185827, 122, '2014-02-01 00:35:39.000000', 'temperatura', 737.0000, 'ºC'),
	(185828, 122, '2014-02-01 00:35:40.000000', 'temperatura', 4.0000, 'ºC'),
	(185829, 122, '2014-02-01 00:35:41.000000', 'temperatura', 210.0000, 'ºC'),
	(185830, 122, '2014-02-01 00:35:42.000000', 'temperatura', 1037.0000, 'ºC'),
	(185831, 122, '2014-02-01 00:35:43.000000', 'temperatura', 957.0000, 'ºC'),
	(185832, 122, '2014-02-01 00:35:44.000000', 'temperatura', 476.0000, 'ºC'),
	(185833, 122, '2014-02-01 00:35:45.000000', 'temperatura', 708.0000, 'ºC'),
	(185834, 122, '2014-02-01 00:35:46.000000', 'temperatura', 914.0000, 'ºC'),
	(185835, 122, '2014-02-01 00:35:47.000000', 'temperatura', 45.0000, 'ºC'),
	(185836, 122, '2014-02-01 00:35:48.000000', 'temperatura', 1083.0000, 'ºC'),
	(185837, 122, '2014-02-01 00:35:49.000000', 'temperatura', 482.0000, 'ºC'),
	(185838, 122, '2014-02-01 00:35:50.000000', 'temperatura', 362.0000, 'ºC'),
	(185839, 122, '2014-02-01 00:35:51.000000', 'temperatura', 363.0000, 'ºC'),
	(185840, 122, '2014-02-01 00:35:52.000000', 'temperatura', 730.0000, 'ºC'),
	(185841, 122, '2014-02-01 00:35:53.000000', 'temperatura', 162.0000, 'ºC'),
	(185842, 122, '2014-02-01 00:35:54.000000', 'temperatura', 1022.0000, 'ºC'),
	(185843, 122, '2014-02-01 00:35:55.000000', 'temperatura', 1021.0000, 'ºC'),
	(185844, 122, '2014-02-01 00:35:56.000000', 'temperatura', 842.0000, 'ºC'),
	(185845, 122, '2014-02-01 00:35:57.000000', 'temperatura', 1147.0000, 'ºC'),
	(185846, 122, '2014-02-01 00:35:58.000000', 'temperatura', 807.0000, 'ºC'),
	(185847, 122, '2014-02-01 00:35:59.000000', 'temperatura', 597.0000, 'ºC'),
	(185848, 122, '2014-02-01 00:36:00.000000', 'temperatura', 566.0000, 'ºC'),
	(185849, 122, '2014-02-01 00:36:01.000000', 'temperatura', 1037.0000, 'ºC'),
	(185850, 122, '2014-02-01 00:36:02.000000', 'temperatura', 1089.0000, 'ºC'),
	(185851, 122, '2014-02-01 00:36:03.000000', 'temperatura', 1134.0000, 'ºC'),
	(185852, 122, '2014-02-01 00:36:04.000000', 'temperatura', 5.0000, 'ºC'),
	(185853, 122, '2014-02-01 00:36:05.000000', 'temperatura', 224.0000, 'ºC'),
	(185854, 122, '2014-02-01 00:36:06.000000', 'temperatura', 1105.0000, 'ºC'),
	(185855, 122, '2014-02-01 00:36:07.000000', 'temperatura', 54.0000, 'ºC'),
	(185856, 122, '2014-02-01 00:36:08.000000', 'temperatura', 556.0000, 'ºC'),
	(185857, 122, '2014-02-01 00:36:09.000000', 'temperatura', 217.0000, 'ºC'),
	(185858, 122, '2014-02-01 00:36:10.000000', 'temperatura', 617.0000, 'ºC'),
	(185859, 122, '2014-02-01 00:36:11.000000', 'temperatura', 36.0000, 'ºC'),
	(185860, 122, '2014-02-01 00:36:12.000000', 'temperatura', 728.0000, 'ºC'),
	(185861, 122, '2014-02-01 00:36:13.000000', 'temperatura', 1132.0000, 'ºC'),
	(185862, 122, '2014-02-01 00:36:14.000000', 'temperatura', 1075.0000, 'ºC'),
	(185863, 122, '2014-02-01 00:36:15.000000', 'temperatura', 783.0000, 'ºC'),
	(185864, 122, '2014-02-01 00:36:16.000000', 'temperatura', 690.0000, 'ºC'),
	(185865, 122, '2014-02-01 00:36:17.000000', 'temperatura', 1102.0000, 'ºC'),
	(185866, 122, '2014-02-01 00:36:18.000000', 'temperatura', 1040.0000, 'ºC'),
	(185867, 122, '2014-02-01 00:36:19.000000', 'temperatura', 694.0000, 'ºC'),
	(185868, 122, '2014-02-01 00:36:20.000000', 'temperatura', 350.0000, 'ºC'),
	(185869, 122, '2014-02-01 00:36:21.000000', 'temperatura', 868.0000, 'ºC'),
	(185870, 122, '2014-02-01 00:36:22.000000', 'temperatura', 890.0000, 'ºC'),
	(185871, 122, '2014-02-01 00:36:23.000000', 'temperatura', 648.0000, 'ºC'),
	(185872, 122, '2014-02-01 00:36:24.000000', 'temperatura', 571.0000, 'ºC'),
	(185873, 122, '2014-02-01 00:36:25.000000', 'temperatura', 911.0000, 'ºC'),
	(185874, 122, '2014-02-01 00:36:26.000000', 'temperatura', 440.0000, 'ºC'),
	(185875, 122, '2014-02-01 00:36:27.000000', 'temperatura', 671.0000, 'ºC'),
	(185876, 122, '2014-02-01 00:36:28.000000', 'temperatura', 832.0000, 'ºC'),
	(185877, 122, '2014-02-01 00:36:29.000000', 'temperatura', 950.0000, 'ºC'),
	(185878, 122, '2014-02-01 00:36:30.000000', 'temperatura', 1055.0000, 'ºC'),
	(185879, 122, '2014-02-01 00:36:31.000000', 'temperatura', 23.0000, 'ºC'),
	(185880, 122, '2014-02-01 00:36:32.000000', 'temperatura', 553.0000, 'ºC'),
	(185881, 122, '2014-02-01 00:36:33.000000', 'temperatura', 297.0000, 'ºC'),
	(185882, 122, '2014-02-01 00:36:34.000000', 'temperatura', 1024.0000, 'ºC'),
	(185883, 122, '2014-02-01 00:36:35.000000', 'temperatura', 632.0000, 'ºC'),
	(185884, 122, '2014-02-01 00:36:36.000000', 'temperatura', 87.0000, 'ºC'),
	(185885, 122, '2014-02-01 00:36:37.000000', 'temperatura', 941.0000, 'ºC'),
	(185886, 122, '2014-02-01 00:36:38.000000', 'temperatura', 844.0000, 'ºC'),
	(185887, 122, '2014-02-01 00:36:39.000000', 'temperatura', 195.0000, 'ºC'),
	(185888, 122, '2014-02-01 00:36:40.000000', 'temperatura', 847.0000, 'ºC'),
	(185889, 122, '2014-02-01 00:36:41.000000', 'temperatura', 49.0000, 'ºC'),
	(185890, 122, '2014-02-01 00:36:42.000000', 'temperatura', 106.0000, 'ºC'),
	(185891, 122, '2014-02-01 00:36:43.000000', 'temperatura', 385.0000, 'ºC'),
	(185892, 122, '2014-02-01 00:36:44.000000', 'temperatura', 404.0000, 'ºC'),
	(185893, 122, '2014-02-01 00:36:45.000000', 'temperatura', 865.0000, 'ºC'),
	(185894, 122, '2014-02-01 00:36:46.000000', 'temperatura', 715.0000, 'ºC'),
	(185895, 122, '2014-02-01 00:36:47.000000', 'temperatura', 982.0000, 'ºC'),
	(185896, 122, '2014-02-01 00:36:48.000000', 'temperatura', 365.0000, 'ºC'),
	(185897, 122, '2014-02-01 00:36:49.000000', 'temperatura', 79.0000, 'ºC'),
	(185898, 122, '2014-02-01 00:36:50.000000', 'temperatura', 498.0000, 'ºC'),
	(185899, 122, '2014-02-01 00:36:51.000000', 'temperatura', 1057.0000, 'ºC'),
	(185900, 122, '2014-02-01 00:36:52.000000', 'temperatura', 190.0000, 'ºC'),
	(185901, 122, '2014-02-01 00:36:53.000000', 'temperatura', 180.0000, 'ºC'),
	(185902, 122, '2014-02-01 00:36:54.000000', 'temperatura', 332.0000, 'ºC'),
	(185903, 122, '2014-02-01 00:36:55.000000', 'temperatura', 1119.0000, 'ºC'),
	(185904, 122, '2014-02-01 00:36:56.000000', 'temperatura', 1000.0000, 'ºC'),
	(185905, 122, '2014-02-01 00:36:57.000000', 'temperatura', 443.0000, 'ºC'),
	(185906, 122, '2014-02-01 00:36:58.000000', 'temperatura', 418.0000, 'ºC'),
	(185907, 122, '2014-02-01 00:36:59.000000', 'temperatura', 759.0000, 'ºC'),
	(185908, 122, '2014-02-01 00:37:00.000000', 'temperatura', 141.0000, 'ºC'),
	(185909, 122, '2014-02-01 00:37:01.000000', 'temperatura', 830.0000, 'ºC'),
	(185910, 122, '2014-02-01 00:37:02.000000', 'temperatura', 129.0000, 'ºC'),
	(185911, 122, '2014-02-01 00:37:03.000000', 'temperatura', 553.0000, 'ºC'),
	(185912, 122, '2014-02-01 00:37:04.000000', 'temperatura', 1181.0000, 'ºC'),
	(185913, 122, '2014-02-01 00:37:05.000000', 'temperatura', 645.0000, 'ºC'),
	(185914, 122, '2014-02-01 00:37:06.000000', 'temperatura', 885.0000, 'ºC'),
	(185915, 122, '2014-02-01 00:37:07.000000', 'temperatura', 88.0000, 'ºC'),
	(185916, 122, '2014-02-01 00:37:08.000000', 'temperatura', 187.0000, 'ºC'),
	(185917, 122, '2014-02-01 00:37:09.000000', 'temperatura', 672.0000, 'ºC'),
	(185918, 122, '2014-02-01 00:37:10.000000', 'temperatura', 400.0000, 'ºC'),
	(185919, 122, '2014-02-01 00:37:11.000000', 'temperatura', 1184.0000, 'ºC'),
	(185920, 122, '2014-02-01 00:37:12.000000', 'temperatura', 1118.0000, 'ºC'),
	(185921, 122, '2014-02-01 00:37:13.000000', 'temperatura', 840.0000, 'ºC'),
	(185922, 122, '2014-02-01 00:37:14.000000', 'temperatura', 849.0000, 'ºC'),
	(185923, 122, '2014-02-01 00:37:15.000000', 'temperatura', 522.0000, 'ºC'),
	(185924, 122, '2014-02-01 00:37:16.000000', 'temperatura', 66.0000, 'ºC'),
	(185925, 122, '2014-02-01 00:37:17.000000', 'temperatura', 1164.0000, 'ºC'),
	(185926, 122, '2014-02-01 00:37:18.000000', 'temperatura', 821.0000, 'ºC'),
	(185927, 122, '2014-02-01 00:37:19.000000', 'temperatura', 615.0000, 'ºC'),
	(185928, 122, '2014-02-01 00:37:20.000000', 'temperatura', 613.0000, 'ºC'),
	(185929, 122, '2014-02-01 00:37:21.000000', 'temperatura', 21.0000, 'ºC'),
	(185930, 122, '2014-02-01 00:37:22.000000', 'temperatura', 665.0000, 'ºC'),
	(185931, 122, '2014-02-01 00:37:23.000000', 'temperatura', 864.0000, 'ºC'),
	(185932, 122, '2014-02-01 00:37:24.000000', 'temperatura', 1125.0000, 'ºC'),
	(185933, 122, '2014-02-01 00:37:25.000000', 'temperatura', 635.0000, 'ºC'),
	(185934, 122, '2014-02-01 00:37:26.000000', 'temperatura', 1000.0000, 'ºC'),
	(185935, 122, '2014-02-01 00:37:27.000000', 'temperatura', 694.0000, 'ºC'),
	(185936, 122, '2014-02-01 00:37:28.000000', 'temperatura', 472.0000, 'ºC'),
	(185937, 122, '2014-02-01 00:37:29.000000', 'temperatura', 279.0000, 'ºC'),
	(185938, 122, '2014-02-01 00:37:30.000000', 'temperatura', 1178.0000, 'ºC'),
	(185939, 122, '2014-02-01 00:37:31.000000', 'temperatura', 252.0000, 'ºC'),
	(185940, 122, '2014-02-01 00:37:32.000000', 'temperatura', 129.0000, 'ºC'),
	(185941, 122, '2014-02-01 00:37:33.000000', 'temperatura', 1087.0000, 'ºC'),
	(185942, 122, '2014-02-01 00:37:34.000000', 'temperatura', 250.0000, 'ºC'),
	(185943, 122, '2014-02-01 00:37:35.000000', 'temperatura', 390.0000, 'ºC'),
	(185944, 122, '2014-02-01 00:37:36.000000', 'temperatura', 1199.0000, 'ºC'),
	(185945, 122, '2014-02-01 00:37:37.000000', 'temperatura', 25.0000, 'ºC'),
	(185946, 122, '2014-02-01 00:37:38.000000', 'temperatura', 128.0000, 'ºC'),
	(185947, 122, '2014-02-01 00:37:39.000000', 'temperatura', 567.0000, 'ºC'),
	(185948, 122, '2014-02-01 00:37:40.000000', 'temperatura', 51.0000, 'ºC'),
	(185949, 122, '2014-02-01 00:37:41.000000', 'temperatura', 954.0000, 'ºC'),
	(185950, 122, '2014-02-01 00:37:42.000000', 'temperatura', 1017.0000, 'ºC'),
	(185951, 122, '2014-02-01 00:37:43.000000', 'temperatura', 1024.0000, 'ºC'),
	(185952, 122, '2014-02-01 00:37:44.000000', 'temperatura', 872.0000, 'ºC'),
	(185953, 122, '2014-02-01 00:37:45.000000', 'temperatura', 85.0000, 'ºC'),
	(185954, 122, '2014-02-01 00:37:46.000000', 'temperatura', 209.0000, 'ºC'),
	(185955, 122, '2014-02-01 00:37:47.000000', 'temperatura', 793.0000, 'ºC'),
	(185956, 122, '2014-02-01 00:37:48.000000', 'temperatura', 939.0000, 'ºC'),
	(185957, 122, '2014-02-01 00:37:49.000000', 'temperatura', 1117.0000, 'ºC'),
	(185958, 122, '2014-02-01 00:37:50.000000', 'temperatura', 366.0000, 'ºC'),
	(185959, 122, '2014-02-01 00:37:51.000000', 'temperatura', 882.0000, 'ºC'),
	(185960, 122, '2014-02-01 00:37:52.000000', 'temperatura', 910.0000, 'ºC'),
	(185961, 122, '2014-02-01 00:37:53.000000', 'temperatura', 706.0000, 'ºC'),
	(185962, 122, '2014-02-01 00:37:54.000000', 'temperatura', 800.0000, 'ºC'),
	(185963, 122, '2014-02-01 00:37:55.000000', 'temperatura', 683.0000, 'ºC'),
	(185964, 122, '2014-02-01 00:37:56.000000', 'temperatura', 1014.0000, 'ºC'),
	(185965, 122, '2014-02-01 00:37:57.000000', 'temperatura', 623.0000, 'ºC'),
	(185966, 122, '2014-02-01 00:37:58.000000', 'temperatura', 72.0000, 'ºC'),
	(185967, 122, '2014-02-01 00:37:59.000000', 'temperatura', 891.0000, 'ºC'),
	(185968, 122, '2014-02-01 00:38:00.000000', 'temperatura', 638.0000, 'ºC'),
	(185969, 122, '2014-02-01 00:38:01.000000', 'temperatura', 520.0000, 'ºC'),
	(185970, 122, '2014-02-01 00:38:02.000000', 'temperatura', 688.0000, 'ºC'),
	(185971, 122, '2014-02-01 00:38:03.000000', 'temperatura', 678.0000, 'ºC'),
	(185972, 122, '2014-02-01 00:38:04.000000', 'temperatura', 129.0000, 'ºC'),
	(185973, 122, '2014-02-01 00:38:05.000000', 'temperatura', 1009.0000, 'ºC'),
	(185974, 122, '2014-02-01 00:38:06.000000', 'temperatura', 1060.0000, 'ºC'),
	(185975, 122, '2014-02-01 00:38:07.000000', 'temperatura', 1074.0000, 'ºC'),
	(185976, 122, '2014-02-01 00:38:08.000000', 'temperatura', 990.0000, 'ºC'),
	(185977, 122, '2014-02-01 00:38:09.000000', 'temperatura', 529.0000, 'ºC'),
	(185978, 122, '2014-02-01 00:38:10.000000', 'temperatura', 877.0000, 'ºC'),
	(185979, 122, '2014-02-01 00:38:11.000000', 'temperatura', 396.0000, 'ºC'),
	(185980, 122, '2014-02-01 00:38:12.000000', 'temperatura', 551.0000, 'ºC'),
	(185981, 122, '2014-02-01 00:38:13.000000', 'temperatura', 365.0000, 'ºC'),
	(185982, 122, '2014-02-01 00:38:14.000000', 'temperatura', 176.0000, 'ºC'),
	(185983, 122, '2014-02-01 00:38:15.000000', 'temperatura', 984.0000, 'ºC'),
	(185984, 122, '2014-02-01 00:38:16.000000', 'temperatura', 792.0000, 'ºC'),
	(185985, 122, '2014-02-01 00:38:17.000000', 'temperatura', 1009.0000, 'ºC'),
	(185986, 122, '2014-02-01 00:38:18.000000', 'temperatura', 268.0000, 'ºC'),
	(185987, 122, '2014-02-01 00:38:19.000000', 'temperatura', 713.0000, 'ºC'),
	(185988, 122, '2014-02-01 00:38:20.000000', 'temperatura', 363.0000, 'ºC'),
	(185989, 122, '2014-02-01 00:38:21.000000', 'temperatura', 877.0000, 'ºC'),
	(185990, 122, '2014-02-01 00:38:22.000000', 'temperatura', 894.0000, 'ºC'),
	(185991, 122, '2014-02-01 00:38:23.000000', 'temperatura', 642.0000, 'ºC'),
	(185992, 122, '2014-02-01 00:38:24.000000', 'temperatura', 527.0000, 'ºC'),
	(185993, 122, '2014-02-01 00:38:25.000000', 'temperatura', 709.0000, 'ºC'),
	(185994, 122, '2014-02-01 00:38:26.000000', 'temperatura', 765.0000, 'ºC'),
	(185995, 122, '2014-02-01 00:38:27.000000', 'temperatura', 499.0000, 'ºC'),
	(185996, 122, '2014-02-01 00:38:28.000000', 'temperatura', 199.0000, 'ºC'),
	(185997, 122, '2014-02-01 00:38:29.000000', 'temperatura', 699.0000, 'ºC'),
	(185998, 122, '2014-02-01 00:38:30.000000', 'temperatura', 497.0000, 'ºC'),
	(185999, 122, '2014-02-01 00:38:31.000000', 'temperatura', 392.0000, 'ºC'),
	(186000, 122, '2014-02-01 00:38:32.000000', 'temperatura', 466.0000, 'ºC'),
	(186001, 122, '2014-02-01 00:38:33.000000', 'temperatura', 1157.0000, 'ºC'),
	(186002, 122, '2014-02-01 00:38:34.000000', 'temperatura', 785.0000, 'ºC'),
	(186003, 122, '2014-02-01 00:38:35.000000', 'temperatura', 457.0000, 'ºC'),
	(186004, 122, '2014-02-01 00:38:36.000000', 'temperatura', 1128.0000, 'ºC'),
	(186005, 122, '2014-02-01 00:38:37.000000', 'temperatura', 672.0000, 'ºC'),
	(186006, 122, '2014-02-01 00:38:38.000000', 'temperatura', 1174.0000, 'ºC'),
	(186007, 122, '2014-02-01 00:38:39.000000', 'temperatura', 256.0000, 'ºC'),
	(186008, 122, '2014-02-01 00:38:40.000000', 'temperatura', 157.0000, 'ºC'),
	(186009, 122, '2014-02-01 00:38:41.000000', 'temperatura', 19.0000, 'ºC'),
	(186010, 122, '2014-02-01 00:38:42.000000', 'temperatura', 823.0000, 'ºC'),
	(186011, 122, '2014-02-01 00:38:43.000000', 'temperatura', 458.0000, 'ºC'),
	(186012, 122, '2014-02-01 00:38:44.000000', 'temperatura', 1023.0000, 'ºC'),
	(186013, 122, '2014-02-01 00:38:45.000000', 'temperatura', 140.0000, 'ºC'),
	(186014, 122, '2014-02-01 00:38:46.000000', 'temperatura', 32.0000, 'ºC'),
	(186015, 122, '2014-02-01 00:38:47.000000', 'temperatura', 941.0000, 'ºC'),
	(186016, 122, '2014-02-01 00:38:48.000000', 'temperatura', 1008.0000, 'ºC'),
	(186017, 122, '2014-02-01 00:38:49.000000', 'temperatura', 1017.0000, 'ºC'),
	(186018, 122, '2014-02-01 00:38:50.000000', 'temperatura', 864.0000, 'ºC'),
	(186019, 122, '2014-02-01 00:38:51.000000', 'temperatura', 70.0000, 'ºC'),
	(186020, 122, '2014-02-01 00:38:52.000000', 'temperatura', 157.0000, 'ºC'),
	(186021, 122, '2014-02-01 00:38:53.000000', 'temperatura', 575.0000, 'ºC'),
	(186022, 122, '2014-02-01 00:38:54.000000', 'temperatura', 3.0000, 'ºC'),
	(186023, 122, '2014-02-01 00:38:55.000000', 'temperatura', 693.0000, 'ºC'),
	(186024, 122, '2014-02-01 00:38:56.000000', 'temperatura', 1056.0000, 'ºC'),
	(186025, 122, '2014-02-01 00:38:57.000000', 'temperatura', 802.0000, 'ºC'),
	(186026, 122, '2014-02-01 00:38:58.000000', 'temperatura', 841.0000, 'ºC'),
	(186027, 122, '2014-02-01 00:38:59.000000', 'temperatura', 598.0000, 'ºC'),
	(186028, 122, '2014-02-01 00:39:00.000000', 'temperatura', 470.0000, 'ºC'),
	(186029, 122, '2014-02-01 00:39:01.000000', 'temperatura', 554.0000, 'ºC'),
	(186030, 122, '2014-02-01 00:39:02.000000', 'temperatura', 164.0000, 'ºC'),
	(186031, 122, '2014-02-01 00:39:03.000000', 'temperatura', 355.0000, 'ºC'),
	(186032, 122, '2014-02-01 00:39:04.000000', 'temperatura', 85.0000, 'ºC'),
	(186033, 122, '2014-02-01 00:39:05.000000', 'temperatura', 561.0000, 'ºC'),
	(186034, 122, '2014-02-01 00:39:06.000000', 'temperatura', 149.0000, 'ºC'),
	(186035, 122, '2014-02-01 00:39:07.000000', 'temperatura', 264.0000, 'ºC'),
	(186036, 122, '2014-02-01 00:39:08.000000', 'temperatura', 874.0000, 'ºC'),
	(186037, 122, '2014-02-01 00:39:09.000000', 'temperatura', 1179.0000, 'ºC'),
	(186038, 122, '2014-02-01 00:39:10.000000', 'temperatura', 873.0000, 'ºC'),
	(186039, 122, '2014-02-01 00:39:11.000000', 'temperatura', 827.0000, 'ºC'),
	(186040, 122, '2014-02-01 00:39:12.000000', 'temperatura', 316.0000, 'ºC'),
	(186041, 122, '2014-02-01 00:39:13.000000', 'temperatura', 300.0000, 'ºC'),
	(186042, 122, '2014-02-01 00:39:14.000000', 'temperatura', 552.0000, 'ºC'),
	(186043, 122, '2014-02-01 00:39:15.000000', 'temperatura', 660.0000, 'ºC'),
	(186044, 122, '2014-02-01 00:39:16.000000', 'temperatura', 447.0000, 'ºC'),
	(186045, 122, '2014-02-01 00:39:17.000000', 'temperatura', 252.0000, 'ºC'),
	(186046, 122, '2014-02-01 00:39:18.000000', 'temperatura', 1123.0000, 'ºC'),
	(186047, 122, '2014-02-01 00:39:19.000000', 'temperatura', 58.0000, 'ºC'),
	(186048, 122, '2014-02-01 00:39:20.000000', 'temperatura', 523.0000, 'ºC'),
	(186049, 122, '2014-02-01 00:39:21.000000', 'temperatura', 42.0000, 'ºC'),
	(186050, 122, '2014-02-01 00:39:22.000000', 'temperatura', 1040.0000, 'ºC'),
	(186051, 122, '2014-02-01 00:39:23.000000', 'temperatura', 273.0000, 'ºC'),
	(186052, 122, '2014-02-01 00:39:24.000000', 'temperatura', 647.0000, 'ºC'),
	(186053, 122, '2014-02-01 00:39:25.000000', 'temperatura', 16.0000, 'ºC'),
	(186054, 122, '2014-02-01 00:39:26.000000', 'temperatura', 541.0000, 'ºC'),
	(186055, 122, '2014-02-01 00:39:27.000000', 'temperatura', 255.0000, 'ºC'),
	(186056, 122, '2014-02-01 00:39:28.000000', 'temperatura', 854.0000, 'ºC'),
	(186057, 122, '2014-02-01 00:39:29.000000', 'temperatura', 1104.0000, 'ºC'),
	(186058, 122, '2014-02-01 00:39:30.000000', 'temperatura', 560.0000, 'ºC'),
	(186059, 122, '2014-02-01 00:39:31.000000', 'temperatura', 689.0000, 'ºC'),
	(186060, 122, '2014-02-01 00:39:32.000000', 'temperatura', 563.0000, 'ºC'),
	(186061, 122, '2014-02-01 00:39:33.000000', 'temperatura', 750.0000, 'ºC'),
	(186062, 122, '2014-02-01 00:39:34.000000', 'temperatura', 860.0000, 'ºC'),
	(186063, 122, '2014-02-01 00:39:35.000000', 'temperatura', 851.0000, 'ºC'),
	(186064, 122, '2014-02-01 00:39:36.000000', 'temperatura', 474.0000, 'ºC'),
	(186065, 122, '2014-02-01 00:39:37.000000', 'temperatura', 1018.0000, 'ºC'),
	(186066, 122, '2014-02-01 00:39:38.000000', 'temperatura', 71.0000, 'ºC'),
	(186067, 122, '2014-02-01 00:39:39.000000', 'temperatura', 900.0000, 'ºC'),
	(186068, 122, '2014-02-01 00:39:40.000000', 'temperatura', 688.0000, 'ºC'),
	(186069, 122, '2014-02-01 00:39:41.000000', 'temperatura', 740.0000, 'ºC'),
	(186070, 122, '2014-02-01 00:39:42.000000', 'temperatura', 438.0000, 'ºC'),
	(186071, 122, '2014-02-01 00:39:43.000000', 'temperatura', 1170.0000, 'ºC'),
	(186072, 122, '2014-02-01 00:39:44.000000', 'temperatura', 936.0000, 'ºC'),
	(186073, 122, '2014-02-01 00:39:45.000000', 'temperatura', 1169.0000, 'ºC'),
	(186074, 122, '2014-02-01 00:39:46.000000', 'temperatura', 637.0000, 'ºC'),
	(186075, 122, '2014-02-01 00:39:47.000000', 'temperatura', 881.0000, 'ºC'),
	(186076, 122, '2014-02-01 00:39:48.000000', 'temperatura', 96.0000, 'ºC'),
	(186077, 122, '2014-02-01 00:39:49.000000', 'temperatura', 234.0000, 'ºC'),
	(186078, 122, '2014-02-01 00:39:50.000000', 'temperatura', 884.0000, 'ºC'),
	(186079, 122, '2014-02-01 00:39:51.000000', 'temperatura', 119.0000, 'ºC'),
	(186080, 122, '2014-02-01 00:39:52.000000', 'temperatura', 342.0000, 'ºC'),
	(186081, 122, '2014-02-01 00:39:53.000000', 'temperatura', 153.0000, 'ºC'),
	(186082, 122, '2014-02-01 00:39:54.000000', 'temperatura', 939.0000, 'ºC'),
	(186083, 122, '2014-02-01 00:39:55.000000', 'temperatura', 638.0000, 'ºC'),
	(186084, 122, '2014-02-01 00:39:56.000000', 'temperatura', 374.0000, 'ºC'),
	(186085, 122, '2014-02-01 00:39:57.000000', 'temperatura', 1157.0000, 'ºC'),
	(186086, 122, '2014-02-01 00:39:58.000000', 'temperatura', 1062.0000, 'ºC'),
	(186087, 122, '2014-02-01 00:39:59.000000', 'temperatura', 642.0000, 'ºC'),
	(186088, 122, '2014-02-01 00:40:00.000000', 'temperatura', 22.0000, 'ºC'),
	(186089, 122, '2014-02-01 00:40:01.000000', 'temperatura', 584.0000, 'ºC'),
	(186090, 122, '2014-02-01 00:40:02.000000', 'temperatura', 456.0000, 'ºC'),
	(186091, 122, '2014-02-01 00:40:03.000000', 'temperatura', 527.0000, 'ºC'),
	(186092, 122, '2014-02-01 00:40:04.000000', 'temperatura', 69.0000, 'ºC'),
	(186093, 122, '2014-02-01 00:40:05.000000', 'temperatura', 1165.0000, 'ºC'),
	(186094, 122, '2014-02-01 00:40:06.000000', 'temperatura', 816.0000, 'ºC'),
	(186095, 122, '2014-02-01 00:40:07.000000', 'temperatura', 587.0000, 'ºC'),
	(186096, 122, '2014-02-01 00:40:08.000000', 'temperatura', 485.0000, 'ºC'),
	(186097, 122, '2014-02-01 00:40:09.000000', 'temperatura', 667.0000, 'ºC'),
	(186098, 122, '2014-02-01 00:40:10.000000', 'temperatura', 682.0000, 'ºC'),
	(186099, 122, '2014-02-01 00:40:11.000000', 'temperatura', 207.0000, 'ºC'),
	(186100, 122, '2014-02-01 00:40:12.000000', 'temperatura', 190.0000, 'ºC'),
	(186101, 122, '2014-02-01 00:40:13.000000', 'temperatura', 328.0000, 'ºC'),
	(186102, 122, '2014-02-01 00:40:14.000000', 'temperatura', 1071.0000, 'ºC'),
	(186103, 122, '2014-02-01 00:40:15.000000', 'temperatura', 773.0000, 'ºC'),
	(186104, 122, '2014-02-01 00:40:16.000000', 'temperatura', 652.0000, 'ºC'),
	(186105, 122, '2014-02-01 00:40:17.000000', 'temperatura', 942.0000, 'ºC'),
	(186106, 122, '2014-02-01 00:40:18.000000', 'temperatura', 352.0000, 'ºC'),
	(186107, 122, '2014-02-01 00:40:19.000000', 'temperatura', 137.0000, 'ºC'),
	(186108, 122, '2014-02-01 00:40:20.000000', 'temperatura', 828.0000, 'ºC'),
	(186109, 122, '2014-02-01 00:40:21.000000', 'temperatura', 131.0000, 'ºC'),
	(186110, 122, '2014-02-01 00:40:22.000000', 'temperatura', 571.0000, 'ºC'),
	(186111, 122, '2014-02-01 00:40:23.000000', 'temperatura', 64.0000, 'ºC'),
	(186112, 122, '2014-02-01 00:40:24.000000', 'temperatura', 1004.0000, 'ºC'),
	(186113, 122, '2014-02-01 00:40:25.000000', 'temperatura', 31.0000, 'ºC'),
	(186114, 122, '2014-02-01 00:40:26.000000', 'temperatura', 744.0000, 'ºC'),
	(186115, 122, '2014-02-01 00:40:27.000000', 'temperatura', 28.0000, 'ºC'),
	(186116, 122, '2014-02-01 00:40:28.000000', 'temperatura', 310.0000, 'ºC'),
	(186117, 122, '2014-02-01 00:40:29.000000', 'temperatura', 263.0000, 'ºC'),
	(186118, 122, '2014-02-01 00:40:30.000000', 'temperatura', 387.0000, 'ºC'),
	(186119, 122, '2014-02-01 00:40:31.000000', 'temperatura', 1146.0000, 'ºC'),
	(186120, 122, '2014-02-01 00:40:32.000000', 'temperatura', 971.0000, 'ºC'),
	(186121, 122, '2014-02-01 00:40:33.000000', 'temperatura', 217.0000, 'ºC'),
	(186122, 122, '2014-02-01 00:40:34.000000', 'temperatura', 571.0000, 'ºC'),
	(186123, 122, '2014-02-01 00:40:35.000000', 'temperatura', 1006.0000, 'ºC'),
	(186124, 122, '2014-02-01 00:40:36.000000', 'temperatura', 917.0000, 'ºC'),
	(186125, 122, '2014-02-01 00:40:37.000000', 'temperatura', 368.0000, 'ºC'),
	(186126, 122, '2014-02-01 00:40:38.000000', 'temperatura', 288.0000, 'ºC'),
	(186127, 122, '2014-02-01 00:40:39.000000', 'temperatura', 338.0000, 'ºC'),
	(186128, 122, '2014-02-01 00:40:40.000000', 'temperatura', 824.0000, 'ºC'),
	(186129, 122, '2014-02-01 00:40:41.000000', 'temperatura', 708.0000, 'ºC'),
	(186130, 122, '2014-02-01 00:40:42.000000', 'temperatura', 1068.0000, 'ºC'),
	(186131, 122, '2014-02-01 00:40:43.000000', 'temperatura', 816.0000, 'ºC'),
	(186132, 122, '2014-02-01 00:40:44.000000', 'temperatura', 876.0000, 'ºC'),
	(186133, 122, '2014-02-01 00:40:45.000000', 'temperatura', 734.0000, 'ºC'),
	(186134, 122, '2014-02-01 00:40:46.000000', 'temperatura', 1042.0000, 'ºC'),
	(186135, 122, '2014-02-01 00:40:47.000000', 'temperatura', 608.0000, 'ºC'),
	(186136, 122, '2014-02-01 00:40:48.000000', 'temperatura', 1115.0000, 'ºC'),
	(186137, 122, '2014-02-01 00:40:49.000000', 'temperatura', 152.0000, 'ºC'),
	(186138, 122, '2014-02-01 00:40:50.000000', 'temperatura', 1016.0000, 'ºC'),
	(186139, 122, '2014-02-01 00:40:51.000000', 'temperatura', 1023.0000, 'ºC'),
	(186140, 122, '2014-02-01 00:40:52.000000', 'temperatura', 869.0000, 'ºC'),
	(186141, 122, '2014-02-01 00:40:53.000000', 'temperatura', 75.0000, 'ºC'),
	(186142, 122, '2014-02-01 00:40:54.000000', 'temperatura', 170.0000, 'ºC'),
	(186143, 122, '2014-02-01 00:40:55.000000', 'temperatura', 627.0000, 'ºC'),
	(186144, 122, '2014-02-01 00:40:56.000000', 'temperatura', 222.0000, 'ºC'),
	(186145, 122, '2014-02-01 00:40:57.000000', 'temperatura', 431.0000, 'ºC'),
	(186146, 122, '2014-02-01 00:40:58.000000', 'temperatura', 291.0000, 'ºC'),
	(186147, 122, '2014-02-01 00:40:59.000000', 'temperatura', 163.0000, 'ºC'),
	(186148, 122, '2014-02-01 00:41:00.000000', 'temperatura', 1141.0000, 'ºC'),
	(186149, 122, '2014-02-01 00:41:01.000000', 'temperatura', 416.0000, 'ºC'),
	(186150, 122, '2014-02-01 00:41:02.000000', 'temperatura', 1058.0000, 'ºC'),
	(186151, 122, '2014-02-01 00:41:03.000000', 'temperatura', 444.0000, 'ºC'),
	(186152, 122, '2014-02-01 00:41:04.000000', 'temperatura', 247.0000, 'ºC'),
	(186153, 122, '2014-02-01 00:41:05.000000', 'temperatura', 1103.0000, 'ºC'),
	(186154, 122, '2014-02-01 00:41:06.000000', 'temperatura', 1176.0000, 'ºC'),
	(186155, 122, '2014-02-01 00:41:07.000000', 'temperatura', 169.0000, 'ºC'),
	(186156, 122, '2014-02-01 00:41:08.000000', 'temperatura', 919.0000, 'ºC'),
	(186157, 122, '2014-02-01 00:41:09.000000', 'temperatura', 490.0000, 'ºC'),
	(186158, 122, '2014-02-01 00:41:10.000000', 'temperatura', 891.0000, 'ºC'),
	(186159, 122, '2014-02-01 00:41:11.000000', 'temperatura', 586.0000, 'ºC'),
	(186160, 122, '2014-02-01 00:41:12.000000', 'temperatura', 259.0000, 'ºC'),
	(186161, 122, '2014-02-01 00:41:13.000000', 'temperatura', 738.0000, 'ºC'),
	(186162, 122, '2014-02-01 00:41:14.000000', 'temperatura', 512.0000, 'ºC'),
	(186163, 122, '2014-02-01 00:41:15.000000', 'temperatura', 346.0000, 'ºC'),
	(186164, 122, '2014-02-01 00:41:16.000000', 'temperatura', 194.0000, 'ºC'),
	(186165, 122, '2014-02-01 00:41:17.000000', 'temperatura', 1135.0000, 'ºC'),
	(186166, 122, '2014-02-01 00:41:18.000000', 'temperatura', 290.0000, 'ºC'),
	(186167, 122, '2014-02-01 00:41:19.000000', 'temperatura', 448.0000, 'ºC'),
	(186168, 122, '2014-02-01 00:41:20.000000', 'temperatura', 170.0000, 'ºC'),
	(186169, 122, '2014-02-01 00:41:21.000000', 'temperatura', 705.0000, 'ºC'),
	(186170, 122, '2014-02-01 00:41:22.000000', 'temperatura', 616.0000, 'ºC'),
	(186171, 122, '2014-02-01 00:41:23.000000', 'temperatura', 965.0000, 'ºC'),
	(186172, 122, '2014-02-01 00:41:24.000000', 'temperatura', 580.0000, 'ºC'),
	(186173, 122, '2014-02-01 00:41:25.000000', 'temperatura', 2.0000, 'ºC'),
	(186174, 122, '2014-02-01 00:41:26.000000', 'temperatura', 672.0000, 'ºC'),
	(186175, 122, '2014-02-01 00:41:27.000000', 'temperatura', 956.0000, 'ºC'),
	(186176, 122, '2014-02-01 00:41:28.000000', 'temperatura', 364.0000, 'ºC'),
	(186177, 122, '2014-02-01 00:41:29.000000', 'temperatura', 152.0000, 'ºC'),
	(186178, 122, '2014-02-01 00:41:30.000000', 'temperatura', 870.0000, 'ºC'),
	(186179, 122, '2014-02-01 00:41:31.000000', 'temperatura', 292.0000, 'ºC'),
	(186180, 122, '2014-02-01 00:41:32.000000', 'temperatura', 50.0000, 'ºC'),
	(186181, 122, '2014-02-01 00:41:33.000000', 'temperatura', 577.0000, 'ºC'),
	(186182, 122, '2014-02-01 00:41:34.000000', 'temperatura', 336.0000, 'ºC'),
	(186183, 122, '2014-02-01 00:41:35.000000', 'temperatura', 1150.0000, 'ºC'),
	(186184, 122, '2014-02-01 00:41:36.000000', 'temperatura', 1143.0000, 'ºC'),
	(186185, 122, '2014-02-01 00:41:37.000000', 'temperatura', 1062.0000, 'ºC'),
	(186186, 122, '2014-02-01 00:41:38.000000', 'temperatura', 685.0000, 'ºC'),
	(186187, 122, '2014-02-01 00:41:39.000000', 'temperatura', 237.0000, 'ºC'),
	(186188, 122, '2014-02-01 00:41:40.000000', 'temperatura', 331.0000, 'ºC'),
	(186189, 122, '2014-02-01 00:41:41.000000', 'temperatura', 945.0000, 'ºC'),
	(186190, 122, '2014-02-01 00:41:42.000000', 'temperatura', 133.0000, 'ºC'),
	(186191, 122, '2014-02-01 00:41:43.000000', 'temperatura', 232.0000, 'ºC'),
	(186192, 122, '2014-02-01 00:41:44.000000', 'temperatura', 759.0000, 'ºC'),
	(186193, 122, '2014-02-01 00:41:45.000000', 'temperatura', 699.0000, 'ºC'),
	(186194, 122, '2014-02-01 00:41:46.000000', 'temperatura', 18.0000, 'ºC'),
	(186195, 122, '2014-02-01 00:41:47.000000', 'temperatura', 393.0000, 'ºC'),
	(186196, 122, '2014-02-01 00:41:48.000000', 'temperatura', 713.0000, 'ºC'),
	(186197, 122, '2014-02-01 00:41:49.000000', 'temperatura', 1184.0000, 'ºC'),
	(186198, 122, '2014-02-01 00:41:50.000000', 'temperatura', 185.0000, 'ºC'),
	(186199, 122, '2014-02-01 00:41:51.000000', 'temperatura', 972.0000, 'ºC'),
	(186200, 122, '2014-02-01 00:41:52.000000', 'temperatura', 708.0000, 'ºC'),
	(186201, 122, '2014-02-01 00:41:53.000000', 'temperatura', 621.0000, 'ºC'),
	(186202, 122, '2014-02-01 00:41:54.000000', 'temperatura', 982.0000, 'ºC'),
	(186203, 122, '2014-02-01 00:41:55.000000', 'temperatura', 647.0000, 'ºC'),
	(186204, 122, '2014-02-01 00:41:56.000000', 'temperatura', 288.0000, 'ºC'),
	(186205, 122, '2014-02-01 00:41:57.000000', 'temperatura', 702.0000, 'ºC'),
	(186206, 122, '2014-02-01 00:41:58.000000', 'temperatura', 247.0000, 'ºC'),
	(186207, 122, '2014-02-01 00:41:59.000000', 'temperatura', 327.0000, 'ºC'),
	(186208, 122, '2014-02-01 00:42:00.000000', 'temperatura', 897.0000, 'ºC'),
	(186209, 122, '2014-02-01 00:42:01.000000', 'temperatura', 1103.0000, 'ºC'),
	(186210, 122, '2014-02-01 00:42:02.000000', 'temperatura', 425.0000, 'ºC'),
	(186211, 122, '2014-02-01 00:42:03.000000', 'temperatura', 18.0000, 'ºC'),
	(186212, 122, '2014-02-01 00:42:04.000000', 'temperatura', 15.0000, 'ºC'),
	(186213, 122, '2014-02-01 00:42:05.000000', 'temperatura', 21.0000, 'ºC'),
	(186214, 122, '2014-02-01 00:42:06.000000', 'temperatura', 59.0000, 'ºC'),
	(186215, 122, '2014-02-01 00:42:07.000000', 'temperatura', 234.0000, 'ºC'),
	(186216, 122, '2014-02-01 00:42:08.000000', 'temperatura', 994.0000, 'ºC'),
	(186217, 122, '2014-02-01 00:42:09.000000', 'temperatura', 667.0000, 'ºC'),
	(186218, 122, '2014-02-01 00:42:10.000000', 'temperatura', 354.0000, 'ºC'),
	(186219, 122, '2014-02-01 00:42:11.000000', 'temperatura', 972.0000, 'ºC'),
	(186220, 122, '2014-02-01 00:42:12.000000', 'temperatura', 195.0000, 'ºC'),
	(186221, 122, '2014-02-01 00:42:13.000000', 'temperatura', 462.0000, 'ºC'),
	(186222, 122, '2014-02-01 00:42:14.000000', 'temperatura', 525.0000, 'ºC'),
	(186223, 122, '2014-02-01 00:42:15.000000', 'temperatura', 40.0000, 'ºC'),
	(186224, 122, '2014-02-01 00:42:16.000000', 'temperatura', 1026.0000, 'ºC'),
	(186225, 122, '2014-02-01 00:42:17.000000', 'temperatura', 211.0000, 'ºC'),
	(186226, 122, '2014-02-01 00:42:18.000000', 'temperatura', 375.0000, 'ºC'),
	(186227, 122, '2014-02-01 00:42:19.000000', 'temperatura', 43.0000, 'ºC'),
	(186228, 122, '2014-02-01 00:42:20.000000', 'temperatura', 291.0000, 'ºC'),
	(186229, 122, '2014-02-01 00:42:21.000000', 'temperatura', 125.0000, 'ºC'),
	(186230, 122, '2014-02-01 00:42:22.000000', 'temperatura', 955.0000, 'ºC'),
	(186231, 122, '2014-02-01 00:42:23.000000', 'temperatura', 798.0000, 'ºC'),
	(186232, 122, '2014-02-01 00:42:24.000000', 'temperatura', 1126.0000, 'ºC'),
	(186233, 122, '2014-02-01 00:42:25.000000', 'temperatura', 838.0000, 'ºC'),
	(186234, 122, '2014-02-01 00:42:26.000000', 'temperatura', 814.0000, 'ºC'),
	(186235, 122, '2014-02-01 00:42:27.000000', 'temperatura', 353.0000, 'ºC'),
	(186236, 122, '2014-02-01 00:42:28.000000', 'temperatura', 524.0000, 'ºC'),
	(186237, 122, '2014-02-01 00:42:29.000000', 'temperatura', 362.0000, 'ºC'),
	(186238, 122, '2014-02-01 00:42:30.000000', 'temperatura', 238.0000, 'ºC'),
	(186239, 122, '2014-02-01 00:42:31.000000', 'temperatura', 103.0000, 'ºC'),
	(186240, 122, '2014-02-01 00:42:32.000000', 'temperatura', 1003.0000, 'ºC'),
	(186241, 122, '2014-02-01 00:42:33.000000', 'temperatura', 1105.0000, 'ºC'),
	(186242, 122, '2014-02-01 00:42:34.000000', 'temperatura', 117.0000, 'ºC'),
	(186243, 122, '2014-02-01 00:42:35.000000', 'temperatura', 869.0000, 'ºC'),
	(186244, 122, '2014-02-01 00:42:36.000000', 'temperatura', 397.0000, 'ºC'),
	(186245, 122, '2014-02-01 00:42:37.000000', 'temperatura', 577.0000, 'ºC'),
	(186246, 122, '2014-02-01 00:42:38.000000', 'temperatura', 495.0000, 'ºC'),
	(186247, 122, '2014-02-01 00:42:39.000000', 'temperatura', 743.0000, 'ºC'),
	(186248, 122, '2014-02-01 00:42:40.000000', 'temperatura', 1031.0000, 'ºC'),
	(186249, 122, '2014-02-01 00:42:41.000000', 'temperatura', 526.0000, 'ºC'),
	(186250, 122, '2014-02-01 00:42:42.000000', 'temperatura', 740.0000, 'ºC'),
	(186251, 122, '2014-02-01 00:42:43.000000', 'temperatura', 922.0000, 'ºC'),
	(186252, 122, '2014-02-01 00:42:44.000000', 'temperatura', 1188.0000, 'ºC'),
	(186253, 122, '2014-02-01 00:42:45.000000', 'temperatura', 777.0000, 'ºC'),
	(186254, 122, '2014-02-01 00:42:46.000000', 'temperatura', 322.0000, 'ºC'),
	(186255, 122, '2014-02-01 00:42:47.000000', 'temperatura', 478.0000, 'ºC'),
	(186256, 122, '2014-02-01 00:42:48.000000', 'temperatura', 226.0000, 'ºC'),
	(186257, 122, '2014-02-01 00:42:49.000000', 'temperatura', 897.0000, 'ºC'),
	(186258, 122, '2014-02-01 00:42:50.000000', 'temperatura', 208.0000, 'ºC'),
	(186259, 122, '2014-02-01 00:42:51.000000', 'temperatura', 747.0000, 'ºC'),
	(186260, 122, '2014-02-01 00:42:52.000000', 'temperatura', 711.0000, 'ºC'),
	(186261, 122, '2014-02-01 00:42:53.000000', 'temperatura', 117.0000, 'ºC'),
	(186262, 122, '2014-02-01 00:42:54.000000', 'temperatura', 850.0000, 'ºC'),
	(186263, 122, '2014-02-01 00:42:55.000000', 'temperatura', 302.0000, 'ºC'),
	(186264, 122, '2014-02-01 00:42:56.000000', 'temperatura', 158.0000, 'ºC'),
	(186265, 122, '2014-02-01 00:42:57.000000', 'temperatura', 1086.0000, 'ºC'),
	(186266, 122, '2014-02-01 00:42:58.000000', 'temperatura', 156.0000, 'ºC'),
	(186267, 122, '2014-02-01 00:42:59.000000', 'temperatura', 1122.0000, 'ºC'),
	(186268, 122, '2014-02-01 00:43:00.000000', 'temperatura', 345.0000, 'ºC'),
	(186269, 122, '2014-02-01 00:43:01.000000', 'temperatura', 756.0000, 'ºC'),
	(186270, 122, '2014-02-01 00:43:02.000000', 'temperatura', 349.0000, 'ºC'),
	(186271, 122, '2014-02-01 00:43:03.000000', 'temperatura', 676.0000, 'ºC'),
	(186272, 122, '2014-02-01 00:43:04.000000', 'temperatura', 1134.0000, 'ºC'),
	(186273, 122, '2014-02-01 00:43:05.000000', 'temperatura', 41.0000, 'ºC'),
	(186274, 122, '2014-02-01 00:43:06.000000', 'temperatura', 406.0000, 'ºC'),
	(186275, 122, '2014-02-01 00:43:07.000000', 'temperatura', 708.0000, 'ºC'),
	(186276, 122, '2014-02-01 00:43:08.000000', 'temperatura', 1122.0000, 'ºC'),
	(186277, 122, '2014-02-01 00:43:09.000000', 'temperatura', 1084.0000, 'ºC'),
	(186278, 122, '2014-02-01 00:43:10.000000', 'temperatura', 856.0000, 'ºC'),
	(186279, 122, '2014-02-01 00:43:11.000000', 'temperatura', 1027.0000, 'ºC'),
	(186280, 122, '2014-02-01 00:43:12.000000', 'temperatura', 167.0000, 'ºC'),
	(186281, 122, '2014-02-01 00:43:13.000000', 'temperatura', 156.0000, 'ºC'),
	(186282, 122, '2014-02-01 00:43:14.000000', 'temperatura', 279.0000, 'ºC'),
	(186283, 122, '2014-02-01 00:43:15.000000', 'temperatura', 927.0000, 'ºC'),
	(186284, 122, '2014-02-01 00:43:16.000000', 'temperatura', 199.0000, 'ºC'),
	(186285, 122, '2014-02-01 00:43:17.000000', 'temperatura', 615.0000, 'ºC'),
	(186286, 122, '2014-02-01 00:43:18.000000', 'temperatura', 78.0000, 'ºC'),
	(186287, 122, '2014-02-01 00:43:19.000000', 'temperatura', 944.0000, 'ºC'),
	(186288, 122, '2014-02-01 00:43:20.000000', 'temperatura', 886.0000, 'ºC'),
	(186289, 122, '2014-02-01 00:43:21.000000', 'temperatura', 400.0000, 'ºC'),
	(186290, 122, '2014-02-01 00:43:22.000000', 'temperatura', 542.0000, 'ºC'),
	(186291, 122, '2014-02-01 00:43:23.000000', 'temperatura', 311.0000, 'ºC'),
	(186292, 122, '2014-02-01 00:43:24.000000', 'temperatura', 1131.0000, 'ºC'),
	(186293, 122, '2014-02-01 00:43:25.000000', 'temperatura', 1122.0000, 'ºC'),
	(186294, 122, '2014-02-01 00:43:26.000000', 'temperatura', 1015.0000, 'ºC'),
	(186295, 122, '2014-02-01 00:43:27.000000', 'temperatura', 513.0000, 'ºC'),
	(186296, 122, '2014-02-01 00:43:28.000000', 'temperatura', 717.0000, 'ºC'),
	(186297, 122, '2014-02-01 00:43:29.000000', 'temperatura', 850.0000, 'ºC'),
	(186298, 122, '2014-02-01 00:43:30.000000', 'temperatura', 897.0000, 'ºC'),
	(186299, 122, '2014-02-01 00:43:31.000000', 'temperatura', 738.0000, 'ºC'),
	(186300, 122, '2014-02-01 00:43:32.000000', 'temperatura', 999.0000, 'ºC'),
	(186301, 122, '2014-02-01 00:43:33.000000', 'temperatura', 381.0000, 'ºC'),
	(186302, 122, '2014-02-01 00:43:34.000000', 'temperatura', 107.0000, 'ºC'),
	(186303, 122, '2014-02-01 00:43:35.000000', 'temperatura', 592.0000, 'ºC'),
	(186304, 122, '2014-02-01 00:43:36.000000', 'temperatura', 242.0000, 'ºC'),
	(186305, 122, '2014-02-01 00:43:37.000000', 'temperatura', 633.0000, 'ºC'),
	(186306, 122, '2014-02-01 00:43:38.000000', 'temperatura', 40.0000, 'ºC'),
	(186307, 122, '2014-02-01 00:43:39.000000', 'temperatura', 703.0000, 'ºC'),
	(186308, 122, '2014-02-01 00:43:40.000000', 'temperatura', 994.0000, 'ºC'),
	(186309, 122, '2014-02-01 00:43:41.000000', 'temperatura', 462.0000, 'ºC'),
	(186310, 122, '2014-02-01 00:43:42.000000', 'temperatura', 530.0000, 'ºC'),
	(186311, 122, '2014-02-01 00:43:43.000000', 'temperatura', 63.0000, 'ºC'),
	(186312, 122, '2014-02-01 00:43:44.000000', 'temperatura', 1126.0000, 'ºC'),
	(186313, 122, '2014-02-01 00:43:45.000000', 'temperatura', 641.0000, 'ºC'),
	(186314, 122, '2014-02-01 00:43:46.000000', 'temperatura', 1029.0000, 'ºC'),
	(186315, 122, '2014-02-01 00:43:47.000000', 'temperatura', 820.0000, 'ºC'),
	(186316, 122, '2014-02-01 00:43:48.000000', 'temperatura', 1014.0000, 'ºC'),
	(186317, 122, '2014-02-01 00:43:49.000000', 'temperatura', 210.0000, 'ºC'),
	(186318, 122, '2014-02-01 00:43:50.000000', 'temperatura', 409.0000, 'ºC'),
	(186319, 122, '2014-02-01 00:43:51.000000', 'temperatura', 215.0000, 'ºC'),
	(186320, 122, '2014-02-01 00:43:52.000000', 'temperatura', 1050.0000, 'ºC'),
	(186321, 122, '2014-02-01 00:43:53.000000', 'temperatura', 1006.0000, 'ºC'),
	(186322, 122, '2014-02-01 00:43:54.000000', 'temperatura', 682.0000, 'ºC'),
	(186323, 122, '2014-02-01 00:43:55.000000', 'temperatura', 389.0000, 'ºC'),
	(186324, 122, '2014-02-01 00:43:56.000000', 'temperatura', 1103.0000, 'ºC'),
	(186325, 122, '2014-02-01 00:43:57.000000', 'temperatura', 746.0000, 'ºC'),
	(186326, 122, '2014-02-01 00:43:58.000000', 'temperatura', 424.0000, 'ºC'),
	(186327, 122, '2014-02-01 00:43:59.000000', 'temperatura', 1082.0000, 'ºC'),
	(186328, 122, '2014-02-01 00:44:00.000000', 'temperatura', 540.0000, 'ºC'),
	(186329, 122, '2014-02-01 00:44:01.000000', 'temperatura', 652.0000, 'ºC'),
	(186330, 122, '2014-02-01 00:44:02.000000', 'temperatura', 442.0000, 'ºC'),
	(186331, 122, '2014-02-01 00:44:03.000000', 'temperatura', 252.0000, 'ºC'),
	(186332, 122, '2014-02-01 00:44:04.000000', 'temperatura', 1137.0000, 'ºC'),
	(186333, 122, '2014-02-01 00:44:05.000000', 'temperatura', 129.0000, 'ºC'),
	(186334, 122, '2014-02-01 00:44:06.000000', 'temperatura', 836.0000, 'ºC'),
	(186335, 122, '2014-02-01 00:44:07.000000', 'temperatura', 192.0000, 'ºC'),
	(186336, 122, '2014-02-01 00:44:08.000000', 'temperatura', 854.0000, 'ºC'),
	(186337, 122, '2014-02-01 00:44:09.000000', 'temperatura', 95.0000, 'ºC'),
	(186338, 122, '2014-02-01 00:44:10.000000', 'temperatura', 312.0000, 'ºC'),
	(186339, 122, '2014-02-01 00:44:11.000000', 'temperatura', 76.0000, 'ºC'),
	(186340, 122, '2014-02-01 00:44:12.000000', 'temperatura', 642.0000, 'ºC'),
	(186341, 122, '2014-02-01 00:44:13.000000', 'temperatura', 586.0000, 'ºC'),
	(186342, 122, '2014-02-01 00:44:14.000000', 'temperatura', 1001.0000, 'ºC'),
	(186343, 122, '2014-02-01 00:44:15.000000', 'temperatura', 851.0000, 'ºC'),
	(186344, 122, '2014-02-01 00:44:16.000000', 'temperatura', 51.0000, 'ºC'),
	(186345, 122, '2014-02-01 00:44:17.000000', 'temperatura', 102.0000, 'ºC'),
	(186346, 122, '2014-02-01 00:44:18.000000', 'temperatura', 357.0000, 'ºC'),
	(186347, 122, '2014-02-01 00:44:19.000000', 'temperatura', 281.0000, 'ºC'),
	(186348, 122, '2014-02-01 00:44:20.000000', 'temperatura', 335.0000, 'ºC'),
	(186349, 122, '2014-02-01 00:44:21.000000', 'temperatura', 830.0000, 'ºC'),
	(186350, 122, '2014-02-01 00:44:22.000000', 'temperatura', 746.0000, 'ºC'),
	(186351, 122, '2014-02-01 00:44:23.000000', 'temperatura', 40.0000, 'ºC'),
	(186352, 122, '2014-02-01 00:44:24.000000', 'temperatura', 363.0000, 'ºC'),
	(186353, 122, '2014-02-01 00:44:25.000000', 'temperatura', 495.0000, 'ºC'),
	(186354, 122, '2014-02-01 00:44:26.000000', 'temperatura', 189.0000, 'ºC'),
	(186355, 122, '2014-02-01 00:44:27.000000', 'temperatura', 659.0000, 'ºC'),
	(186356, 122, '2014-02-01 00:44:28.000000', 'temperatura', 330.0000, 'ºC'),
	(186357, 122, '2014-02-01 00:44:29.000000', 'temperatura', 871.0000, 'ºC'),
	(186358, 122, '2014-02-01 00:44:30.000000', 'temperatura', 966.0000, 'ºC'),
	(186359, 122, '2014-02-01 00:44:31.000000', 'temperatura', 1017.0000, 'ºC'),
	(186360, 122, '2014-02-01 00:44:32.000000', 'temperatura', 990.0000, 'ºC'),
	(186361, 122, '2014-02-01 00:44:33.000000', 'temperatura', 697.0000, 'ºC'),
	(186362, 122, '2014-02-01 00:44:34.000000', 'temperatura', 515.0000, 'ºC'),
	(186363, 122, '2014-02-01 00:44:35.000000', 'temperatura', 487.0000, 'ºC'),
	(186364, 122, '2014-02-01 00:44:36.000000', 'temperatura', 890.0000, 'ºC'),
	(186365, 122, '2014-02-01 00:44:37.000000', 'temperatura', 591.0000, 'ºC'),
	(186366, 122, '2014-02-01 00:44:38.000000', 'temperatura', 284.0000, 'ºC'),
	(186367, 122, '2014-02-01 00:44:39.000000', 'temperatura', 847.0000, 'ºC'),
	(186368, 122, '2014-02-01 00:44:40.000000', 'temperatura', 986.0000, 'ºC'),
	(186369, 122, '2014-02-01 00:44:41.000000', 'temperatura', 1187.0000, 'ºC'),
	(186370, 122, '2014-02-01 00:44:42.000000', 'temperatura', 579.0000, 'ºC'),
	(186371, 122, '2014-02-01 00:44:43.000000', 'temperatura', 532.0000, 'ºC'),
	(186372, 122, '2014-02-01 00:44:44.000000', 'temperatura', 926.0000, 'ºC'),
	(186373, 122, '2014-02-01 00:44:45.000000', 'temperatura', 634.0000, 'ºC'),
	(186374, 122, '2014-02-01 00:44:46.000000', 'temperatura', 393.0000, 'ºC'),
	(186375, 122, '2014-02-01 00:44:47.000000', 'temperatura', 63.0000, 'ºC'),
	(186376, 122, '2014-02-01 00:44:48.000000', 'temperatura', 338.0000, 'ºC'),
	(186377, 122, '2014-02-01 00:44:49.000000', 'temperatura', 300.0000, 'ºC'),
	(186378, 122, '2014-02-01 00:44:50.000000', 'temperatura', 486.0000, 'ºC'),
	(186379, 122, '2014-02-01 00:44:51.000000', 'temperatura', 330.0000, 'ºC'),
	(186380, 122, '2014-02-01 00:44:52.000000', 'temperatura', 192.0000, 'ºC'),
	(186381, 122, '2014-02-01 00:44:53.000000', 'temperatura', 1171.0000, 'ºC'),
	(186382, 122, '2014-02-01 00:44:54.000000', 'temperatura', 479.0000, 'ºC'),
	(186383, 122, '2014-02-01 00:44:55.000000', 'temperatura', 84.0000, 'ºC'),
	(186384, 122, '2014-02-01 00:44:56.000000', 'temperatura', 184.0000, 'ºC'),
	(186385, 122, '2014-02-01 00:44:57.000000', 'temperatura', 666.0000, 'ºC'),
	(186386, 122, '2014-02-01 00:44:58.000000', 'temperatura', 381.0000, 'ºC'),
	(186387, 122, '2014-02-01 00:44:59.000000', 'temperatura', 1106.0000, 'ºC'),
	(186388, 122, '2014-02-01 00:45:00.000000', 'temperatura', 787.0000, 'ºC'),
	(186389, 122, '2014-02-01 00:45:01.000000', 'temperatura', 618.0000, 'ºC'),
	(186390, 122, '2014-02-01 00:45:02.000000', 'temperatura', 730.0000, 'ºC'),
	(186391, 122, '2014-02-01 00:45:03.000000', 'temperatura', 596.0000, 'ºC'),
	(186392, 122, '2014-02-01 00:45:04.000000', 'temperatura', 789.0000, 'ºC'),
	(186393, 122, '2014-02-01 00:45:05.000000', 'temperatura', 958.0000, 'ºC'),
	(186394, 122, '2014-02-01 00:45:06.000000', 'temperatura', 23.0000, 'ºC'),
	(186395, 122, '2014-02-01 00:45:07.000000', 'temperatura', 844.0000, 'ºC'),
	(186396, 122, '2014-02-01 00:45:08.000000', 'temperatura', 551.0000, 'ºC'),
	(186397, 122, '2014-02-01 00:45:09.000000', 'temperatura', 223.0000, 'ºC'),
	(186398, 122, '2014-02-01 00:45:10.000000', 'temperatura', 661.0000, 'ºC'),
	(186399, 122, '2014-02-01 00:45:11.000000', 'temperatura', 239.0000, 'ºC'),
	(186400, 122, '2014-02-01 00:45:12.000000', 'temperatura', 412.0000, 'ºC'),
	(186401, 122, '2014-02-01 00:45:13.000000', 'temperatura', 143.0000, 'ºC'),
	(186402, 122, '2014-02-01 00:45:14.000000', 'temperatura', 680.0000, 'ºC'),
	(186403, 122, '2014-02-01 00:45:15.000000', 'temperatura', 571.0000, 'ºC'),
	(186404, 122, '2014-02-01 00:45:16.000000', 'temperatura', 816.0000, 'ºC'),
	(186405, 122, '2014-02-01 00:45:17.000000', 'temperatura', 1167.0000, 'ºC'),
	(186406, 122, '2014-02-01 00:45:18.000000', 'temperatura', 986.0000, 'ºC'),
	(186407, 122, '2014-02-01 00:45:19.000000', 'temperatura', 231.0000, 'ºC'),
	(186408, 122, '2014-02-01 00:45:20.000000', 'temperatura', 596.0000, 'ºC'),
	(186409, 122, '2014-02-01 00:45:21.000000', 'temperatura', 1088.0000, 'ºC'),
	(186410, 122, '2014-02-01 00:45:22.000000', 'temperatura', 53.0000, 'ºC'),
	(186411, 122, '2014-02-01 00:45:23.000000', 'temperatura', 603.0000, 'ºC'),
	(186412, 122, '2014-02-01 00:45:24.000000', 'temperatura', 454.0000, 'ºC'),
	(186413, 122, '2014-02-01 00:45:25.000000', 'temperatura', 462.0000, 'ºC'),
	(186414, 122, '2014-02-01 00:45:26.000000', 'temperatura', 950.0000, 'ºC'),
	(186415, 122, '2014-02-01 00:45:27.000000', 'temperatura', 962.0000, 'ºC'),
	(186416, 122, '2014-02-01 00:45:28.000000', 'temperatura', 761.0000, 'ºC'),
	(186417, 122, '2014-02-01 00:45:29.000000', 'temperatura', 922.0000, 'ºC'),
	(186418, 122, '2014-02-01 00:45:30.000000', 'temperatura', 1124.0000, 'ºC'),
	(186419, 122, '2014-02-01 00:45:31.000000', 'temperatura', 456.0000, 'ºC'),
	(186420, 122, '2014-02-01 00:45:32.000000', 'temperatura', 107.0000, 'ºC'),
	(186421, 122, '2014-02-01 00:45:33.000000', 'temperatura', 370.0000, 'ºC'),
	(186422, 122, '2014-02-01 00:45:34.000000', 'temperatura', 328.0000, 'ºC'),
	(186423, 122, '2014-02-01 00:45:35.000000', 'temperatura', 531.0000, 'ºC'),
	(186424, 122, '2014-02-01 00:45:36.000000', 'temperatura', 473.0000, 'ºC'),
	(186425, 122, '2014-02-01 00:45:37.000000', 'temperatura', 771.0000, 'ºC'),
	(186426, 122, '2014-02-01 00:45:38.000000', 'temperatura', 36.0000, 'ºC'),
	(186427, 122, '2014-02-01 00:45:39.000000', 'temperatura', 268.0000, 'ºC'),
	(186428, 122, '2014-02-01 00:45:40.000000', 'temperatura', 32.0000, 'ºC'),
	(186429, 122, '2014-02-01 00:45:41.000000', 'temperatura', 556.0000, 'ºC'),
	(186430, 122, '2014-02-01 00:45:42.000000', 'temperatura', 284.0000, 'ºC'),
	(186431, 122, '2014-02-01 00:45:43.000000', 'temperatura', 953.0000, 'ºC'),
	(186432, 122, '2014-02-01 00:45:44.000000', 'temperatura', 313.0000, 'ºC'),
	(186433, 122, '2014-02-01 00:45:45.000000', 'temperatura', 1106.0000, 'ºC'),
	(186434, 122, '2014-02-01 00:45:46.000000', 'temperatura', 991.0000, 'ºC'),
	(186435, 122, '2014-02-01 00:45:47.000000', 'temperatura', 438.0000, 'ºC'),
	(186436, 122, '2014-02-01 00:45:48.000000', 'temperatura', 417.0000, 'ºC'),
	(186437, 122, '2014-02-01 00:45:49.000000', 'temperatura', 772.0000, 'ºC'),
	(186438, 122, '2014-02-01 00:45:50.000000', 'temperatura', 210.0000, 'ºC'),
	(186439, 122, '2014-02-01 00:45:51.000000', 'temperatura', 1134.0000, 'ºC'),
	(186440, 122, '2014-02-01 00:45:52.000000', 'temperatura', 239.0000, 'ºC'),
	(186441, 122, '2014-02-01 00:45:53.000000', 'temperatura', 197.0000, 'ºC'),
	(186442, 122, '2014-02-01 00:45:54.000000', 'temperatura', 265.0000, 'ºC'),
	(186443, 122, '2014-02-01 00:45:55.000000', 'temperatura', 735.0000, 'ºC'),
	(186444, 122, '2014-02-01 00:45:56.000000', 'temperatura', 481.0000, 'ºC'),
	(186445, 122, '2014-02-01 00:45:57.000000', 'temperatura', 199.0000, 'ºC'),
	(186446, 122, '2014-02-01 00:45:58.000000', 'temperatura', 753.0000, 'ºC'),
	(186447, 122, '2014-02-01 00:45:59.000000', 'temperatura', 768.0000, 'ºC'),
	(186448, 122, '2014-02-01 00:46:00.000000', 'temperatura', 383.0000, 'ºC'),
	(186449, 122, '2014-02-01 00:46:01.000000', 'temperatura', 811.0000, 'ºC'),
	(186450, 122, '2014-02-01 00:46:02.000000', 'temperatura', 505.0000, 'ºC'),
	(186451, 122, '2014-02-01 00:46:03.000000', 'temperatura', 95.0000, 'ºC'),
	(186452, 122, '2014-02-01 00:46:04.000000', 'temperatura', 161.0000, 'ºC'),
	(186453, 122, '2014-02-01 00:46:05.000000', 'temperatura', 518.0000, 'ºC'),
	(186454, 122, '2014-02-01 00:46:06.000000', 'temperatura', 910.0000, 'ºC'),
	(186455, 122, '2014-02-01 00:46:07.000000', 'temperatura', 594.0000, 'ºC'),
	(186456, 122, '2014-02-01 00:46:08.000000', 'temperatura', 241.0000, 'ºC'),
	(186457, 122, '2014-02-01 00:46:09.000000', 'temperatura', 624.0000, 'ºC'),
	(186458, 122, '2014-02-01 00:46:10.000000', 'temperatura', 1197.0000, 'ºC'),
	(186459, 122, '2014-02-01 00:46:11.000000', 'temperatura', 514.0000, 'ºC'),
	(186460, 122, '2014-02-01 00:46:12.000000', 'temperatura', 180.0000, 'ºC'),
	(186461, 122, '2014-02-01 00:46:13.000000', 'temperatura', 559.0000, 'ºC'),
	(186462, 122, '2014-02-01 00:46:14.000000', 'temperatura', 1054.0000, 'ºC'),
	(186463, 122, '2014-02-01 00:46:15.000000', 'temperatura', 1194.0000, 'ºC'),
	(186464, 122, '2014-02-01 00:46:16.000000', 'temperatura', 409.0000, 'ºC'),
	(186465, 122, '2014-02-01 00:46:17.000000', 'temperatura', 865.0000, 'ºC'),
	(186466, 122, '2014-02-01 00:46:18.000000', 'temperatura', 696.0000, 'ºC'),
	(186467, 122, '2014-02-01 00:46:19.000000', 'temperatura', 887.0000, 'ºC'),
	(186468, 122, '2014-02-01 00:46:20.000000', 'temperatura', 1148.0000, 'ºC'),
	(186469, 122, '2014-02-01 00:46:21.000000', 'temperatura', 680.0000, 'ºC'),
	(186470, 122, '2014-02-01 00:46:22.000000', 'temperatura', 1157.0000, 'ºC'),
	(186471, 122, '2014-02-01 00:46:23.000000', 'temperatura', 145.0000, 'ºC'),
	(186472, 122, '2014-02-01 00:46:24.000000', 'temperatura', 853.0000, 'ºC'),
	(186473, 122, '2014-02-01 00:46:25.000000', 'temperatura', 230.0000, 'ºC'),
	(186474, 122, '2014-02-01 00:46:26.000000', 'temperatura', 993.0000, 'ºC'),
	(186475, 122, '2014-02-01 00:46:27.000000', 'temperatura', 675.0000, 'ºC'),
	(186476, 122, '2014-02-01 00:46:28.000000', 'temperatura', 398.0000, 'ºC'),
	(186477, 122, '2014-02-01 00:46:29.000000', 'temperatura', 1165.0000, 'ºC'),
	(186478, 122, '2014-02-01 00:46:30.000000', 'temperatura', 1032.0000, 'ºC'),
	(186479, 122, '2014-02-01 00:46:31.000000', 'temperatura', 466.0000, 'ºC'),
	(186480, 122, '2014-02-01 00:46:32.000000', 'temperatura', 433.0000, 'ºC'),
	(186481, 122, '2014-02-01 00:46:33.000000', 'temperatura', 766.0000, 'ºC'),
	(186482, 122, '2014-02-01 00:46:34.000000', 'temperatura', 135.0000, 'ºC'),
	(186483, 122, '2014-02-01 00:46:35.000000', 'temperatura', 776.0000, 'ºC'),
	(186484, 122, '2014-02-01 00:46:36.000000', 'temperatura', 1076.0000, 'ºC'),
	(186485, 122, '2014-02-01 00:46:37.000000', 'temperatura', 651.0000, 'ºC'),
	(186486, 122, '2014-02-01 00:46:38.000000', 'temperatura', 27.0000, 'ºC'),
	(186487, 122, '2014-02-01 00:46:39.000000', 'temperatura', 582.0000, 'ºC'),
	(186488, 122, '2014-02-01 00:46:40.000000', 'temperatura', 431.0000, 'ºC'),
	(186489, 122, '2014-02-01 00:46:41.000000', 'temperatura', 407.0000, 'ºC'),
	(186490, 122, '2014-02-01 00:46:42.000000', 'temperatura', 745.0000, 'ºC'),
	(186491, 122, '2014-02-01 00:46:43.000000', 'temperatura', 103.0000, 'ºC'),
	(186492, 122, '2014-02-01 00:46:44.000000', 'temperatura', 681.0000, 'ºC'),
	(186493, 122, '2014-02-01 00:46:45.000000', 'temperatura', 698.0000, 'ºC'),
	(186494, 122, '2014-02-01 00:46:46.000000', 'temperatura', 248.0000, 'ºC'),
	(186495, 122, '2014-02-01 00:46:47.000000', 'temperatura', 348.0000, 'ºC'),
	(186496, 122, '2014-02-01 00:46:48.000000', 'temperatura', 993.0000, 'ºC'),
	(186497, 122, '2014-02-01 00:46:49.000000', 'temperatura', 321.0000, 'ºC'),
	(186498, 122, '2014-02-01 00:46:50.000000', 'temperatura', 1027.0000, 'ºC'),
	(186499, 122, '2014-02-01 00:46:51.000000', 'temperatura', 573.0000, 'ºC'),
	(186500, 122, '2014-02-01 00:46:52.000000', 'temperatura', 986.0000, 'ºC'),
	(186501, 122, '2014-02-01 00:46:53.000000', 'temperatura', 810.0000, 'ºC'),
	(186502, 122, '2014-02-01 00:46:54.000000', 'temperatura', 1095.0000, 'ºC'),
	(186503, 122, '2014-02-01 00:46:55.000000', 'temperatura', 642.0000, 'ºC'),
	(186504, 122, '2014-02-01 00:46:56.000000', 'temperatura', 1128.0000, 'ºC'),
	(186505, 122, '2014-02-01 00:46:57.000000', 'temperatura', 112.0000, 'ºC'),
	(186506, 122, '2014-02-01 00:46:58.000000', 'temperatura', 777.0000, 'ºC'),
	(186507, 122, '2014-02-01 00:46:59.000000', 'temperatura', 1150.0000, 'ºC'),
	(186508, 122, '2014-02-01 00:47:00.000000', 'temperatura', 1018.0000, 'ºC'),
	(186509, 122, '2014-02-01 00:47:01.000000', 'temperatura', 440.0000, 'ºC'),
	(186510, 122, '2014-02-01 00:47:02.000000', 'temperatura', 348.0000, 'ºC'),
	(186511, 122, '2014-02-01 00:47:03.000000', 'temperatura', 420.0000, 'ºC'),
	(186512, 122, '2014-02-01 00:47:04.000000', 'temperatura', 1057.0000, 'ºC'),
	(186513, 122, '2014-02-01 00:47:05.000000', 'temperatura', 424.0000, 'ºC'),
	(186514, 122, '2014-02-01 00:47:06.000000', 'temperatura', 150.0000, 'ºC'),
	(186515, 122, '2014-02-01 00:47:07.000000', 'temperatura', 679.0000, 'ºC'),
	(186516, 122, '2014-02-01 00:47:08.000000', 'temperatura', 546.0000, 'ºC'),
	(186517, 122, '2014-02-01 00:47:09.000000', 'temperatura', 694.0000, 'ºC'),
	(186518, 122, '2014-02-01 00:47:10.000000', 'temperatura', 633.0000, 'ºC'),
	(186519, 122, '2014-02-01 00:47:11.000000', 'temperatura', 1082.0000, 'ºC'),
	(186520, 122, '2014-02-01 00:47:12.000000', 'temperatura', 1114.0000, 'ºC'),
	(186521, 122, '2014-02-01 00:47:13.000000', 'temperatura', 1121.0000, 'ºC'),
	(186522, 122, '2014-02-01 00:47:14.000000', 'temperatura', 1066.0000, 'ºC'),
	(186523, 122, '2014-02-01 00:47:15.000000', 'temperatura', 768.0000, 'ºC'),
	(186524, 122, '2014-02-01 00:47:16.000000', 'temperatura', 641.0000, 'ºC'),
	(186525, 122, '2014-02-01 00:47:17.000000', 'temperatura', 903.0000, 'ºC'),
	(186526, 122, '2014-02-01 00:47:18.000000', 'temperatura', 192.0000, 'ºC'),
	(186527, 122, '2014-02-01 00:47:19.000000', 'temperatura', 652.0000, 'ºC'),
	(186528, 122, '2014-02-01 00:47:20.000000', 'temperatura', 286.0000, 'ºC'),
	(186529, 122, '2014-02-01 00:47:21.000000', 'temperatura', 671.0000, 'ºC'),
	(186530, 122, '2014-02-01 00:47:22.000000', 'temperatura', 100.0000, 'ºC'),
	(186531, 122, '2014-02-01 00:47:23.000000', 'temperatura', 886.0000, 'ºC'),
	(186532, 122, '2014-02-01 00:47:24.000000', 'temperatura', 532.0000, 'ºC'),
	(186533, 122, '2014-02-01 00:47:25.000000', 'temperatura', 2.0000, 'ºC'),
	(186534, 122, '2014-02-01 00:47:26.000000', 'temperatura', 815.0000, 'ºC'),
	(186535, 122, '2014-02-01 00:47:27.000000', 'temperatura', 467.0000, 'ºC'),
	(186536, 122, '2014-02-01 00:47:28.000000', 'temperatura', 1093.0000, 'ºC'),
	(186537, 122, '2014-02-01 00:47:29.000000', 'temperatura', 462.0000, 'ºC'),
	(186538, 122, '2014-02-01 00:47:30.000000', 'temperatura', 232.0000, 'ºC'),
	(186539, 122, '2014-02-01 00:47:31.000000', 'temperatura', 977.0000, 'ºC'),
	(186540, 122, '2014-02-01 00:47:32.000000', 'temperatura', 587.0000, 'ºC'),
	(186541, 122, '2014-02-01 00:47:33.000000', 'temperatura', 5.0000, 'ºC'),
	(186542, 122, '2014-02-01 00:47:34.000000', 'temperatura', 665.0000, 'ºC'),
	(186543, 122, '2014-02-01 00:47:35.000000', 'temperatura', 912.0000, 'ºC'),
	(186544, 122, '2014-02-01 00:47:36.000000', 'temperatura', 166.0000, 'ºC'),
	(186545, 122, '2014-02-01 00:47:37.000000', 'temperatura', 493.0000, 'ºC'),
	(186546, 122, '2014-02-01 00:47:38.000000', 'temperatura', 768.0000, 'ºC'),
	(186547, 122, '2014-02-01 00:47:39.000000', 'temperatura', 1161.0000, 'ºC'),
	(186548, 122, '2014-02-01 00:47:40.000000', 'temperatura', 1104.0000, 'ºC'),
	(186549, 122, '2014-02-01 00:47:41.000000', 'temperatura', 834.0000, 'ºC'),
	(186550, 122, '2014-02-01 00:47:42.000000', 'temperatura', 859.0000, 'ºC'),
	(186551, 122, '2014-02-01 00:47:43.000000', 'temperatura', 596.0000, 'ºC'),
	(186552, 122, '2014-02-01 00:47:44.000000', 'temperatura', 401.0000, 'ºC'),
	(186553, 122, '2014-02-01 00:47:45.000000', 'temperatura', 217.0000, 'ºC'),
	(186554, 122, '2014-02-01 00:47:46.000000', 'temperatura', 1083.0000, 'ºC'),
	(186555, 122, '2014-02-01 00:47:47.000000', 'temperatura', 1166.0000, 'ºC'),
	(186556, 122, '2014-02-01 00:47:48.000000', 'temperatura', 181.0000, 'ºC'),
	(186557, 122, '2014-02-01 00:47:49.000000', 'temperatura', 1007.0000, 'ºC'),
	(186558, 122, '2014-02-01 00:47:50.000000', 'temperatura', 893.0000, 'ºC'),
	(186559, 122, '2014-02-01 00:47:51.000000', 'temperatura', 243.0000, 'ºC'),
	(186560, 122, '2014-02-01 00:47:52.000000', 'temperatura', 937.0000, 'ºC'),
	(186561, 122, '2014-02-01 00:47:53.000000', 'temperatura', 355.0000, 'ºC'),
	(186562, 122, '2014-02-01 00:47:54.000000', 'temperatura', 165.0000, 'ºC'),
	(186563, 122, '2014-02-01 00:47:55.000000', 'temperatura', 963.0000, 'ºC'),
	(186564, 122, '2014-02-01 00:47:56.000000', 'temperatura', 719.0000, 'ºC'),
	(186565, 122, '2014-02-01 00:47:57.000000', 'temperatura', 705.0000, 'ºC'),
	(186566, 122, '2014-02-01 00:47:58.000000', 'temperatura', 168.0000, 'ºC'),
	(186567, 122, '2014-02-01 00:47:59.000000', 'temperatura', 1128.0000, 'ºC'),
	(186568, 122, '2014-02-01 00:48:00.000000', 'temperatura', 336.0000, 'ºC'),
	(186569, 122, '2014-02-01 00:48:01.000000', 'temperatura', 694.0000, 'ºC'),
	(186570, 122, '2014-02-01 00:48:02.000000', 'temperatura', 65.0000, 'ºC'),
	(186571, 122, '2014-02-01 00:48:03.000000', 'temperatura', 641.0000, 'ºC'),
	(186572, 122, '2014-02-01 00:48:04.000000', 'temperatura', 614.0000, 'ºC'),
	(186573, 122, '2014-02-01 00:48:05.000000', 'temperatura', 1145.0000, 'ºC'),
	(186574, 122, '2014-02-01 00:48:06.000000', 'temperatura', 286.0000, 'ºC'),
	(186575, 122, '2014-02-01 00:48:07.000000', 'temperatura', 393.0000, 'ºC'),
	(186576, 122, '2014-02-01 00:48:08.000000', 'temperatura', 1110.0000, 'ºC'),
	(186577, 122, '2014-02-01 00:48:09.000000', 'temperatura', 769.0000, 'ºC'),
	(186578, 122, '2014-02-01 00:48:10.000000', 'temperatura', 518.0000, 'ºC'),
	(186579, 122, '2014-02-01 00:48:11.000000', 'temperatura', 284.0000, 'ºC'),
	(186580, 122, '2014-02-01 00:48:12.000000', 'temperatura', 1065.0000, 'ºC'),
	(186581, 122, '2014-02-01 00:48:13.000000', 'temperatura', 872.0000, 'ºC'),
	(186582, 122, '2014-02-01 00:48:14.000000', 'temperatura', 1166.0000, 'ºC'),
	(186583, 122, '2014-02-01 00:48:15.000000', 'temperatura', 813.0000, 'ºC'),
	(186584, 122, '2014-02-01 00:48:16.000000', 'temperatura', 568.0000, 'ºC'),
	(186585, 122, '2014-02-01 00:48:17.000000', 'temperatura', 404.0000, 'ºC'),
	(186586, 122, '2014-02-01 00:48:18.000000', 'temperatura', 314.0000, 'ºC'),
	(186587, 122, '2014-02-01 00:48:19.000000', 'temperatura', 359.0000, 'ºC'),
	(186588, 122, '2014-02-01 00:48:20.000000', 'temperatura', 854.0000, 'ºC'),
	(186589, 122, '2014-02-01 00:48:21.000000', 'temperatura', 792.0000, 'ºC'),
	(186590, 122, '2014-02-01 00:48:22.000000', 'temperatura', 200.0000, 'ºC'),
	(186591, 122, '2014-02-01 00:48:23.000000', 'temperatura', 1024.0000, 'ºC'),
	(186592, 122, '2014-02-01 00:48:24.000000', 'temperatura', 922.0000, 'ºC'),
	(186593, 122, '2014-02-01 00:48:25.000000', 'temperatura', 337.0000, 'ºC'),
	(186594, 122, '2014-02-01 00:48:26.000000', 'temperatura', 121.0000, 'ºC'),
	(186595, 122, '2014-02-01 00:48:27.000000', 'temperatura', 793.0000, 'ºC'),
	(186596, 122, '2014-02-01 00:48:28.000000', 'temperatura', 3.0000, 'ºC'),
	(186597, 122, '2014-02-01 00:48:29.000000', 'temperatura', 36.0000, 'ºC'),
	(186598, 122, '2014-02-01 00:48:30.000000', 'temperatura', 171.0000, 'ºC'),
	(186599, 122, '2014-02-01 00:48:31.000000', 'temperatura', 750.0000, 'ºC'),
	(186600, 122, '2014-02-01 00:48:32.000000', 'temperatura', 835.0000, 'ºC'),
	(186601, 122, '2014-02-01 00:48:33.000000', 'temperatura', 726.0000, 'ºC'),
	(186602, 122, '2014-02-01 00:48:34.000000', 'temperatura', 1128.0000, 'ºC'),
	(186603, 122, '2014-02-01 00:48:35.000000', 'temperatura', 1059.0000, 'ºC'),
	(186604, 122, '2014-02-01 00:48:36.000000', 'temperatura', 714.0000, 'ºC'),
	(186605, 122, '2014-02-01 00:48:37.000000', 'temperatura', 394.0000, 'ºC'),
	(186606, 122, '2014-02-01 00:48:38.000000', 'temperatura', 1027.0000, 'ºC'),
	(186607, 122, '2014-02-01 00:48:39.000000', 'temperatura', 356.0000, 'ºC'),
	(186608, 122, '2014-02-01 00:48:40.000000', 'temperatura', 1098.0000, 'ºC'),
	(186609, 122, '2014-02-01 00:48:41.000000', 'temperatura', 822.0000, 'ºC'),
	(186610, 122, '2014-02-01 00:48:42.000000', 'temperatura', 816.0000, 'ºC'),
	(186611, 122, '2014-02-01 00:48:43.000000', 'temperatura', 417.0000, 'ºC'),
	(186612, 122, '2014-02-01 00:48:44.000000', 'temperatura', 836.0000, 'ºC'),
	(186613, 122, '2014-02-01 00:48:45.000000', 'temperatura', 528.0000, 'ºC'),
	(186614, 122, '2014-02-01 00:48:46.000000', 'temperatura', 135.0000, 'ºC'),
	(186615, 122, '2014-02-01 00:48:47.000000', 'temperatura', 289.0000, 'ºC'),
	(186616, 122, '2014-02-01 00:48:48.000000', 'temperatura', 1040.0000, 'ºC'),
	(186617, 122, '2014-02-01 00:48:49.000000', 'temperatura', 737.0000, 'ºC'),
	(186618, 122, '2014-02-01 00:48:50.000000', 'temperatura', 562.0000, 'ºC'),
	(186619, 122, '2014-02-01 00:48:51.000000', 'temperatura', 601.0000, 'ºC'),
	(186620, 122, '2014-02-01 00:48:52.000000', 'temperatura', 120.0000, 'ºC'),
	(186621, 122, '2014-02-01 00:48:53.000000', 'temperatura', 1196.0000, 'ºC'),
	(186622, 122, '2014-02-01 00:48:54.000000', 'temperatura', 821.0000, 'ºC'),
	(186623, 122, '2014-02-01 00:48:55.000000', 'temperatura', 518.0000, 'ºC'),
	(186624, 122, '2014-02-01 00:48:56.000000', 'temperatura', 126.0000, 'ºC'),
	(186625, 122, '2014-02-01 00:48:57.000000', 'temperatura', 278.0000, 'ºC'),
	(186626, 122, '2014-02-01 00:48:58.000000', 'temperatura', 1011.0000, 'ºC'),
	(186627, 122, '2014-02-01 00:48:59.000000', 'temperatura', 621.0000, 'ºC'),
	(186628, 122, '2014-02-01 00:49:00.000000', 'temperatura', 73.0000, 'ºC'),
	(186629, 122, '2014-02-01 00:49:01.000000', 'temperatura', 903.0000, 'ºC'),
	(186630, 122, '2014-02-01 00:49:02.000000', 'temperatura', 696.0000, 'ºC'),
	(186631, 122, '2014-02-01 00:49:03.000000', 'temperatura', 770.0000, 'ºC'),
	(186632, 122, '2014-02-01 00:49:04.000000', 'temperatura', 565.0000, 'ºC'),
	(186633, 122, '2014-02-01 00:49:05.000000', 'temperatura', 513.0000, 'ºC'),
	(186634, 122, '2014-02-01 00:49:06.000000', 'temperatura', 872.0000, 'ºC'),
	(186635, 122, '2014-02-01 00:49:07.000000', 'temperatura', 422.0000, 'ºC'),
	(186636, 122, '2014-02-01 00:49:08.000000', 'temperatura', 696.0000, 'ºC'),
	(186637, 122, '2014-02-01 00:49:09.000000', 'temperatura', 1012.0000, 'ºC'),
	(186638, 122, '2014-02-01 00:49:10.000000', 'temperatura', 573.0000, 'ºC'),
	(186639, 122, '2014-02-01 00:49:11.000000', 'temperatura', 1030.0000, 'ºC'),
	(186640, 122, '2014-02-01 00:49:12.000000', 'temperatura', 1031.0000, 'ºC'),
	(186641, 122, '2014-02-01 00:49:13.000000', 'temperatura', 865.0000, 'ºC'),
	(186642, 122, '2014-02-01 00:49:14.000000', 'temperatura', 34.0000, 'ºC'),
	(186643, 122, '2014-02-01 00:49:15.000000', 'temperatura', 1176.0000, 'ºC'),
	(186644, 122, '2014-02-01 00:49:16.000000', 'temperatura', 976.0000, 'ºC'),
	(186645, 122, '2014-02-01 00:49:17.000000', 'temperatura', 155.0000, 'ºC'),
	(186646, 122, '2014-02-01 00:49:18.000000', 'temperatura', 249.0000, 'ºC'),
	(186647, 122, '2014-02-01 00:49:19.000000', 'temperatura', 777.0000, 'ºC'),
	(186648, 122, '2014-02-01 00:49:20.000000', 'temperatura', 740.0000, 'ºC'),
	(186649, 122, '2014-02-01 00:49:21.000000', 'temperatura', 169.0000, 'ºC'),
	(186650, 122, '2014-02-01 00:49:22.000000', 'temperatura', 1027.0000, 'ºC'),
	(186651, 122, '2014-02-01 00:49:23.000000', 'temperatura', 1027.0000, 'ºC'),
	(186652, 122, '2014-02-01 00:49:24.000000', 'temperatura', 855.0000, 'ºC'),
	(186653, 122, '2014-02-01 00:49:25.000000', 'temperatura', 1194.0000, 'ºC'),
	(186654, 122, '2014-02-01 00:49:26.000000', 'temperatura', 1006.0000, 'ºC'),
	(186655, 122, '2014-02-01 00:49:27.000000', 'temperatura', 249.0000, 'ºC'),
	(186656, 122, '2014-02-01 00:49:28.000000', 'temperatura', 627.0000, 'ºC'),
	(186657, 122, '2014-02-01 00:49:29.000000', 'temperatura', 1188.0000, 'ºC'),
	(186658, 122, '2014-02-01 00:49:30.000000', 'temperatura', 458.0000, 'ºC'),
	(186659, 122, '2014-02-01 00:49:31.000000', 'temperatura', 1128.0000, 'ºC'),
	(186660, 122, '2014-02-01 00:49:32.000000', 'temperatura', 667.0000, 'ºC'),
	(186661, 122, '2014-02-01 00:49:33.000000', 'temperatura', 1150.0000, 'ºC'),
	(186662, 122, '2014-02-01 00:49:34.000000', 'temperatura', 151.0000, 'ºC'),
	(186663, 122, '2014-02-01 00:49:35.000000', 'temperatura', 905.0000, 'ºC'),
	(186664, 122, '2014-02-01 00:49:36.000000', 'temperatura', 472.0000, 'ºC'),
	(186665, 122, '2014-02-01 00:49:37.000000', 'temperatura', 845.0000, 'ºC'),
	(186666, 122, '2014-02-01 00:49:38.000000', 'temperatura', 408.0000, 'ºC'),
	(186667, 122, '2014-02-01 00:49:39.000000', 'temperatura', 709.0000, 'ºC'),
	(186668, 122, '2014-02-01 00:49:40.000000', 'temperatura', 1118.0000, 'ºC'),
	(186669, 122, '2014-02-01 00:49:41.000000', 'temperatura', 1066.0000, 'ºC'),
	(186670, 122, '2014-02-01 00:49:42.000000', 'temperatura', 775.0000, 'ºC'),
	(186671, 122, '2014-02-01 00:49:43.000000', 'temperatura', 676.0000, 'ºC'),
	(186672, 122, '2014-02-01 00:49:44.000000', 'temperatura', 1059.0000, 'ºC'),
	(186673, 122, '2014-02-01 00:49:45.000000', 'temperatura', 865.0000, 'ºC'),
	(186674, 122, '2014-02-01 00:49:46.000000', 'temperatura', 1149.0000, 'ºC'),
	(186675, 122, '2014-02-01 00:49:47.000000', 'temperatura', 749.0000, 'ºC'),
	(186676, 122, '2014-02-01 00:49:48.000000', 'temperatura', 298.0000, 'ºC'),
	(186677, 122, '2014-02-01 00:49:49.000000', 'temperatura', 444.0000, 'ºC'),
	(186678, 122, '2014-02-01 00:49:50.000000', 'temperatura', 127.0000, 'ºC'),
	(186679, 122, '2014-02-01 00:49:51.000000', 'temperatura', 502.0000, 'ºC'),
	(186680, 122, '2014-02-01 00:49:52.000000', 'temperatura', 932.0000, 'ºC'),
	(186681, 122, '2014-02-01 00:49:53.000000', 'temperatura', 754.0000, 'ºC'),
	(186682, 122, '2014-02-01 00:49:54.000000', 'temperatura', 976.0000, 'ºC'),
	(186683, 122, '2014-02-01 00:49:55.000000', 'temperatura', 217.0000, 'ºC'),
	(186684, 122, '2014-02-01 00:49:56.000000', 'temperatura', 557.0000, 'ºC'),
	(186685, 122, '2014-02-01 00:49:57.000000', 'temperatura', 935.0000, 'ºC'),
	(186686, 122, '2014-02-01 00:49:58.000000', 'temperatura', 604.0000, 'ºC'),
	(186687, 122, '2014-02-01 00:49:59.000000', 'temperatura', 218.0000, 'ºC'),
	(186688, 122, '2014-02-01 00:50:00.000000', 'temperatura', 475.0000, 'ºC'),
	(186689, 122, '2014-02-01 00:50:01.000000', 'temperatura', 522.0000, 'ºC'),
	(186690, 122, '2014-02-01 00:50:02.000000', 'temperatura', 1187.0000, 'ºC'),
	(186691, 122, '2014-02-01 00:50:03.000000', 'temperatura', 771.0000, 'ºC'),
	(186692, 122, '2014-02-01 00:50:04.000000', 'temperatura', 292.0000, 'ºC'),
	(186693, 122, '2014-02-01 00:50:05.000000', 'temperatura', 350.0000, 'ºC'),
	(186694, 122, '2014-02-01 00:50:06.000000', 'temperatura', 871.0000, 'ºC'),
	(186695, 122, '2014-02-01 00:50:07.000000', 'temperatura', 908.0000, 'ºC'),
	(186696, 122, '2014-02-01 00:50:08.000000', 'temperatura', 726.0000, 'ºC'),
	(186697, 122, '2014-02-01 00:50:09.000000', 'temperatura', 906.0000, 'ºC'),
	(186698, 122, '2014-02-01 00:50:10.000000', 'temperatura', 1152.0000, 'ºC'),
	(186699, 122, '2014-02-01 00:50:11.000000', 'temperatura', 643.0000, 'ºC'),
	(186700, 122, '2014-02-01 00:50:12.000000', 'temperatura', 962.0000, 'ºC'),
	(186701, 122, '2014-02-01 00:50:13.000000', 'temperatura', 478.0000, 'ºC'),
	(186702, 122, '2014-02-01 00:50:14.000000', 'temperatura', 708.0000, 'ºC'),
	(186703, 122, '2014-02-01 00:50:15.000000', 'temperatura', 903.0000, 'ºC'),
	(186704, 122, '2014-02-01 00:50:16.000000', 'temperatura', 1194.0000, 'ºC'),
	(186705, 122, '2014-02-01 00:50:17.000000', 'temperatura', 861.0000, 'ºC'),
	(186706, 122, '2014-02-01 00:50:18.000000', 'temperatura', 725.0000, 'ºC'),
	(186707, 122, '2014-02-01 00:50:19.000000', 'temperatura', 1042.0000, 'ºC'),
	(186708, 122, '2014-02-01 00:50:20.000000', 'temperatura', 635.0000, 'ºC'),
	(186709, 122, '2014-02-01 00:50:21.000000', 'temperatura', 51.0000, 'ºC'),
	(186710, 122, '2014-02-01 00:50:22.000000', 'temperatura', 750.0000, 'ºC'),
	(186711, 122, '2014-02-01 00:50:23.000000', 'temperatura', 1198.0000, 'ºC'),
	(186712, 122, '2014-02-01 00:50:24.000000', 'temperatura', 138.0000, 'ºC'),
	(186713, 122, '2014-02-01 00:50:25.000000', 'temperatura', 699.0000, 'ºC'),
	(186714, 122, '2014-02-01 00:50:26.000000', 'temperatura', 679.0000, 'ºC'),
	(186715, 122, '2014-02-01 00:50:27.000000', 'temperatura', 98.0000, 'ºC'),
	(186716, 122, '2014-02-01 00:50:28.000000', 'temperatura', 856.0000, 'ºC'),
	(186717, 122, '2014-02-01 00:50:29.000000', 'temperatura', 386.0000, 'ºC'),
	(186718, 122, '2014-02-01 00:50:30.000000', 'temperatura', 561.0000, 'ºC'),
	(186719, 122, '2014-02-01 00:50:31.000000', 'temperatura', 447.0000, 'ºC'),
	(186720, 122, '2014-02-01 00:50:32.000000', 'temperatura', 555.0000, 'ºC'),
	(186721, 122, '2014-02-01 00:50:33.000000', 'temperatura', 234.0000, 'ºC'),
	(186722, 122, '2014-02-01 00:50:34.000000', 'temperatura', 706.0000, 'ºC'),
	(186723, 122, '2014-02-01 00:50:35.000000', 'temperatura', 427.0000, 'ºC'),
	(186724, 122, '2014-02-01 00:50:36.000000', 'temperatura', 19.0000, 'ºC'),
	(186725, 122, '2014-02-01 00:50:37.000000', 'temperatura', 13.0000, 'ºC'),
	(186726, 122, '2014-02-01 00:50:38.000000', 'temperatura', 7.0000, 'ºC'),
	(186727, 122, '2014-02-01 00:50:39.000000', 'temperatura', 0.0000, 'ºC'),
	(186728, 122, '2014-02-01 00:50:40.000000', 'temperatura', 1178.0000, 'ºC'),
	(186729, 122, '2014-02-01 00:50:41.000000', 'temperatura', 1089.0000, 'ºC'),
	(186730, 122, '2014-02-01 00:50:42.000000', 'temperatura', 712.0000, 'ºC'),
	(186731, 122, '2014-02-01 00:50:43.000000', 'temperatura', 296.0000, 'ºC'),
	(186732, 122, '2014-02-01 00:50:44.000000', 'temperatura', 542.0000, 'ºC'),
	(186733, 122, '2014-02-01 00:50:45.000000', 'temperatura', 622.0000, 'ºC'),
	(186734, 122, '2014-02-01 00:50:46.000000', 'temperatura', 286.0000, 'ºC'),
	(186735, 122, '2014-02-01 00:50:47.000000', 'temperatura', 763.0000, 'ºC'),
	(186736, 122, '2014-02-01 00:50:48.000000', 'temperatura', 558.0000, 'ºC'),
	(186737, 122, '2014-02-01 00:50:49.000000', 'temperatura', 503.0000, 'ºC'),
	(186738, 122, '2014-02-01 00:50:50.000000', 'temperatura', 840.0000, 'ºC'),
	(186739, 122, '2014-02-01 00:50:51.000000', 'temperatura', 290.0000, 'ºC'),
	(186740, 122, '2014-02-01 00:50:52.000000', 'temperatura', 133.0000, 'ºC'),
	(186741, 122, '2014-02-01 00:50:53.000000', 'temperatura', 994.0000, 'ºC'),
	(186742, 122, '2014-02-01 00:50:54.000000', 'temperatura', 971.0000, 'ºC'),
	(186743, 122, '2014-02-01 00:50:55.000000', 'temperatura', 674.0000, 'ºC'),
	(186744, 122, '2014-02-01 00:50:56.000000', 'temperatura', 456.0000, 'ºC'),
	(186745, 122, '2014-02-01 00:50:57.000000', 'temperatura', 261.0000, 'ºC'),
	(186746, 122, '2014-02-01 00:50:58.000000', 'temperatura', 1136.0000, 'ºC'),
	(186747, 122, '2014-02-01 00:50:59.000000', 'temperatura', 97.0000, 'ºC'),
	(186748, 122, '2014-02-01 00:51:00.000000', 'temperatura', 679.0000, 'ºC'),
	(186749, 122, '2014-02-01 00:51:01.000000', 'temperatura', 704.0000, 'ºC'),
	(186750, 122, '2014-02-01 00:51:02.000000', 'temperatura', 282.0000, 'ºC'),
	(186751, 122, '2014-02-01 00:51:03.000000', 'temperatura', 501.0000, 'ºC'),
	(186752, 122, '2014-02-01 00:51:04.000000', 'temperatura', 457.0000, 'ºC'),
	(186753, 122, '2014-02-01 00:51:05.000000', 'temperatura', 781.0000, 'ºC'),
	(186754, 122, '2014-02-01 00:51:06.000000', 'temperatura', 138.0000, 'ºC'),
	(186755, 122, '2014-02-01 00:51:07.000000', 'temperatura', 746.0000, 'ºC'),
	(186756, 122, '2014-02-01 00:51:08.000000', 'temperatura', 919.0000, 'ºC'),
	(186757, 122, '2014-02-01 00:51:09.000000', 'temperatura', 1154.0000, 'ºC'),
	(186758, 122, '2014-02-01 00:51:10.000000', 'temperatura', 616.0000, 'ºC'),
	(186759, 122, '2014-02-01 00:51:11.000000', 'temperatura', 817.0000, 'ºC'),
	(186760, 122, '2014-02-01 00:51:12.000000', 'temperatura', 1036.0000, 'ºC'),
	(186761, 122, '2014-02-01 00:51:13.000000', 'temperatura', 332.0000, 'ºC'),
	(186762, 122, '2014-02-01 00:51:14.000000', 'temperatura', 952.0000, 'ºC'),
	(186763, 122, '2014-02-01 00:51:15.000000', 'temperatura', 165.0000, 'ºC'),
	(186764, 122, '2014-02-01 00:51:16.000000', 'temperatura', 371.0000, 'ºC'),
	(186765, 122, '2014-02-01 00:51:17.000000', 'temperatura', 159.0000, 'ºC'),
	(186766, 122, '2014-02-01 00:51:18.000000', 'temperatura', 883.0000, 'ºC'),
	(186767, 122, '2014-02-01 00:51:19.000000', 'temperatura', 340.0000, 'ºC'),
	(186768, 122, '2014-02-01 00:51:20.000000', 'temperatura', 250.0000, 'ºC'),
	(186769, 122, '2014-02-01 00:51:21.000000', 'temperatura', 231.0000, 'ºC'),
	(186770, 122, '2014-02-01 00:51:22.000000', 'temperatura', 407.0000, 'ºC'),
	(186771, 122, '2014-02-01 00:51:23.000000', 'temperatura', 140.0000, 'ºC'),
	(186772, 122, '2014-02-01 00:51:24.000000', 'temperatura', 679.0000, 'ºC'),
	(186773, 122, '2014-02-01 00:51:25.000000', 'temperatura', 574.0000, 'ºC'),
	(186774, 122, '2014-02-01 00:51:26.000000', 'temperatura', 837.0000, 'ºC'),
	(186775, 122, '2014-02-01 00:51:27.000000', 'temperatura', 62.0000, 'ºC'),
	(186776, 122, '2014-02-01 00:51:28.000000', 'temperatura', 198.0000, 'ºC'),
	(186777, 122, '2014-02-01 00:51:29.000000', 'temperatura', 805.0000, 'ºC'),
	(186778, 122, '2014-02-01 00:51:30.000000', 'temperatura', 1032.0000, 'ºC'),
	(186779, 122, '2014-02-01 00:51:31.000000', 'temperatura', 346.0000, 'ºC'),
	(186780, 122, '2014-02-01 00:51:32.000000', 'temperatura', 1033.0000, 'ºC'),
	(186781, 122, '2014-02-01 00:51:33.000000', 'temperatura', 529.0000, 'ºC'),
	(186782, 122, '2014-02-01 00:51:34.000000', 'temperatura', 748.0000, 'ºC'),
	(186783, 122, '2014-02-01 00:51:35.000000', 'temperatura', 951.0000, 'ºC'),
	(186784, 122, '2014-02-01 00:51:36.000000', 'temperatura', 111.0000, 'ºC'),
	(186785, 122, '2014-02-01 00:51:37.000000', 'temperatura', 102.0000, 'ºC'),
	(186786, 122, '2014-02-01 00:51:38.000000', 'temperatura', 179.0000, 'ºC'),
	(186787, 122, '2014-02-01 00:51:39.000000', 'temperatura', 590.0000, 'ºC'),
	(186788, 122, '2014-02-01 00:51:40.000000', 'temperatura', 13.0000, 'ºC'),
	(186789, 122, '2014-02-01 00:51:41.000000', 'temperatura', 695.0000, 'ºC'),
	(186790, 122, '2014-02-01 00:51:42.000000', 'temperatura', 1037.0000, 'ºC'),
	(186791, 122, '2014-02-01 00:51:43.000000', 'temperatura', 699.0000, 'ºC'),
	(186792, 122, '2014-02-01 00:51:44.000000', 'temperatura', 386.0000, 'ºC'),
	(186793, 122, '2014-02-01 00:51:45.000000', 'temperatura', 1033.0000, 'ºC'),
	(186794, 122, '2014-02-01 00:51:46.000000', 'temperatura', 409.0000, 'ºC'),
	(186795, 122, '2014-02-01 00:51:47.000000', 'temperatura', 145.0000, 'ºC'),
	(186796, 122, '2014-02-01 00:51:48.000000', 'temperatura', 698.0000, 'ºC'),
	(186797, 122, '2014-02-01 00:51:49.000000', 'temperatura', 658.0000, 'ºC'),
	(186798, 122, '2014-02-01 00:51:50.000000', 'temperatura', 1195.0000, 'ºC'),
	(186799, 122, '2014-02-01 00:51:51.000000', 'temperatura', 402.0000, 'ºC'),
	(186800, 122, '2014-02-01 00:51:52.000000', 'temperatura', 826.0000, 'ºC'),
	(186801, 122, '2014-02-01 00:51:53.000000', 'temperatura', 526.0000, 'ºC'),
	(186802, 122, '2014-02-01 00:51:54.000000', 'temperatura', 150.0000, 'ºC'),
	(186803, 122, '2014-02-01 00:51:55.000000', 'temperatura', 374.0000, 'ºC'),
	(186804, 122, '2014-02-01 00:51:56.000000', 'temperatura', 219.0000, 'ºC'),
	(186805, 122, '2014-02-01 00:51:57.000000', 'temperatura', 1172.0000, 'ºC'),
	(186806, 122, '2014-02-01 00:51:58.000000', 'temperatura', 407.0000, 'ºC'),
	(186807, 122, '2014-02-01 00:51:59.000000', 'temperatura', 918.0000, 'ºC'),
	(186808, 122, '2014-02-01 00:52:00.000000', 'temperatura', 971.0000, 'ºC'),
	(186809, 122, '2014-02-01 00:52:01.000000', 'temperatura', 900.0000, 'ºC'),
	(186810, 122, '2014-02-01 00:52:02.000000', 'temperatura', 388.0000, 'ºC'),
	(186811, 122, '2014-02-01 00:52:03.000000', 'temperatura', 438.0000, 'ºC'),
	(186812, 122, '2014-02-01 00:52:04.000000', 'temperatura', 1030.0000, 'ºC'),
	(186813, 122, '2014-02-01 00:52:05.000000', 'temperatura', 233.0000, 'ºC'),
	(186814, 122, '2014-02-01 00:52:06.000000', 'temperatura', 479.0000, 'ºC'),
	(186815, 122, '2014-02-01 00:52:07.000000', 'temperatura', 495.0000, 'ºC'),
	(186816, 122, '2014-02-01 00:52:08.000000', 'temperatura', 1040.0000, 'ºC'),
	(186817, 122, '2014-02-01 00:52:09.000000', 'temperatura', 116.0000, 'ºC'),
	(186818, 122, '2014-02-01 00:52:10.000000', 'temperatura', 1058.0000, 'ºC'),
	(186819, 122, '2014-02-01 00:52:11.000000', 'temperatura', 142.0000, 'ºC'),
	(186820, 122, '2014-02-01 00:52:12.000000', 'temperatura', 1137.0000, 'ºC'),
	(186821, 122, '2014-02-01 00:52:13.000000', 'temperatura', 462.0000, 'ºC'),
	(186822, 122, '2014-02-01 00:52:14.000000', 'temperatura', 96.0000, 'ºC'),
	(186823, 122, '2014-02-01 00:52:15.000000', 'temperatura', 297.0000, 'ºC'),
	(186824, 122, '2014-02-01 00:52:16.000000', 'temperatura', 1198.0000, 'ºC'),
	(186825, 122, '2014-02-01 00:52:17.000000', 'temperatura', 300.0000, 'ºC'),
	(186826, 122, '2014-02-01 00:52:18.000000', 'temperatura', 305.0000, 'ºC'),
	(186827, 122, '2014-02-01 00:52:19.000000', 'temperatura', 624.0000, 'ºC'),
	(186828, 122, '2014-02-01 00:52:20.000000', 'temperatura', 1006.0000, 'ºC'),
	(186829, 122, '2014-02-01 00:52:21.000000', 'temperatura', 759.0000, 'ºC'),
	(186830, 122, '2014-02-01 00:52:22.000000', 'temperatura', 777.0000, 'ºC'),
	(186831, 122, '2014-02-01 00:52:23.000000', 'temperatura', 409.0000, 'ºC'),
	(186832, 122, '2014-02-01 00:52:24.000000', 'temperatura', 913.0000, 'ºC'),
	(186833, 122, '2014-02-01 00:52:25.000000', 'temperatura', 939.0000, 'ºC'),
	(186834, 122, '2014-02-01 00:52:26.000000', 'temperatura', 759.0000, 'ºC'),
	(186835, 122, '2014-02-01 00:52:27.000000', 'temperatura', 976.0000, 'ºC'),
	(186836, 122, '2014-02-01 00:52:28.000000', 'temperatura', 203.0000, 'ºC'),
	(186837, 122, '2014-02-01 00:52:29.000000', 'temperatura', 487.0000, 'ºC'),
	(186838, 122, '2014-02-01 00:52:30.000000', 'temperatura', 626.0000, 'ºC'),
	(186839, 122, '2014-02-01 00:52:31.000000', 'temperatura', 470.0000, 'ºC'),
	(186840, 122, '2014-02-01 00:52:32.000000', 'temperatura', 472.0000, 'ºC'),
	(186841, 122, '2014-02-01 00:52:33.000000', 'temperatura', 951.0000, 'ºC'),
	(186842, 122, '2014-02-01 00:52:34.000000', 'temperatura', 941.0000, 'ºC'),
	(186843, 122, '2014-02-01 00:52:35.000000', 'temperatura', 652.0000, 'ºC'),
	(186844, 122, '2014-02-01 00:52:36.000000', 'temperatura', 439.0000, 'ºC'),
	(186845, 122, '2014-02-01 00:52:37.000000', 'temperatura', 237.0000, 'ºC'),
	(186846, 122, '2014-02-01 00:52:38.000000', 'temperatura', 1070.0000, 'ºC'),
	(186847, 122, '2014-02-01 00:52:39.000000', 'temperatura', 1041.0000, 'ºC'),
	(186848, 122, '2014-02-01 00:52:40.000000', 'temperatura', 795.0000, 'ºC'),
	(186849, 122, '2014-02-01 00:52:41.000000', 'temperatura', 851.0000, 'ºC'),
	(186850, 122, '2014-02-01 00:52:42.000000', 'temperatura', 669.0000, 'ºC'),
	(186851, 122, '2014-02-01 00:52:43.000000', 'temperatura', 795.0000, 'ºC'),
	(186852, 122, '2014-02-01 00:52:44.000000', 'temperatura', 770.0000, 'ºC'),
	(186853, 122, '2014-02-01 00:52:45.000000', 'temperatura', 263.0000, 'ºC'),
	(186854, 122, '2014-02-01 00:52:46.000000', 'temperatura', 208.0000, 'ºC'),
	(186855, 122, '2014-02-01 00:52:47.000000', 'temperatura', 252.0000, 'ºC'),
	(186856, 122, '2014-02-01 00:52:48.000000', 'temperatura', 633.0000, 'ºC'),
	(186857, 122, '2014-02-01 00:52:49.000000', 'temperatura', 12.0000, 'ºC'),
	(186858, 122, '2014-02-01 00:52:50.000000', 'temperatura', 562.0000, 'ºC'),
	(186859, 122, '2014-02-01 00:52:51.000000', 'temperatura', 372.0000, 'ºC'),
	(186860, 122, '2014-02-01 00:52:52.000000', 'temperatura', 175.0000, 'ºC'),
	(186861, 122, '2014-02-01 00:52:53.000000', 'temperatura', 962.0000, 'ºC'),
	(186862, 122, '2014-02-01 00:52:54.000000', 'temperatura', 684.0000, 'ºC'),
	(186863, 122, '2014-02-01 00:52:55.000000', 'temperatura', 533.0000, 'ºC'),
	(186864, 122, '2014-02-01 00:52:56.000000', 'temperatura', 614.0000, 'ºC'),
	(186865, 122, '2014-02-01 00:52:57.000000', 'temperatura', 270.0000, 'ºC'),
	(186866, 122, '2014-02-01 00:52:58.000000', 'temperatura', 711.0000, 'ºC'),
	(186867, 122, '2014-02-01 00:52:59.000000', 'temperatura', 344.0000, 'ºC'),
	(186868, 122, '2014-02-01 00:53:00.000000', 'temperatura', 789.0000, 'ºC'),
	(186869, 122, '2014-02-01 00:53:01.000000', 'temperatura', 513.0000, 'ºC'),
	(186870, 122, '2014-02-01 00:53:02.000000', 'temperatura', 197.0000, 'ºC'),
	(186871, 122, '2014-02-01 00:53:03.000000', 'temperatura', 648.0000, 'ºC'),
	(186872, 122, '2014-02-01 00:53:04.000000', 'temperatura', 249.0000, 'ºC'),
	(186873, 122, '2014-02-01 00:53:05.000000', 'temperatura', 501.0000, 'ºC'),
	(186874, 122, '2014-02-01 00:53:06.000000', 'temperatura', 560.0000, 'ºC'),
	(186875, 122, '2014-02-01 00:53:07.000000', 'temperatura', 98.0000, 'ºC'),
	(186876, 122, '2014-02-01 00:53:08.000000', 'temperatura', 10.0000, 'ºC'),
	(186877, 122, '2014-02-01 00:53:09.000000', 'temperatura', 955.0000, 'ºC'),
	(186878, 122, '2014-02-01 00:53:10.000000', 'temperatura', 1147.0000, 'ºC'),
	(186879, 122, '2014-02-01 00:53:11.000000', 'temperatura', 469.0000, 'ºC'),
	(186880, 122, '2014-02-01 00:53:12.000000', 'temperatura', 103.0000, 'ºC'),
	(186881, 122, '2014-02-01 00:53:13.000000', 'temperatura', 312.0000, 'ºC'),
	(186882, 122, '2014-02-01 00:53:14.000000', 'temperatura', 50.0000, 'ºC'),
	(186883, 122, '2014-02-01 00:53:15.000000', 'temperatura', 515.0000, 'ºC'),
	(186884, 122, '2014-02-01 00:53:16.000000', 'temperatura', 26.0000, 'ºC'),
	(186885, 122, '2014-02-01 00:53:17.000000', 'temperatura', 987.0000, 'ºC'),
	(186886, 122, '2014-02-01 00:53:18.000000', 'temperatura', 56.0000, 'ºC'),
	(186887, 122, '2014-02-01 00:53:19.000000', 'temperatura', 919.0000, 'ºC'),
	(186888, 122, '2014-02-01 00:53:20.000000', 'temperatura', 828.0000, 'ºC'),
	(186889, 122, '2014-02-01 00:53:21.000000', 'temperatura', 185.0000, 'ºC'),
	(186890, 122, '2014-02-01 00:53:22.000000', 'temperatura', 840.0000, 'ºC'),
	(186891, 122, '2014-02-01 00:53:23.000000', 'temperatura', 48.0000, 'ºC'),
	(186892, 122, '2014-02-01 00:53:24.000000', 'temperatura', 117.0000, 'ºC'),
	(186893, 122, '2014-02-01 00:53:25.000000', 'temperatura', 443.0000, 'ºC'),
	(186894, 122, '2014-02-01 00:53:26.000000', 'temperatura', 666.0000, 'ºC'),
	(186895, 122, '2014-02-01 00:53:27.000000', 'temperatura', 799.0000, 'ºC'),
	(186896, 122, '2014-02-01 00:53:28.000000', 'temperatura', 797.0000, 'ºC'),
	(186897, 122, '2014-02-01 00:53:29.000000', 'temperatura', 388.0000, 'ºC'),
	(186898, 122, '2014-02-01 00:53:30.000000', 'temperatura', 749.0000, 'ºC'),
	(186899, 122, '2014-02-01 00:53:31.000000', 'temperatura', 185.0000, 'ºC'),
	(186900, 122, '2014-02-01 00:53:32.000000', 'temperatura', 1075.0000, 'ºC'),
	(186901, 122, '2014-02-01 00:53:33.000000', 'temperatura', 21.0000, 'ºC'),
	(186902, 122, '2014-02-01 00:53:34.000000', 'temperatura', 482.0000, 'ºC'),
	(186903, 122, '2014-02-01 00:53:35.000000', 'temperatura', 1148.0000, 'ºC'),
	(186904, 122, '2014-02-01 00:53:36.000000', 'temperatura', 692.0000, 'ºC'),
	(186905, 122, '2014-02-01 00:53:37.000000', 'temperatura', 20.0000, 'ºC'),
	(186906, 122, '2014-02-01 00:53:38.000000', 'temperatura', 422.0000, 'ºC'),
	(186907, 122, '2014-02-01 00:53:39.000000', 'temperatura', 851.0000, 'ºC'),
	(186908, 122, '2014-02-01 00:53:40.000000', 'temperatura', 590.0000, 'ºC'),
	(186909, 122, '2014-02-01 00:53:41.000000', 'temperatura', 396.0000, 'ºC'),
	(186910, 122, '2014-02-01 00:53:42.000000', 'temperatura', 213.0000, 'ºC'),
	(186911, 122, '2014-02-01 00:53:43.000000', 'temperatura', 1078.0000, 'ºC'),
	(186912, 122, '2014-02-01 00:53:44.000000', 'temperatura', 1149.0000, 'ºC'),
	(186913, 122, '2014-02-01 00:53:45.000000', 'temperatura', 113.0000, 'ºC'),
	(186914, 122, '2014-02-01 00:53:46.000000', 'temperatura', 718.0000, 'ºC'),
	(186915, 122, '2014-02-01 00:53:47.000000', 'temperatura', 853.0000, 'ºC'),
	(186916, 122, '2014-02-01 00:53:48.000000', 'temperatura', 911.0000, 'ºC'),
	(186917, 122, '2014-02-01 00:53:49.000000', 'temperatura', 796.0000, 'ºC'),
	(186918, 122, '2014-02-01 00:53:50.000000', 'temperatura', 47.0000, 'ºC'),
	(186919, 122, '2014-02-01 00:53:51.000000', 'temperatura', 247.0000, 'ºC'),
	(186920, 122, '2014-02-01 00:53:52.000000', 'temperatura', 1095.0000, 'ºC'),
	(186921, 122, '2014-02-01 00:53:53.000000', 'temperatura', 1137.0000, 'ºC'),
	(186922, 122, '2014-02-01 00:53:54.000000', 'temperatura', 1197.0000, 'ºC'),
	(186923, 122, '2014-02-01 00:53:55.000000', 'temperatura', 175.0000, 'ºC'),
	(186924, 122, '2014-02-01 00:53:56.000000', 'temperatura', 886.0000, 'ºC'),
	(186925, 122, '2014-02-01 00:53:57.000000', 'temperatura', 305.0000, 'ºC'),
	(186926, 122, '2014-02-01 00:53:58.000000', 'temperatura', 67.0000, 'ºC'),
	(186927, 122, '2014-02-01 00:53:59.000000', 'temperatura', 620.0000, 'ºC'),
	(186928, 122, '2014-02-01 00:54:00.000000', 'temperatura', 499.0000, 'ºC'),
	(186929, 122, '2014-02-01 00:54:01.000000', 'temperatura', 635.0000, 'ºC'),
	(186930, 122, '2014-02-01 00:54:02.000000', 'temperatura', 480.0000, 'ºC'),
	(186931, 122, '2014-02-01 00:54:03.000000', 'temperatura', 494.0000, 'ºC'),
	(186932, 122, '2014-02-01 00:54:04.000000', 'temperatura', 1031.0000, 'ºC'),
	(186933, 122, '2014-02-01 00:54:05.000000', 'temperatura', 74.0000, 'ºC'),
	(186934, 122, '2014-02-01 00:54:06.000000', 'temperatura', 879.0000, 'ºC'),
	(186935, 122, '2014-02-01 00:54:07.000000', 'temperatura', 573.0000, 'ºC'),
	(186936, 122, '2014-02-01 00:54:08.000000', 'temperatura', 229.0000, 'ºC'),
	(186937, 122, '2014-02-01 00:54:09.000000', 'temperatura', 625.0000, 'ºC'),
	(186938, 122, '2014-02-01 00:54:10.000000', 'temperatura', 39.0000, 'ºC'),
	(186939, 122, '2014-02-01 00:54:11.000000', 'temperatura', 720.0000, 'ºC'),
	(186940, 122, '2014-02-01 00:54:12.000000', 'temperatura', 1085.0000, 'ºC'),
	(186941, 122, '2014-02-01 00:54:13.000000', 'temperatura', 864.0000, 'ºC'),
	(186942, 122, '2014-02-01 00:54:14.000000', 'temperatura', 1066.0000, 'ºC'),
	(186943, 122, '2014-02-01 00:54:15.000000', 'temperatura', 339.0000, 'ºC'),
	(186944, 122, '2014-02-01 00:54:16.000000', 'temperatura', 899.0000, 'ºC'),
	(186945, 122, '2014-02-01 00:54:17.000000', 'temperatura', 1077.0000, 'ºC'),
	(186946, 122, '2014-02-01 00:54:18.000000', 'temperatura', 290.0000, 'ºC'),
	(186947, 122, '2014-02-01 00:54:19.000000', 'temperatura', 618.0000, 'ºC'),
	(186948, 122, '2014-02-01 00:54:20.000000', 'temperatura', 1021.0000, 'ºC'),
	(186949, 122, '2014-02-01 00:54:21.000000', 'temperatura', 853.0000, 'ºC'),
	(186950, 122, '2014-02-01 00:54:22.000000', 'temperatura', 1.0000, 'ºC'),
	(186951, 122, '2014-02-01 00:54:23.000000', 'temperatura', 1046.0000, 'ºC'),
	(186952, 122, '2014-02-01 00:54:24.000000', 'temperatura', 428.0000, 'ºC'),
	(186953, 122, '2014-02-01 00:54:25.000000', 'temperatura', 201.0000, 'ºC'),
	(186954, 122, '2014-02-01 00:54:26.000000', 'temperatura', 920.0000, 'ºC'),
	(186955, 122, '2014-02-01 00:54:27.000000', 'temperatura', 401.0000, 'ºC'),
	(186956, 122, '2014-02-01 00:54:28.000000', 'temperatura', 446.0000, 'ºC'),
	(186957, 122, '2014-02-01 00:54:29.000000', 'temperatura', 1027.0000, 'ºC'),
	(186958, 122, '2014-02-01 00:54:30.000000', 'temperatura', 196.0000, 'ºC'),
	(186959, 122, '2014-02-01 00:54:31.000000', 'temperatura', 299.0000, 'ºC'),
	(186960, 122, '2014-02-01 00:54:32.000000', 'temperatura', 909.0000, 'ºC'),
	(186961, 122, '2014-02-01 00:54:33.000000', 'temperatura', 49.0000, 'ºC'),
	(186962, 122, '2014-02-01 00:54:34.000000', 'temperatura', 1117.0000, 'ºC'),
	(186963, 122, '2014-02-01 00:54:35.000000', 'temperatura', 638.0000, 'ºC'),
	(186964, 122, '2014-02-01 00:54:36.000000', 'temperatura', 1039.0000, 'ºC'),
	(186965, 122, '2014-02-01 00:54:37.000000', 'temperatura', 884.0000, 'ºC'),
	(186966, 122, '2014-02-01 00:54:38.000000', 'temperatura', 104.0000, 'ºC'),
	(186967, 122, '2014-02-01 00:54:39.000000', 'temperatura', 267.0000, 'ºC'),
	(186968, 122, '2014-02-01 00:54:40.000000', 'temperatura', 1023.0000, 'ºC'),
	(186969, 122, '2014-02-01 00:54:41.000000', 'temperatura', 716.0000, 'ºC'),
	(186970, 122, '2014-02-01 00:54:42.000000', 'temperatura', 509.0000, 'ºC'),
	(186971, 122, '2014-02-01 00:54:43.000000', 'temperatura', 400.0000, 'ºC'),
	(186972, 122, '2014-02-01 00:54:44.000000', 'temperatura', 472.0000, 'ºC'),
	(186973, 122, '2014-02-01 00:54:45.000000', 'temperatura', 1161.0000, 'ºC'),
	(186974, 122, '2014-02-01 00:54:46.000000', 'temperatura', 789.0000, 'ºC'),
	(186975, 122, '2014-02-01 00:54:47.000000', 'temperatura', 462.0000, 'ºC'),
	(186976, 122, '2014-02-01 00:54:48.000000', 'temperatura', 1143.0000, 'ºC'),
	(186977, 122, '2014-02-01 00:54:49.000000', 'temperatura', 731.0000, 'ºC'),
	(186978, 122, '2014-02-01 00:54:50.000000', 'temperatura', 228.0000, 'ºC'),
	(186979, 122, '2014-02-01 00:54:51.000000', 'temperatura', 146.0000, 'ºC'),
	(186980, 122, '2014-02-01 00:54:52.000000', 'temperatura', 48.0000, 'ºC'),
	(186981, 122, '2014-02-01 00:54:53.000000', 'temperatura', 1002.0000, 'ºC'),
	(186982, 122, '2014-02-01 00:54:54.000000', 'temperatura', 66.0000, 'ºC'),
	(186983, 122, '2014-02-01 00:54:55.000000', 'temperatura', 924.0000, 'ºC'),
	(186984, 122, '2014-02-01 00:54:56.000000', 'temperatura', 824.0000, 'ºC'),
	(186985, 122, '2014-02-01 00:54:57.000000', 'temperatura', 149.0000, 'ºC'),
	(186986, 122, '2014-02-01 00:54:58.000000', 'temperatura', 672.0000, 'ºC'),
	(186987, 122, '2014-02-01 00:54:59.000000', 'temperatura', 513.0000, 'ºC'),
	(186988, 122, '2014-02-01 00:55:00.000000', 'temperatura', 549.0000, 'ºC'),
	(186989, 122, '2014-02-01 00:55:01.000000', 'temperatura', 8.0000, 'ºC'),
	(186990, 122, '2014-02-01 00:55:02.000000', 'temperatura', 795.0000, 'ºC'),
	(186991, 122, '2014-02-01 00:55:03.000000', 'temperatura', 349.0000, 'ºC'),
	(186992, 122, '2014-02-01 00:55:04.000000', 'temperatura', 563.0000, 'ºC'),
	(186993, 122, '2014-02-01 00:55:05.000000', 'temperatura', 567.0000, 'ºC'),
	(186994, 122, '2014-02-01 00:55:06.000000', 'temperatura', 1147.0000, 'ºC'),
	(186995, 122, '2014-02-01 00:55:07.000000', 'temperatura', 434.0000, 'ºC'),
	(186996, 122, '2014-02-01 00:55:08.000000', 'temperatura', 1131.0000, 'ºC'),
	(186997, 122, '2014-02-01 00:55:09.000000', 'temperatura', 754.0000, 'ºC'),
	(186998, 122, '2014-02-01 00:55:10.000000', 'temperatura', 375.0000, 'ºC'),
	(186999, 122, '2014-02-01 00:55:11.000000', 'temperatura', 815.0000, 'ºC'),
	(187000, 122, '2014-02-01 00:55:12.000000', 'temperatura', 550.0000, 'ºC'),
	(187001, 122, '2014-02-01 00:55:13.000000', 'temperatura', 307.0000, 'ºC'),
	(187002, 122, '2014-02-01 00:55:14.000000', 'temperatura', 1084.0000, 'ºC'),
	(187003, 122, '2014-02-01 00:55:15.000000', 'temperatura', 900.0000, 'ºC'),
	(187004, 122, '2014-02-01 00:55:16.000000', 'temperatura', 48.0000, 'ºC'),
	(187005, 122, '2014-02-01 00:55:17.000000', 'temperatura', 1141.0000, 'ºC'),
	(187006, 122, '2014-02-01 00:55:18.000000', 'temperatura', 762.0000, 'ºC'),
	(187007, 122, '2014-02-01 00:55:19.000000', 'temperatura', 386.0000, 'ºC'),
	(187008, 122, '2014-02-01 00:55:20.000000', 'temperatura', 846.0000, 'ºC'),
	(187009, 122, '2014-02-01 00:55:21.000000', 'temperatura', 673.0000, 'ºC'),
	(187010, 122, '2014-02-01 00:55:22.000000', 'temperatura', 827.0000, 'ºC'),
	(187011, 122, '2014-02-01 00:55:23.000000', 'temperatura', 915.0000, 'ºC'),
	(187012, 122, '2014-02-01 00:55:24.000000', 'temperatura', 896.0000, 'ºC'),
	(187013, 122, '2014-02-01 00:55:25.000000', 'temperatura', 537.0000, 'ºC'),
	(187014, 122, '2014-02-01 00:55:26.000000', 'temperatura', 1197.0000, 'ºC'),
	(187015, 122, '2014-02-01 00:55:27.000000', 'temperatura', 773.0000, 'ºC'),
	(187016, 122, '2014-02-01 00:55:28.000000', 'temperatura', 275.0000, 'ºC'),
	(187017, 122, '2014-02-01 00:55:29.000000', 'temperatura', 255.0000, 'ºC'),
	(187018, 122, '2014-02-01 00:55:30.000000', 'temperatura', 450.0000, 'ºC'),
	(187019, 122, '2014-02-01 00:55:31.000000', 'temperatura', 286.0000, 'ºC'),
	(187020, 122, '2014-02-01 00:55:32.000000', 'temperatura', 81.0000, 'ºC'),
	(187021, 122, '2014-02-01 00:55:33.000000', 'temperatura', 746.0000, 'ºC'),
	(187022, 122, '2014-02-01 00:55:34.000000', 'temperatura', 1090.0000, 'ºC'),
	(187023, 122, '2014-02-01 00:55:35.000000', 'temperatura', 812.0000, 'ºC'),
	(187024, 122, '2014-02-01 00:55:36.000000', 'temperatura', 788.0000, 'ºC'),
	(187025, 122, '2014-02-01 00:55:37.000000', 'temperatura', 307.0000, 'ºC'),
	(187026, 122, '2014-02-01 00:55:38.000000', 'temperatura', 370.0000, 'ºC'),
	(187027, 122, '2014-02-01 00:55:39.000000', 'temperatura', 929.0000, 'ºC'),
	(187028, 122, '2014-02-01 00:55:40.000000', 'temperatura', 1138.0000, 'ºC'),
	(187029, 122, '2014-02-01 00:55:41.000000', 'temperatura', 501.0000, 'ºC'),
	(187030, 122, '2014-02-01 00:55:42.000000', 'temperatura', 293.0000, 'ºC'),
	(187031, 122, '2014-02-01 00:55:43.000000', 'temperatura', 1160.0000, 'ºC'),
	(187032, 122, '2014-02-01 00:55:44.000000', 'temperatura', 125.0000, 'ºC'),
	(187033, 122, '2014-02-01 00:55:45.000000', 'temperatura', 743.0000, 'ºC'),
	(187034, 122, '2014-02-01 00:55:46.000000', 'temperatura', 943.0000, 'ºC'),
	(187035, 122, '2014-02-01 00:55:47.000000', 'temperatura', 85.0000, 'ºC'),
	(187036, 122, '2014-02-01 00:55:48.000000', 'temperatura', 1195.0000, 'ºC'),
	(187037, 122, '2014-02-01 00:55:49.000000', 'temperatura', 922.0000, 'ºC'),
	(187038, 122, '2014-02-01 00:55:50.000000', 'temperatura', 1024.0000, 'ºC'),
	(187039, 122, '2014-02-01 00:55:51.000000', 'temperatura', 1157.0000, 'ºC'),
	(187040, 122, '2014-02-01 00:55:52.000000', 'temperatura', 313.0000, 'ºC'),
	(187041, 122, '2014-02-01 00:55:53.000000', 'temperatura', 493.0000, 'ºC'),
	(187042, 122, '2014-02-01 00:55:54.000000', 'temperatura', 326.0000, 'ºC'),
	(187043, 122, '2014-02-01 00:55:55.000000', 'temperatura', 153.0000, 'ºC'),
	(187044, 122, '2014-02-01 00:55:56.000000', 'temperatura', 989.0000, 'ºC'),
	(187045, 122, '2014-02-01 00:55:57.000000', 'temperatura', 886.0000, 'ºC'),
	(187046, 122, '2014-02-01 00:55:58.000000', 'temperatura', 263.0000, 'ºC'),
	(187047, 122, '2014-02-01 00:55:59.000000', 'temperatura', 1056.0000, 'ºC'),
	(187048, 122, '2014-02-01 00:56:00.000000', 'temperatura', 893.0000, 'ºC'),
	(187049, 122, '2014-02-01 00:56:01.000000', 'temperatura', 99.0000, 'ºC'),
	(187050, 122, '2014-02-01 00:56:02.000000', 'temperatura', 216.0000, 'ºC'),
	(187051, 122, '2014-02-01 00:56:03.000000', 'temperatura', 781.0000, 'ºC'),
	(187052, 122, '2014-02-01 00:56:04.000000', 'temperatura', 860.0000, 'ºC'),
	(187053, 122, '2014-02-01 00:56:05.000000', 'temperatura', 755.0000, 'ºC'),
	(187054, 122, '2014-02-01 00:56:06.000000', 'temperatura', 1197.0000, 'ºC'),
	(187055, 122, '2014-02-01 00:56:07.000000', 'temperatura', 120.0000, 'ºC'),
	(187056, 122, '2014-02-01 00:56:08.000000', 'temperatura', 609.0000, 'ºC'),
	(187057, 122, '2014-02-01 00:56:09.000000', 'temperatura', 286.0000, 'ºC'),
	(187058, 122, '2014-02-01 00:56:10.000000', 'temperatura', 806.0000, 'ºC'),
	(187059, 122, '2014-02-01 00:56:11.000000', 'temperatura', 769.0000, 'ºC'),
	(187060, 122, '2014-02-01 00:56:12.000000', 'temperatura', 230.0000, 'ºC'),
	(187061, 122, '2014-02-01 00:56:13.000000', 'temperatura', 41.0000, 'ºC'),
	(187062, 122, '2014-02-01 00:56:14.000000', 'temperatura', 716.0000, 'ºC'),
	(187063, 122, '2014-02-01 00:56:15.000000', 'temperatura', 1056.0000, 'ºC'),
	(187064, 122, '2014-02-01 00:56:16.000000', 'temperatura', 735.0000, 'ºC'),
	(187065, 122, '2014-02-01 00:56:17.000000', 'temperatura', 505.0000, 'ºC'),
	(187066, 122, '2014-02-01 00:56:18.000000', 'temperatura', 320.0000, 'ºC'),
	(187067, 122, '2014-02-01 00:56:19.000000', 'temperatura', 88.0000, 'ºC'),
	(187068, 122, '2014-02-01 00:56:20.000000', 'temperatura', 678.0000, 'ºC'),
	(187069, 122, '2014-02-01 00:56:21.000000', 'temperatura', 727.0000, 'ºC'),
	(187070, 122, '2014-02-01 00:56:22.000000', 'temperatura', 403.0000, 'ºC'),
	(187071, 122, '2014-02-01 00:56:23.000000', 'temperatura', 1035.0000, 'ºC'),
	(187072, 122, '2014-02-01 00:56:24.000000', 'temperatura', 364.0000, 'ºC'),
	(187073, 122, '2014-02-01 00:56:25.000000', 'temperatura', 1116.0000, 'ºC'),
	(187074, 122, '2014-02-01 00:56:26.000000', 'temperatura', 891.0000, 'ºC'),
	(187075, 122, '2014-02-01 00:56:27.000000', 'temperatura', 1105.0000, 'ºC'),
	(187076, 122, '2014-02-01 00:56:28.000000', 'temperatura', 455.0000, 'ºC'),
	(187077, 122, '2014-02-01 00:56:29.000000', 'temperatura', 158.0000, 'ºC'),
	(187078, 122, '2014-02-01 00:56:30.000000', 'temperatura', 626.0000, 'ºC'),
	(187079, 122, '2014-02-01 00:56:31.000000', 'temperatura', 258.0000, 'ºC'),
	(187080, 122, '2014-02-01 00:56:32.000000', 'temperatura', 610.0000, 'ºC'),
	(187081, 122, '2014-02-01 00:56:33.000000', 'temperatura', 1079.0000, 'ºC'),
	(187082, 122, '2014-02-01 00:56:34.000000', 'temperatura', 1165.0000, 'ºC'),
	(187083, 122, '2014-02-01 00:56:35.000000', 'temperatura', 188.0000, 'ºC'),
	(187084, 122, '2014-02-01 00:56:36.000000', 'temperatura', 1047.0000, 'ºC'),
	(187085, 122, '2014-02-01 00:56:37.000000', 'temperatura', 1069.0000, 'ºC'),
	(187086, 122, '2014-02-01 00:56:38.000000', 'temperatura', 1007.0000, 'ºC'),
	(187087, 122, '2014-02-01 00:56:39.000000', 'temperatura', 626.0000, 'ºC'),
	(187088, 122, '2014-02-01 00:56:40.000000', 'temperatura', 109.0000, 'ºC'),
	(187089, 122, '2014-02-01 00:56:41.000000', 'temperatura', 1071.0000, 'ºC'),
	(187090, 122, '2014-02-01 00:56:42.000000', 'temperatura', 226.0000, 'ºC'),
	(187091, 122, '2014-02-01 00:56:43.000000', 'temperatura', 316.0000, 'ºC'),
	(187092, 122, '2014-02-01 00:56:44.000000', 'temperatura', 905.0000, 'ºC'),
	(187093, 122, '2014-02-01 00:56:45.000000', 'temperatura', 1178.0000, 'ºC'),
	(187094, 122, '2014-02-01 00:56:46.000000', 'temperatura', 776.0000, 'ºC'),
	(187095, 122, '2014-02-01 00:56:47.000000', 'temperatura', 346.0000, 'ºC'),
	(187096, 122, '2014-02-01 00:56:48.000000', 'temperatura', 603.0000, 'ºC'),
	(187097, 122, '2014-02-01 00:56:49.000000', 'temperatura', 775.0000, 'ºC'),
	(187098, 122, '2014-02-01 00:56:50.000000', 'temperatura', 869.0000, 'ºC'),
	(187099, 122, '2014-02-01 00:56:51.000000', 'temperatura', 818.0000, 'ºC'),
	(187100, 122, '2014-02-01 00:56:52.000000', 'temperatura', 284.0000, 'ºC'),
	(187101, 122, '2014-02-01 00:56:53.000000', 'temperatura', 167.0000, 'ºC'),
	(187102, 122, '2014-02-01 00:56:54.000000', 'temperatura', 1184.0000, 'ºC'),
	(187103, 122, '2014-02-01 00:56:55.000000', 'temperatura', 621.0000, 'ºC'),
	(187104, 122, '2014-02-01 00:56:56.000000', 'temperatura', 751.0000, 'ºC'),
	(187105, 122, '2014-02-01 00:56:57.000000', 'temperatura', 693.0000, 'ºC'),
	(187106, 122, '2014-02-01 00:56:58.000000', 'temperatura', 15.0000, 'ºC'),
	(187107, 122, '2014-02-01 00:56:59.000000', 'temperatura', 393.0000, 'ºC'),
	(187108, 122, '2014-02-01 00:57:00.000000', 'temperatura', 722.0000, 'ºC'),
	(187109, 122, '2014-02-01 00:57:01.000000', 'temperatura', 33.0000, 'ºC'),
	(187110, 122, '2014-02-01 00:57:02.000000', 'temperatura', 400.0000, 'ºC'),
	(187111, 122, '2014-02-01 00:57:03.000000', 'temperatura', 700.0000, 'ºC'),
	(187112, 122, '2014-02-01 00:57:04.000000', 'temperatura', 1101.0000, 'ºC'),
	(187113, 122, '2014-02-01 00:57:05.000000', 'temperatura', 1006.0000, 'ºC'),
	(187114, 122, '2014-02-01 00:57:06.000000', 'temperatura', 528.0000, 'ºC'),
	(187115, 122, '2014-02-01 00:57:07.000000', 'temperatura', 821.0000, 'ºC'),
	(187116, 122, '2014-02-01 00:57:08.000000', 'temperatura', 124.0000, 'ºC'),
	(187117, 122, '2014-02-01 00:57:09.000000', 'temperatura', 555.0000, 'ºC'),
	(187118, 122, '2014-02-01 00:57:10.000000', 'temperatura', 4.0000, 'ºC'),
	(187119, 122, '2014-02-01 00:57:11.000000', 'temperatura', 757.0000, 'ºC'),
	(187120, 122, '2014-02-01 00:57:12.000000', 'temperatura', 175.0000, 'ºC'),
	(187121, 122, '2014-02-01 00:57:13.000000', 'temperatura', 1001.0000, 'ºC'),
	(187122, 122, '2014-02-01 00:57:14.000000', 'temperatura', 884.0000, 'ºC'),
	(187123, 122, '2014-02-01 00:57:15.000000', 'temperatura', 215.0000, 'ºC'),
	(187124, 122, '2014-02-01 00:57:16.000000', 'temperatura', 822.0000, 'ºC'),
	(187125, 122, '2014-02-01 00:57:17.000000', 'temperatura', 1068.0000, 'ºC'),
	(187126, 122, '2014-02-01 00:57:18.000000', 'temperatura', 476.0000, 'ºC'),
	(187127, 122, '2014-02-01 00:57:19.000000', 'temperatura', 375.0000, 'ºC'),
	(187128, 122, '2014-02-01 00:57:20.000000', 'temperatura', 446.0000, 'ºC'),
	(187129, 122, '2014-02-01 00:57:21.000000', 'temperatura', 1105.0000, 'ºC'),
	(187130, 122, '2014-02-01 00:57:22.000000', 'temperatura', 589.0000, 'ºC'),
	(187131, 122, '2014-02-01 00:57:23.000000', 'temperatura', 829.0000, 'ºC'),
	(187132, 122, '2014-02-01 00:57:24.000000', 'temperatura', 1178.0000, 'ºC'),
	(187133, 122, '2014-02-01 00:57:25.000000', 'temperatura', 1005.0000, 'ºC'),
	(187134, 122, '2014-02-01 00:57:26.000000', 'temperatura', 291.0000, 'ºC'),
	(187135, 122, '2014-02-01 00:57:27.000000', 'temperatura', 841.0000, 'ºC'),
	(187136, 122, '2014-02-01 00:57:28.000000', 'temperatura', 934.0000, 'ºC'),
	(187137, 122, '2014-02-01 00:57:29.000000', 'temperatura', 945.0000, 'ºC'),
	(187138, 122, '2014-02-01 00:57:30.000000', 'temperatura', 726.0000, 'ºC'),
	(187139, 122, '2014-02-01 00:57:31.000000', 'temperatura', 793.0000, 'ºC'),
	(187140, 122, '2014-02-01 00:57:32.000000', 'temperatura', 590.0000, 'ºC'),
	(187141, 122, '2014-02-01 00:57:33.000000', 'temperatura', 571.0000, 'ºC'),
	(187142, 122, '2014-02-01 00:57:34.000000', 'temperatura', 1085.0000, 'ºC'),
	(187143, 122, '2014-02-01 00:57:35.000000', 'temperatura', 111.0000, 'ºC'),
	(187144, 122, '2014-02-01 00:57:36.000000', 'temperatura', 901.0000, 'ºC'),
	(187145, 122, '2014-02-01 00:57:37.000000', 'temperatura', 574.0000, 'ºC'),
	(187146, 122, '2014-02-01 00:57:38.000000', 'temperatura', 165.0000, 'ºC'),
	(187147, 122, '2014-02-01 00:57:39.000000', 'temperatura', 305.0000, 'ºC'),
	(187148, 122, '2014-02-01 00:57:40.000000', 'temperatura', 1030.0000, 'ºC'),
	(187149, 122, '2014-02-01 00:57:41.000000', 'temperatura', 634.0000, 'ºC'),
	(187150, 122, '2014-02-01 00:57:42.000000', 'temperatura', 80.0000, 'ºC'),
	(187151, 122, '2014-02-01 00:57:43.000000', 'temperatura', 900.0000, 'ºC'),
	(187152, 122, '2014-02-01 00:57:44.000000', 'temperatura', 661.0000, 'ºC'),
	(187153, 122, '2014-02-01 00:57:45.000000', 'temperatura', 604.0000, 'ºC'),
	(187154, 122, '2014-02-01 00:57:46.000000', 'temperatura', 1038.0000, 'ºC'),
	(187155, 122, '2014-02-01 00:57:47.000000', 'temperatura', 978.0000, 'ºC'),
	(187156, 122, '2014-02-01 00:57:48.000000', 'temperatura', 576.0000, 'ºC'),
	(187157, 122, '2014-02-01 00:57:49.000000', 'temperatura', 1146.0000, 'ºC'),
	(187158, 122, '2014-02-01 00:57:50.000000', 'temperatura', 403.0000, 'ºC'),
	(187159, 122, '2014-02-01 00:57:51.000000', 'temperatura', 977.0000, 'ºC'),
	(187160, 122, '2014-02-01 00:57:52.000000', 'temperatura', 78.0000, 'ºC'),
	(187161, 122, '2014-02-01 00:57:53.000000', 'temperatura', 1057.0000, 'ºC'),
	(187162, 122, '2014-02-01 00:57:54.000000', 'temperatura', 252.0000, 'ºC'),
	(187163, 122, '2014-02-01 00:57:55.000000', 'temperatura', 492.0000, 'ºC'),
	(187164, 122, '2014-02-01 00:57:56.000000', 'temperatura', 504.0000, 'ºC'),
	(187165, 122, '2014-02-01 00:57:57.000000', 'temperatura', 1043.0000, 'ºC'),
	(187166, 122, '2014-02-01 00:57:58.000000', 'temperatura', 105.0000, 'ºC'),
	(187167, 122, '2014-02-01 00:57:59.000000', 'temperatura', 996.0000, 'ºC'),
	(187168, 122, '2014-02-01 00:58:00.000000', 'temperatura', 1066.0000, 'ºC'),
	(187169, 122, '2014-02-01 00:58:01.000000', 'temperatura', 1143.0000, 'ºC'),
	(187170, 122, '2014-02-01 00:58:02.000000', 'temperatura', 116.0000, 'ºC'),
	(187171, 122, '2014-02-01 00:58:03.000000', 'temperatura', 753.0000, 'ºC'),
	(187172, 122, '2014-02-01 00:58:04.000000', 'temperatura', 1019.0000, 'ºC'),
	(187173, 122, '2014-02-01 00:58:05.000000', 'temperatura', 435.0000, 'ºC'),
	(187174, 122, '2014-02-01 00:58:06.000000', 'temperatura', 318.0000, 'ºC'),
	(187175, 122, '2014-02-01 00:58:07.000000', 'temperatura', 287.0000, 'ºC'),
	(187176, 122, '2014-02-01 00:58:08.000000', 'temperatura', 483.0000, 'ºC'),
	(187177, 122, '2014-02-01 00:58:09.000000', 'temperatura', 352.0000, 'ºC'),
	(187178, 122, '2014-02-01 00:58:10.000000', 'temperatura', 312.0000, 'ºC'),
	(187179, 122, '2014-02-01 00:58:11.000000', 'temperatura', 505.0000, 'ºC'),
	(187180, 122, '2014-02-01 00:58:12.000000', 'temperatura', 388.0000, 'ºC'),
	(187181, 122, '2014-02-01 00:58:13.000000', 'temperatura', 426.0000, 'ºC'),
	(187182, 122, '2014-02-01 00:58:14.000000', 'temperatura', 966.0000, 'ºC'),
	(187183, 122, '2014-02-01 00:58:15.000000', 'temperatura', 1154.0000, 'ºC'),
	(187184, 122, '2014-02-01 00:58:16.000000', 'temperatura', 472.0000, 'ºC'),
	(187185, 122, '2014-02-01 00:58:17.000000', 'temperatura', 98.0000, 'ºC'),
	(187186, 122, '2014-02-01 00:58:18.000000', 'temperatura', 276.0000, 'ºC'),
	(187187, 122, '2014-02-01 00:58:19.000000', 'temperatura', 1086.0000, 'ºC'),
	(187188, 122, '2014-02-01 00:58:20.000000', 'temperatura', 1000.0000, 'ºC'),
	(187189, 122, '2014-02-01 00:58:21.000000', 'temperatura', 546.0000, 'ºC'),
	(187190, 122, '2014-02-01 00:58:22.000000', 'temperatura', 930.0000, 'ºC'),
	(187191, 122, '2014-02-01 00:58:23.000000', 'temperatura', 610.0000, 'ºC'),
	(187192, 122, '2014-02-01 00:58:24.000000', 'temperatura', 264.0000, 'ºC'),
	(187193, 122, '2014-02-01 00:58:25.000000', 'temperatura', 688.0000, 'ºC'),
	(187194, 122, '2014-02-01 00:58:26.000000', 'temperatura', 247.0000, 'ºC'),
	(187195, 122, '2014-02-01 00:58:27.000000', 'temperatura', 374.0000, 'ºC'),
	(187196, 122, '2014-02-01 00:58:28.000000', 'temperatura', 1129.0000, 'ºC'),
	(187197, 122, '2014-02-01 00:58:29.000000', 'temperatura', 923.0000, 'ºC'),
	(187198, 122, '2014-02-01 00:58:30.000000', 'temperatura', 28.0000, 'ºC'),
	(187199, 122, '2014-02-01 00:58:31.000000', 'temperatura', 973.0000, 'ºC'),
	(187200, 122, '2014-02-01 00:58:32.000000', 'temperatura', 1182.0000, 'ºC'),
	(187201, 122, '2014-02-01 00:58:33.000000', 'temperatura', 589.0000, 'ºC'),
	(187202, 122, '2014-02-01 00:58:34.000000', 'temperatura', 600.0000, 'ºC'),
	(187203, 122, '2014-02-01 00:58:35.000000', 'temperatura', 32.0000, 'ºC'),
	(187204, 122, '2014-02-01 00:58:36.000000', 'temperatura', 763.0000, 'ºC'),
	(187205, 122, '2014-02-01 00:58:37.000000', 'temperatura', 121.0000, 'ºC'),
	(187206, 122, '2014-02-01 00:58:38.000000', 'temperatura', 713.0000, 'ºC'),
	(187207, 122, '2014-02-01 00:58:39.000000', 'temperatura', 804.0000, 'ºC'),
	(187208, 122, '2014-02-01 00:58:40.000000', 'temperatura', 681.0000, 'ºC'),
	(187209, 122, '2014-02-01 00:58:41.000000', 'temperatura', 993.0000, 'ºC'),
	(187210, 122, '2014-02-01 00:58:42.000000', 'temperatura', 525.0000, 'ºC'),
	(187211, 122, '2014-02-01 00:58:43.000000', 'temperatura', 843.0000, 'ºC'),
	(187212, 122, '2014-02-01 00:58:44.000000', 'temperatura', 242.0000, 'ºC'),
	(187213, 122, '2014-02-01 00:58:45.000000', 'temperatura', 1083.0000, 'ºC'),
	(187214, 122, '2014-02-01 00:58:46.000000', 'temperatura', 1089.0000, 'ºC'),
	(187215, 122, '2014-02-01 00:58:47.000000', 'temperatura', 998.0000, 'ºC'),
	(187216, 122, '2014-02-01 00:58:48.000000', 'temperatura', 521.0000, 'ºC'),
	(187217, 122, '2014-02-01 00:58:49.000000', 'temperatura', 812.0000, 'ºC'),
	(187218, 122, '2014-02-01 00:58:50.000000', 'temperatura', 97.0000, 'ºC'),
	(187219, 122, '2014-02-01 00:58:51.000000', 'temperatura', 450.0000, 'ºC'),
	(187220, 122, '2014-02-01 00:58:52.000000', 'temperatura', 761.0000, 'ºC'),
	(187221, 122, '2014-02-01 00:58:53.000000', 'temperatura', 53.0000, 'ºC'),
	(187222, 122, '2014-02-01 00:58:54.000000', 'temperatura', 382.0000, 'ºC'),
	(187223, 122, '2014-02-01 00:58:55.000000', 'temperatura', 554.0000, 'ºC'),
	(187224, 122, '2014-02-01 00:58:56.000000', 'temperatura', 423.0000, 'ºC'),
	(187225, 122, '2014-02-01 00:58:57.000000', 'temperatura', 455.0000, 'ºC'),
	(187226, 122, '2014-02-01 00:58:58.000000', 'temperatura', 1005.0000, 'ºC'),
	(187227, 122, '2014-02-01 00:58:59.000000', 'temperatura', 61.0000, 'ºC'),
	(187228, 122, '2014-02-01 00:59:00.000000', 'temperatura', 889.0000, 'ºC'),
	(187229, 122, '2014-02-01 00:59:01.000000', 'temperatura', 662.0000, 'ºC'),
	(187230, 122, '2014-02-01 00:59:02.000000', 'temperatura', 646.0000, 'ºC'),
	(187231, 122, '2014-02-01 00:59:03.000000', 'temperatura', 44.0000, 'ºC'),
	(187232, 122, '2014-02-01 00:59:04.000000', 'temperatura', 683.0000, 'ºC'),
	(187233, 122, '2014-02-01 00:59:05.000000', 'temperatura', 881.0000, 'ºC'),
	(187234, 122, '2014-02-01 00:59:06.000000', 'temperatura', 1158.0000, 'ºC'),
	(187235, 122, '2014-02-01 00:59:07.000000', 'temperatura', 749.0000, 'ºC'),
	(187236, 122, '2014-02-01 00:59:08.000000', 'temperatura', 271.0000, 'ºC'),
	(187237, 122, '2014-02-01 00:59:09.000000', 'temperatura', 306.0000, 'ºC'),
	(187238, 122, '2014-02-01 00:59:10.000000', 'temperatura', 720.0000, 'ºC'),
	(187239, 122, '2014-02-01 00:59:11.000000', 'temperatura', 282.0000, 'ºC'),
	(187240, 122, '2014-02-01 00:59:12.000000', 'temperatura', 449.0000, 'ºC'),
	(187241, 122, '2014-02-01 00:59:13.000000', 'temperatura', 200.0000, 'ºC'),
	(187242, 122, '2014-02-01 00:59:14.000000', 'temperatura', 856.0000, 'ºC'),
	(187243, 122, '2014-02-01 00:59:15.000000', 'temperatura', 78.0000, 'ºC'),
	(187244, 122, '2014-02-01 00:59:16.000000', 'temperatura', 221.0000, 'ºC'),
	(187245, 122, '2014-02-01 00:59:17.000000', 'temperatura', 875.0000, 'ºC'),
	(187246, 122, '2014-02-01 00:59:18.000000', 'temperatura', 110.0000, 'ºC'),
	(187247, 122, '2014-02-01 00:59:19.000000', 'temperatura', 328.0000, 'ºC'),
	(187248, 122, '2014-02-01 00:59:20.000000', 'temperatura', 110.0000, 'ºC'),
	(187249, 122, '2014-02-01 00:59:21.000000', 'temperatura', 764.0000, 'ºC'),
	(187250, 122, '2014-02-01 00:59:22.000000', 'temperatura', 1094.0000, 'ºC'),
	(187251, 122, '2014-02-01 00:59:23.000000', 'temperatura', 776.0000, 'ºC'),
	(187252, 122, '2014-02-01 00:59:24.000000', 'temperatura', 598.0000, 'ºC'),
	(187253, 122, '2014-02-01 00:59:25.000000', 'temperatura', 665.0000, 'ºC'),
	(187254, 122, '2014-02-01 00:59:26.000000', 'temperatura', 330.0000, 'ºC'),
	(187255, 122, '2014-02-01 00:59:27.000000', 'temperatura', 858.0000, 'ºC'),
	(187256, 122, '2014-02-01 00:59:28.000000', 'temperatura', 897.0000, 'ºC'),
	(187257, 122, '2014-02-01 00:59:29.000000', 'temperatura', 715.0000, 'ºC'),
	(187258, 122, '2014-02-01 00:59:30.000000', 'temperatura', 883.0000, 'ºC'),
	(187259, 122, '2014-02-01 00:59:31.000000', 'temperatura', 1070.0000, 'ºC'),
	(187260, 122, '2014-02-01 00:59:32.000000', 'temperatura', 302.0000, 'ºC'),
	(187261, 122, '2014-02-01 00:59:33.000000', 'temperatura', 701.0000, 'ºC'),
	(187262, 122, '2014-02-01 00:59:34.000000', 'temperatura', 198.0000, 'ºC'),
	(187263, 122, '2014-02-01 00:59:35.000000', 'temperatura', 87.0000, 'ºC'),
	(187264, 122, '2014-02-01 00:59:36.000000', 'temperatura', 1042.0000, 'ºC'),
	(187265, 122, '2014-02-01 00:59:37.000000', 'temperatura', 149.0000, 'ºC'),
	(187266, 122, '2014-02-01 00:59:38.000000', 'temperatura', 22.0000, 'ºC'),
	(187267, 122, '2014-02-01 00:59:39.000000', 'temperatura', 861.0000, 'ºC'),
	(187268, 122, '2014-02-01 00:59:40.000000', 'temperatura', 641.0000, 'ºC'),
	(187269, 122, '2014-02-01 00:59:41.000000', 'temperatura', 622.0000, 'ºC'),
	(187270, 122, '2014-02-01 00:59:42.000000', 'temperatura', 1187.0000, 'ºC'),
	(187271, 122, '2014-02-01 00:59:43.000000', 'temperatura', 471.0000, 'ºC'),
	(187272, 122, '2014-02-01 00:59:44.000000', 'temperatura', 1195.0000, 'ºC'),
	(187273, 122, '2014-02-01 00:59:45.000000', 'temperatura', 961.0000, 'ºC'),
	(187274, 122, '2014-02-01 00:59:46.000000', 'temperatura', 20.0000, 'ºC'),
	(187275, 122, '2014-02-01 00:59:47.000000', 'temperatura', 818.0000, 'ºC'),
	(187276, 122, '2014-02-01 00:59:48.000000', 'temperatura', 429.0000, 'ºC'),
	(187277, 122, '2014-02-01 00:59:49.000000', 'temperatura', 893.0000, 'ºC'),
	(187278, 122, '2014-02-01 00:59:50.000000', 'temperatura', 778.0000, 'ºC'),
	(187279, 122, '2014-02-01 00:59:51.000000', 'temperatura', 10.0000, 'ºC'),
	(187280, 122, '2014-02-01 00:59:52.000000', 'temperatura', 116.0000, 'ºC'),
	(187281, 122, '2014-02-01 00:59:53.000000', 'temperatura', 554.0000, 'ºC'),
	(187282, 122, '2014-02-01 00:59:54.000000', 'temperatura', 20.0000, 'ºC'),
	(187283, 122, '2014-02-01 00:59:55.000000', 'temperatura', 839.0000, 'ºC'),
	(187284, 122, '2014-02-01 00:59:56.000000', 'temperatura', 535.0000, 'ºC'),
	(187285, 122, '2014-02-01 00:59:57.000000', 'temperatura', 159.0000, 'ºC'),
	(187286, 122, '2014-02-01 00:59:58.000000', 'temperatura', 390.0000, 'ºC'),
	(187287, 122, '2014-02-01 00:59:59.000000', 'temperatura', 274.0000, 'ºC'),
	(187288, 122, '2014-02-01 01:00:00.000000', 'temperatura', 201.0000, 'ºC'),
	(187289, 122, '2014-02-01 01:00:01.000000', 'temperatura', 182.0000, 'ºC'),
	(187290, 122, '2014-02-01 01:00:02.000000', 'temperatura', 307.0000, 'ºC'),
	(187291, 122, '2014-02-01 01:00:03.000000', 'temperatura', 992.0000, 'ºC'),
	(187292, 122, '2014-02-01 01:00:04.000000', 'temperatura', 440.0000, 'ºC'),
	(187293, 122, '2014-02-01 01:00:05.000000', 'temperatura', 422.0000, 'ºC'),
	(187294, 122, '2014-02-01 01:00:06.000000', 'temperatura', 789.0000, 'ºC'),
	(187295, 122, '2014-02-01 01:00:07.000000', 'temperatura', 283.0000, 'ºC'),
	(187296, 122, '2014-02-01 01:00:08.000000', 'temperatura', 246.0000, 'ºC'),
	(187297, 122, '2014-02-01 01:00:09.000000', 'temperatura', 383.0000, 'ºC'),
	(187298, 122, '2014-02-01 01:00:10.000000', 'temperatura', 1178.0000, 'ºC'),
	(187299, 122, '2014-02-01 01:00:11.000000', 'temperatura', 1142.0000, 'ºC'),
	(187300, 122, '2014-02-01 01:00:12.000000', 'temperatura', 976.0000, 'ºC'),
	(187301, 122, '2014-02-01 01:00:13.000000', 'temperatura', 253.0000, 'ºC'),
	(187302, 122, '2014-02-01 01:00:14.000000', 'temperatura', 736.0000, 'ºC'),
	(187303, 122, '2014-02-01 01:00:15.000000', 'temperatura', 525.0000, 'ºC'),
	(187304, 122, '2014-02-01 01:00:16.000000', 'temperatura', 417.0000, 'ºC'),
	(187305, 122, '2014-02-01 01:00:17.000000', 'temperatura', 510.0000, 'ºC'),
	(187306, 122, '2014-02-01 01:00:18.000000', 'temperatura', 100.0000, 'ºC'),
	(187307, 122, '2014-02-01 01:00:19.000000', 'temperatura', 172.0000, 'ºC'),
	(187308, 122, '2014-02-01 01:00:20.000000', 'temperatura', 558.0000, 'ºC'),
	(187309, 122, '2014-02-01 01:00:21.000000', 'temperatura', 1077.0000, 'ºC'),
	(187310, 122, '2014-02-01 01:00:22.000000', 'temperatura', 108.0000, 'ºC'),
	(187311, 122, '2014-02-01 01:00:23.000000', 'temperatura', 913.0000, 'ºC'),
	(187312, 122, '2014-02-01 01:00:24.000000', 'temperatura', 641.0000, 'ºC'),
	(187313, 122, '2014-02-01 01:00:25.000000', 'temperatura', 466.0000, 'ºC'),
	(187314, 122, '2014-02-01 01:00:26.000000', 'temperatura', 409.0000, 'ºC'),
	(187315, 122, '2014-02-01 01:00:27.000000', 'temperatura', 646.0000, 'ºC'),
	(187316, 122, '2014-02-01 01:00:28.000000', 'temperatura', 802.0000, 'ºC'),
	(187317, 122, '2014-02-01 01:00:29.000000', 'temperatura', 875.0000, 'ºC'),
	(187318, 122, '2014-02-01 01:00:30.000000', 'temperatura', 769.0000, 'ºC'),
	(187319, 122, '2014-02-01 01:00:31.000000', 'temperatura', 22.0000, 'ºC'),
	(187320, 122, '2014-02-01 01:00:32.000000', 'temperatura', 203.0000, 'ºC'),
	(187321, 122, '2014-02-01 01:00:33.000000', 'temperatura', 950.0000, 'ºC'),
	(187322, 122, '2014-02-01 01:00:34.000000', 'temperatura', 542.0000, 'ºC'),
	(187323, 122, '2014-02-01 01:00:35.000000', 'temperatura', 1058.0000, 'ºC'),
	(187324, 122, '2014-02-01 01:00:36.000000', 'temperatura', 67.0000, 'ºC'),
	(187325, 122, '2014-02-01 01:00:37.000000', 'temperatura', 761.0000, 'ºC'),
	(187326, 122, '2014-02-01 01:00:38.000000', 'temperatura', 3.0000, 'ºC'),
	(187327, 122, '2014-02-01 01:00:39.000000', 'temperatura', 134.0000, 'ºC'),
	(187328, 122, '2014-02-01 01:00:40.000000', 'temperatura', 660.0000, 'ºC'),
	(187329, 122, '2014-02-01 01:00:41.000000', 'temperatura', 499.0000, 'ºC'),
	(187330, 122, '2014-02-01 01:00:42.000000', 'temperatura', 517.0000, 'ºC'),
	(187331, 122, '2014-02-01 01:00:43.000000', 'temperatura', 1086.0000, 'ºC'),
	(187332, 122, '2014-02-01 01:00:44.000000', 'temperatura', 278.0000, 'ºC'),
	(187333, 122, '2014-02-01 01:00:45.000000', 'temperatura', 536.0000, 'ºC'),
	(187334, 122, '2014-02-01 01:00:46.000000', 'temperatura', 647.0000, 'ºC'),
	(187335, 122, '2014-02-01 01:00:47.000000', 'temperatura', 425.0000, 'ºC'),
	(187336, 122, '2014-02-01 01:00:48.000000', 'temperatura', 183.0000, 'ºC'),
	(187337, 122, '2014-02-01 01:00:49.000000', 'temperatura', 844.0000, 'ºC'),
	(187338, 122, '2014-02-01 01:00:50.000000', 'temperatura', 70.0000, 'ºC'),
	(187339, 122, '2014-02-01 01:00:51.000000', 'temperatura', 217.0000, 'ºC'),
	(187340, 122, '2014-02-01 01:00:52.000000', 'temperatura', 875.0000, 'ºC'),
	(187341, 122, '2014-02-01 01:00:53.000000', 'temperatura', 124.0000, 'ºC'),
	(187342, 122, '2014-02-01 01:00:54.000000', 'temperatura', 397.0000, 'ºC'),
	(187343, 122, '2014-02-01 01:00:55.000000', 'temperatura', 413.0000, 'ºC'),
	(187344, 122, '2014-02-01 01:00:56.000000', 'temperatura', 877.0000, 'ºC'),
	(187345, 122, '2014-02-01 01:00:57.000000', 'temperatura', 743.0000, 'ºC'),
	(187346, 122, '2014-02-01 01:00:58.000000', 'temperatura', 1086.0000, 'ºC'),
	(187347, 122, '2014-02-01 01:00:59.000000', 'temperatura', 800.0000, 'ºC'),
	(187348, 122, '2014-02-01 01:01:00.000000', 'temperatura', 742.0000, 'ºC'),
	(187349, 122, '2014-02-01 01:01:01.000000', 'temperatura', 112.0000, 'ºC'),
	(187350, 122, '2014-02-01 01:01:02.000000', 'temperatura', 733.0000, 'ºC'),
	(187351, 122, '2014-02-01 01:01:03.000000', 'temperatura', 929.0000, 'ºC'),
	(187352, 122, '2014-02-01 01:01:04.000000', 'temperatura', 49.0000, 'ºC'),
	(187353, 122, '2014-02-01 01:01:05.000000', 'temperatura', 1059.0000, 'ºC'),
	(187354, 122, '2014-02-01 01:01:06.000000', 'temperatura', 349.0000, 'ºC'),
	(187355, 122, '2014-02-01 01:01:07.000000', 'temperatura', 966.0000, 'ºC'),
	(187356, 122, '2014-02-01 01:01:08.000000', 'temperatura', 182.0000, 'ºC'),
	(187357, 122, '2014-02-01 01:01:09.000000', 'temperatura', 416.0000, 'ºC'),
	(187358, 122, '2014-02-01 01:01:10.000000', 'temperatura', 334.0000, 'ºC'),
	(187359, 122, '2014-02-01 01:01:11.000000', 'temperatura', 422.0000, 'ºC'),
	(187360, 122, '2014-02-01 01:01:12.000000', 'temperatura', 1109.0000, 'ºC'),
	(187361, 122, '2014-02-01 01:01:13.000000', 'temperatura', 681.0000, 'ºC'),
	(187362, 122, '2014-02-01 01:01:14.000000', 'temperatura', 77.0000, 'ºC'),
	(187363, 122, '2014-02-01 01:01:15.000000', 'temperatura', 741.0000, 'ºC'),
	(187364, 122, '2014-02-01 01:01:16.000000', 'temperatura', 1078.0000, 'ºC'),
	(187365, 122, '2014-02-01 01:01:17.000000', 'temperatura', 765.0000, 'ºC'),
	(187366, 122, '2014-02-01 01:01:18.000000', 'temperatura', 591.0000, 'ºC'),
	(187367, 122, '2014-02-01 01:01:19.000000', 'temperatura', 661.0000, 'ºC'),
	(187368, 122, '2014-02-01 01:01:20.000000', 'temperatura', 334.0000, 'ºC'),
	(187369, 122, '2014-02-01 01:01:21.000000', 'temperatura', 886.0000, 'ºC'),
	(187370, 122, '2014-02-01 01:01:22.000000', 'temperatura', 1031.0000, 'ºC'),
	(187371, 122, '2014-02-01 01:01:23.000000', 'temperatura', 94.0000, 'ºC'),
	(187372, 122, '2014-02-01 01:01:24.000000', 'temperatura', 979.0000, 'ºC'),
	(187373, 122, '2014-02-01 01:01:25.000000', 'temperatura', 1013.0000, 'ºC'),
	(187374, 122, '2014-02-01 01:01:26.000000', 'temperatura', 931.0000, 'ºC'),
	(187375, 122, '2014-02-01 01:01:27.000000', 'temperatura', 414.0000, 'ºC'),
	(187376, 122, '2014-02-01 01:01:28.000000', 'temperatura', 476.0000, 'ºC'),
	(187377, 122, '2014-02-01 01:01:29.000000', 'temperatura', 1142.0000, 'ºC'),
	(187378, 122, '2014-02-01 01:01:30.000000', 'temperatura', 680.0000, 'ºC'),
	(187379, 122, '2014-02-01 01:01:31.000000', 'temperatura', 1175.0000, 'ºC'),
	(187380, 122, '2014-02-01 01:01:32.000000', 'temperatura', 235.0000, 'ºC'),
	(187381, 122, '2014-02-01 01:01:33.000000', 'temperatura', 51.0000, 'ºC'),
	(187382, 122, '2014-02-01 01:01:34.000000', 'temperatura', 752.0000, 'ºC'),
	(187383, 122, '2014-02-01 01:01:35.000000', 'temperatura', 6.0000, 'ºC'),
	(187384, 122, '2014-02-01 01:01:36.000000', 'temperatura', 174.0000, 'ºC'),
	(187385, 122, '2014-02-01 01:01:37.000000', 'temperatura', 853.0000, 'ºC'),
	(187386, 122, '2014-02-01 01:01:38.000000', 'temperatura', 146.0000, 'ºC'),
	(187387, 122, '2014-02-01 01:01:39.000000', 'temperatura', 568.0000, 'ºC'),
	(187388, 122, '2014-02-01 01:01:40.000000', 'temperatura', 6.0000, 'ºC'),
	(187389, 122, '2014-02-01 01:01:41.000000', 'temperatura', 724.0000, 'ºC'),
	(187390, 122, '2014-02-01 01:01:42.000000', 'temperatura', 4.0000, 'ºC'),
	(187391, 122, '2014-02-01 01:01:43.000000', 'temperatura', 248.0000, 'ºC'),
	(187392, 122, '2014-02-01 01:01:44.000000', 'temperatura', 27.0000, 'ºC'),
	(187393, 122, '2014-02-01 01:01:45.000000', 'temperatura', 594.0000, 'ºC'),
	(187394, 122, '2014-02-01 01:01:46.000000', 'temperatura', 488.0000, 'ºC'),
	(187395, 122, '2014-02-01 01:01:47.000000', 'temperatura', 659.0000, 'ºC'),
	(187396, 122, '2014-02-01 01:01:48.000000', 'temperatura', 633.0000, 'ºC'),
	(187397, 122, '2014-02-01 01:01:49.000000', 'temperatura', 1186.0000, 'ºC'),
	(187398, 122, '2014-02-01 01:01:50.000000', 'temperatura', 432.0000, 'ºC'),
	(187399, 122, '2014-02-01 01:01:51.000000', 'temperatura', 1002.0000, 'ºC'),
	(187400, 122, '2014-02-01 01:01:52.000000', 'temperatura', 114.0000, 'ºC'),
	(187401, 122, '2014-02-01 01:01:53.000000', 'temperatura', 1167.0000, 'ºC'),
	(187402, 122, '2014-02-01 01:01:54.000000', 'temperatura', 690.0000, 'ºC'),
	(187403, 122, '2014-02-01 01:01:55.000000', 'temperatura', 1153.0000, 'ºC'),
	(187404, 122, '2014-02-01 01:01:56.000000', 'temperatura', 93.0000, 'ºC'),
	(187405, 122, '2014-02-01 01:01:57.000000', 'temperatura', 609.0000, 'ºC'),
	(187406, 122, '2014-02-01 01:01:58.000000', 'temperatura', 366.0000, 'ºC'),
	(187407, 122, '2014-02-01 01:01:59.000000', 'temperatura', 1.0000, 'ºC'),
	(187408, 122, '2014-02-01 01:02:00.000000', 'temperatura', 111.0000, 'ºC'),
	(187409, 122, '2014-02-01 01:02:01.000000', 'temperatura', 551.0000, 'ºC'),
	(187410, 122, '2014-02-01 01:02:02.000000', 'temperatura', 23.0000, 'ºC'),
	(187411, 122, '2014-02-01 01:02:03.000000', 'temperatura', 863.0000, 'ºC'),
	(187412, 122, '2014-02-01 01:02:04.000000', 'temperatura', 644.0000, 'ºC'),
	(187413, 122, '2014-02-01 01:02:05.000000', 'temperatura', 634.0000, 'ºC'),
	(187414, 122, '2014-02-01 01:02:06.000000', 'temperatura', 37.0000, 'ºC'),
	(187415, 122, '2014-02-01 01:02:07.000000', 'temperatura', 684.0000, 'ºC'),
	(187416, 122, '2014-02-01 01:02:08.000000', 'temperatura', 908.0000, 'ºC'),
	(187417, 122, '2014-02-01 01:02:09.000000', 'temperatura', 90.0000, 'ºC'),
	(187418, 122, '2014-02-01 01:02:10.000000', 'temperatura', 126.0000, 'ºC'),
	(187419, 122, '2014-02-01 01:02:11.000000', 'temperatura', 362.0000, 'ºC'),
	(187420, 122, '2014-02-01 01:02:12.000000', 'temperatura', 230.0000, 'ºC'),
	(187421, 122, '2014-02-01 01:02:13.000000', 'temperatura', 66.0000, 'ºC'),
	(187422, 122, '2014-02-01 01:02:14.000000', 'temperatura', 840.0000, 'ºC'),
	(187423, 122, '2014-02-01 01:02:15.000000', 'temperatura', 403.0000, 'ºC'),
	(187424, 122, '2014-02-01 01:02:16.000000', 'temperatura', 696.0000, 'ºC'),
	(187425, 122, '2014-02-01 01:02:17.000000', 'temperatura', 1069.0000, 'ºC'),
	(187426, 122, '2014-02-01 01:02:18.000000', 'temperatura', 860.0000, 'ºC'),
	(187427, 122, '2014-02-01 01:02:19.000000', 'temperatura', 1095.0000, 'ºC'),
	(187428, 122, '2014-02-01 01:02:20.000000', 'temperatura', 493.0000, 'ºC'),
	(187429, 122, '2014-02-01 01:02:21.000000', 'temperatura', 380.0000, 'ºC'),
	(187430, 122, '2014-02-01 01:02:22.000000', 'temperatura', 421.0000, 'ºC'),
	(187431, 122, '2014-02-01 01:02:23.000000', 'temperatura', 967.0000, 'ºC'),
	(187432, 122, '2014-02-01 01:02:24.000000', 'temperatura', 1172.0000, 'ºC'),
	(187433, 122, '2014-02-01 01:02:25.000000', 'temperatura', 561.0000, 'ºC'),
	(187434, 122, '2014-02-01 01:02:26.000000', 'temperatura', 491.0000, 'ºC'),
	(187435, 122, '2014-02-01 01:02:27.000000', 'temperatura', 769.0000, 'ºC'),
	(187436, 122, '2014-02-01 01:02:28.000000', 'temperatura', 1174.0000, 'ºC'),
	(187437, 122, '2014-02-01 01:02:29.000000', 'temperatura', 1164.0000, 'ºC'),
	(187438, 122, '2014-02-01 01:02:30.000000', 'temperatura', 1100.0000, 'ºC'),
	(187439, 122, '2014-02-01 01:02:31.000000', 'temperatura', 807.0000, 'ºC'),
	(187440, 122, '2014-02-01 01:02:32.000000', 'temperatura', 735.0000, 'ºC'),
	(187441, 122, '2014-02-01 01:02:33.000000', 'temperatura', 55.0000, 'ºC'),
	(187442, 122, '2014-02-01 01:02:34.000000', 'temperatura', 472.0000, 'ºC'),
	(187443, 122, '2014-02-01 01:02:35.000000', 'temperatura', 995.0000, 'ºC'),
	(187444, 122, '2014-02-01 01:02:36.000000', 'temperatura', 1158.0000, 'ºC'),
	(187445, 122, '2014-02-01 01:02:37.000000', 'temperatura', 407.0000, 'ºC'),
	(187446, 122, '2014-02-01 01:02:38.000000', 'temperatura', 960.0000, 'ºC'),
	(187447, 122, '2014-02-01 01:02:39.000000', 'temperatura', 1179.0000, 'ºC'),
	(187448, 122, '2014-02-01 01:02:40.000000', 'temperatura', 618.0000, 'ºC'),
	(187449, 122, '2014-02-01 01:02:41.000000', 'temperatura', 754.0000, 'ºC'),
	(187450, 122, '2014-02-01 01:02:42.000000', 'temperatura', 715.0000, 'ºC'),
	(187451, 122, '2014-02-01 01:02:43.000000', 'temperatura', 116.0000, 'ºC'),
	(187452, 122, '2014-02-01 01:02:44.000000', 'temperatura', 833.0000, 'ºC'),
	(187453, 122, '2014-02-01 01:02:45.000000', 'temperatura', 218.0000, 'ºC'),
	(187454, 122, '2014-02-01 01:02:46.000000', 'temperatura', 991.0000, 'ºC'),
	(187455, 122, '2014-02-01 01:02:47.000000', 'temperatura', 701.0000, 'ºC'),
	(187456, 122, '2014-02-01 01:02:48.000000', 'temperatura', 532.0000, 'ºC'),
	(187457, 122, '2014-02-01 01:02:49.000000', 'temperatura', 560.0000, 'ºC'),
	(187458, 122, '2014-02-01 01:02:50.000000', 'temperatura', 3.0000, 'ºC'),
	(187459, 122, '2014-02-01 01:02:51.000000', 'temperatura', 735.0000, 'ºC'),
	(187460, 122, '2014-02-01 01:02:52.000000', 'temperatura', 66.0000, 'ºC'),
	(187461, 122, '2014-02-01 01:02:53.000000', 'temperatura', 525.0000, 'ºC'),
	(187462, 122, '2014-02-01 01:02:54.000000', 'temperatura', 27.0000, 'ºC'),
	(187463, 122, '2014-02-01 01:02:55.000000', 'temperatura', 963.0000, 'ºC'),
	(187464, 122, '2014-02-01 01:02:56.000000', 'temperatura', 1135.0000, 'ºC'),
	(187465, 122, '2014-02-01 01:02:57.000000', 'temperatura', 387.0000, 'ºC'),
	(187466, 122, '2014-02-01 01:02:58.000000', 'temperatura', 929.0000, 'ºC'),
	(187467, 122, '2014-02-01 01:02:59.000000', 'temperatura', 1083.0000, 'ºC'),
	(187468, 122, '2014-02-01 01:03:00.000000', 'temperatura', 232.0000, 'ºC'),
	(187469, 122, '2014-02-01 01:03:01.000000', 'temperatura', 308.0000, 'ºC'),
	(187470, 122, '2014-02-01 01:03:02.000000', 'temperatura', 846.0000, 'ºC'),
	(187471, 122, '2014-02-01 01:03:03.000000', 'temperatura', 908.0000, 'ºC'),
	(187472, 122, '2014-02-01 01:03:04.000000', 'temperatura', 800.0000, 'ºC'),
	(187473, 122, '2014-02-01 01:03:05.000000', 'temperatura', 78.0000, 'ºC'),
	(187474, 122, '2014-02-01 01:03:06.000000', 'temperatura', 392.0000, 'ºC'),
	(187475, 122, '2014-02-01 01:03:07.000000', 'temperatura', 525.0000, 'ºC'),
	(187476, 122, '2014-02-01 01:03:08.000000', 'temperatura', 251.0000, 'ºC'),
	(187477, 122, '2014-02-01 01:03:09.000000', 'temperatura', 881.0000, 'ºC'),
	(187478, 122, '2014-02-01 01:03:10.000000', 'temperatura', 51.0000, 'ºC'),
	(187479, 122, '2014-02-01 01:03:11.000000', 'temperatura', 14.0000, 'ºC'),
	(187480, 122, '2014-02-01 01:03:12.000000', 'temperatura', 1119.0000, 'ºC'),
	(187481, 122, '2014-02-01 01:03:13.000000', 'temperatura', 751.0000, 'ºC'),
	(187482, 122, '2014-02-01 01:03:14.000000', 'temperatura', 398.0000, 'ºC'),
	(187483, 122, '2014-02-01 01:03:15.000000', 'temperatura', 938.0000, 'ºC'),
	(187484, 122, '2014-02-01 01:03:16.000000', 'temperatura', 1095.0000, 'ºC'),
	(187485, 122, '2014-02-01 01:03:17.000000', 'temperatura', 261.0000, 'ºC'),
	(187486, 122, '2014-02-01 01:03:18.000000', 'temperatura', 423.0000, 'ºC'),
	(187487, 122, '2014-02-01 01:03:19.000000', 'temperatura', 134.0000, 'ºC'),
	(187488, 122, '2014-02-01 01:03:20.000000', 'temperatura', 598.0000, 'ºC'),
	(187489, 122, '2014-02-01 01:03:21.000000', 'temperatura', 190.0000, 'ºC'),
	(187490, 122, '2014-02-01 01:03:22.000000', 'temperatura', 356.0000, 'ºC'),
	(187491, 122, '2014-02-01 01:03:23.000000', 'temperatura', 10.0000, 'ºC'),
	(187492, 122, '2014-02-01 01:03:24.000000', 'temperatura', 184.0000, 'ºC'),
	(187493, 122, '2014-02-01 01:03:25.000000', 'temperatura', 889.0000, 'ºC'),
	(187494, 122, '2014-02-01 01:03:26.000000', 'temperatura', 296.0000, 'ºC'),
	(187495, 122, '2014-02-01 01:03:27.000000', 'temperatura', 12.0000, 'ºC'),
	(187496, 122, '2014-02-01 01:03:28.000000', 'temperatura', 372.0000, 'ºC'),
	(187497, 122, '2014-02-01 01:03:29.000000', 'temperatura', 627.0000, 'ºC'),
	(187498, 122, '2014-02-01 01:03:30.000000', 'temperatura', 817.0000, 'ºC'),
	(187499, 122, '2014-02-01 01:03:31.000000', 'temperatura', 1005.0000, 'ºC'),
	(187500, 122, '2014-02-01 01:03:32.000000', 'temperatura', 173.0000, 'ºC'),
	(187501, 122, '2014-02-01 01:03:33.000000', 'temperatura', 252.0000, 'ºC'),
	(187502, 122, '2014-02-01 01:03:34.000000', 'temperatura', 740.0000, 'ºC'),
	(187503, 122, '2014-02-01 01:03:35.000000', 'temperatura', 544.0000, 'ºC'),
	(187504, 122, '2014-02-01 01:03:36.000000', 'temperatura', 500.0000, 'ºC'),
	(187505, 122, '2014-02-01 01:03:37.000000', 'temperatura', 870.0000, 'ºC'),
	(187506, 122, '2014-02-01 01:03:38.000000', 'temperatura', 449.0000, 'ºC'),
	(187507, 122, '2014-02-01 01:03:39.000000', 'temperatura', 837.0000, 'ºC'),
	(187508, 122, '2014-02-01 01:03:40.000000', 'temperatura', 437.0000, 'ºC'),
	(187509, 122, '2014-02-01 01:03:41.000000', 'temperatura', 874.0000, 'ºC'),
	(187510, 122, '2014-02-01 01:03:42.000000', 'temperatura', 660.0000, 'ºC'),
	(187511, 122, '2014-02-01 01:03:43.000000', 'temperatura', 681.0000, 'ºC'),
	(187512, 122, '2014-02-01 01:03:44.000000', 'temperatura', 223.0000, 'ºC'),
	(187513, 122, '2014-02-01 01:03:45.000000', 'temperatura', 275.0000, 'ºC'),
	(187514, 122, '2014-02-01 01:03:46.000000', 'temperatura', 706.0000, 'ºC'),
	(187515, 122, '2014-02-01 01:03:47.000000', 'temperatura', 303.0000, 'ºC'),
	(187516, 122, '2014-02-01 01:03:48.000000', 'temperatura', 600.0000, 'ºC'),
	(187517, 122, '2014-02-01 01:03:49.000000', 'temperatura', 893.0000, 'ºC'),
	(187518, 122, '2014-02-01 01:03:50.000000', 'temperatura', 262.0000, 'ºC'),
	(187519, 122, '2014-02-01 01:03:51.000000', 'temperatura', 1034.0000, 'ºC'),
	(187520, 122, '2014-02-01 01:03:52.000000', 'temperatura', 785.0000, 'ºC'),
	(187521, 122, '2014-02-01 01:03:53.000000', 'temperatura', 823.0000, 'ºC'),
	(187522, 122, '2014-02-01 01:03:54.000000', 'temperatura', 559.0000, 'ºC'),
	(187523, 122, '2014-02-01 01:03:55.000000', 'temperatura', 329.0000, 'ºC'),
	(187524, 122, '2014-02-01 01:03:56.000000', 'temperatura', 1166.0000, 'ºC'),
	(187525, 122, '2014-02-01 01:03:57.000000', 'temperatura', 45.0000, 'ºC'),
	(187526, 122, '2014-02-01 01:03:58.000000', 'temperatura', 329.0000, 'ºC'),
	(187527, 122, '2014-02-01 01:03:59.000000', 'temperatura', 310.0000, 'ºC'),
	(187528, 122, '2014-02-01 01:04:00.000000', 'temperatura', 561.0000, 'ºC'),
	(187529, 122, '2014-02-01 01:04:01.000000', 'temperatura', 677.0000, 'ºC'),
	(187530, 122, '2014-02-01 01:04:02.000000', 'temperatura', 502.0000, 'ºC'),
	(187531, 122, '2014-02-01 01:04:03.000000', 'temperatura', 479.0000, 'ºC'),
	(187532, 122, '2014-02-01 01:04:04.000000', 'temperatura', 888.0000, 'ºC'),
	(187533, 122, '2014-02-01 01:04:05.000000', 'temperatura', 606.0000, 'ºC'),
	(187534, 122, '2014-02-01 01:04:06.000000', 'temperatura', 368.0000, 'ºC'),
	(187535, 122, '2014-02-01 01:04:07.000000', 'temperatura', 20.0000, 'ºC'),
	(187536, 122, '2014-02-01 01:04:08.000000', 'temperatura', 199.0000, 'ºC'),
	(187537, 122, '2014-02-01 01:04:09.000000', 'temperatura', 934.0000, 'ºC'),
	(187538, 122, '2014-02-01 01:04:10.000000', 'temperatura', 474.0000, 'ºC'),
	(187539, 122, '2014-02-01 01:04:11.000000', 'temperatura', 769.0000, 'ºC'),
	(187540, 122, '2014-02-01 01:04:12.000000', 'temperatura', 22.0000, 'ºC'),
	(187541, 122, '2014-02-01 01:04:13.000000', 'temperatura', 206.0000, 'ºC'),
	(187542, 122, '2014-02-01 01:04:14.000000', 'temperatura', 964.0000, 'ºC'),
	(187543, 122, '2014-02-01 01:04:15.000000', 'temperatura', 601.0000, 'ºC'),
	(187544, 122, '2014-02-01 01:04:16.000000', 'temperatura', 115.0000, 'ºC'),
	(187545, 122, '2014-02-01 01:04:17.000000', 'temperatura', 1170.0000, 'ºC'),
	(187546, 122, '2014-02-01 01:04:18.000000', 'temperatura', 709.0000, 'ºC'),
	(187547, 122, '2014-02-01 01:04:19.000000', 'temperatura', 34.0000, 'ºC'),
	(187548, 122, '2014-02-01 01:04:20.000000', 'temperatura', 442.0000, 'ºC'),
	(187549, 122, '2014-02-01 01:04:21.000000', 'temperatura', 910.0000, 'ºC'),
	(187550, 122, '2014-02-01 01:04:22.000000', 'temperatura', 822.0000, 'ºC'),
	(187551, 122, '2014-02-01 01:04:23.000000', 'temperatura', 183.0000, 'ºC'),
	(187552, 122, '2014-02-01 01:04:24.000000', 'temperatura', 847.0000, 'ºC'),
	(187553, 122, '2014-02-01 01:04:25.000000', 'temperatura', 90.0000, 'ºC'),
	(187554, 122, '2014-02-01 01:04:26.000000', 'temperatura', 306.0000, 'ºC'),
	(187555, 122, '2014-02-01 01:04:27.000000', 'temperatura', 64.0000, 'ºC'),
	(187556, 122, '2014-02-01 01:04:28.000000', 'temperatura', 600.0000, 'ºC'),
	(187557, 122, '2014-02-01 01:04:29.000000', 'temperatura', 407.0000, 'ºC'),
	(187558, 122, '2014-02-01 01:04:30.000000', 'temperatura', 239.0000, 'ºC'),
	(187559, 122, '2014-02-01 01:04:31.000000', 'temperatura', 1172.0000, 'ºC'),
	(187560, 122, '2014-02-01 01:04:32.000000', 'temperatura', 345.0000, 'ºC'),
	(187561, 122, '2014-02-01 01:04:33.000000', 'temperatura', 611.0000, 'ºC'),
	(187562, 122, '2014-02-01 01:04:34.000000', 'temperatura', 819.0000, 'ºC'),
	(187563, 122, '2014-02-01 01:04:35.000000', 'temperatura', 1063.0000, 'ºC'),
	(187564, 122, '2014-02-01 01:04:36.000000', 'temperatura', 457.0000, 'ºC'),
	(187565, 122, '2014-02-01 01:04:37.000000', 'temperatura', 298.0000, 'ºC'),
	(187566, 122, '2014-02-01 01:04:38.000000', 'temperatura', 121.0000, 'ºC'),
	(187567, 122, '2014-02-01 01:04:39.000000', 'temperatura', 908.0000, 'ºC'),
	(187568, 122, '2014-02-01 01:04:40.000000', 'temperatura', 579.0000, 'ºC'),
	(187569, 122, '2014-02-01 01:04:41.000000', 'temperatura', 174.0000, 'ºC'),
	(187570, 122, '2014-02-01 01:04:42.000000', 'temperatura', 330.0000, 'ºC'),
	(187571, 122, '2014-02-01 01:04:43.000000', 'temperatura', 1130.0000, 'ºC'),
	(187572, 122, '2014-02-01 01:04:44.000000', 'temperatura', 1062.0000, 'ºC'),
	(187573, 122, '2014-02-01 01:04:45.000000', 'temperatura', 717.0000, 'ºC'),
	(187574, 122, '2014-02-01 01:04:46.000000', 'temperatura', 403.0000, 'ºC'),
	(187575, 122, '2014-02-01 01:04:47.000000', 'temperatura', 1062.0000, 'ºC'),
	(187576, 122, '2014-02-01 01:04:48.000000', 'temperatura', 503.0000, 'ºC'),
	(187577, 122, '2014-02-01 01:04:49.000000', 'temperatura', 531.0000, 'ºC'),
	(187578, 122, '2014-02-01 01:04:50.000000', 'temperatura', 1145.0000, 'ºC'),
	(187579, 122, '2014-02-01 01:04:51.000000', 'temperatura', 535.0000, 'ºC'),
	(187580, 122, '2014-02-01 01:04:52.000000', 'temperatura', 437.0000, 'ºC'),
	(187581, 122, '2014-02-01 01:04:53.000000', 'temperatura', 581.0000, 'ºC'),
	(187582, 122, '2014-02-01 01:04:54.000000', 'temperatura', 394.0000, 'ºC'),
	(187583, 122, '2014-02-01 01:04:55.000000', 'temperatura', 226.0000, 'ºC'),
	(187584, 122, '2014-02-01 01:04:56.000000', 'temperatura', 1151.0000, 'ºC'),
	(187585, 122, '2014-02-01 01:04:57.000000', 'temperatura', 275.0000, 'ºC'),
	(187586, 122, '2014-02-01 01:04:58.000000', 'temperatura', 323.0000, 'ºC'),
	(187587, 122, '2014-02-01 01:04:59.000000', 'temperatura', 790.0000, 'ºC'),
	(187588, 122, '2014-02-01 01:05:00.000000', 'temperatura', 581.0000, 'ºC'),
	(187589, 122, '2014-02-01 01:05:01.000000', 'temperatura', 538.0000, 'ºC'),
	(187590, 122, '2014-02-01 01:05:02.000000', 'temperatura', 946.0000, 'ºC'),
	(187591, 122, '2014-02-01 01:05:03.000000', 'temperatura', 717.0000, 'ºC'),
	(187592, 122, '2014-02-01 01:05:04.000000', 'temperatura', 747.0000, 'ºC'),
	(187593, 122, '2014-02-01 01:05:05.000000', 'temperatura', 385.0000, 'ºC'),
	(187594, 122, '2014-02-01 01:05:06.000000', 'temperatura', 883.0000, 'ºC'),
	(187595, 122, '2014-02-01 01:05:07.000000', 'temperatura', 861.0000, 'ºC'),
	(187596, 122, '2014-02-01 01:05:08.000000', 'temperatura', 457.0000, 'ºC'),
	(187597, 122, '2014-02-01 01:05:09.000000', 'temperatura', 904.0000, 'ºC'),
	(187598, 122, '2014-02-01 01:05:10.000000', 'temperatura', 748.0000, 'ºC'),
	(187599, 122, '2014-02-01 01:05:11.000000', 'temperatura', 1028.0000, 'ºC'),
	(187600, 122, '2014-02-01 01:05:12.000000', 'temperatura', 496.0000, 'ºC'),
	(187601, 122, '2014-02-01 01:05:13.000000', 'temperatura', 597.0000, 'ºC'),
	(187602, 122, '2014-02-01 01:05:14.000000', 'temperatura', 298.0000, 'ºC'),
	(187603, 122, '2014-02-01 01:05:15.000000', 'temperatura', 898.0000, 'ºC'),
	(187604, 122, '2014-02-01 01:05:16.000000', 'temperatura', 1199.0000, 'ºC'),
	(187605, 122, '2014-02-01 01:05:17.000000', 'temperatura', 900.0000, 'ºC'),
	(187606, 122, '2014-02-01 01:05:18.000000', 'temperatura', 902.0000, 'ºC'),
	(187607, 122, '2014-02-01 01:05:19.000000', 'temperatura', 612.0000, 'ºC'),
	(187608, 122, '2014-02-01 01:05:20.000000', 'temperatura', 353.0000, 'ºC'),
	(187609, 122, '2014-02-01 01:05:21.000000', 'temperatura', 1129.0000, 'ºC'),
	(187610, 122, '2014-02-01 01:05:22.000000', 'temperatura', 988.0000, 'ºC'),
	(187611, 122, '2014-02-01 01:05:23.000000', 'temperatura', 355.0000, 'ºC'),
	(187612, 122, '2014-02-01 01:05:24.000000', 'temperatura', 8.0000, 'ºC'),
	(187613, 122, '2014-02-01 01:05:25.000000', 'temperatura', 178.0000, 'ºC'),
	(187614, 122, '2014-02-01 01:05:26.000000', 'temperatura', 865.0000, 'ºC'),
	(187615, 122, '2014-02-01 01:05:27.000000', 'temperatura', 190.0000, 'ºC'),
	(187616, 122, '2014-02-01 01:05:28.000000', 'temperatura', 759.0000, 'ºC'),
	(187617, 122, '2014-02-01 01:05:29.000000', 'temperatura', 824.0000, 'ºC'),
	(187618, 122, '2014-02-01 01:05:30.000000', 'temperatura', 642.0000, 'ºC'),
	(187619, 122, '2014-02-01 01:05:31.000000', 'temperatura', 738.0000, 'ºC'),
	(187620, 122, '2014-02-01 01:05:32.000000', 'temperatura', 564.0000, 'ºC'),
	(187621, 122, '2014-02-01 01:05:33.000000', 'temperatura', 606.0000, 'ºC'),
	(187622, 122, '2014-02-01 01:05:34.000000', 'temperatura', 138.0000, 'ºC'),
	(187623, 122, '2014-02-01 01:05:35.000000', 'temperatura', 73.0000, 'ºC'),
	(187624, 122, '2014-02-01 01:05:36.000000', 'temperatura', 1152.0000, 'ºC'),
	(187625, 122, '2014-02-01 01:05:37.000000', 'temperatura', 743.0000, 'ºC'),
	(187626, 122, '2014-02-01 01:05:38.000000', 'temperatura', 260.0000, 'ºC'),
	(187627, 122, '2014-02-01 01:05:39.000000', 'temperatura', 272.0000, 'ºC'),
	(187628, 122, '2014-02-01 01:05:40.000000', 'temperatura', 581.0000, 'ºC'),
	(187629, 122, '2014-02-01 01:05:41.000000', 'temperatura', 890.0000, 'ºC'),
	(187630, 122, '2014-02-01 01:05:42.000000', 'temperatura', 306.0000, 'ºC'),
	(187631, 122, '2014-02-01 01:05:43.000000', 'temperatura', 61.0000, 'ºC'),
	(187632, 122, '2014-02-01 01:05:44.000000', 'temperatura', 588.0000, 'ºC'),
	(187633, 122, '2014-02-01 01:05:45.000000', 'temperatura', 358.0000, 'ºC'),
	(187634, 122, '2014-02-01 01:05:46.000000', 'temperatura', 28.0000, 'ºC'),
	(187635, 122, '2014-02-01 01:05:47.000000', 'temperatura', 264.0000, 'ºC'),
	(187636, 122, '2014-02-01 01:05:48.000000', 'temperatura', 38.0000, 'ºC'),
	(187637, 122, '2014-02-01 01:05:49.000000', 'temperatura', 596.0000, 'ºC'),
	(187638, 122, '2014-02-01 01:05:50.000000', 'temperatura', 469.0000, 'ºC'),
	(187639, 122, '2014-02-01 01:05:51.000000', 'temperatura', 556.0000, 'ºC'),
	(187640, 122, '2014-02-01 01:05:52.000000', 'temperatura', 173.0000, 'ºC'),
	(187641, 122, '2014-02-01 01:05:53.000000', 'temperatura', 398.0000, 'ºC'),
	(187642, 122, '2014-02-01 01:05:54.000000', 'temperatura', 272.0000, 'ºC'),
	(187643, 122, '2014-02-01 01:05:55.000000', 'temperatura', 166.0000, 'ºC'),
	(187644, 122, '2014-02-01 01:05:56.000000', 'temperatura', 17.0000, 'ºC'),
	(187645, 122, '2014-02-01 01:05:57.000000', 'temperatura', 784.0000, 'ºC'),
	(187646, 122, '2014-02-01 01:05:58.000000', 'temperatura', 270.0000, 'ºC'),
	(187647, 122, '2014-02-01 01:05:59.000000', 'temperatura', 201.0000, 'ºC'),
	(187648, 122, '2014-02-01 01:06:00.000000', 'temperatura', 192.0000, 'ºC'),
	(187649, 122, '2014-02-01 01:06:01.000000', 'temperatura', 361.0000, 'ºC'),
	(187650, 122, '2014-02-01 01:06:02.000000', 'temperatura', 26.0000, 'ºC'),
	(187651, 122, '2014-02-01 01:06:03.000000', 'temperatura', 249.0000, 'ºC'),
	(187652, 122, '2014-02-01 01:06:04.000000', 'temperatura', 1168.0000, 'ºC'),
	(187653, 122, '2014-02-01 01:06:05.000000', 'temperatura', 291.0000, 'ºC'),
	(187654, 122, '2014-02-01 01:06:06.000000', 'temperatura', 354.0000, 'ºC'),
	(187655, 122, '2014-02-01 01:06:07.000000', 'temperatura', 896.0000, 'ºC'),
	(187656, 122, '2014-02-01 01:06:08.000000', 'temperatura', 1021.0000, 'ºC'),
	(187657, 122, '2014-02-01 01:06:09.000000', 'temperatura', 16.0000, 'ºC'),
	(187658, 122, '2014-02-01 01:06:10.000000', 'temperatura', 619.0000, 'ºC'),
	(187659, 122, '2014-02-01 01:06:11.000000', 'temperatura', 648.0000, 'ºC'),
	(187660, 122, '2014-02-01 01:06:12.000000', 'temperatura', 183.0000, 'ºC'),
	(187661, 122, '2014-02-01 01:06:13.000000', 'temperatura', 171.0000, 'ºC'),
	(187662, 122, '2014-02-01 01:06:14.000000', 'temperatura', 307.0000, 'ºC'),
	(187663, 122, '2014-02-01 01:06:15.000000', 'temperatura', 1021.0000, 'ºC'),
	(187664, 122, '2014-02-01 01:06:16.000000', 'temperatura', 586.0000, 'ºC'),
	(187665, 122, '2014-02-01 01:06:17.000000', 'temperatura', 1068.0000, 'ºC'),
	(187666, 122, '2014-02-01 01:06:18.000000', 'temperatura', 1184.0000, 'ºC'),
	(187667, 122, '2014-02-01 01:06:19.000000', 'temperatura', 314.0000, 'ºC'),
	(187668, 122, '2014-02-01 01:06:20.000000', 'temperatura', 418.0000, 'ºC'),
	(187669, 122, '2014-02-01 01:06:21.000000', 'temperatura', 1151.0000, 'ºC'),
	(187670, 122, '2014-02-01 01:06:22.000000', 'temperatura', 900.0000, 'ºC'),
	(187671, 122, '2014-02-01 01:06:23.000000', 'temperatura', 1049.0000, 'ºC'),
	(187672, 122, '2014-02-01 01:06:24.000000', 'temperatura', 144.0000, 'ºC'),
	(187673, 122, '2014-02-01 01:06:25.000000', 'temperatura', 1174.0000, 'ºC'),
	(187674, 122, '2014-02-01 01:06:26.000000', 'temperatura', 639.0000, 'ºC'),
	(187675, 122, '2014-02-01 01:06:27.000000', 'temperatura', 871.0000, 'ºC'),
	(187676, 122, '2014-02-01 01:06:28.000000', 'temperatura', 42.0000, 'ºC'),
	(187677, 122, '2014-02-01 01:06:29.000000', 'temperatura', 1196.0000, 'ºC'),
	(187678, 122, '2014-02-01 01:06:30.000000', 'temperatura', 1054.0000, 'ºC'),
	(187679, 122, '2014-02-01 01:06:31.000000', 'temperatura', 483.0000, 'ºC'),
	(187680, 122, '2014-02-01 01:06:32.000000', 'temperatura', 452.0000, 'ºC'),
	(187681, 122, '2014-02-01 01:06:33.000000', 'temperatura', 813.0000, 'ºC'),
	(187682, 122, '2014-02-01 01:06:34.000000', 'temperatura', 309.0000, 'ºC'),
	(187683, 122, '2014-02-01 01:06:35.000000', 'temperatura', 308.0000, 'ºC'),
	(187684, 122, '2014-02-01 01:06:36.000000', 'temperatura', 614.0000, 'ºC'),
	(187685, 122, '2014-02-01 01:06:37.000000', 'temperatura', 945.0000, 'ºC'),
	(187686, 122, '2014-02-01 01:06:38.000000', 'temperatura', 482.0000, 'ºC'),
	(187687, 122, '2014-02-01 01:06:39.000000', 'temperatura', 777.0000, 'ºC'),
	(187688, 122, '2014-02-01 01:06:40.000000', 'temperatura', 40.0000, 'ºC'),
	(187689, 122, '2014-02-01 01:06:41.000000', 'temperatura', 271.0000, 'ºC'),
	(187690, 122, '2014-02-01 01:06:42.000000', 'temperatura', 32.0000, 'ºC'),
	(187691, 122, '2014-02-01 01:06:43.000000', 'temperatura', 551.0000, 'ºC'),
	(187692, 122, '2014-02-01 01:06:44.000000', 'temperatura', 258.0000, 'ºC'),
	(187693, 122, '2014-02-01 01:06:45.000000', 'temperatura', 837.0000, 'ºC'),
	(187694, 122, '2014-02-01 01:06:46.000000', 'temperatura', 1011.0000, 'ºC'),
	(187695, 122, '2014-02-01 01:06:47.000000', 'temperatura', 146.0000, 'ºC'),
	(187696, 122, '2014-02-01 01:06:48.000000', 'temperatura', 96.0000, 'ºC'),
	(187697, 122, '2014-02-01 01:06:49.000000', 'temperatura', 44.0000, 'ºC'),
	(187698, 122, '2014-02-01 01:06:50.000000', 'temperatura', 1133.0000, 'ºC'),
	(187699, 122, '2014-02-01 01:06:51.000000', 'temperatura', 732.0000, 'ºC'),
	(187700, 122, '2014-02-01 01:06:52.000000', 'temperatura', 261.0000, 'ºC'),
	(187701, 122, '2014-02-01 01:06:53.000000', 'temperatura', 309.0000, 'ºC'),
	(187702, 122, '2014-02-01 01:06:54.000000', 'temperatura', 763.0000, 'ºC'),
	(187703, 122, '2014-02-01 01:06:55.000000', 'temperatura', 491.0000, 'ºC'),
	(187704, 122, '2014-02-01 01:06:56.000000', 'temperatura', 164.0000, 'ºC'),
	(187705, 122, '2014-02-01 01:06:57.000000', 'temperatura', 548.0000, 'ºC'),
	(187706, 122, '2014-02-01 01:06:58.000000', 'temperatura', 1047.0000, 'ºC'),
	(187707, 122, '2014-02-01 01:06:59.000000', 'temperatura', 1194.0000, 'ºC'),
	(187708, 122, '2014-02-01 01:07:00.000000', 'temperatura', 428.0000, 'ºC'),
	(187709, 122, '2014-02-01 01:07:01.000000', 'temperatura', 959.0000, 'ºC'),
	(187710, 122, '2014-02-01 01:07:02.000000', 'temperatura', 1112.0000, 'ºC'),
	(187711, 122, '2014-02-01 01:07:03.000000', 'temperatura', 282.0000, 'ºC'),
	(187712, 122, '2014-02-01 01:07:04.000000', 'temperatura', 474.0000, 'ºC'),
	(187713, 122, '2014-02-01 01:07:05.000000', 'temperatura', 326.0000, 'ºC'),
	(187714, 122, '2014-02-01 01:07:06.000000', 'temperatura', 209.0000, 'ºC'),
	(187715, 122, '2014-02-01 01:07:07.000000', 'temperatura', 68.0000, 'ºC'),
	(187716, 122, '2014-02-01 01:07:08.000000', 'temperatura', 912.0000, 'ºC'),
	(187717, 122, '2014-02-01 01:07:09.000000', 'temperatura', 759.0000, 'ºC'),
	(187718, 122, '2014-02-01 01:07:10.000000', 'temperatura', 1056.0000, 'ºC'),
	(187719, 122, '2014-02-01 01:07:11.000000', 'temperatura', 606.0000, 'ºC'),
	(187720, 122, '2014-02-01 01:07:12.000000', 'temperatura', 1062.0000, 'ºC'),
	(187721, 122, '2014-02-01 01:07:13.000000', 'temperatura', 1092.0000, 'ºC'),
	(187722, 122, '2014-02-01 01:07:14.000000', 'temperatura', 1074.0000, 'ºC'),
	(187723, 122, '2014-02-01 01:07:15.000000', 'temperatura', 895.0000, 'ºC'),
	(187724, 122, '2014-02-01 01:07:16.000000', 'temperatura', 55.0000, 'ºC'),
	(187725, 122, '2014-02-01 01:07:17.000000', 'temperatura', 1191.0000, 'ºC'),
	(187726, 122, '2014-02-01 01:07:18.000000', 'temperatura', 988.0000, 'ºC'),
	(187727, 122, '2014-02-01 01:07:19.000000', 'temperatura', 170.0000, 'ºC'),
	(187728, 122, '2014-02-01 01:07:20.000000', 'temperatura', 285.0000, 'ºC'),
	(187729, 122, '2014-02-01 01:07:21.000000', 'temperatura', 916.0000, 'ºC'),
	(187730, 122, '2014-02-01 01:07:22.000000', 'temperatura', 127.0000, 'ºC'),
	(187731, 122, '2014-02-01 01:07:23.000000', 'temperatura', 284.0000, 'ºC'),
	(187732, 122, '2014-02-01 01:07:24.000000', 'temperatura', 1042.0000, 'ºC'),
	(187733, 122, '2014-02-01 01:07:25.000000', 'temperatura', 759.0000, 'ºC'),
	(187734, 122, '2014-02-01 01:07:26.000000', 'temperatura', 667.0000, 'ºC'),
	(187735, 122, '2014-02-01 01:07:27.000000', 'temperatura', 1061.0000, 'ºC'),
	(187736, 122, '2014-02-01 01:07:28.000000', 'temperatura', 904.0000, 'ºC'),
	(187737, 122, '2014-02-01 01:07:29.000000', 'temperatura', 136.0000, 'ºC'),
	(187738, 122, '2014-02-01 01:07:30.000000', 'temperatura', 371.0000, 'ºC'),
	(187739, 122, '2014-02-01 01:07:31.000000', 'temperatura', 247.0000, 'ºC'),
	(187740, 122, '2014-02-01 01:07:32.000000', 'temperatura', 122.0000, 'ºC'),
	(187741, 122, '2014-02-01 01:07:33.000000', 'temperatura', 1070.0000, 'ºC'),
	(187742, 122, '2014-02-01 01:07:34.000000', 'temperatura', 183.0000, 'ºC'),
	(187743, 122, '2014-02-01 01:07:35.000000', 'temperatura', 106.0000, 'ºC'),
	(187744, 122, '2014-02-01 01:07:36.000000', 'temperatura', 1180.0000, 'ºC'),
	(187745, 122, '2014-02-01 01:07:37.000000', 'temperatura', 783.0000, 'ºC'),
	(187746, 122, '2014-02-01 01:07:38.000000', 'temperatura', 374.0000, 'ºC'),
	(187747, 122, '2014-02-01 01:07:39.000000', 'temperatura', 724.0000, 'ºC'),
	(187748, 122, '2014-02-01 01:07:40.000000', 'temperatura', 99.0000, 'ºC'),
	(187749, 122, '2014-02-01 01:07:41.000000', 'temperatura', 722.0000, 'ºC'),
	(187750, 122, '2014-02-01 01:07:42.000000', 'temperatura', 916.0000, 'ºC'),
	(187751, 122, '2014-02-01 01:07:43.000000', 'temperatura', 11.0000, 'ºC'),
	(187752, 122, '2014-02-01 01:07:44.000000', 'temperatura', 909.0000, 'ºC'),
	(187753, 122, '2014-02-01 01:07:45.000000', 'temperatura', 914.0000, 'ºC'),
	(187754, 122, '2014-02-01 01:07:46.000000', 'temperatura', 641.0000, 'ºC'),
	(187755, 122, '2014-02-01 01:07:47.000000', 'temperatura', 466.0000, 'ºC'),
	(187756, 122, '2014-02-01 01:07:48.000000', 'temperatura', 405.0000, 'ºC'),
	(187757, 122, '2014-02-01 01:07:49.000000', 'temperatura', 628.0000, 'ºC'),
	(187758, 122, '2014-02-01 01:07:50.000000', 'temperatura', 726.0000, 'ºC'),
	(187759, 122, '2014-02-01 01:07:51.000000', 'temperatura', 548.0000, 'ºC'),
	(187760, 122, '2014-02-01 01:07:52.000000', 'temperatura', 560.0000, 'ºC'),
	(187761, 122, '2014-02-01 01:07:53.000000', 'temperatura', 1158.0000, 'ºC'),
	(187762, 122, '2014-02-01 01:07:54.000000', 'temperatura', 509.0000, 'ºC'),
	(187763, 122, '2014-02-01 01:07:55.000000', 'temperatura', 274.0000, 'ºC'),
	(187764, 122, '2014-02-01 01:07:56.000000', 'temperatura', 1043.0000, 'ºC'),
	(187765, 122, '2014-02-01 01:07:57.000000', 'temperatura', 792.0000, 'ºC'),
	(187766, 122, '2014-02-01 01:07:58.000000', 'temperatura', 831.0000, 'ºC'),
	(187767, 122, '2014-02-01 01:07:59.000000', 'temperatura', 580.0000, 'ºC'),
	(187768, 122, '2014-02-01 01:08:00.000000', 'temperatura', 406.0000, 'ºC'),
	(187769, 122, '2014-02-01 01:08:01.000000', 'temperatura', 294.0000, 'ºC'),
	(187770, 122, '2014-02-01 01:08:02.000000', 'temperatura', 249.0000, 'ºC'),
	(187771, 122, '2014-02-01 01:08:03.000000', 'temperatura', 365.0000, 'ºC'),
	(187772, 122, '2014-02-01 01:08:04.000000', 'temperatura', 1079.0000, 'ºC'),
	(187773, 122, '2014-02-01 01:08:05.000000', 'temperatura', 699.0000, 'ºC'),
	(187774, 122, '2014-02-01 01:08:06.000000', 'temperatura', 259.0000, 'ºC'),
	(187775, 122, '2014-02-01 01:08:07.000000', 'temperatura', 397.0000, 'ºC'),
	(187776, 122, '2014-02-01 01:08:08.000000', 'temperatura', 8.0000, 'ºC'),
	(187777, 122, '2014-02-01 01:08:09.000000', 'temperatura', 51.0000, 'ºC'),
	(187778, 122, '2014-02-01 01:08:10.000000', 'temperatura', 233.0000, 'ºC'),
	(187779, 122, '2014-02-01 01:08:11.000000', 'temperatura', 1013.0000, 'ºC'),
	(187780, 122, '2014-02-01 01:08:12.000000', 'temperatura', 763.0000, 'ºC'),
	(187781, 122, '2014-02-01 01:08:13.000000', 'temperatura', 779.0000, 'ºC'),
	(187782, 122, '2014-02-01 01:08:14.000000', 'temperatura', 406.0000, 'ºC'),
	(187783, 122, '2014-02-01 01:08:15.000000', 'temperatura', 892.0000, 'ºC'),
	(187784, 122, '2014-02-01 01:08:16.000000', 'temperatura', 842.0000, 'ºC'),
	(187785, 122, '2014-02-01 01:08:17.000000', 'temperatura', 336.0000, 'ºC'),
	(187786, 122, '2014-02-01 01:08:18.000000', 'temperatura', 354.0000, 'ºC'),
	(187787, 122, '2014-02-01 01:08:19.000000', 'temperatura', 762.0000, 'ºC'),
	(187788, 122, '2014-02-01 01:08:20.000000', 'temperatura', 349.0000, 'ºC'),
	(187789, 122, '2014-02-01 01:08:21.000000', 'temperatura', 657.0000, 'ºC'),
	(187790, 122, '2014-02-01 01:08:22.000000', 'temperatura', 1042.0000, 'ºC'),
	(187791, 122, '2014-02-01 01:08:23.000000', 'temperatura', 837.0000, 'ºC'),
	(187792, 122, '2014-02-01 01:08:24.000000', 'temperatura', 1061.0000, 'ºC'),
	(187793, 122, '2014-02-01 01:08:25.000000', 'temperatura', 393.0000, 'ºC'),
	(187794, 122, '2014-02-01 01:08:26.000000', 'temperatura', 1181.0000, 'ºC'),
	(187795, 122, '2014-02-01 01:08:27.000000', 'temperatura', 1129.0000, 'ºC'),
	(187796, 122, '2014-02-01 01:08:28.000000', 'temperatura', 901.0000, 'ºC'),
	(187797, 122, '2014-02-01 01:08:29.000000', 'temperatura', 1121.0000, 'ºC'),
	(187798, 122, '2014-02-01 01:08:30.000000', 'temperatura', 501.0000, 'ºC'),
	(187799, 122, '2014-02-01 01:08:31.000000', 'temperatura', 343.0000, 'ºC'),
	(187800, 122, '2014-02-01 01:08:32.000000', 'temperatura', 212.0000, 'ºC'),
	(187801, 122, '2014-02-01 01:08:33.000000', 'temperatura', 31.0000, 'ºC'),
	(187802, 122, '2014-02-01 01:08:34.000000', 'temperatura', 720.0000, 'ºC'),
	(187803, 122, '2014-02-01 01:08:35.000000', 'temperatura', 1106.0000, 'ºC'),
	(187804, 122, '2014-02-01 01:08:36.000000', 'temperatura', 973.0000, 'ºC'),
	(187805, 122, '2014-02-01 01:08:37.000000', 'temperatura', 345.0000, 'ºC'),
	(187806, 122, '2014-02-01 01:08:38.000000', 'temperatura', 8.0000, 'ºC'),
	(187807, 122, '2014-02-01 01:08:39.000000', 'temperatura', 206.0000, 'ºC'),
	(187808, 122, '2014-02-01 01:08:40.000000', 'temperatura', 1007.0000, 'ºC'),
	(187809, 122, '2014-02-01 01:08:41.000000', 'temperatura', 815.0000, 'ºC'),
	(187810, 122, '2014-02-01 01:08:42.000000', 'temperatura', 1055.0000, 'ºC'),
	(187811, 122, '2014-02-01 01:08:43.000000', 'temperatura', 429.0000, 'ºC'),
	(187812, 122, '2014-02-01 01:08:44.000000', 'temperatura', 181.0000, 'ºC'),
	(187813, 122, '2014-02-01 01:08:45.000000', 'temperatura', 821.0000, 'ºC'),
	(187814, 122, '2014-02-01 01:08:46.000000', 'temperatura', 1159.0000, 'ºC'),
	(187815, 122, '2014-02-01 01:08:47.000000', 'temperatura', 935.0000, 'ºC'),
	(187816, 122, '2014-02-01 01:08:48.000000', 'temperatura', 1199.0000, 'ºC'),
	(187817, 122, '2014-02-01 01:08:49.000000', 'temperatura', 789.0000, 'ºC'),
	(187818, 122, '2014-02-01 01:08:50.000000', 'temperatura', 349.0000, 'ºC'),
	(187819, 122, '2014-02-01 01:08:51.000000', 'temperatura', 580.0000, 'ºC'),
	(187820, 122, '2014-02-01 01:08:52.000000', 'temperatura', 652.0000, 'ºC'),
	(187821, 122, '2014-02-01 01:08:53.000000', 'temperatura', 321.0000, 'ºC'),
	(187822, 122, '2014-02-01 01:08:54.000000', 'temperatura', 848.0000, 'ºC'),
	(187823, 122, '2014-02-01 01:08:55.000000', 'temperatura', 877.0000, 'ºC'),
	(187824, 122, '2014-02-01 01:08:56.000000', 'temperatura', 642.0000, 'ºC'),
	(187825, 122, '2014-02-01 01:08:57.000000', 'temperatura', 580.0000, 'ºC'),
	(187826, 122, '2014-02-01 01:08:58.000000', 'temperatura', 975.0000, 'ºC'),
	(187827, 122, '2014-02-01 01:08:59.000000', 'temperatura', 735.0000, 'ºC'),
	(187828, 122, '2014-02-01 01:09:00.000000', 'temperatura', 750.0000, 'ºC'),
	(187829, 122, '2014-02-01 01:09:01.000000', 'temperatura', 348.0000, 'ºC'),
	(187830, 122, '2014-02-01 01:09:02.000000', 'temperatura', 687.0000, 'ºC'),
	(187831, 122, '2014-02-01 01:09:03.000000', 'temperatura', 1193.0000, 'ºC'),
	(187832, 122, '2014-02-01 01:09:04.000000', 'temperatura', 302.0000, 'ºC'),
	(187833, 122, '2014-02-01 01:09:05.000000', 'temperatura', 335.0000, 'ºC'),
	(187834, 122, '2014-02-01 01:09:06.000000', 'temperatura', 767.0000, 'ºC'),
	(187835, 122, '2014-02-01 01:09:07.000000', 'temperatura', 430.0000, 'ºC'),
	(187836, 122, '2014-02-01 01:09:08.000000', 'temperatura', 1052.0000, 'ºC'),
	(187837, 122, '2014-02-01 01:09:09.000000', 'temperatura', 369.0000, 'ºC'),
	(187838, 122, '2014-02-01 01:09:10.000000', 'temperatura', 1088.0000, 'ºC'),
	(187839, 122, '2014-02-01 01:09:11.000000', 'temperatura', 734.0000, 'ºC'),
	(187840, 122, '2014-02-01 01:09:12.000000', 'temperatura', 408.0000, 'ºC'),
	(187841, 122, '2014-02-01 01:09:13.000000', 'temperatura', 1036.0000, 'ºC'),
	(187842, 122, '2014-02-01 01:09:14.000000', 'temperatura', 360.0000, 'ºC'),
	(187843, 122, '2014-02-01 01:09:15.000000', 'temperatura', 1089.0000, 'ºC'),
	(187844, 122, '2014-02-01 01:09:16.000000', 'temperatura', 766.0000, 'ºC'),
	(187845, 122, '2014-02-01 01:09:17.000000', 'temperatura', 565.0000, 'ºC'),
	(187846, 122, '2014-02-01 01:09:18.000000', 'temperatura', 528.0000, 'ºC'),
	(187847, 122, '2014-02-01 01:09:19.000000', 'temperatura', 946.0000, 'ºC'),
	(187848, 122, '2014-02-01 01:09:20.000000', 'temperatura', 744.0000, 'ºC'),
	(187849, 122, '2014-02-01 01:09:21.000000', 'temperatura', 883.0000, 'ºC'),
	(187850, 122, '2014-02-01 01:09:22.000000', 'temperatura', 984.0000, 'ºC'),
	(187851, 122, '2014-02-01 01:09:23.000000', 'temperatura', 1071.0000, 'ºC'),
	(187852, 122, '2014-02-01 01:09:24.000000', 'temperatura', 4.0000, 'ºC'),
	(187853, 122, '2014-02-01 01:09:25.000000', 'temperatura', 408.0000, 'ºC'),
	(187854, 122, '2014-02-01 01:09:26.000000', 'temperatura', 830.0000, 'ºC'),
	(187855, 122, '2014-02-01 01:09:27.000000', 'temperatura', 525.0000, 'ºC'),
	(187856, 122, '2014-02-01 01:09:28.000000', 'temperatura', 137.0000, 'ºC'),
	(187857, 122, '2014-02-01 01:09:29.000000', 'temperatura', 309.0000, 'ºC'),
	(187858, 122, '2014-02-01 01:09:30.000000', 'temperatura', 1136.0000, 'ºC'),
	(187859, 122, '2014-02-01 01:09:31.000000', 'temperatura', 1154.0000, 'ºC'),
	(187860, 122, '2014-02-01 01:09:32.000000', 'temperatura', 1163.0000, 'ºC'),
	(187861, 122, '2014-02-01 01:09:33.000000', 'temperatura', 1153.0000, 'ºC'),
	(187862, 122, '2014-02-01 01:09:34.000000', 'temperatura', 1078.0000, 'ºC'),
	(187863, 122, '2014-02-01 01:09:35.000000', 'temperatura', 731.0000, 'ºC'),
	(187864, 122, '2014-02-01 01:09:36.000000', 'temperatura', 419.0000, 'ºC'),
	(187865, 122, '2014-02-01 01:09:37.000000', 'temperatura', 1105.0000, 'ºC'),
	(187866, 122, '2014-02-01 01:09:38.000000', 'temperatura', 668.0000, 'ºC'),
	(187867, 122, '2014-02-01 01:09:39.000000', 'temperatura', 26.0000, 'ºC'),
	(187868, 122, '2014-02-01 01:09:40.000000', 'temperatura', 528.0000, 'ºC'),
	(187869, 122, '2014-02-01 01:09:41.000000', 'temperatura', 159.0000, 'ºC'),
	(187870, 122, '2014-02-01 01:09:42.000000', 'temperatura', 415.0000, 'ºC'),
	(187871, 122, '2014-02-01 01:09:43.000000', 'temperatura', 395.0000, 'ºC'),
	(187872, 122, '2014-02-01 01:09:44.000000', 'temperatura', 733.0000, 'ºC'),
	(187873, 122, '2014-02-01 01:09:45.000000', 'temperatura', 79.0000, 'ºC'),
	(187874, 122, '2014-02-01 01:09:46.000000', 'temperatura', 598.0000, 'ºC'),
	(187875, 122, '2014-02-01 01:09:47.000000', 'temperatura', 353.0000, 'ºC'),
	(187876, 122, '2014-02-01 01:09:48.000000', 'temperatura', 1171.0000, 'ºC'),
	(187877, 122, '2014-02-01 01:09:49.000000', 'temperatura', 1197.0000, 'ºC'),
	(187878, 122, '2014-02-01 01:09:50.000000', 'temperatura', 72.0000, 'ºC'),
	(187879, 122, '2014-02-01 01:09:51.000000', 'temperatura', 368.0000, 'ºC'),
	(187880, 122, '2014-02-01 01:09:52.000000', 'temperatura', 424.0000, 'ºC'),
	(187881, 122, '2014-02-01 01:09:53.000000', 'temperatura', 1020.0000, 'ºC'),
	(187882, 122, '2014-02-01 01:09:54.000000', 'temperatura', 226.0000, 'ºC'),
	(187883, 122, '2014-02-01 01:09:55.000000', 'temperatura', 471.0000, 'ºC'),
	(187884, 122, '2014-02-01 01:09:56.000000', 'temperatura', 480.0000, 'ºC'),
	(187885, 122, '2014-02-01 01:09:57.000000', 'temperatura', 985.0000, 'ºC'),
	(187886, 122, '2014-02-01 01:09:58.000000', 'temperatura', 1084.0000, 'ºC'),
	(187887, 122, '2014-02-01 01:09:59.000000', 'temperatura', 69.0000, 'ºC'),
	(187888, 122, '2014-02-01 01:10:00.000000', 'temperatura', 692.0000, 'ºC'),
	(187889, 122, '2014-02-01 01:10:01.000000', 'temperatura', 852.0000, 'ºC'),
	(187890, 122, '2014-02-01 01:10:02.000000', 'temperatura', 984.0000, 'ºC'),
	(187891, 122, '2014-02-01 01:10:03.000000', 'temperatura', 1166.0000, 'ºC'),
	(187892, 122, '2014-02-01 01:10:04.000000', 'temperatura', 476.0000, 'ºC'),
	(187893, 122, '2014-02-01 01:10:05.000000', 'temperatura', 86.0000, 'ºC'),
	(187894, 122, '2014-02-01 01:10:06.000000', 'temperatura', 200.0000, 'ºC'),
	(187895, 122, '2014-02-01 01:10:07.000000', 'temperatura', 742.0000, 'ºC'),
	(187896, 122, '2014-02-01 01:10:08.000000', 'temperatura', 713.0000, 'ºC'),
	(187897, 122, '2014-02-01 01:10:09.000000', 'temperatura', 139.0000, 'ºC'),
	(187898, 122, '2014-02-01 01:10:10.000000', 'temperatura', 958.0000, 'ºC'),
	(187899, 122, '2014-02-01 01:10:11.000000', 'temperatura', 771.0000, 'ºC'),
	(187900, 122, '2014-02-01 01:10:12.000000', 'temperatura', 984.0000, 'ºC'),
	(187901, 122, '2014-02-01 01:10:13.000000', 'temperatura', 207.0000, 'ºC'),
	(187902, 122, '2014-02-01 01:10:14.000000', 'temperatura', 482.0000, 'ºC'),
	(187903, 122, '2014-02-01 01:10:15.000000', 'temperatura', 588.0000, 'ºC'),
	(187904, 122, '2014-02-01 01:10:16.000000', 'temperatura', 297.0000, 'ºC'),
	(187905, 122, '2014-02-01 01:10:17.000000', 'temperatura', 922.0000, 'ºC'),
	(187906, 122, '2014-02-01 01:10:18.000000', 'temperatura', 117.0000, 'ºC'),
	(187907, 122, '2014-02-01 01:10:19.000000', 'temperatura', 221.0000, 'ºC'),
	(187908, 122, '2014-02-01 01:10:20.000000', 'temperatura', 753.0000, 'ºC'),
	(187909, 122, '2014-02-01 01:10:21.000000', 'temperatura', 705.0000, 'ºC'),
	(187910, 122, '2014-02-01 01:10:22.000000', 'temperatura', 66.0000, 'ºC'),
	(187911, 122, '2014-02-01 01:10:23.000000', 'temperatura', 616.0000, 'ºC'),
	(187912, 122, '2014-02-01 01:10:24.000000', 'temperatura', 480.0000, 'ºC'),
	(187913, 122, '2014-02-01 01:10:25.000000', 'temperatura', 556.0000, 'ºC'),
	(187914, 122, '2014-02-01 01:10:26.000000', 'temperatura', 139.0000, 'ºC'),
	(187915, 122, '2014-02-01 01:10:27.000000', 'temperatura', 226.0000, 'ºC'),
	(187916, 122, '2014-02-01 01:10:28.000000', 'temperatura', 714.0000, 'ºC'),
	(187917, 122, '2014-02-01 01:10:29.000000', 'temperatura', 493.0000, 'ºC'),
	(187918, 122, '2014-02-01 01:10:30.000000', 'temperatura', 325.0000, 'ºC'),
	(187919, 122, '2014-02-01 01:10:31.000000', 'temperatura', 146.0000, 'ºC'),
	(187920, 122, '2014-02-01 01:10:32.000000', 'temperatura', 956.0000, 'ºC'),
	(187921, 122, '2014-02-01 01:10:33.000000', 'temperatura', 742.0000, 'ºC'),
	(187922, 122, '2014-02-01 01:10:34.000000', 'temperatura', 843.0000, 'ºC'),
	(187923, 122, '2014-02-01 01:10:35.000000', 'temperatura', 788.0000, 'ºC'),
	(187924, 122, '2014-02-01 01:10:36.000000', 'temperatura', 212.0000, 'ºC'),
	(187925, 122, '2014-02-01 01:10:37.000000', 'temperatura', 1095.0000, 'ºC'),
	(187926, 122, '2014-02-01 01:10:38.000000', 'temperatura', 40.0000, 'ºC'),
	(187927, 122, '2014-02-01 01:10:39.000000', 'temperatura', 518.0000, 'ºC'),
	(187928, 122, '2014-02-01 01:10:40.000000', 'temperatura', 70.0000, 'ºC'),
	(187929, 122, '2014-02-01 01:10:41.000000', 'temperatura', 1194.0000, 'ºC'),
	(187930, 122, '2014-02-01 01:10:42.000000', 'temperatura', 962.0000, 'ºC'),
	(187931, 122, '2014-02-01 01:10:43.000000', 'temperatura', 28.0000, 'ºC'),
	(187932, 122, '2014-02-01 01:10:44.000000', 'temperatura', 854.0000, 'ºC'),
	(187933, 122, '2014-02-01 01:10:45.000000', 'temperatura', 587.0000, 'ºC'),
	(187934, 122, '2014-02-01 01:10:46.000000', 'temperatura', 372.0000, 'ºC'),
	(187935, 122, '2014-02-01 01:10:47.000000', 'temperatura', 99.0000, 'ºC'),
	(187936, 122, '2014-02-01 01:10:48.000000', 'temperatura', 579.0000, 'ºC'),
	(187937, 122, '2014-02-01 01:10:49.000000', 'temperatura', 198.0000, 'ºC'),
	(187938, 122, '2014-02-01 01:10:50.000000', 'temperatura', 456.0000, 'ºC'),
	(187939, 122, '2014-02-01 01:10:51.000000', 'temperatura', 485.0000, 'ºC'),
	(187940, 122, '2014-02-01 01:10:52.000000', 'temperatura', 1056.0000, 'ºC'),
	(187941, 122, '2014-02-01 01:10:53.000000', 'temperatura', 226.0000, 'ºC'),
	(187942, 122, '2014-02-01 01:10:54.000000', 'temperatura', 364.0000, 'ºC'),
	(187943, 122, '2014-02-01 01:10:55.000000', 'temperatura', 1140.0000, 'ºC'),
	(187944, 122, '2014-02-01 01:10:56.000000', 'temperatura', 1010.0000, 'ºC'),
	(187945, 122, '2014-02-01 01:10:57.000000', 'temperatura', 430.0000, 'ºC'),
	(187946, 122, '2014-02-01 01:10:58.000000', 'temperatura', 319.0000, 'ºC'),
	(187947, 122, '2014-02-01 01:10:59.000000', 'temperatura', 306.0000, 'ºC'),
	(187948, 122, '2014-02-01 01:11:00.000000', 'temperatura', 572.0000, 'ºC'),
	(187949, 122, '2014-02-01 01:11:01.000000', 'temperatura', 744.0000, 'ºC'),
	(187950, 122, '2014-02-01 01:11:02.000000', 'temperatura', 805.0000, 'ºC'),
	(187951, 122, '2014-02-01 01:11:03.000000', 'temperatura', 592.0000, 'ºC'),
	(187952, 122, '2014-02-01 01:11:04.000000', 'temperatura', 547.0000, 'ºC'),
	(187953, 122, '2014-02-01 01:11:05.000000', 'temperatura', 960.0000, 'ºC'),
	(187954, 122, '2014-02-01 01:11:06.000000', 'temperatura', 758.0000, 'ºC'),
	(187955, 122, '2014-02-01 01:11:07.000000', 'temperatura', 911.0000, 'ºC'),
	(187956, 122, '2014-02-01 01:11:08.000000', 'temperatura', 1083.0000, 'ºC'),
	(187957, 122, '2014-02-01 01:11:09.000000', 'temperatura', 283.0000, 'ºC'),
	(187958, 122, '2014-02-01 01:11:10.000000', 'temperatura', 567.0000, 'ºC'),
	(187959, 122, '2014-02-01 01:11:11.000000', 'temperatura', 786.0000, 'ºC'),
	(187960, 122, '2014-02-01 01:11:12.000000', 'temperatura', 1030.0000, 'ºC'),
	(187961, 122, '2014-02-01 01:11:13.000000', 'temperatura', 391.0000, 'ºC'),
	(187962, 122, '2014-02-01 01:11:14.000000', 'temperatura', 68.0000, 'ºC'),
	(187963, 122, '2014-02-01 01:11:15.000000', 'temperatura', 366.0000, 'ºC'),
	(187964, 122, '2014-02-01 01:11:16.000000', 'temperatura', 425.0000, 'ºC'),
	(187965, 122, '2014-02-01 01:11:17.000000', 'temperatura', 1029.0000, 'ºC'),
	(187966, 122, '2014-02-01 01:11:18.000000', 'temperatura', 269.0000, 'ºC'),
	(187967, 122, '2014-02-01 01:11:19.000000', 'temperatura', 657.0000, 'ºC'),
	(187968, 122, '2014-02-01 01:11:20.000000', 'temperatura', 81.0000, 'ºC'),
	(187969, 122, '2014-02-01 01:11:21.000000', 'temperatura', 836.0000, 'ºC'),
	(187970, 122, '2014-02-01 01:11:22.000000', 'temperatura', 335.0000, 'ºC'),
	(187971, 122, '2014-02-01 01:11:23.000000', 'temperatura', 368.0000, 'ºC'),
	(187972, 122, '2014-02-01 01:11:24.000000', 'temperatura', 836.0000, 'ºC'),
	(187973, 122, '2014-02-01 01:11:25.000000', 'temperatura', 676.0000, 'ºC'),
	(187974, 122, '2014-02-01 01:11:26.000000', 'temperatura', 873.0000, 'ºC'),
	(187975, 122, '2014-02-01 01:11:27.000000', 'temperatura', 1138.0000, 'ºC'),
	(187976, 122, '2014-02-01 01:11:28.000000', 'temperatura', 672.0000, 'ºC'),
	(187977, 122, '2014-02-01 01:11:29.000000', 'temperatura', 1144.0000, 'ºC'),
	(187978, 122, '2014-02-01 01:11:30.000000', 'temperatura', 107.0000, 'ºC'),
	(187979, 122, '2014-02-01 01:11:31.000000', 'temperatura', 704.0000, 'ºC'),
	(187980, 122, '2014-02-01 01:11:32.000000', 'temperatura', 799.0000, 'ºC'),
	(187981, 122, '2014-02-01 01:11:33.000000', 'temperatura', 682.0000, 'ºC'),
	(187982, 122, '2014-02-01 01:11:34.000000', 'temperatura', 1015.0000, 'ºC'),
	(187983, 122, '2014-02-01 01:11:35.000000', 'temperatura', 629.0000, 'ºC'),
	(187984, 122, '2014-02-01 01:11:36.000000', 'temperatura', 100.0000, 'ºC'),
	(187985, 122, '2014-02-01 01:11:37.000000', 'temperatura', 1014.0000, 'ºC'),
	(187986, 122, '2014-02-01 01:11:38.000000', 'temperatura', 1170.0000, 'ºC'),
	(187987, 122, '2014-02-01 01:11:39.000000', 'temperatura', 411.0000, 'ºC'),
	(187988, 122, '2014-02-01 01:11:40.000000', 'temperatura', 943.0000, 'ºC'),
	(187989, 122, '2014-02-01 01:11:41.000000', 'temperatura', 1083.0000, 'ºC'),
	(187990, 122, '2014-02-01 01:11:42.000000', 'temperatura', 189.0000, 'ºC'),
	(187991, 122, '2014-02-01 01:11:43.000000', 'temperatura', 94.0000, 'ºC'),
	(187992, 122, '2014-02-01 01:11:44.000000', 'temperatura', 1103.0000, 'ºC'),
	(187993, 122, '2014-02-01 01:11:45.000000', 'temperatura', 433.0000, 'ºC'),
	(187994, 122, '2014-02-01 01:11:46.000000', 'temperatura', 58.0000, 'ºC'),
	(187995, 122, '2014-02-01 01:11:47.000000', 'temperatura', 192.0000, 'ºC'),
	(187996, 122, '2014-02-01 01:11:48.000000', 'temperatura', 786.0000, 'ºC'),
	(187997, 122, '2014-02-01 01:11:49.000000', 'temperatura', 955.0000, 'ºC'),
	(187998, 122, '2014-02-01 01:11:50.000000', 'temperatura', 16.0000, 'ºC'),
	(187999, 122, '2014-02-01 01:11:51.000000', 'temperatura', 816.0000, 'ºC'),
	(188000, 122, '2014-02-01 01:11:52.000000', 'temperatura', 433.0000, 'ºC'),
	(188001, 122, '2014-02-01 01:11:53.000000', 'temperatura', 915.0000, 'ºC'),
	(188002, 122, '2014-02-01 01:11:54.000000', 'temperatura', 880.0000, 'ºC'),
	(188003, 122, '2014-02-01 01:11:55.000000', 'temperatura', 454.0000, 'ºC'),
	(188004, 122, '2014-02-01 01:11:56.000000', 'temperatura', 832.0000, 'ºC'),
	(188005, 122, '2014-02-01 01:11:57.000000', 'temperatura', 397.0000, 'ºC'),
	(188006, 122, '2014-02-01 01:11:58.000000', 'temperatura', 691.0000, 'ºC'),
	(188007, 122, '2014-02-01 01:11:59.000000', 'temperatura', 1063.0000, 'ºC'),
	(188008, 122, '2014-02-01 01:12:00.000000', 'temperatura', 843.0000, 'ºC'),
	(188009, 122, '2014-02-01 01:12:01.000000', 'temperatura', 1028.0000, 'ºC'),
	(188010, 122, '2014-02-01 01:12:02.000000', 'temperatura', 209.0000, 'ºC'),
	(188011, 122, '2014-02-01 01:12:03.000000', 'temperatura', 363.0000, 'ºC'),
	(188012, 122, '2014-02-01 01:12:04.000000', 'temperatura', 1186.0000, 'ºC'),
	(188013, 122, '2014-02-01 01:12:05.000000', 'temperatura', 44.0000, 'ºC'),
	(188014, 122, '2014-02-01 01:12:06.000000', 'temperatura', 262.0000, 'ºC'),
	(188015, 122, '2014-02-01 01:12:07.000000', 'temperatura', 1178.0000, 'ºC'),
	(188016, 122, '2014-02-01 01:12:08.000000', 'temperatura', 304.0000, 'ºC'),
	(188017, 122, '2014-02-01 01:12:09.000000', 'temperatura', 388.0000, 'ºC'),
	(188018, 122, '2014-02-01 01:12:10.000000', 'temperatura', 1030.0000, 'ºC'),
	(188019, 122, '2014-02-01 01:12:11.000000', 'temperatura', 383.0000, 'ºC'),
	(188020, 122, '2014-02-01 01:12:12.000000', 'temperatura', 28.0000, 'ºC'),
	(188021, 122, '2014-02-01 01:12:13.000000', 'temperatura', 192.0000, 'ºC'),
	(188022, 122, '2014-02-01 01:12:14.000000', 'temperatura', 877.0000, 'ºC'),
	(188023, 122, '2014-02-01 01:12:15.000000', 'temperatura', 209.0000, 'ºC'),
	(188024, 122, '2014-02-01 01:12:16.000000', 'temperatura', 813.0000, 'ºC'),
	(188025, 122, '2014-02-01 01:12:17.000000', 'temperatura', 1038.0000, 'ºC'),
	(188026, 122, '2014-02-01 01:12:18.000000', 'temperatura', 351.0000, 'ºC'),
	(188027, 122, '2014-02-01 01:12:19.000000', 'temperatura', 1041.0000, 'ºC'),
	(188028, 122, '2014-02-01 01:12:20.000000', 'temperatura', 555.0000, 'ºC'),
	(188029, 122, '2014-02-01 01:12:21.000000', 'temperatura', 854.0000, 'ºC'),
	(188030, 122, '2014-02-01 01:12:22.000000', 'temperatura', 202.0000, 'ºC'),
	(188031, 122, '2014-02-01 01:12:23.000000', 'temperatura', 849.0000, 'ºC'),
	(188032, 122, '2014-02-01 01:12:24.000000', 'temperatura', 41.0000, 'ºC'),
	(188033, 122, '2014-02-01 01:12:25.000000', 'temperatura', 56.0000, 'ºC'),
	(188034, 122, '2014-02-01 01:12:26.000000', 'temperatura', 157.0000, 'ºC'),
	(188035, 122, '2014-02-01 01:12:27.000000', 'temperatura', 620.0000, 'ºC'),
	(188036, 122, '2014-02-01 01:12:28.000000', 'temperatura', 229.0000, 'ºC'),
	(188037, 122, '2014-02-01 01:12:29.000000', 'temperatura', 486.0000, 'ºC'),
	(188038, 122, '2014-02-01 01:12:30.000000', 'temperatura', 543.0000, 'ºC'),
	(188039, 122, '2014-02-01 01:12:31.000000', 'temperatura', 59.0000, 'ºC'),
	(188040, 122, '2014-02-01 01:12:32.000000', 'temperatura', 1066.0000, 'ºC'),
	(188041, 122, '2014-02-01 01:12:33.000000', 'temperatura', 351.0000, 'ºC'),
	(188042, 122, '2014-02-01 01:12:34.000000', 'temperatura', 959.0000, 'ºC'),
	(188043, 122, '2014-02-01 01:12:35.000000', 'temperatura', 144.0000, 'ºC'),
	(188044, 122, '2014-02-01 01:12:36.000000', 'temperatura', 242.0000, 'ºC'),
	(188045, 122, '2014-02-01 01:12:37.000000', 'temperatura', 777.0000, 'ºC'),
	(188046, 122, '2014-02-01 01:12:38.000000', 'temperatura', 759.0000, 'ºC'),
	(188047, 122, '2014-02-01 01:12:39.000000', 'temperatura', 267.0000, 'ºC'),
	(188048, 122, '2014-02-01 01:12:40.000000', 'temperatura', 258.0000, 'ºC'),
	(188049, 122, '2014-02-01 01:12:41.000000', 'temperatura', 488.0000, 'ºC'),
	(188050, 122, '2014-02-01 01:12:42.000000', 'temperatura', 466.0000, 'ºC'),
	(188051, 122, '2014-02-01 01:12:43.000000', 'temperatura', 869.0000, 'ºC'),
	(188052, 122, '2014-02-01 01:12:44.000000', 'temperatura', 545.0000, 'ºC'),
	(188053, 122, '2014-02-01 01:12:45.000000', 'temperatura', 120.0000, 'ºC'),
	(188054, 122, '2014-02-01 01:12:46.000000', 'temperatura', 164.0000, 'ºC'),
	(188055, 122, '2014-02-01 01:12:47.000000', 'temperatura', 462.0000, 'ºC'),
	(188056, 122, '2014-02-01 01:12:48.000000', 'temperatura', 617.0000, 'ºC'),
	(188057, 122, '2014-02-01 01:12:49.000000', 'temperatura', 500.0000, 'ºC'),
	(188058, 122, '2014-02-01 01:12:50.000000', 'temperatura', 651.0000, 'ºC'),
	(188059, 122, '2014-02-01 01:12:51.000000', 'temperatura', 554.0000, 'ºC'),
	(188060, 122, '2014-02-01 01:12:52.000000', 'temperatura', 818.0000, 'ºC'),
	(188061, 122, '2014-02-01 01:12:53.000000', 'temperatura', 29.0000, 'ºC'),
	(188062, 122, '2014-02-01 01:12:54.000000', 'temperatura', 90.0000, 'ºC'),
	(188063, 122, '2014-02-01 01:12:55.000000', 'temperatura', 363.0000, 'ºC'),
	(188064, 122, '2014-02-01 01:12:56.000000', 'temperatura', 348.0000, 'ºC'),
	(188065, 122, '2014-02-01 01:12:57.000000', 'temperatura', 650.0000, 'ºC'),
	(188066, 122, '2014-02-01 01:12:58.000000', 'temperatura', 1008.0000, 'ºC'),
	(188067, 122, '2014-02-01 01:12:59.000000', 'temperatura', 690.0000, 'ºC'),
	(188068, 122, '2014-02-01 01:13:00.000000', 'temperatura', 424.0000, 'ºC'),
	(188069, 122, '2014-02-01 01:13:01.000000', 'temperatura', 54.0000, 'ºC'),
	(188070, 122, '2014-02-01 01:13:02.000000', 'temperatura', 197.0000, 'ºC'),
	(188071, 122, '2014-02-01 01:13:03.000000', 'temperatura', 825.0000, 'ºC'),
	(188072, 122, '2014-02-01 01:13:04.000000', 'temperatura', 1133.0000, 'ºC'),
	(188073, 122, '2014-02-01 01:13:05.000000', 'temperatura', 791.0000, 'ºC'),
	(188074, 122, '2014-02-01 01:13:06.000000', 'temperatura', 558.0000, 'ºC'),
	(188075, 122, '2014-02-01 01:13:07.000000', 'temperatura', 416.0000, 'ºC'),
	(188076, 122, '2014-02-01 01:13:08.000000', 'temperatura', 406.0000, 'ºC'),
	(188077, 122, '2014-02-01 01:13:09.000000', 'temperatura', 784.0000, 'ºC'),
	(188078, 122, '2014-02-01 01:13:10.000000', 'temperatura', 304.0000, 'ºC'),
	(188079, 122, '2014-02-01 01:13:11.000000', 'temperatura', 366.0000, 'ºC'),
	(188080, 122, '2014-02-01 01:13:12.000000', 'temperatura', 918.0000, 'ºC'),
	(188081, 122, '2014-02-01 01:13:13.000000', 'temperatura', 1092.0000, 'ºC'),
	(188082, 122, '2014-02-01 01:13:14.000000', 'temperatura', 306.0000, 'ºC'),
	(188083, 122, '2014-02-01 01:13:15.000000', 'temperatura', 654.0000, 'ºC'),
	(188084, 122, '2014-02-01 01:13:16.000000', 'temperatura', 1152.0000, 'ºC'),
	(188085, 122, '2014-02-01 01:13:17.000000', 'temperatura', 201.0000, 'ºC'),
	(188086, 122, '2014-02-01 01:13:18.000000', 'temperatura', 1149.0000, 'ºC'),
	(188087, 122, '2014-02-01 01:13:19.000000', 'temperatura', 343.0000, 'ºC'),
	(188088, 122, '2014-02-01 01:13:20.000000', 'temperatura', 670.0000, 'ºC'),
	(188089, 122, '2014-02-01 01:13:21.000000', 'temperatura', 1119.0000, 'ºC'),
	(188090, 122, '2014-02-01 01:13:22.000000', 'temperatura', 1185.0000, 'ºC'),
	(188091, 122, '2014-02-01 01:13:23.000000', 'temperatura', 168.0000, 'ºC'),
	(188092, 122, '2014-02-01 01:13:24.000000', 'temperatura', 888.0000, 'ºC'),
	(188093, 122, '2014-02-01 01:13:25.000000', 'temperatura', 334.0000, 'ºC'),
	(188094, 122, '2014-02-01 01:13:26.000000', 'temperatura', 209.0000, 'ºC'),
	(188095, 122, '2014-02-01 01:13:27.000000', 'temperatura', 42.0000, 'ºC'),
	(188096, 122, '2014-02-01 01:13:28.000000', 'temperatura', 784.0000, 'ºC'),
	(188097, 122, '2014-02-01 01:13:29.000000', 'temperatura', 192.0000, 'ºC'),
	(188098, 122, '2014-02-01 01:13:30.000000', 'temperatura', 1012.0000, 'ºC'),
	(188099, 122, '2014-02-01 01:13:31.000000', 'temperatura', 882.0000, 'ºC'),
	(188100, 122, '2014-02-01 01:13:32.000000', 'temperatura', 176.0000, 'ºC'),
	(188101, 122, '2014-02-01 01:13:33.000000', 'temperatura', 635.0000, 'ºC'),
	(188102, 122, '2014-02-01 01:13:34.000000', 'temperatura', 248.0000, 'ºC'),
	(188103, 122, '2014-02-01 01:13:35.000000', 'temperatura', 535.0000, 'ºC'),
	(188104, 122, '2014-02-01 01:13:36.000000', 'temperatura', 731.0000, 'ºC'),
	(188105, 122, '2014-02-01 01:13:37.000000', 'temperatura', 849.0000, 'ºC'),
	(188106, 122, '2014-02-01 01:13:38.000000', 'temperatura', 854.0000, 'ºC'),
	(188107, 122, '2014-02-01 01:13:39.000000', 'temperatura', 525.0000, 'ºC'),
	(188108, 122, '2014-02-01 01:13:40.000000', 'temperatura', 63.0000, 'ºC'),
	(188109, 122, '2014-02-01 01:13:41.000000', 'temperatura', 1141.0000, 'ºC'),
	(188110, 122, '2014-02-01 01:13:42.000000', 'temperatura', 714.0000, 'ºC'),
	(188111, 122, '2014-02-01 01:13:43.000000', 'temperatura', 150.0000, 'ºC'),
	(188112, 122, '2014-02-01 01:13:44.000000', 'temperatura', 1008.0000, 'ºC'),
	(188113, 122, '2014-02-01 01:13:45.000000', 'temperatura', 992.0000, 'ºC'),
	(188114, 122, '2014-02-01 01:13:46.000000', 'temperatura', 734.0000, 'ºC'),
	(188115, 122, '2014-02-01 01:13:47.000000', 'temperatura', 694.0000, 'ºC'),
	(188116, 122, '2014-02-01 01:13:48.000000', 'temperatura', 71.0000, 'ºC'),
	(188117, 122, '2014-02-01 01:13:49.000000', 'temperatura', 674.0000, 'ºC'),
	(188118, 122, '2014-02-01 01:13:50.000000', 'temperatura', 757.0000, 'ºC'),
	(188119, 122, '2014-02-01 01:13:51.000000', 'temperatura', 565.0000, 'ºC'),
	(188120, 122, '2014-02-01 01:13:52.000000', 'temperatura', 553.0000, 'ºC'),
	(188121, 122, '2014-02-01 01:13:53.000000', 'temperatura', 1070.0000, 'ºC'),
	(188122, 122, '2014-02-01 01:13:54.000000', 'temperatura', 93.0000, 'ºC'),
	(188123, 122, '2014-02-01 01:13:55.000000', 'temperatura', 855.0000, 'ºC'),
	(188124, 122, '2014-02-01 01:13:56.000000', 'temperatura', 398.0000, 'ºC'),
	(188125, 122, '2014-02-01 01:13:57.000000', 'temperatura', 626.0000, 'ºC'),
	(188126, 122, '2014-02-01 01:13:58.000000', 'temperatura', 737.0000, 'ºC'),
	(188127, 122, '2014-02-01 01:13:59.000000', 'temperatura', 606.0000, 'ºC'),
	(188128, 122, '2014-02-01 01:14:00.000000', 'temperatura', 818.0000, 'ºC'),
	(188129, 122, '2014-02-01 01:14:01.000000', 'temperatura', 1075.0000, 'ºC'),
	(188130, 122, '2014-02-01 01:14:02.000000', 'temperatura', 521.0000, 'ºC'),
	(188131, 122, '2014-02-01 01:14:03.000000', 'temperatura', 579.0000, 'ºC'),
	(188132, 122, '2014-02-01 01:14:04.000000', 'temperatura', 135.0000, 'ºC'),
	(188133, 122, '2014-02-01 01:14:05.000000', 'temperatura', 137.0000, 'ºC'),
	(188134, 122, '2014-02-01 01:14:06.000000', 'temperatura', 282.0000, 'ºC'),
	(188135, 122, '2014-02-01 01:14:07.000000', 'temperatura', 998.0000, 'ºC'),
	(188136, 122, '2014-02-01 01:14:08.000000', 'temperatura', 543.0000, 'ºC'),
	(188137, 122, '2014-02-01 01:14:09.000000', 'temperatura', 922.0000, 'ºC'),
	(188138, 122, '2014-02-01 01:14:10.000000', 'temperatura', 582.0000, 'ºC'),
	(188139, 122, '2014-02-01 01:14:11.000000', 'temperatura', 145.0000, 'ºC'),
	(188140, 122, '2014-02-01 01:14:12.000000', 'temperatura', 181.0000, 'ºC'),
	(188141, 122, '2014-02-01 01:14:13.000000', 'temperatura', 469.0000, 'ºC'),
	(188142, 122, '2014-02-01 01:14:14.000000', 'temperatura', 604.0000, 'ºC'),
	(188143, 122, '2014-02-01 01:14:15.000000', 'temperatura', 412.0000, 'ºC'),
	(188144, 122, '2014-02-01 01:14:16.000000', 'temperatura', 248.0000, 'ºC'),
	(188145, 122, '2014-02-01 01:14:17.000000', 'temperatura', 5.0000, 'ºC'),
	(188146, 122, '2014-02-01 01:14:18.000000', 'temperatura', 483.0000, 'ºC'),
	(188147, 122, '2014-02-01 01:14:19.000000', 'temperatura', 1198.0000, 'ºC'),
	(188148, 122, '2014-02-01 01:14:20.000000', 'temperatura', 941.0000, 'ºC'),
	(188149, 122, '2014-02-01 01:14:21.000000', 'temperatura', 1113.0000, 'ºC'),
	(188150, 122, '2014-02-01 01:14:22.000000', 'temperatura', 341.0000, 'ºC'),
	(188151, 122, '2014-02-01 01:14:23.000000', 'temperatura', 765.0000, 'ºC'),
	(188152, 122, '2014-02-01 01:14:24.000000', 'temperatura', 406.0000, 'ºC'),
	(188153, 122, '2014-02-01 01:14:25.000000', 'temperatura', 933.0000, 'ºC'),
	(188154, 122, '2014-02-01 01:14:26.000000', 'temperatura', 1049.0000, 'ºC'),
	(188155, 122, '2014-02-01 01:14:27.000000', 'temperatura', 47.0000, 'ºC'),
	(188156, 122, '2014-02-01 01:14:28.000000', 'temperatura', 690.0000, 'ºC'),
	(188157, 122, '2014-02-01 01:14:29.000000', 'temperatura', 907.0000, 'ºC'),
	(188158, 122, '2014-02-01 01:14:30.000000', 'temperatura', 66.0000, 'ºC'),
	(188159, 122, '2014-02-01 01:14:31.000000', 'temperatura', 8.0000, 'ºC'),
	(188160, 122, '2014-02-01 01:14:32.000000', 'temperatura', 1042.0000, 'ºC'),
	(188161, 122, '2014-02-01 01:14:33.000000', 'temperatura', 387.0000, 'ºC'),
	(188162, 122, '2014-02-01 01:14:34.000000', 'temperatura', 11.0000, 'ºC'),
	(188163, 122, '2014-02-01 01:14:35.000000', 'temperatura', 93.0000, 'ºC'),
	(188164, 122, '2014-02-01 01:14:36.000000', 'temperatura', 431.0000, 'ºC'),
	(188165, 122, '2014-02-01 01:14:37.000000', 'temperatura', 677.0000, 'ºC'),
	(188166, 122, '2014-02-01 01:14:38.000000', 'temperatura', 895.0000, 'ºC'),
	(188167, 122, '2014-02-01 01:14:39.000000', 'temperatura', 44.0000, 'ºC'),
	(188168, 122, '2014-02-01 01:14:40.000000', 'temperatura', 1137.0000, 'ºC'),
	(188169, 122, '2014-02-01 01:14:41.000000', 'temperatura', 752.0000, 'ºC'),
	(188170, 122, '2014-02-01 01:14:42.000000', 'temperatura', 348.0000, 'ºC'),
	(188171, 122, '2014-02-01 01:14:43.000000', 'temperatura', 686.0000, 'ºC'),
	(188172, 122, '2014-02-01 01:14:44.000000', 'temperatura', 1187.0000, 'ºC'),
	(188173, 122, '2014-02-01 01:14:45.000000', 'temperatura', 276.0000, 'ºC'),
	(188174, 122, '2014-02-01 01:14:46.000000', 'temperatura', 221.0000, 'ºC'),
	(188175, 122, '2014-02-01 01:14:47.000000', 'temperatura', 279.0000, 'ºC'),
	(188176, 122, '2014-02-01 01:14:48.000000', 'temperatura', 730.0000, 'ºC'),
	(188177, 122, '2014-02-01 01:14:49.000000', 'temperatura', 413.0000, 'ºC'),
	(188178, 122, '2014-02-01 01:14:50.000000', 'temperatura', 1077.0000, 'ºC'),
	(188179, 122, '2014-02-01 01:14:51.000000', 'temperatura', 546.0000, 'ºC'),
	(188180, 122, '2014-02-01 01:14:52.000000', 'temperatura', 698.0000, 'ºC'),
	(188181, 122, '2014-02-01 01:14:53.000000', 'temperatura', 653.0000, 'ºC'),
	(188182, 122, '2014-02-01 01:14:54.000000', 'temperatura', 1170.0000, 'ºC'),
	(188183, 122, '2014-02-01 01:14:55.000000', 'temperatura', 295.0000, 'ºC'),
	(188184, 122, '2014-02-01 01:14:56.000000', 'temperatura', 363.0000, 'ºC'),
	(188185, 122, '2014-02-01 01:14:57.000000', 'temperatura', 931.0000, 'ºC'),
	(188186, 122, '2014-02-01 01:14:58.000000', 'temperatura', 1165.0000, 'ºC'),
	(188187, 122, '2014-02-01 01:14:59.000000', 'temperatura', 632.0000, 'ºC'),
	(188188, 122, '2014-02-01 01:15:00.000000', 'temperatura', 865.0000, 'ºC'),
	(188189, 122, '2014-02-01 01:15:01.000000', 'temperatura', 30.0000, 'ºC'),
	(188190, 122, '2014-02-01 01:15:02.000000', 'temperatura', 1155.0000, 'ºC'),
	(188191, 122, '2014-02-01 01:15:03.000000', 'temperatura', 887.0000, 'ºC'),
	(188192, 122, '2014-02-01 01:15:04.000000', 'temperatura', 971.0000, 'ºC'),
	(188193, 122, '2014-02-01 01:15:05.000000', 'temperatura', 996.0000, 'ºC'),
	(188194, 122, '2014-02-01 01:15:06.000000', 'temperatura', 864.0000, 'ºC'),
	(188195, 122, '2014-02-01 01:15:07.000000', 'temperatura', 133.0000, 'ºC'),
	(188196, 122, '2014-02-01 01:15:08.000000', 'temperatura', 476.0000, 'ºC'),
	(188197, 122, '2014-02-01 01:15:09.000000', 'temperatura', 781.0000, 'ºC'),
	(188198, 122, '2014-02-01 01:15:10.000000', 'temperatura', 76.0000, 'ºC'),
	(188199, 122, '2014-02-01 01:15:11.000000', 'temperatura', 438.0000, 'ºC'),
	(188200, 122, '2014-02-01 01:15:12.000000', 'temperatura', 763.0000, 'ºC'),
	(188201, 122, '2014-02-01 01:15:13.000000', 'temperatura', 101.0000, 'ºC'),
	(188202, 122, '2014-02-01 01:15:14.000000', 'temperatura', 617.0000, 'ºC'),
	(188203, 122, '2014-02-01 01:15:15.000000', 'temperatura', 382.0000, 'ºC'),
	(188204, 122, '2014-02-01 01:15:16.000000', 'temperatura', 61.0000, 'ºC'),
	(188205, 122, '2014-02-01 01:15:17.000000', 'temperatura', 360.0000, 'ºC'),
	(188206, 122, '2014-02-01 01:15:18.000000', 'temperatura', 417.0000, 'ºC'),
	(188207, 122, '2014-02-01 01:15:19.000000', 'temperatura', 1005.0000, 'ºC'),
	(188208, 122, '2014-02-01 01:15:20.000000', 'temperatura', 175.0000, 'ºC'),
	(188209, 122, '2014-02-01 01:15:21.000000', 'temperatura', 259.0000, 'ºC'),
	(188210, 122, '2014-02-01 01:15:22.000000', 'temperatura', 771.0000, 'ºC'),
	(188211, 122, '2014-02-01 01:15:23.000000', 'temperatura', 677.0000, 'ºC'),
	(188212, 122, '2014-02-01 01:15:24.000000', 'temperatura', 1073.0000, 'ºC'),
	(188213, 122, '2014-02-01 01:15:25.000000', 'temperatura', 935.0000, 'ºC'),
	(188214, 122, '2014-02-01 01:15:26.000000', 'temperatura', 255.0000, 'ºC'),
	(188215, 122, '2014-02-01 01:15:27.000000', 'temperatura', 872.0000, 'ºC'),
	(188216, 122, '2014-02-01 01:15:28.000000', 'temperatura', 1197.0000, 'ºC'),
	(188217, 122, '2014-02-01 01:15:29.000000', 'temperatura', 966.0000, 'ºC'),
	(188218, 122, '2014-02-01 01:15:30.000000', 'temperatura', 42.0000, 'ºC'),
	(188219, 122, '2014-02-01 01:15:31.000000', 'temperatura', 912.0000, 'ºC'),
	(188220, 122, '2014-02-01 01:15:32.000000', 'temperatura', 833.0000, 'ºC'),
	(188221, 122, '2014-02-01 01:15:33.000000', 'temperatura', 230.0000, 'ºC'),
	(188222, 122, '2014-02-01 01:15:34.000000', 'temperatura', 1051.0000, 'ºC'),
	(188223, 122, '2014-02-01 01:15:35.000000', 'temperatura', 965.0000, 'ºC'),
	(188224, 122, '2014-02-01 01:15:36.000000', 'temperatura', 474.0000, 'ºC'),
	(188225, 122, '2014-02-01 01:15:37.000000', 'temperatura', 676.0000, 'ºC'),
	(188226, 122, '2014-02-01 01:15:38.000000', 'temperatura', 757.0000, 'ºC'),
	(188227, 122, '2014-02-01 01:15:39.000000', 'temperatura', 558.0000, 'ºC'),
	(188228, 122, '2014-02-01 01:15:40.000000', 'temperatura', 521.0000, 'ºC'),
	(188229, 122, '2014-02-01 01:15:41.000000', 'temperatura', 930.0000, 'ºC'),
	(188230, 122, '2014-02-01 01:15:42.000000', 'temperatura', 686.0000, 'ºC'),
	(188231, 122, '2014-02-01 01:15:43.000000', 'temperatura', 641.0000, 'ºC'),
	(188232, 122, '2014-02-01 01:15:44.000000', 'temperatura', 1147.0000, 'ºC'),
	(188233, 122, '2014-02-01 01:15:45.000000', 'temperatura', 212.0000, 'ºC'),
	(188234, 122, '2014-02-01 01:15:46.000000', 'temperatura', 22.0000, 'ºC'),
	(188235, 122, '2014-02-01 01:15:47.000000', 'temperatura', 674.0000, 'ºC'),
	(188236, 122, '2014-02-01 01:15:48.000000', 'temperatura', 904.0000, 'ºC'),
	(188237, 122, '2014-02-01 01:15:49.000000', 'temperatura', 100.0000, 'ºC'),
	(188238, 122, '2014-02-01 01:15:50.000000', 'temperatura', 187.0000, 'ºC'),
	(188239, 122, '2014-02-01 01:15:51.000000', 'temperatura', 638.0000, 'ºC'),
	(188240, 122, '2014-02-01 01:15:52.000000', 'temperatura', 227.0000, 'ºC'),
	(188241, 122, '2014-02-01 01:15:53.000000', 'temperatura', 421.0000, 'ºC'),
	(188242, 122, '2014-02-01 01:15:54.000000', 'temperatura', 224.0000, 'ºC'),
	(188243, 122, '2014-02-01 01:15:55.000000', 'temperatura', 1058.0000, 'ºC'),
	(188244, 122, '2014-02-01 01:15:56.000000', 'temperatura', 1020.0000, 'ºC'),
	(188245, 122, '2014-02-01 01:15:57.000000', 'temperatura', 724.0000, 'ºC'),
	(188246, 122, '2014-02-01 01:15:58.000000', 'temperatura', 564.0000, 'ºC'),
	(188247, 122, '2014-02-01 01:15:59.000000', 'temperatura', 646.0000, 'ºC'),
	(188248, 122, '2014-02-01 01:16:00.000000', 'temperatura', 337.0000, 'ºC'),
	(188249, 122, '2014-02-01 01:16:01.000000', 'temperatura', 950.0000, 'ºC'),
	(188250, 122, '2014-02-01 01:16:02.000000', 'temperatura', 139.0000, 'ºC'),
	(188251, 122, '2014-02-01 01:16:03.000000', 'temperatura', 247.0000, 'ºC'),
	(188252, 122, '2014-02-01 01:16:04.000000', 'temperatura', 819.0000, 'ºC'),
	(188253, 122, '2014-02-01 01:16:05.000000', 'temperatura', 952.0000, 'ºC'),
	(188254, 122, '2014-02-01 01:16:06.000000', 'temperatura', 1104.0000, 'ºC'),
	(188255, 122, '2014-02-01 01:16:07.000000', 'temperatura', 264.0000, 'ºC'),
	(188256, 122, '2014-02-01 01:16:08.000000', 'temperatura', 409.0000, 'ºC'),
	(188257, 122, '2014-02-01 01:16:09.000000', 'temperatura', 54.0000, 'ºC'),
	(188258, 122, '2014-02-01 01:16:10.000000', 'temperatura', 241.0000, 'ºC'),
	(188259, 122, '2014-02-01 01:16:11.000000', 'temperatura', 1045.0000, 'ºC'),
	(188260, 122, '2014-02-01 01:16:12.000000', 'temperatura', 904.0000, 'ºC'),
	(188261, 122, '2014-02-01 01:16:13.000000', 'temperatura', 186.0000, 'ºC'),
	(188262, 122, '2014-02-01 01:16:14.000000', 'temperatura', 616.0000, 'ºC'),
	(188263, 122, '2014-02-01 01:16:15.000000', 'temperatura', 124.0000, 'ºC'),
	(188264, 122, '2014-02-01 01:16:16.000000', 'temperatura', 1173.0000, 'ºC'),
	(188265, 122, '2014-02-01 01:16:17.000000', 'temperatura', 695.0000, 'ºC'),
	(188266, 122, '2014-02-01 01:16:18.000000', 'temperatura', 1153.0000, 'ºC'),
	(188267, 122, '2014-02-01 01:16:19.000000', 'temperatura', 83.0000, 'ºC'),
	(188268, 122, '2014-02-01 01:16:20.000000', 'temperatura', 557.0000, 'ºC'),
	(188269, 122, '2014-02-01 01:16:21.000000', 'temperatura', 137.0000, 'ºC'),
	(188270, 122, '2014-02-01 01:16:22.000000', 'temperatura', 211.0000, 'ºC'),
	(188271, 122, '2014-02-01 01:16:23.000000', 'temperatura', 648.0000, 'ºC'),
	(188272, 122, '2014-02-01 01:16:24.000000', 'temperatura', 207.0000, 'ºC'),
	(188273, 122, '2014-02-01 01:16:25.000000', 'temperatura', 292.0000, 'ºC'),
	(188274, 122, '2014-02-01 01:16:26.000000', 'temperatura', 841.0000, 'ºC'),
	(188275, 122, '2014-02-01 01:16:27.000000', 'temperatura', 927.0000, 'ºC'),
	(188276, 122, '2014-02-01 01:16:28.000000', 'temperatura', 914.0000, 'ºC'),
	(188277, 122, '2014-02-01 01:16:29.000000', 'temperatura', 589.0000, 'ºC'),
	(188278, 122, '2014-02-01 01:16:30.000000', 'temperatura', 203.0000, 'ºC'),
	(188279, 122, '2014-02-01 01:16:31.000000', 'temperatura', 450.0000, 'ºC'),
	(188280, 122, '2014-02-01 01:16:32.000000', 'temperatura', 439.0000, 'ºC'),
	(188281, 122, '2014-02-01 01:16:33.000000', 'temperatura', 845.0000, 'ºC'),
	(188282, 122, '2014-02-01 01:16:34.000000', 'temperatura', 508.0000, 'ºC'),
	(188283, 122, '2014-02-01 01:16:35.000000', 'temperatura', 7.0000, 'ºC'),
	(188284, 122, '2014-02-01 01:16:36.000000', 'temperatura', 910.0000, 'ºC'),
	(188285, 122, '2014-02-01 01:16:37.000000', 'temperatura', 930.0000, 'ºC'),
	(188286, 122, '2014-02-01 01:16:38.000000', 'temperatura', 720.0000, 'ºC'),
	(188287, 122, '2014-02-01 01:16:39.000000', 'temperatura', 810.0000, 'ºC'),
	(188288, 122, '2014-02-01 01:16:40.000000', 'temperatura', 691.0000, 'ºC'),
	(188289, 122, '2014-02-01 01:16:41.000000', 'temperatura', 1027.0000, 'ºC'),
	(188290, 122, '2014-02-01 01:16:42.000000', 'temperatura', 664.0000, 'ºC'),
	(188291, 122, '2014-02-01 01:16:43.000000', 'temperatura', 236.0000, 'ºC'),
	(188292, 122, '2014-02-01 01:16:44.000000', 'temperatura', 390.0000, 'ºC'),
	(188293, 122, '2014-02-01 01:16:45.000000', 'temperatura', 43.0000, 'ºC'),
	(188294, 122, '2014-02-01 01:16:46.000000', 'temperatura', 245.0000, 'ºC'),
	(188295, 122, '2014-02-01 01:16:47.000000', 'temperatura', 1094.0000, 'ºC'),
	(188296, 122, '2014-02-01 01:16:48.000000', 'temperatura', 1139.0000, 'ºC'),
	(188297, 122, '2014-02-01 01:16:49.000000', 'temperatura', 14.0000, 'ºC'),
	(188298, 122, '2014-02-01 01:16:50.000000', 'temperatura', 251.0000, 'ºC'),
	(188299, 122, '2014-02-01 01:16:51.000000', 'temperatura', 12.0000, 'ºC'),
	(188300, 122, '2014-02-01 01:16:52.000000', 'temperatura', 511.0000, 'ºC'),
	(188301, 122, '2014-02-01 01:16:53.000000', 'temperatura', 120.0000, 'ºC'),
	(188302, 122, '2014-02-01 01:16:54.000000', 'temperatura', 265.0000, 'ºC'),
	(188303, 122, '2014-02-01 01:16:55.000000', 'temperatura', 965.0000, 'ºC'),
	(188304, 122, '2014-02-01 01:16:56.000000', 'temperatura', 433.0000, 'ºC'),
	(188305, 122, '2014-02-01 01:16:57.000000', 'temperatura', 469.0000, 'ºC'),
	(188306, 122, '2014-02-01 01:16:58.000000', 'temperatura', 1045.0000, 'ºC'),
	(188307, 122, '2014-02-01 01:16:59.000000', 'temperatura', 219.0000, 'ºC'),
	(188308, 122, '2014-02-01 01:17:00.000000', 'temperatura', 360.0000, 'ºC'),
	(188309, 122, '2014-02-01 01:17:01.000000', 'temperatura', 1144.0000, 'ºC'),
	(188310, 122, '2014-02-01 01:17:02.000000', 'temperatura', 1040.0000, 'ºC'),
	(188311, 122, '2014-02-01 01:17:03.000000', 'temperatura', 571.0000, 'ºC'),
	(188312, 122, '2014-02-01 01:17:04.000000', 'temperatura', 932.0000, 'ºC'),
	(188313, 122, '2014-02-01 01:17:05.000000', 'temperatura', 549.0000, 'ºC'),
	(188314, 122, '2014-02-01 01:17:06.000000', 'temperatura', 1149.0000, 'ºC'),
	(188315, 122, '2014-02-01 01:17:07.000000', 'temperatura', 497.0000, 'ºC'),
	(188316, 122, '2014-02-01 01:17:08.000000', 'temperatura', 240.0000, 'ºC'),
	(188317, 122, '2014-02-01 01:17:09.000000', 'temperatura', 909.0000, 'ºC'),
	(188318, 122, '2014-02-01 01:17:10.000000', 'temperatura', 225.0000, 'ºC'),
	(188319, 122, '2014-02-01 01:17:11.000000', 'temperatura', 798.0000, 'ºC'),
	(188320, 122, '2014-02-01 01:17:12.000000', 'temperatura', 915.0000, 'ºC'),
	(188321, 122, '2014-02-01 01:17:13.000000', 'temperatura', 982.0000, 'ºC'),
	(188322, 122, '2014-02-01 01:17:14.000000', 'temperatura', 965.0000, 'ºC'),
	(188323, 122, '2014-02-01 01:17:15.000000', 'temperatura', 680.0000, 'ºC'),
	(188324, 122, '2014-02-01 01:17:16.000000', 'temperatura', 507.0000, 'ºC'),
	(188325, 122, '2014-02-01 01:17:17.000000', 'temperatura', 494.0000, 'ºC'),
	(188326, 122, '2014-02-01 01:17:18.000000', 'temperatura', 949.0000, 'ºC'),
	(188327, 122, '2014-02-01 01:17:19.000000', 'temperatura', 864.0000, 'ºC'),
	(188328, 122, '2014-02-01 01:17:20.000000', 'temperatura', 275.0000, 'ºC'),
	(188329, 122, '2014-02-01 01:17:21.000000', 'temperatura', 1184.0000, 'ºC'),
	(188330, 122, '2014-02-01 01:17:22.000000', 'temperatura', 294.0000, 'ºC'),
	(188331, 122, '2014-02-01 01:17:23.000000', 'temperatura', 318.0000, 'ºC'),
	(188332, 122, '2014-02-01 01:17:24.000000', 'temperatura', 711.0000, 'ºC'),
	(188333, 122, '2014-02-01 01:17:25.000000', 'temperatura', 199.0000, 'ºC'),
	(188334, 122, '2014-02-01 01:17:26.000000', 'temperatura', 65.0000, 'ºC'),
	(188335, 122, '2014-02-01 01:17:27.000000', 'temperatura', 927.0000, 'ºC'),
	(188336, 122, '2014-02-01 01:17:28.000000', 'temperatura', 839.0000, 'ºC'),
	(188337, 122, '2014-02-01 01:17:29.000000', 'temperatura', 216.0000, 'ºC'),
	(188338, 122, '2014-02-01 01:17:30.000000', 'temperatura', 963.0000, 'ºC'),
	(188339, 122, '2014-02-01 01:17:31.000000', 'temperatura', 568.0000, 'ºC'),
	(188340, 122, '2014-02-01 01:17:32.000000', 'temperatura', 1149.0000, 'ºC'),
	(188341, 122, '2014-02-01 01:17:33.000000', 'temperatura', 445.0000, 'ºC'),
	(188342, 122, '2014-02-01 01:17:34.000000', 'temperatura', 1177.0000, 'ºC'),
	(188343, 122, '2014-02-01 01:17:35.000000', 'temperatura', 951.0000, 'ºC'),
	(188344, 122, '2014-02-01 01:17:36.000000', 'temperatura', 25.0000, 'ºC'),
	(188345, 122, '2014-02-01 01:17:37.000000', 'temperatura', 874.0000, 'ºC'),
	(188346, 122, '2014-02-01 01:17:38.000000', 'temperatura', 694.0000, 'ºC'),
	(188347, 122, '2014-02-01 01:17:39.000000', 'temperatura', 850.0000, 'ºC'),
	(188348, 122, '2014-02-01 01:17:40.000000', 'temperatura', 967.0000, 'ºC'),
	(188349, 122, '2014-02-01 01:17:41.000000', 'temperatura', 1086.0000, 'ºC'),
	(188350, 122, '2014-02-01 01:17:42.000000', 'temperatura', 128.0000, 'ºC'),
	(188351, 122, '2014-02-01 01:17:43.000000', 'temperatura', 982.0000, 'ºC'),
	(188352, 122, '2014-02-01 01:17:44.000000', 'temperatura', 926.0000, 'ºC'),
	(188353, 122, '2014-02-01 01:17:45.000000', 'temperatura', 484.0000, 'ºC'),
	(188354, 122, '2014-02-01 01:17:46.000000', 'temperatura', 845.0000, 'ºC'),
	(188355, 122, '2014-02-01 01:17:47.000000', 'temperatura', 374.0000, 'ºC'),
	(188356, 122, '2014-02-01 01:17:48.000000', 'temperatura', 533.0000, 'ºC'),
	(188357, 122, '2014-02-01 01:17:49.000000', 'temperatura', 345.0000, 'ºC'),
	(188358, 122, '2014-02-01 01:17:50.000000', 'temperatura', 126.0000, 'ºC'),
	(188359, 122, '2014-02-01 01:17:51.000000', 'temperatura', 796.0000, 'ºC'),
	(188360, 122, '2014-02-01 01:17:52.000000', 'temperatura', 1.0000, 'ºC'),
	(188361, 122, '2014-02-01 01:17:53.000000', 'temperatura', 20.0000, 'ºC'),
	(188362, 122, '2014-02-01 01:17:54.000000', 'temperatura', 94.0000, 'ºC'),
	(188363, 122, '2014-02-01 01:17:55.000000', 'temperatura', 414.0000, 'ºC'),
	(188364, 122, '2014-02-01 01:17:56.000000', 'temperatura', 585.0000, 'ºC'),
	(188365, 122, '2014-02-01 01:17:57.000000', 'temperatura', 486.0000, 'ºC'),
	(188366, 122, '2014-02-01 01:17:58.000000', 'temperatura', 676.0000, 'ºC'),
	(188367, 122, '2014-02-01 01:17:59.000000', 'temperatura', 723.0000, 'ºC'),
	(188368, 122, '2014-02-01 01:18:00.000000', 'temperatura', 388.0000, 'ºC'),
	(188369, 122, '2014-02-01 01:18:01.000000', 'temperatura', 971.0000, 'ºC'),
	(188370, 122, '2014-02-01 01:18:02.000000', 'temperatura', 92.0000, 'ºC'),
	(188371, 122, '2014-02-01 01:18:03.000000', 'temperatura', 1149.0000, 'ºC'),
	(188372, 122, '2014-02-01 01:18:04.000000', 'temperatura', 667.0000, 'ºC'),
	(188373, 122, '2014-02-01 01:18:05.000000', 'temperatura', 1088.0000, 'ºC'),
	(188374, 122, '2014-02-01 01:18:06.000000', 'temperatura', 1041.0000, 'ºC'),
	(188375, 122, '2014-02-01 01:18:07.000000', 'temperatura', 741.0000, 'ºC'),
	(188376, 122, '2014-02-01 01:18:08.000000', 'temperatura', 583.0000, 'ºC'),
	(188377, 122, '2014-02-01 01:18:09.000000', 'temperatura', 690.0000, 'ºC'),
	(188378, 122, '2014-02-01 01:18:10.000000', 'temperatura', 505.0000, 'ºC'),
	(188379, 122, '2014-02-01 01:18:11.000000', 'temperatura', 454.0000, 'ºC'),
	(188380, 122, '2014-02-01 01:18:12.000000', 'temperatura', 754.0000, 'ºC'),
	(188381, 122, '2014-02-01 01:18:13.000000', 'temperatura', 10.0000, 'ºC'),
	(188382, 122, '2014-02-01 01:18:14.000000', 'temperatura', 187.0000, 'ºC'),
	(188383, 122, '2014-02-01 01:18:15.000000', 'temperatura', 908.0000, 'ºC'),
	(188384, 122, '2014-02-01 01:18:16.000000', 'temperatura', 378.0000, 'ºC'),
	(188385, 122, '2014-02-01 01:18:17.000000', 'temperatura', 365.0000, 'ºC'),
	(188386, 122, '2014-02-01 01:18:18.000000', 'temperatura', 693.0000, 'ºC'),
	(188387, 122, '2014-02-01 01:18:19.000000', 'temperatura', 1172.0000, 'ºC'),
	(188388, 122, '2014-02-01 01:18:20.000000', 'temperatura', 178.0000, 'ºC'),
	(188389, 122, '2014-02-01 01:18:21.000000', 'temperatura', 978.0000, 'ºC'),
	(188390, 122, '2014-02-01 01:18:22.000000', 'temperatura', 754.0000, 'ºC'),
	(188391, 122, '2014-02-01 01:18:23.000000', 'temperatura', 835.0000, 'ºC'),
	(188392, 122, '2014-02-01 01:18:24.000000', 'temperatura', 716.0000, 'ºC'),
	(188393, 122, '2014-02-01 01:18:25.000000', 'temperatura', 1076.0000, 'ºC'),
	(188394, 122, '2014-02-01 01:18:26.000000', 'temperatura', 831.0000, 'ºC'),
	(188395, 122, '2014-02-01 01:18:27.000000', 'temperatura', 927.0000, 'ºC'),
	(188396, 122, '2014-02-01 01:18:28.000000', 'temperatura', 943.0000, 'ºC'),
	(188397, 122, '2014-02-01 01:18:29.000000', 'temperatura', 733.0000, 'ºC'),
	(188398, 122, '2014-02-01 01:18:30.000000', 'temperatura', 838.0000, 'ºC'),
	(188399, 122, '2014-02-01 01:18:31.000000', 'temperatura', 790.0000, 'ºC'),
	(188400, 122, '2014-02-01 01:18:32.000000', 'temperatura', 238.0000, 'ºC'),
	(188401, 122, '2014-02-01 01:18:33.000000', 'temperatura', 22.0000, 'ºC'),
	(188402, 122, '2014-02-01 01:18:34.000000', 'temperatura', 595.0000, 'ºC'),
	(188403, 122, '2014-02-01 01:18:35.000000', 'temperatura', 511.0000, 'ºC'),
	(188404, 122, '2014-02-01 01:18:36.000000', 'temperatura', 769.0000, 'ºC'),
	(188405, 122, '2014-02-01 01:18:37.000000', 'temperatura', 1113.0000, 'ºC'),
	(188406, 122, '2014-02-01 01:18:38.000000', 'temperatura', 859.0000, 'ºC'),
	(188407, 122, '2014-02-01 01:18:39.000000', 'temperatura', 956.0000, 'ºC'),
	(188408, 122, '2014-02-01 01:18:40.000000', 'temperatura', 1005.0000, 'ºC'),
	(188409, 122, '2014-02-01 01:18:41.000000', 'temperatura', 957.0000, 'ºC'),
	(188410, 122, '2014-02-01 01:18:42.000000', 'temperatura', 572.0000, 'ºC'),
	(188411, 122, '2014-02-01 01:18:43.000000', 'temperatura', 1189.0000, 'ºC'),
	(188412, 122, '2014-02-01 01:18:44.000000', 'temperatura', 630.0000, 'ºC'),
	(188413, 122, '2014-02-01 01:18:45.000000', 'temperatura', 782.0000, 'ºC'),
	(188414, 122, '2014-02-01 01:18:46.000000', 'temperatura', 822.0000, 'ºC'),
	(188415, 122, '2014-02-01 01:18:47.000000', 'temperatura', 564.0000, 'ºC'),
	(188416, 122, '2014-02-01 01:18:48.000000', 'temperatura', 354.0000, 'ºC'),
	(188417, 122, '2014-02-01 01:18:49.000000', 'temperatura', 80.0000, 'ºC'),
	(188418, 122, '2014-02-01 01:18:50.000000', 'temperatura', 537.0000, 'ºC'),
	(188419, 122, '2014-02-01 01:18:51.000000', 'temperatura', 45.0000, 'ºC'),
	(188420, 122, '2014-02-01 01:18:52.000000', 'temperatura', 1016.0000, 'ºC'),
	(188421, 122, '2014-02-01 01:18:53.000000', 'temperatura', 145.0000, 'ºC'),
	(188422, 122, '2014-02-01 01:18:54.000000', 'temperatura', 75.0000, 'ºC'),
	(188423, 122, '2014-02-01 01:18:55.000000', 'temperatura', 1144.0000, 'ºC'),
	(188424, 122, '2014-02-01 01:18:56.000000', 'temperatura', 693.0000, 'ºC'),
	(188425, 122, '2014-02-01 01:18:57.000000', 'temperatura', 36.0000, 'ºC'),
	(188426, 122, '2014-02-01 01:18:58.000000', 'temperatura', 499.0000, 'ºC'),
	(188427, 122, '2014-02-01 01:18:59.000000', 'temperatura', 1188.0000, 'ºC'),
	(188428, 122, '2014-02-01 01:19:00.000000', 'temperatura', 846.0000, 'ºC'),
	(188429, 122, '2014-02-01 01:19:01.000000', 'temperatura', 664.0000, 'ºC'),
	(188430, 122, '2014-02-01 01:19:02.000000', 'temperatura', 782.0000, 'ºC'),
	(188431, 122, '2014-02-01 01:19:03.000000', 'temperatura', 721.0000, 'ºC'),
	(188432, 122, '2014-02-01 01:19:04.000000', 'temperatura', 59.0000, 'ºC'),
	(188433, 122, '2014-02-01 01:19:05.000000', 'temperatura', 534.0000, 'ºC'),
	(188434, 122, '2014-02-01 01:19:06.000000', 'temperatura', 92.0000, 'ºC'),
	(188435, 122, '2014-02-01 01:19:07.000000', 'temperatura', 57.0000, 'ºC'),
	(188436, 122, '2014-02-01 01:19:08.000000', 'temperatura', 10.0000, 'ºC'),
	(188437, 122, '2014-02-01 01:19:09.000000', 'temperatura', 1080.0000, 'ºC'),
	(188438, 122, '2014-02-01 01:19:10.000000', 'temperatura', 570.0000, 'ºC'),
	(188439, 122, '2014-02-01 01:19:11.000000', 'temperatura', 811.0000, 'ºC'),
	(188440, 122, '2014-02-01 01:19:12.000000', 'temperatura', 1144.0000, 'ºC'),
	(188441, 122, '2014-02-01 01:19:13.000000', 'temperatura', 889.0000, 'ºC'),
	(188442, 122, '2014-02-01 01:19:14.000000', 'temperatura', 1013.0000, 'ºC'),
	(188443, 122, '2014-02-01 01:19:15.000000', 'temperatura', 1199.0000, 'ºC'),
	(188444, 122, '2014-02-01 01:19:16.000000', 'temperatura', 556.0000, 'ºC'),
	(188445, 122, '2014-02-01 01:19:17.000000', 'temperatura', 384.0000, 'ºC'),
	(188446, 122, '2014-02-01 01:19:18.000000', 'temperatura', 251.0000, 'ºC'),
	(188447, 122, '2014-02-01 01:19:19.000000', 'temperatura', 102.0000, 'ºC'),
	(188448, 122, '2014-02-01 01:19:20.000000', 'temperatura', 961.0000, 'ºC'),
	(188449, 122, '2014-02-01 01:19:21.000000', 'temperatura', 897.0000, 'ºC'),
	(188450, 122, '2014-02-01 01:19:22.000000', 'temperatura', 402.0000, 'ºC'),
	(188451, 122, '2014-02-01 01:19:23.000000', 'temperatura', 522.0000, 'ºC'),
	(188452, 122, '2014-02-01 01:19:24.000000', 'temperatura', 203.0000, 'ºC'),
	(188453, 122, '2014-02-01 01:19:25.000000', 'temperatura', 651.0000, 'ºC'),
	(188454, 122, '2014-02-01 01:19:26.000000', 'temperatura', 247.0000, 'ºC'),
	(188455, 122, '2014-02-01 01:19:27.000000', 'temperatura', 482.0000, 'ºC'),
	(188456, 122, '2014-02-01 01:19:28.000000', 'temperatura', 470.0000, 'ºC'),
	(188457, 122, '2014-02-01 01:19:29.000000', 'temperatura', 902.0000, 'ºC'),
	(188458, 122, '2014-02-01 01:19:30.000000', 'temperatura', 702.0000, 'ºC'),
	(188459, 122, '2014-02-01 01:19:31.000000', 'temperatura', 803.0000, 'ºC'),
	(188460, 122, '2014-02-01 01:19:32.000000', 'temperatura', 709.0000, 'ºC'),
	(188461, 122, '2014-02-01 01:19:33.000000', 'temperatura', 1137.0000, 'ºC'),
	(188462, 122, '2014-02-01 01:19:34.000000', 'temperatura', 1158.0000, 'ºC'),
	(188463, 122, '2014-02-01 01:19:35.000000', 'temperatura', 1182.0000, 'ºC'),
	(188464, 122, '2014-02-01 01:19:36.000000', 'temperatura', 33.0000, 'ºC'),
	(188465, 122, '2014-02-01 01:19:37.000000', 'temperatura', 223.0000, 'ºC'),
	(188466, 122, '2014-02-01 01:19:38.000000', 'temperatura', 1015.0000, 'ºC'),
	(188467, 122, '2014-02-01 01:19:39.000000', 'temperatura', 805.0000, 'ºC'),
	(188468, 122, '2014-02-01 01:19:40.000000', 'temperatura', 982.0000, 'ºC'),
	(188469, 122, '2014-02-01 01:19:41.000000', 'temperatura', 97.0000, 'ºC'),
	(188470, 122, '2014-02-01 01:19:42.000000', 'temperatura', 1137.0000, 'ºC'),
	(188471, 122, '2014-02-01 01:19:43.000000', 'temperatura', 596.0000, 'ºC'),
	(188472, 122, '2014-02-01 01:19:44.000000', 'temperatura', 771.0000, 'ºC'),
	(188473, 122, '2014-02-01 01:19:45.000000', 'temperatura', 866.0000, 'ºC'),
	(188474, 122, '2014-02-01 01:19:46.000000', 'temperatura', 818.0000, 'ºC'),
	(188475, 122, '2014-02-01 01:19:47.000000', 'temperatura', 294.0000, 'ºC'),
	(188476, 122, '2014-02-01 01:19:48.000000', 'temperatura', 215.0000, 'ºC'),
	(188477, 122, '2014-02-01 01:19:49.000000', 'temperatura', 192.0000, 'ºC'),
	(188478, 122, '2014-02-01 01:19:50.000000', 'temperatura', 318.0000, 'ºC'),
	(188479, 122, '2014-02-01 01:19:51.000000', 'temperatura', 1013.0000, 'ºC'),
	(188480, 122, '2014-02-01 01:19:52.000000', 'temperatura', 511.0000, 'ºC'),
	(188481, 122, '2014-02-01 01:19:53.000000', 'temperatura', 718.0000, 'ºC'),
	(188482, 122, '2014-02-01 01:19:54.000000', 'temperatura', 858.0000, 'ºC'),
	(188483, 122, '2014-02-01 01:19:55.000000', 'temperatura', 937.0000, 'ºC'),
	(188484, 122, '2014-02-01 01:19:56.000000', 'temperatura', 909.0000, 'ºC'),
	(188485, 122, '2014-02-01 01:19:57.000000', 'temperatura', 536.0000, 'ºC'),
	(188486, 122, '2014-02-01 01:19:58.000000', 'temperatura', 1154.0000, 'ºC'),
	(188487, 122, '2014-02-01 01:19:59.000000', 'temperatura', 562.0000, 'ºC'),
	(188488, 122, '2014-02-01 01:20:00.000000', 'temperatura', 547.0000, 'ºC'),
	(188489, 122, '2014-02-01 01:20:01.000000', 'temperatura', 1050.0000, 'ºC'),
	(188490, 122, '2014-02-01 01:20:02.000000', 'temperatura', 10.0000, 'ºC'),
	(188491, 122, '2014-02-01 01:20:03.000000', 'temperatura', 498.0000, 'ºC'),
	(188492, 122, '2014-02-01 01:20:04.000000', 'temperatura', 64.0000, 'ºC'),
	(188493, 122, '2014-02-01 01:20:05.000000', 'temperatura', 26.0000, 'ºC'),
	(188494, 122, '2014-02-01 01:20:06.000000', 'temperatura', 1136.0000, 'ºC'),
	(188495, 122, '2014-02-01 01:20:07.000000', 'temperatura', 805.0000, 'ºC'),
	(188496, 122, '2014-02-01 01:20:08.000000', 'temperatura', 616.0000, 'ºC'),
	(188497, 122, '2014-02-01 01:20:09.000000', 'temperatura', 666.0000, 'ºC'),
	(188498, 122, '2014-02-01 01:20:10.000000', 'temperatura', 282.0000, 'ºC'),
	(188499, 122, '2014-02-01 01:20:11.000000', 'temperatura', 612.0000, 'ºC'),
	(188500, 122, '2014-02-01 01:20:12.000000', 'temperatura', 1017.0000, 'ºC'),
	(188501, 122, '2014-02-01 01:20:13.000000', 'temperatura', 848.0000, 'ºC'),
	(188502, 122, '2014-02-01 01:20:14.000000', 'temperatura', 1190.0000, 'ºC'),
	(188503, 122, '2014-02-01 01:20:15.000000', 'temperatura', 1004.0000, 'ºC'),
	(188504, 122, '2014-02-01 01:20:16.000000', 'temperatura', 254.0000, 'ºC'),
	(188505, 122, '2014-02-01 01:20:17.000000', 'temperatura', 657.0000, 'ºC'),
	(188506, 122, '2014-02-01 01:20:18.000000', 'temperatura', 124.0000, 'ºC'),
	(188507, 122, '2014-02-01 01:20:19.000000', 'temperatura', 1048.0000, 'ºC'),
	(188508, 122, '2014-02-01 01:20:20.000000', 'temperatura', 67.0000, 'ºC'),
	(188509, 122, '2014-02-01 01:20:21.000000', 'temperatura', 794.0000, 'ºC'),
	(188510, 122, '2014-02-01 01:20:22.000000', 'temperatura', 170.0000, 'ºC'),
	(188511, 122, '2014-02-01 01:20:23.000000', 'temperatura', 866.0000, 'ºC'),
	(188512, 122, '2014-02-01 01:20:24.000000', 'temperatura', 222.0000, 'ºC'),
	(188513, 122, '2014-02-01 01:20:25.000000', 'temperatura', 912.0000, 'ºC'),
	(188514, 122, '2014-02-01 01:20:26.000000', 'temperatura', 295.0000, 'ºC'),
	(188515, 122, '2014-02-01 01:20:27.000000', 'temperatura', 1138.0000, 'ºC'),
	(188516, 122, '2014-02-01 01:20:28.000000', 'temperatura', 5.0000, 'ºC'),
	(188517, 122, '2014-02-01 01:20:29.000000', 'temperatura', 213.0000, 'ºC'),
	(188518, 122, '2014-02-01 01:20:30.000000', 'temperatura', 1051.0000, 'ºC'),
	(188519, 122, '2014-02-01 01:20:31.000000', 'temperatura', 1018.0000, 'ºC'),
	(188520, 122, '2014-02-01 01:20:32.000000', 'temperatura', 735.0000, 'ºC'),
	(188521, 122, '2014-02-01 01:20:33.000000', 'temperatura', 621.0000, 'ºC'),
	(188522, 122, '2014-02-01 01:20:34.000000', 'temperatura', 900.0000, 'ºC'),
	(188523, 122, '2014-02-01 01:20:35.000000', 'temperatura', 239.0000, 'ºC'),
	(188524, 122, '2014-02-01 01:20:36.000000', 'temperatura', 895.0000, 'ºC'),
	(188525, 122, '2014-02-01 01:20:37.000000', 'temperatura', 157.0000, 'ºC'),
	(188526, 122, '2014-02-01 01:20:38.000000', 'temperatura', 501.0000, 'ºC'),
	(188527, 122, '2014-02-01 01:20:39.000000', 'temperatura', 834.0000, 'ºC'),
	(188528, 122, '2014-02-01 01:20:40.000000', 'temperatura', 266.0000, 'ºC'),
	(188529, 122, '2014-02-01 01:20:41.000000', 'temperatura', 32.0000, 'ºC'),
	(188530, 122, '2014-02-01 01:20:42.000000', 'temperatura', 560.0000, 'ºC'),
	(188531, 122, '2014-02-01 01:20:43.000000', 'temperatura', 304.0000, 'ºC'),
	(188532, 122, '2014-02-01 01:20:44.000000', 'temperatura', 1042.0000, 'ºC'),
	(188533, 122, '2014-02-01 01:20:45.000000', 'temperatura', 697.0000, 'ºC'),
	(188534, 122, '2014-02-01 01:20:46.000000', 'temperatura', 362.0000, 'ºC'),
	(188535, 122, '2014-02-01 01:20:47.000000', 'temperatura', 920.0000, 'ºC'),
	(188536, 122, '2014-02-01 01:20:48.000000', 'temperatura', 1112.0000, 'ºC'),
	(188537, 122, '2014-02-01 01:20:49.000000', 'temperatura', 401.0000, 'ºC'),
	(188538, 122, '2014-02-01 01:20:50.000000', 'temperatura', 1072.0000, 'ºC'),
	(188539, 122, '2014-02-01 01:20:51.000000', 'temperatura', 555.0000, 'ºC'),
	(188540, 122, '2014-02-01 01:20:52.000000', 'temperatura', 759.0000, 'ºC'),
	(188541, 122, '2014-02-01 01:20:53.000000', 'temperatura', 931.0000, 'ºC'),
	(188542, 122, '2014-02-01 01:20:54.000000', 'temperatura', 1180.0000, 'ºC'),
	(188543, 122, '2014-02-01 01:20:55.000000', 'temperatura', 708.0000, 'ºC'),
	(188544, 122, '2014-02-01 01:20:56.000000', 'temperatura', 1199.0000, 'ºC'),
	(188545, 122, '2014-02-01 01:20:57.000000', 'temperatura', 273.0000, 'ºC'),
	(188546, 122, '2014-02-01 01:20:58.000000', 'temperatura', 168.0000, 'ºC'),
	(188547, 122, '2014-02-01 01:20:59.000000', 'temperatura', 23.0000, 'ºC'),
	(188548, 122, '2014-02-01 01:21:00.000000', 'temperatura', 811.0000, 'ºC'),
	(188549, 122, '2014-02-01 01:21:01.000000', 'temperatura', 386.0000, 'ºC'),
	(188550, 122, '2014-02-01 01:21:02.000000', 'temperatura', 696.0000, 'ºC'),
	(188551, 122, '2014-02-01 01:21:03.000000', 'temperatura', 1124.0000, 'ºC'),
	(188552, 122, '2014-02-01 01:21:04.000000', 'temperatura', 1131.0000, 'ºC'),
	(188553, 122, '2014-02-01 01:21:05.000000', 'temperatura', 1086.0000, 'ºC'),
	(188554, 122, '2014-02-01 01:21:06.000000', 'temperatura', 836.0000, 'ºC'),
	(188555, 122, '2014-02-01 01:21:07.000000', 'temperatura', 921.0000, 'ºC'),
	(188556, 122, '2014-02-01 01:21:08.000000', 'temperatura', 900.0000, 'ºC'),
	(188557, 122, '2014-02-01 01:21:09.000000', 'temperatura', 536.0000, 'ºC'),
	(188558, 122, '2014-02-01 01:21:10.000000', 'temperatura', 1181.0000, 'ºC'),
	(188559, 122, '2014-02-01 01:21:11.000000', 'temperatura', 699.0000, 'ºC'),
	(188560, 122, '2014-02-01 01:21:12.000000', 'temperatura', 1153.0000, 'ºC'),
	(188561, 122, '2014-02-01 01:21:13.000000', 'temperatura', 65.0000, 'ºC'),
	(188562, 122, '2014-02-01 01:21:14.000000', 'temperatura', 470.0000, 'ºC'),
	(188563, 122, '2014-02-01 01:21:15.000000', 'temperatura', 954.0000, 'ºC'),
	(188564, 122, '2014-02-01 01:21:16.000000', 'temperatura', 959.0000, 'ºC'),
	(188565, 122, '2014-02-01 01:21:17.000000', 'temperatura', 737.0000, 'ºC'),
	(188566, 122, '2014-02-01 01:21:18.000000', 'temperatura', 806.0000, 'ºC'),
	(188567, 122, '2014-02-01 01:21:19.000000', 'temperatura', 618.0000, 'ºC'),
	(188568, 122, '2014-02-01 01:21:20.000000', 'temperatura', 674.0000, 'ºC'),
	(188569, 122, '2014-02-01 01:21:21.000000', 'temperatura', 316.0000, 'ºC'),
	(188570, 122, '2014-02-01 01:21:22.000000', 'temperatura', 760.0000, 'ºC'),
	(188571, 122, '2014-02-01 01:21:23.000000', 'temperatura', 450.0000, 'ºC'),
	(188572, 122, '2014-02-01 01:21:24.000000', 'temperatura', 1173.0000, 'ºC'),
	(188573, 122, '2014-02-01 01:21:25.000000', 'temperatura', 915.0000, 'ºC'),
	(188574, 122, '2014-02-01 01:21:26.000000', 'temperatura', 1055.0000, 'ºC'),
	(188575, 122, '2014-02-01 01:21:27.000000', 'temperatura', 133.0000, 'ºC'),
	(188576, 122, '2014-02-01 01:21:28.000000', 'temperatura', 1100.0000, 'ºC'),
	(188577, 122, '2014-02-01 01:21:29.000000', 'temperatura', 303.0000, 'ºC'),
	(188578, 122, '2014-02-01 01:21:30.000000', 'temperatura', 614.0000, 'ºC'),
	(188579, 122, '2014-02-01 01:21:31.000000', 'temperatura', 962.0000, 'ºC'),
	(188580, 122, '2014-02-01 01:21:32.000000', 'temperatura', 568.0000, 'ºC'),
	(188581, 122, '2014-02-01 01:21:33.000000', 'temperatura', 1154.0000, 'ºC'),
	(188582, 122, '2014-02-01 01:21:34.000000', 'temperatura', 468.0000, 'ºC'),
	(188583, 122, '2014-02-01 01:21:35.000000', 'temperatura', 79.0000, 'ºC'),
	(188584, 122, '2014-02-01 01:21:36.000000', 'temperatura', 192.0000, 'ºC'),
	(188585, 122, '2014-02-01 01:21:37.000000', 'temperatura', 721.0000, 'ºC'),
	(188586, 122, '2014-02-01 01:21:38.000000', 'temperatura', 632.0000, 'ºC'),
	(188587, 122, '2014-02-01 01:21:39.000000', 'temperatura', 995.0000, 'ºC'),
	(188588, 122, '2014-02-01 01:21:40.000000', 'temperatura', 680.0000, 'ºC'),
	(188589, 122, '2014-02-01 01:21:41.000000', 'temperatura', 417.0000, 'ºC'),
	(188590, 122, '2014-02-01 01:21:42.000000', 'temperatura', 46.0000, 'ºC'),
	(188591, 122, '2014-02-01 01:21:43.000000', 'temperatura', 177.0000, 'ºC'),
	(188592, 122, '2014-02-01 01:21:44.000000', 'temperatura', 748.0000, 'ºC'),
	(188593, 122, '2014-02-01 01:21:45.000000', 'temperatura', 810.0000, 'ºC'),
	(188594, 122, '2014-02-01 01:21:46.000000', 'temperatura', 605.0000, 'ºC'),
	(188595, 122, '2014-02-01 01:21:47.000000', 'temperatura', 595.0000, 'ºC'),
	(188596, 122, '2014-02-01 01:21:48.000000', 'temperatura', 1162.0000, 'ºC'),
	(188597, 122, '2014-02-01 01:21:49.000000', 'temperatura', 426.0000, 'ºC'),
	(188598, 122, '2014-02-01 01:21:50.000000', 'temperatura', 1045.0000, 'ºC'),
	(188599, 122, '2014-02-01 01:21:51.000000', 'temperatura', 346.0000, 'ºC'),
	(188600, 122, '2014-02-01 01:21:52.000000', 'temperatura', 996.0000, 'ºC'),
	(188601, 122, '2014-02-01 01:21:53.000000', 'temperatura', 343.0000, 'ºC'),
	(188602, 122, '2014-02-01 01:21:54.000000', 'temperatura', 1129.0000, 'ºC'),
	(188603, 122, '2014-02-01 01:21:55.000000', 'temperatura', 1017.0000, 'ºC'),
	(188604, 122, '2014-02-01 01:21:56.000000', 'temperatura', 495.0000, 'ºC'),
	(188605, 122, '2014-02-01 01:21:57.000000', 'temperatura', 628.0000, 'ºC'),
	(188606, 122, '2014-02-01 01:21:58.000000', 'temperatura', 454.0000, 'ºC'),
	(188607, 122, '2014-02-01 01:21:59.000000', 'temperatura', 386.0000, 'ºC'),
	(188608, 122, '2014-02-01 01:22:00.000000', 'temperatura', 567.0000, 'ºC'),
	(188609, 122, '2014-02-01 01:22:01.000000', 'temperatura', 479.0000, 'ºC'),
	(188610, 122, '2014-02-01 01:22:02.000000', 'temperatura', 695.0000, 'ºC'),
	(188611, 122, '2014-02-01 01:22:03.000000', 'temperatura', 839.0000, 'ºC'),
	(188612, 122, '2014-02-01 01:22:04.000000', 'temperatura', 912.0000, 'ºC'),
	(188613, 122, '2014-02-01 01:22:05.000000', 'temperatura', 841.0000, 'ºC'),
	(188614, 122, '2014-02-01 01:22:06.000000', 'temperatura', 269.0000, 'ºC'),
	(188615, 122, '2014-02-01 01:22:07.000000', 'temperatura', 22.0000, 'ºC'),
	(188616, 122, '2014-02-01 01:22:08.000000', 'temperatura', 506.0000, 'ºC'),
	(188617, 122, '2014-02-01 01:22:09.000000', 'temperatura', 63.0000, 'ºC'),
	(188618, 122, '2014-02-01 01:22:10.000000', 'temperatura', 1196.0000, 'ºC'),
	(188619, 122, '2014-02-01 01:22:11.000000', 'temperatura', 992.0000, 'ºC'),
	(188620, 122, '2014-02-01 01:22:12.000000', 'temperatura', 174.0000, 'ºC'),
	(188621, 122, '2014-02-01 01:22:13.000000', 'temperatura', 294.0000, 'ºC'),
	(188622, 122, '2014-02-01 01:22:14.000000', 'temperatura', 947.0000, 'ºC'),
	(188623, 122, '2014-02-01 01:22:15.000000', 'temperatura', 253.0000, 'ºC'),
	(188624, 122, '2014-02-01 01:22:16.000000', 'temperatura', 826.0000, 'ºC'),
	(188625, 122, '2014-02-01 01:22:17.000000', 'temperatura', 971.0000, 'ºC'),
	(188626, 122, '2014-02-01 01:22:18.000000', 'temperatura', 1178.0000, 'ºC'),
	(188627, 122, '2014-02-01 01:22:19.000000', 'temperatura', 575.0000, 'ºC'),
	(188628, 122, '2014-02-01 01:22:20.000000', 'temperatura', 544.0000, 'ºC'),
	(188629, 122, '2014-02-01 01:22:21.000000', 'temperatura', 997.0000, 'ºC'),
	(188630, 122, '2014-02-01 01:22:22.000000', 'temperatura', 951.0000, 'ºC'),
	(188631, 122, '2014-02-01 01:22:23.000000', 'temperatura', 564.0000, 'ºC'),
	(188632, 122, '2014-02-01 01:22:24.000000', 'temperatura', 1168.0000, 'ºC'),
	(188633, 122, '2014-02-01 01:22:25.000000', 'temperatura', 549.0000, 'ºC'),
	(188634, 122, '2014-02-01 01:22:26.000000', 'temperatura', 440.0000, 'ºC'),
	(188635, 122, '2014-02-01 01:22:27.000000', 'temperatura', 556.0000, 'ºC'),
	(188636, 122, '2014-02-01 01:22:28.000000', 'temperatura', 260.0000, 'ºC'),
	(188637, 122, '2014-02-01 01:22:29.000000', 'temperatura', 834.0000, 'ºC'),
	(188638, 122, '2014-02-01 01:22:30.000000', 'temperatura', 987.0000, 'ºC'),
	(188639, 122, '2014-02-01 01:22:31.000000', 'temperatura', 35.0000, 'ºC'),
	(188640, 122, '2014-02-01 01:22:32.000000', 'temperatura', 816.0000, 'ºC'),
	(188641, 122, '2014-02-01 01:22:33.000000', 'temperatura', 373.0000, 'ºC'),
	(188642, 122, '2014-02-01 01:22:34.000000', 'temperatura', 620.0000, 'ºC'),
	(188643, 122, '2014-02-01 01:22:35.000000', 'temperatura', 781.0000, 'ºC'),
	(188644, 122, '2014-02-01 01:22:36.000000', 'temperatura', 845.0000, 'ºC'),
	(188645, 122, '2014-02-01 01:22:37.000000', 'temperatura', 685.0000, 'ºC'),
	(188646, 122, '2014-02-01 01:22:38.000000', 'temperatura', 887.0000, 'ºC'),
	(188647, 122, '2014-02-01 01:22:39.000000', 'temperatura', 1184.0000, 'ºC'),
	(188648, 122, '2014-02-01 01:22:40.000000', 'temperatura', 856.0000, 'ºC'),
	(188649, 122, '2014-02-01 01:22:41.000000', 'temperatura', 731.0000, 'ºC'),
	(188650, 122, '2014-02-01 01:22:42.000000', 'temperatura', 1087.0000, 'ºC'),
	(188651, 122, '2014-02-01 01:22:43.000000', 'temperatura', 843.0000, 'ºC'),
	(188652, 122, '2014-02-01 01:22:44.000000', 'temperatura', 954.0000, 'ºC'),
	(188653, 122, '2014-02-01 01:22:45.000000', 'temperatura', 1040.0000, 'ºC'),
	(188654, 122, '2014-02-01 01:22:46.000000', 'temperatura', 1141.0000, 'ºC'),
	(188655, 122, '2014-02-01 01:22:47.000000', 'temperatura', 185.0000, 'ºC'),
	(188656, 122, '2014-02-01 01:22:48.000000', 'temperatura', 1101.0000, 'ºC'),
	(188657, 122, '2014-02-01 01:22:49.000000', 'temperatura', 153.0000, 'ºC'),
	(188658, 122, '2014-02-01 01:22:50.000000', 'temperatura', 1063.0000, 'ºC'),
	(188659, 122, '2014-02-01 01:22:51.000000', 'temperatura', 54.0000, 'ºC'),
	(188660, 122, '2014-02-01 01:22:52.000000', 'temperatura', 681.0000, 'ºC'),
	(188661, 122, '2014-02-01 01:22:53.000000', 'temperatura', 844.0000, 'ºC'),
	(188662, 122, '2014-02-01 01:22:54.000000', 'temperatura', 977.0000, 'ºC'),
	(188663, 122, '2014-02-01 01:22:55.000000', 'temperatura', 1156.0000, 'ºC'),
	(188664, 122, '2014-02-01 01:22:56.000000', 'temperatura', 448.0000, 'ºC'),
	(188665, 122, '2014-02-01 01:22:57.000000', 'temperatura', 1173.0000, 'ºC'),
	(188666, 122, '2014-02-01 01:22:58.000000', 'temperatura', 921.0000, 'ºC'),
	(188667, 122, '2014-02-01 01:22:59.000000', 'temperatura', 1088.0000, 'ºC'),
	(188668, 122, '2014-02-01 01:23:00.000000', 'temperatura', 276.0000, 'ºC'),
	(188669, 122, '2014-02-01 01:23:01.000000', 'temperatura', 518.0000, 'ºC'),
	(188670, 122, '2014-02-01 01:23:02.000000', 'temperatura', 562.0000, 'ºC'),
	(188671, 122, '2014-02-01 01:23:03.000000', 'temperatura', 57.0000, 'ºC'),
	(188672, 122, '2014-02-01 01:23:04.000000', 'temperatura', 1000.0000, 'ºC'),
	(188673, 122, '2014-02-01 01:23:05.000000', 'temperatura', 29.0000, 'ºC'),
	(188674, 122, '2014-02-01 01:23:06.000000', 'temperatura', 746.0000, 'ºC'),
	(188675, 122, '2014-02-01 01:23:07.000000', 'temperatura', 43.0000, 'ºC'),
	(188676, 122, '2014-02-01 01:23:08.000000', 'temperatura', 379.0000, 'ºC'),
	(188677, 122, '2014-02-01 01:23:09.000000', 'temperatura', 566.0000, 'ºC'),
	(188678, 122, '2014-02-01 01:23:10.000000', 'temperatura', 493.0000, 'ºC'),
	(188679, 122, '2014-02-01 01:23:11.000000', 'temperatura', 767.0000, 'ºC'),
	(188680, 122, '2014-02-01 01:23:12.000000', 'temperatura', 1156.0000, 'ºC'),
	(188681, 122, '2014-02-01 01:23:13.000000', 'temperatura', 1079.0000, 'ºC'),
	(188682, 122, '2014-02-01 01:23:14.000000', 'temperatura', 730.0000, 'ºC'),
	(188683, 122, '2014-02-01 01:23:15.000000', 'temperatura', 411.0000, 'ºC'),
	(188684, 122, '2014-02-01 01:23:16.000000', 'temperatura', 1066.0000, 'ºC'),
	(188685, 122, '2014-02-01 01:23:17.000000', 'temperatura', 497.0000, 'ºC'),
	(188686, 122, '2014-02-01 01:23:18.000000', 'temperatura', 486.0000, 'ºC'),
	(188687, 122, '2014-02-01 01:23:19.000000', 'temperatura', 942.0000, 'ºC'),
	(188688, 122, '2014-02-01 01:23:20.000000', 'temperatura', 853.0000, 'ºC'),
	(188689, 122, '2014-02-01 01:23:21.000000', 'temperatura', 237.0000, 'ºC'),
	(188690, 122, '2014-02-01 01:23:22.000000', 'temperatura', 1029.0000, 'ºC'),
	(188691, 122, '2014-02-01 01:23:23.000000', 'temperatura', 834.0000, 'ºC'),
	(188692, 122, '2014-02-01 01:23:24.000000', 'temperatura', 1085.0000, 'ºC'),
	(188693, 122, '2014-02-01 01:23:25.000000', 'temperatura', 520.0000, 'ºC'),
	(188694, 122, '2014-02-01 01:23:26.000000', 'temperatura', 548.0000, 'ºC'),
	(188695, 122, '2014-02-01 01:23:27.000000', 'temperatura', 1180.0000, 'ºC'),
	(188696, 122, '2014-02-01 01:23:28.000000', 'temperatura', 655.0000, 'ºC'),
	(188697, 122, '2014-02-01 01:23:29.000000', 'temperatura', 936.0000, 'ºC'),
	(188698, 122, '2014-02-01 01:23:30.000000', 'temperatura', 318.0000, 'ºC'),
	(188699, 122, '2014-02-01 01:23:31.000000', 'temperatura', 1181.0000, 'ºC'),
	(188700, 122, '2014-02-01 01:23:32.000000', 'temperatura', 151.0000, 'ºC'),
	(188701, 122, '2014-02-01 01:23:33.000000', 'temperatura', 812.0000, 'ºC'),
	(188702, 122, '2014-02-01 01:23:34.000000', 'temperatura', 9.0000, 'ºC'),
	(188703, 122, '2014-02-01 01:23:35.000000', 'temperatura', 10.0000, 'ºC'),
	(188704, 122, '2014-02-01 01:23:36.000000', 'temperatura', 23.0000, 'ºC'),
	(188705, 122, '2014-02-01 01:23:37.000000', 'temperatura', 87.0000, 'ºC'),
	(188706, 122, '2014-02-01 01:23:38.000000', 'temperatura', 367.0000, 'ºC'),
	(188707, 122, '2014-02-01 01:23:39.000000', 'temperatura', 372.0000, 'ºC'),
	(188708, 122, '2014-02-01 01:23:40.000000', 'temperatura', 759.0000, 'ºC'),
	(188709, 122, '2014-02-01 01:23:41.000000', 'temperatura', 283.0000, 'ºC'),
	(188710, 122, '2014-02-01 01:23:42.000000', 'temperatura', 335.0000, 'ºC'),
	(188711, 122, '2014-02-01 01:23:43.000000', 'temperatura', 827.0000, 'ºC'),
	(188712, 122, '2014-02-01 01:23:44.000000', 'temperatura', 733.0000, 'ºC'),
	(188713, 122, '2014-02-01 01:23:45.000000', 'temperatura', 1182.0000, 'ºC'),
	(188714, 122, '2014-02-01 01:23:46.000000', 'temperatura', 113.0000, 'ºC'),
	(188715, 122, '2014-02-01 01:23:47.000000', 'temperatura', 621.0000, 'ºC'),
	(188716, 122, '2014-02-01 01:23:48.000000', 'temperatura', 365.0000, 'ºC'),
	(188717, 122, '2014-02-01 01:23:49.000000', 'temperatura', 1162.0000, 'ºC'),
	(188718, 122, '2014-02-01 01:23:50.000000', 'temperatura', 1115.0000, 'ºC'),
	(188719, 122, '2014-02-01 01:23:51.000000', 'temperatura', 889.0000, 'ºC'),
	(188720, 122, '2014-02-01 01:23:52.000000', 'temperatura', 1103.0000, 'ºC'),
	(188721, 122, '2014-02-01 01:23:53.000000', 'temperatura', 448.0000, 'ºC'),
	(188722, 122, '2014-02-01 01:23:54.000000', 'temperatura', 132.0000, 'ºC'),
	(188723, 122, '2014-02-01 01:23:55.000000', 'temperatura', 514.0000, 'ºC'),
	(188724, 122, '2014-02-01 01:23:56.000000', 'temperatura', 977.0000, 'ºC'),
	(188725, 122, '2014-02-01 01:23:57.000000', 'temperatura', 944.0000, 'ºC'),
	(188726, 122, '2014-02-01 01:23:58.000000', 'temperatura', 588.0000, 'ºC'),
	(188727, 122, '2014-02-01 01:23:59.000000', 'temperatura', 107.0000, 'ºC'),
	(188728, 122, '2014-02-01 01:24:00.000000', 'temperatura', 1174.0000, 'ºC'),
	(188729, 122, '2014-02-01 01:24:01.000000', 'temperatura', 748.0000, 'ºC'),
	(188730, 122, '2014-02-01 01:24:02.000000', 'temperatura', 217.0000, 'ºC'),
	(188731, 122, '2014-02-01 01:24:03.000000', 'temperatura', 45.0000, 'ºC'),
	(188732, 122, '2014-02-01 01:24:04.000000', 'temperatura', 773.0000, 'ºC'),
	(188733, 122, '2014-02-01 01:24:05.000000', 'temperatura', 130.0000, 'ºC'),
	(188734, 122, '2014-02-01 01:24:06.000000', 'temperatura', 731.0000, 'ºC'),
	(188735, 122, '2014-02-01 01:24:07.000000', 'temperatura', 868.0000, 'ºC'),
	(188736, 122, '2014-02-01 01:24:08.000000', 'temperatura', 947.0000, 'ºC'),
	(188737, 122, '2014-02-01 01:24:09.000000', 'temperatura', 931.0000, 'ºC'),
	(188738, 122, '2014-02-01 01:24:10.000000', 'temperatura', 614.0000, 'ºC'),
	(188739, 122, '2014-02-01 01:24:11.000000', 'temperatura', 280.0000, 'ºC'),
	(188740, 122, '2014-02-01 01:24:12.000000', 'temperatura', 755.0000, 'ºC'),
	(188741, 122, '2014-02-01 01:24:13.000000', 'temperatura', 539.0000, 'ºC'),
	(188742, 122, '2014-02-01 01:24:14.000000', 'temperatura', 429.0000, 'ºC'),
	(188743, 122, '2014-02-01 01:24:15.000000', 'temperatura', 528.0000, 'ºC'),
	(188744, 122, '2014-02-01 01:24:16.000000', 'temperatura', 153.0000, 'ºC'),
	(188745, 122, '2014-02-01 01:24:17.000000', 'temperatura', 384.0000, 'ºC'),
	(188746, 122, '2014-02-01 01:24:18.000000', 'temperatura', 261.0000, 'ºC'),
	(188747, 122, '2014-02-01 01:24:19.000000', 'temperatura', 153.0000, 'ºC'),
	(188748, 122, '2014-02-01 01:24:20.000000', 'temperatura', 1181.0000, 'ºC'),
	(188749, 122, '2014-02-01 01:24:21.000000', 'temperatura', 648.0000, 'ºC'),
	(188750, 122, '2014-02-01 01:24:22.000000', 'temperatura', 896.0000, 'ºC'),
	(188751, 122, '2014-02-01 01:24:23.000000', 'temperatura', 135.0000, 'ºC'),
	(188752, 122, '2014-02-01 01:24:24.000000', 'temperatura', 391.0000, 'ºC'),
	(188753, 122, '2014-02-01 01:24:25.000000', 'temperatura', 348.0000, 'ºC'),
	(188754, 122, '2014-02-01 01:24:26.000000', 'temperatura', 570.0000, 'ºC'),
	(188755, 122, '2014-02-01 01:24:27.000000', 'temperatura', 605.0000, 'ºC'),
	(188756, 122, '2014-02-01 01:24:28.000000', 'temperatura', 116.0000, 'ºC'),
	(188757, 122, '2014-02-01 01:24:29.000000', 'temperatura', 1164.0000, 'ºC'),
	(188758, 122, '2014-02-01 01:24:30.000000', 'temperatura', 674.0000, 'ºC'),
	(188759, 122, '2014-02-01 01:24:31.000000', 'temperatura', 1079.0000, 'ºC'),
	(188760, 122, '2014-02-01 01:24:32.000000', 'temperatura', 973.0000, 'ºC'),
	(188761, 122, '2014-02-01 01:24:33.000000', 'temperatura', 431.0000, 'ºC'),
	(188762, 122, '2014-02-01 01:24:34.000000', 'temperatura', 433.0000, 'ºC'),
	(188763, 122, '2014-02-01 01:24:35.000000', 'temperatura', 873.0000, 'ºC'),
	(188764, 122, '2014-02-01 01:24:36.000000', 'temperatura', 666.0000, 'ºC'),
	(188765, 122, '2014-02-01 01:24:37.000000', 'temperatura', 710.0000, 'ºC'),
	(188766, 122, '2014-02-01 01:24:38.000000', 'temperatura', 355.0000, 'ºC'),
	(188767, 122, '2014-02-01 01:24:39.000000', 'temperatura', 843.0000, 'ºC'),
	(188768, 122, '2014-02-01 01:24:40.000000', 'temperatura', 751.0000, 'ºC'),
	(188769, 122, '2014-02-01 01:24:41.000000', 'temperatura', 29.0000, 'ºC'),
	(188770, 122, '2014-02-01 01:24:42.000000', 'temperatura', 290.0000, 'ºC'),
	(188771, 122, '2014-02-01 01:24:43.000000', 'temperatura', 163.0000, 'ºC'),
	(188772, 122, '2014-02-01 01:24:44.000000', 'temperatura', 1148.0000, 'ºC'),
	(188773, 122, '2014-02-01 01:24:45.000000', 'temperatura', 449.0000, 'ºC'),
	(188774, 122, '2014-02-01 01:24:46.000000', 'temperatura', 1.0000, 'ºC'),
	(188775, 122, '2014-02-01 01:24:47.000000', 'temperatura', 1060.0000, 'ºC'),
	(188776, 122, '2014-02-01 01:24:48.000000', 'temperatura', 497.0000, 'ºC'),
	(188777, 122, '2014-02-01 01:24:49.000000', 'temperatura', 504.0000, 'ºC'),
	(188778, 122, '2014-02-01 01:24:50.000000', 'temperatura', 1031.0000, 'ºC'),
	(188779, 122, '2014-02-01 01:24:51.000000', 'temperatura', 41.0000, 'ºC'),
	(188780, 122, '2014-02-01 01:24:52.000000', 'temperatura', 715.0000, 'ºC'),
	(188781, 122, '2014-02-01 01:24:53.000000', 'temperatura', 1050.0000, 'ºC'),
	(188782, 122, '2014-02-01 01:24:54.000000', 'temperatura', 709.0000, 'ºC'),
	(188783, 122, '2014-02-01 01:24:55.000000', 'temperatura', 394.0000, 'ºC'),
	(188784, 122, '2014-02-01 01:24:56.000000', 'temperatura', 1042.0000, 'ºC'),
	(188785, 122, '2014-02-01 01:24:57.000000', 'temperatura', 430.0000, 'ºC'),
	(188786, 122, '2014-02-01 01:24:58.000000', 'temperatura', 224.0000, 'ºC'),
	(188787, 122, '2014-02-01 01:24:59.000000', 'temperatura', 1033.0000, 'ºC'),
	(188788, 122, '2014-02-01 01:25:00.000000', 'temperatura', 891.0000, 'ºC'),
	(188789, 122, '2014-02-01 01:25:01.000000', 'temperatura', 156.0000, 'ºC'),
	(188790, 122, '2014-02-01 01:25:02.000000', 'temperatura', 508.0000, 'ºC'),
	(188791, 122, '2014-02-01 01:25:03.000000', 'temperatura', 873.0000, 'ºC'),
	(188792, 122, '2014-02-01 01:25:04.000000', 'temperatura', 440.0000, 'ºC'),
	(188793, 122, '2014-02-01 01:25:05.000000', 'temperatura', 781.0000, 'ºC'),
	(188794, 122, '2014-02-01 01:25:06.000000', 'temperatura', 187.0000, 'ºC'),
	(188795, 122, '2014-02-01 01:25:07.000000', 'temperatura', 993.0000, 'ºC'),
	(188796, 122, '2014-02-01 01:25:08.000000', 'temperatura', 804.0000, 'ºC'),
	(188797, 122, '2014-02-01 01:25:09.000000', 'temperatura', 1043.0000, 'ºC'),
	(188798, 122, '2014-02-01 01:25:10.000000', 'temperatura', 401.0000, 'ºC'),
	(188799, 122, '2014-02-01 01:25:11.000000', 'temperatura', 75.0000, 'ºC'),
	(188800, 122, '2014-02-01 01:25:12.000000', 'temperatura', 376.0000, 'ºC'),
	(188801, 122, '2014-02-01 01:25:13.000000', 'temperatura', 453.0000, 'ºC'),
	(188802, 122, '2014-02-01 01:25:14.000000', 'temperatura', 1138.0000, 'ºC'),
	(188803, 122, '2014-02-01 01:25:15.000000', 'temperatura', 732.0000, 'ºC'),
	(188804, 122, '2014-02-01 01:25:16.000000', 'temperatura', 247.0000, 'ºC'),
	(188805, 122, '2014-02-01 01:25:17.000000', 'temperatura', 241.0000, 'ºC'),
	(188806, 122, '2014-02-01 01:25:18.000000', 'temperatura', 461.0000, 'ºC'),
	(188807, 122, '2014-02-01 01:25:19.000000', 'temperatura', 385.0000, 'ºC'),
	(188808, 122, '2014-02-01 01:25:20.000000', 'temperatura', 540.0000, 'ºC'),
	(188809, 122, '2014-02-01 01:25:21.000000', 'temperatura', 347.0000, 'ºC'),
	(188810, 122, '2014-02-01 01:25:22.000000', 'temperatura', 117.0000, 'ºC'),
	(188811, 122, '2014-02-01 01:25:23.000000', 'temperatura', 744.0000, 'ºC'),
	(188812, 122, '2014-02-01 01:25:24.000000', 'temperatura', 971.0000, 'ºC'),
	(188813, 122, '2014-02-01 01:25:25.000000', 'temperatura', 222.0000, 'ºC'),
	(188814, 122, '2014-02-01 01:25:26.000000', 'temperatura', 598.0000, 'ºC'),
	(188815, 122, '2014-02-01 01:25:27.000000', 'temperatura', 1125.0000, 'ºC'),
	(188816, 122, '2014-02-01 01:25:28.000000', 'temperatura', 232.0000, 'ºC'),
	(188817, 122, '2014-02-01 01:25:29.000000', 'temperatura', 184.0000, 'ºC'),
	(188818, 122, '2014-02-01 01:25:30.000000', 'temperatura', 225.0000, 'ºC'),
	(188819, 122, '2014-02-01 01:25:31.000000', 'temperatura', 575.0000, 'ºC'),
	(188820, 122, '2014-02-01 01:25:32.000000', 'temperatura', 1002.0000, 'ºC'),
	(188821, 122, '2014-02-01 01:25:33.000000', 'temperatura', 882.0000, 'ºC'),
	(188822, 122, '2014-02-01 01:25:34.000000', 'temperatura', 206.0000, 'ºC'),
	(188823, 122, '2014-02-01 01:25:35.000000', 'temperatura', 782.0000, 'ºC'),
	(188824, 122, '2014-02-01 01:25:36.000000', 'temperatura', 895.0000, 'ºC'),
	(188825, 122, '2014-02-01 01:25:37.000000', 'temperatura', 928.0000, 'ºC'),
	(188826, 122, '2014-02-01 01:25:38.000000', 'temperatura', 756.0000, 'ºC'),
	(188827, 122, '2014-02-01 01:25:39.000000', 'temperatura', 997.0000, 'ºC'),
	(188828, 122, '2014-02-01 01:25:40.000000', 'temperatura', 316.0000, 'ºC'),
	(188829, 122, '2014-02-01 01:25:41.000000', 'temperatura', 992.0000, 'ºC'),
	(188830, 122, '2014-02-01 01:25:42.000000', 'temperatura', 410.0000, 'ºC'),
	(188831, 122, '2014-02-01 01:25:43.000000', 'temperatura', 276.0000, 'ºC'),
	(188832, 122, '2014-02-01 01:25:44.000000', 'temperatura', 148.0000, 'ºC'),
	(188833, 122, '2014-02-01 01:25:45.000000', 'temperatura', 1115.0000, 'ºC'),
	(188834, 122, '2014-02-01 01:25:46.000000', 'temperatura', 330.0000, 'ºC'),
	(188835, 122, '2014-02-01 01:25:47.000000', 'temperatura', 705.0000, 'ºC'),
	(188836, 122, '2014-02-01 01:25:48.000000', 'temperatura', 135.0000, 'ºC'),
	(188837, 122, '2014-02-01 01:25:49.000000', 'temperatura', 960.0000, 'ºC'),
	(188838, 122, '2014-02-01 01:25:50.000000', 'temperatura', 795.0000, 'ºC'),
	(188839, 122, '2014-02-01 01:25:51.000000', 'temperatura', 1097.0000, 'ºC'),
	(188840, 122, '2014-02-01 01:25:52.000000', 'temperatura', 699.0000, 'ºC'),
	(188841, 122, '2014-02-01 01:25:53.000000', 'temperatura', 205.0000, 'ºC'),
	(188842, 122, '2014-02-01 01:25:54.000000', 'temperatura', 128.0000, 'ºC'),
	(188843, 122, '2014-02-01 01:25:55.000000', 'temperatura', 26.0000, 'ºC'),
	(188844, 122, '2014-02-01 01:25:56.000000', 'temperatura', 948.0000, 'ºC'),
	(188845, 122, '2014-02-01 01:25:57.000000', 'temperatura', 1060.0000, 'ºC'),
	(188846, 122, '2014-02-01 01:25:58.000000', 'temperatura', 56.0000, 'ºC'),
	(188847, 122, '2014-02-01 01:25:59.000000', 'temperatura', 700.0000, 'ºC'),
	(188848, 122, '2014-02-01 01:26:00.000000', 'temperatura', 935.0000, 'ºC'),
	(188849, 122, '2014-02-01 01:26:01.000000', 'temperatura', 174.0000, 'ºC'),
	(188850, 122, '2014-02-01 01:26:02.000000', 'temperatura', 466.0000, 'ºC'),
	(188851, 122, '2014-02-01 01:26:03.000000', 'temperatura', 606.0000, 'ºC'),
	(188852, 122, '2014-02-01 01:26:04.000000', 'temperatura', 436.0000, 'ºC'),
	(188853, 122, '2014-02-01 01:26:05.000000', 'temperatura', 361.0000, 'ºC'),
	(188854, 122, '2014-02-01 01:26:06.000000', 'temperatura', 499.0000, 'ºC'),
	(188855, 122, '2014-02-01 01:26:07.000000', 'temperatura', 210.0000, 'ºC'),
	(188856, 122, '2014-02-01 01:26:08.000000', 'temperatura', 754.0000, 'ºC'),
	(188857, 122, '2014-02-01 01:26:09.000000', 'temperatura', 740.0000, 'ºC'),
	(188858, 122, '2014-02-01 01:26:10.000000', 'temperatura', 239.0000, 'ºC'),
	(188859, 122, '2014-02-01 01:26:11.000000', 'temperatura', 174.0000, 'ºC'),
	(188860, 122, '2014-02-01 01:26:12.000000', 'temperatura', 156.0000, 'ºC'),
	(188861, 122, '2014-02-01 01:26:13.000000', 'temperatura', 258.0000, 'ºC'),
	(188862, 122, '2014-02-01 01:26:14.000000', 'temperatura', 821.0000, 'ºC'),
	(188863, 122, '2014-02-01 01:26:15.000000', 'temperatura', 931.0000, 'ºC'),
	(188864, 122, '2014-02-01 01:26:16.000000', 'temperatura', 993.0000, 'ºC'),
	(188865, 122, '2014-02-01 01:26:17.000000', 'temperatura', 973.0000, 'ºC'),
	(188866, 122, '2014-02-01 01:26:18.000000', 'temperatura', 687.0000, 'ºC'),
	(188867, 122, '2014-02-01 01:26:19.000000', 'temperatura', 516.0000, 'ºC'),
	(188868, 122, '2014-02-01 01:26:20.000000', 'temperatura', 521.0000, 'ºC'),
	(188869, 122, '2014-02-01 01:26:21.000000', 'temperatura', 1055.0000, 'ºC'),
	(188870, 122, '2014-02-01 01:26:22.000000', 'temperatura', 115.0000, 'ºC'),
	(188871, 122, '2014-02-01 01:26:23.000000', 'temperatura', 1010.0000, 'ºC'),
	(188872, 122, '2014-02-01 01:26:24.000000', 'temperatura', 1106.0000, 'ºC'),
	(188873, 122, '2014-02-01 01:26:25.000000', 'temperatura', 98.0000, 'ºC'),
	(188874, 122, '2014-02-01 01:26:26.000000', 'temperatura', 775.0000, 'ºC'),
	(188875, 122, '2014-02-01 01:26:27.000000', 'temperatura', 1179.0000, 'ºC'),
	(188876, 122, '2014-02-01 01:26:28.000000', 'temperatura', 1170.0000, 'ºC'),
	(188877, 122, '2014-02-01 01:26:29.000000', 'temperatura', 1116.0000, 'ºC'),
	(188878, 122, '2014-02-01 01:26:30.000000', 'temperatura', 872.0000, 'ºC'),
	(188879, 122, '2014-02-01 01:26:31.000000', 'temperatura', 1009.0000, 'ºC'),
	(188880, 122, '2014-02-01 01:26:32.000000', 'temperatura', 31.0000, 'ºC'),
	(188881, 122, '2014-02-01 01:26:33.000000', 'temperatura', 730.0000, 'ºC'),
	(188882, 122, '2014-02-01 01:26:34.000000', 'temperatura', 1158.0000, 'ºC'),
	(188883, 122, '2014-02-01 01:26:35.000000', 'temperatura', 1198.0000, 'ºC'),
	(188884, 122, '2014-02-01 01:26:36.000000', 'temperatura', 117.0000, 'ºC'),
	(188885, 122, '2014-02-01 01:26:37.000000', 'temperatura', 592.0000, 'ºC'),
	(188886, 122, '2014-02-01 01:26:38.000000', 'temperatura', 209.0000, 'ºC'),
	(188887, 122, '2014-02-01 01:26:39.000000', 'temperatura', 468.0000, 'ºC'),
	(188888, 122, '2014-02-01 01:26:40.000000', 'temperatura', 515.0000, 'ºC'),
	(188889, 122, '2014-02-01 01:26:41.000000', 'temperatura', 1172.0000, 'ºC'),
	(188890, 122, '2014-02-01 01:26:42.000000', 'temperatura', 713.0000, 'ºC'),
	(188891, 122, '2014-02-01 01:26:43.000000', 'temperatura', 52.0000, 'ºC'),
	(188892, 122, '2014-02-01 01:26:44.000000', 'temperatura', 519.0000, 'ºC'),
	(188893, 122, '2014-02-01 01:26:45.000000', 'temperatura', 41.0000, 'ºC'),
	(188894, 122, '2014-02-01 01:26:46.000000', 'temperatura', 1047.0000, 'ºC'),
	(188895, 122, '2014-02-01 01:26:47.000000', 'temperatura', 312.0000, 'ºC'),
	(188896, 122, '2014-02-01 01:26:48.000000', 'temperatura', 822.0000, 'ºC'),
	(188897, 122, '2014-02-01 01:26:49.000000', 'temperatura', 774.0000, 'ºC'),
	(188898, 122, '2014-02-01 01:26:50.000000', 'temperatura', 206.0000, 'ºC'),
	(188899, 122, '2014-02-01 01:26:51.000000', 'temperatura', 1108.0000, 'ºC'),
	(188900, 122, '2014-02-01 01:26:52.000000', 'temperatura', 120.0000, 'ºC'),
	(188901, 122, '2014-02-01 01:26:53.000000', 'temperatura', 879.0000, 'ºC'),
	(188902, 122, '2014-02-01 01:26:54.000000', 'temperatura', 433.0000, 'ºC'),
	(188903, 122, '2014-02-01 01:26:55.000000', 'temperatura', 728.0000, 'ºC'),
	(188904, 122, '2014-02-01 01:26:56.000000', 'temperatura', 1143.0000, 'ºC'),
	(188905, 122, '2014-02-01 01:26:57.000000', 'temperatura', 1131.0000, 'ºC'),
	(188906, 122, '2014-02-01 01:26:58.000000', 'temperatura', 1026.0000, 'ºC'),
	(188907, 122, '2014-02-01 01:26:59.000000', 'temperatura', 539.0000, 'ºC'),
	(188908, 122, '2014-02-01 01:27:00.000000', 'temperatura', 818.0000, 'ºC'),
	(188909, 122, '2014-02-01 01:27:01.000000', 'temperatura', 73.0000, 'ºC'),
	(188910, 122, '2014-02-01 01:27:02.000000', 'temperatura', 309.0000, 'ºC'),
	(188911, 122, '2014-02-01 01:27:03.000000', 'temperatura', 129.0000, 'ºC'),
	(188912, 122, '2014-02-01 01:27:04.000000', 'temperatura', 918.0000, 'ºC'),
	(188913, 122, '2014-02-01 01:27:05.000000', 'temperatura', 603.0000, 'ºC'),
	(188914, 122, '2014-02-01 01:27:06.000000', 'temperatura', 263.0000, 'ºC'),
	(188915, 122, '2014-02-01 01:27:07.000000', 'temperatura', 707.0000, 'ºC'),
	(188916, 122, '2014-02-01 01:27:08.000000', 'temperatura', 347.0000, 'ºC'),
	(188917, 122, '2014-02-01 01:27:09.000000', 'temperatura', 813.0000, 'ºC'),
	(188918, 122, '2014-02-01 01:27:10.000000', 'temperatura', 624.0000, 'ºC'),
	(188919, 122, '2014-02-01 01:27:11.000000', 'temperatura', 681.0000, 'ºC'),
	(188920, 122, '2014-02-01 01:27:12.000000', 'temperatura', 333.0000, 'ºC'),
	(188921, 122, '2014-02-01 01:27:13.000000', 'temperatura', 825.0000, 'ºC'),
	(188922, 122, '2014-02-01 01:27:14.000000', 'temperatura', 725.0000, 'ºC'),
	(188923, 122, '2014-02-01 01:27:15.000000', 'temperatura', 1150.0000, 'ºC'),
	(188924, 122, '2014-02-01 01:27:16.000000', 'temperatura', 1174.0000, 'ºC'),
	(188925, 122, '2014-02-01 01:27:17.000000', 'temperatura', 22.0000, 'ºC'),
	(188926, 122, '2014-02-01 01:27:18.000000', 'temperatura', 187.0000, 'ºC'),
	(188927, 122, '2014-02-01 01:27:19.000000', 'temperatura', 872.0000, 'ºC'),
	(188928, 122, '2014-02-01 01:27:20.000000', 'temperatura', 197.0000, 'ºC'),
	(188929, 122, '2014-02-01 01:27:21.000000', 'temperatura', 771.0000, 'ºC'),
	(188930, 122, '2014-02-01 01:27:22.000000', 'temperatura', 863.0000, 'ºC'),
	(188931, 122, '2014-02-01 01:27:23.000000', 'temperatura', 804.0000, 'ºC'),
	(188932, 122, '2014-02-01 01:27:24.000000', 'temperatura', 230.0000, 'ºC'),
	(188933, 122, '2014-02-01 01:27:25.000000', 'temperatura', 1140.0000, 'ºC'),
	(188934, 122, '2014-02-01 01:27:26.000000', 'temperatura', 211.0000, 'ºC'),
	(188935, 122, '2014-02-01 01:27:27.000000', 'temperatura', 33.0000, 'ºC'),
	(188936, 122, '2014-02-01 01:27:28.000000', 'temperatura', 733.0000, 'ºC'),
	(188937, 122, '2014-02-01 01:27:29.000000', 'temperatura', 1169.0000, 'ºC'),
	(188938, 122, '2014-02-01 01:27:30.000000', 'temperatura', 46.0000, 'ºC'),
	(188939, 122, '2014-02-01 01:27:31.000000', 'temperatura', 321.0000, 'ºC'),
	(188940, 122, '2014-02-01 01:27:32.000000', 'temperatura', 270.0000, 'ºC'),
	(188941, 122, '2014-02-01 01:27:33.000000', 'temperatura', 387.0000, 'ºC'),
	(188942, 122, '2014-02-01 01:27:34.000000', 'temperatura', 1124.0000, 'ºC'),
	(188943, 122, '2014-02-01 01:27:35.000000', 'temperatura', 858.0000, 'ºC'),
	(188944, 122, '2014-02-01 01:27:36.000000', 'temperatura', 922.0000, 'ºC'),
	(188945, 122, '2014-02-01 01:27:37.000000', 'temperatura', 835.0000, 'ºC'),
	(188946, 122, '2014-02-01 01:27:38.000000', 'temperatura', 208.0000, 'ºC'),
	(188947, 122, '2014-02-01 01:27:39.000000', 'temperatura', 935.0000, 'ºC'),
	(188948, 122, '2014-02-01 01:27:40.000000', 'temperatura', 454.0000, 'ºC'),
	(188949, 122, '2014-02-01 01:27:41.000000', 'temperatura', 666.0000, 'ºC'),
	(188950, 122, '2014-02-01 01:27:42.000000', 'temperatura', 766.0000, 'ºC'),
	(188951, 122, '2014-02-01 01:27:43.000000', 'temperatura', 633.0000, 'ºC'),
	(188952, 122, '2014-02-01 01:27:44.000000', 'temperatura', 869.0000, 'ºC'),
	(188953, 122, '2014-02-01 01:27:45.000000', 'temperatura', 46.0000, 'ºC'),
	(188954, 122, '2014-02-01 01:27:46.000000', 'temperatura', 23.0000, 'ºC'),
	(188955, 122, '2014-02-01 01:27:47.000000', 'temperatura', 1178.0000, 'ºC'),
	(188956, 122, '2014-02-01 01:27:48.000000', 'temperatura', 1020.0000, 'ºC'),
	(188957, 122, '2014-02-01 01:27:49.000000', 'temperatura', 368.0000, 'ºC'),
	(188958, 122, '2014-02-01 01:27:50.000000', 'temperatura', 1182.0000, 'ºC'),
	(188959, 122, '2014-02-01 01:27:51.000000', 'temperatura', 3.0000, 'ºC'),
	(188960, 122, '2014-02-01 01:27:52.000000', 'temperatura', 72.0000, 'ºC'),
	(188961, 122, '2014-02-01 01:27:53.000000', 'temperatura', 349.0000, 'ºC'),
	(188962, 122, '2014-02-01 01:27:54.000000', 'temperatura', 332.0000, 'ºC'),
	(188963, 122, '2014-02-01 01:27:55.000000', 'temperatura', 613.0000, 'ºC'),
	(188964, 122, '2014-02-01 01:27:56.000000', 'temperatura', 868.0000, 'ºC'),
	(188965, 122, '2014-02-01 01:27:57.000000', 'temperatura', 103.0000, 'ºC'),
	(188966, 122, '2014-02-01 01:27:58.000000', 'temperatura', 311.0000, 'ºC'),
	(188967, 122, '2014-02-01 01:27:59.000000', 'temperatura', 46.0000, 'ºC'),
	(188968, 122, '2014-02-01 01:28:00.000000', 'temperatura', 497.0000, 'ºC'),
	(188969, 122, '2014-02-01 01:28:01.000000', 'temperatura', 1149.0000, 'ºC'),
	(188970, 122, '2014-02-01 01:28:02.000000', 'temperatura', 652.0000, 'ºC'),
	(188971, 122, '2014-02-01 01:28:03.000000', 'temperatura', 1015.0000, 'ºC'),
	(188972, 122, '2014-02-01 01:28:04.000000', 'temperatura', 719.0000, 'ºC'),
	(188973, 122, '2014-02-01 01:28:05.000000', 'temperatura', 553.0000, 'ºC'),
	(188974, 122, '2014-02-01 01:28:06.000000', 'temperatura', 606.0000, 'ºC'),
	(188975, 122, '2014-02-01 01:28:07.000000', 'temperatura', 172.0000, 'ºC'),
	(188976, 122, '2014-02-01 01:28:08.000000', 'temperatura', 244.0000, 'ºC'),
	(188977, 122, '2014-02-01 01:28:09.000000', 'temperatura', 705.0000, 'ºC'),
	(188978, 122, '2014-02-01 01:28:10.000000', 'temperatura', 394.0000, 'ºC'),
	(188979, 122, '2014-02-01 01:28:11.000000', 'temperatura', 1054.0000, 'ºC'),
	(188980, 122, '2014-02-01 01:28:12.000000', 'temperatura', 489.0000, 'ºC'),
	(188981, 122, '2014-02-01 01:28:13.000000', 'temperatura', 485.0000, 'ºC'),
	(188982, 122, '2014-02-01 01:28:14.000000', 'temperatura', 958.0000, 'ºC'),
	(188983, 122, '2014-02-01 01:28:15.000000', 'temperatura', 934.0000, 'ºC'),
	(188984, 122, '2014-02-01 01:28:16.000000', 'temperatura', 596.0000, 'ºC'),
	(188985, 122, '2014-02-01 01:28:17.000000', 'temperatura', 178.0000, 'ºC'),
	(188986, 122, '2014-02-01 01:28:18.000000', 'temperatura', 303.0000, 'ºC'),
	(188987, 122, '2014-02-01 01:28:19.000000', 'temperatura', 984.0000, 'ºC'),
	(188988, 122, '2014-02-01 01:28:20.000000', 'temperatura', 408.0000, 'ºC'),
	(188989, 122, '2014-02-01 01:28:21.000000', 'temperatura', 291.0000, 'ºC'),
	(188990, 122, '2014-02-01 01:28:22.000000', 'temperatura', 230.0000, 'ºC'),
	(188991, 122, '2014-02-01 01:28:23.000000', 'temperatura', 277.0000, 'ºC'),
	(188992, 122, '2014-02-01 01:28:24.000000', 'temperatura', 697.0000, 'ºC'),
	(188993, 122, '2014-02-01 01:28:25.000000', 'temperatura', 254.0000, 'ºC'),
	(188994, 122, '2014-02-01 01:28:26.000000', 'temperatura', 378.0000, 'ºC'),
	(188995, 122, '2014-02-01 01:28:27.000000', 'temperatura', 1130.0000, 'ºC'),
	(188996, 122, '2014-02-01 01:28:28.000000', 'temperatura', 915.0000, 'ºC'),
	(188997, 122, '2014-02-01 01:28:29.000000', 'temperatura', 1186.0000, 'ºC'),
	(188998, 122, '2014-02-01 01:28:30.000000', 'temperatura', 785.0000, 'ºC'),
	(188999, 122, '2014-02-01 01:28:31.000000', 'temperatura', 369.0000, 'ºC'),
	(189000, 122, '2014-02-01 01:28:32.000000', 'temperatura', 690.0000, 'ºC'),
	(189001, 122, '2014-02-01 01:28:33.000000', 'temperatura', 1142.0000, 'ºC'),
	(189002, 122, '2014-02-01 01:28:34.000000', 'temperatura', 42.0000, 'ºC'),
	(189003, 122, '2014-02-01 01:28:35.000000', 'temperatura', 384.0000, 'ºC'),
	(189004, 122, '2014-02-01 01:28:36.000000', 'temperatura', 595.0000, 'ºC'),
	(189005, 122, '2014-02-01 01:28:37.000000', 'temperatura', 624.0000, 'ºC'),
	(189006, 122, '2014-02-01 01:28:38.000000', 'temperatura', 137.0000, 'ºC'),
	(189007, 122, '2014-02-01 01:28:39.000000', 'temperatura', 11.0000, 'ºC'),
	(189008, 122, '2014-02-01 01:28:40.000000', 'temperatura', 843.0000, 'ºC'),
	(189009, 122, '2014-02-01 01:28:41.000000', 'temperatura', 585.0000, 'ºC'),
	(189010, 122, '2014-02-01 01:28:42.000000', 'temperatura', 397.0000, 'ºC'),
	(189011, 122, '2014-02-01 01:28:43.000000', 'temperatura', 230.0000, 'ºC'),
	(189012, 122, '2014-02-01 01:28:44.000000', 'temperatura', 1161.0000, 'ºC'),
	(189013, 122, '2014-02-01 01:28:45.000000', 'temperatura', 313.0000, 'ºC'),
	(189014, 122, '2014-02-01 01:28:46.000000', 'temperatura', 482.0000, 'ºC'),
	(189015, 122, '2014-02-01 01:28:47.000000', 'temperatura', 272.0000, 'ºC'),
	(189016, 122, '2014-02-01 01:28:48.000000', 'temperatura', 1113.0000, 'ºC'),
	(189017, 122, '2014-02-01 01:28:49.000000', 'temperatura', 1152.0000, 'ºC'),
	(189018, 122, '2014-02-01 01:28:50.000000', 'temperatura', 19.0000, 'ºC'),
	(189019, 122, '2014-02-01 01:28:51.000000', 'temperatura', 240.0000, 'ºC'),
	(189020, 122, '2014-02-01 01:28:52.000000', 'temperatura', 1146.0000, 'ºC'),
	(189021, 122, '2014-02-01 01:28:53.000000', 'temperatura', 209.0000, 'ºC'),
	(189022, 122, '2014-02-01 01:28:54.000000', 'temperatura', 8.0000, 'ºC'),
	(189023, 122, '2014-02-01 01:28:55.000000', 'temperatura', 615.0000, 'ºC'),
	(189024, 122, '2014-02-01 01:28:56.000000', 'temperatura', 650.0000, 'ºC'),
	(189025, 122, '2014-02-01 01:28:57.000000', 'temperatura', 205.0000, 'ºC'),
	(189026, 122, '2014-02-01 01:28:58.000000', 'temperatura', 276.0000, 'ºC'),
	(189027, 122, '2014-02-01 01:28:59.000000', 'temperatura', 767.0000, 'ºC'),
	(189028, 122, '2014-02-01 01:29:00.000000', 'temperatura', 608.0000, 'ºC'),
	(189029, 122, '2014-02-01 01:29:01.000000', 'temperatura', 738.0000, 'ºC'),
	(189030, 122, '2014-02-01 01:29:02.000000', 'temperatura', 666.0000, 'ºC'),
	(189031, 122, '2014-02-01 01:29:03.000000', 'temperatura', 1115.0000, 'ºC'),
	(189032, 122, '2014-02-01 01:29:04.000000', 'temperatura', 1180.0000, 'ºC'),
	(189033, 122, '2014-02-01 01:29:05.000000', 'temperatura', 154.0000, 'ºC'),
	(189034, 122, '2014-02-01 01:29:06.000000', 'temperatura', 832.0000, 'ºC'),
	(189035, 122, '2014-02-01 01:29:07.000000', 'temperatura', 98.0000, 'ºC'),
	(189036, 122, '2014-02-01 01:29:08.000000', 'temperatura', 394.0000, 'ºC'),
	(189037, 122, '2014-02-01 01:29:09.000000', 'temperatura', 479.0000, 'ºC'),
	(189038, 122, '2014-02-01 01:29:10.000000', 'temperatura', 10.0000, 'ºC'),
	(189039, 122, '2014-02-01 01:29:11.000000', 'temperatura', 1017.0000, 'ºC'),
	(189040, 122, '2014-02-01 01:29:12.000000', 'temperatura', 253.0000, 'ºC'),
	(189041, 122, '2014-02-01 01:29:13.000000', 'temperatura', 615.0000, 'ºC'),
	(189042, 122, '2014-02-01 01:29:14.000000', 'temperatura', 1115.0000, 'ºC'),
	(189043, 122, '2014-02-01 01:29:15.000000', 'temperatura', 131.0000, 'ºC'),
	(189044, 122, '2014-02-01 01:29:16.000000', 'temperatura', 909.0000, 'ºC'),
	(189045, 122, '2014-02-01 01:29:17.000000', 'temperatura', 554.0000, 'ºC'),
	(189046, 122, '2014-02-01 01:29:18.000000', 'temperatura', 43.0000, 'ºC'),
	(189047, 122, '2014-02-01 01:29:19.000000', 'temperatura', 952.0000, 'ºC'),
	(189048, 122, '2014-02-01 01:29:20.000000', 'temperatura', 1034.0000, 'ºC'),
	(189049, 122, '2014-02-01 01:29:21.000000', 'temperatura', 1114.0000, 'ºC'),
	(189050, 122, '2014-02-01 01:29:22.000000', 'temperatura', 70.0000, 'ºC'),
	(189051, 122, '2014-02-01 01:29:23.000000', 'temperatura', 605.0000, 'ºC'),
	(189052, 122, '2014-02-01 01:29:24.000000', 'temperatura', 419.0000, 'ºC'),
	(189053, 122, '2014-02-01 01:29:25.000000', 'temperatura', 279.0000, 'ºC'),
	(189054, 122, '2014-02-01 01:29:26.000000', 'temperatura', 141.0000, 'ºC'),
	(189055, 122, '2014-02-01 01:29:27.000000', 'temperatura', 1065.0000, 'ºC'),
	(189056, 122, '2014-02-01 01:29:28.000000', 'temperatura', 102.0000, 'ºC'),
	(189057, 122, '2014-02-01 01:29:29.000000', 'temperatura', 919.0000, 'ºC'),
	(189058, 122, '2014-02-01 01:29:30.000000', 'temperatura', 687.0000, 'ºC'),
	(189059, 122, '2014-02-01 01:29:31.000000', 'temperatura', 681.0000, 'ºC'),
	(189060, 122, '2014-02-01 01:29:32.000000', 'temperatura', 142.0000, 'ºC'),
	(189061, 122, '2014-02-01 01:29:33.000000', 'temperatura', 1068.0000, 'ºC'),
	(189062, 122, '2014-02-01 01:29:34.000000', 'temperatura', 114.0000, 'ºC'),
	(189063, 122, '2014-02-01 01:29:35.000000', 'temperatura', 965.0000, 'ºC'),
	(189064, 122, '2014-02-01 01:29:36.000000', 'temperatura', 886.0000, 'ºC'),
	(189065, 122, '2014-02-01 01:29:37.000000', 'temperatura', 334.0000, 'ºC'),
	(189066, 122, '2014-02-01 01:29:38.000000', 'temperatura', 215.0000, 'ºC'),
	(189067, 122, '2014-02-01 01:29:39.000000', 'temperatura', 72.0000, 'ºC'),
	(189068, 122, '2014-02-01 01:29:40.000000', 'temperatura', 917.0000, 'ºC'),
	(189069, 122, '2014-02-01 01:29:41.000000', 'temperatura', 767.0000, 'ºC'),
	(189070, 122, '2014-02-01 01:29:42.000000', 'temperatura', 1087.0000, 'ºC'),
	(189071, 122, '2014-02-01 01:29:43.000000', 'temperatura', 733.0000, 'ºC'),
	(189072, 122, '2014-02-01 01:29:44.000000', 'temperatura', 405.0000, 'ºC'),
	(189073, 122, '2014-02-01 01:29:45.000000', 'temperatura', 1027.0000, 'ºC'),
	(189074, 122, '2014-02-01 01:29:46.000000', 'temperatura', 319.0000, 'ºC'),
	(189075, 122, '2014-02-01 01:29:47.000000', 'temperatura', 914.0000, 'ºC'),
	(189076, 122, '2014-02-01 01:29:48.000000', 'temperatura', 16.0000, 'ºC'),
	(189077, 122, '2014-02-01 01:29:49.000000', 'temperatura', 938.0000, 'ºC'),
	(189078, 122, '2014-02-01 01:29:50.000000', 'temperatura', 1043.0000, 'ºC'),
	(189079, 122, '2014-02-01 01:29:51.000000', 'temperatura', 1.0000, 'ºC'),
	(189080, 122, '2014-02-01 01:29:52.000000', 'temperatura', 476.0000, 'ºC'),
	(189081, 122, '2014-02-01 01:29:53.000000', 'temperatura', 1176.0000, 'ºC'),
	(189082, 122, '2014-02-01 01:29:54.000000', 'temperatura', 855.0000, 'ºC'),
	(189083, 122, '2014-02-01 01:29:55.000000', 'temperatura', 745.0000, 'ºC'),
	(189084, 122, '2014-02-01 01:29:56.000000', 'temperatura', 1162.0000, 'ºC'),
	(189085, 122, '2014-02-01 01:29:57.000000', 'temperatura', 1177.0000, 'ºC'),
	(189086, 122, '2014-02-01 01:29:58.000000', 'temperatura', 0.0000, 'ºC'),
	(189087, 122, '2014-02-01 01:29:59.000000', 'temperatura', 67.0000, 'ºC'),
	(189088, 122, '2014-02-01 01:30:00.000000', 'temperatura', 337.0000, 'ºC'),
	(189089, 122, '2014-02-01 01:30:01.000000', 'temperatura', 283.0000, 'ºC'),
	(189090, 122, '2014-02-01 01:30:02.000000', 'temperatura', 405.0000, 'ºC'),
	(189091, 122, '2014-02-01 01:30:03.000000', 'temperatura', 1175.0000, 'ºC'),
	(189092, 122, '2014-02-01 01:30:04.000000', 'temperatura', 1061.0000, 'ºC'),
	(189093, 122, '2014-02-01 01:30:05.000000', 'temperatura', 581.0000, 'ºC'),
	(189094, 122, '2014-02-01 01:30:06.000000', 'temperatura', 923.0000, 'ºC'),
	(189095, 122, '2014-02-01 01:30:07.000000', 'temperatura', 472.0000, 'ºC'),
	(189096, 122, '2014-02-01 01:30:08.000000', 'temperatura', 790.0000, 'ºC'),
	(189097, 122, '2014-02-01 01:30:09.000000', 'temperatura', 133.0000, 'ºC'),
	(189098, 122, '2014-02-01 01:30:10.000000', 'temperatura', 699.0000, 'ºC'),
	(189099, 122, '2014-02-01 01:30:11.000000', 'temperatura', 697.0000, 'ºC'),
	(189100, 122, '2014-02-01 01:30:12.000000', 'temperatura', 186.0000, 'ºC'),
	(189101, 122, '2014-02-01 01:30:13.000000', 'temperatura', 42.0000, 'ºC'),
	(189102, 122, '2014-02-01 01:30:14.000000', 'temperatura', 853.0000, 'ºC'),
	(189103, 122, '2014-02-01 01:30:15.000000', 'temperatura', 537.0000, 'ºC'),
	(189104, 122, '2014-02-01 01:30:16.000000', 'temperatura', 127.0000, 'ºC'),
	(189105, 122, '2014-02-01 01:30:17.000000', 'temperatura', 225.0000, 'ºC'),
	(189106, 122, '2014-02-01 01:30:18.000000', 'temperatura', 743.0000, 'ºC'),
	(189107, 122, '2014-02-01 01:30:19.000000', 'temperatura', 642.0000, 'ºC'),
	(189108, 122, '2014-02-01 01:30:20.000000', 'temperatura', 980.0000, 'ºC'),
	(189109, 122, '2014-02-01 01:30:21.000000', 'temperatura', 575.0000, 'ºC'),
	(189110, 122, '2014-02-01 01:30:22.000000', 'temperatura', 1136.0000, 'ºC'),
	(189111, 122, '2014-02-01 01:30:23.000000', 'temperatura', 357.0000, 'ºC'),
	(189112, 122, '2014-02-01 01:30:24.000000', 'temperatura', 777.0000, 'ºC'),
	(189113, 122, '2014-02-01 01:30:25.000000', 'temperatura', 413.0000, 'ºC'),
	(189114, 122, '2014-02-01 01:30:26.000000', 'temperatura', 935.0000, 'ºC'),
	(189115, 122, '2014-02-01 01:30:27.000000', 'temperatura', 1038.0000, 'ºC'),
	(189116, 122, '2014-02-01 01:30:28.000000', 'temperatura', 1183.0000, 'ºC'),
	(189117, 122, '2014-02-01 01:30:29.000000', 'temperatura', 401.0000, 'ºC'),
	(189118, 122, '2014-02-01 01:30:30.000000', 'temperatura', 858.0000, 'ºC'),
	(189119, 122, '2014-02-01 01:30:31.000000', 'temperatura', 686.0000, 'ºC'),
	(189120, 122, '2014-02-01 01:30:32.000000', 'temperatura', 859.0000, 'ºC'),
	(189121, 122, '2014-02-01 01:30:33.000000', 'temperatura', 1036.0000, 'ºC'),
	(189122, 122, '2014-02-01 01:30:34.000000', 'temperatura', 205.0000, 'ºC'),
	(189123, 122, '2014-02-01 01:30:35.000000', 'temperatura', 317.0000, 'ºC'),
	(189124, 122, '2014-02-01 01:30:36.000000', 'temperatura', 970.0000, 'ºC'),
	(189125, 122, '2014-02-01 01:30:37.000000', 'temperatura', 301.0000, 'ºC'),
	(189126, 122, '2014-02-01 01:30:38.000000', 'temperatura', 992.0000, 'ºC'),
	(189127, 122, '2014-02-01 01:30:39.000000', 'temperatura', 461.0000, 'ºC'),
	(189128, 122, '2014-02-01 01:30:40.000000', 'temperatura', 529.0000, 'ºC'),
	(189129, 122, '2014-02-01 01:30:41.000000', 'temperatura', 64.0000, 'ºC'),
	(189130, 122, '2014-02-01 01:30:42.000000', 'temperatura', 1131.0000, 'ºC'),
	(189131, 122, '2014-02-01 01:30:43.000000', 'temperatura', 665.0000, 'ºC'),
	(189132, 122, '2014-02-01 01:30:44.000000', 'temperatura', 1131.0000, 'ºC'),
	(189133, 122, '2014-02-01 01:30:45.000000', 'temperatura', 60.0000, 'ºC'),
	(189134, 122, '2014-02-01 01:30:46.000000', 'temperatura', 507.0000, 'ºC'),
	(189135, 122, '2014-02-01 01:30:47.000000', 'temperatura', 1156.0000, 'ºC'),
	(189136, 122, '2014-02-01 01:30:48.000000', 'temperatura', 659.0000, 'ºC'),
	(189137, 122, '2014-02-01 01:30:49.000000', 'temperatura', 1028.0000, 'ºC'),
	(189138, 122, '2014-02-01 01:30:50.000000', 'temperatura', 764.0000, 'ºC'),
	(189139, 122, '2014-02-01 01:30:51.000000', 'temperatura', 738.0000, 'ºC'),
	(189140, 122, '2014-02-01 01:30:52.000000', 'temperatura', 198.0000, 'ºC'),
	(189141, 122, '2014-02-01 01:30:53.000000', 'temperatura', 1176.0000, 'ºC'),
	(189142, 122, '2014-02-01 01:30:54.000000', 'temperatura', 486.0000, 'ºC'),
	(189143, 122, '2014-02-01 01:30:55.000000', 'temperatura', 102.0000, 'ºC'),
	(189144, 122, '2014-02-01 01:30:56.000000', 'temperatura', 251.0000, 'ºC'),
	(189145, 122, '2014-02-01 01:30:57.000000', 'temperatura', 952.0000, 'ºC'),
	(189146, 122, '2014-02-01 01:30:58.000000', 'temperatura', 406.0000, 'ºC'),
	(189147, 122, '2014-02-01 01:30:59.000000', 'temperatura', 373.0000, 'ºC'),
	(189148, 122, '2014-02-01 01:31:00.000000', 'temperatura', 649.0000, 'ºC'),
	(189149, 122, '2014-02-01 01:31:01.000000', 'temperatura', 926.0000, 'ºC'),
	(189150, 122, '2014-02-01 01:31:02.000000', 'temperatura', 282.0000, 'ºC'),
	(189151, 122, '2014-02-01 01:31:03.000000', 'temperatura', 1034.0000, 'ºC'),
	(189152, 122, '2014-02-01 01:31:04.000000', 'temperatura', 725.0000, 'ºC'),
	(189153, 122, '2014-02-01 01:31:05.000000', 'temperatura', 523.0000, 'ºC'),
	(189154, 122, '2014-02-01 01:31:06.000000', 'temperatura', 440.0000, 'ºC'),
	(189155, 122, '2014-02-01 01:31:07.000000', 'temperatura', 630.0000, 'ºC'),
	(189156, 122, '2014-02-01 01:31:08.000000', 'temperatura', 631.0000, 'ºC'),
	(189157, 122, '2014-02-01 01:31:09.000000', 'temperatura', 67.0000, 'ºC'),
	(189158, 122, '2014-02-01 01:31:10.000000', 'temperatura', 840.0000, 'ºC'),
	(189159, 122, '2014-02-01 01:31:11.000000', 'temperatura', 401.0000, 'ºC'),
	(189160, 122, '2014-02-01 01:31:12.000000', 'temperatura', 685.0000, 'ºC'),
	(189161, 122, '2014-02-01 01:31:13.000000', 'temperatura', 1025.0000, 'ºC'),
	(189162, 122, '2014-02-01 01:31:14.000000', 'temperatura', 667.0000, 'ºC'),
	(189163, 122, '2014-02-01 01:31:15.000000', 'temperatura', 262.0000, 'ºC'),
	(189164, 122, '2014-02-01 01:31:16.000000', 'temperatura', 509.0000, 'ºC'),
	(189165, 122, '2014-02-01 01:31:17.000000', 'temperatura', 558.0000, 'ºC'),
	(189166, 122, '2014-02-01 01:31:18.000000', 'temperatura', 65.0000, 'ºC'),
	(189167, 122, '2014-02-01 01:31:19.000000', 'temperatura', 1051.0000, 'ºC'),
	(189168, 122, '2014-02-01 01:31:20.000000', 'temperatura', 260.0000, 'ºC'),
	(189169, 122, '2014-02-01 01:31:21.000000', 'temperatura', 549.0000, 'ºC'),
	(189170, 122, '2014-02-01 01:31:22.000000', 'temperatura', 764.0000, 'ºC'),
	(189171, 122, '2014-02-01 01:31:23.000000', 'temperatura', 972.0000, 'ºC'),
	(189172, 122, '2014-02-01 01:31:24.000000', 'temperatura', 172.0000, 'ºC'),
	(189173, 122, '2014-02-01 01:31:25.000000', 'temperatura', 341.0000, 'ºC'),
	(189174, 122, '2014-02-01 01:31:26.000000', 'temperatura', 1193.0000, 'ºC'),
	(189175, 122, '2014-02-01 01:31:27.000000', 'temperatura', 141.0000, 'ºC'),
	(189176, 118, '2014-02-15 00:00:00.000000', 'temperatura', 802.0000, 'ºC'),
	(189177, 118, '2014-02-15 00:00:01.000000', 'temperatura', 635.0000, 'ºC'),
	(189178, 118, '2014-02-15 00:00:02.000000', 'temperatura', 771.0000, 'ºC'),
	(189179, 118, '2014-02-15 00:00:03.000000', 'temperatura', 752.0000, 'ºC'),
	(189180, 118, '2014-02-15 00:00:04.000000', 'temperatura', 247.0000, 'ºC'),
	(189181, 118, '2014-02-15 00:00:05.000000', 'temperatura', 179.0000, 'ºC'),
	(189182, 118, '2014-02-15 00:00:06.000000', 'temperatura', 154.0000, 'ºC'),
	(189183, 118, '2014-02-15 00:00:07.000000', 'temperatura', 234.0000, 'ºC'),
	(189184, 118, '2014-02-15 00:00:08.000000', 'temperatura', 708.0000, 'ºC'),
	(189185, 118, '2014-02-15 00:00:09.000000', 'temperatura', 438.0000, 'ºC'),
	(189186, 118, '2014-02-15 00:00:10.000000', 'temperatura', 65.0000, 'ºC'),
	(189187, 118, '2014-02-15 00:00:11.000000', 'temperatura', 213.0000, 'ºC'),
	(189188, 118, '2014-02-15 00:00:12.000000', 'temperatura', 871.0000, 'ºC'),
	(189189, 118, '2014-02-15 00:00:13.000000', 'temperatura', 118.0000, 'ºC'),
	(189190, 118, '2014-02-15 00:00:14.000000', 'temperatura', 375.0000, 'ºC'),
	(189191, 118, '2014-02-15 00:00:15.000000', 'temperatura', 324.0000, 'ºC'),
	(189192, 118, '2014-02-15 00:00:16.000000', 'temperatura', 493.0000, 'ºC'),
	(189193, 118, '2014-02-15 00:00:17.000000', 'temperatura', 293.0000, 'ºC'),
	(189194, 118, '2014-02-15 00:00:18.000000', 'temperatura', 1185.0000, 'ºC'),
	(189195, 118, '2014-02-15 00:00:19.000000', 'temperatura', 250.0000, 'ºC'),
	(189196, 118, '2014-02-15 00:00:20.000000', 'temperatura', 96.0000, 'ºC'),
	(189197, 118, '2014-02-15 00:00:21.000000', 'temperatura', 928.0000, 'ºC'),
	(189198, 118, '2014-02-15 00:00:22.000000', 'temperatura', 753.0000, 'ºC'),
	(189199, 118, '2014-02-15 00:00:23.000000', 'temperatura', 983.0000, 'ºC'),
	(189200, 118, '2014-02-15 00:00:24.000000', 'temperatura', 255.0000, 'ºC'),
	(189201, 118, '2014-02-15 00:00:25.000000', 'temperatura', 729.0000, 'ºC'),
	(189202, 118, '2014-02-15 00:00:26.000000', 'temperatura', 477.0000, 'ºC'),
	(189203, 118, '2014-02-15 00:00:27.000000', 'temperatura', 201.0000, 'ºC'),
	(189204, 118, '2014-02-15 00:00:28.000000', 'temperatura', 774.0000, 'ºC'),
	(189205, 118, '2014-02-15 00:00:29.000000', 'temperatura', 866.0000, 'ºC'),
	(189206, 118, '2014-02-15 00:00:30.000000', 'temperatura', 810.0000, 'ºC'),
	(189207, 118, '2014-02-15 00:00:31.000000', 'temperatura', 252.0000, 'ºC'),
	(189208, 118, '2014-02-15 00:00:32.000000', 'temperatura', 30.0000, 'ºC'),
	(189209, 118, '2014-02-15 00:00:33.000000', 'temperatura', 595.0000, 'ºC'),
	(189210, 118, '2014-02-15 00:00:34.000000', 'temperatura', 484.0000, 'ºC'),
	(189211, 118, '2014-02-15 00:00:35.000000', 'temperatura', 636.0000, 'ºC'),
	(189212, 118, '2014-02-15 00:00:36.000000', 'temperatura', 527.0000, 'ºC'),
	(189213, 118, '2014-02-15 00:00:37.000000', 'temperatura', 729.0000, 'ºC'),
	(189214, 118, '2014-02-15 00:00:38.000000', 'temperatura', 866.0000, 'ºC'),
	(189215, 118, '2014-02-15 00:00:39.000000', 'temperatura', 944.0000, 'ºC'),
	(189216, 118, '2014-02-15 00:00:40.000000', 'temperatura', 920.0000, 'ºC'),
	(189217, 118, '2014-02-15 00:00:41.000000', 'temperatura', 571.0000, 'ºC'),
	(189218, 118, '2014-02-15 00:00:42.000000', 'temperatura', 93.0000, 'ºC'),
	(189219, 118, '2014-02-15 00:00:43.000000', 'temperatura', 1152.0000, 'ºC'),
	(189220, 118, '2014-02-15 00:00:44.000000', 'temperatura', 683.0000, 'ºC'),
	(189221, 118, '2014-02-15 00:00:45.000000', 'temperatura', 1157.0000, 'ºC'),
	(189222, 118, '2014-02-15 00:00:46.000000', 'temperatura', 140.0000, 'ºC'),
	(189223, 118, '2014-02-15 00:00:47.000000', 'temperatura', 828.0000, 'ºC'),
	(189224, 118, '2014-02-15 00:00:48.000000', 'temperatura', 122.0000, 'ºC'),
	(189225, 118, '2014-02-15 00:00:49.000000', 'temperatura', 525.0000, 'ºC'),
	(189226, 118, '2014-02-15 00:00:50.000000', 'temperatura', 1059.0000, 'ºC'),
	(189227, 118, '2014-02-15 00:00:51.000000', 'temperatura', 120.0000, 'ºC'),
	(189228, 118, '2014-02-15 00:00:52.000000', 'temperatura', 1023.0000, 'ºC'),
	(189229, 118, '2014-02-15 00:00:53.000000', 'temperatura', 1155.0000, 'ºC'),
	(189230, 118, '2014-02-15 00:00:54.000000', 'temperatura', 308.0000, 'ºC'),
	(189231, 118, '2014-02-15 00:00:55.000000', 'temperatura', 476.0000, 'ºC'),
	(189232, 118, '2014-02-15 00:00:56.000000', 'temperatura', 255.0000, 'ºC'),
	(189233, 118, '2014-02-15 00:00:57.000000', 'temperatura', 1048.0000, 'ºC'),
	(189234, 118, '2014-02-15 00:00:58.000000', 'temperatura', 875.0000, 'ºC'),
	(189235, 118, '2014-02-15 00:00:59.000000', 'temperatura', 34.0000, 'ºC'),
	(189236, 118, '2014-02-15 00:01:00.000000', 'temperatura', 1143.0000, 'ºC'),
	(189237, 118, '2014-02-15 00:01:01.000000', 'temperatura', 816.0000, 'ºC'),
	(189238, 118, '2014-02-15 00:01:02.000000', 'temperatura', 650.0000, 'ºC'),
	(189239, 118, '2014-02-15 00:01:03.000000', 'temperatura', 803.0000, 'ºC'),
	(189240, 118, '2014-02-15 00:01:04.000000', 'temperatura', 864.0000, 'ºC'),
	(189241, 118, '2014-02-15 00:01:05.000000', 'temperatura', 714.0000, 'ºC'),
	(189242, 118, '2014-02-15 00:01:06.000000', 'temperatura', 977.0000, 'ºC'),
	(189243, 118, '2014-02-15 00:01:07.000000', 'temperatura', 345.0000, 'ºC'),
	(189244, 118, '2014-02-15 00:01:08.000000', 'temperatura', 1195.0000, 'ºC'),
	(189245, 118, '2014-02-15 00:01:09.000000', 'temperatura', 142.0000, 'ºC'),
	(189246, 118, '2014-02-15 00:01:10.000000', 'temperatura', 722.0000, 'ºC'),
	(189247, 118, '2014-02-15 00:01:11.000000', 'temperatura', 786.0000, 'ºC'),
	(189248, 118, '2014-02-15 00:01:12.000000', 'temperatura', 565.0000, 'ºC'),
	(189249, 118, '2014-02-15 00:01:13.000000', 'temperatura', 468.0000, 'ºC'),
	(189250, 118, '2014-02-15 00:01:14.000000', 'temperatura', 643.0000, 'ºC'),
	(189251, 118, '2014-02-15 00:01:15.000000', 'temperatura', 613.0000, 'ºC'),
	(189252, 118, '2014-02-15 00:01:16.000000', 'temperatura', 1137.0000, 'ºC'),
	(189253, 118, '2014-02-15 00:01:17.000000', 'temperatura', 244.0000, 'ºC'),
	(189254, 118, '2014-02-15 00:01:18.000000', 'temperatura', 212.0000, 'ºC'),
	(189255, 118, '2014-02-15 00:01:19.000000', 'temperatura', 327.0000, 'ºC'),
	(189256, 118, '2014-02-15 00:01:20.000000', 'temperatura', 998.0000, 'ºC'),
	(189257, 118, '2014-02-15 00:01:21.000000', 'temperatura', 412.0000, 'ºC'),
	(189258, 118, '2014-02-15 00:01:22.000000', 'temperatura', 266.0000, 'ºC'),
	(189259, 118, '2014-02-15 00:01:23.000000', 'temperatura', 95.0000, 'ºC'),
	(189260, 118, '2014-02-15 00:01:24.000000', 'temperatura', 878.0000, 'ºC'),
	(189261, 118, '2014-02-15 00:01:25.000000', 'temperatura', 506.0000, 'ºC'),
	(189262, 118, '2014-02-15 00:01:26.000000', 'temperatura', 1096.0000, 'ºC'),
	(189263, 118, '2014-02-15 00:01:27.000000', 'temperatura', 364.0000, 'ºC'),
	(189264, 118, '2014-02-15 00:01:28.000000', 'temperatura', 931.0000, 'ºC'),
	(189265, 118, '2014-02-15 00:01:29.000000', 'temperatura', 1163.0000, 'ºC'),
	(189266, 118, '2014-02-15 00:01:30.000000', 'temperatura', 622.0000, 'ºC'),
	(189267, 118, '2014-02-15 00:01:31.000000', 'temperatura', 824.0000, 'ºC'),
	(189268, 118, '2014-02-15 00:01:32.000000', 'temperatura', 1051.0000, 'ºC'),
	(189269, 118, '2014-02-15 00:01:33.000000', 'temperatura', 386.0000, 'ºC'),
	(189270, 118, '2014-02-15 00:01:34.000000', 'temperatura', 1178.0000, 'ºC'),
	(189271, 118, '2014-02-15 00:01:35.000000', 'temperatura', 1134.0000, 'ºC'),
	(189272, 118, '2014-02-15 00:01:36.000000', 'temperatura', 934.0000, 'ºC'),
	(189273, 118, '2014-02-15 00:01:37.000000', 'temperatura', 68.0000, 'ºC'),
	(189274, 118, '2014-02-15 00:01:38.000000', 'temperatura', 1138.0000, 'ºC'),
	(189275, 118, '2014-02-15 00:01:39.000000', 'temperatura', 687.0000, 'ºC'),
	(189276, 118, '2014-02-15 00:01:40.000000', 'temperatura', 21.0000, 'ºC'),
	(189277, 118, '2014-02-15 00:01:41.000000', 'temperatura', 444.0000, 'ºC'),
	(189278, 118, '2014-02-15 00:01:42.000000', 'temperatura', 957.0000, 'ºC'),
	(189279, 118, '2014-02-15 00:01:43.000000', 'temperatura', 1054.0000, 'ºC'),
	(189280, 118, '2014-02-15 00:01:44.000000', 'temperatura', 1198.0000, 'ºC'),
	(189281, 118, '2014-02-15 00:01:45.000000', 'temperatura', 432.0000, 'ºC'),
	(189282, 118, '2014-02-15 00:01:46.000000', 'temperatura', 964.0000, 'ºC'),
	(189283, 118, '2014-02-15 00:01:47.000000', 'temperatura', 1125.0000, 'ºC'),
	(189284, 118, '2014-02-15 00:01:48.000000', 'temperatura', 333.0000, 'ºC'),
	(189285, 118, '2014-02-15 00:01:49.000000', 'temperatura', 692.0000, 'ºC'),
	(189286, 118, '2014-02-15 00:01:50.000000', 'temperatura', 63.0000, 'ºC'),
	(189287, 118, '2014-02-15 00:01:51.000000', 'temperatura', 636.0000, 'ºC'),
	(189288, 118, '2014-02-15 00:01:52.000000', 'temperatura', 593.0000, 'ºC'),
	(189289, 118, '2014-02-15 00:01:53.000000', 'temperatura', 1057.0000, 'ºC'),
	(189290, 118, '2014-02-15 00:01:54.000000', 'temperatura', 1106.0000, 'ºC'),
	(189291, 118, '2014-02-15 00:01:55.000000', 'temperatura', 1162.0000, 'ºC'),
	(189292, 118, '2014-02-15 00:01:56.000000', 'temperatura', 90.0000, 'ºC'),
	(189293, 118, '2014-02-15 00:01:57.000000', 'temperatura', 567.0000, 'ºC'),
	(189294, 118, '2014-02-15 00:01:58.000000', 'temperatura', 162.0000, 'ºC'),
	(189295, 118, '2014-02-15 00:01:59.000000', 'temperatura', 312.0000, 'ºC'),
	(189296, 118, '2014-02-15 00:02:00.000000', 'temperatura', 1073.0000, 'ºC'),
	(189297, 118, '2014-02-15 00:02:01.000000', 'temperatura', 832.0000, 'ºC'),
	(189298, 118, '2014-02-15 00:02:02.000000', 'temperatura', 941.0000, 'ºC'),
	(189299, 118, '2014-02-15 00:02:03.000000', 'temperatura', 1009.0000, 'ºC'),
	(189300, 118, '2014-02-15 00:02:04.000000', 'temperatura', 1022.0000, 'ºC'),
	(189301, 118, '2014-02-15 00:02:05.000000', 'temperatura', 885.0000, 'ºC'),
	(189302, 118, '2014-02-15 00:02:06.000000', 'temperatura', 159.0000, 'ºC'),
	(189303, 118, '2014-02-15 00:02:07.000000', 'temperatura', 540.0000, 'ºC'),
	(189304, 118, '2014-02-15 00:02:08.000000', 'temperatura', 1026.0000, 'ºC'),
	(189305, 118, '2014-02-15 00:02:09.000000', 'temperatura', 1107.0000, 'ºC'),
	(189306, 118, '2014-02-15 00:02:10.000000', 'temperatura', 59.0000, 'ºC'),
	(189307, 118, '2014-02-15 00:02:11.000000', 'temperatura', 573.0000, 'ºC'),
	(189308, 118, '2014-02-15 00:02:12.000000', 'temperatura', 288.0000, 'ºC'),
	(189309, 118, '2014-02-15 00:02:13.000000', 'temperatura', 922.0000, 'ºC'),
	(189310, 118, '2014-02-15 00:02:14.000000', 'temperatura', 149.0000, 'ºC'),
	(189311, 118, '2014-02-15 00:02:15.000000', 'temperatura', 378.0000, 'ºC'),
	(189312, 118, '2014-02-15 00:02:16.000000', 'temperatura', 242.0000, 'ºC'),
	(189313, 118, '2014-02-15 00:02:17.000000', 'temperatura', 78.0000, 'ºC'),
	(189314, 118, '2014-02-15 00:02:18.000000', 'temperatura', 864.0000, 'ºC'),
	(189315, 118, '2014-02-15 00:02:19.000000', 'temperatura', 486.0000, 'ºC'),
	(189316, 118, '2014-02-15 00:02:20.000000', 'temperatura', 1040.0000, 'ºC'),
	(189317, 118, '2014-02-15 00:02:21.000000', 'temperatura', 143.0000, 'ºC'),
	(189318, 118, '2014-02-15 00:02:22.000000', 'temperatura', 1194.0000, 'ºC'),
	(189319, 118, '2014-02-15 00:02:23.000000', 'temperatura', 744.0000, 'ºC'),
	(189320, 118, '2014-02-15 00:02:24.000000', 'temperatura', 135.0000, 'ºC'),
	(189321, 118, '2014-02-15 00:02:25.000000', 'temperatura', 846.0000, 'ºC'),
	(189322, 118, '2014-02-15 00:02:26.000000', 'temperatura', 224.0000, 'ºC'),
	(189323, 118, '2014-02-15 00:02:27.000000', 'temperatura', 981.0000, 'ºC'),
	(189324, 118, '2014-02-15 00:02:28.000000', 'temperatura', 635.0000, 'ºC'),
	(189325, 118, '2014-02-15 00:02:29.000000', 'temperatura', 234.0000, 'ºC'),
	(189326, 118, '2014-02-15 00:02:30.000000', 'temperatura', 464.0000, 'ºC'),
	(189327, 118, '2014-02-15 00:02:31.000000', 'temperatura', 419.0000, 'ºC'),
	(189328, 118, '2014-02-15 00:02:32.000000', 'temperatura', 702.0000, 'ºC'),
	(189329, 118, '2014-02-15 00:02:33.000000', 'temperatura', 1056.0000, 'ºC'),
	(189330, 118, '2014-02-15 00:02:34.000000', 'temperatura', 775.0000, 'ºC'),
	(189331, 118, '2014-02-15 00:02:35.000000', 'temperatura', 708.0000, 'ºC'),
	(189332, 118, '2014-02-15 00:02:36.000000', 'temperatura', 12.0000, 'ºC'),
	(189333, 118, '2014-02-15 00:02:37.000000', 'temperatura', 339.0000, 'ºC'),
	(189334, 118, '2014-02-15 00:02:38.000000', 'temperatura', 461.0000, 'ºC'),
	(189335, 118, '2014-02-15 00:02:39.000000', 'temperatura', 86.0000, 'ºC'),
	(189336, 118, '2014-02-15 00:02:40.000000', 'temperatura', 250.0000, 'ºC'),
	(189337, 118, '2014-02-15 00:02:41.000000', 'temperatura', 989.0000, 'ºC'),
	(189338, 118, '2014-02-15 00:02:42.000000', 'temperatura', 598.0000, 'ºC'),
	(189339, 118, '2014-02-15 00:02:43.000000', 'temperatura', 24.0000, 'ºC'),
	(189340, 118, '2014-02-15 00:02:44.000000', 'temperatura', 724.0000, 'ºC'),
	(189341, 118, '2014-02-15 00:02:45.000000', 'temperatura', 1148.0000, 'ºC'),
	(189342, 118, '2014-02-15 00:02:46.000000', 'temperatura', 1170.0000, 'ºC'),
	(189343, 118, '2014-02-15 00:02:47.000000', 'temperatura', 7.0000, 'ºC'),
	(189344, 118, '2014-02-15 00:02:48.000000', 'temperatura', 125.0000, 'ºC'),
	(189345, 118, '2014-02-15 00:02:49.000000', 'temperatura', 605.0000, 'ºC'),
	(189346, 118, '2014-02-15 00:02:50.000000', 'temperatura', 251.0000, 'ºC'),
	(189347, 118, '2014-02-15 00:02:51.000000', 'temperatura', 642.0000, 'ºC'),
	(189348, 118, '2014-02-15 00:02:52.000000', 'temperatura', 55.0000, 'ºC'),
	(189349, 118, '2014-02-15 00:02:53.000000', 'temperatura', 749.0000, 'ºC'),
	(189350, 118, '2014-02-15 00:02:54.000000', 'temperatura', 1182.0000, 'ºC'),
	(189351, 118, '2014-02-15 00:02:55.000000', 'temperatura', 63.0000, 'ºC'),
	(189352, 118, '2014-02-15 00:02:56.000000', 'temperatura', 370.0000, 'ºC'),
	(189353, 118, '2014-02-15 00:02:57.000000', 'temperatura', 459.0000, 'ºC'),
	(189354, 118, '2014-02-15 00:02:58.000000', 'temperatura', 1189.0000, 'ºC'),
	(189355, 118, '2014-02-15 00:02:59.000000', 'temperatura', 966.0000, 'ºC'),
	(189356, 118, '2014-02-15 00:03:00.000000', 'temperatura', 65.0000, 'ºC'),
	(189357, 118, '2014-02-15 00:03:01.000000', 'temperatura', 1027.0000, 'ºC'),
	(189358, 118, '2014-02-15 00:03:02.000000', 'temperatura', 141.0000, 'ºC'),
	(189359, 118, '2014-02-15 00:03:03.000000', 'temperatura', 26.0000, 'ºC'),
	(189360, 118, '2014-02-15 00:03:04.000000', 'temperatura', 905.0000, 'ºC'),
	(189361, 118, '2014-02-15 00:03:05.000000', 'temperatura', 848.0000, 'ºC'),
	(189362, 118, '2014-02-15 00:03:06.000000', 'temperatura', 325.0000, 'ºC'),
	(189363, 118, '2014-02-15 00:03:07.000000', 'temperatura', 282.0000, 'ºC'),
	(189364, 118, '2014-02-15 00:03:08.000000', 'temperatura', 434.0000, 'ºC'),
	(189365, 118, '2014-02-15 00:03:09.000000', 'temperatura', 124.0000, 'ºC'),
	(189366, 118, '2014-02-15 00:03:10.000000', 'temperatura', 519.0000, 'ºC'),
	(189367, 118, '2014-02-15 00:03:11.000000', 'temperatura', 1025.0000, 'ºC'),
	(189368, 118, '2014-02-15 00:03:12.000000', 'temperatura', 1169.0000, 'ºC'),
	(189369, 118, '2014-02-15 00:03:13.000000', 'temperatura', 368.0000, 'ºC'),
	(189370, 118, '2014-02-15 00:03:14.000000', 'temperatura', 735.0000, 'ºC'),
	(189371, 118, '2014-02-15 00:03:15.000000', 'temperatura', 169.0000, 'ºC'),
	(189372, 118, '2014-02-15 00:03:16.000000', 'temperatura', 1044.0000, 'ºC'),
	(189373, 118, '2014-02-15 00:03:17.000000', 'temperatura', 1112.0000, 'ºC'),
	(189374, 118, '2014-02-15 00:03:18.000000', 'temperatura', 28.0000, 'ºC'),
	(189375, 118, '2014-02-15 00:03:19.000000', 'temperatura', 403.0000, 'ºC'),
	(189376, 118, '2014-02-15 00:03:20.000000', 'temperatura', 732.0000, 'ºC'),
	(189377, 118, '2014-02-15 00:03:21.000000', 'temperatura', 54.0000, 'ºC'),
	(189378, 118, '2014-02-15 00:03:22.000000', 'temperatura', 473.0000, 'ºC'),
	(189379, 118, '2014-02-15 00:03:23.000000', 'temperatura', 1005.0000, 'ºC'),
	(189380, 118, '2014-02-15 00:03:24.000000', 'temperatura', 4.0000, 'ºC'),
	(189381, 118, '2014-02-15 00:03:25.000000', 'temperatura', 608.0000, 'ºC'),
	(189382, 118, '2014-02-15 00:03:26.000000', 'temperatura', 627.0000, 'ºC'),
	(189383, 118, '2014-02-15 00:03:27.000000', 'temperatura', 114.0000, 'ºC'),
	(189384, 118, '2014-02-15 00:03:28.000000', 'temperatura', 1087.0000, 'ºC'),
	(189385, 118, '2014-02-15 00:03:29.000000', 'temperatura', 294.0000, 'ºC'),
	(189386, 118, '2014-02-15 00:03:30.000000', 'temperatura', 609.0000, 'ºC'),
	(189387, 118, '2014-02-15 00:03:31.000000', 'temperatura', 964.0000, 'ºC'),
	(189388, 118, '2014-02-15 00:03:32.000000', 'temperatura', 594.0000, 'ºC'),
	(189389, 118, '2014-02-15 00:03:33.000000', 'temperatura', 79.0000, 'ºC'),
	(189390, 118, '2014-02-15 00:03:34.000000', 'temperatura', 1015.0000, 'ºC'),
	(189391, 118, '2014-02-15 00:03:35.000000', 'temperatura', 36.0000, 'ºC'),
	(189392, 118, '2014-02-15 00:03:36.000000', 'temperatura', 735.0000, 'ºC'),
	(189393, 118, '2014-02-15 00:03:37.000000', 'temperatura', 1166.0000, 'ºC'),
	(189394, 118, '2014-02-15 00:03:38.000000', 'temperatura', 29.0000, 'ºC'),
	(189395, 118, '2014-02-15 00:03:39.000000', 'temperatura', 245.0000, 'ºC'),
	(189396, 118, '2014-02-15 00:03:40.000000', 'temperatura', 1141.0000, 'ºC'),
	(189397, 118, '2014-02-15 00:03:41.000000', 'temperatura', 170.0000, 'ºC'),
	(189398, 118, '2014-02-15 00:03:42.000000', 'temperatura', 1025.0000, 'ºC'),
	(189399, 118, '2014-02-15 00:03:43.000000', 'temperatura', 1019.0000, 'ºC'),
	(189400, 118, '2014-02-15 00:03:44.000000', 'temperatura', 818.0000, 'ºC'),
	(189401, 118, '2014-02-15 00:03:45.000000', 'temperatura', 1034.0000, 'ºC'),
	(189402, 118, '2014-02-15 00:03:46.000000', 'temperatura', 317.0000, 'ºC'),
	(189403, 118, '2014-02-15 00:03:47.000000', 'temperatura', 884.0000, 'ºC'),
	(189404, 118, '2014-02-15 00:03:48.000000', 'temperatura', 1069.0000, 'ºC'),
	(189405, 118, '2014-02-15 00:03:49.000000', 'temperatura', 293.0000, 'ºC'),
	(189406, 118, '2014-02-15 00:03:50.000000', 'temperatura', 659.0000, 'ºC'),
	(189407, 118, '2014-02-15 00:03:51.000000', 'temperatura', 16.0000, 'ºC'),
	(189408, 118, '2014-02-15 00:03:52.000000', 'temperatura', 505.0000, 'ºC'),
	(189409, 118, '2014-02-15 00:03:53.000000', 'temperatura', 75.0000, 'ºC'),
	(189410, 118, '2014-02-15 00:03:54.000000', 'temperatura', 61.0000, 'ºC'),
	(189411, 118, '2014-02-15 00:03:55.000000', 'temperatura', 83.0000, 'ºC'),
	(189412, 118, '2014-02-15 00:03:56.000000', 'temperatura', 230.0000, 'ºC'),
	(189413, 118, '2014-02-15 00:03:57.000000', 'temperatura', 902.0000, 'ºC'),
	(189414, 118, '2014-02-15 00:03:58.000000', 'temperatura', 223.0000, 'ºC'),
	(189415, 118, '2014-02-15 00:03:59.000000', 'temperatura', 807.0000, 'ºC'),
	(189416, 118, '2014-02-15 00:04:00.000000', 'temperatura', 965.0000, 'ºC'),
	(189417, 118, '2014-02-15 00:04:01.000000', 'temperatura', 8.0000, 'ºC'),
	(189418, 118, '2014-02-15 00:04:02.000000', 'temperatura', 744.0000, 'ºC'),
	(189419, 118, '2014-02-15 00:04:03.000000', 'temperatura', 98.0000, 'ºC'),
	(189420, 118, '2014-02-15 00:04:04.000000', 'temperatura', 660.0000, 'ºC'),
	(189421, 118, '2014-02-15 00:04:05.000000', 'temperatura', 603.0000, 'ºC'),
	(189422, 118, '2014-02-15 00:04:06.000000', 'temperatura', 1037.0000, 'ºC'),
	(189423, 118, '2014-02-15 00:04:07.000000', 'temperatura', 976.0000, 'ºC'),
	(189424, 118, '2014-02-15 00:04:08.000000', 'temperatura', 569.0000, 'ºC'),
	(189425, 118, '2014-02-15 00:04:09.000000', 'temperatura', 1118.0000, 'ºC'),
	(189426, 118, '2014-02-15 00:04:10.000000', 'temperatura', 284.0000, 'ºC'),
	(189427, 118, '2014-02-15 00:04:11.000000', 'temperatura', 467.0000, 'ºC'),
	(189428, 118, '2014-02-15 00:04:12.000000', 'temperatura', 282.0000, 'ºC'),
	(189429, 118, '2014-02-15 00:04:13.000000', 'temperatura', 11.0000, 'ºC'),
	(189430, 118, '2014-02-15 00:04:14.000000', 'temperatura', 407.0000, 'ºC'),
	(189431, 118, '2014-02-15 00:04:15.000000', 'temperatura', 803.0000, 'ºC'),
	(189432, 118, '2014-02-15 00:04:16.000000', 'temperatura', 396.0000, 'ºC'),
	(189433, 118, '2014-02-15 00:04:17.000000', 'temperatura', 770.0000, 'ºC'),
	(189434, 118, '2014-02-15 00:04:18.000000', 'temperatura', 264.0000, 'ºC'),
	(189435, 118, '2014-02-15 00:04:19.000000', 'temperatura', 209.0000, 'ºC'),
	(189436, 118, '2014-02-15 00:04:20.000000', 'temperatura', 255.0000, 'ºC'),
	(189437, 118, '2014-02-15 00:04:21.000000', 'temperatura', 646.0000, 'ºC'),
	(189438, 118, '2014-02-15 00:04:22.000000', 'temperatura', 68.0000, 'ºC'),
	(189439, 118, '2014-02-15 00:04:23.000000', 'temperatura', 803.0000, 'ºC'),
	(189440, 118, '2014-02-15 00:04:24.000000', 'temperatura', 211.0000, 'ºC'),
	(189441, 118, '2014-02-15 00:04:25.000000', 'temperatura', 1045.0000, 'ºC'),
	(189442, 118, '2014-02-15 00:04:26.000000', 'temperatura', 991.0000, 'ºC'),
	(189443, 118, '2014-02-15 00:04:27.000000', 'temperatura', 623.0000, 'ºC'),
	(189444, 118, '2014-02-15 00:04:28.000000', 'temperatura', 144.0000, 'ºC'),
	(189445, 118, '2014-02-15 00:04:29.000000', 'temperatura', 49.0000, 'ºC'),
	(189446, 118, '2014-02-15 00:04:30.000000', 'temperatura', 1013.0000, 'ºC'),
	(189447, 118, '2014-02-15 00:04:31.000000', 'temperatura', 118.0000, 'ºC'),
	(189448, 118, '2014-02-15 00:04:32.000000', 'temperatura', 1154.0000, 'ºC'),
	(189449, 118, '2014-02-15 00:04:33.000000', 'temperatura', 614.0000, 'ºC'),
	(189450, 118, '2014-02-15 00:04:34.000000', 'temperatura', 810.0000, 'ºC'),
	(189451, 118, '2014-02-15 00:04:35.000000', 'temperatura', 1009.0000, 'ºC'),
	(189452, 118, '2014-02-15 00:04:36.000000', 'temperatura', 217.0000, 'ºC'),
	(189453, 118, '2014-02-15 00:04:37.000000', 'temperatura', 456.0000, 'ºC'),
	(189454, 118, '2014-02-15 00:04:38.000000', 'temperatura', 429.0000, 'ºC'),
	(189455, 118, '2014-02-15 00:04:39.000000', 'temperatura', 780.0000, 'ºC'),
	(189456, 118, '2014-02-15 00:04:40.000000', 'temperatura', 210.0000, 'ºC'),
	(189457, 118, '2014-02-15 00:04:41.000000', 'temperatura', 1114.0000, 'ºC'),
	(189458, 118, '2014-02-15 00:04:42.000000', 'temperatura', 138.0000, 'ºC'),
	(189459, 118, '2014-02-15 00:04:43.000000', 'temperatura', 951.0000, 'ºC'),
	(189460, 118, '2014-02-15 00:04:44.000000', 'temperatura', 739.0000, 'ºC'),
	(189461, 118, '2014-02-15 00:04:45.000000', 'temperatura', 844.0000, 'ºC'),
	(189462, 118, '2014-02-15 00:04:46.000000', 'temperatura', 805.0000, 'ºC'),
	(189463, 118, '2014-02-15 00:04:47.000000', 'temperatura', 292.0000, 'ºC'),
	(189464, 118, '2014-02-15 00:04:48.000000', 'temperatura', 246.0000, 'ºC'),
	(189465, 118, '2014-02-15 00:04:49.000000', 'temperatura', 352.0000, 'ºC'),
	(189466, 118, '2014-02-15 00:04:50.000000', 'temperatura', 1025.0000, 'ºC'),
	(189467, 118, '2014-02-15 00:04:51.000000', 'temperatura', 467.0000, 'ºC'),
	(189468, 118, '2014-02-15 00:04:52.000000', 'temperatura', 462.0000, 'ºC'),
	(189469, 118, '2014-02-15 00:04:53.000000', 'temperatura', 909.0000, 'ºC'),
	(189470, 118, '2014-02-15 00:04:54.000000', 'temperatura', 760.0000, 'ºC'),
	(189471, 118, '2014-02-15 00:04:55.000000', 'temperatura', 1075.0000, 'ºC'),
	(189472, 118, '2014-02-15 00:04:56.000000', 'temperatura', 693.0000, 'ºC'),
	(189473, 118, '2014-02-15 00:04:57.000000', 'temperatura', 243.0000, 'ºC'),
	(189474, 118, '2014-02-15 00:04:58.000000', 'temperatura', 336.0000, 'ºC'),
	(189475, 118, '2014-02-15 00:04:59.000000', 'temperatura', 950.0000, 'ºC'),
	(189476, 118, '2014-02-15 00:05:00.000000', 'temperatura', 142.0000, 'ºC'),
	(189477, 118, '2014-02-15 00:05:01.000000', 'temperatura', 261.0000, 'ºC'),
	(189478, 118, '2014-02-15 00:05:02.000000', 'temperatura', 878.0000, 'ºC'),
	(189479, 118, '2014-02-15 00:05:03.000000', 'temperatura', 7.0000, 'ºC'),
	(189480, 118, '2014-02-15 00:05:04.000000', 'temperatura', 1003.0000, 'ºC'),
	(189481, 118, '2014-02-15 00:05:05.000000', 'temperatura', 196.0000, 'ºC'),
	(189482, 118, '2014-02-15 00:05:06.000000', 'temperatura', 369.0000, 'ºC'),
	(189483, 118, '2014-02-15 00:05:07.000000', 'temperatura', 60.0000, 'ºC'),
	(189484, 118, '2014-02-15 00:05:08.000000', 'temperatura', 391.0000, 'ºC'),
	(189485, 118, '2014-02-15 00:05:09.000000', 'temperatura', 579.0000, 'ºC'),
	(189486, 118, '2014-02-15 00:05:10.000000', 'temperatura', 519.0000, 'ºC'),
	(189487, 118, '2014-02-15 00:05:11.000000', 'temperatura', 858.0000, 'ºC'),
	(189488, 118, '2014-02-15 00:05:12.000000', 'temperatura', 337.0000, 'ºC'),
	(189489, 118, '2014-02-15 00:05:13.000000', 'temperatura', 309.0000, 'ºC'),
	(189490, 118, '2014-02-15 00:05:14.000000', 'temperatura', 535.0000, 'ºC'),
	(189491, 118, '2014-02-15 00:05:15.000000', 'temperatura', 547.0000, 'ºC'),
	(189492, 118, '2014-02-15 00:05:16.000000', 'temperatura', 1131.0000, 'ºC'),
	(189493, 118, '2014-02-15 00:05:17.000000', 'temperatura', 417.0000, 'ºC'),
	(189494, 118, '2014-02-15 00:05:18.000000', 'temperatura', 1090.0000, 'ºC'),
	(189495, 118, '2014-02-15 00:05:19.000000', 'temperatura', 602.0000, 'ºC'),
	(189496, 118, '2014-02-15 00:05:20.000000', 'temperatura', 940.0000, 'ºC'),
	(189497, 118, '2014-02-15 00:05:21.000000', 'temperatura', 492.0000, 'ºC'),
	(189498, 118, '2014-02-15 00:05:22.000000', 'temperatura', 843.0000, 'ºC'),
	(189499, 118, '2014-02-15 00:05:23.000000', 'temperatura', 340.0000, 'ºC'),
	(189500, 118, '2014-02-15 00:05:24.000000', 'temperatura', 371.0000, 'ºC'),
	(189501, 118, '2014-02-15 00:05:25.000000', 'temperatura', 834.0000, 'ºC'),
	(189502, 118, '2014-02-15 00:05:26.000000', 'temperatura', 657.0000, 'ºC'),
	(189503, 118, '2014-02-15 00:05:27.000000', 'temperatura', 784.0000, 'ºC'),
	(189504, 118, '2014-02-15 00:05:28.000000', 'temperatura', 750.0000, 'ºC'),
	(189505, 118, '2014-02-15 00:05:29.000000', 'temperatura', 200.0000, 'ºC'),
	(189506, 118, '2014-02-15 00:05:30.000000', 'temperatura', 1150.0000, 'ºC'),
	(189507, 118, '2014-02-15 00:05:31.000000', 'temperatura', 349.0000, 'ºC'),
	(189508, 118, '2014-02-15 00:05:32.000000', 'temperatura', 695.0000, 'ºC'),
	(189509, 118, '2014-02-15 00:05:33.000000', 'temperatura', 28.0000, 'ºC'),
	(189510, 118, '2014-02-15 00:05:34.000000', 'temperatura', 457.0000, 'ºC'),
	(189511, 118, '2014-02-15 00:05:35.000000', 'temperatura', 1001.0000, 'ºC'),
	(189512, 118, '2014-02-15 00:05:36.000000', 'temperatura', 33.0000, 'ºC'),
	(189513, 118, '2014-02-15 00:05:37.000000', 'temperatura', 763.0000, 'ºC'),
	(189514, 118, '2014-02-15 00:05:38.000000', 'temperatura', 117.0000, 'ºC'),
	(189515, 118, '2014-02-15 00:05:39.000000', 'temperatura', 695.0000, 'ºC'),
	(189516, 118, '2014-02-15 00:05:40.000000', 'temperatura', 727.0000, 'ºC'),
	(189517, 118, '2014-02-15 00:05:41.000000', 'temperatura', 350.0000, 'ºC'),
	(189518, 118, '2014-02-15 00:05:42.000000', 'temperatura', 769.0000, 'ºC'),
	(189519, 118, '2014-02-15 00:05:43.000000', 'temperatura', 397.0000, 'ºC'),
	(189520, 118, '2014-02-15 00:05:44.000000', 'temperatura', 876.0000, 'ºC'),
	(189521, 118, '2014-02-15 00:05:45.000000', 'temperatura', 792.0000, 'ºC'),
	(189522, 118, '2014-02-15 00:05:46.000000', 'temperatura', 134.0000, 'ºC'),
	(189523, 118, '2014-02-15 00:05:47.000000', 'temperatura', 691.0000, 'ºC'),
	(189524, 118, '2014-02-15 00:05:48.000000', 'temperatura', 655.0000, 'ºC'),
	(189525, 118, '2014-02-15 00:05:49.000000', 'temperatura', 3.0000, 'ºC'),
	(189526, 118, '2014-02-15 00:05:50.000000', 'temperatura', 452.0000, 'ºC'),
	(189527, 118, '2014-02-15 00:05:51.000000', 'temperatura', 1048.0000, 'ºC'),
	(189528, 118, '2014-02-15 00:05:52.000000', 'temperatura', 287.0000, 'ºC'),
	(189529, 118, '2014-02-15 00:05:53.000000', 'temperatura', 693.0000, 'ºC'),
	(189530, 118, '2014-02-15 00:05:54.000000', 'temperatura', 201.0000, 'ºC'),
	(189531, 118, '2014-02-15 00:05:55.000000', 'temperatura', 128.0000, 'ºC'),
	(189532, 118, '2014-02-15 00:05:56.000000', 'temperatura', 37.0000, 'ºC'),
	(189533, 118, '2014-02-15 00:05:57.000000', 'temperatura', 1004.0000, 'ºC'),
	(189534, 118, '2014-02-15 00:05:58.000000', 'temperatura', 107.0000, 'ºC'),
	(189535, 118, '2014-02-15 00:05:59.000000', 'temperatura', 1124.0000, 'ºC'),
	(189536, 118, '2014-02-15 00:06:00.000000', 'temperatura', 498.0000, 'ºC'),
	(189537, 118, '2014-02-15 00:06:01.000000', 'temperatura', 321.0000, 'ºC'),
	(189538, 118, '2014-02-15 00:06:02.000000', 'temperatura', 112.0000, 'ºC'),
	(189539, 118, '2014-02-15 00:06:03.000000', 'temperatura', 796.0000, 'ºC'),
	(189540, 118, '2014-02-15 00:06:04.000000', 'temperatura', 47.0000, 'ºC'),
	(189541, 118, '2014-02-15 00:06:05.000000', 'temperatura', 244.0000, 'ºC'),
	(189542, 118, '2014-02-15 00:06:06.000000', 'temperatura', 1083.0000, 'ºC'),
	(189543, 118, '2014-02-15 00:06:07.000000', 'temperatura', 1081.0000, 'ºC'),
	(189544, 118, '2014-02-15 00:06:08.000000', 'temperatura', 957.0000, 'ºC'),
	(189545, 118, '2014-02-15 00:06:09.000000', 'temperatura', 343.0000, 'ºC'),
	(189546, 118, '2014-02-15 00:06:10.000000', 'temperatura', 44.0000, 'ºC'),
	(189547, 118, '2014-02-15 00:06:11.000000', 'temperatura', 393.0000, 'ºC'),
	(189548, 118, '2014-02-15 00:06:12.000000', 'temperatura', 633.0000, 'ºC'),
	(189549, 118, '2014-02-15 00:06:13.000000', 'temperatura', 788.0000, 'ºC'),
	(189550, 118, '2014-02-15 00:06:14.000000', 'temperatura', 839.0000, 'ºC'),
	(189551, 118, '2014-02-15 00:06:15.000000', 'temperatura', 633.0000, 'ºC'),
	(189552, 118, '2014-02-15 00:06:16.000000', 'temperatura', 647.0000, 'ºC'),
	(189553, 118, '2014-02-15 00:06:17.000000', 'temperatura', 138.0000, 'ºC'),
	(189554, 118, '2014-02-15 00:06:18.000000', 'temperatura', 1151.0000, 'ºC'),
	(189555, 118, '2014-02-15 00:06:19.000000', 'temperatura', 540.0000, 'ºC'),
	(189556, 118, '2014-02-15 00:06:20.000000', 'temperatura', 448.0000, 'ºC'),
	(189557, 118, '2014-02-15 00:06:21.000000', 'temperatura', 621.0000, 'ºC'),
	(189558, 118, '2014-02-15 00:06:22.000000', 'temperatura', 562.0000, 'ºC'),
	(189559, 118, '2014-02-15 00:06:23.000000', 'temperatura', 947.0000, 'ºC'),
	(189560, 118, '2014-02-15 00:06:24.000000', 'temperatura', 650.0000, 'ºC'),
	(189561, 118, '2014-02-15 00:06:25.000000', 'temperatura', 408.0000, 'ºC'),
	(189562, 118, '2014-02-15 00:06:26.000000', 'temperatura', 92.0000, 'ºC'),
	(189563, 118, '2014-02-15 00:06:27.000000', 'temperatura', 435.0000, 'ºC'),
	(189564, 118, '2014-02-15 00:06:28.000000', 'temperatura', 698.0000, 'ºC'),
	(189565, 118, '2014-02-15 00:06:29.000000', 'temperatura', 988.0000, 'ºC'),
	(189566, 118, '2014-02-15 00:06:30.000000', 'temperatura', 445.0000, 'ºC'),
	(189567, 118, '2014-02-15 00:06:31.000000', 'temperatura', 462.0000, 'ºC'),
	(189568, 118, '2014-02-15 00:06:32.000000', 'temperatura', 974.0000, 'ºC'),
	(189569, 118, '2014-02-15 00:06:33.000000', 'temperatura', 1087.0000, 'ºC'),
	(189570, 118, '2014-02-15 00:06:34.000000', 'temperatura', 114.0000, 'ºC'),
	(189571, 118, '2014-02-15 00:06:35.000000', 'temperatura', 908.0000, 'ºC'),
	(189572, 118, '2014-02-15 00:06:36.000000', 'temperatura', 598.0000, 'ºC'),
	(189573, 118, '2014-02-15 00:06:37.000000', 'temperatura', 267.0000, 'ºC'),
	(189574, 118, '2014-02-15 00:06:38.000000', 'temperatura', 741.0000, 'ºC'),
	(189575, 118, '2014-02-15 00:06:39.000000', 'temperatura', 505.0000, 'ºC'),
	(189576, 118, '2014-02-15 00:06:40.000000', 'temperatura', 303.0000, 'ºC'),
	(189577, 118, '2014-02-15 00:06:41.000000', 'temperatura', 2.0000, 'ºC'),
	(189578, 118, '2014-02-15 00:06:42.000000', 'temperatura', 299.0000, 'ºC'),
	(189579, 118, '2014-02-15 00:06:43.000000', 'temperatura', 291.0000, 'ºC'),
	(189580, 118, '2014-02-15 00:06:44.000000', 'temperatura', 560.0000, 'ºC'),
	(189581, 118, '2014-02-15 00:06:45.000000', 'temperatura', 724.0000, 'ºC'),
	(189582, 118, '2014-02-15 00:06:46.000000', 'temperatura', 743.0000, 'ºC'),
	(189583, 118, '2014-02-15 00:06:47.000000', 'temperatura', 342.0000, 'ºC'),
	(189584, 118, '2014-02-15 00:06:48.000000', 'temperatura', 684.0000, 'ºC'),
	(189585, 118, '2014-02-15 00:06:49.000000', 'temperatura', 1192.0000, 'ºC'),
	(189586, 118, '2014-02-15 00:06:50.000000', 'temperatura', 311.0000, 'ºC'),
	(189587, 118, '2014-02-15 00:06:51.000000', 'temperatura', 379.0000, 'ºC'),
	(189588, 118, '2014-02-15 00:06:52.000000', 'temperatura', 963.0000, 'ºC'),
	(189589, 118, '2014-02-15 00:06:53.000000', 'temperatura', 76.0000, 'ºC'),
	(189590, 118, '2014-02-15 00:06:54.000000', 'temperatura', 1095.0000, 'ºC'),
	(189591, 118, '2014-02-15 00:06:55.000000', 'temperatura', 444.0000, 'ºC'),
	(189592, 118, '2014-02-15 00:06:56.000000', 'temperatura', 139.0000, 'ºC'),
	(189593, 118, '2014-02-15 00:06:57.000000', 'temperatura', 561.0000, 'ºC'),
	(189594, 118, '2014-02-15 00:06:58.000000', 'temperatura', 1188.0000, 'ºC'),
	(189595, 118, '2014-02-15 00:06:59.000000', 'temperatura', 658.0000, 'ºC'),
	(189596, 118, '2014-02-15 00:07:00.000000', 'temperatura', 925.0000, 'ºC'),
	(189597, 118, '2014-02-15 00:07:01.000000', 'temperatura', 253.0000, 'ºC'),
	(189598, 118, '2014-02-15 00:07:02.000000', 'temperatura', 888.0000, 'ºC'),
	(189599, 118, '2014-02-15 00:07:03.000000', 'temperatura', 85.0000, 'ºC'),
	(189600, 118, '2014-02-15 00:07:04.000000', 'temperatura', 159.0000, 'ºC'),
	(189601, 118, '2014-02-15 00:07:05.000000', 'temperatura', 542.0000, 'ºC'),
	(189602, 118, '2014-02-15 00:07:06.000000', 'temperatura', 1031.0000, 'ºC'),
	(189603, 118, '2014-02-15 00:07:07.000000', 'temperatura', 1133.0000, 'ºC'),
	(189604, 118, '2014-02-15 00:07:08.000000', 'temperatura', 170.0000, 'ºC'),
	(189605, 118, '2014-02-15 00:07:09.000000', 'temperatura', 1054.0000, 'ºC'),
	(189606, 118, '2014-02-15 00:07:10.000000', 'temperatura', 1159.0000, 'ºC'),
	(189607, 118, '2014-02-15 00:07:11.000000', 'temperatura', 234.0000, 'ºC'),
	(189608, 118, '2014-02-15 00:07:12.000000', 'temperatura', 93.0000, 'ºC'),
	(189609, 118, '2014-02-15 00:07:13.000000', 'temperatura', 965.0000, 'ºC'),
	(189610, 118, '2014-02-15 00:07:14.000000', 'temperatura', 947.0000, 'ºC'),
	(189611, 118, '2014-02-15 00:07:15.000000', 'temperatura', 639.0000, 'ºC'),
	(189612, 118, '2014-02-15 00:07:16.000000', 'temperatura', 355.0000, 'ºC'),
	(189613, 118, '2014-02-15 00:07:17.000000', 'temperatura', 1059.0000, 'ºC'),
	(189614, 118, '2014-02-15 00:07:18.000000', 'temperatura', 630.0000, 'ºC'),
	(189615, 118, '2014-02-15 00:07:19.000000', 'temperatura', 1176.0000, 'ºC'),
	(189616, 118, '2014-02-15 00:07:20.000000', 'temperatura', 387.0000, 'ºC'),
	(189617, 118, '2014-02-15 00:07:21.000000', 'temperatura', 809.0000, 'ºC'),
	(189618, 118, '2014-02-15 00:07:22.000000', 'temperatura', 485.0000, 'ºC'),
	(189619, 118, '2014-02-15 00:07:23.000000', 'temperatura', 1199.0000, 'ºC'),
	(189620, 118, '2014-02-15 00:07:24.000000', 'temperatura', 939.0000, 'ºC'),
	(189621, 118, '2014-02-15 00:07:25.000000', 'temperatura', 1097.0000, 'ºC'),
	(189622, 118, '2014-02-15 00:07:26.000000', 'temperatura', 270.0000, 'ºC'),
	(189623, 118, '2014-02-15 00:07:27.000000', 'temperatura', 458.0000, 'ºC'),
	(189624, 118, '2014-02-15 00:07:28.000000', 'temperatura', 282.0000, 'ºC'),
	(189625, 118, '2014-02-15 00:07:29.000000', 'temperatura', 34.0000, 'ºC'),
	(189626, 118, '2014-02-15 00:07:30.000000', 'temperatura', 527.0000, 'ºC'),
	(189627, 118, '2014-02-15 00:07:31.000000', 'temperatura', 133.0000, 'ºC'),
	(189628, 118, '2014-02-15 00:07:32.000000', 'temperatura', 285.0000, 'ºC'),
	(189629, 118, '2014-02-15 00:07:33.000000', 'temperatura', 1028.0000, 'ºC'),
	(189630, 118, '2014-02-15 00:07:34.000000', 'temperatura', 685.0000, 'ºC'),
	(189631, 118, '2014-02-15 00:07:35.000000', 'temperatura', 340.0000, 'ºC'),
	(189632, 118, '2014-02-15 00:07:36.000000', 'temperatura', 847.0000, 'ºC'),
	(189633, 118, '2014-02-15 00:07:37.000000', 'temperatura', 816.0000, 'ºC'),
	(189634, 118, '2014-02-15 00:07:38.000000', 'temperatura', 337.0000, 'ºC'),
	(189635, 118, '2014-02-15 00:07:39.000000', 'temperatura', 438.0000, 'ºC'),
	(189636, 118, '2014-02-15 00:07:40.000000', 'temperatura', 1179.0000, 'ºC'),
	(189637, 118, '2014-02-15 00:07:41.000000', 'temperatura', 984.0000, 'ºC'),
	(189638, 118, '2014-02-15 00:07:42.000000', 'temperatura', 181.0000, 'ºC'),
	(189639, 118, '2014-02-15 00:07:43.000000', 'temperatura', 354.0000, 'ºC'),
	(189640, 118, '2014-02-15 00:07:44.000000', 'temperatura', 30.0000, 'ºC'),
	(189641, 118, '2014-02-15 00:07:45.000000', 'temperatura', 285.0000, 'ºC'),
	(189642, 118, '2014-02-15 00:07:46.000000', 'temperatura', 138.0000, 'ºC'),
	(189643, 118, '2014-02-15 00:07:47.000000', 'temperatura', 1035.0000, 'ºC'),
	(189644, 118, '2014-02-15 00:07:48.000000', 'temperatura', 1160.0000, 'ºC'),
	(189645, 118, '2014-02-15 00:07:49.000000', 'temperatura', 298.0000, 'ºC'),
	(189646, 118, '2014-02-15 00:07:50.000000', 'temperatura', 410.0000, 'ºC'),
	(189647, 118, '2014-02-15 00:07:51.000000', 'temperatura', 1157.0000, 'ºC'),
	(189648, 118, '2014-02-15 00:07:52.000000', 'temperatura', 956.0000, 'ºC'),
	(189649, 118, '2014-02-15 00:07:53.000000', 'temperatura', 110.0000, 'ºC'),
	(189650, 118, '2014-02-15 00:07:54.000000', 'temperatura', 83.0000, 'ºC'),
	(189651, 118, '2014-02-15 00:07:55.000000', 'temperatura', 85.0000, 'ºC'),
	(189652, 118, '2014-02-15 00:07:56.000000', 'temperatura', 176.0000, 'ºC'),
	(189653, 118, '2014-02-15 00:07:57.000000', 'temperatura', 625.0000, 'ºC'),
	(189654, 118, '2014-02-15 00:07:58.000000', 'temperatura', 196.0000, 'ºC'),
	(189655, 118, '2014-02-15 00:07:59.000000', 'temperatura', 309.0000, 'ºC'),
	(189656, 118, '2014-02-15 00:08:00.000000', 'temperatura', 954.0000, 'ºC'),
	(189657, 118, '2014-02-15 00:08:01.000000', 'temperatura', 246.0000, 'ºC'),
	(189658, 118, '2014-02-15 00:08:02.000000', 'temperatura', 768.0000, 'ºC'),
	(189659, 118, '2014-02-15 00:08:03.000000', 'temperatura', 704.0000, 'ºC'),
	(189660, 118, '2014-02-15 00:08:04.000000', 'temperatura', 14.0000, 'ºC'),
	(189661, 118, '2014-02-15 00:08:05.000000', 'temperatura', 358.0000, 'ºC'),
	(189662, 118, '2014-02-15 00:08:06.000000', 'temperatura', 551.0000, 'ºC'),
	(189663, 118, '2014-02-15 00:08:07.000000', 'temperatura', 480.0000, 'ºC'),
	(189664, 118, '2014-02-15 00:08:08.000000', 'temperatura', 746.0000, 'ºC'),
	(189665, 118, '2014-02-15 00:08:09.000000', 'temperatura', 1091.0000, 'ºC'),
	(189666, 118, '2014-02-15 00:08:10.000000', 'temperatura', 819.0000, 'ºC'),
	(189667, 118, '2014-02-15 00:08:11.000000', 'temperatura', 820.0000, 'ºC'),
	(189668, 118, '2014-02-15 00:08:12.000000', 'temperatura', 446.0000, 'ºC'),
	(189669, 118, '2014-02-15 00:08:13.000000', 'temperatura', 969.0000, 'ºC'),
	(189670, 118, '2014-02-15 00:08:14.000000', 'temperatura', 1110.0000, 'ºC'),
	(189671, 118, '2014-02-15 00:08:15.000000', 'temperatura', 242.0000, 'ºC'),
	(189672, 118, '2014-02-15 00:08:16.000000', 'temperatura', 280.0000, 'ºC'),
	(189673, 118, '2014-02-15 00:08:17.000000', 'temperatura', 675.0000, 'ºC'),
	(189674, 118, '2014-02-15 00:08:18.000000', 'temperatura', 136.0000, 'ºC'),
	(189675, 118, '2014-02-15 00:08:19.000000', 'temperatura', 1057.0000, 'ºC'),
	(189676, 118, '2014-02-15 00:08:20.000000', 'temperatura', 76.0000, 'ºC'),
	(189677, 118, '2014-02-15 00:08:21.000000', 'temperatura', 811.0000, 'ºC'),
	(189678, 118, '2014-02-15 00:08:22.000000', 'temperatura', 227.0000, 'ºC'),
	(189679, 118, '2014-02-15 00:08:23.000000', 'temperatura', 1103.0000, 'ºC'),
	(189680, 118, '2014-02-15 00:08:24.000000', 'temperatura', 32.0000, 'ºC'),
	(189681, 118, '2014-02-15 00:08:25.000000', 'temperatura', 452.0000, 'ºC'),
	(189682, 118, '2014-02-15 00:08:26.000000', 'temperatura', 966.0000, 'ºC'),
	(189683, 118, '2014-02-15 00:08:27.000000', 'temperatura', 1076.0000, 'ºC'),
	(189684, 118, '2014-02-15 00:08:28.000000', 'temperatura', 81.0000, 'ºC'),
	(189685, 118, '2014-02-15 00:08:29.000000', 'temperatura', 777.0000, 'ºC'),
	(189686, 118, '2014-02-15 00:08:30.000000', 'temperatura', 43.0000, 'ºC'),
	(189687, 118, '2014-02-15 00:08:31.000000', 'temperatura', 283.0000, 'ºC'),
	(189688, 118, '2014-02-15 00:08:32.000000', 'temperatura', 87.0000, 'ºC'),
	(189689, 118, '2014-02-15 00:08:33.000000', 'temperatura', 786.0000, 'ºC'),
	(189690, 118, '2014-02-15 00:08:34.000000', 'temperatura', 69.0000, 'ºC'),
	(189691, 118, '2014-02-15 00:08:35.000000', 'temperatura', 389.0000, 'ºC'),
	(189692, 118, '2014-02-15 00:08:36.000000', 'temperatura', 537.0000, 'ºC'),
	(189693, 118, '2014-02-15 00:08:37.000000', 'temperatura', 321.0000, 'ºC'),
	(189694, 118, '2014-02-15 00:08:38.000000', 'temperatura', 1192.0000, 'ºC'),
	(189695, 118, '2014-02-15 00:08:39.000000', 'temperatura', 200.0000, 'ºC'),
	(189696, 118, '2014-02-15 00:08:40.000000', 'temperatura', 1022.0000, 'ºC'),
	(189697, 118, '2014-02-15 00:08:41.000000', 'temperatura', 912.0000, 'ºC'),
	(189698, 118, '2014-02-15 00:08:42.000000', 'temperatura', 296.0000, 'ºC'),
	(189699, 118, '2014-02-15 00:08:43.000000', 'temperatura', 1141.0000, 'ºC'),
	(189700, 118, '2014-02-15 00:08:44.000000', 'temperatura', 20.0000, 'ºC'),
	(189701, 118, '2014-02-15 00:08:45.000000', 'temperatura', 277.0000, 'ºC'),
	(189702, 118, '2014-02-15 00:08:46.000000', 'temperatura', 126.0000, 'ºC'),
	(189703, 118, '2014-02-15 00:08:47.000000', 'temperatura', 997.0000, 'ºC'),
	(189704, 118, '2014-02-15 00:08:48.000000', 'temperatura', 1010.0000, 'ºC'),
	(189705, 118, '2014-02-15 00:08:49.000000', 'temperatura', 860.0000, 'ºC'),
	(189706, 118, '2014-02-15 00:08:50.000000', 'temperatura', 69.0000, 'ºC'),
	(189707, 118, '2014-02-15 00:08:51.000000', 'temperatura', 167.0000, 'ºC'),
	(189708, 118, '2014-02-15 00:08:52.000000', 'temperatura', 627.0000, 'ºC'),
	(189709, 118, '2014-02-15 00:08:53.000000', 'temperatura', 234.0000, 'ºC'),
	(189710, 118, '2014-02-15 00:08:54.000000', 'temperatura', 490.0000, 'ºC'),
	(189711, 118, '2014-02-15 00:08:55.000000', 'temperatura', 548.0000, 'ºC'),
	(189712, 118, '2014-02-15 00:08:56.000000', 'temperatura', 71.0000, 'ºC'),
	(189713, 118, '2014-02-15 00:08:57.000000', 'temperatura', 1111.0000, 'ºC'),
	(189714, 118, '2014-02-15 00:08:58.000000', 'temperatura', 542.0000, 'ºC'),
	(189715, 118, '2014-02-15 00:08:59.000000', 'temperatura', 578.0000, 'ºC'),
	(189716, 118, '2014-02-15 00:09:00.000000', 'temperatura', 66.0000, 'ºC'),
	(189717, 118, '2014-02-15 00:09:01.000000', 'temperatura', 997.0000, 'ºC'),
	(189718, 118, '2014-02-15 00:09:02.000000', 'temperatura', 1185.0000, 'ºC'),
	(189719, 118, '2014-02-15 00:09:03.000000', 'temperatura', 534.0000, 'ºC'),
	(189720, 118, '2014-02-15 00:09:04.000000', 'temperatura', 317.0000, 'ºC'),
	(189721, 118, '2014-02-15 00:09:05.000000', 'temperatura', 1185.0000, 'ºC'),
	(189722, 118, '2014-02-15 00:09:06.000000', 'temperatura', 171.0000, 'ºC'),
	(189723, 118, '2014-02-15 00:09:07.000000', 'temperatura', 904.0000, 'ºC'),
	(189724, 118, '2014-02-15 00:09:08.000000', 'temperatura', 406.0000, 'ºC'),
	(189725, 118, '2014-02-15 00:09:09.000000', 'temperatura', 519.0000, 'ºC'),
	(189726, 118, '2014-02-15 00:09:10.000000', 'temperatura', 179.0000, 'ºC'),
	(189727, 118, '2014-02-15 00:09:11.000000', 'temperatura', 536.0000, 'ºC'),
	(189728, 118, '2014-02-15 00:09:12.000000', 'temperatura', 943.0000, 'ºC'),
	(189729, 118, '2014-02-15 00:09:13.000000', 'temperatura', 710.0000, 'ºC'),
	(189730, 118, '2014-02-15 00:09:14.000000', 'temperatura', 720.0000, 'ºC'),
	(189731, 118, '2014-02-15 00:09:15.000000', 'temperatura', 271.0000, 'ºC'),
	(189732, 118, '2014-02-15 00:09:16.000000', 'temperatura', 395.0000, 'ºC'),
	(189733, 118, '2014-02-15 00:09:17.000000', 'temperatura', 1161.0000, 'ºC'),
	(189734, 118, '2014-02-15 00:09:18.000000', 'temperatura', 1021.0000, 'ºC'),
	(189735, 118, '2014-02-15 00:09:19.000000', 'temperatura', 424.0000, 'ºC'),
	(189736, 118, '2014-02-15 00:09:20.000000', 'temperatura', 255.0000, 'ºC'),
	(189737, 118, '2014-02-15 00:09:21.000000', 'temperatura', 6.0000, 'ºC'),
	(189738, 118, '2014-02-15 00:09:22.000000', 'temperatura', 463.0000, 'ºC'),
	(189739, 118, '2014-02-15 00:09:23.000000', 'temperatura', 1100.0000, 'ºC'),
	(189740, 118, '2014-02-15 00:09:24.000000', 'temperatura', 510.0000, 'ºC'),
	(189741, 118, '2014-02-15 00:09:25.000000', 'temperatura', 450.0000, 'ºC'),
	(189742, 118, '2014-02-15 00:09:26.000000', 'temperatura', 721.0000, 'ºC'),
	(189743, 118, '2014-02-15 00:09:27.000000', 'temperatura', 1054.0000, 'ºC'),
	(189744, 118, '2014-02-15 00:09:28.000000', 'temperatura', 708.0000, 'ºC'),
	(189745, 118, '2014-02-15 00:09:29.000000', 'temperatura', 379.0000, 'ºC'),
	(189746, 118, '2014-02-15 00:09:30.000000', 'temperatura', 970.0000, 'ºC'),
	(189747, 118, '2014-02-15 00:09:31.000000', 'temperatura', 114.0000, 'ºC'),
	(189748, 118, '2014-02-15 00:09:32.000000', 'temperatura', 61.0000, 'ºC'),
	(189749, 118, '2014-02-15 00:09:33.000000', 'temperatura', 1161.0000, 'ºC'),
	(189750, 118, '2014-02-15 00:09:34.000000', 'temperatura', 825.0000, 'ºC'),
	(189751, 118, '2014-02-15 00:09:35.000000', 'temperatura', 643.0000, 'ºC'),
	(189752, 118, '2014-02-15 00:09:36.000000', 'temperatura', 740.0000, 'ºC'),
	(189753, 118, '2014-02-15 00:09:37.000000', 'temperatura', 572.0000, 'ºC'),
	(189754, 118, '2014-02-15 00:09:38.000000', 'temperatura', 638.0000, 'ºC'),
	(189755, 118, '2014-02-15 00:09:39.000000', 'temperatura', 278.0000, 'ºC'),
	(189756, 118, '2014-02-15 00:09:40.000000', 'temperatura', 674.0000, 'ºC'),
	(189757, 118, '2014-02-15 00:09:41.000000', 'temperatura', 139.0000, 'ºC'),
	(189758, 118, '2014-02-15 00:09:42.000000', 'temperatura', 1071.0000, 'ºC'),
	(189759, 118, '2014-02-15 00:09:43.000000', 'temperatura', 140.0000, 'ºC'),
	(189760, 118, '2014-02-15 00:09:44.000000', 'temperatura', 1088.0000, 'ºC'),
	(189761, 118, '2014-02-15 00:09:45.000000', 'temperatura', 222.0000, 'ºC'),
	(189762, 118, '2014-02-15 00:09:46.000000', 'temperatura', 243.0000, 'ºC'),
	(189763, 118, '2014-02-15 00:09:47.000000', 'temperatura', 550.0000, 'ºC'),
	(189764, 118, '2014-02-15 00:09:48.000000', 'temperatura', 824.0000, 'ºC'),
	(189765, 118, '2014-02-15 00:09:49.000000', 'temperatura', 70.0000, 'ºC'),
	(189766, 118, '2014-02-15 00:09:50.000000', 'temperatura', 279.0000, 'ºC'),
	(189767, 118, '2014-02-15 00:09:51.000000', 'temperatura', 1183.0000, 'ºC'),
	(189768, 118, '2014-02-15 00:09:52.000000', 'temperatura', 280.0000, 'ºC'),
	(189769, 118, '2014-02-15 00:09:53.000000', 'temperatura', 252.0000, 'ºC'),
	(189770, 118, '2014-02-15 00:09:54.000000', 'temperatura', 422.0000, 'ºC'),
	(189771, 118, '2014-02-15 00:09:55.000000', 'temperatura', 153.0000, 'ºC'),
	(189772, 118, '2014-02-15 00:09:56.000000', 'temperatura', 702.0000, 'ºC'),
	(189773, 118, '2014-02-15 00:09:57.000000', 'temperatura', 649.0000, 'ºC'),
	(189774, 118, '2014-02-15 00:09:58.000000', 'temperatura', 1138.0000, 'ºC'),
	(189775, 118, '2014-02-15 00:09:59.000000', 'temperatura', 146.0000, 'ºC'),
	(189776, 118, '2014-02-15 00:10:00.000000', 'temperatura', 914.0000, 'ºC'),
	(189777, 118, '2014-02-15 00:10:01.000000', 'temperatura', 534.0000, 'ºC'),
	(189778, 118, '2014-02-15 00:10:02.000000', 'temperatura', 1126.0000, 'ºC'),
	(189779, 118, '2014-02-15 00:10:03.000000', 'temperatura', 431.0000, 'ºC'),
	(189780, 118, '2014-02-15 00:10:04.000000', 'temperatura', 1177.0000, 'ºC'),
	(189781, 118, '2014-02-15 00:10:05.000000', 'temperatura', 994.0000, 'ºC'),
	(189782, 118, '2014-02-15 00:10:06.000000', 'temperatura', 240.0000, 'ºC'),
	(189783, 118, '2014-02-15 00:10:07.000000', 'temperatura', 616.0000, 'ºC'),
	(189784, 118, '2014-02-15 00:10:08.000000', 'temperatura', 1160.0000, 'ºC'),
	(189785, 118, '2014-02-15 00:10:09.000000', 'temperatura', 352.0000, 'ºC'),
	(189786, 118, '2014-02-15 00:10:10.000000', 'temperatura', 681.0000, 'ºC'),
	(189787, 118, '2014-02-15 00:10:11.000000', 'temperatura', 1149.0000, 'ºC'),
	(189788, 118, '2014-02-15 00:10:12.000000', 'temperatura', 102.0000, 'ºC'),
	(189789, 118, '2014-02-15 00:10:13.000000', 'temperatura', 665.0000, 'ºC'),
	(189790, 118, '2014-02-15 00:10:14.000000', 'temperatura', 617.0000, 'ºC'),
	(189791, 118, '2014-02-15 00:10:15.000000', 'temperatura', 1094.0000, 'ºC'),
	(189792, 118, '2014-02-15 00:10:16.000000', 'temperatura', 18.0000, 'ºC'),
	(189793, 118, '2014-02-15 00:10:17.000000', 'temperatura', 407.0000, 'ºC'),
	(189794, 118, '2014-02-15 00:10:18.000000', 'temperatura', 782.0000, 'ºC'),
	(189795, 118, '2014-02-15 00:10:19.000000', 'temperatura', 288.0000, 'ºC'),
	(189796, 118, '2014-02-15 00:10:20.000000', 'temperatura', 297.0000, 'ºC'),
	(189797, 118, '2014-02-15 00:10:21.000000', 'temperatura', 622.0000, 'ºC'),
	(189798, 118, '2014-02-15 00:10:22.000000', 'temperatura', 1020.0000, 'ºC'),
	(189799, 118, '2014-02-15 00:10:23.000000', 'temperatura', 833.0000, 'ºC'),
	(189800, 118, '2014-02-15 00:10:24.000000', 'temperatura', 1108.0000, 'ºC'),
	(189801, 118, '2014-02-15 00:10:25.000000', 'temperatura', 638.0000, 'ºC'),
	(189802, 118, '2014-02-15 00:10:26.000000', 'temperatura', 1068.0000, 'ºC'),
	(189803, 118, '2014-02-15 00:10:27.000000', 'temperatura', 1027.0000, 'ºC'),
	(189804, 118, '2014-02-15 00:10:28.000000', 'temperatura', 730.0000, 'ºC'),
	(189805, 118, '2014-02-15 00:10:29.000000', 'temperatura', 569.0000, 'ºC'),
	(189806, 118, '2014-02-15 00:10:30.000000', 'temperatura', 654.0000, 'ºC'),
	(189807, 118, '2014-02-15 00:10:31.000000', 'temperatura', 367.0000, 'ºC'),
	(189808, 118, '2014-02-15 00:10:32.000000', 'temperatura', 1072.0000, 'ºC'),
	(189809, 118, '2014-02-15 00:10:33.000000', 'temperatura', 660.0000, 'ºC'),
	(189810, 118, '2014-02-15 00:10:34.000000', 'temperatura', 83.0000, 'ºC'),
	(189811, 118, '2014-02-15 00:10:35.000000', 'temperatura', 836.0000, 'ºC'),
	(189812, 118, '2014-02-15 00:10:36.000000', 'temperatura', 333.0000, 'ºC'),
	(189813, 118, '2014-02-15 00:10:37.000000', 'temperatura', 356.0000, 'ºC'),
	(189814, 118, '2014-02-15 00:10:38.000000', 'temperatura', 784.0000, 'ºC'),
	(189815, 118, '2014-02-15 00:10:39.000000', 'temperatura', 451.0000, 'ºC'),
	(189816, 118, '2014-02-15 00:10:40.000000', 'temperatura', 1102.0000, 'ºC'),
	(189817, 118, '2014-02-15 00:10:41.000000', 'temperatura', 560.0000, 'ºC'),
	(189818, 118, '2014-02-15 00:10:42.000000', 'temperatura', 692.0000, 'ºC'),
	(189819, 118, '2014-02-15 00:10:43.000000', 'temperatura', 581.0000, 'ºC'),
	(189820, 118, '2014-02-15 00:10:44.000000', 'temperatura', 831.0000, 'ºC'),
	(189821, 118, '2014-02-15 00:10:45.000000', 'temperatura', 13.0000, 'ºC'),
	(189822, 118, '2014-02-15 00:10:46.000000', 'temperatura', 1169.0000, 'ºC'),
	(189823, 118, '2014-02-15 00:10:47.000000', 'temperatura', 1010.0000, 'ºC'),
	(189824, 118, '2014-02-15 00:10:48.000000', 'temperatura', 344.0000, 'ºC'),
	(189825, 118, '2014-02-15 00:10:49.000000', 'temperatura', 1089.0000, 'ºC'),
	(189826, 118, '2014-02-15 00:10:50.000000', 'temperatura', 814.0000, 'ºC'),
	(189827, 118, '2014-02-15 00:10:51.000000', 'temperatura', 803.0000, 'ºC'),
	(189828, 118, '2014-02-15 00:10:52.000000', 'temperatura', 373.0000, 'ºC'),
	(189829, 118, '2014-02-15 00:10:53.000000', 'temperatura', 658.0000, 'ºC'),
	(189830, 118, '2014-02-15 00:10:54.000000', 'temperatura', 970.0000, 'ºC'),
	(189831, 118, '2014-02-15 00:10:55.000000', 'temperatura', 476.0000, 'ºC'),
	(189832, 118, '2014-02-15 00:10:56.000000', 'temperatura', 673.0000, 'ºC'),
	(189833, 118, '2014-02-15 00:10:57.000000', 'temperatura', 736.0000, 'ºC'),
	(189834, 118, '2014-02-15 00:10:58.000000', 'temperatura', 461.0000, 'ºC'),
	(189835, 118, '2014-02-15 00:10:59.000000', 'temperatura', 100.0000, 'ºC'),
	(189836, 118, '2014-02-15 00:11:00.000000', 'temperatura', 315.0000, 'ºC'),
	(189837, 118, '2014-02-15 00:11:01.000000', 'temperatura', 76.0000, 'ºC'),
	(189838, 118, '2014-02-15 00:11:02.000000', 'temperatura', 638.0000, 'ºC'),
	(189839, 118, '2014-02-15 00:11:03.000000', 'temperatura', 560.0000, 'ºC'),
	(189840, 118, '2014-02-15 00:11:04.000000', 'temperatura', 887.0000, 'ºC'),
	(189841, 118, '2014-02-15 00:11:05.000000', 'temperatura', 354.0000, 'ºC'),
	(189842, 118, '2014-02-15 00:11:06.000000', 'temperatura', 310.0000, 'ºC'),
	(189843, 118, '2014-02-15 00:11:07.000000', 'temperatura', 488.0000, 'ºC'),
	(189844, 118, '2014-02-15 00:11:08.000000', 'temperatura', 310.0000, 'ºC'),
	(189845, 118, '2014-02-15 00:11:09.000000', 'temperatura', 86.0000, 'ºC'),
	(189846, 118, '2014-02-15 00:11:10.000000', 'temperatura', 701.0000, 'ºC'),
	(189847, 118, '2014-02-15 00:11:11.000000', 'temperatura', 847.0000, 'ºC'),
	(189848, 118, '2014-02-15 00:11:12.000000', 'temperatura', 934.0000, 'ºC'),
	(189849, 118, '2014-02-15 00:11:13.000000', 'temperatura', 929.0000, 'ºC'),
	(189850, 118, '2014-02-15 00:11:14.000000', 'temperatura', 643.0000, 'ºC'),
	(189851, 118, '2014-02-15 00:11:15.000000', 'temperatura', 429.0000, 'ºC'),
	(189852, 118, '2014-02-15 00:11:16.000000', 'temperatura', 217.0000, 'ºC'),
	(189853, 118, '2014-02-15 00:11:17.000000', 'temperatura', 997.0000, 'ºC'),
	(189854, 118, '2014-02-15 00:11:18.000000', 'temperatura', 737.0000, 'ºC'),
	(189855, 118, '2014-02-15 00:11:19.000000', 'temperatura', 693.0000, 'ºC'),
	(189856, 118, '2014-02-15 00:11:20.000000', 'temperatura', 53.0000, 'ºC'),
	(189857, 118, '2014-02-15 00:11:21.000000', 'temperatura', 589.0000, 'ºC'),
	(189858, 118, '2014-02-15 00:11:22.000000', 'temperatura', 386.0000, 'ºC'),
	(189859, 118, '2014-02-15 00:11:23.000000', 'temperatura', 163.0000, 'ºC'),
	(189860, 118, '2014-02-15 00:11:24.000000', 'temperatura', 856.0000, 'ºC'),
	(189861, 118, '2014-02-15 00:11:25.000000', 'temperatura', 191.0000, 'ºC'),
	(189862, 118, '2014-02-15 00:11:26.000000', 'temperatura', 791.0000, 'ºC'),
	(189863, 118, '2014-02-15 00:11:27.000000', 'temperatura', 980.0000, 'ºC'),
	(189864, 118, '2014-02-15 00:11:28.000000', 'temperatura', 128.0000, 'ºC'),
	(189865, 118, '2014-02-15 00:11:29.000000', 'temperatura', 100.0000, 'ºC'),
	(189866, 118, '2014-02-15 00:11:30.000000', 'temperatura', 118.0000, 'ºC'),
	(189867, 118, '2014-02-15 00:11:31.000000', 'temperatura', 292.0000, 'ºC'),
	(189868, 118, '2014-02-15 00:11:32.000000', 'temperatura', 1104.0000, 'ºC'),
	(189869, 118, '2014-02-15 00:11:33.000000', 'temperatura', 1044.0000, 'ºC'),
	(189870, 118, '2014-02-15 00:11:34.000000', 'temperatura', 710.0000, 'ºC'),
	(189871, 118, '2014-02-15 00:11:35.000000', 'temperatura', 419.0000, 'ºC'),
	(189872, 118, '2014-02-15 00:11:36.000000', 'temperatura', 1166.0000, 'ºC'),
	(189873, 118, '2014-02-15 00:11:37.000000', 'temperatura', 974.0000, 'ºC'),
	(189874, 118, '2014-02-15 00:11:38.000000', 'temperatura', 173.0000, 'ºC'),
	(189875, 118, '2014-02-15 00:11:39.000000', 'temperatura', 344.0000, 'ºC'),
	(189876, 118, '2014-02-15 00:11:40.000000', 'temperatura', 2.0000, 'ºC'),
	(189877, 118, '2014-02-15 00:11:41.000000', 'temperatura', 179.0000, 'ºC'),
	(189878, 118, '2014-02-15 00:11:42.000000', 'temperatura', 889.0000, 'ºC'),
	(189879, 118, '2014-02-15 00:11:43.000000', 'temperatura', 306.0000, 'ºC'),
	(189880, 118, '2014-02-15 00:11:44.000000', 'temperatura', 67.0000, 'ºC'),
	(189881, 118, '2014-02-15 00:11:45.000000', 'temperatura', 615.0000, 'ºC'),
	(189882, 118, '2014-02-15 00:11:46.000000', 'temperatura', 474.0000, 'ºC'),
	(189883, 118, '2014-02-15 00:11:47.000000', 'temperatura', 527.0000, 'ºC'),
	(189884, 118, '2014-02-15 00:11:48.000000', 'temperatura', 12.0000, 'ºC'),
	(189885, 118, '2014-02-15 00:11:49.000000', 'temperatura', 879.0000, 'ºC'),
	(189886, 118, '2014-02-15 00:11:50.000000', 'temperatura', 759.0000, 'ºC'),
	(189887, 118, '2014-02-15 00:11:51.000000', 'temperatura', 1160.0000, 'ºC'),
	(189888, 118, '2014-02-15 00:11:52.000000', 'temperatura', 1123.0000, 'ºC'),
	(189889, 118, '2014-02-15 00:11:53.000000', 'temperatura', 935.0000, 'ºC'),
	(189890, 118, '2014-02-15 00:11:54.000000', 'temperatura', 109.0000, 'ºC'),
	(189891, 118, '2014-02-15 00:11:55.000000', 'temperatura', 138.0000, 'ºC'),
	(189892, 118, '2014-02-15 00:11:56.000000', 'temperatura', 366.0000, 'ºC'),
	(189893, 118, '2014-02-15 00:11:57.000000', 'temperatura', 216.0000, 'ºC'),
	(189894, 118, '2014-02-15 00:11:58.000000', 'temperatura', 1184.0000, 'ºC'),
	(189895, 118, '2014-02-15 00:11:59.000000', 'temperatura', 471.0000, 'ºC'),
	(189896, 118, '2014-02-15 00:12:00.000000', 'temperatura', 5.0000, 'ºC'),
	(189897, 118, '2014-02-15 00:12:01.000000', 'temperatura', 1012.0000, 'ºC'),
	(189898, 118, '2014-02-15 00:12:02.000000', 'temperatura', 245.0000, 'ºC'),
	(189899, 118, '2014-02-15 00:12:03.000000', 'temperatura', 590.0000, 'ºC'),
	(189900, 118, '2014-02-15 00:12:04.000000', 'temperatura', 1014.0000, 'ºC'),
	(189901, 118, '2014-02-15 00:12:05.000000', 'temperatura', 901.0000, 'ºC'),
	(189902, 118, '2014-02-15 00:12:06.000000', 'temperatura', 263.0000, 'ºC'),
	(189903, 118, '2014-02-15 00:12:07.000000', 'temperatura', 1013.0000, 'ºC'),
	(189904, 118, '2014-02-15 00:12:08.000000', 'temperatura', 679.0000, 'ºC'),
	(189905, 118, '2014-02-15 00:12:09.000000', 'temperatura', 353.0000, 'ºC'),
	(189906, 118, '2014-02-15 00:12:10.000000', 'temperatura', 930.0000, 'ºC'),
	(189907, 118, '2014-02-15 00:12:11.000000', 'temperatura', 1192.0000, 'ºC'),
	(189908, 118, '2014-02-15 00:12:12.000000', 'temperatura', 768.0000, 'ºC'),
	(189909, 118, '2014-02-15 00:12:13.000000', 'temperatura', 267.0000, 'ºC'),
	(189910, 118, '2014-02-15 00:12:14.000000', 'temperatura', 231.0000, 'ºC'),
	(189911, 118, '2014-02-15 00:12:15.000000', 'temperatura', 355.0000, 'ºC'),
	(189912, 118, '2014-02-15 00:12:16.000000', 'temperatura', 1082.0000, 'ºC'),
	(189913, 118, '2014-02-15 00:12:17.000000', 'temperatura', 746.0000, 'ºC'),
	(189914, 118, '2014-02-15 00:12:18.000000', 'temperatura', 486.0000, 'ºC'),
	(189915, 118, '2014-02-15 00:12:19.000000', 'temperatura', 189.0000, 'ºC'),
	(189916, 118, '2014-02-15 00:12:20.000000', 'temperatura', 691.0000, 'ºC'),
	(189917, 118, '2014-02-15 00:12:21.000000', 'temperatura', 487.0000, 'ºC'),
	(189918, 118, '2014-02-15 00:12:22.000000', 'temperatura', 363.0000, 'ºC'),
	(189919, 118, '2014-02-15 00:12:23.000000', 'temperatura', 355.0000, 'ºC'),
	(189920, 118, '2014-02-15 00:12:24.000000', 'temperatura', 684.0000, 'ºC'),
	(189921, 118, '2014-02-15 00:12:25.000000', 'temperatura', 1158.0000, 'ºC'),
	(189922, 118, '2014-02-15 00:12:26.000000', 'temperatura', 139.0000, 'ºC'),
	(189923, 118, '2014-02-15 00:12:27.000000', 'temperatura', 819.0000, 'ºC'),
	(189924, 118, '2014-02-15 00:12:28.000000', 'temperatura', 81.0000, 'ºC'),
	(189925, 118, '2014-02-15 00:12:29.000000', 'temperatura', 346.0000, 'ºC'),
	(189926, 118, '2014-02-15 00:12:30.000000', 'temperatura', 288.0000, 'ºC'),
	(189927, 118, '2014-02-15 00:12:31.000000', 'temperatura', 401.0000, 'ºC'),
	(189928, 118, '2014-02-15 00:12:32.000000', 'temperatura', 1145.0000, 'ºC'),
	(189929, 118, '2014-02-15 00:12:33.000000', 'temperatura', 920.0000, 'ºC'),
	(189930, 118, '2014-02-15 00:12:34.000000', 'temperatura', 1166.0000, 'ºC'),
	(189931, 118, '2014-02-15 00:12:35.000000', 'temperatura', 672.0000, 'ºC'),
	(189932, 118, '2014-02-15 00:12:36.000000', 'temperatura', 1062.0000, 'ºC'),
	(189933, 118, '2014-02-15 00:12:37.000000', 'temperatura', 895.0000, 'ºC'),
	(189934, 118, '2014-02-15 00:12:38.000000', 'temperatura', 89.0000, 'ºC'),
	(189935, 118, '2014-02-15 00:12:39.000000', 'temperatura', 161.0000, 'ºC'),
	(189936, 118, '2014-02-15 00:12:40.000000', 'temperatura', 537.0000, 'ºC'),
	(189937, 118, '2014-02-15 00:12:41.000000', 'temperatura', 1005.0000, 'ºC'),
	(189938, 118, '2014-02-15 00:12:42.000000', 'temperatura', 1012.0000, 'ºC'),
	(189939, 118, '2014-02-15 00:12:43.000000', 'temperatura', 848.0000, 'ºC'),
	(189940, 118, '2014-02-15 00:12:44.000000', 'temperatura', 2.0000, 'ºC'),
	(189941, 118, '2014-02-15 00:12:45.000000', 'temperatura', 1069.0000, 'ºC'),
	(189942, 118, '2014-02-15 00:12:46.000000', 'temperatura', 538.0000, 'ºC'),
	(189943, 118, '2014-02-15 00:12:47.000000', 'temperatura', 685.0000, 'ºC'),
	(189944, 118, '2014-02-15 00:12:48.000000', 'temperatura', 610.0000, 'ºC'),
	(189945, 118, '2014-02-15 00:12:49.000000', 'temperatura', 995.0000, 'ºC'),
	(189946, 118, '2014-02-15 00:12:50.000000', 'temperatura', 747.0000, 'ºC'),
	(189947, 118, '2014-02-15 00:12:51.000000', 'temperatura', 750.0000, 'ºC'),
	(189948, 118, '2014-02-15 00:12:52.000000', 'temperatura', 309.0000, 'ºC'),
	(189949, 118, '2014-02-15 00:12:53.000000', 'temperatura', 495.0000, 'ºC'),
	(189950, 118, '2014-02-15 00:12:54.000000', 'temperatura', 348.0000, 'ºC'),
	(189951, 118, '2014-02-15 00:12:55.000000', 'temperatura', 256.0000, 'ºC'),
	(189952, 118, '2014-02-15 00:12:56.000000', 'temperatura', 235.0000, 'ºC'),
	(189953, 118, '2014-02-15 00:12:57.000000', 'temperatura', 411.0000, 'ºC'),
	(189954, 118, '2014-02-15 00:12:58.000000', 'temperatura', 148.0000, 'ºC'),
	(189955, 118, '2014-02-15 00:12:59.000000', 'temperatura', 706.0000, 'ºC'),
	(189956, 118, '2014-02-15 00:13:00.000000', 'temperatura', 689.0000, 'ºC'),
	(189957, 118, '2014-02-15 00:13:01.000000', 'temperatura', 127.0000, 'ºC'),
	(189958, 118, '2014-02-15 00:13:02.000000', 'temperatura', 967.0000, 'ºC'),
	(189959, 118, '2014-02-15 00:13:03.000000', 'temperatura', 857.0000, 'ºC'),
	(189960, 118, '2014-02-15 00:13:04.000000', 'temperatura', 182.0000, 'ºC'),
	(189961, 118, '2014-02-15 00:13:05.000000', 'temperatura', 741.0000, 'ºC'),
	(189962, 118, '2014-02-15 00:13:06.000000', 'temperatura', 757.0000, 'ºC'),
	(189963, 118, '2014-02-15 00:13:07.000000', 'temperatura', 364.0000, 'ºC'),
	(189964, 118, '2014-02-15 00:13:08.000000', 'temperatura', 750.0000, 'ºC'),
	(189965, 118, '2014-02-15 00:13:09.000000', 'temperatura', 258.0000, 'ºC'),
	(189966, 118, '2014-02-15 00:13:10.000000', 'temperatura', 239.0000, 'ºC'),
	(189967, 118, '2014-02-15 00:13:11.000000', 'temperatura', 424.0000, 'ºC'),
	(189968, 118, '2014-02-15 00:13:12.000000', 'temperatura', 200.0000, 'ºC'),
	(189969, 118, '2014-02-15 00:13:13.000000', 'temperatura', 932.0000, 'ºC'),
	(189970, 118, '2014-02-15 00:13:14.000000', 'temperatura', 460.0000, 'ºC'),
	(189971, 118, '2014-02-15 00:13:15.000000', 'temperatura', 703.0000, 'ºC'),
	(189972, 118, '2014-02-15 00:13:16.000000', 'temperatura', 938.0000, 'ºC'),
	(189973, 118, '2014-02-15 00:13:17.000000', 'temperatura', 182.0000, 'ºC'),
	(189974, 118, '2014-02-15 00:13:18.000000', 'temperatura', 494.0000, 'ºC'),
	(189975, 118, '2014-02-15 00:13:19.000000', 'temperatura', 726.0000, 'ºC'),
	(189976, 118, '2014-02-15 00:13:20.000000', 'temperatura', 950.0000, 'ºC'),
	(189977, 118, '2014-02-15 00:13:21.000000', 'temperatura', 170.0000, 'ºC'),
	(189978, 118, '2014-02-15 00:13:22.000000', 'temperatura', 401.0000, 'ºC'),
	(189979, 118, '2014-02-15 00:13:23.000000', 'temperatura', 296.0000, 'ºC'),
	(189980, 118, '2014-02-15 00:13:24.000000', 'temperatura', 276.0000, 'ºC'),
	(189981, 118, '2014-02-15 00:13:25.000000', 'temperatura', 494.0000, 'ºC'),
	(189982, 118, '2014-02-15 00:13:26.000000', 'temperatura', 443.0000, 'ºC'),
	(189983, 118, '2014-02-15 00:13:27.000000', 'temperatura', 734.0000, 'ºC'),
	(189984, 118, '2014-02-15 00:13:28.000000', 'temperatura', 1143.0000, 'ºC'),
	(189985, 118, '2014-02-15 00:13:29.000000', 'temperatura', 1110.0000, 'ºC'),
	(189986, 118, '2014-02-15 00:13:30.000000', 'temperatura', 925.0000, 'ºC'),
	(189987, 118, '2014-02-15 00:13:31.000000', 'temperatura', 93.0000, 'ºC'),
	(189988, 118, '2014-02-15 00:13:32.000000', 'temperatura', 92.0000, 'ºC'),
	(189989, 118, '2014-02-15 00:13:33.000000', 'temperatura', 180.0000, 'ºC'),
	(189990, 118, '2014-02-15 00:13:34.000000', 'temperatura', 625.0000, 'ºC'),
	(189991, 118, '2014-02-15 00:13:35.000000', 'temperatura', 184.0000, 'ºC'),
	(189992, 118, '2014-02-15 00:13:36.000000', 'temperatura', 246.0000, 'ºC'),
	(189993, 118, '2014-02-15 00:13:37.000000', 'temperatura', 679.0000, 'ºC'),
	(189994, 118, '2014-02-15 00:13:38.000000', 'temperatura', 258.0000, 'ºC'),
	(189995, 118, '2014-02-15 00:13:39.000000', 'temperatura', 451.0000, 'ºC'),
	(189996, 118, '2014-02-15 00:13:40.000000', 'temperatura', 285.0000, 'ºC'),
	(189997, 118, '2014-02-15 00:13:41.000000', 'temperatura', 70.0000, 'ºC'),
	(189998, 118, '2014-02-15 00:13:42.000000', 'temperatura', 696.0000, 'ºC'),
	(189999, 118, '2014-02-15 00:13:43.000000', 'temperatura', 872.0000, 'ºC'),
	(190000, 118, '2014-02-15 00:13:44.000000', 'temperatura', 1073.0000, 'ºC'),
	(190001, 118, '2014-02-15 00:13:45.000000', 'temperatura', 348.0000, 'ºC'),
	(190002, 118, '2014-02-15 00:13:46.000000', 'temperatura', 923.0000, 'ºC'),
	(190003, 118, '2014-02-15 00:13:47.000000', 'temperatura', 1169.0000, 'ºC'),
	(190004, 118, '2014-02-15 00:13:48.000000', 'temperatura', 676.0000, 'ºC'),
	(190005, 118, '2014-02-15 00:13:49.000000', 'temperatura', 1076.0000, 'ºC'),
	(190006, 118, '2014-02-15 00:13:50.000000', 'temperatura', 953.0000, 'ºC'),
	(190007, 118, '2014-02-15 00:13:51.000000', 'temperatura', 337.0000, 'ºC'),
	(190008, 118, '2014-02-15 00:13:52.000000', 'temperatura', 28.0000, 'ºC'),
	(190009, 118, '2014-02-15 00:13:53.000000', 'temperatura', 327.0000, 'ºC'),
	(190010, 118, '2014-02-15 00:13:54.000000', 'temperatura', 351.0000, 'ºC'),
	(190011, 118, '2014-02-15 00:13:55.000000', 'temperatura', 775.0000, 'ºC'),
	(190012, 118, '2014-02-15 00:13:56.000000', 'temperatura', 421.0000, 'ºC'),
	(190013, 118, '2014-02-15 00:13:57.000000', 'temperatura', 983.0000, 'ºC'),
	(190014, 118, '2014-02-15 00:13:58.000000', 'temperatura', 53.0000, 'ºC'),
	(190015, 118, '2014-02-15 00:13:59.000000', 'temperatura', 915.0000, 'ºC'),
	(190016, 118, '2014-02-15 00:14:00.000000', 'temperatura', 818.0000, 'ºC'),
	(190017, 118, '2014-02-15 00:14:01.000000', 'temperatura', 143.0000, 'ºC'),
	(190018, 118, '2014-02-15 00:14:02.000000', 'temperatura', 662.0000, 'ºC'),
	(190019, 118, '2014-02-15 00:14:03.000000', 'temperatura', 481.0000, 'ºC'),
	(190020, 118, '2014-02-15 00:14:04.000000', 'temperatura', 420.0000, 'ºC'),
	(190021, 118, '2014-02-15 00:14:05.000000', 'temperatura', 658.0000, 'ºC'),
	(190022, 118, '2014-02-15 00:14:06.000000', 'temperatura', 831.0000, 'ºC'),
	(190023, 118, '2014-02-15 00:14:07.000000', 'temperatura', 982.0000, 'ºC'),
	(190024, 118, '2014-02-15 00:14:08.000000', 'temperatura', 15.0000, 'ºC'),
	(190025, 118, '2014-02-15 00:14:09.000000', 'temperatura', 731.0000, 'ºC'),
	(190026, 118, '2014-02-15 00:14:10.000000', 'temperatura', 12.0000, 'ºC'),
	(190027, 118, '2014-02-15 00:14:11.000000', 'temperatura', 264.0000, 'ºC'),
	(190028, 118, '2014-02-15 00:14:12.000000', 'temperatura', 87.0000, 'ºC'),
	(190029, 118, '2014-02-15 00:14:13.000000', 'temperatura', 844.0000, 'ºC'),
	(190030, 118, '2014-02-15 00:14:14.000000', 'temperatura', 360.0000, 'ºC'),
	(190031, 118, '2014-02-15 00:14:15.000000', 'temperatura', 466.0000, 'ºC'),
	(190032, 118, '2014-02-15 00:14:16.000000', 'temperatura', 50.0000, 'ºC'),
	(190033, 118, '2014-02-15 00:14:17.000000', 'temperatura', 54.0000, 'ºC'),
	(190034, 118, '2014-02-15 00:14:18.000000', 'temperatura', 121.0000, 'ºC'),
	(190035, 118, '2014-02-15 00:14:19.000000', 'temperatura', 442.0000, 'ºC'),
	(190036, 118, '2014-02-15 00:14:20.000000', 'temperatura', 647.0000, 'ºC'),
	(190037, 118, '2014-02-15 00:14:21.000000', 'temperatura', 710.0000, 'ºC'),
	(190038, 118, '2014-02-15 00:14:22.000000', 'temperatura', 410.0000, 'ºC'),
	(190039, 118, '2014-02-15 00:14:23.000000', 'temperatura', 1120.0000, 'ºC'),
	(190040, 118, '2014-02-15 00:14:24.000000', 'temperatura', 772.0000, 'ºC'),
	(190041, 118, '2014-02-15 00:14:25.000000', 'temperatura', 499.0000, 'ºC'),
	(190042, 118, '2014-02-15 00:14:26.000000', 'temperatura', 179.0000, 'ºC'),
	(190043, 118, '2014-02-15 00:14:27.000000', 'temperatura', 601.0000, 'ºC'),
	(190044, 118, '2014-02-15 00:14:28.000000', 'temperatura', 67.0000, 'ºC'),
	(190045, 118, '2014-02-15 00:14:29.000000', 'temperatura', 931.0000, 'ºC'),
	(190046, 118, '2014-02-15 00:14:30.000000', 'temperatura', 856.0000, 'ºC'),
	(190047, 118, '2014-02-15 00:14:31.000000', 'temperatura', 286.0000, 'ºC'),
	(190048, 118, '2014-02-15 00:14:32.000000', 'temperatura', 65.0000, 'ºC'),
	(190049, 118, '2014-02-15 00:14:33.000000', 'temperatura', 664.0000, 'ºC'),
	(190050, 118, '2014-02-15 00:14:34.000000', 'temperatura', 729.0000, 'ºC'),
	(190051, 118, '2014-02-15 00:14:35.000000', 'temperatura', 450.0000, 'ºC'),
	(190052, 118, '2014-02-15 00:14:36.000000', 'temperatura', 67.0000, 'ºC'),
	(190053, 118, '2014-02-15 00:14:37.000000', 'temperatura', 182.0000, 'ºC'),
	(190054, 118, '2014-02-15 00:14:38.000000', 'temperatura', 712.0000, 'ºC'),
	(190055, 118, '2014-02-15 00:14:39.000000', 'temperatura', 615.0000, 'ºC'),
	(190056, 118, '2014-02-15 00:14:40.000000', 'temperatura', 938.0000, 'ºC'),
	(190057, 118, '2014-02-15 00:14:41.000000', 'temperatura', 447.0000, 'ºC'),
	(190058, 118, '2014-02-15 00:14:42.000000', 'temperatura', 619.0000, 'ºC'),
	(190059, 118, '2014-02-15 00:14:43.000000', 'temperatura', 557.0000, 'ºC'),
	(190060, 118, '2014-02-15 00:14:44.000000', 'temperatura', 927.0000, 'ºC'),
	(190061, 118, '2014-02-15 00:14:45.000000', 'temperatura', 563.0000, 'ºC'),
	(190062, 118, '2014-02-15 00:14:46.000000', 'temperatura', 38.0000, 'ºC'),
	(190063, 118, '2014-02-15 00:14:47.000000', 'temperatura', 898.0000, 'ºC'),
	(190064, 118, '2014-02-15 00:14:48.000000', 'temperatura', 778.0000, 'ºC'),
	(190065, 118, '2014-02-15 00:14:49.000000', 'temperatura', 1195.0000, 'ºC'),
	(190066, 118, '2014-02-15 00:14:50.000000', 'temperatura', 41.0000, 'ºC'),
	(190067, 118, '2014-02-15 00:14:51.000000', 'temperatura', 221.0000, 'ºC'),
	(190068, 118, '2014-02-15 00:14:52.000000', 'temperatura', 981.0000, 'ºC'),
	(190069, 118, '2014-02-15 00:14:53.000000', 'temperatura', 645.0000, 'ºC'),
	(190070, 118, '2014-02-15 00:14:54.000000', 'temperatura', 280.0000, 'ºC'),
	(190071, 118, '2014-02-15 00:14:55.000000', 'temperatura', 669.0000, 'ºC'),
	(190072, 118, '2014-02-15 00:14:56.000000', 'temperatura', 102.0000, 'ºC'),
	(190073, 118, '2014-02-15 00:14:57.000000', 'temperatura', 905.0000, 'ºC'),
	(190074, 118, '2014-02-15 00:14:58.000000', 'temperatura', 620.0000, 'ºC'),
	(190075, 118, '2014-02-15 00:14:59.000000', 'temperatura', 383.0000, 'ºC'),
	(190076, 118, '2014-02-15 00:15:00.000000', 'temperatura', 58.0000, 'ºC'),
	(190077, 118, '2014-02-15 00:15:01.000000', 'temperatura', 343.0000, 'ºC'),
	(190078, 118, '2014-02-15 00:15:02.000000', 'temperatura', 339.0000, 'ºC'),
	(190079, 118, '2014-02-15 00:15:03.000000', 'temperatura', 666.0000, 'ºC'),
	(190080, 118, '2014-02-15 00:15:04.000000', 'temperatura', 1116.0000, 'ºC'),
	(190081, 118, '2014-02-15 00:15:05.000000', 'temperatura', 1179.0000, 'ºC'),
	(190082, 118, '2014-02-15 00:15:06.000000', 'temperatura', 151.0000, 'ºC'),
	(190083, 118, '2014-02-15 00:15:07.000000', 'temperatura', 817.0000, 'ºC'),
	(190084, 118, '2014-02-15 00:15:08.000000', 'temperatura', 34.0000, 'ºC'),
	(190085, 118, '2014-02-15 00:15:09.000000', 'temperatura', 119.0000, 'ºC'),
	(190086, 118, '2014-02-15 00:15:10.000000', 'temperatura', 494.0000, 'ºC'),
	(190087, 118, '2014-02-15 00:15:11.000000', 'temperatura', 913.0000, 'ºC'),
	(190088, 118, '2014-02-15 00:15:12.000000', 'temperatura', 684.0000, 'ºC'),
	(190089, 118, '2014-02-15 00:15:13.000000', 'temperatura', 680.0000, 'ºC'),
	(190090, 118, '2014-02-15 00:15:14.000000', 'temperatura', 148.0000, 'ºC'),
	(190091, 118, '2014-02-15 00:15:15.000000', 'temperatura', 1100.0000, 'ºC'),
	(190092, 118, '2014-02-15 00:15:16.000000', 'temperatura', 257.0000, 'ºC'),
	(190093, 118, '2014-02-15 00:15:17.000000', 'temperatura', 388.0000, 'ºC'),
	(190094, 118, '2014-02-15 00:15:18.000000', 'temperatura', 1166.0000, 'ºC'),
	(190095, 118, '2014-02-15 00:15:19.000000', 'temperatura', 1068.0000, 'ºC'),
	(190096, 118, '2014-02-15 00:15:20.000000', 'temperatura', 642.0000, 'ºC'),
	(190097, 118, '2014-02-15 00:15:21.000000', 'temperatura', 5.0000, 'ºC'),
	(190098, 118, '2014-02-15 00:15:22.000000', 'temperatura', 500.0000, 'ºC'),
	(190099, 118, '2014-02-15 00:15:23.000000', 'temperatura', 84.0000, 'ºC'),
	(190100, 118, '2014-02-15 00:15:24.000000', 'temperatura', 124.0000, 'ºC'),
	(190101, 118, '2014-02-15 00:15:25.000000', 'temperatura', 367.0000, 'ºC'),
	(190102, 118, '2014-02-15 00:15:26.000000', 'temperatura', 263.0000, 'ºC'),
	(190103, 118, '2014-02-15 00:15:27.000000', 'temperatura', 215.0000, 'ºC'),
	(190104, 118, '2014-02-15 00:15:28.000000', 'temperatura', 284.0000, 'ºC'),
	(190105, 118, '2014-02-15 00:15:29.000000', 'temperatura', 779.0000, 'ºC'),
	(190106, 118, '2014-02-15 00:15:30.000000', 'temperatura', 642.0000, 'ºC'),
	(190107, 118, '2014-02-15 00:15:31.000000', 'temperatura', 875.0000, 'ºC'),
	(190108, 118, '2014-02-15 00:15:32.000000', 'temperatura', 48.0000, 'ºC'),
	(190109, 118, '2014-02-15 00:15:33.000000', 'temperatura', 14.0000, 'ºC'),
	(190110, 118, '2014-02-15 00:15:34.000000', 'temperatura', 1129.0000, 'ºC'),
	(190111, 118, '2014-02-15 00:15:35.000000', 'temperatura', 802.0000, 'ºC'),
	(190112, 118, '2014-02-15 00:15:36.000000', 'temperatura', 622.0000, 'ºC'),
	(190113, 118, '2014-02-15 00:15:37.000000', 'temperatura', 708.0000, 'ºC'),
	(190114, 118, '2014-02-15 00:15:38.000000', 'temperatura', 472.0000, 'ºC'),
	(190115, 118, '2014-02-15 00:15:39.000000', 'temperatura', 238.0000, 'ºC'),
	(190116, 118, '2014-02-15 00:15:40.000000', 'temperatura', 976.0000, 'ºC'),
	(190117, 118, '2014-02-15 00:15:41.000000', 'temperatura', 565.0000, 'ºC'),
	(190118, 118, '2014-02-15 00:15:42.000000', 'temperatura', 1098.0000, 'ºC'),
	(190119, 118, '2014-02-15 00:15:43.000000', 'temperatura', 195.0000, 'ºC'),
	(190120, 118, '2014-02-15 00:15:44.000000', 'temperatura', 80.0000, 'ºC'),
	(190121, 118, '2014-02-15 00:15:45.000000', 'temperatura', 1018.0000, 'ºC'),
	(190122, 118, '2014-02-15 00:15:46.000000', 'temperatura', 48.0000, 'ºC'),
	(190123, 118, '2014-02-15 00:15:47.000000', 'temperatura', 787.0000, 'ºC'),
	(190124, 118, '2014-02-15 00:15:48.000000', 'temperatura', 191.0000, 'ºC'),
	(190125, 118, '2014-02-15 00:15:49.000000', 'temperatura', 996.0000, 'ºC'),
	(190126, 118, '2014-02-15 00:15:50.000000', 'temperatura', 805.0000, 'ºC'),
	(190127, 118, '2014-02-15 00:15:51.000000', 'temperatura', 1039.0000, 'ºC'),
	(190128, 118, '2014-02-15 00:15:52.000000', 'temperatura', 382.0000, 'ºC'),
	(190129, 118, '2014-02-15 00:15:53.000000', 'temperatura', 1191.0000, 'ºC'),
	(190130, 118, '2014-02-15 00:15:54.000000', 'temperatura', 11.0000, 'ºC'),
	(190131, 118, '2014-02-15 00:15:55.000000', 'temperatura', 82.0000, 'ºC'),
	(190132, 118, '2014-02-15 00:15:56.000000', 'temperatura', 379.0000, 'ºC'),
	(190133, 118, '2014-02-15 00:15:57.000000', 'temperatura', 450.0000, 'ºC'),
	(190134, 118, '2014-02-15 00:15:58.000000', 'temperatura', 1112.0000, 'ºC'),
	(190135, 118, '2014-02-15 00:15:59.000000', 'temperatura', 612.0000, 'ºC'),
	(190136, 118, '2014-02-15 00:16:00.000000', 'temperatura', 924.0000, 'ºC'),
	(190137, 118, '2014-02-15 00:16:01.000000', 'temperatura', 386.0000, 'ºC'),
	(190138, 118, '2014-02-15 00:16:02.000000', 'temperatura', 356.0000, 'ºC'),
	(190139, 118, '2014-02-15 00:16:03.000000', 'temperatura', 622.0000, 'ºC'),
	(190140, 118, '2014-02-15 00:16:04.000000', 'temperatura', 843.0000, 'ºC'),
	(190141, 118, '2014-02-15 00:16:05.000000', 'temperatura', 1151.0000, 'ºC'),
	(190142, 118, '2014-02-15 00:16:06.000000', 'temperatura', 825.0000, 'ºC'),
	(190143, 118, '2014-02-15 00:16:07.000000', 'temperatura', 672.0000, 'ºC'),
	(190144, 118, '2014-02-15 00:16:08.000000', 'temperatura', 885.0000, 'ºC'),
	(190145, 118, '2014-02-15 00:16:09.000000', 'temperatura', 11.0000, 'ºC'),
	(190146, 118, '2014-02-15 00:16:10.000000', 'temperatura', 1001.0000, 'ºC'),
	(190147, 118, '2014-02-15 00:16:11.000000', 'temperatura', 170.0000, 'ºC'),
	(190148, 118, '2014-02-15 00:16:12.000000', 'temperatura', 250.0000, 'ºC'),
	(190149, 118, '2014-02-15 00:16:13.000000', 'temperatura', 739.0000, 'ºC'),
	(190150, 118, '2014-02-15 00:16:14.000000', 'temperatura', 545.0000, 'ºC'),
	(190151, 118, '2014-02-15 00:16:15.000000', 'temperatura', 511.0000, 'ºC'),
	(190152, 118, '2014-02-15 00:16:16.000000', 'temperatura', 918.0000, 'ºC'),
	(190153, 118, '2014-02-15 00:16:17.000000', 'temperatura', 657.0000, 'ºC'),
	(190154, 118, '2014-02-15 00:16:18.000000', 'temperatura', 534.0000, 'ºC'),
	(190155, 118, '2014-02-15 00:16:19.000000', 'temperatura', 700.0000, 'ºC'),
	(190156, 118, '2014-02-15 00:16:20.000000', 'temperatura', 695.0000, 'ºC'),
	(190157, 118, '2014-02-15 00:16:21.000000', 'temperatura', 179.0000, 'ºC'),
	(190158, 118, '2014-02-15 00:16:22.000000', 'temperatura', 9.0000, 'ºC'),
	(190159, 118, '2014-02-15 00:16:23.000000', 'temperatura', 709.0000, 'ºC'),
	(190160, 118, '2014-02-15 00:16:24.000000', 'temperatura', 1117.0000, 'ºC'),
	(190161, 118, '2014-02-15 00:16:25.000000', 'temperatura', 1061.0000, 'ºC'),
	(190162, 118, '2014-02-15 00:16:26.000000', 'temperatura', 754.0000, 'ºC'),
	(190163, 118, '2014-02-15 00:16:27.000000', 'temperatura', 586.0000, 'ºC'),
	(190164, 118, '2014-02-15 00:16:28.000000', 'temperatura', 670.0000, 'ºC'),
	(190165, 118, '2014-02-15 00:16:29.000000', 'temperatura', 393.0000, 'ºC'),
	(190166, 118, '2014-02-15 00:16:30.000000', 'temperatura', 1153.0000, 'ºC'),
	(190167, 118, '2014-02-15 00:16:31.000000', 'temperatura', 990.0000, 'ºC'),
	(190168, 118, '2014-02-15 00:16:32.000000', 'temperatura', 288.0000, 'ºC'),
	(190169, 118, '2014-02-15 00:16:33.000000', 'temperatura', 871.0000, 'ºC'),
	(190170, 118, '2014-02-15 00:16:34.000000', 'temperatura', 1094.0000, 'ºC'),
	(190171, 118, '2014-02-15 00:16:35.000000', 'temperatura', 457.0000, 'ºC'),
	(190172, 118, '2014-02-15 00:16:36.000000', 'temperatura', 201.0000, 'ºC'),
	(190173, 118, '2014-02-15 00:16:37.000000', 'temperatura', 837.0000, 'ºC'),
	(190174, 118, '2014-02-15 00:16:38.000000', 'temperatura', 1182.0000, 'ºC'),
	(190175, 118, '2014-02-15 00:16:39.000000', 'temperatura', 999.0000, 'ºC'),
	(190176, 118, '2014-02-15 00:16:40.000000', 'temperatura', 249.0000, 'ºC'),
	(190177, 118, '2014-02-15 00:16:41.000000', 'temperatura', 647.0000, 'ºC'),
	(190178, 118, '2014-02-15 00:16:42.000000', 'temperatura', 92.0000, 'ºC'),
	(190179, 118, '2014-02-15 00:16:43.000000', 'temperatura', 917.0000, 'ºC'),
	(190180, 118, '2014-02-15 00:16:44.000000', 'temperatura', 709.0000, 'ºC'),
	(190181, 118, '2014-02-15 00:16:45.000000', 'temperatura', 796.0000, 'ºC'),
	(190182, 118, '2014-02-15 00:16:46.000000', 'temperatura', 651.0000, 'ºC'),
	(190183, 118, '2014-02-15 00:16:47.000000', 'temperatura', 869.0000, 'ºC'),
	(190184, 118, '2014-02-15 00:16:48.000000', 'temperatura', 1191.0000, 'ºC'),
	(190185, 118, '2014-02-15 00:16:49.000000', 'temperatura', 949.0000, 'ºC'),
	(190186, 118, '2014-02-15 00:16:50.000000', 'temperatura', 1172.0000, 'ºC'),
	(190187, 118, '2014-02-15 00:16:51.000000', 'temperatura', 613.0000, 'ºC'),
	(190188, 118, '2014-02-15 00:16:52.000000', 'temperatura', 751.0000, 'ºC'),
	(190189, 118, '2014-02-15 00:16:53.000000', 'temperatura', 715.0000, 'ºC'),
	(190190, 118, '2014-02-15 00:16:54.000000', 'temperatura', 122.0000, 'ºC'),
	(190191, 118, '2014-02-15 00:16:55.000000', 'temperatura', 865.0000, 'ºC'),
	(190192, 118, '2014-02-15 00:16:56.000000', 'temperatura', 361.0000, 'ºC'),
	(190193, 118, '2014-02-15 00:16:57.000000', 'temperatura', 412.0000, 'ºC'),
	(190194, 118, '2014-02-15 00:16:58.000000', 'temperatura', 976.0000, 'ºC'),
	(190195, 118, '2014-02-15 00:16:59.000000', 'temperatura', 46.0000, 'ºC'),
	(190196, 118, '2014-02-15 00:17:00.000000', 'temperatura', 900.0000, 'ºC'),
	(190197, 118, '2014-02-15 00:17:01.000000', 'temperatura', 764.0000, 'ºC'),
	(190198, 118, '2014-02-15 00:17:02.000000', 'temperatura', 1120.0000, 'ºC'),
	(190199, 118, '2014-02-15 00:17:03.000000', 'temperatura', 909.0000, 'ºC'),
	(190200, 118, '2014-02-15 00:17:04.000000', 'temperatura', 1185.0000, 'ºC'),
	(190201, 118, '2014-02-15 00:17:05.000000', 'temperatura', 797.0000, 'ºC'),
	(190202, 118, '2014-02-15 00:17:06.000000', 'temperatura', 432.0000, 'ºC'),
	(190203, 118, '2014-02-15 00:17:07.000000', 'temperatura', 971.0000, 'ºC'),
	(190204, 118, '2014-02-15 00:17:08.000000', 'temperatura', 1160.0000, 'ºC'),
	(190205, 118, '2014-02-15 00:17:09.000000', 'temperatura', 487.0000, 'ºC'),
	(190206, 118, '2014-02-15 00:17:10.000000', 'temperatura', 154.0000, 'ºC'),
	(190207, 118, '2014-02-15 00:17:11.000000', 'temperatura', 509.0000, 'ºC'),
	(190208, 118, '2014-02-15 00:17:12.000000', 'temperatura', 884.0000, 'ºC'),
	(190209, 118, '2014-02-15 00:17:13.000000', 'temperatura', 493.0000, 'ºC'),
	(190210, 118, '2014-02-15 00:17:14.000000', 'temperatura', 1012.0000, 'ºC'),
	(190211, 118, '2014-02-15 00:17:15.000000', 'temperatura', 1184.0000, 'ºC'),
	(190212, 118, '2014-02-15 00:17:16.000000', 'temperatura', 483.0000, 'ºC'),
	(190213, 118, '2014-02-15 00:17:17.000000', 'temperatura', 65.0000, 'ºC'),
	(190214, 118, '2014-02-15 00:17:18.000000', 'temperatura', 77.0000, 'ºC'),
	(190215, 118, '2014-02-15 00:17:19.000000', 'temperatura', 189.0000, 'ºC'),
	(190216, 118, '2014-02-15 00:17:20.000000', 'temperatura', 714.0000, 'ºC'),
	(190217, 118, '2014-02-15 00:17:21.000000', 'temperatura', 603.0000, 'ºC'),
	(190218, 118, '2014-02-15 00:17:22.000000', 'temperatura', 874.0000, 'ºC'),
	(190219, 118, '2014-02-15 00:17:23.000000', 'temperatura', 163.0000, 'ºC'),
	(190220, 118, '2014-02-15 00:17:24.000000', 'temperatura', 592.0000, 'ºC'),
	(190221, 118, '2014-02-15 00:17:25.000000', 'temperatura', 72.0000, 'ºC'),
	(190222, 118, '2014-02-15 00:17:26.000000', 'temperatura', 982.0000, 'ºC'),
	(190223, 118, '2014-02-15 00:17:27.000000', 'temperatura', 1098.0000, 'ºC'),
	(190224, 118, '2014-02-15 00:17:28.000000', 'temperatura', 143.0000, 'ºC'),
	(190225, 118, '2014-02-15 00:17:29.000000', 'temperatura', 1022.0000, 'ºC'),
	(190226, 118, '2014-02-15 00:17:30.000000', 'temperatura', 1080.0000, 'ºC'),
	(190227, 118, '2014-02-15 00:17:31.000000', 'temperatura', 1134.0000, 'ºC'),
	(190228, 118, '2014-02-15 00:17:32.000000', 'temperatura', 31.0000, 'ºC'),
	(190229, 118, '2014-02-15 00:17:33.000000', 'temperatura', 353.0000, 'ºC'),
	(190230, 118, '2014-02-15 00:17:34.000000', 'temperatura', 473.0000, 'ºC'),
	(190231, 118, '2014-02-15 00:17:35.000000', 'temperatura', 106.0000, 'ºC'),
	(190232, 118, '2014-02-15 00:17:36.000000', 'temperatura', 312.0000, 'ºC'),
	(190233, 118, '2014-02-15 00:17:37.000000', 'temperatura', 43.0000, 'ºC'),
	(190234, 118, '2014-02-15 00:17:38.000000', 'temperatura', 480.0000, 'ºC'),
	(190235, 118, '2014-02-15 00:17:39.000000', 'temperatura', 1073.0000, 'ºC'),
	(190236, 118, '2014-02-15 00:17:40.000000', 'temperatura', 324.0000, 'ºC'),
	(190237, 118, '2014-02-15 00:17:41.000000', 'temperatura', 800.0000, 'ºC'),
	(190238, 118, '2014-02-15 00:17:42.000000', 'temperatura', 631.0000, 'ºC'),
	(190239, 118, '2014-02-15 00:17:43.000000', 'temperatura', 754.0000, 'ºC'),
	(190240, 118, '2014-02-15 00:17:44.000000', 'temperatura', 680.0000, 'ºC'),
	(190241, 118, '2014-02-15 00:17:45.000000', 'temperatura', 1137.0000, 'ºC'),
	(190242, 118, '2014-02-15 00:17:46.000000', 'temperatura', 44.0000, 'ºC'),
	(190243, 118, '2014-02-15 00:17:47.000000', 'temperatura', 409.0000, 'ºC'),
	(190244, 118, '2014-02-15 00:17:48.000000', 'temperatura', 716.0000, 'ºC'),
	(190245, 118, '2014-02-15 00:17:49.000000', 'temperatura', 1154.0000, 'ºC'),
	(190246, 118, '2014-02-15 00:17:50.000000', 'temperatura', 21.0000, 'ºC'),
	(190247, 118, '2014-02-15 00:17:51.000000', 'temperatura', 242.0000, 'ºC'),
	(190248, 118, '2014-02-15 00:17:52.000000', 'temperatura', 1148.0000, 'ºC'),
	(190249, 118, '2014-02-15 00:17:53.000000', 'temperatura', 213.0000, 'ºC'),
	(190250, 118, '2014-02-15 00:17:54.000000', 'temperatura', 25.0000, 'ºC'),
	(190251, 118, '2014-02-15 00:17:55.000000', 'temperatura', 684.0000, 'ºC'),
	(190252, 118, '2014-02-15 00:17:56.000000', 'temperatura', 944.0000, 'ºC'),
	(190253, 118, '2014-02-15 00:17:57.000000', 'temperatura', 272.0000, 'ºC'),
	(190254, 118, '2014-02-15 00:17:58.000000', 'temperatura', 925.0000, 'ºC'),
	(190255, 118, '2014-02-15 00:17:59.000000', 'temperatura', 213.0000, 'ºC'),
	(190256, 118, '2014-02-15 00:18:00.000000', 'temperatura', 689.0000, 'ºC'),
	(190257, 118, '2014-02-15 00:18:01.000000', 'temperatura', 405.0000, 'ºC'),
	(190258, 118, '2014-02-15 00:18:02.000000', 'temperatura', 1158.0000, 'ºC'),
	(190259, 118, '2014-02-15 00:18:03.000000', 'temperatura', 976.0000, 'ºC'),
	(190260, 118, '2014-02-15 00:18:04.000000', 'temperatura', 208.0000, 'ºC'),
	(190261, 118, '2014-02-15 00:18:05.000000', 'temperatura', 513.0000, 'ºC'),
	(190262, 118, '2014-02-15 00:18:06.000000', 'temperatura', 740.0000, 'ºC'),
	(190263, 118, '2014-02-15 00:18:07.000000', 'temperatura', 963.0000, 'ºC'),
	(190264, 118, '2014-02-15 00:18:08.000000', 'temperatura', 193.0000, 'ºC'),
	(190265, 118, '2014-02-15 00:18:09.000000', 'temperatura', 480.0000, 'ºC'),
	(190266, 118, '2014-02-15 00:18:10.000000', 'temperatura', 619.0000, 'ºC'),
	(190267, 118, '2014-02-15 00:18:11.000000', 'temperatura', 457.0000, 'ºC'),
	(190268, 118, '2014-02-15 00:18:12.000000', 'temperatura', 428.0000, 'ºC'),
	(190269, 118, '2014-02-15 00:18:13.000000', 'temperatura', 768.0000, 'ºC'),
	(190270, 118, '2014-02-15 00:18:14.000000', 'temperatura', 159.0000, 'ºC'),
	(190271, 118, '2014-02-15 00:18:15.000000', 'temperatura', 889.0000, 'ºC'),
	(190272, 118, '2014-02-15 00:18:16.000000', 'temperatura', 367.0000, 'ºC'),
	(190273, 118, '2014-02-15 00:18:17.000000', 'temperatura', 372.0000, 'ºC'),
	(190274, 118, '2014-02-15 00:18:18.000000', 'temperatura', 759.0000, 'ºC'),
	(190275, 118, '2014-02-15 00:18:19.000000', 'temperatura', 277.0000, 'ºC'),
	(190276, 118, '2014-02-15 00:18:20.000000', 'temperatura', 309.0000, 'ºC'),
	(190277, 118, '2014-02-15 00:18:21.000000', 'temperatura', 716.0000, 'ºC'),
	(190278, 118, '2014-02-15 00:18:22.000000', 'temperatura', 254.0000, 'ºC'),
	(190279, 118, '2014-02-15 00:18:23.000000', 'temperatura', 322.0000, 'ºC'),
	(190280, 118, '2014-02-15 00:18:24.000000', 'temperatura', 849.0000, 'ºC'),
	(190281, 118, '2014-02-15 00:18:25.000000', 'temperatura', 878.0000, 'ºC'),
	(190282, 118, '2014-02-15 00:18:26.000000', 'temperatura', 642.0000, 'ºC'),
	(190283, 118, '2014-02-15 00:18:27.000000', 'temperatura', 579.0000, 'ºC'),
	(190284, 118, '2014-02-15 00:18:28.000000', 'temperatura', 970.0000, 'ºC'),
	(190285, 118, '2014-02-15 00:18:29.000000', 'temperatura', 713.0000, 'ºC'),
	(190286, 118, '2014-02-15 00:18:30.000000', 'temperatura', 657.0000, 'ºC'),
	(190287, 118, '2014-02-15 00:18:31.000000', 'temperatura', 1144.0000, 'ºC'),
	(190288, 118, '2014-02-15 00:18:32.000000', 'temperatura', 150.0000, 'ºC'),
	(190289, 118, '2014-02-15 00:18:33.000000', 'temperatura', 917.0000, 'ºC'),
	(190290, 118, '2014-02-15 00:18:34.000000', 'temperatura', 536.0000, 'ºC'),
	(190291, 118, '2014-02-15 00:18:35.000000', 'temperatura', 1129.0000, 'ºC'),
	(190292, 118, '2014-02-15 00:18:36.000000', 'temperatura', 438.0000, 'ºC'),
	(190293, 118, '2014-02-15 00:18:37.000000', 'temperatura', 3.0000, 'ºC'),
	(190294, 118, '2014-02-15 00:18:38.000000', 'temperatura', 1103.0000, 'ºC'),
	(190295, 118, '2014-02-15 00:18:39.000000', 'temperatura', 704.0000, 'ºC'),
	(190296, 118, '2014-02-15 00:18:40.000000', 'temperatura', 213.0000, 'ºC'),
	(190297, 118, '2014-02-15 00:18:41.000000', 'temperatura', 152.0000, 'ºC'),
	(190298, 118, '2014-02-15 00:18:42.000000', 'temperatura', 124.0000, 'ºC'),
	(190299, 118, '2014-02-15 00:18:43.000000', 'temperatura', 163.0000, 'ºC'),
	(190300, 118, '2014-02-15 00:18:44.000000', 'temperatura', 443.0000, 'ºC'),
	(190301, 118, '2014-02-15 00:18:45.000000', 'temperatura', 528.0000, 'ºC'),
	(190302, 118, '2014-02-15 00:18:46.000000', 'temperatura', 111.0000, 'ºC'),
	(190303, 118, '2014-02-15 00:18:47.000000', 'temperatura', 169.0000, 'ºC'),
	(190304, 118, '2014-02-15 00:18:48.000000', 'temperatura', 516.0000, 'ºC'),
	(190305, 118, '2014-02-15 00:18:49.000000', 'temperatura', 873.0000, 'ºC'),
	(190306, 118, '2014-02-15 00:18:50.000000', 'temperatura', 419.0000, 'ºC'),
	(190307, 118, '2014-02-15 00:18:51.000000', 'temperatura', 673.0000, 'ºC'),
	(190308, 118, '2014-02-15 00:18:52.000000', 'temperatura', 911.0000, 'ºC'),
	(190309, 118, '2014-02-15 00:18:53.000000', 'temperatura', 137.0000, 'ºC'),
	(190310, 118, '2014-02-15 00:18:54.000000', 'temperatura', 352.0000, 'ºC'),
	(190311, 118, '2014-02-15 00:18:55.000000', 'temperatura', 151.0000, 'ºC'),
	(190312, 118, '2014-02-15 00:18:56.000000', 'temperatura', 896.0000, 'ºC'),
	(190313, 118, '2014-02-15 00:18:57.000000', 'temperatura', 431.0000, 'ºC'),
	(190314, 118, '2014-02-15 00:18:58.000000', 'temperatura', 666.0000, 'ºC'),
	(190315, 118, '2014-02-15 00:18:59.000000', 'temperatura', 838.0000, 'ºC'),
	(190316, 118, '2014-02-15 00:19:00.000000', 'temperatura', 994.0000, 'ºC'),
	(190317, 118, '2014-02-15 00:19:01.000000', 'temperatura', 56.0000, 'ºC'),
	(190318, 118, '2014-02-15 00:19:02.000000', 'temperatura', 900.0000, 'ºC'),
	(190319, 118, '2014-02-15 00:19:03.000000', 'temperatura', 731.0000, 'ºC'),
	(190320, 118, '2014-02-15 00:19:04.000000', 'temperatura', 954.0000, 'ºC'),
	(190321, 118, '2014-02-15 00:19:05.000000', 'temperatura', 177.0000, 'ºC'),
	(190322, 118, '2014-02-15 00:19:06.000000', 'temperatura', 427.0000, 'ºC'),
	(190323, 118, '2014-02-15 00:19:07.000000', 'temperatura', 401.0000, 'ºC'),
	(190324, 118, '2014-02-15 00:19:08.000000', 'temperatura', 725.0000, 'ºC'),
	(190325, 118, '2014-02-15 00:19:09.000000', 'temperatura', 23.0000, 'ºC'),
	(190326, 118, '2014-02-15 00:19:10.000000', 'temperatura', 338.0000, 'ºC'),
	(190327, 118, '2014-02-15 00:19:11.000000', 'temperatura', 425.0000, 'ºC'),
	(190328, 118, '2014-02-15 00:19:12.000000', 'temperatura', 1111.0000, 'ºC'),
	(190329, 118, '2014-02-15 00:19:13.000000', 'temperatura', 682.0000, 'ºC'),
	(190330, 118, '2014-02-15 00:19:14.000000', 'temperatura', 76.0000, 'ºC'),
	(190331, 118, '2014-02-15 00:19:15.000000', 'temperatura', 732.0000, 'ºC'),
	(190332, 118, '2014-02-15 00:19:16.000000', 'temperatura', 1036.0000, 'ºC'),
	(190333, 118, '2014-02-15 00:19:17.000000', 'temperatura', 584.0000, 'ºC'),
	(190334, 118, '2014-02-15 00:19:18.000000', 'temperatura', 1013.0000, 'ºC'),
	(190335, 118, '2014-02-15 00:19:19.000000', 'temperatura', 912.0000, 'ºC'),
	(190336, 118, '2014-02-15 00:19:20.000000', 'temperatura', 321.0000, 'ºC'),
	(190337, 118, '2014-02-15 00:19:21.000000', 'temperatura', 72.0000, 'ºC'),
	(190338, 118, '2014-02-15 00:19:22.000000', 'temperatura', 595.0000, 'ºC'),
	(190339, 118, '2014-02-15 00:19:23.000000', 'temperatura', 361.0000, 'ºC'),
	(190340, 118, '2014-02-15 00:19:24.000000', 'temperatura', 18.0000, 'ºC'),
	(190341, 118, '2014-02-15 00:19:25.000000', 'temperatura', 211.0000, 'ºC'),
	(190342, 118, '2014-02-15 00:19:26.000000', 'temperatura', 1000.0000, 'ºC'),
	(190343, 118, '2014-02-15 00:19:27.000000', 'temperatura', 767.0000, 'ºC'),
	(190344, 118, '2014-02-15 00:19:28.000000', 'temperatura', 837.0000, 'ºC'),
	(190345, 118, '2014-02-15 00:19:29.000000', 'temperatura', 684.0000, 'ºC'),
	(190346, 118, '2014-02-15 00:19:30.000000', 'temperatura', 911.0000, 'ºC'),
	(190347, 118, '2014-02-15 00:19:31.000000', 'temperatura', 104.0000, 'ºC'),
	(190348, 118, '2014-02-15 00:19:32.000000', 'temperatura', 187.0000, 'ºC'),
	(190349, 118, '2014-02-15 00:19:33.000000', 'temperatura', 623.0000, 'ºC'),
	(190350, 118, '2014-02-15 00:19:34.000000', 'temperatura', 155.0000, 'ºC'),
	(190351, 118, '2014-02-15 00:19:35.000000', 'temperatura', 107.0000, 'ºC'),
	(190352, 118, '2014-02-15 00:19:36.000000', 'temperatura', 71.0000, 'ºC'),
	(190353, 118, '2014-02-15 00:19:37.000000', 'temperatura', 35.0000, 'ºC'),
	(190354, 118, '2014-02-15 00:19:38.000000', 'temperatura', 1160.0000, 'ºC'),
	(190355, 118, '2014-02-15 00:19:39.000000', 'temperatura', 898.0000, 'ºC'),
	(190356, 118, '2014-02-15 00:19:40.000000', 'temperatura', 1010.0000, 'ºC'),
	(190357, 118, '2014-02-15 00:19:41.000000', 'temperatura', 1154.0000, 'ºC'),
	(190358, 118, '2014-02-15 00:19:42.000000', 'temperatura', 343.0000, 'ºC'),
	(190359, 118, '2014-02-15 00:19:43.000000', 'temperatura', 651.0000, 'ºC'),
	(190360, 118, '2014-02-15 00:19:44.000000', 'temperatura', 1027.0000, 'ºC'),
	(190361, 118, '2014-02-15 00:19:45.000000', 'temperatura', 783.0000, 'ºC'),
	(190362, 118, '2014-02-15 00:19:46.000000', 'temperatura', 834.0000, 'ºC'),
	(190363, 118, '2014-02-15 00:19:47.000000', 'temperatura', 621.0000, 'ºC'),
	(190364, 118, '2014-02-15 00:19:48.000000', 'temperatura', 603.0000, 'ºC'),
	(190365, 118, '2014-02-15 00:19:49.000000', 'temperatura', 1152.0000, 'ºC'),
	(190366, 118, '2014-02-15 00:19:50.000000', 'temperatura', 352.0000, 'ºC'),
	(190367, 118, '2014-02-15 00:19:51.000000', 'temperatura', 705.0000, 'ºC'),
	(190368, 118, '2014-02-15 00:19:52.000000', 'temperatura', 68.0000, 'ºC'),
	(190369, 118, '2014-02-15 00:19:53.000000', 'temperatura', 626.0000, 'ºC'),
	(190370, 118, '2014-02-15 00:19:54.000000', 'temperatura', 526.0000, 'ºC'),
	(190371, 118, '2014-02-15 00:19:55.000000', 'temperatura', 753.0000, 'ºC'),
	(190372, 118, '2014-02-15 00:19:56.000000', 'temperatura', 988.0000, 'ºC'),
	(190373, 118, '2014-02-15 00:19:57.000000', 'temperatura', 280.0000, 'ºC'),
	(190374, 118, '2014-02-15 00:19:58.000000', 'temperatura', 838.0000, 'ºC'),
	(190375, 118, '2014-02-15 00:19:59.000000', 'temperatura', 950.0000, 'ºC'),
	(190376, 118, '2014-02-15 00:20:00.000000', 'temperatura', 1035.0000, 'ºC'),
	(190377, 118, '2014-02-15 00:20:01.000000', 'temperatura', 1125.0000, 'ºC'),
	(190378, 118, '2014-02-15 00:20:02.000000', 'temperatura', 122.0000, 'ºC'),
	(190379, 118, '2014-02-15 00:20:03.000000', 'temperatura', 837.0000, 'ºC'),
	(190380, 118, '2014-02-15 00:20:04.000000', 'temperatura', 219.0000, 'ºC'),
	(190381, 118, '2014-02-15 00:20:05.000000', 'temperatura', 985.0000, 'ºC'),
	(190382, 118, '2014-02-15 00:20:06.000000', 'temperatura', 668.0000, 'ºC'),
	(190383, 118, '2014-02-15 00:20:07.000000', 'temperatura', 384.0000, 'ºC'),
	(190384, 118, '2014-02-15 00:20:08.000000', 'temperatura', 1116.0000, 'ºC'),
	(190385, 118, '2014-02-15 00:20:09.000000', 'temperatura', 828.0000, 'ºC'),
	(190386, 118, '2014-02-15 00:20:10.000000', 'temperatura', 792.0000, 'ºC'),
	(190387, 118, '2014-02-15 00:20:11.000000', 'temperatura', 277.0000, 'ºC'),
	(190388, 118, '2014-02-15 00:20:12.000000', 'temperatura', 209.0000, 'ºC'),
	(190389, 118, '2014-02-15 00:20:13.000000', 'temperatura', 214.0000, 'ºC'),
	(190390, 118, '2014-02-15 00:20:14.000000', 'temperatura', 444.0000, 'ºC'),
	(190391, 118, '2014-02-15 00:20:15.000000', 'temperatura', 380.0000, 'ºC'),
	(190392, 118, '2014-02-15 00:20:16.000000', 'temperatura', 569.0000, 'ºC'),
	(190393, 118, '2014-02-15 00:20:17.000000', 'temperatura', 506.0000, 'ºC'),
	(190394, 118, '2014-02-15 00:20:18.000000', 'temperatura', 824.0000, 'ºC'),
	(190395, 118, '2014-02-15 00:20:19.000000', 'temperatura', 201.0000, 'ºC'),
	(190396, 118, '2014-02-15 00:20:20.000000', 'temperatura', 936.0000, 'ºC'),
	(190397, 118, '2014-02-15 00:20:21.000000', 'temperatura', 475.0000, 'ºC'),
	(190398, 118, '2014-02-15 00:20:22.000000', 'temperatura', 769.0000, 'ºC'),
	(190399, 118, '2014-02-15 00:20:23.000000', 'temperatura', 19.0000, 'ºC'),
	(190400, 118, '2014-02-15 00:20:24.000000', 'temperatura', 189.0000, 'ºC'),
	(190401, 118, '2014-02-15 00:20:25.000000', 'temperatura', 889.0000, 'ºC'),
	(190402, 118, '2014-02-15 00:20:26.000000', 'temperatura', 277.0000, 'ºC'),
	(190403, 118, '2014-02-15 00:20:27.000000', 'temperatura', 1117.0000, 'ºC'),
	(190404, 118, '2014-02-15 00:20:28.000000', 'temperatura', 1158.0000, 'ºC'),
	(190405, 118, '2014-02-15 00:20:29.000000', 'temperatura', 38.0000, 'ºC'),
	(190406, 118, '2014-02-15 00:20:30.000000', 'temperatura', 315.0000, 'ºC'),
	(190407, 118, '2014-02-15 00:20:31.000000', 'temperatura', 263.0000, 'ºC'),
	(190408, 118, '2014-02-15 00:20:32.000000', 'temperatura', 372.0000, 'ºC'),
	(190409, 118, '2014-02-15 00:20:33.000000', 'temperatura', 1072.0000, 'ºC'),
	(190410, 118, '2014-02-15 00:20:34.000000', 'temperatura', 642.0000, 'ºC'),
	(190411, 118, '2014-02-15 00:20:35.000000', 'temperatura', 1194.0000, 'ºC'),
	(190412, 118, '2014-02-15 00:20:36.000000', 'temperatura', 447.0000, 'ºC'),
	(190413, 118, '2014-02-15 00:20:37.000000', 'temperatura', 1050.0000, 'ºC'),
	(190414, 118, '2014-02-15 00:20:38.000000', 'temperatura', 313.0000, 'ºC'),
	(190415, 118, '2014-02-15 00:20:39.000000', 'temperatura', 814.0000, 'ºC'),
	(190416, 118, '2014-02-15 00:20:40.000000', 'temperatura', 731.0000, 'ºC'),
	(190417, 118, '2014-02-15 00:20:41.000000', 'temperatura', 12.0000, 'ºC'),
	(190418, 118, '2014-02-15 00:20:42.000000', 'temperatura', 268.0000, 'ºC'),
	(190419, 118, '2014-02-15 00:20:43.000000', 'temperatura', 107.0000, 'ºC'),
	(190420, 118, '2014-02-15 00:20:44.000000', 'temperatura', 930.0000, 'ºC'),
	(190421, 118, '2014-02-15 00:20:45.000000', 'temperatura', 730.0000, 'ºC'),
	(190422, 118, '2014-02-15 00:20:46.000000', 'temperatura', 859.0000, 'ºC'),
	(190423, 118, '2014-02-15 00:20:47.000000', 'temperatura', 907.0000, 'ºC'),
	(190424, 118, '2014-02-15 00:20:48.000000', 'temperatura', 759.0000, 'ºC'),
	(190425, 118, '2014-02-15 00:20:49.000000', 'temperatura', 1075.0000, 'ºC'),
	(190426, 118, '2014-02-15 00:20:50.000000', 'temperatura', 697.0000, 'ºC'),
	(190427, 118, '2014-02-15 00:20:51.000000', 'temperatura', 263.0000, 'ºC'),
	(190428, 118, '2014-02-15 00:20:52.000000', 'temperatura', 422.0000, 'ºC'),
	(190429, 118, '2014-02-15 00:20:53.000000', 'temperatura', 124.0000, 'ºC'),
	(190430, 118, '2014-02-15 00:20:54.000000', 'temperatura', 553.0000, 'ºC'),
	(190431, 118, '2014-02-15 00:20:55.000000', 'temperatura', 1195.0000, 'ºC'),
	(190432, 118, '2014-02-15 00:20:56.000000', 'temperatura', 717.0000, 'ºC'),
	(190433, 118, '2014-02-15 00:20:57.000000', 'temperatura', 1198.0000, 'ºC'),
	(190434, 118, '2014-02-15 00:20:58.000000', 'temperatura', 240.0000, 'ºC'),
	(190435, 118, '2014-02-15 00:20:59.000000', 'temperatura', 5.0000, 'ºC'),
	(190436, 118, '2014-02-15 00:21:00.000000', 'temperatura', 508.0000, 'ºC'),
	(190437, 118, '2014-02-15 00:21:01.000000', 'temperatura', 125.0000, 'ºC'),
	(190438, 118, '2014-02-15 00:21:02.000000', 'temperatura', 303.0000, 'ºC'),
	(190439, 118, '2014-02-15 00:21:03.000000', 'temperatura', 1138.0000, 'ºC'),
	(190440, 118, '2014-02-15 00:21:04.000000', 'temperatura', 1183.0000, 'ºC'),
	(190441, 118, '2014-02-15 00:21:05.000000', 'temperatura', 99.0000, 'ºC'),
	(190442, 118, '2014-02-15 00:21:06.000000', 'temperatura', 550.0000, 'ºC'),
	(190443, 118, '2014-02-15 00:21:07.000000', 'temperatura', 52.0000, 'ºC'),
	(190444, 118, '2014-02-15 00:21:08.000000', 'temperatura', 1008.0000, 'ºC'),
	(190445, 118, '2014-02-15 00:21:09.000000', 'temperatura', 88.0000, 'ºC'),
	(190446, 118, '2014-02-15 00:21:10.000000', 'temperatura', 1016.0000, 'ºC'),
	(190447, 118, '2014-02-15 00:21:11.000000', 'temperatura', 14.0000, 'ºC'),
	(190448, 118, '2014-02-15 00:21:12.000000', 'temperatura', 625.0000, 'ºC'),
	(190449, 118, '2014-02-15 00:21:13.000000', 'temperatura', 684.0000, 'ºC'),
	(190450, 118, '2014-02-15 00:21:14.000000', 'temperatura', 344.0000, 'ºC'),
	(190451, 118, '2014-02-15 00:21:15.000000', 'temperatura', 871.0000, 'ºC'),
	(190452, 118, '2014-02-15 00:21:16.000000', 'temperatura', 921.0000, 'ºC'),
	(190453, 118, '2014-02-15 00:21:17.000000', 'temperatura', 793.0000, 'ºC'),
	(190454, 118, '2014-02-15 00:21:18.000000', 'temperatura', 3.0000, 'ºC'),
	(190455, 118, '2014-02-15 00:21:19.000000', 'temperatura', 38.0000, 'ºC'),
	(190456, 118, '2014-02-15 00:21:20.000000', 'temperatura', 181.0000, 'ºC'),
	(190457, 118, '2014-02-15 00:21:21.000000', 'temperatura', 789.0000, 'ºC'),
	(190458, 118, '2014-02-15 00:21:22.000000', 'temperatura', 1004.0000, 'ºC'),
	(190459, 118, '2014-02-15 00:21:23.000000', 'temperatura', 254.0000, 'ºC'),
	(190460, 118, '2014-02-15 00:21:24.000000', 'temperatura', 656.0000, 'ºC'),
	(190461, 118, '2014-02-15 00:21:25.000000', 'temperatura', 122.0000, 'ºC'),
	(190462, 118, '2014-02-15 00:21:26.000000', 'temperatura', 1039.0000, 'ºC'),
	(190463, 118, '2014-02-15 00:21:27.000000', 'temperatura', 32.0000, 'ºC'),
	(190464, 118, '2014-02-15 00:21:28.000000', 'temperatura', 642.0000, 'ºC'),
	(190465, 118, '2014-02-15 00:21:29.000000', 'temperatura', 713.0000, 'ºC'),
	(190466, 118, '2014-02-15 00:21:30.000000', 'temperatura', 441.0000, 'ºC'),
	(190467, 118, '2014-02-15 00:21:31.000000', 'temperatura', 67.0000, 'ºC'),
	(190468, 118, '2014-02-15 00:21:32.000000', 'temperatura', 212.0000, 'ºC'),
	(190469, 118, '2014-02-15 00:21:33.000000', 'temperatura', 861.0000, 'ºC'),
	(190470, 118, '2014-02-15 00:21:34.000000', 'temperatura', 68.0000, 'ºC'),
	(190471, 118, '2014-02-15 00:21:35.000000', 'temperatura', 157.0000, 'ºC'),
	(190472, 118, '2014-02-15 00:21:36.000000', 'temperatura', 582.0000, 'ºC'),
	(190473, 118, '2014-02-15 00:21:37.000000', 'temperatura', 39.0000, 'ºC'),
	(190474, 118, '2014-02-15 00:21:38.000000', 'temperatura', 849.0000, 'ºC'),
	(190475, 118, '2014-02-15 00:21:39.000000', 'temperatura', 531.0000, 'ºC'),
	(190476, 118, '2014-02-15 00:21:40.000000', 'temperatura', 107.0000, 'ºC'),
	(190477, 118, '2014-02-15 00:21:41.000000', 'temperatura', 144.0000, 'ºC'),
	(190478, 118, '2014-02-15 00:21:42.000000', 'temperatura', 397.0000, 'ºC'),
	(190479, 118, '2014-02-15 00:21:43.000000', 'temperatura', 355.0000, 'ºC'),
	(190480, 118, '2014-02-15 00:21:44.000000', 'temperatura', 585.0000, 'ºC'),
	(190481, 118, '2014-02-15 00:21:45.000000', 'temperatura', 661.0000, 'ºC'),
	(190482, 118, '2014-02-15 00:21:46.000000', 'temperatura', 350.0000, 'ºC'),
	(190483, 118, '2014-02-15 00:21:47.000000', 'temperatura', 966.0000, 'ºC'),
	(190484, 118, '2014-02-15 00:21:48.000000', 'temperatura', 183.0000, 'ºC'),
	(190485, 118, '2014-02-15 00:21:49.000000', 'temperatura', 415.0000, 'ºC'),
	(190486, 118, '2014-02-15 00:21:50.000000', 'temperatura', 326.0000, 'ºC'),
	(190487, 118, '2014-02-15 00:21:51.000000', 'temperatura', 385.0000, 'ºC'),
	(190488, 118, '2014-02-15 00:21:52.000000', 'temperatura', 950.0000, 'ºC'),
	(190489, 118, '2014-02-15 00:21:53.000000', 'temperatura', 1195.0000, 'ºC'),
	(190490, 118, '2014-02-15 00:21:54.000000', 'temperatura', 726.0000, 'ºC'),
	(190491, 118, '2014-02-15 00:21:55.000000', 'temperatura', 45.0000, 'ºC'),
	(190492, 118, '2014-02-15 00:21:56.000000', 'temperatura', 446.0000, 'ºC'),
	(190493, 118, '2014-02-15 00:21:57.000000', 'temperatura', 897.0000, 'ºC'),
	(190494, 118, '2014-02-15 00:21:58.000000', 'temperatura', 746.0000, 'ºC'),
	(190495, 118, '2014-02-15 00:21:59.000000', 'temperatura', 1040.0000, 'ºC'),
	(190496, 118, '2014-02-15 00:22:00.000000', 'temperatura', 561.0000, 'ºC'),
	(190497, 118, '2014-02-15 00:22:01.000000', 'temperatura', 888.0000, 'ºC'),
	(190498, 118, '2014-02-15 00:22:02.000000', 'temperatura', 356.0000, 'ºC'),
	(190499, 118, '2014-02-15 00:22:03.000000', 'temperatura', 315.0000, 'ºC'),
	(190500, 118, '2014-02-15 00:22:04.000000', 'temperatura', 511.0000, 'ºC'),
	(190501, 118, '2014-02-15 00:22:05.000000', 'temperatura', 407.0000, 'ºC'),
	(190502, 118, '2014-02-15 00:22:06.000000', 'temperatura', 506.0000, 'ºC'),
	(190503, 118, '2014-02-15 00:22:07.000000', 'temperatura', 107.0000, 'ºC'),
	(190504, 118, '2014-02-15 00:22:08.000000', 'temperatura', 218.0000, 'ºC'),
	(190505, 118, '2014-02-15 00:22:09.000000', 'temperatura', 769.0000, 'ºC'),
	(190506, 118, '2014-02-15 00:22:10.000000', 'temperatura', 792.0000, 'ºC'),
	(190507, 118, '2014-02-15 00:22:11.000000', 'temperatura', 455.0000, 'ºC'),
	(190508, 118, '2014-02-15 00:22:12.000000', 'temperatura', 1098.0000, 'ºC'),
	(190509, 118, '2014-02-15 00:22:13.000000', 'temperatura', 526.0000, 'ºC'),
	(190510, 118, '2014-02-15 00:22:14.000000', 'temperatura', 534.0000, 'ºC'),
	(190511, 118, '2014-02-15 00:22:15.000000', 'temperatura', 1095.0000, 'ºC'),
	(190512, 118, '2014-02-15 00:22:16.000000', 'temperatura', 274.0000, 'ºC'),
	(190513, 118, '2014-02-15 00:22:17.000000', 'temperatura', 483.0000, 'ºC'),
	(190514, 118, '2014-02-15 00:22:18.000000', 'temperatura', 395.0000, 'ºC'),
	(190515, 118, '2014-02-15 00:22:19.000000', 'temperatura', 526.0000, 'ºC'),
	(190516, 118, '2014-02-15 00:22:20.000000', 'temperatura', 246.0000, 'ºC'),
	(190517, 118, '2014-02-15 00:22:21.000000', 'temperatura', 852.0000, 'ºC'),
	(190518, 118, '2014-02-15 00:22:22.000000', 'temperatura', 1124.0000, 'ºC'),
	(190519, 118, '2014-02-15 00:22:23.000000', 'temperatura', 663.0000, 'ºC'),
	(190520, 118, '2014-02-15 00:22:24.000000', 'temperatura', 1145.0000, 'ºC'),
	(190521, 118, '2014-02-15 00:22:25.000000', 'temperatura', 136.0000, 'ºC'),
	(190522, 118, '2014-02-15 00:22:26.000000', 'temperatura', 844.0000, 'ºC'),
	(190523, 118, '2014-02-15 00:22:27.000000', 'temperatura', 212.0000, 'ºC'),
	(190524, 118, '2014-02-15 00:22:28.000000', 'temperatura', 930.0000, 'ºC'),
	(190525, 118, '2014-02-15 00:22:29.000000', 'temperatura', 415.0000, 'ºC'),
	(190526, 118, '2014-02-15 00:22:30.000000', 'temperatura', 485.0000, 'ºC'),
	(190527, 118, '2014-02-15 00:22:31.000000', 'temperatura', 1181.0000, 'ºC'),
	(190528, 118, '2014-02-15 00:22:32.000000', 'temperatura', 848.0000, 'ºC'),
	(190529, 118, '2014-02-15 00:22:33.000000', 'temperatura', 701.0000, 'ºC'),
	(190530, 118, '2014-02-15 00:22:34.000000', 'temperatura', 960.0000, 'ºC'),
	(190531, 118, '2014-02-15 00:22:35.000000', 'temperatura', 296.0000, 'ºC'),
	(190532, 118, '2014-02-15 00:22:36.000000', 'temperatura', 1003.0000, 'ºC'),
	(190533, 118, '2014-02-15 00:22:37.000000', 'temperatura', 524.0000, 'ºC'),
	(190534, 118, '2014-02-15 00:22:38.000000', 'temperatura', 815.0000, 'ºC'),
	(190535, 118, '2014-02-15 00:22:39.000000', 'temperatura', 102.0000, 'ºC'),
	(190536, 118, '2014-02-15 00:22:40.000000', 'temperatura', 467.0000, 'ºC'),
	(190537, 118, '2014-02-15 00:22:41.000000', 'temperatura', 830.0000, 'ºC'),
	(190538, 118, '2014-02-15 00:22:42.000000', 'temperatura', 350.0000, 'ºC'),
	(190539, 118, '2014-02-15 00:22:43.000000', 'temperatura', 461.0000, 'ºC'),
	(190540, 118, '2014-02-15 00:22:44.000000', 'temperatura', 53.0000, 'ºC'),
	(190541, 118, '2014-02-15 00:22:45.000000', 'temperatura', 84.0000, 'ºC'),
	(190542, 118, '2014-02-15 00:22:46.000000', 'temperatura', 261.0000, 'ºC'),
	(190543, 118, '2014-02-15 00:22:47.000000', 'temperatura', 1054.0000, 'ºC'),
	(190544, 118, '2014-02-15 00:22:48.000000', 'temperatura', 886.0000, 'ºC'),
	(190545, 118, '2014-02-15 00:22:49.000000', 'temperatura', 67.0000, 'ºC'),
	(190546, 118, '2014-02-15 00:22:50.000000', 'temperatura', 81.0000, 'ºC'),
	(190547, 118, '2014-02-15 00:22:51.000000', 'temperatura', 204.0000, 'ºC'),
	(190548, 118, '2014-02-15 00:22:52.000000', 'temperatura', 777.0000, 'ºC'),
	(190549, 118, '2014-02-15 00:22:53.000000', 'temperatura', 872.0000, 'ºC'),
	(190550, 118, '2014-02-15 00:22:54.000000', 'temperatura', 829.0000, 'ºC'),
	(190551, 118, '2014-02-15 00:22:55.000000', 'temperatura', 329.0000, 'ºC'),
	(190552, 118, '2014-02-15 00:22:56.000000', 'temperatura', 360.0000, 'ºC'),
	(190553, 118, '2014-02-15 00:22:57.000000', 'temperatura', 814.0000, 'ºC'),
	(190554, 118, '2014-02-15 00:22:58.000000', 'temperatura', 592.0000, 'ºC'),
	(190555, 118, '2014-02-15 00:22:59.000000', 'temperatura', 515.0000, 'ºC'),
	(190556, 118, '2014-02-15 00:23:00.000000', 'temperatura', 803.0000, 'ºC'),
	(190557, 118, '2014-02-15 00:23:01.000000', 'temperatura', 67.0000, 'ºC'),
	(190558, 118, '2014-02-15 00:23:02.000000', 'temperatura', 329.0000, 'ºC'),
	(190559, 118, '2014-02-15 00:23:03.000000', 'temperatura', 245.0000, 'ºC'),
	(190560, 118, '2014-02-15 00:23:04.000000', 'temperatura', 237.0000, 'ºC'),
	(190561, 118, '2014-02-15 00:23:05.000000', 'temperatura', 449.0000, 'ºC'),
	(190562, 118, '2014-02-15 00:23:06.000000', 'temperatura', 337.0000, 'ºC'),
	(190563, 118, '2014-02-15 00:23:07.000000', 'temperatura', 339.0000, 'ºC'),
	(190564, 118, '2014-02-15 00:23:08.000000', 'temperatura', 682.0000, 'ºC'),
	(190565, 118, '2014-02-15 00:23:09.000000', 'temperatura', 1195.0000, 'ºC'),
	(190566, 118, '2014-02-15 00:23:10.000000', 'temperatura', 331.0000, 'ºC'),
	(190567, 118, '2014-02-15 00:23:11.000000', 'temperatura', 471.0000, 'ºC'),
	(190568, 118, '2014-02-15 00:23:12.000000', 'temperatura', 160.0000, 'ºC'),
	(190569, 118, '2014-02-15 00:23:13.000000', 'temperatura', 589.0000, 'ºC'),
	(190570, 118, '2014-02-15 00:23:14.000000', 'temperatura', 65.0000, 'ºC'),
	(190571, 118, '2014-02-15 00:23:15.000000', 'temperatura', 957.0000, 'ºC'),
	(190572, 118, '2014-02-15 00:23:16.000000', 'temperatura', 993.0000, 'ºC'),
	(190573, 118, '2014-02-15 00:23:17.000000', 'temperatura', 893.0000, 'ºC'),
	(190574, 118, '2014-02-15 00:23:18.000000', 'temperatura', 286.0000, 'ºC'),
	(190575, 118, '2014-02-15 00:23:19.000000', 'temperatura', 1151.0000, 'ºC'),
	(190576, 118, '2014-02-15 00:23:20.000000', 'temperatura', 98.0000, 'ºC'),
	(190577, 118, '2014-02-15 00:23:21.000000', 'temperatura', 636.0000, 'ºC'),
	(190578, 118, '2014-02-15 00:23:22.000000', 'temperatura', 486.0000, 'ºC'),
	(190579, 118, '2014-02-15 00:23:23.000000', 'temperatura', 524.0000, 'ºC'),
	(190580, 118, '2014-02-15 00:23:24.000000', 'temperatura', 1164.0000, 'ºC'),
	(190581, 118, '2014-02-15 00:23:25.000000', 'temperatura', 649.0000, 'ºC'),
	(190582, 118, '2014-02-15 00:23:26.000000', 'temperatura', 950.0000, 'ºC'),
	(190583, 118, '2014-02-15 00:23:27.000000', 'temperatura', 406.0000, 'ºC'),
	(190584, 118, '2014-02-15 00:23:28.000000', 'temperatura', 380.0000, 'ºC'),
	(190585, 118, '2014-02-15 00:23:29.000000', 'temperatura', 683.0000, 'ºC'),
	(190586, 118, '2014-02-15 00:23:30.000000', 'temperatura', 1076.0000, 'ºC'),
	(190587, 118, '2014-02-15 00:23:31.000000', 'temperatura', 933.0000, 'ºC'),
	(190588, 118, '2014-02-15 00:23:32.000000', 'temperatura', 235.0000, 'ºC'),
	(190589, 118, '2014-02-15 00:23:33.000000', 'temperatura', 779.0000, 'ºC'),
	(190590, 118, '2014-02-15 00:23:34.000000', 'temperatura', 787.0000, 'ºC'),
	(190591, 118, '2014-02-15 00:23:35.000000', 'temperatura', 401.0000, 'ºC'),
	(190592, 118, '2014-02-15 00:23:36.000000', 'temperatura', 845.0000, 'ºC'),
	(190593, 118, '2014-02-15 00:23:37.000000', 'temperatura', 621.0000, 'ºC'),
	(190594, 118, '2014-02-15 00:23:38.000000', 'temperatura', 570.0000, 'ºC'),
	(190595, 118, '2014-02-15 00:23:39.000000', 'temperatura', 989.0000, 'ºC'),
	(190596, 118, '2014-02-15 00:23:40.000000', 'temperatura', 837.0000, 'ºC'),
	(190597, 118, '2014-02-15 00:23:41.000000', 'temperatura', 16.0000, 'ºC'),
	(190598, 118, '2014-02-15 00:23:42.000000', 'temperatura', 1171.0000, 'ºC'),
	(190599, 118, '2014-02-15 00:23:43.000000', 'temperatura', 1009.0000, 'ºC'),
	(190600, 118, '2014-02-15 00:23:44.000000', 'temperatura', 330.0000, 'ºC'),
	(190601, 118, '2014-02-15 00:23:45.000000', 'temperatura', 1023.0000, 'ºC'),
	(190602, 118, '2014-02-15 00:23:46.000000', 'temperatura', 525.0000, 'ºC'),
	(190603, 118, '2014-02-15 00:23:47.000000', 'temperatura', 755.0000, 'ºC'),
	(190604, 118, '2014-02-15 00:23:48.000000', 'temperatura', 1004.0000, 'ºC'),
	(190605, 118, '2014-02-15 00:23:49.000000', 'temperatura', 354.0000, 'ºC'),
	(190606, 118, '2014-02-15 00:23:50.000000', 'temperatura', 1159.0000, 'ºC'),
	(190607, 118, '2014-02-15 00:23:51.000000', 'temperatura', 1133.0000, 'ºC'),
	(190608, 118, '2014-02-15 00:23:52.000000', 'temperatura', 989.0000, 'ºC'),
	(190609, 118, '2014-02-15 00:23:53.000000', 'temperatura', 344.0000, 'ºC'),
	(190610, 118, '2014-02-15 00:23:54.000000', 'temperatura', 1156.0000, 'ºC'),
	(190611, 118, '2014-02-15 00:23:55.000000', 'temperatura', 1149.0000, 'ºC'),
	(190612, 118, '2014-02-15 00:23:56.000000', 'temperatura', 1076.0000, 'ºC'),
	(190613, 118, '2014-02-15 00:23:57.000000', 'temperatura', 736.0000, 'ºC'),
	(190614, 118, '2014-02-15 00:23:58.000000', 'temperatura', 451.0000, 'ºC'),
	(190615, 118, '2014-02-15 00:23:59.000000', 'temperatura', 49.0000, 'ºC'),
	(190616, 118, '2014-02-15 00:24:00.000000', 'temperatura', 91.0000, 'ºC'),
	(190617, 118, '2014-02-15 00:24:01.000000', 'temperatura', 310.0000, 'ºC'),
	(190618, 118, '2014-02-15 00:24:02.000000', 'temperatura', 75.0000, 'ºC'),
	(190619, 118, '2014-02-15 00:24:03.000000', 'temperatura', 646.0000, 'ºC'),
	(190620, 118, '2014-02-15 00:24:04.000000', 'temperatura', 604.0000, 'ºC'),
	(190621, 118, '2014-02-15 00:24:05.000000', 'temperatura', 1084.0000, 'ºC'),
	(190622, 118, '2014-02-15 00:24:06.000000', 'temperatura', 7.0000, 'ºC'),
	(190623, 118, '2014-02-15 00:24:07.000000', 'temperatura', 385.0000, 'ºC'),
	(190624, 118, '2014-02-15 00:24:08.000000', 'temperatura', 703.0000, 'ºC'),
	(190625, 118, '2014-02-15 00:24:09.000000', 'temperatura', 1163.0000, 'ºC'),
	(190626, 118, '2014-02-15 00:24:10.000000', 'temperatura', 106.0000, 'ºC'),
	(190627, 118, '2014-02-15 00:24:11.000000', 'temperatura', 639.0000, 'ºC'),
	(190628, 118, '2014-02-15 00:24:12.000000', 'temperatura', 479.0000, 'ºC'),
	(190629, 118, '2014-02-15 00:24:13.000000', 'temperatura', 477.0000, 'ºC'),
	(190630, 118, '2014-02-15 00:24:14.000000', 'temperatura', 951.0000, 'ºC'),
	(190631, 118, '2014-02-15 00:24:15.000000', 'temperatura', 922.0000, 'ºC'),
	(190632, 118, '2014-02-15 00:24:16.000000', 'temperatura', 559.0000, 'ºC'),
	(190633, 118, '2014-02-15 00:24:17.000000', 'temperatura', 31.0000, 'ºC'),
	(190634, 118, '2014-02-15 00:24:18.000000', 'temperatura', 875.0000, 'ºC'),
	(190635, 118, '2014-02-15 00:24:19.000000', 'temperatura', 686.0000, 'ºC'),
	(190636, 118, '2014-02-15 00:24:20.000000', 'temperatura', 805.0000, 'ºC'),
	(190637, 118, '2014-02-15 00:24:21.000000', 'temperatura', 765.0000, 'ºC'),
	(190638, 118, '2014-02-15 00:24:22.000000', 'temperatura', 212.0000, 'ºC'),
	(190639, 118, '2014-02-15 00:24:23.000000', 'temperatura', 1166.0000, 'ºC'),
	(190640, 118, '2014-02-15 00:24:24.000000', 'temperatura', 392.0000, 'ºC'),
	(190641, 118, '2014-02-15 00:24:25.000000', 'temperatura', 865.0000, 'ºC'),
	(190642, 118, '2014-02-15 00:24:26.000000', 'temperatura', 750.0000, 'ºC'),
	(190643, 118, '2014-02-15 00:24:27.000000', 'temperatura', 1156.0000, 'ºC'),
	(190644, 118, '2014-02-15 00:24:28.000000', 'temperatura', 1129.0000, 'ºC'),
	(190645, 118, '2014-02-15 00:24:29.000000', 'temperatura', 978.0000, 'ºC'),
	(190646, 118, '2014-02-15 00:24:30.000000', 'temperatura', 303.0000, 'ºC'),
	(190647, 118, '2014-02-15 00:24:31.000000', 'temperatura', 981.0000, 'ºC'),
	(190648, 118, '2014-02-15 00:24:32.000000', 'temperatura', 395.0000, 'ºC'),
	(190649, 118, '2014-02-15 00:24:33.000000', 'temperatura', 234.0000, 'ºC'),
	(190650, 118, '2014-02-15 00:24:34.000000', 'temperatura', 1184.0000, 'ºC'),
	(190651, 118, '2014-02-15 00:24:35.000000', 'temperatura', 421.0000, 'ºC'),
	(190652, 118, '2014-02-15 00:24:36.000000', 'temperatura', 954.0000, 'ºC'),
	(190653, 118, '2014-02-15 00:24:37.000000', 'temperatura', 1107.0000, 'ºC'),
	(190654, 118, '2014-02-15 00:24:38.000000', 'temperatura', 273.0000, 'ºC'),
	(190655, 118, '2014-02-15 00:24:39.000000', 'temperatura', 446.0000, 'ºC'),
	(190656, 118, '2014-02-15 00:24:40.000000', 'temperatura', 211.0000, 'ºC'),
	(190657, 118, '2014-02-15 00:24:41.000000', 'temperatura', 918.0000, 'ºC'),
	(190658, 118, '2014-02-15 00:24:42.000000', 'temperatura', 357.0000, 'ºC'),
	(190659, 118, '2014-02-15 00:24:43.000000', 'temperatura', 231.0000, 'ºC'),
	(190660, 118, '2014-02-15 00:24:44.000000', 'temperatura', 87.0000, 'ºC'),
	(190661, 118, '2014-02-15 00:24:45.000000', 'temperatura', 941.0000, 'ºC'),
	(190662, 118, '2014-02-15 00:24:46.000000', 'temperatura', 842.0000, 'ºC'),
	(190663, 118, '2014-02-15 00:24:47.000000', 'temperatura', 191.0000, 'ºC'),
	(190664, 118, '2014-02-15 00:24:48.000000', 'temperatura', 828.0000, 'ºC'),
	(190665, 118, '2014-02-15 00:24:49.000000', 'temperatura', 1169.0000, 'ºC'),
	(190666, 118, '2014-02-15 00:24:50.000000', 'temperatura', 959.0000, 'ºC'),
	(190667, 118, '2014-02-15 00:24:51.000000', 'temperatura', 88.0000, 'ºC'),
	(190668, 118, '2014-02-15 00:24:52.000000', 'temperatura', 1166.0000, 'ºC'),
	(190669, 118, '2014-02-15 00:24:53.000000', 'temperatura', 764.0000, 'ºC'),
	(190670, 118, '2014-02-15 00:24:54.000000', 'temperatura', 323.0000, 'ºC'),
	(190671, 118, '2014-02-15 00:24:55.000000', 'temperatura', 523.0000, 'ºC'),
	(190672, 118, '2014-02-15 00:24:56.000000', 'temperatura', 447.0000, 'ºC'),
	(190673, 118, '2014-02-15 00:24:57.000000', 'temperatura', 667.0000, 'ºC'),
	(190674, 118, '2014-02-15 00:24:58.000000', 'temperatura', 793.0000, 'ºC'),
	(190675, 118, '2014-02-15 00:24:59.000000', 'temperatura', 767.0000, 'ºC'),
	(190676, 118, '2014-02-15 00:25:00.000000', 'temperatura', 255.0000, 'ºC'),
	(190677, 118, '2014-02-15 00:25:01.000000', 'temperatura', 174.0000, 'ºC'),
	(190678, 118, '2014-02-15 00:25:02.000000', 'temperatura', 105.0000, 'ºC'),
	(190679, 118, '2014-02-15 00:25:03.000000', 'temperatura', 4.0000, 'ºC'),
	(190680, 118, '2014-02-15 00:25:04.000000', 'temperatura', 907.0000, 'ºC'),
	(190681, 118, '2014-02-15 00:25:05.000000', 'temperatura', 924.0000, 'ºC'),
	(190682, 118, '2014-02-15 00:25:06.000000', 'temperatura', 701.0000, 'ºC'),
	(190683, 118, '2014-02-15 00:25:07.000000', 'temperatura', 730.0000, 'ºC'),
	(190684, 118, '2014-02-15 00:25:08.000000', 'temperatura', 347.0000, 'ºC'),
	(190685, 118, '2014-02-15 00:25:09.000000', 'temperatura', 748.0000, 'ºC'),
	(190686, 118, '2014-02-15 00:25:10.000000', 'temperatura', 299.0000, 'ºC'),
	(190687, 118, '2014-02-15 00:25:11.000000', 'temperatura', 451.0000, 'ºC'),
	(190688, 118, '2014-02-15 00:25:12.000000', 'temperatura', 159.0000, 'ºC'),
	(190689, 118, '2014-02-15 00:25:13.000000', 'temperatura', 644.0000, 'ºC'),
	(190690, 118, '2014-02-15 00:25:14.000000', 'temperatura', 340.0000, 'ºC'),
	(190691, 118, '2014-02-15 00:25:15.000000', 'temperatura', 971.0000, 'ºC'),
	(190692, 118, '2014-02-15 00:25:16.000000', 'temperatura', 235.0000, 'ºC'),
	(190693, 118, '2014-02-15 00:25:17.000000', 'temperatura', 661.0000, 'ºC'),
	(190694, 118, '2014-02-15 00:25:18.000000', 'temperatura', 203.0000, 'ºC'),
	(190695, 118, '2014-02-15 00:25:19.000000', 'temperatura', 230.0000, 'ºC'),
	(190696, 118, '2014-02-15 00:25:20.000000', 'temperatura', 541.0000, 'ºC'),
	(190697, 118, '2014-02-15 00:25:21.000000', 'temperatura', 818.0000, 'ºC'),
	(190698, 118, '2014-02-15 00:25:22.000000', 'temperatura', 67.0000, 'ºC'),
	(190699, 118, '2014-02-15 00:25:23.000000', 'temperatura', 280.0000, 'ºC'),
	(190700, 118, '2014-02-15 00:25:24.000000', 'temperatura', 2.0000, 'ºC'),
	(190701, 118, '2014-02-15 00:25:25.000000', 'temperatura', 370.0000, 'ºC'),
	(190702, 118, '2014-02-15 00:25:26.000000', 'temperatura', 644.0000, 'ºC'),
	(190703, 118, '2014-02-15 00:25:27.000000', 'temperatura', 911.0000, 'ºC'),
	(190704, 118, '2014-02-15 00:25:28.000000', 'temperatura', 223.0000, 'ºC'),
	(190705, 118, '2014-02-15 00:25:29.000000', 'temperatura', 784.0000, 'ºC'),
	(190706, 118, '2014-02-15 00:25:30.000000', 'temperatura', 853.0000, 'ºC'),
	(190707, 118, '2014-02-15 00:25:31.000000', 'temperatura', 710.0000, 'ºC'),
	(190708, 118, '2014-02-15 00:25:32.000000', 'temperatura', 991.0000, 'ºC'),
	(190709, 118, '2014-02-15 00:25:33.000000', 'temperatura', 428.0000, 'ºC'),
	(190710, 118, '2014-02-15 00:25:34.000000', 'temperatura', 366.0000, 'ºC'),
	(190711, 118, '2014-02-15 00:25:35.000000', 'temperatura', 547.0000, 'ºC'),
	(190712, 118, '2014-02-15 00:25:36.000000', 'temperatura', 436.0000, 'ºC'),
	(190713, 118, '2014-02-15 00:25:37.000000', 'temperatura', 541.0000, 'ºC'),
	(190714, 118, '2014-02-15 00:25:38.000000', 'temperatura', 198.0000, 'ºC'),
	(190715, 118, '2014-02-15 00:25:39.000000', 'temperatura', 567.0000, 'ºC'),
	(190716, 118, '2014-02-15 00:25:40.000000', 'temperatura', 1042.0000, 'ºC'),
	(190717, 118, '2014-02-15 00:25:41.000000', 'temperatura', 1111.0000, 'ºC'),
	(190718, 118, '2014-02-15 00:25:42.000000', 'temperatura', 27.0000, 'ºC'),
	(190719, 118, '2014-02-15 00:25:43.000000', 'temperatura', 405.0000, 'ºC'),
	(190720, 118, '2014-02-15 00:25:44.000000', 'temperatura', 741.0000, 'ºC'),
	(190721, 118, '2014-02-15 00:25:45.000000', 'temperatura', 93.0000, 'ºC'),
	(190722, 118, '2014-02-15 00:25:46.000000', 'temperatura', 642.0000, 'ºC'),
	(190723, 118, '2014-02-15 00:25:47.000000', 'temperatura', 530.0000, 'ºC'),
	(190724, 118, '2014-02-15 00:25:48.000000', 'temperatura', 725.0000, 'ºC'),
	(190725, 118, '2014-02-15 00:25:49.000000', 'temperatura', 836.0000, 'ºC'),
	(190726, 118, '2014-02-15 00:25:50.000000', 'temperatura', 807.0000, 'ºC'),
	(190727, 118, '2014-02-15 00:25:51.000000', 'temperatura', 326.0000, 'ºC'),
	(190728, 118, '2014-02-15 00:25:52.000000', 'temperatura', 409.0000, 'ºC'),
	(190729, 118, '2014-02-15 00:25:53.000000', 'temperatura', 1066.0000, 'ºC'),
	(190730, 118, '2014-02-15 00:25:54.000000', 'temperatura', 505.0000, 'ºC'),
	(190731, 118, '2014-02-15 00:25:55.000000', 'temperatura', 527.0000, 'ºC'),
	(190732, 118, '2014-02-15 00:25:56.000000', 'temperatura', 1122.0000, 'ºC'),
	(190733, 118, '2014-02-15 00:25:57.000000', 'temperatura', 427.0000, 'ºC'),
	(190734, 118, '2014-02-15 00:25:58.000000', 'temperatura', 1171.0000, 'ºC'),
	(190735, 118, '2014-02-15 00:25:59.000000', 'temperatura', 976.0000, 'ºC'),
	(190736, 118, '2014-02-15 00:26:00.000000', 'temperatura', 166.0000, 'ºC'),
	(190737, 118, '2014-02-15 00:26:01.000000', 'temperatura', 302.0000, 'ºC'),
	(190738, 118, '2014-02-15 00:26:02.000000', 'temperatura', 1012.0000, 'ºC'),
	(190739, 118, '2014-02-15 00:26:03.000000', 'temperatura', 557.0000, 'ºC'),
	(190740, 118, '2014-02-15 00:26:04.000000', 'temperatura', 947.0000, 'ºC'),
	(190741, 118, '2014-02-15 00:26:05.000000', 'temperatura', 666.0000, 'ºC'),
	(190742, 118, '2014-02-15 00:26:06.000000', 'temperatura', 489.0000, 'ºC'),
	(190743, 118, '2014-02-15 00:26:07.000000', 'temperatura', 447.0000, 'ºC'),
	(190744, 118, '2014-02-15 00:26:08.000000', 'temperatura', 768.0000, 'ºC'),
	(190745, 118, '2014-02-15 00:26:09.000000', 'temperatura', 101.0000, 'ºC'),
	(190746, 118, '2014-02-15 00:26:10.000000', 'temperatura', 602.0000, 'ºC'),
	(190747, 118, '2014-02-15 00:26:11.000000', 'temperatura', 306.0000, 'ºC'),
	(190748, 118, '2014-02-15 00:26:12.000000', 'temperatura', 923.0000, 'ºC'),
	(190749, 118, '2014-02-15 00:26:13.000000', 'temperatura', 101.0000, 'ºC'),
	(190750, 118, '2014-02-15 00:26:14.000000', 'temperatura', 134.0000, 'ºC'),
	(190751, 118, '2014-02-15 00:26:15.000000', 'temperatura', 367.0000, 'ºC'),
	(190752, 118, '2014-02-15 00:26:16.000000', 'temperatura', 232.0000, 'ºC'),
	(190753, 118, '2014-02-15 00:26:17.000000', 'temperatura', 63.0000, 'ºC'),
	(190754, 118, '2014-02-15 00:26:18.000000', 'temperatura', 817.0000, 'ºC'),
	(190755, 118, '2014-02-15 00:26:19.000000', 'temperatura', 299.0000, 'ºC'),
	(190756, 118, '2014-02-15 00:26:20.000000', 'temperatura', 241.0000, 'ºC'),
	(190757, 118, '2014-02-15 00:26:21.000000', 'temperatura', 311.0000, 'ºC'),
	(190758, 118, '2014-02-15 00:26:22.000000', 'temperatura', 833.0000, 'ºC'),
	(190759, 118, '2014-02-15 00:26:23.000000', 'temperatura', 833.0000, 'ºC'),
	(190760, 118, '2014-02-15 00:26:24.000000', 'temperatura', 464.0000, 'ºC'),
	(190761, 118, '2014-02-15 00:26:25.000000', 'temperatura', 1024.0000, 'ºC'),
	(190762, 118, '2014-02-15 00:26:26.000000', 'temperatura', 129.0000, 'ºC'),
	(190763, 118, '2014-02-15 00:26:27.000000', 'temperatura', 1173.0000, 'ºC'),
	(190764, 118, '2014-02-15 00:26:28.000000', 'temperatura', 680.0000, 'ºC'),
	(190765, 118, '2014-02-15 00:26:29.000000', 'temperatura', 1080.0000, 'ºC'),
	(190766, 118, '2014-02-15 00:26:30.000000', 'temperatura', 962.0000, 'ºC'),
	(190767, 118, '2014-02-15 00:26:31.000000', 'temperatura', 371.0000, 'ºC'),
	(190768, 118, '2014-02-15 00:26:32.000000', 'temperatura', 168.0000, 'ºC'),
	(190769, 118, '2014-02-15 00:26:33.000000', 'temperatura', 930.0000, 'ºC'),
	(190770, 118, '2014-02-15 00:26:34.000000', 'temperatura', 544.0000, 'ºC'),
	(190771, 118, '2014-02-15 00:26:35.000000', 'temperatura', 1130.0000, 'ºC'),
	(190772, 118, '2014-02-15 00:26:36.000000', 'temperatura', 418.0000, 'ºC'),
	(190773, 118, '2014-02-15 00:26:37.000000', 'temperatura', 1101.0000, 'ºC'),
	(190774, 118, '2014-02-15 00:26:38.000000', 'temperatura', 650.0000, 'ºC'),
	(190775, 118, '2014-02-15 00:26:39.000000', 'temperatura', 1149.0000, 'ºC'),
	(190776, 118, '2014-02-15 00:26:40.000000', 'temperatura', 195.0000, 'ºC'),
	(190777, 118, '2014-02-15 00:26:41.000000', 'temperatura', 1131.0000, 'ºC'),
	(190778, 118, '2014-02-15 00:26:42.000000', 'temperatura', 267.0000, 'ºC'),
	(190779, 118, '2014-02-15 00:26:43.000000', 'temperatura', 346.0000, 'ºC'),
	(190780, 118, '2014-02-15 00:26:44.000000', 'temperatura', 926.0000, 'ºC'),
	(190781, 118, '2014-02-15 00:26:45.000000', 'temperatura', 1193.0000, 'ºC'),
	(190782, 118, '2014-02-15 00:26:46.000000', 'temperatura', 790.0000, 'ºC'),
	(190783, 118, '2014-02-15 00:26:47.000000', 'temperatura', 368.0000, 'ºC'),
	(190784, 118, '2014-02-15 00:26:48.000000', 'temperatura', 674.0000, 'ºC'),
	(190785, 118, '2014-02-15 00:26:49.000000', 'temperatura', 1066.0000, 'ºC'),
	(190786, 118, '2014-02-15 00:26:50.000000', 'temperatura', 907.0000, 'ºC'),
	(190787, 118, '2014-02-15 00:26:51.000000', 'temperatura', 136.0000, 'ºC'),
	(190788, 118, '2014-02-15 00:26:52.000000', 'temperatura', 361.0000, 'ºC'),
	(190789, 118, '2014-02-15 00:26:53.000000', 'temperatura', 197.0000, 'ºC'),
	(190790, 118, '2014-02-15 00:26:54.000000', 'temperatura', 1102.0000, 'ºC'),
	(190791, 118, '2014-02-15 00:26:55.000000', 'temperatura', 122.0000, 'ºC'),
	(190792, 118, '2014-02-15 00:26:56.000000', 'temperatura', 902.0000, 'ºC'),
	(190793, 118, '2014-02-15 00:26:57.000000', 'temperatura', 547.0000, 'ºC'),
	(190794, 118, '2014-02-15 00:26:58.000000', 'temperatura', 27.0000, 'ºC'),
	(190795, 118, '2014-02-15 00:26:59.000000', 'temperatura', 894.0000, 'ºC'),
	(190796, 118, '2014-02-15 00:27:00.000000', 'temperatura', 791.0000, 'ºC'),
	(190797, 118, '2014-02-15 00:27:01.000000', 'temperatura', 74.0000, 'ºC'),
	(190798, 118, '2014-02-15 00:27:02.000000', 'temperatura', 396.0000, 'ºC'),
	(190799, 118, '2014-02-15 00:27:03.000000', 'temperatura', 557.0000, 'ºC'),
	(190800, 118, '2014-02-15 00:27:04.000000', 'temperatura', 401.0000, 'ºC'),
	(190801, 118, '2014-02-15 00:27:05.000000', 'temperatura', 333.0000, 'ºC'),
	(190802, 118, '2014-02-15 00:27:06.000000', 'temperatura', 462.0000, 'ºC'),
	(190803, 118, '2014-02-15 00:27:07.000000', 'temperatura', 110.0000, 'ºC'),
	(190804, 118, '2014-02-15 00:27:08.000000', 'temperatura', 367.0000, 'ºC'),
	(190805, 118, '2014-02-15 00:27:09.000000', 'temperatura', 306.0000, 'ºC'),
	(190806, 118, '2014-02-15 00:27:10.000000', 'temperatura', 427.0000, 'ºC'),
	(190807, 118, '2014-02-15 00:27:11.000000', 'temperatura', 20.0000, 'ºC'),
	(190808, 118, '2014-02-15 00:27:12.000000', 'temperatura', 20.0000, 'ºC'),
	(190809, 118, '2014-02-15 00:27:13.000000', 'temperatura', 40.0000, 'ºC'),
	(190810, 118, '2014-02-15 00:27:14.000000', 'temperatura', 139.0000, 'ºC'),
	(190811, 118, '2014-02-15 00:27:15.000000', 'temperatura', 575.0000, 'ºC'),
	(190812, 118, '2014-02-15 00:27:16.000000', 'temperatura', 58.0000, 'ºC'),
	(190813, 118, '2014-02-15 00:27:17.000000', 'temperatura', 968.0000, 'ºC'),
	(190814, 118, '2014-02-15 00:27:18.000000', 'temperatura', 1067.0000, 'ºC'),
	(190815, 118, '2014-02-15 00:27:19.000000', 'temperatura', 32.0000, 'ºC'),
	(190816, 118, '2014-02-15 00:27:20.000000', 'temperatura', 558.0000, 'ºC'),
	(190817, 118, '2014-02-15 00:27:21.000000', 'temperatura', 297.0000, 'ºC'),
	(190818, 118, '2014-02-15 00:27:22.000000', 'temperatura', 1010.0000, 'ºC'),
	(190819, 118, '2014-02-15 00:27:23.000000', 'temperatura', 558.0000, 'ºC'),
	(190820, 118, '2014-02-15 00:27:24.000000', 'temperatura', 961.0000, 'ºC'),
	(190821, 118, '2014-02-15 00:27:25.000000', 'temperatura', 730.0000, 'ºC'),
	(190822, 118, '2014-02-15 00:27:26.000000', 'temperatura', 768.0000, 'ºC'),
	(190823, 118, '2014-02-15 00:27:27.000000', 'temperatura', 452.0000, 'ºC'),
	(190824, 118, '2014-02-15 00:27:28.000000', 'temperatura', 1155.0000, 'ºC'),
	(190825, 118, '2014-02-15 00:27:29.000000', 'temperatura', 820.0000, 'ºC'),
	(190826, 118, '2014-02-15 00:27:30.000000', 'temperatura', 637.0000, 'ºC'),
	(190827, 118, '2014-02-15 00:27:31.000000', 'temperatura', 723.0000, 'ºC'),
	(190828, 118, '2014-02-15 00:27:32.000000', 'temperatura', 506.0000, 'ºC'),
	(190829, 118, '2014-02-15 00:27:33.000000', 'temperatura', 359.0000, 'ºC'),
	(190830, 118, '2014-02-15 00:27:34.000000', 'temperatura', 281.0000, 'ºC'),
	(190831, 118, '2014-02-15 00:27:35.000000', 'temperatura', 327.0000, 'ºC'),
	(190832, 118, '2014-02-15 00:27:36.000000', 'temperatura', 794.0000, 'ºC'),
	(190833, 118, '2014-02-15 00:27:37.000000', 'temperatura', 589.0000, 'ºC'),
	(190834, 118, '2014-02-15 00:27:38.000000', 'temperatura', 564.0000, 'ºC'),
	(190835, 118, '2014-02-15 00:27:39.000000', 'temperatura', 1054.0000, 'ºC'),
	(190836, 118, '2014-02-15 00:27:40.000000', 'temperatura', 1178.0000, 'ºC'),
	(190837, 118, '2014-02-15 00:27:41.000000', 'temperatura', 329.0000, 'ºC'),
	(190838, 118, '2014-02-15 00:27:42.000000', 'temperatura', 510.0000, 'ºC'),
	(190839, 118, '2014-02-15 00:27:43.000000', 'temperatura', 364.0000, 'ºC'),
	(190840, 118, '2014-02-15 00:27:44.000000', 'temperatura', 292.0000, 'ºC'),
	(190841, 118, '2014-02-15 00:27:45.000000', 'temperatura', 368.0000, 'ºC'),
	(190842, 118, '2014-02-15 00:27:46.000000', 'temperatura', 966.0000, 'ºC'),
	(190843, 118, '2014-02-15 00:27:47.000000', 'temperatura', 126.0000, 'ºC'),
	(190844, 118, '2014-02-15 00:27:48.000000', 'temperatura', 130.0000, 'ºC'),
	(190845, 118, '2014-02-15 00:27:49.000000', 'temperatura', 275.0000, 'ºC'),
	(190846, 118, '2014-02-15 00:27:50.000000', 'temperatura', 986.0000, 'ºC'),
	(190847, 118, '2014-02-15 00:27:51.000000', 'temperatura', 506.0000, 'ºC'),
	(190848, 118, '2014-02-15 00:27:52.000000', 'temperatura', 771.0000, 'ºC'),
	(190849, 118, '2014-02-15 00:27:53.000000', 'temperatura', 1136.0000, 'ºC'),
	(190850, 118, '2014-02-15 00:27:54.000000', 'temperatura', 968.0000, 'ºC'),
	(190851, 118, '2014-02-15 00:27:55.000000', 'temperatura', 233.0000, 'ºC'),
	(190852, 118, '2014-02-15 00:27:56.000000', 'temperatura', 660.0000, 'ºC'),
	(190853, 118, '2014-02-15 00:27:57.000000', 'temperatura', 202.0000, 'ºC'),
	(190854, 118, '2014-02-15 00:27:58.000000', 'temperatura', 230.0000, 'ºC'),
	(190855, 118, '2014-02-15 00:27:59.000000', 'temperatura', 543.0000, 'ºC'),
	(190856, 118, '2014-02-15 00:28:00.000000', 'temperatura', 828.0000, 'ºC'),
	(190857, 118, '2014-02-15 00:28:01.000000', 'temperatura', 112.0000, 'ºC'),
	(190858, 118, '2014-02-15 00:28:02.000000', 'temperatura', 477.0000, 'ºC'),
	(190859, 118, '2014-02-15 00:28:03.000000', 'temperatura', 847.0000, 'ºC'),
	(190860, 118, '2014-02-15 00:28:04.000000', 'temperatura', 406.0000, 'ºC'),
	(190861, 118, '2014-02-15 00:28:05.000000', 'temperatura', 687.0000, 'ºC'),
	(190862, 118, '2014-02-15 00:28:06.000000', 'temperatura', 1020.0000, 'ºC'),
	(190863, 118, '2014-02-15 00:28:07.000000', 'temperatura', 641.0000, 'ºC'),
	(190864, 118, '2014-02-15 00:28:08.000000', 'temperatura', 144.0000, 'ºC'),
	(190865, 118, '2014-02-15 00:28:09.000000', 'temperatura', 1197.0000, 'ºC'),
	(190866, 118, '2014-02-15 00:28:10.000000', 'temperatura', 755.0000, 'ºC'),
	(190867, 118, '2014-02-15 00:28:11.000000', 'temperatura', 182.0000, 'ºC'),
	(190868, 118, '2014-02-15 00:28:12.000000', 'temperatura', 1046.0000, 'ºC'),
	(190869, 118, '2014-02-15 00:28:13.000000', 'temperatura', 1084.0000, 'ºC'),
	(190870, 118, '2014-02-15 00:28:14.000000', 'temperatura', 1084.0000, 'ºC'),
	(190871, 118, '2014-02-15 00:28:15.000000', 'temperatura', 966.0000, 'ºC'),
	(190872, 118, '2014-02-15 00:28:16.000000', 'temperatura', 381.0000, 'ºC'),
	(190873, 118, '2014-02-15 00:28:17.000000', 'temperatura', 208.0000, 'ºC'),
	(190874, 118, '2014-02-15 00:28:18.000000', 'temperatura', 1098.0000, 'ºC'),
	(190875, 118, '2014-02-15 00:28:19.000000', 'temperatura', 66.0000, 'ºC'),
	(190876, 118, '2014-02-15 00:28:20.000000', 'temperatura', 637.0000, 'ºC'),
	(190877, 118, '2014-02-15 00:28:21.000000', 'temperatura', 585.0000, 'ºC'),
	(190878, 118, '2014-02-15 00:28:22.000000', 'temperatura', 1016.0000, 'ºC'),
	(190879, 118, '2014-02-15 00:28:23.000000', 'temperatura', 926.0000, 'ºC'),
	(190880, 118, '2014-02-15 00:28:24.000000', 'temperatura', 380.0000, 'ºC'),
	(190881, 118, '2014-02-15 00:28:25.000000', 'temperatura', 325.0000, 'ºC'),
	(190882, 118, '2014-02-15 00:28:26.000000', 'temperatura', 485.0000, 'ºC'),
	(190883, 118, '2014-02-15 00:28:27.000000', 'temperatura', 251.0000, 'ºC'),
	(190884, 118, '2014-02-15 00:28:28.000000', 'temperatura', 1000.0000, 'ºC'),
	(190885, 118, '2014-02-15 00:28:29.000000', 'temperatura', 646.0000, 'ºC'),
	(190886, 118, '2014-02-15 00:28:30.000000', 'temperatura', 231.0000, 'ºC'),
	(190887, 118, '2014-02-15 00:28:31.000000', 'temperatura', 420.0000, 'ºC'),
	(190888, 118, '2014-02-15 00:28:32.000000', 'temperatura', 205.0000, 'ºC'),
	(190889, 118, '2014-02-15 00:28:33.000000', 'temperatura', 968.0000, 'ºC'),
	(190890, 118, '2014-02-15 00:28:34.000000', 'temperatura', 625.0000, 'ºC'),
	(190891, 118, '2014-02-15 00:28:35.000000', 'temperatura', 222.0000, 'ºC'),
	(190892, 118, '2014-02-15 00:28:36.000000', 'temperatura', 437.0000, 'ºC'),
	(190893, 118, '2014-02-15 00:28:37.000000', 'temperatura', 316.0000, 'ºC'),
	(190894, 118, '2014-02-15 00:28:38.000000', 'temperatura', 271.0000, 'ºC'),
	(190895, 118, '2014-02-15 00:28:39.000000', 'temperatura', 409.0000, 'ºC'),
	(190896, 118, '2014-02-15 00:28:40.000000', 'temperatura', 30.0000, 'ºC'),
	(190897, 118, '2014-02-15 00:28:41.000000', 'temperatura', 126.0000, 'ºC'),
	(190898, 118, '2014-02-15 00:28:42.000000', 'temperatura', 540.0000, 'ºC'),
	(190899, 118, '2014-02-15 00:28:43.000000', 'temperatura', 1121.0000, 'ºC'),
	(190900, 118, '2014-02-15 00:28:44.000000', 'temperatura', 385.0000, 'ºC'),
	(190901, 118, '2014-02-15 00:28:45.000000', 'temperatura', 965.0000, 'ºC'),
	(190902, 118, '2014-02-15 00:28:46.000000', 'temperatura', 69.0000, 'ºC'),
	(190903, 118, '2014-02-15 00:28:47.000000', 'temperatura', 1051.0000, 'ºC'),
	(190904, 118, '2014-02-15 00:28:48.000000', 'temperatura', 250.0000, 'ºC'),
	(190905, 118, '2014-02-15 00:28:49.000000', 'temperatura', 496.0000, 'ºC'),
	(190906, 118, '2014-02-15 00:28:50.000000', 'temperatura', 531.0000, 'ºC'),
	(190907, 118, '2014-02-15 00:28:51.000000', 'temperatura', 1168.0000, 'ºC'),
	(190908, 118, '2014-02-15 00:28:52.000000', 'temperatura', 648.0000, 'ºC'),
	(190909, 118, '2014-02-15 00:28:53.000000', 'temperatura', 936.0000, 'ºC'),
	(190910, 118, '2014-02-15 00:28:54.000000', 'temperatura', 335.0000, 'ºC'),
	(190911, 118, '2014-02-15 00:28:55.000000', 'temperatura', 69.0000, 'ºC'),
	(190912, 118, '2014-02-15 00:28:56.000000', 'temperatura', 539.0000, 'ºC'),
	(190913, 118, '2014-02-15 00:28:57.000000', 'temperatura', 91.0000, 'ºC'),
	(190914, 118, '2014-02-15 00:28:58.000000', 'temperatura', 36.0000, 'ºC'),
	(190915, 118, '2014-02-15 00:28:59.000000', 'temperatura', 1107.0000, 'ºC'),
	(190916, 118, '2014-02-15 00:29:00.000000', 'temperatura', 627.0000, 'ºC'),
	(190917, 118, '2014-02-15 00:29:01.000000', 'temperatura', 1017.0000, 'ºC'),
	(190918, 118, '2014-02-15 00:29:02.000000', 'temperatura', 803.0000, 'ºC'),
	(190919, 118, '2014-02-15 00:29:03.000000', 'temperatura', 967.0000, 'ºC'),
	(190920, 118, '2014-02-15 00:29:04.000000', 'temperatura', 24.0000, 'ºC'),
	(190921, 118, '2014-02-15 00:29:05.000000', 'temperatura', 818.0000, 'ºC'),
	(190922, 118, '2014-02-15 00:29:06.000000', 'temperatura', 421.0000, 'ºC'),
	(190923, 118, '2014-02-15 00:29:07.000000', 'temperatura', 849.0000, 'ºC'),
	(190924, 118, '2014-02-15 00:29:08.000000', 'temperatura', 584.0000, 'ºC'),
	(190925, 118, '2014-02-15 00:29:09.000000', 'temperatura', 373.0000, 'ºC'),
	(190926, 118, '2014-02-15 00:29:10.000000', 'temperatura', 113.0000, 'ºC'),
	(190927, 118, '2014-02-15 00:29:11.000000', 'temperatura', 648.0000, 'ºC'),
	(190928, 118, '2014-02-15 00:29:12.000000', 'temperatura', 500.0000, 'ºC'),
	(190929, 118, '2014-02-15 00:29:13.000000', 'temperatura', 557.0000, 'ºC'),
	(190930, 118, '2014-02-15 00:29:14.000000', 'temperatura', 85.0000, 'ºC'),
	(190931, 118, '2014-02-15 00:29:15.000000', 'temperatura', 1156.0000, 'ºC'),
	(190932, 118, '2014-02-15 00:29:16.000000', 'temperatura', 726.0000, 'ºC'),
	(190933, 118, '2014-02-15 00:29:17.000000', 'temperatura', 161.0000, 'ºC'),
	(190934, 118, '2014-02-15 00:29:18.000000', 'temperatura', 1026.0000, 'ºC'),
	(190935, 118, '2014-02-15 00:29:19.000000', 'temperatura', 1048.0000, 'ºC'),
	(190936, 118, '2014-02-15 00:29:20.000000', 'temperatura', 965.0000, 'ºC'),
	(190937, 118, '2014-02-15 00:29:21.000000', 'temperatura', 481.0000, 'ºC'),
	(190938, 118, '2014-02-15 00:29:22.000000', 'temperatura', 708.0000, 'ºC'),
	(190939, 118, '2014-02-15 00:29:23.000000', 'temperatura', 898.0000, 'ºC'),
	(190940, 118, '2014-02-15 00:29:24.000000', 'temperatura', 1167.0000, 'ºC'),
	(190941, 118, '2014-02-15 00:29:25.000000', 'temperatura', 743.0000, 'ºC'),
	(190942, 118, '2014-02-15 00:29:26.000000', 'temperatura', 214.0000, 'ºC'),
	(190943, 118, '2014-02-15 00:29:27.000000', 'temperatura', 40.0000, 'ºC'),
	(190944, 118, '2014-02-15 00:29:28.000000', 'temperatura', 761.0000, 'ºC'),
	(190945, 118, '2014-02-15 00:29:29.000000', 'temperatura', 86.0000, 'ºC'),
	(190946, 118, '2014-02-15 00:29:30.000000', 'temperatura', 545.0000, 'ºC'),
	(190947, 118, '2014-02-15 00:29:31.000000', 'temperatura', 69.0000, 'ºC'),
	(190948, 118, '2014-02-15 00:29:32.000000', 'temperatura', 1110.0000, 'ºC'),
	(190949, 118, '2014-02-15 00:29:33.000000', 'temperatura', 545.0000, 'ºC'),
	(190950, 118, '2014-02-15 00:29:34.000000', 'temperatura', 594.0000, 'ºC'),
	(190951, 118, '2014-02-15 00:29:35.000000', 'temperatura', 137.0000, 'ºC'),
	(190952, 118, '2014-02-15 00:29:36.000000', 'temperatura', 101.0000, 'ºC'),
	(190953, 118, '2014-02-15 00:29:37.000000', 'temperatura', 98.0000, 'ºC'),
	(190954, 118, '2014-02-15 00:29:38.000000', 'temperatura', 184.0000, 'ºC'),
	(190955, 118, '2014-02-15 00:29:39.000000', 'temperatura', 628.0000, 'ºC'),
	(190956, 118, '2014-02-15 00:29:40.000000', 'temperatura', 189.0000, 'ºC'),
	(190957, 118, '2014-02-15 00:29:41.000000', 'temperatura', 262.0000, 'ºC'),
	(190958, 118, '2014-02-15 00:29:42.000000', 'temperatura', 742.0000, 'ºC'),
	(190959, 118, '2014-02-15 00:29:43.000000', 'temperatura', 527.0000, 'ºC'),
	(190960, 118, '2014-02-15 00:29:44.000000', 'temperatura', 408.0000, 'ºC'),
	(190961, 118, '2014-02-15 00:29:45.000000', 'temperatura', 461.0000, 'ºC'),
	(190962, 118, '2014-02-15 00:29:46.000000', 'temperatura', 1081.0000, 'ºC'),
	(190963, 118, '2014-02-15 00:29:47.000000', 'temperatura', 420.0000, 'ºC'),
	(190964, 118, '2014-02-15 00:29:48.000000', 'temperatura', 60.0000, 'ºC'),
	(190965, 118, '2014-02-15 00:29:49.000000', 'temperatura', 239.0000, 'ºC'),
	(190966, 118, '2014-02-15 00:29:50.000000', 'temperatura', 1017.0000, 'ºC'),
	(190967, 118, '2014-02-15 00:29:51.000000', 'temperatura', 766.0000, 'ºC'),
	(190968, 118, '2014-02-15 00:29:52.000000', 'temperatura', 782.0000, 'ºC'),
	(190969, 118, '2014-02-15 00:29:53.000000', 'temperatura', 411.0000, 'ºC'),
	(190970, 118, '2014-02-15 00:29:54.000000', 'temperatura', 910.0000, 'ºC'),
	(190971, 118, '2014-02-15 00:29:55.000000', 'temperatura', 916.0000, 'ºC'),
	(190972, 118, '2014-02-15 00:29:56.000000', 'temperatura', 652.0000, 'ºC'),
	(190973, 118, '2014-02-15 00:29:57.000000', 'temperatura', 514.0000, 'ºC'),
	(190974, 118, '2014-02-15 00:29:58.000000', 'temperatura', 612.0000, 'ºC'),
	(190975, 118, '2014-02-15 00:29:59.000000', 'temperatura', 320.0000, 'ºC'),
	(190976, 118, '2014-02-15 00:30:00.000000', 'temperatura', 966.0000, 'ºC'),
	(190977, 118, '2014-02-15 00:30:01.000000', 'temperatura', 269.0000, 'ºC'),
	(190978, 118, '2014-02-15 00:30:02.000000', 'temperatura', 846.0000, 'ºC'),
	(190979, 118, '2014-02-15 00:30:03.000000', 'temperatura', 1024.0000, 'ºC'),
	(190980, 118, '2014-02-15 00:30:04.000000', 'temperatura', 184.0000, 'ºC'),
	(190981, 118, '2014-02-15 00:30:05.000000', 'temperatura', 250.0000, 'ºC'),
	(190982, 118, '2014-02-15 00:30:06.000000', 'temperatura', 696.0000, 'ºC'),
	(190983, 118, '2014-02-15 00:30:07.000000', 'temperatura', 332.0000, 'ºC'),
	(190984, 118, '2014-02-15 00:30:08.000000', 'temperatura', 773.0000, 'ºC'),
	(190985, 118, '2014-02-15 00:30:09.000000', 'temperatura', 468.0000, 'ºC'),
	(190986, 118, '2014-02-15 00:30:10.000000', 'temperatura', 20.0000, 'ºC'),
	(190987, 118, '2014-02-15 00:30:11.000000', 'temperatura', 1099.0000, 'ºC'),
	(190988, 118, '2014-02-15 00:30:12.000000', 'temperatura', 634.0000, 'ºC'),
	(190989, 118, '2014-02-15 00:30:13.000000', 'temperatura', 1076.0000, 'ºC'),
	(190990, 118, '2014-02-15 00:30:14.000000', 'temperatura', 1076.0000, 'ºC'),
	(190991, 118, '2014-02-15 00:30:15.000000', 'temperatura', 955.0000, 'ºC'),
	(190992, 118, '2014-02-15 00:30:16.000000', 'temperatura', 346.0000, 'ºC'),
	(190993, 118, '2014-02-15 00:30:17.000000', 'temperatura', 66.0000, 'ºC'),
	(190994, 118, '2014-02-15 00:30:18.000000', 'temperatura', 491.0000, 'ºC'),
	(190995, 118, '2014-02-15 00:30:19.000000', 'temperatura', 1059.0000, 'ºC'),
	(190996, 118, '2014-02-15 00:30:20.000000', 'temperatura', 220.0000, 'ºC'),
	(190997, 118, '2014-02-15 00:30:21.000000', 'temperatura', 325.0000, 'ºC'),
	(190998, 118, '2014-02-15 00:30:22.000000', 'temperatura', 965.0000, 'ºC'),
	(190999, 118, '2014-02-15 00:30:23.000000', 'temperatura', 249.0000, 'ºC'),
	(191000, 118, '2014-02-15 00:30:24.000000', 'temperatura', 751.0000, 'ºC'),
	(191001, 118, '2014-02-15 00:30:25.000000', 'temperatura', 610.0000, 'ºC'),
	(191002, 118, '2014-02-15 00:30:26.000000', 'temperatura', 799.0000, 'ºC'),
	(191003, 118, '2014-02-15 00:30:27.000000', 'temperatura', 963.0000, 'ºC'),
	(191004, 118, '2014-02-15 00:30:28.000000', 'temperatura', 19.0000, 'ºC'),
	(191005, 118, '2014-02-15 00:30:29.000000', 'temperatura', 807.0000, 'ºC'),
	(191006, 118, '2014-02-15 00:30:30.000000', 'temperatura', 378.0000, 'ºC'),
	(191007, 118, '2014-02-15 00:30:31.000000', 'temperatura', 669.0000, 'ºC'),
	(191008, 118, '2014-02-15 00:30:32.000000', 'temperatura', 1012.0000, 'ºC'),
	(191009, 118, '2014-02-15 00:30:33.000000', 'temperatura', 652.0000, 'ºC'),
	(191010, 118, '2014-02-15 00:30:34.000000', 'temperatura', 223.0000, 'ºC'),
	(191011, 118, '2014-02-15 00:30:35.000000', 'temperatura', 363.0000, 'ºC'),
	(191012, 118, '2014-02-15 00:30:36.000000', 'temperatura', 1146.0000, 'ºC'),
	(191013, 118, '2014-02-15 00:30:37.000000', 'temperatura', 1039.0000, 'ºC'),
	(191014, 118, '2014-02-15 00:30:38.000000', 'temperatura', 559.0000, 'ºC'),
	(191015, 118, '2014-02-15 00:30:39.000000', 'temperatura', 879.0000, 'ºC'),
	(191016, 118, '2014-02-15 00:30:40.000000', 'temperatura', 317.0000, 'ºC'),
	(191017, 118, '2014-02-15 00:30:41.000000', 'temperatura', 147.0000, 'ºC'),
	(191018, 118, '2014-02-15 00:30:42.000000', 'temperatura', 988.0000, 'ºC'),
	(191019, 118, '2014-02-15 00:30:43.000000', 'temperatura', 899.0000, 'ºC'),
	(191020, 118, '2014-02-15 00:30:44.000000', 'temperatura', 331.0000, 'ºC'),
	(191021, 118, '2014-02-15 00:30:45.000000', 'temperatura', 158.0000, 'ºC'),
	(191022, 118, '2014-02-15 00:30:46.000000', 'temperatura', 996.0000, 'ºC'),
	(191023, 118, '2014-02-15 00:30:47.000000', 'temperatura', 908.0000, 'ºC'),
	(191024, 118, '2014-02-15 00:30:48.000000', 'temperatura', 354.0000, 'ºC'),
	(191025, 118, '2014-02-15 00:30:49.000000', 'temperatura', 244.0000, 'ºC'),
	(191026, 118, '2014-02-15 00:30:50.000000', 'temperatura', 160.0000, 'ºC'),
	(191027, 118, '2014-02-15 00:30:51.000000', 'temperatura', 68.0000, 'ºC'),
	(191028, 118, '2014-02-15 00:30:52.000000', 'temperatura', 1061.0000, 'ºC'),
	(191029, 118, '2014-02-15 00:30:53.000000', 'temperatura', 300.0000, 'ºC'),
	(191030, 118, '2014-02-15 00:30:54.000000', 'temperatura', 720.0000, 'ºC'),
	(191031, 118, '2014-02-15 00:30:55.000000', 'temperatura', 300.0000, 'ºC'),
	(191032, 118, '2014-02-15 00:30:56.000000', 'temperatura', 542.0000, 'ºC'),
	(191033, 118, '2014-02-15 00:30:57.000000', 'temperatura', 610.0000, 'ºC'),
	(191034, 118, '2014-02-15 00:30:58.000000', 'temperatura', 223.0000, 'ºC'),
	(191035, 118, '2014-02-15 00:30:59.000000', 'temperatura', 487.0000, 'ºC'),
	(191036, 118, '2014-02-15 00:31:00.000000', 'temperatura', 568.0000, 'ºC'),
	(191037, 118, '2014-02-15 00:31:01.000000', 'temperatura', 177.0000, 'ºC'),
	(191038, 118, '2014-02-15 00:31:02.000000', 'temperatura', 384.0000, 'ºC'),
	(191039, 118, '2014-02-15 00:31:03.000000', 'temperatura', 189.0000, 'ºC'),
	(191040, 118, '2014-02-15 00:31:04.000000', 'temperatura', 991.0000, 'ºC'),
	(191041, 118, '2014-02-15 00:31:05.000000', 'temperatura', 791.0000, 'ºC'),
	(191042, 118, '2014-02-15 00:31:06.000000', 'temperatura', 982.0000, 'ºC'),
	(191043, 118, '2014-02-15 00:31:07.000000', 'temperatura', 139.0000, 'ºC'),
	(191044, 118, '2014-02-15 00:31:08.000000', 'temperatura', 148.0000, 'ºC'),
	(191045, 118, '2014-02-15 00:31:09.000000', 'temperatura', 322.0000, 'ºC'),
	(191046, 118, '2014-02-15 00:31:10.000000', 'temperatura', 1168.0000, 'ºC'),
	(191047, 118, '2014-02-15 00:31:11.000000', 'temperatura', 73.0000, 'ºC'),
	(191048, 118, '2014-02-15 00:31:12.000000', 'temperatura', 461.0000, 'ºC'),
	(191049, 118, '2014-02-15 00:31:13.000000', 'temperatura', 886.0000, 'ºC'),
	(191050, 118, '2014-02-15 00:31:14.000000', 'temperatura', 648.0000, 'ºC'),
	(191051, 118, '2014-02-15 00:31:15.000000', 'temperatura', 581.0000, 'ºC'),
	(191052, 118, '2014-02-15 00:31:16.000000', 'temperatura', 964.0000, 'ºC'),
	(191053, 118, '2014-02-15 00:31:17.000000', 'temperatura', 677.0000, 'ºC'),
	(191054, 118, '2014-02-15 00:31:18.000000', 'temperatura', 495.0000, 'ºC'),
	(191055, 118, '2014-02-15 00:31:19.000000', 'temperatura', 442.0000, 'ºC'),
	(191056, 118, '2014-02-15 00:31:20.000000', 'temperatura', 726.0000, 'ºC'),
	(191057, 118, '2014-02-15 00:31:21.000000', 'temperatura', 1103.0000, 'ºC'),
	(191058, 118, '2014-02-15 00:31:22.000000', 'temperatura', 940.0000, 'ºC'),
	(191059, 118, '2014-02-15 00:31:23.000000', 'temperatura', 190.0000, 'ºC'),
	(191060, 118, '2014-02-15 00:31:24.000000', 'temperatura', 533.0000, 'ºC'),
	(191061, 118, '2014-02-15 00:31:25.000000', 'temperatura', 892.0000, 'ºC'),
	(191062, 118, '2014-02-15 00:31:26.000000', 'temperatura', 464.0000, 'ºC'),
	(191063, 118, '2014-02-15 00:31:27.000000', 'temperatura', 843.0000, 'ºC'),
	(191064, 118, '2014-02-15 00:31:28.000000', 'temperatura', 424.0000, 'ºC'),
	(191065, 118, '2014-02-15 00:31:29.000000', 'temperatura', 790.0000, 'ºC'),
	(191066, 118, '2014-02-15 00:31:30.000000', 'temperatura', 281.0000, 'ºC'),
	(191067, 118, '2014-02-15 00:31:31.000000', 'temperatura', 235.0000, 'ºC'),
	(191068, 118, '2014-02-15 00:31:32.000000', 'temperatura', 330.0000, 'ºC'),
	(191069, 118, '2014-02-15 00:31:33.000000', 'temperatura', 948.0000, 'ºC'),
	(191070, 118, '2014-02-15 00:31:34.000000', 'temperatura', 151.0000, 'ºC'),
	(191071, 118, '2014-02-15 00:31:35.000000', 'temperatura', 312.0000, 'ºC'),
	(191072, 118, '2014-02-15 00:31:36.000000', 'temperatura', 1108.0000, 'ºC'),
	(191073, 118, '2014-02-15 00:31:37.000000', 'temperatura', 1002.0000, 'ºC'),
	(191074, 118, '2014-02-15 00:31:38.000000', 'temperatura', 489.0000, 'ºC'),
	(191075, 118, '2014-02-15 00:31:39.000000', 'temperatura', 638.0000, 'ºC'),
	(191076, 118, '2014-02-15 00:31:40.000000', 'temperatura', 525.0000, 'ºC'),
	(191077, 118, '2014-02-15 00:31:41.000000', 'temperatura', 711.0000, 'ºC'),
	(191078, 118, '2014-02-15 00:31:42.000000', 'temperatura', 781.0000, 'ºC'),
	(191079, 118, '2014-02-15 00:31:43.000000', 'temperatura', 574.0000, 'ºC'),
	(191080, 118, '2014-02-15 00:31:44.000000', 'temperatura', 526.0000, 'ºC'),
	(191081, 118, '2014-02-15 00:31:45.000000', 'temperatura', 907.0000, 'ºC'),
	(191082, 118, '2014-02-15 00:31:46.000000', 'temperatura', 559.0000, 'ºC'),
	(191083, 118, '2014-02-15 00:31:47.000000', 'temperatura', 75.0000, 'ºC'),
	(191084, 118, '2014-02-15 00:31:48.000000', 'temperatura', 1098.0000, 'ºC'),
	(191085, 118, '2014-02-15 00:31:49.000000', 'temperatura', 464.0000, 'ºC'),
	(191086, 118, '2014-02-15 00:31:50.000000', 'temperatura', 229.0000, 'ºC'),
	(191087, 118, '2014-02-15 00:31:51.000000', 'temperatura', 951.0000, 'ºC'),
	(191088, 118, '2014-02-15 00:31:52.000000', 'temperatura', 468.0000, 'ºC'),
	(191089, 118, '2014-02-15 00:31:53.000000', 'temperatura', 687.0000, 'ºC'),
	(191090, 118, '2014-02-15 00:31:54.000000', 'temperatura', 834.0000, 'ºC'),
	(191091, 118, '2014-02-15 00:31:55.000000', 'temperatura', 907.0000, 'ºC'),
	(191092, 118, '2014-02-15 00:31:56.000000', 'temperatura', 834.0000, 'ºC'),
	(191093, 118, '2014-02-15 00:31:57.000000', 'temperatura', 250.0000, 'ºC'),
	(191094, 118, '2014-02-15 00:31:58.000000', 'temperatura', 1149.0000, 'ºC'),
	(191095, 118, '2014-02-15 00:31:59.000000', 'temperatura', 194.0000, 'ºC'),
	(191096, 118, '2014-02-15 00:32:00.000000', 'temperatura', 1125.0000, 'ºC'),
	(191097, 118, '2014-02-15 00:32:01.000000', 'temperatura', 244.0000, 'ºC'),
	(191098, 118, '2014-02-15 00:32:02.000000', 'temperatura', 246.0000, 'ºC'),
	(191099, 118, '2014-02-15 00:32:03.000000', 'temperatura', 499.0000, 'ºC'),
	(191100, 118, '2014-02-15 00:32:04.000000', 'temperatura', 556.0000, 'ºC'),
	(191101, 118, '2014-02-15 00:32:05.000000', 'temperatura', 85.0000, 'ºC'),
	(191102, 118, '2014-02-15 00:32:06.000000', 'temperatura', 1158.0000, 'ºC'),
	(191103, 118, '2014-02-15 00:32:07.000000', 'temperatura', 733.0000, 'ºC'),
	(191104, 118, '2014-02-15 00:32:08.000000', 'temperatura', 194.0000, 'ºC'),
	(191105, 118, '2014-02-15 00:32:09.000000', 'temperatura', 1171.0000, 'ºC'),
	(191106, 118, '2014-02-15 00:32:10.000000', 'temperatura', 472.0000, 'ºC'),
	(191107, 118, '2014-02-15 00:32:11.000000', 'temperatura', 48.0000, 'ºC'),
	(191108, 118, '2014-02-15 00:32:12.000000', 'temperatura', 25.0000, 'ºC'),
	(191109, 118, '2014-02-15 00:32:13.000000', 'temperatura', 1180.0000, 'ºC'),
	(191110, 118, '2014-02-15 00:32:14.000000', 'temperatura', 1028.0000, 'ºC'),
	(191111, 118, '2014-02-15 00:32:15.000000', 'temperatura', 399.0000, 'ºC'),
	(191112, 118, '2014-02-15 00:32:16.000000', 'temperatura', 113.0000, 'ºC'),
	(191113, 118, '2014-02-15 00:32:17.000000', 'temperatura', 568.0000, 'ºC'),
	(191114, 118, '2014-02-15 00:32:18.000000', 'temperatura', 102.0000, 'ºC'),
	(191115, 118, '2014-02-15 00:32:19.000000', 'temperatura', 6.0000, 'ºC'),
	(191116, 118, '2014-02-15 00:32:20.000000', 'temperatura', 923.0000, 'ºC'),
	(191117, 118, '2014-02-15 00:32:21.000000', 'temperatura', 999.0000, 'ºC'),
	(191118, 118, '2014-02-15 00:32:22.000000', 'temperatura', 1026.0000, 'ºC'),
	(191119, 118, '2014-02-15 00:32:23.000000', 'temperatura', 933.0000, 'ºC'),
	(191120, 118, '2014-02-15 00:32:24.000000', 'temperatura', 389.0000, 'ºC'),
	(191121, 118, '2014-02-15 00:32:25.000000', 'temperatura', 346.0000, 'ºC'),
	(191122, 118, '2014-02-15 00:32:26.000000', 'temperatura', 563.0000, 'ºC'),
	(191123, 118, '2014-02-15 00:32:27.000000', 'temperatura', 579.0000, 'ºC'),
	(191124, 118, '2014-02-15 00:32:28.000000', 'temperatura', 7.0000, 'ºC'),
	(191125, 118, '2014-02-15 00:32:29.000000', 'temperatura', 699.0000, 'ºC'),
	(191126, 118, '2014-02-15 00:32:30.000000', 'temperatura', 1073.0000, 'ºC'),
	(191127, 118, '2014-02-15 00:32:31.000000', 'temperatura', 869.0000, 'ºC'),
	(191128, 118, '2014-02-15 00:32:32.000000', 'temperatura', 1128.0000, 'ºC'),
	(191129, 118, '2014-02-15 00:32:33.000000', 'temperatura', 633.0000, 'ºC'),
	(191130, 118, '2014-02-15 00:32:34.000000', 'temperatura', 980.0000, 'ºC'),
	(191131, 118, '2014-02-15 00:32:35.000000', 'temperatura', 600.0000, 'ºC'),
	(191132, 118, '2014-02-15 00:32:36.000000', 'temperatura', 64.0000, 'ºC'),
	(191133, 118, '2014-02-15 00:32:37.000000', 'temperatura', 917.0000, 'ºC'),
	(191134, 118, '2014-02-15 00:32:38.000000', 'temperatura', 795.0000, 'ºC'),
	(191135, 118, '2014-02-15 00:32:39.000000', 'temperatura', 26.0000, 'ºC'),
	(191136, 118, '2014-02-15 00:32:40.000000', 'temperatura', 143.0000, 'ºC'),
	(191137, 118, '2014-02-15 00:32:41.000000', 'temperatura', 639.0000, 'ºC'),
	(191138, 118, '2014-02-15 00:32:42.000000', 'temperatura', 368.0000, 'ºC'),
	(191139, 118, '2014-02-15 00:32:43.000000', 'temperatura', 1122.0000, 'ºC'),
	(191140, 118, '2014-02-15 00:32:44.000000', 'temperatura', 907.0000, 'ºC'),
	(191141, 118, '2014-02-15 00:32:45.000000', 'temperatura', 1171.0000, 'ºC'),
	(191142, 118, '2014-02-15 00:32:46.000000', 'temperatura', 735.0000, 'ºC'),
	(191143, 118, '2014-02-15 00:32:47.000000', 'temperatura', 161.0000, 'ºC'),
	(191144, 118, '2014-02-15 00:32:48.000000', 'temperatura', 1002.0000, 'ºC'),
	(191145, 118, '2014-02-15 00:32:49.000000', 'temperatura', 926.0000, 'ºC'),
	(191146, 118, '2014-02-15 00:32:50.000000', 'temperatura', 423.0000, 'ºC'),
	(191147, 118, '2014-02-15 00:32:51.000000', 'temperatura', 538.0000, 'ºC'),
	(191148, 118, '2014-02-15 00:32:52.000000', 'temperatura', 224.0000, 'ºC'),
	(191149, 118, '2014-02-15 00:32:53.000000', 'temperatura', 704.0000, 'ºC'),
	(191150, 118, '2014-02-15 00:32:54.000000', 'temperatura', 451.0000, 'ºC'),
	(191151, 118, '2014-02-15 00:32:55.000000', 'temperatura', 144.0000, 'ºC'),
	(191152, 118, '2014-02-15 00:32:56.000000', 'temperatura', 565.0000, 'ºC'),
	(191153, 118, '2014-02-15 00:32:57.000000', 'temperatura', 1193.0000, 'ºC'),
	(191154, 118, '2014-02-15 00:32:58.000000', 'temperatura', 670.0000, 'ºC'),
	(191155, 118, '2014-02-15 00:32:59.000000', 'temperatura', 972.0000, 'ºC'),
	(191156, 118, '2014-02-15 00:33:00.000000', 'temperatura', 453.0000, 'ºC'),
	(191157, 118, '2014-02-15 00:33:01.000000', 'temperatura', 547.0000, 'ºC'),
	(191158, 118, '2014-02-15 00:33:02.000000', 'temperatura', 179.0000, 'ºC'),
	(191159, 118, '2014-02-15 00:33:03.000000', 'temperatura', 454.0000, 'ºC'),
	(191160, 118, '2014-02-15 00:33:04.000000', 'temperatura', 534.0000, 'ºC'),
	(191161, 118, '2014-02-15 00:33:05.000000', 'temperatura', 110.0000, 'ºC'),
	(191162, 118, '2014-02-15 00:33:06.000000', 'temperatura', 146.0000, 'ºC'),
	(191163, 118, '2014-02-15 00:33:07.000000', 'temperatura', 401.0000, 'ºC'),
	(191164, 118, '2014-02-15 00:33:08.000000', 'temperatura', 369.0000, 'ºC'),
	(191165, 118, '2014-02-15 00:33:09.000000', 'temperatura', 642.0000, 'ºC'),
	(191166, 118, '2014-02-15 00:33:10.000000', 'temperatura', 905.0000, 'ºC'),
	(191167, 118, '2014-02-15 00:33:11.000000', 'temperatura', 198.0000, 'ºC'),
	(191168, 118, '2014-02-15 00:33:12.000000', 'temperatura', 676.0000, 'ºC'),
	(191169, 118, '2014-02-15 00:33:13.000000', 'temperatura', 385.0000, 'ºC'),
	(191170, 118, '2014-02-15 00:33:14.000000', 'temperatura', 1100.0000, 'ºC'),
	(191171, 118, '2014-02-15 00:33:15.000000', 'temperatura', 746.0000, 'ºC'),
	(191172, 118, '2014-02-15 00:33:16.000000', 'temperatura', 429.0000, 'ºC'),
	(191173, 118, '2014-02-15 00:33:17.000000', 'temperatura', 1106.0000, 'ºC'),
	(191174, 118, '2014-02-15 00:33:18.000000', 'temperatura', 647.0000, 'ºC'),
	(191175, 118, '2014-02-15 00:33:19.000000', 'temperatura', 1115.0000, 'ºC'),
	(191176, 118, '2014-02-15 00:33:20.000000', 'temperatura', 37.0000, 'ºC'),
	(191177, 118, '2014-02-15 00:33:21.000000', 'temperatura', 438.0000, 'ºC'),
	(191178, 118, '2014-02-15 00:33:22.000000', 'temperatura', 880.0000, 'ºC'),
	(191179, 118, '2014-02-15 00:33:23.000000', 'temperatura', 688.0000, 'ºC'),
	(191180, 118, '2014-02-15 00:33:24.000000', 'temperatura', 798.0000, 'ºC'),
	(191181, 118, '2014-02-15 00:33:25.000000', 'temperatura', 728.0000, 'ºC'),
	(191182, 118, '2014-02-15 00:33:26.000000', 'temperatura', 47.0000, 'ºC'),
	(191183, 118, '2014-02-15 00:33:27.000000', 'temperatura', 450.0000, 'ºC'),
	(191184, 118, '2014-02-15 00:33:28.000000', 'temperatura', 912.0000, 'ºC'),
	(191185, 118, '2014-02-15 00:33:29.000000', 'temperatura', 810.0000, 'ºC'),
	(191186, 118, '2014-02-15 00:33:30.000000', 'temperatura', 116.0000, 'ºC'),
	(191187, 118, '2014-02-15 00:33:31.000000', 'temperatura', 547.0000, 'ºC'),
	(191188, 118, '2014-02-15 00:33:32.000000', 'temperatura', 1189.0000, 'ºC'),
	(191189, 118, '2014-02-15 00:33:33.000000', 'temperatura', 705.0000, 'ºC'),
	(191190, 118, '2014-02-15 00:33:34.000000', 'temperatura', 1160.0000, 'ºC'),
	(191191, 118, '2014-02-15 00:33:35.000000', 'temperatura', 83.0000, 'ºC'),
	(191192, 118, '2014-02-15 00:33:36.000000', 'temperatura', 538.0000, 'ºC'),
	(191193, 118, '2014-02-15 00:33:37.000000', 'temperatura', 39.0000, 'ºC'),
	(191194, 118, '2014-02-15 00:33:38.000000', 'temperatura', 980.0000, 'ºC'),
	(191195, 118, '2014-02-15 00:33:39.000000', 'temperatura', 1187.0000, 'ºC'),
	(191196, 118, '2014-02-15 00:33:40.000000', 'temperatura', 595.0000, 'ºC'),
	(191197, 118, '2014-02-15 00:33:41.000000', 'temperatura', 615.0000, 'ºC'),
	(191198, 118, '2014-02-15 00:33:42.000000', 'temperatura', 89.0000, 'ºC'),
	(191199, 118, '2014-02-15 00:33:43.000000', 'temperatura', 999.0000, 'ºC'),
	(191200, 118, '2014-02-15 00:33:44.000000', 'temperatura', 1131.0000, 'ºC'),
	(191201, 118, '2014-02-15 00:33:45.000000', 'temperatura', 258.0000, 'ºC'),
	(191202, 118, '2014-02-15 00:33:46.000000', 'temperatura', 297.0000, 'ºC'),
	(191203, 118, '2014-02-15 00:33:47.000000', 'temperatura', 710.0000, 'ºC'),
	(191204, 118, '2014-02-15 00:33:48.000000', 'temperatura', 259.0000, 'ºC'),
	(191205, 118, '2014-02-15 00:33:49.000000', 'temperatura', 366.0000, 'ºC'),
	(191206, 118, '2014-02-15 00:33:50.000000', 'temperatura', 1056.0000, 'ºC'),
	(191207, 118, '2014-02-15 00:33:51.000000', 'temperatura', 579.0000, 'ºC'),
	(191208, 118, '2014-02-15 00:33:52.000000', 'temperatura', 929.0000, 'ºC'),
	(191209, 118, '2014-02-15 00:33:53.000000', 'temperatura', 507.0000, 'ºC'),
	(191210, 118, '2014-02-15 00:33:54.000000', 'temperatura', 950.0000, 'ºC'),
	(191211, 118, '2014-02-15 00:33:55.000000', 'temperatura', 831.0000, 'ºC'),
	(191212, 118, '2014-02-15 00:33:56.000000', 'temperatura', 104.0000, 'ºC'),
	(191213, 118, '2014-02-15 00:33:57.000000', 'temperatura', 426.0000, 'ºC'),
	(191214, 118, '2014-02-15 00:33:58.000000', 'temperatura', 622.0000, 'ºC'),
	(191215, 118, '2014-02-15 00:33:59.000000', 'temperatura', 630.0000, 'ºC'),
	(191216, 118, '2014-02-15 00:34:00.000000', 'temperatura', 84.0000, 'ºC'),
	(191217, 118, '2014-02-15 00:34:01.000000', 'temperatura', 932.0000, 'ºC'),
	(191218, 118, '2014-02-15 00:34:02.000000', 'temperatura', 807.0000, 'ºC'),
	(191219, 118, '2014-02-15 00:34:03.000000', 'temperatura', 38.0000, 'ºC'),
	(191220, 118, '2014-02-15 00:34:04.000000', 'temperatura', 172.0000, 'ºC'),
	(191221, 118, '2014-02-15 00:34:05.000000', 'temperatura', 745.0000, 'ºC'),
	(191222, 118, '2014-02-15 00:34:06.000000', 'temperatura', 810.0000, 'ºC'),
	(191223, 118, '2014-02-15 00:34:07.000000', 'temperatura', 615.0000, 'ºC'),
	(191224, 118, '2014-02-15 00:34:08.000000', 'temperatura', 645.0000, 'ºC'),
	(191225, 118, '2014-02-15 00:34:09.000000', 'temperatura', 181.0000, 'ºC'),
	(191226, 118, '2014-02-15 00:34:10.000000', 'temperatura', 173.0000, 'ºC'),
	(191227, 118, '2014-02-15 00:34:11.000000', 'temperatura', 319.0000, 'ºC'),
	(191228, 118, '2014-02-15 00:34:12.000000', 'temperatura', 1076.0000, 'ºC'),
	(191229, 118, '2014-02-15 00:34:13.000000', 'temperatura', 826.0000, 'ºC'),
	(191230, 118, '2014-02-15 00:34:14.000000', 'temperatura', 902.0000, 'ºC'),
	(191231, 118, '2014-02-15 00:34:15.000000', 'temperatura', 833.0000, 'ºC'),
	(191232, 118, '2014-02-15 00:34:16.000000', 'temperatura', 261.0000, 'ºC'),
	(191233, 118, '2014-02-15 00:34:17.000000', 'temperatura', 4.0000, 'ºC'),
	(191234, 118, '2014-02-15 00:34:18.000000', 'temperatura', 440.0000, 'ºC'),
	(191235, 118, '2014-02-15 00:34:19.000000', 'temperatura', 987.0000, 'ºC'),
	(191236, 118, '2014-02-15 00:34:20.000000', 'temperatura', 16.0000, 'ºC'),
	(191237, 118, '2014-02-15 00:34:21.000000', 'temperatura', 721.0000, 'ºC'),
	(191238, 118, '2014-02-15 00:34:22.000000', 'temperatura', 1156.0000, 'ºC'),
	(191239, 118, '2014-02-15 00:34:23.000000', 'temperatura', 20.0000, 'ºC'),
	(191240, 118, '2014-02-15 00:34:24.000000', 'temperatura', 229.0000, 'ºC'),
	(191241, 118, '2014-02-15 00:34:25.000000', 'temperatura', 1088.0000, 'ºC'),
	(191242, 118, '2014-02-15 00:34:26.000000', 'temperatura', 1152.0000, 'ºC'),
	(191243, 118, '2014-02-15 00:34:27.000000', 'temperatura', 98.0000, 'ºC'),
	(191244, 118, '2014-02-15 00:34:28.000000', 'temperatura', 634.0000, 'ºC'),
	(191245, 118, '2014-02-15 00:34:29.000000', 'temperatura', 476.0000, 'ºC'),
	(191246, 118, '2014-02-15 00:34:30.000000', 'temperatura', 480.0000, 'ºC'),
	(191247, 118, '2014-02-15 00:34:31.000000', 'temperatura', 970.0000, 'ºC'),
	(191248, 118, '2014-02-15 00:34:32.000000', 'temperatura', 1014.0000, 'ºC'),
	(191249, 118, '2014-02-15 00:34:33.000000', 'temperatura', 957.0000, 'ºC'),
	(191250, 118, '2014-02-15 00:34:34.000000', 'temperatura', 545.0000, 'ºC'),
	(191251, 118, '2014-02-15 00:34:35.000000', 'temperatura', 1054.0000, 'ºC'),
	(191252, 118, '2014-02-15 00:34:36.000000', 'temperatura', 34.0000, 'ºC'),
	(191253, 118, '2014-02-15 00:34:37.000000', 'temperatura', 610.0000, 'ºC'),
	(191254, 118, '2014-02-15 00:34:38.000000', 'temperatura', 546.0000, 'ºC'),
	(191255, 118, '2014-02-15 00:34:39.000000', 'temperatura', 903.0000, 'ºC'),
	(191256, 118, '2014-02-15 00:34:40.000000', 'temperatura', 478.0000, 'ºC'),
	(191257, 118, '2014-02-15 00:34:41.000000', 'temperatura', 879.0000, 'ºC'),
	(191258, 118, '2014-02-15 00:34:42.000000', 'temperatura', 564.0000, 'ºC'),
	(191259, 118, '2014-02-15 00:34:43.000000', 'temperatura', 184.0000, 'ºC'),
	(191260, 118, '2014-02-15 00:34:44.000000', 'temperatura', 428.0000, 'ºC'),
	(191261, 118, '2014-02-15 00:34:45.000000', 'temperatura', 388.0000, 'ºC'),
	(191262, 118, '2014-02-15 00:34:46.000000', 'temperatura', 656.0000, 'ºC'),
	(191263, 118, '2014-02-15 00:34:47.000000', 'temperatura', 916.0000, 'ºC'),
	(191264, 118, '2014-02-15 00:34:48.000000', 'temperatura', 212.0000, 'ºC'),
	(191265, 118, '2014-02-15 00:34:49.000000', 'temperatura', 714.0000, 'ºC'),
	(191266, 118, '2014-02-15 00:34:50.000000', 'temperatura', 535.0000, 'ºC'),
	(191267, 118, '2014-02-15 00:34:51.000000', 'temperatura', 535.0000, 'ºC'),
	(191268, 118, '2014-02-15 00:34:52.000000', 'temperatura', 1069.0000, 'ºC'),
	(191269, 118, '2014-02-15 00:34:53.000000', 'temperatura', 139.0000, 'ºC'),
	(191270, 118, '2014-02-15 00:34:54.000000', 'temperatura', 1090.0000, 'ºC'),
	(191271, 118, '2014-02-15 00:34:55.000000', 'temperatura', 233.0000, 'ºC'),
	(191272, 118, '2014-02-15 00:34:56.000000', 'temperatura', 296.0000, 'ºC'),
	(191273, 118, '2014-02-15 00:34:57.000000', 'temperatura', 780.0000, 'ºC'),
	(191274, 118, '2014-02-15 00:34:58.000000', 'temperatura', 613.0000, 'ºC'),
	(191275, 118, '2014-02-15 00:34:59.000000', 'temperatura', 727.0000, 'ºC'),
	(191276, 118, '2014-02-15 00:35:00.000000', 'temperatura', 597.0000, 'ºC'),
	(191277, 118, '2014-02-15 00:35:01.000000', 'temperatura', 805.0000, 'ºC'),
	(191278, 118, '2014-02-15 00:35:02.000000', 'temperatura', 1032.0000, 'ºC'),
	(191279, 118, '2014-02-15 00:35:03.000000', 'temperatura', 348.0000, 'ºC'),
	(191280, 118, '2014-02-15 00:35:04.000000', 'temperatura', 1045.0000, 'ºC'),
	(191281, 118, '2014-02-15 00:35:05.000000', 'temperatura', 581.0000, 'ºC'),
	(191282, 118, '2014-02-15 00:35:06.000000', 'temperatura', 971.0000, 'ºC'),
	(191283, 118, '2014-02-15 00:35:07.000000', 'temperatura', 712.0000, 'ºC'),
	(191284, 118, '2014-02-15 00:35:08.000000', 'temperatura', 649.0000, 'ºC'),
	(191285, 118, '2014-02-15 00:35:09.000000', 'temperatura', 1107.0000, 'ºC'),
	(191286, 118, '2014-02-15 00:35:10.000000', 'temperatura', 1191.0000, 'ºC'),
	(191287, 118, '2014-02-15 00:35:11.000000', 'temperatura', 232.0000, 'ºC'),
	(191288, 118, '2014-02-15 00:35:12.000000', 'temperatura', 1190.0000, 'ºC'),
	(191289, 118, '2014-02-15 00:35:13.000000', 'temperatura', 455.0000, 'ºC'),
	(191290, 118, '2014-02-15 00:35:14.000000', 'temperatura', 1104.0000, 'ºC'),
	(191291, 118, '2014-02-15 00:35:15.000000', 'temperatura', 555.0000, 'ºC'),
	(191292, 118, '2014-02-15 00:35:16.000000', 'temperatura', 664.0000, 'ºC'),
	(191293, 118, '2014-02-15 00:35:17.000000', 'temperatura', 454.0000, 'ºC'),
	(191294, 118, '2014-02-15 00:35:18.000000', 'temperatura', 279.0000, 'ºC'),
	(191295, 118, '2014-02-15 00:35:19.000000', 'temperatura', 33.0000, 'ºC'),
	(191296, 118, '2014-02-15 00:35:20.000000', 'temperatura', 530.0000, 'ºC'),
	(191297, 118, '2014-02-15 00:35:21.000000', 'temperatura', 151.0000, 'ºC'),
	(191298, 118, '2014-02-15 00:35:22.000000', 'temperatura', 364.0000, 'ºC'),
	(191299, 118, '2014-02-15 00:35:23.000000', 'temperatura', 169.0000, 'ºC'),
	(191300, 118, '2014-02-15 00:35:24.000000', 'temperatura', 954.0000, 'ºC'),
	(191301, 118, '2014-02-15 00:35:25.000000', 'temperatura', 663.0000, 'ºC'),
	(191302, 118, '2014-02-15 00:35:26.000000', 'temperatura', 451.0000, 'ºC'),
	(191303, 118, '2014-02-15 00:35:27.000000', 'temperatura', 270.0000, 'ºC'),
	(191304, 118, '2014-02-15 00:35:28.000000', 'temperatura', 1196.0000, 'ºC'),
	(191305, 118, '2014-02-15 00:35:29.000000', 'temperatura', 373.0000, 'ºC'),
	(191306, 118, '2014-02-15 00:35:30.000000', 'temperatura', 674.0000, 'ºC'),
	(191307, 118, '2014-02-15 00:35:31.000000', 'temperatura', 1054.0000, 'ºC'),
	(191308, 118, '2014-02-15 00:35:32.000000', 'temperatura', 847.0000, 'ºC'),
	(191309, 118, '2014-02-15 00:35:33.000000', 'temperatura', 1072.0000, 'ºC'),
	(191310, 118, '2014-02-15 00:35:34.000000', 'temperatura', 422.0000, 'ºC'),
	(191311, 118, '2014-02-15 00:35:35.000000', 'temperatura', 92.0000, 'ºC'),
	(191312, 118, '2014-02-15 00:35:36.000000', 'temperatura', 397.0000, 'ºC'),
	(191313, 118, '2014-02-15 00:35:37.000000', 'temperatura', 510.0000, 'ºC'),
	(191314, 118, '2014-02-15 00:35:38.000000', 'temperatura', 160.0000, 'ºC'),
	(191315, 118, '2014-02-15 00:35:39.000000', 'temperatura', 468.0000, 'ºC'),
	(191316, 118, '2014-02-15 00:35:40.000000', 'temperatura', 660.0000, 'ºC'),
	(191317, 118, '2014-02-15 00:35:41.000000', 'temperatura', 697.0000, 'ºC'),
	(191318, 118, '2014-02-15 00:35:42.000000', 'temperatura', 305.0000, 'ºC'),
	(191319, 118, '2014-02-15 00:35:43.000000', 'temperatura', 636.0000, 'ºC'),
	(191320, 118, '2014-02-15 00:35:44.000000', 'temperatura', 1063.0000, 'ºC'),
	(191321, 118, '2014-02-15 00:35:45.000000', 'temperatura', 1009.0000, 'ºC'),
	(191322, 118, '2014-02-15 00:35:46.000000', 'temperatura', 656.0000, 'ºC'),
	(191323, 118, '2014-02-15 00:35:47.000000', 'temperatura', 253.0000, 'ºC'),
	(191324, 118, '2014-02-15 00:35:48.000000', 'temperatura', 497.0000, 'ºC'),
	(191325, 118, '2014-02-15 00:35:49.000000', 'temperatura', 527.0000, 'ºC'),
	(191326, 118, '2014-02-15 00:35:50.000000', 'temperatura', 1145.0000, 'ºC'),
	(191327, 118, '2014-02-15 00:35:51.000000', 'temperatura', 544.0000, 'ºC'),
	(191328, 118, '2014-02-15 00:35:52.000000', 'temperatura', 488.0000, 'ºC'),
	(191329, 118, '2014-02-15 00:35:53.000000', 'temperatura', 805.0000, 'ºC'),
	(191330, 118, '2014-02-15 00:35:54.000000', 'temperatura', 163.0000, 'ºC'),
	(191331, 118, '2014-02-15 00:35:55.000000', 'temperatura', 801.0000, 'ºC'),
	(191332, 118, '2014-02-15 00:35:56.000000', 'temperatura', 1117.0000, 'ºC'),
	(191333, 118, '2014-02-15 00:35:57.000000', 'temperatura', 782.0000, 'ºC'),
	(191334, 118, '2014-02-15 00:35:58.000000', 'temperatura', 558.0000, 'ºC'),
	(191335, 118, '2014-02-15 00:35:59.000000', 'temperatura', 446.0000, 'ºC'),
	(191336, 118, '2014-02-15 00:36:00.000000', 'temperatura', 558.0000, 'ºC'),
	(191337, 118, '2014-02-15 00:36:01.000000', 'temperatura', 252.0000, 'ºC'),
	(191338, 118, '2014-02-15 00:36:02.000000', 'temperatura', 787.0000, 'ºC'),
	(191339, 118, '2014-02-15 00:36:03.000000', 'temperatura', 777.0000, 'ºC'),
	(191340, 118, '2014-02-15 00:36:04.000000', 'temperatura', 326.0000, 'ºC'),
	(191341, 118, '2014-02-15 00:36:05.000000', 'temperatura', 501.0000, 'ºC'),
	(191342, 118, '2014-02-15 00:36:06.000000', 'temperatura', 328.0000, 'ºC'),
	(191343, 118, '2014-02-15 00:36:07.000000', 'temperatura', 138.0000, 'ºC'),
	(191344, 118, '2014-02-15 00:36:08.000000', 'temperatura', 903.0000, 'ºC'),
	(191345, 118, '2014-02-15 00:36:09.000000', 'temperatura', 505.0000, 'ºC'),
	(191346, 118, '2014-02-15 00:36:10.000000', 'temperatura', 1016.0000, 'ºC'),
	(191347, 118, '2014-02-15 00:36:11.000000', 'temperatura', 1163.0000, 'ºC'),
	(191348, 118, '2014-02-15 00:36:12.000000', 'temperatura', 371.0000, 'ºC'),
	(191349, 118, '2014-02-15 00:36:13.000000', 'temperatura', 763.0000, 'ºC'),
	(191350, 118, '2014-02-15 00:36:14.000000', 'temperatura', 304.0000, 'ºC'),
	(191351, 118, '2014-02-15 00:36:15.000000', 'temperatura', 430.0000, 'ºC'),
	(191352, 118, '2014-02-15 00:36:16.000000', 'temperatura', 38.0000, 'ºC'),
	(191353, 118, '2014-02-15 00:36:17.000000', 'temperatura', 100.0000, 'ºC'),
	(191354, 118, '2014-02-15 00:36:18.000000', 'temperatura', 386.0000, 'ºC'),
	(191355, 118, '2014-02-15 00:36:19.000000', 'temperatura', 431.0000, 'ºC'),
	(191356, 118, '2014-02-15 00:36:20.000000', 'temperatura', 999.0000, 'ºC'),
	(191357, 118, '2014-02-15 00:36:21.000000', 'temperatura', 103.0000, 'ºC'),
	(191358, 118, '2014-02-15 00:36:22.000000', 'temperatura', 1118.0000, 'ºC'),
	(191359, 118, '2014-02-15 00:36:23.000000', 'temperatura', 483.0000, 'ºC'),
	(191360, 118, '2014-02-15 00:36:24.000000', 'temperatura', 261.0000, 'ºC'),
	(191361, 118, '2014-02-15 00:36:25.000000', 'temperatura', 1056.0000, 'ºC'),
	(191362, 118, '2014-02-15 00:36:26.000000', 'temperatura', 897.0000, 'ºC'),
	(191363, 118, '2014-02-15 00:36:27.000000', 'temperatura', 116.0000, 'ºC'),
	(191364, 118, '2014-02-15 00:36:28.000000', 'temperatura', 293.0000, 'ºC'),
	(191365, 118, '2014-02-15 00:36:29.000000', 'temperatura', 1115.0000, 'ºC'),
	(191366, 118, '2014-02-15 00:36:30.000000', 'temperatura', 1097.0000, 'ºC'),
	(191367, 118, '2014-02-15 00:36:31.000000', 'temperatura', 941.0000, 'ºC'),
	(191368, 118, '2014-02-15 00:36:32.000000', 'temperatura', 216.0000, 'ºC'),
	(191369, 118, '2014-02-15 00:36:33.000000', 'temperatura', 655.0000, 'ºC'),
	(191370, 118, '2014-02-15 00:36:34.000000', 'temperatura', 229.0000, 'ºC'),
	(191371, 118, '2014-02-15 00:36:35.000000', 'temperatura', 381.0000, 'ºC'),
	(191372, 118, '2014-02-15 00:36:36.000000', 'temperatura', 18.0000, 'ºC'),
	(191373, 118, '2014-02-15 00:36:37.000000', 'temperatura', 148.0000, 'ºC'),
	(191374, 118, '2014-02-15 00:36:38.000000', 'temperatura', 685.0000, 'ºC'),
	(191375, 118, '2014-02-15 00:36:39.000000', 'temperatura', 582.0000, 'ºC'),
	(191376, 118, '2014-02-15 00:36:40.000000', 'temperatura', 856.0000, 'ºC'),
	(191377, 118, '2014-02-15 00:36:41.000000', 'temperatura', 135.0000, 'ºC'),
	(191378, 118, '2014-02-15 00:36:42.000000', 'temperatura', 509.0000, 'ºC'),
	(191379, 118, '2014-02-15 00:36:43.000000', 'temperatura', 939.0000, 'ºC'),
	(191380, 118, '2014-02-15 00:36:44.000000', 'temperatura', 770.0000, 'ºC'),
	(191381, 118, '2014-02-15 00:36:45.000000', 'temperatura', 1030.0000, 'ºC'),
	(191382, 118, '2014-02-15 00:36:46.000000', 'temperatura', 444.0000, 'ºC'),
	(191383, 118, '2014-02-15 00:36:47.000000', 'temperatura', 329.0000, 'ºC'),
	(191384, 118, '2014-02-15 00:36:48.000000', 'temperatura', 313.0000, 'ºC'),
	(191385, 118, '2014-02-15 00:36:49.000000', 'temperatura', 577.0000, 'ºC'),
	(191386, 118, '2014-02-15 00:36:50.000000', 'temperatura', 750.0000, 'ºC'),
	(191387, 118, '2014-02-15 00:36:51.000000', 'temperatura', 817.0000, 'ºC'),
	(191388, 118, '2014-02-15 00:36:52.000000', 'temperatura', 635.0000, 'ºC'),
	(191389, 118, '2014-02-15 00:36:53.000000', 'temperatura', 726.0000, 'ºC'),
	(191390, 118, '2014-02-15 00:36:54.000000', 'temperatura', 523.0000, 'ºC'),
	(191391, 118, '2014-02-15 00:36:55.000000', 'temperatura', 440.0000, 'ºC'),
	(191392, 118, '2014-02-15 00:36:56.000000', 'temperatura', 631.0000, 'ºC'),
	(191393, 118, '2014-02-15 00:36:57.000000', 'temperatura', 636.0000, 'ºC'),
	(191394, 118, '2014-02-15 00:36:58.000000', 'temperatura', 87.0000, 'ºC'),
	(191395, 118, '2014-02-15 00:36:59.000000', 'temperatura', 929.0000, 'ºC'),
	(191396, 118, '2014-02-15 00:37:00.000000', 'temperatura', 783.0000, 'ºC'),
	(191397, 118, '2014-02-15 00:37:01.000000', 'temperatura', 1129.0000, 'ºC'),
	(191398, 118, '2014-02-15 00:37:02.000000', 'temperatura', 896.0000, 'ºC'),
	(191399, 118, '2014-02-15 00:37:03.000000', 'temperatura', 1093.0000, 'ºC'),
	(191400, 118, '2014-02-15 00:37:04.000000', 'temperatura', 378.0000, 'ºC'),
	(191401, 118, '2014-02-15 00:37:05.000000', 'temperatura', 1010.0000, 'ºC'),
	(191402, 118, '2014-02-15 00:37:06.000000', 'temperatura', 320.0000, 'ºC'),
	(191403, 118, '2014-02-15 00:37:07.000000', 'temperatura', 967.0000, 'ºC'),
	(191404, 118, '2014-02-15 00:37:08.000000', 'temperatura', 279.0000, 'ºC'),
	(191405, 118, '2014-02-15 00:37:09.000000', 'temperatura', 892.0000, 'ºC'),
	(191406, 118, '2014-02-15 00:37:10.000000', 'temperatura', 25.0000, 'ºC'),
	(191407, 118, '2014-02-15 00:37:11.000000', 'temperatura', 1047.0000, 'ºC'),
	(191408, 118, '2014-02-15 00:37:12.000000', 'temperatura', 361.0000, 'ºC'),
	(191409, 118, '2014-02-15 00:37:13.000000', 'temperatura', 1067.0000, 'ºC'),
	(191410, 118, '2014-02-15 00:37:14.000000', 'temperatura', 651.0000, 'ºC'),
	(191411, 118, '2014-02-15 00:37:15.000000', 'temperatura', 53.0000, 'ºC'),
	(191412, 118, '2014-02-15 00:37:16.000000', 'temperatura', 716.0000, 'ºC'),
	(191413, 118, '2014-02-15 00:37:17.000000', 'temperatura', 1018.0000, 'ºC'),
	(191414, 118, '2014-02-15 00:37:18.000000', 'temperatura', 544.0000, 'ºC'),
	(191415, 118, '2014-02-15 00:37:19.000000', 'temperatura', 867.0000, 'ºC'),
	(191416, 118, '2014-02-15 00:37:20.000000', 'temperatura', 302.0000, 'ºC'),
	(191417, 118, '2014-02-15 00:37:21.000000', 'temperatura', 109.0000, 'ºC'),
	(191418, 118, '2014-02-15 00:37:22.000000', 'temperatura', 840.0000, 'ºC'),
	(191419, 118, '2014-02-15 00:37:23.000000', 'temperatura', 273.0000, 'ºC'),
	(191420, 118, '2014-02-15 00:37:24.000000', 'temperatura', 48.0000, 'ºC'),
	(191421, 118, '2014-02-15 00:37:25.000000', 'temperatura', 620.0000, 'ºC'),
	(191422, 118, '2014-02-15 00:37:26.000000', 'temperatura', 558.0000, 'ºC'),
	(191423, 118, '2014-02-15 00:37:27.000000', 'temperatura', 932.0000, 'ºC'),
	(191424, 118, '2014-02-15 00:37:28.000000', 'temperatura', 583.0000, 'ºC'),
	(191425, 118, '2014-02-15 00:37:29.000000', 'temperatura', 121.0000, 'ºC'),
	(191426, 118, '2014-02-15 00:37:30.000000', 'temperatura', 58.0000, 'ºC'),
	(191427, 118, '2014-02-15 00:37:31.000000', 'temperatura', 1126.0000, 'ºC'),
	(191428, 118, '2014-02-15 00:37:32.000000', 'temperatura', 656.0000, 'ºC'),
	(191429, 118, '2014-02-15 00:37:33.000000', 'temperatura', 1105.0000, 'ºC'),
	(191430, 118, '2014-02-15 00:37:34.000000', 'temperatura', 1154.0000, 'ºC'),
	(191431, 118, '2014-02-15 00:37:35.000000', 'temperatura', 58.0000, 'ºC'),
	(191432, 118, '2014-02-15 00:37:36.000000', 'temperatura', 428.0000, 'ºC'),
	(191433, 118, '2014-02-15 00:37:37.000000', 'temperatura', 768.0000, 'ºC'),
	(191434, 118, '2014-02-15 00:37:38.000000', 'temperatura', 156.0000, 'ºC'),
	(191435, 118, '2014-02-15 00:37:39.000000', 'temperatura', 875.0000, 'ºC'),
	(191436, 118, '2014-02-15 00:37:40.000000', 'temperatura', 307.0000, 'ºC'),
	(191437, 118, '2014-02-15 00:37:41.000000', 'temperatura', 110.0000, 'ºC'),
	(191438, 118, '2014-02-15 00:37:42.000000', 'temperatura', 830.0000, 'ºC'),
	(191439, 118, '2014-02-15 00:37:43.000000', 'temperatura', 219.0000, 'ºC'),
	(191440, 118, '2014-02-15 00:37:44.000000', 'temperatura', 1007.0000, 'ºC'),
	(191441, 118, '2014-02-15 00:37:45.000000', 'temperatura', 778.0000, 'ºC'),
	(191442, 118, '2014-02-15 00:37:46.000000', 'temperatura', 868.0000, 'ºC'),
	(191443, 118, '2014-02-15 00:37:47.000000', 'temperatura', 807.0000, 'ºC'),
	(191444, 118, '2014-02-15 00:37:48.000000', 'temperatura', 232.0000, 'ºC'),
	(191445, 118, '2014-02-15 00:37:49.000000', 'temperatura', 1140.0000, 'ºC'),
	(191446, 118, '2014-02-15 00:37:50.000000', 'temperatura', 205.0000, 'ºC'),
	(191447, 118, '2014-02-15 00:37:51.000000', 'temperatura', 4.0000, 'ºC'),
	(191448, 118, '2014-02-15 00:37:52.000000', 'temperatura', 608.0000, 'ºC'),
	(191449, 118, '2014-02-15 00:37:53.000000', 'temperatura', 627.0000, 'ºC'),
	(191450, 118, '2014-02-15 00:37:54.000000', 'temperatura', 113.0000, 'ºC'),
	(191451, 118, '2014-02-15 00:37:55.000000', 'temperatura', 1084.0000, 'ºC'),
	(191452, 118, '2014-02-15 00:37:56.000000', 'temperatura', 280.0000, 'ºC'),
	(191453, 118, '2014-02-15 00:37:57.000000', 'temperatura', 547.0000, 'ºC'),
	(191454, 118, '2014-02-15 00:37:58.000000', 'temperatura', 699.0000, 'ºC'),
	(191455, 118, '2014-02-15 00:37:59.000000', 'temperatura', 654.0000, 'ºC'),
	(191456, 118, '2014-02-15 00:38:00.000000', 'temperatura', 1171.0000, 'ºC'),
	(191457, 118, '2014-02-15 00:38:01.000000', 'temperatura', 297.0000, 'ºC'),
	(191458, 118, '2014-02-15 00:38:02.000000', 'temperatura', 369.0000, 'ºC'),
	(191459, 118, '2014-02-15 00:38:03.000000', 'temperatura', 956.0000, 'ºC'),
	(191460, 118, '2014-02-15 00:38:04.000000', 'temperatura', 75.0000, 'ºC'),
	(191461, 118, '2014-02-15 00:38:05.000000', 'temperatura', 1106.0000, 'ºC'),
	(191462, 118, '2014-02-15 00:38:06.000000', 'temperatura', 504.0000, 'ºC'),
	(191463, 118, '2014-02-15 00:38:07.000000', 'temperatura', 403.0000, 'ºC'),
	(191464, 118, '2014-02-15 00:38:08.000000', 'temperatura', 504.0000, 'ºC'),
	(191465, 118, '2014-02-15 00:38:09.000000', 'temperatura', 111.0000, 'ºC'),
	(191466, 118, '2014-02-15 00:38:10.000000', 'temperatura', 244.0000, 'ºC'),
	(191467, 118, '2014-02-15 00:38:11.000000', 'temperatura', 889.0000, 'ºC'),
	(191468, 118, '2014-02-15 00:38:12.000000', 'temperatura', 114.0000, 'ºC'),
	(191469, 118, '2014-02-15 00:38:13.000000', 'temperatura', 303.0000, 'ºC'),
	(191470, 118, '2014-02-15 00:38:14.000000', 'temperatura', 1172.0000, 'ºC'),
	(191471, 118, '2014-02-15 00:38:15.000000', 'temperatura', 154.0000, 'ºC'),
	(191472, 118, '2014-02-15 00:38:16.000000', 'temperatura', 853.0000, 'ºC'),
	(191473, 118, '2014-02-15 00:38:17.000000', 'temperatura', 204.0000, 'ºC'),
	(191474, 118, '2014-02-15 00:38:18.000000', 'temperatura', 862.0000, 'ºC'),
	(191475, 118, '2014-02-15 00:38:19.000000', 'temperatura', 97.0000, 'ºC'),
	(191476, 118, '2014-02-15 00:38:20.000000', 'temperatura', 299.0000, 'ºC'),
	(191477, 118, '2014-02-15 00:38:21.000000', 'temperatura', 4.0000, 'ºC'),
	(191478, 118, '2014-02-15 00:38:22.000000', 'temperatura', 324.0000, 'ºC'),
	(191479, 118, '2014-02-15 00:38:23.000000', 'temperatura', 407.0000, 'ºC'),
	(191480, 118, '2014-02-15 00:38:24.000000', 'temperatura', 1066.0000, 'ºC'),
	(191481, 118, '2014-02-15 00:38:25.000000', 'temperatura', 510.0000, 'ºC'),
	(191482, 118, '2014-02-15 00:38:26.000000', 'temperatura', 553.0000, 'ºC'),
	(191483, 118, '2014-02-15 00:38:27.000000', 'temperatura', 34.0000, 'ºC'),
	(191484, 118, '2014-02-15 00:38:28.000000', 'temperatura', 912.0000, 'ºC'),
	(191485, 118, '2014-02-15 00:38:29.000000', 'temperatura', 858.0000, 'ºC'),
	(191486, 118, '2014-02-15 00:38:30.000000', 'temperatura', 353.0000, 'ºC'),
	(191487, 118, '2014-02-15 00:38:31.000000', 'temperatura', 393.0000, 'ºC'),
	(191488, 118, '2014-02-15 00:38:32.000000', 'temperatura', 905.0000, 'ºC'),
	(191489, 118, '2014-02-15 00:38:33.000000', 'temperatura', 949.0000, 'ºC'),
	(191490, 118, '2014-02-15 00:38:34.000000', 'temperatura', 831.0000, 'ºC'),
	(191491, 118, '2014-02-15 00:38:35.000000', 'temperatura', 109.0000, 'ºC'),
	(191492, 118, '2014-02-15 00:38:36.000000', 'temperatura', 451.0000, 'ºC'),
	(191493, 118, '2014-02-15 00:38:37.000000', 'temperatura', 727.0000, 'ºC'),
	(191494, 118, '2014-02-15 00:38:38.000000', 'temperatura', 1084.0000, 'ºC'),
	(191495, 118, '2014-02-15 00:38:39.000000', 'temperatura', 840.0000, 'ºC'),
	(191496, 118, '2014-02-15 00:38:40.000000', 'temperatura', 948.0000, 'ºC'),
	(191497, 118, '2014-02-15 00:38:41.000000', 'temperatura', 1019.0000, 'ºC'),
	(191498, 118, '2014-02-15 00:38:42.000000', 'temperatura', 1054.0000, 'ºC'),
	(191499, 118, '2014-02-15 00:38:43.000000', 'temperatura', 1014.0000, 'ºC'),
	(191500, 118, '2014-02-15 00:38:44.000000', 'temperatura', 709.0000, 'ºC'),
	(191501, 118, '2014-02-15 00:38:45.000000', 'temperatura', 502.0000, 'ºC'),
	(191502, 118, '2014-02-15 00:38:46.000000', 'temperatura', 382.0000, 'ºC'),
	(191503, 118, '2014-02-15 00:38:47.000000', 'temperatura', 407.0000, 'ºC'),
	(191504, 118, '2014-02-15 00:38:48.000000', 'temperatura', 889.0000, 'ºC'),
	(191505, 118, '2014-02-15 00:38:49.000000', 'temperatura', 823.0000, 'ºC'),
	(191506, 118, '2014-02-15 00:38:50.000000', 'temperatura', 250.0000, 'ºC'),
	(191507, 118, '2014-02-15 00:38:51.000000', 'temperatura', 1180.0000, 'ºC'),
	(191508, 118, '2014-02-15 00:38:52.000000', 'temperatura', 351.0000, 'ºC'),
	(191509, 118, '2014-02-15 00:38:53.000000', 'temperatura', 615.0000, 'ºC'),
	(191510, 118, '2014-02-15 00:38:54.000000', 'temperatura', 823.0000, 'ºC'),
	(191511, 118, '2014-02-15 00:38:55.000000', 'temperatura', 1069.0000, 'ºC'),
	(191512, 118, '2014-02-15 00:38:56.000000', 'temperatura', 478.0000, 'ºC'),
	(191513, 118, '2014-02-15 00:38:57.000000', 'temperatura', 384.0000, 'ºC'),
	(191514, 118, '2014-02-15 00:38:58.000000', 'temperatura', 487.0000, 'ºC'),
	(191515, 118, '2014-02-15 00:38:59.000000', 'temperatura', 83.0000, 'ºC'),
	(191516, 118, '2014-02-15 00:39:00.000000', 'temperatura', 154.0000, 'ºC'),
	(191517, 118, '2014-02-15 00:39:01.000000', 'temperatura', 522.0000, 'ºC'),
	(191518, 118, '2014-02-15 00:39:02.000000', 'temperatura', 949.0000, 'ºC'),
	(191519, 118, '2014-02-15 00:39:03.000000', 'temperatura', 781.0000, 'ºC'),
	(191520, 118, '2014-02-15 00:39:04.000000', 'temperatura', 1058.0000, 'ºC'),
	(191521, 118, '2014-02-15 00:39:05.000000', 'temperatura', 545.0000, 'ºC'),
	(191522, 118, '2014-02-15 00:39:06.000000', 'temperatura', 753.0000, 'ºC'),
	(191523, 118, '2014-02-15 00:39:07.000000', 'temperatura', 930.0000, 'ºC'),
	(191524, 118, '2014-02-15 00:39:08.000000', 'temperatura', 1191.0000, 'ºC'),
	(191525, 118, '2014-02-15 00:39:09.000000', 'temperatura', 768.0000, 'ºC'),
	(191526, 118, '2014-02-15 00:39:10.000000', 'temperatura', 266.0000, 'ºC'),
	(191527, 118, '2014-02-15 00:39:11.000000', 'temperatura', 225.0000, 'ºC'),
	(191528, 118, '2014-02-15 00:39:12.000000', 'temperatura', 331.0000, 'ºC'),
	(191529, 118, '2014-02-15 00:39:13.000000', 'temperatura', 978.0000, 'ºC'),
	(191530, 118, '2014-02-15 00:39:14.000000', 'temperatura', 297.0000, 'ºC'),
	(191531, 118, '2014-02-15 00:39:15.000000', 'temperatura', 953.0000, 'ºC'),
	(191532, 118, '2014-02-15 00:39:16.000000', 'temperatura', 272.0000, 'ºC'),
	(191533, 118, '2014-02-15 00:39:17.000000', 'temperatura', 903.0000, 'ºC'),
	(191534, 118, '2014-02-15 00:39:18.000000', 'temperatura', 98.0000, 'ºC'),
	(191535, 118, '2014-02-15 00:39:19.000000', 'temperatura', 184.0000, 'ºC'),
	(191536, 118, '2014-02-15 00:39:20.000000', 'temperatura', 625.0000, 'ºC'),
	(191537, 118, '2014-02-15 00:39:21.000000', 'temperatura', 173.0000, 'ºC'),
	(191538, 118, '2014-02-15 00:39:22.000000', 'temperatura', 190.0000, 'ºC'),
	(191539, 118, '2014-02-15 00:39:23.000000', 'temperatura', 431.0000, 'ºC'),
	(191540, 118, '2014-02-15 00:39:24.000000', 'temperatura', 388.0000, 'ºC'),
	(191541, 118, '2014-02-15 00:39:25.000000', 'temperatura', 648.0000, 'ºC'),
	(191542, 118, '2014-02-15 00:39:26.000000', 'temperatura', 874.0000, 'ºC'),
	(191543, 118, '2014-02-15 00:39:27.000000', 'temperatura', 29.0000, 'ºC'),
	(191544, 118, '2014-02-15 00:39:28.000000', 'temperatura', 1125.0000, 'ºC'),
	(191545, 118, '2014-02-15 00:39:29.000000', 'temperatura', 735.0000, 'ºC'),
	(191546, 118, '2014-02-15 00:39:30.000000', 'temperatura', 300.0000, 'ºC'),
	(191547, 118, '2014-02-15 00:39:31.000000', 'temperatura', 499.0000, 'ºC'),
	(191548, 118, '2014-02-15 00:39:32.000000', 'temperatura', 393.0000, 'ºC'),
	(191549, 118, '2014-02-15 00:39:33.000000', 'temperatura', 468.0000, 'ºC'),
	(191550, 118, '2014-02-15 00:39:34.000000', 'temperatura', 1164.0000, 'ºC'),
	(191551, 118, '2014-02-15 00:39:35.000000', 'temperatura', 813.0000, 'ºC'),
	(191552, 118, '2014-02-15 00:39:36.000000', 'temperatura', 576.0000, 'ºC'),
	(191553, 118, '2014-02-15 00:39:37.000000', 'temperatura', 443.0000, 'ºC'),
	(191554, 118, '2014-02-15 00:39:38.000000', 'temperatura', 485.0000, 'ºC'),
	(191555, 118, '2014-02-15 00:39:39.000000', 'temperatura', 1098.0000, 'ºC'),
	(191556, 118, '2014-02-15 00:39:40.000000', 'temperatura', 435.0000, 'ºC'),
	(191557, 118, '2014-02-15 00:39:41.000000', 'temperatura', 83.0000, 'ºC'),
	(191558, 118, '2014-02-15 00:39:42.000000', 'temperatura', 308.0000, 'ºC'),
	(191559, 118, '2014-02-15 00:39:43.000000', 'temperatura', 93.0000, 'ºC'),
	(191560, 118, '2014-02-15 00:39:44.000000', 'temperatura', 742.0000, 'ºC'),
	(191561, 118, '2014-02-15 00:39:45.000000', 'temperatura', 1029.0000, 'ºC'),
	(191562, 118, '2014-02-15 00:39:46.000000', 'temperatura', 523.0000, 'ºC'),
	(191563, 118, '2014-02-15 00:39:47.000000', 'temperatura', 725.0000, 'ºC'),
	(191564, 118, '2014-02-15 00:39:48.000000', 'temperatura', 859.0000, 'ºC'),
	(191565, 118, '2014-02-15 00:39:49.000000', 'temperatura', 920.0000, 'ºC'),
	(191566, 118, '2014-02-15 00:39:50.000000', 'temperatura', 823.0000, 'ºC'),
	(191567, 118, '2014-02-15 00:39:51.000000', 'temperatura', 157.0000, 'ºC'),
	(191568, 118, '2014-02-15 00:39:52.000000', 'temperatura', 714.0000, 'ºC'),
	(191569, 118, '2014-02-15 00:39:53.000000', 'temperatura', 700.0000, 'ºC'),
	(191570, 118, '2014-02-15 00:39:54.000000', 'temperatura', 160.0000, 'ºC'),
	(191571, 118, '2014-02-15 00:39:55.000000', 'temperatura', 1100.0000, 'ºC'),
	(191572, 118, '2014-02-15 00:39:56.000000', 'temperatura', 220.0000, 'ºC'),
	(191573, 118, '2014-02-15 00:39:57.000000', 'temperatura', 199.0000, 'ºC'),
	(191574, 118, '2014-02-15 00:39:58.000000', 'temperatura', 336.0000, 'ºC'),
	(191575, 118, '2014-02-15 00:39:59.000000', 'temperatura', 1085.0000, 'ºC'),
	(191576, 118, '2014-02-15 00:40:00.000000', 'temperatura', 815.0000, 'ºC'),
	(191577, 118, '2014-02-15 00:40:01.000000', 'temperatura', 822.0000, 'ºC'),
	(191578, 118, '2014-02-15 00:40:02.000000', 'temperatura', 466.0000, 'ºC'),
	(191579, 118, '2014-02-15 00:40:03.000000', 'temperatura', 1063.0000, 'ºC'),
	(191580, 118, '2014-02-15 00:40:04.000000', 'temperatura', 319.0000, 'ºC'),
	(191581, 118, '2014-02-15 00:40:05.000000', 'temperatura', 807.0000, 'ºC'),
	(191582, 118, '2014-02-15 00:40:06.000000', 'temperatura', 678.0000, 'ºC'),
	(191583, 118, '2014-02-15 00:40:07.000000', 'temperatura', 969.0000, 'ºC'),
	(191584, 118, '2014-02-15 00:40:08.000000', 'temperatura', 413.0000, 'ºC'),
	(191585, 118, '2014-02-15 00:40:09.000000', 'temperatura', 360.0000, 'ºC'),
	(191586, 118, '2014-02-15 00:40:10.000000', 'temperatura', 558.0000, 'ºC'),
	(191587, 118, '2014-02-15 00:40:11.000000', 'temperatura', 513.0000, 'ºC'),
	(191588, 118, '2014-02-15 00:40:12.000000', 'temperatura', 892.0000, 'ºC'),
	(191589, 118, '2014-02-15 00:40:13.000000', 'temperatura', 521.0000, 'ºC'),
	(191590, 118, '2014-02-15 00:40:14.000000', 'temperatura', 1128.0000, 'ºC'),
	(191591, 118, '2014-02-15 00:40:15.000000', 'temperatura', 477.0000, 'ºC'),
	(191592, 118, '2014-02-15 00:40:16.000000', 'temperatura', 204.0000, 'ºC'),
	(191593, 118, '2014-02-15 00:40:17.000000', 'temperatura', 786.0000, 'ºC'),
	(191594, 118, '2014-02-15 00:40:18.000000', 'temperatura', 922.0000, 'ºC'),
	(191595, 118, '2014-02-15 00:40:19.000000', 'temperatura', 1050.0000, 'ºC'),
	(191596, 118, '2014-02-15 00:40:20.000000', 'temperatura', 83.0000, 'ºC'),
	(191597, 118, '2014-02-15 00:40:21.000000', 'temperatura', 868.0000, 'ºC'),
	(191598, 118, '2014-02-15 00:40:22.000000', 'temperatura', 491.0000, 'ºC'),
	(191599, 118, '2014-02-15 00:40:23.000000', 'temperatura', 1052.0000, 'ºC'),
	(191600, 118, '2014-02-15 00:40:24.000000', 'temperatura', 189.0000, 'ºC'),
	(191601, 118, '2014-02-15 00:40:25.000000', 'temperatura', 188.0000, 'ºC'),
	(191602, 118, '2014-02-15 00:40:26.000000', 'temperatura', 373.0000, 'ºC'),
	(191603, 118, '2014-02-15 00:40:27.000000', 'temperatura', 100.0000, 'ºC'),
	(191604, 118, '2014-02-15 00:40:28.000000', 'temperatura', 582.0000, 'ºC'),
	(191605, 118, '2014-02-15 00:40:29.000000', 'temperatura', 213.0000, 'ºC'),
	(191606, 118, '2014-02-15 00:40:30.000000', 'temperatura', 518.0000, 'ºC'),
	(191607, 118, '2014-02-15 00:40:31.000000', 'temperatura', 751.0000, 'ºC'),
	(191608, 118, '2014-02-15 00:40:32.000000', 'temperatura', 1000.0000, 'ºC'),
	(191609, 118, '2014-02-15 00:40:33.000000', 'temperatura', 349.0000, 'ºC'),
	(191610, 118, '2014-02-15 00:40:34.000000', 'temperatura', 1145.0000, 'ºC'),
	(191611, 118, '2014-02-15 00:40:35.000000', 'temperatura', 1079.0000, 'ºC'),
	(191612, 118, '2014-02-15 00:40:36.000000', 'temperatura', 760.0000, 'ºC'),
	(191613, 118, '2014-02-15 00:40:37.000000', 'temperatura', 562.0000, 'ºC'),
	(191614, 118, '2014-02-15 00:40:38.000000', 'temperatura', 532.0000, 'ºC'),
	(191615, 118, '2014-02-15 00:40:39.000000', 'temperatura', 975.0000, 'ºC'),
	(191616, 118, '2014-02-15 00:40:40.000000', 'temperatura', 881.0000, 'ºC'),
	(191617, 118, '2014-02-15 00:40:41.000000', 'temperatura', 278.0000, 'ºC'),
	(191618, 118, '2014-02-15 00:40:42.000000', 'temperatura', 1150.0000, 'ºC'),
	(191619, 118, '2014-02-15 00:40:43.000000', 'temperatura', 114.0000, 'ºC'),
	(191620, 118, '2014-02-15 00:40:44.000000', 'temperatura', 721.0000, 'ºC'),
	(191621, 118, '2014-02-15 00:40:45.000000', 'temperatura', 863.0000, 'ºC'),
	(191622, 118, '2014-02-15 00:40:46.000000', 'temperatura', 955.0000, 'ºC'),
	(191623, 118, '2014-02-15 00:40:47.000000', 'temperatura', 985.0000, 'ºC'),
	(191624, 118, '2014-02-15 00:40:48.000000', 'temperatura', 863.0000, 'ºC'),
	(191625, 118, '2014-02-15 00:40:49.000000', 'temperatura', 158.0000, 'ºC'),
	(191626, 118, '2014-02-15 00:40:50.000000', 'temperatura', 601.0000, 'ºC'),
	(191627, 118, '2014-02-15 00:40:51.000000', 'temperatura', 130.0000, 'ºC'),
	(191628, 118, '2014-02-15 00:40:52.000000', 'temperatura', 51.0000, 'ºC'),
	(191629, 118, '2014-02-15 00:40:53.000000', 'temperatura', 1064.0000, 'ºC'),
	(191630, 118, '2014-02-15 00:40:54.000000', 'temperatura', 369.0000, 'ºC'),
	(191631, 118, '2014-02-15 00:40:55.000000', 'temperatura', 1053.0000, 'ºC'),
	(191632, 118, '2014-02-15 00:40:56.000000', 'temperatura', 559.0000, 'ºC'),
	(191633, 118, '2014-02-15 00:40:57.000000', 'temperatura', 837.0000, 'ºC'),
	(191634, 118, '2014-02-15 00:40:58.000000', 'temperatura', 109.0000, 'ºC'),
	(191635, 118, '2014-02-15 00:40:59.000000', 'temperatura', 435.0000, 'ºC'),
	(191636, 118, '2014-02-15 00:41:00.000000', 'temperatura', 649.0000, 'ºC'),
	(191637, 118, '2014-02-15 00:41:01.000000', 'temperatura', 740.0000, 'ºC'),
	(191638, 118, '2014-02-15 00:41:02.000000', 'temperatura', 554.0000, 'ºC'),
	(191639, 118, '2014-02-15 00:41:03.000000', 'temperatura', 549.0000, 'ºC'),
	(191640, 118, '2014-02-15 00:41:04.000000', 'temperatura', 1082.0000, 'ºC'),
	(191641, 118, '2014-02-15 00:41:05.000000', 'temperatura', 166.0000, 'ºC'),
	(191642, 118, '2014-02-15 00:41:06.000000', 'temperatura', 1182.0000, 'ºC'),
	(191643, 118, '2014-02-15 00:41:07.000000', 'temperatura', 613.0000, 'ºC'),
	(191644, 118, '2014-02-15 00:41:08.000000', 'temperatura', 722.0000, 'ºC'),
	(191645, 118, '2014-02-15 00:41:09.000000', 'temperatura', 569.0000, 'ºC'),
	(191646, 118, '2014-02-15 00:41:10.000000', 'temperatura', 682.0000, 'ºC'),
	(191647, 118, '2014-02-15 00:41:11.000000', 'temperatura', 503.0000, 'ºC'),
	(191648, 118, '2014-02-15 00:41:12.000000', 'temperatura', 469.0000, 'ºC'),
	(191649, 118, '2014-02-15 00:41:13.000000', 'temperatura', 837.0000, 'ºC'),
	(191650, 118, '2014-02-15 00:41:14.000000', 'temperatura', 379.0000, 'ºC'),
	(191651, 118, '2014-02-15 00:41:15.000000', 'temperatura', 584.0000, 'ºC'),
	(191652, 118, '2014-02-15 00:41:16.000000', 'temperatura', 581.0000, 'ºC'),
	(191653, 118, '2014-02-15 00:41:17.000000', 'temperatura', 1157.0000, 'ºC'),
	(191654, 118, '2014-02-15 00:41:18.000000', 'temperatura', 440.0000, 'ºC'),
	(191655, 118, '2014-02-15 00:41:19.000000', 'temperatura', 1129.0000, 'ºC'),
	(191656, 118, '2014-02-15 00:41:20.000000', 'temperatura', 725.0000, 'ºC'),
	(191657, 118, '2014-02-15 00:41:21.000000', 'temperatura', 239.0000, 'ºC'),
	(191658, 118, '2014-02-15 00:41:22.000000', 'temperatura', 221.0000, 'ºC'),
	(191659, 118, '2014-02-15 00:41:23.000000', 'temperatura', 388.0000, 'ºC'),
	(191660, 118, '2014-02-15 00:41:24.000000', 'temperatura', 77.0000, 'ºC'),
	(191661, 118, '2014-02-15 00:41:25.000000', 'temperatura', 423.0000, 'ºC'),
	(191662, 118, '2014-02-15 00:41:26.000000', 'temperatura', 684.0000, 'ºC'),
	(191663, 118, '2014-02-15 00:41:27.000000', 'temperatura', 952.0000, 'ºC'),
	(191664, 118, '2014-02-15 00:41:28.000000', 'temperatura', 309.0000, 'ºC'),
	(191665, 118, '2014-02-15 00:41:29.000000', 'temperatura', 1089.0000, 'ºC'),
	(191666, 118, '2014-02-15 00:41:30.000000', 'temperatura', 919.0000, 'ºC'),
	(191667, 118, '2014-02-15 00:41:31.000000', 'temperatura', 130.0000, 'ºC'),
	(191668, 118, '2014-02-15 00:41:32.000000', 'temperatura', 293.0000, 'ºC'),
	(191669, 118, '2014-02-15 00:41:33.000000', 'temperatura', 1075.0000, 'ºC'),
	(191670, 118, '2014-02-15 00:41:34.000000', 'temperatura', 896.0000, 'ºC'),
	(191671, 118, '2014-02-15 00:41:35.000000', 'temperatura', 57.0000, 'ºC'),
	(191672, 118, '2014-02-15 00:41:36.000000', 'temperatura', 1195.0000, 'ºC'),
	(191673, 118, '2014-02-15 00:41:37.000000', 'temperatura', 1006.0000, 'ºC'),
	(191674, 118, '2014-02-15 00:41:38.000000', 'temperatura', 245.0000, 'ºC'),
	(191675, 118, '2014-02-15 00:41:39.000000', 'temperatura', 608.0000, 'ºC'),
	(191676, 118, '2014-02-15 00:41:40.000000', 'temperatura', 1105.0000, 'ºC'),
	(191677, 118, '2014-02-15 00:41:41.000000', 'temperatura', 104.0000, 'ºC'),
	(191678, 118, '2014-02-15 00:41:42.000000', 'temperatura', 802.0000, 'ºC'),
	(191679, 118, '2014-02-15 00:41:43.000000', 'temperatura', 100.0000, 'ºC'),
	(191680, 118, '2014-02-15 00:41:44.000000', 'temperatura', 495.0000, 'ºC'),
	(191681, 118, '2014-02-15 00:41:45.000000', 'temperatura', 977.0000, 'ºC'),
	(191682, 118, '2014-02-15 00:41:46.000000', 'temperatura', 998.0000, 'ºC'),
	(191683, 118, '2014-02-15 00:41:47.000000', 'temperatura', 860.0000, 'ºC'),
	(191684, 118, '2014-02-15 00:41:48.000000', 'temperatura', 107.0000, 'ºC'),
	(191685, 118, '2014-02-15 00:41:49.000000', 'temperatura', 355.0000, 'ºC'),
	(191686, 118, '2014-02-15 00:41:50.000000', 'temperatura', 256.0000, 'ºC'),
	(191687, 118, '2014-02-15 00:41:51.000000', 'temperatura', 213.0000, 'ºC'),
	(191688, 118, '2014-02-15 00:41:52.000000', 'temperatura', 297.0000, 'ºC'),
	(191689, 118, '2014-02-15 00:41:53.000000', 'temperatura', 848.0000, 'ºC'),
	(191690, 118, '2014-02-15 00:41:54.000000', 'temperatura', 950.0000, 'ºC'),
	(191691, 118, '2014-02-15 00:41:55.000000', 'temperatura', 1006.0000, 'ºC'),
	(191692, 118, '2014-02-15 00:41:56.000000', 'temperatura', 980.0000, 'ºC'),
	(191693, 118, '2014-02-15 00:41:57.000000', 'temperatura', 682.0000, 'ºC'),
	(191694, 118, '2014-02-15 00:41:58.000000', 'temperatura', 473.0000, 'ºC'),
	(191695, 118, '2014-02-15 00:41:59.000000', 'temperatura', 317.0000, 'ºC'),
	(191696, 118, '2014-02-15 00:42:00.000000', 'temperatura', 169.0000, 'ºC'),
	(191697, 118, '2014-02-15 00:42:01.000000', 'temperatura', 1094.0000, 'ºC'),
	(191698, 118, '2014-02-15 00:42:02.000000', 'temperatura', 164.0000, 'ºC'),
	(191699, 118, '2014-02-15 00:42:03.000000', 'temperatura', 1136.0000, 'ºC'),
	(191700, 118, '2014-02-15 00:42:04.000000', 'temperatura', 390.0000, 'ºC'),
	(191701, 118, '2014-02-15 00:42:05.000000', 'temperatura', 942.0000, 'ºC'),
	(191702, 118, '2014-02-15 00:42:06.000000', 'temperatura', 1143.0000, 'ºC'),
	(191703, 118, '2014-02-15 00:42:07.000000', 'temperatura', 487.0000, 'ºC'),
	(191704, 118, '2014-02-15 00:42:08.000000', 'temperatura', 206.0000, 'ºC'),
	(191705, 118, '2014-02-15 00:42:09.000000', 'temperatura', 771.0000, 'ºC'),
	(191706, 118, '2014-02-15 00:42:10.000000', 'temperatura', 836.0000, 'ºC'),
	(191707, 118, '2014-02-15 00:42:11.000000', 'temperatura', 668.0000, 'ºC'),
	(191708, 118, '2014-02-15 00:42:12.000000', 'temperatura', 832.0000, 'ºC'),
	(191709, 118, '2014-02-15 00:42:13.000000', 'temperatura', 956.0000, 'ºC'),
	(191710, 118, '2014-02-15 00:42:14.000000', 'temperatura', 1086.0000, 'ºC'),
	(191711, 118, '2014-02-15 00:42:15.000000', 'temperatura', 161.0000, 'ºC'),
	(191712, 118, '2014-02-15 00:42:16.000000', 'temperatura', 1149.0000, 'ºC'),
	(191713, 118, '2014-02-15 00:42:17.000000', 'temperatura', 464.0000, 'ºC'),
	(191714, 118, '2014-02-15 00:42:18.000000', 'temperatura', 72.0000, 'ºC'),
	(191715, 118, '2014-02-15 00:42:19.000000', 'temperatura', 168.0000, 'ºC'),
	(191716, 118, '2014-02-15 00:42:20.000000', 'temperatura', 626.0000, 'ºC'),
	(191717, 118, '2014-02-15 00:42:21.000000', 'temperatura', 225.0000, 'ºC'),
	(191718, 118, '2014-02-15 00:42:22.000000', 'temperatura', 450.0000, 'ºC'),
	(191719, 118, '2014-02-15 00:42:23.000000', 'temperatura', 373.0000, 'ºC'),
	(191720, 118, '2014-02-15 00:42:24.000000', 'temperatura', 514.0000, 'ºC'),
	(191721, 118, '2014-02-15 00:42:25.000000', 'temperatura', 254.0000, 'ºC'),
	(191722, 118, '2014-02-15 00:42:26.000000', 'temperatura', 929.0000, 'ºC'),
	(191723, 118, '2014-02-15 00:42:27.000000', 'temperatura', 283.0000, 'ºC'),
	(191724, 118, '2014-02-15 00:42:28.000000', 'temperatura', 1028.0000, 'ºC'),
	(191725, 118, '2014-02-15 00:42:29.000000', 'temperatura', 691.0000, 'ºC'),
	(191726, 118, '2014-02-15 00:42:30.000000', 'temperatura', 370.0000, 'ºC'),
	(191727, 118, '2014-02-15 00:42:31.000000', 'temperatura', 980.0000, 'ºC'),
	(191728, 118, '2014-02-15 00:42:32.000000', 'temperatura', 190.0000, 'ºC'),
	(191729, 118, '2014-02-15 00:42:33.000000', 'temperatura', 412.0000, 'ºC'),
	(191730, 118, '2014-02-15 00:42:34.000000', 'temperatura', 288.0000, 'ºC'),
	(191731, 118, '2014-02-15 00:42:35.000000', 'temperatura', 208.0000, 'ºC'),
	(191732, 118, '2014-02-15 00:42:36.000000', 'temperatura', 173.0000, 'ºC'),
	(191733, 118, '2014-02-15 00:42:37.000000', 'temperatura', 242.0000, 'ºC'),
	(191734, 118, '2014-02-15 00:42:38.000000', 'temperatura', 691.0000, 'ºC'),
	(191735, 118, '2014-02-15 00:42:39.000000', 'temperatura', 329.0000, 'ºC'),
	(191736, 118, '2014-02-15 00:42:40.000000', 'temperatura', 772.0000, 'ºC'),
	(191737, 118, '2014-02-15 00:42:41.000000', 'temperatura', 475.0000, 'ºC'),
	(191738, 118, '2014-02-15 00:42:42.000000', 'temperatura', 60.0000, 'ºC'),
	(191739, 118, '2014-02-15 00:42:43.000000', 'temperatura', 74.0000, 'ºC'),
	(191740, 118, '2014-02-15 00:42:44.000000', 'temperatura', 190.0000, 'ºC'),
	(191741, 118, '2014-02-15 00:42:45.000000', 'temperatura', 729.0000, 'ºC'),
	(191742, 118, '2014-02-15 00:42:46.000000', 'temperatura', 675.0000, 'ºC'),
	(191743, 118, '2014-02-15 00:42:47.000000', 'temperatura', 1191.0000, 'ºC'),
	(191744, 118, '2014-02-15 00:42:48.000000', 'temperatura', 328.0000, 'ºC'),
	(191745, 118, '2014-02-15 00:42:49.000000', 'temperatura', 469.0000, 'ºC'),
	(191746, 118, '2014-02-15 00:42:50.000000', 'temperatura', 160.0000, 'ºC'),
	(191747, 118, '2014-02-15 00:42:51.000000', 'temperatura', 595.0000, 'ºC'),
	(191748, 118, '2014-02-15 00:42:52.000000', 'temperatura', 96.0000, 'ºC'),
	(191749, 118, '2014-02-15 00:42:53.000000', 'temperatura', 1097.0000, 'ºC'),
	(191750, 118, '2014-02-15 00:42:54.000000', 'temperatura', 396.0000, 'ºC'),
	(191751, 118, '2014-02-15 00:42:55.000000', 'temperatura', 1087.0000, 'ºC'),
	(191752, 118, '2014-02-15 00:42:56.000000', 'temperatura', 651.0000, 'ºC'),
	(191753, 118, '2014-02-15 00:42:57.000000', 'temperatura', 1193.0000, 'ºC'),
	(191754, 118, '2014-02-15 00:42:58.000000', 'temperatura', 412.0000, 'ºC'),
	(191755, 118, '2014-02-15 00:42:59.000000', 'temperatura', 884.0000, 'ºC'),
	(191756, 118, '2014-02-15 00:43:00.000000', 'temperatura', 783.0000, 'ºC'),
	(191757, 118, '2014-02-15 00:43:01.000000', 'temperatura', 63.0000, 'ºC'),
	(191758, 118, '2014-02-15 00:43:02.000000', 'temperatura', 366.0000, 'ºC'),
	(191759, 118, '2014-02-15 00:43:03.000000', 'temperatura', 444.0000, 'ºC'),
	(191760, 118, '2014-02-15 00:43:04.000000', 'temperatura', 1121.0000, 'ºC'),
	(191761, 118, '2014-02-15 00:43:05.000000', 'temperatura', 675.0000, 'ºC'),
	(191762, 118, '2014-02-15 00:43:06.000000', 'temperatura', 10.0000, 'ºC'),
	(191763, 118, '2014-02-15 00:43:07.000000', 'temperatura', 426.0000, 'ºC'),
	(191764, 118, '2014-02-15 00:43:08.000000', 'temperatura', 900.0000, 'ºC'),
	(191765, 118, '2014-02-15 00:43:09.000000', 'temperatura', 824.0000, 'ºC'),
	(191766, 118, '2014-02-15 00:43:10.000000', 'temperatura', 222.0000, 'ºC'),
	(191767, 118, '2014-02-15 00:43:11.000000', 'temperatura', 1035.0000, 'ºC'),
	(191768, 118, '2014-02-15 00:43:12.000000', 'temperatura', 912.0000, 'ºC'),
	(191769, 118, '2014-02-15 00:43:13.000000', 'temperatura', 256.0000, 'ºC'),
	(191770, 118, '2014-02-15 00:43:14.000000', 'temperatura', 943.0000, 'ºC'),
	(191771, 118, '2014-02-15 00:43:15.000000', 'temperatura', 349.0000, 'ºC'),
	(191772, 118, '2014-02-15 00:43:16.000000', 'temperatura', 115.0000, 'ºC'),
	(191773, 118, '2014-02-15 00:43:17.000000', 'temperatura', 730.0000, 'ºC'),
	(191774, 118, '2014-02-15 00:43:18.000000', 'temperatura', 905.0000, 'ºC'),
	(191775, 118, '2014-02-15 00:43:19.000000', 'temperatura', 1136.0000, 'ºC'),
	(191776, 118, '2014-02-15 00:43:20.000000', 'temperatura', 564.0000, 'ºC'),
	(191777, 118, '2014-02-15 00:43:21.000000', 'temperatura', 614.0000, 'ºC'),
	(191778, 118, '2014-02-15 00:43:22.000000', 'temperatura', 178.0000, 'ºC'),
	(191779, 118, '2014-02-15 00:43:23.000000', 'temperatura', 249.0000, 'ºC'),
	(191780, 118, '2014-02-15 00:43:24.000000', 'temperatura', 713.0000, 'ºC'),
	(191781, 118, '2014-02-15 00:43:25.000000', 'temperatura', 417.0000, 'ºC'),
	(191782, 118, '2014-02-15 00:43:26.000000', 'temperatura', 1147.0000, 'ºC'),
	(191783, 118, '2014-02-15 00:43:27.000000', 'temperatura', 883.0000, 'ºC'),
	(191784, 118, '2014-02-15 00:43:28.000000', 'temperatura', 973.0000, 'ºC'),
	(191785, 118, '2014-02-15 00:43:29.000000', 'temperatura', 1020.0000, 'ºC'),
	(191786, 118, '2014-02-15 00:43:30.000000', 'temperatura', 981.0000, 'ºC'),
	(191787, 118, '2014-02-15 00:43:31.000000', 'temperatura', 646.0000, 'ºC'),
	(191788, 118, '2014-02-15 00:43:32.000000', 'temperatura', 286.0000, 'ºC'),
	(191789, 118, '2014-02-15 00:43:33.000000', 'temperatura', 692.0000, 'ºC'),
	(191790, 118, '2014-02-15 00:43:34.000000', 'temperatura', 202.0000, 'ºC'),
	(191791, 118, '2014-02-15 00:43:35.000000', 'temperatura', 136.0000, 'ºC'),
	(191792, 118, '2014-02-15 00:43:36.000000', 'temperatura', 75.0000, 'ºC'),
	(191793, 118, '2014-02-15 00:43:37.000000', 'temperatura', 1166.0000, 'ºC'),
	(191794, 118, '2014-02-15 00:43:38.000000', 'temperatura', 805.0000, 'ºC'),
	(191795, 118, '2014-02-15 00:43:39.000000', 'temperatura', 528.0000, 'ºC'),
	(191796, 118, '2014-02-15 00:43:40.000000', 'temperatura', 224.0000, 'ºC'),
	(191797, 118, '2014-02-15 00:43:41.000000', 'temperatura', 739.0000, 'ºC'),
	(191798, 118, '2014-02-15 00:43:42.000000', 'temperatura', 623.0000, 'ºC'),
	(191799, 118, '2014-02-15 00:43:43.000000', 'temperatura', 897.0000, 'ºC'),
	(191800, 118, '2014-02-15 00:43:44.000000', 'temperatura', 218.0000, 'ºC'),
	(191801, 118, '2014-02-15 00:43:45.000000', 'temperatura', 797.0000, 'ºC'),
	(191802, 118, '2014-02-15 00:43:46.000000', 'temperatura', 934.0000, 'ºC'),
	(191803, 118, '2014-02-15 00:43:47.000000', 'temperatura', 1077.0000, 'ºC'),
	(191804, 118, '2014-02-15 00:43:48.000000', 'temperatura', 184.0000, 'ºC'),
	(191805, 118, '2014-02-15 00:43:49.000000', 'temperatura', 90.0000, 'ºC'),
	(191806, 118, '2014-02-15 00:43:50.000000', 'temperatura', 1099.0000, 'ºC'),
	(191807, 118, '2014-02-15 00:43:51.000000', 'temperatura', 425.0000, 'ºC'),
	(191808, 118, '2014-02-15 00:43:52.000000', 'temperatura', 30.0000, 'ºC'),
	(191809, 118, '2014-02-15 00:43:53.000000', 'temperatura', 77.0000, 'ºC'),
	(191810, 118, '2014-02-15 00:43:54.000000', 'temperatura', 292.0000, 'ºC'),
	(191811, 118, '2014-02-15 00:43:55.000000', 'temperatura', 29.0000, 'ºC'),
	(191812, 118, '2014-02-15 00:43:56.000000', 'temperatura', 472.0000, 'ºC'),
	(191813, 118, '2014-02-15 00:43:57.000000', 'temperatura', 1071.0000, 'ºC'),
	(191814, 118, '2014-02-15 00:43:58.000000', 'temperatura', 343.0000, 'ºC'),
	(191815, 118, '2014-02-15 00:43:59.000000', 'temperatura', 899.0000, 'ºC'),
	(191816, 118, '2014-02-15 00:44:00.000000', 'temperatura', 1067.0000, 'ºC'),
	(191817, 118, '2014-02-15 00:44:01.000000', 'temperatura', 240.0000, 'ºC'),
	(191818, 118, '2014-02-15 00:44:02.000000', 'temperatura', 398.0000, 'ºC'),
	(191819, 118, '2014-02-15 00:44:03.000000', 'temperatura', 73.0000, 'ºC'),
	(191820, 118, '2014-02-15 00:44:04.000000', 'temperatura', 370.0000, 'ºC'),
	(191821, 118, '2014-02-15 00:44:05.000000', 'temperatura', 432.0000, 'ºC'),
	(191822, 118, '2014-02-15 00:44:06.000000', 'temperatura', 1049.0000, 'ºC'),
	(191823, 118, '2014-02-15 00:44:07.000000', 'temperatura', 349.0000, 'ºC'),
	(191824, 118, '2014-02-15 00:44:08.000000', 'temperatura', 999.0000, 'ºC'),
	(191825, 118, '2014-02-15 00:44:09.000000', 'temperatura', 351.0000, 'ºC'),
	(191826, 118, '2014-02-15 00:44:10.000000', 'temperatura', 1157.0000, 'ºC'),
	(191827, 118, '2014-02-15 00:44:11.000000', 'temperatura', 1131.0000, 'ºC'),
	(191828, 118, '2014-02-15 00:44:12.000000', 'temperatura', 985.0000, 'ºC'),
	(191829, 118, '2014-02-15 00:44:13.000000', 'temperatura', 332.0000, 'ºC'),
	(191830, 118, '2014-02-15 00:44:14.000000', 'temperatura', 1106.0000, 'ºC'),
	(191831, 118, '2014-02-15 00:44:15.000000', 'temperatura', 935.0000, 'ºC'),
	(191832, 118, '2014-02-15 00:44:16.000000', 'temperatura', 155.0000, 'ºC'),
	(191833, 118, '2014-02-15 00:44:17.000000', 'temperatura', 373.0000, 'ºC'),
	(191834, 118, '2014-02-15 00:44:18.000000', 'temperatura', 198.0000, 'ºC'),
	(191835, 118, '2014-02-15 00:44:19.000000', 'temperatura', 1075.0000, 'ºC'),
	(191836, 118, '2014-02-15 00:44:20.000000', 'temperatura', 1179.0000, 'ºC'),
	(191837, 118, '2014-02-15 00:44:21.000000', 'temperatura', 269.0000, 'ºC'),
	(191838, 118, '2014-02-15 00:44:22.000000', 'temperatura', 210.0000, 'ºC'),
	(191839, 118, '2014-02-15 00:44:23.000000', 'temperatura', 246.0000, 'ºC'),
	(191840, 118, '2014-02-15 00:44:24.000000', 'temperatura', 597.0000, 'ºC'),
	(191841, 118, '2014-02-15 00:44:25.000000', 'temperatura', 1049.0000, 'ºC'),
	(191842, 118, '2014-02-15 00:44:26.000000', 'temperatura', 1055.0000, 'ºC'),
	(191843, 118, '2014-02-15 00:44:27.000000', 'temperatura', 929.0000, 'ºC'),
	(191844, 118, '2014-02-15 00:44:28.000000', 'temperatura', 281.0000, 'ºC'),
	(191845, 118, '2014-02-15 00:44:29.000000', 'temperatura', 1017.0000, 'ºC'),
	(191846, 118, '2014-02-15 00:44:30.000000', 'temperatura', 641.0000, 'ºC'),
	(191847, 118, '2014-02-15 00:44:31.000000', 'temperatura', 156.0000, 'ºC'),
	(191848, 118, '2014-02-15 00:44:32.000000', 'temperatura', 56.0000, 'ºC'),
	(191849, 118, '2014-02-15 00:44:33.000000', 'temperatura', 1014.0000, 'ºC'),
	(191850, 118, '2014-02-15 00:44:34.000000', 'temperatura', 102.0000, 'ºC'),
	(191851, 118, '2014-02-15 00:44:35.000000', 'temperatura', 1069.0000, 'ºC'),
	(191852, 118, '2014-02-15 00:44:36.000000', 'temperatura', 237.0000, 'ºC'),
	(191853, 118, '2014-02-15 00:44:37.000000', 'temperatura', 381.0000, 'ºC'),
	(191854, 118, '2014-02-15 00:44:38.000000', 'temperatura', 1192.0000, 'ºC'),
	(191855, 118, '2014-02-15 00:44:39.000000', 'temperatura', 21.0000, 'ºC'),
	(191856, 118, '2014-02-15 00:44:40.000000', 'temperatura', 128.0000, 'ºC'),
	(191857, 118, '2014-02-15 00:44:41.000000', 'temperatura', 576.0000, 'ºC'),
	(191858, 118, '2014-02-15 00:44:42.000000', 'temperatura', 97.0000, 'ºC'),
	(191859, 118, '2014-02-15 00:44:43.000000', 'temperatura', 1156.0000, 'ºC'),
	(191860, 118, '2014-02-15 00:44:44.000000', 'temperatura', 691.0000, 'ºC'),
	(191861, 118, '2014-02-15 00:44:45.000000', 'temperatura', 1186.0000, 'ºC'),
	(191862, 118, '2014-02-15 00:44:46.000000', 'temperatura', 258.0000, 'ºC'),
	(191863, 118, '2014-02-15 00:44:47.000000', 'temperatura', 131.0000, 'ºC'),
	(191864, 118, '2014-02-15 00:44:48.000000', 'temperatura', 1083.0000, 'ºC'),
	(191865, 118, '2014-02-15 00:44:49.000000', 'temperatura', 224.0000, 'ºC'),
	(191866, 118, '2014-02-15 00:44:50.000000', 'temperatura', 271.0000, 'ºC'),
	(191867, 118, '2014-02-15 00:44:51.000000', 'temperatura', 683.0000, 'ºC'),
	(191868, 118, '2014-02-15 00:44:52.000000', 'temperatura', 203.0000, 'ºC'),
	(191869, 118, '2014-02-15 00:44:53.000000', 'temperatura', 167.0000, 'ºC'),
	(191870, 118, '2014-02-15 00:44:54.000000', 'temperatura', 225.0000, 'ºC'),
	(191871, 118, '2014-02-15 00:44:55.000000', 'temperatura', 624.0000, 'ºC'),
	(191872, 118, '2014-02-15 00:44:56.000000', 'temperatura', 47.0000, 'ºC'),
	(191873, 118, '2014-02-15 00:44:57.000000', 'temperatura', 764.0000, 'ºC'),
	(191874, 118, '2014-02-15 00:44:58.000000', 'temperatura', 79.0000, 'ºC'),
	(191875, 118, '2014-02-15 00:44:59.000000', 'temperatura', 501.0000, 'ºC'),
	(191876, 118, '2014-02-15 00:45:00.000000', 'temperatura', 1072.0000, 'ºC'),
	(191877, 118, '2014-02-15 00:45:01.000000', 'temperatura', 257.0000, 'ºC'),
	(191878, 118, '2014-02-15 00:45:02.000000', 'temperatura', 470.0000, 'ºC'),
	(191879, 118, '2014-02-15 00:45:03.000000', 'temperatura', 380.0000, 'ºC'),
	(191880, 118, '2014-02-15 00:45:04.000000', 'temperatura', 488.0000, 'ºC'),
	(191881, 118, '2014-02-15 00:45:05.000000', 'temperatura', 102.0000, 'ºC'),
	(191882, 118, '2014-02-15 00:45:06.000000', 'temperatura', 246.0000, 'ºC'),
	(191883, 118, '2014-02-15 00:45:07.000000', 'temperatura', 925.0000, 'ºC'),
	(191884, 118, '2014-02-15 00:45:08.000000', 'temperatura', 287.0000, 'ºC'),
	(191885, 118, '2014-02-15 00:45:09.000000', 'temperatura', 1063.0000, 'ºC'),
	(191886, 118, '2014-02-15 00:45:10.000000', 'temperatura', 851.0000, 'ºC'),
	(191887, 118, '2014-02-15 00:45:11.000000', 'temperatura', 1069.0000, 'ºC'),
	(191888, 118, '2014-02-15 00:45:12.000000', 'temperatura', 392.0000, 'ºC'),
	(191889, 118, '2014-02-15 00:45:13.000000', 'temperatura', 1154.0000, 'ºC'),
	(191890, 118, '2014-02-15 00:45:14.000000', 'temperatura', 992.0000, 'ºC'),
	(191891, 118, '2014-02-15 00:45:15.000000', 'temperatura', 301.0000, 'ºC'),
	(191892, 118, '2014-02-15 00:45:16.000000', 'temperatura', 929.0000, 'ºC'),
	(191893, 118, '2014-02-15 00:45:17.000000', 'temperatura', 141.0000, 'ºC'),
	(191894, 118, '2014-02-15 00:45:18.000000', 'temperatura', 321.0000, 'ºC'),
	(191895, 118, '2014-02-15 00:45:19.000000', 'temperatura', 1181.0000, 'ºC'),
	(191896, 118, '2014-02-15 00:45:20.000000', 'temperatura', 141.0000, 'ºC'),
	(191897, 118, '2014-02-15 00:45:21.000000', 'temperatura', 764.0000, 'ºC'),
	(191898, 118, '2014-02-15 00:45:22.000000', 'temperatura', 996.0000, 'ºC'),
	(191899, 118, '2014-02-15 00:45:23.000000', 'temperatura', 290.0000, 'ºC'),
	(191900, 118, '2014-02-15 00:45:24.000000', 'temperatura', 860.0000, 'ºC'),
	(191901, 118, '2014-02-15 00:45:25.000000', 'temperatura', 1032.0000, 'ºC'),
	(191902, 118, '2014-02-15 00:45:26.000000', 'temperatura', 181.0000, 'ºC'),
	(191903, 118, '2014-02-15 00:45:27.000000', 'temperatura', 211.0000, 'ºC'),
	(191904, 118, '2014-02-15 00:45:28.000000', 'temperatura', 511.0000, 'ºC'),
	(191905, 118, '2014-02-15 00:45:29.000000', 'temperatura', 723.0000, 'ºC'),
	(191906, 118, '2014-02-15 00:45:30.000000', 'temperatura', 883.0000, 'ºC'),
	(191907, 118, '2014-02-15 00:45:31.000000', 'temperatura', 1046.0000, 'ºC'),
	(191908, 118, '2014-02-15 00:45:32.000000', 'temperatura', 183.0000, 'ºC'),
	(191909, 118, '2014-02-15 00:45:33.000000', 'temperatura', 175.0000, 'ºC'),
	(191910, 118, '2014-02-15 00:45:34.000000', 'temperatura', 329.0000, 'ºC'),
	(191911, 118, '2014-02-15 00:45:35.000000', 'temperatura', 1120.0000, 'ºC'),
	(191912, 118, '2014-02-15 00:45:36.000000', 'temperatura', 1012.0000, 'ºC'),
	(191913, 118, '2014-02-15 00:45:37.000000', 'temperatura', 499.0000, 'ºC'),
	(191914, 118, '2014-02-15 00:45:38.000000', 'temperatura', 663.0000, 'ºC'),
	(191915, 118, '2014-02-15 00:45:39.000000', 'temperatura', 618.0000, 'ºC'),
	(191916, 118, '2014-02-15 00:45:40.000000', 'temperatura', 1100.0000, 'ºC'),
	(191917, 118, '2014-02-15 00:45:41.000000', 'temperatura', 45.0000, 'ºC'),
	(191918, 118, '2014-02-15 00:45:42.000000', 'temperatura', 527.0000, 'ºC'),
	(191919, 118, '2014-02-15 00:45:43.000000', 'temperatura', 102.0000, 'ºC'),
	(191920, 118, '2014-02-15 00:45:44.000000', 'temperatura', 130.0000, 'ºC'),
	(191921, 118, '2014-02-15 00:45:45.000000', 'temperatura', 345.0000, 'ºC'),
	(191922, 118, '2014-02-15 00:45:46.000000', 'temperatura', 134.0000, 'ºC'),
	(191923, 118, '2014-02-15 00:45:47.000000', 'temperatura', 834.0000, 'ºC'),
	(191924, 118, '2014-02-15 00:45:48.000000', 'temperatura', 169.0000, 'ºC'),
	(191925, 118, '2014-02-15 00:45:49.000000', 'temperatura', 742.0000, 'ºC'),
	(191926, 118, '2014-02-15 00:45:50.000000', 'temperatura', 805.0000, 'ºC'),
	(191927, 118, '2014-02-15 00:45:51.000000', 'temperatura', 601.0000, 'ºC'),
	(191928, 118, '2014-02-15 00:45:52.000000', 'temperatura', 589.0000, 'ºC'),
	(191929, 118, '2014-02-15 00:45:53.000000', 'temperatura', 1141.0000, 'ºC'),
	(191930, 118, '2014-02-15 00:45:54.000000', 'temperatura', 341.0000, 'ºC'),
	(191931, 118, '2014-02-15 00:45:55.000000', 'temperatura', 680.0000, 'ºC'),
	(191932, 118, '2014-02-15 00:45:56.000000', 'temperatura', 1179.0000, 'ºC'),
	(191933, 118, '2014-02-15 00:45:57.000000', 'temperatura', 253.0000, 'ºC'),
	(191934, 118, '2014-02-15 00:45:58.000000', 'temperatura', 131.0000, 'ºC'),
	(191935, 118, '2014-02-15 00:45:59.000000', 'temperatura', 1094.0000, 'ºC'),
	(191936, 118, '2014-02-15 00:46:00.000000', 'temperatura', 280.0000, 'ºC'),
	(191937, 118, '2014-02-15 00:46:01.000000', 'temperatura', 517.0000, 'ºC'),
	(191938, 118, '2014-02-15 00:46:02.000000', 'temperatura', 545.0000, 'ºC'),
	(191939, 118, '2014-02-15 00:46:03.000000', 'temperatura', 1177.0000, 'ºC'),
	(191940, 118, '2014-02-15 00:46:04.000000', 'temperatura', 649.0000, 'ºC'),
	(191941, 118, '2014-02-15 00:46:05.000000', 'temperatura', 913.0000, 'ºC'),
	(191942, 118, '2014-02-15 00:46:06.000000', 'temperatura', 220.0000, 'ºC'),
	(191943, 118, '2014-02-15 00:46:07.000000', 'temperatura', 763.0000, 'ºC'),
	(191944, 118, '2014-02-15 00:46:08.000000', 'temperatura', 753.0000, 'ºC'),
	(191945, 118, '2014-02-15 00:46:09.000000', 'temperatura', 279.0000, 'ºC'),
	(191946, 118, '2014-02-15 00:46:10.000000', 'temperatura', 336.0000, 'ºC'),
	(191947, 118, '2014-02-15 00:46:11.000000', 'temperatura', 843.0000, 'ºC'),
	(191948, 118, '2014-02-15 00:46:12.000000', 'temperatura', 808.0000, 'ºC'),
	(191949, 118, '2014-02-15 00:46:13.000000', 'temperatura', 309.0000, 'ºC'),
	(191950, 118, '2014-02-15 00:46:14.000000', 'temperatura', 323.0000, 'ºC'),
	(191951, 118, '2014-02-15 00:46:15.000000', 'temperatura', 690.0000, 'ºC'),
	(191952, 118, '2014-02-15 00:46:16.000000', 'temperatura', 79.0000, 'ºC'),
	(191953, 118, '2014-02-15 00:46:17.000000', 'temperatura', 725.0000, 'ºC'),
	(191954, 118, '2014-02-15 00:46:18.000000', 'temperatura', 988.0000, 'ºC'),
	(191955, 118, '2014-02-15 00:46:19.000000', 'temperatura', 367.0000, 'ºC'),
	(191956, 118, '2014-02-15 00:46:20.000000', 'temperatura', 69.0000, 'ºC'),
	(191957, 118, '2014-02-15 00:46:21.000000', 'temperatura', 447.0000, 'ºC'),
	(191958, 118, '2014-02-15 00:46:22.000000', 'temperatura', 828.0000, 'ºC'),
	(191959, 118, '2014-02-15 00:46:23.000000', 'temperatura', 399.0000, 'ºC'),
	(191960, 118, '2014-02-15 00:46:24.000000', 'temperatura', 714.0000, 'ºC'),
	(191961, 118, '2014-02-15 00:46:25.000000', 'temperatura', 1170.0000, 'ºC'),
	(191962, 118, '2014-02-15 00:46:26.000000', 'temperatura', 111.0000, 'ºC'),
	(191963, 118, '2014-02-15 00:46:27.000000', 'temperatura', 647.0000, 'ºC'),
	(191964, 118, '2014-02-15 00:46:28.000000', 'temperatura', 499.0000, 'ºC'),
	(191965, 118, '2014-02-15 00:46:29.000000', 'temperatura', 556.0000, 'ºC'),
	(191966, 118, '2014-02-15 00:46:30.000000', 'temperatura', 82.0000, 'ºC'),
	(191967, 118, '2014-02-15 00:46:31.000000', 'temperatura', 1145.0000, 'ºC'),
	(191968, 118, '2014-02-15 00:46:32.000000', 'temperatura', 677.0000, 'ºC'),
	(191969, 118, '2014-02-15 00:46:33.000000', 'temperatura', 1151.0000, 'ºC'),
	(191970, 118, '2014-02-15 00:46:34.000000', 'temperatura', 123.0000, 'ºC'),
	(191971, 118, '2014-02-15 00:46:35.000000', 'temperatura', 764.0000, 'ºC'),
	(191972, 118, '2014-02-15 00:46:36.000000', 'temperatura', 1050.0000, 'ºC'),
	(191973, 118, '2014-02-15 00:46:37.000000', 'temperatura', 558.0000, 'ºC'),
	(191974, 118, '2014-02-15 00:46:38.000000', 'temperatura', 843.0000, 'ºC'),
	(191975, 118, '2014-02-15 00:46:39.000000', 'temperatura', 140.0000, 'ºC'),
	(191976, 118, '2014-02-15 00:46:40.000000', 'temperatura', 574.0000, 'ºC'),
	(191977, 118, '2014-02-15 00:46:41.000000', 'temperatura', 49.0000, 'ºC'),
	(191978, 118, '2014-02-15 00:46:42.000000', 'temperatura', 922.0000, 'ºC'),
	(191979, 118, '2014-02-15 00:46:43.000000', 'temperatura', 864.0000, 'ºC'),
	(191980, 118, '2014-02-15 00:46:44.000000', 'temperatura', 354.0000, 'ºC'),
	(191981, 118, '2014-02-15 00:46:45.000000', 'temperatura', 381.0000, 'ºC'),
	(191982, 118, '2014-02-15 00:46:46.000000', 'temperatura', 842.0000, 'ºC'),
	(191983, 118, '2014-02-15 00:46:47.000000', 'temperatura', 668.0000, 'ºC'),
	(191984, 118, '2014-02-15 00:46:48.000000', 'temperatura', 813.0000, 'ºC'),
	(191985, 118, '2014-02-15 00:46:49.000000', 'temperatura', 864.0000, 'ºC'),
	(191986, 118, '2014-02-15 00:46:50.000000', 'temperatura', 680.0000, 'ºC'),
	(191987, 118, '2014-02-15 00:46:51.000000', 'temperatura', 810.0000, 'ºC'),
	(191988, 118, '2014-02-15 00:46:52.000000', 'temperatura', 809.0000, 'ºC'),
	(191989, 118, '2014-02-15 00:46:53.000000', 'temperatura', 415.0000, 'ºC'),
	(191990, 118, '2014-02-15 00:46:54.000000', 'temperatura', 849.0000, 'ºC'),
	(191991, 118, '2014-02-15 00:46:55.000000', 'temperatura', 599.0000, 'ºC'),
	(191992, 118, '2014-02-15 00:46:56.000000', 'temperatura', 450.0000, 'ºC'),
	(191993, 118, '2014-02-15 00:46:57.000000', 'temperatura', 451.0000, 'ºC'),
	(191994, 118, '2014-02-15 00:46:58.000000', 'temperatura', 908.0000, 'ºC'),
	(191995, 118, '2014-02-15 00:46:59.000000', 'temperatura', 786.0000, 'ºC'),
	(191996, 118, '2014-02-15 00:47:00.000000', 'temperatura', 6.0000, 'ºC'),
	(191997, 118, '2014-02-15 00:47:01.000000', 'temperatura', 75.0000, 'ºC'),
	(191998, 118, '2014-02-15 00:47:02.000000', 'temperatura', 355.0000, 'ºC'),
	(191999, 118, '2014-02-15 00:47:03.000000', 'temperatura', 350.0000, 'ºC'),
	(192000, 118, '2014-02-15 00:47:04.000000', 'temperatura', 685.0000, 'ºC'),
	(192001, 118, '2014-02-15 00:47:05.000000', 'temperatura', 1175.0000, 'ºC'),
	(192002, 118, '2014-02-15 00:47:06.000000', 'temperatura', 221.0000, 'ºC'),
	(192003, 118, '2014-02-15 00:47:07.000000', 'temperatura', 1180.0000, 'ºC'),
	(192004, 118, '2014-02-15 00:47:08.000000', 'temperatura', 438.0000, 'ºC'),
	(192005, 118, '2014-02-15 00:47:09.000000', 'temperatura', 1049.0000, 'ºC'),
	(192006, 118, '2014-02-15 00:47:10.000000', 'temperatura', 331.0000, 'ºC'),
	(192007, 118, '2014-02-15 00:47:11.000000', 'temperatura', 910.0000, 'ºC'),
	(192008, 118, '2014-02-15 00:47:12.000000', 'temperatura', 1158.0000, 'ºC'),
	(192009, 118, '2014-02-15 00:47:13.000000', 'temperatura', 662.0000, 'ºC'),
	(192010, 118, '2014-02-15 00:47:14.000000', 'temperatura', 1033.0000, 'ºC'),
	(192011, 118, '2014-02-15 00:47:15.000000', 'temperatura', 781.0000, 'ºC'),
	(192012, 118, '2014-02-15 00:47:16.000000', 'temperatura', 807.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(192013, 118, '2014-02-15 00:47:17.000000', 'temperatura', 492.0000, 'ºC'),
	(192014, 118, '2014-02-15 00:47:18.000000', 'temperatura', 38.0000, 'ºC'),
	(192015, 118, '2014-02-15 00:47:19.000000', 'temperatura', 1114.0000, 'ºC'),
	(192016, 118, '2014-02-15 00:47:20.000000', 'temperatura', 659.0000, 'ºC'),
	(192017, 118, '2014-02-15 00:47:21.000000', 'temperatura', 1154.0000, 'ºC'),
	(192018, 118, '2014-02-15 00:47:22.000000', 'temperatura', 192.0000, 'ºC'),
	(192019, 118, '2014-02-15 00:47:23.000000', 'temperatura', 1099.0000, 'ºC'),
	(192020, 118, '2014-02-15 00:47:24.000000', 'temperatura', 119.0000, 'ºC'),
	(192021, 118, '2014-02-15 00:47:25.000000', 'temperatura', 898.0000, 'ºC'),
	(192022, 118, '2014-02-15 00:47:26.000000', 'temperatura', 535.0000, 'ºC'),
	(192023, 118, '2014-02-15 00:47:27.000000', 'temperatura', 1182.0000, 'ºC'),
	(192024, 118, '2014-02-15 00:47:28.000000', 'temperatura', 706.0000, 'ºC'),
	(192025, 118, '2014-02-15 00:47:29.000000', 'temperatura', 1183.0000, 'ºC'),
	(192026, 118, '2014-02-15 00:47:30.000000', 'temperatura', 196.0000, 'ºC'),
	(192027, 118, '2014-02-15 00:47:31.000000', 'temperatura', 1033.0000, 'ºC'),
	(192028, 118, '2014-02-15 00:47:32.000000', 'temperatura', 976.0000, 'ºC'),
	(192029, 118, '2014-02-15 00:47:33.000000', 'temperatura', 583.0000, 'ºC'),
	(192030, 118, '2014-02-15 00:47:34.000000', 'temperatura', 1189.0000, 'ºC'),
	(192031, 118, '2014-02-15 00:47:35.000000', 'temperatura', 596.0000, 'ºC'),
	(192032, 118, '2014-02-15 00:47:36.000000', 'temperatura', 613.0000, 'ºC'),
	(192033, 118, '2014-02-15 00:47:37.000000', 'temperatura', 76.0000, 'ºC'),
	(192034, 118, '2014-02-15 00:47:38.000000', 'temperatura', 941.0000, 'ºC'),
	(192035, 118, '2014-02-15 00:47:39.000000', 'temperatura', 877.0000, 'ºC'),
	(192036, 118, '2014-02-15 00:47:40.000000', 'temperatura', 365.0000, 'ºC'),
	(192037, 118, '2014-02-15 00:47:41.000000', 'temperatura', 391.0000, 'ºC'),
	(192038, 118, '2014-02-15 00:47:42.000000', 'temperatura', 864.0000, 'ºC'),
	(192039, 118, '2014-02-15 00:47:43.000000', 'temperatura', 747.0000, 'ºC'),
	(192040, 118, '2014-02-15 00:47:44.000000', 'temperatura', 1141.0000, 'ºC'),
	(192041, 118, '2014-02-15 00:47:45.000000', 'temperatura', 1066.0000, 'ºC'),
	(192042, 118, '2014-02-15 00:47:46.000000', 'temperatura', 706.0000, 'ºC'),
	(192043, 118, '2014-02-15 00:47:47.000000', 'temperatura', 333.0000, 'ºC'),
	(192044, 118, '2014-02-15 00:47:48.000000', 'temperatura', 750.0000, 'ºC'),
	(192045, 118, '2014-02-15 00:47:49.000000', 'temperatura', 349.0000, 'ºC'),
	(192046, 118, '2014-02-15 00:47:50.000000', 'temperatura', 695.0000, 'ºC'),
	(192047, 118, '2014-02-15 00:47:51.000000', 'temperatura', 27.0000, 'ºC'),
	(192048, 118, '2014-02-15 00:47:52.000000', 'temperatura', 453.0000, 'ºC'),
	(192049, 118, '2014-02-15 00:47:53.000000', 'temperatura', 986.0000, 'ºC'),
	(192050, 118, '2014-02-15 00:47:54.000000', 'temperatura', 1169.0000, 'ºC'),
	(192051, 118, '2014-02-15 00:47:55.000000', 'temperatura', 488.0000, 'ºC'),
	(192052, 118, '2014-02-15 00:47:56.000000', 'temperatura', 133.0000, 'ºC'),
	(192053, 118, '2014-02-15 00:47:57.000000', 'temperatura', 403.0000, 'ºC'),
	(192054, 118, '2014-02-15 00:47:58.000000', 'temperatura', 417.0000, 'ºC'),
	(192055, 118, '2014-02-15 00:47:59.000000', 'temperatura', 876.0000, 'ºC'),
	(192056, 118, '2014-02-15 00:48:00.000000', 'temperatura', 730.0000, 'ºC'),
	(192057, 118, '2014-02-15 00:48:01.000000', 'temperatura', 1022.0000, 'ºC'),
	(192058, 118, '2014-02-15 00:48:02.000000', 'temperatura', 521.0000, 'ºC'),
	(192059, 118, '2014-02-15 00:48:03.000000', 'temperatura', 737.0000, 'ºC'),
	(192060, 118, '2014-02-15 00:48:04.000000', 'temperatura', 924.0000, 'ºC'),
	(192061, 118, '2014-02-15 00:48:05.000000', 'temperatura', 10.0000, 'ºC'),
	(192062, 118, '2014-02-15 00:48:06.000000', 'temperatura', 877.0000, 'ºC'),
	(192063, 118, '2014-02-15 00:48:07.000000', 'temperatura', 756.0000, 'ºC'),
	(192064, 118, '2014-02-15 00:48:08.000000', 'temperatura', 1152.0000, 'ºC'),
	(192065, 118, '2014-02-15 00:48:09.000000', 'temperatura', 1089.0000, 'ºC'),
	(192066, 118, '2014-02-15 00:48:10.000000', 'temperatura', 792.0000, 'ºC'),
	(192067, 118, '2014-02-15 00:48:11.000000', 'temperatura', 694.0000, 'ºC'),
	(192068, 118, '2014-02-15 00:48:12.000000', 'temperatura', 1095.0000, 'ºC'),
	(192069, 118, '2014-02-15 00:48:13.000000', 'temperatura', 994.0000, 'ºC'),
	(192070, 118, '2014-02-15 00:48:14.000000', 'temperatura', 484.0000, 'ºC'),
	(192071, 118, '2014-02-15 00:48:15.000000', 'temperatura', 641.0000, 'ºC'),
	(192072, 118, '2014-02-15 00:48:16.000000', 'temperatura', 552.0000, 'ºC'),
	(192073, 118, '2014-02-15 00:48:17.000000', 'temperatura', 836.0000, 'ºC'),
	(192074, 118, '2014-02-15 00:48:18.000000', 'temperatura', 125.0000, 'ºC'),
	(192075, 118, '2014-02-15 00:48:19.000000', 'temperatura', 518.0000, 'ºC'),
	(192076, 118, '2014-02-15 00:48:20.000000', 'temperatura', 1014.0000, 'ºC'),
	(192077, 118, '2014-02-15 00:48:21.000000', 'temperatura', 1116.0000, 'ºC'),
	(192078, 118, '2014-02-15 00:48:22.000000', 'temperatura', 138.0000, 'ºC'),
	(192079, 118, '2014-02-15 00:48:23.000000', 'temperatura', 945.0000, 'ºC'),
	(192080, 118, '2014-02-15 00:48:24.000000', 'temperatura', 709.0000, 'ºC'),
	(192081, 118, '2014-02-15 00:48:25.000000', 'temperatura', 710.0000, 'ºC'),
	(192082, 118, '2014-02-15 00:48:26.000000', 'temperatura', 223.0000, 'ºC'),
	(192083, 118, '2014-02-15 00:48:27.000000', 'temperatura', 186.0000, 'ºC'),
	(192084, 118, '2014-02-15 00:48:28.000000', 'temperatura', 262.0000, 'ºC'),
	(192085, 118, '2014-02-15 00:48:29.000000', 'temperatura', 754.0000, 'ºC'),
	(192086, 118, '2014-02-15 00:48:30.000000', 'temperatura', 585.0000, 'ºC'),
	(192087, 118, '2014-02-15 00:48:31.000000', 'temperatura', 664.0000, 'ºC'),
	(192088, 118, '2014-02-15 00:48:32.000000', 'temperatura', 364.0000, 'ºC'),
	(192089, 118, '2014-02-15 00:48:33.000000', 'temperatura', 1029.0000, 'ºC'),
	(192090, 118, '2014-02-15 00:48:34.000000', 'temperatura', 455.0000, 'ºC'),
	(192091, 118, '2014-02-15 00:48:35.000000', 'temperatura', 387.0000, 'ºC'),
	(192092, 118, '2014-02-15 00:48:36.000000', 'temperatura', 571.0000, 'ºC'),
	(192093, 118, '2014-02-15 00:48:37.000000', 'temperatura', 496.0000, 'ºC'),
	(192094, 118, '2014-02-15 00:48:38.000000', 'temperatura', 767.0000, 'ºC'),
	(192095, 118, '2014-02-15 00:48:39.000000', 'temperatura', 1147.0000, 'ºC'),
	(192096, 118, '2014-02-15 00:48:40.000000', 'temperatura', 1035.0000, 'ºC'),
	(192097, 118, '2014-02-15 00:48:41.000000', 'temperatura', 535.0000, 'ºC'),
	(192098, 118, '2014-02-15 00:48:42.000000', 'temperatura', 768.0000, 'ºC'),
	(192099, 118, '2014-02-15 00:48:43.000000', 'temperatura', 1036.0000, 'ºC'),
	(192100, 118, '2014-02-15 00:48:44.000000', 'temperatura', 477.0000, 'ºC'),
	(192101, 118, '2014-02-15 00:48:45.000000', 'temperatura', 477.0000, 'ºC'),
	(192102, 118, '2014-02-15 00:48:46.000000', 'temperatura', 955.0000, 'ºC'),
	(192103, 118, '2014-02-15 00:48:47.000000', 'temperatura', 946.0000, 'ºC'),
	(192104, 118, '2014-02-15 00:48:48.000000', 'temperatura', 663.0000, 'ºC'),
	(192105, 118, '2014-02-15 00:48:49.000000', 'temperatura', 481.0000, 'ºC'),
	(192106, 118, '2014-02-15 00:48:50.000000', 'temperatura', 413.0000, 'ºC'),
	(192107, 118, '2014-02-15 00:48:51.000000', 'temperatura', 623.0000, 'ºC'),
	(192108, 118, '2014-02-15 00:48:52.000000', 'temperatura', 678.0000, 'ºC'),
	(192109, 118, '2014-02-15 00:48:53.000000', 'temperatura', 321.0000, 'ºC'),
	(192110, 118, '2014-02-15 00:48:54.000000', 'temperatura', 770.0000, 'ºC'),
	(192111, 118, '2014-02-15 00:48:55.000000', 'temperatura', 490.0000, 'ºC'),
	(192112, 118, '2014-02-15 00:48:56.000000', 'temperatura', 140.0000, 'ºC'),
	(192113, 118, '2014-02-15 00:48:57.000000', 'temperatura', 429.0000, 'ºC'),
	(192114, 118, '2014-02-15 00:48:58.000000', 'temperatura', 526.0000, 'ºC'),
	(192115, 118, '2014-02-15 00:48:59.000000', 'temperatura', 143.0000, 'ºC'),
	(192116, 118, '2014-02-15 00:49:00.000000', 'temperatura', 337.0000, 'ºC'),
	(192117, 118, '2014-02-15 00:49:01.000000', 'temperatura', 59.0000, 'ºC'),
	(192118, 118, '2014-02-15 00:49:02.000000', 'temperatura', 482.0000, 'ºC'),
	(192119, 118, '2014-02-15 00:49:03.000000', 'temperatura', 1033.0000, 'ºC'),
	(192120, 118, '2014-02-15 00:49:04.000000', 'temperatura', 121.0000, 'ºC'),
	(192121, 118, '2014-02-15 00:49:05.000000', 'temperatura', 1107.0000, 'ºC'),
	(192122, 118, '2014-02-15 00:49:06.000000', 'temperatura', 370.0000, 'ºC'),
	(192123, 118, '2014-02-15 00:49:07.000000', 'temperatura', 932.0000, 'ºC'),
	(192124, 118, '2014-02-15 00:49:08.000000', 'temperatura', 1151.0000, 'ºC'),
	(192125, 118, '2014-02-15 00:49:09.000000', 'temperatura', 560.0000, 'ºC'),
	(192126, 118, '2014-02-15 00:49:10.000000', 'temperatura', 546.0000, 'ºC'),
	(192127, 118, '2014-02-15 00:49:11.000000', 'temperatura', 1051.0000, 'ºC'),
	(192128, 118, '2014-02-15 00:49:12.000000', 'temperatura', 16.0000, 'ºC'),
	(192129, 118, '2014-02-15 00:49:13.000000', 'temperatura', 528.0000, 'ºC'),
	(192130, 118, '2014-02-15 00:49:14.000000', 'temperatura', 191.0000, 'ºC'),
	(192131, 118, '2014-02-15 00:49:15.000000', 'temperatura', 572.0000, 'ºC'),
	(192132, 118, '2014-02-15 00:49:16.000000', 'temperatura', 1087.0000, 'ºC'),
	(192133, 118, '2014-02-15 00:49:17.000000', 'temperatura', 120.0000, 'ºC'),
	(192134, 118, '2014-02-15 00:49:18.000000', 'temperatura', 939.0000, 'ºC'),
	(192135, 118, '2014-02-15 00:49:19.000000', 'temperatura', 735.0000, 'ºC'),
	(192136, 118, '2014-02-15 00:49:20.000000', 'temperatura', 857.0000, 'ºC'),
	(192137, 118, '2014-02-15 00:49:21.000000', 'temperatura', 884.0000, 'ºC'),
	(192138, 118, '2014-02-15 00:49:22.000000', 'temperatura', 646.0000, 'ºC'),
	(192139, 118, '2014-02-15 00:49:23.000000', 'temperatura', 582.0000, 'ºC'),
	(192140, 118, '2014-02-15 00:49:24.000000', 'temperatura', 970.0000, 'ºC'),
	(192141, 118, '2014-02-15 00:49:25.000000', 'temperatura', 705.0000, 'ºC'),
	(192142, 118, '2014-02-15 00:49:26.000000', 'temperatura', 617.0000, 'ºC'),
	(192143, 118, '2014-02-15 00:49:27.000000', 'temperatura', 969.0000, 'ºC'),
	(192144, 118, '2014-02-15 00:49:28.000000', 'temperatura', 594.0000, 'ºC'),
	(192145, 118, '2014-02-15 00:49:29.000000', 'temperatura', 66.0000, 'ºC'),
	(192146, 118, '2014-02-15 00:49:30.000000', 'temperatura', 947.0000, 'ºC'),
	(192147, 118, '2014-02-15 00:49:31.000000', 'temperatura', 938.0000, 'ºC'),
	(192148, 118, '2014-02-15 00:49:32.000000', 'temperatura', 650.0000, 'ºC'),
	(192149, 118, '2014-02-15 00:49:33.000000', 'temperatura', 437.0000, 'ºC'),
	(192150, 118, '2014-02-15 00:49:34.000000', 'temperatura', 234.0000, 'ºC'),
	(192151, 118, '2014-02-15 00:49:35.000000', 'temperatura', 1059.0000, 'ºC'),
	(192152, 118, '2014-02-15 00:49:36.000000', 'temperatura', 995.0000, 'ºC'),
	(192153, 118, '2014-02-15 00:49:37.000000', 'temperatura', 599.0000, 'ºC'),
	(192154, 118, '2014-02-15 00:49:38.000000', 'temperatura', 8.0000, 'ºC'),
	(192155, 118, '2014-02-15 00:49:39.000000', 'temperatura', 645.0000, 'ºC'),
	(192156, 118, '2014-02-15 00:49:40.000000', 'temperatura', 802.0000, 'ºC'),
	(192157, 118, '2014-02-15 00:49:41.000000', 'temperatura', 873.0000, 'ºC'),
	(192158, 118, '2014-02-15 00:49:42.000000', 'temperatura', 762.0000, 'ºC'),
	(192159, 118, '2014-02-15 00:49:43.000000', 'temperatura', 1192.0000, 'ºC'),
	(192160, 118, '2014-02-15 00:49:44.000000', 'temperatura', 74.0000, 'ºC'),
	(192161, 118, '2014-02-15 00:49:45.000000', 'temperatura', 393.0000, 'ºC'),
	(192162, 118, '2014-02-15 00:49:46.000000', 'temperatura', 546.0000, 'ºC'),
	(192163, 118, '2014-02-15 00:49:47.000000', 'temperatura', 352.0000, 'ºC'),
	(192164, 118, '2014-02-15 00:49:48.000000', 'temperatura', 121.0000, 'ºC'),
	(192165, 118, '2014-02-15 00:49:49.000000', 'temperatura', 748.0000, 'ºC'),
	(192166, 118, '2014-02-15 00:49:50.000000', 'temperatura', 979.0000, 'ºC'),
	(192167, 118, '2014-02-15 00:49:51.000000', 'temperatura', 251.0000, 'ºC'),
	(192168, 118, '2014-02-15 00:49:52.000000', 'temperatura', 719.0000, 'ºC'),
	(192169, 118, '2014-02-15 00:49:53.000000', 'temperatura', 442.0000, 'ºC'),
	(192170, 118, '2014-02-15 00:49:54.000000', 'temperatura', 52.0000, 'ºC'),
	(192171, 118, '2014-02-15 00:49:55.000000', 'temperatura', 134.0000, 'ºC'),
	(192172, 118, '2014-02-15 00:49:56.000000', 'temperatura', 516.0000, 'ºC'),
	(192173, 118, '2014-02-15 00:49:57.000000', 'temperatura', 978.0000, 'ºC'),
	(192174, 118, '2014-02-15 00:49:58.000000', 'temperatura', 941.0000, 'ºC'),
	(192175, 118, '2014-02-15 00:49:59.000000', 'temperatura', 575.0000, 'ºC'),
	(192176, 118, '2014-02-15 00:50:00.000000', 'temperatura', 49.0000, 'ºC'),
	(192177, 118, '2014-02-15 00:50:01.000000', 'temperatura', 923.0000, 'ºC'),
	(192178, 118, '2014-02-15 00:50:02.000000', 'temperatura', 867.0000, 'ºC'),
	(192179, 118, '2014-02-15 00:50:03.000000', 'temperatura', 366.0000, 'ºC'),
	(192180, 118, '2014-02-15 00:50:04.000000', 'temperatura', 431.0000, 'ºC'),
	(192181, 118, '2014-02-15 00:50:05.000000', 'temperatura', 1057.0000, 'ºC'),
	(192182, 118, '2014-02-15 00:50:06.000000', 'temperatura', 392.0000, 'ºC'),
	(192183, 118, '2014-02-15 00:50:07.000000', 'temperatura', 1190.0000, 'ºC'),
	(192184, 118, '2014-02-15 00:50:08.000000', 'temperatura', 1175.0000, 'ºC'),
	(192185, 118, '2014-02-15 00:50:09.000000', 'temperatura', 1106.0000, 'ºC'),
	(192186, 118, '2014-02-15 00:50:10.000000', 'temperatura', 806.0000, 'ºC'),
	(192187, 118, '2014-02-15 00:50:11.000000', 'temperatura', 713.0000, 'ºC'),
	(192188, 118, '2014-02-15 00:50:12.000000', 'temperatura', 1146.0000, 'ºC'),
	(192189, 118, '2014-02-15 00:50:13.000000', 'temperatura', 1190.0000, 'ºC'),
	(192190, 118, '2014-02-15 00:50:14.000000', 'temperatura', 113.0000, 'ºC'),
	(192191, 118, '2014-02-15 00:50:15.000000', 'temperatura', 597.0000, 'ºC'),
	(192192, 118, '2014-02-15 00:50:16.000000', 'temperatura', 247.0000, 'ºC'),
	(192193, 118, '2014-02-15 00:50:17.000000', 'temperatura', 643.0000, 'ºC'),
	(192194, 118, '2014-02-15 00:50:18.000000', 'temperatura', 76.0000, 'ºC'),
	(192195, 118, '2014-02-15 00:50:19.000000', 'temperatura', 849.0000, 'ºC'),
	(192196, 118, '2014-02-15 00:50:20.000000', 'temperatura', 419.0000, 'ºC'),
	(192197, 118, '2014-02-15 00:50:21.000000', 'temperatura', 748.0000, 'ºC'),
	(192198, 118, '2014-02-15 00:50:22.000000', 'temperatura', 82.0000, 'ºC'),
	(192199, 118, '2014-02-15 00:50:23.000000', 'temperatura', 567.0000, 'ºC'),
	(192200, 118, '2014-02-15 00:50:24.000000', 'temperatura', 190.0000, 'ºC'),
	(192201, 118, '2014-02-15 00:50:25.000000', 'temperatura', 450.0000, 'ºC'),
	(192202, 118, '2014-02-15 00:50:26.000000', 'temperatura', 480.0000, 'ºC'),
	(192203, 118, '2014-02-15 00:50:27.000000', 'temperatura', 1049.0000, 'ºC'),
	(192204, 118, '2014-02-15 00:50:28.000000', 'temperatura', 207.0000, 'ºC'),
	(192205, 118, '2014-02-15 00:50:29.000000', 'temperatura', 287.0000, 'ºC'),
	(192206, 118, '2014-02-15 00:50:30.000000', 'temperatura', 815.0000, 'ºC'),
	(192207, 118, '2014-02-15 00:50:31.000000', 'temperatura', 816.0000, 'ºC'),
	(192208, 118, '2014-02-15 00:50:32.000000', 'temperatura', 433.0000, 'ºC'),
	(192209, 118, '2014-02-15 00:50:33.000000', 'temperatura', 919.0000, 'ºC'),
	(192210, 118, '2014-02-15 00:50:34.000000', 'temperatura', 896.0000, 'ºC'),
	(192211, 118, '2014-02-15 00:50:35.000000', 'temperatura', 524.0000, 'ºC'),
	(192212, 118, '2014-02-15 00:50:36.000000', 'temperatura', 1134.0000, 'ºC'),
	(192213, 118, '2014-02-15 00:50:37.000000', 'temperatura', 495.0000, 'ºC'),
	(192214, 118, '2014-02-15 00:50:38.000000', 'temperatura', 277.0000, 'ºC'),
	(192215, 118, '2014-02-15 00:50:39.000000', 'temperatura', 1099.0000, 'ºC'),
	(192216, 118, '2014-02-15 00:50:40.000000', 'temperatura', 1067.0000, 'ºC'),
	(192217, 118, '2014-02-15 00:50:41.000000', 'temperatura', 835.0000, 'ºC'),
	(192218, 118, '2014-02-15 00:50:42.000000', 'temperatura', 975.0000, 'ºC'),
	(192219, 118, '2014-02-15 00:50:43.000000', 'temperatura', 1170.0000, 'ºC'),
	(192220, 118, '2014-02-15 00:50:44.000000', 'temperatura', 525.0000, 'ºC'),
	(192221, 118, '2014-02-15 00:50:45.000000', 'temperatura', 318.0000, 'ºC'),
	(192222, 118, '2014-02-15 00:50:46.000000', 'temperatura', 15.0000, 'ºC'),
	(192223, 118, '2014-02-15 00:50:47.000000', 'temperatura', 321.0000, 'ºC'),
	(192224, 118, '2014-02-15 00:50:48.000000', 'temperatura', 360.0000, 'ºC'),
	(192225, 118, '2014-02-15 00:50:49.000000', 'temperatura', 840.0000, 'ºC'),
	(192226, 118, '2014-02-15 00:50:50.000000', 'temperatura', 717.0000, 'ºC'),
	(192227, 118, '2014-02-15 00:50:51.000000', 'temperatura', 1066.0000, 'ºC'),
	(192228, 118, '2014-02-15 00:50:52.000000', 'temperatura', 782.0000, 'ºC'),
	(192229, 118, '2014-02-15 00:50:53.000000', 'temperatura', 711.0000, 'ºC'),
	(192230, 118, '2014-02-15 00:50:54.000000', 'temperatura', 8.0000, 'ºC'),
	(192231, 118, '2014-02-15 00:50:55.000000', 'temperatura', 307.0000, 'ºC'),
	(192232, 118, '2014-02-15 00:50:56.000000', 'temperatura', 312.0000, 'ºC'),
	(192233, 118, '2014-02-15 00:50:57.000000', 'temperatura', 638.0000, 'ºC'),
	(192234, 118, '2014-02-15 00:50:58.000000', 'temperatura', 1057.0000, 'ºC'),
	(192235, 118, '2014-02-15 00:50:59.000000', 'temperatura', 969.0000, 'ºC'),
	(192236, 118, '2014-02-15 00:51:00.000000', 'temperatura', 474.0000, 'ºC'),
	(192237, 118, '2014-02-15 00:51:01.000000', 'temperatura', 667.0000, 'ºC'),
	(192238, 118, '2014-02-15 00:51:02.000000', 'temperatura', 711.0000, 'ºC'),
	(192239, 118, '2014-02-15 00:51:03.000000', 'temperatura', 356.0000, 'ºC'),
	(192240, 118, '2014-02-15 00:51:04.000000', 'temperatura', 845.0000, 'ºC'),
	(192241, 118, '2014-02-15 00:51:05.000000', 'temperatura', 760.0000, 'ºC'),
	(192242, 118, '2014-02-15 00:51:06.000000', 'temperatura', 64.0000, 'ºC'),
	(192243, 118, '2014-02-15 00:51:07.000000', 'temperatura', 443.0000, 'ºC'),
	(192244, 118, '2014-02-15 00:51:08.000000', 'temperatura', 820.0000, 'ºC'),
	(192245, 118, '2014-02-15 00:51:09.000000', 'temperatura', 374.0000, 'ºC'),
	(192246, 118, '2014-02-15 00:51:10.000000', 'temperatura', 609.0000, 'ºC'),
	(192247, 118, '2014-02-15 00:51:11.000000', 'temperatura', 725.0000, 'ºC'),
	(192248, 118, '2014-02-15 00:51:12.000000', 'temperatura', 599.0000, 'ºC'),
	(192249, 118, '2014-02-15 00:51:13.000000', 'temperatura', 822.0000, 'ºC'),
	(192250, 118, '2014-02-15 00:51:14.000000', 'temperatura', 1110.0000, 'ºC'),
	(192251, 118, '2014-02-15 00:51:15.000000', 'temperatura', 688.0000, 'ºC'),
	(192252, 118, '2014-02-15 00:51:16.000000', 'temperatura', 108.0000, 'ºC'),
	(192253, 118, '2014-02-15 00:51:17.000000', 'temperatura', 876.0000, 'ºC'),
	(192254, 118, '2014-02-15 00:51:18.000000', 'temperatura', 458.0000, 'ºC'),
	(192255, 118, '2014-02-15 00:51:19.000000', 'temperatura', 861.0000, 'ºC'),
	(192256, 118, '2014-02-15 00:51:20.000000', 'temperatura', 530.0000, 'ºC'),
	(192257, 118, '2014-02-15 00:51:21.000000', 'temperatura', 70.0000, 'ºC'),
	(192258, 118, '2014-02-15 00:51:22.000000', 'temperatura', 1161.0000, 'ºC'),
	(192259, 118, '2014-02-15 00:51:23.000000', 'temperatura', 793.0000, 'ºC'),
	(192260, 118, '2014-02-15 00:51:24.000000', 'temperatura', 486.0000, 'ºC'),
	(192261, 118, '2014-02-15 00:51:25.000000', 'temperatura', 48.0000, 'ºC'),
	(192262, 118, '2014-02-15 00:51:26.000000', 'temperatura', 1184.0000, 'ºC'),
	(192263, 118, '2014-02-15 00:51:27.000000', 'temperatura', 976.0000, 'ºC'),
	(192264, 118, '2014-02-15 00:51:28.000000', 'temperatura', 129.0000, 'ºC'),
	(192265, 118, '2014-02-15 00:51:29.000000', 'temperatura', 115.0000, 'ºC'),
	(192266, 118, '2014-02-15 00:51:30.000000', 'temperatura', 191.0000, 'ºC'),
	(192267, 118, '2014-02-15 00:51:31.000000', 'temperatura', 610.0000, 'ºC'),
	(192268, 118, '2014-02-15 00:51:32.000000', 'temperatura', 76.0000, 'ºC'),
	(192269, 118, '2014-02-15 00:51:33.000000', 'temperatura', 951.0000, 'ºC'),
	(192270, 118, '2014-02-15 00:51:34.000000', 'temperatura', 927.0000, 'ºC'),
	(192271, 118, '2014-02-15 00:51:35.000000', 'temperatura', 582.0000, 'ºC'),
	(192272, 118, '2014-02-15 00:51:36.000000', 'temperatura', 129.0000, 'ºC'),
	(192273, 118, '2014-02-15 00:51:37.000000', 'temperatura', 100.0000, 'ºC'),
	(192274, 118, '2014-02-15 00:51:38.000000', 'temperatura', 115.0000, 'ºC'),
	(192275, 118, '2014-02-15 00:51:39.000000', 'temperatura', 273.0000, 'ºC'),
	(192276, 118, '2014-02-15 00:51:40.000000', 'temperatura', 1023.0000, 'ºC'),
	(192277, 118, '2014-02-15 00:51:41.000000', 'temperatura', 696.0000, 'ºC'),
	(192278, 118, '2014-02-15 00:51:42.000000', 'temperatura', 410.0000, 'ºC'),
	(192279, 118, '2014-02-15 00:51:43.000000', 'temperatura', 1163.0000, 'ºC'),
	(192280, 118, '2014-02-15 00:51:44.000000', 'temperatura', 986.0000, 'ºC'),
	(192281, 118, '2014-02-15 00:51:45.000000', 'temperatura', 242.0000, 'ºC'),
	(192282, 118, '2014-02-15 00:51:46.000000', 'temperatura', 653.0000, 'ºC'),
	(192283, 118, '2014-02-15 00:51:47.000000', 'temperatura', 140.0000, 'ºC'),
	(192284, 118, '2014-02-15 00:51:48.000000', 'temperatura', 1141.0000, 'ºC'),
	(192285, 118, '2014-02-15 00:51:49.000000', 'temperatura', 485.0000, 'ºC'),
	(192286, 118, '2014-02-15 00:51:50.000000', 'temperatura', 204.0000, 'ºC'),
	(192287, 118, '2014-02-15 00:51:51.000000', 'temperatura', 765.0000, 'ºC'),
	(192288, 118, '2014-02-15 00:51:52.000000', 'temperatura', 814.0000, 'ºC'),
	(192289, 118, '2014-02-15 00:51:53.000000', 'temperatura', 576.0000, 'ºC'),
	(192290, 118, '2014-02-15 00:51:54.000000', 'temperatura', 437.0000, 'ºC'),
	(192291, 118, '2014-02-15 00:51:55.000000', 'temperatura', 458.0000, 'ºC'),
	(192292, 118, '2014-02-15 00:51:56.000000', 'temperatura', 980.0000, 'ºC'),
	(192293, 118, '2014-02-15 00:51:57.000000', 'temperatura', 1126.0000, 'ºC'),
	(192294, 118, '2014-02-15 00:51:58.000000', 'temperatura', 292.0000, 'ºC'),
	(192295, 118, '2014-02-15 00:51:59.000000', 'temperatura', 483.0000, 'ºC'),
	(192296, 118, '2014-02-15 00:52:00.000000', 'temperatura', 337.0000, 'ºC'),
	(192297, 118, '2014-02-15 00:52:01.000000', 'temperatura', 238.0000, 'ºC'),
	(192298, 118, '2014-02-15 00:52:02.000000', 'temperatura', 178.0000, 'ºC'),
	(192299, 118, '2014-02-15 00:52:03.000000', 'temperatura', 178.0000, 'ºC'),
	(192300, 118, '2014-02-15 00:52:04.000000', 'temperatura', 355.0000, 'ºC'),
	(192301, 118, '2014-02-15 00:52:05.000000', 'temperatura', 44.0000, 'ºC'),
	(192302, 118, '2014-02-15 00:52:06.000000', 'temperatura', 353.0000, 'ºC'),
	(192303, 118, '2014-02-15 00:52:07.000000', 'temperatura', 433.0000, 'ºC'),
	(192304, 118, '2014-02-15 00:52:08.000000', 'temperatura', 1109.0000, 'ºC'),
	(192305, 118, '2014-02-15 00:52:09.000000', 'temperatura', 645.0000, 'ºC'),
	(192306, 118, '2014-02-15 00:52:10.000000', 'temperatura', 1097.0000, 'ºC'),
	(192307, 118, '2014-02-15 00:52:11.000000', 'temperatura', 1150.0000, 'ºC'),
	(192308, 118, '2014-02-15 00:52:12.000000', 'temperatura', 62.0000, 'ºC'),
	(192309, 118, '2014-02-15 00:52:13.000000', 'temperatura', 458.0000, 'ºC'),
	(192310, 118, '2014-02-15 00:52:14.000000', 'temperatura', 907.0000, 'ºC'),
	(192311, 118, '2014-02-15 00:52:15.000000', 'temperatura', 761.0000, 'ºC'),
	(192312, 118, '2014-02-15 00:52:16.000000', 'temperatura', 1086.0000, 'ºC'),
	(192313, 118, '2014-02-15 00:52:17.000000', 'temperatura', 746.0000, 'ºC'),
	(192314, 118, '2014-02-15 00:52:18.000000', 'temperatura', 472.0000, 'ºC'),
	(192315, 118, '2014-02-15 00:52:19.000000', 'temperatura', 123.0000, 'ºC'),
	(192316, 118, '2014-02-15 00:52:20.000000', 'temperatura', 399.0000, 'ºC'),
	(192317, 118, '2014-02-15 00:52:21.000000', 'temperatura', 429.0000, 'ºC'),
	(192318, 118, '2014-02-15 00:52:22.000000', 'temperatura', 947.0000, 'ºC'),
	(192319, 118, '2014-02-15 00:52:23.000000', 'temperatura', 1047.0000, 'ºC'),
	(192320, 118, '2014-02-15 00:52:24.000000', 'temperatura', 1197.0000, 'ºC'),
	(192321, 118, '2014-02-15 00:52:25.000000', 'temperatura', 445.0000, 'ºC'),
	(192322, 118, '2014-02-15 00:52:26.000000', 'temperatura', 1035.0000, 'ºC'),
	(192323, 118, '2014-02-15 00:52:27.000000', 'temperatura', 241.0000, 'ºC'),
	(192324, 118, '2014-02-15 00:52:28.000000', 'temperatura', 500.0000, 'ºC'),
	(192325, 118, '2014-02-15 00:52:29.000000', 'temperatura', 575.0000, 'ºC'),
	(192326, 118, '2014-02-15 00:52:30.000000', 'temperatura', 178.0000, 'ºC'),
	(192327, 118, '2014-02-15 00:52:31.000000', 'temperatura', 366.0000, 'ºC'),
	(192328, 118, '2014-02-15 00:52:32.000000', 'temperatura', 97.0000, 'ºC'),
	(192329, 118, '2014-02-15 00:52:33.000000', 'temperatura', 585.0000, 'ºC'),
	(192330, 118, '2014-02-15 00:52:34.000000', 'temperatura', 236.0000, 'ºC'),
	(192331, 118, '2014-02-15 00:52:35.000000', 'temperatura', 626.0000, 'ºC'),
	(192332, 118, '2014-02-15 00:52:36.000000', 'temperatura', 20.0000, 'ºC'),
	(192333, 118, '2014-02-15 00:52:37.000000', 'temperatura', 623.0000, 'ºC'),
	(192334, 118, '2014-02-15 00:52:38.000000', 'temperatura', 657.0000, 'ºC'),
	(192335, 118, '2014-02-15 00:52:39.000000', 'temperatura', 217.0000, 'ºC'),
	(192336, 118, '2014-02-15 00:52:40.000000', 'temperatura', 312.0000, 'ºC'),
	(192337, 118, '2014-02-15 00:52:41.000000', 'temperatura', 909.0000, 'ºC'),
	(192338, 118, '2014-02-15 00:52:42.000000', 'temperatura', 10.0000, 'ºC'),
	(192339, 118, '2014-02-15 00:52:43.000000', 'temperatura', 925.0000, 'ºC'),
	(192340, 118, '2014-02-15 00:52:44.000000', 'temperatura', 995.0000, 'ºC'),
	(192341, 118, '2014-02-15 00:52:45.000000', 'temperatura', 1001.0000, 'ºC'),
	(192342, 118, '2014-02-15 00:52:46.000000', 'temperatura', 821.0000, 'ºC'),
	(192343, 118, '2014-02-15 00:52:47.000000', 'temperatura', 1103.0000, 'ºC'),
	(192344, 118, '2014-02-15 00:52:48.000000', 'temperatura', 651.0000, 'ºC'),
	(192345, 118, '2014-02-15 00:52:49.000000', 'temperatura', 1149.0000, 'ºC'),
	(192346, 118, '2014-02-15 00:52:50.000000', 'temperatura', 189.0000, 'ºC'),
	(192347, 118, '2014-02-15 00:52:51.000000', 'temperatura', 1102.0000, 'ºC'),
	(192348, 118, '2014-02-15 00:52:52.000000', 'temperatura', 142.0000, 'ºC'),
	(192349, 118, '2014-02-15 00:52:53.000000', 'temperatura', 1005.0000, 'ºC'),
	(192350, 118, '2014-02-15 00:52:54.000000', 'temperatura', 997.0000, 'ºC'),
	(192351, 118, '2014-02-15 00:52:55.000000', 'temperatura', 774.0000, 'ºC'),
	(192352, 118, '2014-02-15 00:52:56.000000', 'temperatura', 876.0000, 'ºC'),
	(192353, 118, '2014-02-15 00:52:57.000000', 'temperatura', 861.0000, 'ºC'),
	(192354, 118, '2014-02-15 00:52:58.000000', 'temperatura', 477.0000, 'ºC'),
	(192355, 118, '2014-02-15 00:52:59.000000', 'temperatura', 1001.0000, 'ºC'),
	(192356, 118, '2014-02-15 00:53:00.000000', 'temperatura', 1176.0000, 'ºC'),
	(192357, 118, '2014-02-15 00:53:01.000000', 'temperatura', 478.0000, 'ºC'),
	(192358, 118, '2014-02-15 00:53:02.000000', 'temperatura', 61.0000, 'ºC'),
	(192359, 118, '2014-02-15 00:53:03.000000', 'temperatura', 70.0000, 'ºC'),
	(192360, 118, '2014-02-15 00:53:04.000000', 'temperatura', 170.0000, 'ºC'),
	(192361, 118, '2014-02-15 00:53:05.000000', 'temperatura', 639.0000, 'ºC'),
	(192362, 118, '2014-02-15 00:53:06.000000', 'temperatura', 286.0000, 'ºC'),
	(192363, 118, '2014-02-15 00:53:07.000000', 'temperatura', 714.0000, 'ºC'),
	(192364, 118, '2014-02-15 00:53:08.000000', 'temperatura', 311.0000, 'ºC'),
	(192365, 118, '2014-02-15 00:53:09.000000', 'temperatura', 615.0000, 'ºC'),
	(192366, 118, '2014-02-15 00:53:10.000000', 'temperatura', 943.0000, 'ºC'),
	(192367, 118, '2014-02-15 00:53:11.000000', 'temperatura', 468.0000, 'ºC'),
	(192368, 118, '2014-02-15 00:53:12.000000', 'temperatura', 714.0000, 'ºC'),
	(192369, 118, '2014-02-15 00:53:13.000000', 'temperatura', 966.0000, 'ºC'),
	(192370, 118, '2014-02-15 00:53:14.000000', 'temperatura', 287.0000, 'ºC'),
	(192371, 118, '2014-02-15 00:53:15.000000', 'temperatura', 937.0000, 'ºC'),
	(192372, 118, '2014-02-15 00:53:16.000000', 'temperatura', 225.0000, 'ºC'),
	(192373, 118, '2014-02-15 00:53:17.000000', 'temperatura', 715.0000, 'ºC'),
	(192374, 118, '2014-02-15 00:53:18.000000', 'temperatura', 500.0000, 'ºC'),
	(192375, 118, '2014-02-15 00:53:19.000000', 'temperatura', 355.0000, 'ºC'),
	(192376, 118, '2014-02-15 00:53:20.000000', 'temperatura', 275.0000, 'ºC'),
	(192377, 118, '2014-02-15 00:53:21.000000', 'temperatura', 310.0000, 'ºC'),
	(192378, 118, '2014-02-15 00:53:22.000000', 'temperatura', 728.0000, 'ºC'),
	(192379, 118, '2014-02-15 00:53:23.000000', 'temperatura', 309.0000, 'ºC'),
	(192380, 118, '2014-02-15 00:53:24.000000', 'temperatura', 562.0000, 'ºC'),
	(192381, 118, '2014-02-15 00:53:25.000000', 'temperatura', 682.0000, 'ºC'),
	(192382, 118, '2014-02-15 00:53:26.000000', 'temperatura', 523.0000, 'ºC'),
	(192383, 118, '2014-02-15 00:53:27.000000', 'temperatura', 573.0000, 'ºC'),
	(192384, 118, '2014-02-15 00:53:28.000000', 'temperatura', 94.0000, 'ºC'),
	(192385, 118, '2014-02-15 00:53:29.000000', 'temperatura', 1153.0000, 'ºC'),
	(192386, 118, '2014-02-15 00:53:30.000000', 'temperatura', 684.0000, 'ºC'),
	(192387, 118, '2014-02-15 00:53:31.000000', 'temperatura', 1161.0000, 'ºC'),
	(192388, 118, '2014-02-15 00:53:32.000000', 'temperatura', 154.0000, 'ºC'),
	(192389, 118, '2014-02-15 00:53:33.000000', 'temperatura', 887.0000, 'ºC'),
	(192390, 118, '2014-02-15 00:53:34.000000', 'temperatura', 372.0000, 'ºC'),
	(192391, 118, '2014-02-15 00:53:35.000000', 'temperatura', 399.0000, 'ºC'),
	(192392, 118, '2014-02-15 00:53:36.000000', 'temperatura', 880.0000, 'ºC'),
	(192393, 118, '2014-02-15 00:53:37.000000', 'temperatura', 804.0000, 'ºC'),
	(192394, 118, '2014-02-15 00:53:38.000000', 'temperatura', 180.0000, 'ºC'),
	(192395, 118, '2014-02-15 00:53:39.000000', 'temperatura', 888.0000, 'ºC'),
	(192396, 118, '2014-02-15 00:53:40.000000', 'temperatura', 303.0000, 'ºC'),
	(192397, 118, '2014-02-15 00:53:41.000000', 'temperatura', 49.0000, 'ºC'),
	(192398, 118, '2014-02-15 00:53:42.000000', 'temperatura', 535.0000, 'ºC'),
	(192399, 118, '2014-02-15 00:53:43.000000', 'temperatura', 132.0000, 'ºC'),
	(192400, 118, '2014-02-15 00:53:44.000000', 'temperatura', 253.0000, 'ºC'),
	(192401, 118, '2014-02-15 00:53:45.000000', 'temperatura', 870.0000, 'ºC'),
	(192402, 118, '2014-02-15 00:53:46.000000', 'temperatura', 1192.0000, 'ºC'),
	(192403, 118, '2014-02-15 00:53:47.000000', 'temperatura', 952.0000, 'ºC'),
	(192404, 118, '2014-02-15 00:53:48.000000', 'temperatura', 1182.0000, 'ºC'),
	(192405, 118, '2014-02-15 00:53:49.000000', 'temperatura', 656.0000, 'ºC'),
	(192406, 118, '2014-02-15 00:53:50.000000', 'temperatura', 933.0000, 'ºC'),
	(192407, 118, '2014-02-15 00:53:51.000000', 'temperatura', 300.0000, 'ºC'),
	(192408, 118, '2014-02-15 00:53:52.000000', 'temperatura', 1102.0000, 'ºC'),
	(192409, 118, '2014-02-15 00:53:53.000000', 'temperatura', 1009.0000, 'ºC'),
	(192410, 118, '2014-02-15 00:53:54.000000', 'temperatura', 541.0000, 'ºC'),
	(192411, 118, '2014-02-15 00:53:55.000000', 'temperatura', 879.0000, 'ºC'),
	(192412, 118, '2014-02-15 00:53:56.000000', 'temperatura', 372.0000, 'ºC'),
	(192413, 118, '2014-02-15 00:53:57.000000', 'temperatura', 422.0000, 'ºC'),
	(192414, 118, '2014-02-15 00:53:58.000000', 'temperatura', 997.0000, 'ºC'),
	(192415, 118, '2014-02-15 00:53:59.000000', 'temperatura', 118.0000, 'ºC'),
	(192416, 118, '2014-02-15 00:54:00.000000', 'temperatura', 1198.0000, 'ºC'),
	(192417, 118, '2014-02-15 00:54:01.000000', 'temperatura', 837.0000, 'ºC'),
	(192418, 118, '2014-02-15 00:54:02.000000', 'temperatura', 591.0000, 'ºC'),
	(192419, 118, '2014-02-15 00:54:03.000000', 'temperatura', 443.0000, 'ºC'),
	(192420, 118, '2014-02-15 00:54:04.000000', 'temperatura', 445.0000, 'ºC'),
	(192421, 118, '2014-02-15 00:54:05.000000', 'temperatura', 897.0000, 'ºC'),
	(192422, 118, '2014-02-15 00:54:06.000000', 'temperatura', 750.0000, 'ºC'),
	(192423, 118, '2014-02-15 00:54:07.000000', 'temperatura', 1059.0000, 'ºC'),
	(192424, 118, '2014-02-15 00:54:08.000000', 'temperatura', 645.0000, 'ºC'),
	(192425, 118, '2014-02-15 00:54:09.000000', 'temperatura', 48.0000, 'ºC'),
	(192426, 118, '2014-02-15 00:54:10.000000', 'temperatura', 708.0000, 'ºC'),
	(192427, 118, '2014-02-15 00:54:11.000000', 'temperatura', 995.0000, 'ºC'),
	(192428, 118, '2014-02-15 00:54:12.000000', 'temperatura', 453.0000, 'ºC'),
	(192429, 118, '2014-02-15 00:54:13.000000', 'temperatura', 481.0000, 'ºC'),
	(192430, 118, '2014-02-15 00:54:14.000000', 'temperatura', 1045.0000, 'ºC'),
	(192431, 118, '2014-02-15 00:54:15.000000', 'temperatura', 181.0000, 'ºC'),
	(192432, 118, '2014-02-15 00:54:16.000000', 'temperatura', 173.0000, 'ºC'),
	(192433, 118, '2014-02-15 00:54:17.000000', 'temperatura', 323.0000, 'ºC'),
	(192434, 118, '2014-02-15 00:54:18.000000', 'temperatura', 1094.0000, 'ºC'),
	(192435, 118, '2014-02-15 00:54:19.000000', 'temperatura', 901.0000, 'ºC'),
	(192436, 118, '2014-02-15 00:54:20.000000', 'temperatura', 23.0000, 'ºC'),
	(192437, 118, '2014-02-15 00:54:21.000000', 'temperatura', 1013.0000, 'ºC'),
	(192438, 118, '2014-02-15 00:54:22.000000', 'temperatura', 198.0000, 'ºC'),
	(192439, 118, '2014-02-15 00:54:23.000000', 'temperatura', 352.0000, 'ºC'),
	(192440, 118, '2014-02-15 00:54:24.000000', 'temperatura', 1165.0000, 'ºC'),
	(192441, 118, '2014-02-15 00:54:25.000000', 'temperatura', 1171.0000, 'ºC'),
	(192442, 118, '2014-02-15 00:54:26.000000', 'temperatura', 1160.0000, 'ºC'),
	(192443, 118, '2014-02-15 00:54:27.000000', 'temperatura', 1089.0000, 'ºC'),
	(192444, 118, '2014-02-15 00:54:28.000000', 'temperatura', 766.0000, 'ºC'),
	(192445, 118, '2014-02-15 00:54:29.000000', 'temperatura', 561.0000, 'ºC'),
	(192446, 118, '2014-02-15 00:54:30.000000', 'temperatura', 509.0000, 'ºC'),
	(192447, 118, '2014-02-15 00:54:31.000000', 'temperatura', 860.0000, 'ºC'),
	(192448, 118, '2014-02-15 00:54:32.000000', 'temperatura', 376.0000, 'ºC'),
	(192449, 118, '2014-02-15 00:54:33.000000', 'temperatura', 500.0000, 'ºC'),
	(192450, 118, '2014-02-15 00:54:34.000000', 'temperatura', 173.0000, 'ºC'),
	(192451, 118, '2014-02-15 00:54:35.000000', 'temperatura', 566.0000, 'ºC'),
	(192452, 118, '2014-02-15 00:54:36.000000', 'temperatura', 1110.0000, 'ºC'),
	(192453, 118, '2014-02-15 00:54:37.000000', 'temperatura', 253.0000, 'ºC'),
	(192454, 118, '2014-02-15 00:54:38.000000', 'temperatura', 335.0000, 'ºC'),
	(192455, 118, '2014-02-15 00:54:39.000000', 'temperatura', 915.0000, 'ºC'),
	(192456, 118, '2014-02-15 00:54:40.000000', 'temperatura', 1172.0000, 'ºC'),
	(192457, 118, '2014-02-15 00:54:41.000000', 'temperatura', 716.0000, 'ºC'),
	(192458, 118, '2014-02-15 00:54:42.000000', 'temperatura', 65.0000, 'ºC'),
	(192459, 118, '2014-02-15 00:54:43.000000', 'temperatura', 576.0000, 'ºC'),
	(192460, 118, '2014-02-15 00:54:44.000000', 'temperatura', 286.0000, 'ºC'),
	(192461, 118, '2014-02-15 00:54:45.000000', 'temperatura', 904.0000, 'ºC'),
	(192462, 118, '2014-02-15 00:54:46.000000', 'temperatura', 61.0000, 'ºC'),
	(192463, 118, '2014-02-15 00:54:47.000000', 'temperatura', 1196.0000, 'ºC'),
	(192464, 118, '2014-02-15 00:54:48.000000', 'temperatura', 996.0000, 'ºC'),
	(192465, 118, '2014-02-15 00:54:49.000000', 'temperatura', 191.0000, 'ºC'),
	(192466, 118, '2014-02-15 00:54:50.000000', 'temperatura', 370.0000, 'ºC'),
	(192467, 118, '2014-02-15 00:54:51.000000', 'temperatura', 77.0000, 'ºC'),
	(192468, 118, '2014-02-15 00:54:52.000000', 'temperatura', 476.0000, 'ºC'),
	(192469, 118, '2014-02-15 00:54:53.000000', 'temperatura', 951.0000, 'ºC'),
	(192470, 118, '2014-02-15 00:54:54.000000', 'temperatura', 924.0000, 'ºC'),
	(192471, 118, '2014-02-15 00:54:55.000000', 'temperatura', 569.0000, 'ºC'),
	(192472, 118, '2014-02-15 00:54:56.000000', 'temperatura', 72.0000, 'ºC'),
	(192473, 118, '2014-02-15 00:54:57.000000', 'temperatura', 1055.0000, 'ºC'),
	(192474, 118, '2014-02-15 00:54:58.000000', 'temperatura', 258.0000, 'ºC'),
	(192475, 118, '2014-02-15 00:54:59.000000', 'temperatura', 526.0000, 'ºC'),
	(192476, 118, '2014-02-15 00:55:00.000000', 'temperatura', 655.0000, 'ºC'),
	(192477, 118, '2014-02-15 00:55:01.000000', 'temperatura', 498.0000, 'ºC'),
	(192478, 118, '2014-02-15 00:55:02.000000', 'temperatura', 528.0000, 'ºC'),
	(192479, 118, '2014-02-15 00:55:03.000000', 'temperatura', 1144.0000, 'ºC'),
	(192480, 118, '2014-02-15 00:55:04.000000', 'temperatura', 537.0000, 'ºC'),
	(192481, 118, '2014-02-15 00:55:05.000000', 'temperatura', 454.0000, 'ºC'),
	(192482, 118, '2014-02-15 00:55:06.000000', 'temperatura', 661.0000, 'ºC'),
	(192483, 118, '2014-02-15 00:55:07.000000', 'temperatura', 742.0000, 'ºC'),
	(192484, 118, '2014-02-15 00:55:08.000000', 'temperatura', 530.0000, 'ºC'),
	(192485, 118, '2014-02-15 00:55:09.000000', 'temperatura', 422.0000, 'ºC'),
	(192486, 118, '2014-02-15 00:55:10.000000', 'temperatura', 519.0000, 'ºC'),
	(192487, 118, '2014-02-15 00:55:11.000000', 'temperatura', 133.0000, 'ºC'),
	(192488, 118, '2014-02-15 00:55:12.000000', 'temperatura', 306.0000, 'ºC'),
	(192489, 118, '2014-02-15 00:55:13.000000', 'temperatura', 1134.0000, 'ºC'),
	(192490, 118, '2014-02-15 00:55:14.000000', 'temperatura', 1150.0000, 'ºC'),
	(192491, 118, '2014-02-15 00:55:15.000000', 'temperatura', 1149.0000, 'ºC'),
	(192492, 118, '2014-02-15 00:55:16.000000', 'temperatura', 1098.0000, 'ºC'),
	(192493, 118, '2014-02-15 00:55:17.000000', 'temperatura', 841.0000, 'ºC'),
	(192494, 118, '2014-02-15 00:55:18.000000', 'temperatura', 911.0000, 'ºC'),
	(192495, 118, '2014-02-15 00:55:19.000000', 'temperatura', 835.0000, 'ºC'),
	(192496, 118, '2014-02-15 00:55:20.000000', 'temperatura', 242.0000, 'ºC'),
	(192497, 118, '2014-02-15 00:55:21.000000', 'temperatura', 1103.0000, 'ºC'),
	(192498, 118, '2014-02-15 00:55:22.000000', 'temperatura', 1192.0000, 'ºC'),
	(192499, 118, '2014-02-15 00:55:23.000000', 'temperatura', 250.0000, 'ºC'),
	(192500, 118, '2014-02-15 00:55:24.000000', 'temperatura', 77.0000, 'ºC'),
	(192501, 118, '2014-02-15 00:55:25.000000', 'temperatura', 832.0000, 'ºC'),
	(192502, 118, '2014-02-15 00:55:26.000000', 'temperatura', 332.0000, 'ºC'),
	(192503, 118, '2014-02-15 00:55:27.000000', 'temperatura', 363.0000, 'ºC'),
	(192504, 118, '2014-02-15 00:55:28.000000', 'temperatura', 819.0000, 'ºC'),
	(192505, 118, '2014-02-15 00:55:29.000000', 'temperatura', 608.0000, 'ºC'),
	(192506, 118, '2014-02-15 00:55:30.000000', 'temperatura', 584.0000, 'ºC'),
	(192507, 118, '2014-02-15 00:55:31.000000', 'temperatura', 1096.0000, 'ºC'),
	(192508, 118, '2014-02-15 00:55:32.000000', 'temperatura', 129.0000, 'ºC'),
	(192509, 118, '2014-02-15 00:55:33.000000', 'temperatura', 958.0000, 'ºC'),
	(192510, 118, '2014-02-15 00:55:34.000000', 'temperatura', 804.0000, 'ºC'),
	(192511, 118, '2014-02-15 00:55:35.000000', 'temperatura', 1146.0000, 'ºC'),
	(192512, 118, '2014-02-15 00:55:36.000000', 'temperatura', 917.0000, 'ºC'),
	(192513, 118, '2014-02-15 00:55:37.000000', 'temperatura', 1148.0000, 'ºC'),
	(192514, 118, '2014-02-15 00:55:38.000000', 'temperatura', 591.0000, 'ºC'),
	(192515, 118, '2014-02-15 00:55:39.000000', 'temperatura', 710.0000, 'ºC'),
	(192516, 118, '2014-02-15 00:55:40.000000', 'temperatura', 580.0000, 'ºC'),
	(192517, 118, '2014-02-15 00:55:41.000000', 'temperatura', 767.0000, 'ºC'),
	(192518, 118, '2014-02-15 00:55:42.000000', 'temperatura', 898.0000, 'ºC'),
	(192519, 118, '2014-02-15 00:55:43.000000', 'temperatura', 989.0000, 'ºC'),
	(192520, 118, '2014-02-15 00:55:44.000000', 'temperatura', 1053.0000, 'ºC'),
	(192521, 118, '2014-02-15 00:55:45.000000', 'temperatura', 1095.0000, 'ºC'),
	(192522, 118, '2014-02-15 00:55:46.000000', 'temperatura', 1120.0000, 'ºC'),
	(192523, 118, '2014-02-15 00:55:47.000000', 'temperatura', 1113.0000, 'ºC'),
	(192524, 118, '2014-02-15 00:55:48.000000', 'temperatura', 1008.0000, 'ºC'),
	(192525, 118, '2014-02-15 00:55:49.000000', 'temperatura', 500.0000, 'ºC'),
	(192526, 118, '2014-02-15 00:55:50.000000', 'temperatura', 676.0000, 'ºC'),
	(192527, 118, '2014-02-15 00:55:51.000000', 'temperatura', 680.0000, 'ºC'),
	(192528, 118, '2014-02-15 00:55:52.000000', 'temperatura', 173.0000, 'ºC'),
	(192529, 118, '2014-02-15 00:55:53.000000', 'temperatura', 25.0000, 'ºC'),
	(192530, 118, '2014-02-15 00:55:54.000000', 'temperatura', 806.0000, 'ºC'),
	(192531, 118, '2014-02-15 00:55:55.000000', 'temperatura', 358.0000, 'ºC'),
	(192532, 118, '2014-02-15 00:55:56.000000', 'temperatura', 571.0000, 'ºC'),
	(192533, 118, '2014-02-15 00:55:57.000000', 'temperatura', 582.0000, 'ºC'),
	(192534, 118, '2014-02-15 00:55:58.000000', 'temperatura', 1195.0000, 'ºC'),
	(192535, 118, '2014-02-15 00:55:59.000000', 'temperatura', 632.0000, 'ºC'),
	(192536, 118, '2014-02-15 00:56:00.000000', 'temperatura', 773.0000, 'ºC'),
	(192537, 118, '2014-02-15 00:56:01.000000', 'temperatura', 771.0000, 'ºC'),
	(192538, 118, '2014-02-15 00:56:02.000000', 'temperatura', 336.0000, 'ºC'),
	(192539, 118, '2014-02-15 00:56:03.000000', 'temperatura', 567.0000, 'ºC'),
	(192540, 118, '2014-02-15 00:56:04.000000', 'temperatura', 628.0000, 'ºC'),
	(192541, 118, '2014-02-15 00:56:05.000000', 'temperatura', 240.0000, 'ºC'),
	(192542, 118, '2014-02-15 00:56:06.000000', 'temperatura', 516.0000, 'ºC'),
	(192543, 118, '2014-02-15 00:56:07.000000', 'temperatura', 661.0000, 'ºC'),
	(192544, 118, '2014-02-15 00:56:08.000000', 'temperatura', 557.0000, 'ºC'),
	(192545, 118, '2014-02-15 00:56:09.000000', 'temperatura', 804.0000, 'ºC'),
	(192546, 118, '2014-02-15 00:56:10.000000', 'temperatura', 1149.0000, 'ºC'),
	(192547, 118, '2014-02-15 00:56:11.000000', 'temperatura', 935.0000, 'ºC'),
	(192548, 118, '2014-02-15 00:56:12.000000', 'temperatura', 28.0000, 'ºC'),
	(192549, 118, '2014-02-15 00:56:13.000000', 'temperatura', 935.0000, 'ºC'),
	(192550, 118, '2014-02-15 00:56:14.000000', 'temperatura', 992.0000, 'ºC'),
	(192551, 118, '2014-02-15 00:56:15.000000', 'temperatura', 955.0000, 'ºC'),
	(192552, 118, '2014-02-15 00:56:16.000000', 'temperatura', 599.0000, 'ºC'),
	(192553, 118, '2014-02-15 00:56:17.000000', 'temperatura', 132.0000, 'ºC'),
	(192554, 118, '2014-02-15 00:56:18.000000', 'temperatura', 64.0000, 'ºC'),
	(192555, 118, '2014-02-15 00:56:19.000000', 'temperatura', 1125.0000, 'ºC'),
	(192556, 118, '2014-02-15 00:56:20.000000', 'temperatura', 631.0000, 'ºC'),
	(192557, 118, '2014-02-15 00:56:21.000000', 'temperatura', 981.0000, 'ºC'),
	(192558, 118, '2014-02-15 00:56:22.000000', 'temperatura', 614.0000, 'ºC'),
	(192559, 118, '2014-02-15 00:56:23.000000', 'temperatura', 128.0000, 'ºC'),
	(192560, 118, '2014-02-15 00:56:24.000000', 'temperatura', 1196.0000, 'ºC'),
	(192561, 118, '2014-02-15 00:56:25.000000', 'temperatura', 797.0000, 'ºC'),
	(192562, 118, '2014-02-15 00:56:26.000000', 'temperatura', 399.0000, 'ºC'),
	(192563, 118, '2014-02-15 00:56:27.000000', 'temperatura', 806.0000, 'ºC'),
	(192564, 118, '2014-02-15 00:56:28.000000', 'temperatura', 431.0000, 'ºC'),
	(192565, 118, '2014-02-15 00:56:29.000000', 'temperatura', 940.0000, 'ºC'),
	(192566, 118, '2014-02-15 00:56:30.000000', 'temperatura', 1005.0000, 'ºC'),
	(192567, 118, '2014-02-15 00:56:31.000000', 'temperatura', 1006.0000, 'ºC'),
	(192568, 118, '2014-02-15 00:56:32.000000', 'temperatura', 814.0000, 'ºC'),
	(192569, 118, '2014-02-15 00:56:33.000000', 'temperatura', 1056.0000, 'ºC'),
	(192570, 118, '2014-02-15 00:56:34.000000', 'temperatura', 435.0000, 'ºC'),
	(192571, 118, '2014-02-15 00:56:35.000000', 'temperatura', 210.0000, 'ºC'),
	(192572, 118, '2014-02-15 00:56:36.000000', 'temperatura', 947.0000, 'ºC'),
	(192573, 118, '2014-02-15 00:56:37.000000', 'temperatura', 502.0000, 'ºC'),
	(192574, 118, '2014-02-15 00:56:38.000000', 'temperatura', 872.0000, 'ºC'),
	(192575, 118, '2014-02-15 00:56:39.000000', 'temperatura', 452.0000, 'ºC'),
	(192576, 118, '2014-02-15 00:56:40.000000', 'temperatura', 847.0000, 'ºC'),
	(192577, 118, '2014-02-15 00:56:41.000000', 'temperatura', 478.0000, 'ºC'),
	(192578, 118, '2014-02-15 00:56:42.000000', 'temperatura', 1050.0000, 'ºC'),
	(192579, 118, '2014-02-15 00:56:43.000000', 'temperatura', 218.0000, 'ºC'),
	(192580, 118, '2014-02-15 00:56:44.000000', 'temperatura', 339.0000, 'ºC'),
	(192581, 118, '2014-02-15 00:56:45.000000', 'temperatura', 1042.0000, 'ºC'),
	(192582, 118, '2014-02-15 00:56:46.000000', 'temperatura', 594.0000, 'ºC'),
	(192583, 118, '2014-02-15 00:56:47.000000', 'temperatura', 1042.0000, 'ºC'),
	(192584, 118, '2014-02-15 00:56:48.000000', 'temperatura', 1031.0000, 'ºC'),
	(192585, 118, '2014-02-15 00:56:49.000000', 'temperatura', 828.0000, 'ºC'),
	(192586, 118, '2014-02-15 00:56:50.000000', 'temperatura', 1050.0000, 'ºC'),
	(192587, 118, '2014-02-15 00:56:51.000000', 'temperatura', 364.0000, 'ºC'),
	(192588, 118, '2014-02-15 00:56:52.000000', 'temperatura', 1069.0000, 'ºC'),
	(192589, 118, '2014-02-15 00:56:53.000000', 'temperatura', 656.0000, 'ºC'),
	(192590, 118, '2014-02-15 00:56:54.000000', 'temperatura', 73.0000, 'ºC'),
	(192591, 118, '2014-02-15 00:56:55.000000', 'temperatura', 796.0000, 'ºC'),
	(192592, 118, '2014-02-15 00:56:56.000000', 'temperatura', 164.0000, 'ºC'),
	(192593, 118, '2014-02-15 00:56:57.000000', 'temperatura', 830.0000, 'ºC'),
	(192594, 118, '2014-02-15 00:56:58.000000', 'temperatura', 58.0000, 'ºC'),
	(192595, 118, '2014-02-15 00:56:59.000000', 'temperatura', 201.0000, 'ºC'),
	(192596, 118, '2014-02-15 00:57:00.000000', 'temperatura', 831.0000, 'ºC'),
	(192597, 118, '2014-02-15 00:57:01.000000', 'temperatura', 1152.0000, 'ºC'),
	(192598, 118, '2014-02-15 00:57:02.000000', 'temperatura', 868.0000, 'ºC'),
	(192599, 118, '2014-02-15 00:57:03.000000', 'temperatura', 885.0000, 'ºC'),
	(192600, 118, '2014-02-15 00:57:04.000000', 'temperatura', 621.0000, 'ºC'),
	(192601, 118, '2014-02-15 00:57:05.000000', 'temperatura', 453.0000, 'ºC'),
	(192602, 118, '2014-02-15 00:57:06.000000', 'temperatura', 400.0000, 'ºC'),
	(192603, 118, '2014-02-15 00:57:07.000000', 'temperatura', 643.0000, 'ºC'),
	(192604, 118, '2014-02-15 00:57:08.000000', 'temperatura', 815.0000, 'ºC'),
	(192605, 118, '2014-02-15 00:57:09.000000', 'temperatura', 945.0000, 'ºC'),
	(192606, 118, '2014-02-15 00:57:10.000000', 'temperatura', 1080.0000, 'ºC'),
	(192607, 118, '2014-02-15 00:57:11.000000', 'temperatura', 167.0000, 'ºC'),
	(192608, 118, '2014-02-15 00:57:12.000000', 'temperatura', 1193.0000, 'ºC'),
	(192609, 118, '2014-02-15 00:57:13.000000', 'temperatura', 667.0000, 'ºC'),
	(192610, 118, '2014-02-15 00:57:14.000000', 'temperatura', 956.0000, 'ºC'),
	(192611, 118, '2014-02-15 00:57:15.000000', 'temperatura', 378.0000, 'ºC'),
	(192612, 118, '2014-02-15 00:57:16.000000', 'temperatura', 224.0000, 'ºC'),
	(192613, 118, '2014-02-15 00:57:17.000000', 'temperatura', 1185.0000, 'ºC'),
	(192614, 118, '2014-02-15 00:57:18.000000', 'temperatura', 456.0000, 'ºC'),
	(192615, 118, '2014-02-15 00:57:19.000000', 'temperatura', 1124.0000, 'ºC'),
	(192616, 118, '2014-02-15 00:57:20.000000', 'temperatura', 654.0000, 'ºC'),
	(192617, 118, '2014-02-15 00:57:21.000000', 'temperatura', 1099.0000, 'ºC'),
	(192618, 118, '2014-02-15 00:57:22.000000', 'temperatura', 1133.0000, 'ºC'),
	(192619, 118, '2014-02-15 00:57:23.000000', 'temperatura', 1169.0000, 'ºC'),
	(192620, 118, '2014-02-15 00:57:24.000000', 'temperatura', 48.0000, 'ºC'),
	(192621, 118, '2014-02-15 00:57:25.000000', 'temperatura', 331.0000, 'ºC'),
	(192622, 118, '2014-02-15 00:57:26.000000', 'temperatura', 314.0000, 'ºC'),
	(192623, 118, '2014-02-15 00:57:27.000000', 'temperatura', 575.0000, 'ºC'),
	(192624, 118, '2014-02-15 00:57:28.000000', 'temperatura', 733.0000, 'ºC'),
	(192625, 118, '2014-02-15 00:57:29.000000', 'temperatura', 740.0000, 'ºC'),
	(192626, 118, '2014-02-15 00:57:30.000000', 'temperatura', 304.0000, 'ºC'),
	(192627, 118, '2014-02-15 00:57:31.000000', 'temperatura', 501.0000, 'ºC'),
	(192628, 118, '2014-02-15 00:57:32.000000', 'temperatura', 392.0000, 'ºC'),
	(192629, 118, '2014-02-15 00:57:33.000000', 'temperatura', 460.0000, 'ºC'),
	(192630, 118, '2014-02-15 00:57:34.000000', 'temperatura', 1121.0000, 'ºC'),
	(192631, 118, '2014-02-15 00:57:35.000000', 'temperatura', 627.0000, 'ºC'),
	(192632, 118, '2014-02-15 00:57:36.000000', 'temperatura', 972.0000, 'ºC'),
	(192633, 118, '2014-02-15 00:57:37.000000', 'temperatura', 578.0000, 'ºC'),
	(192634, 118, '2014-02-15 00:57:38.000000', 'temperatura', 1177.0000, 'ºC'),
	(192635, 118, '2014-02-15 00:57:39.000000', 'temperatura', 550.0000, 'ºC'),
	(192636, 118, '2014-02-15 00:57:40.000000', 'temperatura', 418.0000, 'ºC'),
	(192637, 118, '2014-02-15 00:57:41.000000', 'temperatura', 442.0000, 'ºC'),
	(192638, 118, '2014-02-15 00:57:42.000000', 'temperatura', 958.0000, 'ºC'),
	(192639, 118, '2014-02-15 00:57:43.000000', 'temperatura', 1062.0000, 'ºC'),
	(192640, 118, '2014-02-15 00:57:44.000000', 'temperatura', 38.0000, 'ºC'),
	(192641, 118, '2014-02-15 00:57:45.000000', 'temperatura', 603.0000, 'ºC'),
	(192642, 118, '2014-02-15 00:57:46.000000', 'temperatura', 504.0000, 'ºC'),
	(192643, 118, '2014-02-15 00:57:47.000000', 'temperatura', 711.0000, 'ºC'),
	(192644, 118, '2014-02-15 00:57:48.000000', 'temperatura', 844.0000, 'ºC'),
	(192645, 118, '2014-02-15 00:57:49.000000', 'temperatura', 887.0000, 'ºC'),
	(192646, 118, '2014-02-15 00:57:50.000000', 'temperatura', 704.0000, 'ºC'),
	(192647, 118, '2014-02-15 00:57:51.000000', 'temperatura', 861.0000, 'ºC'),
	(192648, 118, '2014-02-15 00:57:52.000000', 'temperatura', 993.0000, 'ºC'),
	(192649, 118, '2014-02-15 00:57:53.000000', 'temperatura', 1182.0000, 'ºC'),
	(192650, 118, '2014-02-15 00:57:54.000000', 'temperatura', 530.0000, 'ºC'),
	(192651, 118, '2014-02-15 00:57:55.000000', 'temperatura', 307.0000, 'ºC'),
	(192652, 118, '2014-02-15 00:57:56.000000', 'temperatura', 1143.0000, 'ºC'),
	(192653, 118, '2014-02-15 00:57:57.000000', 'temperatura', 1196.0000, 'ºC'),
	(192654, 118, '2014-02-15 00:57:58.000000', 'temperatura', 150.0000, 'ºC'),
	(192655, 118, '2014-02-15 00:57:59.000000', 'temperatura', 763.0000, 'ºC'),
	(192656, 118, '2014-02-15 00:58:00.000000', 'temperatura', 964.0000, 'ºC'),
	(192657, 118, '2014-02-15 00:58:01.000000', 'temperatura', 135.0000, 'ºC'),
	(192658, 118, '2014-02-15 00:58:02.000000', 'temperatura', 181.0000, 'ºC'),
	(192659, 118, '2014-02-15 00:58:03.000000', 'temperatura', 499.0000, 'ºC'),
	(192660, 118, '2014-02-15 00:58:04.000000', 'temperatura', 756.0000, 'ºC'),
	(192661, 118, '2014-02-15 00:58:05.000000', 'temperatura', 1082.0000, 'ºC'),
	(192662, 118, '2014-02-15 00:58:06.000000', 'temperatura', 742.0000, 'ºC'),
	(192663, 118, '2014-02-15 00:58:07.000000', 'temperatura', 465.0000, 'ºC'),
	(192664, 118, '2014-02-15 00:58:08.000000', 'temperatura', 100.0000, 'ºC'),
	(192665, 118, '2014-02-15 00:58:09.000000', 'temperatura', 306.0000, 'ºC'),
	(192666, 118, '2014-02-15 00:58:10.000000', 'temperatura', 29.0000, 'ºC'),
	(192667, 118, '2014-02-15 00:58:11.000000', 'temperatura', 429.0000, 'ºC'),
	(192668, 118, '2014-02-15 00:58:12.000000', 'temperatura', 859.0000, 'ºC'),
	(192669, 118, '2014-02-15 00:58:13.000000', 'temperatura', 606.0000, 'ºC'),
	(192670, 118, '2014-02-15 00:58:14.000000', 'temperatura', 456.0000, 'ºC'),
	(192671, 118, '2014-02-15 00:58:15.000000', 'temperatura', 461.0000, 'ºC'),
	(192672, 118, '2014-02-15 00:58:16.000000', 'temperatura', 937.0000, 'ºC'),
	(192673, 118, '2014-02-15 00:58:17.000000', 'temperatura', 901.0000, 'ºC'),
	(192674, 118, '2014-02-15 00:58:18.000000', 'temperatura', 497.0000, 'ºC'),
	(192675, 118, '2014-02-15 00:58:19.000000', 'temperatura', 981.0000, 'ºC'),
	(192676, 118, '2014-02-15 00:58:20.000000', 'temperatura', 1014.0000, 'ºC'),
	(192677, 118, '2014-02-15 00:58:21.000000', 'temperatura', 930.0000, 'ºC'),
	(192678, 118, '2014-02-15 00:58:22.000000', 'temperatura', 406.0000, 'ºC'),
	(192679, 118, '2014-02-15 00:58:23.000000', 'temperatura', 442.0000, 'ºC'),
	(192680, 118, '2014-02-15 00:58:24.000000', 'temperatura', 990.0000, 'ºC'),
	(192681, 118, '2014-02-15 00:58:25.000000', 'temperatura', 26.0000, 'ºC'),
	(192682, 118, '2014-02-15 00:58:26.000000', 'temperatura', 762.0000, 'ºC'),
	(192683, 118, '2014-02-15 00:58:27.000000', 'temperatura', 131.0000, 'ºC'),
	(192684, 118, '2014-02-15 00:58:28.000000', 'temperatura', 770.0000, 'ºC'),
	(192685, 118, '2014-02-15 00:58:29.000000', 'temperatura', 1055.0000, 'ºC'),
	(192686, 118, '2014-02-15 00:58:30.000000', 'temperatura', 569.0000, 'ºC'),
	(192687, 118, '2014-02-15 00:58:31.000000', 'temperatura', 879.0000, 'ºC'),
	(192688, 118, '2014-02-15 00:58:32.000000', 'temperatura', 289.0000, 'ºC'),
	(192689, 118, '2014-02-15 00:58:33.000000', 'temperatura', 8.0000, 'ºC'),
	(192690, 118, '2014-02-15 00:58:34.000000', 'temperatura', 373.0000, 'ºC'),
	(192691, 118, '2014-02-15 00:58:35.000000', 'temperatura', 644.0000, 'ºC'),
	(192692, 118, '2014-02-15 00:58:36.000000', 'temperatura', 900.0000, 'ºC'),
	(192693, 118, '2014-02-15 00:58:37.000000', 'temperatura', 168.0000, 'ºC'),
	(192694, 118, '2014-02-15 00:58:38.000000', 'temperatura', 542.0000, 'ºC'),
	(192695, 118, '2014-02-15 00:58:39.000000', 'temperatura', 1006.0000, 'ºC'),
	(192696, 118, '2014-02-15 00:58:40.000000', 'temperatura', 1004.0000, 'ºC'),
	(192697, 118, '2014-02-15 00:58:41.000000', 'temperatura', 805.0000, 'ºC'),
	(192698, 118, '2014-02-15 00:58:42.000000', 'temperatura', 1010.0000, 'ºC'),
	(192699, 118, '2014-02-15 00:58:43.000000', 'temperatura', 237.0000, 'ºC'),
	(192700, 118, '2014-02-15 00:58:44.000000', 'temperatura', 556.0000, 'ºC'),
	(192701, 118, '2014-02-15 00:58:45.000000', 'temperatura', 870.0000, 'ºC'),
	(192702, 118, '2014-02-15 00:58:46.000000', 'temperatura', 283.0000, 'ºC'),
	(192703, 118, '2014-02-15 00:58:47.000000', 'temperatura', 3.0000, 'ºC'),
	(192704, 118, '2014-02-15 00:58:48.000000', 'temperatura', 366.0000, 'ºC'),
	(192705, 118, '2014-02-15 00:58:49.000000', 'temperatura', 624.0000, 'ºC'),
	(192706, 118, '2014-02-15 00:58:50.000000', 'temperatura', 822.0000, 'ºC'),
	(192707, 118, '2014-02-15 00:58:51.000000', 'temperatura', 1038.0000, 'ºC'),
	(192708, 118, '2014-02-15 00:58:52.000000', 'temperatura', 326.0000, 'ºC'),
	(192709, 118, '2014-02-15 00:58:53.000000', 'temperatura', 915.0000, 'ºC'),
	(192710, 118, '2014-02-15 00:58:54.000000', 'temperatura', 1196.0000, 'ºC'),
	(192711, 118, '2014-02-15 00:58:55.000000', 'temperatura', 836.0000, 'ºC'),
	(192712, 118, '2014-02-15 00:58:56.000000', 'temperatura', 594.0000, 'ºC'),
	(192713, 118, '2014-02-15 00:58:57.000000', 'temperatura', 462.0000, 'ºC'),
	(192714, 118, '2014-02-15 00:58:58.000000', 'temperatura', 530.0000, 'ºC'),
	(192715, 118, '2014-02-15 00:58:59.000000', 'temperatura', 62.0000, 'ºC'),
	(192716, 118, '2014-02-15 00:59:00.000000', 'temperatura', 1120.0000, 'ºC'),
	(192717, 118, '2014-02-15 00:59:01.000000', 'temperatura', 615.0000, 'ºC'),
	(192718, 118, '2014-02-15 00:59:02.000000', 'temperatura', 918.0000, 'ºC'),
	(192719, 118, '2014-02-15 00:59:03.000000', 'temperatura', 343.0000, 'ºC'),
	(192720, 118, '2014-02-15 00:59:04.000000', 'temperatura', 162.0000, 'ºC'),
	(192721, 118, '2014-02-15 00:59:05.000000', 'temperatura', 982.0000, 'ºC'),
	(192722, 118, '2014-02-15 00:59:06.000000', 'temperatura', 825.0000, 'ºC'),
	(192723, 118, '2014-02-15 00:59:07.000000', 'temperatura', 1178.0000, 'ºC'),
	(192724, 118, '2014-02-15 00:59:08.000000', 'temperatura', 1015.0000, 'ºC'),
	(192725, 118, '2014-02-15 00:59:09.000000', 'temperatura', 344.0000, 'ºC'),
	(192726, 118, '2014-02-15 00:59:10.000000', 'temperatura', 1073.0000, 'ºC'),
	(192727, 118, '2014-02-15 00:59:11.000000', 'temperatura', 735.0000, 'ºC'),
	(192728, 118, '2014-02-15 00:59:12.000000', 'temperatura', 455.0000, 'ºC'),
	(192729, 118, '2014-02-15 00:59:13.000000', 'temperatura', 72.0000, 'ºC'),
	(192730, 118, '2014-02-15 00:59:14.000000', 'temperatura', 196.0000, 'ºC'),
	(192731, 118, '2014-02-15 00:59:15.000000', 'temperatura', 762.0000, 'ºC'),
	(192732, 118, '2014-02-15 00:59:16.000000', 'temperatura', 826.0000, 'ºC'),
	(192733, 118, '2014-02-15 00:59:17.000000', 'temperatura', 642.0000, 'ºC'),
	(192734, 118, '2014-02-15 00:59:18.000000', 'temperatura', 734.0000, 'ºC'),
	(192735, 118, '2014-02-15 00:59:19.000000', 'temperatura', 545.0000, 'ºC'),
	(192736, 118, '2014-02-15 00:59:20.000000', 'temperatura', 521.0000, 'ºC'),
	(192737, 118, '2014-02-15 00:59:21.000000', 'temperatura', 973.0000, 'ºC'),
	(192738, 118, '2014-02-15 00:59:22.000000', 'temperatura', 902.0000, 'ºC'),
	(192739, 118, '2014-02-15 00:59:23.000000', 'temperatura', 390.0000, 'ºC'),
	(192740, 118, '2014-02-15 00:59:24.000000', 'temperatura', 447.0000, 'ºC'),
	(192741, 118, '2014-02-15 00:59:25.000000', 'temperatura', 1063.0000, 'ºC'),
	(192742, 118, '2014-02-15 00:59:26.000000', 'temperatura', 373.0000, 'ºC'),
	(192743, 118, '2014-02-15 00:59:27.000000', 'temperatura', 1079.0000, 'ºC'),
	(192744, 118, '2014-02-15 00:59:28.000000', 'temperatura', 678.0000, 'ºC'),
	(192745, 118, '2014-02-15 00:59:29.000000', 'temperatura', 152.0000, 'ºC'),
	(192746, 118, '2014-02-15 00:59:30.000000', 'temperatura', 1127.0000, 'ºC'),
	(192747, 118, '2014-02-15 00:59:31.000000', 'temperatura', 380.0000, 'ºC'),
	(192748, 118, '2014-02-15 00:59:32.000000', 'temperatura', 921.0000, 'ºC'),
	(192749, 118, '2014-02-15 00:59:33.000000', 'temperatura', 1064.0000, 'ºC'),
	(192750, 118, '2014-02-15 00:59:34.000000', 'temperatura', 159.0000, 'ºC'),
	(192751, 118, '2014-02-15 00:59:35.000000', 'temperatura', 4.0000, 'ºC'),
	(192752, 118, '2014-02-15 00:59:36.000000', 'temperatura', 741.0000, 'ºC'),
	(192753, 118, '2014-02-15 00:59:37.000000', 'temperatura', 95.0000, 'ºC'),
	(192754, 118, '2014-02-15 00:59:38.000000', 'temperatura', 653.0000, 'ºC'),
	(192755, 118, '2014-02-15 00:59:39.000000', 'temperatura', 580.0000, 'ºC'),
	(192756, 118, '2014-02-15 00:59:40.000000', 'temperatura', 941.0000, 'ºC'),
	(192757, 118, '2014-02-15 00:59:41.000000', 'temperatura', 567.0000, 'ºC'),
	(192758, 118, '2014-02-15 00:59:42.000000', 'temperatura', 11.0000, 'ºC'),
	(192759, 118, '2014-02-15 00:59:43.000000', 'temperatura', 754.0000, 'ºC'),
	(192760, 118, '2014-02-15 00:59:44.000000', 'temperatura', 138.0000, 'ºC'),
	(192761, 118, '2014-02-15 00:59:45.000000', 'temperatura', 830.0000, 'ºC'),
	(192762, 118, '2014-02-15 00:59:46.000000', 'temperatura', 137.0000, 'ºC'),
	(192763, 118, '2014-02-15 00:59:47.000000', 'temperatura', 595.0000, 'ºC'),
	(192764, 118, '2014-02-15 00:59:48.000000', 'temperatura', 163.0000, 'ºC'),
	(192765, 118, '2014-02-15 00:59:49.000000', 'temperatura', 231.0000, 'ºC'),
	(192766, 118, '2014-02-15 00:59:50.000000', 'temperatura', 666.0000, 'ºC'),
	(192767, 118, '2014-02-15 00:59:51.000000', 'temperatura', 239.0000, 'ºC'),
	(192768, 118, '2014-02-15 00:59:52.000000', 'temperatura', 395.0000, 'ºC'),
	(192769, 118, '2014-02-15 00:59:53.000000', 'temperatura', 61.0000, 'ºC'),
	(192770, 118, '2014-02-15 00:59:54.000000', 'temperatura', 321.0000, 'ºC'),
	(192771, 118, '2014-02-15 00:59:55.000000', 'temperatura', 220.0000, 'ºC'),
	(192772, 118, '2014-02-15 00:59:56.000000', 'temperatura', 141.0000, 'ºC'),
	(192773, 118, '2014-02-15 00:59:57.000000', 'temperatura', 42.0000, 'ºC'),
	(192774, 118, '2014-02-15 00:59:58.000000', 'temperatura', 989.0000, 'ºC'),
	(192775, 118, '2014-02-15 00:59:59.000000', 'temperatura', 20.0000, 'ºC'),
	(192776, 118, '2014-02-15 01:00:00.000000', 'temperatura', 732.0000, 'ºC'),
	(192777, 118, '2014-02-15 01:00:01.000000', 'temperatura', 2.0000, 'ºC'),
	(192778, 118, '2014-02-15 01:00:02.000000', 'temperatura', 213.0000, 'ºC'),
	(192779, 118, '2014-02-15 01:00:03.000000', 'temperatura', 1062.0000, 'ºC'),
	(192780, 118, '2014-02-15 01:00:04.000000', 'temperatura', 1071.0000, 'ºC'),
	(192781, 118, '2014-02-15 01:00:05.000000', 'temperatura', 967.0000, 'ºC'),
	(192782, 118, '2014-02-15 01:00:06.000000', 'temperatura', 425.0000, 'ºC'),
	(192783, 118, '2014-02-15 01:00:07.000000', 'temperatura', 425.0000, 'ºC'),
	(192784, 118, '2014-02-15 01:00:08.000000', 'temperatura', 848.0000, 'ºC'),
	(192785, 118, '2014-02-15 01:00:09.000000', 'temperatura', 565.0000, 'ºC'),
	(192786, 118, '2014-02-15 01:00:10.000000', 'temperatura', 283.0000, 'ºC'),
	(192787, 118, '2014-02-15 01:00:11.000000', 'temperatura', 919.0000, 'ºC'),
	(192788, 118, '2014-02-15 01:00:12.000000', 'temperatura', 148.0000, 'ºC'),
	(192789, 118, '2014-02-15 01:00:13.000000', 'temperatura', 384.0000, 'ºC'),
	(192790, 118, '2014-02-15 01:00:14.000000', 'temperatura', 275.0000, 'ºC'),
	(192791, 118, '2014-02-15 01:00:15.000000', 'temperatura', 224.0000, 'ºC'),
	(192792, 118, '2014-02-15 01:00:16.000000', 'temperatura', 294.0000, 'ºC'),
	(192793, 118, '2014-02-15 01:00:17.000000', 'temperatura', 801.0000, 'ºC'),
	(192794, 118, '2014-02-15 01:00:18.000000', 'temperatura', 722.0000, 'ºC'),
	(192795, 118, '2014-02-15 01:00:19.000000', 'temperatura', 8.0000, 'ºC'),
	(192796, 118, '2014-02-15 01:00:20.000000', 'temperatura', 276.0000, 'ºC'),
	(192797, 118, '2014-02-15 01:00:21.000000', 'temperatura', 154.0000, 'ºC'),
	(192798, 118, '2014-02-15 01:00:22.000000', 'temperatura', 1144.0000, 'ºC'),
	(192799, 118, '2014-02-15 01:00:23.000000', 'temperatura', 458.0000, 'ºC'),
	(192800, 118, '2014-02-15 01:00:24.000000', 'temperatura', 60.0000, 'ºC'),
	(192801, 118, '2014-02-15 01:00:25.000000', 'temperatura', 125.0000, 'ºC'),
	(192802, 118, '2014-02-15 01:00:26.000000', 'temperatura', 445.0000, 'ºC'),
	(192803, 118, '2014-02-15 01:00:27.000000', 'temperatura', 652.0000, 'ºC'),
	(192804, 118, '2014-02-15 01:00:28.000000', 'temperatura', 723.0000, 'ºC'),
	(192805, 118, '2014-02-15 01:00:29.000000', 'temperatura', 461.0000, 'ºC'),
	(192806, 118, '2014-02-15 01:00:30.000000', 'temperatura', 136.0000, 'ºC'),
	(192807, 118, '2014-02-15 01:00:31.000000', 'temperatura', 498.0000, 'ºC'),
	(192808, 118, '2014-02-15 01:00:32.000000', 'temperatura', 883.0000, 'ºC'),
	(192809, 118, '2014-02-15 01:00:33.000000', 'temperatura', 521.0000, 'ºC'),
	(192810, 118, '2014-02-15 01:00:34.000000', 'temperatura', 1157.0000, 'ºC'),
	(192811, 118, '2014-02-15 01:00:35.000000', 'temperatura', 623.0000, 'ºC'),
	(192812, 118, '2014-02-15 01:00:36.000000', 'temperatura', 845.0000, 'ºC'),
	(192813, 118, '2014-02-15 01:00:37.000000', 'temperatura', 1158.0000, 'ºC'),
	(192814, 118, '2014-02-15 01:00:38.000000', 'temperatura', 853.0000, 'ºC'),
	(192815, 118, '2014-02-15 01:00:39.000000', 'temperatura', 794.0000, 'ºC'),
	(192816, 118, '2014-02-15 01:00:40.000000', 'temperatura', 209.0000, 'ºC'),
	(192817, 118, '2014-02-15 01:00:41.000000', 'temperatura', 1063.0000, 'ºC'),
	(192818, 118, '2014-02-15 01:00:42.000000', 'temperatura', 1088.0000, 'ºC'),
	(192819, 118, '2014-02-15 01:00:43.000000', 'temperatura', 1053.0000, 'ºC'),
	(192820, 118, '2014-02-15 01:00:44.000000', 'temperatura', 800.0000, 'ºC'),
	(192821, 118, '2014-02-15 01:00:45.000000', 'temperatura', 843.0000, 'ºC'),
	(192822, 118, '2014-02-15 01:00:46.000000', 'temperatura', 615.0000, 'ºC'),
	(192823, 118, '2014-02-15 01:00:47.000000', 'temperatura', 547.0000, 'ºC'),
	(192824, 118, '2014-02-15 01:00:48.000000', 'temperatura', 891.0000, 'ºC'),
	(192825, 118, '2014-02-15 01:00:49.000000', 'temperatura', 412.0000, 'ºC'),
	(192826, 118, '2014-02-15 01:00:50.000000', 'temperatura', 588.0000, 'ºC'),
	(192827, 118, '2014-02-15 01:00:51.000000', 'temperatura', 507.0000, 'ºC'),
	(192828, 118, '2014-02-15 01:00:52.000000', 'temperatura', 770.0000, 'ºC'),
	(192829, 118, '2014-02-15 01:00:53.000000', 'temperatura', 1130.0000, 'ºC'),
	(192830, 118, '2014-02-15 01:00:54.000000', 'temperatura', 942.0000, 'ºC'),
	(192831, 118, '2014-02-15 01:00:55.000000', 'temperatura', 121.0000, 'ºC'),
	(192832, 118, '2014-02-15 01:00:56.000000', 'temperatura', 177.0000, 'ºC'),
	(192833, 118, '2014-02-15 01:00:57.000000', 'temperatura', 522.0000, 'ºC'),
	(192834, 118, '2014-02-15 01:00:58.000000', 'temperatura', 882.0000, 'ºC'),
	(192835, 118, '2014-02-15 01:00:59.000000', 'temperatura', 444.0000, 'ºC'),
	(192836, 118, '2014-02-15 01:01:00.000000', 'temperatura', 776.0000, 'ºC'),
	(192837, 118, '2014-02-15 01:01:01.000000', 'temperatura', 148.0000, 'ºC'),
	(192838, 118, '2014-02-15 01:01:02.000000', 'temperatura', 812.0000, 'ºC'),
	(192839, 118, '2014-02-15 01:01:03.000000', 'temperatura', 18.0000, 'ºC'),
	(192840, 118, '2014-02-15 01:01:04.000000', 'temperatura', 55.0000, 'ºC'),
	(192841, 118, '2014-02-15 01:01:05.000000', 'temperatura', 221.0000, 'ºC'),
	(192842, 118, '2014-02-15 01:01:06.000000', 'temperatura', 940.0000, 'ºC'),
	(192843, 118, '2014-02-15 01:01:07.000000', 'temperatura', 436.0000, 'ºC'),
	(192844, 118, '2014-02-15 01:01:08.000000', 'temperatura', 562.0000, 'ºC'),
	(192845, 118, '2014-02-15 01:01:09.000000', 'temperatura', 302.0000, 'ºC'),
	(192846, 118, '2014-02-15 01:01:10.000000', 'temperatura', 1025.0000, 'ºC'),
	(192847, 118, '2014-02-15 01:01:11.000000', 'temperatura', 621.0000, 'ºC'),
	(192848, 118, '2014-02-15 01:01:12.000000', 'temperatura', 30.0000, 'ºC'),
	(192849, 118, '2014-02-15 01:01:13.000000', 'temperatura', 688.0000, 'ºC'),
	(192850, 118, '2014-02-15 01:01:14.000000', 'temperatura', 950.0000, 'ºC'),
	(192851, 118, '2014-02-15 01:01:15.000000', 'temperatura', 288.0000, 'ºC'),
	(192852, 118, '2014-02-15 01:01:16.000000', 'temperatura', 987.0000, 'ºC'),
	(192853, 118, '2014-02-15 01:01:17.000000', 'temperatura', 474.0000, 'ºC'),
	(192854, 118, '2014-02-15 01:01:18.000000', 'temperatura', 610.0000, 'ºC'),
	(192855, 118, '2014-02-15 01:01:19.000000', 'temperatura', 430.0000, 'ºC'),
	(192856, 118, '2014-02-15 01:01:20.000000', 'temperatura', 317.0000, 'ºC'),
	(192857, 118, '2014-02-15 01:01:21.000000', 'temperatura', 298.0000, 'ºC'),
	(192858, 118, '2014-02-15 01:01:22.000000', 'temperatura', 538.0000, 'ºC'),
	(192859, 118, '2014-02-15 01:01:23.000000', 'temperatura', 596.0000, 'ºC'),
	(192860, 118, '2014-02-15 01:01:24.000000', 'temperatura', 167.0000, 'ºC'),
	(192861, 118, '2014-02-15 01:01:25.000000', 'temperatura', 246.0000, 'ºC'),
	(192862, 118, '2014-02-15 01:01:26.000000', 'temperatura', 730.0000, 'ºC'),
	(192863, 118, '2014-02-15 01:01:27.000000', 'temperatura', 512.0000, 'ºC'),
	(192864, 118, '2014-02-15 01:01:28.000000', 'temperatura', 373.0000, 'ºC'),
	(192865, 118, '2014-02-15 01:01:29.000000', 'temperatura', 329.0000, 'ºC'),
	(192866, 118, '2014-02-15 01:01:30.000000', 'temperatura', 528.0000, 'ºC'),
	(192867, 118, '2014-02-15 01:01:31.000000', 'temperatura', 450.0000, 'ºC'),
	(192868, 118, '2014-02-15 01:01:32.000000', 'temperatura', 668.0000, 'ºC'),
	(192869, 118, '2014-02-15 01:01:33.000000', 'temperatura', 793.0000, 'ºC'),
	(192870, 118, '2014-02-15 01:01:34.000000', 'temperatura', 758.0000, 'ºC'),
	(192871, 118, '2014-02-15 01:01:35.000000', 'temperatura', 211.0000, 'ºC'),
	(192872, 118, '2014-02-15 01:01:36.000000', 'temperatura', 1183.0000, 'ºC'),
	(192873, 118, '2014-02-15 01:01:37.000000', 'temperatura', 483.0000, 'ºC'),
	(192874, 118, '2014-02-15 01:01:38.000000', 'temperatura', 66.0000, 'ºC'),
	(192875, 118, '2014-02-15 01:01:39.000000', 'temperatura', 82.0000, 'ºC'),
	(192876, 118, '2014-02-15 01:01:40.000000', 'temperatura', 212.0000, 'ºC'),
	(192877, 118, '2014-02-15 01:01:41.000000', 'temperatura', 815.0000, 'ºC'),
	(192878, 118, '2014-02-15 01:01:42.000000', 'temperatura', 1037.0000, 'ºC'),
	(192879, 118, '2014-02-15 01:01:43.000000', 'temperatura', 343.0000, 'ºC'),
	(192880, 118, '2014-02-15 01:01:44.000000', 'temperatura', 1003.0000, 'ºC'),
	(192881, 118, '2014-02-15 01:01:45.000000', 'temperatura', 388.0000, 'ºC'),
	(192882, 118, '2014-02-15 01:01:46.000000', 'temperatura', 131.0000, 'ºC'),
	(192883, 118, '2014-02-15 01:01:47.000000', 'temperatura', 693.0000, 'ºC'),
	(192884, 118, '2014-02-15 01:01:48.000000', 'temperatura', 673.0000, 'ºC'),
	(192885, 118, '2014-02-15 01:01:49.000000', 'temperatura', 83.0000, 'ºC'),
	(192886, 118, '2014-02-15 01:01:50.000000', 'temperatura', 800.0000, 'ºC'),
	(192887, 118, '2014-02-15 01:01:51.000000', 'temperatura', 151.0000, 'ºC'),
	(192888, 118, '2014-02-15 01:01:52.000000', 'temperatura', 754.0000, 'ºC'),
	(192889, 118, '2014-02-15 01:01:53.000000', 'temperatura', 917.0000, 'ºC'),
	(192890, 118, '2014-02-15 01:01:54.000000', 'temperatura', 1123.0000, 'ºC'),
	(192891, 118, '2014-02-15 01:01:55.000000', 'temperatura', 464.0000, 'ºC'),
	(192892, 118, '2014-02-15 01:01:56.000000', 'temperatura', 155.0000, 'ºC'),
	(192893, 118, '2014-02-15 01:01:57.000000', 'temperatura', 580.0000, 'ºC'),
	(192894, 118, '2014-02-15 01:01:58.000000', 'temperatura', 37.0000, 'ºC'),
	(192895, 118, '2014-02-15 01:01:59.000000', 'temperatura', 844.0000, 'ºC'),
	(192896, 118, '2014-02-15 01:02:00.000000', 'temperatura', 510.0000, 'ºC'),
	(192897, 118, '2014-02-15 01:02:01.000000', 'temperatura', 19.0000, 'ºC'),
	(192898, 118, '2014-02-15 01:02:02.000000', 'temperatura', 966.0000, 'ºC'),
	(192899, 118, '2014-02-15 01:02:03.000000', 'temperatura', 1171.0000, 'ºC'),
	(192900, 118, '2014-02-15 01:02:04.000000', 'temperatura', 561.0000, 'ºC'),
	(192901, 118, '2014-02-15 01:02:05.000000', 'temperatura', 490.0000, 'ºC'),
	(192902, 118, '2014-02-15 01:02:06.000000', 'temperatura', 770.0000, 'ºC'),
	(192903, 118, '2014-02-15 01:02:07.000000', 'temperatura', 1178.0000, 'ºC'),
	(192904, 118, '2014-02-15 01:02:08.000000', 'temperatura', 1179.0000, 'ºC'),
	(192905, 118, '2014-02-15 01:02:09.000000', 'temperatura', 1164.0000, 'ºC'),
	(192906, 118, '2014-02-15 01:02:10.000000', 'temperatura', 1084.0000, 'ºC'),
	(192907, 118, '2014-02-15 01:02:11.000000', 'temperatura', 728.0000, 'ºC'),
	(192908, 118, '2014-02-15 01:02:12.000000', 'temperatura', 388.0000, 'ºC'),
	(192909, 118, '2014-02-15 01:02:13.000000', 'temperatura', 956.0000, 'ºC'),
	(192910, 118, '2014-02-15 01:02:14.000000', 'temperatura', 17.0000, 'ºC'),
	(192911, 118, '2014-02-15 01:02:15.000000', 'temperatura', 819.0000, 'ºC'),
	(192912, 118, '2014-02-15 01:02:16.000000', 'temperatura', 443.0000, 'ºC'),
	(192913, 118, '2014-02-15 01:02:17.000000', 'temperatura', 958.0000, 'ºC'),
	(192914, 118, '2014-02-15 01:02:18.000000', 'temperatura', 1064.0000, 'ºC'),
	(192915, 118, '2014-02-15 01:02:19.000000', 'temperatura', 44.0000, 'ºC'),
	(192916, 118, '2014-02-15 01:02:20.000000', 'temperatura', 629.0000, 'ºC'),
	(192917, 118, '2014-02-15 01:02:21.000000', 'temperatura', 615.0000, 'ºC'),
	(192918, 118, '2014-02-15 01:02:22.000000', 'temperatura', 1190.0000, 'ºC'),
	(192919, 118, '2014-02-15 01:02:23.000000', 'temperatura', 503.0000, 'ºC'),
	(192920, 118, '2014-02-15 01:02:24.000000', 'temperatura', 144.0000, 'ºC'),
	(192921, 118, '2014-02-15 01:02:25.000000', 'temperatura', 414.0000, 'ºC'),
	(192922, 118, '2014-02-15 01:02:26.000000', 'temperatura', 438.0000, 'ºC'),
	(192923, 118, '2014-02-15 01:02:27.000000', 'temperatura', 948.0000, 'ºC'),
	(192924, 118, '2014-02-15 01:02:28.000000', 'temperatura', 1028.0000, 'ºC'),
	(192925, 118, '2014-02-15 01:02:29.000000', 'temperatura', 1097.0000, 'ºC'),
	(192926, 118, '2014-02-15 01:02:30.000000', 'temperatura', 1199.0000, 'ºC'),
	(192927, 118, '2014-02-15 01:02:31.000000', 'temperatura', 306.0000, 'ºC'),
	(192928, 118, '2014-02-15 01:02:32.000000', 'temperatura', 331.0000, 'ºC'),
	(192929, 118, '2014-02-15 01:02:33.000000', 'temperatura', 741.0000, 'ºC'),
	(192930, 118, '2014-02-15 01:02:34.000000', 'temperatura', 311.0000, 'ºC'),
	(192931, 118, '2014-02-15 01:02:35.000000', 'temperatura', 533.0000, 'ºC'),
	(192932, 118, '2014-02-15 01:02:36.000000', 'temperatura', 534.0000, 'ºC'),
	(192933, 118, '2014-02-15 01:02:37.000000', 'temperatura', 1070.0000, 'ºC'),
	(192934, 118, '2014-02-15 01:02:38.000000', 'temperatura', 151.0000, 'ºC'),
	(192935, 118, '2014-02-15 01:02:39.000000', 'temperatura', 1143.0000, 'ºC'),
	(192936, 118, '2014-02-15 01:02:40.000000', 'temperatura', 463.0000, 'ºC'),
	(192937, 118, '2014-02-15 01:02:41.000000', 'temperatura', 86.0000, 'ºC'),
	(192938, 118, '2014-02-15 01:02:42.000000', 'temperatura', 240.0000, 'ºC'),
	(192939, 118, '2014-02-15 01:02:43.000000', 'temperatura', 943.0000, 'ºC'),
	(192940, 118, '2014-02-15 01:02:44.000000', 'temperatura', 397.0000, 'ºC'),
	(192941, 118, '2014-02-15 01:02:45.000000', 'temperatura', 355.0000, 'ºC'),
	(192942, 118, '2014-02-15 01:02:46.000000', 'temperatura', 586.0000, 'ºC'),
	(192943, 118, '2014-02-15 01:02:47.000000', 'temperatura', 663.0000, 'ºC'),
	(192944, 118, '2014-02-15 01:02:48.000000', 'temperatura', 361.0000, 'ºC'),
	(192945, 118, '2014-02-15 01:02:49.000000', 'temperatura', 1014.0000, 'ºC'),
	(192946, 118, '2014-02-15 01:02:50.000000', 'temperatura', 388.0000, 'ºC'),
	(192947, 118, '2014-02-15 01:02:51.000000', 'temperatura', 98.0000, 'ºC'),
	(192948, 118, '2014-02-15 01:02:52.000000', 'temperatura', 526.0000, 'ºC'),
	(192949, 118, '2014-02-15 01:02:53.000000', 'temperatura', 1136.0000, 'ºC'),
	(192950, 118, '2014-02-15 01:02:54.000000', 'temperatura', 502.0000, 'ºC'),
	(192951, 118, '2014-02-15 01:02:55.000000', 'temperatura', 305.0000, 'ºC'),
	(192952, 118, '2014-02-15 01:02:56.000000', 'temperatura', 20.0000, 'ºC'),
	(192953, 118, '2014-02-15 01:02:57.000000', 'temperatura', 382.0000, 'ºC'),
	(192954, 118, '2014-02-15 01:02:58.000000', 'temperatura', 654.0000, 'ºC'),
	(192955, 118, '2014-02-15 01:02:59.000000', 'temperatura', 924.0000, 'ºC'),
	(192956, 118, '2014-02-15 01:03:00.000000', 'temperatura', 260.0000, 'ºC'),
	(192957, 118, '2014-02-15 01:03:01.000000', 'temperatura', 927.0000, 'ºC'),
	(192958, 118, '2014-02-15 01:03:02.000000', 'temperatura', 258.0000, 'ºC'),
	(192959, 118, '2014-02-15 01:03:03.000000', 'temperatura', 906.0000, 'ºC'),
	(192960, 118, '2014-02-15 01:03:04.000000', 'temperatura', 156.0000, 'ºC'),
	(192961, 118, '2014-02-15 01:03:05.000000', 'temperatura', 465.0000, 'ºC'),
	(192962, 118, '2014-02-15 01:03:06.000000', 'temperatura', 657.0000, 'ºC'),
	(192963, 118, '2014-02-15 01:03:07.000000', 'temperatura', 689.0000, 'ºC'),
	(192964, 118, '2014-02-15 01:03:08.000000', 'temperatura', 276.0000, 'ºC'),
	(192965, 118, '2014-02-15 01:03:09.000000', 'temperatura', 513.0000, 'ºC'),
	(192966, 118, '2014-02-15 01:03:10.000000', 'temperatura', 535.0000, 'ºC'),
	(192967, 118, '2014-02-15 01:03:11.000000', 'temperatura', 1140.0000, 'ºC'),
	(192968, 118, '2014-02-15 01:03:12.000000', 'temperatura', 495.0000, 'ºC'),
	(192969, 118, '2014-02-15 01:03:13.000000', 'temperatura', 255.0000, 'ºC'),
	(192970, 118, '2014-02-15 01:03:14.000000', 'temperatura', 991.0000, 'ºC'),
	(192971, 118, '2014-02-15 01:03:15.000000', 'temperatura', 591.0000, 'ºC'),
	(192972, 118, '2014-02-15 01:03:16.000000', 'temperatura', 1183.0000, 'ºC'),
	(192973, 118, '2014-02-15 01:03:17.000000', 'temperatura', 540.0000, 'ºC'),
	(192974, 118, '2014-02-15 01:03:18.000000', 'temperatura', 353.0000, 'ºC'),
	(192975, 118, '2014-02-15 01:03:19.000000', 'temperatura', 143.0000, 'ºC'),
	(192976, 118, '2014-02-15 01:03:20.000000', 'temperatura', 860.0000, 'ºC'),
	(192977, 118, '2014-02-15 01:03:21.000000', 'temperatura', 271.0000, 'ºC'),
	(192978, 118, '2014-02-15 01:03:22.000000', 'temperatura', 1173.0000, 'ºC'),
	(192979, 118, '2014-02-15 01:03:23.000000', 'temperatura', 255.0000, 'ºC'),
	(192980, 118, '2014-02-15 01:03:24.000000', 'temperatura', 156.0000, 'ºC'),
	(192981, 118, '2014-02-15 01:03:25.000000', 'temperatura', 16.0000, 'ºC'),
	(192982, 118, '2014-02-15 01:03:26.000000', 'temperatura', 810.0000, 'ºC'),
	(192983, 118, '2014-02-15 01:03:27.000000', 'temperatura', 404.0000, 'ºC'),
	(192984, 118, '2014-02-15 01:03:28.000000', 'temperatura', 790.0000, 'ºC'),
	(192985, 118, '2014-02-15 01:03:29.000000', 'temperatura', 338.0000, 'ºC'),
	(192986, 118, '2014-02-15 01:03:30.000000', 'temperatura', 522.0000, 'ºC'),
	(192987, 118, '2014-02-15 01:03:31.000000', 'temperatura', 398.0000, 'ºC'),
	(192988, 118, '2014-02-15 01:03:32.000000', 'temperatura', 422.0000, 'ºC'),
	(192989, 118, '2014-02-15 01:03:33.000000', 'temperatura', 916.0000, 'ºC'),
	(192990, 118, '2014-02-15 01:03:34.000000', 'temperatura', 914.0000, 'ºC'),
	(192991, 118, '2014-02-15 01:03:35.000000', 'temperatura', 625.0000, 'ºC'),
	(192992, 118, '2014-02-15 01:03:36.000000', 'temperatura', 383.0000, 'ºC'),
	(192993, 118, '2014-02-15 01:03:37.000000', 'temperatura', 41.0000, 'ºC'),
	(192994, 118, '2014-02-15 01:03:38.000000', 'temperatura', 255.0000, 'ºC'),
	(192995, 118, '2014-02-15 01:03:39.000000', 'temperatura', 1154.0000, 'ºC'),
	(192996, 118, '2014-02-15 01:03:40.000000', 'temperatura', 206.0000, 'ºC'),
	(192997, 118, '2014-02-15 01:03:41.000000', 'temperatura', 1166.0000, 'ºC'),
	(192998, 118, '2014-02-15 01:03:42.000000', 'temperatura', 415.0000, 'ºC'),
	(192999, 118, '2014-02-15 01:03:43.000000', 'temperatura', 976.0000, 'ºC'),
	(193000, 118, '2014-02-15 01:03:44.000000', 'temperatura', 37.0000, 'ºC'),
	(193001, 118, '2014-02-15 01:03:45.000000', 'temperatura', 858.0000, 'ºC'),
	(193002, 118, '2014-02-15 01:03:46.000000', 'temperatura', 580.0000, 'ºC'),
	(193003, 118, '2014-02-15 01:03:47.000000', 'temperatura', 326.0000, 'ºC'),
	(193004, 118, '2014-02-15 01:03:48.000000', 'temperatura', 1088.0000, 'ºC'),
	(193005, 118, '2014-02-15 01:03:49.000000', 'temperatura', 866.0000, 'ºC'),
	(193006, 118, '2014-02-15 01:03:50.000000', 'temperatura', 1063.0000, 'ºC'),
	(193007, 118, '2014-02-15 01:03:51.000000', 'temperatura', 319.0000, 'ºC'),
	(193008, 118, '2014-02-15 01:03:52.000000', 'temperatura', 808.0000, 'ºC'),
	(193009, 118, '2014-02-15 01:03:53.000000', 'temperatura', 683.0000, 'ºC'),
	(193010, 118, '2014-02-15 01:03:54.000000', 'temperatura', 990.0000, 'ºC'),
	(193011, 118, '2014-02-15 01:03:55.000000', 'temperatura', 504.0000, 'ºC'),
	(193012, 118, '2014-02-15 01:03:56.000000', 'temperatura', 750.0000, 'ºC'),
	(193013, 118, '2014-02-15 01:03:57.000000', 'temperatura', 1039.0000, 'ºC'),
	(193014, 118, '2014-02-15 01:03:58.000000', 'temperatura', 543.0000, 'ºC'),
	(193015, 118, '2014-02-15 01:03:59.000000', 'temperatura', 802.0000, 'ºC'),
	(193016, 118, '2014-02-15 01:04:00.000000', 'temperatura', 1179.0000, 'ºC'),
	(193017, 118, '2014-02-15 01:04:01.000000', 'temperatura', 1091.0000, 'ºC'),
	(193018, 118, '2014-02-15 01:04:02.000000', 'temperatura', 719.0000, 'ºC'),
	(193019, 118, '2014-02-15 01:04:03.000000', 'temperatura', 323.0000, 'ºC'),
	(193020, 118, '2014-02-15 01:04:04.000000', 'temperatura', 656.0000, 'ºC'),
	(193021, 118, '2014-02-15 01:04:05.000000', 'temperatura', 1111.0000, 'ºC'),
	(193022, 118, '2014-02-15 01:04:06.000000', 'temperatura', 1188.0000, 'ºC'),
	(193023, 118, '2014-02-15 01:04:07.000000', 'temperatura', 206.0000, 'ºC'),
	(193024, 118, '2014-02-15 01:04:08.000000', 'temperatura', 1068.0000, 'ºC'),
	(193025, 118, '2014-02-15 01:04:09.000000', 'temperatura', 1123.0000, 'ºC'),
	(193026, 118, '2014-02-15 01:04:10.000000', 'temperatura', 13.0000, 'ºC'),
	(193027, 118, '2014-02-15 01:04:11.000000', 'temperatura', 295.0000, 'ºC'),
	(193028, 118, '2014-02-15 01:04:12.000000', 'temperatura', 235.0000, 'ºC'),
	(193029, 118, '2014-02-15 01:04:13.000000', 'temperatura', 290.0000, 'ºC'),
	(193030, 118, '2014-02-15 01:04:14.000000', 'temperatura', 745.0000, 'ºC'),
	(193031, 118, '2014-02-15 01:04:15.000000', 'temperatura', 456.0000, 'ºC'),
	(193032, 118, '2014-02-15 01:04:16.000000', 'temperatura', 45.0000, 'ºC'),
	(193033, 118, '2014-02-15 01:04:17.000000', 'temperatura', 60.0000, 'ºC'),
	(193034, 118, '2014-02-15 01:04:18.000000', 'temperatura', 162.0000, 'ºC'),
	(193035, 118, '2014-02-15 01:04:19.000000', 'temperatura', 633.0000, 'ºC'),
	(193036, 118, '2014-02-15 01:04:20.000000', 'temperatura', 278.0000, 'ºC'),
	(193037, 118, '2014-02-15 01:04:21.000000', 'temperatura', 691.0000, 'ºC'),
	(193038, 118, '2014-02-15 01:04:22.000000', 'temperatura', 224.0000, 'ºC'),
	(193039, 118, '2014-02-15 01:04:23.000000', 'temperatura', 247.0000, 'ºC'),
	(193040, 118, '2014-02-15 01:04:24.000000', 'temperatura', 562.0000, 'ºC'),
	(193041, 118, '2014-02-15 01:04:25.000000', 'temperatura', 870.0000, 'ºC'),
	(193042, 118, '2014-02-15 01:04:26.000000', 'temperatura', 264.0000, 'ºC'),
	(193043, 118, '2014-02-15 01:04:27.000000', 'temperatura', 1109.0000, 'ºC'),
	(193044, 118, '2014-02-15 01:04:28.000000', 'temperatura', 1157.0000, 'ºC'),
	(193045, 118, '2014-02-15 01:04:29.000000', 'temperatura', 56.0000, 'ºC'),
	(193046, 118, '2014-02-15 01:04:30.000000', 'temperatura', 412.0000, 'ºC'),
	(193047, 118, '2014-02-15 01:04:31.000000', 'temperatura', 692.0000, 'ºC'),
	(193048, 118, '2014-02-15 01:04:32.000000', 'temperatura', 1026.0000, 'ºC'),
	(193049, 118, '2014-02-15 01:04:33.000000', 'temperatura', 653.0000, 'ºC'),
	(193050, 118, '2014-02-15 01:04:34.000000', 'temperatura', 186.0000, 'ºC'),
	(193051, 118, '2014-02-15 01:04:35.000000', 'temperatura', 171.0000, 'ºC'),
	(193052, 118, '2014-02-15 01:04:36.000000', 'temperatura', 301.0000, 'ºC'),
	(193053, 118, '2014-02-15 01:04:37.000000', 'temperatura', 990.0000, 'ºC'),
	(193054, 118, '2014-02-15 01:04:38.000000', 'temperatura', 446.0000, 'ºC'),
	(193055, 118, '2014-02-15 01:04:39.000000', 'temperatura', 463.0000, 'ºC'),
	(193056, 118, '2014-02-15 01:04:40.000000', 'temperatura', 975.0000, 'ºC'),
	(193057, 118, '2014-02-15 01:04:41.000000', 'temperatura', 1087.0000, 'ºC'),
	(193058, 118, '2014-02-15 01:04:42.000000', 'temperatura', 112.0000, 'ºC'),
	(193059, 118, '2014-02-15 01:04:43.000000', 'temperatura', 897.0000, 'ºC'),
	(193060, 118, '2014-02-15 01:04:44.000000', 'temperatura', 552.0000, 'ºC'),
	(193061, 118, '2014-02-15 01:04:45.000000', 'temperatura', 69.0000, 'ºC'),
	(193062, 118, '2014-02-15 01:04:46.000000', 'temperatura', 1089.0000, 'ºC'),
	(193063, 118, '2014-02-15 01:04:47.000000', 'temperatura', 438.0000, 'ºC'),
	(193064, 118, '2014-02-15 01:04:48.000000', 'temperatura', 125.0000, 'ºC'),
	(193065, 118, '2014-02-15 01:04:49.000000', 'temperatura', 511.0000, 'ºC'),
	(193066, 118, '2014-02-15 01:04:50.000000', 'temperatura', 981.0000, 'ºC'),
	(193067, 118, '2014-02-15 01:04:51.000000', 'temperatura', 972.0000, 'ºC'),
	(193068, 118, '2014-02-15 01:04:52.000000', 'temperatura', 716.0000, 'ºC'),
	(193069, 118, '2014-02-15 01:04:53.000000', 'temperatura', 667.0000, 'ºC'),
	(193070, 118, '2014-02-15 01:04:54.000000', 'temperatura', 1185.0000, 'ºC'),
	(193071, 118, '2014-02-15 01:04:55.000000', 'temperatura', 325.0000, 'ºC'),
	(193072, 118, '2014-02-15 01:04:56.000000', 'temperatura', 469.0000, 'ºC'),
	(193073, 118, '2014-02-15 01:04:57.000000', 'temperatura', 172.0000, 'ºC'),
	(193074, 118, '2014-02-15 01:04:58.000000', 'temperatura', 654.0000, 'ºC'),
	(193075, 118, '2014-02-15 01:04:59.000000', 'temperatura', 352.0000, 'ºC'),
	(193076, 118, '2014-02-15 01:05:00.000000', 'temperatura', 1001.0000, 'ºC'),
	(193077, 118, '2014-02-15 01:05:01.000000', 'temperatura', 347.0000, 'ºC'),
	(193078, 118, '2014-02-15 01:05:02.000000', 'temperatura', 1135.0000, 'ºC'),
	(193079, 118, '2014-02-15 01:05:03.000000', 'temperatura', 1032.0000, 'ºC'),
	(193080, 118, '2014-02-15 01:05:04.000000', 'temperatura', 557.0000, 'ºC'),
	(193081, 118, '2014-02-15 01:05:05.000000', 'temperatura', 889.0000, 'ºC'),
	(193082, 118, '2014-02-15 01:05:06.000000', 'temperatura', 377.0000, 'ºC'),
	(193083, 118, '2014-02-15 01:05:07.000000', 'temperatura', 416.0000, 'ºC'),
	(193084, 118, '2014-02-15 01:05:08.000000', 'temperatura', 949.0000, 'ºC'),
	(193085, 118, '2014-02-15 01:05:09.000000', 'temperatura', 1099.0000, 'ºC'),
	(193086, 118, '2014-02-15 01:05:10.000000', 'temperatura', 249.0000, 'ºC'),
	(193087, 118, '2014-02-15 01:05:11.000000', 'temperatura', 349.0000, 'ºC'),
	(193088, 118, '2014-02-15 01:05:12.000000', 'temperatura', 998.0000, 'ºC'),
	(193089, 118, '2014-02-15 01:05:13.000000', 'temperatura', 345.0000, 'ºC'),
	(193090, 118, '2014-02-15 01:05:14.000000', 'temperatura', 1128.0000, 'ºC'),
	(193091, 118, '2014-02-15 01:05:15.000000', 'temperatura', 1009.0000, 'ºC'),
	(193092, 118, '2014-02-15 01:05:16.000000', 'temperatura', 460.0000, 'ºC'),
	(193093, 118, '2014-02-15 01:05:17.000000', 'temperatura', 474.0000, 'ºC'),
	(193094, 118, '2014-02-15 01:05:18.000000', 'temperatura', 989.0000, 'ºC'),
	(193095, 118, '2014-02-15 01:05:19.000000', 'temperatura', 1124.0000, 'ºC'),
	(193096, 118, '2014-02-15 01:05:20.000000', 'temperatura', 254.0000, 'ºC'),
	(193097, 118, '2014-02-15 01:05:21.000000', 'temperatura', 297.0000, 'ºC'),
	(193098, 118, '2014-02-15 01:05:22.000000', 'temperatura', 723.0000, 'ºC'),
	(193099, 118, '2014-02-15 01:05:23.000000', 'temperatura', 323.0000, 'ºC'),
	(193100, 118, '2014-02-15 01:05:24.000000', 'temperatura', 650.0000, 'ºC'),
	(193101, 118, '2014-02-15 01:05:25.000000', 'temperatura', 1081.0000, 'ºC'),
	(193102, 118, '2014-02-15 01:05:26.000000', 'temperatura', 1054.0000, 'ºC'),
	(193103, 118, '2014-02-15 01:05:27.000000', 'temperatura', 827.0000, 'ºC'),
	(193104, 118, '2014-02-15 01:05:28.000000', 'temperatura', 976.0000, 'ºC'),
	(193105, 118, '2014-02-15 01:05:29.000000', 'temperatura', 1198.0000, 'ºC'),
	(193106, 118, '2014-02-15 01:05:30.000000', 'temperatura', 662.0000, 'ºC'),
	(193107, 118, '2014-02-15 01:05:31.000000', 'temperatura', 916.0000, 'ºC'),
	(193108, 118, '2014-02-15 01:05:32.000000', 'temperatura', 193.0000, 'ºC'),
	(193109, 118, '2014-02-15 01:05:33.000000', 'temperatura', 621.0000, 'ºC'),
	(193110, 118, '2014-02-15 01:05:34.000000', 'temperatura', 124.0000, 'ºC'),
	(193111, 118, '2014-02-15 01:05:35.000000', 'temperatura', 1158.0000, 'ºC'),
	(193112, 118, '2014-02-15 01:05:36.000000', 'temperatura', 618.0000, 'ºC'),
	(193113, 118, '2014-02-15 01:05:37.000000', 'temperatura', 815.0000, 'ºC'),
	(193114, 118, '2014-02-15 01:05:38.000000', 'temperatura', 1022.0000, 'ºC'),
	(193115, 118, '2014-02-15 01:05:39.000000', 'temperatura', 268.0000, 'ºC'),
	(193116, 118, '2014-02-15 01:05:40.000000', 'temperatura', 672.0000, 'ºC'),
	(193117, 118, '2014-02-15 01:05:41.000000', 'temperatura', 157.0000, 'ºC'),
	(193118, 118, '2014-02-15 01:05:42.000000', 'temperatura', 1169.0000, 'ºC'),
	(193119, 118, '2014-02-15 01:05:43.000000', 'temperatura', 573.0000, 'ºC'),
	(193120, 118, '2014-02-15 01:05:44.000000', 'temperatura', 560.0000, 'ºC'),
	(193121, 118, '2014-02-15 01:05:45.000000', 'temperatura', 1081.0000, 'ºC'),
	(193122, 118, '2014-02-15 01:05:46.000000', 'temperatura', 127.0000, 'ºC'),
	(193123, 118, '2014-02-15 01:05:47.000000', 'temperatura', 993.0000, 'ºC'),
	(193124, 118, '2014-02-15 01:05:48.000000', 'temperatura', 983.0000, 'ºC'),
	(193125, 118, '2014-02-15 01:05:49.000000', 'temperatura', 737.0000, 'ºC'),
	(193126, 118, '2014-02-15 01:05:50.000000', 'temperatura', 738.0000, 'ºC'),
	(193127, 118, '2014-02-15 01:05:51.000000', 'temperatura', 278.0000, 'ºC'),
	(193128, 118, '2014-02-15 01:05:52.000000', 'temperatura', 379.0000, 'ºC'),
	(193129, 118, '2014-02-15 01:05:53.000000', 'temperatura', 1058.0000, 'ºC'),
	(193130, 118, '2014-02-15 01:05:54.000000', 'temperatura', 556.0000, 'ºC'),
	(193131, 118, '2014-02-15 01:05:55.000000', 'temperatura', 804.0000, 'ºC'),
	(193132, 118, '2014-02-15 01:05:56.000000', 'temperatura', 1153.0000, 'ºC'),
	(193133, 118, '2014-02-15 01:05:57.000000', 'temperatura', 954.0000, 'ºC'),
	(193134, 118, '2014-02-15 01:05:58.000000', 'temperatura', 112.0000, 'ºC'),
	(193135, 118, '2014-02-15 01:05:59.000000', 'temperatura', 99.0000, 'ºC'),
	(193136, 118, '2014-02-15 01:06:00.000000', 'temperatura', 160.0000, 'ºC'),
	(193137, 118, '2014-02-15 01:06:01.000000', 'temperatura', 504.0000, 'ºC'),
	(193138, 118, '2014-02-15 01:06:02.000000', 'temperatura', 838.0000, 'ºC'),
	(193139, 118, '2014-02-15 01:06:03.000000', 'temperatura', 281.0000, 'ºC'),
	(193140, 118, '2014-02-15 01:06:04.000000', 'temperatura', 91.0000, 'ºC'),
	(193141, 118, '2014-02-15 01:06:05.000000', 'temperatura', 810.0000, 'ºC'),
	(193142, 118, '2014-02-15 01:06:06.000000', 'temperatura', 181.0000, 'ºC'),
	(193143, 118, '2014-02-15 01:06:07.000000', 'temperatura', 872.0000, 'ºC'),
	(193144, 118, '2014-02-15 01:06:08.000000', 'temperatura', 219.0000, 'ºC'),
	(193145, 118, '2014-02-15 01:06:09.000000', 'temperatura', 879.0000, 'ºC'),
	(193146, 118, '2014-02-15 01:06:10.000000', 'temperatura', 138.0000, 'ºC'),
	(193147, 118, '2014-02-15 01:06:11.000000', 'temperatura', 456.0000, 'ºC'),
	(193148, 118, '2014-02-15 01:06:12.000000', 'temperatura', 665.0000, 'ºC'),
	(193149, 118, '2014-02-15 01:06:13.000000', 'temperatura', 759.0000, 'ºC'),
	(193150, 118, '2014-02-15 01:06:14.000000', 'temperatura', 600.0000, 'ºC'),
	(193151, 118, '2014-02-15 01:06:15.000000', 'temperatura', 725.0000, 'ºC'),
	(193152, 118, '2014-02-15 01:06:16.000000', 'temperatura', 623.0000, 'ºC'),
	(193153, 118, '2014-02-15 01:06:17.000000', 'temperatura', 942.0000, 'ºC'),
	(193154, 118, '2014-02-15 01:06:18.000000', 'temperatura', 441.0000, 'ºC'),
	(193155, 118, '2014-02-15 01:06:19.000000', 'temperatura', 579.0000, 'ºC'),
	(193156, 118, '2014-02-15 01:06:20.000000', 'temperatura', 373.0000, 'ºC'),
	(193157, 118, '2014-02-15 01:06:21.000000', 'temperatura', 127.0000, 'ºC'),
	(193158, 118, '2014-02-15 01:06:22.000000', 'temperatura', 716.0000, 'ºC'),
	(193159, 118, '2014-02-15 01:06:23.000000', 'temperatura', 802.0000, 'ºC'),
	(193160, 118, '2014-02-15 01:06:24.000000', 'temperatura', 660.0000, 'ºC'),
	(193161, 118, '2014-02-15 01:06:25.000000', 'temperatura', 893.0000, 'ºC'),
	(193162, 118, '2014-02-15 01:06:26.000000', 'temperatura', 89.0000, 'ºC'),
	(193163, 118, '2014-02-15 01:06:27.000000', 'temperatura', 166.0000, 'ºC'),
	(193164, 118, '2014-02-15 01:06:28.000000', 'temperatura', 564.0000, 'ºC'),
	(193165, 118, '2014-02-15 01:06:29.000000', 'temperatura', 1120.0000, 'ºC'),
	(193166, 118, '2014-02-15 01:06:30.000000', 'temperatura', 310.0000, 'ºC'),
	(193167, 118, '2014-02-15 01:06:31.000000', 'temperatura', 589.0000, 'ºC'),
	(193168, 118, '2014-02-15 01:06:32.000000', 'temperatura', 817.0000, 'ºC'),
	(193169, 118, '2014-02-15 01:06:33.000000', 'temperatura', 1116.0000, 'ºC'),
	(193170, 118, '2014-02-15 01:06:34.000000', 'temperatura', 731.0000, 'ºC'),
	(193171, 118, '2014-02-15 01:06:35.000000', 'temperatura', 307.0000, 'ºC'),
	(193172, 118, '2014-02-15 01:06:36.000000', 'temperatura', 542.0000, 'ºC'),
	(193173, 118, '2014-02-15 01:06:37.000000', 'temperatura', 590.0000, 'ºC'),
	(193174, 118, '2014-02-15 01:06:38.000000', 'temperatura', 125.0000, 'ºC'),
	(193175, 118, '2014-02-15 01:06:39.000000', 'temperatura', 54.0000, 'ºC'),
	(193176, 118, '2014-02-15 01:06:40.000000', 'temperatura', 1095.0000, 'ºC'),
	(193177, 118, '2014-02-15 01:06:41.000000', 'temperatura', 516.0000, 'ºC'),
	(193178, 118, '2014-02-15 01:06:42.000000', 'temperatura', 496.0000, 'ºC'),
	(193179, 118, '2014-02-15 01:06:43.000000', 'temperatura', 931.0000, 'ºC'),
	(193180, 118, '2014-02-15 01:06:44.000000', 'temperatura', 767.0000, 'ºC'),
	(193181, 118, '2014-02-15 01:06:45.000000', 'temperatura', 1044.0000, 'ºC'),
	(193182, 118, '2014-02-15 01:06:46.000000', 'temperatura', 517.0000, 'ºC'),
	(193183, 118, '2014-02-15 01:06:47.000000', 'temperatura', 654.0000, 'ºC'),
	(193184, 118, '2014-02-15 01:06:48.000000', 'temperatura', 520.0000, 'ºC'),
	(193185, 118, '2014-02-15 01:06:49.000000', 'temperatura', 639.0000, 'ºC'),
	(193186, 118, '2014-02-15 01:06:50.000000', 'temperatura', 433.0000, 'ºC'),
	(193187, 118, '2014-02-15 01:06:51.000000', 'temperatura', 252.0000, 'ºC'),
	(193188, 118, '2014-02-15 01:06:52.000000', 'temperatura', 1160.0000, 'ºC'),
	(193189, 118, '2014-02-15 01:06:53.000000', 'temperatura', 243.0000, 'ºC'),
	(193190, 118, '2014-02-15 01:06:54.000000', 'temperatura', 135.0000, 'ºC'),
	(193191, 118, '2014-02-15 01:06:55.000000', 'temperatura', 1146.0000, 'ºC'),
	(193192, 118, '2014-02-15 01:06:56.000000', 'temperatura', 528.0000, 'ºC'),
	(193193, 118, '2014-02-15 01:06:57.000000', 'temperatura', 401.0000, 'ºC'),
	(193194, 118, '2014-02-15 01:06:58.000000', 'temperatura', 421.0000, 'ºC'),
	(193195, 118, '2014-02-15 01:06:59.000000', 'temperatura', 904.0000, 'ºC'),
	(193196, 118, '2014-02-15 01:07:00.000000', 'temperatura', 856.0000, 'ºC'),
	(193197, 118, '2014-02-15 01:07:01.000000', 'temperatura', 367.0000, 'ºC'),
	(193198, 118, '2014-02-15 01:07:02.000000', 'temperatura', 471.0000, 'ºC'),
	(193199, 118, '2014-02-15 01:07:03.000000', 'temperatura', 53.0000, 'ºC'),
	(193200, 118, '2014-02-15 01:07:04.000000', 'temperatura', 53.0000, 'ºC'),
	(193201, 118, '2014-02-15 01:07:05.000000', 'temperatura', 108.0000, 'ºC'),
	(193202, 118, '2014-02-15 01:07:06.000000', 'temperatura', 381.0000, 'ºC'),
	(193203, 118, '2014-02-15 01:07:07.000000', 'temperatura', 379.0000, 'ºC'),
	(193204, 118, '2014-02-15 01:07:08.000000', 'temperatura', 755.0000, 'ºC'),
	(193205, 118, '2014-02-15 01:07:09.000000', 'temperatura', 237.0000, 'ºC'),
	(193206, 118, '2014-02-15 01:07:10.000000', 'temperatura', 122.0000, 'ºC'),
	(193207, 118, '2014-02-15 01:07:11.000000', 'temperatura', 1097.0000, 'ºC'),
	(193208, 118, '2014-02-15 01:07:12.000000', 'temperatura', 321.0000, 'ºC'),
	(193209, 118, '2014-02-15 01:07:13.000000', 'temperatura', 714.0000, 'ºC'),
	(193210, 118, '2014-02-15 01:07:14.000000', 'temperatura', 208.0000, 'ºC'),
	(193211, 118, '2014-02-15 01:07:15.000000', 'temperatura', 98.0000, 'ºC'),
	(193212, 118, '2014-02-15 01:07:16.000000', 'temperatura', 1066.0000, 'ºC'),
	(193213, 118, '2014-02-15 01:07:17.000000', 'temperatura', 235.0000, 'ºC'),
	(193214, 118, '2014-02-15 01:07:18.000000', 'temperatura', 380.0000, 'ºC'),
	(193215, 118, '2014-02-15 01:07:19.000000', 'temperatura', 1194.0000, 'ºC'),
	(193216, 118, '2014-02-15 01:07:20.000000', 'temperatura', 32.0000, 'ºC'),
	(193217, 118, '2014-02-15 01:07:21.000000', 'temperatura', 176.0000, 'ºC'),
	(193218, 118, '2014-02-15 01:07:22.000000', 'temperatura', 787.0000, 'ºC'),
	(193219, 118, '2014-02-15 01:07:23.000000', 'temperatura', 1009.0000, 'ºC'),
	(193220, 118, '2014-02-15 01:07:24.000000', 'temperatura', 281.0000, 'ºC'),
	(193221, 118, '2014-02-15 01:07:25.000000', 'temperatura', 781.0000, 'ºC'),
	(193222, 118, '2014-02-15 01:07:26.000000', 'temperatura', 662.0000, 'ºC'),
	(193223, 118, '2014-02-15 01:07:27.000000', 'temperatura', 965.0000, 'ºC'),
	(193224, 118, '2014-02-15 01:07:28.000000', 'temperatura', 442.0000, 'ºC'),
	(193225, 118, '2014-02-15 01:07:29.000000', 'temperatura', 516.0000, 'ºC'),
	(193226, 118, '2014-02-15 01:07:30.000000', 'temperatura', 52.0000, 'ºC'),
	(193227, 118, '2014-02-15 01:07:31.000000', 'temperatura', 1114.0000, 'ºC'),
	(193228, 118, '2014-02-15 01:07:32.000000', 'temperatura', 616.0000, 'ºC'),
	(193229, 118, '2014-02-15 01:07:33.000000', 'temperatura', 935.0000, 'ºC'),
	(193230, 118, '2014-02-15 01:07:34.000000', 'temperatura', 431.0000, 'ºC'),
	(193231, 118, '2014-02-15 01:07:35.000000', 'temperatura', 550.0000, 'ºC'),
	(193232, 118, '2014-02-15 01:07:36.000000', 'temperatura', 255.0000, 'ºC'),
	(193233, 118, '2014-02-15 01:07:37.000000', 'temperatura', 826.0000, 'ºC'),
	(193234, 118, '2014-02-15 01:07:38.000000', 'temperatura', 968.0000, 'ºC'),
	(193235, 118, '2014-02-15 01:07:39.000000', 'temperatura', 1160.0000, 'ºC'),
	(193236, 118, '2014-02-15 01:07:40.000000', 'temperatura', 497.0000, 'ºC'),
	(193237, 118, '2014-02-15 01:07:41.000000', 'temperatura', 204.0000, 'ºC'),
	(193238, 118, '2014-02-15 01:07:42.000000', 'temperatura', 731.0000, 'ºC'),
	(193239, 118, '2014-02-15 01:07:43.000000', 'temperatura', 643.0000, 'ºC'),
	(193240, 118, '2014-02-15 01:07:44.000000', 'temperatura', 1023.0000, 'ºC'),
	(193241, 118, '2014-02-15 01:07:45.000000', 'temperatura', 785.0000, 'ºC'),
	(193242, 118, '2014-02-15 01:07:46.000000', 'temperatura', 856.0000, 'ºC'),
	(193243, 118, '2014-02-15 01:07:47.000000', 'temperatura', 727.0000, 'ºC'),
	(193244, 118, '2014-02-15 01:07:48.000000', 'temperatura', 1066.0000, 'ºC'),
	(193245, 118, '2014-02-15 01:07:49.000000', 'temperatura', 750.0000, 'ºC'),
	(193246, 118, '2014-02-15 01:07:50.000000', 'temperatura', 551.0000, 'ºC'),
	(193247, 118, '2014-02-15 01:07:51.000000', 'temperatura', 505.0000, 'ºC'),
	(193248, 118, '2014-02-15 01:07:52.000000', 'temperatura', 874.0000, 'ºC'),
	(193249, 118, '2014-02-15 01:07:53.000000', 'temperatura', 453.0000, 'ºC'),
	(193250, 118, '2014-02-15 01:07:54.000000', 'temperatura', 847.0000, 'ºC'),
	(193251, 118, '2014-02-15 01:07:55.000000', 'temperatura', 474.0000, 'ºC'),
	(193252, 118, '2014-02-15 01:07:56.000000', 'temperatura', 1028.0000, 'ºC'),
	(193253, 118, '2014-02-15 01:07:57.000000', 'temperatura', 121.0000, 'ºC'),
	(193254, 118, '2014-02-15 01:07:58.000000', 'temperatura', 1121.0000, 'ºC'),
	(193255, 118, '2014-02-15 01:07:59.000000', 'temperatura', 442.0000, 'ºC'),
	(193256, 118, '2014-02-15 01:08:00.000000', 'temperatura', 49.0000, 'ºC'),
	(193257, 118, '2014-02-15 01:08:01.000000', 'temperatura', 120.0000, 'ºC'),
	(193258, 118, '2014-02-15 01:08:02.000000', 'temperatura', 453.0000, 'ºC'),
	(193259, 118, '2014-02-15 01:08:03.000000', 'temperatura', 704.0000, 'ºC'),
	(193260, 118, '2014-02-15 01:08:04.000000', 'temperatura', 964.0000, 'ºC'),
	(193261, 118, '2014-02-15 01:08:05.000000', 'temperatura', 309.0000, 'ºC'),
	(193262, 118, '2014-02-15 01:08:06.000000', 'temperatura', 1053.0000, 'ºC'),
	(193263, 118, '2014-02-15 01:08:07.000000', 'temperatura', 736.0000, 'ºC'),
	(193264, 118, '2014-02-15 01:08:08.000000', 'temperatura', 523.0000, 'ºC'),
	(193265, 118, '2014-02-15 01:08:09.000000', 'temperatura', 409.0000, 'ºC'),
	(193266, 118, '2014-02-15 01:08:10.000000', 'temperatura', 474.0000, 'ºC'),
	(193267, 118, '2014-02-15 01:08:11.000000', 'temperatura', 1146.0000, 'ºC'),
	(193268, 118, '2014-02-15 01:08:12.000000', 'temperatura', 706.0000, 'ºC'),
	(193269, 118, '2014-02-15 01:08:13.000000', 'temperatura', 92.0000, 'ºC'),
	(193270, 118, '2014-02-15 01:08:14.000000', 'temperatura', 745.0000, 'ºC'),
	(193271, 118, '2014-02-15 01:08:15.000000', 'temperatura', 1047.0000, 'ºC'),
	(193272, 118, '2014-02-15 01:08:16.000000', 'temperatura', 601.0000, 'ºC'),
	(193273, 118, '2014-02-15 01:08:17.000000', 'temperatura', 1066.0000, 'ºC'),
	(193274, 118, '2014-02-15 01:08:18.000000', 'temperatura', 1125.0000, 'ºC'),
	(193275, 118, '2014-02-15 01:08:19.000000', 'temperatura', 30.0000, 'ºC'),
	(193276, 118, '2014-02-15 01:08:20.000000', 'temperatura', 377.0000, 'ºC'),
	(193277, 118, '2014-02-15 01:08:21.000000', 'temperatura', 593.0000, 'ºC'),
	(193278, 118, '2014-02-15 01:08:22.000000', 'temperatura', 634.0000, 'ºC'),
	(193279, 118, '2014-02-15 01:08:23.000000', 'temperatura', 191.0000, 'ºC'),
	(193280, 118, '2014-02-15 01:08:24.000000', 'temperatura', 253.0000, 'ºC'),
	(193281, 118, '2014-02-15 01:08:25.000000', 'temperatura', 693.0000, 'ºC'),
	(193282, 118, '2014-02-15 01:08:26.000000', 'temperatura', 307.0000, 'ºC'),
	(193283, 118, '2014-02-15 01:08:27.000000', 'temperatura', 655.0000, 'ºC'),
	(193284, 118, '2014-02-15 01:08:28.000000', 'temperatura', 1157.0000, 'ºC'),
	(193285, 118, '2014-02-15 01:08:29.000000', 'temperatura', 218.0000, 'ºC'),
	(193286, 118, '2014-02-15 01:08:30.000000', 'temperatura', 22.0000, 'ºC'),
	(193287, 118, '2014-02-15 01:08:31.000000', 'temperatura', 655.0000, 'ºC'),
	(193288, 118, '2014-02-15 01:08:32.000000', 'temperatura', 810.0000, 'ºC'),
	(193289, 118, '2014-02-15 01:08:33.000000', 'temperatura', 887.0000, 'ºC'),
	(193290, 118, '2014-02-15 01:08:34.000000', 'temperatura', 803.0000, 'ºC'),
	(193291, 118, '2014-02-15 01:08:35.000000', 'temperatura', 156.0000, 'ºC'),
	(193292, 118, '2014-02-15 01:08:36.000000', 'temperatura', 771.0000, 'ºC'),
	(193293, 118, '2014-02-15 01:08:37.000000', 'temperatura', 989.0000, 'ºC'),
	(193294, 118, '2014-02-15 01:08:38.000000', 'temperatura', 233.0000, 'ºC'),
	(193295, 118, '2014-02-15 01:08:39.000000', 'temperatura', 596.0000, 'ºC'),
	(193296, 118, '2014-02-15 01:08:40.000000', 'temperatura', 1082.0000, 'ºC'),
	(193297, 118, '2014-02-15 01:08:41.000000', 'temperatura', 24.0000, 'ºC'),
	(193298, 118, '2014-02-15 01:08:42.000000', 'temperatura', 472.0000, 'ºC'),
	(193299, 118, '2014-02-15 01:08:43.000000', 'temperatura', 1090.0000, 'ºC'),
	(193300, 118, '2014-02-15 01:08:44.000000', 'temperatura', 436.0000, 'ºC'),
	(193301, 118, '2014-02-15 01:08:45.000000', 'temperatura', 108.0000, 'ºC'),
	(193302, 118, '2014-02-15 01:08:46.000000', 'temperatura', 434.0000, 'ºC'),
	(193303, 118, '2014-02-15 01:08:47.000000', 'temperatura', 644.0000, 'ºC'),
	(193304, 118, '2014-02-15 01:08:48.000000', 'temperatura', 722.0000, 'ºC'),
	(193305, 118, '2014-02-15 01:08:49.000000', 'temperatura', 475.0000, 'ºC'),
	(193306, 118, '2014-02-15 01:08:50.000000', 'temperatura', 212.0000, 'ºC'),
	(193307, 118, '2014-02-15 01:08:51.000000', 'temperatura', 836.0000, 'ºC'),
	(193308, 118, '2014-02-15 01:08:52.000000', 'temperatura', 1142.0000, 'ºC'),
	(193309, 118, '2014-02-15 01:08:53.000000', 'temperatura', 802.0000, 'ºC'),
	(193310, 118, '2014-02-15 01:08:54.000000', 'temperatura', 588.0000, 'ºC'),
	(193311, 118, '2014-02-15 01:08:55.000000', 'temperatura', 531.0000, 'ºC'),
	(193312, 118, '2014-02-15 01:08:56.000000', 'temperatura', 892.0000, 'ºC'),
	(193313, 118, '2014-02-15 01:08:57.000000', 'temperatura', 470.0000, 'ºC'),
	(193314, 118, '2014-02-15 01:08:58.000000', 'temperatura', 872.0000, 'ºC'),
	(193315, 118, '2014-02-15 01:08:59.000000', 'temperatura', 549.0000, 'ºC'),
	(193316, 118, '2014-02-15 01:09:00.000000', 'temperatura', 133.0000, 'ºC'),
	(193317, 118, '2014-02-15 01:09:01.000000', 'temperatura', 218.0000, 'ºC'),
	(193318, 118, '2014-02-15 01:09:02.000000', 'temperatura', 690.0000, 'ºC'),
	(193319, 118, '2014-02-15 01:09:03.000000', 'temperatura', 398.0000, 'ºC'),
	(193320, 118, '2014-02-15 01:09:04.000000', 'temperatura', 1121.0000, 'ºC'),
	(193321, 118, '2014-02-15 01:09:05.000000', 'temperatura', 809.0000, 'ºC'),
	(193322, 118, '2014-02-15 01:09:06.000000', 'temperatura', 686.0000, 'ºC'),
	(193323, 118, '2014-02-15 01:09:07.000000', 'temperatura', 1000.0000, 'ºC'),
	(193324, 118, '2014-02-15 01:09:08.000000', 'temperatura', 545.0000, 'ºC'),
	(193325, 118, '2014-02-15 01:09:09.000000', 'temperatura', 924.0000, 'ºC'),
	(193326, 118, '2014-02-15 01:09:10.000000', 'temperatura', 587.0000, 'ºC'),
	(193327, 118, '2014-02-15 01:09:11.000000', 'temperatura', 163.0000, 'ºC'),
	(193328, 118, '2014-02-15 01:09:12.000000', 'temperatura', 253.0000, 'ºC'),
	(193329, 118, '2014-02-15 01:09:13.000000', 'temperatura', 779.0000, 'ºC'),
	(193330, 118, '2014-02-15 01:09:14.000000', 'temperatura', 735.0000, 'ºC'),
	(193331, 118, '2014-02-15 01:09:15.000000', 'temperatura', 140.0000, 'ºC'),
	(193332, 118, '2014-02-15 01:09:16.000000', 'temperatura', 896.0000, 'ºC'),
	(193333, 118, '2014-02-15 01:09:17.000000', 'temperatura', 458.0000, 'ºC'),
	(193334, 118, '2014-02-15 01:09:18.000000', 'temperatura', 805.0000, 'ºC'),
	(193335, 118, '2014-02-15 01:09:19.000000', 'temperatura', 252.0000, 'ºC'),
	(193336, 118, '2014-02-15 01:09:20.000000', 'temperatura', 43.0000, 'ºC'),
	(193337, 118, '2014-02-15 01:09:21.000000', 'temperatura', 661.0000, 'ºC'),
	(193338, 118, '2014-02-15 01:09:22.000000', 'temperatura', 777.0000, 'ºC'),
	(193339, 118, '2014-02-15 01:09:23.000000', 'temperatura', 700.0000, 'ºC'),
	(193340, 118, '2014-02-15 01:09:24.000000', 'temperatura', 1173.0000, 'ºC'),
	(193341, 118, '2014-02-15 01:09:25.000000', 'temperatura', 162.0000, 'ºC'),
	(193342, 118, '2014-02-15 01:09:26.000000', 'temperatura', 894.0000, 'ºC'),
	(193343, 118, '2014-02-15 01:09:27.000000', 'temperatura', 383.0000, 'ºC'),
	(193344, 118, '2014-02-15 01:09:28.000000', 'temperatura', 435.0000, 'ºC'),
	(193345, 118, '2014-02-15 01:09:29.000000', 'temperatura', 1025.0000, 'ºC'),
	(193346, 118, '2014-02-15 01:09:30.000000', 'temperatura', 221.0000, 'ºC'),
	(193347, 118, '2014-02-15 01:09:31.000000', 'temperatura', 430.0000, 'ºC'),
	(193348, 118, '2014-02-15 01:09:32.000000', 'temperatura', 286.0000, 'ºC'),
	(193349, 118, '2014-02-15 01:09:33.000000', 'temperatura', 141.0000, 'ºC'),
	(193350, 118, '2014-02-15 01:09:34.000000', 'temperatura', 1047.0000, 'ºC'),
	(193351, 118, '2014-02-15 01:09:35.000000', 'temperatura', 14.0000, 'ºC'),
	(193352, 118, '2014-02-15 01:09:36.000000', 'temperatura', 527.0000, 'ºC'),
	(193353, 118, '2014-02-15 01:09:37.000000', 'temperatura', 197.0000, 'ºC'),
	(193354, 118, '2014-02-15 01:09:38.000000', 'temperatura', 603.0000, 'ºC'),
	(193355, 118, '2014-02-15 01:09:39.000000', 'temperatura', 24.0000, 'ºC'),
	(193356, 118, '2014-02-15 01:09:40.000000', 'temperatura', 712.0000, 'ºC'),
	(193357, 118, '2014-02-15 01:09:41.000000', 'temperatura', 1088.0000, 'ºC'),
	(193358, 118, '2014-02-15 01:09:42.000000', 'temperatura', 907.0000, 'ºC'),
	(193359, 118, '2014-02-15 01:09:43.000000', 'temperatura', 68.0000, 'ºC'),
	(193360, 118, '2014-02-15 01:09:44.000000', 'temperatura', 23.0000, 'ºC'),
	(193361, 118, '2014-02-15 01:09:45.000000', 'temperatura', 1109.0000, 'ºC'),
	(193362, 118, '2014-02-15 01:09:46.000000', 'temperatura', 678.0000, 'ºC'),
	(193363, 118, '2014-02-15 01:09:47.000000', 'temperatura', 63.0000, 'ºC'),
	(193364, 118, '2014-02-15 01:09:48.000000', 'temperatura', 680.0000, 'ºC'),
	(193365, 118, '2014-02-15 01:09:49.000000', 'temperatura', 814.0000, 'ºC'),
	(193366, 118, '2014-02-15 01:09:50.000000', 'temperatura', 831.0000, 'ºC'),
	(193367, 118, '2014-02-15 01:09:51.000000', 'temperatura', 511.0000, 'ºC'),
	(193368, 118, '2014-02-15 01:09:52.000000', 'temperatura', 63.0000, 'ºC'),
	(193369, 118, '2014-02-15 01:09:53.000000', 'temperatura', 1183.0000, 'ºC'),
	(193370, 118, '2014-02-15 01:09:54.000000', 'temperatura', 926.0000, 'ºC'),
	(193371, 118, '2014-02-15 01:09:55.000000', 'temperatura', 1082.0000, 'ºC'),
	(193372, 118, '2014-02-15 01:09:56.000000', 'temperatura', 234.0000, 'ºC'),
	(193373, 118, '2014-02-15 01:09:57.000000', 'temperatura', 323.0000, 'ºC'),
	(193374, 118, '2014-02-15 01:09:58.000000', 'temperatura', 912.0000, 'ºC'),
	(193375, 118, '2014-02-15 01:09:59.000000', 'temperatura', 1195.0000, 'ºC'),
	(193376, 118, '2014-02-15 01:10:00.000000', 'temperatura', 837.0000, 'ºC'),
	(193377, 118, '2014-02-15 01:10:01.000000', 'temperatura', 602.0000, 'ºC'),
	(193378, 118, '2014-02-15 01:10:02.000000', 'temperatura', 500.0000, 'ºC'),
	(193379, 118, '2014-02-15 01:10:03.000000', 'temperatura', 696.0000, 'ºC'),
	(193380, 118, '2014-02-15 01:10:04.000000', 'temperatura', 778.0000, 'ºC'),
	(193381, 118, '2014-02-15 01:10:05.000000', 'temperatura', 601.0000, 'ºC'),
	(193382, 118, '2014-02-15 01:10:06.000000', 'temperatura', 673.0000, 'ºC'),
	(193383, 118, '2014-02-15 01:10:07.000000', 'temperatura', 364.0000, 'ºC'),
	(193384, 118, '2014-02-15 01:10:08.000000', 'temperatura', 1001.0000, 'ºC'),
	(193385, 118, '2014-02-15 01:10:09.000000', 'temperatura', 313.0000, 'ºC'),
	(193386, 118, '2014-02-15 01:10:10.000000', 'temperatura', 961.0000, 'ºC'),
	(193387, 118, '2014-02-15 01:10:11.000000', 'temperatura', 269.0000, 'ºC'),
	(193388, 118, '2014-02-15 01:10:12.000000', 'temperatura', 861.0000, 'ºC'),
	(193389, 118, '2014-02-15 01:10:13.000000', 'temperatura', 1098.0000, 'ºC'),
	(193390, 118, '2014-02-15 01:10:14.000000', 'temperatura', 507.0000, 'ºC'),
	(193391, 118, '2014-02-15 01:10:15.000000', 'temperatura', 441.0000, 'ºC'),
	(193392, 118, '2014-02-15 01:10:16.000000', 'temperatura', 685.0000, 'ºC'),
	(193393, 118, '2014-02-15 01:10:17.000000', 'temperatura', 902.0000, 'ºC'),
	(193394, 118, '2014-02-15 01:10:18.000000', 'temperatura', 56.0000, 'ºC'),
	(193395, 118, '2014-02-15 01:10:19.000000', 'temperatura', 1174.0000, 'ºC'),
	(193396, 118, '2014-02-15 01:10:20.000000', 'temperatura', 903.0000, 'ºC'),
	(193397, 118, '2014-02-15 01:10:21.000000', 'temperatura', 994.0000, 'ºC'),
	(193398, 118, '2014-02-15 01:10:22.000000', 'temperatura', 1060.0000, 'ºC'),
	(193399, 118, '2014-02-15 01:10:23.000000', 'temperatura', 1119.0000, 'ºC'),
	(193400, 118, '2014-02-15 01:10:24.000000', 'temperatura', 16.0000, 'ºC'),
	(193401, 118, '2014-02-15 01:10:25.000000', 'temperatura', 325.0000, 'ºC'),
	(193402, 118, '2014-02-15 01:10:26.000000', 'temperatura', 377.0000, 'ºC'),
	(193403, 118, '2014-02-15 01:10:27.000000', 'temperatura', 911.0000, 'ºC'),
	(193404, 118, '2014-02-15 01:10:28.000000', 'temperatura', 1023.0000, 'ºC'),
	(193405, 118, '2014-02-15 01:10:29.000000', 'temperatura', 1181.0000, 'ºC'),
	(193406, 118, '2014-02-15 01:10:30.000000', 'temperatura', 439.0000, 'ºC'),
	(193407, 118, '2014-02-15 01:10:31.000000', 'temperatura', 1051.0000, 'ºC'),
	(193408, 118, '2014-02-15 01:10:32.000000', 'temperatura', 340.0000, 'ºC'),
	(193409, 118, '2014-02-15 01:10:33.000000', 'temperatura', 945.0000, 'ºC'),
	(193410, 118, '2014-02-15 01:10:34.000000', 'temperatura', 105.0000, 'ºC'),
	(193411, 118, '2014-02-15 01:10:35.000000', 'temperatura', 94.0000, 'ºC'),
	(193412, 118, '2014-02-15 01:10:36.000000', 'temperatura', 153.0000, 'ºC'),
	(193413, 118, '2014-02-15 01:10:37.000000', 'temperatura', 483.0000, 'ºC'),
	(193414, 118, '2014-02-15 01:10:38.000000', 'temperatura', 759.0000, 'ºC'),
	(193415, 118, '2014-02-15 01:10:39.000000', 'temperatura', 1145.0000, 'ºC'),
	(193416, 118, '2014-02-15 01:10:40.000000', 'temperatura', 1051.0000, 'ºC'),
	(193417, 118, '2014-02-15 01:10:41.000000', 'temperatura', 618.0000, 'ºC'),
	(193418, 118, '2014-02-15 01:10:42.000000', 'temperatura', 1138.0000, 'ºC'),
	(193419, 118, '2014-02-15 01:10:43.000000', 'temperatura', 236.0000, 'ºC'),
	(193420, 118, '2014-02-15 01:10:44.000000', 'temperatura', 166.0000, 'ºC'),
	(193421, 118, '2014-02-15 01:10:45.000000', 'temperatura', 125.0000, 'ºC'),
	(193422, 118, '2014-02-15 01:10:46.000000', 'temperatura', 125.0000, 'ºC'),
	(193423, 118, '2014-02-15 01:10:47.000000', 'temperatura', 251.0000, 'ºC'),
	(193424, 118, '2014-02-15 01:10:48.000000', 'temperatura', 879.0000, 'ºC'),
	(193425, 118, '2014-02-15 01:10:49.000000', 'temperatura', 45.0000, 'ºC'),
	(193426, 118, '2014-02-15 01:10:50.000000', 'temperatura', 1188.0000, 'ºC'),
	(193427, 118, '2014-02-15 01:10:51.000000', 'temperatura', 1007.0000, 'ºC'),
	(193428, 118, '2014-02-15 01:10:52.000000', 'temperatura', 270.0000, 'ºC'),
	(193429, 118, '2014-02-15 01:10:53.000000', 'temperatura', 731.0000, 'ºC'),
	(193430, 118, '2014-02-15 01:10:54.000000', 'temperatura', 445.0000, 'ºC'),
	(193431, 118, '2014-02-15 01:10:55.000000', 'temperatura', 32.0000, 'ºC'),
	(193432, 118, '2014-02-15 01:10:56.000000', 'temperatura', 26.0000, 'ºC'),
	(193433, 118, '2014-02-15 01:10:57.000000', 'temperatura', 35.0000, 'ºC'),
	(193434, 118, '2014-02-15 01:10:58.000000', 'temperatura', 99.0000, 'ºC'),
	(193435, 118, '2014-02-15 01:10:59.000000', 'temperatura', 387.0000, 'ºC'),
	(193436, 118, '2014-02-15 01:11:00.000000', 'temperatura', 440.0000, 'ºC'),
	(193437, 118, '2014-02-15 01:11:01.000000', 'temperatura', 1041.0000, 'ºC'),
	(193438, 118, '2014-02-15 01:11:02.000000', 'temperatura', 283.0000, 'ºC'),
	(193439, 118, '2014-02-15 01:11:03.000000', 'temperatura', 695.0000, 'ºC'),
	(193440, 118, '2014-02-15 01:11:04.000000', 'temperatura', 224.0000, 'ºC'),
	(193441, 118, '2014-02-15 01:11:05.000000', 'temperatura', 235.0000, 'ºC'),
	(193442, 118, '2014-02-15 01:11:06.000000', 'temperatura', 506.0000, 'ºC'),
	(193443, 118, '2014-02-15 01:11:07.000000', 'temperatura', 625.0000, 'ºC'),
	(193444, 118, '2014-02-15 01:11:08.000000', 'temperatura', 406.0000, 'ºC'),
	(193445, 118, '2014-02-15 01:11:09.000000', 'temperatura', 157.0000, 'ºC'),
	(193446, 118, '2014-02-15 01:11:10.000000', 'temperatura', 765.0000, 'ºC'),
	(193447, 118, '2014-02-15 01:11:11.000000', 'temperatura', 956.0000, 'ºC'),
	(193448, 118, '2014-02-15 01:11:12.000000', 'temperatura', 84.0000, 'ºC'),
	(193449, 118, '2014-02-15 01:11:13.000000', 'temperatura', 1153.0000, 'ºC'),
	(193450, 118, '2014-02-15 01:11:14.000000', 'temperatura', 716.0000, 'ºC'),
	(193451, 118, '2014-02-15 01:11:15.000000', 'temperatura', 119.0000, 'ºC'),
	(193452, 118, '2014-02-15 01:11:16.000000', 'temperatura', 848.0000, 'ºC'),
	(193453, 118, '2014-02-15 01:11:17.000000', 'temperatura', 282.0000, 'ºC'),
	(193454, 118, '2014-02-15 01:11:18.000000', 'temperatura', 67.0000, 'ºC'),
	(193455, 118, '2014-02-15 01:11:19.000000', 'temperatura', 692.0000, 'ºC'),
	(193456, 118, '2014-02-15 01:11:20.000000', 'temperatura', 858.0000, 'ºC'),
	(193457, 118, '2014-02-15 01:11:21.000000', 'temperatura', 1016.0000, 'ºC'),
	(193458, 118, '2014-02-15 01:11:22.000000', 'temperatura', 104.0000, 'ºC'),
	(193459, 118, '2014-02-15 01:11:23.000000', 'temperatura', 1072.0000, 'ºC'),
	(193460, 118, '2014-02-15 01:11:24.000000', 'temperatura', 248.0000, 'ºC'),
	(193461, 118, '2014-02-15 01:11:25.000000', 'temperatura', 425.0000, 'ºC'),
	(193462, 118, '2014-02-15 01:11:26.000000', 'temperatura', 183.0000, 'ºC'),
	(193463, 118, '2014-02-15 01:11:27.000000', 'temperatura', 838.0000, 'ºC'),
	(193464, 118, '2014-02-15 01:11:28.000000', 'temperatura', 45.0000, 'ºC'),
	(193465, 118, '2014-02-15 01:11:29.000000', 'temperatura', 109.0000, 'ºC'),
	(193466, 118, '2014-02-15 01:11:30.000000', 'temperatura', 409.0000, 'ºC'),
	(193467, 118, '2014-02-15 01:11:31.000000', 'temperatura', 521.0000, 'ºC'),
	(193468, 118, '2014-02-15 01:11:32.000000', 'temperatura', 176.0000, 'ºC'),
	(193469, 118, '2014-02-15 01:11:33.000000', 'temperatura', 520.0000, 'ºC'),
	(193470, 118, '2014-02-15 01:11:34.000000', 'temperatura', 869.0000, 'ºC'),
	(193471, 118, '2014-02-15 01:11:35.000000', 'temperatura', 389.0000, 'ºC'),
	(193472, 118, '2014-02-15 01:11:36.000000', 'temperatura', 539.0000, 'ºC'),
	(193473, 118, '2014-02-15 01:11:37.000000', 'temperatura', 329.0000, 'ºC'),
	(193474, 118, '2014-02-15 01:11:38.000000', 'temperatura', 28.0000, 'ºC'),
	(193475, 118, '2014-02-15 01:11:39.000000', 'temperatura', 352.0000, 'ºC'),
	(193476, 118, '2014-02-15 01:11:40.000000', 'temperatura', 476.0000, 'ºC'),
	(193477, 118, '2014-02-15 01:11:41.000000', 'temperatura', 125.0000, 'ºC'),
	(193478, 118, '2014-02-15 01:11:42.000000', 'temperatura', 397.0000, 'ºC'),
	(193479, 118, '2014-02-15 01:11:43.000000', 'temperatura', 410.0000, 'ºC'),
	(193480, 118, '2014-02-15 01:11:44.000000', 'temperatura', 860.0000, 'ºC'),
	(193481, 118, '2014-02-15 01:11:45.000000', 'temperatura', 670.0000, 'ºC'),
	(193482, 118, '2014-02-15 01:11:46.000000', 'temperatura', 769.0000, 'ºC'),
	(193483, 118, '2014-02-15 01:11:47.000000', 'temperatura', 638.0000, 'ºC'),
	(193484, 118, '2014-02-15 01:11:48.000000', 'temperatura', 881.0000, 'ºC'),
	(193485, 118, '2014-02-15 01:11:49.000000', 'temperatura', 93.0000, 'ºC'),
	(193486, 118, '2014-02-15 01:11:50.000000', 'temperatura', 222.0000, 'ºC'),
	(193487, 118, '2014-02-15 01:11:51.000000', 'temperatura', 831.0000, 'ºC'),
	(193488, 118, '2014-02-15 01:11:52.000000', 'temperatura', 1091.0000, 'ºC'),
	(193489, 118, '2014-02-15 01:11:53.000000', 'temperatura', 562.0000, 'ºC'),
	(193490, 118, '2014-02-15 01:11:54.000000', 'temperatura', 739.0000, 'ºC'),
	(193491, 118, '2014-02-15 01:11:55.000000', 'temperatura', 807.0000, 'ºC'),
	(193492, 118, '2014-02-15 01:11:56.000000', 'temperatura', 620.0000, 'ºC'),
	(193493, 118, '2014-02-15 01:11:57.000000', 'temperatura', 680.0000, 'ºC'),
	(193494, 118, '2014-02-15 01:11:58.000000', 'temperatura', 342.0000, 'ºC'),
	(193495, 118, '2014-02-15 01:11:59.000000', 'temperatura', 868.0000, 'ºC'),
	(193496, 118, '2014-02-15 01:12:00.000000', 'temperatura', 914.0000, 'ºC'),
	(193497, 118, '2014-02-15 01:12:01.000000', 'temperatura', 767.0000, 'ºC'),
	(193498, 118, '2014-02-15 01:12:02.000000', 'temperatura', 1092.0000, 'ºC'),
	(193499, 118, '2014-02-15 01:12:03.000000', 'temperatura', 761.0000, 'ºC'),
	(193500, 118, '2014-02-15 01:12:04.000000', 'temperatura', 531.0000, 'ºC'),
	(193501, 118, '2014-02-15 01:12:05.000000', 'temperatura', 370.0000, 'ºC'),
	(193502, 118, '2014-02-15 01:12:06.000000', 'temperatura', 259.0000, 'ºC'),
	(193503, 118, '2014-02-15 01:12:07.000000', 'temperatura', 183.0000, 'ºC'),
	(193504, 118, '2014-02-15 01:12:08.000000', 'temperatura', 142.0000, 'ºC'),
	(193505, 118, '2014-02-15 01:12:09.000000', 'temperatura', 158.0000, 'ºC'),
	(193506, 118, '2014-02-15 01:12:10.000000', 'temperatura', 366.0000, 'ºC'),
	(193507, 118, '2014-02-15 01:12:11.000000', 'temperatura', 159.0000, 'ºC'),
	(193508, 118, '2014-02-15 01:12:12.000000', 'temperatura', 894.0000, 'ºC'),
	(193509, 118, '2014-02-15 01:12:13.000000', 'temperatura', 393.0000, 'ºC'),
	(193510, 118, '2014-02-15 01:12:14.000000', 'temperatura', 485.0000, 'ºC'),
	(193511, 118, '2014-02-15 01:12:15.000000', 'temperatura', 47.0000, 'ºC'),
	(193512, 118, '2014-02-15 01:12:16.000000', 'temperatura', 1181.0000, 'ºC'),
	(193513, 118, '2014-02-15 01:12:17.000000', 'temperatura', 965.0000, 'ºC'),
	(193514, 118, '2014-02-15 01:12:18.000000', 'temperatura', 84.0000, 'ºC'),
	(193515, 118, '2014-02-15 01:12:19.000000', 'temperatura', 1122.0000, 'ºC'),
	(193516, 118, '2014-02-15 01:12:20.000000', 'temperatura', 562.0000, 'ºC'),
	(193517, 118, '2014-02-15 01:12:21.000000', 'temperatura', 641.0000, 'ºC'),
	(193518, 118, '2014-02-15 01:12:22.000000', 'temperatura', 320.0000, 'ºC'),
	(193519, 118, '2014-02-15 01:12:23.000000', 'temperatura', 879.0000, 'ºC'),
	(193520, 118, '2014-02-15 01:12:24.000000', 'temperatura', 1034.0000, 'ºC'),
	(193521, 118, '2014-02-15 01:12:25.000000', 'temperatura', 133.0000, 'ºC'),
	(193522, 118, '2014-02-15 01:12:26.000000', 'temperatura', 1162.0000, 'ºC'),
	(193523, 118, '2014-02-15 01:12:27.000000', 'temperatura', 615.0000, 'ºC'),
	(193524, 118, '2014-02-15 01:12:28.000000', 'temperatura', 786.0000, 'ºC'),
	(193525, 118, '2014-02-15 01:12:29.000000', 'temperatura', 887.0000, 'ºC'),
	(193526, 118, '2014-02-15 01:12:30.000000', 'temperatura', 879.0000, 'ºC'),
	(193527, 118, '2014-02-15 01:12:31.000000', 'temperatura', 533.0000, 'ºC'),
	(193528, 118, '2014-02-15 01:12:32.000000', 'temperatura', 27.0000, 'ºC'),
	(193529, 118, '2014-02-15 01:12:33.000000', 'temperatura', 936.0000, 'ºC'),
	(193530, 118, '2014-02-15 01:12:34.000000', 'temperatura', 1003.0000, 'ºC'),
	(193531, 118, '2014-02-15 01:12:35.000000', 'temperatura', 1004.0000, 'ºC'),
	(193532, 118, '2014-02-15 01:12:36.000000', 'temperatura', 812.0000, 'ºC'),
	(193533, 118, '2014-02-15 01:12:37.000000', 'temperatura', 1050.0000, 'ºC'),
	(193534, 118, '2014-02-15 01:12:38.000000', 'temperatura', 414.0000, 'ºC'),
	(193535, 118, '2014-02-15 01:12:39.000000', 'temperatura', 119.0000, 'ºC'),
	(193536, 118, '2014-02-15 01:12:40.000000', 'temperatura', 555.0000, 'ºC'),
	(193537, 118, '2014-02-15 01:12:41.000000', 'temperatura', 20.0000, 'ºC'),
	(193538, 118, '2014-02-15 01:12:42.000000', 'temperatura', 835.0000, 'ºC'),
	(193539, 118, '2014-02-15 01:12:43.000000', 'temperatura', 514.0000, 'ºC'),
	(193540, 118, '2014-02-15 01:12:44.000000', 'temperatura', 68.0000, 'ºC'),
	(193541, 118, '2014-02-15 01:12:45.000000', 'temperatura', 1196.0000, 'ºC'),
	(193542, 118, '2014-02-15 01:12:46.000000', 'temperatura', 977.0000, 'ºC'),
	(193543, 118, '2014-02-15 01:12:47.000000', 'temperatura', 99.0000, 'ºC'),
	(193544, 118, '2014-02-15 01:12:48.000000', 'temperatura', 1163.0000, 'ºC'),
	(193545, 118, '2014-02-15 01:12:49.000000', 'temperatura', 718.0000, 'ºC'),
	(193546, 118, '2014-02-15 01:12:50.000000', 'temperatura', 101.0000, 'ºC'),
	(193547, 118, '2014-02-15 01:12:51.000000', 'temperatura', 752.0000, 'ºC'),
	(193548, 118, '2014-02-15 01:12:52.000000', 'temperatura', 1060.0000, 'ºC'),
	(193549, 118, '2014-02-15 01:12:53.000000', 'temperatura', 641.0000, 'ºC'),
	(193550, 118, '2014-02-15 01:12:54.000000', 'temperatura', 26.0000, 'ºC'),
	(193551, 118, '2014-02-15 01:12:55.000000', 'temperatura', 607.0000, 'ºC'),
	(193552, 118, '2014-02-15 01:12:56.000000', 'temperatura', 560.0000, 'ºC'),
	(193553, 118, '2014-02-15 01:12:57.000000', 'temperatura', 978.0000, 'ºC'),
	(193554, 118, '2014-02-15 01:12:58.000000', 'temperatura', 811.0000, 'ºC'),
	(193555, 118, '2014-02-15 01:12:59.000000', 'temperatura', 1122.0000, 'ºC'),
	(193556, 118, '2014-02-15 01:13:00.000000', 'temperatura', 778.0000, 'ºC'),
	(193557, 118, '2014-02-15 01:13:01.000000', 'temperatura', 525.0000, 'ºC'),
	(193558, 118, '2014-02-15 01:13:02.000000', 'temperatura', 293.0000, 'ºC'),
	(193559, 118, '2014-02-15 01:13:03.000000', 'temperatura', 1088.0000, 'ºC'),
	(193560, 118, '2014-02-15 01:13:04.000000', 'temperatura', 961.0000, 'ºC'),
	(193561, 118, '2014-02-15 01:13:05.000000', 'temperatura', 343.0000, 'ºC'),
	(193562, 118, '2014-02-15 01:13:06.000000', 'temperatura', 34.0000, 'ºC'),
	(193563, 118, '2014-02-15 01:13:07.000000', 'temperatura', 340.0000, 'ºC'),
	(193564, 118, '2014-02-15 01:13:08.000000', 'temperatura', 398.0000, 'ºC'),
	(193565, 118, '2014-02-15 01:13:09.000000', 'temperatura', 969.0000, 'ºC'),
	(193566, 118, '2014-02-15 01:13:10.000000', 'temperatura', 55.0000, 'ºC'),
	(193567, 118, '2014-02-15 01:13:11.000000', 'temperatura', 966.0000, 'ºC'),
	(193568, 118, '2014-02-15 01:13:12.000000', 'temperatura', 1068.0000, 'ºC'),
	(193569, 118, '2014-02-15 01:13:13.000000', 'temperatura', 42.0000, 'ºC'),
	(193570, 118, '2014-02-15 01:13:14.000000', 'temperatura', 607.0000, 'ºC'),
	(193571, 118, '2014-02-15 01:13:15.000000', 'temperatura', 510.0000, 'ºC'),
	(193572, 118, '2014-02-15 01:13:16.000000', 'temperatura', 730.0000, 'ºC'),
	(193573, 118, '2014-02-15 01:13:17.000000', 'temperatura', 921.0000, 'ºC'),
	(193574, 118, '2014-02-15 01:13:18.000000', 'temperatura', 15.0000, 'ºC'),
	(193575, 118, '2014-02-15 01:13:19.000000', 'temperatura', 913.0000, 'ºC'),
	(193576, 118, '2014-02-15 01:13:20.000000', 'temperatura', 921.0000, 'ºC'),
	(193577, 118, '2014-02-15 01:13:21.000000', 'temperatura', 668.0000, 'ºC'),
	(193578, 118, '2014-02-15 01:13:22.000000', 'temperatura', 575.0000, 'ºC'),
	(193579, 118, '2014-02-15 01:13:23.000000', 'temperatura', 873.0000, 'ºC'),
	(193580, 118, '2014-02-15 01:13:24.000000', 'temperatura', 242.0000, 'ºC'),
	(193581, 118, '2014-02-15 01:13:25.000000', 'temperatura', 989.0000, 'ºC'),
	(193582, 118, '2014-02-15 01:13:26.000000', 'temperatura', 621.0000, 'ºC'),
	(193583, 118, '2014-02-15 01:13:27.000000', 'temperatura', 136.0000, 'ºC'),
	(193584, 118, '2014-02-15 01:13:28.000000', 'temperatura', 19.0000, 'ºC'),
	(193585, 118, '2014-02-15 01:13:29.000000', 'temperatura', 887.0000, 'ºC'),
	(193586, 118, '2014-02-15 01:13:30.000000', 'temperatura', 780.0000, 'ºC'),
	(193587, 118, '2014-02-15 01:13:31.000000', 'temperatura', 38.0000, 'ºC'),
	(193588, 118, '2014-02-15 01:13:32.000000', 'temperatura', 252.0000, 'ºC'),
	(193589, 118, '2014-02-15 01:13:33.000000', 'temperatura', 1148.0000, 'ºC'),
	(193590, 118, '2014-02-15 01:13:34.000000', 'temperatura', 181.0000, 'ºC'),
	(193591, 118, '2014-02-15 01:13:35.000000', 'temperatura', 1062.0000, 'ºC'),
	(193592, 118, '2014-02-15 01:13:36.000000', 'temperatura', 1170.0000, 'ºC'),
	(193593, 118, '2014-02-15 01:13:37.000000', 'temperatura', 262.0000, 'ºC'),
	(193594, 118, '2014-02-15 01:13:38.000000', 'temperatura', 201.0000, 'ºC'),
	(193595, 118, '2014-02-15 01:13:39.000000', 'temperatura', 218.0000, 'ºC'),
	(193596, 118, '2014-02-15 01:13:40.000000', 'temperatura', 489.0000, 'ºC'),
	(193597, 118, '2014-02-15 01:13:41.000000', 'temperatura', 593.0000, 'ºC'),
	(193598, 118, '2014-02-15 01:13:42.000000', 'temperatura', 298.0000, 'ºC'),
	(193599, 118, '2014-02-15 01:13:43.000000', 'temperatura', 913.0000, 'ºC'),
	(193600, 118, '2014-02-15 01:13:44.000000', 'temperatura', 70.0000, 'ºC'),
	(193601, 118, '2014-02-15 01:13:45.000000', 'temperatura', 14.0000, 'ºC'),
	(193602, 118, '2014-02-15 01:13:46.000000', 'temperatura', 1058.0000, 'ºC'),
	(193603, 118, '2014-02-15 01:13:47.000000', 'temperatura', 447.0000, 'ºC'),
	(193604, 118, '2014-02-15 01:13:48.000000', 'temperatura', 264.0000, 'ºC'),
	(193605, 118, '2014-02-15 01:13:49.000000', 'temperatura', 1179.0000, 'ºC'),
	(193606, 118, '2014-02-15 01:13:50.000000', 'temperatura', 304.0000, 'ºC'),
	(193607, 118, '2014-02-15 01:13:51.000000', 'temperatura', 385.0000, 'ºC'),
	(193608, 118, '2014-02-15 01:13:52.000000', 'temperatura', 1012.0000, 'ºC'),
	(193609, 118, '2014-02-15 01:13:53.000000', 'temperatura', 306.0000, 'ºC'),
	(193610, 118, '2014-02-15 01:13:54.000000', 'temperatura', 894.0000, 'ºC'),
	(193611, 118, '2014-02-15 01:13:55.000000', 'temperatura', 1154.0000, 'ºC'),
	(193612, 118, '2014-02-15 01:13:56.000000', 'temperatura', 686.0000, 'ºC'),
	(193613, 118, '2014-02-15 01:13:57.000000', 'temperatura', 1167.0000, 'ºC'),
	(193614, 118, '2014-02-15 01:13:58.000000', 'temperatura', 181.0000, 'ºC'),
	(193615, 118, '2014-02-15 01:13:59.000000', 'temperatura', 1004.0000, 'ºC'),
	(193616, 118, '2014-02-15 01:14:00.000000', 'temperatura', 878.0000, 'ºC'),
	(193617, 118, '2014-02-15 01:14:01.000000', 'temperatura', 176.0000, 'ºC'),
	(193618, 118, '2014-02-15 01:14:02.000000', 'temperatura', 649.0000, 'ºC'),
	(193619, 118, '2014-02-15 01:14:03.000000', 'temperatura', 317.0000, 'ºC'),
	(193620, 118, '2014-02-15 01:14:04.000000', 'temperatura', 839.0000, 'ºC'),
	(193621, 118, '2014-02-15 01:14:05.000000', 'temperatura', 842.0000, 'ºC'),
	(193622, 118, '2014-02-15 01:14:06.000000', 'temperatura', 496.0000, 'ºC'),
	(193623, 118, '2014-02-15 01:14:07.000000', 'temperatura', 1155.0000, 'ºC'),
	(193624, 118, '2014-02-15 01:14:08.000000', 'temperatura', 686.0000, 'ºC'),
	(193625, 118, '2014-02-15 01:14:09.000000', 'temperatura', 1166.0000, 'ºC'),
	(193626, 118, '2014-02-15 01:14:10.000000', 'temperatura', 170.0000, 'ºC'),
	(193627, 118, '2014-02-15 01:14:11.000000', 'temperatura', 956.0000, 'ºC'),
	(193628, 118, '2014-02-15 01:14:12.000000', 'temperatura', 667.0000, 'ºC'),
	(193629, 118, '2014-02-15 01:14:13.000000', 'temperatura', 470.0000, 'ºC'),
	(193630, 118, '2014-02-15 01:14:14.000000', 'temperatura', 347.0000, 'ºC'),
	(193631, 118, '2014-02-15 01:14:15.000000', 'temperatura', 329.0000, 'ºC'),
	(193632, 118, '2014-02-15 01:14:16.000000', 'temperatura', 601.0000, 'ºC'),
	(193633, 118, '2014-02-15 01:14:17.000000', 'temperatura', 820.0000, 'ºC'),
	(193634, 118, '2014-02-15 01:14:18.000000', 'temperatura', 1098.0000, 'ºC'),
	(193635, 118, '2014-02-15 01:14:19.000000', 'temperatura', 630.0000, 'ºC'),
	(193636, 118, '2014-02-15 01:14:20.000000', 'temperatura', 1058.0000, 'ºC'),
	(193637, 118, '2014-02-15 01:14:21.000000', 'temperatura', 1000.0000, 'ºC'),
	(193638, 118, '2014-02-15 01:14:22.000000', 'temperatura', 625.0000, 'ºC'),
	(193639, 118, '2014-02-15 01:14:23.000000', 'temperatura', 127.0000, 'ºC'),
	(193640, 118, '2014-02-15 01:14:24.000000', 'temperatura', 1160.0000, 'ºC'),
	(193641, 118, '2014-02-15 01:14:25.000000', 'temperatura', 620.0000, 'ºC'),
	(193642, 118, '2014-02-15 01:14:26.000000', 'temperatura', 820.0000, 'ºC'),
	(193643, 118, '2014-02-15 01:14:27.000000', 'temperatura', 1040.0000, 'ºC'),
	(193644, 118, '2014-02-15 01:14:28.000000', 'temperatura', 341.0000, 'ºC'),
	(193645, 118, '2014-02-15 01:14:29.000000', 'temperatura', 986.0000, 'ºC'),
	(193646, 118, '2014-02-15 01:14:30.000000', 'temperatura', 307.0000, 'ºC'),
	(193647, 118, '2014-02-15 01:14:31.000000', 'temperatura', 978.0000, 'ºC'),
	(193648, 118, '2014-02-15 01:14:32.000000', 'temperatura', 371.0000, 'ºC'),
	(193649, 118, '2014-02-15 01:14:33.000000', 'temperatura', 118.0000, 'ºC'),
	(193650, 118, '2014-02-15 01:14:34.000000', 'temperatura', 681.0000, 'ºC'),
	(193651, 118, '2014-02-15 01:14:35.000000', 'temperatura', 650.0000, 'ºC'),
	(193652, 118, '2014-02-15 01:14:36.000000', 'temperatura', 10.0000, 'ºC'),
	(193653, 118, '2014-02-15 01:14:37.000000', 'temperatura', 497.0000, 'ºC'),
	(193654, 118, '2014-02-15 01:14:38.000000', 'temperatura', 56.0000, 'ºC'),
	(193655, 118, '2014-02-15 01:14:39.000000', 'temperatura', 1190.0000, 'ºC'),
	(193656, 118, '2014-02-15 01:14:40.000000', 'temperatura', 982.0000, 'ºC'),
	(193657, 118, '2014-02-15 01:14:41.000000', 'temperatura', 142.0000, 'ºC'),
	(193658, 118, '2014-02-15 01:14:42.000000', 'temperatura', 166.0000, 'ºC'),
	(193659, 118, '2014-02-15 01:14:43.000000', 'temperatura', 401.0000, 'ºC'),
	(193660, 118, '2014-02-15 01:14:44.000000', 'temperatura', 311.0000, 'ºC'),
	(193661, 118, '2014-02-15 01:14:45.000000', 'temperatura', 350.0000, 'ºC'),
	(193662, 118, '2014-02-15 01:14:46.000000', 'temperatura', 818.0000, 'ºC'),
	(193663, 118, '2014-02-15 01:14:47.000000', 'temperatura', 641.0000, 'ºC'),
	(193664, 118, '2014-02-15 01:14:48.000000', 'temperatura', 749.0000, 'ºC'),
	(193665, 118, '2014-02-15 01:14:49.000000', 'temperatura', 626.0000, 'ºC'),
	(193666, 118, '2014-02-15 01:14:50.000000', 'temperatura', 880.0000, 'ºC'),
	(193667, 118, '2014-02-15 01:14:51.000000', 'temperatura', 125.0000, 'ºC'),
	(193668, 118, '2014-02-15 01:14:52.000000', 'temperatura', 386.0000, 'ºC'),
	(193669, 118, '2014-02-15 01:14:53.000000', 'temperatura', 354.0000, 'ºC'),
	(193670, 118, '2014-02-15 01:14:54.000000', 'temperatura', 611.0000, 'ºC'),
	(193671, 118, '2014-02-15 01:14:55.000000', 'temperatura', 795.0000, 'ºC'),
	(193672, 118, '2014-02-15 01:14:56.000000', 'temperatura', 941.0000, 'ºC'),
	(193673, 118, '2014-02-15 01:14:57.000000', 'temperatura', 1122.0000, 'ºC'),
	(193674, 118, '2014-02-15 01:14:58.000000', 'temperatura', 385.0000, 'ºC'),
	(193675, 118, '2014-02-15 01:14:59.000000', 'temperatura', 963.0000, 'ºC'),
	(193676, 118, '2014-02-15 01:15:00.000000', 'temperatura', 60.0000, 'ºC'),
	(193677, 118, '2014-02-15 01:15:01.000000', 'temperatura', 1009.0000, 'ºC'),
	(193678, 118, '2014-02-15 01:15:02.000000', 'temperatura', 68.0000, 'ºC'),
	(193679, 118, '2014-02-15 01:15:03.000000', 'temperatura', 914.0000, 'ºC'),
	(193680, 118, '2014-02-15 01:15:04.000000', 'temperatura', 764.0000, 'ºC'),
	(193681, 118, '2014-02-15 01:15:05.000000', 'temperatura', 1081.0000, 'ºC'),
	(193682, 118, '2014-02-15 01:15:06.000000', 'temperatura', 713.0000, 'ºC'),
	(193683, 118, '2014-02-15 01:15:07.000000', 'temperatura', 324.0000, 'ºC'),
	(193684, 118, '2014-02-15 01:15:08.000000', 'temperatura', 681.0000, 'ºC'),
	(193685, 118, '2014-02-15 01:15:09.000000', 'temperatura', 33.0000, 'ºC'),
	(193686, 118, '2014-02-15 01:15:10.000000', 'temperatura', 522.0000, 'ºC'),
	(193687, 118, '2014-02-15 01:15:11.000000', 'temperatura', 113.0000, 'ºC'),
	(193688, 118, '2014-02-15 01:15:12.000000', 'temperatura', 197.0000, 'ºC'),
	(193689, 118, '2014-02-15 01:15:13.000000', 'temperatura', 649.0000, 'ºC'),
	(193690, 118, '2014-02-15 01:15:14.000000', 'temperatura', 253.0000, 'ºC'),
	(193691, 118, '2014-02-15 01:15:15.000000', 'temperatura', 517.0000, 'ºC'),
	(193692, 118, '2014-02-15 01:15:16.000000', 'temperatura', 628.0000, 'ºC'),
	(193693, 118, '2014-02-15 01:15:17.000000', 'temperatura', 390.0000, 'ºC'),
	(193694, 118, '2014-02-15 01:15:18.000000', 'temperatura', 65.0000, 'ºC'),
	(193695, 118, '2014-02-15 01:15:19.000000', 'temperatura', 357.0000, 'ºC'),
	(193696, 118, '2014-02-15 01:15:20.000000', 'temperatura', 391.0000, 'ºC'),
	(193697, 118, '2014-02-15 01:15:21.000000', 'temperatura', 884.0000, 'ºC'),
	(193698, 118, '2014-02-15 01:15:22.000000', 'temperatura', 848.0000, 'ºC'),
	(193699, 118, '2014-02-15 01:15:23.000000', 'temperatura', 386.0000, 'ºC'),
	(193700, 118, '2014-02-15 01:15:24.000000', 'temperatura', 588.0000, 'ºC'),
	(193701, 118, '2014-02-15 01:15:25.000000', 'temperatura', 582.0000, 'ºC'),
	(193702, 118, '2014-02-15 01:15:26.000000', 'temperatura', 1146.0000, 'ºC'),
	(193703, 118, '2014-02-15 01:15:27.000000', 'temperatura', 386.0000, 'ºC'),
	(193704, 118, '2014-02-15 01:15:28.000000', 'temperatura', 892.0000, 'ºC'),
	(193705, 118, '2014-02-15 01:15:29.000000', 'temperatura', 902.0000, 'ºC'),
	(193706, 118, '2014-02-15 01:15:30.000000', 'temperatura', 636.0000, 'ºC'),
	(193707, 118, '2014-02-15 01:15:31.000000', 'temperatura', 473.0000, 'ºC'),
	(193708, 118, '2014-02-15 01:15:32.000000', 'temperatura', 460.0000, 'ºC'),
	(193709, 118, '2014-02-15 01:15:33.000000', 'temperatura', 878.0000, 'ºC'),
	(193710, 118, '2014-02-15 01:15:34.000000', 'temperatura', 612.0000, 'ºC'),
	(193711, 118, '2014-02-15 01:15:35.000000', 'temperatura', 427.0000, 'ºC'),
	(193712, 118, '2014-02-15 01:15:36.000000', 'temperatura', 299.0000, 'ºC'),
	(193713, 118, '2014-02-15 01:15:37.000000', 'temperatura', 217.0000, 'ºC'),
	(193714, 118, '2014-02-15 01:15:38.000000', 'temperatura', 185.0000, 'ºC'),
	(193715, 118, '2014-02-15 01:15:39.000000', 'temperatura', 276.0000, 'ºC'),
	(193716, 118, '2014-02-15 01:15:40.000000', 'temperatura', 825.0000, 'ºC'),
	(193717, 118, '2014-02-15 01:15:41.000000', 'temperatura', 899.0000, 'ºC'),
	(193718, 118, '2014-02-15 01:15:42.000000', 'temperatura', 818.0000, 'ºC'),
	(193719, 118, '2014-02-15 01:15:43.000000', 'temperatura', 196.0000, 'ºC'),
	(193720, 118, '2014-02-15 01:15:44.000000', 'temperatura', 924.0000, 'ºC'),
	(193721, 118, '2014-02-15 01:15:45.000000', 'temperatura', 432.0000, 'ºC'),
	(193722, 118, '2014-02-15 01:15:46.000000', 'temperatura', 589.0000, 'ºC'),
	(193723, 118, '2014-02-15 01:15:47.000000', 'temperatura', 451.0000, 'ºC'),
	(193724, 118, '2014-02-15 01:15:48.000000', 'temperatura', 490.0000, 'ºC'),
	(193725, 118, '2014-02-15 01:15:49.000000', 'temperatura', 1095.0000, 'ºC'),
	(193726, 118, '2014-02-15 01:15:50.000000', 'temperatura', 406.0000, 'ºC'),
	(193727, 118, '2014-02-15 01:15:51.000000', 'temperatura', 1146.0000, 'ºC'),
	(193728, 118, '2014-02-15 01:15:52.000000', 'temperatura', 914.0000, 'ºC'),
	(193729, 118, '2014-02-15 01:15:53.000000', 'temperatura', 1131.0000, 'ºC'),
	(193730, 118, '2014-02-15 01:15:54.000000', 'temperatura', 514.0000, 'ºC'),
	(193731, 118, '2014-02-15 01:15:55.000000', 'temperatura', 377.0000, 'ºC'),
	(193732, 118, '2014-02-15 01:15:56.000000', 'temperatura', 342.0000, 'ºC'),
	(193733, 118, '2014-02-15 01:15:57.000000', 'temperatura', 580.0000, 'ºC'),
	(193734, 118, '2014-02-15 01:15:58.000000', 'temperatura', 674.0000, 'ºC'),
	(193735, 118, '2014-02-15 01:15:59.000000', 'temperatura', 430.0000, 'ºC'),
	(193736, 118, '2014-02-15 01:16:00.000000', 'temperatura', 128.0000, 'ºC'),
	(193737, 118, '2014-02-15 01:16:01.000000', 'temperatura', 551.0000, 'ºC'),
	(193738, 118, '2014-02-15 01:16:02.000000', 'temperatura', 1172.0000, 'ºC'),
	(193739, 118, '2014-02-15 01:16:03.000000', 'temperatura', 609.0000, 'ºC'),
	(193740, 118, '2014-02-15 01:16:04.000000', 'temperatura', 730.0000, 'ºC'),
	(193741, 118, '2014-02-15 01:16:05.000000', 'temperatura', 624.0000, 'ºC'),
	(193742, 118, '2014-02-15 01:16:06.000000', 'temperatura', 929.0000, 'ºC'),
	(193743, 118, '2014-02-15 01:16:07.000000', 'temperatura', 375.0000, 'ºC'),
	(193744, 118, '2014-02-15 01:16:08.000000', 'temperatura', 289.0000, 'ºC'),
	(193745, 118, '2014-02-15 01:16:09.000000', 'temperatura', 319.0000, 'ºC'),
	(193746, 118, '2014-02-15 01:16:10.000000', 'temperatura', 730.0000, 'ºC'),
	(193747, 118, '2014-02-15 01:16:11.000000', 'temperatura', 291.0000, 'ºC'),
	(193748, 118, '2014-02-15 01:16:12.000000', 'temperatura', 467.0000, 'ºC'),
	(193749, 118, '2014-02-15 01:16:13.000000', 'temperatura', 264.0000, 'ºC'),
	(193750, 118, '2014-02-15 01:16:14.000000', 'temperatura', 1118.0000, 'ºC'),
	(193751, 118, '2014-02-15 01:16:15.000000', 'temperatura', 1198.0000, 'ºC'),
	(193752, 118, '2014-02-15 01:16:16.000000', 'temperatura', 236.0000, 'ºC'),
	(193753, 118, '2014-02-15 01:16:17.000000', 'temperatura', 1189.0000, 'ºC'),
	(193754, 118, '2014-02-15 01:16:18.000000', 'temperatura', 435.0000, 'ºC'),
	(193755, 118, '2014-02-15 01:16:19.000000', 'temperatura', 1011.0000, 'ºC'),
	(193756, 118, '2014-02-15 01:16:20.000000', 'temperatura', 149.0000, 'ºC'),
	(193757, 118, '2014-02-15 01:16:21.000000', 'temperatura', 113.0000, 'ºC'),
	(193758, 118, '2014-02-15 01:16:22.000000', 'temperatura', 118.0000, 'ºC'),
	(193759, 118, '2014-02-15 01:16:23.000000', 'temperatura', 251.0000, 'ºC'),
	(193760, 118, '2014-02-15 01:16:24.000000', 'temperatura', 904.0000, 'ºC'),
	(193761, 118, '2014-02-15 01:16:25.000000', 'temperatura', 166.0000, 'ºC'),
	(193762, 118, '2014-02-15 01:16:26.000000', 'temperatura', 518.0000, 'ºC'),
	(193763, 118, '2014-02-15 01:16:27.000000', 'temperatura', 894.0000, 'ºC'),
	(193764, 118, '2014-02-15 01:16:28.000000', 'temperatura', 514.0000, 'ºC'),
	(193765, 118, '2014-02-15 01:16:29.000000', 'temperatura', 1090.0000, 'ºC'),
	(193766, 118, '2014-02-15 01:16:30.000000', 'temperatura', 310.0000, 'ºC'),
	(193767, 118, '2014-02-15 01:16:31.000000', 'temperatura', 679.0000, 'ºC'),
	(193768, 118, '2014-02-15 01:16:32.000000', 'temperatura', 64.0000, 'ºC'),
	(193769, 118, '2014-02-15 01:16:33.000000', 'temperatura', 686.0000, 'ºC'),
	(193770, 118, '2014-02-15 01:16:34.000000', 'temperatura', 837.0000, 'ºC'),
	(193771, 118, '2014-02-15 01:16:35.000000', 'temperatura', 928.0000, 'ºC'),
	(193772, 118, '2014-02-15 01:16:36.000000', 'temperatura', 930.0000, 'ºC'),
	(193773, 118, '2014-02-15 01:16:37.000000', 'temperatura', 668.0000, 'ºC'),
	(193774, 118, '2014-02-15 01:16:38.000000', 'temperatura', 547.0000, 'ºC'),
	(193775, 118, '2014-02-15 01:16:39.000000', 'temperatura', 735.0000, 'ºC'),
	(193776, 118, '2014-02-15 01:16:40.000000', 'temperatura', 831.0000, 'ºC'),
	(193777, 118, '2014-02-15 01:16:41.000000', 'temperatura', 752.0000, 'ºC'),
	(193778, 118, '2014-02-15 01:16:42.000000', 'temperatura', 68.0000, 'ºC'),
	(193779, 118, '2014-02-15 01:16:43.000000', 'temperatura', 486.0000, 'ºC'),
	(193780, 118, '2014-02-15 01:16:44.000000', 'temperatura', 1023.0000, 'ºC'),
	(193781, 118, '2014-02-15 01:16:45.000000', 'temperatura', 60.0000, 'ºC'),
	(193782, 118, '2014-02-15 01:16:46.000000', 'temperatura', 830.0000, 'ºC'),
	(193783, 118, '2014-02-15 01:16:47.000000', 'temperatura', 372.0000, 'ºC'),
	(193784, 118, '2014-02-15 01:16:48.000000', 'temperatura', 569.0000, 'ºC'),
	(193785, 118, '2014-02-15 01:16:49.000000', 'temperatura', 531.0000, 'ºC'),
	(193786, 118, '2014-02-15 01:16:50.000000', 'temperatura', 949.0000, 'ºC'),
	(193787, 118, '2014-02-15 01:16:51.000000', 'temperatura', 753.0000, 'ºC'),
	(193788, 118, '2014-02-15 01:16:52.000000', 'temperatura', 919.0000, 'ºC'),
	(193789, 118, '2014-02-15 01:16:53.000000', 'temperatura', 1138.0000, 'ºC'),
	(193790, 118, '2014-02-15 01:16:54.000000', 'temperatura', 530.0000, 'ºC'),
	(193791, 118, '2014-02-15 01:16:55.000000', 'temperatura', 439.0000, 'ºC'),
	(193792, 118, '2014-02-15 01:16:56.000000', 'temperatura', 603.0000, 'ºC'),
	(193793, 118, '2014-02-15 01:16:57.000000', 'temperatura', 501.0000, 'ºC'),
	(193794, 118, '2014-02-15 01:16:58.000000', 'temperatura', 697.0000, 'ºC'),
	(193795, 118, '2014-02-15 01:16:59.000000', 'temperatura', 783.0000, 'ºC'),
	(193796, 118, '2014-02-15 01:17:00.000000', 'temperatura', 622.0000, 'ºC'),
	(193797, 118, '2014-02-15 01:17:01.000000', 'temperatura', 763.0000, 'ºC'),
	(193798, 118, '2014-02-15 01:17:02.000000', 'temperatura', 749.0000, 'ºC'),
	(193799, 118, '2014-02-15 01:17:03.000000', 'temperatura', 255.0000, 'ºC'),
	(193800, 118, '2014-02-15 01:17:04.000000', 'temperatura', 228.0000, 'ºC'),
	(193801, 118, '2014-02-15 01:17:05.000000', 'temperatura', 375.0000, 'ºC'),
	(193802, 118, '2014-02-15 01:17:06.000000', 'temperatura', 1192.0000, 'ºC'),
	(193803, 118, '2014-02-15 01:17:07.000000', 'temperatura', 35.0000, 'ºC'),
	(193804, 118, '2014-02-15 01:17:08.000000', 'temperatura', 200.0000, 'ºC'),
	(193805, 118, '2014-02-15 01:17:09.000000', 'temperatura', 896.0000, 'ºC'),
	(193806, 118, '2014-02-15 01:17:10.000000', 'temperatura', 281.0000, 'ºC'),
	(193807, 118, '2014-02-15 01:17:11.000000', 'temperatura', 1119.0000, 'ºC'),
	(193808, 118, '2014-02-15 01:17:12.000000', 'temperatura', 1150.0000, 'ºC'),
	(193809, 118, '2014-02-15 01:17:13.000000', 'temperatura', 1192.0000, 'ºC'),
	(193810, 118, '2014-02-15 01:17:14.000000', 'temperatura', 114.0000, 'ºC'),
	(193811, 118, '2014-02-15 01:17:15.000000', 'temperatura', 592.0000, 'ºC'),
	(193812, 118, '2014-02-15 01:17:16.000000', 'temperatura', 218.0000, 'ºC'),
	(193813, 118, '2014-02-15 01:17:17.000000', 'temperatura', 516.0000, 'ºC'),
	(193814, 118, '2014-02-15 01:17:18.000000', 'temperatura', 727.0000, 'ºC'),
	(193815, 118, '2014-02-15 01:17:19.000000', 'temperatura', 886.0000, 'ºC'),
	(193816, 118, '2014-02-15 01:17:20.000000', 'temperatura', 1049.0000, 'ºC'),
	(193817, 118, '2014-02-15 01:17:21.000000', 'temperatura', 190.0000, 'ºC'),
	(193818, 118, '2014-02-15 01:17:22.000000', 'temperatura', 201.0000, 'ºC'),
	(193819, 118, '2014-02-15 01:17:23.000000', 'temperatura', 438.0000, 'ºC'),
	(193820, 118, '2014-02-15 01:17:24.000000', 'temperatura', 386.0000, 'ºC'),
	(193821, 118, '2014-02-15 01:17:25.000000', 'temperatura', 618.0000, 'ºC'),
	(193822, 118, '2014-02-15 01:17:26.000000', 'temperatura', 733.0000, 'ºC'),
	(193823, 118, '2014-02-15 01:17:27.000000', 'temperatura', 613.0000, 'ºC'),
	(193824, 118, '2014-02-15 01:17:28.000000', 'temperatura', 863.0000, 'ºC'),
	(193825, 118, '2014-02-15 01:17:29.000000', 'temperatura', 78.0000, 'ºC'),
	(193826, 118, '2014-02-15 01:17:30.000000', 'temperatura', 200.0000, 'ºC'),
	(193827, 118, '2014-02-15 01:17:31.000000', 'temperatura', 769.0000, 'ºC'),
	(193828, 118, '2014-02-15 01:17:32.000000', 'temperatura', 845.0000, 'ºC'),
	(193829, 118, '2014-02-15 01:17:33.000000', 'temperatura', 716.0000, 'ºC'),
	(193830, 118, '2014-02-15 01:17:34.000000', 'temperatura', 1048.0000, 'ºC'),
	(193831, 118, '2014-02-15 01:17:35.000000', 'temperatura', 691.0000, 'ºC'),
	(193832, 118, '2014-02-15 01:17:36.000000', 'temperatura', 311.0000, 'ºC'),
	(193833, 118, '2014-02-15 01:17:37.000000', 'temperatura', 682.0000, 'ºC'),
	(193834, 118, '2014-02-15 01:17:38.000000', 'temperatura', 80.0000, 'ºC'),
	(193835, 118, '2014-02-15 01:17:39.000000', 'temperatura', 755.0000, 'ºC'),
	(193836, 118, '2014-02-15 01:17:40.000000', 'temperatura', 1134.0000, 'ºC'),
	(193837, 118, '2014-02-15 01:17:41.000000', 'temperatura', 1006.0000, 'ºC'),
	(193838, 118, '2014-02-15 01:17:42.000000', 'temperatura', 429.0000, 'ºC'),
	(193839, 118, '2014-02-15 01:17:43.000000', 'temperatura', 325.0000, 'ºC'),
	(193840, 118, '2014-02-15 01:17:44.000000', 'temperatura', 342.0000, 'ºC'),
	(193841, 118, '2014-02-15 01:17:45.000000', 'temperatura', 733.0000, 'ºC'),
	(193842, 118, '2014-02-15 01:17:46.000000', 'temperatura', 240.0000, 'ºC'),
	(193843, 118, '2014-02-15 01:17:47.000000', 'temperatura', 204.0000, 'ºC'),
	(193844, 118, '2014-02-15 01:17:48.000000', 'temperatura', 297.0000, 'ºC'),
	(193845, 118, '2014-02-15 01:17:49.000000', 'temperatura', 874.0000, 'ºC'),
	(193846, 118, '2014-02-15 01:17:50.000000', 'temperatura', 1081.0000, 'ºC'),
	(193847, 118, '2014-02-15 01:17:51.000000', 'temperatura', 382.0000, 'ºC'),
	(193848, 118, '2014-02-15 01:17:52.000000', 'temperatura', 1070.0000, 'ºC'),
	(193849, 118, '2014-02-15 01:17:53.000000', 'temperatura', 603.0000, 'ºC'),
	(193850, 118, '2014-02-15 01:17:54.000000', 'temperatura', 1004.0000, 'ºC'),
	(193851, 118, '2014-02-15 01:17:55.000000', 'temperatura', 811.0000, 'ºC'),
	(193852, 118, '2014-02-15 01:17:56.000000', 'temperatura', 1043.0000, 'ºC'),
	(193853, 118, '2014-02-15 01:17:57.000000', 'temperatura', 382.0000, 'ºC'),
	(193854, 118, '2014-02-15 01:17:58.000000', 'temperatura', 1181.0000, 'ºC'),
	(193855, 118, '2014-02-15 01:17:59.000000', 'temperatura', 1160.0000, 'ºC'),
	(193856, 118, '2014-02-15 01:18:00.000000', 'temperatura', 1058.0000, 'ºC'),
	(193857, 118, '2014-02-15 01:18:01.000000', 'temperatura', 609.0000, 'ºC'),
	(193858, 118, '2014-02-15 01:18:02.000000', 'temperatura', 1072.0000, 'ºC'),
	(193859, 118, '2014-02-15 01:18:03.000000', 'temperatura', 1135.0000, 'ºC'),
	(193860, 118, '2014-02-15 01:18:04.000000', 'temperatura', 57.0000, 'ºC'),
	(193861, 118, '2014-02-15 01:18:05.000000', 'temperatura', 482.0000, 'ºC'),
	(193862, 118, '2014-02-15 01:18:06.000000', 'temperatura', 1041.0000, 'ºC'),
	(193863, 118, '2014-02-15 01:18:07.000000', 'temperatura', 156.0000, 'ºC'),
	(193864, 118, '2014-02-15 01:18:08.000000', 'temperatura', 61.0000, 'ºC'),
	(193865, 118, '2014-02-15 01:18:09.000000', 'temperatura', 1035.0000, 'ºC'),
	(193866, 118, '2014-02-15 01:18:10.000000', 'temperatura', 195.0000, 'ºC'),
	(193867, 118, '2014-02-15 01:18:11.000000', 'temperatura', 269.0000, 'ºC'),
	(193868, 118, '2014-02-15 01:18:12.000000', 'temperatura', 761.0000, 'ºC'),
	(193869, 118, '2014-02-15 01:18:13.000000', 'temperatura', 599.0000, 'ºC'),
	(193870, 118, '2014-02-15 01:18:14.000000', 'temperatura', 714.0000, 'ºC'),
	(193871, 118, '2014-02-15 01:18:15.000000', 'temperatura', 572.0000, 'ºC'),
	(193872, 118, '2014-02-15 01:18:16.000000', 'temperatura', 718.0000, 'ºC'),
	(193873, 118, '2014-02-15 01:18:17.000000', 'temperatura', 673.0000, 'ºC'),
	(193874, 118, '2014-02-15 01:18:18.000000', 'temperatura', 13.0000, 'ºC'),
	(193875, 118, '2014-02-15 01:18:19.000000', 'temperatura', 448.0000, 'ºC'),
	(193876, 118, '2014-02-15 01:18:20.000000', 'temperatura', 1001.0000, 'ºC'),
	(193877, 118, '2014-02-15 01:18:21.000000', 'temperatura', 61.0000, 'ºC'),
	(193878, 118, '2014-02-15 01:18:22.000000', 'temperatura', 903.0000, 'ºC'),
	(193879, 118, '2014-02-15 01:18:23.000000', 'temperatura', 732.0000, 'ºC'),
	(193880, 118, '2014-02-15 01:18:24.000000', 'temperatura', 950.0000, 'ºC'),
	(193881, 118, '2014-02-15 01:18:25.000000', 'temperatura', 154.0000, 'ºC'),
	(193882, 118, '2014-02-15 01:18:26.000000', 'temperatura', 321.0000, 'ºC'),
	(193883, 118, '2014-02-15 01:18:27.000000', 'temperatura', 1145.0000, 'ºC'),
	(193884, 118, '2014-02-15 01:18:28.000000', 'temperatura', 1160.0000, 'ºC'),
	(193885, 118, '2014-02-15 01:18:29.000000', 'temperatura', 1169.0000, 'ºC'),
	(193886, 118, '2014-02-15 01:18:30.000000', 'temperatura', 1163.0000, 'ºC'),
	(193887, 118, '2014-02-15 01:18:31.000000', 'temperatura', 1107.0000, 'ºC'),
	(193888, 118, '2014-02-15 01:18:32.000000', 'temperatura', 850.0000, 'ºC'),
	(193889, 118, '2014-02-15 01:18:33.000000', 'temperatura', 928.0000, 'ºC'),
	(193890, 118, '2014-02-15 01:18:34.000000', 'temperatura', 890.0000, 'ºC'),
	(193891, 118, '2014-02-15 01:18:35.000000', 'temperatura', 466.0000, 'ºC'),
	(193892, 118, '2014-02-15 01:18:36.000000', 'temperatura', 862.0000, 'ºC'),
	(193893, 118, '2014-02-15 01:18:37.000000', 'temperatura', 512.0000, 'ºC'),
	(193894, 118, '2014-02-15 01:18:38.000000', 'temperatura', 1174.0000, 'ºC'),
	(193895, 118, '2014-02-15 01:18:39.000000', 'temperatura', 734.0000, 'ºC'),
	(193896, 118, '2014-02-15 01:18:40.000000', 'temperatura', 150.0000, 'ºC'),
	(193897, 118, '2014-02-15 01:18:41.000000', 'temperatura', 947.0000, 'ºC'),
	(193898, 118, '2014-02-15 01:18:42.000000', 'temperatura', 685.0000, 'ºC'),
	(193899, 118, '2014-02-15 01:18:43.000000', 'temperatura', 585.0000, 'ºC'),
	(193900, 118, '2014-02-15 01:18:44.000000', 'temperatura', 872.0000, 'ºC'),
	(193901, 118, '2014-02-15 01:18:45.000000', 'temperatura', 206.0000, 'ºC'),
	(193902, 118, '2014-02-15 01:18:46.000000', 'temperatura', 812.0000, 'ºC'),
	(193903, 118, '2014-02-15 01:18:47.000000', 'temperatura', 1045.0000, 'ºC'),
	(193904, 118, '2014-02-15 01:18:48.000000', 'temperatura', 386.0000, 'ºC'),
	(193905, 118, '2014-02-15 01:18:49.000000', 'temperatura', 1199.0000, 'ºC'),
	(193906, 118, '2014-02-15 01:18:50.000000', 'temperatura', 35.0000, 'ºC'),
	(193907, 118, '2014-02-15 01:18:51.000000', 'temperatura', 180.0000, 'ºC'),
	(193908, 118, '2014-02-15 01:18:52.000000', 'temperatura', 795.0000, 'ºC'),
	(193909, 118, '2014-02-15 01:18:53.000000', 'temperatura', 1034.0000, 'ºC'),
	(193910, 118, '2014-02-15 01:18:54.000000', 'temperatura', 386.0000, 'ºC'),
	(193911, 118, '2014-02-15 01:18:55.000000', 'temperatura', 29.0000, 'ºC'),
	(193912, 118, '2014-02-15 01:18:56.000000', 'temperatura', 188.0000, 'ºC'),
	(193913, 118, '2014-02-15 01:18:57.000000', 'temperatura', 854.0000, 'ºC'),
	(193914, 118, '2014-02-15 01:18:58.000000', 'temperatura', 105.0000, 'ºC'),
	(193915, 118, '2014-02-15 01:18:59.000000', 'temperatura', 364.0000, 'ºC'),
	(193916, 118, '2014-02-15 01:19:00.000000', 'temperatura', 304.0000, 'ºC'),
	(193917, 118, '2014-02-15 01:19:01.000000', 'temperatura', 430.0000, 'ºC'),
	(193918, 118, '2014-02-15 01:19:02.000000', 'temperatura', 39.0000, 'ºC'),
	(193919, 118, '2014-02-15 01:19:03.000000', 'temperatura', 106.0000, 'ºC'),
	(193920, 118, '2014-02-15 01:19:04.000000', 'temperatura', 412.0000, 'ºC'),
	(193921, 118, '2014-02-15 01:19:05.000000', 'temperatura', 542.0000, 'ºC'),
	(193922, 118, '2014-02-15 01:19:06.000000', 'temperatura', 276.0000, 'ºC'),
	(193923, 118, '2014-02-15 01:19:07.000000', 'temperatura', 955.0000, 'ºC'),
	(193924, 118, '2014-02-15 01:19:08.000000', 'temperatura', 346.0000, 'ºC'),
	(193925, 118, '2014-02-15 01:19:09.000000', 'temperatura', 64.0000, 'ºC'),
	(193926, 118, '2014-02-15 01:19:10.000000', 'temperatura', 484.0000, 'ºC'),
	(193927, 118, '2014-02-15 01:19:11.000000', 'temperatura', 1028.0000, 'ºC'),
	(193928, 118, '2014-02-15 01:19:12.000000', 'temperatura', 89.0000, 'ºC'),
	(193929, 118, '2014-02-15 01:19:13.000000', 'temperatura', 962.0000, 'ºC'),
	(193930, 118, '2014-02-15 01:19:14.000000', 'temperatura', 945.0000, 'ºC'),
	(193931, 118, '2014-02-15 01:19:15.000000', 'temperatura', 637.0000, 'ºC'),
	(193932, 118, '2014-02-15 01:19:16.000000', 'temperatura', 351.0000, 'ºC'),
	(193933, 118, '2014-02-15 01:19:17.000000', 'temperatura', 1044.0000, 'ºC'),
	(193934, 118, '2014-02-15 01:19:18.000000', 'temperatura', 566.0000, 'ºC'),
	(193935, 118, '2014-02-15 01:19:19.000000', 'temperatura', 901.0000, 'ºC'),
	(193936, 118, '2014-02-15 01:19:20.000000', 'temperatura', 408.0000, 'ºC'),
	(193937, 118, '2014-02-15 01:19:21.000000', 'temperatura', 535.0000, 'ºC'),
	(193938, 118, '2014-02-15 01:19:22.000000', 'temperatura', 251.0000, 'ºC'),
	(193939, 118, '2014-02-15 01:19:23.000000', 'temperatura', 853.0000, 'ºC'),
	(193940, 118, '2014-02-15 01:19:24.000000', 'temperatura', 1111.0000, 'ºC'),
	(193941, 118, '2014-02-15 01:19:25.000000', 'temperatura', 599.0000, 'ºC'),
	(193942, 118, '2014-02-15 01:19:26.000000', 'temperatura', 861.0000, 'ºC'),
	(193943, 118, '2014-02-15 01:19:27.000000', 'temperatura', 107.0000, 'ºC'),
	(193944, 118, '2014-02-15 01:19:28.000000', 'temperatura', 355.0000, 'ºC'),
	(193945, 118, '2014-02-15 01:19:29.000000', 'temperatura', 254.0000, 'ºC'),
	(193946, 118, '2014-02-15 01:19:30.000000', 'temperatura', 203.0000, 'ºC'),
	(193947, 118, '2014-02-15 01:19:31.000000', 'temperatura', 256.0000, 'ºC'),
	(193948, 118, '2014-02-15 01:19:32.000000', 'temperatura', 670.0000, 'ºC'),
	(193949, 118, '2014-02-15 01:19:33.000000', 'temperatura', 182.0000, 'ºC'),
	(193950, 118, '2014-02-15 01:19:34.000000', 'temperatura', 103.0000, 'ºC'),
	(193951, 118, '2014-02-15 01:19:35.000000', 'temperatura', 1167.0000, 'ºC'),
	(193952, 118, '2014-02-15 01:19:36.000000', 'temperatura', 727.0000, 'ºC'),
	(193953, 118, '2014-02-15 01:19:37.000000', 'temperatura', 133.0000, 'ºC'),
	(193954, 118, '2014-02-15 01:19:38.000000', 'temperatura', 885.0000, 'ºC'),
	(193955, 118, '2014-02-15 01:19:39.000000', 'temperatura', 426.0000, 'ºC'),
	(193956, 118, '2014-02-15 01:19:40.000000', 'temperatura', 675.0000, 'ºC'),
	(193957, 118, '2014-02-15 01:19:41.000000', 'temperatura', 900.0000, 'ºC'),
	(193958, 118, '2014-02-15 01:19:42.000000', 'temperatura', 75.0000, 'ºC'),
	(193959, 118, '2014-02-15 01:19:43.000000', 'temperatura', 76.0000, 'ºC'),
	(193960, 118, '2014-02-15 01:19:44.000000', 'temperatura', 154.0000, 'ºC'),
	(193961, 118, '2014-02-15 01:19:45.000000', 'temperatura', 544.0000, 'ºC'),
	(193962, 118, '2014-02-15 01:19:46.000000', 'temperatura', 1058.0000, 'ºC'),
	(193963, 118, '2014-02-15 01:19:47.000000', 'temperatura', 56.0000, 'ºC'),
	(193964, 118, '2014-02-15 01:19:48.000000', 'temperatura', 710.0000, 'ºC'),
	(193965, 118, '2014-02-15 01:19:49.000000', 'temperatura', 980.0000, 'ºC'),
	(193966, 118, '2014-02-15 01:19:50.000000', 'temperatura', 372.0000, 'ºC'),
	(193967, 118, '2014-02-15 01:19:51.000000', 'temperatura', 118.0000, 'ºC'),
	(193968, 118, '2014-02-15 01:19:52.000000', 'temperatura', 677.0000, 'ºC'),
	(193969, 118, '2014-02-15 01:19:53.000000', 'temperatura', 631.0000, 'ºC'),
	(193970, 118, '2014-02-15 01:19:54.000000', 'temperatura', 1123.0000, 'ºC'),
	(193971, 118, '2014-02-15 01:19:55.000000', 'temperatura', 125.0000, 'ºC'),
	(193972, 118, '2014-02-15 01:19:56.000000', 'temperatura', 855.0000, 'ºC'),
	(193973, 118, '2014-02-15 01:19:57.000000', 'temperatura', 300.0000, 'ºC'),
	(193974, 118, '2014-02-15 01:19:58.000000', 'temperatura', 137.0000, 'ºC'),
	(193975, 118, '2014-02-15 01:19:59.000000', 'temperatura', 986.0000, 'ºC'),
	(193976, 118, '2014-02-15 01:20:00.000000', 'temperatura', 919.0000, 'ºC'),
	(193977, 118, '2014-02-15 01:20:01.000000', 'temperatura', 438.0000, 'ºC'),
	(193978, 118, '2014-02-15 01:20:02.000000', 'temperatura', 633.0000, 'ºC'),
	(193979, 118, '2014-02-15 01:20:03.000000', 'temperatura', 652.0000, 'ºC'),
	(193980, 118, '2014-02-15 01:20:04.000000', 'temperatura', 161.0000, 'ºC'),
	(193981, 118, '2014-02-15 01:20:05.000000', 'temperatura', 52.0000, 'ºC'),
	(193982, 118, '2014-02-15 01:20:06.000000', 'temperatura', 974.0000, 'ºC'),
	(193983, 118, '2014-02-15 01:20:07.000000', 'temperatura', 1116.0000, 'ºC'),
	(193984, 118, '2014-02-15 01:20:08.000000', 'temperatura', 257.0000, 'ºC'),
	(193985, 118, '2014-02-15 01:20:09.000000', 'temperatura', 337.0000, 'ºC'),
	(193986, 118, '2014-02-15 01:20:10.000000', 'temperatura', 915.0000, 'ºC'),
	(193987, 118, '2014-02-15 01:20:11.000000', 'temperatura', 1164.0000, 'ºC'),
	(193988, 119, '2014-02-15 00:00:00.000000', 'temperatura', 1093.0000, 'ºC'),
	(193989, 119, '2014-02-15 00:00:01.000000', 'temperatura', 1033.0000, 'ºC'),
	(193990, 119, '2014-02-15 00:00:02.000000', 'temperatura', 686.0000, 'ºC'),
	(193991, 119, '2014-02-15 00:00:03.000000', 'temperatura', 334.0000, 'ºC'),
	(193992, 119, '2014-02-15 00:00:04.000000', 'temperatura', 811.0000, 'ºC'),
	(193993, 119, '2014-02-15 00:00:05.000000', 'temperatura', 656.0000, 'ºC'),
	(193994, 119, '2014-02-15 00:00:06.000000', 'temperatura', 846.0000, 'ºC'),
	(193995, 119, '2014-02-15 00:00:07.000000', 'temperatura', 1061.0000, 'ºC'),
	(193996, 119, '2014-02-15 00:00:08.000000', 'temperatura', 370.0000, 'ºC'),
	(193997, 119, '2014-02-15 00:00:09.000000', 'temperatura', 1066.0000, 'ºC'),
	(193998, 119, '2014-02-15 00:00:10.000000', 'temperatura', 623.0000, 'ºC'),
	(193999, 119, '2014-02-15 00:00:11.000000', 'temperatura', 1115.0000, 'ºC'),
	(194000, 119, '2014-02-15 00:00:12.000000', 'temperatura', 109.0000, 'ºC'),
	(194001, 119, '2014-02-15 00:00:13.000000', 'temperatura', 798.0000, 'ºC'),
	(194002, 119, '2014-02-15 00:00:14.000000', 'temperatura', 63.0000, 'ºC'),
	(194003, 119, '2014-02-15 00:00:15.000000', 'temperatura', 322.0000, 'ºC'),
	(194004, 119, '2014-02-15 00:00:16.000000', 'temperatura', 223.0000, 'ºC'),
	(194005, 119, '2014-02-15 00:00:17.000000', 'temperatura', 147.0000, 'ºC'),
	(194006, 119, '2014-02-15 00:00:18.000000', 'temperatura', 67.0000, 'ºC'),
	(194007, 119, '2014-02-15 00:00:19.000000', 'temperatura', 1095.0000, 'ºC'),
	(194008, 119, '2014-02-15 00:00:20.000000', 'temperatura', 475.0000, 'ºC'),
	(194009, 119, '2014-02-15 00:00:21.000000', 'temperatura', 292.0000, 'ºC'),
	(194010, 119, '2014-02-15 00:00:22.000000', 'temperatura', 32.0000, 'ºC'),
	(194011, 119, '2014-02-15 00:00:23.000000', 'temperatura', 486.0000, 'ºC'),
	(194012, 119, '2014-02-15 00:00:24.000000', 'temperatura', 1136.0000, 'ºC'),
	(194013, 119, '2014-02-15 00:00:25.000000', 'temperatura', 621.0000, 'ºC'),
	(194014, 119, '2014-02-15 00:00:26.000000', 'temperatura', 898.0000, 'ºC'),
	(194015, 119, '2014-02-15 00:00:27.000000', 'temperatura', 226.0000, 'ºC'),
	(194016, 119, '2014-02-15 00:00:28.000000', 'temperatura', 838.0000, 'ºC'),
	(194017, 119, '2014-02-15 00:00:29.000000', 'temperatura', 1113.0000, 'ºC'),
	(194018, 119, '2014-02-15 00:00:30.000000', 'temperatura', 652.0000, 'ºC'),
	(194019, 119, '2014-02-15 00:00:31.000000', 'temperatura', 1121.0000, 'ºC'),
	(194020, 119, '2014-02-15 00:00:32.000000', 'temperatura', 50.0000, 'ºC'),
	(194021, 119, '2014-02-15 00:00:33.000000', 'temperatura', 489.0000, 'ºC'),
	(194022, 119, '2014-02-15 00:00:34.000000', 'temperatura', 1093.0000, 'ºC'),
	(194023, 119, '2014-02-15 00:00:35.000000', 'temperatura', 398.0000, 'ºC'),
	(194024, 119, '2014-02-15 00:00:36.000000', 'temperatura', 1113.0000, 'ºC'),
	(194025, 119, '2014-02-15 00:00:37.000000', 'temperatura', 770.0000, 'ºC'),
	(194026, 119, '2014-02-15 00:00:38.000000', 'temperatura', 513.0000, 'ºC'),
	(194027, 119, '2014-02-15 00:00:39.000000', 'temperatura', 254.0000, 'ºC'),
	(194028, 119, '2014-02-15 00:00:40.000000', 'temperatura', 932.0000, 'ºC'),
	(194029, 119, '2014-02-15 00:00:41.000000', 'temperatura', 299.0000, 'ºC'),
	(194030, 119, '2014-02-15 00:00:42.000000', 'temperatura', 1098.0000, 'ºC'),
	(194031, 119, '2014-02-15 00:00:43.000000', 'temperatura', 996.0000, 'ºC'),
	(194032, 119, '2014-02-15 00:00:44.000000', 'temperatura', 486.0000, 'ºC'),
	(194033, 119, '2014-02-15 00:00:45.000000', 'temperatura', 644.0000, 'ºC'),
	(194034, 119, '2014-02-15 00:00:46.000000', 'temperatura', 561.0000, 'ºC'),
	(194035, 119, '2014-02-15 00:00:47.000000', 'temperatura', 872.0000, 'ºC'),
	(194036, 119, '2014-02-15 00:00:48.000000', 'temperatura', 277.0000, 'ºC'),
	(194037, 119, '2014-02-15 00:00:49.000000', 'temperatura', 1170.0000, 'ºC'),
	(194038, 119, '2014-02-15 00:00:50.000000', 'temperatura', 222.0000, 'ºC'),
	(194039, 119, '2014-02-15 00:00:51.000000', 'temperatura', 1199.0000, 'ºC'),
	(194040, 119, '2014-02-15 00:00:52.000000', 'temperatura', 529.0000, 'ºC'),
	(194041, 119, '2014-02-15 00:00:53.000000', 'temperatura', 249.0000, 'ºC'),
	(194042, 119, '2014-02-15 00:00:54.000000', 'temperatura', 859.0000, 'ºC'),
	(194043, 119, '2014-02-15 00:00:55.000000', 'temperatura', 1150.0000, 'ºC'),
	(194044, 119, '2014-02-15 00:00:56.000000', 'temperatura', 772.0000, 'ºC'),
	(194045, 119, '2014-02-15 00:00:57.000000', 'temperatura', 411.0000, 'ºC'),
	(194046, 119, '2014-02-15 00:00:58.000000', 'temperatura', 939.0000, 'ºC'),
	(194047, 119, '2014-02-15 00:00:59.000000', 'temperatura', 1064.0000, 'ºC'),
	(194048, 119, '2014-02-15 00:01:00.000000', 'temperatura', 100.0000, 'ºC'),
	(194049, 119, '2014-02-15 00:01:01.000000', 'temperatura', 912.0000, 'ºC'),
	(194050, 119, '2014-02-15 00:01:02.000000', 'temperatura', 661.0000, 'ºC'),
	(194051, 119, '2014-02-15 00:01:03.000000', 'temperatura', 567.0000, 'ºC'),
	(194052, 119, '2014-02-15 00:01:04.000000', 'temperatura', 852.0000, 'ºC'),
	(194053, 119, '2014-02-15 00:01:05.000000', 'temperatura', 160.0000, 'ºC'),
	(194054, 119, '2014-02-15 00:01:06.000000', 'temperatura', 647.0000, 'ºC'),
	(194055, 119, '2014-02-15 00:01:07.000000', 'temperatura', 352.0000, 'ºC'),
	(194056, 119, '2014-02-15 00:01:08.000000', 'temperatura', 1021.0000, 'ºC'),
	(194057, 119, '2014-02-15 00:01:09.000000', 'temperatura', 451.0000, 'ºC'),
	(194058, 119, '2014-02-15 00:01:10.000000', 'temperatura', 392.0000, 'ºC'),
	(194059, 119, '2014-02-15 00:01:11.000000', 'temperatura', 609.0000, 'ºC'),
	(194060, 119, '2014-02-15 00:01:12.000000', 'temperatura', 666.0000, 'ºC'),
	(194061, 119, '2014-02-15 00:01:13.000000', 'temperatura', 306.0000, 'ºC'),
	(194062, 119, '2014-02-15 00:01:14.000000', 'temperatura', 731.0000, 'ºC'),
	(194063, 119, '2014-02-15 00:01:15.000000', 'temperatura', 340.0000, 'ºC'),
	(194064, 119, '2014-02-15 00:01:16.000000', 'temperatura', 705.0000, 'ºC'),
	(194065, 119, '2014-02-15 00:01:17.000000', 'temperatura', 105.0000, 'ºC'),
	(194066, 119, '2014-02-15 00:01:18.000000', 'temperatura', 810.0000, 'ºC'),
	(194067, 119, '2014-02-15 00:01:19.000000', 'temperatura', 137.0000, 'ºC'),
	(194068, 119, '2014-02-15 00:01:20.000000', 'temperatura', 655.0000, 'ºC'),
	(194069, 119, '2014-02-15 00:01:21.000000', 'temperatura', 466.0000, 'ºC'),
	(194070, 119, '2014-02-15 00:01:22.000000', 'temperatura', 364.0000, 'ºC'),
	(194071, 119, '2014-02-15 00:01:23.000000', 'temperatura', 423.0000, 'ºC'),
	(194072, 119, '2014-02-15 00:01:24.000000', 'temperatura', 1025.0000, 'ºC'),
	(194073, 119, '2014-02-15 00:01:25.000000', 'temperatura', 254.0000, 'ºC'),
	(194074, 119, '2014-02-15 00:01:26.000000', 'temperatura', 597.0000, 'ºC'),
	(194075, 119, '2014-02-15 00:01:27.000000', 'temperatura', 1022.0000, 'ºC'),
	(194076, 119, '2014-02-15 00:01:28.000000', 'temperatura', 921.0000, 'ºC'),
	(194077, 119, '2014-02-15 00:01:29.000000', 'temperatura', 340.0000, 'ºC'),
	(194078, 119, '2014-02-15 00:01:30.000000', 'temperatura', 135.0000, 'ºC'),
	(194079, 119, '2014-02-15 00:01:31.000000', 'temperatura', 858.0000, 'ºC'),
	(194080, 119, '2014-02-15 00:01:32.000000', 'temperatura', 285.0000, 'ºC'),
	(194081, 119, '2014-02-15 00:01:33.000000', 'temperatura', 49.0000, 'ºC'),
	(194082, 119, '2014-02-15 00:01:34.000000', 'temperatura', 593.0000, 'ºC'),
	(194083, 119, '2014-02-15 00:01:35.000000', 'temperatura', 420.0000, 'ºC'),
	(194084, 119, '2014-02-15 00:01:36.000000', 'temperatura', 320.0000, 'ºC'),
	(194085, 119, '2014-02-15 00:01:37.000000', 'temperatura', 339.0000, 'ºC'),
	(194086, 119, '2014-02-15 00:01:38.000000', 'temperatura', 735.0000, 'ºC'),
	(194087, 119, '2014-02-15 00:01:39.000000', 'temperatura', 261.0000, 'ºC'),
	(194088, 119, '2014-02-15 00:01:40.000000', 'temperatura', 299.0000, 'ºC'),
	(194089, 119, '2014-02-15 00:01:41.000000', 'temperatura', 712.0000, 'ºC'),
	(194090, 119, '2014-02-15 00:01:42.000000', 'temperatura', 263.0000, 'ºC'),
	(194091, 119, '2014-02-15 00:01:43.000000', 'temperatura', 379.0000, 'ºC'),
	(194092, 119, '2014-02-15 00:01:44.000000', 'temperatura', 1109.0000, 'ºC'),
	(194093, 119, '2014-02-15 00:01:45.000000', 'temperatura', 808.0000, 'ºC'),
	(194094, 119, '2014-02-15 00:01:46.000000', 'temperatura', 714.0000, 'ºC'),
	(194095, 119, '2014-02-15 00:01:47.000000', 'temperatura', 1147.0000, 'ºC'),
	(194096, 119, '2014-02-15 00:01:48.000000', 'temperatura', 1192.0000, 'ºC'),
	(194097, 119, '2014-02-15 00:01:49.000000', 'temperatura', 120.0000, 'ºC'),
	(194098, 119, '2014-02-15 00:01:50.000000', 'temperatura', 624.0000, 'ºC'),
	(194099, 119, '2014-02-15 00:01:51.000000', 'temperatura', 360.0000, 'ºC'),
	(194100, 119, '2014-02-15 00:01:52.000000', 'temperatura', 1130.0000, 'ºC'),
	(194101, 119, '2014-02-15 00:01:53.000000', 'temperatura', 968.0000, 'ºC'),
	(194102, 119, '2014-02-15 00:01:54.000000', 'temperatura', 253.0000, 'ºC'),
	(194103, 119, '2014-02-15 00:01:55.000000', 'temperatura', 760.0000, 'ºC'),
	(194104, 119, '2014-02-15 00:01:56.000000', 'temperatura', 640.0000, 'ºC'),
	(194105, 119, '2014-02-15 00:01:57.000000', 'temperatura', 921.0000, 'ºC'),
	(194106, 119, '2014-02-15 00:01:58.000000', 'temperatura', 287.0000, 'ºC'),
	(194107, 119, '2014-02-15 00:01:59.000000', 'temperatura', 1070.0000, 'ºC'),
	(194108, 119, '2014-02-15 00:02:00.000000', 'temperatura', 893.0000, 'ºC'),
	(194109, 119, '2014-02-15 00:02:01.000000', 'temperatura', 52.0000, 'ºC'),
	(194110, 119, '2014-02-15 00:02:02.000000', 'temperatura', 1185.0000, 'ºC'),
	(194111, 119, '2014-02-15 00:02:03.000000', 'temperatura', 966.0000, 'ºC'),
	(194112, 119, '2014-02-15 00:02:04.000000', 'temperatura', 79.0000, 'ºC'),
	(194113, 119, '2014-02-15 00:02:05.000000', 'temperatura', 1094.0000, 'ºC'),
	(194114, 119, '2014-02-15 00:02:06.000000', 'temperatura', 435.0000, 'ºC'),
	(194115, 119, '2014-02-15 00:02:07.000000', 'temperatura', 92.0000, 'ºC'),
	(194116, 119, '2014-02-15 00:02:08.000000', 'temperatura', 358.0000, 'ºC'),
	(194117, 119, '2014-02-15 00:02:09.000000', 'temperatura', 313.0000, 'ºC'),
	(194118, 119, '2014-02-15 00:02:10.000000', 'temperatura', 492.0000, 'ºC'),
	(194119, 119, '2014-02-15 00:02:11.000000', 'temperatura', 321.0000, 'ºC'),
	(194120, 119, '2014-02-15 00:02:12.000000', 'temperatura', 128.0000, 'ºC'),
	(194121, 119, '2014-02-15 00:02:13.000000', 'temperatura', 879.0000, 'ºC'),
	(194122, 119, '2014-02-15 00:02:14.000000', 'temperatura', 413.0000, 'ºC'),
	(194123, 119, '2014-02-15 00:02:15.000000', 'temperatura', 628.0000, 'ºC'),
	(194124, 119, '2014-02-15 00:02:16.000000', 'temperatura', 699.0000, 'ºC'),
	(194125, 119, '2014-02-15 00:02:17.000000', 'temperatura', 414.0000, 'ºC'),
	(194126, 119, '2014-02-15 00:02:18.000000', 'temperatura', 1174.0000, 'ºC'),
	(194127, 119, '2014-02-15 00:02:19.000000', 'temperatura', 1030.0000, 'ºC'),
	(194128, 119, '2014-02-15 00:02:20.000000', 'temperatura', 425.0000, 'ºC'),
	(194129, 119, '2014-02-15 00:02:21.000000', 'temperatura', 237.0000, 'ºC'),
	(194130, 119, '2014-02-15 00:02:22.000000', 'temperatura', 1111.0000, 'ºC'),
	(194131, 119, '2014-02-15 00:02:23.000000', 'temperatura', 42.0000, 'ºC'),
	(194132, 119, '2014-02-15 00:02:24.000000', 'temperatura', 480.0000, 'ºC'),
	(194133, 119, '2014-02-15 00:02:25.000000', 'temperatura', 1072.0000, 'ºC'),
	(194134, 119, '2014-02-15 00:02:26.000000', 'temperatura', 321.0000, 'ºC'),
	(194135, 119, '2014-02-15 00:02:27.000000', 'temperatura', 789.0000, 'ºC'),
	(194136, 119, '2014-02-15 00:02:28.000000', 'temperatura', 582.0000, 'ºC'),
	(194137, 119, '2014-02-15 00:02:29.000000', 'temperatura', 544.0000, 'ºC'),
	(194138, 119, '2014-02-15 00:02:30.000000', 'temperatura', 977.0000, 'ºC'),
	(194139, 119, '2014-02-15 00:02:31.000000', 'temperatura', 851.0000, 'ºC'),
	(194140, 119, '2014-02-15 00:02:32.000000', 'temperatura', 125.0000, 'ºC'),
	(194141, 119, '2014-02-15 00:02:33.000000', 'temperatura', 471.0000, 'ºC'),
	(194142, 119, '2014-02-15 00:02:34.000000', 'temperatura', 780.0000, 'ºC'),
	(194143, 119, '2014-02-15 00:02:35.000000', 'temperatura', 88.0000, 'ºC'),
	(194144, 119, '2014-02-15 00:02:36.000000', 'temperatura', 502.0000, 'ºC'),
	(194145, 119, '2014-02-15 00:02:37.000000', 'temperatura', 1045.0000, 'ºC'),
	(194146, 119, '2014-02-15 00:02:38.000000', 'temperatura', 119.0000, 'ºC'),
	(194147, 119, '2014-02-15 00:02:39.000000', 'temperatura', 1059.0000, 'ºC'),
	(194148, 119, '2014-02-15 00:02:40.000000', 'temperatura', 141.0000, 'ºC'),
	(194149, 119, '2014-02-15 00:02:41.000000', 'temperatura', 1128.0000, 'ºC'),
	(194150, 119, '2014-02-15 00:02:42.000000', 'temperatura', 418.0000, 'ºC'),
	(194151, 119, '2014-02-15 00:02:43.000000', 'temperatura', 1108.0000, 'ºC'),
	(194152, 119, '2014-02-15 00:02:44.000000', 'temperatura', 684.0000, 'ºC'),
	(194153, 119, '2014-02-15 00:02:45.000000', 'temperatura', 98.0000, 'ºC'),
	(194154, 119, '2014-02-15 00:02:46.000000', 'temperatura', 838.0000, 'ºC'),
	(194155, 119, '2014-02-15 00:02:47.000000', 'temperatura', 298.0000, 'ºC'),
	(194156, 119, '2014-02-15 00:02:48.000000', 'temperatura', 177.0000, 'ºC'),
	(194157, 119, '2014-02-15 00:02:49.000000', 'temperatura', 1190.0000, 'ºC'),
	(194158, 119, '2014-02-15 00:02:50.000000', 'temperatura', 621.0000, 'ºC'),
	(194159, 119, '2014-02-15 00:02:51.000000', 'temperatura', 733.0000, 'ºC'),
	(194160, 119, '2014-02-15 00:02:52.000000', 'temperatura', 602.0000, 'ºC'),
	(194161, 119, '2014-02-15 00:02:53.000000', 'temperatura', 814.0000, 'ºC'),
	(194162, 119, '2014-02-15 00:02:54.000000', 'temperatura', 1063.0000, 'ºC'),
	(194163, 119, '2014-02-15 00:02:55.000000', 'temperatura', 474.0000, 'ºC'),
	(194164, 119, '2014-02-15 00:02:56.000000', 'temperatura', 382.0000, 'ºC'),
	(194165, 119, '2014-02-15 00:02:57.000000', 'temperatura', 490.0000, 'ºC'),
	(194166, 119, '2014-02-15 00:02:58.000000', 'temperatura', 104.0000, 'ºC'),
	(194167, 119, '2014-02-15 00:02:59.000000', 'temperatura', 250.0000, 'ºC'),
	(194168, 119, '2014-02-15 00:03:00.000000', 'temperatura', 939.0000, 'ºC'),
	(194169, 119, '2014-02-15 00:03:01.000000', 'temperatura', 345.0000, 'ºC'),
	(194170, 119, '2014-02-15 00:03:02.000000', 'temperatura', 109.0000, 'ºC'),
	(194171, 119, '2014-02-15 00:03:03.000000', 'temperatura', 710.0000, 'ºC'),
	(194172, 119, '2014-02-15 00:03:04.000000', 'temperatura', 825.0000, 'ºC'),
	(194173, 119, '2014-02-15 00:03:05.000000', 'temperatura', 794.0000, 'ºC'),
	(194174, 119, '2014-02-15 00:03:06.000000', 'temperatura', 297.0000, 'ºC'),
	(194175, 119, '2014-02-15 00:03:07.000000', 'temperatura', 303.0000, 'ºC'),
	(194176, 119, '2014-02-15 00:03:08.000000', 'temperatura', 625.0000, 'ºC'),
	(194177, 119, '2014-02-15 00:03:09.000000', 'temperatura', 1018.0000, 'ºC'),
	(194178, 119, '2014-02-15 00:03:10.000000', 'temperatura', 814.0000, 'ºC'),
	(194179, 119, '2014-02-15 00:03:11.000000', 'temperatura', 1015.0000, 'ºC'),
	(194180, 119, '2014-02-15 00:03:12.000000', 'temperatura', 236.0000, 'ºC'),
	(194181, 119, '2014-02-15 00:03:13.000000', 'temperatura', 534.0000, 'ºC'),
	(194182, 119, '2014-02-15 00:03:14.000000', 'temperatura', 764.0000, 'ºC'),
	(194183, 119, '2014-02-15 00:03:15.000000', 'temperatura', 1016.0000, 'ºC'),
	(194184, 119, '2014-02-15 00:03:16.000000', 'temperatura', 389.0000, 'ºC'),
	(194185, 119, '2014-02-15 00:03:17.000000', 'temperatura', 99.0000, 'ºC'),
	(194186, 119, '2014-02-15 00:03:18.000000', 'temperatura', 529.0000, 'ºC'),
	(194187, 119, '2014-02-15 00:03:19.000000', 'temperatura', 1146.0000, 'ºC'),
	(194188, 119, '2014-02-15 00:03:20.000000', 'temperatura', 543.0000, 'ºC'),
	(194189, 119, '2014-02-15 00:03:21.000000', 'temperatura', 481.0000, 'ºC'),
	(194190, 119, '2014-02-15 00:03:22.000000', 'temperatura', 773.0000, 'ºC'),
	(194191, 119, '2014-02-15 00:03:23.000000', 'temperatura', 23.0000, 'ºC'),
	(194192, 119, '2014-02-15 00:03:24.000000', 'temperatura', 198.0000, 'ºC'),
	(194193, 119, '2014-02-15 00:03:25.000000', 'temperatura', 922.0000, 'ºC'),
	(194194, 119, '2014-02-15 00:03:26.000000', 'temperatura', 417.0000, 'ºC'),
	(194195, 119, '2014-02-15 00:03:27.000000', 'temperatura', 519.0000, 'ºC'),
	(194196, 119, '2014-02-15 00:03:28.000000', 'temperatura', 143.0000, 'ºC'),
	(194197, 119, '2014-02-15 00:03:29.000000', 'temperatura', 360.0000, 'ºC'),
	(194198, 119, '2014-02-15 00:03:30.000000', 'temperatura', 173.0000, 'ºC'),
	(194199, 119, '2014-02-15 00:03:31.000000', 'temperatura', 983.0000, 'ºC'),
	(194200, 119, '2014-02-15 00:03:32.000000', 'temperatura', 796.0000, 'ºC'),
	(194201, 119, '2014-02-15 00:03:33.000000', 'temperatura', 1031.0000, 'ºC'),
	(194202, 119, '2014-02-15 00:03:34.000000', 'temperatura', 367.0000, 'ºC'),
	(194203, 119, '2014-02-15 00:03:35.000000', 'temperatura', 1143.0000, 'ºC'),
	(194204, 119, '2014-02-15 00:03:36.000000', 'temperatura', 1014.0000, 'ºC'),
	(194205, 119, '2014-02-15 00:03:37.000000', 'temperatura', 443.0000, 'ºC'),
	(194206, 119, '2014-02-15 00:03:38.000000', 'temperatura', 374.0000, 'ºC'),
	(194207, 119, '2014-02-15 00:03:39.000000', 'temperatura', 542.0000, 'ºC'),
	(194208, 119, '2014-02-15 00:03:40.000000', 'temperatura', 387.0000, 'ºC'),
	(194209, 119, '2014-02-15 00:03:41.000000', 'temperatura', 312.0000, 'ºC'),
	(194210, 119, '2014-02-15 00:03:42.000000', 'temperatura', 397.0000, 'ºC'),
	(194211, 119, '2014-02-15 00:03:43.000000', 'temperatura', 1052.0000, 'ºC'),
	(194212, 119, '2014-02-15 00:03:44.000000', 'temperatura', 469.0000, 'ºC'),
	(194213, 119, '2014-02-15 00:03:45.000000', 'temperatura', 389.0000, 'ºC'),
	(194214, 119, '2014-02-15 00:03:46.000000', 'temperatura', 539.0000, 'ºC'),
	(194215, 119, '2014-02-15 00:03:47.000000', 'temperatura', 327.0000, 'ºC'),
	(194216, 119, '2014-02-15 00:03:48.000000', 'temperatura', 18.0000, 'ºC'),
	(194217, 119, '2014-02-15 00:03:49.000000', 'temperatura', 312.0000, 'ºC'),
	(194218, 119, '2014-02-15 00:03:50.000000', 'temperatura', 305.0000, 'ºC'),
	(194219, 119, '2014-02-15 00:03:51.000000', 'temperatura', 589.0000, 'ºC'),
	(194220, 119, '2014-02-15 00:03:52.000000', 'temperatura', 830.0000, 'ºC'),
	(194221, 119, '2014-02-15 00:03:53.000000', 'temperatura', 1183.0000, 'ºC'),
	(194222, 119, '2014-02-15 00:03:54.000000', 'temperatura', 1027.0000, 'ºC'),
	(194223, 119, '2014-02-15 00:03:55.000000', 'temperatura', 387.0000, 'ºC'),
	(194224, 119, '2014-02-15 00:03:56.000000', 'temperatura', 52.0000, 'ºC'),
	(194225, 119, '2014-02-15 00:03:57.000000', 'temperatura', 301.0000, 'ºC'),
	(194226, 119, '2014-02-15 00:03:58.000000', 'temperatura', 150.0000, 'ºC'),
	(194227, 119, '2014-02-15 00:03:59.000000', 'temperatura', 1046.0000, 'ºC'),
	(194228, 119, '2014-02-15 00:04:00.000000', 'temperatura', 1182.0000, 'ºC'),
	(194229, 119, '2014-02-15 00:04:01.000000', 'temperatura', 372.0000, 'ºC'),
	(194230, 119, '2014-02-15 00:04:02.000000', 'temperatura', 713.0000, 'ºC'),
	(194231, 119, '2014-02-15 00:04:03.000000', 'temperatura', 49.0000, 'ºC'),
	(194232, 119, '2014-02-15 00:04:04.000000', 'temperatura', 506.0000, 'ºC'),
	(194233, 119, '2014-02-15 00:04:05.000000', 'temperatura', 1185.0000, 'ºC'),
	(194234, 119, '2014-02-15 00:04:06.000000', 'temperatura', 808.0000, 'ºC'),
	(194235, 119, '2014-02-15 00:04:07.000000', 'temperatura', 485.0000, 'ºC'),
	(194236, 119, '2014-02-15 00:04:08.000000', 'temperatura', 3.0000, 'ºC'),
	(194237, 119, '2014-02-15 00:04:09.000000', 'temperatura', 958.0000, 'ºC'),
	(194238, 119, '2014-02-15 00:04:10.000000', 'temperatura', 1184.0000, 'ºC'),
	(194239, 119, '2014-02-15 00:04:11.000000', 'temperatura', 646.0000, 'ºC'),
	(194240, 119, '2014-02-15 00:04:12.000000', 'temperatura', 880.0000, 'ºC'),
	(194241, 119, '2014-02-15 00:04:13.000000', 'temperatura', 61.0000, 'ºC'),
	(194242, 119, '2014-02-15 00:04:14.000000', 'temperatura', 65.0000, 'ºC'),
	(194243, 119, '2014-02-15 00:04:15.000000', 'temperatura', 145.0000, 'ºC'),
	(194244, 119, '2014-02-15 00:04:16.000000', 'temperatura', 528.0000, 'ºC'),
	(194245, 119, '2014-02-15 00:04:17.000000', 'temperatura', 1004.0000, 'ºC'),
	(194246, 119, '2014-02-15 00:04:18.000000', 'temperatura', 1039.0000, 'ºC'),
	(194247, 119, '2014-02-15 00:04:19.000000', 'temperatura', 982.0000, 'ºC'),
	(194248, 119, '2014-02-15 00:04:20.000000', 'temperatura', 595.0000, 'ºC'),
	(194249, 119, '2014-02-15 00:04:21.000000', 'temperatura', 29.0000, 'ºC'),
	(194250, 119, '2014-02-15 00:04:22.000000', 'temperatura', 760.0000, 'ºC'),
	(194251, 119, '2014-02-15 00:04:23.000000', 'temperatura', 115.0000, 'ºC'),
	(194252, 119, '2014-02-15 00:04:24.000000', 'temperatura', 696.0000, 'ºC'),
	(194253, 119, '2014-02-15 00:04:25.000000', 'temperatura', 736.0000, 'ºC'),
	(194254, 119, '2014-02-15 00:04:26.000000', 'temperatura', 391.0000, 'ºC'),
	(194255, 119, '2014-02-15 00:04:27.000000', 'temperatura', 949.0000, 'ºC'),
	(194256, 119, '2014-02-15 00:04:28.000000', 'temperatura', 1173.0000, 'ºC'),
	(194257, 119, '2014-02-15 00:04:29.000000', 'temperatura', 620.0000, 'ºC'),
	(194258, 119, '2014-02-15 00:04:30.000000', 'temperatura', 778.0000, 'ºC'),
	(194259, 119, '2014-02-15 00:04:31.000000', 'temperatura', 832.0000, 'ºC'),
	(194260, 119, '2014-02-15 00:04:32.000000', 'temperatura', 624.0000, 'ºC'),
	(194261, 119, '2014-02-15 00:04:33.000000', 'temperatura', 628.0000, 'ºC'),
	(194262, 119, '2014-02-15 00:04:34.000000', 'temperatura', 66.0000, 'ºC'),
	(194263, 119, '2014-02-15 00:04:35.000000', 'temperatura', 849.0000, 'ºC'),
	(194264, 119, '2014-02-15 00:04:36.000000', 'temperatura', 444.0000, 'ºC'),
	(194265, 119, '2014-02-15 00:04:37.000000', 'temperatura', 877.0000, 'ºC'),
	(194266, 119, '2014-02-15 00:04:38.000000', 'temperatura', 653.0000, 'ºC'),
	(194267, 119, '2014-02-15 00:04:39.000000', 'temperatura', 634.0000, 'ºC'),
	(194268, 119, '2014-02-15 00:04:40.000000', 'temperatura', 13.0000, 'ºC'),
	(194269, 119, '2014-02-15 00:04:41.000000', 'temperatura', 563.0000, 'ºC'),
	(194270, 119, '2014-02-15 00:04:42.000000', 'temperatura', 378.0000, 'ºC'),
	(194271, 119, '2014-02-15 00:04:43.000000', 'temperatura', 198.0000, 'ºC'),
	(194272, 119, '2014-02-15 00:04:44.000000', 'temperatura', 1060.0000, 'ºC'),
	(194273, 119, '2014-02-15 00:04:45.000000', 'temperatura', 1103.0000, 'ºC'),
	(194274, 119, '2014-02-15 00:04:46.000000', 'temperatura', 1138.0000, 'ºC'),
	(194275, 119, '2014-02-15 00:04:47.000000', 'temperatura', 1181.0000, 'ºC'),
	(194276, 119, '2014-02-15 00:04:48.000000', 'temperatura', 91.0000, 'ºC'),
	(194277, 119, '2014-02-15 00:04:49.000000', 'temperatura', 511.0000, 'ºC'),
	(194278, 119, '2014-02-15 00:04:50.000000', 'temperatura', 1085.0000, 'ºC'),
	(194279, 119, '2014-02-15 00:04:51.000000', 'temperatura', 292.0000, 'ºC'),
	(194280, 119, '2014-02-15 00:04:52.000000', 'temperatura', 604.0000, 'ºC'),
	(194281, 119, '2014-02-15 00:04:53.000000', 'temperatura', 944.0000, 'ºC'),
	(194282, 119, '2014-02-15 00:04:54.000000', 'temperatura', 511.0000, 'ºC'),
	(194283, 119, '2014-02-15 00:04:55.000000', 'temperatura', 923.0000, 'ºC'),
	(194284, 119, '2014-02-15 00:04:56.000000', 'temperatura', 683.0000, 'ºC'),
	(194285, 119, '2014-02-15 00:04:57.000000', 'temperatura', 648.0000, 'ºC'),
	(194286, 119, '2014-02-15 00:04:58.000000', 'temperatura', 1188.0000, 'ºC'),
	(194287, 119, '2014-02-15 00:04:59.000000', 'temperatura', 399.0000, 'ºC'),
	(194288, 119, '2014-02-15 00:05:00.000000', 'temperatura', 831.0000, 'ºC'),
	(194289, 119, '2014-02-15 00:05:01.000000', 'temperatura', 558.0000, 'ºC'),
	(194290, 119, '2014-02-15 00:05:02.000000', 'temperatura', 300.0000, 'ºC'),
	(194291, 119, '2014-02-15 00:05:03.000000', 'temperatura', 1024.0000, 'ºC'),
	(194292, 119, '2014-02-15 00:05:04.000000', 'temperatura', 620.0000, 'ºC'),
	(194293, 119, '2014-02-15 00:05:05.000000', 'temperatura', 29.0000, 'ºC'),
	(194294, 119, '2014-02-15 00:05:06.000000', 'temperatura', 684.0000, 'ºC'),
	(194295, 119, '2014-02-15 00:05:07.000000', 'temperatura', 934.0000, 'ºC'),
	(194296, 119, '2014-02-15 00:05:08.000000', 'temperatura', 218.0000, 'ºC'),
	(194297, 119, '2014-02-15 00:05:09.000000', 'temperatura', 689.0000, 'ºC'),
	(194298, 119, '2014-02-15 00:05:10.000000', 'temperatura', 391.0000, 'ºC'),
	(194299, 119, '2014-02-15 00:05:11.000000', 'temperatura', 1089.0000, 'ºC'),
	(194300, 119, '2014-02-15 00:05:12.000000', 'temperatura', 674.0000, 'ºC'),
	(194301, 119, '2014-02-15 00:05:13.000000', 'temperatura', 100.0000, 'ºC'),
	(194302, 119, '2014-02-15 00:05:14.000000', 'temperatura', 882.0000, 'ºC'),
	(194303, 119, '2014-02-15 00:05:15.000000', 'temperatura', 511.0000, 'ºC'),
	(194304, 119, '2014-02-15 00:05:16.000000', 'temperatura', 1106.0000, 'ºC'),
	(194305, 119, '2014-02-15 00:05:17.000000', 'temperatura', 401.0000, 'ºC'),
	(194306, 119, '2014-02-15 00:05:18.000000', 'temperatura', 1086.0000, 'ºC'),
	(194307, 119, '2014-02-15 00:05:19.000000', 'temperatura', 626.0000, 'ºC'),
	(194308, 119, '2014-02-15 00:05:20.000000', 'temperatura', 1074.0000, 'ºC'),
	(194309, 119, '2014-02-15 00:05:21.000000', 'temperatura', 1091.0000, 'ºC'),
	(194310, 119, '2014-02-15 00:05:22.000000', 'temperatura', 1034.0000, 'ºC'),
	(194311, 119, '2014-02-15 00:05:23.000000', 'temperatura', 698.0000, 'ºC'),
	(194312, 119, '2014-02-15 00:05:24.000000', 'temperatura', 389.0000, 'ºC'),
	(194313, 119, '2014-02-15 00:05:25.000000', 'temperatura', 1051.0000, 'ºC'),
	(194314, 119, '2014-02-15 00:05:26.000000', 'temperatura', 488.0000, 'ºC'),
	(194315, 119, '2014-02-15 00:05:27.000000', 'temperatura', 486.0000, 'ºC'),
	(194316, 119, '2014-02-15 00:05:28.000000', 'temperatura', 970.0000, 'ºC'),
	(194317, 119, '2014-02-15 00:05:29.000000', 'temperatura', 990.0000, 'ºC'),
	(194318, 119, '2014-02-15 00:05:30.000000', 'temperatura', 842.0000, 'ºC'),
	(194319, 119, '2014-02-15 00:05:31.000000', 'temperatura', 39.0000, 'ºC'),
	(194320, 119, '2014-02-15 00:05:32.000000', 'temperatura', 69.0000, 'ºC'),
	(194321, 119, '2014-02-15 00:05:33.000000', 'temperatura', 230.0000, 'ºC'),
	(194322, 119, '2014-02-15 00:05:34.000000', 'temperatura', 945.0000, 'ºC'),
	(194323, 119, '2014-02-15 00:05:35.000000', 'temperatura', 434.0000, 'ºC'),
	(194324, 119, '2014-02-15 00:05:36.000000', 'temperatura', 535.0000, 'ºC'),
	(194325, 119, '2014-02-15 00:05:37.000000', 'temperatura', 174.0000, 'ºC'),
	(194326, 119, '2014-02-15 00:05:38.000000', 'temperatura', 466.0000, 'ºC'),
	(194327, 119, '2014-02-15 00:05:39.000000', 'temperatura', 610.0000, 'ºC'),
	(194328, 119, '2014-02-15 00:05:40.000000', 'temperatura', 449.0000, 'ºC'),
	(194329, 119, '2014-02-15 00:05:41.000000', 'temperatura', 417.0000, 'ºC'),
	(194330, 119, '2014-02-15 00:05:42.000000', 'temperatura', 740.0000, 'ºC'),
	(194331, 119, '2014-02-15 00:05:43.000000', 'temperatura', 50.0000, 'ºC'),
	(194332, 119, '2014-02-15 00:05:44.000000', 'temperatura', 431.0000, 'ºC'),
	(194333, 119, '2014-02-15 00:05:45.000000', 'temperatura', 806.0000, 'ºC'),
	(194334, 119, '2014-02-15 00:05:46.000000', 'temperatura', 336.0000, 'ºC'),
	(194335, 119, '2014-02-15 00:05:47.000000', 'temperatura', 463.0000, 'ºC'),
	(194336, 119, '2014-02-15 00:05:48.000000', 'temperatura', 107.0000, 'ºC'),
	(194337, 119, '2014-02-15 00:05:49.000000', 'temperatura', 348.0000, 'ºC'),
	(194338, 119, '2014-02-15 00:05:50.000000', 'temperatura', 218.0000, 'ºC'),
	(194339, 119, '2014-02-15 00:05:51.000000', 'temperatura', 48.0000, 'ºC'),
	(194340, 119, '2014-02-15 00:05:52.000000', 'temperatura', 785.0000, 'ºC'),
	(194341, 119, '2014-02-15 00:05:53.000000', 'temperatura', 180.0000, 'ºC'),
	(194342, 119, '2014-02-15 00:05:54.000000', 'temperatura', 947.0000, 'ºC'),
	(194343, 119, '2014-02-15 00:05:55.000000', 'temperatura', 596.0000, 'ºC'),
	(194344, 119, '2014-02-15 00:05:56.000000', 'temperatura', 140.0000, 'ºC'),
	(194345, 119, '2014-02-15 00:05:57.000000', 'temperatura', 111.0000, 'ºC'),
	(194346, 119, '2014-02-15 00:05:58.000000', 'temperatura', 136.0000, 'ºC'),
	(194347, 119, '2014-02-15 00:05:59.000000', 'temperatura', 347.0000, 'ºC'),
	(194348, 119, '2014-02-15 00:06:00.000000', 'temperatura', 129.0000, 'ºC'),
	(194349, 119, '2014-02-15 00:06:01.000000', 'temperatura', 802.0000, 'ºC'),
	(194350, 119, '2014-02-15 00:06:02.000000', 'temperatura', 23.0000, 'ºC'),
	(194351, 119, '2014-02-15 00:06:03.000000', 'temperatura', 112.0000, 'ºC'),
	(194352, 119, '2014-02-15 00:06:04.000000', 'temperatura', 489.0000, 'ºC'),
	(194353, 119, '2014-02-15 00:06:05.000000', 'temperatura', 910.0000, 'ºC'),
	(194354, 119, '2014-02-15 00:06:06.000000', 'temperatura', 682.0000, 'ºC'),
	(194355, 119, '2014-02-15 00:06:07.000000', 'temperatura', 681.0000, 'ºC'),
	(194356, 119, '2014-02-15 00:06:08.000000', 'temperatura', 160.0000, 'ºC'),
	(194357, 119, '2014-02-15 00:06:09.000000', 'temperatura', 1159.0000, 'ºC'),
	(194358, 119, '2014-02-15 00:06:10.000000', 'temperatura', 513.0000, 'ºC'),
	(194359, 119, '2014-02-15 00:06:11.000000', 'temperatura', 291.0000, 'ºC'),
	(194360, 119, '2014-02-15 00:06:12.000000', 'temperatura', 1114.0000, 'ºC'),
	(194361, 119, '2014-02-15 00:06:13.000000', 'temperatura', 1097.0000, 'ºC'),
	(194362, 119, '2014-02-15 00:06:14.000000', 'temperatura', 944.0000, 'ºC'),
	(194363, 119, '2014-02-15 00:06:15.000000', 'temperatura', 228.0000, 'ºC'),
	(194364, 119, '2014-02-15 00:06:16.000000', 'temperatura', 710.0000, 'ºC'),
	(194365, 119, '2014-02-15 00:06:17.000000', 'temperatura', 465.0000, 'ºC'),
	(194366, 119, '2014-02-15 00:06:18.000000', 'temperatura', 198.0000, 'ºC'),
	(194367, 119, '2014-02-15 00:06:19.000000', 'temperatura', 795.0000, 'ºC'),
	(194368, 119, '2014-02-15 00:06:20.000000', 'temperatura', 980.0000, 'ºC'),
	(194369, 119, '2014-02-15 00:06:21.000000', 'temperatura', 118.0000, 'ºC'),
	(194370, 119, '2014-02-15 00:06:22.000000', 'temperatura', 47.0000, 'ºC'),
	(194371, 119, '2014-02-15 00:06:23.000000', 'temperatura', 1085.0000, 'ºC'),
	(194372, 119, '2014-02-15 00:06:24.000000', 'temperatura', 483.0000, 'ºC'),
	(194373, 119, '2014-02-15 00:06:25.000000', 'temperatura', 361.0000, 'ºC'),
	(194374, 119, '2014-02-15 00:06:26.000000', 'temperatura', 355.0000, 'ºC'),
	(194375, 119, '2014-02-15 00:06:27.000000', 'temperatura', 691.0000, 'ºC'),
	(194376, 119, '2014-02-15 00:06:28.000000', 'temperatura', 1194.0000, 'ºC'),
	(194377, 119, '2014-02-15 00:06:29.000000', 'temperatura', 296.0000, 'ºC'),
	(194378, 119, '2014-02-15 00:06:30.000000', 'temperatura', 297.0000, 'ºC'),
	(194379, 119, '2014-02-15 00:06:31.000000', 'temperatura', 600.0000, 'ºC'),
	(194380, 119, '2014-02-15 00:06:32.000000', 'temperatura', 910.0000, 'ºC'),
	(194381, 119, '2014-02-15 00:06:33.000000', 'temperatura', 351.0000, 'ºC'),
	(194382, 119, '2014-02-15 00:06:34.000000', 'temperatura', 223.0000, 'ºC'),
	(194383, 119, '2014-02-15 00:06:35.000000', 'temperatura', 63.0000, 'ºC'),
	(194384, 119, '2014-02-15 00:06:36.000000', 'temperatura', 846.0000, 'ºC'),
	(194385, 119, '2014-02-15 00:06:37.000000', 'temperatura', 443.0000, 'ºC'),
	(194386, 119, '2014-02-15 00:06:38.000000', 'temperatura', 878.0000, 'ºC'),
	(194387, 119, '2014-02-15 00:06:39.000000', 'temperatura', 661.0000, 'ºC'),
	(194388, 119, '2014-02-15 00:06:40.000000', 'temperatura', 673.0000, 'ºC'),
	(194389, 119, '2014-02-15 00:06:41.000000', 'temperatura', 179.0000, 'ºC'),
	(194390, 119, '2014-02-15 00:06:42.000000', 'temperatura', 80.0000, 'ºC'),
	(194391, 119, '2014-02-15 00:06:43.000000', 'temperatura', 1062.0000, 'ºC'),
	(194392, 119, '2014-02-15 00:06:44.000000', 'temperatura', 270.0000, 'ºC'),
	(194393, 119, '2014-02-15 00:06:45.000000', 'temperatura', 565.0000, 'ºC'),
	(194394, 119, '2014-02-15 00:06:46.000000', 'temperatura', 814.0000, 'ºC'),
	(194395, 119, '2014-02-15 00:06:47.000000', 'temperatura', 1178.0000, 'ºC'),
	(194396, 119, '2014-02-15 00:06:48.000000', 'temperatura', 1047.0000, 'ºC'),
	(194397, 119, '2014-02-15 00:06:49.000000', 'temperatura', 504.0000, 'ºC'),
	(194398, 119, '2014-02-15 00:06:50.000000', 'temperatura', 577.0000, 'ºC'),
	(194399, 119, '2014-02-15 00:06:51.000000', 'temperatura', 174.0000, 'ºC'),
	(194400, 119, '2014-02-15 00:06:52.000000', 'temperatura', 339.0000, 'ºC'),
	(194401, 119, '2014-02-15 00:06:53.000000', 'temperatura', 1175.0000, 'ºC'),
	(194402, 119, '2014-02-15 00:06:54.000000', 'temperatura', 56.0000, 'ºC'),
	(194403, 119, '2014-02-15 00:06:55.000000', 'temperatura', 356.0000, 'ºC'),
	(194404, 119, '2014-02-15 00:06:56.000000', 'temperatura', 412.0000, 'ºC'),
	(194405, 119, '2014-02-15 00:06:57.000000', 'temperatura', 995.0000, 'ºC'),
	(194406, 119, '2014-02-15 00:06:58.000000', 'temperatura', 139.0000, 'ºC'),
	(194407, 119, '2014-02-15 00:06:59.000000', 'temperatura', 110.0000, 'ºC'),
	(194408, 119, '2014-02-15 00:07:00.000000', 'temperatura', 133.0000, 'ºC'),
	(194409, 119, '2014-02-15 00:07:01.000000', 'temperatura', 335.0000, 'ºC'),
	(194410, 119, '2014-02-15 00:07:02.000000', 'temperatura', 77.0000, 'ºC'),
	(194411, 119, '2014-02-15 00:07:03.000000', 'temperatura', 581.0000, 'ºC'),
	(194412, 119, '2014-02-15 00:07:04.000000', 'temperatura', 276.0000, 'ºC'),
	(194413, 119, '2014-02-15 00:07:05.000000', 'temperatura', 835.0000, 'ºC'),
	(194414, 119, '2014-02-15 00:07:06.000000', 'temperatura', 948.0000, 'ºC'),
	(194415, 119, '2014-02-15 00:07:07.000000', 'temperatura', 1036.0000, 'ºC'),
	(194416, 119, '2014-02-15 00:07:08.000000', 'temperatura', 1137.0000, 'ºC'),
	(194417, 119, '2014-02-15 00:07:09.000000', 'temperatura', 177.0000, 'ºC'),
	(194418, 119, '2014-02-15 00:07:10.000000', 'temperatura', 1075.0000, 'ºC'),
	(194419, 119, '2014-02-15 00:07:11.000000', 'temperatura', 46.0000, 'ºC'),
	(194420, 119, '2014-02-15 00:07:12.000000', 'temperatura', 603.0000, 'ºC'),
	(194421, 119, '2014-02-15 00:07:13.000000', 'temperatura', 476.0000, 'ºC'),
	(194422, 119, '2014-02-15 00:07:14.000000', 'temperatura', 574.0000, 'ºC'),
	(194423, 119, '2014-02-15 00:07:15.000000', 'temperatura', 243.0000, 'ºC'),
	(194424, 119, '2014-02-15 00:07:16.000000', 'temperatura', 693.0000, 'ºC'),
	(194425, 119, '2014-02-15 00:07:17.000000', 'temperatura', 336.0000, 'ºC'),
	(194426, 119, '2014-02-15 00:07:18.000000', 'temperatura', 800.0000, 'ºC'),
	(194427, 119, '2014-02-15 00:07:19.000000', 'temperatura', 593.0000, 'ºC'),
	(194428, 119, '2014-02-15 00:07:20.000000', 'temperatura', 566.0000, 'ºC'),
	(194429, 119, '2014-02-15 00:07:21.000000', 'temperatura', 1051.0000, 'ºC'),
	(194430, 119, '2014-02-15 00:07:22.000000', 'temperatura', 1156.0000, 'ºC'),
	(194431, 119, '2014-02-15 00:07:23.000000', 'temperatura', 228.0000, 'ºC'),
	(194432, 119, '2014-02-15 00:07:24.000000', 'temperatura', 71.0000, 'ºC'),
	(194433, 119, '2014-02-15 00:07:25.000000', 'temperatura', 873.0000, 'ºC'),
	(194434, 119, '2014-02-15 00:07:26.000000', 'temperatura', 552.0000, 'ºC'),
	(194435, 119, '2014-02-15 00:07:27.000000', 'temperatura', 143.0000, 'ºC'),
	(194436, 119, '2014-02-15 00:07:28.000000', 'temperatura', 258.0000, 'ºC'),
	(194437, 119, '2014-02-15 00:07:29.000000', 'temperatura', 861.0000, 'ºC'),
	(194438, 119, '2014-02-15 00:07:30.000000', 'temperatura', 1134.0000, 'ºC'),
	(194439, 119, '2014-02-15 00:07:31.000000', 'temperatura', 684.0000, 'ºC'),
	(194440, 119, '2014-02-15 00:07:32.000000', 'temperatura', 21.0000, 'ºC'),
	(194441, 119, '2014-02-15 00:07:33.000000', 'temperatura', 452.0000, 'ºC'),
	(194442, 119, '2014-02-15 00:07:34.000000', 'temperatura', 1000.0000, 'ºC'),
	(194443, 119, '2014-02-15 00:07:35.000000', 'temperatura', 43.0000, 'ºC'),
	(194444, 119, '2014-02-15 00:07:36.000000', 'temperatura', 816.0000, 'ºC'),
	(194445, 119, '2014-02-15 00:07:37.000000', 'temperatura', 353.0000, 'ºC'),
	(194446, 119, '2014-02-15 00:07:38.000000', 'temperatura', 518.0000, 'ºC'),
	(194447, 119, '2014-02-15 00:07:39.000000', 'temperatura', 330.0000, 'ºC'),
	(194448, 119, '2014-02-15 00:07:40.000000', 'temperatura', 96.0000, 'ºC'),
	(194449, 119, '2014-02-15 00:07:41.000000', 'temperatura', 689.0000, 'ºC'),
	(194450, 119, '2014-02-15 00:07:42.000000', 'temperatura', 760.0000, 'ºC'),
	(194451, 119, '2014-02-15 00:07:43.000000', 'temperatura', 533.0000, 'ºC'),
	(194452, 119, '2014-02-15 00:07:44.000000', 'temperatura', 387.0000, 'ºC'),
	(194453, 119, '2014-02-15 00:07:45.000000', 'temperatura', 336.0000, 'ºC'),
	(194454, 119, '2014-02-15 00:07:46.000000', 'temperatura', 520.0000, 'ºC'),
	(194455, 119, '2014-02-15 00:07:47.000000', 'temperatura', 391.0000, 'ºC'),
	(194456, 119, '2014-02-15 00:07:48.000000', 'temperatura', 395.0000, 'ºC'),
	(194457, 119, '2014-02-15 00:07:49.000000', 'temperatura', 802.0000, 'ºC'),
	(194458, 119, '2014-02-15 00:07:50.000000', 'temperatura', 428.0000, 'ºC'),
	(194459, 119, '2014-02-15 00:07:51.000000', 'temperatura', 932.0000, 'ºC'),
	(194460, 119, '2014-02-15 00:07:52.000000', 'temperatura', 975.0000, 'ºC'),
	(194461, 119, '2014-02-15 00:07:53.000000', 'temperatura', 883.0000, 'ºC'),
	(194462, 119, '2014-02-15 00:07:54.000000', 'temperatura', 290.0000, 'ºC'),
	(194463, 119, '2014-02-15 00:07:55.000000', 'temperatura', 1.0000, 'ºC'),
	(194464, 119, '2014-02-15 00:07:56.000000', 'temperatura', 335.0000, 'ºC'),
	(194465, 119, '2014-02-15 00:07:57.000000', 'temperatura', 474.0000, 'ºC'),
	(194466, 119, '2014-02-15 00:07:58.000000', 'temperatura', 165.0000, 'ºC'),
	(194467, 119, '2014-02-15 00:07:59.000000', 'temperatura', 601.0000, 'ºC'),
	(194468, 119, '2014-02-15 00:08:00.000000', 'temperatura', 113.0000, 'ºC'),
	(194469, 119, '2014-02-15 00:08:01.000000', 'temperatura', 1163.0000, 'ºC'),
	(194470, 119, '2014-02-15 00:08:02.000000', 'temperatura', 678.0000, 'ºC'),
	(194471, 119, '2014-02-15 00:08:03.000000', 'temperatura', 1099.0000, 'ºC'),
	(194472, 119, '2014-02-15 00:08:04.000000', 'temperatura', 1061.0000, 'ºC'),
	(194473, 119, '2014-02-15 00:08:05.000000', 'temperatura', 811.0000, 'ºC'),
	(194474, 119, '2014-02-15 00:08:06.000000', 'temperatura', 872.0000, 'ºC'),
	(194475, 119, '2014-02-15 00:08:07.000000', 'temperatura', 728.0000, 'ºC'),
	(194476, 119, '2014-02-15 00:08:08.000000', 'temperatura', 1025.0000, 'ºC'),
	(194477, 119, '2014-02-15 00:08:09.000000', 'temperatura', 541.0000, 'ºC'),
	(194478, 119, '2014-02-15 00:08:10.000000', 'temperatura', 828.0000, 'ºC'),
	(194479, 119, '2014-02-15 00:08:11.000000', 'temperatura', 121.0000, 'ºC'),
	(194480, 119, '2014-02-15 00:08:12.000000', 'temperatura', 520.0000, 'ºC'),
	(194481, 119, '2014-02-15 00:08:13.000000', 'temperatura', 1036.0000, 'ºC'),
	(194482, 119, '2014-02-15 00:08:14.000000', 'temperatura', 20.0000, 'ºC'),
	(194483, 119, '2014-02-15 00:08:15.000000', 'temperatura', 595.0000, 'ºC'),
	(194484, 119, '2014-02-15 00:08:16.000000', 'temperatura', 514.0000, 'ºC'),
	(194485, 119, '2014-02-15 00:08:17.000000', 'temperatura', 784.0000, 'ºC'),
	(194486, 119, '2014-02-15 00:08:18.000000', 'temperatura', 1179.0000, 'ºC'),
	(194487, 119, '2014-02-15 00:08:19.000000', 'temperatura', 1144.0000, 'ºC'),
	(194488, 119, '2014-02-15 00:08:20.000000', 'temperatura', 985.0000, 'ºC'),
	(194489, 119, '2014-02-15 00:08:21.000000', 'temperatura', 291.0000, 'ºC'),
	(194490, 119, '2014-02-15 00:08:22.000000', 'temperatura', 902.0000, 'ºC'),
	(194491, 119, '2014-02-15 00:08:23.000000', 'temperatura', 37.0000, 'ºC'),
	(194492, 119, '2014-02-15 00:08:24.000000', 'temperatura', 1078.0000, 'ºC'),
	(194493, 119, '2014-02-15 00:08:25.000000', 'temperatura', 482.0000, 'ºC'),
	(194494, 119, '2014-02-15 00:08:26.000000', 'temperatura', 375.0000, 'ºC'),
	(194495, 119, '2014-02-15 00:08:27.000000', 'temperatura', 429.0000, 'ºC'),
	(194496, 119, '2014-02-15 00:08:28.000000', 'temperatura', 1020.0000, 'ºC'),
	(194497, 119, '2014-02-15 00:08:29.000000', 'temperatura', 216.0000, 'ºC'),
	(194498, 119, '2014-02-15 00:08:30.000000', 'temperatura', 420.0000, 'ºC'),
	(194499, 119, '2014-02-15 00:08:31.000000', 'temperatura', 253.0000, 'ºC'),
	(194500, 119, '2014-02-15 00:08:32.000000', 'temperatura', 3.0000, 'ºC'),
	(194501, 119, '2014-02-15 00:08:33.000000', 'temperatura', 459.0000, 'ºC'),
	(194502, 119, '2014-02-15 00:08:34.000000', 'temperatura', 1086.0000, 'ºC'),
	(194503, 119, '2014-02-15 00:08:35.000000', 'temperatura', 454.0000, 'ºC'),
	(194504, 119, '2014-02-15 00:08:36.000000', 'temperatura', 214.0000, 'ºC'),
	(194505, 119, '2014-02-15 00:08:37.000000', 'temperatura', 907.0000, 'ºC'),
	(194506, 119, '2014-02-15 00:08:38.000000', 'temperatura', 294.0000, 'ºC'),
	(194507, 119, '2014-02-15 00:08:39.000000', 'temperatura', 1151.0000, 'ºC'),
	(194508, 119, '2014-02-15 00:08:40.000000', 'temperatura', 73.0000, 'ºC'),
	(194509, 119, '2014-02-15 00:08:41.000000', 'temperatura', 511.0000, 'ºC'),
	(194510, 119, '2014-02-15 00:08:42.000000', 'temperatura', 1135.0000, 'ºC'),
	(194511, 119, '2014-02-15 00:08:43.000000', 'temperatura', 545.0000, 'ºC'),
	(194512, 119, '2014-02-15 00:08:44.000000', 'temperatura', 519.0000, 'ºC'),
	(194513, 119, '2014-02-15 00:08:45.000000', 'temperatura', 962.0000, 'ºC'),
	(194514, 119, '2014-02-15 00:08:46.000000', 'temperatura', 851.0000, 'ºC'),
	(194515, 119, '2014-02-15 00:08:47.000000', 'temperatura', 171.0000, 'ºC'),
	(194516, 119, '2014-02-15 00:08:48.000000', 'temperatura', 703.0000, 'ºC'),
	(194517, 119, '2014-02-15 00:08:49.000000', 'temperatura', 601.0000, 'ºC'),
	(194518, 119, '2014-02-15 00:08:50.000000', 'temperatura', 896.0000, 'ºC'),
	(194519, 119, '2014-02-15 00:08:51.000000', 'temperatura', 279.0000, 'ºC'),
	(194520, 119, '2014-02-15 00:08:52.000000', 'temperatura', 1106.0000, 'ºC'),
	(194521, 119, '2014-02-15 00:08:53.000000', 'temperatura', 1096.0000, 'ºC'),
	(194522, 119, '2014-02-15 00:08:54.000000', 'temperatura', 962.0000, 'ºC'),
	(194523, 119, '2014-02-15 00:08:55.000000', 'temperatura', 323.0000, 'ºC'),
	(194524, 119, '2014-02-15 00:08:56.000000', 'temperatura', 1128.0000, 'ºC'),
	(194525, 119, '2014-02-15 00:08:57.000000', 'temperatura', 1071.0000, 'ºC'),
	(194526, 119, '2014-02-15 00:08:58.000000', 'temperatura', 773.0000, 'ºC'),
	(194527, 119, '2014-02-15 00:08:59.000000', 'temperatura', 650.0000, 'ºC'),
	(194528, 119, '2014-02-15 00:09:00.000000', 'temperatura', 933.0000, 'ºC'),
	(194529, 119, '2014-02-15 00:09:01.000000', 'temperatura', 314.0000, 'ºC'),
	(194530, 119, '2014-02-15 00:09:02.000000', 'temperatura', 1174.0000, 'ºC'),
	(194531, 119, '2014-02-15 00:09:03.000000', 'temperatura', 126.0000, 'ºC'),
	(194532, 119, '2014-02-15 00:09:04.000000', 'temperatura', 708.0000, 'ºC'),
	(194533, 119, '2014-02-15 00:09:05.000000', 'temperatura', 762.0000, 'ºC'),
	(194534, 119, '2014-02-15 00:09:06.000000', 'temperatura', 485.0000, 'ºC'),
	(194535, 119, '2014-02-15 00:09:07.000000', 'temperatura', 143.0000, 'ºC'),
	(194536, 119, '2014-02-15 00:09:08.000000', 'temperatura', 461.0000, 'ºC'),
	(194537, 119, '2014-02-15 00:09:09.000000', 'temperatura', 675.0000, 'ºC'),
	(194538, 119, '2014-02-15 00:09:10.000000', 'temperatura', 791.0000, 'ºC'),
	(194539, 119, '2014-02-15 00:09:11.000000', 'temperatura', 733.0000, 'ºC'),
	(194540, 119, '2014-02-15 00:09:12.000000', 'temperatura', 92.0000, 'ºC'),
	(194541, 119, '2014-02-15 00:09:13.000000', 'temperatura', 661.0000, 'ºC'),
	(194542, 119, '2014-02-15 00:09:14.000000', 'temperatura', 631.0000, 'ºC'),
	(194543, 119, '2014-02-15 00:09:15.000000', 'temperatura', 1172.0000, 'ºC'),
	(194544, 119, '2014-02-15 00:09:16.000000', 'temperatura', 366.0000, 'ºC'),
	(194545, 119, '2014-02-15 00:09:17.000000', 'temperatura', 714.0000, 'ºC'),
	(194546, 119, '2014-02-15 00:09:18.000000', 'temperatura', 73.0000, 'ºC'),
	(194547, 119, '2014-02-15 00:09:19.000000', 'temperatura', 624.0000, 'ºC'),
	(194548, 119, '2014-02-15 00:09:20.000000', 'temperatura', 501.0000, 'ºC'),
	(194549, 119, '2014-02-15 00:09:21.000000', 'temperatura', 632.0000, 'ºC'),
	(194550, 119, '2014-02-15 00:09:22.000000', 'temperatura', 459.0000, 'ºC'),
	(194551, 119, '2014-02-15 00:09:23.000000', 'temperatura', 400.0000, 'ºC'),
	(194552, 119, '2014-02-15 00:09:24.000000', 'temperatura', 624.0000, 'ºC'),
	(194553, 119, '2014-02-15 00:09:25.000000', 'temperatura', 720.0000, 'ºC'),
	(194554, 119, '2014-02-15 00:09:26.000000', 'temperatura', 527.0000, 'ºC'),
	(194555, 119, '2014-02-15 00:09:27.000000', 'temperatura', 477.0000, 'ºC'),
	(194556, 119, '2014-02-15 00:09:28.000000', 'temperatura', 803.0000, 'ºC'),
	(194557, 119, '2014-02-15 00:09:29.000000', 'temperatura', 184.0000, 'ºC'),
	(194558, 119, '2014-02-15 00:09:30.000000', 'temperatura', 914.0000, 'ºC'),
	(194559, 119, '2014-02-15 00:09:31.000000', 'temperatura', 416.0000, 'ºC'),
	(194560, 119, '2014-02-15 00:09:32.000000', 'temperatura', 541.0000, 'ºC'),
	(194561, 119, '2014-02-15 00:09:33.000000', 'temperatura', 256.0000, 'ºC'),
	(194562, 119, '2014-02-15 00:09:34.000000', 'temperatura', 859.0000, 'ºC'),
	(194563, 119, '2014-02-15 00:09:35.000000', 'temperatura', 1126.0000, 'ºC'),
	(194564, 119, '2014-02-15 00:09:36.000000', 'temperatura', 653.0000, 'ºC'),
	(194565, 119, '2014-02-15 00:09:37.000000', 'temperatura', 1088.0000, 'ºC'),
	(194566, 119, '2014-02-15 00:09:38.000000', 'temperatura', 1081.0000, 'ºC'),
	(194567, 119, '2014-02-15 00:09:39.000000', 'temperatura', 940.0000, 'ºC'),
	(194568, 119, '2014-02-15 00:09:40.000000', 'temperatura', 261.0000, 'ºC'),
	(194569, 119, '2014-02-15 00:09:41.000000', 'temperatura', 883.0000, 'ºC'),
	(194570, 119, '2014-02-15 00:09:42.000000', 'temperatura', 34.0000, 'ºC'),
	(194571, 119, '2014-02-15 00:09:43.000000', 'temperatura', 1119.0000, 'ºC'),
	(194572, 119, '2014-02-15 00:09:44.000000', 'temperatura', 695.0000, 'ºC'),
	(194573, 119, '2014-02-15 00:09:45.000000', 'temperatura', 119.0000, 'ºC'),
	(194574, 119, '2014-02-15 00:09:46.000000', 'temperatura', 911.0000, 'ºC'),
	(194575, 119, '2014-02-15 00:09:47.000000', 'temperatura', 599.0000, 'ºC'),
	(194576, 119, '2014-02-15 00:09:48.000000', 'temperatura', 261.0000, 'ºC'),
	(194577, 119, '2014-02-15 00:09:49.000000', 'temperatura', 711.0000, 'ºC'),
	(194578, 119, '2014-02-15 00:09:50.000000', 'temperatura', 372.0000, 'ºC'),
	(194579, 119, '2014-02-15 00:09:51.000000', 'temperatura', 925.0000, 'ºC'),
	(194580, 119, '2014-02-15 00:09:52.000000', 'temperatura', 1112.0000, 'ºC'),
	(194581, 119, '2014-02-15 00:09:53.000000', 'temperatura', 383.0000, 'ºC'),
	(194582, 119, '2014-02-15 00:09:54.000000', 'temperatura', 981.0000, 'ºC'),
	(194583, 119, '2014-02-15 00:09:55.000000', 'temperatura', 156.0000, 'ºC'),
	(194584, 119, '2014-02-15 00:09:56.000000', 'temperatura', 239.0000, 'ºC'),
	(194585, 119, '2014-02-15 00:09:57.000000', 'temperatura', 727.0000, 'ºC'),
	(194586, 119, '2014-02-15 00:09:58.000000', 'temperatura', 517.0000, 'ºC'),
	(194587, 119, '2014-02-15 00:09:59.000000', 'temperatura', 404.0000, 'ºC'),
	(194588, 119, '2014-02-15 00:10:00.000000', 'temperatura', 470.0000, 'ºC'),
	(194589, 119, '2014-02-15 00:10:01.000000', 'temperatura', 1139.0000, 'ºC'),
	(194590, 119, '2014-02-15 00:10:02.000000', 'temperatura', 687.0000, 'ºC'),
	(194591, 119, '2014-02-15 00:10:03.000000', 'temperatura', 16.0000, 'ºC'),
	(194592, 119, '2014-02-15 00:10:04.000000', 'temperatura', 422.0000, 'ºC'),
	(194593, 119, '2014-02-15 00:10:05.000000', 'temperatura', 862.0000, 'ºC'),
	(194594, 119, '2014-02-15 00:10:06.000000', 'temperatura', 644.0000, 'ºC'),
	(194595, 119, '2014-02-15 00:10:07.000000', 'temperatura', 636.0000, 'ºC'),
	(194596, 119, '2014-02-15 00:10:08.000000', 'temperatura', 49.0000, 'ºC'),
	(194597, 119, '2014-02-15 00:10:09.000000', 'temperatura', 737.0000, 'ºC'),
	(194598, 119, '2014-02-15 00:10:10.000000', 'temperatura', 1137.0000, 'ºC'),
	(194599, 119, '2014-02-15 00:10:11.000000', 'temperatura', 1077.0000, 'ºC'),
	(194600, 119, '2014-02-15 00:10:12.000000', 'temperatura', 771.0000, 'ºC'),
	(194601, 119, '2014-02-15 00:10:13.000000', 'temperatura', 628.0000, 'ºC'),
	(194602, 119, '2014-02-15 00:10:14.000000', 'temperatura', 826.0000, 'ºC'),
	(194603, 119, '2014-02-15 00:10:15.000000', 'temperatura', 1049.0000, 'ºC'),
	(194604, 119, '2014-02-15 00:10:16.000000', 'temperatura', 364.0000, 'ºC'),
	(194605, 119, '2014-02-15 00:10:17.000000', 'temperatura', 1074.0000, 'ºC'),
	(194606, 119, '2014-02-15 00:10:18.000000', 'temperatura', 678.0000, 'ºC'),
	(194607, 119, '2014-02-15 00:10:19.000000', 'temperatura', 168.0000, 'ºC'),
	(194608, 119, '2014-02-15 00:10:20.000000', 'temperatura', 7.0000, 'ºC'),
	(194609, 119, '2014-02-15 00:10:21.000000', 'temperatura', 732.0000, 'ºC'),
	(194610, 119, '2014-02-15 00:10:22.000000', 'temperatura', 41.0000, 'ºC'),
	(194611, 119, '2014-02-15 00:10:23.000000', 'temperatura', 407.0000, 'ºC'),
	(194612, 119, '2014-02-15 00:10:24.000000', 'temperatura', 714.0000, 'ºC'),
	(194613, 119, '2014-02-15 00:10:25.000000', 'temperatura', 1150.0000, 'ºC'),
	(194614, 119, '2014-02-15 00:10:26.000000', 'temperatura', 9.0000, 'ºC'),
	(194615, 119, '2014-02-15 00:10:27.000000', 'temperatura', 194.0000, 'ºC'),
	(194616, 119, '2014-02-15 00:10:28.000000', 'temperatura', 946.0000, 'ºC'),
	(194617, 119, '2014-02-15 00:10:29.000000', 'temperatura', 546.0000, 'ºC'),
	(194618, 119, '2014-02-15 00:10:30.000000', 'temperatura', 1094.0000, 'ºC'),
	(194619, 119, '2014-02-15 00:10:31.000000', 'temperatura', 231.0000, 'ºC'),
	(194620, 119, '2014-02-15 00:10:32.000000', 'temperatura', 276.0000, 'ºC'),
	(194621, 119, '2014-02-15 00:10:33.000000', 'temperatura', 685.0000, 'ºC'),
	(194622, 119, '2014-02-15 00:10:34.000000', 'temperatura', 197.0000, 'ºC'),
	(194623, 119, '2014-02-15 00:10:35.000000', 'temperatura', 132.0000, 'ºC'),
	(194624, 119, '2014-02-15 00:10:36.000000', 'temperatura', 69.0000, 'ºC'),
	(194625, 119, '2014-02-15 00:10:37.000000', 'temperatura', 1149.0000, 'ºC'),
	(194626, 119, '2014-02-15 00:10:38.000000', 'temperatura', 738.0000, 'ºC'),
	(194627, 119, '2014-02-15 00:10:39.000000', 'temperatura', 244.0000, 'ºC'),
	(194628, 119, '2014-02-15 00:10:40.000000', 'temperatura', 208.0000, 'ºC'),
	(194629, 119, '2014-02-15 00:10:41.000000', 'temperatura', 308.0000, 'ºC'),
	(194630, 119, '2014-02-15 00:10:42.000000', 'temperatura', 916.0000, 'ºC'),
	(194631, 119, '2014-02-15 00:10:43.000000', 'temperatura', 55.0000, 'ºC'),
	(194632, 119, '2014-02-15 00:10:44.000000', 'temperatura', 1130.0000, 'ºC'),
	(194633, 119, '2014-02-15 00:10:45.000000', 'temperatura', 683.0000, 'ºC'),
	(194634, 119, '2014-02-15 00:10:46.000000', 'temperatura', 29.0000, 'ºC'),
	(194635, 119, '2014-02-15 00:10:47.000000', 'temperatura', 494.0000, 'ºC'),
	(194636, 119, '2014-02-15 00:10:48.000000', 'temperatura', 1182.0000, 'ºC'),
	(194637, 119, '2014-02-15 00:10:49.000000', 'temperatura', 831.0000, 'ºC'),
	(194638, 119, '2014-02-15 00:10:50.000000', 'temperatura', 609.0000, 'ºC'),
	(194639, 119, '2014-02-15 00:10:51.000000', 'temperatura', 553.0000, 'ºC'),
	(194640, 119, '2014-02-15 00:10:52.000000', 'temperatura', 940.0000, 'ºC'),
	(194641, 119, '2014-02-15 00:10:53.000000', 'temperatura', 638.0000, 'ºC'),
	(194642, 119, '2014-02-15 00:10:54.000000', 'temperatura', 374.0000, 'ºC'),
	(194643, 119, '2014-02-15 00:10:55.000000', 'temperatura', 1153.0000, 'ºC'),
	(194644, 119, '2014-02-15 00:10:56.000000', 'temperatura', 1046.0000, 'ºC'),
	(194645, 119, '2014-02-15 00:10:57.000000', 'temperatura', 571.0000, 'ºC'),
	(194646, 119, '2014-02-15 00:10:58.000000', 'temperatura', 916.0000, 'ºC'),
	(194647, 119, '2014-02-15 00:10:59.000000', 'temperatura', 466.0000, 'ºC'),
	(194648, 119, '2014-02-15 00:11:00.000000', 'temperatura', 786.0000, 'ºC'),
	(194649, 119, '2014-02-15 00:11:01.000000', 'temperatura', 130.0000, 'ºC'),
	(194650, 119, '2014-02-15 00:11:02.000000', 'temperatura', 691.0000, 'ºC'),
	(194651, 119, '2014-02-15 00:11:03.000000', 'temperatura', 668.0000, 'ºC'),
	(194652, 119, '2014-02-15 00:11:04.000000', 'temperatura', 67.0000, 'ºC'),
	(194653, 119, '2014-02-15 00:11:05.000000', 'temperatura', 733.0000, 'ºC'),
	(194654, 119, '2014-02-15 00:11:06.000000', 'temperatura', 1065.0000, 'ºC'),
	(194655, 119, '2014-02-15 00:11:07.000000', 'temperatura', 724.0000, 'ºC'),
	(194656, 119, '2014-02-15 00:11:08.000000', 'temperatura', 428.0000, 'ºC'),
	(194657, 119, '2014-02-15 00:11:09.000000', 'temperatura', 1167.0000, 'ºC'),
	(194658, 119, '2014-02-15 00:11:10.000000', 'temperatura', 952.0000, 'ºC'),
	(194659, 119, '2014-02-15 00:11:11.000000', 'temperatura', 58.0000, 'ºC'),
	(194660, 119, '2014-02-15 00:11:12.000000', 'temperatura', 1035.0000, 'ºC'),
	(194661, 119, '2014-02-15 00:11:13.000000', 'temperatura', 200.0000, 'ºC'),
	(194662, 119, '2014-02-15 00:11:14.000000', 'temperatura', 298.0000, 'ºC'),
	(194663, 119, '2014-02-15 00:11:15.000000', 'temperatura', 890.0000, 'ºC'),
	(194664, 119, '2014-02-15 00:11:16.000000', 'temperatura', 1157.0000, 'ºC'),
	(194665, 119, '2014-02-15 00:11:17.000000', 'temperatura', 714.0000, 'ºC'),
	(194666, 119, '2014-02-15 00:11:18.000000', 'temperatura', 98.0000, 'ºC'),
	(194667, 119, '2014-02-15 00:11:19.000000', 'temperatura', 751.0000, 'ºC'),
	(194668, 119, '2014-02-15 00:11:20.000000', 'temperatura', 1062.0000, 'ºC'),
	(194669, 119, '2014-02-15 00:11:21.000000', 'temperatura', 655.0000, 'ºC'),
	(194670, 119, '2014-02-15 00:11:22.000000', 'temperatura', 91.0000, 'ºC'),
	(194671, 119, '2014-02-15 00:11:23.000000', 'temperatura', 892.0000, 'ºC'),
	(194672, 119, '2014-02-15 00:11:24.000000', 'temperatura', 584.0000, 'ºC'),
	(194673, 119, '2014-02-15 00:11:25.000000', 'temperatura', 247.0000, 'ºC'),
	(194674, 119, '2014-02-15 00:11:26.000000', 'temperatura', 682.0000, 'ºC'),
	(194675, 119, '2014-02-15 00:11:27.000000', 'temperatura', 271.0000, 'ºC'),
	(194676, 119, '2014-02-15 00:11:28.000000', 'temperatura', 507.0000, 'ºC'),
	(194677, 119, '2014-02-15 00:11:29.000000', 'temperatura', 524.0000, 'ºC'),
	(194678, 119, '2014-02-15 00:11:30.000000', 'temperatura', 1100.0000, 'ºC'),
	(194679, 119, '2014-02-15 00:11:31.000000', 'temperatura', 329.0000, 'ºC'),
	(194680, 119, '2014-02-15 00:11:32.000000', 'temperatura', 743.0000, 'ºC'),
	(194681, 119, '2014-02-15 00:11:33.000000', 'temperatura', 330.0000, 'ºC'),
	(194682, 119, '2014-02-15 00:11:34.000000', 'temperatura', 621.0000, 'ºC'),
	(194683, 119, '2014-02-15 00:11:35.000000', 'temperatura', 916.0000, 'ºC'),
	(194684, 119, '2014-02-15 00:11:36.000000', 'temperatura', 316.0000, 'ºC'),
	(194685, 119, '2014-02-15 00:11:37.000000', 'temperatura', 35.0000, 'ºC'),
	(194686, 119, '2014-02-15 00:11:38.000000', 'temperatura', 425.0000, 'ºC'),
	(194687, 119, '2014-02-15 00:11:39.000000', 'temperatura', 820.0000, 'ºC'),
	(194688, 119, '2014-02-15 00:11:40.000000', 'temperatura', 427.0000, 'ºC'),
	(194689, 119, '2014-02-15 00:11:41.000000', 'temperatura', 874.0000, 'ºC'),
	(194690, 119, '2014-02-15 00:11:42.000000', 'temperatura', 689.0000, 'ºC'),
	(194691, 119, '2014-02-15 00:11:43.000000', 'temperatura', 822.0000, 'ºC'),
	(194692, 119, '2014-02-15 00:11:44.000000', 'temperatura', 847.0000, 'ºC'),
	(194693, 119, '2014-02-15 00:11:45.000000', 'temperatura', 568.0000, 'ºC'),
	(194694, 119, '2014-02-15 00:11:46.000000', 'temperatura', 298.0000, 'ºC'),
	(194695, 119, '2014-02-15 00:11:47.000000', 'temperatura', 987.0000, 'ºC'),
	(194696, 119, '2014-02-15 00:11:48.000000', 'temperatura', 440.0000, 'ºC'),
	(194697, 119, '2014-02-15 00:11:49.000000', 'temperatura', 441.0000, 'ºC'),
	(194698, 119, '2014-02-15 00:11:50.000000', 'temperatura', 887.0000, 'ºC'),
	(194699, 119, '2014-02-15 00:11:51.000000', 'temperatura', 714.0000, 'ºC'),
	(194700, 119, '2014-02-15 00:11:52.000000', 'temperatura', 906.0000, 'ºC'),
	(194701, 119, '2014-02-15 00:11:53.000000', 'temperatura', 1188.0000, 'ºC'),
	(194702, 119, '2014-02-15 00:11:54.000000', 'temperatura', 824.0000, 'ºC'),
	(194703, 119, '2014-02-15 00:11:55.000000', 'temperatura', 558.0000, 'ºC'),
	(194704, 119, '2014-02-15 00:11:56.000000', 'temperatura', 318.0000, 'ºC'),
	(194705, 119, '2014-02-15 00:11:57.000000', 'temperatura', 1116.0000, 'ºC'),
	(194706, 119, '2014-02-15 00:11:58.000000', 'temperatura', 1026.0000, 'ºC'),
	(194707, 119, '2014-02-15 00:11:59.000000', 'temperatura', 581.0000, 'ºC'),
	(194708, 119, '2014-02-15 00:12:00.000000', 'temperatura', 1030.0000, 'ºC'),
	(194709, 119, '2014-02-15 00:12:01.000000', 'temperatura', 1007.0000, 'ºC'),
	(194710, 119, '2014-02-15 00:12:02.000000', 'temperatura', 747.0000, 'ºC'),
	(194711, 119, '2014-02-15 00:12:03.000000', 'temperatura', 712.0000, 'ºC'),
	(194712, 119, '2014-02-15 00:12:04.000000', 'temperatura', 120.0000, 'ºC'),
	(194713, 119, '2014-02-15 00:12:05.000000', 'temperatura', 866.0000, 'ºC'),
	(194714, 119, '2014-02-15 00:12:06.000000', 'temperatura', 371.0000, 'ºC'),
	(194715, 119, '2014-02-15 00:12:07.000000', 'temperatura', 457.0000, 'ºC'),
	(194716, 119, '2014-02-15 00:12:08.000000', 'temperatura', 1173.0000, 'ºC'),
	(194717, 119, '2014-02-15 00:12:09.000000', 'temperatura', 894.0000, 'ºC'),
	(194718, 119, '2014-02-15 00:12:10.000000', 'temperatura', 954.0000, 'ºC'),
	(194719, 119, '2014-02-15 00:12:11.000000', 'temperatura', 885.0000, 'ºC'),
	(194720, 119, '2014-02-15 00:12:12.000000', 'temperatura', 364.0000, 'ºC'),
	(194721, 119, '2014-02-15 00:12:13.000000', 'temperatura', 365.0000, 'ºC'),
	(194722, 119, '2014-02-15 00:12:14.000000', 'temperatura', 735.0000, 'ºC'),
	(194723, 119, '2014-02-15 00:12:15.000000', 'temperatura', 180.0000, 'ºC'),
	(194724, 119, '2014-02-15 00:12:16.000000', 'temperatura', 1095.0000, 'ºC'),
	(194725, 119, '2014-02-15 00:12:17.000000', 'temperatura', 135.0000, 'ºC'),
	(194726, 119, '2014-02-15 00:12:18.000000', 'temperatura', 991.0000, 'ºC'),
	(194727, 119, '2014-02-15 00:12:19.000000', 'temperatura', 950.0000, 'ºC'),
	(194728, 119, '2014-02-15 00:12:20.000000', 'temperatura', 579.0000, 'ºC'),
	(194729, 119, '2014-02-15 00:12:21.000000', 'temperatura', 44.0000, 'ºC'),
	(194730, 119, '2014-02-15 00:12:22.000000', 'temperatura', 885.0000, 'ºC'),
	(194731, 119, '2014-02-15 00:12:23.000000', 'temperatura', 693.0000, 'ºC'),
	(194732, 119, '2014-02-15 00:12:24.000000', 'temperatura', 812.0000, 'ºC'),
	(194733, 119, '2014-02-15 00:12:25.000000', 'temperatura', 781.0000, 'ºC'),
	(194734, 119, '2014-02-15 00:12:26.000000', 'temperatura', 267.0000, 'ºC'),
	(194735, 119, '2014-02-15 00:12:27.000000', 'temperatura', 196.0000, 'ºC'),
	(194736, 119, '2014-02-15 00:12:28.000000', 'temperatura', 177.0000, 'ºC'),
	(194737, 119, '2014-02-15 00:12:29.000000', 'temperatura', 298.0000, 'ºC'),
	(194738, 119, '2014-02-15 00:12:30.000000', 'temperatura', 960.0000, 'ºC'),
	(194739, 119, '2014-02-15 00:12:31.000000', 'temperatura', 306.0000, 'ºC'),
	(194740, 119, '2014-02-15 00:12:32.000000', 'temperatura', 1051.0000, 'ºC'),
	(194741, 119, '2014-02-15 00:12:33.000000', 'temperatura', 737.0000, 'ºC'),
	(194742, 119, '2014-02-15 00:12:34.000000', 'temperatura', 533.0000, 'ºC'),
	(194743, 119, '2014-02-15 00:12:35.000000', 'temperatura', 454.0000, 'ºC'),
	(194744, 119, '2014-02-15 00:12:36.000000', 'temperatura', 671.0000, 'ºC'),
	(194745, 119, '2014-02-15 00:12:37.000000', 'temperatura', 796.0000, 'ºC'),
	(194746, 119, '2014-02-15 00:12:38.000000', 'temperatura', 767.0000, 'ºC'),
	(194747, 119, '2014-02-15 00:12:39.000000', 'temperatura', 245.0000, 'ºC'),
	(194748, 119, '2014-02-15 00:12:40.000000', 'temperatura', 127.0000, 'ºC'),
	(194749, 119, '2014-02-15 00:12:41.000000', 'temperatura', 1101.0000, 'ºC'),
	(194750, 119, '2014-02-15 00:12:42.000000', 'temperatura', 323.0000, 'ºC'),
	(194751, 119, '2014-02-15 00:12:43.000000', 'temperatura', 712.0000, 'ºC'),
	(194752, 119, '2014-02-15 00:12:44.000000', 'temperatura', 191.0000, 'ºC'),
	(194753, 119, '2014-02-15 00:12:45.000000', 'temperatura', 20.0000, 'ºC'),
	(194754, 119, '2014-02-15 00:12:46.000000', 'temperatura', 729.0000, 'ºC'),
	(194755, 119, '2014-02-15 00:12:47.000000', 'temperatura', 1185.0000, 'ºC'),
	(194756, 119, '2014-02-15 00:12:48.000000', 'temperatura', 140.0000, 'ºC'),
	(194757, 119, '2014-02-15 00:12:49.000000', 'temperatura', 742.0000, 'ºC'),
	(194758, 119, '2014-02-15 00:12:50.000000', 'temperatura', 893.0000, 'ºC'),
	(194759, 119, '2014-02-15 00:12:51.000000', 'temperatura', 1041.0000, 'ºC'),
	(194760, 119, '2014-02-15 00:12:52.000000', 'temperatura', 124.0000, 'ºC'),
	(194761, 119, '2014-02-15 00:12:53.000000', 'temperatura', 1099.0000, 'ºC'),
	(194762, 119, '2014-02-15 00:12:54.000000', 'temperatura', 323.0000, 'ºC'),
	(194763, 119, '2014-02-15 00:12:55.000000', 'temperatura', 719.0000, 'ºC'),
	(194764, 119, '2014-02-15 00:12:56.000000', 'temperatura', 225.0000, 'ºC'),
	(194765, 119, '2014-02-15 00:12:57.000000', 'temperatura', 171.0000, 'ºC'),
	(194766, 119, '2014-02-15 00:12:58.000000', 'temperatura', 179.0000, 'ºC'),
	(194767, 119, '2014-02-15 00:12:59.000000', 'temperatura', 381.0000, 'ºC'),
	(194768, 119, '2014-02-15 00:13:00.000000', 'temperatura', 169.0000, 'ºC'),
	(194769, 119, '2014-02-15 00:13:01.000000', 'temperatura', 903.0000, 'ºC'),
	(194770, 119, '2014-02-15 00:13:02.000000', 'temperatura', 410.0000, 'ºC'),
	(194771, 119, '2014-02-15 00:13:03.000000', 'temperatura', 542.0000, 'ºC'),
	(194772, 119, '2014-02-15 00:13:04.000000', 'temperatura', 279.0000, 'ºC'),
	(194773, 119, '2014-02-15 00:13:05.000000', 'temperatura', 969.0000, 'ºC'),
	(194774, 119, '2014-02-15 00:13:06.000000', 'temperatura', 407.0000, 'ºC'),
	(194775, 119, '2014-02-15 00:13:07.000000', 'temperatura', 332.0000, 'ºC'),
	(194776, 119, '2014-02-15 00:13:08.000000', 'temperatura', 437.0000, 'ºC'),
	(194777, 119, '2014-02-15 00:13:09.000000', 'temperatura', 1192.0000, 'ºC'),
	(194778, 119, '2014-02-15 00:13:10.000000', 'temperatura', 1047.0000, 'ºC'),
	(194779, 119, '2014-02-15 00:13:11.000000', 'temperatura', 463.0000, 'ºC'),
	(194780, 119, '2014-02-15 00:13:12.000000', 'temperatura', 371.0000, 'ºC'),
	(194781, 119, '2014-02-15 00:13:13.000000', 'temperatura', 466.0000, 'ºC'),
	(194782, 119, '2014-02-15 00:13:14.000000', 'temperatura', 19.0000, 'ºC'),
	(194783, 119, '2014-02-15 00:13:15.000000', 'temperatura', 1095.0000, 'ºC'),
	(194784, 119, '2014-02-15 00:13:16.000000', 'temperatura', 621.0000, 'ºC'),
	(194785, 119, '2014-02-15 00:13:17.000000', 'temperatura', 1018.0000, 'ºC'),
	(194786, 119, '2014-02-15 00:13:18.000000', 'temperatura', 830.0000, 'ºC'),
	(194787, 119, '2014-02-15 00:13:19.000000', 'temperatura', 1095.0000, 'ºC'),
	(194788, 119, '2014-02-15 00:13:20.000000', 'temperatura', 586.0000, 'ºC'),
	(194789, 119, '2014-02-15 00:13:21.000000', 'temperatura', 846.0000, 'ºC'),
	(194790, 119, '2014-02-15 00:13:22.000000', 'temperatura', 71.0000, 'ºC'),
	(194791, 119, '2014-02-15 00:13:23.000000', 'temperatura', 218.0000, 'ºC'),
	(194792, 119, '2014-02-15 00:13:24.000000', 'temperatura', 878.0000, 'ºC'),
	(194793, 119, '2014-02-15 00:13:25.000000', 'temperatura', 134.0000, 'ºC'),
	(194794, 119, '2014-02-15 00:13:26.000000', 'temperatura', 439.0000, 'ºC'),
	(194795, 119, '2014-02-15 00:13:27.000000', 'temperatura', 593.0000, 'ºC'),
	(194796, 119, '2014-02-15 00:13:28.000000', 'temperatura', 449.0000, 'ºC'),
	(194797, 119, '2014-02-15 00:13:29.000000', 'temperatura', 465.0000, 'ºC'),
	(194798, 119, '2014-02-15 00:13:30.000000', 'temperatura', 979.0000, 'ºC'),
	(194799, 119, '2014-02-15 00:13:31.000000', 'temperatura', 1102.0000, 'ºC'),
	(194800, 119, '2014-02-15 00:13:32.000000', 'temperatura', 172.0000, 'ºC'),
	(194801, 119, '2014-02-15 00:13:33.000000', 'temperatura', 1155.0000, 'ºC'),
	(194802, 119, '2014-02-15 00:13:34.000000', 'temperatura', 458.0000, 'ºC'),
	(194803, 119, '2014-02-15 00:13:35.000000', 'temperatura', 25.0000, 'ºC'),
	(194804, 119, '2014-02-15 00:13:36.000000', 'temperatura', 1154.0000, 'ºC'),
	(194805, 119, '2014-02-15 00:13:37.000000', 'temperatura', 895.0000, 'ºC'),
	(194806, 119, '2014-02-15 00:13:38.000000', 'temperatura', 1015.0000, 'ºC'),
	(194807, 119, '2014-02-15 00:13:39.000000', 'temperatura', 1189.0000, 'ºC'),
	(194808, 119, '2014-02-15 00:13:40.000000', 'temperatura', 499.0000, 'ºC'),
	(194809, 119, '2014-02-15 00:13:41.000000', 'temperatura', 131.0000, 'ºC'),
	(194810, 119, '2014-02-15 00:13:42.000000', 'temperatura', 358.0000, 'ºC'),
	(194811, 119, '2014-02-15 00:13:43.000000', 'temperatura', 196.0000, 'ºC'),
	(194812, 119, '2014-02-15 00:13:44.000000', 'temperatura', 1106.0000, 'ºC'),
	(194813, 119, '2014-02-15 00:13:45.000000', 'temperatura', 141.0000, 'ºC'),
	(194814, 119, '2014-02-15 00:13:46.000000', 'temperatura', 990.0000, 'ºC'),
	(194815, 119, '2014-02-15 00:13:47.000000', 'temperatura', 929.0000, 'ºC'),
	(194816, 119, '2014-02-15 00:13:48.000000', 'temperatura', 473.0000, 'ºC'),
	(194817, 119, '2014-02-15 00:13:49.000000', 'temperatura', 779.0000, 'ºC'),
	(194818, 119, '2014-02-15 00:13:50.000000', 'temperatura', 78.0000, 'ºC'),
	(194819, 119, '2014-02-15 00:13:51.000000', 'temperatura', 454.0000, 'ºC'),
	(194820, 119, '2014-02-15 00:13:52.000000', 'temperatura', 834.0000, 'ºC'),
	(194821, 119, '2014-02-15 00:13:53.000000', 'temperatura', 408.0000, 'ºC'),
	(194822, 119, '2014-02-15 00:13:54.000000', 'temperatura', 741.0000, 'ºC'),
	(194823, 119, '2014-02-15 00:13:55.000000', 'temperatura', 79.0000, 'ºC'),
	(194824, 119, '2014-02-15 00:13:56.000000', 'temperatura', 572.0000, 'ºC'),
	(194825, 119, '2014-02-15 00:13:57.000000', 'temperatura', 224.0000, 'ºC'),
	(194826, 119, '2014-02-15 00:13:58.000000', 'temperatura', 607.0000, 'ºC'),
	(194827, 119, '2014-02-15 00:13:59.000000', 'temperatura', 1160.0000, 'ºC'),
	(194828, 119, '2014-02-15 00:14:00.000000', 'temperatura', 382.0000, 'ºC'),
	(194829, 119, '2014-02-15 00:14:01.000000', 'temperatura', 829.0000, 'ºC'),
	(194830, 119, '2014-02-15 00:14:02.000000', 'temperatura', 599.0000, 'ºC'),
	(194831, 119, '2014-02-15 00:14:03.000000', 'temperatura', 510.0000, 'ºC'),
	(194832, 119, '2014-02-15 00:14:04.000000', 'temperatura', 751.0000, 'ºC'),
	(194833, 119, '2014-02-15 00:14:05.000000', 'temperatura', 1026.0000, 'ºC'),
	(194834, 119, '2014-02-15 00:14:06.000000', 'temperatura', 478.0000, 'ºC'),
	(194835, 119, '2014-02-15 00:14:07.000000', 'temperatura', 513.0000, 'ºC'),
	(194836, 119, '2014-02-15 00:14:08.000000', 'temperatura', 1133.0000, 'ºC'),
	(194837, 119, '2014-02-15 00:14:09.000000', 'temperatura', 524.0000, 'ºC'),
	(194838, 119, '2014-02-15 00:14:10.000000', 'temperatura', 423.0000, 'ºC'),
	(194839, 119, '2014-02-15 00:14:11.000000', 'temperatura', 541.0000, 'ºC'),
	(194840, 119, '2014-02-15 00:14:12.000000', 'temperatura', 238.0000, 'ºC'),
	(194841, 119, '2014-02-15 00:14:13.000000', 'temperatura', 766.0000, 'ºC'),
	(194842, 119, '2014-02-15 00:14:14.000000', 'temperatura', 717.0000, 'ºC'),
	(194843, 119, '2014-02-15 00:14:15.000000', 'temperatura', 90.0000, 'ºC'),
	(194844, 119, '2014-02-15 00:14:16.000000', 'temperatura', 698.0000, 'ºC'),
	(194845, 119, '2014-02-15 00:14:17.000000', 'temperatura', 819.0000, 'ºC'),
	(194846, 119, '2014-02-15 00:14:18.000000', 'temperatura', 802.0000, 'ºC'),
	(194847, 119, '2014-02-15 00:14:19.000000', 'temperatura', 355.0000, 'ºC'),
	(194848, 119, '2014-02-15 00:14:20.000000', 'temperatura', 569.0000, 'ºC'),
	(194849, 119, '2014-02-15 00:14:21.000000', 'temperatura', 582.0000, 'ºC'),
	(194850, 119, '2014-02-15 00:14:22.000000', 'temperatura', 2.0000, 'ºC'),
	(194851, 119, '2014-02-15 00:14:23.000000', 'temperatura', 666.0000, 'ºC'),
	(194852, 119, '2014-02-15 00:14:24.000000', 'temperatura', 925.0000, 'ºC'),
	(194853, 119, '2014-02-15 00:14:25.000000', 'temperatura', 228.0000, 'ºC'),
	(194854, 119, '2014-02-15 00:14:26.000000', 'temperatura', 766.0000, 'ºC'),
	(194855, 119, '2014-02-15 00:14:27.000000', 'temperatura', 744.0000, 'ºC'),
	(194856, 119, '2014-02-15 00:14:28.000000', 'temperatura', 222.0000, 'ºC'),
	(194857, 119, '2014-02-15 00:14:29.000000', 'temperatura', 78.0000, 'ºC'),
	(194858, 119, '2014-02-15 00:14:30.000000', 'temperatura', 925.0000, 'ºC'),
	(194859, 119, '2014-02-15 00:14:31.000000', 'temperatura', 794.0000, 'ºC'),
	(194860, 119, '2014-02-15 00:14:32.000000', 'temperatura', 1192.0000, 'ºC'),
	(194861, 119, '2014-02-15 00:14:33.000000', 'temperatura', 1181.0000, 'ºC'),
	(194862, 119, '2014-02-15 00:14:34.000000', 'temperatura', 1127.0000, 'ºC'),
	(194863, 119, '2014-02-15 00:14:35.000000', 'temperatura', 892.0000, 'ºC'),
	(194864, 119, '2014-02-15 00:14:36.000000', 'temperatura', 1082.0000, 'ºC'),
	(194865, 119, '2014-02-15 00:14:37.000000', 'temperatura', 335.0000, 'ºC'),
	(194866, 119, '2014-02-15 00:14:38.000000', 'temperatura', 827.0000, 'ºC'),
	(194867, 119, '2014-02-15 00:14:39.000000', 'temperatura', 733.0000, 'ºC'),
	(194868, 119, '2014-02-15 00:14:40.000000', 'temperatura', 1184.0000, 'ºC'),
	(194869, 119, '2014-02-15 00:14:41.000000', 'temperatura', 120.0000, 'ºC'),
	(194870, 119, '2014-02-15 00:14:42.000000', 'temperatura', 649.0000, 'ºC'),
	(194871, 119, '2014-02-15 00:14:43.000000', 'temperatura', 486.0000, 'ºC'),
	(194872, 119, '2014-02-15 00:14:44.000000', 'temperatura', 483.0000, 'ºC'),
	(194873, 119, '2014-02-15 00:14:45.000000', 'temperatura', 958.0000, 'ºC'),
	(194874, 119, '2014-02-15 00:14:46.000000', 'temperatura', 943.0000, 'ºC'),
	(194875, 119, '2014-02-15 00:14:47.000000', 'temperatura', 639.0000, 'ºC'),
	(194876, 119, '2014-02-15 00:14:48.000000', 'temperatura', 367.0000, 'ºC'),
	(194877, 119, '2014-02-15 00:14:49.000000', 'temperatura', 1121.0000, 'ºC'),
	(194878, 119, '2014-02-15 00:14:50.000000', 'temperatura', 901.0000, 'ºC'),
	(194879, 119, '2014-02-15 00:14:51.000000', 'temperatura', 1145.0000, 'ºC'),
	(194880, 119, '2014-02-15 00:14:52.000000', 'temperatura', 620.0000, 'ºC'),
	(194881, 119, '2014-02-15 00:14:53.000000', 'temperatura', 867.0000, 'ºC'),
	(194882, 119, '2014-02-15 00:14:54.000000', 'temperatura', 75.0000, 'ºC'),
	(194883, 119, '2014-02-15 00:14:55.000000', 'temperatura', 175.0000, 'ºC'),
	(194884, 119, '2014-02-15 00:14:56.000000', 'temperatura', 650.0000, 'ºC'),
	(194885, 119, '2014-02-15 00:14:57.000000', 'temperatura', 325.0000, 'ºC'),
	(194886, 119, '2014-02-15 00:14:58.000000', 'temperatura', 874.0000, 'ºC'),
	(194887, 119, '2014-02-15 00:14:59.000000', 'temperatura', 997.0000, 'ºC'),
	(194888, 119, '2014-02-15 00:15:00.000000', 'temperatura', 1162.0000, 'ºC'),
	(194889, 119, '2014-02-15 00:15:01.000000', 'temperatura', 419.0000, 'ºC'),
	(194890, 119, '2014-02-15 00:15:02.000000', 'temperatura', 1012.0000, 'ºC'),
	(194891, 119, '2014-02-15 00:15:03.000000', 'temperatura', 204.0000, 'ºC'),
	(194892, 119, '2014-02-15 00:15:04.000000', 'temperatura', 384.0000, 'ºC'),
	(194893, 119, '2014-02-15 00:15:05.000000', 'temperatura', 109.0000, 'ºC'),
	(194894, 119, '2014-02-15 00:15:06.000000', 'temperatura', 594.0000, 'ºC'),
	(194895, 119, '2014-02-15 00:15:07.000000', 'temperatura', 243.0000, 'ºC'),
	(194896, 119, '2014-02-15 00:15:08.000000', 'temperatura', 632.0000, 'ºC'),
	(194897, 119, '2014-02-15 00:15:09.000000', 'temperatura', 34.0000, 'ºC'),
	(194898, 119, '2014-02-15 00:15:10.000000', 'temperatura', 675.0000, 'ºC'),
	(194899, 119, '2014-02-15 00:15:11.000000', 'temperatura', 873.0000, 'ºC'),
	(194900, 119, '2014-02-15 00:15:12.000000', 'temperatura', 1139.0000, 'ºC'),
	(194901, 119, '2014-02-15 00:15:13.000000', 'temperatura', 676.0000, 'ºC'),
	(194902, 119, '2014-02-15 00:15:14.000000', 'temperatura', 1166.0000, 'ºC'),
	(194903, 119, '2014-02-15 00:15:15.000000', 'temperatura', 201.0000, 'ºC'),
	(194904, 119, '2014-02-15 00:15:16.000000', 'temperatura', 1110.0000, 'ºC'),
	(194905, 119, '2014-02-15 00:15:17.000000', 'temperatura', 145.0000, 'ºC'),
	(194906, 119, '2014-02-15 00:15:18.000000', 'temperatura', 994.0000, 'ºC'),
	(194907, 119, '2014-02-15 00:15:19.000000', 'temperatura', 938.0000, 'ºC'),
	(194908, 119, '2014-02-15 00:15:20.000000', 'temperatura', 509.0000, 'ºC'),
	(194909, 119, '2014-02-15 00:15:21.000000', 'temperatura', 932.0000, 'ºC'),
	(194910, 119, '2014-02-15 00:15:22.000000', 'temperatura', 734.0000, 'ºC'),
	(194911, 119, '2014-02-15 00:15:23.000000', 'temperatura', 875.0000, 'ºC'),
	(194912, 119, '2014-02-15 00:15:24.000000', 'temperatura', 972.0000, 'ºC'),
	(194913, 119, '2014-02-15 00:15:25.000000', 'temperatura', 1038.0000, 'ºC'),
	(194914, 119, '2014-02-15 00:15:26.000000', 'temperatura', 1073.0000, 'ºC'),
	(194915, 119, '2014-02-15 00:15:27.000000', 'temperatura', 1050.0000, 'ºC'),
	(194916, 119, '2014-02-15 00:15:28.000000', 'temperatura', 831.0000, 'ºC'),
	(194917, 119, '2014-02-15 00:15:29.000000', 'temperatura', 1005.0000, 'ºC'),
	(194918, 119, '2014-02-15 00:15:30.000000', 'temperatura', 134.0000, 'ºC'),
	(194919, 119, '2014-02-15 00:15:31.000000', 'temperatura', 56.0000, 'ºC'),
	(194920, 119, '2014-02-15 00:15:32.000000', 'temperatura', 1078.0000, 'ºC'),
	(194921, 119, '2014-02-15 00:15:33.000000', 'temperatura', 421.0000, 'ºC'),
	(194922, 119, '2014-02-15 00:15:34.000000', 'temperatura', 74.0000, 'ºC'),
	(194923, 119, '2014-02-15 00:15:35.000000', 'temperatura', 307.0000, 'ºC'),
	(194924, 119, '2014-02-15 00:15:36.000000', 'temperatura', 112.0000, 'ºC'),
	(194925, 119, '2014-02-15 00:15:37.000000', 'temperatura', 840.0000, 'ºC'),
	(194926, 119, '2014-02-15 00:15:38.000000', 'temperatura', 264.0000, 'ºC'),
	(194927, 119, '2014-02-15 00:15:39.000000', 'temperatura', 0.0000, 'ºC'),
	(194928, 119, '2014-02-15 00:15:40.000000', 'temperatura', 409.0000, 'ºC'),
	(194929, 119, '2014-02-15 00:15:41.000000', 'temperatura', 846.0000, 'ºC'),
	(194930, 119, '2014-02-15 00:15:42.000000', 'temperatura', 605.0000, 'ºC'),
	(194931, 119, '2014-02-15 00:15:43.000000', 'temperatura', 485.0000, 'ºC'),
	(194932, 119, '2014-02-15 00:15:44.000000', 'temperatura', 612.0000, 'ºC'),
	(194933, 119, '2014-02-15 00:15:45.000000', 'temperatura', 404.0000, 'ºC'),
	(194934, 119, '2014-02-15 00:15:46.000000', 'temperatura', 186.0000, 'ºC'),
	(194935, 119, '2014-02-15 00:15:47.000000', 'temperatura', 919.0000, 'ºC'),
	(194936, 119, '2014-02-15 00:15:48.000000', 'temperatura', 439.0000, 'ºC'),
	(194937, 119, '2014-02-15 00:15:49.000000', 'temperatura', 636.0000, 'ºC'),
	(194938, 119, '2014-02-15 00:15:50.000000', 'temperatura', 664.0000, 'ºC'),
	(194939, 119, '2014-02-15 00:15:51.000000', 'temperatura', 213.0000, 'ºC'),
	(194940, 119, '2014-02-15 00:15:52.000000', 'temperatura', 274.0000, 'ºC'),
	(194941, 119, '2014-02-15 00:15:53.000000', 'temperatura', 730.0000, 'ºC'),
	(194942, 119, '2014-02-15 00:15:54.000000', 'temperatura', 431.0000, 'ºC'),
	(194943, 119, '2014-02-15 00:15:55.000000', 'temperatura', 1164.0000, 'ºC'),
	(194944, 119, '2014-02-15 00:15:56.000000', 'temperatura', 926.0000, 'ºC'),
	(194945, 119, '2014-02-15 00:15:57.000000', 'temperatura', 1138.0000, 'ºC'),
	(194946, 119, '2014-02-15 00:15:58.000000', 'temperatura', 514.0000, 'ºC'),
	(194947, 119, '2014-02-15 00:15:59.000000', 'temperatura', 355.0000, 'ºC'),
	(194948, 119, '2014-02-15 00:16:00.000000', 'temperatura', 236.0000, 'ºC'),
	(194949, 119, '2014-02-15 00:16:01.000000', 'temperatura', 116.0000, 'ºC'),
	(194950, 119, '2014-02-15 00:16:02.000000', 'temperatura', 1071.0000, 'ºC'),
	(194951, 119, '2014-02-15 00:16:03.000000', 'temperatura', 207.0000, 'ºC'),
	(194952, 119, '2014-02-15 00:16:04.000000', 'temperatura', 223.0000, 'ºC'),
	(194953, 119, '2014-02-15 00:16:05.000000', 'temperatura', 495.0000, 'ºC'),
	(194954, 119, '2014-02-15 00:16:06.000000', 'temperatura', 604.0000, 'ºC'),
	(194955, 119, '2014-02-15 00:16:07.000000', 'temperatura', 338.0000, 'ºC'),
	(194956, 119, '2014-02-15 00:16:08.000000', 'temperatura', 1076.0000, 'ºC'),
	(194957, 119, '2014-02-15 00:16:09.000000', 'temperatura', 767.0000, 'ºC'),
	(194958, 119, '2014-02-15 00:16:10.000000', 'temperatura', 610.0000, 'ºC'),
	(194959, 119, '2014-02-15 00:16:11.000000', 'temperatura', 747.0000, 'ºC'),
	(194960, 119, '2014-02-15 00:16:12.000000', 'temperatura', 705.0000, 'ºC'),
	(194961, 119, '2014-02-15 00:16:13.000000', 'temperatura', 87.0000, 'ºC'),
	(194962, 119, '2014-02-15 00:16:14.000000', 'temperatura', 720.0000, 'ºC'),
	(194963, 119, '2014-02-15 00:16:15.000000', 'temperatura', 939.0000, 'ºC'),
	(194964, 119, '2014-02-15 00:16:16.000000', 'temperatura', 136.0000, 'ºC'),
	(194965, 119, '2014-02-15 00:16:17.000000', 'temperatura', 262.0000, 'ºC'),
	(194966, 119, '2014-02-15 00:16:18.000000', 'temperatura', 904.0000, 'ºC'),
	(194967, 119, '2014-02-15 00:16:19.000000', 'temperatura', 132.0000, 'ºC'),
	(194968, 119, '2014-02-15 00:16:20.000000', 'temperatura', 350.0000, 'ºC'),
	(194969, 119, '2014-02-15 00:16:21.000000', 'temperatura', 156.0000, 'ºC'),
	(194970, 119, '2014-02-15 00:16:22.000000', 'temperatura', 931.0000, 'ºC'),
	(194971, 119, '2014-02-15 00:16:23.000000', 'temperatura', 584.0000, 'ºC'),
	(194972, 119, '2014-02-15 00:16:24.000000', 'temperatura', 131.0000, 'ºC'),
	(194973, 119, '2014-02-15 00:16:25.000000', 'temperatura', 102.0000, 'ºC'),
	(194974, 119, '2014-02-15 00:16:26.000000', 'temperatura', 116.0000, 'ºC'),
	(194975, 119, '2014-02-15 00:16:27.000000', 'temperatura', 276.0000, 'ºC'),
	(194976, 119, '2014-02-15 00:16:28.000000', 'temperatura', 1032.0000, 'ºC'),
	(194977, 119, '2014-02-15 00:16:29.000000', 'temperatura', 734.0000, 'ºC'),
	(194978, 119, '2014-02-15 00:16:30.000000', 'temperatura', 573.0000, 'ºC'),
	(194979, 119, '2014-02-15 00:16:31.000000', 'temperatura', 665.0000, 'ºC'),
	(194980, 119, '2014-02-15 00:16:32.000000', 'temperatura', 405.0000, 'ºC'),
	(194981, 119, '2014-02-15 00:16:33.000000', 'temperatura', 32.0000, 'ºC'),
	(194982, 119, '2014-02-15 00:16:34.000000', 'temperatura', 145.0000, 'ºC'),
	(194983, 119, '2014-02-15 00:16:35.000000', 'temperatura', 629.0000, 'ºC'),
	(194984, 119, '2014-02-15 00:16:36.000000', 'temperatura', 313.0000, 'ºC'),
	(194985, 119, '2014-02-15 00:16:37.000000', 'temperatura', 875.0000, 'ºC'),
	(194986, 119, '2014-02-15 00:16:38.000000', 'temperatura', 1038.0000, 'ºC'),
	(194987, 119, '2014-02-15 00:16:39.000000', 'temperatura', 165.0000, 'ºC'),
	(194988, 119, '2014-02-15 00:16:40.000000', 'temperatura', 112.0000, 'ºC'),
	(194989, 119, '2014-02-15 00:16:41.000000', 'temperatura', 65.0000, 'ºC'),
	(194990, 119, '2014-02-15 00:16:42.000000', 'temperatura', 1190.0000, 'ºC'),
	(194991, 119, '2014-02-15 00:16:43.000000', 'temperatura', 956.0000, 'ºC'),
	(194992, 119, '2014-02-15 00:16:44.000000', 'temperatura', 9.0000, 'ºC'),
	(194993, 119, '2014-02-15 00:16:45.000000', 'temperatura', 778.0000, 'ºC'),
	(194994, 119, '2014-02-15 00:16:46.000000', 'temperatura', 265.0000, 'ºC'),
	(194995, 119, '2014-02-15 00:16:47.000000', 'temperatura', 191.0000, 'ºC'),
	(194996, 119, '2014-02-15 00:16:48.000000', 'temperatura', 158.0000, 'ºC'),
	(194997, 119, '2014-02-15 00:16:49.000000', 'temperatura', 219.0000, 'ºC'),
	(194998, 119, '2014-02-15 00:16:50.000000', 'temperatura', 623.0000, 'ºC'),
	(194999, 119, '2014-02-15 00:16:51.000000', 'temperatura', 55.0000, 'ºC'),
	(195000, 119, '2014-02-15 00:16:52.000000', 'temperatura', 810.0000, 'ºC'),
	(195001, 119, '2014-02-15 00:16:53.000000', 'temperatura', 283.0000, 'ºC'),
	(195002, 119, '2014-02-15 00:16:54.000000', 'temperatura', 186.0000, 'ºC'),
	(195003, 119, '2014-02-15 00:16:55.000000', 'temperatura', 81.0000, 'ºC'),
	(195004, 119, '2014-02-15 00:16:56.000000', 'temperatura', 1048.0000, 'ºC'),
	(195005, 119, '2014-02-15 00:16:57.000000', 'temperatura', 199.0000, 'ºC'),
	(195006, 119, '2014-02-15 00:16:58.000000', 'temperatura', 250.0000, 'ºC'),
	(195007, 119, '2014-02-15 00:16:59.000000', 'temperatura', 655.0000, 'ºC'),
	(195008, 119, '2014-02-15 00:17:00.000000', 'temperatura', 126.0000, 'ºC'),
	(195009, 119, '2014-02-15 00:17:01.000000', 'temperatura', 1063.0000, 'ºC'),
	(195010, 119, '2014-02-15 00:17:02.000000', 'temperatura', 140.0000, 'ºC'),
	(195011, 119, '2014-02-15 00:17:03.000000', 'temperatura', 1110.0000, 'ºC'),
	(195012, 119, '2014-02-15 00:17:04.000000', 'temperatura', 331.0000, 'ºC'),
	(195013, 119, '2014-02-15 00:17:05.000000', 'temperatura', 725.0000, 'ºC'),
	(195014, 119, '2014-02-15 00:17:06.000000', 'temperatura', 233.0000, 'ºC'),
	(195015, 119, '2014-02-15 00:17:07.000000', 'temperatura', 192.0000, 'ºC'),
	(195016, 119, '2014-02-15 00:17:08.000000', 'temperatura', 259.0000, 'ºC'),
	(195017, 119, '2014-02-15 00:17:09.000000', 'temperatura', 719.0000, 'ºC'),
	(195018, 119, '2014-02-15 00:17:10.000000', 'temperatura', 421.0000, 'ºC'),
	(195019, 119, '2014-02-15 00:17:11.000000', 'temperatura', 1145.0000, 'ºC'),
	(195020, 119, '2014-02-15 00:17:12.000000', 'temperatura', 866.0000, 'ºC'),
	(195021, 119, '2014-02-15 00:17:13.000000', 'temperatura', 892.0000, 'ºC'),
	(195022, 119, '2014-02-15 00:17:14.000000', 'temperatura', 666.0000, 'ºC'),
	(195023, 119, '2014-02-15 00:17:15.000000', 'temperatura', 653.0000, 'ºC'),
	(195024, 119, '2014-02-15 00:17:16.000000', 'temperatura', 68.0000, 'ºC'),
	(195025, 119, '2014-02-15 00:17:17.000000', 'temperatura', 780.0000, 'ºC'),
	(195026, 119, '2014-02-15 00:17:18.000000', 'temperatura', 96.0000, 'ºC'),
	(195027, 119, '2014-02-15 00:17:19.000000', 'temperatura', 543.0000, 'ºC'),
	(195028, 119, '2014-02-15 00:17:20.000000', 'temperatura', 28.0000, 'ºC'),
	(195029, 119, '2014-02-15 00:17:21.000000', 'temperatura', 911.0000, 'ºC'),
	(195030, 119, '2014-02-15 00:17:22.000000', 'temperatura', 872.0000, 'ºC'),
	(195031, 119, '2014-02-15 00:17:23.000000', 'temperatura', 428.0000, 'ºC'),
	(195032, 119, '2014-02-15 00:17:24.000000', 'temperatura', 725.0000, 'ºC'),
	(195033, 119, '2014-02-15 00:17:25.000000', 'temperatura', 1142.0000, 'ºC'),
	(195034, 119, '2014-02-15 00:17:26.000000', 'temperatura', 1134.0000, 'ºC'),
	(195035, 119, '2014-02-15 00:17:27.000000', 'temperatura', 1043.0000, 'ºC'),
	(195036, 119, '2014-02-15 00:17:28.000000', 'temperatura', 615.0000, 'ºC'),
	(195037, 119, '2014-02-15 00:17:29.000000', 'temperatura', 1148.0000, 'ºC'),
	(195038, 119, '2014-02-15 00:17:30.000000', 'temperatura', 296.0000, 'ºC'),
	(195039, 119, '2014-02-15 00:17:31.000000', 'temperatura', 437.0000, 'ºC'),
	(195040, 119, '2014-02-15 00:17:32.000000', 'temperatura', 96.0000, 'ºC'),
	(195041, 119, '2014-02-15 00:17:33.000000', 'temperatura', 370.0000, 'ºC'),
	(195042, 119, '2014-02-15 00:17:34.000000', 'temperatura', 361.0000, 'ºC'),
	(195043, 119, '2014-02-15 00:17:35.000000', 'temperatura', 694.0000, 'ºC'),
	(195044, 119, '2014-02-15 00:17:36.000000', 'temperatura', 1191.0000, 'ºC'),
	(195045, 119, '2014-02-15 00:17:37.000000', 'temperatura', 273.0000, 'ºC'),
	(195046, 119, '2014-02-15 00:17:38.000000', 'temperatura', 191.0000, 'ºC'),
	(195047, 119, '2014-02-15 00:17:39.000000', 'temperatura', 136.0000, 'ºC'),
	(195048, 119, '2014-02-15 00:17:40.000000', 'temperatura', 110.0000, 'ºC'),
	(195049, 119, '2014-02-15 00:17:41.000000', 'temperatura', 141.0000, 'ºC'),
	(195050, 119, '2014-02-15 00:17:42.000000', 'temperatura', 374.0000, 'ºC'),
	(195051, 119, '2014-02-15 00:17:43.000000', 'temperatura', 250.0000, 'ºC'),
	(195052, 119, '2014-02-15 00:17:44.000000', 'temperatura', 129.0000, 'ºC'),
	(195053, 119, '2014-02-15 00:17:45.000000', 'temperatura', 1096.0000, 'ºC'),
	(195054, 119, '2014-02-15 00:17:46.000000', 'temperatura', 294.0000, 'ºC'),
	(195055, 119, '2014-02-15 00:17:47.000000', 'temperatura', 581.0000, 'ºC'),
	(195056, 119, '2014-02-15 00:17:48.000000', 'temperatura', 824.0000, 'ºC'),
	(195057, 119, '2014-02-15 00:17:49.000000', 'temperatura', 1177.0000, 'ºC'),
	(195058, 119, '2014-02-15 00:17:50.000000', 'temperatura', 1012.0000, 'ºC'),
	(195059, 119, '2014-02-15 00:17:51.000000', 'temperatura', 332.0000, 'ºC'),
	(195060, 119, '2014-02-15 00:17:52.000000', 'temperatura', 1023.0000, 'ºC'),
	(195061, 119, '2014-02-15 00:17:53.000000', 'temperatura', 521.0000, 'ºC'),
	(195062, 119, '2014-02-15 00:17:54.000000', 'temperatura', 735.0000, 'ºC'),
	(195063, 119, '2014-02-15 00:17:55.000000', 'temperatura', 915.0000, 'ºC'),
	(195064, 119, '2014-02-15 00:17:56.000000', 'temperatura', 1169.0000, 'ºC'),
	(195065, 119, '2014-02-15 00:17:57.000000', 'temperatura', 699.0000, 'ºC'),
	(195066, 119, '2014-02-15 00:17:58.000000', 'temperatura', 1190.0000, 'ºC'),
	(195067, 119, '2014-02-15 00:17:59.000000', 'temperatura', 253.0000, 'ºC'),
	(195068, 119, '2014-02-15 00:18:00.000000', 'temperatura', 97.0000, 'ºC'),
	(195069, 119, '2014-02-15 00:18:01.000000', 'temperatura', 924.0000, 'ºC'),
	(195070, 119, '2014-02-15 00:18:02.000000', 'temperatura', 732.0000, 'ºC'),
	(195071, 119, '2014-02-15 00:18:03.000000', 'temperatura', 889.0000, 'ºC'),
	(195072, 119, '2014-02-15 00:18:04.000000', 'temperatura', 1049.0000, 'ºC'),
	(195073, 119, '2014-02-15 00:18:05.000000', 'temperatura', 179.0000, 'ºC'),
	(195074, 119, '2014-02-15 00:18:06.000000', 'temperatura', 147.0000, 'ºC'),
	(195075, 119, '2014-02-15 00:18:07.000000', 'temperatura', 199.0000, 'ºC'),
	(195076, 119, '2014-02-15 00:18:08.000000', 'temperatura', 556.0000, 'ºC'),
	(195077, 119, '2014-02-15 00:18:09.000000', 'temperatura', 982.0000, 'ºC'),
	(195078, 119, '2014-02-15 00:18:10.000000', 'temperatura', 841.0000, 'ºC'),
	(195079, 119, '2014-02-15 00:18:11.000000', 'temperatura', 62.0000, 'ºC'),
	(195080, 119, '2014-02-15 00:18:12.000000', 'temperatura', 188.0000, 'ºC'),
	(195081, 119, '2014-02-15 00:18:13.000000', 'temperatura', 755.0000, 'ºC'),
	(195082, 119, '2014-02-15 00:18:14.000000', 'temperatura', 812.0000, 'ºC'),
	(195083, 119, '2014-02-15 00:18:15.000000', 'temperatura', 595.0000, 'ºC'),
	(195084, 119, '2014-02-15 00:18:16.000000', 'temperatura', 539.0000, 'ºC'),
	(195085, 119, '2014-02-15 00:18:17.000000', 'temperatura', 911.0000, 'ºC'),
	(195086, 119, '2014-02-15 00:18:18.000000', 'temperatura', 537.0000, 'ºC'),
	(195087, 119, '2014-02-15 00:18:19.000000', 'temperatura', 1154.0000, 'ºC'),
	(195088, 119, '2014-02-15 00:18:20.000000', 'temperatura', 558.0000, 'ºC'),
	(195089, 119, '2014-02-15 00:18:21.000000', 'temperatura', 528.0000, 'ºC'),
	(195090, 119, '2014-02-15 00:18:22.000000', 'temperatura', 969.0000, 'ºC'),
	(195091, 119, '2014-02-15 00:18:23.000000', 'temperatura', 861.0000, 'ºC'),
	(195092, 119, '2014-02-15 00:18:24.000000', 'temperatura', 197.0000, 'ºC'),
	(195093, 119, '2014-02-15 00:18:25.000000', 'temperatura', 801.0000, 'ºC'),
	(195094, 119, '2014-02-15 00:18:26.000000', 'temperatura', 1018.0000, 'ºC'),
	(195095, 119, '2014-02-15 00:18:27.000000', 'temperatura', 286.0000, 'ºC'),
	(195096, 119, '2014-02-15 00:18:28.000000', 'temperatura', 779.0000, 'ºC'),
	(195097, 119, '2014-02-15 00:18:29.000000', 'temperatura', 634.0000, 'ºC'),
	(195098, 119, '2014-02-15 00:18:30.000000', 'temperatura', 835.0000, 'ºC'),
	(195099, 119, '2014-02-15 00:18:31.000000', 'temperatura', 1072.0000, 'ºC'),
	(195100, 119, '2014-02-15 00:18:32.000000', 'temperatura', 456.0000, 'ºC'),
	(195101, 119, '2014-02-15 00:18:33.000000', 'temperatura', 265.0000, 'ºC'),
	(195102, 119, '2014-02-15 00:18:34.000000', 'temperatura', 1158.0000, 'ºC'),
	(195103, 119, '2014-02-15 00:18:35.000000', 'temperatura', 193.0000, 'ºC'),
	(195104, 119, '2014-02-15 00:18:36.000000', 'temperatura', 1093.0000, 'ºC'),
	(195105, 119, '2014-02-15 00:18:37.000000', 'temperatura', 85.0000, 'ºC'),
	(195106, 119, '2014-02-15 00:18:38.000000', 'temperatura', 750.0000, 'ºC'),
	(195107, 119, '2014-02-15 00:18:39.000000', 'temperatura', 1092.0000, 'ºC'),
	(195108, 119, '2014-02-15 00:18:40.000000', 'temperatura', 812.0000, 'ºC'),
	(195109, 119, '2014-02-15 00:18:41.000000', 'temperatura', 786.0000, 'ºC'),
	(195110, 119, '2014-02-15 00:18:42.000000', 'temperatura', 292.0000, 'ºC'),
	(195111, 119, '2014-02-15 00:18:43.000000', 'temperatura', 303.0000, 'ºC'),
	(195112, 119, '2014-02-15 00:18:44.000000', 'temperatura', 640.0000, 'ºC'),
	(195113, 119, '2014-02-15 00:18:45.000000', 'temperatura', 1092.0000, 'ºC'),
	(195114, 119, '2014-02-15 00:18:46.000000', 'temperatura', 1138.0000, 'ºC'),
	(195115, 119, '2014-02-15 00:18:47.000000', 'temperatura', 17.0000, 'ºC'),
	(195116, 119, '2014-02-15 00:18:48.000000', 'temperatura', 272.0000, 'ºC'),
	(195117, 119, '2014-02-15 00:18:49.000000', 'temperatura', 107.0000, 'ºC'),
	(195118, 119, '2014-02-15 00:18:50.000000', 'temperatura', 922.0000, 'ºC'),
	(195119, 119, '2014-02-15 00:18:51.000000', 'temperatura', 689.0000, 'ºC'),
	(195120, 119, '2014-02-15 00:18:52.000000', 'temperatura', 681.0000, 'ºC'),
	(195121, 119, '2014-02-15 00:18:53.000000', 'temperatura', 136.0000, 'ºC'),
	(195122, 119, '2014-02-15 00:18:54.000000', 'temperatura', 1039.0000, 'ºC'),
	(195123, 119, '2014-02-15 00:18:55.000000', 'temperatura', 1189.0000, 'ºC'),
	(195124, 119, '2014-02-15 00:18:56.000000', 'temperatura', 427.0000, 'ºC'),
	(195125, 119, '2014-02-15 00:18:57.000000', 'temperatura', 970.0000, 'ºC'),
	(195126, 119, '2014-02-15 00:18:58.000000', 'temperatura', 1167.0000, 'ºC'),
	(195127, 119, '2014-02-15 00:18:59.000000', 'temperatura', 526.0000, 'ºC'),
	(195128, 119, '2014-02-15 00:19:00.000000', 'temperatura', 332.0000, 'ºC'),
	(195129, 119, '2014-02-15 00:19:01.000000', 'temperatura', 81.0000, 'ºC'),
	(195130, 119, '2014-02-15 00:19:02.000000', 'temperatura', 608.0000, 'ºC'),
	(195131, 119, '2014-02-15 00:19:03.000000', 'temperatura', 400.0000, 'ºC'),
	(195132, 119, '2014-02-15 00:19:04.000000', 'temperatura', 175.0000, 'ºC'),
	(195133, 119, '2014-02-15 00:19:05.000000', 'temperatura', 875.0000, 'ºC'),
	(195134, 119, '2014-02-15 00:19:06.000000', 'temperatura', 249.0000, 'ºC'),
	(195135, 119, '2014-02-15 00:19:07.000000', 'temperatura', 1023.0000, 'ºC'),
	(195136, 119, '2014-02-15 00:19:08.000000', 'temperatura', 766.0000, 'ºC'),
	(195137, 119, '2014-02-15 00:19:09.000000', 'temperatura', 763.0000, 'ºC'),
	(195138, 119, '2014-02-15 00:19:10.000000', 'temperatura', 319.0000, 'ºC'),
	(195139, 119, '2014-02-15 00:19:11.000000', 'temperatura', 506.0000, 'ºC'),
	(195140, 119, '2014-02-15 00:19:12.000000', 'temperatura', 371.0000, 'ºC'),
	(195141, 119, '2014-02-15 00:19:13.000000', 'temperatura', 341.0000, 'ºC'),
	(195142, 119, '2014-02-15 00:19:14.000000', 'temperatura', 589.0000, 'ºC'),
	(195143, 119, '2014-02-15 00:19:15.000000', 'temperatura', 724.0000, 'ºC'),
	(195144, 119, '2014-02-15 00:19:16.000000', 'temperatura', 654.0000, 'ºC'),
	(195145, 119, '2014-02-15 00:19:17.000000', 'temperatura', 1097.0000, 'ºC'),
	(195146, 119, '2014-02-15 00:19:18.000000', 'temperatura', 1125.0000, 'ºC'),
	(195147, 119, '2014-02-15 00:19:19.000000', 'temperatura', 1133.0000, 'ºC'),
	(195148, 119, '2014-02-15 00:19:20.000000', 'temperatura', 1089.0000, 'ºC'),
	(195149, 119, '2014-02-15 00:19:21.000000', 'temperatura', 850.0000, 'ºC'),
	(195150, 119, '2014-02-15 00:19:22.000000', 'temperatura', 981.0000, 'ºC'),
	(195151, 119, '2014-02-15 00:19:23.000000', 'temperatura', 1157.0000, 'ºC'),
	(195152, 119, '2014-02-15 00:19:24.000000', 'temperatura', 442.0000, 'ºC'),
	(195153, 119, '2014-02-15 00:19:25.000000', 'temperatura', 1139.0000, 'ºC'),
	(195154, 119, '2014-02-15 00:19:26.000000', 'temperatura', 771.0000, 'ºC'),
	(195155, 119, '2014-02-15 00:19:27.000000', 'temperatura', 437.0000, 'ºC'),
	(195156, 119, '2014-02-15 00:19:28.000000', 'temperatura', 1073.0000, 'ºC'),
	(195157, 119, '2014-02-15 00:19:29.000000', 'temperatura', 457.0000, 'ºC'),
	(195158, 119, '2014-02-15 00:19:30.000000', 'temperatura', 263.0000, 'ºC'),
	(195159, 119, '2014-02-15 00:19:31.000000', 'temperatura', 1146.0000, 'ºC'),
	(195160, 119, '2014-02-15 00:19:32.000000', 'temperatura', 143.0000, 'ºC'),
	(195161, 119, '2014-02-15 00:19:33.000000', 'temperatura', 875.0000, 'ºC'),
	(195162, 119, '2014-02-15 00:19:34.000000', 'temperatura', 345.0000, 'ºC'),
	(195163, 119, '2014-02-15 00:19:35.000000', 'temperatura', 304.0000, 'ºC'),
	(195164, 119, '2014-02-15 00:19:36.000000', 'temperatura', 484.0000, 'ºC'),
	(195165, 119, '2014-02-15 00:19:37.000000', 'temperatura', 310.0000, 'ºC'),
	(195166, 119, '2014-02-15 00:19:38.000000', 'temperatura', 99.0000, 'ºC'),
	(195167, 119, '2014-02-15 00:19:39.000000', 'temperatura', 764.0000, 'ºC'),
	(195168, 119, '2014-02-15 00:19:40.000000', 'temperatura', 1123.0000, 'ºC'),
	(195169, 119, '2014-02-15 00:19:41.000000', 'temperatura', 924.0000, 'ºC'),
	(195170, 119, '2014-02-15 00:19:42.000000', 'temperatura', 51.0000, 'ºC'),
	(195171, 119, '2014-02-15 00:19:43.000000', 'temperatura', 1082.0000, 'ºC'),
	(195172, 119, '2014-02-15 00:19:44.000000', 'temperatura', 458.0000, 'ºC'),
	(195173, 119, '2014-02-15 00:19:45.000000', 'temperatura', 245.0000, 'ºC'),
	(195174, 119, '2014-02-15 00:19:46.000000', 'temperatura', 1053.0000, 'ºC'),
	(195175, 119, '2014-02-15 00:19:47.000000', 'temperatura', 930.0000, 'ºC'),
	(195176, 119, '2014-02-15 00:19:48.000000', 'temperatura', 290.0000, 'ºC'),
	(195177, 119, '2014-02-15 00:19:49.000000', 'temperatura', 1061.0000, 'ºC'),
	(195178, 119, '2014-02-15 00:19:50.000000', 'temperatura', 836.0000, 'ºC'),
	(195179, 119, '2014-02-15 00:19:51.000000', 'temperatura', 996.0000, 'ºC'),
	(195180, 119, '2014-02-15 00:19:52.000000', 'temperatura', 72.0000, 'ºC'),
	(195181, 119, '2014-02-15 00:19:53.000000', 'temperatura', 975.0000, 'ºC'),
	(195182, 119, '2014-02-15 00:19:54.000000', 'temperatura', 1058.0000, 'ºC'),
	(195183, 119, '2014-02-15 00:19:55.000000', 'temperatura', 1167.0000, 'ºC'),
	(195184, 119, '2014-02-15 00:19:56.000000', 'temperatura', 260.0000, 'ºC'),
	(195185, 119, '2014-02-15 00:19:57.000000', 'temperatura', 198.0000, 'ºC'),
	(195186, 119, '2014-02-15 00:19:58.000000', 'temperatura', 212.0000, 'ºC'),
	(195187, 119, '2014-02-15 00:19:59.000000', 'temperatura', 467.0000, 'ºC'),
	(195188, 119, '2014-02-15 00:20:00.000000', 'temperatura', 501.0000, 'ºC'),
	(195189, 119, '2014-02-15 00:20:01.000000', 'temperatura', 1101.0000, 'ºC'),
	(195190, 119, '2014-02-15 00:20:02.000000', 'temperatura', 405.0000, 'ºC'),
	(195191, 119, '2014-02-15 00:20:03.000000', 'temperatura', 1124.0000, 'ºC'),
	(195192, 119, '2014-02-15 00:20:04.000000', 'temperatura', 803.0000, 'ºC'),
	(195193, 119, '2014-02-15 00:20:05.000000', 'temperatura', 645.0000, 'ºC'),
	(195194, 119, '2014-02-15 00:20:06.000000', 'temperatura', 816.0000, 'ºC'),
	(195195, 119, '2014-02-15 00:20:07.000000', 'temperatura', 946.0000, 'ºC'),
	(195196, 119, '2014-02-15 00:20:08.000000', 'temperatura', 1084.0000, 'ºC'),
	(195197, 119, '2014-02-15 00:20:09.000000', 'temperatura', 180.0000, 'ºC'),
	(195198, 119, '2014-02-15 00:20:10.000000', 'temperatura', 51.0000, 'ºC'),
	(195199, 119, '2014-02-15 00:20:11.000000', 'temperatura', 915.0000, 'ºC'),
	(195200, 119, '2014-02-15 00:20:12.000000', 'temperatura', 821.0000, 'ºC'),
	(195201, 119, '2014-02-15 00:20:13.000000', 'temperatura', 161.0000, 'ºC'),
	(195202, 119, '2014-02-15 00:20:14.000000', 'temperatura', 741.0000, 'ºC'),
	(195203, 119, '2014-02-15 00:20:15.000000', 'temperatura', 823.0000, 'ºC'),
	(195204, 119, '2014-02-15 00:20:16.000000', 'temperatura', 695.0000, 'ºC'),
	(195205, 119, '2014-02-15 00:20:17.000000', 'temperatura', 1006.0000, 'ºC'),
	(195206, 119, '2014-02-15 00:20:18.000000', 'temperatura', 543.0000, 'ºC'),
	(195207, 119, '2014-02-15 00:20:19.000000', 'temperatura', 898.0000, 'ºC'),
	(195208, 119, '2014-02-15 00:20:20.000000', 'temperatura', 462.0000, 'ºC'),
	(195209, 119, '2014-02-15 00:20:21.000000', 'temperatura', 818.0000, 'ºC'),
	(195210, 119, '2014-02-15 00:20:22.000000', 'temperatura', 302.0000, 'ºC'),
	(195211, 119, '2014-02-15 00:20:23.000000', 'temperatura', 256.0000, 'ºC'),
	(195212, 119, '2014-02-15 00:20:24.000000', 'temperatura', 374.0000, 'ºC'),
	(195213, 119, '2014-02-15 00:20:25.000000', 'temperatura', 1102.0000, 'ºC'),
	(195214, 119, '2014-02-15 00:20:26.000000', 'temperatura', 788.0000, 'ºC'),
	(195215, 119, '2014-02-15 00:20:27.000000', 'temperatura', 636.0000, 'ºC'),
	(195216, 119, '2014-02-15 00:20:28.000000', 'temperatura', 817.0000, 'ºC'),
	(195217, 119, '2014-02-15 00:20:29.000000', 'temperatura', 976.0000, 'ºC'),
	(195218, 119, '2014-02-15 00:20:30.000000', 'temperatura', 29.0000, 'ºC'),
	(195219, 119, '2014-02-15 00:20:31.000000', 'temperatura', 820.0000, 'ºC'),
	(195220, 119, '2014-02-15 00:20:32.000000', 'temperatura', 412.0000, 'ºC'),
	(195221, 119, '2014-02-15 00:20:33.000000', 'temperatura', 800.0000, 'ºC'),
	(195222, 119, '2014-02-15 00:20:34.000000', 'temperatura', 366.0000, 'ºC'),
	(195223, 119, '2014-02-15 00:20:35.000000', 'temperatura', 631.0000, 'ºC'),
	(195224, 119, '2014-02-15 00:20:36.000000', 'temperatura', 859.0000, 'ºC'),
	(195225, 119, '2014-02-15 00:20:37.000000', 'temperatura', 1199.0000, 'ºC'),
	(195226, 119, '2014-02-15 00:20:38.000000', 'temperatura', 1019.0000, 'ºC'),
	(195227, 119, '2014-02-15 00:20:39.000000', 'temperatura', 299.0000, 'ºC'),
	(195228, 119, '2014-02-15 00:20:40.000000', 'temperatura', 839.0000, 'ºC'),
	(195229, 119, '2014-02-15 00:20:41.000000', 'temperatura', 898.0000, 'ºC'),
	(195230, 119, '2014-02-15 00:20:42.000000', 'temperatura', 774.0000, 'ºC'),
	(195231, 119, '2014-02-15 00:20:43.000000', 'temperatura', 1175.0000, 'ºC'),
	(195232, 119, '2014-02-15 00:20:44.000000', 'temperatura', 1153.0000, 'ºC'),
	(195233, 119, '2014-02-15 00:20:45.000000', 'temperatura', 1043.0000, 'ºC'),
	(195234, 119, '2014-02-15 00:20:46.000000', 'temperatura', 555.0000, 'ºC'),
	(195235, 119, '2014-02-15 00:20:47.000000', 'temperatura', 847.0000, 'ºC'),
	(195236, 119, '2014-02-15 00:20:48.000000', 'temperatura', 172.0000, 'ºC'),
	(195237, 119, '2014-02-15 00:20:49.000000', 'temperatura', 717.0000, 'ºC'),
	(195238, 119, '2014-02-15 00:20:50.000000', 'temperatura', 670.0000, 'ºC'),
	(195239, 119, '2014-02-15 00:20:51.000000', 'temperatura', 1.0000, 'ºC'),
	(195240, 119, '2014-02-15 00:20:52.000000', 'temperatura', 393.0000, 'ºC'),
	(195241, 119, '2014-02-15 00:20:53.000000', 'temperatura', 763.0000, 'ºC'),
	(195242, 119, '2014-02-15 00:20:54.000000', 'temperatura', 239.0000, 'ºC'),
	(195243, 119, '2014-02-15 00:20:55.000000', 'temperatura', 105.0000, 'ºC'),
	(195244, 119, '2014-02-15 00:20:56.000000', 'temperatura', 1009.0000, 'ºC'),
	(195245, 119, '2014-02-15 00:20:57.000000', 'temperatura', 1131.0000, 'ºC'),
	(195246, 119, '2014-02-15 00:20:58.000000', 'temperatura', 228.0000, 'ºC'),
	(195247, 119, '2014-02-15 00:20:59.000000', 'temperatura', 147.0000, 'ºC'),
	(195248, 119, '2014-02-15 00:21:00.000000', 'temperatura', 50.0000, 'ºC'),
	(195249, 119, '2014-02-15 00:21:01.000000', 'temperatura', 1012.0000, 'ºC'),
	(195250, 119, '2014-02-15 00:21:02.000000', 'temperatura', 109.0000, 'ºC'),
	(195251, 119, '2014-02-15 00:21:03.000000', 'temperatura', 1110.0000, 'ºC'),
	(195252, 119, '2014-02-15 00:21:04.000000', 'temperatura', 425.0000, 'ºC'),
	(195253, 119, '2014-02-15 00:21:05.000000', 'temperatura', 1196.0000, 'ºC'),
	(195254, 119, '2014-02-15 00:21:06.000000', 'temperatura', 1102.0000, 'ºC'),
	(195255, 119, '2014-02-15 00:21:07.000000', 'temperatura', 726.0000, 'ºC'),
	(195256, 119, '2014-02-15 00:21:08.000000', 'temperatura', 323.0000, 'ºC'),
	(195257, 119, '2014-02-15 00:21:09.000000', 'temperatura', 639.0000, 'ºC'),
	(195258, 119, '2014-02-15 00:21:10.000000', 'temperatura', 1026.0000, 'ºC'),
	(195259, 119, '2014-02-15 00:21:11.000000', 'temperatura', 815.0000, 'ºC'),
	(195260, 119, '2014-02-15 00:21:12.000000', 'temperatura', 994.0000, 'ºC'),
	(195261, 119, '2014-02-15 00:21:13.000000', 'temperatura', 128.0000, 'ºC'),
	(195262, 119, '2014-02-15 00:21:14.000000', 'temperatura', 57.0000, 'ºC'),
	(195263, 119, '2014-02-15 00:21:15.000000', 'temperatura', 1102.0000, 'ºC'),
	(195264, 119, '2014-02-15 00:21:16.000000', 'temperatura', 539.0000, 'ºC'),
	(195265, 119, '2014-02-15 00:21:17.000000', 'temperatura', 590.0000, 'ºC'),
	(195266, 119, '2014-02-15 00:21:18.000000', 'temperatura', 133.0000, 'ºC'),
	(195267, 119, '2014-02-15 00:21:19.000000', 'temperatura', 94.0000, 'ºC'),
	(195268, 119, '2014-02-15 00:21:20.000000', 'temperatura', 75.0000, 'ºC'),
	(195269, 119, '2014-02-15 00:21:21.000000', 'temperatura', 90.0000, 'ºC'),
	(195270, 119, '2014-02-15 00:21:22.000000', 'temperatura', 228.0000, 'ºC'),
	(195271, 119, '2014-02-15 00:21:23.000000', 'temperatura', 869.0000, 'ºC'),
	(195272, 119, '2014-02-15 00:21:24.000000', 'temperatura', 62.0000, 'ºC'),
	(195273, 119, '2014-02-15 00:21:25.000000', 'temperatura', 106.0000, 'ºC'),
	(195274, 119, '2014-02-15 00:21:26.000000', 'temperatura', 341.0000, 'ºC'),
	(195275, 119, '2014-02-15 00:21:27.000000', 'temperatura', 187.0000, 'ºC'),
	(195276, 119, '2014-02-15 00:21:28.000000', 'temperatura', 1115.0000, 'ºC'),
	(195277, 119, '2014-02-15 00:21:29.000000', 'temperatura', 213.0000, 'ºC'),
	(195278, 119, '2014-02-15 00:21:30.000000', 'temperatura', 122.0000, 'ºC'),
	(195279, 119, '2014-02-15 00:21:31.000000', 'temperatura', 1172.0000, 'ºC'),
	(195280, 119, '2014-02-15 00:21:32.000000', 'temperatura', 695.0000, 'ºC'),
	(195281, 119, '2014-02-15 00:21:33.000000', 'temperatura', 1159.0000, 'ºC'),
	(195282, 119, '2014-02-15 00:21:34.000000', 'temperatura', 112.0000, 'ºC'),
	(195283, 119, '2014-02-15 00:21:35.000000', 'temperatura', 681.0000, 'ºC'),
	(195284, 119, '2014-02-15 00:21:36.000000', 'temperatura', 669.0000, 'ºC'),
	(195285, 119, '2014-02-15 00:21:37.000000', 'temperatura', 103.0000, 'ºC'),
	(195286, 119, '2014-02-15 00:21:38.000000', 'temperatura', 910.0000, 'ºC'),
	(195287, 119, '2014-02-15 00:21:39.000000', 'temperatura', 640.0000, 'ºC'),
	(195288, 119, '2014-02-15 00:21:40.000000', 'temperatura', 469.0000, 'ºC'),
	(195289, 119, '2014-02-15 00:21:41.000000', 'temperatura', 426.0000, 'ºC'),
	(195290, 119, '2014-02-15 00:21:42.000000', 'temperatura', 725.0000, 'ºC'),
	(195291, 119, '2014-02-15 00:21:43.000000', 'temperatura', 1146.0000, 'ºC'),
	(195292, 119, '2014-02-15 00:21:44.000000', 'temperatura', 1157.0000, 'ºC'),
	(195293, 119, '2014-02-15 00:21:45.000000', 'temperatura', 1146.0000, 'ºC'),
	(195294, 119, '2014-02-15 00:21:46.000000', 'temperatura', 1060.0000, 'ºC'),
	(195295, 119, '2014-02-15 00:21:47.000000', 'temperatura', 661.0000, 'ºC'),
	(195296, 119, '2014-02-15 00:21:48.000000', 'temperatura', 125.0000, 'ºC'),
	(195297, 119, '2014-02-15 00:21:49.000000', 'temperatura', 1043.0000, 'ºC'),
	(195298, 119, '2014-02-15 00:21:50.000000', 'temperatura', 42.0000, 'ºC'),
	(195299, 119, '2014-02-15 00:21:51.000000', 'temperatura', 679.0000, 'ºC'),
	(195300, 119, '2014-02-15 00:21:52.000000', 'temperatura', 871.0000, 'ºC'),
	(195301, 119, '2014-02-15 00:21:53.000000', 'temperatura', 1117.0000, 'ºC'),
	(195302, 119, '2014-02-15 00:21:54.000000', 'temperatura', 575.0000, 'ºC'),
	(195303, 119, '2014-02-15 00:21:55.000000', 'temperatura', 724.0000, 'ºC'),
	(195304, 119, '2014-02-15 00:21:56.000000', 'temperatura', 693.0000, 'ºC'),
	(195305, 119, '2014-02-15 00:21:57.000000', 'temperatura', 95.0000, 'ºC'),
	(195306, 119, '2014-02-15 00:21:58.000000', 'temperatura', 795.0000, 'ºC'),
	(195307, 119, '2014-02-15 00:21:59.000000', 'temperatura', 91.0000, 'ºC'),
	(195308, 119, '2014-02-15 00:22:00.000000', 'temperatura', 472.0000, 'ºC'),
	(195309, 119, '2014-02-15 00:22:01.000000', 'temperatura', 887.0000, 'ºC'),
	(195310, 119, '2014-02-15 00:22:02.000000', 'temperatura', 621.0000, 'ºC'),
	(195311, 119, '2014-02-15 00:22:03.000000', 'temperatura', 443.0000, 'ºC'),
	(195312, 119, '2014-02-15 00:22:04.000000', 'temperatura', 353.0000, 'ºC'),
	(195313, 119, '2014-02-15 00:22:05.000000', 'temperatura', 438.0000, 'ºC'),
	(195314, 119, '2014-02-15 00:22:06.000000', 'temperatura', 1129.0000, 'ºC'),
	(195315, 119, '2014-02-15 00:22:07.000000', 'temperatura', 731.0000, 'ºC'),
	(195316, 119, '2014-02-15 00:22:08.000000', 'temperatura', 271.0000, 'ºC'),
	(195317, 119, '2014-02-15 00:22:09.000000', 'temperatura', 361.0000, 'ºC'),
	(195318, 119, '2014-02-15 00:22:10.000000', 'temperatura', 992.0000, 'ºC'),
	(195319, 119, '2014-02-15 00:22:11.000000', 'temperatura', 278.0000, 'ºC'),
	(195320, 119, '2014-02-15 00:22:12.000000', 'temperatura', 815.0000, 'ºC'),
	(195321, 119, '2014-02-15 00:22:13.000000', 'temperatura', 841.0000, 'ºC'),
	(195322, 119, '2014-02-15 00:22:14.000000', 'temperatura', 559.0000, 'ºC'),
	(195323, 119, '2014-02-15 00:22:15.000000', 'temperatura', 273.0000, 'ºC'),
	(195324, 119, '2014-02-15 00:22:16.000000', 'temperatura', 891.0000, 'ºC'),
	(195325, 119, '2014-02-15 00:22:17.000000', 'temperatura', 34.0000, 'ºC'),
	(195326, 119, '2014-02-15 00:22:18.000000', 'temperatura', 1100.0000, 'ºC'),
	(195327, 119, '2014-02-15 00:22:19.000000', 'temperatura', 595.0000, 'ºC'),
	(195328, 119, '2014-02-15 00:22:20.000000', 'temperatura', 878.0000, 'ºC'),
	(195329, 119, '2014-02-15 00:22:21.000000', 'temperatura', 204.0000, 'ºC'),
	(195330, 119, '2014-02-15 00:22:22.000000', 'temperatura', 788.0000, 'ºC'),
	(195331, 119, '2014-02-15 00:22:23.000000', 'temperatura', 928.0000, 'ºC'),
	(195332, 119, '2014-02-15 00:22:24.000000', 'temperatura', 1078.0000, 'ºC'),
	(195333, 119, '2014-02-15 00:22:25.000000', 'temperatura', 207.0000, 'ºC'),
	(195334, 119, '2014-02-15 00:22:26.000000', 'temperatura', 201.0000, 'ºC'),
	(195335, 119, '2014-02-15 00:22:27.000000', 'temperatura', 385.0000, 'ºC'),
	(195336, 119, '2014-02-15 00:22:28.000000', 'temperatura', 123.0000, 'ºC'),
	(195337, 119, '2014-02-15 00:22:29.000000', 'temperatura', 661.0000, 'ºC'),
	(195338, 119, '2014-02-15 00:22:30.000000', 'temperatura', 535.0000, 'ºC'),
	(195339, 119, '2014-02-15 00:22:31.000000', 'temperatura', 695.0000, 'ºC'),
	(195340, 119, '2014-02-15 00:22:32.000000', 'temperatura', 668.0000, 'ºC'),
	(195341, 119, '2014-02-15 00:22:33.000000', 'temperatura', 57.0000, 'ºC'),
	(195342, 119, '2014-02-15 00:22:34.000000', 'temperatura', 679.0000, 'ºC'),
	(195343, 119, '2014-02-15 00:22:35.000000', 'temperatura', 827.0000, 'ºC'),
	(195344, 119, '2014-02-15 00:22:36.000000', 'temperatura', 896.0000, 'ºC'),
	(195345, 119, '2014-02-15 00:22:37.000000', 'temperatura', 802.0000, 'ºC'),
	(195346, 119, '2014-02-15 00:22:38.000000', 'temperatura', 123.0000, 'ºC'),
	(195347, 119, '2014-02-15 00:22:39.000000', 'temperatura', 609.0000, 'ºC'),
	(195348, 119, '2014-02-15 00:22:40.000000', 'temperatura', 276.0000, 'ºC'),
	(195349, 119, '2014-02-15 00:22:41.000000', 'temperatura', 753.0000, 'ºC'),
	(195350, 119, '2014-02-15 00:22:42.000000', 'temperatura', 538.0000, 'ºC'),
	(195351, 119, '2014-02-15 00:22:43.000000', 'temperatura', 431.0000, 'ºC'),
	(195352, 119, '2014-02-15 00:22:44.000000', 'temperatura', 542.0000, 'ºC'),
	(195353, 119, '2014-02-15 00:22:45.000000', 'temperatura', 218.0000, 'ºC'),
	(195354, 119, '2014-02-15 00:22:46.000000', 'temperatura', 666.0000, 'ºC'),
	(195355, 119, '2014-02-15 00:22:47.000000', 'temperatura', 274.0000, 'ºC'),
	(195356, 119, '2014-02-15 00:22:48.000000', 'temperatura', 575.0000, 'ºC'),
	(195357, 119, '2014-02-15 00:22:49.000000', 'temperatura', 852.0000, 'ºC'),
	(195358, 119, '2014-02-15 00:22:50.000000', 'temperatura', 137.0000, 'ºC'),
	(195359, 119, '2014-02-15 00:22:51.000000', 'temperatura', 527.0000, 'ºC'),
	(195360, 119, '2014-02-15 00:22:52.000000', 'temperatura', 1025.0000, 'ºC'),
	(195361, 119, '2014-02-15 00:22:53.000000', 'temperatura', 1144.0000, 'ºC'),
	(195362, 119, '2014-02-15 00:22:54.000000', 'temperatura', 245.0000, 'ºC'),
	(195363, 119, '2014-02-15 00:22:55.000000', 'temperatura', 196.0000, 'ºC'),
	(195364, 119, '2014-02-15 00:22:56.000000', 'temperatura', 245.0000, 'ºC'),
	(195365, 119, '2014-02-15 00:22:57.000000', 'temperatura', 638.0000, 'ºC'),
	(195366, 119, '2014-02-15 00:22:58.000000', 'temperatura', 57.0000, 'ºC'),
	(195367, 119, '2014-02-15 00:22:59.000000', 'temperatura', 769.0000, 'ºC'),
	(195368, 119, '2014-02-15 00:23:00.000000', 'temperatura', 74.0000, 'ºC'),
	(195369, 119, '2014-02-15 00:23:01.000000', 'temperatura', 465.0000, 'ºC'),
	(195370, 119, '2014-02-15 00:23:02.000000', 'temperatura', 902.0000, 'ºC'),
	(195371, 119, '2014-02-15 00:23:03.000000', 'temperatura', 717.0000, 'ºC'),
	(195372, 119, '2014-02-15 00:23:04.000000', 'temperatura', 878.0000, 'ºC'),
	(195373, 119, '2014-02-15 00:23:05.000000', 'temperatura', 1041.0000, 'ºC'),
	(195374, 119, '2014-02-15 00:23:06.000000', 'temperatura', 170.0000, 'ºC'),
	(195375, 119, '2014-02-15 00:23:07.000000', 'temperatura', 127.0000, 'ºC'),
	(195376, 119, '2014-02-15 00:23:08.000000', 'temperatura', 128.0000, 'ºC'),
	(195377, 119, '2014-02-15 00:23:09.000000', 'temperatura', 257.0000, 'ºC'),
	(195378, 119, '2014-02-15 00:23:10.000000', 'temperatura', 904.0000, 'ºC'),
	(195379, 119, '2014-02-15 00:23:11.000000', 'temperatura', 149.0000, 'ºC'),
	(195380, 119, '2014-02-15 00:23:12.000000', 'temperatura', 433.0000, 'ºC'),
	(195381, 119, '2014-02-15 00:23:13.000000', 'temperatura', 520.0000, 'ºC'),
	(195382, 119, '2014-02-15 00:23:14.000000', 'temperatura', 98.0000, 'ºC'),
	(195383, 119, '2014-02-15 00:23:15.000000', 'temperatura', 134.0000, 'ºC'),
	(195384, 119, '2014-02-15 00:23:16.000000', 'temperatura', 376.0000, 'ºC'),
	(195385, 119, '2014-02-15 00:23:17.000000', 'temperatura', 278.0000, 'ºC'),
	(195386, 119, '2014-02-15 00:23:18.000000', 'temperatura', 262.0000, 'ºC'),
	(195387, 119, '2014-02-15 00:23:19.000000', 'temperatura', 477.0000, 'ºC'),
	(195388, 119, '2014-02-15 00:23:20.000000', 'temperatura', 399.0000, 'ºC'),
	(195389, 119, '2014-02-15 00:23:21.000000', 'temperatura', 565.0000, 'ºC'),
	(195390, 119, '2014-02-15 00:23:22.000000', 'temperatura', 430.0000, 'ºC'),
	(195391, 119, '2014-02-15 00:23:23.000000', 'temperatura', 453.0000, 'ºC'),
	(195392, 119, '2014-02-15 00:23:24.000000', 'temperatura', 976.0000, 'ºC'),
	(195393, 119, '2014-02-15 00:23:25.000000', 'temperatura', 1120.0000, 'ºC'),
	(195394, 119, '2014-02-15 00:23:26.000000', 'temperatura', 276.0000, 'ºC'),
	(195395, 119, '2014-02-15 00:23:27.000000', 'temperatura', 418.0000, 'ºC'),
	(195396, 119, '2014-02-15 00:23:28.000000', 'temperatura', 64.0000, 'ºC'),
	(195397, 119, '2014-02-15 00:23:29.000000', 'temperatura', 267.0000, 'ºC'),
	(195398, 119, '2014-02-15 00:23:30.000000', 'temperatura', 1142.0000, 'ºC'),
	(195399, 119, '2014-02-15 00:23:31.000000', 'temperatura', 108.0000, 'ºC'),
	(195400, 119, '2014-02-15 00:23:32.000000', 'temperatura', 717.0000, 'ºC'),
	(195401, 119, '2014-02-15 00:23:33.000000', 'temperatura', 859.0000, 'ºC'),
	(195402, 119, '2014-02-15 00:23:34.000000', 'temperatura', 947.0000, 'ºC'),
	(195403, 119, '2014-02-15 00:23:35.000000', 'temperatura', 956.0000, 'ºC'),
	(195404, 119, '2014-02-15 00:23:36.000000', 'temperatura', 740.0000, 'ºC'),
	(195405, 119, '2014-02-15 00:23:37.000000', 'temperatura', 834.0000, 'ºC'),
	(195406, 119, '2014-02-15 00:23:38.000000', 'temperatura', 751.0000, 'ºC'),
	(195407, 119, '2014-02-15 00:23:39.000000', 'temperatura', 55.0000, 'ºC'),
	(195408, 119, '2014-02-15 00:23:40.000000', 'temperatura', 419.0000, 'ºC'),
	(195409, 119, '2014-02-15 00:23:41.000000', 'temperatura', 732.0000, 'ºC'),
	(195410, 119, '2014-02-15 00:23:42.000000', 'temperatura', 5.0000, 'ºC'),
	(195411, 119, '2014-02-15 00:23:43.000000', 'temperatura', 228.0000, 'ºC'),
	(195412, 119, '2014-02-15 00:23:44.000000', 'temperatura', 1124.0000, 'ºC'),
	(195413, 119, '2014-02-15 00:23:45.000000', 'temperatura', 139.0000, 'ºC'),
	(195414, 119, '2014-02-15 00:23:46.000000', 'temperatura', 922.0000, 'ºC'),
	(195415, 119, '2014-02-15 00:23:47.000000', 'temperatura', 595.0000, 'ºC'),
	(195416, 119, '2014-02-15 00:23:48.000000', 'temperatura', 208.0000, 'ºC'),
	(195417, 119, '2014-02-15 00:23:49.000000', 'temperatura', 456.0000, 'ºC'),
	(195418, 119, '2014-02-15 00:23:50.000000', 'temperatura', 455.0000, 'ºC'),
	(195419, 119, '2014-02-15 00:23:51.000000', 'temperatura', 907.0000, 'ºC'),
	(195420, 119, '2014-02-15 00:23:52.000000', 'temperatura', 770.0000, 'ºC'),
	(195421, 119, '2014-02-15 00:23:53.000000', 'temperatura', 1129.0000, 'ºC'),
	(195422, 119, '2014-02-15 00:23:54.000000', 'temperatura', 938.0000, 'ºC'),
	(195423, 119, '2014-02-15 00:23:55.000000', 'temperatura', 104.0000, 'ºC'),
	(195424, 119, '2014-02-15 00:23:56.000000', 'temperatura', 106.0000, 'ºC'),
	(195425, 119, '2014-02-15 00:23:57.000000', 'temperatura', 219.0000, 'ºC'),
	(195426, 119, '2014-02-15 00:23:58.000000', 'temperatura', 778.0000, 'ºC'),
	(195427, 119, '2014-02-15 00:23:59.000000', 'temperatura', 835.0000, 'ºC'),
	(195428, 119, '2014-02-15 00:24:00.000000', 'temperatura', 639.0000, 'ºC'),
	(195429, 119, '2014-02-15 00:24:01.000000', 'temperatura', 693.0000, 'ºC'),
	(195430, 119, '2014-02-15 00:24:02.000000', 'temperatura', 347.0000, 'ºC'),
	(195431, 119, '2014-02-15 00:24:03.000000', 'temperatura', 856.0000, 'ºC'),
	(195432, 119, '2014-02-15 00:24:04.000000', 'temperatura', 840.0000, 'ºC'),
	(195433, 119, '2014-02-15 00:24:05.000000', 'temperatura', 433.0000, 'ºC'),
	(195434, 119, '2014-02-15 00:24:06.000000', 'temperatura', 845.0000, 'ºC'),
	(195435, 119, '2014-02-15 00:24:07.000000', 'temperatura', 526.0000, 'ºC'),
	(195436, 119, '2014-02-15 00:24:08.000000', 'temperatura', 96.0000, 'ºC'),
	(195437, 119, '2014-02-15 00:24:09.000000', 'temperatura', 103.0000, 'ºC'),
	(195438, 119, '2014-02-15 00:24:10.000000', 'temperatura', 226.0000, 'ºC'),
	(195439, 119, '2014-02-15 00:24:11.000000', 'temperatura', 824.0000, 'ºC'),
	(195440, 119, '2014-02-15 00:24:12.000000', 'temperatura', 1039.0000, 'ºC'),
	(195441, 119, '2014-02-15 00:24:13.000000', 'temperatura', 326.0000, 'ºC'),
	(195442, 119, '2014-02-15 00:24:14.000000', 'temperatura', 912.0000, 'ºC'),
	(195443, 119, '2014-02-15 00:24:15.000000', 'temperatura', 1185.0000, 'ºC'),
	(195444, 119, '2014-02-15 00:24:16.000000', 'temperatura', 786.0000, 'ºC'),
	(195445, 119, '2014-02-15 00:24:17.000000', 'temperatura', 379.0000, 'ºC'),
	(195446, 119, '2014-02-15 00:24:18.000000', 'temperatura', 736.0000, 'ºC'),
	(195447, 119, '2014-02-15 00:24:19.000000', 'temperatura', 142.0000, 'ºC'),
	(195448, 119, '2014-02-15 00:24:20.000000', 'temperatura', 903.0000, 'ºC'),
	(195449, 119, '2014-02-15 00:24:21.000000', 'temperatura', 492.0000, 'ºC'),
	(195450, 119, '2014-02-15 00:24:22.000000', 'temperatura', 949.0000, 'ºC'),
	(195451, 119, '2014-02-15 00:24:23.000000', 'temperatura', 868.0000, 'ºC'),
	(195452, 119, '2014-02-15 00:24:24.000000', 'temperatura', 297.0000, 'ºC'),
	(195453, 119, '2014-02-15 00:24:25.000000', 'temperatura', 78.0000, 'ºC'),
	(195454, 119, '2014-02-15 00:24:26.000000', 'temperatura', 701.0000, 'ºC'),
	(195455, 119, '2014-02-15 00:24:27.000000', 'temperatura', 873.0000, 'ºC'),
	(195456, 119, '2014-02-15 00:24:28.000000', 'temperatura', 1059.0000, 'ºC'),
	(195457, 119, '2014-02-15 00:24:29.000000', 'temperatura', 280.0000, 'ºC'),
	(195458, 119, '2014-02-15 00:24:30.000000', 'temperatura', 621.0000, 'ºC'),
	(195459, 119, '2014-02-15 00:24:31.000000', 'temperatura', 1066.0000, 'ºC'),
	(195460, 119, '2014-02-15 00:24:32.000000', 'temperatura', 1067.0000, 'ºC'),
	(195461, 119, '2014-02-15 00:24:33.000000', 'temperatura', 938.0000, 'ºC'),
	(195462, 119, '2014-02-15 00:24:34.000000', 'temperatura', 287.0000, 'ºC'),
	(195463, 119, '2014-02-15 00:24:35.000000', 'temperatura', 1025.0000, 'ºC'),
	(195464, 119, '2014-02-15 00:24:36.000000', 'temperatura', 663.0000, 'ºC'),
	(195465, 119, '2014-02-15 00:24:37.000000', 'temperatura', 242.0000, 'ºC'),
	(195466, 119, '2014-02-15 00:24:38.000000', 'temperatura', 421.0000, 'ºC'),
	(195467, 119, '2014-02-15 00:24:39.000000', 'temperatura', 178.0000, 'ºC'),
	(195468, 119, '2014-02-15 00:24:40.000000', 'temperatura', 829.0000, 'ºC'),
	(195469, 119, '2014-02-15 00:24:41.000000', 'temperatura', 9.0000, 'ºC'),
	(195470, 119, '2014-02-15 00:24:42.000000', 'temperatura', 1161.0000, 'ºC'),
	(195471, 119, '2014-02-15 00:24:43.000000', 'temperatura', 979.0000, 'ºC'),
	(195472, 119, '2014-02-15 00:24:44.000000', 'temperatura', 210.0000, 'ºC'),
	(195473, 119, '2014-02-15 00:24:45.000000', 'temperatura', 516.0000, 'ºC'),
	(195474, 119, '2014-02-15 00:24:46.000000', 'temperatura', 749.0000, 'ºC'),
	(195475, 119, '2014-02-15 00:24:47.000000', 'temperatura', 996.0000, 'ºC'),
	(195476, 119, '2014-02-15 00:24:48.000000', 'temperatura', 336.0000, 'ºC'),
	(195477, 119, '2014-02-15 00:24:49.000000', 'temperatura', 1091.0000, 'ºC'),
	(195478, 119, '2014-02-15 00:24:50.000000', 'temperatura', 849.0000, 'ºC'),
	(195479, 119, '2014-02-15 00:24:51.000000', 'temperatura', 971.0000, 'ºC'),
	(195480, 119, '2014-02-15 00:24:52.000000', 'temperatura', 1107.0000, 'ºC'),
	(195481, 119, '2014-02-15 00:24:53.000000', 'temperatura', 225.0000, 'ºC'),
	(195482, 119, '2014-02-15 00:24:54.000000', 'temperatura', 204.0000, 'ºC'),
	(195483, 119, '2014-02-15 00:24:55.000000', 'temperatura', 346.0000, 'ºC'),
	(195484, 119, '2014-02-15 00:24:56.000000', 'temperatura', 1119.0000, 'ºC'),
	(195485, 119, '2014-02-15 00:24:57.000000', 'temperatura', 959.0000, 'ºC'),
	(195486, 119, '2014-02-15 00:24:58.000000', 'temperatura', 237.0000, 'ºC'),
	(195487, 119, '2014-02-15 00:24:59.000000', 'temperatura', 707.0000, 'ºC'),
	(195488, 119, '2014-02-15 00:25:00.000000', 'temperatura', 425.0000, 'ºC'),
	(195489, 119, '2014-02-15 00:25:01.000000', 'temperatura', 7.0000, 'ºC'),
	(195490, 119, '2014-02-15 00:25:02.000000', 'temperatura', 1159.0000, 'ºC'),
	(195491, 119, '2014-02-15 00:25:03.000000', 'temperatura', 974.0000, 'ºC'),
	(195492, 119, '2014-02-15 00:25:04.000000', 'temperatura', 195.0000, 'ºC'),
	(195493, 119, '2014-02-15 00:25:05.000000', 'temperatura', 452.0000, 'ºC'),
	(195494, 119, '2014-02-15 00:25:06.000000', 'temperatura', 477.0000, 'ºC'),
	(195495, 119, '2014-02-15 00:25:07.000000', 'temperatura', 1028.0000, 'ºC'),
	(195496, 119, '2014-02-15 00:25:08.000000', 'temperatura', 111.0000, 'ºC'),
	(195497, 119, '2014-02-15 00:25:09.000000', 'temperatura', 1070.0000, 'ºC'),
	(195498, 119, '2014-02-15 00:25:10.000000', 'temperatura', 219.0000, 'ºC'),
	(195499, 119, '2014-02-15 00:25:11.000000', 'temperatura', 286.0000, 'ºC'),
	(195500, 119, '2014-02-15 00:25:12.000000', 'temperatura', 773.0000, 'ºC'),
	(195501, 119, '2014-02-15 00:25:13.000000', 'temperatura', 606.0000, 'ºC'),
	(195502, 119, '2014-02-15 00:25:14.000000', 'temperatura', 711.0000, 'ºC'),
	(195503, 119, '2014-02-15 00:25:15.000000', 'temperatura', 537.0000, 'ºC'),
	(195504, 119, '2014-02-15 00:25:16.000000', 'temperatura', 555.0000, 'ºC'),
	(195505, 119, '2014-02-15 00:25:17.000000', 'temperatura', 1165.0000, 'ºC'),
	(195506, 119, '2014-02-15 00:25:18.000000', 'temperatura', 559.0000, 'ºC'),
	(195507, 119, '2014-02-15 00:25:19.000000', 'temperatura', 502.0000, 'ºC'),
	(195508, 119, '2014-02-15 00:25:20.000000', 'temperatura', 831.0000, 'ºC'),
	(195509, 119, '2014-02-15 00:25:21.000000', 'temperatura', 249.0000, 'ºC'),
	(195510, 119, '2014-02-15 00:25:22.000000', 'temperatura', 1154.0000, 'ºC'),
	(195511, 119, '2014-02-15 00:25:23.000000', 'temperatura', 223.0000, 'ºC'),
	(195512, 119, '2014-02-15 00:25:24.000000', 'temperatura', 52.0000, 'ºC'),
	(195513, 119, '2014-02-15 00:25:25.000000', 'temperatura', 794.0000, 'ºC'),
	(195514, 119, '2014-02-15 00:25:26.000000', 'temperatura', 215.0000, 'ºC'),
	(195515, 119, '2014-02-15 00:25:27.000000', 'temperatura', 1093.0000, 'ºC'),
	(195516, 119, '2014-02-15 00:25:28.000000', 'temperatura', 19.0000, 'ºC'),
	(195517, 119, '2014-02-15 00:25:29.000000', 'temperatura', 416.0000, 'ºC'),
	(195518, 119, '2014-02-15 00:25:30.000000', 'temperatura', 823.0000, 'ºC'),
	(195519, 119, '2014-02-15 00:25:31.000000', 'temperatura', 468.0000, 'ºC'),
	(195520, 119, '2014-02-15 00:25:32.000000', 'temperatura', 1072.0000, 'ºC'),
	(195521, 119, '2014-02-15 00:25:33.000000', 'temperatura', 356.0000, 'ºC'),
	(195522, 119, '2014-02-15 00:25:34.000000', 'temperatura', 963.0000, 'ºC'),
	(195523, 119, '2014-02-15 00:25:35.000000', 'temperatura', 147.0000, 'ºC'),
	(195524, 119, '2014-02-15 00:25:36.000000', 'temperatura', 249.0000, 'ºC'),
	(195525, 119, '2014-02-15 00:25:37.000000', 'temperatura', 802.0000, 'ºC'),
	(195526, 119, '2014-02-15 00:25:38.000000', 'temperatura', 867.0000, 'ºC'),
	(195527, 119, '2014-02-15 00:25:39.000000', 'temperatura', 726.0000, 'ºC'),
	(195528, 119, '2014-02-15 00:25:40.000000', 'temperatura', 1032.0000, 'ºC'),
	(195529, 119, '2014-02-15 00:25:41.000000', 'temperatura', 584.0000, 'ºC'),
	(195530, 119, '2014-02-15 00:25:42.000000', 'temperatura', 1021.0000, 'ºC'),
	(195531, 119, '2014-02-15 00:25:43.000000', 'temperatura', 954.0000, 'ºC'),
	(195532, 119, '2014-02-15 00:25:44.000000', 'temperatura', 510.0000, 'ºC'),
	(195533, 119, '2014-02-15 00:25:45.000000', 'temperatura', 887.0000, 'ºC'),
	(195534, 119, '2014-02-15 00:25:46.000000', 'temperatura', 506.0000, 'ºC'),
	(195535, 119, '2014-02-15 00:25:47.000000', 'temperatura', 1070.0000, 'ºC'),
	(195536, 119, '2014-02-15 00:25:48.000000', 'temperatura', 232.0000, 'ºC'),
	(195537, 119, '2014-02-15 00:25:49.000000', 'temperatura', 350.0000, 'ºC'),
	(195538, 119, '2014-02-15 00:25:50.000000', 'temperatura', 1053.0000, 'ºC'),
	(195539, 119, '2014-02-15 00:25:51.000000', 'temperatura', 617.0000, 'ºC'),
	(195540, 119, '2014-02-15 00:25:52.000000', 'temperatura', 1126.0000, 'ºC'),
	(195541, 119, '2014-02-15 00:25:53.000000', 'temperatura', 182.0000, 'ºC'),
	(195542, 119, '2014-02-15 00:25:54.000000', 'temperatura', 1130.0000, 'ºC'),
	(195543, 119, '2014-02-15 00:25:55.000000', 'temperatura', 307.0000, 'ºC'),
	(195544, 119, '2014-02-15 00:25:56.000000', 'temperatura', 542.0000, 'ºC'),
	(195545, 119, '2014-02-15 00:25:57.000000', 'temperatura', 592.0000, 'ºC'),
	(195546, 119, '2014-02-15 00:25:58.000000', 'temperatura', 133.0000, 'ºC'),
	(195547, 119, '2014-02-15 00:25:59.000000', 'temperatura', 92.0000, 'ºC'),
	(195548, 119, '2014-02-15 00:26:00.000000', 'temperatura', 60.0000, 'ºC'),
	(195549, 119, '2014-02-15 00:26:01.000000', 'temperatura', 23.0000, 'ºC'),
	(195550, 119, '2014-02-15 00:26:02.000000', 'temperatura', 1135.0000, 'ºC'),
	(195551, 119, '2014-02-15 00:26:03.000000', 'temperatura', 808.0000, 'ºC'),
	(195552, 119, '2014-02-15 00:26:04.000000', 'temperatura', 635.0000, 'ºC'),
	(195553, 119, '2014-02-15 00:26:05.000000', 'temperatura', 752.0000, 'ºC'),
	(195554, 119, '2014-02-15 00:26:06.000000', 'temperatura', 655.0000, 'ºC'),
	(195555, 119, '2014-02-15 00:26:07.000000', 'temperatura', 1018.0000, 'ºC'),
	(195556, 119, '2014-02-15 00:26:08.000000', 'temperatura', 727.0000, 'ºC'),
	(195557, 119, '2014-02-15 00:26:09.000000', 'temperatura', 581.0000, 'ºC'),
	(195558, 119, '2014-02-15 00:26:10.000000', 'temperatura', 725.0000, 'ºC'),
	(195559, 119, '2014-02-15 00:26:11.000000', 'temperatura', 683.0000, 'ºC'),
	(195560, 119, '2014-02-15 00:26:12.000000', 'temperatura', 38.0000, 'ºC'),
	(195561, 119, '2014-02-15 00:26:13.000000', 'temperatura', 543.0000, 'ºC'),
	(195562, 119, '2014-02-15 00:26:14.000000', 'temperatura', 203.0000, 'ºC'),
	(195563, 119, '2014-02-15 00:26:15.000000', 'temperatura', 584.0000, 'ºC'),
	(195564, 119, '2014-02-15 00:26:16.000000', 'temperatura', 1114.0000, 'ºC'),
	(195565, 119, '2014-02-15 00:26:17.000000', 'temperatura', 217.0000, 'ºC'),
	(195566, 119, '2014-02-15 00:26:18.000000', 'temperatura', 145.0000, 'ºC'),
	(195567, 119, '2014-02-15 00:26:19.000000', 'temperatura', 73.0000, 'ºC'),
	(195568, 119, '2014-02-15 00:26:20.000000', 'temperatura', 1132.0000, 'ºC'),
	(195569, 119, '2014-02-15 00:26:21.000000', 'temperatura', 642.0000, 'ºC'),
	(195570, 119, '2014-02-15 00:26:22.000000', 'temperatura', 1013.0000, 'ºC'),
	(195571, 119, '2014-02-15 00:26:23.000000', 'temperatura', 742.0000, 'ºC'),
	(195572, 119, '2014-02-15 00:26:24.000000', 'temperatura', 670.0000, 'ºC'),
	(195573, 119, '2014-02-15 00:26:25.000000', 'temperatura', 1124.0000, 'ºC'),
	(195574, 119, '2014-02-15 00:26:26.000000', 'temperatura', 11.0000, 'ºC'),
	(195575, 119, '2014-02-15 00:26:27.000000', 'temperatura', 283.0000, 'ºC'),
	(195576, 119, '2014-02-15 00:26:28.000000', 'temperatura', 183.0000, 'ºC'),
	(195577, 119, '2014-02-15 00:26:29.000000', 'temperatura', 65.0000, 'ºC'),
	(195578, 119, '2014-02-15 00:26:30.000000', 'temperatura', 978.0000, 'ºC'),
	(195579, 119, '2014-02-15 00:26:31.000000', 'temperatura', 1095.0000, 'ºC'),
	(195580, 119, '2014-02-15 00:26:32.000000', 'temperatura', 143.0000, 'ºC'),
	(195581, 119, '2014-02-15 00:26:33.000000', 'temperatura', 1028.0000, 'ºC'),
	(195582, 119, '2014-02-15 00:26:34.000000', 'temperatura', 1111.0000, 'ºC'),
	(195583, 119, '2014-02-15 00:26:35.000000', 'temperatura', 74.0000, 'ºC'),
	(195584, 119, '2014-02-15 00:26:36.000000', 'temperatura', 637.0000, 'ºC'),
	(195585, 119, '2014-02-15 00:26:37.000000', 'temperatura', 565.0000, 'ºC'),
	(195586, 119, '2014-02-15 00:26:38.000000', 'temperatura', 913.0000, 'ºC'),
	(195587, 119, '2014-02-15 00:26:39.000000', 'temperatura', 471.0000, 'ºC'),
	(195588, 119, '2014-02-15 00:26:40.000000', 'temperatura', 818.0000, 'ºC'),
	(195589, 119, '2014-02-15 00:26:41.000000', 'temperatura', 278.0000, 'ºC'),
	(195590, 119, '2014-02-15 00:26:42.000000', 'temperatura', 135.0000, 'ºC'),
	(195591, 119, '2014-02-15 00:26:43.000000', 'temperatura', 1043.0000, 'ºC'),
	(195592, 119, '2014-02-15 00:26:44.000000', 'temperatura', 9.0000, 'ºC'),
	(195593, 119, '2014-02-15 00:26:45.000000', 'temperatura', 519.0000, 'ºC'),
	(195594, 119, '2014-02-15 00:26:46.000000', 'temperatura', 167.0000, 'ºC'),
	(195595, 119, '2014-02-15 00:26:47.000000', 'temperatura', 479.0000, 'ºC'),
	(195596, 119, '2014-02-15 00:26:48.000000', 'temperatura', 696.0000, 'ºC'),
	(195597, 119, '2014-02-15 00:26:49.000000', 'temperatura', 842.0000, 'ºC'),
	(195598, 119, '2014-02-15 00:26:50.000000', 'temperatura', 921.0000, 'ºC'),
	(195599, 119, '2014-02-15 00:26:51.000000', 'temperatura', 882.0000, 'ºC'),
	(195600, 119, '2014-02-15 00:26:52.000000', 'temperatura', 446.0000, 'ºC'),
	(195601, 119, '2014-02-15 00:26:53.000000', 'temperatura', 783.0000, 'ºC'),
	(195602, 119, '2014-02-15 00:26:54.000000', 'temperatura', 180.0000, 'ºC'),
	(195603, 119, '2014-02-15 00:26:55.000000', 'temperatura', 951.0000, 'ºC'),
	(195604, 119, '2014-02-15 00:26:56.000000', 'temperatura', 615.0000, 'ºC'),
	(195605, 119, '2014-02-15 00:26:57.000000', 'temperatura', 222.0000, 'ºC'),
	(195606, 119, '2014-02-15 00:26:58.000000', 'temperatura', 467.0000, 'ºC'),
	(195607, 119, '2014-02-15 00:26:59.000000', 'temperatura', 467.0000, 'ºC'),
	(195608, 119, '2014-02-15 00:27:00.000000', 'temperatura', 935.0000, 'ºC'),
	(195609, 119, '2014-02-15 00:27:01.000000', 'temperatura', 875.0000, 'ºC'),
	(195610, 119, '2014-02-15 00:27:02.000000', 'temperatura', 369.0000, 'ºC'),
	(195611, 119, '2014-02-15 00:27:03.000000', 'temperatura', 421.0000, 'ºC'),
	(195612, 119, '2014-02-15 00:27:04.000000', 'temperatura', 999.0000, 'ºC'),
	(195613, 119, '2014-02-15 00:27:05.000000', 'temperatura', 135.0000, 'ºC'),
	(195614, 119, '2014-02-15 00:27:06.000000', 'temperatura', 75.0000, 'ºC'),
	(195615, 119, '2014-02-15 00:27:07.000000', 'temperatura', 1171.0000, 'ºC'),
	(195616, 119, '2014-02-15 00:27:08.000000', 'temperatura', 830.0000, 'ºC'),
	(195617, 119, '2014-02-15 00:27:09.000000', 'temperatura', 636.0000, 'ºC'),
	(195618, 119, '2014-02-15 00:27:10.000000', 'temperatura', 692.0000, 'ºC'),
	(195619, 119, '2014-02-15 00:27:11.000000', 'temperatura', 354.0000, 'ºC'),
	(195620, 119, '2014-02-15 00:27:12.000000', 'temperatura', 895.0000, 'ºC'),
	(195621, 119, '2014-02-15 00:27:13.000000', 'temperatura', 1013.0000, 'ºC'),
	(195622, 119, '2014-02-15 00:27:14.000000', 'temperatura', 1181.0000, 'ºC'),
	(195623, 119, '2014-02-15 00:27:15.000000', 'temperatura', 466.0000, 'ºC'),
	(195624, 119, '2014-02-15 00:27:16.000000', 'temperatura', 1187.0000, 'ºC'),
	(195625, 119, '2014-02-15 00:27:17.000000', 'temperatura', 939.0000, 'ºC'),
	(195626, 119, '2014-02-15 00:27:18.000000', 'temperatura', 1132.0000, 'ºC'),
	(195627, 119, '2014-02-15 00:27:19.000000', 'temperatura', 446.0000, 'ºC'),
	(195628, 119, '2014-02-15 00:27:20.000000', 'temperatura', 34.0000, 'ºC'),
	(195629, 119, '2014-02-15 00:27:21.000000', 'temperatura', 31.0000, 'ºC'),
	(195630, 119, '2014-02-15 00:27:22.000000', 'temperatura', 54.0000, 'ºC'),
	(195631, 119, '2014-02-15 00:27:23.000000', 'temperatura', 179.0000, 'ºC'),
	(195632, 119, '2014-02-15 00:27:24.000000', 'temperatura', 732.0000, 'ºC'),
	(195633, 119, '2014-02-15 00:27:25.000000', 'temperatura', 722.0000, 'ºC'),
	(195634, 119, '2014-02-15 00:27:26.000000', 'temperatura', 217.0000, 'ºC'),
	(195635, 119, '2014-02-15 00:27:27.000000', 'temperatura', 120.0000, 'ºC'),
	(195636, 119, '2014-02-15 00:27:28.000000', 'temperatura', 1149.0000, 'ºC'),
	(195637, 119, '2014-02-15 00:27:29.000000', 'temperatura', 587.0000, 'ºC'),
	(195638, 119, '2014-02-15 00:27:30.000000', 'temperatura', 685.0000, 'ºC'),
	(195639, 119, '2014-02-15 00:27:31.000000', 'temperatura', 467.0000, 'ºC'),
	(195640, 119, '2014-02-15 00:27:32.000000', 'temperatura', 280.0000, 'ºC'),
	(195641, 119, '2014-02-15 00:27:33.000000', 'temperatura', 1199.0000, 'ºC'),
	(195642, 119, '2014-02-15 00:27:34.000000', 'temperatura', 356.0000, 'ºC'),
	(195643, 119, '2014-02-15 00:27:35.000000', 'temperatura', 583.0000, 'ºC'),
	(195644, 119, '2014-02-15 00:27:36.000000', 'temperatura', 649.0000, 'ºC'),
	(195645, 119, '2014-02-15 00:27:37.000000', 'temperatura', 296.0000, 'ºC'),
	(195646, 119, '2014-02-15 00:27:38.000000', 'temperatura', 732.0000, 'ºC'),
	(195647, 119, '2014-02-15 00:27:39.000000', 'temperatura', 375.0000, 'ºC'),
	(195648, 119, '2014-02-15 00:27:40.000000', 'temperatura', 878.0000, 'ºC'),
	(195649, 119, '2014-02-15 00:27:41.000000', 'temperatura', 864.0000, 'ºC'),
	(195650, 119, '2014-02-15 00:27:42.000000', 'temperatura', 488.0000, 'ºC'),
	(195651, 119, '2014-02-15 00:27:43.000000', 'temperatura', 1047.0000, 'ºC'),
	(195652, 119, '2014-02-15 00:27:44.000000', 'temperatura', 173.0000, 'ºC'),
	(195653, 119, '2014-02-15 00:27:45.000000', 'temperatura', 125.0000, 'ºC'),
	(195654, 119, '2014-02-15 00:27:46.000000', 'temperatura', 106.0000, 'ºC'),
	(195655, 119, '2014-02-15 00:27:47.000000', 'temperatura', 153.0000, 'ºC'),
	(195656, 119, '2014-02-15 00:27:48.000000', 'temperatura', 451.0000, 'ºC'),
	(195657, 119, '2014-02-15 00:27:49.000000', 'temperatura', 595.0000, 'ºC'),
	(195658, 119, '2014-02-15 00:27:50.000000', 'temperatura', 421.0000, 'ºC'),
	(195659, 119, '2014-02-15 00:27:51.000000', 'temperatura', 321.0000, 'ºC'),
	(195660, 119, '2014-02-15 00:27:52.000000', 'temperatura', 344.0000, 'ºC'),
	(195661, 119, '2014-02-15 00:27:53.000000', 'temperatura', 757.0000, 'ºC'),
	(195662, 119, '2014-02-15 00:27:54.000000', 'temperatura', 353.0000, 'ºC'),
	(195663, 119, '2014-02-15 00:27:55.000000', 'temperatura', 693.0000, 'ºC'),
	(195664, 119, '2014-02-15 00:27:56.000000', 'temperatura', 6.0000, 'ºC'),
	(195665, 119, '2014-02-15 00:27:57.000000', 'temperatura', 354.0000, 'ºC'),
	(195666, 119, '2014-02-15 00:27:58.000000', 'temperatura', 550.0000, 'ºC'),
	(195667, 119, '2014-02-15 00:27:59.000000', 'temperatura', 490.0000, 'ºC'),
	(195668, 119, '2014-02-15 00:28:00.000000', 'temperatura', 799.0000, 'ºC'),
	(195669, 119, '2014-02-15 00:28:01.000000', 'temperatura', 124.0000, 'ºC'),
	(195670, 119, '2014-02-15 00:28:02.000000', 'temperatura', 626.0000, 'ºC'),
	(195671, 119, '2014-02-15 00:28:03.000000', 'temperatura', 359.0000, 'ºC'),
	(195672, 119, '2014-02-15 00:28:04.000000', 'temperatura', 1118.0000, 'ºC'),
	(195673, 119, '2014-02-15 00:28:05.000000', 'temperatura', 914.0000, 'ºC'),
	(195674, 119, '2014-02-15 00:28:06.000000', 'temperatura', 16.0000, 'ºC'),
	(195675, 119, '2014-02-15 00:28:07.000000', 'temperatura', 937.0000, 'ºC'),
	(195676, 119, '2014-02-15 00:28:08.000000', 'temperatura', 1037.0000, 'ºC'),
	(195677, 119, '2014-02-15 00:28:09.000000', 'temperatura', 1177.0000, 'ºC'),
	(195678, 119, '2014-02-15 00:28:10.000000', 'temperatura', 373.0000, 'ºC'),
	(195679, 119, '2014-02-15 00:28:11.000000', 'temperatura', 736.0000, 'ºC'),
	(195680, 119, '2014-02-15 00:28:12.000000', 'temperatura', 159.0000, 'ºC'),
	(195681, 119, '2014-02-15 00:28:13.000000', 'temperatura', 989.0000, 'ºC'),
	(195682, 119, '2014-02-15 00:28:14.000000', 'temperatura', 869.0000, 'ºC'),
	(195683, 119, '2014-02-15 00:28:15.000000', 'temperatura', 179.0000, 'ºC'),
	(195684, 119, '2014-02-15 00:28:16.000000', 'temperatura', 688.0000, 'ºC'),
	(195685, 119, '2014-02-15 00:28:17.000000', 'temperatura', 503.0000, 'ºC'),
	(195686, 119, '2014-02-15 00:28:18.000000', 'temperatura', 450.0000, 'ºC'),
	(195687, 119, '2014-02-15 00:28:19.000000', 'temperatura', 743.0000, 'ºC'),
	(195688, 119, '2014-02-15 00:28:20.000000', 'temperatura', 1164.0000, 'ºC'),
	(195689, 119, '2014-02-15 00:28:21.000000', 'temperatura', 1193.0000, 'ºC'),
	(195690, 119, '2014-02-15 00:28:22.000000', 'temperatura', 73.0000, 'ºC'),
	(195691, 119, '2014-02-15 00:28:23.000000', 'temperatura', 385.0000, 'ºC'),
	(195692, 119, '2014-02-15 00:28:24.000000', 'temperatura', 509.0000, 'ºC'),
	(195693, 119, '2014-02-15 00:28:25.000000', 'temperatura', 188.0000, 'ºC'),
	(195694, 119, '2014-02-15 00:28:26.000000', 'temperatura', 614.0000, 'ºC'),
	(195695, 119, '2014-02-15 00:28:27.000000', 'temperatura', 106.0000, 'ºC'),
	(195696, 119, '2014-02-15 00:28:28.000000', 'temperatura', 1090.0000, 'ºC'),
	(195697, 119, '2014-02-15 00:28:29.000000', 'temperatura', 333.0000, 'ºC'),
	(195698, 119, '2014-02-15 00:28:30.000000', 'temperatura', 793.0000, 'ºC'),
	(195699, 119, '2014-02-15 00:28:31.000000', 'temperatura', 566.0000, 'ºC'),
	(195700, 119, '2014-02-15 00:28:32.000000', 'temperatura', 454.0000, 'ºC'),
	(195701, 119, '2014-02-15 00:28:33.000000', 'temperatura', 570.0000, 'ºC'),
	(195702, 119, '2014-02-15 00:28:34.000000', 'temperatura', 290.0000, 'ºC'),
	(195703, 119, '2014-02-15 00:28:35.000000', 'temperatura', 940.0000, 'ºC'),
	(195704, 119, '2014-02-15 00:28:36.000000', 'temperatura', 230.0000, 'ºC'),
	(195705, 119, '2014-02-15 00:28:37.000000', 'temperatura', 730.0000, 'ºC'),
	(195706, 119, '2014-02-15 00:28:38.000000', 'temperatura', 562.0000, 'ºC'),
	(195707, 119, '2014-02-15 00:28:39.000000', 'temperatura', 618.0000, 'ºC'),
	(195708, 119, '2014-02-15 00:28:40.000000', 'temperatura', 207.0000, 'ºC'),
	(195709, 119, '2014-02-15 00:28:41.000000', 'temperatura', 380.0000, 'ºC'),
	(195710, 119, '2014-02-15 00:28:42.000000', 'temperatura', 79.0000, 'ºC'),
	(195711, 119, '2014-02-15 00:28:43.000000', 'temperatura', 458.0000, 'ºC'),
	(195712, 119, '2014-02-15 00:28:44.000000', 'temperatura', 851.0000, 'ºC'),
	(195713, 119, '2014-02-15 00:28:45.000000', 'temperatura', 484.0000, 'ºC'),
	(195714, 119, '2014-02-15 00:28:46.000000', 'temperatura', 1066.0000, 'ºC'),
	(195715, 119, '2014-02-15 00:28:47.000000', 'temperatura', 279.0000, 'ºC'),
	(195716, 119, '2014-02-15 00:28:48.000000', 'temperatura', 596.0000, 'ºC'),
	(195717, 119, '2014-02-15 00:28:49.000000', 'temperatura', 943.0000, 'ºC'),
	(195718, 119, '2014-02-15 00:28:50.000000', 'temperatura', 528.0000, 'ºC'),
	(195719, 119, '2014-02-15 00:28:51.000000', 'temperatura', 1011.0000, 'ºC'),
	(195720, 119, '2014-02-15 00:28:52.000000', 'temperatura', 1071.0000, 'ºC'),
	(195721, 119, '2014-02-15 00:28:53.000000', 'temperatura', 1122.0000, 'ºC'),
	(195722, 119, '2014-02-15 00:28:54.000000', 'temperatura', 1197.0000, 'ºC'),
	(195723, 119, '2014-02-15 00:28:55.000000', 'temperatura', 219.0000, 'ºC'),
	(195724, 119, '2014-02-15 00:28:56.000000', 'temperatura', 1104.0000, 'ºC'),
	(195725, 119, '2014-02-15 00:28:57.000000', 'temperatura', 63.0000, 'ºC'),
	(195726, 119, '2014-02-15 00:28:58.000000', 'temperatura', 605.0000, 'ºC'),
	(195727, 119, '2014-02-15 00:28:59.000000', 'temperatura', 436.0000, 'ºC'),
	(195728, 119, '2014-02-15 00:29:00.000000', 'temperatura', 367.0000, 'ºC'),
	(195729, 119, '2014-02-15 00:29:01.000000', 'temperatura', 526.0000, 'ºC'),
	(195730, 119, '2014-02-15 00:29:02.000000', 'temperatura', 331.0000, 'ºC'),
	(195731, 119, '2014-02-15 00:29:03.000000', 'temperatura', 77.0000, 'ºC'),
	(195732, 119, '2014-02-15 00:29:04.000000', 'temperatura', 594.0000, 'ºC'),
	(195733, 119, '2014-02-15 00:29:05.000000', 'temperatura', 337.0000, 'ºC'),
	(195734, 119, '2014-02-15 00:29:06.000000', 'temperatura', 1106.0000, 'ºC'),
	(195735, 119, '2014-02-15 00:29:07.000000', 'temperatura', 916.0000, 'ºC'),
	(195736, 119, '2014-02-15 00:29:08.000000', 'temperatura', 66.0000, 'ºC'),
	(195737, 119, '2014-02-15 00:29:09.000000', 'temperatura', 1181.0000, 'ºC'),
	(195738, 119, '2014-02-15 00:29:10.000000', 'temperatura', 906.0000, 'ºC'),
	(195739, 119, '2014-02-15 00:29:11.000000', 'temperatura', 988.0000, 'ºC'),
	(195740, 119, '2014-02-15 00:29:12.000000', 'temperatura', 1023.0000, 'ºC'),
	(195741, 119, '2014-02-15 00:29:13.000000', 'temperatura', 953.0000, 'ºC'),
	(195742, 119, '2014-02-15 00:29:14.000000', 'temperatura', 494.0000, 'ºC'),
	(195743, 119, '2014-02-15 00:29:15.000000', 'temperatura', 814.0000, 'ºC'),
	(195744, 119, '2014-02-15 00:29:16.000000', 'temperatura', 186.0000, 'ºC'),
	(195745, 119, '2014-02-15 00:29:17.000000', 'temperatura', 887.0000, 'ºC'),
	(195746, 119, '2014-02-15 00:29:18.000000', 'temperatura', 281.0000, 'ºC'),
	(195747, 119, '2014-02-15 00:29:19.000000', 'temperatura', 1143.0000, 'ºC'),
	(195748, 119, '2014-02-15 00:29:20.000000', 'temperatura', 73.0000, 'ºC'),
	(195749, 119, '2014-02-15 00:29:21.000000', 'temperatura', 537.0000, 'ºC'),
	(195750, 119, '2014-02-15 00:29:22.000000', 'temperatura', 64.0000, 'ºC'),
	(195751, 119, '2014-02-15 00:29:23.000000', 'temperatura', 1113.0000, 'ºC'),
	(195752, 119, '2014-02-15 00:29:24.000000', 'temperatura', 570.0000, 'ºC'),
	(195753, 119, '2014-02-15 00:29:25.000000', 'temperatura', 714.0000, 'ºC'),
	(195754, 119, '2014-02-15 00:29:26.000000', 'temperatura', 660.0000, 'ºC'),
	(195755, 119, '2014-02-15 00:29:27.000000', 'temperatura', 1157.0000, 'ºC'),
	(195756, 119, '2014-02-15 00:29:28.000000', 'temperatura', 207.0000, 'ºC'),
	(195757, 119, '2014-02-15 00:29:29.000000', 'temperatura', 1163.0000, 'ºC'),
	(195758, 119, '2014-02-15 00:29:30.000000', 'temperatura', 397.0000, 'ºC'),
	(195759, 119, '2014-02-15 00:29:31.000000', 'temperatura', 897.0000, 'ºC'),
	(195760, 119, '2014-02-15 00:29:32.000000', 'temperatura', 892.0000, 'ºC'),
	(195761, 119, '2014-02-15 00:29:33.000000', 'temperatura', 569.0000, 'ºC'),
	(195762, 119, '2014-02-15 00:29:34.000000', 'temperatura', 172.0000, 'ºC'),
	(195763, 119, '2014-02-15 00:29:35.000000', 'temperatura', 354.0000, 'ºC'),
	(195764, 119, '2014-02-15 00:29:36.000000', 'temperatura', 53.0000, 'ºC'),
	(195765, 119, '2014-02-15 00:29:37.000000', 'temperatura', 404.0000, 'ºC'),
	(195766, 119, '2014-02-15 00:29:38.000000', 'temperatura', 662.0000, 'ºC'),
	(195767, 119, '2014-02-15 00:29:39.000000', 'temperatura', 900.0000, 'ºC'),
	(195768, 119, '2014-02-15 00:29:40.000000', 'temperatura', 113.0000, 'ºC'),
	(195769, 119, '2014-02-15 00:29:41.000000', 'temperatura', 264.0000, 'ºC'),
	(195770, 119, '2014-02-15 00:29:42.000000', 'temperatura', 983.0000, 'ºC'),
	(195771, 119, '2014-02-15 00:29:43.000000', 'temperatura', 523.0000, 'ºC'),
	(195772, 119, '2014-02-15 00:29:44.000000', 'temperatura', 868.0000, 'ºC'),
	(195773, 119, '2014-02-15 00:29:45.000000', 'temperatura', 372.0000, 'ºC'),
	(195774, 119, '2014-02-15 00:29:46.000000', 'temperatura', 456.0000, 'ºC'),
	(195775, 119, '2014-02-15 00:29:47.000000', 'temperatura', 1164.0000, 'ºC'),
	(195776, 119, '2014-02-15 00:29:48.000000', 'temperatura', 855.0000, 'ºC'),
	(195777, 119, '2014-02-15 00:29:49.000000', 'temperatura', 780.0000, 'ºC'),
	(195778, 119, '2014-02-15 00:29:50.000000', 'temperatura', 139.0000, 'ºC'),
	(195779, 119, '2014-02-15 00:29:51.000000', 'temperatura', 753.0000, 'ºC'),
	(195780, 119, '2014-02-15 00:29:52.000000', 'temperatura', 947.0000, 'ºC'),
	(195781, 119, '2014-02-15 00:29:53.000000', 'temperatura', 80.0000, 'ºC'),
	(195782, 119, '2014-02-15 00:29:54.000000', 'temperatura', 1159.0000, 'ºC'),
	(195783, 119, '2014-02-15 00:29:55.000000', 'temperatura', 754.0000, 'ºC'),
	(195784, 119, '2014-02-15 00:29:56.000000', 'temperatura', 293.0000, 'ºC'),
	(195785, 119, '2014-02-15 00:29:57.000000', 'temperatura', 404.0000, 'ºC'),
	(195786, 119, '2014-02-15 00:29:58.000000', 'temperatura', 1141.0000, 'ºC'),
	(195787, 119, '2014-02-15 00:29:59.000000', 'temperatura', 894.0000, 'ºC'),
	(195788, 119, '2014-02-15 00:30:00.000000', 'temperatura', 1047.0000, 'ºC'),
	(195789, 119, '2014-02-15 00:30:01.000000', 'temperatura', 153.0000, 'ºC'),
	(195790, 119, '2014-02-15 00:30:02.000000', 'temperatura', 25.0000, 'ºC'),
	(195791, 119, '2014-02-15 00:30:03.000000', 'temperatura', 867.0000, 'ºC'),
	(195792, 119, '2014-02-15 00:30:04.000000', 'temperatura', 659.0000, 'ºC'),
	(195793, 119, '2014-02-15 00:30:05.000000', 'temperatura', 697.0000, 'ºC'),
	(195794, 119, '2014-02-15 00:30:06.000000', 'temperatura', 307.0000, 'ºC'),
	(195795, 119, '2014-02-15 00:30:07.000000', 'temperatura', 643.0000, 'ºC'),
	(195796, 119, '2014-02-15 00:30:08.000000', 'temperatura', 1098.0000, 'ºC'),
	(195797, 119, '2014-02-15 00:30:09.000000', 'temperatura', 1159.0000, 'ºC'),
	(195798, 119, '2014-02-15 00:30:10.000000', 'temperatura', 102.0000, 'ºC'),
	(195799, 119, '2014-02-15 00:30:11.000000', 'temperatura', 634.0000, 'ºC'),
	(195800, 119, '2014-02-15 00:30:12.000000', 'temperatura', 463.0000, 'ºC'),
	(195801, 119, '2014-02-15 00:30:13.000000', 'temperatura', 415.0000, 'ºC'),
	(195802, 119, '2014-02-15 00:30:14.000000', 'temperatura', 684.0000, 'ºC'),
	(195803, 119, '2014-02-15 00:30:15.000000', 'temperatura', 978.0000, 'ºC'),
	(195804, 119, '2014-02-15 00:30:16.000000', 'temperatura', 439.0000, 'ºC'),
	(195805, 119, '2014-02-15 00:30:17.000000', 'temperatura', 459.0000, 'ºC'),
	(195806, 119, '2014-02-15 00:30:18.000000', 'temperatura', 980.0000, 'ºC'),
	(195807, 119, '2014-02-15 00:30:19.000000', 'temperatura', 1122.0000, 'ºC'),
	(195808, 119, '2014-02-15 00:30:20.000000', 'temperatura', 272.0000, 'ºC'),
	(195809, 119, '2014-02-15 00:30:21.000000', 'temperatura', 392.0000, 'ºC'),
	(195810, 119, '2014-02-15 00:30:22.000000', 'temperatura', 1148.0000, 'ºC'),
	(195811, 119, '2014-02-15 00:30:23.000000', 'temperatura', 961.0000, 'ºC'),
	(195812, 119, '2014-02-15 00:30:24.000000', 'temperatura', 165.0000, 'ºC'),
	(195813, 119, '2014-02-15 00:30:25.000000', 'temperatura', 341.0000, 'ºC'),
	(195814, 119, '2014-02-15 00:30:26.000000', 'temperatura', 10.0000, 'ºC'),
	(195815, 119, '2014-02-15 00:30:27.000000', 'temperatura', 226.0000, 'ºC'),
	(195816, 119, '2014-02-15 00:30:28.000000', 'temperatura', 1103.0000, 'ºC'),
	(195817, 119, '2014-02-15 00:30:29.000000', 'temperatura', 36.0000, 'ºC'),
	(195818, 119, '2014-02-15 00:30:30.000000', 'temperatura', 470.0000, 'ºC'),
	(195819, 119, '2014-02-15 00:30:31.000000', 'temperatura', 1044.0000, 'ºC'),
	(195820, 119, '2014-02-15 00:30:32.000000', 'temperatura', 211.0000, 'ºC'),
	(195821, 119, '2014-02-15 00:30:33.000000', 'temperatura', 322.0000, 'ºC'),
	(195822, 119, '2014-02-15 00:30:34.000000', 'temperatura', 980.0000, 'ºC'),
	(195823, 119, '2014-02-15 00:30:35.000000', 'temperatura', 331.0000, 'ºC'),
	(195824, 119, '2014-02-15 00:30:36.000000', 'temperatura', 1118.0000, 'ºC'),
	(195825, 119, '2014-02-15 00:30:37.000000', 'temperatura', 996.0000, 'ºC'),
	(195826, 119, '2014-02-15 00:30:38.000000', 'temperatura', 428.0000, 'ºC'),
	(195827, 119, '2014-02-15 00:30:39.000000', 'temperatura', 352.0000, 'ºC'),
	(195828, 119, '2014-02-15 00:30:40.000000', 'temperatura', 475.0000, 'ºC'),
	(195829, 119, '2014-02-15 00:30:41.000000', 'temperatura', 123.0000, 'ºC'),
	(195830, 119, '2014-02-15 00:30:42.000000', 'temperatura', 387.0000, 'ºC'),
	(195831, 119, '2014-02-15 00:30:43.000000', 'temperatura', 368.0000, 'ºC'),
	(195832, 119, '2014-02-15 00:30:44.000000', 'temperatura', 681.0000, 'ºC'),
	(195833, 119, '2014-02-15 00:30:45.000000', 'temperatura', 1101.0000, 'ºC'),
	(195834, 119, '2014-02-15 00:30:46.000000', 'temperatura', 1063.0000, 'ºC'),
	(195835, 119, '2014-02-15 00:30:47.000000', 'temperatura', 810.0000, 'ºC'),
	(195836, 119, '2014-02-15 00:30:48.000000', 'temperatura', 865.0000, 'ºC'),
	(195837, 119, '2014-02-15 00:30:49.000000', 'temperatura', 694.0000, 'ºC'),
	(195838, 119, '2014-02-15 00:30:50.000000', 'temperatura', 874.0000, 'ºC'),
	(195839, 119, '2014-02-15 00:30:51.000000', 'temperatura', 1088.0000, 'ºC'),
	(195840, 119, '2014-02-15 00:30:52.000000', 'temperatura', 418.0000, 'ºC'),
	(195841, 119, '2014-02-15 00:30:53.000000', 'temperatura', 28.0000, 'ºC'),
	(195842, 119, '2014-02-15 00:30:54.000000', 'temperatura', 85.0000, 'ºC'),
	(195843, 119, '2014-02-15 00:30:55.000000', 'temperatura', 342.0000, 'ºC'),
	(195844, 119, '2014-02-15 00:30:56.000000', 'temperatura', 254.0000, 'ºC'),
	(195845, 119, '2014-02-15 00:30:57.000000', 'temperatura', 246.0000, 'ºC'),
	(195846, 119, '2014-02-15 00:30:58.000000', 'temperatura', 470.0000, 'ºC'),
	(195847, 119, '2014-02-15 00:30:59.000000', 'temperatura', 413.0000, 'ºC'),
	(195848, 119, '2014-02-15 00:31:00.000000', 'temperatura', 653.0000, 'ºC'),
	(195849, 119, '2014-02-15 00:31:01.000000', 'temperatura', 827.0000, 'ºC'),
	(195850, 119, '2014-02-15 00:31:02.000000', 'temperatura', 978.0000, 'ºC'),
	(195851, 119, '2014-02-15 00:31:03.000000', 'temperatura', 9.0000, 'ºC'),
	(195852, 119, '2014-02-15 00:31:04.000000', 'temperatura', 713.0000, 'ºC'),
	(195853, 119, '2014-02-15 00:31:05.000000', 'temperatura', 1138.0000, 'ºC'),
	(195854, 119, '2014-02-15 00:31:06.000000', 'temperatura', 1152.0000, 'ºC'),
	(195855, 119, '2014-02-15 00:31:07.000000', 'temperatura', 1146.0000, 'ºC'),
	(195856, 119, '2014-02-15 00:31:08.000000', 'temperatura', 1073.0000, 'ºC'),
	(195857, 119, '2014-02-15 00:31:09.000000', 'temperatura', 728.0000, 'ºC'),
	(195858, 119, '2014-02-15 00:31:10.000000', 'temperatura', 423.0000, 'ºC'),
	(195859, 119, '2014-02-15 00:31:11.000000', 'temperatura', 1129.0000, 'ºC'),
	(195860, 119, '2014-02-15 00:31:12.000000', 'temperatura', 776.0000, 'ºC'),
	(195861, 119, '2014-02-15 00:31:13.000000', 'temperatura', 493.0000, 'ºC'),
	(195862, 119, '2014-02-15 00:31:14.000000', 'temperatura', 139.0000, 'ºC'),
	(195863, 119, '2014-02-15 00:31:15.000000', 'temperatura', 415.0000, 'ºC'),
	(195864, 119, '2014-02-15 00:31:16.000000', 'temperatura', 459.0000, 'ºC'),
	(195865, 119, '2014-02-15 00:31:17.000000', 'temperatura', 1049.0000, 'ºC'),
	(195866, 119, '2014-02-15 00:31:18.000000', 'temperatura', 272.0000, 'ºC'),
	(195867, 119, '2014-02-15 00:31:19.000000', 'temperatura', 611.0000, 'ºC'),
	(195868, 119, '2014-02-15 00:31:20.000000', 'temperatura', 1040.0000, 'ºC'),
	(195869, 119, '2014-02-15 00:31:21.000000', 'temperatura', 968.0000, 'ºC'),
	(195870, 119, '2014-02-15 00:31:22.000000', 'temperatura', 522.0000, 'ºC'),
	(195871, 119, '2014-02-15 00:31:23.000000', 'temperatura', 904.0000, 'ºC'),
	(195872, 119, '2014-02-15 00:31:24.000000', 'temperatura', 556.0000, 'ºC'),
	(195873, 119, '2014-02-15 00:31:25.000000', 'temperatura', 69.0000, 'ºC'),
	(195874, 119, '2014-02-15 00:31:26.000000', 'temperatura', 1075.0000, 'ºC'),
	(195875, 119, '2014-02-15 00:31:27.000000', 'temperatura', 372.0000, 'ºC'),
	(195876, 119, '2014-02-15 00:31:28.000000', 'temperatura', 1033.0000, 'ºC'),
	(195877, 119, '2014-02-15 00:31:29.000000', 'temperatura', 450.0000, 'ºC'),
	(195878, 119, '2014-02-15 00:31:30.000000', 'temperatura', 351.0000, 'ºC'),
	(195879, 119, '2014-02-15 00:31:31.000000', 'temperatura', 407.0000, 'ºC'),
	(195880, 119, '2014-02-15 00:31:32.000000', 'temperatura', 982.0000, 'ºC'),
	(195881, 119, '2014-02-15 00:31:33.000000', 'temperatura', 91.0000, 'ºC'),
	(195882, 119, '2014-02-15 00:31:34.000000', 'temperatura', 1109.0000, 'ºC'),
	(195883, 119, '2014-02-15 00:31:35.000000', 'temperatura', 472.0000, 'ºC'),
	(195884, 119, '2014-02-15 00:31:36.000000', 'temperatura', 234.0000, 'ºC'),
	(195885, 119, '2014-02-15 00:31:37.000000', 'temperatura', 954.0000, 'ºC'),
	(195886, 119, '2014-02-15 00:31:38.000000', 'temperatura', 469.0000, 'ºC'),
	(195887, 119, '2014-02-15 00:31:39.000000', 'temperatura', 684.0000, 'ºC'),
	(195888, 119, '2014-02-15 00:31:40.000000', 'temperatura', 814.0000, 'ºC'),
	(195889, 119, '2014-02-15 00:31:41.000000', 'temperatura', 816.0000, 'ºC'),
	(195890, 119, '2014-02-15 00:31:42.000000', 'temperatura', 441.0000, 'ºC'),
	(195891, 119, '2014-02-15 00:31:43.000000', 'temperatura', 956.0000, 'ºC'),
	(195892, 119, '2014-02-15 00:31:44.000000', 'temperatura', 1058.0000, 'ºC'),
	(195893, 119, '2014-02-15 00:31:45.000000', 'temperatura', 23.0000, 'ºC'),
	(195894, 119, '2014-02-15 00:31:46.000000', 'temperatura', 540.0000, 'ºC'),
	(195895, 119, '2014-02-15 00:31:47.000000', 'temperatura', 234.0000, 'ºC'),
	(195896, 119, '2014-02-15 00:31:48.000000', 'temperatura', 750.0000, 'ºC'),
	(195897, 119, '2014-02-15 00:31:49.000000', 'temperatura', 649.0000, 'ºC'),
	(195898, 119, '2014-02-15 00:31:50.000000', 'temperatura', 997.0000, 'ºC'),
	(195899, 119, '2014-02-15 00:31:51.000000', 'temperatura', 636.0000, 'ºC'),
	(195900, 119, '2014-02-15 00:31:52.000000', 'temperatura', 192.0000, 'ºC'),
	(195901, 119, '2014-02-15 00:31:53.000000', 'temperatura', 253.0000, 'ºC'),
	(195902, 119, '2014-02-15 00:31:54.000000', 'temperatura', 687.0000, 'ºC'),
	(195903, 119, '2014-02-15 00:31:55.000000', 'temperatura', 276.0000, 'ºC'),
	(195904, 119, '2014-02-15 00:31:56.000000', 'temperatura', 522.0000, 'ºC'),
	(195905, 119, '2014-02-15 00:31:57.000000', 'temperatura', 582.0000, 'ºC'),
	(195906, 119, '2014-02-15 00:31:58.000000', 'temperatura', 146.0000, 'ºC'),
	(195907, 119, '2014-02-15 00:31:59.000000', 'temperatura', 184.0000, 'ºC'),
	(195908, 119, '2014-02-15 00:32:00.000000', 'temperatura', 482.0000, 'ºC'),
	(195909, 119, '2014-02-15 00:32:01.000000', 'temperatura', 660.0000, 'ºC'),
	(195910, 119, '2014-02-15 00:32:02.000000', 'temperatura', 652.0000, 'ºC'),
	(195911, 119, '2014-02-15 00:32:03.000000', 'temperatura', 81.0000, 'ºC'),
	(195912, 119, '2014-02-15 00:32:04.000000', 'temperatura', 849.0000, 'ºC'),
	(195913, 119, '2014-02-15 00:32:05.000000', 'temperatura', 403.0000, 'ºC'),
	(195914, 119, '2014-02-15 00:32:06.000000', 'temperatura', 669.0000, 'ºC'),
	(195915, 119, '2014-02-15 00:32:07.000000', 'temperatura', 935.0000, 'ºC'),
	(195916, 119, '2014-02-15 00:32:08.000000', 'temperatura', 270.0000, 'ºC'),
	(195917, 119, '2014-02-15 00:32:09.000000', 'temperatura', 947.0000, 'ºC'),
	(195918, 119, '2014-02-15 00:32:10.000000', 'temperatura', 325.0000, 'ºC'),
	(195919, 119, '2014-02-15 00:32:11.000000', 'temperatura', 1182.0000, 'ºC'),
	(195920, 119, '2014-02-15 00:32:12.000000', 'temperatura', 136.0000, 'ºC'),
	(195921, 119, '2014-02-15 00:32:13.000000', 'temperatura', 737.0000, 'ºC'),
	(195922, 119, '2014-02-15 00:32:14.000000', 'temperatura', 874.0000, 'ºC'),
	(195923, 119, '2014-02-15 00:32:15.000000', 'temperatura', 962.0000, 'ºC'),
	(195924, 119, '2014-02-15 00:32:16.000000', 'temperatura', 987.0000, 'ºC'),
	(195925, 119, '2014-02-15 00:32:17.000000', 'temperatura', 849.0000, 'ºC'),
	(195926, 119, '2014-02-15 00:32:18.000000', 'temperatura', 87.0000, 'ºC'),
	(195927, 119, '2014-02-15 00:32:19.000000', 'temperatura', 288.0000, 'ºC'),
	(195928, 119, '2014-02-15 00:32:20.000000', 'temperatura', 1180.0000, 'ºC'),
	(195929, 119, '2014-02-15 00:32:21.000000', 'temperatura', 236.0000, 'ºC'),
	(195930, 119, '2014-02-15 00:32:22.000000', 'temperatura', 39.0000, 'ºC'),
	(195931, 119, '2014-02-15 00:32:23.000000', 'temperatura', 688.0000, 'ºC'),
	(195932, 119, '2014-02-15 00:32:24.000000', 'temperatura', 922.0000, 'ºC'),
	(195933, 119, '2014-02-15 00:32:25.000000', 'temperatura', 147.0000, 'ºC'),
	(195934, 119, '2014-02-15 00:32:26.000000', 'temperatura', 370.0000, 'ºC'),
	(195935, 119, '2014-02-15 00:32:27.000000', 'temperatura', 209.0000, 'ºC'),
	(195936, 119, '2014-02-15 00:32:28.000000', 'temperatura', 1138.0000, 'ºC'),
	(195937, 119, '2014-02-15 00:32:29.000000', 'temperatura', 261.0000, 'ºC'),
	(195938, 119, '2014-02-15 00:32:30.000000', 'temperatura', 291.0000, 'ºC'),
	(195939, 119, '2014-02-15 00:32:31.000000', 'temperatura', 674.0000, 'ºC'),
	(195940, 119, '2014-02-15 00:32:32.000000', 'temperatura', 98.0000, 'ºC'),
	(195941, 119, '2014-02-15 00:32:33.000000', 'temperatura', 869.0000, 'ºC'),
	(195942, 119, '2014-02-15 00:32:34.000000', 'temperatura', 450.0000, 'ºC'),
	(195943, 119, '2014-02-15 00:32:35.000000', 'temperatura', 842.0000, 'ºC'),
	(195944, 119, '2014-02-15 00:32:36.000000', 'temperatura', 462.0000, 'ºC'),
	(195945, 119, '2014-02-15 00:32:37.000000', 'temperatura', 986.0000, 'ºC'),
	(195946, 119, '2014-02-15 00:32:38.000000', 'temperatura', 1143.0000, 'ºC'),
	(195947, 119, '2014-02-15 00:32:39.000000', 'temperatura', 360.0000, 'ºC'),
	(195948, 119, '2014-02-15 00:32:40.000000', 'temperatura', 768.0000, 'ºC'),
	(195949, 119, '2014-02-15 00:32:41.000000', 'temperatura', 364.0000, 'ºC'),
	(195950, 119, '2014-02-15 00:32:42.000000', 'temperatura', 714.0000, 'ºC'),
	(195951, 119, '2014-02-15 00:32:43.000000', 'temperatura', 81.0000, 'ºC'),
	(195952, 119, '2014-02-15 00:32:44.000000', 'temperatura', 663.0000, 'ºC'),
	(195953, 119, '2014-02-15 00:32:45.000000', 'temperatura', 674.0000, 'ºC'),
	(195954, 119, '2014-02-15 00:32:46.000000', 'temperatura', 180.0000, 'ºC'),
	(195955, 119, '2014-02-15 00:32:47.000000', 'temperatura', 78.0000, 'ºC'),
	(195956, 119, '2014-02-15 00:32:48.000000', 'temperatura', 1052.0000, 'ºC'),
	(195957, 119, '2014-02-15 00:32:49.000000', 'temperatura', 227.0000, 'ºC'),
	(195958, 119, '2014-02-15 00:32:50.000000', 'temperatura', 379.0000, 'ºC'),
	(195959, 119, '2014-02-15 00:32:51.000000', 'temperatura', 14.0000, 'ºC'),
	(195960, 119, '2014-02-15 00:32:52.000000', 'temperatura', 134.0000, 'ºC'),
	(195961, 119, '2014-02-15 00:32:53.000000', 'temperatura', 628.0000, 'ºC'),
	(195962, 119, '2014-02-15 00:32:54.000000', 'temperatura', 337.0000, 'ºC'),
	(195963, 119, '2014-02-15 00:32:55.000000', 'temperatura', 1002.0000, 'ºC'),
	(195964, 119, '2014-02-15 00:32:56.000000', 'temperatura', 402.0000, 'ºC'),
	(195965, 119, '2014-02-15 00:32:57.000000', 'temperatura', 203.0000, 'ºC'),
	(195966, 119, '2014-02-15 00:32:58.000000', 'temperatura', 1010.0000, 'ºC'),
	(195967, 119, '2014-02-15 00:32:59.000000', 'temperatura', 840.0000, 'ºC'),
	(195968, 119, '2014-02-15 00:33:00.000000', 'temperatura', 1170.0000, 'ºC'),
	(195969, 119, '2014-02-15 00:33:01.000000', 'temperatura', 932.0000, 'ºC'),
	(195970, 119, '2014-02-15 00:33:02.000000', 'temperatura', 1152.0000, 'ºC'),
	(195971, 119, '2014-02-15 00:33:03.000000', 'temperatura', 564.0000, 'ºC'),
	(195972, 119, '2014-02-15 00:33:04.000000', 'temperatura', 563.0000, 'ºC'),
	(195973, 119, '2014-02-15 00:33:05.000000', 'temperatura', 1123.0000, 'ºC'),
	(195974, 119, '2014-02-15 00:33:06.000000', 'temperatura', 328.0000, 'ºC'),
	(195975, 119, '2014-02-15 00:33:07.000000', 'temperatura', 672.0000, 'ºC'),
	(195976, 119, '2014-02-15 00:33:08.000000', 'temperatura', 1178.0000, 'ºC'),
	(195977, 119, '2014-02-15 00:33:09.000000', 'temperatura', 271.0000, 'ºC'),
	(195978, 119, '2014-02-15 00:33:10.000000', 'temperatura', 223.0000, 'ºC'),
	(195979, 119, '2014-02-15 00:33:11.000000', 'temperatura', 302.0000, 'ºC'),
	(195980, 119, '2014-02-15 00:33:12.000000', 'temperatura', 844.0000, 'ºC'),
	(195981, 119, '2014-02-15 00:33:13.000000', 'temperatura', 911.0000, 'ºC'),
	(195982, 119, '2014-02-15 00:33:14.000000', 'temperatura', 827.0000, 'ºC'),
	(195983, 119, '2014-02-15 00:33:15.000000', 'temperatura', 199.0000, 'ºC'),
	(195984, 119, '2014-02-15 00:33:16.000000', 'temperatura', 916.0000, 'ºC'),
	(195985, 119, '2014-02-15 00:33:17.000000', 'temperatura', 382.0000, 'ºC'),
	(195986, 119, '2014-02-15 00:33:18.000000', 'temperatura', 362.0000, 'ºC'),
	(195987, 119, '2014-02-15 00:33:19.000000', 'temperatura', 666.0000, 'ºC'),
	(195988, 119, '2014-02-15 00:33:20.000000', 'temperatura', 1046.0000, 'ºC'),
	(195989, 119, '2014-02-15 00:33:21.000000', 'temperatura', 830.0000, 'ºC'),
	(195990, 119, '2014-02-15 00:33:22.000000', 'temperatura', 1014.0000, 'ºC'),
	(195991, 119, '2014-02-15 00:33:23.000000', 'temperatura', 181.0000, 'ºC'),
	(195992, 119, '2014-02-15 00:33:24.000000', 'temperatura', 264.0000, 'ºC'),
	(195993, 119, '2014-02-15 00:33:25.000000', 'temperatura', 777.0000, 'ºC'),
	(195994, 119, '2014-02-15 00:33:26.000000', 'temperatura', 695.0000, 'ºC'),
	(195995, 119, '2014-02-15 00:33:27.000000', 'temperatura', 1145.0000, 'ºC'),
	(195996, 119, '2014-02-15 00:33:28.000000', 'temperatura', 38.0000, 'ºC'),
	(195997, 119, '2014-02-15 00:33:29.000000', 'temperatura', 356.0000, 'ºC'),
	(195998, 119, '2014-02-15 00:33:30.000000', 'temperatura', 467.0000, 'ºC'),
	(195999, 119, '2014-02-15 00:33:31.000000', 'temperatura', 66.0000, 'ºC'),
	(196000, 119, '2014-02-15 00:33:32.000000', 'temperatura', 132.0000, 'ºC'),
	(196001, 119, '2014-02-15 00:33:33.000000', 'temperatura', 462.0000, 'ºC'),
	(196002, 119, '2014-02-15 00:33:34.000000', 'temperatura', 715.0000, 'ºC'),
	(196003, 119, '2014-02-15 00:33:35.000000', 'temperatura', 988.0000, 'ºC'),
	(196004, 119, '2014-02-15 00:33:36.000000', 'temperatura', 394.0000, 'ºC'),
	(196005, 119, '2014-02-15 00:33:37.000000', 'temperatura', 209.0000, 'ºC'),
	(196006, 119, '2014-02-15 00:33:38.000000', 'temperatura', 1063.0000, 'ºC'),
	(196007, 119, '2014-02-15 00:33:39.000000', 'temperatura', 1090.0000, 'ºC'),
	(196008, 119, '2014-02-15 00:33:40.000000', 'temperatura', 1061.0000, 'ºC'),
	(196009, 119, '2014-02-15 00:33:41.000000', 'temperatura', 837.0000, 'ºC'),
	(196010, 119, '2014-02-15 00:33:42.000000', 'temperatura', 1002.0000, 'ºC'),
	(196011, 119, '2014-02-15 00:33:43.000000', 'temperatura', 97.0000, 'ºC'),
	(196012, 119, '2014-02-15 00:33:44.000000', 'temperatura', 1081.0000, 'ºC'),
	(196013, 119, '2014-02-15 00:33:45.000000', 'temperatura', 314.0000, 'ºC'),
	(196014, 119, '2014-02-15 00:33:46.000000', 'temperatura', 728.0000, 'ºC'),
	(196015, 119, '2014-02-15 00:33:47.000000', 'temperatura', 300.0000, 'ºC'),
	(196016, 119, '2014-02-15 00:33:48.000000', 'temperatura', 517.0000, 'ºC'),
	(196017, 119, '2014-02-15 00:33:49.000000', 'temperatura', 484.0000, 'ºC'),
	(196018, 119, '2014-02-15 00:33:50.000000', 'temperatura', 868.0000, 'ºC'),
	(196019, 119, '2014-02-15 00:33:51.000000', 'temperatura', 488.0000, 'ºC'),
	(196020, 119, '2014-02-15 00:33:52.000000', 'temperatura', 1039.0000, 'ºC'),
	(196021, 119, '2014-02-15 00:33:53.000000', 'temperatura', 128.0000, 'ºC'),
	(196022, 119, '2014-02-15 00:33:54.000000', 'temperatura', 1127.0000, 'ºC'),
	(196023, 119, '2014-02-15 00:33:55.000000', 'temperatura', 451.0000, 'ºC'),
	(196024, 119, '2014-02-15 00:33:56.000000', 'temperatura', 76.0000, 'ºC'),
	(196025, 119, '2014-02-15 00:33:57.000000', 'temperatura', 224.0000, 'ºC'),
	(196026, 119, '2014-02-15 00:33:58.000000', 'temperatura', 894.0000, 'ºC'),
	(196027, 119, '2014-02-15 00:33:59.000000', 'temperatura', 199.0000, 'ºC'),
	(196028, 119, '2014-02-15 00:34:00.000000', 'temperatura', 714.0000, 'ºC'),
	(196029, 119, '2014-02-15 00:34:01.000000', 'temperatura', 575.0000, 'ºC'),
	(196030, 119, '2014-02-15 00:34:02.000000', 'temperatura', 731.0000, 'ºC'),
	(196031, 119, '2014-02-15 00:34:03.000000', 'temperatura', 732.0000, 'ºC'),
	(196032, 119, '2014-02-15 00:34:04.000000', 'temperatura', 267.0000, 'ºC'),
	(196033, 119, '2014-02-15 00:34:05.000000', 'temperatura', 337.0000, 'ºC'),
	(196034, 119, '2014-02-15 00:34:06.000000', 'temperatura', 888.0000, 'ºC'),
	(196035, 119, '2014-02-15 00:34:07.000000', 'temperatura', 1029.0000, 'ºC'),
	(196036, 119, '2014-02-15 00:34:08.000000', 'temperatura', 81.0000, 'ºC'),
	(196037, 119, '2014-02-15 00:34:09.000000', 'temperatura', 919.0000, 'ºC'),
	(196038, 119, '2014-02-15 00:34:10.000000', 'temperatura', 751.0000, 'ºC'),
	(196039, 119, '2014-02-15 00:34:11.000000', 'temperatura', 998.0000, 'ºC'),
	(196040, 119, '2014-02-15 00:34:12.000000', 'temperatura', 340.0000, 'ºC'),
	(196041, 119, '2014-02-15 00:34:13.000000', 'temperatura', 1104.0000, 'ºC'),
	(196042, 119, '2014-02-15 00:34:14.000000', 'temperatura', 901.0000, 'ºC'),
	(196043, 119, '2014-02-15 00:34:15.000000', 'temperatura', 1192.0000, 'ºC'),
	(196044, 119, '2014-02-15 00:34:16.000000', 'temperatura', 859.0000, 'ºC'),
	(196045, 119, '2014-02-15 00:34:17.000000', 'temperatura', 720.0000, 'ºC'),
	(196046, 119, '2014-02-15 00:34:18.000000', 'temperatura', 1023.0000, 'ºC'),
	(196047, 119, '2014-02-15 00:34:19.000000', 'temperatura', 555.0000, 'ºC'),
	(196048, 119, '2014-02-15 00:34:20.000000', 'temperatura', 909.0000, 'ºC'),
	(196049, 119, '2014-02-15 00:34:21.000000', 'temperatura', 478.0000, 'ºC'),
	(196050, 119, '2014-02-15 00:34:22.000000', 'temperatura', 865.0000, 'ºC'),
	(196051, 119, '2014-02-15 00:34:23.000000', 'temperatura', 492.0000, 'ºC'),
	(196052, 119, '2014-02-15 00:34:24.000000', 'temperatura', 1065.0000, 'ºC'),
	(196053, 119, '2014-02-15 00:34:25.000000', 'temperatura', 249.0000, 'ºC'),
	(196054, 119, '2014-02-15 00:34:26.000000', 'temperatura', 452.0000, 'ºC'),
	(196055, 119, '2014-02-15 00:34:27.000000', 'temperatura', 312.0000, 'ºC'),
	(196056, 119, '2014-02-15 00:34:28.000000', 'temperatura', 203.0000, 'ºC'),
	(196057, 119, '2014-02-15 00:34:29.000000', 'temperatura', 80.0000, 'ºC'),
	(196058, 119, '2014-02-15 00:34:30.000000', 'temperatura', 993.0000, 'ºC'),
	(196059, 119, '2014-02-15 00:34:31.000000', 'temperatura', 1127.0000, 'ºC'),
	(196060, 119, '2014-02-15 00:34:32.000000', 'temperatura', 255.0000, 'ºC'),
	(196061, 119, '2014-02-15 00:34:33.000000', 'temperatura', 294.0000, 'ºC'),
	(196062, 119, '2014-02-15 00:34:34.000000', 'temperatura', 705.0000, 'ºC'),
	(196063, 119, '2014-02-15 00:34:35.000000', 'temperatura', 246.0000, 'ºC'),
	(196064, 119, '2014-02-15 00:34:36.000000', 'temperatura', 313.0000, 'ºC'),
	(196065, 119, '2014-02-15 00:34:37.000000', 'temperatura', 830.0000, 'ºC'),
	(196066, 119, '2014-02-15 00:34:38.000000', 'temperatura', 809.0000, 'ºC'),
	(196067, 119, '2014-02-15 00:34:39.000000', 'temperatura', 358.0000, 'ºC'),
	(196068, 119, '2014-02-15 00:34:40.000000', 'temperatura', 564.0000, 'ºC'),
	(196069, 119, '2014-02-15 00:34:41.000000', 'temperatura', 545.0000, 'ºC'),
	(196070, 119, '2014-02-15 00:34:42.000000', 'temperatura', 1035.0000, 'ºC'),
	(196071, 119, '2014-02-15 00:34:43.000000', 'temperatura', 1141.0000, 'ºC'),
	(196072, 119, '2014-02-15 00:34:44.000000', 'temperatura', 198.0000, 'ºC'),
	(196073, 119, '2014-02-15 00:34:45.000000', 'temperatura', 1169.0000, 'ºC'),
	(196074, 119, '2014-02-15 00:34:46.000000', 'temperatura', 452.0000, 'ºC'),
	(196075, 119, '2014-02-15 00:34:47.000000', 'temperatura', 1151.0000, 'ºC'),
	(196076, 119, '2014-02-15 00:34:48.000000', 'temperatura', 802.0000, 'ºC'),
	(196077, 119, '2014-02-15 00:34:49.000000', 'temperatura', 557.0000, 'ºC'),
	(196078, 119, '2014-02-15 00:34:50.000000', 'temperatura', 380.0000, 'ºC'),
	(196079, 119, '2014-02-15 00:34:51.000000', 'temperatura', 230.0000, 'ºC'),
	(196080, 119, '2014-02-15 00:34:52.000000', 'temperatura', 8.0000, 'ºC'),
	(196081, 119, '2014-02-15 00:34:53.000000', 'temperatura', 552.0000, 'ºC'),
	(196082, 119, '2014-02-15 00:34:54.000000', 'temperatura', 336.0000, 'ºC'),
	(196083, 119, '2014-02-15 00:34:55.000000', 'temperatura', 27.0000, 'ºC'),
	(196084, 119, '2014-02-15 00:34:56.000000', 'temperatura', 324.0000, 'ºC'),
	(196085, 119, '2014-02-15 00:34:57.000000', 'temperatura', 341.0000, 'ºC'),
	(196086, 119, '2014-02-15 00:34:58.000000', 'temperatura', 732.0000, 'ºC'),
	(196087, 119, '2014-02-15 00:34:59.000000', 'temperatura', 240.0000, 'ºC'),
	(196088, 119, '2014-02-15 00:35:00.000000', 'temperatura', 202.0000, 'ºC'),
	(196089, 119, '2014-02-15 00:35:01.000000', 'temperatura', 293.0000, 'ºC'),
	(196090, 119, '2014-02-15 00:35:02.000000', 'temperatura', 857.0000, 'ºC'),
	(196091, 119, '2014-02-15 00:35:03.000000', 'temperatura', 1008.0000, 'ºC'),
	(196092, 119, '2014-02-15 00:35:04.000000', 'temperatura', 69.0000, 'ºC'),
	(196093, 119, '2014-02-15 00:35:05.000000', 'temperatura', 923.0000, 'ºC'),
	(196094, 119, '2014-02-15 00:35:06.000000', 'temperatura', 808.0000, 'ºC'),
	(196095, 119, '2014-02-15 00:35:07.000000', 'temperatura', 69.0000, 'ºC'),
	(196096, 119, '2014-02-15 00:35:08.000000', 'temperatura', 324.0000, 'ºC'),
	(196097, 119, '2014-02-15 00:35:09.000000', 'temperatura', 212.0000, 'ºC'),
	(196098, 119, '2014-02-15 00:35:10.000000', 'temperatura', 88.0000, 'ºC'),
	(196099, 119, '2014-02-15 00:35:11.000000', 'temperatura', 1006.0000, 'ºC'),
	(196100, 119, '2014-02-15 00:35:12.000000', 'temperatura', 1166.0000, 'ºC'),
	(196101, 119, '2014-02-15 00:35:13.000000', 'temperatura', 414.0000, 'ºC'),
	(196102, 119, '2014-02-15 00:35:14.000000', 'temperatura', 971.0000, 'ºC'),
	(196103, 119, '2014-02-15 00:35:15.000000', 'temperatura', 15.0000, 'ºC'),
	(196104, 119, '2014-02-15 00:35:16.000000', 'temperatura', 761.0000, 'ºC'),
	(196105, 119, '2014-02-15 00:35:17.000000', 'temperatura', 160.0000, 'ºC'),
	(196106, 119, '2014-02-15 00:35:18.000000', 'temperatura', 920.0000, 'ºC'),
	(196107, 119, '2014-02-15 00:35:19.000000', 'temperatura', 521.0000, 'ºC'),
	(196108, 119, '2014-02-15 00:35:20.000000', 'temperatura', 1042.0000, 'ºC'),
	(196109, 119, '2014-02-15 00:35:21.000000', 'temperatura', 50.0000, 'ºC'),
	(196110, 119, '2014-02-15 00:35:22.000000', 'temperatura', 725.0000, 'ºC'),
	(196111, 119, '2014-02-15 00:35:23.000000', 'temperatura', 1077.0000, 'ºC'),
	(196112, 119, '2014-02-15 00:35:24.000000', 'temperatura', 807.0000, 'ºC'),
	(196113, 119, '2014-02-15 00:35:25.000000', 'temperatura', 807.0000, 'ºC'),
	(196114, 119, '2014-02-15 00:35:26.000000', 'temperatura', 412.0000, 'ºC'),
	(196115, 119, '2014-02-15 00:35:27.000000', 'temperatura', 841.0000, 'ºC'),
	(196116, 119, '2014-02-15 00:35:28.000000', 'temperatura', 570.0000, 'ºC'),
	(196117, 119, '2014-02-15 00:35:29.000000', 'temperatura', 327.0000, 'ºC'),
	(196118, 119, '2014-02-15 00:35:30.000000', 'temperatura', 1127.0000, 'ºC'),
	(196119, 119, '2014-02-15 00:35:31.000000', 'temperatura', 1055.0000, 'ºC'),
	(196120, 119, '2014-02-15 00:35:32.000000', 'temperatura', 691.0000, 'ºC'),
	(196121, 119, '2014-02-15 00:35:33.000000', 'temperatura', 294.0000, 'ºC'),
	(196122, 119, '2014-02-15 00:35:34.000000', 'temperatura', 594.0000, 'ºC'),
	(196123, 119, '2014-02-15 00:35:35.000000', 'temperatura', 891.0000, 'ºC'),
	(196124, 119, '2014-02-15 00:35:36.000000', 'temperatura', 274.0000, 'ºC'),
	(196125, 119, '2014-02-15 00:35:37.000000', 'temperatura', 1095.0000, 'ºC'),
	(196126, 119, '2014-02-15 00:35:38.000000', 'temperatura', 1055.0000, 'ºC'),
	(196127, 119, '2014-02-15 00:35:39.000000', 'temperatura', 789.0000, 'ºC'),
	(196128, 119, '2014-02-15 00:35:40.000000', 'temperatura', 780.0000, 'ºC'),
	(196129, 119, '2014-02-15 00:35:41.000000', 'temperatura', 333.0000, 'ºC'),
	(196130, 119, '2014-02-15 00:35:42.000000', 'temperatura', 528.0000, 'ºC'),
	(196131, 119, '2014-02-15 00:35:43.000000', 'temperatura', 438.0000, 'ºC'),
	(196132, 119, '2014-02-15 00:35:44.000000', 'temperatura', 610.0000, 'ºC'),
	(196133, 119, '2014-02-15 00:35:45.000000', 'temperatura', 534.0000, 'ºC'),
	(196134, 119, '2014-02-15 00:35:46.000000', 'temperatura', 842.0000, 'ºC'),
	(196135, 119, '2014-02-15 00:35:47.000000', 'temperatura', 209.0000, 'ºC'),
	(196136, 119, '2014-02-15 00:35:48.000000', 'temperatura', 920.0000, 'ºC'),
	(196137, 119, '2014-02-15 00:35:49.000000', 'temperatura', 371.0000, 'ºC'),
	(196138, 119, '2014-02-15 00:35:50.000000', 'temperatura', 295.0000, 'ºC'),
	(196139, 119, '2014-02-15 00:35:51.000000', 'temperatura', 364.0000, 'ºC'),
	(196140, 119, '2014-02-15 00:35:52.000000', 'temperatura', 935.0000, 'ºC'),
	(196141, 119, '2014-02-15 00:35:53.000000', 'temperatura', 1185.0000, 'ºC'),
	(196142, 119, '2014-02-15 00:35:54.000000', 'temperatura', 719.0000, 'ºC'),
	(196143, 119, '2014-02-15 00:35:55.000000', 'temperatura', 41.0000, 'ºC'),
	(196144, 119, '2014-02-15 00:35:56.000000', 'temperatura', 450.0000, 'ºC'),
	(196145, 119, '2014-02-15 00:35:57.000000', 'temperatura', 925.0000, 'ºC'),
	(196146, 119, '2014-02-15 00:35:58.000000', 'temperatura', 877.0000, 'ºC'),
	(196147, 119, '2014-02-15 00:35:59.000000', 'temperatura', 409.0000, 'ºC'),
	(196148, 119, '2014-02-15 00:36:00.000000', 'temperatura', 617.0000, 'ºC'),
	(196149, 119, '2014-02-15 00:36:01.000000', 'temperatura', 656.0000, 'ºC'),
	(196150, 119, '2014-02-15 00:36:02.000000', 'temperatura', 232.0000, 'ºC'),
	(196151, 119, '2014-02-15 00:36:03.000000', 'temperatura', 389.0000, 'ºC'),
	(196152, 119, '2014-02-15 00:36:04.000000', 'temperatura', 53.0000, 'ºC'),
	(196153, 119, '2014-02-15 00:36:05.000000', 'temperatura', 296.0000, 'ºC'),
	(196154, 119, '2014-02-15 00:36:06.000000', 'temperatura', 120.0000, 'ºC'),
	(196155, 119, '2014-02-15 00:36:07.000000', 'temperatura', 916.0000, 'ºC'),
	(196156, 119, '2014-02-15 00:36:08.000000', 'temperatura', 618.0000, 'ºC'),
	(196157, 119, '2014-02-15 00:36:09.000000', 'temperatura', 345.0000, 'ºC'),
	(196158, 119, '2014-02-15 00:36:10.000000', 'temperatura', 1070.0000, 'ºC'),
	(196159, 119, '2014-02-15 00:36:11.000000', 'temperatura', 717.0000, 'ºC'),
	(196160, 119, '2014-02-15 00:36:12.000000', 'temperatura', 373.0000, 'ºC'),
	(196161, 119, '2014-02-15 00:36:13.000000', 'temperatura', 916.0000, 'ºC'),
	(196162, 119, '2014-02-15 00:36:14.000000', 'temperatura', 1060.0000, 'ºC'),
	(196163, 119, '2014-02-15 00:36:15.000000', 'temperatura', 153.0000, 'ºC'),
	(196164, 119, '2014-02-15 00:36:16.000000', 'temperatura', 1186.0000, 'ºC'),
	(196165, 119, '2014-02-15 00:36:17.000000', 'temperatura', 671.0000, 'ºC'),
	(196166, 119, '2014-02-15 00:36:18.000000', 'temperatura', 998.0000, 'ºC'),
	(196167, 119, '2014-02-15 00:36:19.000000', 'temperatura', 578.0000, 'ºC'),
	(196168, 119, '2014-02-15 00:36:20.000000', 'temperatura', 1096.0000, 'ºC'),
	(196169, 119, '2014-02-15 00:36:21.000000', 'temperatura', 148.0000, 'ºC'),
	(196170, 119, '2014-02-15 00:36:22.000000', 'temperatura', 1053.0000, 'ºC'),
	(196171, 119, '2014-02-15 00:36:23.000000', 'temperatura', 21.0000, 'ºC'),
	(196172, 119, '2014-02-15 00:36:24.000000', 'temperatura', 546.0000, 'ºC'),
	(196173, 119, '2014-02-15 00:36:25.000000', 'temperatura', 269.0000, 'ºC'),
	(196174, 119, '2014-02-15 00:36:26.000000', 'temperatura', 905.0000, 'ºC'),
	(196175, 119, '2014-02-15 00:36:27.000000', 'temperatura', 119.0000, 'ºC'),
	(196176, 119, '2014-02-15 00:36:28.000000', 'temperatura', 282.0000, 'ºC'),
	(196177, 119, '2014-02-15 00:36:29.000000', 'temperatura', 1052.0000, 'ºC'),
	(196178, 119, '2014-02-15 00:36:30.000000', 'temperatura', 813.0000, 'ºC'),
	(196179, 119, '2014-02-15 00:36:31.000000', 'temperatura', 912.0000, 'ºC'),
	(196180, 119, '2014-02-15 00:36:32.000000', 'temperatura', 920.0000, 'ºC'),
	(196181, 119, '2014-02-15 00:36:33.000000', 'temperatura', 665.0000, 'ºC'),
	(196182, 119, '2014-02-15 00:36:34.000000', 'temperatura', 566.0000, 'ºC'),
	(196183, 119, '2014-02-15 00:36:35.000000', 'temperatura', 834.0000, 'ºC'),
	(196184, 119, '2014-02-15 00:36:36.000000', 'temperatura', 73.0000, 'ºC'),
	(196185, 119, '2014-02-15 00:36:37.000000', 'temperatura', 264.0000, 'ºC'),
	(196186, 119, '2014-02-15 00:36:38.000000', 'temperatura', 1103.0000, 'ºC'),
	(196187, 119, '2014-02-15 00:36:39.000000', 'temperatura', 1124.0000, 'ºC'),
	(196188, 119, '2014-02-15 00:36:40.000000', 'temperatura', 1111.0000, 'ºC'),
	(196189, 119, '2014-02-15 00:36:41.000000', 'temperatura', 985.0000, 'ºC'),
	(196190, 119, '2014-02-15 00:36:42.000000', 'temperatura', 389.0000, 'ºC'),
	(196191, 119, '2014-02-15 00:36:43.000000', 'temperatura', 194.0000, 'ºC'),
	(196192, 119, '2014-02-15 00:36:44.000000', 'temperatura', 1002.0000, 'ºC'),
	(196193, 119, '2014-02-15 00:36:45.000000', 'temperatura', 827.0000, 'ºC'),
	(196194, 119, '2014-02-15 00:36:46.000000', 'temperatura', 1129.0000, 'ºC'),
	(196195, 119, '2014-02-15 00:36:47.000000', 'temperatura', 764.0000, 'ºC'),
	(196196, 119, '2014-02-15 00:36:48.000000', 'temperatura', 436.0000, 'ºC'),
	(196197, 119, '2014-02-15 00:36:49.000000', 'temperatura', 1087.0000, 'ºC'),
	(196198, 119, '2014-02-15 00:36:50.000000', 'temperatura', 529.0000, 'ºC'),
	(196199, 119, '2014-02-15 00:36:51.000000', 'temperatura', 584.0000, 'ºC'),
	(196200, 119, '2014-02-15 00:36:52.000000', 'temperatura', 134.0000, 'ºC'),
	(196201, 119, '2014-02-15 00:36:53.000000', 'temperatura', 116.0000, 'ºC'),
	(196202, 119, '2014-02-15 00:36:54.000000', 'temperatura', 181.0000, 'ºC'),
	(196203, 119, '2014-02-15 00:36:55.000000', 'temperatura', 558.0000, 'ºC'),
	(196204, 119, '2014-02-15 00:36:56.000000', 'temperatura', 1048.0000, 'ºC'),
	(196205, 119, '2014-02-15 00:36:57.000000', 'temperatura', 1164.0000, 'ºC'),
	(196206, 119, '2014-02-15 00:36:58.000000', 'temperatura', 276.0000, 'ºC'),
	(196207, 119, '2014-02-15 00:36:59.000000', 'temperatura', 291.0000, 'ºC'),
	(196208, 119, '2014-02-15 00:37:00.000000', 'temperatura', 625.0000, 'ºC'),
	(196209, 119, '2014-02-15 00:37:01.000000', 'temperatura', 1055.0000, 'ºC'),
	(196210, 119, '2014-02-15 00:37:02.000000', 'temperatura', 999.0000, 'ºC'),
	(196211, 119, '2014-02-15 00:37:03.000000', 'temperatura', 630.0000, 'ºC'),
	(196212, 119, '2014-02-15 00:37:04.000000', 'temperatura', 155.0000, 'ºC'),
	(196213, 119, '2014-02-15 00:37:05.000000', 'temperatura', 86.0000, 'ºC'),
	(196214, 119, '2014-02-15 00:37:06.000000', 'temperatura', 1164.0000, 'ºC'),
	(196215, 119, '2014-02-15 00:37:07.000000', 'temperatura', 761.0000, 'ºC'),
	(196216, 119, '2014-02-15 00:37:08.000000', 'temperatura', 316.0000, 'ºC'),
	(196217, 119, '2014-02-15 00:37:09.000000', 'temperatura', 497.0000, 'ºC'),
	(196218, 119, '2014-02-15 00:37:10.000000', 'temperatura', 339.0000, 'ºC'),
	(196219, 119, '2014-02-15 00:37:11.000000', 'temperatura', 205.0000, 'ºC'),
	(196220, 119, '2014-02-15 00:37:12.000000', 'temperatura', 6.0000, 'ºC'),
	(196221, 119, '2014-02-15 00:37:13.000000', 'temperatura', 618.0000, 'ºC'),
	(196222, 119, '2014-02-15 00:37:14.000000', 'temperatura', 670.0000, 'ºC'),
	(196223, 119, '2014-02-15 00:37:15.000000', 'temperatura', 297.0000, 'ºC'),
	(196224, 119, '2014-02-15 00:37:16.000000', 'temperatura', 678.0000, 'ºC'),
	(196225, 119, '2014-02-15 00:37:17.000000', 'temperatura', 97.0000, 'ºC'),
	(196226, 119, '2014-02-15 00:37:18.000000', 'temperatura', 853.0000, 'ºC'),
	(196227, 119, '2014-02-15 00:37:19.000000', 'temperatura', 375.0000, 'ºC'),
	(196228, 119, '2014-02-15 00:37:20.000000', 'temperatura', 517.0000, 'ºC'),
	(196229, 119, '2014-02-15 00:37:21.000000', 'temperatura', 258.0000, 'ºC'),
	(196230, 119, '2014-02-15 00:37:22.000000', 'temperatura', 940.0000, 'ºC'),
	(196231, 119, '2014-02-15 00:37:23.000000', 'temperatura', 327.0000, 'ºC'),
	(196232, 119, '2014-02-15 00:37:24.000000', 'temperatura', 17.0000, 'ºC'),
	(196233, 119, '2014-02-15 00:37:25.000000', 'temperatura', 301.0000, 'ºC'),
	(196234, 119, '2014-02-15 00:37:26.000000', 'temperatura', 258.0000, 'ºC'),
	(196235, 119, '2014-02-15 00:37:27.000000', 'temperatura', 387.0000, 'ºC'),
	(196236, 119, '2014-02-15 00:37:28.000000', 'temperatura', 1160.0000, 'ºC'),
	(196237, 119, '2014-02-15 00:37:29.000000', 'temperatura', 1042.0000, 'ºC'),
	(196238, 119, '2014-02-15 00:37:30.000000', 'temperatura', 529.0000, 'ºC'),
	(196239, 119, '2014-02-15 00:37:31.000000', 'temperatura', 722.0000, 'ºC'),
	(196240, 119, '2014-02-15 00:37:32.000000', 'temperatura', 821.0000, 'ºC'),
	(196241, 119, '2014-02-15 00:37:33.000000', 'temperatura', 740.0000, 'ºC'),
	(196242, 119, '2014-02-15 00:37:34.000000', 'temperatura', 39.0000, 'ºC'),
	(196243, 119, '2014-02-15 00:37:35.000000', 'temperatura', 374.0000, 'ºC'),
	(196244, 119, '2014-02-15 00:37:36.000000', 'temperatura', 552.0000, 'ºC'),
	(196245, 119, '2014-02-15 00:37:37.000000', 'temperatura', 441.0000, 'ºC'),
	(196246, 119, '2014-02-15 00:37:38.000000', 'temperatura', 547.0000, 'ºC'),
	(196247, 119, '2014-02-15 00:37:39.000000', 'temperatura', 215.0000, 'ºC'),
	(196248, 119, '2014-02-15 00:37:40.000000', 'temperatura', 635.0000, 'ºC'),
	(196249, 119, '2014-02-15 00:37:41.000000', 'temperatura', 131.0000, 'ºC'),
	(196250, 119, '2014-02-15 00:37:42.000000', 'temperatura', 1149.0000, 'ºC'),
	(196251, 119, '2014-02-15 00:37:43.000000', 'temperatura', 552.0000, 'ºC'),
	(196252, 119, '2014-02-15 00:37:44.000000', 'temperatura', 514.0000, 'ºC'),
	(196253, 119, '2014-02-15 00:37:45.000000', 'temperatura', 917.0000, 'ºC'),
	(196254, 119, '2014-02-15 00:37:46.000000', 'temperatura', 640.0000, 'ºC'),
	(196255, 119, '2014-02-15 00:37:47.000000', 'temperatura', 451.0000, 'ºC'),
	(196256, 119, '2014-02-15 00:37:48.000000', 'temperatura', 334.0000, 'ºC'),
	(196257, 119, '2014-02-15 00:37:49.000000', 'temperatura', 318.0000, 'ºC'),
	(196258, 119, '2014-02-15 00:37:50.000000', 'temperatura', 589.0000, 'ºC'),
	(196259, 119, '2014-02-15 00:37:51.000000', 'temperatura', 790.0000, 'ºC'),
	(196260, 119, '2014-02-15 00:37:52.000000', 'temperatura', 983.0000, 'ºC'),
	(196261, 119, '2014-02-15 00:37:53.000000', 'temperatura', 148.0000, 'ºC'),
	(196262, 119, '2014-02-15 00:37:54.000000', 'temperatura', 189.0000, 'ºC'),
	(196263, 119, '2014-02-15 00:37:55.000000', 'temperatura', 500.0000, 'ºC'),
	(196264, 119, '2014-02-15 00:37:56.000000', 'temperatura', 737.0000, 'ºC'),
	(196265, 119, '2014-02-15 00:37:57.000000', 'temperatura', 986.0000, 'ºC'),
	(196266, 119, '2014-02-15 00:37:58.000000', 'temperatura', 317.0000, 'ºC'),
	(196267, 119, '2014-02-15 00:37:59.000000', 'temperatura', 1028.0000, 'ºC'),
	(196268, 119, '2014-02-15 00:38:00.000000', 'temperatura', 590.0000, 'ºC'),
	(196269, 119, '2014-02-15 00:38:01.000000', 'temperatura', 1065.0000, 'ºC'),
	(196270, 119, '2014-02-15 00:38:02.000000', 'temperatura', 1158.0000, 'ºC'),
	(196271, 119, '2014-02-15 00:38:03.000000', 'temperatura', 193.0000, 'ºC'),
	(196272, 119, '2014-02-15 00:38:04.000000', 'temperatura', 1093.0000, 'ºC'),
	(196273, 119, '2014-02-15 00:38:05.000000', 'temperatura', 87.0000, 'ºC'),
	(196274, 119, '2014-02-15 00:38:06.000000', 'temperatura', 755.0000, 'ºC'),
	(196275, 119, '2014-02-15 00:38:07.000000', 'temperatura', 1115.0000, 'ºC'),
	(196276, 119, '2014-02-15 00:38:08.000000', 'temperatura', 911.0000, 'ºC'),
	(196277, 119, '2014-02-15 00:38:09.000000', 'temperatura', 10.0000, 'ºC'),
	(196278, 119, '2014-02-15 00:38:10.000000', 'temperatura', 919.0000, 'ºC'),
	(196279, 119, '2014-02-15 00:38:11.000000', 'temperatura', 965.0000, 'ºC'),
	(196280, 119, '2014-02-15 00:38:12.000000', 'temperatura', 869.0000, 'ºC'),
	(196281, 119, '2014-02-15 00:38:13.000000', 'temperatura', 251.0000, 'ºC'),
	(196282, 119, '2014-02-15 00:38:14.000000', 'temperatura', 1047.0000, 'ºC'),
	(196283, 119, '2014-02-15 00:38:15.000000', 'temperatura', 884.0000, 'ºC'),
	(196284, 119, '2014-02-15 00:38:16.000000', 'temperatura', 81.0000, 'ºC'),
	(196285, 119, '2014-02-15 00:38:17.000000', 'temperatura', 150.0000, 'ºC'),
	(196286, 119, '2014-02-15 00:38:18.000000', 'temperatura', 511.0000, 'ºC'),
	(196287, 119, '2014-02-15 00:38:19.000000', 'temperatura', 902.0000, 'ºC'),
	(196288, 119, '2014-02-15 00:38:20.000000', 'temperatura', 581.0000, 'ºC'),
	(196289, 119, '2014-02-15 00:38:21.000000', 'temperatura', 196.0000, 'ºC'),
	(196290, 119, '2014-02-15 00:38:22.000000', 'temperatura', 439.0000, 'ºC'),
	(196291, 119, '2014-02-15 00:38:23.000000', 'temperatura', 407.0000, 'ºC'),
	(196292, 119, '2014-02-15 00:38:24.000000', 'temperatura', 720.0000, 'ºC'),
	(196293, 119, '2014-02-15 00:38:25.000000', 'temperatura', 1178.0000, 'ºC'),
	(196294, 119, '2014-02-15 00:38:26.000000', 'temperatura', 130.0000, 'ºC'),
	(196295, 119, '2014-02-15 00:38:27.000000', 'temperatura', 718.0000, 'ºC'),
	(196296, 119, '2014-02-15 00:38:28.000000', 'temperatura', 799.0000, 'ºC'),
	(196297, 119, '2014-02-15 00:38:29.000000', 'temperatura', 641.0000, 'ºC'),
	(196298, 119, '2014-02-15 00:38:30.000000', 'temperatura', 811.0000, 'ºC'),
	(196299, 119, '2014-02-15 00:38:31.000000', 'temperatura', 930.0000, 'ºC'),
	(196300, 119, '2014-02-15 00:38:32.000000', 'temperatura', 1020.0000, 'ºC'),
	(196301, 119, '2014-02-15 00:38:33.000000', 'temperatura', 1110.0000, 'ºC'),
	(196302, 119, '2014-02-15 00:38:34.000000', 'temperatura', 92.0000, 'ºC'),
	(196303, 119, '2014-02-15 00:38:35.000000', 'temperatura', 730.0000, 'ºC'),
	(196304, 119, '2014-02-15 00:38:36.000000', 'temperatura', 972.0000, 'ºC'),
	(196305, 119, '2014-02-15 00:38:37.000000', 'temperatura', 272.0000, 'ºC'),
	(196306, 119, '2014-02-15 00:38:38.000000', 'temperatura', 845.0000, 'ºC'),
	(196307, 119, '2014-02-15 00:38:39.000000', 'temperatura', 1010.0000, 'ºC'),
	(196308, 119, '2014-02-15 00:38:40.000000', 'temperatura', 116.0000, 'ºC'),
	(196309, 119, '2014-02-15 00:38:41.000000', 'temperatura', 1149.0000, 'ºC'),
	(196310, 119, '2014-02-15 00:38:42.000000', 'temperatura', 597.0000, 'ºC'),
	(196311, 119, '2014-02-15 00:38:43.000000', 'temperatura', 740.0000, 'ºC'),
	(196312, 119, '2014-02-15 00:38:44.000000', 'temperatura', 707.0000, 'ºC'),
	(196313, 119, '2014-02-15 00:38:45.000000', 'temperatura', 116.0000, 'ºC'),
	(196314, 119, '2014-02-15 00:38:46.000000', 'temperatura', 861.0000, 'ºC'),
	(196315, 119, '2014-02-15 00:38:47.000000', 'temperatura', 358.0000, 'ºC'),
	(196316, 119, '2014-02-15 00:38:48.000000', 'temperatura', 409.0000, 'ºC'),
	(196317, 119, '2014-02-15 00:38:49.000000', 'temperatura', 969.0000, 'ºC'),
	(196318, 119, '2014-02-15 00:38:50.000000', 'temperatura', 20.0000, 'ºC'),
	(196319, 119, '2014-02-15 00:38:51.000000', 'temperatura', 792.0000, 'ºC'),
	(196320, 119, '2014-02-15 00:38:52.000000', 'temperatura', 303.0000, 'ºC'),
	(196321, 119, '2014-02-15 00:38:53.000000', 'temperatura', 336.0000, 'ºC'),
	(196322, 119, '2014-02-15 00:38:54.000000', 'temperatura', 775.0000, 'ºC'),
	(196323, 119, '2014-02-15 00:38:55.000000', 'temperatura', 464.0000, 'ºC'),
	(196324, 119, '2014-02-15 00:38:56.000000', 'temperatura', 1198.0000, 'ºC'),
	(196325, 119, '2014-02-15 00:38:57.000000', 'temperatura', 1000.0000, 'ºC'),
	(196326, 119, '2014-02-15 00:38:58.000000', 'temperatura', 204.0000, 'ºC'),
	(196327, 119, '2014-02-15 00:38:59.000000', 'temperatura', 422.0000, 'ºC'),
	(196328, 119, '2014-02-15 00:39:00.000000', 'temperatura', 296.0000, 'ºC'),
	(196329, 119, '2014-02-15 00:39:01.000000', 'temperatura', 217.0000, 'ºC'),
	(196330, 119, '2014-02-15 00:39:02.000000', 'temperatura', 197.0000, 'ºC'),
	(196331, 119, '2014-02-15 00:39:03.000000', 'temperatura', 336.0000, 'ºC'),
	(196332, 119, '2014-02-15 00:39:04.000000', 'temperatura', 1090.0000, 'ºC'),
	(196333, 119, '2014-02-15 00:39:05.000000', 'temperatura', 842.0000, 'ºC'),
	(196334, 119, '2014-02-15 00:39:06.000000', 'temperatura', 938.0000, 'ºC'),
	(196335, 119, '2014-02-15 00:39:07.000000', 'temperatura', 967.0000, 'ºC'),
	(196336, 119, '2014-02-15 00:39:08.000000', 'temperatura', 821.0000, 'ºC'),
	(196337, 119, '2014-02-15 00:39:09.000000', 'temperatura', 3.0000, 'ºC'),
	(196338, 119, '2014-02-15 00:39:10.000000', 'temperatura', 1154.0000, 'ºC'),
	(196339, 119, '2014-02-15 00:39:11.000000', 'temperatura', 960.0000, 'ºC'),
	(196340, 119, '2014-02-15 00:39:12.000000', 'temperatura', 141.0000, 'ºC'),
	(196341, 119, '2014-02-15 00:39:13.000000', 'temperatura', 225.0000, 'ºC'),
	(196342, 119, '2014-02-15 00:39:14.000000', 'temperatura', 700.0000, 'ºC'),
	(196343, 119, '2014-02-15 00:39:15.000000', 'temperatura', 429.0000, 'ºC'),
	(196344, 119, '2014-02-15 00:39:16.000000', 'temperatura', 44.0000, 'ºC'),
	(196345, 119, '2014-02-15 00:39:17.000000', 'temperatura', 133.0000, 'ºC'),
	(196346, 119, '2014-02-15 00:39:18.000000', 'temperatura', 533.0000, 'ºC'),
	(196347, 119, '2014-02-15 00:39:19.000000', 'temperatura', 1065.0000, 'ºC'),
	(196348, 119, '2014-02-15 00:39:20.000000', 'temperatura', 130.0000, 'ºC'),
	(196349, 119, '2014-02-15 00:39:21.000000', 'temperatura', 1053.0000, 'ºC'),
	(196350, 119, '2014-02-15 00:39:22.000000', 'temperatura', 75.0000, 'ºC'),
	(196351, 119, '2014-02-15 00:39:23.000000', 'temperatura', 818.0000, 'ºC'),
	(196352, 119, '2014-02-15 00:39:24.000000', 'temperatura', 267.0000, 'ºC'),
	(196353, 119, '2014-02-15 00:39:25.000000', 'temperatura', 78.0000, 'ºC'),
	(196354, 119, '2014-02-15 00:39:26.000000', 'temperatura', 792.0000, 'ºC'),
	(196355, 119, '2014-02-15 00:39:27.000000', 'temperatura', 124.0000, 'ºC'),
	(196356, 119, '2014-02-15 00:39:28.000000', 'temperatura', 647.0000, 'ºC'),
	(196357, 119, '2014-02-15 00:39:29.000000', 'temperatura', 463.0000, 'ºC'),
	(196358, 119, '2014-02-15 00:39:30.000000', 'temperatura', 373.0000, 'ºC'),
	(196359, 119, '2014-02-15 00:39:31.000000', 'temperatura', 479.0000, 'ºC'),
	(196360, 119, '2014-02-15 00:39:32.000000', 'temperatura', 74.0000, 'ºC'),
	(196361, 119, '2014-02-15 00:39:33.000000', 'temperatura', 136.0000, 'ºC'),
	(196362, 119, '2014-02-15 00:39:34.000000', 'temperatura', 458.0000, 'ºC'),
	(196363, 119, '2014-02-15 00:39:35.000000', 'temperatura', 683.0000, 'ºC'),
	(196364, 119, '2014-02-15 00:39:36.000000', 'temperatura', 840.0000, 'ºC'),
	(196365, 119, '2014-02-15 00:39:37.000000', 'temperatura', 953.0000, 'ºC'),
	(196366, 119, '2014-02-15 00:39:38.000000', 'temperatura', 1044.0000, 'ºC'),
	(196367, 119, '2014-02-15 00:39:39.000000', 'temperatura', 1161.0000, 'ºC'),
	(196368, 119, '2014-02-15 00:39:40.000000', 'temperatura', 274.0000, 'ºC'),
	(196369, 119, '2014-02-15 00:39:41.000000', 'temperatura', 289.0000, 'ºC'),
	(196370, 119, '2014-02-15 00:39:42.000000', 'temperatura', 623.0000, 'ºC'),
	(196371, 119, '2014-02-15 00:39:43.000000', 'temperatura', 1049.0000, 'ºC'),
	(196372, 119, '2014-02-15 00:39:44.000000', 'temperatura', 974.0000, 'ºC'),
	(196373, 119, '2014-02-15 00:39:45.000000', 'temperatura', 525.0000, 'ºC'),
	(196374, 119, '2014-02-15 00:39:46.000000', 'temperatura', 902.0000, 'ºC'),
	(196375, 119, '2014-02-15 00:39:47.000000', 'temperatura', 534.0000, 'ºC'),
	(196376, 119, '2014-02-15 00:39:48.000000', 'temperatura', 1168.0000, 'ºC'),
	(196377, 119, '2014-02-15 00:39:49.000000', 'temperatura', 638.0000, 'ºC'),
	(196378, 119, '2014-02-15 00:39:50.000000', 'temperatura', 887.0000, 'ºC'),
	(196379, 119, '2014-02-15 00:39:51.000000', 'temperatura', 121.0000, 'ºC'),
	(196380, 119, '2014-02-15 00:39:52.000000', 'temperatura', 345.0000, 'ºC'),
	(196381, 119, '2014-02-15 00:39:53.000000', 'temperatura', 160.0000, 'ºC'),
	(196382, 119, '2014-02-15 00:39:54.000000', 'temperatura', 969.0000, 'ºC'),
	(196383, 119, '2014-02-15 00:39:55.000000', 'temperatura', 763.0000, 'ºC'),
	(196384, 119, '2014-02-15 00:39:56.000000', 'temperatura', 907.0000, 'ºC'),
	(196385, 119, '2014-02-15 00:39:57.000000', 'temperatura', 1050.0000, 'ºC'),
	(196386, 119, '2014-02-15 00:39:58.000000', 'temperatura', 129.0000, 'ºC'),
	(196387, 119, '2014-02-15 00:39:59.000000', 'temperatura', 1093.0000, 'ºC'),
	(196388, 119, '2014-02-15 00:40:00.000000', 'temperatura', 279.0000, 'ºC'),
	(196389, 119, '2014-02-15 00:40:01.000000', 'temperatura', 518.0000, 'ºC'),
	(196390, 119, '2014-02-15 00:40:02.000000', 'temperatura', 553.0000, 'ºC'),
	(196391, 119, '2014-02-15 00:40:03.000000', 'temperatura', 12.0000, 'ºC'),
	(196392, 119, '2014-02-15 00:40:04.000000', 'temperatura', 801.0000, 'ºC'),
	(196393, 119, '2014-02-15 00:40:05.000000', 'temperatura', 369.0000, 'ºC'),
	(196394, 119, '2014-02-15 00:40:06.000000', 'temperatura', 641.0000, 'ºC'),
	(196395, 119, '2014-02-15 00:40:07.000000', 'temperatura', 899.0000, 'ºC'),
	(196396, 119, '2014-02-15 00:40:08.000000', 'temperatura', 174.0000, 'ºC'),
	(196397, 119, '2014-02-15 00:40:09.000000', 'temperatura', 571.0000, 'ºC'),
	(196398, 119, '2014-02-15 00:40:10.000000', 'temperatura', 1137.0000, 'ºC'),
	(196399, 119, '2014-02-15 00:40:11.000000', 'temperatura', 371.0000, 'ºC'),
	(196400, 119, '2014-02-15 00:40:12.000000', 'temperatura', 843.0000, 'ºC'),
	(196401, 119, '2014-02-15 00:40:13.000000', 'temperatura', 702.0000, 'ºC'),
	(196402, 119, '2014-02-15 00:40:14.000000', 'temperatura', 981.0000, 'ºC'),
	(196403, 119, '2014-02-15 00:40:15.000000', 'temperatura', 399.0000, 'ºC'),
	(196404, 119, '2014-02-15 00:40:16.000000', 'temperatura', 255.0000, 'ºC'),
	(196405, 119, '2014-02-15 00:40:17.000000', 'temperatura', 79.0000, 'ºC'),
	(196406, 119, '2014-02-15 00:40:18.000000', 'temperatura', 829.0000, 'ºC'),
	(196407, 119, '2014-02-15 00:40:19.000000', 'temperatura', 310.0000, 'ºC'),
	(196408, 119, '2014-02-15 00:40:20.000000', 'temperatura', 262.0000, 'ºC'),
	(196409, 119, '2014-02-15 00:40:21.000000', 'temperatura', 379.0000, 'ºC'),
	(196410, 119, '2014-02-15 00:40:22.000000', 'temperatura', 1110.0000, 'ºC'),
	(196411, 119, '2014-02-15 00:40:23.000000', 'temperatura', 816.0000, 'ºC'),
	(196412, 119, '2014-02-15 00:40:24.000000', 'temperatura', 750.0000, 'ºC'),
	(196413, 119, '2014-02-15 00:40:25.000000', 'temperatura', 102.0000, 'ºC'),
	(196414, 119, '2014-02-15 00:40:26.000000', 'temperatura', 658.0000, 'ºC'),
	(196415, 119, '2014-02-15 00:40:27.000000', 'temperatura', 588.0000, 'ºC'),
	(196416, 119, '2014-02-15 00:40:28.000000', 'temperatura', 964.0000, 'ºC'),
	(196417, 119, '2014-02-15 00:40:29.000000', 'temperatura', 658.0000, 'ºC'),
	(196418, 119, '2014-02-15 00:40:30.000000', 'temperatura', 398.0000, 'ºC'),
	(196419, 119, '2014-02-15 00:40:31.000000', 'temperatura', 15.0000, 'ºC'),
	(196420, 119, '2014-02-15 00:40:32.000000', 'temperatura', 82.0000, 'ºC'),
	(196421, 119, '2014-02-15 00:40:33.000000', 'temperatura', 365.0000, 'ºC'),
	(196422, 119, '2014-02-15 00:40:34.000000', 'temperatura', 382.0000, 'ºC'),
	(196423, 119, '2014-02-15 00:40:35.000000', 'temperatura', 815.0000, 'ºC'),
	(196424, 119, '2014-02-15 00:40:36.000000', 'temperatura', 530.0000, 'ºC'),
	(196425, 119, '2014-02-15 00:40:37.000000', 'temperatura', 205.0000, 'ºC'),
	(196426, 119, '2014-02-15 00:40:38.000000', 'temperatura', 634.0000, 'ºC'),
	(196427, 119, '2014-02-15 00:40:39.000000', 'temperatura', 155.0000, 'ºC'),
	(196428, 119, '2014-02-15 00:40:40.000000', 'temperatura', 74.0000, 'ºC'),
	(196429, 119, '2014-02-15 00:40:41.000000', 'temperatura', 1104.0000, 'ºC'),
	(196430, 119, '2014-02-15 00:40:42.000000', 'temperatura', 500.0000, 'ºC'),
	(196431, 119, '2014-02-15 00:40:43.000000', 'temperatura', 390.0000, 'ºC'),
	(196432, 119, '2014-02-15 00:40:44.000000', 'temperatura', 449.0000, 'ºC'),
	(196433, 119, '2014-02-15 00:40:45.000000', 'temperatura', 1078.0000, 'ºC'),
	(196434, 119, '2014-02-15 00:40:46.000000', 'temperatura', 441.0000, 'ºC'),
	(196435, 119, '2014-02-15 00:40:47.000000', 'temperatura', 172.0000, 'ºC'),
	(196436, 119, '2014-02-15 00:40:48.000000', 'temperatura', 737.0000, 'ºC'),
	(196437, 119, '2014-02-15 00:40:49.000000', 'temperatura', 769.0000, 'ºC'),
	(196438, 119, '2014-02-15 00:40:50.000000', 'temperatura', 434.0000, 'ºC'),
	(196439, 119, '2014-02-15 00:40:51.000000', 'temperatura', 1066.0000, 'ºC'),
	(196440, 119, '2014-02-15 00:40:52.000000', 'temperatura', 426.0000, 'ºC'),
	(196441, 119, '2014-02-15 00:40:53.000000', 'temperatura', 132.0000, 'ºC'),
	(196442, 119, '2014-02-15 00:40:54.000000', 'temperatura', 581.0000, 'ºC'),
	(196443, 119, '2014-02-15 00:40:55.000000', 'temperatura', 113.0000, 'ºC'),
	(196444, 119, '2014-02-15 00:40:56.000000', 'temperatura', 22.0000, 'ºC'),
	(196445, 119, '2014-02-15 00:40:57.000000', 'temperatura', 970.0000, 'ºC'),
	(196446, 119, '2014-02-15 00:40:58.000000', 'temperatura', 1187.0000, 'ºC'),
	(196447, 119, '2014-02-15 00:40:59.000000', 'temperatura', 624.0000, 'ºC'),
	(196448, 119, '2014-02-15 00:41:00.000000', 'temperatura', 759.0000, 'ºC'),
	(196449, 119, '2014-02-15 00:41:01.000000', 'temperatura', 724.0000, 'ºC'),
	(196450, 119, '2014-02-15 00:41:02.000000', 'temperatura', 143.0000, 'ºC'),
	(196451, 119, '2014-02-15 00:41:03.000000', 'temperatura', 945.0000, 'ºC'),
	(196452, 119, '2014-02-15 00:41:04.000000', 'temperatura', 697.0000, 'ºC'),
	(196453, 119, '2014-02-15 00:41:05.000000', 'temperatura', 648.0000, 'ºC'),
	(196454, 119, '2014-02-15 00:41:06.000000', 'temperatura', 1152.0000, 'ºC'),
	(196455, 119, '2014-02-15 00:41:07.000000', 'temperatura', 215.0000, 'ºC'),
	(196456, 119, '2014-02-15 00:41:08.000000', 'temperatura', 19.0000, 'ºC'),
	(196457, 119, '2014-02-15 00:41:09.000000', 'temperatura', 651.0000, 'ºC'),
	(196458, 119, '2014-02-15 00:41:10.000000', 'temperatura', 798.0000, 'ºC'),
	(196459, 119, '2014-02-15 00:41:11.000000', 'temperatura', 837.0000, 'ºC'),
	(196460, 119, '2014-02-15 00:41:12.000000', 'temperatura', 593.0000, 'ºC'),
	(196461, 119, '2014-02-15 00:41:13.000000', 'temperatura', 455.0000, 'ºC'),
	(196462, 119, '2014-02-15 00:41:14.000000', 'temperatura', 497.0000, 'ºC'),
	(196463, 119, '2014-02-15 00:41:15.000000', 'temperatura', 1118.0000, 'ºC'),
	(196464, 119, '2014-02-15 00:41:16.000000', 'temperatura', 502.0000, 'ºC'),
	(196465, 119, '2014-02-15 00:41:17.000000', 'temperatura', 355.0000, 'ºC'),
	(196466, 119, '2014-02-15 00:41:18.000000', 'temperatura', 268.0000, 'ºC'),
	(196467, 119, '2014-02-15 00:41:19.000000', 'temperatura', 279.0000, 'ºC'),
	(196468, 119, '2014-02-15 00:41:20.000000', 'temperatura', 590.0000, 'ºC'),
	(196469, 119, '2014-02-15 00:41:21.000000', 'temperatura', 912.0000, 'ºC'),
	(196470, 119, '2014-02-15 00:41:22.000000', 'temperatura', 390.0000, 'ºC'),
	(196471, 119, '2014-02-15 00:41:23.000000', 'temperatura', 418.0000, 'ºC'),
	(196472, 119, '2014-02-15 00:41:24.000000', 'temperatura', 917.0000, 'ºC'),
	(196473, 119, '2014-02-15 00:41:25.000000', 'temperatura', 931.0000, 'ºC'),
	(196474, 119, '2014-02-15 00:41:26.000000', 'temperatura', 708.0000, 'ºC'),
	(196475, 119, '2014-02-15 00:41:27.000000', 'temperatura', 744.0000, 'ºC'),
	(196476, 119, '2014-02-15 00:41:28.000000', 'temperatura', 398.0000, 'ºC'),
	(196477, 119, '2014-02-15 00:41:29.000000', 'temperatura', 960.0000, 'ºC'),
	(196478, 119, '2014-02-15 00:41:30.000000', 'temperatura', 3.0000, 'ºC'),
	(196479, 119, '2014-02-15 00:41:31.000000', 'temperatura', 739.0000, 'ºC'),
	(196480, 119, '2014-02-15 00:41:32.000000', 'temperatura', 85.0000, 'ºC'),
	(196481, 119, '2014-02-15 00:41:33.000000', 'temperatura', 610.0000, 'ºC'),
	(196482, 119, '2014-02-15 00:41:34.000000', 'temperatura', 393.0000, 'ºC'),
	(196483, 119, '2014-02-15 00:41:35.000000', 'temperatura', 137.0000, 'ºC'),
	(196484, 119, '2014-02-15 00:41:36.000000', 'temperatura', 707.0000, 'ºC'),
	(196485, 119, '2014-02-15 00:41:37.000000', 'temperatura', 723.0000, 'ºC'),
	(196486, 119, '2014-02-15 00:41:38.000000', 'temperatura', 297.0000, 'ºC'),
	(196487, 119, '2014-02-15 00:41:39.000000', 'temperatura', 515.0000, 'ºC'),
	(196488, 119, '2014-02-15 00:41:40.000000', 'temperatura', 486.0000, 'ºC'),
	(196489, 119, '2014-02-15 00:41:41.000000', 'temperatura', 886.0000, 'ºC'),
	(196490, 119, '2014-02-15 00:41:42.000000', 'temperatura', 574.0000, 'ºC'),
	(196491, 119, '2014-02-15 00:41:43.000000', 'temperatura', 209.0000, 'ºC'),
	(196492, 119, '2014-02-15 00:41:44.000000', 'temperatura', 525.0000, 'ºC'),
	(196493, 119, '2014-02-15 00:41:45.000000', 'temperatura', 800.0000, 'ºC'),
	(196494, 119, '2014-02-15 00:41:46.000000', 'temperatura', 25.0000, 'ºC'),
	(196495, 119, '2014-02-15 00:41:47.000000', 'temperatura', 123.0000, 'ºC'),
	(196496, 119, '2014-02-15 00:41:48.000000', 'temperatura', 544.0000, 'ºC'),
	(196497, 119, '2014-02-15 00:41:49.000000', 'temperatura', 1150.0000, 'ºC'),
	(196498, 119, '2014-02-15 00:41:50.000000', 'temperatura', 520.0000, 'ºC'),
	(196499, 119, '2014-02-15 00:41:51.000000', 'temperatura', 349.0000, 'ºC'),
	(196500, 119, '2014-02-15 00:41:52.000000', 'temperatura', 184.0000, 'ºC'),
	(196501, 119, '2014-02-15 00:41:53.000000', 'temperatura', 1075.0000, 'ºC'),
	(196502, 119, '2014-02-15 00:41:54.000000', 'temperatura', 24.0000, 'ºC'),
	(196503, 119, '2014-02-15 00:41:55.000000', 'temperatura', 493.0000, 'ºC'),
	(196504, 119, '2014-02-15 00:41:56.000000', 'temperatura', 1195.0000, 'ºC'),
	(196505, 119, '2014-02-15 00:41:57.000000', 'temperatura', 898.0000, 'ºC'),
	(196506, 119, '2014-02-15 00:41:58.000000', 'temperatura', 905.0000, 'ºC'),
	(196507, 119, '2014-02-15 00:41:59.000000', 'temperatura', 631.0000, 'ºC'),
	(196508, 119, '2014-02-15 00:42:00.000000', 'temperatura', 441.0000, 'ºC'),
	(196509, 119, '2014-02-15 00:42:01.000000', 'temperatura', 314.0000, 'ºC'),
	(196510, 119, '2014-02-15 00:42:02.000000', 'temperatura', 244.0000, 'ºC'),
	(196511, 119, '2014-02-15 00:42:03.000000', 'temperatura', 281.0000, 'ºC'),
	(196512, 119, '2014-02-15 00:42:04.000000', 'temperatura', 673.0000, 'ºC'),
	(196513, 119, '2014-02-15 00:42:05.000000', 'temperatura', 124.0000, 'ºC'),
	(196514, 119, '2014-02-15 00:42:06.000000', 'temperatura', 998.0000, 'ºC'),
	(196515, 119, '2014-02-15 00:42:07.000000', 'temperatura', 1022.0000, 'ºC'),
	(196516, 119, '2014-02-15 00:42:08.000000', 'temperatura', 914.0000, 'ºC'),
	(196517, 119, '2014-02-15 00:42:09.000000', 'temperatura', 305.0000, 'ºC'),
	(196518, 119, '2014-02-15 00:42:10.000000', 'temperatura', 1185.0000, 'ºC'),
	(196519, 119, '2014-02-15 00:42:11.000000', 'temperatura', 210.0000, 'ºC'),
	(196520, 119, '2014-02-15 00:42:12.000000', 'temperatura', 1094.0000, 'ºC'),
	(196521, 119, '2014-02-15 00:42:13.000000', 'temperatura', 40.0000, 'ºC'),
	(196522, 119, '2014-02-15 00:42:14.000000', 'temperatura', 520.0000, 'ºC'),
	(196523, 119, '2014-02-15 00:42:15.000000', 'temperatura', 81.0000, 'ºC'),
	(196524, 119, '2014-02-15 00:42:16.000000', 'temperatura', 47.0000, 'ºC'),
	(196525, 119, '2014-02-15 00:42:17.000000', 'temperatura', 1189.0000, 'ºC'),
	(196526, 119, '2014-02-15 00:42:18.000000', 'temperatura', 1007.0000, 'ºC'),
	(196527, 119, '2014-02-15 00:42:19.000000', 'temperatura', 269.0000, 'ºC'),
	(196528, 119, '2014-02-15 00:42:20.000000', 'temperatura', 725.0000, 'ºC'),
	(196529, 119, '2014-02-15 00:42:21.000000', 'temperatura', 418.0000, 'ºC'),
	(196530, 119, '2014-02-15 00:42:22.000000', 'temperatura', 1115.0000, 'ºC'),
	(196531, 119, '2014-02-15 00:42:23.000000', 'temperatura', 720.0000, 'ºC'),
	(196532, 119, '2014-02-15 00:42:24.000000', 'temperatura', 257.0000, 'ºC'),
	(196533, 119, '2014-02-15 00:42:25.000000', 'temperatura', 327.0000, 'ºC'),
	(196534, 119, '2014-02-15 00:42:26.000000', 'temperatura', 863.0000, 'ºC'),
	(196535, 119, '2014-02-15 00:42:27.000000', 'temperatura', 935.0000, 'ºC'),
	(196536, 119, '2014-02-15 00:42:28.000000', 'temperatura', 886.0000, 'ºC'),
	(196537, 119, '2014-02-15 00:42:29.000000', 'temperatura', 426.0000, 'ºC'),
	(196538, 119, '2014-02-15 00:42:30.000000', 'temperatura', 670.0000, 'ºC'),
	(196539, 119, '2014-02-15 00:42:31.000000', 'temperatura', 876.0000, 'ºC'),
	(196540, 119, '2014-02-15 00:42:32.000000', 'temperatura', 1168.0000, 'ºC'),
	(196541, 119, '2014-02-15 00:42:33.000000', 'temperatura', 815.0000, 'ºC'),
	(196542, 119, '2014-02-15 00:42:34.000000', 'temperatura', 570.0000, 'ºC'),
	(196543, 119, '2014-02-15 00:42:35.000000', 'temperatura', 406.0000, 'ºC'),
	(196544, 119, '2014-02-15 00:42:36.000000', 'temperatura', 320.0000, 'ºC'),
	(196545, 119, '2014-02-15 00:42:37.000000', 'temperatura', 383.0000, 'ºC'),
	(196546, 119, '2014-02-15 00:42:38.000000', 'temperatura', 954.0000, 'ºC'),
	(196547, 119, '2014-02-15 00:42:39.000000', 'temperatura', 21.0000, 'ºC'),
	(196548, 119, '2014-02-15 00:42:40.000000', 'temperatura', 845.0000, 'ºC'),
	(196549, 119, '2014-02-15 00:42:41.000000', 'temperatura', 560.0000, 'ºC'),
	(196550, 119, '2014-02-15 00:42:42.000000', 'temperatura', 268.0000, 'ºC'),
	(196551, 119, '2014-02-15 00:42:43.000000', 'temperatura', 859.0000, 'ºC'),
	(196552, 119, '2014-02-15 00:42:44.000000', 'temperatura', 1091.0000, 'ºC'),
	(196553, 119, '2014-02-15 00:42:45.000000', 'temperatura', 479.0000, 'ºC'),
	(196554, 119, '2014-02-15 00:42:46.000000', 'temperatura', 322.0000, 'ºC'),
	(196555, 119, '2014-02-15 00:42:47.000000', 'temperatura', 172.0000, 'ºC'),
	(196556, 119, '2014-02-15 00:42:48.000000', 'temperatura', 1097.0000, 'ºC'),
	(196557, 119, '2014-02-15 00:42:49.000000', 'temperatura', 167.0000, 'ºC'),
	(196558, 119, '2014-02-15 00:42:50.000000', 'temperatura', 1144.0000, 'ºC'),
	(196559, 119, '2014-02-15 00:42:51.000000', 'temperatura', 421.0000, 'ºC'),
	(196560, 119, '2014-02-15 00:42:52.000000', 'temperatura', 1072.0000, 'ºC'),
	(196561, 119, '2014-02-15 00:42:53.000000', 'temperatura', 499.0000, 'ºC'),
	(196562, 119, '2014-02-15 00:42:54.000000', 'temperatura', 481.0000, 'ºC'),
	(196563, 119, '2014-02-15 00:42:55.000000', 'temperatura', 907.0000, 'ºC'),
	(196564, 119, '2014-02-15 00:42:56.000000', 'temperatura', 692.0000, 'ºC'),
	(196565, 119, '2014-02-15 00:42:57.000000', 'temperatura', 738.0000, 'ºC'),
	(196566, 119, '2014-02-15 00:42:58.000000', 'temperatura', 418.0000, 'ºC'),
	(196567, 119, '2014-02-15 00:42:59.000000', 'temperatura', 1074.0000, 'ºC'),
	(196568, 119, '2014-02-15 00:43:00.000000', 'temperatura', 515.0000, 'ºC'),
	(196569, 119, '2014-02-15 00:43:01.000000', 'temperatura', 555.0000, 'ºC'),
	(196570, 119, '2014-02-15 00:43:02.000000', 'temperatura', 33.0000, 'ºC'),
	(196571, 119, '2014-02-15 00:43:03.000000', 'temperatura', 897.0000, 'ºC'),
	(196572, 119, '2014-02-15 00:43:04.000000', 'temperatura', 789.0000, 'ºC'),
	(196573, 119, '2014-02-15 00:43:05.000000', 'temperatura', 54.0000, 'ºC'),
	(196574, 119, '2014-02-15 00:43:06.000000', 'temperatura', 301.0000, 'ºC'),
	(196575, 119, '2014-02-15 00:43:07.000000', 'temperatura', 146.0000, 'ºC'),
	(196576, 119, '2014-02-15 00:43:08.000000', 'temperatura', 1028.0000, 'ºC'),
	(196577, 119, '2014-02-15 00:43:09.000000', 'temperatura', 1100.0000, 'ºC'),
	(196578, 119, '2014-02-15 00:43:10.000000', 'temperatura', 19.0000, 'ºC'),
	(196579, 119, '2014-02-15 00:43:11.000000', 'temperatura', 393.0000, 'ºC'),
	(196580, 119, '2014-02-15 00:43:12.000000', 'temperatura', 711.0000, 'ºC'),
	(196581, 119, '2014-02-15 00:43:13.000000', 'temperatura', 1176.0000, 'ºC'),
	(196582, 119, '2014-02-15 00:43:14.000000', 'temperatura', 148.0000, 'ºC'),
	(196583, 119, '2014-02-15 00:43:15.000000', 'temperatura', 814.0000, 'ºC'),
	(196584, 119, '2014-02-15 00:43:16.000000', 'temperatura', 23.0000, 'ºC'),
	(196585, 119, '2014-02-15 00:43:17.000000', 'temperatura', 76.0000, 'ºC'),
	(196586, 119, '2014-02-15 00:43:18.000000', 'temperatura', 311.0000, 'ºC'),
	(196587, 119, '2014-02-15 00:43:19.000000', 'temperatura', 126.0000, 'ºC'),
	(196588, 119, '2014-02-15 00:43:20.000000', 'temperatura', 899.0000, 'ºC'),
	(196589, 119, '2014-02-15 00:43:21.000000', 'temperatura', 518.0000, 'ºC'),
	(196590, 119, '2014-02-15 00:43:22.000000', 'temperatura', 1091.0000, 'ºC'),
	(196591, 119, '2014-02-15 00:43:23.000000', 'temperatura', 304.0000, 'ºC'),
	(196592, 119, '2014-02-15 00:43:24.000000', 'temperatura', 648.0000, 'ºC'),
	(196593, 119, '2014-02-15 00:43:25.000000', 'temperatura', 1127.0000, 'ºC'),
	(196594, 119, '2014-02-15 00:43:26.000000', 'temperatura', 91.0000, 'ºC'),
	(196595, 119, '2014-02-15 00:43:27.000000', 'temperatura', 675.0000, 'ºC'),
	(196596, 119, '2014-02-15 00:43:28.000000', 'temperatura', 702.0000, 'ºC'),
	(196597, 119, '2014-02-15 00:43:29.000000', 'temperatura', 287.0000, 'ºC'),
	(196598, 119, '2014-02-15 00:43:30.000000', 'temperatura', 531.0000, 'ºC'),
	(196599, 119, '2014-02-15 00:43:31.000000', 'temperatura', 591.0000, 'ºC'),
	(196600, 119, '2014-02-15 00:43:32.000000', 'temperatura', 164.0000, 'ºC'),
	(196601, 119, '2014-02-15 00:43:33.000000', 'temperatura', 247.0000, 'ºC'),
	(196602, 119, '2014-02-15 00:43:34.000000', 'temperatura', 742.0000, 'ºC'),
	(196603, 119, '2014-02-15 00:43:35.000000', 'temperatura', 572.0000, 'ºC'),
	(196604, 119, '2014-02-15 00:43:36.000000', 'temperatura', 635.0000, 'ºC'),
	(196605, 119, '2014-02-15 00:43:37.000000', 'temperatura', 260.0000, 'ºC'),
	(196606, 119, '2014-02-15 00:43:38.000000', 'temperatura', 597.0000, 'ºC'),
	(196607, 119, '2014-02-15 00:43:39.000000', 'temperatura', 1002.0000, 'ºC'),
	(196608, 119, '2014-02-15 00:43:40.000000', 'temperatura', 819.0000, 'ºC'),
	(196609, 119, '2014-02-15 00:43:41.000000', 'temperatura', 1092.0000, 'ºC'),
	(196610, 119, '2014-02-15 00:43:42.000000', 'temperatura', 603.0000, 'ºC'),
	(196611, 119, '2014-02-15 00:43:43.000000', 'temperatura', 939.0000, 'ºC'),
	(196612, 119, '2014-02-15 00:43:44.000000', 'temperatura', 487.0000, 'ºC'),
	(196613, 119, '2014-02-15 00:43:45.000000', 'temperatura', 819.0000, 'ºC'),
	(196614, 119, '2014-02-15 00:43:46.000000', 'temperatura', 236.0000, 'ºC'),
	(196615, 119, '2014-02-15 00:43:47.000000', 'temperatura', 1120.0000, 'ºC'),
	(196616, 119, '2014-02-15 00:43:48.000000', 'temperatura', 94.0000, 'ºC'),
	(196617, 119, '2014-02-15 00:43:49.000000', 'temperatura', 712.0000, 'ºC'),
	(196618, 119, '2014-02-15 00:43:50.000000', 'temperatura', 879.0000, 'ºC'),
	(196619, 119, '2014-02-15 00:43:51.000000', 'temperatura', 1060.0000, 'ºC'),
	(196620, 119, '2014-02-15 00:43:52.000000', 'temperatura', 263.0000, 'ºC'),
	(196621, 119, '2014-02-15 00:43:53.000000', 'temperatura', 533.0000, 'ºC'),
	(196622, 119, '2014-02-15 00:43:54.000000', 'temperatura', 680.0000, 'ºC'),
	(196623, 119, '2014-02-15 00:43:55.000000', 'temperatura', 599.0000, 'ºC'),
	(196624, 119, '2014-02-15 00:43:56.000000', 'temperatura', 957.0000, 'ºC'),
	(196625, 119, '2014-02-15 00:43:57.000000', 'temperatura', 587.0000, 'ºC'),
	(196626, 119, '2014-02-15 00:43:58.000000', 'temperatura', 66.0000, 'ºC'),
	(196627, 119, '2014-02-15 00:43:59.000000', 'temperatura', 970.0000, 'ºC'),
	(196628, 119, '2014-02-15 00:44:00.000000', 'temperatura', 1053.0000, 'ºC'),
	(196629, 119, '2014-02-15 00:44:01.000000', 'temperatura', 1154.0000, 'ºC'),
	(196630, 119, '2014-02-15 00:44:02.000000', 'temperatura', 213.0000, 'ºC'),
	(196631, 119, '2014-02-15 00:44:03.000000', 'temperatura', 1.0000, 'ºC'),
	(196632, 119, '2014-02-15 00:44:04.000000', 'temperatura', 570.0000, 'ºC'),
	(196633, 119, '2014-02-15 00:44:05.000000', 'temperatura', 444.0000, 'ºC'),
	(196634, 119, '2014-02-15 00:44:06.000000', 'temperatura', 511.0000, 'ºC'),
	(196635, 119, '2014-02-15 00:44:07.000000', 'temperatura', 26.0000, 'ºC'),
	(196636, 119, '2014-02-15 00:44:08.000000', 'temperatura', 994.0000, 'ºC'),
	(196637, 119, '2014-02-15 00:44:09.000000', 'temperatura', 95.0000, 'ºC'),
	(196638, 119, '2014-02-15 00:44:10.000000', 'temperatura', 1093.0000, 'ºC'),
	(196639, 119, '2014-02-15 00:44:11.000000', 'temperatura', 382.0000, 'ºC'),
	(196640, 119, '2014-02-15 00:44:12.000000', 'temperatura', 1030.0000, 'ºC'),
	(196641, 119, '2014-02-15 00:44:13.000000', 'temperatura', 404.0000, 'ºC'),
	(196642, 119, '2014-02-15 00:44:14.000000', 'temperatura', 133.0000, 'ºC'),
	(196643, 119, '2014-02-15 00:44:15.000000', 'temperatura', 651.0000, 'ºC'),
	(196644, 119, '2014-02-15 00:44:16.000000', 'temperatura', 459.0000, 'ºC'),
	(196645, 119, '2014-02-15 00:44:17.000000', 'temperatura', 339.0000, 'ºC'),
	(196646, 119, '2014-02-15 00:44:18.000000', 'temperatura', 321.0000, 'ºC'),
	(196647, 119, '2014-02-15 00:44:19.000000', 'temperatura', 590.0000, 'ºC'),
	(196648, 119, '2014-02-15 00:44:20.000000', 'temperatura', 785.0000, 'ºC'),
	(196649, 119, '2014-02-15 00:44:21.000000', 'temperatura', 956.0000, 'ºC'),
	(196650, 119, '2014-02-15 00:44:22.000000', 'temperatura', 25.0000, 'ºC'),
	(196651, 119, '2014-02-15 00:44:23.000000', 'temperatura', 856.0000, 'ºC'),
	(196652, 119, '2014-02-15 00:44:24.000000', 'temperatura', 607.0000, 'ºC'),
	(196653, 119, '2014-02-15 00:44:25.000000', 'temperatura', 467.0000, 'ºC'),
	(196654, 119, '2014-02-15 00:44:26.000000', 'temperatura', 516.0000, 'ºC'),
	(196655, 119, '2014-02-15 00:44:27.000000', 'temperatura', 1181.0000, 'ºC'),
	(196656, 119, '2014-02-15 00:44:28.000000', 'temperatura', 755.0000, 'ºC'),
	(196657, 119, '2014-02-15 00:44:29.000000', 'temperatura', 232.0000, 'ºC'),
	(196658, 119, '2014-02-15 00:44:30.000000', 'temperatura', 98.0000, 'ºC'),
	(196659, 119, '2014-02-15 00:44:31.000000', 'temperatura', 995.0000, 'ºC'),
	(196660, 119, '2014-02-15 00:44:32.000000', 'temperatura', 1081.0000, 'ºC'),
	(196661, 119, '2014-02-15 00:44:33.000000', 'temperatura', 18.0000, 'ºC'),
	(196662, 119, '2014-02-15 00:44:34.000000', 'temperatura', 449.0000, 'ºC'),
	(196663, 119, '2014-02-15 00:44:35.000000', 'temperatura', 991.0000, 'ºC'),
	(196664, 119, '2014-02-15 00:44:36.000000', 'temperatura', 7.0000, 'ºC'),
	(196665, 119, '2014-02-15 00:44:37.000000', 'temperatura', 665.0000, 'ºC'),
	(196666, 119, '2014-02-15 00:44:38.000000', 'temperatura', 904.0000, 'ºC'),
	(196667, 119, '2014-02-15 00:44:39.000000', 'temperatura', 125.0000, 'ºC'),
	(196668, 119, '2014-02-15 00:44:40.000000', 'temperatura', 315.0000, 'ºC'),
	(196669, 119, '2014-02-15 00:44:41.000000', 'temperatura', 1198.0000, 'ºC'),
	(196670, 119, '2014-02-15 00:44:42.000000', 'temperatura', 248.0000, 'ºC'),
	(196671, 119, '2014-02-15 00:44:43.000000', 'temperatura', 47.0000, 'ºC'),
	(196672, 119, '2014-02-15 00:44:44.000000', 'temperatura', 690.0000, 'ºC'),
	(196673, 119, '2014-02-15 00:44:45.000000', 'temperatura', 911.0000, 'ºC'),
	(196674, 119, '2014-02-15 00:44:46.000000', 'temperatura', 83.0000, 'ºC'),
	(196675, 119, '2014-02-15 00:44:47.000000', 'temperatura', 82.0000, 'ºC'),
	(196676, 119, '2014-02-15 00:44:48.000000', 'temperatura', 163.0000, 'ºC'),
	(196677, 119, '2014-02-15 00:44:49.000000', 'temperatura', 571.0000, 'ºC'),
	(196678, 119, '2014-02-15 00:44:50.000000', 'temperatura', 1165.0000, 'ºC'),
	(196679, 119, '2014-02-15 00:44:51.000000', 'temperatura', 511.0000, 'ºC'),
	(196680, 119, '2014-02-15 00:44:52.000000', 'temperatura', 262.0000, 'ºC'),
	(196681, 119, '2014-02-15 00:44:53.000000', 'temperatura', 979.0000, 'ºC'),
	(196682, 119, '2014-02-15 00:44:54.000000', 'temperatura', 507.0000, 'ºC'),
	(196683, 119, '2014-02-15 00:44:55.000000', 'temperatura', 799.0000, 'ºC'),
	(196684, 119, '2014-02-15 00:44:56.000000', 'temperatura', 73.0000, 'ºC'),
	(196685, 119, '2014-02-15 00:44:57.000000', 'temperatura', 369.0000, 'ºC'),
	(196686, 119, '2014-02-15 00:44:58.000000', 'temperatura', 428.0000, 'ºC'),
	(196687, 119, '2014-02-15 00:44:59.000000', 'temperatura', 1033.0000, 'ºC'),
	(196688, 119, '2014-02-15 00:45:00.000000', 'temperatura', 280.0000, 'ºC'),
	(196689, 119, '2014-02-15 00:45:01.000000', 'temperatura', 701.0000, 'ºC'),
	(196690, 119, '2014-02-15 00:45:02.000000', 'temperatura', 267.0000, 'ºC'),
	(196691, 119, '2014-02-15 00:45:03.000000', 'temperatura', 434.0000, 'ºC'),
	(196692, 119, '2014-02-15 00:45:04.000000', 'temperatura', 169.0000, 'ºC'),
	(196693, 119, '2014-02-15 00:45:05.000000', 'temperatura', 743.0000, 'ºC'),
	(196694, 119, '2014-02-15 00:45:06.000000', 'temperatura', 808.0000, 'ºC'),
	(196695, 119, '2014-02-15 00:45:07.000000', 'temperatura', 614.0000, 'ºC'),
	(196696, 119, '2014-02-15 00:45:08.000000', 'temperatura', 643.0000, 'ºC'),
	(196697, 119, '2014-02-15 00:45:09.000000', 'temperatura', 177.0000, 'ºC'),
	(196698, 119, '2014-02-15 00:45:10.000000', 'temperatura', 154.0000, 'ºC'),
	(196699, 119, '2014-02-15 00:45:11.000000', 'temperatura', 238.0000, 'ºC'),
	(196700, 119, '2014-02-15 00:45:12.000000', 'temperatura', 732.0000, 'ºC'),
	(196701, 119, '2014-02-15 00:45:13.000000', 'temperatura', 545.0000, 'ºC'),
	(196702, 119, '2014-02-15 00:45:14.000000', 'temperatura', 529.0000, 'ºC'),
	(196703, 119, '2014-02-15 00:45:15.000000', 'temperatura', 1011.0000, 'ºC'),
	(196704, 119, '2014-02-15 00:45:16.000000', 'temperatura', 1070.0000, 'ºC'),
	(196705, 119, '2014-02-15 00:45:17.000000', 'temperatura', 1115.0000, 'ºC'),
	(196706, 119, '2014-02-15 00:45:18.000000', 'temperatura', 1165.0000, 'ºC'),
	(196707, 119, '2014-02-15 00:45:19.000000', 'temperatura', 80.0000, 'ºC'),
	(196708, 119, '2014-02-15 00:45:20.000000', 'temperatura', 506.0000, 'ºC'),
	(196709, 119, '2014-02-15 00:45:21.000000', 'temperatura', 1093.0000, 'ºC'),
	(196710, 119, '2014-02-15 00:45:22.000000', 'temperatura', 345.0000, 'ºC'),
	(196711, 119, '2014-02-15 00:45:23.000000', 'temperatura', 846.0000, 'ºC'),
	(196712, 119, '2014-02-15 00:45:24.000000', 'temperatura', 797.0000, 'ºC'),
	(196713, 119, '2014-02-15 00:45:25.000000', 'temperatura', 247.0000, 'ºC'),
	(196714, 119, '2014-02-15 00:45:26.000000', 'temperatura', 43.0000, 'ºC'),
	(196715, 119, '2014-02-15 00:45:27.000000', 'temperatura', 677.0000, 'ºC'),
	(196716, 119, '2014-02-15 00:45:28.000000', 'temperatura', 854.0000, 'ºC'),
	(196717, 119, '2014-02-15 00:45:29.000000', 'temperatura', 1041.0000, 'ºC'),
	(196718, 119, '2014-02-15 00:45:30.000000', 'temperatura', 243.0000, 'ºC'),
	(196719, 119, '2014-02-15 00:45:31.000000', 'temperatura', 494.0000, 'ºC'),
	(196720, 119, '2014-02-15 00:45:32.000000', 'temperatura', 542.0000, 'ºC'),
	(196721, 119, '2014-02-15 00:45:33.000000', 'temperatura', 29.0000, 'ºC'),
	(196722, 119, '2014-02-15 00:45:34.000000', 'temperatura', 918.0000, 'ºC'),
	(196723, 119, '2014-02-15 00:45:35.000000', 'temperatura', 905.0000, 'ºC'),
	(196724, 119, '2014-02-15 00:45:36.000000', 'temperatura', 571.0000, 'ºC'),
	(196725, 119, '2014-02-15 00:45:37.000000', 'temperatura', 139.0000, 'ºC'),
	(196726, 119, '2014-02-15 00:45:38.000000', 'temperatura', 185.0000, 'ºC'),
	(196727, 119, '2014-02-15 00:45:39.000000', 'temperatura', 509.0000, 'ºC'),
	(196728, 119, '2014-02-15 00:45:40.000000', 'temperatura', 790.0000, 'ºC'),
	(196729, 119, '2014-02-15 00:45:41.000000', 'temperatura', 25.0000, 'ºC'),
	(196730, 119, '2014-02-15 00:45:42.000000', 'temperatura', 155.0000, 'ºC'),
	(196731, 119, '2014-02-15 00:45:43.000000', 'temperatura', 698.0000, 'ºC'),
	(196732, 119, '2014-02-15 00:45:44.000000', 'temperatura', 628.0000, 'ºC'),
	(196733, 119, '2014-02-15 00:45:45.000000', 'temperatura', 1046.0000, 'ºC'),
	(196734, 119, '2014-02-15 00:45:46.000000', 'temperatura', 947.0000, 'ºC'),
	(196735, 119, '2014-02-15 00:45:47.000000', 'temperatura', 398.0000, 'ºC'),
	(196736, 119, '2014-02-15 00:45:48.000000', 'temperatura', 350.0000, 'ºC'),
	(196737, 119, '2014-02-15 00:45:49.000000', 'temperatura', 556.0000, 'ºC'),
	(196738, 119, '2014-02-15 00:45:50.000000', 'temperatura', 531.0000, 'ºC'),
	(196739, 119, '2014-02-15 00:45:51.000000', 'temperatura', 986.0000, 'ºC'),
	(196740, 119, '2014-02-15 00:45:52.000000', 'temperatura', 937.0000, 'ºC'),
	(196741, 119, '2014-02-15 00:45:53.000000', 'temperatura', 529.0000, 'ºC'),
	(196742, 119, '2014-02-15 00:45:54.000000', 'temperatura', 1033.0000, 'ºC'),
	(196743, 119, '2014-02-15 00:45:55.000000', 'temperatura', 1177.0000, 'ºC'),
	(196744, 119, '2014-02-15 00:45:56.000000', 'temperatura', 389.0000, 'ºC'),
	(196745, 119, '2014-02-15 00:45:57.000000', 'temperatura', 816.0000, 'ºC'),
	(196746, 119, '2014-02-15 00:45:58.000000', 'temperatura', 512.0000, 'ºC'),
	(196747, 119, '2014-02-15 00:45:59.000000', 'temperatura', 111.0000, 'ºC'),
	(196748, 119, '2014-02-15 00:46:00.000000', 'temperatura', 221.0000, 'ºC'),
	(196749, 119, '2014-02-15 00:46:01.000000', 'temperatura', 771.0000, 'ºC'),
	(196750, 119, '2014-02-15 00:46:02.000000', 'temperatura', 794.0000, 'ºC'),
	(196751, 119, '2014-02-15 00:46:03.000000', 'temperatura', 456.0000, 'ºC'),
	(196752, 119, '2014-02-15 00:46:04.000000', 'temperatura', 1098.0000, 'ºC'),
	(196753, 119, '2014-02-15 00:46:05.000000', 'temperatura', 523.0000, 'ºC'),
	(196754, 119, '2014-02-15 00:46:06.000000', 'temperatura', 520.0000, 'ºC'),
	(196755, 119, '2014-02-15 00:46:07.000000', 'temperatura', 1031.0000, 'ºC'),
	(196756, 119, '2014-02-15 00:46:08.000000', 'temperatura', 1198.0000, 'ºC'),
	(196757, 119, '2014-02-15 00:46:09.000000', 'temperatura', 498.0000, 'ºC'),
	(196758, 119, '2014-02-15 00:46:10.000000', 'temperatura', 97.0000, 'ºC'),
	(196759, 119, '2014-02-15 00:46:11.000000', 'temperatura', 190.0000, 'ºC'),
	(196760, 119, '2014-02-15 00:46:12.000000', 'temperatura', 662.0000, 'ºC'),
	(196761, 119, '2014-02-15 00:46:13.000000', 'temperatura', 338.0000, 'ºC'),
	(196762, 119, '2014-02-15 00:46:14.000000', 'temperatura', 903.0000, 'ºC'),
	(196763, 119, '2014-02-15 00:46:15.000000', 'temperatura', 1104.0000, 'ºC'),
	(196764, 119, '2014-02-15 00:46:16.000000', 'temperatura', 409.0000, 'ºC'),
	(196765, 119, '2014-02-15 00:46:17.000000', 'temperatura', 1136.0000, 'ºC'),
	(196766, 119, '2014-02-15 00:46:18.000000', 'temperatura', 851.0000, 'ºC'),
	(196767, 119, '2014-02-15 00:46:19.000000', 'temperatura', 850.0000, 'ºC'),
	(196768, 119, '2014-02-15 00:46:20.000000', 'temperatura', 497.0000, 'ºC'),
	(196769, 119, '2014-02-15 00:46:21.000000', 'temperatura', 1134.0000, 'ºC'),
	(196770, 119, '2014-02-15 00:46:22.000000', 'temperatura', 580.0000, 'ºC'),
	(196771, 119, '2014-02-15 00:46:23.000000', 'temperatura', 698.0000, 'ºC'),
	(196772, 119, '2014-02-15 00:46:24.000000', 'temperatura', 552.0000, 'ºC'),
	(196773, 119, '2014-02-15 00:46:25.000000', 'temperatura', 664.0000, 'ºC'),
	(196774, 119, '2014-02-15 00:46:26.000000', 'temperatura', 466.0000, 'ºC'),
	(196775, 119, '2014-02-15 00:46:27.000000', 'temperatura', 337.0000, 'ºC'),
	(196776, 119, '2014-02-15 00:46:28.000000', 'temperatura', 289.0000, 'ºC'),
	(196777, 119, '2014-02-15 00:46:29.000000', 'temperatura', 436.0000, 'ºC'),
	(196778, 119, '2014-02-15 00:46:30.000000', 'temperatura', 110.0000, 'ºC'),
	(196779, 119, '2014-02-15 00:46:31.000000', 'temperatura', 445.0000, 'ºC'),
	(196780, 119, '2014-02-15 00:46:32.000000', 'temperatura', 695.0000, 'ºC'),
	(196781, 119, '2014-02-15 00:46:33.000000', 'temperatura', 939.0000, 'ºC'),
	(196782, 119, '2014-02-15 00:46:34.000000', 'temperatura', 213.0000, 'ºC'),
	(196783, 119, '2014-02-15 00:46:35.000000', 'temperatura', 649.0000, 'ºC'),
	(196784, 119, '2014-02-15 00:46:36.000000', 'temperatura', 207.0000, 'ºC'),
	(196785, 119, '2014-02-15 00:46:37.000000', 'temperatura', 289.0000, 'ºC'),
	(196786, 119, '2014-02-15 00:46:38.000000', 'temperatura', 824.0000, 'ºC'),
	(196787, 119, '2014-02-15 00:46:39.000000', 'temperatura', 852.0000, 'ºC'),
	(196788, 119, '2014-02-15 00:46:40.000000', 'temperatura', 589.0000, 'ºC'),
	(196789, 119, '2014-02-15 00:46:41.000000', 'temperatura', 390.0000, 'ºC'),
	(196790, 119, '2014-02-15 00:46:42.000000', 'temperatura', 184.0000, 'ºC'),
	(196791, 119, '2014-02-15 00:46:43.000000', 'temperatura', 949.0000, 'ºC'),
	(196792, 119, '2014-02-15 00:46:44.000000', 'temperatura', 596.0000, 'ºC'),
	(196793, 119, '2014-02-15 00:46:45.000000', 'temperatura', 133.0000, 'ºC'),
	(196794, 119, '2014-02-15 00:46:46.000000', 'temperatura', 79.0000, 'ºC'),
	(196795, 119, '2014-02-15 00:46:47.000000', 'temperatura', 1194.0000, 'ºC'),
	(196796, 119, '2014-02-15 00:46:48.000000', 'temperatura', 935.0000, 'ºC'),
	(196797, 119, '2014-02-15 00:46:49.000000', 'temperatura', 1092.0000, 'ºC'),
	(196798, 119, '2014-02-15 00:46:50.000000', 'temperatura', 256.0000, 'ºC'),
	(196799, 119, '2014-02-15 00:46:51.000000', 'temperatura', 404.0000, 'ºC'),
	(196800, 119, '2014-02-15 00:46:52.000000', 'temperatura', 53.0000, 'ºC'),
	(196801, 119, '2014-02-15 00:46:53.000000', 'temperatura', 252.0000, 'ºC'),
	(196802, 119, '2014-02-15 00:46:54.000000', 'temperatura', 1101.0000, 'ºC'),
	(196803, 119, '2014-02-15 00:46:55.000000', 'temperatura', 1149.0000, 'ºC'),
	(196804, 119, '2014-02-15 00:46:56.000000', 'temperatura', 42.0000, 'ºC'),
	(196805, 119, '2014-02-15 00:46:57.000000', 'temperatura', 364.0000, 'ºC'),
	(196806, 119, '2014-02-15 00:46:58.000000', 'temperatura', 494.0000, 'ºC'),
	(196807, 119, '2014-02-15 00:46:59.000000', 'temperatura', 178.0000, 'ºC'),
	(196808, 119, '2014-02-15 00:47:00.000000', 'temperatura', 608.0000, 'ºC'),
	(196809, 119, '2014-02-15 00:47:01.000000', 'temperatura', 107.0000, 'ºC'),
	(196810, 119, '2014-02-15 00:47:02.000000', 'temperatura', 1111.0000, 'ºC'),
	(196811, 119, '2014-02-15 00:47:03.000000', 'temperatura', 433.0000, 'ºC'),
	(196812, 119, '2014-02-15 00:47:04.000000', 'temperatura', 34.0000, 'ºC'),
	(196813, 119, '2014-02-15 00:47:05.000000', 'temperatura', 73.0000, 'ºC'),
	(196814, 119, '2014-02-15 00:47:06.000000', 'temperatura', 262.0000, 'ºC'),
	(196815, 119, '2014-02-15 00:47:07.000000', 'temperatura', 1092.0000, 'ºC'),
	(196816, 119, '2014-02-15 00:47:08.000000', 'temperatura', 1073.0000, 'ºC'),
	(196817, 119, '2014-02-15 00:47:09.000000', 'temperatura', 888.0000, 'ºC'),
	(196818, 119, '2014-02-15 00:47:10.000000', 'temperatura', 25.0000, 'ºC'),
	(196819, 119, '2014-02-15 00:47:11.000000', 'temperatura', 1060.0000, 'ºC'),
	(196820, 119, '2014-02-15 00:47:12.000000', 'temperatura', 425.0000, 'ºC'),
	(196821, 119, '2014-02-15 00:47:13.000000', 'temperatura', 146.0000, 'ºC'),
	(196822, 119, '2014-02-15 00:47:14.000000', 'temperatura', 656.0000, 'ºC'),
	(196823, 119, '2014-02-15 00:47:15.000000', 'temperatura', 444.0000, 'ºC'),
	(196824, 119, '2014-02-15 00:47:16.000000', 'temperatura', 251.0000, 'ºC'),
	(196825, 119, '2014-02-15 00:47:17.000000', 'temperatura', 1122.0000, 'ºC'),
	(196826, 119, '2014-02-15 00:47:18.000000', 'temperatura', 59.0000, 'ºC'),
	(196827, 119, '2014-02-15 00:47:19.000000', 'temperatura', 529.0000, 'ºC'),
	(196828, 119, '2014-02-15 00:47:20.000000', 'temperatura', 70.0000, 'ºC'),
	(196829, 119, '2014-02-15 00:47:21.000000', 'temperatura', 1161.0000, 'ºC'),
	(196830, 119, '2014-02-15 00:47:22.000000', 'temperatura', 797.0000, 'ºC'),
	(196831, 119, '2014-02-15 00:47:23.000000', 'temperatura', 504.0000, 'ºC'),
	(196832, 119, '2014-02-15 00:47:24.000000', 'temperatura', 129.0000, 'ºC'),
	(196833, 119, '2014-02-15 00:47:25.000000', 'temperatura', 332.0000, 'ºC'),
	(196834, 119, '2014-02-15 00:47:26.000000', 'temperatura', 76.0000, 'ºC'),
	(196835, 119, '2014-02-15 00:47:27.000000', 'temperatura', 582.0000, 'ºC'),
	(196836, 119, '2014-02-15 00:47:28.000000', 'temperatura', 283.0000, 'ºC'),
	(196837, 119, '2014-02-15 00:47:29.000000', 'temperatura', 868.0000, 'ºC'),
	(196838, 119, '2014-02-15 00:47:30.000000', 'temperatura', 1093.0000, 'ºC'),
	(196839, 119, '2014-02-15 00:47:31.000000', 'temperatura', 460.0000, 'ºC'),
	(196840, 119, '2014-02-15 00:47:32.000000', 'temperatura', 220.0000, 'ºC'),
	(196841, 119, '2014-02-15 00:47:33.000000', 'temperatura', 924.0000, 'ºC'),
	(196842, 119, '2014-02-15 00:47:34.000000', 'temperatura', 360.0000, 'ºC'),
	(196843, 119, '2014-02-15 00:47:35.000000', 'temperatura', 227.0000, 'ºC'),
	(196844, 119, '2014-02-15 00:47:36.000000', 'temperatura', 55.0000, 'ºC'),
	(196845, 119, '2014-02-15 00:47:37.000000', 'temperatura', 794.0000, 'ºC'),
	(196846, 119, '2014-02-15 00:47:38.000000', 'temperatura', 205.0000, 'ºC'),
	(196847, 119, '2014-02-15 00:47:39.000000', 'temperatura', 1045.0000, 'ºC'),
	(196848, 119, '2014-02-15 00:47:40.000000', 'temperatura', 1009.0000, 'ºC'),
	(196849, 119, '2014-02-15 00:47:41.000000', 'temperatura', 712.0000, 'ºC'),
	(196850, 119, '2014-02-15 00:47:42.000000', 'temperatura', 533.0000, 'ºC'),
	(196851, 119, '2014-02-15 00:47:43.000000', 'temperatura', 531.0000, 'ºC'),
	(196852, 119, '2014-02-15 00:47:44.000000', 'temperatura', 1054.0000, 'ºC'),
	(196853, 119, '2014-02-15 00:47:45.000000', 'temperatura', 79.0000, 'ºC'),
	(196854, 119, '2014-02-15 00:47:46.000000', 'temperatura', 833.0000, 'ºC'),
	(196855, 119, '2014-02-15 00:47:47.000000', 'temperatura', 331.0000, 'ºC'),
	(196856, 119, '2014-02-15 00:47:48.000000', 'temperatura', 354.0000, 'ºC'),
	(196857, 119, '2014-02-15 00:47:49.000000', 'temperatura', 776.0000, 'ºC'),
	(196858, 119, '2014-02-15 00:47:50.000000', 'temperatura', 421.0000, 'ºC'),
	(196859, 119, '2014-02-15 00:47:51.000000', 'temperatura', 978.0000, 'ºC'),
	(196860, 119, '2014-02-15 00:47:52.000000', 'temperatura', 28.0000, 'ºC'),
	(196861, 119, '2014-02-15 00:47:53.000000', 'temperatura', 804.0000, 'ºC'),
	(196862, 119, '2014-02-15 00:47:54.000000', 'temperatura', 339.0000, 'ºC'),
	(196863, 119, '2014-02-15 00:47:55.000000', 'temperatura', 481.0000, 'ºC'),
	(196864, 119, '2014-02-15 00:47:56.000000', 'temperatura', 191.0000, 'ºC'),
	(196865, 119, '2014-02-15 00:47:57.000000', 'temperatura', 711.0000, 'ºC'),
	(196866, 119, '2014-02-15 00:47:58.000000', 'temperatura', 581.0000, 'ºC'),
	(196867, 119, '2014-02-15 00:47:59.000000', 'temperatura', 773.0000, 'ºC'),
	(196868, 119, '2014-02-15 00:48:00.000000', 'temperatura', 923.0000, 'ºC'),
	(196869, 119, '2014-02-15 00:48:01.000000', 'temperatura', 1097.0000, 'ºC'),
	(196870, 119, '2014-02-15 00:48:02.000000', 'temperatura', 317.0000, 'ºC'),
	(196871, 119, '2014-02-15 00:48:03.000000', 'temperatura', 694.0000, 'ºC'),
	(196872, 119, '2014-02-15 00:48:04.000000', 'temperatura', 120.0000, 'ºC'),
	(196873, 119, '2014-02-15 00:48:05.000000', 'temperatura', 917.0000, 'ºC'),
	(196874, 119, '2014-02-15 00:48:06.000000', 'temperatura', 626.0000, 'ºC'),
	(196875, 119, '2014-02-15 00:48:07.000000', 'temperatura', 381.0000, 'ºC'),
	(196876, 119, '2014-02-15 00:48:08.000000', 'temperatura', 25.0000, 'ºC'),
	(196877, 119, '2014-02-15 00:48:09.000000', 'temperatura', 185.0000, 'ºC'),
	(196878, 119, '2014-02-15 00:48:10.000000', 'temperatura', 851.0000, 'ºC'),
	(196879, 119, '2014-02-15 00:48:11.000000', 'temperatura', 101.0000, 'ºC'),
	(196880, 119, '2014-02-15 00:48:12.000000', 'temperatura', 350.0000, 'ºC'),
	(196881, 119, '2014-02-15 00:48:13.000000', 'temperatura', 248.0000, 'ºC'),
	(196882, 119, '2014-02-15 00:48:14.000000', 'temperatura', 191.0000, 'ºC'),
	(196883, 119, '2014-02-15 00:48:15.000000', 'temperatura', 210.0000, 'ºC'),
	(196884, 119, '2014-02-15 00:48:16.000000', 'temperatura', 480.0000, 'ºC'),
	(196885, 119, '2014-02-15 00:48:17.000000', 'temperatura', 570.0000, 'ºC'),
	(196886, 119, '2014-02-15 00:48:18.000000', 'temperatura', 209.0000, 'ºC'),
	(196887, 119, '2014-02-15 00:48:19.000000', 'temperatura', 535.0000, 'ºC'),
	(196888, 119, '2014-02-15 00:48:20.000000', 'temperatura', 848.0000, 'ºC'),
	(196889, 119, '2014-02-15 00:48:21.000000', 'temperatura', 237.0000, 'ºC'),
	(196890, 119, '2014-02-15 00:48:22.000000', 'temperatura', 1041.0000, 'ºC'),
	(196891, 119, '2014-02-15 00:48:23.000000', 'temperatura', 894.0000, 'ºC'),
	(196892, 119, '2014-02-15 00:48:24.000000', 'temperatura', 147.0000, 'ºC'),
	(196893, 119, '2014-02-15 00:48:25.000000', 'temperatura', 456.0000, 'ºC'),
	(196894, 119, '2014-02-15 00:48:26.000000', 'temperatura', 637.0000, 'ºC'),
	(196895, 119, '2014-02-15 00:48:27.000000', 'temperatura', 617.0000, 'ºC'),
	(196896, 119, '2014-02-15 00:48:28.000000', 'temperatura', 1177.0000, 'ºC'),
	(196897, 119, '2014-02-15 00:48:29.000000', 'temperatura', 435.0000, 'ºC'),
	(196898, 119, '2014-02-15 00:48:30.000000', 'temperatura', 1043.0000, 'ºC'),
	(196899, 119, '2014-02-15 00:48:31.000000', 'temperatura', 309.0000, 'ºC'),
	(196900, 119, '2014-02-15 00:48:32.000000', 'temperatura', 818.0000, 'ºC'),
	(196901, 119, '2014-02-15 00:48:33.000000', 'temperatura', 762.0000, 'ºC'),
	(196902, 119, '2014-02-15 00:48:34.000000', 'temperatura', 156.0000, 'ºC'),
	(196903, 119, '2014-02-15 00:48:35.000000', 'temperatura', 896.0000, 'ºC'),
	(196904, 119, '2014-02-15 00:48:36.000000', 'temperatura', 411.0000, 'ºC'),
	(196905, 119, '2014-02-15 00:48:37.000000', 'temperatura', 568.0000, 'ºC'),
	(196906, 119, '2014-02-15 00:48:38.000000', 'temperatura', 408.0000, 'ºC'),
	(196907, 119, '2014-02-15 00:48:39.000000', 'temperatura', 338.0000, 'ºC'),
	(196908, 119, '2014-02-15 00:48:40.000000', 'temperatura', 465.0000, 'ºC'),
	(196909, 119, '2014-02-15 00:48:41.000000', 'temperatura', 111.0000, 'ºC'),
	(196910, 119, '2014-02-15 00:48:42.000000', 'temperatura', 362.0000, 'ºC'),
	(196911, 119, '2014-02-15 00:48:43.000000', 'temperatura', 278.0000, 'ºC'),
	(196912, 119, '2014-02-15 00:48:44.000000', 'temperatura', 302.0000, 'ºC'),
	(196913, 119, '2014-02-15 00:48:45.000000', 'temperatura', 678.0000, 'ºC'),
	(196914, 119, '2014-02-15 00:48:46.000000', 'temperatura', 86.0000, 'ºC'),
	(196915, 119, '2014-02-15 00:48:47.000000', 'temperatura', 795.0000, 'ºC'),
	(196916, 119, '2014-02-15 00:48:48.000000', 'temperatura', 119.0000, 'ºC'),
	(196917, 119, '2014-02-15 00:48:49.000000', 'temperatura', 611.0000, 'ºC'),
	(196918, 119, '2014-02-15 00:48:50.000000', 'temperatura', 298.0000, 'ºC'),
	(196919, 119, '2014-02-15 00:48:51.000000', 'temperatura', 858.0000, 'ºC'),
	(196920, 119, '2014-02-15 00:48:52.000000', 'temperatura', 998.0000, 'ºC'),
	(196921, 119, '2014-02-15 00:48:53.000000', 'temperatura', 13.0000, 'ºC'),
	(196922, 119, '2014-02-15 00:48:54.000000', 'temperatura', 675.0000, 'ºC'),
	(196923, 119, '2014-02-15 00:48:55.000000', 'temperatura', 934.0000, 'ºC'),
	(196924, 119, '2014-02-15 00:48:56.000000', 'temperatura', 246.0000, 'ºC'),
	(196925, 119, '2014-02-15 00:48:57.000000', 'temperatura', 828.0000, 'ºC'),
	(196926, 119, '2014-02-15 00:48:58.000000', 'temperatura', 1004.0000, 'ºC'),
	(196927, 119, '2014-02-15 00:48:59.000000', 'temperatura', 136.0000, 'ºC'),
	(196928, 119, '2014-02-15 00:49:00.000000', 'temperatura', 68.0000, 'ºC'),
	(196929, 119, '2014-02-15 00:49:01.000000', 'temperatura', 1132.0000, 'ºC'),
	(196930, 119, '2014-02-15 00:49:02.000000', 'temperatura', 656.0000, 'ºC'),
	(196931, 119, '2014-02-15 00:49:03.000000', 'temperatura', 1087.0000, 'ºC'),
	(196932, 119, '2014-02-15 00:49:04.000000', 'temperatura', 1065.0000, 'ºC'),
	(196933, 119, '2014-02-15 00:49:05.000000', 'temperatura', 865.0000, 'ºC'),
	(196934, 119, '2014-02-15 00:49:06.000000', 'temperatura', 1130.0000, 'ºC'),
	(196935, 119, '2014-02-15 00:49:07.000000', 'temperatura', 656.0000, 'ºC'),
	(196936, 119, '2014-02-15 00:49:08.000000', 'temperatura', 1089.0000, 'ºC'),
	(196937, 119, '2014-02-15 00:49:09.000000', 'temperatura', 1079.0000, 'ºC'),
	(196938, 119, '2014-02-15 00:49:10.000000', 'temperatura', 928.0000, 'ºC'),
	(196939, 119, '2014-02-15 00:49:11.000000', 'temperatura', 204.0000, 'ºC'),
	(196940, 119, '2014-02-15 00:49:12.000000', 'temperatura', 637.0000, 'ºC'),
	(196941, 119, '2014-02-15 00:49:13.000000', 'temperatura', 173.0000, 'ºC'),
	(196942, 119, '2014-02-15 00:49:14.000000', 'temperatura', 155.0000, 'ºC'),
	(196943, 119, '2014-02-15 00:49:15.000000', 'temperatura', 256.0000, 'ºC'),
	(196944, 119, '2014-02-15 00:49:16.000000', 'temperatura', 817.0000, 'ºC'),
	(196945, 119, '2014-02-15 00:49:17.000000', 'temperatura', 915.0000, 'ºC'),
	(196946, 119, '2014-02-15 00:49:18.000000', 'temperatura', 927.0000, 'ºC'),
	(196947, 119, '2014-02-15 00:49:19.000000', 'temperatura', 690.0000, 'ºC'),
	(196948, 119, '2014-02-15 00:49:20.000000', 'temperatura', 668.0000, 'ºC'),
	(196949, 119, '2014-02-15 00:49:21.000000', 'temperatura', 71.0000, 'ºC'),
	(196950, 119, '2014-02-15 00:49:22.000000', 'temperatura', 753.0000, 'ºC'),
	(196951, 119, '2014-02-15 00:49:23.000000', 'temperatura', 1150.0000, 'ºC'),
	(196952, 119, '2014-02-15 00:49:24.000000', 'temperatura', 1093.0000, 'ºC'),
	(196953, 119, '2014-02-15 00:49:25.000000', 'temperatura', 815.0000, 'ºC'),
	(196954, 119, '2014-02-15 00:49:26.000000', 'temperatura', 795.0000, 'ºC'),
	(196955, 119, '2014-02-15 00:49:27.000000', 'temperatura', 332.0000, 'ºC'),
	(196956, 119, '2014-02-15 00:49:28.000000', 'temperatura', 474.0000, 'ºC'),
	(196957, 119, '2014-02-15 00:49:29.000000', 'temperatura', 175.0000, 'ºC'),
	(196958, 119, '2014-02-15 00:49:30.000000', 'temperatura', 653.0000, 'ºC'),
	(196959, 119, '2014-02-15 00:49:31.000000', 'temperatura', 340.0000, 'ºC'),
	(196960, 119, '2014-02-15 00:49:32.000000', 'temperatura', 943.0000, 'ºC'),
	(196961, 119, '2014-02-15 00:49:33.000000', 'temperatura', 95.0000, 'ºC'),
	(196962, 119, '2014-02-15 00:49:34.000000', 'temperatura', 46.0000, 'ºC'),
	(196963, 119, '2014-02-15 00:49:35.000000', 'temperatura', 1146.0000, 'ºC'),
	(196964, 119, '2014-02-15 00:49:36.000000', 'temperatura', 790.0000, 'ºC'),
	(196965, 119, '2014-02-15 00:49:37.000000', 'temperatura', 515.0000, 'ºC'),
	(196966, 119, '2014-02-15 00:49:38.000000', 'temperatura', 206.0000, 'ºC'),
	(196967, 119, '2014-02-15 00:49:39.000000', 'temperatura', 685.0000, 'ºC'),
	(196968, 119, '2014-02-15 00:49:40.000000', 'temperatura', 408.0000, 'ºC'),
	(196969, 119, '2014-02-15 00:49:41.000000', 'temperatura', 1184.0000, 'ºC'),
	(196970, 119, '2014-02-15 00:49:42.000000', 'temperatura', 1096.0000, 'ºC'),
	(196971, 119, '2014-02-15 00:49:43.000000', 'temperatura', 728.0000, 'ºC'),
	(196972, 119, '2014-02-15 00:49:44.000000', 'temperatura', 356.0000, 'ºC'),
	(196973, 119, '2014-02-15 00:49:45.000000', 'temperatura', 793.0000, 'ºC'),
	(196974, 119, '2014-02-15 00:49:46.000000', 'temperatura', 498.0000, 'ºC'),
	(196975, 119, '2014-02-15 00:49:47.000000', 'temperatura', 112.0000, 'ºC'),
	(196976, 119, '2014-02-15 00:49:48.000000', 'temperatura', 266.0000, 'ºC'),
	(196977, 119, '2014-02-15 00:49:49.000000', 'temperatura', 995.0000, 'ºC'),
	(196978, 119, '2014-02-15 00:49:50.000000', 'temperatura', 577.0000, 'ºC'),
	(196979, 119, '2014-02-15 00:49:51.000000', 'temperatura', 1102.0000, 'ºC'),
	(196980, 119, '2014-02-15 00:49:52.000000', 'temperatura', 179.0000, 'ºC'),
	(196981, 119, '2014-02-15 00:49:53.000000', 'temperatura', 1189.0000, 'ºC'),
	(196982, 119, '2014-02-15 00:49:54.000000', 'temperatura', 609.0000, 'ºC'),
	(196983, 119, '2014-02-15 00:49:55.000000', 'temperatura', 680.0000, 'ºC'),
	(196984, 119, '2014-02-15 00:49:56.000000', 'temperatura', 371.0000, 'ºC'),
	(196985, 119, '2014-02-15 00:49:57.000000', 'temperatura', 1015.0000, 'ºC'),
	(196986, 119, '2014-02-15 00:49:58.000000', 'temperatura', 364.0000, 'ºC'),
	(196987, 119, '2014-02-15 00:49:59.000000', 'temperatura', 1174.0000, 'ºC'),
	(196988, 119, '2014-02-15 00:50:00.000000', 'temperatura', 1179.0000, 'ºC'),
	(196989, 119, '2014-02-15 00:50:01.000000', 'temperatura', 1173.0000, 'ºC'),
	(196990, 119, '2014-02-15 00:50:02.000000', 'temperatura', 1128.0000, 'ºC'),
	(196991, 119, '2014-02-15 00:50:03.000000', 'temperatura', 922.0000, 'ºC'),
	(196992, 119, '2014-02-15 00:50:04.000000', 'temperatura', 25.0000, 'ºC'),
	(196993, 119, '2014-02-15 00:50:05.000000', 'temperatura', 962.0000, 'ºC'),
	(196994, 119, '2014-02-15 00:50:06.000000', 'temperatura', 1134.0000, 'ºC'),
	(196995, 119, '2014-02-15 00:50:07.000000', 'temperatura', 387.0000, 'ºC'),
	(196996, 119, '2014-02-15 00:50:08.000000', 'temperatura', 931.0000, 'ºC'),
	(196997, 119, '2014-02-15 00:50:09.000000', 'temperatura', 1097.0000, 'ºC'),
	(196998, 119, '2014-02-15 00:50:10.000000', 'temperatura', 292.0000, 'ºC'),
	(196999, 119, '2014-02-15 00:50:11.000000', 'temperatura', 568.0000, 'ºC'),
	(197000, 119, '2014-02-15 00:50:12.000000', 'temperatura', 767.0000, 'ºC'),
	(197001, 119, '2014-02-15 00:50:13.000000', 'temperatura', 929.0000, 'ºC'),
	(197002, 119, '2014-02-15 00:50:14.000000', 'temperatura', 1145.0000, 'ºC'),
	(197003, 119, '2014-02-15 00:50:15.000000', 'temperatura', 540.0000, 'ºC'),
	(197004, 119, '2014-02-15 00:50:16.000000', 'temperatura', 463.0000, 'ºC'),
	(197005, 119, '2014-02-15 00:50:17.000000', 'temperatura', 697.0000, 'ºC'),
	(197006, 119, '2014-02-15 00:50:18.000000', 'temperatura', 894.0000, 'ºC'),
	(197007, 119, '2014-02-15 00:50:19.000000', 'temperatura', 1182.0000, 'ºC'),
	(197008, 119, '2014-02-15 00:50:20.000000', 'temperatura', 828.0000, 'ºC'),
	(197009, 119, '2014-02-15 00:50:21.000000', 'temperatura', 594.0000, 'ºC'),
	(197010, 119, '2014-02-15 00:50:22.000000', 'temperatura', 487.0000, 'ºC'),
	(197011, 119, '2014-02-15 00:50:23.000000', 'temperatura', 654.0000, 'ºC'),
	(197012, 119, '2014-02-15 00:50:24.000000', 'temperatura', 611.0000, 'ºC'),
	(197013, 119, '2014-02-15 00:50:25.000000', 'temperatura', 1092.0000, 'ºC'),
	(197014, 119, '2014-02-15 00:50:26.000000', 'temperatura', 28.0000, 'ºC'),
	(197015, 119, '2014-02-15 00:50:27.000000', 'temperatura', 462.0000, 'ºC'),
	(197016, 119, '2014-02-15 00:50:28.000000', 'temperatura', 1028.0000, 'ºC'),
	(197017, 119, '2014-02-15 00:50:29.000000', 'temperatura', 156.0000, 'ºC'),
	(197018, 119, '2014-02-15 00:50:30.000000', 'temperatura', 97.0000, 'ºC'),
	(197019, 119, '2014-02-15 00:50:31.000000', 'temperatura', 15.0000, 'ºC'),
	(197020, 119, '2014-02-15 00:50:32.000000', 'temperatura', 987.0000, 'ºC'),
	(197021, 119, '2014-02-15 00:50:33.000000', 'temperatura', 88.0000, 'ºC'),
	(197022, 119, '2014-02-15 00:50:34.000000', 'temperatura', 1079.0000, 'ºC'),
	(197023, 119, '2014-02-15 00:50:35.000000', 'temperatura', 331.0000, 'ºC'),
	(197024, 119, '2014-02-15 00:50:36.000000', 'temperatura', 819.0000, 'ºC'),
	(197025, 119, '2014-02-15 00:50:37.000000', 'temperatura', 704.0000, 'ºC'),
	(197026, 119, '2014-02-15 00:50:38.000000', 'temperatura', 1062.0000, 'ºC'),
	(197027, 119, '2014-02-15 00:50:39.000000', 'temperatura', 801.0000, 'ºC'),
	(197028, 119, '2014-02-15 00:50:40.000000', 'temperatura', 819.0000, 'ºC'),
	(197029, 119, '2014-02-15 00:50:41.000000', 'temperatura', 490.0000, 'ºC'),
	(197030, 119, '2014-02-15 00:50:42.000000', 'temperatura', 1194.0000, 'ºC'),
	(197031, 119, '2014-02-15 00:50:43.000000', 'temperatura', 902.0000, 'ºC'),
	(197032, 119, '2014-02-15 00:50:44.000000', 'temperatura', 929.0000, 'ºC'),
	(197033, 119, '2014-02-15 00:50:45.000000', 'temperatura', 740.0000, 'ºC'),
	(197034, 119, '2014-02-15 00:50:46.000000', 'temperatura', 914.0000, 'ºC'),
	(197035, 119, '2014-02-15 00:50:47.000000', 'temperatura', 1148.0000, 'ºC'),
	(197036, 119, '2014-02-15 00:50:48.000000', 'temperatura', 601.0000, 'ºC'),
	(197037, 119, '2014-02-15 00:50:49.000000', 'temperatura', 762.0000, 'ºC'),
	(197038, 119, '2014-02-15 00:50:50.000000', 'temperatura', 806.0000, 'ºC'),
	(197039, 119, '2014-02-15 00:50:51.000000', 'temperatura', 545.0000, 'ºC'),
	(197040, 119, '2014-02-15 00:50:52.000000', 'temperatura', 307.0000, 'ºC'),
	(197041, 119, '2014-02-15 00:50:53.000000', 'temperatura', 1100.0000, 'ºC'),
	(197042, 119, '2014-02-15 00:50:54.000000', 'temperatura', 979.0000, 'ºC'),
	(197043, 119, '2014-02-15 00:50:55.000000', 'temperatura', 395.0000, 'ºC'),
	(197044, 119, '2014-02-15 00:50:56.000000', 'temperatura', 241.0000, 'ºC'),
	(197045, 119, '2014-02-15 00:50:57.000000', 'temperatura', 20.0000, 'ºC'),
	(197046, 119, '2014-02-15 00:50:58.000000', 'temperatura', 576.0000, 'ºC'),
	(197047, 119, '2014-02-15 00:50:59.000000', 'temperatura', 420.0000, 'ºC'),
	(197048, 119, '2014-02-15 00:51:00.000000', 'temperatura', 372.0000, 'ºC'),
	(197049, 119, '2014-02-15 00:51:01.000000', 'temperatura', 601.0000, 'ºC'),
	(197050, 119, '2014-02-15 00:51:02.000000', 'temperatura', 689.0000, 'ºC'),
	(197051, 119, '2014-02-15 00:51:03.000000', 'temperatura', 445.0000, 'ºC'),
	(197052, 119, '2014-02-15 00:51:04.000000', 'temperatura', 157.0000, 'ºC'),
	(197053, 119, '2014-02-15 00:51:05.000000', 'temperatura', 653.0000, 'ºC'),
	(197054, 119, '2014-02-15 00:51:06.000000', 'temperatura', 391.0000, 'ºC'),
	(197055, 119, '2014-02-15 00:51:07.000000', 'temperatura', 1198.0000, 'ºC'),
	(197056, 119, '2014-02-15 00:51:08.000000', 'temperatura', 17.0000, 'ºC'),
	(197057, 119, '2014-02-15 00:51:09.000000', 'temperatura', 93.0000, 'ºC'),
	(197058, 119, '2014-02-15 00:51:10.000000', 'temperatura', 414.0000, 'ºC'),
	(197059, 119, '2014-02-15 00:51:11.000000', 'temperatura', 589.0000, 'ºC'),
	(197060, 119, '2014-02-15 00:51:12.000000', 'temperatura', 506.0000, 'ºC'),
	(197061, 119, '2014-02-15 00:51:13.000000', 'temperatura', 762.0000, 'ºC'),
	(197062, 119, '2014-02-15 00:51:14.000000', 'temperatura', 1093.0000, 'ºC'),
	(197063, 119, '2014-02-15 00:51:15.000000', 'temperatura', 778.0000, 'ºC'),
	(197064, 119, '2014-02-15 00:51:16.000000', 'temperatura', 612.0000, 'ºC'),
	(197065, 119, '2014-02-15 00:51:17.000000', 'temperatura', 729.0000, 'ºC'),
	(197066, 119, '2014-02-15 00:51:18.000000', 'temperatura', 606.0000, 'ºC'),
	(197067, 119, '2014-02-15 00:51:19.000000', 'temperatura', 845.0000, 'ºC'),
	(197068, 119, '2014-02-15 00:51:20.000000', 'temperatura', 5.0000, 'ºC'),
	(197069, 119, '2014-02-15 00:51:21.000000', 'temperatura', 1094.0000, 'ºC'),
	(197070, 119, '2014-02-15 00:51:22.000000', 'temperatura', 654.0000, 'ºC'),
	(197071, 119, '2014-02-15 00:51:23.000000', 'temperatura', 1188.0000, 'ºC'),
	(197072, 119, '2014-02-15 00:51:24.000000', 'temperatura', 379.0000, 'ºC'),
	(197073, 119, '2014-02-15 00:51:25.000000', 'temperatura', 730.0000, 'ºC'),
	(197074, 119, '2014-02-15 00:51:26.000000', 'temperatura', 113.0000, 'ºC'),
	(197075, 119, '2014-02-15 00:51:27.000000', 'temperatura', 777.0000, 'ºC'),
	(197076, 119, '2014-02-15 00:51:28.000000', 'temperatura', 1146.0000, 'ºC'),
	(197077, 119, '2014-02-15 00:51:29.000000', 'temperatura', 999.0000, 'ºC'),
	(197078, 119, '2014-02-15 00:51:30.000000', 'temperatura', 360.0000, 'ºC'),
	(197079, 119, '2014-02-15 00:51:31.000000', 'temperatura', 1.0000, 'ºC'),
	(197080, 119, '2014-02-15 00:51:32.000000', 'temperatura', 128.0000, 'ºC'),
	(197081, 119, '2014-02-15 00:51:33.000000', 'temperatura', 638.0000, 'ºC'),
	(197082, 119, '2014-02-15 00:51:34.000000', 'temperatura', 405.0000, 'ºC'),
	(197083, 119, '2014-02-15 00:51:35.000000', 'temperatura', 111.0000, 'ºC'),
	(197084, 119, '2014-02-15 00:51:36.000000', 'temperatura', 540.0000, 'ºC'),
	(197085, 119, '2014-02-15 00:51:37.000000', 'temperatura', 1168.0000, 'ºC'),
	(197086, 119, '2014-02-15 00:51:38.000000', 'temperatura', 621.0000, 'ºC'),
	(197087, 119, '2014-02-15 00:51:39.000000', 'temperatura', 800.0000, 'ºC'),
	(197088, 119, '2014-02-15 00:51:40.000000', 'temperatura', 939.0000, 'ºC'),
	(197089, 119, '2014-02-15 00:51:41.000000', 'temperatura', 1093.0000, 'ºC'),
	(197090, 119, '2014-02-15 00:51:42.000000', 'temperatura', 250.0000, 'ºC'),
	(197091, 119, '2014-02-15 00:51:43.000000', 'temperatura', 372.0000, 'ºC'),
	(197092, 119, '2014-02-15 00:51:44.000000', 'temperatura', 1110.0000, 'ºC'),
	(197093, 119, '2014-02-15 00:51:45.000000', 'temperatura', 835.0000, 'ºC'),
	(197094, 119, '2014-02-15 00:51:46.000000', 'temperatura', 847.0000, 'ºC'),
	(197095, 119, '2014-02-15 00:51:47.000000', 'temperatura', 530.0000, 'ºC'),
	(197096, 119, '2014-02-15 00:51:48.000000', 'temperatura', 108.0000, 'ºC'),
	(197097, 119, '2014-02-15 00:51:49.000000', 'temperatura', 152.0000, 'ºC'),
	(197098, 119, '2014-02-15 00:51:50.000000', 'temperatura', 434.0000, 'ºC'),
	(197099, 119, '2014-02-15 00:51:51.000000', 'temperatura', 517.0000, 'ºC'),
	(197100, 119, '2014-02-15 00:51:52.000000', 'temperatura', 85.0000, 'ºC'),
	(197101, 119, '2014-02-15 00:51:53.000000', 'temperatura', 72.0000, 'ºC'),
	(197102, 119, '2014-02-15 00:51:54.000000', 'temperatura', 105.0000, 'ºC'),
	(197103, 119, '2014-02-15 00:51:55.000000', 'temperatura', 308.0000, 'ºC'),
	(197104, 119, '2014-02-15 00:51:56.000000', 'temperatura', 28.0000, 'ºC'),
	(197105, 119, '2014-02-15 00:51:57.000000', 'temperatura', 417.0000, 'ºC'),
	(197106, 119, '2014-02-15 00:51:58.000000', 'temperatura', 799.0000, 'ºC'),
	(197107, 119, '2014-02-15 00:51:59.000000', 'temperatura', 345.0000, 'ºC'),
	(197108, 119, '2014-02-15 00:52:00.000000', 'temperatura', 529.0000, 'ºC'),
	(197109, 119, '2014-02-15 00:52:01.000000', 'temperatura', 410.0000, 'ºC'),
	(197110, 119, '2014-02-15 00:52:02.000000', 'temperatura', 463.0000, 'ºC'),
	(197111, 119, '2014-02-15 00:52:03.000000', 'temperatura', 1087.0000, 'ºC'),
	(197112, 119, '2014-02-15 00:52:04.000000', 'temperatura', 448.0000, 'ºC'),
	(197113, 119, '2014-02-15 00:52:05.000000', 'temperatura', 176.0000, 'ºC'),
	(197114, 119, '2014-02-15 00:52:06.000000', 'temperatura', 739.0000, 'ºC'),
	(197115, 119, '2014-02-15 00:52:07.000000', 'temperatura', 766.0000, 'ºC'),
	(197116, 119, '2014-02-15 00:52:08.000000', 'temperatura', 414.0000, 'ºC'),
	(197117, 119, '2014-02-15 00:52:09.000000', 'temperatura', 973.0000, 'ºC'),
	(197118, 119, '2014-02-15 00:52:10.000000', 'temperatura', 24.0000, 'ºC'),
	(197119, 119, '2014-02-15 00:52:11.000000', 'temperatura', 803.0000, 'ºC'),
	(197120, 119, '2014-02-15 00:52:12.000000', 'temperatura', 340.0000, 'ºC'),
	(197121, 119, '2014-02-15 00:52:13.000000', 'temperatura', 494.0000, 'ºC'),
	(197122, 119, '2014-02-15 00:52:14.000000', 'temperatura', 251.0000, 'ºC'),
	(197123, 119, '2014-02-15 00:52:15.000000', 'temperatura', 974.0000, 'ºC'),
	(197124, 119, '2014-02-15 00:52:16.000000', 'temperatura', 518.0000, 'ºC'),
	(197125, 119, '2014-02-15 00:52:17.000000', 'temperatura', 867.0000, 'ºC'),
	(197126, 119, '2014-02-15 00:52:18.000000', 'temperatura', 383.0000, 'ºC'),
	(197127, 119, '2014-02-15 00:52:19.000000', 'temperatura', 513.0000, 'ºC'),
	(197128, 119, '2014-02-15 00:52:20.000000', 'temperatura', 217.0000, 'ºC'),
	(197129, 119, '2014-02-15 00:52:21.000000', 'temperatura', 747.0000, 'ºC'),
	(197130, 119, '2014-02-15 00:52:22.000000', 'temperatura', 686.0000, 'ºC'),
	(197131, 119, '2014-02-15 00:52:23.000000', 'temperatura', 1188.0000, 'ºC'),
	(197132, 119, '2014-02-15 00:52:24.000000', 'temperatura', 284.0000, 'ºC'),
	(197133, 119, '2014-02-15 00:52:25.000000', 'temperatura', 257.0000, 'ºC'),
	(197134, 119, '2014-02-15 00:52:26.000000', 'temperatura', 432.0000, 'ºC'),
	(197135, 119, '2014-02-15 00:52:27.000000', 'temperatura', 188.0000, 'ºC'),
	(197136, 119, '2014-02-15 00:52:28.000000', 'temperatura', 845.0000, 'ºC'),
	(197137, 119, '2014-02-15 00:52:29.000000', 'temperatura', 60.0000, 'ºC'),
	(197138, 119, '2014-02-15 00:52:30.000000', 'temperatura', 168.0000, 'ºC'),
	(197139, 119, '2014-02-15 00:52:31.000000', 'temperatura', 660.0000, 'ºC'),
	(197140, 119, '2014-02-15 00:52:32.000000', 'temperatura', 395.0000, 'ºC'),
	(197141, 119, '2014-02-15 00:52:33.000000', 'temperatura', 1197.0000, 'ºC'),
	(197142, 119, '2014-02-15 00:52:34.000000', 'temperatura', 1.0000, 'ºC'),
	(197143, 119, '2014-02-15 00:52:35.000000', 'temperatura', 15.0000, 'ºC'),
	(197144, 119, '2014-02-15 00:52:36.000000', 'temperatura', 71.0000, 'ºC'),
	(197145, 119, '2014-02-15 00:52:37.000000', 'temperatura', 311.0000, 'ºC'),
	(197146, 119, '2014-02-15 00:52:38.000000', 'temperatura', 142.0000, 'ºC'),
	(197147, 119, '2014-02-15 00:52:39.000000', 'temperatura', 978.0000, 'ºC'),
	(197148, 119, '2014-02-15 00:52:40.000000', 'temperatura', 864.0000, 'ºC'),
	(197149, 119, '2014-02-15 00:52:41.000000', 'temperatura', 186.0000, 'ºC'),
	(197150, 119, '2014-02-15 00:52:42.000000', 'temperatura', 738.0000, 'ºC'),
	(197151, 119, '2014-02-15 00:52:43.000000', 'temperatura', 735.0000, 'ºC'),
	(197152, 119, '2014-02-15 00:52:44.000000', 'temperatura', 260.0000, 'ºC'),
	(197153, 119, '2014-02-15 00:52:45.000000', 'temperatura', 295.0000, 'ºC'),
	(197154, 119, '2014-02-15 00:52:46.000000', 'temperatura', 695.0000, 'ºC'),
	(197155, 119, '2014-02-15 00:52:47.000000', 'temperatura', 192.0000, 'ºC'),
	(197156, 119, '2014-02-15 00:52:48.000000', 'temperatura', 74.0000, 'ºC'),
	(197157, 119, '2014-02-15 00:52:49.000000', 'temperatura', 995.0000, 'ºC'),
	(197158, 119, '2014-02-15 00:52:50.000000', 'temperatura', 1154.0000, 'ºC'),
	(197159, 119, '2014-02-15 00:52:51.000000', 'temperatura', 386.0000, 'ºC'),
	(197160, 119, '2014-02-15 00:52:52.000000', 'temperatura', 870.0000, 'ºC'),
	(197161, 119, '2014-02-15 00:52:53.000000', 'temperatura', 790.0000, 'ºC'),
	(197162, 119, '2014-02-15 00:52:54.000000', 'temperatura', 142.0000, 'ºC'),
	(197163, 119, '2014-02-15 00:52:55.000000', 'temperatura', 741.0000, 'ºC'),
	(197164, 119, '2014-02-15 00:52:56.000000', 'temperatura', 878.0000, 'ºC'),
	(197165, 119, '2014-02-15 00:52:57.000000', 'temperatura', 969.0000, 'ºC'),
	(197166, 119, '2014-02-15 00:52:58.000000', 'temperatura', 1012.0000, 'ºC'),
	(197167, 119, '2014-02-15 00:52:59.000000', 'temperatura', 953.0000, 'ºC'),
	(197168, 119, '2014-02-15 00:53:00.000000', 'temperatura', 528.0000, 'ºC'),
	(197169, 119, '2014-02-15 00:53:01.000000', 'temperatura', 982.0000, 'ºC'),
	(197170, 119, '2014-02-15 00:53:02.000000', 'temperatura', 926.0000, 'ºC'),
	(197171, 119, '2014-02-15 00:53:03.000000', 'temperatura', 485.0000, 'ºC'),
	(197172, 119, '2014-02-15 00:53:04.000000', 'temperatura', 849.0000, 'ºC'),
	(197173, 119, '2014-02-15 00:53:05.000000', 'temperatura', 391.0000, 'ºC'),
	(197174, 119, '2014-02-15 00:53:06.000000', 'temperatura', 608.0000, 'ºC'),
	(197175, 119, '2014-02-15 00:53:07.000000', 'temperatura', 669.0000, 'ºC'),
	(197176, 119, '2014-02-15 00:53:08.000000', 'temperatura', 318.0000, 'ºC'),
	(197177, 119, '2014-02-15 00:53:09.000000', 'temperatura', 787.0000, 'ºC'),
	(197178, 119, '2014-02-15 00:53:10.000000', 'temperatura', 580.0000, 'ºC'),
	(197179, 119, '2014-02-15 00:53:11.000000', 'temperatura', 540.0000, 'ºC'),
	(197180, 119, '2014-02-15 00:53:12.000000', 'temperatura', 958.0000, 'ºC'),
	(197181, 119, '2014-02-15 00:53:13.000000', 'temperatura', 774.0000, 'ºC'),
	(197182, 119, '2014-02-15 00:53:14.000000', 'temperatura', 995.0000, 'ºC'),
	(197183, 119, '2014-02-15 00:53:15.000000', 'temperatura', 253.0000, 'ºC'),
	(197184, 119, '2014-02-15 00:53:16.000000', 'temperatura', 682.0000, 'ºC'),
	(197185, 119, '2014-02-15 00:53:17.000000', 'temperatura', 250.0000, 'ºC'),
	(197186, 119, '2014-02-15 00:53:18.000000', 'temperatura', 405.0000, 'ºC'),
	(197187, 119, '2014-02-15 00:53:19.000000', 'temperatura', 77.0000, 'ºC'),
	(197188, 119, '2014-02-15 00:53:20.000000', 'temperatura', 367.0000, 'ºC'),
	(197189, 119, '2014-02-15 00:53:21.000000', 'temperatura', 408.0000, 'ºC'),
	(197190, 119, '2014-02-15 00:53:22.000000', 'temperatura', 938.0000, 'ºC'),
	(197191, 119, '2014-02-15 00:53:23.000000', 'temperatura', 1066.0000, 'ºC'),
	(197192, 119, '2014-02-15 00:53:24.000000', 'temperatura', 119.0000, 'ºC'),
	(197193, 119, '2014-02-15 00:53:25.000000', 'temperatura', 995.0000, 'ºC'),
	(197194, 119, '2014-02-15 00:53:26.000000', 'temperatura', 1018.0000, 'ºC'),
	(197195, 119, '2014-02-15 00:53:27.000000', 'temperatura', 906.0000, 'ºC'),
	(197196, 119, '2014-02-15 00:53:28.000000', 'temperatura', 277.0000, 'ºC'),
	(197197, 119, '2014-02-15 00:53:29.000000', 'temperatura', 1069.0000, 'ºC'),
	(197198, 119, '2014-02-15 00:53:30.000000', 'temperatura', 911.0000, 'ºC'),
	(197199, 119, '2014-02-15 00:53:31.000000', 'temperatura', 152.0000, 'ºC'),
	(197200, 119, '2014-02-15 00:53:32.000000', 'temperatura', 427.0000, 'ºC'),
	(197201, 119, '2014-02-15 00:53:33.000000', 'temperatura', 479.0000, 'ºC'),
	(197202, 119, '2014-02-15 00:53:34.000000', 'temperatura', 1116.0000, 'ºC'),
	(197203, 119, '2014-02-15 00:53:35.000000', 'temperatura', 545.0000, 'ºC'),
	(197204, 119, '2014-02-15 00:53:36.000000', 'temperatura', 574.0000, 'ºC'),
	(197205, 119, '2014-02-15 00:53:37.000000', 'temperatura', 36.0000, 'ºC'),
	(197206, 119, '2014-02-15 00:53:38.000000', 'temperatura', 857.0000, 'ºC'),
	(197207, 119, '2014-02-15 00:53:39.000000', 'temperatura', 578.0000, 'ºC'),
	(197208, 119, '2014-02-15 00:53:40.000000', 'temperatura', 321.0000, 'ºC'),
	(197209, 119, '2014-02-15 00:53:41.000000', 'temperatura', 1072.0000, 'ºC'),
	(197210, 119, '2014-02-15 00:53:42.000000', 'temperatura', 798.0000, 'ºC'),
	(197211, 119, '2014-02-15 00:53:43.000000', 'temperatura', 773.0000, 'ºC'),
	(197212, 119, '2014-02-15 00:53:44.000000', 'temperatura', 273.0000, 'ºC'),
	(197213, 119, '2014-02-15 00:53:45.000000', 'temperatura', 246.0000, 'ºC'),
	(197214, 119, '2014-02-15 00:53:46.000000', 'temperatura', 410.0000, 'ºC'),
	(197215, 119, '2014-02-15 00:53:47.000000', 'temperatura', 112.0000, 'ºC'),
	(197216, 119, '2014-02-15 00:53:48.000000', 'temperatura', 530.0000, 'ºC'),
	(197217, 119, '2014-02-15 00:53:49.000000', 'temperatura', 1116.0000, 'ºC'),
	(197218, 119, '2014-02-15 00:53:50.000000', 'temperatura', 389.0000, 'ºC'),
	(197219, 119, '2014-02-15 00:53:51.000000', 'temperatura', 997.0000, 'ºC'),
	(197220, 119, '2014-02-15 00:53:52.000000', 'temperatura', 218.0000, 'ºC'),
	(197221, 119, '2014-02-15 00:53:53.000000', 'temperatura', 501.0000, 'ºC'),
	(197222, 119, '2014-02-15 00:53:54.000000', 'temperatura', 652.0000, 'ºC'),
	(197223, 119, '2014-02-15 00:53:55.000000', 'temperatura', 555.0000, 'ºC'),
	(197224, 119, '2014-02-15 00:53:56.000000', 'temperatura', 822.0000, 'ºC'),
	(197225, 119, '2014-02-15 00:53:57.000000', 'temperatura', 44.0000, 'ºC'),
	(197226, 119, '2014-02-15 00:53:58.000000', 'temperatura', 156.0000, 'ºC'),
	(197227, 119, '2014-02-15 00:53:59.000000', 'temperatura', 647.0000, 'ºC'),
	(197228, 119, '2014-02-15 00:54:00.000000', 'temperatura', 367.0000, 'ºC'),
	(197229, 119, '2014-02-15 00:54:01.000000', 'temperatura', 1095.0000, 'ºC'),
	(197230, 119, '2014-02-15 00:54:02.000000', 'temperatura', 773.0000, 'ºC'),
	(197231, 119, '2014-02-15 00:54:03.000000', 'temperatura', 583.0000, 'ºC'),
	(197232, 119, '2014-02-15 00:54:04.000000', 'temperatura', 597.0000, 'ºC'),
	(197233, 119, '2014-02-15 00:54:05.000000', 'temperatura', 36.0000, 'ºC'),
	(197234, 119, '2014-02-15 00:54:06.000000', 'temperatura', 788.0000, 'ºC'),
	(197235, 119, '2014-02-15 00:54:07.000000', 'temperatura', 235.0000, 'ºC'),
	(197236, 119, '2014-02-15 00:54:08.000000', 'temperatura', 10.0000, 'ºC'),
	(197237, 119, '2014-02-15 00:54:09.000000', 'temperatura', 545.0000, 'ºC'),
	(197238, 119, '2014-02-15 00:54:10.000000', 'temperatura', 295.0000, 'ºC'),
	(197239, 119, '2014-02-15 00:54:11.000000', 'temperatura', 1043.0000, 'ºC'),
	(197240, 119, '2014-02-15 00:54:12.000000', 'temperatura', 729.0000, 'ºC'),
	(197241, 119, '2014-02-15 00:54:13.000000', 'temperatura', 518.0000, 'ºC'),
	(197242, 119, '2014-02-15 00:54:14.000000', 'temperatura', 404.0000, 'ºC'),
	(197243, 119, '2014-02-15 00:54:15.000000', 'temperatura', 464.0000, 'ºC'),
	(197244, 119, '2014-02-15 00:54:16.000000', 'temperatura', 1111.0000, 'ºC'),
	(197245, 119, '2014-02-15 00:54:17.000000', 'temperatura', 561.0000, 'ºC'),
	(197246, 119, '2014-02-15 00:54:18.000000', 'temperatura', 674.0000, 'ºC'),
	(197247, 119, '2014-02-15 00:54:19.000000', 'temperatura', 487.0000, 'ºC'),
	(197248, 119, '2014-02-15 00:54:20.000000', 'temperatura', 412.0000, 'ºC'),
	(197249, 119, '2014-02-15 00:54:21.000000', 'temperatura', 601.0000, 'ºC'),
	(197250, 119, '2014-02-15 00:54:22.000000', 'temperatura', 570.0000, 'ºC'),
	(197251, 119, '2014-02-15 00:54:23.000000', 'temperatura', 1049.0000, 'ºC'),
	(197252, 119, '2014-02-15 00:54:24.000000', 'temperatura', 1134.0000, 'ºC'),
	(197253, 119, '2014-02-15 00:54:25.000000', 'temperatura', 122.0000, 'ºC'),
	(197254, 119, '2014-02-15 00:54:26.000000', 'temperatura', 810.0000, 'ºC'),
	(197255, 119, '2014-02-15 00:54:27.000000', 'temperatura', 83.0000, 'ºC'),
	(197256, 119, '2014-02-15 00:54:28.000000', 'temperatura', 386.0000, 'ºC'),
	(197257, 119, '2014-02-15 00:54:29.000000', 'temperatura', 483.0000, 'ºC'),
	(197258, 119, '2014-02-15 00:54:30.000000', 'temperatura', 55.0000, 'ºC'),
	(197259, 119, '2014-02-15 00:54:31.000000', 'temperatura', 27.0000, 'ºC'),
	(197260, 119, '2014-02-15 00:54:32.000000', 'temperatura', 1170.0000, 'ºC'),
	(197261, 119, '2014-02-15 00:54:33.000000', 'temperatura', 970.0000, 'ºC'),
	(197262, 119, '2014-02-15 00:54:34.000000', 'temperatura', 139.0000, 'ºC'),
	(197263, 119, '2014-02-15 00:54:35.000000', 'temperatura', 184.0000, 'ºC'),
	(197264, 119, '2014-02-15 00:54:36.000000', 'temperatura', 507.0000, 'ºC'),
	(197265, 119, '2014-02-15 00:54:37.000000', 'temperatura', 784.0000, 'ºC'),
	(197266, 119, '2014-02-15 00:54:38.000000', 'temperatura', 0.0000, 'ºC'),
	(197267, 119, '2014-02-15 00:54:39.000000', 'temperatura', 46.0000, 'ºC'),
	(197268, 119, '2014-02-15 00:54:40.000000', 'temperatura', 232.0000, 'ºC'),
	(197269, 119, '2014-02-15 00:54:41.000000', 'temperatura', 1022.0000, 'ºC'),
	(197270, 119, '2014-02-15 00:54:42.000000', 'temperatura', 813.0000, 'ºC'),
	(197271, 119, '2014-02-15 00:54:43.000000', 'temperatura', 1001.0000, 'ºC'),
	(197272, 119, '2014-02-15 00:54:44.000000', 'temperatura', 167.0000, 'ºC'),
	(197273, 119, '2014-02-15 00:54:45.000000', 'temperatura', 230.0000, 'ºC'),
	(197274, 119, '2014-02-15 00:54:46.000000', 'temperatura', 651.0000, 'ºC'),
	(197275, 119, '2014-02-15 00:54:47.000000', 'temperatura', 165.0000, 'ºC'),
	(197276, 119, '2014-02-15 00:54:48.000000', 'temperatura', 72.0000, 'ºC'),
	(197277, 119, '2014-02-15 00:54:49.000000', 'temperatura', 1068.0000, 'ºC'),
	(197278, 119, '2014-02-15 00:54:50.000000', 'temperatura', 324.0000, 'ºC'),
	(197279, 119, '2014-02-15 00:54:51.000000', 'temperatura', 815.0000, 'ºC'),
	(197280, 119, '2014-02-15 00:54:52.000000', 'temperatura', 703.0000, 'ºC'),
	(197281, 119, '2014-02-15 00:54:53.000000', 'temperatura', 1071.0000, 'ºC'),
	(197282, 119, '2014-02-15 00:54:54.000000', 'temperatura', 848.0000, 'ºC'),
	(197283, 119, '2014-02-15 00:54:55.000000', 'temperatura', 1026.0000, 'ºC'),
	(197284, 119, '2014-02-15 00:54:56.000000', 'temperatura', 188.0000, 'ºC'),
	(197285, 119, '2014-02-15 00:54:57.000000', 'temperatura', 261.0000, 'ºC'),
	(197286, 119, '2014-02-15 00:54:58.000000', 'temperatura', 742.0000, 'ºC'),
	(197287, 119, '2014-02-15 00:54:59.000000', 'temperatura', 526.0000, 'ºC'),
	(197288, 119, '2014-02-15 00:55:00.000000', 'temperatura', 404.0000, 'ºC'),
	(197289, 119, '2014-02-15 00:55:01.000000', 'temperatura', 444.0000, 'ºC'),
	(197290, 119, '2014-02-15 00:55:02.000000', 'temperatura', 1010.0000, 'ºC'),
	(197291, 119, '2014-02-15 00:55:03.000000', 'temperatura', 117.0000, 'ºC'),
	(197292, 119, '2014-02-15 00:55:04.000000', 'temperatura', 1154.0000, 'ºC'),
	(197293, 119, '2014-02-15 00:55:05.000000', 'temperatura', 622.0000, 'ºC'),
	(197294, 119, '2014-02-15 00:55:06.000000', 'temperatura', 847.0000, 'ºC'),
	(197295, 119, '2014-02-15 00:55:07.000000', 'temperatura', 1171.0000, 'ºC'),
	(197296, 119, '2014-02-15 00:55:08.000000', 'temperatura', 912.0000, 'ºC'),
	(197297, 119, '2014-02-15 00:55:09.000000', 'temperatura', 1049.0000, 'ºC'),
	(197298, 119, '2014-02-15 00:55:10.000000', 'temperatura', 108.0000, 'ºC'),
	(197299, 119, '2014-02-15 00:55:11.000000', 'temperatura', 993.0000, 'ºC'),
	(197300, 119, '2014-02-15 00:55:12.000000', 'temperatura', 1041.0000, 'ºC'),
	(197301, 119, '2014-02-15 00:55:13.000000', 'temperatura', 1026.0000, 'ºC'),
	(197302, 119, '2014-02-15 00:55:14.000000', 'temperatura', 808.0000, 'ºC'),
	(197303, 119, '2014-02-15 00:55:15.000000', 'temperatura', 964.0000, 'ºC'),
	(197304, 119, '2014-02-15 00:55:16.000000', 'temperatura', 1197.0000, 'ºC'),
	(197305, 119, '2014-02-15 00:55:17.000000', 'temperatura', 695.0000, 'ºC'),
	(197306, 119, '2014-02-15 00:55:18.000000', 'temperatura', 1081.0000, 'ºC'),
	(197307, 119, '2014-02-15 00:55:19.000000', 'temperatura', 921.0000, 'ºC'),
	(197308, 119, '2014-02-15 00:55:20.000000', 'temperatura', 164.0000, 'ºC'),
	(197309, 119, '2014-02-15 00:55:21.000000', 'temperatura', 457.0000, 'ºC'),
	(197310, 119, '2014-02-15 00:55:22.000000', 'temperatura', 595.0000, 'ºC'),
	(197311, 119, '2014-02-15 00:55:23.000000', 'temperatura', 403.0000, 'ºC'),
	(197312, 119, '2014-02-15 00:55:24.000000', 'temperatura', 231.0000, 'ºC'),
	(197313, 119, '2014-02-15 00:55:25.000000', 'temperatura', 1146.0000, 'ºC'),
	(197314, 119, '2014-02-15 00:55:26.000000', 'temperatura', 239.0000, 'ºC'),
	(197315, 119, '2014-02-15 00:55:27.000000', 'temperatura', 157.0000, 'ºC'),
	(197316, 119, '2014-02-15 00:55:28.000000', 'temperatura', 70.0000, 'ºC'),
	(197317, 119, '2014-02-15 00:55:29.000000', 'temperatura', 1080.0000, 'ºC'),
	(197318, 119, '2014-02-15 00:55:30.000000', 'temperatura', 387.0000, 'ºC'),
	(197319, 119, '2014-02-15 00:55:31.000000', 'temperatura', 1098.0000, 'ºC'),
	(197320, 119, '2014-02-15 00:55:32.000000', 'temperatura', 728.0000, 'ºC'),
	(197321, 119, '2014-02-15 00:55:33.000000', 'temperatura', 349.0000, 'ºC'),
	(197322, 119, '2014-02-15 00:55:34.000000', 'temperatura', 758.0000, 'ºC'),
	(197323, 119, '2014-02-15 00:55:35.000000', 'temperatura', 346.0000, 'ºC'),
	(197324, 119, '2014-02-15 00:55:36.000000', 'temperatura', 657.0000, 'ºC'),
	(197325, 119, '2014-02-15 00:55:37.000000', 'temperatura', 1046.0000, 'ºC'),
	(197326, 119, '2014-02-15 00:55:38.000000', 'temperatura', 861.0000, 'ºC'),
	(197327, 119, '2014-02-15 00:55:39.000000', 'temperatura', 1166.0000, 'ºC'),
	(197328, 119, '2014-02-15 00:55:40.000000', 'temperatura', 847.0000, 'ºC'),
	(197329, 119, '2014-02-15 00:55:41.000000', 'temperatura', 737.0000, 'ºC'),
	(197330, 119, '2014-02-15 00:55:42.000000', 'temperatura', 1146.0000, 'ºC'),
	(197331, 119, '2014-02-15 00:55:43.000000', 'temperatura', 1118.0000, 'ºC'),
	(197332, 119, '2014-02-15 00:55:44.000000', 'temperatura', 952.0000, 'ºC'),
	(197333, 119, '2014-02-15 00:55:45.000000', 'temperatura', 207.0000, 'ºC'),
	(197334, 119, '2014-02-15 00:55:46.000000', 'temperatura', 578.0000, 'ºC'),
	(197335, 119, '2014-02-15 00:55:47.000000', 'temperatura', 1072.0000, 'ºC'),
	(197336, 119, '2014-02-15 00:55:48.000000', 'temperatura', 27.0000, 'ºC'),
	(197337, 119, '2014-02-15 00:55:49.000000', 'temperatura', 520.0000, 'ºC'),
	(197338, 119, '2014-02-15 00:55:50.000000', 'temperatura', 119.0000, 'ºC'),
	(197339, 119, '2014-02-15 00:55:51.000000', 'temperatura', 237.0000, 'ºC'),
	(197340, 119, '2014-02-15 00:55:52.000000', 'temperatura', 825.0000, 'ºC'),
	(197341, 119, '2014-02-15 00:55:53.000000', 'temperatura', 1017.0000, 'ºC'),
	(197342, 119, '2014-02-15 00:55:54.000000', 'temperatura', 208.0000, 'ºC'),
	(197343, 119, '2014-02-15 00:55:55.000000', 'temperatura', 392.0000, 'ºC'),
	(197344, 119, '2014-02-15 00:55:56.000000', 'temperatura', 134.0000, 'ºC'),
	(197345, 119, '2014-02-15 00:55:57.000000', 'temperatura', 694.0000, 'ºC'),
	(197346, 119, '2014-02-15 00:55:58.000000', 'temperatura', 668.0000, 'ºC'),
	(197347, 119, '2014-02-15 00:55:59.000000', 'temperatura', 58.0000, 'ºC'),
	(197348, 119, '2014-02-15 00:56:00.000000', 'temperatura', 690.0000, 'ºC'),
	(197349, 119, '2014-02-15 00:56:01.000000', 'temperatura', 873.0000, 'ºC'),
	(197350, 119, '2014-02-15 00:56:02.000000', 'temperatura', 1097.0000, 'ºC'),
	(197351, 119, '2014-02-15 00:56:03.000000', 'temperatura', 467.0000, 'ºC'),
	(197352, 119, '2014-02-15 00:56:04.000000', 'temperatura', 246.0000, 'ºC'),
	(197353, 119, '2014-02-15 00:56:05.000000', 'temperatura', 1029.0000, 'ºC'),
	(197354, 119, '2014-02-15 00:56:06.000000', 'temperatura', 807.0000, 'ºC'),
	(197355, 119, '2014-02-15 00:56:07.000000', 'temperatura', 948.0000, 'ºC'),
	(197356, 119, '2014-02-15 00:56:08.000000', 'temperatura', 1119.0000, 'ºC'),
	(197357, 119, '2014-02-15 00:56:09.000000', 'temperatura', 353.0000, 'ºC'),
	(197358, 119, '2014-02-15 00:56:10.000000', 'temperatura', 807.0000, 'ºC'),
	(197359, 119, '2014-02-15 00:56:11.000000', 'temperatura', 578.0000, 'ºC'),
	(197360, 119, '2014-02-15 00:56:12.000000', 'temperatura', 470.0000, 'ºC'),
	(197361, 119, '2014-02-15 00:56:13.000000', 'temperatura', 615.0000, 'ºC'),
	(197362, 119, '2014-02-15 00:56:14.000000', 'temperatura', 465.0000, 'ºC'),
	(197363, 119, '2014-02-15 00:56:15.000000', 'temperatura', 479.0000, 'ºC'),
	(197364, 119, '2014-02-15 00:56:16.000000', 'temperatura', 1003.0000, 'ºC'),
	(197365, 119, '2014-02-15 00:56:17.000000', 'temperatura', 1177.0000, 'ºC'),
	(197366, 119, '2014-02-15 00:56:18.000000', 'temperatura', 475.0000, 'ºC'),
	(197367, 119, '2014-02-15 00:56:19.000000', 'temperatura', 47.0000, 'ºC'),
	(197368, 119, '2014-02-15 00:56:20.000000', 'temperatura', 9.0000, 'ºC'),
	(197369, 119, '2014-02-15 00:56:21.000000', 'temperatura', 1104.0000, 'ºC'),
	(197370, 119, '2014-02-15 00:56:22.000000', 'temperatura', 695.0000, 'ºC'),
	(197371, 119, '2014-02-15 00:56:23.000000', 'temperatura', 165.0000, 'ºC'),
	(197372, 119, '2014-02-15 00:56:24.000000', 'temperatura', 1137.0000, 'ºC'),
	(197373, 119, '2014-02-15 00:56:25.000000', 'temperatura', 394.0000, 'ºC'),
	(197374, 119, '2014-02-15 00:56:26.000000', 'temperatura', 956.0000, 'ºC'),
	(197375, 119, '2014-02-15 00:56:27.000000', 'temperatura', 2.0000, 'ºC'),
	(197376, 119, '2014-02-15 00:56:28.000000', 'temperatura', 739.0000, 'ºC'),
	(197377, 119, '2014-02-15 00:56:29.000000', 'temperatura', 92.0000, 'ºC'),
	(197378, 119, '2014-02-15 00:56:30.000000', 'temperatura', 643.0000, 'ºC'),
	(197379, 119, '2014-02-15 00:56:31.000000', 'temperatura', 539.0000, 'ºC'),
	(197380, 119, '2014-02-15 00:56:32.000000', 'temperatura', 766.0000, 'ºC'),
	(197381, 119, '2014-02-15 00:56:33.000000', 'temperatura', 1012.0000, 'ºC'),
	(197382, 119, '2014-02-15 00:56:34.000000', 'temperatura', 364.0000, 'ºC'),
	(197383, 119, '2014-02-15 00:56:35.000000', 'temperatura', 1185.0000, 'ºC'),
	(197384, 119, '2014-02-15 00:56:36.000000', 'temperatura', 31.0000, 'ºC'),
	(197385, 119, '2014-02-15 00:56:37.000000', 'temperatura', 204.0000, 'ºC'),
	(197386, 119, '2014-02-15 00:56:38.000000', 'temperatura', 926.0000, 'ºC'),
	(197387, 119, '2014-02-15 00:56:39.000000', 'temperatura', 418.0000, 'ºC'),
	(197388, 119, '2014-02-15 00:56:40.000000', 'temperatura', 513.0000, 'ºC'),
	(197389, 119, '2014-02-15 00:56:41.000000', 'temperatura', 112.0000, 'ºC'),
	(197390, 119, '2014-02-15 00:56:42.000000', 'temperatura', 221.0000, 'ºC'),
	(197391, 119, '2014-02-15 00:56:43.000000', 'temperatura', 768.0000, 'ºC'),
	(197392, 119, '2014-02-15 00:56:44.000000', 'temperatura', 780.0000, 'ºC'),
	(197393, 119, '2014-02-15 00:56:45.000000', 'temperatura', 397.0000, 'ºC'),
	(197394, 119, '2014-02-15 00:56:46.000000', 'temperatura', 845.0000, 'ºC'),
	(197395, 119, '2014-02-15 00:56:47.000000', 'temperatura', 633.0000, 'ºC'),
	(197396, 119, '2014-02-15 00:56:48.000000', 'temperatura', 633.0000, 'ºC'),
	(197397, 119, '2014-02-15 00:56:49.000000', 'temperatura', 65.0000, 'ºC'),
	(197398, 119, '2014-02-15 00:56:50.000000', 'temperatura', 826.0000, 'ºC'),
	(197399, 119, '2014-02-15 00:56:51.000000', 'temperatura', 337.0000, 'ºC'),
	(197400, 119, '2014-02-15 00:56:52.000000', 'temperatura', 406.0000, 'ºC'),
	(197401, 119, '2014-02-15 00:56:53.000000', 'temperatura', 1021.0000, 'ºC'),
	(197402, 119, '2014-02-15 00:56:54.000000', 'temperatura', 287.0000, 'ºC'),
	(197403, 119, '2014-02-15 00:56:55.000000', 'temperatura', 773.0000, 'ºC'),
	(197404, 119, '2014-02-15 00:56:56.000000', 'temperatura', 604.0000, 'ºC'),
	(197405, 119, '2014-02-15 00:56:57.000000', 'temperatura', 700.0000, 'ºC'),
	(197406, 119, '2014-02-15 00:56:58.000000', 'temperatura', 488.0000, 'ºC'),
	(197407, 119, '2014-02-15 00:56:59.000000', 'temperatura', 344.0000, 'ºC'),
	(197408, 119, '2014-02-15 00:57:00.000000', 'temperatura', 253.0000, 'ºC'),
	(197409, 119, '2014-02-15 00:57:01.000000', 'temperatura', 237.0000, 'ºC'),
	(197410, 119, '2014-02-15 00:57:02.000000', 'temperatura', 424.0000, 'ºC'),
	(197411, 119, '2014-02-15 00:57:03.000000', 'temperatura', 210.0000, 'ºC'),
	(197412, 119, '2014-02-15 00:57:04.000000', 'temperatura', 979.0000, 'ºC'),
	(197413, 119, '2014-02-15 00:57:05.000000', 'temperatura', 664.0000, 'ºC'),
	(197414, 119, '2014-02-15 00:57:06.000000', 'temperatura', 385.0000, 'ºC'),
	(197415, 119, '2014-02-15 00:57:07.000000', 'temperatura', 1132.0000, 'ºC'),
	(197416, 119, '2014-02-15 00:57:08.000000', 'temperatura', 905.0000, 'ºC'),
	(197417, 119, '2014-02-15 00:57:09.000000', 'temperatura', 1132.0000, 'ºC'),
	(197418, 119, '2014-02-15 00:57:10.000000', 'temperatura', 545.0000, 'ºC'),
	(197419, 119, '2014-02-15 00:57:11.000000', 'temperatura', 530.0000, 'ºC'),
	(197420, 119, '2014-02-15 00:57:12.000000', 'temperatura', 1014.0000, 'ºC'),
	(197421, 119, '2014-02-15 00:57:13.000000', 'temperatura', 1082.0000, 'ºC'),
	(197422, 119, '2014-02-15 00:57:14.000000', 'temperatura', 1167.0000, 'ºC'),
	(197423, 119, '2014-02-15 00:57:15.000000', 'temperatura', 188.0000, 'ºC'),
	(197424, 119, '2014-02-15 00:57:16.000000', 'temperatura', 1042.0000, 'ºC'),
	(197425, 119, '2014-02-15 00:57:17.000000', 'temperatura', 1044.0000, 'ºC'),
	(197426, 119, '2014-02-15 00:57:18.000000', 'temperatura', 895.0000, 'ºC'),
	(197427, 119, '2014-02-15 00:57:19.000000', 'temperatura', 144.0000, 'ºC'),
	(197428, 119, '2014-02-15 00:57:20.000000', 'temperatura', 436.0000, 'ºC'),
	(197429, 119, '2014-02-15 00:57:21.000000', 'temperatura', 549.0000, 'ºC'),
	(197430, 119, '2014-02-15 00:57:22.000000', 'temperatura', 236.0000, 'ºC'),
	(197431, 119, '2014-02-15 00:57:23.000000', 'temperatura', 735.0000, 'ºC'),
	(197432, 119, '2014-02-15 00:57:24.000000', 'temperatura', 566.0000, 'ºC'),
	(197433, 119, '2014-02-15 00:57:25.000000', 'temperatura', 627.0000, 'ºC'),
	(197434, 119, '2014-02-15 00:57:26.000000', 'temperatura', 239.0000, 'ºC'),
	(197435, 119, '2014-02-15 00:57:27.000000', 'temperatura', 512.0000, 'ºC'),
	(197436, 119, '2014-02-15 00:57:28.000000', 'temperatura', 644.0000, 'ºC'),
	(197437, 119, '2014-02-15 00:57:29.000000', 'temperatura', 483.0000, 'ºC'),
	(197438, 119, '2014-02-15 00:57:30.000000', 'temperatura', 485.0000, 'ºC'),
	(197439, 119, '2014-02-15 00:57:31.000000', 'temperatura', 975.0000, 'ºC'),
	(197440, 119, '2014-02-15 00:57:32.000000', 'temperatura', 1022.0000, 'ºC'),
	(197441, 119, '2014-02-15 00:57:33.000000', 'temperatura', 983.0000, 'ºC'),
	(197442, 119, '2014-02-15 00:57:34.000000', 'temperatura', 651.0000, 'ºC'),
	(197443, 119, '2014-02-15 00:57:35.000000', 'temperatura', 308.0000, 'ºC'),
	(197444, 119, '2014-02-15 00:57:36.000000', 'temperatura', 787.0000, 'ºC'),
	(197445, 119, '2014-02-15 00:57:37.000000', 'temperatura', 612.0000, 'ºC'),
	(197446, 119, '2014-02-15 00:57:38.000000', 'temperatura', 698.0000, 'ºC'),
	(197447, 119, '2014-02-15 00:57:39.000000', 'temperatura', 456.0000, 'ºC'),
	(197448, 119, '2014-02-15 00:57:40.000000', 'temperatura', 184.0000, 'ºC'),
	(197449, 119, '2014-02-15 00:57:41.000000', 'temperatura', 753.0000, 'ºC'),
	(197450, 119, '2014-02-15 00:57:42.000000', 'temperatura', 814.0000, 'ºC'),
	(197451, 119, '2014-02-15 00:57:43.000000', 'temperatura', 610.0000, 'ºC'),
	(197452, 119, '2014-02-15 00:57:44.000000', 'temperatura', 610.0000, 'ºC'),
	(197453, 119, '2014-02-15 00:57:45.000000', 'temperatura', 21.0000, 'ºC'),
	(197454, 119, '2014-02-15 00:57:46.000000', 'temperatura', 675.0000, 'ºC'),
	(197455, 119, '2014-02-15 00:57:47.000000', 'temperatura', 911.0000, 'ºC'),
	(197456, 119, '2014-02-15 00:57:48.000000', 'temperatura', 129.0000, 'ºC'),
	(197457, 119, '2014-02-15 00:57:49.000000', 'temperatura', 316.0000, 'ºC'),
	(197458, 119, '2014-02-15 00:57:50.000000', 'temperatura', 1193.0000, 'ºC'),
	(197459, 119, '2014-02-15 00:57:51.000000', 'temperatura', 217.0000, 'ºC'),
	(197460, 119, '2014-02-15 00:57:52.000000', 'temperatura', 1107.0000, 'ºC'),
	(197461, 119, '2014-02-15 00:57:53.000000', 'temperatura', 83.0000, 'ºC'),
	(197462, 119, '2014-02-15 00:57:54.000000', 'temperatura', 694.0000, 'ºC'),
	(197463, 119, '2014-02-15 00:57:55.000000', 'temperatura', 824.0000, 'ºC'),
	(197464, 119, '2014-02-15 00:57:56.000000', 'temperatura', 839.0000, 'ºC'),
	(197465, 119, '2014-02-15 00:57:57.000000', 'temperatura', 521.0000, 'ºC'),
	(197466, 119, '2014-02-15 00:57:58.000000', 'temperatura', 89.0000, 'ºC'),
	(197467, 119, '2014-02-15 00:57:59.000000', 'temperatura', 82.0000, 'ºC'),
	(197468, 119, '2014-02-15 00:58:00.000000', 'temperatura', 143.0000, 'ºC'),
	(197469, 119, '2014-02-15 00:58:01.000000', 'temperatura', 471.0000, 'ºC'),
	(197470, 119, '2014-02-15 00:58:02.000000', 'temperatura', 724.0000, 'ºC'),
	(197471, 119, '2014-02-15 00:58:03.000000', 'temperatura', 1011.0000, 'ºC'),
	(197472, 119, '2014-02-15 00:58:04.000000', 'temperatura', 482.0000, 'ºC'),
	(197473, 119, '2014-02-15 00:58:05.000000', 'temperatura', 576.0000, 'ºC'),
	(197474, 119, '2014-02-15 00:58:06.000000', 'temperatura', 235.0000, 'ºC'),
	(197475, 119, '2014-02-15 00:58:07.000000', 'temperatura', 646.0000, 'ºC'),
	(197476, 119, '2014-02-15 00:58:08.000000', 'temperatura', 129.0000, 'ºC'),
	(197477, 119, '2014-02-15 00:58:09.000000', 'temperatura', 1104.0000, 'ºC'),
	(197478, 119, '2014-02-15 00:58:10.000000', 'temperatura', 335.0000, 'ºC'),
	(197479, 119, '2014-02-15 00:58:11.000000', 'temperatura', 764.0000, 'ºC'),
	(197480, 119, '2014-02-15 00:58:12.000000', 'temperatura', 415.0000, 'ºC'),
	(197481, 119, '2014-02-15 00:58:13.000000', 'temperatura', 982.0000, 'ºC'),
	(197482, 119, '2014-02-15 00:58:14.000000', 'temperatura', 65.0000, 'ºC'),
	(197483, 119, '2014-02-15 00:58:15.000000', 'temperatura', 981.0000, 'ºC'),
	(197484, 119, '2014-02-15 00:58:16.000000', 'temperatura', 1111.0000, 'ºC'),
	(197485, 119, '2014-02-15 00:58:17.000000', 'temperatura', 214.0000, 'ºC'),
	(197486, 119, '2014-02-15 00:58:18.000000', 'temperatura', 136.0000, 'ºC'),
	(197487, 119, '2014-02-15 00:58:19.000000', 'temperatura', 38.0000, 'ºC'),
	(197488, 119, '2014-02-15 00:58:20.000000', 'temperatura', 982.0000, 'ºC'),
	(197489, 119, '2014-02-15 00:58:21.000000', 'temperatura', 1198.0000, 'ºC'),
	(197490, 119, '2014-02-15 00:58:22.000000', 'temperatura', 646.0000, 'ºC'),
	(197491, 119, '2014-02-15 00:58:23.000000', 'temperatura', 835.0000, 'ºC'),
	(197492, 119, '2014-02-15 00:58:24.000000', 'temperatura', 1036.0000, 'ºC'),
	(197493, 119, '2014-02-15 00:58:25.000000', 'temperatura', 274.0000, 'ºC'),
	(197494, 119, '2014-02-15 00:58:26.000000', 'temperatura', 666.0000, 'ºC'),
	(197495, 119, '2014-02-15 00:58:27.000000', 'temperatura', 108.0000, 'ºC'),
	(197496, 119, '2014-02-15 00:58:28.000000', 'temperatura', 942.0000, 'ºC'),
	(197497, 119, '2014-02-15 00:58:29.000000', 'temperatura', 788.0000, 'ºC'),
	(197498, 119, '2014-02-15 00:58:30.000000', 'temperatura', 1113.0000, 'ºC'),
	(197499, 119, '2014-02-15 00:58:31.000000', 'temperatura', 803.0000, 'ºC'),
	(197500, 119, '2014-02-15 00:58:32.000000', 'temperatura', 677.0000, 'ºC'),
	(197501, 119, '2014-02-15 00:58:33.000000', 'temperatura', 977.0000, 'ºC'),
	(197502, 119, '2014-02-15 00:58:34.000000', 'temperatura', 455.0000, 'ºC'),
	(197503, 119, '2014-02-15 00:58:35.000000', 'temperatura', 544.0000, 'ºC'),
	(197504, 119, '2014-02-15 00:58:36.000000', 'temperatura', 154.0000, 'ºC'),
	(197505, 119, '2014-02-15 00:58:37.000000', 'temperatura', 337.0000, 'ºC'),
	(197506, 119, '2014-02-15 00:58:38.000000', 'temperatura', 27.0000, 'ºC'),
	(197507, 119, '2014-02-15 00:58:39.000000', 'temperatura', 323.0000, 'ºC'),
	(197508, 119, '2014-02-15 00:58:40.000000', 'temperatura', 335.0000, 'ºC'),
	(197509, 119, '2014-02-15 00:58:41.000000', 'temperatura', 706.0000, 'ºC'),
	(197510, 119, '2014-02-15 00:58:42.000000', 'temperatura', 124.0000, 'ºC'),
	(197511, 119, '2014-02-15 00:58:43.000000', 'temperatura', 902.0000, 'ºC'),
	(197512, 119, '2014-02-15 00:58:44.000000', 'temperatura', 538.0000, 'ºC'),
	(197513, 119, '2014-02-15 00:58:45.000000', 'temperatura', 1186.0000, 'ºC'),
	(197514, 119, '2014-02-15 00:58:46.000000', 'temperatura', 716.0000, 'ºC'),
	(197515, 119, '2014-02-15 00:58:47.000000', 'temperatura', 24.0000, 'ºC'),
	(197516, 119, '2014-02-15 00:58:48.000000', 'temperatura', 369.0000, 'ºC'),
	(197517, 119, '2014-02-15 00:58:49.000000', 'temperatura', 577.0000, 'ºC'),
	(197518, 119, '2014-02-15 00:58:50.000000', 'temperatura', 579.0000, 'ºC'),
	(197519, 119, '2014-02-15 00:58:51.000000', 'temperatura', 1162.0000, 'ºC'),
	(197520, 119, '2014-02-15 00:58:52.000000', 'temperatura', 474.0000, 'ºC'),
	(197521, 119, '2014-02-15 00:58:53.000000', 'temperatura', 83.0000, 'ºC'),
	(197522, 119, '2014-02-15 00:58:54.000000', 'temperatura', 196.0000, 'ºC'),
	(197523, 119, '2014-02-15 00:58:55.000000', 'temperatura', 732.0000, 'ºC'),
	(197524, 119, '2014-02-15 00:58:56.000000', 'temperatura', 672.0000, 'ºC'),
	(197525, 119, '2014-02-15 00:58:57.000000', 'temperatura', 1165.0000, 'ºC'),
	(197526, 119, '2014-02-15 00:58:58.000000', 'temperatura', 210.0000, 'ºC'),
	(197527, 119, '2014-02-15 00:58:59.000000', 'temperatura', 1153.0000, 'ºC'),
	(197528, 119, '2014-02-15 00:59:00.000000', 'temperatura', 337.0000, 'ºC'),
	(197529, 119, '2014-02-15 00:59:01.000000', 'temperatura', 627.0000, 'ºC'),
	(197530, 119, '2014-02-15 00:59:02.000000', 'temperatura', 924.0000, 'ºC'),
	(197531, 119, '2014-02-15 00:59:03.000000', 'temperatura', 341.0000, 'ºC'),
	(197532, 119, '2014-02-15 00:59:04.000000', 'temperatura', 132.0000, 'ºC'),
	(197533, 119, '2014-02-15 00:59:05.000000', 'temperatura', 837.0000, 'ºC'),
	(197534, 119, '2014-02-15 00:59:06.000000', 'temperatura', 189.0000, 'ºC'),
	(197535, 119, '2014-02-15 00:59:07.000000', 'temperatura', 834.0000, 'ºC'),
	(197536, 119, '2014-02-15 00:59:08.000000', 'temperatura', 3.0000, 'ºC'),
	(197537, 119, '2014-02-15 00:59:09.000000', 'temperatura', 1116.0000, 'ºC'),
	(197538, 119, '2014-02-15 00:59:10.000000', 'temperatura', 772.0000, 'ºC'),
	(197539, 119, '2014-02-15 00:59:11.000000', 'temperatura', 512.0000, 'ºC'),
	(197540, 119, '2014-02-15 00:59:12.000000', 'temperatura', 246.0000, 'ºC'),
	(197541, 119, '2014-02-15 00:59:13.000000', 'temperatura', 893.0000, 'ºC'),
	(197542, 119, '2014-02-15 00:59:14.000000', 'temperatura', 129.0000, 'ºC'),
	(197543, 119, '2014-02-15 00:59:15.000000', 'temperatura', 364.0000, 'ºC'),
	(197544, 119, '2014-02-15 00:59:16.000000', 'temperatura', 236.0000, 'ºC'),
	(197545, 119, '2014-02-15 00:59:17.000000', 'temperatura', 90.0000, 'ºC'),
	(197546, 119, '2014-02-15 00:59:18.000000', 'temperatura', 939.0000, 'ºC'),
	(197547, 119, '2014-02-15 00:59:19.000000', 'temperatura', 826.0000, 'ºC'),
	(197548, 119, '2014-02-15 00:59:20.000000', 'temperatura', 113.0000, 'ºC'),
	(197549, 119, '2014-02-15 00:59:21.000000', 'temperatura', 487.0000, 'ºC'),
	(197550, 119, '2014-02-15 00:59:22.000000', 'temperatura', 897.0000, 'ºC'),
	(197551, 119, '2014-02-15 00:59:23.000000', 'temperatura', 623.0000, 'ºC'),
	(197552, 119, '2014-02-15 00:59:24.000000', 'temperatura', 427.0000, 'ºC'),
	(197553, 119, '2014-02-15 00:59:25.000000', 'temperatura', 264.0000, 'ºC'),
	(197554, 119, '2014-02-15 00:59:26.000000', 'temperatura', 42.0000, 'ºC'),
	(197555, 119, '2014-02-15 00:59:27.000000', 'temperatura', 617.0000, 'ºC'),
	(197556, 119, '2014-02-15 00:59:28.000000', 'temperatura', 559.0000, 'ºC'),
	(197557, 119, '2014-02-15 00:59:29.000000', 'temperatura', 944.0000, 'ºC'),
	(197558, 119, '2014-02-15 00:59:30.000000', 'temperatura', 643.0000, 'ºC'),
	(197559, 119, '2014-02-15 00:59:31.000000', 'temperatura', 385.0000, 'ºC'),
	(197560, 119, '2014-02-15 00:59:32.000000', 'temperatura', 1196.0000, 'ºC'),
	(197561, 119, '2014-02-15 00:59:33.000000', 'temperatura', 25.0000, 'ºC'),
	(197562, 119, '2014-02-15 00:59:34.000000', 'temperatura', 138.0000, 'ºC'),
	(197563, 119, '2014-02-15 00:59:35.000000', 'temperatura', 615.0000, 'ºC'),
	(197564, 119, '2014-02-15 00:59:36.000000', 'temperatura', 260.0000, 'ºC'),
	(197565, 119, '2014-02-15 00:59:37.000000', 'temperatura', 656.0000, 'ºC'),
	(197566, 119, '2014-02-15 00:59:38.000000', 'temperatura', 101.0000, 'ºC'),
	(197567, 119, '2014-02-15 00:59:39.000000', 'temperatura', 936.0000, 'ºC'),
	(197568, 119, '2014-02-15 00:59:40.000000', 'temperatura', 778.0000, 'ºC'),
	(197569, 119, '2014-02-15 00:59:41.000000', 'temperatura', 1082.0000, 'ºC'),
	(197570, 119, '2014-02-15 00:59:42.000000', 'temperatura', 679.0000, 'ºC'),
	(197571, 119, '2014-02-15 00:59:43.000000', 'temperatura', 147.0000, 'ºC'),
	(197572, 119, '2014-02-15 00:59:44.000000', 'temperatura', 1101.0000, 'ºC'),
	(197573, 119, '2014-02-15 00:59:45.000000', 'temperatura', 263.0000, 'ºC'),
	(197574, 119, '2014-02-15 00:59:46.000000', 'temperatura', 411.0000, 'ºC'),
	(197575, 119, '2014-02-15 00:59:47.000000', 'temperatura', 66.0000, 'ºC'),
	(197576, 119, '2014-02-15 00:59:48.000000', 'temperatura', 300.0000, 'ºC'),
	(197577, 119, '2014-02-15 00:59:49.000000', 'temperatura', 101.0000, 'ºC'),
	(197578, 119, '2014-02-15 00:59:50.000000', 'temperatura', 805.0000, 'ºC'),
	(197579, 119, '2014-02-15 00:59:51.000000', 'temperatura', 123.0000, 'ºC'),
	(197580, 119, '2014-02-15 00:59:52.000000', 'temperatura', 600.0000, 'ºC'),
	(197581, 119, '2014-02-15 00:59:53.000000', 'temperatura', 231.0000, 'ºC'),
	(197582, 119, '2014-02-15 00:59:54.000000', 'temperatura', 558.0000, 'ºC'),
	(197583, 119, '2014-02-15 00:59:55.000000', 'temperatura', 895.0000, 'ºC'),
	(197584, 119, '2014-02-15 00:59:56.000000', 'temperatura', 402.0000, 'ºC'),
	(197585, 119, '2014-02-15 00:59:57.000000', 'temperatura', 527.0000, 'ºC'),
	(197586, 119, '2014-02-15 00:59:58.000000', 'temperatura', 230.0000, 'ºC'),
	(197587, 119, '2014-02-15 00:59:59.000000', 'temperatura', 767.0000, 'ºC'),
	(197588, 119, '2014-02-15 01:00:00.000000', 'temperatura', 745.0000, 'ºC'),
	(197589, 119, '2014-02-15 01:00:01.000000', 'temperatura', 225.0000, 'ºC'),
	(197590, 119, '2014-02-15 01:00:02.000000', 'temperatura', 90.0000, 'ºC'),
	(197591, 119, '2014-02-15 01:00:03.000000', 'temperatura', 978.0000, 'ºC'),
	(197592, 119, '2014-02-15 01:00:04.000000', 'temperatura', 1018.0000, 'ºC'),
	(197593, 119, '2014-02-15 01:00:05.000000', 'temperatura', 959.0000, 'ºC'),
	(197594, 119, '2014-02-15 01:00:06.000000', 'temperatura', 539.0000, 'ºC'),
	(197595, 119, '2014-02-15 01:00:07.000000', 'temperatura', 1021.0000, 'ºC'),
	(197596, 119, '2014-02-15 01:00:08.000000', 'temperatura', 1086.0000, 'ºC'),
	(197597, 119, '2014-02-15 01:00:09.000000', 'temperatura', 1171.0000, 'ºC'),
	(197598, 119, '2014-02-15 01:00:10.000000', 'temperatura', 194.0000, 'ºC'),
	(197599, 119, '2014-02-15 01:00:11.000000', 'temperatura', 1058.0000, 'ºC'),
	(197600, 119, '2014-02-15 01:00:12.000000', 'temperatura', 1108.0000, 'ºC'),
	(197601, 119, '2014-02-15 01:00:13.000000', 'temperatura', 1167.0000, 'ºC'),
	(197602, 119, '2014-02-15 01:00:14.000000', 'temperatura', 113.0000, 'ºC'),
	(197603, 119, '2014-02-15 01:00:15.000000', 'temperatura', 665.0000, 'ºC'),
	(197604, 119, '2014-02-15 01:00:16.000000', 'temperatura', 586.0000, 'ºC'),
	(197605, 119, '2014-02-15 01:00:17.000000', 'temperatura', 935.0000, 'ºC'),
	(197606, 119, '2014-02-15 01:00:18.000000', 'temperatura', 516.0000, 'ºC'),
	(197607, 119, '2014-02-15 01:00:19.000000', 'temperatura', 979.0000, 'ºC'),
	(197608, 119, '2014-02-15 01:00:20.000000', 'temperatura', 944.0000, 'ºC'),
	(197609, 119, '2014-02-15 01:00:21.000000', 'temperatura', 585.0000, 'ºC'),
	(197610, 119, '2014-02-15 01:00:22.000000', 'temperatura', 94.0000, 'ºC'),
	(197611, 119, '2014-02-15 01:00:23.000000', 'temperatura', 1114.0000, 'ºC'),
	(197612, 119, '2014-02-15 01:00:24.000000', 'temperatura', 489.0000, 'ºC'),
	(197613, 119, '2014-02-15 01:00:25.000000', 'temperatura', 304.0000, 'ºC'),
	(197614, 119, '2014-02-15 01:00:26.000000', 'temperatura', 53.0000, 'ºC'),
	(197615, 119, '2014-02-15 01:00:27.000000', 'temperatura', 554.0000, 'ºC'),
	(197616, 119, '2014-02-15 01:00:28.000000', 'temperatura', 210.0000, 'ºC'),
	(197617, 119, '2014-02-15 01:00:29.000000', 'temperatura', 591.0000, 'ºC'),
	(197618, 119, '2014-02-15 01:00:30.000000', 'temperatura', 1123.0000, 'ºC'),
	(197619, 119, '2014-02-15 01:00:31.000000', 'temperatura', 242.0000, 'ºC'),
	(197620, 119, '2014-02-15 01:00:32.000000', 'temperatura', 244.0000, 'ºC'),
	(197621, 119, '2014-02-15 01:00:33.000000', 'temperatura', 493.0000, 'ºC'),
	(197622, 119, '2014-02-15 01:00:34.000000', 'temperatura', 534.0000, 'ºC'),
	(197623, 119, '2014-02-15 01:00:35.000000', 'temperatura', 1190.0000, 'ºC'),
	(197624, 119, '2014-02-15 01:00:36.000000', 'temperatura', 748.0000, 'ºC'),
	(197625, 119, '2014-02-15 01:00:37.000000', 'temperatura', 173.0000, 'ºC'),
	(197626, 119, '2014-02-15 01:00:38.000000', 'temperatura', 1020.0000, 'ºC'),
	(197627, 119, '2014-02-15 01:00:39.000000', 'temperatura', 982.0000, 'ºC'),
	(197628, 119, '2014-02-15 01:00:40.000000', 'temperatura', 652.0000, 'ºC'),
	(197629, 119, '2014-02-15 01:00:41.000000', 'temperatura', 314.0000, 'ºC'),
	(197630, 119, '2014-02-15 01:00:42.000000', 'temperatura', 813.0000, 'ºC'),
	(197631, 119, '2014-02-15 01:00:43.000000', 'temperatura', 724.0000, 'ºC'),
	(197632, 119, '2014-02-15 01:00:44.000000', 'temperatura', 1180.0000, 'ºC'),
	(197633, 119, '2014-02-15 01:00:45.000000', 'temperatura', 128.0000, 'ºC'),
	(197634, 119, '2014-02-15 01:00:46.000000', 'temperatura', 700.0000, 'ºC'),
	(197635, 119, '2014-02-15 01:00:47.000000', 'temperatura', 719.0000, 'ºC'),
	(197636, 119, '2014-02-15 01:00:48.000000', 'temperatura', 294.0000, 'ºC'),
	(197637, 119, '2014-02-15 01:00:49.000000', 'temperatura', 516.0000, 'ºC'),
	(197638, 119, '2014-02-15 01:00:50.000000', 'temperatura', 497.0000, 'ºC'),
	(197639, 119, '2014-02-15 01:00:51.000000', 'temperatura', 937.0000, 'ºC'),
	(197640, 119, '2014-02-15 01:00:52.000000', 'temperatura', 795.0000, 'ºC'),
	(197641, 119, '2014-02-15 01:00:53.000000', 'temperatura', 1163.0000, 'ºC'),
	(197642, 119, '2014-02-15 01:00:54.000000', 'temperatura', 1033.0000, 'ºC'),
	(197643, 119, '2014-02-15 01:00:55.000000', 'temperatura', 475.0000, 'ºC'),
	(197644, 119, '2014-02-15 01:00:56.000000', 'temperatura', 475.0000, 'ºC'),
	(197645, 119, '2014-02-15 01:00:57.000000', 'temperatura', 951.0000, 'ºC'),
	(197646, 119, '2014-02-15 01:00:58.000000', 'temperatura', 932.0000, 'ºC'),
	(197647, 119, '2014-02-15 01:00:59.000000', 'temperatura', 608.0000, 'ºC'),
	(197648, 119, '2014-02-15 01:01:00.000000', 'temperatura', 242.0000, 'ºC'),
	(197649, 119, '2014-02-15 01:01:01.000000', 'temperatura', 588.0000, 'ºC'),
	(197650, 119, '2014-02-15 01:01:02.000000', 'temperatura', 1016.0000, 'ºC'),
	(197651, 119, '2014-02-15 01:01:03.000000', 'temperatura', 917.0000, 'ºC'),
	(197652, 119, '2014-02-15 01:01:04.000000', 'temperatura', 335.0000, 'ºC'),
	(197653, 119, '2014-02-15 01:01:05.000000', 'temperatura', 125.0000, 'ºC'),
	(197654, 119, '2014-02-15 01:01:06.000000', 'temperatura', 819.0000, 'ºC'),
	(197655, 119, '2014-02-15 01:01:07.000000', 'temperatura', 120.0000, 'ºC'),
	(197656, 119, '2014-02-15 01:01:08.000000', 'temperatura', 547.0000, 'ºC'),
	(197657, 119, '2014-02-15 01:01:09.000000', 'temperatura', 1172.0000, 'ºC'),
	(197658, 119, '2014-02-15 01:01:10.000000', 'temperatura', 622.0000, 'ºC'),
	(197659, 119, '2014-02-15 01:01:11.000000', 'temperatura', 793.0000, 'ºC'),
	(197660, 119, '2014-02-15 01:01:12.000000', 'temperatura', 899.0000, 'ºC'),
	(197661, 119, '2014-02-15 01:01:13.000000', 'temperatura', 919.0000, 'ºC'),
	(197662, 119, '2014-02-15 01:01:14.000000', 'temperatura', 698.0000, 'ºC'),
	(197663, 119, '2014-02-15 01:01:15.000000', 'temperatura', 734.0000, 'ºC'),
	(197664, 119, '2014-02-15 01:01:16.000000', 'temperatura', 375.0000, 'ºC'),
	(197665, 119, '2014-02-15 01:01:17.000000', 'temperatura', 876.0000, 'ºC'),
	(197666, 119, '2014-02-15 01:01:18.000000', 'temperatura', 855.0000, 'ºC'),
	(197667, 119, '2014-02-15 01:01:19.000000', 'temperatura', 446.0000, 'ºC'),
	(197668, 119, '2014-02-15 01:01:20.000000', 'temperatura', 867.0000, 'ºC'),
	(197669, 119, '2014-02-15 01:01:21.000000', 'temperatura', 595.0000, 'ºC'),
	(197670, 119, '2014-02-15 01:01:22.000000', 'temperatura', 378.0000, 'ºC'),
	(197671, 119, '2014-02-15 01:01:23.000000', 'temperatura', 104.0000, 'ºC'),
	(197672, 119, '2014-02-15 01:01:24.000000', 'temperatura', 585.0000, 'ºC'),
	(197673, 119, '2014-02-15 01:01:25.000000', 'temperatura', 217.0000, 'ºC'),
	(197674, 119, '2014-02-15 01:01:26.000000', 'temperatura', 527.0000, 'ºC'),
	(197675, 119, '2014-02-15 01:01:27.000000', 'temperatura', 787.0000, 'ºC'),
	(197676, 119, '2014-02-15 01:01:28.000000', 'temperatura', 1155.0000, 'ºC'),
	(197677, 119, '2014-02-15 01:01:29.000000', 'temperatura', 1013.0000, 'ºC'),
	(197678, 119, '2014-02-15 01:01:30.000000', 'temperatura', 399.0000, 'ºC'),
	(197679, 119, '2014-02-15 01:01:31.000000', 'temperatura', 157.0000, 'ºC'),
	(197680, 119, '2014-02-15 01:01:32.000000', 'temperatura', 788.0000, 'ºC'),
	(197681, 119, '2014-02-15 01:01:33.000000', 'temperatura', 1070.0000, 'ºC'),
	(197682, 119, '2014-02-15 01:01:34.000000', 'temperatura', 588.0000, 'ºC'),
	(197683, 119, '2014-02-15 01:01:35.000000', 'temperatura', 929.0000, 'ºC'),
	(197684, 119, '2014-02-15 01:01:36.000000', 'temperatura', 481.0000, 'ºC'),
	(197685, 119, '2014-02-15 01:01:37.000000', 'temperatura', 818.0000, 'ºC'),
	(197686, 119, '2014-02-15 01:01:38.000000', 'temperatura', 246.0000, 'ºC'),
	(197687, 119, '2014-02-15 01:01:39.000000', 'temperatura', 1180.0000, 'ºC'),
	(197688, 119, '2014-02-15 01:01:40.000000', 'temperatura', 361.0000, 'ºC'),
	(197689, 119, '2014-02-15 01:01:41.000000', 'temperatura', 665.0000, 'ºC'),
	(197690, 119, '2014-02-15 01:01:42.000000', 'temperatura', 1041.0000, 'ºC'),
	(197691, 119, '2014-02-15 01:01:43.000000', 'temperatura', 813.0000, 'ºC'),
	(197692, 119, '2014-02-15 01:01:44.000000', 'temperatura', 940.0000, 'ºC'),
	(197693, 119, '2014-02-15 01:01:45.000000', 'temperatura', 1064.0000, 'ºC'),
	(197694, 119, '2014-02-15 01:01:46.000000', 'temperatura', 98.0000, 'ºC'),
	(197695, 119, '2014-02-15 01:01:47.000000', 'temperatura', 900.0000, 'ºC'),
	(197696, 119, '2014-02-15 01:01:48.000000', 'temperatura', 605.0000, 'ºC'),
	(197697, 119, '2014-02-15 01:01:49.000000', 'temperatura', 328.0000, 'ºC'),
	(197698, 119, '2014-02-15 01:01:50.000000', 'temperatura', 1026.0000, 'ºC'),
	(197699, 119, '2014-02-15 01:01:51.000000', 'temperatura', 547.0000, 'ºC'),
	(197700, 119, '2014-02-15 01:01:52.000000', 'temperatura', 854.0000, 'ºC'),
	(197701, 119, '2014-02-15 01:01:53.000000', 'temperatura', 233.0000, 'ºC'),
	(197702, 119, '2014-02-15 01:01:54.000000', 'temperatura', 1003.0000, 'ºC'),
	(197703, 119, '2014-02-15 01:01:55.000000', 'temperatura', 717.0000, 'ºC'),
	(197704, 119, '2014-02-15 01:01:56.000000', 'temperatura', 574.0000, 'ºC'),
	(197705, 119, '2014-02-15 01:01:57.000000', 'temperatura', 723.0000, 'ºC'),
	(197706, 119, '2014-02-15 01:01:58.000000', 'temperatura', 691.0000, 'ºC'),
	(197707, 119, '2014-02-15 01:01:59.000000', 'temperatura', 85.0000, 'ºC'),
	(197708, 119, '2014-02-15 01:02:00.000000', 'temperatura', 754.0000, 'ºC'),
	(197709, 119, '2014-02-15 01:02:01.000000', 'temperatura', 1116.0000, 'ºC'),
	(197710, 119, '2014-02-15 01:02:02.000000', 'temperatura', 918.0000, 'ºC'),
	(197711, 119, '2014-02-15 01:02:03.000000', 'temperatura', 41.0000, 'ºC'),
	(197712, 119, '2014-02-15 01:02:04.000000', 'temperatura', 1051.0000, 'ºC'),
	(197713, 119, '2014-02-15 01:02:05.000000', 'temperatura', 332.0000, 'ºC'),
	(197714, 119, '2014-02-15 01:02:06.000000', 'temperatura', 910.0000, 'ºC'),
	(197715, 119, '2014-02-15 01:02:07.000000', 'temperatura', 1154.0000, 'ºC'),
	(197716, 119, '2014-02-15 01:02:08.000000', 'temperatura', 641.0000, 'ºC'),
	(197717, 119, '2014-02-15 01:02:09.000000', 'temperatura', 941.0000, 'ºC'),
	(197718, 119, '2014-02-15 01:02:10.000000', 'temperatura', 386.0000, 'ºC'),
	(197719, 119, '2014-02-15 01:02:11.000000', 'temperatura', 305.0000, 'ºC'),
	(197720, 119, '2014-02-15 01:02:12.000000', 'temperatura', 367.0000, 'ºC'),
	(197721, 119, '2014-02-15 01:02:13.000000', 'temperatura', 921.0000, 'ºC'),
	(197722, 119, '2014-02-15 01:02:14.000000', 'temperatura', 1105.0000, 'ºC'),
	(197723, 119, '2014-02-15 01:02:15.000000', 'temperatura', 363.0000, 'ºC'),
	(197724, 119, '2014-02-15 01:02:16.000000', 'temperatura', 901.0000, 'ºC'),
	(197725, 119, '2014-02-15 01:02:17.000000', 'temperatura', 1017.0000, 'ºC'),
	(197726, 119, '2014-02-15 01:02:18.000000', 'temperatura', 1181.0000, 'ºC'),
	(197727, 119, '2014-02-15 01:02:19.000000', 'temperatura', 455.0000, 'ºC'),
	(197728, 119, '2014-02-15 01:02:20.000000', 'temperatura', 1131.0000, 'ºC'),
	(197729, 119, '2014-02-15 01:02:21.000000', 'temperatura', 691.0000, 'ºC'),
	(197730, 119, '2014-02-15 01:02:22.000000', 'temperatura', 63.0000, 'ºC'),
	(197731, 119, '2014-02-15 01:02:23.000000', 'temperatura', 642.0000, 'ºC'),
	(197732, 119, '2014-02-15 01:02:24.000000', 'temperatura', 621.0000, 'ºC'),
	(197733, 119, '2014-02-15 01:02:25.000000', 'temperatura', 1179.0000, 'ºC'),
	(197734, 119, '2014-02-15 01:02:26.000000', 'temperatura', 433.0000, 'ºC'),
	(197735, 119, '2014-02-15 01:02:27.000000', 'temperatura', 1029.0000, 'ºC'),
	(197736, 119, '2014-02-15 01:02:28.000000', 'temperatura', 246.0000, 'ºC'),
	(197737, 119, '2014-02-15 01:02:29.000000', 'temperatura', 545.0000, 'ºC'),
	(197738, 119, '2014-02-15 01:02:30.000000', 'temperatura', 788.0000, 'ºC'),
	(197739, 119, '2014-02-15 01:02:31.000000', 'temperatura', 1106.0000, 'ºC'),
	(197740, 119, '2014-02-15 01:02:32.000000', 'temperatura', 768.0000, 'ºC'),
	(197741, 119, '2014-02-15 01:02:33.000000', 'temperatura', 519.0000, 'ºC'),
	(197742, 119, '2014-02-15 01:02:34.000000', 'temperatura', 292.0000, 'ºC'),
	(197743, 119, '2014-02-15 01:02:35.000000', 'temperatura', 1106.0000, 'ºC'),
	(197744, 119, '2014-02-15 01:02:36.000000', 'temperatura', 1054.0000, 'ºC'),
	(197745, 119, '2014-02-15 01:02:37.000000', 'temperatura', 750.0000, 'ºC'),
	(197746, 119, '2014-02-15 01:02:38.000000', 'temperatura', 589.0000, 'ºC'),
	(197747, 119, '2014-02-15 01:02:39.000000', 'temperatura', 694.0000, 'ºC'),
	(197748, 119, '2014-02-15 01:02:40.000000', 'temperatura', 507.0000, 'ºC'),
	(197749, 119, '2014-02-15 01:02:41.000000', 'temperatura', 451.0000, 'ºC'),
	(197750, 119, '2014-02-15 01:02:42.000000', 'temperatura', 737.0000, 'ºC'),
	(197751, 119, '2014-02-15 01:02:43.000000', 'temperatura', 1132.0000, 'ºC'),
	(197752, 119, '2014-02-15 01:02:44.000000', 'temperatura', 1048.0000, 'ºC'),
	(197753, 119, '2014-02-15 01:02:45.000000', 'temperatura', 646.0000, 'ºC'),
	(197754, 119, '2014-02-15 01:02:46.000000', 'temperatura', 86.0000, 'ºC'),
	(197755, 119, '2014-02-15 01:02:47.000000', 'temperatura', 891.0000, 'ºC'),
	(197756, 119, '2014-02-15 01:02:48.000000', 'temperatura', 599.0000, 'ºC'),
	(197757, 119, '2014-02-15 01:02:49.000000', 'temperatura', 322.0000, 'ºC'),
	(197758, 119, '2014-02-15 01:02:50.000000', 'temperatura', 1015.0000, 'ºC'),
	(197759, 119, '2014-02-15 01:02:51.000000', 'temperatura', 508.0000, 'ºC'),
	(197760, 119, '2014-02-15 01:02:52.000000', 'temperatura', 697.0000, 'ºC'),
	(197761, 119, '2014-02-15 01:02:53.000000', 'temperatura', 760.0000, 'ºC'),
	(197762, 119, '2014-02-15 01:02:54.000000', 'temperatura', 511.0000, 'ºC'),
	(197763, 119, '2014-02-15 01:02:55.000000', 'temperatura', 273.0000, 'ºC'),
	(197764, 119, '2014-02-15 01:02:56.000000', 'temperatura', 1033.0000, 'ºC'),
	(197765, 119, '2014-02-15 01:02:57.000000', 'temperatura', 747.0000, 'ºC'),
	(197766, 119, '2014-02-15 01:02:58.000000', 'temperatura', 637.0000, 'ºC'),
	(197767, 119, '2014-02-15 01:02:59.000000', 'temperatura', 943.0000, 'ºC'),
	(197768, 119, '2014-02-15 01:03:00.000000', 'temperatura', 406.0000, 'ºC'),
	(197769, 119, '2014-02-15 01:03:01.000000', 'temperatura', 402.0000, 'ºC'),
	(197770, 119, '2014-02-15 01:03:02.000000', 'temperatura', 790.0000, 'ºC'),
	(197771, 119, '2014-02-15 01:03:03.000000', 'temperatura', 346.0000, 'ºC'),
	(197772, 119, '2014-02-15 01:03:04.000000', 'temperatura', 562.0000, 'ºC'),
	(197773, 119, '2014-02-15 01:03:05.000000', 'temperatura', 573.0000, 'ºC'),
	(197774, 119, '2014-02-15 01:03:06.000000', 'temperatura', 1180.0000, 'ºC'),
	(197775, 119, '2014-02-15 01:03:07.000000', 'temperatura', 579.0000, 'ºC'),
	(197776, 119, '2014-02-15 01:03:08.000000', 'temperatura', 558.0000, 'ºC'),
	(197777, 119, '2014-02-15 01:03:09.000000', 'temperatura', 1054.0000, 'ºC'),
	(197778, 119, '2014-02-15 01:03:10.000000', 'temperatura', 1196.0000, 'ºC'),
	(197779, 119, '2014-02-15 01:03:11.000000', 'temperatura', 419.0000, 'ºC'),
	(197780, 119, '2014-02-15 01:03:12.000000', 'temperatura', 908.0000, 'ºC'),
	(197781, 119, '2014-02-15 01:03:13.000000', 'temperatura', 882.0000, 'ºC'),
	(197782, 119, '2014-02-15 01:03:14.000000', 'temperatura', 486.0000, 'ºC'),
	(197783, 119, '2014-02-15 01:03:15.000000', 'temperatura', 987.0000, 'ºC'),
	(197784, 119, '2014-02-15 01:03:16.000000', 'temperatura', 1077.0000, 'ºC'),
	(197785, 119, '2014-02-15 01:03:17.000000', 'temperatura', 24.0000, 'ºC'),
	(197786, 119, '2014-02-15 01:03:18.000000', 'temperatura', 491.0000, 'ºC'),
	(197787, 119, '2014-02-15 01:03:19.000000', 'temperatura', 1182.0000, 'ºC'),
	(197788, 119, '2014-02-15 01:03:20.000000', 'temperatura', 836.0000, 'ºC'),
	(197789, 119, '2014-02-15 01:03:21.000000', 'temperatura', 638.0000, 'ºC'),
	(197790, 119, '2014-02-15 01:03:22.000000', 'temperatura', 679.0000, 'ºC'),
	(197791, 119, '2014-02-15 01:03:23.000000', 'temperatura', 284.0000, 'ºC'),
	(197792, 119, '2014-02-15 01:03:24.000000', 'temperatura', 584.0000, 'ºC'),
	(197793, 119, '2014-02-15 01:03:25.000000', 'temperatura', 868.0000, 'ºC'),
	(197794, 119, '2014-02-15 01:03:26.000000', 'temperatura', 189.0000, 'ºC'),
	(197795, 119, '2014-02-15 01:03:27.000000', 'temperatura', 741.0000, 'ºC'),
	(197796, 119, '2014-02-15 01:03:28.000000', 'temperatura', 738.0000, 'ºC'),
	(197797, 119, '2014-02-15 01:03:29.000000', 'temperatura', 269.0000, 'ºC'),
	(197798, 119, '2014-02-15 01:03:30.000000', 'temperatura', 329.0000, 'ºC'),
	(197799, 119, '2014-02-15 01:03:31.000000', 'temperatura', 838.0000, 'ºC'),
	(197800, 119, '2014-02-15 01:03:32.000000', 'temperatura', 804.0000, 'ºC'),
	(197801, 119, '2014-02-15 01:03:33.000000', 'temperatura', 307.0000, 'ºC'),
	(197802, 119, '2014-02-15 01:03:34.000000', 'temperatura', 322.0000, 'ºC'),
	(197803, 119, '2014-02-15 01:03:35.000000', 'temperatura', 692.0000, 'ºC'),
	(197804, 119, '2014-02-15 01:03:36.000000', 'temperatura', 92.0000, 'ºC'),
	(197805, 119, '2014-02-15 01:03:37.000000', 'temperatura', 784.0000, 'ºC'),
	(197806, 119, '2014-02-15 01:03:38.000000', 'temperatura', 44.0000, 'ºC'),
	(197807, 119, '2014-02-15 01:03:39.000000', 'temperatura', 269.0000, 'ºC'),
	(197808, 119, '2014-02-15 01:03:40.000000', 'temperatura', 12.0000, 'ºC'),
	(197809, 119, '2014-02-15 01:03:41.000000', 'temperatura', 454.0000, 'ºC'),
	(197810, 119, '2014-02-15 01:03:42.000000', 'temperatura', 1035.0000, 'ºC'),
	(197811, 119, '2014-02-15 01:03:43.000000', 'temperatura', 215.0000, 'ºC'),
	(197812, 119, '2014-02-15 01:03:44.000000', 'temperatura', 368.0000, 'ºC'),
	(197813, 119, '2014-02-15 01:03:45.000000', 'temperatura', 1195.0000, 'ºC'),
	(197814, 119, '2014-02-15 01:03:46.000000', 'temperatura', 72.0000, 'ºC'),
	(197815, 119, '2014-02-15 01:03:47.000000', 'temperatura', 376.0000, 'ºC'),
	(197816, 119, '2014-02-15 01:03:48.000000', 'temperatura', 465.0000, 'ºC'),
	(197817, 119, '2014-02-15 01:03:49.000000', 'temperatura', 1196.0000, 'ºC'),
	(197818, 119, '2014-02-15 01:03:50.000000', 'temperatura', 986.0000, 'ºC'),
	(197819, 119, '2014-02-15 01:03:51.000000', 'temperatura', 141.0000, 'ºC'),
	(197820, 119, '2014-02-15 01:03:52.000000', 'temperatura', 148.0000, 'ºC'),
	(197821, 119, '2014-02-15 01:03:53.000000', 'temperatura', 317.0000, 'ºC'),
	(197822, 119, '2014-02-15 01:03:54.000000', 'temperatura', 1142.0000, 'ºC'),
	(197823, 119, '2014-02-15 01:03:55.000000', 'temperatura', 1158.0000, 'ºC'),
	(197824, 119, '2014-02-15 01:03:56.000000', 'temperatura', 1166.0000, 'ºC'),
	(197825, 119, '2014-02-15 01:03:57.000000', 'temperatura', 1157.0000, 'ºC'),
	(197826, 119, '2014-02-15 01:03:58.000000', 'temperatura', 1087.0000, 'ºC'),
	(197827, 119, '2014-02-15 01:03:59.000000', 'temperatura', 764.0000, 'ºC'),
	(197828, 119, '2014-02-15 01:04:00.000000', 'temperatura', 560.0000, 'ºC'),
	(197829, 119, '2014-02-15 01:04:01.000000', 'temperatura', 508.0000, 'ºC'),
	(197830, 119, '2014-02-15 01:04:02.000000', 'temperatura', 859.0000, 'ºC'),
	(197831, 119, '2014-02-15 01:04:03.000000', 'temperatura', 374.0000, 'ºC'),
	(197832, 119, '2014-02-15 01:04:04.000000', 'temperatura', 491.0000, 'ºC'),
	(197833, 119, '2014-02-15 01:04:05.000000', 'temperatura', 133.0000, 'ºC'),
	(197834, 119, '2014-02-15 01:04:06.000000', 'temperatura', 392.0000, 'ºC'),
	(197835, 119, '2014-02-15 01:04:07.000000', 'temperatura', 365.0000, 'ºC'),
	(197836, 119, '2014-02-15 01:04:08.000000', 'temperatura', 647.0000, 'ºC'),
	(197837, 119, '2014-02-15 01:04:09.000000', 'temperatura', 940.0000, 'ºC'),
	(197838, 119, '2014-02-15 01:04:10.000000', 'temperatura', 360.0000, 'ºC'),
	(197839, 119, '2014-02-15 01:04:11.000000', 'temperatura', 180.0000, 'ºC'),
	(197840, 119, '2014-02-15 01:04:12.000000', 'temperatura', 1022.0000, 'ºC'),
	(197841, 119, '2014-02-15 01:04:13.000000', 'temperatura', 970.0000, 'ºC'),
	(197842, 119, '2014-02-15 01:04:14.000000', 'temperatura', 585.0000, 'ºC'),
	(197843, 119, '2014-02-15 01:04:15.000000', 'temperatura', 13.0000, 'ºC'),
	(197844, 119, '2014-02-15 01:04:16.000000', 'temperatura', 713.0000, 'ºC'),
	(197845, 119, '2014-02-15 01:04:17.000000', 'temperatura', 1126.0000, 'ºC'),
	(197846, 119, '2014-02-15 01:04:18.000000', 'temperatura', 1090.0000, 'ºC'),
	(197847, 119, '2014-02-15 01:04:19.000000', 'temperatura', 876.0000, 'ºC'),
	(197848, 119, '2014-02-15 01:04:20.000000', 'temperatura', 1107.0000, 'ºC'),
	(197849, 119, '2014-02-15 01:04:21.000000', 'temperatura', 507.0000, 'ºC'),
	(197850, 119, '2014-02-15 01:04:22.000000', 'temperatura', 418.0000, 'ºC'),
	(197851, 119, '2014-02-15 01:04:23.000000', 'temperatura', 566.0000, 'ºC'),
	(197852, 119, '2014-02-15 01:04:24.000000', 'temperatura', 378.0000, 'ºC'),
	(197853, 119, '2014-02-15 01:04:25.000000', 'temperatura', 193.0000, 'ºC'),
	(197854, 119, '2014-02-15 01:04:26.000000', 'temperatura', 1031.0000, 'ºC'),
	(197855, 119, '2014-02-15 01:04:27.000000', 'temperatura', 976.0000, 'ºC'),
	(197856, 119, '2014-02-15 01:04:28.000000', 'temperatura', 587.0000, 'ºC'),
	(197857, 119, '2014-02-15 01:04:29.000000', 'temperatura', 6.0000, 'ºC'),
	(197858, 119, '2014-02-15 01:04:30.000000', 'temperatura', 673.0000, 'ºC'),
	(197859, 119, '2014-02-15 01:04:31.000000', 'temperatura', 945.0000, 'ºC'),
	(197860, 119, '2014-02-15 01:04:32.000000', 'temperatura', 308.0000, 'ºC'),
	(197861, 119, '2014-02-15 01:04:33.000000', 'temperatura', 1104.0000, 'ºC'),
	(197862, 119, '2014-02-15 01:04:34.000000', 'temperatura', 995.0000, 'ºC'),
	(197863, 119, '2014-02-15 01:04:35.000000', 'temperatura', 466.0000, 'ºC'),
	(197864, 119, '2014-02-15 01:04:36.000000', 'temperatura', 545.0000, 'ºC'),
	(197865, 119, '2014-02-15 01:04:37.000000', 'temperatura', 128.0000, 'ºC'),
	(197866, 119, '2014-02-15 01:04:38.000000', 'temperatura', 206.0000, 'ºC'),
	(197867, 119, '2014-02-15 01:04:39.000000', 'temperatura', 644.0000, 'ºC'),
	(197868, 119, '2014-02-15 01:04:40.000000', 'temperatura', 206.0000, 'ºC'),
	(197869, 119, '2014-02-15 01:04:41.000000', 'temperatura', 295.0000, 'ºC'),
	(197870, 119, '2014-02-15 01:04:42.000000', 'temperatura', 859.0000, 'ºC'),
	(197871, 119, '2014-02-15 01:04:43.000000', 'temperatura', 1008.0000, 'ºC'),
	(197872, 119, '2014-02-15 01:04:44.000000', 'temperatura', 67.0000, 'ºC'),
	(197873, 119, '2014-02-15 01:04:45.000000', 'temperatura', 910.0000, 'ºC'),
	(197874, 119, '2014-02-15 01:04:46.000000', 'temperatura', 750.0000, 'ºC'),
	(197875, 119, '2014-02-15 01:04:47.000000', 'temperatura', 1021.0000, 'ºC'),
	(197876, 119, '2014-02-15 01:04:48.000000', 'temperatura', 457.0000, 'ºC'),
	(197877, 119, '2014-02-15 01:04:49.000000', 'temperatura', 421.0000, 'ºC'),
	(197878, 119, '2014-02-15 01:04:50.000000', 'temperatura', 736.0000, 'ºC'),
	(197879, 119, '2014-02-15 01:04:51.000000', 'temperatura', 17.0000, 'ºC'),
	(197880, 119, '2014-02-15 01:04:52.000000', 'temperatura', 275.0000, 'ºC'),
	(197881, 119, '2014-02-15 01:04:53.000000', 'temperatura', 128.0000, 'ºC'),
	(197882, 119, '2014-02-15 01:04:54.000000', 'temperatura', 1013.0000, 'ºC'),
	(197883, 119, '2014-02-15 01:04:55.000000', 'temperatura', 1080.0000, 'ºC'),
	(197884, 119, '2014-02-15 01:04:56.000000', 'temperatura', 1164.0000, 'ºC'),
	(197885, 119, '2014-02-15 01:04:57.000000', 'temperatura', 180.0000, 'ºC'),
	(197886, 119, '2014-02-15 01:04:58.000000', 'temperatura', 1008.0000, 'ºC'),
	(197887, 119, '2014-02-15 01:04:59.000000', 'temperatura', 899.0000, 'ºC'),
	(197888, 119, '2014-02-15 01:05:00.000000', 'temperatura', 273.0000, 'ºC'),
	(197889, 119, '2014-02-15 01:05:01.000000', 'temperatura', 1066.0000, 'ºC'),
	(197890, 119, '2014-02-15 01:05:02.000000', 'temperatura', 915.0000, 'ºC'),
	(197891, 119, '2014-02-15 01:05:03.000000', 'temperatura', 174.0000, 'ºC'),
	(197892, 119, '2014-02-15 01:05:04.000000', 'temperatura', 529.0000, 'ºC'),
	(197893, 119, '2014-02-15 01:05:05.000000', 'temperatura', 923.0000, 'ºC'),
	(197894, 119, '2014-02-15 01:05:06.000000', 'temperatura', 627.0000, 'ºC'),
	(197895, 119, '2014-02-15 01:05:07.000000', 'temperatura', 369.0000, 'ºC'),
	(197896, 119, '2014-02-15 01:05:08.000000', 'temperatura', 1162.0000, 'ºC'),
	(197897, 119, '2014-02-15 01:05:09.000000', 'temperatura', 1105.0000, 'ºC'),
	(197898, 119, '2014-02-15 01:05:10.000000', 'temperatura', 839.0000, 'ºC'),
	(197899, 119, '2014-02-15 01:05:11.000000', 'temperatura', 881.0000, 'ºC'),
	(197900, 119, '2014-02-15 01:05:12.000000', 'temperatura', 688.0000, 'ºC'),
	(197901, 119, '2014-02-15 01:05:13.000000', 'temperatura', 796.0000, 'ºC'),
	(197902, 119, '2014-02-15 01:05:14.000000', 'temperatura', 716.0000, 'ºC'),
	(197903, 119, '2014-02-15 01:05:15.000000', 'temperatura', 1195.0000, 'ºC'),
	(197904, 119, '2014-02-15 01:05:16.000000', 'temperatura', 226.0000, 'ºC'),
	(197905, 119, '2014-02-15 01:05:17.000000', 'temperatura', 1144.0000, 'ºC'),
	(197906, 119, '2014-02-15 01:05:18.000000', 'temperatura', 244.0000, 'ºC'),
	(197907, 119, '2014-02-15 01:05:19.000000', 'temperatura', 190.0000, 'ºC'),
	(197908, 119, '2014-02-15 01:05:20.000000', 'temperatura', 219.0000, 'ºC'),
	(197909, 119, '2014-02-15 01:05:21.000000', 'temperatura', 525.0000, 'ºC'),
	(197910, 119, '2014-02-15 01:05:22.000000', 'temperatura', 768.0000, 'ºC'),
	(197911, 119, '2014-02-15 01:05:23.000000', 'temperatura', 1064.0000, 'ºC'),
	(197912, 119, '2014-02-15 01:05:24.000000', 'temperatura', 619.0000, 'ºC'),
	(197913, 119, '2014-02-15 01:05:25.000000', 'temperatura', 1100.0000, 'ºC'),
	(197914, 119, '2014-02-15 01:05:26.000000', 'temperatura', 47.0000, 'ºC'),
	(197915, 119, '2014-02-15 01:05:27.000000', 'temperatura', 536.0000, 'ºC'),
	(197916, 119, '2014-02-15 01:05:28.000000', 'temperatura', 138.0000, 'ºC'),
	(197917, 119, '2014-02-15 01:05:29.000000', 'temperatura', 281.0000, 'ºC'),
	(197918, 119, '2014-02-15 01:05:30.000000', 'temperatura', 992.0000, 'ºC'),
	(197919, 119, '2014-02-15 01:05:31.000000', 'temperatura', 516.0000, 'ºC'),
	(197920, 119, '2014-02-15 01:05:32.000000', 'temperatura', 806.0000, 'ºC'),
	(197921, 119, '2014-02-15 01:05:33.000000', 'temperatura', 80.0000, 'ºC'),
	(197922, 119, '2014-02-15 01:05:34.000000', 'temperatura', 386.0000, 'ºC'),
	(197923, 119, '2014-02-15 01:05:35.000000', 'temperatura', 491.0000, 'ºC'),
	(197924, 119, '2014-02-15 01:05:36.000000', 'temperatura', 94.0000, 'ºC'),
	(197925, 119, '2014-02-15 01:05:37.000000', 'temperatura', 200.0000, 'ºC'),
	(197926, 119, '2014-02-15 01:05:38.000000', 'temperatura', 719.0000, 'ºC'),
	(197927, 119, '2014-02-15 01:05:39.000000', 'temperatura', 595.0000, 'ºC'),
	(197928, 119, '2014-02-15 01:05:40.000000', 'temperatura', 819.0000, 'ºC'),
	(197929, 119, '2014-02-15 01:05:41.000000', 'temperatura', 1112.0000, 'ºC'),
	(197930, 119, '2014-02-15 01:05:42.000000', 'temperatura', 702.0000, 'ºC'),
	(197931, 119, '2014-02-15 01:05:43.000000', 'temperatura', 173.0000, 'ºC'),
	(197932, 119, '2014-02-15 01:05:44.000000', 'temperatura', 1162.0000, 'ºC'),
	(197933, 119, '2014-02-15 01:05:45.000000', 'temperatura', 491.0000, 'ºC'),
	(197934, 119, '2014-02-15 01:05:46.000000', 'temperatura', 169.0000, 'ºC'),
	(197935, 119, '2014-02-15 01:05:47.000000', 'temperatura', 575.0000, 'ºC'),
	(197936, 119, '2014-02-15 01:05:48.000000', 'temperatura', 1165.0000, 'ºC'),
	(197937, 119, '2014-02-15 01:05:49.000000', 'temperatura', 500.0000, 'ºC'),
	(197938, 119, '2014-02-15 01:05:50.000000', 'temperatura', 209.0000, 'ºC'),
	(197939, 119, '2014-02-15 01:05:51.000000', 'temperatura', 743.0000, 'ºC'),
	(197940, 119, '2014-02-15 01:05:52.000000', 'temperatura', 688.0000, 'ºC'),
	(197941, 119, '2014-02-15 01:05:53.000000', 'temperatura', 14.0000, 'ºC'),
	(197942, 119, '2014-02-15 01:05:54.000000', 'temperatura', 404.0000, 'ºC'),
	(197943, 119, '2014-02-15 01:05:55.000000', 'temperatura', 778.0000, 'ºC'),
	(197944, 119, '2014-02-15 01:05:56.000000', 'temperatura', 279.0000, 'ºC'),
	(197945, 119, '2014-02-15 01:05:57.000000', 'temperatura', 262.0000, 'ºC'),
	(197946, 119, '2014-02-15 01:05:58.000000', 'temperatura', 475.0000, 'ºC'),
	(197947, 119, '2014-02-15 01:05:59.000000', 'temperatura', 390.0000, 'ºC'),
	(197948, 119, '2014-02-15 01:06:00.000000', 'temperatura', 523.0000, 'ºC'),
	(197949, 119, '2014-02-15 01:06:01.000000', 'temperatura', 244.0000, 'ºC'),
	(197950, 119, '2014-02-15 01:06:02.000000', 'temperatura', 855.0000, 'ºC'),
	(197951, 119, '2014-02-15 01:06:03.000000', 'temperatura', 1143.0000, 'ºC'),
	(197952, 119, '2014-02-15 01:06:04.000000', 'temperatura', 750.0000, 'ºC'),
	(197953, 119, '2014-02-15 01:06:05.000000', 'temperatura', 321.0000, 'ºC'),
	(197954, 119, '2014-02-15 01:06:06.000000', 'temperatura', 554.0000, 'ºC'),
	(197955, 119, '2014-02-15 01:06:07.000000', 'temperatura', 611.0000, 'ºC'),
	(197956, 119, '2014-02-15 01:06:08.000000', 'temperatura', 190.0000, 'ºC'),
	(197957, 119, '2014-02-15 01:06:09.000000', 'temperatura', 320.0000, 'ºC'),
	(197958, 119, '2014-02-15 01:06:10.000000', 'temperatura', 1030.0000, 'ºC'),
	(197959, 119, '2014-02-15 01:06:11.000000', 'temperatura', 589.0000, 'ºC'),
	(197960, 119, '2014-02-15 01:06:12.000000', 'temperatura', 1056.0000, 'ºC'),
	(197961, 119, '2014-02-15 01:06:13.000000', 'temperatura', 1112.0000, 'ºC'),
	(197962, 119, '2014-02-15 01:06:14.000000', 'temperatura', 1194.0000, 'ºC'),
	(197963, 119, '2014-02-15 01:06:15.000000', 'temperatura', 233.0000, 'ºC'),
	(197964, 119, '2014-02-15 01:06:16.000000', 'temperatura', 1184.0000, 'ºC'),
	(197965, 119, '2014-02-15 01:06:17.000000', 'temperatura', 422.0000, 'ºC'),
	(197966, 119, '2014-02-15 01:06:18.000000', 'temperatura', 959.0000, 'ºC'),
	(197967, 119, '2014-02-15 01:06:19.000000', 'temperatura', 1130.0000, 'ºC'),
	(197968, 119, '2014-02-15 01:06:20.000000', 'temperatura', 371.0000, 'ºC'),
	(197969, 119, '2014-02-15 01:06:21.000000', 'temperatura', 867.0000, 'ºC'),
	(197970, 119, '2014-02-15 01:06:22.000000', 'temperatura', 820.0000, 'ºC'),
	(197971, 119, '2014-02-15 01:06:23.000000', 'temperatura', 303.0000, 'ºC'),
	(197972, 119, '2014-02-15 01:06:24.000000', 'temperatura', 253.0000, 'ºC'),
	(197973, 119, '2014-02-15 01:06:25.000000', 'temperatura', 359.0000, 'ºC'),
	(197974, 119, '2014-02-15 01:06:26.000000', 'temperatura', 1033.0000, 'ºC'),
	(197975, 119, '2014-02-15 01:06:27.000000', 'temperatura', 491.0000, 'ºC'),
	(197976, 119, '2014-02-15 01:06:28.000000', 'temperatura', 558.0000, 'ºC'),
	(197977, 119, '2014-02-15 01:06:29.000000', 'temperatura', 114.0000, 'ºC'),
	(197978, 119, '2014-02-15 01:06:30.000000', 'temperatura', 100.0000, 'ºC'),
	(197979, 119, '2014-02-15 01:06:31.000000', 'temperatura', 155.0000, 'ºC'),
	(197980, 119, '2014-02-15 01:06:32.000000', 'temperatura', 477.0000, 'ºC'),
	(197981, 119, '2014-02-15 01:06:33.000000', 'temperatura', 719.0000, 'ºC'),
	(197982, 119, '2014-02-15 01:06:34.000000', 'temperatura', 965.0000, 'ºC'),
	(197983, 119, '2014-02-15 01:06:35.000000', 'temperatura', 268.0000, 'ºC'),
	(197984, 119, '2014-02-15 01:06:36.000000', 'temperatura', 848.0000, 'ºC'),
	(197985, 119, '2014-02-15 01:06:37.000000', 'temperatura', 1034.0000, 'ºC'),
	(197986, 119, '2014-02-15 01:06:38.000000', 'temperatura', 227.0000, 'ºC'),
	(197987, 119, '2014-02-15 01:06:39.000000', 'temperatura', 434.0000, 'ºC'),
	(197988, 119, '2014-02-15 01:06:40.000000', 'temperatura', 290.0000, 'ºC'),
	(197989, 119, '2014-02-15 01:06:41.000000', 'temperatura', 147.0000, 'ºC'),
	(197990, 119, '2014-02-15 01:06:42.000000', 'temperatura', 1065.0000, 'ºC'),
	(197991, 119, '2014-02-15 01:06:43.000000', 'temperatura', 86.0000, 'ºC'),
	(197992, 119, '2014-02-15 01:06:44.000000', 'temperatura', 836.0000, 'ºC'),
	(197993, 119, '2014-02-15 01:06:45.000000', 'temperatura', 322.0000, 'ºC'),
	(197994, 119, '2014-02-15 01:06:46.000000', 'temperatura', 301.0000, 'ºC'),
	(197995, 119, '2014-02-15 01:06:47.000000', 'temperatura', 539.0000, 'ºC'),
	(197996, 119, '2014-02-15 01:06:48.000000', 'temperatura', 593.0000, 'ºC'),
	(197997, 119, '2014-02-15 01:06:49.000000', 'temperatura', 150.0000, 'ºC'),
	(197998, 119, '2014-02-15 01:06:50.000000', 'temperatura', 171.0000, 'ºC'),
	(197999, 119, '2014-02-15 01:06:51.000000', 'temperatura', 404.0000, 'ºC'),
	(198000, 119, '2014-02-15 01:06:52.000000', 'temperatura', 307.0000, 'ºC'),
	(198001, 119, '2014-02-15 01:06:53.000000', 'temperatura', 323.0000, 'ºC'),
	(198002, 119, '2014-02-15 01:06:54.000000', 'temperatura', 697.0000, 'ºC'),
	(198003, 119, '2014-02-15 01:06:55.000000', 'temperatura', 115.0000, 'ºC'),
	(198004, 119, '2014-02-15 01:06:56.000000', 'temperatura', 886.0000, 'ºC'),
	(198005, 119, '2014-02-15 01:06:57.000000', 'temperatura', 486.0000, 'ºC'),
	(198006, 119, '2014-02-15 01:06:58.000000', 'temperatura', 971.0000, 'ºC'),
	(198007, 119, '2014-02-15 01:06:59.000000', 'temperatura', 998.0000, 'ºC'),
	(198008, 119, '2014-02-15 01:07:00.000000', 'temperatura', 876.0000, 'ºC'),
	(198009, 119, '2014-02-15 01:07:01.000000', 'temperatura', 189.0000, 'ºC'),
	(198010, 119, '2014-02-15 01:07:02.000000', 'temperatura', 718.0000, 'ºC'),
	(198011, 119, '2014-02-15 01:07:03.000000', 'temperatura', 624.0000, 'ºC'),
	(198012, 119, '2014-02-15 01:07:04.000000', 'temperatura', 966.0000, 'ºC'),
	(198013, 119, '2014-02-15 01:07:05.000000', 'temperatura', 558.0000, 'ºC'),
	(198014, 119, '2014-02-15 01:07:06.000000', 'temperatura', 1092.0000, 'ºC'),
	(198015, 119, '2014-02-15 01:07:07.000000', 'temperatura', 188.0000, 'ºC'),
	(198016, 119, '2014-02-15 01:07:08.000000', 'temperatura', 65.0000, 'ºC'),
	(198017, 119, '2014-02-15 01:07:09.000000', 'temperatura', 959.0000, 'ºC'),
	(198018, 119, '2014-02-15 01:07:10.000000', 'temperatura', 1002.0000, 'ºC'),
	(198019, 119, '2014-02-15 01:07:11.000000', 'temperatura', 932.0000, 'ºC'),
	(198020, 119, '2014-02-15 01:07:12.000000', 'temperatura', 456.0000, 'ºC'),
	(198021, 119, '2014-02-15 01:07:13.000000', 'temperatura', 686.0000, 'ºC'),
	(198022, 119, '2014-02-15 01:07:14.000000', 'temperatura', 860.0000, 'ºC'),
	(198023, 119, '2014-02-15 01:07:15.000000', 'temperatura', 1042.0000, 'ºC'),
	(198024, 119, '2014-02-15 01:07:16.000000', 'temperatura', 229.0000, 'ºC'),
	(198025, 119, '2014-02-15 01:07:17.000000', 'temperatura', 423.0000, 'ºC'),
	(198026, 119, '2014-02-15 01:07:18.000000', 'temperatura', 228.0000, 'ºC'),
	(198027, 119, '2014-02-15 01:07:19.000000', 'temperatura', 1070.0000, 'ºC'),
	(198028, 119, '2014-02-15 01:07:20.000000', 'temperatura', 1066.0000, 'ºC'),
	(198029, 119, '2014-02-15 01:07:21.000000', 'temperatura', 920.0000, 'ºC'),
	(198030, 119, '2014-02-15 01:07:22.000000', 'temperatura', 201.0000, 'ºC'),
	(198031, 119, '2014-02-15 01:07:23.000000', 'temperatura', 649.0000, 'ºC'),
	(198032, 119, '2014-02-15 01:07:24.000000', 'temperatura', 242.0000, 'ºC'),
	(198033, 119, '2014-02-15 01:07:25.000000', 'temperatura', 463.0000, 'ºC'),
	(198034, 119, '2014-02-15 01:07:26.000000', 'temperatura', 390.0000, 'ºC'),
	(198035, 119, '2014-02-15 01:07:27.000000', 'temperatura', 563.0000, 'ºC'),
	(198036, 119, '2014-02-15 01:07:28.000000', 'temperatura', 445.0000, 'ºC'),
	(198037, 119, '2014-02-15 01:07:29.000000', 'temperatura', 537.0000, 'ºC'),
	(198038, 119, '2014-02-15 01:07:30.000000', 'temperatura', 149.0000, 'ºC'),
	(198039, 119, '2014-02-15 01:07:31.000000', 'temperatura', 337.0000, 'ºC'),
	(198040, 119, '2014-02-15 01:07:32.000000', 'temperatura', 36.0000, 'ºC'),
	(198041, 119, '2014-02-15 01:07:33.000000', 'temperatura', 369.0000, 'ºC'),
	(198042, 119, '2014-02-15 01:07:34.000000', 'temperatura', 538.0000, 'ºC'),
	(198043, 119, '2014-02-15 01:07:35.000000', 'temperatura', 383.0000, 'ºC'),
	(198044, 119, '2014-02-15 01:07:36.000000', 'temperatura', 303.0000, 'ºC'),
	(198045, 119, '2014-02-15 01:07:37.000000', 'temperatura', 367.0000, 'ºC'),
	(198046, 119, '2014-02-15 01:07:38.000000', 'temperatura', 926.0000, 'ºC'),
	(198047, 119, '2014-02-15 01:07:39.000000', 'temperatura', 1128.0000, 'ºC'),
	(198048, 119, '2014-02-15 01:07:40.000000', 'temperatura', 465.0000, 'ºC'),
	(198049, 119, '2014-02-15 01:07:41.000000', 'temperatura', 142.0000, 'ºC'),
	(198050, 119, '2014-02-15 01:07:42.000000', 'temperatura', 512.0000, 'ºC'),
	(198051, 119, '2014-02-15 01:07:43.000000', 'temperatura', 937.0000, 'ºC'),
	(198052, 119, '2014-02-15 01:07:44.000000', 'temperatura', 751.0000, 'ºC'),
	(198053, 119, '2014-02-15 01:07:45.000000', 'temperatura', 941.0000, 'ºC'),
	(198054, 119, '2014-02-15 01:07:46.000000', 'temperatura', 55.0000, 'ºC'),
	(198055, 119, '2014-02-15 01:07:47.000000', 'temperatura', 1050.0000, 'ºC'),
	(198056, 119, '2014-02-15 01:07:48.000000', 'temperatura', 289.0000, 'ºC'),
	(198057, 119, '2014-02-15 01:07:49.000000', 'temperatura', 693.0000, 'ºC'),
	(198058, 119, '2014-02-15 01:07:50.000000', 'temperatura', 199.0000, 'ºC'),
	(198059, 119, '2014-02-15 01:07:51.000000', 'temperatura', 118.0000, 'ºC'),
	(198060, 119, '2014-02-15 01:07:52.000000', 'temperatura', 1193.0000, 'ºC'),
	(198061, 119, '2014-02-15 01:07:53.000000', 'temperatura', 809.0000, 'ºC'),
	(198062, 119, '2014-02-15 01:07:54.000000', 'temperatura', 469.0000, 'ºC'),
	(198063, 119, '2014-02-15 01:07:55.000000', 'temperatura', 1117.0000, 'ºC'),
	(198064, 119, '2014-02-15 01:07:56.000000', 'temperatura', 577.0000, 'ºC'),
	(198065, 119, '2014-02-15 01:07:57.000000', 'temperatura', 738.0000, 'ºC'),
	(198066, 119, '2014-02-15 01:07:58.000000', 'temperatura', 757.0000, 'ºC'),
	(198067, 119, '2014-02-15 01:07:59.000000', 'temperatura', 370.0000, 'ºC'),
	(198068, 119, '2014-02-15 01:08:00.000000', 'temperatura', 782.0000, 'ºC'),
	(198069, 119, '2014-02-15 01:08:01.000000', 'temperatura', 398.0000, 'ºC'),
	(198070, 119, '2014-02-15 01:08:02.000000', 'temperatura', 845.0000, 'ºC'),
	(198071, 119, '2014-02-15 01:08:03.000000', 'temperatura', 632.0000, 'ºC'),
	(198072, 119, '2014-02-15 01:08:04.000000', 'temperatura', 626.0000, 'ºC'),
	(198073, 119, '2014-02-15 01:08:05.000000', 'temperatura', 35.0000, 'ºC'),
	(198074, 119, '2014-02-15 01:08:06.000000', 'temperatura', 698.0000, 'ºC'),
	(198075, 119, '2014-02-15 01:08:07.000000', 'temperatura', 984.0000, 'ºC'),
	(198076, 119, '2014-02-15 01:08:08.000000', 'temperatura', 425.0000, 'ºC'),
	(198077, 119, '2014-02-15 01:08:09.000000', 'temperatura', 376.0000, 'ºC'),
	(198078, 119, '2014-02-15 01:08:10.000000', 'temperatura', 606.0000, 'ºC'),
	(198079, 119, '2014-02-15 01:08:11.000000', 'temperatura', 704.0000, 'ºC'),
	(198080, 119, '2014-02-15 01:08:12.000000', 'temperatura', 499.0000, 'ºC'),
	(198081, 119, '2014-02-15 01:08:13.000000', 'temperatura', 384.0000, 'ºC'),
	(198082, 119, '2014-02-15 01:08:14.000000', 'temperatura', 425.0000, 'ºC'),
	(198083, 119, '2014-02-15 01:08:15.000000', 'temperatura', 973.0000, 'ºC'),
	(198084, 119, '2014-02-15 01:08:16.000000', 'temperatura', 1190.0000, 'ºC'),
	(198085, 119, '2014-02-15 01:08:17.000000', 'temperatura', 633.0000, 'ºC'),
	(198086, 119, '2014-02-15 01:08:18.000000', 'temperatura', 793.0000, 'ºC'),
	(198087, 119, '2014-02-15 01:08:19.000000', 'temperatura', 868.0000, 'ºC'),
	(198088, 119, '2014-02-15 01:08:20.000000', 'temperatura', 760.0000, 'ºC'),
	(198089, 119, '2014-02-15 01:08:21.000000', 'temperatura', 1196.0000, 'ºC'),
	(198090, 119, '2014-02-15 01:08:22.000000', 'temperatura', 102.0000, 'ºC'),
	(198091, 119, '2014-02-15 01:08:23.000000', 'temperatura', 524.0000, 'ºC'),
	(198092, 119, '2014-02-15 01:08:24.000000', 'temperatura', 1113.0000, 'ºC'),
	(198093, 119, '2014-02-15 01:08:25.000000', 'temperatura', 392.0000, 'ºC'),
	(198094, 119, '2014-02-15 01:08:26.000000', 'temperatura', 1022.0000, 'ºC'),
	(198095, 119, '2014-02-15 01:08:27.000000', 'temperatura', 334.0000, 'ºC'),
	(198096, 119, '2014-02-15 01:08:28.000000', 'temperatura', 1005.0000, 'ºC'),
	(198097, 119, '2014-02-15 01:08:29.000000', 'temperatura', 424.0000, 'ºC'),
	(198098, 119, '2014-02-15 01:08:30.000000', 'temperatura', 303.0000, 'ºC'),
	(198099, 119, '2014-02-15 01:08:31.000000', 'temperatura', 246.0000, 'ºC'),
	(198100, 119, '2014-02-15 01:08:32.000000', 'temperatura', 323.0000, 'ºC'),
	(198101, 119, '2014-02-15 01:08:33.000000', 'temperatura', 874.0000, 'ºC'),
	(198102, 119, '2014-02-15 01:08:34.000000', 'temperatura', 1003.0000, 'ºC'),
	(198103, 119, '2014-02-15 01:08:35.000000', 'temperatura', 1193.0000, 'ºC'),
	(198104, 119, '2014-02-15 01:08:36.000000', 'temperatura', 559.0000, 'ºC'),
	(198105, 119, '2014-02-15 01:08:37.000000', 'temperatura', 414.0000, 'ºC'),
	(198106, 119, '2014-02-15 01:08:38.000000', 'temperatura', 392.0000, 'ºC'),
	(198107, 119, '2014-02-15 01:08:39.000000', 'temperatura', 721.0000, 'ºC'),
	(198108, 119, '2014-02-15 01:08:40.000000', 'temperatura', 29.0000, 'ºC'),
	(198109, 119, '2014-02-15 01:08:41.000000', 'temperatura', 381.0000, 'ºC'),
	(198110, 119, '2014-02-15 01:08:42.000000', 'temperatura', 621.0000, 'ºC'),
	(198111, 119, '2014-02-15 01:08:43.000000', 'temperatura', 760.0000, 'ºC'),
	(198112, 119, '2014-02-15 01:08:44.000000', 'temperatura', 739.0000, 'ºC'),
	(198113, 119, '2014-02-15 01:08:45.000000', 'temperatura', 213.0000, 'ºC'),
	(198114, 119, '2014-02-15 01:08:46.000000', 'temperatura', 50.0000, 'ºC'),
	(198115, 119, '2014-02-15 01:08:47.000000', 'temperatura', 812.0000, 'ºC'),
	(198116, 119, '2014-02-15 01:08:48.000000', 'temperatura', 312.0000, 'ºC'),
	(198117, 119, '2014-02-15 01:08:49.000000', 'temperatura', 324.0000, 'ºC'),
	(198118, 119, '2014-02-15 01:08:50.000000', 'temperatura', 686.0000, 'ºC'),
	(198119, 119, '2014-02-15 01:08:51.000000', 'temperatura', 55.0000, 'ºC'),
	(198120, 119, '2014-02-15 01:08:52.000000', 'temperatura', 619.0000, 'ºC'),
	(198121, 119, '2014-02-15 01:08:53.000000', 'temperatura', 531.0000, 'ºC'),
	(198122, 119, '2014-02-15 01:08:54.000000', 'temperatura', 797.0000, 'ºC'),
	(198123, 119, '2014-02-15 01:08:55.000000', 'temperatura', 1194.0000, 'ºC'),
	(198124, 119, '2014-02-15 01:08:56.000000', 'temperatura', 1179.0000, 'ºC'),
	(198125, 119, '2014-02-15 01:08:57.000000', 'temperatura', 1115.0000, 'ºC'),
	(198126, 119, '2014-02-15 01:08:58.000000', 'temperatura', 835.0000, 'ºC'),
	(198127, 119, '2014-02-15 01:08:59.000000', 'temperatura', 834.0000, 'ºC'),
	(198128, 119, '2014-02-15 01:09:00.000000', 'temperatura', 464.0000, 'ºC'),
	(198129, 119, '2014-02-15 01:09:01.000000', 'temperatura', 1019.0000, 'ºC'),
	(198130, 119, '2014-02-15 01:09:02.000000', 'temperatura', 104.0000, 'ºC'),
	(198131, 119, '2014-02-15 01:09:03.000000', 'temperatura', 1064.0000, 'ºC'),
	(198132, 119, '2014-02-15 01:09:04.000000', 'temperatura', 208.0000, 'ºC'),
	(198133, 119, '2014-02-15 01:09:05.000000', 'temperatura', 248.0000, 'ºC'),
	(198134, 119, '2014-02-15 01:09:06.000000', 'temperatura', 615.0000, 'ºC'),
	(198135, 119, '2014-02-15 01:09:07.000000', 'temperatura', 1134.0000, 'ºC'),
	(198136, 119, '2014-02-15 01:09:08.000000', 'temperatura', 223.0000, 'ºC'),
	(198137, 119, '2014-02-15 01:09:09.000000', 'temperatura', 113.0000, 'ºC'),
	(198138, 119, '2014-02-15 01:09:10.000000', 'temperatura', 1097.0000, 'ºC'),
	(198139, 119, '2014-02-15 01:09:11.000000', 'temperatura', 349.0000, 'ºC'),
	(198140, 119, '2014-02-15 01:09:12.000000', 'temperatura', 851.0000, 'ºC'),
	(198141, 119, '2014-02-15 01:09:13.000000', 'temperatura', 810.0000, 'ºC'),
	(198142, 119, '2014-02-15 01:09:14.000000', 'temperatura', 299.0000, 'ºC'),
	(198143, 119, '2014-02-15 01:09:15.000000', 'temperatura', 266.0000, 'ºC'),
	(198144, 119, '2014-02-15 01:09:16.000000', 'temperatura', 434.0000, 'ºC'),
	(198145, 119, '2014-02-15 01:09:17.000000', 'temperatura', 172.0000, 'ºC'),
	(198146, 119, '2014-02-15 01:09:18.000000', 'temperatura', 759.0000, 'ºC'),
	(198147, 119, '2014-02-15 01:09:19.000000', 'temperatura', 880.0000, 'ºC'),
	(198148, 119, '2014-02-15 01:09:20.000000', 'temperatura', 923.0000, 'ºC'),
	(198149, 119, '2014-02-15 01:09:21.000000', 'temperatura', 776.0000, 'ºC'),
	(198150, 119, '2014-02-15 01:09:22.000000', 'temperatura', 1113.0000, 'ºC'),
	(198151, 119, '2014-02-15 01:09:23.000000', 'temperatura', 835.0000, 'ºC'),
	(198152, 119, '2014-02-15 01:09:24.000000', 'temperatura', 836.0000, 'ºC'),
	(198153, 119, '2014-02-15 01:09:25.000000', 'temperatura', 478.0000, 'ºC'),
	(198154, 119, '2014-02-15 01:09:26.000000', 'temperatura', 1082.0000, 'ºC'),
	(198155, 119, '2014-02-15 01:09:27.000000', 'temperatura', 378.0000, 'ºC'),
	(198156, 119, '2014-02-15 01:09:28.000000', 'temperatura', 1042.0000, 'ºC'),
	(198157, 119, '2014-02-15 01:09:29.000000', 'temperatura', 477.0000, 'ºC'),
	(198158, 119, '2014-02-15 01:09:30.000000', 'temperatura', 459.0000, 'ºC'),
	(198159, 119, '2014-02-15 01:09:31.000000', 'temperatura', 864.0000, 'ºC'),
	(198160, 119, '2014-02-15 01:09:32.000000', 'temperatura', 545.0000, 'ºC'),
	(198161, 119, '2014-02-15 01:09:33.000000', 'temperatura', 133.0000, 'ºC'),
	(198162, 119, '2014-02-15 01:09:34.000000', 'temperatura', 232.0000, 'ºC'),
	(198163, 119, '2014-02-15 01:09:35.000000', 'temperatura', 759.0000, 'ºC'),
	(198164, 119, '2014-02-15 01:09:36.000000', 'temperatura', 701.0000, 'ºC'),
	(198165, 119, '2014-02-15 01:09:37.000000', 'temperatura', 27.0000, 'ºC'),
	(198166, 119, '2014-02-15 01:09:38.000000', 'temperatura', 434.0000, 'ºC'),
	(198167, 119, '2014-02-15 01:09:39.000000', 'temperatura', 888.0000, 'ºC'),
	(198168, 119, '2014-02-15 01:09:40.000000', 'temperatura', 739.0000, 'ºC'),
	(198169, 119, '2014-02-15 01:09:41.000000', 'temperatura', 1031.0000, 'ºC'),
	(198170, 119, '2014-02-15 01:09:42.000000', 'temperatura', 540.0000, 'ºC'),
	(198171, 119, '2014-02-15 01:09:43.000000', 'temperatura', 805.0000, 'ºC'),
	(198172, 119, '2014-02-15 01:09:44.000000', 'temperatura', 9.0000, 'ºC'),
	(198173, 119, '2014-02-15 01:09:45.000000', 'temperatura', 28.0000, 'ºC'),
	(198174, 119, '2014-02-15 01:09:46.000000', 'temperatura', 113.0000, 'ºC'),
	(198175, 119, '2014-02-15 01:09:47.000000', 'temperatura', 482.0000, 'ºC'),
	(198176, 119, '2014-02-15 01:09:48.000000', 'temperatura', 871.0000, 'ºC'),
	(198177, 119, '2014-02-15 01:09:49.000000', 'temperatura', 511.0000, 'ºC'),
	(198178, 119, '2014-02-15 01:09:50.000000', 'temperatura', 1143.0000, 'ºC'),
	(198179, 119, '2014-02-15 01:09:51.000000', 'temperatura', 581.0000, 'ºC'),
	(198180, 119, '2014-02-15 01:09:52.000000', 'temperatura', 676.0000, 'ºC'),
	(198181, 119, '2014-02-15 01:09:53.000000', 'temperatura', 438.0000, 'ºC'),
	(198182, 119, '2014-02-15 01:09:54.000000', 'temperatura', 165.0000, 'ºC'),
	(198183, 119, '2014-02-15 01:09:55.000000', 'temperatura', 708.0000, 'ºC'),
	(198184, 119, '2014-02-15 01:09:56.000000', 'temperatura', 648.0000, 'ºC'),
	(198185, 119, '2014-02-15 01:09:57.000000', 'temperatura', 1116.0000, 'ºC'),
	(198186, 119, '2014-02-15 01:09:58.000000', 'temperatura', 34.0000, 'ºC'),
	(198187, 119, '2014-02-15 01:09:59.000000', 'temperatura', 426.0000, 'ºC'),
	(198188, 119, '2014-02-15 01:10:00.000000', 'temperatura', 828.0000, 'ºC'),
	(198189, 119, '2014-02-15 01:10:01.000000', 'temperatura', 461.0000, 'ºC'),
	(198190, 119, '2014-02-15 01:10:02.000000', 'temperatura', 1023.0000, 'ºC'),
	(198191, 119, '2014-02-15 01:10:03.000000', 'temperatura', 131.0000, 'ºC'),
	(198192, 119, '2014-02-15 01:10:04.000000', 'temperatura', 1189.0000, 'ºC'),
	(198193, 119, '2014-02-15 01:10:05.000000', 'temperatura', 751.0000, 'ºC'),
	(198194, 119, '2014-02-15 01:10:06.000000', 'temperatura', 191.0000, 'ºC'),
	(198195, 119, '2014-02-15 01:10:07.000000', 'temperatura', 1100.0000, 'ºC'),
	(198196, 119, '2014-02-15 01:10:08.000000', 'temperatura', 126.0000, 'ºC'),
	(198197, 119, '2014-02-15 01:10:09.000000', 'temperatura', 933.0000, 'ºC'),
	(198198, 119, '2014-02-15 01:10:10.000000', 'temperatura', 689.0000, 'ºC'),
	(198199, 119, '2014-02-15 01:10:11.000000', 'temperatura', 643.0000, 'ºC'),
	(198200, 119, '2014-02-15 01:10:12.000000', 'temperatura', 1151.0000, 'ºC'),
	(198201, 119, '2014-02-15 01:10:13.000000', 'temperatura', 227.0000, 'ºC'),
	(198202, 119, '2014-02-15 01:10:14.000000', 'temperatura', 81.0000, 'ºC'),
	(198203, 119, '2014-02-15 01:10:15.000000', 'temperatura', 924.0000, 'ºC'),
	(198204, 119, '2014-02-15 01:10:16.000000', 'temperatura', 779.0000, 'ºC'),
	(198205, 119, '2014-02-15 01:10:17.000000', 'temperatura', 1121.0000, 'ºC'),
	(198206, 119, '2014-02-15 01:10:18.000000', 'temperatura', 871.0000, 'ºC'),
	(198207, 119, '2014-02-15 01:10:19.000000', 'temperatura', 990.0000, 'ºC'),
	(198208, 119, '2014-02-15 01:10:20.000000', 'temperatura', 1139.0000, 'ºC'),
	(198209, 119, '2014-02-15 01:10:21.000000', 'temperatura', 326.0000, 'ºC'),
	(198210, 119, '2014-02-15 01:10:22.000000', 'temperatura', 612.0000, 'ºC'),
	(198211, 119, '2014-02-15 01:10:23.000000', 'temperatura', 884.0000, 'ºC'),
	(198212, 119, '2014-02-15 01:10:24.000000', 'temperatura', 183.0000, 'ºC'),
	(198213, 119, '2014-02-15 01:10:25.000000', 'temperatura', 663.0000, 'ºC'),
	(198214, 119, '2014-02-15 01:10:26.000000', 'temperatura', 369.0000, 'ºC'),
	(198215, 119, '2014-02-15 01:10:27.000000', 'temperatura', 1054.0000, 'ºC'),
	(198216, 119, '2014-02-15 01:10:28.000000', 'temperatura', 566.0000, 'ºC'),
	(198217, 119, '2014-02-15 01:10:29.000000', 'temperatura', 866.0000, 'ºC'),
	(198218, 119, '2014-02-15 01:10:30.000000', 'temperatura', 232.0000, 'ºC'),
	(198219, 119, '2014-02-15 01:10:31.000000', 'temperatura', 965.0000, 'ºC'),
	(198220, 119, '2014-02-15 01:10:32.000000', 'temperatura', 528.0000, 'ºC'),
	(198221, 119, '2014-02-15 01:10:33.000000', 'temperatura', 948.0000, 'ºC'),
	(198222, 119, '2014-02-15 01:10:34.000000', 'temperatura', 754.0000, 'ºC'),
	(198223, 119, '2014-02-15 01:10:35.000000', 'temperatura', 929.0000, 'ºC'),
	(198224, 119, '2014-02-15 01:10:36.000000', 'temperatura', 1181.0000, 'ºC'),
	(198225, 119, '2014-02-15 01:10:37.000000', 'temperatura', 720.0000, 'ºC'),
	(198226, 119, '2014-02-15 01:10:38.000000', 'temperatura', 58.0000, 'ºC'),
	(198227, 119, '2014-02-15 01:10:39.000000', 'temperatura', 528.0000, 'ºC'),
	(198228, 119, '2014-02-15 01:10:40.000000', 'temperatura', 70.0000, 'ºC'),
	(198229, 119, '2014-02-15 01:10:41.000000', 'temperatura', 1163.0000, 'ºC'),
	(198230, 119, '2014-02-15 01:10:42.000000', 'temperatura', 808.0000, 'ºC'),
	(198231, 119, '2014-02-15 01:10:43.000000', 'temperatura', 552.0000, 'ºC'),
	(198232, 119, '2014-02-15 01:10:44.000000', 'temperatura', 334.0000, 'ºC'),
	(198233, 119, '2014-02-15 01:10:45.000000', 'temperatura', 16.0000, 'ºC'),
	(198234, 119, '2014-02-15 01:10:46.000000', 'temperatura', 276.0000, 'ºC'),
	(198235, 119, '2014-02-15 01:10:47.000000', 'temperatura', 135.0000, 'ºC'),
	(198236, 119, '2014-02-15 01:10:48.000000', 'temperatura', 1049.0000, 'ºC'),
	(198237, 119, '2014-02-15 01:10:49.000000', 'temperatura', 38.0000, 'ºC'),
	(198238, 119, '2014-02-15 01:10:50.000000', 'temperatura', 644.0000, 'ºC'),
	(198239, 119, '2014-02-15 01:10:51.000000', 'temperatura', 708.0000, 'ºC'),
	(198240, 119, '2014-02-15 01:10:52.000000', 'temperatura', 405.0000, 'ºC'),
	(198241, 119, '2014-02-15 01:10:53.000000', 'temperatura', 1105.0000, 'ºC'),
	(198242, 119, '2014-02-15 01:10:54.000000', 'temperatura', 710.0000, 'ºC'),
	(198243, 119, '2014-02-15 01:10:55.000000', 'temperatura', 236.0000, 'ºC'),
	(198244, 119, '2014-02-15 01:10:56.000000', 'temperatura', 251.0000, 'ºC'),
	(198245, 119, '2014-02-15 01:10:57.000000', 'temperatura', 546.0000, 'ºC'),
	(198246, 119, '2014-02-15 01:10:58.000000', 'temperatura', 779.0000, 'ºC'),
	(198247, 119, '2014-02-15 01:10:59.000000', 'temperatura', 1059.0000, 'ºC'),
	(198248, 119, '2014-02-15 01:11:00.000000', 'temperatura', 555.0000, 'ºC'),
	(198249, 119, '2014-02-15 01:11:01.000000', 'temperatura', 802.0000, 'ºC'),
	(198250, 119, '2014-02-15 01:11:02.000000', 'temperatura', 1144.0000, 'ºC'),
	(198251, 119, '2014-02-15 01:11:03.000000', 'temperatura', 914.0000, 'ºC'),
	(198252, 119, '2014-02-15 01:11:04.000000', 'temperatura', 1139.0000, 'ºC'),
	(198253, 119, '2014-02-15 01:11:05.000000', 'temperatura', 555.0000, 'ºC'),
	(198254, 119, '2014-02-15 01:11:06.000000', 'temperatura', 557.0000, 'ºC'),
	(198255, 119, '2014-02-15 01:11:07.000000', 'temperatura', 1121.0000, 'ºC'),
	(198256, 119, '2014-02-15 01:11:08.000000', 'temperatura', 334.0000, 'ºC'),
	(198257, 119, '2014-02-15 01:11:09.000000', 'temperatura', 708.0000, 'ºC'),
	(198258, 119, '2014-02-15 01:11:10.000000', 'temperatura', 137.0000, 'ºC'),
	(198259, 119, '2014-02-15 01:11:11.000000', 'temperatura', 962.0000, 'ºC'),
	(198260, 119, '2014-02-15 01:11:12.000000', 'temperatura', 798.0000, 'ºC'),
	(198261, 119, '2014-02-15 01:11:13.000000', 'temperatura', 1105.0000, 'ºC'),
	(198262, 119, '2014-02-15 01:11:14.000000', 'temperatura', 731.0000, 'ºC'),
	(198263, 119, '2014-02-15 01:11:15.000000', 'temperatura', 340.0000, 'ºC'),
	(198264, 119, '2014-02-15 01:11:16.000000', 'temperatura', 709.0000, 'ºC'),
	(198265, 119, '2014-02-15 01:11:17.000000', 'temperatura', 123.0000, 'ºC'),
	(198266, 119, '2014-02-15 01:11:18.000000', 'temperatura', 890.0000, 'ºC'),
	(198267, 119, '2014-02-15 01:11:19.000000', 'temperatura', 481.0000, 'ºC'),
	(198268, 119, '2014-02-15 01:11:20.000000', 'temperatura', 937.0000, 'ºC'),
	(198269, 119, '2014-02-15 01:11:21.000000', 'temperatura', 841.0000, 'ºC'),
	(198270, 119, '2014-02-15 01:11:22.000000', 'temperatura', 197.0000, 'ºC'),
	(198271, 119, '2014-02-15 01:11:23.000000', 'temperatura', 859.0000, 'ºC'),
	(198272, 119, '2014-02-15 01:11:24.000000', 'temperatura', 106.0000, 'ºC'),
	(198273, 119, '2014-02-15 01:11:25.000000', 'temperatura', 354.0000, 'ºC'),
	(198274, 119, '2014-02-15 01:11:26.000000', 'temperatura', 250.0000, 'ºC'),
	(198275, 119, '2014-02-15 01:11:27.000000', 'temperatura', 190.0000, 'ºC'),
	(198276, 119, '2014-02-15 01:11:28.000000', 'temperatura', 201.0000, 'ºC'),
	(198277, 119, '2014-02-15 01:11:29.000000', 'temperatura', 435.0000, 'ºC'),
	(198278, 119, '2014-02-15 01:11:30.000000', 'temperatura', 372.0000, 'ºC'),
	(198279, 119, '2014-02-15 01:11:31.000000', 'temperatura', 557.0000, 'ºC'),
	(198280, 119, '2014-02-15 01:11:32.000000', 'temperatura', 468.0000, 'ºC'),
	(198281, 119, '2014-02-15 01:11:33.000000', 'temperatura', 671.0000, 'ºC'),
	(198282, 119, '2014-02-15 01:11:34.000000', 'temperatura', 751.0000, 'ºC'),
	(198283, 119, '2014-02-15 01:11:35.000000', 'temperatura', 541.0000, 'ºC'),
	(198284, 119, '2014-02-15 01:11:36.000000', 'temperatura', 454.0000, 'ºC'),
	(198285, 119, '2014-02-15 01:11:37.000000', 'temperatura', 648.0000, 'ºC'),
	(198286, 119, '2014-02-15 01:11:38.000000', 'temperatura', 678.0000, 'ºC'),
	(198287, 119, '2014-02-15 01:11:39.000000', 'temperatura', 248.0000, 'ºC'),
	(198288, 119, '2014-02-15 01:11:40.000000', 'temperatura', 403.0000, 'ºC'),
	(198289, 119, '2014-02-15 01:11:41.000000', 'temperatura', 74.0000, 'ºC'),
	(198290, 119, '2014-02-15 01:11:42.000000', 'temperatura', 363.0000, 'ºC'),
	(198291, 119, '2014-02-15 01:11:43.000000', 'temperatura', 392.0000, 'ºC'),
	(198292, 119, '2014-02-15 01:11:44.000000', 'temperatura', 873.0000, 'ºC'),
	(198293, 119, '2014-02-15 01:11:45.000000', 'temperatura', 788.0000, 'ºC'),
	(198294, 119, '2014-02-15 01:11:46.000000', 'temperatura', 120.0000, 'ºC'),
	(198295, 119, '2014-02-15 01:11:47.000000', 'temperatura', 637.0000, 'ºC'),
	(198296, 119, '2014-02-15 01:11:48.000000', 'temperatura', 426.0000, 'ºC'),
	(198297, 119, '2014-02-15 01:11:49.000000', 'temperatura', 222.0000, 'ºC'),
	(198298, 119, '2014-02-15 01:11:50.000000', 'temperatura', 1029.0000, 'ºC'),
	(198299, 119, '2014-02-15 01:11:51.000000', 'temperatura', 882.0000, 'ºC'),
	(198300, 119, '2014-02-15 01:11:52.000000', 'temperatura', 122.0000, 'ºC'),
	(198301, 119, '2014-02-15 01:11:53.000000', 'temperatura', 364.0000, 'ºC'),
	(198302, 119, '2014-02-15 01:11:54.000000', 'temperatura', 254.0000, 'ºC'),
	(198303, 119, '2014-02-15 01:11:55.000000', 'temperatura', 179.0000, 'ºC'),
	(198304, 119, '2014-02-15 01:11:56.000000', 'temperatura', 133.0000, 'ºC'),
	(198305, 119, '2014-02-15 01:11:57.000000', 'temperatura', 130.0000, 'ºC'),
	(198306, 119, '2014-02-15 01:11:58.000000', 'temperatura', 252.0000, 'ºC'),
	(198307, 119, '2014-02-15 01:11:59.000000', 'temperatura', 870.0000, 'ºC'),
	(198308, 119, '2014-02-15 01:12:00.000000', 'temperatura', 1192.0000, 'ºC'),
	(198309, 119, '2014-02-15 01:12:01.000000', 'temperatura', 954.0000, 'ºC'),
	(198310, 119, '2014-02-15 01:12:02.000000', 'temperatura', 1193.0000, 'ºC'),
	(198311, 119, '2014-02-15 01:12:03.000000', 'temperatura', 704.0000, 'ºC'),
	(198312, 119, '2014-02-15 01:12:04.000000', 'temperatura', 1140.0000, 'ºC'),
	(198313, 119, '2014-02-15 01:12:05.000000', 'temperatura', 1190.0000, 'ºC'),
	(198314, 119, '2014-02-15 01:12:06.000000', 'temperatura', 132.0000, 'ºC'),
	(198315, 119, '2014-02-15 01:12:07.000000', 'temperatura', 689.0000, 'ºC'),
	(198316, 119, '2014-02-15 01:12:08.000000', 'temperatura', 648.0000, 'ºC'),
	(198317, 119, '2014-02-15 01:12:09.000000', 'temperatura', 1176.0000, 'ºC'),
	(198318, 119, '2014-02-15 01:12:10.000000', 'temperatura', 336.0000, 'ºC'),
	(198319, 119, '2014-02-15 01:12:11.000000', 'temperatura', 550.0000, 'ºC'),
	(198320, 119, '2014-02-15 01:12:12.000000', 'temperatura', 544.0000, 'ºC'),
	(198321, 119, '2014-02-15 01:12:13.000000', 'temperatura', 1071.0000, 'ºC'),
	(198322, 119, '2014-02-15 01:12:14.000000', 'temperatura', 125.0000, 'ºC'),
	(198323, 119, '2014-02-15 01:12:15.000000', 'temperatura', 1011.0000, 'ºC'),
	(198324, 119, '2014-02-15 01:12:16.000000', 'temperatura', 1080.0000, 'ºC'),
	(198325, 119, '2014-02-15 01:12:17.000000', 'temperatura', 1168.0000, 'ºC'),
	(198326, 119, '2014-02-15 01:12:18.000000', 'temperatura', 201.0000, 'ºC'),
	(198327, 119, '2014-02-15 01:12:19.000000', 'temperatura', 1103.0000, 'ºC'),
	(198328, 119, '2014-02-15 01:12:20.000000', 'temperatura', 112.0000, 'ºC'),
	(198329, 119, '2014-02-15 01:12:21.000000', 'temperatura', 850.0000, 'ºC'),
	(198330, 119, '2014-02-15 01:12:22.000000', 'temperatura', 315.0000, 'ºC'),
	(198331, 119, '2014-02-15 01:12:23.000000', 'temperatura', 226.0000, 'ºC'),
	(198332, 119, '2014-02-15 01:12:24.000000', 'temperatura', 184.0000, 'ºC'),
	(198333, 119, '2014-02-15 01:12:25.000000', 'temperatura', 242.0000, 'ºC'),
	(198334, 119, '2014-02-15 01:12:26.000000', 'temperatura', 659.0000, 'ºC'),
	(198335, 119, '2014-02-15 01:12:27.000000', 'temperatura', 171.0000, 'ºC'),
	(198336, 119, '2014-02-15 01:12:28.000000', 'temperatura', 76.0000, 'ºC'),
	(198337, 119, '2014-02-15 01:12:29.000000', 'temperatura', 1069.0000, 'ºC'),
	(198338, 119, '2014-02-15 01:12:30.000000', 'temperatura', 319.0000, 'ºC'),
	(198339, 119, '2014-02-15 01:12:31.000000', 'temperatura', 787.0000, 'ºC'),
	(198340, 119, '2014-02-15 01:12:32.000000', 'temperatura', 579.0000, 'ºC'),
	(198341, 119, '2014-02-15 01:12:33.000000', 'temperatura', 533.0000, 'ºC'),
	(198342, 119, '2014-02-15 01:12:34.000000', 'temperatura', 928.0000, 'ºC'),
	(198343, 119, '2014-02-15 01:12:35.000000', 'temperatura', 641.0000, 'ºC'),
	(198344, 119, '2014-02-15 01:12:36.000000', 'temperatura', 423.0000, 'ºC'),
	(198345, 119, '2014-02-15 01:12:37.000000', 'temperatura', 190.0000, 'ºC'),
	(198346, 119, '2014-02-15 01:12:38.000000', 'temperatura', 884.0000, 'ºC'),
	(198347, 119, '2014-02-15 01:12:39.000000', 'temperatura', 250.0000, 'ºC'),
	(198348, 119, '2014-02-15 01:12:40.000000', 'temperatura', 997.0000, 'ºC'),
	(198349, 119, '2014-02-15 01:12:41.000000', 'temperatura', 636.0000, 'ºC'),
	(198350, 119, '2014-02-15 01:12:42.000000', 'temperatura', 189.0000, 'ºC'),
	(198351, 119, '2014-02-15 01:12:43.000000', 'temperatura', 240.0000, 'ºC'),
	(198352, 119, '2014-02-15 01:12:44.000000', 'temperatura', 632.0000, 'ºC'),
	(198353, 119, '2014-02-15 01:12:45.000000', 'temperatura', 41.0000, 'ºC'),
	(198354, 119, '2014-02-15 01:12:46.000000', 'temperatura', 710.0000, 'ºC'),
	(198355, 119, '2014-02-15 01:12:47.000000', 'temperatura', 1027.0000, 'ºC'),
	(198356, 119, '2014-02-15 01:12:48.000000', 'temperatura', 605.0000, 'ºC'),
	(198357, 119, '2014-02-15 01:12:49.000000', 'temperatura', 1143.0000, 'ºC'),
	(198358, 119, '2014-02-15 01:12:50.000000', 'temperatura', 303.0000, 'ºC'),
	(198359, 119, '2014-02-15 01:12:51.000000', 'temperatura', 488.0000, 'ºC'),
	(198360, 119, '2014-02-15 01:12:52.000000', 'temperatura', 329.0000, 'ºC'),
	(198361, 119, '2014-02-15 01:12:53.000000', 'temperatura', 180.0000, 'ºC'),
	(198362, 119, '2014-02-15 01:12:54.000000', 'temperatura', 1115.0000, 'ºC'),
	(198363, 119, '2014-02-15 01:12:55.000000', 'temperatura', 238.0000, 'ºC'),
	(198364, 119, '2014-02-15 01:12:56.000000', 'temperatura', 242.0000, 'ºC'),
	(198365, 119, '2014-02-15 01:12:57.000000', 'temperatura', 496.0000, 'ºC'),
	(198366, 119, '2014-02-15 01:12:58.000000', 'temperatura', 558.0000, 'ºC'),
	(198367, 119, '2014-02-15 01:12:59.000000', 'temperatura', 100.0000, 'ºC'),
	(198368, 119, '2014-02-15 01:13:00.000000', 'temperatura', 27.0000, 'ºC'),
	(198369, 119, '2014-02-15 01:13:01.000000', 'temperatura', 1035.0000, 'ºC'),
	(198370, 119, '2014-02-15 01:13:02.000000', 'temperatura', 293.0000, 'ºC'),
	(198371, 119, '2014-02-15 01:13:03.000000', 'temperatura', 763.0000, 'ºC'),
	(198372, 119, '2014-02-15 01:13:04.000000', 'temperatura', 534.0000, 'ºC'),
	(198373, 119, '2014-02-15 01:13:05.000000', 'temperatura', 382.0000, 'ºC'),
	(198374, 119, '2014-02-15 01:13:06.000000', 'temperatura', 307.0000, 'ºC'),
	(198375, 119, '2014-02-15 01:13:07.000000', 'temperatura', 392.0000, 'ºC'),
	(198376, 119, '2014-02-15 01:13:08.000000', 'temperatura', 1038.0000, 'ºC'),
	(198377, 119, '2014-02-15 01:13:09.000000', 'temperatura', 414.0000, 'ºC'),
	(198378, 119, '2014-02-15 01:13:10.000000', 'temperatura', 157.0000, 'ºC'),
	(198379, 119, '2014-02-15 01:13:11.000000', 'temperatura', 744.0000, 'ºC'),
	(198380, 119, '2014-02-15 01:13:12.000000', 'temperatura', 850.0000, 'ºC'),
	(198381, 119, '2014-02-15 01:13:13.000000', 'temperatura', 818.0000, 'ºC'),
	(198382, 119, '2014-02-15 01:13:14.000000', 'temperatura', 340.0000, 'ºC'),
	(198383, 119, '2014-02-15 01:13:15.000000', 'temperatura', 446.0000, 'ºC'),
	(198384, 119, '2014-02-15 01:13:16.000000', 'temperatura', 10.0000, 'ºC'),
	(198385, 119, '2014-02-15 01:13:17.000000', 'temperatura', 1115.0000, 'ºC'),
	(198386, 119, '2014-02-15 01:13:18.000000', 'temperatura', 743.0000, 'ºC'),
	(198387, 119, '2014-02-15 01:13:19.000000', 'temperatura', 371.0000, 'ºC'),
	(198388, 119, '2014-02-15 01:13:20.000000', 'temperatura', 827.0000, 'ºC'),
	(198389, 119, '2014-02-15 01:13:21.000000', 'temperatura', 623.0000, 'ºC'),
	(198390, 119, '2014-02-15 01:13:22.000000', 'temperatura', 636.0000, 'ºC'),
	(198391, 119, '2014-02-15 01:13:23.000000', 'temperatura', 109.0000, 'ºC'),
	(198392, 119, '2014-02-15 01:13:24.000000', 'temperatura', 1037.0000, 'ºC'),
	(198393, 119, '2014-02-15 01:13:25.000000', 'temperatura', 59.0000, 'ºC'),
	(198394, 119, '2014-02-15 01:13:26.000000', 'temperatura', 783.0000, 'ºC'),
	(198395, 119, '2014-02-15 01:13:27.000000', 'temperatura', 140.0000, 'ºC'),
	(198396, 119, '2014-02-15 01:13:28.000000', 'temperatura', 750.0000, 'ºC'),
	(198397, 119, '2014-02-15 01:13:29.000000', 'temperatura', 930.0000, 'ºC'),
	(198398, 119, '2014-02-15 01:13:30.000000', 'temperatura', 0.0000, 'ºC'),
	(198399, 119, '2014-02-15 01:13:31.000000', 'temperatura', 812.0000, 'ºC'),
	(198400, 119, '2014-02-15 01:13:32.000000', 'temperatura', 460.0000, 'ºC'),
	(198401, 119, '2014-02-15 01:13:33.000000', 'temperatura', 1066.0000, 'ºC'),
	(198402, 119, '2014-02-15 01:13:34.000000', 'temperatura', 350.0000, 'ºC'),
	(198403, 119, '2014-02-15 01:13:35.000000', 'temperatura', 953.0000, 'ºC'),
	(198404, 119, '2014-02-15 01:13:36.000000', 'temperatura', 115.0000, 'ºC'),
	(198405, 119, '2014-02-15 01:13:37.000000', 'temperatura', 117.0000, 'ºC'),
	(198406, 119, '2014-02-15 01:13:38.000000', 'temperatura', 241.0000, 'ºC'),
	(198407, 119, '2014-02-15 01:13:39.000000', 'temperatura', 854.0000, 'ºC'),
	(198408, 119, '2014-02-15 01:13:40.000000', 'temperatura', 1147.0000, 'ºC'),
	(198409, 119, '2014-02-15 01:13:41.000000', 'temperatura', 774.0000, 'ºC'),
	(198410, 119, '2014-02-15 01:13:42.000000', 'temperatura', 430.0000, 'ºC'),
	(198411, 119, '2014-02-15 01:13:43.000000', 'temperatura', 1028.0000, 'ºC'),
	(198412, 119, '2014-02-15 01:13:44.000000', 'temperatura', 251.0000, 'ºC'),
	(198413, 119, '2014-02-15 01:13:45.000000', 'temperatura', 573.0000, 'ºC'),
	(198414, 119, '2014-02-15 01:13:46.000000', 'temperatura', 909.0000, 'ºC'),
	(198415, 119, '2014-02-15 01:13:47.000000', 'temperatura', 430.0000, 'ºC'),
	(198416, 119, '2014-02-15 01:13:48.000000', 'temperatura', 620.0000, 'ºC'),
	(198417, 119, '2014-02-15 01:13:49.000000', 'temperatura', 614.0000, 'ºC'),
	(198418, 119, '2014-02-15 01:13:50.000000', 'temperatura', 8.0000, 'ºC'),
	(198419, 119, '2014-02-15 01:13:51.000000', 'temperatura', 597.0000, 'ºC'),
	(198420, 119, '2014-02-15 01:13:52.000000', 'temperatura', 565.0000, 'ºC'),
	(198421, 119, '2014-02-15 01:13:53.000000', 'temperatura', 1032.0000, 'ºC'),
	(198422, 119, '2014-02-15 01:13:54.000000', 'temperatura', 1065.0000, 'ºC'),
	(198423, 119, '2014-02-15 01:13:55.000000', 'temperatura', 1032.0000, 'ºC'),
	(198424, 119, '2014-02-15 01:13:56.000000', 'temperatura', 765.0000, 'ºC'),
	(198425, 119, '2014-02-15 01:13:57.000000', 'temperatura', 727.0000, 'ºC'),
	(198426, 119, '2014-02-15 01:13:58.000000', 'temperatura', 143.0000, 'ºC'),
	(198427, 119, '2014-02-15 01:13:59.000000', 'temperatura', 934.0000, 'ºC'),
	(198428, 119, '2014-02-15 01:14:00.000000', 'temperatura', 640.0000, 'ºC'),
	(198429, 119, '2014-02-15 01:14:01.000000', 'temperatura', 400.0000, 'ºC'),
	(198430, 119, '2014-02-15 01:14:02.000000', 'temperatura', 81.0000, 'ºC'),
	(198431, 119, '2014-02-15 01:14:03.000000', 'temperatura', 407.0000, 'ºC'),
	(198432, 119, '2014-02-15 01:14:04.000000', 'temperatura', 589.0000, 'ºC'),
	(198433, 119, '2014-02-15 01:14:05.000000', 'temperatura', 528.0000, 'ºC'),
	(198434, 119, '2014-02-15 01:14:06.000000', 'temperatura', 872.0000, 'ºC'),
	(198435, 119, '2014-02-15 01:14:07.000000', 'temperatura', 376.0000, 'ºC'),
	(198436, 119, '2014-02-15 01:14:08.000000', 'temperatura', 463.0000, 'ºC'),
	(198437, 119, '2014-02-15 01:14:09.000000', 'temperatura', 1190.0000, 'ºC'),
	(198438, 119, '2014-02-15 01:14:10.000000', 'temperatura', 959.0000, 'ºC'),
	(198439, 119, '2014-02-15 01:14:11.000000', 'temperatura', 25.0000, 'ºC'),
	(198440, 119, '2014-02-15 01:14:12.000000', 'temperatura', 850.0000, 'ºC'),
	(198441, 119, '2014-02-15 01:14:13.000000', 'temperatura', 575.0000, 'ºC'),
	(198442, 119, '2014-02-15 01:14:14.000000', 'temperatura', 324.0000, 'ºC'),
	(198443, 119, '2014-02-15 01:14:15.000000', 'temperatura', 1096.0000, 'ºC'),
	(198444, 119, '2014-02-15 01:14:16.000000', 'temperatura', 911.0000, 'ºC'),
	(198445, 119, '2014-02-15 01:14:17.000000', 'temperatura', 64.0000, 'ºC'),
	(198446, 119, '2014-02-15 01:14:18.000000', 'temperatura', 1189.0000, 'ºC'),
	(198447, 119, '2014-02-15 01:14:19.000000', 'temperatura', 954.0000, 'ºC'),
	(198448, 119, '2014-02-15 01:14:20.000000', 'temperatura', 4.0000, 'ºC'),
	(198449, 119, '2014-02-15 01:14:21.000000', 'temperatura', 760.0000, 'ºC'),
	(198450, 119, '2014-02-15 01:14:22.000000', 'temperatura', 185.0000, 'ºC'),
	(198451, 119, '2014-02-15 01:14:23.000000', 'temperatura', 1048.0000, 'ºC'),
	(198452, 119, '2014-02-15 01:14:24.000000', 'temperatura', 1086.0000, 'ºC'),
	(198453, 119, '2014-02-15 01:14:25.000000', 'temperatura', 1086.0000, 'ºC'),
	(198454, 119, '2014-02-15 01:14:26.000000', 'temperatura', 970.0000, 'ºC'),
	(198455, 119, '2014-02-15 01:14:27.000000', 'temperatura', 395.0000, 'ºC'),
	(198456, 119, '2014-02-15 01:14:28.000000', 'temperatura', 264.0000, 'ºC'),
	(198457, 119, '2014-02-15 01:14:29.000000', 'temperatura', 135.0000, 'ºC'),
	(198458, 119, '2014-02-15 01:14:30.000000', 'temperatura', 1084.0000, 'ºC'),
	(198459, 119, '2014-02-15 01:14:31.000000', 'temperatura', 217.0000, 'ºC'),
	(198460, 119, '2014-02-15 01:14:32.000000', 'temperatura', 232.0000, 'ºC'),
	(198461, 119, '2014-02-15 01:14:33.000000', 'temperatura', 509.0000, 'ºC'),
	(198462, 119, '2014-02-15 01:14:34.000000', 'temperatura', 652.0000, 'ºC'),
	(198463, 119, '2014-02-15 01:14:35.000000', 'temperatura', 531.0000, 'ºC'),
	(198464, 119, '2014-02-15 01:14:36.000000', 'temperatura', 700.0000, 'ºC'),
	(198465, 119, '2014-02-15 01:14:37.000000', 'temperatura', 709.0000, 'ºC'),
	(198466, 119, '2014-02-15 01:14:38.000000', 'temperatura', 246.0000, 'ºC'),
	(198467, 119, '2014-02-15 01:14:39.000000', 'temperatura', 303.0000, 'ºC'),
	(198468, 119, '2014-02-15 01:14:40.000000', 'temperatura', 778.0000, 'ºC'),
	(198469, 119, '2014-02-15 01:14:41.000000', 'temperatura', 583.0000, 'ºC'),
	(198470, 119, '2014-02-15 01:14:42.000000', 'temperatura', 579.0000, 'ºC'),
	(198471, 119, '2014-02-15 01:14:43.000000', 'temperatura', 1147.0000, 'ºC'),
	(198472, 119, '2014-02-15 01:14:44.000000', 'temperatura', 399.0000, 'ºC'),
	(198473, 119, '2014-02-15 01:14:45.000000', 'temperatura', 954.0000, 'ºC'),
	(198474, 119, '2014-02-15 01:14:46.000000', 'temperatura', 1173.0000, 'ºC'),
	(198475, 119, '2014-02-15 01:14:47.000000', 'temperatura', 604.0000, 'ºC'),
	(198476, 119, '2014-02-15 01:14:48.000000', 'temperatura', 699.0000, 'ºC'),
	(198477, 119, '2014-02-15 01:14:49.000000', 'temperatura', 487.0000, 'ºC'),
	(198478, 119, '2014-02-15 01:14:50.000000', 'temperatura', 338.0000, 'ºC'),
	(198479, 119, '2014-02-15 01:14:51.000000', 'temperatura', 227.0000, 'ºC'),
	(198480, 119, '2014-02-15 01:14:52.000000', 'temperatura', 123.0000, 'ºC'),
	(198481, 119, '2014-02-15 01:14:53.000000', 'temperatura', 1133.0000, 'ºC'),
	(198482, 119, '2014-02-15 01:14:54.000000', 'temperatura', 498.0000, 'ºC'),
	(198483, 119, '2014-02-15 01:14:55.000000', 'temperatura', 292.0000, 'ºC'),
	(198484, 119, '2014-02-15 01:14:56.000000', 'temperatura', 1165.0000, 'ºC'),
	(198485, 119, '2014-02-15 01:14:57.000000', 'temperatura', 148.0000, 'ºC'),
	(198486, 119, '2014-02-15 01:14:58.000000', 'temperatura', 848.0000, 'ºC'),
	(198487, 119, '2014-02-15 01:14:59.000000', 'temperatura', 196.0000, 'ºC'),
	(198488, 119, '2014-02-15 01:15:00.000000', 'temperatura', 835.0000, 'ºC'),
	(198489, 119, '2014-02-15 01:15:01.000000', 'temperatura', 1188.0000, 'ºC'),
	(198490, 119, '2014-02-15 01:15:02.000000', 'temperatura', 1037.0000, 'ºC'),
	(198491, 119, '2014-02-15 01:15:03.000000', 'temperatura', 419.0000, 'ºC'),
	(198492, 119, '2014-02-15 01:15:04.000000', 'temperatura', 184.0000, 'ºC'),
	(198493, 119, '2014-02-15 01:15:05.000000', 'temperatura', 863.0000, 'ºC'),
	(198494, 119, '2014-02-15 01:15:06.000000', 'temperatura', 165.0000, 'ºC'),
	(198495, 119, '2014-02-15 01:15:07.000000', 'temperatura', 635.0000, 'ºC'),
	(198496, 119, '2014-02-15 01:15:08.000000', 'temperatura', 281.0000, 'ºC'),
	(198497, 119, '2014-02-15 01:15:09.000000', 'temperatura', 702.0000, 'ºC'),
	(198498, 119, '2014-02-15 01:15:10.000000', 'temperatura', 266.0000, 'ºC'),
	(198499, 119, '2014-02-15 01:15:11.000000', 'temperatura', 424.0000, 'ºC'),
	(198500, 119, '2014-02-15 01:15:12.000000', 'temperatura', 124.0000, 'ºC'),
	(198501, 119, '2014-02-15 01:15:13.000000', 'temperatura', 547.0000, 'ºC'),
	(198502, 119, '2014-02-15 01:15:14.000000', 'temperatura', 1166.0000, 'ºC'),
	(198503, 119, '2014-02-15 01:15:15.000000', 'temperatura', 588.0000, 'ºC'),
	(198504, 119, '2014-02-15 01:15:16.000000', 'temperatura', 644.0000, 'ºC'),
	(198505, 119, '2014-02-15 01:15:17.000000', 'temperatura', 254.0000, 'ºC'),
	(198506, 119, '2014-02-15 01:15:18.000000', 'temperatura', 541.0000, 'ºC'),
	(198507, 119, '2014-02-15 01:15:19.000000', 'temperatura', 744.0000, 'ºC'),
	(198508, 119, '2014-02-15 01:15:20.000000', 'temperatura', 898.0000, 'ºC'),
	(198509, 119, '2014-02-15 01:15:21.000000', 'temperatura', 1058.0000, 'ºC'),
	(198510, 119, '2014-02-15 01:15:22.000000', 'temperatura', 195.0000, 'ºC'),
	(198511, 119, '2014-02-15 01:15:23.000000', 'temperatura', 202.0000, 'ºC'),
	(198512, 119, '2014-02-15 01:15:24.000000', 'temperatura', 426.0000, 'ºC'),
	(198513, 119, '2014-02-15 01:15:25.000000', 'temperatura', 323.0000, 'ºC'),
	(198514, 119, '2014-02-15 01:15:26.000000', 'temperatura', 337.0000, 'ºC'),
	(198515, 119, '2014-02-15 01:15:27.000000', 'temperatura', 718.0000, 'ºC'),
	(198516, 119, '2014-02-15 01:15:28.000000', 'temperatura', 180.0000, 'ºC'),
	(198517, 119, '2014-02-15 01:15:29.000000', 'temperatura', 1146.0000, 'ºC'),
	(198518, 119, '2014-02-15 01:15:30.000000', 'temperatura', 391.0000, 'ºC'),
	(198519, 119, '2014-02-15 01:15:31.000000', 'temperatura', 915.0000, 'ºC'),
	(198520, 119, '2014-02-15 01:15:32.000000', 'temperatura', 1005.0000, 'ºC'),
	(198521, 119, '2014-02-15 01:15:33.000000', 'temperatura', 1081.0000, 'ºC'),
	(198522, 119, '2014-02-15 01:15:34.000000', 'temperatura', 1188.0000, 'ºC'),
	(198523, 119, '2014-02-15 01:15:35.000000', 'temperatura', 300.0000, 'ºC'),
	(198524, 119, '2014-02-15 01:15:36.000000', 'temperatura', 335.0000, 'ºC'),
	(198525, 119, '2014-02-15 01:15:37.000000', 'temperatura', 776.0000, 'ºC'),
	(198526, 119, '2014-02-15 01:15:38.000000', 'temperatura', 477.0000, 'ºC'),
	(198527, 119, '2014-02-15 01:15:39.000000', 'temperatura', 57.0000, 'ºC'),
	(198528, 119, '2014-02-15 01:15:40.000000', 'temperatura', 55.0000, 'ºC'),
	(198529, 119, '2014-02-15 01:15:41.000000', 'temperatura', 102.0000, 'ºC'),
	(198530, 119, '2014-02-15 01:15:42.000000', 'temperatura', 348.0000, 'ºC'),
	(198531, 119, '2014-02-15 01:15:43.000000', 'temperatura', 236.0000, 'ºC'),
	(198532, 119, '2014-02-15 01:15:44.000000', 'temperatura', 133.0000, 'ºC'),
	(198533, 119, '2014-02-15 01:15:45.000000', 'temperatura', 1160.0000, 'ºC'),
	(198534, 119, '2014-02-15 01:15:46.000000', 'temperatura', 602.0000, 'ºC'),
	(198535, 119, '2014-02-15 01:15:47.000000', 'temperatura', 731.0000, 'ºC'),
	(198536, 119, '2014-02-15 01:15:48.000000', 'temperatura', 647.0000, 'ºC'),
	(198537, 119, '2014-02-15 01:15:49.000000', 'temperatura', 1042.0000, 'ºC'),
	(198538, 119, '2014-02-15 01:15:50.000000', 'temperatura', 871.0000, 'ºC'),
	(198539, 119, '2014-02-15 01:15:51.000000', 'temperatura', 28.0000, 'ºC'),
	(198540, 119, '2014-02-15 01:15:52.000000', 'temperatura', 1128.0000, 'ºC'),
	(198541, 119, '2014-02-15 01:15:53.000000', 'temperatura', 756.0000, 'ºC'),
	(198542, 119, '2014-02-15 01:15:54.000000', 'temperatura', 397.0000, 'ºC'),
	(198543, 119, '2014-02-15 01:15:55.000000', 'temperatura', 916.0000, 'ºC'),
	(198544, 119, '2014-02-15 01:15:56.000000', 'temperatura', 991.0000, 'ºC'),
	(198545, 119, '2014-02-15 01:15:57.000000', 'temperatura', 1007.0000, 'ºC'),
	(198546, 119, '2014-02-15 01:15:58.000000', 'temperatura', 862.0000, 'ºC'),
	(198547, 119, '2014-02-15 01:15:59.000000', 'temperatura', 88.0000, 'ºC'),
	(198548, 119, '2014-02-15 01:16:00.000000', 'temperatura', 258.0000, 'ºC'),
	(198549, 119, '2014-02-15 01:16:01.000000', 'temperatura', 1025.0000, 'ºC'),
	(198550, 119, '2014-02-15 01:16:02.000000', 'temperatura', 750.0000, 'ºC'),
	(198551, 119, '2014-02-15 01:16:03.000000', 'temperatura', 677.0000, 'ºC'),
	(198552, 119, '2014-02-15 01:16:04.000000', 'temperatura', 1137.0000, 'ºC'),
	(198553, 119, '2014-02-15 01:16:05.000000', 'temperatura', 51.0000, 'ºC'),
	(198554, 119, '2014-02-15 01:16:06.000000', 'temperatura', 448.0000, 'ºC'),
	(198555, 119, '2014-02-15 01:16:07.000000', 'temperatura', 885.0000, 'ºC'),
	(198556, 119, '2014-02-15 01:16:08.000000', 'temperatura', 684.0000, 'ºC'),
	(198557, 119, '2014-02-15 01:16:09.000000', 'temperatura', 763.0000, 'ºC'),
	(198558, 119, '2014-02-15 01:16:10.000000', 'temperatura', 566.0000, 'ºC'),
	(198559, 119, '2014-02-15 01:16:11.000000', 'temperatura', 542.0000, 'ºC'),
	(198560, 119, '2014-02-15 01:16:12.000000', 'temperatura', 1011.0000, 'ºC'),
	(198561, 119, '2014-02-15 01:16:13.000000', 'temperatura', 1028.0000, 'ºC'),
	(198562, 119, '2014-02-15 01:16:14.000000', 'temperatura', 909.0000, 'ºC'),
	(198563, 119, '2014-02-15 01:16:15.000000', 'temperatura', 262.0000, 'ºC'),
	(198564, 119, '2014-02-15 01:16:16.000000', 'temperatura', 985.0000, 'ºC'),
	(198565, 119, '2014-02-15 01:16:17.000000', 'temperatura', 538.0000, 'ºC'),
	(198566, 119, '2014-02-15 01:16:18.000000', 'temperatura', 934.0000, 'ºC'),
	(198567, 119, '2014-02-15 01:16:19.000000', 'temperatura', 660.0000, 'ºC'),
	(198568, 119, '2014-02-15 01:16:20.000000', 'temperatura', 495.0000, 'ºC'),
	(198569, 119, '2014-02-15 01:16:21.000000', 'temperatura', 499.0000, 'ºC'),
	(198570, 119, '2014-02-15 01:16:22.000000', 'temperatura', 1007.0000, 'ºC'),
	(198571, 119, '2014-02-15 01:16:23.000000', 'temperatura', 1142.0000, 'ºC'),
	(198572, 119, '2014-02-15 01:16:24.000000', 'temperatura', 288.0000, 'ºC'),
	(198573, 119, '2014-02-15 01:16:25.000000', 'temperatura', 414.0000, 'ºC'),
	(198574, 119, '2014-02-15 01:16:26.000000', 'temperatura', 6.0000, 'ºC'),
	(198575, 119, '2014-02-15 01:16:27.000000', 'temperatura', 1188.0000, 'ºC'),
	(198576, 119, '2014-02-15 01:16:28.000000', 'temperatura', 1123.0000, 'ºC'),
	(198577, 119, '2014-02-15 01:16:29.000000', 'temperatura', 851.0000, 'ºC'),
	(198578, 119, '2014-02-15 01:16:30.000000', 'temperatura', 887.0000, 'ºC'),
	(198579, 119, '2014-02-15 01:16:31.000000', 'temperatura', 681.0000, 'ºC'),
	(198580, 119, '2014-02-15 01:16:32.000000', 'temperatura', 745.0000, 'ºC'),
	(198581, 119, '2014-02-15 01:16:33.000000', 'temperatura', 485.0000, 'ºC'),
	(198582, 119, '2014-02-15 01:16:34.000000', 'temperatura', 189.0000, 'ºC'),
	(198583, 119, '2014-02-15 01:16:35.000000', 'temperatura', 689.0000, 'ºC'),
	(198584, 119, '2014-02-15 01:16:36.000000', 'temperatura', 481.0000, 'ºC'),
	(198585, 119, '2014-02-15 01:16:37.000000', 'temperatura', 338.0000, 'ºC'),
	(198586, 119, '2014-02-15 01:16:38.000000', 'temperatura', 245.0000, 'ºC'),
	(198587, 119, '2014-02-15 01:16:39.000000', 'temperatura', 214.0000, 'ºC'),
	(198588, 119, '2014-02-15 01:16:40.000000', 'temperatura', 333.0000, 'ºC'),
	(198589, 119, '2014-02-15 01:16:41.000000', 'temperatura', 1023.0000, 'ºC'),
	(198590, 119, '2014-02-15 01:16:42.000000', 'temperatura', 519.0000, 'ºC'),
	(198591, 119, '2014-02-15 01:16:43.000000', 'temperatura', 726.0000, 'ºC'),
	(198592, 119, '2014-02-15 01:16:44.000000', 'temperatura', 872.0000, 'ºC'),
	(198593, 119, '2014-02-15 01:16:45.000000', 'temperatura', 984.0000, 'ºC'),
	(198594, 119, '2014-02-15 01:16:46.000000', 'temperatura', 1103.0000, 'ºC'),
	(198595, 119, '2014-02-15 01:16:47.000000', 'temperatura', 165.0000, 'ºC'),
	(198596, 119, '2014-02-15 01:16:48.000000', 'temperatura', 1116.0000, 'ºC'),
	(198597, 119, '2014-02-15 01:16:49.000000', 'temperatura', 287.0000, 'ºC'),
	(198598, 119, '2014-02-15 01:16:50.000000', 'temperatura', 488.0000, 'ºC'),
	(198599, 119, '2014-02-15 01:16:51.000000', 'temperatura', 380.0000, 'ºC'),
	(198600, 119, '2014-02-15 01:16:52.000000', 'temperatura', 435.0000, 'ºC'),
	(198601, 119, '2014-02-15 01:16:53.000000', 'temperatura', 1036.0000, 'ºC'),
	(198602, 119, '2014-02-15 01:16:54.000000', 'temperatura', 275.0000, 'ºC'),
	(198603, 119, '2014-02-15 01:16:55.000000', 'temperatura', 666.0000, 'ºC'),
	(198604, 119, '2014-02-15 01:16:56.000000', 'temperatura', 108.0000, 'ºC'),
	(198605, 119, '2014-02-15 01:16:57.000000', 'temperatura', 941.0000, 'ºC'),
	(198606, 119, '2014-02-15 01:16:58.000000', 'temperatura', 782.0000, 'ºC'),
	(198607, 119, '2014-02-15 01:16:59.000000', 'temperatura', 1087.0000, 'ºC'),
	(198608, 119, '2014-02-15 01:17:00.000000', 'temperatura', 690.0000, 'ºC'),
	(198609, 119, '2014-02-15 01:17:01.000000', 'temperatura', 188.0000, 'ºC'),
	(198610, 119, '2014-02-15 01:17:02.000000', 'temperatura', 73.0000, 'ºC'),
	(198611, 119, '2014-02-15 01:17:03.000000', 'temperatura', 1002.0000, 'ºC'),
	(198612, 119, '2014-02-15 01:17:04.000000', 'temperatura', 1192.0000, 'ºC'),
	(198613, 119, '2014-02-15 01:17:05.000000', 'temperatura', 551.0000, 'ºC'),
	(198614, 119, '2014-02-15 01:17:06.000000', 'temperatura', 383.0000, 'ºC'),
	(198615, 119, '2014-02-15 01:17:07.000000', 'temperatura', 260.0000, 'ºC'),
	(198616, 119, '2014-02-15 01:17:08.000000', 'temperatura', 153.0000, 'ºC'),
	(198617, 119, '2014-02-15 01:17:09.000000', 'temperatura', 1186.0000, 'ºC'),
	(198618, 119, '2014-02-15 01:17:10.000000', 'temperatura', 670.0000, 'ºC'),
	(198619, 119, '2014-02-15 01:17:11.000000', 'temperatura', 995.0000, 'ºC'),
	(198620, 119, '2014-02-15 01:17:12.000000', 'temperatura', 563.0000, 'ºC'),
	(198621, 119, '2014-02-15 01:17:13.000000', 'temperatura', 1030.0000, 'ºC'),
	(198622, 119, '2014-02-15 01:17:14.000000', 'temperatura', 1060.0000, 'ºC'),
	(198623, 119, '2014-02-15 01:17:15.000000', 'temperatura', 1013.0000, 'ºC'),
	(198624, 119, '2014-02-15 01:17:16.000000', 'temperatura', 687.0000, 'ºC'),
	(198625, 119, '2014-02-15 01:17:17.000000', 'temperatura', 394.0000, 'ºC'),
	(198626, 119, '2014-02-15 01:17:18.000000', 'temperatura', 1108.0000, 'ºC'),
	(198627, 119, '2014-02-15 01:17:19.000000', 'temperatura', 761.0000, 'ºC'),
	(198628, 119, '2014-02-15 01:17:20.000000', 'temperatura', 483.0000, 'ºC'),
	(198629, 119, '2014-02-15 01:17:21.000000', 'temperatura', 129.0000, 'ºC'),
	(198630, 119, '2014-02-15 01:17:22.000000', 'temperatura', 398.0000, 'ºC'),
	(198631, 119, '2014-02-15 01:17:23.000000', 'temperatura', 402.0000, 'ºC'),
	(198632, 119, '2014-02-15 01:17:24.000000', 'temperatura', 820.0000, 'ºC'),
	(198633, 119, '2014-02-15 01:17:25.000000', 'temperatura', 491.0000, 'ºC'),
	(198634, 119, '2014-02-15 01:17:26.000000', 'temperatura', 1197.0000, 'ºC'),
	(198635, 119, '2014-02-15 01:17:27.000000', 'temperatura', 912.0000, 'ºC'),
	(198636, 119, '2014-02-15 01:17:28.000000', 'temperatura', 971.0000, 'ºC'),
	(198637, 119, '2014-02-15 01:17:29.000000', 'temperatura', 920.0000, 'ºC'),
	(198638, 119, '2014-02-15 01:17:30.000000', 'temperatura', 487.0000, 'ºC'),
	(198639, 119, '2014-02-15 01:17:31.000000', 'temperatura', 874.0000, 'ºC'),
	(198640, 119, '2014-02-15 01:17:32.000000', 'temperatura', 508.0000, 'ºC'),
	(198641, 119, '2014-02-15 01:17:33.000000', 'temperatura', 1122.0000, 'ºC'),
	(198642, 119, '2014-02-15 01:17:34.000000', 'temperatura', 486.0000, 'ºC'),
	(198643, 119, '2014-02-15 01:17:35.000000', 'temperatura', 263.0000, 'ºC'),
	(198644, 119, '2014-02-15 01:17:36.000000', 'temperatura', 1057.0000, 'ºC'),
	(198645, 119, '2014-02-15 01:17:37.000000', 'temperatura', 897.0000, 'ºC'),
	(198646, 119, '2014-02-15 01:17:38.000000', 'temperatura', 113.0000, 'ºC'),
	(198647, 119, '2014-02-15 01:17:39.000000', 'temperatura', 275.0000, 'ºC'),
	(198648, 119, '2014-02-15 01:17:40.000000', 'temperatura', 1038.0000, 'ºC'),
	(198649, 119, '2014-02-15 01:17:41.000000', 'temperatura', 766.0000, 'ºC'),
	(198650, 119, '2014-02-15 01:17:42.000000', 'temperatura', 715.0000, 'ºC'),
	(198651, 119, '2014-02-15 01:17:43.000000', 'temperatura', 77.0000, 'ºC'),
	(198652, 119, '2014-02-15 01:17:44.000000', 'temperatura', 639.0000, 'ºC'),
	(198653, 119, '2014-02-15 01:17:45.000000', 'temperatura', 566.0000, 'ºC'),
	(198654, 119, '2014-02-15 01:17:46.000000', 'temperatura', 915.0000, 'ºC'),
	(198655, 119, '2014-02-15 01:17:47.000000', 'temperatura', 476.0000, 'ºC'),
	(198656, 119, '2014-02-15 01:17:48.000000', 'temperatura', 838.0000, 'ºC'),
	(198657, 119, '2014-02-15 01:17:49.000000', 'temperatura', 359.0000, 'ºC'),
	(198658, 119, '2014-02-15 01:17:50.000000', 'temperatura', 483.0000, 'ºC'),
	(198659, 119, '2014-02-15 01:17:51.000000', 'temperatura', 139.0000, 'ºC'),
	(198660, 119, '2014-02-15 01:17:52.000000', 'temperatura', 448.0000, 'ºC'),
	(198661, 119, '2014-02-15 01:17:53.000000', 'temperatura', 623.0000, 'ºC'),
	(198662, 119, '2014-02-15 01:17:54.000000', 'temperatura', 569.0000, 'ºC'),
	(198663, 119, '2014-02-15 01:17:55.000000', 'temperatura', 979.0000, 'ºC'),
	(198664, 119, '2014-02-15 01:17:56.000000', 'temperatura', 789.0000, 'ºC'),
	(198665, 119, '2014-02-15 01:17:57.000000', 'temperatura', 1007.0000, 'ºC'),
	(198666, 119, '2014-02-15 01:17:58.000000', 'temperatura', 268.0000, 'ºC'),
	(198667, 119, '2014-02-15 01:17:59.000000', 'temperatura', 719.0000, 'ºC'),
	(198668, 119, '2014-02-15 01:18:00.000000', 'temperatura', 394.0000, 'ºC'),
	(198669, 119, '2014-02-15 01:18:01.000000', 'temperatura', 1012.0000, 'ºC'),
	(198670, 119, '2014-02-15 01:18:02.000000', 'temperatura', 280.0000, 'ºC'),
	(198671, 119, '2014-02-15 01:18:03.000000', 'temperatura', 761.0000, 'ºC'),
	(198672, 119, '2014-02-15 01:18:04.000000', 'temperatura', 569.0000, 'ºC'),
	(198673, 119, '2014-02-15 01:18:05.000000', 'temperatura', 563.0000, 'ºC'),
	(198674, 119, '2014-02-15 01:18:06.000000', 'temperatura', 1107.0000, 'ºC'),
	(198675, 119, '2014-02-15 01:18:07.000000', 'temperatura', 246.0000, 'ºC'),
	(198676, 119, '2014-02-15 01:18:08.000000', 'temperatura', 312.0000, 'ºC'),
	(198677, 119, '2014-02-15 01:18:09.000000', 'temperatura', 821.0000, 'ºC'),
	(198678, 119, '2014-02-15 01:18:10.000000', 'temperatura', 769.0000, 'ºC'),
	(198679, 119, '2014-02-15 01:18:11.000000', 'temperatura', 181.0000, 'ºC'),
	(198680, 119, '2014-02-15 01:18:12.000000', 'temperatura', 1000.0000, 'ºC'),
	(198681, 120, '2014-02-15 00:00:00.000000', 'temperatura', 82.0000, 'ºC'),
	(198682, 120, '2014-02-15 00:00:01.000000', 'temperatura', 240.0000, 'ºC'),
	(198683, 120, '2014-02-15 00:00:02.000000', 'temperatura', 957.0000, 'ºC'),
	(198684, 120, '2014-02-15 00:00:03.000000', 'temperatura', 466.0000, 'ºC'),
	(198685, 120, '2014-02-15 00:00:04.000000', 'temperatura', 657.0000, 'ºC'),
	(198686, 120, '2014-02-15 00:00:05.000000', 'temperatura', 689.0000, 'ºC'),
	(198687, 120, '2014-02-15 00:00:06.000000', 'temperatura', 275.0000, 'ºC'),
	(198688, 120, '2014-02-15 00:00:07.000000', 'temperatura', 509.0000, 'ºC'),
	(198689, 120, '2014-02-15 00:00:08.000000', 'temperatura', 521.0000, 'ºC'),
	(198690, 120, '2014-02-15 00:00:09.000000', 'temperatura', 1078.0000, 'ºC'),
	(198691, 120, '2014-02-15 00:00:10.000000', 'temperatura', 229.0000, 'ºC'),
	(198692, 120, '2014-02-15 00:00:11.000000', 'temperatura', 309.0000, 'ºC'),
	(198693, 120, '2014-02-15 00:00:12.000000', 'temperatura', 860.0000, 'ºC'),
	(198694, 120, '2014-02-15 00:00:13.000000', 'temperatura', 973.0000, 'ºC'),
	(198695, 120, '2014-02-15 00:00:14.000000', 'temperatura', 1084.0000, 'ºC'),
	(198696, 120, '2014-02-15 00:00:15.000000', 'temperatura', 103.0000, 'ºC'),
	(198697, 120, '2014-02-15 00:00:16.000000', 'temperatura', 861.0000, 'ºC'),
	(198698, 120, '2014-02-15 00:00:17.000000', 'temperatura', 399.0000, 'ºC'),
	(198699, 120, '2014-02-15 00:00:18.000000', 'temperatura', 612.0000, 'ºC'),
	(198700, 120, '2014-02-15 00:00:19.000000', 'temperatura', 663.0000, 'ºC'),
	(198701, 120, '2014-02-15 00:00:20.000000', 'temperatura', 282.0000, 'ºC'),
	(198702, 120, '2014-02-15 00:00:21.000000', 'temperatura', 618.0000, 'ºC'),
	(198703, 120, '2014-02-15 00:00:22.000000', 'temperatura', 1046.0000, 'ºC'),
	(198704, 120, '2014-02-15 00:00:23.000000', 'temperatura', 975.0000, 'ºC'),
	(198705, 120, '2014-02-15 00:00:24.000000', 'temperatura', 539.0000, 'ºC'),
	(198706, 120, '2014-02-15 00:00:25.000000', 'temperatura', 970.0000, 'ºC'),
	(198707, 120, '2014-02-15 00:00:26.000000', 'temperatura', 832.0000, 'ºC'),
	(198708, 120, '2014-02-15 00:00:27.000000', 'temperatura', 53.0000, 'ºC'),
	(198709, 120, '2014-02-15 00:00:28.000000', 'temperatura', 169.0000, 'ºC'),
	(198710, 120, '2014-02-15 00:00:29.000000', 'temperatura', 686.0000, 'ºC'),
	(198711, 120, '2014-02-15 00:00:30.000000', 'temperatura', 524.0000, 'ºC'),
	(198712, 120, '2014-02-15 00:00:31.000000', 'temperatura', 562.0000, 'ºC'),
	(198713, 120, '2014-02-15 00:00:32.000000', 'temperatura', 37.0000, 'ºC'),
	(198714, 120, '2014-02-15 00:00:33.000000', 'temperatura', 901.0000, 'ºC'),
	(198715, 120, '2014-02-15 00:00:34.000000', 'temperatura', 795.0000, 'ºC'),
	(198716, 120, '2014-02-15 00:00:35.000000', 'temperatura', 74.0000, 'ºC'),
	(198717, 120, '2014-02-15 00:00:36.000000', 'temperatura', 384.0000, 'ºC'),
	(198718, 120, '2014-02-15 00:00:37.000000', 'temperatura', 498.0000, 'ºC'),
	(198719, 120, '2014-02-15 00:00:38.000000', 'temperatura', 138.0000, 'ºC'),
	(198720, 120, '2014-02-15 00:00:39.000000', 'temperatura', 396.0000, 'ºC'),
	(198721, 120, '2014-02-15 00:00:40.000000', 'temperatura', 366.0000, 'ºC'),
	(198722, 120, '2014-02-15 00:00:41.000000', 'temperatura', 643.0000, 'ºC'),
	(198723, 120, '2014-02-15 00:00:42.000000', 'temperatura', 919.0000, 'ºC'),
	(198724, 120, '2014-02-15 00:00:43.000000', 'temperatura', 264.0000, 'ºC'),
	(198725, 120, '2014-02-15 00:00:44.000000', 'temperatura', 966.0000, 'ºC'),
	(198726, 120, '2014-02-15 00:00:45.000000', 'temperatura', 438.0000, 'ºC'),
	(198727, 120, '2014-02-15 00:00:46.000000', 'temperatura', 494.0000, 'ºC'),
	(198728, 120, '2014-02-15 00:00:47.000000', 'temperatura', 1154.0000, 'ºC'),
	(198729, 120, '2014-02-15 00:00:48.000000', 'temperatura', 687.0000, 'ºC'),
	(198730, 120, '2014-02-15 00:00:49.000000', 'temperatura', 1177.0000, 'ºC'),
	(198731, 120, '2014-02-15 00:00:50.000000', 'temperatura', 222.0000, 'ºC'),
	(198732, 120, '2014-02-15 00:00:51.000000', 'temperatura', 1180.0000, 'ºC'),
	(198733, 120, '2014-02-15 00:00:52.000000', 'temperatura', 435.0000, 'ºC'),
	(198734, 120, '2014-02-15 00:00:53.000000', 'temperatura', 1036.0000, 'ºC'),
	(198735, 120, '2014-02-15 00:00:54.000000', 'temperatura', 275.0000, 'ºC'),
	(198736, 120, '2014-02-15 00:00:55.000000', 'temperatura', 667.0000, 'ºC'),
	(198737, 120, '2014-02-15 00:00:56.000000', 'temperatura', 111.0000, 'ºC'),
	(198738, 120, '2014-02-15 00:00:57.000000', 'temperatura', 955.0000, 'ºC'),
	(198739, 120, '2014-02-15 00:00:58.000000', 'temperatura', 841.0000, 'ºC'),
	(198740, 120, '2014-02-15 00:00:59.000000', 'temperatura', 143.0000, 'ºC'),
	(198741, 120, '2014-02-15 00:01:00.000000', 'temperatura', 591.0000, 'ºC'),
	(198742, 120, '2014-02-15 00:01:01.000000', 'temperatura', 127.0000, 'ºC'),
	(198743, 120, '2014-02-15 00:01:02.000000', 'temperatura', 64.0000, 'ºC'),
	(198744, 120, '2014-02-15 00:01:03.000000', 'temperatura', 1139.0000, 'ºC'),
	(198745, 120, '2014-02-15 00:01:04.000000', 'temperatura', 703.0000, 'ºC'),
	(198746, 120, '2014-02-15 00:01:05.000000', 'temperatura', 97.0000, 'ºC'),
	(198747, 120, '2014-02-15 00:01:06.000000', 'temperatura', 775.0000, 'ºC'),
	(198748, 120, '2014-02-15 00:01:07.000000', 'temperatura', 1188.0000, 'ºC'),
	(198749, 120, '2014-02-15 00:01:08.000000', 'temperatura', 16.0000, 'ºC'),
	(198750, 120, '2014-02-15 00:01:09.000000', 'temperatura', 114.0000, 'ºC'),
	(198751, 120, '2014-02-15 00:01:10.000000', 'temperatura', 524.0000, 'ºC'),
	(198752, 120, '2014-02-15 00:01:11.000000', 'temperatura', 1077.0000, 'ºC'),
	(198753, 120, '2014-02-15 00:01:12.000000', 'temperatura', 213.0000, 'ºC'),
	(198754, 120, '2014-02-15 00:01:13.000000', 'temperatura', 236.0000, 'ºC'),
	(198755, 120, '2014-02-15 00:01:14.000000', 'temperatura', 540.0000, 'ºC'),
	(198756, 120, '2014-02-15 00:01:15.000000', 'temperatura', 792.0000, 'ºC'),
	(198757, 120, '2014-02-15 00:01:16.000000', 'temperatura', 1143.0000, 'ºC'),
	(198758, 120, '2014-02-15 00:01:17.000000', 'temperatura', 938.0000, 'ºC'),
	(198759, 120, '2014-02-15 00:01:18.000000', 'temperatura', 62.0000, 'ºC'),
	(198760, 120, '2014-02-15 00:01:19.000000', 'temperatura', 1097.0000, 'ºC'),
	(198761, 120, '2014-02-15 00:01:20.000000', 'temperatura', 499.0000, 'ºC'),
	(198762, 120, '2014-02-15 00:01:21.000000', 'temperatura', 405.0000, 'ºC'),
	(198763, 120, '2014-02-15 00:01:22.000000', 'temperatura', 526.0000, 'ºC'),
	(198764, 120, '2014-02-15 00:01:23.000000', 'temperatura', 219.0000, 'ºC'),
	(198765, 120, '2014-02-15 00:01:24.000000', 'temperatura', 715.0000, 'ºC'),
	(198766, 120, '2014-02-15 00:01:25.000000', 'temperatura', 521.0000, 'ºC'),
	(198767, 120, '2014-02-15 00:01:26.000000', 'temperatura', 459.0000, 'ºC'),
	(198768, 120, '2014-02-15 00:01:27.000000', 'temperatura', 734.0000, 'ºC'),
	(198769, 120, '2014-02-15 00:01:28.000000', 'temperatura', 1094.0000, 'ºC'),
	(198770, 120, '2014-02-15 00:01:29.000000', 'temperatura', 867.0000, 'ºC'),
	(198771, 120, '2014-02-15 00:01:30.000000', 'temperatura', 1054.0000, 'ºC'),
	(198772, 120, '2014-02-15 00:01:31.000000', 'temperatura', 268.0000, 'ºC'),
	(198773, 120, '2014-02-15 00:01:32.000000', 'temperatura', 578.0000, 'ºC'),
	(198774, 120, '2014-02-15 00:01:33.000000', 'temperatura', 888.0000, 'ºC'),
	(198775, 120, '2014-02-15 00:01:34.000000', 'temperatura', 307.0000, 'ºC'),
	(198776, 120, '2014-02-15 00:01:35.000000', 'temperatura', 71.0000, 'ºC'),
	(198777, 120, '2014-02-15 00:01:36.000000', 'temperatura', 633.0000, 'ºC'),
	(198778, 120, '2014-02-15 00:01:37.000000', 'temperatura', 554.0000, 'ºC'),
	(198779, 120, '2014-02-15 00:01:38.000000', 'temperatura', 870.0000, 'ºC'),
	(198780, 120, '2014-02-15 00:01:39.000000', 'temperatura', 288.0000, 'ºC'),
	(198781, 120, '2014-02-15 00:01:40.000000', 'temperatura', 30.0000, 'ºC'),
	(198782, 120, '2014-02-15 00:01:41.000000', 'temperatura', 488.0000, 'ºC'),
	(198783, 120, '2014-02-15 00:01:42.000000', 'temperatura', 1151.0000, 'ºC'),
	(198784, 120, '2014-02-15 00:01:43.000000', 'temperatura', 690.0000, 'ºC'),
	(198785, 120, '2014-02-15 00:01:44.000000', 'temperatura', 1196.0000, 'ºC'),
	(198786, 120, '2014-02-15 00:01:45.000000', 'temperatura', 313.0000, 'ºC'),
	(198787, 120, '2014-02-15 00:01:46.000000', 'temperatura', 376.0000, 'ºC'),
	(198788, 120, '2014-02-15 00:01:47.000000', 'temperatura', 941.0000, 'ºC'),
	(198789, 120, '2014-02-15 00:01:48.000000', 'temperatura', 1177.0000, 'ºC'),
	(198790, 120, '2014-02-15 00:01:49.000000', 'temperatura', 664.0000, 'ºC'),
	(198791, 120, '2014-02-15 00:01:50.000000', 'temperatura', 990.0000, 'ºC'),
	(198792, 120, '2014-02-15 00:01:51.000000', 'temperatura', 557.0000, 'ºC'),
	(198793, 120, '2014-02-15 00:01:52.000000', 'temperatura', 1014.0000, 'ºC'),
	(198794, 120, '2014-02-15 00:01:53.000000', 'temperatura', 1002.0000, 'ºC'),
	(198795, 120, '2014-02-15 00:01:54.000000', 'temperatura', 769.0000, 'ºC'),
	(198796, 120, '2014-02-15 00:01:55.000000', 'temperatura', 840.0000, 'ºC'),
	(198797, 120, '2014-02-15 00:01:56.000000', 'temperatura', 692.0000, 'ºC'),
	(198798, 120, '2014-02-15 00:01:57.000000', 'temperatura', 940.0000, 'ºC'),
	(198799, 120, '2014-02-15 00:01:58.000000', 'temperatura', 223.0000, 'ºC'),
	(198800, 120, '2014-02-15 00:01:59.000000', 'temperatura', 697.0000, 'ºC'),
	(198801, 120, '2014-02-15 00:02:00.000000', 'temperatura', 417.0000, 'ºC'),
	(198802, 120, '2014-02-15 00:02:01.000000', 'temperatura', 1195.0000, 'ºC'),
	(198803, 120, '2014-02-15 00:02:02.000000', 'temperatura', 1122.0000, 'ºC'),
	(198804, 120, '2014-02-15 00:02:03.000000', 'temperatura', 827.0000, 'ºC'),
	(198805, 120, '2014-02-15 00:02:04.000000', 'temperatura', 768.0000, 'ºC'),
	(198806, 120, '2014-02-15 00:02:05.000000', 'temperatura', 160.0000, 'ºC'),
	(198807, 120, '2014-02-15 00:02:06.000000', 'temperatura', 897.0000, 'ºC'),
	(198808, 120, '2014-02-15 00:02:07.000000', 'temperatura', 404.0000, 'ºC'),
	(198809, 120, '2014-02-15 00:02:08.000000', 'temperatura', 529.0000, 'ºC'),
	(198810, 120, '2014-02-15 00:02:09.000000', 'temperatura', 233.0000, 'ºC'),
	(198811, 120, '2014-02-15 00:02:10.000000', 'temperatura', 780.0000, 'ºC'),
	(198812, 120, '2014-02-15 00:02:11.000000', 'temperatura', 799.0000, 'ºC'),
	(198813, 120, '2014-02-15 00:02:12.000000', 'temperatura', 458.0000, 'ºC'),
	(198814, 120, '2014-02-15 00:02:13.000000', 'temperatura', 1093.0000, 'ºC'),
	(198815, 120, '2014-02-15 00:02:14.000000', 'temperatura', 490.0000, 'ºC'),
	(198816, 120, '2014-02-15 00:02:15.000000', 'temperatura', 373.0000, 'ºC'),
	(198817, 120, '2014-02-15 00:02:16.000000', 'temperatura', 394.0000, 'ºC'),
	(198818, 120, '2014-02-15 00:02:17.000000', 'temperatura', 854.0000, 'ºC'),
	(198819, 120, '2014-02-15 00:02:18.000000', 'temperatura', 688.0000, 'ºC'),
	(198820, 120, '2014-02-15 00:02:19.000000', 'temperatura', 880.0000, 'ºC'),
	(198821, 120, '2014-02-15 00:02:20.000000', 'temperatura', 1133.0000, 'ºC'),
	(198822, 120, '2014-02-15 00:02:21.000000', 'temperatura', 628.0000, 'ºC'),
	(198823, 120, '2014-02-15 00:02:22.000000', 'temperatura', 939.0000, 'ºC'),
	(198824, 120, '2014-02-15 00:02:23.000000', 'temperatura', 414.0000, 'ºC'),
	(198825, 120, '2014-02-15 00:02:24.000000', 'temperatura', 452.0000, 'ºC'),
	(198826, 120, '2014-02-15 00:02:25.000000', 'temperatura', 1017.0000, 'ºC'),
	(198827, 120, '2014-02-15 00:02:26.000000', 'temperatura', 133.0000, 'ºC'),
	(198828, 120, '2014-02-15 00:02:27.000000', 'temperatura', 13.0000, 'ºC'),
	(198829, 120, '2014-02-15 00:02:28.000000', 'temperatura', 865.0000, 'ºC'),
	(198830, 120, '2014-02-15 00:02:29.000000', 'temperatura', 688.0000, 'ºC'),
	(198831, 120, '2014-02-15 00:02:30.000000', 'temperatura', 845.0000, 'ºC'),
	(198832, 120, '2014-02-15 00:02:31.000000', 'temperatura', 961.0000, 'ºC'),
	(198833, 120, '2014-02-15 00:02:32.000000', 'temperatura', 1073.0000, 'ºC'),
	(198834, 120, '2014-02-15 00:02:33.000000', 'temperatura', 80.0000, 'ºC'),
	(198835, 120, '2014-02-15 00:02:34.000000', 'temperatura', 781.0000, 'ºC'),
	(198836, 120, '2014-02-15 00:02:35.000000', 'temperatura', 66.0000, 'ºC'),
	(198837, 120, '2014-02-15 00:02:36.000000', 'temperatura', 386.0000, 'ºC'),
	(198838, 120, '2014-02-15 00:02:37.000000', 'temperatura', 536.0000, 'ºC'),
	(198839, 120, '2014-02-15 00:02:38.000000', 'temperatura', 319.0000, 'ºC'),
	(198840, 120, '2014-02-15 00:02:39.000000', 'temperatura', 1189.0000, 'ºC'),
	(198841, 120, '2014-02-15 00:02:40.000000', 'temperatura', 187.0000, 'ºC'),
	(198842, 120, '2014-02-15 00:02:41.000000', 'temperatura', 969.0000, 'ºC'),
	(198843, 120, '2014-02-15 00:02:42.000000', 'temperatura', 684.0000, 'ºC'),
	(198844, 120, '2014-02-15 00:02:43.000000', 'temperatura', 514.0000, 'ºC'),
	(198845, 120, '2014-02-15 00:02:44.000000', 'temperatura', 519.0000, 'ºC'),
	(198846, 120, '2014-02-15 00:02:45.000000', 'temperatura', 1052.0000, 'ºC'),
	(198847, 120, '2014-02-15 00:02:46.000000', 'temperatura', 106.0000, 'ºC'),
	(198848, 120, '2014-02-15 00:02:47.000000', 'temperatura', 974.0000, 'ºC'),
	(198849, 120, '2014-02-15 00:02:48.000000', 'temperatura', 952.0000, 'ºC'),
	(198850, 120, '2014-02-15 00:02:49.000000', 'temperatura', 637.0000, 'ºC'),
	(198851, 120, '2014-02-15 00:02:50.000000', 'temperatura', 331.0000, 'ºC'),
	(198852, 120, '2014-02-15 00:02:51.000000', 'temperatura', 943.0000, 'ºC'),
	(198853, 120, '2014-02-15 00:02:52.000000', 'temperatura', 123.0000, 'ºC'),
	(198854, 120, '2014-02-15 00:02:53.000000', 'temperatura', 188.0000, 'ºC'),
	(198855, 120, '2014-02-15 00:02:54.000000', 'temperatura', 570.0000, 'ºC'),
	(198856, 120, '2014-02-15 00:02:55.000000', 'temperatura', 1085.0000, 'ºC'),
	(198857, 120, '2014-02-15 00:02:56.000000', 'temperatura', 117.0000, 'ºC'),
	(198858, 120, '2014-02-15 00:02:57.000000', 'temperatura', 931.0000, 'ºC'),
	(198859, 120, '2014-02-15 00:02:58.000000', 'temperatura', 703.0000, 'ºC'),
	(198860, 120, '2014-02-15 00:02:59.000000', 'temperatura', 725.0000, 'ºC'),
	(198861, 120, '2014-02-15 00:03:00.000000', 'temperatura', 313.0000, 'ºC'),
	(198862, 120, '2014-02-15 00:03:01.000000', 'temperatura', 593.0000, 'ºC'),
	(198863, 120, '2014-02-15 00:03:02.000000', 'temperatura', 828.0000, 'ºC'),
	(198864, 120, '2014-02-15 00:03:03.000000', 'temperatura', 1160.0000, 'ºC'),
	(198865, 120, '2014-02-15 00:03:04.000000', 'temperatura', 915.0000, 'ºC'),
	(198866, 120, '2014-02-15 00:03:05.000000', 'temperatura', 1095.0000, 'ºC'),
	(198867, 120, '2014-02-15 00:03:06.000000', 'temperatura', 330.0000, 'ºC'),
	(198868, 120, '2014-02-15 00:03:07.000000', 'temperatura', 766.0000, 'ºC'),
	(198869, 120, '2014-02-15 00:03:08.000000', 'temperatura', 440.0000, 'ºC'),
	(198870, 120, '2014-02-15 00:03:09.000000', 'temperatura', 1105.0000, 'ºC'),
	(198871, 120, '2014-02-15 00:03:10.000000', 'temperatura', 605.0000, 'ºC'),
	(198872, 120, '2014-02-15 00:03:11.000000', 'temperatura', 910.0000, 'ºC'),
	(198873, 120, '2014-02-15 00:03:12.000000', 'temperatura', 335.0000, 'ºC'),
	(198874, 120, '2014-02-15 00:03:13.000000', 'temperatura', 146.0000, 'ºC'),
	(198875, 120, '2014-02-15 00:03:14.000000', 'temperatura', 926.0000, 'ºC'),
	(198876, 120, '2014-02-15 00:03:15.000000', 'temperatura', 591.0000, 'ºC'),
	(198877, 120, '2014-02-15 00:03:16.000000', 'temperatura', 178.0000, 'ºC'),
	(198878, 120, '2014-02-15 00:03:17.000000', 'temperatura', 317.0000, 'ºC'),
	(198879, 120, '2014-02-15 00:03:18.000000', 'temperatura', 1053.0000, 'ºC'),
	(198880, 120, '2014-02-15 00:03:19.000000', 'temperatura', 716.0000, 'ºC'),
	(198881, 120, '2014-02-15 00:03:20.000000', 'temperatura', 419.0000, 'ºC'),
	(198882, 120, '2014-02-15 00:03:21.000000', 'temperatura', 1147.0000, 'ºC'),
	(198883, 120, '2014-02-15 00:03:22.000000', 'temperatura', 878.0000, 'ºC'),
	(198884, 120, '2014-02-15 00:03:23.000000', 'temperatura', 951.0000, 'ºC'),
	(198885, 120, '2014-02-15 00:03:24.000000', 'temperatura', 921.0000, 'ºC'),
	(198886, 120, '2014-02-15 00:03:25.000000', 'temperatura', 555.0000, 'ºC'),
	(198887, 120, '2014-02-15 00:03:26.000000', 'temperatura', 9.0000, 'ºC'),
	(198888, 120, '2014-02-15 00:03:27.000000', 'temperatura', 781.0000, 'ºC'),
	(198889, 120, '2014-02-15 00:03:28.000000', 'temperatura', 278.0000, 'ºC'),
	(198890, 120, '2014-02-15 00:03:29.000000', 'temperatura', 247.0000, 'ºC'),
	(198891, 120, '2014-02-15 00:03:30.000000', 'temperatura', 401.0000, 'ºC'),
	(198892, 120, '2014-02-15 00:03:31.000000', 'temperatura', 65.0000, 'ºC'),
	(198893, 120, '2014-02-15 00:03:32.000000', 'temperatura', 324.0000, 'ºC'),
	(198894, 120, '2014-02-15 00:03:33.000000', 'temperatura', 225.0000, 'ºC'),
	(198895, 120, '2014-02-15 00:03:34.000000', 'temperatura', 152.0000, 'ºC'),
	(198896, 120, '2014-02-15 00:03:35.000000', 'temperatura', 88.0000, 'ºC'),
	(198897, 120, '2014-02-15 00:03:36.000000', 'temperatura', 1185.0000, 'ºC'),
	(198898, 120, '2014-02-15 00:03:37.000000', 'temperatura', 859.0000, 'ºC'),
	(198899, 120, '2014-02-15 00:03:38.000000', 'temperatura', 741.0000, 'ºC'),
	(198900, 120, '2014-02-15 00:03:39.000000', 'temperatura', 1129.0000, 'ºC'),
	(198901, 120, '2014-02-15 00:03:40.000000', 'temperatura', 1023.0000, 'ºC'),
	(198902, 120, '2014-02-15 00:03:41.000000', 'temperatura', 528.0000, 'ºC'),
	(198903, 120, '2014-02-15 00:03:42.000000', 'temperatura', 772.0000, 'ºC'),
	(198904, 120, '2014-02-15 00:03:43.000000', 'temperatura', 1077.0000, 'ºC'),
	(198905, 120, '2014-02-15 00:03:44.000000', 'temperatura', 667.0000, 'ºC'),
	(198906, 120, '2014-02-15 00:03:45.000000', 'temperatura', 107.0000, 'ºC'),
	(198907, 120, '2014-02-15 00:03:46.000000', 'temperatura', 932.0000, 'ºC'),
	(198908, 120, '2014-02-15 00:03:47.000000', 'temperatura', 739.0000, 'ºC'),
	(198909, 120, '2014-02-15 00:03:48.000000', 'temperatura', 902.0000, 'ºC'),
	(198910, 120, '2014-02-15 00:03:49.000000', 'temperatura', 1092.0000, 'ºC'),
	(198911, 120, '2014-02-15 00:03:50.000000', 'temperatura', 355.0000, 'ºC'),
	(198912, 120, '2014-02-15 00:03:51.000000', 'temperatura', 901.0000, 'ºC'),
	(198913, 120, '2014-02-15 00:03:52.000000', 'temperatura', 1038.0000, 'ºC'),
	(198914, 120, '2014-02-15 00:03:53.000000', 'temperatura', 87.0000, 'ºC'),
	(198915, 120, '2014-02-15 00:03:54.000000', 'temperatura', 922.0000, 'ºC'),
	(198916, 120, '2014-02-15 00:03:55.000000', 'temperatura', 750.0000, 'ºC'),
	(198917, 120, '2014-02-15 00:03:56.000000', 'temperatura', 985.0000, 'ºC'),
	(198918, 120, '2014-02-15 00:03:57.000000', 'temperatura', 277.0000, 'ºC'),
	(198919, 120, '2014-02-15 00:03:58.000000', 'temperatura', 828.0000, 'ºC'),
	(198920, 120, '2014-02-15 00:03:59.000000', 'temperatura', 912.0000, 'ºC'),
	(198921, 120, '2014-02-15 00:04:00.000000', 'temperatura', 877.0000, 'ºC'),
	(198922, 120, '2014-02-15 00:04:01.000000', 'temperatura', 446.0000, 'ºC'),
	(198923, 120, '2014-02-15 00:04:02.000000', 'temperatura', 802.0000, 'ºC'),
	(198924, 120, '2014-02-15 00:04:03.000000', 'temperatura', 273.0000, 'ºC'),
	(198925, 120, '2014-02-15 00:04:04.000000', 'temperatura', 157.0000, 'ºC'),
	(198926, 120, '2014-02-15 00:04:05.000000', 'temperatura', 1169.0000, 'ºC'),
	(198927, 120, '2014-02-15 00:04:06.000000', 'temperatura', 572.0000, 'ºC'),
	(198928, 120, '2014-02-15 00:04:07.000000', 'temperatura', 554.0000, 'ºC'),
	(198929, 120, '2014-02-15 00:04:08.000000', 'temperatura', 1057.0000, 'ºC'),
	(198930, 120, '2014-02-15 00:04:09.000000', 'temperatura', 22.0000, 'ºC'),
	(198931, 120, '2014-02-15 00:04:10.000000', 'temperatura', 541.0000, 'ºC'),
	(198932, 120, '2014-02-15 00:04:11.000000', 'temperatura', 238.0000, 'ºC'),
	(198933, 120, '2014-02-15 00:04:12.000000', 'temperatura', 769.0000, 'ºC'),
	(198934, 120, '2014-02-15 00:04:13.000000', 'temperatura', 733.0000, 'ºC'),
	(198935, 120, '2014-02-15 00:04:14.000000', 'temperatura', 156.0000, 'ºC'),
	(198936, 120, '2014-02-15 00:04:15.000000', 'temperatura', 982.0000, 'ºC'),
	(198937, 120, '2014-02-15 00:04:16.000000', 'temperatura', 841.0000, 'ºC'),
	(198938, 120, '2014-02-15 00:04:17.000000', 'temperatura', 59.0000, 'ºC'),
	(198939, 120, '2014-02-15 00:04:18.000000', 'temperatura', 174.0000, 'ºC'),
	(198940, 120, '2014-02-15 00:04:19.000000', 'temperatura', 695.0000, 'ºC'),
	(198941, 120, '2014-02-15 00:04:20.000000', 'temperatura', 552.0000, 'ºC'),
	(198942, 120, '2014-02-15 00:04:21.000000', 'temperatura', 676.0000, 'ºC'),
	(198943, 120, '2014-02-15 00:04:22.000000', 'temperatura', 525.0000, 'ºC'),
	(198944, 120, '2014-02-15 00:04:23.000000', 'temperatura', 598.0000, 'ºC'),
	(198945, 120, '2014-02-15 00:04:24.000000', 'temperatura', 215.0000, 'ºC'),
	(198946, 120, '2014-02-15 00:04:25.000000', 'temperatura', 480.0000, 'ºC'),
	(198947, 120, '2014-02-15 00:04:26.000000', 'temperatura', 556.0000, 'ºC'),
	(198948, 120, '2014-02-15 00:04:27.000000', 'temperatura', 140.0000, 'ºC'),
	(198949, 120, '2014-02-15 00:04:28.000000', 'temperatura', 233.0000, 'ºC'),
	(198950, 120, '2014-02-15 00:04:29.000000', 'temperatura', 747.0000, 'ºC'),
	(198951, 120, '2014-02-15 00:04:30.000000', 'temperatura', 636.0000, 'ºC'),
	(198952, 120, '2014-02-15 00:04:31.000000', 'temperatura', 939.0000, 'ºC'),
	(198953, 120, '2014-02-15 00:04:32.000000', 'temperatura', 385.0000, 'ºC'),
	(198954, 120, '2014-02-15 00:04:33.000000', 'temperatura', 312.0000, 'ºC'),
	(198955, 120, '2014-02-15 00:04:34.000000', 'temperatura', 406.0000, 'ºC'),
	(198956, 120, '2014-02-15 00:04:35.000000', 'temperatura', 1094.0000, 'ºC'),
	(198957, 120, '2014-02-15 00:04:36.000000', 'temperatura', 653.0000, 'ºC'),
	(198958, 120, '2014-02-15 00:04:37.000000', 'temperatura', 1183.0000, 'ºC'),
	(198959, 120, '2014-02-15 00:04:38.000000', 'temperatura', 354.0000, 'ºC'),
	(198960, 120, '2014-02-15 00:04:39.000000', 'temperatura', 624.0000, 'ºC'),
	(198961, 120, '2014-02-15 00:04:40.000000', 'temperatura', 860.0000, 'ºC'),
	(198962, 120, '2014-02-15 00:04:41.000000', 'temperatura', 26.0000, 'ºC'),
	(198963, 120, '2014-02-15 00:04:42.000000', 'temperatura', 1152.0000, 'ºC'),
	(198964, 120, '2014-02-15 00:04:43.000000', 'temperatura', 880.0000, 'ºC'),
	(198965, 120, '2014-02-15 00:04:44.000000', 'temperatura', 946.0000, 'ºC'),
	(198966, 120, '2014-02-15 00:04:45.000000', 'temperatura', 888.0000, 'ºC'),
	(198967, 120, '2014-02-15 00:04:46.000000', 'temperatura', 406.0000, 'ºC'),
	(198968, 120, '2014-02-15 00:04:47.000000', 'temperatura', 564.0000, 'ºC'),
	(198969, 120, '2014-02-15 00:04:48.000000', 'temperatura', 402.0000, 'ºC'),
	(198970, 120, '2014-02-15 00:04:49.000000', 'temperatura', 319.0000, 'ºC'),
	(198971, 120, '2014-02-15 00:04:50.000000', 'temperatura', 390.0000, 'ºC'),
	(198972, 120, '2014-02-15 00:04:51.000000', 'temperatura', 992.0000, 'ºC'),
	(198973, 120, '2014-02-15 00:04:52.000000', 'temperatura', 190.0000, 'ºC'),
	(198974, 120, '2014-02-15 00:04:53.000000', 'temperatura', 376.0000, 'ºC'),
	(198975, 120, '2014-02-15 00:04:54.000000', 'temperatura', 108.0000, 'ºC'),
	(198976, 120, '2014-02-15 00:04:55.000000', 'temperatura', 616.0000, 'ºC'),
	(198977, 120, '2014-02-15 00:04:56.000000', 'temperatura', 355.0000, 'ºC'),
	(198978, 120, '2014-02-15 00:04:57.000000', 'temperatura', 1127.0000, 'ºC'),
	(198979, 120, '2014-02-15 00:04:58.000000', 'temperatura', 971.0000, 'ºC'),
	(198980, 120, '2014-02-15 00:04:59.000000', 'temperatura', 274.0000, 'ºC'),
	(198981, 120, '2014-02-15 00:05:00.000000', 'temperatura', 858.0000, 'ºC'),
	(198982, 120, '2014-02-15 00:05:01.000000', 'temperatura', 1066.0000, 'ºC'),
	(198983, 120, '2014-02-15 00:05:02.000000', 'temperatura', 359.0000, 'ºC'),
	(198984, 120, '2014-02-15 00:05:03.000000', 'temperatura', 997.0000, 'ºC'),
	(198985, 120, '2014-02-15 00:05:04.000000', 'temperatura', 310.0000, 'ºC'),
	(198986, 120, '2014-02-15 00:05:05.000000', 'temperatura', 960.0000, 'ºC'),
	(198987, 120, '2014-02-15 00:05:06.000000', 'temperatura', 268.0000, 'ºC'),
	(198988, 120, '2014-02-15 00:05:07.000000', 'temperatura', 860.0000, 'ºC'),
	(198989, 120, '2014-02-15 00:05:08.000000', 'temperatura', 1100.0000, 'ºC'),
	(198990, 120, '2014-02-15 00:05:09.000000', 'temperatura', 517.0000, 'ºC'),
	(198991, 120, '2014-02-15 00:05:10.000000', 'temperatura', 485.0000, 'ºC'),
	(198992, 120, '2014-02-15 00:05:11.000000', 'temperatura', 876.0000, 'ºC'),
	(198993, 120, '2014-02-15 00:05:12.000000', 'temperatura', 527.0000, 'ºC'),
	(198994, 120, '2014-02-15 00:05:13.000000', 'temperatura', 8.0000, 'ºC'),
	(198995, 120, '2014-02-15 00:05:14.000000', 'temperatura', 858.0000, 'ºC'),
	(198996, 120, '2014-02-15 00:05:15.000000', 'temperatura', 666.0000, 'ºC'),
	(198997, 120, '2014-02-15 00:05:16.000000', 'temperatura', 757.0000, 'ºC'),
	(198998, 120, '2014-02-15 00:05:17.000000', 'temperatura', 587.0000, 'ºC'),
	(198999, 120, '2014-02-15 00:05:18.000000', 'temperatura', 664.0000, 'ºC'),
	(199000, 120, '2014-02-15 00:05:19.000000', 'temperatura', 360.0000, 'ºC'),
	(199001, 120, '2014-02-15 00:05:20.000000', 'temperatura', 1008.0000, 'ºC'),
	(199002, 120, '2014-02-15 00:05:21.000000', 'temperatura', 361.0000, 'ºC'),
	(199003, 120, '2014-02-15 00:05:22.000000', 'temperatura', 1180.0000, 'ºC'),
	(199004, 120, '2014-02-15 00:05:23.000000', 'temperatura', 18.0000, 'ºC'),
	(199005, 120, '2014-02-15 00:05:24.000000', 'temperatura', 149.0000, 'ºC'),
	(199006, 120, '2014-02-15 00:05:25.000000', 'temperatura', 694.0000, 'ºC'),
	(199007, 120, '2014-02-15 00:05:26.000000', 'temperatura', 623.0000, 'ºC'),
	(199008, 120, '2014-02-15 00:05:27.000000', 'temperatura', 1035.0000, 'ºC'),
	(199009, 120, '2014-02-15 00:05:28.000000', 'temperatura', 906.0000, 'ºC'),
	(199010, 120, '2014-02-15 00:05:29.000000', 'temperatura', 224.0000, 'ºC'),
	(199011, 120, '2014-02-15 00:05:30.000000', 'temperatura', 805.0000, 'ºC'),
	(199012, 120, '2014-02-15 00:05:31.000000', 'temperatura', 953.0000, 'ºC'),
	(199013, 120, '2014-02-15 00:05:32.000000', 'temperatura', 1148.0000, 'ºC'),
	(199014, 120, '2014-02-15 00:05:33.000000', 'temperatura', 483.0000, 'ºC'),
	(199015, 120, '2014-02-15 00:05:34.000000', 'temperatura', 171.0000, 'ºC'),
	(199016, 120, '2014-02-15 00:05:35.000000', 'temperatura', 605.0000, 'ºC'),
	(199017, 120, '2014-02-15 00:05:36.000000', 'temperatura', 114.0000, 'ºC'),
	(199018, 120, '2014-02-15 00:05:37.000000', 'temperatura', 1156.0000, 'ºC'),
	(199019, 120, '2014-02-15 00:05:38.000000', 'temperatura', 636.0000, 'ºC'),
	(199020, 120, '2014-02-15 00:05:39.000000', 'temperatura', 916.0000, 'ºC'),
	(199021, 120, '2014-02-15 00:05:40.000000', 'temperatura', 270.0000, 'ºC'),
	(199022, 120, '2014-02-15 00:05:41.000000', 'temperatura', 1004.0000, 'ºC'),
	(199023, 120, '2014-02-15 00:05:42.000000', 'temperatura', 609.0000, 'ºC'),
	(199024, 120, '2014-02-15 00:05:43.000000', 'temperatura', 35.0000, 'ºC'),
	(199025, 120, '2014-02-15 00:05:44.000000', 'temperatura', 750.0000, 'ºC'),
	(199026, 120, '2014-02-15 00:05:45.000000', 'temperatura', 42.0000, 'ºC'),
	(199027, 120, '2014-02-15 00:05:46.000000', 'temperatura', 362.0000, 'ºC'),
	(199028, 120, '2014-02-15 00:05:47.000000', 'temperatura', 484.0000, 'ºC'),
	(199029, 120, '2014-02-15 00:05:48.000000', 'temperatura', 134.0000, 'ºC'),
	(199030, 120, '2014-02-15 00:05:49.000000', 'temperatura', 417.0000, 'ºC'),
	(199031, 120, '2014-02-15 00:05:50.000000', 'temperatura', 485.0000, 'ºC'),
	(199032, 120, '2014-02-15 00:05:51.000000', 'temperatura', 1176.0000, 'ºC'),
	(199033, 120, '2014-02-15 00:05:52.000000', 'temperatura', 824.0000, 'ºC'),
	(199034, 120, '2014-02-15 00:05:53.000000', 'temperatura', 592.0000, 'ºC'),
	(199035, 120, '2014-02-15 00:05:54.000000', 'temperatura', 489.0000, 'ºC'),
	(199036, 120, '2014-02-15 00:05:55.000000', 'temperatura', 671.0000, 'ºC'),
	(199037, 120, '2014-02-15 00:05:56.000000', 'temperatura', 688.0000, 'ºC'),
	(199038, 120, '2014-02-15 00:05:57.000000', 'temperatura', 226.0000, 'ºC'),
	(199039, 120, '2014-02-15 00:05:58.000000', 'temperatura', 267.0000, 'ºC'),
	(199040, 120, '2014-02-15 00:05:59.000000', 'temperatura', 659.0000, 'ºC'),
	(199041, 120, '2014-02-15 00:06:00.000000', 'temperatura', 95.0000, 'ºC'),
	(199042, 120, '2014-02-15 00:06:01.000000', 'temperatura', 899.0000, 'ºC'),
	(199043, 120, '2014-02-15 00:06:02.000000', 'temperatura', 611.0000, 'ºC'),
	(199044, 120, '2014-02-15 00:06:03.000000', 'temperatura', 356.0000, 'ºC'),
	(199045, 120, '2014-02-15 00:06:04.000000', 'temperatura', 1148.0000, 'ºC'),
	(199046, 120, '2014-02-15 00:06:05.000000', 'temperatura', 1073.0000, 'ºC'),
	(199047, 120, '2014-02-15 00:06:06.000000', 'temperatura', 721.0000, 'ºC'),
	(199048, 120, '2014-02-15 00:06:07.000000', 'temperatura', 388.0000, 'ºC'),
	(199049, 120, '2014-02-15 00:06:08.000000', 'temperatura', 975.0000, 'ºC'),
	(199050, 120, '2014-02-15 00:06:09.000000', 'temperatura', 111.0000, 'ºC'),
	(199051, 120, '2014-02-15 00:06:10.000000', 'temperatura', 31.0000, 'ºC'),
	(199052, 120, '2014-02-15 00:06:11.000000', 'temperatura', 1023.0000, 'ºC'),
	(199053, 120, '2014-02-15 00:06:12.000000', 'temperatura', 222.0000, 'ºC'),
	(199054, 120, '2014-02-15 00:06:13.000000', 'temperatura', 444.0000, 'ºC'),
	(199055, 120, '2014-02-15 00:06:14.000000', 'temperatura', 352.0000, 'ºC'),
	(199056, 120, '2014-02-15 00:06:15.000000', 'temperatura', 430.0000, 'ºC'),
	(199057, 120, '2014-02-15 00:06:16.000000', 'temperatura', 1093.0000, 'ºC'),
	(199058, 120, '2014-02-15 00:06:17.000000', 'temperatura', 576.0000, 'ºC'),
	(199059, 120, '2014-02-15 00:06:18.000000', 'temperatura', 800.0000, 'ºC'),
	(199060, 120, '2014-02-15 00:06:19.000000', 'temperatura', 1072.0000, 'ºC'),
	(199061, 120, '2014-02-15 00:06:20.000000', 'temperatura', 559.0000, 'ºC'),
	(199062, 120, '2014-02-15 00:06:21.000000', 'temperatura', 783.0000, 'ºC'),
	(199063, 120, '2014-02-15 00:06:22.000000', 'temperatura', 1039.0000, 'ºC'),
	(199064, 120, '2014-02-15 00:06:23.000000', 'temperatura', 446.0000, 'ºC'),
	(199065, 120, '2014-02-15 00:06:24.000000', 'temperatura', 312.0000, 'ºC'),
	(199066, 120, '2014-02-15 00:06:25.000000', 'temperatura', 223.0000, 'ºC'),
	(199067, 120, '2014-02-15 00:06:26.000000', 'temperatura', 180.0000, 'ºC'),
	(199068, 120, '2014-02-15 00:06:27.000000', 'temperatura', 229.0000, 'ºC'),
	(199069, 120, '2014-02-15 00:06:28.000000', 'temperatura', 608.0000, 'ºC'),
	(199070, 120, '2014-02-15 00:06:29.000000', 'temperatura', 1151.0000, 'ºC'),
	(199071, 120, '2014-02-15 00:06:30.000000', 'temperatura', 333.0000, 'ºC'),
	(199072, 120, '2014-02-15 00:06:31.000000', 'temperatura', 611.0000, 'ºC'),
	(199073, 120, '2014-02-15 00:06:32.000000', 'temperatura', 857.0000, 'ºC'),
	(199074, 120, '2014-02-15 00:06:33.000000', 'temperatura', 53.0000, 'ºC'),
	(199075, 120, '2014-02-15 00:06:34.000000', 'temperatura', 95.0000, 'ºC'),
	(199076, 120, '2014-02-15 00:06:35.000000', 'temperatura', 314.0000, 'ºC'),
	(199077, 120, '2014-02-15 00:06:36.000000', 'temperatura', 89.0000, 'ºC'),
	(199078, 120, '2014-02-15 00:06:37.000000', 'temperatura', 702.0000, 'ºC'),
	(199079, 120, '2014-02-15 00:06:38.000000', 'temperatura', 841.0000, 'ºC'),
	(199080, 120, '2014-02-15 00:06:39.000000', 'temperatura', 903.0000, 'ºC'),
	(199081, 120, '2014-02-15 00:06:40.000000', 'temperatura', 793.0000, 'ºC'),
	(199082, 120, '2014-02-15 00:06:41.000000', 'temperatura', 55.0000, 'ºC'),
	(199083, 120, '2014-02-15 00:06:42.000000', 'temperatura', 299.0000, 'ºC'),
	(199084, 120, '2014-02-15 00:06:43.000000', 'temperatura', 127.0000, 'ºC'),
	(199085, 120, '2014-02-15 00:06:44.000000', 'temperatura', 939.0000, 'ºC'),
	(199086, 120, '2014-02-15 00:06:45.000000', 'temperatura', 717.0000, 'ºC'),
	(199087, 120, '2014-02-15 00:06:46.000000', 'temperatura', 767.0000, 'ºC'),
	(199088, 120, '2014-02-15 00:06:47.000000', 'temperatura', 485.0000, 'ºC'),
	(199089, 120, '2014-02-15 00:06:48.000000', 'temperatura', 123.0000, 'ºC'),
	(199090, 120, '2014-02-15 00:06:49.000000', 'temperatura', 363.0000, 'ºC'),
	(199091, 120, '2014-02-15 00:06:50.000000', 'temperatura', 247.0000, 'ºC'),
	(199092, 120, '2014-02-15 00:06:51.000000', 'temperatura', 147.0000, 'ºC'),
	(199093, 120, '2014-02-15 00:06:52.000000', 'temperatura', 1193.0000, 'ºC'),
	(199094, 120, '2014-02-15 00:06:53.000000', 'temperatura', 726.0000, 'ºC'),
	(199095, 120, '2014-02-15 00:06:54.000000', 'temperatura', 49.0000, 'ºC'),
	(199096, 120, '2014-02-15 00:06:55.000000', 'temperatura', 469.0000, 'ºC'),
	(199097, 120, '2014-02-15 00:06:56.000000', 'temperatura', 998.0000, 'ºC'),
	(199098, 120, '2014-02-15 00:06:57.000000', 'temperatura', 1186.0000, 'ºC'),
	(199099, 120, '2014-02-15 00:06:58.000000', 'temperatura', 533.0000, 'ºC'),
	(199100, 120, '2014-02-15 00:06:59.000000', 'temperatura', 308.0000, 'ºC'),
	(199101, 120, '2014-02-15 00:07:00.000000', 'temperatura', 1143.0000, 'ºC'),
	(199102, 120, '2014-02-15 00:07:01.000000', 'temperatura', 1190.0000, 'ºC'),
	(199103, 120, '2014-02-15 00:07:02.000000', 'temperatura', 124.0000, 'ºC'),
	(199104, 120, '2014-02-15 00:07:03.000000', 'temperatura', 649.0000, 'ºC'),
	(199105, 120, '2014-02-15 00:07:04.000000', 'temperatura', 474.0000, 'ºC'),
	(199106, 120, '2014-02-15 00:07:05.000000', 'temperatura', 422.0000, 'ºC'),
	(199107, 120, '2014-02-15 00:07:06.000000', 'temperatura', 688.0000, 'ºC'),
	(199108, 120, '2014-02-15 00:07:07.000000', 'temperatura', 977.0000, 'ºC'),
	(199109, 120, '2014-02-15 00:07:08.000000', 'temperatura', 421.0000, 'ºC'),
	(199110, 120, '2014-02-15 00:07:09.000000', 'temperatura', 373.0000, 'ºC'),
	(199111, 120, '2014-02-15 00:07:10.000000', 'temperatura', 602.0000, 'ºC'),
	(199112, 120, '2014-02-15 00:07:11.000000', 'temperatura', 693.0000, 'ºC'),
	(199113, 120, '2014-02-15 00:07:12.000000', 'temperatura', 458.0000, 'ºC'),
	(199114, 120, '2014-02-15 00:07:13.000000', 'temperatura', 211.0000, 'ºC'),
	(199115, 120, '2014-02-15 00:07:14.000000', 'temperatura', 884.0000, 'ºC'),
	(199116, 120, '2014-02-15 00:07:15.000000', 'temperatura', 187.0000, 'ºC'),
	(199117, 120, '2014-02-15 00:07:16.000000', 'temperatura', 683.0000, 'ºC'),
	(199118, 120, '2014-02-15 00:07:17.000000', 'temperatura', 456.0000, 'ºC'),
	(199119, 120, '2014-02-15 00:07:18.000000', 'temperatura', 231.0000, 'ºC'),
	(199120, 120, '2014-02-15 00:07:19.000000', 'temperatura', 988.0000, 'ºC'),
	(199121, 120, '2014-02-15 00:07:20.000000', 'temperatura', 645.0000, 'ºC'),
	(199122, 120, '2014-02-15 00:07:21.000000', 'temperatura', 264.0000, 'ºC'),
	(199123, 120, '2014-02-15 00:07:22.000000', 'temperatura', 585.0000, 'ºC'),
	(199124, 120, '2014-02-15 00:07:23.000000', 'temperatura', 933.0000, 'ºC'),
	(199125, 120, '2014-02-15 00:07:24.000000', 'temperatura', 511.0000, 'ºC'),
	(199126, 120, '2014-02-15 00:07:25.000000', 'temperatura', 957.0000, 'ºC'),
	(199127, 120, '2014-02-15 00:07:26.000000', 'temperatura', 852.0000, 'ºC'),
	(199128, 120, '2014-02-15 00:07:27.000000', 'temperatura', 190.0000, 'ºC'),
	(199129, 120, '2014-02-15 00:07:28.000000', 'temperatura', 796.0000, 'ºC'),
	(199130, 120, '2014-02-15 00:07:29.000000', 'temperatura', 1009.0000, 'ºC'),
	(199131, 120, '2014-02-15 00:07:30.000000', 'temperatura', 258.0000, 'ºC'),
	(199132, 120, '2014-02-15 00:07:31.000000', 'temperatura', 663.0000, 'ºC'),
	(199133, 120, '2014-02-15 00:07:32.000000', 'temperatura', 143.0000, 'ºC'),
	(199134, 120, '2014-02-15 00:07:33.000000', 'temperatura', 1125.0000, 'ºC'),
	(199135, 120, '2014-02-15 00:07:34.000000', 'temperatura', 397.0000, 'ºC'),
	(199136, 120, '2014-02-15 00:07:35.000000', 'temperatura', 1012.0000, 'ºC'),
	(199137, 120, '2014-02-15 00:07:36.000000', 'temperatura', 270.0000, 'ºC'),
	(199138, 120, '2014-02-15 00:07:37.000000', 'temperatura', 715.0000, 'ºC'),
	(199139, 120, '2014-02-15 00:07:38.000000', 'temperatura', 364.0000, 'ºC'),
	(199140, 120, '2014-02-15 00:07:39.000000', 'temperatura', 874.0000, 'ºC'),
	(199141, 120, '2014-02-15 00:07:40.000000', 'temperatura', 879.0000, 'ºC'),
	(199142, 120, '2014-02-15 00:07:41.000000', 'temperatura', 575.0000, 'ºC'),
	(199143, 120, '2014-02-15 00:07:42.000000', 'temperatura', 239.0000, 'ºC'),
	(199144, 120, '2014-02-15 00:07:43.000000', 'temperatura', 670.0000, 'ºC'),
	(199145, 120, '2014-02-15 00:07:44.000000', 'temperatura', 231.0000, 'ºC'),
	(199146, 120, '2014-02-15 00:07:45.000000', 'temperatura', 348.0000, 'ºC'),
	(199147, 120, '2014-02-15 00:07:46.000000', 'temperatura', 1047.0000, 'ºC'),
	(199148, 120, '2014-02-15 00:07:47.000000', 'temperatura', 591.0000, 'ºC'),
	(199149, 120, '2014-02-15 00:07:48.000000', 'temperatura', 1014.0000, 'ºC'),
	(199150, 120, '2014-02-15 00:07:49.000000', 'temperatura', 900.0000, 'ºC'),
	(199151, 120, '2014-02-15 00:07:50.000000', 'temperatura', 257.0000, 'ºC'),
	(199152, 120, '2014-02-15 00:07:51.000000', 'temperatura', 985.0000, 'ºC'),
	(199153, 120, '2014-02-15 00:07:52.000000', 'temperatura', 557.0000, 'ºC'),
	(199154, 120, '2014-02-15 00:07:53.000000', 'temperatura', 1028.0000, 'ºC'),
	(199155, 120, '2014-02-15 00:07:54.000000', 'temperatura', 1070.0000, 'ºC'),
	(199156, 120, '2014-02-15 00:07:55.000000', 'temperatura', 1067.0000, 'ºC'),
	(199157, 120, '2014-02-15 00:07:56.000000', 'temperatura', 926.0000, 'ºC'),
	(199158, 120, '2014-02-15 00:07:57.000000', 'temperatura', 229.0000, 'ºC'),
	(199159, 120, '2014-02-15 00:07:58.000000', 'temperatura', 767.0000, 'ºC'),
	(199160, 120, '2014-02-15 00:07:59.000000', 'temperatura', 747.0000, 'ºC'),
	(199161, 120, '2014-02-15 00:08:00.000000', 'temperatura', 236.0000, 'ºC'),
	(199162, 120, '2014-02-15 00:08:01.000000', 'temperatura', 138.0000, 'ºC'),
	(199163, 120, '2014-02-15 00:08:02.000000', 'temperatura', 1181.0000, 'ºC'),
	(199164, 120, '2014-02-15 00:08:03.000000', 'temperatura', 695.0000, 'ºC'),
	(199165, 120, '2014-02-15 00:08:04.000000', 'temperatura', 1131.0000, 'ºC'),
	(199166, 120, '2014-02-15 00:08:05.000000', 'temperatura', 1169.0000, 'ºC'),
	(199167, 120, '2014-02-15 00:08:06.000000', 'temperatura', 52.0000, 'ºC'),
	(199168, 120, '2014-02-15 00:08:07.000000', 'temperatura', 356.0000, 'ºC'),
	(199169, 120, '2014-02-15 00:08:08.000000', 'temperatura', 422.0000, 'ºC'),
	(199170, 120, '2014-02-15 00:08:09.000000', 'temperatura', 1042.0000, 'ºC'),
	(199171, 120, '2014-02-15 00:08:10.000000', 'temperatura', 345.0000, 'ºC'),
	(199172, 120, '2014-02-15 00:08:11.000000', 'temperatura', 1001.0000, 'ºC'),
	(199173, 120, '2014-02-15 00:08:12.000000', 'temperatura', 371.0000, 'ºC'),
	(199174, 120, '2014-02-15 00:08:13.000000', 'temperatura', 53.0000, 'ºC'),
	(199175, 120, '2014-02-15 00:08:14.000000', 'temperatura', 349.0000, 'ºC'),
	(199176, 120, '2014-02-15 00:08:15.000000', 'temperatura', 390.0000, 'ºC'),
	(199177, 120, '2014-02-15 00:08:16.000000', 'temperatura', 904.0000, 'ºC'),
	(199178, 120, '2014-02-15 00:08:17.000000', 'temperatura', 949.0000, 'ºC'),
	(199179, 120, '2014-02-15 00:08:18.000000', 'temperatura', 832.0000, 'ºC'),
	(199180, 120, '2014-02-15 00:08:19.000000', 'temperatura', 114.0000, 'ºC'),
	(199181, 120, '2014-02-15 00:08:20.000000', 'temperatura', 476.0000, 'ºC'),
	(199182, 120, '2014-02-15 00:08:21.000000', 'temperatura', 838.0000, 'ºC'),
	(199183, 120, '2014-02-15 00:08:22.000000', 'temperatura', 363.0000, 'ºC'),
	(199184, 120, '2014-02-15 00:08:23.000000', 'temperatura', 502.0000, 'ºC'),
	(199185, 120, '2014-02-15 00:08:24.000000', 'temperatura', 222.0000, 'ºC'),
	(199186, 120, '2014-02-15 00:08:25.000000', 'temperatura', 804.0000, 'ºC'),
	(199187, 120, '2014-02-15 00:08:26.000000', 'temperatura', 954.0000, 'ºC'),
	(199188, 120, '2014-02-15 00:08:27.000000', 'temperatura', 1159.0000, 'ºC'),
	(199189, 120, '2014-02-15 00:08:28.000000', 'temperatura', 534.0000, 'ºC'),
	(199190, 120, '2014-02-15 00:08:29.000000', 'temperatura', 392.0000, 'ºC'),
	(199191, 120, '2014-02-15 00:08:30.000000', 'temperatura', 357.0000, 'ºC'),
	(199192, 120, '2014-02-15 00:08:31.000000', 'temperatura', 613.0000, 'ºC'),
	(199193, 120, '2014-02-15 00:08:32.000000', 'temperatura', 792.0000, 'ºC'),
	(199194, 120, '2014-02-15 00:08:33.000000', 'temperatura', 922.0000, 'ºC'),
	(199195, 120, '2014-02-15 00:08:34.000000', 'temperatura', 1036.0000, 'ºC'),
	(199196, 120, '2014-02-15 00:08:35.000000', 'temperatura', 13.0000, 'ºC'),
	(199197, 120, '2014-02-15 00:08:36.000000', 'temperatura', 556.0000, 'ºC'),
	(199198, 120, '2014-02-15 00:08:37.000000', 'temperatura', 345.0000, 'ºC'),
	(199199, 120, '2014-02-15 00:08:38.000000', 'temperatura', 54.0000, 'ºC'),
	(199200, 120, '2014-02-15 00:08:39.000000', 'temperatura', 437.0000, 'ºC'),
	(199201, 120, '2014-02-15 00:08:40.000000', 'temperatura', 825.0000, 'ºC'),
	(199202, 120, '2014-02-15 00:08:41.000000', 'temperatura', 415.0000, 'ºC'),
	(199203, 120, '2014-02-15 00:08:42.000000', 'temperatura', 798.0000, 'ºC'),
	(199204, 120, '2014-02-15 00:08:43.000000', 'temperatura', 348.0000, 'ºC'),
	(199205, 120, '2014-02-15 00:08:44.000000', 'temperatura', 546.0000, 'ºC'),
	(199206, 120, '2014-02-15 00:08:45.000000', 'temperatura', 485.0000, 'ºC'),
	(199207, 120, '2014-02-15 00:08:46.000000', 'temperatura', 790.0000, 'ºC'),
	(199208, 120, '2014-02-15 00:08:47.000000', 'temperatura', 95.0000, 'ºC'),
	(199209, 120, '2014-02-15 00:08:48.000000', 'temperatura', 507.0000, 'ºC'),
	(199210, 120, '2014-02-15 00:08:49.000000', 'temperatura', 1050.0000, 'ºC'),
	(199211, 120, '2014-02-15 00:08:50.000000', 'temperatura', 127.0000, 'ºC'),
	(199212, 120, '2014-02-15 00:08:51.000000', 'temperatura', 1086.0000, 'ºC'),
	(199213, 120, '2014-02-15 00:08:52.000000', 'temperatura', 249.0000, 'ºC'),
	(199214, 120, '2014-02-15 00:08:53.000000', 'temperatura', 388.0000, 'ºC'),
	(199215, 120, '2014-02-15 00:08:54.000000', 'temperatura', 1192.0000, 'ºC'),
	(199216, 120, '2014-02-15 00:08:55.000000', 'temperatura', 1196.0000, 'ºC'),
	(199217, 120, '2014-02-15 00:08:56.000000', 'temperatura', 5.0000, 'ºC'),
	(199218, 120, '2014-02-15 00:08:57.000000', 'temperatura', 37.0000, 'ºC'),
	(199219, 120, '2014-02-15 00:08:58.000000', 'temperatura', 170.0000, 'ºC'),
	(199220, 120, '2014-02-15 00:08:59.000000', 'temperatura', 739.0000, 'ºC'),
	(199221, 120, '2014-02-15 00:09:00.000000', 'temperatura', 786.0000, 'ºC'),
	(199222, 120, '2014-02-15 00:09:01.000000', 'temperatura', 512.0000, 'ºC'),
	(199223, 120, '2014-02-15 00:09:02.000000', 'temperatura', 205.0000, 'ºC'),
	(199224, 120, '2014-02-15 00:09:03.000000', 'temperatura', 689.0000, 'ºC'),
	(199225, 120, '2014-02-15 00:09:04.000000', 'temperatura', 432.0000, 'ºC'),
	(199226, 120, '2014-02-15 00:09:05.000000', 'temperatura', 92.0000, 'ºC'),
	(199227, 120, '2014-02-15 00:09:06.000000', 'temperatura', 364.0000, 'ºC'),
	(199228, 120, '2014-02-15 00:09:07.000000', 'temperatura', 344.0000, 'ºC'),
	(199229, 120, '2014-02-15 00:09:08.000000', 'temperatura', 629.0000, 'ºC'),
	(199230, 120, '2014-02-15 00:09:09.000000', 'temperatura', 913.0000, 'ºC'),
	(199231, 120, '2014-02-15 00:09:10.000000', 'temperatura', 280.0000, 'ºC'),
	(199232, 120, '2014-02-15 00:09:11.000000', 'temperatura', 1062.0000, 'ºC'),
	(199233, 120, '2014-02-15 00:09:12.000000', 'temperatura', 868.0000, 'ºC'),
	(199234, 120, '2014-02-15 00:09:13.000000', 'temperatura', 1157.0000, 'ºC'),
	(199235, 120, '2014-02-15 00:09:14.000000', 'temperatura', 782.0000, 'ºC'),
	(199236, 120, '2014-02-15 00:09:15.000000', 'temperatura', 438.0000, 'ºC'),
	(199237, 120, '2014-02-15 00:09:16.000000', 'temperatura', 1043.0000, 'ºC'),
	(199238, 120, '2014-02-15 00:09:17.000000', 'temperatura', 304.0000, 'ºC'),
	(199239, 120, '2014-02-15 00:09:18.000000', 'temperatura', 790.0000, 'ºC'),
	(199240, 120, '2014-02-15 00:09:19.000000', 'temperatura', 638.0000, 'ºC'),
	(199241, 120, '2014-02-15 00:09:20.000000', 'temperatura', 819.0000, 'ºC'),
	(199242, 120, '2014-02-15 00:09:21.000000', 'temperatura', 985.0000, 'ºC'),
	(199243, 120, '2014-02-15 00:09:22.000000', 'temperatura', 65.0000, 'ºC'),
	(199244, 120, '2014-02-15 00:09:23.000000', 'temperatura', 973.0000, 'ºC'),
	(199245, 120, '2014-02-15 00:09:24.000000', 'temperatura', 1071.0000, 'ºC'),
	(199246, 120, '2014-02-15 00:09:25.000000', 'temperatura', 35.0000, 'ºC'),
	(199247, 120, '2014-02-15 00:09:26.000000', 'temperatura', 564.0000, 'ºC'),
	(199248, 120, '2014-02-15 00:09:27.000000', 'temperatura', 316.0000, 'ºC'),
	(199249, 120, '2014-02-15 00:09:28.000000', 'temperatura', 1089.0000, 'ºC'),
	(199250, 120, '2014-02-15 00:09:29.000000', 'temperatura', 895.0000, 'ºC'),
	(199251, 120, '2014-02-15 00:09:30.000000', 'temperatura', 9.0000, 'ºC'),
	(199252, 120, '2014-02-15 00:09:31.000000', 'temperatura', 959.0000, 'ºC'),
	(199253, 120, '2014-02-15 00:09:32.000000', 'temperatura', 1171.0000, 'ºC'),
	(199254, 120, '2014-02-15 00:09:33.000000', 'temperatura', 578.0000, 'ºC'),
	(199255, 120, '2014-02-15 00:09:34.000000', 'temperatura', 576.0000, 'ºC'),
	(199256, 120, '2014-02-15 00:09:35.000000', 'temperatura', 1148.0000, 'ºC'),
	(199257, 120, '2014-02-15 00:09:36.000000', 'temperatura', 412.0000, 'ºC'),
	(199258, 120, '2014-02-15 00:09:37.000000', 'temperatura', 1015.0000, 'ºC'),
	(199259, 120, '2014-02-15 00:09:38.000000', 'temperatura', 240.0000, 'ºC'),
	(199260, 120, '2014-02-15 00:09:39.000000', 'temperatura', 556.0000, 'ºC'),
	(199261, 120, '2014-02-15 00:09:40.000000', 'temperatura', 861.0000, 'ºC'),
	(199262, 120, '2014-02-15 00:09:41.000000', 'temperatura', 236.0000, 'ºC'),
	(199263, 120, '2014-02-15 00:09:42.000000', 'temperatura', 996.0000, 'ºC'),
	(199264, 120, '2014-02-15 00:09:43.000000', 'temperatura', 676.0000, 'ºC'),
	(199265, 120, '2014-02-15 00:09:44.000000', 'temperatura', 390.0000, 'ºC'),
	(199266, 120, '2014-02-15 00:09:45.000000', 'temperatura', 1125.0000, 'ºC'),
	(199267, 120, '2014-02-15 00:09:46.000000', 'temperatura', 853.0000, 'ºC'),
	(199268, 120, '2014-02-15 00:09:47.000000', 'temperatura', 893.0000, 'ºC'),
	(199269, 120, '2014-02-15 00:09:48.000000', 'temperatura', 707.0000, 'ºC'),
	(199270, 120, '2014-02-15 00:09:49.000000', 'temperatura', 854.0000, 'ºC'),
	(199271, 120, '2014-02-15 00:09:50.000000', 'temperatura', 949.0000, 'ºC'),
	(199272, 120, '2014-02-15 00:09:51.000000', 'temperatura', 984.0000, 'ºC'),
	(199273, 120, '2014-02-15 00:09:52.000000', 'temperatura', 872.0000, 'ºC'),
	(199274, 120, '2014-02-15 00:09:53.000000', 'temperatura', 212.0000, 'ºC'),
	(199275, 120, '2014-02-15 00:09:54.000000', 'temperatura', 841.0000, 'ºC'),
	(199276, 120, '2014-02-15 00:09:55.000000', 'temperatura', 1171.0000, 'ºC'),
	(199277, 120, '2014-02-15 00:09:56.000000', 'temperatura', 934.0000, 'ºC'),
	(199278, 120, '2014-02-15 00:09:57.000000', 'temperatura', 1156.0000, 'ºC'),
	(199279, 120, '2014-02-15 00:09:58.000000', 'temperatura', 580.0000, 'ºC'),
	(199280, 120, '2014-02-15 00:09:59.000000', 'temperatura', 630.0000, 'ºC'),
	(199281, 120, '2014-02-15 00:10:00.000000', 'temperatura', 212.0000, 'ºC'),
	(199282, 120, '2014-02-15 00:10:01.000000', 'temperatura', 371.0000, 'ºC'),
	(199283, 120, '2014-02-15 00:10:02.000000', 'temperatura', 19.0000, 'ºC'),
	(199284, 120, '2014-02-15 00:10:03.000000', 'temperatura', 182.0000, 'ºC'),
	(199285, 120, '2014-02-15 00:10:04.000000', 'temperatura', 853.0000, 'ºC'),
	(199286, 120, '2014-02-15 00:10:05.000000', 'temperatura', 122.0000, 'ºC'),
	(199287, 120, '2014-02-15 00:10:06.000000', 'temperatura', 449.0000, 'ºC'),
	(199288, 120, '2014-02-15 00:10:07.000000', 'temperatura', 679.0000, 'ºC'),
	(199289, 120, '2014-02-15 00:10:08.000000', 'temperatura', 848.0000, 'ºC'),
	(199290, 120, '2014-02-15 00:10:09.000000', 'temperatura', 1005.0000, 'ºC'),
	(199291, 120, '2014-02-15 00:10:10.000000', 'temperatura', 80.0000, 'ºC'),
	(199292, 120, '2014-02-15 00:10:11.000000', 'temperatura', 986.0000, 'ºC'),
	(199293, 120, '2014-02-15 00:10:12.000000', 'temperatura', 1092.0000, 'ºC'),
	(199294, 120, '2014-02-15 00:10:13.000000', 'temperatura', 102.0000, 'ºC'),
	(199295, 120, '2014-02-15 00:10:14.000000', 'temperatura', 832.0000, 'ºC'),
	(199296, 120, '2014-02-15 00:10:15.000000', 'temperatura', 257.0000, 'ºC'),
	(199297, 120, '2014-02-15 00:10:16.000000', 'temperatura', 1188.0000, 'ºC'),
	(199298, 120, '2014-02-15 00:10:17.000000', 'temperatura', 371.0000, 'ºC'),
	(199299, 120, '2014-02-15 00:10:18.000000', 'temperatura', 692.0000, 'ºC'),
	(199300, 120, '2014-02-15 00:10:19.000000', 'temperatura', 1147.0000, 'ºC'),
	(199301, 120, '2014-02-15 00:10:20.000000', 'temperatura', 58.0000, 'ºC'),
	(199302, 120, '2014-02-15 00:10:21.000000', 'temperatura', 449.0000, 'ºC'),
	(199303, 120, '2014-02-15 00:10:22.000000', 'temperatura', 871.0000, 'ºC'),
	(199304, 120, '2014-02-15 00:10:23.000000', 'temperatura', 609.0000, 'ºC'),
	(199305, 120, '2014-02-15 00:10:24.000000', 'temperatura', 434.0000, 'ºC'),
	(199306, 120, '2014-02-15 00:10:25.000000', 'temperatura', 343.0000, 'ºC'),
	(199307, 120, '2014-02-15 00:10:26.000000', 'temperatura', 413.0000, 'ºC'),
	(199308, 120, '2014-02-15 00:10:27.000000', 'temperatura', 1037.0000, 'ºC'),
	(199309, 120, '2014-02-15 00:10:28.000000', 'temperatura', 347.0000, 'ºC'),
	(199310, 120, '2014-02-15 00:10:29.000000', 'temperatura', 1023.0000, 'ºC'),
	(199311, 120, '2014-02-15 00:10:30.000000', 'temperatura', 475.0000, 'ºC'),
	(199312, 120, '2014-02-15 00:10:31.000000', 'temperatura', 507.0000, 'ºC'),
	(199313, 120, '2014-02-15 00:10:32.000000', 'temperatura', 1109.0000, 'ºC'),
	(199314, 120, '2014-02-15 00:10:33.000000', 'temperatura', 425.0000, 'ºC'),
	(199315, 120, '2014-02-15 00:10:34.000000', 'temperatura', 0.0000, 'ºC'),
	(199316, 120, '2014-02-15 00:10:35.000000', 'temperatura', 1126.0000, 'ºC'),
	(199317, 120, '2014-02-15 00:10:36.000000', 'temperatura', 829.0000, 'ºC'),
	(199318, 120, '2014-02-15 00:10:37.000000', 'temperatura', 770.0000, 'ºC'),
	(199319, 120, '2014-02-15 00:10:38.000000', 'temperatura', 160.0000, 'ºC'),
	(199320, 120, '2014-02-15 00:10:39.000000', 'temperatura', 893.0000, 'ºC'),
	(199321, 120, '2014-02-15 00:10:40.000000', 'temperatura', 384.0000, 'ºC'),
	(199322, 120, '2014-02-15 00:10:41.000000', 'temperatura', 444.0000, 'ºC'),
	(199323, 120, '2014-02-15 00:10:42.000000', 'temperatura', 1066.0000, 'ºC'),
	(199324, 120, '2014-02-15 00:10:43.000000', 'temperatura', 401.0000, 'ºC'),
	(199325, 120, '2014-02-15 00:10:44.000000', 'temperatura', 7.0000, 'ºC'),
	(199326, 120, '2014-02-15 00:10:45.000000', 'temperatura', 31.0000, 'ºC'),
	(199327, 120, '2014-02-15 00:10:46.000000', 'temperatura', 136.0000, 'ºC'),
	(199328, 120, '2014-02-15 00:10:47.000000', 'temperatura', 587.0000, 'ºC'),
	(199329, 120, '2014-02-15 00:10:48.000000', 'temperatura', 129.0000, 'ºC'),
	(199330, 120, '2014-02-15 00:10:49.000000', 'temperatura', 82.0000, 'ºC'),
	(199331, 120, '2014-02-15 00:10:50.000000', 'temperatura', 27.0000, 'ºC'),
	(199332, 120, '2014-02-15 00:10:51.000000', 'temperatura', 1086.0000, 'ºC'),
	(199333, 120, '2014-02-15 00:10:52.000000', 'temperatura', 549.0000, 'ºC'),
	(199334, 120, '2014-02-15 00:10:53.000000', 'temperatura', 689.0000, 'ºC'),
	(199335, 120, '2014-02-15 00:10:54.000000', 'temperatura', 600.0000, 'ºC'),
	(199336, 120, '2014-02-15 00:10:55.000000', 'temperatura', 931.0000, 'ºC'),
	(199337, 120, '2014-02-15 00:10:56.000000', 'temperatura', 458.0000, 'ºC'),
	(199338, 120, '2014-02-15 00:10:57.000000', 'temperatura', 697.0000, 'ºC'),
	(199339, 120, '2014-02-15 00:10:58.000000', 'temperatura', 911.0000, 'ºC'),
	(199340, 120, '2014-02-15 00:10:59.000000', 'temperatura', 66.0000, 'ºC'),
	(199341, 120, '2014-02-15 00:11:00.000000', 'temperatura', 1195.0000, 'ºC'),
	(199342, 120, '2014-02-15 00:11:01.000000', 'temperatura', 977.0000, 'ºC'),
	(199343, 120, '2014-02-15 00:11:02.000000', 'temperatura', 102.0000, 'ºC'),
	(199344, 120, '2014-02-15 00:11:03.000000', 'temperatura', 1181.0000, 'ºC'),
	(199345, 120, '2014-02-15 00:11:04.000000', 'temperatura', 796.0000, 'ºC'),
	(199346, 120, '2014-02-15 00:11:05.000000', 'temperatura', 440.0000, 'ºC'),
	(199347, 120, '2014-02-15 00:11:06.000000', 'temperatura', 1013.0000, 'ºC'),
	(199348, 120, '2014-02-15 00:11:07.000000', 'temperatura', 145.0000, 'ºC'),
	(199349, 120, '2014-02-15 00:11:08.000000', 'temperatura', 86.0000, 'ºC'),
	(199350, 120, '2014-02-15 00:11:09.000000', 'temperatura', 1195.0000, 'ºC'),
	(199351, 120, '2014-02-15 00:11:10.000000', 'temperatura', 918.0000, 'ºC'),
	(199352, 120, '2014-02-15 00:11:11.000000', 'temperatura', 1006.0000, 'ºC'),
	(199353, 120, '2014-02-15 00:11:12.000000', 'temperatura', 1077.0000, 'ºC'),
	(199354, 120, '2014-02-15 00:11:13.000000', 'temperatura', 1168.0000, 'ºC'),
	(199355, 120, '2014-02-15 00:11:14.000000', 'temperatura', 209.0000, 'ºC'),
	(199356, 120, '2014-02-15 00:11:15.000000', 'temperatura', 1143.0000, 'ºC'),
	(199357, 120, '2014-02-15 00:11:16.000000', 'temperatura', 289.0000, 'ºC'),
	(199358, 120, '2014-02-15 00:11:17.000000', 'temperatura', 416.0000, 'ºC'),
	(199359, 120, '2014-02-15 00:11:18.000000', 'temperatura', 12.0000, 'ºC'),
	(199360, 120, '2014-02-15 00:11:19.000000', 'temperatura', 13.0000, 'ºC'),
	(199361, 120, '2014-02-15 00:11:20.000000', 'temperatura', 28.0000, 'ºC'),
	(199362, 120, '2014-02-15 00:11:21.000000', 'temperatura', 101.0000, 'ºC'),
	(199363, 120, '2014-02-15 00:11:22.000000', 'temperatura', 424.0000, 'ºC'),
	(199364, 120, '2014-02-15 00:11:23.000000', 'temperatura', 615.0000, 'ºC'),
	(199365, 120, '2014-02-15 00:11:24.000000', 'temperatura', 603.0000, 'ºC'),
	(199366, 120, '2014-02-15 00:11:25.000000', 'temperatura', 1173.0000, 'ºC'),
	(199367, 120, '2014-02-15 00:11:26.000000', 'temperatura', 457.0000, 'ºC'),
	(199368, 120, '2014-02-15 00:11:27.000000', 'temperatura', 1165.0000, 'ºC'),
	(199369, 120, '2014-02-15 00:11:28.000000', 'temperatura', 857.0000, 'ºC'),
	(199370, 120, '2014-02-15 00:11:29.000000', 'temperatura', 788.0000, 'ºC'),
	(199371, 120, '2014-02-15 00:11:30.000000', 'temperatura', 169.0000, 'ºC'),
	(199372, 120, '2014-02-15 00:11:31.000000', 'temperatura', 882.0000, 'ºC'),
	(199373, 120, '2014-02-15 00:11:32.000000', 'temperatura', 302.0000, 'ºC'),
	(199374, 120, '2014-02-15 00:11:33.000000', 'temperatura', 65.0000, 'ºC'),
	(199375, 120, '2014-02-15 00:11:34.000000', 'temperatura', 622.0000, 'ºC'),
	(199376, 120, '2014-02-15 00:11:35.000000', 'temperatura', 515.0000, 'ºC'),
	(199377, 120, '2014-02-15 00:11:36.000000', 'temperatura', 707.0000, 'ºC'),
	(199378, 120, '2014-02-15 00:11:37.000000', 'temperatura', 792.0000, 'ºC'),
	(199379, 120, '2014-02-15 00:11:38.000000', 'temperatura', 640.0000, 'ºC'),
	(199380, 120, '2014-02-15 00:11:39.000000', 'temperatura', 823.0000, 'ºC'),
	(199381, 120, '2014-02-15 00:11:40.000000', 'temperatura', 996.0000, 'ºC'),
	(199382, 120, '2014-02-15 00:11:41.000000', 'temperatura', 111.0000, 'ºC'),
	(199383, 120, '2014-02-15 00:11:42.000000', 'temperatura', 1168.0000, 'ºC'),
	(199384, 120, '2014-02-15 00:11:43.000000', 'temperatura', 706.0000, 'ºC'),
	(199385, 120, '2014-02-15 00:11:44.000000', 'temperatura', 26.0000, 'ºC'),
	(199386, 120, '2014-02-15 00:11:45.000000', 'temperatura', 413.0000, 'ºC'),
	(199387, 120, '2014-02-15 00:11:46.000000', 'temperatura', 788.0000, 'ºC'),
	(199388, 120, '2014-02-15 00:11:47.000000', 'temperatura', 300.0000, 'ºC'),
	(199389, 120, '2014-02-15 00:11:48.000000', 'temperatura', 336.0000, 'ºC'),
	(199390, 120, '2014-02-15 00:11:49.000000', 'temperatura', 782.0000, 'ºC'),
	(199391, 120, '2014-02-15 00:11:50.000000', 'temperatura', 502.0000, 'ºC'),
	(199392, 120, '2014-02-15 00:11:51.000000', 'temperatura', 167.0000, 'ºC'),
	(199393, 120, '2014-02-15 00:11:52.000000', 'temperatura', 527.0000, 'ºC'),
	(199394, 120, '2014-02-15 00:11:53.000000', 'temperatura', 934.0000, 'ºC'),
	(199395, 120, '2014-02-15 00:11:54.000000', 'temperatura', 689.0000, 'ºC'),
	(199396, 120, '2014-02-15 00:11:55.000000', 'temperatura', 642.0000, 'ºC'),
	(199397, 120, '2014-02-15 00:11:56.000000', 'temperatura', 1147.0000, 'ºC'),
	(199398, 120, '2014-02-15 00:11:57.000000', 'temperatura', 208.0000, 'ºC'),
	(199399, 120, '2014-02-15 00:11:58.000000', 'temperatura', 1199.0000, 'ºC'),
	(199400, 120, '2014-02-15 00:11:59.000000', 'temperatura', 571.0000, 'ºC'),
	(199401, 120, '2014-02-15 00:12:00.000000', 'temperatura', 459.0000, 'ºC'),
	(199402, 120, '2014-02-15 00:12:01.000000', 'temperatura', 584.0000, 'ºC'),
	(199403, 120, '2014-02-15 00:12:02.000000', 'temperatura', 345.0000, 'ºC'),
	(199404, 120, '2014-02-15 00:12:03.000000', 'temperatura', 1170.0000, 'ºC'),
	(199405, 120, '2014-02-15 00:12:04.000000', 'temperatura', 18.0000, 'ºC'),
	(199406, 120, '2014-02-15 00:12:05.000000', 'temperatura', 178.0000, 'ºC'),
	(199407, 120, '2014-02-15 00:12:06.000000', 'temperatura', 838.0000, 'ºC'),
	(199408, 120, '2014-02-15 00:12:07.000000', 'temperatura', 54.0000, 'ºC'),
	(199409, 120, '2014-02-15 00:12:08.000000', 'temperatura', 160.0000, 'ºC'),
	(199410, 120, '2014-02-15 00:12:09.000000', 'temperatura', 635.0000, 'ºC'),
	(199411, 120, '2014-02-15 00:12:10.000000', 'temperatura', 299.0000, 'ºC'),
	(199412, 120, '2014-02-15 00:12:11.000000', 'temperatura', 789.0000, 'ºC'),
	(199413, 120, '2014-02-15 00:12:12.000000', 'temperatura', 648.0000, 'ºC'),
	(199414, 120, '2014-02-15 00:12:13.000000', 'temperatura', 873.0000, 'ºC'),
	(199415, 120, '2014-02-15 00:12:14.000000', 'temperatura', 22.0000, 'ºC'),
	(199416, 120, '2014-02-15 00:12:15.000000', 'temperatura', 1090.0000, 'ºC'),
	(199417, 120, '2014-02-15 00:12:16.000000', 'temperatura', 586.0000, 'ºC'),
	(199418, 120, '2014-02-15 00:12:17.000000', 'temperatura', 859.0000, 'ºC'),
	(199419, 120, '2014-02-15 00:12:18.000000', 'temperatura', 139.0000, 'ºC'),
	(199420, 120, '2014-02-15 00:12:19.000000', 'temperatura', 519.0000, 'ºC'),
	(199421, 120, '2014-02-15 00:12:20.000000', 'temperatura', 980.0000, 'ºC'),
	(199422, 120, '2014-02-15 00:12:21.000000', 'temperatura', 941.0000, 'ºC'),
	(199423, 120, '2014-02-15 00:12:22.000000', 'temperatura', 565.0000, 'ºC'),
	(199424, 120, '2014-02-15 00:12:23.000000', 'temperatura', 2.0000, 'ºC'),
	(199425, 120, '2014-02-15 00:12:24.000000', 'temperatura', 717.0000, 'ºC'),
	(199426, 120, '2014-02-15 00:12:25.000000', 'temperatura', 1178.0000, 'ºC'),
	(199427, 120, '2014-02-15 00:12:26.000000', 'temperatura', 139.0000, 'ºC'),
	(199428, 120, '2014-02-15 00:12:27.000000', 'temperatura', 761.0000, 'ºC'),
	(199429, 120, '2014-02-15 00:12:28.000000', 'temperatura', 989.0000, 'ºC'),
	(199430, 120, '2014-02-15 00:12:29.000000', 'temperatura', 265.0000, 'ºC'),
	(199431, 120, '2014-02-15 00:12:30.000000', 'temperatura', 755.0000, 'ºC'),
	(199432, 120, '2014-02-15 00:12:31.000000', 'temperatura', 583.0000, 'ºC'),
	(199433, 120, '2014-02-15 00:12:32.000000', 'temperatura', 652.0000, 'ºC'),
	(199434, 120, '2014-02-15 00:12:33.000000', 'temperatura', 308.0000, 'ºC'),
	(199435, 120, '2014-02-15 00:12:34.000000', 'temperatura', 786.0000, 'ºC'),
	(199436, 120, '2014-02-15 00:12:35.000000', 'temperatura', 606.0000, 'ºC'),
	(199437, 120, '2014-02-15 00:12:36.000000', 'temperatura', 673.0000, 'ºC'),
	(199438, 120, '2014-02-15 00:12:37.000000', 'temperatura', 346.0000, 'ºC'),
	(199439, 120, '2014-02-15 00:12:38.000000', 'temperatura', 912.0000, 'ºC'),
	(199440, 120, '2014-02-15 00:12:39.000000', 'temperatura', 1123.0000, 'ºC'),
	(199441, 120, '2014-02-15 00:12:40.000000', 'temperatura', 480.0000, 'ºC'),
	(199442, 120, '2014-02-15 00:12:41.000000', 'temperatura', 233.0000, 'ºC'),
	(199443, 120, '2014-02-15 00:12:42.000000', 'temperatura', 922.0000, 'ºC'),
	(199444, 120, '2014-02-15 00:12:43.000000', 'temperatura', 315.0000, 'ºC'),
	(199445, 120, '2014-02-15 00:12:44.000000', 'temperatura', 7.0000, 'ºC'),
	(199446, 120, '2014-02-15 00:12:45.000000', 'temperatura', 293.0000, 'ºC'),
	(199447, 120, '2014-02-15 00:12:46.000000', 'temperatura', 243.0000, 'ºC'),
	(199448, 120, '2014-02-15 00:12:47.000000', 'temperatura', 335.0000, 'ºC'),
	(199449, 120, '2014-02-15 00:12:48.000000', 'temperatura', 947.0000, 'ºC'),
	(199450, 120, '2014-02-15 00:12:49.000000', 'temperatura', 132.0000, 'ºC'),
	(199451, 120, '2014-02-15 00:12:50.000000', 'temperatura', 219.0000, 'ºC'),
	(199452, 120, '2014-02-15 00:12:51.000000', 'temperatura', 700.0000, 'ºC'),
	(199453, 120, '2014-02-15 00:12:52.000000', 'temperatura', 444.0000, 'ºC'),
	(199454, 120, '2014-02-15 00:12:53.000000', 'temperatura', 120.0000, 'ºC'),
	(199455, 120, '2014-02-15 00:12:54.000000', 'temperatura', 466.0000, 'ºC'),
	(199456, 120, '2014-02-15 00:12:55.000000', 'temperatura', 773.0000, 'ºC'),
	(199457, 120, '2014-02-15 00:12:56.000000', 'temperatura', 69.0000, 'ºC'),
	(199458, 120, '2014-02-15 00:12:57.000000', 'temperatura', 425.0000, 'ºC'),
	(199459, 120, '2014-02-15 00:12:58.000000', 'temperatura', 718.0000, 'ºC'),
	(199460, 120, '2014-02-15 00:12:59.000000', 'temperatura', 1117.0000, 'ºC'),
	(199461, 120, '2014-02-15 00:13:00.000000', 'temperatura', 1029.0000, 'ºC'),
	(199462, 120, '2014-02-15 00:13:01.000000', 'temperatura', 595.0000, 'ºC'),
	(199463, 120, '2014-02-15 00:13:02.000000', 'temperatura', 1090.0000, 'ºC'),
	(199464, 120, '2014-02-15 00:13:03.000000', 'temperatura', 63.0000, 'ºC'),
	(199465, 120, '2014-02-15 00:13:04.000000', 'temperatura', 647.0000, 'ºC'),
	(199466, 120, '2014-02-15 00:13:05.000000', 'temperatura', 648.0000, 'ºC'),
	(199467, 120, '2014-02-15 00:13:06.000000', 'temperatura', 96.0000, 'ºC'),
	(199468, 120, '2014-02-15 00:13:07.000000', 'temperatura', 940.0000, 'ºC'),
	(199469, 120, '2014-02-15 00:13:08.000000', 'temperatura', 812.0000, 'ºC'),
	(199470, 120, '2014-02-15 00:13:09.000000', 'temperatura', 40.0000, 'ºC'),
	(199471, 120, '2014-02-15 00:13:10.000000', 'temperatura', 164.0000, 'ºC'),
	(199472, 120, '2014-02-15 00:13:11.000000', 'temperatura', 699.0000, 'ºC'),
	(199473, 120, '2014-02-15 00:13:12.000000', 'temperatura', 606.0000, 'ºC'),
	(199474, 120, '2014-02-15 00:13:13.000000', 'temperatura', 931.0000, 'ºC'),
	(199475, 120, '2014-02-15 00:13:14.000000', 'temperatura', 439.0000, 'ºC'),
	(199476, 120, '2014-02-15 00:13:15.000000', 'temperatura', 603.0000, 'ºC'),
	(199477, 120, '2014-02-15 00:13:16.000000', 'temperatura', 496.0000, 'ºC'),
	(199478, 120, '2014-02-15 00:13:17.000000', 'temperatura', 673.0000, 'ºC'),
	(199479, 120, '2014-02-15 00:13:18.000000', 'temperatura', 677.0000, 'ºC'),
	(199480, 120, '2014-02-15 00:13:19.000000', 'temperatura', 167.0000, 'ºC'),
	(199481, 120, '2014-02-15 00:13:20.000000', 'temperatura', 3.0000, 'ºC'),
	(199482, 120, '2014-02-15 00:13:21.000000', 'temperatura', 714.0000, 'ºC'),
	(199483, 120, '2014-02-15 00:13:22.000000', 'temperatura', 1163.0000, 'ºC'),
	(199484, 120, '2014-02-15 00:13:23.000000', 'temperatura', 72.0000, 'ºC'),
	(199485, 120, '2014-02-15 00:13:24.000000', 'temperatura', 471.0000, 'ºC'),
	(199486, 120, '2014-02-15 00:13:25.000000', 'temperatura', 939.0000, 'ºC'),
	(199487, 120, '2014-02-15 00:13:26.000000', 'temperatura', 883.0000, 'ºC'),
	(199488, 120, '2014-02-15 00:13:27.000000', 'temperatura', 400.0000, 'ºC'),
	(199489, 120, '2014-02-15 00:13:28.000000', 'temperatura', 552.0000, 'ºC'),
	(199490, 120, '2014-02-15 00:13:29.000000', 'temperatura', 359.0000, 'ºC'),
	(199491, 120, '2014-02-15 00:13:30.000000', 'temperatura', 140.0000, 'ºC'),
	(199492, 120, '2014-02-15 00:13:31.000000', 'temperatura', 821.0000, 'ºC'),
	(199493, 120, '2014-02-15 00:13:32.000000', 'temperatura', 89.0000, 'ºC'),
	(199494, 120, '2014-02-15 00:13:33.000000', 'temperatura', 381.0000, 'ºC'),
	(199495, 120, '2014-02-15 00:13:34.000000', 'temperatura', 440.0000, 'ºC'),
	(199496, 120, '2014-02-15 00:13:35.000000', 'temperatura', 1058.0000, 'ºC'),
	(199497, 120, '2014-02-15 00:13:36.000000', 'temperatura', 371.0000, 'ºC'),
	(199498, 120, '2014-02-15 00:13:37.000000', 'temperatura', 1080.0000, 'ºC'),
	(199499, 120, '2014-02-15 00:13:38.000000', 'temperatura', 688.0000, 'ºC'),
	(199500, 120, '2014-02-15 00:13:39.000000', 'temperatura', 201.0000, 'ºC'),
	(199501, 120, '2014-02-15 00:13:40.000000', 'temperatura', 143.0000, 'ºC'),
	(199502, 120, '2014-02-15 00:13:41.000000', 'temperatura', 111.0000, 'ºC'),
	(199503, 120, '2014-02-15 00:13:42.000000', 'temperatura', 127.0000, 'ºC'),
	(199504, 120, '2014-02-15 00:13:43.000000', 'temperatura', 304.0000, 'ºC'),
	(199505, 120, '2014-02-15 00:13:44.000000', 'temperatura', 1139.0000, 'ºC'),
	(199506, 120, '2014-02-15 00:13:45.000000', 'temperatura', 1184.0000, 'ºC'),
	(199507, 120, '2014-02-15 00:13:46.000000', 'temperatura', 102.0000, 'ºC'),
	(199508, 120, '2014-02-15 00:13:47.000000', 'temperatura', 560.0000, 'ºC'),
	(199509, 120, '2014-02-15 00:13:48.000000', 'temperatura', 94.0000, 'ºC'),
	(199510, 120, '2014-02-15 00:13:49.000000', 'temperatura', 1192.0000, 'ºC'),
	(199511, 120, '2014-02-15 00:13:50.000000', 'temperatura', 879.0000, 'ºC'),
	(199512, 120, '2014-02-15 00:13:51.000000', 'temperatura', 817.0000, 'ºC'),
	(199513, 120, '2014-02-15 00:13:52.000000', 'temperatura', 249.0000, 'ºC'),
	(199514, 120, '2014-02-15 00:13:53.000000', 'temperatura', 1194.0000, 'ºC'),
	(199515, 120, '2014-02-15 00:13:54.000000', 'temperatura', 423.0000, 'ºC'),
	(199516, 120, '2014-02-15 00:13:55.000000', 'temperatura', 936.0000, 'ºC'),
	(199517, 120, '2014-02-15 00:13:56.000000', 'temperatura', 1012.0000, 'ºC'),
	(199518, 120, '2014-02-15 00:13:57.000000', 'temperatura', 1051.0000, 'ºC'),
	(199519, 120, '2014-02-15 00:13:58.000000', 'temperatura', 1018.0000, 'ºC'),
	(199520, 120, '2014-02-15 00:13:59.000000', 'temperatura', 737.0000, 'ºC'),
	(199521, 120, '2014-02-15 00:14:00.000000', 'temperatura', 634.0000, 'ºC'),
	(199522, 120, '2014-02-15 00:14:01.000000', 'temperatura', 958.0000, 'ºC'),
	(199523, 120, '2014-02-15 00:14:02.000000', 'temperatura', 491.0000, 'ºC'),
	(199524, 120, '2014-02-15 00:14:03.000000', 'temperatura', 780.0000, 'ºC'),
	(199525, 120, '2014-02-15 00:14:04.000000', 'temperatura', 26.0000, 'ºC'),
	(199526, 120, '2014-02-15 00:14:05.000000', 'temperatura', 191.0000, 'ºC'),
	(199527, 120, '2014-02-15 00:14:06.000000', 'temperatura', 878.0000, 'ºC'),
	(199528, 120, '2014-02-15 00:14:07.000000', 'temperatura', 216.0000, 'ºC'),
	(199529, 120, '2014-02-15 00:14:08.000000', 'temperatura', 847.0000, 'ºC'),
	(199530, 120, '2014-02-15 00:14:09.000000', 'temperatura', 1190.0000, 'ºC'),
	(199531, 120, '2014-02-15 00:14:10.000000', 'temperatura', 1006.0000, 'ºC'),
	(199532, 120, '2014-02-15 00:14:11.000000', 'temperatura', 262.0000, 'ºC'),
	(199533, 120, '2014-02-15 00:14:12.000000', 'temperatura', 693.0000, 'ºC'),
	(199534, 120, '2014-02-15 00:14:13.000000', 'temperatura', 277.0000, 'ºC'),
	(199535, 120, '2014-02-15 00:14:14.000000', 'temperatura', 508.0000, 'ºC'),
	(199536, 120, '2014-02-15 00:14:15.000000', 'temperatura', 510.0000, 'ºC'),
	(199537, 120, '2014-02-15 00:14:16.000000', 'temperatura', 1028.0000, 'ºC'),
	(199538, 120, '2014-02-15 00:14:17.000000', 'temperatura', 10.0000, 'ºC'),
	(199539, 120, '2014-02-15 00:14:18.000000', 'temperatura', 568.0000, 'ºC'),
	(199540, 120, '2014-02-15 00:14:19.000000', 'temperatura', 408.0000, 'ºC'),
	(199541, 120, '2014-02-15 00:14:20.000000', 'temperatura', 337.0000, 'ºC'),
	(199542, 120, '2014-02-15 00:14:21.000000', 'temperatura', 460.0000, 'ºC'),
	(199543, 120, '2014-02-15 00:14:22.000000', 'temperatura', 90.0000, 'ºC'),
	(199544, 120, '2014-02-15 00:14:23.000000', 'temperatura', 269.0000, 'ºC'),
	(199545, 120, '2014-02-15 00:14:24.000000', 'temperatura', 1077.0000, 'ºC'),
	(199546, 120, '2014-02-15 00:14:25.000000', 'temperatura', 978.0000, 'ºC'),
	(199547, 120, '2014-02-15 00:14:26.000000', 'temperatura', 458.0000, 'ºC'),
	(199548, 120, '2014-02-15 00:14:27.000000', 'temperatura', 557.0000, 'ºC'),
	(199549, 120, '2014-02-15 00:14:28.000000', 'temperatura', 210.0000, 'ºC'),
	(199550, 120, '2014-02-15 00:14:29.000000', 'temperatura', 582.0000, 'ºC'),
	(199551, 120, '2014-02-15 00:14:30.000000', 'temperatura', 1078.0000, 'ºC'),
	(199552, 120, '2014-02-15 00:14:31.000000', 'temperatura', 45.0000, 'ºC'),
	(199553, 120, '2014-02-15 00:14:32.000000', 'temperatura', 593.0000, 'ºC'),
	(199554, 120, '2014-02-15 00:14:33.000000', 'temperatura', 428.0000, 'ºC'),
	(199555, 120, '2014-02-15 00:14:34.000000', 'temperatura', 361.0000, 'ºC'),
	(199556, 120, '2014-02-15 00:14:35.000000', 'temperatura', 524.0000, 'ºC'),
	(199557, 120, '2014-02-15 00:14:36.000000', 'temperatura', 338.0000, 'ºC'),
	(199558, 120, '2014-02-15 00:14:37.000000', 'temperatura', 117.0000, 'ºC'),
	(199559, 120, '2014-02-15 00:14:38.000000', 'temperatura', 774.0000, 'ºC'),
	(199560, 120, '2014-02-15 00:14:39.000000', 'temperatura', 1117.0000, 'ºC'),
	(199561, 120, '2014-02-15 00:14:40.000000', 'temperatura', 865.0000, 'ºC'),
	(199562, 120, '2014-02-15 00:14:41.000000', 'temperatura', 972.0000, 'ºC'),
	(199563, 120, '2014-02-15 00:14:42.000000', 'temperatura', 1068.0000, 'ºC'),
	(199564, 120, '2014-02-15 00:14:43.000000', 'temperatura', 22.0000, 'ºC'),
	(199565, 120, '2014-02-15 00:14:44.000000', 'temperatura', 507.0000, 'ºC'),
	(199566, 120, '2014-02-15 00:14:45.000000', 'temperatura', 71.0000, 'ºC'),
	(199567, 120, '2014-02-15 00:14:46.000000', 'temperatura', 32.0000, 'ºC'),
	(199568, 120, '2014-02-15 00:14:47.000000', 'temperatura', 1150.0000, 'ºC'),
	(199569, 120, '2014-02-15 00:14:48.000000', 'temperatura', 855.0000, 'ºC'),
	(199570, 120, '2014-02-15 00:14:49.000000', 'temperatura', 823.0000, 'ºC'),
	(199571, 120, '2014-02-15 00:14:50.000000', 'temperatura', 352.0000, 'ºC'),
	(199572, 120, '2014-02-15 00:14:51.000000', 'temperatura', 491.0000, 'ºC'),
	(199573, 120, '2014-02-15 00:14:52.000000', 'temperatura', 199.0000, 'ºC'),
	(199574, 120, '2014-02-15 00:14:53.000000', 'temperatura', 724.0000, 'ºC'),
	(199575, 120, '2014-02-15 00:14:54.000000', 'temperatura', 624.0000, 'ºC'),
	(199576, 120, '2014-02-15 00:14:55.000000', 'temperatura', 946.0000, 'ºC'),
	(199577, 120, '2014-02-15 00:14:56.000000', 'temperatura', 458.0000, 'ºC'),
	(199578, 120, '2014-02-15 00:14:57.000000', 'temperatura', 652.0000, 'ºC'),
	(199579, 120, '2014-02-15 00:14:58.000000', 'temperatura', 688.0000, 'ºC'),
	(199580, 120, '2014-02-15 00:14:59.000000', 'temperatura', 284.0000, 'ºC'),
	(199581, 120, '2014-02-15 00:15:00.000000', 'temperatura', 559.0000, 'ºC'),
	(199582, 120, '2014-02-15 00:15:01.000000', 'temperatura', 741.0000, 'ºC'),
	(199583, 120, '2014-02-15 00:15:02.000000', 'temperatura', 828.0000, 'ºC'),
	(199584, 120, '2014-02-15 00:15:03.000000', 'temperatura', 718.0000, 'ºC'),
	(199585, 120, '2014-02-15 00:15:04.000000', 'temperatura', 1107.0000, 'ºC'),
	(199586, 120, '2014-02-15 00:15:05.000000', 'temperatura', 981.0000, 'ºC'),
	(199587, 120, '2014-02-15 00:15:06.000000', 'temperatura', 383.0000, 'ºC'),
	(199588, 120, '2014-02-15 00:15:07.000000', 'temperatura', 174.0000, 'ºC'),
	(199589, 120, '2014-02-15 00:15:08.000000', 'temperatura', 921.0000, 'ºC'),
	(199590, 120, '2014-02-15 00:15:09.000000', 'temperatura', 484.0000, 'ºC'),
	(199591, 120, '2014-02-15 00:15:10.000000', 'temperatura', 857.0000, 'ºC'),
	(199592, 120, '2014-02-15 00:15:11.000000', 'temperatura', 432.0000, 'ºC'),
	(199593, 120, '2014-02-15 00:15:12.000000', 'temperatura', 792.0000, 'ºC'),
	(199594, 120, '2014-02-15 00:15:13.000000', 'temperatura', 264.0000, 'ºC'),
	(199595, 120, '2014-02-15 00:15:14.000000', 'temperatura', 143.0000, 'ºC'),
	(199596, 120, '2014-02-15 00:15:15.000000', 'temperatura', 1126.0000, 'ºC'),
	(199597, 120, '2014-02-15 00:15:16.000000', 'temperatura', 401.0000, 'ºC'),
	(199598, 120, '2014-02-15 00:15:17.000000', 'temperatura', 1027.0000, 'ºC'),
	(199599, 120, '2014-02-15 00:15:18.000000', 'temperatura', 334.0000, 'ºC'),
	(199600, 120, '2014-02-15 00:15:19.000000', 'temperatura', 988.0000, 'ºC'),
	(199601, 120, '2014-02-15 00:15:20.000000', 'temperatura', 338.0000, 'ºC'),
	(199602, 120, '2014-02-15 00:15:21.000000', 'temperatura', 1125.0000, 'ºC'),
	(199603, 120, '2014-02-15 00:15:22.000000', 'temperatura', 1015.0000, 'ºC'),
	(199604, 120, '2014-02-15 00:15:23.000000', 'temperatura', 499.0000, 'ºC'),
	(199605, 120, '2014-02-15 00:15:24.000000', 'temperatura', 650.0000, 'ºC'),
	(199606, 120, '2014-02-15 00:15:25.000000', 'temperatura', 552.0000, 'ºC'),
	(199607, 120, '2014-02-15 00:15:26.000000', 'temperatura', 814.0000, 'ºC'),
	(199608, 120, '2014-02-15 00:15:27.000000', 'temperatura', 13.0000, 'ºC'),
	(199609, 120, '2014-02-15 00:15:28.000000', 'temperatura', 23.0000, 'ºC'),
	(199610, 120, '2014-02-15 00:15:29.000000', 'temperatura', 75.0000, 'ºC'),
	(199611, 120, '2014-02-15 00:15:30.000000', 'temperatura', 308.0000, 'ºC'),
	(199612, 120, '2014-02-15 00:15:31.000000', 'temperatura', 117.0000, 'ºC'),
	(199613, 120, '2014-02-15 00:15:32.000000', 'temperatura', 859.0000, 'ºC'),
	(199614, 120, '2014-02-15 00:15:33.000000', 'temperatura', 345.0000, 'ºC'),
	(199615, 120, '2014-02-15 00:15:34.000000', 'temperatura', 348.0000, 'ºC'),
	(199616, 120, '2014-02-15 00:15:35.000000', 'temperatura', 706.0000, 'ºC'),
	(199617, 120, '2014-02-15 00:15:36.000000', 'temperatura', 87.0000, 'ºC'),
	(199618, 120, '2014-02-15 00:15:37.000000', 'temperatura', 716.0000, 'ºC'),
	(199619, 120, '2014-02-15 00:15:38.000000', 'temperatura', 918.0000, 'ºC'),
	(199620, 120, '2014-02-15 00:15:39.000000', 'temperatura', 45.0000, 'ºC'),
	(199621, 120, '2014-02-15 00:15:40.000000', 'temperatura', 1072.0000, 'ºC'),
	(199622, 120, '2014-02-15 00:15:41.000000', 'temperatura', 424.0000, 'ºC'),
	(199623, 120, '2014-02-15 00:15:42.000000', 'temperatura', 104.0000, 'ºC'),
	(199624, 120, '2014-02-15 00:15:43.000000', 'temperatura', 450.0000, 'ºC'),
	(199625, 120, '2014-02-15 00:15:44.000000', 'temperatura', 740.0000, 'ºC'),
	(199626, 120, '2014-02-15 00:15:45.000000', 'temperatura', 1148.0000, 'ºC'),
	(199627, 120, '2014-02-15 00:15:46.000000', 'temperatura', 1120.0000, 'ºC'),
	(199628, 120, '2014-02-15 00:15:47.000000', 'temperatura', 959.0000, 'ºC'),
	(199629, 120, '2014-02-15 00:15:48.000000', 'temperatura', 233.0000, 'ºC'),
	(199630, 120, '2014-02-15 00:15:49.000000', 'temperatura', 690.0000, 'ºC'),
	(199631, 120, '2014-02-15 00:15:50.000000', 'temperatura', 353.0000, 'ºC'),
	(199632, 120, '2014-02-15 00:15:51.000000', 'temperatura', 895.0000, 'ºC'),
	(199633, 120, '2014-02-15 00:15:52.000000', 'temperatura', 1016.0000, 'ºC'),
	(199634, 120, '2014-02-15 00:15:53.000000', 'temperatura', 1195.0000, 'ºC'),
	(199635, 120, '2014-02-15 00:15:54.000000', 'temperatura', 529.0000, 'ºC'),
	(199636, 120, '2014-02-15 00:15:55.000000', 'temperatura', 258.0000, 'ºC'),
	(199637, 120, '2014-02-15 00:15:56.000000', 'temperatura', 905.0000, 'ºC'),
	(199638, 120, '2014-02-15 00:15:57.000000', 'temperatura', 151.0000, 'ºC'),
	(199639, 120, '2014-02-15 00:15:58.000000', 'temperatura', 440.0000, 'ºC'),
	(199640, 120, '2014-02-15 00:15:59.000000', 'temperatura', 550.0000, 'ºC'),
	(199641, 120, '2014-02-15 00:16:00.000000', 'temperatura', 228.0000, 'ºC'),
	(199642, 120, '2014-02-15 00:16:01.000000', 'temperatura', 690.0000, 'ºC'),
	(199643, 120, '2014-02-15 00:16:02.000000', 'temperatura', 367.0000, 'ºC'),
	(199644, 120, '2014-02-15 00:16:03.000000', 'temperatura', 964.0000, 'ºC'),
	(199645, 120, '2014-02-15 00:16:04.000000', 'temperatura', 122.0000, 'ºC'),
	(199646, 120, '2014-02-15 00:16:05.000000', 'temperatura', 117.0000, 'ºC'),
	(199647, 120, '2014-02-15 00:16:06.000000', 'temperatura', 219.0000, 'ºC'),
	(199648, 120, '2014-02-15 00:16:07.000000', 'temperatura', 743.0000, 'ºC'),
	(199649, 120, '2014-02-15 00:16:08.000000', 'temperatura', 661.0000, 'ºC'),
	(199650, 120, '2014-02-15 00:16:09.000000', 'temperatura', 1074.0000, 'ºC'),
	(199651, 120, '2014-02-15 00:16:10.000000', 'temperatura', 987.0000, 'ºC'),
	(199652, 120, '2014-02-15 00:16:11.000000', 'temperatura', 516.0000, 'ºC'),
	(199653, 120, '2014-02-15 00:16:12.000000', 'temperatura', 820.0000, 'ºC'),
	(199654, 120, '2014-02-15 00:16:13.000000', 'temperatura', 153.0000, 'ºC'),
	(199655, 120, '2014-02-15 00:16:14.000000', 'temperatura', 705.0000, 'ºC'),
	(199656, 120, '2014-02-15 00:16:15.000000', 'temperatura', 667.0000, 'ºC'),
	(199657, 120, '2014-02-15 00:16:16.000000', 'temperatura', 19.0000, 'ºC'),
	(199658, 120, '2014-02-15 00:16:17.000000', 'temperatura', 495.0000, 'ºC'),
	(199659, 120, '2014-02-15 00:16:18.000000', 'temperatura', 18.0000, 'ºC'),
	(199660, 120, '2014-02-15 00:16:19.000000', 'temperatura', 1006.0000, 'ºC'),
	(199661, 120, '2014-02-15 00:16:20.000000', 'temperatura', 178.0000, 'ºC'),
	(199662, 120, '2014-02-15 00:16:21.000000', 'temperatura', 270.0000, 'ºC'),
	(199663, 120, '2014-02-15 00:16:22.000000', 'temperatura', 819.0000, 'ºC'),
	(199664, 120, '2014-02-15 00:16:23.000000', 'temperatura', 886.0000, 'ºC'),
	(199665, 120, '2014-02-15 00:16:24.000000', 'temperatura', 772.0000, 'ºC'),
	(199666, 120, '2014-02-15 00:16:25.000000', 'temperatura', 3.0000, 'ºC'),
	(199667, 120, '2014-02-15 00:16:26.000000', 'temperatura', 99.0000, 'ºC'),
	(199668, 120, '2014-02-15 00:16:27.000000', 'temperatura', 485.0000, 'ºC'),
	(199669, 120, '2014-02-15 00:16:28.000000', 'temperatura', 929.0000, 'ºC'),
	(199670, 120, '2014-02-15 00:16:29.000000', 'temperatura', 791.0000, 'ºC'),
	(199671, 120, '2014-02-15 00:16:30.000000', 'temperatura', 1169.0000, 'ºC'),
	(199672, 120, '2014-02-15 00:16:31.000000', 'temperatura', 1070.0000, 'ºC'),
	(199673, 120, '2014-02-15 00:16:32.000000', 'temperatura', 647.0000, 'ºC'),
	(199674, 120, '2014-02-15 00:16:33.000000', 'temperatura', 24.0000, 'ºC'),
	(199675, 120, '2014-02-15 00:16:34.000000', 'temperatura', 579.0000, 'ºC'),
	(199676, 120, '2014-02-15 00:16:35.000000', 'temperatura', 422.0000, 'ºC'),
	(199677, 120, '2014-02-15 00:16:36.000000', 'temperatura', 377.0000, 'ºC'),
	(199678, 120, '2014-02-15 00:16:37.000000', 'temperatura', 618.0000, 'ºC'),
	(199679, 120, '2014-02-15 00:16:38.000000', 'temperatura', 759.0000, 'ºC'),
	(199680, 120, '2014-02-15 00:16:39.000000', 'temperatura', 740.0000, 'ºC'),
	(199681, 120, '2014-02-15 00:16:40.000000', 'temperatura', 226.0000, 'ºC'),
	(199682, 120, '2014-02-15 00:16:41.000000', 'temperatura', 112.0000, 'ºC'),
	(199683, 120, '2014-02-15 00:16:42.000000', 'temperatura', 1079.0000, 'ºC'),
	(199684, 120, '2014-02-15 00:16:43.000000', 'temperatura', 262.0000, 'ºC'),
	(199685, 120, '2014-02-15 00:16:44.000000', 'temperatura', 474.0000, 'ºC'),
	(199686, 120, '2014-02-15 00:16:45.000000', 'temperatura', 385.0000, 'ºC'),
	(199687, 120, '2014-02-15 00:16:46.000000', 'temperatura', 502.0000, 'ºC'),
	(199688, 120, '2014-02-15 00:16:47.000000', 'temperatura', 158.0000, 'ºC'),
	(199689, 120, '2014-02-15 00:16:48.000000', 'temperatura', 481.0000, 'ºC'),
	(199690, 120, '2014-02-15 00:16:49.000000', 'temperatura', 735.0000, 'ºC'),
	(199691, 120, '2014-02-15 00:16:50.000000', 'temperatura', 1030.0000, 'ºC'),
	(199692, 120, '2014-02-15 00:16:51.000000', 'temperatura', 546.0000, 'ºC'),
	(199693, 120, '2014-02-15 00:16:52.000000', 'temperatura', 842.0000, 'ºC'),
	(199694, 120, '2014-02-15 00:16:53.000000', 'temperatura', 173.0000, 'ºC'),
	(199695, 120, '2014-02-15 00:16:54.000000', 'temperatura', 739.0000, 'ºC'),
	(199696, 120, '2014-02-15 00:16:55.000000', 'temperatura', 777.0000, 'ºC'),
	(199697, 120, '2014-02-15 00:16:56.000000', 'temperatura', 467.0000, 'ºC'),
	(199698, 120, '2014-02-15 00:16:57.000000', 'temperatura', 6.0000, 'ºC'),
	(199699, 120, '2014-02-15 00:16:58.000000', 'temperatura', 1028.0000, 'ºC'),
	(199700, 120, '2014-02-15 00:16:59.000000', 'temperatura', 323.0000, 'ºC'),
	(199701, 120, '2014-02-15 00:17:00.000000', 'temperatura', 933.0000, 'ºC'),
	(199702, 120, '2014-02-15 00:17:01.000000', 'temperatura', 97.0000, 'ºC'),
	(199703, 120, '2014-02-15 00:17:02.000000', 'temperatura', 87.0000, 'ºC'),
	(199704, 120, '2014-02-15 00:17:03.000000', 'temperatura', 143.0000, 'ºC'),
	(199705, 120, '2014-02-15 00:17:04.000000', 'temperatura', 454.0000, 'ºC'),
	(199706, 120, '2014-02-15 00:17:05.000000', 'temperatura', 641.0000, 'ºC'),
	(199707, 120, '2014-02-15 00:17:06.000000', 'temperatura', 646.0000, 'ºC'),
	(199708, 120, '2014-02-15 00:17:07.000000', 'temperatura', 104.0000, 'ºC'),
	(199709, 120, '2014-02-15 00:17:08.000000', 'temperatura', 986.0000, 'ºC'),
	(199710, 120, '2014-02-15 00:17:09.000000', 'temperatura', 1016.0000, 'ºC'),
	(199711, 120, '2014-02-15 00:17:10.000000', 'temperatura', 924.0000, 'ºC'),
	(199712, 120, '2014-02-15 00:17:11.000000', 'temperatura', 371.0000, 'ºC'),
	(199713, 120, '2014-02-15 00:17:12.000000', 'temperatura', 283.0000, 'ºC'),
	(199714, 120, '2014-02-15 00:17:13.000000', 'temperatura', 301.0000, 'ºC'),
	(199715, 120, '2014-02-15 00:17:14.000000', 'temperatura', 660.0000, 'ºC'),
	(199716, 120, '2014-02-15 00:17:15.000000', 'temperatura', 1196.0000, 'ºC'),
	(199717, 120, '2014-02-15 00:17:16.000000', 'temperatura', 402.0000, 'ºC'),
	(199718, 120, '2014-02-15 00:17:17.000000', 'temperatura', 822.0000, 'ºC'),
	(199719, 120, '2014-02-15 00:17:18.000000', 'temperatura', 504.0000, 'ºC'),
	(199720, 120, '2014-02-15 00:17:19.000000', 'temperatura', 56.0000, 'ºC'),
	(199721, 120, '2014-02-15 00:17:20.000000', 'temperatura', 1168.0000, 'ºC'),
	(199722, 120, '2014-02-15 00:17:21.000000', 'temperatura', 871.0000, 'ºC'),
	(199723, 120, '2014-02-15 00:17:22.000000', 'temperatura', 854.0000, 'ºC'),
	(199724, 120, '2014-02-15 00:17:23.000000', 'temperatura', 454.0000, 'ºC'),
	(199725, 120, '2014-02-15 00:17:24.000000', 'temperatura', 912.0000, 'ºC'),
	(199726, 120, '2014-02-15 00:17:25.000000', 'temperatura', 796.0000, 'ºC'),
	(199727, 120, '2014-02-15 00:17:26.000000', 'temperatura', 47.0000, 'ºC'),
	(199728, 120, '2014-02-15 00:17:27.000000', 'temperatura', 245.0000, 'ºC'),
	(199729, 120, '2014-02-15 00:17:28.000000', 'temperatura', 1087.0000, 'ºC'),
	(199730, 120, '2014-02-15 00:17:29.000000', 'temperatura', 1097.0000, 'ºC'),
	(199731, 120, '2014-02-15 00:17:30.000000', 'temperatura', 1028.0000, 'ºC'),
	(199732, 120, '2014-02-15 00:17:31.000000', 'temperatura', 647.0000, 'ºC'),
	(199733, 120, '2014-02-15 00:17:32.000000', 'temperatura', 150.0000, 'ºC'),
	(199734, 120, '2014-02-15 00:17:33.000000', 'temperatura', 12.0000, 'ºC'),
	(199735, 120, '2014-02-15 00:17:34.000000', 'temperatura', 811.0000, 'ºC'),
	(199736, 120, '2014-02-15 00:17:35.000000', 'temperatura', 417.0000, 'ºC'),
	(199737, 120, '2014-02-15 00:17:36.000000', 'temperatura', 853.0000, 'ºC'),
	(199738, 120, '2014-02-15 00:17:37.000000', 'temperatura', 617.0000, 'ºC'),
	(199739, 120, '2014-02-15 00:17:38.000000', 'temperatura', 524.0000, 'ºC'),
	(199740, 120, '2014-02-15 00:17:39.000000', 'temperatura', 771.0000, 'ºC'),
	(199741, 120, '2014-02-15 00:17:40.000000', 'temperatura', 1081.0000, 'ºC'),
	(199742, 120, '2014-02-15 00:17:41.000000', 'temperatura', 696.0000, 'ºC'),
	(199743, 120, '2014-02-15 00:17:42.000000', 'temperatura', 236.0000, 'ºC'),
	(199744, 120, '2014-02-15 00:17:43.000000', 'temperatura', 292.0000, 'ºC'),
	(199745, 120, '2014-02-15 00:17:44.000000', 'temperatura', 753.0000, 'ºC'),
	(199746, 120, '2014-02-15 00:17:45.000000', 'temperatura', 492.0000, 'ºC'),
	(199747, 120, '2014-02-15 00:17:46.000000', 'temperatura', 198.0000, 'ºC'),
	(199748, 120, '2014-02-15 00:17:47.000000', 'temperatura', 714.0000, 'ºC'),
	(199749, 120, '2014-02-15 00:17:48.000000', 'temperatura', 580.0000, 'ºC'),
	(199750, 120, '2014-02-15 00:17:49.000000', 'temperatura', 756.0000, 'ºC'),
	(199751, 120, '2014-02-15 00:17:50.000000', 'temperatura', 839.0000, 'ºC'),
	(199752, 120, '2014-02-15 00:17:51.000000', 'temperatura', 730.0000, 'ºC'),
	(199753, 120, '2014-02-15 00:17:52.000000', 'temperatura', 1132.0000, 'ºC'),
	(199754, 120, '2014-02-15 00:17:53.000000', 'temperatura', 1071.0000, 'ºC'),
	(199755, 120, '2014-02-15 00:17:54.000000', 'temperatura', 760.0000, 'ºC'),
	(199756, 120, '2014-02-15 00:17:55.000000', 'temperatura', 585.0000, 'ºC'),
	(199757, 120, '2014-02-15 00:17:56.000000', 'temperatura', 649.0000, 'ºC'),
	(199758, 120, '2014-02-15 00:17:57.000000', 'temperatura', 288.0000, 'ºC'),
	(199759, 120, '2014-02-15 00:17:58.000000', 'temperatura', 696.0000, 'ºC'),
	(199760, 120, '2014-02-15 00:17:59.000000', 'temperatura', 215.0000, 'ºC'),
	(199761, 120, '2014-02-15 00:18:00.000000', 'temperatura', 186.0000, 'ºC'),
	(199762, 120, '2014-02-15 00:18:01.000000', 'temperatura', 288.0000, 'ºC'),
	(199763, 120, '2014-02-15 00:18:02.000000', 'temperatura', 880.0000, 'ºC'),
	(199764, 120, '2014-02-15 00:18:03.000000', 'temperatura', 1138.0000, 'ºC'),
	(199765, 120, '2014-02-15 00:18:04.000000', 'temperatura', 650.0000, 'ºC'),
	(199766, 120, '2014-02-15 00:18:05.000000', 'temperatura', 1038.0000, 'ºC'),
	(199767, 120, '2014-02-15 00:18:06.000000', 'temperatura', 838.0000, 'ºC'),
	(199768, 120, '2014-02-15 00:18:07.000000', 'temperatura', 1078.0000, 'ºC'),
	(199769, 120, '2014-02-15 00:18:08.000000', 'temperatura', 477.0000, 'ºC'),
	(199770, 120, '2014-02-15 00:18:09.000000', 'temperatura', 351.0000, 'ºC'),
	(199771, 120, '2014-02-15 00:18:10.000000', 'temperatura', 327.0000, 'ºC'),
	(199772, 120, '2014-02-15 00:18:11.000000', 'temperatura', 579.0000, 'ºC'),
	(199773, 120, '2014-02-15 00:18:12.000000', 'temperatura', 715.0000, 'ºC'),
	(199774, 120, '2014-02-15 00:18:13.000000', 'temperatura', 637.0000, 'ºC'),
	(199775, 120, '2014-02-15 00:18:14.000000', 'temperatura', 1043.0000, 'ºC'),
	(199776, 120, '2014-02-15 00:18:15.000000', 'temperatura', 904.0000, 'ºC'),
	(199777, 120, '2014-02-15 00:18:16.000000', 'temperatura', 193.0000, 'ºC'),
	(199778, 120, '2014-02-15 00:18:17.000000', 'temperatura', 653.0000, 'ºC'),
	(199779, 120, '2014-02-15 00:18:18.000000', 'temperatura', 286.0000, 'ºC'),
	(199780, 120, '2014-02-15 00:18:19.000000', 'temperatura', 672.0000, 'ºC'),
	(199781, 120, '2014-02-15 00:18:20.000000', 'temperatura', 103.0000, 'ºC'),
	(199782, 120, '2014-02-15 00:18:21.000000', 'temperatura', 897.0000, 'ºC'),
	(199783, 120, '2014-02-15 00:18:22.000000', 'temperatura', 577.0000, 'ºC'),
	(199784, 120, '2014-02-15 00:18:23.000000', 'temperatura', 196.0000, 'ºC'),
	(199785, 120, '2014-02-15 00:18:24.000000', 'temperatura', 447.0000, 'ºC'),
	(199786, 120, '2014-02-15 00:18:25.000000', 'temperatura', 449.0000, 'ºC'),
	(199787, 120, '2014-02-15 00:18:26.000000', 'temperatura', 903.0000, 'ºC'),
	(199788, 120, '2014-02-15 00:18:27.000000', 'temperatura', 768.0000, 'ºC'),
	(199789, 120, '2014-02-15 00:18:28.000000', 'temperatura', 1133.0000, 'ºC'),
	(199790, 120, '2014-02-15 00:18:29.000000', 'temperatura', 960.0000, 'ºC'),
	(199791, 120, '2014-02-15 00:18:30.000000', 'temperatura', 204.0000, 'ºC'),
	(199792, 120, '2014-02-15 00:18:31.000000', 'temperatura', 539.0000, 'ºC'),
	(199793, 120, '2014-02-15 00:18:32.000000', 'temperatura', 884.0000, 'ºC'),
	(199794, 120, '2014-02-15 00:18:33.000000', 'temperatura', 402.0000, 'ºC'),
	(199795, 120, '2014-02-15 00:18:34.000000', 'temperatura', 561.0000, 'ºC'),
	(199796, 120, '2014-02-15 00:18:35.000000', 'temperatura', 398.0000, 'ºC'),
	(199797, 120, '2014-02-15 00:18:36.000000', 'temperatura', 307.0000, 'ºC'),
	(199798, 120, '2014-02-15 00:18:37.000000', 'temperatura', 340.0000, 'ºC'),
	(199799, 120, '2014-02-15 00:18:38.000000', 'temperatura', 783.0000, 'ºC'),
	(199800, 120, '2014-02-15 00:18:39.000000', 'temperatura', 494.0000, 'ºC'),
	(199801, 120, '2014-02-15 00:18:40.000000', 'temperatura', 123.0000, 'ºC'),
	(199802, 120, '2014-02-15 00:18:41.000000', 'temperatura', 331.0000, 'ºC'),
	(199803, 120, '2014-02-15 00:18:42.000000', 'temperatura', 89.0000, 'ºC'),
	(199804, 120, '2014-02-15 00:18:43.000000', 'temperatura', 650.0000, 'ºC'),
	(199805, 120, '2014-02-15 00:18:44.000000', 'temperatura', 585.0000, 'ºC'),
	(199806, 120, '2014-02-15 00:18:45.000000', 'temperatura', 976.0000, 'ºC'),
	(199807, 120, '2014-02-15 00:18:46.000000', 'temperatura', 724.0000, 'ºC'),
	(199808, 120, '2014-02-15 00:18:47.000000', 'temperatura', 694.0000, 'ºC'),
	(199809, 120, '2014-02-15 00:18:48.000000', 'temperatura', 100.0000, 'ºC'),
	(199810, 120, '2014-02-15 00:18:49.000000', 'temperatura', 816.0000, 'ºC'),
	(199811, 120, '2014-02-15 00:18:50.000000', 'temperatura', 180.0000, 'ºC'),
	(199812, 120, '2014-02-15 00:18:51.000000', 'temperatura', 855.0000, 'ºC'),
	(199813, 120, '2014-02-15 00:18:52.000000', 'temperatura', 135.0000, 'ºC'),
	(199814, 120, '2014-02-15 00:18:53.000000', 'temperatura', 508.0000, 'ºC'),
	(199815, 120, '2014-02-15 00:18:54.000000', 'temperatura', 938.0000, 'ºC'),
	(199816, 120, '2014-02-15 00:18:55.000000', 'temperatura', 767.0000, 'ºC'),
	(199817, 120, '2014-02-15 00:18:56.000000', 'temperatura', 1019.0000, 'ºC'),
	(199818, 120, '2014-02-15 00:18:57.000000', 'temperatura', 398.0000, 'ºC'),
	(199819, 120, '2014-02-15 00:18:58.000000', 'temperatura', 130.0000, 'ºC'),
	(199820, 120, '2014-02-15 00:18:59.000000', 'temperatura', 657.0000, 'ºC'),
	(199821, 120, '2014-02-15 00:19:00.000000', 'temperatura', 494.0000, 'ºC'),
	(199822, 120, '2014-02-15 00:19:01.000000', 'temperatura', 502.0000, 'ºC'),
	(199823, 120, '2014-02-15 00:19:02.000000', 'temperatura', 1029.0000, 'ºC'),
	(199824, 120, '2014-02-15 00:19:03.000000', 'temperatura', 39.0000, 'ºC'),
	(199825, 120, '2014-02-15 00:19:04.000000', 'temperatura', 710.0000, 'ºC'),
	(199826, 120, '2014-02-15 00:19:05.000000', 'temperatura', 1033.0000, 'ºC'),
	(199827, 120, '2014-02-15 00:19:06.000000', 'temperatura', 633.0000, 'ºC'),
	(199828, 120, '2014-02-15 00:19:07.000000', 'temperatura', 68.0000, 'ºC'),
	(199829, 120, '2014-02-15 00:19:08.000000', 'temperatura', 840.0000, 'ºC'),
	(199830, 120, '2014-02-15 00:19:09.000000', 'temperatura', 400.0000, 'ºC'),
	(199831, 120, '2014-02-15 00:19:10.000000', 'temperatura', 677.0000, 'ºC'),
	(199832, 120, '2014-02-15 00:19:11.000000', 'temperatura', 987.0000, 'ºC'),
	(199833, 120, '2014-02-15 00:19:12.000000', 'temperatura', 504.0000, 'ºC'),
	(199834, 120, '2014-02-15 00:19:13.000000', 'temperatura', 759.0000, 'ºC'),
	(199835, 120, '2014-02-15 00:19:14.000000', 'temperatura', 1085.0000, 'ºC'),
	(199836, 120, '2014-02-15 00:19:15.000000', 'temperatura', 748.0000, 'ºC'),
	(199837, 120, '2014-02-15 00:19:16.000000', 'temperatura', 486.0000, 'ºC'),
	(199838, 120, '2014-02-15 00:19:17.000000', 'temperatura', 186.0000, 'ºC'),
	(199839, 120, '2014-02-15 00:19:18.000000', 'temperatura', 674.0000, 'ºC'),
	(199840, 120, '2014-02-15 00:19:19.000000', 'temperatura', 411.0000, 'ºC'),
	(199841, 120, '2014-02-15 00:19:20.000000', 'temperatura', 33.0000, 'ºC'),
	(199842, 120, '2014-02-15 00:19:21.000000', 'temperatura', 133.0000, 'ºC'),
	(199843, 120, '2014-02-15 00:19:22.000000', 'temperatura', 565.0000, 'ºC'),
	(199844, 120, '2014-02-15 00:19:23.000000', 'temperatura', 29.0000, 'ºC'),
	(199845, 120, '2014-02-15 00:19:24.000000', 'temperatura', 849.0000, 'ºC'),
	(199846, 120, '2014-02-15 00:19:25.000000', 'temperatura', 558.0000, 'ºC'),
	(199847, 120, '2014-02-15 00:19:26.000000', 'temperatura', 245.0000, 'ºC'),
	(199848, 120, '2014-02-15 00:19:27.000000', 'temperatura', 751.0000, 'ºC'),
	(199849, 120, '2014-02-15 00:19:28.000000', 'temperatura', 621.0000, 'ºC'),
	(199850, 120, '2014-02-15 00:19:29.000000', 'temperatura', 851.0000, 'ºC'),
	(199851, 120, '2014-02-15 00:19:30.000000', 'temperatura', 1193.0000, 'ºC'),
	(199852, 120, '2014-02-15 00:19:31.000000', 'temperatura', 1013.0000, 'ºC'),
	(199853, 120, '2014-02-15 00:19:32.000000', 'temperatura', 285.0000, 'ºC'),
	(199854, 120, '2014-02-15 00:19:33.000000', 'temperatura', 787.0000, 'ºC'),
	(199855, 120, '2014-02-15 00:19:34.000000', 'temperatura', 681.0000, 'ºC'),
	(199856, 120, '2014-02-15 00:19:35.000000', 'temperatura', 1044.0000, 'ºC'),
	(199857, 120, '2014-02-15 00:19:36.000000', 'temperatura', 779.0000, 'ºC'),
	(199858, 120, '2014-02-15 00:19:37.000000', 'temperatura', 764.0000, 'ºC'),
	(199859, 120, '2014-02-15 00:19:38.000000', 'temperatura', 282.0000, 'ºC'),
	(199860, 120, '2014-02-15 00:19:39.000000', 'temperatura', 321.0000, 'ºC'),
	(199861, 120, '2014-02-15 00:19:40.000000', 'temperatura', 757.0000, 'ºC'),
	(199862, 120, '2014-02-15 00:19:41.000000', 'temperatura', 425.0000, 'ºC'),
	(199863, 120, '2014-02-15 00:19:42.000000', 'temperatura', 1051.0000, 'ºC'),
	(199864, 120, '2014-02-15 00:19:43.000000', 'temperatura', 383.0000, 'ºC'),
	(199865, 120, '2014-02-15 00:19:44.000000', 'temperatura', 1162.0000, 'ºC'),
	(199866, 120, '2014-02-15 00:19:45.000000', 'temperatura', 1061.0000, 'ºC'),
	(199867, 120, '2014-02-15 00:19:46.000000', 'temperatura', 622.0000, 'ºC'),
	(199868, 120, '2014-02-15 00:19:47.000000', 'temperatura', 1125.0000, 'ºC'),
	(199869, 120, '2014-02-15 00:19:48.000000', 'temperatura', 159.0000, 'ºC'),
	(199870, 120, '2014-02-15 00:19:49.000000', 'temperatura', 1019.0000, 'ºC'),
	(199871, 120, '2014-02-15 00:19:50.000000', 'temperatura', 1022.0000, 'ºC'),
	(199872, 120, '2014-02-15 00:19:51.000000', 'temperatura', 852.0000, 'ºC'),
	(199873, 120, '2014-02-15 00:19:52.000000', 'temperatura', 1195.0000, 'ºC'),
	(199874, 120, '2014-02-15 00:19:53.000000', 'temperatura', 1019.0000, 'ºC'),
	(199875, 120, '2014-02-15 00:19:54.000000', 'temperatura', 312.0000, 'ºC'),
	(199876, 120, '2014-02-15 00:19:55.000000', 'temperatura', 902.0000, 'ºC'),
	(199877, 120, '2014-02-15 00:19:56.000000', 'temperatura', 1176.0000, 'ºC'),
	(199878, 120, '2014-02-15 00:19:57.000000', 'temperatura', 773.0000, 'ºC'),
	(199879, 120, '2014-02-15 00:19:58.000000', 'temperatura', 337.0000, 'ºC'),
	(199880, 120, '2014-02-15 00:19:59.000000', 'temperatura', 569.0000, 'ºC'),
	(199881, 120, '2014-02-15 00:20:00.000000', 'temperatura', 633.0000, 'ºC'),
	(199882, 120, '2014-02-15 00:20:01.000000', 'temperatura', 260.0000, 'ºC'),
	(199883, 120, '2014-02-15 00:20:02.000000', 'temperatura', 601.0000, 'ºC'),
	(199884, 120, '2014-02-15 00:20:03.000000', 'temperatura', 1025.0000, 'ºC'),
	(199885, 120, '2014-02-15 00:20:04.000000', 'temperatura', 922.0000, 'ºC'),
	(199886, 120, '2014-02-15 00:20:05.000000', 'temperatura', 335.0000, 'ºC'),
	(199887, 120, '2014-02-15 00:20:06.000000', 'temperatura', 111.0000, 'ºC'),
	(199888, 120, '2014-02-15 00:20:07.000000', 'temperatura', 749.0000, 'ºC'),
	(199889, 120, '2014-02-15 00:20:08.000000', 'temperatura', 1011.0000, 'ºC'),
	(199890, 120, '2014-02-15 00:20:09.000000', 'temperatura', 411.0000, 'ºC'),
	(199891, 120, '2014-02-15 00:20:10.000000', 'temperatura', 222.0000, 'ºC'),
	(199892, 120, '2014-02-15 00:20:11.000000', 'temperatura', 1078.0000, 'ºC'),
	(199893, 120, '2014-02-15 00:20:12.000000', 'temperatura', 1125.0000, 'ºC'),
	(199894, 120, '2014-02-15 00:20:13.000000', 'temperatura', 1190.0000, 'ºC'),
	(199895, 120, '2014-02-15 00:20:14.000000', 'temperatura', 174.0000, 'ºC'),
	(199896, 120, '2014-02-15 00:20:15.000000', 'temperatura', 902.0000, 'ºC'),
	(199897, 120, '2014-02-15 00:20:16.000000', 'temperatura', 390.0000, 'ºC'),
	(199898, 120, '2014-02-15 00:20:17.000000', 'temperatura', 443.0000, 'ºC'),
	(199899, 120, '2014-02-15 00:20:18.000000', 'temperatura', 1047.0000, 'ºC'),
	(199900, 120, '2014-02-15 00:20:19.000000', 'temperatura', 306.0000, 'ºC'),
	(199901, 120, '2014-02-15 00:20:20.000000', 'temperatura', 790.0000, 'ºC'),
	(199902, 120, '2014-02-15 00:20:21.000000', 'temperatura', 631.0000, 'ºC'),
	(199903, 120, '2014-02-15 00:20:22.000000', 'temperatura', 788.0000, 'ºC'),
	(199904, 120, '2014-02-15 00:20:23.000000', 'temperatura', 846.0000, 'ºC'),
	(199905, 120, '2014-02-15 00:20:24.000000', 'temperatura', 666.0000, 'ºC'),
	(199906, 120, '2014-02-15 00:20:25.000000', 'temperatura', 791.0000, 'ºC'),
	(199907, 120, '2014-02-15 00:20:26.000000', 'temperatura', 759.0000, 'ºC'),
	(199908, 120, '2014-02-15 00:20:27.000000', 'temperatura', 222.0000, 'ºC'),
	(199909, 120, '2014-02-15 00:20:28.000000', 'temperatura', 32.0000, 'ºC'),
	(199910, 120, '2014-02-15 00:20:29.000000', 'temperatura', 697.0000, 'ºC'),
	(199911, 120, '2014-02-15 00:20:30.000000', 'temperatura', 988.0000, 'ºC'),
	(199912, 120, '2014-02-15 00:20:31.000000', 'temperatura', 452.0000, 'ºC'),
	(199913, 120, '2014-02-15 00:20:32.000000', 'temperatura', 494.0000, 'ºC'),
	(199914, 120, '2014-02-15 00:20:33.000000', 'temperatura', 1116.0000, 'ºC'),
	(199915, 120, '2014-02-15 00:20:34.000000', 'temperatura', 496.0000, 'ºC'),
	(199916, 120, '2014-02-15 00:20:35.000000', 'temperatura', 335.0000, 'ºC'),
	(199917, 120, '2014-02-15 00:20:36.000000', 'temperatura', 188.0000, 'ºC'),
	(199918, 120, '2014-02-15 00:20:37.000000', 'temperatura', 1133.0000, 'ºC'),
	(199919, 120, '2014-02-15 00:20:38.000000', 'temperatura', 302.0000, 'ºC'),
	(199920, 120, '2014-02-15 00:20:39.000000', 'temperatura', 513.0000, 'ºC'),
	(199921, 120, '2014-02-15 00:20:40.000000', 'temperatura', 459.0000, 'ºC'),
	(199922, 120, '2014-02-15 00:20:41.000000', 'temperatura', 755.0000, 'ºC'),
	(199923, 120, '2014-02-15 00:20:42.000000', 'temperatura', 1199.0000, 'ºC'),
	(199924, 120, '2014-02-15 00:20:43.000000', 'temperatura', 131.0000, 'ºC'),
	(199925, 120, '2014-02-15 00:20:44.000000', 'temperatura', 660.0000, 'ºC'),
	(199926, 120, '2014-02-15 00:20:45.000000', 'temperatura', 508.0000, 'ºC'),
	(199927, 120, '2014-02-15 00:20:46.000000', 'temperatura', 560.0000, 'ºC'),
	(199928, 120, '2014-02-15 00:20:47.000000', 'temperatura', 77.0000, 'ºC'),
	(199929, 120, '2014-02-15 00:20:48.000000', 'temperatura', 1107.0000, 'ºC'),
	(199930, 120, '2014-02-15 00:20:49.000000', 'temperatura', 502.0000, 'ºC'),
	(199931, 120, '2014-02-15 00:20:50.000000', 'temperatura', 390.0000, 'ºC'),
	(199932, 120, '2014-02-15 00:20:51.000000', 'temperatura', 445.0000, 'ºC'),
	(199933, 120, '2014-02-15 00:20:52.000000', 'temperatura', 1057.0000, 'ºC'),
	(199934, 120, '2014-02-15 00:20:53.000000', 'temperatura', 349.0000, 'ºC'),
	(199935, 120, '2014-02-15 00:20:54.000000', 'temperatura', 976.0000, 'ºC'),
	(199936, 120, '2014-02-15 00:20:55.000000', 'temperatura', 233.0000, 'ºC'),
	(199937, 120, '2014-02-15 00:20:56.000000', 'temperatura', 638.0000, 'ºC'),
	(199938, 120, '2014-02-15 00:20:57.000000', 'temperatura', 91.0000, 'ºC'),
	(199939, 120, '2014-02-15 00:20:58.000000', 'temperatura', 942.0000, 'ºC'),
	(199940, 120, '2014-02-15 00:20:59.000000', 'temperatura', 836.0000, 'ºC'),
	(199941, 120, '2014-02-15 00:21:00.000000', 'temperatura', 156.0000, 'ºC'),
	(199942, 120, '2014-02-15 00:21:01.000000', 'temperatura', 673.0000, 'ºC'),
	(199943, 120, '2014-02-15 00:21:02.000000', 'temperatura', 495.0000, 'ºC'),
	(199944, 120, '2014-02-15 00:21:03.000000', 'temperatura', 459.0000, 'ºC'),
	(199945, 120, '2014-02-15 00:21:04.000000', 'temperatura', 809.0000, 'ºC'),
	(199946, 120, '2014-02-15 00:21:05.000000', 'temperatura', 271.0000, 'ºC'),
	(199947, 120, '2014-02-15 00:21:06.000000', 'temperatura', 126.0000, 'ºC'),
	(199948, 120, '2014-02-15 00:21:07.000000', 'temperatura', 1019.0000, 'ºC'),
	(199949, 120, '2014-02-15 00:21:08.000000', 'temperatura', 1118.0000, 'ºC'),
	(199950, 120, '2014-02-15 00:21:09.000000', 'temperatura', 131.0000, 'ºC'),
	(199951, 120, '2014-02-15 00:21:10.000000', 'temperatura', 902.0000, 'ºC'),
	(199952, 120, '2014-02-15 00:21:11.000000', 'temperatura', 519.0000, 'ºC'),
	(199953, 120, '2014-02-15 00:21:12.000000', 'temperatura', 1089.0000, 'ºC'),
	(199954, 120, '2014-02-15 00:21:13.000000', 'temperatura', 289.0000, 'ºC'),
	(199955, 120, '2014-02-15 00:21:14.000000', 'temperatura', 576.0000, 'ºC'),
	(199956, 120, '2014-02-15 00:21:15.000000', 'temperatura', 817.0000, 'ºC'),
	(199957, 120, '2014-02-15 00:21:16.000000', 'temperatura', 1155.0000, 'ºC'),
	(199958, 120, '2014-02-15 00:21:17.000000', 'temperatura', 926.0000, 'ºC'),
	(199959, 120, '2014-02-15 00:21:18.000000', 'temperatura', 1166.0000, 'ºC'),
	(199960, 120, '2014-02-15 00:21:19.000000', 'temperatura', 653.0000, 'ºC'),
	(199961, 120, '2014-02-15 00:21:20.000000', 'temperatura', 965.0000, 'ºC'),
	(199962, 120, '2014-02-15 00:21:21.000000', 'temperatura', 466.0000, 'ºC'),
	(199963, 120, '2014-02-15 00:21:22.000000', 'temperatura', 635.0000, 'ºC'),
	(199964, 120, '2014-02-15 00:21:23.000000', 'temperatura', 577.0000, 'ºC'),
	(199965, 120, '2014-02-15 00:21:24.000000', 'temperatura', 981.0000, 'ºC'),
	(199966, 120, '2014-02-15 00:21:25.000000', 'temperatura', 775.0000, 'ºC'),
	(199967, 120, '2014-02-15 00:21:26.000000', 'temperatura', 932.0000, 'ºC'),
	(199968, 120, '2014-02-15 00:21:27.000000', 'temperatura', 1135.0000, 'ºC'),
	(199969, 120, '2014-02-15 00:21:28.000000', 'temperatura', 481.0000, 'ºC'),
	(199970, 120, '2014-02-15 00:21:29.000000', 'temperatura', 198.0000, 'ºC'),
	(199971, 120, '2014-02-15 00:21:30.000000', 'temperatura', 748.0000, 'ºC'),
	(199972, 120, '2014-02-15 00:21:31.000000', 'temperatura', 749.0000, 'ºC'),
	(199973, 120, '2014-02-15 00:21:32.000000', 'temperatura', 299.0000, 'ºC'),
	(199974, 120, '2014-02-15 00:21:33.000000', 'temperatura', 449.0000, 'ºC'),
	(199975, 120, '2014-02-15 00:21:34.000000', 'temperatura', 147.0000, 'ºC'),
	(199976, 120, '2014-02-15 00:21:35.000000', 'temperatura', 591.0000, 'ºC'),
	(199977, 120, '2014-02-15 00:21:36.000000', 'temperatura', 113.0000, 'ºC'),
	(199978, 120, '2014-02-15 00:21:37.000000', 'temperatura', 1194.0000, 'ºC'),
	(199979, 120, '2014-02-15 00:21:38.000000', 'temperatura', 832.0000, 'ºC'),
	(199980, 120, '2014-02-15 00:21:39.000000', 'temperatura', 576.0000, 'ºC'),
	(199981, 120, '2014-02-15 00:21:40.000000', 'temperatura', 386.0000, 'ºC'),
	(199982, 120, '2014-02-15 00:21:41.000000', 'temperatura', 203.0000, 'ºC'),
	(199983, 120, '2014-02-15 00:21:42.000000', 'temperatura', 1057.0000, 'ºC'),
	(199984, 120, '2014-02-15 00:21:43.000000', 'temperatura', 1078.0000, 'ºC'),
	(199985, 120, '2014-02-15 00:21:44.000000', 'temperatura', 1020.0000, 'ºC'),
	(199986, 120, '2014-02-15 00:21:45.000000', 'temperatura', 667.0000, 'ºC'),
	(199987, 120, '2014-02-15 00:21:46.000000', 'temperatura', 274.0000, 'ºC'),
	(199988, 120, '2014-02-15 00:21:47.000000', 'temperatura', 571.0000, 'ºC'),
	(199989, 120, '2014-02-15 00:21:48.000000', 'temperatura', 833.0000, 'ºC'),
	(199990, 120, '2014-02-15 00:21:49.000000', 'temperatura', 53.0000, 'ºC'),
	(199991, 120, '2014-02-15 00:21:50.000000', 'temperatura', 166.0000, 'ºC'),
	(199992, 120, '2014-02-15 00:21:51.000000', 'temperatura', 671.0000, 'ºC'),
	(199993, 120, '2014-02-15 00:21:52.000000', 'temperatura', 457.0000, 'ºC'),
	(199994, 120, '2014-02-15 00:21:53.000000', 'temperatura', 273.0000, 'ºC'),
	(199995, 120, '2014-02-15 00:21:54.000000', 'temperatura', 1193.0000, 'ºC'),
	(199996, 120, '2014-02-15 00:21:55.000000', 'temperatura', 348.0000, 'ºC'),
	(199997, 120, '2014-02-15 00:21:56.000000', 'temperatura', 561.0000, 'ºC'),
	(199998, 120, '2014-02-15 00:21:57.000000', 'temperatura', 560.0000, 'ºC'),
	(199999, 120, '2014-02-15 00:21:58.000000', 'temperatura', 1118.0000, 'ºC'),
	(200000, 120, '2014-02-15 00:21:59.000000', 'temperatura', 310.0000, 'ºC'),
	(200001, 120, '2014-02-15 00:22:00.000000', 'temperatura', 595.0000, 'ºC'),
	(200002, 120, '2014-02-15 00:22:01.000000', 'temperatura', 849.0000, 'ºC'),
	(200003, 120, '2014-02-15 00:22:02.000000', 'temperatura', 57.0000, 'ºC'),
	(200004, 120, '2014-02-15 00:22:03.000000', 'temperatura', 142.0000, 'ºC'),
	(200005, 120, '2014-02-15 00:22:04.000000', 'temperatura', 538.0000, 'ºC'),
	(200006, 120, '2014-02-15 00:22:05.000000', 'temperatura', 1063.0000, 'ºC'),
	(200007, 120, '2014-02-15 00:22:06.000000', 'temperatura', 103.0000, 'ºC'),
	(200008, 120, '2014-02-15 00:22:07.000000', 'temperatura', 925.0000, 'ºC'),
	(200009, 120, '2014-02-15 00:22:08.000000', 'temperatura', 716.0000, 'ºC'),
	(200010, 120, '2014-02-15 00:22:09.000000', 'temperatura', 805.0000, 'ºC'),
	(200011, 120, '2014-02-15 00:22:10.000000', 'temperatura', 678.0000, 'ºC'),
	(200012, 120, '2014-02-15 00:22:11.000000', 'temperatura', 976.0000, 'ºC'),
	(200013, 120, '2014-02-15 00:22:12.000000', 'temperatura', 448.0000, 'ºC'),
	(200014, 120, '2014-02-15 00:22:13.000000', 'temperatura', 510.0000, 'ºC'),
	(200015, 120, '2014-02-15 00:22:14.000000', 'temperatura', 8.0000, 'ºC'),
	(200016, 120, '2014-02-15 00:22:15.000000', 'temperatura', 909.0000, 'ºC'),
	(200017, 120, '2014-02-15 00:22:16.000000', 'temperatura', 921.0000, 'ºC'),
	(200018, 120, '2014-02-15 00:22:17.000000', 'temperatura', 678.0000, 'ºC'),
	(200019, 120, '2014-02-15 00:22:18.000000', 'temperatura', 627.0000, 'ºC'),
	(200020, 120, '2014-02-15 00:22:19.000000', 'temperatura', 1104.0000, 'ºC'),
	(200021, 120, '2014-02-15 00:22:20.000000', 'temperatura', 37.0000, 'ºC'),
	(200022, 120, '2014-02-15 00:22:21.000000', 'temperatura', 475.0000, 'ºC'),
	(200023, 120, '2014-02-15 00:22:22.000000', 'temperatura', 1063.0000, 'ºC'),
	(200024, 120, '2014-02-15 00:22:23.000000', 'temperatura', 293.0000, 'ºC'),
	(200025, 120, '2014-02-15 00:22:24.000000', 'temperatura', 675.0000, 'ºC'),
	(200026, 120, '2014-02-15 00:22:25.000000', 'temperatura', 98.0000, 'ºC'),
	(200027, 120, '2014-02-15 00:22:26.000000', 'temperatura', 865.0000, 'ºC'),
	(200028, 120, '2014-02-15 00:22:27.000000', 'temperatura', 431.0000, 'ºC'),
	(200029, 120, '2014-02-15 00:22:28.000000', 'temperatura', 762.0000, 'ºC'),
	(200030, 120, '2014-02-15 00:22:29.000000', 'temperatura', 116.0000, 'ºC'),
	(200031, 120, '2014-02-15 00:22:30.000000', 'temperatura', 694.0000, 'ºC'),
	(200032, 120, '2014-02-15 00:22:31.000000', 'temperatura', 723.0000, 'ºC'),
	(200033, 120, '2014-02-15 00:22:32.000000', 'temperatura', 334.0000, 'ºC'),
	(200034, 120, '2014-02-15 00:22:33.000000', 'temperatura', 702.0000, 'ºC'),
	(200035, 120, '2014-02-15 00:22:34.000000', 'temperatura', 107.0000, 'ºC'),
	(200036, 120, '2014-02-15 00:22:35.000000', 'temperatura', 831.0000, 'ºC'),
	(200037, 120, '2014-02-15 00:22:36.000000', 'temperatura', 233.0000, 'ºC'),
	(200038, 120, '2014-02-15 00:22:37.000000', 'temperatura', 1072.0000, 'ºC'),
	(200039, 120, '2014-02-15 00:22:38.000000', 'temperatura', 1064.0000, 'ºC'),
	(200040, 120, '2014-02-15 00:22:39.000000', 'temperatura', 902.0000, 'ºC'),
	(200041, 120, '2014-02-15 00:22:40.000000', 'temperatura', 119.0000, 'ºC'),
	(200042, 120, '2014-02-15 00:22:41.000000', 'temperatura', 290.0000, 'ºC'),
	(200043, 120, '2014-02-15 00:22:42.000000', 'temperatura', 1093.0000, 'ºC'),
	(200044, 120, '2014-02-15 00:22:43.000000', 'temperatura', 997.0000, 'ºC'),
	(200045, 120, '2014-02-15 00:22:44.000000', 'temperatura', 504.0000, 'ºC'),
	(200046, 120, '2014-02-15 00:22:45.000000', 'temperatura', 731.0000, 'ºC'),
	(200047, 120, '2014-02-15 00:22:46.000000', 'temperatura', 945.0000, 'ºC'),
	(200048, 120, '2014-02-15 00:22:47.000000', 'temperatura', 131.0000, 'ºC'),
	(200049, 120, '2014-02-15 00:22:48.000000', 'temperatura', 222.0000, 'ºC'),
	(200050, 120, '2014-02-15 00:22:49.000000', 'temperatura', 715.0000, 'ºC'),
	(200051, 120, '2014-02-15 00:22:50.000000', 'temperatura', 509.0000, 'ºC'),
	(200052, 120, '2014-02-15 00:22:51.000000', 'temperatura', 402.0000, 'ºC'),
	(200053, 120, '2014-02-15 00:22:52.000000', 'temperatura', 482.0000, 'ºC'),
	(200054, 120, '2014-02-15 00:22:53.000000', 'temperatura', 4.0000, 'ºC'),
	(200055, 120, '2014-02-15 00:22:54.000000', 'temperatura', 975.0000, 'ºC'),
	(200056, 120, '2014-02-15 00:22:55.000000', 'temperatura', 63.0000, 'ºC'),
	(200057, 120, '2014-02-15 00:22:56.000000', 'temperatura', 992.0000, 'ºC'),
	(200058, 120, '2014-02-15 00:22:57.000000', 'temperatura', 1169.0000, 'ºC'),
	(200059, 120, '2014-02-15 00:22:58.000000', 'temperatura', 471.0000, 'ºC'),
	(200060, 120, '2014-02-15 00:22:59.000000', 'temperatura', 49.0000, 'ºC'),
	(200061, 120, '2014-02-15 00:23:00.000000', 'temperatura', 32.0000, 'ºC'),
	(200062, 120, '2014-02-15 00:23:01.000000', 'temperatura', 14.0000, 'ºC'),
	(200063, 120, '2014-02-15 00:23:02.000000', 'temperatura', 1174.0000, 'ºC'),
	(200064, 120, '2014-02-15 00:23:03.000000', 'temperatura', 1030.0000, 'ºC'),
	(200065, 120, '2014-02-15 00:23:04.000000', 'temperatura', 430.0000, 'ºC'),
	(200066, 120, '2014-02-15 00:23:05.000000', 'temperatura', 257.0000, 'ºC'),
	(200067, 120, '2014-02-15 00:23:06.000000', 'temperatura', 1198.0000, 'ºC'),
	(200068, 120, '2014-02-15 00:23:07.000000', 'temperatura', 418.0000, 'ºC'),
	(200069, 120, '2014-02-15 00:23:08.000000', 'temperatura', 899.0000, 'ºC'),
	(200070, 120, '2014-02-15 00:23:09.000000', 'temperatura', 840.0000, 'ºC'),
	(200071, 120, '2014-02-15 00:23:10.000000', 'temperatura', 305.0000, 'ºC'),
	(200072, 120, '2014-02-15 00:23:11.000000', 'temperatura', 202.0000, 'ºC'),
	(200073, 120, '2014-02-15 00:23:12.000000', 'temperatura', 99.0000, 'ºC'),
	(200074, 120, '2014-02-15 00:23:13.000000', 'temperatura', 1089.0000, 'ºC'),
	(200075, 120, '2014-02-15 00:23:14.000000', 'temperatura', 349.0000, 'ºC'),
	(200076, 120, '2014-02-15 00:23:15.000000', 'temperatura', 878.0000, 'ºC'),
	(200077, 120, '2014-02-15 00:23:16.000000', 'temperatura', 945.0000, 'ºC'),
	(200078, 120, '2014-02-15 00:23:17.000000', 'temperatura', 889.0000, 'ºC'),
	(200079, 120, '2014-02-15 00:23:18.000000', 'temperatura', 412.0000, 'ºC'),
	(200080, 120, '2014-02-15 00:23:19.000000', 'temperatura', 595.0000, 'ºC'),
	(200081, 120, '2014-02-15 00:23:20.000000', 'temperatura', 538.0000, 'ºC'),
	(200082, 120, '2014-02-15 00:23:21.000000', 'temperatura', 904.0000, 'ºC'),
	(200083, 120, '2014-02-15 00:23:22.000000', 'temperatura', 507.0000, 'ºC'),
	(200084, 120, '2014-02-15 00:23:23.000000', 'temperatura', 1024.0000, 'ºC'),
	(200085, 120, '2014-02-15 00:23:24.000000', 'temperatura', 1198.0000, 'ºC'),
	(200086, 120, '2014-02-15 00:23:25.000000', 'temperatura', 519.0000, 'ºC'),
	(200087, 120, '2014-02-15 00:23:26.000000', 'temperatura', 203.0000, 'ºC'),
	(200088, 120, '2014-02-15 00:23:27.000000', 'temperatura', 659.0000, 'ºC'),
	(200089, 120, '2014-02-15 00:23:28.000000', 'temperatura', 286.0000, 'ºC'),
	(200090, 120, '2014-02-15 00:23:29.000000', 'temperatura', 653.0000, 'ºC'),
	(200091, 120, '2014-02-15 00:23:30.000000', 'temperatura', 8.0000, 'ºC'),
	(200092, 120, '2014-02-15 00:23:31.000000', 'temperatura', 479.0000, 'ºC'),
	(200093, 120, '2014-02-15 00:23:32.000000', 'temperatura', 1175.0000, 'ºC'),
	(200094, 120, '2014-02-15 00:23:33.000000', 'temperatura', 836.0000, 'ºC'),
	(200095, 120, '2014-02-15 00:23:34.000000', 'temperatura', 657.0000, 'ºC'),
	(200096, 120, '2014-02-15 00:23:35.000000', 'temperatura', 778.0000, 'ºC'),
	(200097, 120, '2014-02-15 00:23:36.000000', 'temperatura', 720.0000, 'ºC'),
	(200098, 120, '2014-02-15 00:23:37.000000', 'temperatura', 66.0000, 'ºC'),
	(200099, 120, '2014-02-15 00:23:38.000000', 'temperatura', 570.0000, 'ºC'),
	(200100, 120, '2014-02-15 00:23:39.000000', 'temperatura', 251.0000, 'ºC'),
	(200101, 120, '2014-02-15 00:23:40.000000', 'temperatura', 749.0000, 'ºC'),
	(200102, 120, '2014-02-15 00:23:41.000000', 'temperatura', 589.0000, 'ºC'),
	(200103, 120, '2014-02-15 00:23:42.000000', 'temperatura', 700.0000, 'ºC'),
	(200104, 120, '2014-02-15 00:23:43.000000', 'temperatura', 533.0000, 'ºC'),
	(200105, 120, '2014-02-15 00:23:44.000000', 'temperatura', 564.0000, 'ºC'),
	(200106, 120, '2014-02-15 00:23:45.000000', 'temperatura', 23.0000, 'ºC'),
	(200107, 120, '2014-02-15 00:23:46.000000', 'temperatura', 823.0000, 'ºC'),
	(200108, 120, '2014-02-15 00:23:47.000000', 'temperatura', 445.0000, 'ºC'),
	(200109, 120, '2014-02-15 00:23:48.000000', 'temperatura', 959.0000, 'ºC'),
	(200110, 120, '2014-02-15 00:23:49.000000', 'temperatura', 1059.0000, 'ºC'),
	(200111, 120, '2014-02-15 00:23:50.000000', 'temperatura', 20.0000, 'ºC'),
	(200112, 120, '2014-02-15 00:23:51.000000', 'temperatura', 522.0000, 'ºC'),
	(200113, 120, '2014-02-15 00:23:52.000000', 'temperatura', 151.0000, 'ºC'),
	(200114, 120, '2014-02-15 00:23:53.000000', 'temperatura', 389.0000, 'ºC'),
	(200115, 120, '2014-02-15 00:23:54.000000', 'temperatura', 294.0000, 'ºC'),
	(200116, 120, '2014-02-15 00:23:55.000000', 'temperatura', 301.0000, 'ºC'),
	(200117, 120, '2014-02-15 00:23:56.000000', 'temperatura', 626.0000, 'ºC'),
	(200118, 120, '2014-02-15 00:23:57.000000', 'temperatura', 1025.0000, 'ºC'),
	(200119, 120, '2014-02-15 00:23:58.000000', 'temperatura', 851.0000, 'ºC'),
	(200120, 120, '2014-02-15 00:23:59.000000', 'temperatura', 1177.0000, 'ºC'),
	(200121, 120, '2014-02-15 00:24:00.000000', 'temperatura', 935.0000, 'ºC'),
	(200122, 120, '2014-02-15 00:24:01.000000', 'temperatura', 1146.0000, 'ºC'),
	(200123, 120, '2014-02-15 00:24:02.000000', 'temperatura', 522.0000, 'ºC'),
	(200124, 120, '2014-02-15 00:24:03.000000', 'temperatura', 373.0000, 'ºC'),
	(200125, 120, '2014-02-15 00:24:04.000000', 'temperatura', 302.0000, 'ºC'),
	(200126, 120, '2014-02-15 00:24:05.000000', 'temperatura', 388.0000, 'ºC'),
	(200127, 120, '2014-02-15 00:24:06.000000', 'temperatura', 1037.0000, 'ºC'),
	(200128, 120, '2014-02-15 00:24:07.000000', 'temperatura', 422.0000, 'ºC'),
	(200129, 120, '2014-02-15 00:24:08.000000', 'temperatura', 198.0000, 'ºC'),
	(200130, 120, '2014-02-15 00:24:09.000000', 'temperatura', 926.0000, 'ºC'),
	(200131, 120, '2014-02-15 00:24:10.000000', 'temperatura', 434.0000, 'ºC'),
	(200132, 120, '2014-02-15 00:24:11.000000', 'temperatura', 595.0000, 'ºC'),
	(200133, 120, '2014-02-15 00:24:12.000000', 'temperatura', 473.0000, 'ºC'),
	(200134, 120, '2014-02-15 00:24:13.000000', 'temperatura', 580.0000, 'ºC'),
	(200135, 120, '2014-02-15 00:24:14.000000', 'temperatura', 280.0000, 'ºC'),
	(200136, 120, '2014-02-15 00:24:15.000000', 'temperatura', 862.0000, 'ºC'),
	(200137, 120, '2014-02-15 00:24:16.000000', 'temperatura', 1071.0000, 'ºC'),
	(200138, 120, '2014-02-15 00:24:17.000000', 'temperatura', 369.0000, 'ºC'),
	(200139, 120, '2014-02-15 00:24:18.000000', 'temperatura', 1033.0000, 'ºC'),
	(200140, 120, '2014-02-15 00:24:19.000000', 'temperatura', 460.0000, 'ºC'),
	(200141, 120, '2014-02-15 00:24:20.000000', 'temperatura', 400.0000, 'ºC'),
	(200142, 120, '2014-02-15 00:24:21.000000', 'temperatura', 620.0000, 'ºC'),
	(200143, 120, '2014-02-15 00:24:22.000000', 'temperatura', 699.0000, 'ºC'),
	(200144, 120, '2014-02-15 00:24:23.000000', 'temperatura', 437.0000, 'ºC'),
	(200145, 120, '2014-02-15 00:24:24.000000', 'temperatura', 89.0000, 'ºC'),
	(200146, 120, '2014-02-15 00:24:25.000000', 'temperatura', 335.0000, 'ºC'),
	(200147, 120, '2014-02-15 00:24:26.000000', 'temperatura', 208.0000, 'ºC'),
	(200148, 120, '2014-02-15 00:24:27.000000', 'temperatura', 37.0000, 'ºC'),
	(200149, 120, '2014-02-15 00:24:28.000000', 'temperatura', 761.0000, 'ºC'),
	(200150, 120, '2014-02-15 00:24:29.000000', 'temperatura', 95.0000, 'ºC'),
	(200151, 120, '2014-02-15 00:24:30.000000', 'temperatura', 592.0000, 'ºC'),
	(200152, 120, '2014-02-15 00:24:31.000000', 'temperatura', 274.0000, 'ºC'),
	(200153, 120, '2014-02-15 00:24:32.000000', 'temperatura', 795.0000, 'ºC'),
	(200154, 120, '2014-02-15 00:24:33.000000', 'temperatura', 752.0000, 'ºC'),
	(200155, 120, '2014-02-15 00:24:34.000000', 'temperatura', 177.0000, 'ºC'),
	(200156, 120, '2014-02-15 00:24:35.000000', 'temperatura', 1031.0000, 'ºC'),
	(200157, 120, '2014-02-15 00:24:36.000000', 'temperatura', 1024.0000, 'ºC'),
	(200158, 120, '2014-02-15 00:24:37.000000', 'temperatura', 826.0000, 'ºC'),
	(200159, 120, '2014-02-15 00:24:38.000000', 'temperatura', 1059.0000, 'ºC'),
	(200160, 120, '2014-02-15 00:24:39.000000', 'temperatura', 417.0000, 'ºC'),
	(200161, 120, '2014-02-15 00:24:40.000000', 'temperatura', 110.0000, 'ºC'),
	(200162, 120, '2014-02-15 00:24:41.000000', 'temperatura', 499.0000, 'ºC'),
	(200163, 120, '2014-02-15 00:24:42.000000', 'temperatura', 967.0000, 'ºC'),
	(200164, 120, '2014-02-15 00:24:43.000000', 'temperatura', 937.0000, 'ºC'),
	(200165, 120, '2014-02-15 00:24:44.000000', 'temperatura', 583.0000, 'ºC'),
	(200166, 120, '2014-02-15 00:24:45.000000', 'temperatura', 108.0000, 'ºC'),
	(200167, 120, '2014-02-15 00:24:46.000000', 'temperatura', 1189.0000, 'ºC'),
	(200168, 120, '2014-02-15 00:24:47.000000', 'temperatura', 821.0000, 'ºC'),
	(200169, 120, '2014-02-15 00:24:48.000000', 'temperatura', 541.0000, 'ºC'),
	(200170, 120, '2014-02-15 00:24:49.000000', 'temperatura', 243.0000, 'ºC'),
	(200171, 120, '2014-02-15 00:24:50.000000', 'temperatura', 792.0000, 'ºC'),
	(200172, 120, '2014-02-15 00:24:51.000000', 'temperatura', 831.0000, 'ºC'),
	(200173, 120, '2014-02-15 00:24:52.000000', 'temperatura', 578.0000, 'ºC'),
	(200174, 120, '2014-02-15 00:24:53.000000', 'temperatura', 397.0000, 'ºC'),
	(200175, 120, '2014-02-15 00:24:54.000000', 'temperatura', 253.0000, 'ºC'),
	(200176, 120, '2014-02-15 00:24:55.000000', 'temperatura', 74.0000, 'ºC'),
	(200177, 120, '2014-02-15 00:24:56.000000', 'temperatura', 812.0000, 'ºC'),
	(200178, 120, '2014-02-15 00:24:57.000000', 'temperatura', 238.0000, 'ºC'),
	(200179, 120, '2014-02-15 00:24:58.000000', 'temperatura', 1157.0000, 'ºC'),
	(200180, 120, '2014-02-15 00:24:59.000000', 'temperatura', 269.0000, 'ºC'),
	(200181, 120, '2014-02-15 00:25:00.000000', 'temperatura', 273.0000, 'ºC'),
	(200182, 120, '2014-02-15 00:25:01.000000', 'temperatura', 561.0000, 'ºC'),
	(200183, 120, '2014-02-15 00:25:02.000000', 'temperatura', 785.0000, 'ºC'),
	(200184, 120, '2014-02-15 00:25:03.000000', 'temperatura', 1044.0000, 'ºC'),
	(200185, 120, '2014-02-15 00:25:04.000000', 'temperatura', 466.0000, 'ºC'),
	(200186, 120, '2014-02-15 00:25:05.000000', 'temperatura', 396.0000, 'ºC'),
	(200187, 120, '2014-02-15 00:25:06.000000', 'temperatura', 583.0000, 'ºC'),
	(200188, 120, '2014-02-15 00:25:07.000000', 'temperatura', 526.0000, 'ºC'),
	(200189, 120, '2014-02-15 00:25:08.000000', 'temperatura', 883.0000, 'ºC'),
	(200190, 120, '2014-02-15 00:25:09.000000', 'temperatura', 438.0000, 'ºC'),
	(200191, 120, '2014-02-15 00:25:10.000000', 'temperatura', 740.0000, 'ºC'),
	(200192, 120, '2014-02-15 00:25:11.000000', 'temperatura', 1188.0000, 'ºC'),
	(200193, 120, '2014-02-15 00:25:12.000000', 'temperatura', 119.0000, 'ºC'),
	(200194, 120, '2014-02-15 00:25:13.000000', 'temperatura', 632.0000, 'ºC'),
	(200195, 120, '2014-02-15 00:25:14.000000', 'temperatura', 403.0000, 'ºC'),
	(200196, 120, '2014-02-15 00:25:15.000000', 'temperatura', 121.0000, 'ºC'),
	(200197, 120, '2014-02-15 00:25:16.000000', 'temperatura', 597.0000, 'ºC'),
	(200198, 120, '2014-02-15 00:25:17.000000', 'temperatura', 220.0000, 'ºC'),
	(200199, 120, '2014-02-15 00:25:18.000000', 'temperatura', 511.0000, 'ºC'),
	(200200, 120, '2014-02-15 00:25:19.000000', 'temperatura', 697.0000, 'ºC'),
	(200201, 120, '2014-02-15 00:25:20.000000', 'temperatura', 751.0000, 'ºC'),
	(200202, 120, '2014-02-15 00:25:21.000000', 'temperatura', 465.0000, 'ºC'),
	(200203, 120, '2014-02-15 00:25:22.000000', 'temperatura', 71.0000, 'ºC'),
	(200204, 120, '2014-02-15 00:25:23.000000', 'temperatura', 160.0000, 'ºC'),
	(200205, 120, '2014-02-15 00:25:24.000000', 'temperatura', 589.0000, 'ºC'),
	(200206, 120, '2014-02-15 00:25:25.000000', 'temperatura', 67.0000, 'ºC'),
	(200207, 120, '2014-02-15 00:25:26.000000', 'temperatura', 967.0000, 'ºC'),
	(200208, 120, '2014-02-15 00:25:27.000000', 'temperatura', 1034.0000, 'ºC'),
	(200209, 120, '2014-02-15 00:25:28.000000', 'temperatura', 1072.0000, 'ºC'),
	(200210, 120, '2014-02-15 00:25:29.000000', 'temperatura', 1056.0000, 'ºC'),
	(200211, 120, '2014-02-15 00:25:30.000000', 'temperatura', 864.0000, 'ºC'),
	(200212, 120, '2014-02-15 00:25:31.000000', 'temperatura', 1153.0000, 'ºC'),
	(200213, 120, '2014-02-15 00:25:32.000000', 'temperatura', 775.0000, 'ºC'),
	(200214, 120, '2014-02-15 00:25:33.000000', 'temperatura', 417.0000, 'ºC'),
	(200215, 120, '2014-02-15 00:25:34.000000', 'temperatura', 958.0000, 'ºC'),
	(200216, 120, '2014-02-15 00:25:35.000000', 'temperatura', 1139.0000, 'ºC'),
	(200217, 120, '2014-02-15 00:25:36.000000', 'temperatura', 425.0000, 'ºC'),
	(200218, 120, '2014-02-15 00:25:37.000000', 'temperatura', 1105.0000, 'ºC'),
	(200219, 120, '2014-02-15 00:25:38.000000', 'temperatura', 652.0000, 'ºC'),
	(200220, 120, '2014-02-15 00:25:39.000000', 'temperatura', 1146.0000, 'ºC'),
	(200221, 120, '2014-02-15 00:25:40.000000', 'temperatura', 175.0000, 'ºC'),
	(200222, 120, '2014-02-15 00:25:41.000000', 'temperatura', 1036.0000, 'ºC'),
	(200223, 120, '2014-02-15 00:25:42.000000', 'temperatura', 1057.0000, 'ºC'),
	(200224, 120, '2014-02-15 00:25:43.000000', 'temperatura', 978.0000, 'ºC'),
	(200225, 120, '2014-02-15 00:25:44.000000', 'temperatura', 518.0000, 'ºC'),
	(200226, 120, '2014-02-15 00:25:45.000000', 'temperatura', 858.0000, 'ºC'),
	(200227, 120, '2014-02-15 00:25:46.000000', 'temperatura', 336.0000, 'ºC'),
	(200228, 120, '2014-02-15 00:25:47.000000', 'temperatura', 306.0000, 'ºC'),
	(200229, 120, '2014-02-15 00:25:48.000000', 'temperatura', 523.0000, 'ºC'),
	(200230, 120, '2014-02-15 00:25:49.000000', 'temperatura', 496.0000, 'ºC'),
	(200231, 120, '2014-02-15 00:25:50.000000', 'temperatura', 913.0000, 'ºC'),
	(200232, 120, '2014-02-15 00:25:51.000000', 'temperatura', 675.0000, 'ºC'),
	(200233, 120, '2014-02-15 00:25:52.000000', 'temperatura', 640.0000, 'ºC'),
	(200234, 120, '2014-02-15 00:25:53.000000', 'temperatura', 1174.0000, 'ºC'),
	(200235, 120, '2014-02-15 00:25:54.000000', 'temperatura', 350.0000, 'ºC'),
	(200236, 120, '2014-02-15 00:25:55.000000', 'temperatura', 627.0000, 'ºC'),
	(200237, 120, '2014-02-15 00:25:56.000000', 'temperatura', 888.0000, 'ºC'),
	(200238, 120, '2014-02-15 00:25:57.000000', 'temperatura', 158.0000, 'ºC'),
	(200239, 120, '2014-02-15 00:25:58.000000', 'temperatura', 529.0000, 'ºC'),
	(200240, 120, '2014-02-15 00:25:59.000000', 'temperatura', 970.0000, 'ºC'),
	(200241, 120, '2014-02-15 00:26:00.000000', 'temperatura', 865.0000, 'ºC'),
	(200242, 120, '2014-02-15 00:26:01.000000', 'temperatura', 213.0000, 'ºC'),
	(200243, 120, '2014-02-15 00:26:02.000000', 'temperatura', 870.0000, 'ºC'),
	(200244, 120, '2014-02-15 00:26:03.000000', 'temperatura', 112.0000, 'ºC'),
	(200245, 120, '2014-02-15 00:26:04.000000', 'temperatura', 353.0000, 'ºC'),
	(200246, 120, '2014-02-15 00:26:05.000000', 'temperatura', 227.0000, 'ºC'),
	(200247, 120, '2014-02-15 00:26:06.000000', 'temperatura', 75.0000, 'ºC'),
	(200248, 120, '2014-02-15 00:26:07.000000', 'temperatura', 897.0000, 'ºC'),
	(200249, 120, '2014-02-15 00:26:08.000000', 'temperatura', 660.0000, 'ºC'),
	(200250, 120, '2014-02-15 00:26:09.000000', 'temperatura', 610.0000, 'ºC'),
	(200251, 120, '2014-02-15 00:26:10.000000', 'temperatura', 1068.0000, 'ºC'),
	(200252, 120, '2014-02-15 00:26:11.000000', 'temperatura', 1113.0000, 'ºC'),
	(200253, 120, '2014-02-15 00:26:12.000000', 'temperatura', 1160.0000, 'ºC'),
	(200254, 120, '2014-02-15 00:26:13.000000', 'temperatura', 63.0000, 'ºC'),
	(200255, 120, '2014-02-15 00:26:14.000000', 'temperatura', 435.0000, 'ºC'),
	(200256, 120, '2014-02-15 00:26:15.000000', 'temperatura', 785.0000, 'ºC'),
	(200257, 120, '2014-02-15 00:26:16.000000', 'temperatura', 222.0000, 'ºC'),
	(200258, 120, '2014-02-15 00:26:17.000000', 'temperatura', 1154.0000, 'ºC'),
	(200259, 120, '2014-02-15 00:26:18.000000', 'temperatura', 306.0000, 'ºC'),
	(200260, 120, '2014-02-15 00:26:19.000000', 'temperatura', 467.0000, 'ºC'),
	(200261, 120, '2014-02-15 00:26:20.000000', 'temperatura', 217.0000, 'ºC'),
	(200262, 120, '2014-02-15 00:26:21.000000', 'temperatura', 887.0000, 'ºC'),
	(200263, 120, '2014-02-15 00:26:22.000000', 'temperatura', 181.0000, 'ºC'),
	(200264, 120, '2014-02-15 00:26:23.000000', 'temperatura', 647.0000, 'ºC'),
	(200265, 120, '2014-02-15 00:26:24.000000', 'temperatura', 293.0000, 'ºC'),
	(200266, 120, '2014-02-15 00:26:25.000000', 'temperatura', 725.0000, 'ºC'),
	(200267, 120, '2014-02-15 00:26:26.000000', 'temperatura', 346.0000, 'ºC'),
	(200268, 120, '2014-02-15 00:26:27.000000', 'temperatura', 755.0000, 'ºC'),
	(200269, 120, '2014-02-15 00:26:28.000000', 'temperatura', 338.0000, 'ºC'),
	(200270, 120, '2014-02-15 00:26:29.000000', 'temperatura', 625.0000, 'ºC'),
	(200271, 120, '2014-02-15 00:26:30.000000', 'temperatura', 912.0000, 'ºC'),
	(200272, 120, '2014-02-15 00:26:31.000000', 'temperatura', 286.0000, 'ºC'),
	(200273, 120, '2014-02-15 00:26:32.000000', 'temperatura', 1095.0000, 'ºC'),
	(200274, 120, '2014-02-15 00:26:33.000000', 'temperatura', 1017.0000, 'ºC'),
	(200275, 120, '2014-02-15 00:26:34.000000', 'temperatura', 600.0000, 'ºC'),
	(200276, 120, '2014-02-15 00:26:35.000000', 'temperatura', 1148.0000, 'ºC'),
	(200277, 120, '2014-02-15 00:26:36.000000', 'temperatura', 340.0000, 'ºC'),
	(200278, 120, '2014-02-15 00:26:37.000000', 'temperatura', 658.0000, 'ºC'),
	(200279, 120, '2014-02-15 00:26:38.000000', 'temperatura', 1071.0000, 'ºC'),
	(200280, 120, '2014-02-15 00:26:39.000000', 'temperatura', 980.0000, 'ºC'),
	(200281, 120, '2014-02-15 00:26:40.000000', 'temperatura', 486.0000, 'ºC'),
	(200282, 120, '2014-02-15 00:26:41.000000', 'temperatura', 693.0000, 'ºC'),
	(200283, 120, '2014-02-15 00:26:42.000000', 'temperatura', 808.0000, 'ºC'),
	(200284, 120, '2014-02-15 00:26:43.000000', 'temperatura', 759.0000, 'ºC'),
	(200285, 120, '2014-02-15 00:26:44.000000', 'temperatura', 174.0000, 'ºC'),
	(200286, 120, '2014-02-15 00:26:45.000000', 'temperatura', 993.0000, 'ºC'),
	(200287, 120, '2014-02-15 00:26:46.000000', 'temperatura', 842.0000, 'ºC'),
	(200288, 120, '2014-02-15 00:26:47.000000', 'temperatura', 31.0000, 'ºC'),
	(200289, 120, '2014-02-15 00:26:48.000000', 'temperatura', 29.0000, 'ºC'),
	(200290, 120, '2014-02-15 00:26:49.000000', 'temperatura', 52.0000, 'ºC'),
	(200291, 120, '2014-02-15 00:26:50.000000', 'temperatura', 174.0000, 'ºC'),
	(200292, 120, '2014-02-15 00:26:51.000000', 'temperatura', 716.0000, 'ºC'),
	(200293, 120, '2014-02-15 00:26:52.000000', 'temperatura', 657.0000, 'ºC'),
	(200294, 120, '2014-02-15 00:26:53.000000', 'temperatura', 1139.0000, 'ºC'),
	(200295, 120, '2014-02-15 00:26:54.000000', 'temperatura', 124.0000, 'ºC'),
	(200296, 120, '2014-02-15 00:26:55.000000', 'temperatura', 805.0000, 'ºC'),
	(200297, 120, '2014-02-15 00:26:56.000000', 'temperatura', 52.0000, 'ºC'),
	(200298, 120, '2014-02-15 00:26:57.000000', 'temperatura', 248.0000, 'ºC'),
	(200299, 120, '2014-02-15 00:26:58.000000', 'temperatura', 1081.0000, 'ºC'),
	(200300, 120, '2014-02-15 00:26:59.000000', 'temperatura', 1065.0000, 'ºC'),
	(200301, 120, '2014-02-15 00:27:00.000000', 'temperatura', 880.0000, 'ºC'),
	(200302, 120, '2014-02-15 00:27:01.000000', 'temperatura', 8.0000, 'ºC'),
	(200303, 120, '2014-02-15 00:27:02.000000', 'temperatura', 997.0000, 'ºC'),
	(200304, 120, '2014-02-15 00:27:03.000000', 'temperatura', 164.0000, 'ºC'),
	(200305, 120, '2014-02-15 00:27:04.000000', 'temperatura', 228.0000, 'ºC'),
	(200306, 120, '2014-02-15 00:27:05.000000', 'temperatura', 648.0000, 'ºC'),
	(200307, 120, '2014-02-15 00:27:06.000000', 'temperatura', 156.0000, 'ºC'),
	(200308, 120, '2014-02-15 00:27:07.000000', 'temperatura', 39.0000, 'ºC'),
	(200309, 120, '2014-02-15 00:27:08.000000', 'temperatura', 926.0000, 'ºC'),
	(200310, 120, '2014-02-15 00:27:09.000000', 'temperatura', 913.0000, 'ºC'),
	(200311, 120, '2014-02-15 00:27:10.000000', 'temperatura', 590.0000, 'ºC'),
	(200312, 120, '2014-02-15 00:27:11.000000', 'temperatura', 210.0000, 'ºC'),
	(200313, 120, '2014-02-15 00:27:12.000000', 'temperatura', 480.0000, 'ºC'),
	(200314, 120, '2014-02-15 00:27:13.000000', 'temperatura', 570.0000, 'ºC'),
	(200315, 120, '2014-02-15 00:27:14.000000', 'temperatura', 211.0000, 'ºC'),
	(200316, 120, '2014-02-15 00:27:15.000000', 'temperatura', 545.0000, 'ºC'),
	(200317, 120, '2014-02-15 00:27:16.000000', 'temperatura', 895.0000, 'ºC'),
	(200318, 120, '2014-02-15 00:27:17.000000', 'temperatura', 439.0000, 'ºC'),
	(200319, 120, '2014-02-15 00:27:18.000000', 'temperatura', 711.0000, 'ºC'),
	(200320, 120, '2014-02-15 00:27:19.000000', 'temperatura', 1038.0000, 'ºC'),
	(200321, 120, '2014-02-15 00:27:20.000000', 'temperatura', 656.0000, 'ºC'),
	(200322, 120, '2014-02-15 00:27:21.000000', 'temperatura', 169.0000, 'ºC'),
	(200323, 120, '2014-02-15 00:27:22.000000', 'temperatura', 77.0000, 'ºC'),
	(200324, 120, '2014-02-15 00:27:23.000000', 'temperatura', 1078.0000, 'ºC'),
	(200325, 120, '2014-02-15 00:27:24.000000', 'temperatura', 361.0000, 'ºC'),
	(200326, 120, '2014-02-15 00:27:25.000000', 'temperatura', 970.0000, 'ºC'),
	(200327, 120, '2014-02-15 00:27:26.000000', 'temperatura', 168.0000, 'ºC'),
	(200328, 120, '2014-02-15 00:27:27.000000', 'temperatura', 331.0000, 'ºC'),
	(200329, 120, '2014-02-15 00:27:28.000000', 'temperatura', 1151.0000, 'ºC'),
	(200330, 120, '2014-02-15 00:27:29.000000', 'temperatura', 1161.0000, 'ºC'),
	(200331, 120, '2014-02-15 00:27:30.000000', 'temperatura', 1154.0000, 'ºC'),
	(200332, 120, '2014-02-15 00:27:31.000000', 'temperatura', 1088.0000, 'ºC'),
	(200333, 120, '2014-02-15 00:27:32.000000', 'temperatura', 777.0000, 'ºC'),
	(200334, 120, '2014-02-15 00:27:33.000000', 'temperatura', 621.0000, 'ºC'),
	(200335, 120, '2014-02-15 00:27:34.000000', 'temperatura', 774.0000, 'ºC'),
	(200336, 120, '2014-02-15 00:27:35.000000', 'temperatura', 810.0000, 'ºC'),
	(200337, 120, '2014-02-15 00:27:36.000000', 'temperatura', 529.0000, 'ºC'),
	(200338, 120, '2014-02-15 00:27:37.000000', 'temperatura', 214.0000, 'ºC'),
	(200339, 120, '2014-02-15 00:27:38.000000', 'temperatura', 683.0000, 'ºC'),
	(200340, 120, '2014-02-15 00:27:39.000000', 'temperatura', 376.0000, 'ºC'),
	(200341, 120, '2014-02-15 00:27:40.000000', 'temperatura', 1030.0000, 'ºC'),
	(200342, 120, '2014-02-15 00:27:41.000000', 'temperatura', 421.0000, 'ºC'),
	(200343, 120, '2014-02-15 00:27:42.000000', 'temperatura', 216.0000, 'ºC'),
	(200344, 120, '2014-02-15 00:27:43.000000', 'temperatura', 1018.0000, 'ºC'),
	(200345, 120, '2014-02-15 00:27:44.000000', 'temperatura', 845.0000, 'ºC'),
	(200346, 120, '2014-02-15 00:27:45.000000', 'temperatura', 1168.0000, 'ºC'),
	(200347, 120, '2014-02-15 00:27:46.000000', 'temperatura', 906.0000, 'ºC'),
	(200348, 120, '2014-02-15 00:27:47.000000', 'temperatura', 1029.0000, 'ºC'),
	(200349, 120, '2014-02-15 00:27:48.000000', 'temperatura', 26.0000, 'ºC'),
	(200350, 120, '2014-02-15 00:27:49.000000', 'temperatura', 644.0000, 'ºC'),
	(200351, 120, '2014-02-15 00:27:50.000000', 'temperatura', 741.0000, 'ºC'),
	(200352, 120, '2014-02-15 00:27:51.000000', 'temperatura', 573.0000, 'ºC'),
	(200353, 120, '2014-02-15 00:27:52.000000', 'temperatura', 644.0000, 'ºC'),
	(200354, 120, '2014-02-15 00:27:53.000000', 'temperatura', 302.0000, 'ºC'),
	(200355, 120, '2014-02-15 00:27:54.000000', 'temperatura', 777.0000, 'ºC'),
	(200356, 120, '2014-02-15 00:27:55.000000', 'temperatura', 582.0000, 'ºC'),
	(200357, 120, '2014-02-15 00:27:56.000000', 'temperatura', 576.0000, 'ºC'),
	(200358, 120, '2014-02-15 00:27:57.000000', 'temperatura', 1136.0000, 'ºC'),
	(200359, 120, '2014-02-15 00:27:58.000000', 'temperatura', 355.0000, 'ºC'),
	(200360, 120, '2014-02-15 00:27:59.000000', 'temperatura', 764.0000, 'ºC'),
	(200361, 120, '2014-02-15 00:28:00.000000', 'temperatura', 358.0000, 'ºC'),
	(200362, 120, '2014-02-15 00:28:01.000000', 'temperatura', 697.0000, 'ºC'),
	(200363, 120, '2014-02-15 00:28:02.000000', 'temperatura', 14.0000, 'ºC'),
	(200364, 120, '2014-02-15 00:28:03.000000', 'temperatura', 378.0000, 'ºC'),
	(200365, 120, '2014-02-15 00:28:04.000000', 'temperatura', 650.0000, 'ºC'),
	(200366, 120, '2014-02-15 00:28:05.000000', 'temperatura', 916.0000, 'ºC'),
	(200367, 120, '2014-02-15 00:28:06.000000', 'temperatura', 231.0000, 'ºC'),
	(200368, 120, '2014-02-15 00:28:07.000000', 'temperatura', 809.0000, 'ºC'),
	(200369, 120, '2014-02-15 00:28:08.000000', 'temperatura', 949.0000, 'ºC'),
	(200370, 120, '2014-02-15 00:28:09.000000', 'temperatura', 1120.0000, 'ºC'),
	(200371, 120, '2014-02-15 00:28:10.000000', 'temperatura', 354.0000, 'ºC'),
	(200372, 120, '2014-02-15 00:28:11.000000', 'temperatura', 808.0000, 'ºC'),
	(200373, 120, '2014-02-15 00:28:12.000000', 'temperatura', 581.0000, 'ºC'),
	(200374, 120, '2014-02-15 00:28:13.000000', 'temperatura', 480.0000, 'ºC'),
	(200375, 120, '2014-02-15 00:28:14.000000', 'temperatura', 657.0000, 'ºC'),
	(200376, 120, '2014-02-15 00:28:15.000000', 'temperatura', 648.0000, 'ºC'),
	(200377, 120, '2014-02-15 00:28:16.000000', 'temperatura', 67.0000, 'ºC'),
	(200378, 120, '2014-02-15 00:28:17.000000', 'temperatura', 791.0000, 'ºC'),
	(200379, 120, '2014-02-15 00:28:18.000000', 'temperatura', 157.0000, 'ºC'),
	(200380, 120, '2014-02-15 00:28:19.000000', 'temperatura', 810.0000, 'ºC'),
	(200381, 120, '2014-02-15 00:28:20.000000', 'temperatura', 1178.0000, 'ºC'),
	(200382, 120, '2014-02-15 00:28:21.000000', 'temperatura', 1064.0000, 'ºC'),
	(200383, 120, '2014-02-15 00:28:22.000000', 'temperatura', 587.0000, 'ºC'),
	(200384, 120, '2014-02-15 00:28:23.000000', 'temperatura', 941.0000, 'ºC'),
	(200385, 120, '2014-02-15 00:28:24.000000', 'temperatura', 545.0000, 'ºC'),
	(200386, 120, '2014-02-15 00:28:25.000000', 'temperatura', 1102.0000, 'ºC'),
	(200387, 120, '2014-02-15 00:28:26.000000', 'temperatura', 277.0000, 'ºC'),
	(200388, 120, '2014-02-15 00:28:27.000000', 'temperatura', 481.0000, 'ºC'),
	(200389, 120, '2014-02-15 00:28:28.000000', 'temperatura', 373.0000, 'ºC'),
	(200390, 120, '2014-02-15 00:28:29.000000', 'temperatura', 422.0000, 'ºC'),
	(200391, 120, '2014-02-15 00:28:30.000000', 'temperatura', 991.0000, 'ºC'),
	(200392, 120, '2014-02-15 00:28:31.000000', 'temperatura', 92.0000, 'ºC'),
	(200393, 120, '2014-02-15 00:28:32.000000', 'temperatura', 1086.0000, 'ºC'),
	(200394, 120, '2014-02-15 00:28:33.000000', 'temperatura', 355.0000, 'ºC'),
	(200395, 120, '2014-02-15 00:28:34.000000', 'temperatura', 917.0000, 'ºC'),
	(200396, 120, '2014-02-15 00:28:35.000000', 'temperatura', 1123.0000, 'ºC'),
	(200397, 120, '2014-02-15 00:28:36.000000', 'temperatura', 461.0000, 'ºC'),
	(200398, 120, '2014-02-15 00:28:37.000000', 'temperatura', 139.0000, 'ºC'),
	(200399, 120, '2014-02-15 00:28:38.000000', 'temperatura', 510.0000, 'ºC'),
	(200400, 120, '2014-02-15 00:28:39.000000', 'temperatura', 934.0000, 'ºC'),
	(200401, 120, '2014-02-15 00:28:40.000000', 'temperatura', 739.0000, 'ºC'),
	(200402, 120, '2014-02-15 00:28:41.000000', 'temperatura', 896.0000, 'ºC'),
	(200403, 120, '2014-02-15 00:28:42.000000', 'temperatura', 1063.0000, 'ºC'),
	(200404, 120, '2014-02-15 00:28:43.000000', 'temperatura', 227.0000, 'ºC'),
	(200405, 120, '2014-02-15 00:28:44.000000', 'temperatura', 346.0000, 'ºC'),
	(200406, 120, '2014-02-15 00:28:45.000000', 'temperatura', 1051.0000, 'ºC'),
	(200407, 120, '2014-02-15 00:28:46.000000', 'temperatura', 616.0000, 'ºC'),
	(200408, 120, '2014-02-15 00:28:47.000000', 'temperatura', 1129.0000, 'ºC'),
	(200409, 120, '2014-02-15 00:28:48.000000', 'temperatura', 198.0000, 'ºC'),
	(200410, 120, '2014-02-15 00:28:49.000000', 'temperatura', 1.0000, 'ºC'),
	(200411, 120, '2014-02-15 00:28:50.000000', 'temperatura', 612.0000, 'ºC'),
	(200412, 120, '2014-02-15 00:28:51.000000', 'temperatura', 658.0000, 'ºC'),
	(200413, 120, '2014-02-15 00:28:52.000000', 'temperatura', 256.0000, 'ºC'),
	(200414, 120, '2014-02-15 00:28:53.000000', 'temperatura', 505.0000, 'ºC'),
	(200415, 120, '2014-02-15 00:28:54.000000', 'temperatura', 558.0000, 'ºC'),
	(200416, 120, '2014-02-15 00:28:55.000000', 'temperatura', 76.0000, 'ºC'),
	(200417, 120, '2014-02-15 00:28:56.000000', 'temperatura', 1104.0000, 'ºC'),
	(200418, 120, '2014-02-15 00:28:57.000000', 'temperatura', 495.0000, 'ºC'),
	(200419, 120, '2014-02-15 00:28:58.000000', 'temperatura', 361.0000, 'ºC'),
	(200420, 120, '2014-02-15 00:28:59.000000', 'temperatura', 321.0000, 'ºC'),
	(200421, 120, '2014-02-15 00:29:00.000000', 'temperatura', 524.0000, 'ºC'),
	(200422, 120, '2014-02-15 00:29:01.000000', 'temperatura', 457.0000, 'ºC'),
	(200423, 120, '2014-02-15 00:29:02.000000', 'temperatura', 712.0000, 'ºC'),
	(200424, 120, '2014-02-15 00:29:03.000000', 'temperatura', 990.0000, 'ºC'),
	(200425, 120, '2014-02-15 00:29:04.000000', 'temperatura', 413.0000, 'ºC'),
	(200426, 120, '2014-02-15 00:29:05.000000', 'temperatura', 297.0000, 'ºC'),
	(200427, 120, '2014-02-15 00:29:06.000000', 'temperatura', 248.0000, 'ºC'),
	(200428, 120, '2014-02-15 00:29:07.000000', 'temperatura', 349.0000, 'ºC'),
	(200429, 120, '2014-02-15 00:29:08.000000', 'temperatura', 1001.0000, 'ºC'),
	(200430, 120, '2014-02-15 00:29:09.000000', 'temperatura', 358.0000, 'ºC'),
	(200431, 120, '2014-02-15 00:29:10.000000', 'temperatura', 1187.0000, 'ºC'),
	(200432, 120, '2014-02-15 00:29:11.000000', 'temperatura', 64.0000, 'ºC'),
	(200433, 120, '2014-02-15 00:29:12.000000', 'temperatura', 356.0000, 'ºC'),
	(200434, 120, '2014-02-15 00:29:13.000000', 'temperatura', 392.0000, 'ºC'),
	(200435, 120, '2014-02-15 00:29:14.000000', 'temperatura', 892.0000, 'ºC'),
	(200436, 120, '2014-02-15 00:29:15.000000', 'temperatura', 883.0000, 'ºC'),
	(200437, 120, '2014-02-15 00:29:16.000000', 'temperatura', 541.0000, 'ºC'),
	(200438, 120, '2014-02-15 00:29:17.000000', 'temperatura', 55.0000, 'ºC'),
	(200439, 120, '2014-02-15 00:29:18.000000', 'temperatura', 1053.0000, 'ºC'),
	(200440, 120, '2014-02-15 00:29:19.000000', 'temperatura', 302.0000, 'ºC'),
	(200441, 120, '2014-02-15 00:29:20.000000', 'temperatura', 750.0000, 'ºC'),
	(200442, 120, '2014-02-15 00:29:21.000000', 'temperatura', 445.0000, 'ºC'),
	(200443, 120, '2014-02-15 00:29:22.000000', 'temperatura', 1174.0000, 'ºC'),
	(200444, 120, '2014-02-15 00:29:23.000000', 'temperatura', 938.0000, 'ºC'),
	(200445, 120, '2014-02-15 00:29:24.000000', 'temperatura', 1168.0000, 'ºC'),
	(200446, 120, '2014-02-15 00:29:25.000000', 'temperatura', 628.0000, 'ºC'),
	(200447, 120, '2014-02-15 00:29:26.000000', 'temperatura', 835.0000, 'ºC'),
	(200448, 120, '2014-02-15 00:29:27.000000', 'temperatura', 1091.0000, 'ºC'),
	(200449, 120, '2014-02-15 00:29:28.000000', 'temperatura', 549.0000, 'ºC'),
	(200450, 120, '2014-02-15 00:29:29.000000', 'temperatura', 675.0000, 'ºC'),
	(200451, 120, '2014-02-15 00:29:30.000000', 'temperatura', 527.0000, 'ºC'),
	(200452, 120, '2014-02-15 00:29:31.000000', 'temperatura', 611.0000, 'ºC'),
	(200453, 120, '2014-02-15 00:29:32.000000', 'temperatura', 273.0000, 'ºC'),
	(200454, 120, '2014-02-15 00:29:33.000000', 'temperatura', 735.0000, 'ºC'),
	(200455, 120, '2014-02-15 00:29:34.000000', 'temperatura', 457.0000, 'ºC'),
	(200456, 120, '2014-02-15 00:29:35.000000', 'temperatura', 78.0000, 'ºC'),
	(200457, 120, '2014-02-15 00:29:36.000000', 'temperatura', 220.0000, 'ºC'),
	(200458, 120, '2014-02-15 00:29:37.000000', 'temperatura', 869.0000, 'ºC'),
	(200459, 120, '2014-02-15 00:29:38.000000', 'temperatura', 83.0000, 'ºC'),
	(200460, 120, '2014-02-15 00:29:39.000000', 'temperatura', 210.0000, 'ºC'),
	(200461, 120, '2014-02-15 00:29:40.000000', 'temperatura', 800.0000, 'ºC'),
	(200462, 120, '2014-02-15 00:29:41.000000', 'temperatura', 970.0000, 'ºC'),
	(200463, 120, '2014-02-15 00:29:42.000000', 'temperatura', 53.0000, 'ºC'),
	(200464, 120, '2014-02-15 00:29:43.000000', 'temperatura', 953.0000, 'ºC'),
	(200465, 120, '2014-02-15 00:29:44.000000', 'temperatura', 1007.0000, 'ºC'),
	(200466, 120, '2014-02-15 00:29:45.000000', 'temperatura', 977.0000, 'ºC'),
	(200467, 120, '2014-02-15 00:29:46.000000', 'temperatura', 665.0000, 'ºC'),
	(200468, 120, '2014-02-15 00:29:47.000000', 'temperatura', 394.0000, 'ºC'),
	(200469, 120, '2014-02-15 00:29:48.000000', 'temperatura', 1176.0000, 'ºC'),
	(200470, 120, '2014-02-15 00:29:49.000000', 'temperatura', 1099.0000, 'ºC'),
	(200471, 120, '2014-02-15 00:29:50.000000', 'temperatura', 768.0000, 'ºC'),
	(200472, 120, '2014-02-15 00:29:51.000000', 'temperatura', 542.0000, 'ºC'),
	(200473, 120, '2014-02-15 00:29:52.000000', 'temperatura', 409.0000, 'ºC'),
	(200474, 120, '2014-02-15 00:29:53.000000', 'temperatura', 419.0000, 'ºC'),
	(200475, 120, '2014-02-15 00:29:54.000000', 'temperatura', 867.0000, 'ºC'),
	(200476, 120, '2014-02-15 00:29:55.000000', 'temperatura', 678.0000, 'ºC'),
	(200477, 120, '2014-02-15 00:29:56.000000', 'temperatura', 788.0000, 'ºC'),
	(200478, 120, '2014-02-15 00:29:57.000000', 'temperatura', 709.0000, 'ºC'),
	(200479, 120, '2014-02-15 00:29:58.000000', 'temperatura', 1181.0000, 'ºC'),
	(200480, 120, '2014-02-15 00:29:59.000000', 'temperatura', 177.0000, 'ºC'),
	(200481, 120, '2014-02-15 00:30:00.000000', 'temperatura', 943.0000, 'ºC'),
	(200482, 120, '2014-02-15 00:30:01.000000', 'temperatura', 585.0000, 'ºC'),
	(200483, 120, '2014-02-15 00:30:02.000000', 'temperatura', 97.0000, 'ºC'),
	(200484, 120, '2014-02-15 00:30:03.000000', 'temperatura', 1130.0000, 'ºC'),
	(200485, 120, '2014-02-15 00:30:04.000000', 'temperatura', 558.0000, 'ºC'),
	(200486, 120, '2014-02-15 00:30:05.000000', 'temperatura', 602.0000, 'ºC'),
	(200487, 120, '2014-02-15 00:30:06.000000', 'temperatura', 138.0000, 'ºC'),
	(200488, 120, '2014-02-15 00:30:07.000000', 'temperatura', 85.0000, 'ºC'),
	(200489, 120, '2014-02-15 00:30:08.000000', 'temperatura', 8.0000, 'ºC'),
	(200490, 120, '2014-02-15 00:30:09.000000', 'temperatura', 989.0000, 'ºC'),
	(200491, 120, '2014-02-15 00:30:10.000000', 'temperatura', 118.0000, 'ºC'),
	(200492, 120, '2014-02-15 00:30:11.000000', 'temperatura', 27.0000, 'ºC'),
	(200493, 120, '2014-02-15 00:30:12.000000', 'temperatura', 979.0000, 'ºC'),
	(200494, 120, '2014-02-15 00:30:13.000000', 'temperatura', 14.0000, 'ºC'),
	(200495, 120, '2014-02-15 00:30:14.000000', 'temperatura', 736.0000, 'ºC'),
	(200496, 120, '2014-02-15 00:30:15.000000', 'temperatura', 35.0000, 'ºC'),
	(200497, 120, '2014-02-15 00:30:16.000000', 'temperatura', 370.0000, 'ºC'),
	(200498, 120, '2014-02-15 00:30:17.000000', 'temperatura', 546.0000, 'ºC'),
	(200499, 120, '2014-02-15 00:30:18.000000', 'temperatura', 420.0000, 'ºC'),
	(200500, 120, '2014-02-15 00:30:19.000000', 'temperatura', 464.0000, 'ºC'),
	(200501, 120, '2014-02-15 00:30:20.000000', 'temperatura', 1059.0000, 'ºC'),
	(200502, 120, '2014-02-15 00:30:21.000000', 'temperatura', 306.0000, 'ºC'),
	(200503, 120, '2014-02-15 00:30:22.000000', 'temperatura', 750.0000, 'ºC'),
	(200504, 120, '2014-02-15 00:30:23.000000', 'temperatura', 433.0000, 'ºC'),
	(200505, 120, '2014-02-15 00:30:24.000000', 'temperatura', 1118.0000, 'ºC'),
	(200506, 120, '2014-02-15 00:30:25.000000', 'temperatura', 688.0000, 'ºC'),
	(200507, 120, '2014-02-15 00:30:26.000000', 'temperatura', 90.0000, 'ºC'),
	(200508, 120, '2014-02-15 00:30:27.000000', 'temperatura', 784.0000, 'ºC'),
	(200509, 120, '2014-02-15 00:30:28.000000', 'temperatura', 49.0000, 'ºC'),
	(200510, 120, '2014-02-15 00:30:29.000000', 'temperatura', 297.0000, 'ºC'),
	(200511, 120, '2014-02-15 00:30:30.000000', 'temperatura', 137.0000, 'ºC'),
	(200512, 120, '2014-02-15 00:30:31.000000', 'temperatura', 995.0000, 'ºC'),
	(200513, 120, '2014-02-15 00:30:32.000000', 'temperatura', 962.0000, 'ºC'),
	(200514, 120, '2014-02-15 00:30:33.000000', 'temperatura', 629.0000, 'ºC'),
	(200515, 120, '2014-02-15 00:30:34.000000', 'temperatura', 258.0000, 'ºC'),
	(200516, 120, '2014-02-15 00:30:35.000000', 'temperatura', 603.0000, 'ºC'),
	(200517, 120, '2014-02-15 00:30:36.000000', 'temperatura', 1043.0000, 'ºC'),
	(200518, 120, '2014-02-15 00:30:37.000000', 'temperatura', 1005.0000, 'ºC'),
	(200519, 120, '2014-02-15 00:30:38.000000', 'temperatura', 699.0000, 'ºC'),
	(200520, 120, '2014-02-15 00:30:39.000000', 'temperatura', 479.0000, 'ºC'),
	(200521, 120, '2014-02-15 00:30:40.000000', 'temperatura', 300.0000, 'ºC'),
	(200522, 120, '2014-02-15 00:30:41.000000', 'temperatura', 62.0000, 'ºC'),
	(200523, 120, '2014-02-15 00:30:42.000000', 'temperatura', 611.0000, 'ºC'),
	(200524, 120, '2014-02-15 00:30:43.000000', 'temperatura', 472.0000, 'ºC'),
	(200525, 120, '2014-02-15 00:30:44.000000', 'temperatura', 524.0000, 'ºC'),
	(200526, 120, '2014-02-15 00:30:45.000000', 'temperatura', 4.0000, 'ºC'),
	(200527, 120, '2014-02-15 00:30:46.000000', 'temperatura', 852.0000, 'ºC'),
	(200528, 120, '2014-02-15 00:30:47.000000', 'temperatura', 646.0000, 'ºC'),
	(200529, 120, '2014-02-15 00:30:48.000000', 'temperatura', 675.0000, 'ºC'),
	(200530, 120, '2014-02-15 00:30:49.000000', 'temperatura', 239.0000, 'ºC'),
	(200531, 120, '2014-02-15 00:30:50.000000', 'temperatura', 367.0000, 'ºC'),
	(200532, 120, '2014-02-15 00:30:51.000000', 'temperatura', 1122.0000, 'ºC'),
	(200533, 120, '2014-02-15 00:30:52.000000', 'temperatura', 908.0000, 'ºC'),
	(200534, 120, '2014-02-15 00:30:53.000000', 'temperatura', 1175.0000, 'ºC'),
	(200535, 120, '2014-02-15 00:30:54.000000', 'temperatura', 751.0000, 'ºC'),
	(200536, 120, '2014-02-15 00:30:55.000000', 'temperatura', 231.0000, 'ºC'),
	(200537, 120, '2014-02-15 00:30:56.000000', 'temperatura', 102.0000, 'ºC'),
	(200538, 120, '2014-02-15 00:30:57.000000', 'temperatura', 1017.0000, 'ºC'),
	(200539, 120, '2014-02-15 00:30:58.000000', 'temperatura', 1181.0000, 'ºC'),
	(200540, 120, '2014-02-15 00:30:59.000000', 'temperatura', 452.0000, 'ºC'),
	(200541, 120, '2014-02-15 00:31:00.000000', 'temperatura', 1120.0000, 'ºC'),
	(200542, 120, '2014-02-15 00:31:01.000000', 'temperatura', 643.0000, 'ºC'),
	(200543, 120, '2014-02-15 00:31:02.000000', 'temperatura', 1058.0000, 'ºC'),
	(200544, 120, '2014-02-15 00:31:03.000000', 'temperatura', 959.0000, 'ºC'),
	(200545, 120, '2014-02-15 00:31:04.000000', 'temperatura', 420.0000, 'ºC'),
	(200546, 120, '2014-02-15 00:31:05.000000', 'temperatura', 426.0000, 'ºC'),
	(200547, 120, '2014-02-15 00:31:06.000000', 'temperatura', 868.0000, 'ºC'),
	(200548, 120, '2014-02-15 00:31:07.000000', 'temperatura', 665.0000, 'ºC'),
	(200549, 120, '2014-02-15 00:31:08.000000', 'temperatura', 722.0000, 'ºC'),
	(200550, 120, '2014-02-15 00:31:09.000000', 'temperatura', 413.0000, 'ºC'),
	(200551, 120, '2014-02-15 00:31:10.000000', 'temperatura', 1100.0000, 'ºC'),
	(200552, 120, '2014-02-15 00:31:11.000000', 'temperatura', 661.0000, 'ºC'),
	(200553, 120, '2014-02-15 00:31:12.000000', 'temperatura', 6.0000, 'ºC'),
	(200554, 120, '2014-02-15 00:31:13.000000', 'temperatura', 449.0000, 'ºC'),
	(200555, 120, '2014-02-15 00:31:14.000000', 'temperatura', 1025.0000, 'ºC'),
	(200556, 120, '2014-02-15 00:31:15.000000', 'temperatura', 181.0000, 'ºC'),
	(200557, 120, '2014-02-15 00:31:16.000000', 'temperatura', 228.0000, 'ºC'),
	(200558, 120, '2014-02-15 00:31:17.000000', 'temperatura', 601.0000, 'ºC'),
	(200559, 120, '2014-02-15 00:31:18.000000', 'temperatura', 1118.0000, 'ºC'),
	(200560, 120, '2014-02-15 00:31:19.000000', 'temperatura', 187.0000, 'ºC'),
	(200561, 120, '2014-02-15 00:31:20.000000', 'temperatura', 1185.0000, 'ºC'),
	(200562, 120, '2014-02-15 00:31:21.000000', 'temperatura', 561.0000, 'ºC'),
	(200563, 120, '2014-02-15 00:31:22.000000', 'temperatura', 453.0000, 'ºC'),
	(200564, 120, '2014-02-15 00:31:23.000000', 'temperatura', 583.0000, 'ºC'),
	(200565, 120, '2014-02-15 00:31:24.000000', 'temperatura', 358.0000, 'ºC'),
	(200566, 120, '2014-02-15 00:31:25.000000', 'temperatura', 38.0000, 'ºC'),
	(200567, 120, '2014-02-15 00:31:26.000000', 'temperatura', 317.0000, 'ºC'),
	(200568, 120, '2014-02-15 00:31:27.000000', 'temperatura', 272.0000, 'ºC'),
	(200569, 120, '2014-02-15 00:31:28.000000', 'temperatura', 409.0000, 'ºC'),
	(200570, 120, '2014-02-15 00:31:29.000000', 'temperatura', 30.0000, 'ºC'),
	(200571, 120, '2014-02-15 00:31:30.000000', 'temperatura', 125.0000, 'ºC'),
	(200572, 120, '2014-02-15 00:31:31.000000', 'temperatura', 533.0000, 'ºC'),
	(200573, 120, '2014-02-15 00:31:32.000000', 'temperatura', 1092.0000, 'ºC'),
	(200574, 120, '2014-02-15 00:31:33.000000', 'temperatura', 259.0000, 'ºC'),
	(200575, 120, '2014-02-15 00:31:34.000000', 'temperatura', 422.0000, 'ºC'),
	(200576, 120, '2014-02-15 00:31:35.000000', 'temperatura', 132.0000, 'ºC'),
	(200577, 120, '2014-02-15 00:31:36.000000', 'temperatura', 595.0000, 'ºC'),
	(200578, 120, '2014-02-15 00:31:37.000000', 'temperatura', 180.0000, 'ºC'),
	(200579, 120, '2014-02-15 00:31:38.000000', 'temperatura', 315.0000, 'ºC'),
	(200580, 120, '2014-02-15 00:31:39.000000', 'temperatura', 1034.0000, 'ºC'),
	(200581, 120, '2014-02-15 00:31:40.000000', 'temperatura', 627.0000, 'ºC'),
	(200582, 120, '2014-02-15 00:31:41.000000', 'temperatura', 33.0000, 'ºC'),
	(200583, 120, '2014-02-15 00:31:42.000000', 'temperatura', 685.0000, 'ºC'),
	(200584, 120, '2014-02-15 00:31:43.000000', 'temperatura', 926.0000, 'ºC'),
	(200585, 120, '2014-02-15 00:31:44.000000', 'temperatura', 174.0000, 'ºC'),
	(200586, 120, '2014-02-15 00:31:45.000000', 'temperatura', 492.0000, 'ºC'),
	(200587, 120, '2014-02-15 00:31:46.000000', 'temperatura', 738.0000, 'ºC'),
	(200588, 120, '2014-02-15 00:31:47.000000', 'temperatura', 1018.0000, 'ºC'),
	(200589, 120, '2014-02-15 00:31:48.000000', 'temperatura', 473.0000, 'ºC'),
	(200590, 120, '2014-02-15 00:31:49.000000', 'temperatura', 512.0000, 'ºC'),
	(200591, 120, '2014-02-15 00:31:50.000000', 'temperatura', 1141.0000, 'ºC'),
	(200592, 120, '2014-02-15 00:31:51.000000', 'temperatura', 572.0000, 'ºC'),
	(200593, 120, '2014-02-15 00:31:52.000000', 'temperatura', 637.0000, 'ºC'),
	(200594, 120, '2014-02-15 00:31:53.000000', 'temperatura', 268.0000, 'ºC'),
	(200595, 120, '2014-02-15 00:31:54.000000', 'temperatura', 629.0000, 'ºC'),
	(200596, 120, '2014-02-15 00:31:55.000000', 'temperatura', 1143.0000, 'ºC'),
	(200597, 120, '2014-02-15 00:31:56.000000', 'temperatura', 228.0000, 'ºC'),
	(200598, 120, '2014-02-15 00:31:57.000000', 'temperatura', 113.0000, 'ºC'),
	(200599, 120, '2014-02-15 00:31:58.000000', 'temperatura', 1081.0000, 'ºC'),
	(200600, 120, '2014-02-15 00:31:59.000000', 'temperatura', 268.0000, 'ºC'),
	(200601, 120, '2014-02-15 00:32:00.000000', 'temperatura', 495.0000, 'ºC'),
	(200602, 120, '2014-02-15 00:32:01.000000', 'temperatura', 474.0000, 'ºC'),
	(200603, 120, '2014-02-15 00:32:02.000000', 'temperatura', 884.0000, 'ºC'),
	(200604, 120, '2014-02-15 00:32:03.000000', 'temperatura', 597.0000, 'ºC'),
	(200605, 120, '2014-02-15 00:32:04.000000', 'temperatura', 334.0000, 'ºC'),
	(200606, 120, '2014-02-15 00:32:05.000000', 'temperatura', 1080.0000, 'ºC'),
	(200607, 120, '2014-02-15 00:32:06.000000', 'temperatura', 800.0000, 'ºC'),
	(200608, 120, '2014-02-15 00:32:07.000000', 'temperatura', 760.0000, 'ºC'),
	(200609, 120, '2014-02-15 00:32:08.000000', 'temperatura', 202.0000, 'ºC'),
	(200610, 120, '2014-02-15 00:32:09.000000', 'temperatura', 1129.0000, 'ºC'),
	(200611, 120, '2014-02-15 00:32:10.000000', 'temperatura', 238.0000, 'ºC'),
	(200612, 120, '2014-02-15 00:32:11.000000', 'temperatura', 204.0000, 'ºC'),
	(200613, 120, '2014-02-15 00:32:12.000000', 'temperatura', 307.0000, 'ºC'),
	(200614, 120, '2014-02-15 00:32:13.000000', 'temperatura', 925.0000, 'ºC'),
	(200615, 120, '2014-02-15 00:32:14.000000', 'temperatura', 104.0000, 'ºC'),
	(200616, 120, '2014-02-15 00:32:15.000000', 'temperatura', 144.0000, 'ºC'),
	(200617, 120, '2014-02-15 00:32:16.000000', 'temperatura', 409.0000, 'ºC'),
	(200618, 120, '2014-02-15 00:32:17.000000', 'temperatura', 415.0000, 'ºC'),
	(200619, 120, '2014-02-15 00:32:18.000000', 'temperatura', 847.0000, 'ºC'),
	(200620, 120, '2014-02-15 00:32:19.000000', 'temperatura', 592.0000, 'ºC'),
	(200621, 120, '2014-02-15 00:32:20.000000', 'temperatura', 418.0000, 'ºC'),
	(200622, 120, '2014-02-15 00:32:21.000000', 'temperatura', 314.0000, 'ºC'),
	(200623, 120, '2014-02-15 00:32:22.000000', 'temperatura', 317.0000, 'ºC'),
	(200624, 120, '2014-02-15 00:32:23.000000', 'temperatura', 643.0000, 'ºC'),
	(200625, 120, '2014-02-15 00:32:24.000000', 'temperatura', 1065.0000, 'ºC'),
	(200626, 120, '2014-02-15 00:32:25.000000', 'temperatura', 995.0000, 'ºC'),
	(200627, 120, '2014-02-15 00:32:26.000000', 'temperatura', 580.0000, 'ºC'),
	(200628, 120, '2014-02-15 00:32:27.000000', 'temperatura', 1115.0000, 'ºC'),
	(200629, 120, '2014-02-15 00:32:28.000000', 'temperatura', 236.0000, 'ºC'),
	(200630, 120, '2014-02-15 00:32:29.000000', 'temperatura', 238.0000, 'ºC'),
	(200631, 120, '2014-02-15 00:32:30.000000', 'temperatura', 479.0000, 'ºC'),
	(200632, 120, '2014-02-15 00:32:31.000000', 'temperatura', 484.0000, 'ºC'),
	(200633, 120, '2014-02-15 00:32:32.000000', 'temperatura', 983.0000, 'ºC'),
	(200634, 120, '2014-02-15 00:32:33.000000', 'temperatura', 1064.0000, 'ºC'),
	(200635, 120, '2014-02-15 00:32:34.000000', 'temperatura', 1173.0000, 'ºC'),
	(200636, 120, '2014-02-15 00:32:35.000000', 'temperatura', 273.0000, 'ºC'),
	(200637, 120, '2014-02-15 00:32:36.000000', 'temperatura', 245.0000, 'ºC'),
	(200638, 120, '2014-02-15 00:32:37.000000', 'temperatura', 406.0000, 'ºC'),
	(200639, 120, '2014-02-15 00:32:38.000000', 'temperatura', 96.0000, 'ºC'),
	(200640, 120, '2014-02-15 00:32:39.000000', 'temperatura', 462.0000, 'ºC'),
	(200641, 120, '2014-02-15 00:32:40.000000', 'temperatura', 824.0000, 'ºC'),
	(200642, 120, '2014-02-15 00:32:41.000000', 'temperatura', 332.0000, 'ºC'),
	(200643, 120, '2014-02-15 00:32:42.000000', 'temperatura', 389.0000, 'ºC'),
	(200644, 120, '2014-02-15 00:32:43.000000', 'temperatura', 949.0000, 'ºC'),
	(200645, 120, '2014-02-15 00:32:44.000000', 'temperatura', 1177.0000, 'ºC'),
	(200646, 120, '2014-02-15 00:32:45.000000', 'temperatura', 641.0000, 'ºC'),
	(200647, 120, '2014-02-15 00:32:46.000000', 'temperatura', 872.0000, 'ºC'),
	(200648, 120, '2014-02-15 00:32:47.000000', 'temperatura', 41.0000, 'ºC'),
	(200649, 120, '2014-02-15 00:32:48.000000', 'temperatura', 1187.0000, 'ºC'),
	(200650, 120, '2014-02-15 00:32:49.000000', 'temperatura', 1011.0000, 'ºC'),
	(200651, 120, '2014-02-15 00:32:50.000000', 'temperatura', 298.0000, 'ºC'),
	(200652, 120, '2014-02-15 00:32:51.000000', 'temperatura', 856.0000, 'ºC'),
	(200653, 120, '2014-02-15 00:32:52.000000', 'temperatura', 988.0000, 'ºC'),
	(200654, 120, '2014-02-15 00:32:53.000000', 'temperatura', 1172.0000, 'ºC'),
	(200655, 120, '2014-02-15 00:32:54.000000', 'temperatura', 494.0000, 'ºC'),
	(200656, 120, '2014-02-15 00:32:55.000000', 'temperatura', 157.0000, 'ºC'),
	(200657, 120, '2014-02-15 00:32:56.000000', 'temperatura', 503.0000, 'ºC'),
	(200658, 120, '2014-02-15 00:32:57.000000', 'temperatura', 842.0000, 'ºC'),
	(200659, 120, '2014-02-15 00:32:58.000000', 'temperatura', 304.0000, 'ºC'),
	(200660, 120, '2014-02-15 00:32:59.000000', 'temperatura', 196.0000, 'ºC'),
	(200661, 120, '2014-02-15 00:33:00.000000', 'temperatura', 67.0000, 'ºC'),
	(200662, 120, '2014-02-15 00:33:01.000000', 'temperatura', 947.0000, 'ºC'),
	(200663, 120, '2014-02-15 00:33:02.000000', 'temperatura', 937.0000, 'ºC'),
	(200664, 120, '2014-02-15 00:33:03.000000', 'temperatura', 642.0000, 'ºC'),
	(200665, 120, '2014-02-15 00:33:04.000000', 'temperatura', 400.0000, 'ºC'),
	(200666, 120, '2014-02-15 00:33:05.000000', 'temperatura', 74.0000, 'ºC'),
	(200667, 120, '2014-02-15 00:33:06.000000', 'temperatura', 371.0000, 'ºC'),
	(200668, 120, '2014-02-15 00:33:07.000000', 'temperatura', 435.0000, 'ºC'),
	(200669, 120, '2014-02-15 00:33:08.000000', 'temperatura', 1063.0000, 'ºC'),
	(200670, 120, '2014-02-15 00:33:09.000000', 'temperatura', 410.0000, 'ºC'),
	(200671, 120, '2014-02-15 00:33:10.000000', 'temperatura', 61.0000, 'ºC'),
	(200672, 120, '2014-02-15 00:33:11.000000', 'temperatura', 277.0000, 'ºC'),
	(200673, 120, '2014-02-15 00:33:12.000000', 'temperatura', 2.0000, 'ºC'),
	(200674, 120, '2014-02-15 00:33:13.000000', 'temperatura', 381.0000, 'ºC'),
	(200675, 120, '2014-02-15 00:33:14.000000', 'temperatura', 698.0000, 'ºC'),
	(200676, 120, '2014-02-15 00:33:15.000000', 'temperatura', 1150.0000, 'ºC'),
	(200677, 120, '2014-02-15 00:33:16.000000', 'temperatura', 53.0000, 'ºC'),
	(200678, 120, '2014-02-15 00:33:17.000000', 'temperatura', 417.0000, 'ºC'),
	(200679, 120, '2014-02-15 00:33:18.000000', 'temperatura', 726.0000, 'ºC'),
	(200680, 120, '2014-02-15 00:33:19.000000', 'temperatura', 1179.0000, 'ºC'),
	(200681, 120, '2014-02-15 00:33:20.000000', 'temperatura', 118.0000, 'ºC'),
	(200682, 120, '2014-02-15 00:33:21.000000', 'temperatura', 655.0000, 'ºC'),
	(200683, 120, '2014-02-15 00:33:22.000000', 'temperatura', 519.0000, 'ºC'),
	(200684, 120, '2014-02-15 00:33:23.000000', 'temperatura', 633.0000, 'ºC'),
	(200685, 120, '2014-02-15 00:33:24.000000', 'temperatura', 406.0000, 'ºC'),
	(200686, 120, '2014-02-15 00:33:25.000000', 'temperatura', 133.0000, 'ºC'),
	(200687, 120, '2014-02-15 00:33:26.000000', 'temperatura', 647.0000, 'ºC'),
	(200688, 120, '2014-02-15 00:33:27.000000', 'temperatura', 436.0000, 'ºC'),
	(200689, 120, '2014-02-15 00:33:28.000000', 'temperatura', 240.0000, 'ºC'),
	(200690, 120, '2014-02-15 00:33:29.000000', 'temperatura', 1094.0000, 'ºC'),
	(200691, 120, '2014-02-15 00:33:30.000000', 'temperatura', 1149.0000, 'ºC'),
	(200692, 120, '2014-02-15 00:33:31.000000', 'temperatura', 66.0000, 'ºC'),
	(200693, 120, '2014-02-15 00:33:32.000000', 'temperatura', 482.0000, 'ºC'),
	(200694, 120, '2014-02-15 00:33:33.000000', 'temperatura', 1011.0000, 'ºC'),
	(200695, 120, '2014-02-15 00:33:34.000000', 'temperatura', 10.0000, 'ºC'),
	(200696, 120, '2014-02-15 00:33:35.000000', 'temperatura', 616.0000, 'ºC'),
	(200697, 120, '2014-02-15 00:33:36.000000', 'temperatura', 653.0000, 'ºC'),
	(200698, 120, '2014-02-15 00:33:37.000000', 'temperatura', 217.0000, 'ºC'),
	(200699, 120, '2014-02-15 00:33:38.000000', 'temperatura', 327.0000, 'ºC'),
	(200700, 120, '2014-02-15 00:33:39.000000', 'temperatura', 983.0000, 'ºC'),
	(200701, 120, '2014-02-15 00:33:40.000000', 'temperatura', 335.0000, 'ºC'),
	(200702, 120, '2014-02-15 00:33:41.000000', 'temperatura', 1125.0000, 'ºC'),
	(200703, 120, '2014-02-15 00:33:42.000000', 'temperatura', 1020.0000, 'ºC'),
	(200704, 120, '2014-02-15 00:33:43.000000', 'temperatura', 525.0000, 'ºC'),
	(200705, 120, '2014-02-15 00:33:44.000000', 'temperatura', 767.0000, 'ºC'),
	(200706, 120, '2014-02-15 00:33:45.000000', 'temperatura', 1061.0000, 'ºC'),
	(200707, 120, '2014-02-15 00:33:46.000000', 'temperatura', 603.0000, 'ºC'),
	(200708, 120, '2014-02-15 00:33:47.000000', 'temperatura', 1032.0000, 'ºC'),
	(200709, 120, '2014-02-15 00:33:48.000000', 'temperatura', 954.0000, 'ºC'),
	(200710, 120, '2014-02-15 00:33:49.000000', 'temperatura', 472.0000, 'ºC'),
	(200711, 120, '2014-02-15 00:33:50.000000', 'temperatura', 700.0000, 'ºC'),
	(200712, 120, '2014-02-15 00:33:51.000000', 'temperatura', 885.0000, 'ºC'),
	(200713, 120, '2014-02-15 00:33:52.000000', 'temperatura', 1124.0000, 'ºC'),
	(200714, 120, '2014-02-15 00:33:53.000000', 'temperatura', 568.0000, 'ºC'),
	(200715, 120, '2014-02-15 00:33:54.000000', 'temperatura', 667.0000, 'ºC'),
	(200716, 120, '2014-02-15 00:33:55.000000', 'temperatura', 430.0000, 'ºC'),
	(200717, 120, '2014-02-15 00:33:56.000000', 'temperatura', 149.0000, 'ºC'),
	(200718, 120, '2014-02-15 00:33:57.000000', 'temperatura', 659.0000, 'ºC'),
	(200719, 120, '2014-02-15 00:33:58.000000', 'temperatura', 445.0000, 'ºC'),
	(200720, 120, '2014-02-15 00:33:59.000000', 'temperatura', 249.0000, 'ºC'),
	(200721, 120, '2014-02-15 00:34:00.000000', 'temperatura', 1110.0000, 'ºC'),
	(200722, 120, '2014-02-15 00:34:01.000000', 'temperatura', 5.0000, 'ºC'),
	(200723, 120, '2014-02-15 00:34:02.000000', 'temperatura', 293.0000, 'ºC'),
	(200724, 120, '2014-02-15 00:34:03.000000', 'temperatura', 252.0000, 'ºC'),
	(200725, 120, '2014-02-15 00:34:04.000000', 'temperatura', 380.0000, 'ºC'),
	(200726, 120, '2014-02-15 00:34:05.000000', 'temperatura', 1147.0000, 'ºC'),
	(200727, 120, '2014-02-15 00:34:06.000000', 'temperatura', 994.0000, 'ºC'),
	(200728, 120, '2014-02-15 00:34:07.000000', 'temperatura', 331.0000, 'ºC'),
	(200729, 120, '2014-02-15 00:34:08.000000', 'temperatura', 1074.0000, 'ºC'),
	(200730, 120, '2014-02-15 00:34:09.000000', 'temperatura', 778.0000, 'ºC'),
	(200731, 120, '2014-02-15 00:34:10.000000', 'temperatura', 669.0000, 'ºC'),
	(200732, 120, '2014-02-15 00:34:11.000000', 'temperatura', 1011.0000, 'ºC'),
	(200733, 120, '2014-02-15 00:34:12.000000', 'temperatura', 649.0000, 'ºC'),
	(200734, 120, '2014-02-15 00:34:13.000000', 'temperatura', 212.0000, 'ºC'),
	(200735, 120, '2014-02-15 00:34:14.000000', 'temperatura', 312.0000, 'ºC'),
	(200736, 120, '2014-02-15 00:34:15.000000', 'temperatura', 927.0000, 'ºC'),
	(200737, 120, '2014-02-15 00:34:16.000000', 'temperatura', 97.0000, 'ºC'),
	(200738, 120, '2014-02-15 00:34:17.000000', 'temperatura', 106.0000, 'ºC'),
	(200739, 120, '2014-02-15 00:34:18.000000', 'temperatura', 239.0000, 'ºC'),
	(200740, 120, '2014-02-15 00:34:19.000000', 'temperatura', 877.0000, 'ºC'),
	(200741, 120, '2014-02-15 00:34:20.000000', 'temperatura', 71.0000, 'ºC'),
	(200742, 120, '2014-02-15 00:34:21.000000', 'temperatura', 122.0000, 'ºC'),
	(200743, 120, '2014-02-15 00:34:22.000000', 'temperatura', 397.0000, 'ºC'),
	(200744, 120, '2014-02-15 00:34:23.000000', 'temperatura', 420.0000, 'ºC'),
	(200745, 120, '2014-02-15 00:34:24.000000', 'temperatura', 908.0000, 'ºC'),
	(200746, 120, '2014-02-15 00:34:25.000000', 'temperatura', 882.0000, 'ºC'),
	(200747, 120, '2014-02-15 00:34:26.000000', 'temperatura', 487.0000, 'ºC'),
	(200748, 120, '2014-02-15 00:34:27.000000', 'temperatura', 987.0000, 'ºC'),
	(200749, 120, '2014-02-15 00:34:28.000000', 'temperatura', 1075.0000, 'ºC'),
	(200750, 120, '2014-02-15 00:34:29.000000', 'temperatura', 17.0000, 'ºC'),
	(200751, 120, '2014-02-15 00:34:30.000000', 'temperatura', 459.0000, 'ºC'),
	(200752, 120, '2014-02-15 00:34:31.000000', 'temperatura', 1046.0000, 'ºC'),
	(200753, 120, '2014-02-15 00:34:32.000000', 'temperatura', 251.0000, 'ºC'),
	(200754, 120, '2014-02-15 00:34:33.000000', 'temperatura', 519.0000, 'ºC'),
	(200755, 120, '2014-02-15 00:34:34.000000', 'temperatura', 643.0000, 'ºC'),
	(200756, 120, '2014-02-15 00:34:35.000000', 'temperatura', 459.0000, 'ºC'),
	(200757, 120, '2014-02-15 00:34:36.000000', 'temperatura', 367.0000, 'ºC'),
	(200758, 120, '2014-02-15 00:34:37.000000', 'temperatura', 458.0000, 'ºC'),
	(200759, 120, '2014-02-15 00:34:38.000000', 'temperatura', 1190.0000, 'ºC'),
	(200760, 120, '2014-02-15 00:34:39.000000', 'temperatura', 978.0000, 'ºC'),
	(200761, 120, '2014-02-15 00:34:40.000000', 'temperatura', 117.0000, 'ºC'),
	(200762, 120, '2014-02-15 00:34:41.000000', 'temperatura', 54.0000, 'ºC'),
	(200763, 120, '2014-02-15 00:34:42.000000', 'temperatura', 1117.0000, 'ºC'),
	(200764, 120, '2014-02-15 00:34:43.000000', 'temperatura', 627.0000, 'ºC'),
	(200765, 120, '2014-02-15 00:34:44.000000', 'temperatura', 982.0000, 'ºC'),
	(200766, 120, '2014-02-15 00:34:45.000000', 'temperatura', 631.0000, 'ºC'),
	(200767, 120, '2014-02-15 00:34:46.000000', 'temperatura', 207.0000, 'ºC'),
	(200768, 120, '2014-02-15 00:34:47.000000', 'temperatura', 344.0000, 'ºC'),
	(200769, 120, '2014-02-15 00:34:48.000000', 'temperatura', 1100.0000, 'ºC'),
	(200770, 120, '2014-02-15 00:34:49.000000', 'temperatura', 870.0000, 'ºC'),
	(200771, 120, '2014-02-15 00:34:50.000000', 'temperatura', 1047.0000, 'ºC'),
	(200772, 120, '2014-02-15 00:34:51.000000', 'temperatura', 228.0000, 'ºC'),
	(200773, 120, '2014-02-15 00:34:52.000000', 'temperatura', 398.0000, 'ºC'),
	(200774, 120, '2014-02-15 00:34:53.000000', 'temperatura', 106.0000, 'ºC'),
	(200775, 120, '2014-02-15 00:34:54.000000', 'temperatura', 536.0000, 'ºC'),
	(200776, 120, '2014-02-15 00:34:55.000000', 'temperatura', 1165.0000, 'ºC'),
	(200777, 120, '2014-02-15 00:34:56.000000', 'temperatura', 617.0000, 'ºC'),
	(200778, 120, '2014-02-15 00:34:57.000000', 'temperatura', 791.0000, 'ºC'),
	(200779, 120, '2014-02-15 00:34:58.000000', 'temperatura', 906.0000, 'ºC'),
	(200780, 120, '2014-02-15 00:34:59.000000', 'temperatura', 955.0000, 'ºC'),
	(200781, 120, '2014-02-15 00:35:00.000000', 'temperatura', 860.0000, 'ºC'),
	(200782, 120, '2014-02-15 00:35:01.000000', 'temperatura', 234.0000, 'ºC'),
	(200783, 120, '2014-02-15 00:35:02.000000', 'temperatura', 991.0000, 'ºC'),
	(200784, 120, '2014-02-15 00:35:03.000000', 'temperatura', 655.0000, 'ºC'),
	(200785, 120, '2014-02-15 00:35:04.000000', 'temperatura', 302.0000, 'ºC'),
	(200786, 120, '2014-02-15 00:35:05.000000', 'temperatura', 743.0000, 'ºC'),
	(200787, 120, '2014-02-15 00:35:06.000000', 'temperatura', 412.0000, 'ºC'),
	(200788, 120, '2014-02-15 00:35:07.000000', 'temperatura', 1029.0000, 'ºC'),
	(200789, 120, '2014-02-15 00:35:08.000000', 'temperatura', 310.0000, 'ºC'),
	(200790, 120, '2014-02-15 00:35:09.000000', 'temperatura', 862.0000, 'ºC'),
	(200791, 120, '2014-02-15 00:35:10.000000', 'temperatura', 984.0000, 'ºC'),
	(200792, 120, '2014-02-15 00:35:11.000000', 'temperatura', 1131.0000, 'ºC'),
	(200793, 120, '2014-02-15 00:35:12.000000', 'temperatura', 305.0000, 'ºC'),
	(200794, 120, '2014-02-15 00:35:13.000000', 'temperatura', 531.0000, 'ºC'),
	(200795, 120, '2014-02-15 00:35:14.000000', 'temperatura', 543.0000, 'ºC'),
	(200796, 120, '2014-02-15 00:35:15.000000', 'temperatura', 1121.0000, 'ºC'),
	(200797, 120, '2014-02-15 00:35:16.000000', 'temperatura', 376.0000, 'ºC'),
	(200798, 120, '2014-02-15 00:35:17.000000', 'temperatura', 917.0000, 'ºC'),
	(200799, 120, '2014-02-15 00:35:18.000000', 'temperatura', 1059.0000, 'ºC'),
	(200800, 120, '2014-02-15 00:35:19.000000', 'temperatura', 143.0000, 'ºC'),
	(200801, 120, '2014-02-15 00:35:20.000000', 'temperatura', 1141.0000, 'ºC'),
	(200802, 120, '2014-02-15 00:35:21.000000', 'temperatura', 473.0000, 'ºC'),
	(200803, 120, '2014-02-15 00:35:22.000000', 'temperatura', 146.0000, 'ºC'),
	(200804, 120, '2014-02-15 00:35:23.000000', 'temperatura', 509.0000, 'ºC'),
	(200805, 120, '2014-02-15 00:35:24.000000', 'temperatura', 909.0000, 'ºC'),
	(200806, 120, '2014-02-15 00:35:25.000000', 'temperatura', 617.0000, 'ºC'),
	(200807, 120, '2014-02-15 00:35:26.000000', 'temperatura', 359.0000, 'ºC'),
	(200808, 120, '2014-02-15 00:35:27.000000', 'temperatura', 1143.0000, 'ºC'),
	(200809, 120, '2014-02-15 00:35:28.000000', 'temperatura', 1039.0000, 'ºC'),
	(200810, 120, '2014-02-15 00:35:29.000000', 'temperatura', 565.0000, 'ºC'),
	(200811, 120, '2014-02-15 00:35:30.000000', 'temperatura', 911.0000, 'ºC'),
	(200812, 120, '2014-02-15 00:35:31.000000', 'temperatura', 460.0000, 'ºC'),
	(200813, 120, '2014-02-15 00:35:32.000000', 'temperatura', 767.0000, 'ºC'),
	(200814, 120, '2014-02-15 00:35:33.000000', 'temperatura', 56.0000, 'ºC'),
	(200815, 120, '2014-02-15 00:35:34.000000', 'temperatura', 381.0000, 'ºC'),
	(200816, 120, '2014-02-15 00:35:35.000000', 'temperatura', 537.0000, 'ºC'),
	(200817, 120, '2014-02-15 00:35:36.000000', 'temperatura', 342.0000, 'ºC'),
	(200818, 120, '2014-02-15 00:35:37.000000', 'temperatura', 99.0000, 'ºC'),
	(200819, 120, '2014-02-15 00:35:38.000000', 'temperatura', 671.0000, 'ºC'),
	(200820, 120, '2014-02-15 00:35:39.000000', 'temperatura', 658.0000, 'ºC'),
	(200821, 120, '2014-02-15 00:35:40.000000', 'temperatura', 76.0000, 'ºC'),
	(200822, 120, '2014-02-15 00:35:41.000000', 'temperatura', 807.0000, 'ºC'),
	(200823, 120, '2014-02-15 00:35:42.000000', 'temperatura', 208.0000, 'ºC'),
	(200824, 120, '2014-02-15 00:35:43.000000', 'temperatura', 1020.0000, 'ºC'),
	(200825, 120, '2014-02-15 00:35:44.000000', 'temperatura', 876.0000, 'ºC'),
	(200826, 120, '2014-02-15 00:35:45.000000', 'temperatura', 122.0000, 'ºC'),
	(200827, 120, '2014-02-15 00:35:46.000000', 'temperatura', 382.0000, 'ºC'),
	(200828, 120, '2014-02-15 00:35:47.000000', 'temperatura', 343.0000, 'ºC'),
	(200829, 120, '2014-02-15 00:35:48.000000', 'temperatura', 569.0000, 'ºC'),
	(200830, 120, '2014-02-15 00:35:49.000000', 'temperatura', 616.0000, 'ºC'),
	(200831, 120, '2014-02-15 00:35:50.000000', 'temperatura', 175.0000, 'ºC'),
	(200832, 120, '2014-02-15 00:35:51.000000', 'temperatura', 226.0000, 'ºC'),
	(200833, 120, '2014-02-15 00:35:52.000000', 'temperatura', 606.0000, 'ºC'),
	(200834, 120, '2014-02-15 00:35:53.000000', 'temperatura', 1153.0000, 'ºC'),
	(200835, 120, '2014-02-15 00:35:54.000000', 'temperatura', 346.0000, 'ºC'),
	(200836, 120, '2014-02-15 00:35:55.000000', 'temperatura', 672.0000, 'ºC'),
	(200837, 120, '2014-02-15 00:35:56.000000', 'temperatura', 1123.0000, 'ºC'),
	(200838, 120, '2014-02-15 00:35:57.000000', 'temperatura', 1.0000, 'ºC'),
	(200839, 120, '2014-02-15 00:35:58.000000', 'temperatura', 234.0000, 'ºC'),
	(200840, 120, '2014-02-15 00:35:59.000000', 'temperatura', 1171.0000, 'ºC'),
	(200841, 120, '2014-02-15 00:36:00.000000', 'temperatura', 350.0000, 'ºC'),
	(200842, 120, '2014-02-15 00:36:01.000000', 'temperatura', 638.0000, 'ºC'),
	(200843, 120, '2014-02-15 00:36:02.000000', 'temperatura', 941.0000, 'ºC'),
	(200844, 120, '2014-02-15 00:36:03.000000', 'temperatura', 392.0000, 'ºC'),
	(200845, 120, '2014-02-15 00:36:04.000000', 'temperatura', 339.0000, 'ºC'),
	(200846, 120, '2014-02-15 00:36:05.000000', 'temperatura', 518.0000, 'ºC'),
	(200847, 120, '2014-02-15 00:36:06.000000', 'temperatura', 373.0000, 'ºC'),
	(200848, 120, '2014-02-15 00:36:07.000000', 'temperatura', 310.0000, 'ºC'),
	(200849, 120, '2014-02-15 00:36:08.000000', 'temperatura', 432.0000, 'ºC'),
	(200850, 120, '2014-02-15 00:36:09.000000', 'temperatura', 31.0000, 'ºC'),
	(200851, 120, '2014-02-15 00:36:10.000000', 'temperatura', 62.0000, 'ºC'),
	(200852, 120, '2014-02-15 00:36:11.000000', 'temperatura', 214.0000, 'ºC'),
	(200853, 120, '2014-02-15 00:36:12.000000', 'temperatura', 885.0000, 'ºC'),
	(200854, 120, '2014-02-15 00:36:13.000000', 'temperatura', 184.0000, 'ºC'),
	(200855, 120, '2014-02-15 00:36:14.000000', 'temperatura', 665.0000, 'ºC'),
	(200856, 120, '2014-02-15 00:36:15.000000', 'temperatura', 376.0000, 'ºC'),
	(200857, 120, '2014-02-15 00:36:16.000000', 'temperatura', 1083.0000, 'ºC'),
	(200858, 120, '2014-02-15 00:36:17.000000', 'temperatura', 690.0000, 'ºC'),
	(200859, 120, '2014-02-15 00:36:18.000000', 'temperatura', 200.0000, 'ºC'),
	(200860, 120, '2014-02-15 00:36:19.000000', 'temperatura', 129.0000, 'ºC'),
	(200861, 120, '2014-02-15 00:36:20.000000', 'temperatura', 45.0000, 'ºC'),
	(200862, 120, '2014-02-15 00:36:21.000000', 'temperatura', 1039.0000, 'ºC'),
	(200863, 120, '2014-02-15 00:36:22.000000', 'temperatura', 262.0000, 'ºC'),
	(200864, 120, '2014-02-15 00:36:23.000000', 'temperatura', 593.0000, 'ºC'),
	(200865, 120, '2014-02-15 00:36:24.000000', 'temperatura', 980.0000, 'ºC'),
	(200866, 120, '2014-02-15 00:36:25.000000', 'temperatura', 721.0000, 'ºC'),
	(200867, 120, '2014-02-15 00:36:26.000000', 'temperatura', 665.0000, 'ºC'),
	(200868, 120, '2014-02-15 00:36:27.000000', 'temperatura', 1161.0000, 'ºC'),
	(200869, 120, '2014-02-15 00:36:28.000000', 'temperatura', 213.0000, 'ºC'),
	(200870, 120, '2014-02-15 00:36:29.000000', 'temperatura', 1180.0000, 'ºC'),
	(200871, 120, '2014-02-15 00:36:30.000000', 'temperatura', 464.0000, 'ºC'),
	(200872, 120, '2014-02-15 00:36:31.000000', 'temperatura', 1178.0000, 'ºC'),
	(200873, 120, '2014-02-15 00:36:32.000000', 'temperatura', 898.0000, 'ºC'),
	(200874, 120, '2014-02-15 00:36:33.000000', 'temperatura', 959.0000, 'ºC'),
	(200875, 120, '2014-02-15 00:36:34.000000', 'temperatura', 899.0000, 'ºC'),
	(200876, 120, '2014-02-15 00:36:35.000000', 'temperatura', 421.0000, 'ºC'),
	(200877, 120, '2014-02-15 00:36:36.000000', 'temperatura', 607.0000, 'ºC'),
	(200878, 120, '2014-02-15 00:36:37.000000', 'temperatura', 573.0000, 'ºC'),
	(200879, 120, '2014-02-15 00:36:38.000000', 'temperatura', 1043.0000, 'ºC'),
	(200880, 120, '2014-02-15 00:36:39.000000', 'temperatura', 1097.0000, 'ºC'),
	(200881, 120, '2014-02-15 00:36:40.000000', 'temperatura', 1156.0000, 'ºC'),
	(200882, 120, '2014-02-15 00:36:41.000000', 'temperatura', 89.0000, 'ºC'),
	(200883, 120, '2014-02-15 00:36:42.000000', 'temperatura', 578.0000, 'ºC'),
	(200884, 120, '2014-02-15 00:36:43.000000', 'temperatura', 222.0000, 'ºC'),
	(200885, 120, '2014-02-15 00:36:44.000000', 'temperatura', 576.0000, 'ºC'),
	(200886, 120, '2014-02-15 00:36:45.000000', 'temperatura', 1015.0000, 'ºC'),
	(200887, 120, '2014-02-15 00:36:46.000000', 'temperatura', 949.0000, 'ºC'),
	(200888, 120, '2014-02-15 00:36:47.000000', 'temperatura', 500.0000, 'ºC'),
	(200889, 120, '2014-02-15 00:36:48.000000', 'temperatura', 851.0000, 'ºC'),
	(200890, 120, '2014-02-15 00:36:49.000000', 'temperatura', 358.0000, 'ºC'),
	(200891, 120, '2014-02-15 00:36:50.000000', 'temperatura', 437.0000, 'ºC'),
	(200892, 120, '2014-02-15 00:36:51.000000', 'temperatura', 1112.0000, 'ºC'),
	(200893, 120, '2014-02-15 00:36:52.000000', 'temperatura', 650.0000, 'ºC'),
	(200894, 120, '2014-02-15 00:36:53.000000', 'temperatura', 1113.0000, 'ºC'),
	(200895, 120, '2014-02-15 00:36:54.000000', 'temperatura', 15.0000, 'ºC'),
	(200896, 120, '2014-02-15 00:36:55.000000', 'temperatura', 336.0000, 'ºC'),
	(200897, 120, '2014-02-15 00:36:56.000000', 'temperatura', 437.0000, 'ºC'),
	(200898, 120, '2014-02-15 00:36:57.000000', 'temperatura', 1177.0000, 'ºC'),
	(200899, 120, '2014-02-15 00:36:58.000000', 'temperatura', 977.0000, 'ºC'),
	(200900, 120, '2014-02-15 00:36:59.000000', 'temperatura', 151.0000, 'ºC'),
	(200901, 120, '2014-02-15 00:37:00.000000', 'temperatura', 227.0000, 'ºC'),
	(200902, 120, '2014-02-15 00:37:01.000000', 'temperatura', 681.0000, 'ºC'),
	(200903, 120, '2014-02-15 00:37:02.000000', 'temperatura', 326.0000, 'ºC'),
	(200904, 120, '2014-02-15 00:37:03.000000', 'temperatura', 786.0000, 'ºC'),
	(200905, 120, '2014-02-15 00:37:04.000000', 'temperatura', 554.0000, 'ºC'),
	(200906, 120, '2014-02-15 00:37:05.000000', 'temperatura', 411.0000, 'ºC'),
	(200907, 120, '2014-02-15 00:37:06.000000', 'temperatura', 395.0000, 'ºC'),
	(200908, 120, '2014-02-15 00:37:07.000000', 'temperatura', 743.0000, 'ºC'),
	(200909, 120, '2014-02-15 00:37:08.000000', 'temperatura', 132.0000, 'ºC'),
	(200910, 120, '2014-02-15 00:37:09.000000', 'temperatura', 829.0000, 'ºC'),
	(200911, 120, '2014-02-15 00:37:10.000000', 'temperatura', 148.0000, 'ºC'),
	(200912, 120, '2014-02-15 00:37:11.000000', 'temperatura', 657.0000, 'ºC'),
	(200913, 120, '2014-02-15 00:37:12.000000', 'temperatura', 438.0000, 'ºC'),
	(200914, 120, '2014-02-15 00:37:13.000000', 'temperatura', 221.0000, 'ºC'),
	(200915, 120, '2014-02-15 00:37:14.000000', 'temperatura', 991.0000, 'ºC'),
	(200916, 120, '2014-02-15 00:37:15.000000', 'temperatura', 692.0000, 'ºC'),
	(200917, 120, '2014-02-15 00:37:16.000000', 'temperatura', 490.0000, 'ºC'),
	(200918, 120, '2014-02-15 00:37:17.000000', 'temperatura', 373.0000, 'ºC'),
	(200919, 120, '2014-02-15 00:37:18.000000', 'temperatura', 394.0000, 'ºC'),
	(200920, 120, '2014-02-15 00:37:19.000000', 'temperatura', 853.0000, 'ºC'),
	(200921, 120, '2014-02-15 00:37:20.000000', 'temperatura', 682.0000, 'ºC'),
	(200922, 120, '2014-02-15 00:37:21.000000', 'temperatura', 851.0000, 'ºC'),
	(200923, 120, '2014-02-15 00:37:22.000000', 'temperatura', 1013.0000, 'ºC'),
	(200924, 120, '2014-02-15 00:37:23.000000', 'temperatura', 109.0000, 'ºC'),
	(200925, 120, '2014-02-15 00:37:24.000000', 'temperatura', 1107.0000, 'ºC'),
	(200926, 120, '2014-02-15 00:37:25.000000', 'temperatura', 408.0000, 'ºC'),
	(200927, 120, '2014-02-15 00:37:26.000000', 'temperatura', 1122.0000, 'ºC'),
	(200928, 120, '2014-02-15 00:37:27.000000', 'temperatura', 786.0000, 'ºC'),
	(200929, 120, '2014-02-15 00:37:28.000000', 'temperatura', 565.0000, 'ºC'),
	(200930, 120, '2014-02-15 00:37:29.000000', 'temperatura', 466.0000, 'ºC'),
	(200931, 120, '2014-02-15 00:37:30.000000', 'temperatura', 637.0000, 'ºC'),
	(200932, 120, '2014-02-15 00:37:31.000000', 'temperatura', 587.0000, 'ºC'),
	(200933, 120, '2014-02-15 00:37:32.000000', 'temperatura', 1022.0000, 'ºC'),
	(200934, 120, '2014-02-15 00:37:33.000000', 'temperatura', 953.0000, 'ºC'),
	(200935, 120, '2014-02-15 00:37:34.000000', 'temperatura', 498.0000, 'ºC'),
	(200936, 120, '2014-02-15 00:37:35.000000', 'temperatura', 832.0000, 'ºC'),
	(200937, 120, '2014-02-15 00:37:36.000000', 'temperatura', 265.0000, 'ºC'),
	(200938, 120, '2014-02-15 00:37:37.000000', 'temperatura', 32.0000, 'ºC'),
	(200939, 120, '2014-02-15 00:37:38.000000', 'temperatura', 566.0000, 'ºC'),
	(200940, 120, '2014-02-15 00:37:39.000000', 'temperatura', 334.0000, 'ºC'),
	(200941, 120, '2014-02-15 00:37:40.000000', 'temperatura', 1172.0000, 'ºC'),
	(200942, 120, '2014-02-15 00:37:41.000000', 'temperatura', 58.0000, 'ºC'),
	(200943, 120, '2014-02-15 00:37:42.000000', 'temperatura', 374.0000, 'ºC'),
	(200944, 120, '2014-02-15 00:37:43.000000', 'temperatura', 499.0000, 'ºC'),
	(200945, 120, '2014-02-15 00:37:44.000000', 'temperatura', 173.0000, 'ºC'),
	(200946, 120, '2014-02-15 00:37:45.000000', 'temperatura', 567.0000, 'ºC'),
	(200947, 120, '2014-02-15 00:37:46.000000', 'temperatura', 1116.0000, 'ºC'),
	(200948, 120, '2014-02-15 00:37:47.000000', 'temperatura', 282.0000, 'ºC'),
	(200949, 120, '2014-02-15 00:37:48.000000', 'temperatura', 462.0000, 'ºC'),
	(200950, 120, '2014-02-15 00:37:49.000000', 'temperatura', 266.0000, 'ºC'),
	(200951, 120, '2014-02-15 00:37:50.000000', 'temperatura', 1143.0000, 'ºC'),
	(200952, 120, '2014-02-15 00:37:51.000000', 'temperatura', 119.0000, 'ºC'),
	(200953, 120, '2014-02-15 00:37:52.000000', 'temperatura', 764.0000, 'ºC'),
	(200954, 120, '2014-02-15 00:37:53.000000', 'temperatura', 1063.0000, 'ºC'),
	(200955, 120, '2014-02-15 00:37:54.000000', 'temperatura', 623.0000, 'ºC'),
	(200956, 120, '2014-02-15 00:37:55.000000', 'temperatura', 1129.0000, 'ºC'),
	(200957, 120, '2014-02-15 00:37:56.000000', 'temperatura', 175.0000, 'ºC'),
	(200958, 120, '2014-02-15 00:37:57.000000', 'temperatura', 1087.0000, 'ºC'),
	(200959, 120, '2014-02-15 00:37:58.000000', 'temperatura', 113.0000, 'ºC'),
	(200960, 120, '2014-02-15 00:37:59.000000', 'temperatura', 905.0000, 'ºC'),
	(200961, 120, '2014-02-15 00:38:00.000000', 'temperatura', 584.0000, 'ºC'),
	(200962, 120, '2014-02-15 00:38:01.000000', 'temperatura', 206.0000, 'ºC'),
	(200963, 120, '2014-02-15 00:38:02.000000', 'temperatura', 477.0000, 'ºC'),
	(200964, 120, '2014-02-15 00:38:03.000000', 'temperatura', 568.0000, 'ºC'),
	(200965, 120, '2014-02-15 00:38:04.000000', 'temperatura', 212.0000, 'ºC'),
	(200966, 120, '2014-02-15 00:38:05.000000', 'temperatura', 553.0000, 'ºC'),
	(200967, 120, '2014-02-15 00:38:06.000000', 'temperatura', 932.0000, 'ºC'),
	(200968, 120, '2014-02-15 00:38:07.000000', 'temperatura', 602.0000, 'ºC'),
	(200969, 120, '2014-02-15 00:38:08.000000', 'temperatura', 216.0000, 'ºC'),
	(200970, 120, '2014-02-15 00:38:09.000000', 'temperatura', 471.0000, 'ºC'),
	(200971, 120, '2014-02-15 00:38:10.000000', 'temperatura', 510.0000, 'ºC'),
	(200972, 120, '2014-02-15 00:38:11.000000', 'temperatura', 1135.0000, 'ºC'),
	(200973, 120, '2014-02-15 00:38:12.000000', 'temperatura', 546.0000, 'ºC'),
	(200974, 120, '2014-02-15 00:38:13.000000', 'temperatura', 527.0000, 'ºC'),
	(200975, 120, '2014-02-15 00:38:14.000000', 'temperatura', 995.0000, 'ºC'),
	(200976, 120, '2014-02-15 00:38:15.000000', 'temperatura', 996.0000, 'ºC'),
	(200977, 120, '2014-02-15 00:38:16.000000', 'temperatura', 796.0000, 'ºC'),
	(200978, 120, '2014-02-15 00:38:17.000000', 'temperatura', 992.0000, 'ºC'),
	(200979, 120, '2014-02-15 00:38:18.000000', 'temperatura', 172.0000, 'ºC'),
	(200980, 120, '2014-02-15 00:38:19.000000', 'temperatura', 284.0000, 'ºC'),
	(200981, 120, '2014-02-15 00:38:20.000000', 'temperatura', 905.0000, 'ºC'),
	(200982, 120, '2014-02-15 00:38:21.000000', 'temperatura', 73.0000, 'ºC'),
	(200983, 120, '2014-02-15 00:38:22.000000', 'temperatura', 52.0000, 'ºC'),
	(200984, 120, '2014-02-15 00:38:23.000000', 'temperatura', 39.0000, 'ºC'),
	(200985, 120, '2014-02-15 00:38:24.000000', 'temperatura', 39.0000, 'ºC'),
	(200986, 120, '2014-02-15 00:38:25.000000', 'temperatura', 81.0000, 'ºC'),
	(200987, 120, '2014-02-15 00:38:26.000000', 'temperatura', 289.0000, 'ºC'),
	(200988, 120, '2014-02-15 00:38:27.000000', 'temperatura', 2.0000, 'ºC'),
	(200989, 120, '2014-02-15 00:38:28.000000', 'temperatura', 343.0000, 'ºC'),
	(200990, 120, '2014-02-15 00:38:29.000000', 'temperatura', 511.0000, 'ºC'),
	(200991, 120, '2014-02-15 00:38:30.000000', 'temperatura', 327.0000, 'ºC'),
	(200992, 120, '2014-02-15 00:38:31.000000', 'temperatura', 102.0000, 'ºC'),
	(200993, 120, '2014-02-15 00:38:32.000000', 'temperatura', 731.0000, 'ºC'),
	(200994, 120, '2014-02-15 00:38:33.000000', 'temperatura', 948.0000, 'ºC'),
	(200995, 120, '2014-02-15 00:38:34.000000', 'temperatura', 146.0000, 'ºC'),
	(200996, 120, '2014-02-15 00:38:35.000000', 'temperatura', 286.0000, 'ºC'),
	(200997, 120, '2014-02-15 00:38:36.000000', 'temperatura', 993.0000, 'ºC'),
	(200998, 120, '2014-02-15 00:38:37.000000', 'temperatura', 507.0000, 'ºC'),
	(200999, 120, '2014-02-15 00:38:38.000000', 'temperatura', 758.0000, 'ºC'),
	(201000, 120, '2014-02-15 00:38:39.000000', 'temperatura', 1068.0000, 'ºC'),
	(201001, 120, '2014-02-15 00:38:40.000000', 'temperatura', 669.0000, 'ºC'),
	(201002, 120, '2014-02-15 00:38:41.000000', 'temperatura', 141.0000, 'ºC'),
	(201003, 120, '2014-02-15 00:38:42.000000', 'temperatura', 1097.0000, 'ºC'),
	(201004, 120, '2014-02-15 00:38:43.000000', 'temperatura', 263.0000, 'ºC'),
	(201005, 120, '2014-02-15 00:38:44.000000', 'temperatura', 427.0000, 'ºC'),
	(201006, 120, '2014-02-15 00:38:45.000000', 'temperatura', 144.0000, 'ºC'),
	(201007, 120, '2014-02-15 00:38:46.000000', 'temperatura', 639.0000, 'ºC'),
	(201008, 120, '2014-02-15 00:38:47.000000', 'temperatura', 364.0000, 'ºC'),
	(201009, 120, '2014-02-15 00:38:48.000000', 'temperatura', 1105.0000, 'ºC'),
	(201010, 120, '2014-02-15 00:38:49.000000', 'temperatura', 834.0000, 'ºC'),
	(201011, 120, '2014-02-15 00:38:50.000000', 'temperatura', 856.0000, 'ºC'),
	(201012, 120, '2014-02-15 00:38:51.000000', 'temperatura', 576.0000, 'ºC'),
	(201013, 120, '2014-02-15 00:38:52.000000', 'temperatura', 313.0000, 'ºC'),
	(201014, 120, '2014-02-15 00:38:53.000000', 'temperatura', 1039.0000, 'ºC'),
	(201015, 120, '2014-02-15 00:38:54.000000', 'temperatura', 655.0000, 'ºC'),
	(201016, 120, '2014-02-15 00:38:55.000000', 'temperatura', 161.0000, 'ºC'),
	(201017, 120, '2014-02-15 00:38:56.000000', 'temperatura', 39.0000, 'ºC'),
	(201018, 120, '2014-02-15 00:38:57.000000', 'temperatura', 911.0000, 'ºC'),
	(201019, 120, '2014-02-15 00:38:58.000000', 'temperatura', 841.0000, 'ºC'),
	(201020, 120, '2014-02-15 00:38:59.000000', 'temperatura', 272.0000, 'ºC'),
	(201021, 120, '2014-02-15 00:39:00.000000', 'temperatura', 37.0000, 'ºC'),
	(201022, 120, '2014-02-15 00:39:01.000000', 'temperatura', 568.0000, 'ºC'),
	(201023, 120, '2014-02-15 00:39:02.000000', 'temperatura', 332.0000, 'ºC'),
	(201024, 120, '2014-02-15 00:39:03.000000', 'temperatura', 1156.0000, 'ºC'),
	(201025, 120, '2014-02-15 00:39:04.000000', 'temperatura', 1185.0000, 'ºC'),
	(201026, 120, '2014-02-15 00:39:05.000000', 'temperatura', 58.0000, 'ºC'),
	(201027, 120, '2014-02-15 00:39:06.000000', 'temperatura', 337.0000, 'ºC'),
	(201028, 120, '2014-02-15 00:39:07.000000', 'temperatura', 309.0000, 'ºC'),
	(201029, 120, '2014-02-15 00:39:08.000000', 'temperatura', 537.0000, 'ºC'),
	(201030, 120, '2014-02-15 00:39:09.000000', 'temperatura', 555.0000, 'ºC'),
	(201031, 120, '2014-02-15 00:39:10.000000', 'temperatura', 1167.0000, 'ºC'),
	(201032, 120, '2014-02-15 00:39:11.000000', 'temperatura', 569.0000, 'ºC'),
	(201033, 120, '2014-02-15 00:39:12.000000', 'temperatura', 544.0000, 'ºC'),
	(201034, 120, '2014-02-15 00:39:13.000000', 'temperatura', 1016.0000, 'ºC'),
	(201035, 120, '2014-02-15 00:39:14.000000', 'temperatura', 1047.0000, 'ºC'),
	(201036, 120, '2014-02-15 00:39:15.000000', 'temperatura', 989.0000, 'ºC'),
	(201037, 120, '2014-02-15 00:39:16.000000', 'temperatura', 604.0000, 'ºC'),
	(201038, 120, '2014-02-15 00:39:17.000000', 'temperatura', 54.0000, 'ºC'),
	(201039, 120, '2014-02-15 00:39:18.000000', 'temperatura', 857.0000, 'ºC'),
	(201040, 120, '2014-02-15 00:39:19.000000', 'temperatura', 523.0000, 'ºC'),
	(201041, 120, '2014-02-15 00:39:20.000000', 'temperatura', 46.0000, 'ºC'),
	(201042, 120, '2014-02-15 00:39:21.000000', 'temperatura', 1063.0000, 'ºC'),
	(201043, 120, '2014-02-15 00:39:22.000000', 'temperatura', 376.0000, 'ºC'),
	(201044, 120, '2014-02-15 00:39:23.000000', 'temperatura', 1092.0000, 'ºC'),
	(201045, 120, '2014-02-15 00:39:24.000000', 'temperatura', 730.0000, 'ºC'),
	(201046, 120, '2014-02-15 00:39:25.000000', 'temperatura', 377.0000, 'ºC'),
	(201047, 120, '2014-02-15 00:39:26.000000', 'temperatura', 894.0000, 'ºC'),
	(201048, 120, '2014-02-15 00:39:27.000000', 'temperatura', 939.0000, 'ºC'),
	(201049, 120, '2014-02-15 00:39:28.000000', 'temperatura', 814.0000, 'ºC'),
	(201050, 120, '2014-02-15 00:39:29.000000', 'temperatura', 55.0000, 'ºC'),
	(201051, 120, '2014-02-15 00:39:30.000000', 'temperatura', 232.0000, 'ºC'),
	(201052, 120, '2014-02-15 00:39:31.000000', 'temperatura', 995.0000, 'ºC'),
	(201053, 120, '2014-02-15 00:39:32.000000', 'temperatura', 680.0000, 'ºC'),
	(201054, 120, '2014-02-15 00:39:33.000000', 'temperatura', 416.0000, 'ºC'),
	(201055, 120, '2014-02-15 00:39:34.000000', 'temperatura', 40.0000, 'ºC'),
	(201056, 120, '2014-02-15 00:39:35.000000', 'temperatura', 154.0000, 'ºC'),
	(201057, 120, '2014-02-15 00:39:36.000000', 'temperatura', 649.0000, 'ºC'),
	(201058, 120, '2014-02-15 00:39:37.000000', 'temperatura', 386.0000, 'ºC'),
	(201059, 120, '2014-02-15 00:39:38.000000', 'temperatura', 1181.0000, 'ºC'),
	(201060, 120, '2014-02-15 00:39:39.000000', 'temperatura', 1150.0000, 'ºC'),
	(201061, 120, '2014-02-15 00:39:40.000000', 'temperatura', 1007.0000, 'ºC'),
	(201062, 120, '2014-02-15 00:39:41.000000', 'temperatura', 384.0000, 'ºC'),
	(201063, 120, '2014-02-15 00:39:42.000000', 'temperatura', 99.0000, 'ºC'),
	(201064, 120, '2014-02-15 00:39:43.000000', 'temperatura', 543.0000, 'ºC'),
	(201065, 120, '2014-02-15 00:39:44.000000', 'temperatura', 17.0000, 'ºC'),
	(201066, 120, '2014-02-15 00:39:45.000000', 'temperatura', 860.0000, 'ºC'),
	(201067, 120, '2014-02-15 00:39:46.000000', 'temperatura', 649.0000, 'ºC'),
	(201068, 120, '2014-02-15 00:39:47.000000', 'temperatura', 663.0000, 'ºC'),
	(201069, 120, '2014-02-15 00:39:48.000000', 'temperatura', 170.0000, 'ºC'),
	(201070, 120, '2014-02-15 00:39:49.000000', 'temperatura', 62.0000, 'ºC'),
	(201071, 120, '2014-02-15 00:39:50.000000', 'temperatura', 999.0000, 'ºC'),
	(201072, 120, '2014-02-15 00:39:51.000000', 'temperatura', 9.0000, 'ºC'),
	(201073, 120, '2014-02-15 00:39:52.000000', 'temperatura', 651.0000, 'ºC'),
	(201074, 120, '2014-02-15 00:39:53.000000', 'temperatura', 829.0000, 'ºC'),
	(201075, 120, '2014-02-15 00:39:54.000000', 'temperatura', 993.0000, 'ºC'),
	(201076, 120, '2014-02-15 00:39:55.000000', 'temperatura', 75.0000, 'ºC'),
	(201077, 120, '2014-02-15 00:39:56.000000', 'temperatura', 1000.0000, 'ºC'),
	(201078, 120, '2014-02-15 00:39:57.000000', 'temperatura', 1173.0000, 'ºC'),
	(201079, 120, '2014-02-15 00:39:58.000000', 'temperatura', 468.0000, 'ºC'),
	(201080, 120, '2014-02-15 00:39:59.000000', 'temperatura', 22.0000, 'ºC'),
	(201081, 120, '2014-02-15 00:40:00.000000', 'temperatura', 1105.0000, 'ºC'),
	(201082, 120, '2014-02-15 00:40:01.000000', 'temperatura', 660.0000, 'ºC'),
	(201083, 120, '2014-02-15 00:40:02.000000', 'temperatura', 1185.0000, 'ºC'),
	(201084, 120, '2014-02-15 00:40:03.000000', 'temperatura', 344.0000, 'ºC'),
	(201085, 120, '2014-02-15 00:40:04.000000', 'temperatura', 565.0000, 'ºC'),
	(201086, 120, '2014-02-15 00:40:05.000000', 'temperatura', 596.0000, 'ºC'),
	(201087, 120, '2014-02-15 00:40:06.000000', 'temperatura', 85.0000, 'ºC'),
	(201088, 120, '2014-02-15 00:40:07.000000', 'temperatura', 1036.0000, 'ºC'),
	(201089, 120, '2014-02-15 00:40:08.000000', 'temperatura', 125.0000, 'ºC'),
	(201090, 120, '2014-02-15 00:40:09.000000', 'temperatura', 1120.0000, 'ºC'),
	(201091, 120, '2014-02-15 00:40:10.000000', 'temperatura', 424.0000, 'ºC'),
	(201092, 120, '2014-02-15 00:40:11.000000', 'temperatura', 1163.0000, 'ºC'),
	(201093, 120, '2014-02-15 00:40:12.000000', 'temperatura', 941.0000, 'ºC'),
	(201094, 120, '2014-02-15 00:40:13.000000', 'temperatura', 17.0000, 'ºC'),
	(201095, 120, '2014-02-15 00:40:14.000000', 'temperatura', 863.0000, 'ºC'),
	(201096, 120, '2014-02-15 00:40:15.000000', 'temperatura', 665.0000, 'ºC'),
	(201097, 120, '2014-02-15 00:40:16.000000', 'temperatura', 736.0000, 'ºC'),
	(201098, 120, '2014-02-15 00:40:17.000000', 'temperatura', 486.0000, 'ºC'),
	(201099, 120, '2014-02-15 00:40:18.000000', 'temperatura', 221.0000, 'ºC'),
	(201100, 120, '2014-02-15 00:40:19.000000', 'temperatura', 848.0000, 'ºC'),
	(201101, 120, '2014-02-15 00:40:20.000000', 'temperatura', 1176.0000, 'ºC'),
	(201102, 120, '2014-02-15 00:40:21.000000', 'temperatura', 940.0000, 'ºC'),
	(201103, 120, '2014-02-15 00:40:22.000000', 'temperatura', 1170.0000, 'ºC'),
	(201104, 120, '2014-02-15 00:40:23.000000', 'temperatura', 629.0000, 'ºC'),
	(201105, 120, '2014-02-15 00:40:24.000000', 'temperatura', 839.0000, 'ºC'),
	(201106, 120, '2014-02-15 00:40:25.000000', 'temperatura', 1106.0000, 'ºC'),
	(201107, 120, '2014-02-15 00:40:26.000000', 'temperatura', 616.0000, 'ºC'),
	(201108, 120, '2014-02-15 00:40:27.000000', 'temperatura', 963.0000, 'ºC'),
	(201109, 120, '2014-02-15 00:40:28.000000', 'temperatura', 564.0000, 'ºC'),
	(201110, 120, '2014-02-15 00:40:29.000000', 'temperatura', 1134.0000, 'ºC'),
	(201111, 120, '2014-02-15 00:40:30.000000', 'temperatura', 377.0000, 'ºC'),
	(201112, 120, '2014-02-15 00:40:31.000000', 'temperatura', 884.0000, 'ºC'),
	(201113, 120, '2014-02-15 00:40:32.000000', 'temperatura', 890.0000, 'ºC'),
	(201114, 120, '2014-02-15 00:40:33.000000', 'temperatura', 599.0000, 'ºC'),
	(201115, 120, '2014-02-15 00:40:34.000000', 'temperatura', 326.0000, 'ºC'),
	(201116, 120, '2014-02-15 00:40:35.000000', 'temperatura', 1034.0000, 'ºC'),
	(201117, 120, '2014-02-15 00:40:36.000000', 'temperatura', 593.0000, 'ºC'),
	(201118, 120, '2014-02-15 00:40:37.000000', 'temperatura', 1062.0000, 'ºC'),
	(201119, 120, '2014-02-15 00:40:38.000000', 'temperatura', 1134.0000, 'ºC'),
	(201120, 120, '2014-02-15 00:40:39.000000', 'temperatura', 82.0000, 'ºC'),
	(201121, 120, '2014-02-15 00:40:40.000000', 'temperatura', 608.0000, 'ºC'),
	(201122, 120, '2014-02-15 00:40:41.000000', 'temperatura', 394.0000, 'ºC'),
	(201123, 120, '2014-02-15 00:40:42.000000', 'temperatura', 146.0000, 'ºC'),
	(201124, 120, '2014-02-15 00:40:43.000000', 'temperatura', 749.0000, 'ºC'),
	(201125, 120, '2014-02-15 00:40:44.000000', 'temperatura', 908.0000, 'ºC'),
	(201126, 120, '2014-02-15 00:40:45.000000', 'temperatura', 1093.0000, 'ºC'),
	(201127, 120, '2014-02-15 00:40:46.000000', 'temperatura', 341.0000, 'ºC'),
	(201128, 120, '2014-02-15 00:40:47.000000', 'temperatura', 827.0000, 'ºC'),
	(201129, 120, '2014-02-15 00:40:48.000000', 'temperatura', 711.0000, 'ºC'),
	(201130, 120, '2014-02-15 00:40:49.000000', 'temperatura', 1077.0000, 'ºC'),
	(201131, 120, '2014-02-15 00:40:50.000000', 'temperatura', 850.0000, 'ºC'),
	(201132, 120, '2014-02-15 00:40:51.000000', 'temperatura', 1022.0000, 'ºC'),
	(201133, 120, '2014-02-15 00:40:52.000000', 'temperatura', 158.0000, 'ºC'),
	(201134, 120, '2014-02-15 00:40:53.000000', 'temperatura', 124.0000, 'ºC'),
	(201135, 120, '2014-02-15 00:40:54.000000', 'temperatura', 147.0000, 'ºC'),
	(201136, 120, '2014-02-15 00:40:55.000000', 'temperatura', 363.0000, 'ºC'),
	(201137, 120, '2014-02-15 00:40:56.000000', 'temperatura', 173.0000, 'ºC'),
	(201138, 120, '2014-02-15 00:40:57.000000', 'temperatura', 979.0000, 'ºC'),
	(201139, 120, '2014-02-15 00:40:58.000000', 'temperatura', 774.0000, 'ºC'),
	(201140, 120, '2014-02-15 00:40:59.000000', 'temperatura', 935.0000, 'ºC'),
	(201141, 120, '2014-02-15 00:41:00.000000', 'temperatura', 1153.0000, 'ºC'),
	(201142, 120, '2014-02-15 00:41:01.000000', 'temperatura', 562.0000, 'ºC'),
	(201143, 120, '2014-02-15 00:41:02.000000', 'temperatura', 551.0000, 'ºC'),
	(201144, 120, '2014-02-15 00:41:03.000000', 'temperatura', 1071.0000, 'ºC'),
	(201145, 120, '2014-02-15 00:41:04.000000', 'temperatura', 100.0000, 'ºC'),
	(201146, 120, '2014-02-15 00:41:05.000000', 'temperatura', 890.0000, 'ºC'),
	(201147, 120, '2014-02-15 00:41:06.000000', 'temperatura', 549.0000, 'ºC'),
	(201148, 120, '2014-02-15 00:41:07.000000', 'temperatura', 77.0000, 'ºC'),
	(201149, 120, '2014-02-15 00:41:08.000000', 'temperatura', 1137.0000, 'ºC'),
	(201150, 120, '2014-02-15 00:41:09.000000', 'temperatura', 653.0000, 'ºC'),
	(201151, 120, '2014-02-15 00:41:10.000000', 'temperatura', 1055.0000, 'ºC'),
	(201152, 120, '2014-02-15 00:41:11.000000', 'temperatura', 919.0000, 'ºC'),
	(201153, 120, '2014-02-15 00:41:12.000000', 'temperatura', 228.0000, 'ºC'),
	(201154, 120, '2014-02-15 00:41:13.000000', 'temperatura', 786.0000, 'ºC'),
	(201155, 120, '2014-02-15 00:41:14.000000', 'temperatura', 846.0000, 'ºC'),
	(201156, 120, '2014-02-15 00:41:15.000000', 'temperatura', 673.0000, 'ºC'),
	(201157, 120, '2014-02-15 00:41:16.000000', 'temperatura', 828.0000, 'ºC'),
	(201158, 120, '2014-02-15 00:41:17.000000', 'temperatura', 922.0000, 'ºC'),
	(201159, 120, '2014-02-15 00:41:18.000000', 'temperatura', 928.0000, 'ºC'),
	(201160, 120, '2014-02-15 00:41:19.000000', 'temperatura', 671.0000, 'ºC'),
	(201161, 120, '2014-02-15 00:41:20.000000', 'temperatura', 575.0000, 'ºC'),
	(201162, 120, '2014-02-15 00:41:21.000000', 'temperatura', 860.0000, 'ºC'),
	(201163, 120, '2014-02-15 00:41:22.000000', 'temperatura', 175.0000, 'ºC'),
	(201164, 120, '2014-02-15 00:41:23.000000', 'temperatura', 698.0000, 'ºC'),
	(201165, 120, '2014-02-15 00:41:24.000000', 'temperatura', 563.0000, 'ºC'),
	(201166, 120, '2014-02-15 00:41:25.000000', 'temperatura', 721.0000, 'ºC'),
	(201167, 120, '2014-02-15 00:41:26.000000', 'temperatura', 719.0000, 'ºC'),
	(201168, 120, '2014-02-15 00:41:27.000000', 'temperatura', 233.0000, 'ºC'),
	(201169, 120, '2014-02-15 00:41:28.000000', 'temperatura', 207.0000, 'ºC'),
	(201170, 120, '2014-02-15 00:41:29.000000', 'temperatura', 337.0000, 'ºC'),
	(201171, 120, '2014-02-15 00:41:30.000000', 'temperatura', 1064.0000, 'ºC'),
	(201172, 120, '2014-02-15 00:41:31.000000', 'temperatura', 709.0000, 'ºC'),
	(201173, 120, '2014-02-15 00:41:32.000000', 'temperatura', 354.0000, 'ºC'),
	(201174, 120, '2014-02-15 00:41:33.000000', 'temperatura', 843.0000, 'ºC'),
	(201175, 120, '2014-02-15 00:41:34.000000', 'temperatura', 755.0000, 'ºC'),
	(201176, 120, '2014-02-15 00:41:35.000000', 'temperatura', 45.0000, 'ºC'),
	(201177, 120, '2014-02-15 00:41:36.000000', 'temperatura', 361.0000, 'ºC'),
	(201178, 120, '2014-02-15 00:41:37.000000', 'temperatura', 469.0000, 'ºC'),
	(201179, 120, '2014-02-15 00:41:38.000000', 'temperatura', 63.0000, 'ºC'),
	(201180, 120, '2014-02-15 00:41:39.000000', 'temperatura', 108.0000, 'ºC'),
	(201181, 120, '2014-02-15 00:41:40.000000', 'temperatura', 353.0000, 'ºC'),
	(201182, 120, '2014-02-15 00:41:41.000000', 'temperatura', 239.0000, 'ºC'),
	(201183, 120, '2014-02-15 00:41:42.000000', 'temperatura', 138.0000, 'ºC'),
	(201184, 120, '2014-02-15 00:41:43.000000', 'temperatura', 1174.0000, 'ºC'),
	(201185, 120, '2014-02-15 00:41:44.000000', 'temperatura', 657.0000, 'ºC'),
	(201186, 120, '2014-02-15 00:41:45.000000', 'temperatura', 965.0000, 'ºC'),
	(201187, 120, '2014-02-15 00:41:46.000000', 'temperatura', 451.0000, 'ºC'),
	(201188, 120, '2014-02-15 00:41:47.000000', 'temperatura', 562.0000, 'ºC'),
	(201189, 120, '2014-02-15 00:41:48.000000', 'temperatura', 259.0000, 'ºC'),
	(201190, 120, '2014-02-15 00:41:49.000000', 'temperatura', 806.0000, 'ºC'),
	(201191, 120, '2014-02-15 00:41:50.000000', 'temperatura', 857.0000, 'ºC'),
	(201192, 120, '2014-02-15 00:41:51.000000', 'temperatura', 667.0000, 'ºC'),
	(201193, 120, '2014-02-15 00:41:52.000000', 'temperatura', 765.0000, 'ºC'),
	(201194, 120, '2014-02-15 00:41:53.000000', 'temperatura', 625.0000, 'ºC'),
	(201195, 120, '2014-02-15 00:41:54.000000', 'temperatura', 831.0000, 'ºC'),
	(201196, 120, '2014-02-15 00:41:55.000000', 'temperatura', 1077.0000, 'ºC'),
	(201197, 120, '2014-02-15 00:41:56.000000', 'temperatura', 496.0000, 'ºC'),
	(201198, 120, '2014-02-15 00:41:57.000000', 'temperatura', 449.0000, 'ºC'),
	(201199, 120, '2014-02-15 00:41:58.000000', 'temperatura', 755.0000, 'ºC'),
	(201200, 120, '2014-02-15 00:41:59.000000', 'temperatura', 30.0000, 'ºC'),
	(201201, 120, '2014-02-15 00:42:00.000000', 'temperatura', 285.0000, 'ºC'),
	(201202, 120, '2014-02-15 00:42:01.000000', 'temperatura', 137.0000, 'ºC'),
	(201203, 120, '2014-02-15 00:42:02.000000', 'temperatura', 1028.0000, 'ºC'),
	(201204, 120, '2014-02-15 00:42:03.000000', 'temperatura', 1130.0000, 'ºC'),
	(201205, 120, '2014-02-15 00:42:04.000000', 'temperatura', 166.0000, 'ºC'),
	(201206, 120, '2014-02-15 00:42:05.000000', 'temperatura', 1043.0000, 'ºC'),
	(201207, 120, '2014-02-15 00:42:06.000000', 'temperatura', 1117.0000, 'ºC'),
	(201208, 120, '2014-02-15 00:42:07.000000', 'temperatura', 57.0000, 'ºC'),
	(201209, 120, '2014-02-15 00:42:08.000000', 'temperatura', 535.0000, 'ºC'),
	(201210, 120, '2014-02-15 00:42:09.000000', 'temperatura', 105.0000, 'ºC'),
	(201211, 120, '2014-02-15 00:42:10.000000', 'temperatura', 119.0000, 'ºC'),
	(201212, 120, '2014-02-15 00:42:11.000000', 'temperatura', 281.0000, 'ºC'),
	(201213, 120, '2014-02-15 00:42:12.000000', 'temperatura', 1050.0000, 'ºC'),
	(201214, 120, '2014-02-15 00:42:13.000000', 'temperatura', 806.0000, 'ºC'),
	(201215, 120, '2014-02-15 00:42:14.000000', 'temperatura', 882.0000, 'ºC'),
	(201216, 120, '2014-02-15 00:42:15.000000', 'temperatura', 793.0000, 'ºC'),
	(201217, 120, '2014-02-15 00:42:16.000000', 'temperatura', 119.0000, 'ºC'),
	(201218, 120, '2014-02-15 00:42:17.000000', 'temperatura', 617.0000, 'ºC'),
	(201219, 120, '2014-02-15 00:42:18.000000', 'temperatura', 327.0000, 'ºC'),
	(201220, 120, '2014-02-15 00:42:19.000000', 'temperatura', 986.0000, 'ºC'),
	(201221, 120, '2014-02-15 00:42:20.000000', 'temperatura', 349.0000, 'ºC'),
	(201222, 120, '2014-02-15 00:42:21.000000', 'temperatura', 1186.0000, 'ºC'),
	(201223, 120, '2014-02-15 00:42:22.000000', 'temperatura', 84.0000, 'ºC'),
	(201224, 120, '2014-02-15 00:42:23.000000', 'temperatura', 462.0000, 'ºC'),
	(201225, 120, '2014-02-15 00:42:24.000000', 'temperatura', 860.0000, 'ºC'),
	(201226, 120, '2014-02-15 00:42:25.000000', 'temperatura', 512.0000, 'ºC'),
	(201227, 120, '2014-02-15 00:42:26.000000', 'temperatura', 1181.0000, 'ºC'),
	(201228, 120, '2014-02-15 00:42:27.000000', 'temperatura', 770.0000, 'ºC'),
	(201229, 120, '2014-02-15 00:42:28.000000', 'temperatura', 307.0000, 'ºC'),
	(201230, 120, '2014-02-15 00:42:29.000000', 'temperatura', 427.0000, 'ºC'),
	(201231, 120, '2014-02-15 00:42:30.000000', 'temperatura', 15.0000, 'ºC'),
	(201232, 120, '2014-02-15 00:42:31.000000', 'temperatura', 1196.0000, 'ºC'),
	(201233, 120, '2014-02-15 00:42:32.000000', 'temperatura', 1132.0000, 'ºC'),
	(201234, 120, '2014-02-15 00:42:33.000000', 'temperatura', 876.0000, 'ºC'),
	(201235, 120, '2014-02-15 00:42:34.000000', 'temperatura', 981.0000, 'ºC'),
	(201236, 120, '2014-02-15 00:42:35.000000', 'temperatura', 1080.0000, 'ºC'),
	(201237, 120, '2014-02-15 00:42:36.000000', 'temperatura', 58.0000, 'ºC'),
	(201238, 120, '2014-02-15 00:42:37.000000', 'temperatura', 650.0000, 'ºC'),
	(201239, 120, '2014-02-15 00:42:38.000000', 'temperatura', 678.0000, 'ºC'),
	(201240, 120, '2014-02-15 00:42:39.000000', 'temperatura', 240.0000, 'ºC'),
	(201241, 120, '2014-02-15 00:42:40.000000', 'temperatura', 366.0000, 'ºC'),
	(201242, 120, '2014-02-15 00:42:41.000000', 'temperatura', 1109.0000, 'ºC'),
	(201243, 120, '2014-02-15 00:42:42.000000', 'temperatura', 851.0000, 'ºC'),
	(201244, 120, '2014-02-15 00:42:43.000000', 'temperatura', 925.0000, 'ºC'),
	(201245, 120, '2014-02-15 00:42:44.000000', 'temperatura', 875.0000, 'ºC'),
	(201246, 120, '2014-02-15 00:42:45.000000', 'temperatura', 400.0000, 'ºC'),
	(201247, 120, '2014-02-15 00:42:46.000000', 'temperatura', 575.0000, 'ºC'),
	(201248, 120, '2014-02-15 00:42:47.000000', 'temperatura', 476.0000, 'ºC'),
	(201249, 120, '2014-02-15 00:42:48.000000', 'temperatura', 655.0000, 'ºC'),
	(201250, 120, '2014-02-15 00:42:49.000000', 'temperatura', 648.0000, 'ºC'),
	(201251, 120, '2014-02-15 00:42:50.000000', 'temperatura', 75.0000, 'ºC'),
	(201252, 120, '2014-02-15 00:42:51.000000', 'temperatura', 832.0000, 'ºC'),
	(201253, 120, '2014-02-15 00:42:52.000000', 'temperatura', 334.0000, 'ºC'),
	(201254, 120, '2014-02-15 00:42:53.000000', 'temperatura', 374.0000, 'ºC'),
	(201255, 120, '2014-02-15 00:42:54.000000', 'temperatura', 869.0000, 'ºC'),
	(201256, 120, '2014-02-15 00:42:55.000000', 'temperatura', 823.0000, 'ºC'),
	(201257, 120, '2014-02-15 00:42:56.000000', 'temperatura', 311.0000, 'ºC'),
	(201258, 120, '2014-02-15 00:42:57.000000', 'temperatura', 285.0000, 'ºC'),
	(201259, 120, '2014-02-15 00:42:58.000000', 'temperatura', 492.0000, 'ºC'),
	(201260, 120, '2014-02-15 00:42:59.000000', 'temperatura', 408.0000, 'ºC'),
	(201261, 120, '2014-02-15 00:43:00.000000', 'temperatura', 561.0000, 'ºC'),
	(201262, 120, '2014-02-15 00:43:01.000000', 'temperatura', 383.0000, 'ºC'),
	(201263, 120, '2014-02-15 00:43:02.000000', 'temperatura', 234.0000, 'ºC'),
	(201264, 120, '2014-02-15 00:43:03.000000', 'temperatura', 19.0000, 'ºC'),
	(201265, 120, '2014-02-15 00:43:04.000000', 'temperatura', 594.0000, 'ºC'),
	(201266, 120, '2014-02-15 00:43:05.000000', 'temperatura', 516.0000, 'ºC'),
	(201267, 120, '2014-02-15 00:43:06.000000', 'temperatura', 795.0000, 'ºC'),
	(201268, 120, '2014-02-15 00:43:07.000000', 'temperatura', 30.0000, 'ºC'),
	(201269, 120, '2014-02-15 00:43:08.000000', 'temperatura', 167.0000, 'ºC'),
	(201270, 120, '2014-02-15 00:43:09.000000', 'temperatura', 742.0000, 'ºC'),
	(201271, 120, '2014-02-15 00:43:10.000000', 'temperatura', 811.0000, 'ºC'),
	(201272, 120, '2014-02-15 00:43:11.000000', 'temperatura', 628.0000, 'ºC'),
	(201273, 120, '2014-02-15 00:43:12.000000', 'temperatura', 707.0000, 'ºC'),
	(201274, 120, '2014-02-15 00:43:13.000000', 'temperatura', 452.0000, 'ºC'),
	(201275, 120, '2014-02-15 00:43:14.000000', 'temperatura', 141.0000, 'ºC'),
	(201276, 120, '2014-02-15 00:43:15.000000', 'temperatura', 548.0000, 'ºC'),
	(201277, 120, '2014-02-15 00:43:16.000000', 'temperatura', 1118.0000, 'ºC'),
	(201278, 120, '2014-02-15 00:43:17.000000', 'temperatura', 345.0000, 'ºC'),
	(201279, 120, '2014-02-15 00:43:18.000000', 'temperatura', 774.0000, 'ºC'),
	(201280, 120, '2014-02-15 00:43:19.000000', 'temperatura', 433.0000, 'ºC'),
	(201281, 120, '2014-02-15 00:43:20.000000', 'temperatura', 1046.0000, 'ºC'),
	(201282, 120, '2014-02-15 00:43:21.000000', 'temperatura', 331.0000, 'ºC'),
	(201283, 120, '2014-02-15 00:43:22.000000', 'temperatura', 919.0000, 'ºC'),
	(201284, 120, '2014-02-15 00:43:23.000000', 'temperatura', 2.0000, 'ºC'),
	(201285, 120, '2014-02-15 00:43:24.000000', 'temperatura', 852.0000, 'ºC'),
	(201286, 120, '2014-02-15 00:43:25.000000', 'temperatura', 654.0000, 'ºC'),
	(201287, 120, '2014-02-15 00:43:26.000000', 'temperatura', 716.0000, 'ºC'),
	(201288, 120, '2014-02-15 00:43:27.000000', 'temperatura', 417.0000, 'ºC'),
	(201289, 120, '2014-02-15 00:43:28.000000', 'temperatura', 1137.0000, 'ºC'),
	(201290, 120, '2014-02-15 00:43:29.000000', 'temperatura', 836.0000, 'ºC'),
	(201291, 120, '2014-02-15 00:43:30.000000', 'temperatura', 771.0000, 'ºC'),
	(201292, 120, '2014-02-15 00:43:31.000000', 'temperatura', 147.0000, 'ºC'),
	(201293, 120, '2014-02-15 00:43:32.000000', 'temperatura', 821.0000, 'ºC'),
	(201294, 120, '2014-02-15 00:43:33.000000', 'temperatura', 66.0000, 'ºC'),
	(201295, 120, '2014-02-15 00:43:34.000000', 'temperatura', 269.0000, 'ºC'),
	(201296, 120, '2014-02-15 00:43:35.000000', 'temperatura', 1144.0000, 'ºC'),
	(201297, 120, '2014-02-15 00:43:36.000000', 'temperatura', 115.0000, 'ºC'),
	(201298, 120, '2014-02-15 00:43:37.000000', 'temperatura', 743.0000, 'ºC'),
	(201299, 120, '2014-02-15 00:43:38.000000', 'temperatura', 971.0000, 'ºC'),
	(201300, 120, '2014-02-15 00:43:39.000000', 'temperatura', 228.0000, 'ºC'),
	(201301, 120, '2014-02-15 00:43:40.000000', 'temperatura', 626.0000, 'ºC'),
	(201302, 120, '2014-02-15 00:43:41.000000', 'temperatura', 48.0000, 'ºC'),
	(201303, 120, '2014-02-15 00:43:42.000000', 'temperatura', 760.0000, 'ºC'),
	(201304, 120, '2014-02-15 00:43:43.000000', 'temperatura', 56.0000, 'ºC'),
	(201305, 120, '2014-02-15 00:43:44.000000', 'temperatura', 401.0000, 'ºC'),
	(201306, 120, '2014-02-15 00:43:45.000000', 'temperatura', 638.0000, 'ºC'),
	(201307, 120, '2014-02-15 00:43:46.000000', 'temperatura', 785.0000, 'ºC'),
	(201308, 120, '2014-02-15 00:43:47.000000', 'temperatura', 815.0000, 'ºC'),
	(201309, 120, '2014-02-15 00:43:48.000000', 'temperatura', 518.0000, 'ºC'),
	(201310, 120, '2014-02-15 00:43:49.000000', 'temperatura', 148.0000, 'ºC'),
	(201311, 120, '2014-02-15 00:43:50.000000', 'temperatura', 384.0000, 'ºC'),
	(201312, 120, '2014-02-15 00:43:51.000000', 'temperatura', 276.0000, 'ºC'),
	(201313, 120, '2014-02-15 00:43:52.000000', 'temperatura', 228.0000, 'ºC'),
	(201314, 120, '2014-02-15 00:43:53.000000', 'temperatura', 313.0000, 'ºC'),
	(201315, 120, '2014-02-15 00:43:54.000000', 'temperatura', 881.0000, 'ºC'),
	(201316, 120, '2014-02-15 00:43:55.000000', 'temperatura', 1066.0000, 'ºC'),
	(201317, 120, '2014-02-15 00:43:56.000000', 'temperatura', 290.0000, 'ºC'),
	(201318, 120, '2014-02-15 00:43:57.000000', 'temperatura', 649.0000, 'ºC'),
	(201319, 120, '2014-02-15 00:43:58.000000', 'temperatura', 1178.0000, 'ºC'),
	(201320, 120, '2014-02-15 00:43:59.000000', 'temperatura', 343.0000, 'ºC'),
	(201321, 120, '2014-02-15 00:44:00.000000', 'temperatura', 581.0000, 'ºC'),
	(201322, 120, '2014-02-15 00:44:01.000000', 'temperatura', 676.0000, 'ºC'),
	(201323, 120, '2014-02-15 00:44:02.000000', 'temperatura', 440.0000, 'ºC'),
	(201324, 120, '2014-02-15 00:44:03.000000', 'temperatura', 169.0000, 'ºC'),
	(201325, 120, '2014-02-15 00:44:04.000000', 'temperatura', 728.0000, 'ºC'),
	(201326, 120, '2014-02-15 00:44:05.000000', 'temperatura', 732.0000, 'ºC'),
	(201327, 120, '2014-02-15 00:44:06.000000', 'temperatura', 275.0000, 'ºC'),
	(201328, 120, '2014-02-15 00:44:07.000000', 'temperatura', 382.0000, 'ºC'),
	(201329, 120, '2014-02-15 00:44:08.000000', 'temperatura', 1083.0000, 'ºC'),
	(201330, 120, '2014-02-15 00:44:09.000000', 'temperatura', 672.0000, 'ºC'),
	(201331, 120, '2014-02-15 00:44:10.000000', 'temperatura', 112.0000, 'ºC'),
	(201332, 120, '2014-02-15 00:44:11.000000', 'temperatura', 942.0000, 'ºC'),
	(201333, 120, '2014-02-15 00:44:12.000000', 'temperatura', 777.0000, 'ºC'),
	(201334, 120, '2014-02-15 00:44:13.000000', 'temperatura', 1057.0000, 'ºC'),
	(201335, 120, '2014-02-15 00:44:14.000000', 'temperatura', 558.0000, 'ºC'),
	(201336, 120, '2014-02-15 00:44:15.000000', 'temperatura', 816.0000, 'ºC'),
	(201337, 120, '2014-02-15 00:44:16.000000', 'temperatura', 9.0000, 'ºC'),
	(201338, 120, '2014-02-15 00:44:17.000000', 'temperatura', 1198.0000, 'ºC'),
	(201339, 120, '2014-02-15 00:44:18.000000', 'temperatura', 1162.0000, 'ºC'),
	(201340, 120, '2014-02-15 00:44:19.000000', 'temperatura', 1016.0000, 'ºC'),
	(201341, 120, '2014-02-15 00:44:20.000000', 'temperatura', 397.0000, 'ºC'),
	(201342, 120, '2014-02-15 00:44:21.000000', 'temperatura', 136.0000, 'ºC'),
	(201343, 120, '2014-02-15 00:44:22.000000', 'temperatura', 689.0000, 'ºC'),
	(201344, 120, '2014-02-15 00:44:23.000000', 'temperatura', 637.0000, 'ºC'),
	(201345, 120, '2014-02-15 00:44:24.000000', 'temperatura', 1120.0000, 'ºC'),
	(201346, 120, '2014-02-15 00:44:25.000000', 'temperatura', 91.0000, 'ºC'),
	(201347, 120, '2014-02-15 00:44:26.000000', 'temperatura', 694.0000, 'ºC'),
	(201348, 120, '2014-02-15 00:44:27.000000', 'temperatura', 798.0000, 'ºC'),
	(201349, 120, '2014-02-15 00:44:28.000000', 'temperatura', 709.0000, 'ºC'),
	(201350, 120, '2014-02-15 00:44:29.000000', 'temperatura', 1151.0000, 'ºC'),
	(201351, 120, '2014-02-15 00:44:30.000000', 'temperatura', 27.0000, 'ºC'),
	(201352, 120, '2014-02-15 00:44:31.000000', 'temperatura', 284.0000, 'ºC'),
	(201353, 120, '2014-02-15 00:44:32.000000', 'temperatura', 138.0000, 'ºC'),
	(201354, 120, '2014-02-15 00:44:33.000000', 'temperatura', 1040.0000, 'ºC'),
	(201355, 120, '2014-02-15 00:44:34.000000', 'temperatura', 1188.0000, 'ºC'),
	(201356, 120, '2014-02-15 00:44:35.000000', 'temperatura', 419.0000, 'ºC'),
	(201357, 120, '2014-02-15 00:44:36.000000', 'temperatura', 932.0000, 'ºC'),
	(201358, 120, '2014-02-15 00:44:37.000000', 'temperatura', 1004.0000, 'ºC'),
	(201359, 120, '2014-02-15 00:44:38.000000', 'temperatura', 1026.0000, 'ºC'),
	(201360, 120, '2014-02-15 00:44:39.000000', 'temperatura', 916.0000, 'ºC'),
	(201361, 120, '2014-02-15 00:44:40.000000', 'temperatura', 303.0000, 'ºC'),
	(201362, 120, '2014-02-15 00:44:41.000000', 'temperatura', 1169.0000, 'ºC'),
	(201363, 120, '2014-02-15 00:44:42.000000', 'temperatura', 137.0000, 'ºC'),
	(201364, 120, '2014-02-15 00:44:43.000000', 'temperatura', 778.0000, 'ºC'),
	(201365, 120, '2014-02-15 00:44:44.000000', 'temperatura', 1078.0000, 'ºC'),
	(201366, 120, '2014-02-15 00:44:45.000000', 'temperatura', 656.0000, 'ºC'),
	(201367, 120, '2014-02-15 00:44:46.000000', 'temperatura', 49.0000, 'ºC'),
	(201368, 120, '2014-02-15 00:44:47.000000', 'temperatura', 675.0000, 'ºC'),
	(201369, 120, '2014-02-15 00:44:48.000000', 'temperatura', 829.0000, 'ºC'),
	(201370, 120, '2014-02-15 00:44:49.000000', 'temperatura', 920.0000, 'ºC'),
	(201371, 120, '2014-02-15 00:44:50.000000', 'temperatura', 912.0000, 'ºC'),
	(201372, 120, '2014-02-15 00:44:51.000000', 'temperatura', 602.0000, 'ºC'),
	(201373, 120, '2014-02-15 00:44:52.000000', 'temperatura', 277.0000, 'ºC'),
	(201374, 120, '2014-02-15 00:44:53.000000', 'temperatura', 776.0000, 'ºC'),
	(201375, 120, '2014-02-15 00:44:54.000000', 'temperatura', 650.0000, 'ºC'),
	(201376, 120, '2014-02-15 00:44:55.000000', 'temperatura', 923.0000, 'ºC'),
	(201377, 120, '2014-02-15 00:44:56.000000', 'temperatura', 265.0000, 'ºC'),
	(201378, 120, '2014-02-15 00:44:57.000000', 'temperatura', 957.0000, 'ºC'),
	(201379, 120, '2014-02-15 00:44:58.000000', 'temperatura', 390.0000, 'ºC'),
	(201380, 120, '2014-02-15 00:44:59.000000', 'temperatura', 279.0000, 'ºC'),
	(201381, 120, '2014-02-15 00:45:00.000000', 'temperatura', 225.0000, 'ºC'),
	(201382, 120, '2014-02-15 00:45:01.000000', 'temperatura', 291.0000, 'ºC'),
	(201383, 120, '2014-02-15 00:45:02.000000', 'temperatura', 780.0000, 'ºC'),
	(201384, 120, '2014-02-15 00:45:03.000000', 'temperatura', 629.0000, 'ºC'),
	(201385, 120, '2014-02-15 00:45:04.000000', 'temperatura', 805.0000, 'ºC'),
	(201386, 120, '2014-02-15 00:45:05.000000', 'temperatura', 936.0000, 'ºC'),
	(201387, 120, '2014-02-15 00:45:06.000000', 'temperatura', 1067.0000, 'ºC'),
	(201388, 120, '2014-02-15 00:45:07.000000', 'temperatura', 129.0000, 'ºC'),
	(201389, 120, '2014-02-15 00:45:08.000000', 'temperatura', 1043.0000, 'ºC'),
	(201390, 120, '2014-02-15 00:45:09.000000', 'temperatura', 30.0000, 'ºC'),
	(201391, 120, '2014-02-15 00:45:10.000000', 'temperatura', 623.0000, 'ºC'),
	(201392, 120, '2014-02-15 00:45:11.000000', 'temperatura', 622.0000, 'ºC'),
	(201393, 120, '2014-02-15 00:45:12.000000', 'temperatura', 42.0000, 'ºC'),
	(201394, 120, '2014-02-15 00:45:13.000000', 'temperatura', 746.0000, 'ºC'),
	(201395, 120, '2014-02-15 00:45:14.000000', 'temperatura', 2.0000, 'ºC'),
	(201396, 120, '2014-02-15 00:45:15.000000', 'temperatura', 174.0000, 'ºC'),
	(201397, 120, '2014-02-15 00:45:16.000000', 'temperatura', 864.0000, 'ºC'),
	(201398, 120, '2014-02-15 00:45:17.000000', 'temperatura', 198.0000, 'ºC'),
	(201399, 120, '2014-02-15 00:45:18.000000', 'temperatura', 801.0000, 'ºC'),
	(201400, 120, '2014-02-15 00:45:19.000000', 'temperatura', 1011.0000, 'ºC'),
	(201401, 120, '2014-02-15 00:45:20.000000', 'temperatura', 251.0000, 'ºC'),
	(201402, 120, '2014-02-15 00:45:21.000000', 'temperatura', 623.0000, 'ºC'),
	(201403, 120, '2014-02-15 00:45:22.000000', 'temperatura', 1163.0000, 'ºC'),
	(201404, 120, '2014-02-15 00:45:23.000000', 'temperatura', 346.0000, 'ºC'),
	(201405, 120, '2014-02-15 00:45:24.000000', 'temperatura', 643.0000, 'ºC'),
	(201406, 120, '2014-02-15 00:45:25.000000', 'temperatura', 979.0000, 'ºC'),
	(201407, 120, '2014-02-15 00:45:26.000000', 'temperatura', 563.0000, 'ºC'),
	(201408, 120, '2014-02-15 00:45:27.000000', 'temperatura', 1081.0000, 'ºC'),
	(201409, 120, '2014-02-15 00:45:28.000000', 'temperatura', 114.0000, 'ºC'),
	(201410, 120, '2014-02-15 00:45:29.000000', 'temperatura', 928.0000, 'ºC'),
	(201411, 120, '2014-02-15 00:45:30.000000', 'temperatura', 699.0000, 'ºC'),
	(201412, 120, '2014-02-15 00:45:31.000000', 'temperatura', 713.0000, 'ºC'),
	(201413, 120, '2014-02-15 00:45:32.000000', 'temperatura', 266.0000, 'ºC'),
	(201414, 120, '2014-02-15 00:45:33.000000', 'temperatura', 391.0000, 'ºC'),
	(201415, 120, '2014-02-15 00:45:34.000000', 'temperatura', 1157.0000, 'ºC'),
	(201416, 120, '2014-02-15 00:45:35.000000', 'temperatura', 1014.0000, 'ºC'),
	(201417, 120, '2014-02-15 00:45:36.000000', 'temperatura', 400.0000, 'ºC'),
	(201418, 120, '2014-02-15 00:45:37.000000', 'temperatura', 157.0000, 'ºC'),
	(201419, 120, '2014-02-15 00:45:38.000000', 'temperatura', 786.0000, 'ºC'),
	(201420, 120, '2014-02-15 00:45:39.000000', 'temperatura', 1058.0000, 'ºC'),
	(201421, 120, '2014-02-15 00:45:40.000000', 'temperatura', 534.0000, 'ºC'),
	(201422, 120, '2014-02-15 00:45:41.000000', 'temperatura', 695.0000, 'ºC'),
	(201423, 120, '2014-02-15 00:45:42.000000', 'temperatura', 675.0000, 'ºC'),
	(201424, 120, '2014-02-15 00:45:43.000000', 'temperatura', 89.0000, 'ºC'),
	(201425, 120, '2014-02-15 00:45:44.000000', 'temperatura', 822.0000, 'ºC'),
	(201426, 120, '2014-02-15 00:45:45.000000', 'temperatura', 243.0000, 'ºC'),
	(201427, 120, '2014-02-15 00:45:46.000000', 'temperatura', 1151.0000, 'ºC'),
	(201428, 120, '2014-02-15 00:45:47.000000', 'temperatura', 224.0000, 'ºC'),
	(201429, 120, '2014-02-15 00:45:48.000000', 'temperatura', 68.0000, 'ºC'),
	(201430, 120, '2014-02-15 00:45:49.000000', 'temperatura', 869.0000, 'ºC'),
	(201431, 120, '2014-02-15 00:45:50.000000', 'temperatura', 540.0000, 'ºC'),
	(201432, 120, '2014-02-15 00:45:51.000000', 'temperatura', 93.0000, 'ºC'),
	(201433, 120, '2014-02-15 00:45:52.000000', 'temperatura', 45.0000, 'ºC'),
	(201434, 120, '2014-02-15 00:45:53.000000', 'temperatura', 1149.0000, 'ºC'),
	(201435, 120, '2014-02-15 00:45:54.000000', 'temperatura', 808.0000, 'ºC'),
	(201436, 120, '2014-02-15 00:45:55.000000', 'temperatura', 595.0000, 'ºC'),
	(201437, 120, '2014-02-15 00:45:56.000000', 'temperatura', 550.0000, 'ºC'),
	(201438, 120, '2014-02-15 00:45:57.000000', 'temperatura', 965.0000, 'ºC'),
	(201439, 120, '2014-02-15 00:45:58.000000', 'temperatura', 775.0000, 'ºC'),
	(201440, 120, '2014-02-15 00:45:59.000000', 'temperatura', 982.0000, 'ºC'),
	(201441, 120, '2014-02-15 00:46:00.000000', 'temperatura', 185.0000, 'ºC'),
	(201442, 120, '2014-02-15 00:46:01.000000', 'temperatura', 380.0000, 'ºC'),
	(201443, 120, '2014-02-15 00:46:02.000000', 'temperatura', 144.0000, 'ºC'),
	(201444, 120, '2014-02-15 00:46:03.000000', 'temperatura', 783.0000, 'ºC'),
	(201445, 120, '2014-02-15 00:46:04.000000', 'temperatura', 1084.0000, 'ºC'),
	(201446, 120, '2014-02-15 00:46:05.000000', 'temperatura', 669.0000, 'ºC'),
	(201447, 120, '2014-02-15 00:46:06.000000', 'temperatura', 92.0000, 'ºC'),
	(201448, 120, '2014-02-15 00:46:07.000000', 'temperatura', 857.0000, 'ºC'),
	(201449, 120, '2014-02-15 00:46:08.000000', 'temperatura', 409.0000, 'ºC'),
	(201450, 120, '2014-02-15 00:46:09.000000', 'temperatura', 673.0000, 'ºC'),
	(201451, 120, '2014-02-15 00:46:10.000000', 'temperatura', 939.0000, 'ºC'),
	(201452, 120, '2014-02-15 00:46:11.000000', 'temperatura', 275.0000, 'ºC'),
	(201453, 120, '2014-02-15 00:46:12.000000', 'temperatura', 961.0000, 'ºC'),
	(201454, 120, '2014-02-15 00:46:13.000000', 'temperatura', 381.0000, 'ºC'),
	(201455, 120, '2014-02-15 00:46:14.000000', 'temperatura', 220.0000, 'ºC'),
	(201456, 120, '2014-02-15 00:46:15.000000', 'temperatura', 1157.0000, 'ºC'),
	(201457, 120, '2014-02-15 00:46:16.000000', 'temperatura', 326.0000, 'ºC'),
	(201458, 120, '2014-02-15 00:46:17.000000', 'temperatura', 561.0000, 'ºC'),
	(201459, 120, '2014-02-15 00:46:18.000000', 'temperatura', 626.0000, 'ºC'),
	(201460, 120, '2014-02-15 00:46:19.000000', 'temperatura', 249.0000, 'ºC'),
	(201461, 120, '2014-02-15 00:46:20.000000', 'temperatura', 568.0000, 'ºC'),
	(201462, 120, '2014-02-15 00:46:21.000000', 'temperatura', 891.0000, 'ºC'),
	(201463, 120, '2014-02-15 00:46:22.000000', 'temperatura', 353.0000, 'ºC'),
	(201464, 120, '2014-02-15 00:46:23.000000', 'temperatura', 291.0000, 'ºC'),
	(201465, 120, '2014-02-15 00:46:24.000000', 'temperatura', 398.0000, 'ºC'),
	(201466, 120, '2014-02-15 00:46:25.000000', 'temperatura', 1116.0000, 'ºC'),
	(201467, 120, '2014-02-15 00:46:26.000000', 'temperatura', 788.0000, 'ºC'),
	(201468, 120, '2014-02-15 00:46:27.000000', 'temperatura', 592.0000, 'ºC'),
	(201469, 120, '2014-02-15 00:46:28.000000', 'temperatura', 596.0000, 'ºC'),
	(201470, 120, '2014-02-15 00:46:29.000000', 'temperatura', 6.0000, 'ºC'),
	(201471, 120, '2014-02-15 00:46:30.000000', 'temperatura', 642.0000, 'ºC'),
	(201472, 120, '2014-02-15 00:46:31.000000', 'temperatura', 793.0000, 'ºC'),
	(201473, 120, '2014-02-15 00:46:32.000000', 'temperatura', 837.0000, 'ºC'),
	(201474, 120, '2014-02-15 00:46:33.000000', 'temperatura', 609.0000, 'ºC'),
	(201475, 120, '2014-02-15 00:46:34.000000', 'temperatura', 534.0000, 'ºC'),
	(201476, 120, '2014-02-15 00:46:35.000000', 'temperatura', 842.0000, 'ºC'),
	(201477, 120, '2014-02-15 00:46:36.000000', 'temperatura', 210.0000, 'ºC'),
	(201478, 120, '2014-02-15 00:46:37.000000', 'temperatura', 923.0000, 'ºC'),
	(201479, 120, '2014-02-15 00:46:38.000000', 'temperatura', 385.0000, 'ºC'),
	(201480, 120, '2014-02-15 00:46:39.000000', 'temperatura', 355.0000, 'ºC'),
	(201481, 120, '2014-02-15 00:46:40.000000', 'temperatura', 623.0000, 'ºC'),
	(201482, 120, '2014-02-15 00:46:41.000000', 'temperatura', 851.0000, 'ºC'),
	(201483, 120, '2014-02-15 00:46:42.000000', 'temperatura', 1184.0000, 'ºC'),
	(201484, 120, '2014-02-15 00:46:43.000000', 'temperatura', 968.0000, 'ºC'),
	(201485, 120, '2014-02-15 00:46:44.000000', 'temperatura', 89.0000, 'ºC'),
	(201486, 120, '2014-02-15 00:46:45.000000', 'temperatura', 1143.0000, 'ºC'),
	(201487, 120, '2014-02-15 00:46:46.000000', 'temperatura', 647.0000, 'ºC'),
	(201488, 120, '2014-02-15 00:46:47.000000', 'temperatura', 1007.0000, 'ºC'),
	(201489, 120, '2014-02-15 00:46:48.000000', 'temperatura', 695.0000, 'ºC'),
	(201490, 120, '2014-02-15 00:46:49.000000', 'temperatura', 454.0000, 'ºC'),
	(201491, 120, '2014-02-15 00:46:50.000000', 'temperatura', 186.0000, 'ºC'),
	(201492, 120, '2014-02-15 00:46:51.000000', 'temperatura', 767.0000, 'ºC'),
	(201493, 120, '2014-02-15 00:46:52.000000', 'temperatura', 880.0000, 'ºC'),
	(201494, 120, '2014-02-15 00:46:53.000000', 'temperatura', 898.0000, 'ºC'),
	(201495, 120, '2014-02-15 00:46:54.000000', 'temperatura', 652.0000, 'ºC'),
	(201496, 120, '2014-02-15 00:46:55.000000', 'temperatura', 564.0000, 'ºC'),
	(201497, 120, '2014-02-15 00:46:56.000000', 'temperatura', 864.0000, 'ºC'),
	(201498, 120, '2014-02-15 00:46:57.000000', 'temperatura', 231.0000, 'ºC'),
	(201499, 120, '2014-02-15 00:46:58.000000', 'temperatura', 962.0000, 'ºC'),
	(201500, 120, '2014-02-15 00:46:59.000000', 'temperatura', 519.0000, 'ºC'),
	(201501, 120, '2014-02-15 00:47:00.000000', 'temperatura', 910.0000, 'ºC'),
	(201502, 120, '2014-02-15 00:47:01.000000', 'temperatura', 593.0000, 'ºC'),
	(201503, 120, '2014-02-15 00:47:02.000000', 'temperatura', 235.0000, 'ºC'),
	(201504, 120, '2014-02-15 00:47:03.000000', 'temperatura', 595.0000, 'ºC'),
	(201505, 120, '2014-02-15 00:47:04.000000', 'temperatura', 1072.0000, 'ºC'),
	(201506, 120, '2014-02-15 00:47:05.000000', 'temperatura', 1173.0000, 'ºC'),
	(201507, 120, '2014-02-15 00:47:06.000000', 'temperatura', 252.0000, 'ºC'),
	(201508, 120, '2014-02-15 00:47:07.000000', 'temperatura', 139.0000, 'ºC'),
	(201509, 120, '2014-02-15 00:47:08.000000', 'temperatura', 1142.0000, 'ºC'),
	(201510, 120, '2014-02-15 00:47:09.000000', 'temperatura', 491.0000, 'ºC'),
	(201511, 120, '2014-02-15 00:47:10.000000', 'temperatura', 230.0000, 'ºC'),
	(201512, 120, '2014-02-15 00:47:11.000000', 'temperatura', 877.0000, 'ºC'),
	(201513, 120, '2014-02-15 00:47:12.000000', 'temperatura', 94.0000, 'ºC'),
	(201514, 120, '2014-02-15 00:47:13.000000', 'temperatura', 243.0000, 'ºC'),
	(201515, 120, '2014-02-15 00:47:14.000000', 'temperatura', 930.0000, 'ºC'),
	(201516, 120, '2014-02-15 00:47:15.000000', 'temperatura', 325.0000, 'ºC'),
	(201517, 120, '2014-02-15 00:47:16.000000', 'temperatura', 34.0000, 'ºC'),
	(201518, 120, '2014-02-15 00:47:17.000000', 'temperatura', 396.0000, 'ºC'),
	(201519, 120, '2014-02-15 00:47:18.000000', 'temperatura', 676.0000, 'ºC'),
	(201520, 120, '2014-02-15 00:47:19.000000', 'temperatura', 996.0000, 'ºC'),
	(201521, 120, '2014-02-15 00:47:20.000000', 'temperatura', 551.0000, 'ºC'),
	(201522, 120, '2014-02-15 00:47:21.000000', 'temperatura', 968.0000, 'ºC'),
	(201523, 120, '2014-02-15 00:47:22.000000', 'temperatura', 788.0000, 'ºC'),
	(201524, 120, '2014-02-15 00:47:23.000000', 'temperatura', 1036.0000, 'ºC'),
	(201525, 120, '2014-02-15 00:47:24.000000', 'temperatura', 416.0000, 'ºC'),
	(201526, 120, '2014-02-15 00:47:25.000000', 'temperatura', 172.0000, 'ºC'),
	(201527, 120, '2014-02-15 00:47:26.000000', 'temperatura', 814.0000, 'ºC'),
	(201528, 120, '2014-02-15 00:47:27.000000', 'temperatura', 1153.0000, 'ºC'),
	(201529, 120, '2014-02-15 00:47:28.000000', 'temperatura', 926.0000, 'ºC'),
	(201530, 120, '2014-02-15 00:47:29.000000', 'temperatura', 1171.0000, 'ºC'),
	(201531, 120, '2014-02-15 00:47:30.000000', 'temperatura', 675.0000, 'ºC'),
	(201532, 120, '2014-02-15 00:47:31.000000', 'temperatura', 1066.0000, 'ºC'),
	(201533, 120, '2014-02-15 00:47:32.000000', 'temperatura', 903.0000, 'ºC'),
	(201534, 120, '2014-02-15 00:47:33.000000', 'temperatura', 118.0000, 'ºC'),
	(201535, 120, '2014-02-15 00:47:34.000000', 'temperatura', 283.0000, 'ºC'),
	(201536, 120, '2014-02-15 00:47:35.000000', 'temperatura', 1063.0000, 'ºC'),
	(201537, 120, '2014-02-15 00:47:36.000000', 'temperatura', 863.0000, 'ºC'),
	(201538, 120, '2014-02-15 00:47:37.000000', 'temperatura', 1128.0000, 'ºC'),
	(201539, 120, '2014-02-15 00:47:38.000000', 'temperatura', 652.0000, 'ºC'),
	(201540, 120, '2014-02-15 00:47:39.000000', 'temperatura', 1074.0000, 'ºC'),
	(201541, 120, '2014-02-15 00:47:40.000000', 'temperatura', 1016.0000, 'ºC'),
	(201542, 120, '2014-02-15 00:47:41.000000', 'temperatura', 657.0000, 'ºC'),
	(201543, 120, '2014-02-15 00:47:42.000000', 'temperatura', 238.0000, 'ºC'),
	(201544, 120, '2014-02-15 00:47:43.000000', 'temperatura', 418.0000, 'ºC'),
	(201545, 120, '2014-02-15 00:47:44.000000', 'temperatura', 177.0000, 'ºC'),
	(201546, 120, '2014-02-15 00:47:45.000000', 'temperatura', 831.0000, 'ºC'),
	(201547, 120, '2014-02-15 00:47:46.000000', 'temperatura', 23.0000, 'ºC'),
	(201548, 120, '2014-02-15 00:47:47.000000', 'temperatura', 24.0000, 'ºC'),
	(201549, 120, '2014-02-15 00:47:48.000000', 'temperatura', 54.0000, 'ºC'),
	(201550, 120, '2014-02-15 00:47:49.000000', 'temperatura', 195.0000, 'ºC'),
	(201551, 120, '2014-02-15 00:47:50.000000', 'temperatura', 816.0000, 'ºC'),
	(201552, 120, '2014-02-15 00:47:51.000000', 'temperatura', 1096.0000, 'ºC'),
	(201553, 120, '2014-02-15 00:47:52.000000', 'temperatura', 633.0000, 'ºC'),
	(201554, 120, '2014-02-15 00:47:53.000000', 'temperatura', 1078.0000, 'ºC'),
	(201555, 120, '2014-02-15 00:47:54.000000', 'temperatura', 1092.0000, 'ºC'),
	(201556, 120, '2014-02-15 00:47:55.000000', 'temperatura', 1024.0000, 'ºC'),
	(201557, 120, '2014-02-15 00:47:56.000000', 'temperatura', 648.0000, 'ºC'),
	(201558, 120, '2014-02-15 00:47:57.000000', 'temperatura', 165.0000, 'ºC'),
	(201559, 120, '2014-02-15 00:47:58.000000', 'temperatura', 82.0000, 'ºC'),
	(201560, 120, '2014-02-15 00:47:59.000000', 'temperatura', 1115.0000, 'ºC'),
	(201561, 120, '2014-02-15 00:48:00.000000', 'temperatura', 531.0000, 'ºC'),
	(201562, 120, '2014-02-15 00:48:01.000000', 'temperatura', 508.0000, 'ºC'),
	(201563, 120, '2014-02-15 00:48:02.000000', 'temperatura', 951.0000, 'ºC'),
	(201564, 120, '2014-02-15 00:48:03.000000', 'temperatura', 830.0000, 'ºC'),
	(201565, 120, '2014-02-15 00:48:04.000000', 'temperatura', 97.0000, 'ºC'),
	(201566, 120, '2014-02-15 00:48:05.000000', 'temperatura', 395.0000, 'ºC'),
	(201567, 120, '2014-02-15 00:48:06.000000', 'temperatura', 483.0000, 'ºC'),
	(201568, 120, '2014-02-15 00:48:07.000000', 'temperatura', 34.0000, 'ºC'),
	(201569, 120, '2014-02-15 00:48:08.000000', 'temperatura', 1120.0000, 'ºC'),
	(201570, 120, '2014-02-15 00:48:09.000000', 'temperatura', 700.0000, 'ºC'),
	(201571, 120, '2014-02-15 00:48:10.000000', 'temperatura', 141.0000, 'ºC'),
	(201572, 120, '2014-02-15 00:48:11.000000', 'temperatura', 1005.0000, 'ºC'),
	(201573, 120, '2014-02-15 00:48:12.000000', 'temperatura', 1003.0000, 'ºC'),
	(201574, 120, '2014-02-15 00:48:13.000000', 'temperatura', 799.0000, 'ºC'),
	(201575, 120, '2014-02-15 00:48:14.000000', 'temperatura', 988.0000, 'ºC'),
	(201576, 120, '2014-02-15 00:48:15.000000', 'temperatura', 141.0000, 'ºC'),
	(201577, 120, '2014-02-15 00:48:16.000000', 'temperatura', 144.0000, 'ºC'),
	(201578, 120, '2014-02-15 00:48:17.000000', 'temperatura', 298.0000, 'ºC'),
	(201579, 120, '2014-02-15 00:48:18.000000', 'temperatura', 1057.0000, 'ºC'),
	(201580, 120, '2014-02-15 00:48:19.000000', 'temperatura', 791.0000, 'ºC'),
	(201581, 120, '2014-02-15 00:48:20.000000', 'temperatura', 787.0000, 'ºC'),
	(201582, 120, '2014-02-15 00:48:21.000000', 'temperatura', 362.0000, 'ºC'),
	(201583, 120, '2014-02-15 00:48:22.000000', 'temperatura', 647.0000, 'ºC'),
	(201584, 120, '2014-02-15 00:48:23.000000', 'temperatura', 950.0000, 'ºC'),
	(201585, 120, '2014-02-15 00:48:24.000000', 'temperatura', 412.0000, 'ºC'),
	(201586, 120, '2014-02-15 00:48:25.000000', 'temperatura', 407.0000, 'ºC'),
	(201587, 120, '2014-02-15 00:48:26.000000', 'temperatura', 803.0000, 'ºC'),
	(201588, 120, '2014-02-15 00:48:27.000000', 'temperatura', 391.0000, 'ºC'),
	(201589, 120, '2014-02-15 00:48:28.000000', 'temperatura', 750.0000, 'ºC'),
	(201590, 120, '2014-02-15 00:48:29.000000', 'temperatura', 175.0000, 'ºC'),
	(201591, 120, '2014-02-15 00:48:30.000000', 'temperatura', 1025.0000, 'ºC'),
	(201592, 120, '2014-02-15 00:48:31.000000', 'temperatura', 1000.0000, 'ºC'),
	(201593, 120, '2014-02-15 00:48:32.000000', 'temperatura', 725.0000, 'ºC'),
	(201594, 120, '2014-02-15 00:48:33.000000', 'temperatura', 626.0000, 'ºC'),
	(201595, 120, '2014-02-15 00:48:34.000000', 'temperatura', 957.0000, 'ºC'),
	(201596, 120, '2014-02-15 00:48:35.000000', 'temperatura', 506.0000, 'ºC'),
	(201597, 120, '2014-02-15 00:48:36.000000', 'temperatura', 860.0000, 'ºC'),
	(201598, 120, '2014-02-15 00:48:37.000000', 'temperatura', 383.0000, 'ºC'),
	(201599, 120, '2014-02-15 00:48:38.000000', 'temperatura', 535.0000, 'ºC'),
	(201600, 120, '2014-02-15 00:48:39.000000', 'temperatura', 325.0000, 'ºC'),
	(201601, 120, '2014-02-15 00:48:40.000000', 'temperatura', 24.0000, 'ºC'),
	(201602, 120, '2014-02-15 00:48:41.000000', 'temperatura', 342.0000, 'ºC'),
	(201603, 120, '2014-02-15 00:48:42.000000', 'temperatura', 439.0000, 'ºC'),
	(201604, 120, '2014-02-15 00:48:43.000000', 'temperatura', 1169.0000, 'ºC'),
	(201605, 120, '2014-02-15 00:48:44.000000', 'temperatura', 929.0000, 'ºC'),
	(201606, 120, '2014-02-15 00:48:45.000000', 'temperatura', 1138.0000, 'ºC'),
	(201607, 120, '2014-02-15 00:48:46.000000', 'temperatura', 503.0000, 'ºC'),
	(201608, 120, '2014-02-15 00:48:47.000000', 'temperatura', 302.0000, 'ºC'),
	(201609, 120, '2014-02-15 00:48:48.000000', 'temperatura', 3.0000, 'ºC'),
	(201610, 120, '2014-02-15 00:48:49.000000', 'temperatura', 309.0000, 'ºC'),
	(201611, 120, '2014-02-15 00:48:50.000000', 'temperatura', 336.0000, 'ºC'),
	(201612, 120, '2014-02-15 00:48:51.000000', 'temperatura', 752.0000, 'ºC'),
	(201613, 120, '2014-02-15 00:48:52.000000', 'temperatura', 354.0000, 'ºC'),
	(201614, 120, '2014-02-15 00:48:53.000000', 'temperatura', 713.0000, 'ºC'),
	(201615, 120, '2014-02-15 00:48:54.000000', 'temperatura', 104.0000, 'ºC'),
	(201616, 120, '2014-02-15 00:48:55.000000', 'temperatura', 782.0000, 'ºC'),
	(201617, 120, '2014-02-15 00:48:56.000000', 'temperatura', 1196.0000, 'ºC'),
	(201618, 120, '2014-02-15 00:48:57.000000', 'temperatura', 37.0000, 'ºC'),
	(201619, 120, '2014-02-15 00:48:58.000000', 'temperatura', 199.0000, 'ºC'),
	(201620, 120, '2014-02-15 00:48:59.000000', 'temperatura', 883.0000, 'ºC'),
	(201621, 120, '2014-02-15 00:49:00.000000', 'temperatura', 218.0000, 'ºC'),
	(201622, 120, '2014-02-15 00:49:01.000000', 'temperatura', 840.0000, 'ºC'),
	(201623, 120, '2014-02-15 00:49:02.000000', 'temperatura', 1147.0000, 'ºC'),
	(201624, 120, '2014-02-15 00:49:03.000000', 'temperatura', 815.0000, 'ºC'),
	(201625, 120, '2014-02-15 00:49:04.000000', 'temperatura', 637.0000, 'ºC'),
	(201626, 120, '2014-02-15 00:49:05.000000', 'temperatura', 739.0000, 'ºC'),
	(201627, 120, '2014-02-15 00:49:06.000000', 'temperatura', 586.0000, 'ºC'),
	(201628, 120, '2014-02-15 00:49:07.000000', 'temperatura', 713.0000, 'ºC'),
	(201629, 120, '2014-02-15 00:49:08.000000', 'temperatura', 608.0000, 'ºC'),
	(201630, 120, '2014-02-15 00:49:09.000000', 'temperatura', 901.0000, 'ºC'),
	(201631, 120, '2014-02-15 00:49:10.000000', 'temperatura', 282.0000, 'ºC'),
	(201632, 120, '2014-02-15 00:49:11.000000', 'temperatura', 1105.0000, 'ºC'),
	(201633, 120, '2014-02-15 00:49:12.000000', 'temperatura', 1081.0000, 'ºC'),
	(201634, 120, '2014-02-15 00:49:13.000000', 'temperatura', 890.0000, 'ºC'),
	(201635, 120, '2014-02-15 00:49:14.000000', 'temperatura', 8.0000, 'ºC'),
	(201636, 120, '2014-02-15 00:49:15.000000', 'temperatura', 971.0000, 'ºC'),
	(201637, 120, '2014-02-15 00:49:16.000000', 'temperatura', 33.0000, 'ºC'),
	(201638, 120, '2014-02-15 00:49:17.000000', 'temperatura', 852.0000, 'ºC'),
	(201639, 120, '2014-02-15 00:49:18.000000', 'temperatura', 561.0000, 'ºC'),
	(201640, 120, '2014-02-15 00:49:19.000000', 'temperatura', 250.0000, 'ºC'),
	(201641, 120, '2014-02-15 00:49:20.000000', 'temperatura', 769.0000, 'ºC'),
	(201642, 120, '2014-02-15 00:49:21.000000', 'temperatura', 692.0000, 'ºC'),
	(201643, 120, '2014-02-15 00:49:22.000000', 'temperatura', 1156.0000, 'ºC'),
	(201644, 120, '2014-02-15 00:49:23.000000', 'temperatura', 106.0000, 'ºC'),
	(201645, 120, '2014-02-15 00:49:24.000000', 'temperatura', 659.0000, 'ºC'),
	(201646, 120, '2014-02-15 00:49:25.000000', 'temperatura', 579.0000, 'ºC'),
	(201647, 120, '2014-02-15 00:49:26.000000', 'temperatura', 918.0000, 'ºC'),
	(201648, 120, '2014-02-15 00:49:27.000000', 'temperatura', 452.0000, 'ºC'),
	(201649, 120, '2014-02-15 00:49:28.000000', 'temperatura', 708.0000, 'ºC'),
	(201650, 120, '2014-02-15 00:49:29.000000', 'temperatura', 983.0000, 'ºC'),
	(201651, 120, '2014-02-15 00:49:30.000000', 'temperatura', 393.0000, 'ºC'),
	(201652, 120, '2014-02-15 00:49:31.000000', 'temperatura', 216.0000, 'ºC'),
	(201653, 120, '2014-02-15 00:49:32.000000', 'temperatura', 1103.0000, 'ºC'),
	(201654, 120, '2014-02-15 00:49:33.000000', 'temperatura', 65.0000, 'ºC'),
	(201655, 120, '2014-02-15 00:49:34.000000', 'temperatura', 618.0000, 'ºC'),
	(201656, 120, '2014-02-15 00:49:35.000000', 'temperatura', 497.0000, 'ºC'),
	(201657, 120, '2014-02-15 00:49:36.000000', 'temperatura', 631.0000, 'ºC'),
	(201658, 120, '2014-02-15 00:49:37.000000', 'temperatura', 466.0000, 'ºC'),
	(201659, 120, '2014-02-15 00:49:38.000000', 'temperatura', 434.0000, 'ºC'),
	(201660, 120, '2014-02-15 00:49:39.000000', 'temperatura', 775.0000, 'ºC'),
	(201661, 120, '2014-02-15 00:49:40.000000', 'temperatura', 173.0000, 'ºC'),
	(201662, 120, '2014-02-15 00:49:41.000000', 'temperatura', 941.0000, 'ºC'),
	(201663, 120, '2014-02-15 00:49:42.000000', 'temperatura', 588.0000, 'ºC'),
	(201664, 120, '2014-02-15 00:49:43.000000', 'temperatura', 117.0000, 'ºC'),
	(201665, 120, '2014-02-15 00:49:44.000000', 'temperatura', 20.0000, 'ºC'),
	(201666, 120, '2014-02-15 00:49:45.000000', 'temperatura', 950.0000, 'ºC'),
	(201667, 120, '2014-02-15 00:49:46.000000', 'temperatura', 1091.0000, 'ºC'),
	(201668, 120, '2014-02-15 00:49:47.000000', 'temperatura', 203.0000, 'ºC'),
	(201669, 120, '2014-02-15 00:49:48.000000', 'temperatura', 146.0000, 'ºC'),
	(201670, 120, '2014-02-15 00:49:49.000000', 'temperatura', 118.0000, 'ºC'),
	(201671, 120, '2014-02-15 00:49:50.000000', 'temperatura', 156.0000, 'ºC'),
	(201672, 120, '2014-02-15 00:49:51.000000', 'temperatura', 425.0000, 'ºC'),
	(201673, 120, '2014-02-15 00:49:52.000000', 'temperatura', 457.0000, 'ºC'),
	(201674, 120, '2014-02-15 00:49:53.000000', 'temperatura', 1009.0000, 'ºC'),
	(201675, 120, '2014-02-15 00:49:54.000000', 'temperatura', 75.0000, 'ºC'),
	(201676, 120, '2014-02-15 00:49:55.000000', 'temperatura', 949.0000, 'ºC'),
	(201677, 120, '2014-02-15 00:49:56.000000', 'temperatura', 923.0000, 'ºC'),
	(201678, 120, '2014-02-15 00:49:57.000000', 'temperatura', 565.0000, 'ºC'),
	(201679, 120, '2014-02-15 00:49:58.000000', 'temperatura', 58.0000, 'ºC'),
	(201680, 120, '2014-02-15 00:49:59.000000', 'temperatura', 994.0000, 'ºC'),
	(201681, 120, '2014-02-15 00:50:00.000000', 'temperatura', 1196.0000, 'ºC'),
	(201682, 120, '2014-02-15 00:50:01.000000', 'temperatura', 601.0000, 'ºC'),
	(201683, 120, '2014-02-15 00:50:02.000000', 'temperatura', 618.0000, 'ºC'),
	(201684, 120, '2014-02-15 00:50:03.000000', 'temperatura', 88.0000, 'ºC'),
	(201685, 120, '2014-02-15 00:50:04.000000', 'temperatura', 986.0000, 'ºC'),
	(201686, 120, '2014-02-15 00:50:05.000000', 'temperatura', 1065.0000, 'ºC'),
	(201687, 120, '2014-02-15 00:50:06.000000', 'temperatura', 1170.0000, 'ºC'),
	(201688, 120, '2014-02-15 00:50:07.000000', 'temperatura', 256.0000, 'ºC'),
	(201689, 120, '2014-02-15 00:50:08.000000', 'temperatura', 167.0000, 'ºC'),
	(201690, 120, '2014-02-15 00:50:09.000000', 'temperatura', 70.0000, 'ºC'),
	(201691, 120, '2014-02-15 00:50:10.000000', 'temperatura', 1049.0000, 'ºC'),
	(201692, 120, '2014-02-15 00:50:11.000000', 'temperatura', 235.0000, 'ºC'),
	(201693, 120, '2014-02-15 00:50:12.000000', 'temperatura', 430.0000, 'ºC'),
	(201694, 120, '2014-02-15 00:50:13.000000', 'temperatura', 245.0000, 'ºC'),
	(201695, 120, '2014-02-15 00:50:14.000000', 'temperatura', 1135.0000, 'ºC'),
	(201696, 120, '2014-02-15 00:50:15.000000', 'temperatura', 139.0000, 'ºC'),
	(201697, 120, '2014-02-15 00:50:16.000000', 'temperatura', 893.0000, 'ºC'),
	(201698, 120, '2014-02-15 00:50:17.000000', 'temperatura', 448.0000, 'ºC'),
	(201699, 120, '2014-02-15 00:50:18.000000', 'temperatura', 761.0000, 'ºC'),
	(201700, 120, '2014-02-15 00:50:19.000000', 'temperatura', 63.0000, 'ºC'),
	(201701, 120, '2014-02-15 00:50:20.000000', 'temperatura', 430.0000, 'ºC'),
	(201702, 120, '2014-02-15 00:50:21.000000', 'temperatura', 764.0000, 'ºC'),
	(201703, 120, '2014-02-15 00:50:22.000000', 'temperatura', 129.0000, 'ºC'),
	(201704, 120, '2014-02-15 00:50:23.000000', 'temperatura', 753.0000, 'ºC'),
	(201705, 120, '2014-02-15 00:50:24.000000', 'temperatura', 978.0000, 'ºC'),
	(201706, 120, '2014-02-15 00:50:25.000000', 'temperatura', 232.0000, 'ºC'),
	(201707, 120, '2014-02-15 00:50:26.000000', 'temperatura', 627.0000, 'ºC'),
	(201708, 120, '2014-02-15 00:50:27.000000', 'temperatura', 40.0000, 'ºC'),
	(201709, 120, '2014-02-15 00:50:28.000000', 'temperatura', 720.0000, 'ºC'),
	(201710, 120, '2014-02-15 00:50:29.000000', 'temperatura', 1078.0000, 'ºC'),
	(201711, 120, '2014-02-15 00:50:30.000000', 'temperatura', 832.0000, 'ºC'),
	(201712, 120, '2014-02-15 00:50:31.000000', 'temperatura', 927.0000, 'ºC'),
	(201713, 120, '2014-02-15 00:50:32.000000', 'temperatura', 937.0000, 'ºC'),
	(201714, 120, '2014-02-15 00:50:33.000000', 'temperatura', 707.0000, 'ºC'),
	(201715, 120, '2014-02-15 00:50:34.000000', 'temperatura', 722.0000, 'ºC'),
	(201716, 120, '2014-02-15 00:50:35.000000', 'temperatura', 292.0000, 'ºC'),
	(201717, 120, '2014-02-15 00:50:36.000000', 'temperatura', 492.0000, 'ºC'),
	(201718, 120, '2014-02-15 00:50:37.000000', 'temperatura', 388.0000, 'ºC'),
	(201719, 120, '2014-02-15 00:50:38.000000', 'temperatura', 461.0000, 'ºC'),
	(201720, 120, '2014-02-15 00:50:39.000000', 'temperatura', 1144.0000, 'ºC'),
	(201721, 120, '2014-02-15 00:50:40.000000', 'temperatura', 738.0000, 'ºC'),
	(201722, 120, '2014-02-15 00:50:41.000000', 'temperatura', 255.0000, 'ºC'),
	(201723, 120, '2014-02-15 00:50:42.000000', 'temperatura', 265.0000, 'ºC'),
	(201724, 120, '2014-02-15 00:50:43.000000', 'temperatura', 561.0000, 'ºC'),
	(201725, 120, '2014-02-15 00:50:44.000000', 'temperatura', 810.0000, 'ºC'),
	(201726, 120, '2014-02-15 00:50:45.000000', 'temperatura', 1166.0000, 'ºC'),
	(201727, 120, '2014-02-15 00:50:46.000000', 'temperatura', 1003.0000, 'ºC'),
	(201728, 120, '2014-02-15 00:50:47.000000', 'temperatura', 314.0000, 'ºC'),
	(201729, 120, '2014-02-15 00:50:48.000000', 'temperatura', 965.0000, 'ºC'),
	(201730, 120, '2014-02-15 00:50:49.000000', 'temperatura', 283.0000, 'ºC'),
	(201731, 120, '2014-02-15 00:50:50.000000', 'temperatura', 919.0000, 'ºC'),
	(201732, 120, '2014-02-15 00:50:51.000000', 'temperatura', 145.0000, 'ºC'),
	(201733, 120, '2014-02-15 00:50:52.000000', 'temperatura', 371.0000, 'ºC'),
	(201734, 120, '2014-02-15 00:50:53.000000', 'temperatura', 220.0000, 'ºC'),
	(201735, 120, '2014-02-15 00:50:54.000000', 'temperatura', 1186.0000, 'ºC'),
	(201736, 120, '2014-02-15 00:50:55.000000', 'temperatura', 471.0000, 'ºC'),
	(201737, 120, '2014-02-15 00:50:56.000000', 'temperatura', 1196.0000, 'ºC'),
	(201738, 120, '2014-02-15 00:50:57.000000', 'temperatura', 969.0000, 'ºC'),
	(201739, 120, '2014-02-15 00:50:58.000000', 'temperatura', 59.0000, 'ºC'),
	(201740, 120, '2014-02-15 00:50:59.000000', 'temperatura', 989.0000, 'ºC'),
	(201741, 120, '2014-02-15 00:51:00.000000', 'temperatura', 1167.0000, 'ºC'),
	(201742, 120, '2014-02-15 00:51:01.000000', 'temperatura', 469.0000, 'ºC'),
	(201743, 120, '2014-02-15 00:51:02.000000', 'temperatura', 46.0000, 'ºC'),
	(201744, 120, '2014-02-15 00:51:03.000000', 'temperatura', 23.0000, 'ºC'),
	(201745, 120, '2014-02-15 00:51:04.000000', 'temperatura', 1176.0000, 'ºC'),
	(201746, 120, '2014-02-15 00:51:05.000000', 'temperatura', 1013.0000, 'ºC'),
	(201747, 120, '2014-02-15 00:51:06.000000', 'temperatura', 335.0000, 'ºC'),
	(201748, 120, '2014-02-15 00:51:07.000000', 'temperatura', 1040.0000, 'ºC'),
	(201749, 120, '2014-02-15 00:51:08.000000', 'temperatura', 593.0000, 'ºC'),
	(201750, 120, '2014-02-15 00:51:09.000000', 'temperatura', 1047.0000, 'ºC'),
	(201751, 120, '2014-02-15 00:51:10.000000', 'temperatura', 1057.0000, 'ºC'),
	(201752, 120, '2014-02-15 00:51:11.000000', 'temperatura', 942.0000, 'ºC'),
	(201753, 120, '2014-02-15 00:51:12.000000', 'temperatura', 341.0000, 'ºC'),
	(201754, 120, '2014-02-15 00:51:13.000000', 'temperatura', 79.0000, 'ºC'),
	(201755, 120, '2014-02-15 00:51:14.000000', 'temperatura', 573.0000, 'ºC'),
	(201756, 120, '2014-02-15 00:51:15.000000', 'temperatura', 230.0000, 'ºC'),
	(201757, 120, '2014-02-15 00:51:16.000000', 'temperatura', 631.0000, 'ºC'),
	(201758, 120, '2014-02-15 00:51:17.000000', 'temperatura', 66.0000, 'ºC'),
	(201759, 120, '2014-02-15 00:51:18.000000', 'temperatura', 839.0000, 'ºC'),
	(201760, 120, '2014-02-15 00:51:19.000000', 'temperatura', 395.0000, 'ºC'),
	(201761, 120, '2014-02-15 00:51:20.000000', 'temperatura', 661.0000, 'ºC'),
	(201762, 120, '2014-02-15 00:51:21.000000', 'temperatura', 918.0000, 'ºC'),
	(201763, 120, '2014-02-15 00:51:22.000000', 'temperatura', 208.0000, 'ºC'),
	(201764, 120, '2014-02-15 00:51:23.000000', 'temperatura', 686.0000, 'ºC'),
	(201765, 120, '2014-02-15 00:51:24.000000', 'temperatura', 405.0000, 'ºC'),
	(201766, 120, '2014-02-15 00:51:25.000000', 'temperatura', 1170.0000, 'ºC'),
	(201767, 120, '2014-02-15 00:51:26.000000', 'temperatura', 1033.0000, 'ºC'),
	(201768, 120, '2014-02-15 00:51:27.000000', 'temperatura', 457.0000, 'ºC'),
	(201769, 120, '2014-02-15 00:51:28.000000', 'temperatura', 386.0000, 'ºC'),
	(201770, 120, '2014-02-15 00:51:29.000000', 'temperatura', 562.0000, 'ºC'),
	(201771, 120, '2014-02-15 00:51:30.000000', 'temperatura', 449.0000, 'ºC'),
	(201772, 120, '2014-02-15 00:51:31.000000', 'temperatura', 563.0000, 'ºC'),
	(201773, 120, '2014-02-15 00:51:32.000000', 'temperatura', 265.0000, 'ºC'),
	(201774, 120, '2014-02-15 00:51:33.000000', 'temperatura', 839.0000, 'ºC'),
	(201775, 120, '2014-02-15 00:51:34.000000', 'temperatura', 1001.0000, 'ºC'),
	(201776, 120, '2014-02-15 00:51:35.000000', 'temperatura', 86.0000, 'ºC'),
	(201777, 120, '2014-02-15 00:51:36.000000', 'temperatura', 1028.0000, 'ºC'),
	(201778, 120, '2014-02-15 00:51:37.000000', 'temperatura', 83.0000, 'ºC'),
	(201779, 120, '2014-02-15 00:51:38.000000', 'temperatura', 931.0000, 'ºC'),
	(201780, 120, '2014-02-15 00:51:39.000000', 'temperatura', 806.0000, 'ºC'),
	(201781, 120, '2014-02-15 00:51:40.000000', 'temperatura', 37.0000, 'ºC'),
	(201782, 120, '2014-02-15 00:51:41.000000', 'temperatura', 170.0000, 'ºC'),
	(201783, 120, '2014-02-15 00:51:42.000000', 'temperatura', 738.0000, 'ºC'),
	(201784, 120, '2014-02-15 00:51:43.000000', 'temperatura', 781.0000, 'ºC'),
	(201785, 120, '2014-02-15 00:51:44.000000', 'temperatura', 490.0000, 'ºC'),
	(201786, 120, '2014-02-15 00:51:45.000000', 'temperatura', 108.0000, 'ºC'),
	(201787, 120, '2014-02-15 00:51:46.000000', 'temperatura', 272.0000, 'ºC'),
	(201788, 120, '2014-02-15 00:51:47.000000', 'temperatura', 1037.0000, 'ºC'),
	(201789, 120, '2014-02-15 00:51:48.000000', 'temperatura', 770.0000, 'ºC'),
	(201790, 120, '2014-02-15 00:51:49.000000', 'temperatura', 740.0000, 'ºC'),
	(201791, 120, '2014-02-15 00:51:50.000000', 'temperatura', 188.0000, 'ºC'),
	(201792, 120, '2014-02-15 00:51:51.000000', 'temperatura', 1123.0000, 'ºC'),
	(201793, 120, '2014-02-15 00:51:52.000000', 'temperatura', 251.0000, 'ºC'),
	(201794, 120, '2014-02-15 00:51:53.000000', 'temperatura', 287.0000, 'ºC'),
	(201795, 120, '2014-02-15 00:51:54.000000', 'temperatura', 680.0000, 'ºC'),
	(201796, 120, '2014-02-15 00:51:55.000000', 'temperatura', 142.0000, 'ºC'),
	(201797, 120, '2014-02-15 00:51:56.000000', 'temperatura', 1070.0000, 'ºC'),
	(201798, 120, '2014-02-15 00:51:57.000000', 'temperatura', 124.0000, 'ºC'),
	(201799, 120, '2014-02-15 00:51:58.000000', 'temperatura', 1010.0000, 'ºC'),
	(201800, 120, '2014-02-15 00:51:59.000000', 'temperatura', 1080.0000, 'ºC'),
	(201801, 120, '2014-02-15 00:52:00.000000', 'temperatura', 1172.0000, 'ºC'),
	(201802, 120, '2014-02-15 00:52:01.000000', 'temperatura', 218.0000, 'ºC'),
	(201803, 120, '2014-02-15 00:52:02.000000', 'temperatura', 1177.0000, 'ºC'),
	(201804, 120, '2014-02-15 00:52:03.000000', 'temperatura', 430.0000, 'ºC'),
	(201805, 120, '2014-02-15 00:52:04.000000', 'temperatura', 1020.0000, 'ºC'),
	(201806, 120, '2014-02-15 00:52:05.000000', 'temperatura', 212.0000, 'ºC'),
	(201807, 120, '2014-02-15 00:52:06.000000', 'temperatura', 397.0000, 'ºC'),
	(201808, 120, '2014-02-15 00:52:07.000000', 'temperatura', 152.0000, 'ºC'),
	(201809, 120, '2014-02-15 00:52:08.000000', 'temperatura', 769.0000, 'ºC'),
	(201810, 120, '2014-02-15 00:52:09.000000', 'temperatura', 991.0000, 'ºC'),
	(201811, 120, '2014-02-15 00:52:10.000000', 'temperatura', 246.0000, 'ºC'),
	(201812, 120, '2014-02-15 00:52:11.000000', 'temperatura', 660.0000, 'ºC'),
	(201813, 120, '2014-02-15 00:52:12.000000', 'temperatura', 162.0000, 'ºC'),
	(201814, 120, '2014-02-15 00:52:13.000000', 'temperatura', 30.0000, 'ºC'),
	(201815, 120, '2014-02-15 00:52:14.000000', 'temperatura', 865.0000, 'ºC'),
	(201816, 120, '2014-02-15 00:52:15.000000', 'temperatura', 634.0000, 'ºC'),
	(201817, 120, '2014-02-15 00:52:16.000000', 'temperatura', 575.0000, 'ºC'),
	(201818, 120, '2014-02-15 00:52:17.000000', 'temperatura', 974.0000, 'ºC'),
	(201819, 120, '2014-02-15 00:52:18.000000', 'temperatura', 746.0000, 'ºC'),
	(201820, 120, '2014-02-15 00:52:19.000000', 'temperatura', 807.0000, 'ºC'),
	(201821, 120, '2014-02-15 00:52:20.000000', 'temperatura', 597.0000, 'ºC'),
	(201822, 120, '2014-02-15 00:52:21.000000', 'temperatura', 565.0000, 'ºC'),
	(201823, 120, '2014-02-15 00:52:22.000000', 'temperatura', 1037.0000, 'ºC'),
	(201824, 120, '2014-02-15 00:52:23.000000', 'temperatura', 1087.0000, 'ºC'),
	(201825, 120, '2014-02-15 00:52:24.000000', 'temperatura', 1126.0000, 'ºC'),
	(201826, 120, '2014-02-15 00:52:25.000000', 'temperatura', 1170.0000, 'ºC'),
	(201827, 120, '2014-02-15 00:52:26.000000', 'temperatura', 72.0000, 'ºC'),
	(201828, 120, '2014-02-15 00:52:27.000000', 'temperatura', 451.0000, 'ºC'),
	(201829, 120, '2014-02-15 00:52:28.000000', 'temperatura', 839.0000, 'ºC'),
	(201830, 120, '2014-02-15 00:52:29.000000', 'temperatura', 443.0000, 'ºC'),
	(201831, 120, '2014-02-15 00:52:30.000000', 'temperatura', 897.0000, 'ºC'),
	(201832, 120, '2014-02-15 00:52:31.000000', 'temperatura', 759.0000, 'ºC'),
	(201833, 120, '2014-02-15 00:52:32.000000', 'temperatura', 1103.0000, 'ºC'),
	(201834, 120, '2014-02-15 00:52:33.000000', 'temperatura', 839.0000, 'ºC'),
	(201835, 120, '2014-02-15 00:52:34.000000', 'temperatura', 886.0000, 'ºC'),
	(201836, 120, '2014-02-15 00:52:35.000000', 'temperatura', 713.0000, 'ºC'),
	(201837, 120, '2014-02-15 00:52:36.000000', 'temperatura', 908.0000, 'ºC'),
	(201838, 120, '2014-02-15 00:52:37.000000', 'temperatura', 2.0000, 'ºC'),
	(201839, 120, '2014-02-15 00:52:38.000000', 'temperatura', 885.0000, 'ºC'),
	(201840, 120, '2014-02-15 00:52:39.000000', 'temperatura', 822.0000, 'ºC'),
	(201841, 120, '2014-02-15 00:52:40.000000', 'temperatura', 254.0000, 'ºC'),
	(201842, 120, '2014-02-15 00:52:41.000000', 'temperatura', 5.0000, 'ºC'),
	(201843, 120, '2014-02-15 00:52:42.000000', 'temperatura', 463.0000, 'ºC'),
	(201844, 120, '2014-02-15 00:52:43.000000', 'temperatura', 1099.0000, 'ºC'),
	(201845, 120, '2014-02-15 00:52:44.000000', 'temperatura', 506.0000, 'ºC'),
	(201846, 120, '2014-02-15 00:52:45.000000', 'temperatura', 437.0000, 'ºC'),
	(201847, 120, '2014-02-15 00:52:46.000000', 'temperatura', 665.0000, 'ºC'),
	(201848, 120, '2014-02-15 00:52:47.000000', 'temperatura', 813.0000, 'ºC'),
	(201849, 120, '2014-02-15 00:52:48.000000', 'temperatura', 872.0000, 'ºC'),
	(201850, 120, '2014-02-15 00:52:49.000000', 'temperatura', 721.0000, 'ºC'),
	(201851, 120, '2014-02-15 00:52:50.000000', 'temperatura', 989.0000, 'ºC'),
	(201852, 120, '2014-02-15 00:52:51.000000', 'temperatura', 383.0000, 'ºC'),
	(201853, 120, '2014-02-15 00:52:52.000000', 'temperatura', 148.0000, 'ºC'),
	(201854, 120, '2014-02-15 00:52:53.000000', 'temperatura', 791.0000, 'ºC'),
	(201855, 120, '2014-02-15 00:52:54.000000', 'temperatura', 1114.0000, 'ºC'),
	(201856, 120, '2014-02-15 00:52:55.000000', 'temperatura', 795.0000, 'ºC'),
	(201857, 120, '2014-02-15 00:52:56.000000', 'temperatura', 636.0000, 'ºC'),
	(201858, 120, '2014-02-15 00:52:57.000000', 'temperatura', 794.0000, 'ºC'),
	(201859, 120, '2014-02-15 00:52:58.000000', 'temperatura', 862.0000, 'ºC'),
	(201860, 120, '2014-02-15 00:52:59.000000', 'temperatura', 730.0000, 'ºC'),
	(201861, 120, '2014-02-15 00:53:00.000000', 'temperatura', 1063.0000, 'ºC'),
	(201862, 120, '2014-02-15 00:53:01.000000', 'temperatura', 725.0000, 'ºC'),
	(201863, 120, '2014-02-15 00:53:02.000000', 'temperatura', 436.0000, 'ºC'),
	(201864, 120, '2014-02-15 00:53:03.000000', 'temperatura', 8.0000, 'ºC'),
	(201865, 120, '2014-02-15 00:53:04.000000', 'temperatura', 1133.0000, 'ºC'),
	(201866, 120, '2014-02-15 00:53:05.000000', 'temperatura', 839.0000, 'ºC'),
	(201867, 120, '2014-02-15 00:53:06.000000', 'temperatura', 799.0000, 'ºC'),
	(201868, 120, '2014-02-15 00:53:07.000000', 'temperatura', 277.0000, 'ºC'),
	(201869, 120, '2014-02-15 00:53:08.000000', 'temperatura', 189.0000, 'ºC'),
	(201870, 120, '2014-02-15 00:53:09.000000', 'temperatura', 113.0000, 'ºC'),
	(201871, 120, '2014-02-15 00:53:10.000000', 'temperatura', 1199.0000, 'ºC'),
	(201872, 120, '2014-02-15 00:53:11.000000', 'temperatura', 856.0000, 'ºC'),
	(201873, 120, '2014-02-15 00:53:12.000000', 'temperatura', 682.0000, 'ºC'),
	(201874, 120, '2014-02-15 00:53:13.000000', 'temperatura', 844.0000, 'ºC'),
	(201875, 120, '2014-02-15 00:53:14.000000', 'temperatura', 976.0000, 'ºC'),
	(201876, 120, '2014-02-15 00:53:15.000000', 'temperatura', 1148.0000, 'ºC'),
	(201877, 120, '2014-02-15 00:53:16.000000', 'temperatura', 412.0000, 'ºC'),
	(201878, 120, '2014-02-15 00:53:17.000000', 'temperatura', 1015.0000, 'ºC'),
	(201879, 120, '2014-02-15 00:53:18.000000', 'temperatura', 243.0000, 'ºC'),
	(201880, 120, '2014-02-15 00:53:19.000000', 'temperatura', 568.0000, 'ºC'),
	(201881, 120, '2014-02-15 00:53:20.000000', 'temperatura', 911.0000, 'ºC'),
	(201882, 120, '2014-02-15 00:53:21.000000', 'temperatura', 450.0000, 'ºC'),
	(201883, 120, '2014-02-15 00:53:22.000000', 'temperatura', 721.0000, 'ºC'),
	(201884, 120, '2014-02-15 00:53:23.000000', 'temperatura', 1054.0000, 'ºC'),
	(201885, 120, '2014-02-15 00:53:24.000000', 'temperatura', 708.0000, 'ºC'),
	(201886, 120, '2014-02-15 00:53:25.000000', 'temperatura', 377.0000, 'ºC'),
	(201887, 120, '2014-02-15 00:53:26.000000', 'temperatura', 960.0000, 'ºC'),
	(201888, 120, '2014-02-15 00:53:27.000000', 'temperatura', 73.0000, 'ºC'),
	(201889, 120, '2014-02-15 00:53:28.000000', 'temperatura', 1083.0000, 'ºC'),
	(201890, 120, '2014-02-15 00:53:29.000000', 'temperatura', 398.0000, 'ºC'),
	(201891, 120, '2014-02-15 00:53:30.000000', 'temperatura', 1143.0000, 'ºC'),
	(201892, 120, '2014-02-15 00:53:31.000000', 'temperatura', 919.0000, 'ºC'),
	(201893, 120, '2014-02-15 00:53:32.000000', 'temperatura', 1168.0000, 'ºC'),
	(201894, 120, '2014-02-15 00:53:33.000000', 'temperatura', 683.0000, 'ºC'),
	(201895, 120, '2014-02-15 00:53:34.000000', 'temperatura', 1113.0000, 'ºC'),
	(201896, 120, '2014-02-15 00:53:35.000000', 'temperatura', 1117.0000, 'ºC'),
	(201897, 120, '2014-02-15 00:53:36.000000', 'temperatura', 1047.0000, 'ºC'),
	(201898, 120, '2014-02-15 00:53:37.000000', 'temperatura', 685.0000, 'ºC'),
	(201899, 120, '2014-02-15 00:53:38.000000', 'temperatura', 284.0000, 'ºC'),
	(201900, 120, '2014-02-15 00:53:39.000000', 'temperatura', 563.0000, 'ºC'),
	(201901, 120, '2014-02-15 00:53:40.000000', 'temperatura', 765.0000, 'ºC'),
	(201902, 120, '2014-02-15 00:53:41.000000', 'temperatura', 935.0000, 'ºC'),
	(201903, 120, '2014-02-15 00:53:42.000000', 'temperatura', 1181.0000, 'ºC'),
	(201904, 120, '2014-02-15 00:53:43.000000', 'temperatura', 701.0000, 'ºC'),
	(201905, 120, '2014-02-15 00:53:44.000000', 'temperatura', 1162.0000, 'ºC'),
	(201906, 120, '2014-02-15 00:53:45.000000', 'temperatura', 110.0000, 'ºC'),
	(201907, 120, '2014-02-15 00:53:46.000000', 'temperatura', 661.0000, 'ºC'),
	(201908, 120, '2014-02-15 00:53:47.000000', 'temperatura', 576.0000, 'ºC'),
	(201909, 120, '2014-02-15 00:53:48.000000', 'temperatura', 899.0000, 'ºC'),
	(201910, 120, '2014-02-15 00:53:49.000000', 'temperatura', 368.0000, 'ºC'),
	(201911, 120, '2014-02-15 00:53:50.000000', 'temperatura', 342.0000, 'ºC'),
	(201912, 120, '2014-02-15 00:53:51.000000', 'temperatura', 606.0000, 'ºC'),
	(201913, 120, '2014-02-15 00:53:52.000000', 'temperatura', 807.0000, 'ºC'),
	(201914, 120, '2014-02-15 00:53:53.000000', 'temperatura', 1015.0000, 'ºC'),
	(201915, 120, '2014-02-15 00:53:54.000000', 'temperatura', 254.0000, 'ºC'),
	(201916, 120, '2014-02-15 00:53:55.000000', 'temperatura', 629.0000, 'ºC'),
	(201917, 120, '2014-02-15 00:53:56.000000', 'temperatura', 1180.0000, 'ºC'),
	(201918, 120, '2014-02-15 00:53:57.000000', 'temperatura', 414.0000, 'ºC'),
	(201919, 120, '2014-02-15 00:53:58.000000', 'temperatura', 933.0000, 'ºC'),
	(201920, 120, '2014-02-15 00:53:59.000000', 'temperatura', 1023.0000, 'ºC'),
	(201921, 120, '2014-02-15 00:54:00.000000', 'temperatura', 1114.0000, 'ºC'),
	(201922, 120, '2014-02-15 00:54:01.000000', 'temperatura', 104.0000, 'ºC'),
	(201923, 120, '2014-02-15 00:54:02.000000', 'temperatura', 778.0000, 'ºC'),
	(201924, 120, '2014-02-15 00:54:03.000000', 'temperatura', 1177.0000, 'ºC'),
	(201925, 120, '2014-02-15 00:54:04.000000', 'temperatura', 1153.0000, 'ºC'),
	(201926, 120, '2014-02-15 00:54:05.000000', 'temperatura', 1035.0000, 'ºC'),
	(201927, 120, '2014-02-15 00:54:06.000000', 'temperatura', 514.0000, 'ºC'),
	(201928, 120, '2014-02-15 00:54:07.000000', 'temperatura', 667.0000, 'ºC'),
	(201929, 120, '2014-02-15 00:54:08.000000', 'temperatura', 592.0000, 'ºC'),
	(201930, 120, '2014-02-15 00:54:09.000000', 'temperatura', 958.0000, 'ºC'),
	(201931, 120, '2014-02-15 00:54:10.000000', 'temperatura', 618.0000, 'ºC'),
	(201932, 120, '2014-02-15 00:54:11.000000', 'temperatura', 216.0000, 'ºC'),
	(201933, 120, '2014-02-15 00:54:12.000000', 'temperatura', 427.0000, 'ºC'),
	(201934, 120, '2014-02-15 00:54:13.000000', 'temperatura', 286.0000, 'ºC'),
	(201935, 120, '2014-02-15 00:54:14.000000', 'temperatura', 152.0000, 'ºC'),
	(201936, 120, '2014-02-15 00:54:15.000000', 'temperatura', 1101.0000, 'ºC'),
	(201937, 120, '2014-02-15 00:54:16.000000', 'temperatura', 250.0000, 'ºC'),
	(201938, 120, '2014-02-15 00:54:17.000000', 'temperatura', 345.0000, 'ºC'),
	(201939, 120, '2014-02-15 00:54:18.000000', 'temperatura', 979.0000, 'ºC'),
	(201940, 120, '2014-02-15 00:54:19.000000', 'temperatura', 258.0000, 'ºC'),
	(201941, 120, '2014-02-15 00:54:20.000000', 'temperatura', 756.0000, 'ºC'),
	(201942, 120, '2014-02-15 00:54:21.000000', 'temperatura', 604.0000, 'ºC'),
	(201943, 120, '2014-02-15 00:54:22.000000', 'temperatura', 752.0000, 'ºC'),
	(201944, 120, '2014-02-15 00:54:23.000000', 'temperatura', 751.0000, 'ºC'),
	(201945, 120, '2014-02-15 00:54:24.000000', 'temperatura', 298.0000, 'ºC'),
	(201946, 120, '2014-02-15 00:54:25.000000', 'temperatura', 438.0000, 'ºC'),
	(201947, 120, '2014-02-15 00:54:26.000000', 'temperatura', 96.0000, 'ºC'),
	(201948, 120, '2014-02-15 00:54:27.000000', 'temperatura', 366.0000, 'ºC'),
	(201949, 120, '2014-02-15 00:54:28.000000', 'temperatura', 343.0000, 'ºC'),
	(201950, 120, '2014-02-15 00:54:29.000000', 'temperatura', 616.0000, 'ºC'),
	(201951, 120, '2014-02-15 00:54:30.000000', 'temperatura', 853.0000, 'ºC'),
	(201952, 120, '2014-02-15 00:54:31.000000', 'temperatura', 17.0000, 'ºC'),
	(201953, 120, '2014-02-15 00:54:32.000000', 'temperatura', 1127.0000, 'ºC'),
	(201954, 120, '2014-02-15 00:54:33.000000', 'temperatura', 783.0000, 'ºC'),
	(201955, 120, '2014-02-15 00:54:34.000000', 'temperatura', 537.0000, 'ºC'),
	(201956, 120, '2014-02-15 00:54:35.000000', 'temperatura', 337.0000, 'ºC'),
	(201957, 120, '2014-02-15 00:54:36.000000', 'temperatura', 75.0000, 'ºC'),
	(201958, 120, '2014-02-15 00:54:37.000000', 'temperatura', 564.0000, 'ºC'),
	(201959, 120, '2014-02-15 00:54:38.000000', 'temperatura', 194.0000, 'ºC'),
	(201960, 120, '2014-02-15 00:54:39.000000', 'temperatura', 479.0000, 'ºC'),
	(201961, 120, '2014-02-15 00:54:40.000000', 'temperatura', 615.0000, 'ºC'),
	(201962, 120, '2014-02-15 00:54:41.000000', 'temperatura', 437.0000, 'ºC'),
	(201963, 120, '2014-02-15 00:54:42.000000', 'temperatura', 343.0000, 'ºC'),
	(201964, 120, '2014-02-15 00:54:43.000000', 'temperatura', 402.0000, 'ºC'),
	(201965, 120, '2014-02-15 00:54:44.000000', 'temperatura', 984.0000, 'ºC'),
	(201966, 120, '2014-02-15 00:54:45.000000', 'temperatura', 113.0000, 'ºC'),
	(201967, 120, '2014-02-15 00:54:46.000000', 'temperatura', 15.0000, 'ºC'),
	(201968, 120, '2014-02-15 00:54:47.000000', 'temperatura', 935.0000, 'ºC'),
	(201969, 120, '2014-02-15 00:54:48.000000', 'temperatura', 1030.0000, 'ºC'),
	(201970, 120, '2014-02-15 00:54:49.000000', 'temperatura', 1146.0000, 'ºC'),
	(201971, 120, '2014-02-15 00:54:50.000000', 'temperatura', 243.0000, 'ºC'),
	(201972, 120, '2014-02-15 00:54:51.000000', 'temperatura', 174.0000, 'ºC'),
	(201973, 120, '2014-02-15 00:54:52.000000', 'temperatura', 142.0000, 'ºC'),
	(201974, 120, '2014-02-15 00:54:53.000000', 'temperatura', 190.0000, 'ºC'),
	(201975, 120, '2014-02-15 00:54:54.000000', 'temperatura', 524.0000, 'ºC'),
	(201976, 120, '2014-02-15 00:54:55.000000', 'temperatura', 852.0000, 'ºC'),
	(201977, 120, '2014-02-15 00:54:56.000000', 'temperatura', 289.0000, 'ºC'),
	(201978, 120, '2014-02-15 00:54:57.000000', 'temperatura', 87.0000, 'ºC'),
	(201979, 120, '2014-02-15 00:54:58.000000', 'temperatura', 771.0000, 'ºC'),
	(201980, 120, '2014-02-15 00:54:59.000000', 'temperatura', 1194.0000, 'ºC'),
	(201981, 120, '2014-02-15 00:55:00.000000', 'temperatura', 56.0000, 'ºC'),
	(201982, 120, '2014-02-15 00:55:01.000000', 'temperatura', 299.0000, 'ºC'),
	(201983, 120, '2014-02-15 00:55:02.000000', 'temperatura', 129.0000, 'ºC'),
	(201984, 120, '2014-02-15 00:55:03.000000', 'temperatura', 948.0000, 'ºC'),
	(201985, 120, '2014-02-15 00:55:04.000000', 'temperatura', 752.0000, 'ºC'),
	(201986, 120, '2014-02-15 00:55:05.000000', 'temperatura', 917.0000, 'ºC'),
	(201987, 120, '2014-02-15 00:55:06.000000', 'temperatura', 1130.0000, 'ºC'),
	(201988, 120, '2014-02-15 00:55:07.000000', 'temperatura', 501.0000, 'ºC'),
	(201989, 120, '2014-02-15 00:55:08.000000', 'temperatura', 312.0000, 'ºC'),
	(201990, 120, '2014-02-15 00:55:09.000000', 'temperatura', 61.0000, 'ºC'),
	(201991, 120, '2014-02-15 00:55:10.000000', 'temperatura', 568.0000, 'ºC'),
	(201992, 120, '2014-02-15 00:55:11.000000', 'temperatura', 256.0000, 'ºC'),
	(201993, 120, '2014-02-15 00:55:12.000000', 'temperatura', 776.0000, 'ºC'),
	(201994, 120, '2014-02-15 00:55:13.000000', 'temperatura', 713.0000, 'ºC'),
	(201995, 120, '2014-02-15 00:55:14.000000', 'temperatura', 39.0000, 'ºC'),
	(201996, 120, '2014-02-15 00:55:15.000000', 'temperatura', 456.0000, 'ºC'),
	(201997, 120, '2014-02-15 00:55:16.000000', 'temperatura', 961.0000, 'ºC'),
	(201998, 120, '2014-02-15 00:55:17.000000', 'temperatura', 1041.0000, 'ºC'),
	(201999, 120, '2014-02-15 00:55:18.000000', 'temperatura', 1120.0000, 'ºC'),
	(202000, 120, '2014-02-15 00:55:19.000000', 'temperatura', 79.0000, 'ºC'),
	(202001, 120, '2014-02-15 00:55:20.000000', 'temperatura', 634.0000, 'ºC'),
	(202002, 120, '2014-02-15 00:55:21.000000', 'temperatura', 534.0000, 'ºC'),
	(202003, 120, '2014-02-15 00:55:22.000000', 'temperatura', 770.0000, 'ºC'),
	(202004, 120, '2014-02-15 00:55:23.000000', 'temperatura', 1046.0000, 'ºC'),
	(202005, 120, '2014-02-15 00:55:24.000000', 'temperatura', 523.0000, 'ºC'),
	(202006, 120, '2014-02-15 00:55:25.000000', 'temperatura', 675.0000, 'ºC'),
	(202007, 120, '2014-02-15 00:55:26.000000', 'temperatura', 605.0000, 'ºC'),
	(202008, 120, '2014-02-15 00:55:27.000000', 'temperatura', 1004.0000, 'ºC'),
	(202009, 120, '2014-02-15 00:55:28.000000', 'temperatura', 805.0000, 'ºC'),
	(202010, 120, '2014-02-15 00:55:29.000000', 'temperatura', 1014.0000, 'ºC'),
	(202011, 120, '2014-02-15 00:55:30.000000', 'temperatura', 255.0000, 'ºC'),
	(202012, 120, '2014-02-15 00:55:31.000000', 'temperatura', 631.0000, 'ºC'),
	(202013, 120, '2014-02-15 00:55:32.000000', 'temperatura', 1194.0000, 'ºC'),
	(202014, 120, '2014-02-15 00:55:33.000000', 'temperatura', 474.0000, 'ºC'),
	(202015, 120, '2014-02-15 00:55:34.000000', 'temperatura', 1191.0000, 'ºC'),
	(202016, 120, '2014-02-15 00:55:35.000000', 'temperatura', 935.0000, 'ºC'),
	(202017, 120, '2014-02-15 00:55:36.000000', 'temperatura', 1099.0000, 'ºC'),
	(202018, 120, '2014-02-15 00:55:37.000000', 'temperatura', 292.0000, 'ºC'),
	(202019, 120, '2014-02-15 00:55:38.000000', 'temperatura', 565.0000, 'ºC'),
	(202020, 120, '2014-02-15 00:55:39.000000', 'temperatura', 748.0000, 'ºC'),
	(202021, 120, '2014-02-15 00:55:40.000000', 'temperatura', 844.0000, 'ºC'),
	(202022, 120, '2014-02-15 00:55:41.000000', 'temperatura', 778.0000, 'ºC'),
	(202023, 120, '2014-02-15 00:55:42.000000', 'temperatura', 157.0000, 'ºC'),
	(202024, 120, '2014-02-15 00:55:43.000000', 'temperatura', 853.0000, 'ºC'),
	(202025, 120, '2014-02-15 00:55:44.000000', 'temperatura', 195.0000, 'ºC'),
	(202026, 120, '2014-02-15 00:55:45.000000', 'temperatura', 816.0000, 'ºC'),
	(202027, 120, '2014-02-15 00:55:46.000000', 'temperatura', 1097.0000, 'ºC'),
	(202028, 120, '2014-02-15 00:55:47.000000', 'temperatura', 637.0000, 'ºC'),
	(202029, 120, '2014-02-15 00:55:48.000000', 'temperatura', 1096.0000, 'ºC'),
	(202030, 120, '2014-02-15 00:55:49.000000', 'temperatura', 1167.0000, 'ºC'),
	(202031, 120, '2014-02-15 00:55:50.000000', 'temperatura', 150.0000, 'ºC'),
	(202032, 120, '2014-02-15 00:55:51.000000', 'temperatura', 847.0000, 'ºC'),
	(202033, 120, '2014-02-15 00:55:52.000000', 'temperatura', 189.0000, 'ºC'),
	(202034, 120, '2014-02-15 00:55:53.000000', 'temperatura', 801.0000, 'ºC'),
	(202035, 120, '2014-02-15 00:55:54.000000', 'temperatura', 1039.0000, 'ºC'),
	(202036, 120, '2014-02-15 00:55:55.000000', 'temperatura', 391.0000, 'ºC'),
	(202037, 120, '2014-02-15 00:55:56.000000', 'temperatura', 41.0000, 'ºC'),
	(202038, 120, '2014-02-15 00:55:57.000000', 'temperatura', 233.0000, 'ºC'),
	(202039, 120, '2014-02-15 00:55:58.000000', 'temperatura', 1041.0000, 'ºC'),
	(202040, 120, '2014-02-15 00:55:59.000000', 'temperatura', 909.0000, 'ºC'),
	(202041, 120, '2014-02-15 00:56:00.000000', 'temperatura', 220.0000, 'ºC'),
	(202042, 120, '2014-02-15 00:56:01.000000', 'temperatura', 775.0000, 'ºC'),
	(202043, 120, '2014-02-15 00:56:02.000000', 'temperatura', 817.0000, 'ºC'),
	(202044, 120, '2014-02-15 00:56:03.000000', 'temperatura', 559.0000, 'ºC'),
	(202045, 120, '2014-02-15 00:56:04.000000', 'temperatura', 343.0000, 'ºC'),
	(202046, 120, '2014-02-15 00:56:05.000000', 'temperatura', 38.0000, 'ºC'),
	(202047, 120, '2014-02-15 00:56:06.000000', 'temperatura', 361.0000, 'ºC'),
	(202048, 120, '2014-02-15 00:56:07.000000', 'temperatura', 493.0000, 'ºC'),
	(202049, 120, '2014-02-15 00:56:08.000000', 'temperatura', 183.0000, 'ºC'),
	(202050, 120, '2014-02-15 00:56:09.000000', 'temperatura', 638.0000, 'ºC'),
	(202051, 120, '2014-02-15 00:56:10.000000', 'temperatura', 240.0000, 'ºC'),
	(202052, 120, '2014-02-15 00:56:11.000000', 'temperatura', 487.0000, 'ºC'),
	(202053, 120, '2014-02-15 00:56:12.000000', 'temperatura', 513.0000, 'ºC'),
	(202054, 120, '2014-02-15 00:56:13.000000', 'temperatura', 1107.0000, 'ºC'),
	(202055, 120, '2014-02-15 00:56:14.000000', 'temperatura', 397.0000, 'ºC'),
	(202056, 120, '2014-02-15 00:56:15.000000', 'temperatura', 1064.0000, 'ºC'),
	(202057, 120, '2014-02-15 00:56:16.000000', 'temperatura', 529.0000, 'ºC'),
	(202058, 120, '2014-02-15 00:56:17.000000', 'temperatura', 655.0000, 'ºC'),
	(202059, 120, '2014-02-15 00:56:18.000000', 'temperatura', 485.0000, 'ºC'),
	(202060, 120, '2014-02-15 00:56:19.000000', 'temperatura', 464.0000, 'ºC'),
	(202061, 120, '2014-02-15 00:56:20.000000', 'temperatura', 866.0000, 'ºC'),
	(202062, 120, '2014-02-15 00:56:21.000000', 'temperatura', 538.0000, 'ºC'),
	(202063, 120, '2014-02-15 00:56:22.000000', 'temperatura', 92.0000, 'ºC'),
	(202064, 120, '2014-02-15 00:56:23.000000', 'temperatura', 48.0000, 'ºC'),
	(202065, 120, '2014-02-15 00:56:24.000000', 'temperatura', 1164.0000, 'ºC'),
	(202066, 120, '2014-02-15 00:56:25.000000', 'temperatura', 876.0000, 'ºC'),
	(202067, 120, '2014-02-15 00:56:26.000000', 'temperatura', 888.0000, 'ºC'),
	(202068, 120, '2014-02-15 00:56:27.000000', 'temperatura', 611.0000, 'ºC'),
	(202069, 120, '2014-02-15 00:56:28.000000', 'temperatura', 393.0000, 'ºC'),
	(202070, 120, '2014-02-15 00:56:29.000000', 'temperatura', 134.0000, 'ºC'),
	(202071, 120, '2014-02-15 00:56:30.000000', 'temperatura', 691.0000, 'ºC'),
	(202072, 120, '2014-02-15 00:56:31.000000', 'temperatura', 651.0000, 'ºC'),
	(202073, 120, '2014-02-15 00:56:32.000000', 'temperatura', 1184.0000, 'ºC'),
	(202074, 120, '2014-02-15 00:56:33.000000', 'temperatura', 367.0000, 'ºC'),
	(202075, 120, '2014-02-15 00:56:34.000000', 'temperatura', 685.0000, 'ºC'),
	(202076, 120, '2014-02-15 00:56:35.000000', 'temperatura', 1124.0000, 'ºC'),
	(202077, 120, '2014-02-15 00:56:36.000000', 'temperatura', 1166.0000, 'ºC'),
	(202078, 120, '2014-02-15 00:56:37.000000', 'temperatura', 59.0000, 'ºC'),
	(202079, 120, '2014-02-15 00:56:38.000000', 'temperatura', 397.0000, 'ºC'),
	(202080, 120, '2014-02-15 00:56:39.000000', 'temperatura', 608.0000, 'ºC'),
	(202081, 120, '2014-02-15 00:56:40.000000', 'temperatura', 648.0000, 'ºC'),
	(202082, 120, '2014-02-15 00:56:41.000000', 'temperatura', 217.0000, 'ºC'),
	(202083, 120, '2014-02-15 00:56:42.000000', 'temperatura', 341.0000, 'ºC'),
	(202084, 120, '2014-02-15 00:56:43.000000', 'temperatura', 1056.0000, 'ºC'),
	(202085, 120, '2014-02-15 00:56:44.000000', 'temperatura', 659.0000, 'ºC'),
	(202086, 120, '2014-02-15 00:56:45.000000', 'temperatura', 126.0000, 'ºC'),
	(202087, 120, '2014-02-15 00:56:46.000000', 'temperatura', 1053.0000, 'ºC'),
	(202088, 120, '2014-02-15 00:56:47.000000', 'temperatura', 86.0000, 'ºC'),
	(202089, 120, '2014-02-15 00:56:48.000000', 'temperatura', 874.0000, 'ºC'),
	(202090, 120, '2014-02-15 00:56:49.000000', 'temperatura', 511.0000, 'ºC'),
	(202091, 120, '2014-02-15 00:56:50.000000', 'temperatura', 1136.0000, 'ºC'),
	(202092, 120, '2014-02-15 00:56:51.000000', 'temperatura', 546.0000, 'ºC'),
	(202093, 120, '2014-02-15 00:56:52.000000', 'temperatura', 522.0000, 'ºC'),
	(202094, 120, '2014-02-15 00:56:53.000000', 'temperatura', 972.0000, 'ºC'),
	(202095, 120, '2014-02-15 00:56:54.000000', 'temperatura', 897.0000, 'ºC'),
	(202096, 120, '2014-02-15 00:56:55.000000', 'temperatura', 367.0000, 'ºC'),
	(202097, 120, '2014-02-15 00:56:56.000000', 'temperatura', 347.0000, 'ºC'),
	(202098, 120, '2014-02-15 00:56:57.000000', 'temperatura', 634.0000, 'ºC'),
	(202099, 120, '2014-02-15 00:56:58.000000', 'temperatura', 930.0000, 'ºC'),
	(202100, 120, '2014-02-15 00:56:59.000000', 'temperatura', 348.0000, 'ºC'),
	(202101, 120, '2014-02-15 00:57:00.000000', 'temperatura', 150.0000, 'ºC'),
	(202102, 120, '2014-02-15 00:57:01.000000', 'temperatura', 909.0000, 'ºC'),
	(202103, 120, '2014-02-15 00:57:02.000000', 'temperatura', 494.0000, 'ºC'),
	(202104, 120, '2014-02-15 00:57:03.000000', 'temperatura', 942.0000, 'ºC'),
	(202105, 120, '2014-02-15 00:57:04.000000', 'temperatura', 828.0000, 'ºC'),
	(202106, 120, '2014-02-15 00:57:05.000000', 'temperatura', 115.0000, 'ºC'),
	(202107, 120, '2014-02-15 00:57:06.000000', 'temperatura', 492.0000, 'ºC'),
	(202108, 120, '2014-02-15 00:57:07.000000', 'temperatura', 917.0000, 'ºC'),
	(202109, 120, '2014-02-15 00:57:08.000000', 'temperatura', 707.0000, 'ºC'),
	(202110, 120, '2014-02-15 00:57:09.000000', 'temperatura', 786.0000, 'ºC'),
	(202111, 120, '2014-02-15 00:57:10.000000', 'temperatura', 611.0000, 'ºC'),
	(202112, 120, '2014-02-15 00:57:11.000000', 'temperatura', 696.0000, 'ºC'),
	(202113, 120, '2014-02-15 00:57:12.000000', 'temperatura', 447.0000, 'ºC'),
	(202114, 120, '2014-02-15 00:57:13.000000', 'temperatura', 146.0000, 'ºC'),
	(202115, 120, '2014-02-15 00:57:14.000000', 'temperatura', 592.0000, 'ºC'),
	(202116, 120, '2014-02-15 00:57:15.000000', 'temperatura', 122.0000, 'ºC'),
	(202117, 120, '2014-02-15 00:57:16.000000', 'temperatura', 35.0000, 'ºC'),
	(202118, 120, '2014-02-15 00:57:17.000000', 'temperatura', 1009.0000, 'ºC'),
	(202119, 120, '2014-02-15 00:57:18.000000', 'temperatura', 139.0000, 'ºC'),
	(202120, 120, '2014-02-15 00:57:19.000000', 'temperatura', 70.0000, 'ºC'),
	(202121, 120, '2014-02-15 00:57:20.000000', 'temperatura', 1132.0000, 'ºC'),
	(202122, 120, '2014-02-15 00:57:21.000000', 'temperatura', 651.0000, 'ºC'),
	(202123, 120, '2014-02-15 00:57:22.000000', 'temperatura', 1059.0000, 'ºC'),
	(202124, 120, '2014-02-15 00:57:23.000000', 'temperatura', 942.0000, 'ºC'),
	(202125, 120, '2014-02-15 00:57:24.000000', 'temperatura', 333.0000, 'ºC'),
	(202126, 120, '2014-02-15 00:57:25.000000', 'temperatura', 38.0000, 'ºC'),
	(202127, 120, '2014-02-15 00:57:26.000000', 'temperatura', 395.0000, 'ºC'),
	(202128, 120, '2014-02-15 00:57:27.000000', 'temperatura', 661.0000, 'ºC'),
	(202129, 120, '2014-02-15 00:57:28.000000', 'temperatura', 921.0000, 'ºC'),
	(202130, 120, '2014-02-15 00:57:29.000000', 'temperatura', 221.0000, 'ºC'),
	(202131, 120, '2014-02-15 00:57:30.000000', 'temperatura', 745.0000, 'ºC'),
	(202132, 120, '2014-02-15 00:57:31.000000', 'temperatura', 661.0000, 'ºC'),
	(202133, 120, '2014-02-15 00:57:32.000000', 'temperatura', 1072.0000, 'ºC'),
	(202134, 120, '2014-02-15 00:57:33.000000', 'temperatura', 975.0000, 'ºC'),
	(202135, 120, '2014-02-15 00:57:34.000000', 'temperatura', 461.0000, 'ºC'),
	(202136, 120, '2014-02-15 00:57:35.000000', 'temperatura', 579.0000, 'ºC'),
	(202137, 120, '2014-02-15 00:57:36.000000', 'temperatura', 315.0000, 'ºC'),
	(202138, 120, '2014-02-15 00:57:37.000000', 'temperatura', 1036.0000, 'ºC'),
	(202139, 120, '2014-02-15 00:57:38.000000', 'temperatura', 638.0000, 'ºC'),
	(202140, 120, '2014-02-15 00:57:39.000000', 'temperatura', 80.0000, 'ºC'),
	(202141, 120, '2014-02-15 00:57:40.000000', 'temperatura', 887.0000, 'ºC'),
	(202142, 120, '2014-02-15 00:57:41.000000', 'temperatura', 598.0000, 'ºC'),
	(202143, 120, '2014-02-15 00:57:42.000000', 'temperatura', 327.0000, 'ºC'),
	(202144, 120, '2014-02-15 00:57:43.000000', 'temperatura', 1043.0000, 'ºC'),
	(202145, 120, '2014-02-15 00:57:44.000000', 'temperatura', 634.0000, 'ºC'),
	(202146, 120, '2014-02-15 00:57:45.000000', 'temperatura', 42.0000, 'ºC'),
	(202147, 120, '2014-02-15 00:57:46.000000', 'temperatura', 707.0000, 'ºC'),
	(202148, 120, '2014-02-15 00:57:47.000000', 'temperatura', 1010.0000, 'ºC'),
	(202149, 120, '2014-02-15 00:57:48.000000', 'temperatura', 529.0000, 'ºC'),
	(202150, 120, '2014-02-15 00:57:49.000000', 'temperatura', 816.0000, 'ºC'),
	(202151, 120, '2014-02-15 00:57:50.000000', 'temperatura', 96.0000, 'ºC'),
	(202152, 120, '2014-02-15 00:57:51.000000', 'temperatura', 429.0000, 'ºC'),
	(202153, 120, '2014-02-15 00:57:52.000000', 'temperatura', 657.0000, 'ºC'),
	(202154, 120, '2014-02-15 00:57:53.000000', 'temperatura', 801.0000, 'ºC'),
	(202155, 120, '2014-02-15 00:57:54.000000', 'temperatura', 833.0000, 'ºC'),
	(202156, 120, '2014-02-15 00:57:55.000000', 'temperatura', 564.0000, 'ºC'),
	(202157, 120, '2014-02-15 00:57:56.000000', 'temperatura', 323.0000, 'ºC'),
	(202158, 120, '2014-02-15 00:57:57.000000', 'temperatura', 1121.0000, 'ºC'),
	(202159, 120, '2014-02-15 00:57:58.000000', 'temperatura', 1036.0000, 'ºC'),
	(202160, 120, '2014-02-15 00:57:59.000000', 'temperatura', 617.0000, 'ºC'),
	(202161, 120, '2014-02-15 00:58:00.000000', 'temperatura', 1179.0000, 'ºC'),
	(202162, 120, '2014-02-15 00:58:01.000000', 'temperatura', 444.0000, 'ºC'),
	(202163, 120, '2014-02-15 00:58:02.000000', 'temperatura', 1082.0000, 'ºC'),
	(202164, 120, '2014-02-15 00:58:03.000000', 'temperatura', 478.0000, 'ºC'),
	(202165, 120, '2014-02-15 00:58:04.000000', 'temperatura', 344.0000, 'ºC'),
	(202166, 120, '2014-02-15 00:58:05.000000', 'temperatura', 286.0000, 'ºC'),
	(202167, 120, '2014-02-15 00:58:06.000000', 'temperatura', 401.0000, 'ºC'),
	(202168, 120, '2014-02-15 00:58:07.000000', 'temperatura', 1148.0000, 'ºC'),
	(202169, 120, '2014-02-15 00:58:08.000000', 'temperatura', 938.0000, 'ºC'),
	(202170, 120, '2014-02-15 00:58:09.000000', 'temperatura', 45.0000, 'ºC'),
	(202171, 120, '2014-02-15 00:58:10.000000', 'temperatura', 1014.0000, 'ºC'),
	(202172, 120, '2014-02-15 00:58:11.000000', 'temperatura', 132.0000, 'ºC'),
	(202173, 120, '2014-02-15 00:58:12.000000', 'temperatura', 22.0000, 'ºC'),
	(202174, 120, '2014-02-15 00:58:13.000000', 'temperatura', 912.0000, 'ºC'),
	(202175, 120, '2014-02-15 00:58:14.000000', 'temperatura', 895.0000, 'ºC'),
	(202176, 120, '2014-02-15 00:58:15.000000', 'temperatura', 540.0000, 'ºC'),
	(202177, 120, '2014-02-15 00:58:16.000000', 'temperatura', 14.0000, 'ºC'),
	(202178, 120, '2014-02-15 00:58:17.000000', 'temperatura', 852.0000, 'ºC'),
	(202179, 120, '2014-02-15 00:58:18.000000', 'temperatura', 618.0000, 'ºC'),
	(202180, 120, '2014-02-15 00:58:19.000000', 'temperatura', 536.0000, 'ºC'),
	(202181, 120, '2014-02-15 00:58:20.000000', 'temperatura', 824.0000, 'ºC'),
	(202182, 120, '2014-02-15 00:58:21.000000', 'temperatura', 112.0000, 'ºC'),
	(202183, 120, '2014-02-15 00:58:22.000000', 'temperatura', 491.0000, 'ºC'),
	(202184, 120, '2014-02-15 00:58:23.000000', 'temperatura', 921.0000, 'ºC'),
	(202185, 120, '2014-02-15 00:58:24.000000', 'temperatura', 729.0000, 'ºC'),
	(202186, 120, '2014-02-15 00:58:25.000000', 'temperatura', 883.0000, 'ºC'),
	(202187, 120, '2014-02-15 00:58:26.000000', 'temperatura', 1029.0000, 'ºC'),
	(202188, 120, '2014-02-15 00:58:27.000000', 'temperatura', 97.0000, 'ºC'),
	(202189, 120, '2014-02-15 00:58:28.000000', 'temperatura', 999.0000, 'ºC'),
	(202190, 120, '2014-02-15 00:58:29.000000', 'temperatura', 1104.0000, 'ºC'),
	(202191, 120, '2014-02-15 00:58:30.000000', 'temperatura', 125.0000, 'ºC'),
	(202192, 120, '2014-02-15 00:58:31.000000', 'temperatura', 913.0000, 'ºC'),
	(202193, 120, '2014-02-15 00:58:32.000000', 'temperatura', 588.0000, 'ºC'),
	(202194, 120, '2014-02-15 00:58:33.000000', 'temperatura', 204.0000, 'ºC'),
	(202195, 120, '2014-02-15 00:58:34.000000', 'temperatura', 455.0000, 'ºC'),
	(202196, 120, '2014-02-15 00:58:35.000000', 'temperatura', 463.0000, 'ºC'),
	(202197, 120, '2014-02-15 00:58:36.000000', 'temperatura', 952.0000, 'ºC'),
	(202198, 120, '2014-02-15 00:58:37.000000', 'temperatura', 973.0000, 'ºC'),
	(202199, 120, '2014-02-15 00:58:38.000000', 'temperatura', 808.0000, 'ºC'),
	(202200, 120, '2014-02-15 00:58:39.000000', 'temperatura', 1121.0000, 'ºC'),
	(202201, 120, '2014-02-15 00:58:40.000000', 'temperatura', 783.0000, 'ºC'),
	(202202, 120, '2014-02-15 00:58:41.000000', 'temperatura', 552.0000, 'ºC'),
	(202203, 120, '2014-02-15 00:58:42.000000', 'temperatura', 410.0000, 'ºC'),
	(202204, 120, '2014-02-15 00:58:43.000000', 'temperatura', 394.0000, 'ºC'),
	(202205, 120, '2014-02-15 00:58:44.000000', 'temperatura', 741.0000, 'ºC'),
	(202206, 120, '2014-02-15 00:58:45.000000', 'temperatura', 125.0000, 'ºC'),
	(202207, 120, '2014-02-15 00:58:46.000000', 'temperatura', 801.0000, 'ºC'),
	(202208, 120, '2014-02-15 00:58:47.000000', 'temperatura', 31.0000, 'ºC'),
	(202209, 120, '2014-02-15 00:58:48.000000', 'temperatura', 150.0000, 'ºC'),
	(202210, 120, '2014-02-15 00:58:49.000000', 'temperatura', 661.0000, 'ºC'),
	(202211, 120, '2014-02-15 00:58:50.000000', 'temperatura', 456.0000, 'ºC'),
	(202212, 120, '2014-02-15 00:58:51.000000', 'temperatura', 294.0000, 'ºC'),
	(202213, 120, '2014-02-15 00:58:52.000000', 'temperatura', 106.0000, 'ºC'),
	(202214, 120, '2014-02-15 00:58:53.000000', 'temperatura', 848.0000, 'ºC'),
	(202215, 120, '2014-02-15 00:58:54.000000', 'temperatura', 320.0000, 'ºC'),
	(202216, 120, '2014-02-15 00:58:55.000000', 'temperatura', 258.0000, 'ºC'),
	(202217, 120, '2014-02-15 00:58:56.000000', 'temperatura', 329.0000, 'ºC'),
	(202218, 120, '2014-02-15 00:58:57.000000', 'temperatura', 873.0000, 'ºC'),
	(202219, 120, '2014-02-15 00:58:58.000000', 'temperatura', 976.0000, 'ºC'),
	(202220, 120, '2014-02-15 00:58:59.000000', 'temperatura', 1065.0000, 'ºC'),
	(202221, 120, '2014-02-15 00:59:00.000000', 'temperatura', 1194.0000, 'ºC'),
	(202222, 120, '2014-02-15 00:59:01.000000', 'temperatura', 379.0000, 'ºC'),
	(202223, 120, '2014-02-15 00:59:02.000000', 'temperatura', 710.0000, 'ºC'),
	(202224, 120, '2014-02-15 00:59:03.000000', 'temperatura', 16.0000, 'ºC'),
	(202225, 120, '2014-02-15 00:59:04.000000', 'temperatura', 348.0000, 'ºC'),
	(202226, 120, '2014-02-15 00:59:05.000000', 'temperatura', 494.0000, 'ºC'),
	(202227, 120, '2014-02-15 00:59:06.000000', 'temperatura', 226.0000, 'ºC'),
	(202228, 120, '2014-02-15 00:59:07.000000', 'temperatura', 848.0000, 'ºC'),
	(202229, 120, '2014-02-15 00:59:08.000000', 'temperatura', 1161.0000, 'ºC'),
	(202230, 120, '2014-02-15 00:59:09.000000', 'temperatura', 864.0000, 'ºC'),
	(202231, 120, '2014-02-15 00:59:10.000000', 'temperatura', 837.0000, 'ºC'),
	(202232, 120, '2014-02-15 00:59:11.000000', 'temperatura', 393.0000, 'ºC'),
	(202233, 120, '2014-02-15 00:59:12.000000', 'temperatura', 653.0000, 'ºC'),
	(202234, 120, '2014-02-15 00:59:13.000000', 'temperatura', 890.0000, 'ºC'),
	(202235, 120, '2014-02-15 00:59:14.000000', 'temperatura', 89.0000, 'ºC'),
	(202236, 120, '2014-02-15 00:59:15.000000', 'temperatura', 176.0000, 'ºC'),
	(202237, 120, '2014-02-15 00:59:16.000000', 'temperatura', 614.0000, 'ºC'),
	(202238, 120, '2014-02-15 00:59:17.000000', 'temperatura', 142.0000, 'ºC'),
	(202239, 120, '2014-02-15 00:59:18.000000', 'temperatura', 67.0000, 'ºC'),
	(202240, 120, '2014-02-15 00:59:19.000000', 'temperatura', 1109.0000, 'ºC'),
	(202241, 120, '2014-02-15 00:59:20.000000', 'temperatura', 545.0000, 'ºC'),
	(202242, 120, '2014-02-15 00:59:21.000000', 'temperatura', 597.0000, 'ºC'),
	(202243, 120, '2014-02-15 00:59:22.000000', 'temperatura', 152.0000, 'ºC'),
	(202244, 120, '2014-02-15 00:59:23.000000', 'temperatura', 170.0000, 'ºC'),
	(202245, 120, '2014-02-15 00:59:24.000000', 'temperatura', 393.0000, 'ºC'),
	(202246, 120, '2014-02-15 00:59:25.000000', 'temperatura', 256.0000, 'ºC'),
	(202247, 120, '2014-02-15 00:59:26.000000', 'temperatura', 102.0000, 'ºC'),
	(202248, 120, '2014-02-15 00:59:27.000000', 'temperatura', 943.0000, 'ºC'),
	(202249, 120, '2014-02-15 00:59:28.000000', 'temperatura', 808.0000, 'ºC'),
	(202250, 120, '2014-02-15 00:59:29.000000', 'temperatura', 10.0000, 'ºC'),
	(202251, 120, '2014-02-15 00:59:30.000000', 'temperatura', 28.0000, 'ºC'),
	(202252, 120, '2014-02-15 00:59:31.000000', 'temperatura', 112.0000, 'ºC'),
	(202253, 120, '2014-02-15 00:59:32.000000', 'temperatura', 474.0000, 'ºC'),
	(202254, 120, '2014-02-15 00:59:33.000000', 'temperatura', 835.0000, 'ºC'),
	(202255, 120, '2014-02-15 00:59:34.000000', 'temperatura', 353.0000, 'ºC'),
	(202256, 120, '2014-02-15 00:59:35.000000', 'temperatura', 459.0000, 'ºC'),
	(202257, 120, '2014-02-15 00:59:36.000000', 'temperatura', 39.0000, 'ºC'),
	(202258, 120, '2014-02-15 00:59:37.000000', 'temperatura', 17.0000, 'ºC'),
	(202259, 120, '2014-02-15 00:59:38.000000', 'temperatura', 1170.0000, 'ºC'),
	(202260, 120, '2014-02-15 00:59:39.000000', 'temperatura', 1000.0000, 'ºC'),
	(202261, 120, '2014-02-15 00:59:40.000000', 'temperatura', 292.0000, 'ºC'),
	(202262, 120, '2014-02-15 00:59:41.000000', 'temperatura', 858.0000, 'ºC'),
	(202263, 120, '2014-02-15 00:59:42.000000', 'temperatura', 1014.0000, 'ºC'),
	(202264, 120, '2014-02-15 00:59:43.000000', 'temperatura', 97.0000, 'ºC'),
	(202265, 120, '2014-02-15 00:59:44.000000', 'temperatura', 1045.0000, 'ºC'),
	(202266, 120, '2014-02-15 00:59:45.000000', 'temperatura', 132.0000, 'ºC'),
	(202267, 120, '2014-02-15 00:59:46.000000', 'temperatura', 1125.0000, 'ºC'),
	(202268, 120, '2014-02-15 00:59:47.000000', 'temperatura', 430.0000, 'ºC'),
	(202269, 120, '2014-02-15 00:59:48.000000', 'temperatura', 1176.0000, 'ºC'),
	(202270, 120, '2014-02-15 00:59:49.000000', 'temperatura', 990.0000, 'ºC'),
	(202271, 120, '2014-02-15 00:59:50.000000', 'temperatura', 222.0000, 'ºC'),
	(202272, 120, '2014-02-15 00:59:51.000000', 'temperatura', 540.0000, 'ºC'),
	(202273, 120, '2014-02-15 00:59:52.000000', 'temperatura', 837.0000, 'ºC'),
	(202274, 120, '2014-02-15 00:59:53.000000', 'temperatura', 164.0000, 'ºC'),
	(202275, 120, '2014-02-15 00:59:54.000000', 'temperatura', 710.0000, 'ºC'),
	(202276, 120, '2014-02-15 00:59:55.000000', 'temperatura', 660.0000, 'ºC'),
	(202277, 120, '2014-02-15 00:59:56.000000', 'temperatura', 1169.0000, 'ºC'),
	(202278, 120, '2014-02-15 00:59:57.000000', 'temperatura', 264.0000, 'ºC'),
	(202279, 120, '2014-02-15 00:59:58.000000', 'temperatura', 217.0000, 'ºC'),
	(202280, 120, '2014-02-15 00:59:59.000000', 'temperatura', 290.0000, 'ºC'),
	(202281, 120, '2014-02-15 01:00:00.000000', 'temperatura', 801.0000, 'ºC'),
	(202282, 120, '2014-02-15 01:00:01.000000', 'temperatura', 736.0000, 'ºC'),
	(202283, 120, '2014-02-15 01:00:02.000000', 'temperatura', 78.0000, 'ºC'),
	(202284, 120, '2014-02-15 01:00:03.000000', 'temperatura', 581.0000, 'ºC'),
	(202285, 120, '2014-02-15 01:00:04.000000', 'temperatura', 271.0000, 'ºC'),
	(202286, 120, '2014-02-15 01:00:05.000000', 'temperatura', 812.0000, 'ºC'),
	(202287, 120, '2014-02-15 01:00:06.000000', 'temperatura', 847.0000, 'ºC'),
	(202288, 120, '2014-02-15 01:00:07.000000', 'temperatura', 600.0000, 'ºC'),
	(202289, 120, '2014-02-15 01:00:08.000000', 'temperatura', 460.0000, 'ºC'),
	(202290, 120, '2014-02-15 01:00:09.000000', 'temperatura', 500.0000, 'ºC'),
	(202291, 120, '2014-02-15 01:00:10.000000', 'temperatura', 1122.0000, 'ºC'),
	(202292, 120, '2014-02-15 01:00:11.000000', 'temperatura', 510.0000, 'ºC'),
	(202293, 120, '2014-02-15 01:00:12.000000', 'temperatura', 384.0000, 'ºC'),
	(202294, 120, '2014-02-15 01:00:13.000000', 'temperatura', 390.0000, 'ºC'),
	(202295, 120, '2014-02-15 01:00:14.000000', 'temperatura', 798.0000, 'ºC'),
	(202296, 120, '2014-02-15 01:00:15.000000', 'temperatura', 423.0000, 'ºC'),
	(202297, 120, '2014-02-15 01:00:16.000000', 'temperatura', 918.0000, 'ºC'),
	(202298, 120, '2014-02-15 01:00:17.000000', 'temperatura', 924.0000, 'ºC'),
	(202299, 120, '2014-02-15 01:00:18.000000', 'temperatura', 664.0000, 'ºC'),
	(202300, 120, '2014-02-15 01:00:19.000000', 'temperatura', 550.0000, 'ºC'),
	(202301, 120, '2014-02-15 01:00:20.000000', 'temperatura', 759.0000, 'ºC'),
	(202302, 120, '2014-02-15 01:00:21.000000', 'temperatura', 945.0000, 'ºC'),
	(202303, 120, '2014-02-15 01:00:22.000000', 'temperatura', 50.0000, 'ºC'),
	(202304, 120, '2014-02-15 01:00:23.000000', 'temperatura', 1013.0000, 'ºC'),
	(202305, 120, '2014-02-15 01:00:24.000000', 'temperatura', 115.0000, 'ºC'),
	(202306, 120, '2014-02-15 01:00:25.000000', 'temperatura', 1137.0000, 'ºC'),
	(202307, 120, '2014-02-15 01:00:26.000000', 'temperatura', 540.0000, 'ºC'),
	(202308, 120, '2014-02-15 01:00:27.000000', 'temperatura', 488.0000, 'ºC'),
	(202309, 120, '2014-02-15 01:00:28.000000', 'temperatura', 823.0000, 'ºC'),
	(202310, 120, '2014-02-15 01:00:29.000000', 'temperatura', 252.0000, 'ºC'),
	(202311, 120, '2014-02-15 01:00:30.000000', 'temperatura', 1192.0000, 'ºC'),
	(202312, 120, '2014-02-15 01:00:31.000000', 'temperatura', 403.0000, 'ºC'),
	(202313, 120, '2014-02-15 01:00:32.000000', 'temperatura', 840.0000, 'ºC'),
	(202314, 120, '2014-02-15 01:00:33.000000', 'temperatura', 591.0000, 'ºC'),
	(202315, 120, '2014-02-15 01:00:34.000000', 'temperatura', 436.0000, 'ºC'),
	(202316, 120, '2014-02-15 01:00:35.000000', 'temperatura', 405.0000, 'ºC'),
	(202317, 120, '2014-02-15 01:00:36.000000', 'temperatura', 721.0000, 'ºC'),
	(202318, 120, '2014-02-15 01:00:37.000000', 'temperatura', 1188.0000, 'ºC'),
	(202319, 120, '2014-02-15 01:00:38.000000', 'temperatura', 180.0000, 'ºC'),
	(202320, 120, '2014-02-15 01:00:39.000000', 'temperatura', 933.0000, 'ºC'),
	(202321, 120, '2014-02-15 01:00:40.000000', 'temperatura', 529.0000, 'ºC'),
	(202322, 120, '2014-02-15 01:00:41.000000', 'temperatura', 1045.0000, 'ºC'),
	(202323, 120, '2014-02-15 01:00:42.000000', 'temperatura', 40.0000, 'ºC'),
	(202324, 120, '2014-02-15 01:00:43.000000', 'temperatura', 664.0000, 'ºC'),
	(202325, 120, '2014-02-15 01:00:44.000000', 'temperatura', 803.0000, 'ºC'),
	(202326, 120, '2014-02-15 01:00:45.000000', 'temperatura', 821.0000, 'ºC'),
	(202327, 120, '2014-02-15 01:00:46.000000', 'temperatura', 496.0000, 'ºC'),
	(202328, 120, '2014-02-15 01:00:47.000000', 'temperatura', 20.0000, 'ºC'),
	(202329, 120, '2014-02-15 01:00:48.000000', 'temperatura', 1010.0000, 'ºC'),
	(202330, 120, '2014-02-15 01:00:49.000000', 'temperatura', 193.0000, 'ºC'),
	(202331, 120, '2014-02-15 01:00:50.000000', 'temperatura', 335.0000, 'ºC'),
	(202332, 120, '2014-02-15 01:00:51.000000', 'temperatura', 1097.0000, 'ºC'),
	(202333, 120, '2014-02-15 01:00:52.000000', 'temperatura', 879.0000, 'ºC'),
	(202334, 120, '2014-02-15 01:00:53.000000', 'temperatura', 1105.0000, 'ºC'),
	(202335, 120, '2014-02-15 01:00:54.000000', 'temperatura', 488.0000, 'ºC'),
	(202336, 120, '2014-02-15 01:00:55.000000', 'temperatura', 326.0000, 'ºC'),
	(202337, 120, '2014-02-15 01:00:56.000000', 'temperatura', 167.0000, 'ºC'),
	(202338, 120, '2014-02-15 01:00:57.000000', 'temperatura', 1055.0000, 'ºC'),
	(202339, 120, '2014-02-15 01:00:58.000000', 'temperatura', 1178.0000, 'ºC'),
	(202340, 120, '2014-02-15 01:00:59.000000', 'temperatura', 324.0000, 'ºC'),
	(202341, 120, '2014-02-15 01:01:00.000000', 'temperatura', 484.0000, 'ºC'),
	(202342, 120, '2014-02-15 01:01:01.000000', 'temperatura', 252.0000, 'ºC'),
	(202343, 120, '2014-02-15 01:01:02.000000', 'temperatura', 1008.0000, 'ºC'),
	(202344, 120, '2014-02-15 01:01:03.000000', 'temperatura', 682.0000, 'ºC'),
	(202345, 120, '2014-02-15 01:01:04.000000', 'temperatura', 390.0000, 'ºC'),
	(202346, 120, '2014-02-15 01:01:05.000000', 'temperatura', 1103.0000, 'ºC'),
	(202347, 120, '2014-02-15 01:01:06.000000', 'temperatura', 746.0000, 'ºC'),
	(202348, 120, '2014-02-15 01:01:07.000000', 'temperatura', 420.0000, 'ºC'),
	(202349, 120, '2014-02-15 01:01:08.000000', 'temperatura', 1065.0000, 'ºC'),
	(202350, 120, '2014-02-15 01:01:09.000000', 'temperatura', 465.0000, 'ºC'),
	(202351, 120, '2014-02-15 01:01:10.000000', 'temperatura', 330.0000, 'ºC'),
	(202352, 120, '2014-02-15 01:01:11.000000', 'temperatura', 257.0000, 'ºC'),
	(202353, 120, '2014-02-15 01:01:12.000000', 'temperatura', 293.0000, 'ºC'),
	(202354, 120, '2014-02-15 01:01:13.000000', 'temperatura', 696.0000, 'ºC'),
	(202355, 120, '2014-02-15 01:01:14.000000', 'temperatura', 202.0000, 'ºC'),
	(202356, 120, '2014-02-15 01:01:15.000000', 'temperatura', 121.0000, 'ºC'),
	(202357, 120, '2014-02-15 01:01:16.000000', 'temperatura', 1198.0000, 'ºC'),
	(202358, 120, '2014-02-15 01:01:17.000000', 'temperatura', 830.0000, 'ºC'),
	(202359, 120, '2014-02-15 01:01:18.000000', 'temperatura', 558.0000, 'ºC'),
	(202360, 120, '2014-02-15 01:01:19.000000', 'temperatura', 298.0000, 'ºC'),
	(202361, 120, '2014-02-15 01:01:20.000000', 'temperatura', 1018.0000, 'ºC'),
	(202362, 120, '2014-02-15 01:01:21.000000', 'temperatura', 594.0000, 'ºC'),
	(202363, 120, '2014-02-15 01:01:22.000000', 'temperatura', 1119.0000, 'ºC'),
	(202364, 120, '2014-02-15 01:01:23.000000', 'temperatura', 214.0000, 'ºC'),
	(202365, 120, '2014-02-15 01:01:24.000000', 'temperatura', 113.0000, 'ºC'),
	(202366, 120, '2014-02-15 01:01:25.000000', 'temperatura', 1124.0000, 'ºC'),
	(202367, 120, '2014-02-15 01:01:26.000000', 'temperatura', 479.0000, 'ºC'),
	(202368, 120, '2014-02-15 01:01:27.000000', 'temperatura', 224.0000, 'ºC'),
	(202369, 120, '2014-02-15 01:01:28.000000', 'temperatura', 886.0000, 'ºC'),
	(202370, 120, '2014-02-15 01:01:29.000000', 'temperatura', 157.0000, 'ºC'),
	(202371, 120, '2014-02-15 01:01:30.000000', 'temperatura', 527.0000, 'ºC'),
	(202372, 120, '2014-02-15 01:01:31.000000', 'temperatura', 965.0000, 'ºC'),
	(202373, 120, '2014-02-15 01:01:32.000000', 'temperatura', 846.0000, 'ºC'),
	(202374, 120, '2014-02-15 01:01:33.000000', 'temperatura', 134.0000, 'ºC'),
	(202375, 120, '2014-02-15 01:01:34.000000', 'temperatura', 531.0000, 'ºC'),
	(202376, 120, '2014-02-15 01:01:35.000000', 'temperatura', 1055.0000, 'ºC'),
	(202377, 120, '2014-02-15 01:01:36.000000', 'temperatura', 81.0000, 'ºC'),
	(202378, 120, '2014-02-15 01:01:37.000000', 'temperatura', 842.0000, 'ºC'),
	(202379, 120, '2014-02-15 01:01:38.000000', 'temperatura', 367.0000, 'ºC'),
	(202380, 120, '2014-02-15 01:01:39.000000', 'temperatura', 511.0000, 'ºC'),
	(202381, 120, '2014-02-15 01:01:40.000000', 'temperatura', 255.0000, 'ºC'),
	(202382, 120, '2014-02-15 01:01:41.000000', 'temperatura', 942.0000, 'ºC'),
	(202383, 120, '2014-02-15 01:01:42.000000', 'temperatura', 344.0000, 'ºC'),
	(202384, 120, '2014-02-15 01:01:43.000000', 'temperatura', 95.0000, 'ºC'),
	(202385, 120, '2014-02-15 01:01:44.000000', 'temperatura', 644.0000, 'ºC'),
	(202386, 120, '2014-02-15 01:01:45.000000', 'temperatura', 534.0000, 'ºC'),
	(202387, 120, '2014-02-15 01:01:46.000000', 'temperatura', 738.0000, 'ºC'),
	(202388, 120, '2014-02-15 01:01:47.000000', 'temperatura', 888.0000, 'ºC'),
	(202389, 120, '2014-02-15 01:01:48.000000', 'temperatura', 1029.0000, 'ºC'),
	(202390, 120, '2014-02-15 01:01:49.000000', 'temperatura', 80.0000, 'ºC'),
	(202391, 120, '2014-02-15 01:01:50.000000', 'temperatura', 912.0000, 'ºC'),
	(202392, 120, '2014-02-15 01:01:51.000000', 'temperatura', 723.0000, 'ºC'),
	(202393, 120, '2014-02-15 01:01:52.000000', 'temperatura', 879.0000, 'ºC'),
	(202394, 120, '2014-02-15 01:01:53.000000', 'temperatura', 1025.0000, 'ºC'),
	(202395, 120, '2014-02-15 01:01:54.000000', 'temperatura', 88.0000, 'ºC'),
	(202396, 120, '2014-02-15 01:01:55.000000', 'temperatura', 965.0000, 'ºC'),
	(202397, 120, '2014-02-15 01:01:56.000000', 'temperatura', 961.0000, 'ºC'),
	(202398, 120, '2014-02-15 01:01:57.000000', 'temperatura', 710.0000, 'ºC'),
	(202399, 120, '2014-02-15 01:01:58.000000', 'temperatura', 667.0000, 'ºC'),
	(202400, 120, '2014-02-15 01:01:59.000000', 'temperatura', 7.0000, 'ºC'),
	(202401, 120, '2014-02-15 01:02:00.000000', 'temperatura', 436.0000, 'ºC'),
	(202402, 120, '2014-02-15 01:02:01.000000', 'temperatura', 957.0000, 'ºC'),
	(202403, 120, '2014-02-15 01:02:02.000000', 'temperatura', 1077.0000, 'ºC'),
	(202404, 120, '2014-02-15 01:02:03.000000', 'temperatura', 116.0000, 'ºC'),
	(202405, 120, '2014-02-15 01:02:04.000000', 'temperatura', 947.0000, 'ºC'),
	(202406, 120, '2014-02-15 01:02:05.000000', 'temperatura', 791.0000, 'ºC'),
	(202407, 120, '2014-02-15 01:02:06.000000', 'temperatura', 1113.0000, 'ºC'),
	(202408, 120, '2014-02-15 01:02:07.000000', 'temperatura', 793.0000, 'ºC'),
	(202409, 120, '2014-02-15 01:02:08.000000', 'temperatura', 627.0000, 'ºC'),
	(202410, 120, '2014-02-15 01:02:09.000000', 'temperatura', 754.0000, 'ºC'),
	(202411, 120, '2014-02-15 01:02:10.000000', 'temperatura', 691.0000, 'ºC'),
	(202412, 120, '2014-02-15 01:02:11.000000', 'temperatura', 1194.0000, 'ºC'),
	(202413, 120, '2014-02-15 01:02:12.000000', 'temperatura', 295.0000, 'ºC'),
	(202414, 120, '2014-02-15 01:02:13.000000', 'temperatura', 295.0000, 'ºC'),
	(202415, 120, '2014-02-15 01:02:14.000000', 'temperatura', 591.0000, 'ºC'),
	(202416, 120, '2014-02-15 01:02:15.000000', 'temperatura', 871.0000, 'ºC'),
	(202417, 120, '2014-02-15 01:02:16.000000', 'temperatura', 183.0000, 'ºC'),
	(202418, 120, '2014-02-15 01:02:17.000000', 'temperatura', 704.0000, 'ºC'),
	(202419, 120, '2014-02-15 01:02:18.000000', 'temperatura', 568.0000, 'ºC'),
	(202420, 120, '2014-02-15 01:02:19.000000', 'temperatura', 730.0000, 'ºC'),
	(202421, 120, '2014-02-15 01:02:20.000000', 'temperatura', 746.0000, 'ºC'),
	(202422, 120, '2014-02-15 01:02:21.000000', 'temperatura', 340.0000, 'ºC'),
	(202423, 120, '2014-02-15 01:02:22.000000', 'temperatura', 662.0000, 'ºC'),
	(202424, 120, '2014-02-15 01:02:23.000000', 'temperatura', 1089.0000, 'ºC'),
	(202425, 120, '2014-02-15 01:02:24.000000', 'temperatura', 1062.0000, 'ºC'),
	(202426, 120, '2014-02-15 01:02:25.000000', 'temperatura', 841.0000, 'ºC'),
	(202427, 120, '2014-02-15 01:02:26.000000', 'temperatura', 1020.0000, 'ºC'),
	(202428, 120, '2014-02-15 01:02:27.000000', 'temperatura', 178.0000, 'ºC'),
	(202429, 120, '2014-02-15 01:02:28.000000', 'temperatura', 228.0000, 'ºC'),
	(202430, 120, '2014-02-15 01:02:29.000000', 'temperatura', 610.0000, 'ºC'),
	(202431, 120, '2014-02-15 01:02:30.000000', 'temperatura', 1166.0000, 'ºC'),
	(202432, 120, '2014-02-15 01:02:31.000000', 'temperatura', 399.0000, 'ºC'),
	(202433, 120, '2014-02-15 01:02:32.000000', 'temperatura', 896.0000, 'ºC'),
	(202434, 120, '2014-02-15 01:02:33.000000', 'temperatura', 886.0000, 'ºC'),
	(202435, 120, '2014-02-15 01:02:34.000000', 'temperatura', 543.0000, 'ºC'),
	(202436, 120, '2014-02-15 01:02:35.000000', 'temperatura', 57.0000, 'ºC'),
	(202437, 120, '2014-02-15 01:02:36.000000', 'temperatura', 1057.0000, 'ºC'),
	(202438, 120, '2014-02-15 01:02:37.000000', 'temperatura', 315.0000, 'ºC'),
	(202439, 120, '2014-02-15 01:02:38.000000', 'temperatura', 802.0000, 'ºC'),
	(202440, 120, '2014-02-15 01:02:39.000000', 'temperatura', 666.0000, 'ºC'),
	(202441, 120, '2014-02-15 01:02:40.000000', 'temperatura', 925.0000, 'ºC'),
	(202442, 120, '2014-02-15 01:02:41.000000', 'temperatura', 226.0000, 'ºC'),
	(202443, 120, '2014-02-15 01:02:42.000000', 'temperatura', 756.0000, 'ºC'),
	(202444, 120, '2014-02-15 01:02:43.000000', 'temperatura', 704.0000, 'ºC'),
	(202445, 120, '2014-02-15 01:02:44.000000', 'temperatura', 52.0000, 'ºC'),
	(202446, 120, '2014-02-15 01:02:45.000000', 'temperatura', 550.0000, 'ºC'),
	(202447, 120, '2014-02-15 01:02:46.000000', 'temperatura', 194.0000, 'ºC'),
	(202448, 120, '2014-02-15 01:02:47.000000', 'temperatura', 522.0000, 'ºC'),
	(202449, 120, '2014-02-15 01:02:48.000000', 'temperatura', 826.0000, 'ºC'),
	(202450, 120, '2014-02-15 01:02:49.000000', 'temperatura', 164.0000, 'ºC'),
	(202451, 120, '2014-02-15 01:02:50.000000', 'temperatura', 744.0000, 'ºC'),
	(202452, 120, '2014-02-15 01:02:51.000000', 'temperatura', 830.0000, 'ºC'),
	(202453, 120, '2014-02-15 01:02:52.000000', 'temperatura', 716.0000, 'ºC'),
	(202454, 120, '2014-02-15 01:02:53.000000', 'temperatura', 1090.0000, 'ºC'),
	(202455, 120, '2014-02-15 01:02:54.000000', 'temperatura', 902.0000, 'ºC'),
	(202456, 120, '2014-02-15 01:02:55.000000', 'temperatura', 40.0000, 'ºC'),
	(202457, 120, '2014-02-15 01:02:56.000000', 'temperatura', 1096.0000, 'ºC'),
	(202458, 120, '2014-02-15 01:02:57.000000', 'temperatura', 558.0000, 'ºC'),
	(202459, 120, '2014-02-15 01:02:58.000000', 'temperatura', 705.0000, 'ºC'),
	(202460, 120, '2014-02-15 01:02:59.000000', 'temperatura', 652.0000, 'ºC'),
	(202461, 120, '2014-02-15 01:03:00.000000', 'temperatura', 1145.0000, 'ºC'),
	(202462, 120, '2014-02-15 01:03:01.000000', 'temperatura', 167.0000, 'ºC'),
	(202463, 120, '2014-02-15 01:03:02.000000', 'temperatura', 1003.0000, 'ºC'),
	(202464, 120, '2014-02-15 01:03:03.000000', 'temperatura', 913.0000, 'ºC'),
	(202465, 120, '2014-02-15 01:03:04.000000', 'temperatura', 356.0000, 'ºC'),
	(202466, 120, '2014-02-15 01:03:05.000000', 'temperatura', 241.0000, 'ºC'),
	(202467, 120, '2014-02-15 01:03:06.000000', 'temperatura', 140.0000, 'ºC'),
	(202468, 120, '2014-02-15 01:03:07.000000', 'temperatura', 1178.0000, 'ºC'),
	(202469, 120, '2014-02-15 01:03:08.000000', 'temperatura', 670.0000, 'ºC'),
	(202470, 120, '2014-02-15 01:03:09.000000', 'temperatura', 1017.0000, 'ºC'),
	(202471, 120, '2014-02-15 01:03:10.000000', 'temperatura', 675.0000, 'ºC'),
	(202472, 120, '2014-02-15 01:03:11.000000', 'temperatura', 323.0000, 'ºC'),
	(202473, 120, '2014-02-15 01:03:12.000000', 'temperatura', 793.0000, 'ºC'),
	(202474, 120, '2014-02-15 01:03:13.000000', 'temperatura', 596.0000, 'ºC'),
	(202475, 120, '2014-02-15 01:03:14.000000', 'temperatura', 599.0000, 'ºC'),
	(202476, 120, '2014-02-15 01:03:15.000000', 'temperatura', 11.0000, 'ºC'),
	(202477, 120, '2014-02-15 01:03:16.000000', 'temperatura', 655.0000, 'ºC'),
	(202478, 120, '2014-02-15 01:03:17.000000', 'temperatura', 846.0000, 'ºC'),
	(202479, 120, '2014-02-15 01:03:18.000000', 'temperatura', 1062.0000, 'ºC'),
	(202480, 120, '2014-02-15 01:03:19.000000', 'temperatura', 376.0000, 'ºC'),
	(202481, 120, '2014-02-15 01:03:20.000000', 'temperatura', 1093.0000, 'ºC'),
	(202482, 120, '2014-02-15 01:03:21.000000', 'temperatura', 736.0000, 'ºC'),
	(202483, 120, '2014-02-15 01:03:22.000000', 'temperatura', 402.0000, 'ºC'),
	(202484, 120, '2014-02-15 01:03:23.000000', 'temperatura', 1003.0000, 'ºC'),
	(202485, 120, '2014-02-15 01:03:24.000000', 'temperatura', 211.0000, 'ºC'),
	(202486, 120, '2014-02-15 01:03:25.000000', 'temperatura', 445.0000, 'ºC'),
	(202487, 120, '2014-02-15 01:03:26.000000', 'temperatura', 393.0000, 'ºC'),
	(202488, 120, '2014-02-15 01:03:27.000000', 'temperatura', 632.0000, 'ºC'),
	(202489, 120, '2014-02-15 01:03:28.000000', 'temperatura', 780.0000, 'ºC'),
	(202490, 120, '2014-02-15 01:03:29.000000', 'temperatura', 803.0000, 'ºC'),
	(202491, 120, '2014-02-15 01:03:30.000000', 'temperatura', 477.0000, 'ºC'),
	(202492, 120, '2014-02-15 01:03:31.000000', 'temperatura', 1174.0000, 'ºC'),
	(202493, 120, '2014-02-15 01:03:32.000000', 'temperatura', 842.0000, 'ºC'),
	(202494, 120, '2014-02-15 01:03:33.000000', 'temperatura', 690.0000, 'ºC'),
	(202495, 120, '2014-02-15 01:03:34.000000', 'temperatura', 921.0000, 'ºC'),
	(202496, 120, '2014-02-15 01:03:35.000000', 'temperatura', 139.0000, 'ºC'),
	(202497, 120, '2014-02-15 01:03:36.000000', 'temperatura', 330.0000, 'ºC'),
	(202498, 120, '2014-02-15 01:03:37.000000', 'temperatura', 34.0000, 'ºC'),
	(202499, 120, '2014-02-15 01:03:38.000000', 'temperatura', 379.0000, 'ºC'),
	(202500, 120, '2014-02-15 01:03:39.000000', 'temperatura', 596.0000, 'ºC'),
	(202501, 120, '2014-02-15 01:03:40.000000', 'temperatura', 642.0000, 'ºC'),
	(202502, 120, '2014-02-15 01:03:41.000000', 'temperatura', 224.0000, 'ºC'),
	(202503, 120, '2014-02-15 01:03:42.000000', 'temperatura', 394.0000, 'ºC'),
	(202504, 120, '2014-02-15 01:03:43.000000', 'temperatura', 98.0000, 'ºC'),
	(202505, 120, '2014-02-15 01:03:44.000000', 'temperatura', 509.0000, 'ºC'),
	(202506, 120, '2014-02-15 01:03:45.000000', 'temperatura', 1052.0000, 'ºC'),
	(202507, 120, '2014-02-15 01:03:46.000000', 'temperatura', 133.0000, 'ºC'),
	(202508, 120, '2014-02-15 01:03:47.000000', 'temperatura', 1108.0000, 'ºC'),
	(202509, 120, '2014-02-15 01:03:48.000000', 'temperatura', 343.0000, 'ºC'),
	(202510, 120, '2014-02-15 01:03:49.000000', 'temperatura', 790.0000, 'ºC'),
	(202511, 120, '2014-02-15 01:03:50.000000', 'temperatura', 521.0000, 'ºC'),
	(202512, 120, '2014-02-15 01:03:51.000000', 'temperatura', 238.0000, 'ºC'),
	(202513, 120, '2014-02-15 01:03:52.000000', 'temperatura', 827.0000, 'ºC'),
	(202514, 120, '2014-02-15 01:03:53.000000', 'temperatura', 1021.0000, 'ºC'),
	(202515, 120, '2014-02-15 01:03:54.000000', 'temperatura', 225.0000, 'ºC'),
	(202516, 120, '2014-02-15 01:03:55.000000', 'temperatura', 461.0000, 'ºC'),
	(202517, 120, '2014-02-15 01:03:56.000000', 'temperatura', 430.0000, 'ºC'),
	(202518, 120, '2014-02-15 01:03:57.000000', 'temperatura', 770.0000, 'ºC'),
	(202519, 120, '2014-02-15 01:03:58.000000', 'temperatura', 159.0000, 'ºC'),
	(202520, 120, '2014-02-15 01:03:59.000000', 'temperatura', 885.0000, 'ºC'),
	(202521, 120, '2014-02-15 01:04:00.000000', 'temperatura', 349.0000, 'ºC'),
	(202522, 120, '2014-02-15 01:04:01.000000', 'temperatura', 290.0000, 'ºC'),
	(202523, 120, '2014-02-15 01:04:02.000000', 'temperatura', 405.0000, 'ºC'),
	(202524, 120, '2014-02-15 01:04:03.000000', 'temperatura', 1157.0000, 'ºC'),
	(202525, 120, '2014-02-15 01:04:04.000000', 'temperatura', 967.0000, 'ºC'),
	(202526, 120, '2014-02-15 01:04:05.000000', 'temperatura', 167.0000, 'ºC'),
	(202527, 120, '2014-02-15 01:04:06.000000', 'temperatura', 334.0000, 'ºC'),
	(202528, 120, '2014-02-15 01:04:07.000000', 'temperatura', 1171.0000, 'ºC'),
	(202529, 120, '2014-02-15 01:04:08.000000', 'temperatura', 52.0000, 'ºC'),
	(202530, 120, '2014-02-15 01:04:09.000000', 'temperatura', 349.0000, 'ºC'),
	(202531, 120, '2014-02-15 01:04:10.000000', 'temperatura', 387.0000, 'ºC'),
	(202532, 120, '2014-02-15 01:04:11.000000', 'temperatura', 891.0000, 'ºC'),
	(202533, 120, '2014-02-15 01:04:12.000000', 'temperatura', 896.0000, 'ºC'),
	(202534, 120, '2014-02-15 01:04:13.000000', 'temperatura', 604.0000, 'ºC'),
	(202535, 120, '2014-02-15 01:04:14.000000', 'temperatura', 332.0000, 'ºC'),
	(202536, 120, '2014-02-15 01:04:15.000000', 'temperatura', 1051.0000, 'ºC'),
	(202537, 120, '2014-02-15 01:04:16.000000', 'temperatura', 657.0000, 'ºC'),
	(202538, 120, '2014-02-15 01:04:17.000000', 'temperatura', 132.0000, 'ºC'),
	(202539, 120, '2014-02-15 01:04:18.000000', 'temperatura', 1091.0000, 'ºC'),
	(202540, 120, '2014-02-15 01:04:19.000000', 'temperatura', 258.0000, 'ºC'),
	(202541, 120, '2014-02-15 01:04:20.000000', 'temperatura', 418.0000, 'ºC'),
	(202542, 120, '2014-02-15 01:04:21.000000', 'temperatura', 116.0000, 'ºC'),
	(202543, 120, '2014-02-15 01:04:22.000000', 'temperatura', 525.0000, 'ºC'),
	(202544, 120, '2014-02-15 01:04:23.000000', 'temperatura', 1079.0000, 'ºC'),
	(202545, 120, '2014-02-15 01:04:24.000000', 'temperatura', 222.0000, 'ºC'),
	(202546, 120, '2014-02-15 01:04:25.000000', 'temperatura', 271.0000, 'ºC'),
	(202547, 120, '2014-02-15 01:04:26.000000', 'temperatura', 690.0000, 'ºC'),
	(202548, 120, '2014-02-15 01:04:27.000000', 'temperatura', 236.0000, 'ºC'),
	(202549, 120, '2014-02-15 01:04:28.000000', 'temperatura', 311.0000, 'ºC'),
	(202550, 120, '2014-02-15 01:04:29.000000', 'temperatura', 849.0000, 'ºC'),
	(202551, 120, '2014-02-15 01:04:30.000000', 'temperatura', 911.0000, 'ºC'),
	(202552, 120, '2014-02-15 01:04:31.000000', 'temperatura', 809.0000, 'ºC'),
	(202553, 120, '2014-02-15 01:04:32.000000', 'temperatura', 114.0000, 'ºC'),
	(202554, 120, '2014-02-15 01:04:33.000000', 'temperatura', 541.0000, 'ºC'),
	(202555, 120, '2014-02-15 01:04:34.000000', 'temperatura', 1162.0000, 'ºC'),
	(202556, 120, '2014-02-15 01:04:35.000000', 'temperatura', 591.0000, 'ºC'),
	(202557, 120, '2014-02-15 01:04:36.000000', 'temperatura', 669.0000, 'ºC'),
	(202558, 120, '2014-02-15 01:04:37.000000', 'temperatura', 373.0000, 'ºC'),
	(202559, 120, '2014-02-15 01:04:38.000000', 'temperatura', 1059.0000, 'ºC'),
	(202560, 120, '2014-02-15 01:04:39.000000', 'temperatura', 576.0000, 'ºC'),
	(202561, 120, '2014-02-15 01:04:40.000000', 'temperatura', 902.0000, 'ºC'),
	(202562, 120, '2014-02-15 01:04:41.000000', 'temperatura', 382.0000, 'ºC'),
	(202563, 120, '2014-02-15 01:04:42.000000', 'temperatura', 406.0000, 'ºC'),
	(202564, 120, '2014-02-15 01:04:43.000000', 'temperatura', 885.0000, 'ºC'),
	(202565, 120, '2014-02-15 01:04:44.000000', 'temperatura', 808.0000, 'ºC'),
	(202566, 120, '2014-02-15 01:04:45.000000', 'temperatura', 186.0000, 'ºC'),
	(202567, 120, '2014-02-15 01:04:46.000000', 'temperatura', 904.0000, 'ºC'),
	(202568, 120, '2014-02-15 01:04:47.000000', 'temperatura', 363.0000, 'ºC'),
	(202569, 120, '2014-02-15 01:04:48.000000', 'temperatura', 303.0000, 'ºC'),
	(202570, 120, '2014-02-15 01:04:49.000000', 'temperatura', 429.0000, 'ºC'),
	(202571, 120, '2014-02-15 01:04:50.000000', 'temperatura', 34.0000, 'ºC'),
	(202572, 120, '2014-02-15 01:04:51.000000', 'temperatura', 84.0000, 'ºC'),
	(202573, 120, '2014-02-15 01:04:52.000000', 'temperatura', 319.0000, 'ºC'),
	(202574, 120, '2014-02-15 01:04:53.000000', 'temperatura', 143.0000, 'ºC'),
	(202575, 120, '2014-02-15 01:04:54.000000', 'temperatura', 958.0000, 'ºC'),
	(202576, 120, '2014-02-15 01:04:55.000000', 'temperatura', 761.0000, 'ºC'),
	(202577, 120, '2014-02-15 01:04:56.000000', 'temperatura', 933.0000, 'ºC'),
	(202578, 120, '2014-02-15 01:04:57.000000', 'temperatura', 1180.0000, 'ºC'),
	(202579, 120, '2014-02-15 01:04:58.000000', 'temperatura', 702.0000, 'ºC'),
	(202580, 120, '2014-02-15 01:04:59.000000', 'temperatura', 1173.0000, 'ºC'),
	(202581, 120, '2014-02-15 01:05:00.000000', 'temperatura', 158.0000, 'ºC'),
	(202582, 120, '2014-02-15 01:05:01.000000', 'temperatura', 872.0000, 'ºC'),
	(202583, 120, '2014-02-15 01:05:02.000000', 'temperatura', 285.0000, 'ºC'),
	(202584, 120, '2014-02-15 01:05:03.000000', 'temperatura', 10.0000, 'ºC'),
	(202585, 120, '2014-02-15 01:05:04.000000', 'temperatura', 397.0000, 'ºC'),
	(202586, 120, '2014-02-15 01:05:05.000000', 'temperatura', 756.0000, 'ºC'),
	(202587, 120, '2014-02-15 01:05:06.000000', 'temperatura', 187.0000, 'ºC'),
	(202588, 120, '2014-02-15 01:05:07.000000', 'temperatura', 1067.0000, 'ºC'),
	(202589, 120, '2014-02-15 01:05:08.000000', 'temperatura', 1175.0000, 'ºC'),
	(202590, 120, '2014-02-15 01:05:09.000000', 'temperatura', 273.0000, 'ºC'),
	(202591, 120, '2014-02-15 01:05:10.000000', 'temperatura', 243.0000, 'ºC'),
	(202592, 120, '2014-02-15 01:05:11.000000', 'temperatura', 395.0000, 'ºC'),
	(202593, 120, '2014-02-15 01:05:12.000000', 'temperatura', 46.0000, 'ºC'),
	(202594, 120, '2014-02-15 01:05:13.000000', 'temperatura', 245.0000, 'ºC'),
	(202595, 120, '2014-02-15 01:05:14.000000', 'temperatura', 1089.0000, 'ºC'),
	(202596, 120, '2014-02-15 01:05:15.000000', 'temperatura', 1111.0000, 'ºC'),
	(202597, 120, '2014-02-15 01:05:16.000000', 'temperatura', 1090.0000, 'ºC'),
	(202598, 120, '2014-02-15 01:05:17.000000', 'temperatura', 916.0000, 'ºC'),
	(202599, 120, '2014-02-15 01:05:18.000000', 'temperatura', 109.0000, 'ºC'),
	(202600, 120, '2014-02-15 01:05:19.000000', 'temperatura', 201.0000, 'ºC'),
	(202601, 120, '2014-02-15 01:05:20.000000', 'temperatura', 675.0000, 'ºC'),
	(202602, 120, '2014-02-15 01:05:21.000000', 'temperatura', 374.0000, 'ºC'),
	(202603, 120, '2014-02-15 01:05:22.000000', 'temperatura', 1045.0000, 'ºC'),
	(202604, 120, '2014-02-15 01:05:23.000000', 'temperatura', 503.0000, 'ºC'),
	(202605, 120, '2014-02-15 01:05:24.000000', 'temperatura', 579.0000, 'ºC'),
	(202606, 120, '2014-02-15 01:05:25.000000', 'temperatura', 189.0000, 'ºC'),
	(202607, 120, '2014-02-15 01:05:26.000000', 'temperatura', 406.0000, 'ºC'),
	(202608, 120, '2014-02-15 01:05:27.000000', 'temperatura', 266.0000, 'ºC'),
	(202609, 120, '2014-02-15 01:05:28.000000', 'temperatura', 111.0000, 'ºC'),
	(202610, 120, '2014-02-15 01:05:29.000000', 'temperatura', 957.0000, 'ºC'),
	(202611, 120, '2014-02-15 01:05:30.000000', 'temperatura', 854.0000, 'ºC'),
	(202612, 120, '2014-02-15 01:05:31.000000', 'temperatura', 201.0000, 'ºC'),
	(202613, 120, '2014-02-15 01:05:32.000000', 'temperatura', 842.0000, 'ºC'),
	(202614, 120, '2014-02-15 01:05:33.000000', 'temperatura', 6.0000, 'ºC'),
	(202615, 120, '2014-02-15 01:05:34.000000', 'temperatura', 1107.0000, 'ºC'),
	(202616, 120, '2014-02-15 01:05:35.000000', 'temperatura', 715.0000, 'ºC'),
	(202617, 120, '2014-02-15 01:05:36.000000', 'temperatura', 253.0000, 'ºC'),
	(202618, 120, '2014-02-15 01:05:37.000000', 'temperatura', 324.0000, 'ºC'),
	(202619, 120, '2014-02-15 01:05:38.000000', 'temperatura', 862.0000, 'ºC'),
	(202620, 120, '2014-02-15 01:05:39.000000', 'temperatura', 937.0000, 'ºC'),
	(202621, 120, '2014-02-15 01:05:40.000000', 'temperatura', 902.0000, 'ºC'),
	(202622, 120, '2014-02-15 01:05:41.000000', 'temperatura', 497.0000, 'ºC'),
	(202623, 120, '2014-02-15 01:05:42.000000', 'temperatura', 981.0000, 'ºC'),
	(202624, 120, '2014-02-15 01:05:43.000000', 'temperatura', 1013.0000, 'ºC'),
	(202625, 120, '2014-02-15 01:05:44.000000', 'temperatura', 923.0000, 'ºC'),
	(202626, 120, '2014-02-15 01:05:45.000000', 'temperatura', 378.0000, 'ºC'),
	(202627, 120, '2014-02-15 01:05:46.000000', 'temperatura', 318.0000, 'ºC'),
	(202628, 120, '2014-02-15 01:05:47.000000', 'temperatura', 460.0000, 'ºC'),
	(202629, 120, '2014-02-15 01:05:48.000000', 'temperatura', 146.0000, 'ºC'),
	(202630, 120, '2014-02-15 01:05:49.000000', 'temperatura', 551.0000, 'ºC'),
	(202631, 120, '2014-02-15 01:05:50.000000', 'temperatura', 1118.0000, 'ºC'),
	(202632, 120, '2014-02-15 01:05:51.000000', 'temperatura', 337.0000, 'ºC'),
	(202633, 120, '2014-02-15 01:05:52.000000', 'temperatura', 732.0000, 'ºC'),
	(202634, 120, '2014-02-15 01:05:53.000000', 'temperatura', 250.0000, 'ºC'),
	(202635, 120, '2014-02-15 01:05:54.000000', 'temperatura', 255.0000, 'ºC'),
	(202636, 120, '2014-02-15 01:05:55.000000', 'temperatura', 526.0000, 'ºC'),
	(202637, 120, '2014-02-15 01:05:56.000000', 'temperatura', 663.0000, 'ºC'),
	(202638, 120, '2014-02-15 01:05:57.000000', 'temperatura', 539.0000, 'ºC'),
	(202639, 120, '2014-02-15 01:05:58.000000', 'temperatura', 707.0000, 'ºC'),
	(202640, 120, '2014-02-15 01:05:59.000000', 'temperatura', 716.0000, 'ºC'),
	(202641, 120, '2014-02-15 01:06:00.000000', 'temperatura', 260.0000, 'ºC'),
	(202642, 120, '2014-02-15 01:06:01.000000', 'temperatura', 354.0000, 'ºC'),
	(202643, 120, '2014-02-15 01:06:02.000000', 'temperatura', 990.0000, 'ºC'),
	(202644, 120, '2014-02-15 01:06:03.000000', 'temperatura', 287.0000, 'ºC'),
	(202645, 120, '2014-02-15 01:06:04.000000', 'temperatura', 866.0000, 'ºC'),
	(202646, 120, '2014-02-15 01:06:05.000000', 'temperatura', 1068.0000, 'ºC'),
	(202647, 120, '2014-02-15 01:06:06.000000', 'temperatura', 343.0000, 'ºC'),
	(202648, 120, '2014-02-15 01:06:07.000000', 'temperatura', 914.0000, 'ºC'),
	(202649, 120, '2014-02-15 01:06:08.000000', 'temperatura', 1138.0000, 'ºC'),
	(202650, 120, '2014-02-15 01:06:09.000000', 'temperatura', 550.0000, 'ºC'),
	(202651, 120, '2014-02-15 01:06:10.000000', 'temperatura', 537.0000, 'ºC'),
	(202652, 120, '2014-02-15 01:06:11.000000', 'temperatura', 1035.0000, 'ºC'),
	(202653, 120, '2014-02-15 01:06:12.000000', 'temperatura', 1163.0000, 'ºC'),
	(202654, 120, '2014-02-15 01:06:13.000000', 'temperatura', 310.0000, 'ºC'),
	(202655, 120, '2014-02-15 01:06:14.000000', 'temperatura', 462.0000, 'ºC'),
	(202656, 120, '2014-02-15 01:06:15.000000', 'temperatura', 181.0000, 'ºC'),
	(202657, 120, '2014-02-15 01:06:16.000000', 'temperatura', 720.0000, 'ºC'),
	(202658, 120, '2014-02-15 01:06:17.000000', 'temperatura', 655.0000, 'ºC'),
	(202659, 120, '2014-02-15 01:06:18.000000', 'temperatura', 1119.0000, 'ºC'),
	(202660, 120, '2014-02-15 01:06:19.000000', 'temperatura', 29.0000, 'ºC'),
	(202661, 120, '2014-02-15 01:06:20.000000', 'temperatura', 387.0000, 'ºC'),
	(202662, 120, '2014-02-15 01:06:21.000000', 'temperatura', 651.0000, 'ºC'),
	(202663, 120, '2014-02-15 01:06:22.000000', 'temperatura', 893.0000, 'ºC'),
	(202664, 120, '2014-02-15 01:06:23.000000', 'temperatura', 114.0000, 'ºC'),
	(202665, 120, '2014-02-15 01:06:24.000000', 'temperatura', 290.0000, 'ºC'),
	(202666, 120, '2014-02-15 01:06:25.000000', 'temperatura', 1108.0000, 'ºC'),
	(202667, 120, '2014-02-15 01:06:26.000000', 'temperatura', 1071.0000, 'ºC'),
	(202668, 120, '2014-02-15 01:06:27.000000', 'temperatura', 832.0000, 'ºC'),
	(202669, 120, '2014-02-15 01:06:28.000000', 'temperatura', 949.0000, 'ºC'),
	(202670, 120, '2014-02-15 01:06:29.000000', 'temperatura', 1048.0000, 'ºC'),
	(202671, 120, '2014-02-15 01:06:30.000000', 'temperatura', 1194.0000, 'ºC'),
	(202672, 120, '2014-02-15 01:06:31.000000', 'temperatura', 425.0000, 'ºC'),
	(202673, 120, '2014-02-15 01:06:32.000000', 'temperatura', 943.0000, 'ºC'),
	(202674, 120, '2014-02-15 01:06:33.000000', 'temperatura', 1042.0000, 'ºC'),
	(202675, 120, '2014-02-15 01:06:34.000000', 'temperatura', 1181.0000, 'ºC'),
	(202676, 120, '2014-02-15 01:06:35.000000', 'temperatura', 380.0000, 'ºC'),
	(202677, 120, '2014-02-15 01:06:36.000000', 'temperatura', 759.0000, 'ºC'),
	(202678, 120, '2014-02-15 01:06:37.000000', 'temperatura', 253.0000, 'ºC'),
	(202679, 120, '2014-02-15 01:06:38.000000', 'temperatura', 188.0000, 'ºC'),
	(202680, 120, '2014-02-15 01:06:39.000000', 'temperatura', 183.0000, 'ºC'),
	(202681, 120, '2014-02-15 01:06:40.000000', 'temperatura', 350.0000, 'ºC'),
	(202682, 120, '2014-02-15 01:06:41.000000', 'temperatura', 2.0000, 'ºC'),
	(202683, 120, '2014-02-15 01:06:42.000000', 'temperatura', 159.0000, 'ºC'),
	(202684, 120, '2014-02-15 01:06:43.000000', 'temperatura', 793.0000, 'ºC'),
	(202685, 120, '2014-02-15 01:06:44.000000', 'temperatura', 1086.0000, 'ºC'),
	(202686, 120, '2014-02-15 01:06:45.000000', 'temperatura', 652.0000, 'ºC'),
	(202687, 120, '2014-02-15 01:06:46.000000', 'temperatura', 4.0000, 'ºC'),
	(202688, 120, '2014-02-15 01:06:47.000000', 'temperatura', 464.0000, 'ºC'),
	(202689, 120, '2014-02-15 01:06:48.000000', 'temperatura', 1110.0000, 'ºC'),
	(202690, 120, '2014-02-15 01:06:49.000000', 'temperatura', 557.0000, 'ºC'),
	(202691, 120, '2014-02-15 01:06:50.000000', 'temperatura', 657.0000, 'ºC'),
	(202692, 120, '2014-02-15 01:06:51.000000', 'temperatura', 415.0000, 'ºC'),
	(202693, 120, '2014-02-15 01:06:52.000000', 'temperatura', 104.0000, 'ºC'),
	(202694, 120, '2014-02-15 01:06:53.000000', 'temperatura', 475.0000, 'ºC'),
	(202695, 120, '2014-02-15 01:06:54.000000', 'temperatura', 864.0000, 'ºC'),
	(202696, 120, '2014-02-15 01:06:55.000000', 'temperatura', 495.0000, 'ºC'),
	(202697, 120, '2014-02-15 01:06:56.000000', 'temperatura', 1083.0000, 'ºC'),
	(202698, 120, '2014-02-15 01:06:57.000000', 'temperatura', 331.0000, 'ºC'),
	(202699, 120, '2014-02-15 01:06:58.000000', 'temperatura', 808.0000, 'ºC'),
	(202700, 120, '2014-02-15 01:06:59.000000', 'temperatura', 646.0000, 'ºC'),
	(202701, 120, '2014-02-15 01:07:00.000000', 'temperatura', 805.0000, 'ºC'),
	(202702, 120, '2014-02-15 01:07:01.000000', 'temperatura', 890.0000, 'ºC'),
	(202703, 120, '2014-02-15 01:07:02.000000', 'temperatura', 833.0000, 'ºC'),
	(202704, 120, '2014-02-15 01:07:03.000000', 'temperatura', 296.0000, 'ºC'),
	(202705, 120, '2014-02-15 01:07:04.000000', 'temperatura', 183.0000, 'ºC'),
	(202706, 120, '2014-02-15 01:07:05.000000', 'temperatura', 27.0000, 'ºC'),
	(202707, 120, '2014-02-15 01:07:06.000000', 'temperatura', 786.0000, 'ºC'),
	(202708, 120, '2014-02-15 01:07:07.000000', 'temperatura', 248.0000, 'ºC'),
	(202709, 120, '2014-02-15 01:07:08.000000', 'temperatura', 82.0000, 'ºC'),
	(202710, 120, '2014-02-15 01:07:09.000000', 'temperatura', 870.0000, 'ºC'),
	(202711, 120, '2014-02-15 01:07:10.000000', 'temperatura', 501.0000, 'ºC'),
	(202712, 120, '2014-02-15 01:07:11.000000', 'temperatura', 1098.0000, 'ºC'),
	(202713, 120, '2014-02-15 01:07:12.000000', 'temperatura', 387.0000, 'ºC'),
	(202714, 120, '2014-02-15 01:07:13.000000', 'temperatura', 1042.0000, 'ºC'),
	(202715, 120, '2014-02-15 01:07:14.000000', 'temperatura', 447.0000, 'ºC'),
	(202716, 120, '2014-02-15 01:07:15.000000', 'temperatura', 311.0000, 'ºC'),
	(202717, 120, '2014-02-15 01:07:16.000000', 'temperatura', 215.0000, 'ºC'),
	(202718, 120, '2014-02-15 01:07:17.000000', 'temperatura', 143.0000, 'ºC'),
	(202719, 120, '2014-02-15 01:07:18.000000', 'temperatura', 69.0000, 'ºC'),
	(202720, 120, '2014-02-15 01:07:19.000000', 'temperatura', 1117.0000, 'ºC'),
	(202721, 120, '2014-02-15 01:07:20.000000', 'temperatura', 579.0000, 'ºC'),
	(202722, 120, '2014-02-15 01:07:21.000000', 'temperatura', 744.0000, 'ºC'),
	(202723, 120, '2014-02-15 01:07:22.000000', 'temperatura', 785.0000, 'ºC'),
	(202724, 120, '2014-02-15 01:07:23.000000', 'temperatura', 494.0000, 'ºC'),
	(202725, 120, '2014-02-15 01:07:24.000000', 'temperatura', 116.0000, 'ºC'),
	(202726, 120, '2014-02-15 01:07:25.000000', 'temperatura', 297.0000, 'ºC'),
	(202727, 120, '2014-02-15 01:07:26.000000', 'temperatura', 1137.0000, 'ºC'),
	(202728, 120, '2014-02-15 01:07:27.000000', 'temperatura', 1193.0000, 'ºC'),
	(202729, 120, '2014-02-15 01:07:28.000000', 'temperatura', 157.0000, 'ºC'),
	(202730, 120, '2014-02-15 01:07:29.000000', 'temperatura', 806.0000, 'ºC'),
	(202731, 120, '2014-02-15 01:07:30.000000', 'temperatura', 1159.0000, 'ºC'),
	(202732, 120, '2014-02-15 01:07:31.000000', 'temperatura', 976.0000, 'ºC'),
	(202733, 120, '2014-02-15 01:07:32.000000', 'temperatura', 206.0000, 'ºC'),
	(202734, 120, '2014-02-15 01:07:33.000000', 'temperatura', 504.0000, 'ºC'),
	(202735, 120, '2014-02-15 01:07:34.000000', 'temperatura', 699.0000, 'ºC'),
	(202736, 120, '2014-02-15 01:07:35.000000', 'temperatura', 785.0000, 'ºC'),
	(202737, 120, '2014-02-15 01:07:36.000000', 'temperatura', 628.0000, 'ºC'),
	(202738, 120, '2014-02-15 01:07:37.000000', 'temperatura', 784.0000, 'ºC'),
	(202739, 120, '2014-02-15 01:07:38.000000', 'temperatura', 838.0000, 'ºC'),
	(202740, 120, '2014-02-15 01:07:39.000000', 'temperatura', 638.0000, 'ºC'),
	(202741, 120, '2014-02-15 01:07:40.000000', 'temperatura', 675.0000, 'ºC'),
	(202742, 120, '2014-02-15 01:07:41.000000', 'temperatura', 262.0000, 'ºC'),
	(202743, 120, '2014-02-15 01:07:42.000000', 'temperatura', 488.0000, 'ºC'),
	(202744, 120, '2014-02-15 01:07:43.000000', 'temperatura', 452.0000, 'ºC'),
	(202745, 120, '2014-02-15 01:07:44.000000', 'temperatura', 796.0000, 'ºC'),
	(202746, 120, '2014-02-15 01:07:45.000000', 'temperatura', 226.0000, 'ºC'),
	(202747, 120, '2014-02-15 01:07:46.000000', 'temperatura', 1141.0000, 'ºC'),
	(202748, 120, '2014-02-15 01:07:47.000000', 'temperatura', 228.0000, 'ºC'),
	(202749, 120, '2014-02-15 01:07:48.000000', 'temperatura', 119.0000, 'ºC'),
	(202750, 120, '2014-02-15 01:07:49.000000', 'temperatura', 1112.0000, 'ºC'),
	(202751, 120, '2014-02-15 01:07:50.000000', 'temperatura', 403.0000, 'ºC'),
	(202752, 120, '2014-02-15 01:07:51.000000', 'temperatura', 1079.0000, 'ºC'),
	(202753, 120, '2014-02-15 01:07:52.000000', 'temperatura', 587.0000, 'ºC'),
	(202754, 120, '2014-02-15 01:07:53.000000', 'temperatura', 897.0000, 'ºC'),
	(202755, 120, '2014-02-15 01:07:54.000000', 'temperatura', 327.0000, 'ºC'),
	(202756, 120, '2014-02-15 01:07:55.000000', 'temperatura', 144.0000, 'ºC'),
	(202757, 120, '2014-02-15 01:07:56.000000', 'temperatura', 939.0000, 'ºC'),
	(202758, 120, '2014-02-15 01:07:57.000000', 'temperatura', 665.0000, 'ºC'),
	(202759, 120, '2014-02-15 01:07:58.000000', 'temperatura', 506.0000, 'ºC'),
	(202760, 120, '2014-02-15 01:07:59.000000', 'temperatura', 536.0000, 'ºC'),
	(202761, 120, '2014-02-15 01:08:00.000000', 'temperatura', 1165.0000, 'ºC'),
	(202762, 120, '2014-02-15 01:08:01.000000', 'temperatura', 616.0000, 'ºC'),
	(202763, 120, '2014-02-15 01:08:02.000000', 'temperatura', 785.0000, 'ºC'),
	(202764, 120, '2014-02-15 01:08:03.000000', 'temperatura', 877.0000, 'ºC'),
	(202765, 120, '2014-02-15 01:08:04.000000', 'temperatura', 832.0000, 'ºC'),
	(202766, 120, '2014-02-15 01:08:05.000000', 'temperatura', 328.0000, 'ºC'),
	(202767, 120, '2014-02-15 01:08:06.000000', 'temperatura', 346.0000, 'ºC'),
	(202768, 120, '2014-02-15 01:08:07.000000', 'temperatura', 746.0000, 'ºC'),
	(202769, 120, '2014-02-15 01:08:08.000000', 'temperatura', 292.0000, 'ºC'),
	(202770, 120, '2014-02-15 01:08:09.000000', 'temperatura', 422.0000, 'ºC'),
	(202771, 120, '2014-02-15 01:08:10.000000', 'temperatura', 36.0000, 'ºC'),
	(202772, 120, '2014-02-15 01:08:11.000000', 'temperatura', 114.0000, 'ºC'),
	(202773, 120, '2014-02-15 01:08:12.000000', 'temperatura', 462.0000, 'ºC'),
	(202774, 120, '2014-02-15 01:08:13.000000', 'temperatura', 771.0000, 'ºC'),
	(202775, 120, '2014-02-15 01:08:14.000000', 'temperatura', 67.0000, 'ºC'),
	(202776, 120, '2014-02-15 01:08:15.000000', 'temperatura', 422.0000, 'ºC'),
	(202777, 120, '2014-02-15 01:08:16.000000', 'temperatura', 711.0000, 'ºC'),
	(202778, 120, '2014-02-15 01:08:17.000000', 'temperatura', 1087.0000, 'ºC'),
	(202779, 120, '2014-02-15 01:08:18.000000', 'temperatura', 905.0000, 'ºC'),
	(202780, 120, '2014-02-15 01:08:19.000000', 'temperatura', 65.0000, 'ºC'),
	(202781, 120, '2014-02-15 01:08:20.000000', 'temperatura', 12.0000, 'ºC'),
	(202782, 120, '2014-02-15 01:08:21.000000', 'temperatura', 1063.0000, 'ºC'),
	(202783, 120, '2014-02-15 01:08:22.000000', 'temperatura', 479.0000, 'ºC'),
	(202784, 120, '2014-02-15 01:08:23.000000', 'temperatura', 408.0000, 'ºC'),
	(202785, 120, '2014-02-15 01:08:24.000000', 'temperatura', 601.0000, 'ºC'),
	(202786, 120, '2014-02-15 01:08:25.000000', 'temperatura', 584.0000, 'ºC'),
	(202787, 120, '2014-02-15 01:08:26.000000', 'temperatura', 1116.0000, 'ºC'),
	(202788, 120, '2014-02-15 01:08:27.000000', 'temperatura', 231.0000, 'ºC'),
	(202789, 120, '2014-02-15 01:08:28.000000', 'temperatura', 206.0000, 'ºC'),
	(202790, 120, '2014-02-15 01:08:29.000000', 'temperatura', 336.0000, 'ºC'),
	(202791, 120, '2014-02-15 01:08:30.000000', 'temperatura', 1064.0000, 'ºC'),
	(202792, 120, '2014-02-15 01:08:31.000000', 'temperatura', 712.0000, 'ºC'),
	(202793, 120, '2014-02-15 01:08:32.000000', 'temperatura', 368.0000, 'ºC'),
	(202794, 120, '2014-02-15 01:08:33.000000', 'temperatura', 905.0000, 'ºC'),
	(202795, 120, '2014-02-15 01:08:34.000000', 'temperatura', 1021.0000, 'ºC'),
	(202796, 120, '2014-02-15 01:08:35.000000', 'temperatura', 1189.0000, 'ºC'),
	(202797, 120, '2014-02-15 01:08:36.000000', 'temperatura', 486.0000, 'ºC'),
	(202798, 120, '2014-02-15 01:08:37.000000', 'temperatura', 60.0000, 'ºC'),
	(202799, 120, '2014-02-15 01:08:38.000000', 'temperatura', 43.0000, 'ºC'),
	(202800, 120, '2014-02-15 01:08:39.000000', 'temperatura', 37.0000, 'ºC'),
	(202801, 120, '2014-02-15 01:08:40.000000', 'temperatura', 56.0000, 'ºC'),
	(202802, 120, '2014-02-15 01:08:41.000000', 'temperatura', 169.0000, 'ºC'),
	(202803, 120, '2014-02-15 01:08:42.000000', 'temperatura', 677.0000, 'ºC'),
	(202804, 120, '2014-02-15 01:08:43.000000', 'temperatura', 480.0000, 'ºC'),
	(202805, 120, '2014-02-15 01:08:44.000000', 'temperatura', 369.0000, 'ºC'),
	(202806, 120, '2014-02-15 01:08:45.000000', 'temperatura', 407.0000, 'ºC'),
	(202807, 120, '2014-02-15 01:08:46.000000', 'temperatura', 927.0000, 'ºC'),
	(202808, 120, '2014-02-15 01:08:47.000000', 'temperatura', 1014.0000, 'ºC'),
	(202809, 120, '2014-02-15 01:08:48.000000', 'temperatura', 1091.0000, 'ºC'),
	(202810, 120, '2014-02-15 01:08:49.000000', 'temperatura', 13.0000, 'ºC'),
	(202811, 120, '2014-02-15 01:08:50.000000', 'temperatura', 391.0000, 'ºC'),
	(202812, 120, '2014-02-15 01:08:51.000000', 'temperatura', 716.0000, 'ºC'),
	(202813, 120, '2014-02-15 01:08:52.000000', 'temperatura', 8.0000, 'ºC'),
	(202814, 120, '2014-02-15 01:08:53.000000', 'temperatura', 293.0000, 'ºC'),
	(202815, 120, '2014-02-15 01:08:54.000000', 'temperatura', 242.0000, 'ºC'),
	(202816, 120, '2014-02-15 01:08:55.000000', 'temperatura', 332.0000, 'ºC'),
	(202817, 120, '2014-02-15 01:08:56.000000', 'temperatura', 935.0000, 'ºC'),
	(202818, 120, '2014-02-15 01:08:57.000000', 'temperatura', 79.0000, 'ºC'),
	(202819, 120, '2014-02-15 01:08:58.000000', 'temperatura', 1190.0000, 'ºC'),
	(202820, 120, '2014-02-15 01:08:59.000000', 'temperatura', 913.0000, 'ºC'),
	(202821, 120, '2014-02-15 01:09:00.000000', 'temperatura', 997.0000, 'ºC'),
	(202822, 120, '2014-02-15 01:09:01.000000', 'temperatura', 1044.0000, 'ºC'),
	(202823, 120, '2014-02-15 01:09:02.000000', 'temperatura', 1032.0000, 'ºC'),
	(202824, 120, '2014-02-15 01:09:03.000000', 'temperatura', 827.0000, 'ºC'),
	(202825, 120, '2014-02-15 01:09:04.000000', 'temperatura', 1038.0000, 'ºC'),
	(202826, 120, '2014-02-15 01:09:05.000000', 'temperatura', 312.0000, 'ºC'),
	(202827, 120, '2014-02-15 01:09:06.000000', 'temperatura', 845.0000, 'ºC'),
	(202828, 120, '2014-02-15 01:09:07.000000', 'temperatura', 891.0000, 'ºC'),
	(202829, 120, '2014-02-15 01:09:08.000000', 'temperatura', 719.0000, 'ºC'),
	(202830, 120, '2014-02-15 01:09:09.000000', 'temperatura', 922.0000, 'ºC'),
	(202831, 120, '2014-02-15 01:09:10.000000', 'temperatura', 56.0000, 'ºC'),
	(202832, 120, '2014-02-15 01:09:11.000000', 'temperatura', 1114.0000, 'ºC'),
	(202833, 120, '2014-02-15 01:09:12.000000', 'temperatura', 603.0000, 'ºC'),
	(202834, 120, '2014-02-15 01:09:13.000000', 'temperatura', 873.0000, 'ºC'),
	(202835, 120, '2014-02-15 01:09:14.000000', 'temperatura', 158.0000, 'ºC'),
	(202836, 120, '2014-02-15 01:09:15.000000', 'temperatura', 570.0000, 'ºC'),
	(202837, 120, '2014-02-15 01:09:16.000000', 'temperatura', 1179.0000, 'ºC'),
	(202838, 120, '2014-02-15 01:09:17.000000', 'temperatura', 583.0000, 'ºC'),
	(202839, 120, '2014-02-15 01:09:18.000000', 'temperatura', 579.0000, 'ºC'),
	(202840, 120, '2014-02-15 01:09:19.000000', 'temperatura', 1148.0000, 'ºC'),
	(202841, 120, '2014-02-15 01:09:20.000000', 'temperatura', 403.0000, 'ºC'),
	(202842, 120, '2014-02-15 01:09:21.000000', 'temperatura', 970.0000, 'ºC'),
	(202843, 120, '2014-02-15 01:09:22.000000', 'temperatura', 43.0000, 'ºC'),
	(202844, 120, '2014-02-15 01:09:23.000000', 'temperatura', 903.0000, 'ºC'),
	(202845, 120, '2014-02-15 01:09:24.000000', 'temperatura', 788.0000, 'ºC'),
	(202846, 120, '2014-02-15 01:09:25.000000', 'temperatura', 30.0000, 'ºC'),
	(202847, 120, '2014-02-15 01:09:26.000000', 'temperatura', 187.0000, 'ºC'),
	(202848, 120, '2014-02-15 01:09:27.000000', 'temperatura', 845.0000, 'ºC'),
	(202849, 120, '2014-02-15 01:09:28.000000', 'temperatura', 66.0000, 'ºC'),
	(202850, 120, '2014-02-15 01:09:29.000000', 'temperatura', 195.0000, 'ºC'),
	(202851, 120, '2014-02-15 01:09:30.000000', 'temperatura', 778.0000, 'ºC'),
	(202852, 120, '2014-02-15 01:09:31.000000', 'temperatura', 904.0000, 'ºC'),
	(202853, 120, '2014-02-15 01:09:32.000000', 'temperatura', 989.0000, 'ºC'),
	(202854, 120, '2014-02-15 01:09:33.000000', 'temperatura', 1030.0000, 'ºC'),
	(202855, 120, '2014-02-15 01:09:34.000000', 'temperatura', 987.0000, 'ºC'),
	(202856, 120, '2014-02-15 01:09:35.000000', 'temperatura', 644.0000, 'ºC'),
	(202857, 120, '2014-02-15 01:09:36.000000', 'temperatura', 258.0000, 'ºC'),
	(202858, 120, '2014-02-15 01:09:37.000000', 'temperatura', 559.0000, 'ºC'),
	(202859, 120, '2014-02-15 01:09:38.000000', 'temperatura', 822.0000, 'ºC'),
	(202860, 120, '2014-02-15 01:09:39.000000', 'temperatura', 32.0000, 'ºC'),
	(202861, 120, '2014-02-15 01:09:40.000000', 'temperatura', 95.0000, 'ºC'),
	(202862, 120, '2014-02-15 01:09:41.000000', 'temperatura', 381.0000, 'ºC'),
	(202863, 120, '2014-02-15 01:09:42.000000', 'temperatura', 418.0000, 'ºC'),
	(202864, 120, '2014-02-15 01:09:43.000000', 'temperatura', 948.0000, 'ºC'),
	(202865, 120, '2014-02-15 01:09:44.000000', 'temperatura', 1087.0000, 'ºC'),
	(202866, 120, '2014-02-15 01:09:45.000000', 'temperatura', 191.0000, 'ºC'),
	(202867, 120, '2014-02-15 01:09:46.000000', 'temperatura', 93.0000, 'ºC'),
	(202868, 120, '2014-02-15 01:09:47.000000', 'temperatura', 1095.0000, 'ºC'),
	(202869, 120, '2014-02-15 01:09:48.000000', 'temperatura', 394.0000, 'ºC'),
	(202870, 120, '2014-02-15 01:09:49.000000', 'temperatura', 1086.0000, 'ºC'),
	(202871, 120, '2014-02-15 01:09:50.000000', 'temperatura', 650.0000, 'ºC'),
	(202872, 120, '2014-02-15 01:09:51.000000', 'temperatura', 1191.0000, 'ºC'),
	(202873, 120, '2014-02-15 01:09:52.000000', 'temperatura', 406.0000, 'ºC'),
	(202874, 120, '2014-02-15 01:09:53.000000', 'temperatura', 857.0000, 'ºC'),
	(202875, 120, '2014-02-15 01:09:54.000000', 'temperatura', 668.0000, 'ºC'),
	(202876, 120, '2014-02-15 01:09:55.000000', 'temperatura', 769.0000, 'ºC'),
	(202877, 120, '2014-02-15 01:09:56.000000', 'temperatura', 642.0000, 'ºC'),
	(202878, 120, '2014-02-15 01:09:57.000000', 'temperatura', 903.0000, 'ºC'),
	(202879, 120, '2014-02-15 01:09:58.000000', 'temperatura', 189.0000, 'ºC'),
	(202880, 120, '2014-02-15 01:09:59.000000', 'temperatura', 636.0000, 'ºC'),
	(202881, 120, '2014-02-15 01:10:00.000000', 'temperatura', 212.0000, 'ºC'),
	(202882, 120, '2014-02-15 01:10:01.000000', 'temperatura', 354.0000, 'ºC'),
	(202883, 120, '2014-02-15 01:10:02.000000', 'temperatura', 1136.0000, 'ºC'),
	(202884, 120, '2014-02-15 01:10:03.000000', 'temperatura', 1019.0000, 'ºC'),
	(202885, 120, '2014-02-15 01:10:04.000000', 'temperatura', 487.0000, 'ºC'),
	(202886, 120, '2014-02-15 01:10:05.000000', 'temperatura', 579.0000, 'ºC'),
	(202887, 120, '2014-02-15 01:10:06.000000', 'temperatura', 233.0000, 'ºC'),
	(202888, 120, '2014-02-15 01:10:07.000000', 'temperatura', 628.0000, 'ºC'),
	(202889, 120, '2014-02-15 01:10:08.000000', 'temperatura', 43.0000, 'ºC'),
	(202890, 120, '2014-02-15 01:10:09.000000', 'temperatura', 731.0000, 'ºC'),
	(202891, 120, '2014-02-15 01:10:10.000000', 'temperatura', 1126.0000, 'ºC'),
	(202892, 120, '2014-02-15 01:10:11.000000', 'temperatura', 1038.0000, 'ºC'),
	(202893, 120, '2014-02-15 01:10:12.000000', 'temperatura', 614.0000, 'ºC'),
	(202894, 120, '2014-02-15 01:10:13.000000', 'temperatura', 1155.0000, 'ºC'),
	(202895, 120, '2014-02-15 01:10:14.000000', 'temperatura', 333.0000, 'ºC'),
	(202896, 120, '2014-02-15 01:10:15.000000', 'temperatura', 600.0000, 'ºC'),
	(202897, 120, '2014-02-15 01:10:16.000000', 'temperatura', 802.0000, 'ºC'),
	(202898, 120, '2014-02-15 01:10:17.000000', 'temperatura', 1009.0000, 'ºC'),
	(202899, 120, '2014-02-15 01:10:18.000000', 'temperatura', 242.0000, 'ºC'),
	(202900, 120, '2014-02-15 01:10:19.000000', 'temperatura', 583.0000, 'ºC'),
	(202901, 120, '2014-02-15 01:10:20.000000', 'temperatura', 989.0000, 'ºC'),
	(202902, 120, '2014-02-15 01:10:21.000000', 'temperatura', 796.0000, 'ºC'),
	(202903, 120, '2014-02-15 01:10:22.000000', 'temperatura', 1015.0000, 'ºC'),
	(202904, 120, '2014-02-15 01:10:23.000000', 'temperatura', 289.0000, 'ºC'),
	(202905, 120, '2014-02-15 01:10:24.000000', 'temperatura', 798.0000, 'ºC'),
	(202906, 120, '2014-02-15 01:10:25.000000', 'temperatura', 722.0000, 'ºC'),
	(202907, 120, '2014-02-15 01:10:26.000000', 'temperatura', 19.0000, 'ºC'),
	(202908, 120, '2014-02-15 01:10:27.000000', 'temperatura', 328.0000, 'ºC'),
	(202909, 120, '2014-02-15 01:10:28.000000', 'temperatura', 386.0000, 'ºC'),
	(202910, 120, '2014-02-15 01:10:29.000000', 'temperatura', 944.0000, 'ºC'),
	(202911, 120, '2014-02-15 01:10:30.000000', 'temperatura', 1163.0000, 'ºC'),
	(202912, 120, '2014-02-15 01:10:31.000000', 'temperatura', 586.0000, 'ºC'),
	(202913, 120, '2014-02-15 01:10:32.000000', 'temperatura', 638.0000, 'ºC'),
	(202914, 120, '2014-02-15 01:10:33.000000', 'temperatura', 236.0000, 'ºC'),
	(202915, 120, '2014-02-15 01:10:34.000000', 'temperatura', 463.0000, 'ºC'),
	(202916, 120, '2014-02-15 01:10:35.000000', 'temperatura', 410.0000, 'ºC'),
	(202917, 120, '2014-02-15 01:10:36.000000', 'temperatura', 659.0000, 'ºC'),
	(202918, 120, '2014-02-15 01:10:37.000000', 'temperatura', 867.0000, 'ºC'),
	(202919, 120, '2014-02-15 01:10:38.000000', 'temperatura', 1157.0000, 'ºC'),
	(202920, 120, '2014-02-15 01:10:39.000000', 'temperatura', 785.0000, 'ºC'),
	(202921, 120, '2014-02-15 01:10:40.000000', 'temperatura', 455.0000, 'ºC'),
	(202922, 120, '2014-02-15 01:10:41.000000', 'temperatura', 1121.0000, 'ºC'),
	(202923, 120, '2014-02-15 01:10:42.000000', 'temperatura', 640.0000, 'ºC'),
	(202924, 120, '2014-02-15 01:10:43.000000', 'temperatura', 1037.0000, 'ºC'),
	(202925, 120, '2014-02-15 01:10:44.000000', 'temperatura', 867.0000, 'ºC'),
	(202926, 120, '2014-02-15 01:10:45.000000', 'temperatura', 22.0000, 'ºC'),
	(202927, 120, '2014-02-15 01:10:46.000000', 'temperatura', 1112.0000, 'ºC'),
	(202928, 120, '2014-02-15 01:10:47.000000', 'temperatura', 695.0000, 'ºC'),
	(202929, 120, '2014-02-15 01:10:48.000000', 'temperatura', 139.0000, 'ºC'),
	(202930, 120, '2014-02-15 01:10:49.000000', 'temperatura', 1012.0000, 'ºC'),
	(202931, 120, '2014-02-15 01:10:50.000000', 'temperatura', 1041.0000, 'ºC'),
	(202932, 120, '2014-02-15 01:10:51.000000', 'temperatura', 970.0000, 'ºC'),
	(202933, 120, '2014-02-15 01:10:52.000000', 'temperatura', 529.0000, 'ºC'),
	(202934, 120, '2014-02-15 01:10:53.000000', 'temperatura', 935.0000, 'ºC'),
	(202935, 120, '2014-02-15 01:10:54.000000', 'temperatura', 690.0000, 'ºC'),
	(202936, 120, '2014-02-15 01:10:55.000000', 'temperatura', 645.0000, 'ºC'),
	(202937, 120, '2014-02-15 01:10:56.000000', 'temperatura', 1154.0000, 'ºC'),
	(202938, 120, '2014-02-15 01:10:57.000000', 'temperatura', 236.0000, 'ºC'),
	(202939, 120, '2014-02-15 01:10:58.000000', 'temperatura', 119.0000, 'ºC'),
	(202940, 120, '2014-02-15 01:10:59.000000', 'temperatura', 1088.0000, 'ºC'),
	(202941, 120, '2014-02-15 01:11:00.000000', 'temperatura', 284.0000, 'ºC'),
	(202942, 120, '2014-02-15 01:11:01.000000', 'temperatura', 556.0000, 'ºC'),
	(202943, 120, '2014-02-15 01:11:02.000000', 'temperatura', 727.0000, 'ºC'),
	(202944, 120, '2014-02-15 01:11:03.000000', 'temperatura', 767.0000, 'ºC'),
	(202945, 120, '2014-02-15 01:11:04.000000', 'temperatura', 454.0000, 'ºC'),
	(202946, 120, '2014-02-15 01:11:05.000000', 'temperatura', 1169.0000, 'ºC'),
	(202947, 120, '2014-02-15 01:11:06.000000', 'temperatura', 886.0000, 'ºC'),
	(202948, 120, '2014-02-15 01:11:07.000000', 'temperatura', 922.0000, 'ºC'),
	(202949, 120, '2014-02-15 01:11:08.000000', 'temperatura', 752.0000, 'ºC'),
	(202950, 120, '2014-02-15 01:11:09.000000', 'temperatura', 996.0000, 'ºC'),
	(202951, 120, '2014-02-15 01:11:10.000000', 'temperatura', 325.0000, 'ºC'),
	(202952, 120, '2014-02-15 01:11:11.000000', 'temperatura', 1037.0000, 'ºC'),
	(202953, 120, '2014-02-15 01:11:12.000000', 'temperatura', 609.0000, 'ºC'),
	(202954, 120, '2014-02-15 01:11:13.000000', 'temperatura', 1137.0000, 'ºC'),
	(202955, 120, '2014-02-15 01:11:14.000000', 'temperatura', 255.0000, 'ºC'),
	(202956, 120, '2014-02-15 01:11:15.000000', 'temperatura', 267.0000, 'ºC'),
	(202957, 120, '2014-02-15 01:11:16.000000', 'temperatura', 572.0000, 'ºC'),
	(202958, 120, '2014-02-15 01:11:17.000000', 'temperatura', 857.0000, 'ºC'),
	(202959, 120, '2014-02-15 01:11:18.000000', 'temperatura', 171.0000, 'ºC'),
	(202960, 120, '2014-02-15 01:11:19.000000', 'temperatura', 682.0000, 'ºC'),
	(202961, 120, '2014-02-15 01:11:20.000000', 'temperatura', 501.0000, 'ºC'),
	(202962, 120, '2014-02-15 01:11:21.000000', 'temperatura', 458.0000, 'ºC'),
	(202963, 120, '2014-02-15 01:11:22.000000', 'temperatura', 787.0000, 'ºC'),
	(202964, 120, '2014-02-15 01:11:23.000000', 'temperatura', 164.0000, 'ºC'),
	(202965, 120, '2014-02-15 01:11:24.000000', 'temperatura', 857.0000, 'ºC'),
	(202966, 120, '2014-02-15 01:11:25.000000', 'temperatura', 195.0000, 'ºC'),
	(202967, 120, '2014-02-15 01:11:26.000000', 'temperatura', 804.0000, 'ºC'),
	(202968, 120, '2014-02-15 01:11:27.000000', 'temperatura', 1036.0000, 'ºC'),
	(202969, 120, '2014-02-15 01:11:28.000000', 'temperatura', 369.0000, 'ºC'),
	(202970, 120, '2014-02-15 01:11:29.000000', 'temperatura', 1135.0000, 'ºC'),
	(202971, 120, '2014-02-15 01:11:30.000000', 'temperatura', 969.0000, 'ºC'),
	(202972, 120, '2014-02-15 01:11:31.000000', 'temperatura', 243.0000, 'ºC'),
	(202973, 120, '2014-02-15 01:11:32.000000', 'temperatura', 705.0000, 'ºC'),
	(202974, 120, '2014-02-15 01:11:33.000000', 'temperatura', 399.0000, 'ºC'),
	(202975, 120, '2014-02-15 01:11:34.000000', 'temperatura', 1081.0000, 'ºC'),
	(202976, 120, '2014-02-15 01:11:35.000000', 'temperatura', 609.0000, 'ºC'),
	(202977, 120, '2014-02-15 01:11:36.000000', 'temperatura', 1000.0000, 'ºC'),
	(202978, 120, '2014-02-15 01:11:37.000000', 'temperatura', 776.0000, 'ºC'),
	(202979, 120, '2014-02-15 01:11:38.000000', 'temperatura', 881.0000, 'ºC'),
	(202980, 120, '2014-02-15 01:11:39.000000', 'temperatura', 878.0000, 'ºC'),
	(202981, 120, '2014-02-15 01:11:40.000000', 'temperatura', 546.0000, 'ºC'),
	(202982, 120, '2014-02-15 01:11:41.000000', 'temperatura', 96.0000, 'ºC'),
	(202983, 120, '2014-02-15 01:11:42.000000', 'temperatura', 43.0000, 'ºC'),
	(202984, 120, '2014-02-15 01:11:43.000000', 'temperatura', 1129.0000, 'ºC'),
	(202985, 120, '2014-02-15 01:11:44.000000', 'temperatura', 716.0000, 'ºC'),
	(202986, 120, '2014-02-15 01:11:45.000000', 'temperatura', 193.0000, 'ºC'),
	(202987, 120, '2014-02-15 01:11:46.000000', 'temperatura', 17.0000, 'ºC'),
	(202988, 120, '2014-02-15 01:11:47.000000', 'temperatura', 707.0000, 'ºC'),
	(202989, 120, '2014-02-15 01:11:48.000000', 'temperatura', 1084.0000, 'ºC'),
	(202990, 120, '2014-02-15 01:11:49.000000', 'temperatura', 900.0000, 'ºC'),
	(202991, 120, '2014-02-15 01:11:50.000000', 'temperatura', 47.0000, 'ºC'),
	(202992, 120, '2014-02-15 01:11:51.000000', 'temperatura', 1135.0000, 'ºC'),
	(202993, 120, '2014-02-15 01:11:52.000000', 'temperatura', 735.0000, 'ºC'),
	(202994, 120, '2014-02-15 01:11:53.000000', 'temperatura', 271.0000, 'ºC'),
	(202995, 120, '2014-02-15 01:11:54.000000', 'temperatura', 352.0000, 'ºC'),
	(202996, 120, '2014-02-15 01:11:55.000000', 'temperatura', 946.0000, 'ºC'),
	(202997, 120, '2014-02-15 01:11:56.000000', 'temperatura', 75.0000, 'ºC'),
	(202998, 120, '2014-02-15 01:11:57.000000', 'temperatura', 1136.0000, 'ºC'),
	(202999, 120, '2014-02-15 01:11:58.000000', 'temperatura', 657.0000, 'ºC'),
	(203000, 120, '2014-02-15 01:11:59.000000', 'temperatura', 1076.0000, 'ºC'),
	(203001, 120, '2014-02-15 01:12:00.000000', 'temperatura', 1012.0000, 'ºC'),
	(203002, 120, '2014-02-15 01:12:01.000000', 'temperatura', 630.0000, 'ºC'),
	(203003, 120, '2014-02-15 01:12:02.000000', 'temperatura', 114.0000, 'ºC'),
	(203004, 120, '2014-02-15 01:12:03.000000', 'temperatura', 1079.0000, 'ºC'),
	(203005, 120, '2014-02-15 01:12:04.000000', 'temperatura', 257.0000, 'ºC'),
	(203006, 120, '2014-02-15 01:12:05.000000', 'temperatura', 448.0000, 'ºC'),
	(203007, 120, '2014-02-15 01:12:06.000000', 'temperatura', 268.0000, 'ºC'),
	(203008, 120, '2014-02-15 01:12:07.000000', 'temperatura', 1196.0000, 'ºC'),
	(203009, 120, '2014-02-15 01:12:08.000000', 'temperatura', 378.0000, 'ºC'),
	(203010, 120, '2014-02-15 01:12:09.000000', 'temperatura', 702.0000, 'ºC'),
	(203011, 120, '2014-02-15 01:12:10.000000', 'temperatura', 1176.0000, 'ºC'),
	(203012, 120, '2014-02-15 01:12:11.000000', 'temperatura', 177.0000, 'ºC'),
	(203013, 120, '2014-02-15 01:12:12.000000', 'temperatura', 956.0000, 'ºC'),
	(203014, 120, '2014-02-15 01:12:13.000000', 'temperatura', 648.0000, 'ºC'),
	(203015, 120, '2014-02-15 01:12:14.000000', 'temperatura', 373.0000, 'ºC'),
	(203016, 120, '2014-02-15 01:12:15.000000', 'temperatura', 1123.0000, 'ºC'),
	(203017, 120, '2014-02-15 01:12:16.000000', 'temperatura', 897.0000, 'ºC'),
	(203018, 120, '2014-02-15 01:12:17.000000', 'temperatura', 1115.0000, 'ºC'),
	(203019, 120, '2014-02-15 01:12:18.000000', 'temperatura', 486.0000, 'ºC'),
	(203020, 120, '2014-02-15 01:12:19.000000', 'temperatura', 286.0000, 'ºC'),
	(203021, 120, '2014-02-15 01:12:20.000000', 'temperatura', 1174.0000, 'ºC'),
	(203022, 120, '2014-02-15 01:12:21.000000', 'temperatura', 210.0000, 'ºC'),
	(203023, 120, '2014-02-15 01:12:22.000000', 'temperatura', 1129.0000, 'ºC'),
	(203024, 120, '2014-02-15 01:12:23.000000', 'temperatura', 214.0000, 'ºC'),
	(203025, 120, '2014-02-15 01:12:24.000000', 'temperatura', 85.0000, 'ºC'),
	(203026, 120, '2014-02-15 01:12:25.000000', 'temperatura', 982.0000, 'ºC'),
	(203027, 120, '2014-02-15 01:12:26.000000', 'temperatura', 1058.0000, 'ºC'),
	(203028, 120, '2014-02-15 01:12:27.000000', 'temperatura', 1145.0000, 'ºC'),
	(203029, 120, '2014-02-15 01:12:28.000000', 'temperatura', 149.0000, 'ºC'),
	(203030, 120, '2014-02-15 01:12:29.000000', 'temperatura', 914.0000, 'ºC'),
	(203031, 120, '2014-02-15 01:12:30.000000', 'temperatura', 520.0000, 'ºC'),
	(203032, 120, '2014-02-15 01:12:31.000000', 'temperatura', 1059.0000, 'ºC'),
	(203033, 120, '2014-02-15 01:12:32.000000', 'temperatura', 138.0000, 'ºC'),
	(203034, 120, '2014-02-15 01:12:33.000000', 'temperatura', 1111.0000, 'ºC'),
	(203035, 120, '2014-02-15 01:12:34.000000', 'temperatura', 344.0000, 'ºC'),
	(203036, 120, '2014-02-15 01:12:35.000000', 'temperatura', 784.0000, 'ºC'),
	(203037, 120, '2014-02-15 01:12:36.000000', 'temperatura', 492.0000, 'ºC'),
	(203038, 120, '2014-02-15 01:12:37.000000', 'temperatura', 105.0000, 'ºC'),
	(203039, 120, '2014-02-15 01:12:38.000000', 'temperatura', 253.0000, 'ºC'),
	(203040, 120, '2014-02-15 01:12:39.000000', 'temperatura', 949.0000, 'ºC'),
	(203041, 120, '2014-02-15 01:12:40.000000', 'temperatura', 387.0000, 'ºC'),
	(203042, 120, '2014-02-15 01:12:41.000000', 'temperatura', 288.0000, 'ºC'),
	(203043, 120, '2014-02-15 01:12:42.000000', 'temperatura', 281.0000, 'ºC'),
	(203044, 120, '2014-02-15 01:12:43.000000', 'temperatura', 539.0000, 'ºC'),
	(203045, 120, '2014-02-15 01:12:44.000000', 'temperatura', 654.0000, 'ºC'),
	(203046, 120, '2014-02-15 01:12:45.000000', 'temperatura', 454.0000, 'ºC'),
	(203047, 120, '2014-02-15 01:12:46.000000', 'temperatura', 308.0000, 'ºC'),
	(203048, 120, '2014-02-15 01:12:47.000000', 'temperatura', 178.0000, 'ºC'),
	(203049, 120, '2014-02-15 01:12:48.000000', 'temperatura', 1167.0000, 'ºC'),
	(203050, 120, '2014-02-15 01:12:49.000000', 'temperatura', 502.0000, 'ºC'),
	(203051, 120, '2014-02-15 01:12:50.000000', 'temperatura', 209.0000, 'ºC'),
	(203052, 120, '2014-02-15 01:12:51.000000', 'temperatura', 740.0000, 'ºC'),
	(203053, 120, '2014-02-15 01:12:52.000000', 'temperatura', 674.0000, 'ºC'),
	(203054, 120, '2014-02-15 01:12:53.000000', 'temperatura', 1151.0000, 'ºC'),
	(203055, 120, '2014-02-15 01:12:54.000000', 'temperatura', 135.0000, 'ºC'),
	(203056, 120, '2014-02-15 01:12:55.000000', 'temperatura', 819.0000, 'ºC'),
	(203057, 120, '2014-02-15 01:12:56.000000', 'temperatura', 91.0000, 'ºC'),
	(203058, 120, '2014-02-15 01:12:57.000000', 'temperatura', 400.0000, 'ºC'),
	(203059, 120, '2014-02-15 01:12:58.000000', 'temperatura', 525.0000, 'ºC'),
	(203060, 120, '2014-02-15 01:12:59.000000', 'temperatura', 228.0000, 'ºC'),
	(203061, 120, '2014-02-15 01:13:00.000000', 'temperatura', 766.0000, 'ºC'),
	(203062, 120, '2014-02-15 01:13:01.000000', 'temperatura', 743.0000, 'ºC'),
	(203063, 120, '2014-02-15 01:13:02.000000', 'temperatura', 221.0000, 'ºC'),
	(203064, 120, '2014-02-15 01:13:03.000000', 'temperatura', 77.0000, 'ºC'),
	(203065, 120, '2014-02-15 01:13:04.000000', 'temperatura', 922.0000, 'ºC'),
	(203066, 120, '2014-02-15 01:13:05.000000', 'temperatura', 777.0000, 'ºC'),
	(203067, 120, '2014-02-15 01:13:06.000000', 'temperatura', 1121.0000, 'ºC'),
	(203068, 120, '2014-02-15 01:13:07.000000', 'temperatura', 876.0000, 'ºC'),
	(203069, 120, '2014-02-15 01:13:08.000000', 'temperatura', 1016.0000, 'ºC'),
	(203070, 120, '2014-02-15 01:13:09.000000', 'temperatura', 53.0000, 'ºC'),
	(203071, 120, '2014-02-15 01:13:10.000000', 'temperatura', 817.0000, 'ºC'),
	(203072, 120, '2014-02-15 01:13:11.000000', 'temperatura', 326.0000, 'ºC'),
	(203073, 120, '2014-02-15 01:13:12.000000', 'temperatura', 380.0000, 'ºC'),
	(203074, 120, '2014-02-15 01:13:13.000000', 'temperatura', 924.0000, 'ºC'),
	(203075, 120, '2014-02-15 01:13:14.000000', 'temperatura', 1081.0000, 'ºC'),
	(203076, 120, '2014-02-15 01:13:15.000000', 'temperatura', 232.0000, 'ºC'),
	(203077, 120, '2014-02-15 01:13:16.000000', 'temperatura', 317.0000, 'ºC'),
	(203078, 120, '2014-02-15 01:13:17.000000', 'temperatura', 892.0000, 'ºC'),
	(203079, 120, '2014-02-15 01:13:18.000000', 'temperatura', 1108.0000, 'ºC'),
	(203080, 120, '2014-02-15 01:13:19.000000', 'temperatura', 464.0000, 'ºC'),
	(203081, 120, '2014-02-15 01:13:20.000000', 'temperatura', 196.0000, 'ºC'),
	(203082, 120, '2014-02-15 01:13:21.000000', 'temperatura', 790.0000, 'ºC'),
	(203083, 120, '2014-02-15 01:13:22.000000', 'temperatura', 963.0000, 'ºC'),
	(203084, 120, '2014-02-15 01:13:23.000000', 'temperatura', 46.0000, 'ºC'),
	(203085, 120, '2014-02-15 01:13:24.000000', 'temperatura', 942.0000, 'ºC'),
	(203086, 120, '2014-02-15 01:13:25.000000', 'temperatura', 973.0000, 'ºC'),
	(203087, 120, '2014-02-15 01:13:26.000000', 'temperatura', 838.0000, 'ºC'),
	(203088, 120, '2014-02-15 01:13:27.000000', 'temperatura', 71.0000, 'ºC'),
	(203089, 120, '2014-02-15 01:13:28.000000', 'temperatura', 243.0000, 'ºC'),
	(203090, 120, '2014-02-15 01:13:29.000000', 'temperatura', 1001.0000, 'ºC'),
	(203091, 120, '2014-02-15 01:13:30.000000', 'temperatura', 678.0000, 'ºC'),
	(203092, 120, '2014-02-15 01:13:31.000000', 'temperatura', 388.0000, 'ºC'),
	(203093, 120, '2014-02-15 01:13:32.000000', 'temperatura', 1107.0000, 'ºC'),
	(203094, 120, '2014-02-15 01:13:33.000000', 'temperatura', 769.0000, 'ºC'),
	(203095, 120, '2014-02-15 01:13:34.000000', 'temperatura', 524.0000, 'ºC'),
	(203096, 120, '2014-02-15 01:13:35.000000', 'temperatura', 315.0000, 'ºC'),
	(203097, 120, '2014-02-15 01:13:36.000000', 'temperatura', 4.0000, 'ºC'),
	(203098, 120, '2014-02-15 01:13:37.000000', 'temperatura', 274.0000, 'ºC'),
	(203099, 120, '2014-02-15 01:13:38.000000', 'temperatura', 158.0000, 'ºC'),
	(203100, 120, '2014-02-15 01:13:39.000000', 'temperatura', 1170.0000, 'ºC'),
	(203101, 120, '2014-02-15 01:13:40.000000', 'temperatura', 576.0000, 'ºC'),
	(203102, 120, '2014-02-15 01:13:41.000000', 'temperatura', 569.0000, 'ºC'),
	(203103, 120, '2014-02-15 01:13:42.000000', 'temperatura', 1119.0000, 'ºC'),
	(203104, 120, '2014-02-15 01:13:43.000000', 'temperatura', 287.0000, 'ºC'),
	(203105, 120, '2014-02-15 01:13:44.000000', 'temperatura', 479.0000, 'ºC'),
	(203106, 120, '2014-02-15 01:13:45.000000', 'temperatura', 333.0000, 'ºC'),
	(203107, 120, '2014-02-15 01:13:46.000000', 'temperatura', 228.0000, 'ºC'),
	(203108, 120, '2014-02-15 01:13:47.000000', 'temperatura', 145.0000, 'ºC'),
	(203109, 120, '2014-02-15 01:13:48.000000', 'temperatura', 38.0000, 'ºC'),
	(203110, 120, '2014-02-15 01:13:49.000000', 'temperatura', 958.0000, 'ºC'),
	(203111, 120, '2014-02-15 01:13:50.000000', 'temperatura', 1076.0000, 'ºC'),
	(203112, 120, '2014-02-15 01:13:51.000000', 'temperatura', 105.0000, 'ºC'),
	(203113, 120, '2014-02-15 01:13:52.000000', 'temperatura', 896.0000, 'ºC'),
	(203114, 120, '2014-02-15 01:13:53.000000', 'temperatura', 569.0000, 'ºC'),
	(203115, 120, '2014-02-15 01:13:54.000000', 'temperatura', 154.0000, 'ºC'),
	(203116, 120, '2014-02-15 01:13:55.000000', 'temperatura', 266.0000, 'ºC'),
	(203117, 120, '2014-02-15 01:13:56.000000', 'temperatura', 870.0000, 'ºC'),
	(203118, 120, '2014-02-15 01:13:57.000000', 'temperatura', 1151.0000, 'ºC'),
	(203119, 120, '2014-02-15 01:13:58.000000', 'temperatura', 744.0000, 'ºC'),
	(203120, 120, '2014-02-15 01:13:59.000000', 'temperatura', 267.0000, 'ºC'),
	(203121, 120, '2014-02-15 01:14:00.000000', 'temperatura', 304.0000, 'ºC'),
	(203122, 120, '2014-02-15 01:14:01.000000', 'temperatura', 719.0000, 'ºC'),
	(203123, 120, '2014-02-15 01:14:02.000000', 'temperatura', 286.0000, 'ºC'),
	(203124, 120, '2014-02-15 01:14:03.000000', 'temperatura', 471.0000, 'ºC'),
	(203125, 120, '2014-02-15 01:14:04.000000', 'temperatura', 300.0000, 'ºC'),
	(203126, 120, '2014-02-15 01:14:05.000000', 'temperatura', 87.0000, 'ºC'),
	(203127, 120, '2014-02-15 01:14:06.000000', 'temperatura', 734.0000, 'ºC'),
	(203128, 120, '2014-02-15 01:14:07.000000', 'temperatura', 1012.0000, 'ºC'),
	(203129, 120, '2014-02-15 01:14:08.000000', 'temperatura', 457.0000, 'ºC'),
	(203130, 120, '2014-02-15 01:14:09.000000', 'temperatura', 450.0000, 'ºC'),
	(203131, 120, '2014-02-15 01:14:10.000000', 'temperatura', 879.0000, 'ºC'),
	(203132, 120, '2014-02-15 01:14:11.000000', 'temperatura', 647.0000, 'ºC'),
	(203133, 120, '2014-02-15 01:14:12.000000', 'temperatura', 596.0000, 'ºC'),
	(203134, 120, '2014-02-15 01:14:13.000000', 'temperatura', 1039.0000, 'ºC'),
	(203135, 120, '2014-02-15 01:14:14.000000', 'temperatura', 1007.0000, 'ºC'),
	(203136, 120, '2014-02-15 01:14:15.000000', 'temperatura', 718.0000, 'ºC'),
	(203137, 120, '2014-02-15 01:14:16.000000', 'temperatura', 572.0000, 'ºC'),
	(203138, 120, '2014-02-15 01:14:17.000000', 'temperatura', 707.0000, 'ºC'),
	(203139, 120, '2014-02-15 01:14:18.000000', 'temperatura', 619.0000, 'ºC'),
	(203140, 120, '2014-02-15 01:14:19.000000', 'temperatura', 972.0000, 'ºC'),
	(203141, 120, '2014-02-15 01:14:20.000000', 'temperatura', 607.0000, 'ºC'),
	(203142, 120, '2014-02-15 01:14:21.000000', 'temperatura', 118.0000, 'ºC'),
	(203143, 120, '2014-02-15 01:14:22.000000', 'temperatura', 1168.0000, 'ºC'),
	(203144, 120, '2014-02-15 01:14:23.000000', 'temperatura', 688.0000, 'ºC'),
	(203145, 120, '2014-02-15 01:14:24.000000', 'temperatura', 1136.0000, 'ºC'),
	(203146, 120, '2014-02-15 01:14:25.000000', 'temperatura', 16.0000, 'ºC'),
	(203147, 120, '2014-02-15 01:14:26.000000', 'temperatura', 274.0000, 'ºC'),
	(203148, 120, '2014-02-15 01:14:27.000000', 'temperatura', 123.0000, 'ºC'),
	(203149, 120, '2014-02-15 01:14:28.000000', 'temperatura', 991.0000, 'ºC'),
	(203150, 120, '2014-02-15 01:14:29.000000', 'temperatura', 986.0000, 'ºC'),
	(203151, 120, '2014-02-15 01:14:30.000000', 'temperatura', 758.0000, 'ºC'),
	(203152, 120, '2014-02-15 01:14:31.000000', 'temperatura', 835.0000, 'ºC'),
	(203153, 120, '2014-02-15 01:14:32.000000', 'temperatura', 700.0000, 'ºC'),
	(203154, 120, '2014-02-15 01:14:33.000000', 'temperatura', 995.0000, 'ºC'),
	(203155, 120, '2014-02-15 01:14:34.000000', 'temperatura', 477.0000, 'ºC'),
	(203156, 120, '2014-02-15 01:14:35.000000', 'temperatura', 598.0000, 'ºC'),
	(203157, 120, '2014-02-15 01:14:36.000000', 'temperatura', 359.0000, 'ºC'),
	(203158, 120, '2014-02-15 01:14:37.000000', 'temperatura', 3.0000, 'ºC'),
	(203159, 120, '2014-02-15 01:14:38.000000', 'temperatura', 136.0000, 'ºC'),
	(203160, 120, '2014-02-15 01:14:39.000000', 'temperatura', 674.0000, 'ºC'),
	(203161, 120, '2014-02-15 01:14:40.000000', 'temperatura', 562.0000, 'ºC'),
	(203162, 120, '2014-02-15 01:14:41.000000', 'temperatura', 787.0000, 'ºC'),
	(203163, 120, '2014-02-15 01:14:42.000000', 'temperatura', 1051.0000, 'ºC'),
	(203164, 120, '2014-02-15 01:14:43.000000', 'temperatura', 495.0000, 'ºC'),
	(203165, 120, '2014-02-15 01:14:44.000000', 'temperatura', 520.0000, 'ºC'),
	(203166, 120, '2014-02-15 01:14:45.000000', 'temperatura', 1118.0000, 'ºC'),
	(203167, 120, '2014-02-15 01:14:46.000000', 'temperatura', 429.0000, 'ºC'),
	(203168, 120, '2014-02-15 01:14:47.000000', 'temperatura', 1191.0000, 'ºC'),
	(203169, 120, '2014-02-15 01:14:48.000000', 'temperatura', 1069.0000, 'ºC'),
	(203170, 120, '2014-02-15 01:14:49.000000', 'temperatura', 572.0000, 'ºC'),
	(203171, 120, '2014-02-15 01:14:50.000000', 'temperatura', 853.0000, 'ºC'),
	(203172, 120, '2014-02-15 01:14:51.000000', 'temperatura', 152.0000, 'ºC'),
	(203173, 120, '2014-02-15 01:14:52.000000', 'temperatura', 601.0000, 'ºC'),
	(203174, 120, '2014-02-15 01:14:53.000000', 'temperatura', 149.0000, 'ºC'),
	(203175, 120, '2014-02-15 01:14:54.000000', 'temperatura', 144.0000, 'ºC'),
	(203176, 120, '2014-02-15 01:14:55.000000', 'temperatura', 273.0000, 'ºC'),
	(203177, 120, '2014-02-15 01:14:56.000000', 'temperatura', 935.0000, 'ºC'),
	(203178, 120, '2014-02-15 01:14:57.000000', 'temperatura', 254.0000, 'ºC'),
	(203179, 120, '2014-02-15 01:14:58.000000', 'temperatura', 865.0000, 'ºC'),
	(203180, 120, '2014-02-15 01:14:59.000000', 'temperatura', 1165.0000, 'ºC'),
	(203181, 120, '2014-02-15 01:15:00.000000', 'temperatura', 829.0000, 'ºC'),
	(203182, 120, '2014-02-15 01:15:01.000000', 'temperatura', 651.0000, 'ºC'),
	(203183, 120, '2014-02-15 01:15:02.000000', 'temperatura', 768.0000, 'ºC'),
	(203184, 120, '2014-02-15 01:15:03.000000', 'temperatura', 686.0000, 'ºC'),
	(203185, 120, '2014-02-15 01:15:04.000000', 'temperatura', 1129.0000, 'ºC'),
	(203186, 120, '2014-02-15 01:15:05.000000', 'temperatura', 1185.0000, 'ºC'),
	(203187, 120, '2014-02-15 01:15:06.000000', 'temperatura', 140.0000, 'ºC'),
	(203188, 120, '2014-02-15 01:15:07.000000', 'temperatura', 745.0000, 'ºC'),
	(203189, 120, '2014-02-15 01:15:08.000000', 'temperatura', 907.0000, 'ºC'),
	(203190, 120, '2014-02-15 01:15:09.000000', 'temperatura', 1098.0000, 'ºC'),
	(203191, 120, '2014-02-15 01:15:10.000000', 'temperatura', 369.0000, 'ºC'),
	(203192, 120, '2014-02-15 01:15:11.000000', 'temperatura', 953.0000, 'ºC'),
	(203193, 120, '2014-02-15 01:15:12.000000', 'temperatura', 60.0000, 'ºC'),
	(203194, 120, '2014-02-15 01:15:13.000000', 'temperatura', 1039.0000, 'ºC'),
	(203195, 120, '2014-02-15 01:15:14.000000', 'temperatura', 215.0000, 'ºC'),
	(203196, 120, '2014-02-15 01:15:15.000000', 'temperatura', 361.0000, 'ºC'),
	(203197, 120, '2014-02-15 01:15:16.000000', 'temperatura', 1158.0000, 'ºC'),
	(203198, 120, '2014-02-15 01:15:17.000000', 'temperatura', 1108.0000, 'ºC'),
	(203199, 120, '2014-02-15 01:15:18.000000', 'temperatura', 867.0000, 'ºC'),
	(203200, 120, '2014-02-15 01:15:19.000000', 'temperatura', 1011.0000, 'ºC'),
	(203201, 120, '2014-02-15 01:15:20.000000', 'temperatura', 54.0000, 'ºC'),
	(203202, 120, '2014-02-15 01:15:21.000000', 'temperatura', 837.0000, 'ºC'),
	(203203, 120, '2014-02-15 01:15:22.000000', 'temperatura', 424.0000, 'ºC'),
	(203204, 120, '2014-02-15 01:15:23.000000', 'temperatura', 811.0000, 'ºC'),
	(203205, 120, '2014-02-15 01:15:24.000000', 'temperatura', 383.0000, 'ºC'),
	(203206, 120, '2014-02-15 01:15:25.000000', 'temperatura', 681.0000, 'ºC'),
	(203207, 120, '2014-02-15 01:15:26.000000', 'temperatura', 1056.0000, 'ºC'),
	(203208, 120, '2014-02-15 01:15:27.000000', 'temperatura', 839.0000, 'ºC'),
	(203209, 120, '2014-02-15 01:15:28.000000', 'temperatura', 1029.0000, 'ºC'),
	(203210, 120, '2014-02-15 01:15:29.000000', 'temperatura', 227.0000, 'ºC'),
	(203211, 120, '2014-02-15 01:15:30.000000', 'temperatura', 449.0000, 'ºC'),
	(203212, 120, '2014-02-15 01:15:31.000000', 'temperatura', 365.0000, 'ºC'),
	(203213, 120, '2014-02-15 01:15:32.000000', 'temperatura', 477.0000, 'ºC'),
	(203214, 120, '2014-02-15 01:15:33.000000', 'temperatura', 92.0000, 'ºC'),
	(203215, 120, '2014-02-15 01:15:34.000000', 'temperatura', 229.0000, 'ºC'),
	(203216, 120, '2014-02-15 01:15:35.000000', 'temperatura', 867.0000, 'ºC'),
	(203217, 120, '2014-02-15 01:15:36.000000', 'temperatura', 52.0000, 'ºC'),
	(203218, 120, '2014-02-15 01:15:37.000000', 'temperatura', 56.0000, 'ºC'),
	(203219, 120, '2014-02-15 01:15:38.000000', 'temperatura', 128.0000, 'ºC'),
	(203220, 120, '2014-02-15 01:15:39.000000', 'temperatura', 472.0000, 'ºC'),
	(203221, 120, '2014-02-15 01:15:40.000000', 'temperatura', 776.0000, 'ºC'),
	(203222, 120, '2014-02-15 01:15:41.000000', 'temperatura', 64.0000, 'ºC'),
	(203223, 120, '2014-02-15 01:15:42.000000', 'temperatura', 392.0000, 'ºC'),
	(203224, 120, '2014-02-15 01:15:43.000000', 'temperatura', 569.0000, 'ºC'),
	(203225, 120, '2014-02-15 01:15:44.000000', 'temperatura', 469.0000, 'ºC'),
	(203226, 120, '2014-02-15 01:15:45.000000', 'temperatura', 639.0000, 'ºC'),
	(203227, 120, '2014-02-15 01:15:46.000000', 'temperatura', 586.0000, 'ºC'),
	(203228, 120, '2014-02-15 01:15:47.000000', 'temperatura', 1017.0000, 'ºC'),
	(203229, 120, '2014-02-15 01:15:48.000000', 'temperatura', 925.0000, 'ºC'),
	(203230, 120, '2014-02-15 01:15:49.000000', 'temperatura', 375.0000, 'ºC'),
	(203231, 120, '2014-02-15 01:15:50.000000', 'temperatura', 300.0000, 'ºC'),
	(203232, 120, '2014-02-15 01:15:51.000000', 'temperatura', 378.0000, 'ºC'),
	(203233, 120, '2014-02-15 01:15:52.000000', 'temperatura', 989.0000, 'ºC'),
	(203234, 120, '2014-02-15 01:15:53.000000', 'temperatura', 210.0000, 'ºC'),
	(203235, 120, '2014-02-15 01:15:54.000000', 'temperatura', 482.0000, 'ºC'),
	(203236, 120, '2014-02-15 01:15:55.000000', 'temperatura', 584.0000, 'ºC'),
	(203237, 120, '2014-02-15 01:15:56.000000', 'temperatura', 275.0000, 'ºC'),
	(203238, 120, '2014-02-15 01:15:57.000000', 'temperatura', 823.0000, 'ºC'),
	(203239, 120, '2014-02-15 01:15:58.000000', 'temperatura', 892.0000, 'ºC'),
	(203240, 120, '2014-02-15 01:15:59.000000', 'temperatura', 789.0000, 'ºC'),
	(203241, 120, '2014-02-15 01:16:00.000000', 'temperatura', 72.0000, 'ºC'),
	(203242, 120, '2014-02-15 01:16:01.000000', 'temperatura', 393.0000, 'ºC'),
	(203243, 120, '2014-02-15 01:16:02.000000', 'temperatura', 548.0000, 'ºC'),
	(203244, 120, '2014-02-15 01:16:03.000000', 'temperatura', 363.0000, 'ºC'),
	(203245, 120, '2014-02-15 01:16:04.000000', 'temperatura', 172.0000, 'ºC'),
	(203246, 120, '2014-02-15 01:16:05.000000', 'temperatura', 972.0000, 'ºC'),
	(203247, 120, '2014-02-15 01:16:06.000000', 'temperatura', 743.0000, 'ºC'),
	(203248, 120, '2014-02-15 01:16:07.000000', 'temperatura', 801.0000, 'ºC'),
	(203249, 120, '2014-02-15 01:16:08.000000', 'temperatura', 575.0000, 'ºC'),
	(203250, 120, '2014-02-15 01:16:09.000000', 'temperatura', 471.0000, 'ºC'),
	(203251, 120, '2014-02-15 01:16:10.000000', 'temperatura', 633.0000, 'ºC'),
	(203252, 120, '2014-02-15 01:16:11.000000', 'temperatura', 553.0000, 'ºC'),
	(203253, 120, '2014-02-15 01:16:12.000000', 'temperatura', 866.0000, 'ºC'),
	(203254, 120, '2014-02-15 01:16:13.000000', 'temperatura', 271.0000, 'ºC'),
	(203255, 120, '2014-02-15 01:16:14.000000', 'temperatura', 1157.0000, 'ºC'),
	(203256, 120, '2014-02-15 01:16:15.000000', 'temperatura', 173.0000, 'ºC'),
	(203257, 120, '2014-02-15 01:16:16.000000', 'temperatura', 995.0000, 'ºC'),
	(203258, 120, '2014-02-15 01:16:17.000000', 'temperatura', 858.0000, 'ºC'),
	(203259, 120, '2014-02-15 01:16:18.000000', 'temperatura', 102.0000, 'ºC'),
	(203260, 120, '2014-02-15 01:16:19.000000', 'temperatura', 340.0000, 'ºC'),
	(203261, 120, '2014-02-15 01:16:20.000000', 'temperatura', 193.0000, 'ºC'),
	(203262, 120, '2014-02-15 01:16:21.000000', 'temperatura', 1145.0000, 'ºC'),
	(203263, 120, '2014-02-15 01:16:22.000000', 'temperatura', 347.0000, 'ºC'),
	(203264, 120, '2014-02-15 01:16:23.000000', 'temperatura', 700.0000, 'ºC'),
	(203265, 120, '2014-02-15 01:16:24.000000', 'temperatura', 60.0000, 'ºC'),
	(203266, 120, '2014-02-15 01:16:25.000000', 'temperatura', 599.0000, 'ºC'),
	(203267, 120, '2014-02-15 01:16:26.000000', 'temperatura', 417.0000, 'ºC'),
	(203268, 120, '2014-02-15 01:16:27.000000', 'temperatura', 287.0000, 'ºC'),
	(203269, 120, '2014-02-15 01:16:28.000000', 'temperatura', 185.0000, 'ºC'),
	(203270, 120, '2014-02-15 01:16:29.000000', 'temperatura', 63.0000, 'ºC'),
	(203271, 120, '2014-02-15 01:16:30.000000', 'temperatura', 961.0000, 'ºC'),
	(203272, 120, '2014-02-15 01:16:31.000000', 'temperatura', 1016.0000, 'ºC'),
	(203273, 120, '2014-02-15 01:16:32.000000', 'temperatura', 999.0000, 'ºC'),
	(203274, 120, '2014-02-15 01:16:33.000000', 'temperatura', 748.0000, 'ºC'),
	(203275, 120, '2014-02-15 01:16:34.000000', 'temperatura', 742.0000, 'ºC'),
	(203276, 120, '2014-02-15 01:16:35.000000', 'temperatura', 267.0000, 'ºC'),
	(203277, 120, '2014-02-15 01:16:36.000000', 'temperatura', 311.0000, 'ºC'),
	(203278, 120, '2014-02-15 01:16:37.000000', 'temperatura', 753.0000, 'ºC'),
	(203279, 120, '2014-02-15 01:16:38.000000', 'temperatura', 432.0000, 'ºC'),
	(203280, 120, '2014-02-15 01:16:39.000000', 'temperatura', 1101.0000, 'ºC'),
	(203281, 120, '2014-02-15 01:16:40.000000', 'temperatura', 609.0000, 'ºC'),
	(203282, 120, '2014-02-15 01:16:41.000000', 'temperatura', 943.0000, 'ºC'),
	(203283, 120, '2014-02-15 01:16:42.000000', 'temperatura', 489.0000, 'ºC'),
	(203284, 120, '2014-02-15 01:16:43.000000', 'temperatura', 815.0000, 'ºC'),
	(203285, 120, '2014-02-15 01:16:44.000000', 'temperatura', 207.0000, 'ºC'),
	(203286, 120, '2014-02-15 01:16:45.000000', 'temperatura', 994.0000, 'ºC'),
	(203287, 120, '2014-02-15 01:16:46.000000', 'temperatura', 748.0000, 'ºC'),
	(203288, 120, '2014-02-15 01:16:47.000000', 'temperatura', 759.0000, 'ºC'),
	(203289, 120, '2014-02-15 01:16:48.000000', 'temperatura', 350.0000, 'ºC'),
	(203290, 120, '2014-02-15 01:16:49.000000', 'temperatura', 675.0000, 'ºC'),
	(203291, 120, '2014-02-15 01:16:50.000000', 'temperatura', 1127.0000, 'ºC'),
	(203292, 120, '2014-02-15 01:16:51.000000', 'temperatura', 7.0000, 'ºC'),
	(203293, 120, '2014-02-15 01:16:52.000000', 'temperatura', 257.0000, 'ºC'),
	(203294, 120, '2014-02-15 01:16:53.000000', 'temperatura', 66.0000, 'ºC'),
	(203295, 120, '2014-02-15 01:16:54.000000', 'temperatura', 756.0000, 'ºC'),
	(203296, 120, '2014-02-15 01:16:55.000000', 'temperatura', 1183.0000, 'ºC'),
	(203297, 120, '2014-02-15 01:16:56.000000', 'temperatura', 50.0000, 'ºC'),
	(203298, 120, '2014-02-15 01:16:57.000000', 'temperatura', 300.0000, 'ºC'),
	(203299, 120, '2014-02-15 01:16:58.000000', 'temperatura', 153.0000, 'ºC'),
	(203300, 120, '2014-02-15 01:16:59.000000', 'temperatura', 1063.0000, 'ºC'),
	(203301, 120, '2014-02-15 01:17:00.000000', 'temperatura', 57.0000, 'ºC'),
	(203302, 120, '2014-02-15 01:17:01.000000', 'temperatura', 694.0000, 'ºC'),
	(203303, 120, '2014-02-15 01:17:02.000000', 'temperatura', 903.0000, 'ºC'),
	(203304, 120, '2014-02-15 01:17:03.000000', 'temperatura', 33.0000, 'ºC'),
	(203305, 120, '2014-02-15 01:17:04.000000', 'temperatura', 1055.0000, 'ºC'),
	(203306, 120, '2014-02-15 01:17:05.000000', 'temperatura', 377.0000, 'ºC'),
	(203307, 120, '2014-02-15 01:17:06.000000', 'temperatura', 1123.0000, 'ºC'),
	(203308, 120, '2014-02-15 01:17:07.000000', 'temperatura', 881.0000, 'ºC'),
	(203309, 120, '2014-02-15 01:17:08.000000', 'temperatura', 1039.0000, 'ºC'),
	(203310, 120, '2014-02-15 01:17:09.000000', 'temperatura', 153.0000, 'ºC'),
	(203311, 120, '2014-02-15 01:17:10.000000', 'temperatura', 48.0000, 'ºC'),
	(203312, 120, '2014-02-15 01:17:11.000000', 'temperatura', 981.0000, 'ºC'),
	(203313, 120, '2014-02-15 01:17:12.000000', 'temperatura', 1163.0000, 'ºC'),
	(203314, 120, '2014-02-15 01:17:13.000000', 'temperatura', 471.0000, 'ºC'),
	(203315, 120, '2014-02-15 01:17:14.000000', 'temperatura', 67.0000, 'ºC'),
	(203316, 120, '2014-02-15 01:17:15.000000', 'temperatura', 122.0000, 'ºC'),
	(203317, 120, '2014-02-15 01:17:16.000000', 'temperatura', 408.0000, 'ºC'),
	(203318, 120, '2014-02-15 01:17:17.000000', 'temperatura', 478.0000, 'ºC'),
	(203319, 120, '2014-02-15 01:17:18.000000', 'temperatura', 1163.0000, 'ºC'),
	(203320, 120, '2014-02-15 01:17:19.000000', 'temperatura', 785.0000, 'ºC'),
	(203321, 120, '2014-02-15 01:17:20.000000', 'temperatura', 434.0000, 'ºC'),
	(203322, 120, '2014-02-15 01:17:21.000000', 'temperatura', 1015.0000, 'ºC'),
	(203323, 120, '2014-02-15 01:17:22.000000', 'temperatura', 174.0000, 'ºC'),
	(203324, 120, '2014-02-15 01:17:23.000000', 'temperatura', 226.0000, 'ºC'),
	(203325, 120, '2014-02-15 01:17:24.000000', 'temperatura', 608.0000, 'ºC'),
	(203326, 120, '2014-02-15 01:17:25.000000', 'temperatura', 1164.0000, 'ºC'),
	(203327, 120, '2014-02-15 01:17:26.000000', 'temperatura', 398.0000, 'ºC'),
	(203328, 120, '2014-02-15 01:17:27.000000', 'temperatura', 895.0000, 'ºC'),
	(203329, 120, '2014-02-15 01:17:28.000000', 'temperatura', 883.0000, 'ºC'),
	(203330, 120, '2014-02-15 01:17:29.000000', 'temperatura', 530.0000, 'ºC'),
	(203331, 120, '2014-02-15 01:17:30.000000', 'temperatura', 1.0000, 'ºC'),
	(203332, 120, '2014-02-15 01:17:31.000000', 'temperatura', 816.0000, 'ºC'),
	(203333, 120, '2014-02-15 01:17:32.000000', 'temperatura', 478.0000, 'ºC'),
	(203334, 120, '2014-02-15 01:17:33.000000', 'temperatura', 1142.0000, 'ºC'),
	(203335, 120, '2014-02-15 01:17:34.000000', 'temperatura', 678.0000, 'ºC'),
	(203336, 120, '2014-02-15 01:17:35.000000', 'temperatura', 1163.0000, 'ºC'),
	(203337, 120, '2014-02-15 01:17:36.000000', 'temperatura', 182.0000, 'ºC'),
	(203338, 120, '2014-02-15 01:17:37.000000', 'temperatura', 1023.0000, 'ºC'),
	(203339, 120, '2014-02-15 01:17:38.000000', 'temperatura', 969.0000, 'ºC'),
	(203340, 120, '2014-02-15 01:17:39.000000', 'temperatura', 578.0000, 'ºC'),
	(203341, 120, '2014-02-15 01:17:40.000000', 'temperatura', 1180.0000, 'ºC'),
	(203342, 120, '2014-02-15 01:17:41.000000', 'temperatura', 570.0000, 'ºC'),
	(203343, 120, '2014-02-15 01:17:42.000000', 'temperatura', 507.0000, 'ºC'),
	(203344, 120, '2014-02-15 01:17:43.000000', 'temperatura', 827.0000, 'ºC'),
	(203345, 120, '2014-02-15 01:17:44.000000', 'temperatura', 214.0000, 'ºC'),
	(203346, 120, '2014-02-15 01:17:45.000000', 'temperatura', 991.0000, 'ºC'),
	(203347, 120, '2014-02-15 01:17:46.000000', 'temperatura', 714.0000, 'ºC'),
	(203348, 120, '2014-02-15 01:17:47.000000', 'temperatura', 597.0000, 'ºC'),
	(203349, 120, '2014-02-15 01:17:48.000000', 'temperatura', 845.0000, 'ºC'),
	(203350, 120, '2014-02-15 01:17:49.000000', 'temperatura', 32.0000, 'ºC'),
	(203351, 120, '2014-02-15 01:17:50.000000', 'temperatura', 25.0000, 'ºC'),
	(203352, 120, '2014-02-15 01:17:51.000000', 'temperatura', 30.0000, 'ºC'),
	(203353, 120, '2014-02-15 01:17:52.000000', 'temperatura', 77.0000, 'ºC'),
	(203354, 120, '2014-02-15 01:17:53.000000', 'temperatura', 294.0000, 'ºC'),
	(203355, 120, '2014-02-15 01:17:54.000000', 'temperatura', 41.0000, 'ºC'),
	(203356, 120, '2014-02-15 01:17:55.000000', 'temperatura', 525.0000, 'ºC'),
	(203357, 120, '2014-02-15 01:17:56.000000', 'temperatura', 99.0000, 'ºC'),
	(203358, 120, '2014-02-15 01:17:57.000000', 'temperatura', 124.0000, 'ºC'),
	(203359, 120, '2014-02-15 01:17:58.000000', 'temperatura', 321.0000, 'ºC'),
	(203360, 120, '2014-02-15 01:17:59.000000', 'temperatura', 35.0000, 'ºC'),
	(203361, 120, '2014-02-15 01:18:00.000000', 'temperatura', 411.0000, 'ºC'),
	(203362, 120, '2014-02-15 01:18:01.000000', 'temperatura', 752.0000, 'ºC'),
	(203363, 120, '2014-02-15 01:18:02.000000', 'temperatura', 128.0000, 'ºC'),
	(203364, 120, '2014-02-15 01:18:03.000000', 'temperatura', 785.0000, 'ºC'),
	(203365, 120, '2014-02-15 01:18:04.000000', 'temperatura', 1139.0000, 'ºC'),
	(203366, 120, '2014-02-15 01:18:05.000000', 'temperatura', 941.0000, 'ºC'),
	(203367, 120, '2014-02-15 01:18:06.000000', 'temperatura', 88.0000, 'ºC'),
	(203368, 120, '2014-02-15 01:18:07.000000', 'temperatura', 20.0000, 'ºC'),
	(203369, 120, '2014-02-15 01:18:08.000000', 'temperatura', 1034.0000, 'ºC'),
	(203370, 120, '2014-02-15 01:18:09.000000', 'temperatura', 313.0000, 'ºC'),
	(203371, 120, '2014-02-15 01:18:10.000000', 'temperatura', 864.0000, 'ºC'),
	(203372, 120, '2014-02-15 01:18:11.000000', 'temperatura', 978.0000, 'ºC'),
	(203373, 120, '2014-02-15 01:18:12.000000', 'temperatura', 1102.0000, 'ºC'),
	(203374, 120, '2014-02-15 01:18:13.000000', 'temperatura', 176.0000, 'ºC'),
	(203375, 120, '2014-02-15 01:18:14.000000', 'temperatura', 1172.0000, 'ºC'),
	(203376, 120, '2014-02-15 01:18:15.000000', 'temperatura', 535.0000, 'ºC'),
	(203377, 120, '2014-02-15 01:18:16.000000', 'temperatura', 360.0000, 'ºC'),
	(203378, 120, '2014-02-15 01:18:17.000000', 'temperatura', 194.0000, 'ºC'),
	(203379, 120, '2014-02-15 01:18:18.000000', 'temperatura', 1091.0000, 'ºC'),
	(203380, 120, '2014-02-15 01:18:19.000000', 'temperatura', 75.0000, 'ºC'),
	(203381, 120, '2014-02-15 01:18:20.000000', 'temperatura', 703.0000, 'ºC'),
	(203382, 120, '2014-02-15 01:18:21.000000', 'temperatura', 891.0000, 'ºC'),
	(203383, 120, '2014-02-15 01:18:22.000000', 'temperatura', 1147.0000, 'ºC'),
	(203384, 120, '2014-02-15 01:18:23.000000', 'temperatura', 663.0000, 'ºC'),
	(203385, 120, '2014-02-15 01:18:24.000000', 'temperatura', 1074.0000, 'ºC'),
	(203386, 120, '2014-02-15 01:18:25.000000', 'temperatura', 980.0000, 'ºC'),
	(203387, 120, '2014-02-15 01:18:26.000000', 'temperatura', 481.0000, 'ºC'),
	(203388, 120, '2014-02-15 01:18:27.000000', 'temperatura', 665.0000, 'ºC'),
	(203389, 120, '2014-02-15 01:18:28.000000', 'temperatura', 684.0000, 'ºC'),
	(203390, 120, '2014-02-15 01:18:29.000000', 'temperatura', 224.0000, 'ºC'),
	(203391, 120, '2014-02-15 01:18:30.000000', 'temperatura', 269.0000, 'ºC'),
	(203392, 120, '2014-02-15 01:18:31.000000', 'temperatura', 675.0000, 'ºC'),
	(203393, 120, '2014-02-15 01:18:32.000000', 'temperatura', 167.0000, 'ºC'),
	(203394, 120, '2014-02-15 01:18:33.000000', 'temperatura', 9.0000, 'ºC'),
	(203395, 120, '2014-02-15 01:18:34.000000', 'temperatura', 744.0000, 'ºC'),
	(203396, 120, '2014-02-15 01:18:35.000000', 'temperatura', 94.0000, 'ºC'),
	(203397, 120, '2014-02-15 01:18:36.000000', 'temperatura', 639.0000, 'ºC'),
	(203398, 120, '2014-02-15 01:18:37.000000', 'temperatura', 512.0000, 'ºC'),
	(203399, 120, '2014-02-15 01:18:38.000000', 'temperatura', 647.0000, 'ºC'),
	(203400, 120, '2014-02-15 01:18:39.000000', 'temperatura', 496.0000, 'ºC'),
	(203401, 120, '2014-02-15 01:18:40.000000', 'temperatura', 540.0000, 'ºC'),
	(203402, 120, '2014-02-15 01:18:41.000000', 'temperatura', 12.0000, 'ºC'),
	(203403, 120, '2014-02-15 01:18:42.000000', 'temperatura', 842.0000, 'ºC'),
	(203404, 120, '2014-02-15 01:18:43.000000', 'temperatura', 573.0000, 'ºC'),
	(203405, 120, '2014-02-15 01:18:44.000000', 'temperatura', 339.0000, 'ºC'),
	(203406, 120, '2014-02-15 01:18:45.000000', 'temperatura', 1176.0000, 'ºC'),
	(203407, 120, '2014-02-15 01:18:46.000000', 'temperatura', 63.0000, 'ºC'),
	(203408, 120, '2014-02-15 01:18:47.000000', 'temperatura', 390.0000, 'ºC'),
	(203409, 120, '2014-02-15 01:18:48.000000', 'temperatura', 561.0000, 'ºC'),
	(203410, 120, '2014-02-15 01:18:49.000000', 'temperatura', 434.0000, 'ºC'),
	(203411, 120, '2014-02-15 01:18:50.000000', 'temperatura', 488.0000, 'ºC'),
	(203412, 120, '2014-02-15 01:18:51.000000', 'temperatura', 1138.0000, 'ºC'),
	(203413, 120, '2014-02-15 01:18:52.000000', 'temperatura', 627.0000, 'ºC'),
	(203414, 120, '2014-02-15 01:18:53.000000', 'temperatura', 920.0000, 'ºC'),
	(203415, 120, '2014-02-15 01:18:54.000000', 'temperatura', 322.0000, 'ºC'),
	(203416, 120, '2014-02-15 01:18:55.000000', 'temperatura', 48.0000, 'ºC'),
	(203417, 120, '2014-02-15 01:18:56.000000', 'temperatura', 477.0000, 'ºC'),
	(203418, 120, '2014-02-15 01:18:57.000000', 'temperatura', 1041.0000, 'ºC'),
	(203419, 120, '2014-02-15 01:18:58.000000', 'temperatura', 173.0000, 'ºC'),
	(203420, 120, '2014-02-15 01:18:59.000000', 'temperatura', 145.0000, 'ºC'),
	(203421, 120, '2014-02-15 01:19:00.000000', 'temperatura', 207.0000, 'ºC'),
	(203422, 120, '2014-02-15 01:19:01.000000', 'temperatura', 599.0000, 'ºC'),
	(203423, 120, '2014-02-15 01:19:02.000000', 'temperatura', 1176.0000, 'ºC'),
	(203424, 120, '2014-02-15 01:19:03.000000', 'temperatura', 483.0000, 'ºC'),
	(203425, 120, '2014-02-15 01:19:04.000000', 'temperatura', 87.0000, 'ºC'),
	(203426, 120, '2014-02-15 01:19:05.000000', 'temperatura', 186.0000, 'ºC'),
	(203427, 120, '2014-02-15 01:19:06.000000', 'temperatura', 672.0000, 'ºC'),
	(203428, 120, '2014-02-15 01:19:07.000000', 'temperatura', 401.0000, 'ºC'),
	(203429, 120, '2014-02-15 01:19:08.000000', 'temperatura', 1191.0000, 'ºC'),
	(203430, 120, '2014-02-15 01:19:09.000000', 'temperatura', 1153.0000, 'ºC'),
	(203431, 120, '2014-02-15 01:19:10.000000', 'temperatura', 992.0000, 'ºC'),
	(203432, 120, '2014-02-15 01:19:11.000000', 'temperatura', 303.0000, 'ºC'),
	(203433, 120, '2014-02-15 01:19:12.000000', 'temperatura', 938.0000, 'ºC'),
	(203434, 120, '2014-02-15 01:19:13.000000', 'temperatura', 183.0000, 'ºC'),
	(203435, 120, '2014-02-15 01:19:14.000000', 'temperatura', 502.0000, 'ºC'),
	(203436, 120, '2014-02-15 01:19:15.000000', 'temperatura', 762.0000, 'ºC'),
	(203437, 120, '2014-02-15 01:19:16.000000', 'temperatura', 1103.0000, 'ºC'),
	(203438, 120, '2014-02-15 01:19:17.000000', 'temperatura', 829.0000, 'ºC'),
	(203439, 120, '2014-02-15 01:19:18.000000', 'temperatura', 835.0000, 'ºC'),
	(203440, 120, '2014-02-15 01:19:19.000000', 'temperatura', 490.0000, 'ºC'),
	(203441, 120, '2014-02-15 01:19:20.000000', 'temperatura', 1146.0000, 'ºC'),
	(203442, 120, '2014-02-15 01:19:21.000000', 'temperatura', 660.0000, 'ºC'),
	(203443, 120, '2014-02-15 01:19:22.000000', 'temperatura', 1062.0000, 'ºC'),
	(203444, 120, '2014-02-15 01:19:23.000000', 'temperatura', 929.0000, 'ºC'),
	(203445, 120, '2014-02-15 01:19:24.000000', 'temperatura', 260.0000, 'ºC'),
	(203446, 120, '2014-02-15 01:19:25.000000', 'temperatura', 916.0000, 'ºC'),
	(203447, 120, '2014-02-15 01:19:26.000000', 'temperatura', 200.0000, 'ºC'),
	(203448, 120, '2014-02-15 01:19:27.000000', 'temperatura', 652.0000, 'ºC'),
	(203449, 120, '2014-02-15 01:19:28.000000', 'temperatura', 260.0000, 'ºC'),
	(203450, 120, '2014-02-15 01:19:29.000000', 'temperatura', 543.0000, 'ºC'),
	(203451, 120, '2014-02-15 01:19:30.000000', 'temperatura', 737.0000, 'ºC'),
	(203452, 120, '2014-02-15 01:19:31.000000', 'temperatura', 855.0000, 'ºC'),
	(203453, 120, '2014-02-15 01:19:32.000000', 'temperatura', 864.0000, 'ºC'),
	(203454, 120, '2014-02-15 01:19:33.000000', 'temperatura', 556.0000, 'ºC'),
	(203455, 120, '2014-02-15 01:19:34.000000', 'temperatura', 187.0000, 'ºC'),
	(203456, 120, '2014-02-15 01:19:35.000000', 'temperatura', 470.0000, 'ºC'),
	(203457, 120, '2014-02-15 01:19:36.000000', 'temperatura', 588.0000, 'ºC'),
	(203458, 120, '2014-02-15 01:19:37.000000', 'temperatura', 333.0000, 'ºC'),
	(203459, 120, '2014-02-15 01:19:38.000000', 'temperatura', 1100.0000, 'ºC'),
	(203460, 120, '2014-02-15 01:19:39.000000', 'temperatura', 902.0000, 'ºC'),
	(203461, 120, '2014-02-15 01:19:40.000000', 'temperatura', 10.0000, 'ºC'),
	(203462, 120, '2014-02-15 01:19:41.000000', 'temperatura', 945.0000, 'ºC'),
	(203463, 120, '2014-02-15 01:19:42.000000', 'temperatura', 1095.0000, 'ºC'),
	(203464, 120, '2014-02-15 01:19:43.000000', 'temperatura', 242.0000, 'ºC'),
	(203465, 120, '2014-02-15 01:19:44.000000', 'temperatura', 323.0000, 'ºC'),
	(203466, 120, '2014-02-15 01:19:45.000000', 'temperatura', 891.0000, 'ºC'),
	(203467, 120, '2014-02-15 01:19:46.000000', 'temperatura', 1088.0000, 'ºC'),
	(203468, 120, '2014-02-15 01:19:47.000000', 'temperatura', 365.0000, 'ºC'),
	(203469, 120, '2014-02-15 01:19:48.000000', 'temperatura', 960.0000, 'ºC'),
	(203470, 120, '2014-02-15 01:19:49.000000', 'temperatura', 108.0000, 'ºC'),
	(203471, 120, '2014-02-15 01:19:50.000000', 'temperatura', 62.0000, 'ºC'),
	(203472, 120, '2014-02-15 01:19:51.000000', 'temperatura', 1183.0000, 'ºC'),
	(203473, 120, '2014-02-15 01:19:52.000000', 'temperatura', 931.0000, 'ºC'),
	(203474, 120, '2014-02-15 01:19:53.000000', 'temperatura', 1108.0000, 'ºC'),
	(203475, 120, '2014-02-15 01:19:54.000000', 'temperatura', 347.0000, 'ºC'),
	(203476, 120, '2014-02-15 01:19:55.000000', 'temperatura', 812.0000, 'ºC'),
	(203477, 120, '2014-02-15 01:19:56.000000', 'temperatura', 618.0000, 'ºC'),
	(203478, 120, '2014-02-15 01:19:57.000000', 'temperatura', 657.0000, 'ºC'),
	(203479, 120, '2014-02-15 01:19:58.000000', 'temperatura', 230.0000, 'ºC'),
	(203480, 120, '2014-02-15 01:19:59.000000', 'temperatura', 381.0000, 'ºC'),
	(203481, 120, '2014-02-15 01:20:00.000000', 'temperatura', 14.0000, 'ºC'),
	(203482, 120, '2014-02-15 01:20:01.000000', 'temperatura', 126.0000, 'ºC'),
	(203483, 120, '2014-02-15 01:20:02.000000', 'temperatura', 589.0000, 'ºC'),
	(203484, 120, '2014-02-15 01:20:03.000000', 'temperatura', 169.0000, 'ºC'),
	(203485, 120, '2014-02-15 01:20:04.000000', 'temperatura', 277.0000, 'ºC'),
	(203486, 120, '2014-02-15 01:20:05.000000', 'temperatura', 880.0000, 'ºC'),
	(203487, 120, '2014-02-15 01:20:06.000000', 'temperatura', 1170.0000, 'ºC'),
	(203488, 120, '2014-02-15 01:20:07.000000', 'temperatura', 811.0000, 'ºC'),
	(203489, 120, '2014-02-15 01:20:08.000000', 'temperatura', 545.0000, 'ºC'),
	(203490, 120, '2014-02-15 01:20:09.000000', 'temperatura', 290.0000, 'ºC'),
	(203491, 120, '2014-02-15 01:20:10.000000', 'temperatura', 1019.0000, 'ºC'),
	(203492, 120, '2014-02-15 01:20:11.000000', 'temperatura', 622.0000, 'ºC'),
	(203493, 120, '2014-02-15 01:20:12.000000', 'temperatura', 57.0000, 'ºC'),
	(203494, 120, '2014-02-15 01:20:13.000000', 'temperatura', 818.0000, 'ºC'),
	(203495, 120, '2014-02-15 01:20:14.000000', 'temperatura', 317.0000, 'ºC'),
	(203496, 120, '2014-02-15 01:20:15.000000', 'temperatura', 335.0000, 'ºC'),
	(203497, 120, '2014-02-15 01:20:16.000000', 'temperatura', 725.0000, 'ºC'),
	(203498, 120, '2014-02-15 01:20:17.000000', 'temperatura', 218.0000, 'ºC'),
	(203499, 120, '2014-02-15 01:20:18.000000', 'temperatura', 117.0000, 'ºC'),
	(203500, 120, '2014-02-15 01:20:19.000000', 'temperatura', 1132.0000, 'ºC'),
	(203501, 120, '2014-02-15 01:20:20.000000', 'temperatura', 511.0000, 'ºC'),
	(203502, 120, '2014-02-15 01:20:21.000000', 'temperatura', 356.0000, 'ºC'),
	(203503, 120, '2014-02-15 01:20:22.000000', 'temperatura', 249.0000, 'ºC'),
	(203504, 120, '2014-02-15 01:20:23.000000', 'temperatura', 176.0000, 'ºC'),
	(203505, 120, '2014-02-15 01:20:24.000000', 'temperatura', 133.0000, 'ºC'),
	(203506, 120, '2014-02-15 01:20:25.000000', 'temperatura', 139.0000, 'ºC'),
	(203507, 120, '2014-02-15 01:20:26.000000', 'temperatura', 297.0000, 'ºC'),
	(203508, 120, '2014-02-15 01:20:27.000000', 'temperatura', 1070.0000, 'ºC'),
	(203509, 120, '2014-02-15 01:20:28.000000', 'temperatura', 857.0000, 'ºC'),
	(203510, 120, '2014-02-15 01:20:29.000000', 'temperatura', 1074.0000, 'ºC'),
	(203511, 120, '2014-02-15 01:20:30.000000', 'temperatura', 402.0000, 'ºC'),
	(203512, 120, '2014-02-15 01:20:31.000000', 'temperatura', 1189.0000, 'ºC'),
	(203513, 120, '2014-02-15 01:20:32.000000', 'temperatura', 1139.0000, 'ºC'),
	(203514, 120, '2014-02-15 01:20:33.000000', 'temperatura', 928.0000, 'ºC'),
	(203515, 120, '2014-02-15 01:20:34.000000', 'temperatura', 23.0000, 'ºC'),
	(203516, 120, '2014-02-15 01:20:35.000000', 'temperatura', 934.0000, 'ºC'),
	(203517, 120, '2014-02-15 01:20:36.000000', 'temperatura', 1000.0000, 'ºC'),
	(203518, 120, '2014-02-15 01:20:37.000000', 'temperatura', 1001.0000, 'ºC'),
	(203519, 120, '2014-02-15 01:20:38.000000', 'temperatura', 802.0000, 'ºC'),
	(203520, 120, '2014-02-15 01:20:39.000000', 'temperatura', 1008.0000, 'ºC'),
	(203521, 120, '2014-02-15 01:20:40.000000', 'temperatura', 233.0000, 'ºC'),
	(203522, 120, '2014-02-15 01:20:41.000000', 'temperatura', 543.0000, 'ºC'),
	(203523, 120, '2014-02-15 01:20:42.000000', 'temperatura', 815.0000, 'ºC'),
	(203524, 120, '2014-02-15 01:20:43.000000', 'temperatura', 48.0000, 'ºC'),
	(203525, 120, '2014-02-15 01:20:44.000000', 'temperatura', 195.0000, 'ºC'),
	(203526, 120, '2014-02-15 01:20:45.000000', 'temperatura', 831.0000, 'ºC'),
	(203527, 120, '2014-02-15 01:20:46.000000', 'temperatura', 1171.0000, 'ºC'),
	(203528, 120, '2014-02-15 01:20:47.000000', 'temperatura', 964.0000, 'ºC'),
	(203529, 120, '2014-02-15 01:20:48.000000', 'temperatura', 108.0000, 'ºC'),
	(203530, 120, '2014-02-15 01:20:49.000000', 'temperatura', 46.0000, 'ºC'),
	(203531, 120, '2014-02-15 01:20:50.000000', 'temperatura', 1108.0000, 'ºC'),
	(203532, 120, '2014-02-15 01:20:51.000000', 'temperatura', 601.0000, 'ºC'),
	(203533, 120, '2014-02-15 01:20:52.000000', 'temperatura', 881.0000, 'ºC'),
	(203534, 120, '2014-02-15 01:20:53.000000', 'temperatura', 203.0000, 'ºC'),
	(203535, 120, '2014-02-15 01:20:54.000000', 'temperatura', 773.0000, 'ºC'),
	(203536, 120, '2014-02-15 01:20:55.000000', 'temperatura', 857.0000, 'ºC'),
	(203537, 120, '2014-02-15 01:20:56.000000', 'temperatura', 767.0000, 'ºC'),
	(203538, 120, '2014-02-15 01:20:57.000000', 'temperatura', 62.0000, 'ºC'),
	(203539, 120, '2014-02-15 01:20:58.000000', 'temperatura', 410.0000, 'ºC'),
	(203540, 120, '2014-02-15 01:20:59.000000', 'temperatura', 665.0000, 'ºC'),
	(203541, 120, '2014-02-15 01:21:00.000000', 'temperatura', 894.0000, 'ºC'),
	(203542, 120, '2014-02-15 01:21:01.000000', 'temperatura', 77.0000, 'ºC'),
	(203543, 120, '2014-02-15 01:21:02.000000', 'temperatura', 101.0000, 'ºC'),
	(203544, 120, '2014-02-15 01:21:03.000000', 'temperatura', 277.0000, 'ºC'),
	(203545, 120, '2014-02-15 01:21:04.000000', 'temperatura', 1083.0000, 'ºC'),
	(203546, 120, '2014-02-15 01:21:05.000000', 'temperatura', 983.0000, 'ºC'),
	(203547, 120, '2014-02-15 01:21:06.000000', 'temperatura', 466.0000, 'ºC'),
	(203548, 120, '2014-02-15 01:21:07.000000', 'temperatura', 582.0000, 'ºC'),
	(203549, 120, '2014-02-15 01:21:08.000000', 'temperatura', 315.0000, 'ºC'),
	(203550, 120, '2014-02-15 01:21:09.000000', 'temperatura', 1027.0000, 'ºC'),
	(203551, 120, '2014-02-15 01:21:10.000000', 'temperatura', 589.0000, 'ºC'),
	(203552, 120, '2014-02-15 01:21:11.000000', 'temperatura', 1066.0000, 'ºC'),
	(203553, 120, '2014-02-15 01:21:12.000000', 'temperatura', 1164.0000, 'ºC'),
	(203554, 120, '2014-02-15 01:21:13.000000', 'temperatura', 224.0000, 'ºC'),
	(203555, 120, '2014-02-15 01:21:14.000000', 'temperatura', 26.0000, 'ºC'),
	(203556, 120, '2014-02-15 01:21:15.000000', 'temperatura', 659.0000, 'ºC'),
	(203557, 120, '2014-02-15 01:21:16.000000', 'temperatura', 817.0000, 'ºC'),
	(203558, 120, '2014-02-15 01:21:17.000000', 'temperatura', 911.0000, 'ºC'),
	(203559, 120, '2014-02-15 01:21:18.000000', 'temperatura', 902.0000, 'ºC'),
	(203560, 120, '2014-02-15 01:21:19.000000', 'temperatura', 578.0000, 'ºC'),
	(203561, 120, '2014-02-15 01:21:20.000000', 'temperatura', 184.0000, 'ºC'),
	(203562, 120, '2014-02-15 01:21:21.000000', 'temperatura', 389.0000, 'ºC'),
	(203563, 120, '2014-02-15 01:21:22.000000', 'temperatura', 192.0000, 'ºC'),
	(203564, 120, '2014-02-15 01:21:23.000000', 'temperatura', 992.0000, 'ºC'),
	(203565, 120, '2014-02-15 01:21:24.000000', 'temperatura', 787.0000, 'ºC'),
	(203566, 120, '2014-02-15 01:21:25.000000', 'temperatura', 960.0000, 'ºC'),
	(203567, 120, '2014-02-15 01:21:26.000000', 'temperatura', 41.0000, 'ºC'),
	(203568, 120, '2014-02-15 01:21:27.000000', 'temperatura', 922.0000, 'ºC'),
	(203569, 120, '2014-02-15 01:21:28.000000', 'temperatura', 887.0000, 'ºC'),
	(203570, 120, '2014-02-15 01:21:29.000000', 'temperatura', 473.0000, 'ºC'),
	(203571, 120, '2014-02-15 01:21:30.000000', 'temperatura', 901.0000, 'ºC'),
	(203572, 120, '2014-02-15 01:21:31.000000', 'temperatura', 690.0000, 'ºC'),
	(203573, 120, '2014-02-15 01:21:32.000000', 'temperatura', 745.0000, 'ºC'),
	(203574, 120, '2014-02-15 01:21:33.000000', 'temperatura', 454.0000, 'ºC'),
	(203575, 120, '2014-02-15 01:21:34.000000', 'temperatura', 39.0000, 'ºC'),
	(203576, 120, '2014-02-15 01:21:35.000000', 'temperatura', 31.0000, 'ºC'),
	(203577, 120, '2014-02-15 01:21:36.000000', 'temperatura', 38.0000, 'ºC'),
	(203578, 120, '2014-02-15 01:21:37.000000', 'temperatura', 98.0000, 'ºC'),
	(203579, 120, '2014-02-15 01:21:38.000000', 'temperatura', 376.0000, 'ºC'),
	(203580, 120, '2014-02-15 01:21:39.000000', 'temperatura', 387.0000, 'ºC'),
	(203581, 120, '2014-02-15 01:21:40.000000', 'temperatura', 809.0000, 'ºC'),
	(203582, 120, '2014-02-15 01:21:41.000000', 'temperatura', 482.0000, 'ºC'),
	(203583, 120, '2014-02-15 01:21:42.000000', 'temperatura', 1183.0000, 'ºC'),
	(203584, 120, '2014-02-15 01:21:43.000000', 'temperatura', 872.0000, 'ºC'),
	(203585, 120, '2014-02-15 01:21:44.000000', 'temperatura', 812.0000, 'ºC'),
	(203586, 120, '2014-02-15 01:21:45.000000', 'temperatura', 243.0000, 'ºC'),
	(203587, 120, '2014-02-15 01:21:46.000000', 'temperatura', 1180.0000, 'ºC'),
	(203588, 120, '2014-02-15 01:21:47.000000', 'temperatura', 372.0000, 'ºC'),
	(203589, 120, '2014-02-15 01:21:48.000000', 'temperatura', 720.0000, 'ºC'),
	(203590, 120, '2014-02-15 01:21:49.000000', 'temperatura', 83.0000, 'ºC'),
	(203591, 120, '2014-02-15 01:21:50.000000', 'temperatura', 657.0000, 'ºC'),
	(203592, 120, '2014-02-15 01:21:51.000000', 'temperatura', 636.0000, 'ºC'),
	(203593, 120, '2014-02-15 01:21:52.000000', 'temperatura', 11.0000, 'ºC'),
	(203594, 120, '2014-02-15 01:21:53.000000', 'temperatura', 548.0000, 'ºC'),
	(203595, 120, '2014-02-15 01:21:54.000000', 'temperatura', 305.0000, 'ºC'),
	(203596, 120, '2014-02-15 01:21:55.000000', 'temperatura', 1082.0000, 'ºC'),
	(203597, 120, '2014-02-15 01:21:56.000000', 'temperatura', 895.0000, 'ºC'),
	(203598, 120, '2014-02-15 01:21:57.000000', 'temperatura', 31.0000, 'ºC'),
	(203599, 120, '2014-02-15 01:21:58.000000', 'temperatura', 1069.0000, 'ºC'),
	(203600, 120, '2014-02-15 01:21:59.000000', 'temperatura', 453.0000, 'ºC'),
	(203601, 120, '2014-02-15 01:22:00.000000', 'temperatura', 259.0000, 'ºC'),
	(203602, 120, '2014-02-15 01:22:01.000000', 'temperatura', 1136.0000, 'ºC'),
	(203603, 120, '2014-02-15 01:22:02.000000', 'temperatura', 106.0000, 'ºC'),
	(203604, 120, '2014-02-15 01:22:03.000000', 'temperatura', 720.0000, 'ºC'),
	(203605, 120, '2014-02-15 01:22:04.000000', 'temperatura', 883.0000, 'ºC'),
	(203606, 120, '2014-02-15 01:22:05.000000', 'temperatura', 1054.0000, 'ºC'),
	(203607, 120, '2014-02-15 01:22:06.000000', 'temperatura', 222.0000, 'ºC'),
	(203608, 120, '2014-02-15 01:22:07.000000', 'temperatura', 348.0000, 'ºC'),
	(203609, 120, '2014-02-15 01:22:08.000000', 'temperatura', 1076.0000, 'ºC'),
	(203610, 120, '2014-02-15 01:22:09.000000', 'temperatura', 737.0000, 'ºC'),
	(203611, 120, '2014-02-15 01:22:10.000000', 'temperatura', 459.0000, 'ºC'),
	(203612, 120, '2014-02-15 01:22:11.000000', 'temperatura', 82.0000, 'ºC'),
	(203613, 120, '2014-02-15 01:22:12.000000', 'temperatura', 234.0000, 'ºC'),
	(203614, 120, '2014-02-15 01:22:13.000000', 'temperatura', 925.0000, 'ºC'),
	(203615, 120, '2014-02-15 01:22:14.000000', 'temperatura', 322.0000, 'ºC'),
	(203616, 120, '2014-02-15 01:22:15.000000', 'temperatura', 35.0000, 'ºC'),
	(203617, 120, '2014-02-15 01:22:16.000000', 'temperatura', 412.0000, 'ºC'),
	(203618, 120, '2014-02-15 01:22:17.000000', 'temperatura', 754.0000, 'ºC'),
	(203619, 120, '2014-02-15 01:22:18.000000', 'temperatura', 134.0000, 'ºC'),
	(203620, 120, '2014-02-15 01:22:19.000000', 'temperatura', 807.0000, 'ºC'),
	(203621, 120, '2014-02-15 01:22:20.000000', 'temperatura', 36.0000, 'ºC'),
	(203622, 120, '2014-02-15 01:22:21.000000', 'temperatura', 158.0000, 'ºC'),
	(203623, 120, '2014-02-15 01:22:22.000000', 'temperatura', 685.0000, 'ºC'),
	(203624, 120, '2014-02-15 01:22:23.000000', 'temperatura', 549.0000, 'ºC'),
	(203625, 120, '2014-02-15 01:22:24.000000', 'temperatura', 690.0000, 'ºC'),
	(203626, 120, '2014-02-15 01:22:25.000000', 'temperatura', 605.0000, 'ºC'),
	(203627, 120, '2014-02-15 01:22:26.000000', 'temperatura', 953.0000, 'ºC'),
	(203628, 120, '2014-02-15 01:22:27.000000', 'temperatura', 552.0000, 'ºC'),
	(203629, 120, '2014-02-15 01:22:28.000000', 'temperatura', 1100.0000, 'ºC'),
	(203630, 120, '2014-02-15 01:22:29.000000', 'temperatura', 245.0000, 'ºC'),
	(203631, 120, '2014-02-15 01:22:30.000000', 'temperatura', 328.0000, 'ºC'),
	(203632, 120, '2014-02-15 01:22:31.000000', 'temperatura', 902.0000, 'ºC'),
	(203633, 120, '2014-02-15 01:22:32.000000', 'temperatura', 1130.0000, 'ºC'),
	(203634, 120, '2014-02-15 01:22:33.000000', 'temperatura', 541.0000, 'ºC'),
	(203635, 120, '2014-02-15 01:22:34.000000', 'temperatura', 518.0000, 'ºC'),
	(203636, 120, '2014-02-15 01:22:35.000000', 'temperatura', 966.0000, 'ºC'),
	(203637, 120, '2014-02-15 01:22:36.000000', 'temperatura', 878.0000, 'ºC'),
	(203638, 120, '2014-02-15 01:22:37.000000', 'temperatura', 293.0000, 'ºC'),
	(203639, 120, '2014-02-15 01:22:38.000000', 'temperatura', 31.0000, 'ºC'),
	(203640, 120, '2014-02-15 01:22:39.000000', 'temperatura', 477.0000, 'ºC'),
	(203641, 120, '2014-02-15 01:22:40.000000', 'temperatura', 1091.0000, 'ºC'),
	(203642, 120, '2014-02-15 01:22:41.000000', 'temperatura', 425.0000, 'ºC'),
	(203643, 120, '2014-02-15 01:22:42.000000', 'temperatura', 52.0000, 'ºC'),
	(203644, 120, '2014-02-15 01:22:43.000000', 'temperatura', 185.0000, 'ºC'),
	(203645, 120, '2014-02-15 01:22:44.000000', 'temperatura', 771.0000, 'ºC'),
	(203646, 120, '2014-02-15 01:22:45.000000', 'temperatura', 899.0000, 'ºC'),
	(203647, 120, '2014-02-15 01:22:46.000000', 'temperatura', 982.0000, 'ºC'),
	(203648, 120, '2014-02-15 01:22:47.000000', 'temperatura', 1016.0000, 'ºC'),
	(203649, 120, '2014-02-15 01:22:48.000000', 'temperatura', 934.0000, 'ºC'),
	(203650, 120, '2014-02-15 01:22:49.000000', 'temperatura', 421.0000, 'ºC'),
	(203651, 120, '2014-02-15 01:22:50.000000', 'temperatura', 503.0000, 'ºC'),
	(203652, 120, '2014-02-15 01:22:51.000000', 'temperatura', 55.0000, 'ºC'),
	(203653, 120, '2014-02-15 01:22:52.000000', 'temperatura', 1165.0000, 'ºC'),
	(203654, 120, '2014-02-15 01:22:53.000000', 'temperatura', 863.0000, 'ºC'),
	(203655, 120, '2014-02-15 01:22:54.000000', 'temperatura', 818.0000, 'ºC'),
	(203656, 120, '2014-02-15 01:22:55.000000', 'temperatura', 300.0000, 'ºC'),
	(203657, 120, '2014-02-15 01:22:56.000000', 'temperatura', 249.0000, 'ºC'),
	(203658, 120, '2014-02-15 01:22:57.000000', 'temperatura', 343.0000, 'ºC'),
	(203659, 120, '2014-02-15 01:22:58.000000', 'temperatura', 969.0000, 'ºC'),
	(203660, 120, '2014-02-15 01:22:59.000000', 'temperatura', 218.0000, 'ºC'),
	(203661, 120, '2014-02-15 01:23:00.000000', 'temperatura', 581.0000, 'ºC'),
	(203662, 120, '2014-02-15 01:23:01.000000', 'temperatura', 1055.0000, 'ºC'),
	(203663, 120, '2014-02-15 01:23:02.000000', 'temperatura', 1130.0000, 'ºC'),
	(203664, 120, '2014-02-15 01:23:03.000000', 'temperatura', 87.0000, 'ºC'),
	(203665, 120, '2014-02-15 01:23:04.000000', 'temperatura', 645.0000, 'ºC'),
	(203666, 120, '2014-02-15 01:23:05.000000', 'temperatura', 566.0000, 'ºC'),
	(203667, 120, '2014-02-15 01:23:06.000000', 'temperatura', 892.0000, 'ºC'),
	(203668, 120, '2014-02-15 01:23:07.000000', 'temperatura', 366.0000, 'ºC'),
	(203669, 120, '2014-02-15 01:23:08.000000', 'temperatura', 354.0000, 'ºC'),
	(203670, 120, '2014-02-15 01:23:09.000000', 'temperatura', 674.0000, 'ºC'),
	(203671, 120, '2014-02-15 01:23:10.000000', 'temperatura', 1107.0000, 'ºC'),
	(203672, 120, '2014-02-15 01:23:11.000000', 'temperatura', 1114.0000, 'ºC'),
	(203673, 120, '2014-02-15 01:23:12.000000', 'temperatura', 1049.0000, 'ºC'),
	(203674, 120, '2014-02-15 01:23:13.000000', 'temperatura', 704.0000, 'ºC'),
	(203675, 120, '2014-02-15 01:23:14.000000', 'temperatura', 372.0000, 'ºC'),
	(203676, 120, '2014-02-15 01:23:15.000000', 'temperatura', 950.0000, 'ºC'),
	(203677, 120, '2014-02-15 01:23:16.000000', 'temperatura', 32.0000, 'ºC'),
	(203678, 120, '2014-02-15 01:23:17.000000', 'temperatura', 912.0000, 'ºC'),
	(203679, 120, '2014-02-15 01:23:18.000000', 'temperatura', 865.0000, 'ºC'),
	(203680, 120, '2014-02-15 01:23:19.000000', 'temperatura', 387.0000, 'ºC'),
	(203681, 120, '2014-02-15 01:23:20.000000', 'temperatura', 543.0000, 'ºC'),
	(203682, 120, '2014-02-15 01:23:21.000000', 'temperatura', 354.0000, 'ºC'),
	(203683, 120, '2014-02-15 01:23:22.000000', 'temperatura', 142.0000, 'ºC'),
	(203684, 120, '2014-02-15 01:23:23.000000', 'temperatura', 848.0000, 'ºC'),
	(203685, 120, '2014-02-15 01:23:24.000000', 'temperatura', 214.0000, 'ºC'),
	(203686, 120, '2014-02-15 01:23:25.000000', 'temperatura', 927.0000, 'ºC'),
	(203687, 120, '2014-02-15 01:23:26.000000', 'temperatura', 394.0000, 'ºC'),
	(203688, 120, '2014-02-15 01:23:27.000000', 'temperatura', 390.0000, 'ºC'),
	(203689, 120, '2014-02-15 01:23:28.000000', 'temperatura', 768.0000, 'ºC'),
	(203690, 120, '2014-02-15 01:23:29.000000', 'temperatura', 272.0000, 'ºC'),
	(203691, 120, '2014-02-15 01:23:30.000000', 'temperatura', 256.0000, 'ºC'),
	(203692, 120, '2014-02-15 01:23:31.000000', 'temperatura', 463.0000, 'ºC'),
	(203693, 120, '2014-02-15 01:23:32.000000', 'temperatura', 348.0000, 'ºC'),
	(203694, 120, '2014-02-15 01:23:33.000000', 'temperatura', 351.0000, 'ºC'),
	(203695, 120, '2014-02-15 01:23:34.000000', 'temperatura', 713.0000, 'ºC'),
	(203696, 120, '2014-02-15 01:23:35.000000', 'temperatura', 114.0000, 'ºC'),
	(203697, 120, '2014-02-15 01:23:36.000000', 'temperatura', 828.0000, 'ºC'),
	(203698, 120, '2014-02-15 01:23:37.000000', 'temperatura', 201.0000, 'ºC'),
	(203699, 120, '2014-02-15 01:23:38.000000', 'temperatura', 919.0000, 'ºC'),
	(203700, 120, '2014-02-15 01:23:39.000000', 'temperatura', 392.0000, 'ºC'),
	(203701, 120, '2014-02-15 01:23:40.000000', 'temperatura', 405.0000, 'ºC'),
	(203702, 120, '2014-02-15 01:23:41.000000', 'temperatura', 847.0000, 'ºC'),
	(203703, 120, '2014-02-15 01:23:42.000000', 'temperatura', 624.0000, 'ºC'),
	(203704, 120, '2014-02-15 01:23:43.000000', 'temperatura', 577.0000, 'ºC'),
	(203705, 120, '2014-02-15 01:23:44.000000', 'temperatura', 1016.0000, 'ºC'),
	(203706, 120, '2014-02-15 01:23:45.000000', 'temperatura', 948.0000, 'ºC'),
	(203707, 120, '2014-02-15 01:23:46.000000', 'temperatura', 492.0000, 'ºC'),
	(203708, 120, '2014-02-15 01:23:47.000000', 'temperatura', 818.0000, 'ºC'),
	(203709, 120, '2014-02-15 01:23:48.000000', 'temperatura', 212.0000, 'ºC'),
	(203710, 120, '2014-02-15 01:23:49.000000', 'temperatura', 1006.0000, 'ºC'),
	(203711, 120, '2014-02-15 01:23:50.000000', 'temperatura', 797.0000, 'ºC'),
	(203712, 120, '2014-02-15 01:23:51.000000', 'temperatura', 968.0000, 'ºC'),
	(203713, 120, '2014-02-15 01:23:52.000000', 'temperatura', 47.0000, 'ºC'),
	(203714, 120, '2014-02-15 01:23:53.000000', 'temperatura', 932.0000, 'ºC'),
	(203715, 120, '2014-02-15 01:23:54.000000', 'temperatura', 919.0000, 'ºC'),
	(203716, 120, '2014-02-15 01:23:55.000000', 'temperatura', 599.0000, 'ºC'),
	(203717, 120, '2014-02-15 01:23:56.000000', 'temperatura', 237.0000, 'ºC'),
	(203718, 120, '2014-02-15 01:23:57.000000', 'temperatura', 591.0000, 'ºC'),
	(203719, 120, '2014-02-15 01:23:58.000000', 'temperatura', 1044.0000, 'ºC'),
	(203720, 120, '2014-02-15 01:23:59.000000', 'temperatura', 1047.0000, 'ºC'),
	(203721, 120, '2014-02-15 01:24:00.000000', 'temperatura', 903.0000, 'ºC'),
	(203722, 120, '2014-02-15 01:24:01.000000', 'temperatura', 173.0000, 'ºC'),
	(203723, 120, '2014-02-15 01:24:02.000000', 'temperatura', 560.0000, 'ºC'),
	(203724, 120, '2014-02-15 01:24:03.000000', 'temperatura', 1078.0000, 'ºC'),
	(203725, 120, '2014-02-15 01:24:04.000000', 'temperatura', 113.0000, 'ºC'),
	(203726, 120, '2014-02-15 01:24:05.000000', 'temperatura', 929.0000, 'ºC'),
	(203727, 120, '2014-02-15 01:24:06.000000', 'temperatura', 710.0000, 'ºC'),
	(203728, 120, '2014-02-15 01:24:07.000000', 'temperatura', 761.0000, 'ºC'),
	(203729, 120, '2014-02-15 01:24:08.000000', 'temperatura', 475.0000, 'ºC'),
	(203730, 120, '2014-02-15 01:24:09.000000', 'temperatura', 94.0000, 'ºC'),
	(203731, 120, '2014-02-15 01:24:10.000000', 'temperatura', 246.0000, 'ºC'),
	(203732, 120, '2014-02-15 01:24:11.000000', 'temperatura', 947.0000, 'ºC'),
	(203733, 120, '2014-02-15 01:24:12.000000', 'temperatura', 397.0000, 'ºC'),
	(203734, 120, '2014-02-15 01:24:13.000000', 'temperatura', 344.0000, 'ºC'),
	(203735, 120, '2014-02-15 01:24:14.000000', 'temperatura', 530.0000, 'ºC'),
	(203736, 120, '2014-02-15 01:24:15.000000', 'temperatura', 417.0000, 'ºC'),
	(203737, 120, '2014-02-15 01:24:16.000000', 'temperatura', 496.0000, 'ºC'),
	(203738, 120, '2014-02-15 01:24:17.000000', 'temperatura', 31.0000, 'ºC'),
	(203739, 120, '2014-02-15 01:24:18.000000', 'temperatura', 1069.0000, 'ºC'),
	(203740, 120, '2014-02-15 01:24:19.000000', 'temperatura', 449.0000, 'ºC'),
	(203741, 120, '2014-02-15 01:24:20.000000', 'temperatura', 242.0000, 'ºC'),
	(203742, 120, '2014-02-15 01:24:21.000000', 'temperatura', 1061.0000, 'ºC'),
	(203743, 120, '2014-02-15 01:24:22.000000', 'temperatura', 981.0000, 'ºC'),
	(203744, 120, '2014-02-15 01:24:23.000000', 'temperatura', 522.0000, 'ºC'),
	(203745, 120, '2014-02-15 01:24:24.000000', 'temperatura', 867.0000, 'ºC'),
	(203746, 120, '2014-02-15 01:24:25.000000', 'temperatura', 370.0000, 'ºC'),
	(203747, 120, '2014-02-15 01:24:26.000000', 'temperatura', 450.0000, 'ºC'),
	(203748, 120, '2014-02-15 01:24:27.000000', 'temperatura', 1138.0000, 'ºC'),
	(203749, 120, '2014-02-15 01:24:28.000000', 'temperatura', 742.0000, 'ºC'),
	(203750, 120, '2014-02-15 01:24:29.000000', 'temperatura', 298.0000, 'ºC'),
	(203751, 120, '2014-02-15 01:24:30.000000', 'temperatura', 462.0000, 'ºC'),
	(203752, 120, '2014-02-15 01:24:31.000000', 'temperatura', 217.0000, 'ºC'),
	(203753, 120, '2014-02-15 01:24:32.000000', 'temperatura', 901.0000, 'ºC'),
	(203754, 120, '2014-02-15 01:24:33.000000', 'temperatura', 254.0000, 'ºC'),
	(203755, 120, '2014-02-15 01:24:34.000000', 'temperatura', 969.0000, 'ºC'),
	(203756, 120, '2014-02-15 01:24:35.000000', 'temperatura', 480.0000, 'ºC'),
	(203757, 120, '2014-02-15 01:24:36.000000', 'temperatura', 696.0000, 'ºC'),
	(203758, 120, '2014-02-15 01:24:37.000000', 'temperatura', 841.0000, 'ºC'),
	(203759, 120, '2014-02-15 01:24:38.000000', 'temperatura', 915.0000, 'ºC'),
	(203760, 120, '2014-02-15 01:24:39.000000', 'temperatura', 854.0000, 'ºC'),
	(203761, 120, '2014-02-15 01:24:40.000000', 'temperatura', 324.0000, 'ºC'),
	(203762, 120, '2014-02-15 01:24:41.000000', 'temperatura', 260.0000, 'ºC'),
	(203763, 120, '2014-02-15 01:24:42.000000', 'temperatura', 327.0000, 'ºC'),
	(203764, 120, '2014-02-15 01:24:43.000000', 'temperatura', 856.0000, 'ºC'),
	(203765, 120, '2014-02-15 01:24:44.000000', 'temperatura', 901.0000, 'ºC'),
	(203766, 120, '2014-02-15 01:24:45.000000', 'temperatura', 736.0000, 'ºC'),
	(203767, 120, '2014-02-15 01:24:46.000000', 'temperatura', 977.0000, 'ºC'),
	(203768, 120, '2014-02-15 01:24:47.000000', 'temperatura', 280.0000, 'ºC'),
	(203769, 120, '2014-02-15 01:24:48.000000', 'temperatura', 867.0000, 'ºC'),
	(203770, 120, '2014-02-15 01:24:49.000000', 'temperatura', 1098.0000, 'ºC'),
	(203771, 120, '2014-02-15 01:24:50.000000', 'temperatura', 487.0000, 'ºC'),
	(203772, 120, '2014-02-15 01:24:51.000000', 'temperatura', 343.0000, 'ºC'),
	(203773, 120, '2014-02-15 01:24:52.000000', 'temperatura', 255.0000, 'ºC'),
	(203774, 120, '2014-02-15 01:24:53.000000', 'temperatura', 248.0000, 'ºC'),
	(203775, 120, '2014-02-15 01:24:54.000000', 'temperatura', 472.0000, 'ºC'),
	(203776, 120, '2014-02-15 01:24:55.000000', 'temperatura', 419.0000, 'ºC'),
	(203777, 120, '2014-02-15 01:24:56.000000', 'temperatura', 678.0000, 'ºC'),
	(203778, 120, '2014-02-15 01:24:57.000000', 'temperatura', 936.0000, 'ºC'),
	(203779, 120, '2014-02-15 01:24:58.000000', 'temperatura', 244.0000, 'ºC'),
	(203780, 120, '2014-02-15 01:24:59.000000', 'temperatura', 814.0000, 'ºC'),
	(203781, 120, '2014-02-15 01:25:00.000000', 'temperatura', 939.0000, 'ºC'),
	(203782, 120, '2014-02-15 01:25:01.000000', 'temperatura', 1051.0000, 'ºC'),
	(203783, 120, '2014-02-15 01:25:02.000000', 'temperatura', 40.0000, 'ºC'),
	(203784, 120, '2014-02-15 01:25:03.000000', 'temperatura', 646.0000, 'ºC'),
	(203785, 120, '2014-02-15 01:25:04.000000', 'temperatura', 713.0000, 'ºC'),
	(203786, 120, '2014-02-15 01:25:05.000000', 'temperatura', 426.0000, 'ºC'),
	(203787, 120, '2014-02-15 01:25:06.000000', 'temperatura', 1194.0000, 'ºC'),
	(203788, 120, '2014-02-15 01:25:07.000000', 'temperatura', 1090.0000, 'ºC'),
	(203789, 120, '2014-02-15 01:25:08.000000', 'temperatura', 668.0000, 'ºC'),
	(203790, 120, '2014-02-15 01:25:09.000000', 'temperatura', 72.0000, 'ºC'),
	(203791, 120, '2014-02-15 01:25:10.000000', 'temperatura', 756.0000, 'ºC'),
	(203792, 120, '2014-02-15 01:25:11.000000', 'temperatura', 1166.0000, 'ºC'),
	(203793, 120, '2014-02-15 01:25:12.000000', 'temperatura', 1162.0000, 'ºC'),
	(203794, 120, '2014-02-15 01:25:13.000000', 'temperatura', 1113.0000, 'ºC'),
	(203795, 120, '2014-02-15 01:25:14.000000', 'temperatura', 879.0000, 'ºC'),
	(203796, 120, '2014-02-15 01:25:15.000000', 'temperatura', 1057.0000, 'ºC'),
	(203797, 120, '2014-02-15 01:25:16.000000', 'temperatura', 247.0000, 'ºC'),
	(203798, 120, '2014-02-15 01:25:17.000000', 'temperatura', 467.0000, 'ºC'),
	(203799, 120, '2014-02-15 01:25:18.000000', 'temperatura', 392.0000, 'ºC'),
	(203800, 120, '2014-02-15 01:25:19.000000', 'temperatura', 563.0000, 'ºC'),
	(203801, 120, '2014-02-15 01:25:20.000000', 'temperatura', 436.0000, 'ºC'),
	(203802, 120, '2014-02-15 01:25:21.000000', 'temperatura', 491.0000, 'ºC'),
	(203803, 120, '2014-02-15 01:25:22.000000', 'temperatura', 1150.0000, 'ºC'),
	(203804, 120, '2014-02-15 01:25:23.000000', 'temperatura', 678.0000, 'ºC'),
	(203805, 120, '2014-02-15 01:25:24.000000', 'temperatura', 1141.0000, 'ºC'),
	(203806, 120, '2014-02-15 01:25:25.000000', 'temperatura', 69.0000, 'ºC'),
	(203807, 120, '2014-02-15 01:25:26.000000', 'temperatura', 523.0000, 'ºC'),
	(203808, 120, '2014-02-15 01:25:27.000000', 'temperatura', 7.0000, 'ºC'),
	(203809, 120, '2014-02-15 01:25:28.000000', 'temperatura', 869.0000, 'ºC'),
	(203810, 120, '2014-02-15 01:25:29.000000', 'temperatura', 723.0000, 'ºC'),
	(203811, 120, '2014-02-15 01:25:30.000000', 'temperatura', 1008.0000, 'ºC'),
	(203812, 120, '2014-02-15 01:25:31.000000', 'temperatura', 472.0000, 'ºC'),
	(203813, 120, '2014-02-15 01:25:32.000000', 'temperatura', 539.0000, 'ºC'),
	(203814, 120, '2014-02-15 01:25:33.000000', 'temperatura', 76.0000, 'ºC'),
	(203815, 120, '2014-02-15 01:25:34.000000', 'temperatura', 1165.0000, 'ºC'),
	(203816, 120, '2014-02-15 01:25:35.000000', 'temperatura', 796.0000, 'ºC'),
	(203817, 120, '2014-02-15 01:25:36.000000', 'temperatura', 484.0000, 'ºC'),
	(203818, 120, '2014-02-15 01:25:37.000000', 'temperatura', 36.0000, 'ºC'),
	(203819, 120, '2014-02-15 01:25:38.000000', 'temperatura', 1128.0000, 'ºC'),
	(203820, 120, '2014-02-15 01:25:39.000000', 'temperatura', 732.0000, 'ºC'),
	(203821, 120, '2014-02-15 01:25:40.000000', 'temperatura', 277.0000, 'ºC'),
	(203822, 121, '2014-02-15 00:00:00.000000', 'temperatura', 1111.0000, 'ºC'),
	(203823, 121, '2014-02-15 00:00:01.000000', 'temperatura', 793.0000, 'ºC'),
	(203824, 121, '2014-02-15 00:00:02.000000', 'temperatura', 629.0000, 'ºC'),
	(203825, 121, '2014-02-15 00:00:03.000000', 'temperatura', 769.0000, 'ºC'),
	(203826, 121, '2014-02-15 00:00:04.000000', 'temperatura', 756.0000, 'ºC'),
	(203827, 121, '2014-02-15 00:00:05.000000', 'temperatura', 276.0000, 'ºC'),
	(203828, 121, '2014-02-15 00:00:06.000000', 'temperatura', 312.0000, 'ºC'),
	(203829, 121, '2014-02-15 00:00:07.000000', 'temperatura', 733.0000, 'ºC'),
	(203830, 121, '2014-02-15 00:00:08.000000', 'temperatura', 328.0000, 'ºC'),
	(203831, 121, '2014-02-15 00:00:09.000000', 'temperatura', 644.0000, 'ºC'),
	(203832, 121, '2014-02-15 00:00:10.000000', 'temperatura', 1034.0000, 'ºC'),
	(203833, 121, '2014-02-15 00:00:11.000000', 'temperatura', 839.0000, 'ºC'),
	(203834, 121, '2014-02-15 00:00:12.000000', 'temperatura', 1094.0000, 'ºC'),
	(203835, 121, '2014-02-15 00:00:13.000000', 'temperatura', 554.0000, 'ºC'),
	(203836, 121, '2014-02-15 00:00:14.000000', 'temperatura', 686.0000, 'ºC'),
	(203837, 121, '2014-02-15 00:00:15.000000', 'temperatura', 572.0000, 'ºC'),
	(203838, 121, '2014-02-15 00:00:16.000000', 'temperatura', 800.0000, 'ºC'),
	(203839, 121, '2014-02-15 00:00:17.000000', 'temperatura', 1087.0000, 'ºC'),
	(203840, 121, '2014-02-15 00:00:18.000000', 'temperatura', 632.0000, 'ºC'),
	(203841, 121, '2014-02-15 00:00:19.000000', 'temperatura', 1102.0000, 'ºC'),
	(203842, 121, '2014-02-15 00:00:20.000000', 'temperatura', 15.0000, 'ºC'),
	(203843, 121, '2014-02-15 00:00:21.000000', 'temperatura', 371.0000, 'ºC'),
	(203844, 121, '2014-02-15 00:00:22.000000', 'temperatura', 607.0000, 'ºC'),
	(203845, 121, '2014-02-15 00:00:23.000000', 'temperatura', 724.0000, 'ºC'),
	(203846, 121, '2014-02-15 00:00:24.000000', 'temperatura', 599.0000, 'ºC'),
	(203847, 121, '2014-02-15 00:00:25.000000', 'temperatura', 822.0000, 'ºC'),
	(203848, 121, '2014-02-15 00:00:26.000000', 'temperatura', 1116.0000, 'ºC'),
	(203849, 121, '2014-02-15 00:00:27.000000', 'temperatura', 713.0000, 'ºC'),
	(203850, 121, '2014-02-15 00:00:28.000000', 'temperatura', 219.0000, 'ºC'),
	(203851, 121, '2014-02-15 00:00:29.000000', 'temperatura', 156.0000, 'ºC'),
	(203852, 121, '2014-02-15 00:00:30.000000', 'temperatura', 125.0000, 'ºC'),
	(203853, 121, '2014-02-15 00:00:31.000000', 'temperatura', 158.0000, 'ºC'),
	(203854, 121, '2014-02-15 00:00:32.000000', 'temperatura', 415.0000, 'ºC'),
	(203855, 121, '2014-02-15 00:00:33.000000', 'temperatura', 400.0000, 'ºC'),
	(203856, 121, '2014-02-15 00:00:34.000000', 'temperatura', 758.0000, 'ºC'),
	(203857, 121, '2014-02-15 00:00:35.000000', 'temperatura', 188.0000, 'ºC'),
	(203858, 121, '2014-02-15 00:00:36.000000', 'temperatura', 1069.0000, 'ºC'),
	(203859, 121, '2014-02-15 00:00:37.000000', 'temperatura', 1179.0000, 'ºC'),
	(203860, 121, '2014-02-15 00:00:38.000000', 'temperatura', 291.0000, 'ºC'),
	(203861, 121, '2014-02-15 00:00:39.000000', 'temperatura', 316.0000, 'ºC'),
	(203862, 121, '2014-02-15 00:00:40.000000', 'temperatura', 708.0000, 'ºC'),
	(203863, 121, '2014-02-15 00:00:41.000000', 'temperatura', 194.0000, 'ºC'),
	(203864, 121, '2014-02-15 00:00:42.000000', 'temperatura', 44.0000, 'ºC'),
	(203865, 121, '2014-02-15 00:00:43.000000', 'temperatura', 840.0000, 'ºC'),
	(203866, 121, '2014-02-15 00:00:44.000000', 'temperatura', 466.0000, 'ºC'),
	(203867, 121, '2014-02-15 00:00:45.000000', 'temperatura', 1014.0000, 'ºC'),
	(203868, 121, '2014-02-15 00:00:46.000000', 'temperatura', 71.0000, 'ºC'),
	(203869, 121, '2014-02-15 00:00:47.000000', 'temperatura', 912.0000, 'ºC'),
	(203870, 121, '2014-02-15 00:00:48.000000', 'temperatura', 747.0000, 'ºC'),
	(203871, 121, '2014-02-15 00:00:49.000000', 'temperatura', 1000.0000, 'ºC'),
	(203872, 121, '2014-02-15 00:00:50.000000', 'temperatura', 359.0000, 'ºC'),
	(203873, 121, '2014-02-15 00:00:51.000000', 'temperatura', 1196.0000, 'ºC'),
	(203874, 121, '2014-02-15 00:00:52.000000', 'temperatura', 103.0000, 'ºC'),
	(203875, 121, '2014-02-15 00:00:53.000000', 'temperatura', 527.0000, 'ºC'),
	(203876, 121, '2014-02-15 00:00:54.000000', 'temperatura', 1126.0000, 'ºC'),
	(203877, 121, '2014-02-15 00:00:55.000000', 'temperatura', 452.0000, 'ºC'),
	(203878, 121, '2014-02-15 00:00:56.000000', 'temperatura', 80.0000, 'ºC'),
	(203879, 121, '2014-02-15 00:00:57.000000', 'temperatura', 246.0000, 'ºC'),
	(203880, 121, '2014-02-15 00:00:58.000000', 'temperatura', 991.0000, 'ºC'),
	(203881, 121, '2014-02-15 00:00:59.000000', 'temperatura', 615.0000, 'ºC'),
	(203882, 121, '2014-02-15 00:01:00.000000', 'temperatura', 105.0000, 'ºC'),
	(203883, 121, '2014-02-15 00:01:01.000000', 'temperatura', 1081.0000, 'ºC'),
	(203884, 121, '2014-02-15 00:01:02.000000', 'temperatura', 289.0000, 'ºC'),
	(203885, 121, '2014-02-15 00:01:03.000000', 'temperatura', 601.0000, 'ºC'),
	(203886, 121, '2014-02-15 00:01:04.000000', 'temperatura', 942.0000, 'ºC'),
	(203887, 121, '2014-02-15 00:01:05.000000', 'temperatura', 506.0000, 'ºC'),
	(203888, 121, '2014-02-15 00:01:06.000000', 'temperatura', 903.0000, 'ºC'),
	(203889, 121, '2014-02-15 00:01:07.000000', 'temperatura', 599.0000, 'ºC'),
	(203890, 121, '2014-02-15 00:01:08.000000', 'temperatura', 287.0000, 'ºC'),
	(203891, 121, '2014-02-15 00:01:09.000000', 'temperatura', 839.0000, 'ºC'),
	(203892, 121, '2014-02-15 00:01:10.000000', 'temperatura', 933.0000, 'ºC'),
	(203893, 121, '2014-02-15 00:01:11.000000', 'temperatura', 949.0000, 'ºC'),
	(203894, 121, '2014-02-15 00:01:12.000000', 'temperatura', 746.0000, 'ºC'),
	(203895, 121, '2014-02-15 00:01:13.000000', 'temperatura', 883.0000, 'ºC'),
	(203896, 121, '2014-02-15 00:01:14.000000', 'temperatura', 976.0000, 'ºC'),
	(203897, 121, '2014-02-15 00:01:15.000000', 'temperatura', 1034.0000, 'ºC'),
	(203898, 121, '2014-02-15 00:01:16.000000', 'temperatura', 1041.0000, 'ºC'),
	(203899, 121, '2014-02-15 00:01:17.000000', 'temperatura', 902.0000, 'ºC'),
	(203900, 121, '2014-02-15 00:01:18.000000', 'temperatura', 190.0000, 'ºC'),
	(203901, 121, '2014-02-15 00:01:19.000000', 'temperatura', 643.0000, 'ºC'),
	(203902, 121, '2014-02-15 00:01:20.000000', 'temperatura', 248.0000, 'ºC'),
	(203903, 121, '2014-02-15 00:01:21.000000', 'temperatura', 508.0000, 'ºC'),
	(203904, 121, '2014-02-15 00:01:22.000000', 'temperatura', 599.0000, 'ºC'),
	(203905, 121, '2014-02-15 00:01:23.000000', 'temperatura', 273.0000, 'ºC'),
	(203906, 121, '2014-02-15 00:01:24.000000', 'temperatura', 766.0000, 'ºC'),
	(203907, 121, '2014-02-15 00:01:25.000000', 'temperatura', 611.0000, 'ºC'),
	(203908, 121, '2014-02-15 00:01:26.000000', 'temperatura', 757.0000, 'ºC'),
	(203909, 121, '2014-02-15 00:01:27.000000', 'temperatura', 754.0000, 'ºC'),
	(203910, 121, '2014-02-15 00:01:28.000000', 'temperatura', 297.0000, 'ºC'),
	(203911, 121, '2014-02-15 00:01:29.000000', 'temperatura', 427.0000, 'ºC'),
	(203912, 121, '2014-02-15 00:01:30.000000', 'temperatura', 43.0000, 'ºC'),
	(203913, 121, '2014-02-15 00:01:31.000000', 'temperatura', 137.0000, 'ºC'),
	(203914, 121, '2014-02-15 00:01:32.000000', 'temperatura', 553.0000, 'ºC'),
	(203915, 121, '2014-02-15 00:01:33.000000', 'temperatura', 1157.0000, 'ºC'),
	(203916, 121, '2014-02-15 00:01:34.000000', 'temperatura', 524.0000, 'ºC'),
	(203917, 121, '2014-02-15 00:01:35.000000', 'temperatura', 350.0000, 'ºC'),
	(203918, 121, '2014-02-15 00:01:36.000000', 'temperatura', 181.0000, 'ºC'),
	(203919, 121, '2014-02-15 00:01:37.000000', 'temperatura', 1053.0000, 'ºC'),
	(203920, 121, '2014-02-15 00:01:38.000000', 'temperatura', 1124.0000, 'ºC'),
	(203921, 121, '2014-02-15 00:01:39.000000', 'temperatura', 63.0000, 'ºC'),
	(203922, 121, '2014-02-15 00:01:40.000000', 'temperatura', 541.0000, 'ºC'),
	(203923, 121, '2014-02-15 00:01:41.000000', 'temperatura', 116.0000, 'ºC'),
	(203924, 121, '2014-02-15 00:01:42.000000', 'temperatura', 156.0000, 'ºC'),
	(203925, 121, '2014-02-15 00:01:43.000000', 'temperatura', 435.0000, 'ºC'),
	(203926, 121, '2014-02-15 00:01:44.000000', 'temperatura', 508.0000, 'ºC'),
	(203927, 121, '2014-02-15 00:01:45.000000', 'temperatura', 34.0000, 'ºC'),
	(203928, 121, '2014-02-15 00:01:46.000000', 'temperatura', 1049.0000, 'ºC'),
	(203929, 121, '2014-02-15 00:01:47.000000', 'temperatura', 341.0000, 'ºC'),
	(203930, 121, '2014-02-15 00:01:48.000000', 'temperatura', 960.0000, 'ºC'),
	(203931, 121, '2014-02-15 00:01:49.000000', 'temperatura', 178.0000, 'ºC'),
	(203932, 121, '2014-02-15 00:01:50.000000', 'temperatura', 408.0000, 'ºC'),
	(203933, 121, '2014-02-15 00:01:51.000000', 'temperatura', 307.0000, 'ºC'),
	(203934, 121, '2014-02-15 00:01:52.000000', 'temperatura', 313.0000, 'ºC'),
	(203935, 121, '2014-02-15 00:01:53.000000', 'temperatura', 644.0000, 'ºC'),
	(203936, 121, '2014-02-15 00:01:54.000000', 'temperatura', 1083.0000, 'ºC'),
	(203937, 121, '2014-02-15 00:01:55.000000', 'temperatura', 1084.0000, 'ºC'),
	(203938, 121, '2014-02-15 00:01:56.000000', 'temperatura', 970.0000, 'ºC'),
	(203939, 121, '2014-02-15 00:01:57.000000', 'temperatura', 398.0000, 'ºC'),
	(203940, 121, '2014-02-15 00:01:58.000000', 'temperatura', 281.0000, 'ºC'),
	(203941, 121, '2014-02-15 00:01:59.000000', 'temperatura', 213.0000, 'ºC'),
	(203942, 121, '2014-02-15 00:02:00.000000', 'temperatura', 222.0000, 'ºC'),
	(203943, 121, '2014-02-15 00:02:01.000000', 'temperatura', 473.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(203944, 121, '2014-02-15 00:02:02.000000', 'temperatura', 497.0000, 'ºC'),
	(203945, 121, '2014-02-15 00:02:03.000000', 'temperatura', 1068.0000, 'ºC'),
	(203946, 121, '2014-02-15 00:02:04.000000', 'temperatura', 248.0000, 'ºC'),
	(203947, 121, '2014-02-15 00:02:05.000000', 'temperatura', 437.0000, 'ºC'),
	(203948, 121, '2014-02-15 00:02:06.000000', 'temperatura', 240.0000, 'ºC'),
	(203949, 121, '2014-02-15 00:02:07.000000', 'temperatura', 1091.0000, 'ºC'),
	(203950, 121, '2014-02-15 00:02:08.000000', 'temperatura', 1136.0000, 'ºC'),
	(203951, 121, '2014-02-15 00:02:09.000000', 'temperatura', 6.0000, 'ºC'),
	(203952, 121, '2014-02-15 00:02:10.000000', 'temperatura', 221.0000, 'ºC'),
	(203953, 121, '2014-02-15 00:02:11.000000', 'temperatura', 1090.0000, 'ºC'),
	(203954, 121, '2014-02-15 00:02:12.000000', 'temperatura', 1189.0000, 'ºC'),
	(203955, 121, '2014-02-15 00:02:13.000000', 'temperatura', 272.0000, 'ºC'),
	(203956, 121, '2014-02-15 00:02:14.000000', 'temperatura', 195.0000, 'ºC'),
	(203957, 121, '2014-02-15 00:02:15.000000', 'temperatura', 158.0000, 'ºC'),
	(203958, 121, '2014-02-15 00:02:16.000000', 'temperatura', 207.0000, 'ºC'),
	(203959, 121, '2014-02-15 00:02:17.000000', 'temperatura', 560.0000, 'ºC'),
	(203960, 121, '2014-02-15 00:02:18.000000', 'temperatura', 980.0000, 'ºC'),
	(203961, 121, '2014-02-15 00:02:19.000000', 'temperatura', 821.0000, 'ºC'),
	(203962, 121, '2014-02-15 00:02:20.000000', 'temperatura', 1163.0000, 'ºC'),
	(203963, 121, '2014-02-15 00:02:21.000000', 'temperatura', 955.0000, 'ºC'),
	(203964, 121, '2014-02-15 00:02:22.000000', 'temperatura', 85.0000, 'ºC'),
	(203965, 121, '2014-02-15 00:02:23.000000', 'temperatura', 1163.0000, 'ºC'),
	(203966, 121, '2014-02-15 00:02:24.000000', 'temperatura', 757.0000, 'ºC'),
	(203967, 121, '2014-02-15 00:02:25.000000', 'temperatura', 300.0000, 'ºC'),
	(203968, 121, '2014-02-15 00:02:26.000000', 'temperatura', 427.0000, 'ºC'),
	(203969, 121, '2014-02-15 00:02:27.000000', 'temperatura', 36.0000, 'ºC'),
	(203970, 121, '2014-02-15 00:02:28.000000', 'temperatura', 102.0000, 'ºC'),
	(203971, 121, '2014-02-15 00:02:29.000000', 'temperatura', 399.0000, 'ºC'),
	(203972, 121, '2014-02-15 00:02:30.000000', 'temperatura', 493.0000, 'ºC'),
	(203973, 121, '2014-02-15 00:02:31.000000', 'temperatura', 66.0000, 'ºC'),
	(203974, 121, '2014-02-15 00:02:32.000000', 'temperatura', 50.0000, 'ºC'),
	(203975, 121, '2014-02-15 00:02:33.000000', 'temperatura', 55.0000, 'ºC'),
	(203976, 121, '2014-02-15 00:02:34.000000', 'temperatura', 126.0000, 'ºC'),
	(203977, 121, '2014-02-15 00:02:35.000000', 'temperatura', 464.0000, 'ºC'),
	(203978, 121, '2014-02-15 00:02:36.000000', 'temperatura', 743.0000, 'ºC'),
	(203979, 121, '2014-02-15 00:02:37.000000', 'temperatura', 1123.0000, 'ºC'),
	(203980, 121, '2014-02-15 00:02:38.000000', 'temperatura', 987.0000, 'ºC'),
	(203981, 121, '2014-02-15 00:02:39.000000', 'temperatura', 364.0000, 'ºC'),
	(203982, 121, '2014-02-15 00:02:40.000000', 'temperatura', 63.0000, 'ºC'),
	(203983, 121, '2014-02-15 00:02:41.000000', 'temperatura', 421.0000, 'ºC'),
	(203984, 121, '2014-02-15 00:02:42.000000', 'temperatura', 718.0000, 'ºC'),
	(203985, 121, '2014-02-15 00:02:43.000000', 'temperatura', 1128.0000, 'ºC'),
	(203986, 121, '2014-02-15 00:02:44.000000', 'temperatura', 1086.0000, 'ºC'),
	(203987, 121, '2014-02-15 00:02:45.000000', 'temperatura', 847.0000, 'ºC'),
	(203988, 121, '2014-02-15 00:02:46.000000', 'temperatura', 976.0000, 'ºC'),
	(203989, 121, '2014-02-15 00:02:47.000000', 'temperatura', 1139.0000, 'ºC'),
	(203990, 121, '2014-02-15 00:02:48.000000', 'temperatura', 368.0000, 'ºC'),
	(203991, 121, '2014-02-15 00:02:49.000000', 'temperatura', 825.0000, 'ºC'),
	(203992, 121, '2014-02-15 00:02:50.000000', 'temperatura', 619.0000, 'ºC'),
	(203993, 121, '2014-02-15 00:02:51.000000', 'temperatura', 622.0000, 'ºC'),
	(203994, 121, '2014-02-15 00:02:52.000000', 'temperatura', 51.0000, 'ºC'),
	(203995, 121, '2014-02-15 00:02:53.000000', 'temperatura', 793.0000, 'ºC'),
	(203996, 121, '2014-02-15 00:02:54.000000', 'temperatura', 209.0000, 'ºC'),
	(203997, 121, '2014-02-15 00:02:55.000000', 'temperatura', 1070.0000, 'ºC'),
	(203998, 121, '2014-02-15 00:02:56.000000', 'temperatura', 1122.0000, 'ºC'),
	(203999, 121, '2014-02-15 00:02:57.000000', 'temperatura', 2.0000, 'ºC'),
	(204000, 121, '2014-02-15 00:02:58.000000', 'temperatura', 241.0000, 'ºC'),
	(204001, 121, '2014-02-15 00:02:59.000000', 'temperatura', 3.0000, 'ºC'),
	(204002, 121, '2014-02-15 00:03:00.000000', 'temperatura', 493.0000, 'ºC'),
	(204003, 121, '2014-02-15 00:03:01.000000', 'temperatura', 54.0000, 'ºC'),
	(204004, 121, '2014-02-15 00:03:02.000000', 'temperatura', 1194.0000, 'ºC'),
	(204005, 121, '2014-02-15 00:03:03.000000', 'temperatura', 1006.0000, 'ºC'),
	(204006, 121, '2014-02-15 00:03:04.000000', 'temperatura', 250.0000, 'ºC'),
	(204007, 121, '2014-02-15 00:03:05.000000', 'temperatura', 631.0000, 'ºC'),
	(204008, 121, '2014-02-15 00:03:06.000000', 'temperatura', 6.0000, 'ºC'),
	(204009, 121, '2014-02-15 00:03:07.000000', 'temperatura', 537.0000, 'ºC'),
	(204010, 121, '2014-02-15 00:03:08.000000', 'temperatura', 267.0000, 'ºC'),
	(204011, 121, '2014-02-15 00:03:09.000000', 'temperatura', 927.0000, 'ºC'),
	(204012, 121, '2014-02-15 00:03:10.000000', 'temperatura', 233.0000, 'ºC'),
	(204013, 121, '2014-02-15 00:03:11.000000', 'temperatura', 783.0000, 'ºC'),
	(204014, 121, '2014-02-15 00:03:12.000000', 'temperatura', 819.0000, 'ºC'),
	(204015, 121, '2014-02-15 00:03:13.000000', 'temperatura', 544.0000, 'ºC'),
	(204016, 121, '2014-02-15 00:03:14.000000', 'temperatura', 267.0000, 'ºC'),
	(204017, 121, '2014-02-15 00:03:15.000000', 'temperatura', 900.0000, 'ºC'),
	(204018, 121, '2014-02-15 00:03:16.000000', 'temperatura', 102.0000, 'ºC'),
	(204019, 121, '2014-02-15 00:03:17.000000', 'temperatura', 211.0000, 'ºC'),
	(204020, 121, '2014-02-15 00:03:18.000000', 'temperatura', 748.0000, 'ºC'),
	(204021, 121, '2014-02-15 00:03:19.000000', 'temperatura', 708.0000, 'ºC'),
	(204022, 121, '2014-02-15 00:03:20.000000', 'temperatura', 95.0000, 'ºC'),
	(204023, 121, '2014-02-15 00:03:21.000000', 'temperatura', 754.0000, 'ºC'),
	(204024, 121, '2014-02-15 00:03:22.000000', 'temperatura', 1084.0000, 'ºC'),
	(204025, 121, '2014-02-15 00:03:23.000000', 'temperatura', 757.0000, 'ºC'),
	(204026, 121, '2014-02-15 00:03:24.000000', 'temperatura', 537.0000, 'ºC'),
	(204027, 121, '2014-02-15 00:03:25.000000', 'temperatura', 412.0000, 'ºC'),
	(204028, 121, '2014-02-15 00:03:26.000000', 'temperatura', 449.0000, 'ºC'),
	(204029, 121, '2014-02-15 00:03:27.000000', 'temperatura', 1012.0000, 'ºC'),
	(204030, 121, '2014-02-15 00:03:28.000000', 'temperatura', 113.0000, 'ºC'),
	(204031, 121, '2014-02-15 00:03:29.000000', 'temperatura', 1131.0000, 'ºC'),
	(204032, 121, '2014-02-15 00:03:30.000000', 'temperatura', 515.0000, 'ºC'),
	(204033, 121, '2014-02-15 00:03:31.000000', 'temperatura', 383.0000, 'ºC'),
	(204034, 121, '2014-02-15 00:03:32.000000', 'temperatura', 369.0000, 'ºC'),
	(204035, 121, '2014-02-15 00:03:33.000000', 'temperatura', 696.0000, 'ºC'),
	(204036, 121, '2014-02-15 00:03:34.000000', 'temperatura', 1176.0000, 'ºC'),
	(204037, 121, '2014-02-15 00:03:35.000000', 'temperatura', 189.0000, 'ºC'),
	(204038, 121, '2014-02-15 00:03:36.000000', 'temperatura', 1021.0000, 'ºC'),
	(204039, 121, '2014-02-15 00:03:37.000000', 'temperatura', 936.0000, 'ºC'),
	(204040, 121, '2014-02-15 00:03:38.000000', 'temperatura', 418.0000, 'ºC'),
	(204041, 121, '2014-02-15 00:03:39.000000', 'temperatura', 481.0000, 'ºC'),
	(204042, 121, '2014-02-15 00:03:40.000000', 'temperatura', 1153.0000, 'ºC'),
	(204043, 121, '2014-02-15 00:03:41.000000', 'temperatura', 721.0000, 'ºC'),
	(204044, 121, '2014-02-15 00:03:42.000000', 'temperatura', 149.0000, 'ºC'),
	(204045, 121, '2014-02-15 00:03:43.000000', 'temperatura', 980.0000, 'ºC'),
	(204046, 121, '2014-02-15 00:03:44.000000', 'temperatura', 856.0000, 'ºC'),
	(204047, 121, '2014-02-15 00:03:45.000000', 'temperatura', 139.0000, 'ºC'),
	(204048, 121, '2014-02-15 00:03:46.000000', 'temperatura', 529.0000, 'ºC'),
	(204049, 121, '2014-02-15 00:03:47.000000', 'temperatura', 1027.0000, 'ºC'),
	(204050, 121, '2014-02-15 00:03:48.000000', 'temperatura', 1147.0000, 'ºC'),
	(204051, 121, '2014-02-15 00:03:49.000000', 'temperatura', 258.0000, 'ºC'),
	(204052, 121, '2014-02-15 00:03:50.000000', 'temperatura', 248.0000, 'ºC'),
	(204053, 121, '2014-02-15 00:03:51.000000', 'temperatura', 466.0000, 'ºC'),
	(204054, 121, '2014-02-15 00:03:52.000000', 'temperatura', 389.0000, 'ºC'),
	(204055, 121, '2014-02-15 00:03:53.000000', 'temperatura', 545.0000, 'ºC'),
	(204056, 121, '2014-02-15 00:03:54.000000', 'temperatura', 358.0000, 'ºC'),
	(204057, 121, '2014-02-15 00:03:55.000000', 'temperatura', 154.0000, 'ºC'),
	(204058, 121, '2014-02-15 00:03:56.000000', 'temperatura', 900.0000, 'ºC'),
	(204059, 121, '2014-02-15 00:03:57.000000', 'temperatura', 436.0000, 'ºC'),
	(204060, 121, '2014-02-15 00:03:58.000000', 'temperatura', 681.0000, 'ºC'),
	(204061, 121, '2014-02-15 00:03:59.000000', 'temperatura', 896.0000, 'ºC'),
	(204062, 121, '2014-02-15 00:04:00.000000', 'temperatura', 39.0000, 'ºC'),
	(204063, 121, '2014-02-15 00:04:01.000000', 'temperatura', 1108.0000, 'ºC'),
	(204064, 121, '2014-02-15 00:04:02.000000', 'temperatura', 623.0000, 'ºC'),
	(204065, 121, '2014-02-15 00:04:03.000000', 'temperatura', 991.0000, 'ºC'),
	(204066, 121, '2014-02-15 00:04:04.000000', 'temperatura', 687.0000, 'ºC'),
	(204067, 121, '2014-02-15 00:04:05.000000', 'temperatura', 463.0000, 'ºC'),
	(204068, 121, '2014-02-15 00:04:06.000000', 'temperatura', 254.0000, 'ºC'),
	(204069, 121, '2014-02-15 00:04:07.000000', 'temperatura', 1080.0000, 'ºC'),
	(204070, 121, '2014-02-15 00:04:08.000000', 'temperatura', 1041.0000, 'ºC'),
	(204071, 121, '2014-02-15 00:04:09.000000', 'temperatura', 764.0000, 'ºC'),
	(204072, 121, '2014-02-15 00:04:10.000000', 'temperatura', 696.0000, 'ºC'),
	(204073, 121, '2014-02-15 00:04:11.000000', 'temperatura', 1192.0000, 'ºC'),
	(204074, 121, '2014-02-15 00:04:12.000000', 'temperatura', 269.0000, 'ºC'),
	(204075, 121, '2014-02-15 00:04:13.000000', 'temperatura', 172.0000, 'ºC'),
	(204076, 121, '2014-02-15 00:04:14.000000', 'temperatura', 54.0000, 'ºC'),
	(204077, 121, '2014-02-15 00:04:15.000000', 'temperatura', 954.0000, 'ºC'),
	(204078, 121, '2014-02-15 00:04:16.000000', 'temperatura', 1008.0000, 'ºC'),
	(204079, 121, '2014-02-15 00:04:17.000000', 'temperatura', 978.0000, 'ºC'),
	(204080, 121, '2014-02-15 00:04:18.000000', 'temperatura', 666.0000, 'ºC'),
	(204081, 121, '2014-02-15 00:04:19.000000', 'temperatura', 398.0000, 'ºC'),
	(204082, 121, '2014-02-15 00:04:20.000000', 'temperatura', 1190.0000, 'ºC'),
	(204083, 121, '2014-02-15 00:04:21.000000', 'temperatura', 1157.0000, 'ºC'),
	(204084, 121, '2014-02-15 00:04:22.000000', 'temperatura', 1018.0000, 'ºC'),
	(204085, 121, '2014-02-15 00:04:23.000000', 'temperatura', 416.0000, 'ºC'),
	(204086, 121, '2014-02-15 00:04:24.000000', 'temperatura', 228.0000, 'ºC'),
	(204087, 121, '2014-02-15 00:04:25.000000', 'temperatura', 1094.0000, 'ºC'),
	(204088, 121, '2014-02-15 00:04:26.000000', 'temperatura', 1184.0000, 'ºC'),
	(204089, 121, '2014-02-15 00:04:27.000000', 'temperatura', 241.0000, 'ºC'),
	(204090, 121, '2014-02-15 00:04:28.000000', 'temperatura', 54.0000, 'ºC'),
	(204091, 121, '2014-02-15 00:04:29.000000', 'temperatura', 744.0000, 'ºC'),
	(204092, 121, '2014-02-15 00:04:30.000000', 'temperatura', 1162.0000, 'ºC'),
	(204093, 121, '2014-02-15 00:04:31.000000', 'temperatura', 1176.0000, 'ºC'),
	(204094, 121, '2014-02-15 00:04:32.000000', 'temperatura', 1196.0000, 'ºC'),
	(204095, 121, '2014-02-15 00:04:33.000000', 'temperatura', 51.0000, 'ºC'),
	(204096, 121, '2014-02-15 00:04:34.000000', 'temperatura', 267.0000, 'ºC'),
	(204097, 121, '2014-02-15 00:04:35.000000', 'temperatura', 1185.0000, 'ºC'),
	(204098, 121, '2014-02-15 00:04:36.000000', 'temperatura', 325.0000, 'ºC'),
	(204099, 121, '2014-02-15 00:04:37.000000', 'temperatura', 470.0000, 'ºC'),
	(204100, 121, '2014-02-15 00:04:38.000000', 'temperatura', 174.0000, 'ºC'),
	(204101, 121, '2014-02-15 00:04:39.000000', 'temperatura', 663.0000, 'ºC'),
	(204102, 121, '2014-02-15 00:04:40.000000', 'temperatura', 393.0000, 'ºC'),
	(204103, 121, '2014-02-15 00:04:41.000000', 'temperatura', 1175.0000, 'ºC'),
	(204104, 121, '2014-02-15 00:04:42.000000', 'temperatura', 1099.0000, 'ºC'),
	(204105, 121, '2014-02-15 00:04:43.000000', 'temperatura', 769.0000, 'ºC'),
	(204106, 121, '2014-02-15 00:04:44.000000', 'temperatura', 551.0000, 'ºC'),
	(204107, 121, '2014-02-15 00:04:45.000000', 'temperatura', 446.0000, 'ºC'),
	(204108, 121, '2014-02-15 00:04:46.000000', 'temperatura', 578.0000, 'ºC'),
	(204109, 121, '2014-02-15 00:04:47.000000', 'temperatura', 354.0000, 'ºC'),
	(204110, 121, '2014-02-15 00:04:48.000000', 'temperatura', 35.0000, 'ºC'),
	(204111, 121, '2014-02-15 00:04:49.000000', 'temperatura', 315.0000, 'ºC'),
	(204112, 121, '2014-02-15 00:04:50.000000', 'temperatura', 271.0000, 'ºC'),
	(204113, 121, '2014-02-15 00:04:51.000000', 'temperatura', 411.0000, 'ºC'),
	(204114, 121, '2014-02-15 00:04:52.000000', 'temperatura', 44.0000, 'ºC'),
	(204115, 121, '2014-02-15 00:04:53.000000', 'temperatura', 184.0000, 'ºC'),
	(204116, 121, '2014-02-15 00:04:54.000000', 'temperatura', 790.0000, 'ºC'),
	(204117, 121, '2014-02-15 00:04:55.000000', 'temperatura', 998.0000, 'ºC'),
	(204118, 121, '2014-02-15 00:04:56.000000', 'temperatura', 220.0000, 'ºC'),
	(204119, 121, '2014-02-15 00:04:57.000000', 'temperatura', 508.0000, 'ºC'),
	(204120, 121, '2014-02-15 00:04:58.000000', 'temperatura', 680.0000, 'ºC'),
	(204121, 121, '2014-02-15 00:04:59.000000', 'temperatura', 676.0000, 'ºC'),
	(204122, 121, '2014-02-15 00:05:00.000000', 'temperatura', 140.0000, 'ºC'),
	(204123, 121, '2014-02-15 00:05:01.000000', 'temperatura', 1072.0000, 'ºC'),
	(204124, 121, '2014-02-15 00:05:02.000000', 'temperatura', 139.0000, 'ºC'),
	(204125, 121, '2014-02-15 00:05:03.000000', 'temperatura', 1082.0000, 'ºC'),
	(204126, 121, '2014-02-15 00:05:04.000000', 'temperatura', 192.0000, 'ºC'),
	(204127, 121, '2014-02-15 00:05:05.000000', 'temperatura', 115.0000, 'ºC'),
	(204128, 121, '2014-02-15 00:05:06.000000', 'temperatura', 1199.0000, 'ºC'),
	(204129, 121, '2014-02-15 00:05:07.000000', 'temperatura', 851.0000, 'ºC'),
	(204130, 121, '2014-02-15 00:05:08.000000', 'temperatura', 659.0000, 'ºC'),
	(204131, 121, '2014-02-15 00:05:09.000000', 'temperatura', 740.0000, 'ºC'),
	(204132, 121, '2014-02-15 00:05:10.000000', 'temperatura', 525.0000, 'ºC'),
	(204133, 121, '2014-02-15 00:05:11.000000', 'temperatura', 406.0000, 'ºC'),
	(204134, 121, '2014-02-15 00:05:12.000000', 'temperatura', 456.0000, 'ºC'),
	(204135, 121, '2014-02-15 00:05:13.000000', 'temperatura', 1062.0000, 'ºC'),
	(204136, 121, '2014-02-15 00:05:14.000000', 'temperatura', 341.0000, 'ºC'),
	(204137, 121, '2014-02-15 00:05:15.000000', 'temperatura', 919.0000, 'ºC'),
	(204138, 121, '2014-02-15 00:05:16.000000', 'temperatura', 1173.0000, 'ºC'),
	(204139, 121, '2014-02-15 00:05:17.000000', 'temperatura', 709.0000, 'ºC'),
	(204140, 121, '2014-02-15 00:05:18.000000', 'temperatura', 27.0000, 'ºC'),
	(204141, 121, '2014-02-15 00:05:19.000000', 'temperatura', 406.0000, 'ºC'),
	(204142, 121, '2014-02-15 00:05:20.000000', 'temperatura', 751.0000, 'ºC'),
	(204143, 121, '2014-02-15 00:05:21.000000', 'temperatura', 138.0000, 'ºC'),
	(204144, 121, '2014-02-15 00:05:22.000000', 'temperatura', 836.0000, 'ºC'),
	(204145, 121, '2014-02-15 00:05:23.000000', 'temperatura', 165.0000, 'ºC'),
	(204146, 121, '2014-02-15 00:05:24.000000', 'temperatura', 721.0000, 'ºC'),
	(204147, 121, '2014-02-15 00:05:25.000000', 'temperatura', 708.0000, 'ºC'),
	(204148, 121, '2014-02-15 00:05:26.000000', 'temperatura', 180.0000, 'ºC'),
	(204149, 121, '2014-02-15 00:05:27.000000', 'temperatura', 1174.0000, 'ºC'),
	(204150, 121, '2014-02-15 00:05:28.000000', 'temperatura', 533.0000, 'ºC'),
	(204151, 121, '2014-02-15 00:05:29.000000', 'temperatura', 344.0000, 'ºC'),
	(204152, 121, '2014-02-15 00:05:30.000000', 'temperatura', 120.0000, 'ºC'),
	(204153, 121, '2014-02-15 00:05:31.000000', 'temperatura', 768.0000, 'ºC'),
	(204154, 121, '2014-02-15 00:05:32.000000', 'temperatura', 1080.0000, 'ºC'),
	(204155, 121, '2014-02-15 00:05:33.000000', 'temperatura', 697.0000, 'ºC'),
	(204156, 121, '2014-02-15 00:05:34.000000', 'temperatura', 246.0000, 'ºC'),
	(204157, 121, '2014-02-15 00:05:35.000000', 'temperatura', 339.0000, 'ºC'),
	(204158, 121, '2014-02-15 00:05:36.000000', 'temperatura', 957.0000, 'ºC'),
	(204159, 121, '2014-02-15 00:05:37.000000', 'temperatura', 169.0000, 'ºC'),
	(204160, 121, '2014-02-15 00:05:38.000000', 'temperatura', 373.0000, 'ºC'),
	(204161, 121, '2014-02-15 00:05:39.000000', 'temperatura', 158.0000, 'ºC'),
	(204162, 121, '2014-02-15 00:05:40.000000', 'temperatura', 875.0000, 'ºC'),
	(204163, 121, '2014-02-15 00:05:41.000000', 'temperatura', 298.0000, 'ºC'),
	(204164, 121, '2014-02-15 00:05:42.000000', 'temperatura', 66.0000, 'ºC'),
	(204165, 121, '2014-02-15 00:05:43.000000', 'temperatura', 635.0000, 'ºC'),
	(204166, 121, '2014-02-15 00:05:44.000000', 'temperatura', 578.0000, 'ºC'),
	(204167, 121, '2014-02-15 00:05:45.000000', 'temperatura', 988.0000, 'ºC'),
	(204168, 121, '2014-02-15 00:05:46.000000', 'temperatura', 805.0000, 'ºC'),
	(204169, 121, '2014-02-15 00:05:47.000000', 'temperatura', 1062.0000, 'ºC'),
	(204170, 121, '2014-02-15 00:05:48.000000', 'temperatura', 496.0000, 'ºC'),
	(204171, 121, '2014-02-15 00:05:49.000000', 'temperatura', 494.0000, 'ºC'),
	(204172, 121, '2014-02-15 00:05:50.000000', 'temperatura', 983.0000, 'ºC'),
	(204173, 121, '2014-02-15 00:05:51.000000', 'temperatura', 1032.0000, 'ºC'),
	(204174, 121, '2014-02-15 00:05:52.000000', 'temperatura', 1014.0000, 'ºC'),
	(204175, 121, '2014-02-15 00:05:53.000000', 'temperatura', 773.0000, 'ºC'),
	(204176, 121, '2014-02-15 00:05:54.000000', 'temperatura', 824.0000, 'ºC'),
	(204177, 121, '2014-02-15 00:05:55.000000', 'temperatura', 603.0000, 'ºC'),
	(204178, 121, '2014-02-15 00:05:56.000000', 'temperatura', 542.0000, 'ºC'),
	(204179, 121, '2014-02-15 00:05:57.000000', 'temperatura', 903.0000, 'ºC'),
	(204180, 121, '2014-02-15 00:05:58.000000', 'temperatura', 490.0000, 'ºC'),
	(204181, 121, '2014-02-15 00:05:59.000000', 'temperatura', 941.0000, 'ºC'),
	(204182, 121, '2014-02-15 00:06:00.000000', 'temperatura', 834.0000, 'ºC'),
	(204183, 121, '2014-02-15 00:06:01.000000', 'temperatura', 148.0000, 'ºC'),
	(204184, 121, '2014-02-15 00:06:02.000000', 'temperatura', 641.0000, 'ºC'),
	(204185, 121, '2014-02-15 00:06:03.000000', 'temperatura', 359.0000, 'ºC'),
	(204186, 121, '2014-02-15 00:06:04.000000', 'temperatura', 1071.0000, 'ºC'),
	(204187, 121, '2014-02-15 00:06:05.000000', 'temperatura', 680.0000, 'ºC'),
	(204188, 121, '2014-02-15 00:06:06.000000', 'temperatura', 189.0000, 'ºC'),
	(204189, 121, '2014-02-15 00:06:07.000000', 'temperatura', 105.0000, 'ºC'),
	(204190, 121, '2014-02-15 00:06:08.000000', 'temperatura', 1159.0000, 'ºC'),
	(204191, 121, '2014-02-15 00:06:09.000000', 'temperatura', 681.0000, 'ºC'),
	(204192, 121, '2014-02-15 00:06:10.000000', 'temperatura', 1127.0000, 'ºC'),
	(204193, 121, '2014-02-15 00:06:11.000000', 'temperatura', 1192.0000, 'ºC'),
	(204194, 121, '2014-02-15 00:06:12.000000', 'temperatura', 181.0000, 'ºC'),
	(204195, 121, '2014-02-15 00:06:13.000000', 'temperatura', 927.0000, 'ºC'),
	(204196, 121, '2014-02-15 00:06:14.000000', 'temperatura', 494.0000, 'ºC'),
	(204197, 121, '2014-02-15 00:06:15.000000', 'temperatura', 889.0000, 'ºC'),
	(204198, 121, '2014-02-15 00:06:16.000000', 'temperatura', 565.0000, 'ºC'),
	(204199, 121, '2014-02-15 00:06:17.000000', 'temperatura', 160.0000, 'ºC'),
	(204200, 121, '2014-02-15 00:06:18.000000', 'temperatura', 303.0000, 'ºC'),
	(204201, 121, '2014-02-15 00:06:19.000000', 'temperatura', 1035.0000, 'ºC'),
	(204202, 121, '2014-02-15 00:06:20.000000', 'temperatura', 665.0000, 'ºC'),
	(204203, 121, '2014-02-15 00:06:21.000000', 'temperatura', 223.0000, 'ºC'),
	(204204, 121, '2014-02-15 00:06:22.000000', 'temperatura', 319.0000, 'ºC'),
	(204205, 121, '2014-02-15 00:06:23.000000', 'temperatura', 928.0000, 'ºC'),
	(204206, 121, '2014-02-15 00:06:24.000000', 'temperatura', 83.0000, 'ºC'),
	(204207, 121, '2014-02-15 00:06:25.000000', 'temperatura', 32.0000, 'ºC'),
	(204208, 121, '2014-02-15 00:06:26.000000', 'temperatura', 1110.0000, 'ºC'),
	(204209, 121, '2014-02-15 00:06:27.000000', 'temperatura', 657.0000, 'ºC'),
	(204210, 121, '2014-02-15 00:06:28.000000', 'temperatura', 1154.0000, 'ºC'),
	(204211, 121, '2014-02-15 00:06:29.000000', 'temperatura', 200.0000, 'ºC'),
	(204212, 121, '2014-02-15 00:06:30.000000', 'temperatura', 1137.0000, 'ºC'),
	(204213, 121, '2014-02-15 00:06:31.000000', 'temperatura', 288.0000, 'ºC'),
	(204214, 121, '2014-02-15 00:06:32.000000', 'temperatura', 427.0000, 'ºC'),
	(204215, 121, '2014-02-15 00:06:33.000000', 'temperatura', 74.0000, 'ºC'),
	(204216, 121, '2014-02-15 00:06:34.000000', 'temperatura', 286.0000, 'ºC'),
	(204217, 121, '2014-02-15 00:06:35.000000', 'temperatura', 12.0000, 'ºC'),
	(204218, 121, '2014-02-15 00:06:36.000000', 'temperatura', 402.0000, 'ºC'),
	(204219, 121, '2014-02-15 00:06:37.000000', 'temperatura', 773.0000, 'ºC'),
	(204220, 121, '2014-02-15 00:06:38.000000', 'temperatura', 259.0000, 'ºC'),
	(204221, 121, '2014-02-15 00:06:39.000000', 'temperatura', 178.0000, 'ºC'),
	(204222, 121, '2014-02-15 00:06:40.000000', 'temperatura', 112.0000, 'ºC'),
	(204223, 121, '2014-02-15 00:06:41.000000', 'temperatura', 27.0000, 'ºC'),
	(204224, 121, '2014-02-15 00:06:42.000000', 'temperatura', 1001.0000, 'ºC'),
	(204225, 121, '2014-02-15 00:06:43.000000', 'temperatura', 123.0000, 'ºC'),
	(204226, 121, '2014-02-15 00:06:44.000000', 'temperatura', 11.0000, 'ºC'),
	(204227, 121, '2014-02-15 00:06:45.000000', 'temperatura', 889.0000, 'ºC'),
	(204228, 121, '2014-02-15 00:06:46.000000', 'temperatura', 811.0000, 'ºC'),
	(204229, 121, '2014-02-15 00:06:47.000000', 'temperatura', 191.0000, 'ºC'),
	(204230, 121, '2014-02-15 00:06:48.000000', 'temperatura', 920.0000, 'ºC'),
	(204231, 121, '2014-02-15 00:06:49.000000', 'temperatura', 426.0000, 'ºC'),
	(204232, 121, '2014-02-15 00:06:50.000000', 'temperatura', 574.0000, 'ºC'),
	(204233, 121, '2014-02-15 00:06:51.000000', 'temperatura', 391.0000, 'ºC'),
	(204234, 121, '2014-02-15 00:06:52.000000', 'temperatura', 235.0000, 'ºC'),
	(204235, 121, '2014-02-15 00:06:53.000000', 'temperatura', 1.0000, 'ºC'),
	(204236, 121, '2014-02-15 00:06:54.000000', 'temperatura', 502.0000, 'ºC'),
	(204237, 121, '2014-02-15 00:06:55.000000', 'temperatura', 105.0000, 'ºC'),
	(204238, 121, '2014-02-15 00:06:56.000000', 'temperatura', 222.0000, 'ºC'),
	(204239, 121, '2014-02-15 00:06:57.000000', 'temperatura', 795.0000, 'ºC'),
	(204240, 121, '2014-02-15 00:06:58.000000', 'temperatura', 909.0000, 'ºC'),
	(204241, 121, '2014-02-15 00:06:59.000000', 'temperatura', 962.0000, 'ºC'),
	(204242, 121, '2014-02-15 00:07:00.000000', 'temperatura', 883.0000, 'ºC'),
	(204243, 121, '2014-02-15 00:07:01.000000', 'temperatura', 329.0000, 'ºC'),
	(204244, 121, '2014-02-15 00:07:02.000000', 'temperatura', 195.0000, 'ºC'),
	(204245, 121, '2014-02-15 00:07:03.000000', 'temperatura', 1189.0000, 'ºC'),
	(204246, 121, '2014-02-15 00:07:04.000000', 'temperatura', 561.0000, 'ºC'),
	(204247, 121, '2014-02-15 00:07:05.000000', 'temperatura', 438.0000, 'ºC'),
	(204248, 121, '2014-02-15 00:07:06.000000', 'temperatura', 509.0000, 'ºC'),
	(204249, 121, '2014-02-15 00:07:07.000000', 'temperatura', 30.0000, 'ºC'),
	(204250, 121, '2014-02-15 00:07:08.000000', 'temperatura', 1022.0000, 'ºC'),
	(204251, 121, '2014-02-15 00:07:09.000000', 'temperatura', 222.0000, 'ºC'),
	(204252, 121, '2014-02-15 00:07:10.000000', 'temperatura', 443.0000, 'ºC'),
	(204253, 121, '2014-02-15 00:07:11.000000', 'temperatura', 350.0000, 'ºC'),
	(204254, 121, '2014-02-15 00:07:12.000000', 'temperatura', 421.0000, 'ºC'),
	(204255, 121, '2014-02-15 00:07:13.000000', 'temperatura', 1054.0000, 'ºC'),
	(204256, 121, '2014-02-15 00:07:14.000000', 'temperatura', 411.0000, 'ºC'),
	(204257, 121, '2014-02-15 00:07:15.000000', 'temperatura', 91.0000, 'ºC'),
	(204258, 121, '2014-02-15 00:07:16.000000', 'temperatura', 424.0000, 'ºC'),
	(204259, 121, '2014-02-15 00:07:17.000000', 'temperatura', 649.0000, 'ºC'),
	(204260, 121, '2014-02-15 00:07:18.000000', 'temperatura', 770.0000, 'ºC'),
	(204261, 121, '2014-02-15 00:07:19.000000', 'temperatura', 705.0000, 'ºC'),
	(204262, 121, '2014-02-15 00:07:20.000000', 'temperatura', 17.0000, 'ºC'),
	(204263, 121, '2014-02-15 00:07:21.000000', 'temperatura', 370.0000, 'ºC'),
	(204264, 121, '2014-02-15 00:07:22.000000', 'temperatura', 600.0000, 'ºC'),
	(204265, 121, '2014-02-15 00:07:23.000000', 'temperatura', 689.0000, 'ºC'),
	(204266, 121, '2014-02-15 00:07:24.000000', 'temperatura', 447.0000, 'ºC'),
	(204267, 121, '2014-02-15 00:07:25.000000', 'temperatura', 170.0000, 'ºC'),
	(204268, 121, '2014-02-15 00:07:26.000000', 'temperatura', 708.0000, 'ºC'),
	(204269, 121, '2014-02-15 00:07:27.000000', 'temperatura', 630.0000, 'ºC'),
	(204270, 121, '2014-02-15 00:07:28.000000', 'temperatura', 1029.0000, 'ºC'),
	(204271, 121, '2014-02-15 00:07:29.000000', 'temperatura', 853.0000, 'ºC'),
	(204272, 121, '2014-02-15 00:07:30.000000', 'temperatura', 1180.0000, 'ºC'),
	(204273, 121, '2014-02-15 00:07:31.000000', 'temperatura', 942.0000, 'ºC'),
	(204274, 121, '2014-02-15 00:07:32.000000', 'temperatura', 1168.0000, 'ºC'),
	(204275, 121, '2014-02-15 00:07:33.000000', 'temperatura', 616.0000, 'ºC'),
	(204276, 121, '2014-02-15 00:07:34.000000', 'temperatura', 777.0000, 'ºC'),
	(204277, 121, '2014-02-15 00:07:35.000000', 'temperatura', 837.0000, 'ºC'),
	(204278, 121, '2014-02-15 00:07:36.000000', 'temperatura', 656.0000, 'ºC'),
	(204279, 121, '2014-02-15 00:07:37.000000', 'temperatura', 769.0000, 'ºC'),
	(204280, 121, '2014-02-15 00:07:38.000000', 'temperatura', 676.0000, 'ºC'),
	(204281, 121, '2014-02-15 00:07:39.000000', 'temperatura', 1073.0000, 'ºC'),
	(204282, 121, '2014-02-15 00:07:40.000000', 'temperatura', 938.0000, 'ºC'),
	(204283, 121, '2014-02-15 00:07:41.000000', 'temperatura', 271.0000, 'ºC'),
	(204284, 121, '2014-02-15 00:07:42.000000', 'temperatura', 943.0000, 'ºC'),
	(204285, 121, '2014-02-15 00:07:43.000000', 'temperatura', 300.0000, 'ºC'),
	(204286, 121, '2014-02-15 00:07:44.000000', 'temperatura', 1072.0000, 'ºC'),
	(204287, 121, '2014-02-15 00:07:45.000000', 'temperatura', 860.0000, 'ºC'),
	(204288, 121, '2014-02-15 00:07:46.000000', 'temperatura', 1084.0000, 'ºC'),
	(204289, 121, '2014-02-15 00:07:47.000000', 'temperatura', 441.0000, 'ºC'),
	(204290, 121, '2014-02-15 00:07:48.000000', 'temperatura', 153.0000, 'ºC'),
	(204291, 121, '2014-02-15 00:07:49.000000', 'temperatura', 642.0000, 'ºC'),
	(204292, 121, '2014-02-15 00:07:50.000000', 'temperatura', 351.0000, 'ºC'),
	(204293, 121, '2014-02-15 00:07:51.000000', 'temperatura', 1032.0000, 'ºC'),
	(204294, 121, '2014-02-15 00:07:52.000000', 'temperatura', 505.0000, 'ºC'),
	(204295, 121, '2014-02-15 00:07:53.000000', 'temperatura', 631.0000, 'ºC'),
	(204296, 121, '2014-02-15 00:07:54.000000', 'temperatura', 438.0000, 'ºC'),
	(204297, 121, '2014-02-15 00:07:55.000000', 'temperatura', 299.0000, 'ºC'),
	(204298, 121, '2014-02-15 00:07:56.000000', 'temperatura', 181.0000, 'ºC'),
	(204299, 121, '2014-02-15 00:07:57.000000', 'temperatura', 10.0000, 'ºC'),
	(204300, 121, '2014-02-15 00:07:58.000000', 'temperatura', 708.0000, 'ºC'),
	(204301, 121, '2014-02-15 00:07:59.000000', 'temperatura', 1108.0000, 'ºC'),
	(204302, 121, '2014-02-15 00:08:00.000000', 'temperatura', 1018.0000, 'ºC'),
	(204303, 121, '2014-02-15 00:08:01.000000', 'temperatura', 565.0000, 'ºC'),
	(204304, 121, '2014-02-15 00:08:02.000000', 'temperatura', 971.0000, 'ºC'),
	(204305, 121, '2014-02-15 00:08:03.000000', 'temperatura', 762.0000, 'ºC'),
	(204306, 121, '2014-02-15 00:08:04.000000', 'temperatura', 897.0000, 'ºC'),
	(204307, 121, '2014-02-15 00:08:05.000000', 'temperatura', 1001.0000, 'ºC'),
	(204308, 121, '2014-02-15 00:08:06.000000', 'temperatura', 1114.0000, 'ºC'),
	(204309, 121, '2014-02-15 00:08:07.000000', 'temperatura', 168.0000, 'ºC'),
	(204310, 121, '2014-02-15 00:08:08.000000', 'temperatura', 1096.0000, 'ºC'),
	(204311, 121, '2014-02-15 00:08:09.000000', 'temperatura', 179.0000, 'ºC'),
	(204312, 121, '2014-02-15 00:08:10.000000', 'temperatura', 8.0000, 'ºC'),
	(204313, 121, '2014-02-15 00:08:11.000000', 'temperatura', 702.0000, 'ºC'),
	(204314, 121, '2014-02-15 00:08:12.000000', 'temperatura', 1087.0000, 'ºC'),
	(204315, 121, '2014-02-15 00:08:13.000000', 'temperatura', 932.0000, 'ºC'),
	(204316, 121, '2014-02-15 00:08:14.000000', 'temperatura', 196.0000, 'ºC'),
	(204317, 121, '2014-02-15 00:08:15.000000', 'temperatura', 584.0000, 'ºC'),
	(204318, 121, '2014-02-15 00:08:16.000000', 'temperatura', 1135.0000, 'ºC'),
	(204319, 121, '2014-02-15 00:08:17.000000', 'temperatura', 325.0000, 'ºC'),
	(204320, 121, '2014-02-15 00:08:18.000000', 'temperatura', 617.0000, 'ºC'),
	(204321, 121, '2014-02-15 00:08:19.000000', 'temperatura', 912.0000, 'ºC'),
	(204322, 121, '2014-02-15 00:08:20.000000', 'temperatura', 309.0000, 'ºC'),
	(204323, 121, '2014-02-15 00:08:21.000000', 'temperatura', 9.0000, 'ºC'),
	(204324, 121, '2014-02-15 00:08:22.000000', 'temperatura', 317.0000, 'ºC'),
	(204325, 121, '2014-02-15 00:08:23.000000', 'temperatura', 362.0000, 'ºC'),
	(204326, 121, '2014-02-15 00:08:24.000000', 'temperatura', 857.0000, 'ºC'),
	(204327, 121, '2014-02-15 00:08:25.000000', 'temperatura', 800.0000, 'ºC'),
	(204328, 121, '2014-02-15 00:08:26.000000', 'temperatura', 228.0000, 'ºC'),
	(204329, 121, '2014-02-15 00:08:27.000000', 'temperatura', 1141.0000, 'ºC'),
	(204330, 121, '2014-02-15 00:08:28.000000', 'temperatura', 221.0000, 'ºC'),
	(204331, 121, '2014-02-15 00:08:29.000000', 'temperatura', 83.0000, 'ºC'),
	(204332, 121, '2014-02-15 00:08:30.000000', 'temperatura', 952.0000, 'ºC'),
	(204333, 121, '2014-02-15 00:08:31.000000', 'temperatura', 910.0000, 'ºC'),
	(204334, 121, '2014-02-15 00:08:32.000000', 'temperatura', 497.0000, 'ºC'),
	(204335, 121, '2014-02-15 00:08:33.000000', 'temperatura', 956.0000, 'ºC'),
	(204336, 121, '2014-02-15 00:08:34.000000', 'temperatura', 890.0000, 'ºC'),
	(204337, 121, '2014-02-15 00:08:35.000000', 'temperatura', 380.0000, 'ºC'),
	(204338, 121, '2014-02-15 00:08:36.000000', 'temperatura', 432.0000, 'ºC'),
	(204339, 121, '2014-02-15 00:08:37.000000', 'temperatura', 1021.0000, 'ºC'),
	(204340, 121, '2014-02-15 00:08:38.000000', 'temperatura', 208.0000, 'ºC'),
	(204341, 121, '2014-02-15 00:08:39.000000', 'temperatura', 376.0000, 'ºC'),
	(204342, 121, '2014-02-15 00:08:40.000000', 'temperatura', 58.0000, 'ºC'),
	(204343, 121, '2014-02-15 00:08:41.000000', 'temperatura', 365.0000, 'ºC'),
	(204344, 121, '2014-02-15 00:08:42.000000', 'temperatura', 448.0000, 'ºC'),
	(204345, 121, '2014-02-15 00:08:43.000000', 'temperatura', 1148.0000, 'ºC'),
	(204346, 121, '2014-02-15 00:08:44.000000', 'temperatura', 794.0000, 'ºC'),
	(204347, 121, '2014-02-15 00:08:45.000000', 'temperatura', 526.0000, 'ºC'),
	(204348, 121, '2014-02-15 00:08:46.000000', 'temperatura', 249.0000, 'ºC'),
	(204349, 121, '2014-02-15 00:08:47.000000', 'temperatura', 868.0000, 'ºC'),
	(204350, 121, '2014-02-15 00:08:48.000000', 'temperatura', 1194.0000, 'ºC'),
	(204351, 121, '2014-02-15 00:08:49.000000', 'temperatura', 965.0000, 'ºC'),
	(204352, 121, '2014-02-15 00:08:50.000000', 'temperatura', 42.0000, 'ºC'),
	(204353, 121, '2014-02-15 00:08:51.000000', 'temperatura', 919.0000, 'ºC'),
	(204354, 121, '2014-02-15 00:08:52.000000', 'temperatura', 866.0000, 'ºC'),
	(204355, 121, '2014-02-15 00:08:53.000000', 'temperatura', 376.0000, 'ºC'),
	(204356, 121, '2014-02-15 00:08:54.000000', 'temperatura', 481.0000, 'ºC'),
	(204357, 121, '2014-02-15 00:08:55.000000', 'temperatura', 80.0000, 'ºC'),
	(204358, 121, '2014-02-15 00:08:56.000000', 'temperatura', 156.0000, 'ºC'),
	(204359, 121, '2014-02-15 00:08:57.000000', 'temperatura', 542.0000, 'ºC'),
	(204360, 121, '2014-02-15 00:08:58.000000', 'temperatura', 1041.0000, 'ºC'),
	(204361, 121, '2014-02-15 00:08:59.000000', 'temperatura', 1182.0000, 'ºC'),
	(204362, 121, '2014-02-15 00:09:00.000000', 'temperatura', 384.0000, 'ºC'),
	(204363, 121, '2014-02-15 00:09:01.000000', 'temperatura', 778.0000, 'ºC'),
	(204364, 121, '2014-02-15 00:09:02.000000', 'temperatura', 337.0000, 'ºC'),
	(204365, 121, '2014-02-15 00:09:03.000000', 'temperatura', 552.0000, 'ºC'),
	(204366, 121, '2014-02-15 00:09:04.000000', 'temperatura', 549.0000, 'ºC'),
	(204367, 121, '2014-02-15 00:09:05.000000', 'temperatura', 1092.0000, 'ºC'),
	(204368, 121, '2014-02-15 00:09:06.000000', 'temperatura', 210.0000, 'ºC'),
	(204369, 121, '2014-02-15 00:09:07.000000', 'temperatura', 178.0000, 'ºC'),
	(204370, 121, '2014-02-15 00:09:08.000000', 'temperatura', 258.0000, 'ºC'),
	(204371, 121, '2014-02-15 00:09:09.000000', 'temperatura', 758.0000, 'ºC'),
	(204372, 121, '2014-02-15 00:09:10.000000', 'temperatura', 615.0000, 'ºC'),
	(204373, 121, '2014-02-15 00:09:11.000000', 'temperatura', 803.0000, 'ºC'),
	(204374, 121, '2014-02-15 00:09:12.000000', 'temperatura', 969.0000, 'ºC'),
	(204375, 121, '2014-02-15 00:09:13.000000', 'temperatura', 39.0000, 'ºC'),
	(204376, 121, '2014-02-15 00:09:14.000000', 'temperatura', 886.0000, 'ºC'),
	(204377, 121, '2014-02-15 00:09:15.000000', 'temperatura', 714.0000, 'ºC'),
	(204378, 121, '2014-02-15 00:09:16.000000', 'temperatura', 911.0000, 'ºC'),
	(204379, 121, '2014-02-15 00:09:17.000000', 'temperatura', 16.0000, 'ºC'),
	(204380, 121, '2014-02-15 00:09:18.000000', 'temperatura', 945.0000, 'ºC'),
	(204381, 121, '2014-02-15 00:09:19.000000', 'temperatura', 1081.0000, 'ºC'),
	(204382, 121, '2014-02-15 00:09:20.000000', 'temperatura', 168.0000, 'ºC'),
	(204383, 121, '2014-02-15 00:09:21.000000', 'temperatura', 1197.0000, 'ºC'),
	(204384, 121, '2014-02-15 00:09:22.000000', 'temperatura', 682.0000, 'ºC'),
	(204385, 121, '2014-02-15 00:09:23.000000', 'temperatura', 1020.0000, 'ºC'),
	(204386, 121, '2014-02-15 00:09:24.000000', 'temperatura', 655.0000, 'ºC'),
	(204387, 121, '2014-02-15 00:09:25.000000', 'temperatura', 216.0000, 'ºC'),
	(204388, 121, '2014-02-15 00:09:26.000000', 'temperatura', 314.0000, 'ºC'),
	(204389, 121, '2014-02-15 00:09:27.000000', 'temperatura', 922.0000, 'ºC'),
	(204390, 121, '2014-02-15 00:09:28.000000', 'temperatura', 70.0000, 'ºC'),
	(204391, 121, '2014-02-15 00:09:29.000000', 'temperatura', 1184.0000, 'ºC'),
	(204392, 121, '2014-02-15 00:09:30.000000', 'temperatura', 912.0000, 'ºC'),
	(204393, 121, '2014-02-15 00:09:31.000000', 'temperatura', 1006.0000, 'ºC'),
	(204394, 121, '2014-02-15 00:09:32.000000', 'temperatura', 1094.0000, 'ºC'),
	(204395, 121, '2014-02-15 00:09:33.000000', 'temperatura', 54.0000, 'ºC'),
	(204396, 121, '2014-02-15 00:09:34.000000', 'temperatura', 590.0000, 'ºC'),
	(204397, 121, '2014-02-15 00:09:35.000000', 'temperatura', 388.0000, 'ºC'),
	(204398, 121, '2014-02-15 00:09:36.000000', 'temperatura', 169.0000, 'ºC'),
	(204399, 121, '2014-02-15 00:09:37.000000', 'temperatura', 881.0000, 'ºC'),
	(204400, 121, '2014-02-15 00:09:38.000000', 'temperatura', 298.0000, 'ºC'),
	(204401, 121, '2014-02-15 00:09:39.000000', 'temperatura', 49.0000, 'ºC'),
	(204402, 121, '2014-02-15 00:09:40.000000', 'temperatura', 552.0000, 'ºC'),
	(204403, 121, '2014-02-15 00:09:41.000000', 'temperatura', 212.0000, 'ºC'),
	(204404, 121, '2014-02-15 00:09:42.000000', 'temperatura', 606.0000, 'ºC'),
	(204405, 121, '2014-02-15 00:09:43.000000', 'temperatura', 1196.0000, 'ºC'),
	(204406, 121, '2014-02-15 00:09:44.000000', 'temperatura', 561.0000, 'ºC'),
	(204407, 121, '2014-02-15 00:09:45.000000', 'temperatura', 417.0000, 'ºC'),
	(204408, 121, '2014-02-15 00:09:46.000000', 'temperatura', 403.0000, 'ºC'),
	(204409, 121, '2014-02-15 00:09:47.000000', 'temperatura', 764.0000, 'ºC'),
	(204410, 121, '2014-02-15 00:09:48.000000', 'temperatura', 210.0000, 'ºC'),
	(204411, 121, '2014-02-15 00:09:49.000000', 'temperatura', 1160.0000, 'ºC'),
	(204412, 121, '2014-02-15 00:09:50.000000', 'temperatura', 369.0000, 'ºC'),
	(204413, 121, '2014-02-15 00:09:51.000000', 'temperatura', 766.0000, 'ºC'),
	(204414, 121, '2014-02-15 00:09:52.000000', 'temperatura', 325.0000, 'ºC'),
	(204415, 121, '2014-02-15 00:09:53.000000', 'temperatura', 525.0000, 'ºC'),
	(204416, 121, '2014-02-15 00:09:54.000000', 'temperatura', 452.0000, 'ºC'),
	(204417, 121, '2014-02-15 00:09:55.000000', 'temperatura', 685.0000, 'ºC'),
	(204418, 121, '2014-02-15 00:09:56.000000', 'temperatura', 869.0000, 'ºC'),
	(204419, 121, '2014-02-15 00:09:57.000000', 'temperatura', 1092.0000, 'ºC'),
	(204420, 121, '2014-02-15 00:09:58.000000', 'temperatura', 452.0000, 'ºC'),
	(204421, 121, '2014-02-15 00:09:59.000000', 'temperatura', 184.0000, 'ºC'),
	(204422, 121, '2014-02-15 00:10:00.000000', 'temperatura', 764.0000, 'ºC'),
	(204423, 121, '2014-02-15 00:10:01.000000', 'temperatura', 869.0000, 'ºC'),
	(204424, 121, '2014-02-15 00:10:02.000000', 'temperatura', 854.0000, 'ºC'),
	(204425, 121, '2014-02-15 00:10:03.000000', 'temperatura', 462.0000, 'ºC'),
	(204426, 121, '2014-02-15 00:10:04.000000', 'temperatura', 947.0000, 'ºC'),
	(204427, 121, '2014-02-15 00:10:05.000000', 'temperatura', 953.0000, 'ºC'),
	(204428, 121, '2014-02-15 00:10:06.000000', 'temperatura', 721.0000, 'ºC'),
	(204429, 121, '2014-02-15 00:10:07.000000', 'temperatura', 749.0000, 'ºC'),
	(204430, 121, '2014-02-15 00:10:08.000000', 'temperatura', 381.0000, 'ºC'),
	(204431, 121, '2014-02-15 00:10:09.000000', 'temperatura', 859.0000, 'ºC'),
	(204432, 121, '2014-02-15 00:10:10.000000', 'temperatura', 755.0000, 'ºC'),
	(204433, 121, '2014-02-15 00:10:11.000000', 'temperatura', 1195.0000, 'ºC'),
	(204434, 121, '2014-02-15 00:10:12.000000', 'temperatura', 112.0000, 'ºC'),
	(204435, 121, '2014-02-15 00:10:13.000000', 'temperatura', 574.0000, 'ºC'),
	(204436, 121, '2014-02-15 00:10:14.000000', 'temperatura', 134.0000, 'ºC'),
	(204437, 121, '2014-02-15 00:10:15.000000', 'temperatura', 151.0000, 'ºC'),
	(204438, 121, '2014-02-15 00:10:16.000000', 'temperatura', 353.0000, 'ºC'),
	(204439, 121, '2014-02-15 00:10:17.000000', 'temperatura', 112.0000, 'ºC'),
	(204440, 121, '2014-02-15 00:10:18.000000', 'temperatura', 700.0000, 'ºC'),
	(204441, 121, '2014-02-15 00:10:19.000000', 'temperatura', 765.0000, 'ºC'),
	(204442, 121, '2014-02-15 00:10:20.000000', 'temperatura', 526.0000, 'ºC'),
	(204443, 121, '2014-02-15 00:10:21.000000', 'temperatura', 335.0000, 'ºC'),
	(204444, 121, '2014-02-15 00:10:22.000000', 'temperatura', 97.0000, 'ºC'),
	(204445, 121, '2014-02-15 00:10:23.000000', 'temperatura', 679.0000, 'ºC'),
	(204446, 121, '2014-02-15 00:10:24.000000', 'temperatura', 706.0000, 'ºC'),
	(204447, 121, '2014-02-15 00:10:25.000000', 'temperatura', 293.0000, 'ºC'),
	(204448, 121, '2014-02-15 00:10:26.000000', 'temperatura', 550.0000, 'ºC'),
	(204449, 121, '2014-02-15 00:10:27.000000', 'temperatura', 670.0000, 'ºC'),
	(204450, 121, '2014-02-15 00:10:28.000000', 'temperatura', 500.0000, 'ºC'),
	(204451, 121, '2014-02-15 00:10:29.000000', 'temperatura', 490.0000, 'ºC'),
	(204452, 121, '2014-02-15 00:10:30.000000', 'temperatura', 952.0000, 'ºC'),
	(204453, 121, '2014-02-15 00:10:31.000000', 'temperatura', 889.0000, 'ºC'),
	(204454, 121, '2014-02-15 00:10:32.000000', 'temperatura', 388.0000, 'ºC'),
	(204455, 121, '2014-02-15 00:10:33.000000', 'temperatura', 477.0000, 'ºC'),
	(204456, 121, '2014-02-15 00:10:34.000000', 'temperatura', 19.0000, 'ºC'),
	(204457, 121, '2014-02-15 00:10:35.000000', 'temperatura', 1064.0000, 'ºC'),
	(204458, 121, '2014-02-15 00:10:36.000000', 'temperatura', 464.0000, 'ºC'),
	(204459, 121, '2014-02-15 00:10:37.000000', 'temperatura', 328.0000, 'ºC'),
	(204460, 121, '2014-02-15 00:10:38.000000', 'temperatura', 249.0000, 'ºC'),
	(204461, 121, '2014-02-15 00:10:39.000000', 'temperatura', 264.0000, 'ºC'),
	(204462, 121, '2014-02-15 00:10:40.000000', 'temperatura', 570.0000, 'ºC'),
	(204463, 121, '2014-02-15 00:10:41.000000', 'temperatura', 858.0000, 'ºC'),
	(204464, 121, '2014-02-15 00:10:42.000000', 'temperatura', 183.0000, 'ºC'),
	(204465, 121, '2014-02-15 00:10:43.000000', 'temperatura', 743.0000, 'ºC'),
	(204466, 121, '2014-02-15 00:10:44.000000', 'temperatura', 764.0000, 'ºC'),
	(204467, 121, '2014-02-15 00:10:45.000000', 'temperatura', 391.0000, 'ºC'),
	(204468, 121, '2014-02-15 00:10:46.000000', 'temperatura', 863.0000, 'ºC'),
	(204469, 121, '2014-02-15 00:10:47.000000', 'temperatura', 741.0000, 'ºC'),
	(204470, 121, '2014-02-15 00:10:48.000000', 'temperatura', 1120.0000, 'ºC'),
	(204471, 121, '2014-02-15 00:10:49.000000', 'temperatura', 974.0000, 'ºC'),
	(204472, 121, '2014-02-15 00:10:50.000000', 'temperatura', 313.0000, 'ºC'),
	(204473, 121, '2014-02-15 00:10:51.000000', 'temperatura', 1044.0000, 'ºC'),
	(204474, 121, '2014-02-15 00:10:52.000000', 'temperatura', 681.0000, 'ºC'),
	(204475, 121, '2014-02-15 00:10:53.000000', 'temperatura', 274.0000, 'ºC'),
	(204476, 121, '2014-02-15 00:10:54.000000', 'temperatura', 527.0000, 'ºC'),
	(204477, 121, '2014-02-15 00:10:55.000000', 'temperatura', 612.0000, 'ºC'),
	(204478, 121, '2014-02-15 00:10:56.000000', 'temperatura', 279.0000, 'ºC'),
	(204479, 121, '2014-02-15 00:10:57.000000', 'temperatura', 762.0000, 'ºC'),
	(204480, 121, '2014-02-15 00:10:58.000000', 'temperatura', 572.0000, 'ºC'),
	(204481, 121, '2014-02-15 00:10:59.000000', 'temperatura', 574.0000, 'ºC'),
	(204482, 121, '2014-02-15 00:11:00.000000', 'temperatura', 1157.0000, 'ºC'),
	(204483, 121, '2014-02-15 00:11:01.000000', 'temperatura', 461.0000, 'ºC'),
	(204484, 121, '2014-02-15 00:11:02.000000', 'temperatura', 34.0000, 'ºC'),
	(204485, 121, '2014-02-15 00:11:03.000000', 'temperatura', 1186.0000, 'ºC'),
	(204486, 121, '2014-02-15 00:11:04.000000', 'temperatura', 1032.0000, 'ºC'),
	(204487, 121, '2014-02-15 00:11:05.000000', 'temperatura', 400.0000, 'ºC'),
	(204488, 121, '2014-02-15 00:11:06.000000', 'temperatura', 106.0000, 'ºC'),
	(204489, 121, '2014-02-15 00:11:07.000000', 'temperatura', 528.0000, 'ºC'),
	(204490, 121, '2014-02-15 00:11:08.000000', 'temperatura', 1124.0000, 'ºC'),
	(204491, 121, '2014-02-15 00:11:09.000000', 'temperatura', 434.0000, 'ºC'),
	(204492, 121, '2014-02-15 00:11:10.000000', 'temperatura', 2.0000, 'ºC'),
	(204493, 121, '2014-02-15 00:11:11.000000', 'temperatura', 1108.0000, 'ºC'),
	(204494, 121, '2014-02-15 00:11:12.000000', 'temperatura', 733.0000, 'ºC'),
	(204495, 121, '2014-02-15 00:11:13.000000', 'temperatura', 342.0000, 'ºC'),
	(204496, 121, '2014-02-15 00:11:14.000000', 'temperatura', 713.0000, 'ºC'),
	(204497, 121, '2014-02-15 00:11:15.000000', 'temperatura', 139.0000, 'ºC'),
	(204498, 121, '2014-02-15 00:11:16.000000', 'temperatura', 955.0000, 'ºC'),
	(204499, 121, '2014-02-15 00:11:17.000000', 'temperatura', 761.0000, 'ºC'),
	(204500, 121, '2014-02-15 00:11:18.000000', 'temperatura', 938.0000, 'ºC'),
	(204501, 121, '2014-02-15 00:11:19.000000', 'temperatura', 7.0000, 'ºC'),
	(204502, 121, '2014-02-15 00:11:20.000000', 'temperatura', 822.0000, 'ºC'),
	(204503, 121, '2014-02-15 00:11:21.000000', 'temperatura', 490.0000, 'ºC'),
	(204504, 121, '2014-02-15 00:11:22.000000', 'temperatura', 1185.0000, 'ºC'),
	(204505, 121, '2014-02-15 00:11:23.000000', 'temperatura', 856.0000, 'ºC'),
	(204506, 121, '2014-02-15 00:11:24.000000', 'temperatura', 724.0000, 'ºC'),
	(204507, 121, '2014-02-15 00:11:25.000000', 'temperatura', 1055.0000, 'ºC'),
	(204508, 121, '2014-02-15 00:11:26.000000', 'temperatura', 702.0000, 'ºC'),
	(204509, 121, '2014-02-15 00:11:27.000000', 'temperatura', 346.0000, 'ºC'),
	(204510, 121, '2014-02-15 00:11:28.000000', 'temperatura', 822.0000, 'ºC'),
	(204511, 121, '2014-02-15 00:11:29.000000', 'temperatura', 675.0000, 'ºC'),
	(204512, 121, '2014-02-15 00:11:30.000000', 'temperatura', 911.0000, 'ºC'),
	(204513, 121, '2014-02-15 00:11:31.000000', 'temperatura', 129.0000, 'ºC'),
	(204514, 121, '2014-02-15 00:11:32.000000', 'temperatura', 311.0000, 'ºC'),
	(204515, 121, '2014-02-15 00:11:33.000000', 'temperatura', 1170.0000, 'ºC'),
	(204516, 121, '2014-02-15 00:11:34.000000', 'temperatura', 117.0000, 'ºC'),
	(204517, 121, '2014-02-15 00:11:35.000000', 'temperatura', 675.0000, 'ºC'),
	(204518, 121, '2014-02-15 00:11:36.000000', 'temperatura', 624.0000, 'ºC'),
	(204519, 121, '2014-02-15 00:11:37.000000', 'temperatura', 1095.0000, 'ºC'),
	(204520, 121, '2014-02-15 00:11:38.000000', 'temperatura', 4.0000, 'ºC'),
	(204521, 121, '2014-02-15 00:11:39.000000', 'temperatura', 335.0000, 'ºC'),
	(204522, 121, '2014-02-15 00:11:40.000000', 'temperatura', 463.0000, 'ºC'),
	(204523, 121, '2014-02-15 00:11:41.000000', 'temperatura', 113.0000, 'ºC'),
	(204524, 121, '2014-02-15 00:11:42.000000', 'temperatura', 376.0000, 'ºC'),
	(204525, 121, '2014-02-15 00:11:43.000000', 'temperatura', 340.0000, 'ºC'),
	(204526, 121, '2014-02-15 00:11:44.000000', 'temperatura', 573.0000, 'ºC'),
	(204527, 121, '2014-02-15 00:11:45.000000', 'temperatura', 646.0000, 'ºC'),
	(204528, 121, '2014-02-15 00:11:46.000000', 'temperatura', 312.0000, 'ºC'),
	(204529, 121, '2014-02-15 00:11:47.000000', 'temperatura', 822.0000, 'ºC'),
	(204530, 121, '2014-02-15 00:11:48.000000', 'temperatura', 773.0000, 'ºC'),
	(204531, 121, '2014-02-15 00:11:49.000000', 'temperatura', 199.0000, 'ºC'),
	(204532, 121, '2014-02-15 00:11:50.000000', 'temperatura', 1079.0000, 'ºC'),
	(204533, 121, '2014-02-15 00:11:51.000000', 'temperatura', 1195.0000, 'ºC'),
	(204534, 121, '2014-02-15 00:11:52.000000', 'temperatura', 342.0000, 'ºC'),
	(204535, 121, '2014-02-15 00:11:53.000000', 'temperatura', 523.0000, 'ºC'),
	(204536, 121, '2014-02-15 00:11:54.000000', 'temperatura', 391.0000, 'ºC'),
	(204537, 121, '2014-02-15 00:11:55.000000', 'temperatura', 388.0000, 'ºC'),
	(204538, 121, '2014-02-15 00:11:56.000000', 'temperatura', 764.0000, 'ºC'),
	(204539, 121, '2014-02-15 00:11:57.000000', 'temperatura', 258.0000, 'ºC'),
	(204540, 121, '2014-02-15 00:11:58.000000', 'temperatura', 199.0000, 'ºC'),
	(204541, 121, '2014-02-15 00:11:59.000000', 'temperatura', 220.0000, 'ºC'),
	(204542, 121, '2014-02-15 00:12:00.000000', 'temperatura', 504.0000, 'ºC'),
	(204543, 121, '2014-02-15 00:12:01.000000', 'temperatura', 663.0000, 'ºC'),
	(204544, 121, '2014-02-15 00:12:02.000000', 'temperatura', 601.0000, 'ºC'),
	(204545, 121, '2014-02-15 00:12:03.000000', 'temperatura', 1017.0000, 'ºC'),
	(204546, 121, '2014-02-15 00:12:04.000000', 'temperatura', 882.0000, 'ºC'),
	(204547, 121, '2014-02-15 00:12:05.000000', 'temperatura', 160.0000, 'ºC'),
	(204548, 121, '2014-02-15 00:12:06.000000', 'temperatura', 556.0000, 'ºC'),
	(204549, 121, '2014-02-15 00:12:07.000000', 'temperatura', 1099.0000, 'ºC'),
	(204550, 121, '2014-02-15 00:12:08.000000', 'temperatura', 228.0000, 'ºC'),
	(204551, 121, '2014-02-15 00:12:09.000000', 'temperatura', 242.0000, 'ºC'),
	(204552, 121, '2014-02-15 00:12:10.000000', 'temperatura', 528.0000, 'ºC'),
	(204553, 121, '2014-02-15 00:12:11.000000', 'temperatura', 713.0000, 'ºC'),
	(204554, 121, '2014-02-15 00:12:12.000000', 'temperatura', 784.0000, 'ºC'),
	(204555, 121, '2014-02-15 00:12:13.000000', 'temperatura', 582.0000, 'ºC'),
	(204556, 121, '2014-02-15 00:12:14.000000', 'temperatura', 556.0000, 'ºC'),
	(204557, 121, '2014-02-15 00:12:15.000000', 'temperatura', 1033.0000, 'ºC'),
	(204558, 121, '2014-02-15 00:12:16.000000', 'temperatura', 1100.0000, 'ºC'),
	(204559, 121, '2014-02-15 00:12:17.000000', 'temperatura', 2.0000, 'ºC'),
	(204560, 121, '2014-02-15 00:12:18.000000', 'temperatura', 312.0000, 'ºC'),
	(204561, 121, '2014-02-15 00:12:19.000000', 'temperatura', 352.0000, 'ºC'),
	(204562, 121, '2014-02-15 00:12:20.000000', 'temperatura', 824.0000, 'ºC'),
	(204563, 121, '2014-02-15 00:12:21.000000', 'temperatura', 667.0000, 'ºC'),
	(204564, 121, '2014-02-15 00:12:22.000000', 'temperatura', 863.0000, 'ºC'),
	(204565, 121, '2014-02-15 00:12:23.000000', 'temperatura', 1113.0000, 'ºC'),
	(204566, 121, '2014-02-15 00:12:24.000000', 'temperatura', 576.0000, 'ºC'),
	(204567, 121, '2014-02-15 00:12:25.000000', 'temperatura', 742.0000, 'ºC'),
	(204568, 121, '2014-02-15 00:12:26.000000', 'temperatura', 783.0000, 'ºC'),
	(204569, 121, '2014-02-15 00:12:27.000000', 'temperatura', 488.0000, 'ºC'),
	(204570, 121, '2014-02-15 00:12:28.000000', 'temperatura', 92.0000, 'ºC'),
	(204571, 121, '2014-02-15 00:12:29.000000', 'temperatura', 198.0000, 'ºC'),
	(204572, 121, '2014-02-15 00:12:30.000000', 'temperatura', 714.0000, 'ºC'),
	(204573, 121, '2014-02-15 00:12:31.000000', 'temperatura', 577.0000, 'ºC'),
	(204574, 121, '2014-02-15 00:12:32.000000', 'temperatura', 742.0000, 'ºC'),
	(204575, 121, '2014-02-15 00:12:33.000000', 'temperatura', 779.0000, 'ºC'),
	(204576, 121, '2014-02-15 00:12:34.000000', 'temperatura', 470.0000, 'ºC'),
	(204577, 121, '2014-02-15 00:12:35.000000', 'temperatura', 12.0000, 'ºC'),
	(204578, 121, '2014-02-15 00:12:36.000000', 'temperatura', 1050.0000, 'ºC'),
	(204579, 121, '2014-02-15 00:12:37.000000', 'temperatura', 418.0000, 'ºC'),
	(204580, 121, '2014-02-15 00:12:38.000000', 'temperatura', 138.0000, 'ºC'),
	(204581, 121, '2014-02-15 00:12:39.000000', 'temperatura', 637.0000, 'ºC'),
	(204582, 121, '2014-02-15 00:12:40.000000', 'temperatura', 371.0000, 'ºC'),
	(204583, 121, '2014-02-15 00:12:41.000000', 'temperatura', 1144.0000, 'ºC'),
	(204584, 121, '2014-02-15 00:12:42.000000', 'temperatura', 1008.0000, 'ºC'),
	(204585, 121, '2014-02-15 00:12:43.000000', 'temperatura', 408.0000, 'ºC'),
	(204586, 121, '2014-02-15 00:12:44.000000', 'temperatura', 217.0000, 'ºC'),
	(204587, 121, '2014-02-15 00:12:45.000000', 'temperatura', 1063.0000, 'ºC'),
	(204588, 121, '2014-02-15 00:12:46.000000', 'temperatura', 1062.0000, 'ºC'),
	(204589, 121, '2014-02-15 00:12:47.000000', 'temperatura', 921.0000, 'ºC'),
	(204590, 121, '2014-02-15 00:12:48.000000', 'temperatura', 221.0000, 'ºC'),
	(204591, 121, '2014-02-15 00:12:49.000000', 'temperatura', 740.0000, 'ºC'),
	(204592, 121, '2014-02-15 00:12:50.000000', 'temperatura', 640.0000, 'ºC'),
	(204593, 121, '2014-02-15 00:12:51.000000', 'temperatura', 979.0000, 'ºC'),
	(204594, 121, '2014-02-15 00:12:52.000000', 'temperatura', 578.0000, 'ºC'),
	(204595, 121, '2014-02-15 00:12:53.000000', 'temperatura', 1152.0000, 'ºC'),
	(204596, 121, '2014-02-15 00:12:54.000000', 'temperatura', 427.0000, 'ºC'),
	(204597, 121, '2014-02-15 00:12:55.000000', 'temperatura', 1078.0000, 'ºC'),
	(204598, 121, '2014-02-15 00:12:56.000000', 'temperatura', 509.0000, 'ºC'),
	(204599, 121, '2014-02-15 00:12:57.000000', 'temperatura', 512.0000, 'ºC'),
	(204600, 121, '2014-02-15 00:12:58.000000', 'temperatura', 1035.0000, 'ºC'),
	(204601, 121, '2014-02-15 00:12:59.000000', 'temperatura', 37.0000, 'ºC'),
	(204602, 121, '2014-02-15 00:13:00.000000', 'temperatura', 682.0000, 'ºC'),
	(204603, 121, '2014-02-15 00:13:01.000000', 'temperatura', 898.0000, 'ºC'),
	(204604, 121, '2014-02-15 00:13:02.000000', 'temperatura', 44.0000, 'ºC'),
	(204605, 121, '2014-02-15 00:13:03.000000', 'temperatura', 1127.0000, 'ºC'),
	(204606, 121, '2014-02-15 00:13:04.000000', 'temperatura', 702.0000, 'ºC'),
	(204607, 121, '2014-02-15 00:13:05.000000', 'temperatura', 131.0000, 'ºC'),
	(204608, 121, '2014-02-15 00:13:06.000000', 'temperatura', 951.0000, 'ºC'),
	(204609, 121, '2014-02-15 00:13:07.000000', 'temperatura', 761.0000, 'ºC'),
	(204610, 121, '2014-02-15 00:13:08.000000', 'temperatura', 952.0000, 'ºC'),
	(204611, 121, '2014-02-15 00:13:09.000000', 'temperatura', 78.0000, 'ºC'),
	(204612, 121, '2014-02-15 00:13:10.000000', 'temperatura', 1136.0000, 'ºC'),
	(204613, 121, '2014-02-15 00:13:11.000000', 'temperatura', 647.0000, 'ºC'),
	(204614, 121, '2014-02-15 00:13:12.000000', 'temperatura', 1027.0000, 'ºC'),
	(204615, 121, '2014-02-15 00:13:13.000000', 'temperatura', 793.0000, 'ºC'),
	(204616, 121, '2014-02-15 00:13:14.000000', 'temperatura', 885.0000, 'ºC'),
	(204617, 121, '2014-02-15 00:13:15.000000', 'temperatura', 848.0000, 'ºC'),
	(204618, 121, '2014-02-15 00:13:16.000000', 'temperatura', 385.0000, 'ºC'),
	(204619, 121, '2014-02-15 00:13:17.000000', 'temperatura', 581.0000, 'ºC'),
	(204620, 121, '2014-02-15 00:13:18.000000', 'temperatura', 549.0000, 'ºC'),
	(204621, 121, '2014-02-15 00:13:19.000000', 'temperatura', 1002.0000, 'ºC'),
	(204622, 121, '2014-02-15 00:13:20.000000', 'temperatura', 965.0000, 'ºC'),
	(204623, 121, '2014-02-15 00:13:21.000000', 'temperatura', 621.0000, 'ºC'),
	(204624, 121, '2014-02-15 00:13:22.000000', 'temperatura', 209.0000, 'ºC'),
	(204625, 121, '2014-02-15 00:13:23.000000', 'temperatura', 385.0000, 'ºC'),
	(204626, 121, '2014-02-15 00:13:24.000000', 'temperatura', 96.0000, 'ºC'),
	(204627, 121, '2014-02-15 00:13:25.000000', 'temperatura', 525.0000, 'ºC'),
	(204628, 121, '2014-02-15 00:13:26.000000', 'temperatura', 1137.0000, 'ºC'),
	(204629, 121, '2014-02-15 00:13:27.000000', 'temperatura', 512.0000, 'ºC'),
	(204630, 121, '2014-02-15 00:13:28.000000', 'temperatura', 348.0000, 'ºC'),
	(204631, 121, '2014-02-15 00:13:29.000000', 'temperatura', 207.0000, 'ºC'),
	(204632, 121, '2014-02-15 00:13:30.000000', 'temperatura', 1188.0000, 'ºC'),
	(204633, 121, '2014-02-15 00:13:31.000000', 'temperatura', 523.0000, 'ºC'),
	(204634, 121, '2014-02-15 00:13:32.000000', 'temperatura', 251.0000, 'ºC'),
	(204635, 121, '2014-02-15 00:13:33.000000', 'temperatura', 886.0000, 'ºC'),
	(204636, 121, '2014-02-15 00:13:34.000000', 'temperatura', 77.0000, 'ºC'),
	(204637, 121, '2014-02-15 00:13:35.000000', 'temperatura', 129.0000, 'ºC'),
	(204638, 121, '2014-02-15 00:13:36.000000', 'temperatura', 413.0000, 'ºC'),
	(204639, 121, '2014-02-15 00:13:37.000000', 'temperatura', 478.0000, 'ºC'),
	(204640, 121, '2014-02-15 00:13:38.000000', 'temperatura', 1153.0000, 'ºC'),
	(204641, 121, '2014-02-15 00:13:39.000000', 'temperatura', 730.0000, 'ºC'),
	(204642, 121, '2014-02-15 00:13:40.000000', 'temperatura', 193.0000, 'ºC'),
	(204643, 121, '2014-02-15 00:13:41.000000', 'temperatura', 1176.0000, 'ºC'),
	(204644, 121, '2014-02-15 00:13:42.000000', 'temperatura', 500.0000, 'ºC'),
	(204645, 121, '2014-02-15 00:13:43.000000', 'temperatura', 172.0000, 'ºC'),
	(204646, 121, '2014-02-15 00:13:44.000000', 'temperatura', 560.0000, 'ºC'),
	(204647, 121, '2014-02-15 00:13:45.000000', 'temperatura', 1086.0000, 'ºC'),
	(204648, 121, '2014-02-15 00:13:46.000000', 'temperatura', 151.0000, 'ºC'),
	(204649, 121, '2014-02-15 00:13:47.000000', 'temperatura', 1098.0000, 'ºC'),
	(204650, 121, '2014-02-15 00:13:48.000000', 'temperatura', 235.0000, 'ºC'),
	(204651, 121, '2014-02-15 00:13:49.000000', 'temperatura', 283.0000, 'ºC'),
	(204652, 121, '2014-02-15 00:13:50.000000', 'temperatura', 711.0000, 'ºC'),
	(204653, 121, '2014-02-15 00:13:51.000000', 'temperatura', 306.0000, 'ºC'),
	(204654, 121, '2014-02-15 00:13:52.000000', 'temperatura', 595.0000, 'ºC'),
	(204655, 121, '2014-02-15 00:13:53.000000', 'temperatura', 861.0000, 'ºC'),
	(204656, 121, '2014-02-15 00:13:54.000000', 'temperatura', 120.0000, 'ºC'),
	(204657, 121, '2014-02-15 00:13:55.000000', 'temperatura', 418.0000, 'ºC'),
	(204658, 121, '2014-02-15 00:13:56.000000', 'temperatura', 530.0000, 'ºC'),
	(204659, 121, '2014-02-15 00:13:57.000000', 'temperatura', 196.0000, 'ºC'),
	(204660, 121, '2014-02-15 00:13:58.000000', 'temperatura', 591.0000, 'ºC'),
	(204661, 121, '2014-02-15 00:13:59.000000', 'temperatura', 1168.0000, 'ºC'),
	(204662, 121, '2014-02-15 00:14:00.000000', 'temperatura', 468.0000, 'ºC'),
	(204663, 121, '2014-02-15 00:14:01.000000', 'temperatura', 36.0000, 'ºC'),
	(204664, 121, '2014-02-15 00:14:02.000000', 'temperatura', 1176.0000, 'ºC'),
	(204665, 121, '2014-02-15 00:14:03.000000', 'temperatura', 975.0000, 'ºC'),
	(204666, 121, '2014-02-15 00:14:04.000000', 'temperatura', 144.0000, 'ºC'),
	(204667, 121, '2014-02-15 00:14:05.000000', 'temperatura', 197.0000, 'ºC'),
	(204668, 121, '2014-02-15 00:14:06.000000', 'temperatura', 553.0000, 'ºC'),
	(204669, 121, '2014-02-15 00:14:07.000000', 'temperatura', 976.0000, 'ºC'),
	(204670, 121, '2014-02-15 00:14:08.000000', 'temperatura', 822.0000, 'ºC'),
	(204671, 121, '2014-02-15 00:14:09.000000', 'temperatura', 1181.0000, 'ºC'),
	(204672, 121, '2014-02-15 00:14:10.000000', 'temperatura', 1038.0000, 'ºC'),
	(204673, 121, '2014-02-15 00:14:11.000000', 'temperatura', 451.0000, 'ºC'),
	(204674, 121, '2014-02-15 00:14:12.000000', 'temperatura', 338.0000, 'ºC'),
	(204675, 121, '2014-02-15 00:14:13.000000', 'temperatura', 339.0000, 'ºC'),
	(204676, 121, '2014-02-15 00:14:14.000000', 'temperatura', 681.0000, 'ºC'),
	(204677, 121, '2014-02-15 00:14:15.000000', 'temperatura', 1188.0000, 'ºC'),
	(204678, 121, '2014-02-15 00:14:16.000000', 'temperatura', 296.0000, 'ºC'),
	(204679, 121, '2014-02-15 00:14:17.000000', 'temperatura', 318.0000, 'ºC'),
	(204680, 121, '2014-02-15 00:14:18.000000', 'temperatura', 702.0000, 'ºC'),
	(204681, 121, '2014-02-15 00:14:19.000000', 'temperatura', 158.0000, 'ºC'),
	(204682, 121, '2014-02-15 00:14:20.000000', 'temperatura', 1083.0000, 'ºC'),
	(204683, 121, '2014-02-15 00:14:21.000000', 'temperatura', 143.0000, 'ºC'),
	(204684, 121, '2014-02-15 00:14:22.000000', 'temperatura', 1067.0000, 'ºC'),
	(204685, 121, '2014-02-15 00:14:23.000000', 'temperatura', 107.0000, 'ºC'),
	(204686, 121, '2014-02-15 00:14:24.000000', 'temperatura', 934.0000, 'ºC'),
	(204687, 121, '2014-02-15 00:14:25.000000', 'temperatura', 748.0000, 'ºC'),
	(204688, 121, '2014-02-15 00:14:26.000000', 'temperatura', 941.0000, 'ºC'),
	(204689, 121, '2014-02-15 00:14:27.000000', 'temperatura', 60.0000, 'ºC'),
	(204690, 121, '2014-02-15 00:14:28.000000', 'temperatura', 1080.0000, 'ºC'),
	(204691, 121, '2014-02-15 00:14:29.000000', 'temperatura', 418.0000, 'ºC'),
	(204692, 121, '2014-02-15 00:14:30.000000', 'temperatura', 50.0000, 'ºC'),
	(204693, 121, '2014-02-15 00:14:31.000000', 'temperatura', 197.0000, 'ºC'),
	(204694, 121, '2014-02-15 00:14:32.000000', 'temperatura', 835.0000, 'ºC'),
	(204695, 121, '2014-02-15 00:14:33.000000', 'temperatura', 1184.0000, 'ºC'),
	(204696, 121, '2014-02-15 00:14:34.000000', 'temperatura', 1016.0000, 'ºC'),
	(204697, 121, '2014-02-15 00:14:35.000000', 'temperatura', 330.0000, 'ºC'),
	(204698, 121, '2014-02-15 00:14:36.000000', 'temperatura', 1001.0000, 'ºC'),
	(204699, 121, '2014-02-15 00:14:37.000000', 'temperatura', 417.0000, 'ºC'),
	(204700, 121, '2014-02-15 00:14:38.000000', 'temperatura', 280.0000, 'ºC'),
	(204701, 121, '2014-02-15 00:14:39.000000', 'temperatura', 150.0000, 'ºC'),
	(204702, 121, '2014-02-15 00:14:40.000000', 'temperatura', 1111.0000, 'ºC'),
	(204703, 121, '2014-02-15 00:14:41.000000', 'temperatura', 303.0000, 'ºC'),
	(204704, 121, '2014-02-15 00:14:42.000000', 'temperatura', 586.0000, 'ºC'),
	(204705, 121, '2014-02-15 00:14:43.000000', 'temperatura', 820.0000, 'ºC'),
	(204706, 121, '2014-02-15 00:14:44.000000', 'temperatura', 1145.0000, 'ºC'),
	(204707, 121, '2014-02-15 00:14:45.000000', 'temperatura', 863.0000, 'ºC'),
	(204708, 121, '2014-02-15 00:14:46.000000', 'temperatura', 880.0000, 'ºC'),
	(204709, 121, '2014-02-15 00:14:47.000000', 'temperatura', 611.0000, 'ºC'),
	(204710, 121, '2014-02-15 00:14:48.000000', 'temperatura', 418.0000, 'ºC'),
	(204711, 121, '2014-02-15 00:14:49.000000', 'temperatura', 257.0000, 'ºC'),
	(204712, 121, '2014-02-15 00:14:50.000000', 'temperatura', 33.0000, 'ºC'),
	(204713, 121, '2014-02-15 00:14:51.000000', 'temperatura', 594.0000, 'ºC'),
	(204714, 121, '2014-02-15 00:14:52.000000', 'temperatura', 471.0000, 'ºC'),
	(204715, 121, '2014-02-15 00:14:53.000000', 'temperatura', 572.0000, 'ºC'),
	(204716, 121, '2014-02-15 00:14:54.000000', 'temperatura', 249.0000, 'ºC'),
	(204717, 121, '2014-02-15 00:14:55.000000', 'temperatura', 727.0000, 'ºC'),
	(204718, 121, '2014-02-15 00:14:56.000000', 'temperatura', 491.0000, 'ºC'),
	(204719, 121, '2014-02-15 00:14:57.000000', 'temperatura', 273.0000, 'ºC'),
	(204720, 121, '2014-02-15 00:14:58.000000', 'temperatura', 1093.0000, 'ºC'),
	(204721, 121, '2014-02-15 00:14:59.000000', 'temperatura', 1045.0000, 'ºC'),
	(204722, 121, '2014-02-15 00:15:00.000000', 'temperatura', 747.0000, 'ºC'),
	(204723, 121, '2014-02-15 00:15:01.000000', 'temperatura', 599.0000, 'ºC'),
	(204724, 121, '2014-02-15 00:15:02.000000', 'temperatura', 757.0000, 'ºC'),
	(204725, 121, '2014-02-15 00:15:03.000000', 'temperatura', 787.0000, 'ºC'),
	(204726, 121, '2014-02-15 00:15:04.000000', 'temperatura', 464.0000, 'ºC'),
	(204727, 121, '2014-02-15 00:15:05.000000', 'temperatura', 1162.0000, 'ºC'),
	(204728, 121, '2014-02-15 00:15:06.000000', 'temperatura', 816.0000, 'ºC'),
	(204729, 121, '2014-02-15 00:15:07.000000', 'temperatura', 594.0000, 'ºC'),
	(204730, 121, '2014-02-15 00:15:08.000000', 'temperatura', 523.0000, 'ºC'),
	(204731, 121, '2014-02-15 00:15:09.000000', 'temperatura', 832.0000, 'ºC'),
	(204732, 121, '2014-02-15 00:15:10.000000', 'temperatura', 192.0000, 'ºC'),
	(204733, 121, '2014-02-15 00:15:11.000000', 'temperatura', 864.0000, 'ºC'),
	(204734, 121, '2014-02-15 00:15:12.000000', 'temperatura', 143.0000, 'ºC'),
	(204735, 121, '2014-02-15 00:15:13.000000', 'temperatura', 526.0000, 'ºC'),
	(204736, 121, '2014-02-15 00:15:14.000000', 'temperatura', 1001.0000, 'ºC'),
	(204737, 121, '2014-02-15 00:15:15.000000', 'temperatura', 1028.0000, 'ºC'),
	(204738, 121, '2014-02-15 00:15:16.000000', 'temperatura', 938.0000, 'ºC'),
	(204739, 121, '2014-02-15 00:15:17.000000', 'temperatura', 404.0000, 'ºC'),
	(204740, 121, '2014-02-15 00:15:18.000000', 'temperatura', 407.0000, 'ºC'),
	(204741, 121, '2014-02-15 00:15:19.000000', 'temperatura', 823.0000, 'ºC'),
	(204742, 121, '2014-02-15 00:15:20.000000', 'temperatura', 494.0000, 'ºC'),
	(204743, 121, '2014-02-15 00:15:21.000000', 'temperatura', 4.0000, 'ºC'),
	(204744, 121, '2014-02-15 00:15:22.000000', 'temperatura', 937.0000, 'ºC'),
	(204745, 121, '2014-02-15 00:15:23.000000', 'temperatura', 1074.0000, 'ºC'),
	(204746, 121, '2014-02-15 00:15:24.000000', 'temperatura', 159.0000, 'ºC'),
	(204747, 121, '2014-02-15 00:15:25.000000', 'temperatura', 1176.0000, 'ºC'),
	(204748, 121, '2014-02-15 00:15:26.000000', 'temperatura', 600.0000, 'ºC'),
	(204749, 121, '2014-02-15 00:15:27.000000', 'temperatura', 675.0000, 'ºC'),
	(204750, 121, '2014-02-15 00:15:28.000000', 'temperatura', 374.0000, 'ºC'),
	(204751, 121, '2014-02-15 00:15:29.000000', 'temperatura', 1044.0000, 'ºC'),
	(204752, 121, '2014-02-15 00:15:30.000000', 'temperatura', 500.0000, 'ºC'),
	(204753, 121, '2014-02-15 00:15:31.000000', 'temperatura', 570.0000, 'ºC'),
	(204754, 121, '2014-02-15 00:15:32.000000', 'temperatura', 147.0000, 'ºC'),
	(204755, 121, '2014-02-15 00:15:33.000000', 'temperatura', 229.0000, 'ºC'),
	(204756, 121, '2014-02-15 00:15:34.000000', 'temperatura', 702.0000, 'ºC'),
	(204757, 121, '2014-02-15 00:15:35.000000', 'temperatura', 425.0000, 'ºC'),
	(204758, 121, '2014-02-15 00:15:36.000000', 'temperatura', 19.0000, 'ºC'),
	(204759, 121, '2014-02-15 00:15:37.000000', 'temperatura', 22.0000, 'ºC'),
	(204760, 121, '2014-02-15 00:15:38.000000', 'temperatura', 52.0000, 'ºC'),
	(204761, 121, '2014-02-15 00:15:39.000000', 'temperatura', 196.0000, 'ºC'),
	(204762, 121, '2014-02-15 00:15:40.000000', 'temperatura', 822.0000, 'ºC'),
	(204763, 121, '2014-02-15 00:15:41.000000', 'temperatura', 1122.0000, 'ºC'),
	(204764, 121, '2014-02-15 00:15:42.000000', 'temperatura', 745.0000, 'ºC'),
	(204765, 121, '2014-02-15 00:15:43.000000', 'temperatura', 361.0000, 'ºC'),
	(204766, 121, '2014-02-15 00:15:44.000000', 'temperatura', 770.0000, 'ºC'),
	(204767, 121, '2014-02-15 00:15:45.000000', 'temperatura', 366.0000, 'ºC'),
	(204768, 121, '2014-02-15 00:15:46.000000', 'temperatura', 720.0000, 'ºC'),
	(204769, 121, '2014-02-15 00:15:47.000000', 'temperatura', 103.0000, 'ºC'),
	(204770, 121, '2014-02-15 00:15:48.000000', 'temperatura', 756.0000, 'ºC'),
	(204771, 121, '2014-02-15 00:15:49.000000', 'temperatura', 1072.0000, 'ºC'),
	(204772, 121, '2014-02-15 00:15:50.000000', 'temperatura', 690.0000, 'ºC'),
	(204773, 121, '2014-02-15 00:15:51.000000', 'temperatura', 237.0000, 'ºC'),
	(204774, 121, '2014-02-15 00:15:52.000000', 'temperatura', 315.0000, 'ºC'),
	(204775, 121, '2014-02-15 00:15:53.000000', 'temperatura', 864.0000, 'ºC'),
	(204776, 121, '2014-02-15 00:15:54.000000', 'temperatura', 975.0000, 'ºC'),
	(204777, 121, '2014-02-15 00:15:55.000000', 'temperatura', 1085.0000, 'ºC'),
	(204778, 121, '2014-02-15 00:15:56.000000', 'temperatura', 101.0000, 'ºC'),
	(204779, 121, '2014-02-15 00:15:57.000000', 'temperatura', 848.0000, 'ºC'),
	(204780, 121, '2014-02-15 00:15:58.000000', 'temperatura', 341.0000, 'ºC'),
	(204781, 121, '2014-02-15 00:15:59.000000', 'temperatura', 358.0000, 'ºC'),
	(204782, 121, '2014-02-15 00:16:00.000000', 'temperatura', 771.0000, 'ºC'),
	(204783, 121, '2014-02-15 00:16:01.000000', 'temperatura', 380.0000, 'ºC'),
	(204784, 121, '2014-02-15 00:16:02.000000', 'temperatura', 787.0000, 'ºC'),
	(204785, 121, '2014-02-15 00:16:03.000000', 'temperatura', 394.0000, 'ºC'),
	(204786, 121, '2014-02-15 00:16:04.000000', 'temperatura', 810.0000, 'ºC'),
	(204787, 121, '2014-02-15 00:16:05.000000', 'temperatura', 470.0000, 'ºC'),
	(204788, 121, '2014-02-15 00:16:06.000000', 'temperatura', 1118.0000, 'ºC'),
	(204789, 121, '2014-02-15 00:16:07.000000', 'temperatura', 584.0000, 'ºC'),
	(204790, 121, '2014-02-15 00:16:08.000000', 'temperatura', 764.0000, 'ºC'),
	(204791, 121, '2014-02-15 00:16:09.000000', 'temperatura', 869.0000, 'ºC'),
	(204792, 121, '2014-02-15 00:16:10.000000', 'temperatura', 855.0000, 'ºC'),
	(204793, 121, '2014-02-15 00:16:11.000000', 'temperatura', 466.0000, 'ºC'),
	(204794, 121, '2014-02-15 00:16:12.000000', 'temperatura', 969.0000, 'ºC'),
	(204795, 121, '2014-02-15 00:16:13.000000', 'temperatura', 1044.0000, 'ºC'),
	(204796, 121, '2014-02-15 00:16:14.000000', 'temperatura', 1116.0000, 'ºC'),
	(204797, 121, '2014-02-15 00:16:15.000000', 'temperatura', 46.0000, 'ºC'),
	(204798, 121, '2014-02-15 00:16:16.000000', 'temperatura', 483.0000, 'ºC'),
	(204799, 121, '2014-02-15 00:16:17.000000', 'temperatura', 1076.0000, 'ºC'),
	(204800, 121, '2014-02-15 00:16:18.000000', 'temperatura', 332.0000, 'ºC'),
	(204801, 121, '2014-02-15 00:16:19.000000', 'temperatura', 835.0000, 'ºC'),
	(204802, 121, '2014-02-15 00:16:20.000000', 'temperatura', 777.0000, 'ºC'),
	(204803, 121, '2014-02-15 00:16:21.000000', 'temperatura', 179.0000, 'ºC'),
	(204804, 121, '2014-02-15 00:16:22.000000', 'temperatura', 967.0000, 'ºC'),
	(204805, 121, '2014-02-15 00:16:23.000000', 'temperatura', 699.0000, 'ºC'),
	(204806, 121, '2014-02-15 00:16:24.000000', 'temperatura', 593.0000, 'ºC'),
	(204807, 121, '2014-02-15 00:16:25.000000', 'temperatura', 868.0000, 'ºC'),
	(204808, 121, '2014-02-15 00:16:26.000000', 'temperatura', 163.0000, 'ºC'),
	(204809, 121, '2014-02-15 00:16:27.000000', 'temperatura', 612.0000, 'ºC'),
	(204810, 121, '2014-02-15 00:16:28.000000', 'temperatura', 170.0000, 'ºC'),
	(204811, 121, '2014-02-15 00:16:29.000000', 'temperatura', 214.0000, 'ºC'),
	(204812, 121, '2014-02-15 00:16:30.000000', 'temperatura', 562.0000, 'ºC'),
	(204813, 121, '2014-02-15 00:16:31.000000', 'temperatura', 968.0000, 'ºC'),
	(204814, 121, '2014-02-15 00:16:32.000000', 'temperatura', 756.0000, 'ºC'),
	(204815, 121, '2014-02-15 00:16:33.000000', 'temperatura', 875.0000, 'ºC'),
	(204816, 121, '2014-02-15 00:16:34.000000', 'temperatura', 909.0000, 'ºC'),
	(204817, 121, '2014-02-15 00:16:35.000000', 'temperatura', 722.0000, 'ºC'),
	(204818, 121, '2014-02-15 00:16:36.000000', 'temperatura', 880.0000, 'ºC'),
	(204819, 121, '2014-02-15 00:16:37.000000', 'temperatura', 1036.0000, 'ºC'),
	(204820, 121, '2014-02-15 00:16:38.000000', 'temperatura', 141.0000, 'ºC'),
	(204821, 121, '2014-02-15 00:16:39.000000', 'temperatura', 1197.0000, 'ºC'),
	(204822, 121, '2014-02-15 00:16:40.000000', 'temperatura', 764.0000, 'ºC'),
	(204823, 121, '2014-02-15 00:16:41.000000', 'temperatura', 227.0000, 'ºC'),
	(204824, 121, '2014-02-15 00:16:42.000000', 'temperatura', 46.0000, 'ºC'),
	(204825, 121, '2014-02-15 00:16:43.000000', 'temperatura', 748.0000, 'ºC'),
	(204826, 121, '2014-02-15 00:16:44.000000', 'temperatura', 4.0000, 'ºC'),
	(204827, 121, '2014-02-15 00:16:45.000000', 'temperatura', 177.0000, 'ºC'),
	(204828, 121, '2014-02-15 00:16:46.000000', 'temperatura', 872.0000, 'ºC'),
	(204829, 121, '2014-02-15 00:16:47.000000', 'temperatura', 229.0000, 'ºC'),
	(204830, 121, '2014-02-15 00:16:48.000000', 'temperatura', 929.0000, 'ºC'),
	(204831, 121, '2014-02-15 00:16:49.000000', 'temperatura', 358.0000, 'ºC'),
	(204832, 121, '2014-02-15 00:16:50.000000', 'temperatura', 204.0000, 'ºC'),
	(204833, 121, '2014-02-15 00:16:51.000000', 'temperatura', 1146.0000, 'ºC'),
	(204834, 121, '2014-02-15 00:16:52.000000', 'temperatura', 318.0000, 'ºC'),
	(204835, 121, '2014-02-15 00:16:53.000000', 'temperatura', 554.0000, 'ºC'),
	(204836, 121, '2014-02-15 00:16:54.000000', 'temperatura', 615.0000, 'ºC'),
	(204837, 121, '2014-02-15 00:16:55.000000', 'temperatura', 214.0000, 'ºC'),
	(204838, 121, '2014-02-15 00:16:56.000000', 'temperatura', 426.0000, 'ºC'),
	(204839, 121, '2014-02-15 00:16:57.000000', 'temperatura', 289.0000, 'ºC'),
	(204840, 121, '2014-02-15 00:16:58.000000', 'temperatura', 166.0000, 'ºC'),
	(204841, 121, '2014-02-15 00:16:59.000000', 'temperatura', 1163.0000, 'ºC'),
	(204842, 121, '2014-02-15 00:17:00.000000', 'temperatura', 519.0000, 'ºC'),
	(204843, 121, '2014-02-15 00:17:01.000000', 'temperatura', 306.0000, 'ºC'),
	(204844, 121, '2014-02-15 00:17:02.000000', 'temperatura', 1173.0000, 'ºC'),
	(204845, 121, '2014-02-15 00:17:03.000000', 'temperatura', 150.0000, 'ºC'),
	(204846, 121, '2014-02-15 00:17:04.000000', 'temperatura', 828.0000, 'ºC'),
	(204847, 121, '2014-02-15 00:17:05.000000', 'temperatura', 92.0000, 'ºC'),
	(204848, 121, '2014-02-15 00:17:06.000000', 'temperatura', 375.0000, 'ºC'),
	(204849, 121, '2014-02-15 00:17:07.000000', 'temperatura', 400.0000, 'ºC'),
	(204850, 121, '2014-02-15 00:17:08.000000', 'temperatura', 875.0000, 'ºC'),
	(204851, 121, '2014-02-15 00:17:09.000000', 'temperatura', 776.0000, 'ºC'),
	(204852, 121, '2014-02-15 00:17:10.000000', 'temperatura', 57.0000, 'ºC'),
	(204853, 121, '2014-02-15 00:17:11.000000', 'temperatura', 358.0000, 'ºC'),
	(204854, 121, '2014-02-15 00:17:12.000000', 'temperatura', 416.0000, 'ºC'),
	(204855, 121, '2014-02-15 00:17:13.000000', 'temperatura', 1010.0000, 'ºC'),
	(204856, 121, '2014-02-15 00:17:14.000000', 'temperatura', 202.0000, 'ºC'),
	(204857, 121, '2014-02-15 00:17:15.000000', 'temperatura', 380.0000, 'ºC'),
	(204858, 121, '2014-02-15 00:17:16.000000', 'temperatura', 95.0000, 'ºC'),
	(204859, 121, '2014-02-15 00:17:17.000000', 'temperatura', 536.0000, 'ºC'),
	(204860, 121, '2014-02-15 00:17:18.000000', 'temperatura', 1197.0000, 'ºC'),
	(204861, 121, '2014-02-15 00:17:19.000000', 'temperatura', 776.0000, 'ºC'),
	(204862, 121, '2014-02-15 00:17:20.000000', 'temperatura', 291.0000, 'ºC'),
	(204863, 121, '2014-02-15 00:17:21.000000', 'temperatura', 324.0000, 'ºC'),
	(204864, 121, '2014-02-15 00:17:22.000000', 'temperatura', 751.0000, 'ºC'),
	(204865, 121, '2014-02-15 00:17:23.000000', 'temperatura', 382.0000, 'ºC'),
	(204866, 121, '2014-02-15 00:17:24.000000', 'temperatura', 856.0000, 'ºC'),
	(204867, 121, '2014-02-15 00:17:25.000000', 'temperatura', 737.0000, 'ºC'),
	(204868, 121, '2014-02-15 00:17:26.000000', 'temperatura', 1118.0000, 'ºC'),
	(204869, 121, '2014-02-15 00:17:27.000000', 'temperatura', 979.0000, 'ºC'),
	(204870, 121, '2014-02-15 00:17:28.000000', 'temperatura', 341.0000, 'ºC'),
	(204871, 121, '2014-02-15 00:17:29.000000', 'temperatura', 1168.0000, 'ºC'),
	(204872, 121, '2014-02-15 00:17:30.000000', 'temperatura', 18.0000, 'ºC'),
	(204873, 121, '2014-02-15 00:17:31.000000', 'temperatura', 186.0000, 'ºC'),
	(204874, 121, '2014-02-15 00:17:32.000000', 'temperatura', 877.0000, 'ºC'),
	(204875, 121, '2014-02-15 00:17:33.000000', 'temperatura', 226.0000, 'ºC'),
	(204876, 121, '2014-02-15 00:17:34.000000', 'temperatura', 900.0000, 'ºC'),
	(204877, 121, '2014-02-15 00:17:35.000000', 'temperatura', 224.0000, 'ºC'),
	(204878, 121, '2014-02-15 00:17:36.000000', 'temperatura', 821.0000, 'ºC'),
	(204879, 121, '2014-02-15 00:17:37.000000', 'temperatura', 1030.0000, 'ºC'),
	(204880, 121, '2014-02-15 00:17:38.000000', 'temperatura', 291.0000, 'ºC'),
	(204881, 121, '2014-02-15 00:17:39.000000', 'temperatura', 766.0000, 'ºC'),
	(204882, 121, '2014-02-15 00:17:40.000000', 'temperatura', 556.0000, 'ºC'),
	(204883, 121, '2014-02-15 00:17:41.000000', 'temperatura', 482.0000, 'ºC'),
	(204884, 121, '2014-02-15 00:17:42.000000', 'temperatura', 744.0000, 'ºC'),
	(204885, 121, '2014-02-15 00:17:43.000000', 'temperatura', 1076.0000, 'ºC'),
	(204886, 121, '2014-02-15 00:17:44.000000', 'temperatura', 746.0000, 'ºC'),
	(204887, 121, '2014-02-15 00:17:45.000000', 'temperatura', 505.0000, 'ºC'),
	(204888, 121, '2014-02-15 00:17:46.000000', 'temperatura', 284.0000, 'ºC'),
	(204889, 121, '2014-02-15 00:17:47.000000', 'temperatura', 1108.0000, 'ºC'),
	(204890, 121, '2014-02-15 00:17:48.000000', 'temperatura', 1086.0000, 'ºC'),
	(204891, 121, '2014-02-15 00:17:49.000000', 'temperatura', 908.0000, 'ºC'),
	(204892, 121, '2014-02-15 00:17:50.000000', 'temperatura', 81.0000, 'ºC'),
	(204893, 121, '2014-02-15 00:17:51.000000', 'temperatura', 83.0000, 'ºC'),
	(204894, 121, '2014-02-15 00:17:52.000000', 'temperatura', 172.0000, 'ºC'),
	(204895, 121, '2014-02-15 00:17:53.000000', 'temperatura', 613.0000, 'ºC'),
	(204896, 121, '2014-02-15 00:17:54.000000', 'temperatura', 149.0000, 'ºC'),
	(204897, 121, '2014-02-15 00:17:55.000000', 'temperatura', 108.0000, 'ºC'),
	(204898, 121, '2014-02-15 00:17:56.000000', 'temperatura', 93.0000, 'ºC'),
	(204899, 121, '2014-02-15 00:17:57.000000', 'temperatura', 141.0000, 'ºC'),
	(204900, 121, '2014-02-15 00:17:58.000000', 'temperatura', 426.0000, 'ºC'),
	(204901, 121, '2014-02-15 00:17:59.000000', 'temperatura', 506.0000, 'ºC'),
	(204902, 121, '2014-02-15 00:18:00.000000', 'temperatura', 53.0000, 'ºC'),
	(204903, 121, '2014-02-15 00:18:01.000000', 'temperatura', 1147.0000, 'ºC'),
	(204904, 121, '2014-02-15 00:18:02.000000', 'temperatura', 777.0000, 'ºC'),
	(204905, 121, '2014-02-15 00:18:03.000000', 'temperatura', 445.0000, 'ºC'),
	(204906, 121, '2014-02-15 00:18:04.000000', 'temperatura', 1094.0000, 'ºC'),
	(204907, 121, '2014-02-15 00:18:05.000000', 'temperatura', 537.0000, 'ºC'),
	(204908, 121, '2014-02-15 00:18:06.000000', 'temperatura', 604.0000, 'ºC'),
	(204909, 121, '2014-02-15 00:18:07.000000', 'temperatura', 208.0000, 'ºC'),
	(204910, 121, '2014-02-15 00:18:08.000000', 'temperatura', 429.0000, 'ºC'),
	(204911, 121, '2014-02-15 00:18:09.000000', 'temperatura', 323.0000, 'ºC'),
	(204912, 121, '2014-02-15 00:18:10.000000', 'temperatura', 329.0000, 'ºC'),
	(204913, 121, '2014-02-15 00:18:11.000000', 'temperatura', 674.0000, 'ºC'),
	(204914, 121, '2014-02-15 00:18:12.000000', 'temperatura', 1185.0000, 'ºC'),
	(204915, 121, '2014-02-15 00:18:13.000000', 'temperatura', 301.0000, 'ºC'),
	(204916, 121, '2014-02-15 00:18:14.000000', 'temperatura', 354.0000, 'ºC'),
	(204917, 121, '2014-02-15 00:18:15.000000', 'temperatura', 864.0000, 'ºC'),
	(204918, 121, '2014-02-15 00:18:16.000000', 'temperatura', 861.0000, 'ºC'),
	(204919, 121, '2014-02-15 00:18:17.000000', 'temperatura', 511.0000, 'ºC'),
	(204920, 121, '2014-02-15 00:18:18.000000', 'temperatura', 1175.0000, 'ºC'),
	(204921, 121, '2014-02-15 00:18:19.000000', 'temperatura', 741.0000, 'ºC'),
	(204922, 121, '2014-02-15 00:18:20.000000', 'temperatura', 182.0000, 'ºC'),
	(204923, 121, '2014-02-15 00:18:21.000000', 'temperatura', 1088.0000, 'ºC'),
	(204924, 121, '2014-02-15 00:18:22.000000', 'temperatura', 94.0000, 'ºC'),
	(204925, 121, '2014-02-15 00:18:23.000000', 'temperatura', 808.0000, 'ºC'),
	(204926, 121, '2014-02-15 00:18:24.000000', 'temperatura', 159.0000, 'ºC'),
	(204927, 121, '2014-02-15 00:18:25.000000', 'temperatura', 769.0000, 'ºC'),
	(204928, 121, '2014-02-15 00:18:26.000000', 'temperatura', 971.0000, 'ºC'),
	(204929, 121, '2014-02-15 00:18:27.000000', 'temperatura', 149.0000, 'ºC'),
	(204930, 121, '2014-02-15 00:18:28.000000', 'temperatura', 232.0000, 'ºC'),
	(204931, 121, '2014-02-15 00:18:29.000000', 'temperatura', 712.0000, 'ºC'),
	(204932, 121, '2014-02-15 00:18:30.000000', 'temperatura', 467.0000, 'ºC'),
	(204933, 121, '2014-02-15 00:18:31.000000', 'temperatura', 197.0000, 'ºC'),
	(204934, 121, '2014-02-15 00:18:32.000000', 'temperatura', 787.0000, 'ºC'),
	(204935, 121, '2014-02-15 00:18:33.000000', 'temperatura', 945.0000, 'ºC'),
	(204936, 121, '2014-02-15 00:18:34.000000', 'temperatura', 1164.0000, 'ºC'),
	(204937, 121, '2014-02-15 00:18:35.000000', 'temperatura', 583.0000, 'ºC'),
	(204938, 121, '2014-02-15 00:18:36.000000', 'temperatura', 625.0000, 'ºC'),
	(204939, 121, '2014-02-15 00:18:37.000000', 'temperatura', 177.0000, 'ºC'),
	(204940, 121, '2014-02-15 00:18:38.000000', 'temperatura', 212.0000, 'ºC'),
	(204941, 121, '2014-02-15 00:18:39.000000', 'temperatura', 526.0000, 'ºC'),
	(204942, 121, '2014-02-15 00:18:40.000000', 'temperatura', 797.0000, 'ºC'),
	(204943, 121, '2014-02-15 00:18:41.000000', 'temperatura', 7.0000, 'ºC'),
	(204944, 121, '2014-02-15 00:18:42.000000', 'temperatura', 43.0000, 'ºC'),
	(204945, 121, '2014-02-15 00:18:43.000000', 'temperatura', 195.0000, 'ºC'),
	(204946, 121, '2014-02-15 00:18:44.000000', 'temperatura', 847.0000, 'ºC'),
	(204947, 121, '2014-02-15 00:18:45.000000', 'temperatura', 52.0000, 'ºC'),
	(204948, 121, '2014-02-15 00:18:46.000000', 'temperatura', 120.0000, 'ºC'),
	(204949, 121, '2014-02-15 00:18:47.000000', 'temperatura', 445.0000, 'ºC'),
	(204950, 121, '2014-02-15 00:18:48.000000', 'temperatura', 666.0000, 'ºC'),
	(204951, 121, '2014-02-15 00:18:49.000000', 'temperatura', 793.0000, 'ºC'),
	(204952, 121, '2014-02-15 00:18:50.000000', 'temperatura', 767.0000, 'ºC'),
	(204953, 121, '2014-02-15 00:18:51.000000', 'temperatura', 257.0000, 'ºC'),
	(204954, 121, '2014-02-15 00:18:52.000000', 'temperatura', 185.0000, 'ºC'),
	(204955, 121, '2014-02-15 00:18:53.000000', 'temperatura', 153.0000, 'ºC'),
	(204956, 121, '2014-02-15 00:18:54.000000', 'temperatura', 213.0000, 'ºC'),
	(204957, 121, '2014-02-15 00:18:55.000000', 'temperatura', 607.0000, 'ºC'),
	(204958, 121, '2014-02-15 00:18:56.000000', 'temperatura', 1195.0000, 'ºC'),
	(204959, 121, '2014-02-15 00:18:57.000000', 'temperatura', 556.0000, 'ºC'),
	(204960, 121, '2014-02-15 00:18:58.000000', 'temperatura', 396.0000, 'ºC'),
	(204961, 121, '2014-02-15 00:18:59.000000', 'temperatura', 312.0000, 'ºC'),
	(204962, 121, '2014-02-15 00:19:00.000000', 'temperatura', 370.0000, 'ºC'),
	(204963, 121, '2014-02-15 00:19:01.000000', 'temperatura', 916.0000, 'ºC'),
	(204964, 121, '2014-02-15 00:19:02.000000', 'temperatura', 1072.0000, 'ºC'),
	(204965, 121, '2014-02-15 00:19:03.000000', 'temperatura', 210.0000, 'ºC'),
	(204966, 121, '2014-02-15 00:19:04.000000', 'temperatura', 236.0000, 'ºC'),
	(204967, 121, '2014-02-15 00:19:05.000000', 'temperatura', 551.0000, 'ºC'),
	(204968, 121, '2014-02-15 00:19:06.000000', 'temperatura', 849.0000, 'ºC'),
	(204969, 121, '2014-02-15 00:19:07.000000', 'temperatura', 190.0000, 'ºC'),
	(204970, 121, '2014-02-15 00:19:08.000000', 'temperatura', 804.0000, 'ºC'),
	(204971, 121, '2014-02-15 00:19:09.000000', 'temperatura', 1049.0000, 'ºC'),
	(204972, 121, '2014-02-15 00:19:10.000000', 'temperatura', 433.0000, 'ºC'),
	(204973, 121, '2014-02-15 00:19:11.000000', 'temperatura', 219.0000, 'ºC'),
	(204974, 121, '2014-02-15 00:19:12.000000', 'temperatura', 996.0000, 'ºC'),
	(204975, 121, '2014-02-15 00:19:13.000000', 'temperatura', 725.0000, 'ºC'),
	(204976, 121, '2014-02-15 00:19:14.000000', 'temperatura', 639.0000, 'ºC'),
	(204977, 121, '2014-02-15 00:19:15.000000', 'temperatura', 1018.0000, 'ºC'),
	(204978, 121, '2014-02-15 00:19:16.000000', 'temperatura', 775.0000, 'ºC'),
	(204979, 121, '2014-02-15 00:19:17.000000', 'temperatura', 821.0000, 'ºC'),
	(204980, 121, '2014-02-15 00:19:18.000000', 'temperatura', 581.0000, 'ºC'),
	(204981, 121, '2014-02-15 00:19:19.000000', 'temperatura', 443.0000, 'ºC'),
	(204982, 121, '2014-02-15 00:19:20.000000', 'temperatura', 471.0000, 'ºC'),
	(204983, 121, '2014-02-15 00:19:21.000000', 'temperatura', 1025.0000, 'ºC'),
	(204984, 121, '2014-02-15 00:19:22.000000', 'temperatura', 114.0000, 'ºC'),
	(204985, 121, '2014-02-15 00:19:23.000000', 'temperatura', 1097.0000, 'ºC'),
	(204986, 121, '2014-02-15 00:19:24.000000', 'temperatura', 342.0000, 'ºC'),
	(204987, 121, '2014-02-15 00:19:25.000000', 'temperatura', 819.0000, 'ºC'),
	(204988, 121, '2014-02-15 00:19:26.000000', 'temperatura', 670.0000, 'ºC'),
	(204989, 121, '2014-02-15 00:19:27.000000', 'temperatura', 894.0000, 'ºC'),
	(204990, 121, '2014-02-15 00:19:28.000000', 'temperatura', 60.0000, 'ºC'),
	(204991, 121, '2014-02-15 00:19:29.000000', 'temperatura', 19.0000, 'ºC'),
	(204992, 121, '2014-02-15 00:19:30.000000', 'temperatura', 1115.0000, 'ºC'),
	(204993, 121, '2014-02-15 00:19:31.000000', 'temperatura', 717.0000, 'ºC'),
	(204994, 121, '2014-02-15 00:19:32.000000', 'temperatura', 243.0000, 'ºC'),
	(204995, 121, '2014-02-15 00:19:33.000000', 'temperatura', 264.0000, 'ºC'),
	(204996, 121, '2014-02-15 00:19:34.000000', 'temperatura', 592.0000, 'ºC'),
	(204997, 121, '2014-02-15 00:19:35.000000', 'temperatura', 969.0000, 'ºC'),
	(204998, 121, '2014-02-15 00:19:36.000000', 'temperatura', 668.0000, 'ºC'),
	(204999, 121, '2014-02-15 00:19:37.000000', 'temperatura', 433.0000, 'ºC'),
	(205000, 121, '2014-02-15 00:19:38.000000', 'temperatura', 163.0000, 'ºC'),
	(205001, 121, '2014-02-15 00:19:39.000000', 'temperatura', 717.0000, 'ºC'),
	(205002, 121, '2014-02-15 00:19:40.000000', 'temperatura', 694.0000, 'ºC'),
	(205003, 121, '2014-02-15 00:19:41.000000', 'temperatura', 121.0000, 'ºC'),
	(205004, 121, '2014-02-15 00:19:42.000000', 'temperatura', 922.0000, 'ºC'),
	(205005, 121, '2014-02-15 00:19:43.000000', 'temperatura', 649.0000, 'ºC'),
	(205006, 121, '2014-02-15 00:19:44.000000', 'temperatura', 481.0000, 'ºC'),
	(205007, 121, '2014-02-15 00:19:45.000000', 'temperatura', 457.0000, 'ºC'),
	(205008, 121, '2014-02-15 00:19:46.000000', 'temperatura', 842.0000, 'ºC'),
	(205009, 121, '2014-02-15 00:19:47.000000', 'temperatura', 440.0000, 'ºC'),
	(205010, 121, '2014-02-15 00:19:48.000000', 'temperatura', 875.0000, 'ºC'),
	(205011, 121, '2014-02-15 00:19:49.000000', 'temperatura', 654.0000, 'ºC'),
	(205012, 121, '2014-02-15 00:19:50.000000', 'temperatura', 648.0000, 'ºC'),
	(205013, 121, '2014-02-15 00:19:51.000000', 'temperatura', 78.0000, 'ºC'),
	(205014, 121, '2014-02-15 00:19:52.000000', 'temperatura', 847.0000, 'ºC'),
	(205015, 121, '2014-02-15 00:19:53.000000', 'temperatura', 402.0000, 'ºC'),
	(205016, 121, '2014-02-15 00:19:54.000000', 'temperatura', 670.0000, 'ºC'),
	(205017, 121, '2014-02-15 00:19:55.000000', 'temperatura', 945.0000, 'ºC'),
	(205018, 121, '2014-02-15 00:19:56.000000', 'temperatura', 316.0000, 'ºC'),
	(205019, 121, '2014-02-15 00:19:57.000000', 'temperatura', 1146.0000, 'ºC'),
	(205020, 121, '2014-02-15 00:19:58.000000', 'temperatura', 1180.0000, 'ºC'),
	(205021, 121, '2014-02-15 00:19:59.000000', 'temperatura', 64.0000, 'ºC'),
	(205022, 121, '2014-02-15 00:20:00.000000', 'temperatura', 380.0000, 'ºC'),
	(205023, 121, '2014-02-15 00:20:01.000000', 'temperatura', 506.0000, 'ºC'),
	(205024, 121, '2014-02-15 00:20:02.000000', 'temperatura', 194.0000, 'ºC'),
	(205025, 121, '2014-02-15 00:20:03.000000', 'temperatura', 653.0000, 'ºC'),
	(205026, 121, '2014-02-15 00:20:04.000000', 'temperatura', 284.0000, 'ºC'),
	(205027, 121, '2014-02-15 00:20:05.000000', 'temperatura', 658.0000, 'ºC'),
	(205028, 121, '2014-02-15 00:20:06.000000', 'temperatura', 41.0000, 'ºC'),
	(205029, 121, '2014-02-15 00:20:07.000000', 'temperatura', 633.0000, 'ºC'),
	(205030, 121, '2014-02-15 00:20:08.000000', 'temperatura', 640.0000, 'ºC'),
	(205031, 121, '2014-02-15 00:20:09.000000', 'temperatura', 101.0000, 'ºC'),
	(205032, 121, '2014-02-15 00:20:10.000000', 'temperatura', 985.0000, 'ºC'),
	(205033, 121, '2014-02-15 00:20:11.000000', 'temperatura', 1025.0000, 'ºC'),
	(205034, 121, '2014-02-15 00:20:12.000000', 'temperatura', 968.0000, 'ºC'),
	(205035, 121, '2014-02-15 00:20:13.000000', 'temperatura', 566.0000, 'ºC'),
	(205036, 121, '2014-02-15 00:20:14.000000', 'temperatura', 1126.0000, 'ºC'),
	(205037, 121, '2014-02-15 00:20:15.000000', 'temperatura', 334.0000, 'ºC'),
	(205038, 121, '2014-02-15 00:20:16.000000', 'temperatura', 693.0000, 'ºC'),
	(205039, 121, '2014-02-15 00:20:17.000000', 'temperatura', 64.0000, 'ºC'),
	(205040, 121, '2014-02-15 00:20:18.000000', 'temperatura', 642.0000, 'ºC'),
	(205041, 121, '2014-02-15 00:20:19.000000', 'temperatura', 616.0000, 'ºC'),
	(205042, 121, '2014-02-15 00:20:20.000000', 'temperatura', 1154.0000, 'ºC'),
	(205043, 121, '2014-02-15 00:20:21.000000', 'temperatura', 324.0000, 'ºC'),
	(205044, 121, '2014-02-15 00:20:22.000000', 'temperatura', 559.0000, 'ºC'),
	(205045, 121, '2014-02-15 00:20:23.000000', 'temperatura', 624.0000, 'ºC'),
	(205046, 121, '2014-02-15 00:20:24.000000', 'temperatura', 245.0000, 'ºC'),
	(205047, 121, '2014-02-15 00:20:25.000000', 'temperatura', 550.0000, 'ºC'),
	(205048, 121, '2014-02-15 00:20:26.000000', 'temperatura', 819.0000, 'ºC'),
	(205049, 121, '2014-02-15 00:20:27.000000', 'temperatura', 44.0000, 'ºC'),
	(205050, 121, '2014-02-15 00:20:28.000000', 'temperatura', 164.0000, 'ºC'),
	(205051, 121, '2014-02-15 00:20:29.000000', 'temperatura', 687.0000, 'ºC'),
	(205052, 121, '2014-02-15 00:20:30.000000', 'temperatura', 543.0000, 'ºC'),
	(205053, 121, '2014-02-15 00:20:31.000000', 'temperatura', 654.0000, 'ºC'),
	(205054, 121, '2014-02-15 00:20:32.000000', 'temperatura', 444.0000, 'ºC'),
	(205055, 121, '2014-02-15 00:20:33.000000', 'temperatura', 257.0000, 'ºC'),
	(205056, 121, '2014-02-15 00:20:34.000000', 'temperatura', 1155.0000, 'ºC'),
	(205057, 121, '2014-02-15 00:20:35.000000', 'temperatura', 202.0000, 'ºC'),
	(205058, 121, '2014-02-15 00:20:36.000000', 'temperatura', 1146.0000, 'ºC'),
	(205059, 121, '2014-02-15 00:20:37.000000', 'temperatura', 326.0000, 'ºC'),
	(205060, 121, '2014-02-15 00:20:38.000000', 'temperatura', 592.0000, 'ºC'),
	(205061, 121, '2014-02-15 00:20:39.000000', 'temperatura', 780.0000, 'ºC'),
	(205062, 121, '2014-02-15 00:20:40.000000', 'temperatura', 928.0000, 'ºC'),
	(205063, 121, '2014-02-15 00:20:41.000000', 'temperatura', 1099.0000, 'ºC'),
	(205064, 121, '2014-02-15 00:20:42.000000', 'temperatura', 312.0000, 'ºC'),
	(205065, 121, '2014-02-15 00:20:43.000000', 'temperatura', 662.0000, 'ºC'),
	(205066, 121, '2014-02-15 00:20:44.000000', 'temperatura', 1177.0000, 'ºC'),
	(205067, 121, '2014-02-15 00:20:45.000000', 'temperatura', 299.0000, 'ºC'),
	(205068, 121, '2014-02-15 00:20:46.000000', 'temperatura', 362.0000, 'ºC'),
	(205069, 121, '2014-02-15 00:20:47.000000', 'temperatura', 917.0000, 'ºC'),
	(205070, 121, '2014-02-15 00:20:48.000000', 'temperatura', 1098.0000, 'ºC'),
	(205071, 121, '2014-02-15 00:20:49.000000', 'temperatura', 340.0000, 'ºC'),
	(205072, 121, '2014-02-15 00:20:50.000000', 'temperatura', 806.0000, 'ºC'),
	(205073, 121, '2014-02-15 00:20:51.000000', 'temperatura', 609.0000, 'ºC'),
	(205074, 121, '2014-02-15 00:20:52.000000', 'temperatura', 629.0000, 'ºC'),
	(205075, 121, '2014-02-15 00:20:53.000000', 'temperatura', 116.0000, 'ºC'),
	(205076, 121, '2014-02-15 00:20:54.000000', 'temperatura', 1096.0000, 'ºC'),
	(205077, 121, '2014-02-15 00:20:55.000000', 'temperatura', 334.0000, 'ºC'),
	(205078, 121, '2014-02-15 00:20:56.000000', 'temperatura', 781.0000, 'ºC'),
	(205079, 121, '2014-02-15 00:20:57.000000', 'temperatura', 503.0000, 'ºC'),
	(205080, 121, '2014-02-15 00:20:58.000000', 'temperatura', 174.0000, 'ºC'),
	(205081, 121, '2014-02-15 00:20:59.000000', 'temperatura', 561.0000, 'ºC'),
	(205082, 121, '2014-02-15 00:21:00.000000', 'temperatura', 1081.0000, 'ºC'),
	(205083, 121, '2014-02-15 00:21:01.000000', 'temperatura', 125.0000, 'ºC'),
	(205084, 121, '2014-02-15 00:21:02.000000', 'temperatura', 982.0000, 'ºC'),
	(205085, 121, '2014-02-15 00:21:03.000000', 'temperatura', 937.0000, 'ºC'),
	(205086, 121, '2014-02-15 00:21:04.000000', 'temperatura', 540.0000, 'ºC'),
	(205087, 121, '2014-02-15 00:21:05.000000', 'temperatura', 1088.0000, 'ºC'),
	(205088, 121, '2014-02-15 00:21:06.000000', 'temperatura', 219.0000, 'ºC'),
	(205089, 121, '2014-02-15 00:21:07.000000', 'temperatura', 233.0000, 'ºC'),
	(205090, 121, '2014-02-15 00:21:08.000000', 'temperatura', 509.0000, 'ºC'),
	(205091, 121, '2014-02-15 00:21:09.000000', 'temperatura', 644.0000, 'ºC'),
	(205092, 121, '2014-02-15 00:21:10.000000', 'temperatura', 495.0000, 'ºC'),
	(205093, 121, '2014-02-15 00:21:11.000000', 'temperatura', 544.0000, 'ºC'),
	(205094, 121, '2014-02-15 00:21:12.000000', 'temperatura', 34.0000, 'ºC'),
	(205095, 121, '2014-02-15 00:21:13.000000', 'temperatura', 938.0000, 'ºC'),
	(205096, 121, '2014-02-15 00:21:14.000000', 'temperatura', 990.0000, 'ºC'),
	(205097, 121, '2014-02-15 00:21:15.000000', 'temperatura', 937.0000, 'ºC'),
	(205098, 121, '2014-02-15 00:21:16.000000', 'temperatura', 515.0000, 'ºC'),
	(205099, 121, '2014-02-15 00:21:17.000000', 'temperatura', 966.0000, 'ºC'),
	(205100, 121, '2014-02-15 00:21:18.000000', 'temperatura', 883.0000, 'ºC'),
	(205101, 121, '2014-02-15 00:21:19.000000', 'temperatura', 319.0000, 'ºC'),
	(205102, 121, '2014-02-15 00:21:20.000000', 'temperatura', 146.0000, 'ºC'),
	(205103, 121, '2014-02-15 00:21:21.000000', 'temperatura', 973.0000, 'ºC'),
	(205104, 121, '2014-02-15 00:21:22.000000', 'temperatura', 830.0000, 'ºC'),
	(205105, 121, '2014-02-15 00:21:23.000000', 'temperatura', 29.0000, 'ºC'),
	(205106, 121, '2014-02-15 00:21:24.000000', 'temperatura', 55.0000, 'ºC'),
	(205107, 121, '2014-02-15 00:21:25.000000', 'temperatura', 190.0000, 'ºC'),
	(205108, 121, '2014-02-15 00:21:26.000000', 'temperatura', 786.0000, 'ºC'),
	(205109, 121, '2014-02-15 00:21:27.000000', 'temperatura', 960.0000, 'ºC'),
	(205110, 121, '2014-02-15 00:21:28.000000', 'temperatura', 42.0000, 'ºC'),
	(205111, 121, '2014-02-15 00:21:29.000000', 'temperatura', 931.0000, 'ºC'),
	(205112, 121, '2014-02-15 00:21:30.000000', 'temperatura', 931.0000, 'ºC'),
	(205113, 121, '2014-02-15 00:21:31.000000', 'temperatura', 663.0000, 'ºC'),
	(205114, 121, '2014-02-15 00:21:32.000000', 'temperatura', 520.0000, 'ºC'),
	(205115, 121, '2014-02-15 00:21:33.000000', 'temperatura', 611.0000, 'ºC'),
	(205116, 121, '2014-02-15 00:21:34.000000', 'temperatura', 297.0000, 'ºC'),
	(205117, 121, '2014-02-15 00:21:35.000000', 'temperatura', 851.0000, 'ºC'),
	(205118, 121, '2014-02-15 00:21:36.000000', 'temperatura', 967.0000, 'ºC'),
	(205119, 121, '2014-02-15 00:21:37.000000', 'temperatura', 1083.0000, 'ºC'),
	(205120, 121, '2014-02-15 00:21:38.000000', 'temperatura', 114.0000, 'ºC'),
	(205121, 121, '2014-02-15 00:21:39.000000', 'temperatura', 919.0000, 'ºC'),
	(205122, 121, '2014-02-15 00:21:40.000000', 'temperatura', 656.0000, 'ºC'),
	(205123, 121, '2014-02-15 00:21:41.000000', 'temperatura', 521.0000, 'ºC'),
	(205124, 121, '2014-02-15 00:21:42.000000', 'temperatura', 641.0000, 'ºC'),
	(205125, 121, '2014-02-15 00:21:43.000000', 'temperatura', 439.0000, 'ºC'),
	(205126, 121, '2014-02-15 00:21:44.000000', 'temperatura', 274.0000, 'ºC'),
	(205127, 121, '2014-02-15 00:21:45.000000', 'temperatura', 52.0000, 'ºC'),
	(205128, 121, '2014-02-15 00:21:46.000000', 'temperatura', 638.0000, 'ºC'),
	(205129, 121, '2014-02-15 00:21:47.000000', 'temperatura', 636.0000, 'ºC'),
	(205130, 121, '2014-02-15 00:21:48.000000', 'temperatura', 67.0000, 'ºC'),
	(205131, 121, '2014-02-15 00:21:49.000000', 'temperatura', 828.0000, 'ºC'),
	(205132, 121, '2014-02-15 00:21:50.000000', 'temperatura', 337.0000, 'ºC'),
	(205133, 121, '2014-02-15 00:21:51.000000', 'temperatura', 404.0000, 'ºC'),
	(205134, 121, '2014-02-15 00:21:52.000000', 'temperatura', 1008.0000, 'ºC'),
	(205135, 121, '2014-02-15 00:21:53.000000', 'temperatura', 231.0000, 'ºC'),
	(205136, 121, '2014-02-15 00:21:54.000000', 'temperatura', 530.0000, 'ºC'),
	(205137, 121, '2014-02-15 00:21:55.000000', 'temperatura', 758.0000, 'ºC'),
	(205138, 121, '2014-02-15 00:21:56.000000', 'temperatura', 1002.0000, 'ºC'),
	(205139, 121, '2014-02-15 00:21:57.000000', 'temperatura', 334.0000, 'ºC'),
	(205140, 121, '2014-02-15 00:21:58.000000', 'temperatura', 1065.0000, 'ºC'),
	(205141, 121, '2014-02-15 00:21:59.000000', 'temperatura', 724.0000, 'ºC'),
	(205142, 121, '2014-02-15 00:22:00.000000', 'temperatura', 424.0000, 'ºC'),
	(205143, 121, '2014-02-15 00:22:01.000000', 'temperatura', 1148.0000, 'ºC'),
	(205144, 121, '2014-02-15 00:22:02.000000', 'temperatura', 870.0000, 'ºC'),
	(205145, 121, '2014-02-15 00:22:03.000000', 'temperatura', 906.0000, 'ºC'),
	(205146, 121, '2014-02-15 00:22:04.000000', 'temperatura', 720.0000, 'ºC'),
	(205147, 121, '2014-02-15 00:22:05.000000', 'temperatura', 882.0000, 'ºC'),
	(205148, 121, '2014-02-15 00:22:06.000000', 'temperatura', 1049.0000, 'ºC'),
	(205149, 121, '2014-02-15 00:22:07.000000', 'temperatura', 203.0000, 'ºC'),
	(205150, 121, '2014-02-15 00:22:08.000000', 'temperatura', 267.0000, 'ºC'),
	(205151, 121, '2014-02-15 00:22:09.000000', 'temperatura', 728.0000, 'ºC'),
	(205152, 121, '2014-02-15 00:22:10.000000', 'temperatura', 440.0000, 'ºC'),
	(205153, 121, '2014-02-15 00:22:11.000000', 'temperatura', 14.0000, 'ºC'),
	(205154, 121, '2014-02-15 00:22:12.000000', 'temperatura', 1150.0000, 'ºC'),
	(205155, 121, '2014-02-15 00:22:13.000000', 'temperatura', 909.0000, 'ºC'),
	(205156, 121, '2014-02-15 00:22:14.000000', 'temperatura', 1096.0000, 'ºC'),
	(205157, 121, '2014-02-15 00:22:15.000000', 'temperatura', 353.0000, 'ºC'),
	(205158, 121, '2014-02-15 00:22:16.000000', 'temperatura', 880.0000, 'ºC'),
	(205159, 121, '2014-02-15 00:22:17.000000', 'temperatura', 939.0000, 'ºC'),
	(205160, 121, '2014-02-15 00:22:18.000000', 'temperatura', 855.0000, 'ºC'),
	(205161, 121, '2014-02-15 00:22:19.000000', 'temperatura', 257.0000, 'ºC'),
	(205162, 121, '2014-02-15 00:22:20.000000', 'temperatura', 1123.0000, 'ºC'),
	(205163, 121, '2014-02-15 00:22:21.000000', 'temperatura', 45.0000, 'ºC'),
	(205164, 121, '2014-02-15 00:22:22.000000', 'temperatura', 458.0000, 'ºC'),
	(205165, 121, '2014-02-15 00:22:23.000000', 'temperatura', 953.0000, 'ºC'),
	(205166, 121, '2014-02-15 00:22:24.000000', 'temperatura', 992.0000, 'ºC'),
	(205167, 121, '2014-02-15 00:22:25.000000', 'temperatura', 899.0000, 'ºC'),
	(205168, 121, '2014-02-15 00:22:26.000000', 'temperatura', 323.0000, 'ºC'),
	(205169, 121, '2014-02-15 00:22:27.000000', 'temperatura', 119.0000, 'ºC'),
	(205170, 121, '2014-02-15 00:22:28.000000', 'temperatura', 825.0000, 'ºC'),
	(205171, 121, '2014-02-15 00:22:29.000000', 'temperatura', 169.0000, 'ºC'),
	(205172, 121, '2014-02-15 00:22:30.000000', 'temperatura', 769.0000, 'ºC'),
	(205173, 121, '2014-02-15 00:22:31.000000', 'temperatura', 938.0000, 'ºC'),
	(205174, 121, '2014-02-15 00:22:32.000000', 'temperatura', 1184.0000, 'ºC'),
	(205175, 121, '2014-02-15 00:22:33.000000', 'temperatura', 705.0000, 'ºC'),
	(205176, 121, '2014-02-15 00:22:34.000000', 'temperatura', 1176.0000, 'ºC'),
	(205177, 121, '2014-02-15 00:22:35.000000', 'temperatura', 166.0000, 'ºC'),
	(205178, 121, '2014-02-15 00:22:36.000000', 'temperatura', 902.0000, 'ºC'),
	(205179, 121, '2014-02-15 00:22:37.000000', 'temperatura', 413.0000, 'ºC'),
	(205180, 121, '2014-02-15 00:22:38.000000', 'temperatura', 558.0000, 'ºC'),
	(205181, 121, '2014-02-15 00:22:39.000000', 'temperatura', 350.0000, 'ºC'),
	(205182, 121, '2014-02-15 00:22:40.000000', 'temperatura', 80.0000, 'ºC'),
	(205183, 121, '2014-02-15 00:22:41.000000', 'temperatura', 547.0000, 'ºC'),
	(205184, 121, '2014-02-15 00:22:42.000000', 'temperatura', 98.0000, 'ºC'),
	(205185, 121, '2014-02-15 00:22:43.000000', 'temperatura', 49.0000, 'ºC'),
	(205186, 121, '2014-02-15 00:22:44.000000', 'temperatura', 1153.0000, 'ºC'),
	(205187, 121, '2014-02-15 00:22:45.000000', 'temperatura', 819.0000, 'ºC'),
	(205188, 121, '2014-02-15 00:22:46.000000', 'temperatura', 635.0000, 'ºC'),
	(205189, 121, '2014-02-15 00:22:47.000000', 'temperatura', 717.0000, 'ºC'),
	(205190, 121, '2014-02-15 00:22:48.000000', 'temperatura', 484.0000, 'ºC'),
	(205191, 121, '2014-02-15 00:22:49.000000', 'temperatura', 267.0000, 'ºC'),
	(205192, 121, '2014-02-15 00:22:50.000000', 'temperatura', 1084.0000, 'ºC'),
	(205193, 121, '2014-02-15 00:22:51.000000', 'temperatura', 1020.0000, 'ºC'),
	(205194, 121, '2014-02-15 00:22:52.000000', 'temperatura', 650.0000, 'ºC'),
	(205195, 121, '2014-02-15 00:22:53.000000', 'temperatura', 188.0000, 'ºC'),
	(205196, 121, '2014-02-15 00:22:54.000000', 'temperatura', 193.0000, 'ºC'),
	(205197, 121, '2014-02-15 00:22:55.000000', 'temperatura', 401.0000, 'ºC'),
	(205198, 121, '2014-02-15 00:22:56.000000', 'temperatura', 224.0000, 'ºC'),
	(205199, 121, '2014-02-15 00:22:57.000000', 'temperatura', 1119.0000, 'ºC'),
	(205200, 121, '2014-02-15 00:22:58.000000', 'temperatura', 125.0000, 'ºC'),
	(205201, 121, '2014-02-15 00:22:59.000000', 'temperatura', 867.0000, 'ºC'),
	(205202, 121, '2014-02-15 00:23:00.000000', 'temperatura', 361.0000, 'ºC'),
	(205203, 121, '2014-02-15 00:23:01.000000', 'temperatura', 406.0000, 'ºC'),
	(205204, 121, '2014-02-15 00:23:02.000000', 'temperatura', 945.0000, 'ºC'),
	(205205, 121, '2014-02-15 00:23:03.000000', 'temperatura', 1107.0000, 'ºC'),
	(205206, 121, '2014-02-15 00:23:04.000000', 'temperatura', 300.0000, 'ºC'),
	(205207, 121, '2014-02-15 00:23:05.000000', 'temperatura', 579.0000, 'ºC'),
	(205208, 121, '2014-02-15 00:23:06.000000', 'temperatura', 795.0000, 'ºC'),
	(205209, 121, '2014-02-15 00:23:07.000000', 'temperatura', 1042.0000, 'ºC'),
	(205210, 121, '2014-02-15 00:23:08.000000', 'temperatura', 422.0000, 'ºC'),
	(205211, 121, '2014-02-15 00:23:09.000000', 'temperatura', 185.0000, 'ºC'),
	(205212, 121, '2014-02-15 00:23:10.000000', 'temperatura', 860.0000, 'ºC'),
	(205213, 121, '2014-02-15 00:23:11.000000', 'temperatura', 147.0000, 'ºC'),
	(205214, 121, '2014-02-15 00:23:12.000000', 'temperatura', 554.0000, 'ºC'),
	(205215, 121, '2014-02-15 00:23:13.000000', 'temperatura', 1130.0000, 'ºC'),
	(205216, 121, '2014-02-15 00:23:14.000000', 'temperatura', 387.0000, 'ºC'),
	(205217, 121, '2014-02-15 00:23:15.000000', 'temperatura', 948.0000, 'ºC'),
	(205218, 121, '2014-02-15 00:23:16.000000', 'temperatura', 1179.0000, 'ºC'),
	(205219, 121, '2014-02-15 00:23:17.000000', 'temperatura', 652.0000, 'ºC'),
	(205220, 121, '2014-02-15 00:23:18.000000', 'temperatura', 924.0000, 'ºC'),
	(205221, 121, '2014-02-15 00:23:19.000000', 'temperatura', 263.0000, 'ºC'),
	(205222, 121, '2014-02-15 00:23:20.000000', 'temperatura', 943.0000, 'ºC'),
	(205223, 121, '2014-02-15 00:23:21.000000', 'temperatura', 328.0000, 'ºC'),
	(205224, 121, '2014-02-15 00:23:22.000000', 'temperatura', 9.0000, 'ºC'),
	(205225, 121, '2014-02-15 00:23:23.000000', 'temperatura', 263.0000, 'ºC'),
	(205226, 121, '2014-02-15 00:23:24.000000', 'temperatura', 89.0000, 'ºC'),
	(205227, 121, '2014-02-15 00:23:25.000000', 'temperatura', 855.0000, 'ºC'),
	(205228, 121, '2014-02-15 00:23:26.000000', 'temperatura', 410.0000, 'ºC'),
	(205229, 121, '2014-02-15 00:23:27.000000', 'temperatura', 683.0000, 'ºC'),
	(205230, 121, '2014-02-15 00:23:28.000000', 'temperatura', 989.0000, 'ºC'),
	(205231, 121, '2014-02-15 00:23:29.000000', 'temperatura', 495.0000, 'ºC'),
	(205232, 121, '2014-02-15 00:23:30.000000', 'temperatura', 707.0000, 'ºC'),
	(205233, 121, '2014-02-15 00:23:31.000000', 'temperatura', 850.0000, 'ºC'),
	(205234, 121, '2014-02-15 00:23:32.000000', 'temperatura', 929.0000, 'ºC'),
	(205235, 121, '2014-02-15 00:23:33.000000', 'temperatura', 898.0000, 'ºC'),
	(205236, 121, '2014-02-15 00:23:34.000000', 'temperatura', 504.0000, 'ºC'),
	(205237, 121, '2014-02-15 00:23:35.000000', 'temperatura', 1028.0000, 'ºC'),
	(205238, 121, '2014-02-15 00:23:36.000000', 'temperatura', 25.0000, 'ºC'),
	(205239, 121, '2014-02-15 00:23:37.000000', 'temperatura', 642.0000, 'ºC'),
	(205240, 121, '2014-02-15 00:23:38.000000', 'temperatura', 734.0000, 'ºC'),
	(205241, 121, '2014-02-15 00:23:39.000000', 'temperatura', 546.0000, 'ºC'),
	(205242, 121, '2014-02-15 00:23:40.000000', 'temperatura', 528.0000, 'ºC'),
	(205243, 121, '2014-02-15 00:23:41.000000', 'temperatura', 1002.0000, 'ºC'),
	(205244, 121, '2014-02-15 00:23:42.000000', 'temperatura', 1026.0000, 'ºC'),
	(205245, 121, '2014-02-15 00:23:43.000000', 'temperatura', 926.0000, 'ºC'),
	(205246, 121, '2014-02-15 00:23:44.000000', 'temperatura', 353.0000, 'ºC'),
	(205247, 121, '2014-02-15 00:23:45.000000', 'temperatura', 185.0000, 'ºC'),
	(205248, 121, '2014-02-15 00:23:46.000000', 'temperatura', 1068.0000, 'ºC'),
	(205249, 121, '2014-02-15 00:23:47.000000', 'temperatura', 1184.0000, 'ºC'),
	(205250, 121, '2014-02-15 00:23:48.000000', 'temperatura', 318.0000, 'ºC'),
	(205251, 121, '2014-02-15 00:23:49.000000', 'temperatura', 440.0000, 'ºC'),
	(205252, 121, '2014-02-15 00:23:50.000000', 'temperatura', 46.0000, 'ºC'),
	(205253, 121, '2014-02-15 00:23:51.000000', 'temperatura', 111.0000, 'ºC'),
	(205254, 121, '2014-02-15 00:23:52.000000', 'temperatura', 415.0000, 'ºC'),
	(205255, 121, '2014-02-15 00:23:53.000000', 'temperatura', 546.0000, 'ºC'),
	(205256, 121, '2014-02-15 00:23:54.000000', 'temperatura', 283.0000, 'ºC'),
	(205257, 121, '2014-02-15 00:23:55.000000', 'temperatura', 977.0000, 'ºC'),
	(205258, 121, '2014-02-15 00:23:56.000000', 'temperatura', 436.0000, 'ºC'),
	(205259, 121, '2014-02-15 00:23:57.000000', 'temperatura', 450.0000, 'ºC'),
	(205260, 121, '2014-02-15 00:23:58.000000', 'temperatura', 942.0000, 'ºC'),
	(205261, 121, '2014-02-15 00:23:59.000000', 'temperatura', 961.0000, 'ºC'),
	(205262, 121, '2014-02-15 00:24:00.000000', 'temperatura', 780.0000, 'ºC'),
	(205263, 121, '2014-02-15 00:24:01.000000', 'temperatura', 1019.0000, 'ºC'),
	(205264, 121, '2014-02-15 00:24:02.000000', 'temperatura', 353.0000, 'ºC'),
	(205265, 121, '2014-02-15 00:24:03.000000', 'temperatura', 1110.0000, 'ºC'),
	(205266, 121, '2014-02-15 00:24:04.000000', 'temperatura', 891.0000, 'ºC'),
	(205267, 121, '2014-02-15 00:24:05.000000', 'temperatura', 1127.0000, 'ºC'),
	(205268, 121, '2014-02-15 00:24:06.000000', 'temperatura', 564.0000, 'ºC'),
	(205269, 121, '2014-02-15 00:24:07.000000', 'temperatura', 636.0000, 'ºC'),
	(205270, 121, '2014-02-15 00:24:08.000000', 'temperatura', 290.0000, 'ºC'),
	(205271, 121, '2014-02-15 00:24:09.000000', 'temperatura', 744.0000, 'ºC'),
	(205272, 121, '2014-02-15 00:24:10.000000', 'temperatura', 448.0000, 'ºC'),
	(205273, 121, '2014-02-15 00:24:11.000000', 'temperatura', 12.0000, 'ºC'),
	(205274, 121, '2014-02-15 00:24:12.000000', 'temperatura', 1113.0000, 'ºC'),
	(205275, 121, '2014-02-15 00:24:13.000000', 'temperatura', 729.0000, 'ºC'),
	(205276, 121, '2014-02-15 00:24:14.000000', 'temperatura', 308.0000, 'ºC'),
	(205277, 121, '2014-02-15 00:24:15.000000', 'temperatura', 551.0000, 'ºC'),
	(205278, 121, '2014-02-15 00:24:16.000000', 'temperatura', 634.0000, 'ºC'),
	(205279, 121, '2014-02-15 00:24:17.000000', 'temperatura', 318.0000, 'ºC'),
	(205280, 121, '2014-02-15 00:24:18.000000', 'temperatura', 888.0000, 'ºC'),
	(205281, 121, '2014-02-15 00:24:19.000000', 'temperatura', 1088.0000, 'ºC'),
	(205282, 121, '2014-02-15 00:24:20.000000', 'temperatura', 374.0000, 'ºC'),
	(205283, 121, '2014-02-15 00:24:21.000000', 'temperatura', 1009.0000, 'ºC'),
	(205284, 121, '2014-02-15 00:24:22.000000', 'temperatura', 324.0000, 'ºC'),
	(205285, 121, '2014-02-15 00:24:23.000000', 'temperatura', 992.0000, 'ºC'),
	(205286, 121, '2014-02-15 00:24:24.000000', 'temperatura', 391.0000, 'ºC'),
	(205287, 121, '2014-02-15 00:24:25.000000', 'temperatura', 177.0000, 'ºC'),
	(205288, 121, '2014-02-15 00:24:26.000000', 'temperatura', 915.0000, 'ºC'),
	(205289, 121, '2014-02-15 00:24:27.000000', 'temperatura', 443.0000, 'ºC'),
	(205290, 121, '2014-02-15 00:24:28.000000', 'temperatura', 671.0000, 'ºC'),
	(205291, 121, '2014-02-15 00:24:29.000000', 'temperatura', 825.0000, 'ºC'),
	(205292, 121, '2014-02-15 00:24:30.000000', 'temperatura', 914.0000, 'ºC'),
	(205293, 121, '2014-02-15 00:24:31.000000', 'temperatura', 897.0000, 'ºC'),
	(205294, 121, '2014-02-15 00:24:32.000000', 'temperatura', 542.0000, 'ºC'),
	(205295, 121, '2014-02-15 00:24:33.000000', 'temperatura', 22.0000, 'ºC'),
	(205296, 121, '2014-02-15 00:24:34.000000', 'temperatura', 881.0000, 'ºC'),
	(205297, 121, '2014-02-15 00:24:35.000000', 'temperatura', 742.0000, 'ºC'),
	(205298, 121, '2014-02-15 00:24:36.000000', 'temperatura', 1067.0000, 'ºC'),
	(205299, 121, '2014-02-15 00:24:37.000000', 'temperatura', 711.0000, 'ºC'),
	(205300, 121, '2014-02-15 00:24:38.000000', 'temperatura', 352.0000, 'ºC'),
	(205301, 121, '2014-02-15 00:24:39.000000', 'temperatura', 829.0000, 'ºC'),
	(205302, 121, '2014-02-15 00:24:40.000000', 'temperatura', 689.0000, 'ºC'),
	(205303, 121, '2014-02-15 00:24:41.000000', 'temperatura', 960.0000, 'ºC'),
	(205304, 121, '2014-02-15 00:24:42.000000', 'temperatura', 333.0000, 'ºC'),
	(205305, 121, '2014-02-15 00:24:43.000000', 'temperatura', 1187.0000, 'ºC'),
	(205306, 121, '2014-02-15 00:24:44.000000', 'temperatura', 134.0000, 'ºC'),
	(205307, 121, '2014-02-15 00:24:45.000000', 'temperatura', 711.0000, 'ºC'),
	(205308, 121, '2014-02-15 00:24:46.000000', 'temperatura', 754.0000, 'ºC'),
	(205309, 121, '2014-02-15 00:24:47.000000', 'temperatura', 435.0000, 'ºC'),
	(205310, 121, '2014-02-15 00:24:48.000000', 'temperatura', 1114.0000, 'ºC'),
	(205311, 121, '2014-02-15 00:24:49.000000', 'temperatura', 666.0000, 'ºC'),
	(205312, 121, '2014-02-15 00:24:50.000000', 'temperatura', 1187.0000, 'ºC'),
	(205313, 121, '2014-02-15 00:24:51.000000', 'temperatura', 338.0000, 'ºC'),
	(205314, 121, '2014-02-15 00:24:52.000000', 'temperatura', 530.0000, 'ºC'),
	(205315, 121, '2014-02-15 00:24:53.000000', 'temperatura', 435.0000, 'ºC'),
	(205316, 121, '2014-02-15 00:24:54.000000', 'temperatura', 585.0000, 'ºC'),
	(205317, 121, '2014-02-15 00:24:55.000000', 'temperatura', 423.0000, 'ºC'),
	(205318, 121, '2014-02-15 00:24:56.000000', 'temperatura', 358.0000, 'ºC'),
	(205319, 121, '2014-02-15 00:24:57.000000', 'temperatura', 524.0000, 'ºC'),
	(205320, 121, '2014-02-15 00:24:58.000000', 'temperatura', 344.0000, 'ºC'),
	(205321, 121, '2014-02-15 00:24:59.000000', 'temperatura', 151.0000, 'ºC'),
	(205322, 121, '2014-02-15 00:25:00.000000', 'temperatura', 924.0000, 'ºC'),
	(205323, 121, '2014-02-15 00:25:01.000000', 'temperatura', 565.0000, 'ºC'),
	(205324, 121, '2014-02-15 00:25:02.000000', 'temperatura', 54.0000, 'ºC'),
	(205325, 121, '2014-02-15 00:25:03.000000', 'temperatura', 976.0000, 'ºC'),
	(205326, 121, '2014-02-15 00:25:04.000000', 'temperatura', 1118.0000, 'ºC'),
	(205327, 121, '2014-02-15 00:25:05.000000', 'temperatura', 264.0000, 'ºC'),
	(205328, 121, '2014-02-15 00:25:06.000000', 'temperatura', 368.0000, 'ºC'),
	(205329, 121, '2014-02-15 00:25:07.000000', 'temperatura', 1046.0000, 'ºC'),
	(205330, 121, '2014-02-15 00:25:08.000000', 'temperatura', 527.0000, 'ºC'),
	(205331, 121, '2014-02-15 00:25:09.000000', 'temperatura', 696.0000, 'ºC'),
	(205332, 121, '2014-02-15 00:25:10.000000', 'temperatura', 702.0000, 'ºC'),
	(205333, 121, '2014-02-15 00:25:11.000000', 'temperatura', 222.0000, 'ºC'),
	(205334, 121, '2014-02-15 00:25:12.000000', 'temperatura', 205.0000, 'ºC'),
	(205335, 121, '2014-02-15 00:25:13.000000', 'temperatura', 359.0000, 'ºC'),
	(205336, 121, '2014-02-15 00:25:14.000000', 'temperatura', 1180.0000, 'ºC'),
	(205337, 121, '2014-02-15 00:25:15.000000', 'temperatura', 23.0000, 'ºC'),
	(205338, 121, '2014-02-15 00:25:16.000000', 'temperatura', 176.0000, 'ºC'),
	(205339, 121, '2014-02-15 00:25:17.000000', 'temperatura', 810.0000, 'ºC'),
	(205340, 121, '2014-02-15 00:25:18.000000', 'temperatura', 1122.0000, 'ºC'),
	(205341, 121, '2014-02-15 00:25:19.000000', 'temperatura', 783.0000, 'ºC'),
	(205342, 121, '2014-02-15 00:25:20.000000', 'temperatura', 550.0000, 'ºC'),
	(205343, 121, '2014-02-15 00:25:21.000000', 'temperatura', 400.0000, 'ºC'),
	(205344, 121, '2014-02-15 00:25:22.000000', 'temperatura', 349.0000, 'ºC'),
	(205345, 121, '2014-02-15 00:25:23.000000', 'temperatura', 547.0000, 'ºC'),
	(205346, 121, '2014-02-15 00:25:24.000000', 'temperatura', 490.0000, 'ºC'),
	(205347, 121, '2014-02-15 00:25:25.000000', 'temperatura', 806.0000, 'ºC'),
	(205348, 121, '2014-02-15 00:25:26.000000', 'temperatura', 164.0000, 'ºC'),
	(205349, 121, '2014-02-15 00:25:27.000000', 'temperatura', 800.0000, 'ºC'),
	(205350, 121, '2014-02-15 00:25:28.000000', 'temperatura', 1109.0000, 'ºC'),
	(205351, 121, '2014-02-15 00:25:29.000000', 'temperatura', 747.0000, 'ºC'),
	(205352, 121, '2014-02-15 00:25:30.000000', 'temperatura', 407.0000, 'ºC'),
	(205353, 121, '2014-02-15 00:25:31.000000', 'temperatura', 996.0000, 'ºC'),
	(205354, 121, '2014-02-15 00:25:32.000000', 'temperatura', 160.0000, 'ºC'),
	(205355, 121, '2014-02-15 00:25:33.000000', 'temperatura', 213.0000, 'ºC'),
	(205356, 121, '2014-02-15 00:25:34.000000', 'temperatura', 584.0000, 'ºC'),
	(205357, 121, '2014-02-15 00:25:35.000000', 'temperatura', 1083.0000, 'ºC'),
	(205358, 121, '2014-02-15 00:25:36.000000', 'temperatura', 63.0000, 'ºC'),
	(205359, 121, '2014-02-15 00:25:37.000000', 'temperatura', 664.0000, 'ºC'),
	(205360, 121, '2014-02-15 00:25:38.000000', 'temperatura', 734.0000, 'ºC'),
	(205361, 121, '2014-02-15 00:25:39.000000', 'temperatura', 479.0000, 'ºC'),
	(205362, 121, '2014-02-15 00:25:40.000000', 'temperatura', 191.0000, 'ºC'),
	(205363, 121, '2014-02-15 00:25:41.000000', 'temperatura', 719.0000, 'ºC'),
	(205364, 121, '2014-02-15 00:25:42.000000', 'temperatura', 623.0000, 'ºC'),
	(205365, 121, '2014-02-15 00:25:43.000000', 'temperatura', 957.0000, 'ºC'),
	(205366, 121, '2014-02-15 00:25:44.000000', 'temperatura', 519.0000, 'ºC'),
	(205367, 121, '2014-02-15 00:25:45.000000', 'temperatura', 922.0000, 'ºC'),
	(205368, 121, '2014-02-15 00:25:46.000000', 'temperatura', 655.0000, 'ºC'),
	(205369, 121, '2014-02-15 00:25:47.000000', 'temperatura', 510.0000, 'ºC'),
	(205370, 121, '2014-02-15 00:25:48.000000', 'temperatura', 586.0000, 'ºC'),
	(205371, 121, '2014-02-15 00:25:49.000000', 'temperatura', 199.0000, 'ºC'),
	(205372, 121, '2014-02-15 00:25:50.000000', 'temperatura', 438.0000, 'ºC'),
	(205373, 121, '2014-02-15 00:25:51.000000', 'temperatura', 395.0000, 'ºC'),
	(205374, 121, '2014-02-15 00:25:52.000000', 'temperatura', 662.0000, 'ºC'),
	(205375, 121, '2014-02-15 00:25:53.000000', 'temperatura', 927.0000, 'ºC'),
	(205376, 121, '2014-02-15 00:25:54.000000', 'temperatura', 246.0000, 'ºC'),
	(205377, 121, '2014-02-15 00:25:55.000000', 'temperatura', 849.0000, 'ºC'),
	(205378, 121, '2014-02-15 00:25:56.000000', 'temperatura', 1109.0000, 'ºC'),
	(205379, 121, '2014-02-15 00:25:57.000000', 'temperatura', 598.0000, 'ºC'),
	(205380, 121, '2014-02-15 00:25:58.000000', 'temperatura', 865.0000, 'ºC'),
	(205381, 121, '2014-02-15 00:25:59.000000', 'temperatura', 132.0000, 'ºC'),
	(205382, 121, '2014-02-15 00:26:00.000000', 'temperatura', 466.0000, 'ºC'),
	(205383, 121, '2014-02-15 00:26:01.000000', 'temperatura', 736.0000, 'ºC'),
	(205384, 121, '2014-02-15 00:26:02.000000', 'temperatura', 1079.0000, 'ºC'),
	(205385, 121, '2014-02-15 00:26:03.000000', 'temperatura', 788.0000, 'ºC'),
	(205386, 121, '2014-02-15 00:26:04.000000', 'temperatura', 703.0000, 'ºC'),
	(205387, 121, '2014-02-15 00:26:05.000000', 'temperatura', 1150.0000, 'ºC'),
	(205388, 121, '2014-02-15 00:26:06.000000', 'temperatura', 45.0000, 'ºC'),
	(205389, 121, '2014-02-15 00:26:07.000000', 'temperatura', 373.0000, 'ºC'),
	(205390, 121, '2014-02-15 00:26:08.000000', 'temperatura', 532.0000, 'ºC'),
	(205391, 121, '2014-02-15 00:26:09.000000', 'temperatura', 340.0000, 'ºC'),
	(205392, 121, '2014-02-15 00:26:10.000000', 'temperatura', 107.0000, 'ºC'),
	(205393, 121, '2014-02-15 00:26:11.000000', 'temperatura', 712.0000, 'ºC'),
	(205394, 121, '2014-02-15 00:26:12.000000', 'temperatura', 843.0000, 'ºC'),
	(205395, 121, '2014-02-15 00:26:13.000000', 'temperatura', 877.0000, 'ºC'),
	(205396, 121, '2014-02-15 00:26:14.000000', 'temperatura', 657.0000, 'ºC'),
	(205397, 121, '2014-02-15 00:26:15.000000', 'temperatura', 656.0000, 'ºC'),
	(205398, 121, '2014-02-15 00:26:16.000000', 'temperatura', 110.0000, 'ºC'),
	(205399, 121, '2014-02-15 00:26:17.000000', 'temperatura', 981.0000, 'ºC'),
	(205400, 121, '2014-02-15 00:26:18.000000', 'temperatura', 974.0000, 'ºC'),
	(205401, 121, '2014-02-15 00:26:19.000000', 'temperatura', 730.0000, 'ºC'),
	(205402, 121, '2014-02-15 00:26:20.000000', 'temperatura', 726.0000, 'ºC'),
	(205403, 121, '2014-02-15 00:26:21.000000', 'temperatura', 241.0000, 'ºC'),
	(205404, 121, '2014-02-15 00:26:22.000000', 'temperatura', 229.0000, 'ºC'),
	(205405, 121, '2014-02-15 00:26:23.000000', 'temperatura', 421.0000, 'ºC'),
	(205406, 121, '2014-02-15 00:26:24.000000', 'temperatura', 220.0000, 'ºC'),
	(205407, 121, '2014-02-15 00:26:25.000000', 'temperatura', 1036.0000, 'ºC'),
	(205408, 121, '2014-02-15 00:26:26.000000', 'temperatura', 921.0000, 'ºC'),
	(205409, 121, '2014-02-15 00:26:27.000000', 'temperatura', 299.0000, 'ºC'),
	(205410, 121, '2014-02-15 00:26:28.000000', 'temperatura', 1133.0000, 'ºC'),
	(205411, 121, '2014-02-15 00:26:29.000000', 'temperatura', 1167.0000, 'ºC'),
	(205412, 121, '2014-02-15 00:26:30.000000', 'temperatura', 38.0000, 'ºC'),
	(205413, 121, '2014-02-15 00:26:31.000000', 'temperatura', 289.0000, 'ºC'),
	(205414, 121, '2014-02-15 00:26:32.000000', 'temperatura', 130.0000, 'ºC'),
	(205415, 121, '2014-02-15 00:26:33.000000', 'temperatura', 983.0000, 'ºC'),
	(205416, 121, '2014-02-15 00:26:34.000000', 'temperatura', 927.0000, 'ºC'),
	(205417, 121, '2014-02-15 00:26:35.000000', 'temperatura', 487.0000, 'ºC'),
	(205418, 121, '2014-02-15 00:26:36.000000', 'temperatura', 856.0000, 'ºC'),
	(205419, 121, '2014-02-15 00:26:37.000000', 'temperatura', 417.0000, 'ºC'),
	(205420, 121, '2014-02-15 00:26:38.000000', 'temperatura', 719.0000, 'ºC'),
	(205421, 121, '2014-02-15 00:26:39.000000', 'temperatura', 1143.0000, 'ºC'),
	(205422, 121, '2014-02-15 00:26:40.000000', 'temperatura', 1161.0000, 'ºC'),
	(205423, 121, '2014-02-15 00:26:41.000000', 'temperatura', 1174.0000, 'ºC'),
	(205424, 121, '2014-02-15 00:26:42.000000', 'temperatura', 1190.0000, 'ºC'),
	(205425, 121, '2014-02-15 00:26:43.000000', 'temperatura', 27.0000, 'ºC'),
	(205426, 121, '2014-02-15 00:26:44.000000', 'temperatura', 165.0000, 'ºC'),
	(205427, 121, '2014-02-15 00:26:45.000000', 'temperatura', 744.0000, 'ºC'),
	(205428, 121, '2014-02-15 00:26:46.000000', 'temperatura', 825.0000, 'ºC'),
	(205429, 121, '2014-02-15 00:26:47.000000', 'temperatura', 693.0000, 'ºC'),
	(205430, 121, '2014-02-15 00:26:48.000000', 'temperatura', 990.0000, 'ºC'),
	(205431, 121, '2014-02-15 00:26:49.000000', 'temperatura', 473.0000, 'ºC'),
	(205432, 121, '2014-02-15 00:26:50.000000', 'temperatura', 594.0000, 'ºC'),
	(205433, 121, '2014-02-15 00:26:51.000000', 'temperatura', 354.0000, 'ºC'),
	(205434, 121, '2014-02-15 00:26:52.000000', 'temperatura', 1186.0000, 'ºC'),
	(205435, 121, '2014-02-15 00:26:53.000000', 'temperatura', 71.0000, 'ºC'),
	(205436, 121, '2014-02-15 00:26:54.000000', 'temperatura', 398.0000, 'ºC'),
	(205437, 121, '2014-02-15 00:26:55.000000', 'temperatura', 575.0000, 'ºC'),
	(205438, 121, '2014-02-15 00:26:56.000000', 'temperatura', 484.0000, 'ºC'),
	(205439, 121, '2014-02-15 00:26:57.000000', 'temperatura', 694.0000, 'ºC'),
	(205440, 121, '2014-02-15 00:26:58.000000', 'temperatura', 817.0000, 'ºC'),
	(205441, 121, '2014-02-15 00:26:59.000000', 'temperatura', 805.0000, 'ºC'),
	(205442, 121, '2014-02-15 00:27:00.000000', 'temperatura', 374.0000, 'ºC'),
	(205443, 121, '2014-02-15 00:27:01.000000', 'temperatura', 658.0000, 'ºC'),
	(205444, 121, '2014-02-15 00:27:02.000000', 'temperatura', 966.0000, 'ºC'),
	(205445, 121, '2014-02-15 00:27:03.000000', 'temperatura', 458.0000, 'ºC'),
	(205446, 121, '2014-02-15 00:27:04.000000', 'temperatura', 591.0000, 'ºC'),
	(205447, 121, '2014-02-15 00:27:05.000000', 'temperatura', 381.0000, 'ºC'),
	(205448, 121, '2014-02-15 00:27:06.000000', 'temperatura', 131.0000, 'ºC'),
	(205449, 121, '2014-02-15 00:27:07.000000', 'temperatura', 715.0000, 'ºC'),
	(205450, 121, '2014-02-15 00:27:08.000000', 'temperatura', 781.0000, 'ºC'),
	(205451, 121, '2014-02-15 00:27:09.000000', 'temperatura', 563.0000, 'ºC'),
	(205452, 121, '2014-02-15 00:27:10.000000', 'temperatura', 472.0000, 'ºC'),
	(205453, 121, '2014-02-15 00:27:11.000000', 'temperatura', 672.0000, 'ºC'),
	(205454, 121, '2014-02-15 00:27:12.000000', 'temperatura', 744.0000, 'ºC'),
	(205455, 121, '2014-02-15 00:27:13.000000', 'temperatura', 505.0000, 'ºC'),
	(205456, 121, '2014-02-15 00:27:14.000000', 'temperatura', 292.0000, 'ºC'),
	(205457, 121, '2014-02-15 00:27:15.000000', 'temperatura', 1148.0000, 'ºC'),
	(205458, 121, '2014-02-15 00:27:16.000000', 'temperatura', 65.0000, 'ºC'),
	(205459, 121, '2014-02-15 00:27:17.000000', 'temperatura', 479.0000, 'ºC'),
	(205460, 121, '2014-02-15 00:27:18.000000', 'temperatura', 1001.0000, 'ºC'),
	(205461, 121, '2014-02-15 00:27:19.000000', 'temperatura', 1169.0000, 'ºC'),
	(205462, 121, '2014-02-15 00:27:20.000000', 'temperatura', 441.0000, 'ºC'),
	(205463, 121, '2014-02-15 00:27:21.000000', 'temperatura', 1102.0000, 'ºC'),
	(205464, 121, '2014-02-15 00:27:22.000000', 'temperatura', 584.0000, 'ºC'),
	(205465, 121, '2014-02-15 00:27:23.000000', 'temperatura', 814.0000, 'ºC'),
	(205466, 121, '2014-02-15 00:27:24.000000', 'temperatura', 1121.0000, 'ºC'),
	(205467, 121, '2014-02-15 00:27:25.000000', 'temperatura', 764.0000, 'ºC'),
	(205468, 121, '2014-02-15 00:27:26.000000', 'temperatura', 455.0000, 'ºC'),
	(205469, 121, '2014-02-15 00:27:27.000000', 'temperatura', 1185.0000, 'ºC'),
	(205470, 121, '2014-02-15 00:27:28.000000', 'temperatura', 961.0000, 'ºC'),
	(205471, 121, '2014-02-15 00:27:29.000000', 'temperatura', 48.0000, 'ºC'),
	(205472, 121, '2014-02-15 00:27:30.000000', 'temperatura', 959.0000, 'ºC'),
	(205473, 121, '2014-02-15 00:27:31.000000', 'temperatura', 1051.0000, 'ºC'),
	(205474, 121, '2014-02-15 00:27:32.000000', 'temperatura', 1178.0000, 'ºC'),
	(205475, 121, '2014-02-15 00:27:33.000000', 'temperatura', 338.0000, 'ºC'),
	(205476, 121, '2014-02-15 00:27:34.000000', 'temperatura', 558.0000, 'ºC'),
	(205477, 121, '2014-02-15 00:27:35.000000', 'temperatura', 576.0000, 'ºC'),
	(205478, 121, '2014-02-15 00:27:36.000000', 'temperatura', 7.0000, 'ºC'),
	(205479, 121, '2014-02-15 00:27:37.000000', 'temperatura', 705.0000, 'ºC'),
	(205480, 121, '2014-02-15 00:27:38.000000', 'temperatura', 1107.0000, 'ºC'),
	(205481, 121, '2014-02-15 00:27:39.000000', 'temperatura', 1018.0000, 'ºC'),
	(205482, 121, '2014-02-15 00:27:40.000000', 'temperatura', 569.0000, 'ºC'),
	(205483, 121, '2014-02-15 00:27:41.000000', 'temperatura', 995.0000, 'ºC'),
	(205484, 121, '2014-02-15 00:27:42.000000', 'temperatura', 865.0000, 'ºC'),
	(205485, 121, '2014-02-15 00:27:43.000000', 'temperatura', 142.0000, 'ºC'),
	(205486, 121, '2014-02-15 00:27:44.000000', 'temperatura', 517.0000, 'ºC'),
	(205487, 121, '2014-02-15 00:27:45.000000', 'temperatura', 958.0000, 'ºC'),
	(205488, 121, '2014-02-15 00:27:46.000000', 'temperatura', 838.0000, 'ºC'),
	(205489, 121, '2014-02-15 00:27:47.000000', 'temperatura', 120.0000, 'ºC'),
	(205490, 121, '2014-02-15 00:27:48.000000', 'temperatura', 484.0000, 'ºC'),
	(205491, 121, '2014-02-15 00:27:49.000000', 'temperatura', 859.0000, 'ºC'),
	(205492, 121, '2014-02-15 00:27:50.000000', 'temperatura', 445.0000, 'ºC'),
	(205493, 121, '2014-02-15 00:27:51.000000', 'temperatura', 850.0000, 'ºC'),
	(205494, 121, '2014-02-15 00:27:52.000000', 'temperatura', 516.0000, 'ºC'),
	(205495, 121, '2014-02-15 00:27:53.000000', 'temperatura', 31.0000, 'ºC'),
	(205496, 121, '2014-02-15 00:27:54.000000', 'temperatura', 1006.0000, 'ºC'),
	(205497, 121, '2014-02-15 00:27:55.000000', 'temperatura', 136.0000, 'ºC'),
	(205498, 121, '2014-02-15 00:27:56.000000', 'temperatura', 64.0000, 'ºC'),
	(205499, 121, '2014-02-15 00:27:57.000000', 'temperatura', 1113.0000, 'ºC'),
	(205500, 121, '2014-02-15 00:27:58.000000', 'temperatura', 571.0000, 'ºC'),
	(205501, 121, '2014-02-15 00:27:59.000000', 'temperatura', 720.0000, 'ºC'),
	(205502, 121, '2014-02-15 00:28:00.000000', 'temperatura', 686.0000, 'ºC'),
	(205503, 121, '2014-02-15 00:28:01.000000', 'temperatura', 69.0000, 'ºC'),
	(205504, 121, '2014-02-15 00:28:02.000000', 'temperatura', 687.0000, 'ºC'),
	(205505, 121, '2014-02-15 00:28:03.000000', 'temperatura', 829.0000, 'ºC'),
	(205506, 121, '2014-02-15 00:28:04.000000', 'temperatura', 886.0000, 'ºC'),
	(205507, 121, '2014-02-15 00:28:05.000000', 'temperatura', 745.0000, 'ºC'),
	(205508, 121, '2014-02-15 00:28:06.000000', 'temperatura', 1064.0000, 'ºC'),
	(205509, 121, '2014-02-15 00:28:07.000000', 'temperatura', 687.0000, 'ºC'),
	(205510, 121, '2014-02-15 00:28:08.000000', 'temperatura', 243.0000, 'ºC'),
	(205511, 121, '2014-02-15 00:28:09.000000', 'temperatura', 354.0000, 'ºC'),
	(205512, 121, '2014-02-15 00:28:10.000000', 'temperatura', 1042.0000, 'ºC'),
	(205513, 121, '2014-02-15 00:28:11.000000', 'temperatura', 548.0000, 'ºC'),
	(205514, 121, '2014-02-15 00:28:12.000000', 'temperatura', 814.0000, 'ºC'),
	(205515, 121, '2014-02-15 00:28:13.000000', 'temperatura', 28.0000, 'ºC'),
	(205516, 121, '2014-02-15 00:28:14.000000', 'temperatura', 97.0000, 'ºC'),
	(205517, 121, '2014-02-15 00:28:15.000000', 'temperatura', 401.0000, 'ºC'),
	(205518, 121, '2014-02-15 00:28:16.000000', 'temperatura', 513.0000, 'ºC'),
	(205519, 121, '2014-02-15 00:28:17.000000', 'temperatura', 166.0000, 'ºC'),
	(205520, 121, '2014-02-15 00:28:18.000000', 'temperatura', 489.0000, 'ºC'),
	(205521, 121, '2014-02-15 00:28:19.000000', 'temperatura', 748.0000, 'ºC'),
	(205522, 121, '2014-02-15 00:28:20.000000', 'temperatura', 1075.0000, 'ºC'),
	(205523, 121, '2014-02-15 00:28:21.000000', 'temperatura', 729.0000, 'ºC'),
	(205524, 121, '2014-02-15 00:28:22.000000', 'temperatura', 422.0000, 'ºC'),
	(205525, 121, '2014-02-15 00:28:23.000000', 'temperatura', 1124.0000, 'ºC'),
	(205526, 121, '2014-02-15 00:28:24.000000', 'temperatura', 756.0000, 'ºC'),
	(205527, 121, '2014-02-15 00:28:25.000000', 'temperatura', 406.0000, 'ºC'),
	(205528, 121, '2014-02-15 00:28:26.000000', 'temperatura', 961.0000, 'ºC'),
	(205529, 121, '2014-02-15 00:28:27.000000', 'temperatura', 1191.0000, 'ºC'),
	(205530, 121, '2014-02-15 00:28:28.000000', 'temperatura', 670.0000, 'ºC'),
	(205531, 121, '2014-02-15 00:28:29.000000', 'temperatura', 980.0000, 'ºC'),
	(205532, 121, '2014-02-15 00:28:30.000000', 'temperatura', 491.0000, 'ºC'),
	(205533, 121, '2014-02-15 00:28:31.000000', 'temperatura', 713.0000, 'ºC'),
	(205534, 121, '2014-02-15 00:28:32.000000', 'temperatura', 894.0000, 'ºC'),
	(205535, 121, '2014-02-15 00:28:33.000000', 'temperatura', 1129.0000, 'ºC'),
	(205536, 121, '2014-02-15 00:28:34.000000', 'temperatura', 565.0000, 'ºC'),
	(205537, 121, '2014-02-15 00:28:35.000000', 'temperatura', 639.0000, 'ºC'),
	(205538, 121, '2014-02-15 00:28:36.000000', 'temperatura', 298.0000, 'ºC'),
	(205539, 121, '2014-02-15 00:28:37.000000', 'temperatura', 776.0000, 'ºC'),
	(205540, 121, '2014-02-15 00:28:38.000000', 'temperatura', 585.0000, 'ºC'),
	(205541, 121, '2014-02-15 00:28:39.000000', 'temperatura', 597.0000, 'ºC'),
	(205542, 121, '2014-02-15 00:28:40.000000', 'temperatura', 33.0000, 'ºC'),
	(205543, 121, '2014-02-15 00:28:41.000000', 'temperatura', 772.0000, 'ºC'),
	(205544, 121, '2014-02-15 00:28:42.000000', 'temperatura', 162.0000, 'ºC'),
	(205545, 121, '2014-02-15 00:28:43.000000', 'temperatura', 896.0000, 'ºC'),
	(205546, 121, '2014-02-15 00:28:44.000000', 'temperatura', 395.0000, 'ºC'),
	(205547, 121, '2014-02-15 00:28:45.000000', 'temperatura', 486.0000, 'ºC'),
	(205548, 121, '2014-02-15 00:28:46.000000', 'temperatura', 46.0000, 'ºC'),
	(205549, 121, '2014-02-15 00:28:47.000000', 'temperatura', 1171.0000, 'ºC'),
	(205550, 121, '2014-02-15 00:28:48.000000', 'temperatura', 920.0000, 'ºC'),
	(205551, 121, '2014-02-15 00:28:49.000000', 'temperatura', 1085.0000, 'ºC'),
	(205552, 121, '2014-02-15 00:28:50.000000', 'temperatura', 267.0000, 'ºC'),
	(205553, 121, '2014-02-15 00:28:51.000000', 'temperatura', 478.0000, 'ºC'),
	(205554, 121, '2014-02-15 00:28:52.000000', 'temperatura', 391.0000, 'ºC'),
	(205555, 121, '2014-02-15 00:28:53.000000', 'temperatura', 523.0000, 'ºC'),
	(205556, 121, '2014-02-15 00:28:54.000000', 'temperatura', 244.0000, 'ºC'),
	(205557, 121, '2014-02-15 00:28:55.000000', 'temperatura', 848.0000, 'ºC'),
	(205558, 121, '2014-02-15 00:28:56.000000', 'temperatura', 1110.0000, 'ºC'),
	(205559, 121, '2014-02-15 00:28:57.000000', 'temperatura', 605.0000, 'ºC'),
	(205560, 121, '2014-02-15 00:28:58.000000', 'temperatura', 895.0000, 'ºC'),
	(205561, 121, '2014-02-15 00:28:59.000000', 'temperatura', 260.0000, 'ºC'),
	(205562, 121, '2014-02-15 00:29:00.000000', 'temperatura', 1015.0000, 'ºC'),
	(205563, 121, '2014-02-15 00:29:01.000000', 'temperatura', 696.0000, 'ºC'),
	(205564, 121, '2014-02-15 00:29:02.000000', 'temperatura', 435.0000, 'ºC'),
	(205565, 121, '2014-02-15 00:29:03.000000', 'temperatura', 88.0000, 'ºC'),
	(205566, 121, '2014-02-15 00:29:04.000000', 'temperatura', 336.0000, 'ºC'),
	(205567, 121, '2014-02-15 00:29:05.000000', 'temperatura', 215.0000, 'ºC'),
	(205568, 121, '2014-02-15 00:29:06.000000', 'temperatura', 70.0000, 'ºC'),
	(205569, 121, '2014-02-15 00:29:07.000000', 'temperatura', 902.0000, 'ºC'),
	(205570, 121, '2014-02-15 00:29:08.000000', 'temperatura', 703.0000, 'ºC'),
	(205571, 121, '2014-02-15 00:29:09.000000', 'temperatura', 810.0000, 'ºC'),
	(205572, 121, '2014-02-15 00:29:10.000000', 'temperatura', 739.0000, 'ºC'),
	(205573, 121, '2014-02-15 00:29:11.000000', 'temperatura', 67.0000, 'ºC'),
	(205574, 121, '2014-02-15 00:29:12.000000', 'temperatura', 520.0000, 'ºC'),
	(205575, 121, '2014-02-15 00:29:13.000000', 'temperatura', 1197.0000, 'ºC'),
	(205576, 121, '2014-02-15 00:29:14.000000', 'temperatura', 826.0000, 'ºC'),
	(205577, 121, '2014-02-15 00:29:15.000000', 'temperatura', 542.0000, 'ºC'),
	(205578, 121, '2014-02-15 00:29:16.000000', 'temperatura', 230.0000, 'ºC'),
	(205579, 121, '2014-02-15 00:29:17.000000', 'temperatura', 726.0000, 'ºC'),
	(205580, 121, '2014-02-15 00:29:18.000000', 'temperatura', 540.0000, 'ºC'),
	(205581, 121, '2014-02-15 00:29:19.000000', 'temperatura', 523.0000, 'ºC'),
	(205582, 121, '2014-02-15 00:29:20.000000', 'temperatura', 994.0000, 'ºC'),
	(205583, 121, '2014-02-15 00:29:21.000000', 'temperatura', 1002.0000, 'ºC'),
	(205584, 121, '2014-02-15 00:29:22.000000', 'temperatura', 828.0000, 'ºC'),
	(205585, 121, '2014-02-15 00:29:23.000000', 'temperatura', 1134.0000, 'ºC'),
	(205586, 121, '2014-02-15 00:29:24.000000', 'temperatura', 789.0000, 'ºC'),
	(205587, 121, '2014-02-15 00:29:25.000000', 'temperatura', 541.0000, 'ºC'),
	(205588, 121, '2014-02-15 00:29:26.000000', 'temperatura', 337.0000, 'ºC'),
	(205589, 121, '2014-02-15 00:29:27.000000', 'temperatura', 65.0000, 'ºC'),
	(205590, 121, '2014-02-15 00:29:28.000000', 'temperatura', 516.0000, 'ºC'),
	(205591, 121, '2014-02-15 00:29:29.000000', 'temperatura', 1184.0000, 'ºC'),
	(205592, 121, '2014-02-15 00:29:30.000000', 'temperatura', 771.0000, 'ºC'),
	(205593, 121, '2014-02-15 00:29:31.000000', 'temperatura', 305.0000, 'ºC'),
	(205594, 121, '2014-02-15 00:29:32.000000', 'temperatura', 413.0000, 'ºC'),
	(205595, 121, '2014-02-15 00:29:33.000000', 'temperatura', 1151.0000, 'ºC'),
	(205596, 121, '2014-02-15 00:29:34.000000', 'temperatura', 917.0000, 'ºC'),
	(205597, 121, '2014-02-15 00:29:35.000000', 'temperatura', 1133.0000, 'ºC'),
	(205598, 121, '2014-02-15 00:29:36.000000', 'temperatura', 514.0000, 'ºC'),
	(205599, 121, '2014-02-15 00:29:37.000000', 'temperatura', 372.0000, 'ºC'),
	(205600, 121, '2014-02-15 00:29:38.000000', 'temperatura', 320.0000, 'ºC'),
	(205601, 121, '2014-02-15 00:29:39.000000', 'temperatura', 483.0000, 'ºC'),
	(205602, 121, '2014-02-15 00:29:40.000000', 'temperatura', 255.0000, 'ºC'),
	(205603, 121, '2014-02-15 00:29:41.000000', 'temperatura', 1026.0000, 'ºC'),
	(205604, 121, '2014-02-15 00:29:42.000000', 'temperatura', 765.0000, 'ºC'),
	(205605, 121, '2014-02-15 00:29:43.000000', 'temperatura', 746.0000, 'ºC'),
	(205606, 121, '2014-02-15 00:29:44.000000', 'temperatura', 238.0000, 'ºC'),
	(205607, 121, '2014-02-15 00:29:45.000000', 'temperatura', 153.0000, 'ºC'),
	(205608, 121, '2014-02-15 00:29:46.000000', 'temperatura', 50.0000, 'ºC'),
	(205609, 121, '2014-02-15 00:29:47.000000', 'temperatura', 990.0000, 'ºC'),
	(205610, 121, '2014-02-15 00:29:48.000000', 'temperatura', 3.0000, 'ºC'),
	(205611, 121, '2014-02-15 00:29:49.000000', 'temperatura', 645.0000, 'ºC'),
	(205612, 121, '2014-02-15 00:29:50.000000', 'temperatura', 818.0000, 'ºC'),
	(205613, 121, '2014-02-15 00:29:51.000000', 'temperatura', 953.0000, 'ºC'),
	(205614, 121, '2014-02-15 00:29:52.000000', 'temperatura', 1110.0000, 'ºC'),
	(205615, 121, '2014-02-15 00:29:53.000000', 'temperatura', 295.0000, 'ºC'),
	(205616, 121, '2014-02-15 00:29:54.000000', 'temperatura', 545.0000, 'ºC'),
	(205617, 121, '2014-02-15 00:29:55.000000', 'temperatura', 641.0000, 'ºC'),
	(205618, 121, '2014-02-15 00:29:56.000000', 'temperatura', 372.0000, 'ºC'),
	(205619, 121, '2014-02-15 00:29:57.000000', 'temperatura', 1135.0000, 'ºC'),
	(205620, 121, '2014-02-15 00:29:58.000000', 'temperatura', 960.0000, 'ºC'),
	(205621, 121, '2014-02-15 00:29:59.000000', 'temperatura', 196.0000, 'ºC'),
	(205622, 121, '2014-02-15 00:30:00.000000', 'temperatura', 498.0000, 'ºC'),
	(205623, 121, '2014-02-15 00:30:01.000000', 'temperatura', 706.0000, 'ºC'),
	(205624, 121, '2014-02-15 00:30:02.000000', 'temperatura', 834.0000, 'ºC'),
	(205625, 121, '2014-02-15 00:30:03.000000', 'temperatura', 855.0000, 'ºC'),
	(205626, 121, '2014-02-15 00:30:04.000000', 'temperatura', 573.0000, 'ºC'),
	(205627, 121, '2014-02-15 00:30:05.000000', 'temperatura', 302.0000, 'ºC'),
	(205628, 121, '2014-02-15 00:30:06.000000', 'temperatura', 989.0000, 'ºC'),
	(205629, 121, '2014-02-15 00:30:07.000000', 'temperatura', 441.0000, 'ºC'),
	(205630, 121, '2014-02-15 00:30:08.000000', 'temperatura', 439.0000, 'ºC'),
	(205631, 121, '2014-02-15 00:30:09.000000', 'temperatura', 871.0000, 'ºC'),
	(205632, 121, '2014-02-15 00:30:10.000000', 'temperatura', 638.0000, 'ºC'),
	(205633, 121, '2014-02-15 00:30:11.000000', 'temperatura', 578.0000, 'ºC'),
	(205634, 121, '2014-02-15 00:30:12.000000', 'temperatura', 975.0000, 'ºC'),
	(205635, 121, '2014-02-15 00:30:13.000000', 'temperatura', 743.0000, 'ºC'),
	(205636, 121, '2014-02-15 00:30:14.000000', 'temperatura', 789.0000, 'ºC'),
	(205637, 121, '2014-02-15 00:30:15.000000', 'temperatura', 518.0000, 'ºC'),
	(205638, 121, '2014-02-15 00:30:16.000000', 'temperatura', 225.0000, 'ºC'),
	(205639, 121, '2014-02-15 00:30:17.000000', 'temperatura', 770.0000, 'ºC'),
	(205640, 121, '2014-02-15 00:30:18.000000', 'temperatura', 777.0000, 'ºC'),
	(205641, 121, '2014-02-15 00:30:19.000000', 'temperatura', 376.0000, 'ºC'),
	(205642, 121, '2014-02-15 00:30:20.000000', 'temperatura', 749.0000, 'ºC'),
	(205643, 121, '2014-02-15 00:30:21.000000', 'temperatura', 216.0000, 'ºC'),
	(205644, 121, '2014-02-15 00:30:22.000000', 'temperatura', 35.0000, 'ºC'),
	(205645, 121, '2014-02-15 00:30:23.000000', 'temperatura', 725.0000, 'ºC'),
	(205646, 121, '2014-02-15 00:30:24.000000', 'temperatura', 1124.0000, 'ºC'),
	(205647, 121, '2014-02-15 00:30:25.000000', 'temperatura', 1044.0000, 'ºC'),
	(205648, 121, '2014-02-15 00:30:26.000000', 'temperatura', 649.0000, 'ºC'),
	(205649, 121, '2014-02-15 00:30:27.000000', 'temperatura', 111.0000, 'ºC'),
	(205650, 121, '2014-02-15 00:30:28.000000', 'temperatura', 1010.0000, 'ºC'),
	(205651, 121, '2014-02-15 00:30:29.000000', 'temperatura', 1118.0000, 'ºC'),
	(205652, 121, '2014-02-15 00:30:30.000000', 'temperatura', 160.0000, 'ºC'),
	(205653, 121, '2014-02-15 00:30:31.000000', 'temperatura', 1047.0000, 'ºC'),
	(205654, 121, '2014-02-15 00:30:32.000000', 'temperatura', 1157.0000, 'ºC'),
	(205655, 121, '2014-02-15 00:30:33.000000', 'temperatura', 243.0000, 'ºC'),
	(205656, 121, '2014-02-15 00:30:34.000000', 'temperatura', 143.0000, 'ºC'),
	(205657, 121, '2014-02-15 00:30:35.000000', 'temperatura', 1188.0000, 'ºC'),
	(205658, 121, '2014-02-15 00:30:36.000000', 'temperatura', 713.0000, 'ºC'),
	(205659, 121, '2014-02-15 00:30:37.000000', 'temperatura', 1.0000, 'ºC'),
	(205660, 121, '2014-02-15 00:30:38.000000', 'temperatura', 267.0000, 'ºC'),
	(205661, 121, '2014-02-15 00:30:39.000000', 'temperatura', 132.0000, 'ºC'),
	(205662, 121, '2014-02-15 00:30:40.000000', 'temperatura', 1058.0000, 'ºC'),
	(205663, 121, '2014-02-15 00:30:41.000000', 'temperatura', 95.0000, 'ºC'),
	(205664, 121, '2014-02-15 00:30:42.000000', 'temperatura', 903.0000, 'ºC'),
	(205665, 121, '2014-02-15 00:30:43.000000', 'temperatura', 628.0000, 'ºC'),
	(205666, 121, '2014-02-15 00:30:44.000000', 'temperatura', 433.0000, 'ºC'),
	(205667, 121, '2014-02-15 00:30:45.000000', 'temperatura', 281.0000, 'ºC'),
	(205668, 121, '2014-02-15 00:30:46.000000', 'temperatura', 109.0000, 'ºC'),
	(205669, 121, '2014-02-15 00:30:47.000000', 'temperatura', 899.0000, 'ºC'),
	(205670, 121, '2014-02-15 00:30:48.000000', 'temperatura', 572.0000, 'ºC'),
	(205671, 121, '2014-02-15 00:30:49.000000', 'temperatura', 160.0000, 'ºC'),
	(205672, 121, '2014-02-15 00:30:50.000000', 'temperatura', 286.0000, 'ºC'),
	(205673, 121, '2014-02-15 00:30:51.000000', 'temperatura', 949.0000, 'ºC'),
	(205674, 121, '2014-02-15 00:30:52.000000', 'temperatura', 290.0000, 'ºC'),
	(205675, 121, '2014-02-15 00:30:53.000000', 'temperatura', 1001.0000, 'ºC'),
	(205676, 121, '2014-02-15 00:30:54.000000', 'temperatura', 537.0000, 'ºC'),
	(205677, 121, '2014-02-15 00:30:55.000000', 'temperatura', 882.0000, 'ºC'),
	(205678, 121, '2014-02-15 00:30:56.000000', 'temperatura', 399.0000, 'ºC'),
	(205679, 121, '2014-02-15 00:30:57.000000', 'temperatura', 551.0000, 'ºC'),
	(205680, 121, '2014-02-15 00:30:58.000000', 'temperatura', 356.0000, 'ºC'),
	(205681, 121, '2014-02-15 00:30:59.000000', 'temperatura', 130.0000, 'ºC'),
	(205682, 121, '2014-02-15 00:31:00.000000', 'temperatura', 781.0000, 'ºC'),
	(205683, 121, '2014-02-15 00:31:01.000000', 'temperatura', 1115.0000, 'ºC'),
	(205684, 121, '2014-02-15 00:31:02.000000', 'temperatura', 833.0000, 'ºC'),
	(205685, 121, '2014-02-15 00:31:03.000000', 'temperatura', 822.0000, 'ºC'),
	(205686, 121, '2014-02-15 00:31:04.000000', 'temperatura', 412.0000, 'ºC'),
	(205687, 121, '2014-02-15 00:31:05.000000', 'temperatura', 795.0000, 'ºC'),
	(205688, 121, '2014-02-15 00:31:06.000000', 'temperatura', 337.0000, 'ºC'),
	(205689, 121, '2014-02-15 00:31:07.000000', 'temperatura', 502.0000, 'ºC'),
	(205690, 121, '2014-02-15 00:31:08.000000', 'temperatura', 299.0000, 'ºC'),
	(205691, 121, '2014-02-15 00:31:09.000000', 'temperatura', 1192.0000, 'ºC'),
	(205692, 121, '2014-02-15 00:31:10.000000', 'temperatura', 260.0000, 'ºC'),
	(205693, 121, '2014-02-15 00:31:11.000000', 'temperatura', 125.0000, 'ºC'),
	(205694, 121, '2014-02-15 00:31:12.000000', 'temperatura', 1047.0000, 'ºC'),
	(205695, 121, '2014-02-15 00:31:13.000000', 'temperatura', 59.0000, 'ºC'),
	(205696, 121, '2014-02-15 00:31:14.000000', 'temperatura', 756.0000, 'ºC'),
	(205697, 121, '2014-02-15 00:31:15.000000', 'temperatura', 2.0000, 'ºC'),
	(205698, 121, '2014-02-15 00:31:16.000000', 'temperatura', 143.0000, 'ºC'),
	(205699, 121, '2014-02-15 00:31:17.000000', 'temperatura', 711.0000, 'ºC'),
	(205700, 121, '2014-02-15 00:31:18.000000', 'temperatura', 727.0000, 'ºC'),
	(205701, 121, '2014-02-15 00:31:19.000000', 'temperatura', 301.0000, 'ºC'),
	(205702, 121, '2014-02-15 00:31:20.000000', 'temperatura', 525.0000, 'ºC'),
	(205703, 121, '2014-02-15 00:31:21.000000', 'temperatura', 524.0000, 'ºC'),
	(205704, 121, '2014-02-15 00:31:22.000000', 'temperatura', 1042.0000, 'ºC'),
	(205705, 121, '2014-02-15 00:31:23.000000', 'temperatura', 41.0000, 'ºC'),
	(205706, 121, '2014-02-15 00:31:24.000000', 'temperatura', 680.0000, 'ºC'),
	(205707, 121, '2014-02-15 00:31:25.000000', 'temperatura', 878.0000, 'ºC'),
	(205708, 121, '2014-02-15 00:31:26.000000', 'temperatura', 1150.0000, 'ºC'),
	(205709, 121, '2014-02-15 00:31:27.000000', 'temperatura', 714.0000, 'ºC'),
	(205710, 121, '2014-02-15 00:31:28.000000', 'temperatura', 124.0000, 'ºC'),
	(205711, 121, '2014-02-15 00:31:29.000000', 'temperatura', 875.0000, 'ºC'),
	(205712, 121, '2014-02-15 00:31:30.000000', 'temperatura', 406.0000, 'ºC'),
	(205713, 121, '2014-02-15 00:31:31.000000', 'temperatura', 607.0000, 'ºC'),
	(205714, 121, '2014-02-15 00:31:32.000000', 'temperatura', 614.0000, 'ºC'),
	(205715, 121, '2014-02-15 00:31:33.000000', 'temperatura', 51.0000, 'ºC'),
	(205716, 121, '2014-02-15 00:31:34.000000', 'temperatura', 813.0000, 'ºC'),
	(205717, 121, '2014-02-15 00:31:35.000000', 'temperatura', 315.0000, 'ºC'),
	(205718, 121, '2014-02-15 00:31:36.000000', 'temperatura', 334.0000, 'ºC'),
	(205719, 121, '2014-02-15 00:31:37.000000', 'temperatura', 727.0000, 'ºC'),
	(205720, 121, '2014-02-15 00:31:38.000000', 'temperatura', 232.0000, 'ºC'),
	(205721, 121, '2014-02-15 00:31:39.000000', 'temperatura', 181.0000, 'ºC'),
	(205722, 121, '2014-02-15 00:31:40.000000', 'temperatura', 209.0000, 'ºC'),
	(205723, 121, '2014-02-15 00:31:41.000000', 'temperatura', 502.0000, 'ºC'),
	(205724, 121, '2014-02-15 00:31:42.000000', 'temperatura', 685.0000, 'ºC'),
	(205725, 121, '2014-02-15 00:31:43.000000', 'temperatura', 717.0000, 'ºC'),
	(205726, 121, '2014-02-15 00:31:44.000000', 'temperatura', 332.0000, 'ºC'),
	(205727, 121, '2014-02-15 00:31:45.000000', 'temperatura', 711.0000, 'ºC'),
	(205728, 121, '2014-02-15 00:31:46.000000', 'temperatura', 159.0000, 'ºC'),
	(205729, 121, '2014-02-15 00:31:47.000000', 'temperatura', 1062.0000, 'ºC'),
	(205730, 121, '2014-02-15 00:31:48.000000', 'temperatura', 35.0000, 'ºC'),
	(205731, 121, '2014-02-15 00:31:49.000000', 'temperatura', 587.0000, 'ºC'),
	(205732, 121, '2014-02-15 00:31:50.000000', 'temperatura', 432.0000, 'ºC'),
	(205733, 121, '2014-02-15 00:31:51.000000', 'temperatura', 401.0000, 'ºC'),
	(205734, 121, '2014-02-15 00:31:52.000000', 'temperatura', 708.0000, 'ºC'),
	(205735, 121, '2014-02-15 00:31:53.000000', 'temperatura', 1140.0000, 'ºC'),
	(205736, 121, '2014-02-15 00:31:54.000000', 'temperatura', 1174.0000, 'ºC'),
	(205737, 121, '2014-02-15 00:31:55.000000', 'temperatura', 49.0000, 'ºC'),
	(205738, 121, '2014-02-15 00:31:56.000000', 'temperatura', 327.0000, 'ºC'),
	(205739, 121, '2014-02-15 00:31:57.000000', 'temperatura', 287.0000, 'ºC'),
	(205740, 121, '2014-02-15 00:31:58.000000', 'temperatura', 454.0000, 'ºC'),
	(205741, 121, '2014-02-15 00:31:59.000000', 'temperatura', 209.0000, 'ºC'),
	(205742, 121, '2014-02-15 00:32:00.000000', 'temperatura', 882.0000, 'ºC'),
	(205743, 121, '2014-02-15 00:32:01.000000', 'temperatura', 186.0000, 'ºC'),
	(205744, 121, '2014-02-15 00:32:02.000000', 'temperatura', 684.0000, 'ºC'),
	(205745, 121, '2014-02-15 00:32:03.000000', 'temperatura', 462.0000, 'ºC'),
	(205746, 121, '2014-02-15 00:32:04.000000', 'temperatura', 257.0000, 'ºC'),
	(205747, 121, '2014-02-15 00:32:05.000000', 'temperatura', 1099.0000, 'ºC'),
	(205748, 121, '2014-02-15 00:32:06.000000', 'temperatura', 1126.0000, 'ºC'),
	(205749, 121, '2014-02-15 00:32:07.000000', 'temperatura', 1135.0000, 'ºC'),
	(205750, 121, '2014-02-15 00:32:08.000000', 'temperatura', 1097.0000, 'ºC'),
	(205751, 121, '2014-02-15 00:32:09.000000', 'temperatura', 882.0000, 'ºC'),
	(205752, 121, '2014-02-15 00:32:10.000000', 'temperatura', 1119.0000, 'ºC'),
	(205753, 121, '2014-02-15 00:32:11.000000', 'temperatura', 547.0000, 'ºC'),
	(205754, 121, '2014-02-15 00:32:12.000000', 'temperatura', 580.0000, 'ºC'),
	(205755, 121, '2014-02-15 00:32:13.000000', 'temperatura', 61.0000, 'ºC'),
	(205756, 121, '2014-02-15 00:32:14.000000', 'temperatura', 964.0000, 'ºC'),
	(205757, 121, '2014-02-15 00:32:15.000000', 'temperatura', 1037.0000, 'ºC'),
	(205758, 121, '2014-02-15 00:32:16.000000', 'temperatura', 1094.0000, 'ºC'),
	(205759, 121, '2014-02-15 00:32:17.000000', 'temperatura', 1157.0000, 'ºC'),
	(205760, 121, '2014-02-15 00:32:18.000000', 'temperatura', 107.0000, 'ºC'),
	(205761, 121, '2014-02-15 00:32:19.000000', 'temperatura', 665.0000, 'ºC'),
	(205762, 121, '2014-02-15 00:32:20.000000', 'temperatura', 603.0000, 'ºC'),
	(205763, 121, '2014-02-15 00:32:21.000000', 'temperatura', 1019.0000, 'ºC'),
	(205764, 121, '2014-02-15 00:32:22.000000', 'temperatura', 889.0000, 'ºC'),
	(205765, 121, '2014-02-15 00:32:23.000000', 'temperatura', 185.0000, 'ºC'),
	(205766, 121, '2014-02-15 00:32:24.000000', 'temperatura', 662.0000, 'ºC'),
	(205767, 121, '2014-02-15 00:32:25.000000', 'temperatura', 356.0000, 'ºC'),
	(205768, 121, '2014-02-15 00:32:26.000000', 'temperatura', 993.0000, 'ºC'),
	(205769, 121, '2014-02-15 00:32:27.000000', 'temperatura', 296.0000, 'ºC'),
	(205770, 121, '2014-02-15 00:32:28.000000', 'temperatura', 903.0000, 'ºC'),
	(205771, 121, '2014-02-15 00:32:29.000000', 'temperatura', 25.0000, 'ºC'),
	(205772, 121, '2014-02-15 00:32:30.000000', 'temperatura', 1019.0000, 'ºC'),
	(205773, 121, '2014-02-15 00:32:31.000000', 'temperatura', 222.0000, 'ºC'),
	(205774, 121, '2014-02-15 00:32:32.000000', 'temperatura', 452.0000, 'ºC'),
	(205775, 121, '2014-02-15 00:32:33.000000', 'temperatura', 394.0000, 'ºC'),
	(205776, 121, '2014-02-15 00:32:34.000000', 'temperatura', 616.0000, 'ºC'),
	(205777, 121, '2014-02-15 00:32:35.000000', 'temperatura', 697.0000, 'ºC'),
	(205778, 121, '2014-02-15 00:32:36.000000', 'temperatura', 439.0000, 'ºC'),
	(205779, 121, '2014-02-15 00:32:37.000000', 'temperatura', 103.0000, 'ºC'),
	(205780, 121, '2014-02-15 00:32:38.000000', 'temperatura', 401.0000, 'ºC'),
	(205781, 121, '2014-02-15 00:32:39.000000', 'temperatura', 495.0000, 'ºC'),
	(205782, 121, '2014-02-15 00:32:40.000000', 'temperatura', 71.0000, 'ºC'),
	(205783, 121, '2014-02-15 00:32:41.000000', 'temperatura', 73.0000, 'ºC'),
	(205784, 121, '2014-02-15 00:32:42.000000', 'temperatura', 153.0000, 'ºC'),
	(205785, 121, '2014-02-15 00:32:43.000000', 'temperatura', 546.0000, 'ºC'),
	(205786, 121, '2014-02-15 00:32:44.000000', 'temperatura', 1071.0000, 'ºC'),
	(205787, 121, '2014-02-15 00:32:45.000000', 'temperatura', 116.0000, 'ºC'),
	(205788, 121, '2014-02-15 00:32:46.000000', 'temperatura', 969.0000, 'ºC'),
	(205789, 121, '2014-02-15 00:32:47.000000', 'temperatura', 897.0000, 'ºC'),
	(205790, 121, '2014-02-15 00:32:48.000000', 'temperatura', 379.0000, 'ºC'),
	(205791, 121, '2014-02-15 00:32:49.000000', 'temperatura', 403.0000, 'ºC'),
	(205792, 121, '2014-02-15 00:32:50.000000', 'temperatura', 879.0000, 'ºC'),
	(205793, 121, '2014-02-15 00:32:51.000000', 'temperatura', 785.0000, 'ºC'),
	(205794, 121, '2014-02-15 00:32:52.000000', 'temperatura', 90.0000, 'ºC'),
	(205795, 121, '2014-02-15 00:32:53.000000', 'temperatura', 496.0000, 'ºC'),
	(205796, 121, '2014-02-15 00:32:54.000000', 'temperatura', 1012.0000, 'ºC'),
	(205797, 121, '2014-02-15 00:32:55.000000', 'temperatura', 1170.0000, 'ºC'),
	(205798, 121, '2014-02-15 00:32:56.000000', 'temperatura', 417.0000, 'ºC'),
	(205799, 121, '2014-02-15 00:32:57.000000', 'temperatura', 973.0000, 'ºC'),
	(205800, 121, '2014-02-15 00:32:58.000000', 'temperatura', 13.0000, 'ºC'),
	(205801, 121, '2014-02-15 00:32:59.000000', 'temperatura', 749.0000, 'ºC'),
	(205802, 121, '2014-02-15 00:33:00.000000', 'temperatura', 107.0000, 'ºC'),
	(205803, 121, '2014-02-15 00:33:01.000000', 'temperatura', 688.0000, 'ºC'),
	(205804, 121, '2014-02-15 00:33:02.000000', 'temperatura', 721.0000, 'ºC'),
	(205805, 121, '2014-02-15 00:33:03.000000', 'temperatura', 341.0000, 'ºC'),
	(205806, 121, '2014-02-15 00:33:04.000000', 'temperatura', 743.0000, 'ºC'),
	(205807, 121, '2014-02-15 00:33:05.000000', 'temperatura', 291.0000, 'ºC'),
	(205808, 121, '2014-02-15 00:33:06.000000', 'temperatura', 427.0000, 'ºC'),
	(205809, 121, '2014-02-15 00:33:07.000000', 'temperatura', 64.0000, 'ºC'),
	(205810, 121, '2014-02-15 00:33:08.000000', 'temperatura', 240.0000, 'ºC'),
	(205811, 121, '2014-02-15 00:33:09.000000', 'temperatura', 1006.0000, 'ºC'),
	(205812, 121, '2014-02-15 00:33:10.000000', 'temperatura', 711.0000, 'ºC'),
	(205813, 121, '2014-02-15 00:33:11.000000', 'temperatura', 539.0000, 'ºC'),
	(205814, 121, '2014-02-15 00:33:12.000000', 'temperatura', 560.0000, 'ºC'),
	(205815, 121, '2014-02-15 00:33:13.000000', 'temperatura', 1183.0000, 'ºC'),
	(205816, 121, '2014-02-15 00:33:14.000000', 'temperatura', 637.0000, 'ºC'),
	(205817, 121, '2014-02-15 00:33:15.000000', 'temperatura', 836.0000, 'ºC'),
	(205818, 121, '2014-02-15 00:33:16.000000', 'temperatura', 1071.0000, 'ºC'),
	(205819, 121, '2014-02-15 00:33:17.000000', 'temperatura', 446.0000, 'ºC'),
	(205820, 121, '2014-02-15 00:33:18.000000', 'temperatura', 218.0000, 'ºC'),
	(205821, 121, '2014-02-15 00:33:19.000000', 'temperatura', 951.0000, 'ºC'),
	(205822, 121, '2014-02-15 00:33:20.000000', 'temperatura', 504.0000, 'ºC'),
	(205823, 121, '2014-02-15 00:33:21.000000', 'temperatura', 866.0000, 'ºC'),
	(205824, 121, '2014-02-15 00:33:22.000000', 'temperatura', 417.0000, 'ºC'),
	(205825, 121, '2014-02-15 00:33:23.000000', 'temperatura', 690.0000, 'ºC'),
	(205826, 121, '2014-02-15 00:33:24.000000', 'temperatura', 999.0000, 'ºC'),
	(205827, 121, '2014-02-15 00:33:25.000000', 'temperatura', 524.0000, 'ºC'),
	(205828, 121, '2014-02-15 00:33:26.000000', 'temperatura', 823.0000, 'ºC'),
	(205829, 121, '2014-02-15 00:33:27.000000', 'temperatura', 145.0000, 'ºC'),
	(205830, 121, '2014-02-15 00:33:28.000000', 'temperatura', 657.0000, 'ºC'),
	(205831, 121, '2014-02-15 00:33:29.000000', 'temperatura', 450.0000, 'ºC'),
	(205832, 121, '2014-02-15 00:33:30.000000', 'temperatura', 278.0000, 'ºC'),
	(205833, 121, '2014-02-15 00:33:31.000000', 'temperatura', 40.0000, 'ºC'),
	(205834, 121, '2014-02-15 00:33:32.000000', 'temperatura', 570.0000, 'ºC'),
	(205835, 121, '2014-02-15 00:33:33.000000', 'temperatura', 327.0000, 'ºC'),
	(205836, 121, '2014-02-15 00:33:34.000000', 'temperatura', 1127.0000, 'ºC'),
	(205837, 121, '2014-02-15 00:33:35.000000', 'temperatura', 1052.0000, 'ºC'),
	(205838, 121, '2014-02-15 00:33:36.000000', 'temperatura', 682.0000, 'ºC'),
	(205839, 121, '2014-02-15 00:33:37.000000', 'temperatura', 256.0000, 'ºC'),
	(205840, 121, '2014-02-15 00:33:38.000000', 'temperatura', 433.0000, 'ºC'),
	(205841, 121, '2014-02-15 00:33:39.000000', 'temperatura', 197.0000, 'ºC'),
	(205842, 121, '2014-02-15 00:33:40.000000', 'temperatura', 887.0000, 'ºC'),
	(205843, 121, '2014-02-15 00:33:41.000000', 'temperatura', 246.0000, 'ºC'),
	(205844, 121, '2014-02-15 00:33:42.000000', 'temperatura', 967.0000, 'ºC'),
	(205845, 121, '2014-02-15 00:33:43.000000', 'temperatura', 499.0000, 'ºC'),
	(205846, 121, '2014-02-15 00:33:44.000000', 'temperatura', 796.0000, 'ºC'),
	(205847, 121, '2014-02-15 00:33:45.000000', 'temperatura', 83.0000, 'ºC'),
	(205848, 121, '2014-02-15 00:33:46.000000', 'temperatura', 425.0000, 'ºC'),
	(205849, 121, '2014-02-15 00:33:47.000000', 'temperatura', 680.0000, 'ºC'),
	(205850, 121, '2014-02-15 00:33:48.000000', 'temperatura', 922.0000, 'ºC'),
	(205851, 121, '2014-02-15 00:33:49.000000', 'temperatura', 174.0000, 'ºC'),
	(205852, 121, '2014-02-15 00:33:50.000000', 'temperatura', 502.0000, 'ºC'),
	(205853, 121, '2014-02-15 00:33:51.000000', 'temperatura', 787.0000, 'ºC'),
	(205854, 121, '2014-02-15 00:33:52.000000', 'temperatura', 33.0000, 'ºC'),
	(205855, 121, '2014-02-15 00:33:53.000000', 'temperatura', 203.0000, 'ºC'),
	(205856, 121, '2014-02-15 00:33:54.000000', 'temperatura', 918.0000, 'ºC'),
	(205857, 121, '2014-02-15 00:33:55.000000', 'temperatura', 382.0000, 'ºC'),
	(205858, 121, '2014-02-15 00:33:56.000000', 'temperatura', 354.0000, 'ºC'),
	(205859, 121, '2014-02-15 00:33:57.000000', 'temperatura', 626.0000, 'ºC'),
	(205860, 121, '2014-02-15 00:33:58.000000', 'temperatura', 866.0000, 'ºC'),
	(205861, 121, '2014-02-15 00:33:59.000000', 'temperatura', 55.0000, 'ºC'),
	(205862, 121, '2014-02-15 00:34:00.000000', 'temperatura', 79.0000, 'ºC'),
	(205863, 121, '2014-02-15 00:34:01.000000', 'temperatura', 227.0000, 'ºC'),
	(205864, 121, '2014-02-15 00:34:02.000000', 'temperatura', 902.0000, 'ºC'),
	(205865, 121, '2014-02-15 00:34:03.000000', 'temperatura', 226.0000, 'ºC'),
	(205866, 121, '2014-02-15 00:34:04.000000', 'temperatura', 827.0000, 'ºC'),
	(205867, 121, '2014-02-15 00:34:05.000000', 'temperatura', 1055.0000, 'ºC'),
	(205868, 121, '2014-02-15 00:34:06.000000', 'temperatura', 398.0000, 'ºC'),
	(205869, 121, '2014-02-15 00:34:07.000000', 'temperatura', 22.0000, 'ºC'),
	(205870, 121, '2014-02-15 00:34:08.000000', 'temperatura', 120.0000, 'ºC'),
	(205871, 121, '2014-02-15 00:34:09.000000', 'temperatura', 531.0000, 'ºC'),
	(205872, 121, '2014-02-15 00:34:10.000000', 'temperatura', 1097.0000, 'ºC'),
	(205873, 121, '2014-02-15 00:34:11.000000', 'temperatura', 293.0000, 'ºC'),
	(205874, 121, '2014-02-15 00:34:12.000000', 'temperatura', 576.0000, 'ºC'),
	(205875, 121, '2014-02-15 00:34:13.000000', 'temperatura', 799.0000, 'ºC'),
	(205876, 121, '2014-02-15 00:34:14.000000', 'temperatura', 1067.0000, 'ºC'),
	(205877, 121, '2014-02-15 00:34:15.000000', 'temperatura', 541.0000, 'ºC'),
	(205878, 121, '2014-02-15 00:34:16.000000', 'temperatura', 702.0000, 'ºC'),
	(205879, 121, '2014-02-15 00:34:17.000000', 'temperatura', 689.0000, 'ºC'),
	(205880, 121, '2014-02-15 00:34:18.000000', 'temperatura', 138.0000, 'ºC'),
	(205881, 121, '2014-02-15 00:34:19.000000', 'temperatura', 1023.0000, 'ºC'),
	(205882, 121, '2014-02-15 00:34:20.000000', 'temperatura', 1104.0000, 'ºC'),
	(205883, 121, '2014-02-15 00:34:21.000000', 'temperatura', 48.0000, 'ºC'),
	(205884, 121, '2014-02-15 00:34:22.000000', 'temperatura', 532.0000, 'ºC'),
	(205885, 121, '2014-02-15 00:34:23.000000', 'temperatura', 115.0000, 'ºC'),
	(205886, 121, '2014-02-15 00:34:24.000000', 'temperatura', 179.0000, 'ºC'),
	(205887, 121, '2014-02-15 00:34:25.000000', 'temperatura', 553.0000, 'ºC'),
	(205888, 121, '2014-02-15 00:34:26.000000', 'temperatura', 1026.0000, 'ºC'),
	(205889, 121, '2014-02-15 00:34:27.000000', 'temperatura', 1073.0000, 'ºC'),
	(205890, 121, '2014-02-15 00:34:28.000000', 'temperatura', 1088.0000, 'ºC'),
	(205891, 121, '2014-02-15 00:34:29.000000', 'temperatura', 1021.0000, 'ºC'),
	(205892, 121, '2014-02-15 00:34:30.000000', 'temperatura', 643.0000, 'ºC'),
	(205893, 121, '2014-02-15 00:34:31.000000', 'temperatura', 150.0000, 'ºC'),
	(205894, 121, '2014-02-15 00:34:32.000000', 'temperatura', 23.0000, 'ºC'),
	(205895, 121, '2014-02-15 00:34:33.000000', 'temperatura', 864.0000, 'ºC'),
	(205896, 121, '2014-02-15 00:34:34.000000', 'temperatura', 652.0000, 'ºC'),
	(205897, 121, '2014-02-15 00:34:35.000000', 'temperatura', 670.0000, 'ºC'),
	(205898, 121, '2014-02-15 00:34:36.000000', 'temperatura', 194.0000, 'ºC'),
	(205899, 121, '2014-02-15 00:34:37.000000', 'temperatura', 159.0000, 'ºC'),
	(205900, 121, '2014-02-15 00:34:38.000000', 'temperatura', 214.0000, 'ºC'),
	(205901, 121, '2014-02-15 00:34:39.000000', 'temperatura', 593.0000, 'ºC'),
	(205902, 121, '2014-02-15 00:34:40.000000', 'temperatura', 1123.0000, 'ºC'),
	(205903, 121, '2014-02-15 00:34:41.000000', 'temperatura', 237.0000, 'ºC'),
	(205904, 121, '2014-02-15 00:34:42.000000', 'temperatura', 218.0000, 'ºC'),
	(205905, 121, '2014-02-15 00:34:43.000000', 'temperatura', 379.0000, 'ºC'),
	(205906, 121, '2014-02-15 00:34:44.000000', 'temperatura', 42.0000, 'ºC'),
	(205907, 121, '2014-02-15 00:34:45.000000', 'temperatura', 271.0000, 'ºC'),
	(205908, 121, '2014-02-15 00:34:46.000000', 'temperatura', 31.0000, 'ºC'),
	(205909, 121, '2014-02-15 00:34:47.000000', 'temperatura', 544.0000, 'ºC'),
	(205910, 121, '2014-02-15 00:34:48.000000', 'temperatura', 226.0000, 'ºC'),
	(205911, 121, '2014-02-15 00:34:49.000000', 'temperatura', 697.0000, 'ºC'),
	(205912, 121, '2014-02-15 00:34:50.000000', 'temperatura', 407.0000, 'ºC'),
	(205913, 121, '2014-02-15 00:34:51.000000', 'temperatura', 1147.0000, 'ºC'),
	(205914, 121, '2014-02-15 00:34:52.000000', 'temperatura', 914.0000, 'ºC'),
	(205915, 121, '2014-02-15 00:34:53.000000', 'temperatura', 1129.0000, 'ºC'),
	(205916, 121, '2014-02-15 00:34:54.000000', 'temperatura', 503.0000, 'ºC'),
	(205917, 121, '2014-02-15 00:34:55.000000', 'temperatura', 329.0000, 'ºC'),
	(205918, 121, '2014-02-15 00:34:56.000000', 'temperatura', 135.0000, 'ºC'),
	(205919, 121, '2014-02-15 00:34:57.000000', 'temperatura', 890.0000, 'ºC'),
	(205920, 121, '2014-02-15 00:34:58.000000', 'temperatura', 444.0000, 'ºC'),
	(205921, 121, '2014-02-15 00:34:59.000000', 'temperatura', 753.0000, 'ºC'),
	(205922, 121, '2014-02-15 00:35:00.000000', 'temperatura', 30.0000, 'ºC'),
	(205923, 121, '2014-02-15 00:35:01.000000', 'temperatura', 295.0000, 'ºC'),
	(205924, 121, '2014-02-15 00:35:02.000000', 'temperatura', 185.0000, 'ºC'),
	(205925, 121, '2014-02-15 00:35:03.000000', 'temperatura', 41.0000, 'ºC'),
	(205926, 121, '2014-02-15 00:35:04.000000', 'temperatura', 850.0000, 'ºC'),
	(205927, 121, '2014-02-15 00:35:05.000000', 'temperatura', 529.0000, 'ºC'),
	(205928, 121, '2014-02-15 00:35:06.000000', 'temperatura', 95.0000, 'ºC'),
	(205929, 121, '2014-02-15 00:35:07.000000', 'temperatura', 88.0000, 'ºC'),
	(205930, 121, '2014-02-15 00:35:08.000000', 'temperatura', 154.0000, 'ºC'),
	(205931, 121, '2014-02-15 00:35:09.000000', 'temperatura', 509.0000, 'ºC'),
	(205932, 121, '2014-02-15 00:35:10.000000', 'temperatura', 882.0000, 'ºC'),
	(205933, 121, '2014-02-15 00:35:11.000000', 'temperatura', 486.0000, 'ºC'),
	(205934, 121, '2014-02-15 00:35:12.000000', 'temperatura', 982.0000, 'ºC'),
	(205935, 121, '2014-02-15 00:35:13.000000', 'temperatura', 1054.0000, 'ºC'),
	(205936, 121, '2014-02-15 00:35:14.000000', 'temperatura', 1123.0000, 'ºC'),
	(205937, 121, '2014-02-15 00:35:15.000000', 'temperatura', 56.0000, 'ºC'),
	(205938, 121, '2014-02-15 00:35:16.000000', 'temperatura', 508.0000, 'ºC'),
	(205939, 121, '2014-02-15 00:35:17.000000', 'temperatura', 1176.0000, 'ºC'),
	(205940, 121, '2014-02-15 00:35:18.000000', 'temperatura', 753.0000, 'ºC'),
	(205941, 121, '2014-02-15 00:35:19.000000', 'temperatura', 240.0000, 'ºC'),
	(205942, 121, '2014-02-15 00:35:20.000000', 'temperatura', 140.0000, 'ºC'),
	(205943, 121, '2014-02-15 00:35:21.000000', 'temperatura', 1182.0000, 'ºC'),
	(205944, 121, '2014-02-15 00:35:22.000000', 'temperatura', 689.0000, 'ºC'),
	(205945, 121, '2014-02-15 00:35:23.000000', 'temperatura', 1099.0000, 'ºC'),
	(205946, 121, '2014-02-15 00:35:24.000000', 'temperatura', 1029.0000, 'ºC'),
	(205947, 121, '2014-02-15 00:35:25.000000', 'temperatura', 647.0000, 'ºC'),
	(205948, 121, '2014-02-15 00:35:26.000000', 'temperatura', 149.0000, 'ºC'),
	(205949, 121, '2014-02-15 00:35:27.000000', 'temperatura', 7.0000, 'ºC'),
	(205950, 121, '2014-02-15 00:35:28.000000', 'temperatura', 786.0000, 'ºC'),
	(205951, 121, '2014-02-15 00:35:29.000000', 'temperatura', 308.0000, 'ºC'),
	(205952, 121, '2014-02-15 00:35:30.000000', 'temperatura', 385.0000, 'ºC'),
	(205953, 121, '2014-02-15 00:35:31.000000', 'temperatura', 1002.0000, 'ºC'),
	(205954, 121, '2014-02-15 00:35:32.000000', 'temperatura', 255.0000, 'ºC'),
	(205955, 121, '2014-02-15 00:35:33.000000', 'temperatura', 668.0000, 'ºC'),
	(205956, 121, '2014-02-15 00:35:34.000000', 'temperatura', 178.0000, 'ºC'),
	(205957, 121, '2014-02-15 00:35:35.000000', 'temperatura', 86.0000, 'ºC'),
	(205958, 121, '2014-02-15 00:35:36.000000', 'temperatura', 1098.0000, 'ºC'),
	(205959, 121, '2014-02-15 00:35:37.000000', 'temperatura', 430.0000, 'ºC'),
	(205960, 121, '2014-02-15 00:35:38.000000', 'temperatura', 56.0000, 'ºC'),
	(205961, 121, '2014-02-15 00:35:39.000000', 'temperatura', 192.0000, 'ºC'),
	(205962, 121, '2014-02-15 00:35:40.000000', 'temperatura', 793.0000, 'ºC'),
	(205963, 121, '2014-02-15 00:35:41.000000', 'temperatura', 987.0000, 'ºC'),
	(205964, 121, '2014-02-15 00:35:42.000000', 'temperatura', 158.0000, 'ºC'),
	(205965, 121, '2014-02-15 00:35:43.000000', 'temperatura', 228.0000, 'ºC'),
	(205966, 121, '2014-02-15 00:35:44.000000', 'temperatura', 668.0000, 'ºC'),
	(205967, 121, '2014-02-15 00:35:45.000000', 'temperatura', 254.0000, 'ºC'),
	(205968, 121, '2014-02-15 00:35:46.000000', 'temperatura', 468.0000, 'ºC'),
	(205969, 121, '2014-02-15 00:35:47.000000', 'temperatura', 380.0000, 'ºC'),
	(205970, 121, '2014-02-15 00:35:48.000000', 'temperatura', 495.0000, 'ºC'),
	(205971, 121, '2014-02-15 00:35:49.000000', 'temperatura', 136.0000, 'ºC'),
	(205972, 121, '2014-02-15 00:35:50.000000', 'temperatura', 397.0000, 'ºC'),
	(205973, 121, '2014-02-15 00:35:51.000000', 'temperatura', 375.0000, 'ºC'),
	(205974, 121, '2014-02-15 00:35:52.000000', 'temperatura', 686.0000, 'ºC'),
	(205975, 121, '2014-02-15 00:35:53.000000', 'temperatura', 1105.0000, 'ºC'),
	(205976, 121, '2014-02-15 00:35:54.000000', 'temperatura', 1069.0000, 'ºC'),
	(205977, 121, '2014-02-15 00:35:55.000000', 'temperatura', 830.0000, 'ºC'),
	(205978, 121, '2014-02-15 00:35:56.000000', 'temperatura', 942.0000, 'ºC'),
	(205979, 121, '2014-02-15 00:35:57.000000', 'temperatura', 1023.0000, 'ºC'),
	(205980, 121, '2014-02-15 00:35:58.000000', 'temperatura', 1089.0000, 'ºC'),
	(205981, 121, '2014-02-15 00:35:59.000000', 'temperatura', 1177.0000, 'ºC'),
	(205982, 121, '2014-02-15 00:36:00.000000', 'temperatura', 218.0000, 'ºC'),
	(205983, 121, '2014-02-15 00:36:01.000000', 'temperatura', 1161.0000, 'ºC'),
	(205984, 121, '2014-02-15 00:36:02.000000', 'temperatura', 351.0000, 'ºC'),
	(205985, 121, '2014-02-15 00:36:03.000000', 'temperatura', 670.0000, 'ºC'),
	(205986, 121, '2014-02-15 00:36:04.000000', 'temperatura', 1099.0000, 'ºC'),
	(205987, 121, '2014-02-15 00:36:05.000000', 'temperatura', 1085.0000, 'ºC'),
	(205988, 121, '2014-02-15 00:36:06.000000', 'temperatura', 927.0000, 'ºC'),
	(205989, 121, '2014-02-15 00:36:07.000000', 'temperatura', 180.0000, 'ºC'),
	(205990, 121, '2014-02-15 00:36:08.000000', 'temperatura', 523.0000, 'ºC'),
	(205991, 121, '2014-02-15 00:36:09.000000', 'temperatura', 873.0000, 'ºC'),
	(205992, 121, '2014-02-15 00:36:10.000000', 'temperatura', 398.0000, 'ºC'),
	(205993, 121, '2014-02-15 00:36:11.000000', 'temperatura', 573.0000, 'ºC'),
	(205994, 121, '2014-02-15 00:36:12.000000', 'temperatura', 468.0000, 'ºC'),
	(205995, 121, '2014-02-15 00:36:13.000000', 'temperatura', 625.0000, 'ºC'),
	(205996, 121, '2014-02-15 00:36:14.000000', 'temperatura', 518.0000, 'ºC'),
	(205997, 121, '2014-02-15 00:36:15.000000', 'temperatura', 719.0000, 'ºC'),
	(205998, 121, '2014-02-15 00:36:16.000000', 'temperatura', 839.0000, 'ºC'),
	(205999, 121, '2014-02-15 00:36:17.000000', 'temperatura', 840.0000, 'ºC'),
	(206000, 121, '2014-02-15 00:36:18.000000', 'temperatura', 482.0000, 'ºC'),
	(206001, 121, '2014-02-15 00:36:19.000000', 'temperatura', 1090.0000, 'ºC'),
	(206002, 121, '2014-02-15 00:36:20.000000', 'temperatura', 406.0000, 'ºC'),
	(206003, 121, '2014-02-15 00:36:21.000000', 'temperatura', 1160.0000, 'ºC'),
	(206004, 121, '2014-02-15 00:36:22.000000', 'temperatura', 983.0000, 'ºC'),
	(206005, 121, '2014-02-15 00:36:23.000000', 'temperatura', 236.0000, 'ºC'),
	(206006, 121, '2014-02-15 00:36:24.000000', 'temperatura', 632.0000, 'ºC'),
	(206007, 121, '2014-02-15 00:36:25.000000', 'temperatura', 50.0000, 'ºC'),
	(206008, 121, '2014-02-15 00:36:26.000000', 'temperatura', 754.0000, 'ºC'),
	(206009, 121, '2014-02-15 00:36:27.000000', 'temperatura', 23.0000, 'ºC'),
	(206010, 121, '2014-02-15 00:36:28.000000', 'temperatura', 254.0000, 'ºC'),
	(206011, 121, '2014-02-15 00:36:29.000000', 'temperatura', 2.0000, 'ºC'),
	(206012, 121, '2014-02-15 00:36:30.000000', 'temperatura', 448.0000, 'ºC'),
	(206013, 121, '2014-02-15 00:36:31.000000', 'temperatura', 1033.0000, 'ºC'),
	(206014, 121, '2014-02-15 00:36:32.000000', 'temperatura', 221.0000, 'ºC'),
	(206015, 121, '2014-02-15 00:36:33.000000', 'temperatura', 406.0000, 'ºC'),
	(206016, 121, '2014-02-15 00:36:34.000000', 'temperatura', 169.0000, 'ºC'),
	(206017, 121, '2014-02-15 00:36:35.000000', 'temperatura', 825.0000, 'ºC'),
	(206018, 121, '2014-02-15 00:36:36.000000', 'temperatura', 21.0000, 'ºC'),
	(206019, 121, '2014-02-15 00:36:37.000000', 'temperatura', 28.0000, 'ºC'),
	(206020, 121, '2014-02-15 00:36:38.000000', 'temperatura', 78.0000, 'ºC'),
	(206021, 121, '2014-02-15 00:36:39.000000', 'temperatura', 307.0000, 'ºC'),
	(206022, 121, '2014-02-15 00:36:40.000000', 'temperatura', 100.0000, 'ºC'),
	(206023, 121, '2014-02-15 00:36:41.000000', 'temperatura', 780.0000, 'ºC'),
	(206024, 121, '2014-02-15 00:36:42.000000', 'temperatura', 0.0000, 'ºC'),
	(206025, 121, '2014-02-15 00:36:43.000000', 'temperatura', 61.0000, 'ºC'),
	(206026, 121, '2014-02-15 00:36:44.000000', 'temperatura', 304.0000, 'ºC'),
	(206027, 121, '2014-02-15 00:36:45.000000', 'temperatura', 138.0000, 'ºC'),
	(206028, 121, '2014-02-15 00:36:46.000000', 'temperatura', 977.0000, 'ºC'),
	(206029, 121, '2014-02-15 00:36:47.000000', 'temperatura', 875.0000, 'ºC'),
	(206030, 121, '2014-02-15 00:36:48.000000', 'temperatura', 242.0000, 'ºC'),
	(206031, 121, '2014-02-15 00:36:49.000000', 'temperatura', 984.0000, 'ºC'),
	(206032, 121, '2014-02-15 00:36:50.000000', 'temperatura', 598.0000, 'ºC'),
	(206033, 121, '2014-02-15 00:36:51.000000', 'temperatura', 37.0000, 'ºC'),
	(206034, 121, '2014-02-15 00:36:52.000000', 'temperatura', 793.0000, 'ºC'),
	(206035, 121, '2014-02-15 00:36:53.000000', 'temperatura', 253.0000, 'ºC'),
	(206036, 121, '2014-02-15 00:36:54.000000', 'temperatura', 85.0000, 'ºC'),
	(206037, 121, '2014-02-15 00:36:55.000000', 'temperatura', 868.0000, 'ºC'),
	(206038, 121, '2014-02-15 00:36:56.000000', 'temperatura', 484.0000, 'ºC'),
	(206039, 121, '2014-02-15 00:36:57.000000', 'temperatura', 1017.0000, 'ºC'),
	(206040, 121, '2014-02-15 00:36:58.000000', 'temperatura', 34.0000, 'ºC'),
	(206041, 121, '2014-02-15 00:36:59.000000', 'temperatura', 719.0000, 'ºC'),
	(206042, 121, '2014-02-15 00:37:00.000000', 'temperatura', 1094.0000, 'ºC'),
	(206043, 121, '2014-02-15 00:37:01.000000', 'temperatura', 914.0000, 'ºC'),
	(206044, 121, '2014-02-15 00:37:02.000000', 'temperatura', 89.0000, 'ºC'),
	(206045, 121, '2014-02-15 00:37:03.000000', 'temperatura', 103.0000, 'ºC'),
	(206046, 121, '2014-02-15 00:37:04.000000', 'temperatura', 247.0000, 'ºC'),
	(206047, 121, '2014-02-15 00:37:05.000000', 'temperatura', 928.0000, 'ºC'),
	(206048, 121, '2014-02-15 00:37:06.000000', 'temperatura', 299.0000, 'ºC'),
	(206049, 121, '2014-02-15 00:37:07.000000', 'temperatura', 1110.0000, 'ºC'),
	(206050, 121, '2014-02-15 00:37:08.000000', 'temperatura', 1056.0000, 'ºC'),
	(206051, 121, '2014-02-15 00:37:09.000000', 'temperatura', 748.0000, 'ºC'),
	(206052, 121, '2014-02-15 00:37:10.000000', 'temperatura', 574.0000, 'ºC'),
	(206053, 121, '2014-02-15 00:37:11.000000', 'temperatura', 627.0000, 'ºC'),
	(206054, 121, '2014-02-15 00:37:12.000000', 'temperatura', 214.0000, 'ºC'),
	(206055, 121, '2014-02-15 00:37:13.000000', 'temperatura', 390.0000, 'ºC'),
	(206056, 121, '2014-02-15 00:37:14.000000', 'temperatura', 109.0000, 'ºC'),
	(206057, 121, '2014-02-15 00:37:15.000000', 'temperatura', 575.0000, 'ºC'),
	(206058, 121, '2014-02-15 00:37:16.000000', 'temperatura', 150.0000, 'ºC'),
	(206059, 121, '2014-02-15 00:37:17.000000', 'temperatura', 222.0000, 'ºC'),
	(206060, 121, '2014-02-15 00:37:18.000000', 'temperatura', 663.0000, 'ºC'),
	(206061, 121, '2014-02-15 00:37:19.000000', 'temperatura', 248.0000, 'ºC'),
	(206062, 121, '2014-02-15 00:37:20.000000', 'temperatura', 453.0000, 'ºC'),
	(206063, 121, '2014-02-15 00:37:21.000000', 'temperatura', 323.0000, 'ºC'),
	(206064, 121, '2014-02-15 00:37:22.000000', 'temperatura', 255.0000, 'ºC'),
	(206065, 121, '2014-02-15 00:37:23.000000', 'temperatura', 306.0000, 'ºC'),
	(206066, 121, '2014-02-15 00:37:24.000000', 'temperatura', 767.0000, 'ºC'),
	(206067, 121, '2014-02-15 00:37:25.000000', 'temperatura', 517.0000, 'ºC'),
	(206068, 121, '2014-02-15 00:37:26.000000', 'temperatura', 284.0000, 'ºC'),
	(206069, 121, '2014-02-15 00:37:27.000000', 'temperatura', 1071.0000, 'ºC'),
	(206070, 121, '2014-02-15 00:37:28.000000', 'temperatura', 904.0000, 'ºC'),
	(206071, 121, '2014-02-15 00:37:29.000000', 'temperatura', 105.0000, 'ºC'),
	(206072, 121, '2014-02-15 00:37:30.000000', 'temperatura', 213.0000, 'ºC'),
	(206073, 121, '2014-02-15 00:37:31.000000', 'temperatura', 753.0000, 'ºC'),
	(206074, 121, '2014-02-15 00:37:32.000000', 'temperatura', 726.0000, 'ºC'),
	(206075, 121, '2014-02-15 00:37:33.000000', 'temperatura', 173.0000, 'ºC'),
	(206076, 121, '2014-02-15 00:37:34.000000', 'temperatura', 1085.0000, 'ºC'),
	(206077, 121, '2014-02-15 00:37:35.000000', 'temperatura', 109.0000, 'ºC'),
	(206078, 121, '2014-02-15 00:37:36.000000', 'temperatura', 888.0000, 'ºC'),
	(206079, 121, '2014-02-15 00:37:37.000000', 'temperatura', 516.0000, 'ºC'),
	(206080, 121, '2014-02-15 00:37:38.000000', 'temperatura', 1115.0000, 'ºC'),
	(206081, 121, '2014-02-15 00:37:39.000000', 'temperatura', 428.0000, 'ºC'),
	(206082, 121, '2014-02-15 00:37:40.000000', 'temperatura', 1195.0000, 'ºC'),
	(206083, 121, '2014-02-15 00:37:41.000000', 'temperatura', 1092.0000, 'ºC'),
	(206084, 121, '2014-02-15 00:37:42.000000', 'temperatura', 677.0000, 'ºC'),
	(206085, 121, '2014-02-15 00:37:43.000000', 'temperatura', 109.0000, 'ºC'),
	(206086, 121, '2014-02-15 00:37:44.000000', 'temperatura', 913.0000, 'ºC'),
	(206087, 121, '2014-02-15 00:37:45.000000', 'temperatura', 638.0000, 'ºC'),
	(206088, 121, '2014-02-15 00:37:46.000000', 'temperatura', 453.0000, 'ºC'),
	(206089, 121, '2014-02-15 00:37:47.000000', 'temperatura', 351.0000, 'ºC'),
	(206090, 121, '2014-02-15 00:37:48.000000', 'temperatura', 398.0000, 'ºC'),
	(206091, 121, '2014-02-15 00:37:49.000000', 'temperatura', 937.0000, 'ºC'),
	(206092, 121, '2014-02-15 00:37:50.000000', 'temperatura', 1093.0000, 'ºC'),
	(206093, 121, '2014-02-15 00:37:51.000000', 'temperatura', 252.0000, 'ºC'),
	(206094, 121, '2014-02-15 00:37:52.000000', 'temperatura', 384.0000, 'ºC'),
	(206095, 121, '2014-02-15 00:37:53.000000', 'temperatura', 1161.0000, 'ºC'),
	(206096, 121, '2014-02-15 00:37:54.000000', 'temperatura', 1057.0000, 'ºC'),
	(206097, 121, '2014-02-15 00:37:55.000000', 'temperatura', 601.0000, 'ºC'),
	(206098, 121, '2014-02-15 00:37:56.000000', 'temperatura', 1035.0000, 'ºC'),
	(206099, 121, '2014-02-15 00:37:57.000000', 'temperatura', 974.0000, 'ºC'),
	(206100, 121, '2014-02-15 00:37:58.000000', 'temperatura', 565.0000, 'ºC'),
	(206101, 121, '2014-02-15 00:37:59.000000', 'temperatura', 1103.0000, 'ºC'),
	(206102, 121, '2014-02-15 00:38:00.000000', 'temperatura', 222.0000, 'ºC'),
	(206103, 121, '2014-02-15 00:38:01.000000', 'temperatura', 200.0000, 'ºC'),
	(206104, 121, '2014-02-15 00:38:02.000000', 'temperatura', 335.0000, 'ºC'),
	(206105, 121, '2014-02-15 00:38:03.000000', 'temperatura', 1075.0000, 'ºC'),
	(206106, 121, '2014-02-15 00:38:04.000000', 'temperatura', 769.0000, 'ºC'),
	(206107, 121, '2014-02-15 00:38:05.000000', 'temperatura', 622.0000, 'ºC'),
	(206108, 121, '2014-02-15 00:38:06.000000', 'temperatura', 805.0000, 'ºC'),
	(206109, 121, '2014-02-15 00:38:07.000000', 'temperatura', 956.0000, 'ºC'),
	(206110, 121, '2014-02-15 00:38:08.000000', 'temperatura', 1169.0000, 'ºC'),
	(206111, 121, '2014-02-15 00:38:09.000000', 'temperatura', 576.0000, 'ºC'),
	(206112, 121, '2014-02-15 00:38:10.000000', 'temperatura', 575.0000, 'ºC'),
	(206113, 121, '2014-02-15 00:38:11.000000', 'temperatura', 1148.0000, 'ºC'),
	(206114, 121, '2014-02-15 00:38:12.000000', 'temperatura', 416.0000, 'ºC'),
	(206115, 121, '2014-02-15 00:38:13.000000', 'temperatura', 1035.0000, 'ºC'),
	(206116, 121, '2014-02-15 00:38:14.000000', 'temperatura', 329.0000, 'ºC'),
	(206117, 121, '2014-02-15 00:38:15.000000', 'temperatura', 938.0000, 'ºC'),
	(206118, 121, '2014-02-15 00:38:16.000000', 'temperatura', 105.0000, 'ºC'),
	(206119, 121, '2014-02-15 00:38:17.000000', 'temperatura', 113.0000, 'ºC'),
	(206120, 121, '2014-02-15 00:38:18.000000', 'temperatura', 248.0000, 'ºC'),
	(206121, 121, '2014-02-15 00:38:19.000000', 'temperatura', 903.0000, 'ºC'),
	(206122, 121, '2014-02-15 00:38:20.000000', 'temperatura', 173.0000, 'ºC'),
	(206123, 121, '2014-02-15 00:38:21.000000', 'temperatura', 554.0000, 'ºC'),
	(206124, 121, '2014-02-15 00:38:22.000000', 'temperatura', 1052.0000, 'ºC'),
	(206125, 121, '2014-02-15 00:38:23.000000', 'temperatura', 1198.0000, 'ºC'),
	(206126, 121, '2014-02-15 00:38:24.000000', 'temperatura', 435.0000, 'ºC'),
	(206127, 121, '2014-02-15 00:38:25.000000', 'temperatura', 982.0000, 'ºC'),
	(206128, 121, '2014-02-15 00:38:26.000000', 'temperatura', 4.0000, 'ºC'),
	(206129, 121, '2014-02-15 00:38:27.000000', 'temperatura', 675.0000, 'ºC'),
	(206130, 121, '2014-02-15 00:38:28.000000', 'temperatura', 963.0000, 'ºC'),
	(206131, 121, '2014-02-15 00:38:29.000000', 'temperatura', 392.0000, 'ºC'),
	(206132, 121, '2014-02-15 00:38:30.000000', 'temperatura', 271.0000, 'ºC'),
	(206133, 121, '2014-02-15 00:38:31.000000', 'temperatura', 181.0000, 'ºC'),
	(206134, 121, '2014-02-15 00:38:32.000000', 'temperatura', 91.0000, 'ºC'),
	(206135, 121, '2014-02-15 00:38:33.000000', 'temperatura', 1114.0000, 'ºC'),
	(206136, 121, '2014-02-15 00:38:34.000000', 'temperatura', 495.0000, 'ºC'),
	(206137, 121, '2014-02-15 00:38:35.000000', 'temperatura', 336.0000, 'ºC'),
	(206138, 121, '2014-02-15 00:38:36.000000', 'temperatura', 194.0000, 'ºC'),
	(206139, 121, '2014-02-15 00:38:37.000000', 'temperatura', 1162.0000, 'ºC'),
	(206140, 121, '2014-02-15 00:38:38.000000', 'temperatura', 429.0000, 'ºC'),
	(206141, 121, '2014-02-15 00:38:39.000000', 'temperatura', 1060.0000, 'ºC'),
	(206142, 121, '2014-02-15 00:38:40.000000', 'temperatura', 414.0000, 'ºC'),
	(206143, 121, '2014-02-15 00:38:41.000000', 'temperatura', 91.0000, 'ºC'),
	(206144, 121, '2014-02-15 00:38:42.000000', 'temperatura', 415.0000, 'ºC'),
	(206145, 121, '2014-02-15 00:38:43.000000', 'temperatura', 600.0000, 'ºC'),
	(206146, 121, '2014-02-15 00:38:44.000000', 'temperatura', 558.0000, 'ºC'),
	(206147, 121, '2014-02-15 00:38:45.000000', 'temperatura', 988.0000, 'ºC'),
	(206148, 121, '2014-02-15 00:38:46.000000', 'temperatura', 867.0000, 'ºC'),
	(206149, 121, '2014-02-15 00:38:47.000000', 'temperatura', 170.0000, 'ºC'),
	(206150, 121, '2014-02-15 00:38:48.000000', 'temperatura', 653.0000, 'ºC'),
	(206151, 121, '2014-02-15 00:38:49.000000', 'temperatura', 353.0000, 'ºC'),
	(206152, 121, '2014-02-15 00:38:50.000000', 'temperatura', 1007.0000, 'ºC'),
	(206153, 121, '2014-02-15 00:38:51.000000', 'temperatura', 377.0000, 'ºC'),
	(206154, 121, '2014-02-15 00:38:52.000000', 'temperatura', 66.0000, 'ºC'),
	(206155, 121, '2014-02-15 00:38:53.000000', 'temperatura', 398.0000, 'ºC'),
	(206156, 121, '2014-02-15 00:38:54.000000', 'temperatura', 591.0000, 'ºC'),
	(206157, 121, '2014-02-15 00:38:55.000000', 'temperatura', 563.0000, 'ºC'),
	(206158, 121, '2014-02-15 00:38:56.000000', 'temperatura', 1040.0000, 'ºC'),
	(206159, 121, '2014-02-15 00:38:57.000000', 'temperatura', 1114.0000, 'ºC'),
	(206160, 121, '2014-02-15 00:38:58.000000', 'temperatura', 51.0000, 'ºC'),
	(206161, 121, '2014-02-15 00:38:59.000000', 'temperatura', 512.0000, 'ºC'),
	(206162, 121, '2014-02-15 00:39:00.000000', 'temperatura', 6.0000, 'ºC'),
	(206163, 121, '2014-02-15 00:39:01.000000', 'temperatura', 897.0000, 'ºC'),
	(206164, 121, '2014-02-15 00:39:02.000000', 'temperatura', 866.0000, 'ºC'),
	(206165, 121, '2014-02-15 00:39:03.000000', 'temperatura', 440.0000, 'ºC'),
	(206166, 121, '2014-02-15 00:39:04.000000', 'temperatura', 801.0000, 'ºC'),
	(206167, 121, '2014-02-15 00:39:05.000000', 'temperatura', 286.0000, 'ºC'),
	(206168, 121, '2014-02-15 00:39:06.000000', 'temperatura', 226.0000, 'ºC'),
	(206169, 121, '2014-02-15 00:39:07.000000', 'temperatura', 276.0000, 'ºC'),
	(206170, 121, '2014-02-15 00:39:08.000000', 'temperatura', 699.0000, 'ºC'),
	(206171, 121, '2014-02-15 00:39:09.000000', 'temperatura', 269.0000, 'ºC'),
	(206172, 121, '2014-02-15 00:39:10.000000', 'temperatura', 450.0000, 'ºC'),
	(206173, 121, '2014-02-15 00:39:11.000000', 'temperatura', 244.0000, 'ºC'),
	(206174, 121, '2014-02-15 00:39:12.000000', 'temperatura', 1071.0000, 'ºC'),
	(206175, 121, '2014-02-15 00:39:13.000000', 'temperatura', 1024.0000, 'ºC'),
	(206176, 121, '2014-02-15 00:39:14.000000', 'temperatura', 706.0000, 'ºC'),
	(206177, 121, '2014-02-15 00:39:15.000000', 'temperatura', 459.0000, 'ºC'),
	(206178, 121, '2014-02-15 00:39:16.000000', 'temperatura', 176.0000, 'ºC'),
	(206179, 121, '2014-02-15 00:39:17.000000', 'temperatura', 706.0000, 'ºC'),
	(206180, 121, '2014-02-15 00:39:18.000000', 'temperatura', 601.0000, 'ºC'),
	(206181, 121, '2014-02-15 00:39:19.000000', 'temperatura', 886.0000, 'ºC'),
	(206182, 121, '2014-02-15 00:39:20.000000', 'temperatura', 230.0000, 'ºC'),
	(206183, 121, '2014-02-15 00:39:21.000000', 'temperatura', 891.0000, 'ºC'),
	(206184, 121, '2014-02-15 00:39:22.000000', 'temperatura', 166.0000, 'ºC'),
	(206185, 121, '2014-02-15 00:39:23.000000', 'temperatura', 556.0000, 'ºC'),
	(206186, 121, '2014-02-15 00:39:24.000000', 'temperatura', 1085.0000, 'ºC'),
	(206187, 121, '2014-02-15 00:39:25.000000', 'temperatura', 158.0000, 'ºC'),
	(206188, 121, '2014-02-15 00:39:26.000000', 'temperatura', 1135.0000, 'ºC'),
	(206189, 121, '2014-02-15 00:39:27.000000', 'temperatura', 399.0000, 'ºC'),
	(206190, 121, '2014-02-15 00:39:28.000000', 'temperatura', 993.0000, 'ºC'),
	(206191, 121, '2014-02-15 00:39:29.000000', 'temperatura', 169.0000, 'ºC'),
	(206192, 121, '2014-02-15 00:39:30.000000', 'temperatura', 265.0000, 'ºC'),
	(206193, 121, '2014-02-15 00:39:31.000000', 'temperatura', 818.0000, 'ºC'),
	(206194, 121, '2014-02-15 00:39:32.000000', 'temperatura', 896.0000, 'ºC'),
	(206195, 121, '2014-02-15 00:39:33.000000', 'temperatura', 826.0000, 'ºC'),
	(206196, 121, '2014-02-15 00:39:34.000000', 'temperatura', 242.0000, 'ºC'),
	(206197, 121, '2014-02-15 00:39:35.000000', 'temperatura', 1134.0000, 'ºC'),
	(206198, 121, '2014-02-15 00:39:36.000000', 'temperatura', 144.0000, 'ºC'),
	(206199, 121, '2014-02-15 00:39:37.000000', 'temperatura', 916.0000, 'ºC'),
	(206200, 121, '2014-02-15 00:39:38.000000', 'temperatura', 552.0000, 'ºC'),
	(206201, 121, '2014-02-15 00:39:39.000000', 'temperatura', 12.0000, 'ºC'),
	(206202, 121, '2014-02-15 00:39:40.000000', 'temperatura', 806.0000, 'ºC'),
	(206203, 121, '2014-02-15 00:39:41.000000', 'temperatura', 393.0000, 'ºC'),
	(206204, 121, '2014-02-15 00:39:42.000000', 'temperatura', 749.0000, 'ºC'),
	(206205, 121, '2014-02-15 00:39:43.000000', 'temperatura', 166.0000, 'ºC'),
	(206206, 121, '2014-02-15 00:39:44.000000', 'temperatura', 981.0000, 'ºC'),
	(206207, 121, '2014-02-15 00:39:45.000000', 'temperatura', 811.0000, 'ºC'),
	(206208, 121, '2014-02-15 00:39:46.000000', 'temperatura', 1111.0000, 'ºC'),
	(206209, 121, '2014-02-15 00:39:47.000000', 'temperatura', 722.0000, 'ºC'),
	(206210, 121, '2014-02-15 00:39:48.000000', 'temperatura', 280.0000, 'ºC'),
	(206211, 121, '2014-02-15 00:39:49.000000', 'temperatura', 432.0000, 'ºC'),
	(206212, 121, '2014-02-15 00:39:50.000000', 'temperatura', 121.0000, 'ºC'),
	(206213, 121, '2014-02-15 00:39:51.000000', 'temperatura', 511.0000, 'ºC'),
	(206214, 121, '2014-02-15 00:39:52.000000', 'temperatura', 994.0000, 'ºC'),
	(206215, 121, '2014-02-15 00:39:53.000000', 'temperatura', 1034.0000, 'ºC'),
	(206216, 121, '2014-02-15 00:39:54.000000', 'temperatura', 991.0000, 'ºC'),
	(206217, 121, '2014-02-15 00:39:55.000000', 'temperatura', 653.0000, 'ºC'),
	(206218, 121, '2014-02-15 00:39:56.000000', 'temperatura', 291.0000, 'ºC'),
	(206219, 121, '2014-02-15 00:39:57.000000', 'temperatura', 698.0000, 'ºC'),
	(206220, 121, '2014-02-15 00:39:58.000000', 'temperatura', 216.0000, 'ºC'),
	(206221, 121, '2014-02-15 00:39:59.000000', 'temperatura', 189.0000, 'ºC'),
	(206222, 121, '2014-02-15 00:40:00.000000', 'temperatura', 298.0000, 'ºC'),
	(206223, 121, '2014-02-15 00:40:01.000000', 'temperatura', 920.0000, 'ºC'),
	(206224, 121, '2014-02-15 00:40:02.000000', 'temperatura', 110.0000, 'ºC'),
	(206225, 121, '2014-02-15 00:40:03.000000', 'temperatura', 189.0000, 'ºC'),
	(206226, 121, '2014-02-15 00:40:04.000000', 'temperatura', 616.0000, 'ºC'),
	(206227, 121, '2014-02-15 00:40:05.000000', 'temperatura', 114.0000, 'ºC'),
	(206228, 121, '2014-02-15 00:40:06.000000', 'temperatura', 1120.0000, 'ºC'),
	(206229, 121, '2014-02-15 00:40:07.000000', 'temperatura', 460.0000, 'ºC'),
	(206230, 121, '2014-02-15 00:40:08.000000', 'temperatura', 140.0000, 'ºC'),
	(206231, 121, '2014-02-15 00:40:09.000000', 'temperatura', 522.0000, 'ºC'),
	(206232, 121, '2014-02-15 00:40:10.000000', 'temperatura', 988.0000, 'ºC'),
	(206233, 121, '2014-02-15 00:40:11.000000', 'temperatura', 974.0000, 'ºC'),
	(206234, 121, '2014-02-15 00:40:12.000000', 'temperatura', 708.0000, 'ºC'),
	(206235, 121, '2014-02-15 00:40:13.000000', 'temperatura', 618.0000, 'ºC'),
	(206236, 121, '2014-02-15 00:40:14.000000', 'temperatura', 968.0000, 'ºC'),
	(206237, 121, '2014-02-15 00:40:15.000000', 'temperatura', 587.0000, 'ºC'),
	(206238, 121, '2014-02-15 00:40:16.000000', 'temperatura', 28.0000, 'ºC'),
	(206239, 121, '2014-02-15 00:40:17.000000', 'temperatura', 783.0000, 'ºC'),
	(206240, 121, '2014-02-15 00:40:18.000000', 'temperatura', 232.0000, 'ºC'),
	(206241, 121, '2014-02-15 00:40:19.000000', 'temperatura', 8.0000, 'ºC'),
	(206242, 121, '2014-02-15 00:40:20.000000', 'temperatura', 548.0000, 'ºC'),
	(206243, 121, '2014-02-15 00:40:21.000000', 'temperatura', 316.0000, 'ºC'),
	(206244, 121, '2014-02-15 00:40:22.000000', 'temperatura', 1137.0000, 'ºC'),
	(206245, 121, '2014-02-15 00:40:23.000000', 'temperatura', 1136.0000, 'ºC'),
	(206246, 121, '2014-02-15 00:40:24.000000', 'temperatura', 1068.0000, 'ºC'),
	(206247, 121, '2014-02-15 00:40:25.000000', 'temperatura', 735.0000, 'ºC'),
	(206248, 121, '2014-02-15 00:40:26.000000', 'temperatura', 472.0000, 'ºC'),
	(206249, 121, '2014-02-15 00:40:27.000000', 'temperatura', 156.0000, 'ºC'),
	(206250, 121, '2014-02-15 00:40:28.000000', 'temperatura', 565.0000, 'ºC'),
	(206251, 121, '2014-02-15 00:40:29.000000', 'temperatura', 1158.0000, 'ºC'),
	(206252, 121, '2014-02-15 00:40:30.000000', 'temperatura', 495.0000, 'ºC'),
	(206253, 121, '2014-02-15 00:40:31.000000', 'temperatura', 202.0000, 'ºC'),
	(206254, 121, '2014-02-15 00:40:32.000000', 'temperatura', 724.0000, 'ºC'),
	(206255, 121, '2014-02-15 00:40:33.000000', 'temperatura', 614.0000, 'ºC'),
	(206256, 121, '2014-02-15 00:40:34.000000', 'temperatura', 900.0000, 'ºC'),
	(206257, 121, '2014-02-15 00:40:35.000000', 'temperatura', 259.0000, 'ºC'),
	(206258, 121, '2014-02-15 00:40:36.000000', 'temperatura', 995.0000, 'ºC'),
	(206259, 121, '2014-02-15 00:40:37.000000', 'temperatura', 596.0000, 'ºC'),
	(206260, 121, '2014-02-15 00:40:38.000000', 'temperatura', 1198.0000, 'ºC'),
	(206261, 121, '2014-02-15 00:40:39.000000', 'temperatura', 602.0000, 'ºC'),
	(206262, 121, '2014-02-15 00:40:40.000000', 'temperatura', 617.0000, 'ºC'),
	(206263, 121, '2014-02-15 00:40:41.000000', 'temperatura', 81.0000, 'ºC'),
	(206264, 121, '2014-02-15 00:40:42.000000', 'temperatura', 951.0000, 'ºC'),
	(206265, 121, '2014-02-15 00:40:43.000000', 'temperatura', 915.0000, 'ºC'),
	(206266, 121, '2014-02-15 00:40:44.000000', 'temperatura', 521.0000, 'ºC'),
	(206267, 121, '2014-02-15 00:40:45.000000', 'temperatura', 1061.0000, 'ºC'),
	(206268, 121, '2014-02-15 00:40:46.000000', 'temperatura', 141.0000, 'ºC'),
	(206269, 121, '2014-02-15 00:40:47.000000', 'temperatura', 1123.0000, 'ºC'),
	(206270, 121, '2014-02-15 00:40:48.000000', 'temperatura', 393.0000, 'ºC'),
	(206271, 121, '2014-02-15 00:40:49.000000', 'temperatura', 998.0000, 'ºC'),
	(206272, 121, '2014-02-15 00:40:50.000000', 'temperatura', 209.0000, 'ºC'),
	(206273, 121, '2014-02-15 00:40:51.000000', 'temperatura', 453.0000, 'ºC'),
	(206274, 121, '2014-02-15 00:40:52.000000', 'temperatura', 437.0000, 'ºC'),
	(206275, 121, '2014-02-15 00:40:53.000000', 'temperatura', 825.0000, 'ºC'),
	(206276, 121, '2014-02-15 00:40:54.000000', 'temperatura', 417.0000, 'ºC'),
	(206277, 121, '2014-02-15 00:40:55.000000', 'temperatura', 810.0000, 'ºC'),
	(206278, 121, '2014-02-15 00:40:56.000000', 'temperatura', 400.0000, 'ºC'),
	(206279, 121, '2014-02-15 00:40:57.000000', 'temperatura', 770.0000, 'ºC'),
	(206280, 121, '2014-02-15 00:40:58.000000', 'temperatura', 252.0000, 'ºC'),
	(206281, 121, '2014-02-15 00:40:59.000000', 'temperatura', 152.0000, 'ºC'),
	(206282, 121, '2014-02-15 00:41:00.000000', 'temperatura', 1.0000, 'ºC'),
	(206283, 121, '2014-02-15 00:41:01.000000', 'temperatura', 750.0000, 'ºC'),
	(206284, 121, '2014-02-15 00:41:02.000000', 'temperatura', 147.0000, 'ºC'),
	(206285, 121, '2014-02-15 00:41:03.000000', 'temperatura', 884.0000, 'ºC'),
	(206286, 121, '2014-02-15 00:41:04.000000', 'temperatura', 382.0000, 'ºC'),
	(206287, 121, '2014-02-15 00:41:05.000000', 'temperatura', 460.0000, 'ºC'),
	(206288, 121, '2014-02-15 00:41:06.000000', 'temperatura', 1152.0000, 'ºC'),
	(206289, 121, '2014-02-15 00:41:07.000000', 'temperatura', 783.0000, 'ºC'),
	(206290, 121, '2014-02-15 00:41:08.000000', 'temperatura', 457.0000, 'ºC'),
	(206291, 121, '2014-02-15 00:41:09.000000', 'temperatura', 1139.0000, 'ºC'),
	(206292, 121, '2014-02-15 00:41:10.000000', 'temperatura', 723.0000, 'ºC'),
	(206293, 121, '2014-02-15 00:41:11.000000', 'temperatura', 198.0000, 'ºC'),
	(206294, 121, '2014-02-15 00:41:12.000000', 'temperatura', 24.0000, 'ºC'),
	(206295, 121, '2014-02-15 00:41:13.000000', 'temperatura', 724.0000, 'ºC'),
	(206296, 121, '2014-02-15 00:41:14.000000', 'temperatura', 1151.0000, 'ºC'),
	(206297, 121, '2014-02-15 00:41:15.000000', 'temperatura', 1183.0000, 'ºC'),
	(206298, 121, '2014-02-15 00:41:16.000000', 'temperatura', 60.0000, 'ºC'),
	(206299, 121, '2014-02-15 00:41:17.000000', 'temperatura', 352.0000, 'ºC'),
	(206300, 121, '2014-02-15 00:41:18.000000', 'temperatura', 383.0000, 'ºC'),
	(206301, 121, '2014-02-15 00:41:19.000000', 'temperatura', 857.0000, 'ºC'),
	(206302, 121, '2014-02-15 00:41:20.000000', 'temperatura', 738.0000, 'ºC'),
	(206303, 121, '2014-02-15 00:41:21.000000', 'temperatura', 1118.0000, 'ºC'),
	(206304, 121, '2014-02-15 00:41:22.000000', 'temperatura', 977.0000, 'ºC'),
	(206305, 121, '2014-02-15 00:41:23.000000', 'temperatura', 333.0000, 'ºC'),
	(206306, 121, '2014-02-15 00:41:24.000000', 'temperatura', 1134.0000, 'ºC'),
	(206307, 121, '2014-02-15 00:41:25.000000', 'temperatura', 1071.0000, 'ºC'),
	(206308, 121, '2014-02-15 00:41:26.000000', 'temperatura', 756.0000, 'ºC'),
	(206309, 121, '2014-02-15 00:41:27.000000', 'temperatura', 565.0000, 'ºC'),
	(206310, 121, '2014-02-15 00:41:28.000000', 'temperatura', 556.0000, 'ºC'),
	(206311, 121, '2014-02-15 00:41:29.000000', 'temperatura', 1087.0000, 'ºC'),
	(206312, 121, '2014-02-15 00:41:30.000000', 'temperatura', 167.0000, 'ºC'),
	(206313, 121, '2014-02-15 00:41:31.000000', 'temperatura', 1173.0000, 'ºC'),
	(206314, 121, '2014-02-15 00:41:32.000000', 'temperatura', 567.0000, 'ºC'),
	(206315, 121, '2014-02-15 00:41:33.000000', 'temperatura', 516.0000, 'ºC'),
	(206316, 121, '2014-02-15 00:41:34.000000', 'temperatura', 878.0000, 'ºC'),
	(206317, 121, '2014-02-15 00:41:35.000000', 'temperatura', 442.0000, 'ºC'),
	(206318, 121, '2014-02-15 00:41:36.000000', 'temperatura', 776.0000, 'ºC'),
	(206319, 121, '2014-02-15 00:41:37.000000', 'temperatura', 155.0000, 'ºC'),
	(206320, 121, '2014-02-15 00:41:38.000000', 'temperatura', 847.0000, 'ºC'),
	(206321, 121, '2014-02-15 00:41:39.000000', 'temperatura', 171.0000, 'ºC'),
	(206322, 121, '2014-02-15 00:41:40.000000', 'temperatura', 715.0000, 'ºC'),
	(206323, 121, '2014-02-15 00:41:41.000000', 'temperatura', 660.0000, 'ºC'),
	(206324, 121, '2014-02-15 00:41:42.000000', 'temperatura', 1159.0000, 'ºC'),
	(206325, 121, '2014-02-15 00:41:43.000000', 'temperatura', 213.0000, 'ºC'),
	(206326, 121, '2014-02-15 00:41:44.000000', 'temperatura', 1190.0000, 'ºC'),
	(206327, 121, '2014-02-15 00:41:45.000000', 'temperatura', 510.0000, 'ºC'),
	(206328, 121, '2014-02-15 00:41:46.000000', 'temperatura', 183.0000, 'ºC'),
	(206329, 121, '2014-02-15 00:41:47.000000', 'temperatura', 583.0000, 'ºC'),
	(206330, 121, '2014-02-15 00:41:48.000000', 'temperatura', 1166.0000, 'ºC'),
	(206331, 121, '2014-02-15 00:41:49.000000', 'temperatura', 483.0000, 'ºC'),
	(206332, 121, '2014-02-15 00:41:50.000000', 'temperatura', 118.0000, 'ºC'),
	(206333, 121, '2014-02-15 00:41:51.000000', 'temperatura', 341.0000, 'ºC'),
	(206334, 121, '2014-02-15 00:41:52.000000', 'temperatura', 151.0000, 'ºC'),
	(206335, 121, '2014-02-15 00:41:53.000000', 'temperatura', 931.0000, 'ºC'),
	(206336, 121, '2014-02-15 00:41:54.000000', 'temperatura', 603.0000, 'ºC'),
	(206337, 121, '2014-02-15 00:41:55.000000', 'temperatura', 225.0000, 'ºC'),
	(206338, 121, '2014-02-15 00:41:56.000000', 'temperatura', 513.0000, 'ºC'),
	(206339, 121, '2014-02-15 00:41:57.000000', 'temperatura', 693.0000, 'ºC'),
	(206340, 121, '2014-02-15 00:41:58.000000', 'temperatura', 727.0000, 'ºC'),
	(206341, 121, '2014-02-15 00:41:59.000000', 'temperatura', 357.0000, 'ºC'),
	(206342, 121, '2014-02-15 00:42:00.000000', 'temperatura', 802.0000, 'ºC'),
	(206343, 121, '2014-02-15 00:42:01.000000', 'temperatura', 541.0000, 'ºC'),
	(206344, 121, '2014-02-15 00:42:02.000000', 'temperatura', 301.0000, 'ºC'),
	(206345, 121, '2014-02-15 00:42:03.000000', 'temperatura', 1080.0000, 'ºC'),
	(206346, 121, '2014-02-15 00:42:04.000000', 'temperatura', 899.0000, 'ºC'),
	(206347, 121, '2014-02-15 00:42:05.000000', 'temperatura', 55.0000, 'ºC'),
	(206348, 121, '2014-02-15 00:42:06.000000', 'temperatura', 1179.0000, 'ºC'),
	(206349, 121, '2014-02-15 00:42:07.000000', 'temperatura', 932.0000, 'ºC'),
	(206350, 121, '2014-02-15 00:42:08.000000', 'temperatura', 1120.0000, 'ºC'),
	(206351, 121, '2014-02-15 00:42:09.000000', 'temperatura', 407.0000, 'ºC'),
	(206352, 121, '2014-02-15 00:42:10.000000', 'temperatura', 1077.0000, 'ºC'),
	(206353, 121, '2014-02-15 00:42:11.000000', 'temperatura', 562.0000, 'ºC'),
	(206354, 121, '2014-02-15 00:42:12.000000', 'temperatura', 782.0000, 'ºC'),
	(206355, 121, '2014-02-15 00:42:13.000000', 'temperatura', 1024.0000, 'ºC'),
	(206356, 121, '2014-02-15 00:42:14.000000', 'temperatura', 373.0000, 'ºC'),
	(206357, 121, '2014-02-15 00:42:15.000000', 'temperatura', 1195.0000, 'ºC'),
	(206358, 121, '2014-02-15 00:42:16.000000', 'temperatura', 57.0000, 'ºC'),
	(206359, 121, '2014-02-15 00:42:17.000000', 'temperatura', 299.0000, 'ºC'),
	(206360, 121, '2014-02-15 00:42:18.000000', 'temperatura', 125.0000, 'ºC'),
	(206361, 121, '2014-02-15 00:42:19.000000', 'temperatura', 928.0000, 'ºC'),
	(206362, 121, '2014-02-15 00:42:20.000000', 'temperatura', 668.0000, 'ºC'),
	(206363, 121, '2014-02-15 00:42:21.000000', 'temperatura', 554.0000, 'ºC'),
	(206364, 121, '2014-02-15 00:42:22.000000', 'temperatura', 766.0000, 'ºC'),
	(206365, 121, '2014-02-15 00:42:23.000000', 'temperatura', 971.0000, 'ºC'),
	(206366, 121, '2014-02-15 00:42:24.000000', 'temperatura', 156.0000, 'ºC'),
	(206367, 121, '2014-02-15 00:42:25.000000', 'temperatura', 269.0000, 'ºC'),
	(206368, 121, '2014-02-15 00:42:26.000000', 'temperatura', 875.0000, 'ºC'),
	(206369, 121, '2014-02-15 00:42:27.000000', 'temperatura', 1169.0000, 'ºC'),
	(206370, 121, '2014-02-15 00:42:28.000000', 'temperatura', 822.0000, 'ºC'),
	(206371, 121, '2014-02-15 00:42:29.000000', 'temperatura', 603.0000, 'ºC'),
	(206372, 121, '2014-02-15 00:42:30.000000', 'temperatura', 548.0000, 'ºC'),
	(206373, 121, '2014-02-15 00:42:31.000000', 'temperatura', 931.0000, 'ºC'),
	(206374, 121, '2014-02-15 00:42:32.000000', 'temperatura', 614.0000, 'ºC'),
	(206375, 121, '2014-02-15 00:42:33.000000', 'temperatura', 275.0000, 'ºC'),
	(206376, 121, '2014-02-15 00:42:34.000000', 'temperatura', 734.0000, 'ºC'),
	(206377, 121, '2014-02-15 00:42:35.000000', 'temperatura', 447.0000, 'ºC'),
	(206378, 121, '2014-02-15 00:42:36.000000', 'temperatura', 33.0000, 'ºC'),
	(206379, 121, '2014-02-15 00:42:37.000000', 'temperatura', 25.0000, 'ºC'),
	(206380, 121, '2014-02-15 00:42:38.000000', 'temperatura', 28.0000, 'ºC'),
	(206381, 121, '2014-02-15 00:42:39.000000', 'temperatura', 64.0000, 'ºC'),
	(206382, 121, '2014-02-15 00:42:40.000000', 'temperatura', 235.0000, 'ºC'),
	(206383, 121, '2014-02-15 00:42:41.000000', 'temperatura', 986.0000, 'ºC'),
	(206384, 121, '2014-02-15 00:42:42.000000', 'temperatura', 625.0000, 'ºC'),
	(206385, 121, '2014-02-15 00:42:43.000000', 'temperatura', 166.0000, 'ºC'),
	(206386, 121, '2014-02-15 00:42:44.000000', 'temperatura', 158.0000, 'ºC'),
	(206387, 121, '2014-02-15 00:42:45.000000', 'temperatura', 292.0000, 'ºC'),
	(206388, 121, '2014-02-15 00:42:46.000000', 'temperatura', 987.0000, 'ºC'),
	(206389, 121, '2014-02-15 00:42:47.000000', 'temperatura', 458.0000, 'ºC'),
	(206390, 121, '2014-02-15 00:42:48.000000', 'temperatura', 528.0000, 'ºC'),
	(206391, 121, '2014-02-15 00:42:49.000000', 'temperatura', 70.0000, 'ºC'),
	(206392, 121, '2014-02-15 00:42:50.000000', 'temperatura', 1165.0000, 'ºC'),
	(206393, 121, '2014-02-15 00:42:51.000000', 'temperatura', 817.0000, 'ºC'),
	(206394, 121, '2014-02-15 00:42:52.000000', 'temperatura', 591.0000, 'ºC'),
	(206395, 121, '2014-02-15 00:42:53.000000', 'temperatura', 504.0000, 'ºC'),
	(206396, 121, '2014-02-15 00:42:54.000000', 'temperatura', 748.0000, 'ºC'),
	(206397, 121, '2014-02-15 00:42:55.000000', 'temperatura', 1026.0000, 'ºC'),
	(206398, 121, '2014-02-15 00:42:56.000000', 'temperatura', 490.0000, 'ºC'),
	(206399, 121, '2014-02-15 00:42:57.000000', 'temperatura', 569.0000, 'ºC'),
	(206400, 121, '2014-02-15 00:42:58.000000', 'temperatura', 178.0000, 'ºC'),
	(206401, 121, '2014-02-15 00:42:59.000000', 'temperatura', 384.0000, 'ºC'),
	(206402, 121, '2014-02-15 00:43:00.000000', 'temperatura', 185.0000, 'ºC'),
	(206403, 121, '2014-02-15 00:43:01.000000', 'temperatura', 975.0000, 'ºC'),
	(206404, 121, '2014-02-15 00:43:02.000000', 'temperatura', 720.0000, 'ºC'),
	(206405, 121, '2014-02-15 00:43:03.000000', 'temperatura', 674.0000, 'ºC'),
	(206406, 121, '2014-02-15 00:43:04.000000', 'temperatura', 11.0000, 'ºC'),
	(206407, 121, '2014-02-15 00:43:05.000000', 'temperatura', 433.0000, 'ºC'),
	(206408, 121, '2014-02-15 00:43:06.000000', 'temperatura', 931.0000, 'ºC'),
	(206409, 121, '2014-02-15 00:43:07.000000', 'temperatura', 958.0000, 'ºC'),
	(206410, 121, '2014-02-15 00:43:08.000000', 'temperatura', 799.0000, 'ºC'),
	(206411, 121, '2014-02-15 00:43:09.000000', 'temperatura', 1119.0000, 'ºC'),
	(206412, 121, '2014-02-15 00:43:10.000000', 'temperatura', 799.0000, 'ºC'),
	(206413, 121, '2014-02-15 00:43:11.000000', 'temperatura', 637.0000, 'ºC'),
	(206414, 121, '2014-02-15 00:43:12.000000', 'temperatura', 789.0000, 'ºC'),
	(206415, 121, '2014-02-15 00:43:13.000000', 'temperatura', 835.0000, 'ºC'),
	(206416, 121, '2014-02-15 00:43:14.000000', 'temperatura', 609.0000, 'ºC'),
	(206417, 121, '2014-02-15 00:43:15.000000', 'temperatura', 539.0000, 'ºC'),
	(206418, 121, '2014-02-15 00:43:16.000000', 'temperatura', 870.0000, 'ºC'),
	(206419, 121, '2014-02-15 00:43:17.000000', 'temperatura', 331.0000, 'ºC'),
	(206420, 121, '2014-02-15 00:43:18.000000', 'temperatura', 247.0000, 'ºC'),
	(206421, 121, '2014-02-15 00:43:19.000000', 'temperatura', 243.0000, 'ºC'),
	(206422, 121, '2014-02-15 00:43:20.000000', 'temperatura', 473.0000, 'ºC'),
	(206423, 121, '2014-02-15 00:43:21.000000', 'temperatura', 437.0000, 'ºC'),
	(206424, 121, '2014-02-15 00:43:22.000000', 'temperatura', 768.0000, 'ºC'),
	(206425, 121, '2014-02-15 00:43:23.000000', 'temperatura', 129.0000, 'ºC'),
	(206426, 121, '2014-02-15 00:43:24.000000', 'temperatura', 740.0000, 'ºC'),
	(206427, 121, '2014-02-15 00:43:25.000000', 'temperatura', 916.0000, 'ºC'),
	(206428, 121, '2014-02-15 00:43:26.000000', 'temperatura', 1161.0000, 'ºC'),
	(206429, 121, '2014-02-15 00:43:27.000000', 'temperatura', 658.0000, 'ºC'),
	(206430, 121, '2014-02-15 00:43:28.000000', 'temperatura', 1006.0000, 'ºC'),
	(206431, 121, '2014-02-15 00:43:29.000000', 'temperatura', 658.0000, 'ºC'),
	(206432, 121, '2014-02-15 00:43:30.000000', 'temperatura', 270.0000, 'ºC'),
	(206433, 121, '2014-02-15 00:43:31.000000', 'temperatura', 577.0000, 'ºC'),
	(206434, 121, '2014-02-15 00:43:32.000000', 'temperatura', 875.0000, 'ºC'),
	(206435, 121, '2014-02-15 00:43:33.000000', 'temperatura', 244.0000, 'ºC'),
	(206436, 121, '2014-02-15 00:43:34.000000', 'temperatura', 995.0000, 'ºC'),
	(206437, 121, '2014-02-15 00:43:35.000000', 'temperatura', 646.0000, 'ºC'),
	(206438, 121, '2014-02-15 00:43:36.000000', 'temperatura', 242.0000, 'ºC'),
	(206439, 121, '2014-02-15 00:43:37.000000', 'temperatura', 476.0000, 'ºC'),
	(206440, 121, '2014-02-15 00:43:38.000000', 'temperatura', 451.0000, 'ºC'),
	(206441, 121, '2014-02-15 00:43:39.000000', 'temperatura', 830.0000, 'ºC'),
	(206442, 121, '2014-02-15 00:43:40.000000', 'temperatura', 398.0000, 'ºC'),
	(206443, 121, '2014-02-15 00:43:41.000000', 'temperatura', 698.0000, 'ºC'),
	(206444, 121, '2014-02-15 00:43:42.000000', 'temperatura', 1098.0000, 'ºC'),
	(206445, 121, '2014-02-15 00:43:43.000000', 'temperatura', 996.0000, 'ºC'),
	(206446, 121, '2014-02-15 00:43:44.000000', 'temperatura', 485.0000, 'ºC'),
	(206447, 121, '2014-02-15 00:43:45.000000', 'temperatura', 637.0000, 'ºC'),
	(206448, 121, '2014-02-15 00:43:46.000000', 'temperatura', 531.0000, 'ºC'),
	(206449, 121, '2014-02-15 00:43:47.000000', 'temperatura', 745.0000, 'ºC'),
	(206450, 121, '2014-02-15 00:43:48.000000', 'temperatura', 934.0000, 'ºC'),
	(206451, 121, '2014-02-15 00:43:49.000000', 'temperatura', 34.0000, 'ºC'),
	(206452, 121, '2014-02-15 00:43:50.000000', 'temperatura', 971.0000, 'ºC'),
	(206453, 121, '2014-02-15 00:43:51.000000', 'temperatura', 1152.0000, 'ºC'),
	(206454, 121, '2014-02-15 00:43:52.000000', 'temperatura', 446.0000, 'ºC'),
	(206455, 121, '2014-02-15 00:43:53.000000', 'temperatura', 1175.0000, 'ºC'),
	(206456, 121, '2014-02-15 00:43:54.000000', 'temperatura', 936.0000, 'ºC'),
	(206457, 121, '2014-02-15 00:43:55.000000', 'temperatura', 1158.0000, 'ºC'),
	(206458, 121, '2014-02-15 00:43:56.000000', 'temperatura', 580.0000, 'ºC'),
	(206459, 121, '2014-02-15 00:43:57.000000', 'temperatura', 628.0000, 'ºC'),
	(206460, 121, '2014-02-15 00:43:58.000000', 'temperatura', 201.0000, 'ºC'),
	(206461, 121, '2014-02-15 00:43:59.000000', 'temperatura', 322.0000, 'ºC'),
	(206462, 121, '2014-02-15 00:44:00.000000', 'temperatura', 1005.0000, 'ºC'),
	(206463, 121, '2014-02-15 00:44:01.000000', 'temperatura', 461.0000, 'ºC'),
	(206464, 121, '2014-02-15 00:44:02.000000', 'temperatura', 491.0000, 'ºC'),
	(206465, 121, '2014-02-15 00:44:03.000000', 'temperatura', 1070.0000, 'ºC'),
	(206466, 121, '2014-02-15 00:44:04.000000', 'temperatura', 279.0000, 'ºC'),
	(206467, 121, '2014-02-15 00:44:05.000000', 'temperatura', 587.0000, 'ºC'),
	(206468, 121, '2014-02-15 00:44:06.000000', 'temperatura', 896.0000, 'ºC'),
	(206469, 121, '2014-02-15 00:44:07.000000', 'temperatura', 322.0000, 'ºC'),
	(206470, 121, '2014-02-15 00:44:08.000000', 'temperatura', 121.0000, 'ºC'),
	(206471, 121, '2014-02-15 00:44:09.000000', 'temperatura', 838.0000, 'ºC'),
	(206472, 121, '2014-02-15 00:44:10.000000', 'temperatura', 227.0000, 'ºC'),
	(206473, 121, '2014-02-15 00:44:11.000000', 'temperatura', 1025.0000, 'ºC'),
	(206474, 121, '2014-02-15 00:44:12.000000', 'temperatura', 841.0000, 'ºC'),
	(206475, 121, '2014-02-15 00:44:13.000000', 'temperatura', 1132.0000, 'ºC'),
	(206476, 121, '2014-02-15 00:44:14.000000', 'temperatura', 737.0000, 'ºC'),
	(206477, 121, '2014-02-15 00:44:15.000000', 'temperatura', 289.0000, 'ºC'),
	(206478, 121, '2014-02-15 00:44:16.000000', 'temperatura', 435.0000, 'ºC'),
	(206479, 121, '2014-02-15 00:44:17.000000', 'temperatura', 108.0000, 'ºC'),
	(206480, 121, '2014-02-15 00:44:18.000000', 'temperatura', 438.0000, 'ºC'),
	(206481, 121, '2014-02-15 00:44:19.000000', 'temperatura', 665.0000, 'ºC'),
	(206482, 121, '2014-02-15 00:44:20.000000', 'temperatura', 811.0000, 'ºC'),
	(206483, 121, '2014-02-15 00:44:21.000000', 'temperatura', 860.0000, 'ºC'),
	(206484, 121, '2014-02-15 00:44:22.000000', 'temperatura', 668.0000, 'ºC'),
	(206485, 121, '2014-02-15 00:44:23.000000', 'temperatura', 761.0000, 'ºC'),
	(206486, 121, '2014-02-15 00:44:24.000000', 'temperatura', 601.0000, 'ºC'),
	(206487, 121, '2014-02-15 00:44:25.000000', 'temperatura', 723.0000, 'ºC'),
	(206488, 121, '2014-02-15 00:44:26.000000', 'temperatura', 613.0000, 'ºC'),
	(206489, 121, '2014-02-15 00:44:27.000000', 'temperatura', 898.0000, 'ºC'),
	(206490, 121, '2014-02-15 00:44:28.000000', 'temperatura', 250.0000, 'ºC'),
	(206491, 121, '2014-02-15 00:44:29.000000', 'temperatura', 957.0000, 'ºC'),
	(206492, 121, '2014-02-15 00:44:30.000000', 'temperatura', 435.0000, 'ºC'),
	(206493, 121, '2014-02-15 00:44:31.000000', 'temperatura', 505.0000, 'ºC'),
	(206494, 121, '2014-02-15 00:44:32.000000', 'temperatura', 19.0000, 'ºC'),
	(206495, 121, '2014-02-15 00:44:33.000000', 'temperatura', 982.0000, 'ºC'),
	(206496, 121, '2014-02-15 00:44:34.000000', 'temperatura', 51.0000, 'ºC'),
	(206497, 121, '2014-02-15 00:44:35.000000', 'temperatura', 911.0000, 'ºC'),
	(206498, 121, '2014-02-15 00:44:36.000000', 'temperatura', 801.0000, 'ºC'),
	(206499, 121, '2014-02-15 00:44:37.000000', 'temperatura', 71.0000, 'ºC'),
	(206500, 121, '2014-02-15 00:44:38.000000', 'temperatura', 356.0000, 'ºC'),
	(206501, 121, '2014-02-15 00:44:39.000000', 'temperatura', 366.0000, 'ºC'),
	(206502, 121, '2014-02-15 00:44:40.000000', 'temperatura', 761.0000, 'ºC'),
	(206503, 121, '2014-02-15 00:44:41.000000', 'temperatura', 310.0000, 'ºC'),
	(206504, 121, '2014-02-15 00:44:42.000000', 'temperatura', 467.0000, 'ºC'),
	(206505, 121, '2014-02-15 00:44:43.000000', 'temperatura', 204.0000, 'ºC'),
	(206506, 121, '2014-02-15 00:44:44.000000', 'temperatura', 819.0000, 'ºC'),
	(206507, 121, '2014-02-15 00:44:45.000000', 'temperatura', 1082.0000, 'ºC'),
	(206508, 121, '2014-02-15 00:44:46.000000', 'temperatura', 557.0000, 'ºC'),
	(206509, 121, '2014-02-15 00:44:47.000000', 'temperatura', 736.0000, 'ºC'),
	(206510, 121, '2014-02-15 00:44:48.000000', 'temperatura', 812.0000, 'ºC'),
	(206511, 121, '2014-02-15 00:44:49.000000', 'temperatura', 650.0000, 'ºC'),
	(206512, 121, '2014-02-15 00:44:50.000000', 'temperatura', 815.0000, 'ºC'),
	(206513, 121, '2014-02-15 00:44:51.000000', 'temperatura', 926.0000, 'ºC'),
	(206514, 121, '2014-02-15 00:44:52.000000', 'temperatura', 986.0000, 'ºC'),
	(206515, 121, '2014-02-15 00:44:53.000000', 'temperatura', 950.0000, 'ºC'),
	(206516, 121, '2014-02-15 00:44:54.000000', 'temperatura', 595.0000, 'ºC'),
	(206517, 121, '2014-02-15 00:44:55.000000', 'temperatura', 123.0000, 'ºC'),
	(206518, 121, '2014-02-15 00:44:56.000000', 'temperatura', 31.0000, 'ºC'),
	(206519, 121, '2014-02-15 00:44:57.000000', 'temperatura', 985.0000, 'ºC'),
	(206520, 121, '2014-02-15 00:44:58.000000', 'temperatura', 34.0000, 'ºC'),
	(206521, 121, '2014-02-15 00:44:59.000000', 'temperatura', 814.0000, 'ºC'),
	(206522, 121, '2014-02-15 00:45:00.000000', 'temperatura', 368.0000, 'ºC'),
	(206523, 121, '2014-02-15 00:45:01.000000', 'temperatura', 601.0000, 'ºC'),
	(206524, 121, '2014-02-15 00:45:02.000000', 'temperatura', 699.0000, 'ºC'),
	(206525, 121, '2014-02-15 00:45:03.000000', 'temperatura', 493.0000, 'ºC'),
	(206526, 121, '2014-02-15 00:45:04.000000', 'temperatura', 370.0000, 'ºC'),
	(206527, 121, '2014-02-15 00:45:05.000000', 'temperatura', 371.0000, 'ºC'),
	(206528, 121, '2014-02-15 00:45:06.000000', 'temperatura', 745.0000, 'ºC'),
	(206529, 121, '2014-02-15 00:45:07.000000', 'temperatura', 212.0000, 'ºC'),
	(206530, 121, '2014-02-15 00:45:08.000000', 'temperatura', 27.0000, 'ºC'),
	(206531, 121, '2014-02-15 00:45:09.000000', 'temperatura', 697.0000, 'ºC'),
	(206532, 121, '2014-02-15 00:45:10.000000', 'temperatura', 1005.0000, 'ºC'),
	(206533, 121, '2014-02-15 00:45:11.000000', 'temperatura', 533.0000, 'ºC'),
	(206534, 121, '2014-02-15 00:45:12.000000', 'temperatura', 854.0000, 'ºC'),
	(206535, 121, '2014-02-15 00:45:13.000000', 'temperatura', 270.0000, 'ºC'),
	(206536, 121, '2014-02-15 00:45:14.000000', 'temperatura', 1187.0000, 'ºC'),
	(206537, 121, '2014-02-15 00:45:15.000000', 'temperatura', 326.0000, 'ºC'),
	(206538, 121, '2014-02-15 00:45:16.000000', 'temperatura', 472.0000, 'ºC'),
	(206539, 121, '2014-02-15 00:45:17.000000', 'temperatura', 180.0000, 'ºC'),
	(206540, 121, '2014-02-15 00:45:18.000000', 'temperatura', 686.0000, 'ºC'),
	(206541, 121, '2014-02-15 00:45:19.000000', 'temperatura', 488.0000, 'ºC'),
	(206542, 121, '2014-02-15 00:45:20.000000', 'temperatura', 385.0000, 'ºC'),
	(206543, 121, '2014-02-15 00:45:21.000000', 'temperatura', 461.0000, 'ºC'),
	(206544, 121, '2014-02-15 00:45:22.000000', 'temperatura', 1149.0000, 'ºC'),
	(206545, 121, '2014-02-15 00:45:23.000000', 'temperatura', 763.0000, 'ºC'),
	(206546, 121, '2014-02-15 00:45:24.000000', 'temperatura', 370.0000, 'ºC'),
	(206547, 121, '2014-02-15 00:45:25.000000', 'temperatura', 759.0000, 'ºC'),
	(206548, 121, '2014-02-15 00:45:26.000000', 'temperatura', 285.0000, 'ºC'),
	(206549, 121, '2014-02-15 00:45:27.000000', 'temperatura', 349.0000, 'ºC'),
	(206550, 121, '2014-02-15 00:45:28.000000', 'temperatura', 892.0000, 'ºC'),
	(206551, 121, '2014-02-15 00:45:29.000000', 'temperatura', 1014.0000, 'ºC'),
	(206552, 121, '2014-02-15 00:45:30.000000', 'temperatura', 1193.0000, 'ºC'),
	(206553, 121, '2014-02-15 00:45:31.000000', 'temperatura', 525.0000, 'ºC'),
	(206554, 121, '2014-02-15 00:45:32.000000', 'temperatura', 244.0000, 'ºC'),
	(206555, 121, '2014-02-15 00:45:33.000000', 'temperatura', 848.0000, 'ºC'),
	(206556, 121, '2014-02-15 00:45:34.000000', 'temperatura', 1110.0000, 'ºC'),
	(206557, 121, '2014-02-15 00:45:35.000000', 'temperatura', 603.0000, 'ºC'),
	(206558, 121, '2014-02-15 00:45:36.000000', 'temperatura', 888.0000, 'ºC'),
	(206559, 121, '2014-02-15 00:45:37.000000', 'temperatura', 231.0000, 'ºC'),
	(206560, 121, '2014-02-15 00:45:38.000000', 'temperatura', 892.0000, 'ºC'),
	(206561, 121, '2014-02-15 00:45:39.000000', 'temperatura', 169.0000, 'ºC'),
	(206562, 121, '2014-02-15 00:45:40.000000', 'temperatura', 567.0000, 'ºC'),
	(206563, 121, '2014-02-15 00:45:41.000000', 'temperatura', 1130.0000, 'ºC'),
	(206564, 121, '2014-02-15 00:45:42.000000', 'temperatura', 348.0000, 'ºC'),
	(206565, 121, '2014-02-15 00:45:43.000000', 'temperatura', 749.0000, 'ºC'),
	(206566, 121, '2014-02-15 00:45:44.000000', 'temperatura', 304.0000, 'ºC'),
	(206567, 121, '2014-02-15 00:45:45.000000', 'temperatura', 473.0000, 'ºC'),
	(206568, 121, '2014-02-15 00:45:46.000000', 'temperatura', 252.0000, 'ºC'),
	(206569, 121, '2014-02-15 00:45:47.000000', 'temperatura', 1040.0000, 'ºC'),
	(206570, 121, '2014-02-15 00:45:48.000000', 'temperatura', 848.0000, 'ºC'),
	(206571, 121, '2014-02-15 00:45:49.000000', 'temperatura', 1119.0000, 'ºC'),
	(206572, 121, '2014-02-15 00:45:50.000000', 'temperatura', 651.0000, 'ºC'),
	(206573, 121, '2014-02-15 00:45:51.000000', 'temperatura', 1100.0000, 'ºC'),
	(206574, 121, '2014-02-15 00:45:52.000000', 'temperatura', 1147.0000, 'ºC'),
	(206575, 121, '2014-02-15 00:45:53.000000', 'temperatura', 36.0000, 'ºC'),
	(206576, 121, '2014-02-15 00:45:54.000000', 'temperatura', 337.0000, 'ºC'),
	(206577, 121, '2014-02-15 00:45:55.000000', 'temperatura', 379.0000, 'ºC'),
	(206578, 121, '2014-02-15 00:45:56.000000', 'temperatura', 886.0000, 'ºC'),
	(206579, 121, '2014-02-15 00:45:57.000000', 'temperatura', 894.0000, 'ºC'),
	(206580, 121, '2014-02-15 00:45:58.000000', 'temperatura', 610.0000, 'ºC'),
	(206581, 121, '2014-02-15 00:45:59.000000', 'temperatura', 369.0000, 'ºC'),
	(206582, 121, '2014-02-15 00:46:00.000000', 'temperatura', 15.0000, 'ºC'),
	(206583, 121, '2014-02-15 00:46:01.000000', 'temperatura', 171.0000, 'ºC'),
	(206584, 121, '2014-02-15 00:46:02.000000', 'temperatura', 808.0000, 'ºC'),
	(206585, 121, '2014-02-15 00:46:03.000000', 'temperatura', 1130.0000, 'ºC'),
	(206586, 121, '2014-02-15 00:46:04.000000', 'temperatura', 823.0000, 'ºC'),
	(206587, 121, '2014-02-15 00:46:05.000000', 'temperatura', 729.0000, 'ºC'),
	(206588, 121, '2014-02-15 00:46:06.000000', 'temperatura', 1173.0000, 'ºC'),
	(206589, 121, '2014-02-15 00:46:07.000000', 'temperatura', 80.0000, 'ºC'),
	(206590, 121, '2014-02-15 00:46:08.000000', 'temperatura', 482.0000, 'ºC'),
	(206591, 121, '2014-02-15 00:46:09.000000', 'temperatura', 972.0000, 'ºC'),
	(206592, 121, '2014-02-15 00:46:10.000000', 'temperatura', 1014.0000, 'ºC'),
	(206593, 121, '2014-02-15 00:46:11.000000', 'temperatura', 954.0000, 'ºC'),
	(206594, 121, '2014-02-15 00:46:12.000000', 'temperatura', 528.0000, 'ºC'),
	(206595, 121, '2014-02-15 00:46:13.000000', 'temperatura', 981.0000, 'ºC'),
	(206596, 121, '2014-02-15 00:46:14.000000', 'temperatura', 918.0000, 'ºC'),
	(206597, 121, '2014-02-15 00:46:15.000000', 'temperatura', 450.0000, 'ºC'),
	(206598, 121, '2014-02-15 00:46:16.000000', 'temperatura', 694.0000, 'ºC'),
	(206599, 121, '2014-02-15 00:46:17.000000', 'temperatura', 921.0000, 'ºC'),
	(206600, 121, '2014-02-15 00:46:18.000000', 'temperatura', 124.0000, 'ºC'),
	(206601, 121, '2014-02-15 00:46:19.000000', 'temperatura', 256.0000, 'ºC'),
	(206602, 121, '2014-02-15 00:46:20.000000', 'temperatura', 907.0000, 'ºC'),
	(206603, 121, '2014-02-15 00:46:21.000000', 'temperatura', 171.0000, 'ºC'),
	(206604, 121, '2014-02-15 00:46:22.000000', 'temperatura', 534.0000, 'ºC'),
	(206605, 121, '2014-02-15 00:46:23.000000', 'temperatura', 958.0000, 'ºC'),
	(206606, 121, '2014-02-15 00:46:24.000000', 'temperatura', 789.0000, 'ºC'),
	(206607, 121, '2014-02-15 00:46:25.000000', 'temperatura', 1071.0000, 'ºC'),
	(206608, 121, '2014-02-15 00:46:26.000000', 'temperatura', 589.0000, 'ºC'),
	(206609, 121, '2014-02-15 00:46:27.000000', 'temperatura', 932.0000, 'ºC'),
	(206610, 121, '2014-02-15 00:46:28.000000', 'temperatura', 492.0000, 'ºC'),
	(206611, 121, '2014-02-15 00:46:29.000000', 'temperatura', 865.0000, 'ºC'),
	(206612, 121, '2014-02-15 00:46:30.000000', 'temperatura', 449.0000, 'ºC'),
	(206613, 121, '2014-02-15 00:46:31.000000', 'temperatura', 849.0000, 'ºC'),
	(206614, 121, '2014-02-15 00:46:32.000000', 'temperatura', 502.0000, 'ºC'),
	(206615, 121, '2014-02-15 00:46:33.000000', 'temperatura', 1163.0000, 'ºC'),
	(206616, 121, '2014-02-15 00:46:34.000000', 'temperatura', 707.0000, 'ºC'),
	(206617, 121, '2014-02-15 00:46:35.000000', 'temperatura', 47.0000, 'ºC'),
	(206618, 121, '2014-02-15 00:46:36.000000', 'temperatura', 516.0000, 'ºC'),
	(206619, 121, '2014-02-15 00:46:37.000000', 'temperatura', 39.0000, 'ºC'),
	(206620, 121, '2014-02-15 00:46:38.000000', 'temperatura', 1047.0000, 'ºC'),
	(206621, 121, '2014-02-15 00:46:39.000000', 'temperatura', 320.0000, 'ºC'),
	(206622, 121, '2014-02-15 00:46:40.000000', 'temperatura', 858.0000, 'ºC'),
	(206623, 121, '2014-02-15 00:46:41.000000', 'temperatura', 930.0000, 'ºC'),
	(206624, 121, '2014-02-15 00:46:42.000000', 'temperatura', 878.0000, 'ºC'),
	(206625, 121, '2014-02-15 00:46:43.000000', 'temperatura', 398.0000, 'ºC'),
	(206626, 121, '2014-02-15 00:46:44.000000', 'temperatura', 557.0000, 'ºC'),
	(206627, 121, '2014-02-15 00:46:45.000000', 'temperatura', 393.0000, 'ºC'),
	(206628, 121, '2014-02-15 00:46:46.000000', 'temperatura', 293.0000, 'ºC'),
	(206629, 121, '2014-02-15 00:46:47.000000', 'temperatura', 286.0000, 'ºC'),
	(206630, 121, '2014-02-15 00:46:48.000000', 'temperatura', 550.0000, 'ºC'),
	(206631, 121, '2014-02-15 00:46:49.000000', 'temperatura', 695.0000, 'ºC'),
	(206632, 121, '2014-02-15 00:46:50.000000', 'temperatura', 626.0000, 'ºC'),
	(206633, 121, '2014-02-15 00:46:51.000000', 'temperatura', 1044.0000, 'ºC'),
	(206634, 121, '2014-02-15 00:46:52.000000', 'temperatura', 941.0000, 'ºC'),
	(206635, 121, '2014-02-15 00:46:53.000000', 'temperatura', 375.0000, 'ºC'),
	(206636, 121, '2014-02-15 00:46:54.000000', 'temperatura', 252.0000, 'ºC'),
	(206637, 121, '2014-02-15 00:46:55.000000', 'temperatura', 136.0000, 'ºC'),
	(206638, 121, '2014-02-15 00:46:56.000000', 'temperatura', 1125.0000, 'ºC'),
	(206639, 121, '2014-02-15 00:46:57.000000', 'temperatura', 416.0000, 'ºC'),
	(206640, 121, '2014-02-15 00:46:58.000000', 'temperatura', 1107.0000, 'ºC'),
	(206641, 121, '2014-02-15 00:46:59.000000', 'temperatura', 687.0000, 'ºC'),
	(206642, 121, '2014-02-15 00:47:00.000000', 'temperatura', 114.0000, 'ºC'),
	(206643, 121, '2014-02-15 00:47:01.000000', 'temperatura', 911.0000, 'ºC'),
	(206644, 121, '2014-02-15 00:47:02.000000', 'temperatura', 612.0000, 'ºC'),
	(206645, 121, '2014-02-15 00:47:03.000000', 'temperatura', 328.0000, 'ºC'),
	(206646, 121, '2014-02-15 00:47:04.000000', 'temperatura', 1005.0000, 'ºC'),
	(206647, 121, '2014-02-15 00:47:05.000000', 'temperatura', 439.0000, 'ºC'),
	(206648, 121, '2014-02-15 00:47:06.000000', 'temperatura', 383.0000, 'ºC'),
	(206649, 121, '2014-02-15 00:47:07.000000', 'temperatura', 597.0000, 'ºC'),
	(206650, 121, '2014-02-15 00:47:08.000000', 'temperatura', 635.0000, 'ºC'),
	(206651, 121, '2014-02-15 00:47:09.000000', 'temperatura', 188.0000, 'ºC'),
	(206652, 121, '2014-02-15 00:47:10.000000', 'temperatura', 233.0000, 'ºC'),
	(206653, 121, '2014-02-15 00:47:11.000000', 'temperatura', 601.0000, 'ºC'),
	(206654, 121, '2014-02-15 00:47:12.000000', 'temperatura', 1108.0000, 'ºC'),
	(206655, 121, '2014-02-15 00:47:13.000000', 'temperatura', 138.0000, 'ºC'),
	(206656, 121, '2014-02-15 00:47:14.000000', 'temperatura', 965.0000, 'ºC'),
	(206657, 121, '2014-02-15 00:47:15.000000', 'temperatura', 813.0000, 'ºC'),
	(206658, 121, '2014-02-15 00:47:16.000000', 'temperatura', 1171.0000, 'ºC'),
	(206659, 121, '2014-02-15 00:47:17.000000', 'temperatura', 1018.0000, 'ºC'),
	(206660, 121, '2014-02-15 00:47:18.000000', 'temperatura', 374.0000, 'ºC'),
	(206661, 121, '2014-02-15 00:47:19.000000', 'temperatura', 18.0000, 'ºC'),
	(206662, 121, '2014-02-15 00:47:20.000000', 'temperatura', 168.0000, 'ºC'),
	(206663, 121, '2014-02-15 00:47:21.000000', 'temperatura', 788.0000, 'ºC'),
	(206664, 121, '2014-02-15 00:47:22.000000', 'temperatura', 1034.0000, 'ºC'),
	(206665, 121, '2014-02-15 00:47:23.000000', 'temperatura', 410.0000, 'ºC'),
	(206666, 121, '2014-02-15 00:47:24.000000', 'temperatura', 146.0000, 'ºC'),
	(206667, 121, '2014-02-15 00:47:25.000000', 'temperatura', 700.0000, 'ºC'),
	(206668, 121, '2014-02-15 00:47:26.000000', 'temperatura', 665.0000, 'ºC'),
	(206669, 121, '2014-02-15 00:47:27.000000', 'temperatura', 25.0000, 'ºC'),
	(206670, 121, '2014-02-15 00:47:28.000000', 'temperatura', 530.0000, 'ºC'),
	(206671, 121, '2014-02-15 00:47:29.000000', 'temperatura', 175.0000, 'ºC'),
	(206672, 121, '2014-02-15 00:47:30.000000', 'temperatura', 485.0000, 'ºC'),
	(206673, 121, '2014-02-15 00:47:31.000000', 'temperatura', 699.0000, 'ºC'),
	(206674, 121, '2014-02-15 00:47:32.000000', 'temperatura', 842.0000, 'ºC'),
	(206675, 121, '2014-02-15 00:47:33.000000', 'temperatura', 915.0000, 'ºC'),
	(206676, 121, '2014-02-15 00:47:34.000000', 'temperatura', 848.0000, 'ºC'),
	(206677, 121, '2014-02-15 00:47:35.000000', 'temperatura', 294.0000, 'ºC'),
	(206678, 121, '2014-02-15 00:47:36.000000', 'temperatura', 129.0000, 'ºC'),
	(206679, 121, '2014-02-15 00:47:37.000000', 'temperatura', 962.0000, 'ºC'),
	(206680, 121, '2014-02-15 00:47:38.000000', 'temperatura', 823.0000, 'ºC'),
	(206681, 121, '2014-02-15 00:47:39.000000', 'temperatura', 28.0000, 'ºC'),
	(206682, 121, '2014-02-15 00:47:40.000000', 'temperatura', 75.0000, 'ºC'),
	(206683, 121, '2014-02-15 00:47:41.000000', 'temperatura', 290.0000, 'ºC'),
	(206684, 121, '2014-02-15 00:47:42.000000', 'temperatura', 27.0000, 'ºC'),
	(206685, 121, '2014-02-15 00:47:43.000000', 'temperatura', 466.0000, 'ºC'),
	(206686, 121, '2014-02-15 00:47:44.000000', 'temperatura', 1049.0000, 'ºC'),
	(206687, 121, '2014-02-15 00:47:45.000000', 'temperatura', 246.0000, 'ºC'),
	(206688, 121, '2014-02-15 00:47:46.000000', 'temperatura', 483.0000, 'ºC'),
	(206689, 121, '2014-02-15 00:47:47.000000', 'temperatura', 478.0000, 'ºC'),
	(206690, 121, '2014-02-15 00:47:48.000000', 'temperatura', 941.0000, 'ºC'),
	(206691, 121, '2014-02-15 00:47:49.000000', 'temperatura', 871.0000, 'ºC'),
	(206692, 121, '2014-02-15 00:47:50.000000', 'temperatura', 333.0000, 'ºC'),
	(206693, 121, '2014-02-15 00:47:51.000000', 'temperatura', 251.0000, 'ºC'),
	(206694, 121, '2014-02-15 00:47:52.000000', 'temperatura', 256.0000, 'ºC'),
	(206695, 121, '2014-02-15 00:47:53.000000', 'temperatura', 528.0000, 'ºC'),
	(206696, 121, '2014-02-15 00:47:54.000000', 'temperatura', 672.0000, 'ºC'),
	(206697, 121, '2014-02-15 00:47:55.000000', 'temperatura', 578.0000, 'ºC'),
	(206698, 121, '2014-02-15 00:47:56.000000', 'temperatura', 875.0000, 'ºC'),
	(206699, 121, '2014-02-15 00:47:57.000000', 'temperatura', 241.0000, 'ºC'),
	(206700, 121, '2014-02-15 00:47:58.000000', 'temperatura', 982.0000, 'ºC'),
	(206701, 121, '2014-02-15 00:47:59.000000', 'temperatura', 585.0000, 'ºC'),
	(206702, 121, '2014-02-15 00:48:00.000000', 'temperatura', 1181.0000, 'ºC'),
	(206703, 121, '2014-02-15 00:48:01.000000', 'temperatura', 550.0000, 'ºC'),
	(206704, 121, '2014-02-15 00:48:02.000000', 'temperatura', 409.0000, 'ºC'),
	(206705, 121, '2014-02-15 00:48:03.000000', 'temperatura', 395.0000, 'ºC'),
	(206706, 121, '2014-02-15 00:48:04.000000', 'temperatura', 747.0000, 'ºC'),
	(206707, 121, '2014-02-15 00:48:05.000000', 'temperatura', 151.0000, 'ºC'),
	(206708, 121, '2014-02-15 00:48:06.000000', 'temperatura', 913.0000, 'ºC'),
	(206709, 121, '2014-02-15 00:48:07.000000', 'temperatura', 514.0000, 'ºC'),
	(206710, 121, '2014-02-15 00:48:08.000000', 'temperatura', 1030.0000, 'ºC'),
	(206711, 121, '2014-02-15 00:48:09.000000', 'temperatura', 9.0000, 'ºC'),
	(206712, 121, '2014-02-15 00:48:10.000000', 'temperatura', 556.0000, 'ºC'),
	(206713, 121, '2014-02-15 00:48:11.000000', 'temperatura', 352.0000, 'ºC'),
	(206714, 121, '2014-02-15 00:48:12.000000', 'temperatura', 93.0000, 'ºC'),
	(206715, 121, '2014-02-15 00:48:13.000000', 'temperatura', 609.0000, 'ºC'),
	(206716, 121, '2014-02-15 00:48:14.000000', 'temperatura', 365.0000, 'ºC'),
	(206717, 121, '2014-02-15 00:48:15.000000', 'temperatura', 2.0000, 'ºC'),
	(206718, 121, '2014-02-15 00:48:16.000000', 'temperatura', 112.0000, 'ºC'),
	(206719, 121, '2014-02-15 00:48:17.000000', 'temperatura', 558.0000, 'ºC'),
	(206720, 121, '2014-02-15 00:48:18.000000', 'temperatura', 53.0000, 'ºC'),
	(206721, 121, '2014-02-15 00:48:19.000000', 'temperatura', 993.0000, 'ºC'),
	(206722, 121, '2014-02-15 00:48:20.000000', 'temperatura', 5.0000, 'ºC'),
	(206723, 121, '2014-02-15 00:48:21.000000', 'temperatura', 645.0000, 'ºC'),
	(206724, 121, '2014-02-15 00:48:22.000000', 'temperatura', 814.0000, 'ºC'),
	(206725, 121, '2014-02-15 00:48:23.000000', 'temperatura', 933.0000, 'ºC'),
	(206726, 121, '2014-02-15 00:48:24.000000', 'temperatura', 1022.0000, 'ºC'),
	(206727, 121, '2014-02-15 00:48:25.000000', 'temperatura', 1114.0000, 'ºC'),
	(206728, 121, '2014-02-15 00:48:26.000000', 'temperatura', 103.0000, 'ºC'),
	(206729, 121, '2014-02-15 00:48:27.000000', 'temperatura', 775.0000, 'ºC'),
	(206730, 121, '2014-02-15 00:48:28.000000', 'temperatura', 1166.0000, 'ºC'),
	(206731, 121, '2014-02-15 00:48:29.000000', 'temperatura', 1107.0000, 'ºC'),
	(206732, 121, '2014-02-15 00:48:30.000000', 'temperatura', 836.0000, 'ºC'),
	(206733, 121, '2014-02-15 00:48:31.000000', 'temperatura', 858.0000, 'ºC'),
	(206734, 121, '2014-02-15 00:48:32.000000', 'temperatura', 584.0000, 'ºC'),
	(206735, 121, '2014-02-15 00:48:33.000000', 'temperatura', 344.0000, 'ºC'),
	(206736, 121, '2014-02-15 00:48:34.000000', 'temperatura', 1172.0000, 'ºC'),
	(206737, 121, '2014-02-15 00:48:35.000000', 'temperatura', 26.0000, 'ºC'),
	(206738, 121, '2014-02-15 00:48:36.000000', 'temperatura', 217.0000, 'ºC'),
	(206739, 121, '2014-02-15 00:48:37.000000', 'temperatura', 1007.0000, 'ºC'),
	(206740, 121, '2014-02-15 00:48:38.000000', 'temperatura', 782.0000, 'ºC'),
	(206741, 121, '2014-02-15 00:48:39.000000', 'temperatura', 891.0000, 'ºC'),
	(206742, 121, '2014-02-15 00:48:40.000000', 'temperatura', 910.0000, 'ºC'),
	(206743, 121, '2014-02-15 00:48:41.000000', 'temperatura', 675.0000, 'ºC'),
	(206744, 121, '2014-02-15 00:48:42.000000', 'temperatura', 647.0000, 'ºC'),
	(206745, 121, '2014-02-15 00:48:43.000000', 'temperatura', 11.0000, 'ºC'),
	(206746, 121, '2014-02-15 00:48:44.000000', 'temperatura', 514.0000, 'ºC'),
	(206747, 121, '2014-02-15 00:48:45.000000', 'temperatura', 137.0000, 'ºC'),
	(206748, 121, '2014-02-15 00:48:46.000000', 'temperatura', 344.0000, 'ºC'),
	(206749, 121, '2014-02-15 00:48:47.000000', 'temperatura', 110.0000, 'ºC'),
	(206750, 121, '2014-02-15 00:48:48.000000', 'temperatura', 719.0000, 'ºC'),
	(206751, 121, '2014-02-15 00:48:49.000000', 'temperatura', 865.0000, 'ºC'),
	(206752, 121, '2014-02-15 00:48:50.000000', 'temperatura', 969.0000, 'ºC'),
	(206753, 121, '2014-02-15 00:48:51.000000', 'temperatura', 1051.0000, 'ºC'),
	(206754, 121, '2014-02-15 00:48:52.000000', 'temperatura', 1146.0000, 'ºC'),
	(206755, 121, '2014-02-15 00:48:53.000000', 'temperatura', 181.0000, 'ºC'),
	(206756, 121, '2014-02-15 00:48:54.000000', 'temperatura', 1064.0000, 'ºC'),
	(206757, 121, '2014-02-15 00:48:55.000000', 'temperatura', 1180.0000, 'ºC'),
	(206758, 121, '2014-02-15 00:48:56.000000', 'temperatura', 307.0000, 'ºC'),
	(206759, 121, '2014-02-15 00:48:57.000000', 'temperatura', 398.0000, 'ºC'),
	(206760, 121, '2014-02-15 00:48:58.000000', 'temperatura', 1067.0000, 'ºC'),
	(206761, 121, '2014-02-15 00:48:59.000000', 'temperatura', 543.0000, 'ºC'),
	(206762, 121, '2014-02-15 00:49:00.000000', 'temperatura', 713.0000, 'ºC'),
	(206763, 121, '2014-02-15 00:49:01.000000', 'temperatura', 737.0000, 'ºC'),
	(206764, 121, '2014-02-15 00:49:02.000000', 'temperatura', 347.0000, 'ºC'),
	(206765, 121, '2014-02-15 00:49:03.000000', 'temperatura', 723.0000, 'ºC'),
	(206766, 121, '2014-02-15 00:49:04.000000', 'temperatura', 174.0000, 'ºC'),
	(206767, 121, '2014-02-15 00:49:05.000000', 'temperatura', 1104.0000, 'ºC'),
	(206768, 121, '2014-02-15 00:49:06.000000', 'temperatura', 197.0000, 'ºC'),
	(206769, 121, '2014-02-15 00:49:07.000000', 'temperatura', 74.0000, 'ºC'),
	(206770, 121, '2014-02-15 00:49:08.000000', 'temperatura', 979.0000, 'ºC'),
	(206771, 121, '2014-02-15 00:49:09.000000', 'temperatura', 1072.0000, 'ºC'),
	(206772, 121, '2014-02-15 00:49:10.000000', 'temperatura', 25.0000, 'ºC'),
	(206773, 121, '2014-02-15 00:49:11.000000', 'temperatura', 508.0000, 'ºC'),
	(206774, 121, '2014-02-15 00:49:12.000000', 'temperatura', 68.0000, 'ºC'),
	(206775, 121, '2014-02-15 00:49:13.000000', 'temperatura', 15.0000, 'ºC'),
	(206776, 121, '2014-02-15 00:49:14.000000', 'temperatura', 1073.0000, 'ºC'),
	(206777, 121, '2014-02-15 00:49:15.000000', 'temperatura', 519.0000, 'ºC'),
	(206778, 121, '2014-02-15 00:49:16.000000', 'temperatura', 577.0000, 'ºC'),
	(206779, 121, '2014-02-15 00:49:17.000000', 'temperatura', 127.0000, 'ºC'),
	(206780, 121, '2014-02-15 00:49:18.000000', 'temperatura', 106.0000, 'ºC'),
	(206781, 121, '2014-02-15 00:49:19.000000', 'temperatura', 150.0000, 'ºC'),
	(206782, 121, '2014-02-15 00:49:20.000000', 'temperatura', 433.0000, 'ºC'),
	(206783, 121, '2014-02-15 00:49:21.000000', 'temperatura', 514.0000, 'ºC'),
	(206784, 121, '2014-02-15 00:49:22.000000', 'temperatura', 70.0000, 'ºC'),
	(206785, 121, '2014-02-15 00:49:23.000000', 'temperatura', 12.0000, 'ºC'),
	(206786, 121, '2014-02-15 00:49:24.000000', 'temperatura', 1049.0000, 'ºC'),
	(206787, 121, '2014-02-15 00:49:25.000000', 'temperatura', 411.0000, 'ºC'),
	(206788, 121, '2014-02-15 00:49:26.000000', 'temperatura', 106.0000, 'ºC'),
	(206789, 121, '2014-02-15 00:49:27.000000', 'temperatura', 500.0000, 'ºC'),
	(206790, 121, '2014-02-15 00:49:28.000000', 'temperatura', 981.0000, 'ºC'),
	(206791, 121, '2014-02-15 00:49:29.000000', 'temperatura', 1007.0000, 'ºC'),
	(206792, 121, '2014-02-15 00:49:30.000000', 'temperatura', 891.0000, 'ºC'),
	(206793, 121, '2014-02-15 00:49:31.000000', 'temperatura', 236.0000, 'ºC'),
	(206794, 121, '2014-02-15 00:49:32.000000', 'temperatura', 908.0000, 'ºC'),
	(206795, 121, '2014-02-15 00:49:33.000000', 'temperatura', 233.0000, 'ºC'),
	(206796, 121, '2014-02-15 00:49:34.000000', 'temperatura', 839.0000, 'ºC'),
	(206797, 121, '2014-02-15 00:49:35.000000', 'temperatura', 1099.0000, 'ºC'),
	(206798, 121, '2014-02-15 00:49:36.000000', 'temperatura', 578.0000, 'ºC'),
	(206799, 121, '2014-02-15 00:49:37.000000', 'temperatura', 792.0000, 'ºC'),
	(206800, 121, '2014-02-15 00:49:38.000000', 'temperatura', 1026.0000, 'ºC'),
	(206801, 121, '2014-02-15 00:49:39.000000', 'temperatura', 357.0000, 'ºC'),
	(206802, 121, '2014-02-15 00:49:40.000000', 'temperatura', 1108.0000, 'ºC'),
	(206803, 121, '2014-02-15 00:49:41.000000', 'temperatura', 870.0000, 'ºC'),
	(206804, 121, '2014-02-15 00:49:42.000000', 'temperatura', 1027.0000, 'ºC'),
	(206805, 121, '2014-02-15 00:49:43.000000', 'temperatura', 126.0000, 'ºC'),
	(206806, 121, '2014-02-15 00:49:44.000000', 'temperatura', 1147.0000, 'ºC'),
	(206807, 121, '2014-02-15 00:49:45.000000', 'temperatura', 558.0000, 'ºC'),
	(206808, 121, '2014-02-15 00:49:46.000000', 'temperatura', 550.0000, 'ºC'),
	(206809, 121, '2014-02-15 00:49:47.000000', 'temperatura', 1076.0000, 'ºC'),
	(206810, 121, '2014-02-15 00:49:48.000000', 'temperatura', 131.0000, 'ºC'),
	(206811, 121, '2014-02-15 00:49:49.000000', 'temperatura', 1027.0000, 'ºC'),
	(206812, 121, '2014-02-15 00:49:50.000000', 'temperatura', 1143.0000, 'ºC'),
	(206813, 121, '2014-02-15 00:49:51.000000', 'temperatura', 235.0000, 'ºC'),
	(206814, 121, '2014-02-15 00:49:52.000000', 'temperatura', 147.0000, 'ºC'),
	(206815, 121, '2014-02-15 00:49:53.000000', 'temperatura', 32.0000, 'ºC'),
	(206816, 121, '2014-02-15 00:49:54.000000', 'temperatura', 917.0000, 'ºC'),
	(206817, 121, '2014-02-15 00:49:55.000000', 'temperatura', 889.0000, 'ºC'),
	(206818, 121, '2014-02-15 00:49:56.000000', 'temperatura', 494.0000, 'ºC'),
	(206819, 121, '2014-02-15 00:49:57.000000', 'temperatura', 1007.0000, 'ºC'),
	(206820, 121, '2014-02-15 00:49:58.000000', 'temperatura', 1150.0000, 'ºC'),
	(206821, 121, '2014-02-15 00:49:59.000000', 'temperatura', 329.0000, 'ºC'),
	(206822, 121, '2014-02-15 00:50:00.000000', 'temperatura', 598.0000, 'ºC'),
	(206823, 121, '2014-02-15 00:50:01.000000', 'temperatura', 801.0000, 'ºC'),
	(206824, 121, '2014-02-15 00:50:02.000000', 'temperatura', 1013.0000, 'ºC'),
	(206825, 121, '2014-02-15 00:50:03.000000', 'temperatura', 261.0000, 'ºC'),
	(206826, 121, '2014-02-15 00:50:04.000000', 'temperatura', 667.0000, 'ºC'),
	(206827, 121, '2014-02-15 00:50:05.000000', 'temperatura', 152.0000, 'ºC'),
	(206828, 121, '2014-02-15 00:50:06.000000', 'temperatura', 1160.0000, 'ºC'),
	(206829, 121, '2014-02-15 00:50:07.000000', 'temperatura', 544.0000, 'ºC'),
	(206830, 121, '2014-02-15 00:50:08.000000', 'temperatura', 442.0000, 'ºC'),
	(206831, 121, '2014-02-15 00:50:09.000000', 'temperatura', 579.0000, 'ºC'),
	(206832, 121, '2014-02-15 00:50:10.000000', 'temperatura', 371.0000, 'ºC'),
	(206833, 121, '2014-02-15 00:50:11.000000', 'temperatura', 115.0000, 'ºC'),
	(206834, 121, '2014-02-15 00:50:12.000000', 'temperatura', 663.0000, 'ºC'),
	(206835, 121, '2014-02-15 00:50:13.000000', 'temperatura', 573.0000, 'ºC'),
	(206836, 121, '2014-02-15 00:50:14.000000', 'temperatura', 875.0000, 'ºC'),
	(206837, 121, '2014-02-15 00:50:15.000000', 'temperatura', 259.0000, 'ºC'),
	(206838, 121, '2014-02-15 00:50:16.000000', 'temperatura', 1067.0000, 'ºC'),
	(206839, 121, '2014-02-15 00:50:17.000000', 'temperatura', 960.0000, 'ºC'),
	(206840, 121, '2014-02-15 00:50:18.000000', 'temperatura', 399.0000, 'ºC'),
	(206841, 121, '2014-02-15 00:50:19.000000', 'temperatura', 314.0000, 'ºC'),
	(206842, 121, '2014-02-15 00:50:20.000000', 'temperatura', 374.0000, 'ºC'),
	(206843, 121, '2014-02-15 00:50:21.000000', 'temperatura', 928.0000, 'ºC'),
	(206844, 121, '2014-02-15 00:50:22.000000', 'temperatura', 1120.0000, 'ºC'),
	(206845, 121, '2014-02-15 00:50:23.000000', 'temperatura', 418.0000, 'ºC'),
	(206846, 121, '2014-02-15 00:50:24.000000', 'temperatura', 1127.0000, 'ºC'),
	(206847, 121, '2014-02-15 00:50:25.000000', 'temperatura', 784.0000, 'ºC'),
	(206848, 121, '2014-02-15 00:50:26.000000', 'temperatura', 537.0000, 'ºC'),
	(206849, 121, '2014-02-15 00:50:27.000000', 'temperatura', 336.0000, 'ºC'),
	(206850, 121, '2014-02-15 00:50:28.000000', 'temperatura', 68.0000, 'ºC'),
	(206851, 121, '2014-02-15 00:50:29.000000', 'temperatura', 533.0000, 'ºC'),
	(206852, 121, '2014-02-15 00:50:30.000000', 'temperatura', 62.0000, 'ºC'),
	(206853, 121, '2014-02-15 00:50:31.000000', 'temperatura', 1113.0000, 'ºC'),
	(206854, 121, '2014-02-15 00:50:32.000000', 'temperatura', 578.0000, 'ºC'),
	(206855, 121, '2014-02-15 00:50:33.000000', 'temperatura', 753.0000, 'ºC'),
	(206856, 121, '2014-02-15 00:50:34.000000', 'temperatura', 832.0000, 'ºC'),
	(206857, 121, '2014-02-15 00:50:35.000000', 'temperatura', 702.0000, 'ºC'),
	(206858, 121, '2014-02-15 00:50:36.000000', 'temperatura', 1012.0000, 'ºC'),
	(206859, 121, '2014-02-15 00:50:37.000000', 'temperatura', 554.0000, 'ºC'),
	(206860, 121, '2014-02-15 00:50:38.000000', 'temperatura', 937.0000, 'ºC'),
	(206861, 121, '2014-02-15 00:50:39.000000', 'temperatura', 620.0000, 'ºC'),
	(206862, 121, '2014-02-15 00:50:40.000000', 'temperatura', 293.0000, 'ºC'),
	(206863, 121, '2014-02-15 00:50:41.000000', 'temperatura', 805.0000, 'ºC'),
	(206864, 121, '2014-02-15 00:50:42.000000', 'temperatura', 744.0000, 'ºC'),
	(206865, 121, '2014-02-15 00:50:43.000000', 'temperatura', 109.0000, 'ºC'),
	(206866, 121, '2014-02-15 00:50:44.000000', 'temperatura', 710.0000, 'ºC'),
	(206867, 121, '2014-02-15 00:50:45.000000', 'temperatura', 827.0000, 'ºC'),
	(206868, 121, '2014-02-15 00:50:46.000000', 'temperatura', 803.0000, 'ºC'),
	(206869, 121, '2014-02-15 00:50:47.000000', 'temperatura', 335.0000, 'ºC'),
	(206870, 121, '2014-02-15 00:50:48.000000', 'temperatura', 465.0000, 'ºC'),
	(206871, 121, '2014-02-15 00:50:49.000000', 'temperatura', 124.0000, 'ºC'),
	(206872, 121, '2014-02-15 00:50:50.000000', 'temperatura', 423.0000, 'ºC'),
	(206873, 121, '2014-02-15 00:50:51.000000', 'temperatura', 543.0000, 'ºC'),
	(206874, 121, '2014-02-15 00:50:52.000000', 'temperatura', 247.0000, 'ºC'),
	(206875, 121, '2014-02-15 00:50:53.000000', 'temperatura', 809.0000, 'ºC'),
	(206876, 121, '2014-02-15 00:50:54.000000', 'temperatura', 902.0000, 'ºC'),
	(206877, 121, '2014-02-15 00:50:55.000000', 'temperatura', 884.0000, 'ºC'),
	(206878, 121, '2014-02-15 00:50:56.000000', 'temperatura', 515.0000, 'ºC'),
	(206879, 121, '2014-02-15 00:50:57.000000', 'temperatura', 1123.0000, 'ºC'),
	(206880, 121, '2014-02-15 00:50:58.000000', 'temperatura', 470.0000, 'ºC'),
	(206881, 121, '2014-02-15 00:50:59.000000', 'temperatura', 182.0000, 'ºC'),
	(206882, 121, '2014-02-15 00:51:00.000000', 'temperatura', 699.0000, 'ºC'),
	(206883, 121, '2014-02-15 00:51:01.000000', 'temperatura', 549.0000, 'ºC'),
	(206884, 121, '2014-02-15 00:51:02.000000', 'temperatura', 649.0000, 'ºC'),
	(206885, 121, '2014-02-15 00:51:03.000000', 'temperatura', 397.0000, 'ºC'),
	(206886, 121, '2014-02-15 00:51:04.000000', 'temperatura', 42.0000, 'ºC'),
	(206887, 121, '2014-02-15 00:51:05.000000', 'temperatura', 216.0000, 'ºC'),
	(206888, 121, '2014-02-15 00:51:06.000000', 'temperatura', 958.0000, 'ºC'),
	(206889, 121, '2014-02-15 00:51:07.000000', 'temperatura', 541.0000, 'ºC'),
	(206890, 121, '2014-02-15 00:51:08.000000', 'temperatura', 1030.0000, 'ºC'),
	(206891, 121, '2014-02-15 00:51:09.000000', 'temperatura', 1126.0000, 'ºC'),
	(206892, 121, '2014-02-15 00:51:10.000000', 'temperatura', 144.0000, 'ºC'),
	(206893, 121, '2014-02-15 00:51:11.000000', 'temperatura', 942.0000, 'ºC'),
	(206894, 121, '2014-02-15 00:51:12.000000', 'temperatura', 680.0000, 'ºC'),
	(206895, 121, '2014-02-15 00:51:13.000000', 'temperatura', 571.0000, 'ºC'),
	(206896, 121, '2014-02-15 00:51:14.000000', 'temperatura', 818.0000, 'ºC'),
	(206897, 121, '2014-02-15 00:51:15.000000', 'temperatura', 1177.0000, 'ºC'),
	(206898, 121, '2014-02-15 00:51:16.000000', 'temperatura', 1031.0000, 'ºC'),
	(206899, 121, '2014-02-15 00:51:17.000000', 'temperatura', 426.0000, 'ºC'),
	(206900, 121, '2014-02-15 00:51:18.000000', 'temperatura', 238.0000, 'ºC'),
	(206901, 121, '2014-02-15 00:51:19.000000', 'temperatura', 1113.0000, 'ºC'),
	(206902, 121, '2014-02-15 00:51:20.000000', 'temperatura', 52.0000, 'ºC'),
	(206903, 121, '2014-02-15 00:51:21.000000', 'temperatura', 520.0000, 'ºC'),
	(206904, 121, '2014-02-15 00:51:22.000000', 'temperatura', 47.0000, 'ºC'),
	(206905, 121, '2014-02-15 00:51:23.000000', 'temperatura', 1073.0000, 'ºC'),
	(206906, 121, '2014-02-15 00:51:24.000000', 'temperatura', 423.0000, 'ºC'),
	(206907, 121, '2014-02-15 00:51:25.000000', 'temperatura', 98.0000, 'ºC'),
	(206908, 121, '2014-02-15 00:51:26.000000', 'temperatura', 423.0000, 'ºC'),
	(206909, 121, '2014-02-15 00:51:27.000000', 'temperatura', 619.0000, 'ºC'),
	(206910, 121, '2014-02-15 00:51:28.000000', 'temperatura', 628.0000, 'ºC'),
	(206911, 121, '2014-02-15 00:51:29.000000', 'temperatura', 85.0000, 'ºC'),
	(206912, 121, '2014-02-15 00:51:30.000000', 'temperatura', 940.0000, 'ºC'),
	(206913, 121, '2014-02-15 00:51:31.000000', 'temperatura', 846.0000, 'ºC'),
	(206914, 121, '2014-02-15 00:51:32.000000', 'temperatura', 212.0000, 'ºC'),
	(206915, 121, '2014-02-15 00:51:33.000000', 'temperatura', 923.0000, 'ºC'),
	(206916, 121, '2014-02-15 00:51:34.000000', 'temperatura', 378.0000, 'ºC'),
	(206917, 121, '2014-02-15 00:51:35.000000', 'temperatura', 321.0000, 'ºC'),
	(206918, 121, '2014-02-15 00:51:36.000000', 'temperatura', 473.0000, 'ºC'),
	(206919, 121, '2014-02-15 00:51:37.000000', 'temperatura', 200.0000, 'ºC'),
	(206920, 121, '2014-02-15 00:51:38.000000', 'temperatura', 783.0000, 'ºC'),
	(206921, 121, '2014-02-15 00:51:39.000000', 'temperatura', 913.0000, 'ºC'),
	(206922, 121, '2014-02-15 00:51:40.000000', 'temperatura', 1019.0000, 'ºC'),
	(206923, 121, '2014-02-15 00:51:41.000000', 'temperatura', 1156.0000, 'ºC'),
	(206924, 121, '2014-02-15 00:51:42.000000', 'temperatura', 325.0000, 'ºC'),
	(206925, 121, '2014-02-15 00:51:43.000000', 'temperatura', 554.0000, 'ºC'),
	(206926, 121, '2014-02-15 00:51:44.000000', 'temperatura', 599.0000, 'ºC'),
	(206927, 121, '2014-02-15 00:51:45.000000', 'temperatura', 133.0000, 'ºC'),
	(206928, 121, '2014-02-15 00:51:46.000000', 'temperatura', 68.0000, 'ºC'),
	(206929, 121, '2014-02-15 00:51:47.000000', 'temperatura', 1143.0000, 'ºC'),
	(206930, 121, '2014-02-15 00:51:48.000000', 'temperatura', 709.0000, 'ºC'),
	(206931, 121, '2014-02-15 00:51:49.000000', 'temperatura', 119.0000, 'ºC'),
	(206932, 121, '2014-02-15 00:51:50.000000', 'temperatura', 867.0000, 'ºC'),
	(206933, 121, '2014-02-15 00:51:51.000000', 'temperatura', 379.0000, 'ºC'),
	(206934, 121, '2014-02-15 00:51:52.000000', 'temperatura', 495.0000, 'ºC'),
	(206935, 121, '2014-02-15 00:51:53.000000', 'temperatura', 136.0000, 'ºC'),
	(206936, 121, '2014-02-15 00:51:54.000000', 'temperatura', 399.0000, 'ºC'),
	(206937, 121, '2014-02-15 00:51:55.000000', 'temperatura', 384.0000, 'ºC'),
	(206938, 121, '2014-02-15 00:51:56.000000', 'temperatura', 725.0000, 'ºC'),
	(206939, 121, '2014-02-15 00:51:57.000000', 'temperatura', 72.0000, 'ºC'),
	(206940, 121, '2014-02-15 00:51:58.000000', 'temperatura', 585.0000, 'ºC'),
	(206941, 121, '2014-02-15 00:51:59.000000', 'temperatura', 309.0000, 'ºC'),
	(206942, 121, '2014-02-15 00:52:00.000000', 'temperatura', 992.0000, 'ºC'),
	(206943, 121, '2014-02-15 00:52:01.000000', 'temperatura', 433.0000, 'ºC'),
	(206944, 121, '2014-02-15 00:52:02.000000', 'temperatura', 389.0000, 'ºC'),
	(206945, 121, '2014-02-15 00:52:03.000000', 'temperatura', 648.0000, 'ºC'),
	(206946, 121, '2014-02-15 00:52:04.000000', 'temperatura', 875.0000, 'ºC'),
	(206947, 121, '2014-02-15 00:52:05.000000', 'temperatura', 30.0000, 'ºC'),
	(206948, 121, '2014-02-15 00:52:06.000000', 'temperatura', 1124.0000, 'ºC'),
	(206949, 121, '2014-02-15 00:52:07.000000', 'temperatura', 730.0000, 'ºC'),
	(206950, 121, '2014-02-15 00:52:08.000000', 'temperatura', 281.0000, 'ºC'),
	(206951, 121, '2014-02-15 00:52:09.000000', 'temperatura', 414.0000, 'ºC'),
	(206952, 121, '2014-02-15 00:52:10.000000', 'temperatura', 29.0000, 'ºC'),
	(206953, 121, '2014-02-15 00:52:11.000000', 'temperatura', 104.0000, 'ºC'),
	(206954, 121, '2014-02-15 00:52:12.000000', 'temperatura', 432.0000, 'ºC'),
	(206955, 121, '2014-02-15 00:52:13.000000', 'temperatura', 650.0000, 'ºC'),
	(206956, 121, '2014-02-15 00:52:14.000000', 'temperatura', 753.0000, 'ºC'),
	(206957, 121, '2014-02-15 00:52:15.000000', 'temperatura', 616.0000, 'ºC'),
	(206958, 121, '2014-02-15 00:52:16.000000', 'temperatura', 822.0000, 'ºC'),
	(206959, 121, '2014-02-15 00:52:17.000000', 'temperatura', 1062.0000, 'ºC'),
	(206960, 121, '2014-02-15 00:52:18.000000', 'temperatura', 446.0000, 'ºC'),
	(206961, 121, '2014-02-15 00:52:19.000000', 'temperatura', 242.0000, 'ºC'),
	(206962, 121, '2014-02-15 00:52:20.000000', 'temperatura', 1073.0000, 'ºC'),
	(206963, 121, '2014-02-15 00:52:21.000000', 'temperatura', 1041.0000, 'ºC'),
	(206964, 121, '2014-02-15 00:52:22.000000', 'temperatura', 787.0000, 'ºC'),
	(206965, 121, '2014-02-15 00:52:23.000000', 'temperatura', 813.0000, 'ºC'),
	(206966, 121, '2014-02-15 00:52:24.000000', 'temperatura', 503.0000, 'ºC'),
	(206967, 121, '2014-02-15 00:52:25.000000', 'temperatura', 78.0000, 'ºC'),
	(206968, 121, '2014-02-15 00:52:26.000000', 'temperatura', 83.0000, 'ºC'),
	(206969, 121, '2014-02-15 00:52:27.000000', 'temperatura', 178.0000, 'ºC'),
	(206970, 121, '2014-02-15 00:52:28.000000', 'temperatura', 643.0000, 'ºC'),
	(206971, 121, '2014-02-15 00:52:29.000000', 'temperatura', 282.0000, 'ºC'),
	(206972, 121, '2014-02-15 00:52:30.000000', 'temperatura', 681.0000, 'ºC'),
	(206973, 121, '2014-02-15 00:52:31.000000', 'temperatura', 161.0000, 'ºC'),
	(206974, 121, '2014-02-15 00:52:32.000000', 'temperatura', 1161.0000, 'ºC'),
	(206975, 121, '2014-02-15 00:52:33.000000', 'temperatura', 524.0000, 'ºC'),
	(206976, 121, '2014-02-15 00:52:34.000000', 'temperatura', 339.0000, 'ºC'),
	(206977, 121, '2014-02-15 00:52:35.000000', 'temperatura', 121.0000, 'ºC'),
	(206978, 121, '2014-02-15 00:52:36.000000', 'temperatura', 788.0000, 'ºC'),
	(206979, 121, '2014-02-15 00:52:37.000000', 'temperatura', 1178.0000, 'ºC'),
	(206980, 121, '2014-02-15 00:52:38.000000', 'temperatura', 1129.0000, 'ºC'),
	(206981, 121, '2014-02-15 00:52:39.000000', 'temperatura', 908.0000, 'ºC'),
	(206982, 121, '2014-02-15 00:52:40.000000', 'temperatura', 1155.0000, 'ºC'),
	(206983, 121, '2014-02-15 00:52:41.000000', 'temperatura', 653.0000, 'ºC'),
	(206984, 121, '2014-02-15 00:52:42.000000', 'temperatura', 999.0000, 'ºC'),
	(206985, 121, '2014-02-15 00:52:43.000000', 'temperatura', 638.0000, 'ºC'),
	(206986, 121, '2014-02-15 00:52:44.000000', 'temperatura', 194.0000, 'ºC'),
	(206987, 121, '2014-02-15 00:52:45.000000', 'temperatura', 255.0000, 'ºC'),
	(206988, 121, '2014-02-15 00:52:46.000000', 'temperatura', 692.0000, 'ºC'),
	(206989, 121, '2014-02-15 00:52:47.000000', 'temperatura', 297.0000, 'ºC'),
	(206990, 121, '2014-02-15 00:52:48.000000', 'temperatura', 608.0000, 'ºC'),
	(206991, 121, '2014-02-15 00:52:49.000000', 'temperatura', 950.0000, 'ºC'),
	(206992, 121, '2014-02-15 00:52:50.000000', 'temperatura', 525.0000, 'ºC'),
	(206993, 121, '2014-02-15 00:52:51.000000', 'temperatura', 976.0000, 'ºC'),
	(206994, 121, '2014-02-15 00:52:52.000000', 'temperatura', 906.0000, 'ºC'),
	(206995, 121, '2014-02-15 00:52:53.000000', 'temperatura', 402.0000, 'ºC'),
	(206996, 121, '2014-02-15 00:52:54.000000', 'temperatura', 491.0000, 'ºC'),
	(206997, 121, '2014-02-15 00:52:55.000000', 'temperatura', 50.0000, 'ºC'),
	(206998, 121, '2014-02-15 00:52:56.000000', 'temperatura', 1177.0000, 'ºC'),
	(206999, 121, '2014-02-15 00:52:57.000000', 'temperatura', 937.0000, 'ºC'),
	(207000, 121, '2014-02-15 00:52:58.000000', 'temperatura', 1156.0000, 'ºC'),
	(207001, 121, '2014-02-15 00:52:59.000000', 'temperatura', 566.0000, 'ºC'),
	(207002, 121, '2014-02-15 00:53:00.000000', 'temperatura', 565.0000, 'ºC'),
	(207003, 121, '2014-02-15 00:53:01.000000', 'temperatura', 1125.0000, 'ºC'),
	(207004, 121, '2014-02-15 00:53:02.000000', 'temperatura', 331.0000, 'ºC'),
	(207005, 121, '2014-02-15 00:53:03.000000', 'temperatura', 682.0000, 'ºC'),
	(207006, 121, '2014-02-15 00:53:04.000000', 'temperatura', 18.0000, 'ºC'),
	(207007, 121, '2014-02-15 00:53:05.000000', 'temperatura', 444.0000, 'ºC'),
	(207008, 121, '2014-02-15 00:53:06.000000', 'temperatura', 965.0000, 'ºC'),
	(207009, 121, '2014-02-15 00:53:07.000000', 'temperatura', 1096.0000, 'ºC'),
	(207010, 121, '2014-02-15 00:53:08.000000', 'temperatura', 185.0000, 'ºC'),
	(207011, 121, '2014-02-15 00:53:09.000000', 'temperatura', 38.0000, 'ºC'),
	(207012, 121, '2014-02-15 00:53:10.000000', 'temperatura', 836.0000, 'ºC'),
	(207013, 121, '2014-02-15 00:53:11.000000', 'temperatura', 464.0000, 'ºC'),
	(207014, 121, '2014-02-15 00:53:12.000000', 'temperatura', 1013.0000, 'ºC'),
	(207015, 121, '2014-02-15 00:53:13.000000', 'temperatura', 73.0000, 'ºC'),
	(207016, 121, '2014-02-15 00:53:14.000000', 'temperatura', 927.0000, 'ºC'),
	(207017, 121, '2014-02-15 00:53:15.000000', 'temperatura', 815.0000, 'ºC'),
	(207018, 121, '2014-02-15 00:53:16.000000', 'temperatura', 97.0000, 'ºC'),
	(207019, 121, '2014-02-15 00:53:17.000000', 'temperatura', 439.0000, 'ºC'),
	(207020, 121, '2014-02-15 00:53:18.000000', 'temperatura', 704.0000, 'ºC'),
	(207021, 121, '2014-02-15 00:53:19.000000', 'temperatura', 1006.0000, 'ºC'),
	(207022, 121, '2014-02-15 00:53:20.000000', 'temperatura', 517.0000, 'ºC'),
	(207023, 121, '2014-02-15 00:53:21.000000', 'temperatura', 769.0000, 'ºC'),
	(207024, 121, '2014-02-15 00:53:22.000000', 'temperatura', 1092.0000, 'ºC'),
	(207025, 121, '2014-02-15 00:53:23.000000', 'temperatura', 753.0000, 'ºC'),
	(207026, 121, '2014-02-15 00:53:24.000000', 'temperatura', 490.0000, 'ºC'),
	(207027, 121, '2014-02-15 00:53:25.000000', 'temperatura', 191.0000, 'ºC'),
	(207028, 121, '2014-02-15 00:53:26.000000', 'temperatura', 688.0000, 'ºC'),
	(207029, 121, '2014-02-15 00:53:27.000000', 'temperatura', 464.0000, 'ºC'),
	(207030, 121, '2014-02-15 00:53:28.000000', 'temperatura', 259.0000, 'ºC'),
	(207031, 121, '2014-02-15 00:53:29.000000', 'temperatura', 1105.0000, 'ºC'),
	(207032, 121, '2014-02-15 00:53:30.000000', 'temperatura', 1146.0000, 'ºC'),
	(207033, 121, '2014-02-15 00:53:31.000000', 'temperatura', 15.0000, 'ºC'),
	(207034, 121, '2014-02-15 00:53:32.000000', 'temperatura', 240.0000, 'ºC'),
	(207035, 121, '2014-02-15 00:53:33.000000', 'temperatura', 1155.0000, 'ºC'),
	(207036, 121, '2014-02-15 00:53:34.000000', 'temperatura', 253.0000, 'ºC'),
	(207037, 121, '2014-02-15 00:53:35.000000', 'temperatura', 202.0000, 'ºC'),
	(207038, 121, '2014-02-15 00:53:36.000000', 'temperatura', 253.0000, 'ºC'),
	(207039, 121, '2014-02-15 00:53:37.000000', 'temperatura', 658.0000, 'ºC'),
	(207040, 121, '2014-02-15 00:53:38.000000', 'temperatura', 133.0000, 'ºC'),
	(207041, 121, '2014-02-15 00:53:39.000000', 'temperatura', 1090.0000, 'ºC'),
	(207042, 121, '2014-02-15 00:53:40.000000', 'temperatura', 253.0000, 'ºC'),
	(207043, 121, '2014-02-15 00:53:41.000000', 'temperatura', 396.0000, 'ºC'),
	(207044, 121, '2014-02-15 00:53:42.000000', 'temperatura', 21.0000, 'ºC'),
	(207045, 121, '2014-02-15 00:53:43.000000', 'temperatura', 119.0000, 'ºC'),
	(207046, 121, '2014-02-15 00:53:44.000000', 'temperatura', 531.0000, 'ºC'),
	(207047, 121, '2014-02-15 00:53:45.000000', 'temperatura', 1097.0000, 'ºC'),
	(207048, 121, '2014-02-15 00:53:46.000000', 'temperatura', 295.0000, 'ºC'),
	(207049, 121, '2014-02-15 00:53:47.000000', 'temperatura', 583.0000, 'ºC'),
	(207050, 121, '2014-02-15 00:53:48.000000', 'temperatura', 833.0000, 'ºC'),
	(207051, 121, '2014-02-15 00:53:49.000000', 'temperatura', 13.0000, 'ºC'),
	(207052, 121, '2014-02-15 00:53:50.000000', 'temperatura', 1169.0000, 'ºC'),
	(207053, 121, '2014-02-15 00:53:51.000000', 'temperatura', 1006.0000, 'ºC'),
	(207054, 121, '2014-02-15 00:53:52.000000', 'temperatura', 322.0000, 'ºC'),
	(207055, 121, '2014-02-15 00:53:53.000000', 'temperatura', 994.0000, 'ºC'),
	(207056, 121, '2014-02-15 00:53:54.000000', 'temperatura', 403.0000, 'ºC'),
	(207057, 121, '2014-02-15 00:53:55.000000', 'temperatura', 236.0000, 'ºC'),
	(207058, 121, '2014-02-15 00:53:56.000000', 'temperatura', 1169.0000, 'ºC'),
	(207059, 121, '2014-02-15 00:53:57.000000', 'temperatura', 340.0000, 'ºC'),
	(207060, 121, '2014-02-15 00:53:58.000000', 'temperatura', 591.0000, 'ºC'),
	(207061, 121, '2014-02-15 00:53:59.000000', 'temperatura', 737.0000, 'ºC'),
	(207062, 121, '2014-02-15 00:54:00.000000', 'temperatura', 711.0000, 'ºC'),
	(207063, 121, '2014-02-15 00:54:01.000000', 'temperatura', 146.0000, 'ºC'),
	(207064, 121, '2014-02-15 00:54:02.000000', 'temperatura', 999.0000, 'ºC'),
	(207065, 121, '2014-02-15 00:54:03.000000', 'temperatura', 956.0000, 'ºC'),
	(207066, 121, '2014-02-15 00:54:04.000000', 'temperatura', 584.0000, 'ºC'),
	(207067, 121, '2014-02-15 00:54:05.000000', 'temperatura', 52.0000, 'ºC'),
	(207068, 121, '2014-02-15 00:54:06.000000', 'temperatura', 907.0000, 'ºC'),
	(207069, 121, '2014-02-15 00:54:07.000000', 'temperatura', 780.0000, 'ºC'),
	(207070, 121, '2014-02-15 00:54:08.000000', 'temperatura', 1179.0000, 'ºC'),
	(207071, 121, '2014-02-15 00:54:09.000000', 'temperatura', 1156.0000, 'ºC'),
	(207072, 121, '2014-02-15 00:54:10.000000', 'temperatura', 1043.0000, 'ºC'),
	(207073, 121, '2014-02-15 00:54:11.000000', 'temperatura', 549.0000, 'ºC'),
	(207074, 121, '2014-02-15 00:54:12.000000', 'temperatura', 816.0000, 'ºC'),
	(207075, 121, '2014-02-15 00:54:13.000000', 'temperatura', 35.0000, 'ºC'),
	(207076, 121, '2014-02-15 00:54:14.000000', 'temperatura', 126.0000, 'ºC'),
	(207077, 121, '2014-02-15 00:54:15.000000', 'temperatura', 525.0000, 'ºC'),
	(207078, 121, '2014-02-15 00:54:16.000000', 'temperatura', 1050.0000, 'ºC'),
	(207079, 121, '2014-02-15 00:54:17.000000', 'temperatura', 72.0000, 'ºC'),
	(207080, 121, '2014-02-15 00:54:18.000000', 'temperatura', 814.0000, 'ºC'),
	(207081, 121, '2014-02-15 00:54:19.000000', 'temperatura', 252.0000, 'ºC'),
	(207082, 121, '2014-02-15 00:54:20.000000', 'temperatura', 18.0000, 'ºC'),
	(207083, 121, '2014-02-15 00:54:21.000000', 'temperatura', 534.0000, 'ºC'),
	(207084, 121, '2014-02-15 00:54:22.000000', 'temperatura', 219.0000, 'ºC'),
	(207085, 121, '2014-02-15 00:54:23.000000', 'temperatura', 691.0000, 'ºC'),
	(207086, 121, '2014-02-15 00:54:24.000000', 'temperatura', 401.0000, 'ºC'),
	(207087, 121, '2014-02-15 00:54:25.000000', 'temperatura', 1131.0000, 'ºC'),
	(207088, 121, '2014-02-15 00:54:26.000000', 'temperatura', 853.0000, 'ºC'),
	(207089, 121, '2014-02-15 00:54:27.000000', 'temperatura', 871.0000, 'ºC'),
	(207090, 121, '2014-02-15 00:54:28.000000', 'temperatura', 596.0000, 'ºC'),
	(207091, 121, '2014-02-15 00:54:29.000000', 'temperatura', 369.0000, 'ºC'),
	(207092, 121, '2014-02-15 00:54:30.000000', 'temperatura', 55.0000, 'ºC'),
	(207093, 121, '2014-02-15 00:54:31.000000', 'temperatura', 372.0000, 'ºC'),
	(207094, 121, '2014-02-15 00:54:32.000000', 'temperatura', 494.0000, 'ºC'),
	(207095, 121, '2014-02-15 00:54:33.000000', 'temperatura', 155.0000, 'ºC'),
	(207096, 121, '2014-02-15 00:54:34.000000', 'temperatura', 492.0000, 'ºC'),
	(207097, 121, '2014-02-15 00:54:35.000000', 'temperatura', 797.0000, 'ºC'),
	(207098, 121, '2014-02-15 00:54:36.000000', 'temperatura', 110.0000, 'ºC'),
	(207099, 121, '2014-02-15 00:54:37.000000', 'temperatura', 557.0000, 'ºC'),
	(207100, 121, '2014-02-15 00:54:38.000000', 'temperatura', 56.0000, 'ºC'),
	(207101, 121, '2014-02-15 00:54:39.000000', 'temperatura', 1009.0000, 'ºC'),
	(207102, 121, '2014-02-15 00:54:40.000000', 'temperatura', 80.0000, 'ºC'),
	(207103, 121, '2014-02-15 00:54:41.000000', 'temperatura', 973.0000, 'ºC'),
	(207104, 121, '2014-02-15 00:54:42.000000', 'temperatura', 1026.0000, 'ºC'),
	(207105, 121, '2014-02-15 00:54:43.000000', 'temperatura', 1011.0000, 'ºC'),
	(207106, 121, '2014-02-15 00:54:44.000000', 'temperatura', 775.0000, 'ºC'),
	(207107, 121, '2014-02-15 00:54:45.000000', 'temperatura', 846.0000, 'ºC'),
	(207108, 121, '2014-02-15 00:54:46.000000', 'temperatura', 704.0000, 'ºC'),
	(207109, 121, '2014-02-15 00:54:47.000000', 'temperatura', 983.0000, 'ºC'),
	(207110, 121, '2014-02-15 00:54:48.000000', 'temperatura', 402.0000, 'ºC'),
	(207111, 121, '2014-02-15 00:54:49.000000', 'temperatura', 263.0000, 'ºC'),
	(207112, 121, '2014-02-15 00:54:50.000000', 'temperatura', 108.0000, 'ºC'),
	(207113, 121, '2014-02-15 00:54:51.000000', 'temperatura', 954.0000, 'ºC'),
	(207114, 121, '2014-02-15 00:54:52.000000', 'temperatura', 846.0000, 'ºC'),
	(207115, 121, '2014-02-15 00:54:53.000000', 'temperatura', 168.0000, 'ºC'),
	(207116, 121, '2014-02-15 00:54:54.000000', 'temperatura', 703.0000, 'ºC'),
	(207117, 121, '2014-02-15 00:54:55.000000', 'temperatura', 611.0000, 'ºC'),
	(207118, 121, '2014-02-15 00:54:56.000000', 'temperatura', 946.0000, 'ºC'),
	(207119, 121, '2014-02-15 00:54:57.000000', 'temperatura', 497.0000, 'ºC'),
	(207120, 121, '2014-02-15 00:54:58.000000', 'temperatura', 849.0000, 'ºC'),
	(207121, 121, '2014-02-15 00:54:59.000000', 'temperatura', 352.0000, 'ºC'),
	(207122, 121, '2014-02-15 00:55:00.000000', 'temperatura', 415.0000, 'ºC'),
	(207123, 121, '2014-02-15 00:55:01.000000', 'temperatura', 1019.0000, 'ºC'),
	(207124, 121, '2014-02-15 00:55:02.000000', 'temperatura', 251.0000, 'ºC'),
	(207125, 121, '2014-02-15 00:55:03.000000', 'temperatura', 598.0000, 'ºC'),
	(207126, 121, '2014-02-15 00:55:04.000000', 'temperatura', 1038.0000, 'ºC'),
	(207127, 121, '2014-02-15 00:55:05.000000', 'temperatura', 996.0000, 'ºC'),
	(207128, 121, '2014-02-15 00:55:06.000000', 'temperatura', 668.0000, 'ºC'),
	(207129, 121, '2014-02-15 00:55:07.000000', 'temperatura', 352.0000, 'ºC'),
	(207130, 121, '2014-02-15 00:55:08.000000', 'temperatura', 957.0000, 'ºC'),
	(207131, 121, '2014-02-15 00:55:09.000000', 'temperatura', 129.0000, 'ºC'),
	(207132, 121, '2014-02-15 00:55:10.000000', 'temperatura', 173.0000, 'ºC'),
	(207133, 121, '2014-02-15 00:55:11.000000', 'temperatura', 479.0000, 'ºC'),
	(207134, 121, '2014-02-15 00:55:12.000000', 'temperatura', 678.0000, 'ºC'),
	(207135, 121, '2014-02-15 00:55:13.000000', 'temperatura', 752.0000, 'ºC'),
	(207136, 121, '2014-02-15 00:55:14.000000', 'temperatura', 529.0000, 'ºC'),
	(207137, 121, '2014-02-15 00:55:15.000000', 'temperatura', 386.0000, 'ºC'),
	(207138, 121, '2014-02-15 00:55:16.000000', 'temperatura', 347.0000, 'ºC'),
	(207139, 121, '2014-02-15 00:55:17.000000', 'temperatura', 574.0000, 'ºC'),
	(207140, 121, '2014-02-15 00:55:18.000000', 'temperatura', 632.0000, 'ºC'),
	(207141, 121, '2014-02-15 00:55:19.000000', 'temperatura', 240.0000, 'ºC'),
	(207142, 121, '2014-02-15 00:55:20.000000', 'temperatura', 502.0000, 'ºC'),
	(207143, 121, '2014-02-15 00:55:21.000000', 'temperatura', 590.0000, 'ºC'),
	(207144, 121, '2014-02-15 00:55:22.000000', 'temperatura', 247.0000, 'ºC'),
	(207145, 121, '2014-02-15 00:55:23.000000', 'temperatura', 664.0000, 'ºC'),
	(207146, 121, '2014-02-15 00:55:24.000000', 'temperatura', 181.0000, 'ºC'),
	(207147, 121, '2014-02-15 00:55:25.000000', 'temperatura', 112.0000, 'ºC'),
	(207148, 121, '2014-02-15 00:55:26.000000', 'temperatura', 17.0000, 'ºC'),
	(207149, 121, '2014-02-15 00:55:27.000000', 'temperatura', 951.0000, 'ºC'),
	(207150, 121, '2014-02-15 00:55:28.000000', 'temperatura', 1105.0000, 'ºC'),
	(207151, 121, '2014-02-15 00:55:29.000000', 'temperatura', 271.0000, 'ºC'),
	(207152, 121, '2014-02-15 00:55:30.000000', 'temperatura', 439.0000, 'ºC'),
	(207153, 121, '2014-02-15 00:55:31.000000', 'temperatura', 185.0000, 'ºC'),
	(207154, 121, '2014-02-15 00:55:32.000000', 'temperatura', 808.0000, 'ºC'),
	(207155, 121, '2014-02-15 00:55:33.000000', 'temperatura', 1084.0000, 'ºC'),
	(207156, 121, '2014-02-15 00:55:34.000000', 'temperatura', 599.0000, 'ºC'),
	(207157, 121, '2014-02-15 00:55:35.000000', 'temperatura', 944.0000, 'ºC'),
	(207158, 121, '2014-02-15 00:55:36.000000', 'temperatura', 522.0000, 'ºC'),
	(207159, 121, '2014-02-15 00:55:37.000000', 'temperatura', 980.0000, 'ºC'),
	(207160, 121, '2014-02-15 00:55:38.000000', 'temperatura', 932.0000, 'ºC'),
	(207161, 121, '2014-02-15 00:55:39.000000', 'temperatura', 521.0000, 'ºC'),
	(207162, 121, '2014-02-15 00:55:40.000000', 'temperatura', 1012.0000, 'ºC'),
	(207163, 121, '2014-02-15 00:55:41.000000', 'temperatura', 1095.0000, 'ºC'),
	(207164, 121, '2014-02-15 00:55:42.000000', 'temperatura', 39.0000, 'ºC'),
	(207165, 121, '2014-02-15 00:55:43.000000', 'temperatura', 512.0000, 'ºC'),
	(207166, 121, '2014-02-15 00:55:44.000000', 'temperatura', 45.0000, 'ºC'),
	(207167, 121, '2014-02-15 00:55:45.000000', 'temperatura', 1088.0000, 'ºC'),
	(207168, 121, '2014-02-15 00:55:46.000000', 'temperatura', 504.0000, 'ºC'),
	(207169, 121, '2014-02-15 00:55:47.000000', 'temperatura', 456.0000, 'ºC'),
	(207170, 121, '2014-02-15 00:55:48.000000', 'temperatura', 771.0000, 'ºC'),
	(207171, 121, '2014-02-15 00:55:49.000000', 'temperatura', 85.0000, 'ºC'),
	(207172, 121, '2014-02-15 00:55:50.000000', 'temperatura', 514.0000, 'ºC'),
	(207173, 121, '2014-02-15 00:55:51.000000', 'temperatura', 1117.0000, 'ºC'),
	(207174, 121, '2014-02-15 00:55:52.000000', 'temperatura', 442.0000, 'ºC'),
	(207175, 121, '2014-02-15 00:55:53.000000', 'temperatura', 58.0000, 'ºC'),
	(207176, 121, '2014-02-15 00:55:54.000000', 'temperatura', 166.0000, 'ºC'),
	(207177, 121, '2014-02-15 00:55:55.000000', 'temperatura', 655.0000, 'ºC'),
	(207178, 121, '2014-02-15 00:55:56.000000', 'temperatura', 377.0000, 'ºC'),
	(207179, 121, '2014-02-15 00:55:57.000000', 'temperatura', 1120.0000, 'ºC'),
	(207180, 121, '2014-02-15 00:55:58.000000', 'temperatura', 871.0000, 'ºC'),
	(207181, 121, '2014-02-15 00:55:59.000000', 'temperatura', 997.0000, 'ºC'),
	(207182, 121, '2014-02-15 00:56:00.000000', 'temperatura', 1171.0000, 'ºC'),
	(207183, 121, '2014-02-15 00:56:01.000000', 'temperatura', 465.0000, 'ºC'),
	(207184, 121, '2014-02-15 00:56:02.000000', 'temperatura', 14.0000, 'ºC'),
	(207185, 121, '2014-02-15 00:56:03.000000', 'temperatura', 1075.0000, 'ºC'),
	(207186, 121, '2014-02-15 00:56:04.000000', 'temperatura', 535.0000, 'ºC'),
	(207187, 121, '2014-02-15 00:56:05.000000', 'temperatura', 648.0000, 'ºC'),
	(207188, 121, '2014-02-15 00:56:06.000000', 'temperatura', 436.0000, 'ºC'),
	(207189, 121, '2014-02-15 00:56:07.000000', 'temperatura', 237.0000, 'ºC'),
	(207190, 121, '2014-02-15 00:56:08.000000', 'temperatura', 1076.0000, 'ºC'),
	(207191, 121, '2014-02-15 00:56:09.000000', 'temperatura', 1072.0000, 'ºC'),
	(207192, 121, '2014-02-15 00:56:10.000000', 'temperatura', 931.0000, 'ºC'),
	(207193, 121, '2014-02-15 00:56:11.000000', 'temperatura', 239.0000, 'ºC'),
	(207194, 121, '2014-02-15 00:56:12.000000', 'temperatura', 801.0000, 'ºC'),
	(207195, 121, '2014-02-15 00:56:13.000000', 'temperatura', 890.0000, 'ºC'),
	(207196, 121, '2014-02-15 00:56:14.000000', 'temperatura', 846.0000, 'ºC'),
	(207197, 121, '2014-02-15 00:56:15.000000', 'temperatura', 363.0000, 'ºC'),
	(207198, 121, '2014-02-15 00:56:16.000000', 'temperatura', 477.0000, 'ºC'),
	(207199, 121, '2014-02-15 00:56:17.000000', 'temperatura', 98.0000, 'ºC'),
	(207200, 121, '2014-02-15 00:56:18.000000', 'temperatura', 258.0000, 'ºC'),
	(207201, 121, '2014-02-15 00:56:19.000000', 'temperatura', 995.0000, 'ºC'),
	(207202, 121, '2014-02-15 00:56:20.000000', 'temperatura', 601.0000, 'ºC'),
	(207203, 121, '2014-02-15 00:56:21.000000', 'temperatura', 20.0000, 'ºC'),
	(207204, 121, '2014-02-15 00:56:22.000000', 'temperatura', 698.0000, 'ºC'),
	(207205, 121, '2014-02-15 00:56:23.000000', 'temperatura', 1032.0000, 'ºC'),
	(207206, 121, '2014-02-15 00:56:24.000000', 'temperatura', 666.0000, 'ºC'),
	(207207, 121, '2014-02-15 00:56:25.000000', 'temperatura', 236.0000, 'ºC'),
	(207208, 121, '2014-02-15 00:56:26.000000', 'temperatura', 382.0000, 'ºC'),
	(207209, 121, '2014-02-15 00:56:27.000000', 'temperatura', 3.0000, 'ºC'),
	(207210, 121, '2014-02-15 00:56:28.000000', 'temperatura', 68.0000, 'ºC'),
	(207211, 121, '2014-02-15 00:56:29.000000', 'temperatura', 331.0000, 'ºC'),
	(207212, 121, '2014-02-15 00:56:30.000000', 'temperatura', 254.0000, 'ºC'),
	(207213, 121, '2014-02-15 00:56:31.000000', 'temperatura', 277.0000, 'ºC'),
	(207214, 121, '2014-02-15 00:56:32.000000', 'temperatura', 622.0000, 'ºC'),
	(207215, 121, '2014-02-15 00:56:33.000000', 'temperatura', 1081.0000, 'ºC'),
	(207216, 121, '2014-02-15 00:56:34.000000', 'temperatura', 1138.0000, 'ºC'),
	(207217, 121, '2014-02-15 00:56:35.000000', 'temperatura', 48.0000, 'ºC'),
	(207218, 121, '2014-02-15 00:56:36.000000', 'temperatura', 428.0000, 'ºC'),
	(207219, 121, '2014-02-15 00:56:37.000000', 'temperatura', 795.0000, 'ºC'),
	(207220, 121, '2014-02-15 00:56:38.000000', 'temperatura', 290.0000, 'ºC'),
	(207221, 121, '2014-02-15 00:56:39.000000', 'temperatura', 268.0000, 'ºC'),
	(207222, 121, '2014-02-15 00:56:40.000000', 'temperatura', 469.0000, 'ºC'),
	(207223, 121, '2014-02-15 00:56:41.000000', 'temperatura', 344.0000, 'ºC'),
	(207224, 121, '2014-02-15 00:56:42.000000', 'temperatura', 310.0000, 'ºC'),
	(207225, 121, '2014-02-15 00:56:43.000000', 'temperatura', 520.0000, 'ºC'),
	(207226, 121, '2014-02-15 00:56:44.000000', 'temperatura', 471.0000, 'ºC'),
	(207227, 121, '2014-02-15 00:56:45.000000', 'temperatura', 797.0000, 'ºC'),
	(207228, 121, '2014-02-15 00:56:46.000000', 'temperatura', 171.0000, 'ºC'),
	(207229, 121, '2014-02-15 00:56:47.000000', 'temperatura', 864.0000, 'ºC'),
	(207230, 121, '2014-02-15 00:56:48.000000', 'temperatura', 206.0000, 'ºC'),
	(207231, 121, '2014-02-15 00:56:49.000000', 'temperatura', 840.0000, 'ºC'),
	(207232, 121, '2014-02-15 00:56:50.000000', 'temperatura', 1184.0000, 'ºC'),
	(207233, 121, '2014-02-15 00:56:51.000000', 'temperatura', 999.0000, 'ºC'),
	(207234, 121, '2014-02-15 00:56:52.000000', 'temperatura', 244.0000, 'ºC'),
	(207235, 121, '2014-02-15 00:56:53.000000', 'temperatura', 621.0000, 'ºC'),
	(207236, 121, '2014-02-15 00:56:54.000000', 'temperatura', 1177.0000, 'ºC'),
	(207237, 121, '2014-02-15 00:56:55.000000', 'temperatura', 421.0000, 'ºC'),
	(207238, 121, '2014-02-15 00:56:56.000000', 'temperatura', 976.0000, 'ºC'),
	(207239, 121, '2014-02-15 00:56:57.000000', 'temperatura', 15.0000, 'ºC'),
	(207240, 121, '2014-02-15 00:56:58.000000', 'temperatura', 747.0000, 'ºC'),
	(207241, 121, '2014-02-15 00:56:59.000000', 'temperatura', 90.0000, 'ºC'),
	(207242, 121, '2014-02-15 00:57:00.000000', 'temperatura', 610.0000, 'ºC'),
	(207243, 121, '2014-02-15 00:57:01.000000', 'temperatura', 382.0000, 'ºC'),
	(207244, 121, '2014-02-15 00:57:02.000000', 'temperatura', 79.0000, 'ºC'),
	(207245, 121, '2014-02-15 00:57:03.000000', 'temperatura', 450.0000, 'ºC'),
	(207246, 121, '2014-02-15 00:57:04.000000', 'temperatura', 811.0000, 'ºC'),
	(207247, 121, '2014-02-15 00:57:05.000000', 'temperatura', 309.0000, 'ºC'),
	(207248, 121, '2014-02-15 00:57:06.000000', 'temperatura', 313.0000, 'ºC'),
	(207249, 121, '2014-02-15 00:57:07.000000', 'temperatura', 637.0000, 'ºC'),
	(207250, 121, '2014-02-15 00:57:08.000000', 'temperatura', 1046.0000, 'ºC'),
	(207251, 121, '2014-02-15 00:57:09.000000', 'temperatura', 918.0000, 'ºC'),
	(207252, 121, '2014-02-15 00:57:10.000000', 'temperatura', 256.0000, 'ºC'),
	(207253, 121, '2014-02-15 00:57:11.000000', 'temperatura', 923.0000, 'ºC'),
	(207254, 121, '2014-02-15 00:57:12.000000', 'temperatura', 250.0000, 'ºC'),
	(207255, 121, '2014-02-15 00:57:13.000000', 'temperatura', 883.0000, 'ºC'),
	(207256, 121, '2014-02-15 00:57:14.000000', 'temperatura', 62.0000, 'ºC'),
	(207257, 121, '2014-02-15 00:57:15.000000', 'temperatura', 64.0000, 'ºC'),
	(207258, 121, '2014-02-15 00:57:16.000000', 'temperatura', 133.0000, 'ºC'),
	(207259, 121, '2014-02-15 00:57:17.000000', 'temperatura', 474.0000, 'ºC'),
	(207260, 121, '2014-02-15 00:57:18.000000', 'temperatura', 772.0000, 'ºC'),
	(207261, 121, '2014-02-15 00:57:19.000000', 'temperatura', 38.0000, 'ºC'),
	(207262, 121, '2014-02-15 00:57:20.000000', 'temperatura', 276.0000, 'ºC'),
	(207263, 121, '2014-02-15 00:57:21.000000', 'temperatura', 64.0000, 'ºC'),
	(207264, 121, '2014-02-15 00:57:22.000000', 'temperatura', 696.0000, 'ºC'),
	(207265, 121, '2014-02-15 00:57:23.000000', 'temperatura', 885.0000, 'ºC'),
	(207266, 121, '2014-02-15 00:57:24.000000', 'temperatura', 1140.0000, 'ºC'),
	(207267, 121, '2014-02-15 00:57:25.000000', 'temperatura', 644.0000, 'ºC'),
	(207268, 121, '2014-02-15 00:57:26.000000', 'temperatura', 1001.0000, 'ºC'),
	(207269, 121, '2014-02-15 00:57:27.000000', 'temperatura', 673.0000, 'ºC'),
	(207270, 121, '2014-02-15 00:57:28.000000', 'temperatura', 363.0000, 'ºC'),
	(207271, 121, '2014-02-15 00:57:29.000000', 'temperatura', 997.0000, 'ºC'),
	(207272, 121, '2014-02-15 00:57:30.000000', 'temperatura', 298.0000, 'ºC'),
	(207273, 121, '2014-02-15 00:57:31.000000', 'temperatura', 898.0000, 'ºC'),
	(207274, 121, '2014-02-15 00:57:32.000000', 'temperatura', 1195.0000, 'ºC'),
	(207275, 121, '2014-02-15 00:57:33.000000', 'temperatura', 882.0000, 'ºC'),
	(207276, 121, '2014-02-15 00:57:34.000000', 'temperatura', 827.0000, 'ºC'),
	(207277, 121, '2014-02-15 00:57:35.000000', 'temperatura', 290.0000, 'ºC'),
	(207278, 121, '2014-02-15 00:57:36.000000', 'temperatura', 168.0000, 'ºC'),
	(207279, 121, '2014-02-15 00:57:37.000000', 'temperatura', 1170.0000, 'ºC'),
	(207280, 121, '2014-02-15 00:57:38.000000', 'temperatura', 548.0000, 'ºC'),
	(207281, 121, '2014-02-15 00:57:39.000000', 'temperatura', 430.0000, 'ºC'),
	(207282, 121, '2014-02-15 00:57:40.000000', 'temperatura', 505.0000, 'ºC'),
	(207283, 121, '2014-02-15 00:57:41.000000', 'temperatura', 38.0000, 'ºC'),
	(207284, 121, '2014-02-15 00:57:42.000000', 'temperatura', 1077.0000, 'ºC'),
	(207285, 121, '2014-02-15 00:57:43.000000', 'temperatura', 468.0000, 'ºC'),
	(207286, 121, '2014-02-15 00:57:44.000000', 'temperatura', 310.0000, 'ºC'),
	(207287, 121, '2014-02-15 00:57:45.000000', 'temperatura', 149.0000, 'ºC'),
	(207288, 121, '2014-02-15 00:57:46.000000', 'temperatura', 1014.0000, 'ºC'),
	(207289, 121, '2014-02-15 00:57:47.000000', 'temperatura', 1022.0000, 'ºC'),
	(207290, 121, '2014-02-15 00:57:48.000000', 'temperatura', 869.0000, 'ºC'),
	(207291, 121, '2014-02-15 00:57:49.000000', 'temperatura', 78.0000, 'ºC'),
	(207292, 121, '2014-02-15 00:57:50.000000', 'temperatura', 184.0000, 'ºC'),
	(207293, 121, '2014-02-15 00:57:51.000000', 'temperatura', 689.0000, 'ºC'),
	(207294, 121, '2014-02-15 00:57:52.000000', 'temperatura', 492.0000, 'ºC'),
	(207295, 121, '2014-02-15 00:57:53.000000', 'temperatura', 392.0000, 'ºC'),
	(207296, 121, '2014-02-15 00:57:54.000000', 'temperatura', 484.0000, 'ºC'),
	(207297, 121, '2014-02-15 00:57:55.000000', 'temperatura', 48.0000, 'ºC'),
	(207298, 121, '2014-02-15 00:57:56.000000', 'temperatura', 1186.0000, 'ºC'),
	(207299, 121, '2014-02-15 00:57:57.000000', 'temperatura', 986.0000, 'ºC'),
	(207300, 121, '2014-02-15 00:57:58.000000', 'temperatura', 174.0000, 'ºC'),
	(207301, 121, '2014-02-15 00:57:59.000000', 'temperatura', 312.0000, 'ºC'),
	(207302, 121, '2014-02-15 00:58:00.000000', 'temperatura', 1039.0000, 'ºC'),
	(207303, 121, '2014-02-15 00:58:01.000000', 'temperatura', 658.0000, 'ºC'),
	(207304, 121, '2014-02-15 00:58:02.000000', 'temperatura', 175.0000, 'ºC'),
	(207305, 121, '2014-02-15 00:58:03.000000', 'temperatura', 102.0000, 'ºC'),
	(207306, 121, '2014-02-15 00:58:04.000000', 'temperatura', 1186.0000, 'ºC'),
	(207307, 121, '2014-02-15 00:58:05.000000', 'temperatura', 824.0000, 'ºC'),
	(207308, 121, '2014-02-15 00:58:06.000000', 'temperatura', 561.0000, 'ºC'),
	(207309, 121, '2014-02-15 00:58:07.000000', 'temperatura', 336.0000, 'ºC'),
	(207310, 121, '2014-02-15 00:58:08.000000', 'temperatura', 1198.0000, 'ºC'),
	(207311, 121, '2014-02-15 00:58:09.000000', 'temperatura', 180.0000, 'ºC'),
	(207312, 121, '2014-02-15 00:58:10.000000', 'temperatura', 907.0000, 'ºC'),
	(207313, 121, '2014-02-15 00:58:11.000000', 'temperatura', 396.0000, 'ºC'),
	(207314, 121, '2014-02-15 00:58:12.000000', 'temperatura', 460.0000, 'ºC'),
	(207315, 121, '2014-02-15 00:58:13.000000', 'temperatura', 1112.0000, 'ºC'),
	(207316, 121, '2014-02-15 00:58:14.000000', 'temperatura', 582.0000, 'ºC'),
	(207317, 121, '2014-02-15 00:58:15.000000', 'temperatura', 775.0000, 'ºC'),
	(207318, 121, '2014-02-15 00:58:16.000000', 'temperatura', 927.0000, 'ºC'),
	(207319, 121, '2014-02-15 00:58:17.000000', 'temperatura', 1111.0000, 'ºC'),
	(207320, 121, '2014-02-15 00:58:18.000000', 'temperatura', 373.0000, 'ºC'),
	(207321, 121, '2014-02-15 00:58:19.000000', 'temperatura', 935.0000, 'ºC'),
	(207322, 121, '2014-02-15 00:58:20.000000', 'temperatura', 1154.0000, 'ºC'),
	(207323, 121, '2014-02-15 00:58:21.000000', 'temperatura', 568.0000, 'ºC'),
	(207324, 121, '2014-02-15 00:58:22.000000', 'temperatura', 578.0000, 'ºC'),
	(207325, 121, '2014-02-15 00:58:23.000000', 'temperatura', 1188.0000, 'ºC'),
	(207326, 121, '2014-02-15 00:58:24.000000', 'temperatura', 606.0000, 'ºC'),
	(207327, 121, '2014-02-15 00:58:25.000000', 'temperatura', 668.0000, 'ºC'),
	(207328, 121, '2014-02-15 00:58:26.000000', 'temperatura', 320.0000, 'ºC'),
	(207329, 121, '2014-02-15 00:58:27.000000', 'temperatura', 798.0000, 'ºC'),
	(207330, 121, '2014-02-15 00:58:28.000000', 'temperatura', 629.0000, 'ºC'),
	(207331, 121, '2014-02-15 00:58:29.000000', 'temperatura', 753.0000, 'ºC'),
	(207332, 121, '2014-02-15 00:58:30.000000', 'temperatura', 678.0000, 'ºC'),
	(207333, 121, '2014-02-15 00:58:31.000000', 'temperatura', 1132.0000, 'ºC'),
	(207334, 121, '2014-02-15 00:58:32.000000', 'temperatura', 26.0000, 'ºC'),
	(207335, 121, '2014-02-15 00:58:33.000000', 'temperatura', 335.0000, 'ºC'),
	(207336, 121, '2014-02-15 00:58:34.000000', 'temperatura', 396.0000, 'ºC'),
	(207337, 121, '2014-02-15 00:58:35.000000', 'temperatura', 978.0000, 'ºC'),
	(207338, 121, '2014-02-15 00:58:36.000000', 'temperatura', 101.0000, 'ºC'),
	(207339, 121, '2014-02-15 00:58:37.000000', 'temperatura', 1172.0000, 'ºC'),
	(207340, 121, '2014-02-15 00:58:38.000000', 'temperatura', 757.0000, 'ºC'),
	(207341, 121, '2014-02-15 00:58:39.000000', 'temperatura', 268.0000, 'ºC'),
	(207342, 121, '2014-02-15 00:58:40.000000', 'temperatura', 270.0000, 'ºC'),
	(207343, 121, '2014-02-15 00:58:41.000000', 'temperatura', 549.0000, 'ºC'),
	(207344, 121, '2014-02-15 00:58:42.000000', 'temperatura', 733.0000, 'ºC'),
	(207345, 121, '2014-02-15 00:58:43.000000', 'temperatura', 820.0000, 'ºC'),
	(207346, 121, '2014-02-15 00:58:44.000000', 'temperatura', 702.0000, 'ºC'),
	(207347, 121, '2014-02-15 00:58:45.000000', 'temperatura', 1048.0000, 'ºC'),
	(207348, 121, '2014-02-15 00:58:46.000000', 'temperatura', 737.0000, 'ºC'),
	(207349, 121, '2014-02-15 00:58:47.000000', 'temperatura', 542.0000, 'ºC'),
	(207350, 121, '2014-02-15 00:58:48.000000', 'temperatura', 498.0000, 'ºC'),
	(207351, 121, '2014-02-15 00:58:49.000000', 'temperatura', 863.0000, 'ºC'),
	(207352, 121, '2014-02-15 00:58:50.000000', 'temperatura', 424.0000, 'ºC'),
	(207353, 121, '2014-02-15 00:58:51.000000', 'temperatura', 730.0000, 'ºC'),
	(207354, 121, '2014-02-15 00:58:52.000000', 'temperatura', 1180.0000, 'ºC'),
	(207355, 121, '2014-02-15 00:58:53.000000', 'temperatura', 108.0000, 'ºC'),
	(207356, 121, '2014-02-15 00:58:54.000000', 'temperatura', 603.0000, 'ºC'),
	(207357, 121, '2014-02-15 00:58:55.000000', 'temperatura', 292.0000, 'ºC'),
	(207358, 121, '2014-02-15 00:58:56.000000', 'temperatura', 850.0000, 'ºC'),
	(207359, 121, '2014-02-15 00:58:57.000000', 'temperatura', 975.0000, 'ºC'),
	(207360, 121, '2014-02-15 00:58:58.000000', 'temperatura', 1126.0000, 'ºC'),
	(207361, 121, '2014-02-15 00:58:59.000000', 'temperatura', 304.0000, 'ºC'),
	(207362, 121, '2014-02-15 00:59:00.000000', 'temperatura', 542.0000, 'ºC'),
	(207363, 121, '2014-02-15 00:59:01.000000', 'temperatura', 598.0000, 'ºC'),
	(207364, 121, '2014-02-15 00:59:02.000000', 'temperatura', 163.0000, 'ºC'),
	(207365, 121, '2014-02-15 00:59:03.000000', 'temperatura', 225.0000, 'ºC'),
	(207366, 121, '2014-02-15 00:59:04.000000', 'temperatura', 634.0000, 'ºC'),
	(207367, 121, '2014-02-15 00:59:05.000000', 'temperatura', 96.0000, 'ºC'),
	(207368, 121, '2014-02-15 00:59:06.000000', 'temperatura', 977.0000, 'ºC'),
	(207369, 121, '2014-02-15 00:59:07.000000', 'temperatura', 1001.0000, 'ºC'),
	(207370, 121, '2014-02-15 00:59:08.000000', 'temperatura', 871.0000, 'ºC'),
	(207371, 121, '2014-02-15 00:59:09.000000', 'temperatura', 155.0000, 'ºC'),
	(207372, 121, '2014-02-15 00:59:10.000000', 'temperatura', 562.0000, 'ºC'),
	(207373, 121, '2014-02-15 00:59:11.000000', 'temperatura', 1146.0000, 'ºC'),
	(207374, 121, '2014-02-15 00:59:12.000000', 'temperatura', 443.0000, 'ºC'),
	(207375, 121, '2014-02-15 00:59:13.000000', 'temperatura', 1178.0000, 'ºC'),
	(207376, 121, '2014-02-15 00:59:14.000000', 'temperatura', 962.0000, 'ºC'),
	(207377, 121, '2014-02-15 00:59:15.000000', 'temperatura', 77.0000, 'ºC'),
	(207378, 121, '2014-02-15 00:59:16.000000', 'temperatura', 1098.0000, 'ºC'),
	(207379, 121, '2014-02-15 00:59:17.000000', 'temperatura', 461.0000, 'ºC'),
	(207380, 121, '2014-02-15 00:59:18.000000', 'temperatura', 210.0000, 'ºC'),
	(207381, 121, '2014-02-15 00:59:19.000000', 'temperatura', 867.0000, 'ºC'),
	(207382, 121, '2014-02-15 00:59:20.000000', 'temperatura', 107.0000, 'ºC'),
	(207383, 121, '2014-02-15 00:59:21.000000', 'temperatura', 335.0000, 'ºC'),
	(207384, 121, '2014-02-15 00:59:22.000000', 'temperatura', 154.0000, 'ºC'),
	(207385, 121, '2014-02-15 00:59:23.000000', 'temperatura', 967.0000, 'ºC'),
	(207386, 121, '2014-02-15 00:59:24.000000', 'temperatura', 771.0000, 'ºC'),
	(207387, 121, '2014-02-15 00:59:25.000000', 'temperatura', 954.0000, 'ºC'),
	(207388, 121, '2014-02-15 00:59:26.000000', 'temperatura', 59.0000, 'ºC'),
	(207389, 121, '2014-02-15 00:59:27.000000', 'temperatura', 1032.0000, 'ºC'),
	(207390, 121, '2014-02-15 00:59:28.000000', 'temperatura', 184.0000, 'ºC'),
	(207391, 121, '2014-02-15 00:59:29.000000', 'temperatura', 224.0000, 'ºC'),
	(207392, 121, '2014-02-15 00:59:30.000000', 'temperatura', 570.0000, 'ºC'),
	(207393, 121, '2014-02-15 00:59:31.000000', 'temperatura', 979.0000, 'ºC'),
	(207394, 121, '2014-02-15 00:59:32.000000', 'temperatura', 785.0000, 'ºC'),
	(207395, 121, '2014-02-15 00:59:33.000000', 'temperatura', 989.0000, 'ºC'),
	(207396, 121, '2014-02-15 00:59:34.000000', 'temperatura', 190.0000, 'ºC'),
	(207397, 121, '2014-02-15 00:59:35.000000', 'temperatura', 385.0000, 'ºC'),
	(207398, 121, '2014-02-15 00:59:36.000000', 'temperatura', 155.0000, 'ºC'),
	(207399, 121, '2014-02-15 00:59:37.000000', 'temperatura', 822.0000, 'ºC'),
	(207400, 121, '2014-02-15 00:59:38.000000', 'temperatura', 43.0000, 'ºC'),
	(207401, 121, '2014-02-15 00:59:39.000000', 'temperatura', 149.0000, 'ºC'),
	(207402, 121, '2014-02-15 00:59:40.000000', 'temperatura', 618.0000, 'ºC'),
	(207403, 121, '2014-02-15 00:59:41.000000', 'temperatura', 243.0000, 'ºC'),
	(207404, 121, '2014-02-15 00:59:42.000000', 'temperatura', 562.0000, 'ºC'),
	(207405, 121, '2014-02-15 00:59:43.000000', 'temperatura', 883.0000, 'ºC'),
	(207406, 121, '2014-02-15 00:59:44.000000', 'temperatura', 327.0000, 'ºC'),
	(207407, 121, '2014-02-15 00:59:45.000000', 'temperatura', 187.0000, 'ºC'),
	(207408, 121, '2014-02-15 00:59:46.000000', 'temperatura', 1155.0000, 'ºC'),
	(207409, 121, '2014-02-15 00:59:47.000000', 'temperatura', 413.0000, 'ºC'),
	(207410, 121, '2014-02-15 00:59:48.000000', 'temperatura', 1001.0000, 'ºC'),
	(207411, 121, '2014-02-15 00:59:49.000000', 'temperatura', 168.0000, 'ºC'),
	(207412, 121, '2014-02-15 00:59:50.000000', 'temperatura', 235.0000, 'ºC'),
	(207413, 121, '2014-02-15 00:59:51.000000', 'temperatura', 675.0000, 'ºC'),
	(207414, 121, '2014-02-15 00:59:52.000000', 'temperatura', 267.0000, 'ºC'),
	(207415, 121, '2014-02-15 00:59:53.000000', 'temperatura', 512.0000, 'ºC'),
	(207416, 121, '2014-02-15 00:59:54.000000', 'temperatura', 559.0000, 'ºC'),
	(207417, 121, '2014-02-15 00:59:55.000000', 'temperatura', 59.0000, 'ºC'),
	(207418, 121, '2014-02-15 00:59:56.000000', 'temperatura', 1018.0000, 'ºC'),
	(207419, 121, '2014-02-15 00:59:57.000000', 'temperatura', 114.0000, 'ºC'),
	(207420, 121, '2014-02-15 00:59:58.000000', 'temperatura', 1118.0000, 'ºC'),
	(207421, 121, '2014-02-15 00:59:59.000000', 'temperatura', 448.0000, 'ºC'),
	(207422, 121, '2014-02-15 01:00:00.000000', 'temperatura', 86.0000, 'ºC'),
	(207423, 121, '2014-02-15 01:00:01.000000', 'temperatura', 287.0000, 'ºC'),
	(207424, 121, '2014-02-15 01:00:02.000000', 'temperatura', 1178.0000, 'ºC'),
	(207425, 121, '2014-02-15 01:00:03.000000', 'temperatura', 229.0000, 'ºC'),
	(207426, 121, '2014-02-15 01:00:04.000000', 'temperatura', 10.0000, 'ºC'),
	(207427, 121, '2014-02-15 01:00:05.000000', 'temperatura', 563.0000, 'ºC'),
	(207428, 121, '2014-02-15 01:00:06.000000', 'temperatura', 386.0000, 'ºC'),
	(207429, 121, '2014-02-15 01:00:07.000000', 'temperatura', 243.0000, 'ºC'),
	(207430, 121, '2014-02-15 01:00:08.000000', 'temperatura', 58.0000, 'ºC'),
	(207431, 121, '2014-02-15 01:00:09.000000', 'temperatura', 762.0000, 'ºC'),
	(207432, 121, '2014-02-15 01:00:10.000000', 'temperatura', 37.0000, 'ºC'),
	(207433, 121, '2014-02-15 01:00:11.000000', 'temperatura', 300.0000, 'ºC'),
	(207434, 121, '2014-02-15 01:00:12.000000', 'temperatura', 188.0000, 'ºC'),
	(207435, 121, '2014-02-15 01:00:13.000000', 'temperatura', 42.0000, 'ºC'),
	(207436, 121, '2014-02-15 01:00:14.000000', 'temperatura', 846.0000, 'ºC'),
	(207437, 121, '2014-02-15 01:00:15.000000', 'temperatura', 502.0000, 'ºC'),
	(207438, 121, '2014-02-15 01:00:16.000000', 'temperatura', 1176.0000, 'ºC'),
	(207439, 121, '2014-02-15 01:00:17.000000', 'temperatura', 772.0000, 'ºC'),
	(207440, 121, '2014-02-15 01:00:18.000000', 'temperatura', 331.0000, 'ºC'),
	(207441, 121, '2014-02-15 01:00:19.000000', 'temperatura', 543.0000, 'ºC'),
	(207442, 121, '2014-02-15 01:00:20.000000', 'temperatura', 520.0000, 'ºC'),
	(207443, 121, '2014-02-15 01:00:21.000000', 'temperatura', 971.0000, 'ºC'),
	(207444, 121, '2014-02-15 01:00:22.000000', 'temperatura', 896.0000, 'ºC'),
	(207445, 121, '2014-02-15 01:00:23.000000', 'temperatura', 370.0000, 'ºC'),
	(207446, 121, '2014-02-15 01:00:24.000000', 'temperatura', 359.0000, 'ºC'),
	(207447, 121, '2014-02-15 01:00:25.000000', 'temperatura', 686.0000, 'ºC'),
	(207448, 121, '2014-02-15 01:00:26.000000', 'temperatura', 1156.0000, 'ºC'),
	(207449, 121, '2014-02-15 01:00:27.000000', 'temperatura', 121.0000, 'ºC'),
	(207450, 121, '2014-02-15 01:00:28.000000', 'temperatura', 738.0000, 'ºC'),
	(207451, 121, '2014-02-15 01:00:29.000000', 'temperatura', 926.0000, 'ºC'),
	(207452, 121, '2014-02-15 01:00:30.000000', 'temperatura', 15.0000, 'ºC'),
	(207453, 121, '2014-02-15 01:00:31.000000', 'temperatura', 900.0000, 'ºC'),
	(207454, 121, '2014-02-15 01:00:32.000000', 'temperatura', 856.0000, 'ºC'),
	(207455, 121, '2014-02-15 01:00:33.000000', 'temperatura', 379.0000, 'ºC'),
	(207456, 121, '2014-02-15 01:00:34.000000', 'temperatura', 527.0000, 'ºC'),
	(207457, 121, '2014-02-15 01:00:35.000000', 'temperatura', 297.0000, 'ºC'),
	(207458, 121, '2014-02-15 01:00:36.000000', 'temperatura', 1107.0000, 'ºC'),
	(207459, 121, '2014-02-15 01:00:37.000000', 'temperatura', 1043.0000, 'ºC'),
	(207460, 121, '2014-02-15 01:00:38.000000', 'temperatura', 696.0000, 'ºC'),
	(207461, 121, '2014-02-15 01:00:39.000000', 'temperatura', 349.0000, 'ºC'),
	(207462, 121, '2014-02-15 01:00:40.000000', 'temperatura', 859.0000, 'ºC'),
	(207463, 121, '2014-02-15 01:00:41.000000', 'temperatura', 849.0000, 'ºC'),
	(207464, 121, '2014-02-15 01:00:42.000000', 'temperatura', 468.0000, 'ºC'),
	(207465, 121, '2014-02-15 01:00:43.000000', 'temperatura', 995.0000, 'ºC'),
	(207466, 121, '2014-02-15 01:00:44.000000', 'temperatura', 1172.0000, 'ºC'),
	(207467, 121, '2014-02-15 01:00:45.000000', 'temperatura', 474.0000, 'ºC'),
	(207468, 121, '2014-02-15 01:00:46.000000', 'temperatura', 56.0000, 'ºC'),
	(207469, 121, '2014-02-15 01:00:47.000000', 'temperatura', 58.0000, 'ºC'),
	(207470, 121, '2014-02-15 01:00:48.000000', 'temperatura', 122.0000, 'ºC'),
	(207471, 121, '2014-02-15 01:00:49.000000', 'temperatura', 438.0000, 'ºC'),
	(207472, 121, '2014-02-15 01:00:50.000000', 'temperatura', 624.0000, 'ºC'),
	(207473, 121, '2014-02-15 01:00:51.000000', 'temperatura', 608.0000, 'ºC'),
	(207474, 121, '2014-02-15 01:00:52.000000', 'temperatura', 1166.0000, 'ºC'),
	(207475, 121, '2014-02-15 01:00:53.000000', 'temperatura', 406.0000, 'ºC'),
	(207476, 121, '2014-02-15 01:00:54.000000', 'temperatura', 934.0000, 'ºC'),
	(207477, 121, '2014-02-15 01:00:55.000000', 'temperatura', 1050.0000, 'ºC'),
	(207478, 121, '2014-02-15 01:00:56.000000', 'temperatura', 51.0000, 'ºC'),
	(207479, 121, '2014-02-15 01:00:57.000000', 'temperatura', 703.0000, 'ºC'),
	(207480, 121, '2014-02-15 01:00:58.000000', 'temperatura', 965.0000, 'ºC'),
	(207481, 121, '2014-02-15 01:00:59.000000', 'temperatura', 316.0000, 'ºC'),
	(207482, 121, '2014-02-15 01:01:00.000000', 'temperatura', 1084.0000, 'ºC'),
	(207483, 121, '2014-02-15 01:01:01.000000', 'temperatura', 874.0000, 'ºC'),
	(207484, 121, '2014-02-15 01:01:02.000000', 'temperatura', 1119.0000, 'ºC'),
	(207485, 121, '2014-02-15 01:01:03.000000', 'temperatura', 573.0000, 'ºC'),
	(207486, 121, '2014-02-15 01:01:04.000000', 'temperatura', 710.0000, 'ºC'),
	(207487, 121, '2014-02-15 01:01:05.000000', 'temperatura', 630.0000, 'ºC'),
	(207488, 121, '2014-02-15 01:01:06.000000', 'temperatura', 1022.0000, 'ºC'),
	(207489, 121, '2014-02-15 01:01:07.000000', 'temperatura', 818.0000, 'ºC'),
	(207490, 121, '2014-02-15 01:01:08.000000', 'temperatura', 1027.0000, 'ºC'),
	(207491, 121, '2014-02-15 01:01:09.000000', 'temperatura', 282.0000, 'ºC'),
	(207492, 121, '2014-02-15 01:01:10.000000', 'temperatura', 729.0000, 'ºC'),
	(207493, 121, '2014-02-15 01:01:11.000000', 'temperatura', 399.0000, 'ºC'),
	(207494, 121, '2014-02-15 01:01:12.000000', 'temperatura', 1010.0000, 'ºC'),
	(207495, 121, '2014-02-15 01:01:13.000000', 'temperatura', 252.0000, 'ºC'),
	(207496, 121, '2014-02-15 01:01:14.000000', 'temperatura', 631.0000, 'ºC'),
	(207497, 121, '2014-02-15 01:01:15.000000', 'temperatura', 0.0000, 'ºC'),
	(207498, 121, '2014-02-15 01:01:16.000000', 'temperatura', 507.0000, 'ºC'),
	(207499, 121, '2014-02-15 01:01:17.000000', 'temperatura', 136.0000, 'ºC'),
	(207500, 121, '2014-02-15 01:01:18.000000', 'temperatura', 358.0000, 'ºC'),
	(207501, 121, '2014-02-15 01:01:19.000000', 'temperatura', 182.0000, 'ºC'),
	(207502, 121, '2014-02-15 01:01:20.000000', 'temperatura', 1039.0000, 'ºC'),
	(207503, 121, '2014-02-15 01:01:21.000000', 'temperatura', 1049.0000, 'ºC'),
	(207504, 121, '2014-02-15 01:01:22.000000', 'temperatura', 929.0000, 'ºC'),
	(207505, 121, '2014-02-15 01:01:23.000000', 'temperatura', 298.0000, 'ºC'),
	(207506, 121, '2014-02-15 01:01:24.000000', 'temperatura', 1105.0000, 'ºC'),
	(207507, 121, '2014-02-15 01:01:25.000000', 'temperatura', 1032.0000, 'ºC'),
	(207508, 121, '2014-02-15 01:01:26.000000', 'temperatura', 646.0000, 'ºC'),
	(207509, 121, '2014-02-15 01:01:27.000000', 'temperatura', 132.0000, 'ºC'),
	(207510, 121, '2014-02-15 01:01:28.000000', 'temperatura', 1125.0000, 'ºC'),
	(207511, 121, '2014-02-15 01:01:29.000000', 'temperatura', 429.0000, 'ºC'),
	(207512, 121, '2014-02-15 01:01:30.000000', 'temperatura', 1171.0000, 'ºC'),
	(207513, 121, '2014-02-15 01:01:31.000000', 'temperatura', 969.0000, 'ºC'),
	(207514, 121, '2014-02-15 01:01:32.000000', 'temperatura', 131.0000, 'ºC'),
	(207515, 121, '2014-02-15 01:01:33.000000', 'temperatura', 151.0000, 'ºC'),
	(207516, 121, '2014-02-15 01:01:34.000000', 'temperatura', 362.0000, 'ºC'),
	(207517, 121, '2014-02-15 01:01:35.000000', 'temperatura', 155.0000, 'ºC'),
	(207518, 121, '2014-02-15 01:01:36.000000', 'temperatura', 890.0000, 'ºC'),
	(207519, 121, '2014-02-15 01:01:37.000000', 'temperatura', 388.0000, 'ºC'),
	(207520, 121, '2014-02-15 01:01:38.000000', 'temperatura', 470.0000, 'ºC'),
	(207521, 121, '2014-02-15 01:01:39.000000', 'temperatura', 1184.0000, 'ºC'),
	(207522, 121, '2014-02-15 01:01:40.000000', 'temperatura', 912.0000, 'ºC'),
	(207523, 121, '2014-02-15 01:01:41.000000', 'temperatura', 1008.0000, 'ºC'),
	(207524, 121, '2014-02-15 01:01:42.000000', 'temperatura', 1107.0000, 'ºC'),
	(207525, 121, '2014-02-15 01:01:43.000000', 'temperatura', 108.0000, 'ºC'),
	(207526, 121, '2014-02-15 01:01:44.000000', 'temperatura', 821.0000, 'ºC'),
	(207527, 121, '2014-02-15 01:01:45.000000', 'temperatura', 182.0000, 'ºC'),
	(207528, 121, '2014-02-15 01:01:46.000000', 'temperatura', 848.0000, 'ºC'),
	(207529, 121, '2014-02-15 01:01:47.000000', 'temperatura', 92.0000, 'ºC'),
	(207530, 121, '2014-02-15 01:01:48.000000', 'temperatura', 319.0000, 'ºC'),
	(207531, 121, '2014-02-15 01:01:49.000000', 'temperatura', 119.0000, 'ºC'),
	(207532, 121, '2014-02-15 01:01:50.000000', 'temperatura', 840.0000, 'ºC'),
	(207533, 121, '2014-02-15 01:01:51.000000', 'temperatura', 244.0000, 'ºC'),
	(207534, 121, '2014-02-15 01:01:52.000000', 'temperatura', 1098.0000, 'ºC'),
	(207535, 121, '2014-02-15 01:01:53.000000', 'temperatura', 1157.0000, 'ºC'),
	(207536, 121, '2014-02-15 01:01:54.000000', 'temperatura', 95.0000, 'ºC'),
	(207537, 121, '2014-02-15 01:01:55.000000', 'temperatura', 602.0000, 'ºC'),
	(207538, 121, '2014-02-15 01:01:56.000000', 'temperatura', 324.0000, 'ºC'),
	(207539, 121, '2014-02-15 01:01:57.000000', 'temperatura', 1017.0000, 'ºC'),
	(207540, 121, '2014-02-15 01:01:58.000000', 'temperatura', 514.0000, 'ºC'),
	(207541, 121, '2014-02-15 01:01:59.000000', 'temperatura', 719.0000, 'ºC'),
	(207542, 121, '2014-02-15 01:02:00.000000', 'temperatura', 851.0000, 'ºC'),
	(207543, 121, '2014-02-15 01:02:01.000000', 'temperatura', 901.0000, 'ºC'),
	(207544, 121, '2014-02-15 01:02:02.000000', 'temperatura', 753.0000, 'ºC'),
	(207545, 121, '2014-02-15 01:02:03.000000', 'temperatura', 1061.0000, 'ºC'),
	(207546, 121, '2014-02-15 01:02:04.000000', 'temperatura', 646.0000, 'ºC'),
	(207547, 121, '2014-02-15 01:02:05.000000', 'temperatura', 46.0000, 'ºC'),
	(207548, 121, '2014-02-15 01:02:06.000000', 'temperatura', 694.0000, 'ºC'),
	(207549, 121, '2014-02-15 01:02:07.000000', 'temperatura', 934.0000, 'ºC'),
	(207550, 121, '2014-02-15 01:02:08.000000', 'temperatura', 189.0000, 'ºC'),
	(207551, 121, '2014-02-15 01:02:09.000000', 'temperatura', 542.0000, 'ºC'),
	(207552, 121, '2014-02-15 01:02:10.000000', 'temperatura', 945.0000, 'ºC'),
	(207553, 121, '2014-02-15 01:02:11.000000', 'temperatura', 698.0000, 'ºC'),
	(207554, 121, '2014-02-15 01:02:12.000000', 'temperatura', 657.0000, 'ºC'),
	(207555, 121, '2014-02-15 01:02:13.000000', 'temperatura', 1189.0000, 'ºC'),
	(207556, 121, '2014-02-15 01:02:14.000000', 'temperatura', 378.0000, 'ºC'),
	(207557, 121, '2014-02-15 01:02:15.000000', 'temperatura', 720.0000, 'ºC'),
	(207558, 121, '2014-02-15 01:02:16.000000', 'temperatura', 69.0000, 'ºC'),
	(207559, 121, '2014-02-15 01:02:17.000000', 'temperatura', 583.0000, 'ºC'),
	(207560, 121, '2014-02-15 01:02:18.000000', 'temperatura', 309.0000, 'ºC'),
	(207561, 121, '2014-02-15 01:02:19.000000', 'temperatura', 995.0000, 'ºC'),
	(207562, 121, '2014-02-15 01:02:20.000000', 'temperatura', 449.0000, 'ºC'),
	(207563, 121, '2014-02-15 01:02:21.000000', 'temperatura', 462.0000, 'ºC'),
	(207564, 121, '2014-02-15 01:02:22.000000', 'temperatura', 964.0000, 'ºC'),
	(207565, 121, '2014-02-15 01:02:23.000000', 'temperatura', 1032.0000, 'ºC'),
	(207566, 121, '2014-02-15 01:02:24.000000', 'temperatura', 1069.0000, 'ºC'),
	(207567, 121, '2014-02-15 01:02:25.000000', 'temperatura', 1048.0000, 'ºC'),
	(207568, 121, '2014-02-15 01:02:26.000000', 'temperatura', 834.0000, 'ºC'),
	(207569, 121, '2014-02-15 01:02:27.000000', 'temperatura', 1028.0000, 'ºC'),
	(207570, 121, '2014-02-15 01:02:28.000000', 'temperatura', 239.0000, 'ºC'),
	(207571, 121, '2014-02-15 01:02:29.000000', 'temperatura', 512.0000, 'ºC'),
	(207572, 121, '2014-02-15 01:02:30.000000', 'temperatura', 644.0000, 'ºC'),
	(207573, 121, '2014-02-15 01:02:31.000000', 'temperatura', 482.0000, 'ºC'),
	(207574, 121, '2014-02-15 01:02:32.000000', 'temperatura', 479.0000, 'ºC'),
	(207575, 121, '2014-02-15 01:02:33.000000', 'temperatura', 949.0000, 'ºC'),
	(207576, 121, '2014-02-15 01:02:34.000000', 'temperatura', 909.0000, 'ºC'),
	(207577, 121, '2014-02-15 01:02:35.000000', 'temperatura', 499.0000, 'ºC'),
	(207578, 121, '2014-02-15 01:02:36.000000', 'temperatura', 969.0000, 'ºC'),
	(207579, 121, '2014-02-15 01:02:37.000000', 'temperatura', 946.0000, 'ºC'),
	(207580, 121, '2014-02-15 01:02:38.000000', 'temperatura', 627.0000, 'ºC'),
	(207581, 121, '2014-02-15 01:02:39.000000', 'temperatura', 295.0000, 'ºC'),
	(207582, 121, '2014-02-15 01:02:40.000000', 'temperatura', 795.0000, 'ºC'),
	(207583, 121, '2014-02-15 01:02:41.000000', 'temperatura', 690.0000, 'ºC'),
	(207584, 121, '2014-02-15 01:02:42.000000', 'temperatura', 1065.0000, 'ºC'),
	(207585, 121, '2014-02-15 01:02:43.000000', 'temperatura', 856.0000, 'ºC'),
	(207586, 121, '2014-02-15 01:02:44.000000', 'temperatura', 1086.0000, 'ºC'),
	(207587, 121, '2014-02-15 01:02:45.000000', 'temperatura', 462.0000, 'ºC'),
	(207588, 121, '2014-02-15 01:02:46.000000', 'temperatura', 253.0000, 'ºC'),
	(207589, 121, '2014-02-15 01:02:47.000000', 'temperatura', 1078.0000, 'ºC'),
	(207590, 121, '2014-02-15 01:02:48.000000', 'temperatura', 1032.0000, 'ºC'),
	(207591, 121, '2014-02-15 01:02:49.000000', 'temperatura', 727.0000, 'ºC'),
	(207592, 121, '2014-02-15 01:02:50.000000', 'temperatura', 538.0000, 'ºC'),
	(207593, 121, '2014-02-15 01:02:51.000000', 'temperatura', 510.0000, 'ºC'),
	(207594, 121, '2014-02-15 01:02:52.000000', 'temperatura', 938.0000, 'ºC'),
	(207595, 121, '2014-02-15 01:02:53.000000', 'temperatura', 759.0000, 'ºC'),
	(207596, 121, '2014-02-15 01:02:54.000000', 'temperatura', 980.0000, 'ºC'),
	(207597, 121, '2014-02-15 01:02:55.000000', 'temperatura', 227.0000, 'ºC'),
	(207598, 121, '2014-02-15 01:02:56.000000', 'temperatura', 594.0000, 'ºC'),
	(207599, 121, '2014-02-15 01:02:57.000000', 'temperatura', 1089.0000, 'ºC'),
	(207600, 121, '2014-02-15 01:02:58.000000', 'temperatura', 63.0000, 'ºC'),
	(207601, 121, '2014-02-15 01:02:59.000000', 'temperatura', 647.0000, 'ºC'),
	(207602, 121, '2014-02-15 01:03:00.000000', 'temperatura', 649.0000, 'ºC'),
	(207603, 121, '2014-02-15 01:03:01.000000', 'temperatura', 102.0000, 'ºC'),
	(207604, 121, '2014-02-15 01:03:02.000000', 'temperatura', 966.0000, 'ºC'),
	(207605, 121, '2014-02-15 01:03:03.000000', 'temperatura', 924.0000, 'ºC'),
	(207606, 121, '2014-02-15 01:03:04.000000', 'temperatura', 520.0000, 'ºC'),
	(207607, 121, '2014-02-15 01:03:05.000000', 'temperatura', 1031.0000, 'ºC'),
	(207608, 121, '2014-02-15 01:03:06.000000', 'temperatura', 1193.0000, 'ºC'),
	(207609, 121, '2014-02-15 01:03:07.000000', 'temperatura', 475.0000, 'ºC'),
	(207610, 121, '2014-02-15 01:03:08.000000', 'temperatura', 1195.0000, 'ºC'),
	(207611, 121, '2014-02-15 01:03:09.000000', 'temperatura', 953.0000, 'ºC'),
	(207612, 121, '2014-02-15 01:03:10.000000', 'temperatura', 1179.0000, 'ºC'),
	(207613, 121, '2014-02-15 01:03:11.000000', 'temperatura', 638.0000, 'ºC'),
	(207614, 121, '2014-02-15 01:03:12.000000', 'temperatura', 854.0000, 'ºC'),
	(207615, 121, '2014-02-15 01:03:13.000000', 'temperatura', 1157.0000, 'ºC'),
	(207616, 121, '2014-02-15 01:03:14.000000', 'temperatura', 822.0000, 'ºC'),
	(207617, 121, '2014-02-15 01:03:15.000000', 'temperatura', 640.0000, 'ºC'),
	(207618, 121, '2014-02-15 01:03:16.000000', 'temperatura', 735.0000, 'ºC'),
	(207619, 121, '2014-02-15 01:03:17.000000', 'temperatura', 553.0000, 'ºC'),
	(207620, 121, '2014-02-15 01:03:18.000000', 'temperatura', 562.0000, 'ºC'),
	(207621, 121, '2014-02-15 01:03:19.000000', 'temperatura', 1152.0000, 'ºC'),
	(207622, 121, '2014-02-15 01:03:20.000000', 'temperatura', 475.0000, 'ºC'),
	(207623, 121, '2014-02-15 01:03:21.000000', 'temperatura', 120.0000, 'ºC'),
	(207624, 121, '2014-02-15 01:03:22.000000', 'temperatura', 376.0000, 'ºC'),
	(207625, 121, '2014-02-15 01:03:23.000000', 'temperatura', 318.0000, 'ºC'),
	(207626, 121, '2014-02-15 01:03:24.000000', 'temperatura', 462.0000, 'ºC'),
	(207627, 121, '2014-02-15 01:03:25.000000', 'temperatura', 156.0000, 'ºC'),
	(207628, 121, '2014-02-15 01:03:26.000000', 'temperatura', 595.0000, 'ºC'),
	(207629, 121, '2014-02-15 01:03:27.000000', 'temperatura', 106.0000, 'ºC'),
	(207630, 121, '2014-02-15 01:03:28.000000', 'temperatura', 1149.0000, 'ºC'),
	(207631, 121, '2014-02-15 01:03:29.000000', 'temperatura', 624.0000, 'ºC'),
	(207632, 121, '2014-02-15 01:03:30.000000', 'temperatura', 875.0000, 'ºC'),
	(207633, 121, '2014-02-15 01:03:31.000000', 'temperatura', 104.0000, 'ºC'),
	(207634, 121, '2014-02-15 01:03:32.000000', 'temperatura', 297.0000, 'ºC'),
	(207635, 121, '2014-02-15 01:03:33.000000', 'temperatura', 1170.0000, 'ºC'),
	(207636, 121, '2014-02-15 01:03:34.000000', 'temperatura', 161.0000, 'ºC'),
	(207637, 121, '2014-02-15 01:03:35.000000', 'temperatura', 897.0000, 'ºC'),
	(207638, 121, '2014-02-15 01:03:36.000000', 'temperatura', 402.0000, 'ºC'),
	(207639, 121, '2014-02-15 01:03:37.000000', 'temperatura', 518.0000, 'ºC'),
	(207640, 121, '2014-02-15 01:03:38.000000', 'temperatura', 185.0000, 'ºC'),
	(207641, 121, '2014-02-15 01:03:39.000000', 'temperatura', 571.0000, 'ºC'),
	(207642, 121, '2014-02-15 01:03:40.000000', 'temperatura', 1102.0000, 'ºC'),
	(207643, 121, '2014-02-15 01:03:41.000000', 'temperatura', 196.0000, 'ºC'),
	(207644, 121, '2014-02-15 01:03:42.000000', 'temperatura', 74.0000, 'ºC'),
	(207645, 121, '2014-02-15 01:03:43.000000', 'temperatura', 984.0000, 'ºC'),
	(207646, 121, '2014-02-15 01:03:44.000000', 'temperatura', 1100.0000, 'ºC'),
	(207647, 121, '2014-02-15 01:03:45.000000', 'temperatura', 146.0000, 'ºC'),
	(207648, 121, '2014-02-15 01:03:46.000000', 'temperatura', 1030.0000, 'ºC'),
	(207649, 121, '2014-02-15 01:03:47.000000', 'temperatura', 1115.0000, 'ºC'),
	(207650, 121, '2014-02-15 01:03:48.000000', 'temperatura', 86.0000, 'ºC'),
	(207651, 121, '2014-02-15 01:03:49.000000', 'temperatura', 683.0000, 'ºC'),
	(207652, 121, '2014-02-15 01:03:50.000000', 'temperatura', 759.0000, 'ºC'),
	(207653, 121, '2014-02-15 01:03:51.000000', 'temperatura', 548.0000, 'ºC'),
	(207654, 121, '2014-02-15 01:03:52.000000', 'temperatura', 460.0000, 'ºC'),
	(207655, 121, '2014-02-15 01:03:53.000000', 'temperatura', 658.0000, 'ºC'),
	(207656, 121, '2014-02-15 01:03:54.000000', 'temperatura', 713.0000, 'ºC'),
	(207657, 121, '2014-02-15 01:03:55.000000', 'temperatura', 388.0000, 'ºC'),
	(207658, 121, '2014-02-15 01:03:56.000000', 'temperatura', 1002.0000, 'ºC'),
	(207659, 121, '2014-02-15 01:03:57.000000', 'temperatura', 247.0000, 'ºC'),
	(207660, 121, '2014-02-15 01:03:58.000000', 'temperatura', 629.0000, 'ºC'),
	(207661, 121, '2014-02-15 01:03:59.000000', 'temperatura', 3.0000, 'ºC'),
	(207662, 121, '2014-02-15 01:04:00.000000', 'temperatura', 531.0000, 'ºC'),
	(207663, 121, '2014-02-15 01:04:01.000000', 'temperatura', 247.0000, 'ºC'),
	(207664, 121, '2014-02-15 01:04:02.000000', 'temperatura', 840.0000, 'ºC'),
	(207665, 121, '2014-02-15 01:04:03.000000', 'temperatura', 1060.0000, 'ºC'),
	(207666, 121, '2014-02-15 01:04:04.000000', 'temperatura', 383.0000, 'ºC'),
	(207667, 121, '2014-02-15 01:04:05.000000', 'temperatura', 1133.0000, 'ºC'),
	(207668, 121, '2014-02-15 01:04:06.000000', 'temperatura', 916.0000, 'ºC'),
	(207669, 121, '2014-02-15 01:04:07.000000', 'temperatura', 1184.0000, 'ºC'),
	(207670, 121, '2014-02-15 01:04:08.000000', 'temperatura', 772.0000, 'ºC'),
	(207671, 121, '2014-02-15 01:04:09.000000', 'temperatura', 309.0000, 'ºC'),
	(207672, 121, '2014-02-15 01:04:10.000000', 'temperatura', 429.0000, 'ºC'),
	(207673, 121, '2014-02-15 01:04:11.000000', 'temperatura', 19.0000, 'ºC'),
	(207674, 121, '2014-02-15 01:04:12.000000', 'temperatura', 7.0000, 'ºC'),
	(207675, 121, '2014-02-15 01:04:13.000000', 'temperatura', 1180.0000, 'ºC'),
	(207676, 121, '2014-02-15 01:04:14.000000', 'temperatura', 1080.0000, 'ºC'),
	(207677, 121, '2014-02-15 01:04:15.000000', 'temperatura', 659.0000, 'ºC'),
	(207678, 121, '2014-02-15 01:04:16.000000', 'temperatura', 58.0000, 'ºC'),
	(207679, 121, '2014-02-15 01:04:17.000000', 'temperatura', 713.0000, 'ºC'),
	(207680, 121, '2014-02-15 01:04:18.000000', 'temperatura', 990.0000, 'ºC'),
	(207681, 121, '2014-02-15 01:04:19.000000', 'temperatura', 411.0000, 'ºC'),
	(207682, 121, '2014-02-15 01:04:20.000000', 'temperatura', 286.0000, 'ºC'),
	(207683, 121, '2014-02-15 01:04:21.000000', 'temperatura', 196.0000, 'ºC'),
	(207684, 121, '2014-02-15 01:04:22.000000', 'temperatura', 123.0000, 'ºC'),
	(207685, 121, '2014-02-15 01:04:23.000000', 'temperatura', 27.0000, 'ºC'),
	(207686, 121, '2014-02-15 01:04:24.000000', 'temperatura', 968.0000, 'ºC'),
	(207687, 121, '2014-02-15 01:04:25.000000', 'temperatura', 1158.0000, 'ºC'),
	(207688, 121, '2014-02-15 01:04:26.000000', 'temperatura', 489.0000, 'ºC'),
	(207689, 121, '2014-02-15 01:04:27.000000', 'temperatura', 169.0000, 'ºC'),
	(207690, 121, '2014-02-15 01:04:28.000000', 'temperatura', 579.0000, 'ºC'),
	(207691, 121, '2014-02-15 01:04:29.000000', 'temperatura', 1188.0000, 'ºC'),
	(207692, 121, '2014-02-15 01:04:30.000000', 'temperatura', 602.0000, 'ºC'),
	(207693, 121, '2014-02-15 01:04:31.000000', 'temperatura', 649.0000, 'ºC'),
	(207694, 121, '2014-02-15 01:04:32.000000', 'temperatura', 238.0000, 'ºC'),
	(207695, 121, '2014-02-15 01:04:33.000000', 'temperatura', 444.0000, 'ºC'),
	(207696, 121, '2014-02-15 01:04:34.000000', 'temperatura', 306.0000, 'ºC'),
	(207697, 121, '2014-02-15 01:04:35.000000', 'temperatura', 197.0000, 'ºC'),
	(207698, 121, '2014-02-15 01:04:36.000000', 'temperatura', 68.0000, 'ºC'),
	(207699, 121, '2014-02-15 01:04:37.000000', 'temperatura', 950.0000, 'ºC'),
	(207700, 121, '2014-02-15 01:04:38.000000', 'temperatura', 945.0000, 'ºC'),
	(207701, 121, '2014-02-15 01:04:39.000000', 'temperatura', 676.0000, 'ºC'),
	(207702, 121, '2014-02-15 01:04:40.000000', 'temperatura', 547.0000, 'ºC'),
	(207703, 121, '2014-02-15 01:04:41.000000', 'temperatura', 708.0000, 'ºC'),
	(207704, 121, '2014-02-15 01:04:42.000000', 'temperatura', 701.0000, 'ºC'),
	(207705, 121, '2014-02-15 01:04:43.000000', 'temperatura', 179.0000, 'ºC'),
	(207706, 121, '2014-02-15 01:04:44.000000', 'temperatura', 1192.0000, 'ºC'),
	(207707, 121, '2014-02-15 01:04:45.000000', 'temperatura', 626.0000, 'ºC'),
	(207708, 121, '2014-02-15 01:04:46.000000', 'temperatura', 753.0000, 'ºC'),
	(207709, 121, '2014-02-15 01:04:47.000000', 'temperatura', 686.0000, 'ºC'),
	(207710, 121, '2014-02-15 01:04:48.000000', 'temperatura', 1174.0000, 'ºC'),
	(207711, 121, '2014-02-15 01:04:49.000000', 'temperatura', 213.0000, 'ºC'),
	(207712, 121, '2014-02-15 01:04:50.000000', 'temperatura', 1143.0000, 'ºC'),
	(207713, 121, '2014-02-15 01:04:51.000000', 'temperatura', 278.0000, 'ºC'),
	(207714, 121, '2014-02-15 01:04:52.000000', 'temperatura', 359.0000, 'ºC'),
	(207715, 121, '2014-02-15 01:04:53.000000', 'temperatura', 963.0000, 'ºC'),
	(207716, 121, '2014-02-15 01:04:54.000000', 'temperatura', 137.0000, 'ºC'),
	(207717, 121, '2014-02-15 01:04:55.000000', 'temperatura', 197.0000, 'ºC'),
	(207718, 121, '2014-02-15 01:04:56.000000', 'temperatura', 573.0000, 'ºC'),
	(207719, 121, '2014-02-15 01:04:57.000000', 'temperatura', 1075.0000, 'ºC'),
	(207720, 121, '2014-02-15 01:04:58.000000', 'temperatura', 56.0000, 'ºC'),
	(207721, 121, '2014-02-15 01:04:59.000000', 'temperatura', 655.0000, 'ºC'),
	(207722, 121, '2014-02-15 01:05:00.000000', 'temperatura', 710.0000, 'ºC'),
	(207723, 121, '2014-02-15 01:05:01.000000', 'temperatura', 383.0000, 'ºC'),
	(207724, 121, '2014-02-15 01:05:02.000000', 'temperatura', 986.0000, 'ºC'),
	(207725, 121, '2014-02-15 01:05:03.000000', 'temperatura', 182.0000, 'ºC'),
	(207726, 121, '2014-02-15 01:05:04.000000', 'temperatura', 351.0000, 'ºC'),
	(207727, 121, '2014-02-15 01:05:05.000000', 'temperatura', 10.0000, 'ºC'),
	(207728, 121, '2014-02-15 01:05:06.000000', 'temperatura', 198.0000, 'ºC'),
	(207729, 121, '2014-02-15 01:05:07.000000', 'temperatura', 962.0000, 'ºC'),
	(207730, 121, '2014-02-15 01:05:08.000000', 'temperatura', 614.0000, 'ºC'),
	(207731, 121, '2014-02-15 01:05:09.000000', 'temperatura', 187.0000, 'ºC'),
	(207732, 121, '2014-02-15 01:05:10.000000', 'temperatura', 293.0000, 'ºC'),
	(207733, 121, '2014-02-15 01:05:11.000000', 'temperatura', 905.0000, 'ºC'),
	(207734, 121, '2014-02-15 01:05:12.000000', 'temperatura', 46.0000, 'ºC'),
	(207735, 121, '2014-02-15 01:05:13.000000', 'temperatura', 1114.0000, 'ºC'),
	(207736, 121, '2014-02-15 01:05:14.000000', 'temperatura', 635.0000, 'ºC'),
	(207737, 121, '2014-02-15 01:05:15.000000', 'temperatura', 1031.0000, 'ºC'),
	(207738, 121, '2014-02-15 01:05:16.000000', 'temperatura', 851.0000, 'ºC'),
	(207739, 121, '2014-02-15 01:05:17.000000', 'temperatura', 1162.0000, 'ºC'),
	(207740, 121, '2014-02-15 01:05:18.000000', 'temperatura', 856.0000, 'ºC'),
	(207741, 121, '2014-02-15 01:05:19.000000', 'temperatura', 798.0000, 'ºC'),
	(207742, 121, '2014-02-15 01:05:20.000000', 'temperatura', 221.0000, 'ºC'),
	(207743, 121, '2014-02-15 01:05:21.000000', 'temperatura', 1112.0000, 'ºC'),
	(207744, 121, '2014-02-15 01:05:22.000000', 'temperatura', 97.0000, 'ºC'),
	(207745, 121, '2014-02-15 01:05:23.000000', 'temperatura', 750.0000, 'ºC'),
	(207746, 121, '2014-02-15 01:05:24.000000', 'temperatura', 1061.0000, 'ºC'),
	(207747, 121, '2014-02-15 01:05:25.000000', 'temperatura', 656.0000, 'ºC'),
	(207748, 121, '2014-02-15 01:05:26.000000', 'temperatura', 95.0000, 'ºC'),
	(207749, 121, '2014-02-15 01:05:27.000000', 'temperatura', 907.0000, 'ºC'),
	(207750, 121, '2014-02-15 01:05:28.000000', 'temperatura', 650.0000, 'ºC'),
	(207751, 121, '2014-02-15 01:05:29.000000', 'temperatura', 530.0000, 'ºC'),
	(207752, 121, '2014-02-15 01:05:30.000000', 'temperatura', 702.0000, 'ºC'),
	(207753, 121, '2014-02-15 01:05:31.000000', 'temperatura', 719.0000, 'ºC'),
	(207754, 121, '2014-02-15 01:05:32.000000', 'temperatura', 289.0000, 'ºC'),
	(207755, 121, '2014-02-15 01:05:33.000000', 'temperatura', 490.0000, 'ºC'),
	(207756, 121, '2014-02-15 01:05:34.000000', 'temperatura', 382.0000, 'ºC'),
	(207757, 121, '2014-02-15 01:05:35.000000', 'temperatura', 442.0000, 'ºC'),
	(207758, 121, '2014-02-15 01:05:36.000000', 'temperatura', 1064.0000, 'ºC'),
	(207759, 121, '2014-02-15 01:05:37.000000', 'temperatura', 395.0000, 'ºC'),
	(207760, 121, '2014-02-15 01:05:38.000000', 'temperatura', 1181.0000, 'ºC'),
	(207761, 121, '2014-02-15 01:05:39.000000', 'temperatura', 1124.0000, 'ºC'),
	(207762, 121, '2014-02-15 01:05:40.000000', 'temperatura', 875.0000, 'ºC'),
	(207763, 121, '2014-02-15 01:05:41.000000', 'temperatura', 1002.0000, 'ºC'),
	(207764, 121, '2014-02-15 01:05:42.000000', 'temperatura', 1188.0000, 'ºC'),
	(207765, 121, '2014-02-15 01:05:43.000000', 'temperatura', 535.0000, 'ºC'),
	(207766, 121, '2014-02-15 01:05:44.000000', 'temperatura', 309.0000, 'ºC'),
	(207767, 121, '2014-02-15 01:05:45.000000', 'temperatura', 1143.0000, 'ºC'),
	(207768, 121, '2014-02-15 01:05:46.000000', 'temperatura', 1186.0000, 'ºC'),
	(207769, 121, '2014-02-15 01:05:47.000000', 'temperatura', 103.0000, 'ºC'),
	(207770, 121, '2014-02-15 01:05:48.000000', 'temperatura', 557.0000, 'ºC'),
	(207771, 121, '2014-02-15 01:05:49.000000', 'temperatura', 76.0000, 'ºC'),
	(207772, 121, '2014-02-15 01:05:50.000000', 'temperatura', 1110.0000, 'ºC'),
	(207773, 121, '2014-02-15 01:05:51.000000', 'temperatura', 520.0000, 'ºC'),
	(207774, 121, '2014-02-15 01:05:52.000000', 'temperatura', 474.0000, 'ºC'),
	(207775, 121, '2014-02-15 01:05:53.000000', 'temperatura', 810.0000, 'ºC'),
	(207776, 121, '2014-02-15 01:05:54.000000', 'temperatura', 227.0000, 'ºC'),
	(207777, 121, '2014-02-15 01:05:55.000000', 'temperatura', 1105.0000, 'ºC'),
	(207778, 121, '2014-02-15 01:05:56.000000', 'temperatura', 46.0000, 'ºC'),
	(207779, 121, '2014-02-15 01:05:57.000000', 'temperatura', 515.0000, 'ºC'),
	(207780, 121, '2014-02-15 01:05:58.000000', 'temperatura', 35.0000, 'ºC'),
	(207781, 121, '2014-02-15 01:05:59.000000', 'temperatura', 1034.0000, 'ºC'),
	(207782, 121, '2014-02-15 01:06:00.000000', 'temperatura', 264.0000, 'ºC'),
	(207783, 121, '2014-02-15 01:06:01.000000', 'temperatura', 619.0000, 'ºC'),
	(207784, 121, '2014-02-15 01:06:02.000000', 'temperatura', 1104.0000, 'ºC'),
	(207785, 121, '2014-02-15 01:06:03.000000', 'temperatura', 65.0000, 'ºC'),
	(207786, 121, '2014-02-15 01:06:04.000000', 'temperatura', 610.0000, 'ºC'),
	(207787, 121, '2014-02-15 01:06:05.000000', 'temperatura', 457.0000, 'ºC'),
	(207788, 121, '2014-02-15 01:06:06.000000', 'temperatura', 457.0000, 'ºC'),
	(207789, 121, '2014-02-15 01:06:07.000000', 'temperatura', 914.0000, 'ºC'),
	(207790, 121, '2014-02-15 01:06:08.000000', 'temperatura', 797.0000, 'ºC'),
	(207791, 121, '2014-02-15 01:06:09.000000', 'temperatura', 46.0000, 'ºC'),
	(207792, 121, '2014-02-15 01:06:10.000000', 'temperatura', 237.0000, 'ºC'),
	(207793, 122, '2014-02-15 00:00:00.000000', 'temperatura', 941.0000, 'ºC'),
	(207794, 122, '2014-02-15 00:00:01.000000', 'temperatura', 355.0000, 'ºC'),
	(207795, 122, '2014-02-15 00:00:02.000000', 'temperatura', 150.0000, 'ºC'),
	(207796, 122, '2014-02-15 00:00:03.000000', 'temperatura', 886.0000, 'ºC'),
	(207797, 122, '2014-02-15 00:00:04.000000', 'temperatura', 379.0000, 'ºC'),
	(207798, 122, '2014-02-15 00:00:05.000000', 'temperatura', 439.0000, 'ºC'),
	(207799, 122, '2014-02-15 00:00:06.000000', 'temperatura', 1059.0000, 'ºC'),
	(207800, 122, '2014-02-15 00:00:07.000000', 'temperatura', 378.0000, 'ºC'),
	(207801, 122, '2014-02-15 00:00:08.000000', 'temperatura', 1112.0000, 'ºC'),
	(207802, 122, '2014-02-15 00:00:09.000000', 'temperatura', 826.0000, 'ºC'),
	(207803, 122, '2014-02-15 00:00:10.000000', 'temperatura', 795.0000, 'ºC'),
	(207804, 122, '2014-02-15 00:00:11.000000', 'temperatura', 297.0000, 'ºC'),
	(207805, 122, '2014-02-15 00:00:12.000000', 'temperatura', 301.0000, 'ºC'),
	(207806, 122, '2014-02-15 00:00:13.000000', 'temperatura', 614.0000, 'ºC'),
	(207807, 122, '2014-02-15 00:00:14.000000', 'temperatura', 966.0000, 'ºC'),
	(207808, 122, '2014-02-15 00:00:15.000000', 'temperatura', 591.0000, 'ºC'),
	(207809, 122, '2014-02-15 00:00:16.000000', 'temperatura', 57.0000, 'ºC'),
	(207810, 122, '2014-02-15 00:00:17.000000', 'temperatura', 912.0000, 'ºC'),
	(207811, 122, '2014-02-15 00:00:18.000000', 'temperatura', 791.0000, 'ºC'),
	(207812, 122, '2014-02-15 00:00:19.000000', 'temperatura', 17.0000, 'ºC'),
	(207813, 122, '2014-02-15 00:00:20.000000', 'temperatura', 112.0000, 'ºC'),
	(207814, 122, '2014-02-15 00:00:21.000000', 'temperatura', 509.0000, 'ºC'),
	(207815, 122, '2014-02-15 00:00:22.000000', 'temperatura', 1012.0000, 'ºC'),
	(207816, 122, '2014-02-15 00:00:23.000000', 'temperatura', 1133.0000, 'ºC'),
	(207817, 122, '2014-02-15 00:00:24.000000', 'temperatura', 227.0000, 'ºC'),
	(207818, 122, '2014-02-15 00:00:25.000000', 'temperatura', 140.0000, 'ºC'),
	(207819, 122, '2014-02-15 00:00:26.000000', 'temperatura', 19.0000, 'ºC'),
	(207820, 122, '2014-02-15 00:00:27.000000', 'temperatura', 874.0000, 'ºC'),
	(207821, 122, '2014-02-15 00:00:28.000000', 'temperatura', 713.0000, 'ºC'),
	(207822, 122, '2014-02-15 00:00:29.000000', 'temperatura', 944.0000, 'ºC'),
	(207823, 122, '2014-02-15 00:00:30.000000', 'temperatura', 180.0000, 'ºC'),
	(207824, 122, '2014-02-15 00:00:31.000000', 'temperatura', 469.0000, 'ºC'),
	(207825, 122, '2014-02-15 00:00:32.000000', 'temperatura', 606.0000, 'ºC'),
	(207826, 122, '2014-02-15 00:00:33.000000', 'temperatura', 424.0000, 'ºC'),
	(207827, 122, '2014-02-15 00:00:34.000000', 'temperatura', 304.0000, 'ºC'),
	(207828, 122, '2014-02-15 00:00:35.000000', 'temperatura', 245.0000, 'ºC'),
	(207829, 122, '2014-02-15 00:00:36.000000', 'temperatura', 317.0000, 'ºC'),
	(207830, 122, '2014-02-15 00:00:37.000000', 'temperatura', 849.0000, 'ºC'),
	(207831, 122, '2014-02-15 00:00:38.000000', 'temperatura', 894.0000, 'ºC'),
	(207832, 122, '2014-02-15 00:00:39.000000', 'temperatura', 722.0000, 'ºC'),
	(207833, 122, '2014-02-15 00:00:40.000000', 'temperatura', 931.0000, 'ºC'),
	(207834, 122, '2014-02-15 00:00:41.000000', 'temperatura', 87.0000, 'ºC'),
	(207835, 122, '2014-02-15 00:00:42.000000', 'temperatura', 44.0000, 'ºC'),
	(207836, 122, '2014-02-15 00:00:43.000000', 'temperatura', 1159.0000, 'ºC'),
	(207837, 122, '2014-02-15 00:00:44.000000', 'temperatura', 863.0000, 'ºC'),
	(207838, 122, '2014-02-15 00:00:45.000000', 'temperatura', 839.0000, 'ºC'),
	(207839, 122, '2014-02-15 00:00:46.000000', 'temperatura', 408.0000, 'ºC'),
	(207840, 122, '2014-02-15 00:00:47.000000', 'temperatura', 723.0000, 'ºC'),
	(207841, 122, '2014-02-15 00:00:48.000000', 'temperatura', 1191.0000, 'ºC'),
	(207842, 122, '2014-02-15 00:00:49.000000', 'temperatura', 186.0000, 'ºC'),
	(207843, 122, '2014-02-15 00:00:50.000000', 'temperatura', 956.0000, 'ºC'),
	(207844, 122, '2014-02-15 00:00:51.000000', 'temperatura', 626.0000, 'ºC'),
	(207845, 122, '2014-02-15 00:00:52.000000', 'temperatura', 259.0000, 'ºC'),
	(207846, 122, '2014-02-15 00:00:53.000000', 'temperatura', 620.0000, 'ºC'),
	(207847, 122, '2014-02-15 00:00:54.000000', 'temperatura', 1122.0000, 'ºC'),
	(207848, 122, '2014-02-15 00:00:55.000000', 'temperatura', 149.0000, 'ºC'),
	(207849, 122, '2014-02-15 00:00:56.000000', 'temperatura', 981.0000, 'ºC'),
	(207850, 122, '2014-02-15 00:00:57.000000', 'temperatura', 858.0000, 'ºC'),
	(207851, 122, '2014-02-15 00:00:58.000000', 'temperatura', 147.0000, 'ºC'),
	(207852, 122, '2014-02-15 00:00:59.000000', 'temperatura', 563.0000, 'ºC'),
	(207853, 122, '2014-02-15 00:01:00.000000', 'temperatura', 1174.0000, 'ºC'),
	(207854, 122, '2014-02-15 00:01:01.000000', 'temperatura', 581.0000, 'ºC'),
	(207855, 122, '2014-02-15 00:01:02.000000', 'temperatura', 584.0000, 'ºC'),
	(207856, 122, '2014-02-15 00:01:03.000000', 'temperatura', 1177.0000, 'ºC'),
	(207857, 122, '2014-02-15 00:01:04.000000', 'temperatura', 533.0000, 'ºC'),
	(207858, 122, '2014-02-15 00:01:05.000000', 'temperatura', 334.0000, 'ºC'),
	(207859, 122, '2014-02-15 00:01:06.000000', 'temperatura', 72.0000, 'ºC'),
	(207860, 122, '2014-02-15 00:01:07.000000', 'temperatura', 558.0000, 'ºC'),
	(207861, 122, '2014-02-15 00:01:08.000000', 'temperatura', 174.0000, 'ºC'),
	(207862, 122, '2014-02-15 00:01:09.000000', 'temperatura', 399.0000, 'ºC'),
	(207863, 122, '2014-02-15 00:01:10.000000', 'temperatura', 272.0000, 'ºC'),
	(207864, 122, '2014-02-15 00:01:11.000000', 'temperatura', 164.0000, 'ºC'),
	(207865, 122, '2014-02-15 00:01:12.000000', 'temperatura', 4.0000, 'ºC'),
	(207866, 122, '2014-02-15 00:01:13.000000', 'temperatura', 730.0000, 'ºC'),
	(207867, 122, '2014-02-15 00:01:14.000000', 'temperatura', 37.0000, 'ºC'),
	(207868, 122, '2014-02-15 00:01:15.000000', 'temperatura', 395.0000, 'ºC'),
	(207869, 122, '2014-02-15 00:01:16.000000', 'temperatura', 667.0000, 'ºC'),
	(207870, 122, '2014-02-15 00:01:17.000000', 'temperatura', 949.0000, 'ºC'),
	(207871, 122, '2014-02-15 00:01:18.000000', 'temperatura', 343.0000, 'ºC'),
	(207872, 122, '2014-02-15 00:01:19.000000', 'temperatura', 68.0000, 'ºC'),
	(207873, 122, '2014-02-15 00:01:20.000000', 'temperatura', 511.0000, 'ºC'),
	(207874, 122, '2014-02-15 00:01:21.000000', 'temperatura', 1151.0000, 'ºC'),
	(207875, 122, '2014-02-15 00:01:22.000000', 'temperatura', 625.0000, 'ºC'),
	(207876, 122, '2014-02-15 00:01:23.000000', 'temperatura', 869.0000, 'ºC'),
	(207877, 122, '2014-02-15 00:01:24.000000', 'temperatura', 74.0000, 'ºC'),
	(207878, 122, '2014-02-15 00:01:25.000000', 'temperatura', 163.0000, 'ºC'),
	(207879, 122, '2014-02-15 00:01:26.000000', 'temperatura', 594.0000, 'ºC'),
	(207880, 122, '2014-02-15 00:01:27.000000', 'temperatura', 82.0000, 'ºC'),
	(207881, 122, '2014-02-15 00:01:28.000000', 'temperatura', 1029.0000, 'ºC'),
	(207882, 122, '2014-02-15 00:01:29.000000', 'temperatura', 97.0000, 'ºC'),
	(207883, 122, '2014-02-15 00:01:30.000000', 'temperatura', 999.0000, 'ºC'),
	(207884, 122, '2014-02-15 00:01:31.000000', 'temperatura', 1106.0000, 'ºC'),
	(207885, 122, '2014-02-15 00:01:32.000000', 'temperatura', 134.0000, 'ºC'),
	(207886, 122, '2014-02-15 00:01:33.000000', 'temperatura', 950.0000, 'ºC'),
	(207887, 122, '2014-02-15 00:01:34.000000', 'temperatura', 751.0000, 'ºC'),
	(207888, 122, '2014-02-15 00:01:35.000000', 'temperatura', 906.0000, 'ºC'),
	(207889, 122, '2014-02-15 00:01:36.000000', 'temperatura', 1075.0000, 'ºC'),
	(207890, 122, '2014-02-15 00:01:37.000000', 'temperatura', 257.0000, 'ºC'),
	(207891, 122, '2014-02-15 00:01:38.000000', 'temperatura', 460.0000, 'ºC'),
	(207892, 122, '2014-02-15 00:01:39.000000', 'temperatura', 332.0000, 'ºC'),
	(207893, 122, '2014-02-15 00:01:40.000000', 'temperatura', 280.0000, 'ºC'),
	(207894, 122, '2014-02-15 00:01:41.000000', 'temperatura', 405.0000, 'ºC'),
	(207895, 122, '2014-02-15 00:01:42.000000', 'temperatura', 1186.0000, 'ºC'),
	(207896, 122, '2014-02-15 00:01:43.000000', 'temperatura', 1113.0000, 'ºC'),
	(207897, 122, '2014-02-15 00:01:44.000000', 'temperatura', 808.0000, 'ºC'),
	(207898, 122, '2014-02-15 00:01:45.000000', 'temperatura', 701.0000, 'ºC'),
	(207899, 122, '2014-02-15 00:01:46.000000', 'temperatura', 1082.0000, 'ºC'),
	(207900, 122, '2014-02-15 00:01:47.000000', 'temperatura', 909.0000, 'ºC'),
	(207901, 122, '2014-02-15 00:01:48.000000', 'temperatura', 99.0000, 'ºC'),
	(207902, 122, '2014-02-15 00:01:49.000000', 'temperatura', 170.0000, 'ºC'),
	(207903, 122, '2014-02-15 00:01:50.000000', 'temperatura', 553.0000, 'ºC'),
	(207904, 122, '2014-02-15 00:01:51.000000', 'temperatura', 1055.0000, 'ºC'),
	(207905, 122, '2014-02-15 00:01:52.000000', 'temperatura', 18.0000, 'ºC'),
	(207906, 122, '2014-02-15 00:01:53.000000', 'temperatura', 525.0000, 'ºC'),
	(207907, 122, '2014-02-15 00:01:54.000000', 'temperatura', 173.0000, 'ºC'),
	(207908, 122, '2014-02-15 00:01:55.000000', 'temperatura', 489.0000, 'ºC'),
	(207909, 122, '2014-02-15 00:01:56.000000', 'temperatura', 725.0000, 'ºC'),
	(207910, 122, '2014-02-15 00:01:57.000000', 'temperatura', 959.0000, 'ºC'),
	(207911, 122, '2014-02-15 00:01:58.000000', 'temperatura', 222.0000, 'ºC'),
	(207912, 122, '2014-02-15 00:01:59.000000', 'temperatura', 633.0000, 'ºC'),
	(207913, 122, '2014-02-15 00:02:00.000000', 'temperatura', 100.0000, 'ºC'),
	(207914, 122, '2014-02-15 00:02:01.000000', 'temperatura', 1002.0000, 'ºC'),
	(207915, 122, '2014-02-15 00:02:02.000000', 'temperatura', 1109.0000, 'ºC'),
	(207916, 122, '2014-02-15 00:02:03.000000', 'temperatura', 139.0000, 'ºC'),
	(207917, 122, '2014-02-15 00:02:04.000000', 'temperatura', 970.0000, 'ºC'),
	(207918, 122, '2014-02-15 00:02:05.000000', 'temperatura', 833.0000, 'ºC'),
	(207919, 122, '2014-02-15 00:02:06.000000', 'temperatura', 56.0000, 'ºC'),
	(207920, 122, '2014-02-15 00:02:07.000000', 'temperatura', 179.0000, 'ºC'),
	(207921, 122, '2014-02-15 00:02:08.000000', 'temperatura', 730.0000, 'ºC'),
	(207922, 122, '2014-02-15 00:02:09.000000', 'temperatura', 715.0000, 'ºC'),
	(207923, 122, '2014-02-15 00:02:10.000000', 'temperatura', 182.0000, 'ºC'),
	(207924, 122, '2014-02-15 00:02:11.000000', 'temperatura', 1168.0000, 'ºC'),
	(207925, 122, '2014-02-15 00:02:12.000000', 'temperatura', 494.0000, 'ºC'),
	(207926, 122, '2014-02-15 00:02:13.000000', 'temperatura', 165.0000, 'ºC'),
	(207927, 122, '2014-02-15 00:02:14.000000', 'temperatura', 543.0000, 'ºC'),
	(207928, 122, '2014-02-15 00:02:15.000000', 'temperatura', 1023.0000, 'ºC'),
	(207929, 122, '2014-02-15 00:02:16.000000', 'temperatura', 1085.0000, 'ºC'),
	(207930, 122, '2014-02-15 00:02:17.000000', 'temperatura', 1155.0000, 'ºC'),
	(207931, 122, '2014-02-15 00:02:18.000000', 'temperatura', 123.0000, 'ºC'),
	(207932, 122, '2014-02-15 00:02:19.000000', 'temperatura', 749.0000, 'ºC'),
	(207933, 122, '2014-02-15 00:02:20.000000', 'temperatura', 977.0000, 'ºC'),
	(207934, 122, '2014-02-15 00:02:21.000000', 'temperatura', 237.0000, 'ºC'),
	(207935, 122, '2014-02-15 00:02:22.000000', 'temperatura', 654.0000, 'ºC'),
	(207936, 122, '2014-02-15 00:02:23.000000', 'temperatura', 159.0000, 'ºC'),
	(207937, 122, '2014-02-15 00:02:24.000000', 'temperatura', 34.0000, 'ºC'),
	(207938, 122, '2014-02-15 00:02:25.000000', 'temperatura', 895.0000, 'ºC'),
	(207939, 122, '2014-02-15 00:02:26.000000', 'temperatura', 771.0000, 'ºC'),
	(207940, 122, '2014-02-15 00:02:27.000000', 'temperatura', 1171.0000, 'ºC'),
	(207941, 122, '2014-02-15 00:02:28.000000', 'temperatura', 1143.0000, 'ºC'),
	(207942, 122, '2014-02-15 00:02:29.000000', 'temperatura', 1002.0000, 'ºC'),
	(207943, 122, '2014-02-15 00:02:30.000000', 'temperatura', 382.0000, 'ºC'),
	(207944, 122, '2014-02-15 00:02:31.000000', 'temperatura', 106.0000, 'ºC'),
	(207945, 122, '2014-02-15 00:02:32.000000', 'temperatura', 585.0000, 'ºC'),
	(207946, 122, '2014-02-15 00:02:33.000000', 'temperatura', 204.0000, 'ºC'),
	(207947, 122, '2014-02-15 00:02:34.000000', 'temperatura', 469.0000, 'ºC'),
	(207948, 122, '2014-02-15 00:02:35.000000', 'temperatura', 532.0000, 'ºC'),
	(207949, 122, '2014-02-15 00:02:36.000000', 'temperatura', 52.0000, 'ºC'),
	(207950, 122, '2014-02-15 00:02:37.000000', 'temperatura', 1066.0000, 'ºC'),
	(207951, 122, '2014-02-15 00:02:38.000000', 'temperatura', 374.0000, 'ºC'),
	(207952, 122, '2014-02-15 00:02:39.000000', 'temperatura', 1073.0000, 'ºC'),
	(207953, 122, '2014-02-15 00:02:40.000000', 'temperatura', 643.0000, 'ºC'),
	(207954, 122, '2014-02-15 00:02:41.000000', 'temperatura', 1196.0000, 'ºC'),
	(207955, 122, '2014-02-15 00:02:42.000000', 'temperatura', 453.0000, 'ºC'),
	(207956, 122, '2014-02-15 00:02:43.000000', 'temperatura', 1076.0000, 'ºC'),
	(207957, 122, '2014-02-15 00:02:44.000000', 'temperatura', 424.0000, 'ºC'),
	(207958, 122, '2014-02-15 00:02:45.000000', 'temperatura', 90.0000, 'ºC'),
	(207959, 122, '2014-02-15 00:02:46.000000', 'temperatura', 380.0000, 'ºC'),
	(207960, 122, '2014-02-15 00:02:47.000000', 'temperatura', 429.0000, 'ºC'),
	(207961, 122, '2014-02-15 00:02:48.000000', 'temperatura', 1006.0000, 'ºC'),
	(207962, 122, '2014-02-15 00:02:49.000000', 'temperatura', 145.0000, 'ºC'),
	(207963, 122, '2014-02-15 00:02:50.000000', 'temperatura', 105.0000, 'ºC'),
	(207964, 122, '2014-02-15 00:02:51.000000', 'temperatura', 90.0000, 'ºC'),
	(207965, 122, '2014-02-15 00:02:52.000000', 'temperatura', 137.0000, 'ºC'),
	(207966, 122, '2014-02-15 00:02:53.000000', 'temperatura', 415.0000, 'ºC'),
	(207967, 122, '2014-02-15 00:02:54.000000', 'temperatura', 464.0000, 'ºC'),
	(207968, 122, '2014-02-15 00:02:55.000000', 'temperatura', 1077.0000, 'ºC'),
	(207969, 122, '2014-02-15 00:02:56.000000', 'temperatura', 392.0000, 'ºC'),
	(207970, 122, '2014-02-15 00:02:57.000000', 'temperatura', 1131.0000, 'ºC'),
	(207971, 122, '2014-02-15 00:02:58.000000', 'temperatura', 877.0000, 'ºC'),
	(207972, 122, '2014-02-15 00:02:59.000000', 'temperatura', 995.0000, 'ºC'),
	(207973, 122, '2014-02-15 00:03:00.000000', 'temperatura', 1145.0000, 'ºC'),
	(207974, 122, '2014-02-15 00:03:01.000000', 'temperatura', 337.0000, 'ºC'),
	(207975, 122, '2014-02-15 00:03:02.000000', 'temperatura', 654.0000, 'ºC'),
	(207976, 122, '2014-02-15 00:03:03.000000', 'temperatura', 1059.0000, 'ºC'),
	(207977, 122, '2014-02-15 00:03:04.000000', 'temperatura', 933.0000, 'ºC'),
	(207978, 122, '2014-02-15 00:03:05.000000', 'temperatura', 290.0000, 'ºC'),
	(207979, 122, '2014-02-15 00:03:06.000000', 'temperatura', 1052.0000, 'ºC'),
	(207980, 122, '2014-02-15 00:03:07.000000', 'temperatura', 789.0000, 'ºC'),
	(207981, 122, '2014-02-15 00:03:08.000000', 'temperatura', 789.0000, 'ºC'),
	(207982, 122, '2014-02-15 00:03:09.000000', 'temperatura', 380.0000, 'ºC'),
	(207983, 122, '2014-02-15 00:03:10.000000', 'temperatura', 735.0000, 'ºC'),
	(207984, 122, '2014-02-15 00:03:11.000000', 'temperatura', 134.0000, 'ºC'),
	(207985, 122, '2014-02-15 00:03:12.000000', 'temperatura', 864.0000, 'ºC'),
	(207986, 122, '2014-02-15 00:03:13.000000', 'temperatura', 321.0000, 'ºC'),
	(207987, 122, '2014-02-15 00:03:14.000000', 'temperatura', 212.0000, 'ºC'),
	(207988, 122, '2014-02-15 00:03:15.000000', 'temperatura', 100.0000, 'ºC'),
	(207989, 122, '2014-02-15 00:03:16.000000', 'temperatura', 1061.0000, 'ºC'),
	(207990, 122, '2014-02-15 00:03:17.000000', 'temperatura', 207.0000, 'ºC'),
	(207991, 122, '2014-02-15 00:03:18.000000', 'temperatura', 253.0000, 'ºC'),
	(207992, 122, '2014-02-15 00:03:19.000000', 'temperatura', 646.0000, 'ºC'),
	(207993, 122, '2014-02-15 00:03:20.000000', 'temperatura', 71.0000, 'ºC'),
	(207994, 122, '2014-02-15 00:03:21.000000', 'temperatura', 816.0000, 'ºC'),
	(207995, 122, '2014-02-15 00:03:22.000000', 'temperatura', 266.0000, 'ºC'),
	(207996, 122, '2014-02-15 00:03:23.000000', 'temperatura', 86.0000, 'ºC'),
	(207997, 122, '2014-02-15 00:03:24.000000', 'temperatura', 829.0000, 'ºC'),
	(207998, 122, '2014-02-15 00:03:25.000000', 'temperatura', 291.0000, 'ºC'),
	(207999, 122, '2014-02-15 00:03:26.000000', 'temperatura', 167.0000, 'ºC'),
	(208000, 122, '2014-02-15 00:03:27.000000', 'temperatura', 1163.0000, 'ºC'),
	(208001, 122, '2014-02-15 00:03:28.000000', 'temperatura', 513.0000, 'ºC'),
	(208002, 122, '2014-02-15 00:03:29.000000', 'temperatura', 279.0000, 'ºC'),
	(208003, 122, '2014-02-15 00:03:30.000000', 'temperatura', 1056.0000, 'ºC'),
	(208004, 122, '2014-02-15 00:03:31.000000', 'temperatura', 844.0000, 'ºC'),
	(208005, 122, '2014-02-15 00:03:32.000000', 'temperatura', 1053.0000, 'ºC'),
	(208006, 122, '2014-02-15 00:03:33.000000', 'temperatura', 333.0000, 'ºC'),
	(208007, 122, '2014-02-15 00:03:34.000000', 'temperatura', 905.0000, 'ºC'),
	(208008, 122, '2014-02-15 00:03:35.000000', 'temperatura', 1126.0000, 'ºC'),
	(208009, 122, '2014-02-15 00:03:36.000000', 'temperatura', 519.0000, 'ºC'),
	(208010, 122, '2014-02-15 00:03:37.000000', 'temperatura', 414.0000, 'ºC'),
	(208011, 122, '2014-02-15 00:03:38.000000', 'temperatura', 513.0000, 'ºC'),
	(208012, 122, '2014-02-15 00:03:39.000000', 'temperatura', 126.0000, 'ºC'),
	(208013, 122, '2014-02-15 00:03:40.000000', 'temperatura', 291.0000, 'ºC'),
	(208014, 122, '2014-02-15 00:03:41.000000', 'temperatura', 1075.0000, 'ºC'),
	(208015, 122, '2014-02-15 00:03:42.000000', 'temperatura', 906.0000, 'ºC'),
	(208016, 122, '2014-02-15 00:03:43.000000', 'temperatura', 102.0000, 'ºC'),
	(208017, 122, '2014-02-15 00:03:44.000000', 'temperatura', 196.0000, 'ºC'),
	(208018, 122, '2014-02-15 00:03:45.000000', 'temperatura', 672.0000, 'ºC'),
	(208019, 122, '2014-02-15 00:03:46.000000', 'temperatura', 373.0000, 'ºC'),
	(208020, 122, '2014-02-15 00:03:47.000000', 'temperatura', 1048.0000, 'ºC'),
	(208021, 122, '2014-02-15 00:03:48.000000', 'temperatura', 522.0000, 'ºC'),
	(208022, 122, '2014-02-15 00:03:49.000000', 'temperatura', 667.0000, 'ºC'),
	(208023, 122, '2014-02-15 00:03:50.000000', 'temperatura', 569.0000, 'ºC'),
	(208024, 122, '2014-02-15 00:03:51.000000', 'temperatura', 845.0000, 'ºC'),
	(208025, 122, '2014-02-15 00:03:52.000000', 'temperatura', 119.0000, 'ºC'),
	(208026, 122, '2014-02-15 00:03:53.000000', 'temperatura', 461.0000, 'ºC'),
	(208027, 122, '2014-02-15 00:03:54.000000', 'temperatura', 748.0000, 'ºC'),
	(208028, 122, '2014-02-15 00:03:55.000000', 'temperatura', 1156.0000, 'ºC'),
	(208029, 122, '2014-02-15 00:03:56.000000', 'temperatura', 1137.0000, 'ºC'),
	(208030, 122, '2014-02-15 00:03:57.000000', 'temperatura', 1017.0000, 'ºC'),
	(208031, 122, '2014-02-15 00:03:58.000000', 'temperatura', 475.0000, 'ºC'),
	(208032, 122, '2014-02-15 00:03:59.000000', 'temperatura', 525.0000, 'ºC'),
	(208033, 122, '2014-02-15 00:04:00.000000', 'temperatura', 0.0000, 'ºC'),
	(208034, 122, '2014-02-15 00:04:01.000000', 'temperatura', 827.0000, 'ºC'),
	(208035, 122, '2014-02-15 00:04:02.000000', 'temperatura', 533.0000, 'ºC'),
	(208036, 122, '2014-02-15 00:04:03.000000', 'temperatura', 187.0000, 'ºC'),
	(208037, 122, '2014-02-15 00:04:04.000000', 'temperatura', 534.0000, 'ºC'),
	(208038, 122, '2014-02-15 00:04:05.000000', 'temperatura', 911.0000, 'ºC'),
	(208039, 122, '2014-02-15 00:04:06.000000', 'temperatura', 553.0000, 'ºC'),
	(208040, 122, '2014-02-15 00:04:07.000000', 'temperatura', 33.0000, 'ºC'),
	(208041, 122, '2014-02-15 00:04:08.000000', 'temperatura', 907.0000, 'ºC'),
	(208042, 122, '2014-02-15 00:04:09.000000', 'temperatura', 835.0000, 'ºC'),
	(208043, 122, '2014-02-15 00:04:10.000000', 'temperatura', 257.0000, 'ºC'),
	(208044, 122, '2014-02-15 00:04:11.000000', 'temperatura', 1178.0000, 'ºC'),
	(208045, 122, '2014-02-15 00:04:12.000000', 'temperatura', 320.0000, 'ºC'),
	(208046, 122, '2014-02-15 00:04:13.000000', 'temperatura', 465.0000, 'ºC'),
	(208047, 122, '2014-02-15 00:04:14.000000', 'temperatura', 168.0000, 'ºC'),
	(208048, 122, '2014-02-15 00:04:15.000000', 'temperatura', 646.0000, 'ºC'),
	(208049, 122, '2014-02-15 00:04:16.000000', 'temperatura', 327.0000, 'ºC'),
	(208050, 122, '2014-02-15 00:04:17.000000', 'temperatura', 898.0000, 'ºC'),
	(208051, 122, '2014-02-15 00:04:18.000000', 'temperatura', 1106.0000, 'ºC'),
	(208052, 122, '2014-02-15 00:04:19.000000', 'temperatura', 439.0000, 'ºC'),
	(208053, 122, '2014-02-15 00:04:20.000000', 'temperatura', 79.0000, 'ºC'),
	(208054, 122, '2014-02-15 00:04:21.000000', 'temperatura', 277.0000, 'ºC'),
	(208055, 122, '2014-02-15 00:04:22.000000', 'temperatura', 1147.0000, 'ºC'),
	(208056, 122, '2014-02-15 00:04:23.000000', 'temperatura', 104.0000, 'ºC'),
	(208057, 122, '2014-02-15 00:04:24.000000', 'temperatura', 679.0000, 'ºC'),
	(208058, 122, '2014-02-15 00:04:25.000000', 'temperatura', 685.0000, 'ºC'),
	(208059, 122, '2014-02-15 00:04:26.000000', 'temperatura', 187.0000, 'ºC'),
	(208060, 122, '2014-02-15 00:04:27.000000', 'temperatura', 81.0000, 'ºC'),
	(208061, 122, '2014-02-15 00:04:28.000000', 'temperatura', 1046.0000, 'ºC'),
	(208062, 122, '2014-02-15 00:04:29.000000', 'temperatura', 186.0000, 'ºC'),
	(208063, 122, '2014-02-15 00:04:30.000000', 'temperatura', 194.0000, 'ºC'),
	(208064, 122, '2014-02-15 00:04:31.000000', 'temperatura', 412.0000, 'ºC'),
	(208065, 122, '2014-02-15 00:04:32.000000', 'temperatura', 280.0000, 'ºC'),
	(208066, 122, '2014-02-15 00:04:33.000000', 'temperatura', 162.0000, 'ºC'),
	(208067, 122, '2014-02-15 00:04:34.000000', 'temperatura', 1170.0000, 'ºC'),
	(208068, 122, '2014-02-15 00:04:35.000000', 'temperatura', 563.0000, 'ºC'),
	(208069, 122, '2014-02-15 00:04:36.000000', 'temperatura', 509.0000, 'ºC'),
	(208070, 122, '2014-02-15 00:04:37.000000', 'temperatura', 855.0000, 'ºC'),
	(208071, 122, '2014-02-15 00:04:38.000000', 'temperatura', 349.0000, 'ºC'),
	(208072, 122, '2014-02-15 00:04:39.000000', 'temperatura', 378.0000, 'ºC'),
	(208073, 122, '2014-02-15 00:04:40.000000', 'temperatura', 847.0000, 'ºC'),
	(208074, 122, '2014-02-15 00:04:41.000000', 'temperatura', 700.0000, 'ºC'),
	(208075, 122, '2014-02-15 00:04:42.000000', 'temperatura', 958.0000, 'ºC'),
	(208076, 122, '2014-02-15 00:04:43.000000', 'temperatura', 291.0000, 'ºC'),
	(208077, 122, '2014-02-15 00:04:44.000000', 'temperatura', 982.0000, 'ºC'),
	(208078, 122, '2014-02-15 00:04:45.000000', 'temperatura', 437.0000, 'ºC'),
	(208079, 122, '2014-02-15 00:04:46.000000', 'temperatura', 440.0000, 'ºC'),
	(208080, 122, '2014-02-15 00:04:47.000000', 'temperatura', 889.0000, 'ºC'),
	(208081, 122, '2014-02-15 00:04:48.000000', 'temperatura', 724.0000, 'ºC'),
	(208082, 122, '2014-02-15 00:04:49.000000', 'temperatura', 956.0000, 'ºC'),
	(208083, 122, '2014-02-15 00:04:50.000000', 'temperatura', 207.0000, 'ºC'),
	(208084, 122, '2014-02-15 00:04:51.000000', 'temperatura', 567.0000, 'ºC'),
	(208085, 122, '2014-02-15 00:04:52.000000', 'temperatura', 1016.0000, 'ºC'),
	(208086, 122, '2014-02-15 00:04:53.000000', 'temperatura', 981.0000, 'ºC'),
	(208087, 122, '2014-02-15 00:04:54.000000', 'temperatura', 656.0000, 'ºC'),
	(208088, 122, '2014-02-15 00:04:55.000000', 'temperatura', 336.0000, 'ºC'),
	(208089, 122, '2014-02-15 00:04:56.000000', 'temperatura', 914.0000, 'ºC'),
	(208090, 122, '2014-02-15 00:04:57.000000', 'temperatura', 1162.0000, 'ºC'),
	(208091, 122, '2014-02-15 00:04:58.000000', 'temperatura', 669.0000, 'ºC'),
	(208092, 122, '2014-02-15 00:04:59.000000', 'temperatura', 1061.0000, 'ºC'),
	(208093, 122, '2014-02-15 00:05:00.000000', 'temperatura', 898.0000, 'ºC'),
	(208094, 122, '2014-02-15 00:05:01.000000', 'temperatura', 107.0000, 'ºC'),
	(208095, 122, '2014-02-15 00:05:02.000000', 'temperatura', 240.0000, 'ºC'),
	(208096, 122, '2014-02-15 00:05:03.000000', 'temperatura', 882.0000, 'ºC'),
	(208097, 122, '2014-02-15 00:05:04.000000', 'temperatura', 91.0000, 'ºC'),
	(208098, 122, '2014-02-15 00:05:05.000000', 'temperatura', 206.0000, 'ºC'),
	(208099, 122, '2014-02-15 00:05:06.000000', 'temperatura', 761.0000, 'ºC'),
	(208100, 122, '2014-02-15 00:05:07.000000', 'temperatura', 785.0000, 'ºC'),
	(208101, 122, '2014-02-15 00:05:08.000000', 'temperatura', 444.0000, 'ºC'),
	(208102, 122, '2014-02-15 00:05:09.000000', 'temperatura', 1067.0000, 'ºC'),
	(208103, 122, '2014-02-15 00:05:10.000000', 'temperatura', 400.0000, 'ºC'),
	(208104, 122, '2014-02-15 00:05:11.000000', 'temperatura', 2.0000, 'ºC'),
	(208105, 122, '2014-02-15 00:05:12.000000', 'temperatura', 9.0000, 'ºC'),
	(208106, 122, '2014-02-15 00:05:13.000000', 'temperatura', 38.0000, 'ºC'),
	(208107, 122, '2014-02-15 00:05:14.000000', 'temperatura', 165.0000, 'ºC'),
	(208108, 122, '2014-02-15 00:05:15.000000', 'temperatura', 710.0000, 'ºC'),
	(208109, 122, '2014-02-15 00:05:16.000000', 'temperatura', 657.0000, 'ºC'),
	(208110, 122, '2014-02-15 00:05:17.000000', 'temperatura', 1155.0000, 'ºC'),
	(208111, 122, '2014-02-15 00:05:18.000000', 'temperatura', 204.0000, 'ºC'),
	(208112, 122, '2014-02-15 00:05:19.000000', 'temperatura', 1155.0000, 'ºC'),
	(208113, 122, '2014-02-15 00:05:20.000000', 'temperatura', 364.0000, 'ºC'),
	(208114, 122, '2014-02-15 00:05:21.000000', 'temperatura', 754.0000, 'ºC'),
	(208115, 122, '2014-02-15 00:05:22.000000', 'temperatura', 278.0000, 'ºC'),
	(208116, 122, '2014-02-15 00:05:23.000000', 'temperatura', 331.0000, 'ºC'),
	(208117, 122, '2014-02-15 00:05:24.000000', 'temperatura', 821.0000, 'ºC'),
	(208118, 122, '2014-02-15 00:05:25.000000', 'temperatura', 712.0000, 'ºC'),
	(208119, 122, '2014-02-15 00:05:26.000000', 'temperatura', 1096.0000, 'ºC'),
	(208120, 122, '2014-02-15 00:05:27.000000', 'temperatura', 946.0000, 'ºC'),
	(208121, 122, '2014-02-15 00:05:28.000000', 'temperatura', 240.0000, 'ºC'),
	(208122, 122, '2014-02-15 00:05:29.000000', 'temperatura', 765.0000, 'ºC'),
	(208123, 122, '2014-02-15 00:05:30.000000', 'temperatura', 705.0000, 'ºC'),
	(208124, 122, '2014-02-15 00:05:31.000000', 'temperatura', 29.0000, 'ºC'),
	(208125, 122, '2014-02-15 00:05:32.000000', 'temperatura', 433.0000, 'ºC'),
	(208126, 122, '2014-02-15 00:05:33.000000', 'temperatura', 877.0000, 'ºC'),
	(208127, 122, '2014-02-15 00:05:34.000000', 'temperatura', 687.0000, 'ºC'),
	(208128, 122, '2014-02-15 00:05:35.000000', 'temperatura', 803.0000, 'ºC'),
	(208129, 122, '2014-02-15 00:05:36.000000', 'temperatura', 757.0000, 'ºC'),
	(208130, 122, '2014-02-15 00:05:37.000000', 'temperatura', 176.0000, 'ºC'),
	(208131, 122, '2014-02-15 00:05:38.000000', 'temperatura', 1009.0000, 'ºC'),
	(208132, 122, '2014-02-15 00:05:39.000000', 'temperatura', 919.0000, 'ºC'),
	(208133, 122, '2014-02-15 00:05:40.000000', 'temperatura', 366.0000, 'ºC'),
	(208134, 122, '2014-02-15 00:05:41.000000', 'temperatura', 275.0000, 'ºC'),
	(208135, 122, '2014-02-15 00:05:42.000000', 'temperatura', 278.0000, 'ºC'),
	(208136, 122, '2014-02-15 00:05:43.000000', 'temperatura', 563.0000, 'ºC'),
	(208137, 122, '2014-02-15 00:05:44.000000', 'temperatura', 782.0000, 'ºC'),
	(208138, 122, '2014-02-15 00:05:45.000000', 'temperatura', 1023.0000, 'ºC'),
	(208139, 122, '2014-02-15 00:05:46.000000', 'temperatura', 370.0000, 'ºC'),
	(208140, 122, '2014-02-15 00:05:47.000000', 'temperatura', 1182.0000, 'ºC'),
	(208141, 122, '2014-02-15 00:05:48.000000', 'temperatura', 1.0000, 'ºC'),
	(208142, 122, '2014-02-15 00:05:49.000000', 'temperatura', 61.0000, 'ºC'),
	(208143, 122, '2014-02-15 00:05:50.000000', 'temperatura', 299.0000, 'ºC'),
	(208144, 122, '2014-02-15 00:05:51.000000', 'temperatura', 114.0000, 'ºC'),
	(208145, 122, '2014-02-15 00:05:52.000000', 'temperatura', 875.0000, 'ºC'),
	(208146, 122, '2014-02-15 00:05:53.000000', 'temperatura', 432.0000, 'ºC'),
	(208147, 122, '2014-02-15 00:05:54.000000', 'temperatura', 737.0000, 'ºC'),
	(208148, 122, '2014-02-15 00:05:55.000000', 'temperatura', 1188.0000, 'ºC'),
	(208149, 122, '2014-02-15 00:05:56.000000', 'temperatura', 130.0000, 'ºC'),
	(208150, 122, '2014-02-15 00:05:57.000000', 'temperatura', 688.0000, 'ºC'),
	(208151, 122, '2014-02-15 00:05:58.000000', 'temperatura', 649.0000, 'ºC'),
	(208152, 122, '2014-02-15 00:05:59.000000', 'temperatura', 1181.0000, 'ºC'),
	(208153, 122, '2014-02-15 00:06:00.000000', 'temperatura', 360.0000, 'ºC'),
	(208154, 122, '2014-02-15 00:06:01.000000', 'temperatura', 655.0000, 'ºC'),
	(208155, 122, '2014-02-15 00:06:02.000000', 'temperatura', 996.0000, 'ºC'),
	(208156, 122, '2014-02-15 00:06:03.000000', 'temperatura', 618.0000, 'ºC'),
	(208157, 122, '2014-02-15 00:06:04.000000', 'temperatura', 101.0000, 'ºC'),
	(208158, 122, '2014-02-15 00:06:05.000000', 'temperatura', 1052.0000, 'ºC'),
	(208159, 122, '2014-02-15 00:06:06.000000', 'temperatura', 158.0000, 'ºC'),
	(208160, 122, '2014-02-15 00:06:07.000000', 'temperatura', 35.0000, 'ºC'),
	(208161, 122, '2014-02-15 00:06:08.000000', 'temperatura', 902.0000, 'ºC'),
	(208162, 122, '2014-02-15 00:06:09.000000', 'temperatura', 804.0000, 'ºC'),
	(208163, 122, '2014-02-15 00:06:10.000000', 'temperatura', 116.0000, 'ºC'),
	(208164, 122, '2014-02-15 00:06:11.000000', 'temperatura', 568.0000, 'ºC'),
	(208165, 122, '2014-02-15 00:06:12.000000', 'temperatura', 93.0000, 'ºC'),
	(208166, 122, '2014-02-15 00:06:13.000000', 'temperatura', 1162.0000, 'ºC'),
	(208167, 122, '2014-02-15 00:06:14.000000', 'temperatura', 732.0000, 'ºC'),
	(208168, 122, '2014-02-15 00:06:15.000000', 'temperatura', 175.0000, 'ºC'),
	(208169, 122, '2014-02-15 00:06:16.000000', 'temperatura', 1081.0000, 'ºC'),
	(208170, 122, '2014-02-15 00:06:17.000000', 'temperatura', 77.0000, 'ºC'),
	(208171, 122, '2014-02-15 00:06:18.000000', 'temperatura', 744.0000, 'ºC'),
	(208172, 122, '2014-02-15 00:06:19.000000', 'temperatura', 1090.0000, 'ºC'),
	(208173, 122, '2014-02-15 00:06:20.000000', 'temperatura', 819.0000, 'ºC'),
	(208174, 122, '2014-02-15 00:06:21.000000', 'temperatura', 826.0000, 'ºC'),
	(208175, 122, '2014-02-15 00:06:22.000000', 'temperatura', 472.0000, 'ºC'),
	(208176, 122, '2014-02-15 00:06:23.000000', 'temperatura', 1082.0000, 'ºC'),
	(208177, 122, '2014-02-15 00:06:24.000000', 'temperatura', 397.0000, 'ºC'),
	(208178, 122, '2014-02-15 00:06:25.000000', 'temperatura', 1138.0000, 'ºC'),
	(208179, 122, '2014-02-15 00:06:26.000000', 'temperatura', 900.0000, 'ºC'),
	(208180, 122, '2014-02-15 00:06:27.000000', 'temperatura', 1088.0000, 'ºC'),
	(208181, 122, '2014-02-15 00:06:28.000000', 'temperatura', 339.0000, 'ºC'),
	(208182, 122, '2014-02-15 00:06:29.000000', 'temperatura', 833.0000, 'ºC'),
	(208183, 122, '2014-02-15 00:06:30.000000', 'temperatura', 748.0000, 'ºC'),
	(208184, 122, '2014-02-15 00:06:31.000000', 'temperatura', 42.0000, 'ºC'),
	(208185, 122, '2014-02-15 00:06:32.000000', 'temperatura', 365.0000, 'ºC'),
	(208186, 122, '2014-02-15 00:06:33.000000', 'temperatura', 500.0000, 'ºC'),
	(208187, 122, '2014-02-15 00:06:34.000000', 'temperatura', 207.0000, 'ºC'),
	(208188, 122, '2014-02-15 00:06:35.000000', 'temperatura', 736.0000, 'ºC'),
	(208189, 122, '2014-02-15 00:06:36.000000', 'temperatura', 657.0000, 'ºC'),
	(208190, 122, '2014-02-15 00:06:37.000000', 'temperatura', 1079.0000, 'ºC'),
	(208191, 122, '2014-02-15 00:06:38.000000', 'temperatura', 1026.0000, 'ºC'),
	(208192, 122, '2014-02-15 00:06:39.000000', 'temperatura', 691.0000, 'ºC'),
	(208193, 122, '2014-02-15 00:06:40.000000', 'temperatura', 380.0000, 'ºC'),
	(208194, 122, '2014-02-15 00:06:41.000000', 'temperatura', 1028.0000, 'ºC'),
	(208195, 122, '2014-02-15 00:06:42.000000', 'temperatura', 399.0000, 'ºC'),
	(208196, 122, '2014-02-15 00:06:43.000000', 'temperatura', 112.0000, 'ºC'),
	(208197, 122, '2014-02-15 00:06:44.000000', 'temperatura', 562.0000, 'ºC'),
	(208198, 122, '2014-02-15 00:06:45.000000', 'temperatura', 73.0000, 'ºC'),
	(208199, 122, '2014-02-15 00:06:46.000000', 'temperatura', 1083.0000, 'ºC'),
	(208200, 122, '2014-02-15 00:06:47.000000', 'temperatura', 396.0000, 'ºC'),
	(208201, 122, '2014-02-15 00:06:48.000000', 'temperatura', 1131.0000, 'ºC'),
	(208202, 122, '2014-02-15 00:06:49.000000', 'temperatura', 866.0000, 'ºC'),
	(208203, 122, '2014-02-15 00:06:50.000000', 'temperatura', 940.0000, 'ºC'),
	(208204, 122, '2014-02-15 00:06:51.000000', 'temperatura', 902.0000, 'ºC'),
	(208205, 122, '2014-02-15 00:06:52.000000', 'temperatura', 490.0000, 'ºC'),
	(208206, 122, '2014-02-15 00:06:53.000000', 'temperatura', 947.0000, 'ºC'),
	(208207, 122, '2014-02-15 00:06:54.000000', 'temperatura', 862.0000, 'ºC'),
	(208208, 122, '2014-02-15 00:06:55.000000', 'temperatura', 271.0000, 'ºC'),
	(208209, 122, '2014-02-15 00:06:56.000000', 'temperatura', 1170.0000, 'ºC'),
	(208210, 122, '2014-02-15 00:06:57.000000', 'temperatura', 236.0000, 'ºC'),
	(208211, 122, '2014-02-15 00:06:58.000000', 'temperatura', 73.0000, 'ºC'),
	(208212, 122, '2014-02-15 00:06:59.000000', 'temperatura', 854.0000, 'ºC'),
	(208213, 122, '2014-02-15 00:07:00.000000', 'temperatura', 454.0000, 'ºC'),
	(208214, 122, '2014-02-15 00:07:01.000000', 'temperatura', 907.0000, 'ºC'),
	(208215, 122, '2014-02-15 00:07:02.000000', 'temperatura', 775.0000, 'ºC'),
	(208216, 122, '2014-02-15 00:07:03.000000', 'temperatura', 1155.0000, 'ºC'),
	(208217, 122, '2014-02-15 00:07:04.000000', 'temperatura', 1049.0000, 'ºC'),
	(208218, 122, '2014-02-15 00:07:05.000000', 'temperatura', 582.0000, 'ºC'),
	(208219, 122, '2014-02-15 00:07:06.000000', 'temperatura', 961.0000, 'ºC'),
	(208220, 122, '2014-02-15 00:07:07.000000', 'temperatura', 662.0000, 'ºC'),
	(208221, 122, '2014-02-15 00:07:08.000000', 'temperatura', 426.0000, 'ºC'),
	(208222, 122, '2014-02-15 00:07:09.000000', 'temperatura', 144.0000, 'ºC'),
	(208223, 122, '2014-02-15 00:07:10.000000', 'temperatura', 644.0000, 'ºC'),
	(208224, 122, '2014-02-15 00:07:11.000000', 'temperatura', 387.0000, 'ºC'),
	(208225, 122, '2014-02-15 00:07:12.000000', 'temperatura', 4.0000, 'ºC'),
	(208226, 122, '2014-02-15 00:07:13.000000', 'temperatura', 60.0000, 'ºC'),
	(208227, 122, '2014-02-15 00:07:14.000000', 'temperatura', 287.0000, 'ºC'),
	(208228, 122, '2014-02-15 00:07:15.000000', 'temperatura', 54.0000, 'ºC'),
	(208229, 122, '2014-02-15 00:07:16.000000', 'temperatura', 613.0000, 'ºC'),
	(208230, 122, '2014-02-15 00:07:17.000000', 'temperatura', 502.0000, 'ºC'),
	(208231, 122, '2014-02-15 00:07:18.000000', 'temperatura', 670.0000, 'ºC'),
	(208232, 122, '2014-02-15 00:07:19.000000', 'temperatura', 648.0000, 'ºC'),
	(208233, 122, '2014-02-15 00:07:20.000000', 'temperatura', 27.0000, 'ºC'),
	(208234, 122, '2014-02-15 00:07:21.000000', 'temperatura', 595.0000, 'ºC'),
	(208235, 122, '2014-02-15 00:07:22.000000', 'temperatura', 492.0000, 'ºC'),
	(208236, 122, '2014-02-15 00:07:23.000000', 'temperatura', 676.0000, 'ºC'),
	(208237, 122, '2014-02-15 00:07:24.000000', 'temperatura', 705.0000, 'ºC'),
	(208238, 122, '2014-02-15 00:07:25.000000', 'temperatura', 297.0000, 'ºC'),
	(208239, 122, '2014-02-15 00:07:26.000000', 'temperatura', 572.0000, 'ºC'),
	(208240, 122, '2014-02-15 00:07:27.000000', 'temperatura', 770.0000, 'ºC'),
	(208241, 122, '2014-02-15 00:07:28.000000', 'temperatura', 931.0000, 'ºC'),
	(208242, 122, '2014-02-15 00:07:29.000000', 'temperatura', 1149.0000, 'ºC'),
	(208243, 122, '2014-02-15 00:07:30.000000', 'temperatura', 550.0000, 'ºC'),
	(208244, 122, '2014-02-15 00:07:31.000000', 'temperatura', 506.0000, 'ºC'),
	(208245, 122, '2014-02-15 00:07:32.000000', 'temperatura', 880.0000, 'ºC'),
	(208246, 122, '2014-02-15 00:07:33.000000', 'temperatura', 481.0000, 'ºC'),
	(208247, 122, '2014-02-15 00:07:34.000000', 'temperatura', 968.0000, 'ºC'),
	(208248, 122, '2014-02-15 00:07:35.000000', 'temperatura', 998.0000, 'ºC'),
	(208249, 122, '2014-02-15 00:07:36.000000', 'temperatura', 883.0000, 'ºC'),
	(208250, 122, '2014-02-15 00:07:37.000000', 'temperatura', 225.0000, 'ºC'),
	(208251, 122, '2014-02-15 00:07:38.000000', 'temperatura', 874.0000, 'ºC'),
	(208252, 122, '2014-02-15 00:07:39.000000', 'temperatura', 96.0000, 'ºC'),
	(208253, 122, '2014-02-15 00:07:40.000000', 'temperatura', 257.0000, 'ºC'),
	(208254, 122, '2014-02-15 00:07:41.000000', 'temperatura', 1001.0000, 'ºC'),
	(208255, 122, '2014-02-15 00:07:42.000000', 'temperatura', 632.0000, 'ºC'),
	(208256, 122, '2014-02-15 00:07:43.000000', 'temperatura', 159.0000, 'ºC'),
	(208257, 122, '2014-02-15 00:07:44.000000', 'temperatura', 100.0000, 'ºC'),
	(208258, 122, '2014-02-15 00:07:45.000000', 'temperatura', 21.0000, 'ºC'),
	(208259, 122, '2014-02-15 00:07:46.000000', 'temperatura', 1008.0000, 'ºC'),
	(208260, 122, '2014-02-15 00:07:47.000000', 'temperatura', 176.0000, 'ºC'),
	(208261, 122, '2014-02-15 00:07:48.000000', 'temperatura', 257.0000, 'ºC'),
	(208262, 122, '2014-02-15 00:07:49.000000', 'temperatura', 759.0000, 'ºC'),
	(208263, 122, '2014-02-15 00:07:50.000000', 'temperatura', 622.0000, 'ºC'),
	(208264, 122, '2014-02-15 00:07:51.000000', 'temperatura', 833.0000, 'ºC'),
	(208265, 122, '2014-02-15 00:07:52.000000', 'temperatura', 1100.0000, 'ºC'),
	(208266, 122, '2014-02-15 00:07:53.000000', 'temperatura', 604.0000, 'ºC'),
	(208267, 122, '2014-02-15 00:07:54.000000', 'temperatura', 918.0000, 'ºC'),
	(208268, 122, '2014-02-15 00:07:55.000000', 'temperatura', 379.0000, 'ºC'),
	(208269, 122, '2014-02-15 00:07:56.000000', 'temperatura', 343.0000, 'ºC'),
	(208270, 122, '2014-02-15 00:07:57.000000', 'temperatura', 576.0000, 'ºC'),
	(208271, 122, '2014-02-15 00:07:58.000000', 'temperatura', 652.0000, 'ºC'),
	(208272, 122, '2014-02-15 00:07:59.000000', 'temperatura', 334.0000, 'ºC'),
	(208273, 122, '2014-02-15 00:08:00.000000', 'temperatura', 915.0000, 'ºC'),
	(208274, 122, '2014-02-15 00:08:01.000000', 'temperatura', 1174.0000, 'ºC'),
	(208275, 122, '2014-02-15 00:08:02.000000', 'temperatura', 726.0000, 'ºC'),
	(208276, 122, '2014-02-15 00:08:03.000000', 'temperatura', 108.0000, 'ºC'),
	(208277, 122, '2014-02-15 00:08:04.000000', 'temperatura', 764.0000, 'ºC'),
	(208278, 122, '2014-02-15 00:08:05.000000', 'temperatura', 1095.0000, 'ºC'),
	(208279, 122, '2014-02-15 00:08:06.000000', 'temperatura', 785.0000, 'ºC'),
	(208280, 122, '2014-02-15 00:08:07.000000', 'temperatura', 638.0000, 'ºC'),
	(208281, 122, '2014-02-15 00:08:08.000000', 'temperatura', 838.0000, 'ºC'),
	(208282, 122, '2014-02-15 00:08:09.000000', 'temperatura', 1076.0000, 'ºC'),
	(208283, 122, '2014-02-15 00:08:10.000000', 'temperatura', 468.0000, 'ºC'),
	(208284, 122, '2014-02-15 00:08:11.000000', 'temperatura', 311.0000, 'ºC'),
	(208285, 122, '2014-02-15 00:08:12.000000', 'temperatura', 152.0000, 'ºC'),
	(208286, 122, '2014-02-15 00:08:13.000000', 'temperatura', 1025.0000, 'ºC'),
	(208287, 122, '2014-02-15 00:08:14.000000', 'temperatura', 1073.0000, 'ºC'),
	(208288, 122, '2014-02-15 00:08:15.000000', 'temperatura', 1088.0000, 'ºC'),
	(208289, 122, '2014-02-15 00:08:16.000000', 'temperatura', 1023.0000, 'ºC'),
	(208290, 122, '2014-02-15 00:08:17.000000', 'temperatura', 651.0000, 'ºC'),
	(208291, 122, '2014-02-15 00:08:18.000000', 'temperatura', 187.0000, 'ºC'),
	(208292, 122, '2014-02-15 00:08:19.000000', 'temperatura', 180.0000, 'ºC'),
	(208293, 122, '2014-02-15 00:08:20.000000', 'temperatura', 342.0000, 'ºC'),
	(208294, 122, '2014-02-15 00:08:21.000000', 'temperatura', 1169.0000, 'ºC'),
	(208295, 122, '2014-02-15 00:08:22.000000', 'temperatura', 18.0000, 'ºC'),
	(208296, 122, '2014-02-15 00:08:23.000000', 'temperatura', 187.0000, 'ºC'),
	(208297, 122, '2014-02-15 00:08:24.000000', 'temperatura', 879.0000, 'ºC'),
	(208298, 122, '2014-02-15 00:08:25.000000', 'temperatura', 235.0000, 'ºC'),
	(208299, 122, '2014-02-15 00:08:26.000000', 'temperatura', 938.0000, 'ºC'),
	(208300, 122, '2014-02-15 00:08:27.000000', 'temperatura', 385.0000, 'ºC'),
	(208301, 122, '2014-02-15 00:08:28.000000', 'temperatura', 311.0000, 'ºC'),
	(208302, 122, '2014-02-15 00:08:29.000000', 'temperatura', 401.0000, 'ºC'),
	(208303, 122, '2014-02-15 00:08:30.000000', 'temperatura', 1073.0000, 'ºC'),
	(208304, 122, '2014-02-15 00:08:31.000000', 'temperatura', 563.0000, 'ºC'),
	(208305, 122, '2014-02-15 00:08:32.000000', 'temperatura', 795.0000, 'ºC'),
	(208306, 122, '2014-02-15 00:08:33.000000', 'temperatura', 1087.0000, 'ºC'),
	(208307, 122, '2014-02-15 00:08:34.000000', 'temperatura', 651.0000, 'ºC'),
	(208308, 122, '2014-02-15 00:08:35.000000', 'temperatura', 1194.0000, 'ºC'),
	(208309, 122, '2014-02-15 00:08:36.000000', 'temperatura', 417.0000, 'ºC'),
	(208310, 122, '2014-02-15 00:08:37.000000', 'temperatura', 902.0000, 'ºC'),
	(208311, 122, '2014-02-15 00:08:38.000000', 'temperatura', 862.0000, 'ºC'),
	(208312, 122, '2014-02-15 00:08:39.000000', 'temperatura', 405.0000, 'ºC'),
	(208313, 122, '2014-02-15 00:08:40.000000', 'temperatura', 637.0000, 'ºC'),
	(208314, 122, '2014-02-15 00:08:41.000000', 'temperatura', 772.0000, 'ºC'),
	(208315, 122, '2014-02-15 00:08:42.000000', 'temperatura', 749.0000, 'ºC'),
	(208316, 122, '2014-02-15 00:08:43.000000', 'temperatura', 231.0000, 'ºC'),
	(208317, 122, '2014-02-15 00:08:44.000000', 'temperatura', 106.0000, 'ºC'),
	(208318, 122, '2014-02-15 00:08:45.000000', 'temperatura', 1038.0000, 'ºC'),
	(208319, 122, '2014-02-15 00:08:46.000000', 'temperatura', 74.0000, 'ºC'),
	(208320, 122, '2014-02-15 00:08:47.000000', 'temperatura', 854.0000, 'ºC'),
	(208321, 122, '2014-02-15 00:08:48.000000', 'temperatura', 451.0000, 'ºC'),
	(208322, 122, '2014-02-15 00:08:49.000000', 'temperatura', 893.0000, 'ºC'),
	(208323, 122, '2014-02-15 00:08:50.000000', 'temperatura', 713.0000, 'ºC'),
	(208324, 122, '2014-02-15 00:08:51.000000', 'temperatura', 885.0000, 'ºC'),
	(208325, 122, '2014-02-15 00:08:52.000000', 'temperatura', 1087.0000, 'ºC'),
	(208326, 122, '2014-02-15 00:08:53.000000', 'temperatura', 382.0000, 'ºC'),
	(208327, 122, '2014-02-15 00:08:54.000000', 'temperatura', 1049.0000, 'ºC'),
	(208328, 122, '2014-02-15 00:08:55.000000', 'temperatura', 499.0000, 'ºC'),
	(208329, 122, '2014-02-15 00:08:56.000000', 'temperatura', 550.0000, 'ºC'),
	(208330, 122, '2014-02-15 00:08:57.000000', 'temperatura', 55.0000, 'ºC'),
	(208331, 122, '2014-02-15 00:08:58.000000', 'temperatura', 1022.0000, 'ºC'),
	(208332, 122, '2014-02-15 00:08:59.000000', 'temperatura', 147.0000, 'ºC'),
	(208333, 122, '2014-02-15 00:09:00.000000', 'temperatura', 71.0000, 'ºC'),
	(208334, 122, '2014-02-15 00:09:01.000000', 'temperatura', 1113.0000, 'ºC'),
	(208335, 122, '2014-02-15 00:09:02.000000', 'temperatura', 554.0000, 'ºC'),
	(208336, 122, '2014-02-15 00:09:03.000000', 'temperatura', 632.0000, 'ºC'),
	(208337, 122, '2014-02-15 00:09:04.000000', 'temperatura', 297.0000, 'ºC'),
	(208338, 122, '2014-02-15 00:09:05.000000', 'temperatura', 789.0000, 'ºC'),
	(208339, 122, '2014-02-15 00:09:06.000000', 'temperatura', 656.0000, 'ºC'),
	(208340, 122, '2014-02-15 00:09:07.000000', 'temperatura', 915.0000, 'ºC'),
	(208341, 122, '2014-02-15 00:09:08.000000', 'temperatura', 206.0000, 'ºC'),
	(208342, 122, '2014-02-15 00:09:09.000000', 'temperatura', 686.0000, 'ºC'),
	(208343, 122, '2014-02-15 00:09:10.000000', 'temperatura', 412.0000, 'ºC'),
	(208344, 122, '2014-02-15 00:09:11.000000', 'temperatura', 4.0000, 'ºC'),
	(208345, 122, '2014-02-15 00:09:12.000000', 'temperatura', 1185.0000, 'ºC'),
	(208346, 122, '2014-02-15 00:09:13.000000', 'temperatura', 1111.0000, 'ºC'),
	(208347, 122, '2014-02-15 00:09:14.000000', 'temperatura', 803.0000, 'ºC'),
	(208348, 122, '2014-02-15 00:09:15.000000', 'temperatura', 679.0000, 'ºC'),
	(208349, 122, '2014-02-15 00:09:16.000000', 'temperatura', 990.0000, 'ºC'),
	(208350, 122, '2014-02-15 00:09:17.000000', 'temperatura', 513.0000, 'ºC'),
	(208351, 122, '2014-02-15 00:09:18.000000', 'temperatura', 797.0000, 'ºC'),
	(208352, 122, '2014-02-15 00:09:19.000000', 'temperatura', 45.0000, 'ºC'),
	(208353, 122, '2014-02-15 00:09:20.000000', 'temperatura', 233.0000, 'ºC'),
	(208354, 122, '2014-02-15 00:09:21.000000', 'temperatura', 1033.0000, 'ºC'),
	(208355, 122, '2014-02-15 00:09:22.000000', 'temperatura', 864.0000, 'ºC'),
	(208356, 122, '2014-02-15 00:09:23.000000', 'temperatura', 21.0000, 'ºC'),
	(208357, 122, '2014-02-15 00:09:24.000000', 'temperatura', 1114.0000, 'ºC'),
	(208358, 122, '2014-02-15 00:09:25.000000', 'temperatura', 707.0000, 'ºC'),
	(208359, 122, '2014-02-15 00:09:26.000000', 'temperatura', 193.0000, 'ºC'),
	(208360, 122, '2014-02-15 00:09:27.000000', 'temperatura', 46.0000, 'ºC'),
	(208361, 122, '2014-02-15 00:09:28.000000', 'temperatura', 849.0000, 'ºC'),
	(208362, 122, '2014-02-15 00:09:29.000000', 'temperatura', 510.0000, 'ºC'),
	(208363, 122, '2014-02-15 00:09:30.000000', 'temperatura', 2.0000, 'ºC'),
	(208364, 122, '2014-02-15 00:09:31.000000', 'temperatura', 882.0000, 'ºC'),
	(208365, 122, '2014-02-15 00:09:32.000000', 'temperatura', 803.0000, 'ºC'),
	(208366, 122, '2014-02-15 00:09:33.000000', 'temperatura', 170.0000, 'ºC'),
	(208367, 122, '2014-02-15 00:09:34.000000', 'temperatura', 843.0000, 'ºC'),
	(208368, 122, '2014-02-15 00:09:35.000000', 'temperatura', 104.0000, 'ºC'),
	(208369, 122, '2014-02-15 00:09:36.000000', 'temperatura', 392.0000, 'ºC'),
	(208370, 122, '2014-02-15 00:09:37.000000', 'temperatura', 450.0000, 'ºC'),
	(208371, 122, '2014-02-15 00:09:38.000000', 'temperatura', 1075.0000, 'ºC'),
	(208372, 122, '2014-02-15 00:09:39.000000', 'temperatura', 424.0000, 'ºC'),
	(208373, 122, '2014-02-15 00:09:40.000000', 'temperatura', 97.0000, 'ºC'),
	(208374, 122, '2014-02-15 00:09:41.000000', 'temperatura', 414.0000, 'ºC'),
	(208375, 122, '2014-02-15 00:09:42.000000', 'temperatura', 577.0000, 'ºC'),
	(208376, 122, '2014-02-15 00:09:43.000000', 'temperatura', 445.0000, 'ºC'),
	(208377, 122, '2014-02-15 00:09:44.000000', 'temperatura', 496.0000, 'ºC'),
	(208378, 122, '2014-02-15 00:09:45.000000', 'temperatura', 1145.0000, 'ºC'),
	(208379, 122, '2014-02-15 00:09:46.000000', 'temperatura', 639.0000, 'ºC'),
	(208380, 122, '2014-02-15 00:09:47.000000', 'temperatura', 959.0000, 'ºC'),
	(208381, 122, '2014-02-15 00:09:48.000000', 'temperatura', 480.0000, 'ºC'),
	(208382, 122, '2014-02-15 00:09:49.000000', 'temperatura', 722.0000, 'ºC'),
	(208383, 122, '2014-02-15 00:09:50.000000', 'temperatura', 969.0000, 'ºC'),
	(208384, 122, '2014-02-15 00:09:51.000000', 'temperatura', 280.0000, 'ºC'),
	(208385, 122, '2014-02-15 00:09:52.000000', 'temperatura', 894.0000, 'ºC'),
	(208386, 122, '2014-02-15 00:09:53.000000', 'temperatura', 30.0000, 'ºC'),
	(208387, 122, '2014-02-15 00:09:54.000000', 'temperatura', 1070.0000, 'ºC'),
	(208388, 122, '2014-02-15 00:09:55.000000', 'temperatura', 460.0000, 'ºC'),
	(208389, 122, '2014-02-15 00:09:56.000000', 'temperatura', 289.0000, 'ºC'),
	(208390, 122, '2014-02-15 00:09:57.000000', 'temperatura', 65.0000, 'ºC'),
	(208391, 122, '2014-02-15 00:09:58.000000', 'temperatura', 661.0000, 'ºC'),
	(208392, 122, '2014-02-15 00:09:59.000000', 'temperatura', 710.0000, 'ºC'),
	(208393, 122, '2014-02-15 00:10:00.000000', 'temperatura', 367.0000, 'ºC'),
	(208394, 122, '2014-02-15 00:10:01.000000', 'temperatura', 908.0000, 'ºC'),
	(208395, 122, '2014-02-15 00:10:02.000000', 'temperatura', 1036.0000, 'ºC'),
	(208396, 122, '2014-02-15 00:10:03.000000', 'temperatura', 59.0000, 'ºC'),
	(208397, 122, '2014-02-15 00:10:04.000000', 'temperatura', 785.0000, 'ºC'),
	(208398, 122, '2014-02-15 00:10:05.000000', 'temperatura', 149.0000, 'ºC'),
	(208399, 122, '2014-02-15 00:10:06.000000', 'temperatura', 790.0000, 'ºC'),
	(208400, 122, '2014-02-15 00:10:07.000000', 'temperatura', 1104.0000, 'ºC'),
	(208401, 122, '2014-02-15 00:10:08.000000', 'temperatura', 753.0000, 'ºC'),
	(208402, 122, '2014-02-15 00:10:09.000000', 'temperatura', 451.0000, 'ºC'),
	(208403, 122, '2014-02-15 00:10:10.000000', 'temperatura', 1196.0000, 'ºC'),
	(208404, 122, '2014-02-15 00:10:11.000000', 'temperatura', 1026.0000, 'ºC'),
	(208405, 122, '2014-02-15 00:10:12.000000', 'temperatura', 346.0000, 'ºC'),
	(208406, 122, '2014-02-15 00:10:13.000000', 'temperatura', 1049.0000, 'ºC'),
	(208407, 122, '2014-02-15 00:10:14.000000', 'temperatura', 609.0000, 'ºC'),
	(208408, 122, '2014-02-15 00:10:15.000000', 'temperatura', 1101.0000, 'ºC'),
	(208409, 122, '2014-02-15 00:10:16.000000', 'temperatura', 75.0000, 'ºC'),
	(208410, 122, '2014-02-15 00:10:17.000000', 'temperatura', 674.0000, 'ºC'),
	(208411, 122, '2014-02-15 00:10:18.000000', 'temperatura', 744.0000, 'ºC'),
	(208412, 122, '2014-02-15 00:10:19.000000', 'temperatura', 499.0000, 'ºC'),
	(208413, 122, '2014-02-15 00:10:20.000000', 'temperatura', 266.0000, 'ºC'),
	(208414, 122, '2014-02-15 00:10:21.000000', 'temperatura', 1031.0000, 'ºC'),
	(208415, 122, '2014-02-15 00:10:22.000000', 'temperatura', 760.0000, 'ºC'),
	(208416, 122, '2014-02-15 00:10:23.000000', 'temperatura', 706.0000, 'ºC'),
	(208417, 122, '2014-02-15 00:10:24.000000', 'temperatura', 49.0000, 'ºC'),
	(208418, 122, '2014-02-15 00:10:25.000000', 'temperatura', 528.0000, 'ºC'),
	(208419, 122, '2014-02-15 00:10:26.000000', 'temperatura', 94.0000, 'ºC'),
	(208420, 122, '2014-02-15 00:10:27.000000', 'temperatura', 86.0000, 'ºC'),
	(208421, 122, '2014-02-15 00:10:28.000000', 'temperatura', 150.0000, 'ºC'),
	(208422, 122, '2014-02-15 00:10:29.000000', 'temperatura', 493.0000, 'ºC'),
	(208423, 122, '2014-02-15 00:10:30.000000', 'temperatura', 814.0000, 'ºC'),
	(208424, 122, '2014-02-15 00:10:31.000000', 'temperatura', 190.0000, 'ºC'),
	(208425, 122, '2014-02-15 00:10:32.000000', 'temperatura', 910.0000, 'ºC'),
	(208426, 122, '2014-02-15 00:10:33.000000', 'temperatura', 381.0000, 'ºC'),
	(208427, 122, '2014-02-15 00:10:34.000000', 'temperatura', 376.0000, 'ºC'),
	(208428, 122, '2014-02-15 00:10:35.000000', 'temperatura', 735.0000, 'ºC'),
	(208429, 122, '2014-02-15 00:10:36.000000', 'temperatura', 149.0000, 'ºC'),
	(208430, 122, '2014-02-15 00:10:37.000000', 'temperatura', 940.0000, 'ºC'),
	(208431, 122, '2014-02-15 00:10:38.000000', 'temperatura', 652.0000, 'ºC'),
	(208432, 122, '2014-02-15 00:10:39.000000', 'temperatura', 440.0000, 'ºC'),
	(208433, 122, '2014-02-15 00:10:40.000000', 'temperatura', 246.0000, 'ºC'),
	(208434, 122, '2014-02-15 00:10:41.000000', 'temperatura', 1111.0000, 'ºC'),
	(208435, 122, '2014-02-15 00:10:42.000000', 'temperatura', 18.0000, 'ºC'),
	(208436, 122, '2014-02-15 00:10:43.000000', 'temperatura', 358.0000, 'ºC'),
	(208437, 122, '2014-02-15 00:10:44.000000', 'temperatura', 535.0000, 'ºC'),
	(208438, 122, '2014-02-15 00:10:45.000000', 'temperatura', 402.0000, 'ºC'),
	(208439, 122, '2014-02-15 00:10:46.000000', 'temperatura', 406.0000, 'ºC'),
	(208440, 122, '2014-02-15 00:10:47.000000', 'temperatura', 824.0000, 'ºC'),
	(208441, 122, '2014-02-15 00:10:48.000000', 'temperatura', 504.0000, 'ºC'),
	(208442, 122, '2014-02-15 00:10:49.000000', 'temperatura', 46.0000, 'ºC'),
	(208443, 122, '2014-02-15 00:10:50.000000', 'temperatura', 1120.0000, 'ºC'),
	(208444, 122, '2014-02-15 00:10:51.000000', 'temperatura', 662.0000, 'ºC'),
	(208445, 122, '2014-02-15 00:10:52.000000', 'temperatura', 1149.0000, 'ºC'),
	(208446, 122, '2014-02-15 00:10:53.000000', 'temperatura', 162.0000, 'ºC'),
	(208447, 122, '2014-02-15 00:10:54.000000', 'temperatura', 965.0000, 'ºC'),
	(208448, 122, '2014-02-15 00:10:55.000000', 'temperatura', 736.0000, 'ºC'),
	(208449, 122, '2014-02-15 00:10:56.000000', 'temperatura', 787.0000, 'ºC'),
	(208450, 122, '2014-02-15 00:10:57.000000', 'temperatura', 527.0000, 'ºC'),
	(208451, 122, '2014-02-15 00:10:58.000000', 'temperatura', 275.0000, 'ºC'),
	(208452, 122, '2014-02-15 00:10:59.000000', 'temperatura', 996.0000, 'ºC'),
	(208453, 122, '2014-02-15 00:11:00.000000', 'temperatura', 555.0000, 'ºC'),
	(208454, 122, '2014-02-15 00:11:01.000000', 'temperatura', 987.0000, 'ºC'),
	(208455, 122, '2014-02-15 00:11:02.000000', 'temperatura', 871.0000, 'ºC'),
	(208456, 122, '2014-02-15 00:11:03.000000', 'temperatura', 196.0000, 'ºC'),
	(208457, 122, '2014-02-15 00:11:04.000000', 'temperatura', 765.0000, 'ºC'),
	(208458, 122, '2014-02-15 00:11:05.000000', 'temperatura', 839.0000, 'ºC'),
	(208459, 122, '2014-02-15 00:11:06.000000', 'temperatura', 700.0000, 'ºC'),
	(208460, 122, '2014-02-15 00:11:07.000000', 'temperatura', 985.0000, 'ºC'),
	(208461, 122, '2014-02-15 00:11:08.000000', 'temperatura', 426.0000, 'ºC'),
	(208462, 122, '2014-02-15 00:11:09.000000', 'temperatura', 376.0000, 'ºC'),
	(208463, 122, '2014-02-15 00:11:10.000000', 'temperatura', 602.0000, 'ºC'),
	(208464, 122, '2014-02-15 00:11:11.000000', 'temperatura', 681.0000, 'ºC'),
	(208465, 122, '2014-02-15 00:11:12.000000', 'temperatura', 402.0000, 'ºC'),
	(208466, 122, '2014-02-15 00:11:13.000000', 'temperatura', 1167.0000, 'ºC'),
	(208467, 122, '2014-02-15 00:11:14.000000', 'temperatura', 1029.0000, 'ºC'),
	(208468, 122, '2014-02-15 00:11:15.000000', 'temperatura', 445.0000, 'ºC'),
	(208469, 122, '2014-02-15 00:11:16.000000', 'temperatura', 339.0000, 'ºC'),
	(208470, 122, '2014-02-15 00:11:17.000000', 'temperatura', 361.0000, 'ºC'),
	(208471, 122, '2014-02-15 00:11:18.000000', 'temperatura', 789.0000, 'ºC'),
	(208472, 122, '2014-02-15 00:11:19.000000', 'temperatura', 460.0000, 'ºC'),
	(208473, 122, '2014-02-15 00:11:20.000000', 'temperatura', 1136.0000, 'ºC'),
	(208474, 122, '2014-02-15 00:11:21.000000', 'temperatura', 701.0000, 'ºC'),
	(208475, 122, '2014-02-15 00:11:22.000000', 'temperatura', 96.0000, 'ºC'),
	(208476, 122, '2014-02-15 00:11:23.000000', 'temperatura', 777.0000, 'ºC'),
	(208477, 122, '2014-02-15 00:11:24.000000', 'temperatura', 1196.0000, 'ºC'),
	(208478, 122, '2014-02-15 00:11:25.000000', 'temperatura', 51.0000, 'ºC'),
	(208479, 122, '2014-02-15 00:11:26.000000', 'temperatura', 268.0000, 'ºC'),
	(208480, 122, '2014-02-15 00:11:27.000000', 'temperatura', 1185.0000, 'ºC'),
	(208481, 122, '2014-02-15 00:11:28.000000', 'temperatura', 323.0000, 'ºC'),
	(208482, 122, '2014-02-15 00:11:29.000000', 'temperatura', 460.0000, 'ºC'),
	(208483, 122, '2014-02-15 00:11:30.000000', 'temperatura', 134.0000, 'ºC'),
	(208484, 122, '2014-02-15 00:11:31.000000', 'temperatura', 488.0000, 'ºC'),
	(208485, 122, '2014-02-15 00:11:32.000000', 'temperatura', 840.0000, 'ºC'),
	(208486, 122, '2014-02-15 00:11:33.000000', 'temperatura', 336.0000, 'ºC'),
	(208487, 122, '2014-02-15 00:11:34.000000', 'temperatura', 360.0000, 'ºC'),
	(208488, 122, '2014-02-15 00:11:35.000000', 'temperatura', 793.0000, 'ºC'),
	(208489, 122, '2014-02-15 00:11:36.000000', 'temperatura', 486.0000, 'ºC'),
	(208490, 122, '2014-02-15 00:11:37.000000', 'temperatura', 50.0000, 'ºC'),
	(208491, 122, '2014-02-15 00:11:38.000000', 'temperatura', 1194.0000, 'ºC'),
	(208492, 122, '2014-02-15 00:11:39.000000', 'temperatura', 1021.0000, 'ºC'),
	(208493, 122, '2014-02-15 00:11:40.000000', 'temperatura', 325.0000, 'ºC'),
	(208494, 122, '2014-02-15 00:11:41.000000', 'temperatura', 959.0000, 'ºC'),
	(208495, 122, '2014-02-15 00:11:42.000000', 'temperatura', 224.0000, 'ºC'),
	(208496, 122, '2014-02-15 00:11:43.000000', 'temperatura', 640.0000, 'ºC'),
	(208497, 122, '2014-02-15 00:11:44.000000', 'temperatura', 131.0000, 'ºC'),
	(208498, 122, '2014-02-15 00:11:45.000000', 'temperatura', 1134.0000, 'ºC'),
	(208499, 122, '2014-02-15 00:11:46.000000', 'temperatura', 476.0000, 'ºC'),
	(208500, 122, '2014-02-15 00:11:47.000000', 'temperatura', 180.0000, 'ºC'),
	(208501, 122, '2014-02-15 00:11:48.000000', 'temperatura', 671.0000, 'ºC'),
	(208502, 122, '2014-02-15 00:11:49.000000', 'temperatura', 416.0000, 'ºC'),
	(208503, 122, '2014-02-15 00:11:50.000000', 'temperatura', 69.0000, 'ºC'),
	(208504, 122, '2014-02-15 00:11:51.000000', 'temperatura', 298.0000, 'ºC'),
	(208505, 122, '2014-02-15 00:11:52.000000', 'temperatura', 84.0000, 'ºC'),
	(208506, 122, '2014-02-15 00:11:53.000000', 'temperatura', 728.0000, 'ºC'),
	(208507, 122, '2014-02-15 00:11:54.000000', 'temperatura', 985.0000, 'ºC'),
	(208508, 122, '2014-02-15 00:11:55.000000', 'temperatura', 341.0000, 'ºC'),
	(208509, 122, '2014-02-15 00:11:56.000000', 'temperatura', 1154.0000, 'ºC'),
	(208510, 122, '2014-02-15 00:11:57.000000', 'temperatura', 1144.0000, 'ºC'),
	(208511, 122, '2014-02-15 00:11:58.000000', 'temperatura', 1059.0000, 'ºC'),
	(208512, 122, '2014-02-15 00:11:59.000000', 'temperatura', 663.0000, 'ºC'),
	(208513, 122, '2014-02-15 00:12:00.000000', 'temperatura', 139.0000, 'ºC'),
	(208514, 122, '2014-02-15 00:12:01.000000', 'temperatura', 1109.0000, 'ºC'),
	(208515, 122, '2014-02-15 00:12:02.000000', 'temperatura', 325.0000, 'ºC'),
	(208516, 122, '2014-02-15 00:12:03.000000', 'temperatura', 699.0000, 'ºC'),
	(208517, 122, '2014-02-15 00:12:04.000000', 'temperatura', 123.0000, 'ºC'),
	(208518, 122, '2014-02-15 00:12:05.000000', 'temperatura', 917.0000, 'ºC'),
	(208519, 122, '2014-02-15 00:12:06.000000', 'temperatura', 617.0000, 'ºC'),
	(208520, 122, '2014-02-15 00:12:07.000000', 'temperatura', 333.0000, 'ºC'),
	(208521, 122, '2014-02-15 00:12:08.000000', 'temperatura', 1016.0000, 'ºC'),
	(208522, 122, '2014-02-15 00:12:09.000000', 'temperatura', 480.0000, 'ºC'),
	(208523, 122, '2014-02-15 00:12:10.000000', 'temperatura', 553.0000, 'ºC'),
	(208524, 122, '2014-02-15 00:12:11.000000', 'temperatura', 125.0000, 'ºC'),
	(208525, 122, '2014-02-15 00:12:12.000000', 'temperatura', 168.0000, 'ºC'),
	(208526, 122, '2014-02-15 00:12:13.000000', 'temperatura', 463.0000, 'ºC'),
	(208527, 122, '2014-02-15 00:12:14.000000', 'temperatura', 614.0000, 'ºC'),
	(208528, 122, '2014-02-15 00:12:15.000000', 'temperatura', 481.0000, 'ºC'),
	(208529, 122, '2014-02-15 00:12:16.000000', 'temperatura', 563.0000, 'ºC'),
	(208530, 122, '2014-02-15 00:12:17.000000', 'temperatura', 172.0000, 'ºC'),
	(208531, 122, '2014-02-15 00:12:18.000000', 'temperatura', 374.0000, 'ºC'),
	(208532, 122, '2014-02-15 00:12:19.000000', 'temperatura', 152.0000, 'ºC'),
	(208533, 122, '2014-02-15 00:12:20.000000', 'temperatura', 840.0000, 'ºC'),
	(208534, 122, '2014-02-15 00:12:21.000000', 'temperatura', 146.0000, 'ºC'),
	(208535, 122, '2014-02-15 00:12:22.000000', 'temperatura', 608.0000, 'ºC'),
	(208536, 122, '2014-02-15 00:12:23.000000', 'temperatura', 204.0000, 'ºC'),
	(208537, 122, '2014-02-15 00:12:24.000000', 'temperatura', 395.0000, 'ºC'),
	(208538, 122, '2014-02-15 00:12:25.000000', 'temperatura', 164.0000, 'ºC'),
	(208539, 122, '2014-02-15 00:12:26.000000', 'temperatura', 836.0000, 'ºC'),
	(208540, 122, '2014-02-15 00:12:27.000000', 'temperatura', 88.0000, 'ºC'),
	(208541, 122, '2014-02-15 00:12:28.000000', 'temperatura', 333.0000, 'ºC'),
	(208542, 122, '2014-02-15 00:12:29.000000', 'temperatura', 201.0000, 'ºC'),
	(208543, 122, '2014-02-15 00:12:30.000000', 'temperatura', 7.0000, 'ºC'),
	(208544, 122, '2014-02-15 00:12:31.000000', 'temperatura', 633.0000, 'ºC'),
	(208545, 122, '2014-02-15 00:12:32.000000', 'temperatura', 743.0000, 'ºC'),
	(208546, 122, '2014-02-15 00:12:33.000000', 'temperatura', 615.0000, 'ºC'),
	(208547, 122, '2014-02-15 00:12:34.000000', 'temperatura', 850.0000, 'ºC'),
	(208548, 122, '2014-02-15 00:12:35.000000', 'temperatura', 4.0000, 'ºC'),
	(208549, 122, '2014-02-15 00:12:36.000000', 'temperatura', 1070.0000, 'ºC'),
	(208550, 122, '2014-02-15 00:12:37.000000', 'temperatura', 541.0000, 'ºC'),
	(208551, 122, '2014-02-15 00:12:38.000000', 'temperatura', 692.0000, 'ºC'),
	(208552, 122, '2014-02-15 00:12:39.000000', 'temperatura', 640.0000, 'ºC'),
	(208553, 122, '2014-02-15 00:12:40.000000', 'temperatura', 1126.0000, 'ºC'),
	(208554, 122, '2014-02-15 00:12:41.000000', 'temperatura', 108.0000, 'ºC'),
	(208555, 122, '2014-02-15 00:12:42.000000', 'temperatura', 761.0000, 'ºC'),
	(208556, 122, '2014-02-15 00:12:43.000000', 'temperatura', 1084.0000, 'ºC'),
	(208557, 122, '2014-02-15 00:12:44.000000', 'temperatura', 739.0000, 'ºC'),
	(208558, 122, '2014-02-15 00:12:45.000000', 'temperatura', 440.0000, 'ºC'),
	(208559, 122, '2014-02-15 00:12:46.000000', 'temperatura', 1186.0000, 'ºC'),
	(208560, 122, '2014-02-15 00:12:47.000000', 'temperatura', 1008.0000, 'ºC'),
	(208561, 122, '2014-02-15 00:12:48.000000', 'temperatura', 285.0000, 'ºC'),
	(208562, 122, '2014-02-15 00:12:49.000000', 'temperatura', 801.0000, 'ºC'),
	(208563, 122, '2014-02-15 00:12:50.000000', 'temperatura', 749.0000, 'ºC'),
	(208564, 122, '2014-02-15 00:12:51.000000', 'temperatura', 142.0000, 'ºC'),
	(208565, 122, '2014-02-15 00:12:52.000000', 'temperatura', 864.0000, 'ºC'),
	(208566, 122, '2014-02-15 00:12:53.000000', 'temperatura', 295.0000, 'ºC'),
	(208567, 122, '2014-02-15 00:12:54.000000', 'temperatura', 84.0000, 'ºC'),
	(208568, 122, '2014-02-15 00:12:55.000000', 'temperatura', 736.0000, 'ºC'),
	(208569, 122, '2014-02-15 00:12:56.000000', 'temperatura', 1027.0000, 'ºC'),
	(208570, 122, '2014-02-15 00:12:57.000000', 'temperatura', 528.0000, 'ºC'),
	(208571, 122, '2014-02-15 00:12:58.000000', 'temperatura', 759.0000, 'ºC'),
	(208572, 122, '2014-02-15 00:12:59.000000', 'temperatura', 1014.0000, 'ºC'),
	(208573, 122, '2014-02-15 00:13:00.000000', 'temperatura', 392.0000, 'ºC'),
	(208574, 122, '2014-02-15 00:13:01.000000', 'temperatura', 117.0000, 'ºC'),
	(208575, 122, '2014-02-15 00:13:02.000000', 'temperatura', 610.0000, 'ºC'),
	(208576, 122, '2014-02-15 00:13:03.000000', 'temperatura', 302.0000, 'ºC'),
	(208577, 122, '2014-02-15 00:13:04.000000', 'temperatura', 877.0000, 'ºC'),
	(208578, 122, '2014-02-15 00:13:05.000000', 'temperatura', 1082.0000, 'ºC'),
	(208579, 122, '2014-02-15 00:13:06.000000', 'temperatura', 379.0000, 'ºC'),
	(208580, 122, '2014-02-15 00:13:07.000000', 'temperatura', 1048.0000, 'ºC'),
	(208581, 122, '2014-02-15 00:13:08.000000', 'temperatura', 504.0000, 'ºC'),
	(208582, 122, '2014-02-15 00:13:09.000000', 'temperatura', 576.0000, 'ºC'),
	(208583, 122, '2014-02-15 00:13:10.000000', 'temperatura', 171.0000, 'ºC'),
	(208584, 122, '2014-02-15 00:13:11.000000', 'temperatura', 326.0000, 'ºC'),
	(208585, 122, '2014-02-15 00:13:12.000000', 'temperatura', 1118.0000, 'ºC'),
	(208586, 122, '2014-02-15 00:13:13.000000', 'temperatura', 1014.0000, 'ºC'),
	(208587, 122, '2014-02-15 00:13:14.000000', 'temperatura', 513.0000, 'ºC'),
	(208588, 122, '2014-02-15 00:13:15.000000', 'temperatura', 727.0000, 'ºC'),
	(208589, 122, '2014-02-15 00:13:16.000000', 'temperatura', 894.0000, 'ºC'),
	(208590, 122, '2014-02-15 00:13:17.000000', 'temperatura', 1091.0000, 'ºC'),
	(208591, 122, '2014-02-15 00:13:18.000000', 'temperatura', 373.0000, 'ºC'),
	(208592, 122, '2014-02-15 00:13:19.000000', 'temperatura', 992.0000, 'ºC'),
	(208593, 122, '2014-02-15 00:13:20.000000', 'temperatura', 241.0000, 'ºC'),
	(208594, 122, '2014-02-15 00:13:21.000000', 'temperatura', 629.0000, 'ºC'),
	(208595, 122, '2014-02-15 00:13:22.000000', 'temperatura', 22.0000, 'ºC'),
	(208596, 122, '2014-02-15 00:13:23.000000', 'temperatura', 626.0000, 'ºC'),
	(208597, 122, '2014-02-15 00:13:24.000000', 'temperatura', 661.0000, 'ºC'),
	(208598, 122, '2014-02-15 00:13:25.000000', 'temperatura', 231.0000, 'ºC'),
	(208599, 122, '2014-02-15 00:13:26.000000', 'temperatura', 372.0000, 'ºC'),
	(208600, 122, '2014-02-15 00:13:27.000000', 'temperatura', 1169.0000, 'ºC'),
	(208601, 122, '2014-02-15 00:13:28.000000', 'temperatura', 1127.0000, 'ºC'),
	(208602, 122, '2014-02-15 00:13:29.000000', 'temperatura', 931.0000, 'ºC'),
	(208603, 122, '2014-02-15 00:13:30.000000', 'temperatura', 73.0000, 'ºC'),
	(208604, 122, '2014-02-15 00:13:31.000000', 'temperatura', 1173.0000, 'ºC'),
	(208605, 122, '2014-02-15 00:13:32.000000', 'temperatura', 845.0000, 'ºC'),
	(208606, 122, '2014-02-15 00:13:33.000000', 'temperatura', 705.0000, 'ºC'),
	(208607, 122, '2014-02-15 00:13:34.000000', 'temperatura', 993.0000, 'ºC'),
	(208608, 122, '2014-02-15 00:13:35.000000', 'temperatura', 452.0000, 'ºC'),
	(208609, 122, '2014-02-15 00:13:36.000000', 'temperatura', 480.0000, 'ºC'),
	(208610, 122, '2014-02-15 00:13:37.000000', 'temperatura', 1042.0000, 'ºC'),
	(208611, 122, '2014-02-15 00:13:38.000000', 'temperatura', 174.0000, 'ºC'),
	(208612, 122, '2014-02-15 00:13:39.000000', 'temperatura', 143.0000, 'ºC'),
	(208613, 122, '2014-02-15 00:13:40.000000', 'temperatura', 195.0000, 'ºC'),
	(208614, 122, '2014-02-15 00:13:41.000000', 'temperatura', 546.0000, 'ºC'),
	(208615, 122, '2014-02-15 00:13:42.000000', 'temperatura', 945.0000, 'ºC'),
	(208616, 122, '2014-02-15 00:13:43.000000', 'temperatura', 688.0000, 'ºC'),
	(208617, 122, '2014-02-15 00:13:44.000000', 'temperatura', 607.0000, 'ºC'),
	(208618, 122, '2014-02-15 00:13:45.000000', 'temperatura', 970.0000, 'ºC'),
	(208619, 122, '2014-02-15 00:13:46.000000', 'temperatura', 630.0000, 'ºC'),
	(208620, 122, '2014-02-15 00:13:47.000000', 'temperatura', 239.0000, 'ºC'),
	(208621, 122, '2014-02-15 00:13:48.000000', 'temperatura', 505.0000, 'ºC'),
	(208622, 122, '2014-02-15 00:13:49.000000', 'temperatura', 608.0000, 'ºC'),
	(208623, 122, '2014-02-15 00:13:50.000000', 'temperatura', 327.0000, 'ºC'),
	(208624, 122, '2014-02-15 00:13:51.000000', 'temperatura', 1010.0000, 'ºC'),
	(208625, 122, '2014-02-15 00:13:52.000000', 'temperatura', 471.0000, 'ºC'),
	(208626, 122, '2014-02-15 00:13:53.000000', 'temperatura', 527.0000, 'ºC'),
	(208627, 122, '2014-02-15 00:13:54.000000', 'temperatura', 21.0000, 'ºC'),
	(208628, 122, '2014-02-15 00:13:55.000000', 'temperatura', 925.0000, 'ºC'),
	(208629, 122, '2014-02-15 00:13:56.000000', 'temperatura', 960.0000, 'ºC'),
	(208630, 122, '2014-02-15 00:13:57.000000', 'temperatura', 828.0000, 'ºC'),
	(208631, 122, '2014-02-15 00:13:58.000000', 'temperatura', 59.0000, 'ºC'),
	(208632, 122, '2014-02-15 00:13:59.000000', 'temperatura', 210.0000, 'ºC'),
	(208633, 122, '2014-02-15 00:14:00.000000', 'temperatura', 876.0000, 'ºC'),
	(208634, 122, '2014-02-15 00:14:01.000000', 'temperatura', 149.0000, 'ºC'),
	(208635, 122, '2014-02-15 00:14:02.000000', 'temperatura', 518.0000, 'ºC'),
	(208636, 122, '2014-02-15 00:14:03.000000', 'temperatura', 944.0000, 'ºC'),
	(208637, 122, '2014-02-15 00:14:04.000000', 'temperatura', 767.0000, 'ºC'),
	(208638, 122, '2014-02-15 00:14:05.000000', 'temperatura', 1004.0000, 'ºC'),
	(208639, 122, '2014-02-15 00:14:06.000000', 'temperatura', 317.0000, 'ºC'),
	(208640, 122, '2014-02-15 00:14:07.000000', 'temperatura', 976.0000, 'ºC'),
	(208641, 122, '2014-02-15 00:14:08.000000', 'temperatura', 329.0000, 'ºC'),
	(208642, 122, '2014-02-15 00:14:09.000000', 'temperatura', 1116.0000, 'ºC'),
	(208643, 122, '2014-02-15 00:14:10.000000', 'temperatura', 993.0000, 'ºC'),
	(208644, 122, '2014-02-15 00:14:11.000000', 'temperatura', 417.0000, 'ºC'),
	(208645, 122, '2014-02-15 00:14:12.000000', 'temperatura', 310.0000, 'ºC'),
	(208646, 122, '2014-02-15 00:14:13.000000', 'temperatura', 296.0000, 'ºC'),
	(208647, 122, '2014-02-15 00:14:14.000000', 'temperatura', 553.0000, 'ºC'),
	(208648, 122, '2014-02-15 00:14:15.000000', 'temperatura', 676.0000, 'ºC'),
	(208649, 122, '2014-02-15 00:14:16.000000', 'temperatura', 524.0000, 'ºC'),
	(208650, 122, '2014-02-15 00:14:17.000000', 'temperatura', 590.0000, 'ºC'),
	(208651, 122, '2014-02-15 00:14:18.000000', 'temperatura', 180.0000, 'ºC'),
	(208652, 122, '2014-02-15 00:14:19.000000', 'temperatura', 330.0000, 'ºC'),
	(208653, 122, '2014-02-15 00:14:20.000000', 'temperatura', 1111.0000, 'ºC'),
	(208654, 122, '2014-02-15 00:14:21.000000', 'temperatura', 965.0000, 'ºC'),
	(208655, 122, '2014-02-15 00:14:22.000000', 'temperatura', 293.0000, 'ºC'),
	(208656, 122, '2014-02-15 00:14:23.000000', 'temperatura', 970.0000, 'ºC'),
	(208657, 122, '2014-02-15 00:14:24.000000', 'temperatura', 371.0000, 'ºC'),
	(208658, 122, '2014-02-15 00:14:25.000000', 'temperatura', 148.0000, 'ºC'),
	(208659, 122, '2014-02-15 00:14:26.000000', 'temperatura', 826.0000, 'ºC'),
	(208660, 122, '2014-02-15 00:14:27.000000', 'temperatura', 87.0000, 'ºC'),
	(208661, 122, '2014-02-15 00:14:28.000000', 'temperatura', 356.0000, 'ºC'),
	(208662, 122, '2014-02-15 00:14:29.000000', 'temperatura', 320.0000, 'ºC'),
	(208663, 122, '2014-02-15 00:14:30.000000', 'temperatura', 531.0000, 'ºC'),
	(208664, 122, '2014-02-15 00:14:31.000000', 'temperatura', 498.0000, 'ºC'),
	(208665, 122, '2014-02-15 00:14:32.000000', 'temperatura', 895.0000, 'ºC'),
	(208666, 122, '2014-02-15 00:14:33.000000', 'temperatura', 583.0000, 'ºC'),
	(208667, 122, '2014-02-15 00:14:34.000000', 'temperatura', 229.0000, 'ºC'),
	(208668, 122, '2014-02-15 00:14:35.000000', 'temperatura', 595.0000, 'ºC'),
	(208669, 122, '2014-02-15 00:14:36.000000', 'temperatura', 1091.0000, 'ºC'),
	(208670, 122, '2014-02-15 00:14:37.000000', 'temperatura', 70.0000, 'ºC'),
	(208671, 122, '2014-02-15 00:14:38.000000', 'temperatura', 680.0000, 'ºC'),
	(208672, 122, '2014-02-15 00:14:39.000000', 'temperatura', 787.0000, 'ºC'),
	(208673, 122, '2014-02-15 00:14:40.000000', 'temperatura', 695.0000, 'ºC'),
	(208674, 122, '2014-02-15 00:14:41.000000', 'temperatura', 1118.0000, 'ºC'),
	(208675, 122, '2014-02-15 00:14:42.000000', 'temperatura', 1102.0000, 'ºC'),
	(208676, 122, '2014-02-15 00:14:43.000000', 'temperatura', 957.0000, 'ºC'),
	(208677, 122, '2014-02-15 00:14:44.000000', 'temperatura', 281.0000, 'ºC'),
	(208678, 122, '2014-02-15 00:14:45.000000', 'temperatura', 934.0000, 'ºC'),
	(208679, 122, '2014-02-15 00:14:46.000000', 'temperatura', 229.0000, 'ºC'),
	(208680, 122, '2014-02-15 00:14:47.000000', 'temperatura', 742.0000, 'ºC'),
	(208681, 122, '2014-02-15 00:14:48.000000', 'temperatura', 625.0000, 'ºC'),
	(208682, 122, '2014-02-15 00:14:49.000000', 'temperatura', 901.0000, 'ºC'),
	(208683, 122, '2014-02-15 00:14:50.000000', 'temperatura', 227.0000, 'ºC'),
	(208684, 122, '2014-02-15 00:14:51.000000', 'temperatura', 835.0000, 'ºC'),
	(208685, 122, '2014-02-15 00:14:52.000000', 'temperatura', 1095.0000, 'ºC'),
	(208686, 122, '2014-02-15 00:14:53.000000', 'temperatura', 570.0000, 'ºC'),
	(208687, 122, '2014-02-15 00:14:54.000000', 'temperatura', 764.0000, 'ºC'),
	(208688, 122, '2014-02-15 00:14:55.000000', 'temperatura', 910.0000, 'ºC'),
	(208689, 122, '2014-02-15 00:14:56.000000', 'temperatura', 1058.0000, 'ºC'),
	(208690, 122, '2014-02-15 00:14:57.000000', 'temperatura', 160.0000, 'ºC'),
	(208691, 122, '2014-02-15 00:14:58.000000', 'temperatura', 29.0000, 'ºC'),
	(208692, 122, '2014-02-15 00:14:59.000000', 'temperatura', 865.0000, 'ºC'),
	(208693, 122, '2014-02-15 00:15:00.000000', 'temperatura', 636.0000, 'ºC'),
	(208694, 122, '2014-02-15 00:15:01.000000', 'temperatura', 587.0000, 'ºC'),
	(208695, 122, '2014-02-15 00:15:02.000000', 'temperatura', 1028.0000, 'ºC'),
	(208696, 122, '2014-02-15 00:15:03.000000', 'temperatura', 981.0000, 'ºC'),
	(208697, 122, '2014-02-15 00:15:04.000000', 'temperatura', 618.0000, 'ºC'),
	(208698, 122, '2014-02-15 00:15:05.000000', 'temperatura', 150.0000, 'ºC'),
	(208699, 122, '2014-02-15 00:15:06.000000', 'temperatura', 96.0000, 'ºC'),
	(208700, 122, '2014-02-15 00:15:07.000000', 'temperatura', 31.0000, 'ºC'),
	(208701, 122, '2014-02-15 00:15:08.000000', 'temperatura', 1065.0000, 'ºC'),
	(208702, 122, '2014-02-15 00:15:09.000000', 'temperatura', 434.0000, 'ºC'),
	(208703, 122, '2014-02-15 00:15:10.000000', 'temperatura', 176.0000, 'ºC'),
	(208704, 122, '2014-02-15 00:15:11.000000', 'temperatura', 779.0000, 'ºC'),
	(208705, 122, '2014-02-15 00:15:12.000000', 'temperatura', 965.0000, 'ºC'),
	(208706, 122, '2014-02-15 00:15:13.000000', 'temperatura', 91.0000, 'ºC'),
	(208707, 122, '2014-02-15 00:15:14.000000', 'temperatura', 1159.0000, 'ºC'),
	(208708, 122, '2014-02-15 00:15:15.000000', 'temperatura', 724.0000, 'ºC'),
	(208709, 122, '2014-02-15 00:15:16.000000', 'temperatura', 142.0000, 'ºC'),
	(208710, 122, '2014-02-15 00:15:17.000000', 'temperatura', 938.0000, 'ºC'),
	(208711, 122, '2014-02-15 00:15:18.000000', 'temperatura', 663.0000, 'ºC'),
	(208712, 122, '2014-02-15 00:15:19.000000', 'temperatura', 504.0000, 'ºC'),
	(208713, 122, '2014-02-15 00:15:20.000000', 'temperatura', 532.0000, 'ºC'),
	(208714, 122, '2014-02-15 00:15:21.000000', 'temperatura', 1149.0000, 'ºC'),
	(208715, 122, '2014-02-15 00:15:22.000000', 'temperatura', 550.0000, 'ºC'),
	(208716, 122, '2014-02-15 00:15:23.000000', 'temperatura', 501.0000, 'ºC'),
	(208717, 122, '2014-02-15 00:15:24.000000', 'temperatura', 856.0000, 'ºC'),
	(208718, 122, '2014-02-15 00:15:25.000000', 'temperatura', 378.0000, 'ºC'),
	(208719, 122, '2014-02-15 00:15:26.000000', 'temperatura', 522.0000, 'ºC'),
	(208720, 122, '2014-02-15 00:15:27.000000', 'temperatura', 278.0000, 'ºC'),
	(208721, 122, '2014-02-15 00:15:28.000000', 'temperatura', 1025.0000, 'ºC'),
	(208722, 122, '2014-02-15 00:15:29.000000', 'temperatura', 691.0000, 'ºC'),
	(208723, 122, '2014-02-15 00:15:30.000000', 'temperatura', 381.0000, 'ºC'),
	(208724, 122, '2014-02-15 00:15:31.000000', 'temperatura', 1034.0000, 'ºC'),
	(208725, 122, '2014-02-15 00:15:32.000000', 'temperatura', 426.0000, 'ºC'),
	(208726, 122, '2014-02-15 00:15:33.000000', 'temperatura', 227.0000, 'ºC'),
	(208727, 122, '2014-02-15 00:15:34.000000', 'temperatura', 1059.0000, 'ºC'),
	(208728, 122, '2014-02-15 00:15:35.000000', 'temperatura', 1013.0000, 'ºC'),
	(208729, 122, '2014-02-15 00:15:36.000000', 'temperatura', 688.0000, 'ºC'),
	(208730, 122, '2014-02-15 00:15:37.000000', 'temperatura', 401.0000, 'ºC'),
	(208731, 122, '2014-02-15 00:15:38.000000', 'temperatura', 1143.0000, 'ºC'),
	(208732, 122, '2014-02-15 00:15:39.000000', 'temperatura', 911.0000, 'ºC'),
	(208733, 122, '2014-02-15 00:15:40.000000', 'temperatura', 1126.0000, 'ºC'),
	(208734, 122, '2014-02-15 00:15:41.000000', 'temperatura', 496.0000, 'ºC'),
	(208735, 122, '2014-02-15 00:15:42.000000', 'temperatura', 306.0000, 'ºC'),
	(208736, 122, '2014-02-15 00:15:43.000000', 'temperatura', 40.0000, 'ºC'),
	(208737, 122, '2014-02-15 00:15:44.000000', 'temperatura', 483.0000, 'ºC'),
	(208738, 122, '2014-02-15 00:15:45.000000', 'temperatura', 1094.0000, 'ºC'),
	(208739, 122, '2014-02-15 00:15:46.000000', 'temperatura', 422.0000, 'ºC'),
	(208740, 122, '2014-02-15 00:15:47.000000', 'temperatura', 31.0000, 'ºC'),
	(208741, 122, '2014-02-15 00:15:48.000000', 'temperatura', 88.0000, 'ºC'),
	(208742, 122, '2014-02-15 00:15:49.000000', 'temperatura', 349.0000, 'ºC'),
	(208743, 122, '2014-02-15 00:15:50.000000', 'temperatura', 279.0000, 'ºC'),
	(208744, 122, '2014-02-15 00:15:51.000000', 'temperatura', 348.0000, 'ºC'),
	(208745, 122, '2014-02-15 00:15:52.000000', 'temperatura', 907.0000, 'ºC'),
	(208746, 122, '2014-02-15 00:15:53.000000', 'temperatura', 1088.0000, 'ºC'),
	(208747, 122, '2014-02-15 00:15:54.000000', 'temperatura', 323.0000, 'ºC'),
	(208748, 122, '2014-02-15 00:15:55.000000', 'temperatura', 748.0000, 'ºC'),
	(208749, 122, '2014-02-15 00:15:56.000000', 'temperatura', 373.0000, 'ºC'),
	(208750, 122, '2014-02-15 00:15:57.000000', 'temperatura', 821.0000, 'ºC'),
	(208751, 122, '2014-02-15 00:15:58.000000', 'temperatura', 586.0000, 'ºC'),
	(208752, 122, '2014-02-15 00:15:59.000000', 'temperatura', 469.0000, 'ºC'),
	(208753, 122, '2014-02-15 00:16:00.000000', 'temperatura', 587.0000, 'ºC'),
	(208754, 122, '2014-02-15 00:16:01.000000', 'temperatura', 327.0000, 'ºC'),
	(208755, 122, '2014-02-15 00:16:02.000000', 'temperatura', 1074.0000, 'ºC'),
	(208756, 122, '2014-02-15 00:16:03.000000', 'temperatura', 790.0000, 'ºC'),
	(208757, 122, '2014-02-15 00:16:04.000000', 'temperatura', 730.0000, 'ºC'),
	(208758, 122, '2014-02-15 00:16:05.000000', 'temperatura', 80.0000, 'ºC'),
	(208759, 122, '2014-02-15 00:16:06.000000', 'temperatura', 611.0000, 'ºC'),
	(208760, 122, '2014-02-15 00:16:07.000000', 'temperatura', 414.0000, 'ºC'),
	(208761, 122, '2014-02-15 00:16:08.000000', 'temperatura', 237.0000, 'ºC'),
	(208762, 122, '2014-02-15 00:16:09.000000', 'temperatura', 1146.0000, 'ºC'),
	(208763, 122, '2014-02-15 00:16:10.000000', 'temperatura', 217.0000, 'ºC'),
	(208764, 122, '2014-02-15 00:16:11.000000', 'temperatura', 49.0000, 'ºC'),
	(208765, 122, '2014-02-15 00:16:12.000000', 'temperatura', 793.0000, 'ºC'),
	(208766, 122, '2014-02-15 00:16:13.000000', 'temperatura', 218.0000, 'ºC'),
	(208767, 122, '2014-02-15 00:16:14.000000', 'temperatura', 1113.0000, 'ºC'),
	(208768, 122, '2014-02-15 00:16:15.000000', 'temperatura', 112.0000, 'ºC'),
	(208769, 122, '2014-02-15 00:16:16.000000', 'temperatura', 819.0000, 'ºC'),
	(208770, 122, '2014-02-15 00:16:17.000000', 'temperatura', 160.0000, 'ºC'),
	(208771, 122, '2014-02-15 00:16:18.000000', 'temperatura', 743.0000, 'ºC'),
	(208772, 122, '2014-02-15 00:16:19.000000', 'temperatura', 835.0000, 'ºC'),
	(208773, 122, '2014-02-15 00:16:20.000000', 'temperatura', 746.0000, 'ºC'),
	(208774, 122, '2014-02-15 00:16:21.000000', 'temperatura', 27.0000, 'ºC'),
	(208775, 122, '2014-02-15 00:16:22.000000', 'temperatura', 299.0000, 'ºC'),
	(208776, 122, '2014-02-15 00:16:23.000000', 'temperatura', 214.0000, 'ºC'),
	(208777, 122, '2014-02-15 00:16:24.000000', 'temperatura', 171.0000, 'ºC'),
	(208778, 122, '2014-02-15 00:16:25.000000', 'temperatura', 215.0000, 'ºC'),
	(208779, 122, '2014-02-15 00:16:26.000000', 'temperatura', 563.0000, 'ºC'),
	(208780, 122, '2014-02-15 00:16:27.000000', 'temperatura', 968.0000, 'ºC'),
	(208781, 122, '2014-02-15 00:16:28.000000', 'temperatura', 755.0000, 'ºC'),
	(208782, 122, '2014-02-15 00:16:29.000000', 'temperatura', 868.0000, 'ºC'),
	(208783, 122, '2014-02-15 00:16:30.000000', 'temperatura', 877.0000, 'ºC'),
	(208784, 122, '2014-02-15 00:16:31.000000', 'temperatura', 583.0000, 'ºC'),
	(208785, 122, '2014-02-15 00:16:32.000000', 'temperatura', 283.0000, 'ºC'),
	(208786, 122, '2014-02-15 00:16:33.000000', 'temperatura', 866.0000, 'ºC'),
	(208787, 122, '2014-02-15 00:16:34.000000', 'temperatura', 1080.0000, 'ºC'),
	(208788, 122, '2014-02-15 00:16:35.000000', 'temperatura', 404.0000, 'ºC'),
	(208789, 122, '2014-02-15 00:16:36.000000', 'temperatura', 1179.0000, 'ºC'),
	(208790, 122, '2014-02-15 00:16:37.000000', 'temperatura', 1084.0000, 'ºC'),
	(208791, 122, '2014-02-15 00:16:38.000000', 'temperatura', 682.0000, 'ºC'),
	(208792, 122, '2014-02-15 00:16:39.000000', 'temperatura', 159.0000, 'ºC'),
	(208793, 122, '2014-02-15 00:16:40.000000', 'temperatura', 1150.0000, 'ºC'),
	(208794, 122, '2014-02-15 00:16:41.000000', 'temperatura', 476.0000, 'ºC'),
	(208795, 122, '2014-02-15 00:16:42.000000', 'temperatura', 127.0000, 'ºC'),
	(208796, 122, '2014-02-15 00:16:43.000000', 'temperatura', 408.0000, 'ºC'),
	(208797, 122, '2014-02-15 00:16:44.000000', 'temperatura', 462.0000, 'ºC'),
	(208798, 122, '2014-02-15 00:16:45.000000', 'temperatura', 1085.0000, 'ºC'),
	(208799, 122, '2014-02-15 00:16:46.000000', 'temperatura', 438.0000, 'ºC'),
	(208800, 122, '2014-02-15 00:16:47.000000', 'temperatura', 136.0000, 'ºC'),
	(208801, 122, '2014-02-15 00:16:48.000000', 'temperatura', 566.0000, 'ºC'),
	(208802, 122, '2014-02-15 00:16:49.000000', 'temperatura', 21.0000, 'ºC'),
	(208803, 122, '2014-02-15 00:16:50.000000', 'temperatura', 810.0000, 'ºC'),
	(208804, 122, '2014-02-15 00:16:51.000000', 'temperatura', 387.0000, 'ºC'),
	(208805, 122, '2014-02-15 00:16:52.000000', 'temperatura', 707.0000, 'ºC'),
	(208806, 122, '2014-02-15 00:16:53.000000', 'temperatura', 1172.0000, 'ºC'),
	(208807, 122, '2014-02-15 00:16:54.000000', 'temperatura', 141.0000, 'ºC'),
	(208808, 122, '2014-02-15 00:16:55.000000', 'temperatura', 790.0000, 'ºC'),
	(208809, 122, '2014-02-15 00:16:56.000000', 'temperatura', 1127.0000, 'ºC'),
	(208810, 122, '2014-02-15 00:16:57.000000', 'temperatura', 864.0000, 'ºC'),
	(208811, 122, '2014-02-15 00:16:58.000000', 'temperatura', 940.0000, 'ºC'),
	(208812, 122, '2014-02-15 00:16:59.000000', 'temperatura', 908.0000, 'ºC'),
	(208813, 122, '2014-02-15 00:17:00.000000', 'temperatura', 519.0000, 'ºC'),
	(208814, 122, '2014-02-15 00:17:01.000000', 'temperatura', 1075.0000, 'ºC'),
	(208815, 122, '2014-02-15 00:17:02.000000', 'temperatura', 217.0000, 'ºC'),
	(208816, 122, '2014-02-15 00:17:03.000000', 'temperatura', 259.0000, 'ºC'),
	(208817, 122, '2014-02-15 00:17:04.000000', 'temperatura', 645.0000, 'ºC'),
	(208818, 122, '2014-02-15 00:17:05.000000', 'temperatura', 48.0000, 'ºC'),
	(208819, 122, '2014-02-15 00:17:06.000000', 'temperatura', 707.0000, 'ºC'),
	(208820, 122, '2014-02-15 00:17:07.000000', 'temperatura', 991.0000, 'ºC'),
	(208821, 122, '2014-02-15 00:17:08.000000', 'temperatura', 436.0000, 'ºC'),
	(208822, 122, '2014-02-15 00:17:09.000000', 'temperatura', 406.0000, 'ºC'),
	(208823, 122, '2014-02-15 00:17:10.000000', 'temperatura', 722.0000, 'ºC'),
	(208824, 122, '2014-02-15 00:17:11.000000', 'temperatura', 1194.0000, 'ºC'),
	(208825, 122, '2014-02-15 00:17:12.000000', 'temperatura', 205.0000, 'ºC'),
	(208826, 122, '2014-02-15 00:17:13.000000', 'temperatura', 1042.0000, 'ºC'),
	(208827, 122, '2014-02-15 00:17:14.000000', 'temperatura', 996.0000, 'ºC'),
	(208828, 122, '2014-02-15 00:17:15.000000', 'temperatura', 654.0000, 'ºC'),
	(208829, 122, '2014-02-15 00:17:16.000000', 'temperatura', 285.0000, 'ºC'),
	(208830, 122, '2014-02-15 00:17:17.000000', 'temperatura', 662.0000, 'ºC'),
	(208831, 122, '2014-02-15 00:17:18.000000', 'temperatura', 54.0000, 'ºC'),
	(208832, 122, '2014-02-15 00:17:19.000000', 'temperatura', 684.0000, 'ºC'),
	(208833, 122, '2014-02-15 00:17:20.000000', 'temperatura', 860.0000, 'ºC'),
	(208834, 122, '2014-02-15 00:17:21.000000', 'temperatura', 1048.0000, 'ºC'),
	(208835, 122, '2014-02-15 00:17:22.000000', 'temperatura', 259.0000, 'ºC'),
	(208836, 122, '2014-02-15 00:17:23.000000', 'temperatura', 554.0000, 'ºC'),
	(208837, 122, '2014-02-15 00:17:24.000000', 'temperatura', 791.0000, 'ºC'),
	(208838, 122, '2014-02-15 00:17:25.000000', 'temperatura', 1095.0000, 'ºC'),
	(208839, 122, '2014-02-15 00:17:26.000000', 'temperatura', 702.0000, 'ºC'),
	(208840, 122, '2014-02-15 00:17:27.000000', 'temperatura', 227.0000, 'ºC'),
	(208841, 122, '2014-02-15 00:17:28.000000', 'temperatura', 227.0000, 'ºC'),
	(208842, 122, '2014-02-15 00:17:29.000000', 'temperatura', 455.0000, 'ºC'),
	(208843, 122, '2014-02-15 00:17:30.000000', 'temperatura', 395.0000, 'ºC'),
	(208844, 122, '2014-02-15 00:17:31.000000', 'temperatura', 611.0000, 'ºC'),
	(208845, 122, '2014-02-15 00:17:32.000000', 'temperatura', 672.0000, 'ºC'),
	(208846, 122, '2014-02-15 00:17:33.000000', 'temperatura', 326.0000, 'ºC'),
	(208847, 122, '2014-02-15 00:17:34.000000', 'temperatura', 816.0000, 'ºC'),
	(208848, 122, '2014-02-15 00:17:35.000000', 'temperatura', 700.0000, 'ºC'),
	(208849, 122, '2014-02-15 00:17:36.000000', 'temperatura', 1055.0000, 'ºC'),
	(208850, 122, '2014-02-15 00:17:37.000000', 'temperatura', 775.0000, 'ºC'),
	(208851, 122, '2014-02-15 00:17:38.000000', 'temperatura', 710.0000, 'ºC'),
	(208852, 122, '2014-02-15 00:17:39.000000', 'temperatura', 24.0000, 'ºC'),
	(208853, 122, '2014-02-15 00:17:40.000000', 'temperatura', 390.0000, 'ºC'),
	(208854, 122, '2014-02-15 00:17:41.000000', 'temperatura', 681.0000, 'ºC'),
	(208855, 122, '2014-02-15 00:17:42.000000', 'temperatura', 1034.0000, 'ºC'),
	(208856, 122, '2014-02-15 00:17:43.000000', 'temperatura', 730.0000, 'ºC'),
	(208857, 122, '2014-02-15 00:17:44.000000', 'temperatura', 545.0000, 'ºC'),
	(208858, 122, '2014-02-15 00:17:45.000000', 'temperatura', 537.0000, 'ºC'),
	(208859, 122, '2014-02-15 00:17:46.000000', 'temperatura', 1050.0000, 'ºC'),
	(208860, 122, '2014-02-15 00:17:47.000000', 'temperatura', 38.0000, 'ºC'),
	(208861, 122, '2014-02-15 00:17:48.000000', 'temperatura', 641.0000, 'ºC'),
	(208862, 122, '2014-02-15 00:17:49.000000', 'temperatura', 693.0000, 'ºC'),
	(208863, 122, '2014-02-15 00:17:50.000000', 'temperatura', 340.0000, 'ºC'),
	(208864, 122, '2014-02-15 00:17:51.000000', 'temperatura', 822.0000, 'ºC'),
	(208865, 122, '2014-02-15 00:17:52.000000', 'temperatura', 690.0000, 'ºC'),
	(208866, 122, '2014-02-15 00:17:53.000000', 'temperatura', 985.0000, 'ºC'),
	(208867, 122, '2014-02-15 00:17:54.000000', 'temperatura', 454.0000, 'ºC'),
	(208868, 122, '2014-02-15 00:17:55.000000', 'temperatura', 517.0000, 'ºC'),
	(208869, 122, '2014-02-15 00:17:56.000000', 'temperatura', 21.0000, 'ºC'),
	(208870, 122, '2014-02-15 00:17:57.000000', 'temperatura', 957.0000, 'ºC'),
	(208871, 122, '2014-02-15 00:17:58.000000', 'temperatura', 1120.0000, 'ºC'),
	(208872, 122, '2014-02-15 00:17:59.000000', 'temperatura', 331.0000, 'ºC'),
	(208873, 122, '2014-02-15 00:18:00.000000', 'temperatura', 693.0000, 'ºC'),
	(208874, 122, '2014-02-15 00:18:01.000000', 'temperatura', 76.0000, 'ºC'),
	(208875, 122, '2014-02-15 00:18:02.000000', 'temperatura', 701.0000, 'ºC'),
	(208876, 122, '2014-02-15 00:18:03.000000', 'temperatura', 876.0000, 'ºC'),
	(208877, 122, '2014-02-15 00:18:04.000000', 'temperatura', 1076.0000, 'ºC'),
	(208878, 122, '2014-02-15 00:18:05.000000', 'temperatura', 356.0000, 'ºC'),
	(208879, 122, '2014-02-15 00:18:06.000000', 'temperatura', 949.0000, 'ºC'),
	(208880, 122, '2014-02-15 00:18:07.000000', 'temperatura', 81.0000, 'ºC'),
	(208881, 122, '2014-02-15 00:18:08.000000', 'temperatura', 1156.0000, 'ºC'),
	(208882, 122, '2014-02-15 00:18:09.000000', 'temperatura', 737.0000, 'ºC'),
	(208883, 122, '2014-02-15 00:18:10.000000', 'temperatura', 216.0000, 'ºC'),
	(208884, 122, '2014-02-15 00:18:11.000000', 'temperatura', 73.0000, 'ºC'),
	(208885, 122, '2014-02-15 00:18:12.000000', 'temperatura', 914.0000, 'ºC'),
	(208886, 122, '2014-02-15 00:18:13.000000', 'temperatura', 755.0000, 'ºC'),
	(208887, 122, '2014-02-15 00:18:14.000000', 'temperatura', 1030.0000, 'ºC'),
	(208888, 122, '2014-02-15 00:18:15.000000', 'temperatura', 488.0000, 'ºC'),
	(208889, 122, '2014-02-15 00:18:16.000000', 'temperatura', 549.0000, 'ºC'),
	(208890, 122, '2014-02-15 00:18:17.000000', 'temperatura', 84.0000, 'ºC'),
	(208891, 122, '2014-02-15 00:18:18.000000', 'temperatura', 1172.0000, 'ºC'),
	(208892, 122, '2014-02-15 00:18:19.000000', 'temperatura', 807.0000, 'ºC'),
	(208893, 122, '2014-02-15 00:18:20.000000', 'temperatura', 521.0000, 'ºC'),
	(208894, 122, '2014-02-15 00:18:21.000000', 'temperatura', 186.0000, 'ºC'),
	(208895, 122, '2014-02-15 00:18:22.000000', 'temperatura', 566.0000, 'ºC'),
	(208896, 122, '2014-02-15 00:18:23.000000', 'temperatura', 1072.0000, 'ºC'),
	(208897, 122, '2014-02-15 00:18:24.000000', 'temperatura', 65.0000, 'ºC'),
	(208898, 122, '2014-02-15 00:18:25.000000', 'temperatura', 707.0000, 'ºC'),
	(208899, 122, '2014-02-15 00:18:26.000000', 'temperatura', 940.0000, 'ºC'),
	(208900, 122, '2014-02-15 00:18:27.000000', 'temperatura', 181.0000, 'ºC'),
	(208901, 122, '2014-02-15 00:18:28.000000', 'temperatura', 486.0000, 'ºC'),
	(208902, 122, '2014-02-15 00:18:29.000000', 'temperatura', 688.0000, 'ºC'),
	(208903, 122, '2014-02-15 00:18:30.000000', 'temperatura', 783.0000, 'ºC'),
	(208904, 122, '2014-02-15 00:18:31.000000', 'temperatura', 653.0000, 'ºC'),
	(208905, 122, '2014-02-15 00:18:32.000000', 'temperatura', 913.0000, 'ºC'),
	(208906, 122, '2014-02-15 00:18:33.000000', 'temperatura', 208.0000, 'ºC'),
	(208907, 122, '2014-02-15 00:18:34.000000', 'temperatura', 700.0000, 'ºC'),
	(208908, 122, '2014-02-15 00:18:35.000000', 'temperatura', 478.0000, 'ºC'),
	(208909, 122, '2014-02-15 00:18:36.000000', 'temperatura', 289.0000, 'ºC'),
	(208910, 122, '2014-02-15 00:18:37.000000', 'temperatura', 14.0000, 'ºC'),
	(208911, 122, '2014-02-15 00:18:38.000000', 'temperatura', 404.0000, 'ºC'),
	(208912, 122, '2014-02-15 00:18:39.000000', 'temperatura', 776.0000, 'ºC'),
	(208913, 122, '2014-02-15 00:18:40.000000', 'temperatura', 268.0000, 'ºC'),
	(208914, 122, '2014-02-15 00:18:41.000000', 'temperatura', 213.0000, 'ºC'),
	(208915, 122, '2014-02-15 00:18:42.000000', 'temperatura', 261.0000, 'ºC'),
	(208916, 122, '2014-02-15 00:18:43.000000', 'temperatura', 665.0000, 'ºC'),
	(208917, 122, '2014-02-15 00:18:44.000000', 'temperatura', 145.0000, 'ºC'),
	(208918, 122, '2014-02-15 00:18:45.000000', 'temperatura', 1130.0000, 'ºC'),
	(208919, 122, '2014-02-15 00:18:46.000000', 'temperatura', 414.0000, 'ºC'),
	(208920, 122, '2014-02-15 00:18:47.000000', 'temperatura', 1082.0000, 'ºC'),
	(208921, 122, '2014-02-15 00:18:48.000000', 'temperatura', 569.0000, 'ºC'),
	(208922, 122, '2014-02-15 00:18:49.000000', 'temperatura', 798.0000, 'ºC'),
	(208923, 122, '2014-02-15 00:18:50.000000', 'temperatura', 1085.0000, 'ºC'),
	(208924, 122, '2014-02-15 00:18:51.000000', 'temperatura', 630.0000, 'ºC'),
	(208925, 122, '2014-02-15 00:18:52.000000', 'temperatura', 1098.0000, 'ºC'),
	(208926, 122, '2014-02-15 00:18:53.000000', 'temperatura', 1199.0000, 'ºC'),
	(208927, 122, '2014-02-15 00:18:54.000000', 'temperatura', 301.0000, 'ºC'),
	(208928, 122, '2014-02-15 00:18:55.000000', 'temperatura', 310.0000, 'ºC'),
	(208929, 122, '2014-02-15 00:18:56.000000', 'temperatura', 647.0000, 'ºC'),
	(208930, 122, '2014-02-15 00:18:57.000000', 'temperatura', 1105.0000, 'ºC'),
	(208931, 122, '2014-02-15 00:18:58.000000', 'temperatura', 1186.0000, 'ºC'),
	(208932, 122, '2014-02-15 00:18:59.000000', 'temperatura', 213.0000, 'ºC'),
	(208933, 122, '2014-02-15 00:19:00.000000', 'temperatura', 1110.0000, 'ºC'),
	(208934, 122, '2014-02-15 00:19:01.000000', 'temperatura', 111.0000, 'ºC'),
	(208935, 122, '2014-02-15 00:19:02.000000', 'temperatura', 825.0000, 'ºC'),
	(208936, 122, '2014-02-15 00:19:03.000000', 'temperatura', 193.0000, 'ºC'),
	(208937, 122, '2014-02-15 00:19:04.000000', 'temperatura', 891.0000, 'ºC'),
	(208938, 122, '2014-02-15 00:19:05.000000', 'temperatura', 276.0000, 'ºC'),
	(208939, 122, '2014-02-15 00:19:06.000000', 'temperatura', 1108.0000, 'ºC'),
	(208940, 122, '2014-02-15 00:19:07.000000', 'temperatura', 1111.0000, 'ºC'),
	(208941, 122, '2014-02-15 00:19:08.000000', 'temperatura', 1033.0000, 'ºC'),
	(208942, 122, '2014-02-15 00:19:09.000000', 'temperatura', 632.0000, 'ºC'),
	(208943, 122, '2014-02-15 00:19:10.000000', 'temperatura', 60.0000, 'ºC'),
	(208944, 122, '2014-02-15 00:19:11.000000', 'temperatura', 805.0000, 'ºC'),
	(208945, 122, '2014-02-15 00:19:12.000000', 'temperatura', 244.0000, 'ºC'),
	(208946, 122, '2014-02-15 00:19:13.000000', 'temperatura', 7.0000, 'ºC'),
	(208947, 122, '2014-02-15 00:19:14.000000', 'temperatura', 505.0000, 'ºC'),
	(208948, 122, '2014-02-15 00:19:15.000000', 'temperatura', 103.0000, 'ºC'),
	(208949, 122, '2014-02-15 00:19:16.000000', 'temperatura', 202.0000, 'ºC'),
	(208950, 122, '2014-02-15 00:19:17.000000', 'temperatura', 700.0000, 'ºC'),
	(208951, 122, '2014-02-15 00:19:18.000000', 'temperatura', 495.0000, 'ºC'),
	(208952, 122, '2014-02-15 00:19:19.000000', 'temperatura', 374.0000, 'ºC'),
	(208953, 122, '2014-02-15 00:19:20.000000', 'temperatura', 388.0000, 'ºC'),
	(208954, 122, '2014-02-15 00:19:21.000000', 'temperatura', 819.0000, 'ºC'),
	(208955, 122, '2014-02-15 00:19:22.000000', 'temperatura', 531.0000, 'ºC'),
	(208956, 122, '2014-02-15 00:19:23.000000', 'temperatura', 197.0000, 'ºC'),
	(208957, 122, '2014-02-15 00:19:24.000000', 'temperatura', 595.0000, 'ºC'),
	(208958, 122, '2014-02-15 00:19:25.000000', 'temperatura', 1183.0000, 'ºC'),
	(208959, 122, '2014-02-15 00:19:26.000000', 'temperatura', 532.0000, 'ºC'),
	(208960, 122, '2014-02-15 00:19:27.000000', 'temperatura', 312.0000, 'ºC'),
	(208961, 122, '2014-02-15 00:19:28.000000', 'temperatura', 1165.0000, 'ºC'),
	(208962, 122, '2014-02-15 00:19:29.000000', 'temperatura', 87.0000, 'ºC'),
	(208963, 122, '2014-02-15 00:19:30.000000', 'temperatura', 541.0000, 'ºC'),
	(208964, 122, '2014-02-15 00:19:31.000000', 'temperatura', 44.0000, 'ºC'),
	(208965, 122, '2014-02-15 00:19:32.000000', 'temperatura', 997.0000, 'ºC'),
	(208966, 122, '2014-02-15 00:19:33.000000', 'temperatura', 52.0000, 'ºC'),
	(208967, 122, '2014-02-15 00:19:34.000000', 'temperatura', 872.0000, 'ºC'),
	(208968, 122, '2014-02-15 00:19:35.000000', 'temperatura', 606.0000, 'ºC'),
	(208969, 122, '2014-02-15 00:19:36.000000', 'temperatura', 413.0000, 'ºC'),
	(208970, 122, '2014-02-15 00:19:37.000000', 'temperatura', 245.0000, 'ºC'),
	(208971, 122, '2014-02-15 00:19:38.000000', 'temperatura', 1190.0000, 'ºC'),
	(208972, 122, '2014-02-15 00:19:39.000000', 'temperatura', 415.0000, 'ºC'),
	(208973, 122, '2014-02-15 00:19:40.000000', 'temperatura', 905.0000, 'ºC'),
	(208974, 122, '2014-02-15 00:19:41.000000', 'temperatura', 879.0000, 'ºC'),
	(208975, 122, '2014-02-15 00:19:42.000000', 'temperatura', 480.0000, 'ºC'),
	(208976, 122, '2014-02-15 00:19:43.000000', 'temperatura', 963.0000, 'ºC'),
	(208977, 122, '2014-02-15 00:19:44.000000', 'temperatura', 979.0000, 'ºC'),
	(208978, 122, '2014-02-15 00:19:45.000000', 'temperatura', 804.0000, 'ºC'),
	(208979, 122, '2014-02-15 00:19:46.000000', 'temperatura', 1082.0000, 'ºC'),
	(208980, 122, '2014-02-15 00:19:47.000000', 'temperatura', 600.0000, 'ºC'),
	(208981, 122, '2014-02-15 00:19:48.000000', 'temperatura', 953.0000, 'ºC'),
	(208982, 122, '2014-02-15 00:19:49.000000', 'temperatura', 567.0000, 'ºC'),
	(208983, 122, '2014-02-15 00:19:50.000000', 'temperatura', 1178.0000, 'ºC'),
	(208984, 122, '2014-02-15 00:19:51.000000', 'temperatura', 588.0000, 'ºC'),
	(208985, 122, '2014-02-15 00:19:52.000000', 'temperatura', 609.0000, 'ºC'),
	(208986, 122, '2014-02-15 00:19:53.000000', 'temperatura', 78.0000, 'ºC'),
	(208987, 122, '2014-02-15 00:19:54.000000', 'temperatura', 964.0000, 'ºC'),
	(208988, 122, '2014-02-15 00:19:55.000000', 'temperatura', 988.0000, 'ºC'),
	(208989, 122, '2014-02-15 00:19:56.000000', 'temperatura', 848.0000, 'ºC'),
	(208990, 122, '2014-02-15 00:19:57.000000', 'temperatura', 74.0000, 'ºC'),
	(208991, 122, '2014-02-15 00:19:58.000000', 'temperatura', 230.0000, 'ºC'),
	(208992, 122, '2014-02-15 00:19:59.000000', 'temperatura', 926.0000, 'ºC'),
	(208993, 122, '2014-02-15 00:20:00.000000', 'temperatura', 339.0000, 'ºC'),
	(208994, 122, '2014-02-15 00:20:01.000000', 'temperatura', 121.0000, 'ºC'),
	(208995, 122, '2014-02-15 00:20:02.000000', 'temperatura', 788.0000, 'ºC'),
	(208996, 122, '2014-02-15 00:20:03.000000', 'temperatura', 1175.0000, 'ºC'),
	(208997, 122, '2014-02-15 00:20:04.000000', 'temperatura', 1112.0000, 'ºC'),
	(208998, 122, '2014-02-15 00:20:05.000000', 'temperatura', 837.0000, 'ºC'),
	(208999, 122, '2014-02-15 00:20:06.000000', 'temperatura', 848.0000, 'ºC'),
	(209000, 122, '2014-02-15 00:20:07.000000', 'temperatura', 531.0000, 'ºC'),
	(209001, 122, '2014-02-15 00:20:08.000000', 'temperatura', 109.0000, 'ºC'),
	(209002, 122, '2014-02-15 00:20:09.000000', 'temperatura', 153.0000, 'ºC'),
	(209003, 122, '2014-02-15 00:20:10.000000', 'temperatura', 439.0000, 'ºC'),
	(209004, 122, '2014-02-15 00:20:11.000000', 'temperatura', 535.0000, 'ºC'),
	(209005, 122, '2014-02-15 00:20:12.000000', 'temperatura', 161.0000, 'ºC'),
	(209006, 122, '2014-02-15 00:20:13.000000', 'temperatura', 397.0000, 'ºC'),
	(209007, 122, '2014-02-15 00:20:14.000000', 'temperatura', 306.0000, 'ºC'),
	(209008, 122, '2014-02-15 00:20:15.000000', 'temperatura', 338.0000, 'ºC'),
	(209009, 122, '2014-02-15 00:20:16.000000', 'temperatura', 771.0000, 'ºC'),
	(209010, 122, '2014-02-15 00:20:17.000000', 'temperatura', 445.0000, 'ºC'),
	(209011, 122, '2014-02-15 00:20:18.000000', 'temperatura', 1109.0000, 'ºC'),
	(209012, 122, '2014-02-15 00:20:19.000000', 'temperatura', 613.0000, 'ºC'),
	(209013, 122, '2014-02-15 00:20:20.000000', 'temperatura', 939.0000, 'ºC'),
	(209014, 122, '2014-02-15 00:20:21.000000', 'temperatura', 455.0000, 'ºC'),
	(209015, 122, '2014-02-15 00:20:22.000000', 'temperatura', 659.0000, 'ºC'),
	(209016, 122, '2014-02-15 00:20:23.000000', 'temperatura', 729.0000, 'ºC'),
	(209017, 122, '2014-02-15 00:20:24.000000', 'temperatura', 472.0000, 'ºC'),
	(209018, 122, '2014-02-15 00:20:25.000000', 'temperatura', 170.0000, 'ºC'),
	(209019, 122, '2014-02-15 00:20:26.000000', 'temperatura', 635.0000, 'ºC'),
	(209020, 122, '2014-02-15 00:20:27.000000', 'temperatura', 266.0000, 'ºC'),
	(209021, 122, '2014-02-15 00:20:28.000000', 'temperatura', 628.0000, 'ºC'),
	(209022, 122, '2014-02-15 00:20:29.000000', 'temperatura', 1139.0000, 'ºC'),
	(209023, 122, '2014-02-15 00:20:30.000000', 'temperatura', 212.0000, 'ºC'),
	(209024, 122, '2014-02-15 00:20:31.000000', 'temperatura', 45.0000, 'ºC'),
	(209025, 122, '2014-02-15 00:20:32.000000', 'temperatura', 787.0000, 'ºC'),
	(209026, 122, '2014-02-15 00:20:33.000000', 'temperatura', 202.0000, 'ºC'),
	(209027, 122, '2014-02-15 00:20:34.000000', 'temperatura', 1047.0000, 'ºC'),
	(209028, 122, '2014-02-15 00:20:35.000000', 'temperatura', 1032.0000, 'ºC'),
	(209029, 122, '2014-02-15 00:20:36.000000', 'temperatura', 821.0000, 'ºC'),
	(209030, 122, '2014-02-15 00:20:37.000000', 'temperatura', 1007.0000, 'ºC'),
	(209031, 122, '2014-02-15 00:20:38.000000', 'temperatura', 173.0000, 'ºC'),
	(209032, 122, '2014-02-15 00:20:39.000000', 'temperatura', 246.0000, 'ºC'),
	(209033, 122, '2014-02-15 00:20:40.000000', 'temperatura', 709.0000, 'ºC'),
	(209034, 122, '2014-02-15 00:20:41.000000', 'temperatura', 406.0000, 'ºC'),
	(209035, 122, '2014-02-15 00:20:42.000000', 'temperatura', 1107.0000, 'ºC'),
	(209036, 122, '2014-02-15 00:20:43.000000', 'temperatura', 717.0000, 'ºC'),
	(209037, 122, '2014-02-15 00:20:44.000000', 'temperatura', 265.0000, 'ºC'),
	(209038, 122, '2014-02-15 00:20:45.000000', 'temperatura', 372.0000, 'ºC'),
	(209039, 122, '2014-02-15 00:20:46.000000', 'temperatura', 1067.0000, 'ºC'),
	(209040, 122, '2014-02-15 00:20:47.000000', 'temperatura', 618.0000, 'ºC'),
	(209041, 122, '2014-02-15 00:20:48.000000', 'temperatura', 1091.0000, 'ºC'),
	(209042, 122, '2014-02-15 00:20:49.000000', 'temperatura', 0.0000, 'ºC'),
	(209043, 122, '2014-02-15 00:20:50.000000', 'temperatura', 330.0000, 'ºC'),
	(209044, 122, '2014-02-15 00:20:51.000000', 'temperatura', 448.0000, 'ºC'),
	(209045, 122, '2014-02-15 00:20:52.000000', 'temperatura', 53.0000, 'ºC'),
	(209046, 122, '2014-02-15 00:20:53.000000', 'temperatura', 122.0000, 'ºC'),
	(209047, 122, '2014-02-15 00:20:54.000000', 'temperatura', 451.0000, 'ºC'),
	(209048, 122, '2014-02-15 00:20:55.000000', 'temperatura', 687.0000, 'ºC'),
	(209049, 122, '2014-02-15 00:20:56.000000', 'temperatura', 886.0000, 'ºC'),
	(209050, 122, '2014-02-15 00:20:57.000000', 'temperatura', 1168.0000, 'ºC'),
	(209051, 122, '2014-02-15 00:20:58.000000', 'temperatura', 782.0000, 'ºC'),
	(209052, 122, '2014-02-15 00:20:59.000000', 'temperatura', 409.0000, 'ºC'),
	(209053, 122, '2014-02-15 00:21:00.000000', 'temperatura', 897.0000, 'ºC'),
	(209054, 122, '2014-02-15 00:21:01.000000', 'temperatura', 859.0000, 'ºC'),
	(209055, 122, '2014-02-15 00:21:02.000000', 'temperatura', 403.0000, 'ºC'),
	(209056, 122, '2014-02-15 00:21:03.000000', 'temperatura', 640.0000, 'ºC'),
	(209057, 122, '2014-02-15 00:21:04.000000', 'temperatura', 789.0000, 'ºC'),
	(209058, 122, '2014-02-15 00:21:05.000000', 'temperatura', 829.0000, 'ºC'),
	(209059, 122, '2014-02-15 00:21:06.000000', 'temperatura', 577.0000, 'ºC'),
	(209060, 122, '2014-02-15 00:21:07.000000', 'temperatura', 399.0000, 'ºC'),
	(209061, 122, '2014-02-15 00:21:08.000000', 'temperatura', 265.0000, 'ºC'),
	(209062, 122, '2014-02-15 00:21:09.000000', 'temperatura', 127.0000, 'ºC'),
	(209063, 122, '2014-02-15 00:21:10.000000', 'temperatura', 1040.0000, 'ºC'),
	(209064, 122, '2014-02-15 00:21:11.000000', 'temperatura', 20.0000, 'ºC'),
	(209065, 122, '2014-02-15 00:21:12.000000', 'temperatura', 580.0000, 'ºC'),
	(209066, 122, '2014-02-15 00:21:13.000000', 'temperatura', 441.0000, 'ºC'),
	(209067, 122, '2014-02-15 00:21:14.000000', 'temperatura', 465.0000, 'ºC'),
	(209068, 122, '2014-02-15 00:21:15.000000', 'temperatura', 1003.0000, 'ºC'),
	(209069, 122, '2014-02-15 00:21:16.000000', 'temperatura', 20.0000, 'ºC'),
	(209070, 122, '2014-02-15 00:21:17.000000', 'temperatura', 692.0000, 'ºC'),
	(209071, 122, '2014-02-15 00:21:18.000000', 'temperatura', 999.0000, 'ºC'),
	(209072, 122, '2014-02-15 00:21:19.000000', 'temperatura', 522.0000, 'ºC'),
	(209073, 122, '2014-02-15 00:21:20.000000', 'temperatura', 813.0000, 'ºC'),
	(209074, 122, '2014-02-15 00:21:21.000000', 'temperatura', 101.0000, 'ºC'),
	(209075, 122, '2014-02-15 00:21:22.000000', 'temperatura', 464.0000, 'ºC'),
	(209076, 122, '2014-02-15 00:21:23.000000', 'temperatura', 817.0000, 'ºC'),
	(209077, 122, '2014-02-15 00:21:24.000000', 'temperatura', 296.0000, 'ºC'),
	(209078, 122, '2014-02-15 00:21:25.000000', 'temperatura', 229.0000, 'ºC'),
	(209079, 122, '2014-02-15 00:21:26.000000', 'temperatura', 255.0000, 'ºC'),
	(209080, 122, '2014-02-15 00:21:27.000000', 'temperatura', 592.0000, 'ºC'),
	(209081, 122, '2014-02-15 00:21:28.000000', 'temperatura', 994.0000, 'ºC'),
	(209082, 122, '2014-02-15 00:21:29.000000', 'temperatura', 794.0000, 'ºC'),
	(209083, 122, '2014-02-15 00:21:30.000000', 'temperatura', 988.0000, 'ºC'),
	(209084, 122, '2014-02-15 00:21:31.000000', 'temperatura', 160.0000, 'ºC'),
	(209085, 122, '2014-02-15 00:21:32.000000', 'temperatura', 235.0000, 'ºC'),
	(209086, 122, '2014-02-15 00:21:33.000000', 'temperatura', 698.0000, 'ºC'),
	(209087, 122, '2014-02-15 00:21:34.000000', 'temperatura', 384.0000, 'ºC'),
	(209088, 122, '2014-02-15 00:21:35.000000', 'temperatura', 1026.0000, 'ºC'),
	(209089, 122, '2014-02-15 00:21:36.000000', 'temperatura', 380.0000, 'ºC'),
	(209090, 122, '2014-02-15 00:21:37.000000', 'temperatura', 21.0000, 'ºC'),
	(209091, 122, '2014-02-15 00:21:38.000000', 'temperatura', 165.0000, 'ºC'),
	(209092, 122, '2014-02-15 00:21:39.000000', 'temperatura', 765.0000, 'ºC'),
	(209093, 122, '2014-02-15 00:21:40.000000', 'temperatura', 930.0000, 'ºC'),
	(209094, 122, '2014-02-15 00:21:41.000000', 'temperatura', 1155.0000, 'ºC'),
	(209095, 122, '2014-02-15 00:21:42.000000', 'temperatura', 587.0000, 'ºC'),
	(209096, 122, '2014-02-15 00:21:43.000000', 'temperatura', 669.0000, 'ºC'),
	(209097, 122, '2014-02-15 00:21:44.000000', 'temperatura', 383.0000, 'ºC'),
	(209098, 122, '2014-02-15 00:21:45.000000', 'temperatura', 1109.0000, 'ºC'),
	(209099, 122, '2014-02-15 00:21:46.000000', 'temperatura', 795.0000, 'ºC'),
	(209100, 122, '2014-02-15 00:21:47.000000', 'temperatura', 650.0000, 'ºC'),
	(209101, 122, '2014-02-15 00:21:48.000000', 'temperatura', 864.0000, 'ºC'),
	(209102, 122, '2014-02-15 00:21:49.000000', 'temperatura', 1173.0000, 'ºC'),
	(209103, 122, '2014-02-15 00:21:50.000000', 'temperatura', 871.0000, 'ºC'),
	(209104, 122, '2014-02-15 00:21:51.000000', 'temperatura', 836.0000, 'ºC'),
	(209105, 122, '2014-02-15 00:21:52.000000', 'temperatura', 371.0000, 'ºC'),
	(209106, 122, '2014-02-15 00:21:53.000000', 'temperatura', 544.0000, 'ºC'),
	(209107, 122, '2014-02-15 00:21:54.000000', 'temperatura', 410.0000, 'ºC'),
	(209108, 122, '2014-02-15 00:21:55.000000', 'temperatura', 418.0000, 'ºC'),
	(209109, 122, '2014-02-15 00:21:56.000000', 'temperatura', 859.0000, 'ºC'),
	(209110, 122, '2014-02-15 00:21:57.000000', 'temperatura', 642.0000, 'ºC'),
	(209111, 122, '2014-02-15 00:21:58.000000', 'temperatura', 635.0000, 'ºC'),
	(209112, 122, '2014-02-15 00:21:59.000000', 'temperatura', 51.0000, 'ºC'),
	(209113, 122, '2014-02-15 00:22:00.000000', 'temperatura', 747.0000, 'ºC'),
	(209114, 122, '2014-02-15 00:22:01.000000', 'temperatura', 1183.0000, 'ºC'),
	(209115, 122, '2014-02-15 00:22:02.000000', 'temperatura', 77.0000, 'ºC'),
	(209116, 122, '2014-02-15 00:22:03.000000', 'temperatura', 435.0000, 'ºC'),
	(209117, 122, '2014-02-15 00:22:04.000000', 'temperatura', 744.0000, 'ºC'),
	(209118, 122, '2014-02-15 00:22:05.000000', 'temperatura', 15.0000, 'ºC'),
	(209119, 122, '2014-02-15 00:22:06.000000', 'temperatura', 246.0000, 'ºC'),
	(209120, 122, '2014-02-15 00:22:07.000000', 'temperatura', 1185.0000, 'ºC'),
	(209121, 122, '2014-02-15 00:22:08.000000', 'temperatura', 388.0000, 'ºC'),
	(209122, 122, '2014-02-15 00:22:09.000000', 'temperatura', 785.0000, 'ºC'),
	(209123, 122, '2014-02-15 00:22:10.000000', 'temperatura', 363.0000, 'ºC'),
	(209124, 122, '2014-02-15 00:22:11.000000', 'temperatura', 659.0000, 'ºC'),
	(209125, 122, '2014-02-15 00:22:12.000000', 'temperatura', 1007.0000, 'ºC'),
	(209126, 122, '2014-02-15 00:22:13.000000', 'temperatura', 659.0000, 'ºC'),
	(209127, 122, '2014-02-15 00:22:14.000000', 'temperatura', 274.0000, 'ºC'),
	(209128, 122, '2014-02-15 00:22:15.000000', 'temperatura', 594.0000, 'ºC'),
	(209129, 122, '2014-02-15 00:22:16.000000', 'temperatura', 950.0000, 'ºC'),
	(209130, 122, '2014-02-15 00:22:17.000000', 'temperatura', 566.0000, 'ºC'),
	(209131, 122, '2014-02-15 00:22:18.000000', 'temperatura', 1183.0000, 'ºC'),
	(209132, 122, '2014-02-15 00:22:19.000000', 'temperatura', 616.0000, 'ºC'),
	(209133, 122, '2014-02-15 00:22:20.000000', 'temperatura', 732.0000, 'ºC'),
	(209134, 122, '2014-02-15 00:22:21.000000', 'temperatura', 611.0000, 'ºC'),
	(209135, 122, '2014-02-15 00:22:22.000000', 'temperatura', 859.0000, 'ºC'),
	(209136, 122, '2014-02-15 00:22:23.000000', 'temperatura', 66.0000, 'ºC'),
	(209137, 122, '2014-02-15 00:22:24.000000', 'temperatura', 150.0000, 'ºC'),
	(209138, 122, '2014-02-15 00:22:25.000000', 'temperatura', 554.0000, 'ºC'),
	(209139, 122, '2014-02-15 00:22:26.000000', 'temperatura', 1122.0000, 'ºC'),
	(209140, 122, '2014-02-15 00:22:27.000000', 'temperatura', 349.0000, 'ºC'),
	(209141, 122, '2014-02-15 00:22:28.000000', 'temperatura', 777.0000, 'ºC'),
	(209142, 122, '2014-02-15 00:22:29.000000', 'temperatura', 438.0000, 'ºC'),
	(209143, 122, '2014-02-15 00:22:30.000000', 'temperatura', 1059.0000, 'ºC'),
	(209144, 122, '2014-02-15 00:22:31.000000', 'temperatura', 384.0000, 'ºC'),
	(209145, 122, '2014-02-15 00:22:32.000000', 'temperatura', 1143.0000, 'ºC'),
	(209146, 122, '2014-02-15 00:22:33.000000', 'temperatura', 965.0000, 'ºC'),
	(209147, 122, '2014-02-15 00:22:34.000000', 'temperatura', 194.0000, 'ºC'),
	(209148, 122, '2014-02-15 00:22:35.000000', 'temperatura', 477.0000, 'ºC'),
	(209149, 122, '2014-02-15 00:22:36.000000', 'temperatura', 604.0000, 'ºC'),
	(209150, 122, '2014-02-15 00:22:37.000000', 'temperatura', 389.0000, 'ºC'),
	(209151, 122, '2014-02-15 00:22:38.000000', 'temperatura', 134.0000, 'ºC'),
	(209152, 122, '2014-02-15 00:22:39.000000', 'temperatura', 704.0000, 'ºC'),
	(209153, 122, '2014-02-15 00:22:40.000000', 'temperatura', 720.0000, 'ºC'),
	(209154, 122, '2014-02-15 00:22:41.000000', 'temperatura', 286.0000, 'ºC'),
	(209155, 122, '2014-02-15 00:22:42.000000', 'temperatura', 470.0000, 'ºC'),
	(209156, 122, '2014-02-15 00:22:43.000000', 'temperatura', 294.0000, 'ºC'),
	(209157, 122, '2014-02-15 00:22:44.000000', 'temperatura', 59.0000, 'ºC'),
	(209158, 122, '2014-02-15 00:22:45.000000', 'temperatura', 613.0000, 'ºC'),
	(209159, 122, '2014-02-15 00:22:46.000000', 'temperatura', 488.0000, 'ºC'),
	(209160, 122, '2014-02-15 00:22:47.000000', 'temperatura', 601.0000, 'ºC'),
	(209161, 122, '2014-02-15 00:22:48.000000', 'temperatura', 343.0000, 'ºC'),
	(209162, 122, '2014-02-15 00:22:49.000000', 'temperatura', 1110.0000, 'ºC'),
	(209163, 122, '2014-02-15 00:22:50.000000', 'temperatura', 924.0000, 'ºC'),
	(209164, 122, '2014-02-15 00:22:51.000000', 'temperatura', 89.0000, 'ºC'),
	(209165, 122, '2014-02-15 00:22:52.000000', 'temperatura', 76.0000, 'ºC'),
	(209166, 122, '2014-02-15 00:22:53.000000', 'temperatura', 112.0000, 'ºC'),
	(209167, 122, '2014-02-15 00:22:54.000000', 'temperatura', 330.0000, 'ºC'),
	(209168, 122, '2014-02-15 00:22:55.000000', 'temperatura', 118.0000, 'ºC'),
	(209169, 122, '2014-02-15 00:22:56.000000', 'temperatura', 801.0000, 'ºC'),
	(209170, 122, '2014-02-15 00:22:57.000000', 'temperatura', 51.0000, 'ºC'),
	(209171, 122, '2014-02-15 00:22:58.000000', 'temperatura', 253.0000, 'ºC'),
	(209172, 122, '2014-02-15 00:22:59.000000', 'temperatura', 1113.0000, 'ºC'),
	(209173, 122, '2014-02-15 00:23:00.000000', 'temperatura', 4.0000, 'ºC'),
	(209174, 122, '2014-02-15 00:23:01.000000', 'temperatura', 281.0000, 'ºC'),
	(209175, 122, '2014-02-15 00:23:02.000000', 'temperatura', 195.0000, 'ºC'),
	(209176, 122, '2014-02-15 00:23:03.000000', 'temperatura', 131.0000, 'ºC'),
	(209177, 122, '2014-02-15 00:23:04.000000', 'temperatura', 73.0000, 'ºC'),
	(209178, 122, '2014-02-15 00:23:05.000000', 'temperatura', 1173.0000, 'ºC'),
	(209179, 122, '2014-02-15 00:23:06.000000', 'temperatura', 845.0000, 'ºC'),
	(209180, 122, '2014-02-15 00:23:07.000000', 'temperatura', 706.0000, 'ºC'),
	(209181, 122, '2014-02-15 00:23:08.000000', 'temperatura', 995.0000, 'ºC'),
	(209182, 122, '2014-02-15 00:23:09.000000', 'temperatura', 459.0000, 'ºC'),
	(209183, 122, '2014-02-15 00:23:10.000000', 'temperatura', 509.0000, 'ºC'),
	(209184, 122, '2014-02-15 00:23:11.000000', 'temperatura', 1170.0000, 'ºC'),
	(209185, 122, '2014-02-15 00:23:12.000000', 'temperatura', 724.0000, 'ºC'),
	(209186, 122, '2014-02-15 00:23:13.000000', 'temperatura', 108.0000, 'ºC'),
	(209187, 122, '2014-02-15 00:23:14.000000', 'temperatura', 771.0000, 'ºC'),
	(209188, 122, '2014-02-15 00:23:15.000000', 'temperatura', 1130.0000, 'ºC'),
	(209189, 122, '2014-02-15 00:23:16.000000', 'temperatura', 937.0000, 'ºC'),
	(209190, 122, '2014-02-15 00:23:17.000000', 'temperatura', 96.0000, 'ºC'),
	(209191, 122, '2014-02-15 00:23:18.000000', 'temperatura', 71.0000, 'ºC'),
	(209192, 122, '2014-02-15 00:23:19.000000', 'temperatura', 68.0000, 'ºC'),
	(209193, 122, '2014-02-15 00:23:20.000000', 'temperatura', 127.0000, 'ºC'),
	(209194, 122, '2014-02-15 00:23:21.000000', 'temperatura', 429.0000, 'ºC'),
	(209195, 122, '2014-02-15 00:23:22.000000', 'temperatura', 567.0000, 'ºC'),
	(209196, 122, '2014-02-15 00:23:23.000000', 'temperatura', 349.0000, 'ºC'),
	(209197, 122, '2014-02-15 00:23:24.000000', 'temperatura', 42.0000, 'ºC'),
	(209198, 122, '2014-02-15 00:23:25.000000', 'temperatura', 364.0000, 'ºC'),
	(209199, 122, '2014-02-15 00:23:26.000000', 'temperatura', 494.0000, 'ºC'),
	(209200, 122, '2014-02-15 00:23:27.000000', 'temperatura', 178.0000, 'ºC'),
	(209201, 122, '2014-02-15 00:23:28.000000', 'temperatura', 608.0000, 'ºC'),
	(209202, 122, '2014-02-15 00:23:29.000000', 'temperatura', 108.0000, 'ºC'),
	(209203, 122, '2014-02-15 00:23:30.000000', 'temperatura', 1114.0000, 'ºC'),
	(209204, 122, '2014-02-15 00:23:31.000000', 'temperatura', 449.0000, 'ºC'),
	(209205, 122, '2014-02-15 00:23:32.000000', 'temperatura', 101.0000, 'ºC'),
	(209206, 122, '2014-02-15 00:23:33.000000', 'temperatura', 359.0000, 'ºC'),
	(209207, 122, '2014-02-15 00:23:34.000000', 'temperatura', 292.0000, 'ºC'),
	(209208, 122, '2014-02-15 00:23:35.000000', 'temperatura', 386.0000, 'ºC'),
	(209209, 122, '2014-02-15 00:23:36.000000', 'temperatura', 1051.0000, 'ºC'),
	(209210, 122, '2014-02-15 00:23:37.000000', 'temperatura', 501.0000, 'ºC'),
	(209211, 122, '2014-02-15 00:23:38.000000', 'temperatura', 551.0000, 'ºC'),
	(209212, 122, '2014-02-15 00:23:39.000000', 'temperatura', 54.0000, 'ºC'),
	(209213, 122, '2014-02-15 00:23:40.000000', 'temperatura', 1016.0000, 'ºC'),
	(209214, 122, '2014-02-15 00:23:41.000000', 'temperatura', 121.0000, 'ºC'),
	(209215, 122, '2014-02-15 00:23:42.000000', 'temperatura', 1156.0000, 'ºC'),
	(209216, 122, '2014-02-15 00:23:43.000000', 'temperatura', 616.0000, 'ºC'),
	(209217, 122, '2014-02-15 00:23:44.000000', 'temperatura', 813.0000, 'ºC'),
	(209218, 122, '2014-02-15 00:23:45.000000', 'temperatura', 1020.0000, 'ºC'),
	(209219, 122, '2014-02-15 00:23:46.000000', 'temperatura', 259.0000, 'ºC'),
	(209220, 122, '2014-02-15 00:23:47.000000', 'temperatura', 638.0000, 'ºC'),
	(209221, 122, '2014-02-15 00:23:48.000000', 'temperatura', 11.0000, 'ºC'),
	(209222, 122, '2014-02-15 00:23:49.000000', 'temperatura', 541.0000, 'ºC'),
	(209223, 122, '2014-02-15 00:23:50.000000', 'temperatura', 271.0000, 'ºC'),
	(209224, 122, '2014-02-15 00:23:51.000000', 'temperatura', 936.0000, 'ºC'),
	(209225, 122, '2014-02-15 00:23:52.000000', 'temperatura', 267.0000, 'ºC'),
	(209226, 122, '2014-02-15 00:23:53.000000', 'temperatura', 929.0000, 'ºC'),
	(209227, 122, '2014-02-15 00:23:54.000000', 'temperatura', 242.0000, 'ºC'),
	(209228, 122, '2014-02-15 00:23:55.000000', 'temperatura', 823.0000, 'ºC'),
	(209229, 122, '2014-02-15 00:23:56.000000', 'temperatura', 991.0000, 'ºC'),
	(209230, 122, '2014-02-15 00:23:57.000000', 'temperatura', 84.0000, 'ºC'),
	(209231, 122, '2014-02-15 00:23:58.000000', 'temperatura', 1049.0000, 'ºC'),
	(209232, 122, '2014-02-15 00:23:59.000000', 'temperatura', 194.0000, 'ºC'),
	(209233, 122, '2014-02-15 00:24:00.000000', 'temperatura', 225.0000, 'ºC'),
	(209234, 122, '2014-02-15 00:24:01.000000', 'temperatura', 543.0000, 'ºC'),
	(209235, 122, '2014-02-15 00:24:02.000000', 'temperatura', 841.0000, 'ºC'),
	(209236, 122, '2014-02-15 00:24:03.000000', 'temperatura', 174.0000, 'ºC'),
	(209237, 122, '2014-02-15 00:24:04.000000', 'temperatura', 748.0000, 'ºC'),
	(209238, 122, '2014-02-15 00:24:05.000000', 'temperatura', 819.0000, 'ºC'),
	(209239, 122, '2014-02-15 00:24:06.000000', 'temperatura', 652.0000, 'ºC'),
	(209240, 122, '2014-02-15 00:24:07.000000', 'temperatura', 803.0000, 'ºC'),
	(209241, 122, '2014-02-15 00:24:08.000000', 'temperatura', 859.0000, 'ºC'),
	(209242, 122, '2014-02-15 00:24:09.000000', 'temperatura', 687.0000, 'ºC'),
	(209243, 122, '2014-02-15 00:24:10.000000', 'temperatura', 859.0000, 'ºC'),
	(209244, 122, '2014-02-15 00:24:11.000000', 'temperatura', 1032.0000, 'ºC'),
	(209245, 122, '2014-02-15 00:24:12.000000', 'temperatura', 187.0000, 'ºC'),
	(209246, 122, '2014-02-15 00:24:13.000000', 'temperatura', 236.0000, 'ºC'),
	(209247, 122, '2014-02-15 00:24:14.000000', 'temperatura', 623.0000, 'ºC'),
	(209248, 122, '2014-02-15 00:24:15.000000', 'temperatura', 6.0000, 'ºC'),
	(209249, 122, '2014-02-15 00:24:16.000000', 'temperatura', 560.0000, 'ºC'),
	(209250, 122, '2014-02-15 00:24:17.000000', 'temperatura', 384.0000, 'ºC'),
	(209251, 122, '2014-02-15 00:24:18.000000', 'temperatura', 242.0000, 'ºC'),
	(209252, 122, '2014-02-15 00:24:19.000000', 'temperatura', 58.0000, 'ºC'),
	(209253, 122, '2014-02-15 00:24:20.000000', 'temperatura', 762.0000, 'ºC'),
	(209254, 122, '2014-02-15 00:24:21.000000', 'temperatura', 38.0000, 'ºC'),
	(209255, 122, '2014-02-15 00:24:22.000000', 'temperatura', 305.0000, 'ºC'),
	(209256, 122, '2014-02-15 00:24:23.000000', 'temperatura', 210.0000, 'ºC'),
	(209257, 122, '2014-02-15 00:24:24.000000', 'temperatura', 138.0000, 'ºC'),
	(209258, 122, '2014-02-15 00:24:25.000000', 'temperatura', 60.0000, 'ºC'),
	(209259, 122, '2014-02-15 00:24:26.000000', 'temperatura', 1085.0000, 'ºC'),
	(209260, 122, '2014-02-15 00:24:27.000000', 'temperatura', 445.0000, 'ºC'),
	(209261, 122, '2014-02-15 00:24:28.000000', 'temperatura', 169.0000, 'ºC'),
	(209262, 122, '2014-02-15 00:24:29.000000', 'temperatura', 714.0000, 'ºC'),
	(209263, 122, '2014-02-15 00:24:30.000000', 'temperatura', 663.0000, 'ºC'),
	(209264, 122, '2014-02-15 00:24:31.000000', 'temperatura', 1173.0000, 'ºC'),
	(209265, 122, '2014-02-15 00:24:32.000000', 'temperatura', 279.0000, 'ºC'),
	(209266, 122, '2014-02-15 00:24:33.000000', 'temperatura', 273.0000, 'ºC'),
	(209267, 122, '2014-02-15 00:24:34.000000', 'temperatura', 528.0000, 'ºC'),
	(209268, 122, '2014-02-15 00:24:35.000000', 'temperatura', 623.0000, 'ºC'),
	(209269, 122, '2014-02-15 00:24:36.000000', 'temperatura', 329.0000, 'ºC'),
	(209270, 122, '2014-02-15 00:24:37.000000', 'temperatura', 979.0000, 'ºC'),
	(209271, 122, '2014-02-15 00:24:38.000000', 'temperatura', 307.0000, 'ºC'),
	(209272, 122, '2014-02-15 00:24:39.000000', 'temperatura', 998.0000, 'ºC'),
	(209273, 122, '2014-02-15 00:24:40.000000', 'temperatura', 470.0000, 'ºC'),
	(209274, 122, '2014-02-15 00:24:41.000000', 'temperatura', 556.0000, 'ºC'),
	(209275, 122, '2014-02-15 00:24:42.000000', 'temperatura', 170.0000, 'ºC'),
	(209276, 122, '2014-02-15 00:24:43.000000', 'temperatura', 384.0000, 'ºC'),
	(209277, 122, '2014-02-15 00:24:44.000000', 'temperatura', 208.0000, 'ºC'),
	(209278, 122, '2014-02-15 00:24:45.000000', 'temperatura', 1091.0000, 'ºC'),
	(209279, 122, '2014-02-15 00:24:46.000000', 'temperatura', 30.0000, 'ºC'),
	(209280, 122, '2014-02-15 00:24:47.000000', 'temperatura', 476.0000, 'ºC'),
	(209281, 122, '2014-02-15 00:24:48.000000', 'temperatura', 1092.0000, 'ºC'),
	(209282, 122, '2014-02-15 00:24:49.000000', 'temperatura', 432.0000, 'ºC'),
	(209283, 122, '2014-02-15 00:24:50.000000', 'temperatura', 86.0000, 'ºC'),
	(209284, 122, '2014-02-15 00:24:51.000000', 'temperatura', 332.0000, 'ºC'),
	(209285, 122, '2014-02-15 00:24:52.000000', 'temperatura', 205.0000, 'ºC'),
	(209286, 122, '2014-02-15 00:24:53.000000', 'temperatura', 27.0000, 'ºC'),
	(209287, 122, '2014-02-15 00:24:54.000000', 'temperatura', 722.0000, 'ºC'),
	(209288, 122, '2014-02-15 00:24:55.000000', 'temperatura', 1129.0000, 'ºC'),
	(209289, 122, '2014-02-15 00:24:56.000000', 'temperatura', 1079.0000, 'ºC'),
	(209290, 122, '2014-02-15 00:24:57.000000', 'temperatura', 809.0000, 'ºC'),
	(209291, 122, '2014-02-15 00:24:58.000000', 'temperatura', 807.0000, 'ºC'),
	(209292, 122, '2014-02-15 00:24:59.000000', 'temperatura', 409.0000, 'ºC'),
	(209293, 122, '2014-02-15 00:25:00.000000', 'temperatura', 825.0000, 'ºC'),
	(209294, 122, '2014-02-15 00:25:01.000000', 'temperatura', 496.0000, 'ºC'),
	(209295, 122, '2014-02-15 00:25:02.000000', 'temperatura', 9.0000, 'ºC'),
	(209296, 122, '2014-02-15 00:25:03.000000', 'temperatura', 956.0000, 'ºC'),
	(209297, 122, '2014-02-15 00:25:04.000000', 'temperatura', 1153.0000, 'ºC'),
	(209298, 122, '2014-02-15 00:25:05.000000', 'temperatura', 497.0000, 'ºC'),
	(209299, 122, '2014-02-15 00:25:06.000000', 'temperatura', 226.0000, 'ºC'),
	(209300, 122, '2014-02-15 00:25:07.000000', 'temperatura', 839.0000, 'ºC'),
	(209301, 122, '2014-02-15 00:25:08.000000', 'temperatura', 1120.0000, 'ºC'),
	(209302, 122, '2014-02-15 00:25:09.000000', 'temperatura', 682.0000, 'ºC'),
	(209303, 122, '2014-02-15 00:25:10.000000', 'temperatura', 51.0000, 'ºC'),
	(209304, 122, '2014-02-15 00:25:11.000000', 'temperatura', 609.0000, 'ºC'),
	(209305, 122, '2014-02-15 00:25:12.000000', 'temperatura', 492.0000, 'ºC'),
	(209306, 122, '2014-02-15 00:25:13.000000', 'temperatura', 632.0000, 'ºC'),
	(209307, 122, '2014-02-15 00:25:14.000000', 'temperatura', 487.0000, 'ºC'),
	(209308, 122, '2014-02-15 00:25:15.000000', 'temperatura', 537.0000, 'ºC'),
	(209309, 122, '2014-02-15 00:25:16.000000', 'temperatura', 25.0000, 'ºC'),
	(209310, 122, '2014-02-15 00:25:17.000000', 'temperatura', 916.0000, 'ºC'),
	(209311, 122, '2014-02-15 00:25:18.000000', 'temperatura', 906.0000, 'ºC'),
	(209312, 122, '2014-02-15 00:25:19.000000', 'temperatura', 584.0000, 'ºC'),
	(209313, 122, '2014-02-15 00:25:20.000000', 'temperatura', 200.0000, 'ºC'),
	(209314, 122, '2014-02-15 00:25:21.000000', 'temperatura', 448.0000, 'ºC'),
	(209315, 122, '2014-02-15 00:25:22.000000', 'temperatura', 441.0000, 'ºC'),
	(209316, 122, '2014-02-15 00:25:23.000000', 'temperatura', 864.0000, 'ºC'),
	(209317, 122, '2014-02-15 00:25:24.000000', 'temperatura', 595.0000, 'ºC'),
	(209318, 122, '2014-02-15 00:25:25.000000', 'temperatura', 384.0000, 'ºC'),
	(209319, 122, '2014-02-15 00:25:26.000000', 'temperatura', 135.0000, 'ºC'),
	(209320, 122, '2014-02-15 00:25:27.000000', 'temperatura', 726.0000, 'ºC'),
	(209321, 122, '2014-02-15 00:25:28.000000', 'temperatura', 824.0000, 'ºC'),
	(209322, 122, '2014-02-15 00:25:29.000000', 'temperatura', 741.0000, 'ºC'),
	(209323, 122, '2014-02-15 00:25:30.000000', 'temperatura', 37.0000, 'ºC'),
	(209324, 122, '2014-02-15 00:25:31.000000', 'temperatura', 359.0000, 'ºC'),
	(209325, 122, '2014-02-15 00:25:32.000000', 'temperatura', 486.0000, 'ºC'),
	(209326, 122, '2014-02-15 00:25:33.000000', 'temperatura', 151.0000, 'ºC'),
	(209327, 122, '2014-02-15 00:25:34.000000', 'temperatura', 501.0000, 'ºC'),
	(209328, 122, '2014-02-15 00:25:35.000000', 'temperatura', 851.0000, 'ºC'),
	(209329, 122, '2014-02-15 00:25:36.000000', 'temperatura', 354.0000, 'ºC'),
	(209330, 122, '2014-02-15 00:25:37.000000', 'temperatura', 419.0000, 'ºC'),
	(209331, 122, '2014-02-15 00:25:38.000000', 'temperatura', 1030.0000, 'ºC'),
	(209332, 122, '2014-02-15 00:25:39.000000', 'temperatura', 295.0000, 'ºC'),
	(209333, 122, '2014-02-15 00:25:40.000000', 'temperatura', 786.0000, 'ºC'),
	(209334, 122, '2014-02-15 00:25:41.000000', 'temperatura', 647.0000, 'ºC'),
	(209335, 122, '2014-02-15 00:25:42.000000', 'temperatura', 877.0000, 'ºC'),
	(209336, 122, '2014-02-15 00:25:43.000000', 'temperatura', 43.0000, 'ºC'),
	(209337, 122, '2014-02-15 00:25:44.000000', 'temperatura', 1187.0000, 'ºC'),
	(209338, 122, '2014-02-15 00:25:45.000000', 'temperatura', 1005.0000, 'ºC'),
	(209339, 122, '2014-02-15 00:25:46.000000', 'temperatura', 265.0000, 'ºC'),
	(209340, 122, '2014-02-15 00:25:47.000000', 'temperatura', 709.0000, 'ºC'),
	(209341, 122, '2014-02-15 00:25:48.000000', 'temperatura', 350.0000, 'ºC'),
	(209342, 122, '2014-02-15 00:25:49.000000', 'temperatura', 825.0000, 'ºC'),
	(209343, 122, '2014-02-15 00:25:50.000000', 'temperatura', 676.0000, 'ºC'),
	(209344, 122, '2014-02-15 00:25:51.000000', 'temperatura', 905.0000, 'ºC'),
	(209345, 122, '2014-02-15 00:25:52.000000', 'temperatura', 96.0000, 'ºC'),
	(209346, 122, '2014-02-15 00:25:53.000000', 'temperatura', 168.0000, 'ºC'),
	(209347, 122, '2014-02-15 00:25:54.000000', 'temperatura', 552.0000, 'ºC'),
	(209348, 122, '2014-02-15 00:25:55.000000', 'temperatura', 1058.0000, 'ºC'),
	(209349, 122, '2014-02-15 00:25:56.000000', 'temperatura', 32.0000, 'ºC'),
	(209350, 122, '2014-02-15 00:25:57.000000', 'temperatura', 587.0000, 'ºC'),
	(209351, 122, '2014-02-15 00:25:58.000000', 'temperatura', 440.0000, 'ºC'),
	(209352, 122, '2014-02-15 00:25:59.000000', 'temperatura', 439.0000, 'ºC'),
	(209353, 122, '2014-02-15 00:26:00.000000', 'temperatura', 877.0000, 'ºC'),
	(209354, 122, '2014-02-15 00:26:01.000000', 'temperatura', 666.0000, 'ºC'),
	(209355, 122, '2014-02-15 00:26:02.000000', 'temperatura', 701.0000, 'ºC'),
	(209356, 122, '2014-02-15 00:26:03.000000', 'temperatura', 306.0000, 'ºC'),
	(209357, 122, '2014-02-15 00:26:04.000000', 'temperatura', 630.0000, 'ºC'),
	(209358, 122, '2014-02-15 00:26:05.000000', 'temperatura', 1032.0000, 'ºC'),
	(209359, 122, '2014-02-15 00:26:06.000000', 'temperatura', 868.0000, 'ºC'),
	(209360, 122, '2014-02-15 00:26:07.000000', 'temperatura', 48.0000, 'ºC'),
	(209361, 122, '2014-02-15 00:26:08.000000', 'temperatura', 35.0000, 'ºC'),
	(209362, 122, '2014-02-15 00:26:09.000000', 'temperatura', 33.0000, 'ºC'),
	(209363, 122, '2014-02-15 00:26:10.000000', 'temperatura', 58.0000, 'ºC'),
	(209364, 122, '2014-02-15 00:26:11.000000', 'temperatura', 191.0000, 'ºC'),
	(209365, 122, '2014-02-15 00:26:12.000000', 'temperatura', 781.0000, 'ºC'),
	(209366, 122, '2014-02-15 00:26:13.000000', 'temperatura', 933.0000, 'ºC'),
	(209367, 122, '2014-02-15 00:26:14.000000', 'temperatura', 1121.0000, 'ºC'),
	(209368, 122, '2014-02-15 00:26:15.000000', 'temperatura', 408.0000, 'ºC'),
	(209369, 122, '2014-02-15 00:26:16.000000', 'temperatura', 1078.0000, 'ºC'),
	(209370, 122, '2014-02-15 00:26:17.000000', 'temperatura', 566.0000, 'ºC'),
	(209371, 122, '2014-02-15 00:26:18.000000', 'temperatura', 797.0000, 'ºC'),
	(209372, 122, '2014-02-15 00:26:19.000000', 'temperatura', 1086.0000, 'ºC'),
	(209373, 122, '2014-02-15 00:26:20.000000', 'temperatura', 642.0000, 'ºC'),
	(209374, 122, '2014-02-15 00:26:21.000000', 'temperatura', 1153.0000, 'ºC'),
	(209375, 122, '2014-02-15 00:26:22.000000', 'temperatura', 239.0000, 'ºC'),
	(209376, 122, '2014-02-15 00:26:23.000000', 'temperatura', 134.0000, 'ºC'),
	(209377, 122, '2014-02-15 00:26:24.000000', 'temperatura', 1157.0000, 'ºC'),
	(209378, 122, '2014-02-15 00:26:25.000000', 'temperatura', 582.0000, 'ºC'),
	(209379, 122, '2014-02-15 00:26:26.000000', 'temperatura', 639.0000, 'ºC'),
	(209380, 122, '2014-02-15 00:26:27.000000', 'temperatura', 250.0000, 'ºC'),
	(209381, 122, '2014-02-15 00:26:28.000000', 'temperatura', 535.0000, 'ºC'),
	(209382, 122, '2014-02-15 00:26:29.000000', 'temperatura', 725.0000, 'ºC'),
	(209383, 122, '2014-02-15 00:26:30.000000', 'temperatura', 819.0000, 'ºC'),
	(209384, 122, '2014-02-15 00:26:31.000000', 'temperatura', 720.0000, 'ºC'),
	(209385, 122, '2014-02-15 00:26:32.000000', 'temperatura', 1145.0000, 'ºC'),
	(209386, 122, '2014-02-15 00:26:33.000000', 'temperatura', 1167.0000, 'ºC'),
	(209387, 122, '2014-02-15 00:26:34.000000', 'temperatura', 1197.0000, 'ºC'),
	(209388, 122, '2014-02-15 00:26:35.000000', 'temperatura', 86.0000, 'ºC'),
	(209389, 122, '2014-02-15 00:26:36.000000', 'temperatura', 442.0000, 'ºC'),
	(209390, 122, '2014-02-15 00:26:37.000000', 'temperatura', 749.0000, 'ºC'),
	(209391, 122, '2014-02-15 00:26:38.000000', 'temperatura', 21.0000, 'ºC'),
	(209392, 122, '2014-02-15 00:26:39.000000', 'temperatura', 259.0000, 'ºC'),
	(209393, 122, '2014-02-15 00:26:40.000000', 'temperatura', 33.0000, 'ºC'),
	(209394, 122, '2014-02-15 00:26:41.000000', 'temperatura', 588.0000, 'ºC'),
	(209395, 122, '2014-02-15 00:26:42.000000', 'temperatura', 443.0000, 'ºC'),
	(209396, 122, '2014-02-15 00:26:43.000000', 'temperatura', 452.0000, 'ºC'),
	(209397, 122, '2014-02-15 00:26:44.000000', 'temperatura', 930.0000, 'ºC'),
	(209398, 122, '2014-02-15 00:26:45.000000', 'temperatura', 896.0000, 'ºC'),
	(209399, 122, '2014-02-15 00:26:46.000000', 'temperatura', 488.0000, 'ºC'),
	(209400, 122, '2014-02-15 00:26:47.000000', 'temperatura', 956.0000, 'ºC'),
	(209401, 122, '2014-02-15 00:26:48.000000', 'temperatura', 913.0000, 'ºC'),
	(209402, 122, '2014-02-15 00:26:49.000000', 'temperatura', 501.0000, 'ºC'),
	(209403, 122, '2014-02-15 00:26:50.000000', 'temperatura', 964.0000, 'ºC'),
	(209404, 122, '2014-02-15 00:26:51.000000', 'temperatura', 917.0000, 'ºC'),
	(209405, 122, '2014-02-15 00:26:52.000000', 'temperatura', 496.0000, 'ºC'),
	(209406, 122, '2014-02-15 00:26:53.000000', 'temperatura', 929.0000, 'ºC'),
	(209407, 122, '2014-02-15 00:26:54.000000', 'temperatura', 758.0000, 'ºC'),
	(209408, 122, '2014-02-15 00:26:55.000000', 'temperatura', 1003.0000, 'ºC'),
	(209409, 122, '2014-02-15 00:26:56.000000', 'temperatura', 341.0000, 'ºC'),
	(209410, 122, '2014-02-15 00:26:57.000000', 'temperatura', 1097.0000, 'ºC'),
	(209411, 122, '2014-02-15 00:26:58.000000', 'temperatura', 861.0000, 'ºC'),
	(209412, 122, '2014-02-15 00:26:59.000000', 'temperatura', 1016.0000, 'ºC'),
	(209413, 122, '2014-02-15 00:27:00.000000', 'temperatura', 98.0000, 'ºC'),
	(209414, 122, '2014-02-15 00:27:01.000000', 'temperatura', 1042.0000, 'ºC'),
	(209415, 122, '2014-02-15 00:27:02.000000', 'temperatura', 116.0000, 'ºC'),
	(209416, 122, '2014-02-15 00:27:03.000000', 'temperatura', 1056.0000, 'ºC'),
	(209417, 122, '2014-02-15 00:27:04.000000', 'temperatura', 133.0000, 'ºC'),
	(209418, 122, '2014-02-15 00:27:05.000000', 'temperatura', 1097.0000, 'ºC'),
	(209419, 122, '2014-02-15 00:27:06.000000', 'temperatura', 285.0000, 'ºC'),
	(209420, 122, '2014-02-15 00:27:07.000000', 'temperatura', 533.0000, 'ºC'),
	(209421, 122, '2014-02-15 00:27:08.000000', 'temperatura', 614.0000, 'ºC'),
	(209422, 122, '2014-02-15 00:27:09.000000', 'temperatura', 268.0000, 'ºC'),
	(209423, 122, '2014-02-15 00:27:10.000000', 'temperatura', 701.0000, 'ºC'),
	(209424, 122, '2014-02-15 00:27:11.000000', 'temperatura', 300.0000, 'ºC'),
	(209425, 122, '2014-02-15 00:27:12.000000', 'temperatura', 600.0000, 'ºC'),
	(209426, 122, '2014-02-15 00:27:13.000000', 'temperatura', 899.0000, 'ºC'),
	(209427, 122, '2014-02-15 00:27:14.000000', 'temperatura', 296.0000, 'ºC'),
	(209428, 122, '2014-02-15 00:27:15.000000', 'temperatura', 1183.0000, 'ºC'),
	(209429, 122, '2014-02-15 00:27:16.000000', 'temperatura', 229.0000, 'ºC'),
	(209430, 122, '2014-02-15 00:27:17.000000', 'temperatura', 1197.0000, 'ºC'),
	(209431, 122, '2014-02-15 00:27:18.000000', 'temperatura', 497.0000, 'ºC'),
	(209432, 122, '2014-02-15 00:27:19.000000', 'temperatura', 94.0000, 'ºC'),
	(209433, 122, '2014-02-15 00:27:20.000000', 'temperatura', 180.0000, 'ºC'),
	(209434, 122, '2014-02-15 00:27:21.000000', 'temperatura', 620.0000, 'ºC'),
	(209435, 122, '2014-02-15 00:27:22.000000', 'temperatura', 158.0000, 'ºC'),
	(209436, 122, '2014-02-15 00:27:23.000000', 'temperatura', 130.0000, 'ºC'),
	(209437, 122, '2014-02-15 00:27:24.000000', 'temperatura', 176.0000, 'ºC'),
	(209438, 122, '2014-02-15 00:27:25.000000', 'temperatura', 490.0000, 'ºC'),
	(209439, 122, '2014-02-15 00:27:26.000000', 'temperatura', 725.0000, 'ºC'),
	(209440, 122, '2014-02-15 00:27:27.000000', 'temperatura', 956.0000, 'ºC'),
	(209441, 122, '2014-02-15 00:27:28.000000', 'temperatura', 204.0000, 'ºC'),
	(209442, 122, '2014-02-15 00:27:29.000000', 'temperatura', 555.0000, 'ºC'),
	(209443, 122, '2014-02-15 00:27:30.000000', 'temperatura', 960.0000, 'ºC'),
	(209444, 122, '2014-02-15 00:27:31.000000', 'temperatura', 736.0000, 'ºC'),
	(209445, 122, '2014-02-15 00:27:32.000000', 'temperatura', 802.0000, 'ºC'),
	(209446, 122, '2014-02-15 00:27:33.000000', 'temperatura', 602.0000, 'ºC'),
	(209447, 122, '2014-02-15 00:27:34.000000', 'temperatura', 605.0000, 'ºC'),
	(209448, 122, '2014-02-15 00:27:35.000000', 'temperatura', 21.0000, 'ºC'),
	(209449, 122, '2014-02-15 00:27:36.000000', 'temperatura', 690.0000, 'ºC'),
	(209450, 122, '2014-02-15 00:27:37.000000', 'temperatura', 985.0000, 'ºC'),
	(209451, 122, '2014-02-15 00:27:38.000000', 'temperatura', 457.0000, 'ºC'),
	(209452, 122, '2014-02-15 00:27:39.000000', 'temperatura', 530.0000, 'ºC'),
	(209453, 122, '2014-02-15 00:27:40.000000', 'temperatura', 79.0000, 'ºC'),
	(209454, 122, '2014-02-15 00:27:41.000000', 'temperatura', 5.0000, 'ºC'),
	(209455, 122, '2014-02-15 00:27:42.000000', 'temperatura', 988.0000, 'ºC'),
	(209456, 122, '2014-02-15 00:27:43.000000', 'temperatura', 126.0000, 'ºC'),
	(209457, 122, '2014-02-15 00:27:44.000000', 'temperatura', 67.0000, 'ºC'),
	(209458, 122, '2014-02-15 00:27:45.000000', 'temperatura', 1157.0000, 'ºC'),
	(209459, 122, '2014-02-15 00:27:46.000000', 'temperatura', 786.0000, 'ºC'),
	(209460, 122, '2014-02-15 00:27:47.000000', 'temperatura', 459.0000, 'ºC'),
	(209461, 122, '2014-02-15 00:27:48.000000', 'temperatura', 1137.0000, 'ºC'),
	(209462, 122, '2014-02-15 00:27:49.000000', 'temperatura', 708.0000, 'ºC'),
	(209463, 122, '2014-02-15 00:27:50.000000', 'temperatura', 130.0000, 'ºC'),
	(209464, 122, '2014-02-15 00:27:51.000000', 'temperatura', 926.0000, 'ºC'),
	(209465, 122, '2014-02-15 00:27:52.000000', 'temperatura', 640.0000, 'ºC'),
	(209466, 122, '2014-02-15 00:27:53.000000', 'temperatura', 424.0000, 'ºC'),
	(209467, 122, '2014-02-15 00:27:54.000000', 'temperatura', 201.0000, 'ºC'),
	(209468, 122, '2014-02-15 00:27:55.000000', 'temperatura', 931.0000, 'ºC'),
	(209469, 122, '2014-02-15 00:27:56.000000', 'temperatura', 453.0000, 'ºC'),
	(209470, 122, '2014-02-15 00:27:57.000000', 'temperatura', 672.0000, 'ºC'),
	(209471, 122, '2014-02-15 00:27:58.000000', 'temperatura', 803.0000, 'ºC'),
	(209472, 122, '2014-02-15 00:27:59.000000', 'temperatura', 797.0000, 'ºC'),
	(209473, 122, '2014-02-15 00:28:00.000000', 'temperatura', 378.0000, 'ºC'),
	(209474, 122, '2014-02-15 00:28:01.000000', 'temperatura', 701.0000, 'ºC'),
	(209475, 122, '2014-02-15 00:28:02.000000', 'temperatura', 1171.0000, 'ºC'),
	(209476, 122, '2014-02-15 00:28:03.000000', 'temperatura', 153.0000, 'ºC'),
	(209477, 122, '2014-02-15 00:28:04.000000', 'temperatura', 853.0000, 'ºC'),
	(209478, 122, '2014-02-15 00:28:05.000000', 'temperatura', 204.0000, 'ºC'),
	(209479, 122, '2014-02-15 00:28:06.000000', 'temperatura', 864.0000, 'ºC'),
	(209480, 122, '2014-02-15 00:28:07.000000', 'temperatura', 106.0000, 'ºC'),
	(209481, 122, '2014-02-15 00:28:08.000000', 'temperatura', 340.0000, 'ºC'),
	(209482, 122, '2014-02-15 00:28:09.000000', 'temperatura', 182.0000, 'ºC'),
	(209483, 122, '2014-02-15 00:28:10.000000', 'temperatura', 1089.0000, 'ºC'),
	(209484, 122, '2014-02-15 00:28:11.000000', 'temperatura', 100.0000, 'ºC'),
	(209485, 122, '2014-02-15 00:28:12.000000', 'temperatura', 836.0000, 'ºC'),
	(209486, 122, '2014-02-15 00:28:13.000000', 'temperatura', 279.0000, 'ºC'),
	(209487, 122, '2014-02-15 00:28:14.000000', 'temperatura', 88.0000, 'ºC'),
	(209488, 122, '2014-02-15 00:28:15.000000', 'temperatura', 805.0000, 'ºC'),
	(209489, 122, '2014-02-15 00:28:16.000000', 'temperatura', 159.0000, 'ºC'),
	(209490, 122, '2014-02-15 00:28:17.000000', 'temperatura', 781.0000, 'ºC'),
	(209491, 122, '2014-02-15 00:28:18.000000', 'temperatura', 1027.0000, 'ºC'),
	(209492, 122, '2014-02-15 00:28:19.000000', 'temperatura', 394.0000, 'ºC'),
	(209493, 122, '2014-02-15 00:28:20.000000', 'temperatura', 89.0000, 'ºC'),
	(209494, 122, '2014-02-15 00:28:21.000000', 'temperatura', 464.0000, 'ºC'),
	(209495, 122, '2014-02-15 00:28:22.000000', 'temperatura', 853.0000, 'ºC'),
	(209496, 122, '2014-02-15 00:28:23.000000', 'temperatura', 476.0000, 'ºC'),
	(209497, 122, '2014-02-15 00:28:24.000000', 'temperatura', 1019.0000, 'ºC'),
	(209498, 122, '2014-02-15 00:28:25.000000', 'temperatura', 67.0000, 'ºC'),
	(209499, 122, '2014-02-15 00:28:26.000000', 'temperatura', 878.0000, 'ºC'),
	(209500, 122, '2014-02-15 00:28:27.000000', 'temperatura', 592.0000, 'ºC'),
	(209501, 122, '2014-02-15 00:28:28.000000', 'temperatura', 324.0000, 'ºC'),
	(209502, 122, '2014-02-15 00:28:29.000000', 'temperatura', 1045.0000, 'ºC'),
	(209503, 122, '2014-02-15 00:28:30.000000', 'temperatura', 652.0000, 'ºC'),
	(209504, 122, '2014-02-15 00:28:31.000000', 'temperatura', 128.0000, 'ºC'),
	(209505, 122, '2014-02-15 00:28:32.000000', 'temperatura', 1085.0000, 'ºC'),
	(209506, 122, '2014-02-15 00:28:33.000000', 'temperatura', 239.0000, 'ºC'),
	(209507, 122, '2014-02-15 00:28:34.000000', 'temperatura', 340.0000, 'ºC'),
	(209508, 122, '2014-02-15 00:28:35.000000', 'temperatura', 987.0000, 'ºC'),
	(209509, 122, '2014-02-15 00:28:36.000000', 'temperatura', 313.0000, 'ºC'),
	(209510, 122, '2014-02-15 00:28:37.000000', 'temperatura', 1003.0000, 'ºC'),
	(209511, 122, '2014-02-15 00:28:38.000000', 'temperatura', 478.0000, 'ºC'),
	(209512, 122, '2014-02-15 00:28:39.000000', 'temperatura', 582.0000, 'ºC'),
	(209513, 122, '2014-02-15 00:28:40.000000', 'temperatura', 275.0000, 'ºC'),
	(209514, 122, '2014-02-15 00:28:41.000000', 'temperatura', 829.0000, 'ºC'),
	(209515, 122, '2014-02-15 00:28:42.000000', 'temperatura', 922.0000, 'ºC'),
	(209516, 122, '2014-02-15 00:28:43.000000', 'temperatura', 923.0000, 'ºC'),
	(209517, 122, '2014-02-15 00:28:44.000000', 'temperatura', 649.0000, 'ºC'),
	(209518, 122, '2014-02-15 00:28:45.000000', 'temperatura', 475.0000, 'ºC'),
	(209519, 122, '2014-02-15 00:28:46.000000', 'temperatura', 429.0000, 'ºC'),
	(209520, 122, '2014-02-15 00:28:47.000000', 'temperatura', 722.0000, 'ºC'),
	(209521, 122, '2014-02-15 00:28:48.000000', 'temperatura', 1122.0000, 'ºC'),
	(209522, 122, '2014-02-15 00:28:49.000000', 'temperatura', 1047.0000, 'ºC'),
	(209523, 122, '2014-02-15 00:28:50.000000', 'temperatura', 668.0000, 'ºC'),
	(209524, 122, '2014-02-15 00:28:51.000000', 'temperatura', 199.0000, 'ºC'),
	(209525, 122, '2014-02-15 00:28:52.000000', 'temperatura', 192.0000, 'ºC'),
	(209526, 122, '2014-02-15 00:28:53.000000', 'temperatura', 363.0000, 'ºC'),
	(209527, 122, '2014-02-15 00:28:54.000000', 'temperatura', 40.0000, 'ºC'),
	(209528, 122, '2014-02-15 00:28:55.000000', 'temperatura', 309.0000, 'ºC'),
	(209529, 122, '2014-02-15 00:28:56.000000', 'temperatura', 229.0000, 'ºC'),
	(209530, 122, '2014-02-15 00:28:57.000000', 'temperatura', 218.0000, 'ºC'),
	(209531, 122, '2014-02-15 00:28:58.000000', 'temperatura', 405.0000, 'ºC'),
	(209532, 122, '2014-02-15 00:28:59.000000', 'temperatura', 168.0000, 'ºC'),
	(209533, 122, '2014-02-15 00:29:00.000000', 'temperatura', 828.0000, 'ºC'),
	(209534, 122, '2014-02-15 00:29:01.000000', 'temperatura', 37.0000, 'ºC'),
	(209535, 122, '2014-02-15 00:29:02.000000', 'temperatura', 100.0000, 'ºC'),
	(209536, 122, '2014-02-15 00:29:03.000000', 'temperatura', 391.0000, 'ºC'),
	(209537, 122, '2014-02-15 00:29:04.000000', 'temperatura', 455.0000, 'ºC'),
	(209538, 122, '2014-02-15 00:29:05.000000', 'temperatura', 1103.0000, 'ºC'),
	(209539, 122, '2014-02-15 00:29:06.000000', 'temperatura', 552.0000, 'ºC'),
	(209540, 122, '2014-02-15 00:29:07.000000', 'temperatura', 650.0000, 'ºC'),
	(209541, 122, '2014-02-15 00:29:08.000000', 'temperatura', 396.0000, 'ºC'),
	(209542, 122, '2014-02-15 00:29:09.000000', 'temperatura', 31.0000, 'ºC'),
	(209543, 122, '2014-02-15 00:29:10.000000', 'temperatura', 165.0000, 'ºC'),
	(209544, 122, '2014-02-15 00:29:11.000000', 'temperatura', 733.0000, 'ºC'),
	(209545, 122, '2014-02-15 00:29:12.000000', 'temperatura', 773.0000, 'ºC'),
	(209546, 122, '2014-02-15 00:29:13.000000', 'temperatura', 464.0000, 'ºC'),
	(209547, 122, '2014-02-15 00:29:14.000000', 'temperatura', 1.0000, 'ºC'),
	(209548, 122, '2014-02-15 00:29:15.000000', 'temperatura', 1016.0000, 'ºC'),
	(209549, 122, '2014-02-15 00:29:16.000000', 'temperatura', 278.0000, 'ºC'),
	(209550, 122, '2014-02-15 00:29:17.000000', 'temperatura', 741.0000, 'ºC'),
	(209551, 122, '2014-02-15 00:29:18.000000', 'temperatura', 472.0000, 'ºC'),
	(209552, 122, '2014-02-15 00:29:19.000000', 'temperatura', 135.0000, 'ºC'),
	(209553, 122, '2014-02-15 00:29:20.000000', 'temperatura', 462.0000, 'ºC'),
	(209554, 122, '2014-02-15 00:29:21.000000', 'temperatura', 706.0000, 'ºC'),
	(209555, 122, '2014-02-15 00:29:22.000000', 'temperatura', 943.0000, 'ºC'),
	(209556, 122, '2014-02-15 00:29:23.000000', 'temperatura', 196.0000, 'ºC'),
	(209557, 122, '2014-02-15 00:29:24.000000', 'temperatura', 554.0000, 'ºC'),
	(209558, 122, '2014-02-15 00:29:25.000000', 'temperatura', 984.0000, 'ºC'),
	(209559, 122, '2014-02-15 00:29:26.000000', 'temperatura', 855.0000, 'ºC'),
	(209560, 122, '2014-02-15 00:29:27.000000', 'temperatura', 124.0000, 'ºC'),
	(209561, 122, '2014-02-15 00:29:28.000000', 'temperatura', 457.0000, 'ºC'),
	(209562, 122, '2014-02-15 00:29:29.000000', 'temperatura', 711.0000, 'ºC'),
	(209563, 122, '2014-02-15 00:29:30.000000', 'temperatura', 986.0000, 'ºC'),
	(209564, 122, '2014-02-15 00:29:31.000000', 'temperatura', 395.0000, 'ºC'),
	(209565, 122, '2014-02-15 00:29:32.000000', 'temperatura', 220.0000, 'ºC'),
	(209566, 122, '2014-02-15 00:29:33.000000', 'temperatura', 1116.0000, 'ºC'),
	(209567, 122, '2014-02-15 00:29:34.000000', 'temperatura', 121.0000, 'ºC'),
	(209568, 122, '2014-02-15 00:29:35.000000', 'temperatura', 855.0000, 'ºC'),
	(209569, 122, '2014-02-15 00:29:36.000000', 'temperatura', 312.0000, 'ºC'),
	(209570, 122, '2014-02-15 00:29:37.000000', 'temperatura', 198.0000, 'ºC'),
	(209571, 122, '2014-02-15 00:29:38.000000', 'temperatura', 54.0000, 'ºC'),
	(209572, 122, '2014-02-15 00:29:39.000000', 'temperatura', 875.0000, 'ºC'),
	(209573, 122, '2014-02-15 00:29:40.000000', 'temperatura', 615.0000, 'ºC'),
	(209574, 122, '2014-02-15 00:29:41.000000', 'temperatura', 451.0000, 'ºC'),
	(209575, 122, '2014-02-15 00:29:42.000000', 'temperatura', 409.0000, 'ºC'),
	(209576, 122, '2014-02-15 00:29:43.000000', 'temperatura', 691.0000, 'ºC'),
	(209577, 122, '2014-02-15 00:29:44.000000', 'temperatura', 1030.0000, 'ºC'),
	(209578, 122, '2014-02-15 00:29:45.000000', 'temperatura', 677.0000, 'ºC'),
	(209579, 122, '2014-02-15 00:29:46.000000', 'temperatura', 297.0000, 'ºC'),
	(209580, 122, '2014-02-15 00:29:47.000000', 'temperatura', 655.0000, 'ºC'),
	(209581, 122, '2014-02-15 00:29:48.000000', 'temperatura', 1182.0000, 'ºC'),
	(209582, 122, '2014-02-15 00:29:49.000000', 'temperatura', 349.0000, 'ºC'),
	(209583, 122, '2014-02-15 00:29:50.000000', 'temperatura', 597.0000, 'ºC'),
	(209584, 122, '2014-02-15 00:29:51.000000', 'temperatura', 738.0000, 'ºC'),
	(209585, 122, '2014-02-15 00:29:52.000000', 'temperatura', 699.0000, 'ºC'),
	(209586, 122, '2014-02-15 00:29:53.000000', 'temperatura', 84.0000, 'ºC'),
	(209587, 122, '2014-02-15 00:29:54.000000', 'temperatura', 721.0000, 'ºC'),
	(209588, 122, '2014-02-15 00:29:55.000000', 'temperatura', 956.0000, 'ºC'),
	(209589, 122, '2014-02-15 00:29:56.000000', 'temperatura', 216.0000, 'ºC'),
	(209590, 122, '2014-02-15 00:29:57.000000', 'temperatura', 612.0000, 'ºC'),
	(209591, 122, '2014-02-15 00:29:58.000000', 'temperatura', 15.0000, 'ºC'),
	(209592, 122, '2014-02-15 00:29:59.000000', 'temperatura', 636.0000, 'ºC'),
	(209593, 122, '2014-02-15 00:30:00.000000', 'temperatura', 738.0000, 'ºC'),
	(209594, 122, '2014-02-15 00:30:01.000000', 'temperatura', 580.0000, 'ºC'),
	(209595, 122, '2014-02-15 00:30:02.000000', 'temperatura', 687.0000, 'ºC'),
	(209596, 122, '2014-02-15 00:30:03.000000', 'temperatura', 496.0000, 'ºC'),
	(209597, 122, '2014-02-15 00:30:04.000000', 'temperatura', 418.0000, 'ºC'),
	(209598, 122, '2014-02-15 00:30:05.000000', 'temperatura', 603.0000, 'ºC'),
	(209599, 122, '2014-02-15 00:30:06.000000', 'temperatura', 560.0000, 'ºC'),
	(209600, 122, '2014-02-15 00:30:07.000000', 'temperatura', 995.0000, 'ºC'),
	(209601, 122, '2014-02-15 00:30:08.000000', 'temperatura', 893.0000, 'ºC'),
	(209602, 122, '2014-02-15 00:30:09.000000', 'temperatura', 280.0000, 'ºC'),
	(209603, 122, '2014-02-15 00:30:10.000000', 'temperatura', 1122.0000, 'ºC'),
	(209604, 122, '2014-02-15 00:30:11.000000', 'temperatura', 1172.0000, 'ºC'),
	(209605, 122, '2014-02-15 00:30:12.000000', 'temperatura', 94.0000, 'ºC'),
	(209606, 122, '2014-02-15 00:30:13.000000', 'temperatura', 554.0000, 'ºC'),
	(209607, 122, '2014-02-15 00:30:14.000000', 'temperatura', 87.0000, 'ºC'),
	(209608, 122, '2014-02-15 00:30:15.000000', 'temperatura', 1175.0000, 'ºC'),
	(209609, 122, '2014-02-15 00:30:16.000000', 'temperatura', 815.0000, 'ºC'),
	(209610, 122, '2014-02-15 00:30:17.000000', 'temperatura', 549.0000, 'ºC'),
	(209611, 122, '2014-02-15 00:30:18.000000', 'temperatura', 302.0000, 'ºC'),
	(209612, 122, '2014-02-15 00:30:19.000000', 'temperatura', 1063.0000, 'ºC'),
	(209613, 122, '2014-02-15 00:30:20.000000', 'temperatura', 808.0000, 'ºC'),
	(209614, 122, '2014-02-15 00:30:21.000000', 'temperatura', 854.0000, 'ºC'),
	(209615, 122, '2014-02-15 00:30:22.000000', 'temperatura', 645.0000, 'ºC'),
	(209616, 122, '2014-02-15 00:30:23.000000', 'temperatura', 663.0000, 'ºC'),
	(209617, 122, '2014-02-15 00:30:24.000000', 'temperatura', 179.0000, 'ºC'),
	(209618, 122, '2014-02-15 00:30:25.000000', 'temperatura', 108.0000, 'ºC'),
	(209619, 122, '2014-02-15 00:30:26.000000', 'temperatura', 4.0000, 'ºC'),
	(209620, 122, '2014-02-15 00:30:27.000000', 'temperatura', 894.0000, 'ºC'),
	(209621, 122, '2014-02-15 00:30:28.000000', 'temperatura', 860.0000, 'ºC'),
	(209622, 122, '2014-02-15 00:30:29.000000', 'temperatura', 420.0000, 'ºC'),
	(209623, 122, '2014-02-15 00:30:30.000000', 'temperatura', 720.0000, 'ºC'),
	(209624, 122, '2014-02-15 00:30:31.000000', 'temperatura', 1139.0000, 'ºC'),
	(209625, 122, '2014-02-15 00:30:32.000000', 'temperatura', 1137.0000, 'ºC'),
	(209626, 122, '2014-02-15 00:30:33.000000', 'temperatura', 1068.0000, 'ºC'),
	(209627, 122, '2014-02-15 00:30:34.000000', 'temperatura', 730.0000, 'ºC'),
	(209628, 122, '2014-02-15 00:30:35.000000', 'temperatura', 446.0000, 'ºC'),
	(209629, 122, '2014-02-15 00:30:36.000000', 'temperatura', 43.0000, 'ºC'),
	(209630, 122, '2014-02-15 00:30:37.000000', 'temperatura', 75.0000, 'ºC'),
	(209631, 122, '2014-02-15 00:30:38.000000', 'temperatura', 246.0000, 'ºC'),
	(209632, 122, '2014-02-15 00:30:39.000000', 'temperatura', 1005.0000, 'ºC'),
	(209633, 122, '2014-02-15 00:30:40.000000', 'temperatura', 687.0000, 'ºC'),
	(209634, 122, '2014-02-15 00:30:41.000000', 'temperatura', 422.0000, 'ºC'),
	(209635, 122, '2014-02-15 00:30:42.000000', 'temperatura', 49.0000, 'ºC'),
	(209636, 122, '2014-02-15 00:30:43.000000', 'temperatura', 180.0000, 'ºC'),
	(209637, 122, '2014-02-15 00:30:44.000000', 'temperatura', 753.0000, 'ºC'),
	(209638, 122, '2014-02-15 00:30:45.000000', 'temperatura', 824.0000, 'ºC'),
	(209639, 122, '2014-02-15 00:30:46.000000', 'temperatura', 664.0000, 'ºC'),
	(209640, 122, '2014-02-15 00:30:47.000000', 'temperatura', 847.0000, 'ºC'),
	(209641, 122, '2014-02-15 00:30:48.000000', 'temperatura', 1045.0000, 'ºC'),
	(209642, 122, '2014-02-15 00:30:49.000000', 'temperatura', 282.0000, 'ºC'),
	(209643, 122, '2014-02-15 00:30:50.000000', 'temperatura', 675.0000, 'ºC'),
	(209644, 122, '2014-02-15 00:30:51.000000', 'temperatura', 132.0000, 'ºC'),
	(209645, 122, '2014-02-15 00:30:52.000000', 'temperatura', 1034.0000, 'ºC'),
	(209646, 122, '2014-02-15 00:30:53.000000', 'temperatura', 1176.0000, 'ºC'),
	(209647, 122, '2014-02-15 00:30:54.000000', 'temperatura', 379.0000, 'ºC'),
	(209648, 122, '2014-02-15 00:30:55.000000', 'temperatura', 768.0000, 'ºC'),
	(209649, 122, '2014-02-15 00:30:56.000000', 'temperatura', 304.0000, 'ºC'),
	(209650, 122, '2014-02-15 00:30:57.000000', 'temperatura', 416.0000, 'ºC'),
	(209651, 122, '2014-02-15 00:30:58.000000', 'temperatura', 1167.0000, 'ºC'),
	(209652, 122, '2014-02-15 00:30:59.000000', 'temperatura', 990.0000, 'ºC'),
	(209653, 122, '2014-02-15 00:31:00.000000', 'temperatura', 250.0000, 'ºC'),
	(209654, 122, '2014-02-15 00:31:01.000000', 'temperatura', 678.0000, 'ºC'),
	(209655, 122, '2014-02-15 00:31:02.000000', 'temperatura', 241.0000, 'ºC'),
	(209656, 122, '2014-02-15 00:31:03.000000', 'temperatura', 374.0000, 'ºC'),
	(209657, 122, '2014-02-15 00:31:04.000000', 'temperatura', 1144.0000, 'ºC'),
	(209658, 122, '2014-02-15 00:31:05.000000', 'temperatura', 999.0000, 'ºC'),
	(209659, 122, '2014-02-15 00:31:06.000000', 'temperatura', 366.0000, 'ºC'),
	(209660, 122, '2014-02-15 00:31:07.000000', 'temperatura', 31.0000, 'ºC'),
	(209661, 122, '2014-02-15 00:31:08.000000', 'temperatura', 260.0000, 'ºC'),
	(209662, 122, '2014-02-15 00:31:09.000000', 'temperatura', 5.0000, 'ºC'),
	(209663, 122, '2014-02-15 00:31:10.000000', 'temperatura', 447.0000, 'ºC'),
	(209664, 122, '2014-02-15 00:31:11.000000', 'temperatura', 1019.0000, 'ºC'),
	(209665, 122, '2014-02-15 00:31:12.000000', 'temperatura', 156.0000, 'ºC'),
	(209666, 122, '2014-02-15 00:31:13.000000', 'temperatura', 124.0000, 'ºC'),
	(209667, 122, '2014-02-15 00:31:14.000000', 'temperatura', 151.0000, 'ºC'),
	(209668, 122, '2014-02-15 00:31:15.000000', 'temperatura', 384.0000, 'ºC'),
	(209669, 122, '2014-02-15 00:31:16.000000', 'temperatura', 267.0000, 'ºC'),
	(209670, 122, '2014-02-15 00:31:17.000000', 'temperatura', 182.0000, 'ºC'),
	(209671, 122, '2014-02-15 00:31:18.000000', 'temperatura', 112.0000, 'ºC'),
	(209672, 122, '2014-02-15 00:31:19.000000', 'temperatura', 15.0000, 'ºC'),
	(209673, 122, '2014-02-15 00:31:20.000000', 'temperatura', 938.0000, 'ºC'),
	(209674, 122, '2014-02-15 00:31:21.000000', 'temperatura', 1047.0000, 'ºC'),
	(209675, 122, '2014-02-15 00:31:22.000000', 'temperatura', 21.0000, 'ºC'),
	(209676, 122, '2014-02-15 00:31:23.000000', 'temperatura', 563.0000, 'ºC'),
	(209677, 122, '2014-02-15 00:31:24.000000', 'temperatura', 355.0000, 'ºC'),
	(209678, 122, '2014-02-15 00:31:25.000000', 'temperatura', 85.0000, 'ºC'),
	(209679, 122, '2014-02-15 00:31:26.000000', 'temperatura', 559.0000, 'ºC'),
	(209680, 122, '2014-02-15 00:31:27.000000', 'temperatura', 141.0000, 'ºC'),
	(209681, 122, '2014-02-15 00:31:28.000000', 'temperatura', 231.0000, 'ºC'),
	(209682, 122, '2014-02-15 00:31:29.000000', 'temperatura', 730.0000, 'ºC'),
	(209683, 122, '2014-02-15 00:31:30.000000', 'temperatura', 560.0000, 'ºC'),
	(209684, 122, '2014-02-15 00:31:31.000000', 'temperatura', 611.0000, 'ºC'),
	(209685, 122, '2014-02-15 00:31:32.000000', 'temperatura', 173.0000, 'ºC'),
	(209686, 122, '2014-02-15 00:31:33.000000', 'temperatura', 233.0000, 'ºC'),
	(209687, 122, '2014-02-15 00:31:34.000000', 'temperatura', 649.0000, 'ºC'),
	(209688, 122, '2014-02-15 00:31:35.000000', 'temperatura', 143.0000, 'ºC'),
	(209689, 122, '2014-02-15 00:31:36.000000', 'temperatura', 1169.0000, 'ºC'),
	(209690, 122, '2014-02-15 00:31:37.000000', 'temperatura', 618.0000, 'ºC'),
	(209691, 122, '2014-02-15 00:31:38.000000', 'temperatura', 782.0000, 'ºC'),
	(209692, 122, '2014-02-15 00:31:39.000000', 'temperatura', 856.0000, 'ºC'),
	(209693, 122, '2014-02-15 00:31:40.000000', 'temperatura', 737.0000, 'ºC'),
	(209694, 122, '2014-02-15 00:31:41.000000', 'temperatura', 1118.0000, 'ºC'),
	(209695, 122, '2014-02-15 00:31:42.000000', 'temperatura', 976.0000, 'ºC'),
	(209696, 122, '2014-02-15 00:31:43.000000', 'temperatura', 330.0000, 'ºC'),
	(209697, 122, '2014-02-15 00:31:44.000000', 'temperatura', 1121.0000, 'ºC'),
	(209698, 122, '2014-02-15 00:31:45.000000', 'temperatura', 1015.0000, 'ºC'),
	(209699, 122, '2014-02-15 00:31:46.000000', 'temperatura', 511.0000, 'ºC'),
	(209700, 122, '2014-02-15 00:31:47.000000', 'temperatura', 711.0000, 'ºC'),
	(209701, 122, '2014-02-15 00:31:48.000000', 'temperatura', 824.0000, 'ºC'),
	(209702, 122, '2014-02-15 00:31:49.000000', 'temperatura', 789.0000, 'ºC'),
	(209703, 122, '2014-02-15 00:31:50.000000', 'temperatura', 270.0000, 'ºC'),
	(209704, 122, '2014-02-15 00:31:51.000000', 'temperatura', 186.0000, 'ºC'),
	(209705, 122, '2014-02-15 00:31:52.000000', 'temperatura', 121.0000, 'ºC'),
	(209706, 122, '2014-02-15 00:31:53.000000', 'temperatura', 47.0000, 'ºC'),
	(209707, 122, '2014-02-15 00:31:54.000000', 'temperatura', 1071.0000, 'ºC'),
	(209708, 122, '2014-02-15 00:31:55.000000', 'temperatura', 417.0000, 'ºC'),
	(209709, 122, '2014-02-15 00:31:56.000000', 'temperatura', 73.0000, 'ºC'),
	(209710, 122, '2014-02-15 00:31:57.000000', 'temperatura', 315.0000, 'ºC'),
	(209711, 122, '2014-02-15 00:31:58.000000', 'temperatura', 155.0000, 'ºC'),
	(209712, 122, '2014-02-15 00:31:59.000000', 'temperatura', 1033.0000, 'ºC'),
	(209713, 122, '2014-02-15 00:32:00.000000', 'temperatura', 1097.0000, 'ºC'),
	(209714, 122, '2014-02-15 00:32:01.000000', 'temperatura', 1189.0000, 'ºC'),
	(209715, 122, '2014-02-15 00:32:02.000000', 'temperatura', 255.0000, 'ºC'),
	(209716, 122, '2014-02-15 00:32:03.000000', 'temperatura', 108.0000, 'ºC'),
	(209717, 122, '2014-02-15 00:32:04.000000', 'temperatura', 975.0000, 'ºC'),
	(209718, 122, '2014-02-15 00:32:05.000000', 'temperatura', 950.0000, 'ºC'),
	(209719, 122, '2014-02-15 00:32:06.000000', 'temperatura', 628.0000, 'ºC'),
	(209720, 122, '2014-02-15 00:32:07.000000', 'temperatura', 288.0000, 'ºC'),
	(209721, 122, '2014-02-15 00:32:08.000000', 'temperatura', 758.0000, 'ºC'),
	(209722, 122, '2014-02-15 00:32:09.000000', 'temperatura', 527.0000, 'ºC'),
	(209723, 122, '2014-02-15 00:32:10.000000', 'temperatura', 360.0000, 'ºC'),
	(209724, 122, '2014-02-15 00:32:11.000000', 'temperatura', 221.0000, 'ºC'),
	(209725, 122, '2014-02-15 00:32:12.000000', 'temperatura', 26.0000, 'ºC'),
	(209726, 122, '2014-02-15 00:32:13.000000', 'temperatura', 668.0000, 'ºC'),
	(209727, 122, '2014-02-15 00:32:14.000000', 'temperatura', 863.0000, 'ºC'),
	(209728, 122, '2014-02-15 00:32:15.000000', 'temperatura', 1109.0000, 'ºC'),
	(209729, 122, '2014-02-15 00:32:16.000000', 'temperatura', 558.0000, 'ºC'),
	(209730, 122, '2014-02-15 00:32:17.000000', 'temperatura', 663.0000, 'ºC'),
	(209731, 122, '2014-02-15 00:32:18.000000', 'temperatura', 442.0000, 'ºC'),
	(209732, 122, '2014-02-15 00:32:19.000000', 'temperatura', 220.0000, 'ºC'),
	(209733, 122, '2014-02-15 00:32:20.000000', 'temperatura', 974.0000, 'ºC'),
	(209734, 122, '2014-02-15 00:32:21.000000', 'temperatura', 613.0000, 'ºC'),
	(209735, 122, '2014-02-15 00:32:22.000000', 'temperatura', 141.0000, 'ºC'),
	(209736, 122, '2014-02-15 00:32:23.000000', 'temperatura', 67.0000, 'ºC'),
	(209737, 122, '2014-02-15 00:32:24.000000', 'temperatura', 1112.0000, 'ºC'),
	(209738, 122, '2014-02-15 00:32:25.000000', 'temperatura', 560.0000, 'ºC'),
	(209739, 122, '2014-02-15 00:32:26.000000', 'temperatura', 666.0000, 'ºC'),
	(209740, 122, '2014-02-15 00:32:27.000000', 'temperatura', 450.0000, 'ºC'),
	(209741, 122, '2014-02-15 00:32:28.000000', 'temperatura', 251.0000, 'ºC'),
	(209742, 122, '2014-02-15 00:32:29.000000', 'temperatura', 1107.0000, 'ºC'),
	(209743, 122, '2014-02-15 00:32:30.000000', 'temperatura', 1180.0000, 'ºC'),
	(209744, 122, '2014-02-15 00:32:31.000000', 'temperatura', 182.0000, 'ºC'),
	(209745, 122, '2014-02-15 00:32:32.000000', 'temperatura', 970.0000, 'ºC'),
	(209746, 122, '2014-02-15 00:32:33.000000', 'temperatura', 704.0000, 'ºC'),
	(209747, 122, '2014-02-15 00:32:34.000000', 'temperatura', 611.0000, 'ºC'),
	(209748, 122, '2014-02-15 00:32:35.000000', 'temperatura', 943.0000, 'ºC'),
	(209749, 122, '2014-02-15 00:32:36.000000', 'temperatura', 482.0000, 'ºC'),
	(209750, 122, '2014-02-15 00:32:37.000000', 'temperatura', 783.0000, 'ºC'),
	(209751, 122, '2014-02-15 00:32:38.000000', 'temperatura', 70.0000, 'ºC'),
	(209752, 122, '2014-02-15 00:32:39.000000', 'temperatura', 400.0000, 'ºC'),
	(209753, 122, '2014-02-15 00:32:40.000000', 'temperatura', 591.0000, 'ºC'),
	(209754, 122, '2014-02-15 00:32:41.000000', 'temperatura', 557.0000, 'ºC'),
	(209755, 122, '2014-02-15 00:32:42.000000', 'temperatura', 1012.0000, 'ºC'),
	(209756, 122, '2014-02-15 00:32:43.000000', 'temperatura', 990.0000, 'ºC'),
	(209757, 122, '2014-02-15 00:32:44.000000', 'temperatura', 714.0000, 'ºC'),
	(209758, 122, '2014-02-15 00:32:45.000000', 'temperatura', 599.0000, 'ºC'),
	(209759, 122, '2014-02-15 00:32:46.000000', 'temperatura', 853.0000, 'ºC'),
	(209760, 122, '2014-02-15 00:32:47.000000', 'temperatura', 69.0000, 'ºC'),
	(209761, 122, '2014-02-15 00:32:48.000000', 'temperatura', 188.0000, 'ºC'),
	(209762, 122, '2014-02-15 00:32:49.000000', 'temperatura', 732.0000, 'ºC'),
	(209763, 122, '2014-02-15 00:32:50.000000', 'temperatura', 697.0000, 'ºC'),
	(209764, 122, '2014-02-15 00:32:51.000000', 'temperatura', 91.0000, 'ºC'),
	(209765, 122, '2014-02-15 00:32:52.000000', 'temperatura', 763.0000, 'ºC'),
	(209766, 122, '2014-02-15 00:32:53.000000', 'temperatura', 1143.0000, 'ºC'),
	(209767, 122, '2014-02-15 00:32:54.000000', 'temperatura', 1026.0000, 'ºC'),
	(209768, 122, '2014-02-15 00:32:55.000000', 'temperatura', 502.0000, 'ºC'),
	(209769, 122, '2014-02-15 00:32:56.000000', 'temperatura', 633.0000, 'ºC'),
	(209770, 122, '2014-02-15 00:32:57.000000', 'temperatura', 457.0000, 'ºC'),
	(209771, 122, '2014-02-15 00:32:58.000000', 'temperatura', 390.0000, 'ºC'),
	(209772, 122, '2014-02-15 00:32:59.000000', 'temperatura', 578.0000, 'ºC'),
	(209773, 122, '2014-02-15 00:33:00.000000', 'temperatura', 521.0000, 'ºC'),
	(209774, 122, '2014-02-15 00:33:01.000000', 'temperatura', 872.0000, 'ºC'),
	(209775, 122, '2014-02-15 00:33:02.000000', 'temperatura', 398.0000, 'ºC'),
	(209776, 122, '2014-02-15 00:33:03.000000', 'temperatura', 574.0000, 'ºC'),
	(209777, 122, '2014-02-15 00:33:04.000000', 'temperatura', 475.0000, 'ºC'),
	(209778, 122, '2014-02-15 00:33:05.000000', 'temperatura', 656.0000, 'ºC'),
	(209779, 122, '2014-02-15 00:33:06.000000', 'temperatura', 657.0000, 'ºC'),
	(209780, 122, '2014-02-15 00:33:07.000000', 'temperatura', 114.0000, 'ºC'),
	(209781, 122, '2014-02-15 00:33:08.000000', 'temperatura', 999.0000, 'ºC'),
	(209782, 122, '2014-02-15 00:33:09.000000', 'temperatura', 1056.0000, 'ºC'),
	(209783, 122, '2014-02-15 00:33:10.000000', 'temperatura', 1085.0000, 'ºC'),
	(209784, 122, '2014-02-15 00:33:11.000000', 'temperatura', 1054.0000, 'ºC'),
	(209785, 122, '2014-02-15 00:33:12.000000', 'temperatura', 818.0000, 'ºC'),
	(209786, 122, '2014-02-15 00:33:13.000000', 'temperatura', 928.0000, 'ºC'),
	(209787, 122, '2014-02-15 00:33:14.000000', 'temperatura', 984.0000, 'ºC'),
	(209788, 122, '2014-02-15 00:33:15.000000', 'temperatura', 940.0000, 'ºC'),
	(209789, 122, '2014-02-15 00:33:16.000000', 'temperatura', 547.0000, 'ºC'),
	(209790, 122, '2014-02-15 00:33:17.000000', 'temperatura', 1114.0000, 'ºC'),
	(209791, 122, '2014-02-15 00:33:18.000000', 'temperatura', 332.0000, 'ºC'),
	(209792, 122, '2014-02-15 00:33:19.000000', 'temperatura', 719.0000, 'ºC'),
	(209793, 122, '2014-02-15 00:33:20.000000', 'temperatura', 199.0000, 'ºC'),
	(209794, 122, '2014-02-15 00:33:21.000000', 'temperatura', 39.0000, 'ºC'),
	(209795, 122, '2014-02-15 00:33:22.000000', 'temperatura', 798.0000, 'ºC'),
	(209796, 122, '2014-02-15 00:33:23.000000', 'temperatura', 274.0000, 'ºC'),
	(209797, 122, '2014-02-15 00:33:24.000000', 'temperatura', 178.0000, 'ºC'),
	(209798, 122, '2014-02-15 00:33:25.000000', 'temperatura', 66.0000, 'ºC'),
	(209799, 122, '2014-02-15 00:33:26.000000', 'temperatura', 996.0000, 'ºC'),
	(209800, 122, '2014-02-15 00:33:27.000000', 'temperatura', 1184.0000, 'ºC'),
	(209801, 122, '2014-02-15 00:33:28.000000', 'temperatura', 533.0000, 'ºC'),
	(209802, 122, '2014-02-15 00:33:29.000000', 'temperatura', 312.0000, 'ºC'),
	(209803, 122, '2014-02-15 00:33:30.000000', 'temperatura', 1160.0000, 'ºC'),
	(209804, 122, '2014-02-15 00:33:31.000000', 'temperatura', 68.0000, 'ºC'),
	(209805, 122, '2014-02-15 00:33:32.000000', 'temperatura', 459.0000, 'ºC'),
	(209806, 122, '2014-02-15 00:33:33.000000', 'temperatura', 892.0000, 'ºC'),
	(209807, 122, '2014-02-15 00:33:34.000000', 'temperatura', 685.0000, 'ºC'),
	(209808, 122, '2014-02-15 00:33:35.000000', 'temperatura', 746.0000, 'ºC'),
	(209809, 122, '2014-02-15 00:33:36.000000', 'temperatura', 479.0000, 'ºC'),
	(209810, 122, '2014-02-15 00:33:37.000000', 'temperatura', 154.0000, 'ºC'),
	(209811, 122, '2014-02-15 00:33:38.000000', 'temperatura', 536.0000, 'ºC'),
	(209812, 122, '2014-02-15 00:33:39.000000', 'temperatura', 1019.0000, 'ºC'),
	(209813, 122, '2014-02-15 00:33:40.000000', 'temperatura', 1088.0000, 'ºC'),
	(209814, 122, '2014-02-15 00:33:41.000000', 'temperatura', 1185.0000, 'ºC'),
	(209815, 122, '2014-02-15 00:33:42.000000', 'temperatura', 259.0000, 'ºC'),
	(209816, 122, '2014-02-15 00:33:43.000000', 'temperatura', 139.0000, 'ºC'),
	(209817, 122, '2014-02-15 00:33:44.000000', 'temperatura', 1120.0000, 'ºC'),
	(209818, 122, '2014-02-15 00:33:45.000000', 'temperatura', 382.0000, 'ºC'),
	(209819, 122, '2014-02-15 00:33:46.000000', 'temperatura', 951.0000, 'ºC'),
	(209820, 122, '2014-02-15 00:33:47.000000', 'temperatura', 8.0000, 'ºC'),
	(209821, 122, '2014-02-15 00:33:48.000000', 'temperatura', 788.0000, 'ºC'),
	(209822, 122, '2014-02-15 00:33:49.000000', 'temperatura', 316.0000, 'ºC'),
	(209823, 122, '2014-02-15 00:33:50.000000', 'temperatura', 416.0000, 'ºC'),
	(209824, 122, '2014-02-15 00:33:51.000000', 'temperatura', 1134.0000, 'ºC'),
	(209825, 122, '2014-02-15 00:33:52.000000', 'temperatura', 820.0000, 'ºC'),
	(209826, 122, '2014-02-15 00:33:53.000000', 'temperatura', 700.0000, 'ºC'),
	(209827, 122, '2014-02-15 00:33:54.000000', 'temperatura', 1039.0000, 'ºC'),
	(209828, 122, '2014-02-15 00:33:55.000000', 'temperatura', 697.0000, 'ºC'),
	(209829, 122, '2014-02-15 00:33:56.000000', 'temperatura', 366.0000, 'ºC'),
	(209830, 122, '2014-02-15 00:33:57.000000', 'temperatura', 943.0000, 'ºC'),
	(209831, 122, '2014-02-15 00:33:58.000000', 'temperatura', 15.0000, 'ºC'),
	(209832, 122, '2014-02-15 00:33:59.000000', 'temperatura', 848.0000, 'ºC'),
	(209833, 122, '2014-02-15 00:34:00.000000', 'temperatura', 594.0000, 'ºC'),
	(209834, 122, '2014-02-15 00:34:01.000000', 'temperatura', 429.0000, 'ºC'),
	(209835, 122, '2014-02-15 00:34:02.000000', 'temperatura', 364.0000, 'ºC'),
	(209836, 122, '2014-02-15 00:34:03.000000', 'temperatura', 530.0000, 'ºC'),
	(209837, 122, '2014-02-15 00:34:04.000000', 'temperatura', 362.0000, 'ºC'),
	(209838, 122, '2014-02-15 00:34:05.000000', 'temperatura', 219.0000, 'ºC'),
	(209839, 122, '2014-02-15 00:34:06.000000', 'temperatura', 9.0000, 'ºC'),
	(209840, 122, '2014-02-15 00:34:07.000000', 'temperatura', 589.0000, 'ºC'),
	(209841, 122, '2014-02-15 00:34:08.000000', 'temperatura', 519.0000, 'ºC'),
	(209842, 122, '2014-02-15 00:34:09.000000', 'temperatura', 828.0000, 'ºC'),
	(209843, 122, '2014-02-15 00:34:10.000000', 'temperatura', 185.0000, 'ºC'),
	(209844, 122, '2014-02-15 00:34:11.000000', 'temperatura', 842.0000, 'ºC'),
	(209845, 122, '2014-02-15 00:34:12.000000', 'temperatura', 54.0000, 'ºC'),
	(209846, 122, '2014-02-15 00:34:13.000000', 'temperatura', 146.0000, 'ºC'),
	(209847, 122, '2014-02-15 00:34:14.000000', 'temperatura', 566.0000, 'ºC'),
	(209848, 122, '2014-02-15 00:34:15.000000', 'temperatura', 1195.0000, 'ºC'),
	(209849, 122, '2014-02-15 00:34:16.000000', 'temperatura', 677.0000, 'ºC'),
	(209850, 122, '2014-02-15 00:34:17.000000', 'temperatura', 998.0000, 'ºC'),
	(209851, 122, '2014-02-15 00:34:18.000000', 'temperatura', 563.0000, 'ºC'),
	(209852, 122, '2014-02-15 00:34:19.000000', 'temperatura', 1021.0000, 'ºC'),
	(209853, 122, '2014-02-15 00:34:20.000000', 'temperatura', 1015.0000, 'ºC'),
	(209854, 122, '2014-02-15 00:34:21.000000', 'temperatura', 814.0000, 'ºC'),
	(209855, 122, '2014-02-15 00:34:22.000000', 'temperatura', 1023.0000, 'ºC'),
	(209856, 122, '2014-02-15 00:34:23.000000', 'temperatura', 274.0000, 'ºC'),
	(209857, 122, '2014-02-15 00:34:24.000000', 'temperatura', 702.0000, 'ºC'),
	(209858, 122, '2014-02-15 00:34:25.000000', 'temperatura', 290.0000, 'ºC'),
	(209859, 122, '2014-02-15 00:34:26.000000', 'temperatura', 544.0000, 'ºC'),
	(209860, 122, '2014-02-15 00:34:27.000000', 'temperatura', 651.0000, 'ºC'),
	(209861, 122, '2014-02-15 00:34:28.000000', 'temperatura', 422.0000, 'ºC'),
	(209862, 122, '2014-02-15 00:34:29.000000', 'temperatura', 157.0000, 'ºC'),
	(209863, 122, '2014-02-15 00:34:30.000000', 'temperatura', 720.0000, 'ºC'),
	(209864, 122, '2014-02-15 00:34:31.000000', 'temperatura', 730.0000, 'ºC'),
	(209865, 122, '2014-02-15 00:34:32.000000', 'temperatura', 292.0000, 'ºC'),
	(209866, 122, '2014-02-15 00:34:33.000000', 'temperatura', 468.0000, 'ºC'),
	(209867, 122, '2014-02-15 00:34:34.000000', 'temperatura', 266.0000, 'ºC'),
	(209868, 122, '2014-02-15 00:34:35.000000', 'temperatura', 1128.0000, 'ºC'),
	(209869, 122, '2014-02-15 00:34:36.000000', 'temperatura', 41.0000, 'ºC'),
	(209870, 122, '2014-02-15 00:34:37.000000', 'temperatura', 420.0000, 'ºC'),
	(209871, 122, '2014-02-15 00:34:38.000000', 'temperatura', 781.0000, 'ºC'),
	(209872, 122, '2014-02-15 00:34:39.000000', 'temperatura', 243.0000, 'ºC'),
	(209873, 122, '2014-02-15 00:34:40.000000', 'temperatura', 72.0000, 'ºC'),
	(209874, 122, '2014-02-15 00:34:41.000000', 'temperatura', 832.0000, 'ºC'),
	(209875, 122, '2014-02-15 00:34:42.000000', 'temperatura', 346.0000, 'ºC'),
	(209876, 122, '2014-02-15 00:34:43.000000', 'temperatura', 433.0000, 'ºC'),
	(209877, 122, '2014-02-15 00:34:44.000000', 'temperatura', 1127.0000, 'ºC'),
	(209878, 122, '2014-02-15 00:34:45.000000', 'temperatura', 736.0000, 'ºC'),
	(209879, 122, '2014-02-15 00:34:46.000000', 'temperatura', 301.0000, 'ºC'),
	(209880, 122, '2014-02-15 00:34:47.000000', 'temperatura', 497.0000, 'ºC'),
	(209881, 122, '2014-02-15 00:34:48.000000', 'temperatura', 381.0000, 'ºC'),
	(209882, 122, '2014-02-15 00:34:49.000000', 'temperatura', 416.0000, 'ºC'),
	(209883, 122, '2014-02-15 00:34:50.000000', 'temperatura', 936.0000, 'ºC'),
	(209884, 122, '2014-02-15 00:34:51.000000', 'temperatura', 1033.0000, 'ºC'),
	(209885, 122, '2014-02-15 00:34:52.000000', 'temperatura', 1158.0000, 'ºC'),
	(209886, 122, '2014-02-15 00:34:53.000000', 'temperatura', 293.0000, 'ºC'),
	(209887, 122, '2014-02-15 00:34:54.000000', 'temperatura', 392.0000, 'ºC'),
	(209888, 122, '2014-02-15 00:34:55.000000', 'temperatura', 1081.0000, 'ºC'),
	(209889, 122, '2014-02-15 00:34:56.000000', 'temperatura', 628.0000, 'ºC'),
	(209890, 122, '2014-02-15 00:34:57.000000', 'temperatura', 1097.0000, 'ºC'),
	(209891, 122, '2014-02-15 00:34:58.000000', 'temperatura', 2.0000, 'ºC'),
	(209892, 122, '2014-02-15 00:34:59.000000', 'temperatura', 322.0000, 'ºC'),
	(209893, 122, '2014-02-15 00:35:00.000000', 'temperatura', 401.0000, 'ºC'),
	(209894, 122, '2014-02-15 00:35:01.000000', 'temperatura', 1040.0000, 'ºC'),
	(209895, 122, '2014-02-15 00:35:02.000000', 'temperatura', 400.0000, 'ºC'),
	(209896, 122, '2014-02-15 00:35:03.000000', 'temperatura', 78.0000, 'ºC'),
	(209897, 122, '2014-02-15 00:35:04.000000', 'temperatura', 393.0000, 'ºC'),
	(209898, 122, '2014-02-15 00:35:05.000000', 'temperatura', 531.0000, 'ºC'),
	(209899, 122, '2014-02-15 00:35:06.000000', 'temperatura', 277.0000, 'ºC'),
	(209900, 122, '2014-02-15 00:35:07.000000', 'temperatura', 992.0000, 'ºC'),
	(209901, 122, '2014-02-15 00:35:08.000000', 'temperatura', 531.0000, 'ºC'),
	(209902, 122, '2014-02-15 00:35:09.000000', 'temperatura', 880.0000, 'ºC'),
	(209903, 122, '2014-02-15 00:35:10.000000', 'temperatura', 406.0000, 'ºC'),
	(209904, 122, '2014-02-15 00:35:11.000000', 'temperatura', 592.0000, 'ºC'),
	(209905, 122, '2014-02-15 00:35:12.000000', 'temperatura', 543.0000, 'ºC'),
	(209906, 122, '2014-02-15 00:35:13.000000', 'temperatura', 937.0000, 'ºC'),
	(209907, 122, '2014-02-15 00:35:14.000000', 'temperatura', 659.0000, 'ºC'),
	(209908, 122, '2014-02-15 00:35:15.000000', 'temperatura', 485.0000, 'ºC'),
	(209909, 122, '2014-02-15 00:35:16.000000', 'temperatura', 446.0000, 'ºC'),
	(209910, 122, '2014-02-15 00:35:17.000000', 'temperatura', 776.0000, 'ºC'),
	(209911, 122, '2014-02-15 00:35:18.000000', 'temperatura', 141.0000, 'ºC'),
	(209912, 122, '2014-02-15 00:35:19.000000', 'temperatura', 780.0000, 'ºC'),
	(209913, 122, '2014-02-15 00:35:20.000000', 'temperatura', 1079.0000, 'ºC'),
	(209914, 122, '2014-02-15 00:35:21.000000', 'temperatura', 653.0000, 'ºC'),
	(209915, 122, '2014-02-15 00:35:22.000000', 'temperatura', 29.0000, 'ºC'),
	(209916, 122, '2014-02-15 00:35:23.000000', 'temperatura', 588.0000, 'ºC'),
	(209917, 122, '2014-02-15 00:35:24.000000', 'temperatura', 452.0000, 'ºC'),
	(209918, 122, '2014-02-15 00:35:25.000000', 'temperatura', 497.0000, 'ºC'),
	(209919, 122, '2014-02-15 00:35:26.000000', 'temperatura', 1131.0000, 'ºC'),
	(209920, 122, '2014-02-15 00:35:27.000000', 'temperatura', 565.0000, 'ºC'),
	(209921, 122, '2014-02-15 00:35:28.000000', 'temperatura', 633.0000, 'ºC'),
	(209922, 122, '2014-02-15 00:35:29.000000', 'temperatura', 267.0000, 'ºC'),
	(209923, 122, '2014-02-15 00:35:30.000000', 'temperatura', 639.0000, 'ºC'),
	(209924, 122, '2014-02-15 00:35:31.000000', 'temperatura', 1194.0000, 'ºC'),
	(209925, 122, '2014-02-15 00:35:32.000000', 'temperatura', 455.0000, 'ºC'),
	(209926, 122, '2014-02-15 00:35:33.000000', 'temperatura', 1090.0000, 'ºC'),
	(209927, 122, '2014-02-15 00:35:34.000000', 'temperatura', 489.0000, 'ºC'),
	(209928, 122, '2014-02-15 00:35:35.000000', 'temperatura', 373.0000, 'ºC'),
	(209929, 122, '2014-02-15 00:35:36.000000', 'temperatura', 397.0000, 'ºC'),
	(209930, 122, '2014-02-15 00:35:37.000000', 'temperatura', 870.0000, 'ºC'),
	(209931, 122, '2014-02-15 00:35:38.000000', 'temperatura', 759.0000, 'ºC'),
	(209932, 122, '2014-02-15 00:35:39.000000', 'temperatura', 1186.0000, 'ºC'),
	(209933, 122, '2014-02-15 00:35:40.000000', 'temperatura', 54.0000, 'ºC'),
	(209934, 122, '2014-02-15 00:35:41.000000', 'temperatura', 311.0000, 'ºC'),
	(209935, 122, '2014-02-15 00:35:42.000000', 'temperatura', 193.0000, 'ºC'),
	(209936, 122, '2014-02-15 00:35:43.000000', 'temperatura', 32.0000, 'ºC'),
	(209937, 122, '2014-02-15 00:35:44.000000', 'temperatura', 784.0000, 'ºC'),
	(209938, 122, '2014-02-15 00:35:45.000000', 'temperatura', 225.0000, 'ºC'),
	(209939, 122, '2014-02-15 00:35:46.000000', 'temperatura', 1170.0000, 'ºC'),
	(209940, 122, '2014-02-15 00:35:47.000000', 'temperatura', 379.0000, 'ºC'),
	(209941, 122, '2014-02-15 00:35:48.000000', 'temperatura', 785.0000, 'ºC'),
	(209942, 122, '2014-02-15 00:35:49.000000', 'temperatura', 389.0000, 'ºC'),
	(209943, 122, '2014-02-15 00:35:50.000000', 'temperatura', 789.0000, 'ºC'),
	(209944, 122, '2014-02-15 00:35:51.000000', 'temperatura', 378.0000, 'ºC'),
	(209945, 122, '2014-02-15 00:35:52.000000', 'temperatura', 726.0000, 'ºC'),
	(209946, 122, '2014-02-15 00:35:53.000000', 'temperatura', 94.0000, 'ºC'),
	(209947, 122, '2014-02-15 00:35:54.000000', 'temperatura', 692.0000, 'ºC'),
	(209948, 122, '2014-02-15 00:35:55.000000', 'temperatura', 781.0000, 'ºC'),
	(209949, 122, '2014-02-15 00:35:56.000000', 'temperatura', 628.0000, 'ºC'),
	(209950, 122, '2014-02-15 00:35:57.000000', 'temperatura', 797.0000, 'ºC'),
	(209951, 122, '2014-02-15 00:35:58.000000', 'temperatura', 901.0000, 'ºC'),
	(209952, 122, '2014-02-15 00:35:59.000000', 'temperatura', 916.0000, 'ºC'),
	(209953, 122, '2014-02-15 00:36:00.000000', 'temperatura', 677.0000, 'ºC'),
	(209954, 122, '2014-02-15 00:36:01.000000', 'temperatura', 637.0000, 'ºC'),
	(209955, 122, '2014-02-15 00:36:02.000000', 'temperatura', 1155.0000, 'ºC'),
	(209956, 122, '2014-02-15 00:36:03.000000', 'temperatura', 262.0000, 'ºC'),
	(209957, 122, '2014-02-15 00:36:04.000000', 'temperatura', 249.0000, 'ºC'),
	(209958, 122, '2014-02-15 00:36:05.000000', 'temperatura', 458.0000, 'ºC'),
	(209959, 122, '2014-02-15 00:36:06.000000', 'temperatura', 342.0000, 'ºC'),
	(209960, 122, '2014-02-15 00:36:07.000000', 'temperatura', 339.0000, 'ºC'),
	(209961, 122, '2014-02-15 00:36:08.000000', 'temperatura', 667.0000, 'ºC'),
	(209962, 122, '2014-02-15 00:36:09.000000', 'temperatura', 1119.0000, 'ºC'),
	(209963, 122, '2014-02-15 00:36:10.000000', 'temperatura', 1195.0000, 'ºC'),
	(209964, 122, '2014-02-15 00:36:11.000000', 'temperatura', 220.0000, 'ºC'),
	(209965, 122, '2014-02-15 00:36:12.000000', 'temperatura', 1113.0000, 'ºC'),
	(209966, 122, '2014-02-15 00:36:13.000000', 'temperatura', 107.0000, 'ºC'),
	(209967, 122, '2014-02-15 00:36:14.000000', 'temperatura', 795.0000, 'ºC'),
	(209968, 122, '2014-02-15 00:36:15.000000', 'temperatura', 56.0000, 'ºC'),
	(209969, 122, '2014-02-15 00:36:16.000000', 'temperatura', 295.0000, 'ºC'),
	(209970, 122, '2014-02-15 00:36:17.000000', 'temperatura', 106.0000, 'ºC'),
	(209971, 122, '2014-02-15 00:36:18.000000', 'temperatura', 848.0000, 'ºC'),
	(209972, 122, '2014-02-15 00:36:19.000000', 'temperatura', 324.0000, 'ºC'),
	(209973, 122, '2014-02-15 00:36:20.000000', 'temperatura', 273.0000, 'ºC'),
	(209974, 122, '2014-02-15 00:36:21.000000', 'temperatura', 394.0000, 'ºC'),
	(209975, 122, '2014-02-15 00:36:22.000000', 'temperatura', 1152.0000, 'ºC'),
	(209976, 122, '2014-02-15 00:36:23.000000', 'temperatura', 980.0000, 'ºC'),
	(209977, 122, '2014-02-15 00:36:24.000000', 'temperatura', 242.0000, 'ºC'),
	(209978, 122, '2014-02-15 00:36:25.000000', 'temperatura', 671.0000, 'ºC'),
	(209979, 122, '2014-02-15 00:36:26.000000', 'temperatura', 230.0000, 'ºC'),
	(209980, 122, '2014-02-15 00:36:27.000000', 'temperatura', 335.0000, 'ºC'),
	(209981, 122, '2014-02-15 00:36:28.000000', 'temperatura', 989.0000, 'ºC'),
	(209982, 122, '2014-02-15 00:36:29.000000', 'temperatura', 340.0000, 'ºC'),
	(209983, 122, '2014-02-15 00:36:30.000000', 'temperatura', 1132.0000, 'ºC'),
	(209984, 122, '2014-02-15 00:36:31.000000', 'temperatura', 1042.0000, 'ºC'),
	(209985, 122, '2014-02-15 00:36:32.000000', 'temperatura', 613.0000, 'ºC'),
	(209986, 122, '2014-02-15 00:36:33.000000', 'temperatura', 1141.0000, 'ºC'),
	(209987, 122, '2014-02-15 00:36:34.000000', 'temperatura', 268.0000, 'ºC'),
	(209988, 122, '2014-02-15 00:36:35.000000', 'temperatura', 316.0000, 'ºC'),
	(209989, 122, '2014-02-15 00:36:36.000000', 'temperatura', 777.0000, 'ºC'),
	(209990, 122, '2014-02-15 00:36:37.000000', 'temperatura', 535.0000, 'ºC'),
	(209991, 122, '2014-02-15 00:36:38.000000', 'temperatura', 347.0000, 'ºC'),
	(209992, 122, '2014-02-15 00:36:39.000000', 'temperatura', 129.0000, 'ºC'),
	(209993, 122, '2014-02-15 00:36:40.000000', 'temperatura', 804.0000, 'ºC'),
	(209994, 122, '2014-02-15 00:36:41.000000', 'temperatura', 33.0000, 'ºC'),
	(209995, 122, '2014-02-15 00:36:42.000000', 'temperatura', 155.0000, 'ºC'),
	(209996, 122, '2014-02-15 00:36:43.000000', 'temperatura', 676.0000, 'ºC'),
	(209997, 122, '2014-02-15 00:36:44.000000', 'temperatura', 516.0000, 'ºC'),
	(209998, 122, '2014-02-15 00:36:45.000000', 'temperatura', 550.0000, 'ºC'),
	(209999, 122, '2014-02-15 00:36:46.000000', 'temperatura', 5.0000, 'ºC'),
	(210000, 122, '2014-02-15 00:36:47.000000', 'temperatura', 774.0000, 'ºC'),
	(210001, 122, '2014-02-15 00:36:48.000000', 'temperatura', 258.0000, 'ºC'),
	(210002, 122, '2014-02-15 00:36:49.000000', 'temperatura', 167.0000, 'ºC'),
	(210003, 122, '2014-02-15 00:36:50.000000', 'temperatura', 60.0000, 'ºC'),
	(210004, 122, '2014-02-15 00:36:51.000000', 'temperatura', 999.0000, 'ºC'),
	(210005, 122, '2014-02-15 00:36:52.000000', 'temperatura', 15.0000, 'ºC'),
	(210006, 122, '2014-02-15 00:36:53.000000', 'temperatura', 682.0000, 'ºC'),
	(210007, 122, '2014-02-15 00:36:54.000000', 'temperatura', 962.0000, 'ºC'),
	(210008, 122, '2014-02-15 00:36:55.000000', 'temperatura', 366.0000, 'ºC'),
	(210009, 122, '2014-02-15 00:36:56.000000', 'temperatura', 145.0000, 'ºC'),
	(210010, 122, '2014-02-15 00:36:57.000000', 'temperatura', 828.0000, 'ºC'),
	(210011, 122, '2014-02-15 00:36:58.000000', 'temperatura', 105.0000, 'ºC'),
	(210012, 122, '2014-02-15 00:36:59.000000', 'temperatura', 443.0000, 'ºC'),
	(210013, 122, '2014-02-15 00:37:00.000000', 'temperatura', 699.0000, 'ºC'),
	(210014, 122, '2014-02-15 00:37:01.000000', 'temperatura', 968.0000, 'ºC'),
	(210015, 122, '2014-02-15 00:37:02.000000', 'temperatura', 344.0000, 'ºC'),
	(210016, 122, '2014-02-15 00:37:03.000000', 'temperatura', 14.0000, 'ºC'),
	(210017, 122, '2014-02-15 00:37:04.000000', 'temperatura', 238.0000, 'ºC'),
	(210018, 122, '2014-02-15 00:37:05.000000', 'temperatura', 1150.0000, 'ºC'),
	(210019, 122, '2014-02-15 00:37:06.000000', 'temperatura', 237.0000, 'ºC'),
	(210020, 122, '2014-02-15 00:37:07.000000', 'temperatura', 134.0000, 'ºC'),
	(210021, 122, '2014-02-15 00:37:08.000000', 'temperatura', 1161.0000, 'ºC'),
	(210022, 122, '2014-02-15 00:37:09.000000', 'temperatura', 602.0000, 'ºC'),
	(210023, 122, '2014-02-15 00:37:10.000000', 'temperatura', 728.0000, 'ºC'),
	(210024, 122, '2014-02-15 00:37:11.000000', 'temperatura', 636.0000, 'ºC'),
	(210025, 122, '2014-02-15 00:37:12.000000', 'temperatura', 997.0000, 'ºC'),
	(210026, 122, '2014-02-15 00:37:13.000000', 'temperatura', 675.0000, 'ºC'),
	(210027, 122, '2014-02-15 00:37:14.000000', 'temperatura', 387.0000, 'ºC'),
	(210028, 122, '2014-02-15 00:37:15.000000', 'temperatura', 1110.0000, 'ºC'),
	(210029, 122, '2014-02-15 00:37:16.000000', 'temperatura', 790.0000, 'ºC'),
	(210030, 122, '2014-02-15 00:37:17.000000', 'temperatura', 620.0000, 'ºC'),
	(210031, 122, '2014-02-15 00:37:18.000000', 'temperatura', 732.0000, 'ºC'),
	(210032, 122, '2014-02-15 00:37:19.000000', 'temperatura', 600.0000, 'ºC'),
	(210033, 122, '2014-02-15 00:37:20.000000', 'temperatura', 805.0000, 'ºC'),
	(210034, 122, '2014-02-15 00:37:21.000000', 'temperatura', 1023.0000, 'ºC'),
	(210035, 122, '2014-02-15 00:37:22.000000', 'temperatura', 303.0000, 'ºC'),
	(210036, 122, '2014-02-15 00:37:23.000000', 'temperatura', 847.0000, 'ºC'),
	(210037, 122, '2014-02-15 00:37:24.000000', 'temperatura', 927.0000, 'ºC'),
	(210038, 122, '2014-02-15 00:37:25.000000', 'temperatura', 895.0000, 'ºC'),
	(210039, 122, '2014-02-15 00:37:26.000000', 'temperatura', 492.0000, 'ºC'),
	(210040, 122, '2014-02-15 00:37:27.000000', 'temperatura', 975.0000, 'ºC'),
	(210041, 122, '2014-02-15 00:37:28.000000', 'temperatura', 1001.0000, 'ºC'),
	(210042, 122, '2014-02-15 00:37:29.000000', 'temperatura', 882.0000, 'ºC'),
	(210043, 122, '2014-02-15 00:37:30.000000', 'temperatura', 204.0000, 'ºC'),
	(210044, 122, '2014-02-15 00:37:31.000000', 'temperatura', 778.0000, 'ºC'),
	(210045, 122, '2014-02-15 00:37:32.000000', 'temperatura', 878.0000, 'ºC'),
	(210046, 122, '2014-02-15 00:37:33.000000', 'temperatura', 854.0000, 'ºC'),
	(210047, 122, '2014-02-15 00:37:34.000000', 'temperatura', 439.0000, 'ºC'),
	(210048, 122, '2014-02-15 00:37:35.000000', 'temperatura', 831.0000, 'ºC'),
	(210049, 122, '2014-02-15 00:37:36.000000', 'temperatura', 438.0000, 'ºC'),
	(210050, 122, '2014-02-15 00:37:37.000000', 'temperatura', 899.0000, 'ºC'),
	(210051, 122, '2014-02-15 00:37:38.000000', 'temperatura', 781.0000, 'ºC'),
	(210052, 122, '2014-02-15 00:37:39.000000', 'temperatura', 7.0000, 'ºC'),
	(210053, 122, '2014-02-15 00:37:40.000000', 'temperatura', 93.0000, 'ºC'),
	(210054, 122, '2014-02-15 00:37:41.000000', 'temperatura', 443.0000, 'ºC'),
	(210055, 122, '2014-02-15 00:37:42.000000', 'temperatura', 738.0000, 'ºC'),
	(210056, 122, '2014-02-15 00:37:43.000000', 'temperatura', 1163.0000, 'ºC'),
	(210057, 122, '2014-02-15 00:37:44.000000', 'temperatura', 1199.0000, 'ºC'),
	(210058, 122, '2014-02-15 00:37:45.000000', 'temperatura', 106.0000, 'ºC'),
	(210059, 122, '2014-02-15 00:37:46.000000', 'temperatura', 536.0000, 'ºC'),
	(210060, 122, '2014-02-15 00:37:47.000000', 'temperatura', 1163.0000, 'ºC'),
	(210061, 122, '2014-02-15 00:37:48.000000', 'temperatura', 606.0000, 'ºC'),
	(210062, 122, '2014-02-15 00:37:49.000000', 'temperatura', 744.0000, 'ºC'),
	(210063, 122, '2014-02-15 00:37:50.000000', 'temperatura', 699.0000, 'ºC'),
	(210064, 122, '2014-02-15 00:37:51.000000', 'temperatura', 64.0000, 'ºC'),
	(210065, 122, '2014-02-15 00:37:52.000000', 'temperatura', 626.0000, 'ºC'),
	(210066, 122, '2014-02-15 00:37:53.000000', 'temperatura', 536.0000, 'ºC'),
	(210067, 122, '2014-02-15 00:37:54.000000', 'temperatura', 802.0000, 'ºC'),
	(210068, 122, '2014-02-15 00:37:55.000000', 'temperatura', 1.0000, 'ºC'),
	(210069, 122, '2014-02-15 00:37:56.000000', 'temperatura', 3.0000, 'ºC'),
	(210070, 122, '2014-02-15 00:37:57.000000', 'temperatura', 9.0000, 'ºC'),
	(210071, 122, '2014-02-15 00:37:58.000000', 'temperatura', 40.0000, 'ºC'),
	(210072, 122, '2014-02-15 00:37:59.000000', 'temperatura', 172.0000, 'ºC'),
	(210073, 122, '2014-02-15 00:38:00.000000', 'temperatura', 738.0000, 'ºC'),
	(210074, 122, '2014-02-15 00:38:01.000000', 'temperatura', 778.0000, 'ºC'),
	(210075, 122, '2014-02-15 00:38:02.000000', 'temperatura', 477.0000, 'ºC'),
	(210076, 122, '2014-02-15 00:38:03.000000', 'temperatura', 51.0000, 'ºC'),
	(210077, 122, '2014-02-15 00:38:04.000000', 'temperatura', 24.0000, 'ºC'),
	(210078, 122, '2014-02-15 00:38:05.000000', 'temperatura', 1168.0000, 'ºC'),
	(210079, 122, '2014-02-15 00:38:06.000000', 'temperatura', 969.0000, 'ºC'),
	(210080, 122, '2014-02-15 00:38:07.000000', 'temperatura', 141.0000, 'ºC'),
	(210081, 122, '2014-02-15 00:38:08.000000', 'temperatura', 198.0000, 'ºC'),
	(210082, 122, '2014-02-15 00:38:09.000000', 'temperatura', 568.0000, 'ºC'),
	(210083, 122, '2014-02-15 00:38:10.000000', 'temperatura', 1046.0000, 'ºC'),
	(210084, 122, '2014-02-15 00:38:11.000000', 'temperatura', 1128.0000, 'ºC'),
	(210085, 122, '2014-02-15 00:38:12.000000', 'temperatura', 101.0000, 'ºC'),
	(210086, 122, '2014-02-15 00:38:13.000000', 'temperatura', 721.0000, 'ºC'),
	(210087, 122, '2014-02-15 00:38:14.000000', 'temperatura', 904.0000, 'ºC'),
	(210088, 122, '2014-02-15 00:38:15.000000', 'temperatura', 1155.0000, 'ºC'),
	(210089, 122, '2014-02-15 00:38:16.000000', 'temperatura', 664.0000, 'ºC'),
	(210090, 122, '2014-02-15 00:38:17.000000', 'temperatura', 1056.0000, 'ºC'),
	(210091, 122, '2014-02-15 00:38:18.000000', 'temperatura', 887.0000, 'ºC'),
	(210092, 122, '2014-02-15 00:38:19.000000', 'temperatura', 67.0000, 'ºC'),
	(210093, 122, '2014-02-15 00:38:20.000000', 'temperatura', 75.0000, 'ºC'),
	(210094, 122, '2014-02-15 00:38:21.000000', 'temperatura', 176.0000, 'ºC'),
	(210095, 122, '2014-02-15 00:38:22.000000', 'temperatura', 656.0000, 'ºC'),
	(210096, 122, '2014-02-15 00:38:23.000000', 'temperatura', 353.0000, 'ºC'),
	(210097, 122, '2014-02-15 00:38:24.000000', 'temperatura', 995.0000, 'ºC'),
	(210098, 122, '2014-02-15 00:38:25.000000', 'temperatura', 316.0000, 'ºC'),
	(210099, 122, '2014-02-15 00:38:26.000000', 'temperatura', 995.0000, 'ºC'),
	(210100, 122, '2014-02-15 00:38:27.000000', 'temperatura', 431.0000, 'ºC'),
	(210101, 122, '2014-02-15 00:38:28.000000', 'temperatura', 367.0000, 'ºC'),
	(210102, 122, '2014-02-15 00:38:29.000000', 'temperatura', 546.0000, 'ºC'),
	(210103, 122, '2014-02-15 00:38:30.000000', 'temperatura', 428.0000, 'ºC'),
	(210104, 122, '2014-02-15 00:38:31.000000', 'temperatura', 500.0000, 'ºC'),
	(210105, 122, '2014-02-15 00:38:32.000000', 'temperatura', 20.0000, 'ºC'),
	(210106, 122, '2014-02-15 00:38:33.000000', 'temperatura', 1001.0000, 'ºC'),
	(210107, 122, '2014-02-15 00:38:34.000000', 'temperatura', 142.0000, 'ºC'),
	(210108, 122, '2014-02-15 00:38:35.000000', 'temperatura', 111.0000, 'ºC'),
	(210109, 122, '2014-02-15 00:38:36.000000', 'temperatura', 128.0000, 'ºC'),
	(210110, 122, '2014-02-15 00:38:37.000000', 'temperatura', 307.0000, 'ºC'),
	(210111, 122, '2014-02-15 00:38:38.000000', 'temperatura', 1151.0000, 'ºC'),
	(210112, 122, '2014-02-15 00:38:39.000000', 'temperatura', 34.0000, 'ºC'),
	(210113, 122, '2014-02-15 00:38:40.000000', 'temperatura', 320.0000, 'ºC'),
	(210114, 122, '2014-02-15 00:38:41.000000', 'temperatura', 298.0000, 'ºC'),
	(210115, 122, '2014-02-15 00:38:42.000000', 'temperatura', 532.0000, 'ºC'),
	(210116, 122, '2014-02-15 00:38:43.000000', 'temperatura', 565.0000, 'ºC'),
	(210117, 122, '2014-02-15 00:38:44.000000', 'temperatura', 31.0000, 'ºC'),
	(210118, 122, '2014-02-15 00:38:45.000000', 'temperatura', 857.0000, 'ºC'),
	(210119, 122, '2014-02-15 00:38:46.000000', 'temperatura', 596.0000, 'ºC'),
	(210120, 122, '2014-02-15 00:38:47.000000', 'temperatura', 408.0000, 'ºC'),
	(210121, 122, '2014-02-15 00:38:48.000000', 'temperatura', 254.0000, 'ºC'),
	(210122, 122, '2014-02-15 00:38:49.000000', 'temperatura', 45.0000, 'ºC'),
	(210123, 122, '2014-02-15 00:38:50.000000', 'temperatura', 663.0000, 'ºC'),
	(210124, 122, '2014-02-15 00:38:51.000000', 'temperatura', 783.0000, 'ºC'),
	(210125, 122, '2014-02-15 00:38:52.000000', 'temperatura', 724.0000, 'ºC'),
	(210126, 122, '2014-02-15 00:38:53.000000', 'temperatura', 74.0000, 'ºC'),
	(210127, 122, '2014-02-15 00:38:54.000000', 'temperatura', 596.0000, 'ºC'),
	(210128, 122, '2014-02-15 00:38:55.000000', 'temperatura', 361.0000, 'ºC'),
	(210129, 122, '2014-02-15 00:38:56.000000', 'temperatura', 18.0000, 'ºC'),
	(210130, 122, '2014-02-15 00:38:57.000000', 'temperatura', 206.0000, 'ºC'),
	(210131, 122, '2014-02-15 00:38:58.000000', 'temperatura', 976.0000, 'ºC'),
	(210132, 122, '2014-02-15 00:38:59.000000', 'temperatura', 663.0000, 'ºC'),
	(210133, 122, '2014-02-15 00:39:00.000000', 'temperatura', 389.0000, 'ºC'),
	(210134, 122, '2014-02-15 00:39:01.000000', 'temperatura', 1154.0000, 'ºC'),
	(210135, 122, '2014-02-15 00:39:02.000000', 'temperatura', 1004.0000, 'ºC'),
	(210136, 122, '2014-02-15 00:39:03.000000', 'temperatura', 361.0000, 'ºC'),
	(210137, 122, '2014-02-15 00:39:04.000000', 'temperatura', 1191.0000, 'ºC'),
	(210138, 122, '2014-02-15 00:39:05.000000', 'temperatura', 74.0000, 'ºC'),
	(210139, 122, '2014-02-15 00:39:06.000000', 'temperatura', 396.0000, 'ºC'),
	(210140, 122, '2014-02-15 00:39:07.000000', 'temperatura', 558.0000, 'ºC'),
	(210141, 122, '2014-02-15 00:39:08.000000', 'temperatura', 402.0000, 'ºC'),
	(210142, 122, '2014-02-15 00:39:09.000000', 'temperatura', 338.0000, 'ºC'),
	(210143, 122, '2014-02-15 00:39:10.000000', 'temperatura', 482.0000, 'ºC'),
	(210144, 122, '2014-02-15 00:39:11.000000', 'temperatura', 200.0000, 'ºC'),
	(210145, 122, '2014-02-15 00:39:12.000000', 'temperatura', 752.0000, 'ºC'),
	(210146, 122, '2014-02-15 00:39:13.000000', 'temperatura', 761.0000, 'ºC'),
	(210147, 122, '2014-02-15 00:39:14.000000', 'temperatura', 350.0000, 'ºC'),
	(210148, 122, '2014-02-15 00:39:15.000000', 'temperatura', 669.0000, 'ºC'),
	(210149, 122, '2014-02-15 00:39:16.000000', 'temperatura', 1095.0000, 'ºC'),
	(210150, 122, '2014-02-15 00:39:17.000000', 'temperatura', 1070.0000, 'ºC'),
	(210151, 122, '2014-02-15 00:39:18.000000', 'temperatura', 863.0000, 'ºC'),
	(210152, 122, '2014-02-15 00:39:19.000000', 'temperatura', 1106.0000, 'ºC'),
	(210153, 122, '2014-02-15 00:39:20.000000', 'temperatura', 542.0000, 'ºC'),
	(210154, 122, '2014-02-15 00:39:21.000000', 'temperatura', 594.0000, 'ºC'),
	(210155, 122, '2014-02-15 00:39:22.000000', 'temperatura', 144.0000, 'ºC'),
	(210156, 122, '2014-02-15 00:39:23.000000', 'temperatura', 140.0000, 'ºC'),
	(210157, 122, '2014-02-15 00:39:24.000000', 'temperatura', 265.0000, 'ºC'),
	(210158, 122, '2014-02-15 00:39:25.000000', 'temperatura', 908.0000, 'ºC'),
	(210159, 122, '2014-02-15 00:39:26.000000', 'temperatura', 143.0000, 'ºC'),
	(210160, 122, '2014-02-15 00:39:27.000000', 'temperatura', 392.0000, 'ºC'),
	(210161, 122, '2014-02-15 00:39:28.000000', 'temperatura', 333.0000, 'ºC'),
	(210162, 122, '2014-02-15 00:39:29.000000', 'temperatura', 487.0000, 'ºC'),
	(210163, 122, '2014-02-15 00:39:30.000000', 'temperatura', 239.0000, 'ºC'),
	(210164, 122, '2014-02-15 00:39:31.000000', 'temperatura', 936.0000, 'ºC'),
	(210165, 122, '2014-02-15 00:39:32.000000', 'temperatura', 360.0000, 'ºC'),
	(210166, 122, '2014-02-15 00:39:33.000000', 'temperatura', 195.0000, 'ºC'),
	(210167, 122, '2014-02-15 00:39:34.000000', 'temperatura', 1093.0000, 'ºC'),
	(210168, 122, '2014-02-15 00:39:35.000000', 'temperatura', 81.0000, 'ºC'),
	(210169, 122, '2014-02-15 00:39:36.000000', 'temperatura', 728.0000, 'ºC'),
	(210170, 122, '2014-02-15 00:39:37.000000', 'temperatura', 997.0000, 'ºC'),
	(210171, 122, '2014-02-15 00:39:38.000000', 'temperatura', 400.0000, 'ºC'),
	(210172, 122, '2014-02-15 00:39:39.000000', 'temperatura', 213.0000, 'ºC'),
	(210173, 122, '2014-02-15 00:39:40.000000', 'temperatura', 1062.0000, 'ºC'),
	(210174, 122, '2014-02-15 00:39:41.000000', 'temperatura', 1072.0000, 'ºC'),
	(210175, 122, '2014-02-15 00:39:42.000000', 'temperatura', 975.0000, 'ºC'),
	(210176, 122, '2014-02-15 00:39:43.000000', 'temperatura', 461.0000, 'ºC'),
	(210177, 122, '2014-02-15 00:39:44.000000', 'temperatura', 577.0000, 'ºC'),
	(210178, 122, '2014-02-15 00:39:45.000000', 'temperatura', 306.0000, 'ºC'),
	(210179, 122, '2014-02-15 00:39:46.000000', 'temperatura', 997.0000, 'ºC'),
	(210180, 122, '2014-02-15 00:39:47.000000', 'temperatura', 470.0000, 'ºC'),
	(210181, 122, '2014-02-15 00:39:48.000000', 'temperatura', 559.0000, 'ºC'),
	(210182, 122, '2014-02-15 00:39:49.000000', 'temperatura', 185.0000, 'ºC'),
	(210183, 122, '2014-02-15 00:39:50.000000', 'temperatura', 449.0000, 'ºC'),
	(210184, 122, '2014-02-15 00:39:51.000000', 'temperatura', 488.0000, 'ºC'),
	(210185, 122, '2014-02-15 00:39:52.000000', 'temperatura', 1097.0000, 'ºC'),
	(210186, 122, '2014-02-15 00:39:53.000000', 'temperatura', 419.0000, 'ºC'),
	(210187, 122, '2014-02-15 00:39:54.000000', 'temperatura', 7.0000, 'ºC'),
	(210188, 122, '2014-02-15 00:39:55.000000', 'temperatura', 1178.0000, 'ºC'),
	(210189, 122, '2014-02-15 00:39:56.000000', 'temperatura', 1068.0000, 'ºC'),
	(210190, 122, '2014-02-15 00:39:57.000000', 'temperatura', 606.0000, 'ºC'),
	(210191, 122, '2014-02-15 00:39:58.000000', 'temperatura', 1029.0000, 'ºC'),
	(210192, 122, '2014-02-15 00:39:59.000000', 'temperatura', 927.0000, 'ºC'),
	(210193, 122, '2014-02-15 00:40:00.000000', 'temperatura', 349.0000, 'ºC'),
	(210194, 122, '2014-02-15 00:40:01.000000', 'temperatura', 165.0000, 'ºC'),
	(210195, 122, '2014-02-15 00:40:02.000000', 'temperatura', 976.0000, 'ºC'),
	(210196, 122, '2014-02-15 00:40:03.000000', 'temperatura', 789.0000, 'ºC'),
	(210197, 122, '2014-02-15 00:40:04.000000', 'temperatura', 1014.0000, 'ºC'),
	(210198, 122, '2014-02-15 00:40:05.000000', 'temperatura', 305.0000, 'ºC'),
	(210199, 122, '2014-02-15 00:40:06.000000', 'temperatura', 885.0000, 'ºC'),
	(210200, 122, '2014-02-15 00:40:07.000000', 'temperatura', 1108.0000, 'ºC'),
	(210201, 122, '2014-02-15 00:40:08.000000', 'temperatura', 486.0000, 'ºC'),
	(210202, 122, '2014-02-15 00:40:09.000000', 'temperatura', 308.0000, 'ºC'),
	(210203, 122, '2014-02-15 00:40:10.000000', 'temperatura', 83.0000, 'ºC'),
	(210204, 122, '2014-02-15 00:40:11.000000', 'temperatura', 689.0000, 'ºC'),
	(210205, 122, '2014-02-15 00:40:12.000000', 'temperatura', 799.0000, 'ºC'),
	(210206, 122, '2014-02-15 00:40:13.000000', 'temperatura', 728.0000, 'ºC'),
	(210207, 122, '2014-02-15 00:40:14.000000', 'temperatura', 44.0000, 'ºC'),
	(210208, 122, '2014-02-15 00:40:15.000000', 'temperatura', 437.0000, 'ºC'),
	(210209, 122, '2014-02-15 00:40:16.000000', 'temperatura', 851.0000, 'ºC'),
	(210210, 122, '2014-02-15 00:40:17.000000', 'temperatura', 547.0000, 'ºC'),
	(210211, 122, '2014-02-15 00:40:18.000000', 'temperatura', 180.0000, 'ºC'),
	(210212, 122, '2014-02-15 00:40:19.000000', 'temperatura', 463.0000, 'ºC'),
	(210213, 122, '2014-02-15 00:40:20.000000', 'temperatura', 572.0000, 'ºC'),
	(210214, 122, '2014-02-15 00:40:21.000000', 'temperatura', 273.0000, 'ºC'),
	(210215, 122, '2014-02-15 00:40:22.000000', 'temperatura', 851.0000, 'ºC'),
	(210216, 122, '2014-02-15 00:40:23.000000', 'temperatura', 1037.0000, 'ºC'),
	(210217, 122, '2014-02-15 00:40:24.000000', 'temperatura', 232.0000, 'ºC'),
	(210218, 122, '2014-02-15 00:40:25.000000', 'temperatura', 450.0000, 'ºC'),
	(210219, 122, '2014-02-15 00:40:26.000000', 'temperatura', 356.0000, 'ºC'),
	(210220, 122, '2014-02-15 00:40:27.000000', 'temperatura', 428.0000, 'ºC'),
	(210221, 122, '2014-02-15 00:40:28.000000', 'temperatura', 1073.0000, 'ºC'),
	(210222, 122, '2014-02-15 00:40:29.000000', 'temperatura', 483.0000, 'ºC'),
	(210223, 122, '2014-02-15 00:40:30.000000', 'temperatura', 395.0000, 'ºC'),
	(210224, 122, '2014-02-15 00:40:31.000000', 'temperatura', 528.0000, 'ºC'),
	(210225, 122, '2014-02-15 00:40:32.000000', 'temperatura', 257.0000, 'ºC'),
	(210226, 122, '2014-02-15 00:40:33.000000', 'temperatura', 899.0000, 'ºC'),
	(210227, 122, '2014-02-15 00:40:34.000000', 'temperatura', 126.0000, 'ºC'),
	(210228, 122, '2014-02-15 00:40:35.000000', 'temperatura', 334.0000, 'ºC'),
	(210229, 122, '2014-02-15 00:40:36.000000', 'temperatura', 91.0000, 'ºC'),
	(210230, 122, '2014-02-15 00:40:37.000000', 'temperatura', 656.0000, 'ºC'),
	(210231, 122, '2014-02-15 00:40:38.000000', 'temperatura', 604.0000, 'ºC'),
	(210232, 122, '2014-02-15 00:40:39.000000', 'temperatura', 1055.0000, 'ºC'),
	(210233, 122, '2014-02-15 00:40:40.000000', 'temperatura', 1063.0000, 'ºC'),
	(210234, 122, '2014-02-15 00:40:41.000000', 'temperatura', 951.0000, 'ºC'),
	(210235, 122, '2014-02-15 00:40:42.000000', 'temperatura', 367.0000, 'ºC'),
	(210236, 122, '2014-02-15 00:40:43.000000', 'temperatura', 184.0000, 'ºC'),
	(210237, 122, '2014-02-15 00:40:44.000000', 'temperatura', 1017.0000, 'ºC'),
	(210238, 122, '2014-02-15 00:40:45.000000', 'temperatura', 932.0000, 'ºC'),
	(210239, 122, '2014-02-15 00:40:46.000000', 'temperatura', 413.0000, 'ºC'),
	(210240, 122, '2014-02-15 00:40:47.000000', 'temperatura', 468.0000, 'ºC'),
	(210241, 122, '2014-02-15 00:40:48.000000', 'temperatura', 1101.0000, 'ºC'),
	(210242, 122, '2014-02-15 00:40:49.000000', 'temperatura', 500.0000, 'ºC'),
	(210243, 122, '2014-02-15 00:40:50.000000', 'temperatura', 400.0000, 'ºC'),
	(210244, 122, '2014-02-15 00:40:51.000000', 'temperatura', 501.0000, 'ºC'),
	(210245, 122, '2014-02-15 00:40:52.000000', 'temperatura', 106.0000, 'ºC'),
	(210246, 122, '2014-02-15 00:40:53.000000', 'temperatura', 228.0000, 'ºC'),
	(210247, 122, '2014-02-15 00:40:54.000000', 'temperatura', 823.0000, 'ºC'),
	(210248, 122, '2014-02-15 00:40:55.000000', 'temperatura', 1029.0000, 'ºC'),
	(210249, 122, '2014-02-15 00:40:56.000000', 'temperatura', 277.0000, 'ºC'),
	(210250, 122, '2014-02-15 00:40:57.000000', 'temperatura', 698.0000, 'ºC'),
	(210251, 122, '2014-02-15 00:40:58.000000', 'temperatura', 260.0000, 'ºC'),
	(210252, 122, '2014-02-15 00:40:59.000000', 'temperatura', 405.0000, 'ºC'),
	(210253, 122, '2014-02-15 00:41:00.000000', 'temperatura', 47.0000, 'ºC'),
	(210254, 122, '2014-02-15 00:41:01.000000', 'temperatura', 219.0000, 'ºC'),
	(210255, 122, '2014-02-15 00:41:02.000000', 'temperatura', 956.0000, 'ºC'),
	(210256, 122, '2014-02-15 00:41:03.000000', 'temperatura', 522.0000, 'ºC'),
	(210257, 122, '2014-02-15 00:41:04.000000', 'temperatura', 941.0000, 'ºC'),
	(210258, 122, '2014-02-15 00:41:05.000000', 'temperatura', 742.0000, 'ºC'),
	(210259, 122, '2014-02-15 00:41:06.000000', 'temperatura', 886.0000, 'ºC'),
	(210260, 122, '2014-02-15 00:41:07.000000', 'temperatura', 1006.0000, 'ºC'),
	(210261, 122, '2014-02-15 00:41:08.000000', 'temperatura', 1170.0000, 'ºC'),
	(210262, 122, '2014-02-15 00:41:09.000000', 'temperatura', 435.0000, 'ºC'),
	(210263, 122, '2014-02-15 00:41:10.000000', 'temperatura', 1063.0000, 'ºC'),
	(210264, 122, '2014-02-15 00:41:11.000000', 'temperatura', 411.0000, 'ºC'),
	(210265, 122, '2014-02-15 00:41:12.000000', 'temperatura', 69.0000, 'ºC'),
	(210266, 122, '2014-02-15 00:41:13.000000', 'temperatura', 311.0000, 'ºC'),
	(210267, 122, '2014-02-15 00:41:14.000000', 'temperatura', 150.0000, 'ºC'),
	(210268, 122, '2014-02-15 00:41:15.000000', 'temperatura', 1018.0000, 'ºC'),
	(210269, 122, '2014-02-15 00:41:16.000000', 'temperatura', 1039.0000, 'ºC'),
	(210270, 122, '2014-02-15 00:41:17.000000', 'temperatura', 944.0000, 'ºC'),
	(210271, 122, '2014-02-15 00:41:18.000000', 'temperatura', 401.0000, 'ºC'),
	(210272, 122, '2014-02-15 00:41:19.000000', 'temperatura', 375.0000, 'ºC'),
	(210273, 122, '2014-02-15 00:41:20.000000', 'temperatura', 673.0000, 'ºC'),
	(210274, 122, '2014-02-15 00:41:21.000000', 'temperatura', 1041.0000, 'ºC'),
	(210275, 122, '2014-02-15 00:41:22.000000', 'temperatura', 784.0000, 'ºC'),
	(210276, 122, '2014-02-15 00:41:23.000000', 'temperatura', 798.0000, 'ºC'),
	(210277, 122, '2014-02-15 00:41:24.000000', 'temperatura', 438.0000, 'ºC'),
	(210278, 122, '2014-02-15 00:41:25.000000', 'temperatura', 996.0000, 'ºC'),
	(210279, 122, '2014-02-15 00:41:26.000000', 'temperatura', 67.0000, 'ºC'),
	(210280, 122, '2014-02-15 00:41:27.000000', 'temperatura', 947.0000, 'ºC'),
	(210281, 122, '2014-02-15 00:41:28.000000', 'temperatura', 935.0000, 'ºC'),
	(210282, 122, '2014-02-15 00:41:29.000000', 'temperatura', 636.0000, 'ºC'),
	(210283, 122, '2014-02-15 00:41:30.000000', 'temperatura', 374.0000, 'ºC'),
	(210284, 122, '2014-02-15 00:41:31.000000', 'temperatura', 1165.0000, 'ºC'),
	(210285, 122, '2014-02-15 00:41:32.000000', 'temperatura', 1100.0000, 'ºC'),
	(210286, 122, '2014-02-15 00:41:33.000000', 'temperatura', 809.0000, 'ºC'),
	(210287, 122, '2014-02-15 00:41:34.000000', 'temperatura', 744.0000, 'ºC'),
	(210288, 122, '2014-02-15 00:41:35.000000', 'temperatura', 93.0000, 'ºC'),
	(210289, 122, '2014-02-15 00:41:36.000000', 'temperatura', 633.0000, 'ºC'),
	(210290, 122, '2014-02-15 00:41:37.000000', 'temperatura', 489.0000, 'ºC'),
	(210291, 122, '2014-02-15 00:41:38.000000', 'temperatura', 546.0000, 'ºC'),
	(210292, 122, '2014-02-15 00:41:39.000000', 'temperatura', 61.0000, 'ºC'),
	(210293, 122, '2014-02-15 00:41:40.000000', 'temperatura', 1070.0000, 'ºC'),
	(210294, 122, '2014-02-15 00:41:41.000000', 'temperatura', 367.0000, 'ºC'),
	(210295, 122, '2014-02-15 00:41:42.000000', 'temperatura', 1025.0000, 'ºC'),
	(210296, 122, '2014-02-15 00:41:43.000000', 'temperatura', 424.0000, 'ºC'),
	(210297, 122, '2014-02-15 00:41:44.000000', 'temperatura', 246.0000, 'ºC'),
	(210298, 122, '2014-02-15 00:41:45.000000', 'temperatura', 1158.0000, 'ºC'),
	(210299, 122, '2014-02-15 00:41:46.000000', 'temperatura', 254.0000, 'ºC'),
	(210300, 122, '2014-02-15 00:41:47.000000', 'temperatura', 197.0000, 'ºC'),
	(210301, 122, '2014-02-15 00:41:48.000000', 'temperatura', 223.0000, 'ºC'),
	(210302, 122, '2014-02-15 00:41:49.000000', 'temperatura', 526.0000, 'ºC'),
	(210303, 122, '2014-02-15 00:41:50.000000', 'temperatura', 760.0000, 'ºC'),
	(210304, 122, '2014-02-15 00:41:51.000000', 'temperatura', 1021.0000, 'ºC'),
	(210305, 122, '2014-02-15 00:41:52.000000', 'temperatura', 427.0000, 'ºC'),
	(210306, 122, '2014-02-15 00:41:53.000000', 'temperatura', 272.0000, 'ºC'),
	(210307, 122, '2014-02-15 00:41:54.000000', 'temperatura', 78.0000, 'ºC'),
	(210308, 122, '2014-02-15 00:41:55.000000', 'temperatura', 775.0000, 'ºC'),
	(210309, 122, '2014-02-15 00:41:56.000000', 'temperatura', 42.0000, 'ºC'),
	(210310, 122, '2014-02-15 00:41:57.000000', 'temperatura', 286.0000, 'ºC'),
	(210311, 122, '2014-02-15 00:41:58.000000', 'temperatura', 105.0000, 'ºC'),
	(210312, 122, '2014-02-15 00:41:59.000000', 'temperatura', 869.0000, 'ºC'),
	(210313, 122, '2014-02-15 00:42:00.000000', 'temperatura', 428.0000, 'ºC'),
	(210314, 122, '2014-02-15 00:42:01.000000', 'temperatura', 732.0000, 'ºC'),
	(210315, 122, '2014-02-15 00:42:02.000000', 'temperatura', 1180.0000, 'ºC'),
	(210316, 122, '2014-02-15 00:42:03.000000', 'temperatura', 104.0000, 'ºC'),
	(210317, 122, '2014-02-15 00:42:04.000000', 'temperatura', 578.0000, 'ºC'),
	(210318, 122, '2014-02-15 00:42:05.000000', 'temperatura', 180.0000, 'ºC'),
	(210319, 122, '2014-02-15 00:42:06.000000', 'temperatura', 366.0000, 'ºC'),
	(210320, 122, '2014-02-15 00:42:07.000000', 'temperatura', 92.0000, 'ºC'),
	(210321, 122, '2014-02-15 00:42:08.000000', 'temperatura', 562.0000, 'ºC'),
	(210322, 122, '2014-02-15 00:42:09.000000', 'temperatura', 135.0000, 'ºC'),
	(210323, 122, '2014-02-15 00:42:10.000000', 'temperatura', 189.0000, 'ºC'),
	(210324, 122, '2014-02-15 00:42:11.000000', 'temperatura', 539.0000, 'ºC'),
	(210325, 122, '2014-02-15 00:42:12.000000', 'temperatura', 931.0000, 'ºC'),
	(210326, 122, '2014-02-15 00:42:13.000000', 'temperatura', 639.0000, 'ºC'),
	(210327, 122, '2014-02-15 00:42:14.000000', 'temperatura', 402.0000, 'ºC'),
	(210328, 122, '2014-02-15 00:42:15.000000', 'temperatura', 94.0000, 'ºC'),
	(210329, 122, '2014-02-15 00:42:16.000000', 'temperatura', 464.0000, 'ºC'),
	(210330, 122, '2014-02-15 00:42:17.000000', 'temperatura', 838.0000, 'ºC'),
	(210331, 122, '2014-02-15 00:42:18.000000', 'temperatura', 401.0000, 'ºC'),
	(210332, 122, '2014-02-15 00:42:19.000000', 'temperatura', 689.0000, 'ºC'),
	(210333, 122, '2014-02-15 00:42:20.000000', 'temperatura', 1044.0000, 'ºC'),
	(210334, 122, '2014-02-15 00:42:21.000000', 'temperatura', 754.0000, 'ºC'),
	(210335, 122, '2014-02-15 00:42:22.000000', 'temperatura', 636.0000, 'ºC'),
	(210336, 122, '2014-02-15 00:42:23.000000', 'temperatura', 919.0000, 'ºC'),
	(210337, 122, '2014-02-15 00:42:24.000000', 'temperatura', 288.0000, 'ºC'),
	(210338, 122, '2014-02-15 00:42:25.000000', 'temperatura', 1084.0000, 'ºC'),
	(210339, 122, '2014-02-15 00:42:26.000000', 'temperatura', 958.0000, 'ºC'),
	(210340, 122, '2014-02-15 00:42:27.000000', 'temperatura', 336.0000, 'ºC'),
	(210341, 122, '2014-02-15 00:42:28.000000', 'temperatura', 6.0000, 'ºC'),
	(210342, 122, '2014-02-15 00:42:29.000000', 'temperatura', 222.0000, 'ºC'),
	(210343, 122, '2014-02-15 00:42:30.000000', 'temperatura', 1092.0000, 'ºC'),
	(210344, 122, '2014-02-15 00:42:31.000000', 'temperatura', 1197.0000, 'ºC'),
	(210345, 122, '2014-02-15 00:42:32.000000', 'temperatura', 306.0000, 'ºC'),
	(210346, 122, '2014-02-15 00:42:33.000000', 'temperatura', 343.0000, 'ºC'),
	(210347, 122, '2014-02-15 00:42:34.000000', 'temperatura', 796.0000, 'ºC'),
	(210348, 122, '2014-02-15 00:42:35.000000', 'temperatura', 553.0000, 'ºC'),
	(210349, 122, '2014-02-15 00:42:36.000000', 'temperatura', 377.0000, 'ºC'),
	(210350, 122, '2014-02-15 00:42:37.000000', 'temperatura', 226.0000, 'ºC'),
	(210351, 122, '2014-02-15 00:42:38.000000', 'temperatura', 2.0000, 'ºC'),
	(210352, 122, '2014-02-15 00:42:39.000000', 'temperatura', 529.0000, 'ºC'),
	(210353, 122, '2014-02-15 00:42:40.000000', 'temperatura', 242.0000, 'ºC'),
	(210354, 122, '2014-02-15 00:42:41.000000', 'temperatura', 822.0000, 'ºC'),
	(210355, 122, '2014-02-15 00:42:42.000000', 'temperatura', 987.0000, 'ºC'),
	(210356, 122, '2014-02-15 00:42:43.000000', 'temperatura', 68.0000, 'ºC'),
	(210357, 122, '2014-02-15 00:42:44.000000', 'temperatura', 981.0000, 'ºC'),
	(210358, 122, '2014-02-15 00:42:45.000000', 'temperatura', 1099.0000, 'ºC'),
	(210359, 122, '2014-02-15 00:42:46.000000', 'temperatura', 152.0000, 'ºC'),
	(210360, 122, '2014-02-15 00:42:47.000000', 'temperatura', 1063.0000, 'ºC'),
	(210361, 122, '2014-02-15 00:42:48.000000', 'temperatura', 61.0000, 'ºC'),
	(210362, 122, '2014-02-15 00:42:49.000000', 'temperatura', 716.0000, 'ºC'),
	(210363, 122, '2014-02-15 00:42:50.000000', 'temperatura', 997.0000, 'ºC'),
	(210364, 122, '2014-02-15 00:42:51.000000', 'temperatura', 436.0000, 'ºC'),
	(210365, 122, '2014-02-15 00:42:52.000000', 'temperatura', 391.0000, 'ºC'),
	(210366, 122, '2014-02-15 00:42:53.000000', 'temperatura', 646.0000, 'ºC'),
	(210367, 122, '2014-02-15 00:42:54.000000', 'temperatura', 857.0000, 'ºC'),
	(210368, 122, '2014-02-15 00:42:55.000000', 'temperatura', 1149.0000, 'ºC'),
	(210369, 122, '2014-02-15 00:42:56.000000', 'temperatura', 772.0000, 'ºC'),
	(210370, 122, '2014-02-15 00:42:57.000000', 'temperatura', 416.0000, 'ºC'),
	(210371, 122, '2014-02-15 00:42:58.000000', 'temperatura', 966.0000, 'ºC'),
	(210372, 122, '2014-02-15 00:42:59.000000', 'temperatura', 1180.0000, 'ºC'),
	(210373, 122, '2014-02-15 00:43:00.000000', 'temperatura', 605.0000, 'ºC'),
	(210374, 122, '2014-02-15 00:43:01.000000', 'temperatura', 685.0000, 'ºC'),
	(210375, 122, '2014-02-15 00:43:02.000000', 'temperatura', 412.0000, 'ºC'),
	(210376, 122, '2014-02-15 00:43:03.000000', 'temperatura', 2.0000, 'ºC'),
	(210377, 122, '2014-02-15 00:43:04.000000', 'temperatura', 1177.0000, 'ºC'),
	(210378, 122, '2014-02-15 00:43:05.000000', 'temperatura', 1081.0000, 'ºC'),
	(210379, 122, '2014-02-15 00:43:06.000000', 'temperatura', 671.0000, 'ºC'),
	(210380, 122, '2014-02-15 00:43:07.000000', 'temperatura', 113.0000, 'ºC'),
	(210381, 122, '2014-02-15 00:43:08.000000', 'temperatura', 955.0000, 'ºC'),
	(210382, 122, '2014-02-15 00:43:09.000000', 'temperatura', 836.0000, 'ºC'),
	(210383, 122, '2014-02-15 00:43:10.000000', 'temperatura', 114.0000, 'ºC'),
	(210384, 122, '2014-02-15 00:43:11.000000', 'temperatura', 465.0000, 'ºC'),
	(210385, 122, '2014-02-15 00:43:12.000000', 'temperatura', 781.0000, 'ºC'),
	(210386, 122, '2014-02-15 00:43:13.000000', 'temperatura', 113.0000, 'ºC'),
	(210387, 122, '2014-02-15 00:43:14.000000', 'temperatura', 623.0000, 'ºC'),
	(210388, 122, '2014-02-15 00:43:15.000000', 'temperatura', 377.0000, 'ºC'),
	(210389, 122, '2014-02-15 00:43:16.000000', 'temperatura', 15.0000, 'ºC'),
	(210390, 122, '2014-02-15 00:43:17.000000', 'temperatura', 146.0000, 'ºC'),
	(210391, 122, '2014-02-15 00:43:18.000000', 'temperatura', 683.0000, 'ºC'),
	(210392, 122, '2014-02-15 00:43:19.000000', 'temperatura', 577.0000, 'ºC'),
	(210393, 122, '2014-02-15 00:43:20.000000', 'temperatura', 837.0000, 'ºC'),
	(210394, 122, '2014-02-15 00:43:21.000000', 'temperatura', 55.0000, 'ºC'),
	(210395, 122, '2014-02-15 00:43:22.000000', 'temperatura', 166.0000, 'ºC'),
	(210396, 122, '2014-02-15 00:43:23.000000', 'temperatura', 666.0000, 'ºC'),
	(210397, 122, '2014-02-15 00:43:24.000000', 'temperatura', 432.0000, 'ºC'),
	(210398, 122, '2014-02-15 00:43:25.000000', 'temperatura', 162.0000, 'ºC'),
	(210399, 122, '2014-02-15 00:43:26.000000', 'temperatura', 716.0000, 'ºC'),
	(210400, 122, '2014-02-15 00:43:27.000000', 'temperatura', 692.0000, 'ºC'),
	(210401, 122, '2014-02-15 00:43:28.000000', 'temperatura', 115.0000, 'ºC'),
	(210402, 122, '2014-02-15 00:43:29.000000', 'temperatura', 897.0000, 'ºC'),
	(210403, 122, '2014-02-15 00:43:30.000000', 'temperatura', 540.0000, 'ºC'),
	(210404, 122, '2014-02-15 00:43:31.000000', 'temperatura', 10.0000, 'ºC'),
	(210405, 122, '2014-02-15 00:43:32.000000', 'temperatura', 832.0000, 'ºC'),
	(210406, 122, '2014-02-15 00:43:33.000000', 'temperatura', 532.0000, 'ºC'),
	(210407, 122, '2014-02-15 00:43:34.000000', 'temperatura', 161.0000, 'ºC'),
	(210408, 122, '2014-02-15 00:43:35.000000', 'temperatura', 411.0000, 'ºC'),
	(210409, 122, '2014-02-15 00:43:36.000000', 'temperatura', 374.0000, 'ºC'),
	(210410, 122, '2014-02-15 00:43:37.000000', 'temperatura', 636.0000, 'ºC'),
	(210411, 122, '2014-02-15 00:43:38.000000', 'temperatura', 861.0000, 'ºC'),
	(210412, 122, '2014-02-15 00:43:39.000000', 'temperatura', 1195.0000, 'ºC'),
	(210413, 122, '2014-02-15 00:43:40.000000', 'temperatura', 994.0000, 'ºC'),
	(210414, 122, '2014-02-15 00:43:41.000000', 'temperatura', 187.0000, 'ºC'),
	(210415, 122, '2014-02-15 00:43:42.000000', 'temperatura', 352.0000, 'ºC'),
	(210416, 122, '2014-02-15 00:43:43.000000', 'temperatura', 1198.0000, 'ºC'),
	(210417, 122, '2014-02-15 00:43:44.000000', 'temperatura', 137.0000, 'ºC'),
	(210418, 122, '2014-02-15 00:43:45.000000', 'temperatura', 692.0000, 'ºC'),
	(210419, 122, '2014-02-15 00:43:46.000000', 'temperatura', 647.0000, 'ºC'),
	(210420, 122, '2014-02-15 00:43:47.000000', 'temperatura', 1163.0000, 'ºC'),
	(210421, 122, '2014-02-15 00:43:48.000000', 'temperatura', 271.0000, 'ºC'),
	(210422, 122, '2014-02-15 00:43:49.000000', 'temperatura', 268.0000, 'ºC'),
	(210423, 122, '2014-02-15 00:43:50.000000', 'temperatura', 528.0000, 'ºC'),
	(210424, 122, '2014-02-15 00:43:51.000000', 'temperatura', 638.0000, 'ºC'),
	(210425, 122, '2014-02-15 00:43:52.000000', 'temperatura', 404.0000, 'ºC'),
	(210426, 122, '2014-02-15 00:43:53.000000', 'temperatura', 106.0000, 'ºC'),
	(210427, 122, '2014-02-15 00:43:54.000000', 'temperatura', 521.0000, 'ºC'),
	(210428, 122, '2014-02-15 00:43:55.000000', 'temperatura', 1084.0000, 'ºC'),
	(210429, 122, '2014-02-15 00:43:56.000000', 'temperatura', 260.0000, 'ºC'),
	(210430, 122, '2014-02-15 00:43:57.000000', 'temperatura', 449.0000, 'ºC'),
	(210431, 122, '2014-02-15 00:43:58.000000', 'temperatura', 263.0000, 'ºC'),
	(210432, 122, '2014-02-15 00:43:59.000000', 'temperatura', 1171.0000, 'ºC'),
	(210433, 122, '2014-02-15 00:44:00.000000', 'temperatura', 264.0000, 'ºC'),
	(210434, 122, '2014-02-15 00:44:01.000000', 'temperatura', 207.0000, 'ºC'),
	(210435, 122, '2014-02-15 00:44:02.000000', 'temperatura', 245.0000, 'ºC'),
	(210436, 122, '2014-02-15 00:44:03.000000', 'temperatura', 605.0000, 'ºC'),
	(210437, 122, '2014-02-15 00:44:04.000000', 'temperatura', 1091.0000, 'ºC'),
	(210438, 122, '2014-02-15 00:44:05.000000', 'temperatura', 41.0000, 'ºC'),
	(210439, 122, '2014-02-15 00:44:06.000000', 'temperatura', 533.0000, 'ºC'),
	(210440, 122, '2014-02-15 00:44:07.000000', 'temperatura', 143.0000, 'ºC'),
	(210441, 122, '2014-02-15 00:44:08.000000', 'temperatura', 318.0000, 'ºC'),
	(210442, 122, '2014-02-15 00:44:09.000000', 'temperatura', 1158.0000, 'ºC'),
	(210443, 122, '2014-02-15 00:44:10.000000', 'temperatura', 38.0000, 'ºC'),
	(210444, 122, '2014-02-15 00:44:11.000000', 'temperatura', 316.0000, 'ºC'),
	(210445, 122, '2014-02-15 00:44:12.000000', 'temperatura', 266.0000, 'ºC'),
	(210446, 122, '2014-02-15 00:44:13.000000', 'temperatura', 381.0000, 'ºC'),
	(210447, 122, '2014-02-15 00:44:14.000000', 'temperatura', 1109.0000, 'ºC'),
	(210448, 122, '2014-02-15 00:44:15.000000', 'temperatura', 801.0000, 'ºC'),
	(210449, 122, '2014-02-15 00:44:16.000000', 'temperatura', 678.0000, 'ºC'),
	(210450, 122, '2014-02-15 00:44:17.000000', 'temperatura', 990.0000, 'ºC'),
	(210451, 122, '2014-02-15 00:44:18.000000', 'temperatura', 518.0000, 'ºC'),
	(210452, 122, '2014-02-15 00:44:19.000000', 'temperatura', 817.0000, 'ºC'),
	(210453, 122, '2014-02-15 00:44:20.000000', 'temperatura', 133.0000, 'ºC'),
	(210454, 122, '2014-02-15 00:44:21.000000', 'temperatura', 614.0000, 'ºC'),
	(210455, 122, '2014-02-15 00:44:22.000000', 'temperatura', 271.0000, 'ºC'),
	(210456, 122, '2014-02-15 00:44:23.000000', 'temperatura', 712.0000, 'ºC'),
	(210457, 122, '2014-02-15 00:44:24.000000', 'temperatura', 350.0000, 'ºC'),
	(210458, 122, '2014-02-15 00:44:25.000000', 'temperatura', 812.0000, 'ºC'),
	(210459, 122, '2014-02-15 00:44:26.000000', 'temperatura', 611.0000, 'ºC'),
	(210460, 122, '2014-02-15 00:44:27.000000', 'temperatura', 621.0000, 'ºC'),
	(210461, 122, '2014-02-15 00:44:28.000000', 'temperatura', 72.0000, 'ºC'),
	(210462, 122, '2014-02-15 00:44:29.000000', 'temperatura', 896.0000, 'ºC'),
	(210463, 122, '2014-02-15 00:44:30.000000', 'temperatura', 667.0000, 'ºC'),
	(210464, 122, '2014-02-15 00:44:31.000000', 'temperatura', 648.0000, 'ºC'),
	(210465, 122, '2014-02-15 00:44:32.000000', 'temperatura', 38.0000, 'ºC'),
	(210466, 122, '2014-02-15 00:44:33.000000', 'temperatura', 648.0000, 'ºC'),
	(210467, 122, '2014-02-15 00:44:34.000000', 'temperatura', 727.0000, 'ºC'),
	(210468, 122, '2014-02-15 00:44:35.000000', 'temperatura', 491.0000, 'ºC'),
	(210469, 122, '2014-02-15 00:44:36.000000', 'temperatura', 272.0000, 'ºC'),
	(210470, 122, '2014-02-15 00:44:37.000000', 'temperatura', 1091.0000, 'ºC'),
	(210471, 122, '2014-02-15 00:44:38.000000', 'temperatura', 1038.0000, 'ºC'),
	(210472, 122, '2014-02-15 00:44:39.000000', 'temperatura', 718.0000, 'ºC'),
	(210473, 122, '2014-02-15 00:44:40.000000', 'temperatura', 474.0000, 'ºC'),
	(210474, 122, '2014-02-15 00:44:41.000000', 'temperatura', 219.0000, 'ºC'),
	(210475, 122, '2014-02-15 00:44:42.000000', 'temperatura', 873.0000, 'ºC'),
	(210476, 122, '2014-02-15 00:44:43.000000', 'temperatura', 110.0000, 'ºC'),
	(210477, 122, '2014-02-15 00:44:44.000000', 'temperatura', 328.0000, 'ºC'),
	(210478, 122, '2014-02-15 00:44:45.000000', 'temperatura', 113.0000, 'ºC'),
	(210479, 122, '2014-02-15 00:44:46.000000', 'temperatura', 781.0000, 'ºC'),
	(210480, 122, '2014-02-15 00:44:47.000000', 'temperatura', 1168.0000, 'ºC'),
	(210481, 122, '2014-02-15 00:44:48.000000', 'temperatura', 1097.0000, 'ºC'),
	(210482, 122, '2014-02-15 00:44:49.000000', 'temperatura', 780.0000, 'ºC'),
	(210483, 122, '2014-02-15 00:44:50.000000', 'temperatura', 611.0000, 'ºC'),
	(210484, 122, '2014-02-15 00:44:51.000000', 'temperatura', 715.0000, 'ºC'),
	(210485, 122, '2014-02-15 00:44:52.000000', 'temperatura', 542.0000, 'ºC'),
	(210486, 122, '2014-02-15 00:44:53.000000', 'temperatura', 564.0000, 'ºC'),
	(210487, 122, '2014-02-15 00:44:54.000000', 'temperatura', 1195.0000, 'ºC'),
	(210488, 122, '2014-02-15 00:44:55.000000', 'temperatura', 684.0000, 'ºC'),
	(210489, 122, '2014-02-15 00:44:56.000000', 'temperatura', 1034.0000, 'ºC'),
	(210490, 122, '2014-02-15 00:44:57.000000', 'temperatura', 721.0000, 'ºC'),
	(210491, 122, '2014-02-15 00:44:58.000000', 'temperatura', 505.0000, 'ºC'),
	(210492, 122, '2014-02-15 00:44:59.000000', 'temperatura', 359.0000, 'ºC'),
	(210493, 122, '2014-02-15 00:45:00.000000', 'temperatura', 280.0000, 'ºC'),
	(210494, 122, '2014-02-15 00:45:01.000000', 'temperatura', 326.0000, 'ºC'),
	(210495, 122, '2014-02-15 00:45:02.000000', 'temperatura', 790.0000, 'ºC'),
	(210496, 122, '2014-02-15 00:45:03.000000', 'temperatura', 573.0000, 'ºC'),
	(210497, 122, '2014-02-15 00:45:04.000000', 'temperatura', 494.0000, 'ºC'),
	(210498, 122, '2014-02-15 00:45:05.000000', 'temperatura', 754.0000, 'ºC'),
	(210499, 122, '2014-02-15 00:45:06.000000', 'temperatura', 1086.0000, 'ºC'),
	(210500, 122, '2014-02-15 00:45:07.000000', 'temperatura', 770.0000, 'ºC'),
	(210501, 122, '2014-02-15 00:45:08.000000', 'temperatura', 594.0000, 'ºC'),
	(210502, 122, '2014-02-15 00:45:09.000000', 'temperatura', 660.0000, 'ºC'),
	(210503, 122, '2014-02-15 00:45:10.000000', 'temperatura', 316.0000, 'ºC'),
	(210504, 122, '2014-02-15 00:45:11.000000', 'temperatura', 804.0000, 'ºC'),
	(210505, 122, '2014-02-15 00:45:12.000000', 'temperatura', 670.0000, 'ºC'),
	(210506, 122, '2014-02-15 00:45:13.000000', 'temperatura', 941.0000, 'ºC'),
	(210507, 122, '2014-02-15 00:45:14.000000', 'temperatura', 295.0000, 'ºC'),
	(210508, 122, '2014-02-15 00:45:15.000000', 'temperatura', 1051.0000, 'ºC'),
	(210509, 122, '2014-02-15 00:45:16.000000', 'temperatura', 770.0000, 'ºC'),
	(210510, 122, '2014-02-15 00:45:17.000000', 'temperatura', 697.0000, 'ºC'),
	(210511, 122, '2014-02-15 00:45:18.000000', 'temperatura', 1176.0000, 'ºC'),
	(210512, 122, '2014-02-15 00:45:19.000000', 'temperatura', 189.0000, 'ºC'),
	(210513, 122, '2014-02-15 00:45:20.000000', 'temperatura', 1019.0000, 'ºC'),
	(210514, 122, '2014-02-15 00:45:21.000000', 'temperatura', 927.0000, 'ºC'),
	(210515, 122, '2014-02-15 00:45:22.000000', 'temperatura', 377.0000, 'ºC'),
	(210516, 122, '2014-02-15 00:45:23.000000', 'temperatura', 307.0000, 'ºC'),
	(210517, 122, '2014-02-15 00:45:24.000000', 'temperatura', 404.0000, 'ºC'),
	(210518, 122, '2014-02-15 00:45:25.000000', 'temperatura', 1101.0000, 'ºC'),
	(210519, 122, '2014-02-15 00:45:26.000000', 'temperatura', 691.0000, 'ºC'),
	(210520, 122, '2014-02-15 00:45:27.000000', 'temperatura', 155.0000, 'ºC'),
	(210521, 122, '2014-02-15 00:45:28.000000', 'temperatura', 1102.0000, 'ºC'),
	(210522, 122, '2014-02-15 00:45:29.000000', 'temperatura', 244.0000, 'ºC'),
	(210523, 122, '2014-02-15 00:45:30.000000', 'temperatura', 314.0000, 'ºC'),
	(210524, 122, '2014-02-15 00:45:31.000000', 'temperatura', 837.0000, 'ºC'),
	(210525, 122, '2014-02-15 00:45:32.000000', 'temperatura', 847.0000, 'ºC'),
	(210526, 122, '2014-02-15 00:45:33.000000', 'temperatura', 521.0000, 'ºC'),
	(210527, 122, '2014-02-15 00:45:34.000000', 'temperatura', 67.0000, 'ºC'),
	(210528, 122, '2014-02-15 00:45:35.000000', 'temperatura', 1173.0000, 'ºC'),
	(210529, 122, '2014-02-15 00:45:36.000000', 'temperatura', 864.0000, 'ºC'),
	(210530, 122, '2014-02-15 00:45:37.000000', 'temperatura', 802.0000, 'ºC'),
	(210531, 122, '2014-02-15 00:45:38.000000', 'temperatura', 220.0000, 'ºC'),
	(210532, 122, '2014-02-15 00:45:39.000000', 'temperatura', 1091.0000, 'ºC'),
	(210533, 122, '2014-02-15 00:45:40.000000', 'temperatura', 1198.0000, 'ºC'),
	(210534, 122, '2014-02-15 00:45:41.000000', 'temperatura', 316.0000, 'ºC'),
	(210535, 122, '2014-02-15 00:45:42.000000', 'temperatura', 386.0000, 'ºC'),
	(210536, 122, '2014-02-15 00:45:43.000000', 'temperatura', 981.0000, 'ºC'),
	(210537, 122, '2014-02-15 00:45:44.000000', 'temperatura', 150.0000, 'ºC'),
	(210538, 122, '2014-02-15 00:45:45.000000', 'temperatura', 206.0000, 'ºC'),
	(210539, 122, '2014-02-15 00:45:46.000000', 'temperatura', 580.0000, 'ºC'),
	(210540, 122, '2014-02-15 00:45:47.000000', 'temperatura', 1081.0000, 'ºC'),
	(210541, 122, '2014-02-15 00:45:48.000000', 'temperatura', 69.0000, 'ºC'),
	(210542, 122, '2014-02-15 00:45:49.000000', 'temperatura', 701.0000, 'ºC'),
	(210543, 122, '2014-02-15 00:45:50.000000', 'temperatura', 897.0000, 'ºC'),
	(210544, 122, '2014-02-15 00:45:51.000000', 'temperatura', 1182.0000, 'ºC'),
	(210545, 122, '2014-02-15 00:45:52.000000', 'temperatura', 821.0000, 'ºC'),
	(210546, 122, '2014-02-15 00:45:53.000000', 'temperatura', 559.0000, 'ºC'),
	(210547, 122, '2014-02-15 00:45:54.000000', 'temperatura', 335.0000, 'ºC'),
	(210548, 122, '2014-02-15 00:45:55.000000', 'temperatura', 1195.0000, 'ºC'),
	(210549, 122, '2014-02-15 00:45:56.000000', 'temperatura', 173.0000, 'ºC'),
	(210550, 122, '2014-02-15 00:45:57.000000', 'temperatura', 879.0000, 'ºC'),
	(210551, 122, '2014-02-15 00:45:58.000000', 'temperatura', 276.0000, 'ºC'),
	(210552, 122, '2014-02-15 00:45:59.000000', 'temperatura', 1143.0000, 'ºC'),
	(210553, 122, '2014-02-15 00:46:00.000000', 'temperatura', 87.0000, 'ºC'),
	(210554, 122, '2014-02-15 00:46:01.000000', 'temperatura', 609.0000, 'ºC'),
	(210555, 122, '2014-02-15 00:46:02.000000', 'temperatura', 384.0000, 'ºC'),
	(210556, 122, '2014-02-15 00:46:03.000000', 'temperatura', 94.0000, 'ºC'),
	(210557, 122, '2014-02-15 00:46:04.000000', 'temperatura', 520.0000, 'ºC'),
	(210558, 122, '2014-02-15 00:46:05.000000', 'temperatura', 1116.0000, 'ºC'),
	(210559, 122, '2014-02-15 00:46:06.000000', 'temperatura', 420.0000, 'ºC'),
	(210560, 122, '2014-02-15 00:46:07.000000', 'temperatura', 1154.0000, 'ºC'),
	(210561, 122, '2014-02-15 00:46:08.000000', 'temperatura', 910.0000, 'ºC'),
	(210562, 122, '2014-02-15 00:46:09.000000', 'temperatura', 1091.0000, 'ºC'),
	(210563, 122, '2014-02-15 00:46:10.000000', 'temperatura', 322.0000, 'ºC'),
	(210564, 122, '2014-02-15 00:46:11.000000', 'temperatura', 740.0000, 'ºC'),
	(210565, 122, '2014-02-15 00:46:12.000000', 'temperatura', 332.0000, 'ºC'),
	(210566, 122, '2014-02-15 00:46:13.000000', 'temperatura', 644.0000, 'ºC'),
	(210567, 122, '2014-02-15 00:46:14.000000', 'temperatura', 1021.0000, 'ºC'),
	(210568, 122, '2014-02-15 00:46:15.000000', 'temperatura', 774.0000, 'ºC'),
	(210569, 122, '2014-02-15 00:46:16.000000', 'temperatura', 808.0000, 'ºC'),
	(210570, 122, '2014-02-15 00:46:17.000000', 'temperatura', 519.0000, 'ºC'),
	(210571, 122, '2014-02-15 00:46:18.000000', 'temperatura', 173.0000, 'ºC'),
	(210572, 122, '2014-02-15 00:46:19.000000', 'temperatura', 506.0000, 'ºC'),
	(210573, 122, '2014-02-15 00:46:20.000000', 'temperatura', 811.0000, 'ºC'),
	(210574, 122, '2014-02-15 00:46:21.000000', 'temperatura', 136.0000, 'ºC'),
	(210575, 122, '2014-02-15 00:46:22.000000', 'temperatura', 651.0000, 'ºC'),
	(210576, 122, '2014-02-15 00:46:23.000000', 'temperatura', 447.0000, 'ºC'),
	(210577, 122, '2014-02-15 00:46:24.000000', 'temperatura', 282.0000, 'ºC'),
	(210578, 122, '2014-02-15 00:46:25.000000', 'temperatura', 68.0000, 'ºC'),
	(210579, 122, '2014-02-15 00:46:26.000000', 'temperatura', 695.0000, 'ºC'),
	(210580, 122, '2014-02-15 00:46:27.000000', 'temperatura', 872.0000, 'ºC'),
	(210581, 122, '2014-02-15 00:46:28.000000', 'temperatura', 1076.0000, 'ºC'),
	(210582, 122, '2014-02-15 00:46:29.000000', 'temperatura', 366.0000, 'ºC'),
	(210583, 122, '2014-02-15 00:46:30.000000', 'temperatura', 1001.0000, 'ºC'),
	(210584, 122, '2014-02-15 00:46:31.000000', 'temperatura', 309.0000, 'ºC'),
	(210585, 122, '2014-02-15 00:46:32.000000', 'temperatura', 941.0000, 'ºC'),
	(210586, 122, '2014-02-15 00:46:33.000000', 'temperatura', 181.0000, 'ºC'),
	(210587, 122, '2014-02-15 00:46:34.000000', 'temperatura', 479.0000, 'ºC'),
	(210588, 122, '2014-02-15 00:46:35.000000', 'temperatura', 654.0000, 'ºC'),
	(210589, 122, '2014-02-15 00:46:36.000000', 'temperatura', 632.0000, 'ºC'),
	(210590, 122, '2014-02-15 00:46:37.000000', 'temperatura', 0.0000, 'ºC'),
	(210591, 122, '2014-02-15 00:46:38.000000', 'temperatura', 502.0000, 'ºC'),
	(210592, 122, '2014-02-15 00:46:39.000000', 'temperatura', 113.0000, 'ºC'),
	(210593, 122, '2014-02-15 00:46:40.000000', 'temperatura', 258.0000, 'ºC'),
	(210594, 122, '2014-02-15 00:46:41.000000', 'temperatura', 951.0000, 'ºC'),
	(210595, 122, '2014-02-15 00:46:42.000000', 'temperatura', 383.0000, 'ºC'),
	(210596, 122, '2014-02-15 00:46:43.000000', 'temperatura', 264.0000, 'ºC'),
	(210597, 122, '2014-02-15 00:46:44.000000', 'temperatura', 169.0000, 'ºC'),
	(210598, 122, '2014-02-15 00:46:45.000000', 'temperatura', 53.0000, 'ºC'),
	(210599, 122, '2014-02-15 00:46:46.000000', 'temperatura', 959.0000, 'ºC'),
	(210600, 122, '2014-02-15 00:46:47.000000', 'temperatura', 1035.0000, 'ºC'),
	(210601, 122, '2014-02-15 00:46:48.000000', 'temperatura', 1099.0000, 'ºC'),
	(210602, 122, '2014-02-15 00:46:49.000000', 'temperatura', 1190.0000, 'ºC'),
	(210603, 122, '2014-02-15 00:46:50.000000', 'temperatura', 256.0000, 'ºC'),
	(210604, 122, '2014-02-15 00:46:51.000000', 'temperatura', 111.0000, 'ºC'),
	(210605, 122, '2014-02-15 00:46:52.000000', 'temperatura', 984.0000, 'ºC'),
	(210606, 122, '2014-02-15 00:46:53.000000', 'temperatura', 991.0000, 'ºC'),
	(210607, 122, '2014-02-15 00:46:54.000000', 'temperatura', 802.0000, 'ºC'),
	(210608, 122, '2014-02-15 00:46:55.000000', 'temperatura', 1039.0000, 'ºC'),
	(210609, 122, '2014-02-15 00:46:56.000000', 'temperatura', 389.0000, 'ºC'),
	(210610, 122, '2014-02-15 00:46:57.000000', 'temperatura', 26.0000, 'ºC'),
	(210611, 122, '2014-02-15 00:46:58.000000', 'temperatura', 167.0000, 'ºC'),
	(210612, 122, '2014-02-15 00:46:59.000000', 'temperatura', 756.0000, 'ºC'),
	(210613, 122, '2014-02-15 00:47:00.000000', 'temperatura', 879.0000, 'ºC'),
	(210614, 122, '2014-02-15 00:47:01.000000', 'temperatura', 926.0000, 'ºC'),
	(210615, 122, '2014-02-15 00:47:02.000000', 'temperatura', 794.0000, 'ºC'),
	(210616, 122, '2014-02-15 00:47:03.000000', 'temperatura', 1193.0000, 'ºC'),
	(210617, 122, '2014-02-15 00:47:04.000000', 'temperatura', 1185.0000, 'ºC'),
	(210618, 122, '2014-02-15 00:47:05.000000', 'temperatura', 1144.0000, 'ºC'),
	(210619, 122, '2014-02-15 00:47:06.000000', 'temperatura', 967.0000, 'ºC'),
	(210620, 122, '2014-02-15 00:47:07.000000', 'temperatura', 203.0000, 'ºC'),
	(210621, 122, '2014-02-15 00:47:08.000000', 'temperatura', 517.0000, 'ºC'),
	(210622, 122, '2014-02-15 00:47:09.000000', 'temperatura', 773.0000, 'ºC'),
	(210623, 122, '2014-02-15 00:47:10.000000', 'temperatura', 1115.0000, 'ºC'),
	(210624, 122, '2014-02-15 00:47:11.000000', 'temperatura', 858.0000, 'ºC'),
	(210625, 122, '2014-02-15 00:47:12.000000', 'temperatura', 943.0000, 'ºC'),
	(210626, 122, '2014-02-15 00:47:13.000000', 'temperatura', 944.0000, 'ºC'),
	(210627, 122, '2014-02-15 00:47:14.000000', 'temperatura', 690.0000, 'ºC'),
	(210628, 122, '2014-02-15 00:47:15.000000', 'temperatura', 620.0000, 'ºC'),
	(210629, 122, '2014-02-15 00:47:16.000000', 'temperatura', 1028.0000, 'ºC'),
	(210630, 122, '2014-02-15 00:47:17.000000', 'temperatura', 881.0000, 'ºC'),
	(210631, 122, '2014-02-15 00:47:18.000000', 'temperatura', 121.0000, 'ºC'),
	(210632, 122, '2014-02-15 00:47:19.000000', 'temperatura', 364.0000, 'ºC'),
	(210633, 122, '2014-02-15 00:47:20.000000', 'temperatura', 256.0000, 'ºC'),
	(210634, 122, '2014-02-15 00:47:21.000000', 'temperatura', 189.0000, 'ºC'),
	(210635, 122, '2014-02-15 00:47:22.000000', 'temperatura', 176.0000, 'ºC'),
	(210636, 122, '2014-02-15 00:47:23.000000', 'temperatura', 316.0000, 'ºC'),
	(210637, 122, '2014-02-15 00:47:24.000000', 'temperatura', 1052.0000, 'ºC'),
	(210638, 122, '2014-02-15 00:47:25.000000', 'temperatura', 713.0000, 'ºC'),
	(210639, 122, '2014-02-15 00:47:26.000000', 'temperatura', 407.0000, 'ºC'),
	(210640, 122, '2014-02-15 00:47:27.000000', 'temperatura', 1097.0000, 'ºC'),
	(210641, 122, '2014-02-15 00:47:28.000000', 'temperatura', 667.0000, 'ºC'),
	(210642, 122, '2014-02-15 00:47:29.000000', 'temperatura', 43.0000, 'ºC'),
	(210643, 122, '2014-02-15 00:47:30.000000', 'temperatura', 614.0000, 'ºC'),
	(210644, 122, '2014-02-15 00:47:31.000000', 'temperatura', 540.0000, 'ºC'),
	(210645, 122, '2014-02-15 00:47:32.000000', 'temperatura', 860.0000, 'ºC'),
	(210646, 122, '2014-02-15 00:47:33.000000', 'temperatura', 282.0000, 'ºC'),
	(210647, 122, '2014-02-15 00:47:34.000000', 'temperatura', 28.0000, 'ºC'),
	(210648, 122, '2014-02-15 00:47:35.000000', 'temperatura', 496.0000, 'ºC'),
	(210649, 122, '2014-02-15 00:47:36.000000', 'temperatura', 1196.0000, 'ºC'),
	(210650, 122, '2014-02-15 00:47:37.000000', 'temperatura', 892.0000, 'ºC'),
	(210651, 122, '2014-02-15 00:47:38.000000', 'temperatura', 873.0000, 'ºC'),
	(210652, 122, '2014-02-15 00:47:39.000000', 'temperatura', 488.0000, 'ºC'),
	(210653, 122, '2014-02-15 00:47:40.000000', 'temperatura', 1023.0000, 'ºC'),
	(210654, 122, '2014-02-15 00:47:41.000000', 'temperatura', 50.0000, 'ºC'),
	(210655, 122, '2014-02-15 00:47:42.000000', 'temperatura', 782.0000, 'ºC'),
	(210656, 122, '2014-02-15 00:47:43.000000', 'temperatura', 161.0000, 'ºC'),
	(210657, 122, '2014-02-15 00:47:44.000000', 'temperatura', 857.0000, 'ºC'),
	(210658, 122, '2014-02-15 00:47:45.000000', 'temperatura', 206.0000, 'ºC'),
	(210659, 122, '2014-02-15 00:47:46.000000', 'temperatura', 858.0000, 'ºC'),
	(210660, 122, '2014-02-15 00:47:47.000000', 'temperatura', 71.0000, 'ºC'),
	(210661, 122, '2014-02-15 00:47:48.000000', 'temperatura', 182.0000, 'ºC'),
	(210662, 122, '2014-02-15 00:47:49.000000', 'temperatura', 700.0000, 'ºC'),
	(210663, 122, '2014-02-15 00:47:50.000000', 'temperatura', 553.0000, 'ºC'),
	(210664, 122, '2014-02-15 00:47:51.000000', 'temperatura', 663.0000, 'ºC'),
	(210665, 122, '2014-02-15 00:47:52.000000', 'temperatura', 460.0000, 'ºC'),
	(210666, 122, '2014-02-15 00:47:53.000000', 'temperatura', 311.0000, 'ºC'),
	(210667, 122, '2014-02-15 00:47:54.000000', 'temperatura', 173.0000, 'ºC'),
	(210668, 122, '2014-02-15 00:47:55.000000', 'temperatura', 1134.0000, 'ºC'),
	(210669, 122, '2014-02-15 00:47:56.000000', 'temperatura', 352.0000, 'ºC'),
	(210670, 122, '2014-02-15 00:47:57.000000', 'temperatura', 757.0000, 'ºC'),
	(210671, 122, '2014-02-15 00:47:58.000000', 'temperatura', 332.0000, 'ºC'),
	(210672, 122, '2014-02-15 00:47:59.000000', 'temperatura', 589.0000, 'ºC'),
	(210673, 122, '2014-02-15 00:48:00.000000', 'temperatura', 749.0000, 'ºC'),
	(210674, 122, '2014-02-15 00:48:01.000000', 'temperatura', 777.0000, 'ºC'),
	(210675, 122, '2014-02-15 00:48:02.000000', 'temperatura', 440.0000, 'ºC'),
	(210676, 122, '2014-02-15 00:48:03.000000', 'temperatura', 1068.0000, 'ºC'),
	(210677, 122, '2014-02-15 00:48:04.000000', 'temperatura', 421.0000, 'ºC'),
	(210678, 122, '2014-02-15 00:48:05.000000', 'temperatura', 101.0000, 'ºC'),
	(210679, 122, '2014-02-15 00:48:06.000000', 'temperatura', 443.0000, 'ºC'),
	(210680, 122, '2014-02-15 00:48:07.000000', 'temperatura', 710.0000, 'ºC'),
	(210681, 122, '2014-02-15 00:48:08.000000', 'temperatura', 1025.0000, 'ºC'),
	(210682, 122, '2014-02-15 00:48:09.000000', 'temperatura', 596.0000, 'ºC'),
	(210683, 122, '2014-02-15 00:48:10.000000', 'temperatura', 1104.0000, 'ºC'),
	(210684, 122, '2014-02-15 00:48:11.000000', 'temperatura', 133.0000, 'ºC'),
	(210685, 122, '2014-02-15 00:48:12.000000', 'temperatura', 955.0000, 'ºC'),
	(210686, 122, '2014-02-15 00:48:13.000000', 'temperatura', 774.0000, 'ºC'),
	(210687, 122, '2014-02-15 00:48:14.000000', 'temperatura', 1008.0000, 'ºC'),
	(210688, 122, '2014-02-15 00:48:15.000000', 'temperatura', 315.0000, 'ºC'),
	(210689, 122, '2014-02-15 00:48:16.000000', 'temperatura', 955.0000, 'ºC'),
	(210690, 122, '2014-02-15 00:48:17.000000', 'temperatura', 230.0000, 'ºC'),
	(210691, 122, '2014-02-15 00:48:18.000000', 'temperatura', 687.0000, 'ºC'),
	(210692, 122, '2014-02-15 00:48:19.000000', 'temperatura', 343.0000, 'ºC'),
	(210693, 122, '2014-02-15 00:48:20.000000', 'temperatura', 856.0000, 'ºC'),
	(210694, 122, '2014-02-15 00:48:21.000000', 'temperatura', 852.0000, 'ºC'),
	(210695, 122, '2014-02-15 00:48:22.000000', 'temperatura', 493.0000, 'ºC'),
	(210696, 122, '2014-02-15 00:48:23.000000', 'temperatura', 1110.0000, 'ºC'),
	(210697, 122, '2014-02-15 00:48:24.000000', 'temperatura', 469.0000, 'ºC'),
	(210698, 122, '2014-02-15 00:48:25.000000', 'temperatura', 218.0000, 'ºC'),
	(210699, 122, '2014-02-15 00:48:26.000000', 'temperatura', 884.0000, 'ºC'),
	(210700, 122, '2014-02-15 00:48:27.000000', 'temperatura', 164.0000, 'ºC'),
	(210701, 122, '2014-02-15 00:48:28.000000', 'temperatura', 568.0000, 'ºC'),
	(210702, 122, '2014-02-15 00:48:29.000000', 'temperatura', 1148.0000, 'ºC'),
	(210703, 122, '2014-02-15 00:48:30.000000', 'temperatura', 437.0000, 'ºC'),
	(210704, 122, '2014-02-15 00:48:31.000000', 'temperatura', 1144.0000, 'ºC'),
	(210705, 122, '2014-02-15 00:48:32.000000', 'temperatura', 807.0000, 'ºC'),
	(210706, 122, '2014-02-15 00:48:33.000000', 'temperatura', 604.0000, 'ºC'),
	(210707, 122, '2014-02-15 00:48:34.000000', 'temperatura', 599.0000, 'ºC'),
	(210708, 122, '2014-02-15 00:48:35.000000', 'temperatura', 1182.0000, 'ºC'),
	(210709, 122, '2014-02-15 00:48:36.000000', 'temperatura', 516.0000, 'ºC'),
	(210710, 122, '2014-02-15 00:48:37.000000', 'temperatura', 234.0000, 'ºC'),
	(210711, 122, '2014-02-15 00:48:38.000000', 'temperatura', 824.0000, 'ºC'),
	(210712, 122, '2014-02-15 00:48:39.000000', 'temperatura', 1016.0000, 'ºC'),
	(210713, 122, '2014-02-15 00:48:40.000000', 'temperatura', 210.0000, 'ºC'),
	(210714, 122, '2014-02-15 00:48:41.000000', 'temperatura', 401.0000, 'ºC'),
	(210715, 122, '2014-02-15 00:48:42.000000', 'temperatura', 174.0000, 'ºC'),
	(210716, 122, '2014-02-15 00:48:43.000000', 'temperatura', 871.0000, 'ºC'),
	(210717, 122, '2014-02-15 00:48:44.000000', 'temperatura', 233.0000, 'ºC'),
	(210718, 122, '2014-02-15 00:48:45.000000', 'temperatura', 952.0000, 'ºC'),
	(210719, 122, '2014-02-15 00:48:46.000000', 'temperatura', 460.0000, 'ºC'),
	(210720, 122, '2014-02-15 00:48:47.000000', 'temperatura', 646.0000, 'ºC'),
	(210721, 122, '2014-02-15 00:48:48.000000', 'temperatura', 650.0000, 'ºC'),
	(210722, 122, '2014-02-15 00:48:49.000000', 'temperatura', 113.0000, 'ºC'),
	(210723, 122, '2014-02-15 00:48:50.000000', 'temperatura', 1016.0000, 'ºC'),
	(210724, 122, '2014-02-15 00:48:51.000000', 'temperatura', 1142.0000, 'ºC'),
	(210725, 122, '2014-02-15 00:48:52.000000', 'temperatura', 262.0000, 'ºC'),
	(210726, 122, '2014-02-15 00:48:53.000000', 'temperatura', 285.0000, 'ºC'),
	(210727, 122, '2014-02-15 00:48:54.000000', 'temperatura', 639.0000, 'ºC'),
	(210728, 122, '2014-02-15 00:48:55.000000', 'temperatura', 1142.0000, 'ºC'),
	(210729, 122, '2014-02-15 00:48:56.000000', 'temperatura', 194.0000, 'ºC'),
	(210730, 122, '2014-02-15 00:48:57.000000', 'temperatura', 1142.0000, 'ºC'),
	(210731, 122, '2014-02-15 00:48:58.000000', 'temperatura', 329.0000, 'ºC'),
	(210732, 122, '2014-02-15 00:48:59.000000', 'temperatura', 621.0000, 'ºC'),
	(210733, 122, '2014-02-15 00:49:00.000000', 'temperatura', 919.0000, 'ºC'),
	(210734, 122, '2014-02-15 00:49:01.000000', 'temperatura', 333.0000, 'ºC'),
	(210735, 122, '2014-02-15 00:49:02.000000', 'temperatura', 108.0000, 'ºC'),
	(210736, 122, '2014-02-15 00:49:03.000000', 'temperatura', 741.0000, 'ºC'),
	(210737, 122, '2014-02-15 00:49:04.000000', 'temperatura', 980.0000, 'ºC'),
	(210738, 122, '2014-02-15 00:49:05.000000', 'temperatura', 278.0000, 'ºC'),
	(210739, 122, '2014-02-15 00:49:06.000000', 'temperatura', 849.0000, 'ºC'),
	(210740, 122, '2014-02-15 00:49:07.000000', 'temperatura', 1014.0000, 'ºC'),
	(210741, 122, '2014-02-15 00:49:08.000000', 'temperatura', 124.0000, 'ºC'),
	(210742, 122, '2014-02-15 00:49:09.000000', 'temperatura', 1179.0000, 'ºC'),
	(210743, 122, '2014-02-15 00:49:10.000000', 'temperatura', 723.0000, 'ºC'),
	(210744, 122, '2014-02-15 00:49:11.000000', 'temperatura', 79.0000, 'ºC'),
	(210745, 122, '2014-02-15 00:49:12.000000', 'temperatura', 625.0000, 'ºC'),
	(210746, 122, '2014-02-15 00:49:13.000000', 'temperatura', 489.0000, 'ºC'),
	(210747, 122, '2014-02-15 00:49:14.000000', 'temperatura', 570.0000, 'ºC'),
	(210748, 122, '2014-02-15 00:49:15.000000', 'temperatura', 183.0000, 'ºC'),
	(210749, 122, '2014-02-15 00:49:16.000000', 'temperatura', 408.0000, 'ºC'),
	(210750, 122, '2014-02-15 00:49:17.000000', 'temperatura', 290.0000, 'ºC'),
	(210751, 122, '2014-02-15 00:49:18.000000', 'temperatura', 227.0000, 'ºC'),
	(210752, 122, '2014-02-15 00:49:19.000000', 'temperatura', 263.0000, 'ºC'),
	(210753, 122, '2014-02-15 00:49:20.000000', 'temperatura', 638.0000, 'ºC'),
	(210754, 122, '2014-02-15 00:49:21.000000', 'temperatura', 1199.0000, 'ºC'),
	(210755, 122, '2014-02-15 00:49:22.000000', 'temperatura', 484.0000, 'ºC'),
	(210756, 122, '2014-02-15 00:49:23.000000', 'temperatura', 22.0000, 'ºC'),
	(210757, 122, '2014-02-15 00:49:24.000000', 'temperatura', 1058.0000, 'ºC'),
	(210758, 122, '2014-02-15 00:49:25.000000', 'temperatura', 423.0000, 'ºC'),
	(210759, 122, '2014-02-15 00:49:26.000000', 'temperatura', 144.0000, 'ºC'),
	(210760, 122, '2014-02-15 00:49:27.000000', 'temperatura', 651.0000, 'ºC'),
	(210761, 122, '2014-02-15 00:49:28.000000', 'temperatura', 424.0000, 'ºC'),
	(210762, 122, '2014-02-15 00:49:29.000000', 'temperatura', 166.0000, 'ºC'),
	(210763, 122, '2014-02-15 00:49:30.000000', 'temperatura', 758.0000, 'ºC'),
	(210764, 122, '2014-02-15 00:49:31.000000', 'temperatura', 894.0000, 'ºC'),
	(210765, 122, '2014-02-15 00:49:32.000000', 'temperatura', 997.0000, 'ºC'),
	(210766, 122, '2014-02-15 00:49:33.000000', 'temperatura', 1103.0000, 'ºC'),
	(210767, 122, '2014-02-15 00:49:34.000000', 'temperatura', 124.0000, 'ºC'),
	(210768, 122, '2014-02-15 00:49:35.000000', 'temperatura', 911.0000, 'ºC'),
	(210769, 122, '2014-02-15 00:49:36.000000', 'temperatura', 583.0000, 'ºC'),
	(210770, 122, '2014-02-15 00:49:37.000000', 'temperatura', 182.0000, 'ºC'),
	(210771, 122, '2014-02-15 00:49:38.000000', 'temperatura', 364.0000, 'ºC'),
	(210772, 122, '2014-02-15 00:49:39.000000', 'temperatura', 75.0000, 'ºC'),
	(210773, 122, '2014-02-15 00:49:40.000000', 'temperatura', 481.0000, 'ºC'),
	(210774, 122, '2014-02-15 00:49:41.000000', 'temperatura', 983.0000, 'ºC'),
	(210775, 122, '2014-02-15 00:49:42.000000', 'temperatura', 1071.0000, 'ºC'),
	(210776, 122, '2014-02-15 00:49:43.000000', 'temperatura', 6.0000, 'ºC'),
	(210777, 122, '2014-02-15 00:49:44.000000', 'temperatura', 417.0000, 'ºC'),
	(210778, 122, '2014-02-15 00:49:45.000000', 'temperatura', 870.0000, 'ºC'),
	(210779, 122, '2014-02-15 00:49:46.000000', 'temperatura', 697.0000, 'ºC'),
	(210780, 122, '2014-02-15 00:49:47.000000', 'temperatura', 878.0000, 'ºC'),
	(210781, 122, '2014-02-15 00:49:48.000000', 'temperatura', 1099.0000, 'ºC'),
	(210782, 122, '2014-02-15 00:49:49.000000', 'temperatura', 461.0000, 'ºC'),
	(210783, 122, '2014-02-15 00:49:50.000000', 'temperatura', 207.0000, 'ºC'),
	(210784, 122, '2014-02-15 00:49:51.000000', 'temperatura', 853.0000, 'ºC'),
	(210785, 122, '2014-02-15 00:49:52.000000', 'temperatura', 45.0000, 'ºC'),
	(210786, 122, '2014-02-15 00:49:53.000000', 'temperatura', 68.0000, 'ºC'),
	(210787, 122, '2014-02-15 00:49:54.000000', 'temperatura', 204.0000, 'ºC'),
	(210788, 122, '2014-02-15 00:49:55.000000', 'temperatura', 818.0000, 'ºC'),
	(210789, 122, '2014-02-15 00:49:56.000000', 'temperatura', 1077.0000, 'ºC'),
	(210790, 122, '2014-02-15 00:49:57.000000', 'temperatura', 532.0000, 'ºC'),
	(210791, 122, '2014-02-15 00:49:58.000000', 'temperatura', 629.0000, 'ºC'),
	(210792, 122, '2014-02-15 00:49:59.000000', 'temperatura', 348.0000, 'ºC'),
	(210793, 122, '2014-02-15 00:50:00.000000', 'temperatura', 1054.0000, 'ºC'),
	(210794, 122, '2014-02-15 00:50:01.000000', 'temperatura', 628.0000, 'ºC'),
	(210795, 122, '2014-02-15 00:50:02.000000', 'temperatura', 1180.0000, 'ºC'),
	(210796, 122, '2014-02-15 00:50:03.000000', 'temperatura', 413.0000, 'ºC'),
	(210797, 122, '2014-02-15 00:50:04.000000', 'temperatura', 927.0000, 'ºC'),
	(210798, 122, '2014-02-15 00:50:05.000000', 'temperatura', 995.0000, 'ºC'),
	(210799, 122, '2014-02-15 00:50:06.000000', 'temperatura', 994.0000, 'ºC'),
	(210800, 122, '2014-02-15 00:50:07.000000', 'temperatura', 786.0000, 'ºC'),
	(210801, 122, '2014-02-15 00:50:08.000000', 'temperatura', 947.0000, 'ºC'),
	(210802, 122, '2014-02-15 00:50:09.000000', 'temperatura', 1180.0000, 'ºC'),
	(210803, 122, '2014-02-15 00:50:10.000000', 'temperatura', 657.0000, 'ºC'),
	(210804, 122, '2014-02-15 00:50:11.000000', 'temperatura', 948.0000, 'ºC'),
	(210805, 122, '2014-02-15 00:50:12.000000', 'temperatura', 367.0000, 'ºC'),
	(210806, 122, '2014-02-15 00:50:13.000000', 'temperatura', 191.0000, 'ºC'),
	(210807, 122, '2014-02-15 00:50:14.000000', 'temperatura', 1056.0000, 'ºC'),
	(210808, 122, '2014-02-15 00:50:15.000000', 'temperatura', 1108.0000, 'ºC'),
	(210809, 122, '2014-02-15 00:50:16.000000', 'temperatura', 1170.0000, 'ºC'),
	(210810, 122, '2014-02-15 00:50:17.000000', 'temperatura', 128.0000, 'ºC'),
	(210811, 122, '2014-02-15 00:50:18.000000', 'temperatura', 730.0000, 'ºC'),
	(210812, 122, '2014-02-15 00:50:19.000000', 'temperatura', 865.0000, 'ºC'),
	(210813, 122, '2014-02-15 00:50:20.000000', 'temperatura', 938.0000, 'ºC'),
	(210814, 122, '2014-02-15 00:50:21.000000', 'temperatura', 895.0000, 'ºC'),
	(210815, 122, '2014-02-15 00:50:22.000000', 'temperatura', 463.0000, 'ºC'),
	(210816, 122, '2014-02-15 00:50:23.000000', 'temperatura', 828.0000, 'ºC'),
	(210817, 122, '2014-02-15 00:50:24.000000', 'temperatura', 353.0000, 'ºC'),
	(210818, 122, '2014-02-15 00:50:25.000000', 'temperatura', 479.0000, 'ºC'),
	(210819, 122, '2014-02-15 00:50:26.000000', 'temperatura', 140.0000, 'ºC'),
	(210820, 122, '2014-02-15 00:50:27.000000', 'temperatura', 462.0000, 'ºC'),
	(210821, 122, '2014-02-15 00:50:28.000000', 'temperatura', 692.0000, 'ºC'),
	(210822, 122, '2014-02-15 00:50:29.000000', 'temperatura', 872.0000, 'ºC'),
	(210823, 122, '2014-02-15 00:50:30.000000', 'temperatura', 1084.0000, 'ºC'),
	(210824, 122, '2014-02-15 00:50:31.000000', 'temperatura', 403.0000, 'ºC'),
	(210825, 122, '2014-02-15 00:50:32.000000', 'temperatura', 1167.0000, 'ºC'),
	(210826, 122, '2014-02-15 00:50:33.000000', 'temperatura', 1026.0000, 'ºC'),
	(210827, 122, '2014-02-15 00:50:34.000000', 'temperatura', 429.0000, 'ºC'),
	(210828, 122, '2014-02-15 00:50:35.000000', 'temperatura', 267.0000, 'ºC'),
	(210829, 122, '2014-02-15 00:50:36.000000', 'temperatura', 47.0000, 'ºC'),
	(210830, 122, '2014-02-15 00:50:37.000000', 'temperatura', 635.0000, 'ºC'),
	(210831, 122, '2014-02-15 00:50:38.000000', 'temperatura', 635.0000, 'ºC'),
	(210832, 122, '2014-02-15 00:50:39.000000', 'temperatura', 71.0000, 'ºC'),
	(210833, 122, '2014-02-15 00:50:40.000000', 'temperatura', 848.0000, 'ºC'),
	(210834, 122, '2014-02-15 00:50:41.000000', 'temperatura', 431.0000, 'ºC'),
	(210835, 122, '2014-02-15 00:50:42.000000', 'temperatura', 808.0000, 'ºC'),
	(210836, 122, '2014-02-15 00:50:43.000000', 'temperatura', 350.0000, 'ºC'),
	(210837, 122, '2014-02-15 00:50:44.000000', 'temperatura', 526.0000, 'ºC'),
	(210838, 122, '2014-02-15 00:50:45.000000', 'temperatura', 380.0000, 'ºC'),
	(210839, 122, '2014-02-15 00:50:46.000000', 'temperatura', 322.0000, 'ºC'),
	(210840, 122, '2014-02-15 00:50:47.000000', 'temperatura', 472.0000, 'ºC'),
	(210841, 122, '2014-02-15 00:50:48.000000', 'temperatura', 195.0000, 'ºC'),
	(210842, 122, '2014-02-15 00:50:49.000000', 'temperatura', 760.0000, 'ºC'),
	(210843, 122, '2014-02-15 00:50:50.000000', 'temperatura', 816.0000, 'ºC'),
	(210844, 122, '2014-02-15 00:50:51.000000', 'temperatura', 599.0000, 'ºC'),
	(210845, 122, '2014-02-15 00:50:52.000000', 'temperatura', 547.0000, 'ºC'),
	(210846, 122, '2014-02-15 00:50:53.000000', 'temperatura', 940.0000, 'ºC'),
	(210847, 122, '2014-02-15 00:50:54.000000', 'temperatura', 659.0000, 'ºC'),
	(210848, 122, '2014-02-15 00:50:55.000000', 'temperatura', 475.0000, 'ºC'),
	(210849, 122, '2014-02-15 00:50:56.000000', 'temperatura', 400.0000, 'ºC'),
	(210850, 122, '2014-02-15 00:50:57.000000', 'temperatura', 575.0000, 'ºC'),
	(210851, 122, '2014-02-15 00:50:58.000000', 'temperatura', 474.0000, 'ºC'),
	(210852, 122, '2014-02-15 00:50:59.000000', 'temperatura', 645.0000, 'ºC'),
	(210853, 122, '2014-02-15 00:51:00.000000', 'temperatura', 604.0000, 'ºC'),
	(210854, 122, '2014-02-15 00:51:01.000000', 'temperatura', 1085.0000, 'ºC'),
	(210855, 122, '2014-02-15 00:51:02.000000', 'temperatura', 13.0000, 'ºC'),
	(210856, 122, '2014-02-15 00:51:03.000000', 'temperatura', 411.0000, 'ºC'),
	(210857, 122, '2014-02-15 00:51:04.000000', 'temperatura', 818.0000, 'ºC'),
	(210858, 122, '2014-02-15 00:51:05.000000', 'temperatura', 455.0000, 'ºC'),
	(210859, 122, '2014-02-15 00:51:06.000000', 'temperatura', 1023.0000, 'ºC'),
	(210860, 122, '2014-02-15 00:51:07.000000', 'temperatura', 152.0000, 'ºC'),
	(210861, 122, '2014-02-15 00:51:08.000000', 'temperatura', 89.0000, 'ºC'),
	(210862, 122, '2014-02-15 00:51:09.000000', 'temperatura', 1191.0000, 'ºC'),
	(210863, 122, '2014-02-15 00:51:10.000000', 'temperatura', 888.0000, 'ºC'),
	(210864, 122, '2014-02-15 00:51:11.000000', 'temperatura', 867.0000, 'ºC'),
	(210865, 122, '2014-02-15 00:51:12.000000', 'temperatura', 471.0000, 'ºC'),
	(210866, 122, '2014-02-15 00:51:13.000000', 'temperatura', 953.0000, 'ºC'),
	(210867, 122, '2014-02-15 00:51:14.000000', 'temperatura', 956.0000, 'ºC'),
	(210868, 122, '2014-02-15 00:51:15.000000', 'temperatura', 719.0000, 'ºC'),
	(210869, 122, '2014-02-15 00:51:16.000000', 'temperatura', 730.0000, 'ºC'),
	(210870, 122, '2014-02-15 00:51:17.000000', 'temperatura', 290.0000, 'ºC'),
	(210871, 122, '2014-02-15 00:51:18.000000', 'temperatura', 464.0000, 'ºC'),
	(210872, 122, '2014-02-15 00:51:19.000000', 'temperatura', 249.0000, 'ºC'),
	(210873, 122, '2014-02-15 00:51:20.000000', 'temperatura', 1052.0000, 'ºC'),
	(210874, 122, '2014-02-15 00:51:21.000000', 'temperatura', 914.0000, 'ºC'),
	(210875, 122, '2014-02-15 00:51:22.000000', 'temperatura', 214.0000, 'ºC'),
	(210876, 122, '2014-02-15 00:51:23.000000', 'temperatura', 729.0000, 'ºC'),
	(210877, 122, '2014-02-15 00:51:24.000000', 'temperatura', 603.0000, 'ºC'),
	(210878, 122, '2014-02-15 00:51:25.000000', 'temperatura', 828.0000, 'ºC'),
	(210879, 122, '2014-02-15 00:51:26.000000', 'temperatura', 1132.0000, 'ºC'),
	(210880, 122, '2014-02-15 00:51:27.000000', 'temperatura', 775.0000, 'ºC'),
	(210881, 122, '2014-02-15 00:51:28.000000', 'temperatura', 479.0000, 'ºC'),
	(210882, 122, '2014-02-15 00:51:29.000000', 'temperatura', 73.0000, 'ºC'),
	(210883, 122, '2014-02-15 00:51:30.000000', 'temperatura', 127.0000, 'ºC'),
	(210884, 122, '2014-02-15 00:51:31.000000', 'temperatura', 418.0000, 'ºC'),
	(210885, 122, '2014-02-15 00:51:32.000000', 'temperatura', 507.0000, 'ºC'),
	(210886, 122, '2014-02-15 00:51:33.000000', 'temperatura', 82.0000, 'ºC'),
	(210887, 122, '2014-02-15 00:51:34.000000', 'temperatura', 89.0000, 'ºC'),
	(210888, 122, '2014-02-15 00:51:35.000000', 'temperatura', 202.0000, 'ºC'),
	(210889, 122, '2014-02-15 00:51:36.000000', 'temperatura', 743.0000, 'ºC'),
	(210890, 122, '2014-02-15 00:51:37.000000', 'temperatura', 709.0000, 'ºC'),
	(210891, 122, '2014-02-15 00:51:38.000000', 'temperatura', 116.0000, 'ºC'),
	(210892, 122, '2014-02-15 00:51:39.000000', 'temperatura', 854.0000, 'ºC'),
	(210893, 122, '2014-02-15 00:51:40.000000', 'temperatura', 322.0000, 'ºC'),
	(210894, 122, '2014-02-15 00:51:41.000000', 'temperatura', 247.0000, 'ºC'),
	(210895, 122, '2014-02-15 00:51:42.000000', 'temperatura', 272.0000, 'ºC'),
	(210896, 122, '2014-02-15 00:51:43.000000', 'temperatura', 619.0000, 'ºC'),
	(210897, 122, '2014-02-15 00:51:44.000000', 'temperatura', 1079.0000, 'ºC'),
	(210898, 122, '2014-02-15 00:51:45.000000', 'temperatura', 1138.0000, 'ºC'),
	(210899, 122, '2014-02-15 00:51:46.000000', 'temperatura', 54.0000, 'ºC'),
	(210900, 122, '2014-02-15 00:51:47.000000', 'temperatura', 455.0000, 'ºC'),
	(210901, 122, '2014-02-15 00:51:48.000000', 'temperatura', 916.0000, 'ºC'),
	(210902, 122, '2014-02-15 00:51:49.000000', 'temperatura', 816.0000, 'ºC'),
	(210903, 122, '2014-02-15 00:51:50.000000', 'temperatura', 131.0000, 'ºC'),
	(210904, 122, '2014-02-15 00:51:51.000000', 'temperatura', 606.0000, 'ºC'),
	(210905, 122, '2014-02-15 00:51:52.000000', 'temperatura', 240.0000, 'ºC'),
	(210906, 122, '2014-02-15 00:51:53.000000', 'temperatura', 580.0000, 'ºC'),
	(210907, 122, '2014-02-15 00:51:54.000000', 'temperatura', 982.0000, 'ºC'),
	(210908, 122, '2014-02-15 00:51:55.000000', 'temperatura', 770.0000, 'ºC'),
	(210909, 122, '2014-02-15 00:51:56.000000', 'temperatura', 904.0000, 'ºC'),
	(210910, 122, '2014-02-15 00:51:57.000000', 'temperatura', 1010.0000, 'ºC'),
	(210911, 122, '2014-02-15 00:51:58.000000', 'temperatura', 1140.0000, 'ºC'),
	(210912, 122, '2014-02-15 00:51:59.000000', 'temperatura', 270.0000, 'ºC'),
	(210913, 122, '2014-02-15 00:52:00.000000', 'temperatura', 332.0000, 'ºC'),
	(210914, 122, '2014-02-15 00:52:01.000000', 'temperatura', 848.0000, 'ºC'),
	(210915, 122, '2014-02-15 00:52:02.000000', 'temperatura', 847.0000, 'ºC'),
	(210916, 122, '2014-02-15 00:52:03.000000', 'temperatura', 490.0000, 'ºC'),
	(210917, 122, '2014-02-15 00:52:04.000000', 'temperatura', 1108.0000, 'ºC'),
	(210918, 122, '2014-02-15 00:52:05.000000', 'temperatura', 473.0000, 'ºC'),
	(210919, 122, '2014-02-15 00:52:06.000000', 'temperatura', 240.0000, 'ºC'),
	(210920, 122, '2014-02-15 00:52:07.000000', 'temperatura', 984.0000, 'ºC'),
	(210921, 122, '2014-02-15 00:52:08.000000', 'temperatura', 599.0000, 'ºC'),
	(210922, 122, '2014-02-15 00:52:09.000000', 'temperatura', 43.0000, 'ºC'),
	(210923, 122, '2014-02-15 00:52:10.000000', 'temperatura', 821.0000, 'ºC'),
	(210924, 122, '2014-02-15 00:52:11.000000', 'temperatura', 373.0000, 'ºC'),
	(210925, 122, '2014-02-15 00:52:12.000000', 'temperatura', 604.0000, 'ºC'),
	(210926, 122, '2014-02-15 00:52:13.000000', 'temperatura', 701.0000, 'ºC'),
	(210927, 122, '2014-02-15 00:52:14.000000', 'temperatura', 495.0000, 'ºC'),
	(210928, 122, '2014-02-15 00:52:15.000000', 'temperatura', 371.0000, 'ºC'),
	(210929, 122, '2014-02-15 00:52:16.000000', 'temperatura', 371.0000, 'ºC'),
	(210930, 122, '2014-02-15 00:52:17.000000', 'temperatura', 740.0000, 'ºC'),
	(210931, 122, '2014-02-15 00:52:18.000000', 'temperatura', 191.0000, 'ºC'),
	(210932, 122, '2014-02-15 00:52:19.000000', 'temperatura', 1133.0000, 'ºC'),
	(210933, 122, '2014-02-15 00:52:20.000000', 'temperatura', 293.0000, 'ºC'),
	(210934, 122, '2014-02-15 00:52:21.000000', 'temperatura', 466.0000, 'ºC'),
	(210935, 122, '2014-02-15 00:52:22.000000', 'temperatura', 253.0000, 'ºC'),
	(210936, 122, '2014-02-15 00:52:23.000000', 'temperatura', 1067.0000, 'ºC'),
	(210937, 122, '2014-02-15 00:52:24.000000', 'temperatura', 974.0000, 'ºC'),
	(210938, 122, '2014-02-15 00:52:25.000000', 'temperatura', 472.0000, 'ºC'),
	(210939, 122, '2014-02-15 00:52:26.000000', 'temperatura', 640.0000, 'ºC'),
	(210940, 122, '2014-02-15 00:52:27.000000', 'temperatura', 583.0000, 'ºC'),
	(210941, 122, '2014-02-15 00:52:28.000000', 'temperatura', 996.0000, 'ºC'),
	(210942, 122, '2014-02-15 00:52:29.000000', 'temperatura', 833.0000, 'ºC'),
	(210943, 122, '2014-02-15 00:52:30.000000', 'temperatura', 1174.0000, 'ºC'),
	(210944, 122, '2014-02-15 00:52:31.000000', 'temperatura', 974.0000, 'ºC'),
	(210945, 122, '2014-02-15 00:52:32.000000', 'temperatura', 147.0000, 'ºC'),
	(210946, 122, '2014-02-15 00:52:33.000000', 'temperatura', 216.0000, 'ºC'),
	(210947, 122, '2014-02-15 00:52:34.000000', 'temperatura', 639.0000, 'ºC'),
	(210948, 122, '2014-02-15 00:52:35.000000', 'temperatura', 145.0000, 'ºC'),
	(210949, 122, '2014-02-15 00:52:36.000000', 'temperatura', 9.0000, 'ºC'),
	(210950, 122, '2014-02-15 00:52:37.000000', 'temperatura', 810.0000, 'ºC'),
	(210951, 122, '2014-02-15 00:52:38.000000', 'temperatura', 426.0000, 'ºC'),
	(210952, 122, '2014-02-15 00:52:39.000000', 'temperatura', 899.0000, 'ºC'),
	(210953, 122, '2014-02-15 00:52:40.000000', 'temperatura', 819.0000, 'ºC'),
	(210954, 122, '2014-02-15 00:52:41.000000', 'temperatura', 199.0000, 'ºC'),
	(210955, 122, '2014-02-15 00:52:42.000000', 'temperatura', 936.0000, 'ºC'),
	(210956, 122, '2014-02-15 00:52:43.000000', 'temperatura', 485.0000, 'ºC'),
	(210957, 122, '2014-02-15 00:52:44.000000', 'temperatura', 818.0000, 'ºC'),
	(210958, 122, '2014-02-15 00:52:45.000000', 'temperatura', 237.0000, 'ºC'),
	(210959, 122, '2014-02-15 00:52:46.000000', 'temperatura', 1130.0000, 'ºC'),
	(210960, 122, '2014-02-15 00:52:47.000000', 'temperatura', 139.0000, 'ºC'),
	(210961, 122, '2014-02-15 00:52:48.000000', 'temperatura', 904.0000, 'ºC'),
	(210962, 122, '2014-02-15 00:52:49.000000', 'temperatura', 506.0000, 'ºC'),
	(210963, 122, '2014-02-15 00:52:50.000000', 'temperatura', 1016.0000, 'ºC'),
	(210964, 122, '2014-02-15 00:52:51.000000', 'temperatura', 1163.0000, 'ºC'),
	(210965, 122, '2014-02-15 00:52:52.000000', 'temperatura', 368.0000, 'ºC'),
	(210966, 122, '2014-02-15 00:52:53.000000', 'temperatura', 753.0000, 'ºC'),
	(210967, 122, '2014-02-15 00:52:54.000000', 'temperatura', 261.0000, 'ºC'),
	(210968, 122, '2014-02-15 00:52:55.000000', 'temperatura', 244.0000, 'ºC'),
	(210969, 122, '2014-02-15 00:52:56.000000', 'temperatura', 441.0000, 'ºC'),
	(210970, 122, '2014-02-15 00:52:57.000000', 'temperatura', 272.0000, 'ºC'),
	(210971, 122, '2014-02-15 00:52:58.000000', 'temperatura', 39.0000, 'ºC'),
	(210972, 122, '2014-02-15 00:52:59.000000', 'temperatura', 577.0000, 'ºC'),
	(210973, 122, '2014-02-15 00:53:00.000000', 'temperatura', 370.0000, 'ºC'),
	(210974, 122, '2014-02-15 00:53:01.000000', 'temperatura', 121.0000, 'ºC'),
	(210975, 122, '2014-02-15 00:53:02.000000', 'temperatura', 694.0000, 'ºC'),
	(210976, 122, '2014-02-15 00:53:03.000000', 'temperatura', 708.0000, 'ºC'),
	(210977, 122, '2014-02-15 00:53:04.000000', 'temperatura', 258.0000, 'ºC'),
	(210978, 122, '2014-02-15 00:53:05.000000', 'temperatura', 365.0000, 'ºC'),
	(210979, 122, '2014-02-15 00:53:06.000000', 'temperatura', 1054.0000, 'ºC'),
	(210980, 122, '2014-02-15 00:53:07.000000', 'temperatura', 574.0000, 'ºC'),
	(210981, 122, '2014-02-15 00:53:08.000000', 'temperatura', 907.0000, 'ºC'),
	(210982, 122, '2014-02-15 00:53:09.000000', 'temperatura', 415.0000, 'ºC'),
	(210983, 122, '2014-02-15 00:53:10.000000', 'temperatura', 556.0000, 'ºC'),
	(210984, 122, '2014-02-15 00:53:11.000000', 'temperatura', 334.0000, 'ºC'),
	(210985, 122, '2014-02-15 00:53:12.000000', 'temperatura', 1.0000, 'ºC'),
	(210986, 122, '2014-02-15 00:53:13.000000', 'temperatura', 206.0000, 'ºC'),
	(210987, 122, '2014-02-15 00:53:14.000000', 'temperatura', 1028.0000, 'ºC'),
	(210988, 122, '2014-02-15 00:53:15.000000', 'temperatura', 920.0000, 'ºC'),
	(210989, 122, '2014-02-15 00:53:16.000000', 'temperatura', 318.0000, 'ºC'),
	(210990, 122, '2014-02-15 00:53:17.000000', 'temperatura', 30.0000, 'ºC'),
	(210991, 122, '2014-02-15 00:53:18.000000', 'temperatura', 398.0000, 'ºC'),
	(210992, 122, '2014-02-15 00:53:19.000000', 'temperatura', 698.0000, 'ºC'),
	(210993, 122, '2014-02-15 00:53:20.000000', 'temperatura', 1096.0000, 'ºC'),
	(210994, 122, '2014-02-15 00:53:21.000000', 'temperatura', 988.0000, 'ºC'),
	(210995, 122, '2014-02-15 00:53:22.000000', 'temperatura', 451.0000, 'ºC'),
	(210996, 122, '2014-02-15 00:53:23.000000', 'temperatura', 491.0000, 'ºC'),
	(210997, 122, '2014-02-15 00:53:24.000000', 'temperatura', 1102.0000, 'ºC'),
	(210998, 122, '2014-02-15 00:53:25.000000', 'temperatura', 438.0000, 'ºC'),
	(210999, 122, '2014-02-15 00:53:26.000000', 'temperatura', 85.0000, 'ºC'),
	(211000, 122, '2014-02-15 00:53:27.000000', 'temperatura', 312.0000, 'ºC'),
	(211001, 122, '2014-02-15 00:53:28.000000', 'temperatura', 104.0000, 'ºC'),
	(211002, 122, '2014-02-15 00:53:29.000000', 'temperatura', 786.0000, 'ºC'),
	(211003, 122, '2014-02-15 00:53:30.000000', 'temperatura', 19.0000, 'ºC'),
	(211004, 122, '2014-02-15 00:53:31.000000', 'temperatura', 138.0000, 'ºC'),
	(211005, 122, '2014-02-15 00:53:32.000000', 'temperatura', 634.0000, 'ºC'),
	(211006, 122, '2014-02-15 00:53:33.000000', 'temperatura', 356.0000, 'ºC'),
	(211007, 122, '2014-02-15 00:53:34.000000', 'temperatura', 1080.0000, 'ºC'),
	(211008, 122, '2014-02-15 00:53:35.000000', 'temperatura', 731.0000, 'ºC'),
	(211009, 122, '2014-02-15 00:53:36.000000', 'temperatura', 414.0000, 'ºC'),
	(211010, 122, '2014-02-15 00:53:37.000000', 'temperatura', 1077.0000, 'ºC'),
	(211011, 122, '2014-02-15 00:53:38.000000', 'temperatura', 543.0000, 'ºC'),
	(211012, 122, '2014-02-15 00:53:39.000000', 'temperatura', 686.0000, 'ºC'),
	(211013, 122, '2014-02-15 00:53:40.000000', 'temperatura', 600.0000, 'ºC'),
	(211014, 122, '2014-02-15 00:53:41.000000', 'temperatura', 945.0000, 'ºC'),
	(211015, 122, '2014-02-15 00:53:42.000000', 'temperatura', 522.0000, 'ºC'),
	(211016, 122, '2014-02-15 00:53:43.000000', 'temperatura', 978.0000, 'ºC'),
	(211017, 122, '2014-02-15 00:53:44.000000', 'temperatura', 924.0000, 'ºC'),
	(211018, 122, '2014-02-15 00:53:45.000000', 'temperatura', 488.0000, 'ºC'),
	(211019, 122, '2014-02-15 00:53:46.000000', 'temperatura', 868.0000, 'ºC'),
	(211020, 122, '2014-02-15 00:53:47.000000', 'temperatura', 475.0000, 'ºC'),
	(211021, 122, '2014-02-15 00:53:48.000000', 'temperatura', 972.0000, 'ºC'),
	(211022, 122, '2014-02-15 00:53:49.000000', 'temperatura', 1035.0000, 'ºC'),
	(211023, 122, '2014-02-15 00:53:50.000000', 'temperatura', 1061.0000, 'ºC'),
	(211024, 122, '2014-02-15 00:53:51.000000', 'temperatura', 999.0000, 'ºC'),
	(211025, 122, '2014-02-15 00:53:52.000000', 'temperatura', 613.0000, 'ºC'),
	(211026, 122, '2014-02-15 00:53:53.000000', 'temperatura', 71.0000, 'ºC'),
	(211027, 122, '2014-02-15 00:53:54.000000', 'temperatura', 913.0000, 'ºC'),
	(211028, 122, '2014-02-15 00:53:55.000000', 'temperatura', 754.0000, 'ºC'),
	(211029, 122, '2014-02-15 00:53:56.000000', 'temperatura', 1031.0000, 'ºC'),
	(211030, 122, '2014-02-15 00:53:57.000000', 'temperatura', 493.0000, 'ºC'),
	(211031, 122, '2014-02-15 00:53:58.000000', 'temperatura', 573.0000, 'ºC'),
	(211032, 122, '2014-02-15 00:53:59.000000', 'temperatura', 187.0000, 'ºC'),
	(211033, 122, '2014-02-15 00:54:00.000000', 'temperatura', 417.0000, 'ºC'),
	(211034, 122, '2014-02-15 00:54:01.000000', 'temperatura', 322.0000, 'ºC'),
	(211035, 122, '2014-02-15 00:54:02.000000', 'temperatura', 363.0000, 'ºC'),
	(211036, 122, '2014-02-15 00:54:03.000000', 'temperatura', 846.0000, 'ºC'),
	(211037, 122, '2014-02-15 00:54:04.000000', 'temperatura', 743.0000, 'ºC'),
	(211038, 122, '2014-02-15 00:54:05.000000', 'temperatura', 1177.0000, 'ºC'),
	(211039, 122, '2014-02-15 00:54:06.000000', 'temperatura', 58.0000, 'ºC'),
	(211040, 122, '2014-02-15 00:54:07.000000', 'temperatura', 358.0000, 'ºC'),
	(211041, 122, '2014-02-15 00:54:08.000000', 'temperatura', 419.0000, 'ºC'),
	(211042, 122, '2014-02-15 00:54:09.000000', 'temperatura', 1019.0000, 'ºC'),
	(211043, 122, '2014-02-15 00:54:10.000000', 'temperatura', 240.0000, 'ºC'),
	(211044, 122, '2014-02-15 00:54:11.000000', 'temperatura', 544.0000, 'ºC'),
	(211045, 122, '2014-02-15 00:54:12.000000', 'temperatura', 799.0000, 'ºC'),
	(211046, 122, '2014-02-15 00:54:13.000000', 'temperatura', 1165.0000, 'ºC'),
	(211047, 122, '2014-02-15 00:54:14.000000', 'temperatura', 1029.0000, 'ºC'),
	(211048, 122, '2014-02-15 00:54:15.000000', 'temperatura', 449.0000, 'ºC'),
	(211049, 122, '2014-02-15 00:54:16.000000', 'temperatura', 358.0000, 'ºC'),
	(211050, 122, '2014-02-15 00:54:17.000000', 'temperatura', 446.0000, 'ºC'),
	(211051, 122, '2014-02-15 00:54:18.000000', 'temperatura', 1155.0000, 'ºC'),
	(211052, 122, '2014-02-15 00:54:19.000000', 'temperatura', 836.0000, 'ºC'),
	(211053, 122, '2014-02-15 00:54:20.000000', 'temperatura', 715.0000, 'ºC'),
	(211054, 122, '2014-02-15 00:54:21.000000', 'temperatura', 1070.0000, 'ºC'),
	(211055, 122, '2014-02-15 00:54:22.000000', 'temperatura', 802.0000, 'ºC'),
	(211056, 122, '2014-02-15 00:54:23.000000', 'temperatura', 804.0000, 'ºC'),
	(211057, 122, '2014-02-15 00:54:24.000000', 'temperatura', 414.0000, 'ºC'),
	(211058, 122, '2014-02-15 00:54:25.000000', 'temperatura', 857.0000, 'ºC'),
	(211059, 122, '2014-02-15 00:54:26.000000', 'temperatura', 646.0000, 'ºC'),
	(211060, 122, '2014-02-15 00:54:27.000000', 'temperatura', 659.0000, 'ºC'),
	(211061, 122, '2014-02-15 00:54:28.000000', 'temperatura', 155.0000, 'ºC'),
	(211062, 122, '2014-02-15 00:54:29.000000', 'temperatura', 1.0000, 'ºC'),
	(211063, 122, '2014-02-15 00:54:30.000000', 'temperatura', 738.0000, 'ºC'),
	(211064, 122, '2014-02-15 00:54:31.000000', 'temperatura', 90.0000, 'ºC'),
	(211065, 122, '2014-02-15 00:54:32.000000', 'temperatura', 634.0000, 'ºC'),
	(211066, 122, '2014-02-15 00:54:33.000000', 'temperatura', 504.0000, 'ºC'),
	(211067, 122, '2014-02-15 00:54:34.000000', 'temperatura', 615.0000, 'ºC'),
	(211068, 122, '2014-02-15 00:54:35.000000', 'temperatura', 365.0000, 'ºC'),
	(211069, 122, '2014-02-15 00:54:36.000000', 'temperatura', 1180.0000, 'ºC'),
	(211070, 122, '2014-02-15 00:54:37.000000', 'temperatura', 5.0000, 'ºC'),
	(211071, 122, '2014-02-15 00:54:38.000000', 'temperatura', 84.0000, 'ºC'),
	(211072, 122, '2014-02-15 00:54:39.000000', 'temperatura', 408.0000, 'ºC'),
	(211073, 122, '2014-02-15 00:54:40.000000', 'temperatura', 588.0000, 'ºC'),
	(211074, 122, '2014-02-15 00:54:41.000000', 'temperatura', 515.0000, 'ºC'),
	(211075, 122, '2014-02-15 00:54:42.000000', 'temperatura', 814.0000, 'ºC'),
	(211076, 122, '2014-02-15 00:54:43.000000', 'temperatura', 126.0000, 'ºC'),
	(211077, 122, '2014-02-15 00:54:44.000000', 'temperatura', 588.0000, 'ºC'),
	(211078, 122, '2014-02-15 00:54:45.000000', 'temperatura', 161.0000, 'ºC'),
	(211079, 122, '2014-02-15 00:54:46.000000', 'temperatura', 242.0000, 'ºC'),
	(211080, 122, '2014-02-15 00:54:47.000000', 'temperatura', 730.0000, 'ºC'),
	(211081, 122, '2014-02-15 00:54:48.000000', 'temperatura', 521.0000, 'ºC'),
	(211082, 122, '2014-02-15 00:54:49.000000', 'temperatura', 417.0000, 'ºC'),
	(211083, 122, '2014-02-15 00:54:50.000000', 'temperatura', 521.0000, 'ºC'),
	(211084, 122, '2014-02-15 00:54:51.000000', 'temperatura', 155.0000, 'ºC'),
	(211085, 122, '2014-02-15 00:54:52.000000', 'temperatura', 411.0000, 'ºC'),
	(211086, 122, '2014-02-15 00:54:53.000000', 'temperatura', 392.0000, 'ºC'),
	(211087, 122, '2014-02-15 00:54:54.000000', 'temperatura', 726.0000, 'ºC'),
	(211088, 122, '2014-02-15 00:54:55.000000', 'temperatura', 56.0000, 'ºC'),
	(211089, 122, '2014-02-15 00:54:56.000000', 'temperatura', 504.0000, 'ºC'),
	(211090, 122, '2014-02-15 00:54:57.000000', 'temperatura', 1151.0000, 'ºC'),
	(211091, 122, '2014-02-15 00:54:58.000000', 'temperatura', 645.0000, 'ºC'),
	(211092, 122, '2014-02-15 00:54:59.000000', 'temperatura', 971.0000, 'ºC'),
	(211093, 122, '2014-02-15 00:55:00.000000', 'temperatura', 523.0000, 'ºC'),
	(211094, 122, '2014-02-15 00:55:01.000000', 'temperatura', 899.0000, 'ºC'),
	(211095, 122, '2014-02-15 00:55:02.000000', 'temperatura', 529.0000, 'ºC'),
	(211096, 122, '2014-02-15 00:55:03.000000', 'temperatura', 1147.0000, 'ºC'),
	(211097, 122, '2014-02-15 00:55:04.000000', 'temperatura', 548.0000, 'ºC'),
	(211098, 122, '2014-02-15 00:55:05.000000', 'temperatura', 499.0000, 'ºC'),
	(211099, 122, '2014-02-15 00:55:06.000000', 'temperatura', 851.0000, 'ºC'),
	(211100, 122, '2014-02-15 00:55:07.000000', 'temperatura', 359.0000, 'ºC'),
	(211101, 122, '2014-02-15 00:55:08.000000', 'temperatura', 445.0000, 'ºC'),
	(211102, 122, '2014-02-15 00:55:09.000000', 'temperatura', 1145.0000, 'ºC'),
	(211103, 122, '2014-02-15 00:55:10.000000', 'temperatura', 793.0000, 'ºC'),
	(211104, 122, '2014-02-15 00:55:11.000000', 'temperatura', 529.0000, 'ºC'),
	(211105, 122, '2014-02-15 00:55:12.000000', 'temperatura', 266.0000, 'ºC'),
	(211106, 122, '2014-02-15 00:55:13.000000', 'temperatura', 942.0000, 'ºC'),
	(211107, 122, '2014-02-15 00:55:14.000000', 'temperatura', 316.0000, 'ºC'),
	(211108, 122, '2014-02-15 00:55:15.000000', 'temperatura', 1152.0000, 'ºC'),
	(211109, 122, '2014-02-15 00:55:16.000000', 'temperatura', 14.0000, 'ºC'),
	(211110, 122, '2014-02-15 00:55:17.000000', 'temperatura', 213.0000, 'ºC'),
	(211111, 122, '2014-02-15 00:55:18.000000', 'temperatura', 1026.0000, 'ºC'),
	(211112, 122, '2014-02-15 00:55:19.000000', 'temperatura', 888.0000, 'ºC'),
	(211113, 122, '2014-02-15 00:55:20.000000', 'temperatura', 165.0000, 'ºC'),
	(211114, 122, '2014-02-15 00:55:21.000000', 'temperatura', 560.0000, 'ºC'),
	(211115, 122, '2014-02-15 00:55:22.000000', 'temperatura', 1106.0000, 'ºC'),
	(211116, 122, '2014-02-15 00:55:23.000000', 'temperatura', 252.0000, 'ºC'),
	(211117, 122, '2014-02-15 00:55:24.000000', 'temperatura', 341.0000, 'ºC'),
	(211118, 122, '2014-02-15 00:55:25.000000', 'temperatura', 952.0000, 'ºC'),
	(211119, 122, '2014-02-15 00:55:26.000000', 'temperatura', 134.0000, 'ºC'),
	(211120, 122, '2014-02-15 00:55:27.000000', 'temperatura', 215.0000, 'ºC'),
	(211121, 122, '2014-02-15 00:55:28.000000', 'temperatura', 676.0000, 'ºC'),
	(211122, 122, '2014-02-15 00:55:29.000000', 'temperatura', 335.0000, 'ºC'),
	(211123, 122, '2014-02-15 00:55:30.000000', 'temperatura', 848.0000, 'ºC'),
	(211124, 122, '2014-02-15 00:55:31.000000', 'temperatura', 834.0000, 'ºC'),
	(211125, 122, '2014-02-15 00:55:32.000000', 'temperatura', 428.0000, 'ºC'),
	(211126, 122, '2014-02-15 00:55:33.000000', 'temperatura', 840.0000, 'ºC'),
	(211127, 122, '2014-02-15 00:55:34.000000', 'temperatura', 513.0000, 'ºC'),
	(211128, 122, '2014-02-15 00:55:35.000000', 'temperatura', 47.0000, 'ºC'),
	(211129, 122, '2014-02-15 00:55:36.000000', 'temperatura', 1095.0000, 'ºC'),
	(211130, 122, '2014-02-15 00:55:37.000000', 'temperatura', 535.0000, 'ºC'),
	(211131, 122, '2014-02-15 00:55:38.000000', 'temperatura', 589.0000, 'ºC'),
	(211132, 122, '2014-02-15 00:55:39.000000', 'temperatura', 142.0000, 'ºC'),
	(211133, 122, '2014-02-15 00:55:40.000000', 'temperatura', 145.0000, 'ºC'),
	(211134, 122, '2014-02-15 00:55:41.000000', 'temperatura', 298.0000, 'ºC'),
	(211135, 122, '2014-02-15 00:55:42.000000', 'temperatura', 1056.0000, 'ºC'),
	(211136, 122, '2014-02-15 00:55:43.000000', 'temperatura', 785.0000, 'ºC'),
	(211137, 122, '2014-02-15 00:55:44.000000', 'temperatura', 760.0000, 'ºC'),
	(211138, 122, '2014-02-15 00:55:45.000000', 'temperatura', 243.0000, 'ºC'),
	(211139, 122, '2014-02-15 00:55:46.000000', 'temperatura', 138.0000, 'ºC'),
	(211140, 122, '2014-02-15 00:55:47.000000', 'temperatura', 1161.0000, 'ºC'),
	(211141, 122, '2014-02-15 00:55:48.000000', 'temperatura', 593.0000, 'ºC'),
	(211142, 122, '2014-02-15 00:55:49.000000', 'temperatura', 680.0000, 'ºC'),
	(211143, 122, '2014-02-15 00:55:50.000000', 'temperatura', 424.0000, 'ºC'),
	(211144, 122, '2014-02-15 00:55:51.000000', 'temperatura', 78.0000, 'ºC'),
	(211145, 122, '2014-02-15 00:55:52.000000', 'temperatura', 318.0000, 'ºC'),
	(211146, 122, '2014-02-15 00:55:53.000000', 'temperatura', 156.0000, 'ºC'),
	(211147, 122, '2014-02-15 00:55:54.000000', 'temperatura', 1029.0000, 'ºC'),
	(211148, 122, '2014-02-15 00:55:55.000000', 'temperatura', 1075.0000, 'ºC'),
	(211149, 122, '2014-02-15 00:55:56.000000', 'temperatura', 1091.0000, 'ºC'),
	(211150, 122, '2014-02-15 00:55:57.000000', 'temperatura', 1031.0000, 'ºC'),
	(211151, 122, '2014-02-15 00:55:58.000000', 'temperatura', 683.0000, 'ºC'),
	(211152, 122, '2014-02-15 00:55:59.000000', 'temperatura', 322.0000, 'ºC'),
	(211153, 122, '2014-02-15 00:56:00.000000', 'temperatura', 761.0000, 'ºC'),
	(211154, 122, '2014-02-15 00:56:01.000000', 'temperatura', 441.0000, 'ºC'),
	(211155, 122, '2014-02-15 00:56:02.000000', 'temperatura', 1121.0000, 'ºC'),
	(211156, 122, '2014-02-15 00:56:03.000000', 'temperatura', 682.0000, 'ºC'),
	(211157, 122, '2014-02-15 00:56:04.000000', 'temperatura', 48.0000, 'ºC'),
	(211158, 122, '2014-02-15 00:56:05.000000', 'temperatura', 596.0000, 'ºC'),
	(211159, 122, '2014-02-15 00:56:06.000000', 'temperatura', 434.0000, 'ºC'),
	(211160, 122, '2014-02-15 00:56:07.000000', 'temperatura', 383.0000, 'ºC'),
	(211161, 122, '2014-02-15 00:56:08.000000', 'temperatura', 616.0000, 'ºC'),
	(211162, 122, '2014-02-15 00:56:09.000000', 'temperatura', 729.0000, 'ºC'),
	(211163, 122, '2014-02-15 00:56:10.000000', 'temperatura', 599.0000, 'ºC'),
	(211164, 122, '2014-02-15 00:56:11.000000', 'temperatura', 809.0000, 'ºC'),
	(211165, 122, '2014-02-15 00:56:12.000000', 'temperatura', 1046.0000, 'ºC'),
	(211166, 122, '2014-02-15 00:56:13.000000', 'temperatura', 405.0000, 'ºC'),
	(211167, 122, '2014-02-15 00:56:14.000000', 'temperatura', 88.0000, 'ºC'),
	(211168, 122, '2014-02-15 00:56:15.000000', 'temperatura', 427.0000, 'ºC'),
	(211169, 122, '2014-02-15 00:56:16.000000', 'temperatura', 670.0000, 'ºC'),
	(211170, 122, '2014-02-15 00:56:17.000000', 'temperatura', 869.0000, 'ºC'),
	(211171, 122, '2014-02-15 00:56:18.000000', 'temperatura', 1135.0000, 'ºC'),
	(211172, 122, '2014-02-15 00:56:19.000000', 'temperatura', 668.0000, 'ºC'),
	(211173, 122, '2014-02-15 00:56:20.000000', 'temperatura', 1136.0000, 'ºC'),
	(211174, 122, '2014-02-15 00:56:21.000000', 'temperatura', 75.0000, 'ºC'),
	(211175, 122, '2014-02-15 00:56:22.000000', 'temperatura', 571.0000, 'ºC'),
	(211176, 122, '2014-02-15 00:56:23.000000', 'temperatura', 227.0000, 'ºC'),
	(211177, 122, '2014-02-15 00:56:24.000000', 'temperatura', 624.0000, 'ºC'),
	(211178, 122, '2014-02-15 00:56:25.000000', 'temperatura', 38.0000, 'ºC'),
	(211179, 122, '2014-02-15 00:56:26.000000', 'temperatura', 719.0000, 'ºC'),
	(211180, 122, '2014-02-15 00:56:27.000000', 'temperatura', 1083.0000, 'ºC'),
	(211181, 122, '2014-02-15 00:56:28.000000', 'temperatura', 859.0000, 'ºC'),
	(211182, 122, '2014-02-15 00:56:29.000000', 'temperatura', 1046.0000, 'ºC'),
	(211183, 122, '2014-02-15 00:56:30.000000', 'temperatura', 251.0000, 'ºC'),
	(211184, 122, '2014-02-15 00:56:31.000000', 'temperatura', 521.0000, 'ºC'),
	(211185, 122, '2014-02-15 00:56:32.000000', 'temperatura', 651.0000, 'ºC'),
	(211186, 122, '2014-02-15 00:56:33.000000', 'temperatura', 492.0000, 'ºC'),
	(211187, 122, '2014-02-15 00:56:34.000000', 'temperatura', 507.0000, 'ºC'),
	(211188, 122, '2014-02-15 00:56:35.000000', 'temperatura', 1062.0000, 'ºC'),
	(211189, 122, '2014-02-15 00:56:36.000000', 'temperatura', 189.0000, 'ºC'),
	(211190, 122, '2014-02-15 00:56:37.000000', 'temperatura', 157.0000, 'ºC'),
	(211191, 122, '2014-02-15 00:56:38.000000', 'temperatura', 220.0000, 'ºC'),
	(211192, 122, '2014-02-15 00:56:39.000000', 'temperatura', 631.0000, 'ºC'),
	(211193, 122, '2014-02-15 00:56:40.000000', 'temperatura', 94.0000, 'ºC'),
	(211194, 122, '2014-02-15 00:56:41.000000', 'temperatura', 978.0000, 'ºC'),
	(211195, 122, '2014-02-15 00:56:42.000000', 'temperatura', 1009.0000, 'ºC'),
	(211196, 122, '2014-02-15 00:56:43.000000', 'temperatura', 912.0000, 'ºC'),
	(211197, 122, '2014-02-15 00:56:44.000000', 'temperatura', 331.0000, 'ºC'),
	(211198, 122, '2014-02-15 00:56:45.000000', 'temperatura', 122.0000, 'ºC'),
	(211199, 122, '2014-02-15 00:56:46.000000', 'temperatura', 818.0000, 'ºC'),
	(211200, 122, '2014-02-15 00:56:47.000000', 'temperatura', 123.0000, 'ºC'),
	(211201, 122, '2014-02-15 00:56:48.000000', 'temperatura', 561.0000, 'ºC'),
	(211202, 122, '2014-02-15 00:56:49.000000', 'temperatura', 38.0000, 'ºC'),
	(211203, 122, '2014-02-15 00:56:50.000000', 'temperatura', 907.0000, 'ºC'),
	(211204, 122, '2014-02-15 00:56:51.000000', 'temperatura', 821.0000, 'ºC'),
	(211205, 122, '2014-02-15 00:56:52.000000', 'temperatura', 184.0000, 'ºC'),
	(211206, 122, '2014-02-15 00:56:53.000000', 'temperatura', 859.0000, 'ºC'),
	(211207, 122, '2014-02-15 00:56:54.000000', 'temperatura', 145.0000, 'ºC'),
	(211208, 122, '2014-02-15 00:56:55.000000', 'temperatura', 546.0000, 'ºC'),
	(211209, 122, '2014-02-15 00:56:56.000000', 'temperatura', 1094.0000, 'ºC'),
	(211210, 122, '2014-02-15 00:56:57.000000', 'temperatura', 235.0000, 'ºC'),
	(211211, 122, '2014-02-15 00:56:58.000000', 'temperatura', 292.0000, 'ºC'),
	(211212, 122, '2014-02-15 00:56:59.000000', 'temperatura', 755.0000, 'ºC'),
	(211213, 122, '2014-02-15 00:57:00.000000', 'temperatura', 501.0000, 'ºC'),
	(211214, 122, '2014-02-15 00:57:01.000000', 'temperatura', 240.0000, 'ºC'),
	(211215, 122, '2014-02-15 00:57:02.000000', 'temperatura', 898.0000, 'ºC'),
	(211216, 122, '2014-02-15 00:57:03.000000', 'temperatura', 170.0000, 'ºC'),
	(211217, 122, '2014-02-15 00:57:04.000000', 'temperatura', 558.0000, 'ºC'),
	(211218, 122, '2014-02-15 00:57:05.000000', 'temperatura', 1078.0000, 'ºC'),
	(211219, 122, '2014-02-15 00:57:06.000000', 'temperatura', 118.0000, 'ºC'),
	(211220, 122, '2014-02-15 00:57:07.000000', 'temperatura', 955.0000, 'ºC'),
	(211221, 122, '2014-02-15 00:57:08.000000', 'temperatura', 824.0000, 'ºC'),
	(211222, 122, '2014-02-15 00:57:09.000000', 'temperatura', 54.0000, 'ºC'),
	(211223, 122, '2014-02-15 00:57:10.000000', 'temperatura', 198.0000, 'ºC'),
	(211224, 122, '2014-02-15 00:57:11.000000', 'temperatura', 829.0000, 'ºC'),
	(211225, 122, '2014-02-15 00:57:12.000000', 'temperatura', 1151.0000, 'ºC'),
	(211226, 122, '2014-02-15 00:57:13.000000', 'temperatura', 868.0000, 'ºC'),
	(211227, 122, '2014-02-15 00:57:14.000000', 'temperatura', 889.0000, 'ºC'),
	(211228, 122, '2014-02-15 00:57:15.000000', 'temperatura', 640.0000, 'ºC'),
	(211229, 122, '2014-02-15 00:57:16.000000', 'temperatura', 532.0000, 'ºC'),
	(211230, 122, '2014-02-15 00:57:17.000000', 'temperatura', 744.0000, 'ºC'),
	(211231, 122, '2014-02-15 00:57:18.000000', 'temperatura', 921.0000, 'ºC'),
	(211232, 122, '2014-02-15 00:57:19.000000', 'temperatura', 1176.0000, 'ºC'),
	(211233, 122, '2014-02-15 00:57:20.000000', 'temperatura', 717.0000, 'ºC'),
	(211234, 122, '2014-02-15 00:57:21.000000', 'temperatura', 57.0000, 'ºC'),
	(211235, 122, '2014-02-15 00:57:22.000000', 'temperatura', 534.0000, 'ºC'),
	(211236, 122, '2014-02-15 00:57:23.000000', 'temperatura', 99.0000, 'ºC'),
	(211237, 122, '2014-02-15 00:57:24.000000', 'temperatura', 92.0000, 'ºC'),
	(211238, 122, '2014-02-15 00:57:25.000000', 'temperatura', 166.0000, 'ºC'),
	(211239, 122, '2014-02-15 00:57:26.000000', 'temperatura', 554.0000, 'ºC'),
	(211240, 122, '2014-02-15 00:57:27.000000', 'temperatura', 1073.0000, 'ºC'),
	(211241, 122, '2014-02-15 00:57:28.000000', 'temperatura', 103.0000, 'ºC'),
	(211242, 122, '2014-02-15 00:57:29.000000', 'temperatura', 895.0000, 'ºC'),
	(211243, 122, '2014-02-15 00:57:30.000000', 'temperatura', 567.0000, 'ºC'),
	(211244, 122, '2014-02-15 00:57:31.000000', 'temperatura', 149.0000, 'ºC'),
	(211245, 122, '2014-02-15 00:57:32.000000', 'temperatura', 248.0000, 'ºC'),
	(211246, 122, '2014-02-15 00:57:33.000000', 'temperatura', 791.0000, 'ºC'),
	(211247, 122, '2014-02-15 00:57:34.000000', 'temperatura', 814.0000, 'ºC'),
	(211248, 122, '2014-02-15 00:57:35.000000', 'temperatura', 497.0000, 'ºC'),
	(211249, 122, '2014-02-15 00:57:36.000000', 'temperatura', 41.0000, 'ºC'),
	(211250, 122, '2014-02-15 00:57:37.000000', 'temperatura', 1115.0000, 'ºC'),
	(211251, 122, '2014-02-15 00:57:38.000000', 'temperatura', 654.0000, 'ºC'),
	(211252, 122, '2014-02-15 00:57:39.000000', 'temperatura', 1123.0000, 'ºC'),
	(211253, 122, '2014-02-15 00:57:40.000000', 'temperatura', 56.0000, 'ºC'),
	(211254, 122, '2014-02-15 00:57:41.000000', 'temperatura', 509.0000, 'ºC'),
	(211255, 122, '2014-02-15 00:57:42.000000', 'temperatura', 1180.0000, 'ºC'),
	(211256, 122, '2014-02-15 00:57:43.000000', 'temperatura', 773.0000, 'ºC'),
	(211257, 122, '2014-02-15 00:57:44.000000', 'temperatura', 324.0000, 'ºC'),
	(211258, 122, '2014-02-15 00:57:45.000000', 'temperatura', 502.0000, 'ºC'),
	(211259, 122, '2014-02-15 00:57:46.000000', 'temperatura', 339.0000, 'ºC'),
	(211260, 122, '2014-02-15 00:57:47.000000', 'temperatura', 188.0000, 'ºC'),
	(211261, 122, '2014-02-15 00:57:48.000000', 'temperatura', 1126.0000, 'ºC'),
	(211262, 122, '2014-02-15 00:57:49.000000', 'temperatura', 266.0000, 'ºC'),
	(211263, 122, '2014-02-15 00:57:50.000000', 'temperatura', 352.0000, 'ºC'),
	(211264, 122, '2014-02-15 00:57:51.000000', 'temperatura', 962.0000, 'ºC'),
	(211265, 122, '2014-02-15 00:57:52.000000', 'temperatura', 153.0000, 'ºC'),
	(211266, 122, '2014-02-15 00:57:53.000000', 'temperatura', 281.0000, 'ºC'),
	(211267, 122, '2014-02-15 00:57:54.000000', 'temperatura', 948.0000, 'ºC'),
	(211268, 122, '2014-02-15 00:57:55.000000', 'temperatura', 297.0000, 'ºC'),
	(211269, 122, '2014-02-15 00:57:56.000000', 'temperatura', 1040.0000, 'ºC'),
	(211270, 122, '2014-02-15 00:57:57.000000', 'temperatura', 708.0000, 'ºC'),
	(211271, 122, '2014-02-15 00:57:58.000000', 'temperatura', 423.0000, 'ºC'),
	(211272, 122, '2014-02-15 00:57:59.000000', 'temperatura', 1191.0000, 'ºC'),
	(211273, 122, '2014-02-15 00:58:00.000000', 'temperatura', 1085.0000, 'ºC'),
	(211274, 122, '2014-02-15 00:58:01.000000', 'temperatura', 653.0000, 'ºC'),
	(211275, 122, '2014-02-15 00:58:02.000000', 'temperatura', 11.0000, 'ºC'),
	(211276, 122, '2014-02-15 00:58:03.000000', 'temperatura', 496.0000, 'ºC'),
	(211277, 122, '2014-02-15 00:58:04.000000', 'temperatura', 47.0000, 'ºC'),
	(211278, 122, '2014-02-15 00:58:05.000000', 'temperatura', 1147.0000, 'ºC'),
	(211279, 122, '2014-02-15 00:58:06.000000', 'temperatura', 794.0000, 'ºC'),
	(211280, 122, '2014-02-15 00:58:07.000000', 'temperatura', 532.0000, 'ºC'),
	(211281, 122, '2014-02-15 00:58:08.000000', 'temperatura', 278.0000, 'ºC'),
	(211282, 122, '2014-02-15 00:58:09.000000', 'temperatura', 992.0000, 'ºC'),
	(211283, 122, '2014-02-15 00:58:10.000000', 'temperatura', 530.0000, 'ºC'),
	(211284, 122, '2014-02-15 00:58:11.000000', 'temperatura', 873.0000, 'ºC'),
	(211285, 122, '2014-02-15 00:58:12.000000', 'temperatura', 374.0000, 'ºC'),
	(211286, 122, '2014-02-15 00:58:13.000000', 'temperatura', 452.0000, 'ºC'),
	(211287, 122, '2014-02-15 00:58:14.000000', 'temperatura', 1140.0000, 'ºC'),
	(211288, 122, '2014-02-15 00:58:15.000000', 'temperatura', 746.0000, 'ºC'),
	(211289, 122, '2014-02-15 00:58:16.000000', 'temperatura', 308.0000, 'ºC'),
	(211290, 122, '2014-02-15 00:58:17.000000', 'temperatura', 503.0000, 'ºC'),
	(211291, 122, '2014-02-15 00:58:18.000000', 'temperatura', 390.0000, 'ºC'),
	(211292, 122, '2014-02-15 00:58:19.000000', 'temperatura', 443.0000, 'ºC'),
	(211293, 122, '2014-02-15 00:58:20.000000', 'temperatura', 1044.0000, 'ºC'),
	(211294, 122, '2014-02-15 00:58:21.000000', 'temperatura', 293.0000, 'ºC'),
	(211295, 122, '2014-02-15 00:58:22.000000', 'temperatura', 731.0000, 'ºC'),
	(211296, 122, '2014-02-15 00:58:23.000000', 'temperatura', 379.0000, 'ºC'),
	(211297, 122, '2014-02-15 00:58:24.000000', 'temperatura', 902.0000, 'ºC'),
	(211298, 122, '2014-02-15 00:58:25.000000', 'temperatura', 973.0000, 'ºC'),
	(211299, 122, '2014-02-15 00:58:26.000000', 'temperatura', 959.0000, 'ºC'),
	(211300, 122, '2014-02-15 00:58:27.000000', 'temperatura', 678.0000, 'ºC'),
	(211301, 122, '2014-02-15 00:58:28.000000', 'temperatura', 512.0000, 'ºC'),
	(211302, 122, '2014-02-15 00:58:29.000000', 'temperatura', 525.0000, 'ºC'),
	(211303, 122, '2014-02-15 00:58:30.000000', 'temperatura', 1091.0000, 'ºC'),
	(211304, 122, '2014-02-15 00:58:31.000000', 'temperatura', 280.0000, 'ºC'),
	(211305, 122, '2014-02-15 00:58:32.000000', 'temperatura', 528.0000, 'ºC'),
	(211306, 122, '2014-02-15 00:58:33.000000', 'temperatura', 599.0000, 'ºC'),
	(211307, 122, '2014-02-15 00:58:34.000000', 'temperatura', 211.0000, 'ºC'),
	(211308, 122, '2014-02-15 00:58:35.000000', 'temperatura', 458.0000, 'ºC'),
	(211309, 122, '2014-02-15 00:58:36.000000', 'temperatura', 460.0000, 'ºC'),
	(211310, 122, '2014-02-15 00:58:37.000000', 'temperatura', 923.0000, 'ºC'),
	(211311, 122, '2014-02-15 00:58:38.000000', 'temperatura', 839.0000, 'ºC'),
	(211312, 122, '2014-02-15 00:58:39.000000', 'temperatura', 226.0000, 'ºC'),
	(211313, 122, '2014-02-15 00:58:40.000000', 'temperatura', 1015.0000, 'ºC'),
	(211314, 122, '2014-02-15 00:58:41.000000', 'temperatura', 795.0000, 'ºC'),
	(211315, 122, '2014-02-15 00:58:42.000000', 'temperatura', 930.0000, 'ºC'),
	(211316, 122, '2014-02-15 00:58:43.000000', 'temperatura', 1068.0000, 'ºC'),
	(211317, 122, '2014-02-15 00:58:44.000000', 'temperatura', 148.0000, 'ºC'),
	(211318, 122, '2014-02-15 00:58:45.000000', 'temperatura', 1138.0000, 'ºC'),
	(211319, 122, '2014-02-15 00:58:46.000000', 'temperatura', 444.0000, 'ºC'),
	(211320, 122, '2014-02-15 00:58:47.000000', 'temperatura', 8.0000, 'ºC'),
	(211321, 122, '2014-02-15 00:58:48.000000', 'temperatura', 1108.0000, 'ºC'),
	(211322, 122, '2014-02-15 00:58:49.000000', 'temperatura', 717.0000, 'ºC'),
	(211323, 122, '2014-02-15 00:58:50.000000', 'temperatura', 263.0000, 'ºC'),
	(211324, 122, '2014-02-15 00:58:51.000000', 'temperatura', 363.0000, 'ºC'),
	(211325, 122, '2014-02-15 00:58:52.000000', 'temperatura', 1026.0000, 'ºC'),
	(211326, 122, '2014-02-15 00:58:53.000000', 'temperatura', 443.0000, 'ºC'),
	(211327, 122, '2014-02-15 00:58:54.000000', 'temperatura', 337.0000, 'ºC'),
	(211328, 122, '2014-02-15 00:58:55.000000', 'temperatura', 356.0000, 'ºC'),
	(211329, 122, '2014-02-15 00:58:56.000000', 'temperatura', 772.0000, 'ºC'),
	(211330, 122, '2014-02-15 00:58:57.000000', 'temperatura', 390.0000, 'ºC'),
	(211331, 122, '2014-02-15 00:58:58.000000', 'temperatura', 835.0000, 'ºC'),
	(211332, 122, '2014-02-15 00:58:59.000000', 'temperatura', 605.0000, 'ºC'),
	(211333, 122, '2014-02-15 00:59:00.000000', 'temperatura', 521.0000, 'ºC'),
	(211334, 122, '2014-02-15 00:59:01.000000', 'temperatura', 789.0000, 'ºC'),
	(211335, 122, '2014-02-15 00:59:02.000000', 'temperatura', 1183.0000, 'ºC'),
	(211336, 122, '2014-02-15 00:59:03.000000', 'temperatura', 1151.0000, 'ºC'),
	(211337, 122, '2014-02-15 00:59:04.000000', 'temperatura', 1003.0000, 'ºC'),
	(211338, 122, '2014-02-15 00:59:05.000000', 'temperatura', 366.0000, 'ºC'),
	(211339, 122, '2014-02-15 00:59:06.000000', 'temperatura', 20.0000, 'ºC'),
	(211340, 122, '2014-02-15 00:59:07.000000', 'temperatura', 203.0000, 'ºC'),
	(211341, 122, '2014-02-15 00:59:08.000000', 'temperatura', 953.0000, 'ºC'),
	(211342, 122, '2014-02-15 00:59:09.000000', 'temperatura', 559.0000, 'ºC'),
	(211343, 122, '2014-02-15 00:59:10.000000', 'temperatura', 1134.0000, 'ºC'),
	(211344, 122, '2014-02-15 00:59:11.000000', 'temperatura', 396.0000, 'ºC'),
	(211345, 122, '2014-02-15 00:59:12.000000', 'temperatura', 977.0000, 'ºC'),
	(211346, 122, '2014-02-15 00:59:13.000000', 'temperatura', 100.0000, 'ºC'),
	(211347, 122, '2014-02-15 00:59:14.000000', 'temperatura', 1167.0000, 'ºC'),
	(211348, 122, '2014-02-15 00:59:15.000000', 'temperatura', 737.0000, 'ºC'),
	(211349, 122, '2014-02-15 00:59:16.000000', 'temperatura', 185.0000, 'ºC'),
	(211350, 122, '2014-02-15 00:59:17.000000', 'temperatura', 1116.0000, 'ºC'),
	(211351, 122, '2014-02-15 00:59:18.000000', 'temperatura', 222.0000, 'ºC'),
	(211352, 122, '2014-02-15 00:59:19.000000', 'temperatura', 166.0000, 'ºC'),
	(211353, 122, '2014-02-15 00:59:20.000000', 'temperatura', 161.0000, 'ºC'),
	(211354, 122, '2014-02-15 00:59:21.000000', 'temperatura', 311.0000, 'ºC'),
	(211355, 122, '2014-02-15 00:59:22.000000', 'temperatura', 1070.0000, 'ºC'),
	(211356, 122, '2014-02-15 00:59:23.000000', 'temperatura', 816.0000, 'ºC'),
	(211357, 122, '2014-02-15 00:59:24.000000', 'temperatura', 872.0000, 'ºC'),
	(211358, 122, '2014-02-15 00:59:25.000000', 'temperatura', 714.0000, 'ºC'),
	(211359, 122, '2014-02-15 00:59:26.000000', 'temperatura', 955.0000, 'ºC'),
	(211360, 122, '2014-02-15 00:59:27.000000', 'temperatura', 232.0000, 'ºC'),
	(211361, 122, '2014-02-15 00:59:28.000000', 'temperatura', 696.0000, 'ºC'),
	(211362, 122, '2014-02-15 00:59:29.000000', 'temperatura', 385.0000, 'ºC'),
	(211363, 122, '2014-02-15 00:59:30.000000', 'temperatura', 1035.0000, 'ºC'),
	(211364, 122, '2014-02-15 00:59:31.000000', 'temperatura', 423.0000, 'ºC'),
	(211365, 122, '2014-02-15 00:59:32.000000', 'temperatura', 209.0000, 'ºC'),
	(211366, 122, '2014-02-15 00:59:33.000000', 'temperatura', 975.0000, 'ºC'),
	(211367, 122, '2014-02-15 00:59:34.000000', 'temperatura', 652.0000, 'ºC'),
	(211368, 122, '2014-02-15 00:59:35.000000', 'temperatura', 333.0000, 'ºC'),
	(211369, 122, '2014-02-15 00:59:36.000000', 'temperatura', 909.0000, 'ºC'),
	(211370, 122, '2014-02-15 00:59:37.000000', 'temperatura', 1148.0000, 'ºC'),
	(211371, 122, '2014-02-15 00:59:38.000000', 'temperatura', 615.0000, 'ºC'),
	(211372, 122, '2014-02-15 00:59:39.000000', 'temperatura', 831.0000, 'ºC'),
	(211373, 122, '2014-02-15 00:59:40.000000', 'temperatura', 1108.0000, 'ºC'),
	(211374, 122, '2014-02-15 00:59:41.000000', 'temperatura', 651.0000, 'ºC'),
	(211375, 122, '2014-02-15 00:59:42.000000', 'temperatura', 1128.0000, 'ºC'),
	(211376, 122, '2014-02-15 00:59:43.000000', 'temperatura', 90.0000, 'ºC'),
	(211377, 122, '2014-02-15 00:59:44.000000', 'temperatura', 667.0000, 'ºC'),
	(211378, 122, '2014-02-15 00:59:45.000000', 'temperatura', 665.0000, 'ºC'),
	(211379, 122, '2014-02-15 00:59:46.000000', 'temperatura', 125.0000, 'ºC'),
	(211380, 122, '2014-02-15 00:59:47.000000', 'temperatura', 1032.0000, 'ºC'),
	(211381, 122, '2014-02-15 00:59:48.000000', 'temperatura', 1182.0000, 'ºC'),
	(211382, 122, '2014-02-15 00:59:49.000000', 'temperatura', 418.0000, 'ºC'),
	(211383, 122, '2014-02-15 00:59:50.000000', 'temperatura', 943.0000, 'ºC'),
	(211384, 122, '2014-02-15 00:59:51.000000', 'temperatura', 1060.0000, 'ºC'),
	(211385, 122, '2014-02-15 00:59:52.000000', 'temperatura', 74.0000, 'ºC'),
	(211386, 122, '2014-02-15 00:59:53.000000', 'temperatura', 791.0000, 'ºC'),
	(211387, 122, '2014-02-15 00:59:54.000000', 'temperatura', 133.0000, 'ºC'),
	(211388, 122, '2014-02-15 00:59:55.000000', 'temperatura', 691.0000, 'ºC'),
	(211389, 122, '2014-02-15 00:59:56.000000', 'temperatura', 656.0000, 'ºC'),
	(211390, 122, '2014-02-15 00:59:57.000000', 'temperatura', 7.0000, 'ºC'),
	(211391, 122, '2014-02-15 00:59:58.000000', 'temperatura', 471.0000, 'ºC'),
	(211392, 122, '2014-02-15 00:59:59.000000', 'temperatura', 1131.0000, 'ºC'),
	(211393, 122, '2014-02-15 01:00:00.000000', 'temperatura', 644.0000, 'ºC'),
	(211394, 122, '2014-02-15 01:00:01.000000', 'temperatura', 1027.0000, 'ºC'),
	(211395, 122, '2014-02-15 01:00:02.000000', 'temperatura', 804.0000, 'ºC'),
	(211396, 122, '2014-02-15 01:00:03.000000', 'temperatura', 939.0000, 'ºC'),
	(211397, 122, '2014-02-15 01:00:04.000000', 'temperatura', 1082.0000, 'ºC'),
	(211398, 122, '2014-02-15 01:00:05.000000', 'temperatura', 195.0000, 'ºC'),
	(211399, 122, '2014-02-15 01:00:06.000000', 'temperatura', 131.0000, 'ºC'),
	(211400, 122, '2014-02-15 01:00:07.000000', 'temperatura', 71.0000, 'ºC'),
	(211401, 122, '2014-02-15 01:00:08.000000', 'temperatura', 1161.0000, 'ºC'),
	(211402, 122, '2014-02-15 01:00:09.000000', 'temperatura', 792.0000, 'ºC'),
	(211403, 122, '2014-02-15 01:00:10.000000', 'temperatura', 478.0000, 'ºC'),
	(211404, 122, '2014-02-15 01:00:11.000000', 'temperatura', 14.0000, 'ºC'),
	(211405, 122, '2014-02-15 01:00:12.000000', 'temperatura', 1036.0000, 'ºC'),
	(211406, 122, '2014-02-15 01:00:13.000000', 'temperatura', 341.0000, 'ºC'),
	(211407, 122, '2014-02-15 01:00:14.000000', 'temperatura', 994.0000, 'ºC'),
	(211408, 122, '2014-02-15 01:00:15.000000', 'temperatura', 350.0000, 'ºC'),
	(211409, 122, '2014-02-15 01:00:16.000000', 'temperatura', 1166.0000, 'ºC'),
	(211410, 122, '2014-02-15 01:00:17.000000', 'temperatura', 1182.0000, 'ºC'),
	(211411, 122, '2014-02-15 01:00:18.000000', 'temperatura', 13.0000, 'ºC'),
	(211412, 122, '2014-02-15 01:00:19.000000', 'temperatura', 120.0000, 'ºC'),
	(211413, 122, '2014-02-15 01:00:20.000000', 'temperatura', 561.0000, 'ºC'),
	(211414, 122, '2014-02-15 01:00:21.000000', 'temperatura', 44.0000, 'ºC'),
	(211415, 122, '2014-02-15 01:00:22.000000', 'temperatura', 939.0000, 'ºC'),
	(211416, 122, '2014-02-15 01:00:23.000000', 'temperatura', 965.0000, 'ºC'),
	(211417, 122, '2014-02-15 01:00:24.000000', 'temperatura', 808.0000, 'ºC'),
	(211418, 122, '2014-02-15 01:00:25.000000', 'temperatura', 1146.0000, 'ºC'),
	(211419, 122, '2014-02-15 01:00:26.000000', 'temperatura', 905.0000, 'ºC'),
	(211420, 122, '2014-02-15 01:00:27.000000', 'temperatura', 1089.0000, 'ºC'),
	(211421, 122, '2014-02-15 01:00:28.000000', 'temperatura', 330.0000, 'ºC'),
	(211422, 122, '2014-02-15 01:00:29.000000', 'temperatura', 785.0000, 'ºC'),
	(211423, 122, '2014-02-15 01:00:30.000000', 'temperatura', 532.0000, 'ºC'),
	(211424, 122, '2014-02-15 01:00:31.000000', 'temperatura', 309.0000, 'ºC'),
	(211425, 122, '2014-02-15 01:00:32.000000', 'temperatura', 1147.0000, 'ºC'),
	(211426, 122, '2014-02-15 01:00:33.000000', 'temperatura', 11.0000, 'ºC'),
	(211427, 122, '2014-02-15 01:00:34.000000', 'temperatura', 214.0000, 'ºC'),
	(211428, 122, '2014-02-15 01:00:35.000000', 'temperatura', 1036.0000, 'ºC'),
	(211429, 122, '2014-02-15 01:00:36.000000', 'temperatura', 941.0000, 'ºC'),
	(211430, 122, '2014-02-15 01:00:37.000000', 'temperatura', 395.0000, 'ºC'),
	(211431, 122, '2014-02-15 01:00:38.000000', 'temperatura', 354.0000, 'ºC'),
	(211432, 122, '2014-02-15 01:00:39.000000', 'temperatura', 584.0000, 'ºC'),
	(211433, 122, '2014-02-15 01:00:40.000000', 'temperatura', 658.0000, 'ºC'),
	(211434, 122, '2014-02-15 01:00:41.000000', 'temperatura', 337.0000, 'ºC'),
	(211435, 122, '2014-02-15 01:00:42.000000', 'temperatura', 914.0000, 'ºC'),
	(211436, 122, '2014-02-15 01:00:43.000000', 'temperatura', 1160.0000, 'ºC'),
	(211437, 122, '2014-02-15 01:00:44.000000', 'temperatura', 657.0000, 'ºC'),
	(211438, 122, '2014-02-15 01:00:45.000000', 'temperatura', 1006.0000, 'ºC'),
	(211439, 122, '2014-02-15 01:00:46.000000', 'temperatura', 661.0000, 'ºC'),
	(211440, 122, '2014-02-15 01:00:47.000000', 'temperatura', 288.0000, 'ºC'),
	(211441, 122, '2014-02-15 01:00:48.000000', 'temperatura', 657.0000, 'ºC'),
	(211442, 122, '2014-02-15 01:00:49.000000', 'temperatura', 23.0000, 'ºC'),
	(211443, 122, '2014-02-15 01:00:50.000000', 'temperatura', 542.0000, 'ºC'),
	(211444, 122, '2014-02-15 01:00:51.000000', 'temperatura', 244.0000, 'ºC'),
	(211445, 122, '2014-02-15 01:00:52.000000', 'temperatura', 791.0000, 'ºC'),
	(211446, 122, '2014-02-15 01:00:53.000000', 'temperatura', 827.0000, 'ºC'),
	(211447, 122, '2014-02-15 01:00:54.000000', 'temperatura', 560.0000, 'ºC'),
	(211448, 122, '2014-02-15 01:00:55.000000', 'temperatura', 322.0000, 'ºC'),
	(211449, 122, '2014-02-15 01:00:56.000000', 'temperatura', 1128.0000, 'ºC'),
	(211450, 122, '2014-02-15 01:00:57.000000', 'temperatura', 1076.0000, 'ºC'),
	(211451, 122, '2014-02-15 01:00:58.000000', 'temperatura', 796.0000, 'ºC'),
	(211452, 122, '2014-02-15 01:00:59.000000', 'temperatura', 751.0000, 'ºC'),
	(211453, 122, '2014-02-15 01:01:00.000000', 'temperatura', 167.0000, 'ºC'),
	(211454, 122, '2014-02-15 01:01:01.000000', 'temperatura', 982.0000, 'ºC'),
	(211455, 122, '2014-02-15 01:01:02.000000', 'temperatura', 811.0000, 'ºC'),
	(211456, 122, '2014-02-15 01:01:03.000000', 'temperatura', 1111.0000, 'ºC'),
	(211457, 122, '2014-02-15 01:01:04.000000', 'temperatura', 723.0000, 'ºC'),
	(211458, 122, '2014-02-15 01:01:05.000000', 'temperatura', 281.0000, 'ºC'),
	(211459, 122, '2014-02-15 01:01:06.000000', 'temperatura', 435.0000, 'ºC'),
	(211460, 122, '2014-02-15 01:01:07.000000', 'temperatura', 134.0000, 'ºC'),
	(211461, 122, '2014-02-15 01:01:08.000000', 'temperatura', 566.0000, 'ºC'),
	(211462, 122, '2014-02-15 01:01:09.000000', 'temperatura', 28.0000, 'ºC'),
	(211463, 122, '2014-02-15 01:01:10.000000', 'temperatura', 843.0000, 'ºC'),
	(211464, 122, '2014-02-15 01:01:11.000000', 'temperatura', 530.0000, 'ºC'),
	(211465, 122, '2014-02-15 01:01:12.000000', 'temperatura', 121.0000, 'ºC'),
	(211466, 122, '2014-02-15 01:01:13.000000', 'temperatura', 216.0000, 'ºC'),
	(211467, 122, '2014-02-15 01:01:14.000000', 'temperatura', 719.0000, 'ºC'),
	(211468, 122, '2014-02-15 01:01:15.000000', 'temperatura', 547.0000, 'ºC'),
	(211469, 122, '2014-02-15 01:01:16.000000', 'temperatura', 578.0000, 'ºC'),
	(211470, 122, '2014-02-15 01:01:17.000000', 'temperatura', 49.0000, 'ºC'),
	(211471, 122, '2014-02-15 01:01:18.000000', 'temperatura', 911.0000, 'ºC'),
	(211472, 122, '2014-02-15 01:01:19.000000', 'temperatura', 809.0000, 'ºC'),
	(211473, 122, '2014-02-15 01:01:20.000000', 'temperatura', 111.0000, 'ºC'),
	(211474, 122, '2014-02-15 01:01:21.000000', 'temperatura', 529.0000, 'ºC'),
	(211475, 122, '2014-02-15 01:01:22.000000', 'temperatura', 1113.0000, 'ºC'),
	(211476, 122, '2014-02-15 01:01:23.000000', 'temperatura', 378.0000, 'ºC'),
	(211477, 122, '2014-02-15 01:01:24.000000', 'temperatura', 952.0000, 'ºC'),
	(211478, 122, '2014-02-15 01:01:25.000000', 'temperatura', 25.0000, 'ºC'),
	(211479, 122, '2014-02-15 01:01:26.000000', 'temperatura', 872.0000, 'ºC'),
	(211480, 122, '2014-02-15 01:01:27.000000', 'temperatura', 683.0000, 'ºC'),
	(211481, 122, '2014-02-15 01:01:28.000000', 'temperatura', 799.0000, 'ºC'),
	(211482, 122, '2014-02-15 01:01:29.000000', 'temperatura', 748.0000, 'ºC'),
	(211483, 122, '2014-02-15 01:01:30.000000', 'temperatura', 142.0000, 'ºC'),
	(211484, 122, '2014-02-15 01:01:31.000000', 'temperatura', 865.0000, 'ºC'),
	(211485, 122, '2014-02-15 01:01:32.000000', 'temperatura', 303.0000, 'ºC'),
	(211486, 122, '2014-02-15 01:01:33.000000', 'temperatura', 118.0000, 'ºC'),
	(211487, 122, '2014-02-15 01:01:34.000000', 'temperatura', 882.0000, 'ºC'),
	(211488, 122, '2014-02-15 01:01:35.000000', 'temperatura', 456.0000, 'ºC'),
	(211489, 122, '2014-02-15 01:01:36.000000', 'temperatura', 836.0000, 'ºC'),
	(211490, 122, '2014-02-15 01:01:37.000000', 'temperatura', 410.0000, 'ºC'),
	(211491, 122, '2014-02-15 01:01:38.000000', 'temperatura', 743.0000, 'ºC'),
	(211492, 122, '2014-02-15 01:01:39.000000', 'temperatura', 86.0000, 'ºC'),
	(211493, 122, '2014-02-15 01:01:40.000000', 'temperatura', 601.0000, 'ºC'),
	(211494, 122, '2014-02-15 01:01:41.000000', 'temperatura', 347.0000, 'ºC'),
	(211495, 122, '2014-02-15 01:01:42.000000', 'temperatura', 1132.0000, 'ºC'),
	(211496, 122, '2014-02-15 01:01:43.000000', 'temperatura', 1021.0000, 'ºC'),
	(211497, 122, '2014-02-15 01:01:44.000000', 'temperatura', 509.0000, 'ºC'),
	(211498, 122, '2014-02-15 01:01:45.000000', 'temperatura', 683.0000, 'ºC'),
	(211499, 122, '2014-02-15 01:01:46.000000', 'temperatura', 689.0000, 'ºC'),
	(211500, 122, '2014-02-15 01:01:47.000000', 'temperatura', 194.0000, 'ºC'),
	(211501, 122, '2014-02-15 01:01:48.000000', 'temperatura', 105.0000, 'ºC'),
	(211502, 122, '2014-02-15 01:01:49.000000', 'temperatura', 1142.0000, 'ºC'),
	(211503, 122, '2014-02-15 01:01:50.000000', 'temperatura', 596.0000, 'ºC'),
	(211504, 122, '2014-02-15 01:01:51.000000', 'temperatura', 757.0000, 'ºC'),
	(211505, 122, '2014-02-15 01:01:52.000000', 'temperatura', 795.0000, 'ºC'),
	(211506, 122, '2014-02-15 01:01:53.000000', 'temperatura', 506.0000, 'ºC'),
	(211507, 122, '2014-02-15 01:01:54.000000', 'temperatura', 144.0000, 'ºC'),
	(211508, 122, '2014-02-15 01:01:55.000000', 'temperatura', 402.0000, 'ºC'),
	(211509, 122, '2014-02-15 01:01:56.000000', 'temperatura', 377.0000, 'ºC'),
	(211510, 122, '2014-02-15 01:01:57.000000', 'temperatura', 682.0000, 'ºC'),
	(211511, 122, '2014-02-15 01:01:58.000000', 'temperatura', 1080.0000, 'ºC'),
	(211512, 122, '2014-02-15 01:01:59.000000', 'temperatura', 955.0000, 'ºC'),
	(211513, 122, '2014-02-15 01:02:00.000000', 'temperatura', 335.0000, 'ºC'),
	(211514, 122, '2014-02-15 01:02:01.000000', 'temperatura', 8.0000, 'ºC'),
	(211515, 122, '2014-02-15 01:02:02.000000', 'temperatura', 239.0000, 'ºC'),
	(211516, 122, '2014-02-15 01:02:03.000000', 'temperatura', 1168.0000, 'ºC'),
	(211517, 122, '2014-02-15 01:02:04.000000', 'temperatura', 327.0000, 'ºC'),
	(211518, 122, '2014-02-15 01:02:05.000000', 'temperatura', 529.0000, 'ºC'),
	(211519, 122, '2014-02-15 01:02:06.000000', 'temperatura', 467.0000, 'ºC'),
	(211520, 122, '2014-02-15 01:02:07.000000', 'temperatura', 748.0000, 'ºC'),
	(211521, 122, '2014-02-15 01:02:08.000000', 'temperatura', 1139.0000, 'ºC'),
	(211522, 122, '2014-02-15 01:02:09.000000', 'temperatura', 1050.0000, 'ºC'),
	(211523, 122, '2014-02-15 01:02:10.000000', 'temperatura', 633.0000, 'ºC'),
	(211524, 122, '2014-02-15 01:02:11.000000', 'temperatura', 16.0000, 'ºC'),
	(211525, 122, '2014-02-15 01:02:12.000000', 'temperatura', 580.0000, 'ºC'),
	(211526, 122, '2014-02-15 01:02:13.000000', 'temperatura', 454.0000, 'ºC'),
	(211527, 122, '2014-02-15 01:02:14.000000', 'temperatura', 530.0000, 'ºC'),
	(211528, 122, '2014-02-15 01:02:15.000000', 'temperatura', 89.0000, 'ºC'),
	(211529, 122, '2014-02-15 01:02:16.000000', 'temperatura', 56.0000, 'ºC'),
	(211530, 122, '2014-02-15 01:02:17.000000', 'temperatura', 12.0000, 'ºC'),
	(211531, 122, '2014-02-15 01:02:18.000000', 'temperatura', 1093.0000, 'ºC'),
	(211532, 122, '2014-02-15 01:02:19.000000', 'temperatura', 631.0000, 'ºC'),
	(211533, 122, '2014-02-15 01:02:20.000000', 'temperatura', 1076.0000, 'ºC'),
	(211534, 122, '2014-02-15 01:02:21.000000', 'temperatura', 1086.0000, 'ºC'),
	(211535, 122, '2014-02-15 01:02:22.000000', 'temperatura', 1002.0000, 'ºC'),
	(211536, 122, '2014-02-15 01:02:23.000000', 'temperatura', 555.0000, 'ºC'),
	(211537, 122, '2014-02-15 01:02:24.000000', 'temperatura', 968.0000, 'ºC'),
	(211538, 122, '2014-02-15 01:02:25.000000', 'temperatura', 777.0000, 'ºC'),
	(211539, 122, '2014-02-15 01:02:26.000000', 'temperatura', 982.0000, 'ºC'),
	(211540, 122, '2014-02-15 01:02:27.000000', 'temperatura', 177.0000, 'ºC'),
	(211541, 122, '2014-02-15 01:02:28.000000', 'temperatura', 342.0000, 'ºC'),
	(211542, 122, '2014-02-15 01:02:29.000000', 'temperatura', 1178.0000, 'ºC'),
	(211543, 122, '2014-02-15 01:02:30.000000', 'temperatura', 65.0000, 'ºC'),
	(211544, 122, '2014-02-15 01:02:31.000000', 'temperatura', 390.0000, 'ºC'),
	(211545, 122, '2014-02-15 01:02:32.000000', 'temperatura', 556.0000, 'ºC'),
	(211546, 122, '2014-02-15 01:02:33.000000', 'temperatura', 411.0000, 'ºC'),
	(211547, 122, '2014-02-15 01:02:34.000000', 'temperatura', 386.0000, 'ºC'),
	(211548, 122, '2014-02-15 01:02:35.000000', 'temperatura', 697.0000, 'ºC'),
	(211549, 122, '2014-02-15 01:02:36.000000', 'temperatura', 1126.0000, 'ºC'),
	(211550, 122, '2014-02-15 01:02:37.000000', 'temperatura', 1143.0000, 'ºC'),
	(211551, 122, '2014-02-15 01:02:38.000000', 'temperatura', 1138.0000, 'ºC'),
	(211552, 122, '2014-02-15 01:02:39.000000', 'temperatura', 1059.0000, 'ºC'),
	(211553, 122, '2014-02-15 01:02:40.000000', 'temperatura', 681.0000, 'ºC'),
	(211554, 122, '2014-02-15 01:02:41.000000', 'temperatura', 230.0000, 'ºC'),
	(211555, 122, '2014-02-15 01:02:42.000000', 'temperatura', 308.0000, 'ºC'),
	(211556, 122, '2014-02-15 01:02:43.000000', 'temperatura', 848.0000, 'ºC'),
	(211557, 122, '2014-02-15 01:02:44.000000', 'temperatura', 919.0000, 'ºC'),
	(211558, 122, '2014-02-15 01:02:45.000000', 'temperatura', 849.0000, 'ºC'),
	(211559, 122, '2014-02-15 01:02:46.000000', 'temperatura', 289.0000, 'ºC'),
	(211560, 122, '2014-02-15 01:02:47.000000', 'temperatura', 98.0000, 'ºC'),
	(211561, 122, '2014-02-15 01:02:48.000000', 'temperatura', 825.0000, 'ºC'),
	(211562, 122, '2014-02-15 01:02:49.000000', 'temperatura', 232.0000, 'ºC'),
	(211563, 122, '2014-02-15 01:02:50.000000', 'temperatura', 1085.0000, 'ºC'),
	(211564, 122, '2014-02-15 01:02:51.000000', 'temperatura', 1130.0000, 'ºC'),
	(211565, 122, '2014-02-15 01:02:52.000000', 'temperatura', 1195.0000, 'ºC'),
	(211566, 122, '2014-02-15 01:02:53.000000', 'temperatura', 185.0000, 'ºC'),
	(211567, 122, '2014-02-15 01:02:54.000000', 'temperatura', 942.0000, 'ºC'),
	(211568, 122, '2014-02-15 01:02:55.000000', 'temperatura', 555.0000, 'ºC'),
	(211569, 122, '2014-02-15 01:02:56.000000', 'temperatura', 1148.0000, 'ºC'),
	(211570, 122, '2014-02-15 01:02:57.000000', 'temperatura', 477.0000, 'ºC'),
	(211571, 122, '2014-02-15 01:02:58.000000', 'temperatura', 143.0000, 'ºC'),
	(211572, 122, '2014-02-15 01:02:59.000000', 'temperatura', 482.0000, 'ºC'),
	(211573, 122, '2014-02-15 01:03:00.000000', 'temperatura', 780.0000, 'ºC'),
	(211574, 122, '2014-02-15 01:03:01.000000', 'temperatura', 57.0000, 'ºC'),
	(211575, 122, '2014-02-15 01:03:02.000000', 'temperatura', 346.0000, 'ºC'),
	(211576, 122, '2014-02-15 01:03:03.000000', 'temperatura', 357.0000, 'ºC'),
	(211577, 122, '2014-02-15 01:03:04.000000', 'temperatura', 749.0000, 'ºC'),
	(211578, 122, '2014-02-15 01:03:05.000000', 'temperatura', 273.0000, 'ºC'),
	(211579, 122, '2014-02-15 01:03:06.000000', 'temperatura', 319.0000, 'ºC'),
	(211580, 122, '2014-02-15 01:03:07.000000', 'temperatura', 778.0000, 'ºC'),
	(211581, 122, '2014-02-15 01:03:08.000000', 'temperatura', 535.0000, 'ºC'),
	(211582, 122, '2014-02-15 01:03:09.000000', 'temperatura', 338.0000, 'ºC'),
	(211583, 122, '2014-02-15 01:03:10.000000', 'temperatura', 88.0000, 'ºC'),
	(211584, 122, '2014-02-15 01:03:11.000000', 'temperatura', 626.0000, 'ºC'),
	(211585, 122, '2014-02-15 01:03:12.000000', 'temperatura', 467.0000, 'ºC'),
	(211586, 122, '2014-02-15 01:03:13.000000', 'temperatura', 457.0000, 'ºC'),
	(211587, 122, '2014-02-15 01:03:14.000000', 'temperatura', 886.0000, 'ºC'),
	(211588, 122, '2014-02-15 01:03:15.000000', 'temperatura', 656.0000, 'ºC'),
	(211589, 122, '2014-02-15 01:03:16.000000', 'temperatura', 626.0000, 'ºC'),
	(211590, 122, '2014-02-15 01:03:17.000000', 'temperatura', 1161.0000, 'ºC'),
	(211591, 122, '2014-02-15 01:03:18.000000', 'temperatura', 327.0000, 'ºC'),
	(211592, 122, '2014-02-15 01:03:19.000000', 'temperatura', 552.0000, 'ºC'),
	(211593, 122, '2014-02-15 01:03:20.000000', 'temperatura', 580.0000, 'ºC'),
	(211594, 122, '2014-02-15 01:03:21.000000', 'temperatura', 45.0000, 'ºC'),
	(211595, 122, '2014-02-15 01:03:22.000000', 'temperatura', 884.0000, 'ºC'),
	(211596, 122, '2014-02-15 01:03:23.000000', 'temperatura', 686.0000, 'ºC'),
	(211597, 122, '2014-02-15 01:03:24.000000', 'temperatura', 779.0000, 'ºC'),
	(211598, 122, '2014-02-15 01:03:25.000000', 'temperatura', 639.0000, 'ºC'),
	(211599, 122, '2014-02-15 01:03:26.000000', 'temperatura', 856.0000, 'ºC'),
	(211600, 122, '2014-02-15 01:03:27.000000', 'temperatura', 1164.0000, 'ºC'),
	(211601, 122, '2014-02-15 01:03:28.000000', 'temperatura', 854.0000, 'ºC'),
	(211602, 122, '2014-02-15 01:03:29.000000', 'temperatura', 776.0000, 'ºC'),
	(211603, 122, '2014-02-15 01:03:30.000000', 'temperatura', 120.0000, 'ºC'),
	(211604, 122, '2014-02-15 01:03:31.000000', 'temperatura', 672.0000, 'ºC'),
	(211605, 122, '2014-02-15 01:03:32.000000', 'temperatura', 599.0000, 'ºC'),
	(211606, 122, '2014-02-15 01:03:33.000000', 'temperatura', 981.0000, 'ºC'),
	(211607, 122, '2014-02-15 01:03:34.000000', 'temperatura', 708.0000, 'ºC'),
	(211608, 122, '2014-02-15 01:03:35.000000', 'temperatura', 600.0000, 'ºC'),
	(211609, 122, '2014-02-15 01:03:36.000000', 'temperatura', 873.0000, 'ºC'),
	(211610, 122, '2014-02-15 01:03:37.000000', 'temperatura', 169.0000, 'ºC'),
	(211611, 122, '2014-02-15 01:03:38.000000', 'temperatura', 623.0000, 'ºC'),
	(211612, 122, '2014-02-15 01:03:39.000000', 'temperatura', 211.0000, 'ºC'),
	(211613, 122, '2014-02-15 01:03:40.000000', 'temperatura', 384.0000, 'ºC'),
	(211614, 122, '2014-02-15 01:03:41.000000', 'temperatura', 87.0000, 'ºC'),
	(211615, 122, '2014-02-15 01:03:42.000000', 'temperatura', 486.0000, 'ºC'),
	(211616, 122, '2014-02-15 01:03:43.000000', 'temperatura', 969.0000, 'ºC'),
	(211617, 122, '2014-02-15 01:03:44.000000', 'temperatura', 989.0000, 'ºC'),
	(211618, 122, '2014-02-15 01:03:45.000000', 'temperatura', 837.0000, 'ºC'),
	(211619, 122, '2014-02-15 01:03:46.000000', 'temperatura', 21.0000, 'ºC'),
	(211620, 122, '2014-02-15 01:03:47.000000', 'temperatura', 1192.0000, 'ºC'),
	(211621, 122, '2014-02-15 01:03:48.000000', 'temperatura', 1097.0000, 'ºC'),
	(211622, 122, '2014-02-15 01:03:49.000000', 'temperatura', 710.0000, 'ºC'),
	(211623, 122, '2014-02-15 01:03:50.000000', 'temperatura', 258.0000, 'ºC'),
	(211624, 122, '2014-02-15 01:03:51.000000', 'temperatura', 361.0000, 'ºC'),
	(211625, 122, '2014-02-15 01:03:52.000000', 'temperatura', 1032.0000, 'ºC'),
	(211626, 122, '2014-02-15 01:03:53.000000', 'temperatura', 477.0000, 'ºC'),
	(211627, 122, '2014-02-15 01:03:54.000000', 'temperatura', 491.0000, 'ºC'),
	(211628, 122, '2014-02-15 01:03:55.000000', 'temperatura', 1024.0000, 'ºC'),
	(211629, 122, '2014-02-15 01:03:56.000000', 'temperatura', 47.0000, 'ºC'),
	(211630, 122, '2014-02-15 01:03:57.000000', 'temperatura', 765.0000, 'ºC'),
	(211631, 122, '2014-02-15 01:03:58.000000', 'temperatura', 82.0000, 'ºC'),
	(211632, 122, '2014-02-15 01:03:59.000000', 'temperatura', 519.0000, 'ºC'),
	(211633, 122, '2014-02-15 01:04:00.000000', 'temperatura', 1146.0000, 'ºC'),
	(211634, 122, '2014-02-15 01:04:01.000000', 'temperatura', 574.0000, 'ºC'),
	(211635, 122, '2014-02-15 01:04:02.000000', 'temperatura', 634.0000, 'ºC'),
	(211636, 122, '2014-02-15 01:04:03.000000', 'temperatura', 249.0000, 'ºC'),
	(211637, 122, '2014-02-15 01:04:04.000000', 'temperatura', 544.0000, 'ºC'),
	(211638, 122, '2014-02-15 01:04:05.000000', 'temperatura', 772.0000, 'ºC'),
	(211639, 122, '2014-02-15 01:04:06.000000', 'temperatura', 1030.0000, 'ºC'),
	(211640, 122, '2014-02-15 01:04:07.000000', 'temperatura', 434.0000, 'ºC'),
	(211641, 122, '2014-02-15 01:04:08.000000', 'temperatura', 279.0000, 'ºC'),
	(211642, 122, '2014-02-15 01:04:09.000000', 'temperatura', 96.0000, 'ºC'),
	(211643, 122, '2014-02-15 01:04:10.000000', 'temperatura', 844.0000, 'ºC'),
	(211644, 122, '2014-02-15 01:04:11.000000', 'temperatura', 329.0000, 'ºC'),
	(211645, 122, '2014-02-15 01:04:12.000000', 'temperatura', 317.0000, 'ºC'),
	(211646, 122, '2014-02-15 01:04:13.000000', 'temperatura', 596.0000, 'ºC'),
	(211647, 122, '2014-02-15 01:04:14.000000', 'temperatura', 829.0000, 'ºC'),
	(211648, 122, '2014-02-15 01:04:15.000000', 'temperatura', 1160.0000, 'ºC'),
	(211649, 122, '2014-02-15 01:04:16.000000', 'temperatura', 913.0000, 'ºC'),
	(211650, 122, '2014-02-15 01:04:17.000000', 'temperatura', 1086.0000, 'ºC'),
	(211651, 122, '2014-02-15 01:04:18.000000', 'temperatura', 292.0000, 'ºC'),
	(211652, 122, '2014-02-15 01:04:19.000000', 'temperatura', 603.0000, 'ºC'),
	(211653, 122, '2014-02-15 01:04:20.000000', 'temperatura', 938.0000, 'ºC'),
	(211654, 122, '2014-02-15 01:04:21.000000', 'temperatura', 484.0000, 'ºC'),
	(211655, 122, '2014-02-15 01:04:22.000000', 'temperatura', 804.0000, 'ºC'),
	(211656, 122, '2014-02-15 01:04:23.000000', 'temperatura', 167.0000, 'ºC'),
	(211657, 122, '2014-02-15 01:04:24.000000', 'temperatura', 827.0000, 'ºC'),
	(211658, 122, '2014-02-15 01:04:25.000000', 'temperatura', 32.0000, 'ºC'),
	(211659, 122, '2014-02-15 01:04:26.000000', 'temperatura', 79.0000, 'ºC'),
	(211660, 122, '2014-02-15 01:04:27.000000', 'temperatura', 298.0000, 'ºC'),
	(211661, 122, '2014-02-15 01:04:28.000000', 'temperatura', 57.0000, 'ºC'),
	(211662, 122, '2014-02-15 01:04:29.000000', 'temperatura', 591.0000, 'ºC'),
	(211663, 122, '2014-02-15 01:04:30.000000', 'temperatura', 386.0000, 'ºC'),
	(211664, 122, '2014-02-15 01:04:31.000000', 'temperatura', 156.0000, 'ºC'),
	(211665, 122, '2014-02-15 01:04:32.000000', 'temperatura', 823.0000, 'ºC'),
	(211666, 122, '2014-02-15 01:04:33.000000', 'temperatura', 48.0000, 'ºC'),
	(211667, 122, '2014-02-15 01:04:34.000000', 'temperatura', 172.0000, 'ºC'),
	(211668, 122, '2014-02-15 01:04:35.000000', 'temperatura', 717.0000, 'ºC'),
	(211669, 122, '2014-02-15 01:04:36.000000', 'temperatura', 670.0000, 'ºC'),
	(211670, 122, '2014-02-15 01:04:37.000000', 'temperatura', 1198.0000, 'ºC'),
	(211671, 122, '2014-02-15 01:04:38.000000', 'temperatura', 381.0000, 'ºC'),
	(211672, 122, '2014-02-15 01:04:39.000000', 'temperatura', 711.0000, 'ºC'),
	(211673, 122, '2014-02-15 01:04:40.000000', 'temperatura', 13.0000, 'ºC'),
	(211674, 122, '2014-02-15 01:04:41.000000', 'temperatura', 332.0000, 'ºC'),
	(211675, 122, '2014-02-15 01:04:42.000000', 'temperatura', 421.0000, 'ºC'),
	(211676, 122, '2014-02-15 01:04:43.000000', 'temperatura', 1110.0000, 'ºC'),
	(211677, 122, '2014-02-15 01:04:44.000000', 'temperatura', 686.0000, 'ºC'),
	(211678, 122, '2014-02-15 01:04:45.000000', 'temperatura', 100.0000, 'ºC'),
	(211679, 122, '2014-02-15 01:04:46.000000', 'temperatura', 844.0000, 'ºC'),
	(211680, 122, '2014-02-15 01:04:47.000000', 'temperatura', 321.0000, 'ºC'),
	(211681, 122, '2014-02-15 01:04:48.000000', 'temperatura', 271.0000, 'ºC'),
	(211682, 122, '2014-02-15 01:04:49.000000', 'temperatura', 393.0000, 'ºC'),
	(211683, 122, '2014-02-15 01:04:50.000000', 'temperatura', 1154.0000, 'ºC'),
	(211684, 122, '2014-02-15 01:04:51.000000', 'temperatura', 989.0000, 'ºC'),
	(211685, 122, '2014-02-15 01:04:52.000000', 'temperatura', 285.0000, 'ºC'),
	(211686, 122, '2014-02-15 01:04:53.000000', 'temperatura', 860.0000, 'ºC'),
	(211687, 122, '2014-02-15 01:04:54.000000', 'temperatura', 1044.0000, 'ºC'),
	(211688, 122, '2014-02-15 01:04:55.000000', 'temperatura', 241.0000, 'ºC'),
	(211689, 122, '2014-02-15 01:04:56.000000', 'temperatura', 474.0000, 'ºC'),
	(211690, 122, '2014-02-15 01:04:57.000000', 'temperatura', 446.0000, 'ºC'),
	(211691, 122, '2014-02-15 01:04:58.000000', 'temperatura', 809.0000, 'ºC'),
	(211692, 122, '2014-02-15 01:04:59.000000', 'temperatura', 306.0000, 'ºC'),
	(211693, 122, '2014-02-15 01:05:00.000000', 'temperatura', 304.0000, 'ºC'),
	(211694, 122, '2014-02-15 01:05:01.000000', 'temperatura', 601.0000, 'ºC'),
	(211695, 122, '2014-02-15 01:05:02.000000', 'temperatura', 894.0000, 'ºC'),
	(211696, 122, '2014-02-15 01:05:03.000000', 'temperatura', 269.0000, 'ºC'),
	(211697, 122, '2014-02-15 01:05:04.000000', 'temperatura', 1063.0000, 'ºC'),
	(211698, 122, '2014-02-15 01:05:05.000000', 'temperatura', 910.0000, 'ºC'),
	(211699, 122, '2014-02-15 01:05:06.000000', 'temperatura', 160.0000, 'ºC'),
	(211700, 122, '2014-02-15 01:05:07.000000', 'temperatura', 469.0000, 'ºC'),
	(211701, 122, '2014-02-15 01:05:08.000000', 'temperatura', 665.0000, 'ºC'),
	(211702, 122, '2014-02-15 01:05:09.000000', 'temperatura', 720.0000, 'ºC'),
	(211703, 122, '2014-02-15 01:05:10.000000', 'temperatura', 407.0000, 'ºC'),
	(211704, 122, '2014-02-15 01:05:11.000000', 'temperatura', 1075.0000, 'ºC'),
	(211705, 122, '2014-02-15 01:05:12.000000', 'temperatura', 554.0000, 'ºC'),
	(211706, 122, '2014-02-15 01:05:13.000000', 'temperatura', 743.0000, 'ºC'),
	(211707, 122, '2014-02-15 01:05:14.000000', 'temperatura', 857.0000, 'ºC'),
	(211708, 122, '2014-02-15 01:05:15.000000', 'temperatura', 857.0000, 'ºC'),
	(211709, 122, '2014-02-15 01:05:16.000000', 'temperatura', 511.0000, 'ºC'),
	(211710, 122, '2014-02-15 01:05:17.000000', 'temperatura', 1188.0000, 'ºC'),
	(211711, 122, '2014-02-15 01:05:18.000000', 'temperatura', 806.0000, 'ºC'),
	(211712, 122, '2014-02-15 01:05:19.000000', 'temperatura', 466.0000, 'ºC'),
	(211713, 122, '2014-02-15 01:05:20.000000', 'temperatura', 1115.0000, 'ºC'),
	(211714, 122, '2014-02-15 01:05:21.000000', 'temperatura', 576.0000, 'ºC'),
	(211715, 122, '2014-02-15 01:05:22.000000', 'temperatura', 734.0000, 'ºC'),
	(211716, 122, '2014-02-15 01:05:23.000000', 'temperatura', 742.0000, 'ºC'),
	(211717, 122, '2014-02-15 01:05:24.000000', 'temperatura', 308.0000, 'ºC'),
	(211718, 122, '2014-02-15 01:05:25.000000', 'temperatura', 515.0000, 'ºC'),
	(211719, 122, '2014-02-15 01:05:26.000000', 'temperatura', 451.0000, 'ºC'),
	(211720, 122, '2014-02-15 01:05:27.000000', 'temperatura', 710.0000, 'ºC'),
	(211721, 122, '2014-02-15 01:05:28.000000', 'temperatura', 999.0000, 'ºC'),
	(211722, 122, '2014-02-15 01:05:29.000000', 'temperatura', 464.0000, 'ºC'),
	(211723, 122, '2014-02-15 01:05:30.000000', 'temperatura', 522.0000, 'ºC'),
	(211724, 122, '2014-02-15 01:05:31.000000', 'temperatura', 21.0000, 'ºC'),
	(211725, 122, '2014-02-15 01:05:32.000000', 'temperatura', 938.0000, 'ºC'),
	(211726, 122, '2014-02-15 01:05:33.000000', 'temperatura', 1027.0000, 'ºC'),
	(211727, 122, '2014-02-15 01:05:34.000000', 'temperatura', 1124.0000, 'ºC'),
	(211728, 122, '2014-02-15 01:05:35.000000', 'temperatura', 138.0000, 'ºC'),
	(211729, 122, '2014-02-15 01:05:36.000000', 'temperatura', 921.0000, 'ºC'),
	(211730, 122, '2014-02-15 01:05:37.000000', 'temperatura', 589.0000, 'ºC'),
	(211731, 122, '2014-02-15 01:05:38.000000', 'temperatura', 183.0000, 'ºC'),
	(211732, 122, '2014-02-15 01:05:39.000000', 'temperatura', 350.0000, 'ºC'),
	(211733, 122, '2014-02-15 01:05:40.000000', 'temperatura', 1199.0000, 'ºC'),
	(211734, 122, '2014-02-15 01:05:41.000000', 'temperatura', 147.0000, 'ºC'),
	(211735, 122, '2014-02-15 01:05:42.000000', 'temperatura', 738.0000, 'ºC'),
	(211736, 122, '2014-02-15 01:05:43.000000', 'temperatura', 849.0000, 'ºC'),
	(211737, 122, '2014-02-15 01:05:44.000000', 'temperatura', 830.0000, 'ºC'),
	(211738, 122, '2014-02-15 01:05:45.000000', 'temperatura', 407.0000, 'ºC'),
	(211739, 122, '2014-02-15 01:05:46.000000', 'temperatura', 743.0000, 'ºC'),
	(211740, 122, '2014-02-15 01:05:47.000000', 'temperatura', 97.0000, 'ºC'),
	(211741, 122, '2014-02-15 01:05:48.000000', 'temperatura', 655.0000, 'ºC'),
	(211742, 122, '2014-02-15 01:05:49.000000', 'temperatura', 583.0000, 'ºC'),
	(211743, 122, '2014-02-15 01:05:50.000000', 'temperatura', 951.0000, 'ºC'),
	(211744, 122, '2014-02-15 01:05:51.000000', 'temperatura', 606.0000, 'ºC'),
	(211745, 122, '2014-02-15 01:05:52.000000', 'temperatura', 177.0000, 'ºC'),
	(211746, 122, '2014-02-15 01:05:53.000000', 'temperatura', 267.0000, 'ºC'),
	(211747, 122, '2014-02-15 01:05:54.000000', 'temperatura', 804.0000, 'ºC'),
	(211748, 122, '2014-02-15 01:05:55.000000', 'temperatura', 822.0000, 'ºC'),
	(211749, 122, '2014-02-15 01:05:56.000000', 'temperatura', 498.0000, 'ºC'),
	(211750, 122, '2014-02-15 01:05:57.000000', 'temperatura', 24.0000, 'ºC'),
	(211751, 122, '2014-02-15 01:05:58.000000', 'temperatura', 1026.0000, 'ºC'),
	(211752, 122, '2014-02-15 01:05:59.000000', 'temperatura', 258.0000, 'ºC'),
	(211753, 122, '2014-02-15 01:06:00.000000', 'temperatura', 614.0000, 'ºC'),
	(211754, 122, '2014-02-15 01:06:01.000000', 'temperatura', 1095.0000, 'ºC'),
	(211755, 122, '2014-02-15 01:06:02.000000', 'temperatura', 36.0000, 'ºC'),
	(211756, 122, '2014-02-15 01:06:03.000000', 'temperatura', 492.0000, 'ºC'),
	(211757, 122, '2014-02-15 01:06:04.000000', 'temperatura', 1154.0000, 'ºC'),
	(211758, 122, '2014-02-15 01:06:05.000000', 'temperatura', 696.0000, 'ºC'),
	(211759, 122, '2014-02-15 01:06:06.000000', 'temperatura', 19.0000, 'ºC'),
	(211760, 122, '2014-02-15 01:06:07.000000', 'temperatura', 404.0000, 'ºC'),
	(211761, 122, '2014-02-15 01:06:08.000000', 'temperatura', 767.0000, 'ºC'),
	(211762, 122, '2014-02-15 01:06:09.000000', 'temperatura', 220.0000, 'ºC'),
	(211763, 122, '2014-02-15 01:06:10.000000', 'temperatura', 3.0000, 'ºC'),
	(211764, 122, '2014-02-15 01:06:11.000000', 'temperatura', 554.0000, 'ºC'),
	(211765, 122, '2014-02-15 01:06:12.000000', 'temperatura', 360.0000, 'ºC'),
	(211766, 122, '2014-02-15 01:06:13.000000', 'temperatura', 140.0000, 'ºC'),
	(211767, 122, '2014-02-15 01:06:14.000000', 'temperatura', 821.0000, 'ºC'),
	(211768, 122, '2014-02-15 01:06:15.000000', 'temperatura', 86.0000, 'ºC'),
	(211769, 122, '2014-02-15 01:06:16.000000', 'temperatura', 369.0000, 'ºC'),
	(211770, 122, '2014-02-15 01:06:17.000000', 'temperatura', 384.0000, 'ºC'),
	(211771, 122, '2014-02-15 01:06:18.000000', 'temperatura', 815.0000, 'ºC'),
	(211772, 122, '2014-02-15 01:06:19.000000', 'temperatura', 522.0000, 'ºC'),
	(211773, 122, '2014-02-15 01:06:20.000000', 'temperatura', 168.0000, 'ºC'),
	(211774, 122, '2014-02-15 01:06:21.000000', 'temperatura', 475.0000, 'ºC'),
	(211775, 122, '2014-02-15 01:06:22.000000', 'temperatura', 670.0000, 'ºC'),
	(211776, 122, '2014-02-15 01:06:23.000000', 'temperatura', 726.0000, 'ºC'),
	(211777, 122, '2014-02-15 01:06:24.000000', 'temperatura', 419.0000, 'ºC'),
	(211778, 122, '2014-02-15 01:06:25.000000', 'temperatura', 1117.0000, 'ºC'),
	(211779, 122, '2014-02-15 01:06:26.000000', 'temperatura', 732.0000, 'ºC'),
	(211780, 122, '2014-02-15 01:06:27.000000', 'temperatura', 306.0000, 'ºC'),
	(211781, 122, '2014-02-15 01:06:28.000000', 'temperatura', 535.0000, 'ºC'),
	(211782, 122, '2014-02-15 01:06:29.000000', 'temperatura', 560.0000, 'ºC'),
	(211783, 122, '2014-02-15 01:06:30.000000', 'temperatura', 1194.0000, 'ºC'),
	(211784, 122, '2014-02-15 01:06:31.000000', 'temperatura', 689.0000, 'ºC'),
	(211785, 122, '2014-02-15 01:06:32.000000', 'temperatura', 1065.0000, 'ºC'),
	(211786, 122, '2014-02-15 01:06:33.000000', 'temperatura', 856.0000, 'ºC'),
	(211787, 122, '2014-02-15 01:06:34.000000', 'temperatura', 1089.0000, 'ºC'),
	(211788, 122, '2014-02-15 01:06:35.000000', 'temperatura', 475.0000, 'ºC'),
	(211789, 122, '2014-02-15 01:06:36.000000', 'temperatura', 311.0000, 'ºC'),
	(211790, 122, '2014-02-15 01:06:37.000000', 'temperatura', 129.0000, 'ºC'),
	(211791, 122, '2014-02-15 01:06:38.000000', 'temperatura', 915.0000, 'ºC'),
	(211792, 122, '2014-02-15 01:06:39.000000', 'temperatura', 585.0000, 'ºC'),
	(211793, 122, '2014-02-15 01:06:40.000000', 'temperatura', 184.0000, 'ºC'),
	(211794, 122, '2014-02-15 01:06:41.000000', 'temperatura', 363.0000, 'ºC'),
	(211795, 122, '2014-02-15 01:06:42.000000', 'temperatura', 66.0000, 'ºC'),
	(211796, 122, '2014-02-15 01:06:43.000000', 'temperatura', 441.0000, 'ºC'),
	(211797, 122, '2014-02-15 01:06:44.000000', 'temperatura', 809.0000, 'ºC'),
	(211798, 122, '2014-02-15 01:06:45.000000', 'temperatura', 319.0000, 'ºC'),
	(211799, 122, '2014-02-15 01:06:46.000000', 'temperatura', 372.0000, 'ºC'),
	(211800, 122, '2014-02-15 01:06:47.000000', 'temperatura', 900.0000, 'ºC'),
	(211801, 122, '2014-02-15 01:06:48.000000', 'temperatura', 987.0000, 'ºC'),
	(211802, 122, '2014-02-15 01:06:49.000000', 'temperatura', 1033.0000, 'ºC'),
	(211803, 122, '2014-02-15 01:06:50.000000', 'temperatura', 1006.0000, 'ºC'),
	(211804, 122, '2014-02-15 01:06:51.000000', 'temperatura', 733.0000, 'ºC'),
	(211805, 122, '2014-02-15 01:06:52.000000', 'temperatura', 645.0000, 'ºC'),
	(211806, 122, '2014-02-15 01:06:53.000000', 'temperatura', 1027.0000, 'ºC'),
	(211807, 122, '2014-02-15 01:06:54.000000', 'temperatura', 800.0000, 'ºC'),
	(211808, 122, '2014-02-15 01:06:55.000000', 'temperatura', 918.0000, 'ºC'),
	(211809, 122, '2014-02-15 01:06:56.000000', 'temperatura', 993.0000, 'ºC'),
	(211810, 122, '2014-02-15 01:06:57.000000', 'temperatura', 1012.0000, 'ºC'),
	(211811, 122, '2014-02-15 01:06:58.000000', 'temperatura', 879.0000, 'ºC'),
	(211812, 122, '2014-02-15 01:06:59.000000', 'temperatura', 161.0000, 'ºC'),
	(211813, 122, '2014-02-15 01:07:00.000000', 'temperatura', 570.0000, 'ºC'),
	(211814, 122, '2014-02-15 01:07:01.000000', 'temperatura', 1166.0000, 'ºC'),
	(211815, 122, '2014-02-15 01:07:02.000000', 'temperatura', 522.0000, 'ºC'),
	(211816, 122, '2014-02-15 01:07:03.000000', 'temperatura', 313.0000, 'ºC'),
	(211817, 122, '2014-02-15 01:07:04.000000', 'temperatura', 1197.0000, 'ºC'),
	(211818, 122, '2014-02-15 01:07:05.000000', 'temperatura', 246.0000, 'ºC'),
	(211819, 122, '2014-02-15 01:07:06.000000', 'temperatura', 42.0000, 'ºC'),
	(211820, 122, '2014-02-15 01:07:07.000000', 'temperatura', 671.0000, 'ºC'),
	(211821, 122, '2014-02-15 01:07:08.000000', 'temperatura', 829.0000, 'ºC'),
	(211822, 122, '2014-02-15 01:07:09.000000', 'temperatura', 935.0000, 'ºC'),
	(211823, 122, '2014-02-15 01:07:10.000000', 'temperatura', 988.0000, 'ºC'),
	(211824, 122, '2014-02-15 01:07:11.000000', 'temperatura', 934.0000, 'ºC'),
	(211825, 122, '2014-02-15 01:07:12.000000', 'temperatura', 507.0000, 'ºC'),
	(211826, 122, '2014-02-15 01:07:13.000000', 'temperatura', 936.0000, 'ºC'),
	(211827, 122, '2014-02-15 01:07:14.000000', 'temperatura', 756.0000, 'ºC'),
	(211828, 122, '2014-02-15 01:07:15.000000', 'temperatura', 974.0000, 'ºC'),
	(211829, 122, '2014-02-15 01:07:16.000000', 'temperatura', 203.0000, 'ºC'),
	(211830, 122, '2014-02-15 01:07:17.000000', 'temperatura', 491.0000, 'ºC'),
	(211831, 122, '2014-02-15 01:07:18.000000', 'temperatura', 648.0000, 'ºC'),
	(211832, 122, '2014-02-15 01:07:19.000000', 'temperatura', 566.0000, 'ºC'),
	(211833, 122, '2014-02-15 01:07:20.000000', 'temperatura', 889.0000, 'ºC'),
	(211834, 122, '2014-02-15 01:07:21.000000', 'temperatura', 347.0000, 'ºC'),
	(211835, 122, '2014-02-15 01:07:22.000000', 'temperatura', 267.0000, 'ºC'),
	(211836, 122, '2014-02-15 01:07:23.000000', 'temperatura', 295.0000, 'ºC'),
	(211837, 122, '2014-02-15 01:07:24.000000', 'temperatura', 676.0000, 'ºC'),
	(211838, 122, '2014-02-15 01:07:25.000000', 'temperatura', 94.0000, 'ºC'),
	(211839, 122, '2014-02-15 01:07:26.000000', 'temperatura', 845.0000, 'ºC'),
	(211840, 122, '2014-02-15 01:07:27.000000', 'temperatura', 341.0000, 'ºC'),
	(211841, 122, '2014-02-15 01:07:28.000000', 'temperatura', 370.0000, 'ºC'),
	(211842, 122, '2014-02-15 01:07:29.000000', 'temperatura', 827.0000, 'ºC'),
	(211843, 122, '2014-02-15 01:07:30.000000', 'temperatura', 626.0000, 'ºC'),
	(211844, 122, '2014-02-15 01:07:31.000000', 'temperatura', 649.0000, 'ºC'),
	(211845, 122, '2014-02-15 01:07:32.000000', 'temperatura', 167.0000, 'ºC'),
	(211846, 122, '2014-02-15 01:07:33.000000', 'temperatura', 91.0000, 'ºC'),
	(211847, 122, '2014-02-15 01:07:34.000000', 'temperatura', 1154.0000, 'ºC'),
	(211848, 122, '2014-02-15 01:07:35.000000', 'temperatura', 698.0000, 'ºC'),
	(211849, 122, '2014-02-15 01:07:36.000000', 'temperatura', 29.0000, 'ºC'),
	(211850, 122, '2014-02-15 01:07:37.000000', 'temperatura', 452.0000, 'ºC'),
	(211851, 122, '2014-02-15 01:07:38.000000', 'temperatura', 972.0000, 'ºC'),
	(211852, 122, '2014-02-15 01:07:39.000000', 'temperatura', 1105.0000, 'ºC'),
	(211853, 122, '2014-02-15 01:07:40.000000', 'temperatura', 211.0000, 'ºC'),
	(211854, 122, '2014-02-15 01:07:41.000000', 'temperatura', 140.0000, 'ºC'),
	(211855, 122, '2014-02-15 01:07:42.000000', 'temperatura', 67.0000, 'ºC'),
	(211856, 122, '2014-02-15 01:07:43.000000', 'temperatura', 1117.0000, 'ºC'),
	(211857, 122, '2014-02-15 01:07:44.000000', 'temperatura', 582.0000, 'ºC'),
	(211858, 122, '2014-02-15 01:07:45.000000', 'temperatura', 760.0000, 'ºC'),
	(211859, 122, '2014-02-15 01:07:46.000000', 'temperatura', 854.0000, 'ºC'),
	(211860, 122, '2014-02-15 01:07:47.000000', 'temperatura', 793.0000, 'ºC'),
	(211861, 122, '2014-02-15 01:07:48.000000', 'temperatura', 201.0000, 'ºC'),
	(211862, 122, '2014-02-15 01:07:49.000000', 'temperatura', 1026.0000, 'ºC'),
	(211863, 122, '2014-02-15 01:07:50.000000', 'temperatura', 930.0000, 'ºC'),
	(211864, 122, '2014-02-15 01:07:51.000000', 'temperatura', 371.0000, 'ºC'),
	(211865, 122, '2014-02-15 01:07:52.000000', 'temperatura', 264.0000, 'ºC'),
	(211866, 122, '2014-02-15 01:07:53.000000', 'temperatura', 209.0000, 'ºC'),
	(211867, 122, '2014-02-15 01:07:54.000000', 'temperatura', 255.0000, 'ºC'),
	(211868, 122, '2014-02-15 01:07:55.000000', 'temperatura', 649.0000, 'ºC'),
	(211869, 122, '2014-02-15 01:07:56.000000', 'temperatura', 79.0000, 'ºC'),
	(211870, 122, '2014-02-15 01:07:57.000000', 'temperatura', 850.0000, 'ºC'),
	(211871, 122, '2014-02-15 01:07:58.000000', 'temperatura', 411.0000, 'ºC'),
	(211872, 122, '2014-02-15 01:07:59.000000', 'temperatura', 705.0000, 'ºC'),
	(211873, 122, '2014-02-15 01:08:00.000000', 'temperatura', 1092.0000, 'ºC'),
	(211874, 122, '2014-02-15 01:08:01.000000', 'temperatura', 948.0000, 'ºC'),
	(211875, 122, '2014-02-15 01:08:02.000000', 'temperatura', 262.0000, 'ºC'),
	(211876, 122, '2014-02-15 01:08:03.000000', 'temperatura', 867.0000, 'ºC'),
	(211877, 122, '2014-02-15 01:08:04.000000', 'temperatura', 1152.0000, 'ºC'),
	(211878, 122, '2014-02-15 01:08:05.000000', 'temperatura', 758.0000, 'ºC'),
	(211879, 122, '2014-02-15 01:08:06.000000', 'temperatura', 334.0000, 'ºC'),
	(211880, 122, '2014-02-15 01:08:07.000000', 'temperatura', 596.0000, 'ºC'),
	(211881, 122, '2014-02-15 01:08:08.000000', 'temperatura', 779.0000, 'ºC'),
	(211882, 122, '2014-02-15 01:08:09.000000', 'temperatura', 908.0000, 'ºC'),
	(211883, 122, '2014-02-15 01:08:10.000000', 'temperatura', 1002.0000, 'ºC'),
	(211884, 122, '2014-02-15 01:08:11.000000', 'temperatura', 1089.0000, 'ºC'),
	(211885, 122, '2014-02-15 01:08:12.000000', 'temperatura', 38.0000, 'ºC'),
	(211886, 122, '2014-02-15 01:08:13.000000', 'temperatura', 525.0000, 'ºC'),
	(211887, 122, '2014-02-15 01:08:14.000000', 'temperatura', 108.0000, 'ºC'),
	(211888, 122, '2014-02-15 01:08:15.000000', 'temperatura', 169.0000, 'ºC'),
	(211889, 122, '2014-02-15 01:08:16.000000', 'temperatura', 522.0000, 'ºC'),
	(211890, 122, '2014-02-15 01:08:17.000000', 'temperatura', 903.0000, 'ºC'),
	(211891, 122, '2014-02-15 01:08:18.000000', 'temperatura', 550.0000, 'ºC'),
	(211892, 122, '2014-02-15 01:08:19.000000', 'temperatura', 40.0000, 'ºC'),
	(211893, 122, '2014-02-15 01:08:20.000000', 'temperatura', 950.0000, 'ºC'),
	(211894, 122, '2014-02-15 01:08:21.000000', 'temperatura', 1032.0000, 'ºC'),
	(211895, 122, '2014-02-15 01:08:22.000000', 'temperatura', 1110.0000, 'ºC'),
	(211896, 122, '2014-02-15 01:08:23.000000', 'temperatura', 56.0000, 'ºC'),
	(211897, 122, '2014-02-15 01:08:24.000000', 'temperatura', 549.0000, 'ºC'),
	(211898, 122, '2014-02-15 01:08:25.000000', 'temperatura', 177.0000, 'ºC'),
	(211899, 122, '2014-02-15 01:08:26.000000', 'temperatura', 439.0000, 'ºC'),
	(211900, 122, '2014-02-15 01:08:27.000000', 'temperatura', 465.0000, 'ºC'),
	(211901, 122, '2014-02-15 01:08:28.000000', 'temperatura', 1010.0000, 'ºC'),
	(211902, 122, '2014-02-15 01:08:29.000000', 'temperatura', 55.0000, 'ºC'),
	(211903, 122, '2014-02-15 01:08:30.000000', 'temperatura', 847.0000, 'ºC'),
	(211904, 122, '2014-02-15 01:08:31.000000', 'temperatura', 469.0000, 'ºC'),
	(211905, 122, '2014-02-15 01:08:32.000000', 'temperatura', 1005.0000, 'ºC'),
	(211906, 122, '2014-02-15 01:08:33.000000', 'temperatura', 18.0000, 'ºC'),
	(211907, 122, '2014-02-15 01:08:34.000000', 'temperatura', 676.0000, 'ºC'),
	(211908, 122, '2014-02-15 01:08:35.000000', 'temperatura', 926.0000, 'ºC'),
	(211909, 122, '2014-02-15 01:08:36.000000', 'temperatura', 203.0000, 'ºC'),
	(211910, 122, '2014-02-15 01:08:37.000000', 'temperatura', 637.0000, 'ºC'),
	(211911, 122, '2014-02-15 01:08:38.000000', 'temperatura', 176.0000, 'ºC'),
	(211912, 122, '2014-02-15 01:08:39.000000', 'temperatura', 169.0000, 'ºC'),
	(211913, 122, '2014-02-15 01:08:40.000000', 'temperatura', 317.0000, 'ºC'),
	(211914, 122, '2014-02-15 01:08:41.000000', 'temperatura', 1080.0000, 'ºC'),
	(211915, 122, '2014-02-15 01:08:42.000000', 'temperatura', 851.0000, 'ºC'),
	(211916, 122, '2014-02-15 01:08:43.000000', 'temperatura', 1015.0000, 'ºC'),
	(211917, 122, '2014-02-15 01:08:44.000000', 'temperatura', 121.0000, 'ºC'),
	(211918, 122, '2014-02-15 01:08:45.000000', 'temperatura', 1161.0000, 'ºC'),
	(211919, 122, '2014-02-15 01:08:46.000000', 'temperatura', 643.0000, 'ºC'),
	(211920, 122, '2014-02-15 01:08:47.000000', 'temperatura', 933.0000, 'ºC'),
	(211921, 122, '2014-02-15 01:08:48.000000', 'temperatura', 334.0000, 'ºC'),
	(211922, 122, '2014-02-15 01:08:49.000000', 'temperatura', 74.0000, 'ºC'),
	(211923, 122, '2014-02-15 01:08:50.000000', 'temperatura', 568.0000, 'ºC'),
	(211924, 122, '2014-02-15 01:08:51.000000', 'temperatura', 218.0000, 'ºC'),
	(211925, 122, '2014-02-15 01:08:52.000000', 'temperatura', 586.0000, 'ºC'),
	(211926, 122, '2014-02-15 01:08:53.000000', 'temperatura', 1076.0000, 'ºC'),
	(211927, 122, '2014-02-15 01:08:54.000000', 'temperatura', 23.0000, 'ºC'),
	(211928, 122, '2014-02-15 01:08:55.000000', 'temperatura', 488.0000, 'ºC'),
	(211929, 122, '2014-02-15 01:08:56.000000', 'temperatura', 1172.0000, 'ºC'),
	(211930, 122, '2014-02-15 01:08:57.000000', 'temperatura', 798.0000, 'ºC'),
	(211931, 122, '2014-02-15 01:08:58.000000', 'temperatura', 472.0000, 'ºC'),
	(211932, 122, '2014-02-15 01:08:59.000000', 'temperatura', 1167.0000, 'ºC'),
	(211933, 122, '2014-02-15 01:09:00.000000', 'temperatura', 819.0000, 'ºC'),
	(211934, 122, '2014-02-15 01:09:01.000000', 'temperatura', 596.0000, 'ºC'),
	(211935, 122, '2014-02-15 01:09:02.000000', 'temperatura', 524.0000, 'ºC'),
	(211936, 122, '2014-02-15 01:09:03.000000', 'temperatura', 832.0000, 'ºC'),
	(211937, 122, '2014-02-15 01:09:04.000000', 'temperatura', 189.0000, 'ºC'),
	(211938, 122, '2014-02-15 01:09:05.000000', 'temperatura', 850.0000, 'ºC'),
	(211939, 122, '2014-02-15 01:09:06.000000', 'temperatura', 83.0000, 'ºC'),
	(211940, 122, '2014-02-15 01:09:07.000000', 'temperatura', 265.0000, 'ºC'),
	(211941, 122, '2014-02-15 01:09:08.000000', 'temperatura', 1076.0000, 'ºC'),
	(211942, 122, '2014-02-15 01:09:09.000000', 'temperatura', 987.0000, 'ºC'),
	(211943, 122, '2014-02-15 01:09:10.000000', 'temperatura', 507.0000, 'ºC'),
	(211944, 122, '2014-02-15 01:09:11.000000', 'temperatura', 773.0000, 'ºC'),
	(211945, 122, '2014-02-15 01:09:12.000000', 'temperatura', 1144.0000, 'ºC'),
	(211946, 122, '2014-02-15 01:09:13.000000', 'temperatura', 1002.0000, 'ºC'),
	(211947, 122, '2014-02-15 01:09:14.000000', 'temperatura', 379.0000, 'ºC'),
	(211948, 122, '2014-02-15 01:09:15.000000', 'temperatura', 88.0000, 'ºC'),
	(211949, 122, '2014-02-15 01:09:16.000000', 'temperatura', 506.0000, 'ºC'),
	(211950, 122, '2014-02-15 01:09:17.000000', 'temperatura', 1067.0000, 'ºC'),
	(211951, 122, '2014-02-15 01:09:18.000000', 'temperatura', 215.0000, 'ºC'),
	(211952, 122, '2014-02-15 01:09:19.000000', 'temperatura', 277.0000, 'ºC'),
	(211953, 122, '2014-02-15 01:09:20.000000', 'temperatura', 740.0000, 'ºC'),
	(211954, 122, '2014-02-15 01:09:21.000000', 'temperatura', 468.0000, 'ºC'),
	(211955, 122, '2014-02-15 01:09:22.000000', 'temperatura', 123.0000, 'ºC'),
	(211956, 122, '2014-02-15 01:09:23.000000', 'temperatura', 410.0000, 'ºC'),
	(211957, 122, '2014-02-15 01:09:24.000000', 'temperatura', 481.0000, 'ºC'),
	(211958, 122, '2014-02-15 01:09:25.000000', 'temperatura', 1177.0000, 'ºC'),
	(211959, 122, '2014-02-15 01:09:26.000000', 'temperatura', 840.0000, 'ºC'),
	(211960, 122, '2014-02-15 01:09:27.000000', 'temperatura', 673.0000, 'ºC'),
	(211961, 122, '2014-02-15 01:09:28.000000', 'temperatura', 843.0000, 'ºC'),
	(211962, 122, '2014-02-15 01:09:29.000000', 'temperatura', 999.0000, 'ºC'),
	(211963, 122, '2014-02-15 01:09:30.000000', 'temperatura', 65.0000, 'ºC'),
	(211964, 122, '2014-02-15 01:09:31.000000', 'temperatura', 929.0000, 'ºC'),
	(211965, 122, '2014-02-15 01:09:32.000000', 'temperatura', 848.0000, 'ºC'),
	(211966, 122, '2014-02-15 01:09:33.000000', 'temperatura', 257.0000, 'ºC'),
	(211967, 122, '2014-02-15 01:09:34.000000', 'temperatura', 1139.0000, 'ºC'),
	(211968, 122, '2014-02-15 01:09:35.000000', 'temperatura', 126.0000, 'ºC'),
	(211969, 122, '2014-02-15 01:09:36.000000', 'temperatura', 815.0000, 'ºC'),
	(211970, 122, '2014-02-15 01:09:37.000000', 'temperatura', 95.0000, 'ºC'),
	(211971, 122, '2014-02-15 01:09:38.000000', 'temperatura', 430.0000, 'ºC'),
	(211972, 122, '2014-02-15 01:09:39.000000', 'temperatura', 666.0000, 'ºC'),
	(211973, 122, '2014-02-15 01:09:40.000000', 'temperatura', 842.0000, 'ºC'),
	(211974, 122, '2014-02-15 01:09:41.000000', 'temperatura', 1011.0000, 'ºC'),
	(211975, 122, '2014-02-15 01:09:42.000000', 'temperatura', 130.0000, 'ºC'),
	(211976, 122, '2014-02-15 01:09:43.000000', 'temperatura', 16.0000, 'ºC'),
	(211977, 122, '2014-02-15 01:09:44.000000', 'temperatura', 894.0000, 'ºC'),
	(211978, 122, '2014-02-15 01:09:45.000000', 'temperatura', 819.0000, 'ºC'),
	(211979, 122, '2014-02-15 01:09:46.000000', 'temperatura', 214.0000, 'ºC'),
	(211980, 122, '2014-02-15 01:09:47.000000', 'temperatura', 1014.0000, 'ºC'),
	(211981, 122, '2014-02-15 01:09:48.000000', 'temperatura', 830.0000, 'ºC'),
	(211982, 122, '2014-02-15 01:09:49.000000', 'temperatura', 1108.0000, 'ºC'),
	(211983, 122, '2014-02-15 01:09:50.000000', 'temperatura', 648.0000, 'ºC'),
	(211984, 122, '2014-02-15 01:09:51.000000', 'temperatura', 1119.0000, 'ºC'),
	(211985, 122, '2014-02-15 01:09:52.000000', 'temperatura', 49.0000, 'ºC'),
	(211986, 122, '2014-02-15 01:09:53.000000', 'temperatura', 490.0000, 'ºC'),
	(211987, 122, '2014-02-15 01:09:54.000000', 'temperatura', 1105.0000, 'ºC'),
	(211988, 122, '2014-02-15 01:09:55.000000', 'temperatura', 454.0000, 'ºC'),
	(211989, 122, '2014-02-15 01:09:56.000000', 'temperatura', 156.0000, 'ºC'),
	(211990, 122, '2014-02-15 01:09:57.000000', 'temperatura', 617.0000, 'ºC'),
	(211991, 122, '2014-02-15 01:09:58.000000', 'temperatura', 216.0000, 'ºC'),
	(211992, 122, '2014-02-15 01:09:59.000000', 'temperatura', 433.0000, 'ºC'),
	(211993, 122, '2014-02-15 01:10:00.000000', 'temperatura', 316.0000, 'ºC'),
	(211994, 122, '2014-02-15 01:10:01.000000', 'temperatura', 282.0000, 'ºC'),
	(211995, 122, '2014-02-15 01:10:02.000000', 'temperatura', 463.0000, 'ºC'),
	(211996, 122, '2014-02-15 01:10:03.000000', 'temperatura', 267.0000, 'ºC'),
	(211997, 122, '2014-02-15 01:10:04.000000', 'temperatura', 1150.0000, 'ºC'),
	(211998, 122, '2014-02-15 01:10:05.000000', 'temperatura', 147.0000, 'ºC'),
	(211999, 122, '2014-02-15 01:10:06.000000', 'temperatura', 885.0000, 'ºC'),
	(212000, 122, '2014-02-15 01:10:07.000000', 'temperatura', 386.0000, 'ºC'),
	(212001, 122, '2014-02-15 01:10:08.000000', 'temperatura', 475.0000, 'ºC'),
	(212002, 122, '2014-02-15 01:10:09.000000', 'temperatura', 16.0000, 'ºC'),
	(212003, 122, '2014-02-15 01:10:10.000000', 'temperatura', 1058.0000, 'ºC'),
	(212004, 122, '2014-02-15 01:10:11.000000', 'temperatura', 439.0000, 'ºC'),
	(212005, 122, '2014-02-15 01:10:12.000000', 'temperatura', 225.0000, 'ºC'),
	(212006, 122, '2014-02-15 01:10:13.000000', 'temperatura', 1007.0000, 'ºC'),
	(212007, 122, '2014-02-15 01:10:14.000000', 'temperatura', 759.0000, 'ºC'),
	(212008, 122, '2014-02-15 01:10:15.000000', 'temperatura', 775.0000, 'ºC'),
	(212009, 122, '2014-02-15 01:10:16.000000', 'temperatura', 397.0000, 'ºC'),
	(212010, 122, '2014-02-15 01:10:17.000000', 'temperatura', 863.0000, 'ºC'),
	(212011, 122, '2014-02-15 01:10:18.000000', 'temperatura', 725.0000, 'ºC'),
	(212012, 122, '2014-02-15 01:10:19.000000', 'temperatura', 1035.0000, 'ºC'),
	(212013, 122, '2014-02-15 01:10:20.000000', 'temperatura', 602.0000, 'ºC'),
	(212014, 122, '2014-02-15 01:10:21.000000', 'temperatura', 1106.0000, 'ºC'),
	(212015, 122, '2014-02-15 01:10:22.000000', 'temperatura', 126.0000, 'ºC'),
	(212016, 122, '2014-02-15 01:10:23.000000', 'temperatura', 909.0000, 'ºC'),
	(212017, 122, '2014-02-15 01:10:24.000000', 'temperatura', 571.0000, 'ºC'),
	(212018, 122, '2014-02-15 01:10:25.000000', 'temperatura', 126.0000, 'ºC'),
	(212019, 122, '2014-02-15 01:10:26.000000', 'temperatura', 120.0000, 'ºC'),
	(212020, 122, '2014-02-15 01:10:27.000000', 'temperatura', 220.0000, 'ºC'),
	(212021, 122, '2014-02-15 01:10:28.000000', 'temperatura', 741.0000, 'ºC'),
	(212022, 122, '2014-02-15 01:10:29.000000', 'temperatura', 646.0000, 'ºC'),
	(212023, 122, '2014-02-15 01:10:30.000000', 'temperatura', 1008.0000, 'ºC'),
	(212024, 122, '2014-02-15 01:10:31.000000', 'temperatura', 700.0000, 'ºC'),
	(212025, 122, '2014-02-15 01:10:32.000000', 'temperatura', 480.0000, 'ºC'),
	(212026, 122, '2014-02-15 01:10:33.000000', 'temperatura', 298.0000, 'ºC'),
	(212027, 122, '2014-02-15 01:10:34.000000', 'temperatura', 50.0000, 'ºC'),
	(212028, 122, '2014-02-15 01:10:35.000000', 'temperatura', 556.0000, 'ºC'),
	(212029, 122, '2014-02-15 01:10:36.000000', 'temperatura', 230.0000, 'ºC'),
	(212030, 122, '2014-02-15 01:10:37.000000', 'temperatura', 685.0000, 'ºC'),
	(212031, 122, '2014-02-15 01:10:38.000000', 'temperatura', 335.0000, 'ºC'),
	(212032, 122, '2014-02-15 01:10:39.000000', 'temperatura', 821.0000, 'ºC'),
	(212033, 122, '2014-02-15 01:10:40.000000', 'temperatura', 700.0000, 'ºC'),
	(212034, 122, '2014-02-15 01:10:41.000000', 'temperatura', 1039.0000, 'ºC'),
	(212035, 122, '2014-02-15 01:10:42.000000', 'temperatura', 693.0000, 'ºC'),
	(212036, 122, '2014-02-15 01:10:43.000000', 'temperatura', 349.0000, 'ºC'),
	(212037, 122, '2014-02-15 01:10:44.000000', 'temperatura', 866.0000, 'ºC'),
	(212038, 122, '2014-02-15 01:10:45.000000', 'temperatura', 885.0000, 'ºC'),
	(212039, 122, '2014-02-15 01:10:46.000000', 'temperatura', 628.0000, 'ºC'),
	(212040, 122, '2014-02-15 01:10:47.000000', 'temperatura', 484.0000, 'ºC'),
	(212041, 122, '2014-02-15 01:10:48.000000', 'temperatura', 537.0000, 'ºC'),
	(212042, 122, '2014-02-15 01:10:49.000000', 'temperatura', 35.0000, 'ºC'),
	(212043, 122, '2014-02-15 01:10:50.000000', 'temperatura', 964.0000, 'ºC'),
	(212044, 122, '2014-02-15 01:10:51.000000', 'temperatura', 1113.0000, 'ºC'),
	(212045, 122, '2014-02-15 01:10:52.000000', 'temperatura', 277.0000, 'ºC'),
	(212046, 122, '2014-02-15 01:10:53.000000', 'temperatura', 443.0000, 'ºC'),
	(212047, 122, '2014-02-15 01:10:54.000000', 'temperatura', 188.0000, 'ºC'),
	(212048, 122, '2014-02-15 01:10:55.000000', 'temperatura', 809.0000, 'ºC'),
	(212049, 122, '2014-02-15 01:10:56.000000', 'temperatura', 1084.0000, 'ºC'),
	(212050, 122, '2014-02-15 01:10:57.000000', 'temperatura', 591.0000, 'ºC'),
	(212051, 122, '2014-02-15 01:10:58.000000', 'temperatura', 905.0000, 'ºC'),
	(212052, 122, '2014-02-15 01:10:59.000000', 'temperatura', 354.0000, 'ºC'),
	(212053, 122, '2014-02-15 01:11:00.000000', 'temperatura', 253.0000, 'ºC'),
	(212054, 122, '2014-02-15 01:11:01.000000', 'temperatura', 203.0000, 'ºC'),
	(212055, 122, '2014-02-15 01:11:02.000000', 'temperatura', 258.0000, 'ºC'),
	(212056, 122, '2014-02-15 01:11:03.000000', 'temperatura', 680.0000, 'ºC'),
	(212057, 122, '2014-02-15 01:11:04.000000', 'temperatura', 227.0000, 'ºC'),
	(212058, 122, '2014-02-15 01:11:05.000000', 'temperatura', 296.0000, 'ºC'),
	(212059, 122, '2014-02-15 01:11:06.000000', 'temperatura', 800.0000, 'ºC'),
	(212060, 122, '2014-02-15 01:11:07.000000', 'temperatura', 713.0000, 'ºC'),
	(212061, 122, '2014-02-15 01:11:08.000000', 'temperatura', 1164.0000, 'ºC'),
	(212062, 122, '2014-02-15 01:11:09.000000', 'temperatura', 84.0000, 'ºC'),
	(212063, 122, '2014-02-15 01:11:10.000000', 'temperatura', 528.0000, 'ºC'),
	(212064, 122, '2014-02-15 01:11:11.000000', 'temperatura', 1186.0000, 'ºC'),
	(212065, 122, '2014-02-15 01:11:12.000000', 'temperatura', 750.0000, 'ºC'),
	(212066, 122, '2014-02-15 01:11:13.000000', 'temperatura', 191.0000, 'ºC'),
	(212067, 122, '2014-02-15 01:11:14.000000', 'temperatura', 1105.0000, 'ºC'),
	(212068, 122, '2014-02-15 01:11:15.000000', 'temperatura', 152.0000, 'ºC'),
	(212069, 122, '2014-02-15 01:11:16.000000', 'temperatura', 1047.0000, 'ºC'),
	(212070, 122, '2014-02-15 01:11:17.000000', 'temperatura', 1177.0000, 'ºC'),
	(212071, 122, '2014-02-15 01:11:18.000000', 'temperatura', 345.0000, 'ºC'),
	(212072, 122, '2014-02-15 01:11:19.000000', 'temperatura', 595.0000, 'ºC'),
	(212073, 122, '2014-02-15 01:11:20.000000', 'temperatura', 739.0000, 'ºC'),
	(212074, 122, '2014-02-15 01:11:21.000000', 'temperatura', 712.0000, 'ºC'),
	(212075, 122, '2014-02-15 01:11:22.000000', 'temperatura', 143.0000, 'ºC'),
	(212076, 122, '2014-02-15 01:11:23.000000', 'temperatura', 980.0000, 'ºC'),
	(212077, 122, '2014-02-15 01:11:24.000000', 'temperatura', 870.0000, 'ºC'),
	(212078, 122, '2014-02-15 01:11:25.000000', 'temperatura', 213.0000, 'ºC'),
	(212079, 122, '2014-02-15 01:11:26.000000', 'temperatura', 854.0000, 'ºC'),
	(212080, 122, '2014-02-15 01:11:27.000000', 'temperatura', 30.0000, 'ºC'),
	(212081, 122, '2014-02-15 01:11:28.000000', 'temperatura', 1188.0000, 'ºC'),
	(212082, 122, '2014-02-15 01:11:29.000000', 'temperatura', 1052.0000, 'ºC'),
	(212083, 122, '2014-02-15 01:11:30.000000', 'temperatura', 498.0000, 'ºC'),
	(212084, 122, '2014-02-15 01:11:31.000000', 'temperatura', 533.0000, 'ºC'),
	(212085, 122, '2014-02-15 01:11:32.000000', 'temperatura', 1173.0000, 'ºC'),
	(212086, 122, '2014-02-15 01:11:33.000000', 'temperatura', 667.0000, 'ºC'),
	(212087, 122, '2014-02-15 01:11:34.000000', 'temperatura', 1015.0000, 'ºC'),
	(212088, 122, '2014-02-15 01:11:35.000000', 'temperatura', 674.0000, 'ºC'),
	(212089, 122, '2014-02-15 01:11:36.000000', 'temperatura', 324.0000, 'ºC'),
	(212090, 122, '2014-02-15 01:11:37.000000', 'temperatura', 800.0000, 'ºC'),
	(212091, 122, '2014-02-15 01:11:38.000000', 'temperatura', 628.0000, 'ºC'),
	(212092, 122, '2014-02-15 01:11:39.000000', 'temperatura', 739.0000, 'ºC'),
	(212093, 122, '2014-02-15 01:11:40.000000', 'temperatura', 612.0000, 'ºC'),
	(212094, 122, '2014-02-15 01:11:41.000000', 'temperatura', 845.0000, 'ºC'),
	(212095, 122, '2014-02-15 01:11:42.000000', 'temperatura', 1191.0000, 'ºC'),
	(212096, 122, '2014-02-15 01:11:43.000000', 'temperatura', 1018.0000, 'ºC'),
	(212097, 122, '2014-02-15 01:11:44.000000', 'temperatura', 319.0000, 'ºC'),
	(212098, 122, '2014-02-15 01:11:45.000000', 'temperatura', 941.0000, 'ºC'),
	(212099, 122, '2014-02-15 01:11:46.000000', 'temperatura', 149.0000, 'ºC'),
	(212100, 122, '2014-02-15 01:11:47.000000', 'temperatura', 323.0000, 'ºC'),
	(212101, 122, '2014-02-15 01:11:48.000000', 'temperatura', 1169.0000, 'ºC'),
	(212102, 122, '2014-02-15 01:11:49.000000', 'temperatura', 74.0000, 'ºC'),
	(212103, 122, '2014-02-15 01:11:50.000000', 'temperatura', 464.0000, 'ºC'),
	(212104, 122, '2014-02-15 01:11:51.000000', 'temperatura', 901.0000, 'ºC'),
	(212105, 122, '2014-02-15 01:11:52.000000', 'temperatura', 710.0000, 'ºC'),
	(212106, 122, '2014-02-15 01:11:53.000000', 'temperatura', 850.0000, 'ºC'),
	(212107, 122, '2014-02-15 01:11:54.000000', 'temperatura', 919.0000, 'ºC'),
	(212108, 122, '2014-02-15 01:11:55.000000', 'temperatura', 848.0000, 'ºC'),
	(212109, 122, '2014-02-15 01:11:56.000000', 'temperatura', 281.0000, 'ºC'),
	(212110, 122, '2014-02-15 01:11:57.000000', 'temperatura', 61.0000, 'ºC'),
	(212111, 122, '2014-02-15 01:11:58.000000', 'temperatura', 662.0000, 'ºC'),
	(212112, 122, '2014-02-15 01:11:59.000000', 'temperatura', 727.0000, 'ºC'),
	(212113, 122, '2014-02-15 01:12:00.000000', 'temperatura', 452.0000, 'ºC'),
	(212114, 122, '2014-02-15 01:12:01.000000', 'temperatura', 78.0000, 'ºC'),
	(212115, 122, '2014-02-15 01:12:02.000000', 'temperatura', 235.0000, 'ºC'),
	(212116, 122, '2014-02-15 01:12:03.000000', 'temperatura', 943.0000, 'ºC'),
	(212117, 122, '2014-02-15 01:12:04.000000', 'temperatura', 408.0000, 'ºC'),
	(212118, 122, '2014-02-15 01:12:05.000000', 'temperatura', 413.0000, 'ºC'),
	(212119, 122, '2014-02-15 01:12:06.000000', 'temperatura', 841.0000, 'ºC'),
	(212120, 122, '2014-02-15 01:12:07.000000', 'temperatura', 565.0000, 'ºC'),
	(212121, 122, '2014-02-15 01:12:08.000000', 'temperatura', 304.0000, 'ºC'),
	(212122, 122, '2014-02-15 01:12:09.000000', 'temperatura', 1025.0000, 'ºC'),
	(212123, 122, '2014-02-15 01:12:10.000000', 'temperatura', 612.0000, 'ºC'),
	(212124, 122, '2014-02-15 01:12:11.000000', 'temperatura', 1185.0000, 'ºC'),
	(212125, 122, '2014-02-15 01:12:12.000000', 'temperatura', 491.0000, 'ºC'),
	(212126, 122, '2014-02-15 01:12:13.000000', 'temperatura', 101.0000, 'ºC'),
	(212127, 122, '2014-02-15 01:12:14.000000', 'temperatura', 231.0000, 'ºC'),
	(212128, 122, '2014-02-15 01:12:15.000000', 'temperatura', 852.0000, 'ºC'),
	(212129, 122, '2014-02-15 01:12:16.000000', 'temperatura', 1168.0000, 'ºC'),
	(212130, 122, '2014-02-15 01:12:17.000000', 'temperatura', 886.0000, 'ºC'),
	(212131, 122, '2014-02-15 01:12:18.000000', 'temperatura', 925.0000, 'ºC'),
	(212132, 122, '2014-02-15 01:12:19.000000', 'temperatura', 767.0000, 'ºC'),
	(212133, 122, '2014-02-15 01:12:20.000000', 'temperatura', 1062.0000, 'ºC'),
	(212134, 122, '2014-02-15 01:12:21.000000', 'temperatura', 608.0000, 'ºC'),
	(212135, 122, '2014-02-15 01:12:22.000000', 'temperatura', 1055.0000, 'ºC'),
	(212136, 122, '2014-02-15 01:12:23.000000', 'temperatura', 1050.0000, 'ºC'),
	(212137, 122, '2014-02-15 01:12:24.000000', 'temperatura', 885.0000, 'ºC'),
	(212138, 122, '2014-02-15 01:12:25.000000', 'temperatura', 76.0000, 'ºC'),
	(212139, 122, '2014-02-15 01:12:26.000000', 'temperatura', 124.0000, 'ºC'),
	(212140, 122, '2014-02-15 01:12:27.000000', 'temperatura', 394.0000, 'ºC'),
	(212141, 122, '2014-02-15 01:12:28.000000', 'temperatura', 398.0000, 'ºC'),
	(212142, 122, '2014-02-15 01:12:29.000000', 'temperatura', 807.0000, 'ºC'),
	(212143, 122, '2014-02-15 01:12:30.000000', 'temperatura', 443.0000, 'ºC'),
	(212144, 122, '2014-02-15 01:12:31.000000', 'temperatura', 994.0000, 'ºC'),
	(212145, 122, '2014-02-15 01:12:32.000000', 'temperatura', 41.0000, 'ºC'),
	(212146, 122, '2014-02-15 01:12:33.000000', 'temperatura', 824.0000, 'ºC'),
	(212147, 122, '2014-02-15 01:12:34.000000', 'temperatura', 398.0000, 'ºC'),
	(212148, 122, '2014-02-15 01:12:35.000000', 'temperatura', 718.0000, 'ºC'),
	(212149, 122, '2014-02-15 01:12:36.000000', 'temperatura', 1199.0000, 'ºC'),
	(212150, 122, '2014-02-15 01:12:37.000000', 'temperatura', 238.0000, 'ºC'),
	(212151, 122, '2014-02-15 01:12:38.000000', 'temperatura', 1194.0000, 'ºC'),
	(212152, 122, '2014-02-15 01:12:39.000000', 'temperatura', 456.0000, 'ºC'),
	(212153, 122, '2014-02-15 01:12:40.000000', 'temperatura', 1099.0000, 'ºC'),
	(212154, 122, '2014-02-15 01:12:41.000000', 'temperatura', 529.0000, 'ºC'),
	(212155, 122, '2014-02-15 01:12:42.000000', 'temperatura', 546.0000, 'ºC'),
	(212156, 122, '2014-02-15 01:12:43.000000', 'temperatura', 1146.0000, 'ºC'),
	(212157, 122, '2014-02-15 01:12:44.000000', 'temperatura', 490.0000, 'ºC'),
	(212158, 122, '2014-02-15 01:12:45.000000', 'temperatura', 212.0000, 'ºC'),
	(212159, 122, '2014-02-15 01:12:46.000000', 'temperatura', 791.0000, 'ºC'),
	(212160, 122, '2014-02-15 01:12:47.000000', 'temperatura', 919.0000, 'ºC'),
	(212161, 122, '2014-02-15 01:12:48.000000', 'temperatura', 1022.0000, 'ºC'),
	(212162, 122, '2014-02-15 01:12:49.000000', 'temperatura', 1156.0000, 'ºC'),
	(212163, 122, '2014-02-15 01:12:50.000000', 'temperatura', 314.0000, 'ºC'),
	(212164, 122, '2014-02-15 01:12:51.000000', 'temperatura', 503.0000, 'ºC'),
	(212165, 122, '2014-02-15 01:12:52.000000', 'temperatura', 372.0000, 'ºC'),
	(212166, 122, '2014-02-15 01:12:53.000000', 'temperatura', 350.0000, 'ºC'),
	(212167, 122, '2014-02-15 01:12:54.000000', 'temperatura', 638.0000, 'ºC'),
	(212168, 122, '2014-02-15 01:12:55.000000', 'temperatura', 938.0000, 'ºC'),
	(212169, 122, '2014-02-15 01:12:56.000000', 'temperatura', 376.0000, 'ºC'),
	(212170, 122, '2014-02-15 01:12:57.000000', 'temperatura', 268.0000, 'ºC'),
	(212171, 122, '2014-02-15 01:12:58.000000', 'temperatura', 210.0000, 'ºC'),
	(212172, 122, '2014-02-15 01:12:59.000000', 'temperatura', 248.0000, 'ºC'),
	(212173, 122, '2014-02-15 01:13:00.000000', 'temperatura', 609.0000, 'ºC'),
	(212174, 122, '2014-02-15 01:13:01.000000', 'temperatura', 1103.0000, 'ºC'),
	(212175, 122, '2014-02-15 01:13:02.000000', 'temperatura', 89.0000, 'ºC'),
	(212176, 122, '2014-02-15 01:13:03.000000', 'temperatura', 737.0000, 'ºC'),
	(212177, 122, '2014-02-15 01:13:04.000000', 'temperatura', 1018.0000, 'ºC'),
	(212178, 122, '2014-02-15 01:13:05.000000', 'temperatura', 478.0000, 'ºC'),
	(212179, 122, '2014-02-15 01:13:06.000000', 'temperatura', 539.0000, 'ºC'),
	(212180, 122, '2014-02-15 01:13:07.000000', 'temperatura', 60.0000, 'ºC'),
	(212181, 122, '2014-02-15 01:13:08.000000', 'temperatura', 1083.0000, 'ºC'),
	(212182, 122, '2014-02-15 01:13:09.000000', 'temperatura', 435.0000, 'ºC'),
	(212183, 122, '2014-02-15 01:13:10.000000', 'temperatura', 128.0000, 'ºC'),
	(212184, 122, '2014-02-15 01:13:11.000000', 'temperatura', 535.0000, 'ºC'),
	(212185, 122, '2014-02-15 01:13:12.000000', 'temperatura', 1089.0000, 'ºC'),
	(212186, 122, '2014-02-15 01:13:13.000000', 'temperatura', 244.0000, 'ºC'),
	(212187, 122, '2014-02-15 01:13:14.000000', 'temperatura', 354.0000, 'ºC'),
	(212188, 122, '2014-02-15 01:13:15.000000', 'temperatura', 1036.0000, 'ºC'),
	(212189, 122, '2014-02-15 01:13:16.000000', 'temperatura', 520.0000, 'ºC'),
	(212190, 122, '2014-02-15 01:13:17.000000', 'temperatura', 690.0000, 'ºC'),
	(212191, 122, '2014-02-15 01:13:18.000000', 'temperatura', 693.0000, 'ºC'),
	(212192, 122, '2014-02-15 01:13:19.000000', 'temperatura', 193.0000, 'ºC'),
	(212193, 122, '2014-02-15 01:13:20.000000', 'temperatura', 88.0000, 'ºC'),
	(212194, 122, '2014-02-15 01:13:21.000000', 'temperatura', 1062.0000, 'ºC'),
	(212195, 122, '2014-02-15 01:13:22.000000', 'temperatura', 245.0000, 'ºC'),
	(212196, 122, '2014-02-15 01:13:23.000000', 'temperatura', 441.0000, 'ºC'),
	(212197, 122, '2014-02-15 01:13:24.000000', 'temperatura', 269.0000, 'ºC'),
	(212198, 122, '2014-02-15 01:13:25.000000', 'temperatura', 24.0000, 'ºC'),
	(212199, 122, '2014-02-15 01:13:26.000000', 'temperatura', 512.0000, 'ºC'),
	(212200, 122, '2014-02-15 01:13:27.000000', 'temperatura', 91.0000, 'ºC'),
	(212201, 122, '2014-02-15 01:13:28.000000', 'temperatura', 116.0000, 'ºC'),
	(212202, 122, '2014-02-15 01:13:29.000000', 'temperatura', 309.0000, 'ºC'),
	(212203, 122, '2014-02-15 01:13:30.000000', 'temperatura', 1199.0000, 'ºC'),
	(212204, 122, '2014-02-15 01:13:31.000000', 'temperatura', 268.0000, 'ºC'),
	(212205, 122, '2014-02-15 01:13:32.000000', 'temperatura', 145.0000, 'ºC'),
	(212206, 122, '2014-02-15 01:13:33.000000', 'temperatura', 1121.0000, 'ºC'),
	(212207, 122, '2014-02-15 01:13:34.000000', 'temperatura', 371.0000, 'ºC'),
	(212208, 122, '2014-02-15 01:13:35.000000', 'temperatura', 891.0000, 'ºC'),
	(212209, 122, '2014-02-15 01:13:36.000000', 'temperatura', 943.0000, 'ºC'),
	(212210, 122, '2014-02-15 01:13:37.000000', 'temperatura', 841.0000, 'ºC'),
	(212211, 122, '2014-02-15 01:13:38.000000', 'temperatura', 179.0000, 'ºC'),
	(212212, 122, '2014-02-15 01:13:39.000000', 'temperatura', 770.0000, 'ºC'),
	(212213, 122, '2014-02-15 01:13:40.000000', 'temperatura', 914.0000, 'ºC'),
	(212214, 122, '2014-02-15 01:13:41.000000', 'temperatura', 1060.0000, 'ºC'),
	(212215, 122, '2014-02-15 01:13:42.000000', 'temperatura', 160.0000, 'ºC'),
	(212216, 122, '2014-02-15 01:13:43.000000', 'temperatura', 20.0000, 'ºC'),
	(212217, 122, '2014-02-15 01:13:44.000000', 'temperatura', 820.0000, 'ºC'),
	(212218, 122, '2014-02-15 01:13:45.000000', 'temperatura', 441.0000, 'ºC'),
	(212219, 122, '2014-02-15 01:13:46.000000', 'temperatura', 944.0000, 'ºC'),
	(212220, 122, '2014-02-15 01:13:47.000000', 'temperatura', 999.0000, 'ºC'),
	(212221, 122, '2014-02-15 01:13:48.000000', 'temperatura', 961.0000, 'ºC'),
	(212222, 122, '2014-02-15 01:13:49.000000', 'temperatura', 611.0000, 'ºC'),
	(212223, 122, '2014-02-15 01:13:50.000000', 'temperatura', 173.0000, 'ºC'),
	(212224, 122, '2014-02-15 01:13:51.000000', 'temperatura', 233.0000, 'ºC'),
	(212225, 122, '2014-02-15 01:13:52.000000', 'temperatura', 647.0000, 'ºC'),
	(212226, 122, '2014-02-15 01:13:53.000000', 'temperatura', 135.0000, 'ºC'),
	(212227, 122, '2014-02-15 01:13:54.000000', 'temperatura', 1136.0000, 'ºC'),
	(212228, 122, '2014-02-15 01:13:55.000000', 'temperatura', 475.0000, 'ºC'),
	(212229, 122, '2014-02-15 01:13:56.000000', 'temperatura', 168.0000, 'ºC'),
	(212230, 122, '2014-02-15 01:13:57.000000', 'temperatura', 617.0000, 'ºC'),
	(212231, 122, '2014-02-15 01:13:58.000000', 'temperatura', 178.0000, 'ºC'),
	(212232, 122, '2014-02-15 01:13:59.000000', 'temperatura', 242.0000, 'ºC'),
	(212233, 122, '2014-02-15 01:14:00.000000', 'temperatura', 674.0000, 'ºC'),
	(212234, 122, '2014-02-15 01:14:01.000000', 'temperatura', 245.0000, 'ºC'),
	(212235, 122, '2014-02-15 01:14:02.000000', 'temperatura', 404.0000, 'ºC'),
	(212236, 122, '2014-02-15 01:14:03.000000', 'temperatura', 86.0000, 'ºC'),
	(212237, 122, '2014-02-15 01:14:04.000000', 'temperatura', 418.0000, 'ºC'),
	(212238, 122, '2014-02-15 01:14:05.000000', 'temperatura', 632.0000, 'ºC'),
	(212239, 122, '2014-02-15 01:14:06.000000', 'temperatura', 708.0000, 'ºC'),
	(212240, 122, '2014-02-15 01:14:07.000000', 'temperatura', 444.0000, 'ºC'),
	(212241, 122, '2014-02-15 01:14:08.000000', 'temperatura', 97.0000, 'ºC'),
	(212242, 122, '2014-02-15 01:14:09.000000', 'temperatura', 352.0000, 'ºC'),
	(212243, 122, '2014-02-15 01:14:10.000000', 'temperatura', 272.0000, 'ºC'),
	(212244, 122, '2014-02-15 01:14:11.000000', 'temperatura', 302.0000, 'ºC'),
	(212245, 122, '2014-02-15 01:14:12.000000', 'temperatura', 696.0000, 'ºC'),
	(212246, 122, '2014-02-15 01:14:13.000000', 'temperatura', 173.0000, 'ºC'),
	(212247, 122, '2014-02-15 01:14:14.000000', 'temperatura', 1179.0000, 'ºC'),
	(212248, 122, '2014-02-15 01:14:15.000000', 'temperatura', 578.0000, 'ºC'),
	(212249, 122, '2014-02-15 01:14:16.000000', 'temperatura', 552.0000, 'ºC'),
	(212250, 122, '2014-02-15 01:14:17.000000', 'temperatura', 1026.0000, 'ºC'),
	(212251, 122, '2014-02-15 01:14:18.000000', 'temperatura', 1076.0000, 'ºC'),
	(212252, 122, '2014-02-15 01:14:19.000000', 'temperatura', 1100.0000, 'ºC'),
	(212253, 122, '2014-02-15 01:14:20.000000', 'temperatura', 1075.0000, 'ºC'),
	(212254, 122, '2014-02-15 01:14:21.000000', 'temperatura', 873.0000, 'ºC'),
	(212255, 122, '2014-02-15 01:14:22.000000', 'temperatura', 1144.0000, 'ºC'),
	(212256, 122, '2014-02-15 01:14:23.000000', 'temperatura', 698.0000, 'ºC'),
	(212257, 122, '2014-02-15 01:14:24.000000', 'temperatura', 60.0000, 'ºC'),
	(212258, 122, '2014-02-15 01:14:25.000000', 'temperatura', 607.0000, 'ºC'),
	(212259, 122, '2014-02-15 01:14:26.000000', 'temperatura', 453.0000, 'ºC'),
	(212260, 122, '2014-02-15 01:14:27.000000', 'temperatura', 447.0000, 'ºC'),
	(212261, 122, '2014-02-15 01:14:28.000000', 'temperatura', 878.0000, 'ºC'),
	(212262, 122, '2014-02-15 01:14:29.000000', 'temperatura', 647.0000, 'ºC'),
	(212263, 122, '2014-02-15 01:14:30.000000', 'temperatura', 602.0000, 'ºC'),
	(212264, 122, '2014-02-15 01:14:31.000000', 'temperatura', 1072.0000, 'ºC'),
	(212265, 122, '2014-02-15 01:14:32.000000', 'temperatura', 1151.0000, 'ºC'),
	(212266, 122, '2014-02-15 01:14:33.000000', 'temperatura', 141.0000, 'ºC'),
	(212267, 122, '2014-02-15 01:14:34.000000', 'temperatura', 853.0000, 'ºC'),
	(212268, 122, '2014-02-15 01:14:35.000000', 'temperatura', 243.0000, 'ºC'),
	(212269, 122, '2014-02-15 01:14:36.000000', 'temperatura', 1057.0000, 'ºC'),
	(212270, 122, '2014-02-15 01:14:37.000000', 'temperatura', 955.0000, 'ºC'),
	(212271, 122, '2014-02-15 01:14:38.000000', 'temperatura', 406.0000, 'ºC'),
	(212272, 122, '2014-02-15 01:14:39.000000', 'temperatura', 365.0000, 'ºC'),
	(212273, 122, '2014-02-15 01:14:40.000000', 'temperatura', 608.0000, 'ºC'),
	(212274, 122, '2014-02-15 01:14:41.000000', 'temperatura', 745.0000, 'ºC'),
	(212275, 122, '2014-02-15 01:14:42.000000', 'temperatura', 703.0000, 'ºC'),
	(212276, 122, '2014-02-15 01:14:43.000000', 'temperatura', 80.0000, 'ºC'),
	(212277, 122, '2014-02-15 01:14:44.000000', 'temperatura', 691.0000, 'ºC'),
	(212278, 122, '2014-02-15 01:14:45.000000', 'temperatura', 815.0000, 'ºC'),
	(212279, 122, '2014-02-15 01:14:46.000000', 'temperatura', 802.0000, 'ºC'),
	(212280, 122, '2014-02-15 01:14:47.000000', 'temperatura', 366.0000, 'ºC'),
	(212281, 122, '2014-02-15 01:14:48.000000', 'temperatura', 624.0000, 'ºC'),
	(212282, 122, '2014-02-15 01:14:49.000000', 'temperatura', 823.0000, 'ºC'),
	(212283, 122, '2014-02-15 01:14:50.000000', 'temperatura', 1043.0000, 'ºC'),
	(212284, 122, '2014-02-15 01:14:51.000000', 'temperatura', 349.0000, 'ºC'),
	(212285, 122, '2014-02-15 01:14:52.000000', 'temperatura', 1015.0000, 'ºC'),
	(212286, 122, '2014-02-15 01:14:53.000000', 'temperatura', 427.0000, 'ºC'),
	(212287, 122, '2014-02-15 01:14:54.000000', 'temperatura', 292.0000, 'ºC'),
	(212288, 122, '2014-02-15 01:14:55.000000', 'temperatura', 178.0000, 'ºC'),
	(212289, 122, '2014-02-15 01:14:56.000000', 'temperatura', 14.0000, 'ºC'),
	(212290, 122, '2014-02-15 01:14:57.000000', 'temperatura', 738.0000, 'ºC'),
	(212291, 122, '2014-02-15 01:14:58.000000', 'temperatura', 49.0000, 'ºC'),
	(212292, 122, '2014-02-15 01:14:59.000000', 'temperatura', 433.0000, 'ºC'),
	(212293, 122, '2014-02-15 01:15:00.000000', 'temperatura', 815.0000, 'ºC'),
	(212294, 122, '2014-02-15 01:15:01.000000', 'temperatura', 378.0000, 'ºC'),
	(212295, 122, '2014-02-15 01:15:02.000000', 'temperatura', 645.0000, 'ºC'),
	(212296, 122, '2014-02-15 01:15:03.000000', 'temperatura', 891.0000, 'ºC'),
	(212297, 122, '2014-02-15 01:15:04.000000', 'temperatura', 120.0000, 'ºC'),
	(212298, 122, '2014-02-15 01:15:05.000000', 'temperatura', 329.0000, 'ºC'),
	(212299, 122, '2014-02-15 01:15:06.000000', 'temperatura', 87.0000, 'ºC'),
	(212300, 122, '2014-02-15 01:15:07.000000', 'temperatura', 647.0000, 'ºC'),
	(212301, 122, '2014-02-15 01:15:08.000000', 'temperatura', 575.0000, 'ºC'),
	(212302, 122, '2014-02-15 01:15:09.000000', 'temperatura', 935.0000, 'ºC'),
	(212303, 122, '2014-02-15 01:15:10.000000', 'temperatura', 549.0000, 'ºC'),
	(212304, 122, '2014-02-15 01:15:11.000000', 'temperatura', 1140.0000, 'ºC'),
	(212305, 122, '2014-02-15 01:15:12.000000', 'temperatura', 454.0000, 'ºC'),
	(212306, 122, '2014-02-15 01:15:13.000000', 'temperatura', 53.0000, 'ºC'),
	(212307, 122, '2014-02-15 01:15:14.000000', 'temperatura', 101.0000, 'ºC'),
	(212308, 122, '2014-02-15 01:15:15.000000', 'temperatura', 348.0000, 'ºC'),
	(212309, 122, '2014-02-15 01:15:16.000000', 'temperatura', 236.0000, 'ºC'),
	(212310, 122, '2014-02-15 01:15:17.000000', 'temperatura', 137.0000, 'ºC'),
	(212311, 122, '2014-02-15 01:15:18.000000', 'temperatura', 1178.0000, 'ºC'),
	(212312, 122, '2014-02-15 01:15:19.000000', 'temperatura', 679.0000, 'ºC'),
	(212313, 122, '2014-02-15 01:15:20.000000', 'temperatura', 1063.0000, 'ºC'),
	(212314, 122, '2014-02-15 01:15:21.000000', 'temperatura', 877.0000, 'ºC'),
	(212315, 122, '2014-02-15 01:15:22.000000', 'temperatura', 1198.0000, 'ºC'),
	(212316, 122, '2014-02-15 01:15:23.000000', 'temperatura', 960.0000, 'ºC'),
	(212317, 122, '2014-02-15 01:15:24.000000', 'temperatura', 6.0000, 'ºC'),
	(212318, 122, '2014-02-15 01:15:25.000000', 'temperatura', 750.0000, 'ºC'),
	(212319, 122, '2014-02-15 01:15:26.000000', 'temperatura', 132.0000, 'ºC'),
	(212320, 122, '2014-02-15 01:15:27.000000', 'temperatura', 810.0000, 'ºC'),
	(212321, 122, '2014-02-15 01:15:28.000000', 'temperatura', 57.0000, 'ºC'),
	(212322, 122, '2014-02-15 01:15:29.000000', 'temperatura', 254.0000, 'ºC'),
	(212323, 122, '2014-02-15 01:15:30.000000', 'temperatura', 1101.0000, 'ºC'),
	(212324, 122, '2014-02-15 01:15:31.000000', 'temperatura', 1144.0000, 'ºC'),
	(212325, 122, '2014-02-15 01:15:32.000000', 'temperatura', 18.0000, 'ºC'),
	(212326, 122, '2014-02-15 01:15:33.000000', 'temperatura', 258.0000, 'ºC'),
	(212327, 122, '2014-02-15 01:15:34.000000', 'temperatura', 38.0000, 'ºC'),
	(212328, 122, '2014-02-15 01:15:35.000000', 'temperatura', 616.0000, 'ºC'),
	(212329, 122, '2014-02-15 01:15:36.000000', 'temperatura', 564.0000, 'ºC'),
	(212330, 122, '2014-02-15 01:15:37.000000', 'temperatura', 973.0000, 'ºC'),
	(212331, 122, '2014-02-15 01:15:38.000000', 'temperatura', 776.0000, 'ºC'),
	(212332, 122, '2014-02-15 01:15:39.000000', 'temperatura', 961.0000, 'ºC'),
	(212333, 122, '2014-02-15 01:15:40.000000', 'temperatura', 76.0000, 'ºC'),
	(212334, 122, '2014-02-15 01:15:41.000000', 'temperatura', 1099.0000, 'ºC'),
	(212335, 122, '2014-02-15 01:15:42.000000', 'temperatura', 465.0000, 'ºC'),
	(212336, 122, '2014-02-15 01:15:43.000000', 'temperatura', 230.0000, 'ºC'),
	(212337, 122, '2014-02-15 01:15:44.000000', 'temperatura', 954.0000, 'ºC'),
	(212338, 122, '2014-02-15 01:15:45.000000', 'temperatura', 483.0000, 'ºC'),
	(212339, 122, '2014-02-15 01:15:46.000000', 'temperatura', 754.0000, 'ºC'),
	(212340, 122, '2014-02-15 01:15:47.000000', 'temperatura', 1119.0000, 'ºC'),
	(212341, 122, '2014-02-15 01:15:48.000000', 'temperatura', 934.0000, 'ºC'),
	(212342, 122, '2014-02-15 01:15:49.000000', 'temperatura', 113.0000, 'ºC'),
	(212343, 122, '2014-02-15 01:15:50.000000', 'temperatura', 163.0000, 'ºC'),
	(212344, 122, '2014-02-15 01:15:51.000000', 'temperatura', 475.0000, 'ºC'),
	(212345, 122, '2014-02-15 01:15:52.000000', 'temperatura', 690.0000, 'ºC'),
	(212346, 122, '2014-02-15 01:15:53.000000', 'temperatura', 822.0000, 'ºC'),
	(212347, 122, '2014-02-15 01:15:54.000000', 'temperatura', 844.0000, 'ºC'),
	(212348, 122, '2014-02-15 01:15:55.000000', 'temperatura', 554.0000, 'ºC'),
	(212349, 122, '2014-02-15 01:15:56.000000', 'temperatura', 237.0000, 'ºC'),
	(212350, 122, '2014-02-15 01:15:57.000000', 'temperatura', 723.0000, 'ºC'),
	(212351, 122, '2014-02-15 01:15:58.000000', 'temperatura', 505.0000, 'ºC'),
	(212352, 122, '2014-02-15 01:15:59.000000', 'temperatura', 356.0000, 'ºC'),
	(212353, 122, '2014-02-15 01:16:00.000000', 'temperatura', 264.0000, 'ºC'),
	(212354, 122, '2014-02-15 01:16:01.000000', 'temperatura', 253.0000, 'ºC'),
	(212355, 122, '2014-02-15 01:16:02.000000', 'temperatura', 476.0000, 'ºC'),
	(212356, 122, '2014-02-15 01:16:03.000000', 'temperatura', 418.0000, 'ºC'),
	(212357, 122, '2014-02-15 01:16:04.000000', 'temperatura', 666.0000, 'ºC'),
	(212358, 122, '2014-02-15 01:16:05.000000', 'temperatura', 873.0000, 'ºC'),
	(212359, 122, '2014-02-15 01:16:06.000000', 'temperatura', 1169.0000, 'ºC'),
	(212360, 122, '2014-02-15 01:16:07.000000', 'temperatura', 826.0000, 'ºC'),
	(212361, 122, '2014-02-15 01:16:08.000000', 'temperatura', 625.0000, 'ºC'),
	(212362, 122, '2014-02-15 01:16:09.000000', 'temperatura', 648.0000, 'ºC'),
	(212363, 122, '2014-02-15 01:16:10.000000', 'temperatura', 166.0000, 'ºC'),
	(212364, 122, '2014-02-15 01:16:11.000000', 'temperatura', 85.0000, 'ºC'),
	(212365, 122, '2014-02-15 01:16:12.000000', 'temperatura', 1127.0000, 'ºC'),
	(212366, 122, '2014-02-15 01:16:13.000000', 'temperatura', 583.0000, 'ºC'),
	(212367, 122, '2014-02-15 01:16:14.000000', 'temperatura', 733.0000, 'ºC'),
	(212368, 122, '2014-02-15 01:16:15.000000', 'temperatura', 716.0000, 'ºC'),
	(212369, 122, '2014-02-15 01:16:16.000000', 'temperatura', 182.0000, 'ºC'),
	(212370, 122, '2014-02-15 01:16:17.000000', 'temperatura', 1161.0000, 'ºC'),
	(212371, 122, '2014-02-15 01:16:18.000000', 'temperatura', 462.0000, 'ºC'),
	(212372, 122, '2014-02-15 01:16:19.000000', 'temperatura', 27.0000, 'ºC'),
	(212373, 122, '2014-02-15 01:16:20.000000', 'temperatura', 1150.0000, 'ºC'),
	(212374, 122, '2014-02-15 01:16:21.000000', 'temperatura', 870.0000, 'ºC'),
	(212375, 122, '2014-02-15 01:16:22.000000', 'temperatura', 901.0000, 'ºC'),
	(212376, 122, '2014-02-15 01:16:23.000000', 'temperatura', 695.0000, 'ºC'),
	(212377, 122, '2014-02-15 01:16:24.000000', 'temperatura', 771.0000, 'ºC'),
	(212378, 122, '2014-02-15 01:16:25.000000', 'temperatura', 570.0000, 'ºC'),
	(212379, 122, '2014-02-15 01:16:26.000000', 'temperatura', 538.0000, 'ºC'),
	(212380, 122, '2014-02-15 01:16:27.000000', 'temperatura', 980.0000, 'ºC'),
	(212381, 122, '2014-02-15 01:16:28.000000', 'temperatura', 885.0000, 'ºC'),
	(212382, 122, '2014-02-15 01:16:29.000000', 'temperatura', 288.0000, 'ºC'),
	(212383, 122, '2014-02-15 01:16:30.000000', 'temperatura', 1186.0000, 'ºC'),
	(212384, 122, '2014-02-15 01:16:31.000000', 'temperatura', 268.0000, 'ºC'),
	(212385, 122, '2014-02-15 01:16:32.000000', 'temperatura', 179.0000, 'ºC'),
	(212386, 122, '2014-02-15 01:16:33.000000', 'temperatura', 92.0000, 'ºC'),
	(212387, 122, '2014-02-15 01:16:34.000000', 'temperatura', 1125.0000, 'ºC'),
	(212388, 122, '2014-02-15 01:16:35.000000', 'temperatura', 550.0000, 'ºC'),
	(212389, 122, '2014-02-15 01:16:36.000000', 'temperatura', 575.0000, 'ºC'),
	(212390, 122, '2014-02-15 01:16:37.000000', 'temperatura', 26.0000, 'ºC'),
	(212391, 122, '2014-02-15 01:16:38.000000', 'temperatura', 805.0000, 'ºC'),
	(212392, 122, '2014-02-15 01:16:39.000000', 'temperatura', 349.0000, 'ºC'),
	(212393, 122, '2014-02-15 01:16:40.000000', 'temperatura', 528.0000, 'ºC'),
	(212394, 122, '2014-02-15 01:16:41.000000', 'temperatura', 396.0000, 'ºC'),
	(212395, 122, '2014-02-15 01:16:42.000000', 'temperatura', 397.0000, 'ºC'),
	(212396, 122, '2014-02-15 01:16:43.000000', 'temperatura', 797.0000, 'ºC'),
	(212397, 122, '2014-02-15 01:16:44.000000', 'temperatura', 394.0000, 'ºC'),
	(212398, 122, '2014-02-15 01:16:45.000000', 'temperatura', 778.0000, 'ºC'),
	(212399, 122, '2014-02-15 01:16:46.000000', 'temperatura', 311.0000, 'ºC'),
	(212400, 122, '2014-02-15 01:16:47.000000', 'temperatura', 419.0000, 'ºC'),
	(212401, 122, '2014-02-15 01:16:48.000000', 'temperatura', 1165.0000, 'ºC'),
	(212402, 122, '2014-02-15 01:16:49.000000', 'temperatura', 966.0000, 'ºC'),
	(212403, 122, '2014-02-15 01:16:50.000000', 'temperatura', 138.0000, 'ºC'),
	(212404, 122, '2014-02-15 01:16:51.000000', 'temperatura', 190.0000, 'ºC'),
	(212405, 122, '2014-02-15 01:16:52.000000', 'temperatura', 535.0000, 'ºC'),
	(212406, 122, '2014-02-15 01:16:53.000000', 'temperatura', 909.0000, 'ºC'),
	(212407, 122, '2014-02-15 01:16:54.000000', 'temperatura', 539.0000, 'ºC'),
	(212408, 122, '2014-02-15 01:16:55.000000', 'temperatura', 1170.0000, 'ºC'),
	(212409, 122, '2014-02-15 01:16:56.000000', 'temperatura', 633.0000, 'ºC'),
	(212410, 122, '2014-02-15 01:16:57.000000', 'temperatura', 854.0000, 'ºC'),
	(212411, 122, '2014-02-15 01:16:58.000000', 'temperatura', 1174.0000, 'ºC'),
	(212412, 122, '2014-02-15 01:16:59.000000', 'temperatura', 908.0000, 'ºC'),
	(212413, 122, '2014-02-15 01:17:00.000000', 'temperatura', 1019.0000, 'ºC'),
	(212414, 122, '2014-02-15 01:17:01.000000', 'temperatura', 1171.0000, 'ºC'),
	(212415, 122, '2014-02-15 01:17:02.000000', 'temperatura', 398.0000, 'ºC'),
	(212416, 122, '2014-02-15 01:17:03.000000', 'temperatura', 876.0000, 'ºC'),
	(212417, 122, '2014-02-15 01:17:04.000000', 'temperatura', 788.0000, 'ºC'),
	(212418, 122, '2014-02-15 01:17:05.000000', 'temperatura', 112.0000, 'ºC'),
	(212419, 122, '2014-02-15 01:17:06.000000', 'temperatura', 597.0000, 'ºC'),
	(212420, 122, '2014-02-15 01:17:07.000000', 'temperatura', 251.0000, 'ºC'),
	(212421, 122, '2014-02-15 01:17:08.000000', 'temperatura', 661.0000, 'ºC'),
	(212422, 122, '2014-02-15 01:17:09.000000', 'temperatura', 156.0000, 'ºC'),
	(212423, 122, '2014-02-15 01:17:10.000000', 'temperatura', 1196.0000, 'ºC'),
	(212424, 122, '2014-02-15 01:17:11.000000', 'temperatura', 714.0000, 'ºC'),
	(212425, 122, '2014-02-15 01:17:12.000000', 'temperatura', 1181.0000, 'ºC'),
	(212426, 122, '2014-02-15 01:17:13.000000', 'temperatura', 166.0000, 'ºC'),
	(212427, 122, '2014-02-15 01:17:14.000000', 'temperatura', 886.0000, 'ºC'),
	(212428, 122, '2014-02-15 01:17:15.000000', 'temperatura', 332.0000, 'ºC'),
	(212429, 122, '2014-02-15 01:17:16.000000', 'temperatura', 201.0000, 'ºC'),
	(212430, 122, '2014-02-15 01:17:17.000000', 'temperatura', 12.0000, 'ºC'),
	(212431, 122, '2014-02-15 01:17:18.000000', 'temperatura', 658.0000, 'ºC'),
	(212432, 122, '2014-02-15 01:17:19.000000', 'temperatura', 853.0000, 'ºC'),
	(212433, 122, '2014-02-15 01:17:20.000000', 'temperatura', 1091.0000, 'ºC'),
	(212434, 122, '2014-02-15 01:17:21.000000', 'temperatura', 498.0000, 'ºC'),
	(212435, 122, '2014-02-15 01:17:22.000000', 'temperatura', 417.0000, 'ºC'),
	(212436, 122, '2014-02-15 01:17:23.000000', 'temperatura', 590.0000, 'ºC'),
	(212437, 122, '2014-02-15 01:17:24.000000', 'temperatura', 500.0000, 'ºC'),
	(212438, 122, '2014-02-15 01:17:25.000000', 'temperatura', 731.0000, 'ºC'),
	(212439, 122, '2014-02-15 01:17:26.000000', 'temperatura', 957.0000, 'ºC'),
	(212440, 122, '2014-02-15 01:17:27.000000', 'temperatura', 190.0000, 'ºC'),
	(212441, 122, '2014-02-15 01:17:28.000000', 'temperatura', 480.0000, 'ºC'),
	(212442, 122, '2014-02-15 01:17:29.000000', 'temperatura', 633.0000, 'ºC'),
	(212443, 122, '2014-02-15 01:17:30.000000', 'temperatura', 522.0000, 'ºC'),
	(212444, 122, '2014-02-15 01:17:31.000000', 'temperatura', 714.0000, 'ºC'),
	(212445, 122, '2014-02-15 01:17:32.000000', 'temperatura', 805.0000, 'ºC'),
	(212446, 122, '2014-02-15 01:17:33.000000', 'temperatura', 683.0000, 'ºC'),
	(212447, 122, '2014-02-15 01:17:34.000000', 'temperatura', 999.0000, 'ºC'),
	(212448, 122, '2014-02-15 01:17:35.000000', 'temperatura', 547.0000, 'ºC'),
	(212449, 122, '2014-02-15 01:17:36.000000', 'temperatura', 938.0000, 'ºC'),
	(212450, 122, '2014-02-15 01:17:37.000000', 'temperatura', 648.0000, 'ºC'),
	(212451, 122, '2014-02-15 01:17:38.000000', 'temperatura', 429.0000, 'ºC'),
	(212452, 122, '2014-02-15 01:17:39.000000', 'temperatura', 201.0000, 'ºC'),
	(212453, 122, '2014-02-15 01:17:40.000000', 'temperatura', 920.0000, 'ºC'),
	(212454, 122, '2014-02-15 01:17:41.000000', 'temperatura', 398.0000, 'ºC'),
	(212455, 122, '2014-02-15 01:17:42.000000', 'temperatura', 431.0000, 'ºC'),
	(212456, 122, '2014-02-15 01:17:43.000000', 'temperatura', 958.0000, 'ºC'),
	(212457, 122, '2014-02-15 01:17:44.000000', 'temperatura', 1101.0000, 'ºC'),
	(212458, 122, '2014-02-15 01:17:45.000000', 'temperatura', 230.0000, 'ºC'),
	(212459, 122, '2014-02-15 01:17:46.000000', 'temperatura', 249.0000, 'ºC'),
	(212460, 122, '2014-02-15 01:17:47.000000', 'temperatura', 555.0000, 'ºC'),
	(212461, 122, '2014-02-15 01:17:48.000000', 'temperatura', 829.0000, 'ºC'),
	(212462, 122, '2014-02-15 01:17:49.000000', 'temperatura', 81.0000, 'ºC'),
	(212463, 122, '2014-02-15 01:17:50.000000', 'temperatura', 316.0000, 'ºC'),
	(212464, 122, '2014-02-15 01:17:51.000000', 'temperatura', 141.0000, 'ºC'),
	(212465, 122, '2014-02-15 01:17:52.000000', 'temperatura', 955.0000, 'ºC'),
	(212466, 122, '2014-02-15 01:17:53.000000', 'temperatura', 752.0000, 'ºC'),
	(212467, 122, '2014-02-15 01:17:54.000000', 'temperatura', 896.0000, 'ºC'),
	(212468, 122, '2014-02-15 01:17:55.000000', 'temperatura', 1026.0000, 'ºC'),
	(212469, 122, '2014-02-15 01:17:56.000000', 'temperatura', 40.0000, 'ºC'),
	(212470, 122, '2014-02-15 01:17:57.000000', 'temperatura', 724.0000, 'ºC'),
	(212471, 122, '2014-02-15 01:17:58.000000', 'temperatura', 1098.0000, 'ºC'),
	(212472, 122, '2014-02-15 01:17:59.000000', 'temperatura', 921.0000, 'ºC'),
	(212473, 122, '2014-02-15 01:18:00.000000', 'temperatura', 111.0000, 'ºC'),
	(212474, 122, '2014-02-15 01:18:01.000000', 'temperatura', 191.0000, 'ºC'),
	(212475, 122, '2014-02-15 01:18:02.000000', 'temperatura', 622.0000, 'ºC'),
	(212476, 122, '2014-02-15 01:18:03.000000', 'temperatura', 139.0000, 'ºC'),
	(212477, 122, '2014-02-15 01:18:04.000000', 'temperatura', 31.0000, 'ºC'),
	(212478, 122, '2014-02-15 01:18:05.000000', 'temperatura', 938.0000, 'ºC'),
	(212479, 122, '2014-02-15 01:18:06.000000', 'temperatura', 997.0000, 'ºC'),
	(212480, 122, '2014-02-15 01:18:07.000000', 'temperatura', 973.0000, 'ºC'),
	(212481, 122, '2014-02-15 01:18:08.000000', 'temperatura', 672.0000, 'ºC'),
	(212482, 122, '2014-02-15 01:18:09.000000', 'temperatura', 441.0000, 'ºC'),
	(212483, 122, '2014-02-15 01:18:10.000000', 'temperatura', 191.0000, 'ºC'),
	(212484, 122, '2014-02-15 01:18:11.000000', 'temperatura', 834.0000, 'ºC'),
	(212485, 122, '2014-02-15 01:18:12.000000', 'temperatura', 1195.0000, 'ºC'),
	(212486, 122, '2014-02-15 01:18:13.000000', 'temperatura', 1076.0000, 'ºC'),
	(212487, 122, '2014-02-15 01:18:14.000000', 'temperatura', 596.0000, 'ºC'),
	(212488, 122, '2014-02-15 01:18:15.000000', 'temperatura', 950.0000, 'ºC'),
	(212489, 122, '2014-02-15 01:18:16.000000', 'temperatura', 562.0000, 'ºC'),
	(212490, 122, '2014-02-15 01:18:17.000000', 'temperatura', 1163.0000, 'ºC'),
	(212491, 122, '2014-02-15 01:18:18.000000', 'temperatura', 527.0000, 'ºC'),
	(212492, 122, '2014-02-15 01:18:19.000000', 'temperatura', 349.0000, 'ºC'),
	(212493, 122, '2014-02-15 01:18:20.000000', 'temperatura', 163.0000, 'ºC'),
	(212494, 122, '2014-02-15 01:18:21.000000', 'temperatura', 968.0000, 'ºC'),
	(212495, 122, '2014-02-15 01:18:22.000000', 'temperatura', 750.0000, 'ºC'),
	(212496, 122, '2014-02-15 01:18:23.000000', 'temperatura', 848.0000, 'ºC'),
	(212497, 122, '2014-02-15 01:18:24.000000', 'temperatura', 791.0000, 'ºC'),
	(212498, 122, '2014-02-15 01:18:25.000000', 'temperatura', 212.0000, 'ºC'),
	(212499, 122, '2014-02-15 01:18:26.000000', 'temperatura', 1086.0000, 'ºC'),
	(212500, 122, '2014-02-15 01:18:27.000000', 'temperatura', 1195.0000, 'ºC'),
	(212501, 122, '2014-02-15 01:18:28.000000', 'temperatura', 317.0000, 'ºC'),
	(212502, 122, '2014-02-15 01:18:29.000000', 'temperatura', 402.0000, 'ºC'),
	(212503, 122, '2014-02-15 01:18:30.000000', 'temperatura', 1059.0000, 'ºC'),
	(212504, 122, '2014-02-15 01:18:31.000000', 'temperatura', 489.0000, 'ºC'),
	(212505, 122, '2014-02-15 01:18:32.000000', 'temperatura', 467.0000, 'ºC'),
	(212506, 122, '2014-02-15 01:18:33.000000', 'temperatura', 870.0000, 'ºC'),
	(212507, 122, '2014-02-15 01:18:34.000000', 'temperatura', 550.0000, 'ºC'),
	(212508, 122, '2014-02-15 01:18:35.000000', 'temperatura', 140.0000, 'ºC'),
	(212509, 122, '2014-02-15 01:18:36.000000', 'temperatura', 250.0000, 'ºC'),
	(212510, 122, '2014-02-15 01:18:37.000000', 'temperatura', 830.0000, 'ºC'),
	(212511, 122, '2014-02-15 01:18:38.000000', 'temperatura', 1002.0000, 'ºC'),
	(212512, 122, '2014-02-15 01:18:39.000000', 'temperatura', 120.0000, 'ºC'),
	(212513, 122, '2014-02-15 01:18:40.000000', 'temperatura', 1196.0000, 'ºC'),
	(212514, 122, '2014-02-15 01:18:41.000000', 'temperatura', 818.0000, 'ºC'),
	(212515, 122, '2014-02-15 01:18:42.000000', 'temperatura', 503.0000, 'ºC'),
	(212516, 122, '2014-02-15 01:18:43.000000', 'temperatura', 61.0000, 'ºC'),
	(212517, 122, '2014-02-15 01:18:44.000000', 'temperatura', 1195.0000, 'ºC'),
	(212518, 122, '2014-02-15 01:18:45.000000', 'temperatura', 996.0000, 'ºC'),
	(212519, 122, '2014-02-15 01:18:46.000000', 'temperatura', 194.0000, 'ºC'),
	(212520, 122, '2014-02-15 01:18:47.000000', 'temperatura', 382.0000, 'ºC'),
	(212521, 122, '2014-02-15 01:18:48.000000', 'temperatura', 127.0000, 'ºC'),
	(212522, 122, '2014-02-15 01:18:49.000000', 'temperatura', 692.0000, 'ºC'),
	(212523, 122, '2014-02-15 01:18:50.000000', 'temperatura', 677.0000, 'ºC'),
	(212524, 122, '2014-02-15 01:18:51.000000', 'temperatura', 112.0000, 'ºC'),
	(212525, 122, '2014-02-15 01:18:52.000000', 'temperatura', 930.0000, 'ºC'),
	(212526, 122, '2014-02-15 01:18:53.000000', 'temperatura', 713.0000, 'ºC'),
	(212527, 122, '2014-02-15 01:18:54.000000', 'temperatura', 776.0000, 'ºC'),
	(212528, 122, '2014-02-15 01:18:55.000000', 'temperatura', 541.0000, 'ºC'),
	(212529, 122, '2014-02-15 01:18:56.000000', 'temperatura', 376.0000, 'ºC'),
	(212530, 122, '2014-02-15 01:18:57.000000', 'temperatura', 257.0000, 'ºC'),
	(212531, 122, '2014-02-15 01:18:58.000000', 'temperatura', 160.0000, 'ºC'),
	(212532, 122, '2014-02-15 01:18:59.000000', 'temperatura', 30.0000, 'ºC'),
	(212533, 122, '2014-02-15 01:19:00.000000', 'temperatura', 868.0000, 'ºC'),
	(212534, 122, '2014-02-15 01:19:01.000000', 'temperatura', 653.0000, 'ºC'),
	(212535, 122, '2014-02-15 01:19:02.000000', 'temperatura', 662.0000, 'ºC'),
	(212536, 122, '2014-02-15 01:19:03.000000', 'temperatura', 150.0000, 'ºC'),
	(212537, 122, '2014-02-15 01:19:04.000000', 'temperatura', 1164.0000, 'ºC'),
	(212538, 122, '2014-02-15 01:19:05.000000', 'temperatura', 571.0000, 'ºC'),
	(212539, 122, '2014-02-15 01:19:06.000000', 'temperatura', 563.0000, 'ºC'),
	(212540, 122, '2014-02-15 01:19:07.000000', 'temperatura', 1103.0000, 'ºC'),
	(212541, 122, '2014-02-15 01:19:08.000000', 'temperatura', 228.0000, 'ºC'),
	(212542, 122, '2014-02-15 01:19:09.000000', 'temperatura', 232.0000, 'ºC'),
	(212543, 122, '2014-02-15 01:19:10.000000', 'temperatura', 475.0000, 'ºC'),
	(212544, 122, '2014-02-15 01:19:11.000000', 'temperatura', 480.0000, 'ºC'),
	(212545, 122, '2014-02-15 01:19:12.000000', 'temperatura', 975.0000, 'ºC'),
	(212546, 122, '2014-02-15 01:19:13.000000', 'temperatura', 1037.0000, 'ºC'),
	(212547, 122, '2014-02-15 01:19:14.000000', 'temperatura', 1060.0000, 'ºC'),
	(212548, 122, '2014-02-15 01:19:15.000000', 'temperatura', 989.0000, 'ºC'),
	(212549, 122, '2014-02-15 01:19:16.000000', 'temperatura', 564.0000, 'ºC'),
	(212550, 122, '2014-02-15 01:19:17.000000', 'temperatura', 1056.0000, 'ºC'),
	(212551, 122, '2014-02-15 01:19:18.000000', 'temperatura', 1189.0000, 'ºC'),
	(212552, 122, '2014-02-15 01:19:19.000000', 'temperatura', 376.0000, 'ºC'),
	(212553, 122, '2014-02-15 01:19:20.000000', 'temperatura', 713.0000, 'ºC'),
	(212554, 122, '2014-02-15 01:19:21.000000', 'temperatura', 40.0000, 'ºC'),
	(212555, 122, '2014-02-15 01:19:22.000000', 'temperatura', 460.0000, 'ºC'),
	(212556, 122, '2014-02-15 01:19:23.000000', 'temperatura', 981.0000, 'ºC'),
	(212557, 122, '2014-02-15 01:19:24.000000', 'temperatura', 1124.0000, 'ºC'),
	(212558, 122, '2014-02-15 01:19:25.000000', 'temperatura', 280.0000, 'ºC'),
	(212559, 122, '2014-02-15 01:19:26.000000', 'temperatura', 427.0000, 'ºC'),
	(212560, 122, '2014-02-15 01:19:27.000000', 'temperatura', 95.0000, 'ºC'),
	(212561, 122, '2014-02-15 01:19:28.000000', 'temperatura', 394.0000, 'ºC'),
	(212562, 122, '2014-02-15 01:19:29.000000', 'temperatura', 485.0000, 'ºC'),
	(212563, 122, '2014-02-15 01:19:30.000000', 'temperatura', 45.0000, 'ºC'),
	(212564, 122, '2014-02-15 01:19:31.000000', 'temperatura', 1170.0000, 'ºC'),
	(212565, 122, '2014-02-15 01:19:32.000000', 'temperatura', 916.0000, 'ºC'),
	(212566, 122, '2014-02-15 01:19:33.000000', 'temperatura', 1068.0000, 'ºC'),
	(212567, 122, '2014-02-15 01:19:34.000000', 'temperatura', 195.0000, 'ºC'),
	(212568, 122, '2014-02-15 01:19:35.000000', 'temperatura', 173.0000, 'ºC'),
	(212569, 122, '2014-02-15 01:19:36.000000', 'temperatura', 278.0000, 'ºC'),
	(212570, 122, '2014-02-15 01:19:37.000000', 'temperatura', 874.0000, 'ºC'),
	(212571, 122, '2014-02-15 01:19:38.000000', 'temperatura', 1135.0000, 'ºC'),
	(212572, 122, '2014-02-15 01:19:39.000000', 'temperatura', 654.0000, 'ºC'),
	(212573, 122, '2014-02-15 01:19:40.000000', 'temperatura', 1065.0000, 'ºC'),
	(212574, 122, '2014-02-15 01:19:41.000000', 'temperatura', 964.0000, 'ºC'),
	(212575, 122, '2014-02-15 01:19:42.000000', 'temperatura', 427.0000, 'ºC'),
	(212576, 122, '2014-02-15 01:19:43.000000', 'temperatura', 442.0000, 'ºC'),
	(212577, 122, '2014-02-15 01:19:44.000000', 'temperatura', 929.0000, 'ºC'),
	(212578, 122, '2014-02-15 01:19:45.000000', 'temperatura', 922.0000, 'ºC'),
	(212579, 122, '2014-02-15 01:19:46.000000', 'temperatura', 622.0000, 'ºC'),
	(212580, 122, '2014-02-15 01:19:47.000000', 'temperatura', 347.0000, 'ºC'),
	(212581, 122, '2014-02-15 01:19:48.000000', 'temperatura', 1066.0000, 'ºC'),
	(212582, 122, '2014-02-15 01:19:49.000000', 'temperatura', 691.0000, 'ºC'),
	(212583, 122, '2014-02-15 01:19:50.000000', 'temperatura', 256.0000, 'ºC'),
	(212584, 122, '2014-02-15 01:19:51.000000', 'temperatura', 410.0000, 'ºC'),
	(212585, 122, '2014-02-15 01:19:52.000000', 'temperatura', 83.0000, 'ºC'),
	(212586, 122, '2014-02-15 01:19:53.000000', 'temperatura', 384.0000, 'ºC'),
	(212587, 122, '2014-02-15 01:19:54.000000', 'temperatura', 472.0000, 'ºC'),
	(212588, 122, '2014-02-15 01:19:55.000000', 'temperatura', 10.0000, 'ºC'),
	(212589, 122, '2014-02-15 01:19:56.000000', 'temperatura', 1034.0000, 'ºC'),
	(212590, 122, '2014-02-15 01:19:57.000000', 'temperatura', 341.0000, 'ºC'),
	(212591, 122, '2014-02-15 01:19:58.000000', 'temperatura', 1005.0000, 'ºC'),
	(212592, 122, '2014-02-15 01:19:59.000000', 'temperatura', 400.0000, 'ºC'),
	(212593, 122, '2014-02-15 01:20:00.000000', 'temperatura', 186.0000, 'ºC'),
	(212594, 122, '2014-02-15 01:20:01.000000', 'temperatura', 933.0000, 'ºC'),
	(212595, 122, '2014-02-15 01:20:02.000000', 'temperatura', 504.0000, 'ºC'),
	(212596, 122, '2014-02-15 01:20:03.000000', 'temperatura', 924.0000, 'ºC'),
	(212597, 122, '2014-02-15 01:20:04.000000', 'temperatura', 706.0000, 'ºC'),
	(212598, 122, '2014-02-15 01:20:05.000000', 'temperatura', 759.0000, 'ºC'),
	(212599, 122, '2014-02-15 01:20:06.000000', 'temperatura', 478.0000, 'ºC'),
	(212600, 122, '2014-02-15 01:20:07.000000', 'temperatura', 115.0000, 'ºC'),
	(212601, 122, '2014-02-15 01:20:08.000000', 'temperatura', 339.0000, 'ºC'),
	(212602, 122, '2014-02-15 01:20:09.000000', 'temperatura', 152.0000, 'ºC'),
	(212603, 122, '2014-02-15 01:20:10.000000', 'temperatura', 943.0000, 'ºC'),
	(212604, 122, '2014-02-15 01:20:11.000000', 'temperatura', 658.0000, 'ºC'),
	(212605, 122, '2014-02-15 01:20:12.000000', 'temperatura', 464.0000, 'ºC'),
	(212606, 122, '2014-02-15 01:20:13.000000', 'temperatura', 344.0000, 'ºC'),
	(212607, 122, '2014-02-15 01:20:14.000000', 'temperatura', 331.0000, 'ºC'),
	(212608, 122, '2014-02-15 01:20:15.000000', 'temperatura', 621.0000, 'ºC'),
	(212609, 122, '2014-02-15 01:20:16.000000', 'temperatura', 913.0000, 'ºC'),
	(212610, 122, '2014-02-15 01:20:17.000000', 'temperatura', 301.0000, 'ºC'),
	(212611, 122, '2014-02-15 01:20:18.000000', 'temperatura', 1167.0000, 'ºC'),
	(212612, 122, '2014-02-15 01:20:19.000000', 'temperatura', 135.0000, 'ºC'),
	(212613, 122, '2014-02-15 01:20:20.000000', 'temperatura', 774.0000, 'ºC'),
	(212614, 122, '2014-02-15 01:20:21.000000', 'temperatura', 1063.0000, 'ºC'),
	(212615, 122, '2014-02-15 01:20:22.000000', 'temperatura', 594.0000, 'ºC'),
	(212616, 122, '2014-02-15 01:20:23.000000', 'temperatura', 984.0000, 'ºC'),
	(212617, 122, '2014-02-15 01:20:24.000000', 'temperatura', 736.0000, 'ºC'),
	(212618, 122, '2014-02-15 01:20:25.000000', 'temperatura', 731.0000, 'ºC'),
	(212619, 122, '2014-02-15 01:20:26.000000', 'temperatura', 244.0000, 'ºC'),
	(212620, 122, '2014-02-15 01:20:27.000000', 'temperatura', 231.0000, 'ºC'),
	(212621, 122, '2014-02-15 01:20:28.000000', 'temperatura', 423.0000, 'ºC'),
	(212622, 122, '2014-02-15 01:20:29.000000', 'temperatura', 222.0000, 'ºC'),
	(212623, 122, '2014-02-15 01:20:30.000000', 'temperatura', 1042.0000, 'ºC'),
	(212624, 122, '2014-02-15 01:20:31.000000', 'temperatura', 942.0000, 'ºC'),
	(212625, 122, '2014-02-15 01:20:32.000000', 'temperatura', 387.0000, 'ºC'),
	(212626, 122, '2014-02-15 01:20:33.000000', 'temperatura', 309.0000, 'ºC'),
	(212627, 122, '2014-02-15 01:20:34.000000', 'temperatura', 384.0000, 'ºC'),
	(212628, 122, '2014-02-15 01:20:35.000000', 'temperatura', 995.0000, 'ºC'),
	(212629, 122, '2014-02-15 01:20:36.000000', 'temperatura', 222.0000, 'ºC'),
	(212630, 122, '2014-02-15 01:20:37.000000', 'temperatura', 524.0000, 'ºC'),
	(212631, 122, '2014-02-15 01:20:38.000000', 'temperatura', 757.0000, 'ºC'),
	(212632, 122, '2014-02-15 01:20:39.000000', 'temperatura', 1012.0000, 'ºC'),
	(212633, 122, '2014-02-15 01:20:40.000000', 'temperatura', 389.0000, 'ºC'),
	(212634, 122, '2014-02-15 01:20:41.000000', 'temperatura', 109.0000, 'ºC'),
	(212635, 122, '2014-02-15 01:20:42.000000', 'temperatura', 580.0000, 'ºC'),
	(212636, 122, '2014-02-15 01:20:43.000000', 'temperatura', 171.0000, 'ºC'),
	(212637, 122, '2014-02-15 01:20:44.000000', 'temperatura', 317.0000, 'ºC'),
	(212638, 122, '2014-02-15 01:20:45.000000', 'temperatura', 1072.0000, 'ºC'),
	(212639, 122, '2014-02-15 01:20:46.000000', 'temperatura', 809.0000, 'ºC'),
	(212640, 122, '2014-02-15 01:20:47.000000', 'temperatura', 829.0000, 'ºC'),
	(212641, 122, '2014-02-15 01:20:48.000000', 'temperatura', 518.0000, 'ºC'),
	(212642, 122, '2014-02-15 01:20:49.000000', 'temperatura', 104.0000, 'ºC'),
	(212643, 122, '2014-02-15 01:20:50.000000', 'temperatura', 166.0000, 'ºC'),
	(212644, 122, '2014-02-15 01:20:51.000000', 'temperatura', 520.0000, 'ºC'),
	(212645, 122, '2014-02-15 01:20:52.000000', 'temperatura', 900.0000, 'ºC'),
	(212646, 122, '2014-02-15 01:20:53.000000', 'temperatura', 541.0000, 'ºC'),
	(212647, 122, '2014-02-15 01:20:54.000000', 'temperatura', 8.0000, 'ºC'),
	(212648, 122, '2014-02-15 01:20:55.000000', 'temperatura', 816.0000, 'ºC'),
	(212649, 122, '2014-02-15 01:20:56.000000', 'temperatura', 457.0000, 'ºC'),
	(212650, 122, '2014-02-15 01:20:57.000000', 'temperatura', 1037.0000, 'ºC'),
	(212651, 122, '2014-02-15 01:20:58.000000', 'temperatura', 215.0000, 'ºC'),
	(212652, 122, '2014-02-15 01:20:59.000000', 'temperatura', 364.0000, 'ºC'),
	(212653, 122, '2014-02-15 01:21:00.000000', 'temperatura', 1176.0000, 'ºC'),
	(212654, 122, '2014-02-15 01:21:01.000000', 'temperatura', 1188.0000, 'ºC'),
	(212655, 122, '2014-02-15 01:21:02.000000', 'temperatura', 12.0000, 'ºC'),
	(212656, 122, '2014-02-15 01:21:03.000000', 'temperatura', 98.0000, 'ºC'),
	(212657, 122, '2014-02-15 01:21:04.000000', 'temperatura', 452.0000, 'ºC'),
	(212658, 122, '2014-02-15 01:21:05.000000', 'temperatura', 770.0000, 'ºC'),
	(212659, 122, '2014-02-15 01:21:06.000000', 'temperatura', 91.0000, 'ºC'),
	(212660, 122, '2014-02-15 01:21:07.000000', 'temperatura', 546.0000, 'ºC'),
	(212661, 122, '2014-02-15 01:21:08.000000', 'temperatura', 58.0000, 'ºC'),
	(212662, 122, '2014-02-15 01:21:09.000000', 'temperatura', 1054.0000, 'ºC'),
	(212663, 122, '2014-02-15 01:21:10.000000', 'temperatura', 294.0000, 'ºC'),
	(212664, 122, '2014-02-15 01:21:11.000000', 'temperatura', 710.0000, 'ºC'),
	(212665, 122, '2014-02-15 01:21:12.000000', 'temperatura', 270.0000, 'ºC'),
	(212666, 122, '2014-02-15 01:21:13.000000', 'temperatura', 418.0000, 'ºC'),
	(212667, 122, '2014-02-15 01:21:14.000000', 'temperatura', 83.0000, 'ºC'),
	(212668, 122, '2014-02-15 01:21:15.000000', 'temperatura', 361.0000, 'ºC'),
	(212669, 122, '2014-02-15 01:21:16.000000', 'temperatura', 356.0000, 'ºC'),
	(212670, 122, '2014-02-15 01:21:17.000000', 'temperatura', 698.0000, 'ºC'),
	(212671, 122, '2014-02-15 01:21:18.000000', 'temperatura', 21.0000, 'ºC'),
	(212672, 122, '2014-02-15 01:21:19.000000', 'temperatura', 410.0000, 'ºC'),
	(212673, 122, '2014-02-15 01:21:20.000000', 'temperatura', 790.0000, 'ºC'),
	(212674, 122, '2014-02-15 01:21:21.000000', 'temperatura', 319.0000, 'ºC'),
	(212675, 122, '2014-02-15 01:21:22.000000', 'temperatura', 427.0000, 'ºC'),
	(212676, 122, '2014-02-15 01:21:23.000000', 'temperatura', 1180.0000, 'ºC'),
	(212677, 122, '2014-02-15 01:21:24.000000', 'temperatura', 1017.0000, 'ºC'),
	(212678, 122, '2014-02-15 01:21:25.000000', 'temperatura', 347.0000, 'ºC'),
	(212679, 122, '2014-02-15 01:21:26.000000', 'temperatura', 1083.0000, 'ºC'),
	(212680, 122, '2014-02-15 01:21:27.000000', 'temperatura', 776.0000, 'ºC'),
	(212681, 122, '2014-02-15 01:21:28.000000', 'temperatura', 631.0000, 'ºC'),
	(212682, 122, '2014-02-15 01:21:29.000000', 'temperatura', 830.0000, 'ºC'),
	(212683, 122, '2014-02-15 01:21:30.000000', 'temperatura', 1054.0000, 'ºC'),
	(212684, 122, '2014-02-15 01:21:31.000000', 'temperatura', 380.0000, 'ºC'),
	(212685, 122, '2014-02-15 01:21:32.000000', 'temperatura', 1141.0000, 'ºC'),
	(212686, 122, '2014-02-15 01:21:33.000000', 'temperatura', 963.0000, 'ºC'),
	(212687, 122, '2014-02-15 01:21:34.000000', 'temperatura', 195.0000, 'ºC'),
	(212688, 122, '2014-02-15 01:21:35.000000', 'temperatura', 485.0000, 'ºC'),
	(212689, 122, '2014-02-15 01:21:36.000000', 'temperatura', 640.0000, 'ºC'),
	(212690, 122, '2014-02-15 01:21:37.000000', 'temperatura', 547.0000, 'ºC'),
	(212691, 122, '2014-02-15 01:21:38.000000', 'temperatura', 817.0000, 'ºC'),
	(212692, 122, '2014-02-15 01:21:39.000000', 'temperatura', 41.0000, 'ºC'),
	(212693, 122, '2014-02-15 01:21:40.000000', 'temperatura', 157.0000, 'ºC'),
	(212694, 122, '2014-02-15 01:21:41.000000', 'temperatura', 662.0000, 'ºC'),
	(212695, 122, '2014-02-15 01:21:42.000000', 'temperatura', 438.0000, 'ºC'),
	(212696, 122, '2014-02-15 01:21:43.000000', 'temperatura', 203.0000, 'ºC'),
	(212697, 122, '2014-02-15 01:21:44.000000', 'temperatura', 905.0000, 'ºC'),
	(212698, 122, '2014-02-15 01:21:45.000000', 'temperatura', 316.0000, 'ºC'),
	(212699, 122, '2014-02-15 01:21:46.000000', 'temperatura', 63.0000, 'ºC'),
	(212700, 122, '2014-02-15 01:21:47.000000', 'temperatura', 568.0000, 'ºC'),
	(212701, 122, '2014-02-15 01:21:48.000000', 'temperatura', 253.0000, 'ºC'),
	(212702, 122, '2014-02-15 01:21:49.000000', 'temperatura', 759.0000, 'ºC'),
	(212703, 122, '2014-02-15 01:21:50.000000', 'temperatura', 637.0000, 'ºC'),
	(212704, 122, '2014-02-15 01:21:51.000000', 'temperatura', 908.0000, 'ºC'),
	(212705, 122, '2014-02-15 01:21:52.000000', 'temperatura', 229.0000, 'ºC'),
	(212706, 122, '2014-02-15 01:21:53.000000', 'temperatura', 822.0000, 'ºC'),
	(212707, 122, '2014-02-15 01:21:54.000000', 'temperatura', 1023.0000, 'ºC'),
	(212708, 122, '2014-02-15 01:21:55.000000', 'temperatura', 249.0000, 'ºC'),
	(212709, 122, '2014-02-15 01:21:56.000000', 'temperatura', 576.0000, 'ºC'),
	(212710, 122, '2014-02-15 01:21:57.000000', 'temperatura', 934.0000, 'ºC'),
	(212711, 122, '2014-02-15 01:21:58.000000', 'temperatura', 543.0000, 'ºC'),
	(212712, 122, '2014-02-15 01:21:59.000000', 'temperatura', 1114.0000, 'ºC'),
	(212713, 122, '2014-02-15 01:22:00.000000', 'temperatura', 340.0000, 'ºC'),
	(212714, 122, '2014-02-15 01:22:01.000000', 'temperatura', 759.0000, 'ºC'),
	(212715, 122, '2014-02-15 01:22:02.000000', 'temperatura', 376.0000, 'ºC'),
	(212716, 122, '2014-02-15 01:22:03.000000', 'temperatura', 805.0000, 'ºC'),
	(212717, 122, '2014-02-15 01:22:04.000000', 'temperatura', 498.0000, 'ºC'),
	(212718, 122, '2014-02-15 01:22:05.000000', 'temperatura', 74.0000, 'ºC'),
	(212719, 122, '2014-02-15 01:22:06.000000', 'temperatura', 75.0000, 'ºC'),
	(212720, 122, '2014-02-15 01:22:07.000000', 'temperatura', 154.0000, 'ºC'),
	(212721, 122, '2014-02-15 01:22:08.000000', 'temperatura', 544.0000, 'ºC'),
	(212722, 122, '2014-02-15 01:22:09.000000', 'temperatura', 1060.0000, 'ºC'),
	(212723, 122, '2014-02-15 01:22:10.000000', 'temperatura', 70.0000, 'ºC'),
	(212724, 122, '2014-02-15 01:22:11.000000', 'temperatura', 771.0000, 'ºC'),
	(212725, 122, '2014-02-15 01:22:12.000000', 'temperatura', 44.0000, 'ºC'),
	(212726, 122, '2014-02-15 01:22:13.000000', 'temperatura', 310.0000, 'ºC'),
	(212727, 122, '2014-02-15 01:22:14.000000', 'temperatura', 216.0000, 'ºC'),
	(212728, 122, '2014-02-15 01:22:15.000000', 'temperatura', 150.0000, 'ºC'),
	(212729, 122, '2014-02-15 01:22:16.000000', 'temperatura', 103.0000, 'ºC'),
	(212730, 122, '2014-02-15 01:22:17.000000', 'temperatura', 65.0000, 'ºC'),
	(212731, 122, '2014-02-15 01:22:18.000000', 'temperatura', 17.0000, 'ºC'),
	(212732, 122, '2014-02-15 01:22:19.000000', 'temperatura', 1090.0000, 'ºC'),
	(212733, 122, '2014-02-15 01:22:20.000000', 'temperatura', 602.0000, 'ºC'),
	(212734, 122, '2014-02-15 01:22:21.000000', 'temperatura', 937.0000, 'ºC'),
	(212735, 122, '2014-02-15 01:22:22.000000', 'temperatura', 481.0000, 'ºC'),
	(212736, 122, '2014-02-15 01:22:23.000000', 'temperatura', 794.0000, 'ºC'),
	(212737, 122, '2014-02-15 01:22:24.000000', 'temperatura', 128.0000, 'ºC'),
	(212738, 122, '2014-02-15 01:22:25.000000', 'temperatura', 657.0000, 'ºC'),
	(212739, 122, '2014-02-15 01:22:26.000000', 'temperatura', 502.0000, 'ºC'),
	(212740, 122, '2014-02-15 01:22:27.000000', 'temperatura', 538.0000, 'ºC'),
	(212741, 122, '2014-02-15 01:22:28.000000', 'temperatura', 1187.0000, 'ºC'),
	(212742, 122, '2014-02-15 01:22:29.000000', 'temperatura', 722.0000, 'ºC'),
	(212743, 122, '2014-02-15 01:22:30.000000', 'temperatura', 49.0000, 'ºC'),
	(212744, 122, '2014-02-15 01:22:31.000000', 'temperatura', 479.0000, 'ºC'),
	(212745, 122, '2014-02-15 01:22:32.000000', 'temperatura', 1047.0000, 'ºC'),
	(212746, 122, '2014-02-15 01:22:33.000000', 'temperatura', 198.0000, 'ºC'),
	(212747, 122, '2014-02-15 01:22:34.000000', 'temperatura', 252.0000, 'ºC'),
	(212748, 122, '2014-02-15 01:22:35.000000', 'temperatura', 667.0000, 'ºC'),
	(212749, 122, '2014-02-15 01:22:36.000000', 'temperatura', 181.0000, 'ºC'),
	(212750, 122, '2014-02-15 01:22:37.000000', 'temperatura', 101.0000, 'ºC'),
	(212751, 122, '2014-02-15 01:22:38.000000', 'temperatura', 1163.0000, 'ºC'),
	(212752, 122, '2014-02-15 01:22:39.000000', 'temperatura', 712.0000, 'ºC'),
	(212753, 122, '2014-02-15 01:22:40.000000', 'temperatura', 73.0000, 'ºC'),
	(212754, 122, '2014-02-15 01:22:41.000000', 'temperatura', 628.0000, 'ºC'),
	(212755, 122, '2014-02-15 01:22:42.000000', 'temperatura', 523.0000, 'ºC'),
	(212756, 122, '2014-02-15 01:22:43.000000', 'temperatura', 732.0000, 'ºC'),
	(212757, 122, '2014-02-15 01:22:44.000000', 'temperatura', 891.0000, 'ºC'),
	(212758, 122, '2014-02-15 01:22:45.000000', 'temperatura', 1058.0000, 'ºC'),
	(212759, 122, '2014-02-15 01:22:46.000000', 'temperatura', 220.0000, 'ºC'),
	(212760, 122, '2014-02-15 01:22:47.000000', 'temperatura', 326.0000, 'ºC'),
	(212761, 122, '2014-02-15 01:22:48.000000', 'temperatura', 970.0000, 'ºC'),
	(212762, 122, '2014-02-15 01:22:49.000000', 'temperatura', 272.0000, 'ºC'),
	(212763, 122, '2014-02-15 01:22:50.000000', 'temperatura', 851.0000, 'ºC'),
	(212764, 122, '2014-02-15 01:22:51.000000', 'temperatura', 1040.0000, 'ºC'),
	(212765, 122, '2014-02-15 01:22:52.000000', 'temperatura', 248.0000, 'ºC'),
	(212766, 122, '2014-02-15 01:22:53.000000', 'temperatura', 520.0000, 'ºC'),
	(212767, 122, '2014-02-15 01:22:54.000000', 'temperatura', 658.0000, 'ºC'),
	(212768, 122, '2014-02-15 01:22:55.000000', 'temperatura', 529.0000, 'ºC'),
	(212769, 122, '2014-02-15 01:22:56.000000', 'temperatura', 671.0000, 'ºC'),
	(212770, 122, '2014-02-15 01:22:57.000000', 'temperatura', 571.0000, 'ºC'),
	(212771, 122, '2014-02-15 01:22:58.000000', 'temperatura', 840.0000, 'ºC'),
	(212772, 122, '2014-02-15 01:22:59.000000', 'temperatura', 90.0000, 'ºC'),
	(212773, 122, '2014-02-15 01:23:00.000000', 'temperatura', 329.0000, 'ºC'),
	(212774, 122, '2014-02-15 01:23:01.000000', 'temperatura', 178.0000, 'ºC'),
	(212775, 122, '2014-02-15 01:23:02.000000', 'temperatura', 1100.0000, 'ºC'),
	(212776, 122, '2014-02-15 01:23:03.000000', 'temperatura', 169.0000, 'ºC'),
	(212777, 122, '2014-02-15 01:23:04.000000', 'temperatura', 1146.0000, 'ºC'),
	(212778, 122, '2014-02-15 01:23:05.000000', 'temperatura', 423.0000, 'ºC'),
	(212779, 122, '2014-02-15 01:23:06.000000', 'temperatura', 1076.0000, 'ºC'),
	(212780, 122, '2014-02-15 01:23:07.000000', 'temperatura', 514.0000, 'ºC'),
	(212781, 122, '2014-02-15 01:23:08.000000', 'temperatura', 540.0000, 'ºC'),
	(212782, 122, '2014-02-15 01:23:09.000000', 'temperatura', 1158.0000, 'ºC'),
	(212783, 122, '2014-02-15 01:23:10.000000', 'temperatura', 571.0000, 'ºC'),
	(212784, 122, '2014-02-15 01:23:11.000000', 'temperatura', 582.0000, 'ºC'),
	(212785, 122, '2014-02-15 01:23:12.000000', 'temperatura', 1196.0000, 'ºC'),
	(212786, 122, '2014-02-15 01:23:13.000000', 'temperatura', 637.0000, 'ºC'),
	(212787, 122, '2014-02-15 01:23:14.000000', 'temperatura', 797.0000, 'ºC'),
	(212788, 122, '2014-02-15 01:23:15.000000', 'temperatura', 874.0000, 'ºC'),
	(212789, 122, '2014-02-15 01:23:16.000000', 'temperatura', 778.0000, 'ºC'),
	(212790, 122, '2014-02-15 01:23:17.000000', 'temperatura', 70.0000, 'ºC'),
	(212791, 122, '2014-02-15 01:23:18.000000', 'temperatura', 418.0000, 'ºC'),
	(212792, 122, '2014-02-15 01:23:19.000000', 'temperatura', 681.0000, 'ºC'),
	(212793, 122, '2014-02-15 01:23:20.000000', 'temperatura', 949.0000, 'ºC'),
	(212794, 122, '2014-02-15 01:23:21.000000', 'temperatura', 302.0000, 'ºC'),
	(212795, 122, '2014-02-15 01:23:22.000000', 'temperatura', 1064.0000, 'ºC'),
	(212796, 122, '2014-02-15 01:23:23.000000', 'temperatura', 815.0000, 'ºC'),
	(212797, 122, '2014-02-15 01:23:24.000000', 'temperatura', 885.0000, 'ºC'),
	(212798, 122, '2014-02-15 01:23:25.000000', 'temperatura', 778.0000, 'ºC'),
	(212799, 122, '2014-02-15 01:23:26.000000', 'temperatura', 35.0000, 'ºC'),
	(212800, 122, '2014-02-15 01:23:27.000000', 'temperatura', 242.0000, 'ºC'),
	(212801, 122, '2014-02-15 01:23:28.000000', 'temperatura', 1106.0000, 'ºC'),
	(212802, 122, '2014-02-15 01:23:29.000000', 'temperatura', 5.0000, 'ºC'),
	(212803, 122, '2014-02-15 01:23:30.000000', 'temperatura', 306.0000, 'ºC'),
	(212804, 122, '2014-02-15 01:23:31.000000', 'temperatura', 316.0000, 'ºC'),
	(212805, 122, '2014-02-15 01:23:32.000000', 'temperatura', 664.0000, 'ºC'),
	(212806, 122, '2014-02-15 01:23:33.000000', 'temperatura', 1171.0000, 'ºC'),
	(212807, 122, '2014-02-15 01:23:34.000000', 'temperatura', 263.0000, 'ºC'),
	(212808, 122, '2014-02-15 01:23:35.000000', 'temperatura', 202.0000, 'ºC'),
	(212809, 122, '2014-02-15 01:23:36.000000', 'temperatura', 223.0000, 'ºC'),
	(212810, 122, '2014-02-15 01:23:37.000000', 'temperatura', 510.0000, 'ºC'),
	(212811, 122, '2014-02-15 01:23:38.000000', 'temperatura', 679.0000, 'ºC'),
	(212812, 122, '2014-02-15 01:23:39.000000', 'temperatura', 667.0000, 'ºC'),
	(212813, 122, '2014-02-15 01:23:40.000000', 'temperatura', 98.0000, 'ºC'),
	(212814, 122, '2014-02-15 01:23:41.000000', 'temperatura', 890.0000, 'ºC'),
	(212815, 122, '2014-02-15 01:23:42.000000', 'temperatura', 555.0000, 'ºC'),
	(212816, 122, '2014-02-15 01:23:43.000000', 'temperatura', 106.0000, 'ºC'),
	(212817, 122, '2014-02-15 01:23:44.000000', 'temperatura', 68.0000, 'ºC'),
	(212818, 122, '2014-02-15 01:23:45.000000', 'temperatura', 20.0000, 'ºC'),
	(212819, 122, '2014-02-15 01:23:46.000000', 'temperatura', 1099.0000, 'ºC'),
	(212820, 122, '2014-02-15 01:23:47.000000', 'temperatura', 633.0000, 'ºC'),
	(212821, 122, '2014-02-15 01:23:48.000000', 'temperatura', 1069.0000, 'ºC'),
	(212822, 122, '2014-02-15 01:23:49.000000', 'temperatura', 1045.0000, 'ºC'),
	(212823, 122, '2014-02-15 01:23:50.000000', 'temperatura', 821.0000, 'ºC'),
	(212824, 122, '2014-02-15 01:23:51.000000', 'temperatura', 970.0000, 'ºC'),
	(212825, 122, '2014-02-15 01:23:52.000000', 'temperatura', 1189.0000, 'ºC'),
	(212826, 122, '2014-02-15 01:23:53.000000', 'temperatura', 634.0000, 'ºC'),
	(212827, 122, '2014-02-15 01:23:54.000000', 'temperatura', 802.0000, 'ºC'),
	(212828, 122, '2014-02-15 01:23:55.000000', 'temperatura', 909.0000, 'ºC'),
	(212829, 122, '2014-02-15 01:23:56.000000', 'temperatura', 938.0000, 'ºC'),
	(212830, 122, '2014-02-15 01:23:57.000000', 'temperatura', 766.0000, 'ºC'),
	(212831, 122, '2014-02-15 01:23:58.000000', 'temperatura', 1017.0000, 'ºC'),
	(212832, 122, '2014-02-15 01:23:59.000000', 'temperatura', 388.0000, 'ºC'),
	(212833, 122, '2014-02-15 01:24:00.000000', 'temperatura', 89.0000, 'ºC'),
	(212834, 122, '2014-02-15 01:24:01.000000', 'temperatura', 479.0000, 'ºC'),
	(212835, 122, '2014-02-15 01:24:02.000000', 'temperatura', 932.0000, 'ºC'),
	(212836, 122, '2014-02-15 01:24:03.000000', 'temperatura', 822.0000, 'ºC'),
	(212837, 122, '2014-02-15 01:24:04.000000', 'temperatura', 115.0000, 'ºC'),
	(212838, 122, '2014-02-15 01:24:05.000000', 'temperatura', 507.0000, 'ºC'),
	(212839, 122, '2014-02-15 01:24:06.000000', 'temperatura', 994.0000, 'ºC'),
	(212840, 122, '2014-02-15 01:24:07.000000', 'temperatura', 1048.0000, 'ºC'),
	(212841, 122, '2014-02-15 01:24:08.000000', 'temperatura', 1058.0000, 'ºC'),
	(212842, 122, '2014-02-15 01:24:09.000000', 'temperatura', 946.0000, 'ºC'),
	(212843, 122, '2014-02-15 01:24:10.000000', 'temperatura', 357.0000, 'ºC'),
	(212844, 122, '2014-02-15 01:24:11.000000', 'temperatura', 149.0000, 'ºC'),
	(212845, 122, '2014-02-15 01:24:12.000000', 'temperatura', 874.0000, 'ºC'),
	(212846, 122, '2014-02-15 01:24:13.000000', 'temperatura', 325.0000, 'ºC'),
	(212847, 122, '2014-02-15 01:24:14.000000', 'temperatura', 201.0000, 'ºC'),
	(212848, 122, '2014-02-15 01:24:15.000000', 'temperatura', 32.0000, 'ºC'),
	(212849, 122, '2014-02-15 01:24:16.000000', 'temperatura', 757.0000, 'ºC'),
	(212850, 122, '2014-02-15 01:24:17.000000', 'temperatura', 89.0000, 'ºC'),
	(212851, 122, '2014-02-15 01:24:18.000000', 'temperatura', 575.0000, 'ºC'),
	(212852, 122, '2014-02-15 01:24:19.000000', 'temperatura', 206.0000, 'ºC'),
	(212853, 122, '2014-02-15 01:24:20.000000', 'temperatura', 509.0000, 'ºC'),
	(212854, 122, '2014-02-15 01:24:21.000000', 'temperatura', 726.0000, 'ºC'),
	(212855, 122, '2014-02-15 01:24:22.000000', 'temperatura', 904.0000, 'ºC'),
	(212856, 122, '2014-02-15 01:24:23.000000', 'temperatura', 1143.0000, 'ºC'),
	(212857, 122, '2014-02-15 01:24:24.000000', 'temperatura', 604.0000, 'ºC'),
	(212858, 122, '2014-02-15 01:24:25.000000', 'temperatura', 791.0000, 'ºC'),
	(212859, 122, '2014-02-15 01:24:26.000000', 'temperatura', 942.0000, 'ºC'),
	(212860, 122, '2014-02-15 01:24:27.000000', 'temperatura', 1138.0000, 'ºC'),
	(212861, 122, '2014-02-15 01:24:28.000000', 'temperatura', 465.0000, 'ºC'),
	(212862, 122, '2014-02-15 01:24:29.000000', 'temperatura', 111.0000, 'ºC'),
	(212863, 122, '2014-02-15 01:24:30.000000', 'temperatura', 360.0000, 'ºC'),
	(212864, 122, '2014-02-15 01:24:31.000000', 'temperatura', 266.0000, 'ºC'),
	(212865, 122, '2014-02-15 01:24:32.000000', 'temperatura', 252.0000, 'ºC'),
	(212866, 122, '2014-02-15 01:24:33.000000', 'temperatura', 463.0000, 'ºC'),
	(212867, 122, '2014-02-15 01:24:34.000000', 'temperatura', 361.0000, 'ºC'),
	(212868, 122, '2014-02-15 01:24:35.000000', 'temperatura', 416.0000, 'ºC'),
	(212869, 122, '2014-02-15 01:24:36.000000', 'temperatura', 996.0000, 'ºC'),
	(212870, 122, '2014-02-15 01:24:37.000000', 'temperatura', 132.0000, 'ºC'),
	(212871, 122, '2014-02-15 01:24:38.000000', 'temperatura', 73.0000, 'ºC'),
	(212872, 122, '2014-02-15 01:24:39.000000', 'temperatura', 1168.0000, 'ºC'),
	(212873, 122, '2014-02-15 01:24:40.000000', 'temperatura', 821.0000, 'ºC'),
	(212874, 122, '2014-02-15 01:24:41.000000', 'temperatura', 602.0000, 'ºC'),
	(212875, 122, '2014-02-15 01:24:42.000000', 'temperatura', 550.0000, 'ºC'),
	(212876, 122, '2014-02-15 01:24:43.000000', 'temperatura', 942.0000, 'ºC'),
	(212877, 122, '2014-02-15 01:24:44.000000', 'temperatura', 660.0000, 'ºC'),
	(212878, 122, '2014-02-15 01:24:45.000000', 'temperatura', 477.0000, 'ºC'),
	(212879, 122, '2014-02-15 01:24:46.000000', 'temperatura', 403.0000, 'ºC'),
	(212880, 122, '2014-02-15 01:24:47.000000', 'temperatura', 586.0000, 'ºC'),
	(212881, 122, '2014-02-15 01:24:48.000000', 'temperatura', 523.0000, 'ºC'),
	(212882, 122, '2014-02-15 01:24:49.000000', 'temperatura', 857.0000, 'ºC'),
	(212883, 122, '2014-02-15 01:24:50.000000', 'temperatura', 317.0000, 'ºC'),
	(212884, 122, '2014-02-15 01:24:51.000000', 'temperatura', 214.0000, 'ºC'),
	(212885, 122, '2014-02-15 01:24:52.000000', 'temperatura', 120.0000, 'ºC'),
	(212886, 122, '2014-02-15 01:24:53.000000', 'temperatura', 1157.0000, 'ºC'),
	(212887, 122, '2014-02-15 01:24:54.000000', 'temperatura', 627.0000, 'ºC'),
	(212888, 122, '2014-02-15 01:24:55.000000', 'temperatura', 864.0000, 'ºC'),
	(212889, 122, '2014-02-15 01:24:56.000000', 'temperatura', 38.0000, 'ºC'),
	(212890, 122, '2014-02-15 01:24:57.000000', 'temperatura', 1199.0000, 'ºC'),
	(212891, 122, '2014-02-15 01:24:58.000000', 'temperatura', 1084.0000, 'ºC'),
	(212892, 122, '2014-02-15 01:24:59.000000', 'temperatura', 621.0000, 'ºC'),
	(212893, 122, '2014-02-15 01:25:00.000000', 'temperatura', 1053.0000, 'ºC'),
	(212894, 122, '2014-02-15 01:25:01.000000', 'temperatura', 1003.0000, 'ºC'),
	(212895, 122, '2014-02-15 01:25:02.000000', 'temperatura', 657.0000, 'ºC'),
	(212896, 122, '2014-02-15 01:25:03.000000', 'temperatura', 277.0000, 'ºC'),
	(212897, 122, '2014-02-15 01:25:04.000000', 'temperatura', 614.0000, 'ºC'),
	(212898, 122, '2014-02-15 01:25:05.000000', 'temperatura', 1040.0000, 'ºC'),
	(212899, 122, '2014-02-15 01:25:06.000000', 'temperatura', 960.0000, 'ºC'),
	(212900, 122, '2014-02-15 01:25:07.000000', 'temperatura', 479.0000, 'ºC'),
	(212901, 122, '2014-02-15 01:25:08.000000', 'temperatura', 714.0000, 'ºC'),
	(212902, 122, '2014-02-15 01:25:09.000000', 'temperatura', 934.0000, 'ºC'),
	(212903, 122, '2014-02-15 01:25:10.000000', 'temperatura', 127.0000, 'ºC'),
	(212904, 122, '2014-02-15 01:25:11.000000', 'temperatura', 235.0000, 'ºC'),
	(212905, 122, '2014-02-15 01:25:12.000000', 'temperatura', 796.0000, 'ºC'),
	(212906, 122, '2014-02-15 01:25:13.000000', 'temperatura', 875.0000, 'ºC'),
	(212907, 122, '2014-02-15 01:25:14.000000', 'temperatura', 789.0000, 'ºC'),
	(212908, 122, '2014-02-15 01:25:15.000000', 'temperatura', 119.0000, 'ºC'),
	(212909, 122, '2014-02-15 01:25:16.000000', 'temperatura', 630.0000, 'ºC'),
	(212910, 122, '2014-02-15 01:25:17.000000', 'temperatura', 391.0000, 'ºC'),
	(212911, 122, '2014-02-15 01:25:18.000000', 'temperatura', 66.0000, 'ºC'),
	(212912, 122, '2014-02-15 01:25:19.000000', 'temperatura', 356.0000, 'ºC'),
	(212913, 122, '2014-02-15 01:25:20.000000', 'temperatura', 385.0000, 'ºC'),
	(212914, 122, '2014-02-15 01:25:21.000000', 'temperatura', 857.0000, 'ºC'),
	(212915, 122, '2014-02-15 01:25:22.000000', 'temperatura', 731.0000, 'ºC'),
	(212916, 122, '2014-02-15 01:25:23.000000', 'temperatura', 1082.0000, 'ºC'),
	(212917, 122, '2014-02-15 01:25:24.000000', 'temperatura', 821.0000, 'ºC'),
	(212918, 122, '2014-02-15 01:25:25.000000', 'temperatura', 858.0000, 'ºC'),
	(212919, 122, '2014-02-15 01:25:26.000000', 'temperatura', 626.0000, 'ºC'),
	(212920, 122, '2014-02-15 01:25:27.000000', 'temperatura', 556.0000, 'ºC'),
	(212921, 122, '2014-02-15 01:25:28.000000', 'temperatura', 904.0000, 'ºC'),
	(212922, 122, '2014-02-15 01:25:29.000000', 'temperatura', 452.0000, 'ºC'),
	(212923, 122, '2014-02-15 01:25:30.000000', 'temperatura', 750.0000, 'ºC'),
	(212924, 122, '2014-02-15 01:25:31.000000', 'temperatura', 1193.0000, 'ºC'),
	(212925, 122, '2014-02-15 01:25:32.000000', 'temperatura', 116.0000, 'ºC'),
	(212926, 122, '2014-02-15 01:25:33.000000', 'temperatura', 601.0000, 'ºC'),
	(212927, 122, '2014-02-15 01:25:34.000000', 'temperatura', 256.0000, 'ºC'),
	(212928, 122, '2014-02-15 01:25:35.000000', 'temperatura', 679.0000, 'ºC'),
	(212929, 122, '2014-02-15 01:25:36.000000', 'temperatura', 228.0000, 'ºC'),
	(212930, 122, '2014-02-15 01:25:37.000000', 'temperatura', 302.0000, 'ºC'),
	(212931, 122, '2014-02-15 01:25:38.000000', 'temperatura', 825.0000, 'ºC'),
	(212932, 122, '2014-02-15 01:25:39.000000', 'temperatura', 822.0000, 'ºC'),
	(212933, 122, '2014-02-15 01:25:40.000000', 'temperatura', 433.0000, 'ºC'),
	(212934, 122, '2014-02-15 01:25:41.000000', 'temperatura', 900.0000, 'ºC'),
	(212935, 122, '2014-02-15 01:25:42.000000', 'temperatura', 801.0000, 'ºC'),
	(212936, 122, '2014-02-15 01:25:43.000000', 'temperatura', 105.0000, 'ºC'),
	(212937, 122, '2014-02-15 01:25:44.000000', 'temperatura', 524.0000, 'ºC'),
	(212938, 122, '2014-02-15 01:25:45.000000', 'temperatura', 1105.0000, 'ºC'),
	(212939, 122, '2014-02-15 01:25:46.000000', 'temperatura', 355.0000, 'ºC'),
	(212940, 122, '2014-02-15 01:25:47.000000', 'temperatura', 858.0000, 'ºC'),
	(212941, 122, '2014-02-15 01:25:48.000000', 'temperatura', 828.0000, 'ºC'),
	(212942, 122, '2014-02-15 01:25:49.000000', 'temperatura', 365.0000, 'ºC'),
	(212943, 122, '2014-02-15 01:25:50.000000', 'temperatura', 540.0000, 'ºC'),
	(212944, 122, '2014-02-15 01:25:51.000000', 'temperatura', 406.0000, 'ºC'),
	(212945, 122, '2014-02-15 01:25:52.000000', 'temperatura', 413.0000, 'ºC'),
	(212946, 122, '2014-02-15 01:25:53.000000', 'temperatura', 845.0000, 'ºC'),
	(212947, 122, '2014-02-15 01:25:54.000000', 'temperatura', 589.0000, 'ºC'),
	(212948, 122, '2014-02-15 01:25:55.000000', 'temperatura', 408.0000, 'ºC'),
	(212949, 122, '2014-02-15 01:25:56.000000', 'temperatura', 274.0000, 'ºC'),
	(212950, 122, '2014-02-15 01:25:57.000000', 'temperatura', 147.0000, 'ºC'),
	(212951, 122, '2014-02-15 01:25:58.000000', 'temperatura', 1112.0000, 'ºC'),
	(212952, 122, '2014-02-15 01:25:59.000000', 'temperatura', 318.0000, 'ºC'),
	(212953, 122, '2014-02-15 01:26:00.000000', 'temperatura', 658.0000, 'ºC'),
	(212954, 122, '2014-02-15 01:26:01.000000', 'temperatura', 1137.0000, 'ºC'),
	(212955, 122, '2014-02-15 01:26:02.000000', 'temperatura', 109.0000, 'ºC'),
	(212956, 122, '2014-02-15 01:26:03.000000', 'temperatura', 734.0000, 'ºC'),
	(212957, 122, '2014-02-15 01:26:04.000000', 'temperatura', 946.0000, 'ºC'),
	(212958, 122, '2014-02-15 01:26:05.000000', 'temperatura', 126.0000, 'ºC'),
	(212959, 122, '2014-02-15 01:26:06.000000', 'temperatura', 194.0000, 'ºC'),
	(212960, 122, '2014-02-15 01:26:07.000000', 'temperatura', 591.0000, 'ºC'),
	(212961, 122, '2014-02-15 01:26:08.000000', 'temperatura', 1172.0000, 'ºC'),
	(212962, 122, '2014-02-15 01:26:09.000000', 'temperatura', 490.0000, 'ºC'),
	(212963, 122, '2014-02-15 01:26:10.000000', 'temperatura', 135.0000, 'ºC'),
	(212964, 122, '2014-02-15 01:26:11.000000', 'temperatura', 404.0000, 'ºC'),
	(212965, 122, '2014-02-15 01:26:12.000000', 'temperatura', 415.0000, 'ºC'),
	(212966, 122, '2014-02-15 01:26:13.000000', 'temperatura', 863.0000, 'ºC'),
	(212967, 122, '2014-02-15 01:26:14.000000', 'temperatura', 670.0000, 'ºC'),
	(212968, 122, '2014-02-15 01:26:15.000000', 'temperatura', 764.0000, 'ºC'),
	(212969, 122, '2014-02-15 01:26:16.000000', 'temperatura', 610.0000, 'ºC'),
	(212970, 122, '2014-02-15 01:26:17.000000', 'temperatura', 758.0000, 'ºC'),
	(212971, 122, '2014-02-15 01:26:18.000000', 'temperatura', 762.0000, 'ºC'),
	(212972, 122, '2014-02-15 01:26:19.000000', 'temperatura', 335.0000, 'ºC'),
	(212973, 122, '2014-02-15 01:26:20.000000', 'temperatura', 589.0000, 'ºC'),
	(212974, 122, '2014-02-15 01:26:21.000000', 'temperatura', 739.0000, 'ºC'),
	(212975, 122, '2014-02-15 01:26:22.000000', 'temperatura', 731.0000, 'ºC'),
	(212976, 122, '2014-02-15 01:26:23.000000', 'temperatura', 240.0000, 'ºC'),
	(212977, 122, '2014-02-15 01:26:24.000000', 'temperatura', 205.0000, 'ºC'),
	(212978, 122, '2014-02-15 01:26:25.000000', 'temperatura', 307.0000, 'ºC'),
	(212979, 122, '2014-02-15 01:26:26.000000', 'temperatura', 921.0000, 'ºC'),
	(212980, 122, '2014-02-15 01:26:27.000000', 'temperatura', 85.0000, 'ºC'),
	(212981, 122, '2014-02-15 01:26:28.000000', 'temperatura', 63.0000, 'ºC'),
	(212982, 122, '2014-02-15 01:26:29.000000', 'temperatura', 59.0000, 'ºC'),
	(212983, 122, '2014-02-15 01:26:30.000000', 'temperatura', 109.0000, 'ºC'),
	(212984, 122, '2014-02-15 01:26:31.000000', 'temperatura', 367.0000, 'ºC'),
	(212985, 122, '2014-02-15 01:26:32.000000', 'temperatura', 307.0000, 'ºC'),
	(212986, 122, '2014-02-15 01:26:33.000000', 'temperatura', 438.0000, 'ºC'),
	(212987, 122, '2014-02-15 01:26:34.000000', 'temperatura', 66.0000, 'ºC'),
	(212988, 122, '2014-02-15 01:26:35.000000', 'temperatura', 216.0000, 'ºC'),
	(212989, 122, '2014-02-15 01:26:36.000000', 'temperatura', 885.0000, 'ºC'),
	(212990, 122, '2014-02-15 01:26:37.000000', 'temperatura', 177.0000, 'ºC'),
	(212991, 122, '2014-02-15 01:26:38.000000', 'temperatura', 630.0000, 'ºC'),
	(212992, 122, '2014-02-15 01:26:39.000000', 'temperatura', 219.0000, 'ºC'),
	(212993, 122, '2014-02-15 01:26:40.000000', 'temperatura', 405.0000, 'ºC'),
	(212994, 122, '2014-02-15 01:26:41.000000', 'temperatura', 171.0000, 'ºC'),
	(212995, 122, '2014-02-15 01:26:42.000000', 'temperatura', 839.0000, 'ºC'),
	(212996, 122, '2014-02-15 01:26:43.000000', 'temperatura', 82.0000, 'ºC'),
	(212997, 122, '2014-02-15 01:26:44.000000', 'temperatura', 293.0000, 'ºC'),
	(212998, 122, '2014-02-15 01:26:45.000000', 'temperatura', 21.0000, 'ºC'),
	(212999, 122, '2014-02-15 01:26:46.000000', 'temperatura', 427.0000, 'ºC'),
	(213000, 122, '2014-02-15 01:26:47.000000', 'temperatura', 873.0000, 'ºC'),
	(213001, 122, '2014-02-15 01:26:48.000000', 'temperatura', 683.0000, 'ºC'),
	(213002, 122, '2014-02-15 01:26:49.000000', 'temperatura', 797.0000, 'ºC'),
	(213003, 122, '2014-02-15 01:26:50.000000', 'temperatura', 737.0000, 'ºC'),
	(213004, 122, '2014-02-15 01:26:51.000000', 'temperatura', 94.0000, 'ºC'),
	(213005, 122, '2014-02-15 01:26:52.000000', 'temperatura', 661.0000, 'ºC'),
	(213006, 122, '2014-02-15 01:26:53.000000', 'temperatura', 620.0000, 'ºC'),
	(213007, 122, '2014-02-15 01:26:54.000000', 'temperatura', 1121.0000, 'ºC'),
	(213008, 122, '2014-02-15 01:26:55.000000', 'temperatura', 145.0000, 'ºC'),
	(213009, 122, '2014-02-15 01:26:56.000000', 'temperatura', 963.0000, 'ºC'),
	(213010, 122, '2014-02-15 01:26:57.000000', 'temperatura', 779.0000, 'ºC'),
	(213011, 122, '2014-02-15 01:26:58.000000', 'temperatura', 1007.0000, 'ºC'),
	(213012, 122, '2014-02-15 01:26:59.000000', 'temperatura', 298.0000, 'ºC'),
	(213013, 122, '2014-02-15 01:27:00.000000', 'temperatura', 868.0000, 'ºC'),
	(213014, 122, '2014-02-15 01:27:01.000000', 'temperatura', 1047.0000, 'ºC'),
	(213015, 122, '2014-02-15 01:27:02.000000', 'temperatura', 231.0000, 'ºC'),
	(213016, 122, '2014-02-15 01:27:03.000000', 'temperatura', 415.0000, 'ºC'),
	(213017, 122, '2014-02-15 01:27:04.000000', 'temperatura', 184.0000, 'ºC'),
	(213018, 122, '2014-02-15 01:27:05.000000', 'temperatura', 875.0000, 'ºC'),
	(213019, 122, '2014-02-15 01:27:06.000000', 'temperatura', 222.0000, 'ºC'),
	(213020, 122, '2014-02-15 01:27:07.000000', 'temperatura', 886.0000, 'ºC'),
	(213021, 122, '2014-02-15 01:27:08.000000', 'temperatura', 164.0000, 'ºC'),
	(213022, 122, '2014-02-15 01:27:09.000000', 'temperatura', 563.0000, 'ºC'),
	(213023, 122, '2014-02-15 01:27:10.000000', 'temperatura', 1124.0000, 'ºC'),
	(213024, 122, '2014-02-15 01:27:11.000000', 'temperatura', 333.0000, 'ºC'),
	(213025, 122, '2014-02-15 01:27:12.000000', 'temperatura', 691.0000, 'ºC'),
	(213026, 122, '2014-02-15 01:27:13.000000', 'temperatura', 58.0000, 'ºC'),
	(213027, 122, '2014-02-15 01:27:14.000000', 'temperatura', 617.0000, 'ºC'),
	(213028, 122, '2014-02-15 01:27:15.000000', 'temperatura', 513.0000, 'ºC'),
	(213029, 122, '2014-02-15 01:27:16.000000', 'temperatura', 714.0000, 'ºC'),
	(213030, 122, '2014-02-15 01:27:17.000000', 'temperatura', 831.0000, 'ºC'),
	(213031, 122, '2014-02-15 01:27:18.000000', 'temperatura', 814.0000, 'ºC'),
	(213032, 122, '2014-02-15 01:27:19.000000', 'temperatura', 379.0000, 'ºC'),
	(213033, 122, '2014-02-15 01:27:20.000000', 'temperatura', 653.0000, 'ºC'),
	(213034, 122, '2014-02-15 01:27:21.000000', 'temperatura', 930.0000, 'ºC'),
	(213035, 122, '2014-02-15 01:27:22.000000', 'temperatura', 290.0000, 'ºC'),
	(213036, 122, '2014-02-15 01:27:23.000000', 'temperatura', 1059.0000, 'ºC'),
	(213037, 122, '2014-02-15 01:27:24.000000', 'temperatura', 828.0000, 'ºC'),
	(213038, 122, '2014-02-15 01:27:25.000000', 'temperatura', 964.0000, 'ºC'),
	(213039, 122, '2014-02-15 01:27:26.000000', 'temperatura', 1135.0000, 'ºC'),
	(213040, 122, '2014-02-15 01:27:27.000000', 'temperatura', 384.0000, 'ºC'),
	(213041, 122, '2014-02-15 01:27:28.000000', 'temperatura', 914.0000, 'ºC'),
	(213042, 122, '2014-02-15 01:27:29.000000', 'temperatura', 1018.0000, 'ºC'),
	(213043, 122, '2014-02-15 01:27:30.000000', 'temperatura', 1148.0000, 'ºC'),
	(213044, 122, '2014-02-15 01:27:31.000000', 'temperatura', 287.0000, 'ºC'),
	(213045, 122, '2014-02-15 01:27:32.000000', 'temperatura', 391.0000, 'ºC'),
	(213046, 122, '2014-02-15 01:27:33.000000', 'temperatura', 1097.0000, 'ºC'),
	(213047, 122, '2014-02-15 01:27:34.000000', 'temperatura', 710.0000, 'ºC'),
	(213048, 122, '2014-02-15 01:27:35.000000', 'temperatura', 262.0000, 'ºC'),
	(213049, 122, '2014-02-15 01:27:36.000000', 'temperatura', 381.0000, 'ºC'),
	(213050, 122, '2014-02-15 01:27:37.000000', 'temperatura', 1117.0000, 'ºC'),
	(213051, 122, '2014-02-15 01:27:38.000000', 'temperatura', 844.0000, 'ºC'),
	(213052, 122, '2014-02-15 01:27:39.000000', 'temperatura', 869.0000, 'ºC'),
	(213053, 122, '2014-02-15 01:27:40.000000', 'temperatura', 613.0000, 'ºC'),
	(213054, 122, '2014-02-15 01:27:41.000000', 'temperatura', 457.0000, 'ºC'),
	(213055, 122, '2014-02-15 01:27:42.000000', 'temperatura', 448.0000, 'ºC'),
	(213056, 122, '2014-02-15 01:27:43.000000', 'temperatura', 868.0000, 'ºC'),
	(213057, 122, '2014-02-15 01:27:44.000000', 'temperatura', 596.0000, 'ºC'),
	(213058, 122, '2014-02-15 01:27:45.000000', 'temperatura', 377.0000, 'ºC'),
	(213059, 122, '2014-02-15 01:27:46.000000', 'temperatura', 97.0000, 'ºC'),
	(213060, 122, '2014-02-15 01:27:47.000000', 'temperatura', 553.0000, 'ºC'),
	(213061, 122, '2014-02-15 01:27:48.000000', 'temperatura', 77.0000, 'ºC'),
	(213062, 122, '2014-02-15 01:27:49.000000', 'temperatura', 1128.0000, 'ºC'),
	(213063, 122, '2014-02-15 01:27:50.000000', 'temperatura', 606.0000, 'ºC'),
	(213064, 122, '2014-02-15 01:27:51.000000', 'temperatura', 848.0000, 'ºC'),
	(213065, 122, '2014-02-15 01:27:52.000000', 'temperatura', 23.0000, 'ºC'),
	(213066, 122, '2014-02-15 01:27:53.000000', 'temperatura', 1171.0000, 'ºC'),
	(213067, 122, '2014-02-15 01:27:54.000000', 'temperatura', 988.0000, 'ºC'),
	(213068, 122, '2014-02-15 01:27:55.000000', 'temperatura', 226.0000, 'ºC'),
	(213069, 122, '2014-02-15 01:27:56.000000', 'temperatura', 567.0000, 'ºC'),
	(213070, 122, '2014-02-15 01:27:57.000000', 'temperatura', 959.0000, 'ºC'),
	(213071, 122, '2014-02-15 01:27:58.000000', 'temperatura', 695.0000, 'ºC'),
	(213072, 122, '2014-02-15 01:27:59.000000', 'temperatura', 598.0000, 'ºC'),
	(213073, 122, '2014-02-15 01:28:00.000000', 'temperatura', 906.0000, 'ºC'),
	(213074, 122, '2014-02-15 01:28:01.000000', 'temperatura', 334.0000, 'ºC'),
	(213075, 122, '2014-02-15 01:28:02.000000', 'temperatura', 155.0000, 'ºC'),
	(213076, 122, '2014-02-15 01:28:03.000000', 'temperatura', 971.0000, 'ºC'),
	(213077, 122, '2014-02-15 01:28:04.000000', 'temperatura', 792.0000, 'ºC'),
	(213078, 122, '2014-02-15 01:28:05.000000', 'temperatura', 1046.0000, 'ºC'),
	(213079, 122, '2014-02-15 01:28:06.000000', 'temperatura', 453.0000, 'ºC'),
	(213080, 122, '2014-02-15 01:28:07.000000', 'temperatura', 331.0000, 'ºC'),
	(213081, 122, '2014-02-15 01:28:08.000000', 'temperatura', 294.0000, 'ºC'),
	(213082, 122, '2014-02-15 01:28:09.000000', 'temperatura', 478.0000, 'ºC'),
	(213083, 122, '2014-02-15 01:28:10.000000', 'temperatura', 307.0000, 'ºC'),
	(213084, 122, '2014-02-15 01:28:11.000000', 'temperatura', 103.0000, 'ºC'),
	(213085, 122, '2014-02-15 01:28:12.000000', 'temperatura', 794.0000, 'ºC'),
	(213086, 122, '2014-02-15 01:28:13.000000', 'temperatura', 61.0000, 'ºC'),
	(213087, 122, '2014-02-15 01:28:14.000000', 'temperatura', 322.0000, 'ºC'),
	(213088, 122, '2014-02-15 01:28:15.000000', 'temperatura', 230.0000, 'ºC'),
	(213089, 122, '2014-02-15 01:28:16.000000', 'temperatura', 183.0000, 'ºC'),
	(213090, 122, '2014-02-15 01:28:17.000000', 'temperatura', 226.0000, 'ºC'),
	(213091, 122, '2014-02-15 01:28:18.000000', 'temperatura', 582.0000, 'ºC'),
	(213092, 122, '2014-02-15 01:28:19.000000', 'temperatura', 1031.0000, 'ºC'),
	(213093, 122, '2014-02-15 01:28:20.000000', 'temperatura', 1012.0000, 'ºC'),
	(213094, 122, '2014-02-15 01:28:21.000000', 'temperatura', 764.0000, 'ºC'),
	(213095, 122, '2014-02-15 01:28:22.000000', 'temperatura', 788.0000, 'ºC'),
	(213096, 122, '2014-02-15 01:28:23.000000', 'temperatura', 446.0000, 'ºC'),
	(213097, 122, '2014-02-15 01:28:24.000000', 'temperatura', 1069.0000, 'ºC'),
	(213098, 122, '2014-02-15 01:28:25.000000', 'temperatura', 408.0000, 'ºC'),
	(213099, 122, '2014-02-15 01:28:26.000000', 'temperatura', 33.0000, 'ºC'),
	(213100, 122, '2014-02-15 01:28:27.000000', 'temperatura', 140.0000, 'ºC'),
	(213101, 122, '2014-02-15 01:28:28.000000', 'temperatura', 600.0000, 'ºC'),
	(213102, 122, '2014-02-15 01:28:29.000000', 'temperatura', 184.0000, 'ºC'),
	(213103, 122, '2014-02-15 01:28:30.000000', 'temperatura', 319.0000, 'ºC'),
	(213104, 122, '2014-02-15 01:28:31.000000', 'temperatura', 1042.0000, 'ºC'),
	(213105, 122, '2014-02-15 01:28:32.000000', 'temperatura', 654.0000, 'ºC'),
	(213106, 122, '2014-02-15 01:28:33.000000', 'temperatura', 147.0000, 'ºC'),
	(213107, 122, '2014-02-15 01:28:34.000000', 'temperatura', 1171.0000, 'ºC'),
	(213108, 122, '2014-02-15 01:28:35.000000', 'temperatura', 614.0000, 'ºC'),
	(213109, 122, '2014-02-15 01:28:36.000000', 'temperatura', 760.0000, 'ºC'),
	(213110, 122, '2014-02-15 01:28:37.000000', 'temperatura', 759.0000, 'ºC'),
	(213111, 122, '2014-02-15 01:28:38.000000', 'temperatura', 316.0000, 'ºC'),
	(213112, 122, '2014-02-15 01:28:39.000000', 'temperatura', 501.0000, 'ºC'),
	(213113, 122, '2014-02-15 01:28:40.000000', 'temperatura', 357.0000, 'ºC'),
	(213114, 122, '2014-02-15 01:28:41.000000', 'temperatura', 283.0000, 'ºC'),
	(213115, 122, '2014-02-15 01:28:42.000000', 'temperatura', 345.0000, 'ºC'),
	(213116, 122, '2014-02-15 01:28:43.000000', 'temperatura', 875.0000, 'ºC'),
	(213117, 122, '2014-02-15 01:28:44.000000', 'temperatura', 943.0000, 'ºC'),
	(213118, 122, '2014-02-15 01:28:45.000000', 'temperatura', 890.0000, 'ºC'),
	(213119, 122, '2014-02-15 01:28:46.000000', 'temperatura', 421.0000, 'ºC'),
	(213120, 122, '2014-02-15 01:28:47.000000', 'temperatura', 634.0000, 'ºC'),
	(213121, 122, '2014-02-15 01:28:48.000000', 'temperatura', 707.0000, 'ºC'),
	(213122, 122, '2014-02-15 01:28:49.000000', 'temperatura', 435.0000, 'ºC'),
	(213123, 122, '2014-02-15 01:28:50.000000', 'temperatura', 55.0000, 'ºC'),
	(213124, 122, '2014-02-15 01:28:51.000000', 'temperatura', 170.0000, 'ºC'),
	(213125, 122, '2014-02-15 01:28:52.000000', 'temperatura', 685.0000, 'ºC'),
	(213126, 122, '2014-02-15 01:28:53.000000', 'temperatura', 518.0000, 'ºC'),
	(213127, 122, '2014-02-15 01:28:54.000000', 'temperatura', 534.0000, 'ºC'),
	(213128, 122, '2014-02-15 01:28:55.000000', 'temperatura', 1115.0000, 'ºC'),
	(213129, 122, '2014-02-15 01:28:56.000000', 'temperatura', 374.0000, 'ºC'),
	(213130, 122, '2014-02-15 01:28:57.000000', 'temperatura', 926.0000, 'ºC'),
	(213131, 122, '2014-02-15 01:28:58.000000', 'temperatura', 1110.0000, 'ºC'),
	(213132, 122, '2014-02-15 01:28:59.000000', 'temperatura', 373.0000, 'ºC'),
	(213133, 122, '2014-02-15 01:29:00.000000', 'temperatura', 935.0000, 'ºC'),
	(213134, 122, '2014-02-15 01:29:01.000000', 'temperatura', 1156.0000, 'ºC'),
	(213135, 122, '2014-02-15 01:29:02.000000', 'temperatura', 576.0000, 'ºC'),
	(213136, 122, '2014-02-15 01:29:03.000000', 'temperatura', 613.0000, 'ºC'),
	(213137, 122, '2014-02-15 01:29:04.000000', 'temperatura', 139.0000, 'ºC'),
	(213138, 122, '2014-02-15 01:29:05.000000', 'temperatura', 53.0000, 'ºC'),
	(213139, 122, '2014-02-15 01:29:06.000000', 'temperatura', 1051.0000, 'ºC'),
	(213140, 122, '2014-02-15 01:29:07.000000', 'temperatura', 296.0000, 'ºC'),
	(213141, 122, '2014-02-15 01:29:08.000000', 'temperatura', 727.0000, 'ºC'),
	(213142, 122, '2014-02-15 01:29:09.000000', 'temperatura', 346.0000, 'ºC'),
	(213143, 122, '2014-02-15 01:29:10.000000', 'temperatura', 751.0000, 'ºC'),
	(213144, 122, '2014-02-15 01:29:11.000000', 'temperatura', 316.0000, 'ºC'),
	(213145, 122, '2014-02-15 01:29:12.000000', 'temperatura', 528.0000, 'ºC'),
	(213146, 122, '2014-02-15 01:29:13.000000', 'temperatura', 491.0000, 'ºC'),
	(213147, 122, '2014-02-15 01:29:14.000000', 'temperatura', 871.0000, 'ºC'),
	(213148, 122, '2014-02-15 01:29:15.000000', 'temperatura', 485.0000, 'ºC'),
	(213149, 122, '2014-02-15 01:29:16.000000', 'temperatura', 1012.0000, 'ºC'),
	(213150, 122, '2014-02-15 01:29:17.000000', 'temperatura', 5.0000, 'ºC'),
	(213151, 122, '2014-02-15 01:29:18.000000', 'temperatura', 591.0000, 'ºC'),
	(213152, 122, '2014-02-15 01:29:19.000000', 'temperatura', 540.0000, 'ºC'),
	(213153, 122, '2014-02-15 01:29:20.000000', 'temperatura', 928.0000, 'ºC'),
	(213154, 122, '2014-02-15 01:29:21.000000', 'temperatura', 618.0000, 'ºC'),
	(213155, 122, '2014-02-15 01:29:22.000000', 'temperatura', 309.0000, 'ºC'),
	(213156, 122, '2014-02-15 01:29:23.000000', 'temperatura', 889.0000, 'ºC'),
	(213157, 122, '2014-02-15 01:29:24.000000', 'temperatura', 1120.0000, 'ºC'),
	(213158, 122, '2014-02-15 01:29:25.000000', 'temperatura', 533.0000, 'ºC'),
	(213159, 122, '2014-02-15 01:29:26.000000', 'temperatura', 506.0000, 'ºC'),
	(213160, 122, '2014-02-15 01:29:27.000000', 'temperatura', 933.0000, 'ºC'),
	(213161, 122, '2014-02-15 01:29:28.000000', 'temperatura', 747.0000, 'ºC'),
	(213162, 122, '2014-02-15 01:29:29.000000', 'temperatura', 934.0000, 'ºC'),
	(213163, 122, '2014-02-15 01:29:30.000000', 'temperatura', 32.0000, 'ºC'),
	(213164, 122, '2014-02-15 01:29:31.000000', 'temperatura', 956.0000, 'ºC'),
	(213165, 122, '2014-02-15 01:29:32.000000', 'temperatura', 1084.0000, 'ºC'),
	(213166, 122, '2014-02-15 01:29:33.000000', 'temperatura', 154.0000, 'ºC'),
	(213167, 122, '2014-02-15 01:29:34.000000', 'temperatura', 1117.0000, 'ºC'),
	(213168, 122, '2014-02-15 01:29:35.000000', 'temperatura', 325.0000, 'ºC'),
	(213169, 122, '2014-02-15 01:29:36.000000', 'temperatura', 676.0000, 'ºC'),
	(213170, 122, '2014-02-15 01:29:37.000000', 'temperatura', 3.0000, 'ºC'),
	(213171, 122, '2014-02-15 01:29:38.000000', 'temperatura', 387.0000, 'ºC'),
	(213172, 122, '2014-02-15 01:29:39.000000', 'temperatura', 727.0000, 'ºC'),
	(213173, 122, '2014-02-15 01:29:40.000000', 'temperatura', 73.0000, 'ºC'),
	(213174, 122, '2014-02-15 01:29:41.000000', 'temperatura', 587.0000, 'ºC'),
	(213175, 122, '2014-02-15 01:29:42.000000', 'temperatura', 315.0000, 'ºC'),
	(213176, 122, '2014-02-15 01:29:43.000000', 'temperatura', 1015.0000, 'ºC'),
	(213177, 122, '2014-02-15 01:29:44.000000', 'temperatura', 531.0000, 'ºC'),
	(213178, 122, '2014-02-15 01:29:45.000000', 'temperatura', 811.0000, 'ºC'),
	(213179, 122, '2014-02-15 01:29:46.000000', 'temperatura', 62.0000, 'ºC'),
	(213180, 122, '2014-02-15 01:29:47.000000', 'temperatura', 276.0000, 'ºC'),
	(213181, 122, '2014-02-15 01:29:48.000000', 'temperatura', 1196.0000, 'ºC'),
	(213182, 122, '2014-02-15 01:29:49.000000', 'temperatura', 354.0000, 'ºC'),
	(213183, 122, '2014-02-15 01:29:50.000000', 'temperatura', 581.0000, 'ºC'),
	(213184, 122, '2014-02-15 01:29:51.000000', 'temperatura', 646.0000, 'ºC'),
	(213185, 122, '2014-02-15 01:29:52.000000', 'temperatura', 285.0000, 'ºC'),
	(213186, 122, '2014-02-15 01:29:53.000000', 'temperatura', 688.0000, 'ºC'),
	(213187, 122, '2014-02-15 01:29:54.000000', 'temperatura', 184.0000, 'ºC'),
	(213188, 122, '2014-02-15 01:29:55.000000', 'temperatura', 58.0000, 'ºC'),
	(213189, 122, '2014-02-15 01:29:56.000000', 'temperatura', 938.0000, 'ºC'),
	(213190, 122, '2014-02-15 01:29:57.000000', 'temperatura', 916.0000, 'ºC'),
	(213191, 122, '2014-02-15 01:29:58.000000', 'temperatura', 566.0000, 'ºC'),
	(213192, 122, '2014-02-15 01:29:59.000000', 'temperatura', 82.0000, 'ºC'),
	(213193, 122, '2014-02-15 01:30:00.000000', 'temperatura', 1112.0000, 'ºC'),
	(213194, 122, '2014-02-15 01:30:01.000000', 'temperatura', 514.0000, 'ºC'),
	(213195, 122, '2014-02-15 01:30:02.000000', 'temperatura', 436.0000, 'ºC'),
	(213196, 122, '2014-02-15 01:30:03.000000', 'temperatura', 637.0000, 'ºC'),
	(213197, 122, '2014-02-15 01:30:04.000000', 'temperatura', 679.0000, 'ºC'),
	(213198, 122, '2014-02-15 01:30:05.000000', 'temperatura', 284.0000, 'ºC'),
	(213199, 122, '2014-02-15 01:30:06.000000', 'temperatura', 582.0000, 'ºC'),
	(213200, 122, '2014-02-15 01:30:07.000000', 'temperatura', 860.0000, 'ºC'),
	(213201, 122, '2014-02-15 01:30:08.000000', 'temperatura', 155.0000, 'ºC'),
	(213202, 122, '2014-02-15 01:30:09.000000', 'temperatura', 594.0000, 'ºC'),
	(213203, 122, '2014-02-15 01:30:10.000000', 'temperatura', 105.0000, 'ºC'),
	(213204, 122, '2014-02-15 01:30:11.000000', 'temperatura', 1145.0000, 'ºC'),
	(213205, 122, '2014-02-15 01:30:12.000000', 'temperatura', 609.0000, 'ºC'),
	(213206, 122, '2014-02-15 01:30:13.000000', 'temperatura', 813.0000, 'ºC'),
	(213207, 122, '2014-02-15 01:30:14.000000', 'temperatura', 1038.0000, 'ºC'),
	(213208, 122, '2014-02-15 01:30:15.000000', 'temperatura', 351.0000, 'ºC'),
	(213209, 122, '2014-02-15 01:30:16.000000', 'temperatura', 1041.0000, 'ºC'),
	(213210, 122, '2014-02-15 01:30:17.000000', 'temperatura', 554.0000, 'ºC'),
	(213211, 122, '2014-02-15 01:30:18.000000', 'temperatura', 849.0000, 'ºC'),
	(213212, 122, '2014-02-15 01:30:19.000000', 'temperatura', 181.0000, 'ºC'),
	(213213, 122, '2014-02-15 01:30:20.000000', 'temperatura', 760.0000, 'ºC'),
	(213214, 122, '2014-02-15 01:30:21.000000', 'temperatura', 855.0000, 'ºC'),
	(213215, 122, '2014-02-15 01:30:22.000000', 'temperatura', 796.0000, 'ºC'),
	(213216, 122, '2014-02-15 01:30:23.000000', 'temperatura', 218.0000, 'ºC'),
	(213217, 122, '2014-02-15 01:30:24.000000', 'temperatura', 1102.0000, 'ºC'),
	(213218, 122, '2014-02-15 01:30:25.000000', 'temperatura', 55.0000, 'ºC'),
	(213219, 122, '2014-02-15 01:30:26.000000', 'temperatura', 572.0000, 'ºC'),
	(213220, 122, '2014-02-15 01:30:27.000000', 'temperatura', 294.0000, 'ºC'),
	(213221, 122, '2014-02-15 01:30:28.000000', 'temperatura', 955.0000, 'ºC'),
	(213222, 122, '2014-02-15 01:30:29.000000', 'temperatura', 295.0000, 'ºC'),
	(213223, 122, '2014-02-15 01:30:30.000000', 'temperatura', 1007.0000, 'ºC'),
	(213224, 122, '2014-02-15 01:30:31.000000', 'temperatura', 554.0000, 'ºC'),
	(213225, 122, '2014-02-15 01:30:32.000000', 'temperatura', 946.0000, 'ºC'),
	(213226, 122, '2014-02-15 01:30:33.000000', 'temperatura', 670.0000, 'ºC'),
	(213227, 122, '2014-02-15 01:30:34.000000', 'temperatura', 513.0000, 'ºC'),
	(213228, 122, '2014-02-15 01:30:35.000000', 'temperatura', 556.0000, 'ºC'),
	(213229, 122, '2014-02-15 01:30:36.000000', 'temperatura', 43.0000, 'ºC'),
	(213230, 122, '2014-02-15 01:30:37.000000', 'temperatura', 946.0000, 'ºC'),
	(213231, 122, '2014-02-15 01:30:38.000000', 'temperatura', 1003.0000, 'ºC'),
	(213232, 122, '2014-02-15 01:30:39.000000', 'temperatura', 974.0000, 'ºC'),
	(213233, 122, '2014-02-15 01:30:40.000000', 'temperatura', 665.0000, 'ºC'),
	(213234, 122, '2014-02-15 01:30:41.000000', 'temperatura', 402.0000, 'ºC'),
	(213235, 122, '2014-02-15 01:30:42.000000', 'temperatura', 18.0000, 'ºC'),
	(213236, 122, '2014-02-15 01:30:43.000000', 'temperatura', 82.0000, 'ºC'),
	(213237, 122, '2014-02-15 01:30:44.000000', 'temperatura', 355.0000, 'ºC'),
	(213238, 122, '2014-02-15 01:30:45.000000', 'temperatura', 332.0000, 'ºC'),
	(213239, 122, '2014-02-15 01:30:46.000000', 'temperatura', 594.0000, 'ºC'),
	(213240, 122, '2014-02-15 01:30:47.000000', 'temperatura', 776.0000, 'ºC'),
	(213241, 122, '2014-02-15 01:30:48.000000', 'temperatura', 899.0000, 'ºC'),
	(213242, 122, '2014-02-15 01:30:49.000000', 'temperatura', 965.0000, 'ºC'),
	(213243, 122, '2014-02-15 01:30:50.000000', 'temperatura', 928.0000, 'ºC'),
	(213244, 122, '2014-02-15 01:30:51.000000', 'temperatura', 547.0000, 'ºC'),
	(213245, 122, '2014-02-15 01:30:52.000000', 'temperatura', 1150.0000, 'ºC'),
	(213246, 122, '2014-02-15 01:30:53.000000', 'temperatura', 512.0000, 'ºC'),
	(213247, 122, '2014-02-15 01:30:54.000000', 'temperatura', 311.0000, 'ºC'),
	(213248, 122, '2014-02-15 01:30:55.000000', 'temperatura', 18.0000, 'ºC'),
	(213249, 122, '2014-02-15 01:30:56.000000', 'temperatura', 358.0000, 'ºC'),
	(213250, 122, '2014-02-15 01:30:57.000000', 'temperatura', 536.0000, 'ºC'),
	(213251, 122, '2014-02-15 01:30:58.000000', 'temperatura', 406.0000, 'ºC'),
	(213252, 122, '2014-02-15 01:30:59.000000', 'temperatura', 424.0000, 'ºC'),
	(213253, 122, '2014-02-15 01:31:00.000000', 'temperatura', 901.0000, 'ºC'),
	(213254, 122, '2014-02-15 01:31:01.000000', 'temperatura', 836.0000, 'ºC'),
	(213255, 122, '2014-02-15 01:31:02.000000', 'temperatura', 276.0000, 'ºC'),
	(213256, 122, '2014-02-15 01:31:03.000000', 'temperatura', 71.0000, 'ºC'),
	(213257, 122, '2014-02-15 01:31:04.000000', 'temperatura', 728.0000, 'ºC'),
	(213258, 122, '2014-02-15 01:31:05.000000', 'temperatura', 1027.0000, 'ºC'),
	(213259, 122, '2014-02-15 01:31:06.000000', 'temperatura', 553.0000, 'ºC'),
	(213260, 122, '2014-02-15 01:31:07.000000', 'temperatura', 883.0000, 'ºC'),
	(213261, 122, '2014-02-15 01:31:08.000000', 'temperatura', 356.0000, 'ºC'),
	(213262, 122, '2014-02-15 01:31:09.000000', 'temperatura', 331.0000, 'ºC'),
	(213263, 122, '2014-02-15 01:31:10.000000', 'temperatura', 590.0000, 'ºC'),
	(213264, 122, '2014-02-15 01:31:11.000000', 'temperatura', 756.0000, 'ºC'),
	(213265, 122, '2014-02-15 01:31:12.000000', 'temperatura', 809.0000, 'ºC'),
	(213266, 122, '2014-02-15 01:31:13.000000', 'temperatura', 577.0000, 'ºC'),
	(213267, 122, '2014-02-15 01:31:14.000000', 'temperatura', 461.0000, 'ºC'),
	(213268, 122, '2014-02-15 01:31:15.000000', 'temperatura', 574.0000, 'ºC'),
	(213269, 122, '2014-02-15 01:31:16.000000', 'temperatura', 288.0000, 'ºC'),
	(213270, 122, '2014-02-15 01:31:17.000000', 'temperatura', 917.0000, 'ºC'),
	(213271, 122, '2014-02-15 01:31:18.000000', 'temperatura', 122.0000, 'ºC'),
	(213272, 122, '2014-02-15 01:31:19.000000', 'temperatura', 259.0000, 'ºC'),
	(213273, 122, '2014-02-15 01:31:20.000000', 'temperatura', 929.0000, 'ºC'),
	(213274, 122, '2014-02-15 01:31:21.000000', 'temperatura', 270.0000, 'ºC'),
	(213275, 122, '2014-02-15 01:31:22.000000', 'temperatura', 961.0000, 'ºC'),
	(213276, 122, '2014-02-15 01:31:23.000000', 'temperatura', 397.0000, 'ºC'),
	(213277, 122, '2014-02-15 01:31:24.000000', 'temperatura', 302.0000, 'ºC'),
	(213278, 122, '2014-02-15 01:31:25.000000', 'temperatura', 321.0000, 'ºC'),
	(213279, 122, '2014-02-15 01:31:26.000000', 'temperatura', 697.0000, 'ºC'),
	(213280, 122, '2014-02-15 01:31:27.000000', 'temperatura', 124.0000, 'ºC'),
	(213281, 122, '2014-02-15 01:31:28.000000', 'temperatura', 929.0000, 'ºC'),
	(213282, 122, '2014-02-15 01:31:29.000000', 'temperatura', 672.0000, 'ºC'),
	(213283, 122, '2014-02-15 01:31:30.000000', 'temperatura', 576.0000, 'ºC'),
	(213284, 122, '2014-02-15 01:31:31.000000', 'temperatura', 865.0000, 'ºC'),
	(213285, 122, '2014-02-15 01:31:32.000000', 'temperatura', 195.0000, 'ºC'),
	(213286, 122, '2014-02-15 01:31:33.000000', 'temperatura', 780.0000, 'ºC'),
	(213287, 122, '2014-02-15 01:31:34.000000', 'temperatura', 915.0000, 'ºC'),
	(213288, 122, '2014-02-15 01:31:35.000000', 'temperatura', 1039.0000, 'ºC'),
	(213289, 122, '2014-02-15 01:31:36.000000', 'temperatura', 47.0000, 'ºC'),
	(213290, 122, '2014-02-15 01:31:37.000000', 'temperatura', 721.0000, 'ºC'),
	(213291, 122, '2014-02-15 01:31:38.000000', 'temperatura', 1062.0000, 'ºC'),
	(213292, 122, '2014-02-15 01:31:39.000000', 'temperatura', 748.0000, 'ºC'),
	(213293, 122, '2014-02-15 01:31:40.000000', 'temperatura', 556.0000, 'ºC'),
	(213294, 122, '2014-02-15 01:31:41.000000', 'temperatura', 534.0000, 'ºC'),
	(213295, 122, '2014-02-15 01:31:42.000000', 'temperatura', 1003.0000, 'ºC'),
	(213296, 122, '2014-02-15 01:31:43.000000', 'temperatura', 1013.0000, 'ºC'),
	(213297, 122, '2014-02-15 01:31:44.000000', 'temperatura', 856.0000, 'ºC'),
	(213298, 122, '2014-02-15 01:31:45.000000', 'temperatura', 44.0000, 'ºC'),
	(213299, 122, '2014-02-15 01:31:46.000000', 'temperatura', 51.0000, 'ºC'),
	(213300, 122, '2014-02-15 01:31:47.000000', 'temperatura', 126.0000, 'ºC'),
	(213301, 122, '2014-02-15 01:31:48.000000', 'temperatura', 475.0000, 'ºC'),
	(213302, 122, '2014-02-15 01:31:49.000000', 'temperatura', 799.0000, 'ºC'),
	(213303, 122, '2014-02-15 01:31:50.000000', 'temperatura', 170.0000, 'ºC'),
	(213304, 122, '2014-02-15 01:31:51.000000', 'temperatura', 853.0000, 'ºC'),
	(213305, 122, '2014-02-15 01:31:52.000000', 'temperatura', 155.0000, 'ºC'),
	(213306, 122, '2014-02-15 01:31:53.000000', 'temperatura', 619.0000, 'ºC'),
	(213307, 122, '2014-02-15 01:31:54.000000', 'temperatura', 230.0000, 'ºC'),
	(213308, 122, '2014-02-15 01:31:55.000000', 'temperatura', 492.0000, 'ºC'),
	(213309, 122, '2014-02-15 01:31:56.000000', 'temperatura', 570.0000, 'ºC'),
	(213310, 122, '2014-02-15 01:31:57.000000', 'temperatura', 177.0000, 'ºC'),
	(213311, 122, '2014-02-15 01:31:58.000000', 'temperatura', 375.0000, 'ºC'),
	(213312, 122, '2014-02-15 01:31:59.000000', 'temperatura', 142.0000, 'ºC'),
	(213313, 122, '2014-02-15 01:32:00.000000', 'temperatura', 789.0000, 'ºC'),
	(213314, 122, '2014-02-15 01:32:01.000000', 'temperatura', 1116.0000, 'ºC'),
	(213315, 122, '2014-02-15 01:32:02.000000', 'temperatura', 815.0000, 'ºC'),
	(213316, 122, '2014-02-15 01:32:03.000000', 'temperatura', 729.0000, 'ºC'),
	(213317, 122, '2014-02-15 01:32:04.000000', 'temperatura', 1198.0000, 'ºC'),
	(213318, 122, '2014-02-15 01:32:05.000000', 'temperatura', 204.0000, 'ºC'),
	(213319, 122, '2014-02-15 01:32:06.000000', 'temperatura', 1026.0000, 'ºC'),
	(213320, 122, '2014-02-15 01:32:07.000000', 'temperatura', 921.0000, 'ºC'),
	(213321, 122, '2014-02-15 01:32:08.000000', 'temperatura', 325.0000, 'ºC'),
	(213322, 122, '2014-02-15 01:32:09.000000', 'temperatura', 61.0000, 'ºC'),
	(213323, 122, '2014-02-15 01:32:10.000000', 'temperatura', 533.0000, 'ºC'),
	(213324, 122, '2014-02-15 01:32:11.000000', 'temperatura', 82.0000, 'ºC'),
	(213325, 122, '2014-02-15 01:32:12.000000', 'temperatura', 12.0000, 'ºC'),
	(213326, 122, '2014-02-15 01:32:13.000000', 'temperatura', 1015.0000, 'ºC'),
	(213327, 122, '2014-02-15 01:32:14.000000', 'temperatura', 241.0000, 'ºC'),
	(213328, 122, '2014-02-15 01:32:15.000000', 'temperatura', 559.0000, 'ºC'),
	(213329, 122, '2014-02-15 01:32:16.000000', 'temperatura', 871.0000, 'ºC'),
	(213330, 122, '2014-02-15 01:32:17.000000', 'temperatura', 278.0000, 'ºC'),
	(213331, 122, '2014-02-15 01:32:18.000000', 'temperatura', 1180.0000, 'ºC'),
	(213332, 122, '2014-02-15 01:32:19.000000', 'temperatura', 264.0000, 'ºC'),
	(213333, 122, '2014-02-15 01:32:20.000000', 'temperatura', 181.0000, 'ºC'),
	(213334, 122, '2014-02-15 01:32:21.000000', 'temperatura', 113.0000, 'ºC'),
	(213335, 122, '2014-02-15 01:32:22.000000', 'temperatura', 23.0000, 'ºC'),
	(213336, 122, '2014-02-15 01:32:23.000000', 'temperatura', 975.0000, 'ºC'),
	(213337, 122, '2014-02-15 01:32:24.000000', 'temperatura', 7.0000, 'ºC'),
	(213338, 122, '2014-02-15 01:32:25.000000', 'temperatura', 711.0000, 'ºC'),
	(213339, 122, '2014-02-15 01:32:26.000000', 'temperatura', 1137.0000, 'ºC'),
	(213340, 122, '2014-02-15 01:32:27.000000', 'temperatura', 1149.0000, 'ºC'),
	(213341, 122, '2014-02-15 01:32:28.000000', 'temperatura', 1134.0000, 'ºC'),
	(213342, 122, '2014-02-15 01:32:29.000000', 'temperatura', 1026.0000, 'ºC'),
	(213343, 122, '2014-02-15 01:32:30.000000', 'temperatura', 529.0000, 'ºC'),
	(213344, 122, '2014-02-15 01:32:31.000000', 'temperatura', 767.0000, 'ºC'),
	(213345, 122, '2014-02-15 01:32:32.000000', 'temperatura', 1047.0000, 'ºC'),
	(213346, 122, '2014-02-15 01:32:33.000000', 'temperatura', 533.0000, 'ºC'),
	(213347, 122, '2014-02-15 01:32:34.000000', 'temperatura', 727.0000, 'ºC'),
	(213348, 122, '2014-02-15 01:32:35.000000', 'temperatura', 837.0000, 'ºC'),
	(213349, 122, '2014-02-15 01:32:36.000000', 'temperatura', 804.0000, 'ºC'),
	(213350, 122, '2014-02-15 01:32:37.000000', 'temperatura', 307.0000, 'ºC'),
	(213351, 122, '2014-02-15 01:32:38.000000', 'temperatura', 326.0000, 'ºC'),
	(213352, 122, '2014-02-15 01:32:39.000000', 'temperatura', 709.0000, 'ºC'),
	(213353, 122, '2014-02-15 01:32:40.000000', 'temperatura', 166.0000, 'ºC'),
	(213354, 122, '2014-02-15 01:32:41.000000', 'temperatura', 1102.0000, 'ºC'),
	(213355, 122, '2014-02-15 01:32:42.000000', 'temperatura', 216.0000, 'ºC'),
	(213356, 122, '2014-02-15 01:32:43.000000', 'temperatura', 175.0000, 'ºC'),
	(213357, 122, '2014-02-15 01:32:44.000000', 'temperatura', 225.0000, 'ºC'),
	(213358, 122, '2014-02-15 01:32:45.000000', 'temperatura', 602.0000, 'ºC'),
	(213359, 122, '2014-02-15 01:32:46.000000', 'temperatura', 1137.0000, 'ºC'),
	(213360, 122, '2014-02-15 01:32:47.000000', 'temperatura', 279.0000, 'ºC'),
	(213361, 122, '2014-02-15 01:32:48.000000', 'temperatura', 382.0000, 'ºC'),
	(213362, 122, '2014-02-15 01:32:49.000000', 'temperatura', 1074.0000, 'ºC'),
	(213363, 122, '2014-02-15 01:32:50.000000', 'temperatura', 624.0000, 'ºC'),
	(213364, 122, '2014-02-15 01:32:51.000000', 'temperatura', 1101.0000, 'ºC'),
	(213365, 122, '2014-02-15 01:32:52.000000', 'temperatura', 32.0000, 'ºC'),
	(213366, 122, '2014-02-15 01:32:53.000000', 'temperatura', 458.0000, 'ºC'),
	(213367, 122, '2014-02-15 01:32:54.000000', 'temperatura', 995.0000, 'ºC'),
	(213368, 122, '2014-02-15 01:32:55.000000', 'temperatura', 2.0000, 'ºC'),
	(213369, 122, '2014-02-15 01:32:56.000000', 'temperatura', 626.0000, 'ºC'),
	(213370, 122, '2014-02-15 01:32:57.000000', 'temperatura', 724.0000, 'ºC'),
	(213371, 122, '2014-02-15 01:32:58.000000', 'temperatura', 540.0000, 'ºC'),
	(213372, 122, '2014-02-15 01:32:59.000000', 'temperatura', 532.0000, 'ºC'),
	(213373, 122, '2014-02-15 01:33:00.000000', 'temperatura', 1038.0000, 'ºC'),
	(213374, 122, '2014-02-15 01:33:01.000000', 'temperatura', 1194.0000, 'ºC'),
	(213375, 122, '2014-02-15 01:33:02.000000', 'temperatura', 456.0000, 'ºC'),
	(213376, 122, '2014-02-15 01:33:03.000000', 'temperatura', 1098.0000, 'ºC'),
	(213377, 122, '2014-02-15 01:33:04.000000', 'temperatura', 524.0000, 'ºC'),
	(213378, 122, '2014-02-15 01:33:05.000000', 'temperatura', 528.0000, 'ºC'),
	(213379, 122, '2014-02-15 01:33:06.000000', 'temperatura', 1067.0000, 'ºC'),
	(213380, 122, '2014-02-15 01:33:07.000000', 'temperatura', 153.0000, 'ºC'),
	(213381, 122, '2014-02-15 01:33:08.000000', 'temperatura', 1165.0000, 'ºC'),
	(213382, 122, '2014-02-15 01:33:09.000000', 'temperatura', 568.0000, 'ºC'),
	(213383, 122, '2014-02-15 01:33:10.000000', 'temperatura', 542.0000, 'ºC'),
	(213384, 122, '2014-02-15 01:33:11.000000', 'temperatura', 1008.0000, 'ºC'),
	(213385, 122, '2014-02-15 01:33:12.000000', 'temperatura', 1015.0000, 'ºC'),
	(213386, 122, '2014-02-15 01:33:13.000000', 'temperatura', 852.0000, 'ºC'),
	(213387, 122, '2014-02-15 01:33:14.000000', 'temperatura', 15.0000, 'ºC'),
	(213388, 122, '2014-02-15 01:33:15.000000', 'temperatura', 1120.0000, 'ºC'),
	(213389, 122, '2014-02-15 01:33:16.000000', 'temperatura', 753.0000, 'ºC'),
	(213390, 122, '2014-02-15 01:33:17.000000', 'temperatura', 409.0000, 'ºC'),
	(213391, 122, '2014-02-15 01:33:18.000000', 'temperatura', 985.0000, 'ºC'),
	(213392, 122, '2014-02-15 01:33:19.000000', 'temperatura', 97.0000, 'ºC'),
	(213393, 122, '2014-02-15 01:33:20.000000', 'temperatura', 1132.0000, 'ºC'),
	(213394, 122, '2014-02-15 01:33:21.000000', 'temperatura', 567.0000, 'ºC'),
	(213395, 122, '2014-02-15 01:33:22.000000', 'temperatura', 643.0000, 'ºC'),
	(213396, 122, '2014-02-15 01:33:23.000000', 'temperatura', 313.0000, 'ºC'),
	(213397, 122, '2014-02-15 01:33:24.000000', 'temperatura', 839.0000, 'ºC'),
	(213398, 122, '2014-02-15 01:33:25.000000', 'temperatura', 853.0000, 'ºC'),
	(213399, 122, '2014-02-15 01:33:26.000000', 'temperatura', 550.0000, 'ºC'),
	(213400, 122, '2014-02-15 01:33:27.000000', 'temperatura', 193.0000, 'ºC'),
	(213401, 122, '2014-02-15 01:33:28.000000', 'temperatura', 515.0000, 'ºC'),
	(213402, 122, '2014-02-15 01:33:29.000000', 'temperatura', 794.0000, 'ºC'),
	(213403, 122, '2014-02-15 01:33:30.000000', 'temperatura', 27.0000, 'ºC'),
	(213404, 122, '2014-02-15 01:33:31.000000', 'temperatura', 152.0000, 'ºC'),
	(213405, 122, '2014-02-15 01:33:32.000000', 'temperatura', 680.0000, 'ºC'),
	(213406, 122, '2014-02-15 01:33:33.000000', 'temperatura', 545.0000, 'ºC'),
	(213407, 122, '2014-02-15 01:33:34.000000', 'temperatura', 685.0000, 'ºC'),
	(213408, 122, '2014-02-15 01:33:35.000000', 'temperatura', 592.0000, 'ºC'),
	(213409, 122, '2014-02-15 01:33:36.000000', 'temperatura', 904.0000, 'ºC'),
	(213410, 122, '2014-02-15 01:33:37.000000', 'temperatura', 345.0000, 'ºC'),
	(213411, 122, '2014-02-15 01:33:38.000000', 'temperatura', 213.0000, 'ºC'),
	(213412, 122, '2014-02-15 01:33:39.000000', 'temperatura', 31.0000, 'ºC'),
	(213413, 122, '2014-02-15 01:33:40.000000', 'temperatura', 716.0000, 'ºC'),
	(213414, 122, '2014-02-15 01:33:41.000000', 'temperatura', 1086.0000, 'ºC'),
	(213415, 122, '2014-02-15 01:33:42.000000', 'temperatura', 884.0000, 'ºC'),
	(213416, 122, '2014-02-15 01:33:43.000000', 'temperatura', 1161.0000, 'ºC'),
	(213417, 122, '2014-02-15 01:33:44.000000', 'temperatura', 753.0000, 'ºC'),
	(213418, 122, '2014-02-15 01:33:45.000000', 'temperatura', 285.0000, 'ºC'),
	(213419, 122, '2014-02-15 01:33:46.000000', 'temperatura', 365.0000, 'ºC'),
	(213420, 118, '2014-03-01 00:00:00.000000', 'temperatura', 154.0000, 'ºC'),
	(213421, 118, '2014-03-01 00:00:01.000000', 'temperatura', 263.0000, 'ºC'),
	(213422, 118, '2014-03-01 00:00:02.000000', 'temperatura', 853.0000, 'ºC'),
	(213423, 118, '2014-03-01 00:00:03.000000', 'temperatura', 1076.0000, 'ºC'),
	(213424, 118, '2014-03-01 00:00:04.000000', 'temperatura', 423.0000, 'ºC'),
	(213425, 118, '2014-03-01 00:00:05.000000', 'temperatura', 85.0000, 'ºC'),
	(213426, 118, '2014-03-01 00:00:06.000000', 'temperatura', 358.0000, 'ºC'),
	(213427, 118, '2014-03-01 00:00:07.000000', 'temperatura', 337.0000, 'ºC'),
	(213428, 118, '2014-03-01 00:00:08.000000', 'temperatura', 610.0000, 'ºC'),
	(213429, 118, '2014-03-01 00:00:09.000000', 'temperatura', 839.0000, 'ºC'),
	(213430, 118, '2014-03-01 00:00:10.000000', 'temperatura', 1166.0000, 'ºC'),
	(213431, 118, '2014-03-01 00:00:11.000000', 'temperatura', 913.0000, 'ºC'),
	(213432, 118, '2014-03-01 00:00:12.000000', 'temperatura', 1069.0000, 'ºC'),
	(213433, 118, '2014-03-01 00:00:13.000000', 'temperatura', 205.0000, 'ºC'),
	(213434, 118, '2014-03-01 00:00:14.000000', 'temperatura', 218.0000, 'ºC'),
	(213435, 118, '2014-03-01 00:00:15.000000', 'temperatura', 475.0000, 'ºC'),
	(213436, 118, '2014-03-01 00:00:16.000000', 'temperatura', 520.0000, 'ºC'),
	(213437, 118, '2014-03-01 00:00:17.000000', 'temperatura', 1179.0000, 'ºC'),
	(213438, 118, '2014-03-01 00:00:18.000000', 'temperatura', 733.0000, 'ºC'),
	(213439, 118, '2014-03-01 00:00:19.000000', 'temperatura', 128.0000, 'ºC'),
	(213440, 118, '2014-03-01 00:00:20.000000', 'temperatura', 844.0000, 'ºC'),
	(213441, 118, '2014-03-01 00:00:21.000000', 'temperatura', 234.0000, 'ºC'),
	(213442, 118, '2014-03-01 00:00:22.000000', 'temperatura', 1038.0000, 'ºC'),
	(213443, 118, '2014-03-01 00:00:23.000000', 'temperatura', 888.0000, 'ºC'),
	(213444, 118, '2014-03-01 00:00:24.000000', 'temperatura', 129.0000, 'ºC'),
	(213445, 118, '2014-03-01 00:00:25.000000', 'temperatura', 379.0000, 'ºC'),
	(213446, 118, '2014-03-01 00:00:26.000000', 'temperatura', 309.0000, 'ºC'),
	(213447, 118, '2014-03-01 00:00:27.000000', 'temperatura', 409.0000, 'ºC'),
	(213448, 118, '2014-03-01 00:00:28.000000', 'temperatura', 1120.0000, 'ºC'),
	(213449, 118, '2014-03-01 00:00:29.000000', 'temperatura', 773.0000, 'ºC'),
	(213450, 118, '2014-03-01 00:00:30.000000', 'temperatura', 505.0000, 'ºC'),
	(213451, 118, '2014-03-01 00:00:31.000000', 'temperatura', 209.0000, 'ºC'),
	(213452, 118, '2014-03-01 00:00:32.000000', 'temperatura', 727.0000, 'ºC'),
	(213453, 118, '2014-03-01 00:00:33.000000', 'temperatura', 608.0000, 'ºC'),
	(213454, 118, '2014-03-01 00:00:34.000000', 'temperatura', 863.0000, 'ºC'),
	(213455, 118, '2014-03-01 00:00:35.000000', 'temperatura', 88.0000, 'ºC'),
	(213456, 118, '2014-03-01 00:00:36.000000', 'temperatura', 255.0000, 'ºC'),
	(213457, 118, '2014-03-01 00:00:37.000000', 'temperatura', 1008.0000, 'ºC'),
	(213458, 118, '2014-03-01 00:00:38.000000', 'temperatura', 678.0000, 'ºC'),
	(213459, 118, '2014-03-01 00:00:39.000000', 'temperatura', 368.0000, 'ºC'),
	(213460, 118, '2014-03-01 00:00:40.000000', 'temperatura', 1003.0000, 'ºC'),
	(213461, 118, '2014-03-01 00:00:41.000000', 'temperatura', 313.0000, 'ºC'),
	(213462, 118, '2014-03-01 00:00:42.000000', 'temperatura', 955.0000, 'ºC'),
	(213463, 118, '2014-03-01 00:00:43.000000', 'temperatura', 237.0000, 'ºC'),
	(213464, 118, '2014-03-01 00:00:44.000000', 'temperatura', 721.0000, 'ºC'),
	(213465, 118, '2014-03-01 00:00:45.000000', 'temperatura', 496.0000, 'ºC'),
	(213466, 118, '2014-03-01 00:00:46.000000', 'temperatura', 318.0000, 'ºC'),
	(213467, 118, '2014-03-01 00:00:47.000000', 'temperatura', 103.0000, 'ºC'),
	(213468, 118, '2014-03-01 00:00:48.000000', 'temperatura', 759.0000, 'ºC'),
	(213469, 118, '2014-03-01 00:00:49.000000', 'temperatura', 1089.0000, 'ºC'),
	(213470, 118, '2014-03-01 00:00:50.000000', 'temperatura', 766.0000, 'ºC'),
	(213471, 118, '2014-03-01 00:00:51.000000', 'temperatura', 566.0000, 'ºC'),
	(213472, 118, '2014-03-01 00:00:52.000000', 'temperatura', 532.0000, 'ºC'),
	(213473, 118, '2014-03-01 00:00:53.000000', 'temperatura', 964.0000, 'ºC'),
	(213474, 118, '2014-03-01 00:00:54.000000', 'temperatura', 821.0000, 'ºC'),
	(213475, 118, '2014-03-01 00:00:55.000000', 'temperatura', 16.0000, 'ºC'),
	(213476, 118, '2014-03-01 00:00:56.000000', 'temperatura', 18.0000, 'ºC'),
	(213477, 118, '2014-03-01 00:00:57.000000', 'temperatura', 42.0000, 'ºC'),
	(213478, 118, '2014-03-01 00:00:58.000000', 'temperatura', 157.0000, 'ºC'),
	(213479, 118, '2014-03-01 00:00:59.000000', 'temperatura', 660.0000, 'ºC'),
	(213480, 118, '2014-03-01 00:01:00.000000', 'temperatura', 428.0000, 'ºC'),
	(213481, 118, '2014-03-01 00:01:01.000000', 'temperatura', 163.0000, 'ºC'),
	(213482, 118, '2014-03-01 00:01:02.000000', 'temperatura', 731.0000, 'ºC'),
	(213483, 118, '2014-03-01 00:01:03.000000', 'temperatura', 764.0000, 'ºC'),
	(213484, 118, '2014-03-01 00:01:04.000000', 'temperatura', 428.0000, 'ºC'),
	(213485, 118, '2014-03-01 00:01:05.000000', 'temperatura', 1051.0000, 'ºC'),
	(213486, 118, '2014-03-01 00:01:06.000000', 'temperatura', 370.0000, 'ºC'),
	(213487, 118, '2014-03-01 00:01:07.000000', 'temperatura', 1099.0000, 'ºC'),
	(213488, 118, '2014-03-01 00:01:08.000000', 'temperatura', 782.0000, 'ºC'),
	(213489, 118, '2014-03-01 00:01:09.000000', 'temperatura', 617.0000, 'ºC'),
	(213490, 118, '2014-03-01 00:01:10.000000', 'temperatura', 739.0000, 'ºC'),
	(213491, 118, '2014-03-01 00:01:11.000000', 'temperatura', 642.0000, 'ºC'),
	(213492, 118, '2014-03-01 00:01:12.000000', 'temperatura', 996.0000, 'ºC'),
	(213493, 118, '2014-03-01 00:01:13.000000', 'temperatura', 652.0000, 'ºC'),
	(213494, 118, '2014-03-01 00:01:14.000000', 'temperatura', 274.0000, 'ºC'),
	(213495, 118, '2014-03-01 00:01:15.000000', 'temperatura', 614.0000, 'ºC'),
	(213496, 118, '2014-03-01 00:01:16.000000', 'temperatura', 1048.0000, 'ºC'),
	(213497, 118, '2014-03-01 00:01:17.000000', 'temperatura', 998.0000, 'ºC'),
	(213498, 118, '2014-03-01 00:01:18.000000', 'temperatura', 649.0000, 'ºC'),
	(213499, 118, '2014-03-01 00:01:19.000000', 'temperatura', 249.0000, 'ºC'),
	(213500, 118, '2014-03-01 00:01:20.000000', 'temperatura', 500.0000, 'ºC'),
	(213501, 118, '2014-03-01 00:01:21.000000', 'temperatura', 553.0000, 'ºC'),
	(213502, 118, '2014-03-01 00:01:22.000000', 'temperatura', 67.0000, 'ºC'),
	(213503, 118, '2014-03-01 00:01:23.000000', 'temperatura', 1074.0000, 'ºC'),
	(213504, 118, '2014-03-01 00:01:24.000000', 'temperatura', 369.0000, 'ºC'),
	(213505, 118, '2014-03-01 00:01:25.000000', 'temperatura', 1024.0000, 'ºC'),
	(213506, 118, '2014-03-01 00:01:26.000000', 'temperatura', 412.0000, 'ºC'),
	(213507, 118, '2014-03-01 00:01:27.000000', 'temperatura', 192.0000, 'ºC'),
	(213508, 118, '2014-03-01 00:01:28.000000', 'temperatura', 922.0000, 'ºC'),
	(213509, 118, '2014-03-01 00:01:29.000000', 'temperatura', 435.0000, 'ºC'),
	(213510, 118, '2014-03-01 00:01:30.000000', 'temperatura', 608.0000, 'ºC'),
	(213511, 118, '2014-03-01 00:01:31.000000', 'temperatura', 537.0000, 'ºC'),
	(213512, 118, '2014-03-01 00:01:32.000000', 'temperatura', 863.0000, 'ºC'),
	(213513, 118, '2014-03-01 00:01:33.000000', 'temperatura', 301.0000, 'ºC'),
	(213514, 118, '2014-03-01 00:01:34.000000', 'temperatura', 119.0000, 'ºC'),
	(213515, 118, '2014-03-01 00:01:35.000000', 'temperatura', 891.0000, 'ºC'),
	(213516, 118, '2014-03-01 00:01:36.000000', 'temperatura', 499.0000, 'ºC'),
	(213517, 118, '2014-03-01 00:01:37.000000', 'temperatura', 1023.0000, 'ºC'),
	(213518, 118, '2014-03-01 00:01:38.000000', 'temperatura', 18.0000, 'ºC'),
	(213519, 118, '2014-03-01 00:01:39.000000', 'temperatura', 623.0000, 'ºC'),
	(213520, 118, '2014-03-01 00:01:40.000000', 'temperatura', 660.0000, 'ºC'),
	(213521, 118, '2014-03-01 00:01:41.000000', 'temperatura', 230.0000, 'ºC'),
	(213522, 118, '2014-03-01 00:01:42.000000', 'temperatura', 373.0000, 'ºC'),
	(213523, 118, '2014-03-01 00:01:43.000000', 'temperatura', 1175.0000, 'ºC'),
	(213524, 118, '2014-03-01 00:01:44.000000', 'temperatura', 1156.0000, 'ºC'),
	(213525, 118, '2014-03-01 00:01:45.000000', 'temperatura', 1057.0000, 'ºC'),
	(213526, 118, '2014-03-01 00:01:46.000000', 'temperatura', 616.0000, 'ºC'),
	(213527, 118, '2014-03-01 00:01:47.000000', 'temperatura', 1111.0000, 'ºC'),
	(213528, 118, '2014-03-01 00:01:48.000000', 'temperatura', 108.0000, 'ºC'),
	(213529, 118, '2014-03-01 00:01:49.000000', 'temperatura', 806.0000, 'ºC'),
	(213530, 118, '2014-03-01 00:01:50.000000', 'temperatura', 106.0000, 'ºC'),
	(213531, 118, '2014-03-01 00:01:51.000000', 'temperatura', 511.0000, 'ºC'),
	(213532, 118, '2014-03-01 00:01:52.000000', 'temperatura', 1040.0000, 'ºC'),
	(213533, 118, '2014-03-01 00:01:53.000000', 'temperatura', 67.0000, 'ºC'),
	(213534, 118, '2014-03-01 00:01:54.000000', 'temperatura', 817.0000, 'ºC'),
	(213535, 118, '2014-03-01 00:01:55.000000', 'temperatura', 284.0000, 'ºC'),
	(213536, 118, '2014-03-01 00:01:56.000000', 'temperatura', 170.0000, 'ºC'),
	(213537, 118, '2014-03-01 00:01:57.000000', 'temperatura', 1197.0000, 'ºC'),
	(213538, 118, '2014-03-01 00:01:58.000000', 'temperatura', 675.0000, 'ºC'),
	(213539, 118, '2014-03-01 00:01:59.000000', 'temperatura', 985.0000, 'ºC'),
	(213540, 118, '2014-03-01 00:02:00.000000', 'temperatura', 500.0000, 'ºC'),
	(213541, 118, '2014-03-01 00:02:01.000000', 'temperatura', 746.0000, 'ºC'),
	(213542, 118, '2014-03-01 00:02:02.000000', 'temperatura', 1030.0000, 'ºC'),
	(213543, 118, '2014-03-01 00:02:03.000000', 'temperatura', 514.0000, 'ºC'),
	(213544, 118, '2014-03-01 00:02:04.000000', 'temperatura', 679.0000, 'ºC'),
	(213545, 118, '2014-03-01 00:02:05.000000', 'temperatura', 654.0000, 'ºC'),
	(213546, 118, '2014-03-01 00:02:06.000000', 'temperatura', 35.0000, 'ºC'),
	(213547, 118, '2014-03-01 00:02:07.000000', 'temperatura', 613.0000, 'ºC'),
	(213548, 118, '2014-03-01 00:02:08.000000', 'temperatura', 560.0000, 'ºC'),
	(213549, 118, '2014-03-01 00:02:09.000000', 'temperatura', 961.0000, 'ºC'),
	(213550, 118, '2014-03-01 00:02:10.000000', 'temperatura', 725.0000, 'ºC'),
	(213551, 118, '2014-03-01 00:02:11.000000', 'temperatura', 743.0000, 'ºC'),
	(213552, 118, '2014-03-01 00:02:12.000000', 'temperatura', 339.0000, 'ºC'),
	(213553, 118, '2014-03-01 00:02:13.000000', 'temperatura', 670.0000, 'ºC'),
	(213554, 118, '2014-03-01 00:02:14.000000', 'temperatura', 1131.0000, 'ºC'),
	(213555, 118, '2014-03-01 00:02:15.000000', 'temperatura', 45.0000, 'ºC'),
	(213556, 118, '2014-03-01 00:02:16.000000', 'temperatura', 432.0000, 'ºC'),
	(213557, 118, '2014-03-01 00:02:17.000000', 'temperatura', 828.0000, 'ºC'),
	(213558, 118, '2014-03-01 00:02:18.000000', 'temperatura', 444.0000, 'ºC'),
	(213559, 118, '2014-03-01 00:02:19.000000', 'temperatura', 935.0000, 'ºC'),
	(213560, 118, '2014-03-01 00:02:20.000000', 'temperatura', 945.0000, 'ºC'),
	(213561, 118, '2014-03-01 00:02:21.000000', 'temperatura', 721.0000, 'ºC'),
	(213562, 118, '2014-03-01 00:02:22.000000', 'temperatura', 769.0000, 'ºC'),
	(213563, 118, '2014-03-01 00:02:23.000000', 'temperatura', 483.0000, 'ºC'),
	(213564, 118, '2014-03-01 00:02:24.000000', 'temperatura', 110.0000, 'ºC'),
	(213565, 118, '2014-03-01 00:02:25.000000', 'temperatura', 301.0000, 'ºC'),
	(213566, 118, '2014-03-01 00:02:26.000000', 'temperatura', 1175.0000, 'ºC'),
	(213567, 118, '2014-03-01 00:02:27.000000', 'temperatura', 173.0000, 'ºC'),
	(213568, 118, '2014-03-01 00:02:28.000000', 'temperatura', 939.0000, 'ºC'),
	(213569, 118, '2014-03-01 00:02:29.000000', 'temperatura', 577.0000, 'ºC'),
	(213570, 118, '2014-03-01 00:02:30.000000', 'temperatura', 68.0000, 'ºC'),
	(213571, 118, '2014-03-01 00:02:31.000000', 'temperatura', 1008.0000, 'ºC'),
	(213572, 118, '2014-03-01 00:02:32.000000', 'temperatura', 39.0000, 'ºC'),
	(213573, 118, '2014-03-01 00:02:33.000000', 'temperatura', 772.0000, 'ºC'),
	(213574, 118, '2014-03-01 00:02:34.000000', 'temperatura', 145.0000, 'ºC'),
	(213575, 118, '2014-03-01 00:02:35.000000', 'temperatura', 807.0000, 'ºC'),
	(213576, 118, '2014-03-01 00:02:36.000000', 'temperatura', 1199.0000, 'ºC'),
	(213577, 118, '2014-03-01 00:02:37.000000', 'temperatura', 1177.0000, 'ºC'),
	(213578, 118, '2014-03-01 00:02:38.000000', 'temperatura', 1089.0000, 'ºC'),
	(213579, 118, '2014-03-01 00:02:39.000000', 'temperatura', 714.0000, 'ºC'),
	(213580, 118, '2014-03-01 00:02:40.000000', 'temperatura', 302.0000, 'ºC'),
	(213581, 118, '2014-03-01 00:02:41.000000', 'temperatura', 568.0000, 'ºC'),
	(213582, 118, '2014-03-01 00:02:42.000000', 'temperatura', 737.0000, 'ºC'),
	(213583, 118, '2014-03-01 00:02:43.000000', 'temperatura', 781.0000, 'ºC'),
	(213584, 118, '2014-03-01 00:02:44.000000', 'temperatura', 495.0000, 'ºC'),
	(213585, 118, '2014-03-01 00:02:45.000000', 'temperatura', 133.0000, 'ºC'),
	(213586, 118, '2014-03-01 00:02:46.000000', 'temperatura', 381.0000, 'ºC'),
	(213587, 118, '2014-03-01 00:02:47.000000', 'temperatura', 307.0000, 'ºC'),
	(213588, 118, '2014-03-01 00:02:48.000000', 'temperatura', 391.0000, 'ºC'),
	(213589, 118, '2014-03-01 00:02:49.000000', 'temperatura', 1036.0000, 'ºC'),
	(213590, 118, '2014-03-01 00:02:50.000000', 'temperatura', 406.0000, 'ºC'),
	(213591, 118, '2014-03-01 00:02:51.000000', 'temperatura', 121.0000, 'ºC'),
	(213592, 118, '2014-03-01 00:02:52.000000', 'temperatura', 589.0000, 'ºC'),
	(213593, 118, '2014-03-01 00:02:53.000000', 'temperatura', 182.0000, 'ºC'),
	(213594, 118, '2014-03-01 00:02:54.000000', 'temperatura', 345.0000, 'ºC'),
	(213595, 118, '2014-03-01 00:02:55.000000', 'temperatura', 1179.0000, 'ºC'),
	(213596, 118, '2014-03-01 00:02:56.000000', 'temperatura', 60.0000, 'ºC'),
	(213597, 118, '2014-03-01 00:02:57.000000', 'temperatura', 364.0000, 'ºC'),
	(213598, 118, '2014-03-01 00:02:58.000000', 'temperatura', 442.0000, 'ºC'),
	(213599, 118, '2014-03-01 00:02:59.000000', 'temperatura', 1118.0000, 'ºC'),
	(213600, 118, '2014-03-01 00:03:00.000000', 'temperatura', 665.0000, 'ºC'),
	(213601, 118, '2014-03-01 00:03:01.000000', 'temperatura', 1172.0000, 'ºC'),
	(213602, 118, '2014-03-01 00:03:02.000000', 'temperatura', 264.0000, 'ºC'),
	(213603, 118, '2014-03-01 00:03:03.000000', 'temperatura', 204.0000, 'ºC'),
	(213604, 118, '2014-03-01 00:03:04.000000', 'temperatura', 228.0000, 'ºC'),
	(213605, 118, '2014-03-01 00:03:05.000000', 'temperatura', 530.0000, 'ºC'),
	(213606, 118, '2014-03-01 00:03:06.000000', 'temperatura', 766.0000, 'ºC'),
	(213607, 118, '2014-03-01 00:03:07.000000', 'temperatura', 1042.0000, 'ºC'),
	(213608, 118, '2014-03-01 00:03:08.000000', 'temperatura', 511.0000, 'ºC'),
	(213609, 118, '2014-03-01 00:03:09.000000', 'temperatura', 632.0000, 'ºC'),
	(213610, 118, '2014-03-01 00:03:10.000000', 'temperatura', 424.0000, 'ºC'),
	(213611, 118, '2014-03-01 00:03:11.000000', 'temperatura', 228.0000, 'ºC'),
	(213612, 118, '2014-03-01 00:03:12.000000', 'temperatura', 1065.0000, 'ºC'),
	(213613, 118, '2014-03-01 00:03:13.000000', 'temperatura', 1043.0000, 'ºC'),
	(213614, 118, '2014-03-01 00:03:14.000000', 'temperatura', 821.0000, 'ºC'),
	(213615, 118, '2014-03-01 00:03:15.000000', 'temperatura', 975.0000, 'ºC'),
	(213616, 118, '2014-03-01 00:03:16.000000', 'temperatura', 12.0000, 'ºC'),
	(213617, 118, '2014-03-01 00:03:17.000000', 'temperatura', 736.0000, 'ºC'),
	(213618, 118, '2014-03-01 00:03:18.000000', 'temperatura', 45.0000, 'ºC'),
	(213619, 118, '2014-03-01 00:03:19.000000', 'temperatura', 417.0000, 'ºC'),
	(213620, 118, '2014-03-01 00:03:20.000000', 'temperatura', 749.0000, 'ºC'),
	(213621, 118, '2014-03-01 00:03:21.000000', 'temperatura', 96.0000, 'ºC'),
	(213622, 118, '2014-03-01 00:03:22.000000', 'temperatura', 635.0000, 'ºC'),
	(213623, 118, '2014-03-01 00:03:23.000000', 'temperatura', 486.0000, 'ºC'),
	(213624, 118, '2014-03-01 00:03:24.000000', 'temperatura', 524.0000, 'ºC'),
	(213625, 118, '2014-03-01 00:03:25.000000', 'temperatura', 1164.0000, 'ºC'),
	(213626, 118, '2014-03-01 00:03:26.000000', 'temperatura', 647.0000, 'ºC'),
	(213627, 118, '2014-03-01 00:03:27.000000', 'temperatura', 946.0000, 'ºC'),
	(213628, 118, '2014-03-01 00:03:28.000000', 'temperatura', 388.0000, 'ºC'),
	(213629, 118, '2014-03-01 00:03:29.000000', 'temperatura', 302.0000, 'ºC'),
	(213630, 118, '2014-03-01 00:03:30.000000', 'temperatura', 346.0000, 'ºC'),
	(213631, 118, '2014-03-01 00:03:31.000000', 'temperatura', 825.0000, 'ºC'),
	(213632, 118, '2014-03-01 00:03:32.000000', 'temperatura', 686.0000, 'ºC'),
	(213633, 118, '2014-03-01 00:03:33.000000', 'temperatura', 956.0000, 'ºC'),
	(213634, 118, '2014-03-01 00:03:34.000000', 'temperatura', 322.0000, 'ºC'),
	(213635, 118, '2014-03-01 00:03:35.000000', 'temperatura', 1144.0000, 'ºC'),
	(213636, 118, '2014-03-01 00:03:36.000000', 'temperatura', 1155.0000, 'ºC'),
	(213637, 118, '2014-03-01 00:03:37.000000', 'temperatura', 1143.0000, 'ºC'),
	(213638, 118, '2014-03-01 00:03:38.000000', 'temperatura', 1052.0000, 'ºC'),
	(213639, 118, '2014-03-01 00:03:39.000000', 'temperatura', 630.0000, 'ºC'),
	(213640, 118, '2014-03-01 00:03:40.000000', 'temperatura', 1196.0000, 'ºC'),
	(213641, 118, '2014-03-01 00:03:41.000000', 'temperatura', 487.0000, 'ºC'),
	(213642, 118, '2014-03-01 00:03:42.000000', 'temperatura', 51.0000, 'ºC'),
	(213643, 118, '2014-03-01 00:03:43.000000', 'temperatura', 1195.0000, 'ºC'),
	(213644, 118, '2014-03-01 00:03:44.000000', 'temperatura', 1022.0000, 'ºC'),
	(213645, 118, '2014-03-01 00:03:45.000000', 'temperatura', 325.0000, 'ºC'),
	(213646, 118, '2014-03-01 00:03:46.000000', 'temperatura', 960.0000, 'ºC'),
	(213647, 118, '2014-03-01 00:03:47.000000', 'temperatura', 224.0000, 'ºC'),
	(213648, 118, '2014-03-01 00:03:48.000000', 'temperatura', 640.0000, 'ºC'),
	(213649, 118, '2014-03-01 00:03:49.000000', 'temperatura', 129.0000, 'ºC'),
	(213650, 118, '2014-03-01 00:03:50.000000', 'temperatura', 1128.0000, 'ºC'),
	(213651, 118, '2014-03-01 00:03:51.000000', 'temperatura', 451.0000, 'ºC'),
	(213652, 118, '2014-03-01 00:03:52.000000', 'temperatura', 73.0000, 'ºC'),
	(213653, 118, '2014-03-01 00:03:53.000000', 'temperatura', 212.0000, 'ºC'),
	(213654, 118, '2014-03-01 00:03:54.000000', 'temperatura', 840.0000, 'ºC'),
	(213655, 118, '2014-03-01 00:03:55.000000', 'temperatura', 1165.0000, 'ºC'),
	(213656, 118, '2014-03-01 00:03:56.000000', 'temperatura', 905.0000, 'ºC'),
	(213657, 118, '2014-03-01 00:03:57.000000', 'temperatura', 1033.0000, 'ºC'),
	(213658, 118, '2014-03-01 00:03:58.000000', 'temperatura', 49.0000, 'ºC'),
	(213659, 118, '2014-03-01 00:03:59.000000', 'temperatura', 748.0000, 'ºC'),
	(213660, 118, '2014-03-01 00:04:00.000000', 'temperatura', 1191.0000, 'ºC'),
	(213661, 118, '2014-03-01 00:04:01.000000', 'temperatura', 112.0000, 'ºC'),
	(213662, 118, '2014-03-01 00:04:02.000000', 'temperatura', 588.0000, 'ºC'),
	(213663, 118, '2014-03-01 00:04:03.000000', 'temperatura', 203.0000, 'ºC'),
	(213664, 118, '2014-03-01 00:04:04.000000', 'temperatura', 451.0000, 'ºC'),
	(213665, 118, '2014-03-01 00:04:05.000000', 'temperatura', 449.0000, 'ºC'),
	(213666, 118, '2014-03-01 00:04:06.000000', 'temperatura', 891.0000, 'ºC'),
	(213667, 118, '2014-03-01 00:04:07.000000', 'temperatura', 708.0000, 'ºC'),
	(213668, 118, '2014-03-01 00:04:08.000000', 'temperatura', 868.0000, 'ºC'),
	(213669, 118, '2014-03-01 00:04:09.000000', 'temperatura', 1017.0000, 'ºC'),
	(213670, 118, '2014-03-01 00:04:10.000000', 'temperatura', 83.0000, 'ºC'),
	(213671, 118, '2014-03-01 00:04:11.000000', 'temperatura', 961.0000, 'ºC'),
	(213672, 118, '2014-03-01 00:04:12.000000', 'temperatura', 960.0000, 'ºC'),
	(213673, 118, '2014-03-01 00:04:13.000000', 'temperatura', 716.0000, 'ºC'),
	(213674, 118, '2014-03-01 00:04:14.000000', 'temperatura', 701.0000, 'ºC'),
	(213675, 118, '2014-03-01 00:04:15.000000', 'temperatura', 157.0000, 'ºC'),
	(213676, 118, '2014-03-01 00:04:16.000000', 'temperatura', 1082.0000, 'ºC'),
	(213677, 118, '2014-03-01 00:04:17.000000', 'temperatura', 141.0000, 'ºC'),
	(213678, 118, '2014-03-01 00:04:18.000000', 'temperatura', 1058.0000, 'ºC'),
	(213679, 118, '2014-03-01 00:04:19.000000', 'temperatura', 68.0000, 'ºC'),
	(213680, 118, '2014-03-01 00:04:20.000000', 'temperatura', 768.0000, 'ºC'),
	(213681, 118, '2014-03-01 00:04:21.000000', 'temperatura', 36.0000, 'ºC'),
	(213682, 118, '2014-03-01 00:04:22.000000', 'temperatura', 277.0000, 'ºC'),
	(213683, 118, '2014-03-01 00:04:23.000000', 'temperatura', 78.0000, 'ºC'),
	(213684, 118, '2014-03-01 00:04:24.000000', 'temperatura', 760.0000, 'ºC'),
	(213685, 118, '2014-03-01 00:04:25.000000', 'temperatura', 1164.0000, 'ºC'),
	(213686, 118, '2014-03-01 00:04:26.000000', 'temperatura', 1144.0000, 'ºC'),
	(213687, 118, '2014-03-01 00:04:27.000000', 'temperatura', 1025.0000, 'ºC'),
	(213688, 118, '2014-03-01 00:04:28.000000', 'temperatura', 496.0000, 'ºC'),
	(213689, 118, '2014-03-01 00:04:29.000000', 'temperatura', 603.0000, 'ºC'),
	(213690, 118, '2014-03-01 00:04:30.000000', 'temperatura', 327.0000, 'ºC'),
	(213691, 118, '2014-03-01 00:04:31.000000', 'temperatura', 1026.0000, 'ºC'),
	(213692, 118, '2014-03-01 00:04:32.000000', 'temperatura', 549.0000, 'ºC'),
	(213693, 118, '2014-03-01 00:04:33.000000', 'temperatura', 870.0000, 'ºC'),
	(213694, 118, '2014-03-01 00:04:34.000000', 'temperatura', 304.0000, 'ºC'),
	(213695, 118, '2014-03-01 00:04:35.000000', 'temperatura', 111.0000, 'ºC'),
	(213696, 118, '2014-03-01 00:04:36.000000', 'temperatura', 843.0000, 'ºC'),
	(213697, 118, '2014-03-01 00:04:37.000000', 'temperatura', 282.0000, 'ºC'),
	(213698, 118, '2014-03-01 00:04:38.000000', 'temperatura', 82.0000, 'ºC'),
	(213699, 118, '2014-03-01 00:04:39.000000', 'temperatura', 762.0000, 'ºC'),
	(213700, 118, '2014-03-01 00:04:40.000000', 'temperatura', 1167.0000, 'ºC'),
	(213701, 118, '2014-03-01 00:04:41.000000', 'temperatura', 1148.0000, 'ºC'),
	(213702, 118, '2014-03-01 00:04:42.000000', 'temperatura', 1040.0000, 'ºC'),
	(213703, 118, '2014-03-01 00:04:43.000000', 'temperatura', 557.0000, 'ºC'),
	(213704, 118, '2014-03-01 00:04:44.000000', 'temperatura', 864.0000, 'ºC'),
	(213705, 118, '2014-03-01 00:04:45.000000', 'temperatura', 251.0000, 'ºC'),
	(213706, 118, '2014-03-01 00:04:46.000000', 'temperatura', 1063.0000, 'ºC'),
	(213707, 118, '2014-03-01 00:04:47.000000', 'temperatura', 960.0000, 'ºC'),
	(213708, 118, '2014-03-01 00:04:48.000000', 'temperatura', 415.0000, 'ºC'),
	(213709, 118, '2014-03-01 00:04:49.000000', 'temperatura', 395.0000, 'ºC'),
	(213710, 118, '2014-03-01 00:04:50.000000', 'temperatura', 729.0000, 'ºC'),
	(213711, 118, '2014-03-01 00:04:51.000000', 'temperatura', 63.0000, 'ºC'),
	(213712, 118, '2014-03-01 00:04:52.000000', 'temperatura', 528.0000, 'ºC'),
	(213713, 118, '2014-03-01 00:04:53.000000', 'temperatura', 51.0000, 'ºC'),
	(213714, 118, '2014-03-01 00:04:54.000000', 'temperatura', 1072.0000, 'ºC'),
	(213715, 118, '2014-03-01 00:04:55.000000', 'temperatura', 407.0000, 'ºC'),
	(213716, 118, '2014-03-01 00:04:56.000000', 'temperatura', 19.0000, 'ºC'),
	(213717, 118, '2014-03-01 00:04:57.000000', 'temperatura', 73.0000, 'ºC'),
	(213718, 118, '2014-03-01 00:04:58.000000', 'temperatura', 310.0000, 'ºC'),
	(213719, 118, '2014-03-01 00:04:59.000000', 'temperatura', 131.0000, 'ºC'),
	(213720, 118, '2014-03-01 00:05:00.000000', 'temperatura', 926.0000, 'ºC'),
	(213721, 118, '2014-03-01 00:05:01.000000', 'temperatura', 635.0000, 'ºC'),
	(213722, 118, '2014-03-01 00:05:02.000000', 'temperatura', 401.0000, 'ºC'),
	(213723, 118, '2014-03-01 00:05:03.000000', 'temperatura', 100.0000, 'ºC'),
	(213724, 118, '2014-03-01 00:05:04.000000', 'temperatura', 496.0000, 'ºC'),
	(213725, 118, '2014-03-01 00:05:05.000000', 'temperatura', 983.0000, 'ºC'),
	(213726, 118, '2014-03-01 00:05:06.000000', 'temperatura', 1027.0000, 'ºC'),
	(213727, 118, '2014-03-01 00:05:07.000000', 'temperatura', 987.0000, 'ºC'),
	(213728, 118, '2014-03-01 00:05:08.000000', 'temperatura', 654.0000, 'ºC'),
	(213729, 118, '2014-03-01 00:05:09.000000', 'temperatura', 309.0000, 'ºC'),
	(213730, 118, '2014-03-01 00:05:10.000000', 'temperatura', 782.0000, 'ºC'),
	(213731, 118, '2014-03-01 00:05:11.000000', 'temperatura', 584.0000, 'ºC'),
	(213732, 118, '2014-03-01 00:05:12.000000', 'temperatura', 575.0000, 'ºC'),
	(213733, 118, '2014-03-01 00:05:13.000000', 'temperatura', 1123.0000, 'ºC'),
	(213734, 118, '2014-03-01 00:05:14.000000', 'temperatura', 289.0000, 'ºC'),
	(213735, 118, '2014-03-01 00:05:15.000000', 'temperatura', 477.0000, 'ºC'),
	(213736, 118, '2014-03-01 00:05:16.000000', 'temperatura', 318.0000, 'ºC'),
	(213737, 118, '2014-03-01 00:05:17.000000', 'temperatura', 161.0000, 'ºC'),
	(213738, 118, '2014-03-01 00:05:18.000000', 'temperatura', 1049.0000, 'ºC'),
	(213739, 118, '2014-03-01 00:05:19.000000', 'temperatura', 1165.0000, 'ºC'),
	(213740, 118, '2014-03-01 00:05:20.000000', 'temperatura', 280.0000, 'ºC'),
	(213741, 118, '2014-03-01 00:05:21.000000', 'temperatura', 303.0000, 'ºC'),
	(213742, 118, '2014-03-01 00:05:22.000000', 'temperatura', 677.0000, 'ºC'),
	(213743, 118, '2014-03-01 00:05:23.000000', 'temperatura', 78.0000, 'ºC'),
	(213744, 118, '2014-03-01 00:05:24.000000', 'temperatura', 757.0000, 'ºC'),
	(213745, 118, '2014-03-01 00:05:25.000000', 'temperatura', 1151.0000, 'ºC'),
	(213746, 118, '2014-03-01 00:05:26.000000', 'temperatura', 1083.0000, 'ºC'),
	(213747, 118, '2014-03-01 00:05:27.000000', 'temperatura', 765.0000, 'ºC'),
	(213748, 118, '2014-03-01 00:05:28.000000', 'temperatura', 577.0000, 'ºC'),
	(213749, 118, '2014-03-01 00:05:29.000000', 'temperatura', 592.0000, 'ºC'),
	(213750, 118, '2014-03-01 00:05:30.000000', 'temperatura', 26.0000, 'ºC'),
	(213751, 118, '2014-03-01 00:05:31.000000', 'temperatura', 755.0000, 'ºC'),
	(213752, 118, '2014-03-01 00:05:32.000000', 'temperatura', 100.0000, 'ºC'),
	(213753, 118, '2014-03-01 00:05:33.000000', 'temperatura', 634.0000, 'ºC'),
	(213754, 118, '2014-03-01 00:05:34.000000', 'temperatura', 472.0000, 'ºC'),
	(213755, 118, '2014-03-01 00:05:35.000000', 'temperatura', 459.0000, 'ºC'),
	(213756, 118, '2014-03-01 00:05:36.000000', 'temperatura', 878.0000, 'ºC'),
	(213757, 118, '2014-03-01 00:05:37.000000', 'temperatura', 613.0000, 'ºC'),
	(213758, 118, '2014-03-01 00:05:38.000000', 'temperatura', 432.0000, 'ºC'),
	(213759, 118, '2014-03-01 00:05:39.000000', 'temperatura', 322.0000, 'ºC'),
	(213760, 118, '2014-03-01 00:05:40.000000', 'temperatura', 312.0000, 'ºC'),
	(213761, 118, '2014-03-01 00:05:41.000000', 'temperatura', 597.0000, 'ºC'),
	(213762, 118, '2014-03-01 00:05:42.000000', 'temperatura', 851.0000, 'ºC'),
	(213763, 118, '2014-03-01 00:05:43.000000', 'temperatura', 63.0000, 'ºC'),
	(213764, 118, '2014-03-01 00:05:44.000000', 'temperatura', 161.0000, 'ºC'),
	(213765, 118, '2014-03-01 00:05:45.000000', 'temperatura', 617.0000, 'ºC'),
	(213766, 118, '2014-03-01 00:05:46.000000', 'temperatura', 201.0000, 'ºC'),
	(213767, 118, '2014-03-01 00:05:47.000000', 'temperatura', 357.0000, 'ºC'),
	(213768, 118, '2014-03-01 00:05:48.000000', 'temperatura', 1182.0000, 'ºC'),
	(213769, 118, '2014-03-01 00:05:49.000000', 'temperatura', 39.0000, 'ºC'),
	(213770, 118, '2014-03-01 00:05:50.000000', 'temperatura', 251.0000, 'ºC'),
	(213771, 118, '2014-03-01 00:05:51.000000', 'temperatura', 1138.0000, 'ºC'),
	(213772, 118, '2014-03-01 00:05:52.000000', 'temperatura', 137.0000, 'ºC'),
	(213773, 118, '2014-03-01 00:05:53.000000', 'temperatura', 871.0000, 'ºC'),
	(213774, 118, '2014-03-01 00:05:54.000000', 'temperatura', 344.0000, 'ºC'),
	(213775, 118, '2014-03-01 00:05:55.000000', 'temperatura', 310.0000, 'ºC'),
	(213776, 118, '2014-03-01 00:05:56.000000', 'temperatura', 515.0000, 'ºC'),
	(213777, 118, '2014-03-01 00:05:57.000000', 'temperatura', 447.0000, 'ºC'),
	(213778, 118, '2014-03-01 00:05:58.000000', 'temperatura', 692.0000, 'ºC'),
	(213779, 118, '2014-03-01 00:05:59.000000', 'temperatura', 919.0000, 'ºC'),
	(213780, 118, '2014-03-01 00:06:00.000000', 'temperatura', 120.0000, 'ºC'),
	(213781, 118, '2014-03-01 00:06:01.000000', 'temperatura', 242.0000, 'ºC'),
	(213782, 118, '2014-03-01 00:06:02.000000', 'temperatura', 851.0000, 'ºC'),
	(213783, 118, '2014-03-01 00:06:03.000000', 'temperatura', 1130.0000, 'ºC'),
	(213784, 118, '2014-03-01 00:06:04.000000', 'temperatura', 695.0000, 'ºC'),
	(213785, 118, '2014-03-01 00:06:05.000000', 'temperatura', 89.0000, 'ºC'),
	(213786, 118, '2014-03-01 00:06:06.000000', 'temperatura', 758.0000, 'ºC'),
	(213787, 118, '2014-03-01 00:06:07.000000', 'temperatura', 1125.0000, 'ºC'),
	(213788, 118, '2014-03-01 00:06:08.000000', 'temperatura', 950.0000, 'ºC'),
	(213789, 118, '2014-03-01 00:06:09.000000', 'temperatura', 176.0000, 'ºC'),
	(213790, 118, '2014-03-01 00:06:10.000000', 'temperatura', 430.0000, 'ºC'),
	(213791, 118, '2014-03-01 00:06:11.000000', 'temperatura', 425.0000, 'ºC'),
	(213792, 118, '2014-03-01 00:06:12.000000', 'temperatura', 834.0000, 'ºC'),
	(213793, 118, '2014-03-01 00:06:13.000000', 'temperatura', 497.0000, 'ºC'),
	(213794, 118, '2014-03-01 00:06:14.000000', 'temperatura', 1184.0000, 'ºC'),
	(213795, 118, '2014-03-01 00:06:15.000000', 'temperatura', 831.0000, 'ºC'),
	(213796, 118, '2014-03-01 00:06:16.000000', 'temperatura', 600.0000, 'ºC'),
	(213797, 118, '2014-03-01 00:06:17.000000', 'temperatura', 507.0000, 'ºC'),
	(213798, 118, '2014-03-01 00:06:18.000000', 'temperatura', 736.0000, 'ºC'),
	(213799, 118, '2014-03-01 00:06:19.000000', 'temperatura', 960.0000, 'ºC'),
	(213800, 118, '2014-03-01 00:06:20.000000', 'temperatura', 194.0000, 'ºC'),
	(213801, 118, '2014-03-01 00:06:21.000000', 'temperatura', 490.0000, 'ºC'),
	(213802, 118, '2014-03-01 00:06:22.000000', 'temperatura', 667.0000, 'ºC'),
	(213803, 118, '2014-03-01 00:06:23.000000', 'temperatura', 668.0000, 'ºC'),
	(213804, 118, '2014-03-01 00:06:24.000000', 'temperatura', 140.0000, 'ºC'),
	(213805, 118, '2014-03-01 00:06:25.000000', 'temperatura', 1096.0000, 'ºC'),
	(213806, 118, '2014-03-01 00:06:26.000000', 'temperatura', 259.0000, 'ºC'),
	(213807, 118, '2014-03-01 00:06:27.000000', 'temperatura', 408.0000, 'ºC'),
	(213808, 118, '2014-03-01 00:06:28.000000', 'temperatura', 62.0000, 'ºC'),
	(213809, 118, '2014-03-01 00:06:29.000000', 'temperatura', 287.0000, 'ºC'),
	(213810, 118, '2014-03-01 00:06:30.000000', 'temperatura', 52.0000, 'ºC'),
	(213811, 118, '2014-03-01 00:06:31.000000', 'temperatura', 596.0000, 'ºC'),
	(213812, 118, '2014-03-01 00:06:32.000000', 'temperatura', 427.0000, 'ºC'),
	(213813, 118, '2014-03-01 00:06:33.000000', 'temperatura', 348.0000, 'ºC'),
	(213814, 118, '2014-03-01 00:06:34.000000', 'temperatura', 460.0000, 'ºC'),
	(213815, 118, '2014-03-01 00:06:35.000000', 'temperatura', 54.0000, 'ºC'),
	(213816, 118, '2014-03-01 00:06:36.000000', 'temperatura', 93.0000, 'ºC'),
	(213817, 118, '2014-03-01 00:06:37.000000', 'temperatura', 303.0000, 'ºC'),
	(213818, 118, '2014-03-01 00:06:38.000000', 'temperatura', 35.0000, 'ºC'),
	(213819, 118, '2014-03-01 00:06:39.000000', 'temperatura', 468.0000, 'ºC'),
	(213820, 118, '2014-03-01 00:06:40.000000', 'temperatura', 1033.0000, 'ºC'),
	(213821, 118, '2014-03-01 00:06:41.000000', 'temperatura', 165.0000, 'ºC'),
	(213822, 118, '2014-03-01 00:06:42.000000', 'temperatura', 124.0000, 'ºC'),
	(213823, 118, '2014-03-01 00:06:43.000000', 'temperatura', 125.0000, 'ºC'),
	(213824, 118, '2014-03-01 00:06:44.000000', 'temperatura', 252.0000, 'ºC'),
	(213825, 118, '2014-03-01 00:06:45.000000', 'temperatura', 889.0000, 'ºC'),
	(213826, 118, '2014-03-01 00:06:46.000000', 'temperatura', 87.0000, 'ºC'),
	(213827, 118, '2014-03-01 00:06:47.000000', 'temperatura', 171.0000, 'ºC'),
	(213828, 118, '2014-03-01 00:06:48.000000', 'temperatura', 592.0000, 'ºC'),
	(213829, 118, '2014-03-01 00:06:49.000000', 'temperatura', 47.0000, 'ºC'),
	(213830, 118, '2014-03-01 00:06:50.000000', 'temperatura', 862.0000, 'ºC'),
	(213831, 118, '2014-03-01 00:06:51.000000', 'temperatura', 568.0000, 'ºC'),
	(213832, 118, '2014-03-01 00:06:52.000000', 'temperatura', 253.0000, 'ºC'),
	(213833, 118, '2014-03-01 00:06:53.000000', 'temperatura', 764.0000, 'ºC'),
	(213834, 118, '2014-03-01 00:06:54.000000', 'temperatura', 659.0000, 'ºC'),
	(213835, 118, '2014-03-01 00:06:55.000000', 'temperatura', 1006.0000, 'ºC'),
	(213836, 118, '2014-03-01 00:06:56.000000', 'temperatura', 653.0000, 'ºC'),
	(213837, 118, '2014-03-01 00:06:57.000000', 'temperatura', 246.0000, 'ºC'),
	(213838, 118, '2014-03-01 00:06:58.000000', 'temperatura', 472.0000, 'ºC'),
	(213839, 118, '2014-03-01 00:06:59.000000', 'temperatura', 421.0000, 'ºC'),
	(213840, 118, '2014-03-01 00:07:00.000000', 'temperatura', 690.0000, 'ºC'),
	(213841, 118, '2014-03-01 00:07:01.000000', 'temperatura', 987.0000, 'ºC'),
	(213842, 118, '2014-03-01 00:07:02.000000', 'temperatura', 466.0000, 'ºC'),
	(213843, 118, '2014-03-01 00:07:03.000000', 'temperatura', 571.0000, 'ºC'),
	(213844, 118, '2014-03-01 00:07:04.000000', 'temperatura', 257.0000, 'ºC'),
	(213845, 118, '2014-03-01 00:07:05.000000', 'temperatura', 773.0000, 'ºC'),
	(213846, 118, '2014-03-01 00:07:06.000000', 'temperatura', 692.0000, 'ºC'),
	(213847, 118, '2014-03-01 00:07:07.000000', 'temperatura', 1143.0000, 'ºC'),
	(213848, 118, '2014-03-01 00:07:08.000000', 'temperatura', 38.0000, 'ºC'),
	(213849, 118, '2014-03-01 00:07:09.000000', 'temperatura', 361.0000, 'ºC'),
	(213850, 118, '2014-03-01 00:07:10.000000', 'temperatura', 494.0000, 'ºC'),
	(213851, 118, '2014-03-01 00:07:11.000000', 'temperatura', 186.0000, 'ºC'),
	(213852, 118, '2014-03-01 00:07:12.000000', 'temperatura', 651.0000, 'ºC'),
	(213853, 118, '2014-03-01 00:07:13.000000', 'temperatura', 294.0000, 'ºC'),
	(213854, 118, '2014-03-01 00:07:14.000000', 'temperatura', 720.0000, 'ºC'),
	(213855, 118, '2014-03-01 00:07:15.000000', 'temperatura', 316.0000, 'ºC'),
	(213856, 118, '2014-03-01 00:07:16.000000', 'temperatura', 621.0000, 'ºC'),
	(213857, 118, '2014-03-01 00:07:17.000000', 'temperatura', 958.0000, 'ºC'),
	(213858, 118, '2014-03-01 00:07:18.000000', 'temperatura', 530.0000, 'ºC'),
	(213859, 118, '2014-03-01 00:07:19.000000', 'temperatura', 973.0000, 'ºC'),
	(213860, 118, '2014-03-01 00:07:20.000000', 'temperatura', 877.0000, 'ºC'),
	(213861, 118, '2014-03-01 00:07:21.000000', 'temperatura', 268.0000, 'ºC'),
	(213862, 118, '2014-03-01 00:07:22.000000', 'temperatura', 1107.0000, 'ºC'),
	(213863, 118, '2014-03-01 00:07:23.000000', 'temperatura', 1134.0000, 'ºC'),
	(213864, 118, '2014-03-01 00:07:24.000000', 'temperatura', 1150.0000, 'ºC'),
	(213865, 118, '2014-03-01 00:07:25.000000', 'temperatura', 1149.0000, 'ºC'),
	(213866, 118, '2014-03-01 00:07:26.000000', 'temperatura', 1094.0000, 'ºC'),
	(213867, 118, '2014-03-01 00:07:27.000000', 'temperatura', 822.0000, 'ºC'),
	(213868, 118, '2014-03-01 00:07:28.000000', 'temperatura', 830.0000, 'ºC'),
	(213869, 118, '2014-03-01 00:07:29.000000', 'temperatura', 484.0000, 'ºC'),
	(213870, 118, '2014-03-01 00:07:30.000000', 'temperatura', 1129.0000, 'ºC'),
	(213871, 118, '2014-03-01 00:07:31.000000', 'temperatura', 594.0000, 'ºC'),
	(213872, 118, '2014-03-01 00:07:32.000000', 'temperatura', 785.0000, 'ºC'),
	(213873, 118, '2014-03-01 00:07:33.000000', 'temperatura', 943.0000, 'ºC'),
	(213874, 118, '2014-03-01 00:07:34.000000', 'temperatura', 1161.0000, 'ºC'),
	(213875, 118, '2014-03-01 00:07:35.000000', 'temperatura', 574.0000, 'ºC'),
	(213876, 118, '2014-03-01 00:07:36.000000', 'temperatura', 591.0000, 'ºC'),
	(213877, 118, '2014-03-01 00:07:37.000000', 'temperatura', 31.0000, 'ºC'),
	(213878, 118, '2014-03-01 00:07:38.000000', 'temperatura', 784.0000, 'ºC'),
	(213879, 118, '2014-03-01 00:07:39.000000', 'temperatura', 226.0000, 'ºC'),
	(213880, 118, '2014-03-01 00:07:40.000000', 'temperatura', 1181.0000, 'ºC'),
	(213881, 118, '2014-03-01 00:07:41.000000', 'temperatura', 427.0000, 'ºC'),
	(213882, 118, '2014-03-01 00:07:42.000000', 'temperatura', 991.0000, 'ºC'),
	(213883, 118, '2014-03-01 00:07:43.000000', 'temperatura', 75.0000, 'ºC'),
	(213884, 118, '2014-03-01 00:07:44.000000', 'temperatura', 1004.0000, 'ºC'),
	(213885, 118, '2014-03-01 00:07:45.000000', 'temperatura', 1195.0000, 'ºC'),
	(213886, 118, '2014-03-01 00:07:46.000000', 'temperatura', 562.0000, 'ºC'),
	(213887, 118, '2014-03-01 00:07:47.000000', 'temperatura', 427.0000, 'ºC'),
	(213888, 118, '2014-03-01 00:07:48.000000', 'temperatura', 448.0000, 'ºC'),
	(213889, 118, '2014-03-01 00:07:49.000000', 'temperatura', 962.0000, 'ºC'),
	(213890, 118, '2014-03-01 00:07:50.000000', 'temperatura', 1063.0000, 'ºC'),
	(213891, 118, '2014-03-01 00:07:51.000000', 'temperatura', 33.0000, 'ºC'),
	(213892, 118, '2014-03-01 00:07:52.000000', 'temperatura', 574.0000, 'ºC'),
	(213893, 118, '2014-03-01 00:07:53.000000', 'temperatura', 373.0000, 'ºC'),
	(213894, 118, '2014-03-01 00:07:54.000000', 'temperatura', 145.0000, 'ºC'),
	(213895, 118, '2014-03-01 00:07:55.000000', 'temperatura', 804.0000, 'ºC'),
	(213896, 118, '2014-03-01 00:07:56.000000', 'temperatura', 1188.0000, 'ºC'),
	(213897, 118, '2014-03-01 00:07:57.000000', 'temperatura', 1126.0000, 'ºC'),
	(213898, 118, '2014-03-01 00:07:58.000000', 'temperatura', 869.0000, 'ºC'),
	(213899, 118, '2014-03-01 00:07:59.000000', 'temperatura', 968.0000, 'ºC'),
	(213900, 118, '2014-03-01 00:08:00.000000', 'temperatura', 1034.0000, 'ºC'),
	(213901, 118, '2014-03-01 00:08:01.000000', 'temperatura', 1065.0000, 'ºC'),
	(213902, 118, '2014-03-01 00:08:02.000000', 'temperatura', 1023.0000, 'ºC'),
	(213903, 118, '2014-03-01 00:08:03.000000', 'temperatura', 722.0000, 'ºC'),
	(213904, 118, '2014-03-01 00:08:04.000000', 'temperatura', 539.0000, 'ºC'),
	(213905, 118, '2014-03-01 00:08:05.000000', 'temperatura', 530.0000, 'ºC'),
	(213906, 118, '2014-03-01 00:08:06.000000', 'temperatura', 1036.0000, 'ºC'),
	(213907, 118, '2014-03-01 00:08:07.000000', 'temperatura', 1188.0000, 'ºC'),
	(213908, 118, '2014-03-01 00:08:08.000000', 'temperatura', 431.0000, 'ºC'),
	(213909, 118, '2014-03-01 00:08:09.000000', 'temperatura', 994.0000, 'ºC'),
	(213910, 118, '2014-03-01 00:08:10.000000', 'temperatura', 77.0000, 'ºC'),
	(213911, 118, '2014-03-01 00:08:11.000000', 'temperatura', 1003.0000, 'ºC'),
	(213912, 118, '2014-03-01 00:08:12.000000', 'temperatura', 1185.0000, 'ºC'),
	(213913, 118, '2014-03-01 00:08:13.000000', 'temperatura', 515.0000, 'ºC'),
	(213914, 118, '2014-03-01 00:08:14.000000', 'temperatura', 221.0000, 'ºC'),
	(213915, 118, '2014-03-01 00:08:15.000000', 'temperatura', 760.0000, 'ºC'),
	(213916, 118, '2014-03-01 00:08:16.000000', 'temperatura', 738.0000, 'ºC'),
	(213917, 118, '2014-03-01 00:08:17.000000', 'temperatura', 211.0000, 'ºC'),
	(213918, 118, '2014-03-01 00:08:18.000000', 'temperatura', 42.0000, 'ºC'),
	(213919, 118, '2014-03-01 00:08:19.000000', 'temperatura', 776.0000, 'ºC'),
	(213920, 118, '2014-03-01 00:08:20.000000', 'temperatura', 155.0000, 'ºC'),
	(213921, 118, '2014-03-01 00:08:21.000000', 'temperatura', 849.0000, 'ºC'),
	(213922, 118, '2014-03-01 00:08:22.000000', 'temperatura', 178.0000, 'ºC'),
	(213923, 118, '2014-03-01 00:08:23.000000', 'temperatura', 744.0000, 'ºC'),
	(213924, 118, '2014-03-01 00:08:24.000000', 'temperatura', 785.0000, 'ºC'),
	(213925, 118, '2014-03-01 00:08:25.000000', 'temperatura', 494.0000, 'ºC'),
	(213926, 118, '2014-03-01 00:08:26.000000', 'temperatura', 118.0000, 'ºC'),
	(213927, 118, '2014-03-01 00:08:27.000000', 'temperatura', 307.0000, 'ºC'),
	(213928, 118, '2014-03-01 00:08:28.000000', 'temperatura', 1183.0000, 'ºC'),
	(213929, 118, '2014-03-01 00:08:29.000000', 'temperatura', 194.0000, 'ºC'),
	(213930, 118, '2014-03-01 00:08:30.000000', 'temperatura', 1021.0000, 'ºC'),
	(213931, 118, '2014-03-01 00:08:31.000000', 'temperatura', 925.0000, 'ºC'),
	(213932, 118, '2014-03-01 00:08:32.000000', 'temperatura', 363.0000, 'ºC'),
	(213933, 118, '2014-03-01 00:08:33.000000', 'temperatura', 240.0000, 'ºC'),
	(213934, 118, '2014-03-01 00:08:34.000000', 'temperatura', 110.0000, 'ºC'),
	(213935, 118, '2014-03-01 00:08:35.000000', 'temperatura', 1033.0000, 'ºC'),
	(213936, 118, '2014-03-01 00:08:36.000000', 'temperatura', 34.0000, 'ºC'),
	(213937, 118, '2014-03-01 00:08:37.000000', 'temperatura', 671.0000, 'ºC'),
	(213938, 118, '2014-03-01 00:08:38.000000', 'temperatura', 852.0000, 'ºC'),
	(213939, 118, '2014-03-01 00:08:39.000000', 'temperatura', 1049.0000, 'ºC'),
	(213940, 118, '2014-03-01 00:08:40.000000', 'temperatura', 290.0000, 'ºC'),
	(213941, 118, '2014-03-01 00:08:41.000000', 'temperatura', 703.0000, 'ºC'),
	(213942, 118, '2014-03-01 00:08:42.000000', 'temperatura', 245.0000, 'ºC'),
	(213943, 118, '2014-03-01 00:08:43.000000', 'temperatura', 315.0000, 'ºC'),
	(213944, 118, '2014-03-01 00:08:44.000000', 'temperatura', 841.0000, 'ºC'),
	(213945, 118, '2014-03-01 00:08:45.000000', 'temperatura', 861.0000, 'ºC'),
	(213946, 118, '2014-03-01 00:08:46.000000', 'temperatura', 584.0000, 'ºC'),
	(213947, 118, '2014-03-01 00:08:47.000000', 'temperatura', 336.0000, 'ºC'),
	(213948, 118, '2014-03-01 00:08:48.000000', 'temperatura', 1129.0000, 'ºC'),
	(213949, 118, '2014-03-01 00:08:49.000000', 'temperatura', 1038.0000, 'ºC'),
	(213950, 118, '2014-03-01 00:08:50.000000', 'temperatura', 603.0000, 'ºC'),
	(213951, 118, '2014-03-01 00:08:51.000000', 'temperatura', 1102.0000, 'ºC'),
	(213952, 118, '2014-03-01 00:08:52.000000', 'temperatura', 102.0000, 'ºC'),
	(213953, 118, '2014-03-01 00:08:53.000000', 'temperatura', 804.0000, 'ºC'),
	(213954, 118, '2014-03-01 00:08:54.000000', 'temperatura', 112.0000, 'ºC'),
	(213955, 118, '2014-03-01 00:08:55.000000', 'temperatura', 552.0000, 'ºC'),
	(213956, 118, '2014-03-01 00:08:56.000000', 'temperatura', 23.0000, 'ºC'),
	(213957, 118, '2014-03-01 00:08:57.000000', 'temperatura', 859.0000, 'ºC'),
	(213958, 118, '2014-03-01 00:08:58.000000', 'temperatura', 626.0000, 'ºC'),
	(213959, 118, '2014-03-01 00:08:59.000000', 'temperatura', 553.0000, 'ºC'),
	(213960, 118, '2014-03-01 00:09:00.000000', 'temperatura', 890.0000, 'ºC'),
	(213961, 118, '2014-03-01 00:09:01.000000', 'temperatura', 388.0000, 'ºC'),
	(213962, 118, '2014-03-01 00:09:02.000000', 'temperatura', 473.0000, 'ºC'),
	(213963, 118, '2014-03-01 00:09:03.000000', 'temperatura', 2.0000, 'ºC'),
	(213964, 118, '2014-03-01 00:09:04.000000', 'temperatura', 992.0000, 'ºC'),
	(213965, 118, '2014-03-01 00:09:05.000000', 'temperatura', 154.0000, 'ºC'),
	(213966, 118, '2014-03-01 00:09:06.000000', 'temperatura', 194.0000, 'ºC'),
	(213967, 118, '2014-03-01 00:09:07.000000', 'temperatura', 508.0000, 'ºC'),
	(213968, 118, '2014-03-01 00:09:08.000000', 'temperatura', 757.0000, 'ºC'),
	(213969, 118, '2014-03-01 00:09:09.000000', 'temperatura', 1063.0000, 'ºC'),
	(213970, 118, '2014-03-01 00:09:10.000000', 'temperatura', 643.0000, 'ºC'),
	(213971, 118, '2014-03-01 00:09:11.000000', 'temperatura', 27.0000, 'ºC'),
	(213972, 118, '2014-03-01 00:09:12.000000', 'temperatura', 605.0000, 'ºC'),
	(213973, 118, '2014-03-01 00:09:13.000000', 'temperatura', 545.0000, 'ºC'),
	(213974, 118, '2014-03-01 00:09:14.000000', 'temperatura', 912.0000, 'ºC'),
	(213975, 118, '2014-03-01 00:09:15.000000', 'temperatura', 524.0000, 'ºC'),
	(213976, 118, '2014-03-01 00:09:16.000000', 'temperatura', 1084.0000, 'ºC'),
	(213977, 118, '2014-03-01 00:09:17.000000', 'temperatura', 247.0000, 'ºC'),
	(213978, 118, '2014-03-01 00:09:18.000000', 'temperatura', 387.0000, 'ºC'),
	(213979, 118, '2014-03-01 00:09:19.000000', 'temperatura', 1191.0000, 'ºC'),
	(213980, 118, '2014-03-01 00:09:20.000000', 'temperatura', 1196.0000, 'ºC'),
	(213981, 118, '2014-03-01 00:09:21.000000', 'temperatura', 9.0000, 'ºC'),
	(213982, 118, '2014-03-01 00:09:22.000000', 'temperatura', 55.0000, 'ºC'),
	(213983, 118, '2014-03-01 00:09:23.000000', 'temperatura', 251.0000, 'ºC'),
	(213984, 118, '2014-03-01 00:09:24.000000', 'temperatura', 1091.0000, 'ºC'),
	(213985, 118, '2014-03-01 00:09:25.000000', 'temperatura', 1100.0000, 'ºC'),
	(213986, 118, '2014-03-01 00:09:26.000000', 'temperatura', 1030.0000, 'ºC'),
	(213987, 118, '2014-03-01 00:09:27.000000', 'temperatura', 648.0000, 'ºC'),
	(213988, 118, '2014-03-01 00:09:28.000000', 'temperatura', 151.0000, 'ºC'),
	(213989, 118, '2014-03-01 00:09:29.000000', 'temperatura', 12.0000, 'ºC'),
	(213990, 118, '2014-03-01 00:09:30.000000', 'temperatura', 805.0000, 'ºC'),
	(213991, 118, '2014-03-01 00:09:31.000000', 'temperatura', 393.0000, 'ºC'),
	(213992, 118, '2014-03-01 00:09:32.000000', 'temperatura', 751.0000, 'ºC'),
	(213993, 118, '2014-03-01 00:09:33.000000', 'temperatura', 174.0000, 'ºC'),
	(213994, 118, '2014-03-01 00:09:34.000000', 'temperatura', 1017.0000, 'ºC'),
	(213995, 118, '2014-03-01 00:09:35.000000', 'temperatura', 963.0000, 'ºC'),
	(213996, 118, '2014-03-01 00:09:36.000000', 'temperatura', 566.0000, 'ºC'),
	(213997, 118, '2014-03-01 00:09:37.000000', 'temperatura', 1141.0000, 'ºC'),
	(213998, 118, '2014-03-01 00:09:38.000000', 'temperatura', 406.0000, 'ºC'),
	(213999, 118, '2014-03-01 00:09:39.000000', 'temperatura', 1007.0000, 'ºC'),
	(214000, 118, '2014-03-01 00:09:40.000000', 'temperatura', 217.0000, 'ºC'),
	(214001, 118, '2014-03-01 00:09:41.000000', 'temperatura', 465.0000, 'ºC'),
	(214002, 118, '2014-03-01 00:09:42.000000', 'temperatura', 474.0000, 'ºC'),
	(214003, 118, '2014-03-01 00:09:43.000000', 'temperatura', 974.0000, 'ºC'),
	(214004, 118, '2014-03-01 00:09:44.000000', 'temperatura', 1051.0000, 'ºC'),
	(214005, 118, '2014-03-01 00:09:45.000000', 'temperatura', 1134.0000, 'ºC'),
	(214006, 118, '2014-03-01 00:09:46.000000', 'temperatura', 118.0000, 'ºC'),
	(214007, 118, '2014-03-01 00:09:47.000000', 'temperatura', 788.0000, 'ºC'),
	(214008, 118, '2014-03-01 00:09:48.000000', 'temperatura', 1188.0000, 'ºC'),
	(214009, 118, '2014-03-01 00:09:49.000000', 'temperatura', 1176.0000, 'ºC'),
	(214010, 118, '2014-03-01 00:09:50.000000', 'temperatura', 1116.0000, 'ºC'),
	(214011, 118, '2014-03-01 00:09:51.000000', 'temperatura', 852.0000, 'ºC'),
	(214012, 118, '2014-03-01 00:09:52.000000', 'temperatura', 911.0000, 'ºC'),
	(214013, 118, '2014-03-01 00:09:53.000000', 'temperatura', 802.0000, 'ºC'),
	(214014, 118, '2014-03-01 00:09:54.000000', 'temperatura', 75.0000, 'ºC'),
	(214015, 118, '2014-03-01 00:09:55.000000', 'temperatura', 371.0000, 'ºC'),
	(214016, 118, '2014-03-01 00:09:56.000000', 'temperatura', 429.0000, 'ºC'),
	(214017, 118, '2014-03-01 00:09:57.000000', 'temperatura', 1034.0000, 'ºC'),
	(214018, 118, '2014-03-01 00:09:58.000000', 'temperatura', 282.0000, 'ºC'),
	(214019, 118, '2014-03-01 00:09:59.000000', 'temperatura', 708.0000, 'ºC'),
	(214020, 118, '2014-03-01 00:10:00.000000', 'temperatura', 294.0000, 'ºC'),
	(214021, 118, '2014-03-01 00:10:01.000000', 'temperatura', 547.0000, 'ºC'),
	(214022, 118, '2014-03-01 00:10:02.000000', 'temperatura', 653.0000, 'ºC'),
	(214023, 118, '2014-03-01 00:10:03.000000', 'temperatura', 424.0000, 'ºC'),
	(214024, 118, '2014-03-01 00:10:04.000000', 'temperatura', 161.0000, 'ºC'),
	(214025, 118, '2014-03-01 00:10:05.000000', 'temperatura', 733.0000, 'ºC'),
	(214026, 118, '2014-03-01 00:10:06.000000', 'temperatura', 784.0000, 'ºC'),
	(214027, 118, '2014-03-01 00:10:07.000000', 'temperatura', 522.0000, 'ºC'),
	(214028, 118, '2014-03-01 00:10:08.000000', 'temperatura', 258.0000, 'ºC'),
	(214029, 118, '2014-03-01 00:10:09.000000', 'temperatura', 924.0000, 'ºC'),
	(214030, 118, '2014-03-01 00:10:10.000000', 'temperatura', 245.0000, 'ºC'),
	(214031, 118, '2014-03-01 00:10:11.000000', 'temperatura', 856.0000, 'ºC'),
	(214032, 118, '2014-03-01 00:10:12.000000', 'temperatura', 1146.0000, 'ºC'),
	(214033, 118, '2014-03-01 00:10:13.000000', 'temperatura', 762.0000, 'ºC'),
	(214034, 118, '2014-03-01 00:10:14.000000', 'temperatura', 371.0000, 'ºC'),
	(214035, 118, '2014-03-01 00:10:15.000000', 'temperatura', 768.0000, 'ºC'),
	(214036, 118, '2014-03-01 00:10:16.000000', 'temperatura', 331.0000, 'ºC'),
	(214037, 118, '2014-03-01 00:10:17.000000', 'temperatura', 551.0000, 'ºC'),
	(214038, 118, '2014-03-01 00:10:18.000000', 'temperatura', 563.0000, 'ºC'),
	(214039, 118, '2014-03-01 00:10:19.000000', 'temperatura', 1162.0000, 'ºC'),
	(214040, 118, '2014-03-01 00:10:20.000000', 'temperatura', 521.0000, 'ºC'),
	(214041, 118, '2014-03-01 00:10:21.000000', 'temperatura', 319.0000, 'ºC'),
	(214042, 118, '2014-03-01 00:10:22.000000', 'temperatura', 32.0000, 'ºC'),
	(214043, 118, '2014-03-01 00:10:23.000000', 'temperatura', 405.0000, 'ºC'),
	(214044, 118, '2014-03-01 00:10:24.000000', 'temperatura', 729.0000, 'ºC'),
	(214045, 118, '2014-03-01 00:10:25.000000', 'temperatura', 30.0000, 'ºC'),
	(214046, 118, '2014-03-01 00:10:26.000000', 'temperatura', 363.0000, 'ºC'),
	(214047, 118, '2014-03-01 00:10:27.000000', 'temperatura', 526.0000, 'ºC'),
	(214048, 118, '2014-03-01 00:10:28.000000', 'temperatura', 340.0000, 'ºC'),
	(214049, 118, '2014-03-01 00:10:29.000000', 'temperatura', 123.0000, 'ºC'),
	(214050, 118, '2014-03-01 00:10:30.000000', 'temperatura', 795.0000, 'ºC'),
	(214051, 118, '2014-03-01 00:10:31.000000', 'temperatura', 9.0000, 'ºC'),
	(214052, 118, '2014-03-01 00:10:32.000000', 'temperatura', 60.0000, 'ºC'),
	(214053, 118, '2014-03-01 00:10:33.000000', 'temperatura', 273.0000, 'ºC'),
	(214054, 118, '2014-03-01 00:10:34.000000', 'temperatura', 1186.0000, 'ºC'),
	(214055, 118, '2014-03-01 00:10:35.000000', 'temperatura', 312.0000, 'ºC'),
	(214056, 118, '2014-03-01 00:10:36.000000', 'temperatura', 400.0000, 'ºC'),
	(214057, 118, '2014-03-01 00:10:37.000000', 'temperatura', 1066.0000, 'ºC'),
	(214058, 118, '2014-03-01 00:10:38.000000', 'temperatura', 529.0000, 'ºC'),
	(214059, 118, '2014-03-01 00:10:39.000000', 'temperatura', 648.0000, 'ºC'),
	(214060, 118, '2014-03-01 00:10:40.000000', 'temperatura', 452.0000, 'ºC'),
	(214061, 118, '2014-03-01 00:10:41.000000', 'temperatura', 319.0000, 'ºC'),
	(214062, 118, '2014-03-01 00:10:42.000000', 'temperatura', 238.0000, 'ºC'),
	(214063, 118, '2014-03-01 00:10:43.000000', 'temperatura', 235.0000, 'ºC'),
	(214064, 118, '2014-03-01 00:10:44.000000', 'temperatura', 461.0000, 'ºC'),
	(214065, 118, '2014-03-01 00:10:45.000000', 'temperatura', 399.0000, 'ºC'),
	(214066, 118, '2014-03-01 00:10:46.000000', 'temperatura', 612.0000, 'ºC'),
	(214067, 118, '2014-03-01 00:10:47.000000', 'temperatura', 663.0000, 'ºC'),
	(214068, 118, '2014-03-01 00:10:48.000000', 'temperatura', 279.0000, 'ºC'),
	(214069, 118, '2014-03-01 00:10:49.000000', 'temperatura', 609.0000, 'ºC'),
	(214070, 118, '2014-03-01 00:10:50.000000', 'temperatura', 1006.0000, 'ºC'),
	(214071, 118, '2014-03-01 00:10:51.000000', 'temperatura', 803.0000, 'ºC'),
	(214072, 118, '2014-03-01 00:10:52.000000', 'temperatura', 1000.0000, 'ºC'),
	(214073, 118, '2014-03-01 00:10:53.000000', 'temperatura', 191.0000, 'ºC'),
	(214074, 118, '2014-03-01 00:10:54.000000', 'temperatura', 354.0000, 'ºC'),
	(214075, 118, '2014-03-01 00:10:55.000000', 'temperatura', 1199.0000, 'ºC'),
	(214076, 118, '2014-03-01 00:10:56.000000', 'temperatura', 132.0000, 'ºC'),
	(214077, 118, '2014-03-01 00:10:57.000000', 'temperatura', 666.0000, 'ºC'),
	(214078, 118, '2014-03-01 00:10:58.000000', 'temperatura', 533.0000, 'ºC'),
	(214079, 118, '2014-03-01 00:10:59.000000', 'temperatura', 666.0000, 'ºC'),
	(214080, 118, '2014-03-01 00:11:00.000000', 'temperatura', 534.0000, 'ºC'),
	(214081, 118, '2014-03-01 00:11:01.000000', 'temperatura', 671.0000, 'ºC'),
	(214082, 118, '2014-03-01 00:11:02.000000', 'temperatura', 555.0000, 'ºC'),
	(214083, 118, '2014-03-01 00:11:03.000000', 'temperatura', 760.0000, 'ºC'),
	(214084, 118, '2014-03-01 00:11:04.000000', 'temperatura', 937.0000, 'ºC'),
	(214085, 118, '2014-03-01 00:11:05.000000', 'temperatura', 5.0000, 'ºC'),
	(214086, 118, '2014-03-01 00:11:06.000000', 'temperatura', 817.0000, 'ºC'),
	(214087, 118, '2014-03-01 00:11:07.000000', 'temperatura', 467.0000, 'ºC'),
	(214088, 118, '2014-03-01 00:11:08.000000', 'temperatura', 1085.0000, 'ºC'),
	(214089, 118, '2014-03-01 00:11:09.000000', 'temperatura', 425.0000, 'ºC'),
	(214090, 118, '2014-03-01 00:11:10.000000', 'temperatura', 69.0000, 'ºC'),
	(214091, 118, '2014-03-01 00:11:11.000000', 'temperatura', 270.0000, 'ºC'),
	(214092, 118, '2014-03-01 00:11:12.000000', 'temperatura', 1145.0000, 'ºC'),
	(214093, 118, '2014-03-01 00:11:13.000000', 'temperatura', 113.0000, 'ºC'),
	(214094, 118, '2014-03-01 00:11:14.000000', 'temperatura', 733.0000, 'ºC'),
	(214095, 118, '2014-03-01 00:11:15.000000', 'temperatura', 925.0000, 'ºC'),
	(214096, 118, '2014-03-01 00:11:16.000000', 'temperatura', 28.0000, 'ºC'),
	(214097, 118, '2014-03-01 00:11:17.000000', 'temperatura', 966.0000, 'ºC'),
	(214098, 118, '2014-03-01 00:11:18.000000', 'temperatura', 1145.0000, 'ºC'),
	(214099, 118, '2014-03-01 00:11:19.000000', 'temperatura', 427.0000, 'ºC'),
	(214100, 118, '2014-03-01 00:11:20.000000', 'temperatura', 1100.0000, 'ºC'),
	(214101, 118, '2014-03-01 00:11:21.000000', 'temperatura', 620.0000, 'ºC'),
	(214102, 118, '2014-03-01 00:11:22.000000', 'temperatura', 1001.0000, 'ºC'),
	(214103, 118, '2014-03-01 00:11:23.000000', 'temperatura', 743.0000, 'ºC'),
	(214104, 118, '2014-03-01 00:11:24.000000', 'temperatura', 716.0000, 'ºC'),
	(214105, 118, '2014-03-01 00:11:25.000000', 'temperatura', 148.0000, 'ºC'),
	(214106, 118, '2014-03-01 00:11:26.000000', 'temperatura', 994.0000, 'ºC'),
	(214107, 118, '2014-03-01 00:11:27.000000', 'temperatura', 927.0000, 'ºC'),
	(214108, 118, '2014-03-01 00:11:28.000000', 'temperatura', 454.0000, 'ºC'),
	(214109, 118, '2014-03-01 00:11:29.000000', 'temperatura', 690.0000, 'ºC'),
	(214110, 118, '2014-03-01 00:11:30.000000', 'temperatura', 889.0000, 'ºC'),
	(214111, 118, '2014-03-01 00:11:31.000000', 'temperatura', 1177.0000, 'ºC'),
	(214112, 118, '2014-03-01 00:11:32.000000', 'temperatura', 815.0000, 'ºC'),
	(214113, 118, '2014-03-01 00:11:33.000000', 'temperatura', 544.0000, 'ºC'),
	(214114, 118, '2014-03-01 00:11:34.000000', 'temperatura', 279.0000, 'ºC'),
	(214115, 118, '2014-03-01 00:11:35.000000', 'temperatura', 961.0000, 'ºC'),
	(214116, 118, '2014-03-01 00:11:36.000000', 'temperatura', 371.0000, 'ºC'),
	(214117, 118, '2014-03-01 00:11:37.000000', 'temperatura', 170.0000, 'ºC'),
	(214118, 118, '2014-03-01 00:11:38.000000', 'temperatura', 940.0000, 'ºC'),
	(214119, 118, '2014-03-01 00:11:39.000000', 'temperatura', 588.0000, 'ºC'),
	(214120, 118, '2014-03-01 00:11:40.000000', 'temperatura', 122.0000, 'ºC'),
	(214121, 118, '2014-03-01 00:11:41.000000', 'temperatura', 45.0000, 'ºC'),
	(214122, 118, '2014-03-01 00:11:42.000000', 'temperatura', 1060.0000, 'ºC'),
	(214123, 118, '2014-03-01 00:11:43.000000', 'temperatura', 367.0000, 'ºC'),
	(214124, 118, '2014-03-01 00:11:44.000000', 'temperatura', 1057.0000, 'ºC'),
	(214125, 118, '2014-03-01 00:11:45.000000', 'temperatura', 581.0000, 'ºC'),
	(214126, 118, '2014-03-01 00:11:46.000000', 'temperatura', 937.0000, 'ºC'),
	(214127, 118, '2014-03-01 00:11:47.000000', 'temperatura', 542.0000, 'ºC'),
	(214128, 118, '2014-03-01 00:11:48.000000', 'temperatura', 1097.0000, 'ºC'),
	(214129, 118, '2014-03-01 00:11:49.000000', 'temperatura', 263.0000, 'ºC'),
	(214130, 118, '2014-03-01 00:11:50.000000', 'temperatura', 424.0000, 'ºC'),
	(214131, 118, '2014-03-01 00:11:51.000000', 'temperatura', 131.0000, 'ºC'),
	(214132, 118, '2014-03-01 00:11:52.000000', 'temperatura', 581.0000, 'ºC'),
	(214133, 118, '2014-03-01 00:11:53.000000', 'temperatura', 116.0000, 'ºC'),
	(214134, 118, '2014-03-01 00:11:54.000000', 'temperatura', 37.0000, 'ºC'),
	(214135, 118, '2014-03-01 00:11:55.000000', 'temperatura', 1039.0000, 'ºC'),
	(214136, 118, '2014-03-01 00:11:56.000000', 'temperatura', 283.0000, 'ºC'),
	(214137, 118, '2014-03-01 00:11:57.000000', 'temperatura', 700.0000, 'ºC'),
	(214138, 118, '2014-03-01 00:11:58.000000', 'temperatura', 251.0000, 'ºC'),
	(214139, 118, '2014-03-01 00:11:59.000000', 'temperatura', 354.0000, 'ºC'),
	(214140, 118, '2014-03-01 00:12:00.000000', 'temperatura', 1019.0000, 'ºC'),
	(214141, 118, '2014-03-01 00:12:01.000000', 'temperatura', 433.0000, 'ºC'),
	(214142, 118, '2014-03-01 00:12:02.000000', 'temperatura', 308.0000, 'ºC'),
	(214143, 118, '2014-03-01 00:12:03.000000', 'temperatura', 242.0000, 'ºC'),
	(214144, 118, '2014-03-01 00:12:04.000000', 'temperatura', 286.0000, 'ºC'),
	(214145, 118, '2014-03-01 00:12:05.000000', 'temperatura', 706.0000, 'ºC'),
	(214146, 118, '2014-03-01 00:12:06.000000', 'temperatura', 273.0000, 'ºC'),
	(214147, 118, '2014-03-01 00:12:07.000000', 'temperatura', 447.0000, 'ºC'),
	(214148, 118, '2014-03-01 00:12:08.000000', 'temperatura', 216.0000, 'ºC'),
	(214149, 118, '2014-03-01 00:12:09.000000', 'temperatura', 938.0000, 'ºC'),
	(214150, 118, '2014-03-01 00:12:10.000000', 'temperatura', 444.0000, 'ºC'),
	(214151, 118, '2014-03-01 00:12:11.000000', 'temperatura', 606.0000, 'ºC'),
	(214152, 118, '2014-03-01 00:12:12.000000', 'temperatura', 497.0000, 'ºC'),
	(214153, 118, '2014-03-01 00:12:13.000000', 'temperatura', 668.0000, 'ºC'),
	(214154, 118, '2014-03-01 00:12:14.000000', 'temperatura', 650.0000, 'ºC'),
	(214155, 118, '2014-03-01 00:12:15.000000', 'temperatura', 46.0000, 'ºC'),
	(214156, 118, '2014-03-01 00:12:16.000000', 'temperatura', 679.0000, 'ºC'),
	(214157, 118, '2014-03-01 00:12:17.000000', 'temperatura', 860.0000, 'ºC'),
	(214158, 118, '2014-03-01 00:12:18.000000', 'temperatura', 1064.0000, 'ºC'),
	(214159, 118, '2014-03-01 00:12:19.000000', 'temperatura', 339.0000, 'ºC'),
	(214160, 118, '2014-03-01 00:12:20.000000', 'temperatura', 906.0000, 'ºC'),
	(214161, 118, '2014-03-01 00:12:21.000000', 'temperatura', 1111.0000, 'ºC'),
	(214162, 118, '2014-03-01 00:12:22.000000', 'temperatura', 439.0000, 'ºC'),
	(214163, 118, '2014-03-01 00:12:23.000000', 'temperatura', 60.0000, 'ºC'),
	(214164, 118, '2014-03-01 00:12:24.000000', 'temperatura', 186.0000, 'ºC'),
	(214165, 118, '2014-03-01 00:12:25.000000', 'temperatura', 749.0000, 'ºC'),
	(214166, 118, '2014-03-01 00:12:26.000000', 'temperatura', 787.0000, 'ºC'),
	(214167, 118, '2014-03-01 00:12:27.000000', 'temperatura', 488.0000, 'ºC'),
	(214168, 118, '2014-03-01 00:12:28.000000', 'temperatura', 81.0000, 'ºC'),
	(214169, 118, '2014-03-01 00:12:29.000000', 'temperatura', 140.0000, 'ºC'),
	(214170, 118, '2014-03-01 00:12:30.000000', 'temperatura', 458.0000, 'ºC'),
	(214171, 118, '2014-03-01 00:12:31.000000', 'temperatura', 669.0000, 'ºC'),
	(214172, 118, '2014-03-01 00:12:32.000000', 'temperatura', 774.0000, 'ºC'),
	(214173, 118, '2014-03-01 00:12:33.000000', 'temperatura', 664.0000, 'ºC'),
	(214174, 118, '2014-03-01 00:12:34.000000', 'temperatura', 998.0000, 'ºC'),
	(214175, 118, '2014-03-01 00:12:35.000000', 'temperatura', 598.0000, 'ºC'),
	(214176, 118, '2014-03-01 00:12:36.000000', 'temperatura', 1196.0000, 'ºC'),
	(214177, 118, '2014-03-01 00:12:37.000000', 'temperatura', 586.0000, 'ºC'),
	(214178, 118, '2014-03-01 00:12:38.000000', 'temperatura', 545.0000, 'ºC'),
	(214179, 118, '2014-03-01 00:12:39.000000', 'temperatura', 964.0000, 'ºC'),
	(214180, 118, '2014-03-01 00:12:40.000000', 'temperatura', 788.0000, 'ºC'),
	(214181, 118, '2014-03-01 00:12:41.000000', 'temperatura', 1047.0000, 'ºC'),
	(214182, 118, '2014-03-01 00:12:42.000000', 'temperatura', 470.0000, 'ºC'),
	(214183, 118, '2014-03-01 00:12:43.000000', 'temperatura', 411.0000, 'ºC'),
	(214184, 118, '2014-03-01 00:12:44.000000', 'temperatura', 645.0000, 'ºC'),
	(214185, 118, '2014-03-01 00:12:45.000000', 'temperatura', 792.0000, 'ºC'),
	(214186, 118, '2014-03-01 00:12:46.000000', 'temperatura', 828.0000, 'ºC'),
	(214187, 118, '2014-03-01 00:12:47.000000', 'temperatura', 562.0000, 'ºC'),
	(214188, 118, '2014-03-01 00:12:48.000000', 'temperatura', 326.0000, 'ºC'),
	(214189, 118, '2014-03-01 00:12:49.000000', 'temperatura', 1146.0000, 'ºC'),
	(214190, 118, '2014-03-01 00:12:50.000000', 'temperatura', 1150.0000, 'ºC'),
	(214191, 118, '2014-03-01 00:12:51.000000', 'temperatura', 1115.0000, 'ºC'),
	(214192, 118, '2014-03-01 00:12:52.000000', 'temperatura', 925.0000, 'ºC'),
	(214193, 118, '2014-03-01 00:12:53.000000', 'temperatura', 82.0000, 'ºC'),
	(214194, 118, '2014-03-01 00:12:54.000000', 'temperatura', 34.0000, 'ºC'),
	(214195, 118, '2014-03-01 00:12:55.000000', 'temperatura', 1126.0000, 'ºC'),
	(214196, 118, '2014-03-01 00:12:56.000000', 'temperatura', 726.0000, 'ºC'),
	(214197, 118, '2014-03-01 00:12:57.000000', 'temperatura', 254.0000, 'ºC'),
	(214198, 118, '2014-03-01 00:12:58.000000', 'temperatura', 292.0000, 'ºC'),
	(214199, 118, '2014-03-01 00:12:59.000000', 'temperatura', 699.0000, 'ºC'),
	(214200, 118, '2014-03-01 00:13:00.000000', 'temperatura', 220.0000, 'ºC'),
	(214201, 118, '2014-03-01 00:13:01.000000', 'temperatura', 202.0000, 'ºC'),
	(214202, 118, '2014-03-01 00:13:02.000000', 'temperatura', 351.0000, 'ºC'),
	(214203, 118, '2014-03-01 00:13:03.000000', 'temperatura', 1149.0000, 'ºC'),
	(214204, 118, '2014-03-01 00:13:04.000000', 'temperatura', 1095.0000, 'ºC'),
	(214205, 118, '2014-03-01 00:13:05.000000', 'temperatura', 826.0000, 'ºC'),
	(214206, 118, '2014-03-01 00:13:06.000000', 'temperatura', 846.0000, 'ºC'),
	(214207, 118, '2014-03-01 00:13:07.000000', 'temperatura', 552.0000, 'ºC'),
	(214208, 118, '2014-03-01 00:13:08.000000', 'temperatura', 224.0000, 'ºC'),
	(214209, 118, '2014-03-01 00:13:09.000000', 'temperatura', 663.0000, 'ºC'),
	(214210, 118, '2014-03-01 00:13:10.000000', 'temperatura', 245.0000, 'ºC'),
	(214211, 118, '2014-03-01 00:13:11.000000', 'temperatura', 436.0000, 'ºC'),
	(214212, 118, '2014-03-01 00:13:12.000000', 'temperatura', 247.0000, 'ºC'),
	(214213, 118, '2014-03-01 00:13:13.000000', 'temperatura', 1125.0000, 'ºC'),
	(214214, 118, '2014-03-01 00:13:14.000000', 'temperatura', 85.0000, 'ºC'),
	(214215, 118, '2014-03-01 00:13:15.000000', 'temperatura', 652.0000, 'ºC'),
	(214216, 118, '2014-03-01 00:13:16.000000', 'temperatura', 603.0000, 'ºC'),
	(214217, 118, '2014-03-01 00:13:17.000000', 'temperatura', 1061.0000, 'ºC'),
	(214218, 118, '2014-03-01 00:13:18.000000', 'temperatura', 1097.0000, 'ºC'),
	(214219, 118, '2014-03-01 00:13:19.000000', 'temperatura', 1103.0000, 'ºC'),
	(214220, 118, '2014-03-01 00:13:20.000000', 'temperatura', 1026.0000, 'ºC'),
	(214221, 118, '2014-03-01 00:13:21.000000', 'temperatura', 619.0000, 'ºC'),
	(214222, 118, '2014-03-01 00:13:22.000000', 'temperatura', 17.0000, 'ºC'),
	(214223, 118, '2014-03-01 00:13:23.000000', 'temperatura', 630.0000, 'ºC'),
	(214224, 118, '2014-03-01 00:13:24.000000', 'temperatura', 701.0000, 'ºC'),
	(214225, 118, '2014-03-01 00:13:25.000000', 'temperatura', 413.0000, 'ºC'),
	(214226, 118, '2014-03-01 00:13:26.000000', 'temperatura', 1164.0000, 'ºC'),
	(214227, 118, '2014-03-01 00:13:27.000000', 'temperatura', 979.0000, 'ºC'),
	(214228, 118, '2014-03-01 00:13:28.000000', 'temperatura', 205.0000, 'ºC'),
	(214229, 118, '2014-03-01 00:13:29.000000', 'temperatura', 488.0000, 'ºC'),
	(214230, 118, '2014-03-01 00:13:30.000000', 'temperatura', 625.0000, 'ºC'),
	(214231, 118, '2014-03-01 00:13:31.000000', 'temperatura', 462.0000, 'ºC'),
	(214232, 118, '2014-03-01 00:13:32.000000', 'temperatura', 435.0000, 'ºC'),
	(214233, 118, '2014-03-01 00:13:33.000000', 'temperatura', 789.0000, 'ºC'),
	(214234, 118, '2014-03-01 00:13:34.000000', 'temperatura', 241.0000, 'ºC'),
	(214235, 118, '2014-03-01 00:13:35.000000', 'temperatura', 39.0000, 'ºC'),
	(214236, 118, '2014-03-01 00:13:36.000000', 'temperatura', 673.0000, 'ºC'),
	(214237, 118, '2014-03-01 00:13:37.000000', 'temperatura', 846.0000, 'ºC'),
	(214238, 118, '2014-03-01 00:13:38.000000', 'temperatura', 1013.0000, 'ºC'),
	(214239, 118, '2014-03-01 00:13:39.000000', 'temperatura', 126.0000, 'ºC'),
	(214240, 118, '2014-03-01 00:13:40.000000', 'temperatura', 1194.0000, 'ºC'),
	(214241, 118, '2014-03-01 00:13:41.000000', 'temperatura', 791.0000, 'ºC'),
	(214242, 118, '2014-03-01 00:13:42.000000', 'temperatura', 373.0000, 'ºC'),
	(214243, 118, '2014-03-01 00:13:43.000000', 'temperatura', 693.0000, 'ºC'),
	(214244, 118, '2014-03-01 00:13:44.000000', 'temperatura', 1146.0000, 'ºC'),
	(214245, 118, '2014-03-01 00:13:45.000000', 'temperatura', 51.0000, 'ºC'),
	(214246, 118, '2014-03-01 00:13:46.000000', 'temperatura', 417.0000, 'ºC'),
	(214247, 118, '2014-03-01 00:13:47.000000', 'temperatura', 734.0000, 'ºC'),
	(214248, 118, '2014-03-01 00:13:48.000000', 'temperatura', 21.0000, 'ºC'),
	(214249, 118, '2014-03-01 00:13:49.000000', 'temperatura', 300.0000, 'ºC'),
	(214250, 118, '2014-03-01 00:13:50.000000', 'temperatura', 241.0000, 'ºC'),
	(214251, 118, '2014-03-01 00:13:51.000000', 'temperatura', 303.0000, 'ºC'),
	(214252, 118, '2014-03-01 00:13:52.000000', 'temperatura', 795.0000, 'ºC'),
	(214253, 118, '2014-03-01 00:13:53.000000', 'temperatura', 663.0000, 'ºC'),
	(214254, 118, '2014-03-01 00:13:54.000000', 'temperatura', 933.0000, 'ºC'),
	(214255, 118, '2014-03-01 00:13:55.000000', 'temperatura', 276.0000, 'ºC'),
	(214256, 118, '2014-03-01 00:13:56.000000', 'temperatura', 982.0000, 'ºC'),
	(214257, 118, '2014-03-01 00:13:57.000000', 'temperatura', 481.0000, 'ºC'),
	(214258, 118, '2014-03-01 00:13:58.000000', 'temperatura', 659.0000, 'ºC'),
	(214259, 118, '2014-03-01 00:13:59.000000', 'temperatura', 655.0000, 'ºC'),
	(214260, 118, '2014-03-01 00:14:00.000000', 'temperatura', 96.0000, 'ºC'),
	(214261, 118, '2014-03-01 00:14:01.000000', 'temperatura', 918.0000, 'ºC'),
	(214262, 118, '2014-03-01 00:14:02.000000', 'temperatura', 702.0000, 'ºC'),
	(214263, 118, '2014-03-01 00:14:03.000000', 'temperatura', 757.0000, 'ºC'),
	(214264, 118, '2014-03-01 00:14:04.000000', 'temperatura', 480.0000, 'ºC'),
	(214265, 118, '2014-03-01 00:14:05.000000', 'temperatura', 130.0000, 'ºC'),
	(214266, 118, '2014-03-01 00:14:06.000000', 'temperatura', 409.0000, 'ºC'),
	(214267, 118, '2014-03-01 00:14:07.000000', 'temperatura', 455.0000, 'ºC'),
	(214268, 118, '2014-03-01 00:14:08.000000', 'temperatura', 1049.0000, 'ºC'),
	(214269, 118, '2014-03-01 00:14:09.000000', 'temperatura', 281.0000, 'ºC'),
	(214270, 118, '2014-03-01 00:14:10.000000', 'temperatura', 659.0000, 'ºC'),
	(214271, 118, '2014-03-01 00:14:11.000000', 'temperatura', 54.0000, 'ºC'),
	(214272, 118, '2014-03-01 00:14:12.000000', 'temperatura', 691.0000, 'ºC'),
	(214273, 118, '2014-03-01 00:14:13.000000', 'temperatura', 892.0000, 'ºC'),
	(214274, 118, '2014-03-01 00:14:14.000000', 'temperatura', 1190.0000, 'ºC'),
	(214275, 118, '2014-03-01 00:14:15.000000', 'temperatura', 875.0000, 'ºC'),
	(214276, 118, '2014-03-01 00:14:16.000000', 'temperatura', 804.0000, 'ºC'),
	(214277, 118, '2014-03-01 00:14:17.000000', 'temperatura', 196.0000, 'ºC'),
	(214278, 118, '2014-03-01 00:14:18.000000', 'temperatura', 968.0000, 'ºC'),
	(214279, 118, '2014-03-01 00:14:19.000000', 'temperatura', 652.0000, 'ºC'),
	(214280, 118, '2014-03-01 00:14:20.000000', 'temperatura', 357.0000, 'ºC'),
	(214281, 118, '2014-03-01 00:14:21.000000', 'temperatura', 1031.0000, 'ºC'),
	(214282, 118, '2014-03-01 00:14:22.000000', 'temperatura', 485.0000, 'ºC'),
	(214283, 118, '2014-03-01 00:14:23.000000', 'temperatura', 531.0000, 'ºC'),
	(214284, 118, '2014-03-01 00:14:24.000000', 'temperatura', 0.0000, 'ºC'),
	(214285, 118, '2014-03-01 00:14:25.000000', 'temperatura', 807.0000, 'ºC'),
	(214286, 118, '2014-03-01 00:14:26.000000', 'temperatura', 438.0000, 'ºC'),
	(214287, 118, '2014-03-01 00:14:27.000000', 'temperatura', 967.0000, 'ºC'),
	(214288, 118, '2014-03-01 00:14:28.000000', 'temperatura', 1124.0000, 'ºC'),
	(214289, 118, '2014-03-01 00:14:29.000000', 'temperatura', 319.0000, 'ºC'),
	(214290, 118, '2014-03-01 00:14:30.000000', 'temperatura', 623.0000, 'ºC'),
	(214291, 118, '2014-03-01 00:14:31.000000', 'temperatura', 958.0000, 'ºC'),
	(214292, 118, '2014-03-01 00:14:32.000000', 'temperatura', 522.0000, 'ºC'),
	(214293, 118, '2014-03-01 00:14:33.000000', 'temperatura', 937.0000, 'ºC'),
	(214294, 118, '2014-03-01 00:14:34.000000', 'temperatura', 718.0000, 'ºC'),
	(214295, 118, '2014-03-01 00:14:35.000000', 'temperatura', 779.0000, 'ºC'),
	(214296, 118, '2014-03-01 00:14:36.000000', 'temperatura', 541.0000, 'ºC'),
	(214297, 118, '2014-03-01 00:14:37.000000', 'temperatura', 369.0000, 'ºC'),
	(214298, 118, '2014-03-01 00:14:38.000000', 'temperatura', 222.0000, 'ºC'),
	(214299, 118, '2014-03-01 00:14:39.000000', 'temperatura', 3.0000, 'ºC'),
	(214300, 118, '2014-03-01 00:14:40.000000', 'temperatura', 549.0000, 'ºC'),
	(214301, 118, '2014-03-01 00:14:41.000000', 'temperatura', 336.0000, 'ºC'),
	(214302, 118, '2014-03-01 00:14:42.000000', 'temperatura', 33.0000, 'ºC'),
	(214303, 118, '2014-03-01 00:14:43.000000', 'temperatura', 359.0000, 'ºC'),
	(214304, 118, '2014-03-01 00:14:44.000000', 'temperatura', 496.0000, 'ºC'),
	(214305, 118, '2014-03-01 00:14:45.000000', 'temperatura', 205.0000, 'ºC'),
	(214306, 118, '2014-03-01 00:14:46.000000', 'temperatura', 735.0000, 'ºC'),
	(214307, 118, '2014-03-01 00:14:47.000000', 'temperatura', 661.0000, 'ºC'),
	(214308, 118, '2014-03-01 00:14:48.000000', 'temperatura', 1102.0000, 'ºC'),
	(214309, 118, '2014-03-01 00:14:49.000000', 'temperatura', 1127.0000, 'ºC'),
	(214310, 118, '2014-03-01 00:14:50.000000', 'temperatura', 1130.0000, 'ºC'),
	(214311, 118, '2014-03-01 00:14:51.000000', 'temperatura', 1068.0000, 'ºC'),
	(214312, 118, '2014-03-01 00:14:52.000000', 'temperatura', 751.0000, 'ºC'),
	(214313, 118, '2014-03-01 00:14:53.000000', 'temperatura', 552.0000, 'ºC'),
	(214314, 118, '2014-03-01 00:14:54.000000', 'temperatura', 506.0000, 'ºC'),
	(214315, 118, '2014-03-01 00:14:55.000000', 'temperatura', 876.0000, 'ºC'),
	(214316, 118, '2014-03-01 00:14:56.000000', 'temperatura', 462.0000, 'ºC'),
	(214317, 118, '2014-03-01 00:14:57.000000', 'temperatura', 884.0000, 'ºC'),
	(214318, 118, '2014-03-01 00:14:58.000000', 'temperatura', 633.0000, 'ºC'),
	(214319, 118, '2014-03-01 00:14:59.000000', 'temperatura', 516.0000, 'ºC'),
	(214320, 118, '2014-03-01 00:15:00.000000', 'temperatura', 679.0000, 'ºC'),
	(214321, 118, '2014-03-01 00:15:01.000000', 'temperatura', 649.0000, 'ºC'),
	(214322, 118, '2014-03-01 00:15:02.000000', 'temperatura', 9.0000, 'ºC'),
	(214323, 118, '2014-03-01 00:15:03.000000', 'temperatura', 499.0000, 'ºC'),
	(214324, 118, '2014-03-01 00:15:04.000000', 'temperatura', 69.0000, 'ºC'),
	(214325, 118, '2014-03-01 00:15:05.000000', 'temperatura', 49.0000, 'ºC'),
	(214326, 118, '2014-03-01 00:15:06.000000', 'temperatura', 37.0000, 'ºC'),
	(214327, 118, '2014-03-01 00:15:07.000000', 'temperatura', 39.0000, 'ºC'),
	(214328, 118, '2014-03-01 00:15:08.000000', 'temperatura', 85.0000, 'ºC'),
	(214329, 118, '2014-03-01 00:15:09.000000', 'temperatura', 308.0000, 'ºC'),
	(214330, 118, '2014-03-01 00:15:10.000000', 'temperatura', 85.0000, 'ºC'),
	(214331, 118, '2014-03-01 00:15:11.000000', 'temperatura', 700.0000, 'ºC'),
	(214332, 118, '2014-03-01 00:15:12.000000', 'temperatura', 847.0000, 'ºC'),
	(214333, 118, '2014-03-01 00:15:13.000000', 'temperatura', 933.0000, 'ºC'),
	(214334, 118, '2014-03-01 00:15:14.000000', 'temperatura', 928.0000, 'ºC'),
	(214335, 118, '2014-03-01 00:15:15.000000', 'temperatura', 641.0000, 'ºC'),
	(214336, 118, '2014-03-01 00:15:16.000000', 'temperatura', 422.0000, 'ºC'),
	(214337, 118, '2014-03-01 00:15:17.000000', 'temperatura', 188.0000, 'ºC'),
	(214338, 118, '2014-03-01 00:15:18.000000', 'temperatura', 872.0000, 'ºC'),
	(214339, 118, '2014-03-01 00:15:19.000000', 'temperatura', 198.0000, 'ºC'),
	(214340, 118, '2014-03-01 00:15:20.000000', 'temperatura', 775.0000, 'ºC'),
	(214341, 118, '2014-03-01 00:15:21.000000', 'temperatura', 879.0000, 'ºC'),
	(214342, 118, '2014-03-01 00:15:22.000000', 'temperatura', 873.0000, 'ºC'),
	(214343, 118, '2014-03-01 00:15:23.000000', 'temperatura', 528.0000, 'ºC'),
	(214344, 118, '2014-03-01 00:15:24.000000', 'temperatura', 20.0000, 'ºC'),
	(214345, 118, '2014-03-01 00:15:25.000000', 'temperatura', 917.0000, 'ºC'),
	(214346, 118, '2014-03-01 00:15:26.000000', 'temperatura', 924.0000, 'ºC'),
	(214347, 118, '2014-03-01 00:15:27.000000', 'temperatura', 670.0000, 'ºC'),
	(214348, 118, '2014-03-01 00:15:28.000000', 'temperatura', 579.0000, 'ºC'),
	(214349, 118, '2014-03-01 00:15:29.000000', 'temperatura', 886.0000, 'ºC'),
	(214350, 118, '2014-03-01 00:15:30.000000', 'temperatura', 292.0000, 'ºC'),
	(214351, 118, '2014-03-01 00:15:31.000000', 'temperatura', 4.0000, 'ºC'),
	(214352, 118, '2014-03-01 00:15:32.000000', 'temperatura', 342.0000, 'ºC'),
	(214353, 118, '2014-03-01 00:15:33.000000', 'temperatura', 502.0000, 'ºC'),
	(214354, 118, '2014-03-01 00:15:34.000000', 'temperatura', 282.0000, 'ºC'),
	(214355, 118, '2014-03-01 00:15:35.000000', 'temperatura', 1106.0000, 'ºC'),
	(214356, 118, '2014-03-01 00:15:36.000000', 'temperatura', 1085.0000, 'ºC'),
	(214357, 118, '2014-03-01 00:15:37.000000', 'temperatura', 906.0000, 'ºC'),
	(214358, 118, '2014-03-01 00:15:38.000000', 'temperatura', 74.0000, 'ºC'),
	(214359, 118, '2014-03-01 00:15:39.000000', 'temperatura', 55.0000, 'ºC'),
	(214360, 118, '2014-03-01 00:15:40.000000', 'temperatura', 54.0000, 'ºC'),
	(214361, 118, '2014-03-01 00:15:41.000000', 'temperatura', 107.0000, 'ºC'),
	(214362, 118, '2014-03-01 00:15:42.000000', 'temperatura', 370.0000, 'ºC'),
	(214363, 118, '2014-03-01 00:15:43.000000', 'temperatura', 330.0000, 'ºC'),
	(214364, 118, '2014-03-01 00:15:44.000000', 'temperatura', 543.0000, 'ºC'),
	(214365, 118, '2014-03-01 00:15:45.000000', 'temperatura', 524.0000, 'ºC'),
	(214366, 118, '2014-03-01 00:15:46.000000', 'temperatura', 991.0000, 'ºC'),
	(214367, 118, '2014-03-01 00:15:47.000000', 'temperatura', 986.0000, 'ºC'),
	(214368, 118, '2014-03-01 00:15:48.000000', 'temperatura', 755.0000, 'ºC'),
	(214369, 118, '2014-03-01 00:15:49.000000', 'temperatura', 817.0000, 'ºC'),
	(214370, 118, '2014-03-01 00:15:50.000000', 'temperatura', 621.0000, 'ºC'),
	(214371, 118, '2014-03-01 00:15:51.000000', 'temperatura', 657.0000, 'ºC'),
	(214372, 118, '2014-03-01 00:15:52.000000', 'temperatura', 220.0000, 'ºC'),
	(214373, 118, '2014-03-01 00:15:53.000000', 'temperatura', 331.0000, 'ºC'),
	(214374, 118, '2014-03-01 00:15:54.000000', 'temperatura', 997.0000, 'ºC'),
	(214375, 118, '2014-03-01 00:15:55.000000', 'temperatura', 390.0000, 'ºC'),
	(214376, 118, '2014-03-01 00:15:56.000000', 'temperatura', 161.0000, 'ºC'),
	(214377, 118, '2014-03-01 00:15:57.000000', 'temperatura', 836.0000, 'ºC'),
	(214378, 118, '2014-03-01 00:15:58.000000', 'temperatura', 97.0000, 'ºC'),
	(214379, 118, '2014-03-01 00:15:59.000000', 'temperatura', 379.0000, 'ºC'),
	(214380, 118, '2014-03-01 00:16:00.000000', 'temperatura', 402.0000, 'ºC'),
	(214381, 118, '2014-03-01 00:16:01.000000', 'temperatura', 875.0000, 'ºC'),
	(214382, 118, '2014-03-01 00:16:02.000000', 'temperatura', 771.0000, 'ºC'),
	(214383, 118, '2014-03-01 00:16:03.000000', 'temperatura', 28.0000, 'ºC'),
	(214384, 118, '2014-03-01 00:16:04.000000', 'temperatura', 230.0000, 'ºC'),
	(214385, 118, '2014-03-01 00:16:05.000000', 'temperatura', 1067.0000, 'ºC'),
	(214386, 118, '2014-03-01 00:16:06.000000', 'temperatura', 1045.0000, 'ºC'),
	(214387, 118, '2014-03-01 00:16:07.000000', 'temperatura', 822.0000, 'ºC'),
	(214388, 118, '2014-03-01 00:16:08.000000', 'temperatura', 978.0000, 'ºC'),
	(214389, 118, '2014-03-01 00:16:09.000000', 'temperatura', 22.0000, 'ºC'),
	(214390, 118, '2014-03-01 00:16:10.000000', 'temperatura', 779.0000, 'ºC'),
	(214391, 118, '2014-03-01 00:16:11.000000', 'temperatura', 228.0000, 'ºC'),
	(214392, 118, '2014-03-01 00:16:12.000000', 'temperatura', 4.0000, 'ºC'),
	(214393, 118, '2014-03-01 00:16:13.000000', 'temperatura', 538.0000, 'ºC'),
	(214394, 118, '2014-03-01 00:16:14.000000', 'temperatura', 278.0000, 'ºC'),
	(214395, 118, '2014-03-01 00:16:15.000000', 'temperatura', 978.0000, 'ºC'),
	(214396, 118, '2014-03-01 00:16:16.000000', 'temperatura', 455.0000, 'ºC'),
	(214397, 118, '2014-03-01 00:16:17.000000', 'temperatura', 544.0000, 'ºC'),
	(214398, 118, '2014-03-01 00:16:18.000000', 'temperatura', 152.0000, 'ºC'),
	(214399, 118, '2014-03-01 00:16:19.000000', 'temperatura', 329.0000, 'ºC'),
	(214400, 118, '2014-03-01 00:16:20.000000', 'temperatura', 1188.0000, 'ºC'),
	(214401, 118, '2014-03-01 00:16:21.000000', 'temperatura', 155.0000, 'ºC'),
	(214402, 118, '2014-03-01 00:16:22.000000', 'temperatura', 811.0000, 'ºC'),
	(214403, 118, '2014-03-01 00:16:23.000000', 'temperatura', 1192.0000, 'ºC'),
	(214404, 118, '2014-03-01 00:16:24.000000', 'temperatura', 1128.0000, 'ºC'),
	(214405, 118, '2014-03-01 00:16:25.000000', 'temperatura', 865.0000, 'ºC'),
	(214406, 118, '2014-03-01 00:16:26.000000', 'temperatura', 941.0000, 'ºC'),
	(214407, 118, '2014-03-01 00:16:27.000000', 'temperatura', 911.0000, 'ºC'),
	(214408, 118, '2014-03-01 00:16:28.000000', 'temperatura', 532.0000, 'ºC'),
	(214409, 118, '2014-03-01 00:16:29.000000', 'temperatura', 1126.0000, 'ºC'),
	(214410, 118, '2014-03-01 00:16:30.000000', 'temperatura', 437.0000, 'ºC'),
	(214411, 118, '2014-03-01 00:16:31.000000', 'temperatura', 4.0000, 'ºC'),
	(214412, 118, '2014-03-01 00:16:32.000000', 'temperatura', 1113.0000, 'ºC'),
	(214413, 118, '2014-03-01 00:16:33.000000', 'temperatura', 752.0000, 'ºC'),
	(214414, 118, '2014-03-01 00:16:34.000000', 'temperatura', 422.0000, 'ºC'),
	(214415, 118, '2014-03-01 00:16:35.000000', 'temperatura', 1056.0000, 'ºC'),
	(214416, 118, '2014-03-01 00:16:36.000000', 'temperatura', 413.0000, 'ºC'),
	(214417, 118, '2014-03-01 00:16:37.000000', 'temperatura', 99.0000, 'ºC'),
	(214418, 118, '2014-03-01 00:16:38.000000', 'temperatura', 454.0000, 'ºC'),
	(214419, 118, '2014-03-01 00:16:39.000000', 'temperatura', 775.0000, 'ºC'),
	(214420, 118, '2014-03-01 00:16:40.000000', 'temperatura', 115.0000, 'ºC'),
	(214421, 118, '2014-03-01 00:16:41.000000', 'temperatura', 651.0000, 'ºC'),
	(214422, 118, '2014-03-01 00:16:42.000000', 'temperatura', 508.0000, 'ºC'),
	(214423, 118, '2014-03-01 00:16:43.000000', 'temperatura', 587.0000, 'ºC'),
	(214424, 118, '2014-03-01 00:16:44.000000', 'temperatura', 214.0000, 'ºC'),
	(214425, 118, '2014-03-01 00:16:45.000000', 'temperatura', 507.0000, 'ºC'),
	(214426, 118, '2014-03-01 00:16:46.000000', 'temperatura', 693.0000, 'ºC'),
	(214427, 118, '2014-03-01 00:16:47.000000', 'temperatura', 744.0000, 'ºC'),
	(214428, 118, '2014-03-01 00:16:48.000000', 'temperatura', 444.0000, 'ºC'),
	(214429, 118, '2014-03-01 00:16:49.000000', 'temperatura', 1188.0000, 'ºC'),
	(214430, 118, '2014-03-01 00:16:50.000000', 'temperatura', 1008.0000, 'ºC'),
	(214431, 118, '2014-03-01 00:16:51.000000', 'temperatura', 275.0000, 'ºC'),
	(214432, 118, '2014-03-01 00:16:52.000000', 'temperatura', 754.0000, 'ºC'),
	(214433, 118, '2014-03-01 00:16:53.000000', 'temperatura', 546.0000, 'ºC'),
	(214434, 118, '2014-03-01 00:16:54.000000', 'temperatura', 466.0000, 'ºC'),
	(214435, 118, '2014-03-01 00:16:55.000000', 'temperatura', 695.0000, 'ºC'),
	(214436, 118, '2014-03-01 00:16:56.000000', 'temperatura', 876.0000, 'ºC'),
	(214437, 118, '2014-03-01 00:16:57.000000', 'temperatura', 1096.0000, 'ºC'),
	(214438, 118, '2014-03-01 00:16:58.000000', 'temperatura', 454.0000, 'ºC'),
	(214439, 118, '2014-03-01 00:16:59.000000', 'temperatura', 182.0000, 'ºC'),
	(214440, 118, '2014-03-01 00:17:00.000000', 'temperatura', 750.0000, 'ºC'),
	(214441, 118, '2014-03-01 00:17:01.000000', 'temperatura', 804.0000, 'ºC'),
	(214442, 118, '2014-03-01 00:17:02.000000', 'temperatura', 569.0000, 'ºC'),
	(214443, 118, '2014-03-01 00:17:03.000000', 'temperatura', 432.0000, 'ºC'),
	(214444, 118, '2014-03-01 00:17:04.000000', 'temperatura', 455.0000, 'ºC'),
	(214445, 118, '2014-03-01 00:17:05.000000', 'temperatura', 981.0000, 'ºC'),
	(214446, 118, '2014-03-01 00:17:06.000000', 'temperatura', 1139.0000, 'ºC'),
	(214447, 118, '2014-03-01 00:17:07.000000', 'temperatura', 354.0000, 'ºC'),
	(214448, 118, '2014-03-01 00:17:08.000000', 'temperatura', 752.0000, 'ºC'),
	(214449, 118, '2014-03-01 00:17:09.000000', 'temperatura', 299.0000, 'ºC'),
	(214450, 118, '2014-03-01 00:17:10.000000', 'temperatura', 441.0000, 'ºC'),
	(214451, 118, '2014-03-01 00:17:11.000000', 'temperatura', 108.0000, 'ºC'),
	(214452, 118, '2014-03-01 00:17:12.000000', 'temperatura', 417.0000, 'ºC'),
	(214453, 118, '2014-03-01 00:17:13.000000', 'temperatura', 560.0000, 'ºC'),
	(214454, 118, '2014-03-01 00:17:14.000000', 'temperatura', 349.0000, 'ºC'),
	(214455, 118, '2014-03-01 00:17:15.000000', 'temperatura', 65.0000, 'ºC'),
	(214456, 118, '2014-03-01 00:17:16.000000', 'temperatura', 481.0000, 'ºC'),
	(214457, 118, '2014-03-01 00:17:17.000000', 'temperatura', 1009.0000, 'ºC'),
	(214458, 118, '2014-03-01 00:17:18.000000', 'temperatura', 5.0000, 'ºC'),
	(214459, 118, '2014-03-01 00:17:19.000000', 'temperatura', 596.0000, 'ºC'),
	(214460, 118, '2014-03-01 00:17:20.000000', 'temperatura', 566.0000, 'ºC'),
	(214461, 118, '2014-03-01 00:17:21.000000', 'temperatura', 1041.0000, 'ºC'),
	(214462, 118, '2014-03-01 00:17:22.000000', 'temperatura', 1108.0000, 'ºC'),
	(214463, 118, '2014-03-01 00:17:23.000000', 'temperatura', 16.0000, 'ºC'),
	(214464, 118, '2014-03-01 00:17:24.000000', 'temperatura', 360.0000, 'ºC'),
	(214465, 118, '2014-03-01 00:17:25.000000', 'temperatura', 550.0000, 'ºC'),
	(214466, 118, '2014-03-01 00:17:26.000000', 'temperatura', 470.0000, 'ºC'),
	(214467, 118, '2014-03-01 00:17:27.000000', 'temperatura', 700.0000, 'ºC'),
	(214468, 118, '2014-03-01 00:17:28.000000', 'temperatura', 894.0000, 'ºC'),
	(214469, 118, '2014-03-01 00:17:29.000000', 'temperatura', 1167.0000, 'ºC'),
	(214470, 118, '2014-03-01 00:17:30.000000', 'temperatura', 754.0000, 'ºC'),
	(214471, 118, '2014-03-01 00:17:31.000000', 'temperatura', 270.0000, 'ºC'),
	(214472, 118, '2014-03-01 00:17:32.000000', 'temperatura', 290.0000, 'ºC'),
	(214473, 118, '2014-03-01 00:17:33.000000', 'temperatura', 641.0000, 'ºC'),
	(214474, 118, '2014-03-01 00:17:34.000000', 'temperatura', 1134.0000, 'ºC'),
	(214475, 118, '2014-03-01 00:17:35.000000', 'temperatura', 149.0000, 'ºC'),
	(214476, 118, '2014-03-01 00:17:36.000000', 'temperatura', 941.0000, 'ºC'),
	(214477, 118, '2014-03-01 00:17:37.000000', 'temperatura', 658.0000, 'ºC'),
	(214478, 118, '2014-03-01 00:17:38.000000', 'temperatura', 468.0000, 'ºC'),
	(214479, 118, '2014-03-01 00:17:39.000000', 'temperatura', 367.0000, 'ºC'),
	(214480, 118, '2014-03-01 00:17:40.000000', 'temperatura', 432.0000, 'ºC'),
	(214481, 118, '2014-03-01 00:17:41.000000', 'temperatura', 1060.0000, 'ºC'),
	(214482, 118, '2014-03-01 00:17:42.000000', 'temperatura', 405.0000, 'ºC'),
	(214483, 118, '2014-03-01 00:17:43.000000', 'temperatura', 45.0000, 'ºC'),
	(214484, 118, '2014-03-01 00:17:44.000000', 'temperatura', 210.0000, 'ºC'),
	(214485, 118, '2014-03-01 00:17:45.000000', 'temperatura', 915.0000, 'ºC'),
	(214486, 118, '2014-03-01 00:17:46.000000', 'temperatura', 345.0000, 'ºC'),
	(214487, 118, '2014-03-01 00:17:47.000000', 'temperatura', 179.0000, 'ºC'),
	(214488, 118, '2014-03-01 00:17:48.000000', 'temperatura', 1063.0000, 'ºC'),
	(214489, 118, '2014-03-01 00:17:49.000000', 'temperatura', 1177.0000, 'ºC'),
	(214490, 118, '2014-03-01 00:17:50.000000', 'temperatura', 295.0000, 'ºC'),
	(214491, 118, '2014-03-01 00:17:51.000000', 'temperatura', 348.0000, 'ºC'),
	(214492, 118, '2014-03-01 00:17:52.000000', 'temperatura', 854.0000, 'ºC'),
	(214493, 118, '2014-03-01 00:17:53.000000', 'temperatura', 825.0000, 'ºC'),
	(214494, 118, '2014-03-01 00:17:54.000000', 'temperatura', 363.0000, 'ºC'),
	(214495, 118, '2014-03-01 00:17:55.000000', 'temperatura', 543.0000, 'ºC'),
	(214496, 118, '2014-03-01 00:17:56.000000', 'temperatura', 425.0000, 'ºC'),
	(214497, 118, '2014-03-01 00:17:57.000000', 'temperatura', 495.0000, 'ºC'),
	(214498, 118, '2014-03-01 00:17:58.000000', 'temperatura', 1.0000, 'ºC'),
	(214499, 118, '2014-03-01 00:17:59.000000', 'temperatura', 919.0000, 'ºC'),
	(214500, 118, '2014-03-01 00:18:00.000000', 'temperatura', 996.0000, 'ºC'),
	(214501, 118, '2014-03-01 00:18:01.000000', 'temperatura', 1020.0000, 'ºC'),
	(214502, 118, '2014-03-01 00:18:02.000000', 'temperatura', 914.0000, 'ºC'),
	(214503, 118, '2014-03-01 00:18:03.000000', 'temperatura', 310.0000, 'ºC'),
	(214504, 118, '2014-03-01 00:18:04.000000', 'temperatura', 8.0000, 'ºC'),
	(214505, 118, '2014-03-01 00:18:05.000000', 'temperatura', 312.0000, 'ºC'),
	(214506, 118, '2014-03-01 00:18:06.000000', 'temperatura', 337.0000, 'ºC'),
	(214507, 118, '2014-03-01 00:18:07.000000', 'temperatura', 751.0000, 'ºC'),
	(214508, 118, '2014-03-01 00:18:08.000000', 'temperatura', 341.0000, 'ºC'),
	(214509, 118, '2014-03-01 00:18:09.000000', 'temperatura', 654.0000, 'ºC'),
	(214510, 118, '2014-03-01 00:18:10.000000', 'temperatura', 1048.0000, 'ºC'),
	(214511, 118, '2014-03-01 00:18:11.000000', 'temperatura', 877.0000, 'ºC'),
	(214512, 118, '2014-03-01 00:18:12.000000', 'temperatura', 43.0000, 'ºC'),
	(214513, 118, '2014-03-01 00:18:13.000000', 'temperatura', 1185.0000, 'ºC'),
	(214514, 118, '2014-03-01 00:18:14.000000', 'temperatura', 997.0000, 'ºC'),
	(214515, 118, '2014-03-01 00:18:15.000000', 'temperatura', 229.0000, 'ºC'),
	(214516, 118, '2014-03-01 00:18:16.000000', 'temperatura', 554.0000, 'ºC'),
	(214517, 118, '2014-03-01 00:18:17.000000', 'temperatura', 885.0000, 'ºC'),
	(214518, 118, '2014-03-01 00:18:18.000000', 'temperatura', 362.0000, 'ºC'),
	(214519, 118, '2014-03-01 00:18:19.000000', 'temperatura', 355.0000, 'ºC'),
	(214520, 118, '2014-03-01 00:18:20.000000', 'temperatura', 690.0000, 'ºC'),
	(214521, 118, '2014-03-01 00:18:21.000000', 'temperatura', 1184.0000, 'ºC'),
	(214522, 118, '2014-03-01 00:18:22.000000', 'temperatura', 251.0000, 'ºC'),
	(214523, 118, '2014-03-01 00:18:23.000000', 'temperatura', 103.0000, 'ºC'),
	(214524, 118, '2014-03-01 00:18:24.000000', 'temperatura', 963.0000, 'ºC'),
	(214525, 118, '2014-03-01 00:18:25.000000', 'temperatura', 905.0000, 'ºC'),
	(214526, 118, '2014-03-01 00:18:26.000000', 'temperatura', 438.0000, 'ºC'),
	(214527, 118, '2014-03-01 00:18:27.000000', 'temperatura', 674.0000, 'ºC'),
	(214528, 118, '2014-03-01 00:18:28.000000', 'temperatura', 859.0000, 'ºC'),
	(214529, 118, '2014-03-01 00:18:29.000000', 'temperatura', 1074.0000, 'ºC'),
	(214530, 118, '2014-03-01 00:18:30.000000', 'temperatura', 393.0000, 'ºC'),
	(214531, 118, '2014-03-01 00:18:31.000000', 'temperatura', 1143.0000, 'ºC'),
	(214532, 118, '2014-03-01 00:18:32.000000', 'temperatura', 936.0000, 'ºC'),
	(214533, 118, '2014-03-01 00:18:33.000000', 'temperatura', 50.0000, 'ºC'),
	(214534, 118, '2014-03-01 00:18:34.000000', 'temperatura', 1044.0000, 'ºC'),
	(214535, 118, '2014-03-01 00:18:35.000000', 'temperatura', 270.0000, 'ºC'),
	(214536, 118, '2014-03-01 00:18:36.000000', 'temperatura', 619.0000, 'ºC'),
	(214537, 118, '2014-03-01 00:18:37.000000', 'temperatura', 1085.0000, 'ºC'),
	(214538, 118, '2014-03-01 00:18:38.000000', 'temperatura', 1168.0000, 'ºC'),
	(214539, 118, '2014-03-01 00:18:39.000000', 'temperatura', 186.0000, 'ºC'),
	(214540, 118, '2014-03-01 00:18:40.000000', 'temperatura', 1028.0000, 'ºC'),
	(214541, 118, '2014-03-01 00:18:41.000000', 'temperatura', 982.0000, 'ºC'),
	(214542, 118, '2014-03-01 00:18:42.000000', 'temperatura', 627.0000, 'ºC'),
	(214543, 118, '2014-03-01 00:18:43.000000', 'temperatura', 191.0000, 'ºC'),
	(214544, 118, '2014-03-01 00:18:44.000000', 'temperatura', 271.0000, 'ºC'),
	(214545, 118, '2014-03-01 00:18:45.000000', 'temperatura', 786.0000, 'ºC'),
	(214546, 118, '2014-03-01 00:18:46.000000', 'temperatura', 716.0000, 'ºC'),
	(214547, 118, '2014-03-01 00:18:47.000000', 'temperatura', 23.0000, 'ºC'),
	(214548, 118, '2014-03-01 00:18:48.000000', 'temperatura', 367.0000, 'ºC'),
	(214549, 118, '2014-03-01 00:18:49.000000', 'temperatura', 566.0000, 'ºC'),
	(214550, 118, '2014-03-01 00:18:50.000000', 'temperatura', 529.0000, 'ºC'),
	(214551, 118, '2014-03-01 00:18:51.000000', 'temperatura', 950.0000, 'ºC'),
	(214552, 118, '2014-03-01 00:18:52.000000', 'temperatura', 763.0000, 'ºC'),
	(214553, 118, '2014-03-01 00:18:53.000000', 'temperatura', 965.0000, 'ºC'),
	(214554, 118, '2014-03-01 00:18:54.000000', 'temperatura', 137.0000, 'ºC'),
	(214555, 118, '2014-03-01 00:18:55.000000', 'temperatura', 192.0000, 'ºC'),
	(214556, 118, '2014-03-01 00:18:56.000000', 'temperatura', 547.0000, 'ºC'),
	(214557, 118, '2014-03-01 00:18:57.000000', 'temperatura', 960.0000, 'ºC'),
	(214558, 118, '2014-03-01 00:18:58.000000', 'temperatura', 761.0000, 'ºC'),
	(214559, 118, '2014-03-01 00:18:59.000000', 'temperatura', 926.0000, 'ºC'),
	(214560, 118, '2014-03-01 00:19:00.000000', 'temperatura', 1148.0000, 'ºC'),
	(214561, 118, '2014-03-01 00:19:01.000000', 'temperatura', 560.0000, 'ºC'),
	(214562, 118, '2014-03-01 00:19:02.000000', 'temperatura', 557.0000, 'ºC'),
	(214563, 118, '2014-03-01 00:19:03.000000', 'temperatura', 1107.0000, 'ºC'),
	(214564, 118, '2014-03-01 00:19:04.000000', 'temperatura', 263.0000, 'ºC'),
	(214565, 118, '2014-03-01 00:19:05.000000', 'temperatura', 396.0000, 'ºC'),
	(214566, 118, '2014-03-01 00:19:06.000000', 'temperatura', 1189.0000, 'ºC'),
	(214567, 118, '2014-03-01 00:19:07.000000', 'temperatura', 1160.0000, 'ºC'),
	(214568, 118, '2014-03-01 00:19:08.000000', 'temperatura', 1034.0000, 'ºC'),
	(214569, 118, '2014-03-01 00:19:09.000000', 'temperatura', 491.0000, 'ºC'),
	(214570, 118, '2014-03-01 00:19:10.000000', 'temperatura', 553.0000, 'ºC'),
	(214571, 118, '2014-03-01 00:19:11.000000', 'temperatura', 92.0000, 'ºC'),
	(214572, 118, '2014-03-01 00:19:12.000000', 'temperatura', 1.0000, 'ºC'),
	(214573, 118, '2014-03-01 00:19:13.000000', 'temperatura', 929.0000, 'ºC'),
	(214574, 118, '2014-03-01 00:19:14.000000', 'temperatura', 1045.0000, 'ºC'),
	(214575, 118, '2014-03-01 00:19:15.000000', 'temperatura', 38.0000, 'ºC'),
	(214576, 118, '2014-03-01 00:19:16.000000', 'temperatura', 656.0000, 'ºC'),
	(214577, 118, '2014-03-01 00:19:17.000000', 'temperatura', 766.0000, 'ºC'),
	(214578, 118, '2014-03-01 00:19:18.000000', 'temperatura', 664.0000, 'ºC'),
	(214579, 118, '2014-03-01 00:19:19.000000', 'temperatura', 1022.0000, 'ºC'),
	(214580, 118, '2014-03-01 00:19:20.000000', 'temperatura', 717.0000, 'ºC'),
	(214581, 118, '2014-03-01 00:19:21.000000', 'temperatura', 521.0000, 'ºC'),
	(214582, 118, '2014-03-01 00:19:22.000000', 'temperatura', 452.0000, 'ºC'),
	(214583, 118, '2014-03-01 00:19:23.000000', 'temperatura', 701.0000, 'ºC'),
	(214584, 118, '2014-03-01 00:19:24.000000', 'temperatura', 947.0000, 'ºC'),
	(214585, 118, '2014-03-01 00:19:25.000000', 'temperatura', 233.0000, 'ºC'),
	(214586, 118, '2014-03-01 00:19:26.000000', 'temperatura', 724.0000, 'ºC'),
	(214587, 118, '2014-03-01 00:19:27.000000', 'temperatura', 524.0000, 'ºC'),
	(214588, 118, '2014-03-01 00:19:28.000000', 'temperatura', 446.0000, 'ºC'),
	(214589, 118, '2014-03-01 00:19:29.000000', 'temperatura', 658.0000, 'ºC'),
	(214590, 118, '2014-03-01 00:19:30.000000', 'temperatura', 755.0000, 'ºC'),
	(214591, 118, '2014-03-01 00:19:31.000000', 'temperatura', 599.0000, 'ºC'),
	(214592, 118, '2014-03-01 00:19:32.000000', 'temperatura', 734.0000, 'ºC'),
	(214593, 118, '2014-03-01 00:19:33.000000', 'temperatura', 670.0000, 'ºC'),
	(214594, 118, '2014-03-01 00:19:34.000000', 'temperatura', 1149.0000, 'ºC'),
	(214595, 118, '2014-03-01 00:19:35.000000', 'temperatura', 134.0000, 'ºC'),
	(214596, 118, '2014-03-01 00:19:36.000000', 'temperatura', 826.0000, 'ºC'),
	(214597, 118, '2014-03-01 00:19:37.000000', 'temperatura', 128.0000, 'ºC'),
	(214598, 118, '2014-03-01 00:19:38.000000', 'temperatura', 564.0000, 'ºC'),
	(214599, 118, '2014-03-01 00:19:39.000000', 'temperatura', 35.0000, 'ºC'),
	(214600, 118, '2014-03-01 00:19:40.000000', 'temperatura', 883.0000, 'ºC'),
	(214601, 118, '2014-03-01 00:19:41.000000', 'temperatura', 713.0000, 'ºC'),
	(214602, 118, '2014-03-01 00:19:42.000000', 'temperatura', 914.0000, 'ºC'),
	(214603, 118, '2014-03-01 00:19:43.000000', 'temperatura', 31.0000, 'ºC'),
	(214604, 118, '2014-03-01 00:19:44.000000', 'temperatura', 1014.0000, 'ºC'),
	(214605, 118, '2014-03-01 00:19:45.000000', 'temperatura', 178.0000, 'ºC'),
	(214606, 118, '2014-03-01 00:19:46.000000', 'temperatura', 249.0000, 'ºC'),
	(214607, 118, '2014-03-01 00:19:47.000000', 'temperatura', 710.0000, 'ºC'),
	(214608, 118, '2014-03-01 00:19:48.000000', 'temperatura', 404.0000, 'ºC'),
	(214609, 118, '2014-03-01 00:19:49.000000', 'temperatura', 1091.0000, 'ºC'),
	(214610, 118, '2014-03-01 00:19:50.000000', 'temperatura', 642.0000, 'ºC'),
	(214611, 118, '2014-03-01 00:19:51.000000', 'temperatura', 1140.0000, 'ºC'),
	(214612, 118, '2014-03-01 00:19:52.000000', 'temperatura', 172.0000, 'ºC'),
	(214613, 118, '2014-03-01 00:19:53.000000', 'temperatura', 1040.0000, 'ºC'),
	(214614, 118, '2014-03-01 00:19:54.000000', 'temperatura', 1085.0000, 'ºC'),
	(214615, 118, '2014-03-01 00:19:55.000000', 'temperatura', 1104.0000, 'ºC'),
	(214616, 118, '2014-03-01 00:19:56.000000', 'temperatura', 1067.0000, 'ºC'),
	(214617, 118, '2014-03-01 00:19:57.000000', 'temperatura', 822.0000, 'ºC'),
	(214618, 118, '2014-03-01 00:19:58.000000', 'temperatura', 910.0000, 'ºC'),
	(214619, 118, '2014-03-01 00:19:59.000000', 'temperatura', 885.0000, 'ºC'),
	(214620, 118, '2014-03-01 00:20:00.000000', 'temperatura', 497.0000, 'ºC'),
	(214621, 118, '2014-03-01 00:20:01.000000', 'temperatura', 1029.0000, 'ºC'),
	(214622, 118, '2014-03-01 00:20:02.000000', 'temperatura', 54.0000, 'ºC'),
	(214623, 118, '2014-03-01 00:20:03.000000', 'temperatura', 783.0000, 'ºC'),
	(214624, 118, '2014-03-01 00:20:04.000000', 'temperatura', 156.0000, 'ºC'),
	(214625, 118, '2014-03-01 00:20:05.000000', 'temperatura', 830.0000, 'ºC'),
	(214626, 118, '2014-03-01 00:20:06.000000', 'temperatura', 83.0000, 'ºC'),
	(214627, 118, '2014-03-01 00:20:07.000000', 'temperatura', 326.0000, 'ºC'),
	(214628, 118, '2014-03-01 00:20:08.000000', 'temperatura', 181.0000, 'ºC'),
	(214629, 118, '2014-03-01 00:20:09.000000', 'temperatura', 1125.0000, 'ºC'),
	(214630, 118, '2014-03-01 00:20:10.000000', 'temperatura', 286.0000, 'ºC'),
	(214631, 118, '2014-03-01 00:20:11.000000', 'temperatura', 456.0000, 'ºC'),
	(214632, 118, '2014-03-01 00:20:12.000000', 'temperatura', 220.0000, 'ºC'),
	(214633, 118, '2014-03-01 00:20:13.000000', 'temperatura', 933.0000, 'ºC'),
	(214634, 118, '2014-03-01 00:20:14.000000', 'temperatura', 405.0000, 'ºC'),
	(214635, 118, '2014-03-01 00:20:15.000000', 'temperatura', 428.0000, 'ºC'),
	(214636, 118, '2014-03-01 00:20:16.000000', 'temperatura', 925.0000, 'ºC'),
	(214637, 118, '2014-03-01 00:20:17.000000', 'temperatura', 943.0000, 'ºC'),
	(214638, 118, '2014-03-01 00:20:18.000000', 'temperatura', 739.0000, 'ºC'),
	(214639, 118, '2014-03-01 00:20:19.000000', 'temperatura', 869.0000, 'ºC'),
	(214640, 118, '2014-03-01 00:20:20.000000', 'temperatura', 925.0000, 'ºC'),
	(214641, 118, '2014-03-01 00:20:21.000000', 'temperatura', 819.0000, 'ºC'),
	(214642, 118, '2014-03-01 00:20:22.000000', 'temperatura', 122.0000, 'ºC'),
	(214643, 118, '2014-03-01 00:20:23.000000', 'temperatura', 552.0000, 'ºC'),
	(214644, 118, '2014-03-01 00:20:24.000000', 'temperatura', 1197.0000, 'ºC'),
	(214645, 118, '2014-03-01 00:20:25.000000', 'temperatura', 728.0000, 'ºC'),
	(214646, 118, '2014-03-01 00:20:26.000000', 'temperatura', 50.0000, 'ºC'),
	(214647, 118, '2014-03-01 00:20:27.000000', 'temperatura', 467.0000, 'ºC'),
	(214648, 118, '2014-03-01 00:20:28.000000', 'temperatura', 984.0000, 'ºC'),
	(214649, 118, '2014-03-01 00:20:29.000000', 'temperatura', 1121.0000, 'ºC'),
	(214650, 118, '2014-03-01 00:20:30.000000', 'temperatura', 254.0000, 'ºC'),
	(214651, 118, '2014-03-01 00:20:31.000000', 'temperatura', 307.0000, 'ºC'),
	(214652, 118, '2014-03-01 00:20:32.000000', 'temperatura', 774.0000, 'ºC'),
	(214653, 118, '2014-03-01 00:20:33.000000', 'temperatura', 551.0000, 'ºC'),
	(214654, 118, '2014-03-01 00:20:34.000000', 'temperatura', 430.0000, 'ºC'),
	(214655, 118, '2014-03-01 00:20:35.000000', 'temperatura', 500.0000, 'ºC'),
	(214656, 118, '2014-03-01 00:20:36.000000', 'temperatura', 9.0000, 'ºC'),
	(214657, 118, '2014-03-01 00:20:37.000000', 'temperatura', 945.0000, 'ºC'),
	(214658, 118, '2014-03-01 00:20:38.000000', 'temperatura', 1101.0000, 'ºC'),
	(214659, 118, '2014-03-01 00:20:39.000000', 'temperatura', 269.0000, 'ºC'),
	(214660, 118, '2014-03-01 00:20:40.000000', 'temperatura', 442.0000, 'ºC'),
	(214661, 118, '2014-03-01 00:20:41.000000', 'temperatura', 203.0000, 'ºC'),
	(214662, 118, '2014-03-01 00:20:42.000000', 'temperatura', 889.0000, 'ºC'),
	(214663, 118, '2014-03-01 00:20:43.000000', 'temperatura', 235.0000, 'ºC'),
	(214664, 118, '2014-03-01 00:20:44.000000', 'temperatura', 911.0000, 'ºC'),
	(214665, 118, '2014-03-01 00:20:45.000000', 'temperatura', 249.0000, 'ºC'),
	(214666, 118, '2014-03-01 00:20:46.000000', 'temperatura', 915.0000, 'ºC'),
	(214667, 118, '2014-03-01 00:20:47.000000', 'temperatura', 225.0000, 'ºC'),
	(214668, 118, '2014-03-01 00:20:48.000000', 'temperatura', 784.0000, 'ºC'),
	(214669, 118, '2014-03-01 00:20:49.000000', 'temperatura', 844.0000, 'ºC'),
	(214670, 118, '2014-03-01 00:20:50.000000', 'temperatura', 668.0000, 'ºC'),
	(214671, 118, '2014-03-01 00:20:51.000000', 'temperatura', 809.0000, 'ºC'),
	(214672, 118, '2014-03-01 00:20:52.000000', 'temperatura', 841.0000, 'ºC'),
	(214673, 118, '2014-03-01 00:20:53.000000', 'temperatura', 581.0000, 'ºC'),
	(214674, 118, '2014-03-01 00:20:54.000000', 'temperatura', 380.0000, 'ºC'),
	(214675, 118, '2014-03-01 00:20:55.000000', 'temperatura', 157.0000, 'ºC'),
	(214676, 118, '2014-03-01 00:20:56.000000', 'temperatura', 847.0000, 'ºC'),
	(214677, 118, '2014-03-01 00:20:57.000000', 'temperatura', 163.0000, 'ºC'),
	(214678, 118, '2014-03-01 00:20:58.000000', 'temperatura', 676.0000, 'ºC'),
	(214679, 118, '2014-03-01 00:20:59.000000', 'temperatura', 491.0000, 'ºC'),
	(214680, 118, '2014-03-01 00:21:00.000000', 'temperatura', 426.0000, 'ºC'),
	(214681, 118, '2014-03-01 00:21:01.000000', 'temperatura', 659.0000, 'ºC'),
	(214682, 118, '2014-03-01 00:21:02.000000', 'temperatura', 819.0000, 'ºC'),
	(214683, 118, '2014-03-01 00:21:03.000000', 'temperatura', 916.0000, 'ºC'),
	(214684, 118, '2014-03-01 00:21:04.000000', 'temperatura', 926.0000, 'ºC'),
	(214685, 118, '2014-03-01 00:21:05.000000', 'temperatura', 683.0000, 'ºC'),
	(214686, 118, '2014-03-01 00:21:06.000000', 'temperatura', 636.0000, 'ºC'),
	(214687, 118, '2014-03-01 00:21:07.000000', 'temperatura', 1132.0000, 'ºC'),
	(214688, 118, '2014-03-01 00:21:08.000000', 'temperatura', 152.0000, 'ºC'),
	(214689, 118, '2014-03-01 00:21:09.000000', 'temperatura', 967.0000, 'ºC'),
	(214690, 118, '2014-03-01 00:21:10.000000', 'temperatura', 776.0000, 'ºC'),
	(214691, 118, '2014-03-01 00:21:11.000000', 'temperatura', 982.0000, 'ºC'),
	(214692, 118, '2014-03-01 00:21:12.000000', 'temperatura', 180.0000, 'ºC'),
	(214693, 118, '2014-03-01 00:21:13.000000', 'temperatura', 356.0000, 'ºC'),
	(214694, 118, '2014-03-01 00:21:14.000000', 'temperatura', 39.0000, 'ºC'),
	(214695, 118, '2014-03-01 00:21:15.000000', 'temperatura', 329.0000, 'ºC'),
	(214696, 118, '2014-03-01 00:21:16.000000', 'temperatura', 328.0000, 'ºC'),
	(214697, 118, '2014-03-01 00:21:17.000000', 'temperatura', 654.0000, 'ºC'),
	(214698, 118, '2014-03-01 00:21:18.000000', 'temperatura', 1086.0000, 'ºC'),
	(214699, 118, '2014-03-01 00:21:19.000000', 'temperatura', 1068.0000, 'ºC'),
	(214700, 118, '2014-03-01 00:21:20.000000', 'temperatura', 881.0000, 'ºC'),
	(214701, 118, '2014-03-01 00:21:21.000000', 'temperatura', 3.0000, 'ºC'),
	(214702, 118, '2014-03-01 00:21:22.000000', 'temperatura', 973.0000, 'ºC'),
	(214703, 118, '2014-03-01 00:21:23.000000', 'temperatura', 56.0000, 'ºC'),
	(214704, 118, '2014-03-01 00:21:24.000000', 'temperatura', 963.0000, 'ºC'),
	(214705, 118, '2014-03-01 00:21:25.000000', 'temperatura', 1049.0000, 'ºC'),
	(214706, 118, '2014-03-01 00:21:26.000000', 'temperatura', 1153.0000, 'ºC'),
	(214707, 118, '2014-03-01 00:21:27.000000', 'temperatura', 218.0000, 'ºC'),
	(214708, 118, '2014-03-01 00:21:28.000000', 'temperatura', 33.0000, 'ºC'),
	(214709, 118, '2014-03-01 00:21:29.000000', 'temperatura', 712.0000, 'ºC'),
	(214710, 118, '2014-03-01 00:21:30.000000', 'temperatura', 1060.0000, 'ºC'),
	(214711, 118, '2014-03-01 00:21:31.000000', 'temperatura', 763.0000, 'ºC'),
	(214712, 118, '2014-03-01 00:21:32.000000', 'temperatura', 637.0000, 'ºC'),
	(214713, 118, '2014-03-01 00:21:33.000000', 'temperatura', 898.0000, 'ºC'),
	(214714, 118, '2014-03-01 00:21:34.000000', 'temperatura', 178.0000, 'ºC'),
	(214715, 118, '2014-03-01 00:21:35.000000', 'temperatura', 598.0000, 'ºC'),
	(214716, 118, '2014-03-01 00:21:36.000000', 'temperatura', 55.0000, 'ºC'),
	(214717, 118, '2014-03-01 00:21:37.000000', 'temperatura', 880.0000, 'ºC'),
	(214718, 118, '2014-03-01 00:21:38.000000', 'temperatura', 639.0000, 'ºC'),
	(214719, 118, '2014-03-01 00:21:39.000000', 'temperatura', 554.0000, 'ºC'),
	(214720, 118, '2014-03-01 00:21:40.000000', 'temperatura', 852.0000, 'ºC'),
	(214721, 118, '2014-03-01 00:21:41.000000', 'temperatura', 198.0000, 'ºC'),
	(214722, 118, '2014-03-01 00:21:42.000000', 'temperatura', 834.0000, 'ºC'),
	(214723, 118, '2014-03-01 00:21:43.000000', 'temperatura', 1178.0000, 'ºC'),
	(214724, 118, '2014-03-01 00:21:44.000000', 'temperatura', 989.0000, 'ºC'),
	(214725, 118, '2014-03-01 00:21:45.000000', 'temperatura', 211.0000, 'ºC'),
	(214726, 118, '2014-03-01 00:21:46.000000', 'temperatura', 487.0000, 'ºC'),
	(214727, 118, '2014-03-01 00:21:47.000000', 'temperatura', 604.0000, 'ºC'),
	(214728, 118, '2014-03-01 00:21:48.000000', 'temperatura', 359.0000, 'ºC'),
	(214729, 118, '2014-03-01 00:21:49.000000', 'temperatura', 1185.0000, 'ºC'),
	(214730, 118, '2014-03-01 00:21:50.000000', 'temperatura', 50.0000, 'ºC'),
	(214731, 118, '2014-03-01 00:21:51.000000', 'temperatura', 292.0000, 'ºC'),
	(214732, 118, '2014-03-01 00:21:52.000000', 'temperatura', 113.0000, 'ºC'),
	(214733, 118, '2014-03-01 00:21:53.000000', 'temperatura', 889.0000, 'ºC'),
	(214734, 118, '2014-03-01 00:21:54.000000', 'temperatura', 508.0000, 'ºC'),
	(214735, 118, '2014-03-01 00:21:55.000000', 'temperatura', 1071.0000, 'ºC'),
	(214736, 118, '2014-03-01 00:21:56.000000', 'temperatura', 232.0000, 'ºC'),
	(214737, 118, '2014-03-01 00:21:57.000000', 'temperatura', 349.0000, 'ºC'),
	(214738, 118, '2014-03-01 00:21:58.000000', 'temperatura', 1047.0000, 'ºC'),
	(214739, 118, '2014-03-01 00:21:59.000000', 'temperatura', 588.0000, 'ºC'),
	(214740, 118, '2014-03-01 00:22:00.000000', 'temperatura', 1001.0000, 'ºC'),
	(214741, 118, '2014-03-01 00:22:01.000000', 'temperatura', 840.0000, 'ºC'),
	(214742, 118, '2014-03-01 00:22:02.000000', 'temperatura', 0.0000, 'ºC'),
	(214743, 118, '2014-03-01 00:22:03.000000', 'temperatura', 1082.0000, 'ºC'),
	(214744, 118, '2014-03-01 00:22:04.000000', 'temperatura', 607.0000, 'ºC'),
	(214745, 118, '2014-03-01 00:22:05.000000', 'temperatura', 989.0000, 'ºC'),
	(214746, 118, '2014-03-01 00:22:06.000000', 'temperatura', 725.0000, 'ºC'),
	(214747, 118, '2014-03-01 00:22:07.000000', 'temperatura', 658.0000, 'ºC'),
	(214748, 118, '2014-03-01 00:22:08.000000', 'temperatura', 1116.0000, 'ºC'),
	(214749, 118, '2014-03-01 00:22:09.000000', 'temperatura', 6.0000, 'ºC'),
	(214750, 118, '2014-03-01 00:22:10.000000', 'temperatura', 282.0000, 'ºC'),
	(214751, 118, '2014-03-01 00:22:11.000000', 'temperatura', 195.0000, 'ºC'),
	(214752, 118, '2014-03-01 00:22:12.000000', 'temperatura', 126.0000, 'ºC'),
	(214753, 118, '2014-03-01 00:22:13.000000', 'temperatura', 49.0000, 'ºC'),
	(214754, 118, '2014-03-01 00:22:14.000000', 'temperatura', 1067.0000, 'ºC'),
	(214755, 118, '2014-03-01 00:22:15.000000', 'temperatura', 387.0000, 'ºC'),
	(214756, 118, '2014-03-01 00:22:16.000000', 'temperatura', 1134.0000, 'ºC'),
	(214757, 118, '2014-03-01 00:22:17.000000', 'temperatura', 911.0000, 'ºC'),
	(214758, 118, '2014-03-01 00:22:18.000000', 'temperatura', 1152.0000, 'ºC'),
	(214759, 118, '2014-03-01 00:22:19.000000', 'temperatura', 628.0000, 'ºC'),
	(214760, 118, '2014-03-01 00:22:20.000000', 'temperatura', 886.0000, 'ºC'),
	(214761, 118, '2014-03-01 00:22:21.000000', 'temperatura', 144.0000, 'ºC'),
	(214762, 118, '2014-03-01 00:22:22.000000', 'temperatura', 462.0000, 'ºC'),
	(214763, 118, '2014-03-01 00:22:23.000000', 'temperatura', 678.0000, 'ºC'),
	(214764, 118, '2014-03-01 00:22:24.000000', 'temperatura', 806.0000, 'ºC'),
	(214765, 118, '2014-03-01 00:22:25.000000', 'temperatura', 796.0000, 'ºC'),
	(214766, 118, '2014-03-01 00:22:26.000000', 'temperatura', 362.0000, 'ºC'),
	(214767, 118, '2014-03-01 00:22:27.000000', 'temperatura', 624.0000, 'ºC'),
	(214768, 118, '2014-03-01 00:22:28.000000', 'temperatura', 832.0000, 'ºC'),
	(214769, 118, '2014-03-01 00:22:29.000000', 'temperatura', 1090.0000, 'ºC'),
	(214770, 118, '2014-03-01 00:22:30.000000', 'temperatura', 553.0000, 'ºC'),
	(214771, 118, '2014-03-01 00:22:31.000000', 'temperatura', 698.0000, 'ºC'),
	(214772, 118, '2014-03-01 00:22:32.000000', 'temperatura', 629.0000, 'ºC'),
	(214773, 118, '2014-03-01 00:22:33.000000', 'temperatura', 1054.0000, 'ºC'),
	(214774, 118, '2014-03-01 00:22:34.000000', 'temperatura', 983.0000, 'ºC'),
	(214775, 118, '2014-03-01 00:22:35.000000', 'temperatura', 553.0000, 'ºC'),
	(214776, 118, '2014-03-01 00:22:36.000000', 'temperatura', 1016.0000, 'ºC'),
	(214777, 118, '2014-03-01 00:22:37.000000', 'temperatura', 1022.0000, 'ºC'),
	(214778, 118, '2014-03-01 00:22:38.000000', 'temperatura', 864.0000, 'ºC'),
	(214779, 118, '2014-03-01 00:22:39.000000', 'temperatura', 54.0000, 'ºC'),
	(214780, 118, '2014-03-01 00:22:40.000000', 'temperatura', 76.0000, 'ºC'),
	(214781, 118, '2014-03-01 00:22:41.000000', 'temperatura', 221.0000, 'ºC'),
	(214782, 118, '2014-03-01 00:22:42.000000', 'temperatura', 876.0000, 'ºC'),
	(214783, 118, '2014-03-01 00:22:43.000000', 'temperatura', 119.0000, 'ºC'),
	(214784, 118, '2014-03-01 00:22:44.000000', 'temperatura', 367.0000, 'ºC'),
	(214785, 118, '2014-03-01 00:22:45.000000', 'temperatura', 278.0000, 'ºC'),
	(214786, 118, '2014-03-01 00:22:46.000000', 'temperatura', 288.0000, 'ºC'),
	(214787, 118, '2014-03-01 00:22:47.000000', 'temperatura', 607.0000, 'ºC'),
	(214788, 118, '2014-03-01 00:22:48.000000', 'temperatura', 973.0000, 'ºC'),
	(214789, 118, '2014-03-01 00:22:49.000000', 'temperatura', 645.0000, 'ºC'),
	(214790, 118, '2014-03-01 00:22:50.000000', 'temperatura', 305.0000, 'ºC'),
	(214791, 118, '2014-03-01 00:22:51.000000', 'temperatura', 789.0000, 'ºC'),
	(214792, 118, '2014-03-01 00:22:52.000000', 'temperatura', 633.0000, 'ºC'),
	(214793, 118, '2014-03-01 00:22:53.000000', 'temperatura', 796.0000, 'ºC'),
	(214794, 118, '2014-03-01 00:22:54.000000', 'temperatura', 882.0000, 'ºC'),
	(214795, 118, '2014-03-01 00:22:55.000000', 'temperatura', 823.0000, 'ºC'),
	(214796, 118, '2014-03-01 00:22:56.000000', 'temperatura', 268.0000, 'ºC'),
	(214797, 118, '2014-03-01 00:22:57.000000', 'temperatura', 72.0000, 'ºC'),
	(214798, 118, '2014-03-01 00:22:58.000000', 'temperatura', 755.0000, 'ºC'),
	(214799, 118, '2014-03-01 00:22:59.000000', 'temperatura', 1160.0000, 'ºC'),
	(214800, 118, '2014-03-01 00:23:00.000000', 'temperatura', 1137.0000, 'ºC'),
	(214801, 118, '2014-03-01 00:23:01.000000', 'temperatura', 1006.0000, 'ºC'),
	(214802, 118, '2014-03-01 00:23:02.000000', 'temperatura', 419.0000, 'ºC'),
	(214803, 118, '2014-03-01 00:23:03.000000', 'temperatura', 279.0000, 'ºC'),
	(214804, 118, '2014-03-01 00:23:04.000000', 'temperatura', 138.0000, 'ºC'),
	(214805, 118, '2014-03-01 00:23:05.000000', 'temperatura', 1053.0000, 'ºC'),
	(214806, 118, '2014-03-01 00:23:06.000000', 'temperatura', 51.0000, 'ºC'),
	(214807, 118, '2014-03-01 00:23:07.000000', 'temperatura', 695.0000, 'ºC'),
	(214808, 118, '2014-03-01 00:23:08.000000', 'temperatura', 925.0000, 'ºC'),
	(214809, 118, '2014-03-01 00:23:09.000000', 'temperatura', 140.0000, 'ºC'),
	(214810, 118, '2014-03-01 00:23:10.000000', 'temperatura', 325.0000, 'ºC'),
	(214811, 118, '2014-03-01 00:23:11.000000', 'temperatura', 8.0000, 'ºC'),
	(214812, 118, '2014-03-01 00:23:12.000000', 'temperatura', 263.0000, 'ºC'),
	(214813, 118, '2014-03-01 00:23:13.000000', 'temperatura', 90.0000, 'ºC'),
	(214814, 118, '2014-03-01 00:23:14.000000', 'temperatura', 863.0000, 'ºC'),
	(214815, 118, '2014-03-01 00:23:15.000000', 'temperatura', 446.0000, 'ºC'),
	(214816, 118, '2014-03-01 00:23:16.000000', 'temperatura', 841.0000, 'ºC'),
	(214817, 118, '2014-03-01 00:23:17.000000', 'temperatura', 468.0000, 'ºC'),
	(214818, 118, '2014-03-01 00:23:18.000000', 'temperatura', 1018.0000, 'ºC'),
	(214819, 118, '2014-03-01 00:23:19.000000', 'temperatura', 84.0000, 'ºC'),
	(214820, 118, '2014-03-01 00:23:20.000000', 'temperatura', 969.0000, 'ºC'),
	(214821, 118, '2014-03-01 00:23:21.000000', 'temperatura', 991.0000, 'ºC'),
	(214822, 118, '2014-03-01 00:23:22.000000', 'temperatura', 851.0000, 'ºC'),
	(214823, 118, '2014-03-01 00:23:23.000000', 'temperatura', 80.0000, 'ºC'),
	(214824, 118, '2014-03-01 00:23:24.000000', 'temperatura', 249.0000, 'ºC'),
	(214825, 118, '2014-03-01 00:23:25.000000', 'temperatura', 1005.0000, 'ºC'),
	(214826, 118, '2014-03-01 00:23:26.000000', 'temperatura', 678.0000, 'ºC'),
	(214827, 118, '2014-03-01 00:23:27.000000', 'temperatura', 374.0000, 'ºC'),
	(214828, 118, '2014-03-01 00:23:28.000000', 'temperatura', 1038.0000, 'ºC'),
	(214829, 118, '2014-03-01 00:23:29.000000', 'temperatura', 468.0000, 'ºC'),
	(214830, 118, '2014-03-01 00:23:30.000000', 'temperatura', 425.0000, 'ºC'),
	(214831, 118, '2014-03-01 00:23:31.000000', 'temperatura', 724.0000, 'ºC'),
	(214832, 118, '2014-03-01 00:23:32.000000', 'temperatura', 1143.0000, 'ºC'),
	(214833, 118, '2014-03-01 00:23:33.000000', 'temperatura', 1145.0000, 'ºC'),
	(214834, 118, '2014-03-01 00:23:34.000000', 'temperatura', 1098.0000, 'ºC'),
	(214835, 118, '2014-03-01 00:23:35.000000', 'temperatura', 853.0000, 'ºC'),
	(214836, 118, '2014-03-01 00:23:36.000000', 'temperatura', 970.0000, 'ºC'),
	(214837, 118, '2014-03-01 00:23:37.000000', 'temperatura', 1095.0000, 'ºC'),
	(214838, 118, '2014-03-01 00:23:38.000000', 'temperatura', 165.0000, 'ºC'),
	(214839, 118, '2014-03-01 00:23:39.000000', 'temperatura', 1140.0000, 'ºC'),
	(214840, 118, '2014-03-01 00:23:40.000000', 'temperatura', 406.0000, 'ºC'),
	(214841, 118, '2014-03-01 00:23:41.000000', 'temperatura', 1009.0000, 'ºC'),
	(214842, 118, '2014-03-01 00:23:42.000000', 'temperatura', 227.0000, 'ºC'),
	(214843, 118, '2014-03-01 00:23:43.000000', 'temperatura', 511.0000, 'ºC'),
	(214844, 118, '2014-03-01 00:23:44.000000', 'temperatura', 672.0000, 'ºC'),
	(214845, 118, '2014-03-01 00:23:45.000000', 'temperatura', 627.0000, 'ºC'),
	(214846, 118, '2014-03-01 00:23:46.000000', 'temperatura', 1122.0000, 'ºC'),
	(214847, 118, '2014-03-01 00:23:47.000000', 'temperatura', 129.0000, 'ºC'),
	(214848, 118, '2014-03-01 00:23:48.000000', 'temperatura', 877.0000, 'ºC'),
	(214849, 118, '2014-03-01 00:23:49.000000', 'temperatura', 400.0000, 'ºC'),
	(214850, 118, '2014-03-01 00:23:50.000000', 'temperatura', 571.0000, 'ºC'),
	(214851, 118, '2014-03-01 00:23:51.000000', 'temperatura', 453.0000, 'ºC'),
	(214852, 118, '2014-03-01 00:23:52.000000', 'temperatura', 554.0000, 'ºC'),
	(214853, 118, '2014-03-01 00:23:53.000000', 'temperatura', 213.0000, 'ºC'),
	(214854, 118, '2014-03-01 00:23:54.000000', 'temperatura', 600.0000, 'ºC'),
	(214855, 118, '2014-03-01 00:23:55.000000', 'temperatura', 1165.0000, 'ºC'),
	(214856, 118, '2014-03-01 00:23:56.000000', 'temperatura', 424.0000, 'ºC'),
	(214857, 118, '2014-03-01 00:23:57.000000', 'temperatura', 1023.0000, 'ºC'),
	(214858, 118, '2014-03-01 00:23:58.000000', 'temperatura', 247.0000, 'ºC'),
	(214859, 118, '2014-03-01 00:23:59.000000', 'temperatura', 566.0000, 'ºC'),
	(214860, 118, '2014-03-01 00:24:00.000000', 'temperatura', 891.0000, 'ºC'),
	(214861, 118, '2014-03-01 00:24:01.000000', 'temperatura', 356.0000, 'ºC'),
	(214862, 118, '2014-03-01 00:24:02.000000', 'temperatura', 306.0000, 'ºC'),
	(214863, 118, '2014-03-01 00:24:03.000000', 'temperatura', 465.0000, 'ºC'),
	(214864, 118, '2014-03-01 00:24:04.000000', 'temperatura', 208.0000, 'ºC'),
	(214865, 118, '2014-03-01 00:24:05.000000', 'temperatura', 842.0000, 'ºC'),
	(214866, 118, '2014-03-01 00:24:06.000000', 'temperatura', 1190.0000, 'ºC'),
	(214867, 118, '2014-03-01 00:24:07.000000', 'temperatura', 1024.0000, 'ºC'),
	(214868, 118, '2014-03-01 00:24:08.000000', 'temperatura', 351.0000, 'ºC'),
	(214869, 118, '2014-03-01 00:24:09.000000', 'temperatura', 1082.0000, 'ºC'),
	(214870, 118, '2014-03-01 00:24:10.000000', 'temperatura', 759.0000, 'ºC'),
	(214871, 118, '2014-03-01 00:24:11.000000', 'temperatura', 550.0000, 'ºC'),
	(214872, 118, '2014-03-01 00:24:12.000000', 'temperatura', 471.0000, 'ºC'),
	(214873, 118, '2014-03-01 00:24:13.000000', 'temperatura', 708.0000, 'ºC'),
	(214874, 118, '2014-03-01 00:24:14.000000', 'temperatura', 925.0000, 'ºC'),
	(214875, 118, '2014-03-01 00:24:15.000000', 'temperatura', 101.0000, 'ºC'),
	(214876, 118, '2014-03-01 00:24:16.000000', 'temperatura', 130.0000, 'ºC'),
	(214877, 118, '2014-03-01 00:24:17.000000', 'temperatura', 349.0000, 'ºC'),
	(214878, 118, '2014-03-01 00:24:18.000000', 'temperatura', 156.0000, 'ºC'),
	(214879, 118, '2014-03-01 00:24:19.000000', 'temperatura', 933.0000, 'ºC'),
	(214880, 118, '2014-03-01 00:24:20.000000', 'temperatura', 599.0000, 'ºC'),
	(214881, 118, '2014-03-01 00:24:21.000000', 'temperatura', 194.0000, 'ºC'),
	(214882, 118, '2014-03-01 00:24:22.000000', 'temperatura', 375.0000, 'ºC'),
	(214883, 118, '2014-03-01 00:24:23.000000', 'temperatura', 92.0000, 'ºC'),
	(214884, 118, '2014-03-01 00:24:24.000000', 'temperatura', 536.0000, 'ºC'),
	(214885, 118, '2014-03-01 00:24:25.000000', 'temperatura', 6.0000, 'ºC'),
	(214886, 118, '2014-03-01 00:24:26.000000', 'temperatura', 822.0000, 'ºC'),
	(214887, 118, '2014-03-01 00:24:27.000000', 'temperatura', 493.0000, 'ºC'),
	(214888, 118, '2014-03-01 00:24:28.000000', 'temperatura', 1197.0000, 'ºC'),
	(214889, 118, '2014-03-01 00:24:29.000000', 'temperatura', 909.0000, 'ºC'),
	(214890, 118, '2014-03-01 00:24:30.000000', 'temperatura', 954.0000, 'ºC'),
	(214891, 118, '2014-03-01 00:24:31.000000', 'temperatura', 842.0000, 'ºC'),
	(214892, 118, '2014-03-01 00:24:32.000000', 'temperatura', 149.0000, 'ºC'),
	(214893, 118, '2014-03-01 00:24:33.000000', 'temperatura', 621.0000, 'ºC'),
	(214894, 118, '2014-03-01 00:24:34.000000', 'temperatura', 260.0000, 'ºC'),
	(214895, 118, '2014-03-01 00:24:35.000000', 'temperatura', 635.0000, 'ºC'),
	(214896, 118, '2014-03-01 00:24:36.000000', 'temperatura', 1196.0000, 'ºC'),
	(214897, 118, '2014-03-01 00:24:37.000000', 'temperatura', 474.0000, 'ºC'),
	(214898, 118, '2014-03-01 00:24:38.000000', 'temperatura', 1183.0000, 'ºC'),
	(214899, 118, '2014-03-01 00:24:39.000000', 'temperatura', 896.0000, 'ºC'),
	(214900, 118, '2014-03-01 00:24:40.000000', 'temperatura', 929.0000, 'ºC'),
	(214901, 118, '2014-03-01 00:24:41.000000', 'temperatura', 758.0000, 'ºC'),
	(214902, 118, '2014-03-01 00:24:42.000000', 'temperatura', 1004.0000, 'ºC'),
	(214903, 118, '2014-03-01 00:24:43.000000', 'temperatura', 345.0000, 'ºC'),
	(214904, 118, '2014-03-01 00:24:44.000000', 'temperatura', 1114.0000, 'ºC'),
	(214905, 118, '2014-03-01 00:24:45.000000', 'temperatura', 934.0000, 'ºC'),
	(214906, 118, '2014-03-01 00:24:46.000000', 'temperatura', 129.0000, 'ºC'),
	(214907, 118, '2014-03-01 00:24:47.000000', 'temperatura', 245.0000, 'ºC'),
	(214908, 118, '2014-03-01 00:24:48.000000', 'temperatura', 837.0000, 'ºC'),
	(214909, 118, '2014-03-01 00:24:49.000000', 'temperatura', 1050.0000, 'ºC'),
	(214910, 118, '2014-03-01 00:24:50.000000', 'temperatura', 339.0000, 'ºC'),
	(214911, 118, '2014-03-01 00:24:51.000000', 'temperatura', 947.0000, 'ºC'),
	(214912, 118, '2014-03-01 00:24:52.000000', 'temperatura', 117.0000, 'ºC'),
	(214913, 118, '2014-03-01 00:24:53.000000', 'temperatura', 145.0000, 'ºC'),
	(214914, 118, '2014-03-01 00:24:54.000000', 'temperatura', 376.0000, 'ºC'),
	(214915, 118, '2014-03-01 00:24:55.000000', 'temperatura', 244.0000, 'ºC'),
	(214916, 118, '2014-03-01 00:24:56.000000', 'temperatura', 92.0000, 'ºC'),
	(214917, 118, '2014-03-01 00:24:57.000000', 'temperatura', 927.0000, 'ºC'),
	(214918, 118, '2014-03-01 00:24:58.000000', 'temperatura', 762.0000, 'ºC'),
	(214919, 118, '2014-03-01 00:24:59.000000', 'temperatura', 1027.0000, 'ºC'),
	(214920, 118, '2014-03-01 00:25:00.000000', 'temperatura', 452.0000, 'ºC'),
	(214921, 118, '2014-03-01 00:25:01.000000', 'temperatura', 377.0000, 'ºC'),
	(214922, 118, '2014-03-01 00:25:02.000000', 'temperatura', 532.0000, 'ºC'),
	(214923, 118, '2014-03-01 00:25:03.000000', 'temperatura', 328.0000, 'ºC'),
	(214924, 118, '2014-03-01 00:25:04.000000', 'temperatura', 47.0000, 'ºC'),
	(214925, 118, '2014-03-01 00:25:05.000000', 'temperatura', 448.0000, 'ºC'),
	(214926, 118, '2014-03-01 00:25:06.000000', 'temperatura', 901.0000, 'ºC'),
	(214927, 118, '2014-03-01 00:25:07.000000', 'temperatura', 760.0000, 'ºC'),
	(214928, 118, '2014-03-01 00:25:08.000000', 'temperatura', 1097.0000, 'ºC'),
	(214929, 118, '2014-03-01 00:25:09.000000', 'temperatura', 807.0000, 'ºC'),
	(214930, 118, '2014-03-01 00:25:10.000000', 'temperatura', 744.0000, 'ºC'),
	(214931, 118, '2014-03-01 00:25:11.000000', 'temperatura', 100.0000, 'ºC'),
	(214932, 118, '2014-03-01 00:25:12.000000', 'temperatura', 670.0000, 'ºC'),
	(214933, 118, '2014-03-01 00:25:13.000000', 'temperatura', 649.0000, 'ºC'),
	(214934, 118, '2014-03-01 00:25:14.000000', 'temperatura', 34.0000, 'ºC'),
	(214935, 118, '2014-03-01 00:25:15.000000', 'temperatura', 623.0000, 'ºC'),
	(214936, 118, '2014-03-01 00:25:16.000000', 'temperatura', 615.0000, 'ºC'),
	(214937, 118, '2014-03-01 00:25:17.000000', 'temperatura', 5.0000, 'ºC'),
	(214938, 118, '2014-03-01 00:25:18.000000', 'temperatura', 582.0000, 'ºC'),
	(214939, 118, '2014-03-01 00:25:19.000000', 'temperatura', 496.0000, 'ºC'),
	(214940, 118, '2014-03-01 00:25:20.000000', 'temperatura', 735.0000, 'ºC'),
	(214941, 118, '2014-03-01 00:25:21.000000', 'temperatura', 985.0000, 'ºC'),
	(214942, 118, '2014-03-01 00:25:22.000000', 'temperatura', 323.0000, 'ºC'),
	(214943, 118, '2014-03-01 00:25:23.000000', 'temperatura', 1061.0000, 'ºC'),
	(214944, 118, '2014-03-01 00:25:24.000000', 'temperatura', 735.0000, 'ºC'),
	(214945, 118, '2014-03-01 00:25:25.000000', 'temperatura', 493.0000, 'ºC'),
	(214946, 118, '2014-03-01 00:25:26.000000', 'temperatura', 262.0000, 'ºC'),
	(214947, 118, '2014-03-01 00:25:27.000000', 'temperatura', 1029.0000, 'ºC'),
	(214948, 118, '2014-03-01 00:25:28.000000', 'temperatura', 762.0000, 'ºC'),
	(214949, 118, '2014-03-01 00:25:29.000000', 'temperatura', 721.0000, 'ºC'),
	(214950, 118, '2014-03-01 00:25:30.000000', 'temperatura', 122.0000, 'ºC'),
	(214951, 118, '2014-03-01 00:25:31.000000', 'temperatura', 846.0000, 'ºC'),
	(214952, 118, '2014-03-01 00:25:32.000000', 'temperatura', 266.0000, 'ºC'),
	(214953, 118, '2014-03-01 00:25:33.000000', 'temperatura', 1192.0000, 'ºC'),
	(214954, 118, '2014-03-01 00:25:34.000000', 'temperatura', 361.0000, 'ºC'),
	(214955, 118, '2014-03-01 00:25:35.000000', 'temperatura', 631.0000, 'ºC'),
	(214956, 118, '2014-03-01 00:25:36.000000', 'temperatura', 872.0000, 'ºC'),
	(214957, 118, '2014-03-01 00:25:37.000000', 'temperatura', 67.0000, 'ºC'),
	(214958, 118, '2014-03-01 00:25:38.000000', 'temperatura', 120.0000, 'ºC'),
	(214959, 118, '2014-03-01 00:25:39.000000', 'temperatura', 401.0000, 'ºC'),
	(214960, 118, '2014-03-01 00:25:40.000000', 'temperatura', 443.0000, 'ºC'),
	(214961, 118, '2014-03-01 00:25:41.000000', 'temperatura', 1012.0000, 'ºC'),
	(214962, 118, '2014-03-01 00:25:42.000000', 'temperatura', 131.0000, 'ºC'),
	(214963, 118, '2014-03-01 00:25:43.000000', 'temperatura', 21.0000, 'ºC'),
	(214964, 118, '2014-03-01 00:25:44.000000', 'temperatura', 913.0000, 'ºC'),
	(214965, 118, '2014-03-01 00:25:45.000000', 'temperatura', 903.0000, 'ºC'),
	(214966, 118, '2014-03-01 00:25:46.000000', 'temperatura', 574.0000, 'ºC'),
	(214967, 118, '2014-03-01 00:25:47.000000', 'temperatura', 164.0000, 'ºC'),
	(214968, 118, '2014-03-01 00:25:48.000000', 'temperatura', 296.0000, 'ºC'),
	(214969, 118, '2014-03-01 00:25:49.000000', 'temperatura', 992.0000, 'ºC'),
	(214970, 118, '2014-03-01 00:25:50.000000', 'temperatura', 470.0000, 'ºC'),
	(214971, 118, '2014-03-01 00:25:51.000000', 'temperatura', 574.0000, 'ºC'),
	(214972, 118, '2014-03-01 00:25:52.000000', 'temperatura', 261.0000, 'ºC'),
	(214973, 118, '2014-03-01 00:25:53.000000', 'temperatura', 782.0000, 'ºC'),
	(214974, 118, '2014-03-01 00:25:54.000000', 'temperatura', 729.0000, 'ºC'),
	(214975, 118, '2014-03-01 00:25:55.000000', 'temperatura', 101.0000, 'ºC'),
	(214976, 118, '2014-03-01 00:25:56.000000', 'temperatura', 716.0000, 'ºC'),
	(214977, 118, '2014-03-01 00:25:57.000000', 'temperatura', 877.0000, 'ºC'),
	(214978, 118, '2014-03-01 00:25:58.000000', 'temperatura', 1038.0000, 'ºC'),
	(214979, 118, '2014-03-01 00:25:59.000000', 'temperatura', 161.0000, 'ºC'),
	(214980, 118, '2014-03-01 00:26:00.000000', 'temperatura', 91.0000, 'ºC'),
	(214981, 118, '2014-03-01 00:26:01.000000', 'temperatura', 1173.0000, 'ºC'),
	(214982, 118, '2014-03-01 00:26:02.000000', 'temperatura', 793.0000, 'ºC'),
	(214983, 118, '2014-03-01 00:26:03.000000', 'temperatura', 446.0000, 'ºC'),
	(214984, 118, '2014-03-01 00:26:04.000000', 'temperatura', 1050.0000, 'ºC'),
	(214985, 118, '2014-03-01 00:26:05.000000', 'temperatura', 314.0000, 'ºC'),
	(214986, 118, '2014-03-01 00:26:06.000000', 'temperatura', 820.0000, 'ºC'),
	(214987, 118, '2014-03-01 00:26:07.000000', 'temperatura', 758.0000, 'ºC'),
	(214988, 118, '2014-03-01 00:26:08.000000', 'temperatura', 132.0000, 'ºC'),
	(214989, 118, '2014-03-01 00:26:09.000000', 'temperatura', 784.0000, 'ºC'),
	(214990, 118, '2014-03-01 00:26:10.000000', 'temperatura', 1126.0000, 'ºC'),
	(214991, 118, '2014-03-01 00:26:11.000000', 'temperatura', 878.0000, 'ºC'),
	(214992, 118, '2014-03-01 00:26:12.000000', 'temperatura', 1013.0000, 'ºC'),
	(214993, 118, '2014-03-01 00:26:13.000000', 'temperatura', 31.0000, 'ºC'),
	(214994, 118, '2014-03-01 00:26:14.000000', 'temperatura', 719.0000, 'ºC'),
	(214995, 118, '2014-03-01 00:26:15.000000', 'temperatura', 1099.0000, 'ºC'),
	(214996, 118, '2014-03-01 00:26:16.000000', 'temperatura', 940.0000, 'ºC'),
	(214997, 118, '2014-03-01 00:26:17.000000', 'temperatura', 205.0000, 'ºC'),
	(214998, 118, '2014-03-01 00:26:18.000000', 'temperatura', 604.0000, 'ºC'),
	(214999, 118, '2014-03-01 00:26:19.000000', 'temperatura', 6.0000, 'ºC'),
	(215000, 118, '2014-03-01 00:26:20.000000', 'temperatura', 618.0000, 'ºC'),
	(215001, 118, '2014-03-01 00:26:21.000000', 'temperatura', 672.0000, 'ºC'),
	(215002, 118, '2014-03-01 00:26:22.000000', 'temperatura', 309.0000, 'ºC'),
	(215003, 118, '2014-03-01 00:26:23.000000', 'temperatura', 727.0000, 'ºC'),
	(215004, 118, '2014-03-01 00:26:24.000000', 'temperatura', 310.0000, 'ºC'),
	(215005, 118, '2014-03-01 00:26:25.000000', 'temperatura', 570.0000, 'ºC'),
	(215006, 118, '2014-03-01 00:26:26.000000', 'temperatura', 718.0000, 'ºC'),
	(215007, 118, '2014-03-01 00:26:27.000000', 'temperatura', 683.0000, 'ºC'),
	(215008, 118, '2014-03-01 00:26:28.000000', 'temperatura', 59.0000, 'ºC'),
	(215009, 118, '2014-03-01 00:26:29.000000', 'temperatura', 648.0000, 'ºC'),
	(215010, 118, '2014-03-01 00:26:30.000000', 'temperatura', 662.0000, 'ºC'),
	(215011, 118, '2014-03-01 00:26:31.000000', 'temperatura', 167.0000, 'ºC'),
	(215012, 118, '2014-03-01 00:26:32.000000', 'temperatura', 48.0000, 'ºC'),
	(215013, 118, '2014-03-01 00:26:33.000000', 'temperatura', 941.0000, 'ºC'),
	(215014, 118, '2014-03-01 00:26:34.000000', 'temperatura', 961.0000, 'ºC'),
	(215015, 118, '2014-03-01 00:26:35.000000', 'temperatura', 782.0000, 'ºC'),
	(215016, 118, '2014-03-01 00:26:36.000000', 'temperatura', 1030.0000, 'ºC'),
	(215017, 118, '2014-03-01 00:26:37.000000', 'temperatura', 403.0000, 'ºC'),
	(215018, 118, '2014-03-01 00:26:38.000000', 'temperatura', 126.0000, 'ºC'),
	(215019, 118, '2014-03-01 00:26:39.000000', 'temperatura', 622.0000, 'ºC'),
	(215020, 118, '2014-03-01 00:26:40.000000', 'temperatura', 331.0000, 'ºC'),
	(215021, 118, '2014-03-01 00:26:41.000000', 'temperatura', 990.0000, 'ºC'),
	(215022, 118, '2014-03-01 00:26:42.000000', 'temperatura', 356.0000, 'ºC'),
	(215023, 118, '2014-03-01 00:26:43.000000', 'temperatura', 13.0000, 'ºC'),
	(215024, 118, '2014-03-01 00:26:44.000000', 'temperatura', 198.0000, 'ºC'),
	(215025, 118, '2014-03-01 00:26:45.000000', 'temperatura', 951.0000, 'ºC'),
	(215026, 118, '2014-03-01 00:26:46.000000', 'temperatura', 562.0000, 'ºC'),
	(215027, 118, '2014-03-01 00:26:47.000000', 'temperatura', 1157.0000, 'ºC'),
	(215028, 118, '2014-03-01 00:26:48.000000', 'temperatura', 500.0000, 'ºC'),
	(215029, 118, '2014-03-01 00:26:49.000000', 'temperatura', 229.0000, 'ºC'),
	(215030, 118, '2014-03-01 00:26:50.000000', 'temperatura', 845.0000, 'ºC'),
	(215031, 118, '2014-03-01 00:26:51.000000', 'temperatura', 1137.0000, 'ºC'),
	(215032, 118, '2014-03-01 00:26:52.000000', 'temperatura', 753.0000, 'ºC'),
	(215033, 118, '2014-03-01 00:26:53.000000', 'temperatura', 355.0000, 'ºC'),
	(215034, 118, '2014-03-01 00:26:54.000000', 'temperatura', 717.0000, 'ºC'),
	(215035, 118, '2014-03-01 00:26:55.000000', 'temperatura', 118.0000, 'ºC'),
	(215036, 118, '2014-03-01 00:26:56.000000', 'temperatura', 840.0000, 'ºC'),
	(215037, 118, '2014-03-01 00:26:57.000000', 'temperatura', 249.0000, 'ºC'),
	(215038, 118, '2014-03-01 00:26:58.000000', 'temperatura', 1122.0000, 'ºC'),
	(215039, 118, '2014-03-01 00:26:59.000000', 'temperatura', 66.0000, 'ºC'),
	(215040, 118, '2014-03-01 00:27:00.000000', 'temperatura', 562.0000, 'ºC'),
	(215041, 118, '2014-03-01 00:27:01.000000', 'temperatura', 213.0000, 'ºC'),
	(215042, 118, '2014-03-01 00:27:02.000000', 'temperatura', 580.0000, 'ºC'),
	(215043, 118, '2014-03-01 00:27:03.000000', 'temperatura', 1061.0000, 'ºC'),
	(215044, 118, '2014-03-01 00:27:04.000000', 'temperatura', 1166.0000, 'ºC'),
	(215045, 118, '2014-03-01 00:27:05.000000', 'temperatura', 248.0000, 'ºC'),
	(215046, 118, '2014-03-01 00:27:06.000000', 'temperatura', 141.0000, 'ºC'),
	(215047, 118, '2014-03-01 00:27:07.000000', 'temperatura', 1162.0000, 'ºC'),
	(215048, 118, '2014-03-01 00:27:08.000000', 'temperatura', 586.0000, 'ºC'),
	(215049, 118, '2014-03-01 00:27:09.000000', 'temperatura', 647.0000, 'ºC'),
	(215050, 118, '2014-03-01 00:27:10.000000', 'temperatura', 276.0000, 'ºC'),
	(215051, 118, '2014-03-01 00:27:11.000000', 'temperatura', 640.0000, 'ºC'),
	(215052, 118, '2014-03-01 00:27:12.000000', 'temperatura', 1173.0000, 'ºC'),
	(215053, 118, '2014-03-01 00:27:13.000000', 'temperatura', 344.0000, 'ºC'),
	(215054, 118, '2014-03-01 00:27:14.000000', 'temperatura', 603.0000, 'ºC'),
	(215055, 118, '2014-03-01 00:27:15.000000', 'temperatura', 783.0000, 'ºC'),
	(215056, 118, '2014-03-01 00:27:16.000000', 'temperatura', 907.0000, 'ºC'),
	(215057, 118, '2014-03-01 00:27:17.000000', 'temperatura', 988.0000, 'ºC'),
	(215058, 118, '2014-03-01 00:27:18.000000', 'temperatura', 1017.0000, 'ºC'),
	(215059, 118, '2014-03-01 00:27:19.000000', 'temperatura', 921.0000, 'ºC'),
	(215060, 118, '2014-03-01 00:27:20.000000', 'temperatura', 357.0000, 'ºC'),
	(215061, 118, '2014-03-01 00:27:21.000000', 'temperatura', 220.0000, 'ºC'),
	(215062, 118, '2014-03-01 00:27:22.000000', 'temperatura', 31.0000, 'ºC'),
	(215063, 118, '2014-03-01 00:27:23.000000', 'temperatura', 694.0000, 'ºC'),
	(215064, 118, '2014-03-01 00:27:24.000000', 'temperatura', 978.0000, 'ºC'),
	(215065, 118, '2014-03-01 00:27:25.000000', 'temperatura', 410.0000, 'ºC'),
	(215066, 118, '2014-03-01 00:27:26.000000', 'temperatura', 316.0000, 'ºC'),
	(215067, 118, '2014-03-01 00:27:27.000000', 'temperatura', 351.0000, 'ºC'),
	(215068, 118, '2014-03-01 00:27:28.000000', 'temperatura', 806.0000, 'ºC'),
	(215069, 118, '2014-03-01 00:27:29.000000', 'temperatura', 577.0000, 'ºC'),
	(215070, 118, '2014-03-01 00:27:30.000000', 'temperatura', 467.0000, 'ºC'),
	(215071, 118, '2014-03-01 00:27:31.000000', 'temperatura', 604.0000, 'ºC'),
	(215072, 118, '2014-03-01 00:27:32.000000', 'temperatura', 422.0000, 'ºC'),
	(215073, 118, '2014-03-01 00:27:33.000000', 'temperatura', 298.0000, 'ºC'),
	(215074, 118, '2014-03-01 00:27:34.000000', 'temperatura', 223.0000, 'ºC'),
	(215075, 118, '2014-03-01 00:27:35.000000', 'temperatura', 221.0000, 'ºC'),
	(215076, 118, '2014-03-01 00:27:36.000000', 'temperatura', 438.0000, 'ºC'),
	(215077, 118, '2014-03-01 00:27:37.000000', 'temperatura', 327.0000, 'ºC'),
	(215078, 118, '2014-03-01 00:27:38.000000', 'temperatura', 323.0000, 'ºC'),
	(215079, 118, '2014-03-01 00:27:39.000000', 'temperatura', 634.0000, 'ºC'),
	(215080, 118, '2014-03-01 00:27:40.000000', 'temperatura', 1001.0000, 'ºC'),
	(215081, 118, '2014-03-01 00:27:41.000000', 'temperatura', 703.0000, 'ºC'),
	(215082, 118, '2014-03-01 00:27:42.000000', 'temperatura', 513.0000, 'ºC'),
	(215083, 118, '2014-03-01 00:27:43.000000', 'temperatura', 455.0000, 'ºC'),
	(215084, 118, '2014-03-01 00:27:44.000000', 'temperatura', 737.0000, 'ºC'),
	(215085, 118, '2014-03-01 00:27:45.000000', 'temperatura', 1120.0000, 'ºC'),
	(215086, 118, '2014-03-01 00:27:46.000000', 'temperatura', 989.0000, 'ºC'),
	(215087, 118, '2014-03-01 00:27:47.000000', 'temperatura', 387.0000, 'ºC'),
	(215088, 118, '2014-03-01 00:27:48.000000', 'temperatura', 166.0000, 'ºC'),
	(215089, 118, '2014-03-01 00:27:49.000000', 'temperatura', 871.0000, 'ºC'),
	(215090, 118, '2014-03-01 00:27:50.000000', 'temperatura', 257.0000, 'ºC'),
	(215091, 118, '2014-03-01 00:27:51.000000', 'temperatura', 1073.0000, 'ºC'),
	(215092, 118, '2014-03-01 00:27:52.000000', 'temperatura', 995.0000, 'ºC'),
	(215093, 118, '2014-03-01 00:27:53.000000', 'temperatura', 556.0000, 'ºC'),
	(215094, 118, '2014-03-01 00:27:54.000000', 'temperatura', 993.0000, 'ºC'),
	(215095, 118, '2014-03-01 00:27:55.000000', 'temperatura', 901.0000, 'ºC'),
	(215096, 118, '2014-03-01 00:27:56.000000', 'temperatura', 326.0000, 'ºC'),
	(215097, 118, '2014-03-01 00:27:57.000000', 'temperatura', 126.0000, 'ºC'),
	(215098, 118, '2014-03-01 00:27:58.000000', 'temperatura', 855.0000, 'ºC'),
	(215099, 118, '2014-03-01 00:27:59.000000', 'temperatura', 295.0000, 'ºC'),
	(215100, 118, '2014-03-01 00:28:00.000000', 'temperatura', 111.0000, 'ºC'),
	(215101, 118, '2014-03-01 00:28:01.000000', 'temperatura', 869.0000, 'ºC'),
	(215102, 118, '2014-03-01 00:28:02.000000', 'temperatura', 415.0000, 'ºC'),
	(215103, 118, '2014-03-01 00:28:03.000000', 'temperatura', 666.0000, 'ºC'),
	(215104, 118, '2014-03-01 00:28:04.000000', 'temperatura', 885.0000, 'ºC'),
	(215105, 118, '2014-03-01 00:28:05.000000', 'temperatura', 27.0000, 'ºC'),
	(215106, 118, '2014-03-01 00:28:06.000000', 'temperatura', 1080.0000, 'ºC'),
	(215107, 118, '2014-03-01 00:28:07.000000', 'temperatura', 520.0000, 'ºC'),
	(215108, 118, '2014-03-01 00:28:08.000000', 'temperatura', 561.0000, 'ºC'),
	(215109, 118, '2014-03-01 00:28:09.000000', 'temperatura', 45.0000, 'ºC'),
	(215110, 118, '2014-03-01 00:28:10.000000', 'temperatura', 944.0000, 'ºC'),
	(215111, 118, '2014-03-01 00:28:11.000000', 'temperatura', 985.0000, 'ºC'),
	(215112, 118, '2014-03-01 00:28:12.000000', 'temperatura', 891.0000, 'ºC'),
	(215113, 118, '2014-03-01 00:28:13.000000', 'temperatura', 304.0000, 'ºC'),
	(215114, 118, '2014-03-01 00:28:14.000000', 'temperatura', 47.0000, 'ºC'),
	(215115, 118, '2014-03-01 00:28:15.000000', 'temperatura', 522.0000, 'ºC'),
	(215116, 118, '2014-03-01 00:28:16.000000', 'temperatura', 69.0000, 'ºC'),
	(215117, 118, '2014-03-01 00:28:17.000000', 'temperatura', 1180.0000, 'ºC'),
	(215118, 118, '2014-03-01 00:28:18.000000', 'temperatura', 895.0000, 'ºC'),
	(215119, 118, '2014-03-01 00:28:19.000000', 'temperatura', 934.0000, 'ºC'),
	(215120, 118, '2014-03-01 00:28:20.000000', 'temperatura', 787.0000, 'ºC'),
	(215121, 118, '2014-03-01 00:28:21.000000', 'temperatura', 1131.0000, 'ºC'),
	(215122, 118, '2014-03-01 00:28:22.000000', 'temperatura', 897.0000, 'ºC'),
	(215123, 118, '2014-03-01 00:28:23.000000', 'temperatura', 1090.0000, 'ºC'),
	(215124, 118, '2014-03-01 00:28:24.000000', 'temperatura', 362.0000, 'ºC'),
	(215125, 118, '2014-03-01 00:28:25.000000', 'temperatura', 940.0000, 'ºC'),
	(215126, 118, '2014-03-01 00:28:26.000000', 'temperatura', 16.0000, 'ºC'),
	(215127, 118, '2014-03-01 00:28:27.000000', 'temperatura', 860.0000, 'ºC'),
	(215128, 118, '2014-03-01 00:28:28.000000', 'temperatura', 650.0000, 'ºC'),
	(215129, 118, '2014-03-01 00:28:29.000000', 'temperatura', 674.0000, 'ºC'),
	(215130, 118, '2014-03-01 00:28:30.000000', 'temperatura', 219.0000, 'ºC'),
	(215131, 118, '2014-03-01 00:28:31.000000', 'temperatura', 273.0000, 'ºC'),
	(215132, 118, '2014-03-01 00:28:32.000000', 'temperatura', 710.0000, 'ºC'),
	(215133, 118, '2014-03-01 00:28:33.000000', 'temperatura', 332.0000, 'ºC'),
	(215134, 118, '2014-03-01 00:28:34.000000', 'temperatura', 730.0000, 'ºC'),
	(215135, 118, '2014-03-01 00:28:35.000000', 'temperatura', 254.0000, 'ºC'),
	(215136, 118, '2014-03-01 00:28:36.000000', 'temperatura', 282.0000, 'ºC'),
	(215137, 118, '2014-03-01 00:28:37.000000', 'temperatura', 648.0000, 'ºC'),
	(215138, 118, '2014-03-01 00:28:38.000000', 'temperatura', 1195.0000, 'ºC'),
	(215139, 118, '2014-03-01 00:28:39.000000', 'temperatura', 433.0000, 'ºC'),
	(215140, 118, '2014-03-01 00:28:40.000000', 'temperatura', 978.0000, 'ºC'),
	(215141, 118, '2014-03-01 00:28:41.000000', 'temperatura', 1193.0000, 'ºC'),
	(215142, 118, '2014-03-01 00:28:42.000000', 'temperatura', 632.0000, 'ºC'),
	(215143, 118, '2014-03-01 00:28:43.000000', 'temperatura', 781.0000, 'ºC'),
	(215144, 118, '2014-03-01 00:28:44.000000', 'temperatura', 808.0000, 'ºC'),
	(215145, 118, '2014-03-01 00:28:45.000000', 'temperatura', 498.0000, 'ºC'),
	(215146, 118, '2014-03-01 00:28:46.000000', 'temperatura', 66.0000, 'ºC'),
	(215147, 118, '2014-03-01 00:28:47.000000', 'temperatura', 38.0000, 'ºC'),
	(215148, 118, '2014-03-01 00:28:48.000000', 'temperatura', 1193.0000, 'ºC'),
	(215149, 118, '2014-03-01 00:28:49.000000', 'temperatura', 1049.0000, 'ºC'),
	(215150, 118, '2014-03-01 00:28:50.000000', 'temperatura', 468.0000, 'ºC'),
	(215151, 118, '2014-03-01 00:28:51.000000', 'temperatura', 395.0000, 'ºC'),
	(215152, 118, '2014-03-01 00:28:52.000000', 'temperatura', 571.0000, 'ºC'),
	(215153, 118, '2014-03-01 00:28:53.000000', 'temperatura', 472.0000, 'ºC'),
	(215154, 118, '2014-03-01 00:28:54.000000', 'temperatura', 647.0000, 'ºC'),
	(215155, 118, '2014-03-01 00:28:55.000000', 'temperatura', 617.0000, 'ºC'),
	(215156, 118, '2014-03-01 00:28:56.000000', 'temperatura', 1145.0000, 'ºC'),
	(215157, 118, '2014-03-01 00:28:57.000000', 'temperatura', 275.0000, 'ºC'),
	(215158, 118, '2014-03-01 00:28:58.000000', 'temperatura', 339.0000, 'ºC'),
	(215159, 118, '2014-03-01 00:28:59.000000', 'temperatura', 873.0000, 'ºC'),
	(215160, 118, '2014-03-01 00:29:00.000000', 'temperatura', 947.0000, 'ºC'),
	(215161, 118, '2014-03-01 00:29:01.000000', 'temperatura', 917.0000, 'ºC'),
	(215162, 118, '2014-03-01 00:29:02.000000', 'temperatura', 545.0000, 'ºC'),
	(215163, 118, '2014-03-01 00:29:03.000000', 'temperatura', 1172.0000, 'ºC'),
	(215164, 118, '2014-03-01 00:29:04.000000', 'temperatura', 627.0000, 'ºC'),
	(215165, 118, '2014-03-01 00:29:05.000000', 'temperatura', 821.0000, 'ºC'),
	(215166, 118, '2014-03-01 00:29:06.000000', 'temperatura', 1022.0000, 'ºC'),
	(215167, 118, '2014-03-01 00:29:07.000000', 'temperatura', 250.0000, 'ºC'),
	(215168, 118, '2014-03-01 00:29:08.000000', 'temperatura', 584.0000, 'ºC'),
	(215169, 118, '2014-03-01 00:29:09.000000', 'temperatura', 971.0000, 'ºC'),
	(215170, 118, '2014-03-01 00:29:10.000000', 'temperatura', 701.0000, 'ºC'),
	(215171, 118, '2014-03-01 00:29:11.000000', 'temperatura', 594.0000, 'ºC'),
	(215172, 118, '2014-03-01 00:29:12.000000', 'temperatura', 869.0000, 'ºC'),
	(215173, 118, '2014-03-01 00:29:13.000000', 'temperatura', 161.0000, 'ºC'),
	(215174, 118, '2014-03-01 00:29:14.000000', 'temperatura', 599.0000, 'ºC'),
	(215175, 118, '2014-03-01 00:29:15.000000', 'temperatura', 114.0000, 'ºC'),
	(215176, 118, '2014-03-01 00:29:16.000000', 'temperatura', 1172.0000, 'ºC'),
	(215177, 118, '2014-03-01 00:29:17.000000', 'temperatura', 718.0000, 'ºC'),
	(215178, 118, '2014-03-01 00:29:18.000000', 'temperatura', 75.0000, 'ºC'),
	(215179, 118, '2014-03-01 00:29:19.000000', 'temperatura', 622.0000, 'ºC'),
	(215180, 118, '2014-03-01 00:29:20.000000', 'temperatura', 484.0000, 'ºC'),
	(215181, 118, '2014-03-01 00:29:21.000000', 'temperatura', 556.0000, 'ºC'),
	(215182, 118, '2014-03-01 00:29:22.000000', 'temperatura', 129.0000, 'ºC'),
	(215183, 118, '2014-03-01 00:29:23.000000', 'temperatura', 175.0000, 'ºC'),
	(215184, 118, '2014-03-01 00:29:24.000000', 'temperatura', 490.0000, 'ºC'),
	(215185, 118, '2014-03-01 00:29:25.000000', 'temperatura', 725.0000, 'ºC'),
	(215186, 118, '2014-03-01 00:29:26.000000', 'temperatura', 957.0000, 'ºC'),
	(215187, 118, '2014-03-01 00:29:27.000000', 'temperatura', 209.0000, 'ºC'),
	(215188, 118, '2014-03-01 00:29:28.000000', 'temperatura', 574.0000, 'ºC'),
	(215189, 118, '2014-03-01 00:29:29.000000', 'temperatura', 1045.0000, 'ºC'),
	(215190, 118, '2014-03-01 00:29:30.000000', 'temperatura', 1103.0000, 'ºC'),
	(215191, 118, '2014-03-01 00:29:31.000000', 'temperatura', 1179.0000, 'ºC'),
	(215192, 118, '2014-03-01 00:29:32.000000', 'temperatura', 189.0000, 'ºC'),
	(215193, 118, '2014-03-01 00:29:33.000000', 'temperatura', 1006.0000, 'ºC'),
	(215194, 118, '2014-03-01 00:29:34.000000', 'temperatura', 864.0000, 'ºC'),
	(215195, 118, '2014-03-01 00:29:35.000000', 'temperatura', 105.0000, 'ºC'),
	(215196, 118, '2014-03-01 00:29:36.000000', 'temperatura', 330.0000, 'ºC'),
	(215197, 118, '2014-03-01 00:29:37.000000', 'temperatura', 137.0000, 'ºC'),
	(215198, 118, '2014-03-01 00:29:38.000000', 'temperatura', 896.0000, 'ºC'),
	(215199, 118, '2014-03-01 00:29:39.000000', 'temperatura', 471.0000, 'ºC'),
	(215200, 118, '2014-03-01 00:29:40.000000', 'temperatura', 865.0000, 'ºC'),
	(215201, 118, '2014-03-01 00:29:41.000000', 'temperatura', 515.0000, 'ºC'),
	(215202, 118, '2014-03-01 00:29:42.000000', 'temperatura', 1180.0000, 'ºC'),
	(215203, 118, '2014-03-01 00:29:43.000000', 'temperatura', 755.0000, 'ºC'),
	(215204, 118, '2014-03-01 00:29:44.000000', 'temperatura', 237.0000, 'ºC'),
	(215205, 118, '2014-03-01 00:29:45.000000', 'temperatura', 120.0000, 'ºC'),
	(215206, 118, '2014-03-01 00:29:46.000000', 'temperatura', 1090.0000, 'ºC'),
	(215207, 118, '2014-03-01 00:29:47.000000', 'temperatura', 290.0000, 'ºC'),
	(215208, 118, '2014-03-01 00:29:48.000000', 'temperatura', 581.0000, 'ºC'),
	(215209, 118, '2014-03-01 00:29:49.000000', 'temperatura', 834.0000, 'ºC'),
	(215210, 118, '2014-03-01 00:29:50.000000', 'temperatura', 27.0000, 'ºC'),
	(215211, 118, '2014-03-01 00:29:51.000000', 'temperatura', 36.0000, 'ºC'),
	(215212, 118, '2014-03-01 00:29:52.000000', 'temperatura', 98.0000, 'ºC'),
	(215213, 118, '2014-03-01 00:29:53.000000', 'temperatura', 384.0000, 'ºC'),
	(215214, 118, '2014-03-01 00:29:54.000000', 'temperatura', 427.0000, 'ºC'),
	(215215, 118, '2014-03-01 00:29:55.000000', 'temperatura', 984.0000, 'ºC'),
	(215216, 118, '2014-03-01 00:29:56.000000', 'temperatura', 37.0000, 'ºC'),
	(215217, 118, '2014-03-01 00:29:57.000000', 'temperatura', 836.0000, 'ºC'),
	(215218, 118, '2014-03-01 00:29:58.000000', 'temperatura', 467.0000, 'ºC'),
	(215219, 118, '2014-03-01 00:29:59.000000', 'temperatura', 1028.0000, 'ºC'),
	(215220, 118, '2014-03-01 00:30:00.000000', 'temperatura', 139.0000, 'ºC'),
	(215221, 118, '2014-03-01 00:30:01.000000', 'temperatura', 11.0000, 'ºC'),
	(215222, 118, '2014-03-01 00:30:02.000000', 'temperatura', 841.0000, 'ºC'),
	(215223, 118, '2014-03-01 00:30:03.000000', 'temperatura', 571.0000, 'ºC'),
	(215224, 118, '2014-03-01 00:30:04.000000', 'temperatura', 332.0000, 'ºC'),
	(215225, 118, '2014-03-01 00:30:05.000000', 'temperatura', 1148.0000, 'ºC'),
	(215226, 118, '2014-03-01 00:30:06.000000', 'temperatura', 1143.0000, 'ºC'),
	(215227, 118, '2014-03-01 00:30:07.000000', 'temperatura', 1073.0000, 'ºC'),
	(215228, 118, '2014-03-01 00:30:08.000000', 'temperatura', 736.0000, 'ºC'),
	(215229, 118, '2014-03-01 00:30:09.000000', 'temperatura', 462.0000, 'ºC'),
	(215230, 118, '2014-03-01 00:30:10.000000', 'temperatura', 104.0000, 'ºC'),
	(215231, 118, '2014-03-01 00:30:11.000000', 'temperatura', 333.0000, 'ºC'),
	(215232, 118, '2014-03-01 00:30:12.000000', 'temperatura', 152.0000, 'ºC'),
	(215233, 118, '2014-03-01 00:30:13.000000', 'temperatura', 963.0000, 'ºC'),
	(215234, 118, '2014-03-01 00:30:14.000000', 'temperatura', 758.0000, 'ºC'),
	(215235, 118, '2014-03-01 00:30:15.000000', 'temperatura', 901.0000, 'ºC'),
	(215236, 118, '2014-03-01 00:30:16.000000', 'temperatura', 1033.0000, 'ºC'),
	(215237, 118, '2014-03-01 00:30:17.000000', 'temperatura', 64.0000, 'ºC'),
	(215238, 118, '2014-03-01 00:30:18.000000', 'temperatura', 820.0000, 'ºC'),
	(215239, 118, '2014-03-01 00:30:19.000000', 'temperatura', 307.0000, 'ºC'),
	(215240, 118, '2014-03-01 00:30:20.000000', 'temperatura', 275.0000, 'ºC'),
	(215241, 118, '2014-03-01 00:30:21.000000', 'temperatura', 455.0000, 'ºC'),
	(215242, 118, '2014-03-01 00:30:22.000000', 'temperatura', 249.0000, 'ºC'),
	(215243, 118, '2014-03-01 00:30:23.000000', 'temperatura', 1082.0000, 'ºC'),
	(215244, 118, '2014-03-01 00:30:24.000000', 'temperatura', 1062.0000, 'ºC'),
	(215245, 118, '2014-03-01 00:30:25.000000', 'temperatura', 867.0000, 'ºC'),
	(215246, 118, '2014-03-01 00:30:26.000000', 'temperatura', 1149.0000, 'ºC'),
	(215247, 118, '2014-03-01 00:30:27.000000', 'temperatura', 742.0000, 'ºC'),
	(215248, 118, '2014-03-01 00:30:28.000000', 'temperatura', 266.0000, 'ºC'),
	(215249, 118, '2014-03-01 00:30:29.000000', 'temperatura', 302.0000, 'ºC'),
	(215250, 118, '2014-03-01 00:30:30.000000', 'temperatura', 713.0000, 'ºC'),
	(215251, 118, '2014-03-01 00:30:31.000000', 'temperatura', 258.0000, 'ºC'),
	(215252, 118, '2014-03-01 00:30:32.000000', 'temperatura', 353.0000, 'ºC'),
	(215253, 118, '2014-03-01 00:30:33.000000', 'temperatura', 991.0000, 'ºC'),
	(215254, 118, '2014-03-01 00:30:34.000000', 'temperatura', 297.0000, 'ºC'),
	(215255, 118, '2014-03-01 00:30:35.000000', 'temperatura', 914.0000, 'ºC'),
	(215256, 118, '2014-03-01 00:30:36.000000', 'temperatura', 80.0000, 'ºC'),
	(215257, 118, '2014-03-01 00:30:37.000000', 'temperatura', 59.0000, 'ºC'),
	(215258, 118, '2014-03-01 00:30:38.000000', 'temperatura', 53.0000, 'ºC'),
	(215259, 118, '2014-03-01 00:30:39.000000', 'temperatura', 92.0000, 'ºC'),
	(215260, 118, '2014-03-01 00:30:40.000000', 'temperatura', 298.0000, 'ºC'),
	(215261, 118, '2014-03-01 00:30:41.000000', 'temperatura', 14.0000, 'ºC'),
	(215262, 118, '2014-03-01 00:30:42.000000', 'temperatura', 377.0000, 'ºC'),
	(215263, 118, '2014-03-01 00:30:43.000000', 'temperatura', 644.0000, 'ºC'),
	(215264, 118, '2014-03-01 00:30:44.000000', 'temperatura', 890.0000, 'ºC'),
	(215265, 118, '2014-03-01 00:30:45.000000', 'temperatura', 117.0000, 'ºC'),
	(215266, 118, '2014-03-01 00:30:46.000000', 'temperatura', 318.0000, 'ºC'),
	(215267, 118, '2014-03-01 00:30:47.000000', 'temperatura', 38.0000, 'ºC'),
	(215268, 118, '2014-03-01 00:30:48.000000', 'temperatura', 435.0000, 'ºC'),
	(215269, 118, '2014-03-01 00:30:49.000000', 'temperatura', 862.0000, 'ºC'),
	(215270, 118, '2014-03-01 00:30:50.000000', 'temperatura', 604.0000, 'ºC'),
	(215271, 118, '2014-03-01 00:30:51.000000', 'temperatura', 438.0000, 'ºC'),
	(215272, 118, '2014-03-01 00:30:52.000000', 'temperatura', 375.0000, 'ºC'),
	(215273, 118, '2014-03-01 00:30:53.000000', 'temperatura', 565.0000, 'ºC'),
	(215274, 118, '2014-03-01 00:30:54.000000', 'temperatura', 499.0000, 'ºC'),
	(215275, 118, '2014-03-01 00:30:55.000000', 'temperatura', 802.0000, 'ºC'),
	(215276, 118, '2014-03-01 00:30:56.000000', 'temperatura', 111.0000, 'ºC'),
	(215277, 118, '2014-03-01 00:30:57.000000', 'temperatura', 549.0000, 'ºC'),
	(215278, 118, '2014-03-01 00:30:58.000000', 'temperatura', 15.0000, 'ºC'),
	(215279, 118, '2014-03-01 00:30:59.000000', 'temperatura', 826.0000, 'ºC'),
	(215280, 118, '2014-03-01 00:31:00.000000', 'temperatura', 485.0000, 'ºC'),
	(215281, 118, '2014-03-01 00:31:01.000000', 'temperatura', 1150.0000, 'ºC'),
	(215282, 118, '2014-03-01 00:31:02.000000', 'temperatura', 693.0000, 'ºC'),
	(215283, 118, '2014-03-01 00:31:03.000000', 'temperatura', 15.0000, 'ºC'),
	(215284, 118, '2014-03-01 00:31:04.000000', 'temperatura', 396.0000, 'ºC'),
	(215285, 118, '2014-03-01 00:31:05.000000', 'temperatura', 735.0000, 'ºC'),
	(215286, 118, '2014-03-01 00:31:06.000000', 'temperatura', 89.0000, 'ºC'),
	(215287, 118, '2014-03-01 00:31:07.000000', 'temperatura', 640.0000, 'ºC'),
	(215288, 118, '2014-03-01 00:31:08.000000', 'temperatura', 534.0000, 'ºC'),
	(215289, 118, '2014-03-01 00:31:09.000000', 'temperatura', 751.0000, 'ºC'),
	(215290, 118, '2014-03-01 00:31:10.000000', 'temperatura', 953.0000, 'ºC'),
	(215291, 118, '2014-03-01 00:31:11.000000', 'temperatura', 114.0000, 'ºC'),
	(215292, 118, '2014-03-01 00:31:12.000000', 'temperatura', 109.0000, 'ºC'),
	(215293, 118, '2014-03-01 00:31:13.000000', 'temperatura', 206.0000, 'ºC'),
	(215294, 118, '2014-03-01 00:31:14.000000', 'temperatura', 704.0000, 'ºC'),
	(215295, 118, '2014-03-01 00:31:15.000000', 'temperatura', 500.0000, 'ºC'),
	(215296, 118, '2014-03-01 00:31:16.000000', 'temperatura', 389.0000, 'ºC'),
	(215297, 118, '2014-03-01 00:31:17.000000', 'temperatura', 446.0000, 'ºC'),
	(215298, 118, '2014-03-01 00:31:18.000000', 'temperatura', 1064.0000, 'ºC'),
	(215299, 118, '2014-03-01 00:31:19.000000', 'temperatura', 382.0000, 'ºC'),
	(215300, 118, '2014-03-01 00:31:20.000000', 'temperatura', 1119.0000, 'ºC'),
	(215301, 118, '2014-03-01 00:31:21.000000', 'temperatura', 851.0000, 'ºC'),
	(215302, 118, '2014-03-01 00:31:22.000000', 'temperatura', 898.0000, 'ºC'),
	(215303, 118, '2014-03-01 00:31:23.000000', 'temperatura', 735.0000, 'ºC'),
	(215304, 118, '2014-03-01 00:31:24.000000', 'temperatura', 985.0000, 'ºC'),
	(215305, 118, '2014-03-01 00:31:25.000000', 'temperatura', 318.0000, 'ºC'),
	(215306, 118, '2014-03-01 00:31:26.000000', 'temperatura', 1035.0000, 'ºC'),
	(215307, 118, '2014-03-01 00:31:27.000000', 'temperatura', 623.0000, 'ºC'),
	(215308, 118, '2014-03-01 00:31:28.000000', 'temperatura', 8.0000, 'ºC'),
	(215309, 118, '2014-03-01 00:31:29.000000', 'temperatura', 575.0000, 'ºC'),
	(215310, 118, '2014-03-01 00:31:30.000000', 'temperatura', 448.0000, 'ºC'),
	(215311, 118, '2014-03-01 00:31:31.000000', 'temperatura', 518.0000, 'ºC'),
	(215312, 118, '2014-03-01 00:31:32.000000', 'temperatura', 45.0000, 'ºC'),
	(215313, 118, '2014-03-01 00:31:33.000000', 'temperatura', 1070.0000, 'ºC'),
	(215314, 118, '2014-03-01 00:31:34.000000', 'temperatura', 417.0000, 'ºC'),
	(215315, 118, '2014-03-01 00:31:35.000000', 'temperatura', 76.0000, 'ºC'),
	(215316, 118, '2014-03-01 00:31:36.000000', 'temperatura', 328.0000, 'ºC'),
	(215317, 118, '2014-03-01 00:31:37.000000', 'temperatura', 212.0000, 'ºC'),
	(215318, 118, '2014-03-01 00:31:38.000000', 'temperatura', 78.0000, 'ºC'),
	(215319, 118, '2014-03-01 00:31:39.000000', 'temperatura', 955.0000, 'ºC'),
	(215320, 118, '2014-03-01 00:31:40.000000', 'temperatura', 939.0000, 'ºC'),
	(215321, 118, '2014-03-01 00:31:41.000000', 'temperatura', 633.0000, 'ºC'),
	(215322, 118, '2014-03-01 00:31:42.000000', 'temperatura', 349.0000, 'ºC'),
	(215323, 118, '2014-03-01 00:31:43.000000', 'temperatura', 1047.0000, 'ºC'),
	(215324, 118, '2014-03-01 00:31:44.000000', 'temperatura', 589.0000, 'ºC'),
	(215325, 118, '2014-03-01 00:31:45.000000', 'temperatura', 1004.0000, 'ºC'),
	(215326, 118, '2014-03-01 00:31:46.000000', 'temperatura', 851.0000, 'ºC'),
	(215327, 118, '2014-03-01 00:31:47.000000', 'temperatura', 46.0000, 'ºC'),
	(215328, 118, '2014-03-01 00:31:48.000000', 'temperatura', 79.0000, 'ºC'),
	(215329, 118, '2014-03-01 00:31:49.000000', 'temperatura', 255.0000, 'ºC'),
	(215330, 118, '2014-03-01 00:31:50.000000', 'temperatura', 1039.0000, 'ºC'),
	(215331, 118, '2014-03-01 00:31:51.000000', 'temperatura', 829.0000, 'ºC'),
	(215332, 118, '2014-03-01 00:31:52.000000', 'temperatura', 1028.0000, 'ºC'),
	(215333, 118, '2014-03-01 00:31:53.000000', 'temperatura', 256.0000, 'ºC'),
	(215334, 118, '2014-03-01 00:31:54.000000', 'temperatura', 595.0000, 'ºC'),
	(215335, 118, '2014-03-01 00:31:55.000000', 'temperatura', 1007.0000, 'ºC'),
	(215336, 118, '2014-03-01 00:31:56.000000', 'temperatura', 852.0000, 'ºC'),
	(215337, 118, '2014-03-01 00:31:57.000000', 'temperatura', 40.0000, 'ºC'),
	(215338, 118, '2014-03-01 00:31:58.000000', 'temperatura', 43.0000, 'ºC'),
	(215339, 118, '2014-03-01 00:31:59.000000', 'temperatura', 95.0000, 'ºC'),
	(215340, 118, '2014-03-01 00:32:00.000000', 'temperatura', 346.0000, 'ºC'),
	(215341, 118, '2014-03-01 00:32:01.000000', 'temperatura', 248.0000, 'ºC'),
	(215342, 118, '2014-03-01 00:32:02.000000', 'temperatura', 203.0000, 'ºC'),
	(215343, 118, '2014-03-01 00:32:03.000000', 'temperatura', 270.0000, 'ºC'),
	(215344, 118, '2014-03-01 00:32:04.000000', 'temperatura', 743.0000, 'ºC'),
	(215345, 118, '2014-03-01 00:32:05.000000', 'temperatura', 503.0000, 'ºC'),
	(215346, 118, '2014-03-01 00:32:06.000000', 'temperatura', 290.0000, 'ºC'),
	(215347, 118, '2014-03-01 00:32:07.000000', 'temperatura', 1138.0000, 'ºC'),
	(215348, 118, '2014-03-01 00:32:08.000000', 'temperatura', 23.0000, 'ºC'),
	(215349, 118, '2014-03-01 00:32:09.000000', 'temperatura', 300.0000, 'ºC'),
	(215350, 118, '2014-03-01 00:32:10.000000', 'temperatura', 230.0000, 'ºC'),
	(215351, 118, '2014-03-01 00:32:11.000000', 'temperatura', 254.0000, 'ºC'),
	(215352, 118, '2014-03-01 00:32:12.000000', 'temperatura', 578.0000, 'ºC'),
	(215353, 118, '2014-03-01 00:32:13.000000', 'temperatura', 929.0000, 'ºC'),
	(215354, 118, '2014-03-01 00:32:14.000000', 'temperatura', 514.0000, 'ºC'),
	(215355, 118, '2014-03-01 00:32:15.000000', 'temperatura', 981.0000, 'ºC'),
	(215356, 118, '2014-03-01 00:32:16.000000', 'temperatura', 964.0000, 'ºC'),
	(215357, 118, '2014-03-01 00:32:17.000000', 'temperatura', 676.0000, 'ºC'),
	(215358, 118, '2014-03-01 00:32:18.000000', 'temperatura', 488.0000, 'ºC'),
	(215359, 118, '2014-03-01 00:32:19.000000', 'temperatura', 413.0000, 'ºC'),
	(215360, 118, '2014-03-01 00:32:20.000000', 'temperatura', 602.0000, 'ºC'),
	(215361, 118, '2014-03-01 00:32:21.000000', 'temperatura', 573.0000, 'ºC'),
	(215362, 118, '2014-03-01 00:32:22.000000', 'temperatura', 1059.0000, 'ºC'),
	(215363, 118, '2014-03-01 00:32:23.000000', 'temperatura', 1177.0000, 'ºC'),
	(215364, 118, '2014-03-01 00:32:24.000000', 'temperatura', 309.0000, 'ºC'),
	(215365, 118, '2014-03-01 00:32:25.000000', 'temperatura', 413.0000, 'ºC'),
	(215366, 118, '2014-03-01 00:32:26.000000', 'temperatura', 1139.0000, 'ºC'),
	(215367, 118, '2014-03-01 00:32:27.000000', 'temperatura', 855.0000, 'ºC'),
	(215368, 118, '2014-03-01 00:32:28.000000', 'temperatura', 860.0000, 'ºC'),
	(215369, 118, '2014-03-01 00:32:29.000000', 'temperatura', 534.0000, 'ºC'),
	(215370, 118, '2014-03-01 00:32:30.000000', 'temperatura', 91.0000, 'ºC'),
	(215371, 118, '2014-03-01 00:32:31.000000', 'temperatura', 54.0000, 'ºC'),
	(215372, 118, '2014-03-01 00:32:32.000000', 'temperatura', 1197.0000, 'ºC'),
	(215373, 118, '2014-03-01 00:32:33.000000', 'temperatura', 1023.0000, 'ºC'),
	(215374, 118, '2014-03-01 00:32:34.000000', 'temperatura', 323.0000, 'ºC'),
	(215375, 118, '2014-03-01 00:32:35.000000', 'temperatura', 950.0000, 'ºC'),
	(215376, 118, '2014-03-01 00:32:36.000000', 'temperatura', 179.0000, 'ºC'),
	(215377, 118, '2014-03-01 00:32:37.000000', 'temperatura', 444.0000, 'ºC'),
	(215378, 118, '2014-03-01 00:32:38.000000', 'temperatura', 486.0000, 'ºC'),
	(215379, 118, '2014-03-01 00:32:39.000000', 'temperatura', 1096.0000, 'ºC'),
	(215380, 118, '2014-03-01 00:32:40.000000', 'temperatura', 423.0000, 'ºC'),
	(215381, 118, '2014-03-01 00:32:41.000000', 'temperatura', 30.0000, 'ºC'),
	(215382, 118, '2014-03-01 00:32:42.000000', 'temperatura', 81.0000, 'ºC'),
	(215383, 118, '2014-03-01 00:32:43.000000', 'temperatura', 315.0000, 'ºC'),
	(215384, 118, '2014-03-01 00:32:44.000000', 'temperatura', 131.0000, 'ºC'),
	(215385, 118, '2014-03-01 00:32:45.000000', 'temperatura', 913.0000, 'ºC'),
	(215386, 118, '2014-03-01 00:32:46.000000', 'temperatura', 573.0000, 'ºC'),
	(215387, 118, '2014-03-01 00:32:47.000000', 'temperatura', 127.0000, 'ºC'),
	(215388, 118, '2014-03-01 00:32:48.000000', 'temperatura', 117.0000, 'ºC'),
	(215389, 118, '2014-03-01 00:32:49.000000', 'temperatura', 205.0000, 'ºC'),
	(215390, 118, '2014-03-01 00:32:50.000000', 'temperatura', 672.0000, 'ºC'),
	(215391, 118, '2014-03-01 00:32:51.000000', 'temperatura', 345.0000, 'ºC'),
	(215392, 118, '2014-03-01 00:32:52.000000', 'temperatura', 909.0000, 'ºC'),
	(215393, 118, '2014-03-01 00:32:53.000000', 'temperatura', 1110.0000, 'ºC'),
	(215394, 118, '2014-03-01 00:32:54.000000', 'temperatura', 426.0000, 'ºC'),
	(215395, 118, '2014-03-01 00:32:55.000000', 'temperatura', 1199.0000, 'ºC'),
	(215396, 118, '2014-03-01 00:32:56.000000', 'temperatura', 1116.0000, 'ºC'),
	(215397, 118, '2014-03-01 00:32:57.000000', 'temperatura', 786.0000, 'ºC'),
	(215398, 118, '2014-03-01 00:32:58.000000', 'temperatura', 582.0000, 'ºC'),
	(215399, 118, '2014-03-01 00:32:59.000000', 'temperatura', 551.0000, 'ºC'),
	(215400, 118, '2014-03-01 00:33:00.000000', 'temperatura', 1009.0000, 'ºC'),
	(215401, 118, '2014-03-01 00:33:01.000000', 'temperatura', 995.0000, 'ºC'),
	(215402, 118, '2014-03-01 00:33:02.000000', 'temperatura', 747.0000, 'ºC'),
	(215403, 118, '2014-03-01 00:33:03.000000', 'temperatura', 750.0000, 'ºC'),
	(215404, 118, '2014-03-01 00:33:04.000000', 'temperatura', 311.0000, 'ºC'),
	(215405, 118, '2014-03-01 00:33:05.000000', 'temperatura', 503.0000, 'ºC'),
	(215406, 118, '2014-03-01 00:33:06.000000', 'temperatura', 383.0000, 'ºC'),
	(215407, 118, '2014-03-01 00:33:07.000000', 'temperatura', 406.0000, 'ºC'),
	(215408, 118, '2014-03-01 00:33:08.000000', 'temperatura', 882.0000, 'ºC'),
	(215409, 118, '2014-03-01 00:33:09.000000', 'temperatura', 794.0000, 'ºC'),
	(215410, 118, '2014-03-01 00:33:10.000000', 'temperatura', 125.0000, 'ºC'),
	(215411, 118, '2014-03-01 00:33:11.000000', 'temperatura', 643.0000, 'ºC'),
	(215412, 118, '2014-03-01 00:33:12.000000', 'temperatura', 439.0000, 'ºC'),
	(215413, 118, '2014-03-01 00:33:13.000000', 'temperatura', 268.0000, 'ºC'),
	(215414, 118, '2014-03-01 00:33:14.000000', 'temperatura', 25.0000, 'ºC'),
	(215415, 118, '2014-03-01 00:33:15.000000', 'temperatura', 518.0000, 'ºC'),
	(215416, 118, '2014-03-01 00:33:16.000000', 'temperatura', 117.0000, 'ºC'),
	(215417, 118, '2014-03-01 00:33:17.000000', 'temperatura', 233.0000, 'ºC'),
	(215418, 118, '2014-03-01 00:33:18.000000', 'temperatura', 813.0000, 'ºC'),
	(215419, 118, '2014-03-01 00:33:19.000000', 'temperatura', 965.0000, 'ºC'),
	(215420, 118, '2014-03-01 00:33:20.000000', 'temperatura', 1188.0000, 'ºC'),
	(215421, 118, '2014-03-01 00:33:21.000000', 'temperatura', 647.0000, 'ºC'),
	(215422, 118, '2014-03-01 00:33:22.000000', 'temperatura', 869.0000, 'ºC'),
	(215423, 118, '2014-03-01 00:33:23.000000', 'temperatura', 7.0000, 'ºC'),
	(215424, 118, '2014-03-01 00:33:24.000000', 'temperatura', 1028.0000, 'ºC'),
	(215425, 118, '2014-03-01 00:33:25.000000', 'temperatura', 318.0000, 'ºC'),
	(215426, 118, '2014-03-01 00:33:26.000000', 'temperatura', 906.0000, 'ºC'),
	(215427, 118, '2014-03-01 00:33:27.000000', 'temperatura', 1177.0000, 'ºC'),
	(215428, 118, '2014-03-01 00:33:28.000000', 'temperatura', 767.0000, 'ºC'),
	(215429, 118, '2014-03-01 00:33:29.000000', 'temperatura', 304.0000, 'ºC'),
	(215430, 118, '2014-03-01 00:33:30.000000', 'temperatura', 420.0000, 'ºC'),
	(215431, 118, '2014-03-01 00:33:31.000000', 'temperatura', 1189.0000, 'ºC'),
	(215432, 118, '2014-03-01 00:33:32.000000', 'temperatura', 1086.0000, 'ºC'),
	(215433, 118, '2014-03-01 00:33:33.000000', 'temperatura', 662.0000, 'ºC'),
	(215434, 118, '2014-03-01 00:33:34.000000', 'temperatura', 55.0000, 'ºC'),
	(215435, 118, '2014-03-01 00:33:35.000000', 'temperatura', 688.0000, 'ºC'),
	(215436, 118, '2014-03-01 00:33:36.000000', 'temperatura', 875.0000, 'ºC'),
	(215437, 118, '2014-03-01 00:33:37.000000', 'temperatura', 1114.0000, 'ºC'),
	(215438, 118, '2014-03-01 00:33:38.000000', 'temperatura', 544.0000, 'ºC'),
	(215439, 118, '2014-03-01 00:33:39.000000', 'temperatura', 579.0000, 'ºC'),
	(215440, 118, '2014-03-01 00:33:40.000000', 'temperatura', 62.0000, 'ºC'),
	(215441, 118, '2014-03-01 00:33:41.000000', 'temperatura', 973.0000, 'ºC'),
	(215442, 118, '2014-03-01 00:33:42.000000', 'temperatura', 1079.0000, 'ºC'),
	(215443, 118, '2014-03-01 00:33:43.000000', 'temperatura', 77.0000, 'ºC'),
	(215444, 118, '2014-03-01 00:33:44.000000', 'temperatura', 750.0000, 'ºC'),
	(215445, 118, '2014-03-01 00:33:45.000000', 'temperatura', 1119.0000, 'ºC'),
	(215446, 118, '2014-03-01 00:33:46.000000', 'temperatura', 943.0000, 'ºC'),
	(215447, 118, '2014-03-01 00:33:47.000000', 'temperatura', 161.0000, 'ºC'),
	(215448, 118, '2014-03-01 00:33:48.000000', 'temperatura', 376.0000, 'ºC'),
	(215449, 118, '2014-03-01 00:33:49.000000', 'temperatura', 197.0000, 'ºC'),
	(215450, 118, '2014-03-01 00:33:50.000000', 'temperatura', 1060.0000, 'ºC'),
	(215451, 118, '2014-03-01 00:33:51.000000', 'temperatura', 1107.0000, 'ºC'),
	(215452, 118, '2014-03-01 00:33:52.000000', 'temperatura', 1156.0000, 'ºC'),
	(215453, 118, '2014-03-01 00:33:53.000000', 'temperatura', 59.0000, 'ºC'),
	(215454, 118, '2014-03-01 00:33:54.000000', 'temperatura', 426.0000, 'ºC'),
	(215455, 118, '2014-03-01 00:33:55.000000', 'temperatura', 756.0000, 'ºC'),
	(215456, 118, '2014-03-01 00:33:56.000000', 'temperatura', 103.0000, 'ºC'),
	(215457, 118, '2014-03-01 00:33:57.000000', 'temperatura', 649.0000, 'ºC'),
	(215458, 118, '2014-03-01 00:33:58.000000', 'temperatura', 534.0000, 'ºC'),
	(215459, 118, '2014-03-01 00:33:59.000000', 'temperatura', 723.0000, 'ºC'),
	(215460, 118, '2014-03-01 00:34:00.000000', 'temperatura', 813.0000, 'ºC'),
	(215461, 118, '2014-03-01 00:34:01.000000', 'temperatura', 699.0000, 'ºC'),
	(215462, 118, '2014-03-01 00:34:02.000000', 'temperatura', 1056.0000, 'ºC'),
	(215463, 118, '2014-03-01 00:34:03.000000', 'temperatura', 783.0000, 'ºC'),
	(215464, 118, '2014-03-01 00:34:04.000000', 'temperatura', 746.0000, 'ºC'),
	(215465, 118, '2014-03-01 00:34:05.000000', 'temperatura', 183.0000, 'ºC'),
	(215466, 118, '2014-03-01 00:34:06.000000', 'temperatura', 1075.0000, 'ºC'),
	(215467, 118, '2014-03-01 00:34:07.000000', 'temperatura', 30.0000, 'ºC'),
	(215468, 118, '2014-03-01 00:34:08.000000', 'temperatura', 524.0000, 'ºC'),
	(215469, 118, '2014-03-01 00:34:09.000000', 'temperatura', 133.0000, 'ºC'),
	(215470, 118, '2014-03-01 00:34:10.000000', 'temperatura', 291.0000, 'ºC'),
	(215471, 118, '2014-03-01 00:34:11.000000', 'temperatura', 1055.0000, 'ºC'),
	(215472, 118, '2014-03-01 00:34:12.000000', 'temperatura', 806.0000, 'ºC'),
	(215473, 118, '2014-03-01 00:34:13.000000', 'temperatura', 862.0000, 'ºC'),
	(215474, 118, '2014-03-01 00:34:14.000000', 'temperatura', 696.0000, 'ºC'),
	(215475, 118, '2014-03-01 00:34:15.000000', 'temperatura', 893.0000, 'ºC'),
	(215476, 118, '2014-03-01 00:34:16.000000', 'temperatura', 1178.0000, 'ºC'),
	(215477, 118, '2014-03-01 00:34:17.000000', 'temperatura', 812.0000, 'ºC'),
	(215478, 118, '2014-03-01 00:34:18.000000', 'temperatura', 525.0000, 'ºC'),
	(215479, 118, '2014-03-01 00:34:19.000000', 'temperatura', 191.0000, 'ºC'),
	(215480, 118, '2014-03-01 00:34:20.000000', 'temperatura', 579.0000, 'ºC'),
	(215481, 118, '2014-03-01 00:34:21.000000', 'temperatura', 1125.0000, 'ºC'),
	(215482, 118, '2014-03-01 00:34:22.000000', 'temperatura', 287.0000, 'ºC'),
	(215483, 118, '2014-03-01 00:34:23.000000', 'temperatura', 462.0000, 'ºC'),
	(215484, 118, '2014-03-01 00:34:24.000000', 'temperatura', 251.0000, 'ºC'),
	(215485, 118, '2014-03-01 00:34:25.000000', 'temperatura', 1066.0000, 'ºC'),
	(215486, 118, '2014-03-01 00:34:26.000000', 'temperatura', 979.0000, 'ºC'),
	(215487, 118, '2014-03-01 00:34:27.000000', 'temperatura', 499.0000, 'ºC'),
	(215488, 118, '2014-03-01 00:34:28.000000', 'temperatura', 757.0000, 'ºC'),
	(215489, 118, '2014-03-01 00:34:29.000000', 'temperatura', 1089.0000, 'ºC'),
	(215490, 118, '2014-03-01 00:34:30.000000', 'temperatura', 773.0000, 'ºC'),
	(215491, 118, '2014-03-01 00:34:31.000000', 'temperatura', 599.0000, 'ºC'),
	(215492, 118, '2014-03-01 00:34:32.000000', 'temperatura', 678.0000, 'ºC'),
	(215493, 118, '2014-03-01 00:34:33.000000', 'temperatura', 391.0000, 'ºC'),
	(215494, 118, '2014-03-01 00:34:34.000000', 'temperatura', 1124.0000, 'ºC'),
	(215495, 118, '2014-03-01 00:34:35.000000', 'temperatura', 847.0000, 'ºC'),
	(215496, 118, '2014-03-01 00:34:36.000000', 'temperatura', 862.0000, 'ºC'),
	(215497, 118, '2014-03-01 00:34:37.000000', 'temperatura', 569.0000, 'ºC'),
	(215498, 118, '2014-03-01 00:34:38.000000', 'temperatura', 259.0000, 'ºC'),
	(215499, 118, '2014-03-01 00:34:39.000000', 'temperatura', 790.0000, 'ºC'),
	(215500, 118, '2014-03-01 00:34:40.000000', 'temperatura', 774.0000, 'ºC'),
	(215501, 118, '2014-03-01 00:34:41.000000', 'temperatura', 299.0000, 'ºC'),
	(215502, 118, '2014-03-01 00:34:42.000000', 'temperatura', 374.0000, 'ºC'),
	(215503, 118, '2014-03-01 00:34:43.000000', 'temperatura', 975.0000, 'ºC'),
	(215504, 118, '2014-03-01 00:34:44.000000', 'temperatura', 151.0000, 'ºC'),
	(215505, 118, '2014-03-01 00:34:45.000000', 'temperatura', 230.0000, 'ºC'),
	(215506, 118, '2014-03-01 00:34:46.000000', 'temperatura', 701.0000, 'ºC'),
	(215507, 118, '2014-03-01 00:34:47.000000', 'temperatura', 412.0000, 'ºC'),
	(215508, 118, '2014-03-01 00:34:48.000000', 'temperatura', 1159.0000, 'ºC'),
	(215509, 118, '2014-03-01 00:34:49.000000', 'temperatura', 959.0000, 'ºC'),
	(215510, 118, '2014-03-01 00:34:50.000000', 'temperatura', 117.0000, 'ºC'),
	(215511, 118, '2014-03-01 00:34:51.000000', 'temperatura', 109.0000, 'ºC'),
	(215512, 118, '2014-03-01 00:34:52.000000', 'temperatura', 195.0000, 'ºC'),
	(215513, 118, '2014-03-01 00:34:53.000000', 'temperatura', 650.0000, 'ºC'),
	(215514, 118, '2014-03-01 00:34:54.000000', 'temperatura', 265.0000, 'ºC'),
	(215515, 118, '2014-03-01 00:34:55.000000', 'temperatura', 574.0000, 'ºC'),
	(215516, 118, '2014-03-01 00:34:56.000000', 'temperatura', 876.0000, 'ºC'),
	(215517, 118, '2014-03-01 00:34:57.000000', 'temperatura', 260.0000, 'ºC'),
	(215518, 118, '2014-03-01 00:34:58.000000', 'temperatura', 1071.0000, 'ºC'),
	(215519, 118, '2014-03-01 00:34:59.000000', 'temperatura', 976.0000, 'ºC'),
	(215520, 118, '2014-03-01 00:35:00.000000', 'temperatura', 468.0000, 'ºC'),
	(215521, 118, '2014-03-01 00:35:01.000000', 'temperatura', 610.0000, 'ºC'),
	(215522, 118, '2014-03-01 00:35:02.000000', 'temperatura', 449.0000, 'ºC'),
	(215523, 118, '2014-03-01 00:35:03.000000', 'temperatura', 414.0000, 'ºC'),
	(215524, 118, '2014-03-01 00:35:04.000000', 'temperatura', 725.0000, 'ºC'),
	(215525, 118, '2014-03-01 00:35:05.000000', 'temperatura', 1182.0000, 'ºC'),
	(215526, 118, '2014-03-01 00:35:06.000000', 'temperatura', 135.0000, 'ºC'),
	(215527, 118, '2014-03-01 00:35:07.000000', 'temperatura', 729.0000, 'ºC'),
	(215528, 118, '2014-03-01 00:35:08.000000', 'temperatura', 841.0000, 'ºC'),
	(215529, 118, '2014-03-01 00:35:09.000000', 'temperatura', 820.0000, 'ºC'),
	(215530, 118, '2014-03-01 00:35:10.000000', 'temperatura', 379.0000, 'ºC'),
	(215531, 118, '2014-03-01 00:35:11.000000', 'temperatura', 633.0000, 'ºC'),
	(215532, 118, '2014-03-01 00:35:12.000000', 'temperatura', 828.0000, 'ºC'),
	(215533, 118, '2014-03-01 00:35:13.000000', 'temperatura', 1040.0000, 'ºC'),
	(215534, 118, '2014-03-01 00:35:14.000000', 'temperatura', 320.0000, 'ºC'),
	(215535, 118, '2014-03-01 00:35:15.000000', 'temperatura', 878.0000, 'ºC'),
	(215536, 118, '2014-03-01 00:35:16.000000', 'temperatura', 1030.0000, 'ºC'),
	(215537, 118, '2014-03-01 00:35:17.000000', 'temperatura', 116.0000, 'ºC'),
	(215538, 118, '2014-03-01 00:35:18.000000', 'temperatura', 1093.0000, 'ºC'),
	(215539, 118, '2014-03-01 00:35:19.000000', 'temperatura', 317.0000, 'ºC'),
	(215540, 118, '2014-03-01 00:35:20.000000', 'temperatura', 705.0000, 'ºC'),
	(215541, 118, '2014-03-01 00:35:21.000000', 'temperatura', 174.0000, 'ºC'),
	(215542, 118, '2014-03-01 00:35:22.000000', 'temperatura', 1155.0000, 'ºC'),
	(215543, 118, '2014-03-01 00:35:23.000000', 'temperatura', 455.0000, 'ºC'),
	(215544, 118, '2014-03-01 00:35:24.000000', 'temperatura', 11.0000, 'ºC'),
	(215545, 118, '2014-03-01 00:35:25.000000', 'temperatura', 1089.0000, 'ºC'),
	(215546, 118, '2014-03-01 00:35:26.000000', 'temperatura', 614.0000, 'ºC'),
	(215547, 118, '2014-03-01 00:35:27.000000', 'temperatura', 1002.0000, 'ºC'),
	(215548, 118, '2014-03-01 00:35:28.000000', 'temperatura', 767.0000, 'ºC'),
	(215549, 118, '2014-03-01 00:35:29.000000', 'temperatura', 833.0000, 'ºC'),
	(215550, 118, '2014-03-01 00:35:30.000000', 'temperatura', 662.0000, 'ºC'),
	(215551, 118, '2014-03-01 00:35:31.000000', 'temperatura', 812.0000, 'ºC'),
	(215552, 118, '2014-03-01 00:35:32.000000', 'temperatura', 877.0000, 'ºC'),
	(215553, 118, '2014-03-01 00:35:33.000000', 'temperatura', 747.0000, 'ºC'),
	(215554, 118, '2014-03-01 00:35:34.000000', 'temperatura', 1103.0000, 'ºC'),
	(215555, 118, '2014-03-01 00:35:35.000000', 'temperatura', 878.0000, 'ºC'),
	(215556, 118, '2014-03-01 00:35:36.000000', 'temperatura', 1081.0000, 'ºC'),
	(215557, 118, '2014-03-01 00:35:37.000000', 'temperatura', 369.0000, 'ºC'),
	(215558, 118, '2014-03-01 00:35:38.000000', 'temperatura', 1003.0000, 'ºC'),
	(215559, 118, '2014-03-01 00:35:39.000000', 'temperatura', 307.0000, 'ºC'),
	(215560, 118, '2014-03-01 00:35:40.000000', 'temperatura', 930.0000, 'ºC'),
	(215561, 118, '2014-03-01 00:35:41.000000', 'temperatura', 127.0000, 'ºC'),
	(215562, 118, '2014-03-01 00:35:42.000000', 'temperatura', 248.0000, 'ºC'),
	(215563, 118, '2014-03-01 00:35:43.000000', 'temperatura', 860.0000, 'ºC'),
	(215564, 118, '2014-03-01 00:35:44.000000', 'temperatura', 1155.0000, 'ºC'),
	(215565, 118, '2014-03-01 00:35:45.000000', 'temperatura', 795.0000, 'ºC'),
	(215566, 118, '2014-03-01 00:35:46.000000', 'temperatura', 509.0000, 'ºC'),
	(215567, 118, '2014-03-01 00:35:47.000000', 'temperatura', 161.0000, 'ºC'),
	(215568, 118, '2014-03-01 00:35:48.000000', 'temperatura', 480.0000, 'ºC'),
	(215569, 118, '2014-03-01 00:35:49.000000', 'temperatura', 719.0000, 'ºC'),
	(215570, 118, '2014-03-01 00:35:50.000000', 'temperatura', 952.0000, 'ºC'),
	(215571, 118, '2014-03-01 00:35:51.000000', 'temperatura', 206.0000, 'ºC'),
	(215572, 118, '2014-03-01 00:35:52.000000', 'temperatura', 575.0000, 'ºC'),
	(215573, 118, '2014-03-01 00:35:53.000000', 'temperatura', 1058.0000, 'ºC'),
	(215574, 118, '2014-03-01 00:35:54.000000', 'temperatura', 1164.0000, 'ºC'),
	(215575, 118, '2014-03-01 00:35:55.000000', 'temperatura', 246.0000, 'ºC'),
	(215576, 118, '2014-03-01 00:35:56.000000', 'temperatura', 138.0000, 'ºC'),
	(215577, 118, '2014-03-01 00:35:57.000000', 'temperatura', 1152.0000, 'ºC'),
	(215578, 118, '2014-03-01 00:35:58.000000', 'temperatura', 547.0000, 'ºC'),
	(215579, 118, '2014-03-01 00:35:59.000000', 'temperatura', 480.0000, 'ºC'),
	(215580, 118, '2014-03-01 00:36:00.000000', 'temperatura', 758.0000, 'ºC'),
	(215581, 118, '2014-03-01 00:36:01.000000', 'temperatura', 1152.0000, 'ºC'),
	(215582, 118, '2014-03-01 00:36:02.000000', 'temperatura', 1086.0000, 'ºC'),
	(215583, 118, '2014-03-01 00:36:03.000000', 'temperatura', 773.0000, 'ºC'),
	(215584, 118, '2014-03-01 00:36:04.000000', 'temperatura', 610.0000, 'ºC'),
	(215585, 118, '2014-03-01 00:36:05.000000', 'temperatura', 731.0000, 'ºC'),
	(215586, 118, '2014-03-01 00:36:06.000000', 'temperatura', 627.0000, 'ºC'),
	(215587, 118, '2014-03-01 00:36:07.000000', 'temperatura', 940.0000, 'ºC'),
	(215588, 118, '2014-03-01 00:36:08.000000', 'temperatura', 420.0000, 'ºC'),
	(215589, 118, '2014-03-01 00:36:09.000000', 'temperatura', 482.0000, 'ºC'),
	(215590, 118, '2014-03-01 00:36:10.000000', 'temperatura', 1149.0000, 'ºC'),
	(215591, 118, '2014-03-01 00:36:11.000000', 'temperatura', 698.0000, 'ºC'),
	(215592, 118, '2014-03-01 00:36:12.000000', 'temperatura', 47.0000, 'ºC'),
	(215593, 118, '2014-03-01 00:36:13.000000', 'temperatura', 540.0000, 'ºC'),
	(215594, 118, '2014-03-01 00:36:14.000000', 'temperatura', 158.0000, 'ºC'),
	(215595, 118, '2014-03-01 00:36:15.000000', 'temperatura', 369.0000, 'ºC'),
	(215596, 118, '2014-03-01 00:36:16.000000', 'temperatura', 175.0000, 'ºC'),
	(215597, 118, '2014-03-01 00:36:17.000000', 'temperatura', 967.0000, 'ºC'),
	(215598, 118, '2014-03-01 00:36:18.000000', 'temperatura', 712.0000, 'ºC'),
	(215599, 118, '2014-03-01 00:36:19.000000', 'temperatura', 658.0000, 'ºC'),
	(215600, 118, '2014-03-01 00:36:20.000000', 'temperatura', 1156.0000, 'ºC'),
	(215601, 118, '2014-03-01 00:36:21.000000', 'temperatura', 206.0000, 'ºC'),
	(215602, 118, '2014-03-01 00:36:22.000000', 'temperatura', 1160.0000, 'ºC'),
	(215603, 118, '2014-03-01 00:36:23.000000', 'temperatura', 386.0000, 'ºC'),
	(215604, 118, '2014-03-01 00:36:24.000000', 'temperatura', 849.0000, 'ºC'),
	(215605, 118, '2014-03-01 00:36:25.000000', 'temperatura', 689.0000, 'ºC'),
	(215606, 118, '2014-03-01 00:36:26.000000', 'temperatura', 896.0000, 'ºC'),
	(215607, 118, '2014-03-01 00:36:27.000000', 'temperatura', 13.0000, 'ºC'),
	(215608, 118, '2014-03-01 00:36:28.000000', 'temperatura', 978.0000, 'ºC'),
	(215609, 118, '2014-03-01 00:36:29.000000', 'temperatura', 53.0000, 'ºC'),
	(215610, 118, '2014-03-01 00:36:30.000000', 'temperatura', 933.0000, 'ºC'),
	(215611, 118, '2014-03-01 00:36:31.000000', 'temperatura', 903.0000, 'ºC'),
	(215612, 118, '2014-03-01 00:36:32.000000', 'temperatura', 518.0000, 'ºC'),
	(215613, 118, '2014-03-01 00:36:33.000000', 'temperatura', 1082.0000, 'ºC'),
	(215614, 118, '2014-03-01 00:36:34.000000', 'temperatura', 254.0000, 'ºC'),
	(215615, 118, '2014-03-01 00:36:35.000000', 'temperatura', 428.0000, 'ºC'),
	(215616, 118, '2014-03-01 00:36:36.000000', 'temperatura', 177.0000, 'ºC'),
	(215617, 118, '2014-03-01 00:36:37.000000', 'temperatura', 803.0000, 'ºC'),
	(215618, 118, '2014-03-01 00:36:38.000000', 'temperatura', 1082.0000, 'ºC'),
	(215619, 118, '2014-03-01 00:36:39.000000', 'temperatura', 602.0000, 'ºC'),
	(215620, 118, '2014-03-01 00:36:40.000000', 'temperatura', 963.0000, 'ºC'),
	(215621, 118, '2014-03-01 00:36:41.000000', 'temperatura', 611.0000, 'ºC'),
	(215622, 118, '2014-03-01 00:36:42.000000', 'temperatura', 165.0000, 'ºC'),
	(215623, 118, '2014-03-01 00:36:43.000000', 'temperatura', 193.0000, 'ºC'),
	(215624, 118, '2014-03-01 00:36:44.000000', 'temperatura', 472.0000, 'ºC'),
	(215625, 118, '2014-03-01 00:36:45.000000', 'temperatura', 579.0000, 'ºC'),
	(215626, 118, '2014-03-01 00:36:46.000000', 'temperatura', 281.0000, 'ºC'),
	(215627, 118, '2014-03-01 00:36:47.000000', 'temperatura', 866.0000, 'ºC'),
	(215628, 118, '2014-03-01 00:36:48.000000', 'temperatura', 1090.0000, 'ºC'),
	(215629, 118, '2014-03-01 00:36:49.000000', 'temperatura', 451.0000, 'ºC'),
	(215630, 118, '2014-03-01 00:36:50.000000', 'temperatura', 187.0000, 'ºC'),
	(215631, 118, '2014-03-01 00:36:51.000000', 'temperatura', 781.0000, 'ºC'),
	(215632, 118, '2014-03-01 00:36:52.000000', 'temperatura', 946.0000, 'ºC'),
	(215633, 118, '2014-03-01 00:36:53.000000', 'temperatura', 1188.0000, 'ºC'),
	(215634, 118, '2014-03-01 00:36:54.000000', 'temperatura', 700.0000, 'ºC'),
	(215635, 118, '2014-03-01 00:36:55.000000', 'temperatura', 1138.0000, 'ºC'),
	(215636, 118, '2014-03-01 00:36:56.000000', 'temperatura', 1191.0000, 'ºC'),
	(215637, 118, '2014-03-01 00:36:57.000000', 'temperatura', 139.0000, 'ºC'),
	(215638, 118, '2014-03-01 00:36:58.000000', 'temperatura', 724.0000, 'ºC'),
	(215639, 118, '2014-03-01 00:36:59.000000', 'temperatura', 802.0000, 'ºC'),
	(215640, 118, '2014-03-01 00:37:00.000000', 'temperatura', 637.0000, 'ºC'),
	(215641, 118, '2014-03-01 00:37:01.000000', 'temperatura', 783.0000, 'ºC'),
	(215642, 118, '2014-03-01 00:37:02.000000', 'temperatura', 802.0000, 'ºC'),
	(215643, 118, '2014-03-01 00:37:03.000000', 'temperatura', 464.0000, 'ºC'),
	(215644, 118, '2014-03-01 00:37:04.000000', 'temperatura', 1113.0000, 'ºC'),
	(215645, 118, '2014-03-01 00:37:05.000000', 'temperatura', 576.0000, 'ºC'),
	(215646, 118, '2014-03-01 00:37:06.000000', 'temperatura', 739.0000, 'ºC'),
	(215647, 118, '2014-03-01 00:37:07.000000', 'temperatura', 766.0000, 'ºC'),
	(215648, 118, '2014-03-01 00:37:08.000000', 'temperatura', 417.0000, 'ºC'),
	(215649, 118, '2014-03-01 00:37:09.000000', 'temperatura', 984.0000, 'ºC'),
	(215650, 118, '2014-03-01 00:37:10.000000', 'temperatura', 72.0000, 'ºC'),
	(215651, 118, '2014-03-01 00:37:11.000000', 'temperatura', 1009.0000, 'ºC'),
	(215652, 118, '2014-03-01 00:37:12.000000', 'temperatura', 30.0000, 'ºC'),
	(215653, 118, '2014-03-01 00:37:13.000000', 'temperatura', 720.0000, 'ºC'),
	(215654, 118, '2014-03-01 00:37:14.000000', 'temperatura', 1114.0000, 'ºC'),
	(215655, 118, '2014-03-01 00:37:15.000000', 'temperatura', 1010.0000, 'ºC'),
	(215656, 118, '2014-03-01 00:37:16.000000', 'temperatura', 506.0000, 'ºC'),
	(215657, 118, '2014-03-01 00:37:17.000000', 'temperatura', 702.0000, 'ºC'),
	(215658, 118, '2014-03-01 00:37:18.000000', 'temperatura', 793.0000, 'ºC'),
	(215659, 118, '2014-03-01 00:37:19.000000', 'temperatura', 658.0000, 'ºC'),
	(215660, 118, '2014-03-01 00:37:20.000000', 'temperatura', 911.0000, 'ºC'),
	(215661, 118, '2014-03-01 00:37:21.000000', 'temperatura', 184.0000, 'ºC'),
	(215662, 118, '2014-03-01 00:37:22.000000', 'temperatura', 587.0000, 'ºC'),
	(215663, 118, '2014-03-01 00:37:23.000000', 'temperatura', 1184.0000, 'ºC'),
	(215664, 118, '2014-03-01 00:37:24.000000', 'temperatura', 558.0000, 'ºC'),
	(215665, 118, '2014-03-01 00:37:25.000000', 'temperatura', 440.0000, 'ºC'),
	(215666, 118, '2014-03-01 00:37:26.000000', 'temperatura', 527.0000, 'ºC'),
	(215667, 118, '2014-03-01 00:37:27.000000', 'temperatura', 114.0000, 'ºC'),
	(215668, 118, '2014-03-01 00:37:28.000000', 'temperatura', 191.0000, 'ºC'),
	(215669, 118, '2014-03-01 00:37:29.000000', 'temperatura', 611.0000, 'ºC'),
	(215670, 118, '2014-03-01 00:37:30.000000', 'temperatura', 85.0000, 'ºC'),
	(215671, 118, '2014-03-01 00:37:31.000000', 'temperatura', 992.0000, 'ºC'),
	(215672, 118, '2014-03-01 00:37:32.000000', 'temperatura', 1106.0000, 'ºC'),
	(215673, 118, '2014-03-01 00:37:33.000000', 'temperatura', 153.0000, 'ºC'),
	(215674, 118, '2014-03-01 00:37:34.000000', 'temperatura', 1049.0000, 'ºC'),
	(215675, 118, '2014-03-01 00:37:35.000000', 'temperatura', 1188.0000, 'ºC'),
	(215676, 118, '2014-03-01 00:37:36.000000', 'temperatura', 392.0000, 'ºC'),
	(215677, 118, '2014-03-01 00:37:37.000000', 'temperatura', 795.0000, 'ºC'),
	(215678, 118, '2014-03-01 00:37:38.000000', 'temperatura', 401.0000, 'ºC'),
	(215679, 118, '2014-03-01 00:37:39.000000', 'temperatura', 818.0000, 'ºC'),
	(215680, 118, '2014-03-01 00:37:40.000000', 'temperatura', 490.0000, 'ºC'),
	(215681, 118, '2014-03-01 00:37:41.000000', 'temperatura', 1197.0000, 'ºC'),
	(215682, 118, '2014-03-01 00:37:42.000000', 'temperatura', 913.0000, 'ºC'),
	(215683, 118, '2014-03-01 00:37:43.000000', 'temperatura', 977.0000, 'ºC'),
	(215684, 118, '2014-03-01 00:37:44.000000', 'temperatura', 946.0000, 'ºC'),
	(215685, 118, '2014-03-01 00:37:45.000000', 'temperatura', 598.0000, 'ºC'),
	(215686, 118, '2014-03-01 00:37:46.000000', 'temperatura', 152.0000, 'ºC'),
	(215687, 118, '2014-03-01 00:37:47.000000', 'temperatura', 167.0000, 'ºC'),
	(215688, 118, '2014-03-01 00:37:48.000000', 'temperatura', 382.0000, 'ºC'),
	(215689, 118, '2014-03-01 00:37:49.000000', 'temperatura', 207.0000, 'ºC'),
	(215690, 118, '2014-03-01 00:37:50.000000', 'temperatura', 1090.0000, 'ºC'),
	(215691, 118, '2014-03-01 00:37:51.000000', 'temperatura', 30.0000, 'ºC'),
	(215692, 118, '2014-03-01 00:37:52.000000', 'temperatura', 478.0000, 'ºC'),
	(215693, 118, '2014-03-01 00:37:53.000000', 'temperatura', 1103.0000, 'ºC'),
	(215694, 118, '2014-03-01 00:37:54.000000', 'temperatura', 481.0000, 'ºC'),
	(215695, 118, '2014-03-01 00:37:55.000000', 'temperatura', 294.0000, 'ºC'),
	(215696, 118, '2014-03-01 00:37:56.000000', 'temperatura', 30.0000, 'ºC'),
	(215697, 118, '2014-03-01 00:37:57.000000', 'temperatura', 470.0000, 'ºC'),
	(215698, 118, '2014-03-01 00:37:58.000000', 'temperatura', 1059.0000, 'ºC'),
	(215699, 118, '2014-03-01 00:37:59.000000', 'temperatura', 285.0000, 'ºC'),
	(215700, 118, '2014-03-01 00:38:00.000000', 'temperatura', 650.0000, 'ºC'),
	(215701, 118, '2014-03-01 00:38:01.000000', 'temperatura', 1193.0000, 'ºC'),
	(215702, 118, '2014-03-01 00:38:02.000000', 'temperatura', 418.0000, 'ºC'),
	(215703, 118, '2014-03-01 00:38:03.000000', 'temperatura', 912.0000, 'ºC'),
	(215704, 118, '2014-03-01 00:38:04.000000', 'temperatura', 906.0000, 'ºC'),
	(215705, 118, '2014-03-01 00:38:05.000000', 'temperatura', 592.0000, 'ºC'),
	(215706, 118, '2014-03-01 00:38:06.000000', 'temperatura', 245.0000, 'ºC'),
	(215707, 118, '2014-03-01 00:38:07.000000', 'temperatura', 649.0000, 'ºC'),
	(215708, 118, '2014-03-01 00:38:08.000000', 'temperatura', 110.0000, 'ºC'),
	(215709, 118, '2014-03-01 00:38:09.000000', 'temperatura', 1002.0000, 'ºC'),
	(215710, 118, '2014-03-01 00:38:10.000000', 'temperatura', 1084.0000, 'ºC'),
	(215711, 118, '2014-03-01 00:38:11.000000', 'temperatura', 12.0000, 'ºC'),
	(215712, 118, '2014-03-01 00:38:12.000000', 'temperatura', 407.0000, 'ºC'),
	(215713, 118, '2014-03-01 00:38:13.000000', 'temperatura', 802.0000, 'ºC'),
	(215714, 118, '2014-03-01 00:38:14.000000', 'temperatura', 390.0000, 'ºC'),
	(215715, 118, '2014-03-01 00:38:15.000000', 'temperatura', 745.0000, 'ºC'),
	(215716, 118, '2014-03-01 00:38:16.000000', 'temperatura', 157.0000, 'ºC'),
	(215717, 118, '2014-03-01 00:38:17.000000', 'temperatura', 947.0000, 'ºC'),
	(215718, 118, '2014-03-01 00:38:18.000000', 'temperatura', 667.0000, 'ºC'),
	(215719, 118, '2014-03-01 00:38:19.000000', 'temperatura', 494.0000, 'ºC'),
	(215720, 118, '2014-03-01 00:38:20.000000', 'temperatura', 469.0000, 'ºC'),
	(215721, 118, '2014-03-01 00:38:21.000000', 'temperatura', 865.0000, 'ºC'),
	(215722, 118, '2014-03-01 00:38:22.000000', 'temperatura', 518.0000, 'ºC'),
	(215723, 118, '2014-03-01 00:38:23.000000', 'temperatura', 1196.0000, 'ºC'),
	(215724, 118, '2014-03-01 00:38:24.000000', 'temperatura', 824.0000, 'ºC'),
	(215725, 118, '2014-03-01 00:38:25.000000', 'temperatura', 535.0000, 'ºC'),
	(215726, 118, '2014-03-01 00:38:26.000000', 'temperatura', 201.0000, 'ºC'),
	(215727, 118, '2014-03-01 00:38:27.000000', 'temperatura', 601.0000, 'ºC'),
	(215728, 118, '2014-03-01 00:38:28.000000', 'temperatura', 3.0000, 'ºC'),
	(215729, 118, '2014-03-01 00:38:29.000000', 'temperatura', 611.0000, 'ºC'),
	(215730, 118, '2014-03-01 00:38:30.000000', 'temperatura', 649.0000, 'ºC'),
	(215731, 118, '2014-03-01 00:38:31.000000', 'temperatura', 213.0000, 'ºC'),
	(215732, 118, '2014-03-01 00:38:32.000000', 'temperatura', 318.0000, 'ºC'),
	(215733, 118, '2014-03-01 00:38:33.000000', 'temperatura', 952.0000, 'ºC'),
	(215734, 118, '2014-03-01 00:38:34.000000', 'temperatura', 207.0000, 'ºC'),
	(215735, 118, '2014-03-01 00:38:35.000000', 'temperatura', 577.0000, 'ºC'),
	(215736, 118, '2014-03-01 00:38:36.000000', 'temperatura', 1066.0000, 'ºC'),
	(215737, 118, '2014-03-01 00:38:37.000000', 'temperatura', 1.0000, 'ºC'),
	(215738, 118, '2014-03-01 00:38:38.000000', 'temperatura', 407.0000, 'ºC'),
	(215739, 118, '2014-03-01 00:38:39.000000', 'temperatura', 830.0000, 'ºC'),
	(215740, 118, '2014-03-01 00:38:40.000000', 'temperatura', 531.0000, 'ºC'),
	(215741, 118, '2014-03-01 00:38:41.000000', 'temperatura', 164.0000, 'ºC'),
	(215742, 118, '2014-03-01 00:38:42.000000', 'temperatura', 429.0000, 'ºC'),
	(215743, 118, '2014-03-01 00:38:43.000000', 'temperatura', 452.0000, 'ºC'),
	(215744, 118, '2014-03-01 00:38:44.000000', 'temperatura', 975.0000, 'ºC'),
	(215745, 118, '2014-03-01 00:38:45.000000', 'temperatura', 1121.0000, 'ºC'),
	(215746, 118, '2014-03-01 00:38:46.000000', 'temperatura', 277.0000, 'ºC'),
	(215747, 118, '2014-03-01 00:38:47.000000', 'temperatura', 424.0000, 'ºC'),
	(215748, 118, '2014-03-01 00:38:48.000000', 'temperatura', 89.0000, 'ºC'),
	(215749, 118, '2014-03-01 00:38:49.000000', 'temperatura', 373.0000, 'ºC'),
	(215750, 118, '2014-03-01 00:38:50.000000', 'temperatura', 400.0000, 'ºC'),
	(215751, 118, '2014-03-01 00:38:51.000000', 'temperatura', 880.0000, 'ºC'),
	(215752, 118, '2014-03-01 00:38:52.000000', 'temperatura', 800.0000, 'ºC'),
	(215753, 118, '2014-03-01 00:38:53.000000', 'temperatura', 162.0000, 'ºC'),
	(215754, 118, '2014-03-01 00:38:54.000000', 'temperatura', 811.0000, 'ºC'),
	(215755, 118, '2014-03-01 00:38:55.000000', 'temperatura', 1168.0000, 'ºC'),
	(215756, 118, '2014-03-01 00:38:56.000000', 'temperatura', 1008.0000, 'ºC'),
	(215757, 118, '2014-03-01 00:38:57.000000', 'temperatura', 337.0000, 'ºC'),
	(215758, 118, '2014-03-01 00:38:58.000000', 'temperatura', 1062.0000, 'ºC'),
	(215759, 118, '2014-03-01 00:38:59.000000', 'temperatura', 698.0000, 'ºC'),
	(215760, 118, '2014-03-01 00:39:00.000000', 'temperatura', 304.0000, 'ºC'),
	(215761, 118, '2014-03-01 00:39:01.000000', 'temperatura', 627.0000, 'ºC'),
	(215762, 118, '2014-03-01 00:39:02.000000', 'temperatura', 1023.0000, 'ºC'),
	(215763, 118, '2014-03-01 00:39:03.000000', 'temperatura', 834.0000, 'ºC'),
	(215764, 118, '2014-03-01 00:39:04.000000', 'temperatura', 1102.0000, 'ºC'),
	(215765, 118, '2014-03-01 00:39:05.000000', 'temperatura', 609.0000, 'ºC'),
	(215766, 118, '2014-03-01 00:39:06.000000', 'temperatura', 937.0000, 'ºC'),
	(215767, 118, '2014-03-01 00:39:07.000000', 'temperatura', 462.0000, 'ºC'),
	(215768, 118, '2014-03-01 00:39:08.000000', 'temperatura', 698.0000, 'ºC'),
	(215769, 118, '2014-03-01 00:39:09.000000', 'temperatura', 904.0000, 'ºC'),
	(215770, 118, '2014-03-01 00:39:10.000000', 'temperatura', 29.0000, 'ºC'),
	(215771, 118, '2014-03-01 00:39:11.000000', 'temperatura', 1031.0000, 'ºC'),
	(215772, 118, '2014-03-01 00:39:12.000000', 'temperatura', 271.0000, 'ºC'),
	(215773, 118, '2014-03-01 00:39:13.000000', 'temperatura', 662.0000, 'ºC'),
	(215774, 118, '2014-03-01 00:39:14.000000', 'temperatura', 95.0000, 'ºC'),
	(215775, 118, '2014-03-01 00:39:15.000000', 'temperatura', 893.0000, 'ºC'),
	(215776, 118, '2014-03-01 00:39:16.000000', 'temperatura', 578.0000, 'ºC'),
	(215777, 118, '2014-03-01 00:39:17.000000', 'temperatura', 213.0000, 'ºC'),
	(215778, 118, '2014-03-01 00:39:18.000000', 'temperatura', 533.0000, 'ºC'),
	(215779, 118, '2014-03-01 00:39:19.000000', 'temperatura', 825.0000, 'ºC'),
	(215780, 118, '2014-03-01 00:39:20.000000', 'temperatura', 124.0000, 'ºC'),
	(215781, 118, '2014-03-01 00:39:21.000000', 'temperatura', 549.0000, 'ºC'),
	(215782, 118, '2014-03-01 00:39:22.000000', 'temperatura', 1173.0000, 'ºC'),
	(215783, 118, '2014-03-01 00:39:23.000000', 'temperatura', 617.0000, 'ºC'),
	(215784, 118, '2014-03-01 00:39:24.000000', 'temperatura', 766.0000, 'ºC'),
	(215785, 118, '2014-03-01 00:39:25.000000', 'temperatura', 781.0000, 'ºC'),
	(215786, 118, '2014-03-01 00:39:26.000000', 'temperatura', 406.0000, 'ºC'),
	(215787, 118, '2014-03-01 00:39:27.000000', 'temperatura', 888.0000, 'ºC'),
	(215788, 118, '2014-03-01 00:39:28.000000', 'temperatura', 822.0000, 'ºC'),
	(215789, 118, '2014-03-01 00:39:29.000000', 'temperatura', 246.0000, 'ºC'),
	(215790, 118, '2014-03-01 00:39:30.000000', 'temperatura', 1166.0000, 'ºC'),
	(215791, 118, '2014-03-01 00:39:31.000000', 'temperatura', 293.0000, 'ºC'),
	(215792, 118, '2014-03-01 00:39:32.000000', 'temperatura', 366.0000, 'ºC'),
	(215793, 118, '2014-03-01 00:39:33.000000', 'temperatura', 954.0000, 'ºC'),
	(215794, 118, '2014-03-01 00:39:34.000000', 'temperatura', 69.0000, 'ºC'),
	(215795, 118, '2014-03-01 00:39:35.000000', 'temperatura', 1087.0000, 'ºC'),
	(215796, 118, '2014-03-01 00:39:36.000000', 'temperatura', 426.0000, 'ºC'),
	(215797, 118, '2014-03-01 00:39:37.000000', 'temperatura', 70.0000, 'ºC'),
	(215798, 118, '2014-03-01 00:39:38.000000', 'temperatura', 273.0000, 'ºC'),
	(215799, 118, '2014-03-01 00:39:39.000000', 'temperatura', 1156.0000, 'ºC'),
	(215800, 118, '2014-03-01 00:39:40.000000', 'temperatura', 161.0000, 'ºC'),
	(215801, 118, '2014-03-01 00:39:41.000000', 'temperatura', 939.0000, 'ºC'),
	(215802, 118, '2014-03-01 00:39:42.000000', 'temperatura', 610.0000, 'ºC'),
	(215803, 118, '2014-03-01 00:39:43.000000', 'temperatura', 234.0000, 'ºC'),
	(215804, 118, '2014-03-01 00:39:44.000000', 'temperatura', 543.0000, 'ºC'),
	(215805, 118, '2014-03-01 00:39:45.000000', 'temperatura', 811.0000, 'ºC'),
	(215806, 118, '2014-03-01 00:39:46.000000', 'temperatura', 29.0000, 'ºC'),
	(215807, 118, '2014-03-01 00:39:47.000000', 'temperatura', 111.0000, 'ºC'),
	(215808, 118, '2014-03-01 00:39:48.000000', 'temperatura', 468.0000, 'ºC'),
	(215809, 118, '2014-03-01 00:39:49.000000', 'temperatura', 809.0000, 'ºC'),
	(215810, 118, '2014-03-01 00:39:50.000000', 'temperatura', 243.0000, 'ºC'),
	(215811, 118, '2014-03-01 00:39:51.000000', 'temperatura', 1185.0000, 'ºC'),
	(215812, 118, '2014-03-01 00:39:52.000000', 'temperatura', 399.0000, 'ºC'),
	(215813, 118, '2014-03-01 00:39:53.000000', 'temperatura', 839.0000, 'ºC'),
	(215814, 118, '2014-03-01 00:39:54.000000', 'temperatura', 599.0000, 'ºC'),
	(215815, 118, '2014-03-01 00:39:55.000000', 'temperatura', 479.0000, 'ºC'),
	(215816, 118, '2014-03-01 00:39:56.000000', 'temperatura', 600.0000, 'ºC'),
	(215817, 118, '2014-03-01 00:39:57.000000', 'temperatura', 362.0000, 'ºC'),
	(215818, 118, '2014-03-01 00:39:58.000000', 'temperatura', 12.0000, 'ºC'),
	(215819, 118, '2014-03-01 00:39:59.000000', 'temperatura', 175.0000, 'ºC'),
	(215820, 118, '2014-03-01 00:40:00.000000', 'temperatura', 838.0000, 'ºC'),
	(215821, 118, '2014-03-01 00:40:01.000000', 'temperatura', 66.0000, 'ºC'),
	(215822, 118, '2014-03-01 00:40:02.000000', 'temperatura', 215.0000, 'ºC'),
	(215823, 118, '2014-03-01 00:40:03.000000', 'temperatura', 877.0000, 'ºC'),
	(215824, 118, '2014-03-01 00:40:04.000000', 'temperatura', 141.0000, 'ºC'),
	(215825, 118, '2014-03-01 00:40:05.000000', 'temperatura', 476.0000, 'ºC'),
	(215826, 118, '2014-03-01 00:40:06.000000', 'temperatura', 755.0000, 'ºC'),
	(215827, 118, '2014-03-01 00:40:07.000000', 'temperatura', 1149.0000, 'ºC'),
	(215828, 118, '2014-03-01 00:40:08.000000', 'temperatura', 1079.0000, 'ºC'),
	(215829, 118, '2014-03-01 00:40:09.000000', 'temperatura', 750.0000, 'ºC'),
	(215830, 118, '2014-03-01 00:40:10.000000', 'temperatura', 512.0000, 'ºC'),
	(215831, 118, '2014-03-01 00:40:11.000000', 'temperatura', 311.0000, 'ºC'),
	(215832, 118, '2014-03-01 00:40:12.000000', 'temperatura', 18.0000, 'ºC'),
	(215833, 118, '2014-03-01 00:40:13.000000', 'temperatura', 358.0000, 'ºC'),
	(215834, 118, '2014-03-01 00:40:14.000000', 'temperatura', 539.0000, 'ºC'),
	(215835, 118, '2014-03-01 00:40:15.000000', 'temperatura', 418.0000, 'ºC'),
	(215836, 118, '2014-03-01 00:40:16.000000', 'temperatura', 475.0000, 'ºC'),
	(215837, 118, '2014-03-01 00:40:17.000000', 'temperatura', 1122.0000, 'ºC'),
	(215838, 118, '2014-03-01 00:40:18.000000', 'temperatura', 586.0000, 'ºC'),
	(215839, 118, '2014-03-01 00:40:19.000000', 'temperatura', 765.0000, 'ºC'),
	(215840, 118, '2014-03-01 00:40:20.000000', 'temperatura', 869.0000, 'ºC'),
	(215841, 118, '2014-03-01 00:40:21.000000', 'temperatura', 848.0000, 'ºC'),
	(215842, 118, '2014-03-01 00:40:22.000000', 'temperatura', 432.0000, 'ºC'),
	(215843, 118, '2014-03-01 00:40:23.000000', 'temperatura', 819.0000, 'ºC'),
	(215844, 118, '2014-03-01 00:40:24.000000', 'temperatura', 399.0000, 'ºC'),
	(215845, 118, '2014-03-01 00:40:25.000000', 'temperatura', 738.0000, 'ºC'),
	(215846, 118, '2014-03-01 00:40:26.000000', 'temperatura', 92.0000, 'ºC'),
	(215847, 118, '2014-03-01 00:40:27.000000', 'temperatura', 646.0000, 'ºC'),
	(215848, 118, '2014-03-01 00:40:28.000000', 'temperatura', 556.0000, 'ºC'),
	(215849, 118, '2014-03-01 00:40:29.000000', 'temperatura', 842.0000, 'ºC'),
	(215850, 118, '2014-03-01 00:40:30.000000', 'temperatura', 142.0000, 'ºC'),
	(215851, 118, '2014-03-01 00:40:31.000000', 'temperatura', 586.0000, 'ºC'),
	(215852, 118, '2014-03-01 00:40:32.000000', 'temperatura', 104.0000, 'ºC'),
	(215853, 118, '2014-03-01 00:40:33.000000', 'temperatura', 1162.0000, 'ºC'),
	(215854, 118, '2014-03-01 00:40:34.000000', 'temperatura', 698.0000, 'ºC'),
	(215855, 118, '2014-03-01 00:40:35.000000', 'temperatura', 3.0000, 'ºC'),
	(215856, 118, '2014-03-01 00:40:36.000000', 'temperatura', 323.0000, 'ºC'),
	(215857, 118, '2014-03-01 00:40:37.000000', 'temperatura', 408.0000, 'ºC'),
	(215858, 118, '2014-03-01 00:40:38.000000', 'temperatura', 1071.0000, 'ºC'),
	(215859, 118, '2014-03-01 00:40:39.000000', 'temperatura', 531.0000, 'ºC'),
	(215860, 118, '2014-03-01 00:40:40.000000', 'temperatura', 644.0000, 'ºC'),
	(215861, 118, '2014-03-01 00:40:41.000000', 'temperatura', 427.0000, 'ºC'),
	(215862, 118, '2014-03-01 00:40:42.000000', 'temperatura', 203.0000, 'ºC'),
	(215863, 118, '2014-03-01 00:40:43.000000', 'temperatura', 934.0000, 'ºC'),
	(215864, 118, '2014-03-01 00:40:44.000000', 'temperatura', 462.0000, 'ºC'),
	(215865, 118, '2014-03-01 00:40:45.000000', 'temperatura', 710.0000, 'ºC'),
	(215866, 118, '2014-03-01 00:40:46.000000', 'temperatura', 964.0000, 'ºC'),
	(215867, 118, '2014-03-01 00:40:47.000000', 'temperatura', 291.0000, 'ºC'),
	(215868, 118, '2014-03-01 00:40:48.000000', 'temperatura', 964.0000, 'ºC'),
	(215869, 118, '2014-03-01 00:40:49.000000', 'temperatura', 347.0000, 'ºC'),
	(215870, 118, '2014-03-01 00:40:50.000000', 'temperatura', 44.0000, 'ºC'),
	(215871, 118, '2014-03-01 00:40:51.000000', 'temperatura', 381.0000, 'ºC'),
	(215872, 118, '2014-03-01 00:40:52.000000', 'temperatura', 572.0000, 'ºC'),
	(215873, 118, '2014-03-01 00:40:53.000000', 'temperatura', 519.0000, 'ºC'),
	(215874, 118, '2014-03-01 00:40:54.000000', 'temperatura', 879.0000, 'ºC'),
	(215875, 118, '2014-03-01 00:40:55.000000', 'temperatura', 437.0000, 'ºC'),
	(215876, 118, '2014-03-01 00:40:56.000000', 'temperatura', 748.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(215877, 118, '2014-03-01 00:40:57.000000', 'temperatura', 31.0000, 'ºC'),
	(215878, 118, '2014-03-01 00:40:58.000000', 'temperatura', 310.0000, 'ºC'),
	(215879, 118, '2014-03-01 00:40:59.000000', 'temperatura', 260.0000, 'ºC'),
	(215880, 118, '2014-03-01 00:41:00.000000', 'temperatura', 368.0000, 'ºC'),
	(215881, 118, '2014-03-01 00:41:01.000000', 'temperatura', 1060.0000, 'ºC'),
	(215882, 118, '2014-03-01 00:41:02.000000', 'temperatura', 595.0000, 'ºC'),
	(215883, 118, '2014-03-01 00:41:03.000000', 'temperatura', 999.0000, 'ºC'),
	(215884, 118, '2014-03-01 00:41:04.000000', 'temperatura', 810.0000, 'ºC'),
	(215885, 118, '2014-03-01 00:41:05.000000', 'temperatura', 1052.0000, 'ºC'),
	(215886, 118, '2014-03-01 00:41:06.000000', 'temperatura', 431.0000, 'ºC'),
	(215887, 118, '2014-03-01 00:41:07.000000', 'temperatura', 202.0000, 'ºC'),
	(215888, 118, '2014-03-01 00:41:08.000000', 'temperatura', 914.0000, 'ºC'),
	(215889, 118, '2014-03-01 00:41:09.000000', 'temperatura', 368.0000, 'ºC'),
	(215890, 118, '2014-03-01 00:41:10.000000', 'temperatura', 296.0000, 'ºC'),
	(215891, 118, '2014-03-01 00:41:11.000000', 'temperatura', 378.0000, 'ºC'),
	(215892, 118, '2014-03-01 00:41:12.000000', 'temperatura', 1000.0000, 'ºC'),
	(215893, 118, '2014-03-01 00:41:13.000000', 'temperatura', 268.0000, 'ºC'),
	(215894, 118, '2014-03-01 00:41:14.000000', 'temperatura', 740.0000, 'ºC'),
	(215895, 118, '2014-03-01 00:41:15.000000', 'temperatura', 495.0000, 'ºC'),
	(215896, 118, '2014-03-01 00:41:16.000000', 'temperatura', 258.0000, 'ºC'),
	(215897, 118, '2014-03-01 00:41:17.000000', 'temperatura', 1004.0000, 'ºC'),
	(215898, 118, '2014-03-01 00:41:18.000000', 'temperatura', 647.0000, 'ºC'),
	(215899, 118, '2014-03-01 00:41:19.000000', 'temperatura', 225.0000, 'ºC'),
	(215900, 118, '2014-03-01 00:41:20.000000', 'temperatura', 384.0000, 'ºC'),
	(215901, 118, '2014-03-01 00:41:21.000000', 'temperatura', 44.0000, 'ºC'),
	(215902, 118, '2014-03-01 00:41:22.000000', 'temperatura', 268.0000, 'ºC'),
	(215903, 118, '2014-03-01 00:41:23.000000', 'temperatura', 10.0000, 'ºC'),
	(215904, 118, '2014-03-01 00:41:24.000000', 'temperatura', 444.0000, 'ºC'),
	(215905, 118, '2014-03-01 00:41:25.000000', 'temperatura', 992.0000, 'ºC'),
	(215906, 118, '2014-03-01 00:41:26.000000', 'temperatura', 30.0000, 'ºC'),
	(215907, 118, '2014-03-01 00:41:27.000000', 'temperatura', 775.0000, 'ºC'),
	(215908, 118, '2014-03-01 00:41:28.000000', 'temperatura', 184.0000, 'ºC'),
	(215909, 118, '2014-03-01 00:41:29.000000', 'temperatura', 996.0000, 'ºC'),
	(215910, 118, '2014-03-01 00:41:30.000000', 'temperatura', 829.0000, 'ºC'),
	(215911, 118, '2014-03-01 00:41:31.000000', 'temperatura', 1155.0000, 'ºC'),
	(215912, 118, '2014-03-01 00:41:32.000000', 'temperatura', 891.0000, 'ºC'),
	(215913, 118, '2014-03-01 00:41:33.000000', 'temperatura', 989.0000, 'ºC'),
	(215914, 118, '2014-03-01 00:41:34.000000', 'temperatura', 1073.0000, 'ºC'),
	(215915, 118, '2014-03-01 00:41:35.000000', 'temperatura', 1197.0000, 'ºC'),
	(215916, 118, '2014-03-01 00:41:36.000000', 'temperatura', 367.0000, 'ºC'),
	(215917, 118, '2014-03-01 00:41:37.000000', 'temperatura', 645.0000, 'ºC'),
	(215918, 118, '2014-03-01 00:41:38.000000', 'temperatura', 924.0000, 'ºC'),
	(215919, 118, '2014-03-01 00:41:39.000000', 'temperatura', 288.0000, 'ºC'),
	(215920, 118, '2014-03-01 00:41:40.000000', 'temperatura', 1066.0000, 'ºC'),
	(215921, 118, '2014-03-01 00:41:41.000000', 'temperatura', 869.0000, 'ºC'),
	(215922, 118, '2014-03-01 00:41:42.000000', 'temperatura', 1145.0000, 'ºC'),
	(215923, 118, '2014-03-01 00:41:43.000000', 'temperatura', 718.0000, 'ºC'),
	(215924, 118, '2014-03-01 00:41:44.000000', 'temperatura', 156.0000, 'ºC'),
	(215925, 118, '2014-03-01 00:41:45.000000', 'temperatura', 1026.0000, 'ºC'),
	(215926, 118, '2014-03-01 00:41:46.000000', 'temperatura', 1063.0000, 'ºC'),
	(215927, 118, '2014-03-01 00:41:47.000000', 'temperatura', 1037.0000, 'ºC'),
	(215928, 118, '2014-03-01 00:41:48.000000', 'temperatura', 795.0000, 'ºC'),
	(215929, 118, '2014-03-01 00:41:49.000000', 'temperatura', 866.0000, 'ºC'),
	(215930, 118, '2014-03-01 00:41:50.000000', 'temperatura', 745.0000, 'ºC'),
	(215931, 118, '2014-03-01 00:41:51.000000', 'temperatura', 1127.0000, 'ºC'),
	(215932, 118, '2014-03-01 00:41:52.000000', 'temperatura', 1002.0000, 'ºC'),
	(215933, 118, '2014-03-01 00:41:53.000000', 'temperatura', 427.0000, 'ºC'),
	(215934, 118, '2014-03-01 00:41:54.000000', 'temperatura', 332.0000, 'ºC'),
	(215935, 118, '2014-03-01 00:41:55.000000', 'temperatura', 380.0000, 'ºC'),
	(215936, 118, '2014-03-01 00:41:56.000000', 'temperatura', 904.0000, 'ºC'),
	(215937, 118, '2014-03-01 00:41:57.000000', 'temperatura', 981.0000, 'ºC'),
	(215938, 118, '2014-03-01 00:41:58.000000', 'temperatura', 992.0000, 'ºC'),
	(215939, 118, '2014-03-01 00:41:59.000000', 'temperatura', 818.0000, 'ºC'),
	(215940, 118, '2014-03-01 00:42:00.000000', 'temperatura', 1115.0000, 'ºC'),
	(215941, 118, '2014-03-01 00:42:01.000000', 'temperatura', 719.0000, 'ºC'),
	(215942, 118, '2014-03-01 00:42:02.000000', 'temperatura', 253.0000, 'ºC'),
	(215943, 118, '2014-03-01 00:42:03.000000', 'temperatura', 310.0000, 'ºC'),
	(215944, 118, '2014-03-01 00:42:04.000000', 'temperatura', 790.0000, 'ºC'),
	(215945, 118, '2014-03-01 00:42:05.000000', 'temperatura', 620.0000, 'ºC'),
	(215946, 118, '2014-03-01 00:42:06.000000', 'temperatura', 730.0000, 'ºC'),
	(215947, 118, '2014-03-01 00:42:07.000000', 'temperatura', 591.0000, 'ºC'),
	(215948, 118, '2014-03-01 00:42:08.000000', 'temperatura', 764.0000, 'ºC'),
	(215949, 118, '2014-03-01 00:42:09.000000', 'temperatura', 848.0000, 'ºC'),
	(215950, 118, '2014-03-01 00:42:10.000000', 'temperatura', 751.0000, 'ºC'),
	(215951, 118, '2014-03-01 00:42:11.000000', 'temperatura', 9.0000, 'ºC'),
	(215952, 118, '2014-03-01 00:42:12.000000', 'temperatura', 193.0000, 'ºC'),
	(215953, 118, '2014-03-01 00:42:13.000000', 'temperatura', 938.0000, 'ºC'),
	(215954, 118, '2014-03-01 00:42:14.000000', 'temperatura', 511.0000, 'ºC'),
	(215955, 118, '2014-03-01 00:42:15.000000', 'temperatura', 941.0000, 'ºC'),
	(215956, 118, '2014-03-01 00:42:16.000000', 'temperatura', 775.0000, 'ºC'),
	(215957, 118, '2014-03-01 00:42:17.000000', 'temperatura', 1051.0000, 'ºC'),
	(215958, 118, '2014-03-01 00:42:18.000000', 'temperatura', 530.0000, 'ºC'),
	(215959, 118, '2014-03-01 00:42:19.000000', 'temperatura', 696.0000, 'ºC'),
	(215960, 118, '2014-03-01 00:42:20.000000', 'temperatura', 693.0000, 'ºC'),
	(215961, 118, '2014-03-01 00:42:21.000000', 'temperatura', 178.0000, 'ºC'),
	(215962, 118, '2014-03-01 00:42:22.000000', 'temperatura', 10.0000, 'ºC'),
	(215963, 118, '2014-03-01 00:42:23.000000', 'temperatura', 715.0000, 'ºC'),
	(215964, 118, '2014-03-01 00:42:24.000000', 'temperatura', 1149.0000, 'ºC'),
	(215965, 118, '2014-03-01 00:42:25.000000', 'temperatura', 1198.0000, 'ºC'),
	(215966, 118, '2014-03-01 00:42:26.000000', 'temperatura', 145.0000, 'ºC'),
	(215967, 118, '2014-03-01 00:42:27.000000', 'temperatura', 733.0000, 'ºC'),
	(215968, 118, '2014-03-01 00:42:28.000000', 'temperatura', 828.0000, 'ºC'),
	(215969, 118, '2014-03-01 00:42:29.000000', 'temperatura', 742.0000, 'ºC'),
	(215970, 118, '2014-03-01 00:42:30.000000', 'temperatura', 26.0000, 'ºC'),
	(215971, 118, '2014-03-01 00:42:31.000000', 'temperatura', 304.0000, 'ºC'),
	(215972, 118, '2014-03-01 00:42:32.000000', 'temperatura', 244.0000, 'ºC'),
	(215973, 118, '2014-03-01 00:42:33.000000', 'temperatura', 310.0000, 'ºC'),
	(215974, 118, '2014-03-01 00:42:34.000000', 'temperatura', 816.0000, 'ºC'),
	(215975, 118, '2014-03-01 00:42:35.000000', 'temperatura', 752.0000, 'ºC'),
	(215976, 118, '2014-03-01 00:42:36.000000', 'temperatura', 113.0000, 'ºC'),
	(215977, 118, '2014-03-01 00:42:37.000000', 'temperatura', 709.0000, 'ºC'),
	(215978, 118, '2014-03-01 00:42:38.000000', 'temperatura', 807.0000, 'ºC'),
	(215979, 118, '2014-03-01 00:42:39.000000', 'temperatura', 709.0000, 'ºC'),
	(215980, 118, '2014-03-01 00:42:40.000000', 'temperatura', 1123.0000, 'ºC'),
	(215981, 118, '2014-03-01 00:42:41.000000', 'temperatura', 1091.0000, 'ºC'),
	(215982, 118, '2014-03-01 00:42:42.000000', 'temperatura', 883.0000, 'ºC'),
	(215983, 118, '2014-03-01 00:42:43.000000', 'temperatura', 1145.0000, 'ºC'),
	(215984, 118, '2014-03-01 00:42:44.000000', 'temperatura', 676.0000, 'ºC'),
	(215985, 118, '2014-03-01 00:42:45.000000', 'temperatura', 1147.0000, 'ºC'),
	(215986, 118, '2014-03-01 00:42:46.000000', 'temperatura', 107.0000, 'ºC'),
	(215987, 118, '2014-03-01 00:42:47.000000', 'temperatura', 695.0000, 'ºC'),
	(215988, 118, '2014-03-01 00:42:48.000000', 'temperatura', 756.0000, 'ºC'),
	(215989, 118, '2014-03-01 00:42:49.000000', 'temperatura', 492.0000, 'ºC'),
	(215990, 118, '2014-03-01 00:42:50.000000', 'temperatura', 196.0000, 'ºC'),
	(215991, 118, '2014-03-01 00:42:51.000000', 'temperatura', 703.0000, 'ºC'),
	(215992, 118, '2014-03-01 00:42:52.000000', 'temperatura', 527.0000, 'ºC'),
	(215993, 118, '2014-03-01 00:42:53.000000', 'temperatura', 525.0000, 'ºC'),
	(215994, 118, '2014-03-01 00:42:54.000000', 'temperatura', 1045.0000, 'ºC'),
	(215995, 118, '2014-03-01 00:42:55.000000', 'temperatura', 51.0000, 'ºC'),
	(215996, 118, '2014-03-01 00:42:56.000000', 'temperatura', 721.0000, 'ºC'),
	(215997, 118, '2014-03-01 00:42:57.000000', 'temperatura', 1054.0000, 'ºC'),
	(215998, 118, '2014-03-01 00:42:58.000000', 'temperatura', 707.0000, 'ºC'),
	(215999, 118, '2014-03-01 00:42:59.000000', 'temperatura', 374.0000, 'ºC'),
	(216000, 118, '2014-03-01 00:43:00.000000', 'temperatura', 947.0000, 'ºC'),
	(216001, 118, '2014-03-01 00:43:01.000000', 'temperatura', 15.0000, 'ºC'),
	(216002, 118, '2014-03-01 00:43:02.000000', 'temperatura', 836.0000, 'ºC'),
	(216003, 118, '2014-03-01 00:43:03.000000', 'temperatura', 532.0000, 'ºC'),
	(216004, 118, '2014-03-01 00:43:04.000000', 'temperatura', 156.0000, 'ºC'),
	(216005, 118, '2014-03-01 00:43:05.000000', 'temperatura', 382.0000, 'ºC'),
	(216006, 118, '2014-03-01 00:43:06.000000', 'temperatura', 243.0000, 'ºC'),
	(216007, 118, '2014-03-01 00:43:07.000000', 'temperatura', 71.0000, 'ºC'),
	(216008, 118, '2014-03-01 00:43:08.000000', 'temperatura', 826.0000, 'ºC'),
	(216009, 118, '2014-03-01 00:43:09.000000', 'temperatura', 319.0000, 'ºC'),
	(216010, 118, '2014-03-01 00:43:10.000000', 'temperatura', 316.0000, 'ºC'),
	(216011, 118, '2014-03-01 00:43:11.000000', 'temperatura', 624.0000, 'ºC'),
	(216012, 118, '2014-03-01 00:43:12.000000', 'temperatura', 971.0000, 'ºC'),
	(216013, 118, '2014-03-01 00:43:13.000000', 'temperatura', 584.0000, 'ºC'),
	(216014, 118, '2014-03-01 00:43:14.000000', 'temperatura', 6.0000, 'ºC'),
	(216015, 118, '2014-03-01 00:43:15.000000', 'temperatura', 680.0000, 'ºC'),
	(216016, 118, '2014-03-01 00:43:16.000000', 'temperatura', 984.0000, 'ºC'),
	(216017, 118, '2014-03-01 00:43:17.000000', 'temperatura', 480.0000, 'ºC'),
	(216018, 118, '2014-03-01 00:43:18.000000', 'temperatura', 647.0000, 'ºC'),
	(216019, 118, '2014-03-01 00:43:19.000000', 'temperatura', 597.0000, 'ºC'),
	(216020, 118, '2014-03-01 00:43:20.000000', 'temperatura', 1044.0000, 'ºC'),
	(216021, 118, '2014-03-01 00:43:21.000000', 'temperatura', 1027.0000, 'ºC'),
	(216022, 118, '2014-03-01 00:43:22.000000', 'temperatura', 807.0000, 'ºC'),
	(216023, 118, '2014-03-01 00:43:23.000000', 'temperatura', 955.0000, 'ºC'),
	(216024, 118, '2014-03-01 00:43:24.000000', 'temperatura', 1152.0000, 'ºC'),
	(216025, 118, '2014-03-01 00:43:25.000000', 'temperatura', 495.0000, 'ºC'),
	(216026, 118, '2014-03-01 00:43:26.000000', 'temperatura', 219.0000, 'ºC'),
	(216027, 118, '2014-03-01 00:43:27.000000', 'temperatura', 810.0000, 'ºC'),
	(216028, 118, '2014-03-01 00:43:28.000000', 'temperatura', 995.0000, 'ºC'),
	(216029, 118, '2014-03-01 00:43:29.000000', 'temperatura', 146.0000, 'ºC'),
	(216030, 118, '2014-03-01 00:43:30.000000', 'temperatura', 146.0000, 'ºC'),
	(216031, 118, '2014-03-01 00:43:31.000000', 'temperatura', 292.0000, 'ºC'),
	(216032, 118, '2014-03-01 00:43:32.000000', 'temperatura', 1022.0000, 'ºC'),
	(216033, 118, '2014-03-01 00:43:33.000000', 'temperatura', 633.0000, 'ºC'),
	(216034, 118, '2014-03-01 00:43:34.000000', 'temperatura', 101.0000, 'ºC'),
	(216035, 118, '2014-03-01 00:43:35.000000', 'temperatura', 1008.0000, 'ºC'),
	(216036, 118, '2014-03-01 00:43:36.000000', 'temperatura', 1136.0000, 'ºC'),
	(216037, 118, '2014-03-01 00:43:37.000000', 'temperatura', 258.0000, 'ºC'),
	(216038, 118, '2014-03-01 00:43:38.000000', 'temperatura', 283.0000, 'ºC'),
	(216039, 118, '2014-03-01 00:43:39.000000', 'temperatura', 638.0000, 'ºC'),
	(216040, 118, '2014-03-01 00:43:40.000000', 'temperatura', 1145.0000, 'ºC'),
	(216041, 118, '2014-03-01 00:43:41.000000', 'temperatura', 212.0000, 'ºC'),
	(216042, 118, '2014-03-01 00:43:42.000000', 'temperatura', 24.0000, 'ºC'),
	(216043, 118, '2014-03-01 00:43:43.000000', 'temperatura', 685.0000, 'ºC'),
	(216044, 118, '2014-03-01 00:43:44.000000', 'temperatura', 951.0000, 'ºC'),
	(216045, 118, '2014-03-01 00:43:45.000000', 'temperatura', 304.0000, 'ºC'),
	(216046, 118, '2014-03-01 00:43:46.000000', 'temperatura', 1066.0000, 'ºC'),
	(216047, 118, '2014-03-01 00:43:47.000000', 'temperatura', 819.0000, 'ºC'),
	(216048, 118, '2014-03-01 00:43:48.000000', 'temperatura', 897.0000, 'ºC'),
	(216049, 118, '2014-03-01 00:43:49.000000', 'temperatura', 830.0000, 'ºC'),
	(216050, 118, '2014-03-01 00:43:50.000000', 'temperatura', 257.0000, 'ºC'),
	(216051, 118, '2014-03-01 00:43:51.000000', 'temperatura', 1195.0000, 'ºC'),
	(216052, 118, '2014-03-01 00:43:52.000000', 'temperatura', 406.0000, 'ºC'),
	(216053, 118, '2014-03-01 00:43:53.000000', 'temperatura', 845.0000, 'ºC'),
	(216054, 118, '2014-03-01 00:43:54.000000', 'temperatura', 606.0000, 'ºC'),
	(216055, 118, '2014-03-01 00:43:55.000000', 'temperatura', 499.0000, 'ºC'),
	(216056, 118, '2014-03-01 00:43:56.000000', 'temperatura', 675.0000, 'ºC'),
	(216057, 118, '2014-03-01 00:43:57.000000', 'temperatura', 677.0000, 'ºC'),
	(216058, 118, '2014-03-01 00:43:58.000000', 'temperatura', 164.0000, 'ºC'),
	(216059, 118, '2014-03-01 00:43:59.000000', 'temperatura', 1188.0000, 'ºC'),
	(216060, 118, '2014-03-01 00:44:00.000000', 'temperatura', 651.0000, 'ºC'),
	(216061, 118, '2014-03-01 00:44:01.000000', 'temperatura', 888.0000, 'ºC'),
	(216062, 118, '2014-03-01 00:44:02.000000', 'temperatura', 91.0000, 'ºC'),
	(216063, 118, '2014-03-01 00:44:03.000000', 'temperatura', 189.0000, 'ºC'),
	(216064, 118, '2014-03-01 00:44:04.000000', 'temperatura', 674.0000, 'ºC'),
	(216065, 118, '2014-03-01 00:44:05.000000', 'temperatura', 404.0000, 'ºC'),
	(216066, 118, '2014-03-01 00:44:06.000000', 'temperatura', 1199.0000, 'ºC'),
	(216067, 118, '2014-03-01 00:44:07.000000', 'temperatura', 1181.0000, 'ºC'),
	(216068, 118, '2014-03-01 00:44:08.000000', 'temperatura', 1109.0000, 'ºC'),
	(216069, 118, '2014-03-01 00:44:09.000000', 'temperatura', 804.0000, 'ºC'),
	(216070, 118, '2014-03-01 00:44:10.000000', 'temperatura', 692.0000, 'ºC'),
	(216071, 118, '2014-03-01 00:44:11.000000', 'temperatura', 1049.0000, 'ºC'),
	(216072, 118, '2014-03-01 00:44:12.000000', 'temperatura', 769.0000, 'ºC'),
	(216073, 118, '2014-03-01 00:44:13.000000', 'temperatura', 698.0000, 'ºC'),
	(216074, 118, '2014-03-01 00:44:14.000000', 'temperatura', 1184.0000, 'ºC'),
	(216075, 118, '2014-03-01 00:44:15.000000', 'temperatura', 226.0000, 'ºC'),
	(216076, 118, '2014-03-01 00:44:16.000000', 'temperatura', 1179.0000, 'ºC'),
	(216077, 118, '2014-03-01 00:44:17.000000', 'temperatura', 419.0000, 'ºC'),
	(216078, 118, '2014-03-01 00:44:18.000000', 'temperatura', 957.0000, 'ºC'),
	(216079, 118, '2014-03-01 00:44:19.000000', 'temperatura', 1131.0000, 'ºC'),
	(216080, 118, '2014-03-01 00:44:20.000000', 'temperatura', 383.0000, 'ºC'),
	(216081, 118, '2014-03-01 00:44:21.000000', 'temperatura', 920.0000, 'ºC'),
	(216082, 118, '2014-03-01 00:44:22.000000', 'temperatura', 1055.0000, 'ºC'),
	(216083, 118, '2014-03-01 00:44:23.000000', 'temperatura', 115.0000, 'ºC'),
	(216084, 118, '2014-03-01 00:44:24.000000', 'temperatura', 1008.0000, 'ºC'),
	(216085, 118, '2014-03-01 00:44:25.000000', 'temperatura', 1098.0000, 'ºC'),
	(216086, 118, '2014-03-01 00:44:26.000000', 'temperatura', 65.0000, 'ºC'),
	(216087, 118, '2014-03-01 00:44:27.000000', 'temperatura', 632.0000, 'ºC'),
	(216088, 118, '2014-03-01 00:44:28.000000', 'temperatura', 567.0000, 'ºC'),
	(216089, 118, '2014-03-01 00:44:29.000000', 'temperatura', 938.0000, 'ºC'),
	(216090, 118, '2014-03-01 00:44:30.000000', 'temperatura', 591.0000, 'ºC'),
	(216091, 118, '2014-03-01 00:44:31.000000', 'temperatura', 141.0000, 'ºC'),
	(216092, 118, '2014-03-01 00:44:32.000000', 'temperatura', 133.0000, 'ºC'),
	(216093, 118, '2014-03-01 00:44:33.000000', 'temperatura', 243.0000, 'ºC'),
	(216094, 118, '2014-03-01 00:44:34.000000', 'temperatura', 816.0000, 'ºC'),
	(216095, 118, '2014-03-01 00:44:35.000000', 'temperatura', 949.0000, 'ºC'),
	(216096, 118, '2014-03-01 00:44:36.000000', 'temperatura', 1100.0000, 'ºC'),
	(216097, 118, '2014-03-01 00:44:37.000000', 'temperatura', 253.0000, 'ºC'),
	(216098, 118, '2014-03-01 00:44:38.000000', 'temperatura', 367.0000, 'ºC'),
	(216099, 118, '2014-03-01 00:44:39.000000', 'temperatura', 1076.0000, 'ºC'),
	(216100, 118, '2014-03-01 00:44:40.000000', 'temperatura', 678.0000, 'ºC'),
	(216101, 118, '2014-03-01 00:44:41.000000', 'temperatura', 165.0000, 'ºC'),
	(216102, 118, '2014-03-01 00:44:42.000000', 'temperatura', 1189.0000, 'ºC'),
	(216103, 118, '2014-03-01 00:44:43.000000', 'temperatura', 649.0000, 'ºC'),
	(216104, 118, '2014-03-01 00:44:44.000000', 'temperatura', 881.0000, 'ºC'),
	(216105, 118, '2014-03-01 00:44:45.000000', 'temperatura', 59.0000, 'ºC'),
	(216106, 118, '2014-03-01 00:44:46.000000', 'temperatura', 52.0000, 'ºC'),
	(216107, 118, '2014-03-01 00:44:47.000000', 'temperatura', 83.0000, 'ºC'),
	(216108, 118, '2014-03-01 00:44:48.000000', 'temperatura', 261.0000, 'ºC'),
	(216109, 118, '2014-03-01 00:44:49.000000', 'temperatura', 1056.0000, 'ºC'),
	(216110, 118, '2014-03-01 00:44:50.000000', 'temperatura', 898.0000, 'ºC'),
	(216111, 118, '2014-03-01 00:44:51.000000', 'temperatura', 121.0000, 'ºC'),
	(216112, 118, '2014-03-01 00:44:52.000000', 'temperatura', 312.0000, 'ºC'),
	(216113, 118, '2014-03-01 00:44:53.000000', 'temperatura', 1196.0000, 'ºC'),
	(216114, 118, '2014-03-01 00:44:54.000000', 'temperatura', 246.0000, 'ºC'),
	(216115, 118, '2014-03-01 00:44:55.000000', 'temperatura', 41.0000, 'ºC'),
	(216116, 118, '2014-03-01 00:44:56.000000', 'temperatura', 670.0000, 'ºC'),
	(216117, 118, '2014-03-01 00:44:57.000000', 'temperatura', 827.0000, 'ºC'),
	(216118, 118, '2014-03-01 00:44:58.000000', 'temperatura', 923.0000, 'ºC'),
	(216119, 118, '2014-03-01 00:44:59.000000', 'temperatura', 936.0000, 'ºC'),
	(216120, 118, '2014-03-01 00:45:00.000000', 'temperatura', 712.0000, 'ºC'),
	(216121, 118, '2014-03-01 00:45:01.000000', 'temperatura', 754.0000, 'ºC'),
	(216122, 118, '2014-03-01 00:45:02.000000', 'temperatura', 431.0000, 'ºC'),
	(216123, 118, '2014-03-01 00:45:03.000000', 'temperatura', 1096.0000, 'ºC'),
	(216124, 118, '2014-03-01 00:45:04.000000', 'temperatura', 586.0000, 'ºC'),
	(216125, 118, '2014-03-01 00:45:05.000000', 'temperatura', 842.0000, 'ºC'),
	(216126, 118, '2014-03-01 00:45:06.000000', 'temperatura', 52.0000, 'ºC'),
	(216127, 118, '2014-03-01 00:45:07.000000', 'temperatura', 134.0000, 'ºC'),
	(216128, 118, '2014-03-01 00:45:08.000000', 'temperatura', 516.0000, 'ºC'),
	(216129, 118, '2014-03-01 00:45:09.000000', 'temperatura', 979.0000, 'ºC'),
	(216130, 118, '2014-03-01 00:45:10.000000', 'temperatura', 946.0000, 'ºC'),
	(216131, 118, '2014-03-01 00:45:11.000000', 'temperatura', 595.0000, 'ºC'),
	(216132, 118, '2014-03-01 00:45:12.000000', 'temperatura', 135.0000, 'ºC'),
	(216133, 118, '2014-03-01 00:45:13.000000', 'temperatura', 94.0000, 'ºC'),
	(216134, 118, '2014-03-01 00:45:14.000000', 'temperatura', 63.0000, 'ºC'),
	(216135, 118, '2014-03-01 00:45:15.000000', 'temperatura', 32.0000, 'ºC'),
	(216136, 118, '2014-03-01 00:45:16.000000', 'temperatura', 1175.0000, 'ºC'),
	(216137, 118, '2014-03-01 00:45:17.000000', 'temperatura', 976.0000, 'ºC'),
	(216138, 118, '2014-03-01 00:45:18.000000', 'temperatura', 157.0000, 'ºC'),
	(216139, 118, '2014-03-01 00:45:19.000000', 'temperatura', 259.0000, 'ºC'),
	(216140, 118, '2014-03-01 00:45:20.000000', 'temperatura', 824.0000, 'ºC'),
	(216141, 118, '2014-03-01 00:45:21.000000', 'temperatura', 941.0000, 'ºC'),
	(216142, 118, '2014-03-01 00:45:22.000000', 'temperatura', 1036.0000, 'ºC'),
	(216143, 118, '2014-03-01 00:45:23.000000', 'temperatura', 1155.0000, 'ºC'),
	(216144, 118, '2014-03-01 00:45:24.000000', 'temperatura', 270.0000, 'ºC'),
	(216145, 118, '2014-03-01 00:45:25.000000', 'temperatura', 284.0000, 'ºC'),
	(216146, 118, '2014-03-01 00:45:26.000000', 'temperatura', 611.0000, 'ºC'),
	(216147, 118, '2014-03-01 00:45:27.000000', 'temperatura', 1006.0000, 'ºC'),
	(216148, 118, '2014-03-01 00:45:28.000000', 'temperatura', 794.0000, 'ºC'),
	(216149, 118, '2014-03-01 00:45:29.000000', 'temperatura', 953.0000, 'ºC'),
	(216150, 118, '2014-03-01 00:45:30.000000', 'temperatura', 1185.0000, 'ºC'),
	(216151, 118, '2014-03-01 00:45:31.000000', 'temperatura', 664.0000, 'ºC'),
	(216152, 118, '2014-03-01 00:45:32.000000', 'temperatura', 968.0000, 'ºC'),
	(216153, 118, '2014-03-01 00:45:33.000000', 'temperatura', 446.0000, 'ºC'),
	(216154, 118, '2014-03-01 00:45:34.000000', 'temperatura', 526.0000, 'ºC'),
	(216155, 118, '2014-03-01 00:45:35.000000', 'temperatura', 92.0000, 'ºC'),
	(216156, 118, '2014-03-01 00:45:36.000000', 'temperatura', 83.0000, 'ºC'),
	(216157, 118, '2014-03-01 00:45:37.000000', 'temperatura', 141.0000, 'ºC'),
	(216158, 118, '2014-03-01 00:45:38.000000', 'temperatura', 457.0000, 'ºC'),
	(216159, 118, '2014-03-01 00:45:39.000000', 'temperatura', 662.0000, 'ºC'),
	(216160, 118, '2014-03-01 00:45:40.000000', 'temperatura', 737.0000, 'ºC'),
	(216161, 118, '2014-03-01 00:45:41.000000', 'temperatura', 503.0000, 'ºC'),
	(216162, 118, '2014-03-01 00:45:42.000000', 'temperatura', 303.0000, 'ºC'),
	(216163, 118, '2014-03-01 00:45:43.000000', 'temperatura', 6.0000, 'ºC'),
	(216164, 118, '2014-03-01 00:45:44.000000', 'temperatura', 324.0000, 'ºC'),
	(216165, 118, '2014-03-01 00:45:45.000000', 'temperatura', 400.0000, 'ºC'),
	(216166, 118, '2014-03-01 00:45:46.000000', 'temperatura', 1029.0000, 'ºC'),
	(216167, 118, '2014-03-01 00:45:47.000000', 'temperatura', 344.0000, 'ºC'),
	(216168, 118, '2014-03-01 00:45:48.000000', 'temperatura', 1036.0000, 'ºC'),
	(216169, 118, '2014-03-01 00:45:49.000000', 'temperatura', 546.0000, 'ºC'),
	(216170, 118, '2014-03-01 00:45:50.000000', 'temperatura', 826.0000, 'ºC'),
	(216171, 118, '2014-03-01 00:45:51.000000', 'temperatura', 89.0000, 'ºC'),
	(216172, 118, '2014-03-01 00:45:52.000000', 'temperatura', 368.0000, 'ºC'),
	(216173, 118, '2014-03-01 00:45:53.000000', 'temperatura', 374.0000, 'ºC'),
	(216174, 118, '2014-03-01 00:45:54.000000', 'temperatura', 767.0000, 'ºC'),
	(216175, 118, '2014-03-01 00:45:55.000000', 'temperatura', 312.0000, 'ºC'),
	(216176, 118, '2014-03-01 00:45:56.000000', 'temperatura', 459.0000, 'ºC'),
	(216177, 118, '2014-03-01 00:45:57.000000', 'temperatura', 161.0000, 'ºC'),
	(216178, 118, '2014-03-01 00:45:58.000000', 'temperatura', 628.0000, 'ºC'),
	(216179, 118, '2014-03-01 00:45:59.000000', 'temperatura', 256.0000, 'ºC'),
	(216180, 118, '2014-03-01 00:46:00.000000', 'temperatura', 599.0000, 'ºC'),
	(216181, 118, '2014-03-01 00:46:01.000000', 'temperatura', 1026.0000, 'ºC'),
	(216182, 118, '2014-03-01 00:46:02.000000', 'temperatura', 934.0000, 'ºC'),
	(216183, 118, '2014-03-01 00:46:03.000000', 'temperatura', 391.0000, 'ºC'),
	(216184, 118, '2014-03-01 00:46:04.000000', 'temperatura', 354.0000, 'ºC'),
	(216185, 118, '2014-03-01 00:46:05.000000', 'temperatura', 599.0000, 'ºC'),
	(216186, 118, '2014-03-01 00:46:06.000000', 'temperatura', 732.0000, 'ºC'),
	(216187, 118, '2014-03-01 00:46:07.000000', 'temperatura', 664.0000, 'ºC'),
	(216188, 118, '2014-03-01 00:46:08.000000', 'temperatura', 1123.0000, 'ºC'),
	(216189, 118, '2014-03-01 00:46:09.000000', 'temperatura', 27.0000, 'ºC'),
	(216190, 118, '2014-03-01 00:46:10.000000', 'temperatura', 363.0000, 'ºC'),
	(216191, 118, '2014-03-01 00:46:11.000000', 'temperatura', 535.0000, 'ºC'),
	(216192, 118, '2014-03-01 00:46:12.000000', 'temperatura', 386.0000, 'ºC'),
	(216193, 118, '2014-03-01 00:46:13.000000', 'temperatura', 327.0000, 'ºC'),
	(216194, 118, '2014-03-01 00:46:14.000000', 'temperatura', 477.0000, 'ºC'),
	(216195, 118, '2014-03-01 00:46:15.000000', 'temperatura', 206.0000, 'ºC'),
	(216196, 118, '2014-03-01 00:46:16.000000', 'temperatura', 796.0000, 'ºC'),
	(216197, 118, '2014-03-01 00:46:17.000000', 'temperatura', 966.0000, 'ºC'),
	(216198, 118, '2014-03-01 00:46:18.000000', 'temperatura', 43.0000, 'ºC'),
	(216199, 118, '2014-03-01 00:46:19.000000', 'temperatura', 915.0000, 'ºC'),
	(216200, 118, '2014-03-01 00:46:20.000000', 'temperatura', 848.0000, 'ºC'),
	(216201, 118, '2014-03-01 00:46:21.000000', 'temperatura', 294.0000, 'ºC'),
	(216202, 118, '2014-03-01 00:46:22.000000', 'temperatura', 128.0000, 'ºC'),
	(216203, 118, '2014-03-01 00:46:23.000000', 'temperatura', 958.0000, 'ºC'),
	(216204, 118, '2014-03-01 00:46:24.000000', 'temperatura', 807.0000, 'ºC'),
	(216205, 118, '2014-03-01 00:46:25.000000', 'temperatura', 1162.0000, 'ºC'),
	(216206, 118, '2014-03-01 00:46:26.000000', 'temperatura', 988.0000, 'ºC'),
	(216207, 118, '2014-03-01 00:46:27.000000', 'temperatura', 256.0000, 'ºC'),
	(216208, 118, '2014-03-01 00:46:28.000000', 'temperatura', 717.0000, 'ºC'),
	(216209, 118, '2014-03-01 00:46:29.000000', 'temperatura', 418.0000, 'ºC'),
	(216210, 118, '2014-03-01 00:46:30.000000', 'temperatura', 1139.0000, 'ºC'),
	(216211, 118, '2014-03-01 00:46:31.000000', 'temperatura', 840.0000, 'ºC'),
	(216212, 118, '2014-03-01 00:46:32.000000', 'temperatura', 784.0000, 'ºC'),
	(216213, 118, '2014-03-01 00:46:33.000000', 'temperatura', 201.0000, 'ºC'),
	(216214, 118, '2014-03-01 00:46:34.000000', 'temperatura', 1052.0000, 'ºC'),
	(216215, 118, '2014-03-01 00:46:35.000000', 'temperatura', 1059.0000, 'ºC'),
	(216216, 118, '2014-03-01 00:46:36.000000', 'temperatura', 940.0000, 'ºC'),
	(216217, 118, '2014-03-01 00:46:37.000000', 'temperatura', 322.0000, 'ºC'),
	(216218, 118, '2014-03-01 00:46:38.000000', 'temperatura', 1189.0000, 'ºC'),
	(216219, 118, '2014-03-01 00:46:39.000000', 'temperatura', 182.0000, 'ºC'),
	(216220, 118, '2014-03-01 00:46:40.000000', 'temperatura', 942.0000, 'ºC'),
	(216221, 118, '2014-03-01 00:46:41.000000', 'temperatura', 564.0000, 'ºC'),
	(216222, 118, '2014-03-01 00:46:42.000000', 'temperatura', 1194.0000, 'ºC'),
	(216223, 118, '2014-03-01 00:46:43.000000', 'temperatura', 681.0000, 'ºC'),
	(216224, 118, '2014-03-01 00:46:44.000000', 'temperatura', 1022.0000, 'ºC'),
	(216225, 118, '2014-03-01 00:46:45.000000', 'temperatura', 668.0000, 'ºC'),
	(216226, 118, '2014-03-01 00:46:46.000000', 'temperatura', 274.0000, 'ºC'),
	(216227, 118, '2014-03-01 00:46:47.000000', 'temperatura', 568.0000, 'ºC'),
	(216228, 118, '2014-03-01 00:46:48.000000', 'temperatura', 818.0000, 'ºC'),
	(216229, 118, '2014-03-01 00:46:49.000000', 'temperatura', 1188.0000, 'ºC'),
	(216230, 118, '2014-03-01 00:46:50.000000', 'temperatura', 1086.0000, 'ºC'),
	(216231, 118, '2014-03-01 00:46:51.000000', 'temperatura', 665.0000, 'ºC'),
	(216232, 118, '2014-03-01 00:46:52.000000', 'temperatura', 69.0000, 'ºC'),
	(216233, 118, '2014-03-01 00:46:53.000000', 'temperatura', 752.0000, 'ºC'),
	(216234, 118, '2014-03-01 00:46:54.000000', 'temperatura', 1152.0000, 'ºC'),
	(216235, 118, '2014-03-01 00:46:55.000000', 'temperatura', 1104.0000, 'ºC'),
	(216236, 118, '2014-03-01 00:46:56.000000', 'temperatura', 867.0000, 'ºC'),
	(216237, 118, '2014-03-01 00:46:57.000000', 'temperatura', 1021.0000, 'ºC'),
	(216238, 118, '2014-03-01 00:46:58.000000', 'temperatura', 107.0000, 'ºC'),
	(216239, 118, '2014-03-01 00:46:59.000000', 'temperatura', 1072.0000, 'ºC'),
	(216240, 118, '2014-03-01 00:47:00.000000', 'temperatura', 238.0000, 'ºC'),
	(216241, 118, '2014-03-01 00:47:01.000000', 'temperatura', 376.0000, 'ºC'),
	(216242, 118, '2014-03-01 00:47:02.000000', 'temperatura', 1167.0000, 'ºC'),
	(216243, 118, '2014-03-01 00:47:03.000000', 'temperatura', 1108.0000, 'ºC'),
	(216244, 118, '2014-03-01 00:47:04.000000', 'temperatura', 840.0000, 'ºC'),
	(216245, 118, '2014-03-01 00:47:05.000000', 'temperatura', 874.0000, 'ºC'),
	(216246, 118, '2014-03-01 00:47:06.000000', 'temperatura', 650.0000, 'ºC'),
	(216247, 118, '2014-03-01 00:47:07.000000', 'temperatura', 629.0000, 'ºC'),
	(216248, 118, '2014-03-01 00:47:08.000000', 'temperatura', 1197.0000, 'ºC'),
	(216249, 118, '2014-03-01 00:47:09.000000', 'temperatura', 498.0000, 'ºC'),
	(216250, 118, '2014-03-01 00:47:10.000000', 'temperatura', 100.0000, 'ºC'),
	(216251, 118, '2014-03-01 00:47:11.000000', 'temperatura', 205.0000, 'ºC'),
	(216252, 118, '2014-03-01 00:47:12.000000', 'temperatura', 725.0000, 'ºC'),
	(216253, 118, '2014-03-01 00:47:13.000000', 'temperatura', 612.0000, 'ºC'),
	(216254, 118, '2014-03-01 00:47:14.000000', 'temperatura', 883.0000, 'ºC'),
	(216255, 118, '2014-03-01 00:47:15.000000', 'temperatura', 182.0000, 'ºC'),
	(216256, 118, '2014-03-01 00:47:16.000000', 'temperatura', 660.0000, 'ºC'),
	(216257, 118, '2014-03-01 00:47:17.000000', 'temperatura', 355.0000, 'ºC'),
	(216258, 118, '2014-03-01 00:47:18.000000', 'temperatura', 996.0000, 'ºC'),
	(216259, 118, '2014-03-01 00:47:19.000000', 'temperatura', 315.0000, 'ºC'),
	(216260, 118, '2014-03-01 00:47:20.000000', 'temperatura', 986.0000, 'ºC'),
	(216261, 118, '2014-03-01 00:47:21.000000', 'temperatura', 386.0000, 'ºC'),
	(216262, 118, '2014-03-01 00:47:22.000000', 'temperatura', 173.0000, 'ºC'),
	(216263, 118, '2014-03-01 00:47:23.000000', 'temperatura', 909.0000, 'ºC'),
	(216264, 118, '2014-03-01 00:47:24.000000', 'temperatura', 426.0000, 'ºC'),
	(216265, 118, '2014-03-01 00:47:25.000000', 'temperatura', 604.0000, 'ºC'),
	(216266, 118, '2014-03-01 00:47:26.000000', 'temperatura', 544.0000, 'ºC'),
	(216267, 118, '2014-03-01 00:47:27.000000', 'temperatura', 905.0000, 'ºC'),
	(216268, 118, '2014-03-01 00:47:28.000000', 'temperatura', 494.0000, 'ºC'),
	(216269, 118, '2014-03-01 00:47:29.000000', 'temperatura', 958.0000, 'ºC'),
	(216270, 118, '2014-03-01 00:47:30.000000', 'temperatura', 905.0000, 'ºC'),
	(216271, 118, '2014-03-01 00:47:31.000000', 'temperatura', 454.0000, 'ºC'),
	(216272, 118, '2014-03-01 00:47:32.000000', 'temperatura', 754.0000, 'ºC'),
	(216273, 118, '2014-03-01 00:47:33.000000', 'temperatura', 10.0000, 'ºC'),
	(216274, 118, '2014-03-01 00:47:34.000000', 'temperatura', 189.0000, 'ºC'),
	(216275, 118, '2014-03-01 00:47:35.000000', 'temperatura', 916.0000, 'ºC'),
	(216276, 118, '2014-03-01 00:47:36.000000', 'temperatura', 413.0000, 'ºC'),
	(216277, 118, '2014-03-01 00:47:37.000000', 'temperatura', 518.0000, 'ºC'),
	(216278, 118, '2014-03-01 00:47:38.000000', 'temperatura', 150.0000, 'ºC'),
	(216279, 118, '2014-03-01 00:47:39.000000', 'temperatura', 396.0000, 'ºC'),
	(216280, 118, '2014-03-01 00:47:40.000000', 'temperatura', 333.0000, 'ºC'),
	(216281, 118, '2014-03-01 00:47:41.000000', 'temperatura', 477.0000, 'ºC'),
	(216282, 118, '2014-03-01 00:47:42.000000', 'temperatura', 185.0000, 'ºC'),
	(216283, 118, '2014-03-01 00:47:43.000000', 'temperatura', 697.0000, 'ºC'),
	(216284, 118, '2014-03-01 00:47:44.000000', 'temperatura', 528.0000, 'ºC'),
	(216285, 118, '2014-03-01 00:47:45.000000', 'temperatura', 552.0000, 'ºC'),
	(216286, 118, '2014-03-01 00:47:46.000000', 'temperatura', 1174.0000, 'ºC'),
	(216287, 118, '2014-03-01 00:47:47.000000', 'temperatura', 614.0000, 'ºC'),
	(216288, 118, '2014-03-01 00:47:48.000000', 'temperatura', 750.0000, 'ºC'),
	(216289, 118, '2014-03-01 00:47:49.000000', 'temperatura', 710.0000, 'ºC'),
	(216290, 118, '2014-03-01 00:47:50.000000', 'temperatura', 100.0000, 'ºC'),
	(216291, 118, '2014-03-01 00:47:51.000000', 'temperatura', 770.0000, 'ºC'),
	(216292, 118, '2014-03-01 00:47:52.000000', 'temperatura', 1151.0000, 'ºC'),
	(216293, 118, '2014-03-01 00:47:53.000000', 'temperatura', 1045.0000, 'ºC'),
	(216294, 118, '2014-03-01 00:47:54.000000', 'temperatura', 572.0000, 'ºC'),
	(216295, 118, '2014-03-01 00:47:55.000000', 'temperatura', 924.0000, 'ºC'),
	(216296, 118, '2014-03-01 00:47:56.000000', 'temperatura', 507.0000, 'ºC'),
	(216297, 118, '2014-03-01 00:47:57.000000', 'temperatura', 964.0000, 'ºC'),
	(216298, 118, '2014-03-01 00:47:58.000000', 'temperatura', 899.0000, 'ºC'),
	(216299, 118, '2014-03-01 00:47:59.000000', 'temperatura', 404.0000, 'ºC'),
	(216300, 118, '2014-03-01 00:48:00.000000', 'temperatura', 523.0000, 'ºC'),
	(216301, 118, '2014-03-01 00:48:01.000000', 'temperatura', 205.0000, 'ºC'),
	(216302, 118, '2014-03-01 00:48:02.000000', 'temperatura', 655.0000, 'ºC'),
	(216303, 118, '2014-03-01 00:48:03.000000', 'temperatura', 262.0000, 'ºC'),
	(216304, 118, '2014-03-01 00:48:04.000000', 'temperatura', 545.0000, 'ºC'),
	(216305, 118, '2014-03-01 00:48:05.000000', 'temperatura', 740.0000, 'ºC'),
	(216306, 118, '2014-03-01 00:48:06.000000', 'temperatura', 865.0000, 'ºC'),
	(216307, 118, '2014-03-01 00:48:07.000000', 'temperatura', 905.0000, 'ºC'),
	(216308, 118, '2014-03-01 00:48:08.000000', 'temperatura', 729.0000, 'ºC'),
	(216309, 118, '2014-03-01 00:48:09.000000', 'temperatura', 932.0000, 'ºC'),
	(216310, 118, '2014-03-01 00:48:10.000000', 'temperatura', 72.0000, 'ºC'),
	(216311, 118, '2014-03-01 00:48:11.000000', 'temperatura', 1167.0000, 'ºC'),
	(216312, 118, '2014-03-01 00:48:12.000000', 'temperatura', 818.0000, 'ºC'),
	(216313, 118, '2014-03-01 00:48:13.000000', 'temperatura', 588.0000, 'ºC'),
	(216314, 118, '2014-03-01 00:48:14.000000', 'temperatura', 489.0000, 'ºC'),
	(216315, 118, '2014-03-01 00:48:15.000000', 'temperatura', 681.0000, 'ºC'),
	(216316, 118, '2014-03-01 00:48:16.000000', 'temperatura', 737.0000, 'ºC'),
	(216317, 118, '2014-03-01 00:48:17.000000', 'temperatura', 445.0000, 'ºC'),
	(216318, 118, '2014-03-01 00:48:18.000000', 'temperatura', 14.0000, 'ºC'),
	(216319, 118, '2014-03-01 00:48:19.000000', 'temperatura', 1134.0000, 'ºC'),
	(216320, 118, '2014-03-01 00:48:20.000000', 'temperatura', 829.0000, 'ºC'),
	(216321, 118, '2014-03-01 00:48:21.000000', 'temperatura', 744.0000, 'ºC'),
	(216322, 118, '2014-03-01 00:48:22.000000', 'temperatura', 35.0000, 'ºC'),
	(216323, 118, '2014-03-01 00:48:23.000000', 'temperatura', 342.0000, 'ºC'),
	(216324, 118, '2014-03-01 00:48:24.000000', 'temperatura', 407.0000, 'ºC'),
	(216325, 118, '2014-03-01 00:48:25.000000', 'temperatura', 1009.0000, 'ºC'),
	(216326, 118, '2014-03-01 00:48:26.000000', 'temperatura', 225.0000, 'ºC'),
	(216327, 118, '2014-03-01 00:48:27.000000', 'temperatura', 496.0000, 'ºC'),
	(216328, 118, '2014-03-01 00:48:28.000000', 'temperatura', 606.0000, 'ºC'),
	(216329, 118, '2014-03-01 00:48:29.000000', 'temperatura', 344.0000, 'ºC'),
	(216330, 118, '2014-03-01 00:48:30.000000', 'temperatura', 1103.0000, 'ºC'),
	(216331, 118, '2014-03-01 00:48:31.000000', 'temperatura', 883.0000, 'ºC'),
	(216332, 118, '2014-03-01 00:48:32.000000', 'temperatura', 1105.0000, 'ºC'),
	(216333, 118, '2014-03-01 00:48:33.000000', 'temperatura', 477.0000, 'ºC'),
	(216334, 118, '2014-03-01 00:48:34.000000', 'temperatura', 272.0000, 'ºC'),
	(216335, 118, '2014-03-01 00:48:35.000000', 'temperatura', 1128.0000, 'ºC'),
	(216336, 118, '2014-03-01 00:48:36.000000', 'temperatura', 24.0000, 'ºC'),
	(216337, 118, '2014-03-01 00:48:37.000000', 'temperatura', 338.0000, 'ºC'),
	(216338, 118, '2014-03-01 00:48:38.000000', 'temperatura', 419.0000, 'ºC'),
	(216339, 118, '2014-03-01 00:48:39.000000', 'temperatura', 1083.0000, 'ºC'),
	(216340, 118, '2014-03-01 00:48:40.000000', 'temperatura', 556.0000, 'ºC'),
	(216341, 118, '2014-03-01 00:48:41.000000', 'temperatura', 731.0000, 'ºC'),
	(216342, 118, '2014-03-01 00:48:42.000000', 'temperatura', 789.0000, 'ºC'),
	(216343, 118, '2014-03-01 00:48:43.000000', 'temperatura', 552.0000, 'ºC'),
	(216344, 118, '2014-03-01 00:48:44.000000', 'temperatura', 392.0000, 'ºC'),
	(216345, 118, '2014-03-01 00:48:45.000000', 'temperatura', 305.0000, 'ºC'),
	(216346, 118, '2014-03-01 00:48:46.000000', 'temperatura', 348.0000, 'ºC'),
	(216347, 118, '2014-03-01 00:48:47.000000', 'temperatura', 828.0000, 'ºC'),
	(216348, 118, '2014-03-01 00:48:48.000000', 'temperatura', 697.0000, 'ºC'),
	(216349, 118, '2014-03-01 00:48:49.000000', 'temperatura', 1002.0000, 'ºC'),
	(216350, 118, '2014-03-01 00:48:50.000000', 'temperatura', 516.0000, 'ºC'),
	(216351, 118, '2014-03-01 00:48:51.000000', 'temperatura', 778.0000, 'ºC'),
	(216352, 118, '2014-03-01 00:48:52.000000', 'temperatura', 1141.0000, 'ºC'),
	(216353, 118, '2014-03-01 00:48:53.000000', 'temperatura', 974.0000, 'ºC'),
	(216354, 118, '2014-03-01 00:48:54.000000', 'temperatura', 244.0000, 'ºC'),
	(216355, 118, '2014-03-01 00:48:55.000000', 'temperatura', 701.0000, 'ºC'),
	(216356, 118, '2014-03-01 00:48:56.000000', 'temperatura', 372.0000, 'ºC'),
	(216357, 118, '2014-03-01 00:48:57.000000', 'temperatura', 960.0000, 'ºC'),
	(216358, 118, '2014-03-01 00:48:58.000000', 'temperatura', 83.0000, 'ºC'),
	(216359, 118, '2014-03-01 00:48:59.000000', 'temperatura', 1134.0000, 'ºC'),
	(216360, 118, '2014-03-01 00:49:00.000000', 'temperatura', 624.0000, 'ºC'),
	(216361, 118, '2014-03-01 00:49:01.000000', 'temperatura', 920.0000, 'ºC'),
	(216362, 118, '2014-03-01 00:49:02.000000', 'temperatura', 325.0000, 'ºC'),
	(216363, 118, '2014-03-01 00:49:03.000000', 'temperatura', 67.0000, 'ºC'),
	(216364, 118, '2014-03-01 00:49:04.000000', 'temperatura', 560.0000, 'ºC'),
	(216365, 118, '2014-03-01 00:49:05.000000', 'temperatura', 198.0000, 'ºC'),
	(216366, 118, '2014-03-01 00:49:06.000000', 'temperatura', 511.0000, 'ºC'),
	(216367, 118, '2014-03-01 00:49:07.000000', 'temperatura', 764.0000, 'ºC'),
	(216368, 118, '2014-03-01 00:49:08.000000', 'temperatura', 1086.0000, 'ºC'),
	(216369, 118, '2014-03-01 00:49:09.000000', 'temperatura', 738.0000, 'ºC'),
	(216370, 118, '2014-03-01 00:49:10.000000', 'temperatura', 432.0000, 'ºC'),
	(216371, 118, '2014-03-01 00:49:11.000000', 'temperatura', 1149.0000, 'ºC'),
	(216372, 118, '2014-03-01 00:49:12.000000', 'temperatura', 849.0000, 'ºC'),
	(216373, 118, '2014-03-01 00:49:13.000000', 'temperatura', 798.0000, 'ºC'),
	(216374, 118, '2014-03-01 00:49:14.000000', 'temperatura', 243.0000, 'ºC'),
	(216375, 118, '2014-03-01 00:49:15.000000', 'temperatura', 23.0000, 'ºC'),
	(216376, 118, '2014-03-01 00:49:16.000000', 'temperatura', 587.0000, 'ºC'),
	(216377, 118, '2014-03-01 00:49:17.000000', 'temperatura', 464.0000, 'ºC'),
	(216378, 118, '2014-03-01 00:49:18.000000', 'temperatura', 559.0000, 'ºC'),
	(216379, 118, '2014-03-01 00:49:19.000000', 'temperatura', 204.0000, 'ºC'),
	(216380, 118, '2014-03-01 00:49:20.000000', 'temperatura', 545.0000, 'ºC'),
	(216381, 118, '2014-03-01 00:49:21.000000', 'temperatura', 912.0000, 'ºC'),
	(216382, 118, '2014-03-01 00:49:22.000000', 'temperatura', 526.0000, 'ºC'),
	(216383, 118, '2014-03-01 00:49:23.000000', 'temperatura', 1096.0000, 'ºC'),
	(216384, 118, '2014-03-01 00:49:24.000000', 'temperatura', 302.0000, 'ºC'),
	(216385, 118, '2014-03-01 00:49:25.000000', 'temperatura', 621.0000, 'ºC'),
	(216386, 118, '2014-03-01 00:49:26.000000', 'temperatura', 1001.0000, 'ºC'),
	(216387, 118, '2014-03-01 00:49:27.000000', 'temperatura', 740.0000, 'ºC'),
	(216388, 118, '2014-03-01 00:49:28.000000', 'temperatura', 701.0000, 'ºC'),
	(216389, 118, '2014-03-01 00:49:29.000000', 'temperatura', 82.0000, 'ºC'),
	(216390, 118, '2014-03-01 00:49:30.000000', 'temperatura', 709.0000, 'ºC'),
	(216391, 118, '2014-03-01 00:49:31.000000', 'temperatura', 898.0000, 'ºC'),
	(216392, 118, '2014-03-01 00:49:32.000000', 'temperatura', 1164.0000, 'ºC'),
	(216393, 118, '2014-03-01 00:49:33.000000', 'temperatura', 728.0000, 'ºC'),
	(216394, 118, '2014-03-01 00:49:34.000000', 'temperatura', 149.0000, 'ºC'),
	(216395, 118, '2014-03-01 00:49:35.000000', 'temperatura', 960.0000, 'ºC'),
	(216396, 118, '2014-03-01 00:49:36.000000', 'temperatura', 753.0000, 'ºC'),
	(216397, 118, '2014-03-01 00:49:37.000000', 'temperatura', 888.0000, 'ºC'),
	(216398, 118, '2014-03-01 00:49:38.000000', 'temperatura', 980.0000, 'ºC'),
	(216399, 118, '2014-03-01 00:49:39.000000', 'temperatura', 1036.0000, 'ºC'),
	(216400, 118, '2014-03-01 00:49:40.000000', 'temperatura', 1039.0000, 'ºC'),
	(216401, 118, '2014-03-01 00:49:41.000000', 'temperatura', 888.0000, 'ºC'),
	(216402, 118, '2014-03-01 00:49:42.000000', 'temperatura', 124.0000, 'ºC'),
	(216403, 118, '2014-03-01 00:49:43.000000', 'temperatura', 357.0000, 'ºC'),
	(216404, 118, '2014-03-01 00:49:44.000000', 'temperatura', 215.0000, 'ºC'),
	(216405, 118, '2014-03-01 00:49:45.000000', 'temperatura', 3.0000, 'ºC'),
	(216406, 118, '2014-03-01 00:49:46.000000', 'temperatura', 572.0000, 'ºC'),
	(216407, 118, '2014-03-01 00:49:47.000000', 'temperatura', 450.0000, 'ºC'),
	(216408, 118, '2014-03-01 00:49:48.000000', 'temperatura', 536.0000, 'ºC'),
	(216409, 118, '2014-03-01 00:49:49.000000', 'temperatura', 131.0000, 'ºC'),
	(216410, 118, '2014-03-01 00:49:50.000000', 'temperatura', 246.0000, 'ºC'),
	(216411, 118, '2014-03-01 00:49:51.000000', 'temperatura', 839.0000, 'ºC'),
	(216412, 118, '2014-03-01 00:49:52.000000', 'temperatura', 1056.0000, 'ºC'),
	(216413, 118, '2014-03-01 00:49:53.000000', 'temperatura', 364.0000, 'ºC'),
	(216414, 118, '2014-03-01 00:49:54.000000', 'temperatura', 1052.0000, 'ºC'),
	(216415, 118, '2014-03-01 00:49:55.000000', 'temperatura', 571.0000, 'ºC'),
	(216416, 118, '2014-03-01 00:49:56.000000', 'temperatura', 897.0000, 'ºC'),
	(216417, 118, '2014-03-01 00:49:57.000000', 'temperatura', 374.0000, 'ºC'),
	(216418, 118, '2014-03-01 00:49:58.000000', 'temperatura', 379.0000, 'ºC'),
	(216419, 118, '2014-03-01 00:49:59.000000', 'temperatura', 772.0000, 'ºC'),
	(216420, 118, '2014-03-01 00:50:00.000000', 'temperatura', 324.0000, 'ºC'),
	(216421, 118, '2014-03-01 00:50:01.000000', 'temperatura', 507.0000, 'ºC'),
	(216422, 118, '2014-03-01 00:50:02.000000', 'temperatura', 360.0000, 'ºC'),
	(216423, 118, '2014-03-01 00:50:03.000000', 'temperatura', 283.0000, 'ºC'),
	(216424, 118, '2014-03-01 00:50:04.000000', 'temperatura', 334.0000, 'ºC'),
	(216425, 118, '2014-03-01 00:50:05.000000', 'temperatura', 821.0000, 'ºC'),
	(216426, 118, '2014-03-01 00:50:06.000000', 'temperatura', 704.0000, 'ºC'),
	(216427, 118, '2014-03-01 00:50:07.000000', 'temperatura', 1058.0000, 'ºC'),
	(216428, 118, '2014-03-01 00:50:08.000000', 'temperatura', 777.0000, 'ºC'),
	(216429, 118, '2014-03-01 00:50:09.000000', 'temperatura', 712.0000, 'ºC'),
	(216430, 118, '2014-03-01 00:50:10.000000', 'temperatura', 31.0000, 'ºC'),
	(216431, 118, '2014-03-01 00:50:11.000000', 'temperatura', 418.0000, 'ºC'),
	(216432, 118, '2014-03-01 00:50:12.000000', 'temperatura', 796.0000, 'ºC'),
	(216433, 118, '2014-03-01 00:50:13.000000', 'temperatura', 328.0000, 'ºC'),
	(216434, 118, '2014-03-01 00:50:14.000000', 'temperatura', 450.0000, 'ºC'),
	(216435, 118, '2014-03-01 00:50:15.000000', 'temperatura', 70.0000, 'ºC'),
	(216436, 118, '2014-03-01 00:50:16.000000', 'temperatura', 198.0000, 'ºC'),
	(216437, 118, '2014-03-01 00:50:17.000000', 'temperatura', 783.0000, 'ºC'),
	(216438, 118, '2014-03-01 00:50:18.000000', 'temperatura', 919.0000, 'ºC'),
	(216439, 118, '2014-03-01 00:50:19.000000', 'temperatura', 1049.0000, 'ºC'),
	(216440, 118, '2014-03-01 00:50:20.000000', 'temperatura', 89.0000, 'ºC'),
	(216441, 118, '2014-03-01 00:50:21.000000', 'temperatura', 900.0000, 'ºC'),
	(216442, 118, '2014-03-01 00:50:22.000000', 'temperatura', 630.0000, 'ºC'),
	(216443, 118, '2014-03-01 00:50:23.000000', 'temperatura', 450.0000, 'ºC'),
	(216444, 118, '2014-03-01 00:50:24.000000', 'temperatura', 361.0000, 'ºC'),
	(216445, 118, '2014-03-01 00:50:25.000000', 'temperatura', 457.0000, 'ºC'),
	(216446, 118, '2014-03-01 00:50:26.000000', 'temperatura', 0.0000, 'ºC'),
	(216447, 118, '2014-03-01 00:50:27.000000', 'temperatura', 1030.0000, 'ºC'),
	(216448, 118, '2014-03-01 00:50:28.000000', 'temperatura', 350.0000, 'ºC'),
	(216449, 118, '2014-03-01 00:50:29.000000', 'temperatura', 1059.0000, 'ºC'),
	(216450, 118, '2014-03-01 00:50:30.000000', 'temperatura', 649.0000, 'ºC'),
	(216451, 118, '2014-03-01 00:50:31.000000', 'temperatura', 66.0000, 'ºC'),
	(216452, 118, '2014-03-01 00:50:32.000000', 'temperatura', 784.0000, 'ºC'),
	(216453, 118, '2014-03-01 00:50:33.000000', 'temperatura', 123.0000, 'ºC'),
	(216454, 118, '2014-03-01 00:50:34.000000', 'temperatura', 665.0000, 'ºC'),
	(216455, 118, '2014-03-01 00:50:35.000000', 'temperatura', 554.0000, 'ºC'),
	(216456, 118, '2014-03-01 00:50:36.000000', 'temperatura', 776.0000, 'ºC'),
	(216457, 118, '2014-03-01 00:50:37.000000', 'temperatura', 1021.0000, 'ºC'),
	(216458, 118, '2014-03-01 00:50:38.000000', 'temperatura', 375.0000, 'ºC'),
	(216459, 118, '2014-03-01 00:50:39.000000', 'temperatura', 13.0000, 'ºC'),
	(216460, 118, '2014-03-01 00:50:40.000000', 'temperatura', 141.0000, 'ºC'),
	(216461, 118, '2014-03-01 00:50:41.000000', 'temperatura', 665.0000, 'ºC'),
	(216462, 118, '2014-03-01 00:50:42.000000', 'temperatura', 505.0000, 'ºC'),
	(216463, 118, '2014-03-01 00:50:43.000000', 'temperatura', 531.0000, 'ºC'),
	(216464, 118, '2014-03-01 00:50:44.000000', 'temperatura', 1138.0000, 'ºC'),
	(216465, 118, '2014-03-01 00:50:45.000000', 'temperatura', 498.0000, 'ºC'),
	(216466, 118, '2014-03-01 00:50:46.000000', 'temperatura', 275.0000, 'ºC'),
	(216467, 118, '2014-03-01 00:50:47.000000', 'temperatura', 1082.0000, 'ºC'),
	(216468, 118, '2014-03-01 00:50:48.000000', 'temperatura', 984.0000, 'ºC'),
	(216469, 118, '2014-03-01 00:50:49.000000', 'temperatura', 477.0000, 'ºC'),
	(216470, 118, '2014-03-01 00:50:50.000000', 'temperatura', 634.0000, 'ºC'),
	(216471, 118, '2014-03-01 00:50:51.000000', 'temperatura', 539.0000, 'ºC'),
	(216472, 118, '2014-03-01 00:50:52.000000', 'temperatura', 792.0000, 'ºC'),
	(216473, 118, '2014-03-01 00:50:53.000000', 'temperatura', 1146.0000, 'ºC'),
	(216474, 118, '2014-03-01 00:50:54.000000', 'temperatura', 951.0000, 'ºC'),
	(216475, 118, '2014-03-01 00:50:55.000000', 'temperatura', 121.0000, 'ºC'),
	(216476, 118, '2014-03-01 00:50:56.000000', 'temperatura', 152.0000, 'ºC'),
	(216477, 118, '2014-03-01 00:50:57.000000', 'temperatura', 399.0000, 'ºC'),
	(216478, 118, '2014-03-01 00:50:58.000000', 'temperatura', 337.0000, 'ºC'),
	(216479, 118, '2014-03-01 00:50:59.000000', 'temperatura', 489.0000, 'ºC'),
	(216480, 118, '2014-03-01 00:51:00.000000', 'temperatura', 237.0000, 'ºC'),
	(216481, 118, '2014-03-01 00:51:01.000000', 'temperatura', 915.0000, 'ºC'),
	(216482, 118, '2014-03-01 00:51:02.000000', 'temperatura', 265.0000, 'ºC'),
	(216483, 118, '2014-03-01 00:51:03.000000', 'temperatura', 983.0000, 'ºC'),
	(216484, 118, '2014-03-01 00:51:04.000000', 'temperatura', 518.0000, 'ºC'),
	(216485, 118, '2014-03-01 00:51:05.000000', 'temperatura', 843.0000, 'ºC'),
	(216486, 118, '2014-03-01 00:51:06.000000', 'temperatura', 263.0000, 'ºC'),
	(216487, 118, '2014-03-01 00:51:07.000000', 'temperatura', 1184.0000, 'ºC'),
	(216488, 118, '2014-03-01 00:51:08.000000', 'temperatura', 332.0000, 'ºC'),
	(216489, 118, '2014-03-01 00:51:09.000000', 'temperatura', 507.0000, 'ºC'),
	(216490, 118, '2014-03-01 00:51:10.000000', 'temperatura', 340.0000, 'ºC'),
	(216491, 118, '2014-03-01 00:51:11.000000', 'temperatura', 180.0000, 'ºC'),
	(216492, 118, '2014-03-01 00:51:12.000000', 'temperatura', 1079.0000, 'ºC'),
	(216493, 118, '2014-03-01 00:51:13.000000', 'temperatura', 58.0000, 'ºC'),
	(216494, 118, '2014-03-01 00:51:14.000000', 'temperatura', 653.0000, 'ºC'),
	(216495, 118, '2014-03-01 00:51:15.000000', 'temperatura', 689.0000, 'ºC'),
	(216496, 118, '2014-03-01 00:51:16.000000', 'temperatura', 288.0000, 'ºC'),
	(216497, 118, '2014-03-01 00:51:17.000000', 'temperatura', 574.0000, 'ºC'),
	(216498, 118, '2014-03-01 00:51:18.000000', 'temperatura', 806.0000, 'ºC'),
	(216499, 118, '2014-03-01 00:51:19.000000', 'temperatura', 1107.0000, 'ºC'),
	(216500, 118, '2014-03-01 00:51:20.000000', 'temperatura', 719.0000, 'ºC'),
	(216501, 118, '2014-03-01 00:51:21.000000', 'temperatura', 273.0000, 'ºC'),
	(216502, 118, '2014-03-01 00:51:22.000000', 'temperatura', 411.0000, 'ºC'),
	(216503, 118, '2014-03-01 00:51:23.000000', 'temperatura', 33.0000, 'ºC'),
	(216504, 118, '2014-03-01 00:51:24.000000', 'temperatura', 136.0000, 'ºC'),
	(216505, 118, '2014-03-01 00:51:25.000000', 'temperatura', 581.0000, 'ºC'),
	(216506, 118, '2014-03-01 00:51:26.000000', 'temperatura', 98.0000, 'ºC'),
	(216507, 118, '2014-03-01 00:51:27.000000', 'temperatura', 1147.0000, 'ºC'),
	(216508, 118, '2014-03-01 00:51:28.000000', 'temperatura', 642.0000, 'ºC'),
	(216509, 118, '2014-03-01 00:51:29.000000', 'temperatura', 970.0000, 'ºC'),
	(216510, 118, '2014-03-01 00:51:30.000000', 'temperatura', 525.0000, 'ºC'),
	(216511, 118, '2014-03-01 00:51:31.000000', 'temperatura', 914.0000, 'ºC'),
	(216512, 118, '2014-03-01 00:51:32.000000', 'temperatura', 596.0000, 'ºC'),
	(216513, 118, '2014-03-01 00:51:33.000000', 'temperatura', 238.0000, 'ºC'),
	(216514, 118, '2014-03-01 00:51:34.000000', 'temperatura', 603.0000, 'ºC'),
	(216515, 118, '2014-03-01 00:51:35.000000', 'temperatura', 1101.0000, 'ºC'),
	(216516, 118, '2014-03-01 00:51:36.000000', 'temperatura', 98.0000, 'ºC'),
	(216517, 118, '2014-03-01 00:51:37.000000', 'temperatura', 788.0000, 'ºC'),
	(216518, 118, '2014-03-01 00:51:38.000000', 'temperatura', 47.0000, 'ºC'),
	(216519, 118, '2014-03-01 00:51:39.000000', 'temperatura', 272.0000, 'ºC'),
	(216520, 118, '2014-03-01 00:51:40.000000', 'temperatura', 18.0000, 'ºC'),
	(216521, 118, '2014-03-01 00:51:41.000000', 'temperatura', 473.0000, 'ºC'),
	(216522, 118, '2014-03-01 00:51:42.000000', 'temperatura', 1113.0000, 'ºC'),
	(216523, 118, '2014-03-01 00:51:43.000000', 'temperatura', 545.0000, 'ºC'),
	(216524, 118, '2014-03-01 00:51:44.000000', 'temperatura', 586.0000, 'ºC'),
	(216525, 118, '2014-03-01 00:51:45.000000', 'temperatura', 96.0000, 'ºC'),
	(216526, 118, '2014-03-01 00:51:46.000000', 'temperatura', 1122.0000, 'ºC'),
	(216527, 118, '2014-03-01 00:51:47.000000', 'temperatura', 522.0000, 'ºC'),
	(216528, 118, '2014-03-01 00:51:48.000000', 'temperatura', 445.0000, 'ºC'),
	(216529, 118, '2014-03-01 00:51:49.000000', 'temperatura', 661.0000, 'ºC'),
	(216530, 118, '2014-03-01 00:51:50.000000', 'temperatura', 768.0000, 'ºC'),
	(216531, 118, '2014-03-01 00:51:51.000000', 'temperatura', 657.0000, 'ºC'),
	(216532, 118, '2014-03-01 00:51:52.000000', 'temperatura', 983.0000, 'ºC'),
	(216533, 118, '2014-03-01 00:51:53.000000', 'temperatura', 545.0000, 'ºC'),
	(216534, 118, '2014-03-01 00:51:54.000000', 'temperatura', 976.0000, 'ºC'),
	(216535, 118, '2014-03-01 00:51:55.000000', 'temperatura', 844.0000, 'ºC'),
	(216536, 118, '2014-03-01 00:51:56.000000', 'temperatura', 95.0000, 'ºC'),
	(216537, 118, '2014-03-01 00:51:57.000000', 'temperatura', 344.0000, 'ºC'),
	(216538, 118, '2014-03-01 00:51:58.000000', 'temperatura', 233.0000, 'ºC'),
	(216539, 118, '2014-03-01 00:51:59.000000', 'temperatura', 135.0000, 'ºC'),
	(216540, 118, '2014-03-01 00:52:00.000000', 'temperatura', 1176.0000, 'ºC'),
	(216541, 118, '2014-03-01 00:52:01.000000', 'temperatura', 674.0000, 'ºC'),
	(216542, 118, '2014-03-01 00:52:02.000000', 'temperatura', 1045.0000, 'ºC'),
	(216543, 118, '2014-03-01 00:52:03.000000', 'temperatura', 803.0000, 'ºC'),
	(216544, 118, '2014-03-01 00:52:04.000000', 'temperatura', 878.0000, 'ºC'),
	(216545, 118, '2014-03-01 00:52:05.000000', 'temperatura', 784.0000, 'ºC'),
	(216546, 118, '2014-03-01 00:52:06.000000', 'temperatura', 85.0000, 'ºC'),
	(216547, 118, '2014-03-01 00:52:07.000000', 'temperatura', 476.0000, 'ºC'),
	(216548, 118, '2014-03-01 00:52:08.000000', 'temperatura', 924.0000, 'ºC'),
	(216549, 118, '2014-03-01 00:52:09.000000', 'temperatura', 793.0000, 'ºC'),
	(216550, 118, '2014-03-01 00:52:10.000000', 'temperatura', 1194.0000, 'ºC'),
	(216551, 118, '2014-03-01 00:52:11.000000', 'temperatura', 1192.0000, 'ºC'),
	(216552, 118, '2014-03-01 00:52:12.000000', 'temperatura', 1177.0000, 'ºC'),
	(216553, 118, '2014-03-01 00:52:13.000000', 'temperatura', 1109.0000, 'ºC'),
	(216554, 118, '2014-03-01 00:52:14.000000', 'temperatura', 814.0000, 'ºC'),
	(216555, 118, '2014-03-01 00:52:15.000000', 'temperatura', 742.0000, 'ºC'),
	(216556, 118, '2014-03-01 00:52:16.000000', 'temperatura', 71.0000, 'ºC'),
	(216557, 118, '2014-03-01 00:52:17.000000', 'temperatura', 529.0000, 'ºC'),
	(216558, 118, '2014-03-01 00:52:18.000000', 'temperatura', 33.0000, 'ºC'),
	(216559, 118, '2014-03-01 00:52:19.000000', 'temperatura', 979.0000, 'ºC'),
	(216560, 118, '2014-03-01 00:52:20.000000', 'temperatura', 1194.0000, 'ºC'),
	(216561, 118, '2014-03-01 00:52:21.000000', 'temperatura', 637.0000, 'ºC'),
	(216562, 118, '2014-03-01 00:52:22.000000', 'temperatura', 801.0000, 'ºC'),
	(216563, 118, '2014-03-01 00:52:23.000000', 'temperatura', 894.0000, 'ºC'),
	(216564, 118, '2014-03-01 00:52:24.000000', 'temperatura', 869.0000, 'ºC'),
	(216565, 118, '2014-03-01 00:52:25.000000', 'temperatura', 463.0000, 'ºC'),
	(216566, 118, '2014-03-01 00:52:26.000000', 'temperatura', 907.0000, 'ºC'),
	(216567, 118, '2014-03-01 00:52:27.000000', 'temperatura', 747.0000, 'ºC'),
	(216568, 118, '2014-03-01 00:52:28.000000', 'temperatura', 1014.0000, 'ºC'),
	(216569, 118, '2014-03-01 00:52:29.000000', 'temperatura', 429.0000, 'ºC'),
	(216570, 118, '2014-03-01 00:52:30.000000', 'temperatura', 304.0000, 'ºC'),
	(216571, 118, '2014-03-01 00:52:31.000000', 'temperatura', 235.0000, 'ºC'),
	(216572, 118, '2014-03-01 00:52:32.000000', 'temperatura', 262.0000, 'ºC'),
	(216573, 118, '2014-03-01 00:52:33.000000', 'temperatura', 606.0000, 'ºC'),
	(216574, 118, '2014-03-01 00:52:34.000000', 'temperatura', 1043.0000, 'ºC'),
	(216575, 118, '2014-03-01 00:52:35.000000', 'temperatura', 999.0000, 'ºC'),
	(216576, 118, '2014-03-01 00:52:36.000000', 'temperatura', 667.0000, 'ºC'),
	(216577, 118, '2014-03-01 00:52:37.000000', 'temperatura', 336.0000, 'ºC'),
	(216578, 118, '2014-03-01 00:52:38.000000', 'temperatura', 881.0000, 'ºC'),
	(216579, 118, '2014-03-01 00:52:39.000000', 'temperatura', 998.0000, 'ºC'),
	(216580, 118, '2014-03-01 00:52:40.000000', 'temperatura', 1148.0000, 'ºC'),
	(216581, 118, '2014-03-01 00:52:41.000000', 'temperatura', 344.0000, 'ºC'),
	(216582, 118, '2014-03-01 00:52:42.000000', 'temperatura', 680.0000, 'ºC'),
	(216583, 118, '2014-03-01 00:52:43.000000', 'temperatura', 1165.0000, 'ºC'),
	(216584, 118, '2014-03-01 00:52:44.000000', 'temperatura', 189.0000, 'ºC'),
	(216585, 118, '2014-03-01 00:52:45.000000', 'temperatura', 1048.0000, 'ºC'),
	(216586, 118, '2014-03-01 00:52:46.000000', 'temperatura', 1074.0000, 'ºC'),
	(216587, 118, '2014-03-01 00:52:47.000000', 'temperatura', 1025.0000, 'ºC'),
	(216588, 118, '2014-03-01 00:52:48.000000', 'temperatura', 703.0000, 'ºC'),
	(216589, 118, '2014-03-01 00:52:49.000000', 'temperatura', 440.0000, 'ºC'),
	(216590, 118, '2014-03-01 00:52:50.000000', 'temperatura', 94.0000, 'ºC'),
	(216591, 118, '2014-03-01 00:52:51.000000', 'temperatura', 348.0000, 'ºC'),
	(216592, 118, '2014-03-01 00:52:52.000000', 'temperatura', 259.0000, 'ºC'),
	(216593, 118, '2014-03-01 00:52:53.000000', 'temperatura', 254.0000, 'ºC'),
	(216594, 118, '2014-03-01 00:52:54.000000', 'temperatura', 490.0000, 'ºC'),
	(216595, 118, '2014-03-01 00:52:55.000000', 'temperatura', 491.0000, 'ºC'),
	(216596, 118, '2014-03-01 00:52:56.000000', 'temperatura', 986.0000, 'ºC'),
	(216597, 118, '2014-03-01 00:52:57.000000', 'temperatura', 1054.0000, 'ºC'),
	(216598, 118, '2014-03-01 00:52:58.000000', 'temperatura', 1116.0000, 'ºC'),
	(216599, 118, '2014-03-01 00:52:59.000000', 'temperatura', 19.0000, 'ºC'),
	(216600, 118, '2014-03-01 00:53:00.000000', 'temperatura', 347.0000, 'ºC'),
	(216601, 118, '2014-03-01 00:53:01.000000', 'temperatura', 477.0000, 'ºC'),
	(216602, 118, '2014-03-01 00:53:02.000000', 'temperatura', 147.0000, 'ºC'),
	(216603, 118, '2014-03-01 00:53:03.000000', 'temperatura', 503.0000, 'ºC'),
	(216604, 118, '2014-03-01 00:53:04.000000', 'temperatura', 875.0000, 'ºC'),
	(216605, 118, '2014-03-01 00:53:05.000000', 'temperatura', 464.0000, 'ºC'),
	(216606, 118, '2014-03-01 00:53:06.000000', 'temperatura', 898.0000, 'ºC'),
	(216607, 118, '2014-03-01 00:53:07.000000', 'temperatura', 697.0000, 'ºC'),
	(216608, 118, '2014-03-01 00:53:08.000000', 'temperatura', 792.0000, 'ºC'),
	(216609, 118, '2014-03-01 00:53:09.000000', 'temperatura', 669.0000, 'ºC'),
	(216610, 118, '2014-03-01 00:53:10.000000', 'temperatura', 971.0000, 'ºC'),
	(216611, 118, '2014-03-01 00:53:11.000000', 'temperatura', 447.0000, 'ºC'),
	(216612, 118, '2014-03-01 00:53:12.000000', 'temperatura', 523.0000, 'ºC'),
	(216613, 118, '2014-03-01 00:53:13.000000', 'temperatura', 76.0000, 'ºC'),
	(216614, 118, '2014-03-01 00:53:14.000000', 'temperatura', 10.0000, 'ºC'),
	(216615, 118, '2014-03-01 00:53:15.000000', 'temperatura', 1023.0000, 'ºC'),
	(216616, 118, '2014-03-01 00:53:16.000000', 'temperatura', 284.0000, 'ºC'),
	(216617, 118, '2014-03-01 00:53:17.000000', 'temperatura', 753.0000, 'ºC'),
	(216618, 118, '2014-03-01 00:53:18.000000', 'temperatura', 512.0000, 'ºC'),
	(216619, 118, '2014-03-01 00:53:19.000000', 'temperatura', 303.0000, 'ºC'),
	(216620, 118, '2014-03-01 00:53:20.000000', 'temperatura', 1178.0000, 'ºC'),
	(216621, 118, '2014-03-01 00:53:21.000000', 'temperatura', 183.0000, 'ºC'),
	(216622, 118, '2014-03-01 00:53:22.000000', 'temperatura', 982.0000, 'ºC'),
	(216623, 118, '2014-03-01 00:53:23.000000', 'temperatura', 762.0000, 'ºC'),
	(216624, 118, '2014-03-01 00:53:24.000000', 'temperatura', 863.0000, 'ºC'),
	(216625, 118, '2014-03-01 00:53:25.000000', 'temperatura', 828.0000, 'ºC'),
	(216626, 118, '2014-03-01 00:53:26.000000', 'temperatura', 354.0000, 'ºC'),
	(216627, 118, '2014-03-01 00:53:27.000000', 'temperatura', 485.0000, 'ºC'),
	(216628, 118, '2014-03-01 00:53:28.000000', 'temperatura', 165.0000, 'ºC'),
	(216629, 118, '2014-03-01 00:53:29.000000', 'temperatura', 571.0000, 'ºC'),
	(216630, 118, '2014-03-01 00:53:30.000000', 'temperatura', 1161.0000, 'ºC'),
	(216631, 118, '2014-03-01 00:53:31.000000', 'temperatura', 489.0000, 'ºC'),
	(216632, 118, '2014-03-01 00:53:32.000000', 'temperatura', 166.0000, 'ºC'),
	(216633, 118, '2014-03-01 00:53:33.000000', 'temperatura', 563.0000, 'ºC'),
	(216634, 118, '2014-03-01 00:53:34.000000', 'temperatura', 1119.0000, 'ºC'),
	(216635, 118, '2014-03-01 00:53:35.000000', 'temperatura', 305.0000, 'ºC'),
	(216636, 118, '2014-03-01 00:53:36.000000', 'temperatura', 570.0000, 'ºC'),
	(216637, 118, '2014-03-01 00:53:37.000000', 'temperatura', 734.0000, 'ºC'),
	(216638, 118, '2014-03-01 00:53:38.000000', 'temperatura', 759.0000, 'ºC'),
	(216639, 118, '2014-03-01 00:53:39.000000', 'temperatura', 395.0000, 'ºC'),
	(216640, 118, '2014-03-01 00:53:40.000000', 'temperatura', 900.0000, 'ºC'),
	(216641, 118, '2014-03-01 00:53:41.000000', 'temperatura', 916.0000, 'ºC'),
	(216642, 118, '2014-03-01 00:53:42.000000', 'temperatura', 677.0000, 'ºC'),
	(216643, 118, '2014-03-01 00:53:43.000000', 'temperatura', 641.0000, 'ºC'),
	(216644, 118, '2014-03-01 00:53:44.000000', 'temperatura', 1172.0000, 'ºC'),
	(216645, 118, '2014-03-01 00:53:45.000000', 'temperatura', 337.0000, 'ºC'),
	(216646, 118, '2014-03-01 00:53:46.000000', 'temperatura', 571.0000, 'ºC'),
	(216647, 118, '2014-03-01 00:53:47.000000', 'temperatura', 642.0000, 'ºC'),
	(216648, 118, '2014-03-01 00:53:48.000000', 'temperatura', 299.0000, 'ºC'),
	(216649, 118, '2014-03-01 00:53:49.000000', 'temperatura', 771.0000, 'ºC'),
	(216650, 118, '2014-03-01 00:53:50.000000', 'temperatura', 558.0000, 'ºC'),
	(216651, 118, '2014-03-01 00:53:51.000000', 'temperatura', 476.0000, 'ºC'),
	(216652, 118, '2014-03-01 00:53:52.000000', 'temperatura', 706.0000, 'ºC'),
	(216653, 118, '2014-03-01 00:53:53.000000', 'temperatura', 901.0000, 'ºC'),
	(216654, 118, '2014-03-01 00:53:54.000000', 'temperatura', 1191.0000, 'ºC'),
	(216655, 118, '2014-03-01 00:53:55.000000', 'temperatura', 849.0000, 'ºC'),
	(216656, 118, '2014-03-01 00:53:56.000000', 'temperatura', 675.0000, 'ºC'),
	(216657, 118, '2014-03-01 00:53:57.000000', 'temperatura', 828.0000, 'ºC'),
	(216658, 118, '2014-03-01 00:53:58.000000', 'temperatura', 915.0000, 'ºC'),
	(216659, 118, '2014-03-01 00:53:59.000000', 'temperatura', 892.0000, 'ºC'),
	(216660, 118, '2014-03-01 00:54:00.000000', 'temperatura', 517.0000, 'ºC'),
	(216661, 118, '2014-03-01 00:54:01.000000', 'temperatura', 1109.0000, 'ºC'),
	(216662, 118, '2014-03-01 00:54:02.000000', 'temperatura', 395.0000, 'ºC'),
	(216663, 118, '2014-03-01 00:54:03.000000', 'temperatura', 1046.0000, 'ºC'),
	(216664, 118, '2014-03-01 00:54:04.000000', 'temperatura', 447.0000, 'ºC'),
	(216665, 118, '2014-03-01 00:54:05.000000', 'temperatura', 299.0000, 'ºC'),
	(216666, 118, '2014-03-01 00:54:06.000000', 'temperatura', 154.0000, 'ºC'),
	(216667, 118, '2014-03-01 00:54:07.000000', 'temperatura', 1072.0000, 'ºC'),
	(216668, 118, '2014-03-01 00:54:08.000000', 'temperatura', 100.0000, 'ºC'),
	(216669, 118, '2014-03-01 00:54:09.000000', 'temperatura', 884.0000, 'ºC'),
	(216670, 118, '2014-03-01 00:54:10.000000', 'temperatura', 520.0000, 'ºC'),
	(216671, 118, '2014-03-01 00:54:11.000000', 'temperatura', 1148.0000, 'ºC'),
	(216672, 118, '2014-03-01 00:54:12.000000', 'temperatura', 582.0000, 'ºC'),
	(216673, 118, '2014-03-01 00:54:13.000000', 'temperatura', 664.0000, 'ºC'),
	(216674, 118, '2014-03-01 00:54:14.000000', 'temperatura', 376.0000, 'ºC'),
	(216675, 118, '2014-03-01 00:54:15.000000', 'temperatura', 1090.0000, 'ºC'),
	(216676, 118, '2014-03-01 00:54:16.000000', 'temperatura', 723.0000, 'ºC'),
	(216677, 118, '2014-03-01 00:54:17.000000', 'temperatura', 345.0000, 'ºC'),
	(216678, 118, '2014-03-01 00:54:18.000000', 'temperatura', 755.0000, 'ºC'),
	(216679, 118, '2014-03-01 00:54:19.000000', 'temperatura', 340.0000, 'ºC'),
	(216680, 118, '2014-03-01 00:54:20.000000', 'temperatura', 636.0000, 'ºC'),
	(216681, 118, '2014-03-01 00:54:21.000000', 'temperatura', 959.0000, 'ºC'),
	(216682, 118, '2014-03-01 00:54:22.000000', 'temperatura', 490.0000, 'ºC'),
	(216683, 118, '2014-03-01 00:54:23.000000', 'temperatura', 771.0000, 'ºC'),
	(216684, 118, '2014-03-01 00:54:24.000000', 'temperatura', 1189.0000, 'ºC'),
	(216685, 118, '2014-03-01 00:54:25.000000', 'temperatura', 29.0000, 'ºC'),
	(216686, 118, '2014-03-01 00:54:26.000000', 'temperatura', 181.0000, 'ºC'),
	(216687, 118, '2014-03-01 00:54:27.000000', 'temperatura', 817.0000, 'ºC'),
	(216688, 118, '2014-03-01 00:54:28.000000', 'temperatura', 1141.0000, 'ºC'),
	(216689, 118, '2014-03-01 00:54:29.000000', 'temperatura', 855.0000, 'ºC'),
	(216690, 118, '2014-03-01 00:54:30.000000', 'temperatura', 853.0000, 'ºC'),
	(216691, 118, '2014-03-01 00:54:31.000000', 'temperatura', 502.0000, 'ºC'),
	(216692, 118, '2014-03-01 00:54:32.000000', 'temperatura', 1150.0000, 'ºC'),
	(216693, 118, '2014-03-01 00:54:33.000000', 'temperatura', 647.0000, 'ºC'),
	(216694, 118, '2014-03-01 00:54:34.000000', 'temperatura', 984.0000, 'ºC'),
	(216695, 118, '2014-03-01 00:54:35.000000', 'temperatura', 578.0000, 'ºC'),
	(216696, 118, '2014-03-01 00:54:36.000000', 'temperatura', 1138.0000, 'ºC'),
	(216697, 118, '2014-03-01 00:54:37.000000', 'temperatura', 358.0000, 'ºC'),
	(216698, 118, '2014-03-01 00:54:38.000000', 'temperatura', 777.0000, 'ºC'),
	(216699, 118, '2014-03-01 00:54:39.000000', 'temperatura', 410.0000, 'ºC'),
	(216700, 118, '2014-03-01 00:54:40.000000', 'temperatura', 919.0000, 'ºC'),
	(216701, 118, '2014-03-01 00:54:41.000000', 'temperatura', 964.0000, 'ºC'),
	(216702, 118, '2014-03-01 00:54:42.000000', 'temperatura', 866.0000, 'ºC'),
	(216703, 118, '2014-03-01 00:54:43.000000', 'temperatura', 239.0000, 'ºC'),
	(216704, 118, '2014-03-01 00:54:44.000000', 'temperatura', 997.0000, 'ºC'),
	(216705, 118, '2014-03-01 00:54:45.000000', 'temperatura', 667.0000, 'ºC'),
	(216706, 118, '2014-03-01 00:54:46.000000', 'temperatura', 345.0000, 'ºC'),
	(216707, 118, '2014-03-01 00:54:47.000000', 'temperatura', 926.0000, 'ºC'),
	(216708, 118, '2014-03-01 00:54:48.000000', 'temperatura', 1195.0000, 'ºC'),
	(216709, 118, '2014-03-01 00:54:49.000000', 'temperatura', 795.0000, 'ºC'),
	(216710, 118, '2014-03-01 00:54:50.000000', 'temperatura', 394.0000, 'ºC'),
	(216711, 118, '2014-03-01 00:54:51.000000', 'temperatura', 782.0000, 'ºC'),
	(216712, 118, '2014-03-01 00:54:52.000000', 'temperatura', 332.0000, 'ºC'),
	(216713, 118, '2014-03-01 00:54:53.000000', 'temperatura', 513.0000, 'ºC'),
	(216714, 118, '2014-03-01 00:54:54.000000', 'temperatura', 370.0000, 'ºC'),
	(216715, 118, '2014-03-01 00:54:55.000000', 'temperatura', 311.0000, 'ºC'),
	(216716, 118, '2014-03-01 00:54:56.000000', 'temperatura', 444.0000, 'ºC'),
	(216717, 118, '2014-03-01 00:54:57.000000', 'temperatura', 87.0000, 'ºC'),
	(216718, 118, '2014-03-01 00:54:58.000000', 'temperatura', 305.0000, 'ºC'),
	(216719, 118, '2014-03-01 00:54:59.000000', 'temperatura', 64.0000, 'ºC'),
	(216720, 118, '2014-03-01 00:55:00.000000', 'temperatura', 606.0000, 'ºC'),
	(216721, 118, '2014-03-01 00:55:01.000000', 'temperatura', 437.0000, 'ºC'),
	(216722, 118, '2014-03-01 00:55:02.000000', 'temperatura', 371.0000, 'ºC'),
	(216723, 118, '2014-03-01 00:55:03.000000', 'temperatura', 541.0000, 'ºC'),
	(216724, 118, '2014-03-01 00:55:04.000000', 'temperatura', 392.0000, 'ºC'),
	(216725, 118, '2014-03-01 00:55:05.000000', 'temperatura', 337.0000, 'ºC'),
	(216726, 118, '2014-03-01 00:55:06.000000', 'temperatura', 512.0000, 'ºC'),
	(216727, 118, '2014-03-01 00:55:07.000000', 'temperatura', 348.0000, 'ºC'),
	(216728, 118, '2014-03-01 00:55:08.000000', 'temperatura', 205.0000, 'ºC'),
	(216729, 118, '2014-03-01 00:55:09.000000', 'temperatura', 1180.0000, 'ºC'),
	(216730, 118, '2014-03-01 00:55:10.000000', 'temperatura', 486.0000, 'ºC'),
	(216731, 118, '2014-03-01 00:55:11.000000', 'temperatura', 89.0000, 'ºC'),
	(216732, 118, '2014-03-01 00:55:12.000000', 'temperatura', 191.0000, 'ºC'),
	(216733, 118, '2014-03-01 00:55:13.000000', 'temperatura', 686.0000, 'ºC'),
	(216734, 118, '2014-03-01 00:55:14.000000', 'temperatura', 458.0000, 'ºC'),
	(216735, 118, '2014-03-01 00:55:15.000000', 'temperatura', 231.0000, 'ºC'),
	(216736, 118, '2014-03-01 00:55:16.000000', 'temperatura', 984.0000, 'ºC'),
	(216737, 118, '2014-03-01 00:55:17.000000', 'temperatura', 627.0000, 'ºC'),
	(216738, 118, '2014-03-01 00:55:18.000000', 'temperatura', 182.0000, 'ºC'),
	(216739, 118, '2014-03-01 00:55:19.000000', 'temperatura', 230.0000, 'ºC'),
	(216740, 118, '2014-03-01 00:55:20.000000', 'temperatura', 605.0000, 'ºC'),
	(216741, 118, '2014-03-01 00:55:21.000000', 'temperatura', 1136.0000, 'ºC'),
	(216742, 118, '2014-03-01 00:55:22.000000', 'temperatura', 266.0000, 'ºC'),
	(216743, 118, '2014-03-01 00:55:23.000000', 'temperatura', 321.0000, 'ºC'),
	(216744, 118, '2014-03-01 00:55:24.000000', 'temperatura', 808.0000, 'ºC'),
	(216745, 118, '2014-03-01 00:55:25.000000', 'temperatura', 680.0000, 'ºC'),
	(216746, 118, '2014-03-01 00:55:26.000000', 'temperatura', 973.0000, 'ºC'),
	(216747, 118, '2014-03-01 00:55:27.000000', 'temperatura', 426.0000, 'ºC'),
	(216748, 118, '2014-03-01 00:55:28.000000', 'temperatura', 413.0000, 'ºC'),
	(216749, 118, '2014-03-01 00:55:29.000000', 'temperatura', 789.0000, 'ºC'),
	(216750, 118, '2014-03-01 00:55:30.000000', 'temperatura', 304.0000, 'ºC'),
	(216751, 118, '2014-03-01 00:55:31.000000', 'temperatura', 353.0000, 'ºC'),
	(216752, 118, '2014-03-01 00:55:32.000000', 'temperatura', 854.0000, 'ºC'),
	(216753, 118, '2014-03-01 00:55:33.000000', 'temperatura', 813.0000, 'ºC'),
	(216754, 118, '2014-03-01 00:55:34.000000', 'temperatura', 304.0000, 'ºC'),
	(216755, 118, '2014-03-01 00:55:35.000000', 'temperatura', 279.0000, 'ºC'),
	(216756, 118, '2014-03-01 00:55:36.000000', 'temperatura', 485.0000, 'ºC'),
	(216757, 118, '2014-03-01 00:55:37.000000', 'temperatura', 388.0000, 'ºC'),
	(216758, 118, '2014-03-01 00:55:38.000000', 'temperatura', 486.0000, 'ºC'),
	(216759, 118, '2014-03-01 00:55:39.000000', 'temperatura', 67.0000, 'ºC'),
	(216760, 118, '2014-03-01 00:55:40.000000', 'temperatura', 76.0000, 'ºC'),
	(216761, 118, '2014-03-01 00:55:41.000000', 'temperatura', 182.0000, 'ºC'),
	(216762, 118, '2014-03-01 00:55:42.000000', 'temperatura', 681.0000, 'ºC'),
	(216763, 118, '2014-03-01 00:55:43.000000', 'temperatura', 459.0000, 'ºC'),
	(216764, 118, '2014-03-01 00:55:44.000000', 'temperatura', 252.0000, 'ºC'),
	(216765, 118, '2014-03-01 00:55:45.000000', 'temperatura', 1082.0000, 'ºC'),
	(216766, 118, '2014-03-01 00:55:46.000000', 'temperatura', 1056.0000, 'ºC'),
	(216767, 118, '2014-03-01 00:55:47.000000', 'temperatura', 836.0000, 'ºC'),
	(216768, 118, '2014-03-01 00:55:48.000000', 'temperatura', 1010.0000, 'ºC'),
	(216769, 118, '2014-03-01 00:55:49.000000', 'temperatura', 142.0000, 'ºC'),
	(216770, 118, '2014-03-01 00:55:50.000000', 'temperatura', 82.0000, 'ºC'),
	(216771, 118, '2014-03-01 00:55:51.000000', 'temperatura', 1186.0000, 'ºC'),
	(216772, 118, '2014-03-01 00:55:52.000000', 'temperatura', 884.0000, 'ºC'),
	(216773, 118, '2014-03-01 00:55:53.000000', 'temperatura', 862.0000, 'ºC'),
	(216774, 118, '2014-03-01 00:55:54.000000', 'temperatura', 457.0000, 'ºC'),
	(216775, 118, '2014-03-01 00:55:55.000000', 'temperatura', 903.0000, 'ºC'),
	(216776, 118, '2014-03-01 00:55:56.000000', 'temperatura', 741.0000, 'ºC'),
	(216777, 118, '2014-03-01 00:55:57.000000', 'temperatura', 997.0000, 'ºC'),
	(216778, 118, '2014-03-01 00:55:58.000000', 'temperatura', 364.0000, 'ºC'),
	(216779, 118, '2014-03-01 00:55:59.000000', 'temperatura', 27.0000, 'ºC'),
	(216780, 118, '2014-03-01 00:56:00.000000', 'temperatura', 244.0000, 'ºC'),
	(216781, 118, '2014-03-01 00:56:01.000000', 'temperatura', 1138.0000, 'ºC'),
	(216782, 118, '2014-03-01 00:56:02.000000', 'temperatura', 160.0000, 'ºC'),
	(216783, 118, '2014-03-01 00:56:03.000000', 'temperatura', 986.0000, 'ºC'),
	(216784, 118, '2014-03-01 00:56:04.000000', 'temperatura', 850.0000, 'ºC'),
	(216785, 118, '2014-03-01 00:56:05.000000', 'temperatura', 93.0000, 'ºC'),
	(216786, 118, '2014-03-01 00:56:06.000000', 'temperatura', 315.0000, 'ºC'),
	(216787, 118, '2014-03-01 00:56:07.000000', 'temperatura', 96.0000, 'ºC'),
	(216788, 118, '2014-03-01 00:56:08.000000', 'temperatura', 736.0000, 'ºC'),
	(216789, 118, '2014-03-01 00:56:09.000000', 'temperatura', 993.0000, 'ºC'),
	(216790, 118, '2014-03-01 00:56:10.000000', 'temperatura', 359.0000, 'ºC'),
	(216791, 118, '2014-03-01 00:56:11.000000', 'temperatura', 14.0000, 'ºC'),
	(216792, 118, '2014-03-01 00:56:12.000000', 'temperatura', 193.0000, 'ºC'),
	(216793, 118, '2014-03-01 00:56:13.000000', 'temperatura', 925.0000, 'ºC'),
	(216794, 118, '2014-03-01 00:56:14.000000', 'temperatura', 447.0000, 'ºC'),
	(216795, 118, '2014-03-01 00:56:15.000000', 'temperatura', 660.0000, 'ºC'),
	(216796, 118, '2014-03-01 00:56:16.000000', 'temperatura', 758.0000, 'ºC'),
	(216797, 118, '2014-03-01 00:56:17.000000', 'temperatura', 612.0000, 'ºC'),
	(216798, 118, '2014-03-01 00:56:18.000000', 'temperatura', 787.0000, 'ºC'),
	(216799, 118, '2014-03-01 00:56:19.000000', 'temperatura', 899.0000, 'ºC'),
	(216800, 118, '2014-03-01 00:56:20.000000', 'temperatura', 933.0000, 'ºC'),
	(216801, 118, '2014-03-01 00:56:21.000000', 'temperatura', 771.0000, 'ºC'),
	(216802, 118, '2014-03-01 00:56:22.000000', 'temperatura', 1054.0000, 'ºC'),
	(216803, 118, '2014-03-01 00:56:23.000000', 'temperatura', 558.0000, 'ºC'),
	(216804, 118, '2014-03-01 00:56:24.000000', 'temperatura', 831.0000, 'ºC'),
	(216805, 118, '2014-03-01 00:56:25.000000', 'temperatura', 78.0000, 'ºC'),
	(216806, 118, '2014-03-01 00:56:26.000000', 'temperatura', 300.0000, 'ºC'),
	(216807, 118, '2014-03-01 00:56:27.000000', 'temperatura', 67.0000, 'ºC'),
	(216808, 118, '2014-03-01 00:56:28.000000', 'temperatura', 633.0000, 'ºC'),
	(216809, 118, '2014-03-01 00:56:29.000000', 'temperatura', 567.0000, 'ºC'),
	(216810, 118, '2014-03-01 00:56:30.000000', 'temperatura', 936.0000, 'ºC'),
	(216811, 118, '2014-03-01 00:56:31.000000', 'temperatura', 581.0000, 'ºC'),
	(216812, 118, '2014-03-01 00:56:32.000000', 'temperatura', 94.0000, 'ºC'),
	(216813, 118, '2014-03-01 00:56:33.000000', 'temperatura', 1130.0000, 'ºC'),
	(216814, 118, '2014-03-01 00:56:34.000000', 'temperatura', 568.0000, 'ºC'),
	(216815, 118, '2014-03-01 00:56:35.000000', 'temperatura', 652.0000, 'ºC'),
	(216816, 118, '2014-03-01 00:56:36.000000', 'temperatura', 356.0000, 'ºC'),
	(216817, 118, '2014-03-01 00:56:37.000000', 'temperatura', 1022.0000, 'ºC'),
	(216818, 118, '2014-03-01 00:56:38.000000', 'temperatura', 446.0000, 'ºC'),
	(216819, 118, '2014-03-01 00:56:39.000000', 'temperatura', 362.0000, 'ºC'),
	(216820, 118, '2014-03-01 00:56:40.000000', 'temperatura', 474.0000, 'ºC'),
	(216821, 118, '2014-03-01 00:56:41.000000', 'temperatura', 82.0000, 'ºC'),
	(216822, 118, '2014-03-01 00:56:42.000000', 'temperatura', 190.0000, 'ºC'),
	(216823, 118, '2014-03-01 00:56:43.000000', 'temperatura', 704.0000, 'ºC'),
	(216824, 118, '2014-03-01 00:56:44.000000', 'temperatura', 550.0000, 'ºC'),
	(216825, 118, '2014-03-01 00:56:45.000000', 'temperatura', 640.0000, 'ºC'),
	(216826, 118, '2014-03-01 00:56:46.000000', 'temperatura', 350.0000, 'ºC'),
	(216827, 118, '2014-03-01 00:56:47.000000', 'temperatura', 1029.0000, 'ºC'),
	(216828, 118, '2014-03-01 00:56:48.000000', 'temperatura', 495.0000, 'ºC'),
	(216829, 118, '2014-03-01 00:56:49.000000', 'temperatura', 591.0000, 'ºC'),
	(216830, 118, '2014-03-01 00:56:50.000000', 'temperatura', 271.0000, 'ºC'),
	(216831, 118, '2014-03-01 00:56:51.000000', 'temperatura', 781.0000, 'ºC'),
	(216832, 118, '2014-03-01 00:56:52.000000', 'temperatura', 694.0000, 'ºC'),
	(216833, 118, '2014-03-01 00:56:53.000000', 'temperatura', 1128.0000, 'ºC'),
	(216834, 118, '2014-03-01 00:56:54.000000', 'temperatura', 1156.0000, 'ºC'),
	(216835, 118, '2014-03-01 00:56:55.000000', 'temperatura', 1198.0000, 'ºC'),
	(216836, 118, '2014-03-01 00:56:56.000000', 'temperatura', 123.0000, 'ºC'),
	(216837, 118, '2014-03-01 00:56:57.000000', 'temperatura', 621.0000, 'ºC'),
	(216838, 118, '2014-03-01 00:56:58.000000', 'temperatura', 337.0000, 'ºC'),
	(216839, 118, '2014-03-01 00:56:59.000000', 'temperatura', 1022.0000, 'ºC'),
	(216840, 118, '2014-03-01 00:57:00.000000', 'temperatura', 501.0000, 'ºC'),
	(216841, 118, '2014-03-01 00:57:01.000000', 'temperatura', 638.0000, 'ºC'),
	(216842, 118, '2014-03-01 00:57:02.000000', 'temperatura', 486.0000, 'ºC'),
	(216843, 118, '2014-03-01 00:57:03.000000', 'temperatura', 517.0000, 'ºC'),
	(216844, 118, '2014-03-01 00:57:04.000000', 'temperatura', 1128.0000, 'ºC'),
	(216845, 118, '2014-03-01 00:57:05.000000', 'temperatura', 488.0000, 'ºC'),
	(216846, 118, '2014-03-01 00:57:06.000000', 'temperatura', 257.0000, 'ºC'),
	(216847, 118, '2014-03-01 00:57:07.000000', 'temperatura', 1023.0000, 'ºC'),
	(216848, 118, '2014-03-01 00:57:08.000000', 'temperatura', 742.0000, 'ºC'),
	(216849, 118, '2014-03-01 00:57:09.000000', 'temperatura', 641.0000, 'ºC'),
	(216850, 118, '2014-03-01 00:57:10.000000', 'temperatura', 982.0000, 'ºC'),
	(216851, 118, '2014-03-01 00:57:11.000000', 'temperatura', 588.0000, 'ºC'),
	(216852, 118, '2014-03-01 00:57:12.000000', 'temperatura', 1196.0000, 'ºC'),
	(216853, 118, '2014-03-01 00:57:13.000000', 'temperatura', 613.0000, 'ºC'),
	(216854, 118, '2014-03-01 00:57:14.000000', 'temperatura', 678.0000, 'ºC'),
	(216855, 118, '2014-03-01 00:57:15.000000', 'temperatura', 352.0000, 'ºC'),
	(216856, 118, '2014-03-01 00:57:16.000000', 'temperatura', 927.0000, 'ºC'),
	(216857, 118, '2014-03-01 00:57:17.000000', 'temperatura', 1181.0000, 'ºC'),
	(216858, 118, '2014-03-01 00:57:18.000000', 'temperatura', 722.0000, 'ºC'),
	(216859, 118, '2014-03-01 00:57:19.000000', 'temperatura', 67.0000, 'ºC'),
	(216860, 118, '2014-03-01 00:57:20.000000', 'temperatura', 572.0000, 'ºC'),
	(216861, 118, '2014-03-01 00:57:21.000000', 'temperatura', 259.0000, 'ºC'),
	(216862, 118, '2014-03-01 00:57:22.000000', 'temperatura', 779.0000, 'ºC'),
	(216863, 118, '2014-03-01 00:57:23.000000', 'temperatura', 718.0000, 'ºC'),
	(216864, 118, '2014-03-01 00:57:24.000000', 'temperatura', 55.0000, 'ºC'),
	(216865, 118, '2014-03-01 00:57:25.000000', 'temperatura', 519.0000, 'ºC'),
	(216866, 118, '2014-03-01 00:57:26.000000', 'temperatura', 31.0000, 'ºC'),
	(216867, 118, '2014-03-01 00:57:27.000000', 'temperatura', 998.0000, 'ºC'),
	(216868, 118, '2014-03-01 00:57:28.000000', 'temperatura', 97.0000, 'ºC'),
	(216869, 118, '2014-03-01 00:57:29.000000', 'temperatura', 1091.0000, 'ºC'),
	(216870, 118, '2014-03-01 00:57:30.000000', 'temperatura', 364.0000, 'ºC'),
	(216871, 118, '2014-03-01 00:57:31.000000', 'temperatura', 947.0000, 'ºC'),
	(216872, 118, '2014-03-01 00:57:32.000000', 'temperatura', 46.0000, 'ºC'),
	(216873, 118, '2014-03-01 00:57:33.000000', 'temperatura', 987.0000, 'ºC'),
	(216874, 118, '2014-03-01 00:57:34.000000', 'temperatura', 1197.0000, 'ºC'),
	(216875, 118, '2014-03-01 00:57:35.000000', 'temperatura', 625.0000, 'ºC'),
	(216876, 118, '2014-03-01 00:57:36.000000', 'temperatura', 734.0000, 'ºC'),
	(216877, 118, '2014-03-01 00:57:37.000000', 'temperatura', 596.0000, 'ºC'),
	(216878, 118, '2014-03-01 00:57:38.000000', 'temperatura', 779.0000, 'ºC'),
	(216879, 118, '2014-03-01 00:57:39.000000', 'temperatura', 907.0000, 'ºC'),
	(216880, 118, '2014-03-01 00:57:40.000000', 'temperatura', 997.0000, 'ºC'),
	(216881, 118, '2014-03-01 00:57:41.000000', 'temperatura', 1064.0000, 'ºC'),
	(216882, 118, '2014-03-01 00:57:42.000000', 'temperatura', 1130.0000, 'ºC'),
	(216883, 118, '2014-03-01 00:57:43.000000', 'temperatura', 60.0000, 'ºC'),
	(216884, 118, '2014-03-01 00:57:44.000000', 'temperatura', 509.0000, 'ºC'),
	(216885, 118, '2014-03-01 00:57:45.000000', 'temperatura', 1168.0000, 'ºC'),
	(216886, 118, '2014-03-01 00:57:46.000000', 'temperatura', 710.0000, 'ºC'),
	(216887, 118, '2014-03-01 00:57:47.000000', 'temperatura', 49.0000, 'ºC'),
	(216888, 118, '2014-03-01 00:57:48.000000', 'temperatura', 515.0000, 'ºC'),
	(216889, 118, '2014-03-01 00:57:49.000000', 'temperatura', 28.0000, 'ºC'),
	(216890, 118, '2014-03-01 00:57:50.000000', 'temperatura', 997.0000, 'ºC'),
	(216891, 118, '2014-03-01 00:57:51.000000', 'temperatura', 102.0000, 'ºC'),
	(216892, 118, '2014-03-01 00:57:52.000000', 'temperatura', 1117.0000, 'ºC'),
	(216893, 118, '2014-03-01 00:57:53.000000', 'temperatura', 481.0000, 'ºC'),
	(216894, 118, '2014-03-01 00:57:54.000000', 'temperatura', 255.0000, 'ºC'),
	(216895, 118, '2014-03-01 00:57:55.000000', 'temperatura', 1030.0000, 'ºC'),
	(216896, 118, '2014-03-01 00:57:56.000000', 'temperatura', 788.0000, 'ºC'),
	(216897, 118, '2014-03-01 00:57:57.000000', 'temperatura', 851.0000, 'ºC'),
	(216898, 118, '2014-03-01 00:57:58.000000', 'temperatura', 692.0000, 'ºC'),
	(216899, 118, '2014-03-01 00:57:59.000000', 'temperatura', 905.0000, 'ºC'),
	(216900, 118, '2014-03-01 00:58:00.000000', 'temperatura', 53.0000, 'ºC'),
	(216901, 118, '2014-03-01 00:58:01.000000', 'temperatura', 1147.0000, 'ºC'),
	(216902, 118, '2014-03-01 00:58:02.000000', 'temperatura', 777.0000, 'ºC'),
	(216903, 118, '2014-03-01 00:58:03.000000', 'temperatura', 443.0000, 'ºC'),
	(216904, 118, '2014-03-01 00:58:04.000000', 'temperatura', 1086.0000, 'ºC'),
	(216905, 118, '2014-03-01 00:58:05.000000', 'temperatura', 503.0000, 'ºC'),
	(216906, 118, '2014-03-01 00:58:06.000000', 'temperatura', 457.0000, 'ºC'),
	(216907, 118, '2014-03-01 00:58:07.000000', 'temperatura', 778.0000, 'ºC'),
	(216908, 118, '2014-03-01 00:58:08.000000', 'temperatura', 118.0000, 'ºC'),
	(216909, 118, '2014-03-01 00:58:09.000000', 'temperatura', 657.0000, 'ºC'),
	(216910, 118, '2014-03-01 00:58:10.000000', 'temperatura', 530.0000, 'ºC'),
	(216911, 118, '2014-03-01 00:58:11.000000', 'temperatura', 682.0000, 'ºC'),
	(216912, 118, '2014-03-01 00:58:12.000000', 'temperatura', 620.0000, 'ºC'),
	(216913, 118, '2014-03-01 00:58:13.000000', 'temperatura', 1053.0000, 'ºC'),
	(216914, 118, '2014-03-01 00:58:14.000000', 'temperatura', 1006.0000, 'ºC'),
	(216915, 118, '2014-03-01 00:58:15.000000', 'temperatura', 671.0000, 'ºC'),
	(216916, 118, '2014-03-01 00:58:16.000000', 'temperatura', 339.0000, 'ºC'),
	(216917, 118, '2014-03-01 00:58:17.000000', 'temperatura', 884.0000, 'ºC'),
	(216918, 118, '2014-03-01 00:58:18.000000', 'temperatura', 1001.0000, 'ºC'),
	(216919, 118, '2014-03-01 00:58:19.000000', 'temperatura', 1156.0000, 'ºC'),
	(216920, 118, '2014-03-01 00:58:20.000000', 'temperatura', 374.0000, 'ºC'),
	(216921, 118, '2014-03-01 00:58:21.000000', 'temperatura', 805.0000, 'ºC'),
	(216922, 118, '2014-03-01 00:58:22.000000', 'temperatura', 501.0000, 'ºC'),
	(216923, 118, '2014-03-01 00:58:23.000000', 'temperatura', 91.0000, 'ºC'),
	(216924, 118, '2014-03-01 00:58:24.000000', 'temperatura', 153.0000, 'ºC'),
	(216925, 118, '2014-03-01 00:58:25.000000', 'temperatura', 494.0000, 'ºC'),
	(216926, 118, '2014-03-01 00:58:26.000000', 'temperatura', 811.0000, 'ºC'),
	(216927, 118, '2014-03-01 00:58:27.000000', 'temperatura', 175.0000, 'ºC'),
	(216928, 118, '2014-03-01 00:58:28.000000', 'temperatura', 841.0000, 'ºC'),
	(216929, 118, '2014-03-01 00:58:29.000000', 'temperatura', 79.0000, 'ºC'),
	(216930, 118, '2014-03-01 00:58:30.000000', 'temperatura', 275.0000, 'ºC'),
	(216931, 118, '2014-03-01 00:58:31.000000', 'temperatura', 1136.0000, 'ºC'),
	(216932, 118, '2014-03-01 00:58:32.000000', 'temperatura', 56.0000, 'ºC'),
	(216933, 118, '2014-03-01 00:58:33.000000', 'temperatura', 474.0000, 'ºC'),
	(216934, 118, '2014-03-01 00:58:34.000000', 'temperatura', 1004.0000, 'ºC'),
	(216935, 118, '2014-03-01 00:58:35.000000', 'temperatura', 1195.0000, 'ºC'),
	(216936, 118, '2014-03-01 00:58:36.000000', 'temperatura', 564.0000, 'ºC'),
	(216937, 118, '2014-03-01 00:58:37.000000', 'temperatura', 438.0000, 'ºC'),
	(216938, 118, '2014-03-01 00:58:38.000000', 'temperatura', 498.0000, 'ºC'),
	(216939, 118, '2014-03-01 00:58:39.000000', 'temperatura', 1176.0000, 'ºC'),
	(216940, 118, '2014-03-01 00:58:40.000000', 'temperatura', 787.0000, 'ºC'),
	(216941, 118, '2014-03-01 00:58:41.000000', 'temperatura', 408.0000, 'ºC'),
	(216942, 118, '2014-03-01 00:58:42.000000', 'temperatura', 877.0000, 'ºC'),
	(216943, 118, '2014-03-01 00:58:43.000000', 'temperatura', 762.0000, 'ºC'),
	(216944, 118, '2014-03-01 00:58:44.000000', 'temperatura', 1180.0000, 'ºC'),
	(216945, 118, '2014-03-01 00:58:45.000000', 'temperatura', 16.0000, 'ºC'),
	(216946, 118, '2014-03-01 00:58:46.000000', 'temperatura', 141.0000, 'ºC'),
	(216947, 118, '2014-03-01 00:58:47.000000', 'temperatura', 655.0000, 'ºC'),
	(216948, 118, '2014-03-01 00:58:48.000000', 'temperatura', 455.0000, 'ºC'),
	(216949, 118, '2014-03-01 00:58:49.000000', 'temperatura', 311.0000, 'ºC'),
	(216950, 118, '2014-03-01 00:58:50.000000', 'temperatura', 189.0000, 'ºC'),
	(216951, 118, '2014-03-01 00:58:51.000000', 'temperatura', 11.0000, 'ºC'),
	(216952, 118, '2014-03-01 00:58:52.000000', 'temperatura', 691.0000, 'ºC'),
	(216953, 118, '2014-03-01 00:58:53.000000', 'temperatura', 1023.0000, 'ºC'),
	(216954, 118, '2014-03-01 00:58:54.000000', 'temperatura', 641.0000, 'ºC'),
	(216955, 118, '2014-03-01 00:58:55.000000', 'temperatura', 136.0000, 'ºC'),
	(216956, 118, '2014-03-01 00:58:56.000000', 'temperatura', 1158.0000, 'ºC'),
	(216957, 118, '2014-03-01 00:58:57.000000', 'temperatura', 581.0000, 'ºC'),
	(216958, 118, '2014-03-01 00:58:58.000000', 'temperatura', 633.0000, 'ºC'),
	(216959, 118, '2014-03-01 00:58:59.000000', 'temperatura', 224.0000, 'ºC'),
	(216960, 118, '2014-03-01 00:59:00.000000', 'temperatura', 418.0000, 'ºC'),
	(216961, 118, '2014-03-01 00:59:01.000000', 'temperatura', 221.0000, 'ºC'),
	(216962, 118, '2014-03-01 00:59:02.000000', 'temperatura', 1050.0000, 'ºC'),
	(216963, 118, '2014-03-01 00:59:03.000000', 'temperatura', 987.0000, 'ºC'),
	(216964, 118, '2014-03-01 00:59:04.000000', 'temperatura', 587.0000, 'ºC'),
	(216965, 118, '2014-03-01 00:59:05.000000', 'temperatura', 1175.0000, 'ºC'),
	(216966, 118, '2014-03-01 00:59:06.000000', 'temperatura', 516.0000, 'ºC'),
	(216967, 118, '2014-03-01 00:59:07.000000', 'temperatura', 252.0000, 'ºC'),
	(216968, 118, '2014-03-01 00:59:08.000000', 'temperatura', 916.0000, 'ºC'),
	(216969, 118, '2014-03-01 00:59:09.000000', 'temperatura', 222.0000, 'ºC'),
	(216970, 118, '2014-03-01 00:59:10.000000', 'temperatura', 764.0000, 'ºC'),
	(216971, 118, '2014-03-01 00:59:11.000000', 'temperatura', 754.0000, 'ºC'),
	(216972, 118, '2014-03-01 00:59:12.000000', 'temperatura', 278.0000, 'ºC'),
	(216973, 118, '2014-03-01 00:59:13.000000', 'temperatura', 328.0000, 'ºC'),
	(216974, 118, '2014-03-01 00:59:14.000000', 'temperatura', 808.0000, 'ºC'),
	(216975, 118, '2014-03-01 00:59:15.000000', 'temperatura', 657.0000, 'ºC'),
	(216976, 118, '2014-03-01 00:59:16.000000', 'temperatura', 860.0000, 'ºC'),
	(216977, 118, '2014-03-01 00:59:17.000000', 'temperatura', 1128.0000, 'ºC'),
	(216978, 118, '2014-03-01 00:59:18.000000', 'temperatura', 663.0000, 'ºC'),
	(216979, 118, '2014-03-01 00:59:19.000000', 'temperatura', 1131.0000, 'ºC'),
	(216980, 118, '2014-03-01 00:59:20.000000', 'temperatura', 65.0000, 'ºC'),
	(216981, 118, '2014-03-01 00:59:21.000000', 'temperatura', 534.0000, 'ºC'),
	(216982, 118, '2014-03-01 00:59:22.000000', 'temperatura', 77.0000, 'ºC'),
	(216983, 118, '2014-03-01 00:59:23.000000', 'temperatura', 1180.0000, 'ºC'),
	(216984, 118, '2014-03-01 00:59:24.000000', 'temperatura', 872.0000, 'ºC'),
	(216985, 118, '2014-03-01 00:59:25.000000', 'temperatura', 820.0000, 'ºC'),
	(216986, 118, '2014-03-01 00:59:26.000000', 'temperatura', 283.0000, 'ºC'),
	(216987, 118, '2014-03-01 00:59:27.000000', 'temperatura', 154.0000, 'ºC'),
	(216988, 118, '2014-03-01 00:59:28.000000', 'temperatura', 1125.0000, 'ºC'),
	(216989, 118, '2014-03-01 00:59:29.000000', 'temperatura', 362.0000, 'ºC'),
	(216990, 118, '2014-03-01 00:59:30.000000', 'temperatura', 835.0000, 'ºC'),
	(216991, 118, '2014-03-01 00:59:31.000000', 'temperatura', 691.0000, 'ºC'),
	(216992, 118, '2014-03-01 00:59:32.000000', 'temperatura', 950.0000, 'ºC'),
	(216993, 118, '2014-03-01 00:59:33.000000', 'temperatura', 277.0000, 'ºC'),
	(216994, 118, '2014-03-01 00:59:34.000000', 'temperatura', 936.0000, 'ºC'),
	(216995, 118, '2014-03-01 00:59:35.000000', 'temperatura', 250.0000, 'ºC'),
	(216996, 118, '2014-03-01 00:59:36.000000', 'temperatura', 843.0000, 'ºC'),
	(216997, 118, '2014-03-01 00:59:37.000000', 'temperatura', 1064.0000, 'ºC'),
	(216998, 118, '2014-03-01 00:59:38.000000', 'temperatura', 390.0000, 'ºC'),
	(216999, 118, '2014-03-01 00:59:39.000000', 'temperatura', 1161.0000, 'ºC'),
	(217000, 118, '2014-03-01 00:59:40.000000', 'temperatura', 1037.0000, 'ºC'),
	(217001, 118, '2014-03-01 00:59:41.000000', 'temperatura', 500.0000, 'ºC'),
	(217002, 118, '2014-03-01 00:59:42.000000', 'temperatura', 589.0000, 'ºC'),
	(217003, 118, '2014-03-01 00:59:43.000000', 'temperatura', 248.0000, 'ºC'),
	(217004, 118, '2014-03-01 00:59:44.000000', 'temperatura', 672.0000, 'ºC'),
	(217005, 118, '2014-03-01 00:59:45.000000', 'temperatura', 215.0000, 'ºC'),
	(217006, 118, '2014-03-01 00:59:46.000000', 'temperatura', 261.0000, 'ºC'),
	(217007, 118, '2014-03-01 00:59:47.000000', 'temperatura', 662.0000, 'ºC'),
	(217008, 118, '2014-03-01 00:59:48.000000', 'temperatura', 125.0000, 'ºC'),
	(217009, 118, '2014-03-01 00:59:49.000000', 'temperatura', 1040.0000, 'ºC'),
	(217010, 118, '2014-03-01 00:59:50.000000', 'temperatura', 27.0000, 'ºC'),
	(217011, 118, '2014-03-01 00:59:51.000000', 'temperatura', 613.0000, 'ºC'),
	(217012, 118, '2014-03-01 00:59:52.000000', 'temperatura', 587.0000, 'ºC'),
	(217013, 118, '2014-03-01 00:59:53.000000', 'temperatura', 1095.0000, 'ºC'),
	(217014, 118, '2014-03-01 00:59:54.000000', 'temperatura', 116.0000, 'ºC'),
	(217015, 118, '2014-03-01 00:59:55.000000', 'temperatura', 895.0000, 'ºC'),
	(217016, 118, '2014-03-01 00:59:56.000000', 'temperatura', 528.0000, 'ºC'),
	(217017, 118, '2014-03-01 00:59:57.000000', 'temperatura', 1156.0000, 'ºC'),
	(217018, 118, '2014-03-01 00:59:58.000000', 'temperatura', 597.0000, 'ºC'),
	(217019, 118, '2014-03-01 00:59:59.000000', 'temperatura', 715.0000, 'ºC'),
	(217020, 118, '2014-03-01 01:00:00.000000', 'temperatura', 584.0000, 'ºC'),
	(217021, 118, '2014-03-01 01:00:01.000000', 'temperatura', 777.0000, 'ºC'),
	(217022, 118, '2014-03-01 01:00:02.000000', 'temperatura', 933.0000, 'ºC'),
	(217023, 118, '2014-03-01 01:00:03.000000', 'temperatura', 1135.0000, 'ºC'),
	(217024, 118, '2014-03-01 01:00:04.000000', 'temperatura', 477.0000, 'ºC'),
	(217025, 118, '2014-03-01 01:00:05.000000', 'temperatura', 180.0000, 'ºC'),
	(217026, 118, '2014-03-01 01:00:06.000000', 'temperatura', 668.0000, 'ºC'),
	(217027, 118, '2014-03-01 01:00:07.000000', 'temperatura', 404.0000, 'ºC'),
	(217028, 118, '2014-03-01 01:00:08.000000', 'temperatura', 13.0000, 'ºC'),
	(217029, 118, '2014-03-01 01:00:09.000000', 'temperatura', 55.0000, 'ºC'),
	(217030, 118, '2014-03-01 01:00:10.000000', 'temperatura', 237.0000, 'ºC'),
	(217031, 118, '2014-03-01 01:00:11.000000', 'temperatura', 1020.0000, 'ºC'),
	(217032, 118, '2014-03-01 01:00:12.000000', 'temperatura', 788.0000, 'ºC'),
	(217033, 118, '2014-03-01 01:00:13.000000', 'temperatura', 881.0000, 'ºC'),
	(217034, 118, '2014-03-01 01:00:14.000000', 'temperatura', 843.0000, 'ºC'),
	(217035, 118, '2014-03-01 01:00:15.000000', 'temperatura', 373.0000, 'ºC'),
	(217036, 118, '2014-03-01 01:00:16.000000', 'temperatura', 536.0000, 'ºC'),
	(217037, 118, '2014-03-01 01:00:17.000000', 'temperatura', 362.0000, 'ºC'),
	(217038, 118, '2014-03-01 01:00:18.000000', 'temperatura', 201.0000, 'ºC'),
	(217039, 118, '2014-03-01 01:00:19.000000', 'temperatura', 1119.0000, 'ºC'),
	(217040, 118, '2014-03-01 01:00:20.000000', 'temperatura', 195.0000, 'ºC'),
	(217041, 118, '2014-03-01 01:00:21.000000', 'temperatura', 17.0000, 'ºC'),
	(217042, 118, '2014-03-01 01:00:22.000000', 'temperatura', 703.0000, 'ºC'),
	(217043, 118, '2014-03-01 01:00:23.000000', 'temperatura', 1062.0000, 'ºC'),
	(217044, 118, '2014-03-01 01:00:24.000000', 'temperatura', 804.0000, 'ºC'),
	(217045, 118, '2014-03-01 01:00:25.000000', 'temperatura', 831.0000, 'ºC'),
	(217046, 118, '2014-03-01 01:00:26.000000', 'temperatura', 546.0000, 'ºC'),
	(217047, 118, '2014-03-01 01:00:27.000000', 'temperatura', 237.0000, 'ºC'),
	(217048, 118, '2014-03-01 01:00:28.000000', 'temperatura', 749.0000, 'ºC'),
	(217049, 118, '2014-03-01 01:00:29.000000', 'temperatura', 633.0000, 'ºC'),
	(217050, 118, '2014-03-01 01:00:30.000000', 'temperatura', 919.0000, 'ºC'),
	(217051, 118, '2014-03-01 01:00:31.000000', 'temperatura', 298.0000, 'ºC'),
	(217052, 118, '2014-03-01 01:00:32.000000', 'temperatura', 1134.0000, 'ºC'),
	(217053, 118, '2014-03-01 01:00:33.000000', 'temperatura', 1177.0000, 'ºC'),
	(217054, 118, '2014-03-01 01:00:34.000000', 'temperatura', 83.0000, 'ºC'),
	(217055, 118, '2014-03-01 01:00:35.000000', 'temperatura', 482.0000, 'ºC'),
	(217056, 118, '2014-03-01 01:00:36.000000', 'temperatura', 964.0000, 'ºC'),
	(217057, 118, '2014-03-01 01:00:37.000000', 'temperatura', 973.0000, 'ºC'),
	(217058, 118, '2014-03-01 01:00:38.000000', 'temperatura', 775.0000, 'ºC'),
	(217059, 118, '2014-03-01 01:00:39.000000', 'temperatura', 956.0000, 'ºC'),
	(217060, 118, '2014-03-01 01:00:40.000000', 'temperatura', 57.0000, 'ºC'),
	(217061, 118, '2014-03-01 01:00:41.000000', 'temperatura', 1015.0000, 'ºC'),
	(217062, 118, '2014-03-01 01:00:42.000000', 'temperatura', 103.0000, 'ºC'),
	(217063, 118, '2014-03-01 01:00:43.000000', 'temperatura', 1074.0000, 'ºC'),
	(217064, 118, '2014-03-01 01:00:44.000000', 'temperatura', 259.0000, 'ºC'),
	(217065, 118, '2014-03-01 01:00:45.000000', 'temperatura', 474.0000, 'ºC'),
	(217066, 118, '2014-03-01 01:00:46.000000', 'temperatura', 392.0000, 'ºC'),
	(217067, 118, '2014-03-01 01:00:47.000000', 'temperatura', 539.0000, 'ºC'),
	(217068, 118, '2014-03-01 01:00:48.000000', 'temperatura', 318.0000, 'ºC'),
	(217069, 118, '2014-03-01 01:00:49.000000', 'temperatura', 1175.0000, 'ºC'),
	(217070, 118, '2014-03-01 01:00:50.000000', 'temperatura', 123.0000, 'ºC'),
	(217071, 118, '2014-03-01 01:00:51.000000', 'temperatura', 690.0000, 'ºC'),
	(217072, 118, '2014-03-01 01:00:52.000000', 'temperatura', 681.0000, 'ºC'),
	(217073, 118, '2014-03-01 01:00:53.000000', 'temperatura', 136.0000, 'ºC'),
	(217074, 118, '2014-03-01 01:00:54.000000', 'temperatura', 1038.0000, 'ºC'),
	(217075, 118, '2014-03-01 01:00:55.000000', 'temperatura', 1181.0000, 'ºC'),
	(217076, 118, '2014-03-01 01:00:56.000000', 'temperatura', 392.0000, 'ºC'),
	(217077, 118, '2014-03-01 01:00:57.000000', 'temperatura', 817.0000, 'ºC'),
	(217078, 118, '2014-03-01 01:00:58.000000', 'temperatura', 510.0000, 'ºC'),
	(217079, 118, '2014-03-01 01:00:59.000000', 'temperatura', 100.0000, 'ºC'),
	(217080, 118, '2014-03-01 01:01:00.000000', 'temperatura', 171.0000, 'ºC'),
	(217081, 118, '2014-03-01 01:01:01.000000', 'temperatura', 553.0000, 'ºC'),
	(217082, 118, '2014-03-01 01:01:02.000000', 'temperatura', 1054.0000, 'ºC'),
	(217083, 118, '2014-03-01 01:01:03.000000', 'temperatura', 12.0000, 'ºC'),
	(217084, 118, '2014-03-01 01:01:04.000000', 'temperatura', 500.0000, 'ºC'),
	(217085, 118, '2014-03-01 01:01:05.000000', 'temperatura', 63.0000, 'ºC'),
	(217086, 118, '2014-03-01 01:01:06.000000', 'temperatura', 15.0000, 'ºC'),
	(217087, 118, '2014-03-01 01:01:07.000000', 'temperatura', 1089.0000, 'ºC'),
	(217088, 118, '2014-03-01 01:01:08.000000', 'temperatura', 598.0000, 'ºC'),
	(217089, 118, '2014-03-01 01:01:09.000000', 'temperatura', 924.0000, 'ºC'),
	(217090, 118, '2014-03-01 01:01:10.000000', 'temperatura', 425.0000, 'ºC'),
	(217091, 118, '2014-03-01 01:01:11.000000', 'temperatura', 554.0000, 'ºC'),
	(217092, 118, '2014-03-01 01:01:12.000000', 'temperatura', 294.0000, 'ºC'),
	(217093, 118, '2014-03-01 01:01:13.000000', 'temperatura', 1010.0000, 'ºC'),
	(217094, 118, '2014-03-01 01:01:14.000000', 'temperatura', 569.0000, 'ºC'),
	(217095, 118, '2014-03-01 01:01:15.000000', 'temperatura', 1015.0000, 'ºC'),
	(217096, 118, '2014-03-01 01:01:16.000000', 'temperatura', 968.0000, 'ºC'),
	(217097, 118, '2014-03-01 01:01:17.000000', 'temperatura', 596.0000, 'ºC'),
	(217098, 118, '2014-03-01 01:01:18.000000', 'temperatura', 76.0000, 'ºC'),
	(217099, 118, '2014-03-01 01:01:19.000000', 'temperatura', 995.0000, 'ºC'),
	(217100, 118, '2014-03-01 01:01:20.000000', 'temperatura', 1144.0000, 'ºC'),
	(217101, 118, '2014-03-01 01:01:21.000000', 'temperatura', 338.0000, 'ºC'),
	(217102, 118, '2014-03-01 01:01:22.000000', 'temperatura', 659.0000, 'ºC'),
	(217103, 118, '2014-03-01 01:01:23.000000', 'temperatura', 1079.0000, 'ºC'),
	(217104, 118, '2014-03-01 01:01:24.000000', 'temperatura', 1018.0000, 'ºC'),
	(217105, 118, '2014-03-01 01:01:25.000000', 'temperatura', 654.0000, 'ºC'),
	(217106, 118, '2014-03-01 01:01:26.000000', 'temperatura', 218.0000, 'ºC'),
	(217107, 118, '2014-03-01 01:01:27.000000', 'temperatura', 328.0000, 'ºC'),
	(217108, 118, '2014-03-01 01:01:28.000000', 'temperatura', 986.0000, 'ºC'),
	(217109, 118, '2014-03-01 01:01:29.000000', 'temperatura', 346.0000, 'ºC'),
	(217110, 118, '2014-03-01 01:01:30.000000', 'temperatura', 1173.0000, 'ºC'),
	(217111, 118, '2014-03-01 01:01:31.000000', 'temperatura', 29.0000, 'ºC'),
	(217112, 118, '2014-03-01 01:01:32.000000', 'temperatura', 225.0000, 'ºC'),
	(217113, 118, '2014-03-01 01:01:33.000000', 'temperatura', 1040.0000, 'ºC'),
	(217114, 118, '2014-03-01 01:01:34.000000', 'temperatura', 925.0000, 'ºC'),
	(217115, 118, '2014-03-01 01:01:35.000000', 'temperatura', 307.0000, 'ºC'),
	(217116, 118, '2014-03-01 01:01:36.000000', 'temperatura', 1161.0000, 'ºC'),
	(217117, 118, '2014-03-01 01:01:37.000000', 'temperatura', 82.0000, 'ºC'),
	(217118, 118, '2014-03-01 01:01:38.000000', 'temperatura', 527.0000, 'ºC'),
	(217119, 118, '2014-03-01 01:01:39.000000', 'temperatura', 1191.0000, 'ºC'),
	(217120, 118, '2014-03-01 01:01:40.000000', 'temperatura', 774.0000, 'ºC'),
	(217121, 118, '2014-03-01 01:01:41.000000', 'temperatura', 296.0000, 'ºC'),
	(217122, 118, '2014-03-01 01:01:42.000000', 'temperatura', 360.0000, 'ºC'),
	(217123, 118, '2014-03-01 01:01:43.000000', 'temperatura', 912.0000, 'ºC'),
	(217124, 118, '2014-03-01 01:01:44.000000', 'temperatura', 1080.0000, 'ºC'),
	(217125, 118, '2014-03-01 01:01:45.000000', 'temperatura', 265.0000, 'ºC'),
	(217126, 118, '2014-03-01 01:01:46.000000', 'temperatura', 484.0000, 'ºC'),
	(217127, 118, '2014-03-01 01:01:47.000000', 'temperatura', 425.0000, 'ºC'),
	(217128, 118, '2014-03-01 01:01:48.000000', 'temperatura', 677.0000, 'ºC'),
	(217129, 118, '2014-03-01 01:01:49.000000', 'temperatura', 908.0000, 'ºC'),
	(217130, 118, '2014-03-01 01:01:50.000000', 'temperatura', 108.0000, 'ºC'),
	(217131, 118, '2014-03-01 01:01:51.000000', 'temperatura', 218.0000, 'ºC'),
	(217132, 118, '2014-03-01 01:01:52.000000', 'temperatura', 768.0000, 'ºC'),
	(217133, 118, '2014-03-01 01:01:53.000000', 'temperatura', 787.0000, 'ºC'),
	(217134, 118, '2014-03-01 01:01:54.000000', 'temperatura', 431.0000, 'ºC'),
	(217135, 118, '2014-03-01 01:01:55.000000', 'temperatura', 992.0000, 'ºC'),
	(217136, 118, '2014-03-01 01:01:56.000000', 'temperatura', 70.0000, 'ºC'),
	(217137, 118, '2014-03-01 01:01:57.000000', 'temperatura', 973.0000, 'ºC'),
	(217138, 118, '2014-03-01 01:01:58.000000', 'temperatura', 1055.0000, 'ºC'),
	(217139, 118, '2014-03-01 01:01:59.000000', 'temperatura', 1157.0000, 'ºC'),
	(217140, 118, '2014-03-01 01:02:00.000000', 'temperatura', 219.0000, 'ºC'),
	(217141, 118, '2014-03-01 01:02:01.000000', 'temperatura', 27.0000, 'ºC'),
	(217142, 118, '2014-03-01 01:02:02.000000', 'temperatura', 677.0000, 'ºC'),
	(217143, 118, '2014-03-01 01:02:03.000000', 'temperatura', 907.0000, 'ºC'),
	(217144, 118, '2014-03-01 01:02:04.000000', 'temperatura', 103.0000, 'ºC'),
	(217145, 118, '2014-03-01 01:02:05.000000', 'temperatura', 194.0000, 'ºC'),
	(217146, 118, '2014-03-01 01:02:06.000000', 'temperatura', 662.0000, 'ºC'),
	(217147, 118, '2014-03-01 01:02:07.000000', 'temperatura', 330.0000, 'ºC'),
	(217148, 118, '2014-03-01 01:02:08.000000', 'temperatura', 863.0000, 'ºC'),
	(217149, 118, '2014-03-01 01:02:09.000000', 'temperatura', 924.0000, 'ºC'),
	(217150, 118, '2014-03-01 01:02:10.000000', 'temperatura', 831.0000, 'ºC'),
	(217151, 118, '2014-03-01 01:02:11.000000', 'temperatura', 186.0000, 'ºC'),
	(217152, 118, '2014-03-01 01:02:12.000000', 'temperatura', 836.0000, 'ºC'),
	(217153, 118, '2014-03-01 01:02:13.000000', 'temperatura', 23.0000, 'ºC'),
	(217154, 118, '2014-03-01 01:02:14.000000', 'temperatura', 9.0000, 'ºC'),
	(217155, 118, '2014-03-01 01:02:15.000000', 'temperatura', 1176.0000, 'ºC'),
	(217156, 118, '2014-03-01 01:02:16.000000', 'temperatura', 1052.0000, 'ºC'),
	(217157, 118, '2014-03-01 01:02:17.000000', 'temperatura', 533.0000, 'ºC'),
	(217158, 118, '2014-03-01 01:02:18.000000', 'temperatura', 710.0000, 'ºC'),
	(217159, 118, '2014-03-01 01:02:19.000000', 'temperatura', 751.0000, 'ºC'),
	(217160, 118, '2014-03-01 01:02:20.000000', 'temperatura', 427.0000, 'ºC'),
	(217161, 118, '2014-03-01 01:02:21.000000', 'temperatura', 1082.0000, 'ºC'),
	(217162, 118, '2014-03-01 01:02:22.000000', 'temperatura', 529.0000, 'ºC'),
	(217163, 118, '2014-03-01 01:02:23.000000', 'temperatura', 601.0000, 'ºC'),
	(217164, 118, '2014-03-01 01:02:24.000000', 'temperatura', 219.0000, 'ºC'),
	(217165, 118, '2014-03-01 01:02:25.000000', 'temperatura', 492.0000, 'ºC'),
	(217166, 118, '2014-03-01 01:02:26.000000', 'temperatura', 605.0000, 'ºC'),
	(217167, 118, '2014-03-01 01:02:27.000000', 'temperatura', 347.0000, 'ºC'),
	(217168, 118, '2014-03-01 01:02:28.000000', 'temperatura', 1123.0000, 'ºC'),
	(217169, 118, '2014-03-01 01:02:29.000000', 'temperatura', 973.0000, 'ºC'),
	(217170, 118, '2014-03-01 01:02:30.000000', 'temperatura', 297.0000, 'ºC'),
	(217171, 118, '2014-03-01 01:02:31.000000', 'temperatura', 966.0000, 'ºC'),
	(217172, 118, '2014-03-01 01:02:32.000000', 'temperatura', 341.0000, 'ºC'),
	(217173, 118, '2014-03-01 01:02:33.000000', 'temperatura', 8.0000, 'ºC'),
	(217174, 118, '2014-03-01 01:02:34.000000', 'temperatura', 215.0000, 'ºC'),
	(217175, 118, '2014-03-01 01:02:35.000000', 'temperatura', 1051.0000, 'ºC'),
	(217176, 118, '2014-03-01 01:02:36.000000', 'temperatura', 1011.0000, 'ºC'),
	(217177, 118, '2014-03-01 01:02:37.000000', 'temperatura', 703.0000, 'ºC'),
	(217178, 118, '2014-03-01 01:02:38.000000', 'temperatura', 483.0000, 'ºC'),
	(217179, 118, '2014-03-01 01:02:39.000000', 'temperatura', 308.0000, 'ºC'),
	(217180, 118, '2014-03-01 01:02:40.000000', 'temperatura', 90.0000, 'ºC'),
	(217181, 118, '2014-03-01 01:02:41.000000', 'temperatura', 725.0000, 'ºC'),
	(217182, 118, '2014-03-01 01:02:42.000000', 'temperatura', 957.0000, 'ºC'),
	(217183, 118, '2014-03-01 01:02:43.000000', 'temperatura', 209.0000, 'ºC'),
	(217184, 118, '2014-03-01 01:02:44.000000', 'temperatura', 576.0000, 'ºC'),
	(217185, 118, '2014-03-01 01:02:45.000000', 'temperatura', 1051.0000, 'ºC'),
	(217186, 118, '2014-03-01 01:02:46.000000', 'temperatura', 1131.0000, 'ºC'),
	(217187, 118, '2014-03-01 01:02:47.000000', 'temperatura', 99.0000, 'ºC'),
	(217188, 118, '2014-03-01 01:02:48.000000', 'temperatura', 705.0000, 'ºC'),
	(217189, 118, '2014-03-01 01:02:49.000000', 'temperatura', 828.0000, 'ºC'),
	(217190, 118, '2014-03-01 01:02:50.000000', 'temperatura', 824.0000, 'ºC'),
	(217191, 118, '2014-03-01 01:02:51.000000', 'temperatura', 439.0000, 'ºC'),
	(217192, 118, '2014-03-01 01:02:52.000000', 'temperatura', 921.0000, 'ºC'),
	(217193, 118, '2014-03-01 01:02:53.000000', 'temperatura', 889.0000, 'ºC'),
	(217194, 118, '2014-03-01 01:02:54.000000', 'temperatura', 483.0000, 'ºC'),
	(217195, 118, '2014-03-01 01:02:55.000000', 'temperatura', 949.0000, 'ºC'),
	(217196, 118, '2014-03-01 01:02:56.000000', 'temperatura', 898.0000, 'ºC'),
	(217197, 118, '2014-03-01 01:02:57.000000', 'temperatura', 443.0000, 'ºC'),
	(217198, 118, '2014-03-01 01:02:58.000000', 'temperatura', 720.0000, 'ºC'),
	(217199, 118, '2014-03-01 01:02:59.000000', 'temperatura', 1072.0000, 'ºC'),
	(217200, 118, '2014-03-01 01:03:00.000000', 'temperatura', 802.0000, 'ºC'),
	(217201, 118, '2014-03-01 01:03:01.000000', 'temperatura', 795.0000, 'ºC'),
	(217202, 118, '2014-03-01 01:03:02.000000', 'temperatura', 369.0000, 'ºC'),
	(217203, 118, '2014-03-01 01:03:03.000000', 'temperatura', 659.0000, 'ºC'),
	(217204, 118, '2014-03-01 01:03:04.000000', 'temperatura', 990.0000, 'ºC'),
	(217205, 118, '2014-03-01 01:03:05.000000', 'temperatura', 573.0000, 'ºC'),
	(217206, 118, '2014-03-01 01:03:06.000000', 'temperatura', 1094.0000, 'ºC'),
	(217207, 118, '2014-03-01 01:03:07.000000', 'temperatura', 153.0000, 'ºC'),
	(217208, 118, '2014-03-01 01:03:08.000000', 'temperatura', 1082.0000, 'ºC'),
	(217209, 118, '2014-03-01 01:03:09.000000', 'temperatura', 153.0000, 'ºC'),
	(217210, 118, '2014-03-01 01:03:10.000000', 'temperatura', 1117.0000, 'ºC'),
	(217211, 118, '2014-03-01 01:03:11.000000', 'temperatura', 328.0000, 'ºC'),
	(217212, 118, '2014-03-01 01:03:12.000000', 'temperatura', 691.0000, 'ºC'),
	(217213, 118, '2014-03-01 01:03:13.000000', 'temperatura', 69.0000, 'ºC'),
	(217214, 118, '2014-03-01 01:03:14.000000', 'temperatura', 673.0000, 'ºC'),
	(217215, 118, '2014-03-01 01:03:15.000000', 'temperatura', 759.0000, 'ºC'),
	(217216, 118, '2014-03-01 01:03:16.000000', 'temperatura', 576.0000, 'ºC'),
	(217217, 118, '2014-03-01 01:03:17.000000', 'temperatura', 605.0000, 'ºC'),
	(217218, 118, '2014-03-01 01:03:18.000000', 'temperatura', 97.0000, 'ºC'),
	(217219, 118, '2014-03-01 01:03:19.000000', 'temperatura', 1071.0000, 'ºC'),
	(217220, 118, '2014-03-01 01:03:20.000000', 'temperatura', 265.0000, 'ºC'),
	(217221, 118, '2014-03-01 01:03:21.000000', 'temperatura', 512.0000, 'ºC'),
	(217222, 118, '2014-03-01 01:03:22.000000', 'temperatura', 565.0000, 'ºC'),
	(217223, 118, '2014-03-01 01:03:23.000000', 'temperatura', 90.0000, 'ºC'),
	(217224, 118, '2014-03-01 01:03:24.000000', 'temperatura', 1154.0000, 'ºC'),
	(217225, 118, '2014-03-01 01:03:25.000000', 'temperatura', 702.0000, 'ºC'),
	(217226, 118, '2014-03-01 01:03:26.000000', 'temperatura', 48.0000, 'ºC'),
	(217227, 118, '2014-03-01 01:03:27.000000', 'temperatura', 535.0000, 'ºC'),
	(217228, 118, '2014-03-01 01:03:28.000000', 'temperatura', 131.0000, 'ºC'),
	(217229, 118, '2014-03-01 01:03:29.000000', 'temperatura', 251.0000, 'ºC'),
	(217230, 118, '2014-03-01 01:03:30.000000', 'temperatura', 863.0000, 'ºC'),
	(217231, 118, '2014-03-01 01:03:31.000000', 'temperatura', 1161.0000, 'ºC'),
	(217232, 118, '2014-03-01 01:03:32.000000', 'temperatura', 818.0000, 'ºC'),
	(217233, 118, '2014-03-01 01:03:33.000000', 'temperatura', 609.0000, 'ºC'),
	(217234, 118, '2014-03-01 01:03:34.000000', 'temperatura', 590.0000, 'ºC'),
	(217235, 118, '2014-03-01 01:03:35.000000', 'temperatura', 1125.0000, 'ºC'),
	(217236, 118, '2014-03-01 01:03:36.000000', 'temperatura', 254.0000, 'ºC'),
	(217237, 118, '2014-03-01 01:03:37.000000', 'temperatura', 295.0000, 'ºC'),
	(217238, 118, '2014-03-01 01:03:38.000000', 'temperatura', 715.0000, 'ºC'),
	(217239, 118, '2014-03-01 01:03:39.000000', 'temperatura', 291.0000, 'ºC'),
	(217240, 118, '2014-03-01 01:03:40.000000', 'temperatura', 509.0000, 'ºC'),
	(217241, 118, '2014-03-01 01:03:41.000000', 'temperatura', 474.0000, 'ºC'),
	(217242, 118, '2014-03-01 01:03:42.000000', 'temperatura', 844.0000, 'ºC'),
	(217243, 118, '2014-03-01 01:03:43.000000', 'temperatura', 396.0000, 'ºC'),
	(217244, 118, '2014-03-01 01:03:44.000000', 'temperatura', 649.0000, 'ºC'),
	(217245, 118, '2014-03-01 01:03:45.000000', 'temperatura', 857.0000, 'ºC'),
	(217246, 118, '2014-03-01 01:03:46.000000', 'temperatura', 1141.0000, 'ºC'),
	(217247, 118, '2014-03-01 01:03:47.000000', 'temperatura', 734.0000, 'ºC'),
	(217248, 118, '2014-03-01 01:03:48.000000', 'temperatura', 247.0000, 'ºC'),
	(217249, 118, '2014-03-01 01:03:49.000000', 'temperatura', 233.0000, 'ºC'),
	(217250, 118, '2014-03-01 01:03:50.000000', 'temperatura', 426.0000, 'ºC'),
	(217251, 118, '2014-03-01 01:03:51.000000', 'temperatura', 232.0000, 'ºC'),
	(217252, 118, '2014-03-01 01:03:52.000000', 'temperatura', 1084.0000, 'ºC'),
	(217253, 118, '2014-03-01 01:03:53.000000', 'temperatura', 1121.0000, 'ºC'),
	(217254, 118, '2014-03-01 01:03:54.000000', 'temperatura', 1155.0000, 'ºC'),
	(217255, 118, '2014-03-01 01:03:55.000000', 'temperatura', 13.0000, 'ºC'),
	(217256, 118, '2014-03-01 01:03:56.000000', 'temperatura', 199.0000, 'ºC'),
	(217257, 118, '2014-03-01 01:03:57.000000', 'temperatura', 958.0000, 'ºC'),
	(217258, 118, '2014-03-01 01:03:58.000000', 'temperatura', 593.0000, 'ºC'),
	(217259, 118, '2014-03-01 01:03:59.000000', 'temperatura', 89.0000, 'ºC'),
	(217260, 118, '2014-03-01 01:04:00.000000', 'temperatura', 1070.0000, 'ºC'),
	(217261, 118, '2014-03-01 01:04:01.000000', 'temperatura', 283.0000, 'ºC'),
	(217262, 118, '2014-03-01 01:04:02.000000', 'temperatura', 607.0000, 'ºC'),
	(217263, 118, '2014-03-01 01:04:03.000000', 'temperatura', 985.0000, 'ºC'),
	(217264, 118, '2014-03-01 01:04:04.000000', 'temperatura', 704.0000, 'ºC'),
	(217265, 118, '2014-03-01 01:04:05.000000', 'temperatura', 566.0000, 'ºC'),
	(217266, 118, '2014-03-01 01:04:06.000000', 'temperatura', 719.0000, 'ºC'),
	(217267, 118, '2014-03-01 01:04:07.000000', 'temperatura', 699.0000, 'ºC'),
	(217268, 118, '2014-03-01 01:04:08.000000', 'temperatura', 136.0000, 'ºC'),
	(217269, 118, '2014-03-01 01:04:09.000000', 'temperatura', 985.0000, 'ºC'),
	(217270, 118, '2014-03-01 01:04:10.000000', 'temperatura', 917.0000, 'ºC'),
	(217271, 118, '2014-03-01 01:04:11.000000', 'temperatura', 431.0000, 'ºC'),
	(217272, 118, '2014-03-01 01:04:12.000000', 'temperatura', 604.0000, 'ºC'),
	(217273, 118, '2014-03-01 01:04:13.000000', 'temperatura', 526.0000, 'ºC'),
	(217274, 118, '2014-03-01 01:04:14.000000', 'temperatura', 819.0000, 'ºC'),
	(217275, 118, '2014-03-01 01:04:15.000000', 'temperatura', 120.0000, 'ºC'),
	(217276, 118, '2014-03-01 01:04:16.000000', 'temperatura', 541.0000, 'ºC'),
	(217277, 118, '2014-03-01 01:04:17.000000', 'temperatura', 1145.0000, 'ºC'),
	(217278, 118, '2014-03-01 01:04:18.000000', 'temperatura', 503.0000, 'ºC'),
	(217279, 118, '2014-03-01 01:04:19.000000', 'temperatura', 283.0000, 'ºC'),
	(217280, 118, '2014-03-01 01:04:20.000000', 'temperatura', 1104.0000, 'ºC'),
	(217281, 118, '2014-03-01 01:04:21.000000', 'temperatura', 1074.0000, 'ºC'),
	(217282, 118, '2014-03-01 01:04:22.000000', 'temperatura', 856.0000, 'ºC'),
	(217283, 118, '2014-03-01 01:04:23.000000', 'temperatura', 1057.0000, 'ºC'),
	(217284, 118, '2014-03-01 01:04:24.000000', 'temperatura', 321.0000, 'ºC'),
	(217285, 118, '2014-03-01 01:04:25.000000', 'temperatura', 834.0000, 'ºC'),
	(217286, 118, '2014-03-01 01:04:26.000000', 'temperatura', 808.0000, 'ºC'),
	(217287, 118, '2014-03-01 01:04:27.000000', 'temperatura', 337.0000, 'ºC'),
	(217288, 118, '2014-03-01 01:04:28.000000', 'temperatura', 461.0000, 'ºC'),
	(217289, 118, '2014-03-01 01:04:29.000000', 'temperatura', 93.0000, 'ºC'),
	(217290, 118, '2014-03-01 01:04:30.000000', 'temperatura', 285.0000, 'ºC'),
	(217291, 118, '2014-03-01 01:04:31.000000', 'temperatura', 1148.0000, 'ºC'),
	(217292, 118, '2014-03-01 01:04:32.000000', 'temperatura', 82.0000, 'ºC'),
	(217293, 118, '2014-03-01 01:04:33.000000', 'temperatura', 569.0000, 'ºC'),
	(217294, 118, '2014-03-01 01:04:34.000000', 'temperatura', 199.0000, 'ºC'),
	(217295, 118, '2014-03-01 01:04:35.000000', 'temperatura', 490.0000, 'ºC'),
	(217296, 118, '2014-03-01 01:04:36.000000', 'temperatura', 652.0000, 'ºC'),
	(217297, 118, '2014-03-01 01:04:37.000000', 'temperatura', 589.0000, 'ºC'),
	(217298, 118, '2014-03-01 01:04:38.000000', 'temperatura', 990.0000, 'ºC'),
	(217299, 118, '2014-03-01 01:04:39.000000', 'temperatura', 784.0000, 'ºC'),
	(217300, 118, '2014-03-01 01:04:40.000000', 'temperatura', 951.0000, 'ºC'),
	(217301, 118, '2014-03-01 01:04:41.000000', 'temperatura', 4.0000, 'ºC'),
	(217302, 118, '2014-03-01 01:04:42.000000', 'temperatura', 766.0000, 'ºC'),
	(217303, 118, '2014-03-01 01:04:43.000000', 'temperatura', 219.0000, 'ºC'),
	(217304, 118, '2014-03-01 01:04:44.000000', 'temperatura', 1198.0000, 'ºC'),
	(217305, 118, '2014-03-01 01:04:45.000000', 'temperatura', 532.0000, 'ºC'),
	(217306, 118, '2014-03-01 01:04:46.000000', 'temperatura', 267.0000, 'ºC'),
	(217307, 118, '2014-03-01 01:04:47.000000', 'temperatura', 940.0000, 'ºC'),
	(217308, 118, '2014-03-01 01:04:48.000000', 'temperatura', 300.0000, 'ºC'),
	(217309, 118, '2014-03-01 01:04:49.000000', 'temperatura', 1079.0000, 'ºC'),
	(217310, 118, '2014-03-01 01:04:50.000000', 'temperatura', 898.0000, 'ºC'),
	(217311, 118, '2014-03-01 01:04:51.000000', 'temperatura', 51.0000, 'ºC'),
	(217312, 118, '2014-03-01 01:04:52.000000', 'temperatura', 1163.0000, 'ºC'),
	(217313, 118, '2014-03-01 01:04:53.000000', 'temperatura', 861.0000, 'ºC'),
	(217314, 118, '2014-03-01 01:04:54.000000', 'temperatura', 818.0000, 'ºC'),
	(217315, 118, '2014-03-01 01:04:55.000000', 'temperatura', 305.0000, 'ºC'),
	(217316, 118, '2014-03-01 01:04:56.000000', 'temperatura', 273.0000, 'ºC'),
	(217317, 118, '2014-03-01 01:04:57.000000', 'temperatura', 449.0000, 'ºC'),
	(217318, 118, '2014-03-01 01:04:58.000000', 'temperatura', 227.0000, 'ºC'),
	(217319, 118, '2014-03-01 01:04:59.000000', 'temperatura', 987.0000, 'ºC'),
	(217320, 118, '2014-03-01 01:05:00.000000', 'temperatura', 656.0000, 'ºC'),
	(217321, 118, '2014-03-01 01:05:01.000000', 'temperatura', 319.0000, 'ºC'),
	(217322, 118, '2014-03-01 01:05:02.000000', 'temperatura', 827.0000, 'ºC'),
	(217323, 118, '2014-03-01 01:05:03.000000', 'temperatura', 780.0000, 'ºC'),
	(217324, 118, '2014-03-01 01:05:04.000000', 'temperatura', 217.0000, 'ºC'),
	(217325, 118, '2014-03-01 01:05:05.000000', 'temperatura', 1148.0000, 'ºC'),
	(217326, 118, '2014-03-01 01:05:06.000000', 'temperatura', 290.0000, 'ºC'),
	(217327, 118, '2014-03-01 01:05:07.000000', 'temperatura', 406.0000, 'ºC'),
	(217328, 118, '2014-03-01 01:05:08.000000', 'temperatura', 1159.0000, 'ºC'),
	(217329, 118, '2014-03-01 01:05:09.000000', 'temperatura', 977.0000, 'ºC'),
	(217330, 118, '2014-03-01 01:05:10.000000', 'temperatura', 208.0000, 'ºC'),
	(217331, 118, '2014-03-01 01:05:11.000000', 'temperatura', 509.0000, 'ºC'),
	(217332, 118, '2014-03-01 01:05:12.000000', 'temperatura', 722.0000, 'ºC'),
	(217333, 118, '2014-03-01 01:05:13.000000', 'temperatura', 883.0000, 'ºC'),
	(217334, 118, '2014-03-01 01:05:14.000000', 'temperatura', 1049.0000, 'ºC'),
	(217335, 118, '2014-03-01 01:05:15.000000', 'temperatura', 199.0000, 'ºC'),
	(217336, 118, '2014-03-01 01:05:16.000000', 'temperatura', 248.0000, 'ºC'),
	(217337, 118, '2014-03-01 01:05:17.000000', 'temperatura', 642.0000, 'ºC'),
	(217338, 118, '2014-03-01 01:05:18.000000', 'temperatura', 68.0000, 'ºC'),
	(217339, 118, '2014-03-01 01:05:19.000000', 'temperatura', 813.0000, 'ºC'),
	(217340, 118, '2014-03-01 01:05:20.000000', 'temperatura', 263.0000, 'ºC'),
	(217341, 118, '2014-03-01 01:05:21.000000', 'temperatura', 74.0000, 'ºC'),
	(217342, 118, '2014-03-01 01:05:22.000000', 'temperatura', 782.0000, 'ºC'),
	(217343, 118, '2014-03-01 01:05:23.000000', 'temperatura', 90.0000, 'ºC'),
	(217344, 118, '2014-03-01 01:05:24.000000', 'temperatura', 503.0000, 'ºC'),
	(217345, 118, '2014-03-01 01:05:25.000000', 'temperatura', 1047.0000, 'ºC'),
	(217346, 118, '2014-03-01 01:05:26.000000', 'temperatura', 126.0000, 'ºC'),
	(217347, 118, '2014-03-01 01:05:27.000000', 'temperatura', 1088.0000, 'ºC'),
	(217348, 118, '2014-03-01 01:05:28.000000', 'temperatura', 261.0000, 'ºC'),
	(217349, 118, '2014-03-01 01:05:29.000000', 'temperatura', 445.0000, 'ºC'),
	(217350, 118, '2014-03-01 01:05:30.000000', 'temperatura', 242.0000, 'ºC'),
	(217351, 118, '2014-03-01 01:05:31.000000', 'temperatura', 1074.0000, 'ºC'),
	(217352, 118, '2014-03-01 01:05:32.000000', 'temperatura', 1044.0000, 'ºC'),
	(217353, 118, '2014-03-01 01:05:33.000000', 'temperatura', 799.0000, 'ºC'),
	(217354, 118, '2014-03-01 01:05:34.000000', 'temperatura', 864.0000, 'ºC'),
	(217355, 118, '2014-03-01 01:05:35.000000', 'temperatura', 722.0000, 'ºC'),
	(217356, 118, '2014-03-01 01:05:36.000000', 'temperatura', 1020.0000, 'ºC'),
	(217357, 118, '2014-03-01 01:05:37.000000', 'temperatura', 532.0000, 'ºC'),
	(217358, 118, '2014-03-01 01:05:38.000000', 'temperatura', 804.0000, 'ºC'),
	(217359, 118, '2014-03-01 01:05:39.000000', 'temperatura', 23.0000, 'ºC'),
	(217360, 118, '2014-03-01 01:05:40.000000', 'temperatura', 103.0000, 'ºC'),
	(217361, 118, '2014-03-01 01:05:41.000000', 'temperatura', 446.0000, 'ºC'),
	(217362, 118, '2014-03-01 01:05:42.000000', 'temperatura', 722.0000, 'ºC'),
	(217363, 118, '2014-03-01 01:05:43.000000', 'temperatura', 1072.0000, 'ºC'),
	(217364, 118, '2014-03-01 01:05:44.000000', 'temperatura', 797.0000, 'ºC'),
	(217365, 118, '2014-03-01 01:05:45.000000', 'temperatura', 768.0000, 'ºC'),
	(217366, 118, '2014-03-01 01:05:46.000000', 'temperatura', 250.0000, 'ºC'),
	(217367, 118, '2014-03-01 01:05:47.000000', 'temperatura', 144.0000, 'ºC'),
	(217368, 118, '2014-03-01 01:05:48.000000', 'temperatura', 1173.0000, 'ºC'),
	(217369, 118, '2014-03-01 01:05:49.000000', 'temperatura', 635.0000, 'ºC'),
	(217370, 118, '2014-03-01 01:05:50.000000', 'temperatura', 853.0000, 'ºC'),
	(217371, 118, '2014-03-01 01:05:51.000000', 'temperatura', 1162.0000, 'ºC'),
	(217372, 118, '2014-03-01 01:05:52.000000', 'temperatura', 851.0000, 'ºC'),
	(217373, 118, '2014-03-01 01:05:53.000000', 'temperatura', 770.0000, 'ºC'),
	(217374, 118, '2014-03-01 01:05:54.000000', 'temperatura', 99.0000, 'ºC'),
	(217375, 118, '2014-03-01 01:05:55.000000', 'temperatura', 585.0000, 'ºC'),
	(217376, 118, '2014-03-01 01:05:56.000000', 'temperatura', 228.0000, 'ºC'),
	(217377, 118, '2014-03-01 01:05:57.000000', 'temperatura', 583.0000, 'ºC'),
	(217378, 118, '2014-03-01 01:05:58.000000', 'temperatura', 1035.0000, 'ºC'),
	(217379, 118, '2014-03-01 01:05:59.000000', 'temperatura', 1025.0000, 'ºC'),
	(217380, 118, '2014-03-01 01:06:00.000000', 'temperatura', 823.0000, 'ºC'),
	(217381, 118, '2014-03-01 01:06:01.000000', 'temperatura', 1038.0000, 'ºC'),
	(217382, 118, '2014-03-01 01:06:02.000000', 'temperatura', 320.0000, 'ºC'),
	(217383, 118, '2014-03-01 01:06:03.000000', 'temperatura', 890.0000, 'ºC'),
	(217384, 118, '2014-03-01 01:06:04.000000', 'temperatura', 1088.0000, 'ºC'),
	(217385, 118, '2014-03-01 01:06:05.000000', 'temperatura', 373.0000, 'ºC'),
	(217386, 118, '2014-03-01 01:06:06.000000', 'temperatura', 1001.0000, 'ºC'),
	(217387, 118, '2014-03-01 01:06:07.000000', 'temperatura', 285.0000, 'ºC'),
	(217388, 118, '2014-03-01 01:06:08.000000', 'temperatura', 821.0000, 'ºC'),
	(217389, 118, '2014-03-01 01:06:09.000000', 'temperatura', 853.0000, 'ºC'),
	(217390, 118, '2014-03-01 01:06:10.000000', 'temperatura', 603.0000, 'ºC'),
	(217391, 118, '2014-03-01 01:06:11.000000', 'temperatura', 456.0000, 'ºC'),
	(217392, 118, '2014-03-01 01:06:12.000000', 'temperatura', 472.0000, 'ºC'),
	(217393, 118, '2014-03-01 01:06:13.000000', 'temperatura', 994.0000, 'ºC'),
	(217394, 118, '2014-03-01 01:06:14.000000', 'temperatura', 1153.0000, 'ºC'),
	(217395, 118, '2014-03-01 01:06:15.000000', 'temperatura', 381.0000, 'ºC'),
	(217396, 118, '2014-03-01 01:06:16.000000', 'temperatura', 850.0000, 'ºC'),
	(217397, 118, '2014-03-01 01:06:17.000000', 'temperatura', 707.0000, 'ºC'),
	(217398, 118, '2014-03-01 01:06:18.000000', 'temperatura', 985.0000, 'ºC'),
	(217399, 118, '2014-03-01 01:06:19.000000', 'temperatura', 405.0000, 'ºC'),
	(217400, 118, '2014-03-01 01:06:20.000000', 'temperatura', 268.0000, 'ºC'),
	(217401, 118, '2014-03-01 01:06:21.000000', 'temperatura', 129.0000, 'ºC'),
	(217402, 118, '2014-03-01 01:06:22.000000', 'temperatura', 1040.0000, 'ºC'),
	(217403, 118, '2014-03-01 01:06:23.000000', 'temperatura', 12.0000, 'ºC'),
	(217404, 118, '2014-03-01 01:06:24.000000', 'temperatura', 540.0000, 'ºC'),
	(217405, 118, '2014-03-01 01:06:25.000000', 'temperatura', 265.0000, 'ºC'),
	(217406, 118, '2014-03-01 01:06:26.000000', 'temperatura', 905.0000, 'ºC'),
	(217407, 118, '2014-03-01 01:06:27.000000', 'temperatura', 133.0000, 'ºC'),
	(217408, 118, '2014-03-01 01:06:28.000000', 'temperatura', 350.0000, 'ºC'),
	(217409, 118, '2014-03-01 01:06:29.000000', 'temperatura', 149.0000, 'ºC'),
	(217410, 118, '2014-03-01 01:06:30.000000', 'temperatura', 896.0000, 'ºC'),
	(217411, 118, '2014-03-01 01:06:31.000000', 'temperatura', 435.0000, 'ºC'),
	(217412, 118, '2014-03-01 01:06:32.000000', 'temperatura', 685.0000, 'ºC'),
	(217413, 118, '2014-03-01 01:06:33.000000', 'temperatura', 921.0000, 'ºC'),
	(217414, 118, '2014-03-01 01:06:34.000000', 'temperatura', 150.0000, 'ºC'),
	(217415, 118, '2014-03-01 01:06:35.000000', 'temperatura', 388.0000, 'ºC'),
	(217416, 118, '2014-03-01 01:06:36.000000', 'temperatura', 289.0000, 'ºC'),
	(217417, 118, '2014-03-01 01:06:37.000000', 'temperatura', 282.0000, 'ºC'),
	(217418, 118, '2014-03-01 01:06:38.000000', 'temperatura', 544.0000, 'ºC'),
	(217419, 118, '2014-03-01 01:06:39.000000', 'temperatura', 675.0000, 'ºC'),
	(217420, 118, '2014-03-01 01:06:40.000000', 'temperatura', 545.0000, 'ºC'),
	(217421, 118, '2014-03-01 01:06:41.000000', 'temperatura', 698.0000, 'ºC'),
	(217422, 118, '2014-03-01 01:06:42.000000', 'temperatura', 658.0000, 'ºC'),
	(217423, 118, '2014-03-01 01:06:43.000000', 'temperatura', 1194.0000, 'ºC'),
	(217424, 118, '2014-03-01 01:06:44.000000', 'temperatura', 398.0000, 'ºC'),
	(217425, 118, '2014-03-01 01:06:45.000000', 'temperatura', 807.0000, 'ºC'),
	(217426, 118, '2014-03-01 01:06:46.000000', 'temperatura', 443.0000, 'ºC'),
	(217427, 118, '2014-03-01 01:06:47.000000', 'temperatura', 993.0000, 'ºC'),
	(217428, 118, '2014-03-01 01:06:48.000000', 'temperatura', 39.0000, 'ºC'),
	(217429, 118, '2014-03-01 01:06:49.000000', 'temperatura', 815.0000, 'ºC'),
	(217430, 118, '2014-03-01 01:06:50.000000', 'temperatura', 359.0000, 'ºC'),
	(217431, 118, '2014-03-01 01:06:51.000000', 'temperatura', 552.0000, 'ºC'),
	(217432, 118, '2014-03-01 01:06:52.000000', 'temperatura', 483.0000, 'ºC'),
	(217433, 118, '2014-03-01 01:06:53.000000', 'temperatura', 759.0000, 'ºC'),
	(217434, 118, '2014-03-01 01:06:54.000000', 'temperatura', 1147.0000, 'ºC'),
	(217435, 118, '2014-03-01 01:06:55.000000', 'temperatura', 1060.0000, 'ºC'),
	(217436, 118, '2014-03-01 01:06:56.000000', 'temperatura', 656.0000, 'ºC'),
	(217437, 118, '2014-03-01 01:06:57.000000', 'temperatura', 103.0000, 'ºC'),
	(217438, 118, '2014-03-01 01:06:58.000000', 'temperatura', 945.0000, 'ºC'),
	(217439, 118, '2014-03-01 01:06:59.000000', 'temperatura', 817.0000, 'ºC'),
	(217440, 118, '2014-03-01 01:07:00.000000', 'temperatura', 50.0000, 'ºC'),
	(217441, 118, '2014-03-01 01:07:01.000000', 'temperatura', 198.0000, 'ºC'),
	(217442, 118, '2014-03-01 01:07:02.000000', 'temperatura', 843.0000, 'ºC'),
	(217443, 118, '2014-03-01 01:07:03.000000', 'temperatura', 23.0000, 'ºC'),
	(217444, 118, '2014-03-01 01:07:04.000000', 'temperatura', 1184.0000, 'ºC'),
	(217445, 118, '2014-03-01 01:07:05.000000', 'temperatura', 1054.0000, 'ºC'),
	(217446, 118, '2014-03-01 01:07:06.000000', 'temperatura', 517.0000, 'ºC'),
	(217447, 118, '2014-03-01 01:07:07.000000', 'temperatura', 622.0000, 'ºC'),
	(217448, 118, '2014-03-01 01:07:08.000000', 'temperatura', 361.0000, 'ºC'),
	(217449, 118, '2014-03-01 01:07:09.000000', 'temperatura', 1139.0000, 'ºC'),
	(217450, 118, '2014-03-01 01:07:10.000000', 'temperatura', 1011.0000, 'ºC'),
	(217451, 118, '2014-03-01 01:07:11.000000', 'temperatura', 440.0000, 'ºC'),
	(217452, 118, '2014-03-01 01:07:12.000000', 'temperatura', 369.0000, 'ºC'),
	(217453, 118, '2014-03-01 01:07:13.000000', 'temperatura', 526.0000, 'ºC'),
	(217454, 118, '2014-03-01 01:07:14.000000', 'temperatura', 323.0000, 'ºC'),
	(217455, 118, '2014-03-01 01:07:15.000000', 'temperatura', 36.0000, 'ºC'),
	(217456, 118, '2014-03-01 01:07:16.000000', 'temperatura', 411.0000, 'ºC'),
	(217457, 118, '2014-03-01 01:07:17.000000', 'temperatura', 748.0000, 'ºC'),
	(217458, 118, '2014-03-01 01:07:18.000000', 'temperatura', 109.0000, 'ºC'),
	(217459, 118, '2014-03-01 01:07:19.000000', 'temperatura', 699.0000, 'ºC'),
	(217460, 118, '2014-03-01 01:07:20.000000', 'temperatura', 770.0000, 'ºC'),
	(217461, 118, '2014-03-01 01:07:21.000000', 'temperatura', 554.0000, 'ºC'),
	(217462, 118, '2014-03-01 01:07:22.000000', 'temperatura', 460.0000, 'ºC'),
	(217463, 118, '2014-03-01 01:07:23.000000', 'temperatura', 637.0000, 'ºC'),
	(217464, 118, '2014-03-01 01:07:24.000000', 'temperatura', 606.0000, 'ºC'),
	(217465, 118, '2014-03-01 01:07:25.000000', 'temperatura', 1121.0000, 'ºC'),
	(217466, 118, '2014-03-01 01:07:26.000000', 'temperatura', 186.0000, 'ºC'),
	(217467, 118, '2014-03-01 01:07:27.000000', 'temperatura', 1170.0000, 'ºC'),
	(217468, 118, '2014-03-01 01:07:28.000000', 'temperatura', 491.0000, 'ºC'),
	(217469, 118, '2014-03-01 01:07:29.000000', 'temperatura', 147.0000, 'ºC'),
	(217470, 118, '2014-03-01 01:07:30.000000', 'temperatura', 463.0000, 'ºC'),
	(217471, 118, '2014-03-01 01:07:31.000000', 'temperatura', 675.0000, 'ºC'),
	(217472, 118, '2014-03-01 01:07:32.000000', 'temperatura', 784.0000, 'ºC'),
	(217473, 118, '2014-03-01 01:07:33.000000', 'temperatura', 698.0000, 'ºC'),
	(217474, 118, '2014-03-01 01:07:34.000000', 'temperatura', 1138.0000, 'ºC'),
	(217475, 118, '2014-03-01 01:07:35.000000', 'temperatura', 1195.0000, 'ºC'),
	(217476, 118, '2014-03-01 01:07:36.000000', 'temperatura', 163.0000, 'ºC'),
	(217477, 118, '2014-03-01 01:07:37.000000', 'temperatura', 830.0000, 'ºC'),
	(217478, 118, '2014-03-01 01:07:38.000000', 'temperatura', 61.0000, 'ºC'),
	(217479, 118, '2014-03-01 01:07:39.000000', 'temperatura', 216.0000, 'ºC'),
	(217480, 118, '2014-03-01 01:07:40.000000', 'temperatura', 896.0000, 'ºC'),
	(217481, 118, '2014-03-01 01:07:41.000000', 'temperatura', 232.0000, 'ºC'),
	(217482, 118, '2014-03-01 01:07:42.000000', 'temperatura', 873.0000, 'ºC'),
	(217483, 118, '2014-03-01 01:07:43.000000', 'temperatura', 70.0000, 'ºC'),
	(217484, 118, '2014-03-01 01:07:44.000000', 'temperatura', 132.0000, 'ºC'),
	(217485, 118, '2014-03-01 01:07:45.000000', 'temperatura', 448.0000, 'ºC'),
	(217486, 118, '2014-03-01 01:07:46.000000', 'temperatura', 647.0000, 'ºC'),
	(217487, 118, '2014-03-01 01:07:47.000000', 'temperatura', 691.0000, 'ºC'),
	(217488, 118, '2014-03-01 01:07:48.000000', 'temperatura', 314.0000, 'ºC'),
	(217489, 118, '2014-03-01 01:07:49.000000', 'temperatura', 696.0000, 'ºC'),
	(217490, 118, '2014-03-01 01:07:50.000000', 'temperatura', 139.0000, 'ºC'),
	(217491, 118, '2014-03-01 01:07:51.000000', 'temperatura', 1008.0000, 'ºC'),
	(217492, 118, '2014-03-01 01:07:52.000000', 'temperatura', 1024.0000, 'ºC'),
	(217493, 118, '2014-03-01 01:07:53.000000', 'temperatura', 898.0000, 'ºC'),
	(217494, 118, '2014-03-01 01:07:54.000000', 'temperatura', 217.0000, 'ºC'),
	(217495, 118, '2014-03-01 01:07:55.000000', 'temperatura', 791.0000, 'ºC'),
	(217496, 118, '2014-03-01 01:07:56.000000', 'temperatura', 906.0000, 'ºC'),
	(217497, 118, '2014-03-01 01:07:57.000000', 'temperatura', 958.0000, 'ºC'),
	(217498, 118, '2014-03-01 01:07:58.000000', 'temperatura', 871.0000, 'ºC'),
	(217499, 118, '2014-03-01 01:07:59.000000', 'temperatura', 281.0000, 'ºC'),
	(217500, 118, '2014-03-01 01:08:00.000000', 'temperatura', 1193.0000, 'ºC'),
	(217501, 118, '2014-03-01 01:08:01.000000', 'temperatura', 321.0000, 'ºC'),
	(217502, 118, '2014-03-01 01:08:02.000000', 'temperatura', 427.0000, 'ºC'),
	(217503, 118, '2014-03-01 01:08:03.000000', 'temperatura', 1174.0000, 'ºC'),
	(217504, 118, '2014-03-01 01:08:04.000000', 'temperatura', 988.0000, 'ºC'),
	(217505, 118, '2014-03-01 01:08:05.000000', 'temperatura', 220.0000, 'ºC'),
	(217506, 118, '2014-03-01 01:08:06.000000', 'temperatura', 537.0000, 'ºC'),
	(217507, 118, '2014-03-01 01:08:07.000000', 'temperatura', 825.0000, 'ºC'),
	(217508, 118, '2014-03-01 01:08:08.000000', 'temperatura', 113.0000, 'ºC'),
	(217509, 118, '2014-03-01 01:08:09.000000', 'temperatura', 492.0000, 'ºC'),
	(217510, 118, '2014-03-01 01:08:10.000000', 'temperatura', 921.0000, 'ºC'),
	(217511, 118, '2014-03-01 01:08:11.000000', 'temperatura', 728.0000, 'ºC'),
	(217512, 118, '2014-03-01 01:08:12.000000', 'temperatura', 877.0000, 'ºC'),
	(217513, 118, '2014-03-01 01:08:13.000000', 'temperatura', 1004.0000, 'ºC'),
	(217514, 118, '2014-03-01 01:08:14.000000', 'temperatura', 1189.0000, 'ºC'),
	(217515, 118, '2014-03-01 01:08:15.000000', 'temperatura', 535.0000, 'ºC'),
	(217516, 118, '2014-03-01 01:08:16.000000', 'temperatura', 305.0000, 'ºC'),
	(217517, 118, '2014-03-01 01:08:17.000000', 'temperatura', 1123.0000, 'ºC'),
	(217518, 118, '2014-03-01 01:08:18.000000', 'temperatura', 1100.0000, 'ºC'),
	(217519, 118, '2014-03-01 01:08:19.000000', 'temperatura', 931.0000, 'ºC'),
	(217520, 118, '2014-03-01 01:08:20.000000', 'temperatura', 155.0000, 'ºC'),
	(217521, 118, '2014-03-01 01:08:21.000000', 'temperatura', 382.0000, 'ºC'),
	(217522, 118, '2014-03-01 01:08:22.000000', 'temperatura', 247.0000, 'ºC'),
	(217523, 118, '2014-03-01 01:08:23.000000', 'temperatura', 87.0000, 'ºC'),
	(217524, 118, '2014-03-01 01:08:24.000000', 'temperatura', 896.0000, 'ºC'),
	(217525, 118, '2014-03-01 01:08:25.000000', 'temperatura', 620.0000, 'ºC'),
	(217526, 118, '2014-03-01 01:08:26.000000', 'temperatura', 411.0000, 'ºC'),
	(217527, 118, '2014-03-01 01:08:27.000000', 'temperatura', 194.0000, 'ºC'),
	(217528, 118, '2014-03-01 01:08:28.000000', 'temperatura', 941.0000, 'ºC'),
	(217529, 118, '2014-03-01 01:08:29.000000', 'temperatura', 521.0000, 'ºC'),
	(217530, 118, '2014-03-01 01:08:30.000000', 'temperatura', 983.0000, 'ºC'),
	(217531, 118, '2014-03-01 01:08:31.000000', 'temperatura', 952.0000, 'ºC'),
	(217532, 118, '2014-03-01 01:08:32.000000', 'temperatura', 611.0000, 'ºC'),
	(217533, 118, '2014-03-01 01:08:33.000000', 'temperatura', 201.0000, 'ºC'),
	(217534, 118, '2014-03-01 01:08:34.000000', 'temperatura', 372.0000, 'ºC'),
	(217535, 118, '2014-03-01 01:08:35.000000', 'temperatura', 57.0000, 'ºC'),
	(217536, 118, '2014-03-01 01:08:36.000000', 'temperatura', 371.0000, 'ºC'),
	(217537, 118, '2014-03-01 01:08:37.000000', 'temperatura', 482.0000, 'ºC'),
	(217538, 118, '2014-03-01 01:08:38.000000', 'temperatura', 100.0000, 'ºC'),
	(217539, 118, '2014-03-01 01:08:39.000000', 'temperatura', 252.0000, 'ºC'),
	(217540, 118, '2014-03-01 01:08:40.000000', 'temperatura', 962.0000, 'ºC'),
	(217541, 118, '2014-03-01 01:08:41.000000', 'temperatura', 452.0000, 'ºC'),
	(217542, 118, '2014-03-01 01:08:42.000000', 'temperatura', 577.0000, 'ºC'),
	(217543, 118, '2014-03-01 01:08:43.000000', 'temperatura', 328.0000, 'ºC'),
	(217544, 118, '2014-03-01 01:08:44.000000', 'temperatura', 1111.0000, 'ºC'),
	(217545, 118, '2014-03-01 01:08:45.000000', 'temperatura', 969.0000, 'ºC'),
	(217546, 118, '2014-03-01 01:08:46.000000', 'temperatura', 316.0000, 'ºC'),
	(217547, 118, '2014-03-01 01:08:47.000000', 'temperatura', 1071.0000, 'ºC'),
	(217548, 118, '2014-03-01 01:08:48.000000', 'temperatura', 809.0000, 'ºC'),
	(217549, 118, '2014-03-01 01:08:49.000000', 'temperatura', 833.0000, 'ºC'),
	(217550, 118, '2014-03-01 01:08:50.000000', 'temperatura', 537.0000, 'ºC'),
	(217551, 118, '2014-03-01 01:08:51.000000', 'temperatura', 186.0000, 'ºC'),
	(217552, 118, '2014-03-01 01:08:52.000000', 'temperatura', 521.0000, 'ºC'),
	(217553, 118, '2014-03-01 01:08:53.000000', 'temperatura', 846.0000, 'ºC'),
	(217554, 118, '2014-03-01 01:08:54.000000', 'temperatura', 266.0000, 'ºC'),
	(217555, 118, '2014-03-01 01:08:55.000000', 'temperatura', 1196.0000, 'ºC'),
	(217556, 118, '2014-03-01 01:08:56.000000', 'temperatura', 380.0000, 'ºC'),
	(217557, 118, '2014-03-01 01:08:57.000000', 'temperatura', 712.0000, 'ºC'),
	(217558, 118, '2014-03-01 01:08:58.000000', 'temperatura', 20.0000, 'ºC'),
	(217559, 118, '2014-03-01 01:08:59.000000', 'temperatura', 364.0000, 'ºC'),
	(217560, 118, '2014-03-01 01:09:00.000000', 'temperatura', 561.0000, 'ºC'),
	(217561, 118, '2014-03-01 01:09:01.000000', 'temperatura', 512.0000, 'ºC'),
	(217562, 118, '2014-03-01 01:09:02.000000', 'temperatura', 878.0000, 'ºC'),
	(217563, 118, '2014-03-01 01:09:03.000000', 'temperatura', 456.0000, 'ºC'),
	(217564, 118, '2014-03-01 01:09:04.000000', 'temperatura', 845.0000, 'ºC'),
	(217565, 118, '2014-03-01 01:09:05.000000', 'temperatura', 456.0000, 'ºC'),
	(217566, 118, '2014-03-01 01:09:06.000000', 'temperatura', 948.0000, 'ºC'),
	(217567, 118, '2014-03-01 01:09:07.000000', 'temperatura', 973.0000, 'ºC'),
	(217568, 118, '2014-03-01 01:09:08.000000', 'temperatura', 823.0000, 'ºC'),
	(217569, 118, '2014-03-01 01:09:09.000000', 'temperatura', 1194.0000, 'ºC'),
	(217570, 118, '2014-03-01 01:09:10.000000', 'temperatura', 1102.0000, 'ºC'),
	(217571, 118, '2014-03-01 01:09:11.000000', 'temperatura', 727.0000, 'ºC'),
	(217572, 118, '2014-03-01 01:09:12.000000', 'temperatura', 329.0000, 'ºC'),
	(217573, 118, '2014-03-01 01:09:13.000000', 'temperatura', 664.0000, 'ºC'),
	(217574, 118, '2014-03-01 01:09:14.000000', 'temperatura', 1134.0000, 'ºC'),
	(217575, 118, '2014-03-01 01:09:15.000000', 'temperatura', 80.0000, 'ºC'),
	(217576, 118, '2014-03-01 01:09:16.000000', 'temperatura', 598.0000, 'ºC'),
	(217577, 118, '2014-03-01 01:09:17.000000', 'temperatura', 351.0000, 'ºC'),
	(217578, 118, '2014-03-01 01:09:18.000000', 'temperatura', 1162.0000, 'ºC'),
	(217579, 118, '2014-03-01 01:09:19.000000', 'temperatura', 1155.0000, 'ºC'),
	(217580, 118, '2014-03-01 01:09:20.000000', 'temperatura', 1090.0000, 'ºC'),
	(217581, 118, '2014-03-01 01:09:21.000000', 'temperatura', 787.0000, 'ºC'),
	(217582, 118, '2014-03-01 01:09:22.000000', 'temperatura', 666.0000, 'ºC'),
	(217583, 118, '2014-03-01 01:09:23.000000', 'temperatura', 969.0000, 'ºC'),
	(217584, 118, '2014-03-01 01:09:24.000000', 'temperatura', 446.0000, 'ºC'),
	(217585, 118, '2014-03-01 01:09:25.000000', 'temperatura', 525.0000, 'ºC'),
	(217586, 118, '2014-03-01 01:09:26.000000', 'temperatura', 86.0000, 'ºC'),
	(217587, 118, '2014-03-01 01:09:27.000000', 'temperatura', 55.0000, 'ºC'),
	(217588, 118, '2014-03-01 01:09:28.000000', 'temperatura', 20.0000, 'ºC'),
	(217589, 118, '2014-03-01 01:09:29.000000', 'temperatura', 1133.0000, 'ºC'),
	(217590, 118, '2014-03-01 01:09:30.000000', 'temperatura', 805.0000, 'ºC'),
	(217591, 118, '2014-03-01 01:09:31.000000', 'temperatura', 626.0000, 'ºC'),
	(217592, 118, '2014-03-01 01:09:32.000000', 'temperatura', 718.0000, 'ºC'),
	(217593, 118, '2014-03-01 01:09:33.000000', 'temperatura', 513.0000, 'ºC'),
	(217594, 118, '2014-03-01 01:09:34.000000', 'temperatura', 410.0000, 'ºC'),
	(217595, 118, '2014-03-01 01:09:35.000000', 'temperatura', 511.0000, 'ºC'),
	(217596, 118, '2014-03-01 01:09:36.000000', 'temperatura', 125.0000, 'ºC'),
	(217597, 118, '2014-03-01 01:09:37.000000', 'temperatura', 292.0000, 'ºC'),
	(217598, 118, '2014-03-01 01:09:38.000000', 'temperatura', 1086.0000, 'ºC'),
	(217599, 118, '2014-03-01 01:09:39.000000', 'temperatura', 954.0000, 'ºC'),
	(217600, 118, '2014-03-01 01:09:40.000000', 'temperatura', 314.0000, 'ºC'),
	(217601, 118, '2014-03-01 01:09:41.000000', 'temperatura', 1107.0000, 'ºC'),
	(217602, 118, '2014-03-01 01:09:42.000000', 'temperatura', 994.0000, 'ºC'),
	(217603, 118, '2014-03-01 01:09:43.000000', 'temperatura', 451.0000, 'ºC'),
	(217604, 118, '2014-03-01 01:09:44.000000', 'temperatura', 474.0000, 'ºC'),
	(217605, 118, '2014-03-01 01:09:45.000000', 'temperatura', 1016.0000, 'ºC'),
	(217606, 118, '2014-03-01 01:09:46.000000', 'temperatura', 60.0000, 'ºC'),
	(217607, 118, '2014-03-01 01:09:47.000000', 'temperatura', 850.0000, 'ºC'),
	(217608, 118, '2014-03-01 01:09:48.000000', 'temperatura', 472.0000, 'ºC'),
	(217609, 118, '2014-03-01 01:09:49.000000', 'temperatura', 1011.0000, 'ºC'),
	(217610, 118, '2014-03-01 01:09:50.000000', 'temperatura', 40.0000, 'ºC'),
	(217611, 118, '2014-03-01 01:09:51.000000', 'temperatura', 767.0000, 'ºC'),
	(217612, 118, '2014-03-01 01:09:52.000000', 'temperatura', 116.0000, 'ºC'),
	(217613, 118, '2014-03-01 01:09:53.000000', 'temperatura', 681.0000, 'ºC'),
	(217614, 118, '2014-03-01 01:09:54.000000', 'temperatura', 656.0000, 'ºC'),
	(217615, 118, '2014-03-01 01:09:55.000000', 'temperatura', 38.0000, 'ºC'),
	(217616, 118, '2014-03-01 01:09:56.000000', 'temperatura', 624.0000, 'ºC'),
	(217617, 118, '2014-03-01 01:09:57.000000', 'temperatura', 605.0000, 'ºC'),
	(217618, 118, '2014-03-01 01:09:58.000000', 'temperatura', 1155.0000, 'ºC'),
	(217619, 118, '2014-03-01 01:09:59.000000', 'temperatura', 359.0000, 'ºC'),
	(217620, 118, '2014-03-01 01:10:00.000000', 'temperatura', 732.0000, 'ºC'),
	(217621, 118, '2014-03-01 01:10:01.000000', 'temperatura', 181.0000, 'ºC'),
	(217622, 118, '2014-03-01 01:10:02.000000', 'temperatura', 1113.0000, 'ºC'),
	(217623, 118, '2014-03-01 01:10:03.000000', 'temperatura', 220.0000, 'ºC'),
	(217624, 118, '2014-03-01 01:10:04.000000', 'temperatura', 161.0000, 'ºC'),
	(217625, 118, '2014-03-01 01:10:05.000000', 'temperatura', 146.0000, 'ºC'),
	(217626, 118, '2014-03-01 01:10:06.000000', 'temperatura', 246.0000, 'ºC'),
	(217627, 118, '2014-03-01 01:10:07.000000', 'temperatura', 795.0000, 'ºC'),
	(217628, 118, '2014-03-01 01:10:08.000000', 'temperatura', 837.0000, 'ºC'),
	(217629, 118, '2014-03-01 01:10:09.000000', 'temperatura', 602.0000, 'ºC'),
	(217630, 118, '2014-03-01 01:10:10.000000', 'temperatura', 499.0000, 'ºC'),
	(217631, 118, '2014-03-01 01:10:11.000000', 'temperatura', 689.0000, 'ºC'),
	(217632, 118, '2014-03-01 01:10:12.000000', 'temperatura', 751.0000, 'ºC'),
	(217633, 118, '2014-03-01 01:10:13.000000', 'temperatura', 485.0000, 'ºC'),
	(217634, 118, '2014-03-01 01:10:14.000000', 'temperatura', 173.0000, 'ºC'),
	(217635, 118, '2014-03-01 01:10:15.000000', 'temperatura', 609.0000, 'ºC'),
	(217636, 118, '2014-03-01 01:10:16.000000', 'temperatura', 129.0000, 'ºC'),
	(217637, 118, '2014-03-01 01:10:17.000000', 'temperatura', 17.0000, 'ºC'),
	(217638, 118, '2014-03-01 01:10:18.000000', 'temperatura', 900.0000, 'ºC'),
	(217639, 118, '2014-03-01 01:10:19.000000', 'temperatura', 850.0000, 'ºC'),
	(217640, 118, '2014-03-01 01:10:20.000000', 'temperatura', 349.0000, 'ºC'),
	(217641, 118, '2014-03-01 01:10:21.000000', 'temperatura', 398.0000, 'ºC'),
	(217642, 118, '2014-03-01 01:10:22.000000', 'temperatura', 942.0000, 'ºC'),
	(217643, 118, '2014-03-01 01:10:23.000000', 'temperatura', 1118.0000, 'ºC'),
	(217644, 118, '2014-03-01 01:10:24.000000', 'temperatura', 363.0000, 'ºC'),
	(217645, 118, '2014-03-01 01:10:25.000000', 'temperatura', 860.0000, 'ºC'),
	(217646, 118, '2014-03-01 01:10:26.000000', 'temperatura', 812.0000, 'ºC'),
	(217647, 118, '2014-03-01 01:10:27.000000', 'temperatura', 280.0000, 'ºC'),
	(217648, 118, '2014-03-01 01:10:28.000000', 'temperatura', 166.0000, 'ºC'),
	(217649, 118, '2014-03-01 01:10:29.000000', 'temperatura', 1189.0000, 'ºC'),
	(217650, 118, '2014-03-01 01:10:30.000000', 'temperatura', 649.0000, 'ºC'),
	(217651, 118, '2014-03-01 01:10:31.000000', 'temperatura', 878.0000, 'ºC'),
	(217652, 118, '2014-03-01 01:10:32.000000', 'temperatura', 45.0000, 'ºC'),
	(217653, 118, '2014-03-01 01:10:33.000000', 'temperatura', 1189.0000, 'ºC'),
	(217654, 118, '2014-03-01 01:10:34.000000', 'temperatura', 1012.0000, 'ºC'),
	(217655, 118, '2014-03-01 01:10:35.000000', 'temperatura', 292.0000, 'ºC'),
	(217656, 118, '2014-03-01 01:10:36.000000', 'temperatura', 827.0000, 'ºC'),
	(217657, 118, '2014-03-01 01:10:37.000000', 'temperatura', 857.0000, 'ºC'),
	(217658, 118, '2014-03-01 01:10:38.000000', 'temperatura', 605.0000, 'ºC'),
	(217659, 118, '2014-03-01 01:10:39.000000', 'temperatura', 455.0000, 'ºC'),
	(217660, 118, '2014-03-01 01:10:40.000000', 'temperatura', 461.0000, 'ºC'),
	(217661, 118, '2014-03-01 01:10:41.000000', 'temperatura', 941.0000, 'ºC'),
	(217662, 118, '2014-03-01 01:10:42.000000', 'temperatura', 923.0000, 'ºC'),
	(217663, 118, '2014-03-01 01:10:43.000000', 'temperatura', 591.0000, 'ºC'),
	(217664, 118, '2014-03-01 01:10:44.000000', 'temperatura', 186.0000, 'ºC'),
	(217665, 118, '2014-03-01 01:10:45.000000', 'temperatura', 357.0000, 'ºC'),
	(217666, 118, '2014-03-01 01:10:46.000000', 'temperatura', 30.0000, 'ºC'),
	(217667, 118, '2014-03-01 01:10:47.000000', 'temperatura', 278.0000, 'ºC'),
	(217668, 118, '2014-03-01 01:10:48.000000', 'temperatura', 99.0000, 'ºC'),
	(217669, 118, '2014-03-01 01:10:49.000000', 'temperatura', 862.0000, 'ºC'),
	(217670, 118, '2014-03-01 01:10:50.000000', 'temperatura', 414.0000, 'ºC'),
	(217671, 118, '2014-03-01 01:10:51.000000', 'temperatura', 686.0000, 'ºC'),
	(217672, 118, '2014-03-01 01:10:52.000000', 'temperatura', 987.0000, 'ºC'),
	(217673, 118, '2014-03-01 01:10:53.000000', 'temperatura', 478.0000, 'ºC'),
	(217674, 118, '2014-03-01 01:10:54.000000', 'temperatura', 629.0000, 'ºC'),
	(217675, 118, '2014-03-01 01:10:55.000000', 'temperatura', 510.0000, 'ºC'),
	(217676, 118, '2014-03-01 01:10:56.000000', 'temperatura', 666.0000, 'ºC'),
	(217677, 118, '2014-03-01 01:10:57.000000', 'temperatura', 602.0000, 'ºC'),
	(217678, 118, '2014-03-01 01:10:58.000000', 'temperatura', 1010.0000, 'ºC'),
	(217679, 118, '2014-03-01 01:10:59.000000', 'temperatura', 843.0000, 'ºC'),
	(217680, 118, '2014-03-01 01:11:00.000000', 'temperatura', 1188.0000, 'ºC'),
	(217681, 118, '2014-03-01 01:11:01.000000', 'temperatura', 1010.0000, 'ºC'),
	(217682, 118, '2014-03-01 01:11:02.000000', 'temperatura', 289.0000, 'ºC'),
	(217683, 118, '2014-03-01 01:11:03.000000', 'temperatura', 813.0000, 'ºC'),
	(217684, 118, '2014-03-01 01:11:04.000000', 'temperatura', 801.0000, 'ºC'),
	(217685, 118, '2014-03-01 01:11:05.000000', 'temperatura', 367.0000, 'ºC'),
	(217686, 118, '2014-03-01 01:11:06.000000', 'temperatura', 630.0000, 'ºC'),
	(217687, 118, '2014-03-01 01:11:07.000000', 'temperatura', 850.0000, 'ºC'),
	(217688, 118, '2014-03-01 01:11:08.000000', 'temperatura', 1162.0000, 'ºC'),
	(217689, 118, '2014-03-01 01:11:09.000000', 'temperatura', 861.0000, 'ºC'),
	(217690, 118, '2014-03-01 01:11:10.000000', 'temperatura', 817.0000, 'ºC'),
	(217691, 118, '2014-03-01 01:11:11.000000', 'temperatura', 302.0000, 'ºC'),
	(217692, 118, '2014-03-01 01:11:12.000000', 'temperatura', 260.0000, 'ºC'),
	(217693, 118, '2014-03-01 01:11:13.000000', 'temperatura', 393.0000, 'ºC'),
	(217694, 118, '2014-03-01 01:11:14.000000', 'temperatura', 1186.0000, 'ºC'),
	(217695, 118, '2014-03-01 01:11:15.000000', 'temperatura', 1153.0000, 'ºC'),
	(217696, 118, '2014-03-01 01:11:16.000000', 'temperatura', 1005.0000, 'ºC'),
	(217697, 118, '2014-03-01 01:11:17.000000', 'temperatura', 370.0000, 'ºC'),
	(217698, 118, '2014-03-01 01:11:18.000000', 'temperatura', 33.0000, 'ºC'),
	(217699, 118, '2014-03-01 01:11:19.000000', 'temperatura', 258.0000, 'ºC'),
	(217700, 118, '2014-03-01 01:11:20.000000', 'temperatura', 1189.0000, 'ºC'),
	(217701, 118, '2014-03-01 01:11:21.000000', 'temperatura', 374.0000, 'ºC'),
	(217702, 118, '2014-03-01 01:11:22.000000', 'temperatura', 703.0000, 'ºC'),
	(217703, 118, '2014-03-01 01:11:23.000000', 'temperatura', 1195.0000, 'ºC'),
	(217704, 118, '2014-03-01 01:11:24.000000', 'temperatura', 265.0000, 'ºC'),
	(217705, 118, '2014-03-01 01:11:25.000000', 'temperatura', 143.0000, 'ºC'),
	(217706, 118, '2014-03-01 01:11:26.000000', 'temperatura', 1117.0000, 'ºC'),
	(217707, 118, '2014-03-01 01:11:27.000000', 'temperatura', 357.0000, 'ºC'),
	(217708, 118, '2014-03-01 01:11:28.000000', 'temperatura', 836.0000, 'ºC'),
	(217709, 118, '2014-03-01 01:11:29.000000', 'temperatura', 710.0000, 'ºC'),
	(217710, 118, '2014-03-01 01:11:30.000000', 'temperatura', 1041.0000, 'ºC'),
	(217711, 118, '2014-03-01 01:11:31.000000', 'temperatura', 676.0000, 'ºC'),
	(217712, 118, '2014-03-01 01:11:32.000000', 'temperatura', 259.0000, 'ºC'),
	(217713, 118, '2014-03-01 01:11:33.000000', 'temperatura', 467.0000, 'ºC'),
	(217714, 118, '2014-03-01 01:11:34.000000', 'temperatura', 358.0000, 'ºC'),
	(217715, 118, '2014-03-01 01:11:35.000000', 'temperatura', 391.0000, 'ºC'),
	(217716, 118, '2014-03-01 01:11:36.000000', 'temperatura', 881.0000, 'ºC'),
	(217717, 118, '2014-03-01 01:11:37.000000', 'temperatura', 832.0000, 'ºC'),
	(217718, 118, '2014-03-01 01:11:38.000000', 'temperatura', 319.0000, 'ºC'),
	(217719, 118, '2014-03-01 01:11:39.000000', 'temperatura', 298.0000, 'ºC'),
	(217720, 118, '2014-03-01 01:11:40.000000', 'temperatura', 535.0000, 'ºC'),
	(217721, 118, '2014-03-01 01:11:41.000000', 'temperatura', 581.0000, 'ºC'),
	(217722, 118, '2014-03-01 01:11:42.000000', 'temperatura', 101.0000, 'ºC'),
	(217723, 118, '2014-03-01 01:11:43.000000', 'temperatura', 1163.0000, 'ºC'),
	(217724, 118, '2014-03-01 01:11:44.000000', 'temperatura', 711.0000, 'ºC'),
	(217725, 118, '2014-03-01 01:11:45.000000', 'temperatura', 69.0000, 'ºC'),
	(217726, 118, '2014-03-01 01:11:46.000000', 'temperatura', 612.0000, 'ºC'),
	(217727, 118, '2014-03-01 01:11:47.000000', 'temperatura', 451.0000, 'ºC'),
	(217728, 118, '2014-03-01 01:11:48.000000', 'temperatura', 422.0000, 'ºC'),
	(217729, 118, '2014-03-01 01:11:49.000000', 'temperatura', 757.0000, 'ºC'),
	(217730, 118, '2014-03-01 01:11:50.000000', 'temperatura', 120.0000, 'ºC'),
	(217731, 118, '2014-03-01 01:11:51.000000', 'temperatura', 730.0000, 'ºC'),
	(217732, 118, '2014-03-01 01:11:52.000000', 'temperatura', 888.0000, 'ºC'),
	(217733, 118, '2014-03-01 01:11:53.000000', 'temperatura', 1053.0000, 'ºC'),
	(217734, 118, '2014-03-01 01:11:54.000000', 'temperatura', 201.0000, 'ºC'),
	(217735, 118, '2014-03-01 01:11:55.000000', 'temperatura', 247.0000, 'ºC'),
	(217736, 118, '2014-03-01 01:11:56.000000', 'temperatura', 633.0000, 'ºC'),
	(217737, 118, '2014-03-01 01:11:57.000000', 'temperatura', 25.0000, 'ºC'),
	(217738, 118, '2014-03-01 01:11:58.000000', 'temperatura', 625.0000, 'ºC'),
	(217739, 118, '2014-03-01 01:11:59.000000', 'temperatura', 651.0000, 'ºC'),
	(217740, 118, '2014-03-01 01:12:00.000000', 'temperatura', 180.0000, 'ºC'),
	(217741, 118, '2014-03-01 01:12:01.000000', 'temperatura', 147.0000, 'ºC'),
	(217742, 118, '2014-03-01 01:12:02.000000', 'temperatura', 195.0000, 'ºC'),
	(217743, 118, '2014-03-01 01:12:03.000000', 'temperatura', 534.0000, 'ºC'),
	(217744, 118, '2014-03-01 01:12:04.000000', 'temperatura', 886.0000, 'ºC'),
	(217745, 118, '2014-03-01 01:12:05.000000', 'temperatura', 427.0000, 'ºC'),
	(217746, 118, '2014-03-01 01:12:06.000000', 'temperatura', 678.0000, 'ºC'),
	(217747, 118, '2014-03-01 01:12:07.000000', 'temperatura', 908.0000, 'ºC'),
	(217748, 118, '2014-03-01 01:12:08.000000', 'temperatura', 108.0000, 'ºC'),
	(217749, 118, '2014-03-01 01:12:09.000000', 'temperatura', 216.0000, 'ºC'),
	(217750, 118, '2014-03-01 01:12:10.000000', 'temperatura', 755.0000, 'ºC'),
	(217751, 118, '2014-03-01 01:12:11.000000', 'temperatura', 729.0000, 'ºC'),
	(217752, 118, '2014-03-01 01:12:12.000000', 'temperatura', 181.0000, 'ºC'),
	(217753, 118, '2014-03-01 01:12:13.000000', 'temperatura', 1119.0000, 'ºC'),
	(217754, 118, '2014-03-01 01:12:14.000000', 'temperatura', 253.0000, 'ºC'),
	(217755, 118, '2014-03-01 01:12:15.000000', 'temperatura', 306.0000, 'ºC'),
	(217756, 118, '2014-03-01 01:12:16.000000', 'temperatura', 771.0000, 'ºC'),
	(217757, 118, '2014-03-01 01:12:17.000000', 'temperatura', 540.0000, 'ºC'),
	(217758, 118, '2014-03-01 01:12:18.000000', 'temperatura', 385.0000, 'ºC'),
	(217759, 118, '2014-03-01 01:12:19.000000', 'temperatura', 308.0000, 'ºC'),
	(217760, 118, '2014-03-01 01:12:20.000000', 'temperatura', 386.0000, 'ºC'),
	(217761, 118, '2014-03-01 01:12:21.000000', 'temperatura', 1005.0000, 'ºC'),
	(217762, 118, '2014-03-01 01:12:22.000000', 'temperatura', 270.0000, 'ºC'),
	(217763, 118, '2014-03-01 01:12:23.000000', 'temperatura', 734.0000, 'ºC'),
	(217764, 118, '2014-03-01 01:12:24.000000', 'temperatura', 459.0000, 'ºC'),
	(217765, 118, '2014-03-01 01:12:25.000000', 'temperatura', 95.0000, 'ºC'),
	(217766, 118, '2014-03-01 01:12:26.000000', 'temperatura', 300.0000, 'ºC'),
	(217767, 118, '2014-03-01 01:12:27.000000', 'temperatura', 13.0000, 'ºC'),
	(217768, 118, '2014-03-01 01:12:28.000000', 'temperatura', 364.0000, 'ºC'),
	(217769, 118, '2014-03-01 01:12:29.000000', 'temperatura', 584.0000, 'ºC'),
	(217770, 118, '2014-03-01 01:12:30.000000', 'temperatura', 630.0000, 'ºC'),
	(217771, 118, '2014-03-01 01:12:31.000000', 'temperatura', 195.0000, 'ºC'),
	(217772, 118, '2014-03-01 01:12:32.000000', 'temperatura', 288.0000, 'ºC'),
	(217773, 118, '2014-03-01 01:12:33.000000', 'temperatura', 856.0000, 'ºC'),
	(217774, 118, '2014-03-01 01:12:34.000000', 'temperatura', 1015.0000, 'ºC'),
	(217775, 118, '2014-03-01 01:12:35.000000', 'temperatura', 109.0000, 'ºC'),
	(217776, 118, '2014-03-01 01:12:36.000000', 'temperatura', 1098.0000, 'ºC'),
	(217777, 118, '2014-03-01 01:12:37.000000', 'temperatura', 366.0000, 'ºC'),
	(217778, 118, '2014-03-01 01:12:38.000000', 'temperatura', 937.0000, 'ºC'),
	(217779, 118, '2014-03-01 01:12:39.000000', 'temperatura', 1188.0000, 'ºC'),
	(217780, 118, '2014-03-01 01:12:40.000000', 'temperatura', 728.0000, 'ºC'),
	(217781, 118, '2014-03-01 01:12:41.000000', 'temperatura', 78.0000, 'ºC'),
	(217782, 118, '2014-03-01 01:12:42.000000', 'temperatura', 606.0000, 'ºC'),
	(217783, 118, '2014-03-01 01:12:43.000000', 'temperatura', 397.0000, 'ºC'),
	(217784, 118, '2014-03-01 01:12:44.000000', 'temperatura', 169.0000, 'ºC'),
	(217785, 118, '2014-03-01 01:12:45.000000', 'temperatura', 852.0000, 'ºC'),
	(217786, 118, '2014-03-01 01:12:46.000000', 'temperatura', 155.0000, 'ºC'),
	(217787, 118, '2014-03-01 01:12:47.000000', 'temperatura', 618.0000, 'ºC'),
	(217788, 118, '2014-03-01 01:12:48.000000', 'temperatura', 228.0000, 'ºC'),
	(217789, 118, '2014-03-01 01:12:49.000000', 'temperatura', 487.0000, 'ºC'),
	(217790, 118, '2014-03-01 01:12:50.000000', 'temperatura', 548.0000, 'ºC'),
	(217791, 118, '2014-03-01 01:12:51.000000', 'temperatura', 82.0000, 'ºC'),
	(217792, 118, '2014-03-01 01:12:52.000000', 'temperatura', 1166.0000, 'ºC'),
	(217793, 118, '2014-03-01 01:12:53.000000', 'temperatura', 785.0000, 'ºC'),
	(217794, 118, '2014-03-01 01:12:54.000000', 'temperatura', 429.0000, 'ºC'),
	(217795, 118, '2014-03-01 01:12:55.000000', 'temperatura', 990.0000, 'ºC'),
	(217796, 118, '2014-03-01 01:12:56.000000', 'temperatura', 63.0000, 'ºC'),
	(217797, 118, '2014-03-01 01:12:57.000000', 'temperatura', 945.0000, 'ºC'),
	(217798, 118, '2014-03-01 01:12:58.000000', 'temperatura', 936.0000, 'ºC'),
	(217799, 118, '2014-03-01 01:12:59.000000', 'temperatura', 646.0000, 'ºC'),
	(217800, 118, '2014-03-01 01:13:00.000000', 'temperatura', 422.0000, 'ºC'),
	(217801, 118, '2014-03-01 01:13:01.000000', 'temperatura', 172.0000, 'ºC'),
	(217802, 118, '2014-03-01 01:13:02.000000', 'temperatura', 794.0000, 'ºC'),
	(217803, 118, '2014-03-01 01:13:03.000000', 'temperatura', 1055.0000, 'ºC'),
	(217804, 118, '2014-03-01 01:13:04.000000', 'temperatura', 493.0000, 'ºC'),
	(217805, 118, '2014-03-01 01:13:05.000000', 'temperatura', 501.0000, 'ºC'),
	(217806, 118, '2014-03-01 01:13:06.000000', 'temperatura', 1027.0000, 'ºC'),
	(217807, 118, '2014-03-01 01:13:07.000000', 'temperatura', 32.0000, 'ºC'),
	(217808, 118, '2014-03-01 01:13:08.000000', 'temperatura', 681.0000, 'ºC'),
	(217809, 118, '2014-03-01 01:13:09.000000', 'temperatura', 909.0000, 'ºC'),
	(217810, 118, '2014-03-01 01:13:10.000000', 'temperatura', 101.0000, 'ºC'),
	(217811, 118, '2014-03-01 01:13:11.000000', 'temperatura', 181.0000, 'ºC'),
	(217812, 118, '2014-03-01 01:13:12.000000', 'temperatura', 603.0000, 'ºC'),
	(217813, 118, '2014-03-01 01:13:13.000000', 'temperatura', 72.0000, 'ºC'),
	(217814, 118, '2014-03-01 01:13:14.000000', 'temperatura', 953.0000, 'ºC'),
	(217815, 118, '2014-03-01 01:13:15.000000', 'temperatura', 947.0000, 'ºC'),
	(217816, 118, '2014-03-01 01:13:16.000000', 'temperatura', 677.0000, 'ºC'),
	(217817, 118, '2014-03-01 01:13:17.000000', 'temperatura', 545.0000, 'ºC'),
	(217818, 118, '2014-03-01 01:13:18.000000', 'temperatura', 696.0000, 'ºC'),
	(217819, 118, '2014-03-01 01:13:19.000000', 'temperatura', 645.0000, 'ºC'),
	(217820, 118, '2014-03-01 01:13:20.000000', 'temperatura', 1139.0000, 'ºC'),
	(217821, 118, '2014-03-01 01:13:21.000000', 'temperatura', 158.0000, 'ºC'),
	(217822, 118, '2014-03-01 01:13:22.000000', 'temperatura', 975.0000, 'ºC'),
	(217823, 118, '2014-03-01 01:13:23.000000', 'temperatura', 802.0000, 'ºC'),
	(217824, 118, '2014-03-01 01:13:24.000000', 'temperatura', 1084.0000, 'ºC'),
	(217825, 118, '2014-03-01 01:13:25.000000', 'temperatura', 616.0000, 'ºC'),
	(217826, 118, '2014-03-01 01:13:26.000000', 'temperatura', 1028.0000, 'ºC'),
	(217827, 118, '2014-03-01 01:13:27.000000', 'temperatura', 894.0000, 'ºC'),
	(217828, 118, '2014-03-01 01:13:28.000000', 'temperatura', 185.0000, 'ºC'),
	(217829, 118, '2014-03-01 01:13:29.000000', 'temperatura', 644.0000, 'ºC'),
	(217830, 118, '2014-03-01 01:13:30.000000', 'temperatura', 266.0000, 'ºC'),
	(217831, 118, '2014-03-01 01:13:31.000000', 'temperatura', 598.0000, 'ºC'),
	(217832, 118, '2014-03-01 01:13:32.000000', 'temperatura', 994.0000, 'ºC'),
	(217833, 118, '2014-03-01 01:13:33.000000', 'temperatura', 777.0000, 'ºC'),
	(217834, 118, '2014-03-01 01:13:34.000000', 'temperatura', 901.0000, 'ºC'),
	(217835, 118, '2014-03-01 01:13:35.000000', 'temperatura', 976.0000, 'ºC'),
	(217836, 118, '2014-03-01 01:13:36.000000', 'temperatura', 977.0000, 'ºC'),
	(217837, 118, '2014-03-01 01:13:37.000000', 'temperatura', 757.0000, 'ºC'),
	(217838, 118, '2014-03-01 01:13:38.000000', 'temperatura', 854.0000, 'ºC'),
	(217839, 118, '2014-03-01 01:13:39.000000', 'temperatura', 800.0000, 'ºC'),
	(217840, 118, '2014-03-01 01:13:40.000000', 'temperatura', 240.0000, 'ºC'),
	(217841, 118, '2014-03-01 01:13:41.000000', 'temperatura', 1.0000, 'ºC'),
	(217842, 118, '2014-03-01 01:13:42.000000', 'temperatura', 484.0000, 'ºC'),
	(217843, 118, '2014-03-01 01:13:43.000000', 'temperatura', 19.0000, 'ºC'),
	(217844, 118, '2014-03-01 01:13:44.000000', 'temperatura', 1042.0000, 'ºC'),
	(217845, 118, '2014-03-01 01:13:45.000000', 'temperatura', 354.0000, 'ºC'),
	(217846, 118, '2014-03-01 01:13:46.000000', 'temperatura', 1043.0000, 'ºC'),
	(217847, 118, '2014-03-01 01:13:47.000000', 'temperatura', 554.0000, 'ºC'),
	(217848, 118, '2014-03-01 01:13:48.000000', 'temperatura', 844.0000, 'ºC'),
	(217849, 118, '2014-03-01 01:13:49.000000', 'temperatura', 157.0000, 'ºC'),
	(217850, 118, '2014-03-01 01:13:50.000000', 'temperatura', 653.0000, 'ºC'),
	(217851, 118, '2014-03-01 01:13:51.000000', 'temperatura', 395.0000, 'ºC'),
	(217852, 118, '2014-03-01 01:13:52.000000', 'temperatura', 17.0000, 'ºC'),
	(217853, 118, '2014-03-01 01:13:53.000000', 'temperatura', 99.0000, 'ºC'),
	(217854, 118, '2014-03-01 01:13:54.000000', 'temperatura', 444.0000, 'ºC'),
	(217855, 118, '2014-03-01 01:13:55.000000', 'temperatura', 723.0000, 'ºC'),
	(217856, 118, '2014-03-01 01:13:56.000000', 'temperatura', 1084.0000, 'ºC'),
	(217857, 118, '2014-03-01 01:13:57.000000', 'temperatura', 854.0000, 'ºC'),
	(217858, 118, '2014-03-01 01:13:58.000000', 'temperatura', 1015.0000, 'ºC'),
	(217859, 118, '2014-03-01 01:13:59.000000', 'temperatura', 115.0000, 'ºC'),
	(217860, 118, '2014-03-01 01:14:00.000000', 'temperatura', 1129.0000, 'ºC'),
	(217861, 118, '2014-03-01 01:14:01.000000', 'temperatura', 501.0000, 'ºC'),
	(217862, 118, '2014-03-01 01:14:02.000000', 'temperatura', 317.0000, 'ºC'),
	(217863, 118, '2014-03-01 01:14:03.000000', 'temperatura', 83.0000, 'ºC'),
	(217864, 118, '2014-03-01 01:14:04.000000', 'temperatura', 664.0000, 'ºC'),
	(217865, 118, '2014-03-01 01:14:05.000000', 'temperatura', 672.0000, 'ºC'),
	(217866, 118, '2014-03-01 01:14:06.000000', 'temperatura', 168.0000, 'ºC'),
	(217867, 118, '2014-03-01 01:14:07.000000', 'temperatura', 26.0000, 'ºC'),
	(217868, 118, '2014-03-01 01:14:08.000000', 'temperatura', 828.0000, 'ºC'),
	(217869, 118, '2014-03-01 01:14:09.000000', 'temperatura', 459.0000, 'ºC'),
	(217870, 118, '2014-03-01 01:14:10.000000', 'temperatura', 1015.0000, 'ºC'),
	(217871, 118, '2014-03-01 01:14:11.000000', 'temperatura', 97.0000, 'ºC'),
	(217872, 118, '2014-03-01 01:14:12.000000', 'temperatura', 1039.0000, 'ºC'),
	(217873, 118, '2014-03-01 01:14:13.000000', 'temperatura', 105.0000, 'ºC'),
	(217874, 118, '2014-03-01 01:14:14.000000', 'temperatura', 1007.0000, 'ºC'),
	(217875, 118, '2014-03-01 01:14:15.000000', 'temperatura', 1124.0000, 'ºC'),
	(217876, 118, '2014-03-01 01:14:16.000000', 'temperatura', 197.0000, 'ºC'),
	(217877, 118, '2014-03-01 01:14:17.000000', 'temperatura', 13.0000, 'ºC'),
	(217878, 118, '2014-03-01 01:14:18.000000', 'temperatura', 675.0000, 'ºC'),
	(217879, 118, '2014-03-01 01:14:19.000000', 'temperatura', 938.0000, 'ºC'),
	(217880, 118, '2014-03-01 01:14:20.000000', 'temperatura', 265.0000, 'ºC'),
	(217881, 118, '2014-03-01 01:14:21.000000', 'temperatura', 909.0000, 'ºC'),
	(217882, 118, '2014-03-01 01:14:22.000000', 'temperatura', 153.0000, 'ºC'),
	(217883, 118, '2014-03-01 01:14:23.000000', 'temperatura', 440.0000, 'ºC'),
	(217884, 118, '2014-03-01 01:14:24.000000', 'temperatura', 540.0000, 'ºC'),
	(217885, 118, '2014-03-01 01:14:25.000000', 'temperatura', 180.0000, 'ºC'),
	(217886, 118, '2014-03-01 01:14:26.000000', 'temperatura', 481.0000, 'ºC'),
	(217887, 118, '2014-03-01 01:14:27.000000', 'temperatura', 667.0000, 'ºC'),
	(217888, 118, '2014-03-01 01:14:28.000000', 'temperatura', 692.0000, 'ºC'),
	(217889, 118, '2014-03-01 01:14:29.000000', 'temperatura', 258.0000, 'ºC'),
	(217890, 118, '2014-03-01 01:14:30.000000', 'temperatura', 417.0000, 'ºC'),
	(217891, 118, '2014-03-01 01:14:31.000000', 'temperatura', 112.0000, 'ºC'),
	(217892, 118, '2014-03-01 01:14:32.000000', 'temperatura', 507.0000, 'ºC'),
	(217893, 118, '2014-03-01 01:14:33.000000', 'temperatura', 999.0000, 'ºC'),
	(217894, 118, '2014-03-01 01:14:34.000000', 'temperatura', 1075.0000, 'ºC'),
	(217895, 118, '2014-03-01 01:14:35.000000', 'temperatura', 1180.0000, 'ºC'),
	(217896, 118, '2014-03-01 01:14:36.000000', 'temperatura', 276.0000, 'ºC'),
	(217897, 118, '2014-03-01 01:14:37.000000', 'temperatura', 240.0000, 'ºC'),
	(217898, 118, '2014-03-01 01:14:38.000000', 'temperatura', 372.0000, 'ºC'),
	(217899, 118, '2014-03-01 01:14:39.000000', 'temperatura', 1140.0000, 'ºC'),
	(217900, 118, '2014-03-01 01:14:40.000000', 'temperatura', 983.0000, 'ºC'),
	(217901, 118, '2014-03-01 01:14:41.000000', 'temperatura', 297.0000, 'ºC'),
	(217902, 118, '2014-03-01 01:14:42.000000', 'temperatura', 935.0000, 'ºC'),
	(217903, 118, '2014-03-01 01:14:43.000000', 'temperatura', 186.0000, 'ºC'),
	(217904, 118, '2014-03-01 01:14:44.000000', 'temperatura', 525.0000, 'ºC'),
	(217905, 118, '2014-03-01 01:14:45.000000', 'temperatura', 866.0000, 'ºC'),
	(217906, 118, '2014-03-01 01:14:46.000000', 'temperatura', 359.0000, 'ºC'),
	(217907, 118, '2014-03-01 01:14:47.000000', 'temperatura', 395.0000, 'ºC'),
	(217908, 118, '2014-03-01 01:14:48.000000', 'temperatura', 897.0000, 'ºC'),
	(217909, 118, '2014-03-01 01:14:49.000000', 'temperatura', 902.0000, 'ºC'),
	(217910, 118, '2014-03-01 01:14:50.000000', 'temperatura', 619.0000, 'ºC'),
	(217911, 118, '2014-03-01 01:14:51.000000', 'temperatura', 390.0000, 'ºC'),
	(217912, 118, '2014-03-01 01:14:52.000000', 'temperatura', 94.0000, 'ºC'),
	(217913, 118, '2014-03-01 01:14:53.000000', 'temperatura', 498.0000, 'ºC'),
	(217914, 118, '2014-03-01 01:14:54.000000', 'temperatura', 1011.0000, 'ºC'),
	(217915, 118, '2014-03-01 01:14:55.000000', 'temperatura', 1162.0000, 'ºC'),
	(217916, 118, '2014-03-01 01:14:56.000000', 'temperatura', 377.0000, 'ºC'),
	(217917, 118, '2014-03-01 01:14:57.000000', 'temperatura', 799.0000, 'ºC'),
	(217918, 118, '2014-03-01 01:14:58.000000', 'temperatura', 465.0000, 'ºC'),
	(217919, 118, '2014-03-01 01:14:59.000000', 'temperatura', 1127.0000, 'ºC'),
	(217920, 118, '2014-03-01 01:15:00.000000', 'temperatura', 641.0000, 'ºC'),
	(217921, 118, '2014-03-01 01:15:01.000000', 'temperatura', 1023.0000, 'ºC'),
	(217922, 118, '2014-03-01 01:15:02.000000', 'temperatura', 793.0000, 'ºC'),
	(217923, 118, '2014-03-01 01:15:03.000000', 'temperatura', 897.0000, 'ºC'),
	(217924, 118, '2014-03-01 01:15:04.000000', 'temperatura', 908.0000, 'ºC'),
	(217925, 118, '2014-03-01 01:15:05.000000', 'temperatura', 650.0000, 'ºC'),
	(217926, 118, '2014-03-01 01:15:06.000000', 'temperatura', 525.0000, 'ºC'),
	(217927, 118, '2014-03-01 01:15:07.000000', 'temperatura', 678.0000, 'ºC'),
	(217928, 118, '2014-03-01 01:15:08.000000', 'temperatura', 614.0000, 'ºC'),
	(217929, 118, '2014-03-01 01:15:09.000000', 'temperatura', 1035.0000, 'ºC'),
	(217930, 118, '2014-03-01 01:15:10.000000', 'temperatura', 934.0000, 'ºC'),
	(217931, 118, '2014-03-01 01:15:11.000000', 'temperatura', 364.0000, 'ºC'),
	(217932, 118, '2014-03-01 01:15:12.000000', 'temperatura', 219.0000, 'ºC'),
	(217933, 118, '2014-03-01 01:15:13.000000', 'temperatura', 5.0000, 'ºC'),
	(217934, 118, '2014-03-01 01:15:14.000000', 'temperatura', 567.0000, 'ºC'),
	(217935, 118, '2014-03-01 01:15:15.000000', 'temperatura', 423.0000, 'ºC'),
	(217936, 118, '2014-03-01 01:15:16.000000', 'temperatura', 411.0000, 'ºC'),
	(217937, 118, '2014-03-01 01:15:17.000000', 'temperatura', 790.0000, 'ºC'),
	(217938, 118, '2014-03-01 01:15:18.000000', 'temperatura', 314.0000, 'ºC'),
	(217939, 118, '2014-03-01 01:15:19.000000', 'temperatura', 404.0000, 'ºC'),
	(217940, 118, '2014-03-01 01:15:20.000000', 'temperatura', 1077.0000, 'ºC'),
	(217941, 118, '2014-03-01 01:15:21.000000', 'temperatura', 572.0000, 'ºC'),
	(217942, 118, '2014-03-01 01:15:22.000000', 'temperatura', 829.0000, 'ºC'),
	(217943, 118, '2014-03-01 01:15:23.000000', 'temperatura', 29.0000, 'ºC'),
	(217944, 118, '2014-03-01 01:15:24.000000', 'temperatura', 58.0000, 'ºC'),
	(217945, 118, '2014-03-01 01:15:25.000000', 'temperatura', 206.0000, 'ºC'),
	(217946, 118, '2014-03-01 01:15:26.000000', 'temperatura', 857.0000, 'ºC'),
	(217947, 118, '2014-03-01 01:15:27.000000', 'temperatura', 66.0000, 'ºC'),
	(217948, 118, '2014-03-01 01:15:28.000000', 'temperatura', 161.0000, 'ºC'),
	(217949, 118, '2014-03-01 01:15:29.000000', 'temperatura', 608.0000, 'ºC'),
	(217950, 118, '2014-03-01 01:15:30.000000', 'temperatura', 156.0000, 'ºC'),
	(217951, 118, '2014-03-01 01:15:31.000000', 'temperatura', 156.0000, 'ºC'),
	(217952, 118, '2014-03-01 01:15:32.000000', 'temperatura', 314.0000, 'ºC'),
	(217953, 118, '2014-03-01 01:15:33.000000', 'temperatura', 1102.0000, 'ºC'),
	(217954, 118, '2014-03-01 01:15:34.000000', 'temperatura', 969.0000, 'ºC'),
	(217955, 118, '2014-03-01 01:15:35.000000', 'temperatura', 338.0000, 'ºC'),
	(217956, 118, '2014-03-01 01:15:36.000000', 'temperatura', 1183.0000, 'ºC'),
	(217957, 118, '2014-03-01 01:15:37.000000', 'temperatura', 103.0000, 'ºC'),
	(217958, 118, '2014-03-01 01:15:38.000000', 'temperatura', 565.0000, 'ºC'),
	(217959, 118, '2014-03-01 01:15:39.000000', 'temperatura', 116.0000, 'ºC'),
	(217960, 118, '2014-03-01 01:15:40.000000', 'temperatura', 86.0000, 'ºC'),
	(217961, 118, '2014-03-01 01:15:41.000000', 'temperatura', 84.0000, 'ºC'),
	(217962, 118, '2014-03-01 01:15:42.000000', 'temperatura', 162.0000, 'ºC'),
	(217963, 118, '2014-03-01 01:15:43.000000', 'temperatura', 557.0000, 'ºC'),
	(217964, 118, '2014-03-01 01:15:44.000000', 'temperatura', 1099.0000, 'ºC'),
	(217965, 118, '2014-03-01 01:15:45.000000', 'temperatura', 225.0000, 'ºC'),
	(217966, 118, '2014-03-01 01:15:46.000000', 'temperatura', 230.0000, 'ºC'),
	(217967, 118, '2014-03-01 01:15:47.000000', 'temperatura', 474.0000, 'ºC'),
	(217968, 118, '2014-03-01 01:15:48.000000', 'temperatura', 480.0000, 'ºC'),
	(217969, 118, '2014-03-01 01:15:49.000000', 'temperatura', 980.0000, 'ºC'),
	(217970, 118, '2014-03-01 01:15:50.000000', 'temperatura', 1059.0000, 'ºC'),
	(217971, 118, '2014-03-01 01:15:51.000000', 'temperatura', 1158.0000, 'ºC'),
	(217972, 118, '2014-03-01 01:15:52.000000', 'temperatura', 213.0000, 'ºC'),
	(217973, 118, '2014-03-01 01:15:53.000000', 'temperatura', 1192.0000, 'ºC'),
	(217974, 118, '2014-03-01 01:15:54.000000', 'temperatura', 520.0000, 'ºC'),
	(217975, 118, '2014-03-01 01:15:55.000000', 'temperatura', 226.0000, 'ºC'),
	(217976, 118, '2014-03-01 01:15:56.000000', 'temperatura', 768.0000, 'ºC'),
	(217977, 118, '2014-03-01 01:15:57.000000', 'temperatura', 763.0000, 'ºC'),
	(217978, 118, '2014-03-01 01:15:58.000000', 'temperatura', 312.0000, 'ºC'),
	(217979, 118, '2014-03-01 01:15:59.000000', 'temperatura', 472.0000, 'ºC'),
	(217980, 118, '2014-03-01 01:16:00.000000', 'temperatura', 226.0000, 'ºC'),
	(217981, 118, '2014-03-01 01:16:01.000000', 'temperatura', 913.0000, 'ºC'),
	(217982, 118, '2014-03-01 01:16:02.000000', 'temperatura', 289.0000, 'ºC'),
	(217983, 118, '2014-03-01 01:16:03.000000', 'temperatura', 1104.0000, 'ºC'),
	(217984, 118, '2014-03-01 01:16:04.000000', 'temperatura', 1054.0000, 'ºC'),
	(217985, 118, '2014-03-01 01:16:05.000000', 'temperatura', 757.0000, 'ºC'),
	(217986, 118, '2014-03-01 01:16:06.000000', 'temperatura', 626.0000, 'ºC'),
	(217987, 118, '2014-03-01 01:16:07.000000', 'temperatura', 859.0000, 'ºC'),
	(217988, 118, '2014-03-01 01:16:08.000000', 'temperatura', 16.0000, 'ºC'),
	(217989, 118, '2014-03-01 01:16:09.000000', 'temperatura', 1107.0000, 'ºC'),
	(217990, 118, '2014-03-01 01:16:10.000000', 'temperatura', 684.0000, 'ºC'),
	(217991, 118, '2014-03-01 01:16:11.000000', 'temperatura', 99.0000, 'ºC'),
	(217992, 118, '2014-03-01 01:16:12.000000', 'temperatura', 847.0000, 'ºC'),
	(217993, 118, '2014-03-01 01:16:13.000000', 'temperatura', 335.0000, 'ºC'),
	(217994, 118, '2014-03-01 01:16:14.000000', 'temperatura', 337.0000, 'ºC'),
	(217995, 118, '2014-03-01 01:16:15.000000', 'temperatura', 681.0000, 'ºC'),
	(217996, 118, '2014-03-01 01:16:16.000000', 'temperatura', 1195.0000, 'ºC'),
	(217997, 118, '2014-03-01 01:16:17.000000', 'temperatura', 331.0000, 'ºC'),
	(217998, 118, '2014-03-01 01:16:18.000000', 'temperatura', 470.0000, 'ºC'),
	(217999, 118, '2014-03-01 01:16:19.000000', 'temperatura', 160.0000, 'ºC'),
	(218000, 118, '2014-03-01 01:16:20.000000', 'temperatura', 587.0000, 'ºC'),
	(218001, 118, '2014-03-01 01:16:21.000000', 'temperatura', 59.0000, 'ºC'),
	(218002, 118, '2014-03-01 01:16:22.000000', 'temperatura', 932.0000, 'ºC'),
	(218003, 118, '2014-03-01 01:16:23.000000', 'temperatura', 884.0000, 'ºC'),
	(218004, 118, '2014-03-01 01:16:24.000000', 'temperatura', 424.0000, 'ºC'),
	(218005, 118, '2014-03-01 01:16:25.000000', 'temperatura', 670.0000, 'ºC'),
	(218006, 118, '2014-03-01 01:16:26.000000', 'temperatura', 878.0000, 'ºC'),
	(218007, 118, '2014-03-01 01:16:27.000000', 'temperatura', 1179.0000, 'ºC'),
	(218008, 118, '2014-03-01 01:16:28.000000', 'temperatura', 861.0000, 'ºC'),
	(218009, 118, '2014-03-01 01:16:29.000000', 'temperatura', 770.0000, 'ºC'),
	(218010, 118, '2014-03-01 01:16:30.000000', 'temperatura', 69.0000, 'ºC'),
	(218011, 118, '2014-03-01 01:16:31.000000', 'temperatura', 435.0000, 'ºC'),
	(218012, 118, '2014-03-01 01:16:32.000000', 'temperatura', 767.0000, 'ºC'),
	(218013, 118, '2014-03-01 01:16:33.000000', 'temperatura', 130.0000, 'ºC'),
	(218014, 118, '2014-03-01 01:16:34.000000', 'temperatura', 752.0000, 'ºC'),
	(218015, 118, '2014-03-01 01:16:35.000000', 'temperatura', 967.0000, 'ºC'),
	(218016, 118, '2014-03-01 01:16:36.000000', 'temperatura', 182.0000, 'ºC'),
	(218017, 118, '2014-03-01 01:16:37.000000', 'temperatura', 410.0000, 'ºC'),
	(218018, 118, '2014-03-01 01:16:38.000000', 'temperatura', 303.0000, 'ºC'),
	(218019, 118, '2014-03-01 01:16:39.000000', 'temperatura', 286.0000, 'ºC'),
	(218020, 118, '2014-03-01 01:16:40.000000', 'temperatura', 521.0000, 'ºC'),
	(218021, 118, '2014-03-01 01:16:41.000000', 'temperatura', 549.0000, 'ºC'),
	(218022, 118, '2014-03-01 01:16:42.000000', 'temperatura', 1183.0000, 'ºC'),
	(218023, 118, '2014-03-01 01:16:43.000000', 'temperatura', 669.0000, 'ºC'),
	(218024, 118, '2014-03-01 01:16:44.000000', 'temperatura', 998.0000, 'ºC'),
	(218025, 118, '2014-03-01 01:16:45.000000', 'temperatura', 580.0000, 'ºC'),
	(218026, 118, '2014-03-01 01:16:46.000000', 'temperatura', 1107.0000, 'ºC'),
	(218027, 118, '2014-03-01 01:16:47.000000', 'temperatura', 195.0000, 'ºC'),
	(218028, 118, '2014-03-01 01:16:48.000000', 'temperatura', 57.0000, 'ºC'),
	(218029, 118, '2014-03-01 01:16:49.000000', 'temperatura', 898.0000, 'ºC'),
	(218030, 118, '2014-03-01 01:16:50.000000', 'temperatura', 718.0000, 'ºC'),
	(218031, 118, '2014-03-01 01:16:51.000000', 'temperatura', 900.0000, 'ºC'),
	(218032, 118, '2014-03-01 01:16:52.000000', 'temperatura', 1146.0000, 'ºC'),
	(218033, 118, '2014-03-01 01:16:53.000000', 'temperatura', 632.0000, 'ºC'),
	(218034, 118, '2014-03-01 01:16:54.000000', 'temperatura', 920.0000, 'ºC'),
	(218035, 118, '2014-03-01 01:16:55.000000', 'temperatura', 306.0000, 'ºC'),
	(218036, 118, '2014-03-01 01:16:56.000000', 'temperatura', 1171.0000, 'ºC'),
	(218037, 118, '2014-03-01 01:16:57.000000', 'temperatura', 136.0000, 'ºC'),
	(218038, 118, '2014-03-01 01:16:58.000000', 'temperatura', 767.0000, 'ºC'),
	(218039, 118, '2014-03-01 01:16:59.000000', 'temperatura', 1029.0000, 'ºC'),
	(218040, 118, '2014-03-01 01:17:00.000000', 'temperatura', 446.0000, 'ºC'),
	(218041, 118, '2014-03-01 01:17:01.000000', 'temperatura', 340.0000, 'ºC'),
	(218042, 118, '2014-03-01 01:17:02.000000', 'temperatura', 366.0000, 'ºC'),
	(218043, 118, '2014-03-01 01:17:03.000000', 'temperatura', 808.0000, 'ºC'),
	(218044, 118, '2014-03-01 01:17:04.000000', 'temperatura', 542.0000, 'ºC'),
	(218045, 118, '2014-03-01 01:17:05.000000', 'temperatura', 288.0000, 'ºC'),
	(218046, 118, '2014-03-01 01:17:06.000000', 'temperatura', 1014.0000, 'ºC'),
	(218047, 118, '2014-03-01 01:17:07.000000', 'temperatura', 606.0000, 'ºC'),
	(218048, 118, '2014-03-01 01:17:08.000000', 'temperatura', 1190.0000, 'ºC'),
	(218049, 118, '2014-03-01 01:17:09.000000', 'temperatura', 532.0000, 'ºC'),
	(218050, 118, '2014-03-01 01:17:10.000000', 'temperatura', 289.0000, 'ºC'),
	(218051, 118, '2014-03-01 01:17:11.000000', 'temperatura', 1049.0000, 'ºC'),
	(218052, 118, '2014-03-01 01:17:12.000000', 'temperatura', 780.0000, 'ºC'),
	(218053, 118, '2014-03-01 01:17:13.000000', 'temperatura', 754.0000, 'ºC'),
	(218054, 118, '2014-03-01 01:17:14.000000', 'temperatura', 229.0000, 'ºC'),
	(218055, 118, '2014-03-01 01:17:15.000000', 'temperatura', 84.0000, 'ºC'),
	(218056, 118, '2014-03-01 01:17:16.000000', 'temperatura', 933.0000, 'ºC'),
	(218057, 118, '2014-03-01 01:17:17.000000', 'temperatura', 815.0000, 'ºC'),
	(218058, 118, '2014-03-01 01:17:18.000000', 'temperatura', 78.0000, 'ºC'),
	(218059, 118, '2014-03-01 01:17:19.000000', 'temperatura', 342.0000, 'ºC'),
	(218060, 118, '2014-03-01 01:17:20.000000', 'temperatura', 280.0000, 'ºC'),
	(218061, 118, '2014-03-01 01:17:21.000000', 'temperatura', 371.0000, 'ºC'),
	(218062, 118, '2014-03-01 01:17:22.000000', 'temperatura', 1018.0000, 'ºC'),
	(218063, 118, '2014-03-01 01:17:23.000000', 'temperatura', 377.0000, 'ºC'),
	(218064, 118, '2014-03-01 01:17:24.000000', 'temperatura', 30.0000, 'ºC'),
	(218065, 118, '2014-03-01 01:17:25.000000', 'temperatura', 219.0000, 'ºC'),
	(218066, 118, '2014-03-01 01:17:26.000000', 'temperatura', 1007.0000, 'ºC'),
	(218067, 118, '2014-03-01 01:17:27.000000', 'temperatura', 778.0000, 'ºC'),
	(218068, 118, '2014-03-01 01:17:28.000000', 'temperatura', 870.0000, 'ºC'),
	(218069, 118, '2014-03-01 01:17:29.000000', 'temperatura', 815.0000, 'ºC'),
	(218070, 118, '2014-03-01 01:17:30.000000', 'temperatura', 265.0000, 'ºC'),
	(218071, 118, '2014-03-01 01:17:31.000000', 'temperatura', 81.0000, 'ºC'),
	(218072, 118, '2014-03-01 01:17:32.000000', 'temperatura', 813.0000, 'ºC'),
	(218073, 118, '2014-03-01 01:17:33.000000', 'temperatura', 220.0000, 'ºC'),
	(218074, 118, '2014-03-01 01:17:34.000000', 'temperatura', 1062.0000, 'ºC'),
	(218075, 118, '2014-03-01 01:17:35.000000', 'temperatura', 1049.0000, 'ºC'),
	(218076, 118, '2014-03-01 01:17:36.000000', 'temperatura', 862.0000, 'ºC'),
	(218077, 118, '2014-03-01 01:17:37.000000', 'temperatura', 1163.0000, 'ºC'),
	(218078, 118, '2014-03-01 01:17:38.000000', 'temperatura', 829.0000, 'ºC'),
	(218079, 118, '2014-03-01 01:17:39.000000', 'temperatura', 655.0000, 'ºC'),
	(218080, 118, '2014-03-01 01:17:40.000000', 'temperatura', 788.0000, 'ºC'),
	(218081, 118, '2014-03-01 01:17:41.000000', 'temperatura', 776.0000, 'ºC'),
	(218082, 118, '2014-03-01 01:17:42.000000', 'temperatura', 318.0000, 'ºC'),
	(218083, 118, '2014-03-01 01:17:43.000000', 'temperatura', 460.0000, 'ºC'),
	(218084, 118, '2014-03-01 01:17:44.000000', 'temperatura', 146.0000, 'ºC'),
	(218085, 118, '2014-03-01 01:17:45.000000', 'temperatura', 552.0000, 'ºC'),
	(218086, 118, '2014-03-01 01:17:46.000000', 'temperatura', 1124.0000, 'ºC'),
	(218087, 118, '2014-03-01 01:17:47.000000', 'temperatura', 365.0000, 'ºC'),
	(218088, 118, '2014-03-01 01:17:48.000000', 'temperatura', 851.0000, 'ºC'),
	(218089, 118, '2014-03-01 01:17:49.000000', 'temperatura', 762.0000, 'ºC'),
	(218090, 118, '2014-03-01 01:17:50.000000', 'temperatura', 56.0000, 'ºC'),
	(218091, 118, '2014-03-01 01:17:51.000000', 'temperatura', 394.0000, 'ºC'),
	(218092, 118, '2014-03-01 01:17:52.000000', 'temperatura', 605.0000, 'ºC'),
	(218093, 118, '2014-03-01 01:17:53.000000', 'temperatura', 641.0000, 'ºC'),
	(218094, 118, '2014-03-01 01:17:54.000000', 'temperatura', 192.0000, 'ºC'),
	(218095, 118, '2014-03-01 01:17:55.000000', 'temperatura', 239.0000, 'ºC'),
	(218096, 118, '2014-03-01 01:17:56.000000', 'temperatura', 616.0000, 'ºC'),
	(218097, 118, '2014-03-01 01:17:57.000000', 'temperatura', 1167.0000, 'ºC'),
	(218098, 118, '2014-03-01 01:17:58.000000', 'temperatura', 385.0000, 'ºC'),
	(218099, 118, '2014-03-01 01:17:59.000000', 'temperatura', 827.0000, 'ºC'),
	(218100, 118, '2014-03-01 01:18:00.000000', 'temperatura', 580.0000, 'ºC'),
	(218101, 118, '2014-03-01 01:18:01.000000', 'temperatura', 420.0000, 'ºC'),
	(218102, 118, '2014-03-01 01:18:02.000000', 'temperatura', 361.0000, 'ºC'),
	(218103, 118, '2014-03-01 01:18:03.000000', 'temperatura', 546.0000, 'ºC'),
	(218104, 118, '2014-03-01 01:18:04.000000', 'temperatura', 447.0000, 'ºC'),
	(218105, 118, '2014-03-01 01:18:05.000000', 'temperatura', 595.0000, 'ºC'),
	(218106, 118, '2014-03-01 01:18:06.000000', 'temperatura', 437.0000, 'ºC'),
	(218107, 118, '2014-03-01 01:18:07.000000', 'temperatura', 400.0000, 'ºC'),
	(218108, 118, '2014-03-01 01:18:08.000000', 'temperatura', 691.0000, 'ºC'),
	(218109, 118, '2014-03-01 01:18:09.000000', 'temperatura', 1054.0000, 'ºC'),
	(218110, 118, '2014-03-01 01:18:10.000000', 'temperatura', 796.0000, 'ºC'),
	(218111, 118, '2014-03-01 01:18:11.000000', 'temperatura', 820.0000, 'ºC'),
	(218112, 118, '2014-03-01 01:18:12.000000', 'temperatura', 512.0000, 'ºC'),
	(218113, 118, '2014-03-01 01:18:13.000000', 'temperatura', 99.0000, 'ºC'),
	(218114, 118, '2014-03-01 01:18:14.000000', 'temperatura', 162.0000, 'ºC'),
	(218115, 118, '2014-03-01 01:18:15.000000', 'temperatura', 511.0000, 'ºC'),
	(218116, 118, '2014-03-01 01:18:16.000000', 'temperatura', 869.0000, 'ºC'),
	(218117, 118, '2014-03-01 01:18:17.000000', 'temperatura', 415.0000, 'ºC'),
	(218118, 118, '2014-03-01 01:18:18.000000', 'temperatura', 666.0000, 'ºC'),
	(218119, 118, '2014-03-01 01:18:19.000000', 'temperatura', 887.0000, 'ºC'),
	(218120, 118, '2014-03-01 01:18:20.000000', 'temperatura', 39.0000, 'ºC'),
	(218121, 118, '2014-03-01 01:18:21.000000', 'temperatura', 1133.0000, 'ºC'),
	(218122, 118, '2014-03-01 01:18:22.000000', 'temperatura', 749.0000, 'ºC'),
	(218123, 118, '2014-03-01 01:18:23.000000', 'temperatura', 347.0000, 'ºC'),
	(218124, 118, '2014-03-01 01:18:24.000000', 'temperatura', 690.0000, 'ºC'),
	(218125, 118, '2014-03-01 01:18:25.000000', 'temperatura', 6.0000, 'ºC'),
	(218126, 118, '2014-03-01 01:18:26.000000', 'temperatura', 363.0000, 'ºC'),
	(218127, 118, '2014-03-01 01:18:27.000000', 'temperatura', 597.0000, 'ºC'),
	(218128, 118, '2014-03-01 01:18:28.000000', 'temperatura', 696.0000, 'ºC'),
	(218129, 118, '2014-03-01 01:18:29.000000', 'temperatura', 490.0000, 'ºC'),
	(218130, 118, '2014-03-01 01:18:30.000000', 'temperatura', 361.0000, 'ºC'),
	(218131, 118, '2014-03-01 01:18:31.000000', 'temperatura', 338.0000, 'ºC'),
	(218132, 118, '2014-03-01 01:18:32.000000', 'temperatura', 605.0000, 'ºC'),
	(218133, 118, '2014-03-01 01:18:33.000000', 'temperatura', 811.0000, 'ºC'),
	(218134, 118, '2014-03-01 01:18:34.000000', 'temperatura', 1044.0000, 'ºC'),
	(218135, 118, '2014-03-01 01:18:35.000000', 'temperatura', 384.0000, 'ºC'),
	(218136, 118, '2014-03-01 01:18:36.000000', 'temperatura', 1189.0000, 'ºC'),
	(218137, 118, '2014-03-01 01:18:37.000000', 'temperatura', 1196.0000, 'ºC'),
	(218138, 118, '2014-03-01 01:18:38.000000', 'temperatura', 12.0000, 'ºC'),
	(218139, 118, '2014-03-01 01:18:39.000000', 'temperatura', 71.0000, 'ºC'),
	(218140, 118, '2014-03-01 01:18:40.000000', 'temperatura', 321.0000, 'ºC'),
	(218141, 118, '2014-03-01 01:18:41.000000', 'temperatura', 192.0000, 'ºC'),
	(218142, 118, '2014-03-01 01:18:42.000000', 'temperatura', 1199.0000, 'ºC'),
	(218143, 118, '2014-03-01 01:18:43.000000', 'temperatura', 617.0000, 'ºC'),
	(218144, 118, '2014-03-01 01:18:44.000000', 'temperatura', 690.0000, 'ºC'),
	(218145, 118, '2014-03-01 01:18:45.000000', 'temperatura', 400.0000, 'ºC'),
	(218146, 118, '2014-03-01 01:18:46.000000', 'temperatura', 1128.0000, 'ºC'),
	(218147, 118, '2014-03-01 01:18:47.000000', 'temperatura', 843.0000, 'ºC'),
	(218148, 118, '2014-03-01 01:18:48.000000', 'temperatura', 829.0000, 'ºC'),
	(218149, 118, '2014-03-01 01:18:49.000000', 'temperatura', 416.0000, 'ºC'),
	(218150, 118, '2014-03-01 01:18:50.000000', 'temperatura', 795.0000, 'ºC'),
	(218151, 118, '2014-03-01 01:18:51.000000', 'temperatura', 329.0000, 'ºC'),
	(218152, 118, '2014-03-01 01:18:52.000000', 'temperatura', 459.0000, 'ºC'),
	(218153, 118, '2014-03-01 01:18:53.000000', 'temperatura', 110.0000, 'ºC'),
	(218154, 118, '2014-03-01 01:18:54.000000', 'temperatura', 373.0000, 'ºC'),
	(218155, 118, '2014-03-01 01:18:55.000000', 'temperatura', 334.0000, 'ºC'),
	(218156, 118, '2014-03-01 01:18:56.000000', 'temperatura', 554.0000, 'ºC'),
	(218157, 118, '2014-03-01 01:18:57.000000', 'temperatura', 568.0000, 'ºC'),
	(218158, 118, '2014-03-01 01:18:58.000000', 'temperatura', 1178.0000, 'ºC'),
	(218159, 118, '2014-03-01 01:18:59.000000', 'temperatura', 586.0000, 'ºC'),
	(218160, 118, '2014-03-01 01:19:00.000000', 'temperatura', 599.0000, 'ºC'),
	(218161, 118, '2014-03-01 01:19:01.000000', 'temperatura', 36.0000, 'ºC'),
	(218162, 118, '2014-03-01 01:19:02.000000', 'temperatura', 783.0000, 'ºC'),
	(218163, 118, '2014-03-01 01:19:03.000000', 'temperatura', 209.0000, 'ºC'),
	(218164, 118, '2014-03-01 01:19:04.000000', 'temperatura', 1094.0000, 'ºC'),
	(218165, 118, '2014-03-01 01:19:05.000000', 'temperatura', 46.0000, 'ºC'),
	(218166, 118, '2014-03-01 01:19:06.000000', 'temperatura', 549.0000, 'ºC'),
	(218167, 118, '2014-03-01 01:19:07.000000', 'temperatura', 205.0000, 'ºC'),
	(218168, 118, '2014-03-01 01:19:08.000000', 'temperatura', 579.0000, 'ºC'),
	(218169, 118, '2014-03-01 01:19:09.000000', 'temperatura', 1080.0000, 'ºC'),
	(218170, 118, '2014-03-01 01:19:10.000000', 'temperatura', 63.0000, 'ºC'),
	(218171, 118, '2014-03-01 01:19:11.000000', 'temperatura', 677.0000, 'ºC'),
	(218172, 118, '2014-03-01 01:19:12.000000', 'temperatura', 798.0000, 'ºC'),
	(218173, 118, '2014-03-01 01:19:13.000000', 'temperatura', 758.0000, 'ºC'),
	(218174, 118, '2014-03-01 01:19:14.000000', 'temperatura', 197.0000, 'ºC'),
	(218175, 118, '2014-03-01 01:19:15.000000', 'temperatura', 1113.0000, 'ºC'),
	(218176, 118, '2014-03-01 01:19:16.000000', 'temperatura', 171.0000, 'ºC'),
	(218177, 118, '2014-03-01 01:19:17.000000', 'temperatura', 1120.0000, 'ºC'),
	(218178, 118, '2014-03-01 01:19:18.000000', 'temperatura', 285.0000, 'ºC'),
	(218179, 118, '2014-03-01 01:19:19.000000', 'temperatura', 466.0000, 'ºC'),
	(218180, 118, '2014-03-01 01:19:20.000000', 'temperatura', 274.0000, 'ºC'),
	(218181, 118, '2014-03-01 01:19:21.000000', 'temperatura', 1176.0000, 'ºC'),
	(218182, 118, '2014-03-01 01:19:22.000000', 'temperatura', 256.0000, 'ºC'),
	(218183, 118, '2014-03-01 01:19:23.000000', 'temperatura', 151.0000, 'ºC'),
	(218184, 118, '2014-03-01 01:19:24.000000', 'temperatura', 1191.0000, 'ºC'),
	(218185, 118, '2014-03-01 01:19:25.000000', 'temperatura', 699.0000, 'ºC'),
	(218186, 118, '2014-03-01 01:19:26.000000', 'temperatura', 1124.0000, 'ºC'),
	(218187, 118, '2014-03-01 01:19:27.000000', 'temperatura', 1123.0000, 'ºC'),
	(218188, 118, '2014-03-01 01:19:28.000000', 'temperatura', 1043.0000, 'ºC'),
	(218189, 118, '2014-03-01 01:19:29.000000', 'temperatura', 647.0000, 'ºC'),
	(218190, 118, '2014-03-01 01:19:30.000000', 'temperatura', 108.0000, 'ºC'),
	(218191, 118, '2014-03-01 01:19:31.000000', 'temperatura', 998.0000, 'ºC'),
	(218192, 118, '2014-03-01 01:19:32.000000', 'temperatura', 1067.0000, 'ºC'),
	(218193, 118, '2014-03-01 01:19:33.000000', 'temperatura', 1142.0000, 'ºC'),
	(218194, 118, '2014-03-01 01:19:34.000000', 'temperatura', 109.0000, 'ºC'),
	(218195, 118, '2014-03-01 01:19:35.000000', 'temperatura', 719.0000, 'ºC'),
	(218196, 118, '2014-03-01 01:19:36.000000', 'temperatura', 870.0000, 'ºC'),
	(218197, 118, '2014-03-01 01:19:37.000000', 'temperatura', 992.0000, 'ºC'),
	(218198, 118, '2014-03-01 01:19:38.000000', 'temperatura', 1151.0000, 'ºC'),
	(218199, 118, '2014-03-01 01:19:39.000000', 'temperatura', 381.0000, 'ºC'),
	(218200, 118, '2014-03-01 01:19:40.000000', 'temperatura', 850.0000, 'ºC'),
	(218201, 118, '2014-03-01 01:19:41.000000', 'temperatura', 709.0000, 'ºC'),
	(218202, 118, '2014-03-01 01:19:42.000000', 'temperatura', 994.0000, 'ºC'),
	(218203, 118, '2014-03-01 01:19:43.000000', 'temperatura', 443.0000, 'ºC'),
	(218204, 118, '2014-03-01 01:19:44.000000', 'temperatura', 436.0000, 'ºC'),
	(218205, 118, '2014-03-01 01:19:45.000000', 'temperatura', 850.0000, 'ºC'),
	(218206, 118, '2014-03-01 01:19:46.000000', 'temperatura', 542.0000, 'ºC'),
	(218207, 118, '2014-03-01 01:19:47.000000', 'temperatura', 160.0000, 'ºC'),
	(218208, 118, '2014-03-01 01:19:48.000000', 'temperatura', 375.0000, 'ºC'),
	(218209, 118, '2014-03-01 01:19:49.000000', 'temperatura', 196.0000, 'ºC'),
	(218210, 118, '2014-03-01 01:19:50.000000', 'temperatura', 1054.0000, 'ºC'),
	(218211, 118, '2014-03-01 01:19:51.000000', 'temperatura', 1082.0000, 'ºC'),
	(218212, 118, '2014-03-01 01:19:52.000000', 'temperatura', 1049.0000, 'ºC'),
	(218213, 118, '2014-03-01 01:19:53.000000', 'temperatura', 800.0000, 'ºC'),
	(218214, 118, '2014-03-01 01:19:54.000000', 'temperatura', 852.0000, 'ºC'),
	(218215, 118, '2014-03-01 01:19:55.000000', 'temperatura', 662.0000, 'ºC'),
	(218216, 118, '2014-03-01 01:19:56.000000', 'temperatura', 755.0000, 'ºC'),
	(218217, 118, '2014-03-01 01:19:57.000000', 'temperatura', 588.0000, 'ºC'),
	(218218, 118, '2014-03-01 01:19:58.000000', 'temperatura', 675.0000, 'ºC'),
	(218219, 118, '2014-03-01 01:19:59.000000', 'temperatura', 414.0000, 'ºC'),
	(218220, 118, '2014-03-01 01:20:00.000000', 'temperatura', 44.0000, 'ºC'),
	(218221, 118, '2014-03-01 01:20:01.000000', 'temperatura', 178.0000, 'ºC'),
	(218222, 118, '2014-03-01 01:20:02.000000', 'temperatura', 757.0000, 'ºC'),
	(218223, 118, '2014-03-01 01:20:03.000000', 'temperatura', 852.0000, 'ºC'),
	(218224, 118, '2014-03-01 01:20:04.000000', 'temperatura', 791.0000, 'ºC'),
	(218225, 118, '2014-03-01 01:20:05.000000', 'temperatura', 201.0000, 'ºC'),
	(218226, 118, '2014-03-01 01:20:06.000000', 'temperatura', 1030.0000, 'ºC'),
	(218227, 118, '2014-03-01 01:20:07.000000', 'temperatura', 949.0000, 'ºC'),
	(218228, 118, '2014-03-01 01:20:08.000000', 'temperatura', 455.0000, 'ºC'),
	(218229, 118, '2014-03-01 01:20:09.000000', 'temperatura', 628.0000, 'ºC'),
	(218230, 118, '2014-03-01 01:20:10.000000', 'temperatura', 578.0000, 'ºC'),
	(218231, 118, '2014-03-01 01:20:11.000000', 'temperatura', 1004.0000, 'ºC'),
	(218232, 118, '2014-03-01 01:20:12.000000', 'temperatura', 889.0000, 'ºC'),
	(218233, 118, '2014-03-01 01:20:13.000000', 'temperatura', 233.0000, 'ºC'),
	(218234, 118, '2014-03-01 01:20:14.000000', 'temperatura', 899.0000, 'ºC'),
	(218235, 118, '2014-03-01 01:20:15.000000', 'temperatura', 195.0000, 'ºC'),
	(218236, 118, '2014-03-01 01:20:16.000000', 'temperatura', 680.0000, 'ºC'),
	(218237, 118, '2014-03-01 01:20:17.000000', 'temperatura', 413.0000, 'ºC'),
	(218238, 118, '2014-03-01 01:20:18.000000', 'temperatura', 29.0000, 'ºC'),
	(218239, 118, '2014-03-01 01:20:19.000000', 'temperatura', 104.0000, 'ºC'),
	(218240, 118, '2014-03-01 01:20:20.000000', 'temperatura', 435.0000, 'ºC'),
	(218241, 118, '2014-03-01 01:20:21.000000', 'temperatura', 661.0000, 'ºC'),
	(218242, 118, '2014-03-01 01:20:22.000000', 'temperatura', 804.0000, 'ºC'),
	(218243, 118, '2014-03-01 01:20:23.000000', 'temperatura', 835.0000, 'ºC'),
	(218244, 118, '2014-03-01 01:20:24.000000', 'temperatura', 563.0000, 'ºC'),
	(218245, 118, '2014-03-01 01:20:25.000000', 'temperatura', 310.0000, 'ºC'),
	(218246, 118, '2014-03-01 01:20:26.000000', 'temperatura', 1061.0000, 'ºC'),
	(218247, 118, '2014-03-01 01:20:27.000000', 'temperatura', 777.0000, 'ºC'),
	(218248, 118, '2014-03-01 01:20:28.000000', 'temperatura', 701.0000, 'ºC'),
	(218249, 118, '2014-03-01 01:20:29.000000', 'temperatura', 1176.0000, 'ºC'),
	(218250, 118, '2014-03-01 01:20:30.000000', 'temperatura', 177.0000, 'ºC'),
	(218251, 118, '2014-03-01 01:20:31.000000', 'temperatura', 957.0000, 'ºC'),
	(218252, 118, '2014-03-01 01:20:32.000000', 'temperatura', 654.0000, 'ºC'),
	(218253, 118, '2014-03-01 01:20:33.000000', 'temperatura', 401.0000, 'ºC'),
	(218254, 118, '2014-03-01 01:20:34.000000', 'temperatura', 41.0000, 'ºC'),
	(218255, 118, '2014-03-01 01:20:35.000000', 'temperatura', 204.0000, 'ºC'),
	(218256, 118, '2014-03-01 01:20:36.000000', 'temperatura', 899.0000, 'ºC'),
	(218257, 118, '2014-03-01 01:20:37.000000', 'temperatura', 284.0000, 'ºC'),
	(218258, 118, '2014-03-01 01:20:38.000000', 'temperatura', 1123.0000, 'ºC'),
	(218259, 118, '2014-03-01 01:20:39.000000', 'temperatura', 1163.0000, 'ºC'),
	(218260, 118, '2014-03-01 01:20:40.000000', 'temperatura', 45.0000, 'ºC'),
	(218261, 118, '2014-03-01 01:20:41.000000', 'temperatura', 336.0000, 'ºC'),
	(218262, 118, '2014-03-01 01:20:42.000000', 'temperatura', 345.0000, 'ºC'),
	(218263, 118, '2014-03-01 01:20:43.000000', 'temperatura', 718.0000, 'ºC'),
	(218264, 118, '2014-03-01 01:20:44.000000', 'temperatura', 155.0000, 'ºC'),
	(218265, 118, '2014-03-01 01:20:45.000000', 'temperatura', 1024.0000, 'ºC'),
	(218266, 118, '2014-03-01 01:20:46.000000', 'temperatura', 1054.0000, 'ºC'),
	(218267, 118, '2014-03-01 01:20:47.000000', 'temperatura', 1001.0000, 'ºC'),
	(218268, 118, '2014-03-01 01:20:48.000000', 'temperatura', 640.0000, 'ºC'),
	(218269, 118, '2014-03-01 01:20:49.000000', 'temperatura', 199.0000, 'ºC'),
	(218270, 118, '2014-03-01 01:20:50.000000', 'temperatura', 273.0000, 'ºC'),
	(218271, 118, '2014-03-01 01:20:51.000000', 'temperatura', 771.0000, 'ºC'),
	(218272, 118, '2014-03-01 01:20:52.000000', 'temperatura', 636.0000, 'ºC'),
	(218273, 118, '2014-03-01 01:20:53.000000', 'temperatura', 869.0000, 'ºC'),
	(218274, 118, '2014-03-01 01:20:54.000000', 'temperatura', 38.0000, 'ºC'),
	(218275, 118, '2014-03-01 01:20:55.000000', 'temperatura', 1182.0000, 'ºC'),
	(218276, 118, '2014-03-01 01:20:56.000000', 'temperatura', 995.0000, 'ºC'),
	(218277, 118, '2014-03-01 01:20:57.000000', 'temperatura', 230.0000, 'ºC'),
	(218278, 118, '2014-03-01 01:20:58.000000', 'temperatura', 567.0000, 'ºC'),
	(218279, 118, '2014-03-01 01:20:59.000000', 'temperatura', 945.0000, 'ºC'),
	(218280, 118, '2014-03-01 01:21:00.000000', 'temperatura', 626.0000, 'ºC'),
	(218281, 118, '2014-03-01 01:21:01.000000', 'temperatura', 294.0000, 'ºC'),
	(218282, 118, '2014-03-01 01:21:02.000000', 'temperatura', 792.0000, 'ºC'),
	(218283, 118, '2014-03-01 01:21:03.000000', 'temperatura', 677.0000, 'ºC'),
	(218284, 118, '2014-03-01 01:21:04.000000', 'temperatura', 1012.0000, 'ºC'),
	(218285, 118, '2014-03-01 01:21:05.000000', 'temperatura', 627.0000, 'ºC'),
	(218286, 118, '2014-03-01 01:21:06.000000', 'temperatura', 101.0000, 'ºC'),
	(218287, 118, '2014-03-01 01:21:07.000000', 'temperatura', 1026.0000, 'ºC'),
	(218288, 118, '2014-03-01 01:21:08.000000', 'temperatura', 26.0000, 'ºC'),
	(218289, 118, '2014-03-01 01:21:09.000000', 'temperatura', 653.0000, 'ºC'),
	(218290, 118, '2014-03-01 01:21:10.000000', 'temperatura', 786.0000, 'ºC'),
	(218291, 118, '2014-03-01 01:21:11.000000', 'temperatura', 774.0000, 'ºC'),
	(218292, 118, '2014-03-01 01:21:12.000000', 'temperatura', 310.0000, 'ºC'),
	(218293, 118, '2014-03-01 01:21:13.000000', 'temperatura', 430.0000, 'ºC'),
	(218294, 118, '2014-03-01 01:21:14.000000', 'temperatura', 21.0000, 'ºC'),
	(218295, 118, '2014-03-01 01:21:15.000000', 'temperatura', 13.0000, 'ºC'),
	(218296, 118, '2014-03-01 01:21:16.000000', 'temperatura', 4.0000, 'ºC'),
	(218297, 118, '2014-03-01 01:21:17.000000', 'temperatura', 1181.0000, 'ºC'),
	(218298, 118, '2014-03-01 01:21:18.000000', 'temperatura', 1094.0000, 'ºC'),
	(218299, 118, '2014-03-01 01:21:19.000000', 'temperatura', 726.0000, 'ºC'),
	(218300, 118, '2014-03-01 01:21:20.000000', 'temperatura', 351.0000, 'ºC'),
	(218301, 118, '2014-03-01 01:21:21.000000', 'temperatura', 775.0000, 'ºC'),
	(218302, 118, '2014-03-01 01:21:22.000000', 'temperatura', 424.0000, 'ºC'),
	(218303, 118, '2014-03-01 01:21:23.000000', 'temperatura', 994.0000, 'ºC'),
	(218304, 118, '2014-03-01 01:21:24.000000', 'temperatura', 97.0000, 'ºC'),
	(218305, 118, '2014-03-01 01:21:25.000000', 'temperatura', 1106.0000, 'ºC'),
	(218306, 118, '2014-03-01 01:21:26.000000', 'temperatura', 440.0000, 'ºC'),
	(218307, 118, '2014-03-01 01:21:27.000000', 'temperatura', 80.0000, 'ºC'),
	(218308, 118, '2014-03-01 01:21:28.000000', 'temperatura', 281.0000, 'ºC'),
	(218309, 118, '2014-03-01 01:21:29.000000', 'temperatura', 1165.0000, 'ºC'),
	(218310, 118, '2014-03-01 01:21:30.000000', 'temperatura', 183.0000, 'ºC'),
	(218311, 118, '2014-03-01 01:21:31.000000', 'temperatura', 1023.0000, 'ºC'),
	(218312, 118, '2014-03-01 01:21:32.000000', 'temperatura', 963.0000, 'ºC'),
	(218313, 118, '2014-03-01 01:21:33.000000', 'temperatura', 548.0000, 'ºC'),
	(218314, 118, '2014-03-01 01:21:34.000000', 'temperatura', 1052.0000, 'ºC'),
	(218315, 118, '2014-03-01 01:21:35.000000', 'temperatura', 16.0000, 'ºC'),
	(218316, 118, '2014-03-01 01:21:36.000000', 'temperatura', 524.0000, 'ºC'),
	(218317, 118, '2014-03-01 01:21:37.000000', 'temperatura', 175.0000, 'ºC'),
	(218318, 118, '2014-03-01 01:21:38.000000', 'temperatura', 502.0000, 'ºC'),
	(218319, 118, '2014-03-01 01:21:39.000000', 'temperatura', 784.0000, 'ºC'),
	(218320, 118, '2014-03-01 01:21:40.000000', 'temperatura', 18.0000, 'ºC'),
	(218321, 118, '2014-03-01 01:21:41.000000', 'temperatura', 135.0000, 'ºC'),
	(218322, 118, '2014-03-01 01:21:42.000000', 'temperatura', 624.0000, 'ºC'),
	(218323, 118, '2014-03-01 01:21:43.000000', 'temperatura', 315.0000, 'ºC'),
	(218324, 118, '2014-03-01 01:21:44.000000', 'temperatura', 902.0000, 'ºC'),
	(218325, 118, '2014-03-01 01:21:45.000000', 'temperatura', 1165.0000, 'ºC'),
	(218326, 118, '2014-03-01 01:21:46.000000', 'temperatura', 718.0000, 'ºC'),
	(218327, 118, '2014-03-01 01:21:47.000000', 'temperatura', 99.0000, 'ºC'),
	(218328, 118, '2014-03-01 01:21:48.000000', 'temperatura', 742.0000, 'ºC'),
	(218329, 118, '2014-03-01 01:21:49.000000', 'temperatura', 1011.0000, 'ºC'),
	(218330, 118, '2014-03-01 01:21:50.000000', 'temperatura', 430.0000, 'ºC'),
	(218331, 118, '2014-03-01 01:21:51.000000', 'temperatura', 317.0000, 'ºC'),
	(218332, 118, '2014-03-01 01:21:52.000000', 'temperatura', 296.0000, 'ºC'),
	(218333, 118, '2014-03-01 01:21:53.000000', 'temperatura', 529.0000, 'ºC'),
	(218334, 118, '2014-03-01 01:21:54.000000', 'temperatura', 556.0000, 'ºC'),
	(218335, 118, '2014-03-01 01:21:55.000000', 'temperatura', 1194.0000, 'ºC'),
	(218336, 118, '2014-03-01 01:21:56.000000', 'temperatura', 703.0000, 'ºC'),
	(218337, 118, '2014-03-01 01:21:57.000000', 'temperatura', 1133.0000, 'ºC'),
	(218338, 118, '2014-03-01 01:21:58.000000', 'temperatura', 1155.0000, 'ºC'),
	(218339, 118, '2014-03-01 01:21:59.000000', 'temperatura', 1179.0000, 'ºC'),
	(218340, 118, '2014-03-01 01:22:00.000000', 'temperatura', 31.0000, 'ºC'),
	(218341, 118, '2014-03-01 01:22:01.000000', 'temperatura', 218.0000, 'ºC'),
	(218342, 118, '2014-03-01 01:22:02.000000', 'temperatura', 996.0000, 'ºC'),
	(218343, 118, '2014-03-01 01:22:03.000000', 'temperatura', 726.0000, 'ºC'),
	(218344, 118, '2014-03-01 01:22:04.000000', 'temperatura', 645.0000, 'ºC'),
	(218345, 118, '2014-03-01 01:22:05.000000', 'temperatura', 1047.0000, 'ºC'),
	(218346, 118, '2014-03-01 01:22:06.000000', 'temperatura', 902.0000, 'ºC'),
	(218347, 118, '2014-03-01 01:22:07.000000', 'temperatura', 166.0000, 'ºC'),
	(218348, 118, '2014-03-01 01:22:08.000000', 'temperatura', 527.0000, 'ºC'),
	(218349, 118, '2014-03-01 01:22:09.000000', 'temperatura', 935.0000, 'ºC'),
	(218350, 118, '2014-03-01 01:22:10.000000', 'temperatura', 697.0000, 'ºC'),
	(218351, 118, '2014-03-01 01:22:11.000000', 'temperatura', 678.0000, 'ºC'),
	(218352, 118, '2014-03-01 01:22:12.000000', 'temperatura', 103.0000, 'ºC'),
	(218353, 118, '2014-03-01 01:22:13.000000', 'temperatura', 878.0000, 'ºC'),
	(218354, 118, '2014-03-01 01:22:14.000000', 'temperatura', 483.0000, 'ºC'),
	(218355, 118, '2014-03-01 01:22:15.000000', 'temperatura', 981.0000, 'ºC'),
	(218356, 118, '2014-03-01 01:22:16.000000', 'temperatura', 1056.0000, 'ºC'),
	(218357, 118, '2014-03-01 01:22:17.000000', 'temperatura', 1137.0000, 'ºC'),
	(218358, 118, '2014-03-01 01:22:18.000000', 'temperatura', 118.0000, 'ºC'),
	(218359, 118, '2014-03-01 01:22:19.000000', 'temperatura', 782.0000, 'ºC'),
	(218360, 118, '2014-03-01 01:22:20.000000', 'temperatura', 1153.0000, 'ºC'),
	(218361, 118, '2014-03-01 01:22:21.000000', 'temperatura', 1020.0000, 'ºC'),
	(218362, 118, '2014-03-01 01:22:22.000000', 'temperatura', 441.0000, 'ºC'),
	(218363, 118, '2014-03-01 01:22:23.000000', 'temperatura', 348.0000, 'ºC'),
	(218364, 118, '2014-03-01 01:22:24.000000', 'temperatura', 418.0000, 'ºC'),
	(218365, 118, '2014-03-01 01:22:25.000000', 'temperatura', 1045.0000, 'ºC'),
	(218366, 118, '2014-03-01 01:22:26.000000', 'temperatura', 370.0000, 'ºC'),
	(218367, 118, '2014-03-01 01:22:27.000000', 'temperatura', 1117.0000, 'ºC'),
	(218368, 118, '2014-03-01 01:22:28.000000', 'temperatura', 874.0000, 'ºC'),
	(218369, 118, '2014-03-01 01:22:29.000000', 'temperatura', 1022.0000, 'ºC'),
	(218370, 118, '2014-03-01 01:22:30.000000', 'temperatura', 86.0000, 'ºC'),
	(218371, 118, '2014-03-01 01:22:31.000000', 'temperatura', 965.0000, 'ºC'),
	(218372, 118, '2014-03-01 01:22:32.000000', 'temperatura', 969.0000, 'ºC'),
	(218373, 118, '2014-03-01 01:22:33.000000', 'temperatura', 752.0000, 'ºC'),
	(218374, 118, '2014-03-01 01:22:34.000000', 'temperatura', 850.0000, 'ºC'),
	(218375, 118, '2014-03-01 01:22:35.000000', 'temperatura', 795.0000, 'ºC'),
	(218376, 118, '2014-03-01 01:22:36.000000', 'temperatura', 225.0000, 'ºC'),
	(218377, 118, '2014-03-01 01:22:37.000000', 'temperatura', 1140.0000, 'ºC'),
	(218378, 118, '2014-03-01 01:22:38.000000', 'temperatura', 226.0000, 'ºC'),
	(218379, 118, '2014-03-01 01:22:39.000000', 'temperatura', 110.0000, 'ºC'),
	(218380, 118, '2014-03-01 01:22:40.000000', 'temperatura', 1074.0000, 'ºC'),
	(218381, 118, '2014-03-01 01:22:41.000000', 'temperatura', 238.0000, 'ºC'),
	(218382, 118, '2014-03-01 01:22:42.000000', 'temperatura', 369.0000, 'ºC'),
	(218383, 118, '2014-03-01 01:22:43.000000', 'temperatura', 1131.0000, 'ºC'),
	(218384, 118, '2014-03-01 01:22:44.000000', 'temperatura', 950.0000, 'ºC'),
	(218385, 118, '2014-03-01 01:22:45.000000', 'temperatura', 157.0000, 'ºC'),
	(218386, 118, '2014-03-01 01:22:46.000000', 'temperatura', 337.0000, 'ºC'),
	(218387, 118, '2014-03-01 01:22:47.000000', 'temperatura', 13.0000, 'ºC'),
	(218388, 118, '2014-03-01 01:22:48.000000', 'temperatura', 253.0000, 'ºC'),
	(218389, 118, '2014-03-01 01:22:49.000000', 'temperatura', 27.0000, 'ºC'),
	(218390, 118, '2014-03-01 01:22:50.000000', 'temperatura', 578.0000, 'ºC'),
	(218391, 118, '2014-03-01 01:22:51.000000', 'temperatura', 407.0000, 'ºC'),
	(218392, 118, '2014-03-01 01:22:52.000000', 'temperatura', 305.0000, 'ºC'),
	(218393, 118, '2014-03-01 01:22:53.000000', 'temperatura', 302.0000, 'ºC'),
	(218394, 118, '2014-03-01 01:22:54.000000', 'temperatura', 596.0000, 'ºC'),
	(218395, 118, '2014-03-01 01:22:55.000000', 'temperatura', 877.0000, 'ºC'),
	(218396, 118, '2014-03-01 01:22:56.000000', 'temperatura', 195.0000, 'ºC'),
	(218397, 118, '2014-03-01 01:22:57.000000', 'temperatura', 744.0000, 'ºC'),
	(218398, 118, '2014-03-01 01:22:58.000000', 'temperatura', 737.0000, 'ºC'),
	(218399, 118, '2014-03-01 01:22:59.000000', 'temperatura', 252.0000, 'ºC'),
	(218400, 118, '2014-03-01 01:23:00.000000', 'temperatura', 249.0000, 'ºC'),
	(218401, 118, '2014-03-01 01:23:01.000000', 'temperatura', 492.0000, 'ºC'),
	(218402, 118, '2014-03-01 01:23:02.000000', 'temperatura', 511.0000, 'ºC'),
	(218403, 118, '2014-03-01 01:23:03.000000', 'temperatura', 1078.0000, 'ºC'),
	(218404, 118, '2014-03-01 01:23:04.000000', 'temperatura', 261.0000, 'ºC'),
	(218405, 118, '2014-03-01 01:23:05.000000', 'temperatura', 468.0000, 'ºC'),
	(218406, 118, '2014-03-01 01:23:06.000000', 'temperatura', 361.0000, 'ºC'),
	(218407, 118, '2014-03-01 01:23:07.000000', 'temperatura', 400.0000, 'ºC'),
	(218408, 118, '2014-03-01 01:23:08.000000', 'temperatura', 920.0000, 'ºC'),
	(218409, 118, '2014-03-01 01:23:09.000000', 'temperatura', 997.0000, 'ºC'),
	(218410, 118, '2014-03-01 01:23:10.000000', 'temperatura', 1025.0000, 'ºC'),
	(218411, 118, '2014-03-01 01:23:11.000000', 'temperatura', 938.0000, 'ºC'),
	(218412, 118, '2014-03-01 01:23:12.000000', 'temperatura', 412.0000, 'ºC'),
	(218413, 118, '2014-03-01 01:23:13.000000', 'temperatura', 448.0000, 'ºC'),
	(218414, 118, '2014-03-01 01:23:14.000000', 'temperatura', 1006.0000, 'ºC'),
	(218415, 118, '2014-03-01 01:23:15.000000', 'temperatura', 86.0000, 'ºC'),
	(218416, 118, '2014-03-01 01:23:16.000000', 'temperatura', 1011.0000, 'ºC'),
	(218417, 118, '2014-03-01 01:23:17.000000', 'temperatura', 1199.0000, 'ºC'),
	(218418, 118, '2014-03-01 01:23:18.000000', 'temperatura', 560.0000, 'ºC'),
	(218419, 118, '2014-03-01 01:23:19.000000', 'temperatura', 405.0000, 'ºC'),
	(218420, 118, '2014-03-01 01:23:20.000000', 'temperatura', 348.0000, 'ºC'),
	(218421, 118, '2014-03-01 01:23:21.000000', 'temperatura', 522.0000, 'ºC'),
	(218422, 118, '2014-03-01 01:23:22.000000', 'temperatura', 366.0000, 'ºC'),
	(218423, 118, '2014-03-01 01:23:23.000000', 'temperatura', 267.0000, 'ºC'),
	(218424, 118, '2014-03-01 01:23:24.000000', 'temperatura', 235.0000, 'ºC'),
	(218425, 118, '2014-03-01 01:23:25.000000', 'temperatura', 374.0000, 'ºC'),
	(218426, 118, '2014-03-01 01:23:26.000000', 'temperatura', 1165.0000, 'ºC'),
	(218427, 118, '2014-03-01 01:23:27.000000', 'temperatura', 1103.0000, 'ºC'),
	(218428, 118, '2014-03-01 01:23:28.000000', 'temperatura', 820.0000, 'ºC'),
	(218429, 118, '2014-03-01 01:23:29.000000', 'temperatura', 793.0000, 'ºC'),
	(218430, 118, '2014-03-01 01:23:30.000000', 'temperatura', 307.0000, 'ºC'),
	(218431, 118, '2014-03-01 01:23:31.000000', 'temperatura', 354.0000, 'ºC'),
	(218432, 118, '2014-03-01 01:23:32.000000', 'temperatura', 850.0000, 'ºC'),
	(218433, 118, '2014-03-01 01:23:33.000000', 'temperatura', 789.0000, 'ºC'),
	(218434, 118, '2014-03-01 01:23:34.000000', 'temperatura', 197.0000, 'ºC'),
	(218435, 118, '2014-03-01 01:23:35.000000', 'temperatura', 1018.0000, 'ºC'),
	(218436, 118, '2014-03-01 01:23:36.000000', 'temperatura', 900.0000, 'ºC'),
	(218437, 118, '2014-03-01 01:23:37.000000', 'temperatura', 245.0000, 'ºC'),
	(218438, 118, '2014-03-01 01:23:38.000000', 'temperatura', 927.0000, 'ºC'),
	(218439, 118, '2014-03-01 01:23:39.000000', 'temperatura', 300.0000, 'ºC'),
	(218440, 118, '2014-03-01 01:23:40.000000', 'temperatura', 1120.0000, 'ºC'),
	(218441, 118, '2014-03-01 01:23:41.000000', 'temperatura', 1099.0000, 'ºC'),
	(218442, 118, '2014-03-01 01:23:42.000000', 'temperatura', 934.0000, 'ºC'),
	(218443, 118, '2014-03-01 01:23:43.000000', 'temperatura', 176.0000, 'ºC'),
	(218444, 118, '2014-03-01 01:23:44.000000', 'temperatura', 477.0000, 'ºC'),
	(218445, 118, '2014-03-01 01:23:45.000000', 'temperatura', 660.0000, 'ºC'),
	(218446, 118, '2014-03-01 01:23:46.000000', 'temperatura', 667.0000, 'ºC'),
	(218447, 118, '2014-03-01 01:23:47.000000', 'temperatura', 158.0000, 'ºC'),
	(218448, 118, '2014-03-01 01:23:48.000000', 'temperatura', 1188.0000, 'ºC'),
	(218449, 118, '2014-03-01 01:23:49.000000', 'temperatura', 667.0000, 'ºC'),
	(218450, 118, '2014-03-01 01:23:50.000000', 'temperatura', 969.0000, 'ºC'),
	(218451, 118, '2014-03-01 01:23:51.000000', 'temperatura', 447.0000, 'ºC'),
	(218452, 118, '2014-03-01 01:23:52.000000', 'temperatura', 528.0000, 'ºC'),
	(218453, 118, '2014-03-01 01:23:53.000000', 'temperatura', 98.0000, 'ºC'),
	(218454, 118, '2014-03-01 01:23:54.000000', 'temperatura', 106.0000, 'ºC'),
	(218455, 118, '2014-03-01 01:23:55.000000', 'temperatura', 236.0000, 'ºC'),
	(218456, 118, '2014-03-01 01:23:56.000000', 'temperatura', 863.0000, 'ºC'),
	(218457, 118, '2014-03-01 01:23:57.000000', 'temperatura', 8.0000, 'ºC'),
	(218458, 118, '2014-03-01 01:23:58.000000', 'temperatura', 1051.0000, 'ºC'),
	(218459, 118, '2014-03-01 01:23:59.000000', 'temperatura', 433.0000, 'ºC'),
	(218460, 118, '2014-03-01 01:24:00.000000', 'temperatura', 214.0000, 'ºC'),
	(218461, 118, '2014-03-01 01:24:01.000000', 'temperatura', 969.0000, 'ºC'),
	(218462, 118, '2014-03-01 01:24:02.000000', 'temperatura', 604.0000, 'ºC'),
	(218463, 118, '2014-03-01 01:24:03.000000', 'temperatura', 114.0000, 'ºC'),
	(218464, 118, '2014-03-01 01:24:04.000000', 'temperatura', 1159.0000, 'ºC'),
	(218465, 118, '2014-03-01 01:24:05.000000', 'temperatura', 653.0000, 'ºC'),
	(218466, 118, '2014-03-01 01:24:06.000000', 'temperatura', 989.0000, 'ºC'),
	(218467, 118, '2014-03-01 01:24:07.000000', 'temperatura', 588.0000, 'ºC'),
	(218468, 118, '2014-03-01 01:24:08.000000', 'temperatura', 1173.0000, 'ºC'),
	(218469, 118, '2014-03-01 01:24:09.000000', 'temperatura', 500.0000, 'ºC'),
	(218470, 118, '2014-03-01 01:24:10.000000', 'temperatura', 181.0000, 'ºC'),
	(218471, 118, '2014-03-01 01:24:11.000000', 'temperatura', 605.0000, 'ºC'),
	(218472, 118, '2014-03-01 01:24:12.000000', 'temperatura', 85.0000, 'ºC'),
	(218473, 118, '2014-03-01 01:24:13.000000', 'temperatura', 1011.0000, 'ºC'),
	(218474, 118, '2014-03-01 01:24:14.000000', 'temperatura', 0.0000, 'ºC'),
	(218475, 118, '2014-03-01 01:24:15.000000', 'temperatura', 567.0000, 'ºC'),
	(218476, 118, '2014-03-01 01:24:16.000000', 'temperatura', 434.0000, 'ºC'),
	(218477, 118, '2014-03-01 01:24:17.000000', 'temperatura', 471.0000, 'ºC'),
	(218478, 118, '2014-03-01 01:24:18.000000', 'temperatura', 1053.0000, 'ºC'),
	(218479, 118, '2014-03-01 01:24:19.000000', 'temperatura', 252.0000, 'ºC'),
	(218480, 118, '2014-03-01 01:24:20.000000', 'temperatura', 502.0000, 'ºC'),
	(218481, 118, '2014-03-01 01:24:21.000000', 'temperatura', 554.0000, 'ºC'),
	(218482, 118, '2014-03-01 01:24:22.000000', 'temperatura', 65.0000, 'ºC'),
	(218483, 118, '2014-03-01 01:24:23.000000', 'temperatura', 1061.0000, 'ºC'),
	(218484, 118, '2014-03-01 01:24:24.000000', 'temperatura', 314.0000, 'ºC'),
	(218485, 118, '2014-03-01 01:24:25.000000', 'temperatura', 786.0000, 'ºC'),
	(218486, 118, '2014-03-01 01:24:26.000000', 'temperatura', 588.0000, 'ºC'),
	(218487, 118, '2014-03-01 01:24:27.000000', 'temperatura', 582.0000, 'ºC'),
	(218488, 118, '2014-03-01 01:24:28.000000', 'temperatura', 1148.0000, 'ºC'),
	(218489, 118, '2014-03-01 01:24:29.000000', 'temperatura', 396.0000, 'ºC'),
	(218490, 118, '2014-03-01 01:24:30.000000', 'temperatura', 934.0000, 'ºC'),
	(218491, 118, '2014-03-01 01:24:31.000000', 'temperatura', 1083.0000, 'ºC'),
	(218492, 118, '2014-03-01 01:24:32.000000', 'temperatura', 216.0000, 'ºC'),
	(218493, 118, '2014-03-01 01:24:33.000000', 'temperatura', 228.0000, 'ºC'),
	(218494, 118, '2014-03-01 01:24:34.000000', 'temperatura', 495.0000, 'ºC'),
	(218495, 118, '2014-03-01 01:24:35.000000', 'temperatura', 589.0000, 'ºC'),
	(218496, 118, '2014-03-01 01:24:36.000000', 'temperatura', 263.0000, 'ºC'),
	(218497, 118, '2014-03-01 01:24:37.000000', 'temperatura', 747.0000, 'ºC'),
	(218498, 118, '2014-03-01 01:24:38.000000', 'temperatura', 545.0000, 'ºC'),
	(218499, 118, '2014-03-01 01:24:39.000000', 'temperatura', 488.0000, 'ºC'),
	(218500, 118, '2014-03-01 01:24:40.000000', 'temperatura', 803.0000, 'ºC'),
	(218501, 118, '2014-03-01 01:24:41.000000', 'temperatura', 151.0000, 'ºC'),
	(218502, 118, '2014-03-01 01:24:42.000000', 'temperatura', 745.0000, 'ºC'),
	(218503, 118, '2014-03-01 01:24:43.000000', 'temperatura', 875.0000, 'ºC'),
	(218504, 118, '2014-03-01 01:24:44.000000', 'temperatura', 940.0000, 'ºC'),
	(218505, 118, '2014-03-01 01:24:45.000000', 'temperatura', 876.0000, 'ºC'),
	(218506, 118, '2014-03-01 01:24:46.000000', 'temperatura', 359.0000, 'ºC'),
	(218507, 118, '2014-03-01 01:24:47.000000', 'temperatura', 368.0000, 'ºC'),
	(218508, 118, '2014-03-01 01:24:48.000000', 'temperatura', 763.0000, 'ºC'),
	(218509, 118, '2014-03-01 01:24:49.000000', 'temperatura', 310.0000, 'ºC'),
	(218510, 118, '2014-03-01 01:24:50.000000', 'temperatura', 464.0000, 'ºC'),
	(218511, 118, '2014-03-01 01:24:51.000000', 'temperatura', 189.0000, 'ºC'),
	(218512, 118, '2014-03-01 01:24:52.000000', 'temperatura', 756.0000, 'ºC'),
	(218513, 118, '2014-03-01 01:24:53.000000', 'temperatura', 810.0000, 'ºC'),
	(218514, 118, '2014-03-01 01:24:54.000000', 'temperatura', 586.0000, 'ºC'),
	(218515, 118, '2014-03-01 01:24:55.000000', 'temperatura', 498.0000, 'ºC'),
	(218516, 118, '2014-03-01 01:24:56.000000', 'temperatura', 735.0000, 'ºC'),
	(218517, 118, '2014-03-01 01:24:57.000000', 'temperatura', 981.0000, 'ºC'),
	(218518, 118, '2014-03-01 01:24:58.000000', 'temperatura', 299.0000, 'ºC'),
	(218519, 118, '2014-03-01 01:24:59.000000', 'temperatura', 951.0000, 'ºC'),
	(218520, 118, '2014-03-01 01:25:00.000000', 'temperatura', 261.0000, 'ºC'),
	(218521, 118, '2014-03-01 01:25:01.000000', 'temperatura', 850.0000, 'ºC'),
	(218522, 118, '2014-03-01 01:25:02.000000', 'temperatura', 1069.0000, 'ºC'),
	(218523, 118, '2014-03-01 01:25:03.000000', 'temperatura', 395.0000, 'ºC'),
	(218524, 118, '2014-03-01 01:25:04.000000', 'temperatura', 1169.0000, 'ºC'),
	(218525, 118, '2014-03-01 01:25:05.000000', 'temperatura', 1062.0000, 'ºC'),
	(218526, 118, '2014-03-01 01:25:06.000000', 'temperatura', 601.0000, 'ºC'),
	(218527, 118, '2014-03-01 01:25:07.000000', 'temperatura', 1020.0000, 'ºC'),
	(218528, 118, '2014-03-01 01:25:08.000000', 'temperatura', 899.0000, 'ºC'),
	(218529, 118, '2014-03-01 01:25:09.000000', 'temperatura', 233.0000, 'ºC'),
	(218530, 118, '2014-03-01 01:25:10.000000', 'temperatura', 868.0000, 'ºC'),
	(218531, 118, '2014-03-01 01:25:11.000000', 'temperatura', 42.0000, 'ºC'),
	(218532, 118, '2014-03-01 01:25:12.000000', 'temperatura', 8.0000, 'ºC'),
	(218533, 118, '2014-03-01 01:25:13.000000', 'temperatura', 1113.0000, 'ºC'),
	(218534, 118, '2014-03-01 01:25:14.000000', 'temperatura', 742.0000, 'ºC'),
	(218535, 118, '2014-03-01 01:25:15.000000', 'temperatura', 374.0000, 'ºC'),
	(218536, 118, '2014-03-01 01:25:16.000000', 'temperatura', 841.0000, 'ºC'),
	(218537, 118, '2014-03-01 01:25:17.000000', 'temperatura', 686.0000, 'ºC'),
	(218538, 118, '2014-03-01 01:25:18.000000', 'temperatura', 905.0000, 'ºC'),
	(218539, 118, '2014-03-01 01:25:19.000000', 'temperatura', 68.0000, 'ºC'),
	(218540, 118, '2014-03-01 01:25:20.000000', 'temperatura', 28.0000, 'ºC'),
	(218541, 118, '2014-03-01 01:25:21.000000', 'temperatura', 1135.0000, 'ºC'),
	(218542, 118, '2014-03-01 01:25:22.000000', 'temperatura', 791.0000, 'ºC'),
	(218543, 118, '2014-03-01 01:25:23.000000', 'temperatura', 553.0000, 'ºC'),
	(218544, 118, '2014-03-01 01:25:24.000000', 'temperatura', 390.0000, 'ºC'),
	(218545, 118, '2014-03-01 01:25:25.000000', 'temperatura', 292.0000, 'ºC'),
	(218546, 118, '2014-03-01 01:25:26.000000', 'temperatura', 290.0000, 'ºC'),
	(218547, 118, '2014-03-01 01:25:27.000000', 'temperatura', 573.0000, 'ºC'),
	(218548, 118, '2014-03-01 01:25:28.000000', 'temperatura', 796.0000, 'ºC'),
	(218549, 118, '2014-03-01 01:25:29.000000', 'temperatura', 1063.0000, 'ºC'),
	(218550, 118, '2014-03-01 01:25:30.000000', 'temperatura', 529.0000, 'ºC'),
	(218551, 118, '2014-03-01 01:25:31.000000', 'temperatura', 654.0000, 'ºC'),
	(218552, 118, '2014-03-01 01:25:32.000000', 'temperatura', 484.0000, 'ºC'),
	(218553, 118, '2014-03-01 01:25:33.000000', 'temperatura', 457.0000, 'ºC'),
	(218554, 118, '2014-03-01 01:25:34.000000', 'temperatura', 836.0000, 'ºC'),
	(218555, 118, '2014-03-01 01:25:35.000000', 'temperatura', 407.0000, 'ºC'),
	(218556, 118, '2014-03-01 01:25:36.000000', 'temperatura', 729.0000, 'ºC'),
	(218557, 118, '2014-03-01 01:25:37.000000', 'temperatura', 22.0000, 'ºC'),
	(218558, 118, '2014-03-01 01:25:38.000000', 'temperatura', 326.0000, 'ºC'),
	(218559, 118, '2014-03-01 01:25:39.000000', 'temperatura', 362.0000, 'ºC'),
	(218560, 118, '2014-03-01 01:25:40.000000', 'temperatura', 833.0000, 'ºC'),
	(218561, 118, '2014-03-01 01:25:41.000000', 'temperatura', 681.0000, 'ºC'),
	(218562, 118, '2014-03-01 01:25:42.000000', 'temperatura', 907.0000, 'ºC'),
	(218563, 118, '2014-03-01 01:25:43.000000', 'temperatura', 90.0000, 'ºC'),
	(218564, 118, '2014-03-01 01:25:44.000000', 'temperatura', 131.0000, 'ºC'),
	(218565, 118, '2014-03-01 01:25:45.000000', 'temperatura', 384.0000, 'ºC'),
	(218566, 118, '2014-03-01 01:25:46.000000', 'temperatura', 330.0000, 'ºC'),
	(218567, 118, '2014-03-01 01:25:47.000000', 'temperatura', 496.0000, 'ºC'),
	(218568, 118, '2014-03-01 01:25:48.000000', 'temperatura', 293.0000, 'ºC'),
	(218569, 118, '2014-03-01 01:25:49.000000', 'temperatura', 1177.0000, 'ºC'),
	(218570, 118, '2014-03-01 01:25:50.000000', 'temperatura', 205.0000, 'ºC'),
	(218571, 118, '2014-03-01 01:25:51.000000', 'temperatura', 1097.0000, 'ºC'),
	(218572, 118, '2014-03-01 01:25:52.000000', 'temperatura', 70.0000, 'ºC'),
	(218573, 118, '2014-03-01 01:25:53.000000', 'temperatura', 660.0000, 'ºC'),
	(218574, 118, '2014-03-01 01:25:54.000000', 'temperatura', 691.0000, 'ºC'),
	(218575, 118, '2014-03-01 01:25:55.000000', 'temperatura', 276.0000, 'ºC'),
	(218576, 118, '2014-03-01 01:25:56.000000', 'temperatura', 506.0000, 'ºC'),
	(218577, 118, '2014-03-01 01:25:57.000000', 'temperatura', 502.0000, 'ºC'),
	(218578, 118, '2014-03-01 01:25:58.000000', 'temperatura', 993.0000, 'ºC'),
	(218579, 118, '2014-03-01 01:25:59.000000', 'temperatura', 1060.0000, 'ºC'),
	(218580, 118, '2014-03-01 01:26:00.000000', 'temperatura', 1120.0000, 'ºC'),
	(218581, 118, '2014-03-01 01:26:01.000000', 'temperatura', 20.0000, 'ºC'),
	(218582, 118, '2014-03-01 01:26:02.000000', 'temperatura', 342.0000, 'ºC'),
	(218583, 118, '2014-03-01 01:26:03.000000', 'temperatura', 450.0000, 'ºC'),
	(218584, 118, '2014-03-01 01:26:04.000000', 'temperatura', 25.0000, 'ºC'),
	(218585, 118, '2014-03-01 01:26:05.000000', 'temperatura', 1174.0000, 'ºC'),
	(218586, 118, '2014-03-01 01:26:06.000000', 'temperatura', 996.0000, 'ºC'),
	(218587, 118, '2014-03-01 01:26:07.000000', 'temperatura', 257.0000, 'ºC'),
	(218588, 118, '2014-03-01 01:26:08.000000', 'temperatura', 699.0000, 'ºC'),
	(218589, 118, '2014-03-01 01:26:09.000000', 'temperatura', 324.0000, 'ºC'),
	(218590, 118, '2014-03-01 01:26:10.000000', 'temperatura', 723.0000, 'ºC'),
	(218591, 118, '2014-03-01 01:26:11.000000', 'temperatura', 243.0000, 'ºC'),
	(218592, 118, '2014-03-01 01:26:12.000000', 'temperatura', 248.0000, 'ºC'),
	(218593, 118, '2014-03-01 01:26:13.000000', 'temperatura', 511.0000, 'ºC'),
	(218594, 118, '2014-03-01 01:26:14.000000', 'temperatura', 610.0000, 'ºC'),
	(218595, 118, '2014-03-01 01:26:15.000000', 'temperatura', 318.0000, 'ºC'),
	(218596, 118, '2014-03-01 01:26:16.000000', 'temperatura', 960.0000, 'ºC'),
	(218597, 118, '2014-03-01 01:26:17.000000', 'temperatura', 246.0000, 'ºC'),
	(218598, 118, '2014-03-01 01:26:18.000000', 'temperatura', 751.0000, 'ºC'),
	(218599, 118, '2014-03-01 01:26:19.000000', 'temperatura', 618.0000, 'ºC'),
	(218600, 118, '2014-03-01 01:26:20.000000', 'temperatura', 837.0000, 'ºC'),
	(218601, 118, '2014-03-01 01:26:21.000000', 'temperatura', 1133.0000, 'ºC'),
	(218602, 118, '2014-03-01 01:26:22.000000', 'temperatura', 754.0000, 'ºC'),
	(218603, 118, '2014-03-01 01:26:23.000000', 'temperatura', 369.0000, 'ºC'),
	(218604, 118, '2014-03-01 01:26:24.000000', 'temperatura', 786.0000, 'ºC'),
	(218605, 118, '2014-03-01 01:26:25.000000', 'temperatura', 424.0000, 'ºC'),
	(218606, 118, '2014-03-01 01:26:26.000000', 'temperatura', 960.0000, 'ºC'),
	(218607, 118, '2014-03-01 01:26:27.000000', 'temperatura', 1130.0000, 'ºC'),
	(218608, 118, '2014-03-01 01:26:28.000000', 'temperatura', 370.0000, 'ºC'),
	(218609, 118, '2014-03-01 01:26:29.000000', 'temperatura', 859.0000, 'ºC'),
	(218610, 118, '2014-03-01 01:26:30.000000', 'temperatura', 789.0000, 'ºC'),
	(218611, 118, '2014-03-01 01:26:31.000000', 'temperatura', 165.0000, 'ºC'),
	(218612, 118, '2014-03-01 01:26:32.000000', 'temperatura', 861.0000, 'ºC'),
	(218613, 118, '2014-03-01 01:26:33.000000', 'temperatura', 208.0000, 'ºC'),
	(218614, 118, '2014-03-01 01:26:34.000000', 'temperatura', 857.0000, 'ºC'),
	(218615, 118, '2014-03-01 01:26:35.000000', 'temperatura', 64.0000, 'ºC'),
	(218616, 118, '2014-03-01 01:26:36.000000', 'temperatura', 150.0000, 'ºC'),
	(218617, 118, '2014-03-01 01:26:37.000000', 'temperatura', 557.0000, 'ºC'),
	(218618, 118, '2014-03-01 01:26:38.000000', 'temperatura', 1136.0000, 'ºC'),
	(218619, 118, '2014-03-01 01:26:39.000000', 'temperatura', 409.0000, 'ºC'),
	(218620, 118, '2014-03-01 01:26:40.000000', 'temperatura', 1037.0000, 'ºC'),
	(218621, 118, '2014-03-01 01:26:41.000000', 'temperatura', 359.0000, 'ºC'),
	(218622, 118, '2014-03-01 01:26:42.000000', 'temperatura', 1085.0000, 'ºC'),
	(218623, 118, '2014-03-01 01:26:43.000000', 'temperatura', 750.0000, 'ºC'),
	(218624, 118, '2014-03-01 01:26:44.000000', 'temperatura', 493.0000, 'ºC'),
	(218625, 118, '2014-03-01 01:26:45.000000', 'temperatura', 215.0000, 'ºC'),
	(218626, 118, '2014-03-01 01:26:46.000000', 'temperatura', 798.0000, 'ºC'),
	(218627, 118, '2014-03-01 01:26:47.000000', 'temperatura', 943.0000, 'ºC'),
	(218628, 118, '2014-03-01 01:26:48.000000', 'temperatura', 1123.0000, 'ºC'),
	(218629, 118, '2014-03-01 01:26:49.000000', 'temperatura', 389.0000, 'ºC'),
	(218630, 118, '2014-03-01 01:26:50.000000', 'temperatura', 973.0000, 'ºC'),
	(218631, 118, '2014-03-01 01:26:51.000000', 'temperatura', 100.0000, 'ºC'),
	(218632, 118, '2014-03-01 01:26:52.000000', 'temperatura', 1180.0000, 'ºC'),
	(218633, 118, '2014-03-01 01:26:53.000000', 'temperatura', 801.0000, 'ºC'),
	(218634, 118, '2014-03-01 01:26:54.000000', 'temperatura', 467.0000, 'ºC'),
	(218635, 118, '2014-03-01 01:26:55.000000', 'temperatura', 1131.0000, 'ºC'),
	(218636, 118, '2014-03-01 01:26:56.000000', 'temperatura', 657.0000, 'ºC'),
	(218637, 118, '2014-03-01 01:26:57.000000', 'temperatura', 1089.0000, 'ºC'),
	(218638, 118, '2014-03-01 01:26:58.000000', 'temperatura', 1077.0000, 'ºC'),
	(218639, 118, '2014-03-01 01:26:59.000000', 'temperatura', 919.0000, 'ºC'),
	(218640, 118, '2014-03-01 01:27:00.000000', 'temperatura', 165.0000, 'ºC'),
	(218641, 118, '2014-03-01 01:27:01.000000', 'temperatura', 468.0000, 'ºC'),
	(218642, 118, '2014-03-01 01:27:02.000000', 'temperatura', 647.0000, 'ºC'),
	(218643, 118, '2014-03-01 01:27:03.000000', 'temperatura', 628.0000, 'ºC'),
	(218644, 118, '2014-03-01 01:27:04.000000', 'temperatura', 3.0000, 'ºC'),
	(218645, 118, '2014-03-01 01:27:05.000000', 'temperatura', 528.0000, 'ºC'),
	(218646, 118, '2014-03-01 01:27:06.000000', 'temperatura', 233.0000, 'ºC'),
	(218647, 118, '2014-03-01 01:27:07.000000', 'temperatura', 782.0000, 'ºC'),
	(218648, 118, '2014-03-01 01:27:08.000000', 'temperatura', 813.0000, 'ºC'),
	(218649, 118, '2014-03-01 01:27:09.000000', 'temperatura', 519.0000, 'ºC'),
	(218650, 118, '2014-03-01 01:27:10.000000', 'temperatura', 156.0000, 'ºC'),
	(218651, 118, '2014-03-01 01:27:11.000000', 'temperatura', 425.0000, 'ºC'),
	(218652, 118, '2014-03-01 01:27:12.000000', 'temperatura', 457.0000, 'ºC'),
	(218653, 118, '2014-03-01 01:27:13.000000', 'temperatura', 1010.0000, 'ºC'),
	(218654, 118, '2014-03-01 01:27:14.000000', 'temperatura', 82.0000, 'ºC'),
	(218655, 118, '2014-03-01 01:27:15.000000', 'temperatura', 977.0000, 'ºC'),
	(218656, 118, '2014-03-01 01:27:16.000000', 'temperatura', 1041.0000, 'ºC'),
	(218657, 118, '2014-03-01 01:27:17.000000', 'temperatura', 1075.0000, 'ºC'),
	(218658, 118, '2014-03-01 01:27:18.000000', 'temperatura', 1051.0000, 'ºC'),
	(218659, 118, '2014-03-01 01:27:19.000000', 'temperatura', 830.0000, 'ºC'),
	(218660, 118, '2014-03-01 01:27:20.000000', 'temperatura', 999.0000, 'ºC'),
	(218661, 118, '2014-03-01 01:27:21.000000', 'temperatura', 105.0000, 'ºC'),
	(218662, 118, '2014-03-01 01:27:22.000000', 'temperatura', 1127.0000, 'ºC'),
	(218663, 118, '2014-03-01 01:27:23.000000', 'temperatura', 520.0000, 'ºC'),
	(218664, 118, '2014-03-01 01:27:24.000000', 'temperatura', 419.0000, 'ºC'),
	(218665, 118, '2014-03-01 01:27:25.000000', 'temperatura', 537.0000, 'ºC'),
	(218666, 118, '2014-03-01 01:27:26.000000', 'temperatura', 230.0000, 'ºC'),
	(218667, 118, '2014-03-01 01:27:27.000000', 'temperatura', 738.0000, 'ºC'),
	(218668, 118, '2014-03-01 01:27:28.000000', 'temperatura', 601.0000, 'ºC'),
	(218669, 118, '2014-03-01 01:27:29.000000', 'temperatura', 792.0000, 'ºC'),
	(218670, 118, '2014-03-01 01:27:30.000000', 'temperatura', 957.0000, 'ºC'),
	(218671, 118, '2014-03-01 01:27:31.000000', 'temperatura', 9.0000, 'ºC'),
	(218672, 118, '2014-03-01 01:27:32.000000', 'temperatura', 777.0000, 'ºC'),
	(218673, 118, '2014-03-01 01:27:33.000000', 'temperatura', 256.0000, 'ºC'),
	(218674, 118, '2014-03-01 01:27:34.000000', 'temperatura', 151.0000, 'ºC'),
	(218675, 118, '2014-03-01 01:27:35.000000', 'temperatura', 1188.0000, 'ºC'),
	(218676, 118, '2014-03-01 01:27:36.000000', 'temperatura', 688.0000, 'ºC'),
	(218677, 118, '2014-03-01 01:27:37.000000', 'temperatura', 1075.0000, 'ºC'),
	(218678, 118, '2014-03-01 01:27:38.000000', 'temperatura', 912.0000, 'ºC'),
	(218679, 118, '2014-03-01 01:27:39.000000', 'temperatura', 134.0000, 'ºC'),
	(218680, 118, '2014-03-01 01:27:40.000000', 'temperatura', 335.0000, 'ºC'),
	(218681, 118, '2014-03-01 01:27:41.000000', 'temperatura', 72.0000, 'ºC'),
	(218682, 118, '2014-03-01 01:27:42.000000', 'temperatura', 557.0000, 'ºC'),
	(218683, 118, '2014-03-01 01:27:43.000000', 'temperatura', 169.0000, 'ºC'),
	(218684, 118, '2014-03-01 01:27:44.000000', 'temperatura', 373.0000, 'ºC'),
	(218685, 118, '2014-03-01 01:27:45.000000', 'temperatura', 159.0000, 'ºC'),
	(218686, 118, '2014-03-01 01:27:46.000000', 'temperatura', 876.0000, 'ºC'),
	(218687, 118, '2014-03-01 01:27:47.000000', 'temperatura', 302.0000, 'ºC'),
	(218688, 118, '2014-03-01 01:27:48.000000', 'temperatura', 85.0000, 'ºC'),
	(218689, 118, '2014-03-01 01:27:49.000000', 'temperatura', 720.0000, 'ºC'),
	(218690, 118, '2014-03-01 01:27:50.000000', 'temperatura', 946.0000, 'ºC'),
	(218691, 118, '2014-03-01 01:27:51.000000', 'temperatura', 168.0000, 'ºC'),
	(218692, 118, '2014-03-01 01:27:52.000000', 'temperatura', 402.0000, 'ºC'),
	(218693, 118, '2014-03-01 01:27:53.000000', 'temperatura', 309.0000, 'ºC'),
	(218694, 118, '2014-03-01 01:27:54.000000', 'temperatura', 338.0000, 'ºC'),
	(218695, 118, '2014-03-01 01:27:55.000000', 'temperatura', 765.0000, 'ºC'),
	(218696, 118, '2014-03-01 01:27:56.000000', 'temperatura', 410.0000, 'ºC'),
	(218697, 118, '2014-03-01 01:27:57.000000', 'temperatura', 957.0000, 'ºC'),
	(218698, 118, '2014-03-01 01:27:58.000000', 'temperatura', 1156.0000, 'ºC'),
	(218699, 118, '2014-03-01 01:27:59.000000', 'temperatura', 511.0000, 'ºC'),
	(218700, 118, '2014-03-01 01:28:00.000000', 'temperatura', 284.0000, 'ºC'),
	(218701, 118, '2014-03-01 01:28:01.000000', 'temperatura', 1088.0000, 'ºC'),
	(218702, 118, '2014-03-01 01:28:02.000000', 'temperatura', 991.0000, 'ºC'),
	(218703, 118, '2014-03-01 01:28:03.000000', 'temperatura', 489.0000, 'ºC'),
	(218704, 118, '2014-03-01 01:28:04.000000', 'temperatura', 675.0000, 'ºC'),
	(218705, 118, '2014-03-01 01:28:05.000000', 'temperatura', 706.0000, 'ºC'),
	(218706, 118, '2014-03-01 01:28:06.000000', 'temperatura', 306.0000, 'ºC'),
	(218707, 118, '2014-03-01 01:28:07.000000', 'temperatura', 611.0000, 'ºC'),
	(218708, 118, '2014-03-01 01:28:08.000000', 'temperatura', 940.0000, 'ºC'),
	(218709, 118, '2014-03-01 01:28:09.000000', 'temperatura', 469.0000, 'ºC'),
	(218710, 118, '2014-03-01 01:28:10.000000', 'temperatura', 722.0000, 'ºC'),
	(218711, 118, '2014-03-01 01:28:11.000000', 'temperatura', 1004.0000, 'ºC'),
	(218712, 118, '2014-03-01 01:28:12.000000', 'temperatura', 456.0000, 'ºC'),
	(218713, 118, '2014-03-01 01:28:13.000000', 'temperatura', 469.0000, 'ºC'),
	(218714, 118, '2014-03-01 01:28:14.000000', 'temperatura', 975.0000, 'ºC'),
	(218715, 118, '2014-03-01 01:28:15.000000', 'temperatura', 1071.0000, 'ºC'),
	(218716, 118, '2014-03-01 01:28:16.000000', 'temperatura', 28.0000, 'ºC'),
	(218717, 118, '2014-03-01 01:28:17.000000', 'temperatura', 529.0000, 'ºC'),
	(218718, 118, '2014-03-01 01:28:18.000000', 'temperatura', 163.0000, 'ºC'),
	(218719, 118, '2014-03-01 01:28:19.000000', 'temperatura', 425.0000, 'ºC'),
	(218720, 118, '2014-03-01 01:28:20.000000', 'temperatura', 440.0000, 'ºC'),
	(218721, 118, '2014-03-01 01:28:21.000000', 'temperatura', 922.0000, 'ºC'),
	(218722, 118, '2014-03-01 01:28:22.000000', 'temperatura', 893.0000, 'ºC'),
	(218723, 118, '2014-03-01 01:28:23.000000', 'temperatura', 498.0000, 'ºC'),
	(218724, 118, '2014-03-01 01:28:24.000000', 'temperatura', 1013.0000, 'ºC'),
	(218725, 118, '2014-03-01 01:28:25.000000', 'temperatura', 1172.0000, 'ºC'),
	(218726, 118, '2014-03-01 01:28:26.000000', 'temperatura', 419.0000, 'ºC'),
	(218727, 118, '2014-03-01 01:28:27.000000', 'temperatura', 982.0000, 'ºC'),
	(218728, 118, '2014-03-01 01:28:28.000000', 'temperatura', 53.0000, 'ºC'),
	(218729, 118, '2014-03-01 01:28:29.000000', 'temperatura', 920.0000, 'ºC'),
	(218730, 118, '2014-03-01 01:28:30.000000', 'temperatura', 840.0000, 'ºC'),
	(218731, 118, '2014-03-01 01:28:31.000000', 'temperatura', 241.0000, 'ºC'),
	(218732, 118, '2014-03-01 01:28:32.000000', 'temperatura', 1086.0000, 'ºC'),
	(218733, 118, '2014-03-01 01:28:33.000000', 'temperatura', 1108.0000, 'ºC'),
	(218734, 118, '2014-03-01 01:28:34.000000', 'temperatura', 1081.0000, 'ºC'),
	(218735, 118, '2014-03-01 01:28:35.000000', 'temperatura', 883.0000, 'ºC'),
	(218736, 118, '2014-03-01 01:28:36.000000', 'temperatura', 1172.0000, 'ºC'),
	(218737, 118, '2014-03-01 01:28:37.000000', 'temperatura', 812.0000, 'ºC'),
	(218738, 118, '2014-03-01 01:28:38.000000', 'temperatura', 542.0000, 'ºC'),
	(218739, 118, '2014-03-01 01:28:39.000000', 'temperatura', 277.0000, 'ºC'),
	(218740, 118, '2014-03-01 01:28:40.000000', 'temperatura', 958.0000, 'ºC'),
	(218741, 118, '2014-03-01 01:28:41.000000', 'temperatura', 360.0000, 'ºC'),
	(218742, 118, '2014-03-01 01:28:42.000000', 'temperatura', 124.0000, 'ºC'),
	(218743, 118, '2014-03-01 01:28:43.000000', 'temperatura', 744.0000, 'ºC'),
	(218744, 118, '2014-03-01 01:28:44.000000', 'temperatura', 949.0000, 'ºC'),
	(218745, 118, '2014-03-01 01:28:45.000000', 'temperatura', 110.0000, 'ºC'),
	(218746, 118, '2014-03-01 01:28:46.000000', 'temperatura', 107.0000, 'ºC'),
	(218747, 118, '2014-03-01 01:28:47.000000', 'temperatura', 204.0000, 'ºC'),
	(218748, 118, '2014-03-01 01:28:48.000000', 'temperatura', 701.0000, 'ºC'),
	(218749, 118, '2014-03-01 01:28:49.000000', 'temperatura', 495.0000, 'ºC'),
	(218750, 118, '2014-03-01 01:28:50.000000', 'temperatura', 369.0000, 'ºC'),
	(218751, 118, '2014-03-01 01:28:51.000000', 'temperatura', 361.0000, 'ºC'),
	(218752, 118, '2014-03-01 01:28:52.000000', 'temperatura', 701.0000, 'ºC'),
	(218753, 118, '2014-03-01 01:28:53.000000', 'temperatura', 21.0000, 'ºC'),
	(218754, 118, '2014-03-01 01:28:54.000000', 'temperatura', 403.0000, 'ºC'),
	(218755, 118, '2014-03-01 01:28:55.000000', 'temperatura', 753.0000, 'ºC'),
	(218756, 118, '2014-03-01 01:28:56.000000', 'temperatura', 156.0000, 'ºC'),
	(218757, 118, '2014-03-01 01:28:57.000000', 'temperatura', 920.0000, 'ºC'),
	(218758, 118, '2014-03-01 01:28:58.000000', 'temperatura', 532.0000, 'ºC'),
	(218759, 118, '2014-03-01 01:28:59.000000', 'temperatura', 1103.0000, 'ºC'),
	(218760, 118, '2014-03-01 01:29:00.000000', 'temperatura', 319.0000, 'ºC'),
	(218761, 118, '2014-03-01 01:29:01.000000', 'temperatura', 687.0000, 'ºC'),
	(218762, 118, '2014-03-01 01:29:02.000000', 'temperatura', 78.0000, 'ºC'),
	(218763, 118, '2014-03-01 01:29:03.000000', 'temperatura', 728.0000, 'ºC'),
	(218764, 118, '2014-03-01 01:29:04.000000', 'temperatura', 1008.0000, 'ºC'),
	(218765, 118, '2014-03-01 01:29:05.000000', 'temperatura', 457.0000, 'ºC'),
	(218766, 118, '2014-03-01 01:29:06.000000', 'temperatura', 462.0000, 'ºC'),
	(218767, 118, '2014-03-01 01:29:07.000000', 'temperatura', 940.0000, 'ºC'),
	(218768, 118, '2014-03-01 01:29:08.000000', 'temperatura', 913.0000, 'ºC'),
	(218769, 118, '2014-03-01 01:29:09.000000', 'temperatura', 546.0000, 'ºC'),
	(218770, 118, '2014-03-01 01:29:10.000000', 'temperatura', 1190.0000, 'ºC'),
	(218771, 118, '2014-03-01 01:29:11.000000', 'temperatura', 713.0000, 'ºC'),
	(218772, 118, '2014-03-01 01:29:12.000000', 'temperatura', 1196.0000, 'ºC'),
	(218773, 118, '2014-03-01 01:29:13.000000', 'temperatura', 241.0000, 'ºC'),
	(218774, 118, '2014-03-01 01:29:14.000000', 'temperatura', 16.0000, 'ºC'),
	(218775, 118, '2014-03-01 01:29:15.000000', 'temperatura', 557.0000, 'ºC'),
	(218776, 118, '2014-03-01 01:29:16.000000', 'temperatura', 340.0000, 'ºC'),
	(218777, 118, '2014-03-01 01:29:17.000000', 'temperatura', 28.0000, 'ºC'),
	(218778, 118, '2014-03-01 01:29:18.000000', 'temperatura', 320.0000, 'ºC'),
	(218779, 118, '2014-03-01 01:29:19.000000', 'temperatura', 318.0000, 'ºC'),
	(218780, 118, '2014-03-01 01:29:20.000000', 'temperatura', 631.0000, 'ºC'),
	(218781, 118, '2014-03-01 01:29:21.000000', 'temperatura', 1000.0000, 'ºC'),
	(218782, 118, '2014-03-01 01:29:22.000000', 'temperatura', 708.0000, 'ºC'),
	(218783, 118, '2014-03-01 01:29:23.000000', 'temperatura', 541.0000, 'ºC'),
	(218784, 118, '2014-03-01 01:29:24.000000', 'temperatura', 579.0000, 'ºC'),
	(218785, 118, '2014-03-01 01:29:25.000000', 'temperatura', 75.0000, 'ºC'),
	(218786, 118, '2014-03-01 01:29:26.000000', 'temperatura', 1036.0000, 'ºC'),
	(218787, 118, '2014-03-01 01:29:27.000000', 'temperatura', 157.0000, 'ºC'),
	(218788, 118, '2014-03-01 01:29:28.000000', 'temperatura', 79.0000, 'ºC'),
	(218789, 118, '2014-03-01 01:29:29.000000', 'temperatura', 1125.0000, 'ºC'),
	(218790, 118, '2014-03-01 01:29:30.000000', 'temperatura', 586.0000, 'ºC'),
	(218791, 118, '2014-03-01 01:29:31.000000', 'temperatura', 754.0000, 'ºC'),
	(218792, 118, '2014-03-01 01:29:32.000000', 'temperatura', 815.0000, 'ºC'),
	(218793, 118, '2014-03-01 01:29:33.000000', 'temperatura', 615.0000, 'ºC'),
	(218794, 118, '2014-03-01 01:29:34.000000', 'temperatura', 629.0000, 'ºC'),
	(218795, 118, '2014-03-01 01:29:35.000000', 'temperatura', 101.0000, 'ºC'),
	(218796, 118, '2014-03-01 01:29:36.000000', 'temperatura', 1020.0000, 'ºC'),
	(218797, 118, '2014-03-01 01:29:37.000000', 'temperatura', 1197.0000, 'ºC'),
	(218798, 118, '2014-03-01 01:29:38.000000', 'temperatura', 527.0000, 'ºC'),
	(218799, 118, '2014-03-01 01:29:39.000000', 'temperatura', 242.0000, 'ºC'),
	(218800, 118, '2014-03-01 01:29:40.000000', 'temperatura', 828.0000, 'ºC'),
	(218801, 118, '2014-03-01 01:29:41.000000', 'temperatura', 1018.0000, 'ºC'),
	(218802, 118, '2014-03-01 01:29:42.000000', 'temperatura', 204.0000, 'ºC'),
	(218803, 118, '2014-03-01 01:29:43.000000', 'temperatura', 367.0000, 'ºC'),
	(218804, 118, '2014-03-01 01:29:44.000000', 'temperatura', 25.0000, 'ºC'),
	(218805, 118, '2014-03-01 01:29:45.000000', 'temperatura', 223.0000, 'ºC'),
	(218806, 118, '2014-03-01 01:29:46.000000', 'temperatura', 1043.0000, 'ºC'),
	(218807, 118, '2014-03-01 01:29:47.000000', 'temperatura', 945.0000, 'ºC'),
	(218808, 118, '2014-03-01 01:29:48.000000', 'temperatura', 396.0000, 'ºC'),
	(218809, 118, '2014-03-01 01:29:49.000000', 'temperatura', 346.0000, 'ºC'),
	(218810, 118, '2014-03-01 01:29:50.000000', 'temperatura', 544.0000, 'ºC'),
	(218811, 118, '2014-03-01 01:29:51.000000', 'temperatura', 481.0000, 'ºC'),
	(218812, 118, '2014-03-01 01:29:52.000000', 'temperatura', 772.0000, 'ºC'),
	(218813, 118, '2014-03-01 01:29:53.000000', 'temperatura', 18.0000, 'ºC'),
	(218814, 118, '2014-03-01 01:29:54.000000', 'temperatura', 176.0000, 'ºC'),
	(218815, 118, '2014-03-01 01:29:55.000000', 'temperatura', 825.0000, 'ºC'),
	(218816, 118, '2014-03-01 01:29:56.000000', 'temperatura', 1198.0000, 'ºC'),
	(218817, 118, '2014-03-01 01:29:57.000000', 'temperatura', 1114.0000, 'ºC'),
	(218818, 118, '2014-03-01 01:29:58.000000', 'temperatura', 776.0000, 'ºC'),
	(218819, 118, '2014-03-01 01:29:59.000000', 'temperatura', 539.0000, 'ºC'),
	(218820, 118, '2014-03-01 01:30:00.000000', 'temperatura', 369.0000, 'ºC'),
	(218821, 118, '2014-03-01 01:30:01.000000', 'temperatura', 228.0000, 'ºC'),
	(218822, 118, '2014-03-01 01:30:02.000000', 'temperatura', 35.0000, 'ºC'),
	(218823, 118, '2014-03-01 01:30:03.000000', 'temperatura', 692.0000, 'ºC'),
	(218824, 118, '2014-03-01 01:30:04.000000', 'temperatura', 955.0000, 'ºC'),
	(218825, 118, '2014-03-01 01:30:05.000000', 'temperatura', 301.0000, 'ºC'),
	(218826, 118, '2014-03-01 01:30:06.000000', 'temperatura', 1037.0000, 'ºC'),
	(218827, 118, '2014-03-01 01:30:07.000000', 'temperatura', 685.0000, 'ºC'),
	(218828, 118, '2014-03-01 01:30:08.000000', 'temperatura', 313.0000, 'ºC'),
	(218829, 118, '2014-03-01 01:30:09.000000', 'temperatura', 712.0000, 'ºC'),
	(218830, 118, '2014-03-01 01:30:10.000000', 'temperatura', 223.0000, 'ºC'),
	(218831, 118, '2014-03-01 01:30:11.000000', 'temperatura', 176.0000, 'ºC'),
	(218832, 118, '2014-03-01 01:30:12.000000', 'temperatura', 212.0000, 'ºC'),
	(218833, 118, '2014-03-01 01:30:13.000000', 'temperatura', 535.0000, 'ºC'),
	(218834, 118, '2014-03-01 01:30:14.000000', 'temperatura', 837.0000, 'ºC'),
	(218835, 118, '2014-03-01 01:30:15.000000', 'temperatura', 182.0000, 'ºC'),
	(218836, 118, '2014-03-01 01:30:16.000000', 'temperatura', 797.0000, 'ºC'),
	(218837, 118, '2014-03-01 01:30:17.000000', 'temperatura', 1043.0000, 'ºC'),
	(218838, 118, '2014-03-01 01:30:18.000000', 'temperatura', 423.0000, 'ºC'),
	(218839, 118, '2014-03-01 01:30:19.000000', 'temperatura', 186.0000, 'ºC'),
	(218840, 118, '2014-03-01 01:30:20.000000', 'temperatura', 864.0000, 'ºC'),
	(218841, 118, '2014-03-01 01:30:21.000000', 'temperatura', 160.0000, 'ºC'),
	(218842, 118, '2014-03-01 01:30:22.000000', 'temperatura', 610.0000, 'ºC'),
	(218843, 118, '2014-03-01 01:30:23.000000', 'temperatura', 172.0000, 'ºC'),
	(218844, 118, '2014-03-01 01:30:24.000000', 'temperatura', 227.0000, 'ºC'),
	(218845, 119, '2014-03-01 00:00:00.000000', 'temperatura', 33.0000, 'ºC'),
	(218846, 119, '2014-03-01 00:00:01.000000', 'temperatura', 697.0000, 'ºC'),
	(218847, 119, '2014-03-01 00:00:02.000000', 'temperatura', 987.0000, 'ºC'),
	(218848, 119, '2014-03-01 00:00:03.000000', 'temperatura', 446.0000, 'ºC'),
	(218849, 119, '2014-03-01 00:00:04.000000', 'temperatura', 467.0000, 'ºC'),
	(218850, 119, '2014-03-01 00:00:05.000000', 'temperatura', 1000.0000, 'ºC'),
	(218851, 119, '2014-03-01 00:00:06.000000', 'temperatura', 1196.0000, 'ºC'),
	(218852, 119, '2014-03-01 00:00:07.000000', 'temperatura', 583.0000, 'ºC'),
	(218853, 119, '2014-03-01 00:00:08.000000', 'temperatura', 527.0000, 'ºC'),
	(218854, 119, '2014-03-01 00:00:09.000000', 'temperatura', 887.0000, 'ºC'),
	(218855, 119, '2014-03-01 00:00:10.000000', 'temperatura', 456.0000, 'ºC'),
	(218856, 119, '2014-03-01 00:00:11.000000', 'temperatura', 816.0000, 'ºC'),
	(218857, 119, '2014-03-01 00:00:12.000000', 'temperatura', 315.0000, 'ºC'),
	(218858, 119, '2014-03-01 00:00:13.000000', 'temperatura', 326.0000, 'ºC'),
	(218859, 119, '2014-03-01 00:00:14.000000', 'temperatura', 686.0000, 'ºC'),
	(218860, 119, '2014-03-01 00:00:15.000000', 'temperatura', 51.0000, 'ºC'),
	(218861, 119, '2014-03-01 00:00:16.000000', 'temperatura', 600.0000, 'ºC'),
	(218862, 119, '2014-03-01 00:00:17.000000', 'temperatura', 445.0000, 'ºC'),
	(218863, 119, '2014-03-01 00:00:18.000000', 'temperatura', 429.0000, 'ºC'),
	(218864, 119, '2014-03-01 00:00:19.000000', 'temperatura', 807.0000, 'ºC'),
	(218865, 119, '2014-03-01 00:00:20.000000', 'temperatura', 352.0000, 'ºC'),
	(218866, 119, '2014-03-01 00:00:21.000000', 'temperatura', 536.0000, 'ºC'),
	(218867, 119, '2014-03-01 00:00:22.000000', 'temperatura', 426.0000, 'ºC'),
	(218868, 119, '2014-03-01 00:00:23.000000', 'temperatura', 523.0000, 'ºC'),
	(218869, 119, '2014-03-01 00:00:24.000000', 'temperatura', 135.0000, 'ºC'),
	(218870, 119, '2014-03-01 00:00:25.000000', 'temperatura', 310.0000, 'ºC'),
	(218871, 119, '2014-03-01 00:00:26.000000', 'temperatura', 1142.0000, 'ºC'),
	(218872, 119, '2014-03-01 00:00:27.000000', 'temperatura', 1184.0000, 'ºC'),
	(218873, 119, '2014-03-01 00:00:28.000000', 'temperatura', 92.0000, 'ºC'),
	(218874, 119, '2014-03-01 00:00:29.000000', 'temperatura', 510.0000, 'ºC'),
	(218875, 119, '2014-03-01 00:00:30.000000', 'temperatura', 1075.0000, 'ºC'),
	(218876, 119, '2014-03-01 00:00:31.000000', 'temperatura', 243.0000, 'ºC'),
	(218877, 119, '2014-03-01 00:00:32.000000', 'temperatura', 392.0000, 'ºC'),
	(218878, 119, '2014-03-01 00:00:33.000000', 'temperatura', 33.0000, 'ºC'),
	(218879, 119, '2014-03-01 00:00:34.000000', 'temperatura', 189.0000, 'ºC'),
	(218880, 119, '2014-03-01 00:00:35.000000', 'temperatura', 847.0000, 'ºC'),
	(218881, 119, '2014-03-01 00:00:36.000000', 'temperatura', 68.0000, 'ºC'),
	(218882, 119, '2014-03-01 00:00:37.000000', 'temperatura', 201.0000, 'ºC'),
	(218883, 119, '2014-03-01 00:00:38.000000', 'temperatura', 800.0000, 'ºC'),
	(218884, 119, '2014-03-01 00:00:39.000000', 'temperatura', 1000.0000, 'ºC'),
	(218885, 119, '2014-03-01 00:00:40.000000', 'temperatura', 198.0000, 'ºC'),
	(218886, 119, '2014-03-01 00:00:41.000000', 'temperatura', 391.0000, 'ºC'),
	(218887, 119, '2014-03-01 00:00:42.000000', 'temperatura', 160.0000, 'ºC'),
	(218888, 119, '2014-03-01 00:00:43.000000', 'temperatura', 829.0000, 'ºC'),
	(218889, 119, '2014-03-01 00:00:44.000000', 'temperatura', 67.0000, 'ºC'),
	(218890, 119, '2014-03-01 00:00:45.000000', 'temperatura', 248.0000, 'ºC'),
	(218891, 119, '2014-03-01 00:00:46.000000', 'temperatura', 1038.0000, 'ºC'),
	(218892, 119, '2014-03-01 00:00:47.000000', 'temperatura', 849.0000, 'ºC'),
	(218893, 119, '2014-03-01 00:00:48.000000', 'temperatura', 1130.0000, 'ºC'),
	(218894, 119, '2014-03-01 00:00:49.000000', 'temperatura', 706.0000, 'ºC'),
	(218895, 119, '2014-03-01 00:00:50.000000', 'temperatura', 137.0000, 'ºC'),
	(218896, 119, '2014-03-01 00:00:51.000000', 'temperatura', 968.0000, 'ºC'),
	(218897, 119, '2014-03-01 00:00:52.000000', 'temperatura', 831.0000, 'ºC'),
	(218898, 119, '2014-03-01 00:00:53.000000', 'temperatura', 50.0000, 'ºC'),
	(218899, 119, '2014-03-01 00:00:54.000000', 'temperatura', 158.0000, 'ºC'),
	(218900, 119, '2014-03-01 00:00:55.000000', 'temperatura', 639.0000, 'ºC'),
	(218901, 119, '2014-03-01 00:00:56.000000', 'temperatura', 323.0000, 'ºC'),
	(218902, 119, '2014-03-01 00:00:57.000000', 'temperatura', 899.0000, 'ºC'),
	(218903, 119, '2014-03-01 00:00:58.000000', 'temperatura', 1128.0000, 'ºC'),
	(218904, 119, '2014-03-01 00:00:59.000000', 'temperatura', 542.0000, 'ºC'),
	(218905, 119, '2014-03-01 00:01:00.000000', 'temperatura', 525.0000, 'ºC'),
	(218906, 119, '2014-03-01 00:01:01.000000', 'temperatura', 1001.0000, 'ºC'),
	(218907, 119, '2014-03-01 00:01:02.000000', 'temperatura', 1030.0000, 'ºC'),
	(218908, 119, '2014-03-01 00:01:03.000000', 'temperatura', 950.0000, 'ºC'),
	(218909, 119, '2014-03-01 00:01:04.000000', 'temperatura', 457.0000, 'ºC'),
	(218910, 119, '2014-03-01 00:01:05.000000', 'temperatura', 636.0000, 'ºC'),
	(218911, 119, '2014-03-01 00:01:06.000000', 'temperatura', 612.0000, 'ºC'),
	(218912, 119, '2014-03-01 00:01:07.000000', 'temperatura', 1150.0000, 'ºC'),
	(218913, 119, '2014-03-01 00:01:08.000000', 'temperatura', 317.0000, 'ºC'),
	(218914, 119, '2014-03-01 00:01:09.000000', 'temperatura', 536.0000, 'ºC'),
	(218915, 119, '2014-03-01 00:01:10.000000', 'temperatura', 528.0000, 'ºC'),
	(218916, 119, '2014-03-01 00:01:11.000000', 'temperatura', 1033.0000, 'ºC'),
	(218917, 119, '2014-03-01 00:01:12.000000', 'temperatura', 1183.0000, 'ºC'),
	(218918, 119, '2014-03-01 00:01:13.000000', 'temperatura', 417.0000, 'ºC'),
	(218919, 119, '2014-03-01 00:01:14.000000', 'temperatura', 934.0000, 'ºC'),
	(218920, 119, '2014-03-01 00:01:15.000000', 'temperatura', 1021.0000, 'ºC'),
	(218921, 119, '2014-03-01 00:01:16.000000', 'temperatura', 1103.0000, 'ºC'),
	(218922, 119, '2014-03-01 00:01:17.000000', 'temperatura', 52.0000, 'ºC'),
	(218923, 119, '2014-03-01 00:01:18.000000', 'temperatura', 553.0000, 'ºC'),
	(218924, 119, '2014-03-01 00:01:19.000000', 'temperatura', 208.0000, 'ºC'),
	(218925, 119, '2014-03-01 00:01:20.000000', 'temperatura', 580.0000, 'ºC'),
	(218926, 119, '2014-03-01 00:01:21.000000', 'temperatura', 1077.0000, 'ºC'),
	(218927, 119, '2014-03-01 00:01:22.000000', 'temperatura', 48.0000, 'ºC'),
	(218928, 119, '2014-03-01 00:01:23.000000', 'temperatura', 609.0000, 'ºC'),
	(218929, 119, '2014-03-01 00:01:24.000000', 'temperatura', 501.0000, 'ºC'),
	(218930, 119, '2014-03-01 00:01:25.000000', 'temperatura', 677.0000, 'ºC'),
	(218931, 119, '2014-03-01 00:01:26.000000', 'temperatura', 683.0000, 'ºC'),
	(218932, 119, '2014-03-01 00:01:27.000000', 'temperatura', 186.0000, 'ºC'),
	(218933, 119, '2014-03-01 00:01:28.000000', 'temperatura', 81.0000, 'ºC'),
	(218934, 119, '2014-03-01 00:01:29.000000', 'temperatura', 1048.0000, 'ºC'),
	(218935, 119, '2014-03-01 00:01:30.000000', 'temperatura', 195.0000, 'ºC'),
	(218936, 119, '2014-03-01 00:01:31.000000', 'temperatura', 233.0000, 'ºC'),
	(218937, 119, '2014-03-01 00:01:32.000000', 'temperatura', 582.0000, 'ºC'),
	(218938, 119, '2014-03-01 00:01:33.000000', 'temperatura', 1011.0000, 'ºC'),
	(218939, 119, '2014-03-01 00:01:34.000000', 'temperatura', 909.0000, 'ºC'),
	(218940, 119, '2014-03-01 00:01:35.000000', 'temperatura', 313.0000, 'ºC'),
	(218941, 119, '2014-03-01 00:01:36.000000', 'temperatura', 40.0000, 'ºC'),
	(218942, 119, '2014-03-01 00:01:37.000000', 'temperatura', 458.0000, 'ºC'),
	(218943, 119, '2014-03-01 00:01:38.000000', 'temperatura', 974.0000, 'ºC'),
	(218944, 119, '2014-03-01 00:01:39.000000', 'temperatura', 1095.0000, 'ºC'),
	(218945, 119, '2014-03-01 00:01:40.000000', 'temperatura', 155.0000, 'ºC'),
	(218946, 119, '2014-03-01 00:01:41.000000', 'temperatura', 1089.0000, 'ºC'),
	(218947, 119, '2014-03-01 00:01:42.000000', 'temperatura', 179.0000, 'ºC'),
	(218948, 119, '2014-03-01 00:01:43.000000', 'temperatura', 32.0000, 'ºC'),
	(218949, 119, '2014-03-01 00:01:44.000000', 'temperatura', 822.0000, 'ºC'),
	(218950, 119, '2014-03-01 00:01:45.000000', 'temperatura', 413.0000, 'ºC'),
	(218951, 119, '2014-03-01 00:01:46.000000', 'temperatura', 802.0000, 'ºC'),
	(218952, 119, '2014-03-01 00:01:47.000000', 'temperatura', 369.0000, 'ºC'),
	(218953, 119, '2014-03-01 00:01:48.000000', 'temperatura', 642.0000, 'ºC'),
	(218954, 119, '2014-03-01 00:01:49.000000', 'temperatura', 904.0000, 'ºC'),
	(218955, 119, '2014-03-01 00:01:50.000000', 'temperatura', 192.0000, 'ºC'),
	(218956, 119, '2014-03-01 00:01:51.000000', 'temperatura', 651.0000, 'ºC'),
	(218957, 119, '2014-03-01 00:01:52.000000', 'temperatura', 278.0000, 'ºC'),
	(218958, 119, '2014-03-01 00:01:53.000000', 'temperatura', 638.0000, 'ºC'),
	(218959, 119, '2014-03-01 00:01:54.000000', 'temperatura', 1158.0000, 'ºC'),
	(218960, 119, '2014-03-01 00:01:55.000000', 'temperatura', 275.0000, 'ºC'),
	(218961, 119, '2014-03-01 00:01:56.000000', 'temperatura', 303.0000, 'ºC'),
	(218962, 119, '2014-03-01 00:01:57.000000', 'temperatura', 691.0000, 'ºC'),
	(218963, 119, '2014-03-01 00:01:58.000000', 'temperatura', 145.0000, 'ºC'),
	(218964, 119, '2014-03-01 00:01:59.000000', 'temperatura', 1052.0000, 'ºC'),
	(218965, 119, '2014-03-01 00:02:00.000000', 'temperatura', 27.0000, 'ºC'),
	(218966, 119, '2014-03-01 00:02:01.000000', 'temperatura', 578.0000, 'ºC'),
	(218967, 119, '2014-03-01 00:02:02.000000', 'temperatura', 410.0000, 'ºC'),
	(218968, 119, '2014-03-01 00:02:03.000000', 'temperatura', 318.0000, 'ºC'),
	(218969, 119, '2014-03-01 00:02:04.000000', 'temperatura', 360.0000, 'ºC'),
	(218970, 119, '2014-03-01 00:02:05.000000', 'temperatura', 846.0000, 'ºC'),
	(218971, 119, '2014-03-01 00:02:06.000000', 'temperatura', 750.0000, 'ºC'),
	(218972, 119, '2014-03-01 00:02:07.000000', 'temperatura', 14.0000, 'ºC'),
	(218973, 119, '2014-03-01 00:02:08.000000', 'temperatura', 219.0000, 'ºC'),
	(218974, 119, '2014-03-01 00:02:09.000000', 'temperatura', 1056.0000, 'ºC'),
	(218975, 119, '2014-03-01 00:02:10.000000', 'temperatura', 1020.0000, 'ºC'),
	(218976, 119, '2014-03-01 00:02:11.000000', 'temperatura', 735.0000, 'ºC'),
	(218977, 119, '2014-03-01 00:02:12.000000', 'temperatura', 615.0000, 'ºC'),
	(218978, 119, '2014-03-01 00:02:13.000000', 'temperatura', 869.0000, 'ºC'),
	(218979, 119, '2014-03-01 00:02:14.000000', 'temperatura', 102.0000, 'ºC'),
	(218980, 119, '2014-03-01 00:02:15.000000', 'temperatura', 304.0000, 'ºC'),
	(218981, 119, '2014-03-01 00:02:16.000000', 'temperatura', 13.0000, 'ºC'),
	(218982, 119, '2014-03-01 00:02:17.000000', 'temperatura', 356.0000, 'ºC'),
	(218983, 119, '2014-03-01 00:02:18.000000', 'temperatura', 541.0000, 'ºC'),
	(218984, 119, '2014-03-01 00:02:19.000000', 'temperatura', 438.0000, 'ºC'),
	(218985, 119, '2014-03-01 00:02:20.000000', 'temperatura', 567.0000, 'ºC'),
	(218986, 119, '2014-03-01 00:02:21.000000', 'temperatura', 320.0000, 'ºC'),
	(218987, 119, '2014-03-01 00:02:22.000000', 'temperatura', 1101.0000, 'ºC'),
	(218988, 119, '2014-03-01 00:02:23.000000', 'temperatura', 946.0000, 'ºC'),
	(218989, 119, '2014-03-01 00:02:24.000000', 'temperatura', 226.0000, 'ºC'),
	(218990, 119, '2014-03-01 00:02:25.000000', 'temperatura', 694.0000, 'ºC'),
	(218991, 119, '2014-03-01 00:02:26.000000', 'temperatura', 392.0000, 'ºC'),
	(218992, 119, '2014-03-01 00:02:27.000000', 'temperatura', 1078.0000, 'ºC'),
	(218993, 119, '2014-03-01 00:02:28.000000', 'temperatura', 616.0000, 'ºC'),
	(218994, 119, '2014-03-01 00:02:29.000000', 'temperatura', 1046.0000, 'ºC'),
	(218995, 119, '2014-03-01 00:02:30.000000', 'temperatura', 980.0000, 'ºC'),
	(218996, 119, '2014-03-01 00:02:31.000000', 'temperatura', 565.0000, 'ºC'),
	(218997, 119, '2014-03-01 00:02:32.000000', 'temperatura', 1087.0000, 'ºC'),
	(218998, 119, '2014-03-01 00:02:33.000000', 'temperatura', 137.0000, 'ºC'),
	(218999, 119, '2014-03-01 00:02:34.000000', 'temperatura', 1028.0000, 'ºC'),
	(219000, 119, '2014-03-01 00:02:35.000000', 'temperatura', 1127.0000, 'ºC'),
	(219001, 119, '2014-03-01 00:02:36.000000', 'temperatura', 153.0000, 'ºC'),
	(219002, 119, '2014-03-01 00:02:37.000000', 'temperatura', 984.0000, 'ºC'),
	(219003, 119, '2014-03-01 00:02:38.000000', 'temperatura', 863.0000, 'ºC'),
	(219004, 119, '2014-03-01 00:02:39.000000', 'temperatura', 164.0000, 'ºC'),
	(219005, 119, '2014-03-01 00:02:40.000000', 'temperatura', 631.0000, 'ºC'),
	(219006, 119, '2014-03-01 00:02:41.000000', 'temperatura', 264.0000, 'ºC'),
	(219007, 119, '2014-03-01 00:02:42.000000', 'temperatura', 626.0000, 'ºC'),
	(219008, 119, '2014-03-01 00:02:43.000000', 'temperatura', 1140.0000, 'ºC'),
	(219009, 119, '2014-03-01 00:02:44.000000', 'temperatura', 223.0000, 'ºC'),
	(219010, 119, '2014-03-01 00:02:45.000000', 'temperatura', 95.0000, 'ºC'),
	(219011, 119, '2014-03-01 00:02:46.000000', 'temperatura', 1005.0000, 'ºC'),
	(219012, 119, '2014-03-01 00:02:47.000000', 'temperatura', 1141.0000, 'ºC'),
	(219013, 119, '2014-03-01 00:02:48.000000', 'temperatura', 292.0000, 'ºC'),
	(219014, 119, '2014-03-01 00:02:49.000000', 'temperatura', 439.0000, 'ºC'),
	(219015, 119, '2014-03-01 00:02:50.000000', 'temperatura', 116.0000, 'ºC'),
	(219016, 119, '2014-03-01 00:02:51.000000', 'temperatura', 464.0000, 'ºC'),
	(219017, 119, '2014-03-01 00:02:52.000000', 'temperatura', 774.0000, 'ºC'),
	(219018, 119, '2014-03-01 00:02:53.000000', 'temperatura', 78.0000, 'ºC'),
	(219019, 119, '2014-03-01 00:02:54.000000', 'temperatura', 469.0000, 'ºC'),
	(219020, 119, '2014-03-01 00:02:55.000000', 'temperatura', 912.0000, 'ºC'),
	(219021, 119, '2014-03-01 00:02:56.000000', 'temperatura', 752.0000, 'ºC'),
	(219022, 119, '2014-03-01 00:02:57.000000', 'temperatura', 1027.0000, 'ºC'),
	(219023, 119, '2014-03-01 00:02:58.000000', 'temperatura', 479.0000, 'ºC'),
	(219024, 119, '2014-03-01 00:02:59.000000', 'temperatura', 514.0000, 'ºC'),
	(219025, 119, '2014-03-01 00:03:00.000000', 'temperatura', 1132.0000, 'ºC'),
	(219026, 119, '2014-03-01 00:03:01.000000', 'temperatura', 519.0000, 'ºC'),
	(219027, 119, '2014-03-01 00:03:02.000000', 'temperatura', 400.0000, 'ºC'),
	(219028, 119, '2014-03-01 00:03:03.000000', 'temperatura', 441.0000, 'ºC'),
	(219029, 119, '2014-03-01 00:03:04.000000', 'temperatura', 1009.0000, 'ºC'),
	(219030, 119, '2014-03-01 00:03:05.000000', 'temperatura', 122.0000, 'ºC'),
	(219031, 119, '2014-03-01 00:03:06.000000', 'temperatura', 1181.0000, 'ºC'),
	(219032, 119, '2014-03-01 00:03:07.000000', 'temperatura', 740.0000, 'ºC'),
	(219033, 119, '2014-03-01 00:03:08.000000', 'temperatura', 160.0000, 'ºC'),
	(219034, 119, '2014-03-01 00:03:09.000000', 'temperatura', 979.0000, 'ºC'),
	(219035, 119, '2014-03-01 00:03:10.000000', 'temperatura', 818.0000, 'ºC'),
	(219036, 119, '2014-03-01 00:03:11.000000', 'temperatura', 1150.0000, 'ºC'),
	(219037, 119, '2014-03-01 00:03:12.000000', 'temperatura', 897.0000, 'ºC'),
	(219038, 119, '2014-03-01 00:03:13.000000', 'temperatura', 1036.0000, 'ºC'),
	(219039, 119, '2014-03-01 00:03:14.000000', 'temperatura', 91.0000, 'ºC'),
	(219040, 119, '2014-03-01 00:03:15.000000', 'temperatura', 947.0000, 'ºC'),
	(219041, 119, '2014-03-01 00:03:16.000000', 'temperatura', 862.0000, 'ºC'),
	(219042, 119, '2014-03-01 00:03:17.000000', 'temperatura', 268.0000, 'ºC'),
	(219043, 119, '2014-03-01 00:03:18.000000', 'temperatura', 1154.0000, 'ºC'),
	(219044, 119, '2014-03-01 00:03:19.000000', 'temperatura', 167.0000, 'ºC'),
	(219045, 119, '2014-03-01 00:03:20.000000', 'temperatura', 972.0000, 'ºC'),
	(219046, 119, '2014-03-01 00:03:21.000000', 'temperatura', 760.0000, 'ºC'),
	(219047, 119, '2014-03-01 00:03:22.000000', 'temperatura', 887.0000, 'ºC'),
	(219048, 119, '2014-03-01 00:03:23.000000', 'temperatura', 953.0000, 'ºC'),
	(219049, 119, '2014-03-01 00:03:24.000000', 'temperatura', 905.0000, 'ºC'),
	(219050, 119, '2014-03-01 00:03:25.000000', 'temperatura', 467.0000, 'ºC'),
	(219051, 119, '2014-03-01 00:03:26.000000', 'temperatura', 821.0000, 'ºC'),
	(219052, 119, '2014-03-01 00:03:27.000000', 'temperatura', 304.0000, 'ºC'),
	(219053, 119, '2014-03-01 00:03:28.000000', 'temperatura', 257.0000, 'ºC'),
	(219054, 119, '2014-03-01 00:03:29.000000', 'temperatura', 375.0000, 'ºC'),
	(219055, 119, '2014-03-01 00:03:30.000000', 'temperatura', 1102.0000, 'ºC'),
	(219056, 119, '2014-03-01 00:03:31.000000', 'temperatura', 788.0000, 'ºC'),
	(219057, 119, '2014-03-01 00:03:32.000000', 'temperatura', 633.0000, 'ºC'),
	(219058, 119, '2014-03-01 00:03:33.000000', 'temperatura', 804.0000, 'ºC'),
	(219059, 119, '2014-03-01 00:03:34.000000', 'temperatura', 918.0000, 'ºC'),
	(219060, 119, '2014-03-01 00:03:35.000000', 'temperatura', 981.0000, 'ºC'),
	(219061, 119, '2014-03-01 00:03:36.000000', 'temperatura', 953.0000, 'ºC'),
	(219062, 119, '2014-03-01 00:03:37.000000', 'temperatura', 620.0000, 'ºC'),
	(219063, 119, '2014-03-01 00:03:38.000000', 'temperatura', 241.0000, 'ºC'),
	(219064, 119, '2014-03-01 00:03:39.000000', 'temperatura', 548.0000, 'ºC'),
	(219065, 119, '2014-03-01 00:03:40.000000', 'temperatura', 818.0000, 'ºC'),
	(219066, 119, '2014-03-01 00:03:41.000000', 'temperatura', 45.0000, 'ºC'),
	(219067, 119, '2014-03-01 00:03:42.000000', 'temperatura', 173.0000, 'ºC'),
	(219068, 119, '2014-03-01 00:03:43.000000', 'temperatura', 728.0000, 'ºC'),
	(219069, 119, '2014-03-01 00:03:44.000000', 'temperatura', 723.0000, 'ºC'),
	(219070, 119, '2014-03-01 00:03:45.000000', 'temperatura', 232.0000, 'ºC'),
	(219071, 119, '2014-03-01 00:03:46.000000', 'temperatura', 191.0000, 'ºC'),
	(219072, 119, '2014-03-01 00:03:47.000000', 'temperatura', 260.0000, 'ºC'),
	(219073, 119, '2014-03-01 00:03:48.000000', 'temperatura', 727.0000, 'ºC'),
	(219074, 119, '2014-03-01 00:03:49.000000', 'temperatura', 455.0000, 'ºC'),
	(219075, 119, '2014-03-01 00:03:50.000000', 'temperatura', 93.0000, 'ºC'),
	(219076, 119, '2014-03-01 00:03:51.000000', 'temperatura', 304.0000, 'ºC'),
	(219077, 119, '2014-03-01 00:03:52.000000', 'temperatura', 38.0000, 'ºC'),
	(219078, 119, '2014-03-01 00:03:53.000000', 'temperatura', 480.0000, 'ºC'),
	(219079, 119, '2014-03-01 00:03:54.000000', 'temperatura', 1085.0000, 'ºC'),
	(219080, 119, '2014-03-01 00:03:55.000000', 'temperatura', 386.0000, 'ºC'),
	(219081, 119, '2014-03-01 00:03:56.000000', 'temperatura', 1078.0000, 'ºC'),
	(219082, 119, '2014-03-01 00:03:57.000000', 'temperatura', 629.0000, 'ºC'),
	(219083, 119, '2014-03-01 00:03:58.000000', 'temperatura', 1114.0000, 'ºC'),
	(219084, 119, '2014-03-01 00:03:59.000000', 'temperatura', 81.0000, 'ºC'),
	(219085, 119, '2014-03-01 00:04:00.000000', 'temperatura', 666.0000, 'ºC'),
	(219086, 119, '2014-03-01 00:04:01.000000', 'temperatura', 688.0000, 'ºC'),
	(219087, 119, '2014-03-01 00:04:02.000000', 'temperatura', 243.0000, 'ºC'),
	(219088, 119, '2014-03-01 00:04:03.000000', 'temperatura', 351.0000, 'ºC'),
	(219089, 119, '2014-03-01 00:04:04.000000', 'temperatura', 1026.0000, 'ºC'),
	(219090, 119, '2014-03-01 00:04:05.000000', 'temperatura', 478.0000, 'ºC'),
	(219091, 119, '2014-03-01 00:04:06.000000', 'temperatura', 512.0000, 'ºC'),
	(219092, 119, '2014-03-01 00:04:07.000000', 'temperatura', 1125.0000, 'ºC'),
	(219093, 119, '2014-03-01 00:04:08.000000', 'temperatura', 492.0000, 'ºC'),
	(219094, 119, '2014-03-01 00:04:09.000000', 'temperatura', 286.0000, 'ºC'),
	(219095, 119, '2014-03-01 00:04:10.000000', 'temperatura', 1154.0000, 'ºC'),
	(219096, 119, '2014-03-01 00:04:11.000000', 'temperatura', 111.0000, 'ºC'),
	(219097, 119, '2014-03-01 00:04:12.000000', 'temperatura', 693.0000, 'ºC'),
	(219098, 119, '2014-03-01 00:04:13.000000', 'temperatura', 735.0000, 'ºC'),
	(219099, 119, '2014-03-01 00:04:14.000000', 'temperatura', 397.0000, 'ºC'),
	(219100, 119, '2014-03-01 00:04:15.000000', 'temperatura', 978.0000, 'ºC'),
	(219101, 119, '2014-03-01 00:04:16.000000', 'temperatura', 101.0000, 'ºC'),
	(219102, 119, '2014-03-01 00:04:17.000000', 'temperatura', 1171.0000, 'ºC'),
	(219103, 119, '2014-03-01 00:04:18.000000', 'temperatura', 751.0000, 'ºC'),
	(219104, 119, '2014-03-01 00:04:19.000000', 'temperatura', 244.0000, 'ºC'),
	(219105, 119, '2014-03-01 00:04:20.000000', 'temperatura', 169.0000, 'ºC'),
	(219106, 119, '2014-03-01 00:04:21.000000', 'temperatura', 110.0000, 'ºC'),
	(219107, 119, '2014-03-01 00:04:22.000000', 'temperatura', 47.0000, 'ºC'),
	(219108, 119, '2014-03-01 00:04:23.000000', 'temperatura', 1104.0000, 'ºC'),
	(219109, 119, '2014-03-01 00:04:24.000000', 'temperatura', 581.0000, 'ºC'),
	(219110, 119, '2014-03-01 00:04:25.000000', 'temperatura', 794.0000, 'ºC'),
	(219111, 119, '2014-03-01 00:04:26.000000', 'temperatura', 1025.0000, 'ºC'),
	(219112, 119, '2014-03-01 00:04:27.000000', 'temperatura', 347.0000, 'ºC'),
	(219113, 119, '2014-03-01 00:04:28.000000', 'temperatura', 1057.0000, 'ºC'),
	(219114, 119, '2014-03-01 00:04:29.000000', 'temperatura', 647.0000, 'ºC'),
	(219115, 119, '2014-03-01 00:04:30.000000', 'temperatura', 64.0000, 'ºC'),
	(219116, 119, '2014-03-01 00:04:31.000000', 'temperatura', 779.0000, 'ºC'),
	(219117, 119, '2014-03-01 00:04:32.000000', 'temperatura', 105.0000, 'ºC'),
	(219118, 119, '2014-03-01 00:04:33.000000', 'temperatura', 586.0000, 'ºC'),
	(219119, 119, '2014-03-01 00:04:34.000000', 'temperatura', 218.0000, 'ºC'),
	(219120, 119, '2014-03-01 00:04:35.000000', 'temperatura', 531.0000, 'ºC'),
	(219121, 119, '2014-03-01 00:04:36.000000', 'temperatura', 804.0000, 'ºC'),
	(219122, 119, '2014-03-01 00:04:37.000000', 'temperatura', 25.0000, 'ºC'),
	(219123, 119, '2014-03-01 00:04:38.000000', 'temperatura', 113.0000, 'ºC'),
	(219124, 119, '2014-03-01 00:04:39.000000', 'temperatura', 491.0000, 'ºC'),
	(219125, 119, '2014-03-01 00:04:40.000000', 'temperatura', 917.0000, 'ºC'),
	(219126, 119, '2014-03-01 00:04:41.000000', 'temperatura', 713.0000, 'ºC'),
	(219127, 119, '2014-03-01 00:04:42.000000', 'temperatura', 812.0000, 'ºC'),
	(219128, 119, '2014-03-01 00:04:43.000000', 'temperatura', 725.0000, 'ºC'),
	(219129, 119, '2014-03-01 00:04:44.000000', 'temperatura', 1187.0000, 'ºC'),
	(219130, 119, '2014-03-01 00:04:45.000000', 'temperatura', 161.0000, 'ºC'),
	(219131, 119, '2014-03-01 00:04:46.000000', 'temperatura', 846.0000, 'ºC'),
	(219132, 119, '2014-03-01 00:04:47.000000', 'temperatura', 145.0000, 'ºC'),
	(219133, 119, '2014-03-01 00:04:48.000000', 'temperatura', 588.0000, 'ºC'),
	(219134, 119, '2014-03-01 00:04:49.000000', 'temperatura', 108.0000, 'ºC'),
	(219135, 119, '2014-03-01 00:04:50.000000', 'temperatura', 1173.0000, 'ºC'),
	(219136, 119, '2014-03-01 00:04:51.000000', 'temperatura', 745.0000, 'ºC'),
	(219137, 119, '2014-03-01 00:04:52.000000', 'temperatura', 205.0000, 'ºC'),
	(219138, 119, '2014-03-01 00:04:53.000000', 'temperatura', 1192.0000, 'ºC'),
	(219139, 119, '2014-03-01 00:04:54.000000', 'temperatura', 544.0000, 'ºC'),
	(219140, 119, '2014-03-01 00:04:55.000000', 'temperatura', 345.0000, 'ºC'),
	(219141, 119, '2014-03-01 00:04:56.000000', 'temperatura', 95.0000, 'ºC'),
	(219142, 119, '2014-03-01 00:04:57.000000', 'temperatura', 638.0000, 'ºC'),
	(219143, 119, '2014-03-01 00:04:58.000000', 'temperatura', 508.0000, 'ºC'),
	(219144, 119, '2014-03-01 00:04:59.000000', 'temperatura', 624.0000, 'ºC'),
	(219145, 119, '2014-03-01 00:05:00.000000', 'temperatura', 400.0000, 'ºC'),
	(219146, 119, '2014-03-01 00:05:01.000000', 'temperatura', 125.0000, 'ºC'),
	(219147, 119, '2014-03-01 00:05:02.000000', 'temperatura', 628.0000, 'ºC'),
	(219148, 119, '2014-03-01 00:05:03.000000', 'temperatura', 363.0000, 'ºC'),
	(219149, 119, '2014-03-01 00:05:04.000000', 'temperatura', 1131.0000, 'ºC'),
	(219150, 119, '2014-03-01 00:05:05.000000', 'temperatura', 969.0000, 'ºC'),
	(219151, 119, '2014-03-01 00:05:06.000000', 'temperatura', 251.0000, 'ºC'),
	(219152, 119, '2014-03-01 00:05:07.000000', 'temperatura', 747.0000, 'ºC'),
	(219153, 119, '2014-03-01 00:05:08.000000', 'temperatura', 584.0000, 'ºC'),
	(219154, 119, '2014-03-01 00:05:09.000000', 'temperatura', 680.0000, 'ºC'),
	(219155, 119, '2014-03-01 00:05:10.000000', 'temperatura', 449.0000, 'ºC'),
	(219156, 119, '2014-03-01 00:05:11.000000', 'temperatura', 204.0000, 'ºC'),
	(219157, 119, '2014-03-01 00:05:12.000000', 'temperatura', 873.0000, 'ºC'),
	(219158, 119, '2014-03-01 00:05:13.000000', 'temperatura', 155.0000, 'ºC'),
	(219159, 119, '2014-03-01 00:05:14.000000', 'temperatura', 555.0000, 'ºC'),
	(219160, 119, '2014-03-01 00:05:15.000000', 'temperatura', 1110.0000, 'ºC'),
	(219161, 119, '2014-03-01 00:05:16.000000', 'temperatura', 285.0000, 'ºC'),
	(219162, 119, '2014-03-01 00:05:17.000000', 'temperatura', 498.0000, 'ºC'),
	(219163, 119, '2014-03-01 00:05:18.000000', 'temperatura', 436.0000, 'ºC'),
	(219164, 119, '2014-03-01 00:05:19.000000', 'temperatura', 686.0000, 'ºC'),
	(219165, 119, '2014-03-01 00:05:20.000000', 'temperatura', 921.0000, 'ºC'),
	(219166, 119, '2014-03-01 00:05:21.000000', 'temperatura', 147.0000, 'ºC'),
	(219167, 119, '2014-03-01 00:05:22.000000', 'temperatura', 373.0000, 'ºC'),
	(219168, 119, '2014-03-01 00:05:23.000000', 'temperatura', 226.0000, 'ºC'),
	(219169, 119, '2014-03-01 00:05:24.000000', 'temperatura', 11.0000, 'ºC'),
	(219170, 119, '2014-03-01 00:05:25.000000', 'temperatura', 576.0000, 'ºC'),
	(219171, 119, '2014-03-01 00:05:26.000000', 'temperatura', 447.0000, 'ºC'),
	(219172, 119, '2014-03-01 00:05:27.000000', 'temperatura', 508.0000, 'ºC'),
	(219173, 119, '2014-03-01 00:05:28.000000', 'temperatura', 1198.0000, 'ºC'),
	(219174, 119, '2014-03-01 00:05:29.000000', 'temperatura', 866.0000, 'ºC'),
	(219175, 119, '2014-03-01 00:05:30.000000', 'temperatura', 739.0000, 'ºC'),
	(219176, 119, '2014-03-01 00:05:31.000000', 'temperatura', 1098.0000, 'ºC'),
	(219177, 119, '2014-03-01 00:05:32.000000', 'temperatura', 872.0000, 'ºC'),
	(219178, 119, '2014-03-01 00:05:33.000000', 'temperatura', 1069.0000, 'ºC'),
	(219179, 119, '2014-03-01 00:05:34.000000', 'temperatura', 326.0000, 'ºC'),
	(219180, 119, '2014-03-01 00:05:35.000000', 'temperatura', 827.0000, 'ºC'),
	(219181, 119, '2014-03-01 00:05:36.000000', 'temperatura', 756.0000, 'ºC'),
	(219182, 119, '2014-03-01 00:05:37.000000', 'temperatura', 99.0000, 'ºC'),
	(219183, 119, '2014-03-01 00:05:38.000000', 'temperatura', 627.0000, 'ºC'),
	(219184, 119, '2014-03-01 00:05:39.000000', 'temperatura', 439.0000, 'ºC'),
	(219185, 119, '2014-03-01 00:05:40.000000', 'temperatura', 316.0000, 'ºC'),
	(219186, 119, '2014-03-01 00:05:41.000000', 'temperatura', 261.0000, 'ºC'),
	(219187, 119, '2014-03-01 00:05:42.000000', 'temperatura', 358.0000, 'ºC'),
	(219188, 119, '2014-03-01 00:05:43.000000', 'temperatura', 1006.0000, 'ºC'),
	(219189, 119, '2014-03-01 00:05:44.000000', 'temperatura', 359.0000, 'ºC'),
	(219190, 119, '2014-03-01 00:05:45.000000', 'temperatura', 1178.0000, 'ºC'),
	(219191, 119, '2014-03-01 00:05:46.000000', 'temperatura', 13.0000, 'ºC'),
	(219192, 119, '2014-03-01 00:05:47.000000', 'temperatura', 133.0000, 'ºC'),
	(219193, 119, '2014-03-01 00:05:48.000000', 'temperatura', 624.0000, 'ºC'),
	(219194, 119, '2014-03-01 00:05:49.000000', 'temperatura', 322.0000, 'ºC'),
	(219195, 119, '2014-03-01 00:05:50.000000', 'temperatura', 940.0000, 'ºC'),
	(219196, 119, '2014-03-01 00:05:51.000000', 'temperatura', 133.0000, 'ºC'),
	(219197, 119, '2014-03-01 00:05:52.000000', 'temperatura', 246.0000, 'ºC'),
	(219198, 119, '2014-03-01 00:05:53.000000', 'temperatura', 831.0000, 'ºC'),
	(219199, 119, '2014-03-01 00:05:54.000000', 'temperatura', 1017.0000, 'ºC'),
	(219200, 119, '2014-03-01 00:05:55.000000', 'temperatura', 191.0000, 'ºC'),
	(219201, 119, '2014-03-01 00:05:56.000000', 'temperatura', 306.0000, 'ºC'),
	(219202, 119, '2014-03-01 00:05:57.000000', 'temperatura', 959.0000, 'ºC'),
	(219203, 119, '2014-03-01 00:05:58.000000', 'temperatura', 276.0000, 'ºC'),
	(219204, 119, '2014-03-01 00:05:59.000000', 'temperatura', 904.0000, 'ºC'),
	(219205, 119, '2014-03-01 00:06:00.000000', 'temperatura', 92.0000, 'ºC'),
	(219206, 119, '2014-03-01 00:06:01.000000', 'temperatura', 148.0000, 'ºC'),
	(219207, 119, '2014-03-01 00:06:02.000000', 'temperatura', 466.0000, 'ºC'),
	(219208, 119, '2014-03-01 00:06:03.000000', 'temperatura', 685.0000, 'ºC'),
	(219209, 119, '2014-03-01 00:06:04.000000', 'temperatura', 826.0000, 'ºC'),
	(219210, 119, '2014-03-01 00:06:05.000000', 'temperatura', 879.0000, 'ºC'),
	(219211, 119, '2014-03-01 00:06:06.000000', 'temperatura', 715.0000, 'ºC'),
	(219212, 119, '2014-03-01 00:06:07.000000', 'temperatura', 938.0000, 'ºC'),
	(219213, 119, '2014-03-01 00:06:08.000000', 'temperatura', 148.0000, 'ºC'),
	(219214, 119, '2014-03-01 00:06:09.000000', 'temperatura', 325.0000, 'ºC'),
	(219215, 119, '2014-03-01 00:06:10.000000', 'temperatura', 1180.0000, 'ºC'),
	(219216, 119, '2014-03-01 00:06:11.000000', 'temperatura', 125.0000, 'ºC'),
	(219217, 119, '2014-03-01 00:06:12.000000', 'temperatura', 688.0000, 'ºC'),
	(219218, 119, '2014-03-01 00:06:13.000000', 'temperatura', 666.0000, 'ºC'),
	(219219, 119, '2014-03-01 00:06:14.000000', 'temperatura', 67.0000, 'ºC'),
	(219220, 119, '2014-03-01 00:06:15.000000', 'temperatura', 737.0000, 'ºC'),
	(219221, 119, '2014-03-01 00:06:16.000000', 'temperatura', 1083.0000, 'ºC'),
	(219222, 119, '2014-03-01 00:06:17.000000', 'temperatura', 807.0000, 'ºC'),
	(219223, 119, '2014-03-01 00:06:18.000000', 'temperatura', 785.0000, 'ºC'),
	(219224, 119, '2014-03-01 00:06:19.000000', 'temperatura', 306.0000, 'ºC'),
	(219225, 119, '2014-03-01 00:06:20.000000', 'temperatura', 375.0000, 'ºC'),
	(219226, 119, '2014-03-01 00:06:21.000000', 'temperatura', 959.0000, 'ºC'),
	(219227, 119, '2014-03-01 00:06:22.000000', 'temperatura', 71.0000, 'ºC'),
	(219228, 119, '2014-03-01 00:06:23.000000', 'temperatura', 1076.0000, 'ºC'),
	(219229, 119, '2014-03-01 00:06:24.000000', 'temperatura', 368.0000, 'ºC'),
	(219230, 119, '2014-03-01 00:06:25.000000', 'temperatura', 1013.0000, 'ºC'),
	(219231, 119, '2014-03-01 00:06:26.000000', 'temperatura', 359.0000, 'ºC'),
	(219232, 119, '2014-03-01 00:06:27.000000', 'temperatura', 1160.0000, 'ºC'),
	(219233, 119, '2014-03-01 00:06:28.000000', 'temperatura', 1121.0000, 'ºC'),
	(219234, 119, '2014-03-01 00:06:29.000000', 'temperatura', 925.0000, 'ºC'),
	(219235, 119, '2014-03-01 00:06:30.000000', 'temperatura', 63.0000, 'ºC'),
	(219236, 119, '2014-03-01 00:06:31.000000', 'temperatura', 1141.0000, 'ºC'),
	(219237, 119, '2014-03-01 00:06:32.000000', 'temperatura', 716.0000, 'ºC'),
	(219238, 119, '2014-03-01 00:06:33.000000', 'temperatura', 157.0000, 'ºC'),
	(219239, 119, '2014-03-01 00:06:34.000000', 'temperatura', 1040.0000, 'ºC'),
	(219240, 119, '2014-03-01 00:06:35.000000', 'temperatura', 1128.0000, 'ºC'),
	(219241, 119, '2014-03-01 00:06:36.000000', 'temperatura', 121.0000, 'ºC'),
	(219242, 119, '2014-03-01 00:06:37.000000', 'temperatura', 822.0000, 'ºC'),
	(219243, 119, '2014-03-01 00:06:38.000000', 'temperatura', 149.0000, 'ºC'),
	(219244, 119, '2014-03-01 00:06:39.000000', 'temperatura', 677.0000, 'ºC'),
	(219245, 119, '2014-03-01 00:06:40.000000', 'temperatura', 540.0000, 'ºC'),
	(219246, 119, '2014-03-01 00:06:41.000000', 'temperatura', 667.0000, 'ºC'),
	(219247, 119, '2014-03-01 00:06:42.000000', 'temperatura', 517.0000, 'ºC'),
	(219248, 119, '2014-03-01 00:06:43.000000', 'temperatura', 584.0000, 'ºC'),
	(219249, 119, '2014-03-01 00:06:44.000000', 'temperatura', 171.0000, 'ºC'),
	(219250, 119, '2014-03-01 00:06:45.000000', 'temperatura', 301.0000, 'ºC'),
	(219251, 119, '2014-03-01 00:06:46.000000', 'temperatura', 994.0000, 'ºC'),
	(219252, 119, '2014-03-01 00:06:47.000000', 'temperatura', 467.0000, 'ºC'),
	(219253, 119, '2014-03-01 00:06:48.000000', 'temperatura', 556.0000, 'ºC'),
	(219254, 119, '2014-03-01 00:06:49.000000', 'temperatura', 176.0000, 'ºC'),
	(219255, 119, '2014-03-01 00:06:50.000000', 'temperatura', 416.0000, 'ºC'),
	(219256, 119, '2014-03-01 00:06:51.000000', 'temperatura', 349.0000, 'ºC'),
	(219257, 119, '2014-03-01 00:06:52.000000', 'temperatura', 499.0000, 'ºC'),
	(219258, 119, '2014-03-01 00:06:53.000000', 'temperatura', 249.0000, 'ºC'),
	(219259, 119, '2014-03-01 00:06:54.000000', 'temperatura', 946.0000, 'ºC'),
	(219260, 119, '2014-03-01 00:06:55.000000', 'temperatura', 385.0000, 'ºC'),
	(219261, 119, '2014-03-01 00:06:56.000000', 'temperatura', 289.0000, 'ºC'),
	(219262, 119, '2014-03-01 00:06:57.000000', 'temperatura', 289.0000, 'ºC'),
	(219263, 119, '2014-03-01 00:06:58.000000', 'temperatura', 578.0000, 'ºC'),
	(219264, 119, '2014-03-01 00:06:59.000000', 'temperatura', 823.0000, 'ºC'),
	(219265, 119, '2014-03-01 00:07:00.000000', 'temperatura', 1181.0000, 'ºC'),
	(219266, 119, '2014-03-01 00:07:01.000000', 'temperatura', 1036.0000, 'ºC'),
	(219267, 119, '2014-03-01 00:07:02.000000', 'temperatura', 438.0000, 'ºC'),
	(219268, 119, '2014-03-01 00:07:03.000000', 'temperatura', 283.0000, 'ºC'),
	(219269, 119, '2014-03-01 00:07:04.000000', 'temperatura', 103.0000, 'ºC'),
	(219270, 119, '2014-03-01 00:07:05.000000', 'temperatura', 866.0000, 'ºC'),
	(219271, 119, '2014-03-01 00:07:06.000000', 'temperatura', 422.0000, 'ºC'),
	(219272, 119, '2014-03-01 00:07:07.000000', 'temperatura', 711.0000, 'ºC'),
	(219273, 119, '2014-03-01 00:07:08.000000', 'temperatura', 1092.0000, 'ºC'),
	(219274, 119, '2014-03-01 00:07:09.000000', 'temperatura', 925.0000, 'ºC'),
	(219275, 119, '2014-03-01 00:07:10.000000', 'temperatura', 151.0000, 'ºC'),
	(219276, 119, '2014-03-01 00:07:11.000000', 'temperatura', 378.0000, 'ºC'),
	(219277, 119, '2014-03-01 00:07:12.000000', 'temperatura', 240.0000, 'ºC'),
	(219278, 119, '2014-03-01 00:07:13.000000', 'temperatura', 67.0000, 'ºC'),
	(219279, 119, '2014-03-01 00:07:14.000000', 'temperatura', 817.0000, 'ºC'),
	(219280, 119, '2014-03-01 00:07:15.000000', 'temperatura', 281.0000, 'ºC'),
	(219281, 119, '2014-03-01 00:07:16.000000', 'temperatura', 156.0000, 'ºC'),
	(219282, 119, '2014-03-01 00:07:17.000000', 'temperatura', 1137.0000, 'ºC'),
	(219283, 119, '2014-03-01 00:07:18.000000', 'temperatura', 417.0000, 'ºC'),
	(219284, 119, '2014-03-01 00:07:19.000000', 'temperatura', 1076.0000, 'ºC'),
	(219285, 119, '2014-03-01 00:07:20.000000', 'temperatura', 529.0000, 'ºC'),
	(219286, 119, '2014-03-01 00:07:21.000000', 'temperatura', 616.0000, 'ºC'),
	(219287, 119, '2014-03-01 00:07:22.000000', 'temperatura', 293.0000, 'ºC'),
	(219288, 119, '2014-03-01 00:07:23.000000', 'temperatura', 819.0000, 'ºC'),
	(219289, 119, '2014-03-01 00:07:24.000000', 'temperatura', 815.0000, 'ºC'),
	(219290, 119, '2014-03-01 00:07:25.000000', 'temperatura', 418.0000, 'ºC'),
	(219291, 119, '2014-03-01 00:07:26.000000', 'temperatura', 847.0000, 'ºC'),
	(219292, 119, '2014-03-01 00:07:27.000000', 'temperatura', 582.0000, 'ºC'),
	(219293, 119, '2014-03-01 00:07:28.000000', 'temperatura', 371.0000, 'ºC'),
	(219294, 119, '2014-03-01 00:07:29.000000', 'temperatura', 106.0000, 'ºC'),
	(219295, 119, '2014-03-01 00:07:30.000000', 'temperatura', 620.0000, 'ºC'),
	(219296, 119, '2014-03-01 00:07:31.000000', 'temperatura', 380.0000, 'ºC'),
	(219297, 119, '2014-03-01 00:07:32.000000', 'temperatura', 41.0000, 'ºC'),
	(219298, 119, '2014-03-01 00:07:33.000000', 'temperatura', 267.0000, 'ºC'),
	(219299, 119, '2014-03-01 00:07:34.000000', 'temperatura', 14.0000, 'ºC'),
	(219300, 119, '2014-03-01 00:07:35.000000', 'temperatura', 466.0000, 'ºC'),
	(219301, 119, '2014-03-01 00:07:36.000000', 'temperatura', 1089.0000, 'ºC'),
	(219302, 119, '2014-03-01 00:07:37.000000', 'temperatura', 450.0000, 'ºC'),
	(219303, 119, '2014-03-01 00:07:38.000000', 'temperatura', 182.0000, 'ºC'),
	(219304, 119, '2014-03-01 00:07:39.000000', 'temperatura', 762.0000, 'ºC'),
	(219305, 119, '2014-03-01 00:07:40.000000', 'temperatura', 863.0000, 'ºC'),
	(219306, 119, '2014-03-01 00:07:41.000000', 'temperatura', 828.0000, 'ºC'),
	(219307, 119, '2014-03-01 00:07:42.000000', 'temperatura', 355.0000, 'ºC'),
	(219308, 119, '2014-03-01 00:07:43.000000', 'temperatura', 488.0000, 'ºC'),
	(219309, 119, '2014-03-01 00:07:44.000000', 'temperatura', 178.0000, 'ºC'),
	(219310, 119, '2014-03-01 00:07:45.000000', 'temperatura', 624.0000, 'ºC'),
	(219311, 119, '2014-03-01 00:07:46.000000', 'temperatura', 188.0000, 'ºC'),
	(219312, 119, '2014-03-01 00:07:47.000000', 'temperatura', 269.0000, 'ºC'),
	(219313, 119, '2014-03-01 00:07:48.000000', 'temperatura', 780.0000, 'ºC'),
	(219314, 119, '2014-03-01 00:07:49.000000', 'temperatura', 693.0000, 'ºC'),
	(219315, 119, '2014-03-01 00:07:50.000000', 'temperatura', 1125.0000, 'ºC'),
	(219316, 119, '2014-03-01 00:07:51.000000', 'temperatura', 1149.0000, 'ºC'),
	(219317, 119, '2014-03-01 00:07:52.000000', 'temperatura', 1168.0000, 'ºC'),
	(219318, 119, '2014-03-01 00:07:53.000000', 'temperatura', 1196.0000, 'ºC'),
	(219319, 119, '2014-03-01 00:07:54.000000', 'temperatura', 75.0000, 'ºC'),
	(219320, 119, '2014-03-01 00:07:55.000000', 'temperatura', 386.0000, 'ºC'),
	(219321, 119, '2014-03-01 00:07:56.000000', 'temperatura', 506.0000, 'ºC'),
	(219322, 119, '2014-03-01 00:07:57.000000', 'temperatura', 175.0000, 'ºC'),
	(219323, 119, '2014-03-01 00:07:58.000000', 'temperatura', 554.0000, 'ºC'),
	(219324, 119, '2014-03-01 00:07:59.000000', 'temperatura', 1049.0000, 'ºC'),
	(219325, 119, '2014-03-01 00:08:00.000000', 'temperatura', 1182.0000, 'ºC'),
	(219326, 119, '2014-03-01 00:08:01.000000', 'temperatura', 363.0000, 'ºC'),
	(219327, 119, '2014-03-01 00:08:02.000000', 'temperatura', 668.0000, 'ºC'),
	(219328, 119, '2014-03-01 00:08:03.000000', 'temperatura', 1055.0000, 'ºC'),
	(219329, 119, '2014-03-01 00:08:04.000000', 'temperatura', 869.0000, 'ºC'),
	(219330, 119, '2014-03-01 00:08:05.000000', 'temperatura', 1182.0000, 'ºC'),
	(219331, 119, '2014-03-01 00:08:06.000000', 'temperatura', 904.0000, 'ºC'),
	(219332, 119, '2014-03-01 00:08:07.000000', 'temperatura', 974.0000, 'ºC'),
	(219333, 119, '2014-03-01 00:08:08.000000', 'temperatura', 959.0000, 'ºC'),
	(219334, 119, '2014-03-01 00:08:09.000000', 'temperatura', 673.0000, 'ºC'),
	(219335, 119, '2014-03-01 00:08:10.000000', 'temperatura', 489.0000, 'ºC'),
	(219336, 119, '2014-03-01 00:08:11.000000', 'temperatura', 427.0000, 'ºC'),
	(219337, 119, '2014-03-01 00:08:12.000000', 'temperatura', 667.0000, 'ºC'),
	(219338, 119, '2014-03-01 00:08:13.000000', 'temperatura', 855.0000, 'ºC'),
	(219339, 119, '2014-03-01 00:08:14.000000', 'temperatura', 1075.0000, 'ºC'),
	(219340, 119, '2014-03-01 00:08:15.000000', 'temperatura', 411.0000, 'ºC'),
	(219341, 119, '2014-03-01 00:08:16.000000', 'temperatura', 29.0000, 'ºC'),
	(219342, 119, '2014-03-01 00:08:17.000000', 'temperatura', 112.0000, 'ºC'),
	(219343, 119, '2014-03-01 00:08:18.000000', 'temperatura', 472.0000, 'ºC'),
	(219344, 119, '2014-03-01 00:08:19.000000', 'temperatura', 827.0000, 'ºC'),
	(219345, 119, '2014-03-01 00:08:20.000000', 'temperatura', 321.0000, 'ºC'),
	(219346, 119, '2014-03-01 00:08:21.000000', 'temperatura', 321.0000, 'ºC'),
	(219347, 119, '2014-03-01 00:08:22.000000', 'temperatura', 645.0000, 'ºC'),
	(219348, 119, '2014-03-01 00:08:23.000000', 'temperatura', 1064.0000, 'ºC'),
	(219349, 119, '2014-03-01 00:08:24.000000', 'temperatura', 982.0000, 'ºC'),
	(219350, 119, '2014-03-01 00:08:25.000000', 'temperatura', 521.0000, 'ºC'),
	(219351, 119, '2014-03-01 00:08:26.000000', 'temperatura', 858.0000, 'ºC'),
	(219352, 119, '2014-03-01 00:08:27.000000', 'temperatura', 327.0000, 'ºC'),
	(219353, 119, '2014-03-01 00:08:28.000000', 'temperatura', 261.0000, 'ºC'),
	(219354, 119, '2014-03-01 00:08:29.000000', 'temperatura', 325.0000, 'ºC'),
	(219355, 119, '2014-03-01 00:08:30.000000', 'temperatura', 843.0000, 'ºC'),
	(219356, 119, '2014-03-01 00:08:31.000000', 'temperatura', 841.0000, 'ºC'),
	(219357, 119, '2014-03-01 00:08:32.000000', 'temperatura', 476.0000, 'ºC'),
	(219358, 119, '2014-03-01 00:08:33.000000', 'temperatura', 1056.0000, 'ºC'),
	(219359, 119, '2014-03-01 00:08:34.000000', 'temperatura', 254.0000, 'ºC'),
	(219360, 119, '2014-03-01 00:08:35.000000', 'temperatura', 500.0000, 'ºC'),
	(219361, 119, '2014-03-01 00:08:36.000000', 'temperatura', 541.0000, 'ºC'),
	(219362, 119, '2014-03-01 00:08:37.000000', 'temperatura', 6.0000, 'ºC'),
	(219363, 119, '2014-03-01 00:08:38.000000', 'temperatura', 809.0000, 'ºC'),
	(219364, 119, '2014-03-01 00:08:39.000000', 'temperatura', 425.0000, 'ºC'),
	(219365, 119, '2014-03-01 00:08:40.000000', 'temperatura', 899.0000, 'ºC'),
	(219366, 119, '2014-03-01 00:08:41.000000', 'temperatura', 819.0000, 'ºC'),
	(219367, 119, '2014-03-01 00:08:42.000000', 'temperatura', 198.0000, 'ºC'),
	(219368, 119, '2014-03-01 00:08:43.000000', 'temperatura', 934.0000, 'ºC'),
	(219369, 119, '2014-03-01 00:08:44.000000', 'temperatura', 476.0000, 'ºC'),
	(219370, 119, '2014-03-01 00:08:45.000000', 'temperatura', 780.0000, 'ºC'),
	(219371, 119, '2014-03-01 00:08:46.000000', 'temperatura', 70.0000, 'ºC'),
	(219372, 119, '2014-03-01 00:08:47.000000', 'temperatura', 412.0000, 'ºC'),
	(219373, 119, '2014-03-01 00:08:48.000000', 'temperatura', 651.0000, 'ºC'),
	(219374, 119, '2014-03-01 00:08:49.000000', 'temperatura', 821.0000, 'ºC'),
	(219375, 119, '2014-03-01 00:08:50.000000', 'temperatura', 950.0000, 'ºC'),
	(219376, 119, '2014-03-01 00:08:51.000000', 'temperatura', 1090.0000, 'ºC'),
	(219377, 119, '2014-03-01 00:08:52.000000', 'temperatura', 198.0000, 'ºC'),
	(219378, 119, '2014-03-01 00:08:53.000000', 'temperatura', 122.0000, 'ºC'),
	(219379, 119, '2014-03-01 00:08:54.000000', 'temperatura', 17.0000, 'ºC'),
	(219380, 119, '2014-03-01 00:08:55.000000', 'temperatura', 921.0000, 'ºC'),
	(219381, 119, '2014-03-01 00:08:56.000000', 'temperatura', 951.0000, 'ºC'),
	(219382, 119, '2014-03-01 00:08:57.000000', 'temperatura', 795.0000, 'ºC'),
	(219383, 119, '2014-03-01 00:08:58.000000', 'temperatura', 1122.0000, 'ºC'),
	(219384, 119, '2014-03-01 00:08:59.000000', 'temperatura', 824.0000, 'ºC'),
	(219385, 119, '2014-03-01 00:09:00.000000', 'temperatura', 755.0000, 'ºC'),
	(219386, 119, '2014-03-01 00:09:01.000000', 'temperatura', 104.0000, 'ºC'),
	(219387, 119, '2014-03-01 00:09:02.000000', 'temperatura', 657.0000, 'ºC'),
	(219388, 119, '2014-03-01 00:09:03.000000', 'temperatura', 571.0000, 'ºC'),
	(219389, 119, '2014-03-01 00:09:04.000000', 'temperatura', 884.0000, 'ºC'),
	(219390, 119, '2014-03-01 00:09:05.000000', 'temperatura', 307.0000, 'ºC'),
	(219391, 119, '2014-03-01 00:09:06.000000', 'temperatura', 84.0000, 'ºC'),
	(219392, 119, '2014-03-01 00:09:07.000000', 'temperatura', 701.0000, 'ºC'),
	(219393, 119, '2014-03-01 00:09:08.000000', 'temperatura', 851.0000, 'ºC'),
	(219394, 119, '2014-03-01 00:09:09.000000', 'temperatura', 954.0000, 'ºC'),
	(219395, 119, '2014-03-01 00:09:10.000000', 'temperatura', 1016.0000, 'ºC'),
	(219396, 119, '2014-03-01 00:09:11.000000', 'temperatura', 1019.0000, 'ºC'),
	(219397, 119, '2014-03-01 00:09:12.000000', 'temperatura', 846.0000, 'ºC'),
	(219398, 119, '2014-03-01 00:09:13.000000', 'temperatura', 1174.0000, 'ºC'),
	(219399, 119, '2014-03-01 00:09:14.000000', 'temperatura', 932.0000, 'ºC'),
	(219400, 119, '2014-03-01 00:09:15.000000', 'temperatura', 1139.0000, 'ºC'),
	(219401, 119, '2014-03-01 00:09:16.000000', 'temperatura', 501.0000, 'ºC'),
	(219402, 119, '2014-03-01 00:09:17.000000', 'temperatura', 288.0000, 'ºC'),
	(219403, 119, '2014-03-01 00:09:18.000000', 'temperatura', 1137.0000, 'ºC'),
	(219404, 119, '2014-03-01 00:09:19.000000', 'temperatura', 21.0000, 'ºC'),
	(219405, 119, '2014-03-01 00:09:20.000000', 'temperatura', 297.0000, 'ºC'),
	(219406, 119, '2014-03-01 00:09:21.000000', 'temperatura', 220.0000, 'ºC'),
	(219407, 119, '2014-03-01 00:09:22.000000', 'temperatura', 211.0000, 'ºC'),
	(219408, 119, '2014-03-01 00:09:23.000000', 'temperatura', 397.0000, 'ºC'),
	(219409, 119, '2014-03-01 00:09:24.000000', 'temperatura', 149.0000, 'ºC'),
	(219410, 119, '2014-03-01 00:09:25.000000', 'temperatura', 757.0000, 'ºC'),
	(219411, 119, '2014-03-01 00:09:26.000000', 'temperatura', 940.0000, 'ºC'),
	(219412, 119, '2014-03-01 00:09:27.000000', 'temperatura', 27.0000, 'ºC'),
	(219413, 119, '2014-03-01 00:09:28.000000', 'temperatura', 916.0000, 'ºC'),
	(219414, 119, '2014-03-01 00:09:29.000000', 'temperatura', 899.0000, 'ºC'),
	(219415, 119, '2014-03-01 00:09:30.000000', 'temperatura', 546.0000, 'ºC'),
	(219416, 119, '2014-03-01 00:09:31.000000', 'temperatura', 35.0000, 'ºC'),
	(219417, 119, '2014-03-01 00:09:32.000000', 'temperatura', 936.0000, 'ºC'),
	(219418, 119, '2014-03-01 00:09:33.000000', 'temperatura', 978.0000, 'ºC'),
	(219419, 119, '2014-03-01 00:09:34.000000', 'temperatura', 882.0000, 'ºC'),
	(219420, 119, '2014-03-01 00:09:35.000000', 'temperatura', 275.0000, 'ºC'),
	(219421, 119, '2014-03-01 00:09:36.000000', 'temperatura', 1128.0000, 'ºC'),
	(219422, 119, '2014-03-01 00:09:37.000000', 'temperatura', 18.0000, 'ºC'),
	(219423, 119, '2014-03-01 00:09:38.000000', 'temperatura', 308.0000, 'ºC'),
	(219424, 119, '2014-03-01 00:09:39.000000', 'temperatura', 284.0000, 'ºC'),
	(219425, 119, '2014-03-01 00:09:40.000000', 'temperatura', 496.0000, 'ºC'),
	(219426, 119, '2014-03-01 00:09:41.000000', 'temperatura', 430.0000, 'ºC'),
	(219427, 119, '2014-03-01 00:09:42.000000', 'temperatura', 660.0000, 'ºC'),
	(219428, 119, '2014-03-01 00:09:43.000000', 'temperatura', 813.0000, 'ºC'),
	(219429, 119, '2014-03-01 00:09:44.000000', 'temperatura', 883.0000, 'ºC'),
	(219430, 119, '2014-03-01 00:09:45.000000', 'temperatura', 778.0000, 'ºC'),
	(219431, 119, '2014-03-01 00:09:46.000000', 'temperatura', 42.0000, 'ºC'),
	(219432, 119, '2014-03-01 00:09:47.000000', 'temperatura', 277.0000, 'ºC'),
	(219433, 119, '2014-03-01 00:09:48.000000', 'temperatura', 60.0000, 'ºC'),
	(219434, 119, '2014-03-01 00:09:49.000000', 'temperatura', 670.0000, 'ºC'),
	(219435, 119, '2014-03-01 00:09:50.000000', 'temperatura', 768.0000, 'ºC'),
	(219436, 119, '2014-03-01 00:09:51.000000', 'temperatura', 633.0000, 'ºC'),
	(219437, 119, '2014-03-01 00:09:52.000000', 'temperatura', 860.0000, 'ºC'),
	(219438, 119, '2014-03-01 00:09:53.000000', 'temperatura', 3.0000, 'ºC'),
	(219439, 119, '2014-03-01 00:09:54.000000', 'temperatura', 1034.0000, 'ºC'),
	(219440, 119, '2014-03-01 00:09:55.000000', 'temperatura', 362.0000, 'ºC'),
	(219441, 119, '2014-03-01 00:09:56.000000', 'temperatura', 1107.0000, 'ºC'),
	(219442, 119, '2014-03-01 00:09:57.000000', 'temperatura', 850.0000, 'ºC'),
	(219443, 119, '2014-03-01 00:09:58.000000', 'temperatura', 932.0000, 'ºC'),
	(219444, 119, '2014-03-01 00:09:59.000000', 'temperatura', 908.0000, 'ºC'),
	(219445, 119, '2014-03-01 00:10:00.000000', 'temperatura', 543.0000, 'ºC'),
	(219446, 119, '2014-03-01 00:10:01.000000', 'temperatura', 1194.0000, 'ºC'),
	(219447, 119, '2014-03-01 00:10:02.000000', 'temperatura', 743.0000, 'ºC'),
	(219448, 119, '2014-03-01 00:10:03.000000', 'temperatura', 132.0000, 'ºC'),
	(219449, 119, '2014-03-01 00:10:04.000000', 'temperatura', 829.0000, 'ºC'),
	(219450, 119, '2014-03-01 00:10:05.000000', 'temperatura', 153.0000, 'ºC'),
	(219451, 119, '2014-03-01 00:10:06.000000', 'temperatura', 678.0000, 'ºC'),
	(219452, 119, '2014-03-01 00:10:07.000000', 'temperatura', 531.0000, 'ºC'),
	(219453, 119, '2014-03-01 00:10:08.000000', 'temperatura', 620.0000, 'ºC'),
	(219454, 119, '2014-03-01 00:10:09.000000', 'temperatura', 308.0000, 'ºC'),
	(219455, 119, '2014-03-01 00:10:10.000000', 'temperatura', 879.0000, 'ºC'),
	(219456, 119, '2014-03-01 00:10:11.000000', 'temperatura', 1072.0000, 'ºC'),
	(219457, 119, '2014-03-01 00:10:12.000000', 'temperatura', 324.0000, 'ºC'),
	(219458, 119, '2014-03-01 00:10:13.000000', 'temperatura', 803.0000, 'ºC'),
	(219459, 119, '2014-03-01 00:10:14.000000', 'temperatura', 645.0000, 'ºC'),
	(219460, 119, '2014-03-01 00:10:15.000000', 'temperatura', 818.0000, 'ºC'),
	(219461, 119, '2014-03-01 00:10:16.000000', 'temperatura', 953.0000, 'ºC'),
	(219462, 119, '2014-03-01 00:10:17.000000', 'temperatura', 1114.0000, 'ºC'),
	(219463, 119, '2014-03-01 00:10:18.000000', 'temperatura', 312.0000, 'ºC'),
	(219464, 119, '2014-03-01 00:10:19.000000', 'temperatura', 618.0000, 'ºC'),
	(219465, 119, '2014-03-01 00:10:20.000000', 'temperatura', 952.0000, 'ºC'),
	(219466, 119, '2014-03-01 00:10:21.000000', 'temperatura', 508.0000, 'ºC'),
	(219467, 119, '2014-03-01 00:10:22.000000', 'temperatura', 884.0000, 'ºC'),
	(219468, 119, '2014-03-01 00:10:23.000000', 'temperatura', 498.0000, 'ºC'),
	(219469, 119, '2014-03-01 00:10:24.000000', 'temperatura', 1036.0000, 'ºC'),
	(219470, 119, '2014-03-01 00:10:25.000000', 'temperatura', 87.0000, 'ºC'),
	(219471, 119, '2014-03-01 00:10:26.000000', 'temperatura', 929.0000, 'ºC'),
	(219472, 119, '2014-03-01 00:10:27.000000', 'temperatura', 783.0000, 'ºC'),
	(219473, 119, '2014-03-01 00:10:28.000000', 'temperatura', 1129.0000, 'ºC'),
	(219474, 119, '2014-03-01 00:10:29.000000', 'temperatura', 894.0000, 'ºC'),
	(219475, 119, '2014-03-01 00:10:30.000000', 'temperatura', 1087.0000, 'ºC'),
	(219476, 119, '2014-03-01 00:10:31.000000', 'temperatura', 352.0000, 'ºC'),
	(219477, 119, '2014-03-01 00:10:32.000000', 'temperatura', 899.0000, 'ºC'),
	(219478, 119, '2014-03-01 00:10:33.000000', 'temperatura', 1042.0000, 'ºC'),
	(219479, 119, '2014-03-01 00:10:34.000000', 'temperatura', 111.0000, 'ºC'),
	(219480, 119, '2014-03-01 00:10:35.000000', 'temperatura', 1029.0000, 'ºC'),
	(219481, 119, '2014-03-01 00:10:36.000000', 'temperatura', 15.0000, 'ºC'),
	(219482, 119, '2014-03-01 00:10:37.000000', 'temperatura', 585.0000, 'ºC'),
	(219483, 119, '2014-03-01 00:10:38.000000', 'temperatura', 484.0000, 'ºC'),
	(219484, 119, '2014-03-01 00:10:39.000000', 'temperatura', 664.0000, 'ºC'),
	(219485, 119, '2014-03-01 00:10:40.000000', 'temperatura', 668.0000, 'ºC'),
	(219486, 119, '2014-03-01 00:10:41.000000', 'temperatura', 148.0000, 'ºC'),
	(219487, 119, '2014-03-01 00:10:42.000000', 'temperatura', 1137.0000, 'ºC'),
	(219488, 119, '2014-03-01 00:10:43.000000', 'temperatura', 443.0000, 'ºC'),
	(219489, 119, '2014-03-01 00:10:44.000000', 'temperatura', 2.0000, 'ºC'),
	(219490, 119, '2014-03-01 00:10:45.000000', 'temperatura', 1081.0000, 'ºC'),
	(219491, 119, '2014-03-01 00:10:46.000000', 'temperatura', 600.0000, 'ºC'),
	(219492, 119, '2014-03-01 00:10:47.000000', 'temperatura', 958.0000, 'ºC'),
	(219493, 119, '2014-03-01 00:10:48.000000', 'temperatura', 588.0000, 'ºC'),
	(219494, 119, '2014-03-01 00:10:49.000000', 'temperatura', 70.0000, 'ºC'),
	(219495, 119, '2014-03-01 00:10:50.000000', 'temperatura', 985.0000, 'ºC'),
	(219496, 119, '2014-03-01 00:10:51.000000', 'temperatura', 1115.0000, 'ºC'),
	(219497, 119, '2014-03-01 00:10:52.000000', 'temperatura', 222.0000, 'ºC'),
	(219498, 119, '2014-03-01 00:10:53.000000', 'temperatura', 165.0000, 'ºC'),
	(219499, 119, '2014-03-01 00:10:54.000000', 'temperatura', 158.0000, 'ºC'),
	(219500, 119, '2014-03-01 00:10:55.000000', 'temperatura', 296.0000, 'ºC'),
	(219501, 119, '2014-03-01 00:10:56.000000', 'temperatura', 1008.0000, 'ºC'),
	(219502, 119, '2014-03-01 00:10:57.000000', 'temperatura', 552.0000, 'ºC'),
	(219503, 119, '2014-03-01 00:10:58.000000', 'temperatura', 936.0000, 'ºC'),
	(219504, 119, '2014-03-01 00:10:59.000000', 'temperatura', 623.0000, 'ºC'),
	(219505, 119, '2014-03-01 00:11:00.000000', 'temperatura', 309.0000, 'ºC'),
	(219506, 119, '2014-03-01 00:11:01.000000', 'temperatura', 876.0000, 'ºC'),
	(219507, 119, '2014-03-01 00:11:02.000000', 'temperatura', 1052.0000, 'ºC'),
	(219508, 119, '2014-03-01 00:11:03.000000', 'temperatura', 234.0000, 'ºC'),
	(219509, 119, '2014-03-01 00:11:04.000000', 'temperatura', 413.0000, 'ºC'),
	(219510, 119, '2014-03-01 00:11:05.000000', 'temperatura', 163.0000, 'ºC'),
	(219511, 119, '2014-03-01 00:11:06.000000', 'temperatura', 776.0000, 'ºC'),
	(219512, 119, '2014-03-01 00:11:07.000000', 'temperatura', 991.0000, 'ºC'),
	(219513, 119, '2014-03-01 00:11:08.000000', 'temperatura', 229.0000, 'ºC'),
	(219514, 119, '2014-03-01 00:11:09.000000', 'temperatura', 570.0000, 'ºC'),
	(219515, 119, '2014-03-01 00:11:10.000000', 'temperatura', 966.0000, 'ºC'),
	(219516, 119, '2014-03-01 00:11:11.000000', 'temperatura', 722.0000, 'ºC'),
	(219517, 119, '2014-03-01 00:11:12.000000', 'temperatura', 709.0000, 'ºC'),
	(219518, 119, '2014-03-01 00:11:13.000000', 'temperatura', 181.0000, 'ºC'),
	(219519, 119, '2014-03-01 00:11:14.000000', 'temperatura', 1177.0000, 'ºC'),
	(219520, 119, '2014-03-01 00:11:15.000000', 'temperatura', 543.0000, 'ºC'),
	(219521, 119, '2014-03-01 00:11:16.000000', 'temperatura', 386.0000, 'ºC'),
	(219522, 119, '2014-03-01 00:11:17.000000', 'temperatura', 301.0000, 'ºC'),
	(219523, 119, '2014-03-01 00:11:18.000000', 'temperatura', 348.0000, 'ºC'),
	(219524, 119, '2014-03-01 00:11:19.000000', 'temperatura', 838.0000, 'ºC'),
	(219525, 119, '2014-03-01 00:11:20.000000', 'temperatura', 745.0000, 'ºC'),
	(219526, 119, '2014-03-01 00:11:21.000000', 'temperatura', 11.0000, 'ºC'),
	(219527, 119, '2014-03-01 00:11:22.000000', 'temperatura', 223.0000, 'ºC'),
	(219528, 119, '2014-03-01 00:11:23.000000', 'temperatura', 1082.0000, 'ºC'),
	(219529, 119, '2014-03-01 00:11:24.000000', 'temperatura', 1143.0000, 'ºC'),
	(219530, 119, '2014-03-01 00:11:25.000000', 'temperatura', 66.0000, 'ºC'),
	(219531, 119, '2014-03-01 00:11:26.000000', 'temperatura', 505.0000, 'ºC'),
	(219532, 119, '2014-03-01 00:11:27.000000', 'temperatura', 1125.0000, 'ºC'),
	(219533, 119, '2014-03-01 00:11:28.000000', 'temperatura', 510.0000, 'ºC'),
	(219534, 119, '2014-03-01 00:11:29.000000', 'temperatura', 378.0000, 'ºC'),
	(219535, 119, '2014-03-01 00:11:30.000000', 'temperatura', 361.0000, 'ºC'),
	(219536, 119, '2014-03-01 00:11:31.000000', 'temperatura', 671.0000, 'ºC'),
	(219537, 119, '2014-03-01 00:11:32.000000', 'temperatura', 1073.0000, 'ºC'),
	(219538, 119, '2014-03-01 00:11:33.000000', 'temperatura', 954.0000, 'ºC'),
	(219539, 119, '2014-03-01 00:11:34.000000', 'temperatura', 350.0000, 'ºC'),
	(219540, 119, '2014-03-01 00:11:35.000000', 'temperatura', 88.0000, 'ºC'),
	(219541, 119, '2014-03-01 00:11:36.000000', 'temperatura', 590.0000, 'ºC'),
	(219542, 119, '2014-03-01 00:11:37.000000', 'temperatura', 287.0000, 'ºC'),
	(219543, 119, '2014-03-01 00:11:38.000000', 'temperatura', 866.0000, 'ºC'),
	(219544, 119, '2014-03-01 00:11:39.000000', 'temperatura', 1070.0000, 'ºC'),
	(219545, 119, '2014-03-01 00:11:40.000000', 'temperatura', 354.0000, 'ºC'),
	(219546, 119, '2014-03-01 00:11:41.000000', 'temperatura', 959.0000, 'ºC'),
	(219547, 119, '2014-03-01 00:11:42.000000', 'temperatura', 133.0000, 'ºC'),
	(219548, 119, '2014-03-01 00:11:43.000000', 'temperatura', 189.0000, 'ºC'),
	(219549, 119, '2014-03-01 00:11:44.000000', 'temperatura', 548.0000, 'ºC'),
	(219550, 119, '2014-03-01 00:11:45.000000', 'temperatura', 972.0000, 'ºC'),
	(219551, 119, '2014-03-01 00:11:46.000000', 'temperatura', 816.0000, 'ºC'),
	(219552, 119, '2014-03-01 00:11:47.000000', 'temperatura', 1166.0000, 'ºC'),
	(219553, 119, '2014-03-01 00:11:48.000000', 'temperatura', 982.0000, 'ºC'),
	(219554, 119, '2014-03-01 00:11:49.000000', 'temperatura', 212.0000, 'ºC'),
	(219555, 119, '2014-03-01 00:11:50.000000', 'temperatura', 513.0000, 'ºC'),
	(219556, 119, '2014-03-01 00:11:51.000000', 'temperatura', 731.0000, 'ºC'),
	(219557, 119, '2014-03-01 00:11:52.000000', 'temperatura', 916.0000, 'ºC'),
	(219558, 119, '2014-03-01 00:11:53.000000', 'temperatura', 1186.0000, 'ºC'),
	(219559, 119, '2014-03-01 00:11:54.000000', 'temperatura', 783.0000, 'ºC'),
	(219560, 119, '2014-03-01 00:11:55.000000', 'temperatura', 356.0000, 'ºC'),
	(219561, 119, '2014-03-01 00:11:56.000000', 'temperatura', 632.0000, 'ºC'),
	(219562, 119, '2014-03-01 00:11:57.000000', 'temperatura', 895.0000, 'ºC'),
	(219563, 119, '2014-03-01 00:11:58.000000', 'temperatura', 177.0000, 'ºC'),
	(219564, 119, '2014-03-01 00:11:59.000000', 'temperatura', 603.0000, 'ºC'),
	(219565, 119, '2014-03-01 00:12:00.000000', 'temperatura', 84.0000, 'ºC'),
	(219566, 119, '2014-03-01 00:12:01.000000', 'temperatura', 1012.0000, 'ºC'),
	(219567, 119, '2014-03-01 00:12:02.000000', 'temperatura', 6.0000, 'ºC'),
	(219568, 119, '2014-03-01 00:12:03.000000', 'temperatura', 595.0000, 'ºC'),
	(219569, 119, '2014-03-01 00:12:04.000000', 'temperatura', 560.0000, 'ºC'),
	(219570, 119, '2014-03-01 00:12:05.000000', 'temperatura', 1012.0000, 'ºC'),
	(219571, 119, '2014-03-01 00:12:06.000000', 'temperatura', 982.0000, 'ºC'),
	(219572, 119, '2014-03-01 00:12:07.000000', 'temperatura', 677.0000, 'ºC'),
	(219573, 119, '2014-03-01 00:12:08.000000', 'temperatura', 436.0000, 'ºC'),
	(219574, 119, '2014-03-01 00:12:09.000000', 'temperatura', 150.0000, 'ºC'),
	(219575, 119, '2014-03-01 00:12:10.000000', 'temperatura', 645.0000, 'ºC'),
	(219576, 119, '2014-03-01 00:12:11.000000', 'temperatura', 373.0000, 'ºC'),
	(219577, 119, '2014-03-01 00:12:12.000000', 'temperatura', 1131.0000, 'ºC'),
	(219578, 119, '2014-03-01 00:12:13.000000', 'temperatura', 937.0000, 'ºC'),
	(219579, 119, '2014-03-01 00:12:14.000000', 'temperatura', 94.0000, 'ºC'),
	(219580, 119, '2014-03-01 00:12:15.000000', 'temperatura', 58.0000, 'ºC'),
	(219581, 119, '2014-03-01 00:12:16.000000', 'temperatura', 9.0000, 'ºC'),
	(219582, 119, '2014-03-01 00:12:17.000000', 'temperatura', 1072.0000, 'ºC'),
	(219583, 119, '2014-03-01 00:12:18.000000', 'temperatura', 534.0000, 'ºC'),
	(219584, 119, '2014-03-01 00:12:19.000000', 'temperatura', 653.0000, 'ºC'),
	(219585, 119, '2014-03-01 00:12:20.000000', 'temperatura', 464.0000, 'ºC'),
	(219586, 119, '2014-03-01 00:12:21.000000', 'temperatura', 360.0000, 'ºC'),
	(219587, 119, '2014-03-01 00:12:22.000000', 'temperatura', 411.0000, 'ºC'),
	(219588, 119, '2014-03-01 00:12:23.000000', 'temperatura', 976.0000, 'ºC'),
	(219589, 119, '2014-03-01 00:12:24.000000', 'temperatura', 47.0000, 'ºC'),
	(219590, 119, '2014-03-01 00:12:25.000000', 'temperatura', 907.0000, 'ºC'),
	(219591, 119, '2014-03-01 00:12:26.000000', 'temperatura', 797.0000, 'ºC'),
	(219592, 119, '2014-03-01 00:12:27.000000', 'temperatura', 61.0000, 'ºC'),
	(219593, 119, '2014-03-01 00:12:28.000000', 'temperatura', 317.0000, 'ºC'),
	(219594, 119, '2014-03-01 00:12:29.000000', 'temperatura', 201.0000, 'ºC'),
	(219595, 119, '2014-03-01 00:12:30.000000', 'temperatura', 55.0000, 'ºC'),
	(219596, 119, '2014-03-01 00:12:31.000000', 'temperatura', 875.0000, 'ºC'),
	(219597, 119, '2014-03-01 00:12:32.000000', 'temperatura', 607.0000, 'ºC'),
	(219598, 119, '2014-03-01 00:12:33.000000', 'temperatura', 410.0000, 'ºC'),
	(219599, 119, '2014-03-01 00:12:34.000000', 'temperatura', 232.0000, 'ºC'),
	(219600, 119, '2014-03-01 00:12:35.000000', 'temperatura', 1129.0000, 'ºC'),
	(219601, 119, '2014-03-01 00:12:36.000000', 'temperatura', 151.0000, 'ºC'),
	(219602, 119, '2014-03-01 00:12:37.000000', 'temperatura', 970.0000, 'ºC'),
	(219603, 119, '2014-03-01 00:12:38.000000', 'temperatura', 795.0000, 'ºC'),
	(219604, 119, '2014-03-01 00:12:39.000000', 'temperatura', 1065.0000, 'ºC'),
	(219605, 119, '2014-03-01 00:12:40.000000', 'temperatura', 543.0000, 'ºC'),
	(219606, 119, '2014-03-01 00:12:41.000000', 'temperatura', 720.0000, 'ºC'),
	(219607, 119, '2014-03-01 00:12:42.000000', 'temperatura', 772.0000, 'ºC'),
	(219608, 119, '2014-03-01 00:12:43.000000', 'temperatura', 502.0000, 'ºC'),
	(219609, 119, '2014-03-01 00:12:44.000000', 'temperatura', 191.0000, 'ºC'),
	(219610, 119, '2014-03-01 00:12:45.000000', 'temperatura', 650.0000, 'ºC'),
	(219611, 119, '2014-03-01 00:12:46.000000', 'temperatura', 279.0000, 'ºC'),
	(219612, 119, '2014-03-01 00:12:47.000000', 'temperatura', 645.0000, 'ºC'),
	(219613, 119, '2014-03-01 00:12:48.000000', 'temperatura', 1189.0000, 'ºC'),
	(219614, 119, '2014-03-01 00:12:49.000000', 'temperatura', 408.0000, 'ºC'),
	(219615, 119, '2014-03-01 00:12:50.000000', 'temperatura', 875.0000, 'ºC'),
	(219616, 119, '2014-03-01 00:12:51.000000', 'temperatura', 753.0000, 'ºC'),
	(219617, 119, '2014-03-01 00:12:52.000000', 'temperatura', 1141.0000, 'ºC'),
	(219618, 119, '2014-03-01 00:12:53.000000', 'temperatura', 1044.0000, 'ºC'),
	(219619, 119, '2014-03-01 00:12:54.000000', 'temperatura', 599.0000, 'ºC'),
	(219620, 119, '2014-03-01 00:12:55.000000', 'temperatura', 1062.0000, 'ºC'),
	(219621, 119, '2014-03-01 00:12:56.000000', 'temperatura', 1113.0000, 'ºC'),
	(219622, 119, '2014-03-01 00:12:57.000000', 'temperatura', 1181.0000, 'ºC'),
	(219623, 119, '2014-03-01 00:12:58.000000', 'temperatura', 167.0000, 'ºC'),
	(219624, 119, '2014-03-01 00:12:59.000000', 'temperatura', 890.0000, 'ºC'),
	(219625, 119, '2014-03-01 00:13:00.000000', 'temperatura', 350.0000, 'ºC'),
	(219626, 119, '2014-03-01 00:13:01.000000', 'temperatura', 280.0000, 'ºC'),
	(219627, 119, '2014-03-01 00:13:02.000000', 'temperatura', 352.0000, 'ºC'),
	(219628, 119, '2014-03-01 00:13:03.000000', 'temperatura', 918.0000, 'ºC'),
	(219629, 119, '2014-03-01 00:13:04.000000', 'temperatura', 1135.0000, 'ºC'),
	(219630, 119, '2014-03-01 00:13:05.000000', 'temperatura', 524.0000, 'ºC'),
	(219631, 119, '2014-03-01 00:13:06.000000', 'temperatura', 414.0000, 'ºC'),
	(219632, 119, '2014-03-01 00:13:07.000000', 'temperatura', 500.0000, 'ºC'),
	(219633, 119, '2014-03-01 00:13:08.000000', 'temperatura', 59.0000, 'ºC'),
	(219634, 119, '2014-03-01 00:13:09.000000', 'temperatura', 1194.0000, 'ºC'),
	(219635, 119, '2014-03-01 00:13:10.000000', 'temperatura', 992.0000, 'ºC'),
	(219636, 119, '2014-03-01 00:13:11.000000', 'temperatura', 179.0000, 'ºC'),
	(219637, 119, '2014-03-01 00:13:12.000000', 'temperatura', 318.0000, 'ºC'),
	(219638, 119, '2014-03-01 00:13:13.000000', 'temperatura', 1056.0000, 'ºC'),
	(219639, 119, '2014-03-01 00:13:14.000000', 'temperatura', 724.0000, 'ºC'),
	(219640, 119, '2014-03-01 00:13:15.000000', 'temperatura', 455.0000, 'ºC'),
	(219641, 119, '2014-03-01 00:13:16.000000', 'temperatura', 104.0000, 'ºC'),
	(219642, 119, '2014-03-01 00:13:17.000000', 'temperatura', 355.0000, 'ºC'),
	(219643, 119, '2014-03-01 00:13:18.000000', 'temperatura', 264.0000, 'ºC'),
	(219644, 119, '2014-03-01 00:13:19.000000', 'temperatura', 254.0000, 'ºC'),
	(219645, 119, '2014-03-01 00:13:20.000000', 'temperatura', 479.0000, 'ºC'),
	(219646, 119, '2014-03-01 00:13:21.000000', 'temperatura', 432.0000, 'ºC'),
	(219647, 119, '2014-03-01 00:13:22.000000', 'temperatura', 723.0000, 'ºC'),
	(219648, 119, '2014-03-01 00:13:23.000000', 'temperatura', 1121.0000, 'ºC'),
	(219649, 119, '2014-03-01 00:13:24.000000', 'temperatura', 1036.0000, 'ºC'),
	(219650, 119, '2014-03-01 00:13:25.000000', 'temperatura', 616.0000, 'ºC'),
	(219651, 119, '2014-03-01 00:13:26.000000', 'temperatura', 1173.0000, 'ºC'),
	(219652, 119, '2014-03-01 00:13:27.000000', 'temperatura', 418.0000, 'ºC'),
	(219653, 119, '2014-03-01 00:13:28.000000', 'temperatura', 970.0000, 'ºC'),
	(219654, 119, '2014-03-01 00:13:29.000000', 'temperatura', 1197.0000, 'ºC'),
	(219655, 119, '2014-03-01 00:13:30.000000', 'temperatura', 677.0000, 'ºC'),
	(219656, 119, '2014-03-01 00:13:31.000000', 'temperatura', 994.0000, 'ºC'),
	(219657, 119, '2014-03-01 00:13:32.000000', 'temperatura', 540.0000, 'ºC'),
	(219658, 119, '2014-03-01 00:13:33.000000', 'temperatura', 918.0000, 'ºC'),
	(219659, 119, '2014-03-01 00:13:34.000000', 'temperatura', 572.0000, 'ºC'),
	(219660, 119, '2014-03-01 00:13:35.000000', 'temperatura', 107.0000, 'ºC'),
	(219661, 119, '2014-03-01 00:13:36.000000', 'temperatura', 19.0000, 'ºC'),
	(219662, 119, '2014-03-01 00:13:37.000000', 'temperatura', 973.0000, 'ºC'),
	(219663, 119, '2014-03-01 00:13:38.000000', 'temperatura', 10.0000, 'ºC'),
	(219664, 119, '2014-03-01 00:13:39.000000', 'temperatura', 730.0000, 'ºC'),
	(219665, 119, '2014-03-01 00:13:40.000000', 'temperatura', 22.0000, 'ºC'),
	(219666, 119, '2014-03-01 00:13:41.000000', 'temperatura', 318.0000, 'ºC'),
	(219667, 119, '2014-03-01 00:13:42.000000', 'temperatura', 327.0000, 'ºC'),
	(219668, 119, '2014-03-01 00:13:43.000000', 'temperatura', 682.0000, 'ºC'),
	(219669, 119, '2014-03-01 00:13:44.000000', 'temperatura', 27.0000, 'ºC'),
	(219670, 119, '2014-03-01 00:13:45.000000', 'temperatura', 490.0000, 'ºC'),
	(219671, 119, '2014-03-01 00:13:46.000000', 'temperatura', 1168.0000, 'ºC'),
	(219672, 119, '2014-03-01 00:13:47.000000', 'temperatura', 773.0000, 'ºC'),
	(219673, 119, '2014-03-01 00:13:48.000000', 'temperatura', 360.0000, 'ºC'),
	(219674, 119, '2014-03-01 00:13:49.000000', 'temperatura', 682.0000, 'ºC'),
	(219675, 119, '2014-03-01 00:13:50.000000', 'temperatura', 1130.0000, 'ºC'),
	(219676, 119, '2014-03-01 00:13:51.000000', 'temperatura', 4.0000, 'ºC'),
	(219677, 119, '2014-03-01 00:13:52.000000', 'temperatura', 233.0000, 'ºC'),
	(219678, 119, '2014-03-01 00:13:53.000000', 'temperatura', 1153.0000, 'ºC'),
	(219679, 119, '2014-03-01 00:13:54.000000', 'temperatura', 266.0000, 'ºC'),
	(219680, 119, '2014-03-01 00:13:55.000000', 'temperatura', 273.0000, 'ºC'),
	(219681, 119, '2014-03-01 00:13:56.000000', 'temperatura', 565.0000, 'ºC'),
	(219682, 119, '2014-03-01 00:13:57.000000', 'temperatura', 806.0000, 'ºC'),
	(219683, 119, '2014-03-01 00:13:58.000000', 'temperatura', 1138.0000, 'ºC'),
	(219684, 119, '2014-03-01 00:13:59.000000', 'temperatura', 872.0000, 'ºC'),
	(219685, 119, '2014-03-01 00:14:00.000000', 'temperatura', 946.0000, 'ºC'),
	(219686, 119, '2014-03-01 00:14:01.000000', 'temperatura', 917.0000, 'ºC'),
	(219687, 119, '2014-03-01 00:14:02.000000', 'temperatura', 544.0000, 'ºC'),
	(219688, 119, '2014-03-01 00:14:03.000000', 'temperatura', 1170.0000, 'ºC'),
	(219689, 119, '2014-03-01 00:14:04.000000', 'temperatura', 621.0000, 'ºC'),
	(219690, 119, '2014-03-01 00:14:05.000000', 'temperatura', 794.0000, 'ºC'),
	(219691, 119, '2014-03-01 00:14:06.000000', 'temperatura', 908.0000, 'ºC'),
	(219692, 119, '2014-03-01 00:14:07.000000', 'temperatura', 959.0000, 'ºC'),
	(219693, 119, '2014-03-01 00:14:08.000000', 'temperatura', 872.0000, 'ºC'),
	(219694, 119, '2014-03-01 00:14:09.000000', 'temperatura', 282.0000, 'ºC'),
	(219695, 119, '2014-03-01 00:14:10.000000', 'temperatura', 1195.0000, 'ºC'),
	(219696, 119, '2014-03-01 00:14:11.000000', 'temperatura', 331.0000, 'ºC'),
	(219697, 119, '2014-03-01 00:14:12.000000', 'temperatura', 470.0000, 'ºC'),
	(219698, 119, '2014-03-01 00:14:13.000000', 'temperatura', 156.0000, 'ºC'),
	(219699, 119, '2014-03-01 00:14:14.000000', 'temperatura', 573.0000, 'ºC'),
	(219700, 119, '2014-03-01 00:14:15.000000', 'temperatura', 1196.0000, 'ºC'),
	(219701, 119, '2014-03-01 00:14:16.000000', 'temperatura', 662.0000, 'ºC'),
	(219702, 119, '2014-03-01 00:14:17.000000', 'temperatura', 922.0000, 'ºC'),
	(219703, 119, '2014-03-01 00:14:18.000000', 'temperatura', 224.0000, 'ºC'),
	(219704, 119, '2014-03-01 00:14:19.000000', 'temperatura', 757.0000, 'ºC'),
	(219705, 119, '2014-03-01 00:14:20.000000', 'temperatura', 712.0000, 'ºC'),
	(219706, 119, '2014-03-01 00:14:21.000000', 'temperatura', 89.0000, 'ºC'),
	(219707, 119, '2014-03-01 00:14:22.000000', 'temperatura', 710.0000, 'ºC'),
	(219708, 119, '2014-03-01 00:14:23.000000', 'temperatura', 883.0000, 'ºC'),
	(219709, 119, '2014-03-01 00:14:24.000000', 'temperatura', 1087.0000, 'ºC'),
	(219710, 119, '2014-03-01 00:14:25.000000', 'temperatura', 386.0000, 'ºC'),
	(219711, 119, '2014-03-01 00:14:26.000000', 'temperatura', 1070.0000, 'ºC'),
	(219712, 119, '2014-03-01 00:14:27.000000', 'temperatura', 590.0000, 'ºC'),
	(219713, 119, '2014-03-01 00:14:28.000000', 'temperatura', 942.0000, 'ºC'),
	(219714, 119, '2014-03-01 00:14:29.000000', 'temperatura', 542.0000, 'ºC'),
	(219715, 119, '2014-03-01 00:14:30.000000', 'temperatura', 1085.0000, 'ºC'),
	(219716, 119, '2014-03-01 00:14:31.000000', 'temperatura', 197.0000, 'ºC'),
	(219717, 119, '2014-03-01 00:14:32.000000', 'temperatura', 131.0000, 'ºC'),
	(219718, 119, '2014-03-01 00:14:33.000000', 'temperatura', 63.0000, 'ºC'),
	(219719, 119, '2014-03-01 00:14:34.000000', 'temperatura', 1124.0000, 'ºC'),
	(219720, 119, '2014-03-01 00:14:35.000000', 'temperatura', 631.0000, 'ºC'),
	(219721, 119, '2014-03-01 00:14:36.000000', 'temperatura', 982.0000, 'ºC'),
	(219722, 119, '2014-03-01 00:14:37.000000', 'temperatura', 619.0000, 'ºC'),
	(219723, 119, '2014-03-01 00:14:38.000000', 'temperatura', 149.0000, 'ºC'),
	(219724, 119, '2014-03-01 00:14:39.000000', 'temperatura', 88.0000, 'ºC'),
	(219725, 119, '2014-03-01 00:14:40.000000', 'temperatura', 1192.0000, 'ºC'),
	(219726, 119, '2014-03-01 00:14:41.000000', 'temperatura', 897.0000, 'ºC'),
	(219727, 119, '2014-03-01 00:14:42.000000', 'temperatura', 911.0000, 'ºC'),
	(219728, 119, '2014-03-01 00:14:43.000000', 'temperatura', 664.0000, 'ºC'),
	(219729, 119, '2014-03-01 00:14:44.000000', 'temperatura', 588.0000, 'ºC'),
	(219730, 119, '2014-03-01 00:14:45.000000', 'temperatura', 950.0000, 'ºC'),
	(219731, 119, '2014-03-01 00:14:46.000000', 'temperatura', 585.0000, 'ºC'),
	(219732, 119, '2014-03-01 00:14:47.000000', 'temperatura', 77.0000, 'ºC'),
	(219733, 119, '2014-03-01 00:14:48.000000', 'temperatura', 1029.0000, 'ºC'),
	(219734, 119, '2014-03-01 00:14:49.000000', 'temperatura', 115.0000, 'ºC'),
	(219735, 119, '2014-03-01 00:14:50.000000', 'temperatura', 1087.0000, 'ºC'),
	(219736, 119, '2014-03-01 00:14:51.000000', 'temperatura', 290.0000, 'ºC'),
	(219737, 119, '2014-03-01 00:14:52.000000', 'temperatura', 591.0000, 'ºC'),
	(219738, 119, '2014-03-01 00:14:53.000000', 'temperatura', 887.0000, 'ºC'),
	(219739, 119, '2014-03-01 00:14:54.000000', 'temperatura', 260.0000, 'ºC'),
	(219740, 119, '2014-03-01 00:14:55.000000', 'temperatura', 1041.0000, 'ºC'),
	(219741, 119, '2014-03-01 00:14:56.000000', 'temperatura', 823.0000, 'ºC'),
	(219742, 119, '2014-03-01 00:14:57.000000', 'temperatura', 995.0000, 'ºC'),
	(219743, 119, '2014-03-01 00:14:58.000000', 'temperatura', 107.0000, 'ºC'),
	(219744, 119, '2014-03-01 00:14:59.000000', 'temperatura', 1150.0000, 'ºC'),
	(219745, 119, '2014-03-01 00:15:00.000000', 'temperatura', 629.0000, 'ºC'),
	(219746, 119, '2014-03-01 00:15:01.000000', 'temperatura', 898.0000, 'ºC'),
	(219747, 119, '2014-03-01 00:15:02.000000', 'temperatura', 201.0000, 'ºC'),
	(219748, 119, '2014-03-01 00:15:03.000000', 'temperatura', 712.0000, 'ºC'),
	(219749, 119, '2014-03-01 00:15:04.000000', 'temperatura', 558.0000, 'ºC'),
	(219750, 119, '2014-03-01 00:15:05.000000', 'temperatura', 656.0000, 'ºC'),
	(219751, 119, '2014-03-01 00:15:06.000000', 'temperatura', 403.0000, 'ºC'),
	(219752, 119, '2014-03-01 00:15:07.000000', 'temperatura', 50.0000, 'ºC'),
	(219753, 119, '2014-03-01 00:15:08.000000', 'temperatura', 239.0000, 'ºC'),
	(219754, 119, '2014-03-01 00:15:09.000000', 'temperatura', 1046.0000, 'ºC'),
	(219755, 119, '2014-03-01 00:15:10.000000', 'temperatura', 914.0000, 'ºC'),
	(219756, 119, '2014-03-01 00:15:11.000000', 'temperatura', 232.0000, 'ºC'),
	(219757, 119, '2014-03-01 00:15:12.000000', 'temperatura', 819.0000, 'ºC'),
	(219758, 119, '2014-03-01 00:15:13.000000', 'temperatura', 998.0000, 'ºC'),
	(219759, 119, '2014-03-01 00:15:14.000000', 'temperatura', 133.0000, 'ºC'),
	(219760, 119, '2014-03-01 00:15:15.000000', 'temperatura', 73.0000, 'ºC'),
	(219761, 119, '2014-03-01 00:15:16.000000', 'temperatura', 1167.0000, 'ºC'),
	(219762, 119, '2014-03-01 00:15:17.000000', 'temperatura', 814.0000, 'ºC'),
	(219763, 119, '2014-03-01 00:15:18.000000', 'temperatura', 571.0000, 'ºC'),
	(219764, 119, '2014-03-01 00:15:19.000000', 'temperatura', 414.0000, 'ºC'),
	(219765, 119, '2014-03-01 00:15:20.000000', 'temperatura', 358.0000, 'ºC'),
	(219766, 119, '2014-03-01 00:15:21.000000', 'temperatura', 547.0000, 'ºC'),
	(219767, 119, '2014-03-01 00:15:22.000000', 'temperatura', 461.0000, 'ºC'),
	(219768, 119, '2014-03-01 00:15:23.000000', 'temperatura', 665.0000, 'ºC'),
	(219769, 119, '2014-03-01 00:15:24.000000', 'temperatura', 745.0000, 'ºC'),
	(219770, 119, '2014-03-01 00:15:25.000000', 'temperatura', 528.0000, 'ºC'),
	(219771, 119, '2014-03-01 00:15:26.000000', 'temperatura', 405.0000, 'ºC'),
	(219772, 119, '2014-03-01 00:15:27.000000', 'temperatura', 443.0000, 'ºC'),
	(219773, 119, '2014-03-01 00:15:28.000000', 'temperatura', 998.0000, 'ºC'),
	(219774, 119, '2014-03-01 00:15:29.000000', 'temperatura', 65.0000, 'ºC'),
	(219775, 119, '2014-03-01 00:15:30.000000', 'temperatura', 929.0000, 'ºC'),
	(219776, 119, '2014-03-01 00:15:31.000000', 'temperatura', 851.0000, 'ºC'),
	(219777, 119, '2014-03-01 00:15:32.000000', 'temperatura', 269.0000, 'ºC'),
	(219778, 119, '2014-03-01 00:15:33.000000', 'temperatura', 1192.0000, 'ºC'),
	(219779, 119, '2014-03-01 00:15:34.000000', 'temperatura', 353.0000, 'ºC'),
	(219780, 119, '2014-03-01 00:15:35.000000', 'temperatura', 588.0000, 'ºC'),
	(219781, 119, '2014-03-01 00:15:36.000000', 'temperatura', 683.0000, 'ºC'),
	(219782, 119, '2014-03-01 00:15:37.000000', 'temperatura', 452.0000, 'ºC'),
	(219783, 119, '2014-03-01 00:15:38.000000', 'temperatura', 212.0000, 'ºC'),
	(219784, 119, '2014-03-01 00:15:39.000000', 'temperatura', 906.0000, 'ºC'),
	(219785, 119, '2014-03-01 00:15:40.000000', 'temperatura', 292.0000, 'ºC'),
	(219786, 119, '2014-03-01 00:15:41.000000', 'temperatura', 1143.0000, 'ºC'),
	(219787, 119, '2014-03-01 00:15:42.000000', 'temperatura', 39.0000, 'ºC'),
	(219788, 119, '2014-03-01 00:15:43.000000', 'temperatura', 369.0000, 'ºC'),
	(219789, 119, '2014-03-01 00:15:44.000000', 'temperatura', 527.0000, 'ºC'),
	(219790, 119, '2014-03-01 00:15:45.000000', 'temperatura', 328.0000, 'ºC'),
	(219791, 119, '2014-03-01 00:15:46.000000', 'temperatura', 59.0000, 'ºC'),
	(219792, 119, '2014-03-01 00:15:47.000000', 'temperatura', 510.0000, 'ºC'),
	(219793, 119, '2014-03-01 00:15:48.000000', 'temperatura', 1176.0000, 'ºC'),
	(219794, 119, '2014-03-01 00:15:49.000000', 'temperatura', 749.0000, 'ºC'),
	(219795, 119, '2014-03-01 00:15:50.000000', 'temperatura', 217.0000, 'ºC'),
	(219796, 119, '2014-03-01 00:15:51.000000', 'temperatura', 38.0000, 'ºC'),
	(219797, 119, '2014-03-01 00:15:52.000000', 'temperatura', 740.0000, 'ºC'),
	(219798, 119, '2014-03-01 00:15:53.000000', 'temperatura', 1187.0000, 'ºC'),
	(219799, 119, '2014-03-01 00:15:54.000000', 'temperatura', 116.0000, 'ºC'),
	(219800, 119, '2014-03-01 00:15:55.000000', 'temperatura', 619.0000, 'ºC'),
	(219801, 119, '2014-03-01 00:15:56.000000', 'temperatura', 347.0000, 'ºC'),
	(219802, 119, '2014-03-01 00:15:57.000000', 'temperatura', 1081.0000, 'ºC'),
	(219803, 119, '2014-03-01 00:15:58.000000', 'temperatura', 763.0000, 'ºC'),
	(219804, 119, '2014-03-01 00:15:59.000000', 'temperatura', 572.0000, 'ºC'),
	(219805, 119, '2014-03-01 00:16:00.000000', 'temperatura', 572.0000, 'ºC'),
	(219806, 119, '2014-03-01 00:16:01.000000', 'temperatura', 1146.0000, 'ºC'),
	(219807, 119, '2014-03-01 00:16:02.000000', 'temperatura', 414.0000, 'ºC'),
	(219808, 119, '2014-03-01 00:16:03.000000', 'temperatura', 1031.0000, 'ºC'),
	(219809, 119, '2014-03-01 00:16:04.000000', 'temperatura', 315.0000, 'ºC'),
	(219810, 119, '2014-03-01 00:16:05.000000', 'temperatura', 882.0000, 'ºC'),
	(219811, 119, '2014-03-01 00:16:06.000000', 'temperatura', 1065.0000, 'ºC'),
	(219812, 119, '2014-03-01 00:16:07.000000', 'temperatura', 278.0000, 'ºC'),
	(219813, 119, '2014-03-01 00:16:08.000000', 'temperatura', 598.0000, 'ºC'),
	(219814, 119, '2014-03-01 00:16:09.000000', 'temperatura', 957.0000, 'ºC'),
	(219815, 119, '2014-03-01 00:16:10.000000', 'temperatura', 593.0000, 'ºC'),
	(219816, 119, '2014-03-01 00:16:11.000000', 'temperatura', 91.0000, 'ºC'),
	(219817, 119, '2014-03-01 00:16:12.000000', 'temperatura', 1080.0000, 'ºC'),
	(219818, 119, '2014-03-01 00:16:13.000000', 'temperatura', 324.0000, 'ºC'),
	(219819, 119, '2014-03-01 00:16:14.000000', 'temperatura', 782.0000, 'ºC'),
	(219820, 119, '2014-03-01 00:16:15.000000', 'temperatura', 538.0000, 'ºC'),
	(219821, 119, '2014-03-01 00:16:16.000000', 'temperatura', 345.0000, 'ºC'),
	(219822, 119, '2014-03-01 00:16:17.000000', 'temperatura', 112.0000, 'ºC'),
	(219823, 119, '2014-03-01 00:16:18.000000', 'temperatura', 727.0000, 'ºC'),
	(219824, 119, '2014-03-01 00:16:19.000000', 'temperatura', 897.0000, 'ºC'),
	(219825, 119, '2014-03-01 00:16:20.000000', 'temperatura', 1105.0000, 'ºC'),
	(219826, 119, '2014-03-01 00:16:21.000000', 'temperatura', 435.0000, 'ºC'),
	(219827, 119, '2014-03-01 00:16:22.000000', 'temperatura', 62.0000, 'ºC'),
	(219828, 119, '2014-03-01 00:16:23.000000', 'temperatura', 206.0000, 'ºC'),
	(219829, 119, '2014-03-01 00:16:24.000000', 'temperatura', 844.0000, 'ºC'),
	(219830, 119, '2014-03-01 00:16:25.000000', 'temperatura', 2.0000, 'ºC'),
	(219831, 119, '2014-03-01 00:16:26.000000', 'temperatura', 1079.0000, 'ºC'),
	(219832, 119, '2014-03-01 00:16:27.000000', 'temperatura', 591.0000, 'ºC'),
	(219833, 119, '2014-03-01 00:16:28.000000', 'temperatura', 917.0000, 'ºC'),
	(219834, 119, '2014-03-01 00:16:29.000000', 'temperatura', 412.0000, 'ºC'),
	(219835, 119, '2014-03-01 00:16:30.000000', 'temperatura', 510.0000, 'ºC'),
	(219836, 119, '2014-03-01 00:16:31.000000', 'temperatura', 117.0000, 'ºC'),
	(219837, 119, '2014-03-01 00:16:32.000000', 'temperatura', 252.0000, 'ºC'),
	(219838, 119, '2014-03-01 00:16:33.000000', 'temperatura', 910.0000, 'ºC'),
	(219839, 119, '2014-03-01 00:16:34.000000', 'temperatura', 193.0000, 'ºC'),
	(219840, 119, '2014-03-01 00:16:35.000000', 'temperatura', 638.0000, 'ºC'),
	(219841, 119, '2014-03-01 00:16:36.000000', 'temperatura', 213.0000, 'ºC'),
	(219842, 119, '2014-03-01 00:16:37.000000', 'temperatura', 348.0000, 'ºC'),
	(219843, 119, '2014-03-01 00:16:38.000000', 'temperatura', 1104.0000, 'ºC'),
	(219844, 119, '2014-03-01 00:16:39.000000', 'temperatura', 877.0000, 'ºC'),
	(219845, 119, '2014-03-01 00:16:40.000000', 'temperatura', 1071.0000, 'ºC'),
	(219846, 119, '2014-03-01 00:16:41.000000', 'temperatura', 324.0000, 'ºC'),
	(219847, 119, '2014-03-01 00:16:42.000000', 'temperatura', 810.0000, 'ºC'),
	(219848, 119, '2014-03-01 00:16:43.000000', 'temperatura', 679.0000, 'ºC'),
	(219849, 119, '2014-03-01 00:16:44.000000', 'temperatura', 963.0000, 'ºC'),
	(219850, 119, '2014-03-01 00:16:45.000000', 'temperatura', 380.0000, 'ºC'),
	(219851, 119, '2014-03-01 00:16:46.000000', 'temperatura', 210.0000, 'ºC'),
	(219852, 119, '2014-03-01 00:16:47.000000', 'temperatura', 1111.0000, 'ºC'),
	(219853, 119, '2014-03-01 00:16:48.000000', 'temperatura', 125.0000, 'ºC'),
	(219854, 119, '2014-03-01 00:16:49.000000', 'temperatura', 894.0000, 'ºC'),
	(219855, 119, '2014-03-01 00:16:50.000000', 'temperatura', 495.0000, 'ºC'),
	(219856, 119, '2014-03-01 00:16:51.000000', 'temperatura', 993.0000, 'ºC'),
	(219857, 119, '2014-03-01 00:16:52.000000', 'temperatura', 1083.0000, 'ºC'),
	(219858, 119, '2014-03-01 00:16:53.000000', 'temperatura', 34.0000, 'ºC'),
	(219859, 119, '2014-03-01 00:16:54.000000', 'temperatura', 520.0000, 'ºC'),
	(219860, 119, '2014-03-01 00:16:55.000000', 'temperatura', 101.0000, 'ºC'),
	(219861, 119, '2014-03-01 00:16:56.000000', 'temperatura', 147.0000, 'ºC'),
	(219862, 119, '2014-03-01 00:16:57.000000', 'temperatura', 429.0000, 'ºC'),
	(219863, 119, '2014-03-01 00:16:58.000000', 'temperatura', 508.0000, 'ºC'),
	(219864, 119, '2014-03-01 00:16:59.000000', 'temperatura', 52.0000, 'ºC'),
	(219865, 119, '2014-03-01 00:17:00.000000', 'temperatura', 1135.0000, 'ºC'),
	(219866, 119, '2014-03-01 00:17:01.000000', 'temperatura', 721.0000, 'ºC'),
	(219867, 119, '2014-03-01 00:17:02.000000', 'temperatura', 199.0000, 'ºC'),
	(219868, 119, '2014-03-01 00:17:03.000000', 'temperatura', 35.0000, 'ºC'),
	(219869, 119, '2014-03-01 00:17:04.000000', 'temperatura', 778.0000, 'ºC'),
	(219870, 119, '2014-03-01 00:17:05.000000', 'temperatura', 184.0000, 'ºC'),
	(219871, 119, '2014-03-01 00:17:06.000000', 'temperatura', 988.0000, 'ºC'),
	(219872, 119, '2014-03-01 00:17:07.000000', 'temperatura', 789.0000, 'ºC'),
	(219873, 119, '2014-03-01 00:17:08.000000', 'temperatura', 982.0000, 'ºC'),
	(219874, 119, '2014-03-01 00:17:09.000000', 'temperatura', 143.0000, 'ºC'),
	(219875, 119, '2014-03-01 00:17:10.000000', 'temperatura', 168.0000, 'ºC'),
	(219876, 119, '2014-03-01 00:17:11.000000', 'temperatura', 413.0000, 'ºC'),
	(219877, 119, '2014-03-01 00:17:12.000000', 'temperatura', 363.0000, 'ºC'),
	(219878, 119, '2014-03-01 00:17:13.000000', 'temperatura', 575.0000, 'ºC'),
	(219879, 119, '2014-03-01 00:17:14.000000', 'temperatura', 588.0000, 'ºC'),
	(219880, 119, '2014-03-01 00:17:15.000000', 'temperatura', 14.0000, 'ºC'),
	(219881, 119, '2014-03-01 00:17:16.000000', 'temperatura', 705.0000, 'ºC'),
	(219882, 119, '2014-03-01 00:17:17.000000', 'temperatura', 1086.0000, 'ºC'),
	(219883, 119, '2014-03-01 00:17:18.000000', 'temperatura', 915.0000, 'ºC'),
	(219884, 119, '2014-03-01 00:17:19.000000', 'temperatura', 115.0000, 'ºC'),
	(219885, 119, '2014-03-01 00:17:20.000000', 'temperatura', 234.0000, 'ºC'),
	(219886, 119, '2014-03-01 00:17:21.000000', 'temperatura', 823.0000, 'ºC'),
	(219887, 119, '2014-03-01 00:17:22.000000', 'temperatura', 1013.0000, 'ºC'),
	(219888, 119, '2014-03-01 00:17:23.000000', 'temperatura', 196.0000, 'ºC'),
	(219889, 119, '2014-03-01 00:17:24.000000', 'temperatura', 342.0000, 'ºC'),
	(219890, 119, '2014-03-01 00:17:25.000000', 'temperatura', 1124.0000, 'ºC'),
	(219891, 119, '2014-03-01 00:17:26.000000', 'temperatura', 996.0000, 'ºC'),
	(219892, 119, '2014-03-01 00:17:27.000000', 'temperatura', 406.0000, 'ºC'),
	(219893, 119, '2014-03-01 00:17:28.000000', 'temperatura', 242.0000, 'ºC'),
	(219894, 119, '2014-03-01 00:17:29.000000', 'temperatura', 1194.0000, 'ºC'),
	(219895, 119, '2014-03-01 00:17:30.000000', 'temperatura', 443.0000, 'ºC'),
	(219896, 119, '2014-03-01 00:17:31.000000', 'temperatura', 1034.0000, 'ºC'),
	(219897, 119, '2014-03-01 00:17:32.000000', 'temperatura', 243.0000, 'ºC'),
	(219898, 119, '2014-03-01 00:17:33.000000', 'temperatura', 513.0000, 'ºC'),
	(219899, 119, '2014-03-01 00:17:34.000000', 'temperatura', 636.0000, 'ºC'),
	(219900, 119, '2014-03-01 00:17:35.000000', 'temperatura', 443.0000, 'ºC'),
	(219901, 119, '2014-03-01 00:17:36.000000', 'temperatura', 306.0000, 'ºC'),
	(219902, 119, '2014-03-01 00:17:37.000000', 'temperatura', 202.0000, 'ºC'),
	(219903, 119, '2014-03-01 00:17:38.000000', 'temperatura', 92.0000, 'ºC'),
	(219904, 119, '2014-03-01 00:17:39.000000', 'temperatura', 1056.0000, 'ºC'),
	(219905, 119, '2014-03-01 00:17:40.000000', 'temperatura', 202.0000, 'ºC'),
	(219906, 119, '2014-03-01 00:17:41.000000', 'temperatura', 242.0000, 'ºC'),
	(219907, 119, '2014-03-01 00:17:42.000000', 'temperatura', 607.0000, 'ºC'),
	(219908, 119, '2014-03-01 00:17:43.000000', 'temperatura', 1109.0000, 'ºC'),
	(219909, 119, '2014-03-01 00:17:44.000000', 'temperatura', 124.0000, 'ºC'),
	(219910, 119, '2014-03-01 00:17:45.000000', 'temperatura', 894.0000, 'ºC'),
	(219911, 119, '2014-03-01 00:17:46.000000', 'temperatura', 500.0000, 'ºC'),
	(219912, 119, '2014-03-01 00:17:47.000000', 'temperatura', 1016.0000, 'ºC'),
	(219913, 119, '2014-03-01 00:17:48.000000', 'temperatura', 1181.0000, 'ºC'),
	(219914, 119, '2014-03-01 00:17:49.000000', 'temperatura', 457.0000, 'ºC'),
	(219915, 119, '2014-03-01 00:17:50.000000', 'temperatura', 1142.0000, 'ºC'),
	(219916, 119, '2014-03-01 00:17:51.000000', 'temperatura', 741.0000, 'ºC'),
	(219917, 119, '2014-03-01 00:17:52.000000', 'temperatura', 278.0000, 'ºC'),
	(219918, 119, '2014-03-01 00:17:53.000000', 'temperatura', 368.0000, 'ºC'),
	(219919, 119, '2014-03-01 00:17:54.000000', 'temperatura', 1008.0000, 'ºC'),
	(219920, 119, '2014-03-01 00:17:55.000000', 'temperatura', 337.0000, 'ºC'),
	(219921, 119, '2014-03-01 00:17:56.000000', 'temperatura', 1062.0000, 'ºC'),
	(219922, 119, '2014-03-01 00:17:57.000000', 'temperatura', 698.0000, 'ºC'),
	(219923, 119, '2014-03-01 00:17:58.000000', 'temperatura', 306.0000, 'ºC'),
	(219924, 119, '2014-03-01 00:17:59.000000', 'temperatura', 636.0000, 'ºC'),
	(219925, 119, '2014-03-01 00:18:00.000000', 'temperatura', 1063.0000, 'ºC'),
	(219926, 119, '2014-03-01 00:18:01.000000', 'temperatura', 1006.0000, 'ºC'),
	(219927, 119, '2014-03-01 00:18:02.000000', 'temperatura', 641.0000, 'ºC'),
	(219928, 119, '2014-03-01 00:18:03.000000', 'temperatura', 190.0000, 'ºC'),
	(219929, 119, '2014-03-01 00:18:04.000000', 'temperatura', 227.0000, 'ºC'),
	(219930, 119, '2014-03-01 00:18:05.000000', 'temperatura', 566.0000, 'ºC'),
	(219931, 119, '2014-03-01 00:18:06.000000', 'temperatura', 951.0000, 'ºC'),
	(219932, 119, '2014-03-01 00:18:07.000000', 'temperatura', 654.0000, 'ºC'),
	(219933, 119, '2014-03-01 00:18:08.000000', 'temperatura', 419.0000, 'ºC'),
	(219934, 119, '2014-03-01 00:18:09.000000', 'temperatura', 133.0000, 'ºC'),
	(219935, 119, '2014-03-01 00:18:10.000000', 'temperatura', 608.0000, 'ºC'),
	(219936, 119, '2014-03-01 00:18:11.000000', 'temperatura', 241.0000, 'ºC'),
	(219937, 119, '2014-03-01 00:18:12.000000', 'temperatura', 583.0000, 'ºC'),
	(219938, 119, '2014-03-01 00:18:13.000000', 'temperatura', 993.0000, 'ºC'),
	(219939, 119, '2014-03-01 00:18:14.000000', 'temperatura', 814.0000, 'ºC'),
	(219940, 119, '2014-03-01 00:18:15.000000', 'temperatura', 1093.0000, 'ºC'),
	(219941, 119, '2014-03-01 00:18:16.000000', 'temperatura', 625.0000, 'ºC'),
	(219942, 119, '2014-03-01 00:18:17.000000', 'temperatura', 1047.0000, 'ºC'),
	(219943, 119, '2014-03-01 00:18:18.000000', 'temperatura', 961.0000, 'ºC'),
	(219944, 119, '2014-03-01 00:18:19.000000', 'temperatura', 462.0000, 'ºC'),
	(219945, 119, '2014-03-01 00:18:20.000000', 'temperatura', 629.0000, 'ºC'),
	(219946, 119, '2014-03-01 00:18:21.000000', 'temperatura', 560.0000, 'ºC'),
	(219947, 119, '2014-03-01 00:18:22.000000', 'temperatura', 914.0000, 'ºC'),
	(219948, 119, '2014-03-01 00:18:23.000000', 'temperatura', 490.0000, 'ºC'),
	(219949, 119, '2014-03-01 00:18:24.000000', 'temperatura', 909.0000, 'ºC'),
	(219950, 119, '2014-03-01 00:18:25.000000', 'temperatura', 676.0000, 'ºC'),
	(219951, 119, '2014-03-01 00:18:26.000000', 'temperatura', 654.0000, 'ºC'),
	(219952, 119, '2014-03-01 00:18:27.000000', 'temperatura', 40.0000, 'ºC'),
	(219953, 119, '2014-03-01 00:18:28.000000', 'temperatura', 639.0000, 'ºC'),
	(219954, 119, '2014-03-01 00:18:29.000000', 'temperatura', 678.0000, 'ºC'),
	(219955, 119, '2014-03-01 00:18:30.000000', 'temperatura', 270.0000, 'ºC'),
	(219956, 119, '2014-03-01 00:18:31.000000', 'temperatura', 518.0000, 'ºC'),
	(219957, 119, '2014-03-01 00:18:32.000000', 'temperatura', 580.0000, 'ºC'),
	(219958, 119, '2014-03-01 00:18:33.000000', 'temperatura', 146.0000, 'ºC'),
	(219959, 119, '2014-03-01 00:18:34.000000', 'temperatura', 191.0000, 'ºC'),
	(219960, 119, '2014-03-01 00:18:35.000000', 'temperatura', 519.0000, 'ºC'),
	(219961, 119, '2014-03-01 00:18:36.000000', 'temperatura', 824.0000, 'ºC'),
	(219962, 119, '2014-03-01 00:18:37.000000', 'temperatura', 160.0000, 'ºC'),
	(219963, 119, '2014-03-01 00:18:38.000000', 'temperatura', 730.0000, 'ºC'),
	(219964, 119, '2014-03-01 00:18:39.000000', 'temperatura', 769.0000, 'ºC'),
	(219965, 119, '2014-03-01 00:18:40.000000', 'temperatura', 457.0000, 'ºC'),
	(219966, 119, '2014-03-01 00:18:41.000000', 'temperatura', 1178.0000, 'ºC'),
	(219967, 119, '2014-03-01 00:18:42.000000', 'temperatura', 918.0000, 'ºC'),
	(219968, 119, '2014-03-01 00:18:43.000000', 'temperatura', 1058.0000, 'ºC'),
	(219969, 119, '2014-03-01 00:18:44.000000', 'temperatura', 135.0000, 'ºC'),
	(219970, 119, '2014-03-01 00:18:45.000000', 'temperatura', 1104.0000, 'ºC'),
	(219971, 119, '2014-03-01 00:18:46.000000', 'temperatura', 315.0000, 'ºC'),
	(219972, 119, '2014-03-01 00:18:47.000000', 'temperatura', 662.0000, 'ºC'),
	(219973, 119, '2014-03-01 00:18:48.000000', 'temperatura', 1168.0000, 'ºC'),
	(219974, 119, '2014-03-01 00:18:49.000000', 'temperatura', 251.0000, 'ºC'),
	(219975, 119, '2014-03-01 00:18:50.000000', 'temperatura', 154.0000, 'ºC'),
	(219976, 119, '2014-03-01 00:18:51.000000', 'temperatura', 19.0000, 'ºC'),
	(219977, 119, '2014-03-01 00:18:52.000000', 'temperatura', 831.0000, 'ºC'),
	(219978, 119, '2014-03-01 00:18:53.000000', 'temperatura', 498.0000, 'ºC'),
	(219979, 119, '2014-03-01 00:18:54.000000', 'temperatura', 1198.0000, 'ºC'),
	(219980, 119, '2014-03-01 00:18:55.000000', 'temperatura', 898.0000, 'ºC'),
	(219981, 119, '2014-03-01 00:18:56.000000', 'temperatura', 895.0000, 'ºC'),
	(219982, 119, '2014-03-01 00:18:57.000000', 'temperatura', 583.0000, 'ºC'),
	(219983, 119, '2014-03-01 00:18:58.000000', 'temperatura', 232.0000, 'ºC'),
	(219984, 119, '2014-03-01 00:18:59.000000', 'temperatura', 609.0000, 'ºC'),
	(219985, 119, '2014-03-01 00:19:00.000000', 'temperatura', 1151.0000, 'ºC'),
	(219986, 119, '2014-03-01 00:19:01.000000', 'temperatura', 330.0000, 'ºC'),
	(219987, 119, '2014-03-01 00:19:02.000000', 'temperatura', 596.0000, 'ºC'),
	(219988, 119, '2014-03-01 00:19:03.000000', 'temperatura', 790.0000, 'ºC'),
	(219989, 119, '2014-03-01 00:19:04.000000', 'temperatura', 964.0000, 'ºC'),
	(219990, 119, '2014-03-01 00:19:05.000000', 'temperatura', 50.0000, 'ºC'),
	(219991, 119, '2014-03-01 00:19:06.000000', 'temperatura', 958.0000, 'ºC'),
	(219992, 119, '2014-03-01 00:19:07.000000', 'temperatura', 1039.0000, 'ºC'),
	(219993, 119, '2014-03-01 00:19:08.000000', 'temperatura', 1122.0000, 'ºC'),
	(219994, 119, '2014-03-01 00:19:09.000000', 'temperatura', 94.0000, 'ºC'),
	(219995, 119, '2014-03-01 00:19:10.000000', 'temperatura', 706.0000, 'ºC'),
	(219996, 119, '2014-03-01 00:19:11.000000', 'temperatura', 849.0000, 'ºC'),
	(219997, 119, '2014-03-01 00:19:12.000000', 'temperatura', 927.0000, 'ºC'),
	(219998, 119, '2014-03-01 00:19:13.000000', 'temperatura', 888.0000, 'ºC'),
	(219999, 119, '2014-03-01 00:19:14.000000', 'temperatura', 461.0000, 'ºC'),
	(220000, 119, '2014-03-01 00:19:15.000000', 'temperatura', 839.0000, 'ºC'),
	(220001, 119, '2014-03-01 00:19:16.000000', 'temperatura', 413.0000, 'ºC'),
	(220002, 119, '2014-03-01 00:19:17.000000', 'temperatura', 750.0000, 'ºC'),
	(220003, 119, '2014-03-01 00:19:18.000000', 'temperatura', 111.0000, 'ºC'),
	(220004, 119, '2014-03-01 00:19:19.000000', 'temperatura', 706.0000, 'ºC'),
	(220005, 119, '2014-03-01 00:19:20.000000', 'temperatura', 795.0000, 'ºC'),
	(220006, 119, '2014-03-01 00:19:21.000000', 'temperatura', 659.0000, 'ºC'),
	(220007, 119, '2014-03-01 00:19:22.000000', 'temperatura', 910.0000, 'ºC'),
	(220008, 119, '2014-03-01 00:19:23.000000', 'temperatura', 173.0000, 'ºC'),
	(220009, 119, '2014-03-01 00:19:24.000000', 'temperatura', 537.0000, 'ºC'),
	(220010, 119, '2014-03-01 00:19:25.000000', 'temperatura', 966.0000, 'ºC'),
	(220011, 119, '2014-03-01 00:19:26.000000', 'temperatura', 818.0000, 'ºC'),
	(220012, 119, '2014-03-01 00:19:27.000000', 'temperatura', 1192.0000, 'ºC'),
	(220013, 119, '2014-03-01 00:19:28.000000', 'temperatura', 1109.0000, 'ºC'),
	(220014, 119, '2014-03-01 00:19:29.000000', 'temperatura', 767.0000, 'ºC'),
	(220015, 119, '2014-03-01 00:19:30.000000', 'temperatura', 508.0000, 'ºC'),
	(220016, 119, '2014-03-01 00:19:31.000000', 'temperatura', 239.0000, 'ºC'),
	(220017, 119, '2014-03-01 00:19:32.000000', 'temperatura', 872.0000, 'ºC'),
	(220018, 119, '2014-03-01 00:19:33.000000', 'temperatura', 43.0000, 'ºC'),
	(220019, 119, '2014-03-01 00:19:34.000000', 'temperatura', 1199.0000, 'ºC'),
	(220020, 119, '2014-03-01 00:19:35.000000', 'temperatura', 1066.0000, 'ºC'),
	(220021, 119, '2014-03-01 00:19:36.000000', 'temperatura', 534.0000, 'ºC'),
	(220022, 119, '2014-03-01 00:19:37.000000', 'temperatura', 674.0000, 'ºC'),
	(220023, 119, '2014-03-01 00:19:38.000000', 'temperatura', 566.0000, 'ºC'),
	(220024, 119, '2014-03-01 00:19:39.000000', 'temperatura', 810.0000, 'ºC'),
	(220025, 119, '2014-03-01 00:19:40.000000', 'temperatura', 1151.0000, 'ºC'),
	(220026, 119, '2014-03-01 00:19:41.000000', 'temperatura', 928.0000, 'ºC'),
	(220027, 119, '2014-03-01 00:19:42.000000', 'temperatura', 1188.0000, 'ºC'),
	(220028, 119, '2014-03-01 00:19:43.000000', 'temperatura', 757.0000, 'ºC'),
	(220029, 119, '2014-03-01 00:19:44.000000', 'temperatura', 220.0000, 'ºC'),
	(220030, 119, '2014-03-01 00:19:45.000000', 'temperatura', 30.0000, 'ºC'),
	(220031, 119, '2014-03-01 00:19:46.000000', 'temperatura', 689.0000, 'ºC'),
	(220032, 119, '2014-03-01 00:19:47.000000', 'temperatura', 958.0000, 'ºC'),
	(220033, 119, '2014-03-01 00:19:48.000000', 'temperatura', 321.0000, 'ºC'),
	(220034, 119, '2014-03-01 00:19:49.000000', 'temperatura', 1131.0000, 'ºC'),
	(220035, 119, '2014-03-01 00:19:50.000000', 'temperatura', 1092.0000, 'ºC'),
	(220036, 119, '2014-03-01 00:19:51.000000', 'temperatura', 868.0000, 'ºC'),
	(220037, 119, '2014-03-01 00:19:52.000000', 'temperatura', 1066.0000, 'ºC'),
	(220038, 119, '2014-03-01 00:19:53.000000', 'temperatura', 324.0000, 'ºC'),
	(220039, 119, '2014-03-01 00:19:54.000000', 'temperatura', 824.0000, 'ºC'),
	(220040, 119, '2014-03-01 00:19:55.000000', 'temperatura', 750.0000, 'ºC'),
	(220041, 119, '2014-03-01 00:19:56.000000', 'temperatura', 77.0000, 'ºC'),
	(220042, 119, '2014-03-01 00:19:57.000000', 'temperatura', 536.0000, 'ºC'),
	(220043, 119, '2014-03-01 00:19:58.000000', 'temperatura', 50.0000, 'ºC'),
	(220044, 119, '2014-03-01 00:19:59.000000', 'temperatura', 1041.0000, 'ºC'),
	(220045, 119, '2014-03-01 00:20:00.000000', 'temperatura', 258.0000, 'ºC'),
	(220046, 119, '2014-03-01 00:20:01.000000', 'temperatura', 565.0000, 'ºC'),
	(220047, 119, '2014-03-01 00:20:02.000000', 'temperatura', 853.0000, 'ºC'),
	(220048, 119, '2014-03-01 00:20:03.000000', 'temperatura', 169.0000, 'ºC'),
	(220049, 119, '2014-03-01 00:20:04.000000', 'temperatura', 687.0000, 'ºC'),
	(220050, 119, '2014-03-01 00:20:05.000000', 'temperatura', 528.0000, 'ºC'),
	(220051, 119, '2014-03-01 00:20:06.000000', 'temperatura', 581.0000, 'ºC'),
	(220052, 119, '2014-03-01 00:20:07.000000', 'temperatura', 122.0000, 'ºC'),
	(220053, 119, '2014-03-01 00:20:08.000000', 'temperatura', 66.0000, 'ºC'),
	(220054, 119, '2014-03-01 00:20:09.000000', 'temperatura', 1166.0000, 'ºC'),
	(220055, 119, '2014-03-01 00:20:10.000000', 'temperatura', 832.0000, 'ºC'),
	(220056, 119, '2014-03-01 00:20:11.000000', 'temperatura', 662.0000, 'ºC'),
	(220057, 119, '2014-03-01 00:20:12.000000', 'temperatura', 816.0000, 'ºC'),
	(220058, 119, '2014-03-01 00:20:13.000000', 'temperatura', 894.0000, 'ºC'),
	(220059, 119, '2014-03-01 00:20:14.000000', 'temperatura', 820.0000, 'ºC'),
	(220060, 119, '2014-03-01 00:20:15.000000', 'temperatura', 221.0000, 'ºC'),
	(220061, 119, '2014-03-01 00:20:16.000000', 'temperatura', 1046.0000, 'ºC'),
	(220062, 119, '2014-03-01 00:20:17.000000', 'temperatura', 968.0000, 'ºC'),
	(220063, 119, '2014-03-01 00:20:18.000000', 'temperatura', 501.0000, 'ºC'),
	(220064, 119, '2014-03-01 00:20:19.000000', 'temperatura', 802.0000, 'ºC'),
	(220065, 119, '2014-03-01 00:20:20.000000', 'temperatura', 109.0000, 'ºC'),
	(220066, 119, '2014-03-01 00:20:21.000000', 'temperatura', 539.0000, 'ºC'),
	(220067, 119, '2014-03-01 00:20:22.000000', 'temperatura', 1167.0000, 'ºC'),
	(220068, 119, '2014-03-01 00:20:23.000000', 'temperatura', 620.0000, 'ºC'),
	(220069, 119, '2014-03-01 00:20:24.000000', 'temperatura', 799.0000, 'ºC'),
	(220070, 119, '2014-03-01 00:20:25.000000', 'temperatura', 934.0000, 'ºC'),
	(220071, 119, '2014-03-01 00:20:26.000000', 'temperatura', 1073.0000, 'ºC'),
	(220072, 119, '2014-03-01 00:20:27.000000', 'temperatura', 166.0000, 'ºC'),
	(220073, 119, '2014-03-01 00:20:28.000000', 'temperatura', 13.0000, 'ºC'),
	(220074, 119, '2014-03-01 00:20:29.000000', 'temperatura', 764.0000, 'ºC'),
	(220075, 119, '2014-03-01 00:20:30.000000', 'temperatura', 182.0000, 'ºC'),
	(220076, 119, '2014-03-01 00:20:31.000000', 'temperatura', 1017.0000, 'ºC'),
	(220077, 119, '2014-03-01 00:20:32.000000', 'temperatura', 943.0000, 'ºC'),
	(220078, 119, '2014-03-01 00:20:33.000000', 'temperatura', 463.0000, 'ºC'),
	(220079, 119, '2014-03-01 00:20:34.000000', 'temperatura', 686.0000, 'ºC'),
	(220080, 119, '2014-03-01 00:20:35.000000', 'temperatura', 844.0000, 'ºC'),
	(220081, 119, '2014-03-01 00:20:36.000000', 'temperatura', 961.0000, 'ºC'),
	(220082, 119, '2014-03-01 00:20:37.000000', 'temperatura', 1071.0000, 'ºC'),
	(220083, 119, '2014-03-01 00:20:38.000000', 'temperatura', 76.0000, 'ºC'),
	(220084, 119, '2014-03-01 00:20:39.000000', 'temperatura', 765.0000, 'ºC'),
	(220085, 119, '2014-03-01 00:20:40.000000', 'temperatura', 0.0000, 'ºC'),
	(220086, 119, '2014-03-01 00:20:41.000000', 'temperatura', 105.0000, 'ºC'),
	(220087, 119, '2014-03-01 00:20:42.000000', 'temperatura', 525.0000, 'ºC'),
	(220088, 119, '2014-03-01 00:20:43.000000', 'temperatura', 1111.0000, 'ºC'),
	(220089, 119, '2014-03-01 00:20:44.000000', 'temperatura', 378.0000, 'ºC'),
	(220090, 119, '2014-03-01 00:20:45.000000', 'temperatura', 959.0000, 'ºC'),
	(220091, 119, '2014-03-01 00:20:46.000000', 'temperatura', 63.0000, 'ºC'),
	(220092, 119, '2014-03-01 00:20:47.000000', 'temperatura', 1038.0000, 'ºC'),
	(220093, 119, '2014-03-01 00:20:48.000000', 'temperatura', 202.0000, 'ºC'),
	(220094, 119, '2014-03-01 00:20:49.000000', 'temperatura', 296.0000, 'ºC'),
	(220095, 119, '2014-03-01 00:20:50.000000', 'temperatura', 873.0000, 'ºC'),
	(220096, 119, '2014-03-01 00:20:51.000000', 'temperatura', 1079.0000, 'ºC'),
	(220097, 119, '2014-03-01 00:20:52.000000', 'temperatura', 375.0000, 'ºC'),
	(220098, 119, '2014-03-01 00:20:53.000000', 'temperatura', 1039.0000, 'ºC'),
	(220099, 119, '2014-03-01 00:20:54.000000', 'temperatura', 469.0000, 'ºC'),
	(220100, 119, '2014-03-01 00:20:55.000000', 'temperatura', 429.0000, 'ºC'),
	(220101, 119, '2014-03-01 00:20:56.000000', 'temperatura', 737.0000, 'ºC'),
	(220102, 119, '2014-03-01 00:20:57.000000', 'temperatura', 1.0000, 'ºC'),
	(220103, 119, '2014-03-01 00:20:58.000000', 'temperatura', 194.0000, 'ºC'),
	(220104, 119, '2014-03-01 00:20:59.000000', 'temperatura', 968.0000, 'ºC'),
	(220105, 119, '2014-03-01 00:21:00.000000', 'temperatura', 658.0000, 'ºC'),
	(220106, 119, '2014-03-01 00:21:01.000000', 'temperatura', 388.0000, 'ºC'),
	(220107, 119, '2014-03-01 00:21:02.000000', 'temperatura', 1165.0000, 'ºC'),
	(220108, 119, '2014-03-01 00:21:03.000000', 'temperatura', 1061.0000, 'ºC'),
	(220109, 119, '2014-03-01 00:21:04.000000', 'temperatura', 611.0000, 'ºC'),
	(220110, 119, '2014-03-01 00:21:05.000000', 'temperatura', 1074.0000, 'ºC'),
	(220111, 119, '2014-03-01 00:21:06.000000', 'temperatura', 1138.0000, 'ºC'),
	(220112, 119, '2014-03-01 00:21:07.000000', 'temperatura', 70.0000, 'ºC'),
	(220113, 119, '2014-03-01 00:21:08.000000', 'temperatura', 533.0000, 'ºC'),
	(220114, 119, '2014-03-01 00:21:09.000000', 'temperatura', 56.0000, 'ºC'),
	(220115, 119, '2014-03-01 00:21:10.000000', 'temperatura', 1081.0000, 'ºC'),
	(220116, 119, '2014-03-01 00:21:11.000000', 'temperatura', 438.0000, 'ºC'),
	(220117, 119, '2014-03-01 00:21:12.000000', 'temperatura', 147.0000, 'ºC'),
	(220118, 119, '2014-03-01 00:21:13.000000', 'temperatura', 623.0000, 'ºC'),
	(220119, 119, '2014-03-01 00:21:14.000000', 'temperatura', 274.0000, 'ºC'),
	(220120, 119, '2014-03-01 00:21:15.000000', 'temperatura', 699.0000, 'ºC'),
	(220121, 119, '2014-03-01 00:21:16.000000', 'temperatura', 276.0000, 'ºC'),
	(220122, 119, '2014-03-01 00:21:17.000000', 'temperatura', 485.0000, 'ºC'),
	(220123, 119, '2014-03-01 00:21:18.000000', 'temperatura', 396.0000, 'ºC'),
	(220124, 119, '2014-03-01 00:21:19.000000', 'temperatura', 525.0000, 'ºC'),
	(220125, 119, '2014-03-01 00:21:20.000000', 'temperatura', 236.0000, 'ºC'),
	(220126, 119, '2014-03-01 00:21:21.000000', 'temperatura', 807.0000, 'ºC'),
	(220127, 119, '2014-03-01 00:21:22.000000', 'temperatura', 928.0000, 'ºC'),
	(220128, 119, '2014-03-01 00:21:23.000000', 'temperatura', 1017.0000, 'ºC'),
	(220129, 119, '2014-03-01 00:21:24.000000', 'temperatura', 1105.0000, 'ºC'),
	(220130, 119, '2014-03-01 00:21:25.000000', 'temperatura', 73.0000, 'ºC'),
	(220131, 119, '2014-03-01 00:21:26.000000', 'temperatura', 651.0000, 'ºC'),
	(220132, 119, '2014-03-01 00:21:27.000000', 'temperatura', 636.0000, 'ºC'),
	(220133, 119, '2014-03-01 00:21:28.000000', 'temperatura', 28.0000, 'ºC'),
	(220134, 119, '2014-03-01 00:21:29.000000', 'temperatura', 630.0000, 'ºC'),
	(220135, 119, '2014-03-01 00:21:30.000000', 'temperatura', 669.0000, 'ºC'),
	(220136, 119, '2014-03-01 00:21:31.000000', 'temperatura', 254.0000, 'ºC'),
	(220137, 119, '2014-03-01 00:21:32.000000', 'temperatura', 464.0000, 'ºC'),
	(220138, 119, '2014-03-01 00:21:33.000000', 'temperatura', 357.0000, 'ºC'),
	(220139, 119, '2014-03-01 00:21:34.000000', 'temperatura', 394.0000, 'ºC'),
	(220140, 119, '2014-03-01 00:21:35.000000', 'temperatura', 898.0000, 'ºC'),
	(220141, 119, '2014-03-01 00:21:36.000000', 'temperatura', 911.0000, 'ºC'),
	(220142, 119, '2014-03-01 00:21:37.000000', 'temperatura', 660.0000, 'ºC'),
	(220143, 119, '2014-03-01 00:21:38.000000', 'temperatura', 566.0000, 'ºC'),
	(220144, 119, '2014-03-01 00:21:39.000000', 'temperatura', 852.0000, 'ºC'),
	(220145, 119, '2014-03-01 00:21:40.000000', 'temperatura', 164.0000, 'ºC'),
	(220146, 119, '2014-03-01 00:21:41.000000', 'temperatura', 662.0000, 'ºC'),
	(220147, 119, '2014-03-01 00:21:42.000000', 'temperatura', 419.0000, 'ºC'),
	(220148, 119, '2014-03-01 00:21:43.000000', 'temperatura', 112.0000, 'ºC'),
	(220149, 119, '2014-03-01 00:21:44.000000', 'temperatura', 500.0000, 'ºC'),
	(220150, 119, '2014-03-01 00:21:45.000000', 'temperatura', 966.0000, 'ºC'),
	(220151, 119, '2014-03-01 00:21:46.000000', 'temperatura', 930.0000, 'ºC'),
	(220152, 119, '2014-03-01 00:21:47.000000', 'temperatura', 552.0000, 'ºC'),
	(220153, 119, '2014-03-01 00:21:48.000000', 'temperatura', 1172.0000, 'ºC'),
	(220154, 119, '2014-03-01 00:21:49.000000', 'temperatura', 602.0000, 'ºC'),
	(220155, 119, '2014-03-01 00:21:50.000000', 'temperatura', 698.0000, 'ºC'),
	(220156, 119, '2014-03-01 00:21:51.000000', 'temperatura', 481.0000, 'ºC'),
	(220157, 119, '2014-03-01 00:21:52.000000', 'temperatura', 313.0000, 'ºC'),
	(220158, 119, '2014-03-01 00:21:53.000000', 'temperatura', 124.0000, 'ºC'),
	(220159, 119, '2014-03-01 00:21:54.000000', 'temperatura', 879.0000, 'ºC'),
	(220160, 119, '2014-03-01 00:21:55.000000', 'temperatura', 426.0000, 'ºC'),
	(220161, 119, '2014-03-01 00:21:56.000000', 'temperatura', 692.0000, 'ºC'),
	(220162, 119, '2014-03-01 00:21:57.000000', 'temperatura', 982.0000, 'ºC'),
	(220163, 119, '2014-03-01 00:21:58.000000', 'temperatura', 437.0000, 'ºC'),
	(220164, 119, '2014-03-01 00:21:59.000000', 'temperatura', 436.0000, 'ºC'),
	(220165, 119, '2014-03-01 00:22:00.000000', 'temperatura', 873.0000, 'ºC'),
	(220166, 119, '2014-03-01 00:22:01.000000', 'temperatura', 657.0000, 'ºC'),
	(220167, 119, '2014-03-01 00:22:02.000000', 'temperatura', 665.0000, 'ºC'),
	(220168, 119, '2014-03-01 00:22:03.000000', 'temperatura', 154.0000, 'ºC'),
	(220169, 119, '2014-03-01 00:22:04.000000', 'temperatura', 1175.0000, 'ºC'),
	(220170, 119, '2014-03-01 00:22:05.000000', 'temperatura', 615.0000, 'ºC'),
	(220171, 119, '2014-03-01 00:22:06.000000', 'temperatura', 751.0000, 'ºC'),
	(220172, 119, '2014-03-01 00:22:07.000000', 'temperatura', 710.0000, 'ºC'),
	(220173, 119, '2014-03-01 00:22:08.000000', 'temperatura', 96.0000, 'ºC'),
	(220174, 119, '2014-03-01 00:22:09.000000', 'temperatura', 751.0000, 'ºC'),
	(220175, 119, '2014-03-01 00:22:10.000000', 'temperatura', 1066.0000, 'ºC'),
	(220176, 119, '2014-03-01 00:22:11.000000', 'temperatura', 678.0000, 'ºC'),
	(220177, 119, '2014-03-01 00:22:12.000000', 'temperatura', 192.0000, 'ºC'),
	(220178, 119, '2014-03-01 00:22:13.000000', 'temperatura', 126.0000, 'ºC'),
	(220179, 119, '2014-03-01 00:22:14.000000', 'temperatura', 54.0000, 'ºC'),
	(220180, 119, '2014-03-01 00:22:15.000000', 'temperatura', 1095.0000, 'ºC'),
	(220181, 119, '2014-03-01 00:22:16.000000', 'temperatura', 513.0000, 'ºC'),
	(220182, 119, '2014-03-01 00:22:17.000000', 'temperatura', 479.0000, 'ºC'),
	(220183, 119, '2014-03-01 00:22:18.000000', 'temperatura', 859.0000, 'ºC'),
	(220184, 119, '2014-03-01 00:22:19.000000', 'temperatura', 456.0000, 'ºC'),
	(220185, 119, '2014-03-01 00:22:20.000000', 'temperatura', 904.0000, 'ºC'),
	(220186, 119, '2014-03-01 00:22:21.000000', 'temperatura', 754.0000, 'ºC'),
	(220187, 119, '2014-03-01 00:22:22.000000', 'temperatura', 1058.0000, 'ºC'),
	(220188, 119, '2014-03-01 00:22:23.000000', 'temperatura', 627.0000, 'ºC'),
	(220189, 119, '2014-03-01 00:22:24.000000', 'temperatura', 1163.0000, 'ºC'),
	(220190, 119, '2014-03-01 00:22:25.000000', 'temperatura', 336.0000, 'ºC'),
	(220191, 119, '2014-03-01 00:22:26.000000', 'temperatura', 589.0000, 'ºC'),
	(220192, 119, '2014-03-01 00:22:27.000000', 'temperatura', 738.0000, 'ºC'),
	(220193, 119, '2014-03-01 00:22:28.000000', 'temperatura', 726.0000, 'ºC'),
	(220194, 119, '2014-03-01 00:22:29.000000', 'temperatura', 214.0000, 'ºC'),
	(220195, 119, '2014-03-01 00:22:30.000000', 'temperatura', 94.0000, 'ºC'),
	(220196, 119, '2014-03-01 00:22:31.000000', 'temperatura', 1030.0000, 'ºC'),
	(220197, 119, '2014-03-01 00:22:32.000000', 'temperatura', 66.0000, 'ºC'),
	(220198, 119, '2014-03-01 00:22:33.000000', 'temperatura', 843.0000, 'ºC'),
	(220199, 119, '2014-03-01 00:22:34.000000', 'temperatura', 414.0000, 'ºC'),
	(220200, 119, '2014-03-01 00:22:35.000000', 'temperatura', 745.0000, 'ºC'),
	(220201, 119, '2014-03-01 00:22:36.000000', 'temperatura', 83.0000, 'ºC'),
	(220202, 119, '2014-03-01 00:22:37.000000', 'temperatura', 579.0000, 'ºC'),
	(220203, 119, '2014-03-01 00:22:38.000000', 'temperatura', 245.0000, 'ºC'),
	(220204, 119, '2014-03-01 00:22:39.000000', 'temperatura', 690.0000, 'ºC'),
	(220205, 119, '2014-03-01 00:22:40.000000', 'temperatura', 316.0000, 'ºC'),
	(220206, 119, '2014-03-01 00:22:41.000000', 'temperatura', 711.0000, 'ºC'),
	(220207, 119, '2014-03-01 00:22:42.000000', 'temperatura', 208.0000, 'ºC'),
	(220208, 119, '2014-03-01 00:22:43.000000', 'temperatura', 107.0000, 'ºC'),
	(220209, 119, '2014-03-01 00:22:44.000000', 'temperatura', 1111.0000, 'ºC'),
	(220210, 119, '2014-03-01 00:22:45.000000', 'temperatura', 435.0000, 'ºC'),
	(220211, 119, '2014-03-01 00:22:46.000000', 'temperatura', 42.0000, 'ºC'),
	(220212, 119, '2014-03-01 00:22:47.000000', 'temperatura', 108.0000, 'ºC'),
	(220213, 119, '2014-03-01 00:22:48.000000', 'temperatura', 412.0000, 'ºC'),
	(220214, 119, '2014-03-01 00:22:49.000000', 'temperatura', 536.0000, 'ºC'),
	(220215, 119, '2014-03-01 00:22:50.000000', 'temperatura', 245.0000, 'ºC'),
	(220216, 119, '2014-03-01 00:22:51.000000', 'temperatura', 820.0000, 'ºC'),
	(220217, 119, '2014-03-01 00:22:52.000000', 'temperatura', 962.0000, 'ºC'),
	(220218, 119, '2014-03-01 00:22:53.000000', 'temperatura', 1153.0000, 'ºC'),
	(220219, 119, '2014-03-01 00:22:54.000000', 'temperatura', 478.0000, 'ºC'),
	(220220, 119, '2014-03-01 00:22:55.000000', 'temperatura', 132.0000, 'ºC'),
	(220221, 119, '2014-03-01 00:22:56.000000', 'temperatura', 426.0000, 'ºC'),
	(220222, 119, '2014-03-01 00:22:57.000000', 'temperatura', 535.0000, 'ºC'),
	(220223, 119, '2014-03-01 00:22:58.000000', 'temperatura', 196.0000, 'ºC'),
	(220224, 119, '2014-03-01 00:22:59.000000', 'temperatura', 576.0000, 'ºC'),
	(220225, 119, '2014-03-01 00:23:00.000000', 'temperatura', 1092.0000, 'ºC'),
	(220226, 119, '2014-03-01 00:23:01.000000', 'temperatura', 132.0000, 'ºC'),
	(220227, 119, '2014-03-01 00:23:02.000000', 'temperatura', 983.0000, 'ºC'),
	(220228, 119, '2014-03-01 00:23:03.000000', 'temperatura', 922.0000, 'ºC'),
	(220229, 119, '2014-03-01 00:23:04.000000', 'temperatura', 461.0000, 'ºC'),
	(220230, 119, '2014-03-01 00:23:05.000000', 'temperatura', 739.0000, 'ºC'),
	(220231, 119, '2014-03-01 00:23:06.000000', 'temperatura', 1113.0000, 'ºC'),
	(220232, 119, '2014-03-01 00:23:07.000000', 'temperatura', 949.0000, 'ºC'),
	(220233, 119, '2014-03-01 00:23:08.000000', 'temperatura', 206.0000, 'ºC'),
	(220234, 119, '2014-03-01 00:23:09.000000', 'temperatura', 585.0000, 'ºC'),
	(220235, 119, '2014-03-01 00:23:10.000000', 'temperatura', 1105.0000, 'ºC'),
	(220236, 119, '2014-03-01 00:23:11.000000', 'temperatura', 172.0000, 'ºC'),
	(220237, 119, '2014-03-01 00:23:12.000000', 'temperatura', 1144.0000, 'ºC'),
	(220238, 119, '2014-03-01 00:23:13.000000', 'temperatura', 405.0000, 'ºC'),
	(220239, 119, '2014-03-01 00:23:14.000000', 'temperatura', 995.0000, 'ºC'),
	(220240, 119, '2014-03-01 00:23:15.000000', 'temperatura', 159.0000, 'ºC'),
	(220241, 119, '2014-03-01 00:23:16.000000', 'temperatura', 209.0000, 'ºC'),
	(220242, 119, '2014-03-01 00:23:17.000000', 'temperatura', 569.0000, 'ºC'),
	(220243, 119, '2014-03-01 00:23:18.000000', 'temperatura', 1021.0000, 'ºC'),
	(220244, 119, '2014-03-01 00:23:19.000000', 'temperatura', 997.0000, 'ºC'),
	(220245, 119, '2014-03-01 00:23:20.000000', 'temperatura', 722.0000, 'ºC'),
	(220246, 119, '2014-03-01 00:23:21.000000', 'temperatura', 618.0000, 'ºC'),
	(220247, 119, '2014-03-01 00:23:22.000000', 'temperatura', 925.0000, 'ºC'),
	(220248, 119, '2014-03-01 00:23:23.000000', 'temperatura', 373.0000, 'ºC'),
	(220249, 119, '2014-03-01 00:23:24.000000', 'temperatura', 290.0000, 'ºC'),
	(220250, 119, '2014-03-01 00:23:25.000000', 'temperatura', 332.0000, 'ºC'),
	(220251, 119, '2014-03-01 00:23:26.000000', 'temperatura', 788.0000, 'ºC'),
	(220252, 119, '2014-03-01 00:23:27.000000', 'temperatura', 546.0000, 'ºC'),
	(220253, 119, '2014-03-01 00:23:28.000000', 'temperatura', 366.0000, 'ºC'),
	(220254, 119, '2014-03-01 00:23:29.000000', 'temperatura', 192.0000, 'ºC'),
	(220255, 119, '2014-03-01 00:23:30.000000', 'temperatura', 1064.0000, 'ºC'),
	(220256, 119, '2014-03-01 00:23:31.000000', 'temperatura', 1142.0000, 'ºC'),
	(220257, 119, '2014-03-01 00:23:32.000000', 'temperatura', 121.0000, 'ºC'),
	(220258, 119, '2014-03-01 00:23:33.000000', 'temperatura', 780.0000, 'ºC'),
	(220259, 119, '2014-03-01 00:23:34.000000', 'temperatura', 1136.0000, 'ºC'),
	(220260, 119, '2014-03-01 00:23:35.000000', 'temperatura', 941.0000, 'ºC'),
	(220261, 119, '2014-03-01 00:23:36.000000', 'temperatura', 96.0000, 'ºC'),
	(220262, 119, '2014-03-01 00:23:37.000000', 'temperatura', 57.0000, 'ºC'),
	(220263, 119, '2014-03-01 00:23:38.000000', 'temperatura', 1196.0000, 'ºC'),
	(220264, 119, '2014-03-01 00:23:39.000000', 'temperatura', 1013.0000, 'ºC'),
	(220265, 119, '2014-03-01 00:23:40.000000', 'temperatura', 277.0000, 'ºC'),
	(220266, 119, '2014-03-01 00:23:41.000000', 'temperatura', 746.0000, 'ºC'),
	(220267, 119, '2014-03-01 00:23:42.000000', 'temperatura', 500.0000, 'ºC'),
	(220268, 119, '2014-03-01 00:23:43.000000', 'temperatura', 262.0000, 'ºC'),
	(220269, 119, '2014-03-01 00:23:44.000000', 'temperatura', 1013.0000, 'ºC'),
	(220270, 119, '2014-03-01 00:23:45.000000', 'temperatura', 677.0000, 'ºC'),
	(220271, 119, '2014-03-01 00:23:46.000000', 'temperatura', 345.0000, 'ºC'),
	(220272, 119, '2014-03-01 00:23:47.000000', 'temperatura', 897.0000, 'ºC'),
	(220273, 119, '2014-03-01 00:23:48.000000', 'temperatura', 1050.0000, 'ºC'),
	(220274, 119, '2014-03-01 00:23:49.000000', 'temperatura', 159.0000, 'ºC'),
	(220275, 119, '2014-03-01 00:23:50.000000', 'temperatura', 47.0000, 'ºC'),
	(220276, 119, '2014-03-01 00:23:51.000000', 'temperatura', 959.0000, 'ºC'),
	(220277, 119, '2014-03-01 00:23:52.000000', 'temperatura', 1054.0000, 'ºC'),
	(220278, 119, '2014-03-01 00:23:53.000000', 'temperatura', 1193.0000, 'ºC'),
	(220279, 119, '2014-03-01 00:23:54.000000', 'temperatura', 403.0000, 'ºC'),
	(220280, 119, '2014-03-01 00:23:55.000000', 'temperatura', 839.0000, 'ºC'),
	(220281, 119, '2014-03-01 00:23:56.000000', 'temperatura', 585.0000, 'ºC'),
	(220282, 119, '2014-03-01 00:23:57.000000', 'temperatura', 407.0000, 'ºC'),
	(220283, 119, '2014-03-01 00:23:58.000000', 'temperatura', 282.0000, 'ºC'),
	(220284, 119, '2014-03-01 00:23:59.000000', 'temperatura', 191.0000, 'ºC'),
	(220285, 119, '2014-03-01 00:24:00.000000', 'temperatura', 108.0000, 'ºC'),
	(220286, 119, '2014-03-01 00:24:01.000000', 'temperatura', 1166.0000, 'ºC'),
	(220287, 119, '2014-03-01 00:24:02.000000', 'temperatura', 707.0000, 'ºC'),
	(220288, 119, '2014-03-01 00:24:03.000000', 'temperatura', 38.0000, 'ºC'),
	(220289, 119, '2014-03-01 00:24:04.000000', 'temperatura', 469.0000, 'ºC'),
	(220290, 119, '2014-03-01 00:24:05.000000', 'temperatura', 1033.0000, 'ºC'),
	(220291, 119, '2014-03-01 00:24:06.000000', 'temperatura', 159.0000, 'ºC'),
	(220292, 119, '2014-03-01 00:24:07.000000', 'temperatura', 97.0000, 'ºC'),
	(220293, 119, '2014-03-01 00:24:08.000000', 'temperatura', 6.0000, 'ºC'),
	(220294, 119, '2014-03-01 00:24:09.000000', 'temperatura', 942.0000, 'ºC'),
	(220295, 119, '2014-03-01 00:24:10.000000', 'temperatura', 1089.0000, 'ºC'),
	(220296, 119, '2014-03-01 00:24:11.000000', 'temperatura', 223.0000, 'ºC'),
	(220297, 119, '2014-03-01 00:24:12.000000', 'temperatura', 247.0000, 'ºC'),
	(220298, 119, '2014-03-01 00:24:13.000000', 'temperatura', 569.0000, 'ºC'),
	(220299, 119, '2014-03-01 00:24:14.000000', 'temperatura', 901.0000, 'ºC'),
	(220300, 119, '2014-03-01 00:24:15.000000', 'temperatura', 402.0000, 'ºC'),
	(220301, 119, '2014-03-01 00:24:16.000000', 'temperatura', 505.0000, 'ºC'),
	(220302, 119, '2014-03-01 00:24:17.000000', 'temperatura', 120.0000, 'ºC'),
	(220303, 119, '2014-03-01 00:24:18.000000', 'temperatura', 285.0000, 'ºC'),
	(220304, 119, '2014-03-01 00:24:19.000000', 'temperatura', 1067.0000, 'ºC'),
	(220305, 119, '2014-03-01 00:24:20.000000', 'temperatura', 880.0000, 'ºC'),
	(220306, 119, '2014-03-01 00:24:21.000000', 'temperatura', 1198.0000, 'ºC'),
	(220307, 119, '2014-03-01 00:24:22.000000', 'temperatura', 952.0000, 'ºC'),
	(220308, 119, '2014-03-01 00:24:23.000000', 'temperatura', 1165.0000, 'ºC'),
	(220309, 119, '2014-03-01 00:24:24.000000', 'temperatura', 572.0000, 'ºC'),
	(220310, 119, '2014-03-01 00:24:25.000000', 'temperatura', 564.0000, 'ºC'),
	(220311, 119, '2014-03-01 00:24:26.000000', 'temperatura', 1106.0000, 'ºC'),
	(220312, 119, '2014-03-01 00:24:27.000000', 'temperatura', 237.0000, 'ºC'),
	(220313, 119, '2014-03-01 00:24:28.000000', 'temperatura', 268.0000, 'ºC'),
	(220314, 119, '2014-03-01 00:24:29.000000', 'temperatura', 631.0000, 'ºC'),
	(220315, 119, '2014-03-01 00:24:30.000000', 'temperatura', 1151.0000, 'ºC'),
	(220316, 119, '2014-03-01 00:24:31.000000', 'temperatura', 262.0000, 'ºC'),
	(220317, 119, '2014-03-01 00:24:32.000000', 'temperatura', 256.0000, 'ºC'),
	(220318, 119, '2014-03-01 00:24:33.000000', 'temperatura', 497.0000, 'ºC'),
	(220319, 119, '2014-03-01 00:24:34.000000', 'temperatura', 517.0000, 'ºC'),
	(220320, 119, '2014-03-01 00:24:35.000000', 'temperatura', 1094.0000, 'ºC'),
	(220321, 119, '2014-03-01 00:24:36.000000', 'temperatura', 319.0000, 'ºC'),
	(220322, 119, '2014-03-01 00:24:37.000000', 'temperatura', 713.0000, 'ºC'),
	(220323, 119, '2014-03-01 00:24:38.000000', 'temperatura', 210.0000, 'ºC'),
	(220324, 119, '2014-03-01 00:24:39.000000', 'temperatura', 112.0000, 'ºC'),
	(220325, 119, '2014-03-01 00:24:40.000000', 'temperatura', 1130.0000, 'ºC'),
	(220326, 119, '2014-03-01 00:24:41.000000', 'temperatura', 516.0000, 'ºC'),
	(220327, 119, '2014-03-01 00:24:42.000000', 'temperatura', 389.0000, 'ºC'),
	(220328, 119, '2014-03-01 00:24:43.000000', 'temperatura', 397.0000, 'ºC'),
	(220329, 119, '2014-03-01 00:24:44.000000', 'temperatura', 820.0000, 'ºC'),
	(220330, 119, '2014-03-01 00:24:45.000000', 'temperatura', 510.0000, 'ºC'),
	(220331, 119, '2014-03-01 00:24:46.000000', 'temperatura', 90.0000, 'ºC'),
	(220332, 119, '2014-03-01 00:24:47.000000', 'temperatura', 120.0000, 'ºC'),
	(220333, 119, '2014-03-01 00:24:48.000000', 'temperatura', 332.0000, 'ºC'),
	(220334, 119, '2014-03-01 00:24:49.000000', 'temperatura', 99.0000, 'ºC'),
	(220335, 119, '2014-03-01 00:24:50.000000', 'temperatura', 699.0000, 'ºC'),
	(220336, 119, '2014-03-01 00:24:51.000000', 'temperatura', 799.0000, 'ºC'),
	(220337, 119, '2014-03-01 00:24:52.000000', 'temperatura', 701.0000, 'ºC'),
	(220338, 119, '2014-03-01 00:24:53.000000', 'temperatura', 1105.0000, 'ºC'),
	(220339, 119, '2014-03-01 00:24:54.000000', 'temperatura', 1025.0000, 'ºC'),
	(220340, 119, '2014-03-01 00:24:55.000000', 'temperatura', 608.0000, 'ºC'),
	(220341, 119, '2014-03-01 00:24:56.000000', 'temperatura', 1166.0000, 'ºC'),
	(220342, 119, '2014-03-01 00:24:57.000000', 'temperatura', 407.0000, 'ºC'),
	(220343, 119, '2014-03-01 00:24:58.000000', 'temperatura', 937.0000, 'ºC'),
	(220344, 119, '2014-03-01 00:24:59.000000', 'temperatura', 1065.0000, 'ºC'),
	(220345, 119, '2014-03-01 00:25:00.000000', 'temperatura', 115.0000, 'ºC'),
	(220346, 119, '2014-03-01 00:25:01.000000', 'temperatura', 978.0000, 'ºC'),
	(220347, 119, '2014-03-01 00:25:02.000000', 'temperatura', 947.0000, 'ºC'),
	(220348, 119, '2014-03-01 00:25:03.000000', 'temperatura', 600.0000, 'ºC'),
	(220349, 119, '2014-03-01 00:25:04.000000', 'temperatura', 160.0000, 'ºC'),
	(220350, 119, '2014-03-01 00:25:05.000000', 'temperatura', 202.0000, 'ºC'),
	(220351, 119, '2014-03-01 00:25:06.000000', 'temperatura', 528.0000, 'ºC'),
	(220352, 119, '2014-03-01 00:25:07.000000', 'temperatura', 835.0000, 'ºC'),
	(220353, 119, '2014-03-01 00:25:08.000000', 'temperatura', 191.0000, 'ºC'),
	(220354, 119, '2014-03-01 00:25:09.000000', 'temperatura', 853.0000, 'ºC'),
	(220355, 119, '2014-03-01 00:25:10.000000', 'temperatura', 90.0000, 'ºC'),
	(220356, 119, '2014-03-01 00:25:11.000000', 'temperatura', 293.0000, 'ºC'),
	(220357, 119, '2014-03-01 00:25:12.000000', 'temperatura', 1195.0000, 'ºC'),
	(220358, 119, '2014-03-01 00:25:13.000000', 'temperatura', 295.0000, 'ºC'),
	(220359, 119, '2014-03-01 00:25:14.000000', 'temperatura', 292.0000, 'ºC'),
	(220360, 119, '2014-03-01 00:25:15.000000', 'temperatura', 574.0000, 'ºC'),
	(220361, 119, '2014-03-01 00:25:16.000000', 'temperatura', 796.0000, 'ºC'),
	(220362, 119, '2014-03-01 00:25:17.000000', 'temperatura', 1056.0000, 'ºC'),
	(220363, 119, '2014-03-01 00:25:18.000000', 'temperatura', 494.0000, 'ºC'),
	(220364, 119, '2014-03-01 00:25:19.000000', 'temperatura', 501.0000, 'ºC'),
	(220365, 119, '2014-03-01 00:25:20.000000', 'temperatura', 1025.0000, 'ºC'),
	(220366, 119, '2014-03-01 00:25:21.000000', 'temperatura', 23.0000, 'ºC'),
	(220367, 119, '2014-03-01 00:25:22.000000', 'temperatura', 640.0000, 'ºC'),
	(220368, 119, '2014-03-01 00:25:23.000000', 'temperatura', 732.0000, 'ºC'),
	(220369, 119, '2014-03-01 00:25:24.000000', 'temperatura', 538.0000, 'ºC'),
	(220370, 119, '2014-03-01 00:25:25.000000', 'temperatura', 498.0000, 'ºC'),
	(220371, 119, '2014-03-01 00:25:26.000000', 'temperatura', 873.0000, 'ºC'),
	(220372, 119, '2014-03-01 00:25:27.000000', 'temperatura', 474.0000, 'ºC'),
	(220373, 119, '2014-03-01 00:25:28.000000', 'temperatura', 950.0000, 'ºC'),
	(220374, 119, '2014-03-01 00:25:29.000000', 'temperatura', 929.0000, 'ºC'),
	(220375, 119, '2014-03-01 00:25:30.000000', 'temperatura', 597.0000, 'ºC'),
	(220376, 119, '2014-03-01 00:25:31.000000', 'temperatura', 197.0000, 'ºC'),
	(220377, 119, '2014-03-01 00:25:32.000000', 'temperatura', 394.0000, 'ºC'),
	(220378, 119, '2014-03-01 00:25:33.000000', 'temperatura', 179.0000, 'ºC'),
	(220379, 119, '2014-03-01 00:25:34.000000', 'temperatura', 914.0000, 'ºC'),
	(220380, 119, '2014-03-01 00:25:35.000000', 'temperatura', 436.0000, 'ºC'),
	(220381, 119, '2014-03-01 00:25:36.000000', 'temperatura', 635.0000, 'ºC'),
	(220382, 119, '2014-03-01 00:25:37.000000', 'temperatura', 670.0000, 'ºC'),
	(220383, 119, '2014-03-01 00:25:38.000000', 'temperatura', 246.0000, 'ºC'),
	(220384, 119, '2014-03-01 00:25:39.000000', 'temperatura', 420.0000, 'ºC'),
	(220385, 119, '2014-03-01 00:25:40.000000', 'temperatura', 163.0000, 'ºC'),
	(220386, 119, '2014-03-01 00:25:41.000000', 'temperatura', 757.0000, 'ºC'),
	(220387, 119, '2014-03-01 00:25:42.000000', 'temperatura', 895.0000, 'ºC'),
	(220388, 119, '2014-03-01 00:25:43.000000', 'temperatura', 1005.0000, 'ºC'),
	(220389, 119, '2014-03-01 00:25:44.000000', 'temperatura', 1139.0000, 'ºC'),
	(220390, 119, '2014-03-01 00:25:45.000000', 'temperatura', 283.0000, 'ºC'),
	(220391, 119, '2014-03-01 00:25:46.000000', 'temperatura', 399.0000, 'ºC'),
	(220392, 119, '2014-03-01 00:25:47.000000', 'temperatura', 1146.0000, 'ºC'),
	(220393, 119, '2014-03-01 00:25:48.000000', 'temperatura', 933.0000, 'ºC'),
	(220394, 119, '2014-03-01 00:25:49.000000', 'temperatura', 30.0000, 'ºC'),
	(220395, 119, '2014-03-01 00:25:50.000000', 'temperatura', 948.0000, 'ºC'),
	(220396, 119, '2014-03-01 00:25:51.000000', 'temperatura', 1052.0000, 'ºC'),
	(220397, 119, '2014-03-01 00:25:52.000000', 'temperatura', 14.0000, 'ºC'),
	(220398, 119, '2014-03-01 00:25:53.000000', 'temperatura', 517.0000, 'ºC'),
	(220399, 119, '2014-03-01 00:25:54.000000', 'temperatura', 143.0000, 'ºC'),
	(220400, 119, '2014-03-01 00:25:55.000000', 'temperatura', 363.0000, 'ºC'),
	(220401, 119, '2014-03-01 00:25:56.000000', 'temperatura', 185.0000, 'ºC'),
	(220402, 119, '2014-03-01 00:25:57.000000', 'temperatura', 1040.0000, 'ºC'),
	(220403, 119, '2014-03-01 00:25:58.000000', 'temperatura', 1044.0000, 'ºC'),
	(220404, 119, '2014-03-01 00:25:59.000000', 'temperatura', 899.0000, 'ºC'),
	(220405, 119, '2014-03-01 00:26:00.000000', 'temperatura', 167.0000, 'ºC'),
	(220406, 119, '2014-03-01 00:26:01.000000', 'temperatura', 535.0000, 'ºC'),
	(220407, 119, '2014-03-01 00:26:02.000000', 'temperatura', 977.0000, 'ºC'),
	(220408, 119, '2014-03-01 00:26:03.000000', 'temperatura', 878.0000, 'ºC'),
	(220409, 119, '2014-03-01 00:26:04.000000', 'temperatura', 261.0000, 'ºC'),
	(220410, 119, '2014-03-01 00:26:05.000000', 'temperatura', 1071.0000, 'ºC'),
	(220411, 119, '2014-03-01 00:26:06.000000', 'temperatura', 971.0000, 'ºC'),
	(220412, 119, '2014-03-01 00:26:07.000000', 'temperatura', 443.0000, 'ºC'),
	(220413, 119, '2014-03-01 00:26:08.000000', 'temperatura', 502.0000, 'ºC'),
	(220414, 119, '2014-03-01 00:26:09.000000', 'temperatura', 1183.0000, 'ºC'),
	(220415, 119, '2014-03-01 00:26:10.000000', 'temperatura', 807.0000, 'ºC'),
	(220416, 119, '2014-03-01 00:26:11.000000', 'temperatura', 488.0000, 'ºC'),
	(220417, 119, '2014-03-01 00:26:12.000000', 'temperatura', 21.0000, 'ºC'),
	(220418, 119, '2014-03-01 00:26:13.000000', 'temperatura', 1039.0000, 'ºC'),
	(220419, 119, '2014-03-01 00:26:14.000000', 'temperatura', 331.0000, 'ºC'),
	(220420, 119, '2014-03-01 00:26:15.000000', 'temperatura', 942.0000, 'ºC'),
	(220421, 119, '2014-03-01 00:26:16.000000', 'temperatura', 116.0000, 'ºC'),
	(220422, 119, '2014-03-01 00:26:17.000000', 'temperatura', 155.0000, 'ºC'),
	(220423, 119, '2014-03-01 00:26:18.000000', 'temperatura', 428.0000, 'ºC'),
	(220424, 119, '2014-03-01 00:26:19.000000', 'temperatura', 476.0000, 'ºC'),
	(220425, 119, '2014-03-01 00:26:20.000000', 'temperatura', 1096.0000, 'ºC'),
	(220426, 119, '2014-03-01 00:26:21.000000', 'temperatura', 452.0000, 'ºC'),
	(220427, 119, '2014-03-01 00:26:22.000000', 'temperatura', 174.0000, 'ºC'),
	(220428, 119, '2014-03-01 00:26:23.000000', 'temperatura', 712.0000, 'ºC'),
	(220429, 119, '2014-03-01 00:26:24.000000', 'temperatura', 638.0000, 'ºC'),
	(220430, 119, '2014-03-01 00:26:25.000000', 'temperatura', 1058.0000, 'ºC'),
	(220431, 119, '2014-03-01 00:26:26.000000', 'temperatura', 973.0000, 'ºC'),
	(220432, 119, '2014-03-01 00:26:27.000000', 'temperatura', 492.0000, 'ºC'),
	(220433, 119, '2014-03-01 00:26:28.000000', 'temperatura', 744.0000, 'ºC'),
	(220434, 119, '2014-03-01 00:26:29.000000', 'temperatura', 1041.0000, 'ºC'),
	(220435, 119, '2014-03-01 00:26:30.000000', 'temperatura', 575.0000, 'ºC'),
	(220436, 119, '2014-03-01 00:26:31.000000', 'temperatura', 954.0000, 'ºC'),
	(220437, 119, '2014-03-01 00:26:32.000000', 'temperatura', 642.0000, 'ºC'),
	(220438, 119, '2014-03-01 00:26:33.000000', 'temperatura', 352.0000, 'ºC'),
	(220439, 119, '2014-03-01 00:26:34.000000', 'temperatura', 1031.0000, 'ºC'),
	(220440, 119, '2014-03-01 00:26:35.000000', 'temperatura', 502.0000, 'ºC'),
	(220441, 119, '2014-03-01 00:26:36.000000', 'temperatura', 617.0000, 'ºC'),
	(220442, 119, '2014-03-01 00:26:37.000000', 'temperatura', 378.0000, 'ºC'),
	(220443, 119, '2014-03-01 00:26:38.000000', 'temperatura', 40.0000, 'ºC'),
	(220444, 119, '2014-03-01 00:26:39.000000', 'temperatura', 268.0000, 'ºC'),
	(220445, 119, '2014-03-01 00:26:40.000000', 'temperatura', 21.0000, 'ºC'),
	(220446, 119, '2014-03-01 00:26:41.000000', 'temperatura', 500.0000, 'ºC'),
	(220447, 119, '2014-03-01 00:26:42.000000', 'temperatura', 38.0000, 'ºC'),
	(220448, 119, '2014-03-01 00:26:43.000000', 'temperatura', 1089.0000, 'ºC'),
	(220449, 119, '2014-03-01 00:26:44.000000', 'temperatura', 534.0000, 'ºC'),
	(220450, 119, '2014-03-01 00:26:45.000000', 'temperatura', 602.0000, 'ºC'),
	(220451, 119, '2014-03-01 00:26:46.000000', 'temperatura', 209.0000, 'ºC'),
	(220452, 119, '2014-03-01 00:26:47.000000', 'temperatura', 441.0000, 'ºC'),
	(220453, 119, '2014-03-01 00:26:48.000000', 'temperatura', 379.0000, 'ºC'),
	(220454, 119, '2014-03-01 00:26:49.000000', 'temperatura', 570.0000, 'ºC'),
	(220455, 119, '2014-03-01 00:26:50.000000', 'temperatura', 514.0000, 'ºC'),
	(220456, 119, '2014-03-01 00:26:51.000000', 'temperatura', 862.0000, 'ºC'),
	(220457, 119, '2014-03-01 00:26:52.000000', 'temperatura', 369.0000, 'ºC'),
	(220458, 119, '2014-03-01 00:26:53.000000', 'temperatura', 460.0000, 'ºC'),
	(220459, 119, '2014-03-01 00:26:54.000000', 'temperatura', 1193.0000, 'ºC'),
	(220460, 119, '2014-03-01 00:26:55.000000', 'temperatura', 986.0000, 'ºC'),
	(220461, 119, '2014-03-01 00:26:56.000000', 'temperatura', 151.0000, 'ºC'),
	(220462, 119, '2014-03-01 00:26:57.000000', 'temperatura', 197.0000, 'ºC'),
	(220463, 119, '2014-03-01 00:26:58.000000', 'temperatura', 531.0000, 'ºC'),
	(220464, 119, '2014-03-01 00:26:59.000000', 'temperatura', 865.0000, 'ºC'),
	(220465, 119, '2014-03-01 00:27:00.000000', 'temperatura', 335.0000, 'ºC'),
	(220466, 119, '2014-03-01 00:27:01.000000', 'temperatura', 278.0000, 'ºC'),
	(220467, 119, '2014-03-01 00:27:02.000000', 'temperatura', 387.0000, 'ºC'),
	(220468, 119, '2014-03-01 00:27:03.000000', 'temperatura', 1103.0000, 'ºC'),
	(220469, 119, '2014-03-01 00:27:04.000000', 'temperatura', 752.0000, 'ºC'),
	(220470, 119, '2014-03-01 00:27:05.000000', 'temperatura', 451.0000, 'ºC'),
	(220471, 119, '2014-03-01 00:27:06.000000', 'temperatura', 0.0000, 'ºC'),
	(220472, 119, '2014-03-01 00:27:07.000000', 'temperatura', 1046.0000, 'ºC'),
	(220473, 119, '2014-03-01 00:27:08.000000', 'temperatura', 431.0000, 'ºC'),
	(220474, 119, '2014-03-01 00:27:09.000000', 'temperatura', 218.0000, 'ºC'),
	(220475, 119, '2014-03-01 00:27:10.000000', 'temperatura', 998.0000, 'ºC'),
	(220476, 119, '2014-03-01 00:27:11.000000', 'temperatura', 737.0000, 'ºC'),
	(220477, 119, '2014-03-01 00:27:12.000000', 'temperatura', 690.0000, 'ºC'),
	(220478, 119, '2014-03-01 00:27:13.000000', 'temperatura', 41.0000, 'ºC'),
	(220479, 119, '2014-03-01 00:27:14.000000', 'temperatura', 536.0000, 'ºC'),
	(220480, 119, '2014-03-01 00:27:15.000000', 'temperatura', 156.0000, 'ºC'),
	(220481, 119, '2014-03-01 00:27:16.000000', 'temperatura', 371.0000, 'ºC'),
	(220482, 119, '2014-03-01 00:27:17.000000', 'temperatura', 189.0000, 'ºC'),
	(220483, 119, '2014-03-01 00:27:18.000000', 'temperatura', 1031.0000, 'ºC'),
	(220484, 119, '2014-03-01 00:27:19.000000', 'temperatura', 991.0000, 'ºC'),
	(220485, 119, '2014-03-01 00:27:20.000000', 'temperatura', 663.0000, 'ºC'),
	(220486, 119, '2014-03-01 00:27:21.000000', 'temperatura', 343.0000, 'ºC'),
	(220487, 119, '2014-03-01 00:27:22.000000', 'temperatura', 927.0000, 'ºC'),
	(220488, 119, '2014-03-01 00:27:23.000000', 'temperatura', 5.0000, 'ºC'),
	(220489, 119, '2014-03-01 00:27:24.000000', 'temperatura', 844.0000, 'ºC'),
	(220490, 119, '2014-03-01 00:27:25.000000', 'temperatura', 608.0000, 'ºC'),
	(220491, 119, '2014-03-01 00:27:26.000000', 'temperatura', 506.0000, 'ºC'),
	(220492, 119, '2014-03-01 00:27:27.000000', 'temperatura', 709.0000, 'ºC'),
	(220493, 119, '2014-03-01 00:27:28.000000', 'temperatura', 825.0000, 'ºC'),
	(220494, 119, '2014-03-01 00:27:29.000000', 'temperatura', 798.0000, 'ºC'),
	(220495, 119, '2014-03-01 00:27:30.000000', 'temperatura', 319.0000, 'ºC'),
	(220496, 119, '2014-03-01 00:27:31.000000', 'temperatura', 398.0000, 'ºC'),
	(220497, 119, '2014-03-01 00:27:32.000000', 'temperatura', 1033.0000, 'ºC'),
	(220498, 119, '2014-03-01 00:27:33.000000', 'temperatura', 374.0000, 'ºC'),
	(220499, 119, '2014-03-01 00:27:34.000000', 'temperatura', 1169.0000, 'ºC'),
	(220500, 119, '2014-03-01 00:27:35.000000', 'temperatura', 1126.0000, 'ºC'),
	(220501, 119, '2014-03-01 00:27:36.000000', 'temperatura', 921.0000, 'ºC'),
	(220502, 119, '2014-03-01 00:27:37.000000', 'temperatura', 29.0000, 'ºC'),
	(220503, 119, '2014-03-01 00:27:38.000000', 'temperatura', 983.0000, 'ºC'),
	(220504, 119, '2014-03-01 00:27:39.000000', 'temperatura', 27.0000, 'ºC'),
	(220505, 119, '2014-03-01 00:27:40.000000', 'temperatura', 786.0000, 'ºC'),
	(220506, 119, '2014-03-01 00:27:41.000000', 'temperatura', 250.0000, 'ºC'),
	(220507, 119, '2014-03-01 00:27:42.000000', 'temperatura', 93.0000, 'ºC'),
	(220508, 119, '2014-03-01 00:27:43.000000', 'temperatura', 916.0000, 'ºC'),
	(220509, 119, '2014-03-01 00:27:44.000000', 'temperatura', 703.0000, 'ºC'),
	(220510, 119, '2014-03-01 00:27:45.000000', 'temperatura', 765.0000, 'ºC'),
	(220511, 119, '2014-03-01 00:27:46.000000', 'temperatura', 516.0000, 'ºC'),
	(220512, 119, '2014-03-01 00:27:47.000000', 'temperatura', 286.0000, 'ºC'),
	(220513, 119, '2014-03-01 00:27:48.000000', 'temperatura', 1082.0000, 'ºC'),
	(220514, 119, '2014-03-01 00:27:49.000000', 'temperatura', 953.0000, 'ºC'),
	(220515, 119, '2014-03-01 00:27:50.000000', 'temperatura', 320.0000, 'ºC'),
	(220516, 119, '2014-03-01 00:27:51.000000', 'temperatura', 1140.0000, 'ºC'),
	(220517, 119, '2014-03-01 00:27:52.000000', 'temperatura', 1143.0000, 'ºC'),
	(220518, 119, '2014-03-01 00:27:53.000000', 'temperatura', 1094.0000, 'ºC'),
	(220519, 119, '2014-03-01 00:27:54.000000', 'temperatura', 843.0000, 'ºC'),
	(220520, 119, '2014-03-01 00:27:55.000000', 'temperatura', 933.0000, 'ºC'),
	(220521, 119, '2014-03-01 00:27:56.000000', 'temperatura', 937.0000, 'ºC'),
	(220522, 119, '2014-03-01 00:27:57.000000', 'temperatura', 684.0000, 'ºC'),
	(220523, 119, '2014-03-01 00:27:58.000000', 'temperatura', 612.0000, 'ºC'),
	(220524, 119, '2014-03-01 00:27:59.000000', 'temperatura', 1009.0000, 'ºC'),
	(220525, 119, '2014-03-01 00:28:00.000000', 'temperatura', 807.0000, 'ºC'),
	(220526, 119, '2014-03-01 00:28:01.000000', 'temperatura', 1010.0000, 'ºC'),
	(220527, 119, '2014-03-01 00:28:02.000000', 'temperatura', 227.0000, 'ºC'),
	(220528, 119, '2014-03-01 00:28:03.000000', 'temperatura', 509.0000, 'ºC'),
	(220529, 119, '2014-03-01 00:28:04.000000', 'temperatura', 661.0000, 'ºC'),
	(220530, 119, '2014-03-01 00:28:05.000000', 'temperatura', 580.0000, 'ºC'),
	(220531, 119, '2014-03-01 00:28:06.000000', 'temperatura', 918.0000, 'ºC'),
	(220532, 119, '2014-03-01 00:28:07.000000', 'temperatura', 449.0000, 'ºC'),
	(220533, 119, '2014-03-01 00:28:08.000000', 'temperatura', 694.0000, 'ºC'),
	(220534, 119, '2014-03-01 00:28:09.000000', 'temperatura', 921.0000, 'ºC'),
	(220535, 119, '2014-03-01 00:28:10.000000', 'temperatura', 123.0000, 'ºC'),
	(220536, 119, '2014-03-01 00:28:11.000000', 'temperatura', 253.0000, 'ºC'),
	(220537, 119, '2014-03-01 00:28:12.000000', 'temperatura', 898.0000, 'ºC'),
	(220538, 119, '2014-03-01 00:28:13.000000', 'temperatura', 132.0000, 'ºC'),
	(220539, 119, '2014-03-01 00:28:14.000000', 'temperatura', 367.0000, 'ºC'),
	(220540, 119, '2014-03-01 00:28:15.000000', 'temperatura', 240.0000, 'ºC'),
	(220541, 119, '2014-03-01 00:28:16.000000', 'temperatura', 97.0000, 'ºC'),
	(220542, 119, '2014-03-01 00:28:17.000000', 'temperatura', 965.0000, 'ºC'),
	(220543, 119, '2014-03-01 00:28:18.000000', 'temperatura', 937.0000, 'ºC'),
	(220544, 119, '2014-03-01 00:28:19.000000', 'temperatura', 591.0000, 'ºC'),
	(220545, 119, '2014-03-01 00:28:20.000000', 'temperatura', 143.0000, 'ºC'),
	(220546, 119, '2014-03-01 00:28:21.000000', 'temperatura', 144.0000, 'ºC'),
	(220547, 119, '2014-03-01 00:28:22.000000', 'temperatura', 290.0000, 'ºC'),
	(220548, 119, '2014-03-01 00:28:23.000000', 'temperatura', 1021.0000, 'ºC'),
	(220549, 119, '2014-03-01 00:28:24.000000', 'temperatura', 634.0000, 'ºC'),
	(220550, 119, '2014-03-01 00:28:25.000000', 'temperatura', 108.0000, 'ºC'),
	(220551, 119, '2014-03-01 00:28:26.000000', 'temperatura', 1037.0000, 'ºC'),
	(220552, 119, '2014-03-01 00:28:27.000000', 'temperatura', 64.0000, 'ºC'),
	(220553, 119, '2014-03-01 00:28:28.000000', 'temperatura', 808.0000, 'ºC'),
	(220554, 119, '2014-03-01 00:28:29.000000', 'temperatura', 247.0000, 'ºC'),
	(220555, 119, '2014-03-01 00:28:30.000000', 'temperatura', 15.0000, 'ºC'),
	(220556, 119, '2014-03-01 00:28:31.000000', 'temperatura', 531.0000, 'ºC'),
	(220557, 119, '2014-03-01 00:28:32.000000', 'temperatura', 212.0000, 'ºC'),
	(220558, 119, '2014-03-01 00:28:33.000000', 'temperatura', 669.0000, 'ºC'),
	(220559, 119, '2014-03-01 00:28:34.000000', 'temperatura', 310.0000, 'ºC'),
	(220560, 119, '2014-03-01 00:28:35.000000', 'temperatura', 741.0000, 'ºC'),
	(220561, 119, '2014-03-01 00:28:36.000000', 'temperatura', 374.0000, 'ºC'),
	(220562, 119, '2014-03-01 00:28:37.000000', 'temperatura', 851.0000, 'ºC'),
	(220563, 119, '2014-03-01 00:28:38.000000', 'temperatura', 731.0000, 'ºC'),
	(220564, 119, '2014-03-01 00:28:39.000000', 'temperatura', 1103.0000, 'ºC'),
	(220565, 119, '2014-03-01 00:28:40.000000', 'temperatura', 923.0000, 'ºC'),
	(220566, 119, '2014-03-01 00:28:41.000000', 'temperatura', 104.0000, 'ºC'),
	(220567, 119, '2014-03-01 00:28:42.000000', 'temperatura', 155.0000, 'ºC'),
	(220568, 119, '2014-03-01 00:28:43.000000', 'temperatura', 462.0000, 'ºC'),
	(220569, 119, '2014-03-01 00:28:44.000000', 'temperatura', 645.0000, 'ºC'),
	(220570, 119, '2014-03-01 00:28:45.000000', 'temperatura', 638.0000, 'ºC'),
	(220571, 119, '2014-03-01 00:28:46.000000', 'temperatura', 59.0000, 'ºC'),
	(220572, 119, '2014-03-01 00:28:47.000000', 'temperatura', 778.0000, 'ºC'),
	(220573, 119, '2014-03-01 00:28:48.000000', 'temperatura', 116.0000, 'ºC'),
	(220574, 119, '2014-03-01 00:28:49.000000', 'temperatura', 645.0000, 'ºC'),
	(220575, 119, '2014-03-01 00:28:50.000000', 'temperatura', 477.0000, 'ºC'),
	(220576, 119, '2014-03-01 00:28:51.000000', 'temperatura', 452.0000, 'ºC'),
	(220577, 119, '2014-03-01 00:28:52.000000', 'temperatura', 829.0000, 'ºC'),
	(220578, 119, '2014-03-01 00:28:53.000000', 'temperatura', 391.0000, 'ºC'),
	(220579, 119, '2014-03-01 00:28:54.000000', 'temperatura', 667.0000, 'ºC'),
	(220580, 119, '2014-03-01 00:28:55.000000', 'temperatura', 965.0000, 'ºC'),
	(220581, 119, '2014-03-01 00:28:56.000000', 'temperatura', 421.0000, 'ºC'),
	(220582, 119, '2014-03-01 00:28:57.000000', 'temperatura', 412.0000, 'ºC'),
	(220583, 119, '2014-03-01 00:28:58.000000', 'temperatura', 799.0000, 'ºC'),
	(220584, 119, '2014-03-01 00:28:59.000000', 'temperatura', 359.0000, 'ºC'),
	(220585, 119, '2014-03-01 00:29:00.000000', 'temperatura', 598.0000, 'ºC'),
	(220586, 119, '2014-03-01 00:29:01.000000', 'temperatura', 713.0000, 'ºC'),
	(220587, 119, '2014-03-01 00:29:02.000000', 'temperatura', 571.0000, 'ºC'),
	(220588, 119, '2014-03-01 00:29:03.000000', 'temperatura', 718.0000, 'ºC'),
	(220589, 119, '2014-03-01 00:29:04.000000', 'temperatura', 676.0000, 'ºC'),
	(220590, 119, '2014-03-01 00:29:05.000000', 'temperatura', 27.0000, 'ºC'),
	(220591, 119, '2014-03-01 00:29:06.000000', 'temperatura', 507.0000, 'ºC'),
	(220592, 119, '2014-03-01 00:29:07.000000', 'temperatura', 57.0000, 'ºC'),
	(220593, 119, '2014-03-01 00:29:08.000000', 'temperatura', 1162.0000, 'ºC'),
	(220594, 119, '2014-03-01 00:29:09.000000', 'temperatura', 839.0000, 'ºC'),
	(220595, 119, '2014-03-01 00:29:10.000000', 'temperatura', 712.0000, 'ºC'),
	(220596, 119, '2014-03-01 00:29:11.000000', 'temperatura', 1044.0000, 'ºC'),
	(220597, 119, '2014-03-01 00:29:12.000000', 'temperatura', 683.0000, 'ºC'),
	(220598, 119, '2014-03-01 00:29:13.000000', 'temperatura', 284.0000, 'ºC'),
	(220599, 119, '2014-03-01 00:29:14.000000', 'temperatura', 573.0000, 'ºC'),
	(220600, 119, '2014-03-01 00:29:15.000000', 'temperatura', 811.0000, 'ºC'),
	(220601, 119, '2014-03-01 00:29:16.000000', 'temperatura', 1139.0000, 'ºC'),
	(220602, 119, '2014-03-01 00:29:17.000000', 'temperatura', 862.0000, 'ºC'),
	(220603, 119, '2014-03-01 00:29:18.000000', 'temperatura', 894.0000, 'ºC'),
	(220604, 119, '2014-03-01 00:29:19.000000', 'temperatura', 685.0000, 'ºC'),
	(220605, 119, '2014-03-01 00:29:20.000000', 'temperatura', 741.0000, 'ºC'),
	(220606, 119, '2014-03-01 00:29:21.000000', 'temperatura', 453.0000, 'ºC'),
	(220607, 119, '2014-03-01 00:29:22.000000', 'temperatura', 40.0000, 'ºC'),
	(220608, 119, '2014-03-01 00:29:23.000000', 'temperatura', 43.0000, 'ºC'),
	(220609, 119, '2014-03-01 00:29:24.000000', 'temperatura', 96.0000, 'ºC'),
	(220610, 119, '2014-03-01 00:29:25.000000', 'temperatura', 353.0000, 'ºC'),
	(220611, 119, '2014-03-01 00:29:26.000000', 'temperatura', 276.0000, 'ºC'),
	(220612, 119, '2014-03-01 00:29:27.000000', 'temperatura', 322.0000, 'ºC'),
	(220613, 119, '2014-03-01 00:29:28.000000', 'temperatura', 784.0000, 'ºC'),
	(220614, 119, '2014-03-01 00:29:29.000000', 'temperatura', 552.0000, 'ºC'),
	(220615, 119, '2014-03-01 00:29:30.000000', 'temperatura', 409.0000, 'ºC'),
	(220616, 119, '2014-03-01 00:29:31.000000', 'temperatura', 391.0000, 'ºC'),
	(220617, 119, '2014-03-01 00:29:32.000000', 'temperatura', 727.0000, 'ºC'),
	(220618, 119, '2014-03-01 00:29:33.000000', 'temperatura', 62.0000, 'ºC'),
	(220619, 119, '2014-03-01 00:29:34.000000', 'temperatura', 529.0000, 'ºC'),
	(220620, 119, '2014-03-01 00:29:35.000000', 'temperatura', 60.0000, 'ºC'),
	(220621, 119, '2014-03-01 00:29:36.000000', 'temperatura', 1116.0000, 'ºC'),
	(220622, 119, '2014-03-01 00:29:37.000000', 'temperatura', 598.0000, 'ºC'),
	(220623, 119, '2014-03-01 00:29:38.000000', 'temperatura', 843.0000, 'ºC'),
	(220624, 119, '2014-03-01 00:29:39.000000', 'temperatura', 21.0000, 'ºC'),
	(220625, 119, '2014-03-01 00:29:40.000000', 'temperatura', 1176.0000, 'ºC'),
	(220626, 119, '2014-03-01 00:29:41.000000', 'temperatura', 1020.0000, 'ºC'),
	(220627, 119, '2014-03-01 00:29:42.000000', 'temperatura', 372.0000, 'ºC'),
	(220628, 119, '2014-03-01 00:29:43.000000', 'temperatura', 1199.0000, 'ºC'),
	(220629, 119, '2014-03-01 00:29:44.000000', 'temperatura', 79.0000, 'ºC'),
	(220630, 119, '2014-03-01 00:29:45.000000', 'temperatura', 401.0000, 'ºC'),
	(220631, 119, '2014-03-01 00:29:46.000000', 'temperatura', 568.0000, 'ºC'),
	(220632, 119, '2014-03-01 00:29:47.000000', 'temperatura', 436.0000, 'ºC'),
	(220633, 119, '2014-03-01 00:29:48.000000', 'temperatura', 478.0000, 'ºC'),
	(220634, 119, '2014-03-01 00:29:49.000000', 'temperatura', 1081.0000, 'ºC'),
	(220635, 119, '2014-03-01 00:29:50.000000', 'temperatura', 370.0000, 'ºC'),
	(220636, 119, '2014-03-01 00:29:51.000000', 'temperatura', 1009.0000, 'ºC'),
	(220637, 119, '2014-03-01 00:29:52.000000', 'temperatura', 337.0000, 'ºC'),
	(220638, 119, '2014-03-01 00:29:53.000000', 'temperatura', 1057.0000, 'ºC'),
	(220639, 119, '2014-03-01 00:29:54.000000', 'temperatura', 677.0000, 'ºC'),
	(220640, 119, '2014-03-01 00:29:55.000000', 'temperatura', 212.0000, 'ºC'),
	(220641, 119, '2014-03-01 00:29:56.000000', 'temperatura', 232.0000, 'ºC'),
	(220642, 119, '2014-03-01 00:29:57.000000', 'temperatura', 524.0000, 'ºC'),
	(220643, 119, '2014-03-01 00:29:58.000000', 'temperatura', 722.0000, 'ºC'),
	(220644, 119, '2014-03-01 00:29:59.000000', 'temperatura', 842.0000, 'ºC'),
	(220645, 119, '2014-03-01 00:30:00.000000', 'temperatura', 842.0000, 'ºC'),
	(220646, 119, '2014-03-01 00:30:01.000000', 'temperatura', 484.0000, 'ºC'),
	(220647, 119, '2014-03-01 00:30:02.000000', 'temperatura', 1094.0000, 'ºC'),
	(220648, 119, '2014-03-01 00:30:03.000000', 'temperatura', 418.0000, 'ºC'),
	(220649, 119, '2014-03-01 00:30:04.000000', 'temperatura', 11.0000, 'ºC'),
	(220650, 119, '2014-03-01 00:30:05.000000', 'temperatura', 0.0000, 'ºC'),
	(220651, 119, '2014-03-01 00:30:06.000000', 'temperatura', 1166.0000, 'ºC'),
	(220652, 119, '2014-03-01 00:30:07.000000', 'temperatura', 1031.0000, 'ºC'),
	(220653, 119, '2014-03-01 00:30:08.000000', 'temperatura', 459.0000, 'ºC'),
	(220654, 119, '2014-03-01 00:30:09.000000', 'temperatura', 400.0000, 'ºC'),
	(220655, 119, '2014-03-01 00:30:10.000000', 'temperatura', 624.0000, 'ºC'),
	(220656, 119, '2014-03-01 00:30:11.000000', 'temperatura', 720.0000, 'ºC'),
	(220657, 119, '2014-03-01 00:30:12.000000', 'temperatura', 530.0000, 'ºC'),
	(220658, 119, '2014-03-01 00:30:13.000000', 'temperatura', 488.0000, 'ºC'),
	(220659, 119, '2014-03-01 00:30:14.000000', 'temperatura', 852.0000, 'ºC'),
	(220660, 119, '2014-03-01 00:30:15.000000', 'temperatura', 397.0000, 'ºC'),
	(220661, 119, '2014-03-01 00:30:16.000000', 'temperatura', 630.0000, 'ºC'),
	(220662, 119, '2014-03-01 00:30:17.000000', 'temperatura', 757.0000, 'ºC'),
	(220663, 119, '2014-03-01 00:30:18.000000', 'temperatura', 697.0000, 'ºC'),
	(220664, 119, '2014-03-01 00:30:19.000000', 'temperatura', 16.0000, 'ºC'),
	(220665, 119, '2014-03-01 00:30:20.000000', 'temperatura', 389.0000, 'ºC'),
	(220666, 119, '2014-03-01 00:30:21.000000', 'temperatura', 697.0000, 'ºC'),
	(220667, 119, '2014-03-01 00:30:22.000000', 'temperatura', 1116.0000, 'ºC'),
	(220668, 119, '2014-03-01 00:30:23.000000', 'temperatura', 1093.0000, 'ºC'),
	(220669, 119, '2014-03-01 00:30:24.000000', 'temperatura', 918.0000, 'ºC'),
	(220670, 119, '2014-03-01 00:30:25.000000', 'temperatura', 108.0000, 'ºC'),
	(220671, 119, '2014-03-01 00:30:26.000000', 'temperatura', 189.0000, 'ºC'),
	(220672, 119, '2014-03-01 00:30:27.000000', 'temperatura', 621.0000, 'ºC'),
	(220673, 119, '2014-03-01 00:30:28.000000', 'temperatura', 140.0000, 'ºC'),
	(220674, 119, '2014-03-01 00:30:29.000000', 'temperatura', 38.0000, 'ºC'),
	(220675, 119, '2014-03-01 00:30:30.000000', 'temperatura', 968.0000, 'ºC'),
	(220676, 119, '2014-03-01 00:30:31.000000', 'temperatura', 1127.0000, 'ºC'),
	(220677, 119, '2014-03-01 00:30:32.000000', 'temperatura', 331.0000, 'ºC'),
	(220678, 119, '2014-03-01 00:30:33.000000', 'temperatura', 673.0000, 'ºC'),
	(220679, 119, '2014-03-01 00:30:34.000000', 'temperatura', 1175.0000, 'ºC'),
	(220680, 119, '2014-03-01 00:30:35.000000', 'temperatura', 258.0000, 'ºC'),
	(220681, 119, '2014-03-01 00:30:36.000000', 'temperatura', 163.0000, 'ºC'),
	(220682, 119, '2014-03-01 00:30:37.000000', 'temperatura', 41.0000, 'ºC'),
	(220683, 119, '2014-03-01 00:30:38.000000', 'temperatura', 915.0000, 'ºC'),
	(220684, 119, '2014-03-01 00:30:39.000000', 'temperatura', 856.0000, 'ºC'),
	(220685, 119, '2014-03-01 00:30:40.000000', 'temperatura', 333.0000, 'ºC'),
	(220686, 119, '2014-03-01 00:30:41.000000', 'temperatura', 300.0000, 'ºC'),
	(220687, 119, '2014-03-01 00:30:42.000000', 'temperatura', 502.0000, 'ºC'),
	(220688, 119, '2014-03-01 00:30:43.000000', 'temperatura', 411.0000, 'ºC'),
	(220689, 119, '2014-03-01 00:30:44.000000', 'temperatura', 546.0000, 'ºC'),
	(220690, 119, '2014-03-01 00:30:45.000000', 'temperatura', 301.0000, 'ºC'),
	(220691, 119, '2014-03-01 00:30:46.000000', 'temperatura', 1064.0000, 'ºC'),
	(220692, 119, '2014-03-01 00:30:47.000000', 'temperatura', 821.0000, 'ºC'),
	(220693, 119, '2014-03-01 00:30:48.000000', 'temperatura', 911.0000, 'ºC'),
	(220694, 119, '2014-03-01 00:30:49.000000', 'temperatura', 893.0000, 'ºC'),
	(220695, 119, '2014-03-01 00:30:50.000000', 'temperatura', 532.0000, 'ºC'),
	(220696, 119, '2014-03-01 00:30:51.000000', 'temperatura', 1181.0000, 'ºC'),
	(220697, 119, '2014-03-01 00:30:52.000000', 'temperatura', 710.0000, 'ºC'),
	(220698, 119, '2014-03-01 00:30:53.000000', 'temperatura', 9.0000, 'ºC'),
	(220699, 119, '2014-03-01 00:30:54.000000', 'temperatura', 314.0000, 'ºC'),
	(220700, 119, '2014-03-01 00:30:55.000000', 'temperatura', 345.0000, 'ºC'),
	(220701, 119, '2014-03-01 00:30:56.000000', 'temperatura', 782.0000, 'ºC'),
	(220702, 119, '2014-03-01 00:30:57.000000', 'temperatura', 478.0000, 'ºC'),
	(220703, 119, '2014-03-01 00:30:58.000000', 'temperatura', 43.0000, 'ºC'),
	(220704, 119, '2014-03-01 00:30:59.000000', 'temperatura', 1180.0000, 'ºC'),
	(220705, 119, '2014-03-01 00:31:00.000000', 'temperatura', 971.0000, 'ºC'),
	(220706, 119, '2014-03-01 00:31:01.000000', 'temperatura', 116.0000, 'ºC'),
	(220707, 119, '2014-03-01 00:31:02.000000', 'temperatura', 67.0000, 'ºC'),
	(220708, 119, '2014-03-01 00:31:03.000000', 'temperatura', 1190.0000, 'ºC'),
	(220709, 119, '2014-03-01 00:31:04.000000', 'temperatura', 949.0000, 'ºC'),
	(220710, 119, '2014-03-01 00:31:05.000000', 'temperatura', 1175.0000, 'ºC'),
	(220711, 119, '2014-03-01 00:31:06.000000', 'temperatura', 629.0000, 'ºC'),
	(220712, 119, '2014-03-01 00:31:07.000000', 'temperatura', 819.0000, 'ºC'),
	(220713, 119, '2014-03-01 00:31:08.000000', 'temperatura', 1009.0000, 'ºC'),
	(220714, 119, '2014-03-01 00:31:09.000000', 'temperatura', 188.0000, 'ºC'),
	(220715, 119, '2014-03-01 00:31:10.000000', 'temperatura', 316.0000, 'ºC'),
	(220716, 119, '2014-03-01 00:31:11.000000', 'temperatura', 1015.0000, 'ºC'),
	(220717, 119, '2014-03-01 00:31:12.000000', 'temperatura', 528.0000, 'ºC'),
	(220718, 119, '2014-03-01 00:31:13.000000', 'temperatura', 796.0000, 'ºC'),
	(220719, 119, '2014-03-01 00:31:14.000000', 'temperatura', 1195.0000, 'ºC'),
	(220720, 119, '2014-03-01 00:31:15.000000', 'temperatura', 1190.0000, 'ºC'),
	(220721, 119, '2014-03-01 00:31:16.000000', 'temperatura', 1165.0000, 'ºC'),
	(220722, 119, '2014-03-01 00:31:17.000000', 'temperatura', 1054.0000, 'ºC'),
	(220723, 119, '2014-03-01 00:31:18.000000', 'temperatura', 577.0000, 'ºC'),
	(220724, 119, '2014-03-01 00:31:19.000000', 'temperatura', 922.0000, 'ºC'),
	(220725, 119, '2014-03-01 00:31:20.000000', 'temperatura', 482.0000, 'ºC'),
	(220726, 119, '2014-03-01 00:31:21.000000', 'temperatura', 844.0000, 'ºC'),
	(220727, 119, '2014-03-01 00:31:22.000000', 'temperatura', 372.0000, 'ºC'),
	(220728, 119, '2014-03-01 00:31:23.000000', 'temperatura', 530.0000, 'ºC'),
	(220729, 119, '2014-03-01 00:31:24.000000', 'temperatura', 336.0000, 'ºC'),
	(220730, 119, '2014-03-01 00:31:25.000000', 'temperatura', 91.0000, 'ºC'),
	(220731, 119, '2014-03-01 00:31:26.000000', 'temperatura', 648.0000, 'ºC'),
	(220732, 119, '2014-03-01 00:31:27.000000', 'temperatura', 564.0000, 'ºC'),
	(220733, 119, '2014-03-01 00:31:28.000000', 'temperatura', 880.0000, 'ºC'),
	(220734, 119, '2014-03-01 00:31:29.000000', 'temperatura', 307.0000, 'ºC'),
	(220735, 119, '2014-03-01 00:31:30.000000', 'temperatura', 97.0000, 'ºC'),
	(220736, 119, '2014-03-01 00:31:31.000000', 'temperatura', 763.0000, 'ºC'),
	(220737, 119, '2014-03-01 00:31:32.000000', 'temperatura', 1125.0000, 'ºC'),
	(220738, 119, '2014-03-01 00:31:33.000000', 'temperatura', 938.0000, 'ºC'),
	(220739, 119, '2014-03-01 00:31:34.000000', 'temperatura', 116.0000, 'ºC'),
	(220740, 119, '2014-03-01 00:31:35.000000', 'temperatura', 165.0000, 'ºC'),
	(220741, 119, '2014-03-01 00:31:36.000000', 'temperatura', 479.0000, 'ºC'),
	(220742, 119, '2014-03-01 00:31:37.000000', 'temperatura', 701.0000, 'ºC'),
	(220743, 119, '2014-03-01 00:31:38.000000', 'temperatura', 869.0000, 'ºC'),
	(220744, 119, '2014-03-01 00:31:39.000000', 'temperatura', 1040.0000, 'ºC'),
	(220745, 119, '2014-03-01 00:31:40.000000', 'temperatura', 193.0000, 'ºC'),
	(220746, 119, '2014-03-01 00:31:41.000000', 'temperatura', 248.0000, 'ºC'),
	(220747, 119, '2014-03-01 00:31:42.000000', 'temperatura', 659.0000, 'ºC'),
	(220748, 119, '2014-03-01 00:31:43.000000', 'temperatura', 152.0000, 'ºC'),
	(220749, 119, '2014-03-01 00:31:44.000000', 'temperatura', 1183.0000, 'ºC'),
	(220750, 119, '2014-03-01 00:31:45.000000', 'temperatura', 660.0000, 'ºC'),
	(220751, 119, '2014-03-01 00:31:46.000000', 'temperatura', 952.0000, 'ºC'),
	(220752, 119, '2014-03-01 00:31:47.000000', 'temperatura', 382.0000, 'ºC'),
	(220753, 119, '2014-03-01 00:31:48.000000', 'temperatura', 253.0000, 'ºC'),
	(220754, 119, '2014-03-01 00:31:49.000000', 'temperatura', 120.0000, 'ºC'),
	(220755, 119, '2014-03-01 00:31:50.000000', 'temperatura', 1042.0000, 'ºC'),
	(220756, 119, '2014-03-01 00:31:51.000000', 'temperatura', 51.0000, 'ºC'),
	(220757, 119, '2014-03-01 00:31:52.000000', 'temperatura', 727.0000, 'ºC'),
	(220758, 119, '2014-03-01 00:31:53.000000', 'temperatura', 1083.0000, 'ºC'),
	(220759, 119, '2014-03-01 00:31:54.000000', 'temperatura', 837.0000, 'ºC'),
	(220760, 119, '2014-03-01 00:31:55.000000', 'temperatura', 936.0000, 'ºC'),
	(220761, 119, '2014-03-01 00:31:56.000000', 'temperatura', 967.0000, 'ºC'),
	(220762, 119, '2014-03-01 00:31:57.000000', 'temperatura', 829.0000, 'ºC'),
	(220763, 119, '2014-03-01 00:31:58.000000', 'temperatura', 45.0000, 'ºC'),
	(220764, 119, '2014-03-01 00:31:59.000000', 'temperatura', 138.0000, 'ºC'),
	(220765, 119, '2014-03-01 00:32:00.000000', 'temperatura', 554.0000, 'ºC'),
	(220766, 119, '2014-03-01 00:32:01.000000', 'temperatura', 1157.0000, 'ºC'),
	(220767, 119, '2014-03-01 00:32:02.000000', 'temperatura', 524.0000, 'ºC'),
	(220768, 119, '2014-03-01 00:32:03.000000', 'temperatura', 348.0000, 'ºC'),
	(220769, 119, '2014-03-01 00:32:04.000000', 'temperatura', 172.0000, 'ºC'),
	(220770, 119, '2014-03-01 00:32:05.000000', 'temperatura', 1013.0000, 'ºC'),
	(220771, 119, '2014-03-01 00:32:06.000000', 'temperatura', 949.0000, 'ºC'),
	(220772, 119, '2014-03-01 00:32:07.000000', 'temperatura', 508.0000, 'ºC'),
	(220773, 119, '2014-03-01 00:32:08.000000', 'temperatura', 895.0000, 'ºC'),
	(220774, 119, '2014-03-01 00:32:09.000000', 'temperatura', 550.0000, 'ºC'),
	(220775, 119, '2014-03-01 00:32:10.000000', 'temperatura', 65.0000, 'ºC'),
	(220776, 119, '2014-03-01 00:32:11.000000', 'temperatura', 1074.0000, 'ºC'),
	(220777, 119, '2014-03-01 00:32:12.000000', 'temperatura', 379.0000, 'ºC'),
	(220778, 119, '2014-03-01 00:32:13.000000', 'temperatura', 1070.0000, 'ºC'),
	(220779, 119, '2014-03-01 00:32:14.000000', 'temperatura', 615.0000, 'ºC'),
	(220780, 119, '2014-03-01 00:32:15.000000', 'temperatura', 1064.0000, 'ºC'),
	(220781, 119, '2014-03-01 00:32:16.000000', 'temperatura', 1076.0000, 'ºC'),
	(220782, 119, '2014-03-01 00:32:17.000000', 'temperatura', 989.0000, 'ºC'),
	(220783, 119, '2014-03-01 00:32:18.000000', 'temperatura', 517.0000, 'ºC'),
	(220784, 119, '2014-03-01 00:32:19.000000', 'temperatura', 819.0000, 'ºC'),
	(220785, 119, '2014-03-01 00:32:20.000000', 'temperatura', 142.0000, 'ºC'),
	(220786, 119, '2014-03-01 00:32:21.000000', 'temperatura', 656.0000, 'ºC'),
	(220787, 119, '2014-03-01 00:32:22.000000', 'temperatura', 455.0000, 'ºC'),
	(220788, 119, '2014-03-01 00:32:23.000000', 'temperatura', 306.0000, 'ºC'),
	(220789, 119, '2014-03-01 00:32:24.000000', 'temperatura', 166.0000, 'ºC'),
	(220790, 119, '2014-03-01 00:32:25.000000', 'temperatura', 1111.0000, 'ºC'),
	(220791, 119, '2014-03-01 00:32:26.000000', 'temperatura', 259.0000, 'ºC'),
	(220792, 119, '2014-03-01 00:32:27.000000', 'temperatura', 363.0000, 'ºC'),
	(220793, 119, '2014-03-01 00:32:28.000000', 'temperatura', 1039.0000, 'ºC'),
	(220794, 119, '2014-03-01 00:32:29.000000', 'temperatura', 507.0000, 'ºC'),
	(220795, 119, '2014-03-01 00:32:30.000000', 'temperatura', 616.0000, 'ºC'),
	(220796, 119, '2014-03-01 00:32:31.000000', 'temperatura', 359.0000, 'ºC'),
	(220797, 119, '2014-03-01 00:32:32.000000', 'temperatura', 1148.0000, 'ºC'),
	(220798, 119, '2014-03-01 00:32:33.000000', 'temperatura', 1065.0000, 'ºC'),
	(220799, 119, '2014-03-01 00:32:34.000000', 'temperatura', 679.0000, 'ºC'),
	(220800, 119, '2014-03-01 00:32:35.000000', 'temperatura', 202.0000, 'ºC'),
	(220801, 119, '2014-03-01 00:32:36.000000', 'temperatura', 173.0000, 'ºC'),
	(220802, 119, '2014-03-01 00:32:37.000000', 'temperatura', 259.0000, 'ºC'),
	(220803, 119, '2014-03-01 00:32:38.000000', 'temperatura', 779.0000, 'ºC'),
	(220804, 119, '2014-03-01 00:32:39.000000', 'temperatura', 715.0000, 'ºC'),
	(220805, 119, '2014-03-01 00:32:40.000000', 'temperatura', 41.0000, 'ºC'),
	(220806, 119, '2014-03-01 00:32:41.000000', 'temperatura', 460.0000, 'ºC'),
	(220807, 119, '2014-03-01 00:32:42.000000', 'temperatura', 977.0000, 'ºC'),
	(220808, 119, '2014-03-01 00:32:43.000000', 'temperatura', 1106.0000, 'ºC'),
	(220809, 119, '2014-03-01 00:32:44.000000', 'temperatura', 200.0000, 'ºC'),
	(220810, 119, '2014-03-01 00:32:45.000000', 'temperatura', 81.0000, 'ºC'),
	(220811, 119, '2014-03-01 00:32:46.000000', 'temperatura', 1004.0000, 'ºC'),
	(220812, 119, '2014-03-01 00:32:47.000000', 'temperatura', 1179.0000, 'ºC'),
	(220813, 119, '2014-03-01 00:32:48.000000', 'temperatura', 485.0000, 'ºC'),
	(220814, 119, '2014-03-01 00:32:49.000000', 'temperatura', 88.0000, 'ºC'),
	(220815, 119, '2014-03-01 00:32:50.000000', 'temperatura', 185.0000, 'ºC'),
	(220816, 119, '2014-03-01 00:32:51.000000', 'temperatura', 660.0000, 'ºC'),
	(220817, 119, '2014-03-01 00:32:52.000000', 'temperatura', 346.0000, 'ºC'),
	(220818, 119, '2014-03-01 00:32:53.000000', 'temperatura', 950.0000, 'ºC'),
	(220819, 119, '2014-03-01 00:32:54.000000', 'temperatura', 112.0000, 'ºC'),
	(220820, 119, '2014-03-01 00:32:55.000000', 'temperatura', 111.0000, 'ºC'),
	(220821, 119, '2014-03-01 00:32:56.000000', 'temperatura', 222.0000, 'ºC'),
	(220822, 119, '2014-03-01 00:32:57.000000', 'temperatura', 774.0000, 'ºC'),
	(220823, 119, '2014-03-01 00:32:58.000000', 'temperatura', 807.0000, 'ºC'),
	(220824, 119, '2014-03-01 00:32:59.000000', 'temperatura', 512.0000, 'ºC'),
	(220825, 119, '2014-03-01 00:33:00.000000', 'temperatura', 139.0000, 'ºC'),
	(220826, 119, '2014-03-01 00:33:01.000000', 'temperatura', 360.0000, 'ºC'),
	(220827, 119, '2014-03-01 00:33:02.000000', 'temperatura', 183.0000, 'ºC'),
	(220828, 119, '2014-03-01 00:33:03.000000', 'temperatura', 1034.0000, 'ºC'),
	(220829, 119, '2014-03-01 00:33:04.000000', 'temperatura', 1023.0000, 'ºC'),
	(220830, 119, '2014-03-01 00:33:05.000000', 'temperatura', 812.0000, 'ºC'),
	(220831, 119, '2014-03-01 00:33:06.000000', 'temperatura', 991.0000, 'ºC'),
	(220832, 119, '2014-03-01 00:33:07.000000', 'temperatura', 120.0000, 'ºC'),
	(220833, 119, '2014-03-01 00:33:08.000000', 'temperatura', 28.0000, 'ºC'),
	(220834, 119, '2014-03-01 00:33:09.000000', 'temperatura', 982.0000, 'ºC'),
	(220835, 119, '2014-03-01 00:33:10.000000', 'temperatura', 25.0000, 'ºC'),
	(220836, 119, '2014-03-01 00:33:11.000000', 'temperatura', 779.0000, 'ºC'),
	(220837, 119, '2014-03-01 00:33:12.000000', 'temperatura', 221.0000, 'ºC'),
	(220838, 119, '2014-03-01 00:33:13.000000', 'temperatura', 1167.0000, 'ºC'),
	(220839, 119, '2014-03-01 00:33:14.000000', 'temperatura', 373.0000, 'ºC'),
	(220840, 119, '2014-03-01 00:33:15.000000', 'temperatura', 764.0000, 'ºC'),
	(220841, 119, '2014-03-01 00:33:16.000000', 'temperatura', 303.0000, 'ºC'),
	(220842, 119, '2014-03-01 00:33:17.000000', 'temperatura', 425.0000, 'ºC'),
	(220843, 119, '2014-03-01 00:33:18.000000', 'temperatura', 13.0000, 'ºC'),
	(220844, 119, '2014-03-01 00:33:19.000000', 'temperatura', 1194.0000, 'ºC'),
	(220845, 119, '2014-03-01 00:33:20.000000', 'temperatura', 1130.0000, 'ºC'),
	(220846, 119, '2014-03-01 00:33:21.000000', 'temperatura', 870.0000, 'ºC'),
	(220847, 119, '2014-03-01 00:33:22.000000', 'temperatura', 958.0000, 'ºC'),
	(220848, 119, '2014-03-01 00:33:23.000000', 'temperatura', 980.0000, 'ºC'),
	(220849, 119, '2014-03-01 00:33:24.000000', 'temperatura', 826.0000, 'ºC'),
	(220850, 119, '2014-03-01 00:33:25.000000', 'temperatura', 1192.0000, 'ºC'),
	(220851, 119, '2014-03-01 00:33:26.000000', 'temperatura', 1082.0000, 'ºC'),
	(220852, 119, '2014-03-01 00:33:27.000000', 'temperatura', 635.0000, 'ºC'),
	(220853, 119, '2014-03-01 00:33:28.000000', 'temperatura', 1131.0000, 'ºC'),
	(220854, 119, '2014-03-01 00:33:29.000000', 'temperatura', 149.0000, 'ºC'),
	(220855, 119, '2014-03-01 00:33:30.000000', 'temperatura', 953.0000, 'ºC'),
	(220856, 119, '2014-03-01 00:33:31.000000', 'temperatura', 717.0000, 'ºC'),
	(220857, 119, '2014-03-01 00:33:32.000000', 'temperatura', 727.0000, 'ºC'),
	(220858, 119, '2014-03-01 00:33:33.000000', 'temperatura', 285.0000, 'ºC'),
	(220859, 119, '2014-03-01 00:33:34.000000', 'temperatura', 442.0000, 'ºC'),
	(220860, 119, '2014-03-01 00:33:35.000000', 'temperatura', 159.0000, 'ºC'),
	(220861, 119, '2014-03-01 00:33:36.000000', 'temperatura', 666.0000, 'ºC'),
	(220862, 119, '2014-03-01 00:33:37.000000', 'temperatura', 455.0000, 'ºC'),
	(220863, 119, '2014-03-01 00:33:38.000000', 'temperatura', 280.0000, 'ºC'),
	(220864, 119, '2014-03-01 00:33:39.000000', 'temperatura', 32.0000, 'ºC'),
	(220865, 119, '2014-03-01 00:33:40.000000', 'temperatura', 522.0000, 'ºC'),
	(220866, 119, '2014-03-01 00:33:41.000000', 'temperatura', 113.0000, 'ºC'),
	(220867, 119, '2014-03-01 00:33:42.000000', 'temperatura', 202.0000, 'ºC'),
	(220868, 119, '2014-03-01 00:33:43.000000', 'temperatura', 671.0000, 'ºC'),
	(220869, 119, '2014-03-01 00:33:44.000000', 'temperatura', 348.0000, 'ºC'),
	(220870, 119, '2014-03-01 00:33:45.000000', 'temperatura', 927.0000, 'ºC'),
	(220871, 119, '2014-03-01 00:33:46.000000', 'temperatura', 1192.0000, 'ºC'),
	(220872, 119, '2014-03-01 00:33:47.000000', 'temperatura', 782.0000, 'ºC'),
	(220873, 119, '2014-03-01 00:33:48.000000', 'temperatura', 331.0000, 'ºC'),
	(220874, 119, '2014-03-01 00:33:49.000000', 'temperatura', 510.0000, 'ºC'),
	(220875, 119, '2014-03-01 00:33:50.000000', 'temperatura', 358.0000, 'ºC'),
	(220876, 119, '2014-03-01 00:33:51.000000', 'temperatura', 261.0000, 'ºC'),
	(220877, 119, '2014-03-01 00:33:52.000000', 'temperatura', 231.0000, 'ºC'),
	(220878, 119, '2014-03-01 00:33:53.000000', 'temperatura', 371.0000, 'ºC'),
	(220879, 119, '2014-03-01 00:33:54.000000', 'temperatura', 1162.0000, 'ºC'),
	(220880, 119, '2014-03-01 00:33:55.000000', 'temperatura', 1100.0000, 'ºC'),
	(220881, 119, '2014-03-01 00:33:56.000000', 'temperatura', 812.0000, 'ºC'),
	(220882, 119, '2014-03-01 00:33:57.000000', 'temperatura', 763.0000, 'ºC'),
	(220883, 119, '2014-03-01 00:33:58.000000', 'temperatura', 178.0000, 'ºC'),
	(220884, 119, '2014-03-01 00:33:59.000000', 'temperatura', 1002.0000, 'ºC'),
	(220885, 119, '2014-03-01 00:34:00.000000', 'temperatura', 874.0000, 'ºC'),
	(220886, 119, '2014-03-01 00:34:01.000000', 'temperatura', 167.0000, 'ºC'),
	(220887, 119, '2014-03-01 00:34:02.000000', 'temperatura', 614.0000, 'ºC'),
	(220888, 119, '2014-03-01 00:34:03.000000', 'temperatura', 169.0000, 'ºC'),
	(220889, 119, '2014-03-01 00:34:04.000000', 'temperatura', 205.0000, 'ºC'),
	(220890, 119, '2014-03-01 00:34:05.000000', 'temperatura', 517.0000, 'ºC'),
	(220891, 119, '2014-03-01 00:34:06.000000', 'temperatura', 770.0000, 'ºC'),
	(220892, 119, '2014-03-01 00:34:07.000000', 'temperatura', 1101.0000, 'ºC'),
	(220893, 119, '2014-03-01 00:34:08.000000', 'temperatura', 793.0000, 'ºC'),
	(220894, 119, '2014-03-01 00:34:09.000000', 'temperatura', 666.0000, 'ºC'),
	(220895, 119, '2014-03-01 00:34:10.000000', 'temperatura', 948.0000, 'ºC'),
	(220896, 119, '2014-03-01 00:34:11.000000', 'temperatura', 346.0000, 'ºC'),
	(220897, 119, '2014-03-01 00:34:12.000000', 'temperatura', 84.0000, 'ºC'),
	(220898, 119, '2014-03-01 00:34:13.000000', 'temperatura', 583.0000, 'ºC'),
	(220899, 119, '2014-03-01 00:34:14.000000', 'temperatura', 265.0000, 'ºC'),
	(220900, 119, '2014-03-01 00:34:15.000000', 'temperatura', 776.0000, 'ºC'),
	(220901, 119, '2014-03-01 00:34:16.000000', 'temperatura', 684.0000, 'ºC'),
	(220902, 119, '2014-03-01 00:34:17.000000', 'temperatura', 1091.0000, 'ºC'),
	(220903, 119, '2014-03-01 00:34:18.000000', 'temperatura', 1007.0000, 'ºC'),
	(220904, 119, '2014-03-01 00:34:19.000000', 'temperatura', 560.0000, 'ºC'),
	(220905, 119, '2014-03-01 00:34:20.000000', 'temperatura', 979.0000, 'ºC'),
	(220906, 119, '2014-03-01 00:34:21.000000', 'temperatura', 817.0000, 'ºC'),
	(220907, 119, '2014-03-01 00:34:22.000000', 'temperatura', 1150.0000, 'ºC'),
	(220908, 119, '2014-03-01 00:34:23.000000', 'temperatura', 898.0000, 'ºC'),
	(220909, 119, '2014-03-01 00:34:24.000000', 'temperatura', 1040.0000, 'ºC'),
	(220910, 119, '2014-03-01 00:34:25.000000', 'temperatura', 108.0000, 'ºC'),
	(220911, 119, '2014-03-01 00:34:26.000000', 'temperatura', 1019.0000, 'ºC'),
	(220912, 119, '2014-03-01 00:34:27.000000', 'temperatura', 1171.0000, 'ºC'),
	(220913, 119, '2014-03-01 00:34:28.000000', 'temperatura', 399.0000, 'ºC'),
	(220914, 119, '2014-03-01 00:34:29.000000', 'temperatura', 883.0000, 'ºC'),
	(220915, 119, '2014-03-01 00:34:30.000000', 'temperatura', 817.0000, 'ºC'),
	(220916, 119, '2014-03-01 00:34:31.000000', 'temperatura', 237.0000, 'ºC'),
	(220917, 119, '2014-03-01 00:34:32.000000', 'temperatura', 1133.0000, 'ºC'),
	(220918, 119, '2014-03-01 00:34:33.000000', 'temperatura', 157.0000, 'ºC'),
	(220919, 119, '2014-03-01 00:34:34.000000', 'temperatura', 985.0000, 'ºC'),
	(220920, 119, '2014-03-01 00:34:35.000000', 'temperatura', 857.0000, 'ºC'),
	(220921, 119, '2014-03-01 00:34:36.000000', 'temperatura', 129.0000, 'ºC'),
	(220922, 119, '2014-03-01 00:34:37.000000', 'temperatura', 473.0000, 'ºC'),
	(220923, 119, '2014-03-01 00:34:38.000000', 'temperatura', 778.0000, 'ºC'),
	(220924, 119, '2014-03-01 00:34:39.000000', 'temperatura', 74.0000, 'ºC'),
	(220925, 119, '2014-03-01 00:34:40.000000', 'temperatura', 436.0000, 'ºC'),
	(220926, 119, '2014-03-01 00:34:41.000000', 'temperatura', 759.0000, 'ºC'),
	(220927, 119, '2014-03-01 00:34:42.000000', 'temperatura', 88.0000, 'ºC'),
	(220928, 119, '2014-03-01 00:34:43.000000', 'temperatura', 563.0000, 'ºC'),
	(220929, 119, '2014-03-01 00:34:44.000000', 'temperatura', 150.0000, 'ºC'),
	(220930, 119, '2014-03-01 00:34:45.000000', 'temperatura', 260.0000, 'ºC'),
	(220931, 119, '2014-03-01 00:34:46.000000', 'temperatura', 853.0000, 'ºC'),
	(220932, 119, '2014-03-01 00:34:47.000000', 'temperatura', 1087.0000, 'ºC'),
	(220933, 119, '2014-03-01 00:34:48.000000', 'temperatura', 474.0000, 'ºC'),
	(220934, 119, '2014-03-01 00:34:49.000000', 'temperatura', 310.0000, 'ºC'),
	(220935, 119, '2014-03-01 00:34:50.000000', 'temperatura', 130.0000, 'ºC'),
	(220936, 119, '2014-03-01 00:34:51.000000', 'temperatura', 922.0000, 'ºC'),
	(220937, 119, '2014-03-01 00:34:52.000000', 'temperatura', 617.0000, 'ºC'),
	(220938, 119, '2014-03-01 00:34:53.000000', 'temperatura', 323.0000, 'ºC'),
	(220939, 119, '2014-03-01 00:34:54.000000', 'temperatura', 962.0000, 'ºC'),
	(220940, 119, '2014-03-01 00:34:55.000000', 'temperatura', 240.0000, 'ºC'),
	(220941, 119, '2014-03-01 00:34:56.000000', 'temperatura', 716.0000, 'ºC'),
	(220942, 119, '2014-03-01 00:34:57.000000', 'temperatura', 463.0000, 'ºC'),
	(220943, 119, '2014-03-01 00:34:58.000000', 'temperatura', 164.0000, 'ºC'),
	(220944, 119, '2014-03-01 00:34:59.000000', 'temperatura', 633.0000, 'ºC'),
	(220945, 119, '2014-03-01 00:35:00.000000', 'temperatura', 275.0000, 'ºC'),
	(220946, 119, '2014-03-01 00:35:01.000000', 'temperatura', 675.0000, 'ºC'),
	(220947, 119, '2014-03-01 00:35:02.000000', 'temperatura', 150.0000, 'ºC'),
	(220948, 119, '2014-03-01 00:35:03.000000', 'temperatura', 1126.0000, 'ºC'),
	(220949, 119, '2014-03-01 00:35:04.000000', 'temperatura', 380.0000, 'ºC'),
	(220950, 119, '2014-03-01 00:35:05.000000', 'temperatura', 921.0000, 'ºC'),
	(220951, 119, '2014-03-01 00:35:06.000000', 'temperatura', 1066.0000, 'ºC'),
	(220952, 119, '2014-03-01 00:35:07.000000', 'temperatura', 168.0000, 'ºC'),
	(220953, 119, '2014-03-01 00:35:08.000000', 'temperatura', 42.0000, 'ºC'),
	(220954, 119, '2014-03-01 00:35:09.000000', 'temperatura', 908.0000, 'ºC'),
	(220955, 119, '2014-03-01 00:35:10.000000', 'temperatura', 813.0000, 'ºC'),
	(220956, 119, '2014-03-01 00:35:11.000000', 'temperatura', 144.0000, 'ºC'),
	(220957, 119, '2014-03-01 00:35:12.000000', 'temperatura', 680.0000, 'ºC'),
	(220958, 119, '2014-03-01 00:35:13.000000', 'temperatura', 570.0000, 'ºC'),
	(220959, 119, '2014-03-01 00:35:14.000000', 'temperatura', 809.0000, 'ºC'),
	(220960, 119, '2014-03-01 00:35:15.000000', 'temperatura', 1135.0000, 'ºC'),
	(220961, 119, '2014-03-01 00:35:16.000000', 'temperatura', 849.0000, 'ºC'),
	(220962, 119, '2014-03-01 00:35:17.000000', 'temperatura', 842.0000, 'ºC'),
	(220963, 119, '2014-03-01 00:35:18.000000', 'temperatura', 463.0000, 'ºC'),
	(220964, 119, '2014-03-01 00:35:19.000000', 'temperatura', 991.0000, 'ºC'),
	(220965, 119, '2014-03-01 00:35:20.000000', 'temperatura', 1164.0000, 'ºC'),
	(220966, 119, '2014-03-01 00:35:21.000000', 'temperatura', 448.0000, 'ºC'),
	(220967, 119, '2014-03-01 00:35:22.000000', 'temperatura', 1150.0000, 'ºC'),
	(220968, 119, '2014-03-01 00:35:23.000000', 'temperatura', 804.0000, 'ºC'),
	(220969, 119, '2014-03-01 00:35:24.000000', 'temperatura', 570.0000, 'ºC'),
	(220970, 119, '2014-03-01 00:35:25.000000', 'temperatura', 440.0000, 'ºC'),
	(220971, 119, '2014-03-01 00:35:26.000000', 'temperatura', 492.0000, 'ºC'),
	(220972, 119, '2014-03-01 00:35:27.000000', 'temperatura', 1139.0000, 'ºC'),
	(220973, 119, '2014-03-01 00:35:28.000000', 'temperatura', 619.0000, 'ºC'),
	(220974, 119, '2014-03-01 00:35:29.000000', 'temperatura', 880.0000, 'ºC'),
	(220975, 119, '2014-03-01 00:35:30.000000', 'temperatura', 143.0000, 'ºC'),
	(220976, 119, '2014-03-01 00:35:31.000000', 'temperatura', 473.0000, 'ºC'),
	(220977, 119, '2014-03-01 00:35:32.000000', 'temperatura', 740.0000, 'ºC'),
	(220978, 119, '2014-03-01 00:35:33.000000', 'temperatura', 1080.0000, 'ºC'),
	(220979, 119, '2014-03-01 00:35:34.000000', 'temperatura', 782.0000, 'ºC'),
	(220980, 119, '2014-03-01 00:35:35.000000', 'temperatura', 669.0000, 'ºC'),
	(220981, 119, '2014-03-01 00:35:36.000000', 'temperatura', 1000.0000, 'ºC'),
	(220982, 119, '2014-03-01 00:35:37.000000', 'temperatura', 594.0000, 'ºC'),
	(220983, 119, '2014-03-01 00:35:38.000000', 'temperatura', 1172.0000, 'ºC'),
	(220984, 119, '2014-03-01 00:35:39.000000', 'temperatura', 477.0000, 'ºC'),
	(220985, 119, '2014-03-01 00:35:40.000000', 'temperatura', 70.0000, 'ºC'),
	(220986, 119, '2014-03-01 00:35:41.000000', 'temperatura', 121.0000, 'ºC'),
	(220987, 119, '2014-03-01 00:35:42.000000', 'temperatura', 395.0000, 'ºC'),
	(220988, 119, '2014-03-01 00:35:43.000000', 'temperatura', 414.0000, 'ºC'),
	(220989, 119, '2014-03-01 00:35:44.000000', 'temperatura', 884.0000, 'ºC'),
	(220990, 119, '2014-03-01 00:35:45.000000', 'temperatura', 778.0000, 'ºC'),
	(220991, 119, '2014-03-01 00:35:46.000000', 'temperatura', 41.0000, 'ºC'),
	(220992, 119, '2014-03-01 00:35:47.000000', 'temperatura', 269.0000, 'ºC'),
	(220993, 119, '2014-03-01 00:35:48.000000', 'temperatura', 25.0000, 'ºC'),
	(220994, 119, '2014-03-01 00:35:49.000000', 'temperatura', 517.0000, 'ºC'),
	(220995, 119, '2014-03-01 00:35:50.000000', 'temperatura', 111.0000, 'ºC'),
	(220996, 119, '2014-03-01 00:35:51.000000', 'temperatura', 203.0000, 'ºC'),
	(220997, 119, '2014-03-01 00:35:52.000000', 'temperatura', 685.0000, 'ºC'),
	(220998, 119, '2014-03-01 00:35:53.000000', 'temperatura', 414.0000, 'ºC'),
	(220999, 119, '2014-03-01 00:35:54.000000', 'temperatura', 17.0000, 'ºC'),
	(221000, 119, '2014-03-01 00:35:55.000000', 'temperatura', 45.0000, 'ºC'),
	(221001, 119, '2014-03-01 00:35:56.000000', 'temperatura', 172.0000, 'ºC'),
	(221002, 119, '2014-03-01 00:35:57.000000', 'temperatura', 728.0000, 'ºC'),
	(221003, 119, '2014-03-01 00:35:58.000000', 'temperatura', 722.0000, 'ºC'),
	(221004, 119, '2014-03-01 00:35:59.000000', 'temperatura', 229.0000, 'ºC'),
	(221005, 119, '2014-03-01 00:36:00.000000', 'temperatura', 180.0000, 'ºC'),
	(221006, 119, '2014-03-01 00:36:01.000000', 'temperatura', 211.0000, 'ºC'),
	(221007, 119, '2014-03-01 00:36:02.000000', 'temperatura', 518.0000, 'ºC'),
	(221008, 119, '2014-03-01 00:36:03.000000', 'temperatura', 757.0000, 'ºC'),
	(221009, 119, '2014-03-01 00:36:04.000000', 'temperatura', 1033.0000, 'ºC'),
	(221010, 119, '2014-03-01 00:36:05.000000', 'temperatura', 492.0000, 'ºC'),
	(221011, 119, '2014-03-01 00:36:06.000000', 'temperatura', 561.0000, 'ºC'),
	(221012, 119, '2014-03-01 00:36:07.000000', 'temperatura', 132.0000, 'ºC'),
	(221013, 119, '2014-03-01 00:36:08.000000', 'temperatura', 175.0000, 'ºC'),
	(221014, 119, '2014-03-01 00:36:09.000000', 'temperatura', 480.0000, 'ºC'),
	(221015, 119, '2014-03-01 00:36:10.000000', 'temperatura', 676.0000, 'ºC'),
	(221016, 119, '2014-03-01 00:36:11.000000', 'temperatura', 742.0000, 'ºC'),
	(221017, 119, '2014-03-01 00:36:12.000000', 'temperatura', 482.0000, 'ºC'),
	(221018, 119, '2014-03-01 00:36:13.000000', 'temperatura', 184.0000, 'ºC'),
	(221019, 119, '2014-03-01 00:36:14.000000', 'temperatura', 675.0000, 'ºC'),
	(221020, 119, '2014-03-01 00:36:15.000000', 'temperatura', 422.0000, 'ºC'),
	(221021, 119, '2014-03-01 00:36:16.000000', 'temperatura', 86.0000, 'ºC'),
	(221022, 119, '2014-03-01 00:36:17.000000', 'temperatura', 363.0000, 'ºC'),
	(221023, 119, '2014-03-01 00:36:18.000000', 'temperatura', 357.0000, 'ºC'),
	(221024, 119, '2014-03-01 00:36:19.000000', 'temperatura', 698.0000, 'ºC'),
	(221025, 119, '2014-03-01 00:36:20.000000', 'temperatura', 17.0000, 'ºC'),
	(221026, 119, '2014-03-01 00:36:21.000000', 'temperatura', 394.0000, 'ºC'),
	(221027, 119, '2014-03-01 00:36:22.000000', 'temperatura', 718.0000, 'ºC'),
	(221028, 119, '2014-03-01 00:36:23.000000', 'temperatura', 10.0000, 'ºC'),
	(221029, 119, '2014-03-01 00:36:24.000000', 'temperatura', 297.0000, 'ºC'),
	(221030, 119, '2014-03-01 00:36:25.000000', 'temperatura', 255.0000, 'ºC'),
	(221031, 119, '2014-03-01 00:36:26.000000', 'temperatura', 386.0000, 'ºC'),
	(221032, 119, '2014-03-01 00:36:27.000000', 'temperatura', 1163.0000, 'ºC'),
	(221033, 119, '2014-03-01 00:36:28.000000', 'temperatura', 1058.0000, 'ºC'),
	(221034, 119, '2014-03-01 00:36:29.000000', 'temperatura', 602.0000, 'ºC'),
	(221035, 119, '2014-03-01 00:36:30.000000', 'temperatura', 1037.0000, 'ºC'),
	(221036, 119, '2014-03-01 00:36:31.000000', 'temperatura', 979.0000, 'ºC'),
	(221037, 119, '2014-03-01 00:36:32.000000', 'temperatura', 584.0000, 'ºC'),
	(221038, 119, '2014-03-01 00:36:33.000000', 'temperatura', 1185.0000, 'ºC'),
	(221039, 119, '2014-03-01 00:36:34.000000', 'temperatura', 572.0000, 'ºC'),
	(221040, 119, '2014-03-01 00:36:35.000000', 'temperatura', 506.0000, 'ºC'),
	(221041, 119, '2014-03-01 00:36:36.000000', 'temperatura', 813.0000, 'ºC'),
	(221042, 119, '2014-03-01 00:36:37.000000', 'temperatura', 151.0000, 'ºC'),
	(221043, 119, '2014-03-01 00:36:38.000000', 'temperatura', 713.0000, 'ºC'),
	(221044, 119, '2014-03-01 00:36:39.000000', 'temperatura', 713.0000, 'ºC'),
	(221045, 119, '2014-03-01 00:36:40.000000', 'temperatura', 228.0000, 'ºC'),
	(221046, 119, '2014-03-01 00:36:41.000000', 'temperatura', 203.0000, 'ºC'),
	(221047, 119, '2014-03-01 00:36:42.000000', 'temperatura', 329.0000, 'ºC'),
	(221048, 119, '2014-03-01 00:36:43.000000', 'temperatura', 1036.0000, 'ºC'),
	(221049, 119, '2014-03-01 00:36:44.000000', 'temperatura', 596.0000, 'ºC'),
	(221050, 119, '2014-03-01 00:36:45.000000', 'temperatura', 1069.0000, 'ºC'),
	(221051, 119, '2014-03-01 00:36:46.000000', 'temperatura', 1160.0000, 'ºC'),
	(221052, 119, '2014-03-01 00:36:47.000000', 'temperatura', 193.0000, 'ºC'),
	(221053, 119, '2014-03-01 00:36:48.000000', 'temperatura', 1087.0000, 'ºC'),
	(221054, 119, '2014-03-01 00:36:49.000000', 'temperatura', 54.0000, 'ºC'),
	(221055, 119, '2014-03-01 00:36:50.000000', 'temperatura', 612.0000, 'ºC'),
	(221056, 119, '2014-03-01 00:36:51.000000', 'temperatura', 498.0000, 'ºC'),
	(221057, 119, '2014-03-01 00:36:52.000000', 'temperatura', 652.0000, 'ºC'),
	(221058, 119, '2014-03-01 00:36:53.000000', 'temperatura', 570.0000, 'ºC'),
	(221059, 119, '2014-03-01 00:36:54.000000', 'temperatura', 893.0000, 'ºC'),
	(221060, 119, '2014-03-01 00:36:55.000000', 'temperatura', 357.0000, 'ºC'),
	(221061, 119, '2014-03-01 00:36:56.000000', 'temperatura', 307.0000, 'ºC'),
	(221062, 119, '2014-03-01 00:36:57.000000', 'temperatura', 464.0000, 'ºC'),
	(221063, 119, '2014-03-01 00:36:58.000000', 'temperatura', 198.0000, 'ºC'),
	(221064, 119, '2014-03-01 00:36:59.000000', 'temperatura', 801.0000, 'ºC'),
	(221065, 119, '2014-03-01 00:37:00.000000', 'temperatura', 1010.0000, 'ºC'),
	(221066, 119, '2014-03-01 00:37:01.000000', 'temperatura', 249.0000, 'ºC'),
	(221067, 119, '2014-03-01 00:37:02.000000', 'temperatura', 616.0000, 'ºC'),
	(221068, 119, '2014-03-01 00:37:03.000000', 'temperatura', 1131.0000, 'ºC'),
	(221069, 119, '2014-03-01 00:37:04.000000', 'temperatura', 209.0000, 'ºC'),
	(221070, 119, '2014-03-01 00:37:05.000000', 'temperatura', 52.0000, 'ºC'),
	(221071, 119, '2014-03-01 00:37:06.000000', 'temperatura', 834.0000, 'ºC'),
	(221072, 119, '2014-03-01 00:37:07.000000', 'temperatura', 415.0000, 'ºC'),
	(221073, 119, '2014-03-01 00:37:08.000000', 'temperatura', 772.0000, 'ºC'),
	(221074, 119, '2014-03-01 00:37:09.000000', 'temperatura', 214.0000, 'ºC'),
	(221075, 119, '2014-03-01 00:37:10.000000', 'temperatura', 1158.0000, 'ºC'),
	(221076, 119, '2014-03-01 00:37:11.000000', 'temperatura', 347.0000, 'ºC'),
	(221077, 119, '2014-03-01 00:37:12.000000', 'temperatura', 662.0000, 'ºC'),
	(221078, 119, '2014-03-01 00:37:13.000000', 'temperatura', 1068.0000, 'ºC'),
	(221079, 119, '2014-03-01 00:37:14.000000', 'temperatura', 955.0000, 'ºC'),
	(221080, 119, '2014-03-01 00:37:15.000000', 'temperatura', 374.0000, 'ºC'),
	(221081, 119, '2014-03-01 00:37:16.000000', 'temperatura', 203.0000, 'ºC'),
	(221082, 119, '2014-03-01 00:37:17.000000', 'temperatura', 1093.0000, 'ºC'),
	(221083, 119, '2014-03-01 00:37:18.000000', 'temperatura', 57.0000, 'ºC'),
	(221084, 119, '2014-03-01 00:37:19.000000', 'temperatura', 609.0000, 'ºC'),
	(221085, 119, '2014-03-01 00:37:20.000000', 'temperatura', 472.0000, 'ºC'),
	(221086, 119, '2014-03-01 00:37:21.000000', 'temperatura', 535.0000, 'ºC'),
	(221087, 119, '2014-03-01 00:37:22.000000', 'temperatura', 58.0000, 'ºC'),
	(221088, 119, '2014-03-01 00:37:23.000000', 'temperatura', 1087.0000, 'ºC'),
	(221089, 119, '2014-03-01 00:37:24.000000', 'temperatura', 462.0000, 'ºC'),
	(221090, 119, '2014-03-01 00:37:25.000000', 'temperatura', 247.0000, 'ºC'),
	(221091, 119, '2014-03-01 00:37:26.000000', 'temperatura', 1050.0000, 'ºC'),
	(221092, 119, '2014-03-01 00:37:27.000000', 'temperatura', 910.0000, 'ºC'),
	(221093, 119, '2014-03-01 00:37:28.000000', 'temperatura', 201.0000, 'ºC'),
	(221094, 119, '2014-03-01 00:37:29.000000', 'temperatura', 677.0000, 'ºC'),
	(221095, 119, '2014-03-01 00:37:30.000000', 'temperatura', 382.0000, 'ºC'),
	(221096, 119, '2014-03-01 00:37:31.000000', 'temperatura', 1080.0000, 'ºC'),
	(221097, 119, '2014-03-01 00:37:32.000000', 'temperatura', 654.0000, 'ºC'),
	(221098, 119, '2014-03-01 00:37:33.000000', 'temperatura', 32.0000, 'ºC'),
	(221099, 119, '2014-03-01 00:37:34.000000', 'temperatura', 596.0000, 'ºC'),
	(221100, 119, '2014-03-01 00:37:35.000000', 'temperatura', 487.0000, 'ºC'),
	(221101, 119, '2014-03-01 00:37:36.000000', 'temperatura', 647.0000, 'ºC'),
	(221102, 119, '2014-03-01 00:37:37.000000', 'temperatura', 575.0000, 'ºC'),
	(221103, 119, '2014-03-01 00:37:38.000000', 'temperatura', 935.0000, 'ºC'),
	(221104, 119, '2014-03-01 00:37:39.000000', 'temperatura', 549.0000, 'ºC'),
	(221105, 119, '2014-03-01 00:37:40.000000', 'temperatura', 1140.0000, 'ºC'),
	(221106, 119, '2014-03-01 00:37:41.000000', 'temperatura', 456.0000, 'ºC'),
	(221107, 119, '2014-03-01 00:37:42.000000', 'temperatura', 59.0000, 'ºC'),
	(221108, 119, '2014-03-01 00:37:43.000000', 'temperatura', 128.0000, 'ºC'),
	(221109, 119, '2014-03-01 00:37:44.000000', 'temperatura', 463.0000, 'ºC'),
	(221110, 119, '2014-03-01 00:37:45.000000', 'temperatura', 732.0000, 'ºC'),
	(221111, 119, '2014-03-01 00:37:46.000000', 'temperatura', 1072.0000, 'ºC'),
	(221112, 119, '2014-03-01 00:37:47.000000', 'temperatura', 763.0000, 'ºC'),
	(221113, 119, '2014-03-01 00:37:48.000000', 'temperatura', 598.0000, 'ºC'),
	(221114, 119, '2014-03-01 00:37:49.000000', 'temperatura', 705.0000, 'ºC'),
	(221115, 119, '2014-03-01 00:37:50.000000', 'temperatura', 529.0000, 'ºC'),
	(221116, 119, '2014-03-01 00:37:51.000000', 'temperatura', 532.0000, 'ºC'),
	(221117, 119, '2014-03-01 00:37:52.000000', 'temperatura', 1072.0000, 'ºC'),
	(221118, 119, '2014-03-01 00:37:53.000000', 'temperatura', 166.0000, 'ºC'),
	(221119, 119, '2014-03-01 00:37:54.000000', 'temperatura', 14.0000, 'ºC'),
	(221120, 119, '2014-03-01 00:37:55.000000', 'temperatura', 773.0000, 'ºC'),
	(221121, 119, '2014-03-01 00:37:56.000000', 'temperatura', 222.0000, 'ºC'),
	(221122, 119, '2014-03-01 00:37:57.000000', 'temperatura', 1194.0000, 'ºC'),
	(221123, 119, '2014-03-01 00:37:58.000000', 'temperatura', 503.0000, 'ºC'),
	(221124, 119, '2014-03-01 00:37:59.000000', 'temperatura', 135.0000, 'ºC'),
	(221125, 119, '2014-03-01 00:38:00.000000', 'temperatura', 366.0000, 'ºC'),
	(221126, 119, '2014-03-01 00:38:01.000000', 'temperatura', 225.0000, 'ºC'),
	(221127, 119, '2014-03-01 00:38:02.000000', 'temperatura', 26.0000, 'ºC'),
	(221128, 119, '2014-03-01 00:38:03.000000', 'temperatura', 658.0000, 'ºC'),
	(221129, 119, '2014-03-01 00:38:04.000000', 'temperatura', 813.0000, 'ºC'),
	(221130, 119, '2014-03-01 00:38:05.000000', 'temperatura', 889.0000, 'ºC'),
	(221131, 119, '2014-03-01 00:38:06.000000', 'temperatura', 809.0000, 'ºC'),
	(221132, 119, '2014-03-01 00:38:07.000000', 'temperatura', 179.0000, 'ºC'),
	(221133, 119, '2014-03-01 00:38:08.000000', 'temperatura', 867.0000, 'ºC'),
	(221134, 119, '2014-03-01 00:38:09.000000', 'temperatura', 198.0000, 'ºC'),
	(221135, 119, '2014-03-01 00:38:10.000000', 'temperatura', 788.0000, 'ºC'),
	(221136, 119, '2014-03-01 00:38:11.000000', 'temperatura', 949.0000, 'ºC'),
	(221137, 119, '2014-03-01 00:38:12.000000', 'temperatura', 1179.0000, 'ºC'),
	(221138, 119, '2014-03-01 00:38:13.000000', 'temperatura', 652.0000, 'ºC'),
	(221139, 119, '2014-03-01 00:38:14.000000', 'temperatura', 920.0000, 'ºC'),
	(221140, 119, '2014-03-01 00:38:15.000000', 'temperatura', 248.0000, 'ºC'),
	(221141, 119, '2014-03-01 00:38:16.000000', 'temperatura', 877.0000, 'ºC'),
	(221142, 119, '2014-03-01 00:38:17.000000', 'temperatura', 43.0000, 'ºC'),
	(221143, 119, '2014-03-01 00:38:18.000000', 'temperatura', 1183.0000, 'ºC'),
	(221144, 119, '2014-03-01 00:38:19.000000', 'temperatura', 987.0000, 'ºC'),
	(221145, 119, '2014-03-01 00:38:20.000000', 'temperatura', 188.0000, 'ºC'),
	(221146, 119, '2014-03-01 00:38:21.000000', 'temperatura', 378.0000, 'ºC'),
	(221147, 119, '2014-03-01 00:38:22.000000', 'temperatura', 126.0000, 'ºC'),
	(221148, 119, '2014-03-01 00:38:23.000000', 'temperatura', 699.0000, 'ºC'),
	(221149, 119, '2014-03-01 00:38:24.000000', 'temperatura', 717.0000, 'ºC'),
	(221150, 119, '2014-03-01 00:38:25.000000', 'temperatura', 287.0000, 'ºC'),
	(221151, 119, '2014-03-01 00:38:26.000000', 'temperatura', 485.0000, 'ºC'),
	(221152, 119, '2014-03-01 00:38:27.000000', 'temperatura', 363.0000, 'ºC'),
	(221153, 119, '2014-03-01 00:38:28.000000', 'temperatura', 363.0000, 'ºC'),
	(221154, 119, '2014-03-01 00:38:29.000000', 'temperatura', 724.0000, 'ºC'),
	(221155, 119, '2014-03-01 00:38:30.000000', 'temperatura', 133.0000, 'ºC'),
	(221156, 119, '2014-03-01 00:38:31.000000', 'temperatura', 892.0000, 'ºC'),
	(221157, 119, '2014-03-01 00:38:32.000000', 'temperatura', 463.0000, 'ºC'),
	(221158, 119, '2014-03-01 00:38:33.000000', 'temperatura', 840.0000, 'ºC'),
	(221159, 119, '2014-03-01 00:38:34.000000', 'temperatura', 412.0000, 'ºC'),
	(221160, 119, '2014-03-01 00:38:35.000000', 'temperatura', 738.0000, 'ºC'),
	(221161, 119, '2014-03-01 00:38:36.000000', 'temperatura', 54.0000, 'ºC'),
	(221162, 119, '2014-03-01 00:38:37.000000', 'temperatura', 458.0000, 'ºC'),
	(221163, 119, '2014-03-01 00:38:38.000000', 'temperatura', 928.0000, 'ºC'),
	(221164, 119, '2014-03-01 00:38:39.000000', 'temperatura', 868.0000, 'ºC'),
	(221165, 119, '2014-03-01 00:38:40.000000', 'temperatura', 356.0000, 'ºC'),
	(221166, 119, '2014-03-01 00:38:41.000000', 'temperatura', 376.0000, 'ºC'),
	(221167, 119, '2014-03-01 00:38:42.000000', 'temperatura', 811.0000, 'ºC'),
	(221168, 119, '2014-03-01 00:38:43.000000', 'temperatura', 528.0000, 'ºC'),
	(221169, 119, '2014-03-01 00:38:44.000000', 'temperatura', 207.0000, 'ºC'),
	(221170, 119, '2014-03-01 00:38:45.000000', 'temperatura', 652.0000, 'ºC'),
	(221171, 119, '2014-03-01 00:38:46.000000', 'temperatura', 240.0000, 'ºC'),
	(221172, 119, '2014-03-01 00:38:47.000000', 'temperatura', 445.0000, 'ºC'),
	(221173, 119, '2014-03-01 00:38:48.000000', 'temperatura', 303.0000, 'ºC'),
	(221174, 119, '2014-03-01 00:38:49.000000', 'temperatura', 181.0000, 'ºC'),
	(221175, 119, '2014-03-01 00:38:50.000000', 'temperatura', 1198.0000, 'ºC'),
	(221176, 119, '2014-03-01 00:38:51.000000', 'temperatura', 646.0000, 'ºC'),
	(221177, 119, '2014-03-01 00:38:52.000000', 'temperatura', 839.0000, 'ºC'),
	(221178, 119, '2014-03-01 00:38:53.000000', 'temperatura', 1055.0000, 'ºC'),
	(221179, 119, '2014-03-01 00:38:54.000000', 'temperatura', 360.0000, 'ºC'),
	(221180, 119, '2014-03-01 00:38:55.000000', 'temperatura', 1037.0000, 'ºC'),
	(221181, 119, '2014-03-01 00:38:56.000000', 'temperatura', 502.0000, 'ºC'),
	(221182, 119, '2014-03-01 00:38:57.000000', 'temperatura', 602.0000, 'ºC'),
	(221183, 119, '2014-03-01 00:38:58.000000', 'temperatura', 304.0000, 'ºC'),
	(221184, 119, '2014-03-01 00:38:59.000000', 'temperatura', 915.0000, 'ºC'),
	(221185, 119, '2014-03-01 00:39:00.000000', 'temperatura', 63.0000, 'ºC'),
	(221186, 119, '2014-03-01 00:39:01.000000', 'temperatura', 1169.0000, 'ºC'),
	(221187, 119, '2014-03-01 00:39:02.000000', 'temperatura', 859.0000, 'ºC'),
	(221188, 119, '2014-03-01 00:39:03.000000', 'temperatura', 788.0000, 'ºC'),
	(221189, 119, '2014-03-01 00:39:04.000000', 'temperatura', 164.0000, 'ºC'),
	(221190, 119, '2014-03-01 00:39:05.000000', 'temperatura', 856.0000, 'ºC'),
	(221191, 119, '2014-03-01 00:39:06.000000', 'temperatura', 190.0000, 'ºC'),
	(221192, 119, '2014-03-01 00:39:07.000000', 'temperatura', 779.0000, 'ºC'),
	(221193, 119, '2014-03-01 00:39:08.000000', 'temperatura', 929.0000, 'ºC'),
	(221194, 119, '2014-03-01 00:39:09.000000', 'temperatura', 1107.0000, 'ºC'),
	(221195, 119, '2014-03-01 00:39:10.000000', 'temperatura', 348.0000, 'ºC'),
	(221196, 119, '2014-03-01 00:39:11.000000', 'temperatura', 820.0000, 'ºC'),
	(221197, 119, '2014-03-01 00:39:12.000000', 'temperatura', 658.0000, 'ºC'),
	(221198, 119, '2014-03-01 00:39:13.000000', 'temperatura', 829.0000, 'ºC'),
	(221199, 119, '2014-03-01 00:39:14.000000', 'temperatura', 972.0000, 'ºC'),
	(221200, 119, '2014-03-01 00:39:15.000000', 'temperatura', 1172.0000, 'ºC'),
	(221201, 119, '2014-03-01 00:39:16.000000', 'temperatura', 546.0000, 'ºC'),
	(221202, 119, '2014-03-01 00:39:17.000000', 'temperatura', 413.0000, 'ºC'),
	(221203, 119, '2014-03-01 00:39:18.000000', 'temperatura', 429.0000, 'ºC'),
	(221204, 119, '2014-03-01 00:39:19.000000', 'temperatura', 906.0000, 'ºC'),
	(221205, 119, '2014-03-01 00:39:20.000000', 'temperatura', 842.0000, 'ºC'),
	(221206, 119, '2014-03-01 00:39:21.000000', 'temperatura', 293.0000, 'ºC'),
	(221207, 119, '2014-03-01 00:39:22.000000', 'temperatura', 139.0000, 'ºC'),
	(221208, 119, '2014-03-01 00:39:23.000000', 'temperatura', 1015.0000, 'ºC'),
	(221209, 119, '2014-03-01 00:39:24.000000', 'temperatura', 1061.0000, 'ºC'),
	(221210, 119, '2014-03-01 00:39:25.000000', 'temperatura', 1061.0000, 'ºC'),
	(221211, 119, '2014-03-01 00:39:26.000000', 'temperatura', 924.0000, 'ºC'),
	(221212, 119, '2014-03-01 00:39:27.000000', 'temperatura', 234.0000, 'ºC'),
	(221213, 119, '2014-03-01 00:39:28.000000', 'temperatura', 801.0000, 'ºC'),
	(221214, 119, '2014-03-01 00:39:29.000000', 'temperatura', 902.0000, 'ºC'),
	(221215, 119, '2014-03-01 00:39:30.000000', 'temperatura', 910.0000, 'ºC'),
	(221216, 119, '2014-03-01 00:39:31.000000', 'temperatura', 641.0000, 'ºC'),
	(221217, 119, '2014-03-01 00:39:32.000000', 'temperatura', 478.0000, 'ºC'),
	(221218, 119, '2014-03-01 00:39:33.000000', 'temperatura', 466.0000, 'ºC'),
	(221219, 119, '2014-03-01 00:39:34.000000', 'temperatura', 895.0000, 'ºC'),
	(221220, 119, '2014-03-01 00:39:35.000000', 'temperatura', 679.0000, 'ºC'),
	(221221, 119, '2014-03-01 00:39:36.000000', 'temperatura', 712.0000, 'ºC'),
	(221222, 119, '2014-03-01 00:39:37.000000', 'temperatura', 321.0000, 'ºC'),
	(221223, 119, '2014-03-01 00:39:38.000000', 'temperatura', 671.0000, 'ºC'),
	(221224, 119, '2014-03-01 00:39:39.000000', 'temperatura', 1193.0000, 'ºC'),
	(221225, 119, '2014-03-01 00:39:40.000000', 'temperatura', 352.0000, 'ºC'),
	(221226, 119, '2014-03-01 00:39:41.000000', 'temperatura', 581.0000, 'ºC'),
	(221227, 119, '2014-03-01 00:39:42.000000', 'temperatura', 648.0000, 'ºC'),
	(221228, 119, '2014-03-01 00:39:43.000000', 'temperatura', 298.0000, 'ºC'),
	(221229, 119, '2014-03-01 00:39:44.000000', 'temperatura', 747.0000, 'ºC'),
	(221230, 119, '2014-03-01 00:39:45.000000', 'temperatura', 442.0000, 'ºC'),
	(221231, 119, '2014-03-01 00:39:46.000000', 'temperatura', 1169.0000, 'ºC'),
	(221232, 119, '2014-03-01 00:39:47.000000', 'temperatura', 921.0000, 'ºC'),
	(221233, 119, '2014-03-01 00:39:48.000000', 'temperatura', 1097.0000, 'ºC'),
	(221234, 119, '2014-03-01 00:39:49.000000', 'temperatura', 323.0000, 'ºC'),
	(221235, 119, '2014-03-01 00:39:50.000000', 'temperatura', 726.0000, 'ºC'),
	(221236, 119, '2014-03-01 00:39:51.000000', 'temperatura', 258.0000, 'ºC'),
	(221237, 119, '2014-03-01 00:39:52.000000', 'temperatura', 316.0000, 'ºC'),
	(221238, 119, '2014-03-01 00:39:53.000000', 'temperatura', 804.0000, 'ºC'),
	(221239, 119, '2014-03-01 00:39:54.000000', 'temperatura', 674.0000, 'ºC'),
	(221240, 119, '2014-03-01 00:39:55.000000', 'temperatura', 957.0000, 'ºC'),
	(221241, 119, '2014-03-01 00:39:56.000000', 'temperatura', 366.0000, 'ºC'),
	(221242, 119, '2014-03-01 00:39:57.000000', 'temperatura', 156.0000, 'ºC'),
	(221243, 119, '2014-03-01 00:39:58.000000', 'temperatura', 885.0000, 'ºC'),
	(221244, 119, '2014-03-01 00:39:59.000000', 'temperatura', 357.0000, 'ºC'),
	(221245, 119, '2014-03-01 00:40:00.000000', 'temperatura', 332.0000, 'ºC'),
	(221246, 119, '2014-03-01 00:40:01.000000', 'temperatura', 589.0000, 'ºC'),
	(221247, 119, '2014-03-01 00:40:02.000000', 'temperatura', 750.0000, 'ºC'),
	(221248, 119, '2014-03-01 00:40:03.000000', 'temperatura', 784.0000, 'ºC'),
	(221249, 119, '2014-03-01 00:40:04.000000', 'temperatura', 469.0000, 'ºC'),
	(221250, 119, '2014-03-01 00:40:05.000000', 'temperatura', 1193.0000, 'ºC'),
	(221251, 119, '2014-03-01 00:40:06.000000', 'temperatura', 960.0000, 'ºC'),
	(221252, 119, '2014-03-01 00:40:07.000000', 'temperatura', 20.0000, 'ºC'),
	(221253, 119, '2014-03-01 00:40:08.000000', 'temperatura', 822.0000, 'ºC'),
	(221254, 119, '2014-03-01 00:40:09.000000', 'temperatura', 449.0000, 'ºC'),
	(221255, 119, '2014-03-01 00:40:10.000000', 'temperatura', 981.0000, 'ºC'),
	(221256, 119, '2014-03-01 00:40:11.000000', 'temperatura', 1158.0000, 'ºC'),
	(221257, 119, '2014-03-01 00:40:12.000000', 'temperatura', 448.0000, 'ºC'),
	(221258, 119, '2014-03-01 00:40:13.000000', 'temperatura', 1165.0000, 'ºC'),
	(221259, 119, '2014-03-01 00:40:14.000000', 'temperatura', 883.0000, 'ºC'),
	(221260, 119, '2014-03-01 00:40:15.000000', 'temperatura', 919.0000, 'ºC'),
	(221261, 119, '2014-03-01 00:40:16.000000', 'temperatura', 746.0000, 'ºC'),
	(221262, 119, '2014-03-01 00:40:17.000000', 'temperatura', 974.0000, 'ºC'),
	(221263, 119, '2014-03-01 00:40:18.000000', 'temperatura', 232.0000, 'ºC'),
	(221264, 119, '2014-03-01 00:40:19.000000', 'temperatura', 640.0000, 'ºC'),
	(221265, 119, '2014-03-01 00:40:20.000000', 'temperatura', 103.0000, 'ºC'),
	(221266, 119, '2014-03-01 00:40:21.000000', 'temperatura', 994.0000, 'ºC'),
	(221267, 119, '2014-03-01 00:40:22.000000', 'temperatura', 1063.0000, 'ºC'),
	(221268, 119, '2014-03-01 00:40:23.000000', 'temperatura', 1133.0000, 'ºC'),
	(221269, 119, '2014-03-01 00:40:24.000000', 'temperatura', 75.0000, 'ºC'),
	(221270, 119, '2014-03-01 00:40:25.000000', 'temperatura', 579.0000, 'ºC'),
	(221271, 119, '2014-03-01 00:40:26.000000', 'temperatura', 268.0000, 'ºC'),
	(221272, 119, '2014-03-01 00:40:27.000000', 'temperatura', 807.0000, 'ºC'),
	(221273, 119, '2014-03-01 00:40:28.000000', 'temperatura', 828.0000, 'ºC'),
	(221274, 119, '2014-03-01 00:40:29.000000', 'temperatura', 523.0000, 'ºC'),
	(221275, 119, '2014-03-01 00:40:30.000000', 'temperatura', 129.0000, 'ºC'),
	(221276, 119, '2014-03-01 00:40:31.000000', 'temperatura', 278.0000, 'ºC'),
	(221277, 119, '2014-03-01 00:40:32.000000', 'temperatura', 1004.0000, 'ºC'),
	(221278, 119, '2014-03-01 00:40:33.000000', 'temperatura', 586.0000, 'ºC'),
	(221279, 119, '2014-03-01 00:40:34.000000', 'temperatura', 1118.0000, 'ºC'),
	(221280, 119, '2014-03-01 00:40:35.000000', 'temperatura', 233.0000, 'ºC'),
	(221281, 119, '2014-03-01 00:40:36.000000', 'temperatura', 210.0000, 'ºC'),
	(221282, 119, '2014-03-01 00:40:37.000000', 'temperatura', 354.0000, 'ºC'),
	(221283, 119, '2014-03-01 00:40:38.000000', 'temperatura', 1139.0000, 'ºC'),
	(221284, 119, '2014-03-01 00:40:39.000000', 'temperatura', 1036.0000, 'ºC'),
	(221285, 119, '2014-03-01 00:40:40.000000', 'temperatura', 561.0000, 'ºC'),
	(221286, 119, '2014-03-01 00:40:41.000000', 'temperatura', 898.0000, 'ºC'),
	(221287, 119, '2014-03-01 00:40:42.000000', 'temperatura', 408.0000, 'ºC'),
	(221288, 119, '2014-03-01 00:40:43.000000', 'temperatura', 547.0000, 'ºC'),
	(221289, 119, '2014-03-01 00:40:44.000000', 'temperatura', 311.0000, 'ºC'),
	(221290, 119, '2014-03-01 00:40:45.000000', 'temperatura', 1112.0000, 'ºC'),
	(221291, 119, '2014-03-01 00:40:46.000000', 'temperatura', 1031.0000, 'ºC'),
	(221292, 119, '2014-03-01 00:40:47.000000', 'temperatura', 619.0000, 'ºC'),
	(221293, 119, '2014-03-01 00:40:48.000000', 'temperatura', 3.0000, 'ºC'),
	(221294, 119, '2014-03-01 00:40:49.000000', 'temperatura', 558.0000, 'ºC'),
	(221295, 119, '2014-03-01 00:40:50.000000', 'temperatura', 381.0000, 'ºC'),
	(221296, 119, '2014-03-01 00:40:51.000000', 'temperatura', 232.0000, 'ºC'),
	(221297, 119, '2014-03-01 00:40:52.000000', 'temperatura', 19.0000, 'ºC'),
	(221298, 119, '2014-03-01 00:40:53.000000', 'temperatura', 600.0000, 'ºC'),
	(221299, 119, '2014-03-01 00:40:54.000000', 'temperatura', 544.0000, 'ºC'),
	(221300, 119, '2014-03-01 00:40:55.000000', 'temperatura', 918.0000, 'ºC'),
	(221301, 119, '2014-03-01 00:40:56.000000', 'temperatura', 558.0000, 'ºC'),
	(221302, 119, '2014-03-01 00:40:57.000000', 'temperatura', 39.0000, 'ºC'),
	(221303, 119, '2014-03-01 00:40:58.000000', 'temperatura', 921.0000, 'ºC'),
	(221304, 119, '2014-03-01 00:40:59.000000', 'temperatura', 889.0000, 'ºC'),
	(221305, 119, '2014-03-01 00:41:00.000000', 'temperatura', 482.0000, 'ºC'),
	(221306, 119, '2014-03-01 00:41:01.000000', 'temperatura', 945.0000, 'ºC'),
	(221307, 119, '2014-03-01 00:41:02.000000', 'temperatura', 877.0000, 'ºC'),
	(221308, 119, '2014-03-01 00:41:03.000000', 'temperatura', 350.0000, 'ºC'),
	(221309, 119, '2014-03-01 00:41:04.000000', 'temperatura', 321.0000, 'ºC'),
	(221310, 119, '2014-03-01 00:41:05.000000', 'temperatura', 557.0000, 'ºC'),
	(221311, 119, '2014-03-01 00:41:06.000000', 'temperatura', 620.0000, 'ºC'),
	(221312, 119, '2014-03-01 00:41:07.000000', 'temperatura', 232.0000, 'ºC'),
	(221313, 119, '2014-03-01 00:41:08.000000', 'temperatura', 501.0000, 'ºC'),
	(221314, 119, '2014-03-01 00:41:09.000000', 'temperatura', 607.0000, 'ºC'),
	(221315, 119, '2014-03-01 00:41:10.000000', 'temperatura', 335.0000, 'ºC'),
	(221316, 119, '2014-03-01 00:41:11.000000', 'temperatura', 1051.0000, 'ºC'),
	(221317, 119, '2014-03-01 00:41:12.000000', 'temperatura', 654.0000, 'ºC'),
	(221318, 119, '2014-03-01 00:41:13.000000', 'temperatura', 115.0000, 'ºC'),
	(221319, 119, '2014-03-01 00:41:14.000000', 'temperatura', 1012.0000, 'ºC'),
	(221320, 119, '2014-03-01 00:41:15.000000', 'temperatura', 1119.0000, 'ºC'),
	(221321, 119, '2014-03-01 00:41:16.000000', 'temperatura', 157.0000, 'ºC'),
	(221322, 119, '2014-03-01 00:41:17.000000', 'temperatura', 1029.0000, 'ºC'),
	(221323, 119, '2014-03-01 00:41:18.000000', 'temperatura', 1076.0000, 'ºC'),
	(221324, 119, '2014-03-01 00:41:19.000000', 'temperatura', 1091.0000, 'ºC'),
	(221325, 119, '2014-03-01 00:41:20.000000', 'temperatura', 1028.0000, 'ºC'),
	(221326, 119, '2014-03-01 00:41:21.000000', 'temperatura', 670.0000, 'ºC'),
	(221327, 119, '2014-03-01 00:41:22.000000', 'temperatura', 264.0000, 'ºC'),
	(221328, 119, '2014-03-01 00:41:23.000000', 'temperatura', 509.0000, 'ºC'),
	(221329, 119, '2014-03-01 00:41:24.000000', 'temperatura', 556.0000, 'ºC'),
	(221330, 119, '2014-03-01 00:41:25.000000', 'temperatura', 53.0000, 'ºC'),
	(221331, 119, '2014-03-01 00:41:26.000000', 'temperatura', 995.0000, 'ºC'),
	(221332, 119, '2014-03-01 00:41:27.000000', 'temperatura', 19.0000, 'ºC'),
	(221333, 119, '2014-03-01 00:41:28.000000', 'temperatura', 711.0000, 'ºC'),
	(221334, 119, '2014-03-01 00:41:29.000000', 'temperatura', 1099.0000, 'ºC'),
	(221335, 119, '2014-03-01 00:41:30.000000', 'temperatura', 962.0000, 'ºC'),
	(221336, 119, '2014-03-01 00:41:31.000000', 'temperatura', 312.0000, 'ºC'),
	(221337, 119, '2014-03-01 00:41:32.000000', 'temperatura', 1074.0000, 'ºC'),
	(221338, 119, '2014-03-01 00:41:33.000000', 'temperatura', 835.0000, 'ºC'),
	(221339, 119, '2014-03-01 00:41:34.000000', 'temperatura', 952.0000, 'ºC'),
	(221340, 119, '2014-03-01 00:41:35.000000', 'temperatura', 1057.0000, 'ºC'),
	(221341, 119, '2014-03-01 00:41:36.000000', 'temperatura', 28.0000, 'ºC'),
	(221342, 119, '2014-03-01 00:41:37.000000', 'temperatura', 569.0000, 'ºC'),
	(221343, 119, '2014-03-01 00:41:38.000000', 'temperatura', 361.0000, 'ºC'),
	(221344, 119, '2014-03-01 00:41:39.000000', 'temperatura', 100.0000, 'ºC'),
	(221345, 119, '2014-03-01 00:41:40.000000', 'temperatura', 617.0000, 'ºC'),
	(221346, 119, '2014-03-01 00:41:41.000000', 'temperatura', 384.0000, 'ºC'),
	(221347, 119, '2014-03-01 00:41:42.000000', 'temperatura', 71.0000, 'ºC'),
	(221348, 119, '2014-03-01 00:41:43.000000', 'temperatura', 402.0000, 'ºC'),
	(221349, 119, '2014-03-01 00:41:44.000000', 'temperatura', 598.0000, 'ºC'),
	(221350, 119, '2014-03-01 00:41:45.000000', 'temperatura', 587.0000, 'ºC'),
	(221351, 119, '2014-03-01 00:41:46.000000', 'temperatura', 1138.0000, 'ºC'),
	(221352, 119, '2014-03-01 00:41:47.000000', 'temperatura', 333.0000, 'ºC'),
	(221353, 119, '2014-03-01 00:41:48.000000', 'temperatura', 650.0000, 'ºC'),
	(221354, 119, '2014-03-01 00:41:49.000000', 'temperatura', 1051.0000, 'ºC'),
	(221355, 119, '2014-03-01 00:41:50.000000', 'temperatura', 905.0000, 'ºC'),
	(221356, 119, '2014-03-01 00:41:51.000000', 'temperatura', 173.0000, 'ºC'),
	(221357, 119, '2014-03-01 00:41:52.000000', 'temperatura', 549.0000, 'ºC'),
	(221358, 119, '2014-03-01 00:41:53.000000', 'temperatura', 1028.0000, 'ºC'),
	(221359, 119, '2014-03-01 00:41:54.000000', 'temperatura', 1093.0000, 'ºC'),
	(221360, 119, '2014-03-01 00:41:55.000000', 'temperatura', 1180.0000, 'ºC'),
	(221361, 119, '2014-03-01 00:41:56.000000', 'temperatura', 223.0000, 'ºC'),
	(221362, 119, '2014-03-01 00:41:57.000000', 'temperatura', 1174.0000, 'ºC'),
	(221363, 119, '2014-03-01 00:41:58.000000', 'temperatura', 403.0000, 'ºC'),
	(221364, 119, '2014-03-01 00:41:59.000000', 'temperatura', 893.0000, 'ºC'),
	(221365, 119, '2014-03-01 00:42:00.000000', 'temperatura', 856.0000, 'ºC'),
	(221366, 119, '2014-03-01 00:42:01.000000', 'temperatura', 400.0000, 'ºC'),
	(221367, 119, '2014-03-01 00:42:02.000000', 'temperatura', 634.0000, 'ºC'),
	(221368, 119, '2014-03-01 00:42:03.000000', 'temperatura', 770.0000, 'ºC'),
	(221369, 119, '2014-03-01 00:42:04.000000', 'temperatura', 750.0000, 'ºC'),
	(221370, 119, '2014-03-01 00:42:05.000000', 'temperatura', 240.0000, 'ºC'),
	(221371, 119, '2014-03-01 00:42:06.000000', 'temperatura', 150.0000, 'ºC'),
	(221372, 119, '2014-03-01 00:42:07.000000', 'temperatura', 32.0000, 'ºC'),
	(221373, 119, '2014-03-01 00:42:08.000000', 'temperatura', 911.0000, 'ºC'),
	(221374, 119, '2014-03-01 00:42:09.000000', 'temperatura', 860.0000, 'ºC'),
	(221375, 119, '2014-03-01 00:42:10.000000', 'temperatura', 366.0000, 'ºC'),
	(221376, 119, '2014-03-01 00:42:11.000000', 'temperatura', 451.0000, 'ºC'),
	(221377, 119, '2014-03-01 00:42:12.000000', 'temperatura', 1158.0000, 'ºC'),
	(221378, 119, '2014-03-01 00:42:13.000000', 'temperatura', 839.0000, 'ºC'),
	(221379, 119, '2014-03-01 00:42:14.000000', 'temperatura', 720.0000, 'ºC'),
	(221380, 119, '2014-03-01 00:42:15.000000', 'temperatura', 1085.0000, 'ºC'),
	(221381, 119, '2014-03-01 00:42:16.000000', 'temperatura', 864.0000, 'ºC'),
	(221382, 119, '2014-03-01 00:42:17.000000', 'temperatura', 1065.0000, 'ºC'),
	(221383, 119, '2014-03-01 00:42:18.000000', 'temperatura', 334.0000, 'ºC'),
	(221384, 119, '2014-03-01 00:42:19.000000', 'temperatura', 874.0000, 'ºC'),
	(221385, 119, '2014-03-01 00:42:20.000000', 'temperatura', 969.0000, 'ºC'),
	(221386, 119, '2014-03-01 00:42:21.000000', 'temperatura', 1024.0000, 'ºC'),
	(221387, 119, '2014-03-01 00:42:22.000000', 'temperatura', 1012.0000, 'ºC'),
	(221388, 119, '2014-03-01 00:42:23.000000', 'temperatura', 788.0000, 'ºC'),
	(221389, 119, '2014-03-01 00:42:24.000000', 'temperatura', 907.0000, 'ºC'),
	(221390, 119, '2014-03-01 00:42:25.000000', 'temperatura', 971.0000, 'ºC'),
	(221391, 119, '2014-03-01 00:42:26.000000', 'temperatura', 936.0000, 'ºC'),
	(221392, 119, '2014-03-01 00:42:27.000000', 'temperatura', 565.0000, 'ºC'),
	(221393, 119, '2014-03-01 00:42:28.000000', 'temperatura', 17.0000, 'ºC'),
	(221394, 119, '2014-03-01 00:42:29.000000', 'temperatura', 792.0000, 'ºC'),
	(221395, 119, '2014-03-01 00:42:30.000000', 'temperatura', 310.0000, 'ºC'),
	(221396, 119, '2014-03-01 00:42:31.000000', 'temperatura', 373.0000, 'ºC'),
	(221397, 119, '2014-03-01 00:42:32.000000', 'temperatura', 936.0000, 'ºC'),
	(221398, 119, '2014-03-01 00:42:33.000000', 'temperatura', 1160.0000, 'ºC'),
	(221399, 119, '2014-03-01 00:42:34.000000', 'temperatura', 592.0000, 'ºC'),
	(221400, 119, '2014-03-01 00:42:35.000000', 'temperatura', 680.0000, 'ºC'),
	(221401, 119, '2014-03-01 00:42:36.000000', 'temperatura', 426.0000, 'ºC'),
	(221402, 119, '2014-03-01 00:42:37.000000', 'temperatura', 92.0000, 'ºC'),
	(221403, 119, '2014-03-01 00:42:38.000000', 'temperatura', 383.0000, 'ºC'),
	(221404, 119, '2014-03-01 00:42:39.000000', 'temperatura', 437.0000, 'ºC'),
	(221405, 119, '2014-03-01 00:42:40.000000', 'temperatura', 1039.0000, 'ºC'),
	(221406, 119, '2014-03-01 00:42:41.000000', 'temperatura', 285.0000, 'ºC'),
	(221407, 119, '2014-03-01 00:42:42.000000', 'temperatura', 706.0000, 'ºC'),
	(221408, 119, '2014-03-01 00:42:43.000000', 'temperatura', 276.0000, 'ºC'),
	(221409, 119, '2014-03-01 00:42:44.000000', 'temperatura', 464.0000, 'ºC'),
	(221410, 119, '2014-03-01 00:42:45.000000', 'temperatura', 292.0000, 'ºC'),
	(221411, 119, '2014-03-01 00:42:46.000000', 'temperatura', 70.0000, 'ºC'),
	(221412, 119, '2014-03-01 00:42:47.000000', 'temperatura', 672.0000, 'ºC'),
	(221413, 119, '2014-03-01 00:42:48.000000', 'temperatura', 754.0000, 'ºC'),
	(221414, 119, '2014-03-01 00:42:49.000000', 'temperatura', 551.0000, 'ºC'),
	(221415, 119, '2014-03-01 00:42:50.000000', 'temperatura', 493.0000, 'ºC'),
	(221416, 119, '2014-03-01 00:42:51.000000', 'temperatura', 813.0000, 'ºC'),
	(221417, 119, '2014-03-01 00:42:52.000000', 'temperatura', 188.0000, 'ºC'),
	(221418, 119, '2014-03-01 00:42:53.000000', 'temperatura', 899.0000, 'ºC'),
	(221419, 119, '2014-03-01 00:42:54.000000', 'temperatura', 333.0000, 'ºC'),
	(221420, 119, '2014-03-01 00:42:55.000000', 'temperatura', 170.0000, 'ºC'),
	(221421, 119, '2014-03-01 00:42:56.000000', 'temperatura', 1050.0000, 'ºC'),
	(221422, 119, '2014-03-01 00:42:57.000000', 'temperatura', 1139.0000, 'ºC'),
	(221423, 119, '2014-03-01 00:42:58.000000', 'temperatura', 147.0000, 'ºC'),
	(221424, 119, '2014-03-01 00:42:59.000000', 'temperatura', 917.0000, 'ºC'),
	(221425, 119, '2014-03-01 00:43:00.000000', 'temperatura', 547.0000, 'ºC'),
	(221426, 119, '2014-03-01 00:43:01.000000', 'temperatura', 1182.0000, 'ºC'),
	(221427, 119, '2014-03-01 00:43:02.000000', 'temperatura', 672.0000, 'ºC'),
	(221428, 119, '2014-03-01 00:43:03.000000', 'temperatura', 1015.0000, 'ºC'),
	(221429, 119, '2014-03-01 00:43:04.000000', 'temperatura', 656.0000, 'ºC'),
	(221430, 119, '2014-03-01 00:43:05.000000', 'temperatura', 239.0000, 'ºC'),
	(221431, 119, '2014-03-01 00:43:06.000000', 'temperatura', 425.0000, 'ºC'),
	(221432, 119, '2014-03-01 00:43:07.000000', 'temperatura', 210.0000, 'ºC'),
	(221433, 119, '2014-03-01 00:43:08.000000', 'temperatura', 976.0000, 'ºC'),
	(221434, 119, '2014-03-01 00:43:09.000000', 'temperatura', 649.0000, 'ºC'),
	(221435, 119, '2014-03-01 00:43:10.000000', 'temperatura', 316.0000, 'ºC'),
	(221436, 119, '2014-03-01 00:43:11.000000', 'temperatura', 836.0000, 'ºC'),
	(221437, 119, '2014-03-01 00:43:12.000000', 'temperatura', 831.0000, 'ºC'),
	(221438, 119, '2014-03-01 00:43:13.000000', 'temperatura', 448.0000, 'ºC'),
	(221439, 119, '2014-03-01 00:43:14.000000', 'temperatura', 949.0000, 'ºC'),
	(221440, 119, '2014-03-01 00:43:15.000000', 'temperatura', 999.0000, 'ºC'),
	(221441, 119, '2014-03-01 00:43:16.000000', 'temperatura', 952.0000, 'ºC'),
	(221442, 119, '2014-03-01 00:43:17.000000', 'temperatura', 560.0000, 'ºC'),
	(221443, 119, '2014-03-01 00:43:18.000000', 'temperatura', 1147.0000, 'ºC'),
	(221444, 119, '2014-03-01 00:43:19.000000', 'temperatura', 455.0000, 'ºC'),
	(221445, 119, '2014-03-01 00:43:20.000000', 'temperatura', 32.0000, 'ºC'),
	(221446, 119, '2014-03-01 00:43:21.000000', 'temperatura', 1199.0000, 'ºC'),
	(221447, 119, '2014-03-01 00:43:22.000000', 'temperatura', 1097.0000, 'ºC'),
	(221448, 119, '2014-03-01 00:43:23.000000', 'temperatura', 689.0000, 'ºC'),
	(221449, 119, '2014-03-01 00:43:24.000000', 'temperatura', 157.0000, 'ºC'),
	(221450, 119, '2014-03-01 00:43:25.000000', 'temperatura', 1116.0000, 'ºC'),
	(221451, 119, '2014-03-01 00:43:26.000000', 'temperatura', 311.0000, 'ºC'),
	(221452, 119, '2014-03-01 00:43:27.000000', 'temperatura', 605.0000, 'ºC'),
	(221453, 119, '2014-03-01 00:43:28.000000', 'temperatura', 894.0000, 'ºC'),
	(221454, 119, '2014-03-01 00:43:29.000000', 'temperatura', 257.0000, 'ºC'),
	(221455, 119, '2014-03-01 00:43:30.000000', 'temperatura', 1003.0000, 'ºC'),
	(221456, 119, '2014-03-01 00:43:31.000000', 'temperatura', 646.0000, 'ºC'),
	(221457, 119, '2014-03-01 00:43:32.000000', 'temperatura', 219.0000, 'ºC'),
	(221458, 119, '2014-03-01 00:43:33.000000', 'temperatura', 357.0000, 'ºC'),
	(221459, 119, '2014-03-01 00:43:34.000000', 'temperatura', 1130.0000, 'ºC'),
	(221460, 119, '2014-03-01 00:43:35.000000', 'temperatura', 978.0000, 'ºC'),
	(221461, 119, '2014-03-01 00:43:36.000000', 'temperatura', 303.0000, 'ºC'),
	(221462, 119, '2014-03-01 00:43:37.000000', 'temperatura', 979.0000, 'ºC'),
	(221463, 119, '2014-03-01 00:43:38.000000', 'temperatura', 387.0000, 'ºC'),
	(221464, 119, '2014-03-01 00:43:39.000000', 'temperatura', 199.0000, 'ºC'),
	(221465, 119, '2014-03-01 00:43:40.000000', 'temperatura', 1033.0000, 'ºC'),
	(221466, 119, '2014-03-01 00:43:41.000000', 'temperatura', 967.0000, 'ºC'),
	(221467, 119, '2014-03-01 00:43:42.000000', 'temperatura', 540.0000, 'ºC'),
	(221468, 119, '2014-03-01 00:43:43.000000', 'temperatura', 998.0000, 'ºC'),
	(221469, 119, '2014-03-01 00:43:44.000000', 'temperatura', 972.0000, 'ºC'),
	(221470, 119, '2014-03-01 00:43:45.000000', 'temperatura', 665.0000, 'ºC'),
	(221471, 119, '2014-03-01 00:43:46.000000', 'temperatura', 412.0000, 'ºC'),
	(221472, 119, '2014-03-01 00:43:47.000000', 'temperatura', 64.0000, 'ºC'),
	(221473, 119, '2014-03-01 00:43:48.000000', 'temperatura', 283.0000, 'ºC'),
	(221474, 119, '2014-03-01 00:43:49.000000', 'temperatura', 24.0000, 'ºC'),
	(221475, 119, '2014-03-01 00:43:50.000000', 'temperatura', 474.0000, 'ºC'),
	(221476, 119, '2014-03-01 00:43:51.000000', 'temperatura', 1097.0000, 'ºC'),
	(221477, 119, '2014-03-01 00:43:52.000000', 'temperatura', 464.0000, 'ºC'),
	(221478, 119, '2014-03-01 00:43:53.000000', 'temperatura', 228.0000, 'ºC'),
	(221479, 119, '2014-03-01 00:43:54.000000', 'temperatura', 950.0000, 'ºC'),
	(221480, 119, '2014-03-01 00:43:55.000000', 'temperatura', 465.0000, 'ºC'),
	(221481, 119, '2014-03-01 00:43:56.000000', 'temperatura', 677.0000, 'ºC'),
	(221482, 119, '2014-03-01 00:43:57.000000', 'temperatura', 792.0000, 'ºC'),
	(221483, 119, '2014-03-01 00:43:58.000000', 'temperatura', 728.0000, 'ºC'),
	(221484, 119, '2014-03-01 00:43:59.000000', 'temperatura', 66.0000, 'ºC'),
	(221485, 119, '2014-03-01 00:44:00.000000', 'temperatura', 544.0000, 'ºC'),
	(221486, 119, '2014-03-01 00:44:01.000000', 'temperatura', 123.0000, 'ºC'),
	(221487, 119, '2014-03-01 00:44:02.000000', 'temperatura', 183.0000, 'ºC'),
	(221488, 119, '2014-03-01 00:44:03.000000', 'temperatura', 549.0000, 'ºC'),
	(221489, 119, '2014-03-01 00:44:04.000000', 'temperatura', 994.0000, 'ºC'),
	(221490, 119, '2014-03-01 00:44:05.000000', 'temperatura', 922.0000, 'ºC'),
	(221491, 119, '2014-03-01 00:44:06.000000', 'temperatura', 432.0000, 'ºC'),
	(221492, 119, '2014-03-01 00:44:07.000000', 'temperatura', 594.0000, 'ºC'),
	(221493, 119, '2014-03-01 00:44:08.000000', 'temperatura', 473.0000, 'ºC'),
	(221494, 119, '2014-03-01 00:44:09.000000', 'temperatura', 583.0000, 'ºC'),
	(221495, 119, '2014-03-01 00:44:10.000000', 'temperatura', 297.0000, 'ºC'),
	(221496, 119, '2014-03-01 00:44:11.000000', 'temperatura', 938.0000, 'ºC'),
	(221497, 119, '2014-03-01 00:44:12.000000', 'temperatura', 199.0000, 'ºC'),
	(221498, 119, '2014-03-01 00:44:13.000000', 'temperatura', 580.0000, 'ºC'),
	(221499, 119, '2014-03-01 00:44:14.000000', 'temperatura', 1103.0000, 'ºC'),
	(221500, 119, '2014-03-01 00:44:15.000000', 'temperatura', 175.0000, 'ºC'),
	(221501, 119, '2014-03-01 00:44:16.000000', 'temperatura', 1167.0000, 'ºC'),
	(221502, 119, '2014-03-01 00:44:17.000000', 'temperatura', 512.0000, 'ºC'),
	(221503, 119, '2014-03-01 00:44:18.000000', 'temperatura', 259.0000, 'ºC'),
	(221504, 119, '2014-03-01 00:44:19.000000', 'temperatura', 958.0000, 'ºC'),
	(221505, 119, '2014-03-01 00:44:20.000000', 'temperatura', 413.0000, 'ºC'),
	(221506, 119, '2014-03-01 00:44:21.000000', 'temperatura', 391.0000, 'ºC'),
	(221507, 119, '2014-03-01 00:44:22.000000', 'temperatura', 716.0000, 'ºC'),
	(221508, 119, '2014-03-01 00:44:23.000000', 'temperatura', 9.0000, 'ºC'),
	(221509, 119, '2014-03-01 00:44:24.000000', 'temperatura', 295.0000, 'ºC'),
	(221510, 119, '2014-03-01 00:44:25.000000', 'temperatura', 252.0000, 'ºC'),
	(221511, 119, '2014-03-01 00:44:26.000000', 'temperatura', 375.0000, 'ºC'),
	(221512, 119, '2014-03-01 00:44:27.000000', 'temperatura', 1117.0000, 'ºC'),
	(221513, 119, '2014-03-01 00:44:28.000000', 'temperatura', 862.0000, 'ºC'),
	(221514, 119, '2014-03-01 00:44:29.000000', 'temperatura', 958.0000, 'ºC'),
	(221515, 119, '2014-03-01 00:44:30.000000', 'temperatura', 1007.0000, 'ºC'),
	(221516, 119, '2014-03-01 00:44:31.000000', 'temperatura', 961.0000, 'ºC'),
	(221517, 119, '2014-03-01 00:44:32.000000', 'temperatura', 583.0000, 'ºC'),
	(221518, 119, '2014-03-01 00:44:33.000000', 'temperatura', 32.0000, 'ºC'),
	(221519, 119, '2014-03-01 00:44:34.000000', 'temperatura', 812.0000, 'ºC'),
	(221520, 119, '2014-03-01 00:44:35.000000', 'temperatura', 363.0000, 'ºC'),
	(221521, 119, '2014-03-01 00:44:36.000000', 'temperatura', 580.0000, 'ºC'),
	(221522, 119, '2014-03-01 00:44:37.000000', 'temperatura', 614.0000, 'ºC'),
	(221523, 119, '2014-03-01 00:44:38.000000', 'temperatura', 130.0000, 'ºC'),
	(221524, 119, '2014-03-01 00:44:39.000000', 'temperatura', 6.0000, 'ºC'),
	(221525, 119, '2014-03-01 00:44:40.000000', 'temperatura', 841.0000, 'ºC'),
	(221526, 119, '2014-03-01 00:44:41.000000', 'temperatura', 590.0000, 'ºC'),
	(221527, 119, '2014-03-01 00:44:42.000000', 'temperatura', 427.0000, 'ºC'),
	(221528, 119, '2014-03-01 00:44:43.000000', 'temperatura', 365.0000, 'ºC'),
	(221529, 119, '2014-03-01 00:44:44.000000', 'temperatura', 545.0000, 'ºC'),
	(221530, 119, '2014-03-01 00:44:45.000000', 'temperatura', 431.0000, 'ºC'),
	(221531, 119, '2014-03-01 00:44:46.000000', 'temperatura', 522.0000, 'ºC'),
	(221532, 119, '2014-03-01 00:44:47.000000', 'temperatura', 116.0000, 'ºC'),
	(221533, 119, '2014-03-01 00:44:48.000000', 'temperatura', 212.0000, 'ºC'),
	(221534, 119, '2014-03-01 00:44:49.000000', 'temperatura', 716.0000, 'ºC'),
	(221535, 119, '2014-03-01 00:44:50.000000', 'temperatura', 545.0000, 'ºC'),
	(221536, 119, '2014-03-01 00:44:51.000000', 'temperatura', 576.0000, 'ºC'),
	(221537, 119, '2014-03-01 00:44:52.000000', 'temperatura', 46.0000, 'ºC'),
	(221538, 119, '2014-03-01 00:44:53.000000', 'temperatura', 902.0000, 'ºC'),
	(221539, 119, '2014-03-01 00:44:54.000000', 'temperatura', 771.0000, 'ºC'),
	(221540, 119, '2014-03-01 00:44:55.000000', 'temperatura', 1151.0000, 'ºC'),
	(221541, 119, '2014-03-01 00:44:56.000000', 'temperatura', 1043.0000, 'ºC'),
	(221542, 119, '2014-03-01 00:44:57.000000', 'temperatura', 560.0000, 'ºC'),
	(221543, 119, '2014-03-01 00:44:58.000000', 'temperatura', 872.0000, 'ºC'),
	(221544, 119, '2014-03-01 00:44:59.000000', 'temperatura', 282.0000, 'ºC'),
	(221545, 119, '2014-03-01 00:45:00.000000', 'temperatura', 1196.0000, 'ºC'),
	(221546, 119, '2014-03-01 00:45:01.000000', 'temperatura', 332.0000, 'ºC'),
	(221547, 119, '2014-03-01 00:45:02.000000', 'temperatura', 474.0000, 'ºC'),
	(221548, 119, '2014-03-01 00:45:03.000000', 'temperatura', 176.0000, 'ºC'),
	(221549, 119, '2014-03-01 00:45:04.000000', 'temperatura', 657.0000, 'ºC'),
	(221550, 119, '2014-03-01 00:45:05.000000', 'temperatura', 356.0000, 'ºC'),
	(221551, 119, '2014-03-01 00:45:06.000000', 'temperatura', 1009.0000, 'ºC'),
	(221552, 119, '2014-03-01 00:45:07.000000', 'temperatura', 378.0000, 'ºC'),
	(221553, 119, '2014-03-01 00:45:08.000000', 'temperatura', 62.0000, 'ºC'),
	(221554, 119, '2014-03-01 00:45:09.000000', 'temperatura', 378.0000, 'ºC'),
	(221555, 119, '2014-03-01 00:45:10.000000', 'temperatura', 504.0000, 'ºC'),
	(221556, 119, '2014-03-01 00:45:11.000000', 'temperatura', 185.0000, 'ºC'),
	(221557, 119, '2014-03-01 00:45:12.000000', 'temperatura', 613.0000, 'ºC'),
	(221558, 119, '2014-03-01 00:45:13.000000', 'temperatura', 113.0000, 'ºC'),
	(221559, 119, '2014-03-01 00:45:14.000000', 'temperatura', 1127.0000, 'ºC'),
	(221560, 119, '2014-03-01 00:45:15.000000', 'temperatura', 497.0000, 'ºC'),
	(221561, 119, '2014-03-01 00:45:16.000000', 'temperatura', 303.0000, 'ºC'),
	(221562, 119, '2014-03-01 00:45:17.000000', 'temperatura', 24.0000, 'ºC'),
	(221563, 119, '2014-03-01 00:45:18.000000', 'temperatura', 410.0000, 'ºC'),
	(221564, 119, '2014-03-01 00:45:19.000000', 'temperatura', 780.0000, 'ºC'),
	(221565, 119, '2014-03-01 00:45:20.000000', 'temperatura', 271.0000, 'ºC'),
	(221566, 119, '2014-03-01 00:45:21.000000', 'temperatura', 213.0000, 'ºC'),
	(221567, 119, '2014-03-01 00:45:22.000000', 'temperatura', 255.0000, 'ºC'),
	(221568, 119, '2014-03-01 00:45:23.000000', 'temperatura', 635.0000, 'ºC'),
	(221569, 119, '2014-03-01 00:45:24.000000', 'temperatura', 12.0000, 'ºC'),
	(221570, 119, '2014-03-01 00:45:25.000000', 'temperatura', 553.0000, 'ºC'),
	(221571, 119, '2014-03-01 00:45:26.000000', 'temperatura', 332.0000, 'ºC'),
	(221572, 119, '2014-03-01 00:45:27.000000', 'temperatura', 2.0000, 'ºC'),
	(221573, 119, '2014-03-01 00:45:28.000000', 'temperatura', 214.0000, 'ºC'),
	(221574, 119, '2014-03-01 00:45:29.000000', 'temperatura', 1063.0000, 'ºC'),
	(221575, 119, '2014-03-01 00:45:30.000000', 'temperatura', 1073.0000, 'ºC'),
	(221576, 119, '2014-03-01 00:45:31.000000', 'temperatura', 978.0000, 'ºC'),
	(221577, 119, '2014-03-01 00:45:32.000000', 'temperatura', 471.0000, 'ºC'),
	(221578, 119, '2014-03-01 00:45:33.000000', 'temperatura', 621.0000, 'ºC'),
	(221579, 119, '2014-03-01 00:45:34.000000', 'temperatura', 492.0000, 'ºC'),
	(221580, 119, '2014-03-01 00:45:35.000000', 'temperatura', 597.0000, 'ºC'),
	(221581, 119, '2014-03-01 00:45:36.000000', 'temperatura', 311.0000, 'ºC'),
	(221582, 119, '2014-03-01 00:45:37.000000', 'temperatura', 966.0000, 'ºC'),
	(221583, 119, '2014-03-01 00:45:38.000000', 'temperatura', 296.0000, 'ºC'),
	(221584, 119, '2014-03-01 00:45:39.000000', 'temperatura', 983.0000, 'ºC'),
	(221585, 119, '2014-03-01 00:45:40.000000', 'temperatura', 429.0000, 'ºC'),
	(221586, 119, '2014-03-01 00:45:41.000000', 'temperatura', 394.0000, 'ºC'),
	(221587, 119, '2014-03-01 00:45:42.000000', 'temperatura', 682.0000, 'ºC'),
	(221588, 119, '2014-03-01 00:45:43.000000', 'temperatura', 1032.0000, 'ºC'),
	(221589, 119, '2014-03-01 00:45:44.000000', 'temperatura', 712.0000, 'ºC'),
	(221590, 119, '2014-03-01 00:45:45.000000', 'temperatura', 466.0000, 'ºC'),
	(221591, 119, '2014-03-01 00:45:46.000000', 'temperatura', 194.0000, 'ºC'),
	(221592, 119, '2014-03-01 00:45:47.000000', 'temperatura', 771.0000, 'ºC'),
	(221593, 119, '2014-03-01 00:45:48.000000', 'temperatura', 875.0000, 'ºC'),
	(221594, 119, '2014-03-01 00:45:49.000000', 'temperatura', 861.0000, 'ºC'),
	(221595, 119, '2014-03-01 00:45:50.000000', 'temperatura', 481.0000, 'ºC'),
	(221596, 119, '2014-03-01 00:45:51.000000', 'temperatura', 1023.0000, 'ºC'),
	(221597, 119, '2014-03-01 00:45:52.000000', 'temperatura', 72.0000, 'ºC'),
	(221598, 119, '2014-03-01 00:45:53.000000', 'temperatura', 890.0000, 'ºC'),
	(221599, 119, '2014-03-01 00:45:54.000000', 'temperatura', 636.0000, 'ºC'),
	(221600, 119, '2014-03-01 00:45:55.000000', 'temperatura', 511.0000, 'ºC'),
	(221601, 119, '2014-03-01 00:45:56.000000', 'temperatura', 649.0000, 'ºC'),
	(221602, 119, '2014-03-01 00:45:57.000000', 'temperatura', 511.0000, 'ºC'),
	(221603, 119, '2014-03-01 00:45:58.000000', 'temperatura', 610.0000, 'ºC'),
	(221604, 119, '2014-03-01 00:45:59.000000', 'temperatura', 317.0000, 'ºC'),
	(221605, 119, '2014-03-01 00:46:00.000000', 'temperatura', 956.0000, 'ºC'),
	(221606, 119, '2014-03-01 00:46:01.000000', 'temperatura', 230.0000, 'ºC'),
	(221607, 119, '2014-03-01 00:46:02.000000', 'temperatura', 683.0000, 'ºC'),
	(221608, 119, '2014-03-01 00:46:03.000000', 'temperatura', 325.0000, 'ºC'),
	(221609, 119, '2014-03-01 00:46:04.000000', 'temperatura', 776.0000, 'ºC'),
	(221610, 119, '2014-03-01 00:46:05.000000', 'temperatura', 504.0000, 'ºC'),
	(221611, 119, '2014-03-01 00:46:06.000000', 'temperatura', 196.0000, 'ºC'),
	(221612, 119, '2014-03-01 00:46:07.000000', 'temperatura', 665.0000, 'ºC'),
	(221613, 119, '2014-03-01 00:46:08.000000', 'temperatura', 340.0000, 'ºC'),
	(221614, 119, '2014-03-01 00:46:09.000000', 'temperatura', 903.0000, 'ºC'),
	(221615, 119, '2014-03-01 00:46:10.000000', 'temperatura', 1099.0000, 'ºC'),
	(221616, 119, '2014-03-01 00:46:11.000000', 'temperatura', 384.0000, 'ºC'),
	(221617, 119, '2014-03-01 00:46:12.000000', 'temperatura', 1023.0000, 'ºC'),
	(221618, 119, '2014-03-01 00:46:13.000000', 'temperatura', 363.0000, 'ºC'),
	(221619, 119, '2014-03-01 00:46:14.000000', 'temperatura', 1148.0000, 'ºC'),
	(221620, 119, '2014-03-01 00:46:15.000000', 'temperatura', 1053.0000, 'ºC'),
	(221621, 119, '2014-03-01 00:46:16.000000', 'temperatura', 618.0000, 'ºC'),
	(221622, 119, '2014-03-01 00:46:17.000000', 'temperatura', 1134.0000, 'ºC'),
	(221623, 119, '2014-03-01 00:46:18.000000', 'temperatura', 215.0000, 'ºC'),
	(221624, 119, '2014-03-01 00:46:19.000000', 'temperatura', 75.0000, 'ºC'),
	(221625, 119, '2014-03-01 00:46:20.000000', 'temperatura', 928.0000, 'ºC'),
	(221626, 119, '2014-03-01 00:46:21.000000', 'temperatura', 818.0000, 'ºC'),
	(221627, 119, '2014-03-01 00:46:22.000000', 'temperatura', 107.0000, 'ºC'),
	(221628, 119, '2014-03-01 00:46:23.000000', 'temperatura', 481.0000, 'ºC'),
	(221629, 119, '2014-03-01 00:46:24.000000', 'temperatura', 885.0000, 'ºC'),
	(221630, 119, '2014-03-01 00:46:25.000000', 'temperatura', 580.0000, 'ºC'),
	(221631, 119, '2014-03-01 00:46:26.000000', 'temperatura', 248.0000, 'ºC'),
	(221632, 119, '2014-03-01 00:46:27.000000', 'temperatura', 701.0000, 'ºC'),
	(221633, 119, '2014-03-01 00:46:28.000000', 'temperatura', 360.0000, 'ºC'),
	(221634, 119, '2014-03-01 00:46:29.000000', 'temperatura', 897.0000, 'ºC'),
	(221635, 119, '2014-03-01 00:46:30.000000', 'temperatura', 1008.0000, 'ºC'),
	(221636, 119, '2014-03-01 00:46:31.000000', 'temperatura', 1147.0000, 'ºC'),
	(221637, 119, '2014-03-01 00:46:32.000000', 'temperatura', 313.0000, 'ºC'),
	(221638, 119, '2014-03-01 00:46:33.000000', 'temperatura', 526.0000, 'ºC'),
	(221639, 119, '2014-03-01 00:46:34.000000', 'temperatura', 489.0000, 'ºC'),
	(221640, 119, '2014-03-01 00:46:35.000000', 'temperatura', 867.0000, 'ºC'),
	(221641, 119, '2014-03-01 00:46:36.000000', 'temperatura', 471.0000, 'ºC'),
	(221642, 119, '2014-03-01 00:46:37.000000', 'temperatura', 955.0000, 'ºC'),
	(221643, 119, '2014-03-01 00:46:38.000000', 'temperatura', 963.0000, 'ºC'),
	(221644, 119, '2014-03-01 00:46:39.000000', 'temperatura', 749.0000, 'ºC'),
	(221645, 119, '2014-03-01 00:46:40.000000', 'temperatura', 856.0000, 'ºC'),
	(221646, 119, '2014-03-01 00:46:41.000000', 'temperatura', 835.0000, 'ºC'),
	(221647, 119, '2014-03-01 00:46:42.000000', 'temperatura', 409.0000, 'ºC'),
	(221648, 119, '2014-03-01 00:46:43.000000', 'temperatura', 739.0000, 'ºC'),
	(221649, 119, '2014-03-01 00:46:44.000000', 'temperatura', 68.0000, 'ºC'),
	(221650, 119, '2014-03-01 00:46:45.000000', 'temperatura', 522.0000, 'ºC'),
	(221651, 119, '2014-03-01 00:46:46.000000', 'temperatura', 8.0000, 'ºC'),
	(221652, 119, '2014-03-01 00:46:47.000000', 'temperatura', 873.0000, 'ºC'),
	(221653, 119, '2014-03-01 00:46:48.000000', 'temperatura', 744.0000, 'ºC'),
	(221654, 119, '2014-03-01 00:46:49.000000', 'temperatura', 1099.0000, 'ºC'),
	(221655, 119, '2014-03-01 00:46:50.000000', 'temperatura', 863.0000, 'ºC'),
	(221656, 119, '2014-03-01 00:46:51.000000', 'temperatura', 1019.0000, 'ºC'),
	(221657, 119, '2014-03-01 00:46:52.000000', 'temperatura', 108.0000, 'ºC'),
	(221658, 119, '2014-03-01 00:46:53.000000', 'temperatura', 1083.0000, 'ºC'),
	(221659, 119, '2014-03-01 00:46:54.000000', 'temperatura', 289.0000, 'ºC'),
	(221660, 119, '2014-03-01 00:46:55.000000', 'temperatura', 600.0000, 'ºC'),
	(221661, 119, '2014-03-01 00:46:56.000000', 'temperatura', 930.0000, 'ºC'),
	(221662, 119, '2014-03-01 00:46:57.000000', 'temperatura', 454.0000, 'ºC'),
	(221663, 119, '2014-03-01 00:46:58.000000', 'temperatura', 679.0000, 'ºC'),
	(221664, 119, '2014-03-01 00:46:59.000000', 'temperatura', 833.0000, 'ºC'),
	(221665, 119, '2014-03-01 00:47:00.000000', 'temperatura', 930.0000, 'ºC'),
	(221666, 119, '2014-03-01 00:47:01.000000', 'temperatura', 951.0000, 'ºC'),
	(221667, 119, '2014-03-01 00:47:02.000000', 'temperatura', 765.0000, 'ºC'),
	(221668, 119, '2014-03-01 00:47:03.000000', 'temperatura', 971.0000, 'ºC'),
	(221669, 119, '2014-03-01 00:47:04.000000', 'temperatura', 160.0000, 'ºC'),
	(221670, 119, '2014-03-01 00:47:05.000000', 'temperatura', 289.0000, 'ºC'),
	(221671, 119, '2014-03-01 00:47:06.000000', 'temperatura', 964.0000, 'ºC'),
	(221672, 119, '2014-03-01 00:47:07.000000', 'temperatura', 353.0000, 'ºC'),
	(221673, 119, '2014-03-01 00:47:08.000000', 'temperatura', 76.0000, 'ºC'),
	(221674, 119, '2014-03-01 00:47:09.000000', 'temperatura', 519.0000, 'ºC'),
	(221675, 119, '2014-03-01 00:47:10.000000', 'temperatura', 1169.0000, 'ºC'),
	(221676, 119, '2014-03-01 00:47:11.000000', 'temperatura', 690.0000, 'ºC'),
	(221677, 119, '2014-03-01 00:47:12.000000', 'temperatura', 1141.0000, 'ºC'),
	(221678, 119, '2014-03-01 00:47:13.000000', 'temperatura', 35.0000, 'ºC'),
	(221679, 119, '2014-03-01 00:47:14.000000', 'temperatura', 352.0000, 'ºC'),
	(221680, 119, '2014-03-01 00:47:15.000000', 'temperatura', 455.0000, 'ºC'),
	(221681, 119, '2014-03-01 00:47:16.000000', 'temperatura', 19.0000, 'ºC'),
	(221682, 119, '2014-03-01 00:47:17.000000', 'temperatura', 1129.0000, 'ºC'),
	(221683, 119, '2014-03-01 00:47:18.000000', 'temperatura', 792.0000, 'ºC'),
	(221684, 119, '2014-03-01 00:47:19.000000', 'temperatura', 573.0000, 'ºC'),
	(221685, 119, '2014-03-01 00:47:20.000000', 'temperatura', 489.0000, 'ºC'),
	(221686, 119, '2014-03-01 00:47:21.000000', 'temperatura', 728.0000, 'ºC'),
	(221687, 119, '2014-03-01 00:47:22.000000', 'temperatura', 974.0000, 'ºC'),
	(221688, 119, '2014-03-01 00:47:23.000000', 'temperatura', 286.0000, 'ºC'),
	(221689, 119, '2014-03-01 00:47:24.000000', 'temperatura', 908.0000, 'ºC'),
	(221690, 119, '2014-03-01 00:47:25.000000', 'temperatura', 82.0000, 'ºC'),
	(221691, 119, '2014-03-01 00:47:26.000000', 'temperatura', 88.0000, 'ºC'),
	(221692, 119, '2014-03-01 00:47:27.000000', 'temperatura', 196.0000, 'ºC'),
	(221693, 119, '2014-03-01 00:47:28.000000', 'temperatura', 714.0000, 'ºC'),
	(221694, 119, '2014-03-01 00:47:29.000000', 'temperatura', 583.0000, 'ºC'),
	(221695, 119, '2014-03-01 00:47:30.000000', 'temperatura', 773.0000, 'ºC'),
	(221696, 119, '2014-03-01 00:47:31.000000', 'temperatura', 918.0000, 'ºC'),
	(221697, 119, '2014-03-01 00:47:32.000000', 'temperatura', 1070.0000, 'ºC'),
	(221698, 119, '2014-03-01 00:47:33.000000', 'temperatura', 199.0000, 'ºC'),
	(221699, 119, '2014-03-01 00:47:34.000000', 'temperatura', 185.0000, 'ºC'),
	(221700, 119, '2014-03-01 00:47:35.000000', 'temperatura', 327.0000, 'ºC'),
	(221701, 119, '2014-03-01 00:47:36.000000', 'temperatura', 1081.0000, 'ºC'),
	(221702, 119, '2014-03-01 00:47:37.000000', 'temperatura', 824.0000, 'ºC'),
	(221703, 119, '2014-03-01 00:47:38.000000', 'temperatura', 879.0000, 'ºC'),
	(221704, 119, '2014-03-01 00:47:39.000000', 'temperatura', 722.0000, 'ºC'),
	(221705, 119, '2014-03-01 00:47:40.000000', 'temperatura', 976.0000, 'ºC'),
	(221706, 119, '2014-03-01 00:47:41.000000', 'temperatura', 313.0000, 'ºC'),
	(221707, 119, '2014-03-01 00:47:42.000000', 'temperatura', 1036.0000, 'ºC'),
	(221708, 119, '2014-03-01 00:47:43.000000', 'temperatura', 645.0000, 'ºC'),
	(221709, 119, '2014-03-01 00:47:44.000000', 'temperatura', 115.0000, 'ºC'),
	(221710, 119, '2014-03-01 00:47:45.000000', 'temperatura', 1039.0000, 'ºC'),
	(221711, 119, '2014-03-01 00:47:46.000000', 'temperatura', 53.0000, 'ºC'),
	(221712, 119, '2014-03-01 00:47:47.000000', 'temperatura', 747.0000, 'ºC'),
	(221713, 119, '2014-03-01 00:47:48.000000', 'temperatura', 1177.0000, 'ºC'),
	(221714, 119, '2014-03-01 00:47:49.000000', 'temperatura', 44.0000, 'ºC'),
	(221715, 119, '2014-03-01 00:47:50.000000', 'temperatura', 289.0000, 'ºC'),
	(221716, 119, '2014-03-01 00:47:51.000000', 'temperatura', 116.0000, 'ºC'),
	(221717, 119, '2014-03-01 00:47:52.000000', 'temperatura', 910.0000, 'ºC'),
	(221718, 119, '2014-03-01 00:47:53.000000', 'temperatura', 604.0000, 'ºC'),
	(221719, 119, '2014-03-01 00:47:54.000000', 'temperatura', 292.0000, 'ºC'),
	(221720, 119, '2014-03-01 00:47:55.000000', 'temperatura', 848.0000, 'ºC'),
	(221721, 119, '2014-03-01 00:47:56.000000', 'temperatura', 963.0000, 'ºC'),
	(221722, 119, '2014-03-01 00:47:57.000000', 'temperatura', 1071.0000, 'ºC'),
	(221723, 119, '2014-03-01 00:47:58.000000', 'temperatura', 68.0000, 'ºC'),
	(221724, 119, '2014-03-01 00:47:59.000000', 'temperatura', 728.0000, 'ºC'),
	(221725, 119, '2014-03-01 00:48:00.000000', 'temperatura', 1037.0000, 'ºC'),
	(221726, 119, '2014-03-01 00:48:01.000000', 'temperatura', 601.0000, 'ºC'),
	(221727, 119, '2014-03-01 00:48:02.000000', 'temperatura', 1094.0000, 'ºC'),
	(221728, 119, '2014-03-01 00:48:03.000000', 'temperatura', 69.0000, 'ºC'),
	(221729, 119, '2014-03-01 00:48:04.000000', 'temperatura', 662.0000, 'ºC'),
	(221730, 119, '2014-03-01 00:48:05.000000', 'temperatura', 703.0000, 'ºC'),
	(221731, 119, '2014-03-01 00:48:06.000000', 'temperatura', 330.0000, 'ºC'),
	(221732, 119, '2014-03-01 00:48:07.000000', 'temperatura', 741.0000, 'ºC'),
	(221733, 119, '2014-03-01 00:48:08.000000', 'temperatura', 316.0000, 'ºC'),
	(221734, 119, '2014-03-01 00:48:09.000000', 'temperatura', 559.0000, 'ºC'),
	(221735, 119, '2014-03-01 00:48:10.000000', 'temperatura', 647.0000, 'ºC'),
	(221736, 119, '2014-03-01 00:48:11.000000', 'temperatura', 358.0000, 'ºC'),
	(221737, 119, '2014-03-01 00:48:12.000000', 'temperatura', 1050.0000, 'ºC'),
	(221738, 119, '2014-03-01 00:48:13.000000', 'temperatura', 575.0000, 'ºC'),
	(221739, 119, '2014-03-01 00:48:14.000000', 'temperatura', 927.0000, 'ºC'),
	(221740, 119, '2014-03-01 00:48:15.000000', 'temperatura', 508.0000, 'ºC'),
	(221741, 119, '2014-03-01 00:48:16.000000', 'temperatura', 962.0000, 'ºC'),
	(221742, 119, '2014-03-01 00:48:17.000000', 'temperatura', 886.0000, 'ºC'),
	(221743, 119, '2014-03-01 00:48:18.000000', 'temperatura', 344.0000, 'ºC'),
	(221744, 119, '2014-03-01 00:48:19.000000', 'temperatura', 264.0000, 'ºC'),
	(221745, 119, '2014-03-01 00:48:20.000000', 'temperatura', 289.0000, 'ºC'),
	(221746, 119, '2014-03-01 00:48:21.000000', 'temperatura', 654.0000, 'ºC'),
	(221747, 119, '2014-03-01 00:48:22.000000', 'temperatura', 1.0000, 'ºC'),
	(221748, 119, '2014-03-01 00:48:23.000000', 'temperatura', 444.0000, 'ºC'),
	(221749, 119, '2014-03-01 00:48:24.000000', 'temperatura', 1019.0000, 'ºC'),
	(221750, 119, '2014-03-01 00:48:25.000000', 'temperatura', 163.0000, 'ºC'),
	(221751, 119, '2014-03-01 00:48:26.000000', 'temperatura', 159.0000, 'ºC'),
	(221752, 119, '2014-03-01 00:48:27.000000', 'temperatura', 307.0000, 'ºC'),
	(221753, 119, '2014-03-01 00:48:28.000000', 'temperatura', 1057.0000, 'ºC'),
	(221754, 119, '2014-03-01 00:48:29.000000', 'temperatura', 767.0000, 'ºC'),
	(221755, 119, '2014-03-01 00:48:30.000000', 'temperatura', 663.0000, 'ºC'),
	(221756, 119, '2014-03-01 00:48:31.000000', 'temperatura', 1015.0000, 'ºC'),
	(221757, 119, '2014-03-01 00:48:32.000000', 'temperatura', 687.0000, 'ºC'),
	(221758, 119, '2014-03-01 00:48:33.000000', 'temperatura', 392.0000, 'ºC'),
	(221759, 119, '2014-03-01 00:48:34.000000', 'temperatura', 1097.0000, 'ºC'),
	(221760, 119, '2014-03-01 00:48:35.000000', 'temperatura', 708.0000, 'ºC'),
	(221761, 119, '2014-03-01 00:48:36.000000', 'temperatura', 253.0000, 'ºC'),
	(221762, 119, '2014-03-01 00:48:37.000000', 'temperatura', 338.0000, 'ºC'),
	(221763, 119, '2014-03-01 00:48:38.000000', 'temperatura', 935.0000, 'ºC'),
	(221764, 119, '2014-03-01 00:48:39.000000', 'temperatura', 60.0000, 'ºC'),
	(221765, 119, '2014-03-01 00:48:40.000000', 'temperatura', 1095.0000, 'ºC'),
	(221766, 119, '2014-03-01 00:48:41.000000', 'temperatura', 496.0000, 'ºC'),
	(221767, 119, '2014-03-01 00:48:42.000000', 'temperatura', 393.0000, 'ºC'),
	(221768, 119, '2014-03-01 00:48:43.000000', 'temperatura', 481.0000, 'ºC'),
	(221769, 119, '2014-03-01 00:48:44.000000', 'temperatura', 26.0000, 'ºC'),
	(221770, 119, '2014-03-01 00:48:45.000000', 'temperatura', 1087.0000, 'ºC'),
	(221771, 119, '2014-03-01 00:48:46.000000', 'temperatura', 558.0000, 'ºC'),
	(221772, 119, '2014-03-01 00:48:47.000000', 'temperatura', 731.0000, 'ºC'),
	(221773, 119, '2014-03-01 00:48:48.000000', 'temperatura', 781.0000, 'ºC'),
	(221774, 119, '2014-03-01 00:48:49.000000', 'temperatura', 511.0000, 'ºC'),
	(221775, 119, '2014-03-01 00:48:50.000000', 'temperatura', 213.0000, 'ºC'),
	(221776, 119, '2014-03-01 00:48:51.000000', 'temperatura', 734.0000, 'ºC'),
	(221777, 119, '2014-03-01 00:48:52.000000', 'temperatura', 630.0000, 'ºC'),
	(221778, 119, '2014-03-01 00:48:53.000000', 'temperatura', 949.0000, 'ºC'),
	(221779, 119, '2014-03-01 00:48:54.000000', 'temperatura', 456.0000, 'ºC'),
	(221780, 119, '2014-03-01 00:48:55.000000', 'temperatura', 631.0000, 'ºC'),
	(221781, 119, '2014-03-01 00:48:56.000000', 'temperatura', 591.0000, 'ºC'),
	(221782, 119, '2014-03-01 00:48:57.000000', 'temperatura', 1059.0000, 'ºC'),
	(221783, 119, '2014-03-01 00:48:58.000000', 'temperatura', 1126.0000, 'ºC'),
	(221784, 119, '2014-03-01 00:48:59.000000', 'temperatura', 50.0000, 'ºC'),
	(221785, 119, '2014-03-01 00:49:00.000000', 'temperatura', 475.0000, 'ºC'),
	(221786, 119, '2014-03-01 00:49:01.000000', 'temperatura', 1025.0000, 'ºC'),
	(221787, 119, '2014-03-01 00:49:02.000000', 'temperatura', 99.0000, 'ºC'),
	(221788, 119, '2014-03-01 00:49:03.000000', 'temperatura', 1023.0000, 'ºC'),
	(221789, 119, '2014-03-01 00:49:04.000000', 'temperatura', 17.0000, 'ºC'),
	(221790, 119, '2014-03-01 00:49:05.000000', 'temperatura', 619.0000, 'ºC'),
	(221791, 119, '2014-03-01 00:49:06.000000', 'temperatura', 642.0000, 'ºC'),
	(221792, 119, '2014-03-01 00:49:07.000000', 'temperatura', 155.0000, 'ºC'),
	(221793, 119, '2014-03-01 00:49:08.000000', 'temperatura', 48.0000, 'ºC'),
	(221794, 119, '2014-03-01 00:49:09.000000', 'temperatura', 978.0000, 'ºC'),
	(221795, 119, '2014-03-01 00:49:10.000000', 'temperatura', 1146.0000, 'ºC'),
	(221796, 119, '2014-03-01 00:49:11.000000', 'temperatura', 396.0000, 'ºC'),
	(221797, 119, '2014-03-01 00:49:12.000000', 'temperatura', 944.0000, 'ºC'),
	(221798, 119, '2014-03-01 00:49:13.000000', 'temperatura', 1133.0000, 'ºC'),
	(221799, 119, '2014-03-01 00:49:14.000000', 'temperatura', 434.0000, 'ºC'),
	(221800, 119, '2014-03-01 00:49:15.000000', 'temperatura', 1169.0000, 'ºC'),
	(221801, 119, '2014-03-01 00:49:16.000000', 'temperatura', 944.0000, 'ºC'),
	(221802, 119, '2014-03-01 00:49:17.000000', 'temperatura', 16.0000, 'ºC'),
	(221803, 119, '2014-03-01 00:49:18.000000', 'temperatura', 846.0000, 'ºC'),
	(221804, 119, '2014-03-01 00:49:19.000000', 'temperatura', 583.0000, 'ºC'),
	(221805, 119, '2014-03-01 00:49:20.000000', 'temperatura', 378.0000, 'ºC'),
	(221806, 119, '2014-03-01 00:49:21.000000', 'temperatura', 142.0000, 'ºC'),
	(221807, 119, '2014-03-01 00:49:22.000000', 'temperatura', 776.0000, 'ºC'),
	(221808, 119, '2014-03-01 00:49:23.000000', 'temperatura', 1056.0000, 'ºC'),
	(221809, 119, '2014-03-01 00:49:24.000000', 'temperatura', 553.0000, 'ºC'),
	(221810, 119, '2014-03-01 00:49:25.000000', 'temperatura', 795.0000, 'ºC'),
	(221811, 119, '2014-03-01 00:49:26.000000', 'temperatura', 1116.0000, 'ºC'),
	(221812, 119, '2014-03-01 00:49:27.000000', 'temperatura', 798.0000, 'ºC'),
	(221813, 119, '2014-03-01 00:49:28.000000', 'temperatura', 640.0000, 'ºC'),
	(221814, 119, '2014-03-01 00:49:29.000000', 'temperatura', 806.0000, 'ºC'),
	(221815, 119, '2014-03-01 00:49:30.000000', 'temperatura', 911.0000, 'ºC'),
	(221816, 119, '2014-03-01 00:49:31.000000', 'temperatura', 940.0000, 'ºC'),
	(221817, 119, '2014-03-01 00:49:32.000000', 'temperatura', 764.0000, 'ºC'),
	(221818, 119, '2014-03-01 00:49:33.000000', 'temperatura', 1002.0000, 'ºC'),
	(221819, 119, '2014-03-01 00:49:34.000000', 'temperatura', 318.0000, 'ºC'),
	(221820, 119, '2014-03-01 00:49:35.000000', 'temperatura', 986.0000, 'ºC'),
	(221821, 119, '2014-03-01 00:49:36.000000', 'temperatura', 376.0000, 'ºC'),
	(221822, 119, '2014-03-01 00:49:37.000000', 'temperatura', 124.0000, 'ºC'),
	(221823, 119, '2014-03-01 00:49:38.000000', 'temperatura', 690.0000, 'ºC'),
	(221824, 119, '2014-03-01 00:49:39.000000', 'temperatura', 680.0000, 'ºC'),
	(221825, 119, '2014-03-01 00:49:40.000000', 'temperatura', 129.0000, 'ºC'),
	(221826, 119, '2014-03-01 00:49:41.000000', 'temperatura', 1008.0000, 'ºC'),
	(221827, 119, '2014-03-01 00:49:42.000000', 'temperatura', 1051.0000, 'ºC'),
	(221828, 119, '2014-03-01 00:49:43.000000', 'temperatura', 1032.0000, 'ºC'),
	(221829, 119, '2014-03-01 00:49:44.000000', 'temperatura', 807.0000, 'ºC'),
	(221830, 119, '2014-03-01 00:49:45.000000', 'temperatura', 942.0000, 'ºC'),
	(221831, 119, '2014-03-01 00:49:46.000000', 'temperatura', 1086.0000, 'ºC'),
	(221832, 119, '2014-03-01 00:49:47.000000', 'temperatura', 206.0000, 'ºC'),
	(221833, 119, '2014-03-01 00:49:48.000000', 'temperatura', 173.0000, 'ºC'),
	(221834, 119, '2014-03-01 00:49:49.000000', 'temperatura', 246.0000, 'ºC'),
	(221835, 119, '2014-03-01 00:49:50.000000', 'temperatura', 714.0000, 'ºC'),
	(221836, 119, '2014-03-01 00:49:51.000000', 'temperatura', 431.0000, 'ºC'),
	(221837, 119, '2014-03-01 00:49:52.000000', 'temperatura', 13.0000, 'ºC'),
	(221838, 119, '2014-03-01 00:49:53.000000', 'temperatura', 1174.0000, 'ºC'),
	(221839, 119, '2014-03-01 00:49:54.000000', 'temperatura', 1032.0000, 'ºC'),
	(221840, 119, '2014-03-01 00:49:55.000000', 'temperatura', 439.0000, 'ºC'),
	(221841, 119, '2014-03-01 00:49:56.000000', 'temperatura', 297.0000, 'ºC'),
	(221842, 119, '2014-03-01 00:49:57.000000', 'temperatura', 171.0000, 'ºC'),
	(221843, 119, '2014-03-01 00:49:58.000000', 'temperatura', 1162.0000, 'ºC'),
	(221844, 119, '2014-03-01 00:49:59.000000', 'temperatura', 497.0000, 'ºC'),
	(221845, 119, '2014-03-01 00:50:00.000000', 'temperatura', 202.0000, 'ºC'),
	(221846, 119, '2014-03-01 00:50:01.000000', 'temperatura', 719.0000, 'ºC'),
	(221847, 119, '2014-03-01 00:50:02.000000', 'temperatura', 588.0000, 'ºC'),
	(221848, 119, '2014-03-01 00:50:03.000000', 'temperatura', 782.0000, 'ºC'),
	(221849, 119, '2014-03-01 00:50:04.000000', 'temperatura', 950.0000, 'ºC'),
	(221850, 119, '2014-03-01 00:50:05.000000', 'temperatura', 3.0000, 'ºC'),
	(221851, 119, '2014-03-01 00:50:06.000000', 'temperatura', 766.0000, 'ºC'),
	(221852, 119, '2014-03-01 00:50:07.000000', 'temperatura', 222.0000, 'ºC'),
	(221853, 119, '2014-03-01 00:50:08.000000', 'temperatura', 13.0000, 'ºC'),
	(221854, 119, '2014-03-01 00:50:09.000000', 'temperatura', 600.0000, 'ºC'),
	(221855, 119, '2014-03-01 00:50:10.000000', 'temperatura', 559.0000, 'ºC'),
	(221856, 119, '2014-03-01 00:50:11.000000', 'temperatura', 996.0000, 'ºC'),
	(221857, 119, '2014-03-01 00:50:12.000000', 'temperatura', 906.0000, 'ºC'),
	(221858, 119, '2014-03-01 00:50:13.000000', 'temperatura', 340.0000, 'ºC'),
	(221859, 119, '2014-03-01 00:50:14.000000', 'temperatura', 184.0000, 'ºC'),
	(221860, 119, '2014-03-01 00:50:15.000000', 'temperatura', 1098.0000, 'ºC'),
	(221861, 119, '2014-03-01 00:50:16.000000', 'temperatura', 139.0000, 'ºC'),
	(221862, 119, '2014-03-01 00:50:17.000000', 'temperatura', 1003.0000, 'ºC'),
	(221863, 119, '2014-03-01 00:50:18.000000', 'temperatura', 998.0000, 'ºC'),
	(221864, 119, '2014-03-01 00:50:19.000000', 'temperatura', 781.0000, 'ºC'),
	(221865, 119, '2014-03-01 00:50:20.000000', 'temperatura', 912.0000, 'ºC'),
	(221866, 119, '2014-03-01 00:50:21.000000', 'temperatura', 1016.0000, 'ºC'),
	(221867, 119, '2014-03-01 00:50:22.000000', 'temperatura', 1147.0000, 'ºC'),
	(221868, 119, '2014-03-01 00:50:23.000000', 'temperatura', 284.0000, 'ºC'),
	(221869, 119, '2014-03-01 00:50:24.000000', 'temperatura', 382.0000, 'ºC'),
	(221870, 119, '2014-03-01 00:50:25.000000', 'temperatura', 1060.0000, 'ºC'),
	(221871, 119, '2014-03-01 00:50:26.000000', 'temperatura', 551.0000, 'ºC'),
	(221872, 119, '2014-03-01 00:50:27.000000', 'temperatura', 777.0000, 'ºC'),
	(221873, 119, '2014-03-01 00:50:28.000000', 'temperatura', 1031.0000, 'ºC'),
	(221874, 119, '2014-03-01 00:50:29.000000', 'temperatura', 427.0000, 'ºC'),
	(221875, 119, '2014-03-01 00:50:30.000000', 'temperatura', 242.0000, 'ºC'),
	(221876, 119, '2014-03-01 00:50:31.000000', 'temperatura', 1128.0000, 'ºC'),
	(221877, 119, '2014-03-01 00:50:32.000000', 'temperatura', 114.0000, 'ºC'),
	(221878, 119, '2014-03-01 00:50:33.000000', 'temperatura', 788.0000, 'ºC'),
	(221879, 119, '2014-03-01 00:50:34.000000', 'temperatura', 1196.0000, 'ºC'),
	(221880, 119, '2014-03-01 00:50:35.000000', 'temperatura', 18.0000, 'ºC'),
	(221881, 119, '2014-03-01 00:50:36.000000', 'temperatura', 102.0000, 'ºC'),
	(221882, 119, '2014-03-01 00:50:37.000000', 'temperatura', 457.0000, 'ºC'),
	(221883, 119, '2014-03-01 00:50:38.000000', 'temperatura', 780.0000, 'ºC'),
	(221884, 119, '2014-03-01 00:50:39.000000', 'temperatura', 131.0000, 'ºC'),
	(221885, 119, '2014-03-01 00:50:40.000000', 'temperatura', 713.0000, 'ºC'),
	(221886, 119, '2014-03-01 00:50:41.000000', 'temperatura', 773.0000, 'ºC'),
	(221887, 119, '2014-03-01 00:50:42.000000', 'temperatura', 526.0000, 'ºC'),
	(221888, 119, '2014-03-01 00:50:43.000000', 'temperatura', 313.0000, 'ºC'),
	(221889, 119, '2014-03-01 00:50:44.000000', 'temperatura', 1188.0000, 'ºC'),
	(221890, 119, '2014-03-01 00:50:45.000000', 'temperatura', 200.0000, 'ºC'),
	(221891, 119, '2014-03-01 00:50:46.000000', 'temperatura', 1039.0000, 'ºC'),
	(221892, 119, '2014-03-01 00:50:47.000000', 'temperatura', 993.0000, 'ºC'),
	(221893, 119, '2014-03-01 00:50:48.000000', 'temperatura', 651.0000, 'ºC'),
	(221894, 119, '2014-03-01 00:50:49.000000', 'temperatura', 274.0000, 'ºC'),
	(221895, 119, '2014-03-01 00:50:50.000000', 'temperatura', 617.0000, 'ºC'),
	(221896, 119, '2014-03-01 00:50:51.000000', 'temperatura', 1065.0000, 'ºC'),
	(221897, 119, '2014-03-01 00:50:52.000000', 'temperatura', 1073.0000, 'ºC'),
	(221898, 119, '2014-03-01 00:50:53.000000', 'temperatura', 971.0000, 'ºC'),
	(221899, 119, '2014-03-01 00:50:54.000000', 'temperatura', 437.0000, 'ºC'),
	(221900, 119, '2014-03-01 00:50:55.000000', 'temperatura', 474.0000, 'ºC'),
	(221901, 119, '2014-03-01 00:50:56.000000', 'temperatura', 1058.0000, 'ºC'),
	(221902, 119, '2014-03-01 00:50:57.000000', 'temperatura', 269.0000, 'ºC'),
	(221903, 119, '2014-03-01 00:50:58.000000', 'temperatura', 571.0000, 'ºC'),
	(221904, 119, '2014-03-01 00:50:59.000000', 'temperatura', 849.0000, 'ºC'),
	(221905, 119, '2014-03-01 00:51:00.000000', 'temperatura', 130.0000, 'ºC'),
	(221906, 119, '2014-03-01 00:51:01.000000', 'temperatura', 506.0000, 'ºC'),
	(221907, 119, '2014-03-01 00:51:02.000000', 'temperatura', 942.0000, 'ºC'),
	(221908, 119, '2014-03-01 00:51:03.000000', 'temperatura', 789.0000, 'ºC'),
	(221909, 119, '2014-03-01 00:51:04.000000', 'temperatura', 1122.0000, 'ºC'),
	(221910, 119, '2014-03-01 00:51:05.000000', 'temperatura', 842.0000, 'ºC'),
	(221911, 119, '2014-03-01 00:51:06.000000', 'temperatura', 843.0000, 'ºC'),
	(221912, 119, '2014-03-01 00:51:07.000000', 'temperatura', 491.0000, 'ºC'),
	(221913, 119, '2014-03-01 00:51:08.000000', 'temperatura', 1126.0000, 'ºC'),
	(221914, 119, '2014-03-01 00:51:09.000000', 'temperatura', 558.0000, 'ºC'),
	(221915, 119, '2014-03-01 00:51:10.000000', 'temperatura', 612.0000, 'ºC'),
	(221916, 119, '2014-03-01 00:51:11.000000', 'temperatura', 186.0000, 'ºC'),
	(221917, 119, '2014-03-01 00:51:12.000000', 'temperatura', 296.0000, 'ºC'),
	(221918, 119, '2014-03-01 00:51:13.000000', 'temperatura', 923.0000, 'ºC'),
	(221919, 119, '2014-03-01 00:51:14.000000', 'temperatura', 127.0000, 'ºC'),
	(221920, 119, '2014-03-01 00:51:15.000000', 'temperatura', 268.0000, 'ºC'),
	(221921, 119, '2014-03-01 00:51:16.000000', 'temperatura', 959.0000, 'ºC'),
	(221922, 119, '2014-03-01 00:51:17.000000', 'temperatura', 393.0000, 'ºC'),
	(221923, 119, '2014-03-01 00:51:18.000000', 'temperatura', 287.0000, 'ºC'),
	(221924, 119, '2014-03-01 00:51:19.000000', 'temperatura', 255.0000, 'ºC'),
	(221925, 119, '2014-03-01 00:51:20.000000', 'temperatura', 416.0000, 'ºC'),
	(221926, 119, '2014-03-01 00:51:21.000000', 'temperatura', 115.0000, 'ºC'),
	(221927, 119, '2014-03-01 00:51:22.000000', 'temperatura', 529.0000, 'ºC'),
	(221928, 119, '2014-03-01 00:51:23.000000', 'temperatura', 1098.0000, 'ºC'),
	(221929, 119, '2014-03-01 00:51:24.000000', 'temperatura', 307.0000, 'ºC'),
	(221930, 119, '2014-03-01 00:51:25.000000', 'temperatura', 638.0000, 'ºC'),
	(221931, 119, '2014-03-01 00:51:26.000000', 'temperatura', 1069.0000, 'ºC'),
	(221932, 119, '2014-03-01 00:51:27.000000', 'temperatura', 1035.0000, 'ºC'),
	(221933, 119, '2014-03-01 00:51:28.000000', 'temperatura', 765.0000, 'ºC'),
	(221934, 119, '2014-03-01 00:51:29.000000', 'temperatura', 724.0000, 'ºC'),
	(221935, 119, '2014-03-01 00:51:30.000000', 'temperatura', 124.0000, 'ºC'),
	(221936, 119, '2014-03-01 00:51:31.000000', 'temperatura', 847.0000, 'ºC'),
	(221937, 119, '2014-03-01 00:51:32.000000', 'temperatura', 266.0000, 'ºC'),
	(221938, 119, '2014-03-01 00:51:33.000000', 'temperatura', 1187.0000, 'ºC'),
	(221939, 119, '2014-03-01 00:51:34.000000', 'temperatura', 337.0000, 'ºC'),
	(221940, 119, '2014-03-01 00:51:35.000000', 'temperatura', 524.0000, 'ºC'),
	(221941, 119, '2014-03-01 00:51:36.000000', 'temperatura', 410.0000, 'ºC'),
	(221942, 119, '2014-03-01 00:51:37.000000', 'temperatura', 480.0000, 'ºC'),
	(221943, 119, '2014-03-01 00:51:38.000000', 'temperatura', 1170.0000, 'ºC'),
	(221944, 119, '2014-03-01 00:51:39.000000', 'temperatura', 810.0000, 'ºC'),
	(221945, 119, '2014-03-01 00:51:40.000000', 'temperatura', 541.0000, 'ºC'),
	(221946, 119, '2014-03-01 00:51:41.000000', 'temperatura', 273.0000, 'ºC'),
	(221947, 119, '2014-03-01 00:51:42.000000', 'temperatura', 946.0000, 'ºC'),
	(221948, 119, '2014-03-01 00:51:43.000000', 'temperatura', 311.0000, 'ºC'),
	(221949, 119, '2014-03-01 00:51:44.000000', 'temperatura', 1116.0000, 'ºC'),
	(221950, 119, '2014-03-01 00:51:45.000000', 'temperatura', 1048.0000, 'ºC'),
	(221951, 119, '2014-03-01 00:51:46.000000', 'temperatura', 691.0000, 'ºC'),
	(221952, 119, '2014-03-01 00:51:47.000000', 'temperatura', 312.0000, 'ºC'),
	(221953, 119, '2014-03-01 00:51:48.000000', 'temperatura', 690.0000, 'ºC'),
	(221954, 119, '2014-03-01 00:51:49.000000', 'temperatura', 113.0000, 'ºC'),
	(221955, 119, '2014-03-01 00:51:50.000000', 'temperatura', 897.0000, 'ºC'),
	(221956, 119, '2014-03-01 00:51:51.000000', 'temperatura', 546.0000, 'ºC'),
	(221957, 119, '2014-03-01 00:51:52.000000', 'temperatura', 38.0000, 'ºC'),
	(221958, 119, '2014-03-01 00:51:53.000000', 'temperatura', 955.0000, 'ºC'),
	(221959, 119, '2014-03-01 00:51:54.000000', 'temperatura', 1058.0000, 'ºC'),
	(221960, 119, '2014-03-01 00:51:55.000000', 'temperatura', 28.0000, 'ºC'),
	(221961, 119, '2014-03-01 00:51:56.000000', 'temperatura', 566.0000, 'ºC'),
	(221962, 119, '2014-03-01 00:51:57.000000', 'temperatura', 348.0000, 'ºC'),
	(221963, 119, '2014-03-01 00:51:58.000000', 'temperatura', 42.0000, 'ºC'),
	(221964, 119, '2014-03-01 00:51:59.000000', 'temperatura', 364.0000, 'ºC'),
	(221965, 119, '2014-03-01 00:52:00.000000', 'temperatura', 497.0000, 'ºC'),
	(221966, 119, '2014-03-01 00:52:01.000000', 'temperatura', 192.0000, 'ºC'),
	(221967, 119, '2014-03-01 00:52:02.000000', 'temperatura', 670.0000, 'ºC'),
	(221968, 119, '2014-03-01 00:52:03.000000', 'temperatura', 374.0000, 'ºC'),
	(221969, 119, '2014-03-01 00:52:04.000000', 'temperatura', 1060.0000, 'ºC'),
	(221970, 119, '2014-03-01 00:52:05.000000', 'temperatura', 581.0000, 'ºC'),
	(221971, 119, '2014-03-01 00:52:06.000000', 'temperatura', 925.0000, 'ºC'),
	(221972, 119, '2014-03-01 00:52:07.000000', 'temperatura', 483.0000, 'ºC'),
	(221973, 119, '2014-03-01 00:52:08.000000', 'temperatura', 839.0000, 'ºC'),
	(221974, 119, '2014-03-01 00:52:09.000000', 'temperatura', 348.0000, 'ºC'),
	(221975, 119, '2014-03-01 00:52:10.000000', 'temperatura', 422.0000, 'ºC'),
	(221976, 119, '2014-03-01 00:52:11.000000', 'temperatura', 1065.0000, 'ºC'),
	(221977, 119, '2014-03-01 00:52:12.000000', 'temperatura', 461.0000, 'ºC'),
	(221978, 119, '2014-03-01 00:52:13.000000', 'temperatura', 311.0000, 'ºC'),
	(221979, 119, '2014-03-01 00:52:14.000000', 'temperatura', 172.0000, 'ºC'),
	(221980, 119, '2014-03-01 00:52:15.000000', 'temperatura', 1128.0000, 'ºC'),
	(221981, 119, '2014-03-01 00:52:16.000000', 'temperatura', 326.0000, 'ºC'),
	(221982, 119, '2014-03-01 00:52:17.000000', 'temperatura', 645.0000, 'ºC'),
	(221983, 119, '2014-03-01 00:52:18.000000', 'temperatura', 1049.0000, 'ºC'),
	(221984, 119, '2014-03-01 00:52:19.000000', 'temperatura', 911.0000, 'ºC'),
	(221985, 119, '2014-03-01 00:52:20.000000', 'temperatura', 207.0000, 'ºC'),
	(221986, 119, '2014-03-01 00:52:21.000000', 'temperatura', 701.0000, 'ºC'),
	(221987, 119, '2014-03-01 00:52:22.000000', 'temperatura', 488.0000, 'ºC'),
	(221988, 119, '2014-03-01 00:52:23.000000', 'temperatura', 336.0000, 'ºC'),
	(221989, 119, '2014-03-01 00:52:24.000000', 'temperatura', 215.0000, 'ºC'),
	(221990, 119, '2014-03-01 00:52:25.000000', 'temperatura', 67.0000, 'ºC'),
	(221991, 119, '2014-03-01 00:52:26.000000', 'temperatura', 891.0000, 'ºC'),
	(221992, 119, '2014-03-01 00:52:27.000000', 'temperatura', 655.0000, 'ºC'),
	(221993, 119, '2014-03-01 00:52:28.000000', 'temperatura', 604.0000, 'ºC'),
	(221994, 119, '2014-03-01 00:52:29.000000', 'temperatura', 1055.0000, 'ºC'),
	(221995, 119, '2014-03-01 00:52:30.000000', 'temperatura', 1063.0000, 'ºC'),
	(221996, 119, '2014-03-01 00:52:31.000000', 'temperatura', 949.0000, 'ºC'),
	(221997, 119, '2014-03-01 00:52:32.000000', 'temperatura', 358.0000, 'ºC'),
	(221998, 119, '2014-03-01 00:52:33.000000', 'temperatura', 145.0000, 'ºC'),
	(221999, 119, '2014-03-01 00:52:34.000000', 'temperatura', 851.0000, 'ºC'),
	(222000, 119, '2014-03-01 00:52:35.000000', 'temperatura', 221.0000, 'ºC'),
	(222001, 119, '2014-03-01 00:52:36.000000', 'temperatura', 950.0000, 'ºC'),
	(222002, 119, '2014-03-01 00:52:37.000000', 'temperatura', 487.0000, 'ºC'),
	(222003, 119, '2014-03-01 00:52:38.000000', 'temperatura', 788.0000, 'ºC'),
	(222004, 119, '2014-03-01 00:52:39.000000', 'temperatura', 79.0000, 'ºC'),
	(222005, 119, '2014-03-01 00:52:40.000000', 'temperatura', 433.0000, 'ºC'),
	(222006, 119, '2014-03-01 00:52:41.000000', 'temperatura', 726.0000, 'ºC'),
	(222007, 119, '2014-03-01 00:52:42.000000', 'temperatura', 1132.0000, 'ºC'),
	(222008, 119, '2014-03-01 00:52:43.000000', 'temperatura', 1085.0000, 'ºC'),
	(222009, 119, '2014-03-01 00:52:44.000000', 'temperatura', 827.0000, 'ºC'),
	(222010, 119, '2014-03-01 00:52:45.000000', 'temperatura', 883.0000, 'ºC'),
	(222011, 119, '2014-03-01 00:52:46.000000', 'temperatura', 734.0000, 'ºC'),
	(222012, 119, '2014-03-01 00:52:47.000000', 'temperatura', 1022.0000, 'ºC'),
	(222013, 119, '2014-03-01 00:52:48.000000', 'temperatura', 509.0000, 'ºC'),
	(222014, 119, '2014-03-01 00:52:49.000000', 'temperatura', 678.0000, 'ºC'),
	(222015, 119, '2014-03-01 00:52:50.000000', 'temperatura', 662.0000, 'ºC'),
	(222016, 119, '2014-03-01 00:52:51.000000', 'temperatura', 77.0000, 'ºC'),
	(222017, 119, '2014-03-01 00:52:52.000000', 'temperatura', 802.0000, 'ºC'),
	(222018, 119, '2014-03-01 00:52:53.000000', 'temperatura', 177.0000, 'ºC'),
	(222019, 119, '2014-03-01 00:52:54.000000', 'temperatura', 879.0000, 'ºC'),
	(222020, 119, '2014-03-01 00:52:55.000000', 'temperatura', 268.0000, 'ºC'),
	(222021, 119, '2014-03-01 00:52:56.000000', 'temperatura', 1100.0000, 'ºC'),
	(222022, 119, '2014-03-01 00:52:57.000000', 'temperatura', 1097.0000, 'ºC'),
	(222023, 119, '2014-03-01 00:52:58.000000', 'temperatura', 985.0000, 'ºC'),
	(222024, 119, '2014-03-01 00:52:59.000000', 'temperatura', 434.0000, 'ºC'),
	(222025, 119, '2014-03-01 00:53:00.000000', 'temperatura', 417.0000, 'ºC'),
	(222026, 119, '2014-03-01 00:53:01.000000', 'temperatura', 782.0000, 'ºC'),
	(222027, 119, '2014-03-01 00:53:02.000000', 'temperatura', 261.0000, 'ºC'),
	(222028, 119, '2014-03-01 00:53:03.000000', 'temperatura', 157.0000, 'ºC'),
	(222029, 119, '2014-03-01 00:53:04.000000', 'temperatura', 4.0000, 'ºC'),
	(222030, 119, '2014-03-01 00:53:05.000000', 'temperatura', 751.0000, 'ºC'),
	(222031, 119, '2014-03-01 00:53:06.000000', 'temperatura', 142.0000, 'ºC'),
	(222032, 119, '2014-03-01 00:53:07.000000', 'temperatura', 860.0000, 'ºC'),
	(222033, 119, '2014-03-01 00:53:08.000000', 'temperatura', 272.0000, 'ºC'),
	(222034, 119, '2014-03-01 00:53:09.000000', 'temperatura', 1179.0000, 'ºC'),
	(222035, 119, '2014-03-01 00:53:10.000000', 'temperatura', 283.0000, 'ºC'),
	(222036, 119, '2014-03-01 00:53:11.000000', 'temperatura', 277.0000, 'ºC'),
	(222037, 119, '2014-03-01 00:53:12.000000', 'temperatura', 538.0000, 'ºC'),
	(222038, 119, '2014-03-01 00:53:13.000000', 'temperatura', 659.0000, 'ºC'),
	(222039, 119, '2014-03-01 00:53:14.000000', 'temperatura', 483.0000, 'ºC'),
	(222040, 119, '2014-03-01 00:53:15.000000', 'temperatura', 438.0000, 'ºC'),
	(222041, 119, '2014-03-01 00:53:16.000000', 'temperatura', 740.0000, 'ºC'),
	(222042, 119, '2014-03-01 00:53:17.000000', 'temperatura', 1189.0000, 'ºC'),
	(222043, 119, '2014-03-01 00:53:18.000000', 'temperatura', 124.0000, 'ºC'),
	(222044, 119, '2014-03-01 00:53:19.000000', 'temperatura', 655.0000, 'ºC'),
	(222045, 119, '2014-03-01 00:53:20.000000', 'temperatura', 502.0000, 'ºC'),
	(222046, 119, '2014-03-01 00:53:21.000000', 'temperatura', 544.0000, 'ºC'),
	(222047, 119, '2014-03-01 00:53:22.000000', 'temperatura', 17.0000, 'ºC'),
	(222048, 119, '2014-03-01 00:53:23.000000', 'temperatura', 853.0000, 'ºC'),
	(222049, 119, '2014-03-01 00:53:24.000000', 'temperatura', 614.0000, 'ºC'),
	(222050, 119, '2014-03-01 00:53:25.000000', 'temperatura', 510.0000, 'ºC'),
	(222051, 119, '2014-03-01 00:53:26.000000', 'temperatura', 710.0000, 'ºC'),
	(222052, 119, '2014-03-01 00:53:27.000000', 'temperatura', 821.0000, 'ºC'),
	(222053, 119, '2014-03-01 00:53:28.000000', 'temperatura', 777.0000, 'ºC'),
	(222054, 119, '2014-03-01 00:53:29.000000', 'temperatura', 219.0000, 'ºC'),
	(222055, 119, '2014-03-01 00:53:30.000000', 'temperatura', 1168.0000, 'ºC'),
	(222056, 119, '2014-03-01 00:53:31.000000', 'temperatura', 381.0000, 'ºC'),
	(222057, 119, '2014-03-01 00:53:32.000000', 'temperatura', 801.0000, 'ºC'),
	(222058, 119, '2014-03-01 00:53:33.000000', 'temperatura', 462.0000, 'ºC'),
	(222059, 119, '2014-03-01 00:53:34.000000', 'temperatura', 1108.0000, 'ºC'),
	(222060, 119, '2014-03-01 00:53:35.000000', 'temperatura', 554.0000, 'ºC'),
	(222061, 119, '2014-03-01 00:53:36.000000', 'temperatura', 648.0000, 'ºC'),
	(222062, 119, '2014-03-01 00:53:37.000000', 'temperatura', 377.0000, 'ºC'),
	(222063, 119, '2014-03-01 00:53:38.000000', 'temperatura', 1143.0000, 'ºC'),
	(222064, 119, '2014-03-01 00:53:39.000000', 'temperatura', 985.0000, 'ºC'),
	(222065, 119, '2014-03-01 00:53:40.000000', 'temperatura', 295.0000, 'ºC'),
	(222066, 119, '2014-03-01 00:53:41.000000', 'temperatura', 921.0000, 'ºC'),
	(222067, 119, '2014-03-01 00:53:42.000000', 'temperatura', 121.0000, 'ºC'),
	(222068, 119, '2014-03-01 00:53:43.000000', 'temperatura', 244.0000, 'ºC'),
	(222069, 119, '2014-03-01 00:53:44.000000', 'temperatura', 856.0000, 'ºC'),
	(222070, 119, '2014-03-01 00:53:45.000000', 'temperatura', 1147.0000, 'ºC'),
	(222071, 119, '2014-03-01 00:53:46.000000', 'temperatura', 768.0000, 'ºC'),
	(222072, 119, '2014-03-01 00:53:47.000000', 'temperatura', 399.0000, 'ºC'),
	(222073, 119, '2014-03-01 00:53:48.000000', 'temperatura', 892.0000, 'ºC'),
	(222074, 119, '2014-03-01 00:53:49.000000', 'temperatura', 865.0000, 'ºC'),
	(222075, 119, '2014-03-01 00:53:50.000000', 'temperatura', 449.0000, 'ºC'),
	(222076, 119, '2014-03-01 00:53:51.000000', 'temperatura', 848.0000, 'ºC'),
	(222077, 119, '2014-03-01 00:53:52.000000', 'temperatura', 496.0000, 'ºC'),
	(222078, 119, '2014-03-01 00:53:53.000000', 'temperatura', 1136.0000, 'ºC'),
	(222079, 119, '2014-03-01 00:53:54.000000', 'temperatura', 592.0000, 'ºC'),
	(222080, 119, '2014-03-01 00:53:55.000000', 'temperatura', 751.0000, 'ºC'),
	(222081, 119, '2014-03-01 00:53:56.000000', 'temperatura', 780.0000, 'ºC'),
	(222082, 119, '2014-03-01 00:53:57.000000', 'temperatura', 448.0000, 'ºC'),
	(222083, 119, '2014-03-01 00:53:58.000000', 'temperatura', 1101.0000, 'ºC'),
	(222084, 119, '2014-03-01 00:53:59.000000', 'temperatura', 562.0000, 'ºC'),
	(222085, 119, '2014-03-01 00:54:00.000000', 'temperatura', 707.0000, 'ºC'),
	(222086, 119, '2014-03-01 00:54:01.000000', 'temperatura', 649.0000, 'ºC'),
	(222087, 119, '2014-03-01 00:54:02.000000', 'temperatura', 1123.0000, 'ºC'),
	(222088, 119, '2014-03-01 00:54:03.000000', 'temperatura', 68.0000, 'ºC'),
	(222089, 119, '2014-03-01 00:54:04.000000', 'temperatura', 575.0000, 'ºC'),
	(222090, 119, '2014-03-01 00:54:05.000000', 'temperatura', 269.0000, 'ºC'),
	(222091, 119, '2014-03-01 00:54:06.000000', 'temperatura', 822.0000, 'ºC'),
	(222092, 119, '2014-03-01 00:54:07.000000', 'temperatura', 903.0000, 'ºC'),
	(222093, 119, '2014-03-01 00:54:08.000000', 'temperatura', 851.0000, 'ºC'),
	(222094, 119, '2014-03-01 00:54:09.000000', 'temperatura', 347.0000, 'ºC'),
	(222095, 119, '2014-03-01 00:54:10.000000', 'temperatura', 383.0000, 'ºC'),
	(222096, 119, '2014-03-01 00:54:11.000000', 'temperatura', 874.0000, 'ºC'),
	(222097, 119, '2014-03-01 00:54:12.000000', 'temperatura', 821.0000, 'ºC'),
	(222098, 119, '2014-03-01 00:54:13.000000', 'temperatura', 282.0000, 'ºC'),
	(222099, 119, '2014-03-01 00:54:14.000000', 'temperatura', 147.0000, 'ºC'),
	(222100, 119, '2014-03-01 00:54:15.000000', 'temperatura', 1091.0000, 'ºC'),
	(222101, 119, '2014-03-01 00:54:16.000000', 'temperatura', 213.0000, 'ºC'),
	(222102, 119, '2014-03-01 00:54:17.000000', 'temperatura', 194.0000, 'ºC'),
	(222103, 119, '2014-03-01 00:54:18.000000', 'temperatura', 331.0000, 'ºC'),
	(222104, 119, '2014-03-01 00:54:19.000000', 'temperatura', 1073.0000, 'ºC'),
	(222105, 119, '2014-03-01 00:54:20.000000', 'temperatura', 773.0000, 'ºC'),
	(222106, 119, '2014-03-01 00:54:21.000000', 'temperatura', 646.0000, 'ºC'),
	(222107, 119, '2014-03-01 00:54:22.000000', 'temperatura', 912.0000, 'ºC'),
	(222108, 119, '2014-03-01 00:54:23.000000', 'temperatura', 222.0000, 'ºC'),
	(222109, 119, '2014-03-01 00:54:24.000000', 'temperatura', 775.0000, 'ºC'),
	(222110, 119, '2014-03-01 00:54:25.000000', 'temperatura', 809.0000, 'ºC'),
	(222111, 119, '2014-03-01 00:54:26.000000', 'temperatura', 522.0000, 'ºC'),
	(222112, 119, '2014-03-01 00:54:27.000000', 'temperatura', 183.0000, 'ºC'),
	(222113, 119, '2014-03-01 00:54:28.000000', 'temperatura', 548.0000, 'ºC'),
	(222114, 119, '2014-03-01 00:54:29.000000', 'temperatura', 991.0000, 'ºC'),
	(222115, 119, '2014-03-01 00:54:30.000000', 'temperatura', 914.0000, 'ºC'),
	(222116, 119, '2014-03-01 00:54:31.000000', 'temperatura', 398.0000, 'ºC'),
	(222117, 119, '2014-03-01 00:54:32.000000', 'temperatura', 446.0000, 'ºC'),
	(222118, 119, '2014-03-01 00:54:33.000000', 'temperatura', 1039.0000, 'ºC'),
	(222119, 119, '2014-03-01 00:54:34.000000', 'temperatura', 257.0000, 'ºC'),
	(222120, 119, '2014-03-01 00:54:35.000000', 'temperatura', 570.0000, 'ºC'),
	(222121, 119, '2014-03-01 00:54:36.000000', 'temperatura', 877.0000, 'ºC'),
	(222122, 119, '2014-03-01 00:54:37.000000', 'temperatura', 277.0000, 'ºC'),
	(222123, 119, '2014-03-01 00:54:38.000000', 'temperatura', 1154.0000, 'ºC'),
	(222124, 119, '2014-03-01 00:54:39.000000', 'temperatura', 138.0000, 'ºC'),
	(222125, 119, '2014-03-01 00:54:40.000000', 'temperatura', 830.0000, 'ºC'),
	(222126, 119, '2014-03-01 00:54:41.000000', 'temperatura', 134.0000, 'ºC'),
	(222127, 119, '2014-03-01 00:54:42.000000', 'temperatura', 583.0000, 'ºC'),
	(222128, 119, '2014-03-01 00:54:43.000000', 'temperatura', 112.0000, 'ºC'),
	(222129, 119, '2014-03-01 00:54:44.000000', 'temperatura', 10.0000, 'ºC'),
	(222130, 119, '2014-03-01 00:54:45.000000', 'temperatura', 917.0000, 'ºC'),
	(222131, 119, '2014-03-01 00:54:46.000000', 'temperatura', 955.0000, 'ºC'),
	(222132, 119, '2014-03-01 00:54:47.000000', 'temperatura', 824.0000, 'ºC'),
	(222133, 119, '2014-03-01 00:54:48.000000', 'temperatura', 56.0000, 'ºC'),
	(222134, 119, '2014-03-01 00:54:49.000000', 'temperatura', 210.0000, 'ºC'),
	(222135, 119, '2014-03-01 00:54:50.000000', 'temperatura', 882.0000, 'ºC'),
	(222136, 119, '2014-03-01 00:54:51.000000', 'temperatura', 181.0000, 'ºC'),
	(222137, 119, '2014-03-01 00:54:52.000000', 'temperatura', 657.0000, 'ºC'),
	(222138, 119, '2014-03-01 00:54:53.000000', 'temperatura', 343.0000, 'ºC'),
	(222139, 119, '2014-03-01 00:54:54.000000', 'temperatura', 945.0000, 'ºC'),
	(222140, 119, '2014-03-01 00:54:55.000000', 'temperatura', 98.0000, 'ºC'),
	(222141, 119, '2014-03-01 00:54:56.000000', 'temperatura', 55.0000, 'ºC'),
	(222142, 119, '2014-03-01 00:54:57.000000', 'temperatura', 1182.0000, 'ºC'),
	(222143, 119, '2014-03-01 00:54:58.000000', 'temperatura', 947.0000, 'ºC'),
	(222144, 119, '2014-03-01 00:54:59.000000', 'temperatura', 1187.0000, 'ºC'),
	(222145, 119, '2014-03-01 00:55:00.000000', 'temperatura', 695.0000, 'ºC'),
	(222146, 119, '2014-03-01 00:55:01.000000', 'temperatura', 1114.0000, 'ºC'),
	(222147, 119, '2014-03-01 00:55:02.000000', 'temperatura', 1085.0000, 'ºC'),
	(222148, 119, '2014-03-01 00:55:03.000000', 'temperatura', 884.0000, 'ºC'),
	(222149, 119, '2014-03-01 00:55:04.000000', 'temperatura', 1165.0000, 'ºC'),
	(222150, 119, '2014-03-01 00:55:05.000000', 'temperatura', 775.0000, 'ºC'),
	(222151, 119, '2014-03-01 00:55:06.000000', 'temperatura', 382.0000, 'ºC'),
	(222152, 119, '2014-03-01 00:55:07.000000', 'temperatura', 783.0000, 'ºC'),
	(222153, 119, '2014-03-01 00:55:08.000000', 'temperatura', 370.0000, 'ºC'),
	(222154, 119, '2014-03-01 00:55:09.000000', 'temperatura', 700.0000, 'ºC'),
	(222155, 119, '2014-03-01 00:55:10.000000', 'temperatura', 1190.0000, 'ºC'),
	(222156, 119, '2014-03-01 00:55:11.000000', 'temperatura', 253.0000, 'ºC'),
	(222157, 119, '2014-03-01 00:55:12.000000', 'temperatura', 92.0000, 'ºC'),
	(222158, 119, '2014-03-01 00:55:13.000000', 'temperatura', 905.0000, 'ºC'),
	(222159, 119, '2014-03-01 00:55:14.000000', 'temperatura', 649.0000, 'ºC'),
	(222160, 119, '2014-03-01 00:55:15.000000', 'temperatura', 531.0000, 'ºC'),
	(222161, 119, '2014-03-01 00:55:16.000000', 'temperatura', 709.0000, 'ºC'),
	(222162, 119, '2014-03-01 00:55:17.000000', 'temperatura', 751.0000, 'ºC'),
	(222163, 119, '2014-03-01 00:55:18.000000', 'temperatura', 428.0000, 'ºC'),
	(222164, 119, '2014-03-01 00:55:19.000000', 'temperatura', 1087.0000, 'ºC'),
	(222165, 119, '2014-03-01 00:55:20.000000', 'temperatura', 551.0000, 'ºC'),
	(222166, 119, '2014-03-01 00:55:21.000000', 'temperatura', 694.0000, 'ºC'),
	(222167, 119, '2014-03-01 00:55:22.000000', 'temperatura', 618.0000, 'ºC'),
	(222168, 119, '2014-03-01 00:55:23.000000', 'temperatura', 1009.0000, 'ºC'),
	(222169, 119, '2014-03-01 00:55:24.000000', 'temperatura', 791.0000, 'ºC'),
	(222170, 119, '2014-03-01 00:55:25.000000', 'temperatura', 929.0000, 'ºC'),
	(222171, 119, '2014-03-01 00:55:26.000000', 'temperatura', 1074.0000, 'ºC'),
	(222172, 119, '2014-03-01 00:55:27.000000', 'temperatura', 182.0000, 'ºC'),
	(222173, 119, '2014-03-01 00:55:28.000000', 'temperatura', 90.0000, 'ºC'),
	(222174, 119, '2014-03-01 00:55:29.000000', 'temperatura', 1104.0000, 'ºC'),
	(222175, 119, '2014-03-01 00:55:30.000000', 'temperatura', 452.0000, 'ºC'),
	(222176, 119, '2014-03-01 00:55:31.000000', 'temperatura', 146.0000, 'ºC'),
	(222177, 119, '2014-03-01 00:55:32.000000', 'temperatura', 575.0000, 'ºC'),
	(222178, 119, '2014-03-01 00:55:33.000000', 'temperatura', 37.0000, 'ºC'),
	(222179, 119, '2014-03-01 00:55:34.000000', 'temperatura', 863.0000, 'ºC'),
	(222180, 119, '2014-03-01 00:55:35.000000', 'temperatura', 603.0000, 'ºC'),
	(222181, 119, '2014-03-01 00:55:36.000000', 'temperatura', 428.0000, 'ºC'),
	(222182, 119, '2014-03-01 00:55:37.000000', 'temperatura', 330.0000, 'ºC'),
	(222183, 119, '2014-03-01 00:55:38.000000', 'temperatura', 365.0000, 'ºC'),
	(222184, 119, '2014-03-01 00:55:39.000000', 'temperatura', 839.0000, 'ºC'),
	(222185, 119, '2014-03-01 00:55:40.000000', 'temperatura', 697.0000, 'ºC'),
	(222186, 119, '2014-03-01 00:55:41.000000', 'temperatura', 970.0000, 'ºC'),
	(222187, 119, '2014-03-01 00:55:42.000000', 'temperatura', 361.0000, 'ºC'),
	(222188, 119, '2014-03-01 00:55:43.000000', 'temperatura', 96.0000, 'ºC'),
	(222189, 119, '2014-03-01 00:55:44.000000', 'temperatura', 598.0000, 'ºC'),
	(222190, 119, '2014-03-01 00:55:45.000000', 'temperatura', 300.0000, 'ºC'),
	(222191, 119, '2014-03-01 00:55:46.000000', 'temperatura', 909.0000, 'ºC'),
	(222192, 119, '2014-03-01 00:55:47.000000', 'temperatura', 44.0000, 'ºC'),
	(222193, 119, '2014-03-01 00:55:48.000000', 'temperatura', 1093.0000, 'ºC'),
	(222194, 119, '2014-03-01 00:55:49.000000', 'temperatura', 535.0000, 'ºC'),
	(222195, 119, '2014-03-01 00:55:50.000000', 'temperatura', 596.0000, 'ºC'),
	(222196, 119, '2014-03-01 00:55:51.000000', 'temperatura', 175.0000, 'ºC'),
	(222197, 119, '2014-03-01 00:55:52.000000', 'temperatura', 288.0000, 'ºC'),
	(222198, 119, '2014-03-01 00:55:53.000000', 'temperatura', 916.0000, 'ºC'),
	(222199, 119, '2014-03-01 00:55:54.000000', 'temperatura', 115.0000, 'ºC'),
	(222200, 119, '2014-03-01 00:55:55.000000', 'temperatura', 229.0000, 'ºC'),
	(222201, 119, '2014-03-01 00:55:56.000000', 'temperatura', 800.0000, 'ºC'),
	(222202, 119, '2014-03-01 00:55:57.000000', 'temperatura', 913.0000, 'ºC'),
	(222203, 119, '2014-03-01 00:55:58.000000', 'temperatura', 968.0000, 'ºC'),
	(222204, 119, '2014-03-01 00:55:59.000000', 'temperatura', 899.0000, 'ºC'),
	(222205, 119, '2014-03-01 00:56:00.000000', 'temperatura', 394.0000, 'ºC'),
	(222206, 119, '2014-03-01 00:56:01.000000', 'temperatura', 470.0000, 'ºC'),
	(222207, 119, '2014-03-01 00:56:02.000000', 'temperatura', 1170.0000, 'ºC'),
	(222208, 119, '2014-03-01 00:56:03.000000', 'temperatura', 842.0000, 'ºC'),
	(222209, 119, '2014-03-01 00:56:04.000000', 'temperatura', 701.0000, 'ºC'),
	(222210, 119, '2014-03-01 00:56:05.000000', 'temperatura', 979.0000, 'ºC'),
	(222211, 119, '2014-03-01 00:56:06.000000', 'temperatura', 391.0000, 'ºC'),
	(222212, 119, '2014-03-01 00:56:07.000000', 'temperatura', 221.0000, 'ºC'),
	(222213, 119, '2014-03-01 00:56:08.000000', 'temperatura', 1132.0000, 'ºC'),
	(222214, 119, '2014-03-01 00:56:09.000000', 'temperatura', 196.0000, 'ºC'),
	(222215, 119, '2014-03-01 00:56:10.000000', 'temperatura', 1186.0000, 'ºC'),
	(222216, 119, '2014-03-01 00:56:11.000000', 'temperatura', 541.0000, 'ºC'),
	(222217, 119, '2014-03-01 00:56:12.000000', 'temperatura', 348.0000, 'ºC'),
	(222218, 119, '2014-03-01 00:56:13.000000', 'temperatura', 117.0000, 'ºC'),
	(222219, 119, '2014-03-01 00:56:14.000000', 'temperatura', 743.0000, 'ºC'),
	(222220, 119, '2014-03-01 00:56:15.000000', 'temperatura', 965.0000, 'ºC'),
	(222221, 119, '2014-03-01 00:56:16.000000', 'temperatura', 198.0000, 'ºC'),
	(222222, 119, '2014-03-01 00:56:17.000000', 'temperatura', 492.0000, 'ºC'),
	(222223, 119, '2014-03-01 00:56:18.000000', 'temperatura', 669.0000, 'ºC'),
	(222224, 119, '2014-03-01 00:56:19.000000', 'temperatura', 669.0000, 'ºC'),
	(222225, 119, '2014-03-01 00:56:20.000000', 'temperatura', 140.0000, 'ºC'),
	(222226, 119, '2014-03-01 00:56:21.000000', 'temperatura', 1090.0000, 'ºC'),
	(222227, 119, '2014-03-01 00:56:22.000000', 'temperatura', 234.0000, 'ºC'),
	(222228, 119, '2014-03-01 00:56:23.000000', 'temperatura', 298.0000, 'ºC'),
	(222229, 119, '2014-03-01 00:56:24.000000', 'temperatura', 790.0000, 'ºC'),
	(222230, 119, '2014-03-01 00:56:25.000000', 'temperatura', 657.0000, 'ºC'),
	(222231, 119, '2014-03-01 00:56:26.000000', 'temperatura', 913.0000, 'ºC'),
	(222232, 119, '2014-03-01 00:56:27.000000', 'temperatura', 197.0000, 'ºC'),
	(222233, 119, '2014-03-01 00:56:28.000000', 'temperatura', 645.0000, 'ºC'),
	(222234, 119, '2014-03-01 00:56:29.000000', 'temperatura', 236.0000, 'ºC'),
	(222235, 119, '2014-03-01 00:56:30.000000', 'temperatura', 444.0000, 'ºC'),
	(222236, 119, '2014-03-01 00:56:31.000000', 'temperatura', 312.0000, 'ºC'),
	(222237, 119, '2014-03-01 00:56:32.000000', 'temperatura', 229.0000, 'ºC'),
	(222238, 119, '2014-03-01 00:56:33.000000', 'temperatura', 208.0000, 'ºC'),
	(222239, 119, '2014-03-01 00:56:34.000000', 'temperatura', 354.0000, 'ºC'),
	(222240, 119, '2014-03-01 00:56:35.000000', 'temperatura', 1146.0000, 'ºC'),
	(222241, 119, '2014-03-01 00:56:36.000000', 'temperatura', 1070.0000, 'ºC'),
	(222242, 119, '2014-03-01 00:56:37.000000', 'temperatura', 712.0000, 'ºC'),
	(222243, 119, '2014-03-01 00:56:38.000000', 'temperatura', 351.0000, 'ºC'),
	(222244, 119, '2014-03-01 00:56:39.000000', 'temperatura', 821.0000, 'ºC'),
	(222245, 119, '2014-03-01 00:56:40.000000', 'temperatura', 649.0000, 'ºC'),
	(222246, 119, '2014-03-01 00:56:41.000000', 'temperatura', 786.0000, 'ºC'),
	(222247, 119, '2014-03-01 00:56:42.000000', 'temperatura', 781.0000, 'ºC'),
	(222248, 119, '2014-03-01 00:56:43.000000', 'temperatura', 348.0000, 'ºC'),
	(222249, 119, '2014-03-01 00:56:44.000000', 'temperatura', 597.0000, 'ºC'),
	(222250, 119, '2014-03-01 00:56:45.000000', 'temperatura', 742.0000, 'ºC'),
	(222251, 119, '2014-03-01 00:56:46.000000', 'temperatura', 720.0000, 'ºC'),
	(222252, 119, '2014-03-01 00:56:47.000000', 'temperatura', 172.0000, 'ºC'),
	(222253, 119, '2014-03-01 00:56:48.000000', 'temperatura', 1104.0000, 'ºC'),
	(222254, 119, '2014-03-01 00:56:49.000000', 'temperatura', 203.0000, 'ºC'),
	(222255, 119, '2014-03-01 00:56:50.000000', 'temperatura', 105.0000, 'ºC'),
	(222256, 119, '2014-03-01 00:56:51.000000', 'temperatura', 1117.0000, 'ºC'),
	(222257, 119, '2014-03-01 00:56:52.000000', 'temperatura', 470.0000, 'ºC'),
	(222258, 119, '2014-03-01 00:56:53.000000', 'temperatura', 198.0000, 'ºC'),
	(222259, 119, '2014-03-01 00:56:54.000000', 'temperatura', 779.0000, 'ºC'),
	(222260, 119, '2014-03-01 00:56:55.000000', 'temperatura', 904.0000, 'ºC'),
	(222261, 119, '2014-03-01 00:56:56.000000', 'temperatura', 983.0000, 'ºC'),
	(222262, 119, '2014-03-01 00:56:57.000000', 'temperatura', 1005.0000, 'ºC'),
	(222263, 119, '2014-03-01 00:56:58.000000', 'temperatura', 874.0000, 'ºC'),
	(222264, 119, '2014-03-01 00:56:59.000000', 'temperatura', 155.0000, 'ºC'),
	(222265, 119, '2014-03-01 00:57:00.000000', 'temperatura', 556.0000, 'ºC'),
	(222266, 119, '2014-03-01 00:57:01.000000', 'temperatura', 1112.0000, 'ºC'),
	(222267, 119, '2014-03-01 00:57:02.000000', 'temperatura', 296.0000, 'ºC'),
	(222268, 119, '2014-03-01 00:57:03.000000', 'temperatura', 542.0000, 'ºC'),
	(222269, 119, '2014-03-01 00:57:04.000000', 'temperatura', 622.0000, 'ºC'),
	(222270, 119, '2014-03-01 00:57:05.000000', 'temperatura', 288.0000, 'ºC'),
	(222271, 119, '2014-03-01 00:57:06.000000', 'temperatura', 771.0000, 'ºC'),
	(222272, 119, '2014-03-01 00:57:07.000000', 'temperatura', 592.0000, 'ºC'),
	(222273, 119, '2014-03-01 00:57:08.000000', 'temperatura', 646.0000, 'ºC'),
	(222274, 119, '2014-03-01 00:57:09.000000', 'temperatura', 256.0000, 'ºC'),
	(222275, 119, '2014-03-01 00:57:10.000000', 'temperatura', 543.0000, 'ºC'),
	(222276, 119, '2014-03-01 00:57:11.000000', 'temperatura', 746.0000, 'ºC'),
	(222277, 119, '2014-03-01 00:57:12.000000', 'temperatura', 904.0000, 'ºC'),
	(222278, 119, '2014-03-01 00:57:13.000000', 'temperatura', 1080.0000, 'ºC'),
	(222279, 119, '2014-03-01 00:57:14.000000', 'temperatura', 288.0000, 'ºC'),
	(222280, 119, '2014-03-01 00:57:15.000000', 'temperatura', 602.0000, 'ºC'),
	(222281, 119, '2014-03-01 00:57:16.000000', 'temperatura', 948.0000, 'ºC'),
	(222282, 119, '2014-03-01 00:57:17.000000', 'temperatura', 533.0000, 'ºC'),
	(222283, 119, '2014-03-01 00:57:18.000000', 'temperatura', 1023.0000, 'ºC'),
	(222284, 119, '2014-03-01 00:57:19.000000', 'temperatura', 1117.0000, 'ºC'),
	(222285, 119, '2014-03-01 00:57:20.000000', 'temperatura', 115.0000, 'ºC'),
	(222286, 119, '2014-03-01 00:57:21.000000', 'temperatura', 826.0000, 'ºC'),
	(222287, 119, '2014-03-01 00:57:22.000000', 'temperatura', 183.0000, 'ºC'),
	(222288, 119, '2014-03-01 00:57:23.000000', 'temperatura', 837.0000, 'ºC'),
	(222289, 119, '2014-03-01 00:57:24.000000', 'temperatura', 39.0000, 'ºC'),
	(222290, 119, '2014-03-01 00:57:25.000000', 'temperatura', 84.0000, 'ºC'),
	(222291, 119, '2014-03-01 00:57:26.000000', 'temperatura', 303.0000, 'ºC'),
	(222292, 119, '2014-03-01 00:57:27.000000', 'temperatura', 65.0000, 'ºC'),
	(222293, 119, '2014-03-01 00:57:28.000000', 'temperatura', 614.0000, 'ºC'),
	(222294, 119, '2014-03-01 00:57:29.000000', 'temperatura', 476.0000, 'ºC'),
	(222295, 119, '2014-03-01 00:57:30.000000', 'temperatura', 540.0000, 'ºC'),
	(222296, 119, '2014-03-01 00:57:31.000000', 'temperatura', 73.0000, 'ºC'),
	(222297, 119, '2014-03-01 00:57:32.000000', 'temperatura', 1143.0000, 'ºC'),
	(222298, 119, '2014-03-01 00:57:33.000000', 'temperatura', 697.0000, 'ºC'),
	(222299, 119, '2014-03-01 00:57:34.000000', 'temperatura', 56.0000, 'ºC'),
	(222300, 119, '2014-03-01 00:57:35.000000', 'temperatura', 590.0000, 'ºC'),
	(222301, 119, '2014-03-01 00:57:36.000000', 'temperatura', 381.0000, 'ºC'),
	(222302, 119, '2014-03-01 00:57:37.000000', 'temperatura', 138.0000, 'ºC'),
	(222303, 119, '2014-03-01 00:57:38.000000', 'temperatura', 746.0000, 'ºC'),
	(222304, 119, '2014-03-01 00:57:39.000000', 'temperatura', 915.0000, 'ºC'),
	(222305, 119, '2014-03-01 00:57:40.000000', 'temperatura', 1139.0000, 'ºC'),
	(222306, 119, '2014-03-01 00:57:41.000000', 'temperatura', 551.0000, 'ºC'),
	(222307, 119, '2014-03-01 00:57:42.000000', 'temperatura', 538.0000, 'ºC'),
	(222308, 119, '2014-03-01 00:57:43.000000', 'temperatura', 1037.0000, 'ºC'),
	(222309, 119, '2014-03-01 00:57:44.000000', 'temperatura', 1172.0000, 'ºC'),
	(222310, 119, '2014-03-01 00:57:45.000000', 'temperatura', 348.0000, 'ºC'),
	(222311, 119, '2014-03-01 00:57:46.000000', 'temperatura', 624.0000, 'ºC'),
	(222312, 119, '2014-03-01 00:57:47.000000', 'temperatura', 879.0000, 'ºC'),
	(222313, 119, '2014-03-01 00:57:48.000000', 'temperatura', 124.0000, 'ºC'),
	(222314, 119, '2014-03-01 00:57:49.000000', 'temperatura', 381.0000, 'ºC'),
	(222315, 119, '2014-03-01 00:57:50.000000', 'temperatura', 336.0000, 'ºC'),
	(222316, 119, '2014-03-01 00:57:51.000000', 'temperatura', 534.0000, 'ºC'),
	(222317, 119, '2014-03-01 00:57:52.000000', 'temperatura', 466.0000, 'ºC'),
	(222318, 119, '2014-03-01 00:57:53.000000', 'temperatura', 727.0000, 'ºC'),
	(222319, 119, '2014-03-01 00:57:54.000000', 'temperatura', 1037.0000, 'ºC'),
	(222320, 119, '2014-03-01 00:57:55.000000', 'temperatura', 606.0000, 'ºC'),
	(222321, 119, '2014-03-01 00:57:56.000000', 'temperatura', 1120.0000, 'ºC'),
	(222322, 119, '2014-03-01 00:57:57.000000', 'temperatura', 180.0000, 'ºC'),
	(222323, 119, '2014-03-01 00:57:58.000000', 'temperatura', 1140.0000, 'ºC'),
	(222324, 119, '2014-03-01 00:57:59.000000', 'temperatura', 364.0000, 'ºC'),
	(222325, 119, '2014-03-01 00:58:00.000000', 'temperatura', 797.0000, 'ºC'),
	(222326, 119, '2014-03-01 00:58:01.000000', 'temperatura', 495.0000, 'ºC'),
	(222327, 119, '2014-03-01 00:58:02.000000', 'temperatura', 83.0000, 'ºC'),
	(222328, 119, '2014-03-01 00:58:03.000000', 'temperatura', 133.0000, 'ºC'),
	(222329, 119, '2014-03-01 00:58:04.000000', 'temperatura', 415.0000, 'ºC'),
	(222330, 119, '2014-03-01 00:58:05.000000', 'temperatura', 475.0000, 'ºC'),
	(222331, 119, '2014-03-01 00:58:06.000000', 'temperatura', 1131.0000, 'ºC'),
	(222332, 119, '2014-03-01 00:58:07.000000', 'temperatura', 631.0000, 'ºC'),
	(222333, 119, '2014-03-01 00:58:08.000000', 'temperatura', 962.0000, 'ºC'),
	(222334, 119, '2014-03-01 00:58:09.000000', 'temperatura', 519.0000, 'ºC'),
	(222335, 119, '2014-03-01 00:58:10.000000', 'temperatura', 910.0000, 'ºC'),
	(222336, 119, '2014-03-01 00:58:11.000000', 'temperatura', 592.0000, 'ºC'),
	(222337, 119, '2014-03-01 00:58:12.000000', 'temperatura', 230.0000, 'ºC'),
	(222338, 119, '2014-03-01 00:58:13.000000', 'temperatura', 573.0000, 'ºC'),
	(222339, 119, '2014-03-01 00:58:14.000000', 'temperatura', 978.0000, 'ºC'),
	(222340, 119, '2014-03-01 00:58:15.000000', 'temperatura', 770.0000, 'ºC'),
	(222341, 119, '2014-03-01 00:58:16.000000', 'temperatura', 916.0000, 'ºC'),
	(222342, 119, '2014-03-01 00:58:17.000000', 'temperatura', 1071.0000, 'ºC'),
	(222343, 119, '2014-03-01 00:58:18.000000', 'temperatura', 209.0000, 'ºC'),
	(222344, 119, '2014-03-01 00:58:19.000000', 'temperatura', 229.0000, 'ºC'),
	(222345, 119, '2014-03-01 00:58:20.000000', 'temperatura', 522.0000, 'ºC'),
	(222346, 119, '2014-03-01 00:58:21.000000', 'temperatura', 724.0000, 'ºC'),
	(222347, 119, '2014-03-01 00:58:22.000000', 'temperatura', 851.0000, 'ºC'),
	(222348, 119, '2014-03-01 00:58:23.000000', 'temperatura', 887.0000, 'ºC'),
	(222349, 119, '2014-03-01 00:58:24.000000', 'temperatura', 679.0000, 'ºC'),
	(222350, 119, '2014-03-01 00:58:25.000000', 'temperatura', 737.0000, 'ºC'),
	(222351, 119, '2014-03-01 00:58:26.000000', 'temperatura', 449.0000, 'ºC'),
	(222352, 119, '2014-03-01 00:58:27.000000', 'temperatura', 33.0000, 'ºC'),
	(222353, 119, '2014-03-01 00:58:28.000000', 'temperatura', 19.0000, 'ºC'),
	(222354, 119, '2014-03-01 00:58:29.000000', 'temperatura', 1197.0000, 'ºC'),
	(222355, 119, '2014-03-01 00:58:30.000000', 'temperatura', 1127.0000, 'ºC'),
	(222356, 119, '2014-03-01 00:58:31.000000', 'temperatura', 846.0000, 'ºC'),
	(222357, 119, '2014-03-01 00:58:32.000000', 'temperatura', 848.0000, 'ºC'),
	(222358, 119, '2014-03-01 00:58:33.000000', 'temperatura', 501.0000, 'ºC'),
	(222359, 119, '2014-03-01 00:58:34.000000', 'temperatura', 1163.0000, 'ºC'),
	(222360, 119, '2014-03-01 00:58:35.000000', 'temperatura', 715.0000, 'ºC'),
	(222361, 119, '2014-03-01 00:58:36.000000', 'temperatura', 83.0000, 'ºC'),
	(222362, 119, '2014-03-01 00:58:37.000000', 'temperatura', 671.0000, 'ºC'),
	(222363, 119, '2014-03-01 00:58:38.000000', 'temperatura', 708.0000, 'ºC'),
	(222364, 119, '2014-03-01 00:58:39.000000', 'temperatura', 326.0000, 'ºC'),
	(222365, 119, '2014-03-01 00:58:40.000000', 'temperatura', 708.0000, 'ºC'),
	(222366, 119, '2014-03-01 00:58:41.000000', 'temperatura', 160.0000, 'ºC'),
	(222367, 119, '2014-03-01 00:58:42.000000', 'temperatura', 1077.0000, 'ºC'),
	(222368, 119, '2014-03-01 00:58:43.000000', 'temperatura', 107.0000, 'ºC'),
	(222369, 119, '2014-03-01 00:58:44.000000', 'temperatura', 904.0000, 'ºC'),
	(222370, 119, '2014-03-01 00:58:45.000000', 'temperatura', 600.0000, 'ºC'),
	(222371, 119, '2014-03-01 00:58:46.000000', 'temperatura', 290.0000, 'ºC'),
	(222372, 119, '2014-03-01 00:58:47.000000', 'temperatura', 849.0000, 'ºC'),
	(222373, 119, '2014-03-01 00:58:48.000000', 'temperatura', 976.0000, 'ºC'),
	(222374, 119, '2014-03-01 00:58:49.000000', 'temperatura', 1133.0000, 'ºC'),
	(222375, 119, '2014-03-01 00:58:50.000000', 'temperatura', 336.0000, 'ºC'),
	(222376, 119, '2014-03-01 00:58:51.000000', 'temperatura', 681.0000, 'ºC'),
	(222377, 119, '2014-03-01 00:58:52.000000', 'temperatura', 1198.0000, 'ºC'),
	(222378, 119, '2014-03-01 00:58:53.000000', 'temperatura', 347.0000, 'ºC'),
	(222379, 119, '2014-03-01 00:58:54.000000', 'temperatura', 544.0000, 'ºC'),
	(222380, 119, '2014-03-01 00:58:55.000000', 'temperatura', 476.0000, 'ºC'),
	(222381, 119, '2014-03-01 00:58:56.000000', 'temperatura', 751.0000, 'ºC'),
	(222382, 119, '2014-03-01 00:58:57.000000', 'temperatura', 1126.0000, 'ºC'),
	(222383, 119, '2014-03-01 00:58:58.000000', 'temperatura', 979.0000, 'ºC'),
	(222384, 119, '2014-03-01 00:58:59.000000', 'temperatura', 317.0000, 'ºC'),
	(222385, 119, '2014-03-01 00:59:00.000000', 'temperatura', 1048.0000, 'ºC'),
	(222386, 119, '2014-03-01 00:59:01.000000', 'temperatura', 691.0000, 'ºC'),
	(222387, 119, '2014-03-01 00:59:02.000000', 'temperatura', 311.0000, 'ºC'),
	(222388, 119, '2014-03-01 00:59:03.000000', 'temperatura', 680.0000, 'ºC'),
	(222389, 119, '2014-03-01 00:59:04.000000', 'temperatura', 70.0000, 'ºC'),
	(222390, 119, '2014-03-01 00:59:05.000000', 'temperatura', 710.0000, 'ºC'),
	(222391, 119, '2014-03-01 00:59:06.000000', 'temperatura', 942.0000, 'ºC'),
	(222392, 119, '2014-03-01 00:59:07.000000', 'temperatura', 181.0000, 'ºC'),
	(222393, 119, '2014-03-01 00:59:08.000000', 'temperatura', 477.0000, 'ºC'),
	(222394, 119, '2014-03-01 00:59:09.000000', 'temperatura', 643.0000, 'ºC'),
	(222395, 119, '2014-03-01 00:59:10.000000', 'temperatura', 584.0000, 'ºC'),
	(222396, 119, '2014-03-01 00:59:11.000000', 'temperatura', 991.0000, 'ºC'),
	(222397, 119, '2014-03-01 00:59:12.000000', 'temperatura', 806.0000, 'ºC'),
	(222398, 119, '2014-03-01 00:59:13.000000', 'temperatura', 1057.0000, 'ºC'),
	(222399, 119, '2014-03-01 00:59:14.000000', 'temperatura', 468.0000, 'ºC'),
	(222400, 119, '2014-03-01 00:59:15.000000', 'temperatura', 370.0000, 'ºC'),
	(222401, 119, '2014-03-01 00:59:16.000000', 'temperatura', 444.0000, 'ºC'),
	(222402, 119, '2014-03-01 00:59:17.000000', 'temperatura', 1113.0000, 'ºC'),
	(222403, 119, '2014-03-01 00:59:18.000000', 'temperatura', 633.0000, 'ºC'),
	(222404, 119, '2014-03-01 00:59:19.000000', 'temperatura', 1025.0000, 'ºC'),
	(222405, 119, '2014-03-01 00:59:20.000000', 'temperatura', 827.0000, 'ºC'),
	(222406, 119, '2014-03-01 00:59:21.000000', 'temperatura', 1060.0000, 'ºC'),
	(222407, 119, '2014-03-01 00:59:22.000000', 'temperatura', 418.0000, 'ºC'),
	(222408, 119, '2014-03-01 00:59:23.000000', 'temperatura', 113.0000, 'ºC'),
	(222409, 119, '2014-03-01 00:59:24.000000', 'temperatura', 510.0000, 'ºC'),
	(222410, 119, '2014-03-01 00:59:25.000000', 'temperatura', 1014.0000, 'ºC'),
	(222411, 119, '2014-03-01 00:59:26.000000', 'temperatura', 1137.0000, 'ºC'),
	(222412, 119, '2014-03-01 00:59:27.000000', 'temperatura', 245.0000, 'ºC'),
	(222413, 119, '2014-03-01 00:59:28.000000', 'temperatura', 215.0000, 'ºC'),
	(222414, 119, '2014-03-01 00:59:29.000000', 'temperatura', 340.0000, 'ºC'),
	(222415, 119, '2014-03-01 00:59:30.000000', 'temperatura', 1057.0000, 'ºC'),
	(222416, 119, '2014-03-01 00:59:31.000000', 'temperatura', 663.0000, 'ºC'),
	(222417, 119, '2014-03-01 00:59:32.000000', 'temperatura', 145.0000, 'ºC'),
	(222418, 119, '2014-03-01 00:59:33.000000', 'temperatura', 1136.0000, 'ºC'),
	(222419, 119, '2014-03-01 00:59:34.000000', 'temperatura', 445.0000, 'ºC'),
	(222420, 119, '2014-03-01 00:59:35.000000', 'temperatura', 20.0000, 'ºC'),
	(222421, 119, '2014-03-01 00:59:36.000000', 'temperatura', 1162.0000, 'ºC'),
	(222422, 119, '2014-03-01 00:59:37.000000', 'temperatura', 954.0000, 'ºC'),
	(222423, 119, '2014-03-01 00:59:38.000000', 'temperatura', 84.0000, 'ºC'),
	(222424, 119, '2014-03-01 00:59:39.000000', 'temperatura', 1157.0000, 'ºC'),
	(222425, 119, '2014-03-01 00:59:40.000000', 'temperatura', 732.0000, 'ºC'),
	(222426, 119, '2014-03-01 00:59:41.000000', 'temperatura', 193.0000, 'ºC'),
	(222427, 119, '2014-03-01 00:59:42.000000', 'temperatura', 1169.0000, 'ºC'),
	(222428, 119, '2014-03-01 00:59:43.000000', 'temperatura', 464.0000, 'ºC'),
	(222429, 119, '2014-03-01 00:59:44.000000', 'temperatura', 15.0000, 'ºC'),
	(222430, 119, '2014-03-01 00:59:45.000000', 'temperatura', 1081.0000, 'ºC'),
	(222431, 119, '2014-03-01 00:59:46.000000', 'temperatura', 563.0000, 'ºC'),
	(222432, 119, '2014-03-01 00:59:47.000000', 'temperatura', 773.0000, 'ºC'),
	(222433, 119, '2014-03-01 00:59:48.000000', 'temperatura', 978.0000, 'ºC'),
	(222434, 119, '2014-03-01 00:59:49.000000', 'temperatura', 168.0000, 'ºC'),
	(222435, 119, '2014-03-01 00:59:50.000000', 'temperatura', 310.0000, 'ºC'),
	(222436, 119, '2014-03-01 00:59:51.000000', 'temperatura', 1044.0000, 'ºC'),
	(222437, 119, '2014-03-01 00:59:52.000000', 'temperatura', 693.0000, 'ºC'),
	(222438, 119, '2014-03-01 00:59:53.000000', 'temperatura', 333.0000, 'ºC'),
	(222439, 119, '2014-03-01 00:59:54.000000', 'temperatura', 787.0000, 'ºC'),
	(222440, 119, '2014-03-01 00:59:55.000000', 'temperatura', 536.0000, 'ºC'),
	(222441, 119, '2014-03-01 00:59:56.000000', 'temperatura', 320.0000, 'ºC'),
	(222442, 119, '2014-03-01 00:59:57.000000', 'temperatura', 1191.0000, 'ºC'),
	(222443, 119, '2014-03-01 00:59:58.000000', 'temperatura', 197.0000, 'ºC'),
	(222444, 119, '2014-03-01 00:59:59.000000', 'temperatura', 1010.0000, 'ºC'),
	(222445, 119, '2014-03-01 01:00:00.000000', 'temperatura', 861.0000, 'ºC'),
	(222446, 119, '2014-03-01 01:00:01.000000', 'temperatura', 75.0000, 'ºC'),
	(222447, 119, '2014-03-01 01:00:02.000000', 'temperatura', 192.0000, 'ºC'),
	(222448, 119, '2014-03-01 01:00:03.000000', 'temperatura', 734.0000, 'ºC'),
	(222449, 119, '2014-03-01 01:00:04.000000', 'temperatura', 697.0000, 'ºC'),
	(222450, 119, '2014-03-01 01:00:05.000000', 'temperatura', 81.0000, 'ºC'),
	(222451, 119, '2014-03-01 01:00:06.000000', 'temperatura', 717.0000, 'ºC'),
	(222452, 119, '2014-03-01 01:00:07.000000', 'temperatura', 940.0000, 'ºC'),
	(222453, 119, '2014-03-01 01:00:08.000000', 'temperatura', 152.0000, 'ºC'),
	(222454, 119, '2014-03-01 01:00:09.000000', 'temperatura', 342.0000, 'ºC'),
	(222455, 119, '2014-03-01 01:00:10.000000', 'temperatura', 51.0000, 'ºC'),
	(222456, 119, '2014-03-01 01:00:11.000000', 'temperatura', 433.0000, 'ºC'),
	(222457, 119, '2014-03-01 01:00:12.000000', 'temperatura', 809.0000, 'ºC'),
	(222458, 119, '2014-03-01 01:00:13.000000', 'temperatura', 348.0000, 'ºC'),
	(222459, 119, '2014-03-01 01:00:14.000000', 'temperatura', 514.0000, 'ºC'),
	(222460, 119, '2014-03-01 01:00:15.000000', 'temperatura', 325.0000, 'ºC'),
	(222461, 119, '2014-03-01 01:00:16.000000', 'temperatura', 84.0000, 'ºC'),
	(222462, 119, '2014-03-01 01:00:17.000000', 'temperatura', 647.0000, 'ºC'),
	(222463, 119, '2014-03-01 01:00:18.000000', 'temperatura', 583.0000, 'ºC'),
	(222464, 119, '2014-03-01 01:00:19.000000', 'temperatura', 976.0000, 'ºC'),
	(222465, 119, '2014-03-01 01:00:20.000000', 'temperatura', 730.0000, 'ºC'),
	(222466, 119, '2014-03-01 01:00:21.000000', 'temperatura', 724.0000, 'ºC'),
	(222467, 119, '2014-03-01 01:00:22.000000', 'temperatura', 230.0000, 'ºC'),
	(222468, 119, '2014-03-01 01:00:23.000000', 'temperatura', 177.0000, 'ºC'),
	(222469, 119, '2014-03-01 01:00:24.000000', 'temperatura', 195.0000, 'ºC'),
	(222470, 119, '2014-03-01 01:00:25.000000', 'temperatura', 444.0000, 'ºC'),
	(222471, 119, '2014-03-01 01:00:26.000000', 'temperatura', 437.0000, 'ºC'),
	(222472, 119, '2014-03-01 01:00:27.000000', 'temperatura', 853.0000, 'ºC'),
	(222473, 119, '2014-03-01 01:00:28.000000', 'temperatura', 554.0000, 'ºC'),
	(222474, 119, '2014-03-01 01:00:29.000000', 'temperatura', 212.0000, 'ºC'),
	(222475, 119, '2014-03-01 01:00:30.000000', 'temperatura', 598.0000, 'ºC'),
	(222476, 119, '2014-03-01 01:00:31.000000', 'temperatura', 1157.0000, 'ºC'),
	(222477, 119, '2014-03-01 01:00:32.000000', 'temperatura', 389.0000, 'ºC'),
	(222478, 119, '2014-03-01 01:00:33.000000', 'temperatura', 874.0000, 'ºC'),
	(222479, 119, '2014-03-01 01:00:34.000000', 'temperatura', 805.0000, 'ºC'),
	(222480, 119, '2014-03-01 01:00:35.000000', 'temperatura', 205.0000, 'ºC'),
	(222481, 119, '2014-03-01 01:00:36.000000', 'temperatura', 1009.0000, 'ºC'),
	(222482, 119, '2014-03-01 01:00:37.000000', 'temperatura', 833.0000, 'ºC'),
	(222483, 119, '2014-03-01 01:00:38.000000', 'temperatura', 1135.0000, 'ºC'),
	(222484, 119, '2014-03-01 01:00:39.000000', 'temperatura', 779.0000, 'ºC'),
	(222485, 119, '2014-03-01 01:00:40.000000', 'temperatura', 491.0000, 'ºC'),
	(222486, 119, '2014-03-01 01:00:41.000000', 'temperatura', 116.0000, 'ºC'),
	(222487, 119, '2014-03-01 01:00:42.000000', 'temperatura', 307.0000, 'ºC'),
	(222488, 119, '2014-03-01 01:00:43.000000', 'temperatura', 1189.0000, 'ºC'),
	(222489, 119, '2014-03-01 01:00:44.000000', 'temperatura', 224.0000, 'ºC'),
	(222490, 119, '2014-03-01 01:00:45.000000', 'temperatura', 1153.0000, 'ºC'),
	(222491, 119, '2014-03-01 01:00:46.000000', 'temperatura', 294.0000, 'ºC'),
	(222492, 119, '2014-03-01 01:00:47.000000', 'temperatura', 410.0000, 'ºC'),
	(222493, 119, '2014-03-01 01:00:48.000000', 'temperatura', 1170.0000, 'ºC'),
	(222494, 119, '2014-03-01 01:00:49.000000', 'temperatura', 1022.0000, 'ºC'),
	(222495, 119, '2014-03-01 01:00:50.000000', 'temperatura', 398.0000, 'ºC'),
	(222496, 119, '2014-03-01 01:00:51.000000', 'temperatura', 126.0000, 'ºC'),
	(222497, 119, '2014-03-01 01:00:52.000000', 'temperatura', 635.0000, 'ºC'),
	(222498, 119, '2014-03-01 01:00:53.000000', 'temperatura', 397.0000, 'ºC'),
	(222499, 119, '2014-03-01 01:00:54.000000', 'temperatura', 80.0000, 'ºC'),
	(222500, 119, '2014-03-01 01:00:55.000000', 'temperatura', 409.0000, 'ºC'),
	(222501, 119, '2014-03-01 01:00:56.000000', 'temperatura', 605.0000, 'ºC'),
	(222502, 119, '2014-03-01 01:00:57.000000', 'temperatura', 601.0000, 'ºC'),
	(222503, 119, '2014-03-01 01:00:58.000000', 'temperatura', 1188.0000, 'ºC'),
	(222504, 119, '2014-03-01 01:00:59.000000', 'temperatura', 540.0000, 'ºC'),
	(222505, 119, '2014-03-01 01:01:00.000000', 'temperatura', 335.0000, 'ºC'),
	(222506, 119, '2014-03-01 01:01:01.000000', 'temperatura', 56.0000, 'ºC'),
	(222507, 119, '2014-03-01 01:01:02.000000', 'temperatura', 476.0000, 'ºC'),
	(222508, 119, '2014-03-01 01:01:03.000000', 'temperatura', 1011.0000, 'ºC'),
	(222509, 119, '2014-03-01 01:01:04.000000', 'temperatura', 26.0000, 'ºC'),
	(222510, 119, '2014-03-01 01:01:05.000000', 'temperatura', 700.0000, 'ºC'),
	(222511, 119, '2014-03-01 01:01:06.000000', 'temperatura', 1024.0000, 'ºC'),
	(222512, 119, '2014-03-01 01:01:07.000000', 'temperatura', 618.0000, 'ºC'),
	(222513, 119, '2014-03-01 01:01:08.000000', 'temperatura', 21.0000, 'ºC'),
	(222514, 119, '2014-03-01 01:01:09.000000', 'temperatura', 650.0000, 'ºC'),
	(222515, 119, '2014-03-01 01:01:10.000000', 'temperatura', 786.0000, 'ºC'),
	(222516, 119, '2014-03-01 01:01:11.000000', 'temperatura', 782.0000, 'ºC'),
	(222517, 119, '2014-03-01 01:01:12.000000', 'temperatura', 354.0000, 'ºC'),
	(222518, 119, '2014-03-01 01:01:13.000000', 'temperatura', 624.0000, 'ºC'),
	(222519, 119, '2014-03-01 01:01:14.000000', 'temperatura', 856.0000, 'ºC'),
	(222520, 119, '2014-03-01 01:01:15.000000', 'temperatura', 11.0000, 'ºC'),
	(222521, 119, '2014-03-01 01:01:16.000000', 'temperatura', 1086.0000, 'ºC'),
	(222522, 119, '2014-03-01 01:01:17.000000', 'temperatura', 600.0000, 'ºC'),
	(222523, 119, '2014-03-01 01:01:18.000000', 'temperatura', 940.0000, 'ºC'),
	(222524, 119, '2014-03-01 01:01:19.000000', 'temperatura', 501.0000, 'ºC'),
	(222525, 119, '2014-03-01 01:01:20.000000', 'temperatura', 887.0000, 'ºC'),
	(222526, 119, '2014-03-01 01:01:21.000000', 'temperatura', 531.0000, 'ºC'),
	(222527, 119, '2014-03-01 01:01:22.000000', 'temperatura', 1193.0000, 'ºC'),
	(222528, 119, '2014-03-01 01:01:23.000000', 'temperatura', 775.0000, 'ºC'),
	(222529, 119, '2014-03-01 01:01:24.000000', 'temperatura', 294.0000, 'ºC'),
	(222530, 119, '2014-03-01 01:01:25.000000', 'temperatura', 348.0000, 'ºC'),
	(222531, 119, '2014-03-01 01:01:26.000000', 'temperatura', 858.0000, 'ºC'),
	(222532, 119, '2014-03-01 01:01:27.000000', 'temperatura', 845.0000, 'ºC'),
	(222533, 119, '2014-03-01 01:01:28.000000', 'temperatura', 452.0000, 'ºC'),
	(222534, 119, '2014-03-01 01:01:29.000000', 'temperatura', 926.0000, 'ºC'),
	(222535, 119, '2014-03-01 01:01:30.000000', 'temperatura', 876.0000, 'ºC'),
	(222536, 119, '2014-03-01 01:01:31.000000', 'temperatura', 402.0000, 'ºC'),
	(222537, 119, '2014-03-01 01:01:32.000000', 'temperatura', 583.0000, 'ºC'),
	(222538, 119, '2014-03-01 01:01:33.000000', 'temperatura', 510.0000, 'ºC'),
	(222539, 119, '2014-03-01 01:01:34.000000', 'temperatura', 799.0000, 'ºC'),
	(222540, 119, '2014-03-01 01:01:35.000000', 'temperatura', 66.0000, 'ºC'),
	(222541, 119, '2014-03-01 01:01:36.000000', 'temperatura', 333.0000, 'ºC'),
	(222542, 119, '2014-03-01 01:01:37.000000', 'temperatura', 267.0000, 'ºC'),
	(222543, 119, '2014-03-01 01:01:38.000000', 'temperatura', 339.0000, 'ºC'),
	(222544, 119, '2014-03-01 01:01:39.000000', 'temperatura', 895.0000, 'ºC'),
	(222545, 119, '2014-03-01 01:01:40.000000', 'temperatura', 1056.0000, 'ºC'),
	(222546, 119, '2014-03-01 01:01:41.000000', 'temperatura', 199.0000, 'ºC'),
	(222547, 119, '2014-03-01 01:01:42.000000', 'temperatura', 224.0000, 'ºC'),
	(222548, 119, '2014-03-01 01:01:43.000000', 'temperatura', 523.0000, 'ºC'),
	(222549, 119, '2014-03-01 01:01:44.000000', 'temperatura', 746.0000, 'ºC'),
	(222550, 119, '2014-03-01 01:01:45.000000', 'temperatura', 962.0000, 'ºC'),
	(222551, 119, '2014-03-01 01:01:46.000000', 'temperatura', 173.0000, 'ºC'),
	(222552, 119, '2014-03-01 01:01:47.000000', 'temperatura', 379.0000, 'ºC'),
	(222553, 119, '2014-03-01 01:01:48.000000', 'temperatura', 176.0000, 'ºC'),
	(222554, 119, '2014-03-01 01:01:49.000000', 'temperatura', 942.0000, 'ºC'),
	(222555, 119, '2014-03-01 01:01:50.000000', 'temperatura', 584.0000, 'ºC'),
	(222556, 119, '2014-03-01 01:01:51.000000', 'temperatura', 94.0000, 'ºC'),
	(222557, 119, '2014-03-01 01:01:52.000000', 'temperatura', 1121.0000, 'ºC'),
	(222558, 119, '2014-03-01 01:01:53.000000', 'temperatura', 520.0000, 'ºC'),
	(222559, 119, '2014-03-01 01:01:54.000000', 'temperatura', 438.0000, 'ºC'),
	(222560, 119, '2014-03-01 01:01:55.000000', 'temperatura', 631.0000, 'ºC'),
	(222561, 119, '2014-03-01 01:01:56.000000', 'temperatura', 640.0000, 'ºC'),
	(222562, 119, '2014-03-01 01:01:57.000000', 'temperatura', 109.0000, 'ºC'),
	(222563, 119, '2014-03-01 01:01:58.000000', 'temperatura', 1027.0000, 'ºC'),
	(222564, 119, '2014-03-01 01:01:59.000000', 'temperatura', 6.0000, 'ºC'),
	(222565, 119, '2014-03-01 01:02:00.000000', 'temperatura', 550.0000, 'ºC'),
	(222566, 119, '2014-03-01 01:02:01.000000', 'temperatura', 331.0000, 'ºC'),
	(222567, 119, '2014-03-01 01:02:02.000000', 'temperatura', 5.0000, 'ºC'),
	(222568, 119, '2014-03-01 01:02:03.000000', 'temperatura', 235.0000, 'ºC'),
	(222569, 119, '2014-03-01 01:02:04.000000', 'temperatura', 1159.0000, 'ºC'),
	(222570, 119, '2014-03-01 01:02:05.000000', 'temperatura', 292.0000, 'ºC'),
	(222571, 119, '2014-03-01 01:02:06.000000', 'temperatura', 383.0000, 'ºC'),
	(222572, 119, '2014-03-01 01:02:07.000000', 'temperatura', 1037.0000, 'ºC'),
	(222573, 119, '2014-03-01 01:02:08.000000', 'temperatura', 439.0000, 'ºC'),
	(222574, 119, '2014-03-01 01:02:09.000000', 'temperatura', 285.0000, 'ºC'),
	(222575, 119, '2014-03-01 01:02:10.000000', 'temperatura', 109.0000, 'ºC'),
	(222576, 119, '2014-03-01 01:02:11.000000', 'temperatura', 890.0000, 'ºC'),
	(222577, 119, '2014-03-01 01:02:12.000000', 'temperatura', 525.0000, 'ºC'),
	(222578, 119, '2014-03-01 01:02:13.000000', 'temperatura', 1154.0000, 'ºC'),
	(222579, 119, '2014-03-01 01:02:14.000000', 'temperatura', 598.0000, 'ºC'),
	(222580, 119, '2014-03-01 01:02:15.000000', 'temperatura', 726.0000, 'ºC'),
	(222581, 119, '2014-03-01 01:02:16.000000', 'temperatura', 635.0000, 'ºC'),
	(222582, 119, '2014-03-01 01:02:17.000000', 'temperatura', 1000.0000, 'ºC'),
	(222583, 119, '2014-03-01 01:02:18.000000', 'temperatura', 695.0000, 'ºC'),
	(222584, 119, '2014-03-01 01:02:19.000000', 'temperatura', 475.0000, 'ºC'),
	(222585, 119, '2014-03-01 01:02:20.000000', 'temperatura', 290.0000, 'ºC'),
	(222586, 119, '2014-03-01 01:02:21.000000', 'temperatura', 25.0000, 'ºC'),
	(222587, 119, '2014-03-01 01:02:22.000000', 'temperatura', 456.0000, 'ºC'),
	(222588, 119, '2014-03-01 01:02:23.000000', 'temperatura', 1005.0000, 'ºC'),
	(222589, 119, '2014-03-01 01:02:24.000000', 'temperatura', 58.0000, 'ºC'),
	(222590, 119, '2014-03-01 01:02:25.000000', 'temperatura', 874.0000, 'ºC'),
	(222591, 119, '2014-03-01 01:02:26.000000', 'temperatura', 597.0000, 'ºC'),
	(222592, 119, '2014-03-01 01:02:27.000000', 'temperatura', 366.0000, 'ºC'),
	(222593, 119, '2014-03-01 01:02:28.000000', 'temperatura', 37.0000, 'ºC'),
	(222594, 119, '2014-03-01 01:02:29.000000', 'temperatura', 289.0000, 'ºC'),
	(222595, 119, '2014-03-01 01:02:30.000000', 'temperatura', 134.0000, 'ºC'),
	(222596, 119, '2014-03-01 01:02:31.000000', 'temperatura', 1004.0000, 'ºC'),
	(222597, 119, '2014-03-01 01:02:32.000000', 'temperatura', 1018.0000, 'ºC'),
	(222598, 119, '2014-03-01 01:02:33.000000', 'temperatura', 878.0000, 'ºC'),
	(222599, 119, '2014-03-01 01:02:34.000000', 'temperatura', 136.0000, 'ºC'),
	(222600, 119, '2014-03-01 01:02:35.000000', 'temperatura', 449.0000, 'ºC'),
	(222601, 119, '2014-03-01 01:02:36.000000', 'temperatura', 636.0000, 'ºC'),
	(222602, 119, '2014-03-01 01:02:37.000000', 'temperatura', 632.0000, 'ºC'),
	(222603, 119, '2014-03-01 01:02:38.000000', 'temperatura', 55.0000, 'ºC'),
	(222604, 119, '2014-03-01 01:02:39.000000', 'temperatura', 778.0000, 'ºC'),
	(222605, 119, '2014-03-01 01:02:40.000000', 'temperatura', 124.0000, 'ºC'),
	(222606, 119, '2014-03-01 01:02:41.000000', 'temperatura', 688.0000, 'ºC'),
	(222607, 119, '2014-03-01 01:02:42.000000', 'temperatura', 668.0000, 'ºC'),
	(222608, 119, '2014-03-01 01:02:43.000000', 'temperatura', 78.0000, 'ºC'),
	(222609, 119, '2014-03-01 01:02:44.000000', 'temperatura', 786.0000, 'ºC'),
	(222610, 119, '2014-03-01 01:02:45.000000', 'temperatura', 96.0000, 'ºC'),
	(222611, 119, '2014-03-01 01:02:46.000000', 'temperatura', 521.0000, 'ºC'),
	(222612, 119, '2014-03-01 01:02:47.000000', 'temperatura', 1120.0000, 'ºC'),
	(222613, 119, '2014-03-01 01:02:48.000000', 'temperatura', 439.0000, 'ºC'),
	(222614, 119, '2014-03-01 01:02:49.000000', 'temperatura', 32.0000, 'ºC'),
	(222615, 119, '2014-03-01 01:02:50.000000', 'temperatura', 46.0000, 'ºC'),
	(222616, 119, '2014-03-01 01:02:51.000000', 'temperatura', 136.0000, 'ºC'),
	(222617, 119, '2014-03-01 01:02:52.000000', 'temperatura', 539.0000, 'ºC'),
	(222618, 119, '2014-03-01 01:02:53.000000', 'temperatura', 1089.0000, 'ºC'),
	(222619, 119, '2014-03-01 01:02:54.000000', 'temperatura', 230.0000, 'ºC'),
	(222620, 119, '2014-03-01 01:02:55.000000', 'temperatura', 281.0000, 'ºC'),
	(222621, 119, '2014-03-01 01:02:56.000000', 'temperatura', 715.0000, 'ºC'),
	(222622, 119, '2014-03-01 01:02:57.000000', 'temperatura', 334.0000, 'ºC'),
	(222623, 119, '2014-03-01 01:02:58.000000', 'temperatura', 725.0000, 'ºC'),
	(222624, 119, '2014-03-01 01:02:59.000000', 'temperatura', 222.0000, 'ºC'),
	(222625, 119, '2014-03-01 01:03:00.000000', 'temperatura', 137.0000, 'ºC'),
	(222626, 119, '2014-03-01 01:03:01.000000', 'temperatura', 20.0000, 'ºC'),
	(222627, 119, '2014-03-01 01:03:02.000000', 'temperatura', 891.0000, 'ºC'),
	(222628, 119, '2014-03-01 01:03:03.000000', 'temperatura', 794.0000, 'ºC'),
	(222629, 119, '2014-03-01 01:03:04.000000', 'temperatura', 97.0000, 'ºC'),
	(222630, 119, '2014-03-01 01:03:05.000000', 'temperatura', 503.0000, 'ºC'),
	(222631, 119, '2014-03-01 01:03:06.000000', 'temperatura', 1025.0000, 'ºC'),
	(222632, 119, '2014-03-01 01:03:07.000000', 'temperatura', 17.0000, 'ºC'),
	(222633, 119, '2014-03-01 01:03:08.000000', 'temperatura', 612.0000, 'ºC'),
	(222634, 119, '2014-03-01 01:03:09.000000', 'temperatura', 609.0000, 'ºC'),
	(222635, 119, '2014-03-01 01:03:10.000000', 'temperatura', 10.0000, 'ºC'),
	(222636, 119, '2014-03-01 01:03:11.000000', 'temperatura', 624.0000, 'ºC'),
	(222637, 119, '2014-03-01 01:03:12.000000', 'temperatura', 690.0000, 'ºC'),
	(222638, 119, '2014-03-01 01:03:13.000000', 'temperatura', 376.0000, 'ºC'),
	(222639, 119, '2014-03-01 01:03:14.000000', 'temperatura', 1014.0000, 'ºC'),
	(222640, 119, '2014-03-01 01:03:15.000000', 'temperatura', 341.0000, 'ºC'),
	(222641, 119, '2014-03-01 01:03:16.000000', 'temperatura', 1063.0000, 'ºC'),
	(222642, 119, '2014-03-01 01:03:17.000000', 'temperatura', 691.0000, 'ºC'),
	(222643, 119, '2014-03-01 01:03:18.000000', 'temperatura', 267.0000, 'ºC'),
	(222644, 119, '2014-03-01 01:03:19.000000', 'temperatura', 464.0000, 'ºC'),
	(222645, 119, '2014-03-01 01:03:20.000000', 'temperatura', 318.0000, 'ºC'),
	(222646, 119, '2014-03-01 01:03:21.000000', 'temperatura', 198.0000, 'ºC'),
	(222647, 119, '2014-03-01 01:03:22.000000', 'temperatura', 37.0000, 'ºC'),
	(222648, 119, '2014-03-01 01:03:23.000000', 'temperatura', 791.0000, 'ºC'),
	(222649, 119, '2014-03-01 01:03:24.000000', 'temperatura', 245.0000, 'ºC'),
	(222650, 119, '2014-03-01 01:03:25.000000', 'temperatura', 54.0000, 'ºC'),
	(222651, 119, '2014-03-01 01:03:26.000000', 'temperatura', 733.0000, 'ºC'),
	(222652, 119, '2014-03-01 01:03:27.000000', 'temperatura', 1105.0000, 'ºC'),
	(222653, 119, '2014-03-01 01:03:28.000000', 'temperatura', 925.0000, 'ºC'),
	(222654, 119, '2014-03-01 01:03:29.000000', 'temperatura', 111.0000, 'ºC'),
	(222655, 119, '2014-03-01 01:03:30.000000', 'temperatura', 180.0000, 'ºC'),
	(222656, 119, '2014-03-01 01:03:31.000000', 'temperatura', 570.0000, 'ºC'),
	(222657, 119, '2014-03-01 01:03:32.000000', 'temperatura', 1109.0000, 'ºC'),
	(222658, 119, '2014-03-01 01:03:33.000000', 'temperatura', 237.0000, 'ºC'),
	(222659, 119, '2014-03-01 01:03:34.000000', 'temperatura', 257.0000, 'ºC'),
	(222660, 119, '2014-03-01 01:03:35.000000', 'temperatura', 576.0000, 'ºC'),
	(222661, 119, '2014-03-01 01:03:36.000000', 'temperatura', 909.0000, 'ºC'),
	(222662, 119, '2014-03-01 01:03:37.000000', 'temperatura', 416.0000, 'ºC'),
	(222663, 119, '2014-03-01 01:03:38.000000', 'temperatura', 554.0000, 'ºC'),
	(222664, 119, '2014-03-01 01:03:39.000000', 'temperatura', 325.0000, 'ºC'),
	(222665, 119, '2014-03-01 01:03:40.000000', 'temperatura', 1161.0000, 'ºC'),
	(222666, 119, '2014-03-01 01:03:41.000000', 'temperatura', 30.0000, 'ºC'),
	(222667, 119, '2014-03-01 01:03:42.000000', 'temperatura', 268.0000, 'ºC'),
	(222668, 119, '2014-03-01 01:03:43.000000', 'temperatura', 49.0000, 'ºC'),
	(222669, 119, '2014-03-01 01:03:44.000000', 'temperatura', 642.0000, 'ºC'),
	(222670, 119, '2014-03-01 01:03:45.000000', 'temperatura', 663.0000, 'ºC'),
	(222671, 119, '2014-03-01 01:03:46.000000', 'temperatura', 189.0000, 'ºC'),
	(222672, 119, '2014-03-01 01:03:47.000000', 'temperatura', 159.0000, 'ºC'),
	(222673, 119, '2014-03-01 01:03:48.000000', 'temperatura', 229.0000, 'ºC'),
	(222674, 119, '2014-03-01 01:03:49.000000', 'temperatura', 667.0000, 'ºC'),
	(222675, 119, '2014-03-01 01:03:50.000000', 'temperatura', 248.0000, 'ºC'),
	(222676, 119, '2014-03-01 01:03:51.000000', 'temperatura', 439.0000, 'ºC'),
	(222677, 119, '2014-03-01 01:03:52.000000', 'temperatura', 254.0000, 'ºC'),
	(222678, 119, '2014-03-01 01:03:53.000000', 'temperatura', 1151.0000, 'ºC'),
	(222679, 119, '2014-03-01 01:03:54.000000', 'temperatura', 192.0000, 'ºC'),
	(222680, 119, '2014-03-01 01:03:55.000000', 'temperatura', 1110.0000, 'ºC'),
	(222681, 119, '2014-03-01 01:03:56.000000', 'temperatura', 176.0000, 'ºC'),
	(222682, 119, '2014-03-01 01:03:57.000000', 'temperatura', 1148.0000, 'ºC'),
	(222683, 119, '2014-03-01 01:03:58.000000', 'temperatura', 412.0000, 'ºC'),
	(222684, 119, '2014-03-01 01:03:59.000000', 'temperatura', 1017.0000, 'ºC'),
	(222685, 119, '2014-03-01 01:04:00.000000', 'temperatura', 248.0000, 'ºC'),
	(222686, 119, '2014-03-01 01:04:01.000000', 'temperatura', 591.0000, 'ºC'),
	(222687, 119, '2014-03-01 01:04:02.000000', 'temperatura', 1011.0000, 'ºC'),
	(222688, 119, '2014-03-01 01:04:03.000000', 'temperatura', 883.0000, 'ºC'),
	(222689, 119, '2014-03-01 01:04:04.000000', 'temperatura', 183.0000, 'ºC'),
	(222690, 119, '2014-03-01 01:04:05.000000', 'temperatura', 667.0000, 'ºC'),
	(222691, 119, '2014-03-01 01:04:06.000000', 'temperatura', 384.0000, 'ºC'),
	(222692, 119, '2014-03-01 01:04:07.000000', 'temperatura', 1122.0000, 'ºC'),
	(222693, 119, '2014-03-01 01:04:08.000000', 'temperatura', 859.0000, 'ºC'),
	(222694, 119, '2014-03-01 01:04:09.000000', 'temperatura', 929.0000, 'ºC'),
	(222695, 119, '2014-03-01 01:04:10.000000', 'temperatura', 867.0000, 'ºC'),
	(222696, 119, '2014-03-01 01:04:11.000000', 'temperatura', 350.0000, 'ºC'),
	(222697, 119, '2014-03-01 01:04:12.000000', 'temperatura', 349.0000, 'ºC'),
	(222698, 119, '2014-03-01 01:04:13.000000', 'temperatura', 693.0000, 'ºC'),
	(222699, 119, '2014-03-01 01:04:14.000000', 'temperatura', 22.0000, 'ºC'),
	(222700, 119, '2014-03-01 01:04:15.000000', 'temperatura', 430.0000, 'ºC'),
	(222701, 119, '2014-03-01 01:04:16.000000', 'temperatura', 884.0000, 'ºC'),
	(222702, 119, '2014-03-01 01:04:17.000000', 'temperatura', 729.0000, 'ºC'),
	(222703, 119, '2014-03-01 01:04:18.000000', 'temperatura', 997.0000, 'ºC'),
	(222704, 119, '2014-03-01 01:04:19.000000', 'temperatura', 397.0000, 'ºC'),
	(222705, 119, '2014-03-01 01:04:20.000000', 'temperatura', 193.0000, 'ºC'),
	(222706, 119, '2014-03-01 01:04:21.000000', 'temperatura', 977.0000, 'ºC'),
	(222707, 119, '2014-03-01 01:04:22.000000', 'temperatura', 705.0000, 'ºC'),
	(222708, 119, '2014-03-01 01:04:23.000000', 'temperatura', 596.0000, 'ºC'),
	(222709, 119, '2014-03-01 01:04:24.000000', 'temperatura', 863.0000, 'ºC'),
	(222710, 119, '2014-03-01 01:04:25.000000', 'temperatura', 129.0000, 'ºC'),
	(222711, 119, '2014-03-01 01:04:26.000000', 'temperatura', 456.0000, 'ºC'),
	(222712, 119, '2014-03-01 01:04:27.000000', 'temperatura', 694.0000, 'ºC'),
	(222713, 119, '2014-03-01 01:04:28.000000', 'temperatura', 900.0000, 'ºC'),
	(222714, 119, '2014-03-01 01:04:29.000000', 'temperatura', 21.0000, 'ºC'),
	(222715, 119, '2014-03-01 01:04:30.000000', 'temperatura', 1006.0000, 'ºC'),
	(222716, 119, '2014-03-01 01:04:31.000000', 'temperatura', 168.0000, 'ºC'),
	(222717, 119, '2014-03-01 01:04:32.000000', 'temperatura', 221.0000, 'ºC'),
	(222718, 119, '2014-03-01 01:04:33.000000', 'temperatura', 602.0000, 'ºC'),
	(222719, 119, '2014-03-01 01:04:34.000000', 'temperatura', 1148.0000, 'ºC'),
	(222720, 119, '2014-03-01 01:04:35.000000', 'temperatura', 333.0000, 'ºC'),
	(222721, 119, '2014-03-01 01:04:36.000000', 'temperatura', 624.0000, 'ºC'),
	(222722, 119, '2014-03-01 01:04:37.000000', 'temperatura', 919.0000, 'ºC'),
	(222723, 119, '2014-03-01 01:04:38.000000', 'temperatura', 325.0000, 'ºC'),
	(222724, 119, '2014-03-01 01:04:39.000000', 'temperatura', 67.0000, 'ºC'),
	(222725, 119, '2014-03-01 01:04:40.000000', 'temperatura', 560.0000, 'ºC'),
	(222726, 119, '2014-03-01 01:04:41.000000', 'temperatura', 200.0000, 'ºC'),
	(222727, 119, '2014-03-01 01:04:42.000000', 'temperatura', 521.0000, 'ºC'),
	(222728, 119, '2014-03-01 01:04:43.000000', 'temperatura', 805.0000, 'ºC'),
	(222729, 119, '2014-03-01 01:04:44.000000', 'temperatura', 63.0000, 'ºC'),
	(222730, 119, '2014-03-01 01:04:45.000000', 'temperatura', 300.0000, 'ºC'),
	(222731, 119, '2014-03-01 01:04:46.000000', 'temperatura', 110.0000, 'ºC'),
	(222732, 119, '2014-03-01 01:04:47.000000', 'temperatura', 852.0000, 'ºC'),
	(222733, 119, '2014-03-01 01:04:48.000000', 'temperatura', 332.0000, 'ºC'),
	(222734, 119, '2014-03-01 01:04:49.000000', 'temperatura', 302.0000, 'ºC'),
	(222735, 119, '2014-03-01 01:04:50.000000', 'temperatura', 514.0000, 'ºC'),
	(222736, 119, '2014-03-01 01:04:51.000000', 'temperatura', 466.0000, 'ºC'),
	(222737, 119, '2014-03-01 01:04:52.000000', 'temperatura', 788.0000, 'ºC'),
	(222738, 119, '2014-03-01 01:04:53.000000', 'temperatura', 142.0000, 'ºC'),
	(222739, 119, '2014-03-01 01:04:54.000000', 'temperatura', 748.0000, 'ºC'),
	(222740, 119, '2014-03-01 01:04:55.000000', 'temperatura', 912.0000, 'ºC'),
	(222741, 119, '2014-03-01 01:04:56.000000', 'temperatura', 1119.0000, 'ºC'),
	(222742, 119, '2014-03-01 01:04:57.000000', 'temperatura', 458.0000, 'ºC'),
	(222743, 119, '2014-03-01 01:04:58.000000', 'temperatura', 132.0000, 'ºC'),
	(222744, 119, '2014-03-01 01:04:59.000000', 'temperatura', 488.0000, 'ºC'),
	(222745, 119, '2014-03-01 01:05:00.000000', 'temperatura', 845.0000, 'ºC'),
	(222746, 119, '2014-03-01 01:05:01.000000', 'temperatura', 360.0000, 'ºC'),
	(222747, 119, '2014-03-01 01:05:02.000000', 'temperatura', 466.0000, 'ºC'),
	(222748, 119, '2014-03-01 01:05:03.000000', 'temperatura', 49.0000, 'ºC'),
	(222749, 119, '2014-03-01 01:05:04.000000', 'temperatura', 50.0000, 'ºC'),
	(222750, 119, '2014-03-01 01:05:05.000000', 'temperatura', 102.0000, 'ºC'),
	(222751, 119, '2014-03-01 01:05:06.000000', 'temperatura', 361.0000, 'ºC'),
	(222752, 119, '2014-03-01 01:05:07.000000', 'temperatura', 298.0000, 'ºC'),
	(222753, 119, '2014-03-01 01:05:08.000000', 'temperatura', 411.0000, 'ºC'),
	(222754, 119, '2014-03-01 01:05:09.000000', 'temperatura', 1158.0000, 'ºC'),
	(222755, 119, '2014-03-01 01:05:10.000000', 'temperatura', 960.0000, 'ºC'),
	(222756, 119, '2014-03-01 01:05:11.000000', 'temperatura', 124.0000, 'ºC'),
	(222757, 119, '2014-03-01 01:05:12.000000', 'temperatura', 140.0000, 'ºC'),
	(222758, 119, '2014-03-01 01:05:13.000000', 'temperatura', 328.0000, 'ºC'),
	(222759, 119, '2014-03-01 01:05:14.000000', 'temperatura', 23.0000, 'ºC'),
	(222760, 119, '2014-03-01 01:05:15.000000', 'temperatura', 329.0000, 'ºC'),
	(222761, 119, '2014-03-01 01:05:16.000000', 'temperatura', 377.0000, 'ºC'),
	(222762, 119, '2014-03-01 01:05:17.000000', 'temperatura', 898.0000, 'ºC'),
	(222763, 119, '2014-03-01 01:05:18.000000', 'temperatura', 959.0000, 'ºC'),
	(222764, 119, '2014-03-01 01:05:19.000000', 'temperatura', 901.0000, 'ºC'),
	(222765, 119, '2014-03-01 01:05:20.000000', 'temperatura', 428.0000, 'ºC'),
	(222766, 119, '2014-03-01 01:05:21.000000', 'temperatura', 638.0000, 'ºC'),
	(222767, 119, '2014-03-01 01:05:22.000000', 'temperatura', 705.0000, 'ºC'),
	(222768, 119, '2014-03-01 01:05:23.000000', 'temperatura', 414.0000, 'ºC'),
	(222769, 119, '2014-03-01 01:05:24.000000', 'temperatura', 1154.0000, 'ºC'),
	(222770, 119, '2014-03-01 01:05:25.000000', 'temperatura', 927.0000, 'ºC'),
	(222771, 119, '2014-03-01 01:05:26.000000', 'temperatura', 1176.0000, 'ºC'),
	(222772, 119, '2014-03-01 01:05:27.000000', 'temperatura', 700.0000, 'ºC'),
	(222773, 119, '2014-03-01 01:05:28.000000', 'temperatura', 1172.0000, 'ºC'),
	(222774, 119, '2014-03-01 01:05:29.000000', 'temperatura', 159.0000, 'ºC'),
	(222775, 119, '2014-03-01 01:05:30.000000', 'temperatura', 882.0000, 'ºC'),
	(222776, 119, '2014-03-01 01:05:31.000000', 'temperatura', 332.0000, 'ºC'),
	(222777, 119, '2014-03-01 01:05:32.000000', 'temperatura', 213.0000, 'ºC'),
	(222778, 119, '2014-03-01 01:05:33.000000', 'temperatura', 71.0000, 'ºC'),
	(222779, 119, '2014-03-01 01:05:34.000000', 'temperatura', 915.0000, 'ºC'),
	(222780, 119, '2014-03-01 01:05:35.000000', 'temperatura', 764.0000, 'ºC'),
	(222781, 119, '2014-03-01 01:05:36.000000', 'temperatura', 1075.0000, 'ºC'),
	(222782, 119, '2014-03-01 01:05:37.000000', 'temperatura', 683.0000, 'ºC'),
	(222783, 119, '2014-03-01 01:05:38.000000', 'temperatura', 193.0000, 'ºC'),
	(222784, 119, '2014-03-01 01:05:39.000000', 'temperatura', 115.0000, 'ºC'),
	(222785, 119, '2014-03-01 01:05:40.000000', 'temperatura', 1195.0000, 'ºC'),
	(222786, 119, '2014-03-01 01:05:41.000000', 'temperatura', 832.0000, 'ºC'),
	(222787, 119, '2014-03-01 01:05:42.000000', 'temperatura', 576.0000, 'ºC'),
	(222788, 119, '2014-03-01 01:05:43.000000', 'temperatura', 382.0000, 'ºC'),
	(222789, 119, '2014-03-01 01:05:44.000000', 'temperatura', 183.0000, 'ºC'),
	(222790, 119, '2014-03-01 01:05:45.000000', 'temperatura', 970.0000, 'ºC'),
	(222791, 119, '2014-03-01 01:05:46.000000', 'temperatura', 702.0000, 'ºC'),
	(222792, 119, '2014-03-01 01:05:47.000000', 'temperatura', 601.0000, 'ºC'),
	(222793, 119, '2014-03-01 01:05:48.000000', 'temperatura', 898.0000, 'ºC'),
	(222794, 119, '2014-03-01 01:05:49.000000', 'temperatura', 286.0000, 'ºC'),
	(222795, 119, '2014-03-01 01:05:50.000000', 'temperatura', 1140.0000, 'ºC'),
	(222796, 119, '2014-03-01 01:05:51.000000', 'temperatura', 41.0000, 'ºC'),
	(222797, 119, '2014-03-01 01:05:52.000000', 'temperatura', 386.0000, 'ºC'),
	(222798, 119, '2014-03-01 01:05:53.000000', 'temperatura', 609.0000, 'ºC'),
	(222799, 119, '2014-03-01 01:05:54.000000', 'temperatura', 686.0000, 'ºC'),
	(222800, 119, '2014-03-01 01:05:55.000000', 'temperatura', 402.0000, 'ºC'),
	(222801, 119, '2014-03-01 01:05:56.000000', 'temperatura', 1155.0000, 'ºC'),
	(222802, 119, '2014-03-01 01:05:57.000000', 'temperatura', 969.0000, 'ºC'),
	(222803, 119, '2014-03-01 01:05:58.000000', 'temperatura', 181.0000, 'ºC'),
	(222804, 119, '2014-03-01 01:05:59.000000', 'temperatura', 396.0000, 'ºC'),
	(222805, 119, '2014-03-01 01:06:00.000000', 'temperatura', 240.0000, 'ºC'),
	(222806, 119, '2014-03-01 01:06:01.000000', 'temperatura', 13.0000, 'ºC'),
	(222807, 119, '2014-03-01 01:06:02.000000', 'temperatura', 546.0000, 'ºC'),
	(222808, 119, '2014-03-01 01:06:03.000000', 'temperatura', 290.0000, 'ºC'),
	(222809, 119, '2014-03-01 01:06:04.000000', 'temperatura', 1012.0000, 'ºC'),
	(222810, 119, '2014-03-01 01:06:05.000000', 'temperatura', 591.0000, 'ºC'),
	(222811, 119, '2014-03-01 01:06:06.000000', 'temperatura', 1121.0000, 'ºC'),
	(222812, 119, '2014-03-01 01:06:07.000000', 'temperatura', 233.0000, 'ºC'),
	(222813, 119, '2014-03-01 01:06:08.000000', 'temperatura', 203.0000, 'ºC'),
	(222814, 119, '2014-03-01 01:06:09.000000', 'temperatura', 318.0000, 'ºC'),
	(222815, 119, '2014-03-01 01:06:10.000000', 'temperatura', 978.0000, 'ºC'),
	(222816, 119, '2014-03-01 01:06:11.000000', 'temperatura', 336.0000, 'ºC'),
	(222817, 119, '2014-03-01 01:06:12.000000', 'temperatura', 1148.0000, 'ºC'),
	(222818, 119, '2014-03-01 01:06:13.000000', 'temperatura', 1134.0000, 'ºC'),
	(222819, 119, '2014-03-01 01:06:14.000000', 'temperatura', 1024.0000, 'ºC'),
	(222820, 119, '2014-03-01 01:06:15.000000', 'temperatura', 517.0000, 'ºC'),
	(222821, 119, '2014-03-01 01:06:16.000000', 'temperatura', 716.0000, 'ºC'),
	(222822, 119, '2014-03-01 01:06:17.000000', 'temperatura', 831.0000, 'ºC'),
	(222823, 119, '2014-03-01 01:06:18.000000', 'temperatura', 806.0000, 'ºC'),
	(222824, 119, '2014-03-01 01:06:19.000000', 'temperatura', 338.0000, 'ºC'),
	(222825, 119, '2014-03-01 01:06:20.000000', 'temperatura', 471.0000, 'ºC'),
	(222826, 119, '2014-03-01 01:06:21.000000', 'temperatura', 144.0000, 'ºC'),
	(222827, 119, '2014-03-01 01:06:22.000000', 'temperatura', 507.0000, 'ºC'),
	(222828, 119, '2014-03-01 01:06:23.000000', 'temperatura', 904.0000, 'ºC'),
	(222829, 119, '2014-03-01 01:06:24.000000', 'temperatura', 599.0000, 'ºC'),
	(222830, 119, '2014-03-01 01:06:25.000000', 'temperatura', 283.0000, 'ºC'),
	(222831, 119, '2014-03-01 01:06:26.000000', 'temperatura', 821.0000, 'ºC'),
	(222832, 119, '2014-03-01 01:06:27.000000', 'temperatura', 854.0000, 'ºC'),
	(222833, 119, '2014-03-01 01:06:28.000000', 'temperatura', 610.0000, 'ºC'),
	(222834, 119, '2014-03-01 01:06:29.000000', 'temperatura', 486.0000, 'ºC'),
	(222835, 119, '2014-03-01 01:06:30.000000', 'temperatura', 602.0000, 'ºC'),
	(222836, 119, '2014-03-01 01:06:31.000000', 'temperatura', 350.0000, 'ºC'),
	(222837, 119, '2014-03-01 01:06:32.000000', 'temperatura', 1148.0000, 'ºC'),
	(222838, 119, '2014-03-01 01:06:33.000000', 'temperatura', 1087.0000, 'ºC'),
	(222839, 119, '2014-03-01 01:06:34.000000', 'temperatura', 794.0000, 'ºC'),
	(222840, 119, '2014-03-01 01:06:35.000000', 'temperatura', 710.0000, 'ºC'),
	(222841, 119, '2014-03-01 01:06:36.000000', 'temperatura', 1168.0000, 'ºC'),
	(222842, 119, '2014-03-01 01:06:37.000000', 'temperatura', 109.0000, 'ºC'),
	(222843, 119, '2014-03-01 01:06:38.000000', 'temperatura', 643.0000, 'ºC'),
	(222844, 119, '2014-03-01 01:06:39.000000', 'temperatura', 488.0000, 'ºC'),
	(222845, 119, '2014-03-01 01:06:40.000000', 'temperatura', 510.0000, 'ºC'),
	(222846, 119, '2014-03-01 01:06:41.000000', 'temperatura', 1088.0000, 'ºC'),
	(222847, 119, '2014-03-01 01:06:42.000000', 'temperatura', 309.0000, 'ºC'),
	(222848, 119, '2014-03-01 01:06:43.000000', 'temperatura', 684.0000, 'ºC'),
	(222849, 119, '2014-03-01 01:06:44.000000', 'temperatura', 92.0000, 'ºC'),
	(222850, 119, '2014-03-01 01:06:45.000000', 'temperatura', 809.0000, 'ºC'),
	(222851, 119, '2014-03-01 01:06:46.000000', 'temperatura', 170.0000, 'ºC'),
	(222852, 119, '2014-03-01 01:06:47.000000', 'temperatura', 823.0000, 'ºC'),
	(222853, 119, '2014-03-01 01:06:48.000000', 'temperatura', 6.0000, 'ºC'),
	(222854, 119, '2014-03-01 01:06:49.000000', 'temperatura', 1160.0000, 'ºC'),
	(222855, 119, '2014-03-01 01:06:50.000000', 'temperatura', 983.0000, 'ºC'),
	(222856, 119, '2014-03-01 01:06:51.000000', 'temperatura', 236.0000, 'ºC'),
	(222857, 119, '2014-03-01 01:06:52.000000', 'temperatura', 633.0000, 'ºC'),
	(222858, 119, '2014-03-01 01:06:53.000000', 'temperatura', 56.0000, 'ºC'),
	(222859, 119, '2014-03-01 01:06:54.000000', 'temperatura', 781.0000, 'ºC'),
	(222860, 119, '2014-03-01 01:06:55.000000', 'temperatura', 138.0000, 'ºC'),
	(222861, 119, '2014-03-01 01:06:56.000000', 'temperatura', 746.0000, 'ºC'),
	(222862, 119, '2014-03-01 01:06:57.000000', 'temperatura', 917.0000, 'ºC'),
	(222863, 119, '2014-03-01 01:06:58.000000', 'temperatura', 1146.0000, 'ºC'),
	(222864, 119, '2014-03-01 01:06:59.000000', 'temperatura', 580.0000, 'ºC'),
	(222865, 119, '2014-03-01 01:07:00.000000', 'temperatura', 663.0000, 'ºC'),
	(222866, 119, '2014-03-01 01:07:01.000000', 'temperatura', 376.0000, 'ºC'),
	(222867, 119, '2014-03-01 01:07:02.000000', 'temperatura', 1090.0000, 'ºC'),
	(222868, 119, '2014-03-01 01:07:03.000000', 'temperatura', 723.0000, 'ºC'),
	(222869, 119, '2014-03-01 01:07:04.000000', 'temperatura', 346.0000, 'ºC'),
	(222870, 119, '2014-03-01 01:07:05.000000', 'temperatura', 762.0000, 'ºC'),
	(222871, 119, '2014-03-01 01:07:06.000000', 'temperatura', 373.0000, 'ºC'),
	(222872, 119, '2014-03-01 01:07:07.000000', 'temperatura', 780.0000, 'ºC'),
	(222873, 119, '2014-03-01 01:07:08.000000', 'temperatura', 380.0000, 'ºC'),
	(222874, 119, '2014-03-01 01:07:09.000000', 'temperatura', 759.0000, 'ºC'),
	(222875, 119, '2014-03-01 01:07:10.000000', 'temperatura', 257.0000, 'ºC'),
	(222876, 119, '2014-03-01 01:07:11.000000', 'temperatura', 207.0000, 'ºC'),
	(222877, 119, '2014-03-01 01:07:12.000000', 'temperatura', 265.0000, 'ºC'),
	(222878, 119, '2014-03-01 01:07:13.000000', 'temperatura', 704.0000, 'ºC'),
	(222879, 119, '2014-03-01 01:07:14.000000', 'temperatura', 325.0000, 'ºC'),
	(222880, 119, '2014-03-01 01:07:15.000000', 'temperatura', 714.0000, 'ºC'),
	(222881, 119, '2014-03-01 01:07:16.000000', 'temperatura', 196.0000, 'ºC'),
	(222882, 119, '2014-03-01 01:07:17.000000', 'temperatura', 39.0000, 'ºC'),
	(222883, 119, '2014-03-01 01:07:18.000000', 'temperatura', 805.0000, 'ºC'),
	(222884, 119, '2014-03-01 01:07:19.000000', 'temperatura', 310.0000, 'ºC'),
	(222885, 119, '2014-03-01 01:07:20.000000', 'temperatura', 337.0000, 'ºC'),
	(222886, 119, '2014-03-01 01:07:21.000000', 'temperatura', 756.0000, 'ºC'),
	(222887, 119, '2014-03-01 01:07:22.000000', 'temperatura', 369.0000, 'ºC'),
	(222888, 119, '2014-03-01 01:07:23.000000', 'temperatura', 777.0000, 'ºC'),
	(222889, 119, '2014-03-01 01:07:24.000000', 'temperatura', 378.0000, 'ºC'),
	(222890, 119, '2014-03-01 01:07:25.000000', 'temperatura', 758.0000, 'ºC'),
	(222891, 119, '2014-03-01 01:07:26.000000', 'temperatura', 260.0000, 'ºC'),
	(222892, 119, '2014-03-01 01:07:27.000000', 'temperatura', 224.0000, 'ºC'),
	(222893, 119, '2014-03-01 01:07:28.000000', 'temperatura', 341.0000, 'ºC'),
	(222894, 119, '2014-03-01 01:07:29.000000', 'temperatura', 1036.0000, 'ºC'),
	(222895, 119, '2014-03-01 01:07:30.000000', 'temperatura', 555.0000, 'ºC'),
	(222896, 119, '2014-03-01 01:07:31.000000', 'temperatura', 866.0000, 'ºC'),
	(222897, 119, '2014-03-01 01:07:32.000000', 'temperatura', 269.0000, 'ºC'),
	(222898, 119, '2014-03-01 01:07:33.000000', 'temperatura', 1146.0000, 'ºC'),
	(222899, 119, '2014-03-01 01:07:34.000000', 'temperatura', 123.0000, 'ºC'),
	(222900, 119, '2014-03-01 01:07:35.000000', 'temperatura', 779.0000, 'ºC'),
	(222901, 119, '2014-03-01 01:07:36.000000', 'temperatura', 1124.0000, 'ºC'),
	(222902, 119, '2014-03-01 01:07:37.000000', 'temperatura', 884.0000, 'ºC'),
	(222903, 119, '2014-03-01 01:07:38.000000', 'temperatura', 1047.0000, 'ºC'),
	(222904, 119, '2014-03-01 01:07:39.000000', 'temperatura', 186.0000, 'ºC'),
	(222905, 119, '2014-03-01 01:07:40.000000', 'temperatura', 188.0000, 'ºC'),
	(222906, 119, '2014-03-01 01:07:41.000000', 'temperatura', 382.0000, 'ºC'),
	(222907, 119, '2014-03-01 01:07:42.000000', 'temperatura', 147.0000, 'ºC'),
	(222908, 119, '2014-03-01 01:07:43.000000', 'temperatura', 790.0000, 'ºC'),
	(222909, 119, '2014-03-01 01:07:44.000000', 'temperatura', 1109.0000, 'ºC'),
	(222910, 119, '2014-03-01 01:07:45.000000', 'temperatura', 775.0000, 'ºC'),
	(222911, 119, '2014-03-01 01:07:46.000000', 'temperatura', 549.0000, 'ºC'),
	(222912, 119, '2014-03-01 01:07:47.000000', 'temperatura', 420.0000, 'ºC'),
	(222913, 119, '2014-03-01 01:07:48.000000', 'temperatura', 455.0000, 'ºC'),
	(222914, 119, '2014-03-01 01:07:49.000000', 'temperatura', 1015.0000, 'ºC'),
	(222915, 119, '2014-03-01 01:07:50.000000', 'temperatura', 111.0000, 'ºC'),
	(222916, 119, '2014-03-01 01:07:51.000000', 'temperatura', 1110.0000, 'ºC'),
	(222917, 119, '2014-03-01 01:07:52.000000', 'temperatura', 419.0000, 'ºC'),
	(222918, 119, '2014-03-01 01:07:53.000000', 'temperatura', 1165.0000, 'ºC'),
	(222919, 119, '2014-03-01 01:07:54.000000', 'temperatura', 968.0000, 'ºC'),
	(222920, 119, '2014-03-01 01:07:55.000000', 'temperatura', 145.0000, 'ºC'),
	(222921, 119, '2014-03-01 01:07:56.000000', 'temperatura', 223.0000, 'ºC'),
	(222922, 119, '2014-03-01 01:07:57.000000', 'temperatura', 681.0000, 'ºC'),
	(222923, 119, '2014-03-01 01:07:58.000000', 'temperatura', 334.0000, 'ºC'),
	(222924, 119, '2014-03-01 01:07:59.000000', 'temperatura', 829.0000, 'ºC'),
	(222925, 119, '2014-03-01 01:08:00.000000', 'temperatura', 745.0000, 'ºC'),
	(222926, 119, '2014-03-01 01:08:01.000000', 'temperatura', 36.0000, 'ºC'),
	(222927, 119, '2014-03-01 01:08:02.000000', 'temperatura', 346.0000, 'ºC'),
	(222928, 119, '2014-03-01 01:08:03.000000', 'temperatura', 421.0000, 'ºC'),
	(222929, 119, '2014-03-01 01:08:04.000000', 'temperatura', 1068.0000, 'ºC'),
	(222930, 119, '2014-03-01 01:08:05.000000', 'temperatura', 478.0000, 'ºC'),
	(222931, 119, '2014-03-01 01:08:06.000000', 'temperatura', 385.0000, 'ºC'),
	(222932, 119, '2014-03-01 01:08:07.000000', 'temperatura', 491.0000, 'ºC'),
	(222933, 119, '2014-03-01 01:08:08.000000', 'temperatura', 100.0000, 'ºC'),
	(222934, 119, '2014-03-01 01:08:09.000000', 'temperatura', 229.0000, 'ºC'),
	(222935, 119, '2014-03-01 01:08:10.000000', 'temperatura', 844.0000, 'ºC'),
	(222936, 119, '2014-03-01 01:08:11.000000', 'temperatura', 1135.0000, 'ºC'),
	(222937, 119, '2014-03-01 01:08:12.000000', 'temperatura', 744.0000, 'ºC'),
	(222938, 119, '2014-03-01 01:08:13.000000', 'temperatura', 314.0000, 'ºC'),
	(222939, 119, '2014-03-01 01:08:14.000000', 'temperatura', 537.0000, 'ºC'),
	(222940, 119, '2014-03-01 01:08:15.000000', 'temperatura', 545.0000, 'ºC'),
	(222941, 119, '2014-03-01 01:08:16.000000', 'temperatura', 1114.0000, 'ºC'),
	(222942, 119, '2014-03-01 01:08:17.000000', 'temperatura', 336.0000, 'ºC'),
	(222943, 119, '2014-03-01 01:08:18.000000', 'temperatura', 739.0000, 'ºC'),
	(222944, 119, '2014-03-01 01:08:19.000000', 'temperatura', 286.0000, 'ºC'),
	(222945, 119, '2014-03-01 01:08:20.000000', 'temperatura', 412.0000, 'ºC'),
	(222946, 119, '2014-03-01 01:08:21.000000', 'temperatura', 6.0000, 'ºC'),
	(222947, 119, '2014-03-01 01:08:22.000000', 'temperatura', 1193.0000, 'ºC'),
	(222948, 119, '2014-03-01 01:08:23.000000', 'temperatura', 1150.0000, 'ºC'),
	(222949, 119, '2014-03-01 01:08:24.000000', 'temperatura', 968.0000, 'ºC'),
	(222950, 119, '2014-03-01 01:08:25.000000', 'temperatura', 190.0000, 'ºC'),
	(222951, 119, '2014-03-01 01:08:26.000000', 'temperatura', 450.0000, 'ºC'),
	(222952, 119, '2014-03-01 01:08:27.000000', 'temperatura', 477.0000, 'ºC'),
	(222953, 119, '2014-03-01 01:08:28.000000', 'temperatura', 1039.0000, 'ºC'),
	(222954, 119, '2014-03-01 01:08:29.000000', 'temperatura', 162.0000, 'ºC'),
	(222955, 119, '2014-03-01 01:08:30.000000', 'temperatura', 95.0000, 'ºC'),
	(222956, 119, '2014-03-01 01:08:31.000000', 'temperatura', 1190.0000, 'ºC'),
	(222957, 119, '2014-03-01 01:08:32.000000', 'temperatura', 865.0000, 'ºC'),
	(222958, 119, '2014-03-01 01:08:33.000000', 'temperatura', 755.0000, 'ºC'),
	(222959, 119, '2014-03-01 01:08:34.000000', 'temperatura', 1183.0000, 'ºC'),
	(222960, 119, '2014-03-01 01:08:35.000000', 'temperatura', 48.0000, 'ºC'),
	(222961, 119, '2014-03-01 01:08:36.000000', 'temperatura', 291.0000, 'ºC'),
	(222962, 119, '2014-03-01 01:08:37.000000', 'temperatura', 113.0000, 'ºC'),
	(222963, 119, '2014-03-01 01:08:38.000000', 'temperatura', 893.0000, 'ºC'),
	(222964, 119, '2014-03-01 01:08:39.000000', 'temperatura', 526.0000, 'ºC'),
	(222965, 119, '2014-03-01 01:08:40.000000', 'temperatura', 1152.0000, 'ºC'),
	(222966, 119, '2014-03-01 01:08:41.000000', 'temperatura', 583.0000, 'ºC'),
	(222967, 119, '2014-03-01 01:08:42.000000', 'temperatura', 659.0000, 'ºC'),
	(222968, 119, '2014-03-01 01:08:43.000000', 'temperatura', 348.0000, 'ºC'),
	(222969, 119, '2014-03-01 01:08:44.000000', 'temperatura', 961.0000, 'ºC'),
	(222970, 119, '2014-03-01 01:08:45.000000', 'temperatura', 161.0000, 'ºC'),
	(222971, 119, '2014-03-01 01:08:46.000000', 'temperatura', 321.0000, 'ºC'),
	(222972, 119, '2014-03-01 01:08:47.000000', 'temperatura', 1126.0000, 'ºC'),
	(222973, 119, '2014-03-01 01:08:48.000000', 'temperatura', 1066.0000, 'ºC'),
	(222974, 119, '2014-03-01 01:08:49.000000', 'temperatura', 752.0000, 'ºC'),
	(222975, 119, '2014-03-01 01:08:50.000000', 'temperatura', 565.0000, 'ºC'),
	(222976, 119, '2014-03-01 01:08:51.000000', 'temperatura', 568.0000, 'ºC'),
	(222977, 119, '2014-03-01 01:08:52.000000', 'temperatura', 1145.0000, 'ºC'),
	(222978, 119, '2014-03-01 01:08:53.000000', 'temperatura', 421.0000, 'ºC'),
	(222979, 119, '2014-03-01 01:08:54.000000', 'temperatura', 1072.0000, 'ºC'),
	(222980, 119, '2014-03-01 01:08:55.000000', 'temperatura', 495.0000, 'ºC'),
	(222981, 119, '2014-03-01 01:08:56.000000', 'temperatura', 463.0000, 'ºC'),
	(222982, 119, '2014-03-01 01:08:57.000000', 'temperatura', 828.0000, 'ºC'),
	(222983, 119, '2014-03-01 01:08:58.000000', 'temperatura', 352.0000, 'ºC'),
	(222984, 119, '2014-03-01 01:08:59.000000', 'temperatura', 475.0000, 'ºC'),
	(222985, 119, '2014-03-01 01:09:00.000000', 'temperatura', 120.0000, 'ºC'),
	(222986, 119, '2014-03-01 01:09:01.000000', 'temperatura', 375.0000, 'ºC'),
	(222987, 119, '2014-03-01 01:09:02.000000', 'temperatura', 318.0000, 'ºC'),
	(222988, 119, '2014-03-01 01:09:03.000000', 'temperatura', 464.0000, 'ºC'),
	(222989, 119, '2014-03-01 01:09:04.000000', 'temperatura', 169.0000, 'ºC'),
	(222990, 119, '2014-03-01 01:09:05.000000', 'temperatura', 650.0000, 'ºC'),
	(222991, 119, '2014-03-01 01:09:06.000000', 'temperatura', 344.0000, 'ºC'),
	(222992, 119, '2014-03-01 01:09:07.000000', 'temperatura', 971.0000, 'ºC'),
	(222993, 119, '2014-03-01 01:09:08.000000', 'temperatura', 224.0000, 'ºC'),
	(222994, 119, '2014-03-01 01:09:09.000000', 'temperatura', 606.0000, 'ºC'),
	(222995, 119, '2014-03-01 01:09:10.000000', 'temperatura', 1161.0000, 'ºC'),
	(222996, 119, '2014-03-01 01:09:11.000000', 'temperatura', 387.0000, 'ºC'),
	(222997, 119, '2014-03-01 01:09:12.000000', 'temperatura', 854.0000, 'ºC'),
	(222998, 119, '2014-03-01 01:09:13.000000', 'temperatura', 709.0000, 'ºC'),
	(222999, 119, '2014-03-01 01:09:14.000000', 'temperatura', 982.0000, 'ºC'),
	(223000, 119, '2014-03-01 01:09:15.000000', 'temperatura', 383.0000, 'ºC'),
	(223001, 119, '2014-03-01 01:09:16.000000', 'temperatura', 168.0000, 'ºC'),
	(223002, 119, '2014-03-01 01:09:17.000000', 'temperatura', 894.0000, 'ºC'),
	(223003, 119, '2014-03-01 01:09:18.000000', 'temperatura', 367.0000, 'ºC'),
	(223004, 119, '2014-03-01 01:09:19.000000', 'temperatura', 354.0000, 'ºC'),
	(223005, 119, '2014-03-01 01:09:20.000000', 'temperatura', 670.0000, 'ºC'),
	(223006, 119, '2014-03-01 01:09:21.000000', 'temperatura', 1086.0000, 'ºC'),
	(223007, 119, '2014-03-01 01:09:22.000000', 'temperatura', 1021.0000, 'ºC'),
	(223008, 119, '2014-03-01 01:09:23.000000', 'temperatura', 648.0000, 'ºC'),
	(223009, 119, '2014-03-01 01:09:24.000000', 'temperatura', 178.0000, 'ºC'),
	(223010, 119, '2014-03-01 01:09:25.000000', 'temperatura', 146.0000, 'ºC'),
	(223011, 119, '2014-03-01 01:09:26.000000', 'temperatura', 196.0000, 'ºC'),
	(223012, 119, '2014-03-01 01:09:27.000000', 'temperatura', 545.0000, 'ºC'),
	(223013, 119, '2014-03-01 01:09:28.000000', 'temperatura', 935.0000, 'ºC'),
	(223014, 119, '2014-03-01 01:09:29.000000', 'temperatura', 640.0000, 'ºC'),
	(223015, 119, '2014-03-01 01:09:30.000000', 'temperatura', 394.0000, 'ºC'),
	(223016, 119, '2014-03-01 01:09:31.000000', 'temperatura', 54.0000, 'ºC'),
	(223017, 119, '2014-03-01 01:09:32.000000', 'temperatura', 285.0000, 'ºC'),
	(223018, 119, '2014-03-01 01:09:33.000000', 'temperatura', 66.0000, 'ºC'),
	(223019, 119, '2014-03-01 01:09:34.000000', 'temperatura', 676.0000, 'ºC'),
	(223020, 119, '2014-03-01 01:09:35.000000', 'temperatura', 780.0000, 'ºC'),
	(223021, 119, '2014-03-01 01:09:36.000000', 'temperatura', 674.0000, 'ºC'),
	(223022, 119, '2014-03-01 01:09:37.000000', 'temperatura', 1031.0000, 'ºC'),
	(223023, 119, '2014-03-01 01:09:38.000000', 'temperatura', 734.0000, 'ºC'),
	(223024, 119, '2014-03-01 01:09:39.000000', 'temperatura', 579.0000, 'ºC'),
	(223025, 119, '2014-03-01 01:09:40.000000', 'temperatura', 691.0000, 'ºC'),
	(223026, 119, '2014-03-01 01:09:41.000000', 'temperatura', 520.0000, 'ºC'),
	(223027, 119, '2014-03-01 01:09:42.000000', 'temperatura', 528.0000, 'ºC'),
	(223028, 119, '2014-03-01 01:09:43.000000', 'temperatura', 1078.0000, 'ºC'),
	(223029, 119, '2014-03-01 01:09:44.000000', 'temperatura', 206.0000, 'ºC'),
	(223030, 119, '2014-03-01 01:09:45.000000', 'temperatura', 198.0000, 'ºC'),
	(223031, 119, '2014-03-01 01:09:46.000000', 'temperatura', 374.0000, 'ºC'),
	(223032, 119, '2014-03-01 01:09:47.000000', 'temperatura', 76.0000, 'ºC'),
	(223033, 119, '2014-03-01 01:09:48.000000', 'temperatura', 458.0000, 'ºC'),
	(223034, 119, '2014-03-01 01:09:49.000000', 'temperatura', 864.0000, 'ºC'),
	(223035, 119, '2014-03-01 01:09:50.000000', 'temperatura', 547.0000, 'ºC'),
	(223036, 119, '2014-03-01 01:09:51.000000', 'temperatura', 141.0000, 'ºC'),
	(223037, 119, '2014-03-01 01:09:52.000000', 'temperatura', 264.0000, 'ºC'),
	(223038, 119, '2014-03-01 01:09:53.000000', 'temperatura', 898.0000, 'ºC'),
	(223039, 119, '2014-03-01 01:09:54.000000', 'temperatura', 98.0000, 'ºC'),
	(223040, 119, '2014-03-01 01:09:55.000000', 'temperatura', 196.0000, 'ºC'),
	(223041, 119, '2014-03-01 01:09:56.000000', 'temperatura', 685.0000, 'ºC'),
	(223042, 119, '2014-03-01 01:09:57.000000', 'temperatura', 441.0000, 'ºC'),
	(223043, 119, '2014-03-01 01:09:58.000000', 'temperatura', 148.0000, 'ºC'),
	(223044, 119, '2014-03-01 01:09:59.000000', 'temperatura', 617.0000, 'ºC'),
	(223045, 119, '2014-03-01 01:10:00.000000', 'temperatura', 243.0000, 'ºC'),
	(223046, 119, '2014-03-01 01:10:01.000000', 'temperatura', 565.0000, 'ºC'),
	(223047, 119, '2014-03-01 01:10:02.000000', 'temperatura', 896.0000, 'ºC'),
	(223048, 119, '2014-03-01 01:10:03.000000', 'temperatura', 387.0000, 'ºC'),
	(223049, 119, '2014-03-01 01:10:04.000000', 'temperatura', 447.0000, 'ºC'),
	(223050, 119, '2014-03-01 01:10:05.000000', 'temperatura', 1075.0000, 'ºC'),
	(223051, 119, '2014-03-01 01:10:06.000000', 'temperatura', 436.0000, 'ºC'),
	(223052, 119, '2014-03-01 01:10:07.000000', 'temperatura', 152.0000, 'ºC'),
	(223053, 119, '2014-03-01 01:10:08.000000', 'temperatura', 654.0000, 'ºC'),
	(223054, 119, '2014-03-01 01:10:09.000000', 'temperatura', 412.0000, 'ºC'),
	(223055, 119, '2014-03-01 01:10:10.000000', 'temperatura', 102.0000, 'ºC'),
	(223056, 119, '2014-03-01 01:10:11.000000', 'temperatura', 473.0000, 'ºC'),
	(223057, 119, '2014-03-01 01:10:12.000000', 'temperatura', 861.0000, 'ºC'),
	(223058, 119, '2014-03-01 01:10:13.000000', 'temperatura', 484.0000, 'ºC'),
	(223059, 119, '2014-03-01 01:10:14.000000', 'temperatura', 1038.0000, 'ºC'),
	(223060, 119, '2014-03-01 01:10:15.000000', 'temperatura', 139.0000, 'ºC'),
	(223061, 119, '2014-03-01 01:10:16.000000', 'temperatura', 1182.0000, 'ºC'),
	(223062, 119, '2014-03-01 01:10:17.000000', 'temperatura', 692.0000, 'ºC'),
	(223063, 119, '2014-03-01 01:10:18.000000', 'temperatura', 1116.0000, 'ºC'),
	(223064, 119, '2014-03-01 01:10:19.000000', 'temperatura', 1103.0000, 'ºC'),
	(223065, 119, '2014-03-01 01:10:20.000000', 'temperatura', 967.0000, 'ºC'),
	(223066, 119, '2014-03-01 01:10:21.000000', 'temperatura', 328.0000, 'ºC'),
	(223067, 119, '2014-03-01 01:10:22.000000', 'temperatura', 1139.0000, 'ºC'),
	(223068, 119, '2014-03-01 01:10:23.000000', 'temperatura', 1111.0000, 'ºC'),
	(223069, 119, '2014-03-01 01:10:24.000000', 'temperatura', 939.0000, 'ºC'),
	(223070, 119, '2014-03-01 01:10:25.000000', 'temperatura', 161.0000, 'ºC'),
	(223071, 119, '2014-03-01 01:10:26.000000', 'temperatura', 389.0000, 'ºC'),
	(223072, 119, '2014-03-01 01:10:27.000000', 'temperatura', 262.0000, 'ºC'),
	(223073, 119, '2014-03-01 01:10:28.000000', 'temperatura', 145.0000, 'ºC'),
	(223074, 119, '2014-03-01 01:10:29.000000', 'temperatura', 1141.0000, 'ºC'),
	(223075, 119, '2014-03-01 01:10:30.000000', 'temperatura', 469.0000, 'ºC'),
	(223076, 119, '2014-03-01 01:10:31.000000', 'temperatura', 122.0000, 'ºC'),
	(223077, 119, '2014-03-01 01:10:32.000000', 'temperatura', 403.0000, 'ºC'),
	(223078, 119, '2014-03-01 01:10:33.000000', 'temperatura', 451.0000, 'ºC'),
	(223079, 119, '2014-03-01 01:10:34.000000', 'temperatura', 1046.0000, 'ºC'),
	(223080, 119, '2014-03-01 01:10:35.000000', 'temperatura', 279.0000, 'ºC'),
	(223081, 119, '2014-03-01 01:10:36.000000', 'temperatura', 656.0000, 'ºC'),
	(223082, 119, '2014-03-01 01:10:37.000000', 'temperatura', 46.0000, 'ºC'),
	(223083, 119, '2014-03-01 01:10:38.000000', 'temperatura', 659.0000, 'ºC'),
	(223084, 119, '2014-03-01 01:10:39.000000', 'temperatura', 760.0000, 'ºC'),
	(223085, 119, '2014-03-01 01:10:40.000000', 'temperatura', 621.0000, 'ºC'),
	(223086, 119, '2014-03-01 01:10:41.000000', 'temperatura', 825.0000, 'ºC'),
	(223087, 119, '2014-03-01 01:10:42.000000', 'temperatura', 1064.0000, 'ºC'),
	(223088, 119, '2014-03-01 01:10:43.000000', 'temperatura', 445.0000, 'ºC'),
	(223089, 119, '2014-03-01 01:10:44.000000', 'temperatura', 234.0000, 'ºC'),
	(223090, 119, '2014-03-01 01:10:45.000000', 'temperatura', 1037.0000, 'ºC'),
	(223091, 119, '2014-03-01 01:10:46.000000', 'temperatura', 882.0000, 'ºC'),
	(223092, 119, '2014-03-01 01:10:47.000000', 'temperatura', 100.0000, 'ºC'),
	(223093, 119, '2014-03-01 01:10:48.000000', 'temperatura', 253.0000, 'ºC'),
	(223094, 119, '2014-03-01 01:10:49.000000', 'temperatura', 964.0000, 'ºC'),
	(223095, 119, '2014-03-01 01:10:50.000000', 'temperatura', 465.0000, 'ºC'),
	(223096, 119, '2014-03-01 01:10:51.000000', 'temperatura', 632.0000, 'ºC'),
	(223097, 119, '2014-03-01 01:10:52.000000', 'temperatura', 567.0000, 'ºC'),
	(223098, 119, '2014-03-01 01:10:53.000000', 'temperatura', 940.0000, 'ºC'),
	(223099, 119, '2014-03-01 01:10:54.000000', 'temperatura', 597.0000, 'ºC'),
	(223100, 119, '2014-03-01 01:10:55.000000', 'temperatura', 165.0000, 'ºC'),
	(223101, 119, '2014-03-01 01:10:56.000000', 'temperatura', 237.0000, 'ºC'),
	(223102, 119, '2014-03-01 01:10:57.000000', 'temperatura', 690.0000, 'ºC'),
	(223103, 119, '2014-03-01 01:10:58.000000', 'temperatura', 340.0000, 'ºC'),
	(223104, 119, '2014-03-01 01:10:59.000000', 'temperatura', 831.0000, 'ºC'),
	(223105, 119, '2014-03-01 01:11:00.000000', 'temperatura', 734.0000, 'ºC'),
	(223106, 119, '2014-03-01 01:11:01.000000', 'temperatura', 1177.0000, 'ºC'),
	(223107, 119, '2014-03-01 01:11:02.000000', 'temperatura', 82.0000, 'ºC'),
	(223108, 119, '2014-03-01 01:11:03.000000', 'temperatura', 483.0000, 'ºC'),
	(223109, 119, '2014-03-01 01:11:04.000000', 'temperatura', 967.0000, 'ºC'),
	(223110, 119, '2014-03-01 01:11:05.000000', 'temperatura', 986.0000, 'ºC'),
	(223111, 119, '2014-03-01 01:11:06.000000', 'temperatura', 829.0000, 'ºC'),
	(223112, 119, '2014-03-01 01:11:07.000000', 'temperatura', 1189.0000, 'ºC'),
	(223113, 119, '2014-03-01 01:11:08.000000', 'temperatura', 1059.0000, 'ºC'),
	(223114, 119, '2014-03-01 01:11:09.000000', 'temperatura', 527.0000, 'ºC'),
	(223115, 119, '2014-03-01 01:11:10.000000', 'temperatura', 660.0000, 'ºC'),
	(223116, 119, '2014-03-01 01:11:11.000000', 'temperatura', 520.0000, 'ºC'),
	(223117, 119, '2014-03-01 01:11:12.000000', 'temperatura', 620.0000, 'ºC'),
	(223118, 119, '2014-03-01 01:11:13.000000', 'temperatura', 339.0000, 'ºC'),
	(223119, 119, '2014-03-01 01:11:14.000000', 'temperatura', 1035.0000, 'ºC'),
	(223120, 119, '2014-03-01 01:11:15.000000', 'temperatura', 560.0000, 'ºC'),
	(223121, 119, '2014-03-01 01:11:16.000000', 'temperatura', 894.0000, 'ºC'),
	(223122, 119, '2014-03-01 01:11:17.000000', 'temperatura', 392.0000, 'ºC'),
	(223123, 119, '2014-03-01 01:11:18.000000', 'temperatura', 476.0000, 'ºC'),
	(223124, 119, '2014-03-01 01:11:19.000000', 'temperatura', 6.0000, 'ºC'),
	(223125, 119, '2014-03-01 01:11:20.000000', 'temperatura', 1001.0000, 'ºC'),
	(223126, 119, '2014-03-01 01:11:21.000000', 'temperatura', 186.0000, 'ºC'),
	(223127, 119, '2014-03-01 01:11:22.000000', 'temperatura', 331.0000, 'ºC'),
	(223128, 119, '2014-03-01 01:11:23.000000', 'temperatura', 1095.0000, 'ºC'),
	(223129, 119, '2014-03-01 01:11:24.000000', 'temperatura', 885.0000, 'ºC'),
	(223130, 119, '2014-03-01 01:11:25.000000', 'temperatura', 1140.0000, 'ºC'),
	(223131, 119, '2014-03-01 01:11:26.000000', 'temperatura', 646.0000, 'ºC'),
	(223132, 119, '2014-03-01 01:11:27.000000', 'temperatura', 1011.0000, 'ºC'),
	(223133, 119, '2014-03-01 01:11:28.000000', 'temperatura', 717.0000, 'ºC'),
	(223134, 119, '2014-03-01 01:11:29.000000', 'temperatura', 552.0000, 'ºC'),
	(223135, 119, '2014-03-01 01:11:30.000000', 'temperatura', 608.0000, 'ºC'),
	(223136, 119, '2014-03-01 01:11:31.000000', 'temperatura', 185.0000, 'ºC'),
	(223137, 119, '2014-03-01 01:11:32.000000', 'temperatura', 301.0000, 'ºC'),
	(223138, 119, '2014-03-01 01:11:33.000000', 'temperatura', 949.0000, 'ºC'),
	(223139, 119, '2014-03-01 01:11:34.000000', 'temperatura', 245.0000, 'ºC'),
	(223140, 119, '2014-03-01 01:11:35.000000', 'temperatura', 778.0000, 'ºC'),
	(223141, 119, '2014-03-01 01:11:36.000000', 'temperatura', 757.0000, 'ºC'),
	(223142, 119, '2014-03-01 01:11:37.000000', 'temperatura', 251.0000, 'ºC'),
	(223143, 119, '2014-03-01 01:11:38.000000', 'temperatura', 183.0000, 'ºC'),
	(223144, 119, '2014-03-01 01:11:39.000000', 'temperatura', 165.0000, 'ºC'),
	(223145, 119, '2014-03-01 01:11:40.000000', 'temperatura', 275.0000, 'ºC'),
	(223146, 119, '2014-03-01 01:11:41.000000', 'temperatura', 879.0000, 'ºC'),
	(223147, 119, '2014-03-01 01:11:42.000000', 'temperatura', 1173.0000, 'ºC'),
	(223148, 119, '2014-03-01 01:11:43.000000', 'temperatura', 825.0000, 'ºC'),
	(223149, 119, '2014-03-01 01:11:44.000000', 'temperatura', 610.0000, 'ºC'),
	(223150, 119, '2014-03-01 01:11:45.000000', 'temperatura', 575.0000, 'ºC'),
	(223151, 119, '2014-03-01 01:11:46.000000', 'temperatura', 1045.0000, 'ºC'),
	(223152, 119, '2014-03-01 01:11:47.000000', 'temperatura', 1100.0000, 'ºC'),
	(223153, 119, '2014-03-01 01:11:48.000000', 'temperatura', 1164.0000, 'ºC'),
	(223154, 119, '2014-03-01 01:11:49.000000', 'temperatura', 122.0000, 'ºC'),
	(223155, 119, '2014-03-01 01:11:50.000000', 'temperatura', 720.0000, 'ºC'),
	(223156, 119, '2014-03-01 01:11:51.000000', 'temperatura', 832.0000, 'ºC'),
	(223157, 119, '2014-03-01 01:11:52.000000', 'temperatura', 803.0000, 'ºC'),
	(223158, 119, '2014-03-01 01:11:53.000000', 'temperatura', 318.0000, 'ºC'),
	(223159, 119, '2014-03-01 01:11:54.000000', 'temperatura', 383.0000, 'ºC'),
	(223160, 119, '2014-03-01 01:11:55.000000', 'temperatura', 960.0000, 'ºC'),
	(223161, 119, '2014-03-01 01:11:56.000000', 'temperatura', 51.0000, 'ºC'),
	(223162, 119, '2014-03-01 01:11:57.000000', 'temperatura', 977.0000, 'ºC'),
	(223163, 119, '2014-03-01 01:11:58.000000', 'temperatura', 1134.0000, 'ºC'),
	(223164, 119, '2014-03-01 01:11:59.000000', 'temperatura', 337.0000, 'ºC'),
	(223165, 119, '2014-03-01 01:12:00.000000', 'temperatura', 686.0000, 'ºC'),
	(223166, 119, '2014-03-01 01:12:01.000000', 'temperatura', 19.0000, 'ºC'),
	(223167, 119, '2014-03-01 01:12:02.000000', 'temperatura', 438.0000, 'ºC'),
	(223168, 119, '2014-03-01 01:12:03.000000', 'temperatura', 934.0000, 'ºC'),
	(223169, 119, '2014-03-01 01:12:04.000000', 'temperatura', 957.0000, 'ºC'),
	(223170, 119, '2014-03-01 01:12:05.000000', 'temperatura', 782.0000, 'ºC'),
	(223171, 119, '2014-03-01 01:12:06.000000', 'temperatura', 1038.0000, 'ºC'),
	(223172, 119, '2014-03-01 01:12:07.000000', 'temperatura', 446.0000, 'ºC'),
	(223173, 119, '2014-03-01 01:12:08.000000', 'temperatura', 315.0000, 'ºC'),
	(223174, 119, '2014-03-01 01:12:09.000000', 'temperatura', 241.0000, 'ºC'),
	(223175, 119, '2014-03-01 01:12:10.000000', 'temperatura', 257.0000, 'ºC'),
	(223176, 119, '2014-03-01 01:12:11.000000', 'temperatura', 563.0000, 'ºC'),
	(223177, 119, '2014-03-01 01:12:12.000000', 'temperatura', 844.0000, 'ºC'),
	(223178, 119, '2014-03-01 01:12:13.000000', 'temperatura', 132.0000, 'ºC'),
	(223179, 119, '2014-03-01 01:12:14.000000', 'temperatura', 530.0000, 'ºC'),
	(223180, 119, '2014-03-01 01:12:15.000000', 'temperatura', 1052.0000, 'ºC'),
	(223181, 119, '2014-03-01 01:12:16.000000', 'temperatura', 73.0000, 'ºC'),
	(223182, 119, '2014-03-01 01:12:17.000000', 'temperatura', 809.0000, 'ºC'),
	(223183, 119, '2014-03-01 01:12:18.000000', 'temperatura', 224.0000, 'ºC'),
	(223184, 119, '2014-03-01 01:12:19.000000', 'temperatura', 1096.0000, 'ºC'),
	(223185, 119, '2014-03-01 01:12:20.000000', 'temperatura', 9.0000, 'ºC'),
	(223186, 119, '2014-03-01 01:12:21.000000', 'temperatura', 356.0000, 'ºC'),
	(223187, 119, '2014-03-01 01:12:22.000000', 'temperatura', 553.0000, 'ºC'),
	(223188, 119, '2014-03-01 01:12:23.000000', 'temperatura', 499.0000, 'ºC'),
	(223189, 119, '2014-03-01 01:12:24.000000', 'temperatura', 837.0000, 'ºC'),
	(223190, 119, '2014-03-01 01:12:25.000000', 'temperatura', 287.0000, 'ºC'),
	(223191, 119, '2014-03-01 01:12:26.000000', 'temperatura', 124.0000, 'ºC'),
	(223192, 119, '2014-03-01 01:12:27.000000', 'temperatura', 960.0000, 'ºC'),
	(223193, 119, '2014-03-01 01:12:28.000000', 'temperatura', 829.0000, 'ºC'),
	(223194, 119, '2014-03-01 01:12:29.000000', 'temperatura', 65.0000, 'ºC'),
	(223195, 119, '2014-03-01 01:12:30.000000', 'temperatura', 237.0000, 'ºC'),
	(223196, 119, '2014-03-01 01:12:31.000000', 'temperatura', 992.0000, 'ºC'),
	(223197, 119, '2014-03-01 01:12:32.000000', 'temperatura', 651.0000, 'ºC'),
	(223198, 119, '2014-03-01 01:12:33.000000', 'temperatura', 277.0000, 'ºC'),
	(223199, 119, '2014-03-01 01:12:34.000000', 'temperatura', 632.0000, 'ºC'),
	(223200, 119, '2014-03-01 01:12:35.000000', 'temperatura', 1131.0000, 'ºC'),
	(223201, 119, '2014-03-01 01:12:36.000000', 'temperatura', 158.0000, 'ºC'),
	(223202, 119, '2014-03-01 01:12:37.000000', 'temperatura', 999.0000, 'ºC'),
	(223203, 119, '2014-03-01 01:12:38.000000', 'temperatura', 921.0000, 'ºC'),
	(223204, 119, '2014-03-01 01:12:39.000000', 'temperatura', 408.0000, 'ºC'),
	(223205, 119, '2014-03-01 01:12:40.000000', 'temperatura', 476.0000, 'ºC'),
	(223206, 119, '2014-03-01 01:12:41.000000', 'temperatura', 1158.0000, 'ºC'),
	(223207, 119, '2014-03-01 01:12:42.000000', 'temperatura', 764.0000, 'ºC'),
	(223208, 119, '2014-03-01 01:12:43.000000', 'temperatura', 346.0000, 'ºC'),
	(223209, 119, '2014-03-01 01:12:44.000000', 'temperatura', 637.0000, 'ºC'),
	(223210, 119, '2014-03-01 01:12:45.000000', 'temperatura', 950.0000, 'ºC'),
	(223211, 119, '2014-03-01 01:12:46.000000', 'temperatura', 438.0000, 'ºC'),
	(223212, 119, '2014-03-01 01:12:47.000000', 'temperatura', 540.0000, 'ºC'),
	(223213, 119, '2014-03-01 01:12:48.000000', 'temperatura', 189.0000, 'ºC'),
	(223214, 119, '2014-03-01 01:12:49.000000', 'temperatura', 523.0000, 'ºC'),
	(223215, 119, '2014-03-01 01:12:50.000000', 'temperatura', 850.0000, 'ºC'),
	(223216, 119, '2014-03-01 01:12:51.000000', 'temperatura', 282.0000, 'ºC'),
	(223217, 119, '2014-03-01 01:12:52.000000', 'temperatura', 59.0000, 'ºC'),
	(223218, 119, '2014-03-01 01:12:53.000000', 'temperatura', 650.0000, 'ºC'),
	(223219, 119, '2014-03-01 01:12:54.000000', 'temperatura', 673.0000, 'ºC'),
	(223220, 119, '2014-03-01 01:12:55.000000', 'temperatura', 217.0000, 'ºC'),
	(223221, 119, '2014-03-01 01:12:56.000000', 'temperatura', 267.0000, 'ºC'),
	(223222, 119, '2014-03-01 01:12:57.000000', 'temperatura', 683.0000, 'ºC'),
	(223223, 119, '2014-03-01 01:12:58.000000', 'temperatura', 217.0000, 'ºC'),
	(223224, 119, '2014-03-01 01:12:59.000000', 'temperatura', 235.0000, 'ºC'),
	(223225, 119, '2014-03-01 01:13:00.000000', 'temperatura', 523.0000, 'ºC'),
	(223226, 119, '2014-03-01 01:13:01.000000', 'temperatura', 713.0000, 'ºC'),
	(223227, 119, '2014-03-01 01:13:02.000000', 'temperatura', 794.0000, 'ºC'),
	(223228, 119, '2014-03-01 01:13:03.000000', 'temperatura', 631.0000, 'ºC'),
	(223229, 119, '2014-03-01 01:13:04.000000', 'temperatura', 776.0000, 'ºC'),
	(223230, 119, '2014-03-01 01:13:05.000000', 'temperatura', 785.0000, 'ºC'),
	(223231, 119, '2014-03-01 01:13:06.000000', 'temperatura', 401.0000, 'ºC'),
	(223232, 119, '2014-03-01 01:13:07.000000', 'temperatura', 847.0000, 'ºC'),
	(223233, 119, '2014-03-01 01:13:08.000000', 'temperatura', 633.0000, 'ºC'),
	(223234, 119, '2014-03-01 01:13:09.000000', 'temperatura', 624.0000, 'ºC'),
	(223235, 119, '2014-03-01 01:13:10.000000', 'temperatura', 24.0000, 'ºC'),
	(223236, 119, '2014-03-01 01:13:11.000000', 'temperatura', 646.0000, 'ºC'),
	(223237, 119, '2014-03-01 01:13:12.000000', 'temperatura', 759.0000, 'ºC'),
	(223238, 119, '2014-03-01 01:13:13.000000', 'temperatura', 658.0000, 'ºC'),
	(223239, 119, '2014-03-01 01:13:14.000000', 'temperatura', 1014.0000, 'ºC'),
	(223240, 119, '2014-03-01 01:13:15.000000', 'temperatura', 697.0000, 'ºC'),
	(223241, 119, '2014-03-01 01:13:16.000000', 'temperatura', 442.0000, 'ºC'),
	(223242, 119, '2014-03-01 01:13:17.000000', 'temperatura', 121.0000, 'ºC'),
	(223243, 119, '2014-03-01 01:13:18.000000', 'temperatura', 478.0000, 'ºC'),
	(223244, 119, '2014-03-01 01:13:19.000000', 'temperatura', 828.0000, 'ºC'),
	(223245, 119, '2014-03-01 01:13:20.000000', 'temperatura', 308.0000, 'ºC'),
	(223246, 119, '2014-03-01 01:13:21.000000', 'temperatura', 257.0000, 'ºC'),
	(223247, 119, '2014-03-01 01:13:22.000000', 'temperatura', 360.0000, 'ºC'),
	(223248, 119, '2014-03-01 01:13:23.000000', 'temperatura', 1029.0000, 'ºC'),
	(223249, 119, '2014-03-01 01:13:24.000000', 'temperatura', 466.0000, 'ºC'),
	(223250, 119, '2014-03-01 01:13:25.000000', 'temperatura', 445.0000, 'ºC'),
	(223251, 119, '2014-03-01 01:13:26.000000', 'temperatura', 827.0000, 'ºC'),
	(223252, 119, '2014-03-01 01:13:27.000000', 'temperatura', 400.0000, 'ºC'),
	(223253, 119, '2014-03-01 01:13:28.000000', 'temperatura', 721.0000, 'ºC'),
	(223254, 119, '2014-03-01 01:13:29.000000', 'temperatura', 4.0000, 'ºC'),
	(223255, 119, '2014-03-01 01:13:30.000000', 'temperatura', 258.0000, 'ºC'),
	(223256, 119, '2014-03-01 01:13:31.000000', 'temperatura', 77.0000, 'ºC'),
	(223257, 119, '2014-03-01 01:13:32.000000', 'temperatura', 813.0000, 'ºC'),
	(223258, 119, '2014-03-01 01:13:33.000000', 'temperatura', 236.0000, 'ºC'),
	(223259, 119, '2014-03-01 01:13:34.000000', 'temperatura', 1141.0000, 'ºC'),
	(223260, 119, '2014-03-01 01:13:35.000000', 'temperatura', 198.0000, 'ºC'),
	(223261, 119, '2014-03-01 01:13:36.000000', 'temperatura', 1166.0000, 'ºC'),
	(223262, 119, '2014-03-01 01:13:37.000000', 'temperatura', 439.0000, 'ºC'),
	(223263, 119, '2014-03-01 01:13:38.000000', 'temperatura', 1094.0000, 'ºC'),
	(223264, 119, '2014-03-01 01:13:39.000000', 'temperatura', 557.0000, 'ºC'),
	(223265, 119, '2014-03-01 01:13:40.000000', 'temperatura', 702.0000, 'ºC'),
	(223266, 119, '2014-03-01 01:13:41.000000', 'temperatura', 639.0000, 'ºC'),
	(223267, 119, '2014-03-01 01:13:42.000000', 'temperatura', 1091.0000, 'ºC'),
	(223268, 119, '2014-03-01 01:13:43.000000', 'temperatura', 1136.0000, 'ºC'),
	(223269, 119, '2014-03-01 01:13:44.000000', 'temperatura', 9.0000, 'ºC'),
	(223270, 119, '2014-03-01 01:13:45.000000', 'temperatura', 236.0000, 'ºC'),
	(223271, 119, '2014-03-01 01:13:46.000000', 'temperatura', 1155.0000, 'ºC'),
	(223272, 119, '2014-03-01 01:13:47.000000', 'temperatura', 265.0000, 'ºC'),
	(223273, 119, '2014-03-01 01:13:48.000000', 'temperatura', 263.0000, 'ºC'),
	(223274, 119, '2014-03-01 01:13:49.000000', 'temperatura', 518.0000, 'ºC'),
	(223275, 119, '2014-03-01 01:13:50.000000', 'temperatura', 604.0000, 'ºC'),
	(223276, 119, '2014-03-01 01:13:51.000000', 'temperatura', 264.0000, 'ºC'),
	(223277, 119, '2014-03-01 01:13:52.000000', 'temperatura', 710.0000, 'ºC'),
	(223278, 119, '2014-03-01 01:13:53.000000', 'temperatura', 357.0000, 'ºC'),
	(223279, 119, '2014-03-01 01:13:54.000000', 'temperatura', 857.0000, 'ºC'),
	(223280, 119, '2014-03-01 01:13:55.000000', 'temperatura', 815.0000, 'ºC'),
	(223281, 119, '2014-03-01 01:13:56.000000', 'temperatura', 303.0000, 'ºC'),
	(223282, 119, '2014-03-01 01:13:57.000000', 'temperatura', 272.0000, 'ºC'),
	(223283, 119, '2014-03-01 01:13:58.000000', 'temperatura', 452.0000, 'ºC'),
	(223284, 119, '2014-03-01 01:13:59.000000', 'temperatura', 243.0000, 'ºC'),
	(223285, 119, '2014-03-01 01:14:00.000000', 'temperatura', 1060.0000, 'ºC'),
	(223286, 119, '2014-03-01 01:14:01.000000', 'temperatura', 972.0000, 'ºC'),
	(223287, 119, '2014-03-01 01:14:02.000000', 'temperatura', 479.0000, 'ºC'),
	(223288, 119, '2014-03-01 01:14:03.000000', 'temperatura', 681.0000, 'ºC'),
	(223289, 119, '2014-03-01 01:14:04.000000', 'temperatura', 766.0000, 'ºC'),
	(223290, 119, '2014-03-01 01:14:05.000000', 'temperatura', 589.0000, 'ºC'),
	(223291, 119, '2014-03-01 01:14:06.000000', 'temperatura', 648.0000, 'ºC'),
	(223292, 119, '2014-03-01 01:14:07.000000', 'temperatura', 272.0000, 'ºC'),
	(223293, 119, '2014-03-01 01:14:08.000000', 'temperatura', 616.0000, 'ºC'),
	(223294, 119, '2014-03-01 01:14:09.000000', 'temperatura', 1066.0000, 'ºC'),
	(223295, 119, '2014-03-01 01:14:10.000000', 'temperatura', 1082.0000, 'ºC'),
	(223296, 119, '2014-03-01 01:14:11.000000', 'temperatura', 1010.0000, 'ºC'),
	(223297, 119, '2014-03-01 01:14:12.000000', 'temperatura', 608.0000, 'ºC'),
	(223298, 119, '2014-03-01 01:14:13.000000', 'temperatura', 9.0000, 'ºC'),
	(223299, 119, '2014-03-01 01:14:14.000000', 'temperatura', 623.0000, 'ºC'),
	(223300, 119, '2014-03-01 01:14:15.000000', 'temperatura', 688.0000, 'ºC'),
	(223301, 119, '2014-03-01 01:14:16.000000', 'temperatura', 369.0000, 'ºC'),
	(223302, 119, '2014-03-01 01:14:17.000000', 'temperatura', 985.0000, 'ºC'),
	(223303, 119, '2014-03-01 01:14:18.000000', 'temperatura', 217.0000, 'ºC'),
	(223304, 119, '2014-03-01 01:14:19.000000', 'temperatura', 533.0000, 'ºC'),
	(223305, 119, '2014-03-01 01:14:20.000000', 'temperatura', 811.0000, 'ºC'),
	(223306, 119, '2014-03-01 01:14:21.000000', 'temperatura', 58.0000, 'ºC'),
	(223307, 119, '2014-03-01 01:14:22.000000', 'temperatura', 259.0000, 'ºC'),
	(223308, 119, '2014-03-01 01:14:23.000000', 'temperatura', 1118.0000, 'ºC'),
	(223309, 119, '2014-03-01 01:14:24.000000', 'temperatura', 16.0000, 'ºC'),
	(223310, 119, '2014-03-01 01:14:25.000000', 'temperatura', 326.0000, 'ºC'),
	(223311, 119, '2014-03-01 01:14:26.000000', 'temperatura', 382.0000, 'ºC'),
	(223312, 119, '2014-03-01 01:14:27.000000', 'temperatura', 931.0000, 'ºC'),
	(223313, 119, '2014-03-01 01:14:28.000000', 'temperatura', 1112.0000, 'ºC'),
	(223314, 119, '2014-03-01 01:14:29.000000', 'temperatura', 366.0000, 'ºC'),
	(223315, 119, '2014-03-01 01:14:30.000000', 'temperatura', 896.0000, 'ºC'),
	(223316, 119, '2014-03-01 01:14:31.000000', 'temperatura', 984.0000, 'ºC'),
	(223317, 119, '2014-03-01 01:14:32.000000', 'temperatura', 1030.0000, 'ºC'),
	(223318, 119, '2014-03-01 01:14:33.000000', 'temperatura', 998.0000, 'ºC'),
	(223319, 119, '2014-03-01 01:14:34.000000', 'temperatura', 700.0000, 'ºC'),
	(223320, 119, '2014-03-01 01:14:35.000000', 'temperatura', 508.0000, 'ºC'),
	(223321, 119, '2014-03-01 01:14:36.000000', 'temperatura', 440.0000, 'ºC'),
	(223322, 119, '2014-03-01 01:14:37.000000', 'temperatura', 678.0000, 'ºC'),
	(223323, 119, '2014-03-01 01:14:38.000000', 'temperatura', 867.0000, 'ºC'),
	(223324, 119, '2014-03-01 01:14:39.000000', 'temperatura', 1105.0000, 'ºC'),
	(223325, 119, '2014-03-01 01:14:40.000000', 'temperatura', 524.0000, 'ºC'),
	(223326, 119, '2014-03-01 01:14:41.000000', 'temperatura', 507.0000, 'ºC'),
	(223327, 119, '2014-03-01 01:14:42.000000', 'temperatura', 962.0000, 'ºC'),
	(223328, 119, '2014-03-01 01:14:43.000000', 'temperatura', 890.0000, 'ºC'),
	(223329, 119, '2014-03-01 01:14:44.000000', 'temperatura', 366.0000, 'ºC'),
	(223330, 119, '2014-03-01 01:14:45.000000', 'temperatura', 359.0000, 'ºC'),
	(223331, 119, '2014-03-01 01:14:46.000000', 'temperatura', 697.0000, 'ºC'),
	(223332, 119, '2014-03-01 01:14:47.000000', 'temperatura', 8.0000, 'ºC'),
	(223333, 119, '2014-03-01 01:14:48.000000', 'temperatura', 348.0000, 'ºC'),
	(223334, 119, '2014-03-01 01:14:49.000000', 'temperatura', 519.0000, 'ºC'),
	(223335, 119, '2014-03-01 01:14:50.000000', 'temperatura', 350.0000, 'ºC'),
	(223336, 119, '2014-03-01 01:14:51.000000', 'temperatura', 192.0000, 'ºC'),
	(223337, 119, '2014-03-01 01:14:52.000000', 'temperatura', 1114.0000, 'ºC'),
	(223338, 119, '2014-03-01 01:14:53.000000', 'temperatura', 192.0000, 'ºC'),
	(223339, 119, '2014-03-01 01:14:54.000000', 'temperatura', 19.0000, 'ºC'),
	(223340, 119, '2014-03-01 01:14:55.000000', 'temperatura', 720.0000, 'ºC'),
	(223341, 119, '2014-03-01 01:14:56.000000', 'temperatura', 1145.0000, 'ºC'),
	(223342, 119, '2014-03-01 01:14:57.000000', 'temperatura', 1162.0000, 'ºC'),
	(223343, 119, '2014-03-01 01:14:58.000000', 'temperatura', 1178.0000, 'ºC'),
	(223344, 119, '2014-03-01 01:14:59.000000', 'temperatura', 3.0000, 'ºC'),
	(223345, 119, '2014-03-01 01:15:00.000000', 'temperatura', 84.0000, 'ºC'),
	(223346, 119, '2014-03-01 01:15:01.000000', 'temperatura', 410.0000, 'ºC'),
	(223347, 119, '2014-03-01 01:15:02.000000', 'temperatura', 597.0000, 'ºC'),
	(223348, 119, '2014-03-01 01:15:03.000000', 'temperatura', 557.0000, 'ºC'),
	(223349, 119, '2014-03-01 01:15:04.000000', 'temperatura', 996.0000, 'ºC'),
	(223350, 119, '2014-03-01 01:15:05.000000', 'temperatura', 906.0000, 'ºC'),
	(223351, 119, '2014-03-01 01:15:06.000000', 'temperatura', 345.0000, 'ºC'),
	(223352, 119, '2014-03-01 01:15:07.000000', 'temperatura', 207.0000, 'ºC'),
	(223353, 119, '2014-03-01 01:15:08.000000', 'temperatura', 0.0000, 'ºC'),
	(223354, 119, '2014-03-01 01:15:09.000000', 'temperatura', 579.0000, 'ºC'),
	(223355, 119, '2014-03-01 01:15:10.000000', 'temperatura', 494.0000, 'ºC'),
	(223356, 119, '2014-03-01 01:15:11.000000', 'temperatura', 735.0000, 'ºC'),
	(223357, 119, '2014-03-01 01:15:12.000000', 'temperatura', 993.0000, 'ºC'),
	(223358, 119, '2014-03-01 01:15:13.000000', 'temperatura', 363.0000, 'ºC'),
	(223359, 119, '2014-03-01 01:15:14.000000', 'temperatura', 34.0000, 'ºC'),
	(223360, 119, '2014-03-01 01:15:15.000000', 'temperatura', 280.0000, 'ºC'),
	(223361, 119, '2014-03-01 01:15:16.000000', 'temperatura', 101.0000, 'ºC'),
	(223362, 119, '2014-03-01 01:15:17.000000', 'temperatura', 867.0000, 'ºC'),
	(223363, 119, '2014-03-01 01:15:18.000000', 'temperatura', 429.0000, 'ºC'),
	(223364, 119, '2014-03-01 01:15:19.000000', 'temperatura', 747.0000, 'ºC'),
	(223365, 119, '2014-03-01 01:15:20.000000', 'temperatura', 49.0000, 'ºC'),
	(223366, 119, '2014-03-01 01:15:21.000000', 'temperatura', 406.0000, 'ºC'),
	(223367, 119, '2014-03-01 01:15:22.000000', 'temperatura', 681.0000, 'ºC'),
	(223368, 119, '2014-03-01 01:15:23.000000', 'temperatura', 986.0000, 'ºC'),
	(223369, 119, '2014-03-01 01:15:24.000000', 'temperatura', 489.0000, 'ºC'),
	(223370, 119, '2014-03-01 01:15:25.000000', 'temperatura', 689.0000, 'ºC'),
	(223371, 119, '2014-03-01 01:15:26.000000', 'temperatura', 776.0000, 'ºC'),
	(223372, 119, '2014-03-01 01:15:27.000000', 'temperatura', 614.0000, 'ºC'),
	(223373, 119, '2014-03-01 01:15:28.000000', 'temperatura', 742.0000, 'ºC'),
	(223374, 119, '2014-03-01 01:15:29.000000', 'temperatura', 667.0000, 'ºC'),
	(223375, 119, '2014-03-01 01:15:30.000000', 'temperatura', 1113.0000, 'ºC'),
	(223376, 119, '2014-03-01 01:15:31.000000', 'temperatura', 1162.0000, 'ºC'),
	(223377, 119, '2014-03-01 01:15:32.000000', 'temperatura', 73.0000, 'ºC'),
	(223378, 119, '2014-03-01 01:15:33.000000', 'temperatura', 480.0000, 'ºC'),
	(223379, 119, '2014-03-01 01:15:34.000000', 'temperatura', 982.0000, 'ºC'),
	(223380, 119, '2014-03-01 01:15:35.000000', 'temperatura', 1071.0000, 'ºC'),
	(223381, 119, '2014-03-01 01:15:36.000000', 'temperatura', 9.0000, 'ºC'),
	(223382, 119, '2014-03-01 01:15:37.000000', 'temperatura', 432.0000, 'ºC'),
	(223383, 119, '2014-03-01 01:15:38.000000', 'temperatura', 934.0000, 'ºC'),
	(223384, 119, '2014-03-01 01:15:39.000000', 'temperatura', 976.0000, 'ºC'),
	(223385, 119, '2014-03-01 01:15:40.000000', 'temperatura', 878.0000, 'ºC'),
	(223386, 119, '2014-03-01 01:15:41.000000', 'temperatura', 261.0000, 'ºC'),
	(223387, 119, '2014-03-01 01:15:42.000000', 'temperatura', 1072.0000, 'ºC'),
	(223388, 119, '2014-03-01 01:15:43.000000', 'temperatura', 978.0000, 'ºC'),
	(223389, 119, '2014-03-01 01:15:44.000000', 'temperatura', 476.0000, 'ºC'),
	(223390, 119, '2014-03-01 01:15:45.000000', 'temperatura', 647.0000, 'ºC'),
	(223391, 119, '2014-03-01 01:15:46.000000', 'temperatura', 606.0000, 'ºC'),
	(223392, 119, '2014-03-01 01:15:47.000000', 'temperatura', 1089.0000, 'ºC'),
	(223393, 119, '2014-03-01 01:15:48.000000', 'temperatura', 29.0000, 'ºC'),
	(223394, 119, '2014-03-01 01:15:49.000000', 'temperatura', 479.0000, 'ºC'),
	(223395, 119, '2014-03-01 01:15:50.000000', 'temperatura', 1107.0000, 'ºC'),
	(223396, 119, '2014-03-01 01:15:51.000000', 'temperatura', 498.0000, 'ºC'),
	(223397, 119, '2014-03-01 01:15:52.000000', 'temperatura', 370.0000, 'ºC'),
	(223398, 119, '2014-03-01 01:15:53.000000', 'temperatura', 357.0000, 'ºC'),
	(223399, 119, '2014-03-01 01:15:54.000000', 'temperatura', 673.0000, 'ºC'),
	(223400, 119, '2014-03-01 01:15:55.000000', 'temperatura', 1097.0000, 'ºC'),
	(223401, 119, '2014-03-01 01:15:56.000000', 'temperatura', 1065.0000, 'ºC'),
	(223402, 119, '2014-03-01 01:15:57.000000', 'temperatura', 835.0000, 'ºC'),
	(223403, 120, '2014-03-01 00:00:00.000000', 'temperatura', 1.0000, 'ºC'),
	(223404, 120, '2014-03-01 00:00:01.000000', 'temperatura', 663.0000, 'ºC'),
	(223405, 120, '2014-03-01 00:00:02.000000', 'temperatura', 913.0000, 'ºC'),
	(223406, 120, '2014-03-01 00:00:03.000000', 'temperatura', 174.0000, 'ºC'),
	(223407, 120, '2014-03-01 00:00:04.000000', 'temperatura', 534.0000, 'ºC'),
	(223408, 120, '2014-03-01 00:00:05.000000', 'temperatura', 949.0000, 'ºC'),
	(223409, 120, '2014-03-01 00:00:06.000000', 'temperatura', 741.0000, 'ºC'),
	(223410, 120, '2014-03-01 00:00:07.000000', 'temperatura', 859.0000, 'ºC'),
	(223411, 120, '2014-03-01 00:00:08.000000', 'temperatura', 871.0000, 'ºC'),
	(223412, 120, '2014-03-01 00:00:09.000000', 'temperatura', 579.0000, 'ºC'),
	(223413, 120, '2014-03-01 00:00:10.000000', 'temperatura', 283.0000, 'ºC'),
	(223414, 120, '2014-03-01 00:00:11.000000', 'temperatura', 881.0000, 'ºC'),
	(223415, 120, '2014-03-01 00:00:12.000000', 'temperatura', 1153.0000, 'ºC'),
	(223416, 120, '2014-03-01 00:00:13.000000', 'temperatura', 723.0000, 'ºC'),
	(223417, 120, '2014-03-01 00:00:14.000000', 'temperatura', 156.0000, 'ºC'),
	(223418, 120, '2014-03-01 00:00:15.000000', 'temperatura', 1012.0000, 'ºC'),
	(223419, 120, '2014-03-01 00:00:16.000000', 'temperatura', 992.0000, 'ºC'),
	(223420, 120, '2014-03-01 00:00:17.000000', 'temperatura', 725.0000, 'ºC'),
	(223421, 120, '2014-03-01 00:00:18.000000', 'temperatura', 649.0000, 'ºC'),
	(223422, 120, '2014-03-01 00:00:19.000000', 'temperatura', 1072.0000, 'ºC'),
	(223423, 120, '2014-03-01 00:00:20.000000', 'temperatura', 1012.0000, 'ºC'),
	(223424, 120, '2014-03-01 00:00:21.000000', 'temperatura', 643.0000, 'ºC'),
	(223425, 120, '2014-03-01 00:00:22.000000', 'temperatura', 181.0000, 'ºC'),
	(223426, 120, '2014-03-01 00:00:23.000000', 'temperatura', 178.0000, 'ºC'),
	(223427, 120, '2014-03-01 00:00:24.000000', 'temperatura', 348.0000, 'ºC'),
	(223428, 120, '2014-03-01 00:00:25.000000', 'temperatura', 5.0000, 'ºC'),
	(223429, 120, '2014-03-01 00:00:26.000000', 'temperatura', 183.0000, 'ºC'),
	(223430, 120, '2014-03-01 00:00:27.000000', 'temperatura', 901.0000, 'ºC'),
	(223431, 120, '2014-03-01 00:00:28.000000', 'temperatura', 355.0000, 'ºC'),
	(223432, 120, '2014-03-01 00:00:29.000000', 'temperatura', 273.0000, 'ºC'),
	(223433, 120, '2014-03-01 00:00:30.000000', 'temperatura', 301.0000, 'ºC'),
	(223434, 120, '2014-03-01 00:00:31.000000', 'temperatura', 686.0000, 'ºC'),
	(223435, 120, '2014-03-01 00:00:32.000000', 'temperatura', 128.0000, 'ºC'),
	(223436, 120, '2014-03-01 00:00:33.000000', 'temperatura', 982.0000, 'ºC'),
	(223437, 120, '2014-03-01 00:00:34.000000', 'temperatura', 928.0000, 'ºC'),
	(223438, 120, '2014-03-01 00:00:35.000000', 'temperatura', 492.0000, 'ºC'),
	(223439, 120, '2014-03-01 00:00:36.000000', 'temperatura', 877.0000, 'ºC'),
	(223440, 120, '2014-03-01 00:00:37.000000', 'temperatura', 509.0000, 'ºC'),
	(223441, 120, '2014-03-01 00:00:38.000000', 'temperatura', 1114.0000, 'ºC'),
	(223442, 120, '2014-03-01 00:00:39.000000', 'temperatura', 443.0000, 'ºC'),
	(223443, 120, '2014-03-01 00:00:40.000000', 'temperatura', 75.0000, 'ºC'),
	(223444, 120, '2014-03-01 00:00:41.000000', 'temperatura', 246.0000, 'ºC'),
	(223445, 120, '2014-03-01 00:00:42.000000', 'temperatura', 1005.0000, 'ºC'),
	(223446, 120, '2014-03-01 00:00:43.000000', 'temperatura', 688.0000, 'ºC'),
	(223447, 120, '2014-03-01 00:00:44.000000', 'temperatura', 426.0000, 'ºC'),
	(223448, 120, '2014-03-01 00:00:45.000000', 'temperatura', 65.0000, 'ºC'),
	(223449, 120, '2014-03-01 00:00:46.000000', 'temperatura', 248.0000, 'ºC'),
	(223450, 120, '2014-03-01 00:00:47.000000', 'temperatura', 1046.0000, 'ºC'),
	(223451, 120, '2014-03-01 00:00:48.000000', 'temperatura', 885.0000, 'ºC'),
	(223452, 120, '2014-03-01 00:00:49.000000', 'temperatura', 89.0000, 'ºC'),
	(223453, 120, '2014-03-01 00:00:50.000000', 'temperatura', 191.0000, 'ºC'),
	(223454, 120, '2014-03-01 00:00:51.000000', 'temperatura', 686.0000, 'ºC'),
	(223455, 120, '2014-03-01 00:00:52.000000', 'temperatura', 459.0000, 'ºC'),
	(223456, 120, '2014-03-01 00:00:53.000000', 'temperatura', 236.0000, 'ºC'),
	(223457, 120, '2014-03-01 00:00:54.000000', 'temperatura', 1004.0000, 'ºC'),
	(223458, 120, '2014-03-01 00:00:55.000000', 'temperatura', 712.0000, 'ºC'),
	(223459, 120, '2014-03-01 00:00:56.000000', 'temperatura', 549.0000, 'ºC'),
	(223460, 120, '2014-03-01 00:00:57.000000', 'temperatura', 609.0000, 'ºC'),
	(223461, 120, '2014-03-01 00:00:58.000000', 'temperatura', 200.0000, 'ºC'),
	(223462, 120, '2014-03-01 00:00:59.000000', 'temperatura', 374.0000, 'ºC'),
	(223463, 120, '2014-03-01 00:01:00.000000', 'temperatura', 70.0000, 'ºC'),
	(223464, 120, '2014-03-01 00:01:01.000000', 'temperatura', 427.0000, 'ºC'),
	(223465, 120, '2014-03-01 00:01:02.000000', 'temperatura', 726.0000, 'ºC'),
	(223466, 120, '2014-03-01 00:01:03.000000', 'temperatura', 1151.0000, 'ºC'),
	(223467, 120, '2014-03-01 00:01:04.000000', 'temperatura', 1175.0000, 'ºC'),
	(223468, 120, '2014-03-01 00:01:05.000000', 'temperatura', 22.0000, 'ºC'),
	(223469, 120, '2014-03-01 00:01:06.000000', 'temperatura', 186.0000, 'ºC'),
	(223470, 120, '2014-03-01 00:01:07.000000', 'temperatura', 863.0000, 'ºC'),
	(223471, 120, '2014-03-01 00:01:08.000000', 'temperatura', 158.0000, 'ºC'),
	(223472, 120, '2014-03-01 00:01:09.000000', 'temperatura', 603.0000, 'ºC'),
	(223473, 120, '2014-03-01 00:01:10.000000', 'temperatura', 143.0000, 'ºC'),
	(223474, 120, '2014-03-01 00:01:11.000000', 'temperatura', 105.0000, 'ºC'),
	(223475, 120, '2014-03-01 00:01:12.000000', 'temperatura', 96.0000, 'ºC'),
	(223476, 120, '2014-03-01 00:01:13.000000', 'temperatura', 167.0000, 'ºC'),
	(223477, 120, '2014-03-01 00:01:14.000000', 'temperatura', 548.0000, 'ºC'),
	(223478, 120, '2014-03-01 00:01:15.000000', 'temperatura', 1040.0000, 'ºC'),
	(223479, 120, '2014-03-01 00:01:16.000000', 'temperatura', 1157.0000, 'ºC'),
	(223480, 120, '2014-03-01 00:01:17.000000', 'temperatura', 265.0000, 'ºC'),
	(223481, 120, '2014-03-01 00:01:18.000000', 'temperatura', 255.0000, 'ºC'),
	(223482, 120, '2014-03-01 00:01:19.000000', 'temperatura', 482.0000, 'ºC'),
	(223483, 120, '2014-03-01 00:01:20.000000', 'temperatura', 442.0000, 'ºC'),
	(223484, 120, '2014-03-01 00:01:21.000000', 'temperatura', 766.0000, 'ºC'),
	(223485, 120, '2014-03-01 00:01:22.000000', 'temperatura', 103.0000, 'ºC'),
	(223486, 120, '2014-03-01 00:01:23.000000', 'temperatura', 619.0000, 'ºC'),
	(223487, 120, '2014-03-01 00:01:24.000000', 'temperatura', 386.0000, 'ºC'),
	(223488, 120, '2014-03-01 00:01:25.000000', 'temperatura', 75.0000, 'ºC'),
	(223489, 120, '2014-03-01 00:01:26.000000', 'temperatura', 415.0000, 'ºC'),
	(223490, 120, '2014-03-01 00:01:27.000000', 'temperatura', 651.0000, 'ºC'),
	(223491, 120, '2014-03-01 00:01:28.000000', 'temperatura', 812.0000, 'ºC'),
	(223492, 120, '2014-03-01 00:01:29.000000', 'temperatura', 908.0000, 'ºC'),
	(223493, 120, '2014-03-01 00:01:30.000000', 'temperatura', 904.0000, 'ºC'),
	(223494, 120, '2014-03-01 00:01:31.000000', 'temperatura', 595.0000, 'ºC'),
	(223495, 120, '2014-03-01 00:01:32.000000', 'temperatura', 266.0000, 'ºC'),
	(223496, 120, '2014-03-01 00:01:33.000000', 'temperatura', 746.0000, 'ºC'),
	(223497, 120, '2014-03-01 00:01:34.000000', 'temperatura', 532.0000, 'ºC'),
	(223498, 120, '2014-03-01 00:01:35.000000', 'temperatura', 422.0000, 'ºC'),
	(223499, 120, '2014-03-01 00:01:36.000000', 'temperatura', 516.0000, 'ºC'),
	(223500, 120, '2014-03-01 00:01:37.000000', 'temperatura', 114.0000, 'ºC'),
	(223501, 120, '2014-03-01 00:01:38.000000', 'temperatura', 224.0000, 'ºC'),
	(223502, 120, '2014-03-01 00:01:39.000000', 'temperatura', 777.0000, 'ºC'),
	(223503, 120, '2014-03-01 00:01:40.000000', 'temperatura', 814.0000, 'ºC'),
	(223504, 120, '2014-03-01 00:01:41.000000', 'temperatura', 539.0000, 'ºC'),
	(223505, 120, '2014-03-01 00:01:42.000000', 'temperatura', 252.0000, 'ºC'),
	(223506, 120, '2014-03-01 00:01:43.000000', 'temperatura', 846.0000, 'ºC'),
	(223507, 120, '2014-03-01 00:01:44.000000', 'temperatura', 1074.0000, 'ºC'),
	(223508, 120, '2014-03-01 00:01:45.000000', 'temperatura', 431.0000, 'ºC'),
	(223509, 120, '2014-03-01 00:01:46.000000', 'temperatura', 133.0000, 'ºC'),
	(223510, 120, '2014-03-01 00:01:47.000000', 'temperatura', 573.0000, 'ºC'),
	(223511, 120, '2014-03-01 00:01:48.000000', 'temperatura', 67.0000, 'ºC'),
	(223512, 120, '2014-03-01 00:01:49.000000', 'temperatura', 1018.0000, 'ºC'),
	(223513, 120, '2014-03-01 00:01:50.000000', 'temperatura', 87.0000, 'ºC'),
	(223514, 120, '2014-03-01 00:01:51.000000', 'temperatura', 982.0000, 'ºC'),
	(223515, 120, '2014-03-01 00:01:52.000000', 'temperatura', 1049.0000, 'ºC'),
	(223516, 120, '2014-03-01 00:01:53.000000', 'temperatura', 1102.0000, 'ºC'),
	(223517, 120, '2014-03-01 00:01:54.000000', 'temperatura', 1161.0000, 'ºC'),
	(223518, 120, '2014-03-01 00:01:55.000000', 'temperatura', 101.0000, 'ºC'),
	(223519, 120, '2014-03-01 00:01:56.000000', 'temperatura', 622.0000, 'ºC'),
	(223520, 120, '2014-03-01 00:01:57.000000', 'temperatura', 407.0000, 'ºC'),
	(223521, 120, '2014-03-01 00:01:58.000000', 'temperatura', 168.0000, 'ºC'),
	(223522, 120, '2014-03-01 00:01:59.000000', 'temperatura', 820.0000, 'ºC'),
	(223523, 120, '2014-03-01 00:02:00.000000', 'temperatura', 1199.0000, 'ºC'),
	(223524, 120, '2014-03-01 00:02:01.000000', 'temperatura', 1132.0000, 'ºC'),
	(223525, 120, '2014-03-01 00:02:02.000000', 'temperatura', 866.0000, 'ºC'),
	(223526, 120, '2014-03-01 00:02:03.000000', 'temperatura', 935.0000, 'ºC'),
	(223527, 120, '2014-03-01 00:02:04.000000', 'temperatura', 878.0000, 'ºC'),
	(223528, 120, '2014-03-01 00:02:05.000000', 'temperatura', 383.0000, 'ºC'),
	(223529, 120, '2014-03-01 00:02:06.000000', 'temperatura', 483.0000, 'ºC'),
	(223530, 120, '2014-03-01 00:02:07.000000', 'temperatura', 65.0000, 'ºC'),
	(223531, 120, '2014-03-01 00:02:08.000000', 'temperatura', 77.0000, 'ºC'),
	(223532, 120, '2014-03-01 00:02:09.000000', 'temperatura', 191.0000, 'ºC'),
	(223533, 120, '2014-03-01 00:02:10.000000', 'temperatura', 724.0000, 'ºC'),
	(223534, 120, '2014-03-01 00:02:11.000000', 'temperatura', 649.0000, 'ºC'),
	(223535, 120, '2014-03-01 00:02:12.000000', 'temperatura', 1074.0000, 'ºC'),
	(223536, 120, '2014-03-01 00:02:13.000000', 'temperatura', 1023.0000, 'ºC'),
	(223537, 120, '2014-03-01 00:02:14.000000', 'temperatura', 691.0000, 'ºC'),
	(223538, 120, '2014-03-01 00:02:15.000000', 'temperatura', 388.0000, 'ºC'),
	(223539, 120, '2014-03-01 00:02:16.000000', 'temperatura', 1069.0000, 'ºC'),
	(223540, 120, '2014-03-01 00:02:17.000000', 'temperatura', 582.0000, 'ºC'),
	(223541, 120, '2014-03-01 00:02:18.000000', 'temperatura', 901.0000, 'ºC'),
	(223542, 120, '2014-03-01 00:02:19.000000', 'temperatura', 358.0000, 'ºC'),
	(223543, 120, '2014-03-01 00:02:20.000000', 'temperatura', 291.0000, 'ºC'),
	(223544, 120, '2014-03-01 00:02:21.000000', 'temperatura', 381.0000, 'ºC'),
	(223545, 120, '2014-03-01 00:02:22.000000', 'temperatura', 1032.0000, 'ºC'),
	(223546, 120, '2014-03-01 00:02:23.000000', 'temperatura', 417.0000, 'ºC'),
	(223547, 120, '2014-03-01 00:02:24.000000', 'temperatura', 192.0000, 'ºC'),
	(223548, 120, '2014-03-01 00:02:25.000000', 'temperatura', 908.0000, 'ºC'),
	(223549, 120, '2014-03-01 00:02:26.000000', 'temperatura', 364.0000, 'ºC'),
	(223550, 120, '2014-03-01 00:02:27.000000', 'temperatura', 296.0000, 'ºC'),
	(223551, 120, '2014-03-01 00:02:28.000000', 'temperatura', 388.0000, 'ºC'),
	(223552, 120, '2014-03-01 00:02:29.000000', 'temperatura', 1051.0000, 'ºC'),
	(223553, 120, '2014-03-01 00:02:30.000000', 'temperatura', 494.0000, 'ºC'),
	(223554, 120, '2014-03-01 00:02:31.000000', 'temperatura', 516.0000, 'ºC'),
	(223555, 120, '2014-03-01 00:02:32.000000', 'temperatura', 1099.0000, 'ºC'),
	(223556, 120, '2014-03-01 00:02:33.000000', 'temperatura', 349.0000, 'ºC'),
	(223557, 120, '2014-03-01 00:02:34.000000', 'temperatura', 847.0000, 'ºC'),
	(223558, 120, '2014-03-01 00:02:35.000000', 'temperatura', 788.0000, 'ºC'),
	(223559, 120, '2014-03-01 00:02:36.000000', 'temperatura', 201.0000, 'ºC'),
	(223560, 120, '2014-03-01 00:02:37.000000', 'temperatura', 1040.0000, 'ºC'),
	(223561, 120, '2014-03-01 00:02:38.000000', 'temperatura', 998.0000, 'ºC'),
	(223562, 120, '2014-03-01 00:02:39.000000', 'temperatura', 669.0000, 'ºC'),
	(223563, 120, '2014-03-01 00:02:40.000000', 'temperatura', 351.0000, 'ºC'),
	(223564, 120, '2014-03-01 00:02:41.000000', 'temperatura', 951.0000, 'ºC'),
	(223565, 120, '2014-03-01 00:02:42.000000', 'temperatura', 100.0000, 'ºC'),
	(223566, 120, '2014-03-01 00:02:43.000000', 'temperatura', 49.0000, 'ºC'),
	(223567, 120, '2014-03-01 00:02:44.000000', 'temperatura', 1144.0000, 'ºC'),
	(223568, 120, '2014-03-01 00:02:45.000000', 'temperatura', 773.0000, 'ºC'),
	(223569, 120, '2014-03-01 00:02:46.000000', 'temperatura', 436.0000, 'ºC'),
	(223570, 120, '2014-03-01 00:02:47.000000', 'temperatura', 1062.0000, 'ºC'),
	(223571, 120, '2014-03-01 00:02:48.000000', 'temperatura', 402.0000, 'ºC'),
	(223572, 120, '2014-03-01 00:02:49.000000', 'temperatura', 26.0000, 'ºC'),
	(223573, 120, '2014-03-01 00:02:50.000000', 'temperatura', 122.0000, 'ºC'),
	(223574, 120, '2014-03-01 00:02:51.000000', 'temperatura', 533.0000, 'ºC'),
	(223575, 120, '2014-03-01 00:02:52.000000', 'temperatura', 1098.0000, 'ºC'),
	(223576, 120, '2014-03-01 00:02:53.000000', 'temperatura', 292.0000, 'ºC'),
	(223577, 120, '2014-03-01 00:02:54.000000', 'temperatura', 567.0000, 'ºC'),
	(223578, 120, '2014-03-01 00:02:55.000000', 'temperatura', 761.0000, 'ºC'),
	(223579, 120, '2014-03-01 00:02:56.000000', 'temperatura', 904.0000, 'ºC'),
	(223580, 120, '2014-03-01 00:02:57.000000', 'temperatura', 1035.0000, 'ºC'),
	(223581, 120, '2014-03-01 00:02:58.000000', 'temperatura', 66.0000, 'ºC'),
	(223582, 120, '2014-03-01 00:02:59.000000', 'temperatura', 826.0000, 'ºC'),
	(223583, 120, '2014-03-01 00:03:00.000000', 'temperatura', 331.0000, 'ºC'),
	(223584, 120, '2014-03-01 00:03:01.000000', 'temperatura', 379.0000, 'ºC'),
	(223585, 120, '2014-03-01 00:03:02.000000', 'temperatura', 900.0000, 'ºC'),
	(223586, 120, '2014-03-01 00:03:03.000000', 'temperatura', 965.0000, 'ºC'),
	(223587, 120, '2014-03-01 00:03:04.000000', 'temperatura', 927.0000, 'ºC'),
	(223588, 120, '2014-03-01 00:03:05.000000', 'temperatura', 539.0000, 'ºC'),
	(223589, 120, '2014-03-01 00:03:06.000000', 'temperatura', 1116.0000, 'ºC'),
	(223590, 120, '2014-03-01 00:03:07.000000', 'temperatura', 363.0000, 'ºC'),
	(223591, 120, '2014-03-01 00:03:08.000000', 'temperatura', 869.0000, 'ºC'),
	(223592, 120, '2014-03-01 00:03:09.000000', 'temperatura', 854.0000, 'ºC'),
	(223593, 120, '2014-03-01 00:03:10.000000', 'temperatura', 463.0000, 'ºC'),
	(223594, 120, '2014-03-01 00:03:11.000000', 'temperatura', 954.0000, 'ºC'),
	(223595, 120, '2014-03-01 00:03:12.000000', 'temperatura', 980.0000, 'ºC'),
	(223596, 120, '2014-03-01 00:03:13.000000', 'temperatura', 840.0000, 'ºC'),
	(223597, 120, '2014-03-01 00:03:14.000000', 'temperatura', 61.0000, 'ºC'),
	(223598, 120, '2014-03-01 00:03:15.000000', 'temperatura', 185.0000, 'ºC'),
	(223599, 120, '2014-03-01 00:03:16.000000', 'temperatura', 741.0000, 'ºC'),
	(223600, 120, '2014-03-01 00:03:17.000000', 'temperatura', 753.0000, 'ºC'),
	(223601, 120, '2014-03-01 00:03:18.000000', 'temperatura', 340.0000, 'ºC'),
	(223602, 120, '2014-03-01 00:03:19.000000', 'temperatura', 642.0000, 'ºC'),
	(223603, 120, '2014-03-01 00:03:20.000000', 'temperatura', 990.0000, 'ºC'),
	(223604, 120, '2014-03-01 00:03:21.000000', 'temperatura', 623.0000, 'ºC'),
	(223605, 120, '2014-03-01 00:03:22.000000', 'temperatura', 148.0000, 'ºC'),
	(223606, 120, '2014-03-01 00:03:23.000000', 'temperatura', 70.0000, 'ºC'),
	(223607, 120, '2014-03-01 00:03:24.000000', 'temperatura', 1108.0000, 'ºC'),
	(223608, 120, '2014-03-01 00:03:25.000000', 'temperatura', 532.0000, 'ºC'),
	(223609, 120, '2014-03-01 00:03:26.000000', 'temperatura', 534.0000, 'ºC'),
	(223610, 120, '2014-03-01 00:03:27.000000', 'temperatura', 1075.0000, 'ºC'),
	(223611, 120, '2014-03-01 00:03:28.000000', 'temperatura', 173.0000, 'ºC'),
	(223612, 120, '2014-03-01 00:03:29.000000', 'temperatura', 42.0000, 'ºC'),
	(223613, 120, '2014-03-01 00:03:30.000000', 'temperatura', 889.0000, 'ºC'),
	(223614, 120, '2014-03-01 00:03:31.000000', 'temperatura', 721.0000, 'ºC'),
	(223615, 120, '2014-03-01 00:03:32.000000', 'temperatura', 940.0000, 'ºC'),
	(223616, 120, '2014-03-01 00:03:33.000000', 'temperatura', 134.0000, 'ºC'),
	(223617, 120, '2014-03-01 00:03:34.000000', 'temperatura', 253.0000, 'ºC'),
	(223618, 120, '2014-03-01 00:03:35.000000', 'temperatura', 864.0000, 'ºC'),
	(223619, 120, '2014-03-01 00:03:36.000000', 'temperatura', 1162.0000, 'ºC'),
	(223620, 120, '2014-03-01 00:03:37.000000', 'temperatura', 819.0000, 'ºC'),
	(223621, 120, '2014-03-01 00:03:38.000000', 'temperatura', 608.0000, 'ºC'),
	(223622, 120, '2014-03-01 00:03:39.000000', 'temperatura', 583.0000, 'ºC'),
	(223623, 120, '2014-03-01 00:03:40.000000', 'temperatura', 1091.0000, 'ºC'),
	(223624, 120, '2014-03-01 00:03:41.000000', 'temperatura', 106.0000, 'ºC'),
	(223625, 120, '2014-03-01 00:03:42.000000', 'temperatura', 859.0000, 'ºC'),
	(223626, 120, '2014-03-01 00:03:43.000000', 'temperatura', 377.0000, 'ºC'),
	(223627, 120, '2014-03-01 00:03:44.000000', 'temperatura', 510.0000, 'ºC'),
	(223628, 120, '2014-03-01 00:03:45.000000', 'temperatura', 219.0000, 'ºC'),
	(223629, 120, '2014-03-01 00:03:46.000000', 'temperatura', 767.0000, 'ºC'),
	(223630, 120, '2014-03-01 00:03:47.000000', 'temperatura', 778.0000, 'ºC'),
	(223631, 120, '2014-03-01 00:03:48.000000', 'temperatura', 390.0000, 'ºC'),
	(223632, 120, '2014-03-01 00:03:49.000000', 'temperatura', 814.0000, 'ºC'),
	(223633, 120, '2014-03-01 00:03:50.000000', 'temperatura', 504.0000, 'ºC'),
	(223634, 120, '2014-03-01 00:03:51.000000', 'temperatura', 76.0000, 'ºC'),
	(223635, 120, '2014-03-01 00:03:52.000000', 'temperatura', 69.0000, 'ºC'),
	(223636, 120, '2014-03-01 00:03:53.000000', 'temperatura', 119.0000, 'ºC'),
	(223637, 120, '2014-03-01 00:03:54.000000', 'temperatura', 386.0000, 'ºC'),
	(223638, 120, '2014-03-01 00:03:55.000000', 'temperatura', 377.0000, 'ºC'),
	(223639, 120, '2014-03-01 00:03:56.000000', 'temperatura', 725.0000, 'ºC'),
	(223640, 120, '2014-03-01 00:03:57.000000', 'temperatura', 93.0000, 'ºC'),
	(223641, 120, '2014-03-01 00:03:58.000000', 'temperatura', 692.0000, 'ºC'),
	(223642, 120, '2014-03-01 00:03:59.000000', 'temperatura', 782.0000, 'ºC'),
	(223643, 120, '2014-03-01 00:04:00.000000', 'temperatura', 636.0000, 'ºC'),
	(223644, 120, '2014-03-01 00:04:01.000000', 'temperatura', 833.0000, 'ºC'),
	(223645, 120, '2014-03-01 00:04:02.000000', 'temperatura', 1056.0000, 'ºC'),
	(223646, 120, '2014-03-01 00:04:03.000000', 'temperatura', 383.0000, 'ºC'),
	(223647, 120, '2014-03-01 00:04:04.000000', 'temperatura', 1146.0000, 'ºC'),
	(223648, 120, '2014-03-01 00:04:05.000000', 'temperatura', 984.0000, 'ºC'),
	(223649, 120, '2014-03-01 00:04:06.000000', 'temperatura', 281.0000, 'ºC'),
	(223650, 120, '2014-03-01 00:04:07.000000', 'temperatura', 854.0000, 'ºC'),
	(223651, 120, '2014-03-01 00:04:08.000000', 'temperatura', 1027.0000, 'ºC'),
	(223652, 120, '2014-03-01 00:04:09.000000', 'temperatura', 175.0000, 'ºC'),
	(223653, 120, '2014-03-01 00:04:10.000000', 'temperatura', 193.0000, 'ºC'),
	(223654, 120, '2014-03-01 00:04:11.000000', 'temperatura', 440.0000, 'ºC'),
	(223655, 120, '2014-03-01 00:04:12.000000', 'temperatura', 422.0000, 'ºC'),
	(223656, 120, '2014-03-01 00:04:13.000000', 'temperatura', 793.0000, 'ºC'),
	(223657, 120, '2014-03-01 00:04:14.000000', 'temperatura', 296.0000, 'ºC'),
	(223658, 120, '2014-03-01 00:04:15.000000', 'temperatura', 305.0000, 'ºC'),
	(223659, 120, '2014-03-01 00:04:16.000000', 'temperatura', 634.0000, 'ºC'),
	(223660, 120, '2014-03-01 00:04:17.000000', 'temperatura', 1057.0000, 'ºC'),
	(223661, 120, '2014-03-01 00:04:18.000000', 'temperatura', 982.0000, 'ºC'),
	(223662, 120, '2014-03-01 00:04:19.000000', 'temperatura', 540.0000, 'ºC'),
	(223663, 120, '2014-03-01 00:04:20.000000', 'temperatura', 956.0000, 'ºC'),
	(223664, 120, '2014-03-01 00:04:21.000000', 'temperatura', 758.0000, 'ºC'),
	(223665, 120, '2014-03-01 00:04:22.000000', 'temperatura', 924.0000, 'ºC'),
	(223666, 120, '2014-03-01 00:04:23.000000', 'temperatura', 1145.0000, 'ºC'),
	(223667, 120, '2014-03-01 00:04:24.000000', 'temperatura', 553.0000, 'ºC'),
	(223668, 120, '2014-03-01 00:04:25.000000', 'temperatura', 531.0000, 'ºC'),
	(223669, 120, '2014-03-01 00:04:26.000000', 'temperatura', 998.0000, 'ºC'),
	(223670, 120, '2014-03-01 00:04:27.000000', 'temperatura', 997.0000, 'ºC'),
	(223671, 120, '2014-03-01 00:04:28.000000', 'temperatura', 790.0000, 'ºC'),
	(223672, 120, '2014-03-01 00:04:29.000000', 'temperatura', 961.0000, 'ºC'),
	(223673, 120, '2014-03-01 00:04:30.000000', 'temperatura', 34.0000, 'ºC'),
	(223674, 120, '2014-03-01 00:04:31.000000', 'temperatura', 888.0000, 'ºC'),
	(223675, 120, '2014-03-01 00:04:32.000000', 'temperatura', 737.0000, 'ºC'),
	(223676, 120, '2014-03-01 00:04:33.000000', 'temperatura', 1023.0000, 'ºC'),
	(223677, 120, '2014-03-01 00:04:34.000000', 'temperatura', 505.0000, 'ºC'),
	(223678, 120, '2014-03-01 00:04:35.000000', 'temperatura', 657.0000, 'ºC'),
	(223679, 120, '2014-03-01 00:04:36.000000', 'temperatura', 568.0000, 'ºC'),
	(223680, 120, '2014-03-01 00:04:37.000000', 'temperatura', 873.0000, 'ºC'),
	(223681, 120, '2014-03-01 00:04:38.000000', 'temperatura', 259.0000, 'ºC'),
	(223682, 120, '2014-03-01 00:04:39.000000', 'temperatura', 1076.0000, 'ºC'),
	(223683, 120, '2014-03-01 00:04:40.000000', 'temperatura', 1004.0000, 'ºC'),
	(223684, 120, '2014-03-01 00:04:41.000000', 'temperatura', 591.0000, 'ºC'),
	(223685, 120, '2014-03-01 00:04:42.000000', 'temperatura', 1144.0000, 'ºC'),
	(223686, 120, '2014-03-01 00:04:43.000000', 'temperatura', 347.0000, 'ºC'),
	(223687, 120, '2014-03-01 00:04:44.000000', 'temperatura', 703.0000, 'ºC'),
	(223688, 120, '2014-03-01 00:04:45.000000', 'temperatura', 76.0000, 'ºC'),
	(223689, 120, '2014-03-01 00:04:46.000000', 'temperatura', 671.0000, 'ºC'),
	(223690, 120, '2014-03-01 00:04:47.000000', 'temperatura', 729.0000, 'ºC'),
	(223691, 120, '2014-03-01 00:04:48.000000', 'temperatura', 433.0000, 'ºC'),
	(223692, 120, '2014-03-01 00:04:49.000000', 'temperatura', 1178.0000, 'ºC'),
	(223693, 120, '2014-03-01 00:04:50.000000', 'temperatura', 993.0000, 'ºC'),
	(223694, 120, '2014-03-01 00:04:51.000000', 'temperatura', 230.0000, 'ºC'),
	(223695, 120, '2014-03-01 00:04:52.000000', 'temperatura', 571.0000, 'ºC'),
	(223696, 120, '2014-03-01 00:04:53.000000', 'temperatura', 967.0000, 'ºC'),
	(223697, 120, '2014-03-01 00:04:54.000000', 'temperatura', 724.0000, 'ºC'),
	(223698, 120, '2014-03-01 00:04:55.000000', 'temperatura', 716.0000, 'ºC'),
	(223699, 120, '2014-03-01 00:04:56.000000', 'temperatura', 210.0000, 'ºC'),
	(223700, 120, '2014-03-01 00:04:57.000000', 'temperatura', 102.0000, 'ºC'),
	(223701, 120, '2014-03-01 00:04:58.000000', 'temperatura', 1080.0000, 'ºC'),
	(223702, 120, '2014-03-01 00:04:59.000000', 'temperatura', 296.0000, 'ºC'),
	(223703, 120, '2014-03-01 00:05:00.000000', 'temperatura', 640.0000, 'ºC'),
	(223704, 120, '2014-03-01 00:05:01.000000', 'temperatura', 1113.0000, 'ºC'),
	(223705, 120, '2014-03-01 00:05:02.000000', 'temperatura', 46.0000, 'ºC'),
	(223706, 120, '2014-03-01 00:05:03.000000', 'temperatura', 491.0000, 'ºC'),
	(223707, 120, '2014-03-01 00:05:04.000000', 'temperatura', 1118.0000, 'ºC'),
	(223708, 120, '2014-03-01 00:05:05.000000', 'temperatura', 519.0000, 'ºC'),
	(223709, 120, '2014-03-01 00:05:06.000000', 'temperatura', 440.0000, 'ºC'),
	(223710, 120, '2014-03-01 00:05:07.000000', 'temperatura', 645.0000, 'ºC'),
	(223711, 120, '2014-03-01 00:05:08.000000', 'temperatura', 703.0000, 'ºC'),
	(223712, 120, '2014-03-01 00:05:09.000000', 'temperatura', 383.0000, 'ºC'),
	(223713, 120, '2014-03-01 00:05:10.000000', 'temperatura', 1007.0000, 'ºC'),
	(223714, 120, '2014-03-01 00:05:11.000000', 'temperatura', 285.0000, 'ºC'),
	(223715, 120, '2014-03-01 00:05:12.000000', 'temperatura', 806.0000, 'ºC'),
	(223716, 120, '2014-03-01 00:05:13.000000', 'temperatura', 774.0000, 'ºC'),
	(223717, 120, '2014-03-01 00:05:14.000000', 'temperatura', 254.0000, 'ºC'),
	(223718, 120, '2014-03-01 00:05:15.000000', 'temperatura', 147.0000, 'ºC'),
	(223719, 120, '2014-03-01 00:05:16.000000', 'temperatura', 1173.0000, 'ºC'),
	(223720, 120, '2014-03-01 00:05:17.000000', 'temperatura', 626.0000, 'ºC'),
	(223721, 120, '2014-03-01 00:05:18.000000', 'temperatura', 810.0000, 'ºC'),
	(223722, 120, '2014-03-01 00:05:19.000000', 'temperatura', 975.0000, 'ºC'),
	(223723, 120, '2014-03-01 00:05:20.000000', 'temperatura', 44.0000, 'ºC'),
	(223724, 120, '2014-03-01 00:05:21.000000', 'temperatura', 896.0000, 'ºC'),
	(223725, 120, '2014-03-01 00:05:22.000000', 'temperatura', 750.0000, 'ºC'),
	(223726, 120, '2014-03-01 00:05:23.000000', 'temperatura', 1061.0000, 'ºC'),
	(223727, 120, '2014-03-01 00:05:24.000000', 'temperatura', 658.0000, 'ºC'),
	(223728, 120, '2014-03-01 00:05:25.000000', 'temperatura', 104.0000, 'ºC'),
	(223729, 120, '2014-03-01 00:05:26.000000', 'temperatura', 949.0000, 'ºC'),
	(223730, 120, '2014-03-01 00:05:27.000000', 'temperatura', 835.0000, 'ºC'),
	(223731, 120, '2014-03-01 00:05:28.000000', 'temperatura', 125.0000, 'ºC'),
	(223732, 120, '2014-03-01 00:05:29.000000', 'temperatura', 523.0000, 'ºC'),
	(223733, 120, '2014-03-01 00:05:30.000000', 'temperatura', 1039.0000, 'ºC'),
	(223734, 120, '2014-03-01 00:05:31.000000', 'temperatura', 25.0000, 'ºC'),
	(223735, 120, '2014-03-01 00:05:32.000000', 'temperatura', 611.0000, 'ºC'),
	(223736, 120, '2014-03-01 00:05:33.000000', 'temperatura', 582.0000, 'ºC'),
	(223737, 120, '2014-03-01 00:05:34.000000', 'temperatura', 1075.0000, 'ºC'),
	(223738, 120, '2014-03-01 00:05:35.000000', 'temperatura', 29.0000, 'ºC'),
	(223739, 120, '2014-03-01 00:05:36.000000', 'temperatura', 522.0000, 'ºC'),
	(223740, 120, '2014-03-01 00:05:37.000000', 'temperatura', 122.0000, 'ºC'),
	(223741, 120, '2014-03-01 00:05:38.000000', 'temperatura', 246.0000, 'ºC'),
	(223742, 120, '2014-03-01 00:05:39.000000', 'temperatura', 865.0000, 'ºC'),
	(223743, 120, '2014-03-01 00:05:40.000000', 'temperatura', 1185.0000, 'ºC'),
	(223744, 120, '2014-03-01 00:05:41.000000', 'temperatura', 933.0000, 'ºC'),
	(223745, 120, '2014-03-01 00:05:42.000000', 'temperatura', 1110.0000, 'ºC'),
	(223746, 120, '2014-03-01 00:05:43.000000', 'temperatura', 353.0000, 'ºC'),
	(223747, 120, '2014-03-01 00:05:44.000000', 'temperatura', 834.0000, 'ºC'),
	(223748, 120, '2014-03-01 00:05:45.000000', 'temperatura', 711.0000, 'ºC'),
	(223749, 120, '2014-03-01 00:05:46.000000', 'temperatura', 1053.0000, 'ºC'),
	(223750, 120, '2014-03-01 00:05:47.000000', 'temperatura', 734.0000, 'ºC'),
	(223751, 120, '2014-03-01 00:05:48.000000', 'temperatura', 512.0000, 'ºC'),
	(223752, 120, '2014-03-01 00:05:49.000000', 'temperatura', 356.0000, 'ºC'),
	(223753, 120, '2014-03-01 00:05:50.000000', 'temperatura', 245.0000, 'ºC'),
	(223754, 120, '2014-03-01 00:05:51.000000', 'temperatura', 157.0000, 'ºC'),
	(223755, 120, '2014-03-01 00:05:52.000000', 'temperatura', 52.0000, 'ºC'),
	(223756, 120, '2014-03-01 00:05:53.000000', 'temperatura', 991.0000, 'ºC'),
	(223757, 120, '2014-03-01 00:05:54.000000', 'temperatura', 1198.0000, 'ºC'),
	(223758, 120, '2014-03-01 00:05:55.000000', 'temperatura', 619.0000, 'ºC'),
	(223759, 120, '2014-03-01 00:05:56.000000', 'temperatura', 702.0000, 'ºC'),
	(223760, 120, '2014-03-01 00:05:57.000000', 'temperatura', 452.0000, 'ºC'),
	(223761, 120, '2014-03-01 00:05:58.000000', 'temperatura', 155.0000, 'ºC'),
	(223762, 120, '2014-03-01 00:05:59.000000', 'temperatura', 619.0000, 'ºC'),
	(223763, 120, '2014-03-01 00:06:00.000000', 'temperatura', 230.0000, 'ºC'),
	(223764, 120, '2014-03-01 00:06:01.000000', 'temperatura', 494.0000, 'ºC'),
	(223765, 120, '2014-03-01 00:06:02.000000', 'temperatura', 582.0000, 'ºC'),
	(223766, 120, '2014-03-01 00:06:03.000000', 'temperatura', 229.0000, 'ºC'),
	(223767, 120, '2014-03-01 00:06:04.000000', 'temperatura', 597.0000, 'ºC'),
	(223768, 120, '2014-03-01 00:06:05.000000', 'temperatura', 1100.0000, 'ºC'),
	(223769, 120, '2014-03-01 00:06:06.000000', 'temperatura', 108.0000, 'ºC'),
	(223770, 120, '2014-03-01 00:06:07.000000', 'temperatura', 840.0000, 'ºC'),
	(223771, 120, '2014-03-01 00:06:08.000000', 'temperatura', 278.0000, 'ºC'),
	(223772, 120, '2014-03-01 00:06:09.000000', 'temperatura', 68.0000, 'ºC'),
	(223773, 120, '2014-03-01 00:06:10.000000', 'temperatura', 708.0000, 'ºC'),
	(223774, 120, '2014-03-01 00:06:11.000000', 'temperatura', 935.0000, 'ºC'),
	(223775, 120, '2014-03-01 00:06:12.000000', 'temperatura', 154.0000, 'ºC'),
	(223776, 120, '2014-03-01 00:06:13.000000', 'temperatura', 367.0000, 'ºC'),
	(223777, 120, '2014-03-01 00:06:14.000000', 'temperatura', 170.0000, 'ºC'),
	(223778, 120, '2014-03-01 00:06:15.000000', 'temperatura', 951.0000, 'ºC'),
	(223779, 120, '2014-03-01 00:06:16.000000', 'temperatura', 644.0000, 'ºC'),
	(223780, 120, '2014-03-01 00:06:17.000000', 'temperatura', 367.0000, 'ºC'),
	(223781, 120, '2014-03-01 00:06:18.000000', 'temperatura', 1104.0000, 'ºC'),
	(223782, 120, '2014-03-01 00:06:19.000000', 'temperatura', 821.0000, 'ºC'),
	(223783, 120, '2014-03-01 00:06:20.000000', 'temperatura', 793.0000, 'ºC'),
	(223784, 120, '2014-03-01 00:06:21.000000', 'temperatura', 303.0000, 'ºC'),
	(223785, 120, '2014-03-01 00:06:22.000000', 'temperatura', 337.0000, 'ºC'),
	(223786, 120, '2014-03-01 00:06:23.000000', 'temperatura', 775.0000, 'ºC'),
	(223787, 120, '2014-03-01 00:06:24.000000', 'temperatura', 465.0000, 'ºC'),
	(223788, 120, '2014-03-01 00:06:25.000000', 'temperatura', 1199.0000, 'ºC'),
	(223789, 120, '2014-03-01 00:06:26.000000', 'temperatura', 1000.0000, 'ºC'),
	(223790, 120, '2014-03-01 00:06:27.000000', 'temperatura', 207.0000, 'ºC'),
	(223791, 120, '2014-03-01 00:06:28.000000', 'temperatura', 433.0000, 'ºC'),
	(223792, 120, '2014-03-01 00:06:29.000000', 'temperatura', 344.0000, 'ºC'),
	(223793, 120, '2014-03-01 00:06:30.000000', 'temperatura', 421.0000, 'ºC'),
	(223794, 120, '2014-03-01 00:06:31.000000', 'temperatura', 1075.0000, 'ºC'),
	(223795, 120, '2014-03-01 00:06:32.000000', 'temperatura', 513.0000, 'ºC'),
	(223796, 120, '2014-03-01 00:06:33.000000', 'temperatura', 541.0000, 'ºC'),
	(223797, 120, '2014-03-01 00:06:34.000000', 'temperatura', 1167.0000, 'ºC'),
	(223798, 120, '2014-03-01 00:06:35.000000', 'temperatura', 610.0000, 'ºC'),
	(223799, 120, '2014-03-01 00:06:36.000000', 'temperatura', 749.0000, 'ºC'),
	(223800, 120, '2014-03-01 00:06:37.000000', 'temperatura', 717.0000, 'ºC'),
	(223801, 120, '2014-03-01 00:06:38.000000', 'temperatura', 138.0000, 'ºC'),
	(223802, 120, '2014-03-01 00:06:39.000000', 'temperatura', 939.0000, 'ºC'),
	(223803, 120, '2014-03-01 00:06:40.000000', 'temperatura', 681.0000, 'ºC'),
	(223804, 120, '2014-03-01 00:06:41.000000', 'temperatura', 589.0000, 'ºC'),
	(223805, 120, '2014-03-01 00:06:42.000000', 'temperatura', 903.0000, 'ºC'),
	(223806, 120, '2014-03-01 00:06:43.000000', 'temperatura', 348.0000, 'ºC'),
	(223807, 120, '2014-03-01 00:06:44.000000', 'temperatura', 231.0000, 'ºC'),
	(223808, 120, '2014-03-01 00:06:45.000000', 'temperatura', 112.0000, 'ºC'),
	(223809, 120, '2014-03-01 00:06:46.000000', 'temperatura', 1068.0000, 'ºC'),
	(223810, 120, '2014-03-01 00:06:47.000000', 'temperatura', 206.0000, 'ºC'),
	(223811, 120, '2014-03-01 00:06:48.000000', 'temperatura', 225.0000, 'ºC'),
	(223812, 120, '2014-03-01 00:06:49.000000', 'temperatura', 507.0000, 'ºC'),
	(223813, 120, '2014-03-01 00:06:50.000000', 'temperatura', 659.0000, 'ºC'),
	(223814, 120, '2014-03-01 00:06:51.000000', 'temperatura', 577.0000, 'ºC'),
	(223815, 120, '2014-03-01 00:06:52.000000', 'temperatura', 909.0000, 'ºC'),
	(223816, 120, '2014-03-01 00:06:53.000000', 'temperatura', 413.0000, 'ºC'),
	(223817, 120, '2014-03-01 00:06:54.000000', 'temperatura', 538.0000, 'ºC'),
	(223818, 120, '2014-03-01 00:06:55.000000', 'temperatura', 250.0000, 'ºC'),
	(223819, 120, '2014-03-01 00:06:56.000000', 'temperatura', 840.0000, 'ºC'),
	(223820, 120, '2014-03-01 00:06:57.000000', 'temperatura', 1048.0000, 'ºC'),
	(223821, 120, '2014-03-01 00:06:58.000000', 'temperatura', 323.0000, 'ºC'),
	(223822, 120, '2014-03-01 00:06:59.000000', 'temperatura', 868.0000, 'ºC'),
	(223823, 120, '2014-03-01 00:07:00.000000', 'temperatura', 975.0000, 'ºC'),
	(223824, 120, '2014-03-01 00:07:01.000000', 'temperatura', 1069.0000, 'ºC'),
	(223825, 120, '2014-03-01 00:07:02.000000', 'temperatura', 22.0000, 'ºC'),
	(223826, 120, '2014-03-01 00:07:03.000000', 'temperatura', 502.0000, 'ºC'),
	(223827, 120, '2014-03-01 00:07:04.000000', 'temperatura', 45.0000, 'ºC'),
	(223828, 120, '2014-03-01 00:07:05.000000', 'temperatura', 1121.0000, 'ºC'),
	(223829, 120, '2014-03-01 00:07:06.000000', 'temperatura', 671.0000, 'ºC'),
	(223830, 120, '2014-03-01 00:07:07.000000', 'temperatura', 1191.0000, 'ºC'),
	(223831, 120, '2014-03-01 00:07:08.000000', 'temperatura', 343.0000, 'ºC'),
	(223832, 120, '2014-03-01 00:07:09.000000', 'temperatura', 543.0000, 'ºC'),
	(223833, 120, '2014-03-01 00:07:10.000000', 'temperatura', 485.0000, 'ºC'),
	(223834, 120, '2014-03-01 00:07:11.000000', 'temperatura', 799.0000, 'ºC'),
	(223835, 120, '2014-03-01 00:07:12.000000', 'temperatura', 139.0000, 'ºC'),
	(223836, 120, '2014-03-01 00:07:13.000000', 'temperatura', 698.0000, 'ºC'),
	(223837, 120, '2014-03-01 00:07:14.000000', 'temperatura', 674.0000, 'ºC'),
	(223838, 120, '2014-03-01 00:07:15.000000', 'temperatura', 78.0000, 'ºC'),
	(223839, 120, '2014-03-01 00:07:16.000000', 'temperatura', 767.0000, 'ºC'),
	(223840, 120, '2014-03-01 00:07:17.000000', 'temperatura', 4.0000, 'ºC'),
	(223841, 120, '2014-03-01 00:07:18.000000', 'temperatura', 117.0000, 'ºC'),
	(223842, 120, '2014-03-01 00:07:19.000000', 'temperatura', 575.0000, 'ºC'),
	(223843, 120, '2014-03-01 00:07:20.000000', 'temperatura', 123.0000, 'ºC'),
	(223844, 120, '2014-03-01 00:07:21.000000', 'temperatura', 90.0000, 'ºC'),
	(223845, 120, '2014-03-01 00:07:22.000000', 'temperatura', 82.0000, 'ºC'),
	(223846, 120, '2014-03-01 00:07:23.000000', 'temperatura', 140.0000, 'ºC'),
	(223847, 120, '2014-03-01 00:07:24.000000', 'temperatura', 455.0000, 'ºC'),
	(223848, 120, '2014-03-01 00:07:25.000000', 'temperatura', 655.0000, 'ºC'),
	(223849, 120, '2014-03-01 00:07:26.000000', 'temperatura', 712.0000, 'ºC'),
	(223850, 120, '2014-03-01 00:07:27.000000', 'temperatura', 393.0000, 'ºC'),
	(223851, 120, '2014-03-01 00:07:28.000000', 'temperatura', 1032.0000, 'ºC'),
	(223852, 120, '2014-03-01 00:07:29.000000', 'temperatura', 380.0000, 'ºC'),
	(223853, 120, '2014-03-01 00:07:30.000000', 'temperatura', 3.0000, 'ºC'),
	(223854, 120, '2014-03-01 00:07:31.000000', 'temperatura', 79.0000, 'ºC'),
	(223855, 120, '2014-03-01 00:07:32.000000', 'temperatura', 384.0000, 'ºC'),
	(223856, 120, '2014-03-01 00:07:33.000000', 'temperatura', 484.0000, 'ºC'),
	(223857, 120, '2014-03-01 00:07:34.000000', 'temperatura', 67.0000, 'ºC'),
	(223858, 120, '2014-03-01 00:07:35.000000', 'temperatura', 84.0000, 'ºC'),
	(223859, 120, '2014-03-01 00:07:36.000000', 'temperatura', 219.0000, 'ºC'),
	(223860, 120, '2014-03-01 00:07:37.000000', 'temperatura', 845.0000, 'ºC'),
	(223861, 120, '2014-03-01 00:07:38.000000', 'temperatura', 1170.0000, 'ºC'),
	(223862, 120, '2014-03-01 00:07:39.000000', 'temperatura', 913.0000, 'ºC'),
	(223863, 120, '2014-03-01 00:07:40.000000', 'temperatura', 1056.0000, 'ºC'),
	(223864, 120, '2014-03-01 00:07:41.000000', 'temperatura', 142.0000, 'ºC'),
	(223865, 120, '2014-03-01 00:07:42.000000', 'temperatura', 1143.0000, 'ºC'),
	(223866, 120, '2014-03-01 00:07:43.000000', 'temperatura', 488.0000, 'ºC'),
	(223867, 120, '2014-03-01 00:07:44.000000', 'temperatura', 212.0000, 'ºC'),
	(223868, 120, '2014-03-01 00:07:45.000000', 'temperatura', 797.0000, 'ºC'),
	(223869, 120, '2014-03-01 00:07:46.000000', 'temperatura', 950.0000, 'ºC'),
	(223870, 120, '2014-03-01 00:07:47.000000', 'temperatura', 1161.0000, 'ºC'),
	(223871, 120, '2014-03-01 00:07:48.000000', 'temperatura', 553.0000, 'ºC'),
	(223872, 120, '2014-03-01 00:07:49.000000', 'temperatura', 485.0000, 'ºC'),
	(223873, 120, '2014-03-01 00:07:50.000000', 'temperatura', 764.0000, 'ºC'),
	(223874, 120, '2014-03-01 00:07:51.000000', 'temperatura', 1168.0000, 'ºC'),
	(223875, 120, '2014-03-01 00:07:52.000000', 'temperatura', 1148.0000, 'ºC'),
	(223876, 120, '2014-03-01 00:07:53.000000', 'temperatura', 1035.0000, 'ºC'),
	(223877, 120, '2014-03-01 00:07:54.000000', 'temperatura', 531.0000, 'ºC'),
	(223878, 120, '2014-03-01 00:07:55.000000', 'temperatura', 750.0000, 'ºC'),
	(223879, 120, '2014-03-01 00:07:56.000000', 'temperatura', 957.0000, 'ºC'),
	(223880, 120, '2014-03-01 00:07:57.000000', 'temperatura', 135.0000, 'ºC'),
	(223881, 120, '2014-03-01 00:07:58.000000', 'temperatura', 207.0000, 'ºC'),
	(223882, 120, '2014-03-01 00:07:59.000000', 'temperatura', 629.0000, 'ºC'),
	(223883, 120, '2014-03-01 00:08:00.000000', 'temperatura', 124.0000, 'ºC'),
	(223884, 120, '2014-03-01 00:08:01.000000', 'temperatura', 1132.0000, 'ºC'),
	(223885, 120, '2014-03-01 00:08:02.000000', 'temperatura', 491.0000, 'ºC'),
	(223886, 120, '2014-03-01 00:08:03.000000', 'temperatura', 260.0000, 'ºC'),
	(223887, 120, '2014-03-01 00:08:04.000000', 'temperatura', 1025.0000, 'ºC'),
	(223888, 120, '2014-03-01 00:08:05.000000', 'temperatura', 746.0000, 'ºC'),
	(223889, 120, '2014-03-01 00:08:06.000000', 'temperatura', 655.0000, 'ºC'),
	(223890, 120, '2014-03-01 00:08:07.000000', 'temperatura', 1036.0000, 'ºC'),
	(223891, 120, '2014-03-01 00:08:08.000000', 'temperatura', 819.0000, 'ºC'),
	(223892, 120, '2014-03-01 00:08:09.000000', 'temperatura', 987.0000, 'ºC'),
	(223893, 120, '2014-03-01 00:08:10.000000', 'temperatura', 77.0000, 'ºC'),
	(223894, 120, '2014-03-01 00:08:11.000000', 'temperatura', 1025.0000, 'ºC'),
	(223895, 120, '2014-03-01 00:08:12.000000', 'temperatura', 95.0000, 'ºC'),
	(223896, 120, '2014-03-01 00:08:13.000000', 'temperatura', 998.0000, 'ºC'),
	(223897, 120, '2014-03-01 00:08:14.000000', 'temperatura', 1109.0000, 'ºC'),
	(223898, 120, '2014-03-01 00:08:15.000000', 'temperatura', 148.0000, 'ºC'),
	(223899, 120, '2014-03-01 00:08:16.000000', 'temperatura', 1016.0000, 'ºC'),
	(223900, 120, '2014-03-01 00:08:17.000000', 'temperatura', 1037.0000, 'ºC'),
	(223901, 120, '2014-03-01 00:08:18.000000', 'temperatura', 937.0000, 'ºC'),
	(223902, 120, '2014-03-01 00:08:19.000000', 'temperatura', 374.0000, 'ºC'),
	(223903, 120, '2014-03-01 00:08:20.000000', 'temperatura', 261.0000, 'ºC'),
	(223904, 120, '2014-03-01 00:08:21.000000', 'temperatura', 183.0000, 'ºC'),
	(223905, 120, '2014-03-01 00:08:22.000000', 'temperatura', 131.0000, 'ºC'),
	(223906, 120, '2014-03-01 00:08:23.000000', 'temperatura', 109.0000, 'ºC'),
	(223907, 120, '2014-03-01 00:08:24.000000', 'temperatura', 150.0000, 'ºC'),
	(223908, 120, '2014-03-01 00:08:25.000000', 'temperatura', 425.0000, 'ºC'),
	(223909, 120, '2014-03-01 00:08:26.000000', 'temperatura', 476.0000, 'ºC'),
	(223910, 120, '2014-03-01 00:08:27.000000', 'temperatura', 1106.0000, 'ºC'),
	(223911, 120, '2014-03-01 00:08:28.000000', 'temperatura', 502.0000, 'ºC'),
	(223912, 120, '2014-03-01 00:08:29.000000', 'temperatura', 394.0000, 'ºC'),
	(223913, 120, '2014-03-01 00:08:30.000000', 'temperatura', 464.0000, 'ºC'),
	(223914, 120, '2014-03-01 00:08:31.000000', 'temperatura', 1138.0000, 'ºC'),
	(223915, 120, '2014-03-01 00:08:32.000000', 'temperatura', 699.0000, 'ºC'),
	(223916, 120, '2014-03-01 00:08:33.000000', 'temperatura', 79.0000, 'ºC'),
	(223917, 120, '2014-03-01 00:08:34.000000', 'temperatura', 701.0000, 'ºC'),
	(223918, 120, '2014-03-01 00:08:35.000000', 'temperatura', 866.0000, 'ºC'),
	(223919, 120, '2014-03-01 00:08:36.000000', 'temperatura', 1027.0000, 'ºC'),
	(223920, 120, '2014-03-01 00:08:37.000000', 'temperatura', 141.0000, 'ºC'),
	(223921, 120, '2014-03-01 00:08:38.000000', 'temperatura', 22.0000, 'ºC'),
	(223922, 120, '2014-03-01 00:08:39.000000', 'temperatura', 886.0000, 'ºC'),
	(223923, 120, '2014-03-01 00:08:40.000000', 'temperatura', 767.0000, 'ºC'),
	(223924, 120, '2014-03-01 00:08:41.000000', 'temperatura', 1177.0000, 'ºC'),
	(223925, 120, '2014-03-01 00:08:42.000000', 'temperatura', 1185.0000, 'ºC'),
	(223926, 120, '2014-03-01 00:08:43.000000', 'temperatura', 1193.0000, 'ºC'),
	(223927, 120, '2014-03-01 00:08:44.000000', 'temperatura', 9.0000, 'ºC'),
	(223928, 120, '2014-03-01 00:08:45.000000', 'temperatura', 69.0000, 'ºC'),
	(223929, 120, '2014-03-01 00:08:46.000000', 'temperatura', 319.0000, 'ºC'),
	(223930, 120, '2014-03-01 00:08:47.000000', 'temperatura', 186.0000, 'ºC'),
	(223931, 120, '2014-03-01 00:08:48.000000', 'temperatura', 1175.0000, 'ºC'),
	(223932, 120, '2014-03-01 00:08:49.000000', 'temperatura', 518.0000, 'ºC'),
	(223933, 120, '2014-03-01 00:08:50.000000', 'temperatura', 264.0000, 'ºC'),
	(223934, 120, '2014-03-01 00:08:51.000000', 'temperatura', 965.0000, 'ºC'),
	(223935, 120, '2014-03-01 00:08:52.000000', 'temperatura', 437.0000, 'ºC'),
	(223936, 120, '2014-03-01 00:08:53.000000', 'temperatura', 488.0000, 'ºC'),
	(223937, 120, '2014-03-01 00:08:54.000000', 'temperatura', 1129.0000, 'ºC'),
	(223938, 120, '2014-03-01 00:08:55.000000', 'temperatura', 584.0000, 'ºC'),
	(223939, 120, '2014-03-01 00:08:56.000000', 'temperatura', 732.0000, 'ºC'),
	(223940, 120, '2014-03-01 00:08:57.000000', 'temperatura', 710.0000, 'ºC'),
	(223941, 120, '2014-03-01 00:08:58.000000', 'temperatura', 155.0000, 'ºC'),
	(223942, 120, '2014-03-01 00:08:59.000000', 'temperatura', 1043.0000, 'ºC'),
	(223943, 120, '2014-03-01 00:09:00.000000', 'temperatura', 1153.0000, 'ºC'),
	(223944, 120, '2014-03-01 00:09:01.000000', 'temperatura', 236.0000, 'ºC'),
	(223945, 120, '2014-03-01 00:09:02.000000', 'temperatura', 119.0000, 'ºC'),
	(223946, 120, '2014-03-01 00:09:03.000000', 'temperatura', 1090.0000, 'ºC'),
	(223947, 120, '2014-03-01 00:09:04.000000', 'temperatura', 293.0000, 'ºC'),
	(223948, 120, '2014-03-01 00:09:05.000000', 'temperatura', 597.0000, 'ºC'),
	(223949, 120, '2014-03-01 00:09:06.000000', 'temperatura', 906.0000, 'ºC'),
	(223950, 120, '2014-03-01 00:09:07.000000', 'temperatura', 337.0000, 'ºC'),
	(223951, 120, '2014-03-01 00:09:08.000000', 'temperatura', 171.0000, 'ºC'),
	(223952, 120, '2014-03-01 00:09:09.000000', 'temperatura', 1043.0000, 'ºC'),
	(223953, 120, '2014-03-01 00:09:10.000000', 'temperatura', 1102.0000, 'ºC'),
	(223954, 120, '2014-03-01 00:09:11.000000', 'temperatura', 1182.0000, 'ºC'),
	(223955, 120, '2014-03-01 00:09:12.000000', 'temperatura', 206.0000, 'ºC'),
	(223956, 120, '2014-03-01 00:09:13.000000', 'temperatura', 1084.0000, 'ºC'),
	(223957, 120, '2014-03-01 00:09:14.000000', 'temperatura', 2.0000, 'ºC'),
	(223958, 120, '2014-03-01 00:09:15.000000', 'temperatura', 358.0000, 'ºC'),
	(223959, 120, '2014-03-01 00:09:16.000000', 'temperatura', 583.0000, 'ºC'),
	(223960, 120, '2014-03-01 00:09:17.000000', 'temperatura', 642.0000, 'ºC'),
	(223961, 120, '2014-03-01 00:09:18.000000', 'temperatura', 262.0000, 'ºC'),
	(223962, 120, '2014-03-01 00:09:19.000000', 'temperatura', 584.0000, 'ºC'),
	(223963, 120, '2014-03-01 00:09:20.000000', 'temperatura', 934.0000, 'ºC'),
	(223964, 120, '2014-03-01 00:09:21.000000', 'temperatura', 519.0000, 'ºC'),
	(223965, 120, '2014-03-01 00:09:22.000000', 'temperatura', 994.0000, 'ºC'),
	(223966, 120, '2014-03-01 00:09:23.000000', 'temperatura', 1014.0000, 'ºC'),
	(223967, 120, '2014-03-01 00:09:24.000000', 'temperatura', 889.0000, 'ºC'),
	(223968, 120, '2014-03-01 00:09:25.000000', 'temperatura', 203.0000, 'ºC'),
	(223969, 120, '2014-03-01 00:09:26.000000', 'temperatura', 747.0000, 'ºC'),
	(223970, 120, '2014-03-01 00:09:27.000000', 'temperatura', 726.0000, 'ºC'),
	(223971, 120, '2014-03-01 00:09:28.000000', 'temperatura', 190.0000, 'ºC'),
	(223972, 120, '2014-03-01 00:09:29.000000', 'temperatura', 1172.0000, 'ºC'),
	(223973, 120, '2014-03-01 00:09:30.000000', 'temperatura', 489.0000, 'ºC'),
	(223974, 120, '2014-03-01 00:09:31.000000', 'temperatura', 131.0000, 'ºC'),
	(223975, 120, '2014-03-01 00:09:32.000000', 'temperatura', 389.0000, 'ºC'),
	(223976, 120, '2014-03-01 00:09:33.000000', 'temperatura', 354.0000, 'ºC'),
	(223977, 120, '2014-03-01 00:09:34.000000', 'temperatura', 603.0000, 'ºC'),
	(223978, 120, '2014-03-01 00:09:35.000000', 'temperatura', 754.0000, 'ºC'),
	(223979, 120, '2014-03-01 00:09:36.000000', 'temperatura', 759.0000, 'ºC'),
	(223980, 120, '2014-03-01 00:09:37.000000', 'temperatura', 335.0000, 'ºC'),
	(223981, 120, '2014-03-01 00:09:38.000000', 'temperatura', 598.0000, 'ºC'),
	(223982, 120, '2014-03-01 00:09:39.000000', 'temperatura', 784.0000, 'ºC'),
	(223983, 120, '2014-03-01 00:09:40.000000', 'temperatura', 929.0000, 'ºC'),
	(223984, 120, '2014-03-01 00:09:41.000000', 'temperatura', 1094.0000, 'ºC'),
	(223985, 120, '2014-03-01 00:09:42.000000', 'temperatura', 283.0000, 'ºC'),
	(223986, 120, '2014-03-01 00:09:43.000000', 'temperatura', 534.0000, 'ºC'),
	(223987, 120, '2014-03-01 00:09:44.000000', 'temperatura', 620.0000, 'ºC'),
	(223988, 120, '2014-03-01 00:09:45.000000', 'temperatura', 299.0000, 'ºC'),
	(223989, 120, '2014-03-01 00:09:46.000000', 'temperatura', 835.0000, 'ºC'),
	(223990, 120, '2014-03-01 00:09:47.000000', 'temperatura', 880.0000, 'ºC'),
	(223991, 120, '2014-03-01 00:09:48.000000', 'temperatura', 697.0000, 'ºC'),
	(223992, 120, '2014-03-01 00:09:49.000000', 'temperatura', 842.0000, 'ºC'),
	(223993, 120, '2014-03-01 00:09:50.000000', 'temperatura', 922.0000, 'ºC'),
	(223994, 120, '2014-03-01 00:09:51.000000', 'temperatura', 885.0000, 'ºC'),
	(223995, 120, '2014-03-01 00:09:52.000000', 'temperatura', 458.0000, 'ºC'),
	(223996, 120, '2014-03-01 00:09:53.000000', 'temperatura', 837.0000, 'ºC'),
	(223997, 120, '2014-03-01 00:09:54.000000', 'temperatura', 412.0000, 'ºC'),
	(223998, 120, '2014-03-01 00:09:55.000000', 'temperatura', 749.0000, 'ºC'),
	(223999, 120, '2014-03-01 00:09:56.000000', 'temperatura', 107.0000, 'ºC'),
	(224000, 120, '2014-03-01 00:09:57.000000', 'temperatura', 691.0000, 'ºC'),
	(224001, 120, '2014-03-01 00:09:58.000000', 'temperatura', 735.0000, 'ºC'),
	(224002, 120, '2014-03-01 00:09:59.000000', 'temperatura', 403.0000, 'ºC'),
	(224003, 120, '2014-03-01 00:10:00.000000', 'temperatura', 1010.0000, 'ºC'),
	(224004, 120, '2014-03-01 00:10:01.000000', 'temperatura', 242.0000, 'ºC'),
	(224005, 120, '2014-03-01 00:10:02.000000', 'temperatura', 579.0000, 'ºC'),
	(224006, 120, '2014-03-01 00:10:03.000000', 'temperatura', 970.0000, 'ºC'),
	(224007, 120, '2014-03-01 00:10:04.000000', 'temperatura', 712.0000, 'ºC'),
	(224008, 120, '2014-03-01 00:10:05.000000', 'temperatura', 652.0000, 'ºC'),
	(224009, 120, '2014-03-01 00:10:06.000000', 'temperatura', 1126.0000, 'ºC'),
	(224010, 120, '2014-03-01 00:10:07.000000', 'temperatura', 75.0000, 'ºC'),
	(224011, 120, '2014-03-01 00:10:08.000000', 'temperatura', 595.0000, 'ºC'),
	(224012, 120, '2014-03-01 00:10:09.000000', 'temperatura', 352.0000, 'ºC'),
	(224013, 120, '2014-03-01 00:10:10.000000', 'temperatura', 1173.0000, 'ºC'),
	(224014, 120, '2014-03-01 00:10:11.000000', 'temperatura', 11.0000, 'ºC'),
	(224015, 120, '2014-03-01 00:10:12.000000', 'temperatura', 137.0000, 'ºC'),
	(224016, 120, '2014-03-01 00:10:13.000000', 'temperatura', 651.0000, 'ºC'),
	(224017, 120, '2014-03-01 00:10:14.000000', 'temperatura', 446.0000, 'ºC'),
	(224018, 120, '2014-03-01 00:10:15.000000', 'temperatura', 277.0000, 'ºC'),
	(224019, 120, '2014-03-01 00:10:16.000000', 'temperatura', 48.0000, 'ºC'),
	(224020, 120, '2014-03-01 00:10:17.000000', 'temperatura', 610.0000, 'ºC'),
	(224021, 120, '2014-03-01 00:10:18.000000', 'temperatura', 504.0000, 'ºC'),
	(224022, 120, '2014-03-01 00:10:19.000000', 'temperatura', 693.0000, 'ºC'),
	(224023, 120, '2014-03-01 00:10:20.000000', 'temperatura', 751.0000, 'ºC'),
	(224024, 120, '2014-03-01 00:10:21.000000', 'temperatura', 480.0000, 'ºC'),
	(224025, 120, '2014-03-01 00:10:22.000000', 'temperatura', 145.0000, 'ºC'),
	(224026, 120, '2014-03-01 00:10:23.000000', 'temperatura', 485.0000, 'ºC'),
	(224027, 120, '2014-03-01 00:10:24.000000', 'temperatura', 791.0000, 'ºC'),
	(224028, 120, '2014-03-01 00:10:25.000000', 'temperatura', 102.0000, 'ºC'),
	(224029, 120, '2014-03-01 00:10:26.000000', 'temperatura', 538.0000, 'ºC'),
	(224030, 120, '2014-03-01 00:10:27.000000', 'temperatura', 1184.0000, 'ºC'),
	(224031, 120, '2014-03-01 00:10:28.000000', 'temperatura', 706.0000, 'ºC'),
	(224032, 120, '2014-03-01 00:10:29.000000', 'temperatura', 1180.0000, 'ºC'),
	(224033, 120, '2014-03-01 00:10:30.000000', 'temperatura', 180.0000, 'ºC'),
	(224034, 120, '2014-03-01 00:10:31.000000', 'temperatura', 961.0000, 'ºC'),
	(224035, 120, '2014-03-01 00:10:32.000000', 'temperatura', 666.0000, 'ºC'),
	(224036, 120, '2014-03-01 00:10:33.000000', 'temperatura', 446.0000, 'ºC'),
	(224037, 120, '2014-03-01 00:10:34.000000', 'temperatura', 233.0000, 'ºC'),
	(224038, 120, '2014-03-01 00:10:35.000000', 'temperatura', 1028.0000, 'ºC'),
	(224039, 120, '2014-03-01 00:10:36.000000', 'temperatura', 840.0000, 'ºC'),
	(224040, 120, '2014-03-01 00:10:37.000000', 'temperatura', 1118.0000, 'ºC'),
	(224041, 120, '2014-03-01 00:10:38.000000', 'temperatura', 671.0000, 'ºC'),
	(224042, 120, '2014-03-01 00:10:39.000000', 'temperatura', 1.0000, 'ºC'),
	(224043, 120, '2014-03-01 00:10:40.000000', 'temperatura', 393.0000, 'ºC'),
	(224044, 120, '2014-03-01 00:10:41.000000', 'temperatura', 761.0000, 'ºC'),
	(224045, 120, '2014-03-01 00:10:42.000000', 'temperatura', 228.0000, 'ºC'),
	(224046, 120, '2014-03-01 00:10:43.000000', 'temperatura', 58.0000, 'ºC'),
	(224047, 120, '2014-03-01 00:10:44.000000', 'temperatura', 807.0000, 'ºC'),
	(224048, 120, '2014-03-01 00:10:45.000000', 'temperatura', 262.0000, 'ºC'),
	(224049, 120, '2014-03-01 00:10:46.000000', 'temperatura', 90.0000, 'ºC'),
	(224050, 120, '2014-03-01 00:10:47.000000', 'temperatura', 865.0000, 'ºC'),
	(224051, 120, '2014-03-01 00:10:48.000000', 'temperatura', 455.0000, 'ºC'),
	(224052, 120, '2014-03-01 00:10:49.000000', 'temperatura', 881.0000, 'ºC'),
	(224053, 120, '2014-03-01 00:10:50.000000', 'temperatura', 639.0000, 'ºC'),
	(224054, 120, '2014-03-01 00:10:51.000000', 'temperatura', 554.0000, 'ºC'),
	(224055, 120, '2014-03-01 00:10:52.000000', 'temperatura', 852.0000, 'ºC'),
	(224056, 120, '2014-03-01 00:10:53.000000', 'temperatura', 201.0000, 'ºC'),
	(224057, 120, '2014-03-01 00:10:54.000000', 'temperatura', 848.0000, 'ºC'),
	(224058, 120, '2014-03-01 00:10:55.000000', 'temperatura', 36.0000, 'ºC'),
	(224059, 120, '2014-03-01 00:10:56.000000', 'temperatura', 39.0000, 'ºC'),
	(224060, 120, '2014-03-01 00:10:57.000000', 'temperatura', 85.0000, 'ºC'),
	(224061, 120, '2014-03-01 00:10:58.000000', 'temperatura', 312.0000, 'ºC'),
	(224062, 120, '2014-03-01 00:10:59.000000', 'temperatura', 102.0000, 'ºC'),
	(224063, 120, '2014-03-01 00:11:00.000000', 'temperatura', 775.0000, 'ºC'),
	(224064, 120, '2014-03-01 00:11:01.000000', 'temperatura', 1171.0000, 'ºC'),
	(224065, 120, '2014-03-01 00:11:02.000000', 'temperatura', 1128.0000, 'ºC'),
	(224066, 120, '2014-03-01 00:11:03.000000', 'temperatura', 930.0000, 'ºC'),
	(224067, 120, '2014-03-01 00:11:04.000000', 'temperatura', 67.0000, 'ºC'),
	(224068, 120, '2014-03-01 00:11:05.000000', 'temperatura', 1143.0000, 'ºC'),
	(224069, 120, '2014-03-01 00:11:06.000000', 'temperatura', 716.0000, 'ºC'),
	(224070, 120, '2014-03-01 00:11:07.000000', 'temperatura', 150.0000, 'ºC'),
	(224071, 120, '2014-03-01 00:11:08.000000', 'temperatura', 1003.0000, 'ºC'),
	(224072, 120, '2014-03-01 00:11:09.000000', 'temperatura', 966.0000, 'ºC'),
	(224073, 120, '2014-03-01 00:11:10.000000', 'temperatura', 622.0000, 'ºC'),
	(224074, 120, '2014-03-01 00:11:11.000000', 'temperatura', 212.0000, 'ºC'),
	(224075, 120, '2014-03-01 00:11:12.000000', 'temperatura', 394.0000, 'ºC'),
	(224076, 120, '2014-03-01 00:11:13.000000', 'temperatura', 136.0000, 'ºC'),
	(224077, 120, '2014-03-01 00:11:14.000000', 'temperatura', 697.0000, 'ºC'),
	(224078, 120, '2014-03-01 00:11:15.000000', 'temperatura', 677.0000, 'ºC'),
	(224079, 120, '2014-03-01 00:11:16.000000', 'temperatura', 96.0000, 'ºC'),
	(224080, 120, '2014-03-01 00:11:17.000000', 'temperatura', 848.0000, 'ºC'),
	(224081, 120, '2014-03-01 00:11:18.000000', 'temperatura', 355.0000, 'ºC'),
	(224082, 120, '2014-03-01 00:11:19.000000', 'temperatura', 429.0000, 'ºC'),
	(224083, 120, '2014-03-01 00:11:20.000000', 'temperatura', 1081.0000, 'ºC'),
	(224084, 120, '2014-03-01 00:11:21.000000', 'temperatura', 519.0000, 'ºC'),
	(224085, 120, '2014-03-01 00:11:22.000000', 'temperatura', 554.0000, 'ºC'),
	(224086, 120, '2014-03-01 00:11:23.000000', 'temperatura', 13.0000, 'ºC'),
	(224087, 120, '2014-03-01 00:11:24.000000', 'temperatura', 804.0000, 'ºC'),
	(224088, 120, '2014-03-01 00:11:25.000000', 'temperatura', 379.0000, 'ºC'),
	(224089, 120, '2014-03-01 00:11:26.000000', 'temperatura', 684.0000, 'ºC'),
	(224090, 120, '2014-03-01 00:11:27.000000', 'temperatura', 1083.0000, 'ºC'),
	(224091, 120, '2014-03-01 00:11:28.000000', 'temperatura', 964.0000, 'ºC'),
	(224092, 120, '2014-03-01 00:11:29.000000', 'temperatura', 372.0000, 'ºC'),
	(224093, 120, '2014-03-01 00:11:30.000000', 'temperatura', 167.0000, 'ºC'),
	(224094, 120, '2014-03-01 00:11:31.000000', 'temperatura', 921.0000, 'ºC'),
	(224095, 120, '2014-03-01 00:11:32.000000', 'temperatura', 504.0000, 'ºC'),
	(224096, 120, '2014-03-01 00:11:33.000000', 'temperatura', 959.0000, 'ºC'),
	(224097, 120, '2014-03-01 00:11:34.000000', 'temperatura', 884.0000, 'ºC'),
	(224098, 120, '2014-03-01 00:11:35.000000', 'temperatura', 343.0000, 'ºC'),
	(224099, 120, '2014-03-01 00:11:36.000000', 'temperatura', 262.0000, 'ºC'),
	(224100, 120, '2014-03-01 00:11:37.000000', 'temperatura', 281.0000, 'ºC'),
	(224101, 120, '2014-03-01 00:11:38.000000', 'temperatura', 620.0000, 'ºC'),
	(224102, 120, '2014-03-01 00:11:39.000000', 'temperatura', 1056.0000, 'ºC'),
	(224103, 120, '2014-03-01 00:11:40.000000', 'temperatura', 1020.0000, 'ºC'),
	(224104, 120, '2014-03-01 00:11:41.000000', 'temperatura', 734.0000, 'ºC'),
	(224105, 120, '2014-03-01 00:11:42.000000', 'temperatura', 612.0000, 'ºC'),
	(224106, 120, '2014-03-01 00:11:43.000000', 'temperatura', 855.0000, 'ºC'),
	(224107, 120, '2014-03-01 00:11:44.000000', 'temperatura', 42.0000, 'ºC'),
	(224108, 120, '2014-03-01 00:11:45.000000', 'temperatura', 45.0000, 'ºC'),
	(224109, 120, '2014-03-01 00:11:46.000000', 'temperatura', 100.0000, 'ºC'),
	(224110, 120, '2014-03-01 00:11:47.000000', 'temperatura', 365.0000, 'ºC'),
	(224111, 120, '2014-03-01 00:11:48.000000', 'temperatura', 326.0000, 'ºC'),
	(224112, 120, '2014-03-01 00:11:49.000000', 'temperatura', 537.0000, 'ºC'),
	(224113, 120, '2014-03-01 00:11:50.000000', 'temperatura', 505.0000, 'ºC'),
	(224114, 120, '2014-03-01 00:11:51.000000', 'temperatura', 916.0000, 'ºC'),
	(224115, 120, '2014-03-01 00:11:52.000000', 'temperatura', 665.0000, 'ºC'),
	(224116, 120, '2014-03-01 00:11:53.000000', 'temperatura', 576.0000, 'ºC'),
	(224117, 120, '2014-03-01 00:11:54.000000', 'temperatura', 888.0000, 'ºC'),
	(224118, 120, '2014-03-01 00:11:55.000000', 'temperatura', 312.0000, 'ºC'),
	(224119, 120, '2014-03-01 00:11:56.000000', 'temperatura', 94.0000, 'ºC'),
	(224120, 120, '2014-03-01 00:11:57.000000', 'temperatura', 738.0000, 'ºC'),
	(224121, 120, '2014-03-01 00:11:58.000000', 'temperatura', 1007.0000, 'ºC'),
	(224122, 120, '2014-03-01 00:11:59.000000', 'temperatura', 420.0000, 'ºC'),
	(224123, 120, '2014-03-01 00:12:00.000000', 'temperatura', 280.0000, 'ºC'),
	(224124, 120, '2014-03-01 00:12:01.000000', 'temperatura', 143.0000, 'ºC'),
	(224125, 120, '2014-03-01 00:12:02.000000', 'temperatura', 1072.0000, 'ºC'),
	(224126, 120, '2014-03-01 00:12:03.000000', 'temperatura', 135.0000, 'ºC'),
	(224127, 120, '2014-03-01 00:12:04.000000', 'temperatura', 1057.0000, 'ºC'),
	(224128, 120, '2014-03-01 00:12:05.000000', 'temperatura', 83.0000, 'ºC'),
	(224129, 120, '2014-03-01 00:12:06.000000', 'temperatura', 844.0000, 'ºC'),
	(224130, 120, '2014-03-01 00:12:07.000000', 'temperatura', 373.0000, 'ºC'),
	(224131, 120, '2014-03-01 00:12:08.000000', 'temperatura', 531.0000, 'ºC'),
	(224132, 120, '2014-03-01 00:12:09.000000', 'temperatura', 338.0000, 'ºC'),
	(224133, 120, '2014-03-01 00:12:10.000000', 'temperatura', 96.0000, 'ºC'),
	(224134, 120, '2014-03-01 00:12:11.000000', 'temperatura', 668.0000, 'ºC'),
	(224135, 120, '2014-03-01 00:12:12.000000', 'temperatura', 650.0000, 'ºC'),
	(224136, 120, '2014-03-01 00:12:13.000000', 'temperatura', 48.0000, 'ºC'),
	(224137, 120, '2014-03-01 00:12:14.000000', 'temperatura', 690.0000, 'ºC'),
	(224138, 120, '2014-03-01 00:12:15.000000', 'temperatura', 907.0000, 'ºC'),
	(224139, 120, '2014-03-01 00:12:16.000000', 'temperatura', 67.0000, 'ºC'),
	(224140, 120, '2014-03-01 00:12:17.000000', 'temperatura', 14.0000, 'ºC'),
	(224141, 120, '2014-03-01 00:12:18.000000', 'temperatura', 1070.0000, 'ºC'),
	(224142, 120, '2014-03-01 00:12:19.000000', 'temperatura', 507.0000, 'ºC'),
	(224143, 120, '2014-03-01 00:12:20.000000', 'temperatura', 525.0000, 'ºC'),
	(224144, 120, '2014-03-01 00:12:21.000000', 'temperatura', 1106.0000, 'ºC'),
	(224145, 120, '2014-03-01 00:12:22.000000', 'temperatura', 356.0000, 'ºC'),
	(224146, 120, '2014-03-01 00:12:23.000000', 'temperatura', 861.0000, 'ºC'),
	(224147, 120, '2014-03-01 00:12:24.000000', 'temperatura', 840.0000, 'ºC'),
	(224148, 120, '2014-03-01 00:12:25.000000', 'temperatura', 415.0000, 'ºC'),
	(224149, 120, '2014-03-01 00:12:26.000000', 'temperatura', 755.0000, 'ºC'),
	(224150, 120, '2014-03-01 00:12:27.000000', 'temperatura', 130.0000, 'ºC'),
	(224151, 120, '2014-03-01 00:12:28.000000', 'temperatura', 786.0000, 'ºC'),
	(224152, 120, '2014-03-01 00:12:29.000000', 'temperatura', 1140.0000, 'ºC'),
	(224153, 120, '2014-03-01 00:12:30.000000', 'temperatura', 945.0000, 'ºC'),
	(224154, 120, '2014-03-01 00:12:31.000000', 'temperatura', 104.0000, 'ºC'),
	(224155, 120, '2014-03-01 00:12:32.000000', 'temperatura', 87.0000, 'ºC'),
	(224156, 120, '2014-03-01 00:12:33.000000', 'temperatura', 120.0000, 'ºC'),
	(224157, 120, '2014-03-01 00:12:34.000000', 'temperatura', 343.0000, 'ºC'),
	(224158, 120, '2014-03-01 00:12:35.000000', 'temperatura', 156.0000, 'ºC'),
	(224159, 120, '2014-03-01 00:12:36.000000', 'temperatura', 949.0000, 'ºC'),
	(224160, 120, '2014-03-01 00:12:37.000000', 'temperatura', 679.0000, 'ºC'),
	(224161, 120, '2014-03-01 00:12:38.000000', 'temperatura', 550.0000, 'ºC'),
	(224162, 120, '2014-03-01 00:12:39.000000', 'temperatura', 712.0000, 'ºC'),
	(224163, 120, '2014-03-01 00:12:40.000000', 'temperatura', 711.0000, 'ºC'),
	(224164, 120, '2014-03-01 00:12:41.000000', 'temperatura', 219.0000, 'ºC'),
	(224165, 120, '2014-03-01 00:12:42.000000', 'temperatura', 163.0000, 'ºC'),
	(224166, 120, '2014-03-01 00:12:43.000000', 'temperatura', 158.0000, 'ºC'),
	(224167, 120, '2014-03-01 00:12:44.000000', 'temperatura', 301.0000, 'ºC'),
	(224168, 120, '2014-03-01 00:12:45.000000', 'temperatura', 1031.0000, 'ºC'),
	(224169, 120, '2014-03-01 00:12:46.000000', 'temperatura', 655.0000, 'ºC'),
	(224170, 120, '2014-03-01 00:12:47.000000', 'temperatura', 182.0000, 'ºC'),
	(224171, 120, '2014-03-01 00:12:48.000000', 'temperatura', 144.0000, 'ºC'),
	(224172, 120, '2014-03-01 00:12:49.000000', 'temperatura', 176.0000, 'ºC'),
	(224173, 120, '2014-03-01 00:12:50.000000', 'temperatura', 449.0000, 'ºC'),
	(224174, 120, '2014-03-01 00:12:51.000000', 'temperatura', 517.0000, 'ºC'),
	(224175, 120, '2014-03-01 00:12:52.000000', 'temperatura', 36.0000, 'ºC'),
	(224176, 120, '2014-03-01 00:12:53.000000', 'temperatura', 1033.0000, 'ºC'),
	(224177, 120, '2014-03-01 00:12:54.000000', 'temperatura', 256.0000, 'ºC'),
	(224178, 120, '2014-03-01 00:12:55.000000', 'temperatura', 583.0000, 'ºC'),
	(224179, 120, '2014-03-01 00:12:56.000000', 'temperatura', 944.0000, 'ºC'),
	(224180, 120, '2014-03-01 00:12:57.000000', 'temperatura', 575.0000, 'ºC'),
	(224181, 120, '2014-03-01 00:12:58.000000', 'temperatura', 42.0000, 'ºC'),
	(224182, 120, '2014-03-01 00:12:59.000000', 'temperatura', 888.0000, 'ºC'),
	(224183, 120, '2014-03-01 00:13:00.000000', 'temperatura', 711.0000, 'ºC'),
	(224184, 120, '2014-03-01 00:13:01.000000', 'temperatura', 892.0000, 'ºC'),
	(224185, 120, '2014-03-01 00:13:02.000000', 'temperatura', 1128.0000, 'ºC'),
	(224186, 120, '2014-03-01 00:13:03.000000', 'temperatura', 566.0000, 'ºC'),
	(224187, 120, '2014-03-01 00:13:04.000000', 'temperatura', 646.0000, 'ºC'),
	(224188, 120, '2014-03-01 00:13:05.000000', 'temperatura', 331.0000, 'ºC'),
	(224189, 120, '2014-03-01 00:13:06.000000', 'temperatura', 918.0000, 'ºC'),
	(224190, 120, '2014-03-01 00:13:07.000000', 'temperatura', 1197.0000, 'ºC'),
	(224191, 120, '2014-03-01 00:13:08.000000', 'temperatura', 830.0000, 'ºC'),
	(224192, 120, '2014-03-01 00:13:09.000000', 'temperatura', 561.0000, 'ºC'),
	(224193, 120, '2014-03-01 00:13:10.000000', 'temperatura', 315.0000, 'ºC'),
	(224194, 120, '2014-03-01 00:13:11.000000', 'temperatura', 1091.0000, 'ºC'),
	(224195, 120, '2014-03-01 00:13:12.000000', 'temperatura', 913.0000, 'ºC'),
	(224196, 120, '2014-03-01 00:13:13.000000', 'temperatura', 90.0000, 'ºC'),
	(224197, 120, '2014-03-01 00:13:14.000000', 'temperatura', 111.0000, 'ºC'),
	(224198, 120, '2014-03-01 00:13:15.000000', 'temperatura', 289.0000, 'ºC'),
	(224199, 120, '2014-03-01 00:13:16.000000', 'temperatura', 1109.0000, 'ºC'),
	(224200, 120, '2014-03-01 00:13:17.000000', 'temperatura', 1081.0000, 'ºC'),
	(224201, 120, '2014-03-01 00:13:18.000000', 'temperatura', 878.0000, 'ºC'),
	(224202, 120, '2014-03-01 00:13:19.000000', 'temperatura', 1145.0000, 'ºC'),
	(224203, 120, '2014-03-01 00:13:20.000000', 'temperatura', 695.0000, 'ºC'),
	(224204, 120, '2014-03-01 00:13:21.000000', 'temperatura', 40.0000, 'ºC'),
	(224205, 120, '2014-03-01 00:13:22.000000', 'temperatura', 514.0000, 'ºC'),
	(224206, 120, '2014-03-01 00:13:23.000000', 'temperatura', 50.0000, 'ºC'),
	(224207, 120, '2014-03-01 00:13:24.000000', 'temperatura', 1109.0000, 'ºC'),
	(224208, 120, '2014-03-01 00:13:25.000000', 'temperatura', 596.0000, 'ºC'),
	(224209, 120, '2014-03-01 00:13:26.000000', 'temperatura', 855.0000, 'ºC'),
	(224210, 120, '2014-03-01 00:13:27.000000', 'temperatura', 85.0000, 'ºC'),
	(224211, 120, '2014-03-01 00:13:28.000000', 'temperatura', 260.0000, 'ºC'),
	(224212, 120, '2014-03-01 00:13:29.000000', 'temperatura', 1045.0000, 'ºC'),
	(224213, 120, '2014-03-01 00:13:30.000000', 'temperatura', 847.0000, 'ºC'),
	(224214, 120, '2014-03-01 00:13:31.000000', 'temperatura', 1102.0000, 'ºC'),
	(224215, 120, '2014-03-01 00:13:32.000000', 'temperatura', 567.0000, 'ºC'),
	(224216, 120, '2014-03-01 00:13:33.000000', 'temperatura', 729.0000, 'ºC'),
	(224217, 120, '2014-03-01 00:13:34.000000', 'temperatura', 744.0000, 'ºC'),
	(224218, 120, '2014-03-01 00:13:35.000000', 'temperatura', 335.0000, 'ºC'),
	(224219, 120, '2014-03-01 00:13:36.000000', 'temperatura', 643.0000, 'ºC'),
	(224220, 120, '2014-03-01 00:13:37.000000', 'temperatura', 1010.0000, 'ºC'),
	(224221, 120, '2014-03-01 00:13:38.000000', 'temperatura', 723.0000, 'ºC'),
	(224222, 120, '2014-03-01 00:13:39.000000', 'temperatura', 587.0000, 'ºC'),
	(224223, 120, '2014-03-01 00:13:40.000000', 'temperatura', 764.0000, 'ºC'),
	(224224, 120, '2014-03-01 00:13:41.000000', 'temperatura', 859.0000, 'ºC'),
	(224225, 120, '2014-03-01 00:13:42.000000', 'temperatura', 804.0000, 'ºC'),
	(224226, 120, '2014-03-01 00:13:43.000000', 'temperatura', 242.0000, 'ºC'),
	(224227, 120, '2014-03-01 00:13:44.000000', 'temperatura', 1.0000, 'ºC'),
	(224228, 120, '2014-03-01 00:13:45.000000', 'temperatura', 479.0000, 'ºC'),
	(224229, 120, '2014-03-01 00:13:46.000000', 'temperatura', 1191.0000, 'ºC'),
	(224230, 120, '2014-03-01 00:13:47.000000', 'temperatura', 918.0000, 'ºC'),
	(224231, 120, '2014-03-01 00:13:48.000000', 'temperatura', 1020.0000, 'ºC'),
	(224232, 120, '2014-03-01 00:13:49.000000', 'temperatura', 1144.0000, 'ºC'),
	(224233, 120, '2014-03-01 00:13:50.000000', 'temperatura', 263.0000, 'ºC'),
	(224234, 120, '2014-03-01 00:13:51.000000', 'temperatura', 281.0000, 'ºC'),
	(224235, 120, '2014-03-01 00:13:52.000000', 'temperatura', 620.0000, 'ºC'),
	(224236, 120, '2014-03-01 00:13:53.000000', 'temperatura', 1054.0000, 'ºC'),
	(224237, 120, '2014-03-01 00:13:54.000000', 'temperatura', 1011.0000, 'ºC'),
	(224238, 120, '2014-03-01 00:13:55.000000', 'temperatura', 694.0000, 'ºC'),
	(224239, 120, '2014-03-01 00:13:56.000000', 'temperatura', 439.0000, 'ºC'),
	(224240, 120, '2014-03-01 00:13:57.000000', 'temperatura', 114.0000, 'ºC'),
	(224241, 120, '2014-03-01 00:13:58.000000', 'temperatura', 454.0000, 'ºC'),
	(224242, 120, '2014-03-01 00:13:59.000000', 'temperatura', 729.0000, 'ºC'),
	(224243, 120, '2014-03-01 00:14:00.000000', 'temperatura', 1081.0000, 'ºC'),
	(224244, 120, '2014-03-01 00:14:01.000000', 'temperatura', 819.0000, 'ºC'),
	(224245, 120, '2014-03-01 00:14:02.000000', 'temperatura', 852.0000, 'ºC'),
	(224246, 120, '2014-03-01 00:14:03.000000', 'temperatura', 603.0000, 'ºC'),
	(224247, 120, '2014-03-01 00:14:04.000000', 'temperatura', 462.0000, 'ºC'),
	(224248, 120, '2014-03-01 00:14:05.000000', 'temperatura', 498.0000, 'ºC'),
	(224249, 120, '2014-03-01 00:14:06.000000', 'temperatura', 1108.0000, 'ºC'),
	(224250, 120, '2014-03-01 00:14:07.000000', 'temperatura', 444.0000, 'ºC'),
	(224251, 120, '2014-03-01 00:14:08.000000', 'temperatura', 96.0000, 'ºC'),
	(224252, 120, '2014-03-01 00:14:09.000000', 'temperatura', 347.0000, 'ºC'),
	(224253, 120, '2014-03-01 00:14:10.000000', 'temperatura', 250.0000, 'ºC'),
	(224254, 120, '2014-03-01 00:14:11.000000', 'temperatura', 211.0000, 'ºC'),
	(224255, 120, '2014-03-01 00:14:12.000000', 'temperatura', 303.0000, 'ºC'),
	(224256, 120, '2014-03-01 00:14:13.000000', 'temperatura', 881.0000, 'ºC'),
	(224257, 120, '2014-03-01 00:14:14.000000', 'temperatura', 1099.0000, 'ºC'),
	(224258, 120, '2014-03-01 00:14:15.000000', 'temperatura', 451.0000, 'ºC'),
	(224259, 120, '2014-03-01 00:14:16.000000', 'temperatura', 157.0000, 'ºC'),
	(224260, 120, '2014-03-01 00:14:17.000000', 'temperatura', 636.0000, 'ºC'),
	(224261, 120, '2014-03-01 00:14:18.000000', 'temperatura', 307.0000, 'ºC'),
	(224262, 120, '2014-03-01 00:14:19.000000', 'temperatura', 829.0000, 'ºC'),
	(224263, 120, '2014-03-01 00:14:20.000000', 'temperatura', 823.0000, 'ºC'),
	(224264, 120, '2014-03-01 00:14:21.000000', 'temperatura', 430.0000, 'ºC'),
	(224265, 120, '2014-03-01 00:14:22.000000', 'temperatura', 880.0000, 'ºC'),
	(224266, 120, '2014-03-01 00:14:23.000000', 'temperatura', 713.0000, 'ºC'),
	(224267, 120, '2014-03-01 00:14:24.000000', 'temperatura', 923.0000, 'ºC'),
	(224268, 120, '2014-03-01 00:14:25.000000', 'temperatura', 79.0000, 'ºC'),
	(224269, 120, '2014-03-01 00:14:26.000000', 'temperatura', 27.0000, 'ºC'),
	(224270, 120, '2014-03-01 00:14:27.000000', 'temperatura', 1096.0000, 'ºC'),
	(224271, 120, '2014-03-01 00:14:28.000000', 'temperatura', 601.0000, 'ºC'),
	(224272, 120, '2014-03-01 00:14:29.000000', 'temperatura', 917.0000, 'ºC'),
	(224273, 120, '2014-03-01 00:14:30.000000', 'temperatura', 381.0000, 'ºC'),
	(224274, 120, '2014-03-01 00:14:31.000000', 'temperatura', 357.0000, 'ºC'),
	(224275, 120, '2014-03-01 00:14:32.000000', 'temperatura', 642.0000, 'ºC'),
	(224276, 120, '2014-03-01 00:14:33.000000', 'temperatura', 940.0000, 'ºC'),
	(224277, 120, '2014-03-01 00:14:34.000000', 'temperatura', 372.0000, 'ºC'),
	(224278, 120, '2014-03-01 00:14:35.000000', 'temperatura', 243.0000, 'ºC'),
	(224279, 120, '2014-03-01 00:14:36.000000', 'temperatura', 98.0000, 'ºC'),
	(224280, 120, '2014-03-01 00:14:37.000000', 'temperatura', 963.0000, 'ºC'),
	(224281, 120, '2014-03-01 00:14:38.000000', 'temperatura', 920.0000, 'ºC'),
	(224282, 120, '2014-03-01 00:14:39.000000', 'temperatura', 514.0000, 'ºC'),
	(224283, 120, '2014-03-01 00:14:40.000000', 'temperatura', 1010.0000, 'ºC'),
	(224284, 120, '2014-03-01 00:14:41.000000', 'temperatura', 1106.0000, 'ºC'),
	(224285, 120, '2014-03-01 00:14:42.000000', 'temperatura', 103.0000, 'ºC'),
	(224286, 120, '2014-03-01 00:14:43.000000', 'temperatura', 795.0000, 'ºC'),
	(224287, 120, '2014-03-01 00:14:44.000000', 'temperatura', 68.0000, 'ºC'),
	(224288, 120, '2014-03-01 00:14:45.000000', 'temperatura', 356.0000, 'ºC'),
	(224289, 120, '2014-03-01 00:14:46.000000', 'temperatura', 376.0000, 'ºC'),
	(224290, 120, '2014-03-01 00:14:47.000000', 'temperatura', 811.0000, 'ºC'),
	(224291, 120, '2014-03-01 00:14:48.000000', 'temperatura', 529.0000, 'ºC'),
	(224292, 120, '2014-03-01 00:14:49.000000', 'temperatura', 212.0000, 'ºC'),
	(224293, 120, '2014-03-01 00:14:50.000000', 'temperatura', 671.0000, 'ºC'),
	(224294, 120, '2014-03-01 00:14:51.000000', 'temperatura', 323.0000, 'ºC'),
	(224295, 120, '2014-03-01 00:14:52.000000', 'temperatura', 803.0000, 'ºC'),
	(224296, 120, '2014-03-01 00:14:53.000000', 'temperatura', 646.0000, 'ºC'),
	(224297, 120, '2014-03-01 00:14:54.000000', 'temperatura', 823.0000, 'ºC'),
	(224298, 120, '2014-03-01 00:14:55.000000', 'temperatura', 976.0000, 'ºC'),
	(224299, 120, '2014-03-01 00:14:56.000000', 'temperatura', 12.0000, 'ºC'),
	(224300, 120, '2014-03-01 00:14:57.000000', 'temperatura', 734.0000, 'ºC'),
	(224301, 120, '2014-03-01 00:14:58.000000', 'temperatura', 32.0000, 'ºC'),
	(224302, 120, '2014-03-01 00:14:59.000000', 'temperatura', 358.0000, 'ºC'),
	(224303, 120, '2014-03-01 00:15:00.000000', 'temperatura', 496.0000, 'ºC'),
	(224304, 120, '2014-03-01 00:15:01.000000', 'temperatura', 207.0000, 'ºC'),
	(224305, 120, '2014-03-01 00:15:02.000000', 'temperatura', 745.0000, 'ºC'),
	(224306, 120, '2014-03-01 00:15:03.000000', 'temperatura', 706.0000, 'ºC'),
	(224307, 120, '2014-03-01 00:15:04.000000', 'temperatura', 95.0000, 'ºC'),
	(224308, 120, '2014-03-01 00:15:05.000000', 'temperatura', 757.0000, 'ºC'),
	(224309, 120, '2014-03-01 00:15:06.000000', 'temperatura', 1103.0000, 'ºC'),
	(224310, 120, '2014-03-01 00:15:07.000000', 'temperatura', 841.0000, 'ºC'),
	(224311, 120, '2014-03-01 00:15:08.000000', 'temperatura', 898.0000, 'ºC'),
	(224312, 120, '2014-03-01 00:15:09.000000', 'temperatura', 770.0000, 'ºC'),
	(224313, 120, '2014-03-01 00:15:10.000000', 'temperatura', 1153.0000, 'ºC'),
	(224314, 120, '2014-03-01 00:15:11.000000', 'temperatura', 1057.0000, 'ºC'),
	(224315, 120, '2014-03-01 00:15:12.000000', 'temperatura', 626.0000, 'ºC'),
	(224316, 120, '2014-03-01 00:15:13.000000', 'temperatura', 1161.0000, 'ºC'),
	(224317, 120, '2014-03-01 00:15:14.000000', 'temperatura', 327.0000, 'ºC'),
	(224318, 120, '2014-03-01 00:15:15.000000', 'temperatura', 553.0000, 'ºC'),
	(224319, 120, '2014-03-01 00:15:16.000000', 'temperatura', 584.0000, 'ºC'),
	(224320, 120, '2014-03-01 00:15:17.000000', 'temperatura', 62.0000, 'ºC'),
	(224321, 120, '2014-03-01 00:15:18.000000', 'temperatura', 957.0000, 'ºC'),
	(224322, 120, '2014-03-01 00:15:19.000000', 'temperatura', 1002.0000, 'ºC'),
	(224323, 120, '2014-03-01 00:15:20.000000', 'temperatura', 940.0000, 'ºC'),
	(224324, 120, '2014-03-01 00:15:21.000000', 'temperatura', 494.0000, 'ºC'),
	(224325, 120, '2014-03-01 00:15:22.000000', 'temperatura', 850.0000, 'ºC'),
	(224326, 120, '2014-03-01 00:15:23.000000', 'temperatura', 368.0000, 'ºC'),
	(224327, 120, '2014-03-01 00:15:24.000000', 'temperatura', 493.0000, 'ºC'),
	(224328, 120, '2014-03-01 00:15:25.000000', 'temperatura', 159.0000, 'ºC'),
	(224329, 120, '2014-03-01 00:15:26.000000', 'temperatura', 519.0000, 'ºC'),
	(224330, 120, '2014-03-01 00:15:27.000000', 'temperatura', 917.0000, 'ºC'),
	(224331, 120, '2014-03-01 00:15:28.000000', 'temperatura', 627.0000, 'ºC'),
	(224332, 120, '2014-03-01 00:15:29.000000', 'temperatura', 386.0000, 'ºC'),
	(224333, 120, '2014-03-01 00:15:30.000000', 'temperatura', 49.0000, 'ºC'),
	(224334, 120, '2014-03-01 00:15:31.000000', 'temperatura', 290.0000, 'ºC'),
	(224335, 120, '2014-03-01 00:15:32.000000', 'temperatura', 100.0000, 'ºC'),
	(224336, 120, '2014-03-01 00:15:33.000000', 'temperatura', 832.0000, 'ºC'),
	(224337, 120, '2014-03-01 00:15:34.000000', 'temperatura', 259.0000, 'ºC'),
	(224338, 120, '2014-03-01 00:15:35.000000', 'temperatura', 2.0000, 'ºC'),
	(224339, 120, '2014-03-01 00:15:36.000000', 'temperatura', 433.0000, 'ºC'),
	(224340, 120, '2014-03-01 00:15:37.000000', 'temperatura', 958.0000, 'ºC'),
	(224341, 120, '2014-03-01 00:15:38.000000', 'temperatura', 1094.0000, 'ºC'),
	(224342, 120, '2014-03-01 00:15:39.000000', 'temperatura', 194.0000, 'ºC'),
	(224343, 120, '2014-03-01 00:15:40.000000', 'temperatura', 88.0000, 'ºC'),
	(224344, 120, '2014-03-01 00:15:41.000000', 'temperatura', 1060.0000, 'ºC'),
	(224345, 120, '2014-03-01 00:15:42.000000', 'temperatura', 238.0000, 'ºC'),
	(224346, 120, '2014-03-01 00:15:43.000000', 'temperatura', 410.0000, 'ºC'),
	(224347, 120, '2014-03-01 00:15:44.000000', 'temperatura', 136.0000, 'ºC'),
	(224348, 120, '2014-03-01 00:15:45.000000', 'temperatura', 651.0000, 'ºC'),
	(224349, 120, '2014-03-01 00:15:46.000000', 'temperatura', 446.0000, 'ºC'),
	(224350, 120, '2014-03-01 00:15:47.000000', 'temperatura', 278.0000, 'ºC'),
	(224351, 120, '2014-03-01 00:15:48.000000', 'temperatura', 53.0000, 'ºC'),
	(224352, 120, '2014-03-01 00:15:49.000000', 'temperatura', 633.0000, 'ºC'),
	(224353, 120, '2014-03-01 00:15:50.000000', 'temperatura', 606.0000, 'ºC'),
	(224354, 120, '2014-03-01 00:15:51.000000', 'temperatura', 1133.0000, 'ºC'),
	(224355, 120, '2014-03-01 00:15:52.000000', 'temperatura', 247.0000, 'ºC'),
	(224356, 120, '2014-03-01 00:15:53.000000', 'temperatura', 235.0000, 'ºC'),
	(224357, 120, '2014-03-01 00:15:54.000000', 'temperatura', 435.0000, 'ºC'),
	(224358, 120, '2014-03-01 00:15:55.000000', 'temperatura', 269.0000, 'ºC'),
	(224359, 120, '2014-03-01 00:15:56.000000', 'temperatura', 43.0000, 'ºC'),
	(224360, 120, '2014-03-01 00:15:57.000000', 'temperatura', 606.0000, 'ºC'),
	(224361, 120, '2014-03-01 00:15:58.000000', 'temperatura', 505.0000, 'ºC'),
	(224362, 120, '2014-03-01 00:15:59.000000', 'temperatura', 704.0000, 'ºC'),
	(224363, 120, '2014-03-01 00:16:00.000000', 'temperatura', 809.0000, 'ºC'),
	(224364, 120, '2014-03-01 00:16:01.000000', 'temperatura', 730.0000, 'ºC'),
	(224365, 120, '2014-03-01 00:16:02.000000', 'temperatura', 24.0000, 'ºC'),
	(224366, 120, '2014-03-01 00:16:03.000000', 'temperatura', 331.0000, 'ºC'),
	(224367, 120, '2014-03-01 00:16:04.000000', 'temperatura', 385.0000, 'ºC'),
	(224368, 120, '2014-03-01 00:16:05.000000', 'temperatura', 933.0000, 'ºC'),
	(224369, 120, '2014-03-01 00:16:06.000000', 'temperatura', 1111.0000, 'ºC'),
	(224370, 120, '2014-03-01 00:16:07.000000', 'temperatura', 358.0000, 'ºC'),
	(224371, 120, '2014-03-01 00:16:08.000000', 'temperatura', 854.0000, 'ºC'),
	(224372, 120, '2014-03-01 00:16:09.000000', 'temperatura', 796.0000, 'ºC'),
	(224373, 120, '2014-03-01 00:16:10.000000', 'temperatura', 221.0000, 'ºC'),
	(224374, 120, '2014-03-01 00:16:11.000000', 'temperatura', 1116.0000, 'ºC'),
	(224375, 120, '2014-03-01 00:16:12.000000', 'temperatura', 116.0000, 'ºC'),
	(224376, 120, '2014-03-01 00:16:13.000000', 'temperatura', 835.0000, 'ºC'),
	(224377, 120, '2014-03-01 00:16:14.000000', 'temperatura', 225.0000, 'ºC'),
	(224378, 120, '2014-03-01 00:16:15.000000', 'temperatura', 1023.0000, 'ºC'),
	(224379, 120, '2014-03-01 00:16:16.000000', 'temperatura', 839.0000, 'ºC'),
	(224380, 120, '2014-03-01 00:16:17.000000', 'temperatura', 1127.0000, 'ºC'),
	(224381, 120, '2014-03-01 00:16:18.000000', 'temperatura', 718.0000, 'ºC'),
	(224382, 120, '2014-03-01 00:16:19.000000', 'temperatura', 211.0000, 'ºC'),
	(224383, 120, '2014-03-01 00:16:20.000000', 'temperatura', 99.0000, 'ºC'),
	(224384, 120, '2014-03-01 00:16:21.000000', 'temperatura', 1066.0000, 'ºC'),
	(224385, 120, '2014-03-01 00:16:22.000000', 'temperatura', 231.0000, 'ºC'),
	(224386, 120, '2014-03-01 00:16:23.000000', 'temperatura', 358.0000, 'ºC'),
	(224387, 120, '2014-03-01 00:16:24.000000', 'temperatura', 1096.0000, 'ºC'),
	(224388, 120, '2014-03-01 00:16:25.000000', 'temperatura', 806.0000, 'ºC'),
	(224389, 120, '2014-03-01 00:16:26.000000', 'temperatura', 742.0000, 'ºC'),
	(224390, 120, '2014-03-01 00:16:27.000000', 'temperatura', 94.0000, 'ºC'),
	(224391, 120, '2014-03-01 00:16:28.000000', 'temperatura', 643.0000, 'ºC'),
	(224392, 120, '2014-03-01 00:16:29.000000', 'temperatura', 533.0000, 'ºC'),
	(224393, 120, '2014-03-01 00:16:30.000000', 'temperatura', 738.0000, 'ºC'),
	(224394, 120, '2014-03-01 00:16:31.000000', 'temperatura', 893.0000, 'ºC'),
	(224395, 120, '2014-03-01 00:16:32.000000', 'temperatura', 1050.0000, 'ºC'),
	(224396, 120, '2014-03-01 00:16:33.000000', 'temperatura', 171.0000, 'ºC'),
	(224397, 120, '2014-03-01 00:16:34.000000', 'temperatura', 107.0000, 'ºC'),
	(224398, 120, '2014-03-01 00:16:35.000000', 'temperatura', 23.0000, 'ºC'),
	(224399, 120, '2014-03-01 00:16:36.000000', 'temperatura', 996.0000, 'ºC'),
	(224400, 120, '2014-03-01 00:16:37.000000', 'temperatura', 108.0000, 'ºC'),
	(224401, 120, '2014-03-01 00:16:38.000000', 'temperatura', 1154.0000, 'ºC'),
	(224402, 120, '2014-03-01 00:16:39.000000', 'temperatura', 647.0000, 'ºC'),
	(224403, 120, '2014-03-01 00:16:40.000000', 'temperatura', 971.0000, 'ºC'),
	(224404, 120, '2014-03-01 00:16:41.000000', 'temperatura', 516.0000, 'ºC'),
	(224405, 120, '2014-03-01 00:16:42.000000', 'temperatura', 868.0000, 'ºC'),
	(224406, 120, '2014-03-01 00:16:43.000000', 'temperatura', 392.0000, 'ºC'),
	(224407, 120, '2014-03-01 00:16:44.000000', 'temperatura', 557.0000, 'ºC'),
	(224408, 120, '2014-03-01 00:16:45.000000', 'temperatura', 409.0000, 'ºC'),
	(224409, 120, '2014-03-01 00:16:46.000000', 'temperatura', 377.0000, 'ºC'),
	(224410, 120, '2014-03-01 00:16:47.000000', 'temperatura', 655.0000, 'ºC'),
	(224411, 120, '2014-03-01 00:16:48.000000', 'temperatura', 948.0000, 'ºC'),
	(224412, 120, '2014-03-01 00:16:49.000000', 'temperatura', 373.0000, 'ºC'),
	(224413, 120, '2014-03-01 00:16:50.000000', 'temperatura', 223.0000, 'ºC'),
	(224414, 120, '2014-03-01 00:16:51.000000', 'temperatura', 1197.0000, 'ºC'),
	(224415, 120, '2014-03-01 00:16:52.000000', 'temperatura', 515.0000, 'ºC'),
	(224416, 120, '2014-03-01 00:16:53.000000', 'temperatura', 183.0000, 'ºC'),
	(224417, 120, '2014-03-01 00:16:54.000000', 'temperatura', 573.0000, 'ºC'),
	(224418, 120, '2014-03-01 00:16:55.000000', 'temperatura', 1118.0000, 'ºC'),
	(224419, 120, '2014-03-01 00:16:56.000000', 'temperatura', 269.0000, 'ºC'),
	(224420, 120, '2014-03-01 00:16:57.000000', 'temperatura', 393.0000, 'ºC'),
	(224421, 120, '2014-03-01 00:16:58.000000', 'temperatura', 1159.0000, 'ºC'),
	(224422, 120, '2014-03-01 00:16:59.000000', 'temperatura', 1017.0000, 'ºC'),
	(224423, 120, '2014-03-01 00:17:00.000000', 'temperatura', 405.0000, 'ºC'),
	(224424, 120, '2014-03-01 00:17:01.000000', 'temperatura', 178.0000, 'ºC'),
	(224425, 120, '2014-03-01 00:17:02.000000', 'temperatura', 876.0000, 'ºC'),
	(224426, 120, '2014-03-01 00:17:03.000000', 'temperatura', 247.0000, 'ºC'),
	(224427, 120, '2014-03-01 00:17:04.000000', 'temperatura', 1005.0000, 'ºC'),
	(224428, 120, '2014-03-01 00:17:05.000000', 'temperatura', 687.0000, 'ºC'),
	(224429, 120, '2014-03-01 00:17:06.000000', 'temperatura', 419.0000, 'ºC'),
	(224430, 120, '2014-03-01 00:17:07.000000', 'temperatura', 35.0000, 'ºC'),
	(224431, 120, '2014-03-01 00:17:08.000000', 'temperatura', 118.0000, 'ºC'),
	(224432, 120, '2014-03-01 00:17:09.000000', 'temperatura', 486.0000, 'ºC'),
	(224433, 120, '2014-03-01 00:17:10.000000', 'temperatura', 875.0000, 'ºC'),
	(224434, 120, '2014-03-01 00:17:11.000000', 'temperatura', 520.0000, 'ºC'),
	(224435, 120, '2014-03-01 00:17:12.000000', 'temperatura', 1176.0000, 'ºC'),
	(224436, 120, '2014-03-01 00:17:13.000000', 'temperatura', 720.0000, 'ºC'),
	(224437, 120, '2014-03-01 00:17:14.000000', 'temperatura', 71.0000, 'ºC'),
	(224438, 120, '2014-03-01 00:17:15.000000', 'temperatura', 597.0000, 'ºC'),
	(224439, 120, '2014-03-01 00:17:16.000000', 'temperatura', 373.0000, 'ºC'),
	(224440, 120, '2014-03-01 00:17:17.000000', 'temperatura', 72.0000, 'ºC'),
	(224441, 120, '2014-03-01 00:17:18.000000', 'temperatura', 444.0000, 'ºC'),
	(224442, 120, '2014-03-01 00:17:19.000000', 'temperatura', 803.0000, 'ºC'),
	(224443, 120, '2014-03-01 00:17:20.000000', 'temperatura', 284.0000, 'ºC'),
	(224444, 120, '2014-03-01 00:17:21.000000', 'temperatura', 211.0000, 'ºC'),
	(224445, 120, '2014-03-01 00:17:22.000000', 'temperatura', 203.0000, 'ºC'),
	(224446, 120, '2014-03-01 00:17:23.000000', 'temperatura', 381.0000, 'ºC'),
	(224447, 120, '2014-03-01 00:17:24.000000', 'temperatura', 98.0000, 'ºC'),
	(224448, 120, '2014-03-01 00:17:25.000000', 'temperatura', 547.0000, 'ºC'),
	(224449, 120, '2014-03-01 00:17:26.000000', 'temperatura', 42.0000, 'ºC'),
	(224450, 120, '2014-03-01 00:17:27.000000', 'temperatura', 970.0000, 'ºC'),
	(224451, 120, '2014-03-01 00:17:28.000000', 'temperatura', 1125.0000, 'ºC'),
	(224452, 120, '2014-03-01 00:17:29.000000', 'temperatura', 314.0000, 'ºC'),
	(224453, 120, '2014-03-01 00:17:30.000000', 'temperatura', 594.0000, 'ºC'),
	(224454, 120, '2014-03-01 00:17:31.000000', 'temperatura', 830.0000, 'ºC'),
	(224455, 120, '2014-03-01 00:17:32.000000', 'temperatura', 1168.0000, 'ºC'),
	(224456, 120, '2014-03-01 00:17:33.000000', 'temperatura', 951.0000, 'ºC'),
	(224457, 120, '2014-03-01 00:17:34.000000', 'temperatura', 52.0000, 'ºC'),
	(224458, 120, '2014-03-01 00:17:35.000000', 'temperatura', 1006.0000, 'ºC'),
	(224459, 120, '2014-03-01 00:17:36.000000', 'temperatura', 75.0000, 'ºC'),
	(224460, 120, '2014-03-01 00:17:37.000000', 'temperatura', 959.0000, 'ºC'),
	(224461, 120, '2014-03-01 00:17:38.000000', 'temperatura', 969.0000, 'ºC'),
	(224462, 120, '2014-03-01 00:17:39.000000', 'temperatura', 768.0000, 'ºC'),
	(224463, 120, '2014-03-01 00:17:40.000000', 'temperatura', 935.0000, 'ºC'),
	(224464, 120, '2014-03-01 00:17:41.000000', 'temperatura', 1170.0000, 'ºC'),
	(224465, 120, '2014-03-01 00:17:42.000000', 'temperatura', 645.0000, 'ºC'),
	(224466, 120, '2014-03-01 00:17:43.000000', 'temperatura', 918.0000, 'ºC'),
	(224467, 120, '2014-03-01 00:17:44.000000', 'temperatura', 255.0000, 'ºC'),
	(224468, 120, '2014-03-01 00:17:45.000000', 'temperatura', 919.0000, 'ºC'),
	(224469, 120, '2014-03-01 00:17:46.000000', 'temperatura', 233.0000, 'ºC'),
	(224470, 120, '2014-03-01 00:17:47.000000', 'temperatura', 808.0000, 'ºC'),
	(224471, 120, '2014-03-01 00:17:48.000000', 'temperatura', 942.0000, 'ºC'),
	(224472, 120, '2014-03-01 00:17:49.000000', 'temperatura', 1087.0000, 'ºC'),
	(224473, 120, '2014-03-01 00:17:50.000000', 'temperatura', 211.0000, 'ºC'),
	(224474, 120, '2014-03-01 00:17:51.000000', 'temperatura', 192.0000, 'ºC'),
	(224475, 120, '2014-03-01 00:17:52.000000', 'temperatura', 330.0000, 'ºC'),
	(224476, 120, '2014-03-01 00:17:53.000000', 'temperatura', 1072.0000, 'ºC'),
	(224477, 120, '2014-03-01 00:17:54.000000', 'temperatura', 772.0000, 'ºC'),
	(224478, 120, '2014-03-01 00:17:55.000000', 'temperatura', 644.0000, 'ºC'),
	(224479, 120, '2014-03-01 00:17:56.000000', 'temperatura', 904.0000, 'ºC'),
	(224480, 120, '2014-03-01 00:17:57.000000', 'temperatura', 189.0000, 'ºC'),
	(224481, 120, '2014-03-01 00:17:58.000000', 'temperatura', 634.0000, 'ºC'),
	(224482, 120, '2014-03-01 00:17:59.000000', 'temperatura', 202.0000, 'ºC'),
	(224483, 120, '2014-03-01 00:18:00.000000', 'temperatura', 311.0000, 'ºC'),
	(224484, 120, '2014-03-01 00:18:01.000000', 'temperatura', 947.0000, 'ºC'),
	(224485, 120, '2014-03-01 00:18:02.000000', 'temperatura', 201.0000, 'ºC'),
	(224486, 120, '2014-03-01 00:18:03.000000', 'temperatura', 568.0000, 'ºC'),
	(224487, 120, '2014-03-01 00:18:04.000000', 'temperatura', 1037.0000, 'ºC'),
	(224488, 120, '2014-03-01 00:18:05.000000', 'temperatura', 1081.0000, 'ºC'),
	(224489, 120, '2014-03-01 00:18:06.000000', 'temperatura', 1096.0000, 'ºC'),
	(224490, 120, '2014-03-01 00:18:07.000000', 'temperatura', 1036.0000, 'ºC'),
	(224491, 120, '2014-03-01 00:18:08.000000', 'temperatura', 693.0000, 'ºC'),
	(224492, 120, '2014-03-01 00:18:09.000000', 'temperatura', 356.0000, 'ºC'),
	(224493, 120, '2014-03-01 00:18:10.000000', 'temperatura', 903.0000, 'ºC'),
	(224494, 120, '2014-03-01 00:18:11.000000', 'temperatura', 1048.0000, 'ºC'),
	(224495, 120, '2014-03-01 00:18:12.000000', 'temperatura', 132.0000, 'ºC'),
	(224496, 120, '2014-03-01 00:18:13.000000', 'temperatura', 1117.0000, 'ºC'),
	(224497, 120, '2014-03-01 00:18:14.000000', 'temperatura', 391.0000, 'ºC'),
	(224498, 120, '2014-03-01 00:18:15.000000', 'temperatura', 1001.0000, 'ºC'),
	(224499, 120, '2014-03-01 00:18:16.000000', 'temperatura', 235.0000, 'ºC'),
	(224500, 120, '2014-03-01 00:18:17.000000', 'temperatura', 572.0000, 'ºC'),
	(224501, 120, '2014-03-01 00:18:18.000000', 'temperatura', 954.0000, 'ºC'),
	(224502, 120, '2014-03-01 00:18:19.000000', 'temperatura', 655.0000, 'ºC'),
	(224503, 120, '2014-03-01 00:18:20.000000', 'temperatura', 414.0000, 'ºC'),
	(224504, 120, '2014-03-01 00:18:21.000000', 'temperatura', 105.0000, 'ºC'),
	(224505, 120, '2014-03-01 00:18:22.000000', 'temperatura', 483.0000, 'ºC'),
	(224506, 120, '2014-03-01 00:18:23.000000', 'temperatura', 903.0000, 'ºC'),
	(224507, 120, '2014-03-01 00:18:24.000000', 'temperatura', 664.0000, 'ºC'),
	(224508, 120, '2014-03-01 00:18:25.000000', 'temperatura', 611.0000, 'ºC'),
	(224509, 120, '2014-03-01 00:18:26.000000', 'temperatura', 1066.0000, 'ºC'),
	(224510, 120, '2014-03-01 00:18:27.000000', 'temperatura', 1096.0000, 'ºC'),
	(224511, 120, '2014-03-01 00:18:28.000000', 'temperatura', 1083.0000, 'ºC'),
	(224512, 120, '2014-03-01 00:18:29.000000', 'temperatura', 926.0000, 'ºC'),
	(224513, 120, '2014-03-01 00:18:30.000000', 'temperatura', 184.0000, 'ºC'),
	(224514, 120, '2014-03-01 00:18:31.000000', 'temperatura', 541.0000, 'ºC'),
	(224515, 120, '2014-03-01 00:18:32.000000', 'temperatura', 954.0000, 'ºC'),
	(224516, 120, '2014-03-01 00:18:33.000000', 'temperatura', 748.0000, 'ºC'),
	(224517, 120, '2014-03-01 00:18:34.000000', 'temperatura', 878.0000, 'ºC'),
	(224518, 120, '2014-03-01 00:18:35.000000', 'temperatura', 948.0000, 'ºC'),
	(224519, 120, '2014-03-01 00:18:36.000000', 'temperatura', 904.0000, 'ºC'),
	(224520, 120, '2014-03-01 00:18:37.000000', 'temperatura', 476.0000, 'ºC'),
	(224521, 120, '2014-03-01 00:18:38.000000', 'temperatura', 870.0000, 'ºC'),
	(224522, 120, '2014-03-01 00:18:39.000000', 'temperatura', 522.0000, 'ºC'),
	(224523, 120, '2014-03-01 00:18:40.000000', 'temperatura', 1199.0000, 'ºC'),
	(224524, 120, '2014-03-01 00:18:41.000000', 'temperatura', 830.0000, 'ºC'),
	(224525, 120, '2014-03-01 00:18:42.000000', 'temperatura', 554.0000, 'ºC'),
	(224526, 120, '2014-03-01 00:18:43.000000', 'temperatura', 279.0000, 'ºC'),
	(224527, 120, '2014-03-01 00:18:44.000000', 'temperatura', 934.0000, 'ºC'),
	(224528, 120, '2014-03-01 00:18:45.000000', 'temperatura', 236.0000, 'ºC'),
	(224529, 120, '2014-03-01 00:18:46.000000', 'temperatura', 775.0000, 'ºC'),
	(224530, 120, '2014-03-01 00:18:47.000000', 'temperatura', 769.0000, 'ºC'),
	(224531, 120, '2014-03-01 00:18:48.000000', 'temperatura', 320.0000, 'ºC'),
	(224532, 120, '2014-03-01 00:18:49.000000', 'temperatura', 496.0000, 'ºC'),
	(224533, 120, '2014-03-01 00:18:50.000000', 'temperatura', 318.0000, 'ºC'),
	(224534, 120, '2014-03-01 00:18:51.000000', 'temperatura', 103.0000, 'ºC'),
	(224535, 120, '2014-03-01 00:18:52.000000', 'temperatura', 762.0000, 'ºC'),
	(224536, 120, '2014-03-01 00:18:53.000000', 'temperatura', 1100.0000, 'ºC'),
	(224537, 120, '2014-03-01 00:18:54.000000', 'temperatura', 813.0000, 'ºC'),
	(224538, 120, '2014-03-01 00:18:55.000000', 'temperatura', 769.0000, 'ºC'),
	(224539, 120, '2014-03-01 00:18:56.000000', 'temperatura', 206.0000, 'ºC'),
	(224540, 120, '2014-03-01 00:18:57.000000', 'temperatura', 1123.0000, 'ºC'),
	(224541, 120, '2014-03-01 00:18:58.000000', 'temperatura', 198.0000, 'ºC'),
	(224542, 120, '2014-03-01 00:18:59.000000', 'temperatura', 21.0000, 'ºC'),
	(224543, 120, '2014-03-01 00:19:00.000000', 'temperatura', 712.0000, 'ºC'),
	(224544, 120, '2014-03-01 00:19:01.000000', 'temperatura', 1097.0000, 'ºC'),
	(224545, 120, '2014-03-01 00:19:02.000000', 'temperatura', 951.0000, 'ºC'),
	(224546, 120, '2014-03-01 00:19:03.000000', 'temperatura', 263.0000, 'ºC'),
	(224547, 120, '2014-03-01 00:19:04.000000', 'temperatura', 861.0000, 'ºC'),
	(224548, 120, '2014-03-01 00:19:05.000000', 'temperatura', 1119.0000, 'ºC'),
	(224549, 120, '2014-03-01 00:19:06.000000', 'temperatura', 613.0000, 'ºC'),
	(224550, 120, '2014-03-01 00:19:07.000000', 'temperatura', 909.0000, 'ºC'),
	(224551, 120, '2014-03-01 00:19:08.000000', 'temperatura', 304.0000, 'ºC'),
	(224552, 120, '2014-03-01 00:19:09.000000', 'temperatura', 1196.0000, 'ºC'),
	(224553, 120, '2014-03-01 00:19:10.000000', 'temperatura', 268.0000, 'ºC'),
	(224554, 120, '2014-03-01 00:19:11.000000', 'temperatura', 154.0000, 'ºC'),
	(224555, 120, '2014-03-01 00:19:12.000000', 'temperatura', 1163.0000, 'ºC'),
	(224556, 120, '2014-03-01 00:19:13.000000', 'temperatura', 556.0000, 'ºC'),
	(224557, 120, '2014-03-01 00:19:14.000000', 'temperatura', 491.0000, 'ºC'),
	(224558, 120, '2014-03-01 00:19:15.000000', 'temperatura', 787.0000, 'ºC'),
	(224559, 120, '2014-03-01 00:19:16.000000', 'temperatura', 62.0000, 'ºC'),
	(224560, 120, '2014-03-01 00:19:17.000000', 'temperatura', 351.0000, 'ºC'),
	(224561, 120, '2014-03-01 00:19:18.000000', 'temperatura', 367.0000, 'ºC'),
	(224562, 120, '2014-03-01 00:19:19.000000', 'temperatura', 783.0000, 'ºC'),
	(224563, 120, '2014-03-01 00:19:20.000000', 'temperatura', 416.0000, 'ºC'),
	(224564, 120, '2014-03-01 00:19:21.000000', 'temperatura', 932.0000, 'ºC'),
	(224565, 120, '2014-03-01 00:19:22.000000', 'temperatura', 1011.0000, 'ºC'),
	(224566, 120, '2014-03-01 00:19:23.000000', 'temperatura', 1059.0000, 'ºC'),
	(224567, 120, '2014-03-01 00:19:24.000000', 'temperatura', 1062.0000, 'ºC'),
	(224568, 120, '2014-03-01 00:19:25.000000', 'temperatura', 936.0000, 'ºC'),
	(224569, 120, '2014-03-01 00:19:26.000000', 'temperatura', 294.0000, 'ºC'),
	(224570, 120, '2014-03-01 00:19:27.000000', 'temperatura', 1064.0000, 'ºC'),
	(224571, 120, '2014-03-01 00:19:28.000000', 'temperatura', 835.0000, 'ºC'),
	(224572, 120, '2014-03-01 00:19:29.000000', 'temperatura', 985.0000, 'ºC'),
	(224573, 120, '2014-03-01 00:19:30.000000', 'temperatura', 21.0000, 'ºC'),
	(224574, 120, '2014-03-01 00:19:31.000000', 'temperatura', 749.0000, 'ºC'),
	(224575, 120, '2014-03-01 00:19:32.000000', 'temperatura', 83.0000, 'ºC'),
	(224576, 120, '2014-03-01 00:19:33.000000', 'temperatura', 571.0000, 'ºC'),
	(224577, 120, '2014-03-01 00:19:34.000000', 'temperatura', 204.0000, 'ºC'),
	(224578, 120, '2014-03-01 00:19:35.000000', 'temperatura', 506.0000, 'ºC'),
	(224579, 120, '2014-03-01 00:19:36.000000', 'temperatura', 720.0000, 'ºC'),
	(224580, 120, '2014-03-01 00:19:37.000000', 'temperatura', 882.0000, 'ºC'),
	(224581, 120, '2014-03-01 00:19:38.000000', 'temperatura', 1051.0000, 'ºC'),
	(224582, 120, '2014-03-01 00:19:39.000000', 'temperatura', 209.0000, 'ºC'),
	(224583, 120, '2014-03-01 00:19:40.000000', 'temperatura', 292.0000, 'ºC'),
	(224584, 120, '2014-03-01 00:19:41.000000', 'temperatura', 833.0000, 'ºC'),
	(224585, 120, '2014-03-01 00:19:42.000000', 'temperatura', 892.0000, 'ºC'),
	(224586, 120, '2014-03-01 00:19:43.000000', 'temperatura', 761.0000, 'ºC'),
	(224587, 120, '2014-03-01 00:19:44.000000', 'temperatura', 1128.0000, 'ºC'),
	(224588, 120, '2014-03-01 00:19:45.000000', 'temperatura', 959.0000, 'ºC'),
	(224589, 120, '2014-03-01 00:19:46.000000', 'temperatura', 213.0000, 'ºC'),
	(224590, 120, '2014-03-01 00:19:47.000000', 'temperatura', 587.0000, 'ºC'),
	(224591, 120, '2014-03-01 00:19:48.000000', 'temperatura', 1096.0000, 'ºC'),
	(224592, 120, '2014-03-01 00:19:49.000000', 'temperatura', 119.0000, 'ºC'),
	(224593, 120, '2014-03-01 00:19:50.000000', 'temperatura', 910.0000, 'ºC'),
	(224594, 120, '2014-03-01 00:19:51.000000', 'temperatura', 591.0000, 'ºC'),
	(224595, 120, '2014-03-01 00:19:52.000000', 'temperatura', 226.0000, 'ºC'),
	(224596, 120, '2014-03-01 00:19:53.000000', 'temperatura', 556.0000, 'ºC'),
	(224597, 120, '2014-03-01 00:19:54.000000', 'temperatura', 906.0000, 'ºC'),
	(224598, 120, '2014-03-01 00:19:55.000000', 'temperatura', 460.0000, 'ºC'),
	(224599, 120, '2014-03-01 00:19:56.000000', 'temperatura', 784.0000, 'ºC'),
	(224600, 120, '2014-03-01 00:19:57.000000', 'temperatura', 140.0000, 'ºC'),
	(224601, 120, '2014-03-01 00:19:58.000000', 'temperatura', 749.0000, 'ºC'),
	(224602, 120, '2014-03-01 00:19:59.000000', 'temperatura', 923.0000, 'ºC'),
	(224603, 120, '2014-03-01 00:20:00.000000', 'temperatura', 1171.0000, 'ºC'),
	(224604, 120, '2014-03-01 00:20:01.000000', 'temperatura', 684.0000, 'ºC'),
	(224605, 120, '2014-03-01 00:20:02.000000', 'temperatura', 1109.0000, 'ºC'),
	(224606, 120, '2014-03-01 00:20:03.000000', 'temperatura', 1093.0000, 'ºC'),
	(224607, 120, '2014-03-01 00:20:04.000000', 'temperatura', 940.0000, 'ºC'),
	(224608, 120, '2014-03-01 00:20:05.000000', 'temperatura', 221.0000, 'ºC'),
	(224609, 120, '2014-03-01 00:20:06.000000', 'temperatura', 685.0000, 'ºC'),
	(224610, 120, '2014-03-01 00:20:07.000000', 'temperatura', 364.0000, 'ºC'),
	(224611, 120, '2014-03-01 00:20:08.000000', 'temperatura', 966.0000, 'ºC'),
	(224612, 120, '2014-03-01 00:20:09.000000', 'temperatura', 138.0000, 'ºC'),
	(224613, 120, '2014-03-01 00:20:10.000000', 'temperatura', 191.0000, 'ºC'),
	(224614, 120, '2014-03-01 00:20:11.000000', 'temperatura', 540.0000, 'ºC'),
	(224615, 120, '2014-03-01 00:20:12.000000', 'temperatura', 930.0000, 'ºC'),
	(224616, 120, '2014-03-01 00:20:13.000000', 'temperatura', 631.0000, 'ºC'),
	(224617, 120, '2014-03-01 00:20:14.000000', 'temperatura', 363.0000, 'ºC'),
	(224618, 120, '2014-03-01 00:20:15.000000', 'temperatura', 1123.0000, 'ºC'),
	(224619, 120, '2014-03-01 00:20:16.000000', 'temperatura', 925.0000, 'ºC'),
	(224620, 120, '2014-03-01 00:20:17.000000', 'temperatura', 57.0000, 'ºC'),
	(224621, 120, '2014-03-01 00:20:18.000000', 'temperatura', 1112.0000, 'ºC'),
	(224622, 120, '2014-03-01 00:20:19.000000', 'temperatura', 589.0000, 'ºC'),
	(224623, 120, '2014-03-01 00:20:20.000000', 'temperatura', 811.0000, 'ºC'),
	(224624, 120, '2014-03-01 00:20:21.000000', 'temperatura', 1087.0000, 'ºC'),
	(224625, 120, '2014-03-01 00:20:22.000000', 'temperatura', 603.0000, 'ºC'),
	(224626, 120, '2014-03-01 00:20:23.000000', 'temperatura', 955.0000, 'ºC'),
	(224627, 120, '2014-03-01 00:20:24.000000', 'temperatura', 566.0000, 'ºC'),
	(224628, 120, '2014-03-01 00:20:25.000000', 'temperatura', 1164.0000, 'ºC'),
	(224629, 120, '2014-03-01 00:20:26.000000', 'temperatura', 523.0000, 'ºC'),
	(224630, 120, '2014-03-01 00:20:27.000000', 'temperatura', 323.0000, 'ºC'),
	(224631, 120, '2014-03-01 00:20:28.000000', 'temperatura', 49.0000, 'ºC'),
	(224632, 120, '2014-03-01 00:20:29.000000', 'temperatura', 475.0000, 'ºC'),
	(224633, 120, '2014-03-01 00:20:30.000000', 'temperatura', 1029.0000, 'ºC'),
	(224634, 120, '2014-03-01 00:20:31.000000', 'temperatura', 121.0000, 'ºC'),
	(224635, 120, '2014-03-01 00:20:32.000000', 'temperatura', 1119.0000, 'ºC'),
	(224636, 120, '2014-03-01 00:20:33.000000', 'temperatura', 430.0000, 'ºC'),
	(224637, 120, '2014-03-01 00:20:34.000000', 'temperatura', 1193.0000, 'ºC'),
	(224638, 120, '2014-03-01 00:20:35.000000', 'temperatura', 1078.0000, 'ºC'),
	(224639, 120, '2014-03-01 00:20:36.000000', 'temperatura', 612.0000, 'ºC'),
	(224640, 120, '2014-03-01 00:20:37.000000', 'temperatura', 1024.0000, 'ºC'),
	(224641, 120, '2014-03-01 00:20:38.000000', 'temperatura', 887.0000, 'ºC'),
	(224642, 120, '2014-03-01 00:20:39.000000', 'temperatura', 164.0000, 'ºC'),
	(224643, 120, '2014-03-01 00:20:40.000000', 'temperatura', 559.0000, 'ºC'),
	(224644, 120, '2014-03-01 00:20:41.000000', 'temperatura', 1104.0000, 'ºC'),
	(224645, 120, '2014-03-01 00:20:42.000000', 'temperatura', 245.0000, 'ºC'),
	(224646, 120, '2014-03-01 00:20:43.000000', 'temperatura', 311.0000, 'ºC'),
	(224647, 120, '2014-03-01 00:20:44.000000', 'temperatura', 822.0000, 'ºC'),
	(224648, 120, '2014-03-01 00:20:45.000000', 'temperatura', 778.0000, 'ºC'),
	(224649, 120, '2014-03-01 00:20:46.000000', 'temperatura', 223.0000, 'ºC'),
	(224650, 120, '2014-03-01 00:20:47.000000', 'temperatura', 1183.0000, 'ºC'),
	(224651, 120, '2014-03-01 00:20:48.000000', 'temperatura', 447.0000, 'ºC'),
	(224652, 120, '2014-03-01 00:20:49.000000', 'temperatura', 1084.0000, 'ºC'),
	(224653, 120, '2014-03-01 00:20:50.000000', 'temperatura', 479.0000, 'ºC'),
	(224654, 120, '2014-03-01 00:20:51.000000', 'temperatura', 344.0000, 'ºC'),
	(224655, 120, '2014-03-01 00:20:52.000000', 'temperatura', 283.0000, 'ºC'),
	(224656, 120, '2014-03-01 00:20:53.000000', 'temperatura', 386.0000, 'ºC'),
	(224657, 120, '2014-03-01 00:20:54.000000', 'temperatura', 1079.0000, 'ºC'),
	(224658, 120, '2014-03-01 00:20:55.000000', 'temperatura', 638.0000, 'ºC'),
	(224659, 120, '2014-03-01 00:20:56.000000', 'temperatura', 1154.0000, 'ºC'),
	(224660, 120, '2014-03-01 00:20:57.000000', 'temperatura', 257.0000, 'ºC'),
	(224661, 120, '2014-03-01 00:20:58.000000', 'temperatura', 221.0000, 'ºC'),
	(224662, 120, '2014-03-01 00:20:59.000000', 'temperatura', 337.0000, 'ºC'),
	(224663, 120, '2014-03-01 00:21:00.000000', 'temperatura', 1022.0000, 'ºC'),
	(224664, 120, '2014-03-01 00:21:01.000000', 'temperatura', 499.0000, 'ºC'),
	(224665, 120, '2014-03-01 00:21:02.000000', 'temperatura', 632.0000, 'ºC'),
	(224666, 120, '2014-03-01 00:21:03.000000', 'temperatura', 461.0000, 'ºC'),
	(224667, 120, '2014-03-01 00:21:04.000000', 'temperatura', 411.0000, 'ºC'),
	(224668, 120, '2014-03-01 00:21:05.000000', 'temperatura', 673.0000, 'ºC'),
	(224669, 120, '2014-03-01 00:21:06.000000', 'temperatura', 930.0000, 'ºC'),
	(224670, 120, '2014-03-01 00:21:07.000000', 'temperatura', 231.0000, 'ºC'),
	(224671, 120, '2014-03-01 00:21:08.000000', 'temperatura', 767.0000, 'ºC'),
	(224672, 120, '2014-03-01 00:21:09.000000', 'temperatura', 744.0000, 'ºC'),
	(224673, 120, '2014-03-01 00:21:10.000000', 'temperatura', 218.0000, 'ºC'),
	(224674, 120, '2014-03-01 00:21:11.000000', 'temperatura', 58.0000, 'ºC'),
	(224675, 120, '2014-03-01 00:21:12.000000', 'temperatura', 836.0000, 'ºC'),
	(224676, 120, '2014-03-01 00:21:13.000000', 'temperatura', 408.0000, 'ºC'),
	(224677, 120, '2014-03-01 00:21:14.000000', 'temperatura', 734.0000, 'ºC'),
	(224678, 120, '2014-03-01 00:21:15.000000', 'temperatura', 44.0000, 'ºC'),
	(224679, 120, '2014-03-01 00:21:16.000000', 'temperatura', 418.0000, 'ºC'),
	(224680, 120, '2014-03-01 00:21:17.000000', 'temperatura', 760.0000, 'ºC'),
	(224681, 120, '2014-03-01 00:21:18.000000', 'temperatura', 144.0000, 'ºC'),
	(224682, 120, '2014-03-01 00:21:19.000000', 'temperatura', 842.0000, 'ºC'),
	(224683, 120, '2014-03-01 00:21:20.000000', 'temperatura', 179.0000, 'ºC'),
	(224684, 120, '2014-03-01 00:21:21.000000', 'temperatura', 769.0000, 'ºC'),
	(224685, 120, '2014-03-01 00:21:22.000000', 'temperatura', 911.0000, 'ºC'),
	(224686, 120, '2014-03-01 00:21:23.000000', 'temperatura', 1045.0000, 'ºC'),
	(224687, 120, '2014-03-01 00:21:24.000000', 'temperatura', 95.0000, 'ºC'),
	(224688, 120, '2014-03-01 00:21:25.000000', 'temperatura', 939.0000, 'ºC'),
	(224689, 120, '2014-03-01 00:21:26.000000', 'temperatura', 810.0000, 'ºC'),
	(224690, 120, '2014-03-01 00:21:27.000000', 'temperatura', 36.0000, 'ºC'),
	(224691, 120, '2014-03-01 00:21:28.000000', 'temperatura', 150.0000, 'ºC'),
	(224692, 120, '2014-03-01 00:21:29.000000', 'temperatura', 641.0000, 'ºC'),
	(224693, 120, '2014-03-01 00:21:30.000000', 'temperatura', 357.0000, 'ºC'),
	(224694, 120, '2014-03-01 00:21:31.000000', 'temperatura', 1062.0000, 'ºC'),
	(224695, 120, '2014-03-01 00:21:32.000000', 'temperatura', 641.0000, 'ºC'),
	(224696, 120, '2014-03-01 00:21:33.000000', 'temperatura', 19.0000, 'ºC'),
	(224697, 120, '2014-03-01 00:21:34.000000', 'temperatura', 570.0000, 'ºC'),
	(224698, 120, '2014-03-01 00:21:35.000000', 'temperatura', 397.0000, 'ºC'),
	(224699, 120, '2014-03-01 00:21:36.000000', 'temperatura', 274.0000, 'ºC'),
	(224700, 120, '2014-03-01 00:21:37.000000', 'temperatura', 180.0000, 'ºC'),
	(224701, 120, '2014-03-01 00:21:38.000000', 'temperatura', 79.0000, 'ºC'),
	(224702, 120, '2014-03-01 00:21:39.000000', 'temperatura', 1054.0000, 'ºC'),
	(224703, 120, '2014-03-01 00:21:40.000000', 'temperatura', 236.0000, 'ºC'),
	(224704, 120, '2014-03-01 00:21:41.000000', 'temperatura', 416.0000, 'ºC'),
	(224705, 120, '2014-03-01 00:21:42.000000', 'temperatura', 175.0000, 'ºC'),
	(224706, 120, '2014-03-01 00:21:43.000000', 'temperatura', 828.0000, 'ºC'),
	(224707, 120, '2014-03-01 00:21:44.000000', 'temperatura', 13.0000, 'ºC'),
	(224708, 120, '2014-03-01 00:21:45.000000', 'temperatura', 1182.0000, 'ºC'),
	(224709, 120, '2014-03-01 00:21:46.000000', 'temperatura', 1071.0000, 'ºC'),
	(224710, 120, '2014-03-01 00:21:47.000000', 'temperatura', 608.0000, 'ºC'),
	(224711, 120, '2014-03-01 00:21:48.000000', 'temperatura', 1030.0000, 'ºC'),
	(224712, 120, '2014-03-01 00:21:49.000000', 'temperatura', 926.0000, 'ºC'),
	(224713, 120, '2014-03-01 00:21:50.000000', 'temperatura', 341.0000, 'ºC'),
	(224714, 120, '2014-03-01 00:21:51.000000', 'temperatura', 125.0000, 'ºC'),
	(224715, 120, '2014-03-01 00:21:52.000000', 'temperatura', 805.0000, 'ºC'),
	(224716, 120, '2014-03-01 00:21:53.000000', 'temperatura', 50.0000, 'ºC'),
	(224717, 120, '2014-03-01 00:21:54.000000', 'temperatura', 234.0000, 'ºC'),
	(224718, 120, '2014-03-01 00:21:55.000000', 'temperatura', 1022.0000, 'ºC'),
	(224719, 120, '2014-03-01 00:21:56.000000', 'temperatura', 807.0000, 'ºC'),
	(224720, 120, '2014-03-01 00:21:57.000000', 'temperatura', 969.0000, 'ºC'),
	(224721, 120, '2014-03-01 00:21:58.000000', 'temperatura', 27.0000, 'ºC'),
	(224722, 120, '2014-03-01 00:21:59.000000', 'temperatura', 828.0000, 'ºC'),
	(224723, 120, '2014-03-01 00:22:00.000000', 'temperatura', 457.0000, 'ºC'),
	(224724, 120, '2014-03-01 00:22:01.000000', 'temperatura', 1004.0000, 'ºC'),
	(224725, 120, '2014-03-01 00:22:02.000000', 'temperatura', 51.0000, 'ºC'),
	(224726, 120, '2014-03-01 00:22:03.000000', 'temperatura', 841.0000, 'ºC'),
	(224727, 120, '2014-03-01 00:22:04.000000', 'temperatura', 454.0000, 'ºC'),
	(224728, 120, '2014-03-01 00:22:05.000000', 'temperatura', 948.0000, 'ºC'),
	(224729, 120, '2014-03-01 00:22:06.000000', 'temperatura', 977.0000, 'ºC'),
	(224730, 120, '2014-03-01 00:22:07.000000', 'temperatura', 842.0000, 'ºC'),
	(224731, 120, '2014-03-01 00:22:08.000000', 'temperatura', 78.0000, 'ºC'),
	(224732, 120, '2014-03-01 00:22:09.000000', 'temperatura', 265.0000, 'ºC'),
	(224733, 120, '2014-03-01 00:22:10.000000', 'temperatura', 1091.0000, 'ºC'),
	(224734, 120, '2014-03-01 00:22:11.000000', 'temperatura', 1061.0000, 'ºC'),
	(224735, 120, '2014-03-01 00:22:12.000000', 'temperatura', 832.0000, 'ºC'),
	(224736, 120, '2014-03-01 00:22:13.000000', 'temperatura', 979.0000, 'ºC'),
	(224737, 120, '2014-03-01 00:22:14.000000', 'temperatura', 1197.0000, 'ºC'),
	(224738, 120, '2014-03-01 00:22:15.000000', 'temperatura', 651.0000, 'ºC'),
	(224739, 120, '2014-03-01 00:22:16.000000', 'temperatura', 863.0000, 'ºC'),
	(224740, 120, '2014-03-01 00:22:17.000000', 'temperatura', 1162.0000, 'ºC'),
	(224741, 120, '2014-03-01 00:22:18.000000', 'temperatura', 823.0000, 'ºC'),
	(224742, 120, '2014-03-01 00:22:19.000000', 'temperatura', 628.0000, 'ºC'),
	(224743, 120, '2014-03-01 00:22:20.000000', 'temperatura', 671.0000, 'ºC'),
	(224744, 120, '2014-03-01 00:22:21.000000', 'temperatura', 273.0000, 'ºC'),
	(224745, 120, '2014-03-01 00:22:22.000000', 'temperatura', 554.0000, 'ºC'),
	(224746, 120, '2014-03-01 00:22:23.000000', 'temperatura', 750.0000, 'ºC'),
	(224747, 120, '2014-03-01 00:22:24.000000', 'temperatura', 887.0000, 'ºC'),
	(224748, 120, '2014-03-01 00:22:25.000000', 'temperatura', 986.0000, 'ºC'),
	(224749, 120, '2014-03-01 00:22:26.000000', 'temperatura', 1068.0000, 'ºC'),
	(224750, 120, '2014-03-01 00:22:27.000000', 'temperatura', 1186.0000, 'ºC'),
	(224751, 120, '2014-03-01 00:22:28.000000', 'temperatura', 325.0000, 'ºC'),
	(224752, 120, '2014-03-01 00:22:29.000000', 'temperatura', 467.0000, 'ºC'),
	(224753, 120, '2014-03-01 00:22:30.000000', 'temperatura', 159.0000, 'ºC'),
	(224754, 120, '2014-03-01 00:22:31.000000', 'temperatura', 595.0000, 'ºC'),
	(224755, 120, '2014-03-01 00:22:32.000000', 'temperatura', 98.0000, 'ºC'),
	(224756, 120, '2014-03-01 00:22:33.000000', 'temperatura', 1107.0000, 'ºC'),
	(224757, 120, '2014-03-01 00:22:34.000000', 'temperatura', 441.0000, 'ºC'),
	(224758, 120, '2014-03-01 00:22:35.000000', 'temperatura', 84.0000, 'ºC'),
	(224759, 120, '2014-03-01 00:22:36.000000', 'temperatura', 297.0000, 'ºC'),
	(224760, 120, '2014-03-01 00:22:37.000000', 'temperatura', 34.0000, 'ºC'),
	(224761, 120, '2014-03-01 00:22:38.000000', 'temperatura', 481.0000, 'ºC'),
	(224762, 120, '2014-03-01 00:22:39.000000', 'temperatura', 1101.0000, 'ºC'),
	(224763, 120, '2014-03-01 00:22:40.000000', 'temperatura', 465.0000, 'ºC'),
	(224764, 120, '2014-03-01 00:22:41.000000', 'temperatura', 220.0000, 'ºC'),
	(224765, 120, '2014-03-01 00:22:42.000000', 'temperatura', 907.0000, 'ºC'),
	(224766, 120, '2014-03-01 00:22:43.000000', 'temperatura', 275.0000, 'ºC'),
	(224767, 120, '2014-03-01 00:22:44.000000', 'temperatura', 1054.0000, 'ºC'),
	(224768, 120, '2014-03-01 00:22:45.000000', 'temperatura', 848.0000, 'ºC'),
	(224769, 120, '2014-03-01 00:22:46.000000', 'temperatura', 1075.0000, 'ºC'),
	(224770, 120, '2014-03-01 00:22:47.000000', 'temperatura', 434.0000, 'ºC'),
	(224771, 120, '2014-03-01 00:22:48.000000', 'temperatura', 144.0000, 'ºC'),
	(224772, 120, '2014-03-01 00:22:49.000000', 'temperatura', 619.0000, 'ºC'),
	(224773, 120, '2014-03-01 00:22:50.000000', 'temperatura', 263.0000, 'ºC'),
	(224774, 120, '2014-03-01 00:22:51.000000', 'temperatura', 660.0000, 'ºC'),
	(224775, 120, '2014-03-01 00:22:52.000000', 'temperatura', 109.0000, 'ºC'),
	(224776, 120, '2014-03-01 00:22:53.000000', 'temperatura', 965.0000, 'ºC'),
	(224777, 120, '2014-03-01 00:22:54.000000', 'temperatura', 899.0000, 'ºC'),
	(224778, 120, '2014-03-01 00:22:55.000000', 'temperatura', 403.0000, 'ºC'),
	(224779, 120, '2014-03-01 00:22:56.000000', 'temperatura', 515.0000, 'ºC'),
	(224780, 120, '2014-03-01 00:22:57.000000', 'temperatura', 169.0000, 'ºC'),
	(224781, 120, '2014-03-01 00:22:58.000000', 'temperatura', 500.0000, 'ºC'),
	(224782, 120, '2014-03-01 00:22:59.000000', 'temperatura', 792.0000, 'ºC'),
	(224783, 120, '2014-03-01 00:23:00.000000', 'temperatura', 60.0000, 'ºC'),
	(224784, 120, '2014-03-01 00:23:01.000000', 'temperatura', 327.0000, 'ºC'),
	(224785, 120, '2014-03-01 00:23:02.000000', 'temperatura', 253.0000, 'ºC'),
	(224786, 120, '2014-03-01 00:23:03.000000', 'temperatura', 283.0000, 'ºC'),
	(224787, 120, '2014-03-01 00:23:04.000000', 'temperatura', 660.0000, 'ºC'),
	(224788, 120, '2014-03-01 00:23:05.000000', 'temperatura', 51.0000, 'ºC'),
	(224789, 120, '2014-03-01 00:23:06.000000', 'temperatura', 676.0000, 'ºC'),
	(224790, 120, '2014-03-01 00:23:07.000000', 'temperatura', 828.0000, 'ºC'),
	(224791, 120, '2014-03-01 00:23:08.000000', 'temperatura', 912.0000, 'ºC'),
	(224792, 120, '2014-03-01 00:23:09.000000', 'temperatura', 875.0000, 'ºC'),
	(224793, 120, '2014-03-01 00:23:10.000000', 'temperatura', 439.0000, 'ºC'),
	(224794, 120, '2014-03-01 00:23:11.000000', 'temperatura', 772.0000, 'ºC'),
	(224795, 120, '2014-03-01 00:23:12.000000', 'temperatura', 144.0000, 'ºC'),
	(224796, 120, '2014-03-01 00:23:13.000000', 'temperatura', 803.0000, 'ºC'),
	(224797, 120, '2014-03-01 00:23:14.000000', 'temperatura', 1186.0000, 'ºC'),
	(224798, 120, '2014-03-01 00:23:15.000000', 'temperatura', 1121.0000, 'ºC'),
	(224799, 120, '2014-03-01 00:23:16.000000', 'temperatura', 845.0000, 'ºC'),
	(224800, 120, '2014-03-01 00:23:17.000000', 'temperatura', 866.0000, 'ºC'),
	(224801, 120, '2014-03-01 00:23:18.000000', 'temperatura', 593.0000, 'ºC'),
	(224802, 120, '2014-03-01 00:23:19.000000', 'temperatura', 366.0000, 'ºC'),
	(224803, 120, '2014-03-01 00:23:20.000000', 'temperatura', 54.0000, 'ºC'),
	(224804, 120, '2014-03-01 00:23:21.000000', 'temperatura', 371.0000, 'ºC'),
	(224805, 120, '2014-03-01 00:23:22.000000', 'temperatura', 494.0000, 'ºC'),
	(224806, 120, '2014-03-01 00:23:23.000000', 'temperatura', 155.0000, 'ºC'),
	(224807, 120, '2014-03-01 00:23:24.000000', 'temperatura', 497.0000, 'ºC'),
	(224808, 120, '2014-03-01 00:23:25.000000', 'temperatura', 821.0000, 'ºC'),
	(224809, 120, '2014-03-01 00:23:26.000000', 'temperatura', 212.0000, 'ºC'),
	(224810, 120, '2014-03-01 00:23:27.000000', 'temperatura', 997.0000, 'ºC'),
	(224811, 120, '2014-03-01 00:23:28.000000', 'temperatura', 750.0000, 'ºC'),
	(224812, 120, '2014-03-01 00:23:29.000000', 'temperatura', 760.0000, 'ºC'),
	(224813, 120, '2014-03-01 00:23:30.000000', 'temperatura', 352.0000, 'ºC'),
	(224814, 120, '2014-03-01 00:23:31.000000', 'temperatura', 680.0000, 'ºC'),
	(224815, 120, '2014-03-01 00:23:32.000000', 'temperatura', 1145.0000, 'ºC'),
	(224816, 120, '2014-03-01 00:23:33.000000', 'temperatura', 85.0000, 'ºC'),
	(224817, 120, '2014-03-01 00:23:34.000000', 'temperatura', 591.0000, 'ºC'),
	(224818, 120, '2014-03-01 00:23:35.000000', 'temperatura', 302.0000, 'ºC'),
	(224819, 120, '2014-03-01 00:23:36.000000', 'temperatura', 936.0000, 'ºC'),
	(224820, 120, '2014-03-01 00:23:37.000000', 'temperatura', 175.0000, 'ºC'),
	(224821, 120, '2014-03-01 00:23:38.000000', 'temperatura', 466.0000, 'ºC'),
	(224822, 120, '2014-03-01 00:23:39.000000', 'temperatura', 608.0000, 'ºC'),
	(224823, 120, '2014-03-01 00:23:40.000000', 'temperatura', 440.0000, 'ºC'),
	(224824, 120, '2014-03-01 00:23:41.000000', 'temperatura', 375.0000, 'ºC'),
	(224825, 120, '2014-03-01 00:23:42.000000', 'temperatura', 559.0000, 'ºC'),
	(224826, 120, '2014-03-01 00:23:43.000000', 'temperatura', 469.0000, 'ºC'),
	(224827, 120, '2014-03-01 00:23:44.000000', 'temperatura', 669.0000, 'ºC'),
	(224828, 120, '2014-03-01 00:23:45.000000', 'temperatura', 740.0000, 'ºC'),
	(224829, 120, '2014-03-01 00:23:46.000000', 'temperatura', 494.0000, 'ºC'),
	(224830, 120, '2014-03-01 00:23:47.000000', 'temperatura', 250.0000, 'ºC'),
	(224831, 120, '2014-03-01 00:23:48.000000', 'temperatura', 967.0000, 'ºC'),
	(224832, 120, '2014-03-01 00:23:49.000000', 'temperatura', 487.0000, 'ºC'),
	(224833, 120, '2014-03-01 00:23:50.000000', 'temperatura', 734.0000, 'ºC'),
	(224834, 120, '2014-03-01 00:23:51.000000', 'temperatura', 1009.0000, 'ºC'),
	(224835, 120, '2014-03-01 00:23:52.000000', 'temperatura', 443.0000, 'ºC'),
	(224836, 120, '2014-03-01 00:23:53.000000', 'temperatura', 389.0000, 'ºC'),
	(224837, 120, '2014-03-01 00:23:54.000000', 'temperatura', 617.0000, 'ºC'),
	(224838, 120, '2014-03-01 00:23:55.000000', 'temperatura', 719.0000, 'ºC'),
	(224839, 120, '2014-03-01 00:23:56.000000', 'temperatura', 544.0000, 'ºC'),
	(224840, 120, '2014-03-01 00:23:57.000000', 'temperatura', 565.0000, 'ºC'),
	(224841, 120, '2014-03-01 00:23:58.000000', 'temperatura', 1193.0000, 'ºC'),
	(224842, 120, '2014-03-01 00:23:59.000000', 'temperatura', 670.0000, 'ºC'),
	(224843, 120, '2014-03-01 00:24:00.000000', 'temperatura', 970.0000, 'ºC'),
	(224844, 120, '2014-03-01 00:24:01.000000', 'temperatura', 440.0000, 'ºC'),
	(224845, 120, '2014-03-01 00:24:02.000000', 'temperatura', 491.0000, 'ºC'),
	(224846, 120, '2014-03-01 00:24:03.000000', 'temperatura', 1137.0000, 'ºC'),
	(224847, 120, '2014-03-01 00:24:04.000000', 'temperatura', 613.0000, 'ºC'),
	(224848, 120, '2014-03-01 00:24:05.000000', 'temperatura', 855.0000, 'ºC'),
	(224849, 120, '2014-03-01 00:24:06.000000', 'temperatura', 34.0000, 'ºC'),
	(224850, 120, '2014-03-01 00:24:07.000000', 'temperatura', 5.0000, 'ºC'),
	(224851, 120, '2014-03-01 00:24:08.000000', 'temperatura', 1124.0000, 'ºC'),
	(224852, 120, '2014-03-01 00:24:09.000000', 'temperatura', 805.0000, 'ºC'),
	(224853, 120, '2014-03-01 00:24:10.000000', 'temperatura', 655.0000, 'ºC'),
	(224854, 120, '2014-03-01 00:24:11.000000', 'temperatura', 862.0000, 'ºC'),
	(224855, 120, '2014-03-01 00:24:12.000000', 'temperatura', 1143.0000, 'ºC'),
	(224856, 120, '2014-03-01 00:24:13.000000', 'temperatura', 732.0000, 'ºC'),
	(224857, 120, '2014-03-01 00:24:14.000000', 'temperatura', 228.0000, 'ºC'),
	(224858, 120, '2014-03-01 00:24:15.000000', 'temperatura', 148.0000, 'ºC'),
	(224859, 120, '2014-03-01 00:24:16.000000', 'temperatura', 54.0000, 'ºC'),
	(224860, 120, '2014-03-01 00:24:17.000000', 'temperatura', 1029.0000, 'ºC'),
	(224861, 120, '2014-03-01 00:24:18.000000', 'temperatura', 181.0000, 'ºC'),
	(224862, 120, '2014-03-01 00:24:19.000000', 'temperatura', 218.0000, 'ºC'),
	(224863, 120, '2014-03-01 00:24:20.000000', 'temperatura', 548.0000, 'ºC'),
	(224864, 120, '2014-03-01 00:24:21.000000', 'temperatura', 886.0000, 'ºC'),
	(224865, 120, '2014-03-01 00:24:22.000000', 'temperatura', 386.0000, 'ºC'),
	(224866, 120, '2014-03-01 00:24:23.000000', 'temperatura', 473.0000, 'ºC'),
	(224867, 120, '2014-03-01 00:24:24.000000', 'temperatura', 8.0000, 'ºC'),
	(224868, 120, '2014-03-01 00:24:25.000000', 'temperatura', 1020.0000, 'ºC'),
	(224869, 120, '2014-03-01 00:24:26.000000', 'temperatura', 277.0000, 'ºC'),
	(224870, 120, '2014-03-01 00:24:27.000000', 'temperatura', 725.0000, 'ºC'),
	(224871, 120, '2014-03-01 00:24:28.000000', 'temperatura', 397.0000, 'ºC'),
	(224872, 120, '2014-03-01 00:24:29.000000', 'temperatura', 1007.0000, 'ºC'),
	(224873, 120, '2014-03-01 00:24:30.000000', 'temperatura', 247.0000, 'ºC'),
	(224874, 120, '2014-03-01 00:24:31.000000', 'temperatura', 615.0000, 'ºC'),
	(224875, 120, '2014-03-01 00:24:32.000000', 'temperatura', 1134.0000, 'ºC'),
	(224876, 120, '2014-03-01 00:24:33.000000', 'temperatura', 224.0000, 'ºC'),
	(224877, 120, '2014-03-01 00:24:34.000000', 'temperatura', 121.0000, 'ºC'),
	(224878, 120, '2014-03-01 00:24:35.000000', 'temperatura', 1134.0000, 'ºC'),
	(224879, 120, '2014-03-01 00:24:36.000000', 'temperatura', 505.0000, 'ºC'),
	(224880, 120, '2014-03-01 00:24:37.000000', 'temperatura', 323.0000, 'ºC'),
	(224881, 120, '2014-03-01 00:24:38.000000', 'temperatura', 102.0000, 'ºC'),
	(224882, 120, '2014-03-01 00:24:39.000000', 'temperatura', 742.0000, 'ºC'),
	(224883, 120, '2014-03-01 00:24:40.000000', 'temperatura', 1005.0000, 'ºC'),
	(224884, 120, '2014-03-01 00:24:41.000000', 'temperatura', 401.0000, 'ºC'),
	(224885, 120, '2014-03-01 00:24:42.000000', 'temperatura', 188.0000, 'ºC'),
	(224886, 120, '2014-03-01 00:24:43.000000', 'temperatura', 938.0000, 'ºC'),
	(224887, 120, '2014-03-01 00:24:44.000000', 'temperatura', 527.0000, 'ºC'),
	(224888, 120, '2014-03-01 00:24:45.000000', 'temperatura', 1021.0000, 'ºC'),
	(224889, 120, '2014-03-01 00:24:46.000000', 'temperatura', 1124.0000, 'ºC'),
	(224890, 120, '2014-03-01 00:24:47.000000', 'temperatura', 157.0000, 'ºC'),
	(224891, 120, '2014-03-01 00:24:48.000000', 'temperatura', 1013.0000, 'ºC'),
	(224892, 120, '2014-03-01 00:24:49.000000', 'temperatura', 996.0000, 'ºC'),
	(224893, 120, '2014-03-01 00:24:50.000000', 'temperatura', 742.0000, 'ºC'),
	(224894, 120, '2014-03-01 00:24:51.000000', 'temperatura', 723.0000, 'ºC'),
	(224895, 120, '2014-03-01 00:24:52.000000', 'temperatura', 187.0000, 'ºC'),
	(224896, 120, '2014-03-01 00:24:53.000000', 'temperatura', 1167.0000, 'ºC'),
	(224897, 120, '2014-03-01 00:24:54.000000', 'temperatura', 476.0000, 'ºC'),
	(224898, 120, '2014-03-01 00:24:55.000000', 'temperatura', 77.0000, 'ºC'),
	(224899, 120, '2014-03-01 00:24:56.000000', 'temperatura', 157.0000, 'ºC'),
	(224900, 120, '2014-03-01 00:24:57.000000', 'temperatura', 557.0000, 'ºC'),
	(224901, 120, '2014-03-01 00:24:58.000000', 'temperatura', 1113.0000, 'ºC'),
	(224902, 120, '2014-03-01 00:24:59.000000', 'temperatura', 294.0000, 'ºC'),
	(224903, 120, '2014-03-01 00:25:00.000000', 'temperatura', 532.0000, 'ºC'),
	(224904, 120, '2014-03-01 00:25:01.000000', 'temperatura', 578.0000, 'ºC'),
	(224905, 120, '2014-03-01 00:25:02.000000', 'temperatura', 97.0000, 'ºC'),
	(224906, 120, '2014-03-01 00:25:03.000000', 'temperatura', 1150.0000, 'ºC'),
	(224907, 120, '2014-03-01 00:25:04.000000', 'temperatura', 658.0000, 'ºC'),
	(224908, 120, '2014-03-01 00:25:05.000000', 'temperatura', 1040.0000, 'ºC'),
	(224909, 120, '2014-03-01 00:25:06.000000', 'temperatura', 828.0000, 'ºC'),
	(224910, 120, '2014-03-01 00:25:07.000000', 'temperatura', 1019.0000, 'ºC'),
	(224911, 120, '2014-03-01 00:25:08.000000', 'temperatura', 211.0000, 'ºC'),
	(224912, 120, '2014-03-01 00:25:09.000000', 'temperatura', 398.0000, 'ºC'),
	(224913, 120, '2014-03-01 00:25:10.000000', 'temperatura', 159.0000, 'ºC'),
	(224914, 120, '2014-03-01 00:25:11.000000', 'temperatura', 800.0000, 'ºC'),
	(224915, 120, '2014-03-01 00:25:12.000000', 'temperatura', 1123.0000, 'ºC'),
	(224916, 120, '2014-03-01 00:25:13.000000', 'temperatura', 818.0000, 'ºC'),
	(224917, 120, '2014-03-01 00:25:14.000000', 'temperatura', 721.0000, 'ºC'),
	(224918, 120, '2014-03-01 00:25:15.000000', 'temperatura', 1150.0000, 'ºC'),
	(224919, 120, '2014-03-01 00:25:16.000000', 'temperatura', 1189.0000, 'ºC'),
	(224920, 120, '2014-03-01 00:25:17.000000', 'temperatura', 96.0000, 'ºC'),
	(224921, 120, '2014-03-01 00:25:18.000000', 'temperatura', 514.0000, 'ºC'),
	(224922, 120, '2014-03-01 00:25:19.000000', 'temperatura', 1083.0000, 'ºC'),
	(224923, 120, '2014-03-01 00:25:20.000000', 'temperatura', 271.0000, 'ºC'),
	(224924, 120, '2014-03-01 00:25:21.000000', 'temperatura', 508.0000, 'ºC'),
	(224925, 120, '2014-03-01 00:25:22.000000', 'temperatura', 527.0000, 'ºC'),
	(224926, 120, '2014-03-01 00:25:23.000000', 'temperatura', 1112.0000, 'ºC'),
	(224927, 120, '2014-03-01 00:25:24.000000', 'temperatura', 381.0000, 'ºC'),
	(224928, 120, '2014-03-01 00:25:25.000000', 'temperatura', 967.0000, 'ºC'),
	(224929, 120, '2014-03-01 00:25:26.000000', 'temperatura', 95.0000, 'ºC'),
	(224930, 120, '2014-03-01 00:25:27.000000', 'temperatura', 1175.0000, 'ºC'),
	(224931, 120, '2014-03-01 00:25:28.000000', 'temperatura', 789.0000, 'ºC'),
	(224932, 120, '2014-03-01 00:25:29.000000', 'temperatura', 422.0000, 'ºC'),
	(224933, 120, '2014-03-01 00:25:30.000000', 'temperatura', 944.0000, 'ºC'),
	(224934, 120, '2014-03-01 00:25:31.000000', 'temperatura', 1054.0000, 'ºC'),
	(224935, 120, '2014-03-01 00:25:32.000000', 'temperatura', 39.0000, 'ºC'),
	(224936, 120, '2014-03-01 00:25:33.000000', 'temperatura', 632.0000, 'ºC'),
	(224937, 120, '2014-03-01 00:25:34.000000', 'temperatura', 643.0000, 'ºC'),
	(224938, 120, '2014-03-01 00:25:35.000000', 'temperatura', 120.0000, 'ºC'),
	(224939, 120, '2014-03-01 00:25:36.000000', 'temperatura', 1070.0000, 'ºC'),
	(224940, 120, '2014-03-01 00:25:37.000000', 'temperatura', 192.0000, 'ºC'),
	(224941, 120, '2014-03-01 00:25:38.000000', 'temperatura', 150.0000, 'ºC'),
	(224942, 120, '2014-03-01 00:25:39.000000', 'temperatura', 174.0000, 'ºC'),
	(224943, 120, '2014-03-01 00:25:40.000000', 'temperatura', 420.0000, 'ºC'),
	(224944, 120, '2014-03-01 00:25:41.000000', 'temperatura', 379.0000, 'ºC'),
	(224945, 120, '2014-03-01 00:25:42.000000', 'temperatura', 634.0000, 'ºC'),
	(224946, 120, '2014-03-01 00:25:43.000000', 'temperatura', 834.0000, 'ºC'),
	(224947, 120, '2014-03-01 00:25:44.000000', 'temperatura', 1070.0000, 'ºC'),
	(224948, 120, '2014-03-01 00:25:45.000000', 'temperatura', 448.0000, 'ºC'),
	(224949, 120, '2014-03-01 00:25:46.000000', 'temperatura', 232.0000, 'ºC'),
	(224950, 120, '2014-03-01 00:25:47.000000', 'temperatura', 1014.0000, 'ºC'),
	(224951, 120, '2014-03-01 00:25:48.000000', 'temperatura', 775.0000, 'ºC'),
	(224952, 120, '2014-03-01 00:25:49.000000', 'temperatura', 832.0000, 'ºC'),
	(224953, 120, '2014-03-01 00:25:50.000000', 'temperatura', 637.0000, 'ºC'),
	(224954, 120, '2014-03-01 00:25:51.000000', 'temperatura', 691.0000, 'ºC'),
	(224955, 120, '2014-03-01 00:25:52.000000', 'temperatura', 342.0000, 'ºC'),
	(224956, 120, '2014-03-01 00:25:53.000000', 'temperatura', 839.0000, 'ºC'),
	(224957, 120, '2014-03-01 00:25:54.000000', 'temperatura', 770.0000, 'ºC'),
	(224958, 120, '2014-03-01 00:25:55.000000', 'temperatura', 132.0000, 'ºC'),
	(224959, 120, '2014-03-01 00:25:56.000000', 'temperatura', 749.0000, 'ºC'),
	(224960, 120, '2014-03-01 00:25:57.000000', 'temperatura', 952.0000, 'ºC'),
	(224961, 120, '2014-03-01 00:25:58.000000', 'temperatura', 113.0000, 'ºC'),
	(224962, 120, '2014-03-01 00:25:59.000000', 'temperatura', 108.0000, 'ºC'),
	(224963, 120, '2014-03-01 00:26:00.000000', 'temperatura', 201.0000, 'ºC'),
	(224964, 120, '2014-03-01 00:26:01.000000', 'temperatura', 684.0000, 'ºC'),
	(224965, 120, '2014-03-01 00:26:02.000000', 'temperatura', 418.0000, 'ºC'),
	(224966, 120, '2014-03-01 00:26:03.000000', 'temperatura', 37.0000, 'ºC'),
	(224967, 120, '2014-03-01 00:26:04.000000', 'temperatura', 132.0000, 'ºC'),
	(224968, 120, '2014-03-01 00:26:05.000000', 'temperatura', 549.0000, 'ºC'),
	(224969, 120, '2014-03-01 00:26:06.000000', 'temperatura', 1149.0000, 'ºC'),
	(224970, 120, '2014-03-01 00:26:07.000000', 'temperatura', 497.0000, 'ºC'),
	(224971, 120, '2014-03-01 00:26:08.000000', 'temperatura', 240.0000, 'ºC'),
	(224972, 120, '2014-03-01 00:26:09.000000', 'temperatura', 910.0000, 'ºC'),
	(224973, 120, '2014-03-01 00:26:10.000000', 'temperatura', 230.0000, 'ºC'),
	(224974, 120, '2014-03-01 00:26:11.000000', 'temperatura', 821.0000, 'ºC'),
	(224975, 120, '2014-03-01 00:26:12.000000', 'temperatura', 1013.0000, 'ºC'),
	(224976, 120, '2014-03-01 00:26:13.000000', 'temperatura', 205.0000, 'ºC'),
	(224977, 120, '2014-03-01 00:26:14.000000', 'temperatura', 388.0000, 'ºC'),
	(224978, 120, '2014-03-01 00:26:15.000000', 'temperatura', 123.0000, 'ºC'),
	(224979, 120, '2014-03-01 00:26:16.000000', 'temperatura', 652.0000, 'ºC'),
	(224980, 120, '2014-03-01 00:26:17.000000', 'temperatura', 490.0000, 'ºC'),
	(224981, 120, '2014-03-01 00:26:18.000000', 'temperatura', 495.0000, 'ºC'),
	(224982, 120, '2014-03-01 00:26:19.000000', 'temperatura', 1005.0000, 'ºC'),
	(224983, 120, '2014-03-01 00:26:20.000000', 'temperatura', 1141.0000, 'ºC'),
	(224984, 120, '2014-03-01 00:26:21.000000', 'temperatura', 291.0000, 'ºC'),
	(224985, 120, '2014-03-01 00:26:22.000000', 'temperatura', 430.0000, 'ºC'),
	(224986, 120, '2014-03-01 00:26:23.000000', 'temperatura', 80.0000, 'ºC'),
	(224987, 120, '2014-03-01 00:26:24.000000', 'temperatura', 309.0000, 'ºC'),
	(224988, 120, '2014-03-01 00:26:25.000000', 'temperatura', 106.0000, 'ºC'),
	(224989, 120, '2014-03-01 00:26:26.000000', 'temperatura', 802.0000, 'ºC'),
	(224990, 120, '2014-03-01 00:26:27.000000', 'temperatura', 92.0000, 'ºC'),
	(224991, 120, '2014-03-01 00:26:28.000000', 'temperatura', 455.0000, 'ºC'),
	(224992, 120, '2014-03-01 00:26:29.000000', 'temperatura', 801.0000, 'ºC'),
	(224993, 120, '2014-03-01 00:26:30.000000', 'temperatura', 241.0000, 'ºC'),
	(224994, 120, '2014-03-01 00:26:31.000000', 'temperatura', 3.0000, 'ºC'),
	(224995, 120, '2014-03-01 00:26:32.000000', 'temperatura', 492.0000, 'ºC'),
	(224996, 120, '2014-03-01 00:26:33.000000', 'temperatura', 51.0000, 'ºC'),
	(224997, 120, '2014-03-01 00:26:34.000000', 'temperatura', 1180.0000, 'ºC'),
	(224998, 120, '2014-03-01 00:26:35.000000', 'temperatura', 946.0000, 'ºC'),
	(224999, 120, '2014-03-01 00:26:36.000000', 'temperatura', 1190.0000, 'ºC'),
	(225000, 120, '2014-03-01 00:26:37.000000', 'temperatura', 712.0000, 'ºC'),
	(225001, 120, '2014-03-01 00:26:38.000000', 'temperatura', 1193.0000, 'ºC'),
	(225002, 120, '2014-03-01 00:26:39.000000', 'temperatura', 231.0000, 'ºC'),
	(225003, 120, '2014-03-01 00:26:40.000000', 'temperatura', 1173.0000, 'ºC'),
	(225004, 120, '2014-03-01 00:26:41.000000', 'temperatura', 373.0000, 'ºC'),
	(225005, 120, '2014-03-01 00:26:42.000000', 'temperatura', 746.0000, 'ºC'),
	(225006, 120, '2014-03-01 00:26:43.000000', 'temperatura', 211.0000, 'ºC'),
	(225007, 120, '2014-03-01 00:26:44.000000', 'temperatura', 16.0000, 'ºC'),
	(225008, 120, '2014-03-01 00:26:45.000000', 'temperatura', 651.0000, 'ºC'),
	(225009, 120, '2014-03-01 00:26:46.000000', 'temperatura', 807.0000, 'ºC'),
	(225010, 120, '2014-03-01 00:26:47.000000', 'temperatura', 882.0000, 'ºC'),
	(225011, 120, '2014-03-01 00:26:48.000000', 'temperatura', 789.0000, 'ºC'),
	(225012, 120, '2014-03-01 00:26:49.000000', 'temperatura', 98.0000, 'ºC'),
	(225013, 120, '2014-03-01 00:26:50.000000', 'temperatura', 524.0000, 'ºC'),
	(225014, 120, '2014-03-01 00:26:51.000000', 'temperatura', 1125.0000, 'ºC'),
	(225015, 120, '2014-03-01 00:26:52.000000', 'temperatura', 454.0000, 'ºC'),
	(225016, 120, '2014-03-01 00:26:53.000000', 'temperatura', 98.0000, 'ºC'),
	(225017, 120, '2014-03-01 00:26:54.000000', 'temperatura', 328.0000, 'ºC'),
	(225018, 120, '2014-03-01 00:26:55.000000', 'temperatura', 147.0000, 'ºC'),
	(225019, 120, '2014-03-01 00:26:56.000000', 'temperatura', 949.0000, 'ºC'),
	(225020, 120, '2014-03-01 00:26:57.000000', 'temperatura', 706.0000, 'ºC'),
	(225021, 120, '2014-03-01 00:26:58.000000', 'temperatura', 681.0000, 'ºC'),
	(225022, 120, '2014-03-01 00:26:59.000000', 'temperatura', 91.0000, 'ºC'),
	(225023, 120, '2014-03-01 00:27:00.000000', 'temperatura', 809.0000, 'ºC'),
	(225024, 120, '2014-03-01 00:27:01.000000', 'temperatura', 175.0000, 'ºC'),
	(225025, 120, '2014-03-01 00:27:02.000000', 'temperatura', 848.0000, 'ºC'),
	(225026, 120, '2014-03-01 00:27:03.000000', 'temperatura', 115.0000, 'ºC'),
	(225027, 120, '2014-03-01 00:27:04.000000', 'temperatura', 434.0000, 'ºC'),
	(225028, 120, '2014-03-01 00:27:05.000000', 'temperatura', 622.0000, 'ºC'),
	(225029, 120, '2014-03-01 00:27:06.000000', 'temperatura', 609.0000, 'ºC'),
	(225030, 120, '2014-03-01 00:27:07.000000', 'temperatura', 1182.0000, 'ºC'),
	(225031, 120, '2014-03-01 00:27:08.000000', 'temperatura', 483.0000, 'ºC'),
	(225032, 120, '2014-03-01 00:27:09.000000', 'temperatura', 67.0000, 'ºC'),
	(225033, 120, '2014-03-01 00:27:10.000000', 'temperatura', 88.0000, 'ºC'),
	(225034, 120, '2014-03-01 00:27:11.000000', 'temperatura', 241.0000, 'ºC'),
	(225035, 120, '2014-03-01 00:27:12.000000', 'temperatura', 939.0000, 'ºC'),
	(225036, 120, '2014-03-01 00:27:13.000000', 'temperatura', 374.0000, 'ºC'),
	(225037, 120, '2014-03-01 00:27:14.000000', 'temperatura', 252.0000, 'ºC'),
	(225038, 120, '2014-03-01 00:27:15.000000', 'temperatura', 139.0000, 'ºC'),
	(225039, 120, '2014-03-01 00:27:16.000000', 'temperatura', 1138.0000, 'ºC'),
	(225040, 120, '2014-03-01 00:27:17.000000', 'temperatura', 473.0000, 'ºC'),
	(225041, 120, '2014-03-01 00:27:18.000000', 'temperatura', 152.0000, 'ºC'),
	(225042, 120, '2014-03-01 00:27:19.000000', 'temperatura', 544.0000, 'ºC'),
	(225043, 120, '2014-03-01 00:27:20.000000', 'temperatura', 1063.0000, 'ºC'),
	(225044, 120, '2014-03-01 00:27:21.000000', 'temperatura', 85.0000, 'ºC'),
	(225045, 120, '2014-03-01 00:27:22.000000', 'temperatura', 833.0000, 'ºC'),
	(225046, 120, '2014-03-01 00:27:23.000000', 'temperatura', 314.0000, 'ºC'),
	(225047, 120, '2014-03-01 00:27:24.000000', 'temperatura', 272.0000, 'ºC'),
	(225048, 120, '2014-03-01 00:27:25.000000', 'temperatura', 416.0000, 'ºC'),
	(225049, 120, '2014-03-01 00:27:26.000000', 'temperatura', 64.0000, 'ºC'),
	(225050, 120, '2014-03-01 00:27:27.000000', 'temperatura', 272.0000, 'ºC'),
	(225051, 120, '2014-03-01 00:27:28.000000', 'temperatura', 1167.0000, 'ºC'),
	(225052, 120, '2014-03-01 00:27:29.000000', 'temperatura', 223.0000, 'ºC'),
	(225053, 120, '2014-03-01 00:27:30.000000', 'temperatura', 14.0000, 'ºC'),
	(225054, 120, '2014-03-01 00:27:31.000000', 'temperatura', 602.0000, 'ºC'),
	(225055, 120, '2014-03-01 00:27:32.000000', 'temperatura', 566.0000, 'ºC'),
	(225056, 120, '2014-03-01 00:27:33.000000', 'temperatura', 1027.0000, 'ºC'),
	(225057, 120, '2014-03-01 00:27:34.000000', 'temperatura', 1038.0000, 'ºC'),
	(225058, 120, '2014-03-01 00:27:35.000000', 'temperatura', 909.0000, 'ºC'),
	(225059, 120, '2014-03-01 00:27:36.000000', 'temperatura', 231.0000, 'ºC'),
	(225060, 120, '2014-03-01 00:27:37.000000', 'temperatura', 827.0000, 'ºC'),
	(225061, 120, '2014-03-01 00:27:38.000000', 'temperatura', 1042.0000, 'ºC'),
	(225062, 120, '2014-03-01 00:27:39.000000', 'temperatura', 329.0000, 'ºC'),
	(225063, 120, '2014-03-01 00:27:40.000000', 'temperatura', 922.0000, 'ºC'),
	(225064, 120, '2014-03-01 00:27:41.000000', 'temperatura', 21.0000, 'ºC'),
	(225065, 120, '2014-03-01 00:27:42.000000', 'temperatura', 943.0000, 'ºC'),
	(225066, 120, '2014-03-01 00:27:43.000000', 'temperatura', 1049.0000, 'ºC'),
	(225067, 120, '2014-03-01 00:27:44.000000', 'temperatura', 17.0000, 'ºC'),
	(225068, 120, '2014-03-01 00:27:45.000000', 'temperatura', 538.0000, 'ºC'),
	(225069, 120, '2014-03-01 00:27:46.000000', 'temperatura', 241.0000, 'ºC'),
	(225070, 120, '2014-03-01 00:27:47.000000', 'temperatura', 793.0000, 'ºC'),
	(225071, 120, '2014-03-01 00:27:48.000000', 'temperatura', 841.0000, 'ºC'),
	(225072, 120, '2014-03-01 00:27:49.000000', 'temperatura', 626.0000, 'ºC'),
	(225073, 120, '2014-03-01 00:27:50.000000', 'temperatura', 606.0000, 'ºC'),
	(225074, 120, '2014-03-01 00:27:51.000000', 'temperatura', 1155.0000, 'ºC'),
	(225075, 120, '2014-03-01 00:27:52.000000', 'temperatura', 355.0000, 'ºC'),
	(225076, 120, '2014-03-01 00:27:53.000000', 'temperatura', 710.0000, 'ºC'),
	(225077, 120, '2014-03-01 00:27:54.000000', 'temperatura', 85.0000, 'ºC'),
	(225078, 120, '2014-03-01 00:27:55.000000', 'temperatura', 697.0000, 'ºC'),
	(225079, 120, '2014-03-01 00:27:56.000000', 'temperatura', 829.0000, 'ºC'),
	(225080, 120, '2014-03-01 00:27:57.000000', 'temperatura', 854.0000, 'ºC'),
	(225081, 120, '2014-03-01 00:27:58.000000', 'temperatura', 583.0000, 'ºC'),
	(225082, 120, '2014-03-01 00:27:59.000000', 'temperatura', 354.0000, 'ºC'),
	(225083, 120, '2014-03-01 00:28:00.000000', 'temperatura', 20.0000, 'ºC'),
	(225084, 120, '2014-03-01 00:28:01.000000', 'temperatura', 241.0000, 'ºC'),
	(225085, 120, '2014-03-01 00:28:02.000000', 'temperatura', 1143.0000, 'ºC'),
	(225086, 120, '2014-03-01 00:28:03.000000', 'temperatura', 195.0000, 'ºC'),
	(225087, 120, '2014-03-01 00:28:04.000000', 'temperatura', 1147.0000, 'ºC'),
	(225088, 120, '2014-03-01 00:28:05.000000', 'temperatura', 350.0000, 'ºC'),
	(225089, 120, '2014-03-01 00:28:06.000000', 'temperatura', 710.0000, 'ºC'),
	(225090, 120, '2014-03-01 00:28:07.000000', 'temperatura', 99.0000, 'ºC'),
	(225091, 120, '2014-03-01 00:28:08.000000', 'temperatura', 764.0000, 'ºC'),
	(225092, 120, '2014-03-01 00:28:09.000000', 'temperatura', 1127.0000, 'ºC'),
	(225093, 120, '2014-03-01 00:28:10.000000', 'temperatura', 942.0000, 'ºC'),
	(225094, 120, '2014-03-01 00:28:11.000000', 'temperatura', 130.0000, 'ºC'),
	(225095, 120, '2014-03-01 00:28:12.000000', 'temperatura', 224.0000, 'ºC'),
	(225096, 120, '2014-03-01 00:28:13.000000', 'temperatura', 729.0000, 'ºC'),
	(225097, 120, '2014-03-01 00:28:14.000000', 'temperatura', 575.0000, 'ºC'),
	(225098, 120, '2014-03-01 00:28:15.000000', 'temperatura', 689.0000, 'ºC'),
	(225099, 120, '2014-03-01 00:28:16.000000', 'temperatura', 519.0000, 'ºC'),
	(225100, 120, '2014-03-01 00:28:17.000000', 'temperatura', 528.0000, 'ºC'),
	(225101, 120, '2014-03-01 00:28:18.000000', 'temperatura', 1082.0000, 'ºC'),
	(225102, 120, '2014-03-01 00:28:19.000000', 'temperatura', 229.0000, 'ºC'),
	(225103, 120, '2014-03-01 00:28:20.000000', 'temperatura', 299.0000, 'ºC'),
	(225104, 120, '2014-03-01 00:28:21.000000', 'temperatura', 807.0000, 'ºC'),
	(225105, 120, '2014-03-01 00:28:22.000000', 'temperatura', 741.0000, 'ºC'),
	(225106, 120, '2014-03-01 00:28:23.000000', 'temperatura', 83.0000, 'ºC'),
	(225107, 120, '2014-03-01 00:28:24.000000', 'temperatura', 593.0000, 'ºC'),
	(225108, 120, '2014-03-01 00:28:25.000000', 'temperatura', 315.0000, 'ºC'),
	(225109, 120, '2014-03-01 00:28:26.000000', 'temperatura', 998.0000, 'ºC'),
	(225110, 120, '2014-03-01 00:28:27.000000', 'temperatura', 443.0000, 'ºC'),
	(225111, 120, '2014-03-01 00:28:28.000000', 'temperatura', 424.0000, 'ºC'),
	(225112, 120, '2014-03-01 00:28:29.000000', 'temperatura', 791.0000, 'ºC'),
	(225113, 120, '2014-03-01 00:28:30.000000', 'temperatura', 284.0000, 'ºC'),
	(225114, 120, '2014-03-01 00:28:31.000000', 'temperatura', 248.0000, 'ºC'),
	(225115, 120, '2014-03-01 00:28:32.000000', 'temperatura', 387.0000, 'ºC'),
	(225116, 120, '2014-03-01 00:28:33.000000', 'temperatura', 1191.0000, 'ºC'),
	(225117, 120, '2014-03-01 00:28:34.000000', 'temperatura', 1195.0000, 'ºC'),
	(225118, 120, '2014-03-01 00:28:35.000000', 'temperatura', 1.0000, 'ºC'),
	(225119, 120, '2014-03-01 00:28:36.000000', 'temperatura', 20.0000, 'ºC'),
	(225120, 120, '2014-03-01 00:28:37.000000', 'temperatura', 100.0000, 'ºC'),
	(225121, 120, '2014-03-01 00:28:38.000000', 'temperatura', 439.0000, 'ºC'),
	(225122, 120, '2014-03-01 00:28:39.000000', 'temperatura', 696.0000, 'ºC'),
	(225123, 120, '2014-03-01 00:28:40.000000', 'temperatura', 962.0000, 'ºC'),
	(225124, 120, '2014-03-01 00:28:41.000000', 'temperatura', 325.0000, 'ºC'),
	(225125, 120, '2014-03-01 00:28:42.000000', 'temperatura', 1137.0000, 'ºC'),
	(225126, 120, '2014-03-01 00:28:43.000000', 'temperatura', 1111.0000, 'ºC'),
	(225127, 120, '2014-03-01 00:28:44.000000', 'temperatura', 944.0000, 'ºC'),
	(225128, 120, '2014-03-01 00:28:45.000000', 'temperatura', 187.0000, 'ºC'),
	(225129, 120, '2014-03-01 00:28:46.000000', 'temperatura', 506.0000, 'ºC'),
	(225130, 120, '2014-03-01 00:28:47.000000', 'temperatura', 767.0000, 'ºC'),
	(225131, 120, '2014-03-01 00:28:48.000000', 'temperatura', 1117.0000, 'ºC'),
	(225132, 120, '2014-03-01 00:28:49.000000', 'temperatura', 886.0000, 'ºC'),
	(225133, 120, '2014-03-01 00:28:50.000000', 'temperatura', 1080.0000, 'ºC'),
	(225134, 120, '2014-03-01 00:28:51.000000', 'temperatura', 344.0000, 'ºC'),
	(225135, 120, '2014-03-01 00:28:52.000000', 'temperatura', 879.0000, 'ºC'),
	(225136, 120, '2014-03-01 00:28:53.000000', 'temperatura', 962.0000, 'ºC'),
	(225137, 120, '2014-03-01 00:28:54.000000', 'temperatura', 975.0000, 'ºC'),
	(225138, 120, '2014-03-01 00:28:55.000000', 'temperatura', 788.0000, 'ºC'),
	(225139, 120, '2014-03-01 00:28:56.000000', 'temperatura', 1016.0000, 'ºC'),
	(225140, 120, '2014-03-01 00:28:57.000000', 'temperatura', 316.0000, 'ºC'),
	(225141, 120, '2014-03-01 00:28:58.000000', 'temperatura', 934.0000, 'ºC'),
	(225142, 120, '2014-03-01 00:28:59.000000', 'temperatura', 124.0000, 'ºC'),
	(225143, 120, '2014-03-01 00:29:00.000000', 'temperatura', 216.0000, 'ºC'),
	(225144, 120, '2014-03-01 00:29:01.000000', 'temperatura', 707.0000, 'ºC'),
	(225145, 120, '2014-03-01 00:29:02.000000', 'temperatura', 490.0000, 'ºC'),
	(225146, 120, '2014-03-01 00:29:03.000000', 'temperatura', 328.0000, 'ºC'),
	(225147, 120, '2014-03-01 00:29:04.000000', 'temperatura', 172.0000, 'ºC'),
	(225148, 120, '2014-03-01 00:29:05.000000', 'temperatura', 1075.0000, 'ºC'),
	(225149, 120, '2014-03-01 00:29:06.000000', 'temperatura', 60.0000, 'ºC'),
	(225150, 120, '2014-03-01 00:29:07.000000', 'temperatura', 675.0000, 'ºC'),
	(225151, 120, '2014-03-01 00:29:08.000000', 'temperatura', 795.0000, 'ºC'),
	(225152, 120, '2014-03-01 00:29:09.000000', 'temperatura', 750.0000, 'ºC'),
	(225153, 120, '2014-03-01 00:29:10.000000', 'temperatura', 167.0000, 'ºC'),
	(225154, 120, '2014-03-01 00:29:11.000000', 'temperatura', 986.0000, 'ºC'),
	(225155, 120, '2014-03-01 00:29:12.000000', 'temperatura', 827.0000, 'ºC'),
	(225156, 120, '2014-03-01 00:29:13.000000', 'temperatura', 1179.0000, 'ºC'),
	(225157, 120, '2014-03-01 00:29:14.000000', 'temperatura', 1014.0000, 'ºC'),
	(225158, 120, '2014-03-01 00:29:15.000000', 'temperatura', 336.0000, 'ºC'),
	(225159, 120, '2014-03-01 00:29:16.000000', 'temperatura', 1035.0000, 'ºC'),
	(225160, 120, '2014-03-01 00:29:17.000000', 'temperatura', 569.0000, 'ºC'),
	(225161, 120, '2014-03-01 00:29:18.000000', 'temperatura', 939.0000, 'ºC'),
	(225162, 120, '2014-03-01 00:29:19.000000', 'temperatura', 590.0000, 'ºC'),
	(225163, 120, '2014-03-01 00:29:20.000000', 'temperatura', 133.0000, 'ºC'),
	(225164, 120, '2014-03-01 00:29:21.000000', 'temperatura', 94.0000, 'ºC'),
	(225165, 120, '2014-03-01 00:29:22.000000', 'temperatura', 72.0000, 'ºC'),
	(225166, 120, '2014-03-01 00:29:23.000000', 'temperatura', 81.0000, 'ºC'),
	(225167, 120, '2014-03-01 00:29:24.000000', 'temperatura', 187.0000, 'ºC'),
	(225168, 120, '2014-03-01 00:29:25.000000', 'temperatura', 694.0000, 'ºC'),
	(225169, 120, '2014-03-01 00:29:26.000000', 'temperatura', 511.0000, 'ºC'),
	(225170, 120, '2014-03-01 00:29:27.000000', 'temperatura', 470.0000, 'ºC'),
	(225171, 120, '2014-03-01 00:29:28.000000', 'temperatura', 819.0000, 'ºC'),
	(225172, 120, '2014-03-01 00:29:29.000000', 'temperatura', 284.0000, 'ºC'),
	(225173, 120, '2014-03-01 00:29:30.000000', 'temperatura', 166.0000, 'ºC'),
	(225174, 120, '2014-03-01 00:29:31.000000', 'temperatura', 1176.0000, 'ºC'),
	(225175, 120, '2014-03-01 00:29:32.000000', 'temperatura', 586.0000, 'ºC'),
	(225176, 120, '2014-03-01 00:29:33.000000', 'temperatura', 599.0000, 'ºC'),
	(225177, 120, '2014-03-01 00:29:34.000000', 'temperatura', 37.0000, 'ºC'),
	(225178, 120, '2014-03-01 00:29:35.000000', 'temperatura', 791.0000, 'ºC'),
	(225179, 120, '2014-03-01 00:29:36.000000', 'temperatura', 243.0000, 'ºC'),
	(225180, 120, '2014-03-01 00:29:37.000000', 'temperatura', 42.0000, 'ºC'),
	(225181, 120, '2014-03-01 00:29:38.000000', 'temperatura', 680.0000, 'ºC'),
	(225182, 120, '2014-03-01 00:29:39.000000', 'temperatura', 877.0000, 'ºC'),
	(225183, 120, '2014-03-01 00:29:40.000000', 'temperatura', 1145.0000, 'ºC'),
	(225184, 120, '2014-03-01 00:29:41.000000', 'temperatura', 696.0000, 'ºC'),
	(225185, 120, '2014-03-01 00:29:42.000000', 'temperatura', 44.0000, 'ºC'),
	(225186, 120, '2014-03-01 00:29:43.000000', 'temperatura', 532.0000, 'ºC'),
	(225187, 120, '2014-03-01 00:29:44.000000', 'temperatura', 127.0000, 'ºC'),
	(225188, 120, '2014-03-01 00:29:45.000000', 'temperatura', 243.0000, 'ºC'),
	(225189, 120, '2014-03-01 00:29:46.000000', 'temperatura', 831.0000, 'ºC'),
	(225190, 120, '2014-03-01 00:29:47.000000', 'temperatura', 1028.0000, 'ºC'),
	(225191, 120, '2014-03-01 00:29:48.000000', 'temperatura', 248.0000, 'ºC'),
	(225192, 120, '2014-03-01 00:29:49.000000', 'temperatura', 555.0000, 'ºC'),
	(225193, 120, '2014-03-01 00:29:50.000000', 'temperatura', 831.0000, 'ºC'),
	(225194, 120, '2014-03-01 00:29:51.000000', 'temperatura', 90.0000, 'ºC'),
	(225195, 120, '2014-03-01 00:29:52.000000', 'temperatura', 359.0000, 'ºC'),
	(225196, 120, '2014-03-01 00:29:53.000000', 'temperatura', 326.0000, 'ºC'),
	(225197, 120, '2014-03-01 00:29:54.000000', 'temperatura', 551.0000, 'ºC'),
	(225198, 120, '2014-03-01 00:29:55.000000', 'temperatura', 579.0000, 'ºC'),
	(225199, 120, '2014-03-01 00:29:56.000000', 'temperatura', 44.0000, 'ºC'),
	(225200, 120, '2014-03-01 00:29:57.000000', 'temperatura', 881.0000, 'ºC'),
	(225201, 120, '2014-03-01 00:29:58.000000', 'temperatura', 675.0000, 'ºC'),
	(225202, 120, '2014-03-01 00:29:59.000000', 'temperatura', 731.0000, 'ºC'),
	(225203, 120, '2014-03-01 00:30:00.000000', 'temperatura', 429.0000, 'ºC'),
	(225204, 120, '2014-03-01 00:30:01.000000', 'temperatura', 1156.0000, 'ºC'),
	(225205, 120, '2014-03-01 00:30:02.000000', 'temperatura', 893.0000, 'ºC'),
	(225206, 120, '2014-03-01 00:30:03.000000', 'temperatura', 997.0000, 'ºC'),
	(225207, 120, '2014-03-01 00:30:04.000000', 'temperatura', 1108.0000, 'ºC'),
	(225208, 120, '2014-03-01 00:30:05.000000', 'temperatura', 148.0000, 'ºC'),
	(225209, 120, '2014-03-01 00:30:06.000000', 'temperatura', 1015.0000, 'ºC'),
	(225210, 120, '2014-03-01 00:30:07.000000', 'temperatura', 1033.0000, 'ºC'),
	(225211, 120, '2014-03-01 00:30:08.000000', 'temperatura', 919.0000, 'ºC'),
	(225212, 120, '2014-03-01 00:30:09.000000', 'temperatura', 299.0000, 'ºC'),
	(225213, 120, '2014-03-01 00:30:10.000000', 'temperatura', 1136.0000, 'ºC'),
	(225214, 120, '2014-03-01 00:30:11.000000', 'temperatura', 1186.0000, 'ºC'),
	(225215, 120, '2014-03-01 00:30:12.000000', 'temperatura', 120.0000, 'ºC'),
	(225216, 120, '2014-03-01 00:30:13.000000', 'temperatura', 642.0000, 'ºC'),
	(225217, 120, '2014-03-01 00:30:14.000000', 'temperatura', 453.0000, 'ºC'),
	(225218, 120, '2014-03-01 00:30:15.000000', 'temperatura', 339.0000, 'ºC'),
	(225219, 120, '2014-03-01 00:30:16.000000', 'temperatura', 335.0000, 'ºC'),
	(225220, 120, '2014-03-01 00:30:17.000000', 'temperatura', 661.0000, 'ºC'),
	(225221, 120, '2014-03-01 00:30:18.000000', 'temperatura', 1101.0000, 'ºC'),
	(225222, 120, '2014-03-01 00:30:19.000000', 'temperatura', 1122.0000, 'ºC'),
	(225223, 120, '2014-03-01 00:30:20.000000', 'temperatura', 1108.0000, 'ºC'),
	(225224, 120, '2014-03-01 00:30:21.000000', 'temperatura', 976.0000, 'ºC'),
	(225225, 120, '2014-03-01 00:30:22.000000', 'temperatura', 353.0000, 'ºC'),
	(225226, 120, '2014-03-01 00:30:23.000000', 'temperatura', 40.0000, 'ºC'),
	(225227, 120, '2014-03-01 00:30:24.000000', 'temperatura', 341.0000, 'ºC'),
	(225228, 120, '2014-03-01 00:30:25.000000', 'temperatura', 385.0000, 'ºC'),
	(225229, 120, '2014-03-01 00:30:26.000000', 'temperatura', 902.0000, 'ºC'),
	(225230, 120, '2014-03-01 00:30:27.000000', 'temperatura', 957.0000, 'ºC'),
	(225231, 120, '2014-03-01 00:30:28.000000', 'temperatura', 878.0000, 'ºC'),
	(225232, 120, '2014-03-01 00:30:29.000000', 'temperatura', 321.0000, 'ºC'),
	(225233, 120, '2014-03-01 00:30:30.000000', 'temperatura', 172.0000, 'ºC'),
	(225234, 120, '2014-03-01 00:30:31.000000', 'temperatura', 1097.0000, 'ºC'),
	(225235, 120, '2014-03-01 00:30:32.000000', 'temperatura', 170.0000, 'ºC'),
	(225236, 120, '2014-03-01 00:30:33.000000', 'temperatura', 1158.0000, 'ºC'),
	(225237, 120, '2014-03-01 00:30:34.000000', 'temperatura', 480.0000, 'ºC'),
	(225238, 120, '2014-03-01 00:30:35.000000', 'temperatura', 127.0000, 'ºC'),
	(225239, 120, '2014-03-01 00:30:36.000000', 'temperatura', 396.0000, 'ºC'),
	(225240, 120, '2014-03-01 00:30:37.000000', 'temperatura', 400.0000, 'ºC'),
	(225241, 120, '2014-03-01 00:30:38.000000', 'temperatura', 814.0000, 'ºC'),
	(225242, 120, '2014-03-01 00:30:39.000000', 'temperatura', 467.0000, 'ºC'),
	(225243, 120, '2014-03-01 00:30:40.000000', 'temperatura', 1097.0000, 'ºC'),
	(225244, 120, '2014-03-01 00:30:41.000000', 'temperatura', 483.0000, 'ºC'),
	(225245, 120, '2014-03-01 00:30:42.000000', 'temperatura', 324.0000, 'ºC'),
	(225246, 120, '2014-03-01 00:30:43.000000', 'temperatura', 172.0000, 'ºC'),
	(225247, 120, '2014-03-01 00:30:44.000000', 'temperatura', 1088.0000, 'ºC'),
	(225248, 120, '2014-03-01 00:30:45.000000', 'temperatura', 123.0000, 'ºC'),
	(225249, 120, '2014-03-01 00:30:46.000000', 'temperatura', 951.0000, 'ºC'),
	(225250, 120, '2014-03-01 00:30:47.000000', 'temperatura', 789.0000, 'ºC'),
	(225251, 120, '2014-03-01 00:30:48.000000', 'temperatura', 1093.0000, 'ºC'),
	(225252, 120, '2014-03-01 00:30:49.000000', 'temperatura', 697.0000, 'ºC'),
	(225253, 120, '2014-03-01 00:30:50.000000', 'temperatura', 205.0000, 'ºC'),
	(225254, 120, '2014-03-01 00:30:51.000000', 'temperatura', 135.0000, 'ºC'),
	(225255, 120, '2014-03-01 00:30:52.000000', 'temperatura', 62.0000, 'ºC'),
	(225256, 120, '2014-03-01 00:30:53.000000', 'temperatura', 1106.0000, 'ºC'),
	(225257, 120, '2014-03-01 00:30:54.000000', 'temperatura', 542.0000, 'ºC'),
	(225258, 120, '2014-03-01 00:30:55.000000', 'temperatura', 595.0000, 'ºC'),
	(225259, 120, '2014-03-01 00:30:56.000000', 'temperatura', 149.0000, 'ºC'),
	(225260, 120, '2014-03-01 00:30:57.000000', 'temperatura', 159.0000, 'ºC'),
	(225261, 120, '2014-03-01 00:30:58.000000', 'temperatura', 351.0000, 'ºC'),
	(225262, 120, '2014-03-01 00:30:59.000000', 'temperatura', 77.0000, 'ºC'),
	(225263, 120, '2014-03-01 00:31:00.000000', 'temperatura', 531.0000, 'ºC'),
	(225264, 120, '2014-03-01 00:31:01.000000', 'temperatura', 25.0000, 'ºC'),
	(225265, 120, '2014-03-01 00:31:02.000000', 'temperatura', 934.0000, 'ºC'),
	(225266, 120, '2014-03-01 00:31:03.000000', 'temperatura', 995.0000, 'ºC'),
	(225267, 120, '2014-03-01 00:31:04.000000', 'temperatura', 974.0000, 'ºC'),
	(225268, 120, '2014-03-01 00:31:05.000000', 'temperatura', 684.0000, 'ºC'),
	(225269, 120, '2014-03-01 00:31:06.000000', 'temperatura', 498.0000, 'ºC'),
	(225270, 120, '2014-03-01 00:31:07.000000', 'temperatura', 441.0000, 'ºC'),
	(225271, 120, '2014-03-01 00:31:08.000000', 'temperatura', 711.0000, 'ºC'),
	(225272, 120, '2014-03-01 00:31:09.000000', 'temperatura', 1032.0000, 'ºC'),
	(225273, 120, '2014-03-01 00:31:10.000000', 'temperatura', 628.0000, 'ºC'),
	(225274, 120, '2014-03-01 00:31:11.000000', 'temperatura', 44.0000, 'ºC'),
	(225275, 120, '2014-03-01 00:31:12.000000', 'temperatura', 735.0000, 'ºC'),
	(225276, 120, '2014-03-01 00:31:13.000000', 'temperatura', 1144.0000, 'ºC'),
	(225277, 120, '2014-03-01 00:31:14.000000', 'temperatura', 1117.0000, 'ºC'),
	(225278, 120, '2014-03-01 00:31:15.000000', 'temperatura', 954.0000, 'ºC'),
	(225279, 120, '2014-03-01 00:31:16.000000', 'temperatura', 218.0000, 'ºC'),
	(225280, 120, '2014-03-01 00:31:17.000000', 'temperatura', 629.0000, 'ºC'),
	(225281, 120, '2014-03-01 00:31:18.000000', 'temperatura', 92.0000, 'ºC'),
	(225282, 120, '2014-03-01 00:31:19.000000', 'temperatura', 973.0000, 'ºC'),
	(225283, 120, '2014-03-01 00:31:20.000000', 'temperatura', 991.0000, 'ºC'),
	(225284, 120, '2014-03-01 00:31:21.000000', 'temperatura', 837.0000, 'ºC'),
	(225285, 120, '2014-03-01 00:31:22.000000', 'temperatura', 11.0000, 'ºC'),
	(225286, 120, '2014-03-01 00:31:23.000000', 'temperatura', 1145.0000, 'ºC'),
	(225287, 120, '2014-03-01 00:31:24.000000', 'temperatura', 891.0000, 'ºC'),
	(225288, 120, '2014-03-01 00:31:25.000000', 'temperatura', 1023.0000, 'ºC'),
	(225289, 120, '2014-03-01 00:31:26.000000', 'temperatura', 42.0000, 'ºC'),
	(225290, 120, '2014-03-01 00:31:27.000000', 'temperatura', 742.0000, 'ºC'),
	(225291, 120, '2014-03-01 00:31:28.000000', 'temperatura', 1186.0000, 'ºC'),
	(225292, 120, '2014-03-01 00:31:29.000000', 'temperatura', 103.0000, 'ºC'),
	(225293, 120, '2014-03-01 00:31:30.000000', 'temperatura', 557.0000, 'ºC'),
	(225294, 120, '2014-03-01 00:31:31.000000', 'temperatura', 79.0000, 'ºC'),
	(225295, 120, '2014-03-01 00:31:32.000000', 'temperatura', 1123.0000, 'ºC'),
	(225296, 120, '2014-03-01 00:31:33.000000', 'temperatura', 578.0000, 'ºC'),
	(225297, 120, '2014-03-01 00:31:34.000000', 'temperatura', 722.0000, 'ºC'),
	(225298, 120, '2014-03-01 00:31:35.000000', 'temperatura', 677.0000, 'ºC'),
	(225299, 120, '2014-03-01 00:31:36.000000', 'temperatura', 19.0000, 'ºC'),
	(225300, 120, '2014-03-01 00:31:37.000000', 'temperatura', 464.0000, 'ºC'),
	(225301, 120, '2014-03-01 00:31:38.000000', 'temperatura', 1065.0000, 'ºC'),
	(225302, 120, '2014-03-01 00:31:39.000000', 'temperatura', 332.0000, 'ºC'),
	(225303, 120, '2014-03-01 00:31:40.000000', 'temperatura', 867.0000, 'ºC'),
	(225304, 120, '2014-03-01 00:31:41.000000', 'temperatura', 940.0000, 'ºC'),
	(225305, 120, '2014-03-01 00:31:42.000000', 'temperatura', 898.0000, 'ºC'),
	(225306, 120, '2014-03-01 00:31:43.000000', 'temperatura', 470.0000, 'ºC'),
	(225307, 120, '2014-03-01 00:31:44.000000', 'temperatura', 858.0000, 'ºC'),
	(225308, 120, '2014-03-01 00:31:45.000000', 'temperatura', 482.0000, 'ºC'),
	(225309, 120, '2014-03-01 00:31:46.000000', 'temperatura', 1034.0000, 'ºC'),
	(225310, 120, '2014-03-01 00:31:47.000000', 'temperatura', 125.0000, 'ºC'),
	(225311, 120, '2014-03-01 00:31:48.000000', 'temperatura', 1125.0000, 'ºC'),
	(225312, 120, '2014-03-01 00:31:49.000000', 'temperatura', 449.0000, 'ºC'),
	(225313, 120, '2014-03-01 00:31:50.000000', 'temperatura', 70.0000, 'ºC'),
	(225314, 120, '2014-03-01 00:31:51.000000', 'temperatura', 202.0000, 'ºC'),
	(225315, 120, '2014-03-01 00:31:52.000000', 'temperatura', 803.0000, 'ºC'),
	(225316, 120, '2014-03-01 00:31:53.000000', 'temperatura', 1010.0000, 'ºC'),
	(225317, 120, '2014-03-01 00:31:54.000000', 'temperatura', 242.0000, 'ºC'),
	(225318, 120, '2014-03-01 00:31:55.000000', 'temperatura', 579.0000, 'ºC'),
	(225319, 120, '2014-03-01 00:31:56.000000', 'temperatura', 971.0000, 'ºC'),
	(225320, 120, '2014-03-01 00:31:57.000000', 'temperatura', 719.0000, 'ºC'),
	(225321, 120, '2014-03-01 00:31:58.000000', 'temperatura', 683.0000, 'ºC'),
	(225322, 120, '2014-03-01 00:31:59.000000', 'temperatura', 59.0000, 'ºC'),
	(225323, 120, '2014-03-01 00:32:00.000000', 'temperatura', 644.0000, 'ºC'),
	(225324, 120, '2014-03-01 00:32:01.000000', 'temperatura', 644.0000, 'ºC'),
	(225325, 120, '2014-03-01 00:32:02.000000', 'temperatura', 89.0000, 'ºC'),
	(225326, 120, '2014-03-01 00:32:03.000000', 'temperatura', 915.0000, 'ºC'),
	(225327, 120, '2014-03-01 00:32:04.000000', 'temperatura', 707.0000, 'ºC'),
	(225328, 120, '2014-03-01 00:32:05.000000', 'temperatura', 790.0000, 'ºC'),
	(225329, 120, '2014-03-01 00:32:06.000000', 'temperatura', 630.0000, 'ºC'),
	(225330, 120, '2014-03-01 00:32:07.000000', 'temperatura', 779.0000, 'ºC'),
	(225331, 120, '2014-03-01 00:32:08.000000', 'temperatura', 806.0000, 'ºC'),
	(225332, 120, '2014-03-01 00:32:09.000000', 'temperatura', 493.0000, 'ºC'),
	(225333, 120, '2014-03-01 00:32:10.000000', 'temperatura', 48.0000, 'ºC'),
	(225334, 120, '2014-03-01 00:32:11.000000', 'temperatura', 1160.0000, 'ºC'),
	(225335, 120, '2014-03-01 00:32:12.000000', 'temperatura', 859.0000, 'ºC'),
	(225336, 120, '2014-03-01 00:32:13.000000', 'temperatura', 813.0000, 'ºC'),
	(225337, 120, '2014-03-01 00:32:14.000000', 'temperatura', 291.0000, 'ºC'),
	(225338, 120, '2014-03-01 00:32:15.000000', 'temperatura', 216.0000, 'ºC'),
	(225339, 120, '2014-03-01 00:32:16.000000', 'temperatura', 207.0000, 'ºC'),
	(225340, 120, '2014-03-01 00:32:17.000000', 'temperatura', 386.0000, 'ºC'),
	(225341, 120, '2014-03-01 00:32:18.000000', 'temperatura', 110.0000, 'ºC'),
	(225342, 120, '2014-03-01 00:32:19.000000', 'temperatura', 594.0000, 'ºC'),
	(225343, 120, '2014-03-01 00:32:20.000000', 'temperatura', 241.0000, 'ºC'),
	(225344, 120, '2014-03-01 00:32:21.000000', 'temperatura', 624.0000, 'ºC'),
	(225345, 120, '2014-03-01 00:32:22.000000', 'temperatura', 1195.0000, 'ºC'),
	(225346, 120, '2014-03-01 00:32:23.000000', 'temperatura', 505.0000, 'ºC'),
	(225347, 120, '2014-03-01 00:32:24.000000', 'temperatura', 140.0000, 'ºC'),
	(225348, 120, '2014-03-01 00:32:25.000000', 'temperatura', 386.0000, 'ºC'),
	(225349, 120, '2014-03-01 00:32:26.000000', 'temperatura', 312.0000, 'ºC'),
	(225350, 120, '2014-03-01 00:32:27.000000', 'temperatura', 401.0000, 'ºC'),
	(225351, 120, '2014-03-01 00:32:28.000000', 'temperatura', 1069.0000, 'ºC'),
	(225352, 120, '2014-03-01 00:32:29.000000', 'temperatura', 542.0000, 'ºC'),
	(225353, 120, '2014-03-01 00:32:30.000000', 'temperatura', 703.0000, 'ºC'),
	(225354, 120, '2014-03-01 00:32:31.000000', 'temperatura', 692.0000, 'ºC'),
	(225355, 120, '2014-03-01 00:32:32.000000', 'temperatura', 151.0000, 'ºC'),
	(225356, 120, '2014-03-01 00:32:33.000000', 'temperatura', 1079.0000, 'ºC'),
	(225357, 120, '2014-03-01 00:32:34.000000', 'temperatura', 141.0000, 'ºC'),
	(225358, 120, '2014-03-01 00:32:35.000000', 'temperatura', 1068.0000, 'ºC'),
	(225359, 120, '2014-03-01 00:32:36.000000', 'temperatura', 117.0000, 'ºC'),
	(225360, 120, '2014-03-01 00:32:37.000000', 'temperatura', 984.0000, 'ºC'),
	(225361, 120, '2014-03-01 00:32:38.000000', 'temperatura', 970.0000, 'ºC'),
	(225362, 120, '2014-03-01 00:32:39.000000', 'temperatura', 699.0000, 'ºC'),
	(225363, 120, '2014-03-01 00:32:40.000000', 'temperatura', 586.0000, 'ºC'),
	(225364, 120, '2014-03-01 00:32:41.000000', 'temperatura', 831.0000, 'ºC'),
	(225365, 120, '2014-03-01 00:32:42.000000', 'temperatura', 1198.0000, 'ºC'),
	(225366, 120, '2014-03-01 00:32:43.000000', 'temperatura', 1098.0000, 'ºC'),
	(225367, 120, '2014-03-01 00:32:44.000000', 'temperatura', 698.0000, 'ºC'),
	(225368, 120, '2014-03-01 00:32:45.000000', 'temperatura', 193.0000, 'ºC'),
	(225369, 120, '2014-03-01 00:32:46.000000', 'temperatura', 75.0000, 'ºC'),
	(225370, 120, '2014-03-01 00:32:47.000000', 'temperatura', 995.0000, 'ºC'),
	(225371, 120, '2014-03-01 00:32:48.000000', 'temperatura', 1149.0000, 'ºC'),
	(225372, 120, '2014-03-01 00:32:49.000000', 'temperatura', 360.0000, 'ºC'),
	(225373, 120, '2014-03-01 00:32:50.000000', 'temperatura', 753.0000, 'ºC'),
	(225374, 120, '2014-03-01 00:32:51.000000', 'temperatura', 286.0000, 'ºC'),
	(225375, 120, '2014-03-01 00:32:52.000000', 'temperatura', 373.0000, 'ºC'),
	(225376, 120, '2014-03-01 00:32:53.000000', 'temperatura', 1008.0000, 'ºC'),
	(225377, 120, '2014-03-01 00:32:54.000000', 'temperatura', 323.0000, 'ºC'),
	(225378, 120, '2014-03-01 00:32:55.000000', 'temperatura', 988.0000, 'ºC'),
	(225379, 120, '2014-03-01 00:32:56.000000', 'temperatura', 374.0000, 'ºC'),
	(225380, 120, '2014-03-01 00:32:57.000000', 'temperatura', 106.0000, 'ºC'),
	(225381, 120, '2014-03-01 00:32:58.000000', 'temperatura', 610.0000, 'ºC'),
	(225382, 120, '2014-03-01 00:32:59.000000', 'temperatura', 331.0000, 'ºC'),
	(225383, 120, '2014-03-01 00:33:00.000000', 'temperatura', 1024.0000, 'ºC'),
	(225384, 120, '2014-03-01 00:33:01.000000', 'temperatura', 528.0000, 'ºC'),
	(225385, 120, '2014-03-01 00:33:02.000000', 'temperatura', 767.0000, 'ºC'),
	(225386, 120, '2014-03-01 00:33:03.000000', 'temperatura', 1053.0000, 'ºC'),
	(225387, 120, '2014-03-01 00:33:04.000000', 'temperatura', 563.0000, 'ºC'),
	(225388, 120, '2014-03-01 00:33:05.000000', 'temperatura', 859.0000, 'ºC'),
	(225389, 120, '2014-03-01 00:33:06.000000', 'temperatura', 206.0000, 'ºC'),
	(225390, 120, '2014-03-01 00:33:07.000000', 'temperatura', 851.0000, 'ºC'),
	(225391, 120, '2014-03-01 00:33:08.000000', 'temperatura', 40.0000, 'ºC'),
	(225392, 120, '2014-03-01 00:33:09.000000', 'temperatura', 49.0000, 'ºC'),
	(225393, 120, '2014-03-01 00:33:10.000000', 'temperatura', 123.0000, 'ºC'),
	(225394, 120, '2014-03-01 00:33:11.000000', 'temperatura', 471.0000, 'ºC'),
	(225395, 120, '2014-03-01 00:33:12.000000', 'temperatura', 786.0000, 'ºC'),
	(225396, 120, '2014-03-01 00:33:13.000000', 'temperatura', 115.0000, 'ºC'),
	(225397, 120, '2014-03-01 00:33:14.000000', 'temperatura', 619.0000, 'ºC'),
	(225398, 120, '2014-03-01 00:33:15.000000', 'temperatura', 351.0000, 'ºC'),
	(225399, 120, '2014-03-01 00:33:16.000000', 'temperatura', 1100.0000, 'ºC'),
	(225400, 120, '2014-03-01 00:33:17.000000', 'temperatura', 844.0000, 'ºC'),
	(225401, 120, '2014-03-01 00:33:18.000000', 'temperatura', 924.0000, 'ºC'),
	(225402, 120, '2014-03-01 00:33:19.000000', 'temperatura', 886.0000, 'ºC'),
	(225403, 120, '2014-03-01 00:33:20.000000', 'temperatura', 460.0000, 'ºC'),
	(225404, 120, '2014-03-01 00:33:21.000000', 'temperatura', 843.0000, 'ºC'),
	(225405, 120, '2014-03-01 00:33:22.000000', 'temperatura', 434.0000, 'ºC'),
	(225406, 120, '2014-03-01 00:33:23.000000', 'temperatura', 842.0000, 'ºC'),
	(225407, 120, '2014-03-01 00:33:24.000000', 'temperatura', 510.0000, 'ºC'),
	(225408, 120, '2014-03-01 00:33:25.000000', 'temperatura', 25.0000, 'ºC'),
	(225409, 120, '2014-03-01 00:33:26.000000', 'temperatura', 995.0000, 'ºC'),
	(225410, 120, '2014-03-01 00:33:27.000000', 'temperatura', 99.0000, 'ºC'),
	(225411, 120, '2014-03-01 00:33:28.000000', 'temperatura', 1110.0000, 'ºC'),
	(225412, 120, '2014-03-01 00:33:29.000000', 'temperatura', 454.0000, 'ºC'),
	(225413, 120, '2014-03-01 00:33:30.000000', 'temperatura', 141.0000, 'ºC'),
	(225414, 120, '2014-03-01 00:33:31.000000', 'temperatura', 543.0000, 'ºC'),
	(225415, 120, '2014-03-01 00:33:32.000000', 'temperatura', 1095.0000, 'ºC'),
	(225416, 120, '2014-03-01 00:33:33.000000', 'temperatura', 244.0000, 'ºC'),
	(225417, 120, '2014-03-01 00:33:34.000000', 'temperatura', 336.0000, 'ºC'),
	(225418, 120, '2014-03-01 00:33:35.000000', 'temperatura', 949.0000, 'ºC'),
	(225419, 120, '2014-03-01 00:33:36.000000', 'temperatura', 138.0000, 'ºC'),
	(225420, 120, '2014-03-01 00:33:37.000000', 'temperatura', 242.0000, 'ºC'),
	(225421, 120, '2014-03-01 00:33:38.000000', 'temperatura', 795.0000, 'ºC'),
	(225422, 120, '2014-03-01 00:33:39.000000', 'temperatura', 852.0000, 'ºC'),
	(225423, 120, '2014-03-01 00:33:40.000000', 'temperatura', 673.0000, 'ºC'),
	(225424, 120, '2014-03-01 00:33:41.000000', 'temperatura', 812.0000, 'ºC'),
	(225425, 120, '2014-03-01 00:33:42.000000', 'temperatura', 839.0000, 'ºC'),
	(225426, 120, '2014-03-01 00:33:43.000000', 'temperatura', 561.0000, 'ºC'),
	(225427, 120, '2014-03-01 00:33:44.000000', 'temperatura', 287.0000, 'ºC'),
	(225428, 120, '2014-03-01 00:33:45.000000', 'temperatura', 952.0000, 'ºC'),
	(225429, 120, '2014-03-01 00:33:46.000000', 'temperatura', 301.0000, 'ºC'),
	(225430, 120, '2014-03-01 00:33:47.000000', 'temperatura', 1050.0000, 'ºC'),
	(225431, 120, '2014-03-01 00:33:48.000000', 'temperatura', 747.0000, 'ºC'),
	(225432, 120, '2014-03-01 00:33:49.000000', 'temperatura', 585.0000, 'ºC'),
	(225433, 120, '2014-03-01 00:33:50.000000', 'temperatura', 685.0000, 'ºC'),
	(225434, 120, '2014-03-01 00:33:51.000000', 'temperatura', 471.0000, 'ºC'),
	(225435, 120, '2014-03-01 00:33:52.000000', 'temperatura', 302.0000, 'ºC'),
	(225436, 120, '2014-03-01 00:33:53.000000', 'temperatura', 96.0000, 'ºC'),
	(225437, 120, '2014-03-01 00:33:54.000000', 'temperatura', 775.0000, 'ºC'),
	(225438, 120, '2014-03-01 00:33:55.000000', 'temperatura', 1186.0000, 'ºC'),
	(225439, 120, '2014-03-01 00:33:56.000000', 'temperatura', 4.0000, 'ºC'),
	(225440, 120, '2014-03-01 00:33:57.000000', 'temperatura', 65.0000, 'ºC'),
	(225441, 120, '2014-03-01 00:33:58.000000', 'temperatura', 314.0000, 'ºC'),
	(225442, 120, '2014-03-01 00:33:59.000000', 'temperatura', 173.0000, 'ºC'),
	(225443, 120, '2014-03-01 00:34:00.000000', 'temperatura', 1124.0000, 'ºC'),
	(225444, 120, '2014-03-01 00:34:01.000000', 'temperatura', 304.0000, 'ºC'),
	(225445, 120, '2014-03-01 00:34:02.000000', 'temperatura', 547.0000, 'ºC'),
	(225446, 120, '2014-03-01 00:34:03.000000', 'temperatura', 625.0000, 'ºC'),
	(225447, 120, '2014-03-01 00:34:04.000000', 'temperatura', 285.0000, 'ºC'),
	(225448, 120, '2014-03-01 00:34:05.000000', 'temperatura', 748.0000, 'ºC'),
	(225449, 120, '2014-03-01 00:34:06.000000', 'temperatura', 487.0000, 'ºC'),
	(225450, 120, '2014-03-01 00:34:07.000000', 'temperatura', 189.0000, 'ºC'),
	(225451, 120, '2014-03-01 00:34:08.000000', 'temperatura', 687.0000, 'ºC'),
	(225452, 120, '2014-03-01 00:34:09.000000', 'temperatura', 469.0000, 'ºC'),
	(225453, 120, '2014-03-01 00:34:10.000000', 'temperatura', 284.0000, 'ºC'),
	(225454, 120, '2014-03-01 00:34:11.000000', 'temperatura', 14.0000, 'ºC'),
	(225455, 120, '2014-03-01 00:34:12.000000', 'temperatura', 417.0000, 'ºC'),
	(225456, 120, '2014-03-01 00:34:13.000000', 'temperatura', 846.0000, 'ºC'),
	(225457, 120, '2014-03-01 00:34:14.000000', 'temperatura', 579.0000, 'ºC'),
	(225458, 120, '2014-03-01 00:34:15.000000', 'temperatura', 355.0000, 'ºC'),
	(225459, 120, '2014-03-01 00:34:16.000000', 'temperatura', 42.0000, 'ºC'),
	(225460, 120, '2014-03-01 00:34:17.000000', 'temperatura', 344.0000, 'ºC'),
	(225461, 120, '2014-03-01 00:34:18.000000', 'temperatura', 394.0000, 'ºC'),
	(225462, 120, '2014-03-01 00:34:19.000000', 'temperatura', 939.0000, 'ºC'),
	(225463, 120, '2014-03-01 00:34:20.000000', 'temperatura', 1116.0000, 'ºC'),
	(225464, 120, '2014-03-01 00:34:21.000000', 'temperatura', 360.0000, 'ºC'),
	(225465, 120, '2014-03-01 00:34:22.000000', 'temperatura', 852.0000, 'ºC'),
	(225466, 120, '2014-03-01 00:34:23.000000', 'temperatura', 782.0000, 'ºC'),
	(225467, 120, '2014-03-01 00:34:24.000000', 'temperatura', 155.0000, 'ºC'),
	(225468, 120, '2014-03-01 00:34:25.000000', 'temperatura', 828.0000, 'ºC'),
	(225469, 120, '2014-03-01 00:34:26.000000', 'temperatura', 74.0000, 'ºC'),
	(225470, 120, '2014-03-01 00:34:27.000000', 'temperatura', 290.0000, 'ºC'),
	(225471, 120, '2014-03-01 00:34:28.000000', 'temperatura', 26.0000, 'ºC'),
	(225472, 120, '2014-03-01 00:34:29.000000', 'temperatura', 460.0000, 'ºC'),
	(225473, 120, '2014-03-01 00:34:30.000000', 'temperatura', 1024.0000, 'ºC'),
	(225474, 120, '2014-03-01 00:34:31.000000', 'temperatura', 141.0000, 'ºC'),
	(225475, 120, '2014-03-01 00:34:32.000000', 'temperatura', 33.0000, 'ºC'),
	(225476, 120, '2014-03-01 00:34:33.000000', 'temperatura', 940.0000, 'ºC'),
	(225477, 120, '2014-03-01 00:34:34.000000', 'temperatura', 1005.0000, 'ºC'),
	(225478, 120, '2014-03-01 00:34:35.000000', 'temperatura', 1005.0000, 'ºC'),
	(225479, 120, '2014-03-01 00:34:36.000000', 'temperatura', 809.0000, 'ºC'),
	(225480, 120, '2014-03-01 00:34:37.000000', 'temperatura', 1031.0000, 'ºC'),
	(225481, 120, '2014-03-01 00:34:38.000000', 'temperatura', 331.0000, 'ºC'),
	(225482, 120, '2014-03-01 00:34:39.000000', 'temperatura', 959.0000, 'ºC'),
	(225483, 120, '2014-03-01 00:34:40.000000', 'temperatura', 203.0000, 'ºC'),
	(225484, 120, '2014-03-01 00:34:41.000000', 'temperatura', 540.0000, 'ºC'),
	(225485, 120, '2014-03-01 00:34:42.000000', 'temperatura', 890.0000, 'ºC'),
	(225486, 120, '2014-03-01 00:34:43.000000', 'temperatura', 431.0000, 'ºC'),
	(225487, 120, '2014-03-01 00:34:44.000000', 'temperatura', 686.0000, 'ºC'),
	(225488, 120, '2014-03-01 00:34:45.000000', 'temperatura', 937.0000, 'ºC'),
	(225489, 120, '2014-03-01 00:34:46.000000', 'temperatura', 226.0000, 'ºC'),
	(225490, 120, '2014-03-01 00:34:47.000000', 'temperatura', 719.0000, 'ºC'),
	(225491, 120, '2014-03-01 00:34:48.000000', 'temperatura', 519.0000, 'ºC'),
	(225492, 120, '2014-03-01 00:34:49.000000', 'temperatura', 437.0000, 'ºC'),
	(225493, 120, '2014-03-01 00:34:50.000000', 'temperatura', 630.0000, 'ºC'),
	(225494, 120, '2014-03-01 00:34:51.000000', 'temperatura', 638.0000, 'ºC'),
	(225495, 120, '2014-03-01 00:34:52.000000', 'temperatura', 99.0000, 'ºC'),
	(225496, 120, '2014-03-01 00:34:53.000000', 'temperatura', 984.0000, 'ºC'),
	(225497, 120, '2014-03-01 00:34:54.000000', 'temperatura', 1023.0000, 'ºC'),
	(225498, 120, '2014-03-01 00:34:55.000000', 'temperatura', 965.0000, 'ºC'),
	(225499, 120, '2014-03-01 00:34:56.000000', 'temperatura', 556.0000, 'ºC'),
	(225500, 120, '2014-03-01 00:34:57.000000', 'temperatura', 1084.0000, 'ºC'),
	(225501, 120, '2014-03-01 00:34:58.000000', 'temperatura', 151.0000, 'ºC'),
	(225502, 120, '2014-03-01 00:34:59.000000', 'temperatura', 1106.0000, 'ºC'),
	(225503, 120, '2014-03-01 00:35:00.000000', 'temperatura', 275.0000, 'ºC'),
	(225504, 120, '2014-03-01 00:35:01.000000', 'temperatura', 460.0000, 'ºC'),
	(225505, 120, '2014-03-01 00:35:02.000000', 'temperatura', 273.0000, 'ºC'),
	(225506, 120, '2014-03-01 00:35:03.000000', 'temperatura', 1186.0000, 'ºC'),
	(225507, 120, '2014-03-01 00:35:04.000000', 'temperatura', 314.0000, 'ºC'),
	(225508, 120, '2014-03-01 00:35:05.000000', 'temperatura', 411.0000, 'ºC'),
	(225509, 120, '2014-03-01 00:35:06.000000', 'temperatura', 1115.0000, 'ºC'),
	(225510, 120, '2014-03-01 00:35:07.000000', 'temperatura', 742.0000, 'ºC'),
	(225511, 120, '2014-03-01 00:35:08.000000', 'temperatura', 367.0000, 'ºC'),
	(225512, 120, '2014-03-01 00:35:09.000000', 'temperatura', 809.0000, 'ºC'),
	(225513, 120, '2014-03-01 00:35:10.000000', 'temperatura', 544.0000, 'ºC'),
	(225514, 120, '2014-03-01 00:35:11.000000', 'temperatura', 294.0000, 'ºC'),
	(225515, 120, '2014-03-01 00:35:12.000000', 'temperatura', 1037.0000, 'ºC'),
	(225516, 120, '2014-03-01 00:35:13.000000', 'temperatura', 703.0000, 'ºC'),
	(225517, 120, '2014-03-01 00:35:14.000000', 'temperatura', 404.0000, 'ºC'),
	(225518, 120, '2014-03-01 00:35:15.000000', 'temperatura', 1114.0000, 'ºC'),
	(225519, 120, '2014-03-01 00:35:16.000000', 'temperatura', 759.0000, 'ºC'),
	(225520, 120, '2014-03-01 00:35:17.000000', 'temperatura', 453.0000, 'ºC'),
	(225521, 120, '2014-03-01 00:35:18.000000', 'temperatura', 1187.0000, 'ºC'),
	(225522, 120, '2014-03-01 00:35:19.000000', 'temperatura', 977.0000, 'ºC'),
	(225523, 120, '2014-03-01 00:35:20.000000', 'temperatura', 126.0000, 'ºC'),
	(225524, 120, '2014-03-01 00:35:21.000000', 'temperatura', 101.0000, 'ºC'),
	(225525, 120, '2014-03-01 00:35:22.000000', 'temperatura', 124.0000, 'ºC'),
	(225526, 120, '2014-03-01 00:35:23.000000', 'temperatura', 318.0000, 'ºC'),
	(225527, 120, '2014-03-01 00:35:24.000000', 'temperatura', 19.0000, 'ºC'),
	(225528, 120, '2014-03-01 00:35:25.000000', 'temperatura', 341.0000, 'ºC'),
	(225529, 120, '2014-03-01 00:35:26.000000', 'temperatura', 448.0000, 'ºC'),
	(225530, 120, '2014-03-01 00:35:27.000000', 'temperatura', 19.0000, 'ºC'),
	(225531, 120, '2014-03-01 00:35:28.000000', 'temperatura', 1150.0000, 'ºC'),
	(225532, 120, '2014-03-01 00:35:29.000000', 'temperatura', 893.0000, 'ºC'),
	(225533, 120, '2014-03-01 00:35:30.000000', 'temperatura', 1016.0000, 'ºC'),
	(225534, 120, '2014-03-01 00:35:31.000000', 'temperatura', 0.0000, 'ºC'),
	(225535, 120, '2014-03-01 00:35:32.000000', 'temperatura', 553.0000, 'ºC'),
	(225536, 120, '2014-03-01 00:35:33.000000', 'temperatura', 367.0000, 'ºC'),
	(225537, 120, '2014-03-01 00:35:34.000000', 'temperatura', 176.0000, 'ºC'),
	(225538, 120, '2014-03-01 00:35:35.000000', 'temperatura', 981.0000, 'ºC'),
	(225539, 120, '2014-03-01 00:35:36.000000', 'temperatura', 775.0000, 'ºC'),
	(225540, 120, '2014-03-01 00:35:37.000000', 'temperatura', 934.0000, 'ºC'),
	(225541, 120, '2014-03-01 00:35:38.000000', 'temperatura', 1146.0000, 'ºC'),
	(225542, 120, '2014-03-01 00:35:39.000000', 'temperatura', 530.0000, 'ºC'),
	(225543, 120, '2014-03-01 00:35:40.000000', 'temperatura', 411.0000, 'ºC'),
	(225544, 120, '2014-03-01 00:35:41.000000', 'temperatura', 465.0000, 'ºC'),
	(225545, 120, '2014-03-01 00:35:42.000000', 'temperatura', 1094.0000, 'ºC'),
	(225546, 120, '2014-03-01 00:35:43.000000', 'temperatura', 475.0000, 'ºC'),
	(225547, 120, '2014-03-01 00:35:44.000000', 'temperatura', 294.0000, 'ºC'),
	(225548, 120, '2014-03-01 00:35:45.000000', 'temperatura', 44.0000, 'ºC'),
	(225549, 120, '2014-03-01 00:35:46.000000', 'temperatura', 541.0000, 'ºC'),
	(225550, 120, '2014-03-01 00:35:47.000000', 'temperatura', 172.0000, 'ºC'),
	(225551, 120, '2014-03-01 00:35:48.000000', 'temperatura', 438.0000, 'ºC'),
	(225552, 120, '2014-03-01 00:35:49.000000', 'temperatura', 475.0000, 'ºC'),
	(225553, 120, '2014-03-01 00:35:50.000000', 'temperatura', 1059.0000, 'ºC'),
	(225554, 120, '2014-03-01 00:35:51.000000', 'temperatura', 271.0000, 'ºC'),
	(225555, 120, '2014-03-01 00:35:52.000000', 'temperatura', 581.0000, 'ºC'),
	(225556, 120, '2014-03-01 00:35:53.000000', 'temperatura', 890.0000, 'ºC'),
	(225557, 120, '2014-03-01 00:35:54.000000', 'temperatura', 310.0000, 'ºC'),
	(225558, 120, '2014-03-01 00:35:55.000000', 'temperatura', 79.0000, 'ºC'),
	(225559, 120, '2014-03-01 00:35:56.000000', 'temperatura', 665.0000, 'ºC'),
	(225560, 120, '2014-03-01 00:35:57.000000', 'temperatura', 691.0000, 'ºC'),
	(225561, 120, '2014-03-01 00:35:58.000000', 'temperatura', 260.0000, 'ºC'),
	(225562, 120, '2014-03-01 00:35:59.000000', 'temperatura', 426.0000, 'ºC'),
	(225563, 120, '2014-03-01 00:36:00.000000', 'temperatura', 151.0000, 'ºC'),
	(225564, 120, '2014-03-01 00:36:01.000000', 'temperatura', 678.0000, 'ºC'),
	(225565, 120, '2014-03-01 00:36:02.000000', 'temperatura', 537.0000, 'ºC'),
	(225566, 120, '2014-03-01 00:36:03.000000', 'temperatura', 651.0000, 'ºC'),
	(225567, 120, '2014-03-01 00:36:04.000000', 'temperatura', 445.0000, 'ºC'),
	(225568, 120, '2014-03-01 00:36:05.000000', 'temperatura', 271.0000, 'ºC'),
	(225569, 120, '2014-03-01 00:36:06.000000', 'temperatura', 23.0000, 'ºC'),
	(225570, 120, '2014-03-01 00:36:07.000000', 'temperatura', 502.0000, 'ºC'),
	(225571, 120, '2014-03-01 00:36:08.000000', 'temperatura', 40.0000, 'ºC'),
	(225572, 120, '2014-03-01 00:36:09.000000', 'temperatura', 1096.0000, 'ºC'),
	(225573, 120, '2014-03-01 00:36:10.000000', 'temperatura', 561.0000, 'ºC'),
	(225574, 120, '2014-03-01 00:36:11.000000', 'temperatura', 718.0000, 'ºC'),
	(225575, 120, '2014-03-01 00:36:12.000000', 'temperatura', 707.0000, 'ºC'),
	(225576, 120, '2014-03-01 00:36:13.000000', 'temperatura', 183.0000, 'ºC'),
	(225577, 120, '2014-03-01 00:36:14.000000', 'temperatura', 1194.0000, 'ºC'),
	(225578, 120, '2014-03-01 00:36:15.000000', 'temperatura', 619.0000, 'ºC'),
	(225579, 120, '2014-03-01 00:36:16.000000', 'temperatura', 717.0000, 'ºC'),
	(225580, 120, '2014-03-01 00:36:17.000000', 'temperatura', 526.0000, 'ºC'),
	(225581, 120, '2014-03-01 00:36:18.000000', 'temperatura', 479.0000, 'ºC'),
	(225582, 120, '2014-03-01 00:36:19.000000', 'temperatura', 818.0000, 'ºC'),
	(225583, 120, '2014-03-01 00:36:20.000000', 'temperatura', 254.0000, 'ºC'),
	(225584, 120, '2014-03-01 00:36:21.000000', 'temperatura', 15.0000, 'ºC'),
	(225585, 120, '2014-03-01 00:36:22.000000', 'temperatura', 515.0000, 'ºC'),
	(225586, 120, '2014-03-01 00:36:23.000000', 'temperatura', 128.0000, 'ºC'),
	(225587, 120, '2014-03-01 00:36:24.000000', 'temperatura', 297.0000, 'ºC'),
	(225588, 120, '2014-03-01 00:36:25.000000', 'temperatura', 1103.0000, 'ºC'),
	(225589, 120, '2014-03-01 00:36:26.000000', 'temperatura', 1024.0000, 'ºC'),
	(225590, 120, '2014-03-01 00:36:27.000000', 'temperatura', 611.0000, 'ºC'),
	(225591, 120, '2014-03-01 00:36:28.000000', 'temperatura', 1182.0000, 'ºC'),
	(225592, 120, '2014-03-01 00:36:29.000000', 'temperatura', 477.0000, 'ºC'),
	(225593, 120, '2014-03-01 00:36:30.000000', 'temperatura', 40.0000, 'ºC'),
	(225594, 120, '2014-03-01 00:36:31.000000', 'temperatura', 1168.0000, 'ºC'),
	(225595, 120, '2014-03-01 00:36:32.000000', 'temperatura', 921.0000, 'ºC'),
	(225596, 120, '2014-03-01 00:36:33.000000', 'temperatura', 1102.0000, 'ºC'),
	(225597, 120, '2014-03-01 00:36:34.000000', 'temperatura', 346.0000, 'ºC'),
	(225598, 120, '2014-03-01 00:36:35.000000', 'temperatura', 825.0000, 'ºC'),
	(225599, 120, '2014-03-01 00:36:36.000000', 'temperatura', 689.0000, 'ºC'),
	(225600, 120, '2014-03-01 00:36:37.000000', 'temperatura', 971.0000, 'ºC'),
	(225601, 120, '2014-03-01 00:36:38.000000', 'temperatura', 386.0000, 'ºC'),
	(225602, 120, '2014-03-01 00:36:39.000000', 'temperatura', 220.0000, 'ºC'),
	(225603, 120, '2014-03-01 00:36:40.000000', 'temperatura', 1141.0000, 'ºC'),
	(225604, 120, '2014-03-01 00:36:41.000000', 'temperatura', 247.0000, 'ºC'),
	(225605, 120, '2014-03-01 00:36:42.000000', 'temperatura', 211.0000, 'ºC'),
	(225606, 120, '2014-03-01 00:36:43.000000', 'temperatura', 315.0000, 'ºC'),
	(225607, 120, '2014-03-01 00:36:44.000000', 'temperatura', 941.0000, 'ºC'),
	(225608, 120, '2014-03-01 00:36:45.000000', 'temperatura', 163.0000, 'ºC'),
	(225609, 120, '2014-03-01 00:36:46.000000', 'temperatura', 392.0000, 'ºC'),
	(225610, 120, '2014-03-01 00:36:47.000000', 'temperatura', 272.0000, 'ºC'),
	(225611, 120, '2014-03-01 00:36:48.000000', 'temperatura', 183.0000, 'ºC'),
	(225612, 120, '2014-03-01 00:36:49.000000', 'temperatura', 99.0000, 'ºC'),
	(225613, 120, '2014-03-01 00:36:50.000000', 'temperatura', 1149.0000, 'ºC'),
	(225614, 120, '2014-03-01 00:36:51.000000', 'temperatura', 646.0000, 'ºC'),
	(225615, 120, '2014-03-01 00:36:52.000000', 'temperatura', 985.0000, 'ºC'),
	(225616, 120, '2014-03-01 00:36:53.000000', 'temperatura', 588.0000, 'ºC'),
	(225617, 120, '2014-03-01 00:36:54.000000', 'temperatura', 1184.0000, 'ºC'),
	(225618, 120, '2014-03-01 00:36:55.000000', 'temperatura', 559.0000, 'ºC'),
	(225619, 120, '2014-03-01 00:36:56.000000', 'temperatura', 442.0000, 'ºC'),
	(225620, 120, '2014-03-01 00:36:57.000000', 'temperatura', 535.0000, 'ºC'),
	(225621, 120, '2014-03-01 00:36:58.000000', 'temperatura', 151.0000, 'ºC'),
	(225622, 120, '2014-03-01 00:36:59.000000', 'temperatura', 347.0000, 'ºC'),
	(225623, 120, '2014-03-01 00:37:00.000000', 'temperatura', 84.0000, 'ºC'),
	(225624, 120, '2014-03-01 00:37:01.000000', 'temperatura', 580.0000, 'ºC'),
	(225625, 120, '2014-03-01 00:37:02.000000', 'temperatura', 249.0000, 'ºC'),
	(225626, 120, '2014-03-01 00:37:03.000000', 'temperatura', 704.0000, 'ºC'),
	(225627, 120, '2014-03-01 00:37:04.000000', 'temperatura', 373.0000, 'ºC'),
	(225628, 120, '2014-03-01 00:37:05.000000', 'temperatura', 952.0000, 'ºC'),
	(225629, 120, '2014-03-01 00:37:06.000000', 'temperatura', 45.0000, 'ºC'),
	(225630, 120, '2014-03-01 00:37:07.000000', 'temperatura', 968.0000, 'ºC'),
	(225631, 120, '2014-03-01 00:37:08.000000', 'temperatura', 1107.0000, 'ºC'),
	(225632, 120, '2014-03-01 00:37:09.000000', 'temperatura', 231.0000, 'ºC'),
	(225633, 120, '2014-03-01 00:37:10.000000', 'temperatura', 235.0000, 'ºC'),
	(225634, 120, '2014-03-01 00:37:11.000000', 'temperatura', 481.0000, 'ºC'),
	(225635, 120, '2014-03-01 00:37:12.000000', 'temperatura', 503.0000, 'ºC'),
	(225636, 120, '2014-03-01 00:37:13.000000', 'temperatura', 1072.0000, 'ºC'),
	(225637, 120, '2014-03-01 00:37:14.000000', 'temperatura', 249.0000, 'ºC'),
	(225638, 120, '2014-03-01 00:37:15.000000', 'temperatura', 431.0000, 'ºC'),
	(225639, 120, '2014-03-01 00:37:16.000000', 'temperatura', 209.0000, 'ºC'),
	(225640, 120, '2014-03-01 00:37:17.000000', 'temperatura', 952.0000, 'ºC'),
	(225641, 120, '2014-03-01 00:37:18.000000', 'temperatura', 533.0000, 'ºC'),
	(225642, 120, '2014-03-01 00:37:19.000000', 'temperatura', 1011.0000, 'ºC'),
	(225643, 120, '2014-03-01 00:37:20.000000', 'temperatura', 1057.0000, 'ºC'),
	(225644, 120, '2014-03-01 00:37:21.000000', 'temperatura', 1050.0000, 'ºC'),
	(225645, 120, '2014-03-01 00:37:22.000000', 'temperatura', 881.0000, 'ºC'),
	(225646, 120, '2014-03-01 00:37:23.000000', 'temperatura', 57.0000, 'ºC'),
	(225647, 120, '2014-03-01 00:37:24.000000', 'temperatura', 40.0000, 'ºC'),
	(225648, 120, '2014-03-01 00:37:25.000000', 'temperatura', 31.0000, 'ºC'),
	(225649, 120, '2014-03-01 00:37:26.000000', 'temperatura', 34.0000, 'ºC'),
	(225650, 120, '2014-03-01 00:37:27.000000', 'temperatura', 76.0000, 'ºC'),
	(225651, 120, '2014-03-01 00:37:28.000000', 'temperatura', 281.0000, 'ºC'),
	(225652, 120, '2014-03-01 00:37:29.000000', 'temperatura', 1179.0000, 'ºC'),
	(225653, 120, '2014-03-01 00:37:30.000000', 'temperatura', 249.0000, 'ºC'),
	(225654, 120, '2014-03-01 00:37:31.000000', 'temperatura', 110.0000, 'ºC'),
	(225655, 120, '2014-03-01 00:37:32.000000', 'temperatura', 1006.0000, 'ºC'),
	(225656, 120, '2014-03-01 00:37:33.000000', 'temperatura', 1097.0000, 'ºC'),
	(225657, 120, '2014-03-01 00:37:34.000000', 'temperatura', 67.0000, 'ºC'),
	(225658, 120, '2014-03-01 00:37:35.000000', 'temperatura', 645.0000, 'ºC'),
	(225659, 120, '2014-03-01 00:37:36.000000', 'temperatura', 626.0000, 'ºC'),
	(225660, 120, '2014-03-01 00:37:37.000000', 'temperatura', 1196.0000, 'ºC'),
	(225661, 120, '2014-03-01 00:37:38.000000', 'temperatura', 501.0000, 'ºC'),
	(225662, 120, '2014-03-01 00:37:39.000000', 'temperatura', 117.0000, 'ºC'),
	(225663, 120, '2014-03-01 00:37:40.000000', 'temperatura', 283.0000, 'ºC'),
	(225664, 120, '2014-03-01 00:37:41.000000', 'temperatura', 1064.0000, 'ºC'),
	(225665, 120, '2014-03-01 00:37:42.000000', 'temperatura', 872.0000, 'ºC'),
	(225666, 120, '2014-03-01 00:37:43.000000', 'temperatura', 1168.0000, 'ºC'),
	(225667, 120, '2014-03-01 00:37:44.000000', 'temperatura', 826.0000, 'ºC'),
	(225668, 120, '2014-03-01 00:37:45.000000', 'temperatura', 625.0000, 'ºC'),
	(225669, 120, '2014-03-01 00:37:46.000000', 'temperatura', 648.0000, 'ºC'),
	(225670, 120, '2014-03-01 00:37:47.000000', 'temperatura', 166.0000, 'ºC'),
	(225671, 120, '2014-03-01 00:37:48.000000', 'temperatura', 87.0000, 'ºC'),
	(225672, 120, '2014-03-01 00:37:49.000000', 'temperatura', 1135.0000, 'ºC'),
	(225673, 120, '2014-03-01 00:37:50.000000', 'temperatura', 615.0000, 'ºC'),
	(225674, 120, '2014-03-01 00:37:51.000000', 'temperatura', 871.0000, 'ºC'),
	(225675, 120, '2014-03-01 00:37:52.000000', 'temperatura', 110.0000, 'ºC'),
	(225676, 120, '2014-03-01 00:37:53.000000', 'temperatura', 337.0000, 'ºC'),
	(225677, 120, '2014-03-01 00:37:54.000000', 'temperatura', 155.0000, 'ºC'),
	(225678, 120, '2014-03-01 00:37:55.000000', 'temperatura', 963.0000, 'ºC'),
	(225679, 120, '2014-03-01 00:37:56.000000', 'temperatura', 754.0000, 'ºC'),
	(225680, 120, '2014-03-01 00:37:57.000000', 'temperatura', 880.0000, 'ºC'),
	(225681, 120, '2014-03-01 00:37:58.000000', 'temperatura', 938.0000, 'ºC'),
	(225682, 120, '2014-03-01 00:37:59.000000', 'temperatura', 851.0000, 'ºC'),
	(225683, 120, '2014-03-01 00:38:00.000000', 'temperatura', 241.0000, 'ºC'),
	(225684, 120, '2014-03-01 00:38:01.000000', 'temperatura', 1054.0000, 'ºC'),
	(225685, 120, '2014-03-01 00:38:02.000000', 'temperatura', 947.0000, 'ºC'),
	(225686, 120, '2014-03-01 00:38:03.000000', 'temperatura', 374.0000, 'ºC'),
	(225687, 120, '2014-03-01 00:38:04.000000', 'temperatura', 229.0000, 'ºC'),
	(225688, 120, '2014-03-01 00:38:05.000000', 'temperatura', 22.0000, 'ºC'),
	(225689, 120, '2014-03-01 00:38:06.000000', 'temperatura', 623.0000, 'ºC'),
	(225690, 120, '2014-03-01 00:38:07.000000', 'temperatura', 653.0000, 'ºC'),
	(225691, 120, '2014-03-01 00:38:08.000000', 'temperatura', 193.0000, 'ºC'),
	(225692, 120, '2014-03-01 00:38:09.000000', 'temperatura', 208.0000, 'ºC'),
	(225693, 120, '2014-03-01 00:38:10.000000', 'temperatura', 461.0000, 'ºC'),
	(225694, 120, '2014-03-01 00:38:11.000000', 'temperatura', 480.0000, 'ºC'),
	(225695, 120, '2014-03-01 00:38:12.000000', 'temperatura', 1019.0000, 'ºC'),
	(225696, 120, '2014-03-01 00:38:13.000000', 'temperatura', 55.0000, 'ºC'),
	(225697, 120, '2014-03-01 00:38:14.000000', 'temperatura', 821.0000, 'ºC'),
	(225698, 120, '2014-03-01 00:38:15.000000', 'temperatura', 337.0000, 'ºC'),
	(225699, 120, '2014-03-01 00:38:16.000000', 'temperatura', 426.0000, 'ºC'),
	(225700, 120, '2014-03-01 00:38:17.000000', 'temperatura', 1118.0000, 'ºC'),
	(225701, 120, '2014-03-01 00:38:18.000000', 'temperatura', 712.0000, 'ºC'),
	(225702, 120, '2014-03-01 00:38:19.000000', 'temperatura', 206.0000, 'ºC'),
	(225703, 120, '2014-03-01 00:38:20.000000', 'temperatura', 97.0000, 'ºC'),
	(225704, 120, '2014-03-01 00:38:21.000000', 'temperatura', 1067.0000, 'ºC'),
	(225705, 120, '2014-03-01 00:38:22.000000', 'temperatura', 244.0000, 'ºC'),
	(225706, 120, '2014-03-01 00:38:23.000000', 'temperatura', 418.0000, 'ºC'),
	(225707, 120, '2014-03-01 00:38:24.000000', 'temperatura', 161.0000, 'ºC'),
	(225708, 120, '2014-03-01 00:38:25.000000', 'temperatura', 751.0000, 'ºC'),
	(225709, 120, '2014-03-01 00:38:26.000000', 'temperatura', 872.0000, 'ºC'),
	(225710, 120, '2014-03-01 00:38:27.000000', 'temperatura', 909.0000, 'ºC'),
	(225711, 120, '2014-03-01 00:38:28.000000', 'temperatura', 727.0000, 'ºC'),
	(225712, 120, '2014-03-01 00:38:29.000000', 'temperatura', 909.0000, 'ºC'),
	(225713, 120, '2014-03-01 00:38:30.000000', 'temperatura', 1165.0000, 'ºC'),
	(225714, 120, '2014-03-01 00:38:31.000000', 'temperatura', 698.0000, 'ºC'),
	(225715, 120, '2014-03-01 00:38:32.000000', 'temperatura', 1198.0000, 'ºC'),
	(225716, 120, '2014-03-01 00:38:33.000000', 'temperatura', 295.0000, 'ºC'),
	(225717, 120, '2014-03-01 00:38:34.000000', 'temperatura', 280.0000, 'ºC'),
	(225718, 120, '2014-03-01 00:38:35.000000', 'temperatura', 515.0000, 'ºC'),
	(225719, 120, '2014-03-01 00:38:36.000000', 'temperatura', 537.0000, 'ºC'),
	(225720, 120, '2014-03-01 00:38:37.000000', 'temperatura', 1139.0000, 'ºC'),
	(225721, 120, '2014-03-01 00:38:38.000000', 'temperatura', 484.0000, 'ºC'),
	(225722, 120, '2014-03-01 00:38:39.000000', 'temperatura', 205.0000, 'ºC'),
	(225723, 120, '2014-03-01 00:38:40.000000', 'temperatura', 772.0000, 'ºC'),
	(225724, 120, '2014-03-01 00:38:41.000000', 'temperatura', 848.0000, 'ºC'),
	(225725, 120, '2014-03-01 00:38:42.000000', 'temperatura', 725.0000, 'ºC'),
	(225726, 120, '2014-03-01 00:38:43.000000', 'temperatura', 1081.0000, 'ºC'),
	(225727, 120, '2014-03-01 00:38:44.000000', 'temperatura', 828.0000, 'ºC'),
	(225728, 120, '2014-03-01 00:38:45.000000', 'temperatura', 901.0000, 'ºC'),
	(225729, 120, '2014-03-01 00:38:46.000000', 'temperatura', 820.0000, 'ºC'),
	(225730, 120, '2014-03-01 00:38:47.000000', 'temperatura', 197.0000, 'ºC'),
	(225731, 120, '2014-03-01 00:38:48.000000', 'temperatura', 926.0000, 'ºC'),
	(225732, 120, '2014-03-01 00:38:49.000000', 'temperatura', 440.0000, 'ºC'),
	(225733, 120, '2014-03-01 00:38:50.000000', 'temperatura', 622.0000, 'ºC'),
	(225734, 120, '2014-03-01 00:38:51.000000', 'temperatura', 591.0000, 'ºC'),
	(225735, 120, '2014-03-01 00:38:52.000000', 'temperatura', 1091.0000, 'ºC'),
	(225736, 120, '2014-03-01 00:38:53.000000', 'temperatura', 80.0000, 'ºC'),
	(225737, 120, '2014-03-01 00:38:54.000000', 'temperatura', 728.0000, 'ºC'),
	(225738, 120, '2014-03-01 00:38:55.000000', 'temperatura', 1000.0000, 'ºC'),
	(225739, 120, '2014-03-01 00:38:56.000000', 'temperatura', 417.0000, 'ºC'),
	(225740, 120, '2014-03-01 00:38:57.000000', 'temperatura', 288.0000, 'ºC'),
	(225741, 120, '2014-03-01 00:38:58.000000', 'temperatura', 186.0000, 'ºC'),
	(225742, 120, '2014-03-01 00:38:59.000000', 'temperatura', 69.0000, 'ºC'),
	(225743, 120, '2014-03-01 00:39:00.000000', 'temperatura', 985.0000, 'ºC'),
	(225744, 120, '2014-03-01 00:39:01.000000', 'temperatura', 1122.0000, 'ºC'),
	(225745, 120, '2014-03-01 00:39:02.000000', 'temperatura', 253.0000, 'ºC'),
	(225746, 120, '2014-03-01 00:39:03.000000', 'temperatura', 298.0000, 'ºC'),
	(225747, 120, '2014-03-01 00:39:04.000000', 'temperatura', 734.0000, 'ºC'),
	(225748, 120, '2014-03-01 00:39:05.000000', 'temperatura', 378.0000, 'ºC'),
	(225749, 120, '2014-03-01 00:39:06.000000', 'temperatura', 886.0000, 'ºC'),
	(225750, 120, '2014-03-01 00:39:07.000000', 'temperatura', 896.0000, 'ºC'),
	(225751, 120, '2014-03-01 00:39:08.000000', 'temperatura', 622.0000, 'ºC'),
	(225752, 120, '2014-03-01 00:39:09.000000', 'temperatura', 423.0000, 'ºC'),
	(225753, 120, '2014-03-01 00:39:10.000000', 'temperatura', 252.0000, 'ºC'),
	(225754, 120, '2014-03-01 00:39:11.000000', 'temperatura', 1190.0000, 'ºC'),
	(225755, 120, '2014-03-01 00:39:12.000000', 'temperatura', 392.0000, 'ºC'),
	(225756, 120, '2014-03-01 00:39:13.000000', 'temperatura', 794.0000, 'ºC'),
	(225757, 120, '2014-03-01 00:39:14.000000', 'temperatura', 392.0000, 'ºC'),
	(225758, 120, '2014-03-01 00:39:15.000000', 'temperatura', 780.0000, 'ºC'),
	(225759, 120, '2014-03-01 00:39:16.000000', 'temperatura', 322.0000, 'ºC'),
	(225760, 120, '2014-03-01 00:39:17.000000', 'temperatura', 472.0000, 'ºC'),
	(225761, 120, '2014-03-01 00:39:18.000000', 'temperatura', 193.0000, 'ºC'),
	(225762, 120, '2014-03-01 00:39:19.000000', 'temperatura', 750.0000, 'ºC'),
	(225763, 120, '2014-03-01 00:39:20.000000', 'temperatura', 771.0000, 'ºC'),
	(225764, 120, '2014-03-01 00:39:21.000000', 'temperatura', 405.0000, 'ºC'),
	(225765, 120, '2014-03-01 00:39:22.000000', 'temperatura', 915.0000, 'ºC'),
	(225766, 120, '2014-03-01 00:39:23.000000', 'temperatura', 961.0000, 'ºC'),
	(225767, 120, '2014-03-01 00:39:24.000000', 'temperatura', 859.0000, 'ºC'),
	(225768, 120, '2014-03-01 00:39:25.000000', 'temperatura', 213.0000, 'ºC'),
	(225769, 120, '2014-03-01 00:39:26.000000', 'temperatura', 887.0000, 'ºC'),
	(225770, 120, '2014-03-01 00:39:27.000000', 'temperatura', 198.0000, 'ºC'),
	(225771, 120, '2014-03-01 00:39:28.000000', 'temperatura', 729.0000, 'ºC'),
	(225772, 120, '2014-03-01 00:39:29.000000', 'temperatura', 651.0000, 'ºC'),
	(225773, 120, '2014-03-01 00:39:30.000000', 'temperatura', 1068.0000, 'ºC'),
	(225774, 120, '2014-03-01 00:39:31.000000', 'temperatura', 990.0000, 'ºC'),
	(225775, 120, '2014-03-01 00:39:32.000000', 'temperatura', 543.0000, 'ºC'),
	(225776, 120, '2014-03-01 00:39:33.000000', 'temperatura', 947.0000, 'ºC'),
	(225777, 120, '2014-03-01 00:39:34.000000', 'temperatura', 707.0000, 'ºC'),
	(225778, 120, '2014-03-01 00:39:35.000000', 'temperatura', 696.0000, 'ºC'),
	(225779, 120, '2014-03-01 00:39:36.000000', 'temperatura', 157.0000, 'ºC'),
	(225780, 120, '2014-03-01 00:39:37.000000', 'temperatura', 1098.0000, 'ºC'),
	(225781, 120, '2014-03-01 00:39:38.000000', 'temperatura', 220.0000, 'ºC'),
	(225782, 120, '2014-03-01 00:39:39.000000', 'temperatura', 205.0000, 'ºC'),
	(225783, 120, '2014-03-01 00:39:40.000000', 'temperatura', 368.0000, 'ºC'),
	(225784, 120, '2014-03-01 00:39:41.000000', 'temperatura', 23.0000, 'ºC'),
	(225785, 120, '2014-03-01 00:39:42.000000', 'temperatura', 211.0000, 'ºC'),
	(225786, 120, '2014-03-01 00:39:43.000000', 'temperatura', 990.0000, 'ºC'),
	(225787, 120, '2014-03-01 00:39:44.000000', 'temperatura', 714.0000, 'ºC'),
	(225788, 120, '2014-03-01 00:39:45.000000', 'temperatura', 602.0000, 'ºC'),
	(225789, 120, '2014-03-01 00:39:46.000000', 'temperatura', 867.0000, 'ºC'),
	(225790, 120, '2014-03-01 00:39:47.000000', 'temperatura', 132.0000, 'ºC'),
	(225791, 120, '2014-03-01 00:39:48.000000', 'temperatura', 460.0000, 'ºC'),
	(225792, 120, '2014-03-01 00:39:49.000000', 'temperatura', 702.0000, 'ºC'),
	(225793, 120, '2014-03-01 00:39:50.000000', 'temperatura', 930.0000, 'ºC'),
	(225794, 120, '2014-03-01 00:39:51.000000', 'temperatura', 146.0000, 'ºC'),
	(225795, 120, '2014-03-01 00:39:52.000000', 'temperatura', 339.0000, 'ºC'),
	(225796, 120, '2014-03-01 00:39:53.000000', 'temperatura', 57.0000, 'ºC'),
	(225797, 120, '2014-03-01 00:39:54.000000', 'temperatura', 468.0000, 'ºC'),
	(225798, 120, '2014-03-01 00:39:55.000000', 'temperatura', 969.0000, 'ºC'),
	(225799, 120, '2014-03-01 00:39:56.000000', 'temperatura', 1044.0000, 'ºC'),
	(225800, 120, '2014-03-01 00:39:57.000000', 'temperatura', 1110.0000, 'ºC'),
	(225801, 120, '2014-03-01 00:39:58.000000', 'temperatura', 22.0000, 'ºC'),
	(225802, 120, '2014-03-01 00:39:59.000000', 'temperatura', 380.0000, 'ºC'),
	(225803, 120, '2014-03-01 00:40:00.000000', 'temperatura', 636.0000, 'ºC'),
	(225804, 120, '2014-03-01 00:40:01.000000', 'temperatura', 837.0000, 'ºC'),
	(225805, 120, '2014-03-01 00:40:02.000000', 'temperatura', 1081.0000, 'ºC'),
	(225806, 120, '2014-03-01 00:40:03.000000', 'temperatura', 493.0000, 'ºC'),
	(225807, 120, '2014-03-01 00:40:04.000000', 'temperatura', 423.0000, 'ºC'),
	(225808, 120, '2014-03-01 00:40:05.000000', 'temperatura', 637.0000, 'ºC'),
	(225809, 120, '2014-03-01 00:40:06.000000', 'temperatura', 716.0000, 'ºC'),
	(225810, 120, '2014-03-01 00:40:07.000000', 'temperatura', 471.0000, 'ºC'),
	(225811, 120, '2014-03-01 00:40:08.000000', 'temperatura', 204.0000, 'ºC'),
	(225812, 120, '2014-03-01 00:40:09.000000', 'temperatura', 811.0000, 'ºC'),
	(225813, 120, '2014-03-01 00:40:10.000000', 'temperatura', 1040.0000, 'ºC'),
	(225814, 120, '2014-03-01 00:40:11.000000', 'temperatura', 370.0000, 'ºC'),
	(225815, 120, '2014-03-01 00:40:12.000000', 'temperatura', 1129.0000, 'ºC'),
	(225816, 120, '2014-03-01 00:40:13.000000', 'temperatura', 934.0000, 'ºC'),
	(225817, 120, '2014-03-01 00:40:14.000000', 'temperatura', 85.0000, 'ºC'),
	(225818, 120, '2014-03-01 00:40:15.000000', 'temperatura', 24.0000, 'ºC'),
	(225819, 120, '2014-03-01 00:40:16.000000', 'temperatura', 1065.0000, 'ºC'),
	(225820, 120, '2014-03-01 00:40:17.000000', 'temperatura', 453.0000, 'ºC'),
	(225821, 120, '2014-03-01 00:40:18.000000', 'temperatura', 273.0000, 'ºC'),
	(225822, 120, '2014-03-01 00:40:19.000000', 'temperatura', 4.0000, 'ºC'),
	(225823, 120, '2014-03-01 00:40:20.000000', 'temperatura', 403.0000, 'ºC'),
	(225824, 120, '2014-03-01 00:40:21.000000', 'temperatura', 805.0000, 'ºC'),
	(225825, 120, '2014-03-01 00:40:22.000000', 'temperatura', 415.0000, 'ºC'),
	(225826, 120, '2014-03-01 00:40:23.000000', 'temperatura', 861.0000, 'ºC'),
	(225827, 120, '2014-03-01 00:40:24.000000', 'temperatura', 659.0000, 'ºC'),
	(225828, 120, '2014-03-01 00:40:25.000000', 'temperatura', 713.0000, 'ºC'),
	(225829, 120, '2014-03-01 00:40:26.000000', 'temperatura', 390.0000, 'ºC'),
	(225830, 120, '2014-03-01 00:40:27.000000', 'temperatura', 1011.0000, 'ºC'),
	(225831, 120, '2014-03-01 00:40:28.000000', 'temperatura', 285.0000, 'ºC'),
	(225832, 120, '2014-03-01 00:40:29.000000', 'temperatura', 793.0000, 'ºC'),
	(225833, 120, '2014-03-01 00:40:30.000000', 'temperatura', 711.0000, 'ºC'),
	(225834, 120, '2014-03-01 00:40:31.000000', 'temperatura', 1175.0000, 'ºC'),
	(225835, 120, '2014-03-01 00:40:32.000000', 'temperatura', 141.0000, 'ºC'),
	(225836, 120, '2014-03-01 00:40:33.000000', 'temperatura', 783.0000, 'ºC'),
	(225837, 120, '2014-03-01 00:40:34.000000', 'temperatura', 1092.0000, 'ºC'),
	(225838, 120, '2014-03-01 00:40:35.000000', 'temperatura', 710.0000, 'ºC'),
	(225839, 120, '2014-03-01 00:40:36.000000', 'temperatura', 277.0000, 'ºC'),
	(225840, 120, '2014-03-01 00:40:37.000000', 'temperatura', 456.0000, 'ºC'),
	(225841, 120, '2014-03-01 00:40:38.000000', 'temperatura', 249.0000, 'ºC'),
	(225842, 120, '2014-03-01 00:40:39.000000', 'temperatura', 1078.0000, 'ºC'),
	(225843, 120, '2014-03-01 00:40:40.000000', 'temperatura', 1043.0000, 'ºC'),
	(225844, 120, '2014-03-01 00:40:41.000000', 'temperatura', 781.0000, 'ºC'),
	(225845, 120, '2014-03-01 00:40:42.000000', 'temperatura', 777.0000, 'ºC'),
	(225846, 120, '2014-03-01 00:40:43.000000', 'temperatura', 341.0000, 'ºC'),
	(225847, 120, '2014-03-01 00:40:44.000000', 'temperatura', 576.0000, 'ºC'),
	(225848, 120, '2014-03-01 00:40:45.000000', 'temperatura', 658.0000, 'ºC'),
	(225849, 120, '2014-03-01 00:40:46.000000', 'temperatura', 364.0000, 'ºC'),
	(225850, 120, '2014-03-01 00:40:47.000000', 'temperatura', 1044.0000, 'ºC'),
	(225851, 120, '2014-03-01 00:40:48.000000', 'temperatura', 529.0000, 'ºC'),
	(225852, 120, '2014-03-01 00:40:49.000000', 'temperatura', 715.0000, 'ºC'),
	(225853, 120, '2014-03-01 00:40:50.000000', 'temperatura', 787.0000, 'ºC'),
	(225854, 120, '2014-03-01 00:40:51.000000', 'temperatura', 590.0000, 'ºC'),
	(225855, 120, '2014-03-01 00:40:52.000000', 'temperatura', 589.0000, 'ºC'),
	(225856, 120, '2014-03-01 00:40:53.000000', 'temperatura', 1177.0000, 'ºC'),
	(225857, 120, '2014-03-01 00:40:54.000000', 'temperatura', 517.0000, 'ºC'),
	(225858, 120, '2014-03-01 00:40:55.000000', 'temperatura', 254.0000, 'ºC'),
	(225859, 120, '2014-03-01 00:40:56.000000', 'temperatura', 920.0000, 'ºC'),
	(225860, 120, '2014-03-01 00:40:57.000000', 'temperatura', 241.0000, 'ºC'),
	(225861, 120, '2014-03-01 00:40:58.000000', 'temperatura', 843.0000, 'ºC'),
	(225862, 120, '2014-03-01 00:40:59.000000', 'temperatura', 1093.0000, 'ºC'),
	(225863, 120, '2014-03-01 00:41:00.000000', 'temperatura', 538.0000, 'ºC'),
	(225864, 120, '2014-03-01 00:41:01.000000', 'temperatura', 612.0000, 'ºC'),
	(225865, 120, '2014-03-01 00:41:02.000000', 'temperatura', 244.0000, 'ºC'),
	(225866, 120, '2014-03-01 00:41:03.000000', 'temperatura', 587.0000, 'ºC'),
	(225867, 120, '2014-03-01 00:41:04.000000', 'temperatura', 1002.0000, 'ºC'),
	(225868, 120, '2014-03-01 00:41:05.000000', 'temperatura', 851.0000, 'ºC'),
	(225869, 120, '2014-03-01 00:41:06.000000', 'temperatura', 47.0000, 'ºC'),
	(225870, 120, '2014-03-01 00:41:07.000000', 'temperatura', 83.0000, 'ºC'),
	(225871, 120, '2014-03-01 00:41:08.000000', 'temperatura', 273.0000, 'ºC'),
	(225872, 120, '2014-03-01 00:41:09.000000', 'temperatura', 1119.0000, 'ºC'),
	(225873, 120, '2014-03-01 00:41:10.000000', 'temperatura', 1177.0000, 'ºC'),
	(225874, 120, '2014-03-01 00:41:11.000000', 'temperatura', 126.0000, 'ºC'),
	(225875, 120, '2014-03-01 00:41:12.000000', 'temperatura', 702.0000, 'ºC'),
	(225876, 120, '2014-03-01 00:41:13.000000', 'temperatura', 731.0000, 'ºC'),
	(225877, 120, '2014-03-01 00:41:14.000000', 'temperatura', 349.0000, 'ºC'),
	(225878, 120, '2014-03-01 00:41:15.000000', 'temperatura', 754.0000, 'ºC'),
	(225879, 120, '2014-03-01 00:41:16.000000', 'temperatura', 323.0000, 'ºC'),
	(225880, 120, '2014-03-01 00:41:17.000000', 'temperatura', 554.0000, 'ºC'),
	(225881, 120, '2014-03-01 00:41:18.000000', 'temperatura', 600.0000, 'ºC'),
	(225882, 120, '2014-03-01 00:41:19.000000', 'temperatura', 140.0000, 'ºC'),
	(225883, 120, '2014-03-01 00:41:20.000000', 'temperatura', 102.0000, 'ºC'),
	(225884, 120, '2014-03-01 00:41:21.000000', 'temperatura', 87.0000, 'ºC'),
	(225885, 120, '2014-03-01 00:41:22.000000', 'temperatura', 132.0000, 'ºC'),
	(225886, 120, '2014-03-01 00:41:23.000000', 'temperatura', 400.0000, 'ºC'),
	(225887, 120, '2014-03-01 00:41:24.000000', 'temperatura', 405.0000, 'ºC'),
	(225888, 120, '2014-03-01 00:41:25.000000', 'temperatura', 825.0000, 'ºC'),
	(225889, 120, '2014-03-01 00:41:26.000000', 'temperatura', 509.0000, 'ºC'),
	(225890, 120, '2014-03-01 00:41:27.000000', 'temperatura', 71.0000, 'ºC'),
	(225891, 120, '2014-03-01 00:41:28.000000', 'temperatura', 28.0000, 'ºC'),
	(225892, 120, '2014-03-01 00:41:29.000000', 'temperatura', 1130.0000, 'ºC'),
	(225893, 120, '2014-03-01 00:41:30.000000', 'temperatura', 765.0000, 'ºC'),
	(225894, 120, '2014-03-01 00:41:31.000000', 'temperatura', 437.0000, 'ºC'),
	(225895, 120, '2014-03-01 00:41:32.000000', 'temperatura', 1089.0000, 'ºC'),
	(225896, 120, '2014-03-01 00:41:33.000000', 'temperatura', 534.0000, 'ºC'),
	(225897, 120, '2014-03-01 00:41:34.000000', 'temperatura', 603.0000, 'ºC'),
	(225898, 120, '2014-03-01 00:41:35.000000', 'temperatura', 215.0000, 'ºC'),
	(225899, 120, '2014-03-01 00:41:36.000000', 'temperatura', 466.0000, 'ºC'),
	(225900, 120, '2014-03-01 00:41:37.000000', 'temperatura', 486.0000, 'ºC'),
	(225901, 120, '2014-03-01 00:41:38.000000', 'temperatura', 1032.0000, 'ºC'),
	(225902, 120, '2014-03-01 00:41:39.000000', 'temperatura', 101.0000, 'ºC'),
	(225903, 120, '2014-03-01 00:41:40.000000', 'temperatura', 1012.0000, 'ºC'),
	(225904, 120, '2014-03-01 00:41:41.000000', 'temperatura', 1157.0000, 'ºC'),
	(225905, 120, '2014-03-01 00:41:42.000000', 'temperatura', 348.0000, 'ºC'),
	(225906, 120, '2014-03-01 00:41:43.000000', 'temperatura', 669.0000, 'ºC'),
	(225907, 120, '2014-03-01 00:41:44.000000', 'temperatura', 1101.0000, 'ºC'),
	(225908, 120, '2014-03-01 00:41:45.000000', 'temperatura', 1101.0000, 'ºC'),
	(225909, 120, '2014-03-01 00:41:46.000000', 'temperatura', 1000.0000, 'ºC'),
	(225910, 120, '2014-03-01 00:41:47.000000', 'temperatura', 498.0000, 'ºC'),
	(225911, 120, '2014-03-01 00:41:48.000000', 'temperatura', 691.0000, 'ºC'),
	(225912, 120, '2014-03-01 00:41:49.000000', 'temperatura', 759.0000, 'ºC'),
	(225913, 120, '2014-03-01 00:41:50.000000', 'temperatura', 526.0000, 'ºC'),
	(225914, 120, '2014-03-01 00:41:51.000000', 'temperatura', 351.0000, 'ºC'),
	(225915, 120, '2014-03-01 00:41:52.000000', 'temperatura', 180.0000, 'ºC'),
	(225916, 120, '2014-03-01 00:41:53.000000', 'temperatura', 1048.0000, 'ºC'),
	(225917, 120, '2014-03-01 00:41:54.000000', 'temperatura', 1100.0000, 'ºC'),
	(225918, 120, '2014-03-01 00:41:55.000000', 'temperatura', 1156.0000, 'ºC'),
	(225919, 120, '2014-03-01 00:41:56.000000', 'temperatura', 80.0000, 'ºC'),
	(225920, 120, '2014-03-01 00:41:57.000000', 'temperatura', 531.0000, 'ºC'),
	(225921, 120, '2014-03-01 00:41:58.000000', 'temperatura', 18.0000, 'ºC'),
	(225922, 120, '2014-03-01 00:41:59.000000', 'temperatura', 898.0000, 'ºC'),
	(225923, 120, '2014-03-01 00:42:00.000000', 'temperatura', 834.0000, 'ºC'),
	(225924, 120, '2014-03-01 00:42:01.000000', 'temperatura', 276.0000, 'ºC'),
	(225925, 120, '2014-03-01 00:42:02.000000', 'temperatura', 79.0000, 'ºC'),
	(225926, 120, '2014-03-01 00:42:03.000000', 'temperatura', 769.0000, 'ºC'),
	(225927, 120, '2014-03-01 00:42:04.000000', 'temperatura', 8.0000, 'ºC'),
	(225928, 120, '2014-03-01 00:42:05.000000', 'temperatura', 133.0000, 'ºC'),
	(225929, 120, '2014-03-01 00:42:06.000000', 'temperatura', 641.0000, 'ºC'),
	(225930, 120, '2014-03-01 00:42:07.000000', 'temperatura', 406.0000, 'ºC'),
	(225931, 120, '2014-03-01 00:42:08.000000', 'temperatura', 107.0000, 'ºC'),
	(225932, 120, '2014-03-01 00:42:09.000000', 'temperatura', 518.0000, 'ºC'),
	(225933, 120, '2014-03-01 00:42:10.000000', 'temperatura', 1071.0000, 'ºC'),
	(225934, 120, '2014-03-01 00:42:11.000000', 'temperatura', 201.0000, 'ºC'),
	(225935, 120, '2014-03-01 00:42:12.000000', 'temperatura', 192.0000, 'ºC'),
	(225936, 120, '2014-03-01 00:42:13.000000', 'temperatura', 358.0000, 'ºC'),
	(225937, 120, '2014-03-01 00:42:14.000000', 'temperatura', 16.0000, 'ºC'),
	(225938, 120, '2014-03-01 00:42:15.000000', 'temperatura', 205.0000, 'ºC'),
	(225939, 120, '2014-03-01 00:42:16.000000', 'temperatura', 977.0000, 'ºC'),
	(225940, 120, '2014-03-01 00:42:17.000000', 'temperatura', 672.0000, 'ºC'),
	(225941, 120, '2014-03-01 00:42:18.000000', 'temperatura', 429.0000, 'ºC'),
	(225942, 120, '2014-03-01 00:42:19.000000', 'temperatura', 130.0000, 'ºC'),
	(225943, 120, '2014-03-01 00:42:20.000000', 'temperatura', 564.0000, 'ºC'),
	(225944, 120, '2014-03-01 00:42:21.000000', 'temperatura', 32.0000, 'ºC'),
	(225945, 120, '2014-03-01 00:42:22.000000', 'temperatura', 866.0000, 'ºC'),
	(225946, 120, '2014-03-01 00:42:23.000000', 'temperatura', 637.0000, 'ºC'),
	(225947, 120, '2014-03-01 00:42:24.000000', 'temperatura', 587.0000, 'ºC'),
	(225948, 120, '2014-03-01 00:42:25.000000', 'temperatura', 1022.0000, 'ºC'),
	(225949, 120, '2014-03-01 00:42:26.000000', 'temperatura', 951.0000, 'ºC'),
	(225950, 120, '2014-03-01 00:42:27.000000', 'temperatura', 491.0000, 'ºC'),
	(225951, 120, '2014-03-01 00:42:28.000000', 'temperatura', 800.0000, 'ºC'),
	(225952, 120, '2014-03-01 00:42:29.000000', 'temperatura', 128.0000, 'ºC'),
	(225953, 120, '2014-03-01 00:42:30.000000', 'temperatura', 641.0000, 'ºC'),
	(225954, 120, '2014-03-01 00:42:31.000000', 'temperatura', 423.0000, 'ºC'),
	(225955, 120, '2014-03-01 00:42:32.000000', 'temperatura', 190.0000, 'ºC'),
	(225956, 120, '2014-03-01 00:42:33.000000', 'temperatura', 881.0000, 'ºC'),
	(225957, 120, '2014-03-01 00:42:34.000000', 'temperatura', 237.0000, 'ºC'),
	(225958, 120, '2014-03-01 00:42:35.000000', 'temperatura', 942.0000, 'ºC'),
	(225959, 120, '2014-03-01 00:42:36.000000', 'temperatura', 399.0000, 'ºC'),
	(225960, 120, '2014-03-01 00:42:37.000000', 'temperatura', 368.0000, 'ºC'),
	(225961, 120, '2014-03-01 00:42:38.000000', 'temperatura', 646.0000, 'ºC'),
	(225962, 120, '2014-03-01 00:42:39.000000', 'temperatura', 924.0000, 'ºC'),
	(225963, 120, '2014-03-01 00:42:40.000000', 'temperatura', 285.0000, 'ºC'),
	(225964, 120, '2014-03-01 00:42:41.000000', 'temperatura', 1052.0000, 'ºC'),
	(225965, 120, '2014-03-01 00:42:42.000000', 'temperatura', 805.0000, 'ºC'),
	(225966, 120, '2014-03-01 00:42:43.000000', 'temperatura', 869.0000, 'ºC'),
	(225967, 120, '2014-03-01 00:42:44.000000', 'temperatura', 733.0000, 'ºC'),
	(225968, 120, '2014-03-01 00:42:45.000000', 'temperatura', 1059.0000, 'ºC'),
	(225969, 120, '2014-03-01 00:42:46.000000', 'temperatura', 696.0000, 'ºC'),
	(225970, 120, '2014-03-01 00:42:47.000000', 'temperatura', 304.0000, 'ºC'),
	(225971, 120, '2014-03-01 00:42:48.000000', 'temperatura', 630.0000, 'ºC'),
	(225972, 120, '2014-03-01 00:42:49.000000', 'temperatura', 1040.0000, 'ºC'),
	(225973, 120, '2014-03-01 00:42:50.000000', 'temperatura', 912.0000, 'ºC'),
	(225974, 120, '2014-03-01 00:42:51.000000', 'temperatura', 241.0000, 'ºC'),
	(225975, 120, '2014-03-01 00:42:52.000000', 'temperatura', 870.0000, 'ºC'),
	(225976, 120, '2014-03-01 00:42:53.000000', 'temperatura', 26.0000, 'ºC'),
	(225977, 120, '2014-03-01 00:42:54.000000', 'temperatura', 1122.0000, 'ºC'),
	(225978, 120, '2014-03-01 00:42:55.000000', 'temperatura', 733.0000, 'ºC'),
	(225979, 120, '2014-03-01 00:42:56.000000', 'temperatura', 300.0000, 'ºC'),
	(225980, 120, '2014-03-01 00:42:57.000000', 'temperatura', 500.0000, 'ºC'),
	(225981, 120, '2014-03-01 00:42:58.000000', 'temperatura', 401.0000, 'ºC'),
	(225982, 120, '2014-03-01 00:42:59.000000', 'temperatura', 505.0000, 'ºC'),
	(225983, 120, '2014-03-01 00:43:00.000000', 'temperatura', 123.0000, 'ºC'),
	(225984, 120, '2014-03-01 00:43:01.000000', 'temperatura', 301.0000, 'ºC'),
	(225985, 120, '2014-03-01 00:43:02.000000', 'temperatura', 1136.0000, 'ºC'),
	(225986, 120, '2014-03-01 00:43:03.000000', 'temperatura', 1178.0000, 'ºC'),
	(225987, 120, '2014-03-01 00:43:04.000000', 'temperatura', 81.0000, 'ºC'),
	(225988, 120, '2014-03-01 00:43:05.000000', 'temperatura', 470.0000, 'ºC'),
	(225989, 120, '2014-03-01 00:43:06.000000', 'temperatura', 911.0000, 'ºC'),
	(225990, 120, '2014-03-01 00:43:07.000000', 'temperatura', 743.0000, 'ºC'),
	(225991, 120, '2014-03-01 00:43:08.000000', 'temperatura', 983.0000, 'ºC'),
	(225992, 120, '2014-03-01 00:43:09.000000', 'temperatura', 285.0000, 'ºC'),
	(225993, 120, '2014-03-01 00:43:10.000000', 'temperatura', 877.0000, 'ºC'),
	(225994, 120, '2014-03-01 00:43:11.000000', 'temperatura', 1132.0000, 'ºC'),
	(225995, 120, '2014-03-01 00:43:12.000000', 'temperatura', 627.0000, 'ºC'),
	(225996, 120, '2014-03-01 00:43:13.000000', 'temperatura', 942.0000, 'ºC'),
	(225997, 120, '2014-03-01 00:43:14.000000', 'temperatura', 427.0000, 'ºC'),
	(225998, 120, '2014-03-01 00:43:15.000000', 'temperatura', 509.0000, 'ºC'),
	(225999, 120, '2014-03-01 00:43:16.000000', 'temperatura', 64.0000, 'ºC'),
	(226000, 120, '2014-03-01 00:43:17.000000', 'temperatura', 1195.0000, 'ºC'),
	(226001, 120, '2014-03-01 00:43:18.000000', 'temperatura', 983.0000, 'ºC'),
	(226002, 120, '2014-03-01 00:43:19.000000', 'temperatura', 131.0000, 'ºC'),
	(226003, 120, '2014-03-01 00:43:20.000000', 'temperatura', 108.0000, 'ºC'),
	(226004, 120, '2014-03-01 00:43:21.000000', 'temperatura', 146.0000, 'ºC'),
	(226005, 120, '2014-03-01 00:43:22.000000', 'temperatura', 409.0000, 'ºC'),
	(226006, 120, '2014-03-01 00:43:23.000000', 'temperatura', 405.0000, 'ºC'),
	(226007, 120, '2014-03-01 00:43:24.000000', 'temperatura', 800.0000, 'ºC'),
	(226008, 120, '2014-03-01 00:43:25.000000', 'temperatura', 386.0000, 'ºC'),
	(226009, 120, '2014-03-01 00:43:26.000000', 'temperatura', 731.0000, 'ºC'),
	(226010, 120, '2014-03-01 00:43:27.000000', 'temperatura', 97.0000, 'ºC'),
	(226011, 120, '2014-03-01 00:43:28.000000', 'temperatura', 691.0000, 'ºC'),
	(226012, 120, '2014-03-01 00:43:29.000000', 'temperatura', 765.0000, 'ºC'),
	(226013, 120, '2014-03-01 00:43:30.000000', 'temperatura', 554.0000, 'ºC'),
	(226014, 120, '2014-03-01 00:43:31.000000', 'temperatura', 473.0000, 'ºC'),
	(226015, 120, '2014-03-01 00:43:32.000000', 'temperatura', 705.0000, 'ºC'),
	(226016, 120, '2014-03-01 00:43:33.000000', 'temperatura', 906.0000, 'ºC'),
	(226017, 120, '2014-03-01 00:43:34.000000', 'temperatura', 16.0000, 'ºC'),
	(226018, 120, '2014-03-01 00:43:35.000000', 'temperatura', 961.0000, 'ºC'),
	(226019, 120, '2014-03-01 00:43:36.000000', 'temperatura', 1159.0000, 'ºC'),
	(226020, 120, '2014-03-01 00:43:37.000000', 'temperatura', 512.0000, 'ºC'),
	(226021, 120, '2014-03-01 00:43:38.000000', 'temperatura', 283.0000, 'ºC'),
	(226022, 120, '2014-03-01 00:43:39.000000', 'temperatura', 1081.0000, 'ºC'),
	(226023, 120, '2014-03-01 00:43:40.000000', 'temperatura', 957.0000, 'ºC'),
	(226024, 120, '2014-03-01 00:43:41.000000', 'temperatura', 343.0000, 'ºC'),
	(226025, 120, '2014-03-01 00:43:42.000000', 'temperatura', 45.0000, 'ºC'),
	(226026, 120, '2014-03-01 00:43:43.000000', 'temperatura', 395.0000, 'ºC'),
	(226027, 120, '2014-03-01 00:43:44.000000', 'temperatura', 641.0000, 'ºC'),
	(226028, 120, '2014-03-01 00:43:45.000000', 'temperatura', 820.0000, 'ºC'),
	(226029, 120, '2014-03-01 00:43:46.000000', 'temperatura', 979.0000, 'ºC'),
	(226030, 120, '2014-03-01 00:43:47.000000', 'temperatura', 36.0000, 'ºC'),
	(226031, 120, '2014-03-01 00:43:48.000000', 'temperatura', 841.0000, 'ºC'),
	(226032, 120, '2014-03-01 00:43:49.000000', 'temperatura', 501.0000, 'ºC'),
	(226033, 120, '2014-03-01 00:43:50.000000', 'temperatura', 1180.0000, 'ºC'),
	(226034, 120, '2014-03-01 00:43:51.000000', 'temperatura', 797.0000, 'ºC'),
	(226035, 120, '2014-03-01 00:43:52.000000', 'temperatura', 444.0000, 'ºC'),
	(226036, 120, '2014-03-01 00:43:53.000000', 'temperatura', 1032.0000, 'ºC'),
	(226037, 120, '2014-03-01 00:43:54.000000', 'temperatura', 227.0000, 'ºC'),
	(226038, 120, '2014-03-01 00:43:55.000000', 'temperatura', 442.0000, 'ºC'),
	(226039, 120, '2014-03-01 00:43:56.000000', 'temperatura', 328.0000, 'ºC'),
	(226040, 120, '2014-03-01 00:43:57.000000', 'temperatura', 317.0000, 'ºC'),
	(226041, 120, '2014-03-01 00:43:58.000000', 'temperatura', 598.0000, 'ºC'),
	(226042, 120, '2014-03-01 00:43:59.000000', 'temperatura', 841.0000, 'ºC'),
	(226043, 120, '2014-03-01 00:44:00.000000', 'temperatura', 11.0000, 'ºC'),
	(226044, 120, '2014-03-01 00:44:01.000000', 'temperatura', 1131.0000, 'ºC'),
	(226045, 120, '2014-03-01 00:44:02.000000', 'temperatura', 824.0000, 'ºC'),
	(226046, 120, '2014-03-01 00:44:03.000000', 'temperatura', 729.0000, 'ºC'),
	(226047, 120, '2014-03-01 00:44:04.000000', 'temperatura', 1172.0000, 'ºC'),
	(226048, 120, '2014-03-01 00:44:05.000000', 'temperatura', 75.0000, 'ºC'),
	(226049, 120, '2014-03-01 00:44:06.000000', 'temperatura', 457.0000, 'ºC'),
	(226050, 120, '2014-03-01 00:44:07.000000', 'temperatura', 860.0000, 'ºC'),
	(226051, 120, '2014-03-01 00:44:08.000000', 'temperatura', 530.0000, 'ºC'),
	(226052, 120, '2014-03-01 00:44:09.000000', 'temperatura', 69.0000, 'ºC'),
	(226053, 120, '2014-03-01 00:44:10.000000', 'temperatura', 1159.0000, 'ºC'),
	(226054, 120, '2014-03-01 00:44:11.000000', 'temperatura', 786.0000, 'ºC'),
	(226055, 120, '2014-03-01 00:44:12.000000', 'temperatura', 456.0000, 'ºC'),
	(226056, 120, '2014-03-01 00:44:13.000000', 'temperatura', 1120.0000, 'ºC'),
	(226057, 120, '2014-03-01 00:44:14.000000', 'temperatura', 633.0000, 'ºC'),
	(226058, 120, '2014-03-01 00:44:15.000000', 'temperatura', 1008.0000, 'ºC'),
	(226059, 120, '2014-03-01 00:44:16.000000', 'temperatura', 739.0000, 'ºC'),
	(226060, 120, '2014-03-01 00:44:17.000000', 'temperatura', 672.0000, 'ºC'),
	(226061, 120, '2014-03-01 00:44:18.000000', 'temperatura', 1143.0000, 'ºC'),
	(226062, 120, '2014-03-01 00:44:19.000000', 'temperatura', 99.0000, 'ºC'),
	(226063, 120, '2014-03-01 00:44:20.000000', 'temperatura', 666.0000, 'ºC'),
	(226064, 120, '2014-03-01 00:44:21.000000', 'temperatura', 636.0000, 'ºC'),
	(226065, 120, '2014-03-01 00:44:22.000000', 'temperatura', 1182.0000, 'ºC'),
	(226066, 120, '2014-03-01 00:44:23.000000', 'temperatura', 403.0000, 'ºC'),
	(226067, 120, '2014-03-01 00:44:24.000000', 'temperatura', 869.0000, 'ºC'),
	(226068, 120, '2014-03-01 00:44:25.000000', 'temperatura', 735.0000, 'ºC'),
	(226069, 120, '2014-03-01 00:44:26.000000', 'temperatura', 1071.0000, 'ºC'),
	(226070, 120, '2014-03-01 00:44:27.000000', 'temperatura', 750.0000, 'ºC'),
	(226071, 120, '2014-03-01 00:44:28.000000', 'temperatura', 536.0000, 'ºC'),
	(226072, 120, '2014-03-01 00:44:29.000000', 'temperatura', 432.0000, 'ºC'),
	(226073, 120, '2014-03-01 00:44:30.000000', 'temperatura', 552.0000, 'ºC'),
	(226074, 120, '2014-03-01 00:44:31.000000', 'temperatura', 264.0000, 'ºC'),
	(226075, 120, '2014-03-01 00:44:32.000000', 'temperatura', 866.0000, 'ºC'),
	(226076, 120, '2014-03-01 00:44:33.000000', 'temperatura', 1137.0000, 'ºC'),
	(226077, 120, '2014-03-01 00:44:34.000000', 'temperatura', 686.0000, 'ºC'),
	(226078, 120, '2014-03-01 00:44:35.000000', 'temperatura', 21.0000, 'ºC'),
	(226079, 120, '2014-03-01 00:44:36.000000', 'temperatura', 450.0000, 'ºC'),
	(226080, 120, '2014-03-01 00:44:37.000000', 'temperatura', 984.0000, 'ºC'),
	(226081, 120, '2014-03-01 00:44:38.000000', 'temperatura', 1170.0000, 'ºC'),
	(226082, 120, '2014-03-01 00:44:39.000000', 'temperatura', 501.0000, 'ºC'),
	(226083, 120, '2014-03-01 00:44:40.000000', 'temperatura', 197.0000, 'ºC'),
	(226084, 120, '2014-03-01 00:44:41.000000', 'temperatura', 680.0000, 'ºC'),
	(226085, 120, '2014-03-01 00:44:42.000000', 'temperatura', 408.0000, 'ºC'),
	(226086, 120, '2014-03-01 00:44:43.000000', 'temperatura', 2.0000, 'ºC'),
	(226087, 120, '2014-03-01 00:44:44.000000', 'temperatura', 1188.0000, 'ºC'),
	(226088, 120, '2014-03-01 00:44:45.000000', 'temperatura', 1136.0000, 'ºC'),
	(226089, 120, '2014-03-01 00:44:46.000000', 'temperatura', 913.0000, 'ºC'),
	(226090, 120, '2014-03-01 00:44:47.000000', 'temperatura', 1158.0000, 'ºC'),
	(226091, 120, '2014-03-01 00:44:48.000000', 'temperatura', 651.0000, 'ºC'),
	(226092, 120, '2014-03-01 00:44:49.000000', 'temperatura', 984.0000, 'ºC'),
	(226093, 120, '2014-03-01 00:44:50.000000', 'temperatura', 565.0000, 'ºC'),
	(226094, 120, '2014-03-01 00:44:51.000000', 'temperatura', 1074.0000, 'ºC'),
	(226095, 120, '2014-03-01 00:44:52.000000', 'temperatura', 74.0000, 'ºC'),
	(226096, 120, '2014-03-01 00:44:53.000000', 'temperatura', 748.0000, 'ºC'),
	(226097, 120, '2014-03-01 00:44:54.000000', 'temperatura', 1120.0000, 'ºC'),
	(226098, 120, '2014-03-01 00:44:55.000000', 'temperatura', 955.0000, 'ºC'),
	(226099, 120, '2014-03-01 00:44:56.000000', 'temperatura', 218.0000, 'ºC'),
	(226100, 120, '2014-03-01 00:44:57.000000', 'temperatura', 622.0000, 'ºC'),
	(226101, 120, '2014-03-01 00:44:58.000000', 'temperatura', 60.0000, 'ºC'),
	(226102, 120, '2014-03-01 00:44:59.000000', 'temperatura', 834.0000, 'ºC'),
	(226103, 120, '2014-03-01 00:45:00.000000', 'temperatura', 390.0000, 'ºC'),
	(226104, 120, '2014-03-01 00:45:01.000000', 'temperatura', 649.0000, 'ºC'),
	(226105, 120, '2014-03-01 00:45:02.000000', 'temperatura', 874.0000, 'ºC'),
	(226106, 120, '2014-03-01 00:45:03.000000', 'temperatura', 24.0000, 'ºC'),
	(226107, 120, '2014-03-01 00:45:04.000000', 'temperatura', 1099.0000, 'ºC'),
	(226108, 120, '2014-03-01 00:45:05.000000', 'temperatura', 625.0000, 'ºC'),
	(226109, 120, '2014-03-01 00:45:06.000000', 'temperatura', 1027.0000, 'ºC'),
	(226110, 120, '2014-03-01 00:45:07.000000', 'temperatura', 863.0000, 'ºC'),
	(226111, 120, '2014-03-01 00:45:08.000000', 'temperatura', 31.0000, 'ºC'),
	(226112, 120, '2014-03-01 00:45:09.000000', 'temperatura', 1168.0000, 'ºC'),
	(226113, 120, '2014-03-01 00:45:10.000000', 'temperatura', 945.0000, 'ºC'),
	(226114, 120, '2014-03-01 00:45:11.000000', 'temperatura', 25.0000, 'ºC'),
	(226115, 120, '2014-03-01 00:45:12.000000', 'temperatura', 889.0000, 'ºC'),
	(226116, 120, '2014-03-01 00:45:13.000000', 'temperatura', 773.0000, 'ºC'),
	(226117, 120, '2014-03-01 00:45:14.000000', 'temperatura', 1196.0000, 'ºC'),
	(226118, 120, '2014-03-01 00:45:15.000000', 'temperatura', 61.0000, 'ºC'),
	(226119, 120, '2014-03-01 00:45:16.000000', 'temperatura', 318.0000, 'ºC'),
	(226120, 120, '2014-03-01 00:45:17.000000', 'temperatura', 208.0000, 'ºC'),
	(226121, 120, '2014-03-01 00:45:18.000000', 'temperatura', 88.0000, 'ºC'),
	(226122, 120, '2014-03-01 00:45:19.000000', 'temperatura', 1016.0000, 'ºC'),
	(226123, 120, '2014-03-01 00:45:20.000000', 'temperatura', 17.0000, 'ºC'),
	(226124, 120, '2014-03-01 00:45:21.000000', 'temperatura', 635.0000, 'ºC'),
	(226125, 120, '2014-03-01 00:45:22.000000', 'temperatura', 725.0000, 'ºC'),
	(226126, 120, '2014-03-01 00:45:23.000000', 'temperatura', 519.0000, 'ºC'),
	(226127, 120, '2014-03-01 00:45:24.000000', 'temperatura', 422.0000, 'ºC'),
	(226128, 120, '2014-03-01 00:45:25.000000', 'temperatura', 555.0000, 'ºC'),
	(226129, 120, '2014-03-01 00:45:26.000000', 'temperatura', 308.0000, 'ºC'),
	(226130, 120, '2014-03-01 00:45:27.000000', 'temperatura', 1077.0000, 'ºC'),
	(226131, 120, '2014-03-01 00:45:28.000000', 'temperatura', 862.0000, 'ºC'),
	(226132, 120, '2014-03-01 00:45:29.000000', 'temperatura', 1078.0000, 'ºC'),
	(226133, 120, '2014-03-01 00:45:30.000000', 'temperatura', 405.0000, 'ºC'),
	(226134, 120, '2014-03-01 00:45:31.000000', 'temperatura', 1191.0000, 'ºC'),
	(226135, 120, '2014-03-01 00:45:32.000000', 'temperatura', 1141.0000, 'ºC'),
	(226136, 120, '2014-03-01 00:45:33.000000', 'temperatura', 933.0000, 'ºC'),
	(226137, 120, '2014-03-01 00:45:34.000000', 'temperatura', 42.0000, 'ºC'),
	(226138, 120, '2014-03-01 00:45:35.000000', 'temperatura', 1012.0000, 'ºC'),
	(226139, 120, '2014-03-01 00:45:36.000000', 'temperatura', 134.0000, 'ºC'),
	(226140, 120, '2014-03-01 00:45:37.000000', 'temperatura', 33.0000, 'ºC'),
	(226141, 120, '2014-03-01 00:45:38.000000', 'temperatura', 964.0000, 'ºC'),
	(226142, 120, '2014-03-01 00:45:39.000000', 'temperatura', 1122.0000, 'ºC'),
	(226143, 120, '2014-03-01 00:45:40.000000', 'temperatura', 318.0000, 'ºC'),
	(226144, 120, '2014-03-01 00:45:41.000000', 'temperatura', 624.0000, 'ºC'),
	(226145, 120, '2014-03-01 00:45:42.000000', 'temperatura', 967.0000, 'ºC'),
	(226146, 120, '2014-03-01 00:45:43.000000', 'temperatura', 565.0000, 'ºC'),
	(226147, 120, '2014-03-01 00:45:44.000000', 'temperatura', 1124.0000, 'ºC'),
	(226148, 120, '2014-03-01 00:45:45.000000', 'temperatura', 325.0000, 'ºC'),
	(226149, 120, '2014-03-01 00:45:46.000000', 'temperatura', 655.0000, 'ºC'),
	(226150, 120, '2014-03-01 00:45:47.000000', 'temperatura', 1102.0000, 'ºC'),
	(226151, 120, '2014-03-01 00:45:48.000000', 'temperatura', 1142.0000, 'ºC'),
	(226152, 120, '2014-03-01 00:45:49.000000', 'temperatura', 5.0000, 'ºC'),
	(226153, 120, '2014-03-01 00:45:50.000000', 'temperatura', 201.0000, 'ºC'),
	(226154, 120, '2014-03-01 00:45:51.000000', 'temperatura', 991.0000, 'ºC'),
	(226155, 120, '2014-03-01 00:45:52.000000', 'temperatura', 753.0000, 'ºC'),
	(226156, 120, '2014-03-01 00:45:53.000000', 'temperatura', 791.0000, 'ºC'),
	(226157, 120, '2014-03-01 00:45:54.000000', 'temperatura', 495.0000, 'ºC'),
	(226158, 120, '2014-03-01 00:45:55.000000', 'temperatura', 105.0000, 'ºC'),
	(226159, 120, '2014-03-01 00:45:56.000000', 'temperatura', 241.0000, 'ºC'),
	(226160, 120, '2014-03-01 00:45:57.000000', 'temperatura', 891.0000, 'ºC'),
	(226161, 120, '2014-03-01 00:45:58.000000', 'temperatura', 132.0000, 'ºC'),
	(226162, 120, '2014-03-01 00:45:59.000000', 'temperatura', 387.0000, 'ºC'),
	(226163, 120, '2014-03-01 00:46:00.000000', 'temperatura', 341.0000, 'ºC'),
	(226164, 120, '2014-03-01 00:46:01.000000', 'temperatura', 545.0000, 'ºC'),
	(226165, 120, '2014-03-01 00:46:02.000000', 'temperatura', 503.0000, 'ºC'),
	(226166, 120, '2014-03-01 00:46:03.000000', 'temperatura', 880.0000, 'ºC'),
	(226167, 120, '2014-03-01 00:46:04.000000', 'temperatura', 490.0000, 'ºC'),
	(226168, 120, '2014-03-01 00:46:05.000000', 'temperatura', 1013.0000, 'ºC'),
	(226169, 120, '2014-03-01 00:46:06.000000', 'temperatura', 1193.0000, 'ºC'),
	(226170, 120, '2014-03-01 00:46:07.000000', 'temperatura', 526.0000, 'ºC'),
	(226171, 120, '2014-03-01 00:46:08.000000', 'temperatura', 253.0000, 'ºC'),
	(226172, 120, '2014-03-01 00:46:09.000000', 'temperatura', 888.0000, 'ºC'),
	(226173, 120, '2014-03-01 00:46:10.000000', 'temperatura', 83.0000, 'ºC'),
	(226174, 120, '2014-03-01 00:46:11.000000', 'temperatura', 150.0000, 'ºC'),
	(226175, 120, '2014-03-01 00:46:12.000000', 'temperatura', 502.0000, 'ºC'),
	(226176, 120, '2014-03-01 00:46:13.000000', 'temperatura', 861.0000, 'ºC'),
	(226177, 120, '2014-03-01 00:46:14.000000', 'temperatura', 399.0000, 'ºC'),
	(226178, 120, '2014-03-01 00:46:15.000000', 'temperatura', 614.0000, 'ºC'),
	(226179, 120, '2014-03-01 00:46:16.000000', 'temperatura', 674.0000, 'ºC'),
	(226180, 120, '2014-03-01 00:46:17.000000', 'temperatura', 329.0000, 'ºC'),
	(226181, 120, '2014-03-01 00:46:18.000000', 'temperatura', 824.0000, 'ºC'),
	(226182, 120, '2014-03-01 00:46:19.000000', 'temperatura', 732.0000, 'ºC'),
	(226183, 120, '2014-03-01 00:46:20.000000', 'temperatura', 1190.0000, 'ºC'),
	(226184, 120, '2014-03-01 00:46:21.000000', 'temperatura', 155.0000, 'ºC'),
	(226185, 120, '2014-03-01 00:46:22.000000', 'temperatura', 805.0000, 'ºC'),
	(226186, 120, '2014-03-01 00:46:23.000000', 'temperatura', 1159.0000, 'ºC'),
	(226187, 120, '2014-03-01 00:46:24.000000', 'temperatura', 983.0000, 'ºC'),
	(226188, 120, '2014-03-01 00:46:25.000000', 'temperatura', 239.0000, 'ºC'),
	(226189, 120, '2014-03-01 00:46:26.000000', 'temperatura', 644.0000, 'ºC'),
	(226190, 120, '2014-03-01 00:46:27.000000', 'temperatura', 106.0000, 'ºC'),
	(226191, 120, '2014-03-01 00:46:28.000000', 'temperatura', 998.0000, 'ºC'),
	(226192, 120, '2014-03-01 00:46:29.000000', 'temperatura', 1074.0000, 'ºC'),
	(226193, 120, '2014-03-01 00:46:30.000000', 'temperatura', 1175.0000, 'ºC'),
	(226194, 120, '2014-03-01 00:46:31.000000', 'temperatura', 253.0000, 'ºC'),
	(226195, 120, '2014-03-01 00:46:32.000000', 'temperatura', 141.0000, 'ºC'),
	(226196, 120, '2014-03-01 00:46:33.000000', 'temperatura', 1146.0000, 'ºC'),
	(226197, 120, '2014-03-01 00:46:34.000000', 'temperatura', 509.0000, 'ºC'),
	(226198, 120, '2014-03-01 00:46:35.000000', 'temperatura', 307.0000, 'ºC'),
	(226199, 120, '2014-03-01 00:46:36.000000', 'temperatura', 7.0000, 'ºC'),
	(226200, 120, '2014-03-01 00:46:37.000000', 'temperatura', 317.0000, 'ºC'),
	(226201, 120, '2014-03-01 00:46:38.000000', 'temperatura', 362.0000, 'ºC'),
	(226202, 120, '2014-03-01 00:46:39.000000', 'temperatura', 862.0000, 'ºC'),
	(226203, 120, '2014-03-01 00:46:40.000000', 'temperatura', 824.0000, 'ºC'),
	(226204, 120, '2014-03-01 00:46:41.000000', 'temperatura', 334.0000, 'ºC'),
	(226205, 120, '2014-03-01 00:46:42.000000', 'temperatura', 398.0000, 'ºC'),
	(226206, 120, '2014-03-01 00:46:43.000000', 'temperatura', 988.0000, 'ºC'),
	(226207, 120, '2014-03-01 00:46:44.000000', 'temperatura', 149.0000, 'ºC'),
	(226208, 120, '2014-03-01 00:46:45.000000', 'temperatura', 179.0000, 'ºC'),
	(226209, 120, '2014-03-01 00:46:46.000000', 'temperatura', 449.0000, 'ºC'),
	(226210, 120, '2014-03-01 00:46:47.000000', 'temperatura', 507.0000, 'ºC'),
	(226211, 120, '2014-03-01 00:46:48.000000', 'temperatura', 1188.0000, 'ºC'),
	(226212, 120, '2014-03-01 00:46:49.000000', 'temperatura', 821.0000, 'ºC'),
	(226213, 120, '2014-03-01 00:46:50.000000', 'temperatura', 542.0000, 'ºC'),
	(226214, 120, '2014-03-01 00:46:51.000000', 'temperatura', 249.0000, 'ºC'),
	(226215, 120, '2014-03-01 00:46:52.000000', 'temperatura', 817.0000, 'ºC'),
	(226216, 120, '2014-03-01 00:46:53.000000', 'temperatura', 940.0000, 'ºC'),
	(226217, 120, '2014-03-01 00:46:54.000000', 'temperatura', 1051.0000, 'ºC'),
	(226218, 120, '2014-03-01 00:46:55.000000', 'temperatura', 32.0000, 'ºC'),
	(226219, 120, '2014-03-01 00:46:56.000000', 'temperatura', 611.0000, 'ºC'),
	(226220, 120, '2014-03-01 00:46:57.000000', 'temperatura', 558.0000, 'ºC'),
	(226221, 120, '2014-03-01 00:46:58.000000', 'temperatura', 956.0000, 'ºC'),
	(226222, 120, '2014-03-01 00:46:59.000000', 'temperatura', 706.0000, 'ºC'),
	(226223, 120, '2014-03-01 00:47:00.000000', 'temperatura', 664.0000, 'ºC'),
	(226224, 120, '2014-03-01 00:47:01.000000', 'temperatura', 3.0000, 'ºC'),
	(226225, 120, '2014-03-01 00:47:02.000000', 'temperatura', 421.0000, 'ºC'),
	(226226, 120, '2014-03-01 00:47:03.000000', 'temperatura', 899.0000, 'ºC'),
	(226227, 120, '2014-03-01 00:47:04.000000', 'temperatura', 834.0000, 'ºC'),
	(226228, 120, '2014-03-01 00:47:05.000000', 'temperatura', 271.0000, 'ºC'),
	(226229, 120, '2014-03-01 00:47:06.000000', 'temperatura', 54.0000, 'ºC'),
	(226230, 120, '2014-03-01 00:47:07.000000', 'temperatura', 656.0000, 'ºC'),
	(226231, 120, '2014-03-01 00:47:08.000000', 'temperatura', 719.0000, 'ºC'),
	(226232, 120, '2014-03-01 00:47:09.000000', 'temperatura', 428.0000, 'ºC'),
	(226233, 120, '2014-03-01 00:47:10.000000', 'temperatura', 1184.0000, 'ºC'),
	(226234, 120, '2014-03-01 00:47:11.000000', 'temperatura', 1034.0000, 'ºC'),
	(226235, 120, '2014-03-01 00:47:12.000000', 'temperatura', 421.0000, 'ºC'),
	(226236, 120, '2014-03-01 00:47:13.000000', 'temperatura', 204.0000, 'ºC'),
	(226237, 120, '2014-03-01 00:47:14.000000', 'temperatura', 958.0000, 'ºC'),
	(226238, 120, '2014-03-01 00:47:15.000000', 'temperatura', 576.0000, 'ºC'),
	(226239, 120, '2014-03-01 00:47:16.000000', 'temperatura', 9.0000, 'ºC'),
	(226240, 120, '2014-03-01 00:47:17.000000', 'temperatura', 719.0000, 'ºC'),
	(226241, 120, '2014-03-01 00:47:18.000000', 'temperatura', 1165.0000, 'ºC'),
	(226242, 120, '2014-03-01 00:47:19.000000', 'temperatura', 69.0000, 'ºC'),
	(226243, 120, '2014-03-01 00:47:20.000000', 'temperatura', 453.0000, 'ºC'),
	(226244, 120, '2014-03-01 00:47:21.000000', 'temperatura', 857.0000, 'ºC'),
	(226245, 120, '2014-03-01 00:47:22.000000', 'temperatura', 527.0000, 'ºC'),
	(226246, 120, '2014-03-01 00:47:23.000000', 'temperatura', 63.0000, 'ºC'),
	(226247, 120, '2014-03-01 00:47:24.000000', 'temperatura', 1137.0000, 'ºC'),
	(226248, 120, '2014-03-01 00:47:25.000000', 'temperatura', 697.0000, 'ºC'),
	(226249, 120, '2014-03-01 00:47:26.000000', 'temperatura', 71.0000, 'ºC'),
	(226250, 120, '2014-03-01 00:47:27.000000', 'temperatura', 668.0000, 'ºC'),
	(226251, 120, '2014-03-01 00:47:28.000000', 'temperatura', 727.0000, 'ºC'),
	(226252, 120, '2014-03-01 00:47:29.000000', 'temperatura', 430.0000, 'ºC'),
	(226253, 120, '2014-03-01 00:47:30.000000', 'temperatura', 1172.0000, 'ºC'),
	(226254, 120, '2014-03-01 00:47:31.000000', 'temperatura', 970.0000, 'ºC'),
	(226255, 120, '2014-03-01 00:47:32.000000', 'temperatura', 135.0000, 'ºC'),
	(226256, 120, '2014-03-01 00:47:33.000000', 'temperatura', 163.0000, 'ºC'),
	(226257, 120, '2014-03-01 00:47:34.000000', 'temperatura', 413.0000, 'ºC'),
	(226258, 120, '2014-03-01 00:47:35.000000', 'temperatura', 378.0000, 'ºC'),
	(226259, 120, '2014-03-01 00:47:36.000000', 'temperatura', 648.0000, 'ºC'),
	(226260, 120, '2014-03-01 00:47:37.000000', 'temperatura', 909.0000, 'ºC'),
	(226261, 120, '2014-03-01 00:47:38.000000', 'temperatura', 201.0000, 'ºC'),
	(226262, 120, '2014-03-01 00:47:39.000000', 'temperatura', 678.0000, 'ºC'),
	(226263, 120, '2014-03-01 00:47:40.000000', 'temperatura', 388.0000, 'ºC'),
	(226264, 120, '2014-03-01 00:47:41.000000', 'temperatura', 1108.0000, 'ºC'),
	(226265, 120, '2014-03-01 00:47:42.000000', 'temperatura', 775.0000, 'ºC'),
	(226266, 120, '2014-03-01 00:47:43.000000', 'temperatura', 551.0000, 'ºC'),
	(226267, 120, '2014-03-01 00:47:44.000000', 'temperatura', 429.0000, 'ºC'),
	(226268, 120, '2014-03-01 00:47:45.000000', 'temperatura', 496.0000, 'ºC'),
	(226269, 120, '2014-03-01 00:47:46.000000', 'temperatura', 1190.0000, 'ºC'),
	(226270, 120, '2014-03-01 00:47:47.000000', 'temperatura', 864.0000, 'ºC'),
	(226271, 120, '2014-03-01 00:47:48.000000', 'temperatura', 751.0000, 'ºC'),
	(226272, 120, '2014-03-01 00:47:49.000000', 'temperatura', 1162.0000, 'ºC'),
	(226273, 120, '2014-03-01 00:47:50.000000', 'temperatura', 1160.0000, 'ºC'),
	(226274, 120, '2014-03-01 00:47:51.000000', 'temperatura', 1115.0000, 'ºC'),
	(226275, 120, '2014-03-01 00:47:52.000000', 'temperatura', 894.0000, 'ºC'),
	(226276, 120, '2014-03-01 00:47:53.000000', 'temperatura', 1124.0000, 'ºC'),
	(226277, 120, '2014-03-01 00:47:54.000000', 'temperatura', 541.0000, 'ºC'),
	(226278, 120, '2014-03-01 00:47:55.000000', 'temperatura', 535.0000, 'ºC'),
	(226279, 120, '2014-03-01 00:47:56.000000', 'temperatura', 1049.0000, 'ºC'),
	(226280, 120, '2014-03-01 00:47:57.000000', 'temperatura', 44.0000, 'ºC'),
	(226281, 120, '2014-03-01 00:47:58.000000', 'temperatura', 671.0000, 'ºC'),
	(226282, 120, '2014-03-01 00:47:59.000000', 'temperatura', 826.0000, 'ºC'),
	(226283, 120, '2014-03-01 00:48:00.000000', 'temperatura', 915.0000, 'ºC'),
	(226284, 120, '2014-03-01 00:48:01.000000', 'temperatura', 897.0000, 'ºC'),
	(226285, 120, '2014-03-01 00:48:02.000000', 'temperatura', 542.0000, 'ºC'),
	(226286, 120, '2014-03-01 00:48:03.000000', 'temperatura', 20.0000, 'ºC'),
	(226287, 120, '2014-03-01 00:48:04.000000', 'temperatura', 873.0000, 'ºC'),
	(226288, 120, '2014-03-01 00:48:05.000000', 'temperatura', 705.0000, 'ºC'),
	(226289, 120, '2014-03-01 00:48:06.000000', 'temperatura', 909.0000, 'ºC'),
	(226290, 120, '2014-03-01 00:48:07.000000', 'temperatura', 28.0000, 'ºC'),
	(226291, 120, '2014-03-01 00:48:08.000000', 'temperatura', 1015.0000, 'ºC'),
	(226292, 120, '2014-03-01 00:48:09.000000', 'temperatura', 191.0000, 'ºC'),
	(226293, 120, '2014-03-01 00:48:10.000000', 'temperatura', 312.0000, 'ºC'),
	(226294, 120, '2014-03-01 00:48:11.000000', 'temperatura', 984.0000, 'ºC'),
	(226295, 120, '2014-03-01 00:48:12.000000', 'temperatura', 388.0000, 'ºC'),
	(226296, 120, '2014-03-01 00:48:13.000000', 'temperatura', 188.0000, 'ºC'),
	(226297, 120, '2014-03-01 00:48:14.000000', 'temperatura', 977.0000, 'ºC'),
	(226298, 120, '2014-03-01 00:48:15.000000', 'temperatura', 722.0000, 'ºC'),
	(226299, 120, '2014-03-01 00:48:16.000000', 'temperatura', 681.0000, 'ºC'),
	(226300, 120, '2014-03-01 00:48:17.000000', 'temperatura', 36.0000, 'ºC'),
	(226301, 120, '2014-03-01 00:48:18.000000', 'temperatura', 541.0000, 'ºC'),
	(226302, 120, '2014-03-01 00:48:19.000000', 'temperatura', 195.0000, 'ºC'),
	(226303, 120, '2014-03-01 00:48:20.000000', 'temperatura', 553.0000, 'ºC'),
	(226304, 120, '2014-03-01 00:48:21.000000', 'temperatura', 981.0000, 'ºC'),
	(226305, 120, '2014-03-01 00:48:22.000000', 'temperatura', 844.0000, 'ºC'),
	(226306, 120, '2014-03-01 00:48:23.000000', 'temperatura', 80.0000, 'ºC'),
	(226307, 120, '2014-03-01 00:48:24.000000', 'temperatura', 266.0000, 'ºC'),
	(226308, 120, '2014-03-01 00:48:25.000000', 'temperatura', 1093.0000, 'ºC'),
	(226309, 120, '2014-03-01 00:48:26.000000', 'temperatura', 1065.0000, 'ºC'),
	(226310, 120, '2014-03-01 00:48:27.000000', 'temperatura', 850.0000, 'ºC'),
	(226311, 120, '2014-03-01 00:48:28.000000', 'temperatura', 1053.0000, 'ºC'),
	(226312, 120, '2014-03-01 00:48:29.000000', 'temperatura', 315.0000, 'ºC'),
	(226313, 120, '2014-03-01 00:48:30.000000', 'temperatura', 816.0000, 'ºC'),
	(226314, 120, '2014-03-01 00:48:31.000000', 'temperatura', 736.0000, 'ºC'),
	(226315, 120, '2014-03-01 00:48:32.000000', 'temperatura', 32.0000, 'ºC'),
	(226316, 120, '2014-03-01 00:48:33.000000', 'temperatura', 352.0000, 'ºC'),
	(226317, 120, '2014-03-01 00:48:34.000000', 'temperatura', 464.0000, 'ºC'),
	(226318, 120, '2014-03-01 00:48:35.000000', 'temperatura', 66.0000, 'ºC'),
	(226319, 120, '2014-03-01 00:48:36.000000', 'temperatura', 139.0000, 'ºC'),
	(226320, 120, '2014-03-01 00:48:37.000000', 'temperatura', 498.0000, 'ºC'),
	(226321, 120, '2014-03-01 00:48:38.000000', 'temperatura', 873.0000, 'ºC'),
	(226322, 120, '2014-03-01 00:48:39.000000', 'temperatura', 470.0000, 'ºC'),
	(226323, 120, '2014-03-01 00:48:40.000000', 'temperatura', 933.0000, 'ºC'),
	(226324, 120, '2014-03-01 00:48:41.000000', 'temperatura', 856.0000, 'ºC'),
	(226325, 120, '2014-03-01 00:48:42.000000', 'temperatura', 283.0000, 'ºC'),
	(226326, 120, '2014-03-01 00:48:43.000000', 'temperatura', 44.0000, 'ºC'),
	(226327, 120, '2014-03-01 00:48:44.000000', 'temperatura', 572.0000, 'ºC'),
	(226328, 120, '2014-03-01 00:48:45.000000', 'temperatura', 331.0000, 'ºC'),
	(226329, 120, '2014-03-01 00:48:46.000000', 'temperatura', 1139.0000, 'ºC'),
	(226330, 120, '2014-03-01 00:48:47.000000', 'temperatura', 1104.0000, 'ºC'),
	(226331, 120, '2014-03-01 00:48:48.000000', 'temperatura', 900.0000, 'ºC'),
	(226332, 120, '2014-03-01 00:48:49.000000', 'temperatura', 1191.0000, 'ºC'),
	(226333, 120, '2014-03-01 00:48:50.000000', 'temperatura', 853.0000, 'ºC'),
	(226334, 120, '2014-03-01 00:48:51.000000', 'temperatura', 694.0000, 'ºC'),
	(226335, 120, '2014-03-01 00:48:52.000000', 'temperatura', 909.0000, 'ºC'),
	(226336, 120, '2014-03-01 00:48:53.000000', 'temperatura', 66.0000, 'ºC'),
	(226337, 120, '2014-03-01 00:48:54.000000', 'temperatura', 2.0000, 'ºC'),
	(226338, 120, '2014-03-01 00:48:55.000000', 'temperatura', 1015.0000, 'ºC'),
	(226339, 120, '2014-03-01 00:48:56.000000', 'temperatura', 268.0000, 'ºC'),
	(226340, 120, '2014-03-01 00:48:57.000000', 'temperatura', 694.0000, 'ºC'),
	(226341, 120, '2014-03-01 00:48:58.000000', 'temperatura', 268.0000, 'ºC'),
	(226342, 120, '2014-03-01 00:48:59.000000', 'temperatura', 458.0000, 'ºC'),
	(226343, 120, '2014-03-01 00:49:00.000000', 'temperatura', 286.0000, 'ºC'),
	(226344, 120, '2014-03-01 00:49:01.000000', 'temperatura', 56.0000, 'ºC'),
	(226345, 120, '2014-03-01 00:49:02.000000', 'temperatura', 621.0000, 'ºC'),
	(226346, 120, '2014-03-01 00:49:03.000000', 'temperatura', 540.0000, 'ºC'),
	(226347, 120, '2014-03-01 00:49:04.000000', 'temperatura', 836.0000, 'ºC'),
	(226348, 120, '2014-03-01 00:49:05.000000', 'temperatura', 161.0000, 'ºC'),
	(226349, 120, '2014-03-01 00:49:06.000000', 'temperatura', 699.0000, 'ºC'),
	(226350, 120, '2014-03-01 00:49:07.000000', 'temperatura', 611.0000, 'ºC'),
	(226351, 120, '2014-03-01 00:49:08.000000', 'temperatura', 958.0000, 'ºC'),
	(226352, 120, '2014-03-01 00:49:09.000000', 'temperatura', 559.0000, 'ºC'),
	(226353, 120, '2014-03-01 00:49:10.000000', 'temperatura', 1123.0000, 'ºC'),
	(226354, 120, '2014-03-01 00:49:11.000000', 'temperatura', 335.0000, 'ºC'),
	(226355, 120, '2014-03-01 00:49:12.000000', 'temperatura', 710.0000, 'ºC'),
	(226356, 120, '2014-03-01 00:49:13.000000', 'temperatura', 143.0000, 'ºC'),
	(226357, 120, '2014-03-01 00:49:14.000000', 'temperatura', 986.0000, 'ºC'),
	(226358, 120, '2014-03-01 00:49:15.000000', 'temperatura', 901.0000, 'ºC'),
	(226359, 120, '2014-03-01 00:49:16.000000', 'temperatura', 350.0000, 'ºC'),
	(226360, 120, '2014-03-01 00:49:17.000000', 'temperatura', 244.0000, 'ºC'),
	(226361, 120, '2014-03-01 00:49:18.000000', 'temperatura', 173.0000, 'ºC'),
	(226362, 120, '2014-03-01 00:49:19.000000', 'temperatura', 133.0000, 'ºC'),
	(226363, 120, '2014-03-01 00:49:20.000000', 'temperatura', 144.0000, 'ºC'),
	(226364, 120, '2014-03-01 00:49:21.000000', 'temperatura', 325.0000, 'ºC'),
	(226365, 120, '2014-03-01 00:49:22.000000', 'temperatura', 1193.0000, 'ºC'),
	(226366, 120, '2014-03-01 00:49:23.000000', 'temperatura', 190.0000, 'ºC'),
	(226367, 120, '2014-03-01 00:49:24.000000', 'temperatura', 970.0000, 'ºC'),
	(226368, 120, '2014-03-01 00:49:25.000000', 'temperatura', 682.0000, 'ºC'),
	(226369, 120, '2014-03-01 00:49:26.000000', 'temperatura', 500.0000, 'ºC'),
	(226370, 120, '2014-03-01 00:49:27.000000', 'temperatura', 456.0000, 'ºC'),
	(226371, 120, '2014-03-01 00:49:28.000000', 'temperatura', 778.0000, 'ºC'),
	(226372, 120, '2014-03-01 00:49:29.000000', 'temperatura', 122.0000, 'ºC'),
	(226373, 120, '2014-03-01 00:49:30.000000', 'temperatura', 679.0000, 'ºC'),
	(226374, 120, '2014-03-01 00:49:31.000000', 'temperatura', 630.0000, 'ºC'),
	(226375, 120, '2014-03-01 00:49:32.000000', 'temperatura', 1114.0000, 'ºC'),
	(226376, 120, '2014-03-01 00:49:33.000000', 'temperatura', 78.0000, 'ºC'),
	(226377, 120, '2014-03-01 00:49:34.000000', 'temperatura', 651.0000, 'ºC'),
	(226378, 120, '2014-03-01 00:49:35.000000', 'temperatura', 619.0000, 'ºC'),
	(226379, 120, '2014-03-01 00:49:36.000000', 'temperatura', 1143.0000, 'ºC'),
	(226380, 120, '2014-03-01 00:49:37.000000', 'temperatura', 257.0000, 'ºC'),
	(226381, 120, '2014-03-01 00:49:38.000000', 'temperatura', 258.0000, 'ºC'),
	(226382, 120, '2014-03-01 00:49:39.000000', 'temperatura', 521.0000, 'ºC'),
	(226383, 120, '2014-03-01 00:49:40.000000', 'temperatura', 628.0000, 'ºC'),
	(226384, 120, '2014-03-01 00:49:41.000000', 'temperatura', 381.0000, 'ºC'),
	(226385, 120, '2014-03-01 00:49:42.000000', 'temperatura', 19.0000, 'ºC'),
	(226386, 120, '2014-03-01 00:49:43.000000', 'temperatura', 154.0000, 'ºC'),
	(226387, 120, '2014-03-01 00:49:44.000000', 'temperatura', 713.0000, 'ºC'),
	(226388, 120, '2014-03-01 00:49:45.000000', 'temperatura', 702.0000, 'ºC'),
	(226389, 120, '2014-03-01 00:49:46.000000', 'temperatura', 174.0000, 'ºC'),
	(226390, 120, '2014-03-01 00:49:47.000000', 'temperatura', 1165.0000, 'ºC'),
	(226391, 120, '2014-03-01 00:49:48.000000', 'temperatura', 502.0000, 'ºC'),
	(226392, 120, '2014-03-01 00:49:49.000000', 'temperatura', 215.0000, 'ºC'),
	(226393, 120, '2014-03-01 00:49:50.000000', 'temperatura', 772.0000, 'ºC'),
	(226394, 120, '2014-03-01 00:49:51.000000', 'temperatura', 812.0000, 'ºC'),
	(226395, 120, '2014-03-01 00:49:52.000000', 'temperatura', 547.0000, 'ºC'),
	(226396, 120, '2014-03-01 00:49:53.000000', 'temperatura', 298.0000, 'ºC'),
	(226397, 120, '2014-03-01 00:49:54.000000', 'temperatura', 1050.0000, 'ºC'),
	(226398, 120, '2014-03-01 00:49:55.000000', 'temperatura', 755.0000, 'ºC'),
	(226399, 120, '2014-03-01 00:49:56.000000', 'temperatura', 626.0000, 'ºC'),
	(226400, 120, '2014-03-01 00:49:57.000000', 'temperatura', 865.0000, 'ºC'),
	(226401, 120, '2014-03-01 00:49:58.000000', 'temperatura', 49.0000, 'ºC'),
	(226402, 120, '2014-03-01 00:49:59.000000', 'temperatura', 51.0000, 'ºC'),
	(226403, 120, '2014-03-01 00:50:00.000000', 'temperatura', 110.0000, 'ºC'),
	(226404, 120, '2014-03-01 00:50:01.000000', 'temperatura', 395.0000, 'ºC'),
	(226405, 120, '2014-03-01 00:50:02.000000', 'temperatura', 445.0000, 'ºC'),
	(226406, 120, '2014-03-01 00:50:03.000000', 'temperatura', 1040.0000, 'ºC'),
	(226407, 120, '2014-03-01 00:50:04.000000', 'temperatura', 267.0000, 'ºC'),
	(226408, 120, '2014-03-01 00:50:05.000000', 'temperatura', 617.0000, 'ºC'),
	(226409, 120, '2014-03-01 00:50:06.000000', 'temperatura', 1083.0000, 'ºC'),
	(226410, 120, '2014-03-01 00:50:07.000000', 'temperatura', 1166.0000, 'ºC'),
	(226411, 120, '2014-03-01 00:50:08.000000', 'temperatura', 179.0000, 'ºC'),
	(226412, 120, '2014-03-01 00:50:09.000000', 'temperatura', 999.0000, 'ºC'),
	(226413, 120, '2014-03-01 00:50:10.000000', 'temperatura', 857.0000, 'ºC'),
	(226414, 120, '2014-03-01 00:50:11.000000', 'temperatura', 91.0000, 'ºC'),
	(226415, 120, '2014-03-01 00:50:12.000000', 'temperatura', 282.0000, 'ºC'),
	(226416, 120, '2014-03-01 00:50:13.000000', 'temperatura', 1140.0000, 'ºC'),
	(226417, 120, '2014-03-01 00:50:14.000000', 'temperatura', 53.0000, 'ºC'),
	(226418, 120, '2014-03-01 00:50:15.000000', 'temperatura', 448.0000, 'ºC'),
	(226419, 120, '2014-03-01 00:50:16.000000', 'temperatura', 879.0000, 'ºC'),
	(226420, 120, '2014-03-01 00:50:17.000000', 'temperatura', 654.0000, 'ºC'),
	(226421, 120, '2014-03-01 00:50:18.000000', 'temperatura', 630.0000, 'ºC'),
	(226422, 120, '2014-03-01 00:50:19.000000', 'temperatura', 1191.0000, 'ºC'),
	(226423, 120, '2014-03-01 00:50:20.000000', 'temperatura', 465.0000, 'ºC'),
	(226424, 120, '2014-03-01 00:50:21.000000', 'temperatura', 1152.0000, 'ºC'),
	(226425, 120, '2014-03-01 00:50:22.000000', 'temperatura', 767.0000, 'ºC'),
	(226426, 120, '2014-03-01 00:50:23.000000', 'temperatura', 380.0000, 'ºC'),
	(226427, 120, '2014-03-01 00:50:24.000000', 'temperatura', 799.0000, 'ºC'),
	(226428, 120, '2014-03-01 00:50:25.000000', 'temperatura', 456.0000, 'ºC'),
	(226429, 120, '2014-03-01 00:50:26.000000', 'temperatura', 1082.0000, 'ºC'),
	(226430, 120, '2014-03-01 00:50:27.000000', 'temperatura', 442.0000, 'ºC'),
	(226431, 120, '2014-03-01 00:50:28.000000', 'temperatura', 166.0000, 'ºC'),
	(226432, 120, '2014-03-01 00:50:29.000000', 'temperatura', 703.0000, 'ºC'),
	(226433, 120, '2014-03-01 00:50:30.000000', 'temperatura', 619.0000, 'ºC'),
	(226434, 120, '2014-03-01 00:50:31.000000', 'temperatura', 985.0000, 'ºC'),
	(226435, 120, '2014-03-01 00:50:32.000000', 'temperatura', 667.0000, 'ºC'),
	(226436, 120, '2014-03-01 00:50:33.000000', 'temperatura', 384.0000, 'ºC'),
	(226437, 120, '2014-03-01 00:50:34.000000', 'temperatura', 1116.0000, 'ºC'),
	(226438, 120, '2014-03-01 00:50:35.000000', 'temperatura', 832.0000, 'ºC'),
	(226439, 120, '2014-03-01 00:50:36.000000', 'temperatura', 810.0000, 'ºC'),
	(226440, 120, '2014-03-01 00:50:37.000000', 'temperatura', 357.0000, 'ºC'),
	(226441, 120, '2014-03-01 00:50:38.000000', 'temperatura', 555.0000, 'ºC'),
	(226442, 120, '2014-03-01 00:50:39.000000', 'temperatura', 505.0000, 'ºC'),
	(226443, 120, '2014-03-01 00:50:40.000000', 'temperatura', 860.0000, 'ºC'),
	(226444, 120, '2014-03-01 00:50:41.000000', 'temperatura', 385.0000, 'ºC'),
	(226445, 120, '2014-03-01 00:50:42.000000', 'temperatura', 547.0000, 'ºC'),
	(226446, 120, '2014-03-01 00:50:43.000000', 'temperatura', 379.0000, 'ºC'),
	(226447, 120, '2014-03-01 00:50:44.000000', 'temperatura', 253.0000, 'ºC'),
	(226448, 120, '2014-03-01 00:50:45.000000', 'temperatura', 131.0000, 'ºC'),
	(226449, 120, '2014-03-01 00:50:46.000000', 'temperatura', 1095.0000, 'ºC'),
	(226450, 120, '2014-03-01 00:50:47.000000', 'temperatura', 285.0000, 'ºC'),
	(226451, 120, '2014-03-01 00:50:48.000000', 'temperatura', 538.0000, 'ºC'),
	(226452, 120, '2014-03-01 00:50:49.000000', 'temperatura', 636.0000, 'ºC'),
	(226453, 120, '2014-03-01 00:50:50.000000', 'temperatura', 366.0000, 'ºC'),
	(226454, 120, '2014-03-01 00:50:51.000000', 'temperatura', 1122.0000, 'ºC'),
	(226455, 120, '2014-03-01 00:50:52.000000', 'temperatura', 911.0000, 'ºC'),
	(226456, 120, '2014-03-01 00:50:53.000000', 'temperatura', 1192.0000, 'ºC'),
	(226457, 120, '2014-03-01 00:50:54.000000', 'temperatura', 826.0000, 'ºC'),
	(226458, 120, '2014-03-01 00:50:55.000000', 'temperatura', 555.0000, 'ºC'),
	(226459, 120, '2014-03-01 00:50:56.000000', 'temperatura', 299.0000, 'ºC'),
	(226460, 120, '2014-03-01 00:50:57.000000', 'temperatura', 1031.0000, 'ºC'),
	(226461, 120, '2014-03-01 00:50:58.000000', 'temperatura', 657.0000, 'ºC'),
	(226462, 120, '2014-03-01 00:50:59.000000', 'temperatura', 194.0000, 'ºC'),
	(226463, 120, '2014-03-01 00:51:00.000000', 'temperatura', 198.0000, 'ºC'),
	(226464, 120, '2014-03-01 00:51:01.000000', 'temperatura', 409.0000, 'ºC'),
	(226465, 120, '2014-03-01 00:51:02.000000', 'temperatura', 251.0000, 'ºC'),
	(226466, 120, '2014-03-01 00:51:03.000000', 'temperatura', 30.0000, 'ºC'),
	(226467, 120, '2014-03-01 00:51:04.000000', 'temperatura', 598.0000, 'ºC'),
	(226468, 120, '2014-03-01 00:51:05.000000', 'temperatura', 501.0000, 'ºC'),
	(226469, 120, '2014-03-01 00:51:06.000000', 'temperatura', 709.0000, 'ºC'),
	(226470, 120, '2014-03-01 00:51:07.000000', 'temperatura', 841.0000, 'ºC'),
	(226471, 120, '2014-03-01 00:51:08.000000', 'temperatura', 882.0000, 'ºC'),
	(226472, 120, '2014-03-01 00:51:09.000000', 'temperatura', 688.0000, 'ºC'),
	(226473, 120, '2014-03-01 00:51:10.000000', 'temperatura', 791.0000, 'ºC'),
	(226474, 120, '2014-03-01 00:51:11.000000', 'temperatura', 694.0000, 'ºC'),
	(226475, 120, '2014-03-01 00:51:12.000000', 'temperatura', 1097.0000, 'ºC'),
	(226476, 120, '2014-03-01 00:51:13.000000', 'temperatura', 1004.0000, 'ºC'),
	(226477, 120, '2014-03-01 00:51:14.000000', 'temperatura', 529.0000, 'ºC'),
	(226478, 120, '2014-03-01 00:51:15.000000', 'temperatura', 833.0000, 'ºC'),
	(226479, 120, '2014-03-01 00:51:16.000000', 'temperatura', 181.0000, 'ºC'),
	(226480, 120, '2014-03-01 00:51:17.000000', 'temperatura', 805.0000, 'ºC'),
	(226481, 120, '2014-03-01 00:51:18.000000', 'temperatura', 1082.0000, 'ºC'),
	(226482, 120, '2014-03-01 00:51:19.000000', 'temperatura', 594.0000, 'ºC'),
	(226483, 120, '2014-03-01 00:51:20.000000', 'temperatura', 926.0000, 'ºC'),
	(226484, 120, '2014-03-01 00:51:21.000000', 'temperatura', 447.0000, 'ºC'),
	(226485, 120, '2014-03-01 00:51:22.000000', 'temperatura', 660.0000, 'ºC'),
	(226486, 120, '2014-03-01 00:51:23.000000', 'temperatura', 756.0000, 'ºC'),
	(226487, 120, '2014-03-01 00:51:24.000000', 'temperatura', 604.0000, 'ºC'),
	(226488, 120, '2014-03-01 00:51:25.000000', 'temperatura', 751.0000, 'ºC'),
	(226489, 120, '2014-03-01 00:51:26.000000', 'temperatura', 742.0000, 'ºC'),
	(226490, 120, '2014-03-01 00:51:27.000000', 'temperatura', 258.0000, 'ºC'),
	(226491, 120, '2014-03-01 00:51:28.000000', 'temperatura', 265.0000, 'ºC'),
	(226492, 120, '2014-03-01 00:51:29.000000', 'temperatura', 550.0000, 'ºC'),
	(226493, 120, '2014-03-01 00:51:30.000000', 'temperatura', 755.0000, 'ºC'),
	(226494, 120, '2014-03-01 00:51:31.000000', 'temperatura', 925.0000, 'ºC'),
	(226495, 120, '2014-03-01 00:51:32.000000', 'temperatura', 1163.0000, 'ºC'),
	(226496, 120, '2014-03-01 00:51:33.000000', 'temperatura', 641.0000, 'ºC'),
	(226497, 120, '2014-03-01 00:51:34.000000', 'temperatura', 914.0000, 'ºC'),
	(226498, 120, '2014-03-01 00:51:35.000000', 'temperatura', 247.0000, 'ºC'),
	(226499, 120, '2014-03-01 00:51:36.000000', 'temperatura', 894.0000, 'ºC'),
	(226500, 120, '2014-03-01 00:51:37.000000', 'temperatura', 128.0000, 'ºC'),
	(226501, 120, '2014-03-01 00:51:38.000000', 'temperatura', 360.0000, 'ºC'),
	(226502, 120, '2014-03-01 00:51:39.000000', 'temperatura', 218.0000, 'ºC'),
	(226503, 120, '2014-03-01 00:51:40.000000', 'temperatura', 10.0000, 'ºC'),
	(226504, 120, '2014-03-01 00:51:41.000000', 'temperatura', 597.0000, 'ºC'),
	(226505, 120, '2014-03-01 00:51:42.000000', 'temperatura', 557.0000, 'ºC'),
	(226506, 120, '2014-03-01 00:51:43.000000', 'temperatura', 993.0000, 'ºC'),
	(226507, 120, '2014-03-01 00:51:44.000000', 'temperatura', 893.0000, 'ºC'),
	(226508, 120, '2014-03-01 00:51:45.000000', 'temperatura', 287.0000, 'ºC'),
	(226509, 120, '2014-03-01 00:51:46.000000', 'temperatura', 1159.0000, 'ºC'),
	(226510, 120, '2014-03-01 00:51:47.000000', 'temperatura', 133.0000, 'ºC'),
	(226511, 120, '2014-03-01 00:51:48.000000', 'temperatura', 787.0000, 'ºC'),
	(226512, 120, '2014-03-01 00:51:49.000000', 'temperatura', 1139.0000, 'ºC'),
	(226513, 120, '2014-03-01 00:51:50.000000', 'temperatura', 934.0000, 'ºC'),
	(226514, 120, '2014-03-01 00:51:51.000000', 'temperatura', 55.0000, 'ºC'),
	(226515, 120, '2014-03-01 00:51:52.000000', 'temperatura', 1073.0000, 'ºC'),
	(226516, 120, '2014-03-01 00:51:53.000000', 'temperatura', 400.0000, 'ºC'),
	(226517, 120, '2014-03-01 00:51:54.000000', 'temperatura', 1180.0000, 'ºC'),
	(226518, 120, '2014-03-01 00:51:55.000000', 'temperatura', 1101.0000, 'ºC'),
	(226519, 120, '2014-03-01 00:51:56.000000', 'temperatura', 765.0000, 'ºC'),
	(226520, 120, '2014-03-01 00:51:57.000000', 'temperatura', 523.0000, 'ºC'),
	(226521, 120, '2014-03-01 00:51:58.000000', 'temperatura', 321.0000, 'ºC'),
	(226522, 120, '2014-03-01 00:51:59.000000', 'temperatura', 36.0000, 'ºC'),
	(226523, 120, '2014-03-01 00:52:00.000000', 'temperatura', 416.0000, 'ºC'),
	(226524, 120, '2014-03-01 00:52:01.000000', 'temperatura', 774.0000, 'ºC'),
	(226525, 120, '2014-03-01 00:52:02.000000', 'temperatura', 223.0000, 'ºC'),
	(226526, 120, '2014-03-01 00:52:03.000000', 'temperatura', 1194.0000, 'ºC'),
	(226527, 120, '2014-03-01 00:52:04.000000', 'temperatura', 502.0000, 'ºC'),
	(226528, 120, '2014-03-01 00:52:05.000000', 'temperatura', 126.0000, 'ºC'),
	(226529, 120, '2014-03-01 00:52:06.000000', 'temperatura', 325.0000, 'ºC'),
	(226530, 120, '2014-03-01 00:52:07.000000', 'temperatura', 47.0000, 'ºC'),
	(226531, 120, '2014-03-01 00:52:08.000000', 'temperatura', 463.0000, 'ºC'),
	(226532, 120, '2014-03-01 00:52:09.000000', 'temperatura', 973.0000, 'ºC'),
	(226533, 120, '2014-03-01 00:52:10.000000', 'temperatura', 1075.0000, 'ºC'),
	(226534, 120, '2014-03-01 00:52:11.000000', 'temperatura', 58.0000, 'ºC'),
	(226535, 120, '2014-03-01 00:52:12.000000', 'temperatura', 667.0000, 'ºC'),
	(226536, 120, '2014-03-01 00:52:13.000000', 'temperatura', 761.0000, 'ºC'),
	(226537, 120, '2014-03-01 00:52:14.000000', 'temperatura', 605.0000, 'ºC'),
	(226538, 120, '2014-03-01 00:52:15.000000', 'temperatura', 741.0000, 'ºC'),
	(226539, 120, '2014-03-01 00:52:16.000000', 'temperatura', 690.0000, 'ºC'),
	(226540, 120, '2014-03-01 00:52:17.000000', 'temperatura', 27.0000, 'ºC'),
	(226541, 120, '2014-03-01 00:52:18.000000', 'temperatura', 464.0000, 'ºC'),
	(226542, 120, '2014-03-01 00:52:19.000000', 'temperatura', 1043.0000, 'ºC'),
	(226543, 120, '2014-03-01 00:52:20.000000', 'temperatura', 222.0000, 'ºC'),
	(226544, 120, '2014-03-01 00:52:21.000000', 'temperatura', 381.0000, 'ºC'),
	(226545, 120, '2014-03-01 00:52:22.000000', 'temperatura', 41.0000, 'ºC'),
	(226546, 120, '2014-03-01 00:52:23.000000', 'temperatura', 262.0000, 'ºC'),
	(226547, 120, '2014-03-01 00:52:24.000000', 'temperatura', 1188.0000, 'ºC'),
	(226548, 120, '2014-03-01 00:52:25.000000', 'temperatura', 353.0000, 'ºC'),
	(226549, 120, '2014-03-01 00:52:26.000000', 'temperatura', 602.0000, 'ºC'),
	(226550, 120, '2014-03-01 00:52:27.000000', 'temperatura', 751.0000, 'ºC'),
	(226551, 120, '2014-03-01 00:52:28.000000', 'temperatura', 748.0000, 'ºC'),
	(226552, 120, '2014-03-01 00:52:29.000000', 'temperatura', 289.0000, 'ºC'),
	(226553, 120, '2014-03-01 00:52:30.000000', 'temperatura', 400.0000, 'ºC'),
	(226554, 120, '2014-03-01 00:52:31.000000', 'temperatura', 1133.0000, 'ºC'),
	(226555, 120, '2014-03-01 00:52:32.000000', 'temperatura', 868.0000, 'ºC'),
	(226556, 120, '2014-03-01 00:52:33.000000', 'temperatura', 938.0000, 'ºC'),
	(226557, 120, '2014-03-01 00:52:34.000000', 'temperatura', 890.0000, 'ºC'),
	(226558, 120, '2014-03-01 00:52:35.000000', 'temperatura', 435.0000, 'ºC'),
	(226559, 120, '2014-03-01 00:52:36.000000', 'temperatura', 706.0000, 'ºC'),
	(226560, 120, '2014-03-01 00:52:37.000000', 'temperatura', 1027.0000, 'ºC'),
	(226561, 120, '2014-03-01 00:52:38.000000', 'temperatura', 617.0000, 'ºC'),
	(226562, 120, '2014-03-01 00:52:39.000000', 'temperatura', 6.0000, 'ºC'),
	(226563, 120, '2014-03-01 00:52:40.000000', 'temperatura', 577.0000, 'ºC'),
	(226564, 120, '2014-03-01 00:52:41.000000', 'temperatura', 469.0000, 'ºC'),
	(226565, 120, '2014-03-01 00:52:42.000000', 'temperatura', 615.0000, 'ºC'),
	(226566, 120, '2014-03-01 00:52:43.000000', 'temperatura', 466.0000, 'ºC'),
	(226567, 120, '2014-03-01 00:52:44.000000', 'temperatura', 485.0000, 'ºC'),
	(226568, 120, '2014-03-01 00:52:45.000000', 'temperatura', 1030.0000, 'ºC'),
	(226569, 120, '2014-03-01 00:52:46.000000', 'temperatura', 96.0000, 'ºC'),
	(226570, 120, '2014-03-01 00:52:47.000000', 'temperatura', 991.0000, 'ºC'),
	(226571, 120, '2014-03-01 00:52:48.000000', 'temperatura', 1067.0000, 'ºC'),
	(226572, 120, '2014-03-01 00:52:49.000000', 'temperatura', 1162.0000, 'ºC'),
	(226573, 120, '2014-03-01 00:52:50.000000', 'temperatura', 211.0000, 'ºC'),
	(226574, 120, '2014-03-01 00:52:51.000000', 'temperatura', 1169.0000, 'ºC'),
	(226575, 120, '2014-03-01 00:52:52.000000', 'temperatura', 411.0000, 'ºC'),
	(226576, 120, '2014-03-01 00:52:53.000000', 'temperatura', 950.0000, 'ºC'),
	(226577, 120, '2014-03-01 00:52:54.000000', 'temperatura', 1119.0000, 'ºC'),
	(226578, 120, '2014-03-01 00:52:55.000000', 'temperatura', 343.0000, 'ºC'),
	(226579, 120, '2014-03-01 00:52:56.000000', 'temperatura', 759.0000, 'ºC'),
	(226580, 120, '2014-03-01 00:52:57.000000', 'temperatura', 366.0000, 'ºC'),
	(226581, 120, '2014-03-01 00:52:58.000000', 'temperatura', 755.0000, 'ºC'),
	(226582, 120, '2014-03-01 00:52:59.000000', 'temperatura', 275.0000, 'ºC'),
	(226583, 120, '2014-03-01 00:53:00.000000', 'temperatura', 312.0000, 'ºC'),
	(226584, 120, '2014-03-01 00:53:01.000000', 'temperatura', 736.0000, 'ºC'),
	(226585, 120, '2014-03-01 00:53:02.000000', 'temperatura', 345.0000, 'ºC'),
	(226586, 120, '2014-03-01 00:53:03.000000', 'temperatura', 715.0000, 'ºC'),
	(226587, 120, '2014-03-01 00:53:04.000000', 'temperatura', 142.0000, 'ºC'),
	(226588, 120, '2014-03-01 00:53:05.000000', 'temperatura', 964.0000, 'ºC'),
	(226589, 120, '2014-03-01 00:53:06.000000', 'temperatura', 796.0000, 'ºC'),
	(226590, 120, '2014-03-01 00:53:07.000000', 'temperatura', 1088.0000, 'ºC'),
	(226591, 120, '2014-03-01 00:53:08.000000', 'temperatura', 651.0000, 'ºC'),
	(226592, 120, '2014-03-01 00:53:09.000000', 'temperatura', 1192.0000, 'ºC'),
	(226593, 120, '2014-03-01 00:53:10.000000', 'temperatura', 409.0000, 'ºC'),
	(226594, 120, '2014-03-01 00:53:11.000000', 'temperatura', 867.0000, 'ºC'),
	(226595, 120, '2014-03-01 00:53:12.000000', 'temperatura', 712.0000, 'ºC'),
	(226596, 120, '2014-03-01 00:53:13.000000', 'temperatura', 956.0000, 'ºC'),
	(226597, 120, '2014-03-01 00:53:14.000000', 'temperatura', 245.0000, 'ºC'),
	(226598, 120, '2014-03-01 00:53:15.000000', 'temperatura', 760.0000, 'ºC'),
	(226599, 120, '2014-03-01 00:53:16.000000', 'temperatura', 662.0000, 'ºC'),
	(226600, 120, '2014-03-01 00:53:17.000000', 'temperatura', 1033.0000, 'ºC'),
	(226601, 120, '2014-03-01 00:53:18.000000', 'temperatura', 779.0000, 'ºC'),
	(226602, 120, '2014-03-01 00:53:19.000000', 'temperatura', 796.0000, 'ºC'),
	(226603, 120, '2014-03-01 00:53:20.000000', 'temperatura', 443.0000, 'ºC'),
	(226604, 120, '2014-03-01 00:53:21.000000', 'temperatura', 1030.0000, 'ºC'),
	(226605, 120, '2014-03-01 00:53:22.000000', 'temperatura', 220.0000, 'ºC'),
	(226606, 120, '2014-03-01 00:53:23.000000', 'temperatura', 410.0000, 'ºC'),
	(226607, 120, '2014-03-01 00:53:24.000000', 'temperatura', 192.0000, 'ºC'),
	(226608, 120, '2014-03-01 00:53:25.000000', 'temperatura', 929.0000, 'ºC'),
	(226609, 120, '2014-03-01 00:53:26.000000', 'temperatura', 471.0000, 'ºC'),
	(226610, 120, '2014-03-01 00:53:27.000000', 'temperatura', 769.0000, 'ºC'),
	(226611, 120, '2014-03-01 00:53:28.000000', 'temperatura', 31.0000, 'ºC'),
	(226612, 120, '2014-03-01 00:53:29.000000', 'temperatura', 249.0000, 'ºC'),
	(226613, 120, '2014-03-01 00:53:30.000000', 'temperatura', 1151.0000, 'ºC'),
	(226614, 120, '2014-03-01 00:53:31.000000', 'temperatura', 210.0000, 'ºC'),
	(226615, 120, '2014-03-01 00:53:32.000000', 'temperatura', 1198.0000, 'ºC'),
	(226616, 120, '2014-03-01 00:53:33.000000', 'temperatura', 560.0000, 'ºC'),
	(226617, 120, '2014-03-01 00:53:34.000000', 'temperatura', 408.0000, 'ºC'),
	(226618, 120, '2014-03-01 00:53:35.000000', 'temperatura', 360.0000, 'ºC'),
	(226619, 120, '2014-03-01 00:53:36.000000', 'temperatura', 576.0000, 'ºC'),
	(226620, 120, '2014-03-01 00:53:37.000000', 'temperatura', 600.0000, 'ºC'),
	(226621, 120, '2014-03-01 00:53:38.000000', 'temperatura', 75.0000, 'ºC'),
	(226622, 120, '2014-03-01 00:53:39.000000', 'temperatura', 972.0000, 'ºC'),
	(226623, 120, '2014-03-01 00:53:40.000000', 'temperatura', 1038.0000, 'ºC'),
	(226624, 120, '2014-03-01 00:53:41.000000', 'temperatura', 1073.0000, 'ºC'),
	(226625, 120, '2014-03-01 00:53:42.000000', 'temperatura', 1052.0000, 'ºC'),
	(226626, 120, '2014-03-01 00:53:43.000000', 'temperatura', 840.0000, 'ºC'),
	(226627, 120, '2014-03-01 00:53:44.000000', 'temperatura', 1044.0000, 'ºC'),
	(226628, 120, '2014-03-01 00:53:45.000000', 'temperatura', 300.0000, 'ºC'),
	(226629, 120, '2014-03-01 00:53:46.000000', 'temperatura', 768.0000, 'ºC'),
	(226630, 120, '2014-03-01 00:53:47.000000', 'temperatura', 541.0000, 'ºC'),
	(226631, 120, '2014-03-01 00:53:48.000000', 'temperatura', 404.0000, 'ºC'),
	(226632, 120, '2014-03-01 00:53:49.000000', 'temperatura', 396.0000, 'ºC'),
	(226633, 120, '2014-03-01 00:53:50.000000', 'temperatura', 770.0000, 'ºC'),
	(226634, 120, '2014-03-01 00:53:51.000000', 'temperatura', 261.0000, 'ºC'),
	(226635, 120, '2014-03-01 00:53:52.000000', 'temperatura', 195.0000, 'ºC'),
	(226636, 120, '2014-03-01 00:53:53.000000', 'temperatura', 191.0000, 'ºC'),
	(226637, 120, '2014-03-01 00:53:54.000000', 'temperatura', 373.0000, 'ºC'),
	(226638, 120, '2014-03-01 00:53:55.000000', 'temperatura', 93.0000, 'ºC'),
	(226639, 120, '2014-03-01 00:53:56.000000', 'temperatura', 544.0000, 'ºC'),
	(226640, 120, '2014-03-01 00:53:57.000000', 'temperatura', 43.0000, 'ºC'),
	(226641, 120, '2014-03-01 00:53:58.000000', 'temperatura', 982.0000, 'ºC'),
	(226642, 120, '2014-03-01 00:53:59.000000', 'temperatura', 1181.0000, 'ºC'),
	(226643, 120, '2014-03-01 00:54:00.000000', 'temperatura', 559.0000, 'ºC'),
	(226644, 120, '2014-03-01 00:54:01.000000', 'temperatura', 452.0000, 'ºC'),
	(226645, 120, '2014-03-01 00:54:02.000000', 'temperatura', 585.0000, 'ºC'),
	(226646, 120, '2014-03-01 00:54:03.000000', 'temperatura', 370.0000, 'ºC'),
	(226647, 120, '2014-03-01 00:54:04.000000', 'temperatura', 94.0000, 'ºC'),
	(226648, 120, '2014-03-01 00:54:05.000000', 'temperatura', 559.0000, 'ºC'),
	(226649, 120, '2014-03-01 00:54:06.000000', 'temperatura', 116.0000, 'ºC'),
	(226650, 120, '2014-03-01 00:54:07.000000', 'temperatura', 104.0000, 'ºC'),
	(226651, 120, '2014-03-01 00:54:08.000000', 'temperatura', 171.0000, 'ºC'),
	(226652, 120, '2014-03-01 00:54:09.000000', 'temperatura', 545.0000, 'ºC'),
	(226653, 120, '2014-03-01 00:54:10.000000', 'temperatura', 1010.0000, 'ºC'),
	(226654, 120, '2014-03-01 00:54:11.000000', 'temperatura', 1017.0000, 'ºC'),
	(226655, 120, '2014-03-01 00:54:12.000000', 'temperatura', 854.0000, 'ºC'),
	(226656, 120, '2014-03-01 00:54:13.000000', 'temperatura', 21.0000, 'ºC'),
	(226657, 120, '2014-03-01 00:54:14.000000', 'temperatura', 1141.0000, 'ºC'),
	(226658, 120, '2014-03-01 00:54:15.000000', 'temperatura', 846.0000, 'ºC'),
	(226659, 120, '2014-03-01 00:54:16.000000', 'temperatura', 806.0000, 'ºC'),
	(226660, 120, '2014-03-01 00:54:17.000000', 'temperatura', 292.0000, 'ºC'),
	(226661, 120, '2014-03-01 00:54:18.000000', 'temperatura', 242.0000, 'ºC'),
	(226662, 120, '2014-03-01 00:54:19.000000', 'temperatura', 335.0000, 'ºC'),
	(226663, 120, '2014-03-01 00:54:20.000000', 'temperatura', 949.0000, 'ºC'),
	(226664, 120, '2014-03-01 00:54:21.000000', 'temperatura', 143.0000, 'ºC'),
	(226665, 120, '2014-03-01 00:54:22.000000', 'temperatura', 266.0000, 'ºC'),
	(226666, 120, '2014-03-01 00:54:23.000000', 'temperatura', 901.0000, 'ºC'),
	(226667, 120, '2014-03-01 00:54:24.000000', 'temperatura', 108.0000, 'ºC'),
	(226668, 120, '2014-03-01 00:54:25.000000', 'temperatura', 236.0000, 'ºC'),
	(226669, 120, '2014-03-01 00:54:26.000000', 'temperatura', 857.0000, 'ºC'),
	(226670, 120, '2014-03-01 00:54:27.000000', 'temperatura', 1179.0000, 'ºC'),
	(226671, 120, '2014-03-01 00:54:28.000000', 'temperatura', 924.0000, 'ºC'),
	(226672, 120, '2014-03-01 00:54:29.000000', 'temperatura', 1083.0000, 'ºC'),
	(226673, 120, '2014-03-01 00:54:30.000000', 'temperatura', 243.0000, 'ºC'),
	(226674, 120, '2014-03-01 00:54:31.000000', 'temperatura', 365.0000, 'ºC'),
	(226675, 120, '2014-03-01 00:54:32.000000', 'temperatura', 1098.0000, 'ºC'),
	(226676, 120, '2014-03-01 00:54:33.000000', 'temperatura', 794.0000, 'ºC'),
	(226677, 120, '2014-03-01 00:54:34.000000', 'temperatura', 677.0000, 'ºC'),
	(226678, 120, '2014-03-01 00:54:35.000000', 'temperatura', 1003.0000, 'ºC'),
	(226679, 120, '2014-03-01 00:54:36.000000', 'temperatura', 584.0000, 'ºC'),
	(226680, 120, '2014-03-01 00:54:37.000000', 'temperatura', 1112.0000, 'ºC'),
	(226681, 120, '2014-03-01 00:54:38.000000', 'temperatura', 208.0000, 'ºC'),
	(226682, 120, '2014-03-01 00:54:39.000000', 'temperatura', 103.0000, 'ºC'),
	(226683, 120, '2014-03-01 00:54:40.000000', 'temperatura', 1094.0000, 'ºC'),
	(226684, 120, '2014-03-01 00:54:41.000000', 'temperatura', 361.0000, 'ºC'),
	(226685, 120, '2014-03-01 00:54:42.000000', 'temperatura', 925.0000, 'ºC'),
	(226686, 120, '2014-03-01 00:54:43.000000', 'temperatura', 1143.0000, 'ºC'),
	(226687, 120, '2014-03-01 00:54:44.000000', 'temperatura', 537.0000, 'ºC'),
	(226688, 120, '2014-03-01 00:54:45.000000', 'temperatura', 460.0000, 'ºC'),
	(226689, 120, '2014-03-01 00:54:46.000000', 'temperatura', 688.0000, 'ºC'),
	(226690, 120, '2014-03-01 00:54:47.000000', 'temperatura', 862.0000, 'ºC'),
	(226691, 120, '2014-03-01 00:54:48.000000', 'temperatura', 1044.0000, 'ºC'),
	(226692, 120, '2014-03-01 00:54:49.000000', 'temperatura', 237.0000, 'ºC'),
	(226693, 120, '2014-03-01 00:54:50.000000', 'temperatura', 452.0000, 'ºC'),
	(226694, 120, '2014-03-01 00:54:51.000000', 'temperatura', 349.0000, 'ºC'),
	(226695, 120, '2014-03-01 00:54:52.000000', 'temperatura', 390.0000, 'ºC'),
	(226696, 120, '2014-03-01 00:54:53.000000', 'temperatura', 903.0000, 'ºC'),
	(226697, 120, '2014-03-01 00:54:54.000000', 'temperatura', 946.0000, 'ºC'),
	(226698, 120, '2014-03-01 00:54:55.000000', 'temperatura', 822.0000, 'ºC'),
	(226699, 120, '2014-03-01 00:54:56.000000', 'temperatura', 72.0000, 'ºC'),
	(226700, 120, '2014-03-01 00:54:57.000000', 'temperatura', 296.0000, 'ºC'),
	(226701, 120, '2014-03-01 00:54:58.000000', 'temperatura', 62.0000, 'ºC'),
	(226702, 120, '2014-03-01 00:54:59.000000', 'temperatura', 623.0000, 'ºC'),
	(226703, 120, '2014-03-01 00:55:00.000000', 'temperatura', 529.0000, 'ºC'),
	(226704, 120, '2014-03-01 00:55:01.000000', 'temperatura', 778.0000, 'ºC'),
	(226705, 120, '2014-03-01 00:55:02.000000', 'temperatura', 1105.0000, 'ºC'),
	(226706, 120, '2014-03-01 00:55:03.000000', 'temperatura', 789.0000, 'ºC'),
	(226707, 120, '2014-03-01 00:55:04.000000', 'temperatura', 632.0000, 'ºC'),
	(226708, 120, '2014-03-01 00:55:05.000000', 'temperatura', 794.0000, 'ºC'),
	(226709, 120, '2014-03-01 00:55:06.000000', 'temperatura', 876.0000, 'ºC'),
	(226710, 120, '2014-03-01 00:55:07.000000', 'temperatura', 795.0000, 'ºC'),
	(226711, 120, '2014-03-01 00:55:08.000000', 'temperatura', 148.0000, 'ºC'),
	(226712, 120, '2014-03-01 00:55:09.000000', 'temperatura', 756.0000, 'ºC'),
	(226713, 120, '2014-03-01 00:55:10.000000', 'temperatura', 938.0000, 'ºC'),
	(226714, 120, '2014-03-01 00:55:11.000000', 'temperatura', 21.0000, 'ºC'),
	(226715, 120, '2014-03-01 00:55:12.000000', 'temperatura', 894.0000, 'ºC'),
	(226716, 120, '2014-03-01 00:55:13.000000', 'temperatura', 804.0000, 'ºC'),
	(226717, 120, '2014-03-01 00:55:14.000000', 'temperatura', 142.0000, 'ºC'),
	(226718, 120, '2014-03-01 00:55:15.000000', 'temperatura', 696.0000, 'ºC'),
	(226719, 120, '2014-03-01 00:55:16.000000', 'temperatura', 654.0000, 'ºC'),
	(226720, 120, '2014-03-01 00:55:17.000000', 'temperatura', 1185.0000, 'ºC'),
	(226721, 120, '2014-03-01 00:55:18.000000', 'temperatura', 361.0000, 'ºC'),
	(226722, 120, '2014-03-01 00:55:19.000000', 'temperatura', 649.0000, 'ºC'),
	(226723, 120, '2014-03-01 00:55:20.000000', 'temperatura', 966.0000, 'ºC'),
	(226724, 120, '2014-03-01 00:55:21.000000', 'temperatura', 480.0000, 'ºC'),
	(226725, 120, '2014-03-01 00:55:22.000000', 'temperatura', 705.0000, 'ºC'),
	(226726, 120, '2014-03-01 00:55:23.000000', 'temperatura', 886.0000, 'ºC'),
	(226727, 120, '2014-03-01 00:55:24.000000', 'temperatura', 1117.0000, 'ºC'),
	(226728, 120, '2014-03-01 00:55:25.000000', 'temperatura', 524.0000, 'ºC'),
	(226729, 120, '2014-03-01 00:55:26.000000', 'temperatura', 472.0000, 'ºC'),
	(226730, 120, '2014-03-01 00:55:27.000000', 'temperatura', 789.0000, 'ºC'),
	(226731, 120, '2014-03-01 00:55:28.000000', 'temperatura', 130.0000, 'ºC'),
	(226732, 120, '2014-03-01 00:55:29.000000', 'temperatura', 683.0000, 'ºC'),
	(226733, 120, '2014-03-01 00:55:30.000000', 'temperatura', 625.0000, 'ºC'),
	(226734, 120, '2014-03-01 00:55:31.000000', 'temperatura', 1078.0000, 'ºC'),
	(226735, 120, '2014-03-01 00:55:32.000000', 'temperatura', 1115.0000, 'ºC'),
	(226736, 120, '2014-03-01 00:55:33.000000', 'temperatura', 1140.0000, 'ºC'),
	(226737, 120, '2014-03-01 00:55:34.000000', 'temperatura', 1154.0000, 'ºC'),
	(226738, 120, '2014-03-01 00:55:35.000000', 'temperatura', 1154.0000, 'ºC'),
	(226739, 120, '2014-03-01 00:55:36.000000', 'temperatura', 1107.0000, 'ºC'),
	(226740, 120, '2014-03-01 00:55:37.000000', 'temperatura', 872.0000, 'ºC'),
	(226741, 120, '2014-03-01 00:55:38.000000', 'temperatura', 1040.0000, 'ºC'),
	(226742, 120, '2014-03-01 00:55:39.000000', 'temperatura', 186.0000, 'ºC'),
	(226743, 120, '2014-03-01 00:55:40.000000', 'temperatura', 210.0000, 'ºC'),
	(226744, 120, '2014-03-01 00:55:41.000000', 'temperatura', 491.0000, 'ºC'),
	(226745, 120, '2014-03-01 00:55:42.000000', 'temperatura', 628.0000, 'ºC'),
	(226746, 120, '2014-03-01 00:55:43.000000', 'temperatura', 465.0000, 'ºC'),
	(226747, 120, '2014-03-01 00:55:44.000000', 'temperatura', 444.0000, 'ºC'),
	(226748, 120, '2014-03-01 00:55:45.000000', 'temperatura', 824.0000, 'ºC'),
	(226749, 120, '2014-03-01 00:55:46.000000', 'temperatura', 389.0000, 'ºC'),
	(226750, 120, '2014-03-01 00:55:47.000000', 'temperatura', 672.0000, 'ºC'),
	(226751, 120, '2014-03-01 00:55:48.000000', 'temperatura', 993.0000, 'ºC'),
	(226752, 120, '2014-03-01 00:55:49.000000', 'temperatura', 550.0000, 'ºC'),
	(226753, 120, '2014-03-01 00:55:50.000000', 'temperatura', 971.0000, 'ºC'),
	(226754, 120, '2014-03-01 00:55:51.000000', 'temperatura', 805.0000, 'ºC'),
	(226755, 120, '2014-03-01 00:55:52.000000', 'temperatura', 1113.0000, 'ºC'),
	(226756, 120, '2014-03-01 00:55:53.000000', 'temperatura', 750.0000, 'ºC'),
	(226757, 120, '2014-03-01 00:55:54.000000', 'temperatura', 412.0000, 'ºC'),
	(226758, 120, '2014-03-01 00:55:55.000000', 'temperatura', 1011.0000, 'ºC'),
	(226759, 120, '2014-03-01 00:55:56.000000', 'temperatura', 219.0000, 'ºC'),
	(226760, 120, '2014-03-01 00:55:57.000000', 'temperatura', 464.0000, 'ºC'),
	(226761, 120, '2014-03-01 00:55:58.000000', 'temperatura', 462.0000, 'ºC'),
	(226762, 120, '2014-03-01 00:55:59.000000', 'temperatura', 917.0000, 'ºC'),
	(226763, 120, '2014-03-01 00:56:00.000000', 'temperatura', 801.0000, 'ºC'),
	(226764, 120, '2014-03-01 00:56:01.000000', 'temperatura', 56.0000, 'ºC'),
	(226765, 120, '2014-03-01 00:56:02.000000', 'temperatura', 278.0000, 'ºC'),
	(226766, 120, '2014-03-01 00:56:03.000000', 'temperatura', 20.0000, 'ºC'),
	(226767, 120, '2014-03-01 00:56:04.000000', 'temperatura', 468.0000, 'ºC'),
	(226768, 120, '2014-03-01 00:56:05.000000', 'temperatura', 1080.0000, 'ºC'),
	(226769, 120, '2014-03-01 00:56:06.000000', 'temperatura', 399.0000, 'ºC'),
	(226770, 120, '2014-03-01 00:56:07.000000', 'temperatura', 1152.0000, 'ºC'),
	(226771, 120, '2014-03-01 00:56:08.000000', 'temperatura', 963.0000, 'ºC'),
	(226772, 120, '2014-03-01 00:56:09.000000', 'temperatura', 163.0000, 'ºC'),
	(226773, 120, '2014-03-01 00:56:10.000000', 'temperatura', 324.0000, 'ºC'),
	(226774, 120, '2014-03-01 00:56:11.000000', 'temperatura', 1130.0000, 'ºC'),
	(226775, 120, '2014-03-01 00:56:12.000000', 'temperatura', 1080.0000, 'ºC'),
	(226776, 120, '2014-03-01 00:56:13.000000', 'temperatura', 812.0000, 'ºC'),
	(226777, 120, '2014-03-01 00:56:14.000000', 'temperatura', 820.0000, 'ºC'),
	(226778, 120, '2014-03-01 00:56:15.000000', 'temperatura', 463.0000, 'ºC'),
	(226779, 120, '2014-03-01 00:56:16.000000', 'temperatura', 1055.0000, 'ºC'),
	(226780, 120, '2014-03-01 00:56:17.000000', 'temperatura', 286.0000, 'ºC'),
	(226781, 120, '2014-03-01 00:56:18.000000', 'temperatura', 665.0000, 'ºC'),
	(226782, 120, '2014-03-01 00:56:19.000000', 'temperatura', 68.0000, 'ºC'),
	(226783, 120, '2014-03-01 00:56:20.000000', 'temperatura', 747.0000, 'ºC'),
	(226784, 120, '2014-03-01 00:56:21.000000', 'temperatura', 1131.0000, 'ºC'),
	(226785, 120, '2014-03-01 00:56:22.000000', 'temperatura', 1014.0000, 'ºC'),
	(226786, 120, '2014-03-01 00:56:23.000000', 'temperatura', 477.0000, 'ºC'),
	(226787, 120, '2014-03-01 00:56:24.000000', 'temperatura', 544.0000, 'ºC'),
	(226788, 120, '2014-03-01 00:56:25.000000', 'temperatura', 89.0000, 'ºC'),
	(226789, 120, '2014-03-01 00:56:26.000000', 'temperatura', 13.0000, 'ºC'),
	(226790, 120, '2014-03-01 00:56:27.000000', 'temperatura', 998.0000, 'ºC'),
	(226791, 120, '2014-03-01 00:56:28.000000', 'temperatura', 152.0000, 'ºC'),
	(226792, 120, '2014-03-01 00:56:29.000000', 'temperatura', 167.0000, 'ºC'),
	(226793, 120, '2014-03-01 00:56:30.000000', 'temperatura', 377.0000, 'ºC'),
	(226794, 120, '2014-03-01 00:56:31.000000', 'temperatura', 188.0000, 'ºC'),
	(226795, 120, '2014-03-01 00:56:32.000000', 'temperatura', 1006.0000, 'ºC'),
	(226796, 120, '2014-03-01 00:56:33.000000', 'temperatura', 869.0000, 'ºC'),
	(226797, 120, '2014-03-01 00:56:34.000000', 'temperatura', 129.0000, 'ºC'),
	(226798, 120, '2014-03-01 00:56:35.000000', 'temperatura', 437.0000, 'ºC'),
	(226799, 120, '2014-03-01 00:56:36.000000', 'temperatura', 597.0000, 'ºC'),
	(226800, 120, '2014-03-01 00:56:37.000000', 'temperatura', 477.0000, 'ºC'),
	(226801, 120, '2014-03-01 00:56:38.000000', 'temperatura', 595.0000, 'ºC'),
	(226802, 120, '2014-03-01 00:56:39.000000', 'temperatura', 342.0000, 'ºC'),
	(226803, 120, '2014-03-01 00:56:40.000000', 'temperatura', 1126.0000, 'ºC'),
	(226804, 120, '2014-03-01 00:56:41.000000', 'temperatura', 1005.0000, 'ºC'),
	(226805, 120, '2014-03-01 00:56:42.000000', 'temperatura', 445.0000, 'ºC'),
	(226806, 120, '2014-03-01 00:56:43.000000', 'temperatura', 414.0000, 'ºC'),
	(226807, 120, '2014-03-01 00:56:44.000000', 'temperatura', 734.0000, 'ºC'),
	(226808, 120, '2014-03-01 00:56:45.000000', 'temperatura', 28.0000, 'ºC'),
	(226809, 120, '2014-03-01 00:56:46.000000', 'temperatura', 340.0000, 'ºC'),
	(226810, 120, '2014-03-01 00:56:47.000000', 'temperatura', 416.0000, 'ºC'),
	(226811, 120, '2014-03-01 00:56:48.000000', 'temperatura', 1060.0000, 'ºC'),
	(226812, 120, '2014-03-01 00:56:49.000000', 'temperatura', 452.0000, 'ºC'),
	(226813, 120, '2014-03-01 00:56:50.000000', 'temperatura', 280.0000, 'ºC'),
	(226814, 120, '2014-03-01 00:56:51.000000', 'temperatura', 43.0000, 'ºC'),
	(226815, 120, '2014-03-01 00:56:52.000000', 'temperatura', 579.0000, 'ºC'),
	(226816, 120, '2014-03-01 00:56:53.000000', 'temperatura', 365.0000, 'ºC'),
	(226817, 120, '2014-03-01 00:56:54.000000', 'temperatura', 89.0000, 'ºC'),
	(226818, 120, '2014-03-01 00:56:55.000000', 'temperatura', 552.0000, 'ºC'),
	(226819, 120, '2014-03-01 00:56:56.000000', 'temperatura', 93.0000, 'ºC'),
	(226820, 120, '2014-03-01 00:56:57.000000', 'temperatura', 8.0000, 'ºC'),
	(226821, 120, '2014-03-01 00:56:58.000000', 'temperatura', 961.0000, 'ºC'),
	(226822, 120, '2014-03-01 00:56:59.000000', 'temperatura', 1183.0000, 'ºC'),
	(226823, 120, '2014-03-01 00:57:00.000000', 'temperatura', 633.0000, 'ºC'),
	(226824, 120, '2014-03-01 00:57:01.000000', 'temperatura', 814.0000, 'ºC'),
	(226825, 120, '2014-03-01 00:57:02.000000', 'temperatura', 972.0000, 'ºC'),
	(226826, 120, '2014-03-01 00:57:03.000000', 'temperatura', 18.0000, 'ºC'),
	(226827, 120, '2014-03-01 00:57:04.000000', 'temperatura', 774.0000, 'ºC'),
	(226828, 120, '2014-03-01 00:57:05.000000', 'temperatura', 217.0000, 'ºC'),
	(226829, 120, '2014-03-01 00:57:06.000000', 'temperatura', 1162.0000, 'ºC'),
	(226830, 120, '2014-03-01 00:57:07.000000', 'temperatura', 360.0000, 'ºC'),
	(226831, 120, '2014-03-01 00:57:08.000000', 'temperatura', 716.0000, 'ºC'),
	(226832, 120, '2014-03-01 00:57:09.000000', 'temperatura', 99.0000, 'ºC'),
	(226833, 120, '2014-03-01 00:57:10.000000', 'temperatura', 750.0000, 'ºC'),
	(226834, 120, '2014-03-01 00:57:11.000000', 'temperatura', 1051.0000, 'ºC'),
	(226835, 120, '2014-03-01 00:57:12.000000', 'temperatura', 605.0000, 'ºC'),
	(226836, 120, '2014-03-01 00:57:13.000000', 'temperatura', 1072.0000, 'ºC'),
	(226837, 120, '2014-03-01 00:57:14.000000', 'temperatura', 1146.0000, 'ºC'),
	(226838, 120, '2014-03-01 00:57:15.000000', 'temperatura', 113.0000, 'ºC'),
	(226839, 120, '2014-03-01 00:57:16.000000', 'temperatura', 730.0000, 'ºC'),
	(226840, 120, '2014-03-01 00:57:17.000000', 'temperatura', 910.0000, 'ºC'),
	(226841, 120, '2014-03-01 00:57:18.000000', 'temperatura', 1159.0000, 'ºC'),
	(226842, 120, '2014-03-01 00:57:19.000000', 'temperatura', 666.0000, 'ºC'),
	(226843, 120, '2014-03-01 00:57:20.000000', 'temperatura', 1054.0000, 'ºC'),
	(226844, 120, '2014-03-01 00:57:21.000000', 'temperatura', 874.0000, 'ºC'),
	(226845, 120, '2014-03-01 00:57:22.000000', 'temperatura', 5.0000, 'ºC'),
	(226846, 120, '2014-03-01 00:57:23.000000', 'temperatura', 1007.0000, 'ºC'),
	(226847, 120, '2014-03-01 00:57:24.000000', 'temperatura', 220.0000, 'ºC'),
	(226848, 120, '2014-03-01 00:57:25.000000', 'temperatura', 481.0000, 'ºC'),
	(226849, 120, '2014-03-01 00:57:26.000000', 'temperatura', 544.0000, 'ºC'),
	(226850, 120, '2014-03-01 00:57:27.000000', 'temperatura', 77.0000, 'ºC'),
	(226851, 120, '2014-03-01 00:57:28.000000', 'temperatura', 1153.0000, 'ºC'),
	(226852, 120, '2014-03-01 00:57:29.000000', 'temperatura', 737.0000, 'ºC'),
	(226853, 120, '2014-03-01 00:57:30.000000', 'temperatura', 225.0000, 'ºC'),
	(226854, 120, '2014-03-01 00:57:31.000000', 'temperatura', 116.0000, 'ºC'),
	(226855, 120, '2014-03-01 00:57:32.000000', 'temperatura', 1105.0000, 'ºC'),
	(226856, 120, '2014-03-01 00:57:33.000000', 'temperatura', 378.0000, 'ºC'),
	(226857, 120, '2014-03-01 00:57:34.000000', 'temperatura', 974.0000, 'ºC'),
	(226858, 120, '2014-03-01 00:57:35.000000', 'temperatura', 136.0000, 'ºC'),
	(226859, 120, '2014-03-01 00:57:36.000000', 'temperatura', 160.0000, 'ºC'),
	(226860, 120, '2014-03-01 00:57:37.000000', 'temperatura', 391.0000, 'ºC'),
	(226861, 120, '2014-03-01 00:57:38.000000', 'temperatura', 276.0000, 'ºC'),
	(226862, 120, '2014-03-01 00:57:39.000000', 'temperatura', 208.0000, 'ºC'),
	(226863, 120, '2014-03-01 00:57:40.000000', 'temperatura', 214.0000, 'ºC'),
	(226864, 120, '2014-03-01 00:57:41.000000', 'temperatura', 444.0000, 'ºC'),
	(226865, 120, '2014-03-01 00:57:42.000000', 'temperatura', 379.0000, 'ºC'),
	(226866, 120, '2014-03-01 00:57:43.000000', 'temperatura', 565.0000, 'ºC'),
	(226867, 120, '2014-03-01 00:57:44.000000', 'temperatura', 488.0000, 'ºC'),
	(226868, 120, '2014-03-01 00:57:45.000000', 'temperatura', 745.0000, 'ºC'),
	(226869, 120, '2014-03-01 00:57:46.000000', 'temperatura', 1061.0000, 'ºC'),
	(226870, 120, '2014-03-01 00:57:47.000000', 'temperatura', 671.0000, 'ºC'),
	(226871, 120, '2014-03-01 00:57:48.000000', 'temperatura', 172.0000, 'ºC'),
	(226872, 120, '2014-03-01 00:57:49.000000', 'temperatura', 49.0000, 'ºC'),
	(226873, 120, '2014-03-01 00:57:50.000000', 'temperatura', 927.0000, 'ºC'),
	(226874, 120, '2014-03-01 00:57:51.000000', 'temperatura', 891.0000, 'ºC'),
	(226875, 120, '2014-03-01 00:57:52.000000', 'temperatura', 474.0000, 'ºC'),
	(226876, 120, '2014-03-01 00:57:53.000000', 'temperatura', 899.0000, 'ºC'),
	(226877, 120, '2014-03-01 00:57:54.000000', 'temperatura', 673.0000, 'ºC'),
	(226878, 120, '2014-03-01 00:57:55.000000', 'temperatura', 668.0000, 'ºC'),
	(226879, 120, '2014-03-01 00:57:56.000000', 'temperatura', 120.0000, 'ºC'),
	(226880, 120, '2014-03-01 00:57:57.000000', 'temperatura', 999.0000, 'ºC'),
	(226881, 120, '2014-03-01 00:57:58.000000', 'temperatura', 1033.0000, 'ºC'),
	(226882, 120, '2014-03-01 00:57:59.000000', 'temperatura', 968.0000, 'ºC'),
	(226883, 120, '2014-03-01 00:58:00.000000', 'temperatura', 542.0000, 'ºC'),
	(226884, 120, '2014-03-01 00:58:01.000000', 'temperatura', 1007.0000, 'ºC'),
	(226885, 120, '2014-03-01 00:58:02.000000', 'temperatura', 1009.0000, 'ºC'),
	(226886, 120, '2014-03-01 00:58:03.000000', 'temperatura', 824.0000, 'ºC'),
	(226887, 120, '2014-03-01 00:58:04.000000', 'temperatura', 1095.0000, 'ºC'),
	(226888, 120, '2014-03-01 00:58:05.000000', 'temperatura', 605.0000, 'ºC'),
	(226889, 120, '2014-03-01 00:58:06.000000', 'temperatura', 938.0000, 'ºC'),
	(226890, 120, '2014-03-01 00:58:07.000000', 'temperatura', 475.0000, 'ºC'),
	(226891, 120, '2014-03-01 00:58:08.000000', 'temperatura', 763.0000, 'ºC'),
	(226892, 120, '2014-03-01 00:58:09.000000', 'temperatura', 1189.0000, 'ºC'),
	(226893, 120, '2014-03-01 00:58:10.000000', 'temperatura', 56.0000, 'ºC'),
	(226894, 120, '2014-03-01 00:58:11.000000', 'temperatura', 314.0000, 'ºC'),
	(226895, 120, '2014-03-01 00:58:12.000000', 'temperatura', 201.0000, 'ºC'),
	(226896, 120, '2014-03-01 00:58:13.000000', 'temperatura', 64.0000, 'ºC'),
	(226897, 120, '2014-03-01 00:58:14.000000', 'temperatura', 917.0000, 'ºC'),
	(226898, 120, '2014-03-01 00:58:15.000000', 'temperatura', 793.0000, 'ºC'),
	(226899, 120, '2014-03-01 00:58:16.000000', 'temperatura', 15.0000, 'ºC'),
	(226900, 120, '2014-03-01 00:58:17.000000', 'temperatura', 95.0000, 'ºC'),
	(226901, 120, '2014-03-01 00:58:18.000000', 'temperatura', 432.0000, 'ºC'),
	(226902, 120, '2014-03-01 00:58:19.000000', 'temperatura', 675.0000, 'ºC'),
	(226903, 120, '2014-03-01 00:58:20.000000', 'temperatura', 881.0000, 'ºC'),
	(226904, 120, '2014-03-01 00:58:21.000000', 'temperatura', 1178.0000, 'ºC'),
	(226905, 120, '2014-03-01 00:58:22.000000', 'temperatura', 851.0000, 'ºC'),
	(226906, 120, '2014-03-01 00:58:23.000000', 'temperatura', 719.0000, 'ºC'),
	(226907, 120, '2014-03-01 00:58:24.000000', 'temperatura', 1042.0000, 'ºC'),
	(226908, 120, '2014-03-01 00:58:25.000000', 'temperatura', 655.0000, 'ºC'),
	(226909, 120, '2014-03-01 00:58:26.000000', 'temperatura', 150.0000, 'ºC'),
	(226910, 120, '2014-03-01 00:58:27.000000', 'temperatura', 1185.0000, 'ºC'),
	(226911, 120, '2014-03-01 00:58:28.000000', 'temperatura', 676.0000, 'ºC'),
	(226912, 120, '2014-03-01 00:58:29.000000', 'temperatura', 1027.0000, 'ºC'),
	(226913, 120, '2014-03-01 00:58:30.000000', 'temperatura', 705.0000, 'ºC'),
	(226914, 120, '2014-03-01 00:58:31.000000', 'temperatura', 445.0000, 'ºC'),
	(226915, 120, '2014-03-01 00:58:32.000000', 'temperatura', 111.0000, 'ºC'),
	(226916, 120, '2014-03-01 00:58:33.000000', 'temperatura', 419.0000, 'ºC'),
	(226917, 120, '2014-03-01 00:58:34.000000', 'temperatura', 564.0000, 'ºC'),
	(226918, 120, '2014-03-01 00:58:35.000000', 'temperatura', 364.0000, 'ºC'),
	(226919, 120, '2014-03-01 00:58:36.000000', 'temperatura', 127.0000, 'ºC'),
	(226920, 120, '2014-03-01 00:58:37.000000', 'temperatura', 745.0000, 'ºC'),
	(226921, 120, '2014-03-01 00:58:38.000000', 'temperatura', 943.0000, 'ºC'),
	(226922, 120, '2014-03-01 00:58:39.000000', 'temperatura', 82.0000, 'ºC'),
	(226923, 120, '2014-03-01 00:58:40.000000', 'temperatura', 1181.0000, 'ºC'),
	(226924, 120, '2014-03-01 00:58:41.000000', 'temperatura', 859.0000, 'ºC'),
	(226925, 120, '2014-03-01 00:58:42.000000', 'temperatura', 754.0000, 'ºC'),
	(226926, 120, '2014-03-01 00:58:43.000000', 'temperatura', 1193.0000, 'ºC'),
	(226927, 120, '2014-03-01 00:58:44.000000', 'temperatura', 103.0000, 'ºC'),
	(226928, 120, '2014-03-01 00:58:45.000000', 'temperatura', 537.0000, 'ºC'),
	(226929, 120, '2014-03-01 00:58:46.000000', 'temperatura', 1178.0000, 'ºC'),
	(226930, 120, '2014-03-01 00:58:47.000000', 'temperatura', 677.0000, 'ºC'),
	(226931, 120, '2014-03-01 00:58:48.000000', 'temperatura', 1052.0000, 'ºC'),
	(226932, 120, '2014-03-01 00:58:49.000000', 'temperatura', 831.0000, 'ºC'),
	(226933, 120, '2014-03-01 00:58:50.000000', 'temperatura', 998.0000, 'ºC'),
	(226934, 120, '2014-03-01 00:58:51.000000', 'temperatura', 96.0000, 'ºC'),
	(226935, 120, '2014-03-01 00:58:52.000000', 'temperatura', 1089.0000, 'ºC'),
	(226936, 120, '2014-03-01 00:58:53.000000', 'temperatura', 355.0000, 'ºC'),
	(226937, 120, '2014-03-01 00:58:54.000000', 'temperatura', 910.0000, 'ºC'),
	(226938, 120, '2014-03-01 00:58:55.000000', 'temperatura', 1087.0000, 'ºC'),
	(226939, 120, '2014-03-01 00:58:56.000000', 'temperatura', 302.0000, 'ºC'),
	(226940, 120, '2014-03-01 00:58:57.000000', 'temperatura', 653.0000, 'ºC'),
	(226941, 120, '2014-03-01 00:58:58.000000', 'temperatura', 1158.0000, 'ºC'),
	(226942, 120, '2014-03-01 00:58:59.000000', 'temperatura', 230.0000, 'ºC'),
	(226943, 120, '2014-03-01 00:59:00.000000', 'temperatura', 79.0000, 'ºC'),
	(226944, 120, '2014-03-01 00:59:01.000000', 'temperatura', 905.0000, 'ºC'),
	(226945, 120, '2014-03-01 00:59:02.000000', 'temperatura', 687.0000, 'ºC'),
	(226946, 120, '2014-03-01 00:59:03.000000', 'temperatura', 722.0000, 'ºC'),
	(226947, 120, '2014-03-01 00:59:04.000000', 'temperatura', 348.0000, 'ºC'),
	(226948, 120, '2014-03-01 00:59:05.000000', 'temperatura', 777.0000, 'ºC'),
	(226949, 120, '2014-03-01 00:59:06.000000', 'temperatura', 440.0000, 'ºC'),
	(226950, 120, '2014-03-01 00:59:07.000000', 'temperatura', 1071.0000, 'ºC'),
	(226951, 120, '2014-03-01 00:59:08.000000', 'temperatura', 434.0000, 'ºC'),
	(226952, 120, '2014-03-01 00:59:09.000000', 'temperatura', 160.0000, 'ºC'),
	(226953, 120, '2014-03-01 00:59:10.000000', 'temperatura', 695.0000, 'ºC'),
	(226954, 120, '2014-03-01 00:59:11.000000', 'temperatura', 598.0000, 'ºC'),
	(226955, 120, '2014-03-01 00:59:12.000000', 'temperatura', 905.0000, 'ºC'),
	(226956, 120, '2014-03-01 00:59:13.000000', 'temperatura', 332.0000, 'ºC'),
	(226957, 120, '2014-03-01 00:59:14.000000', 'temperatura', 147.0000, 'ºC'),
	(226958, 120, '2014-03-01 00:59:15.000000', 'temperatura', 937.0000, 'ºC'),
	(226959, 120, '2014-03-01 00:59:16.000000', 'temperatura', 646.0000, 'ºC'),
	(226960, 120, '2014-03-01 00:59:17.000000', 'temperatura', 417.0000, 'ºC'),
	(226961, 120, '2014-03-01 00:59:18.000000', 'temperatura', 151.0000, 'ºC'),
	(226962, 120, '2014-03-01 00:59:19.000000', 'temperatura', 701.0000, 'ºC'),
	(226963, 120, '2014-03-01 00:59:20.000000', 'temperatura', 655.0000, 'ºC'),
	(226964, 120, '2014-03-01 00:59:21.000000', 'temperatura', 1173.0000, 'ºC'),
	(226965, 120, '2014-03-01 00:59:22.000000', 'temperatura', 301.0000, 'ºC'),
	(226966, 120, '2014-03-01 00:59:23.000000', 'temperatura', 387.0000, 'ºC'),
	(226967, 120, '2014-03-01 00:59:24.000000', 'temperatura', 1031.0000, 'ºC'),
	(226968, 120, '2014-03-01 00:59:25.000000', 'temperatura', 395.0000, 'ºC'),
	(226969, 120, '2014-03-01 00:59:26.000000', 'temperatura', 84.0000, 'ºC'),
	(226970, 120, '2014-03-01 00:59:27.000000', 'temperatura', 433.0000, 'ºC'),
	(226971, 120, '2014-03-01 00:59:28.000000', 'temperatura', 713.0000, 'ºC'),
	(226972, 120, '2014-03-01 00:59:29.000000', 'temperatura', 1067.0000, 'ºC'),
	(226973, 120, '2014-03-01 00:59:30.000000', 'temperatura', 796.0000, 'ºC'),
	(226974, 120, '2014-03-01 00:59:31.000000', 'temperatura', 778.0000, 'ºC'),
	(226975, 120, '2014-03-01 00:59:32.000000', 'temperatura', 306.0000, 'ºC'),
	(226976, 120, '2014-03-01 00:59:33.000000', 'temperatura', 395.0000, 'ºC'),
	(226977, 120, '2014-03-01 00:59:34.000000', 'temperatura', 1059.0000, 'ºC'),
	(226978, 120, '2014-03-01 00:59:35.000000', 'temperatura', 511.0000, 'ºC'),
	(226979, 120, '2014-03-01 00:59:36.000000', 'temperatura', 579.0000, 'ºC'),
	(226980, 120, '2014-03-01 00:59:37.000000', 'temperatura', 162.0000, 'ºC'),
	(226981, 120, '2014-03-01 00:59:38.000000', 'temperatura', 272.0000, 'ºC'),
	(226982, 120, '2014-03-01 00:59:39.000000', 'temperatura', 874.0000, 'ºC'),
	(226983, 120, '2014-03-01 00:59:40.000000', 'temperatura', 1154.0000, 'ºC'),
	(226984, 120, '2014-03-01 00:59:41.000000', 'temperatura', 750.0000, 'ºC'),
	(226985, 120, '2014-03-01 00:59:42.000000', 'temperatura', 286.0000, 'ºC'),
	(226986, 120, '2014-03-01 00:59:43.000000', 'temperatura', 384.0000, 'ºC'),
	(226987, 120, '2014-03-01 00:59:44.000000', 'temperatura', 1060.0000, 'ºC'),
	(226988, 120, '2014-03-01 00:59:45.000000', 'temperatura', 549.0000, 'ºC'),
	(226989, 120, '2014-03-01 00:59:46.000000', 'temperatura', 765.0000, 'ºC'),
	(226990, 120, '2014-03-01 00:59:47.000000', 'temperatura', 981.0000, 'ºC'),
	(226991, 120, '2014-03-01 00:59:48.000000', 'temperatura', 209.0000, 'ºC'),
	(226992, 120, '2014-03-01 00:59:49.000000', 'temperatura', 502.0000, 'ºC'),
	(226993, 120, '2014-03-01 00:59:50.000000', 'temperatura', 684.0000, 'ºC'),
	(226994, 120, '2014-03-01 00:59:51.000000', 'temperatura', 713.0000, 'ºC'),
	(226995, 120, '2014-03-01 00:59:52.000000', 'temperatura', 315.0000, 'ºC'),
	(226996, 120, '2014-03-01 00:59:53.000000', 'temperatura', 635.0000, 'ºC'),
	(226997, 120, '2014-03-01 00:59:54.000000', 'temperatura', 1032.0000, 'ºC'),
	(226998, 120, '2014-03-01 00:59:55.000000', 'temperatura', 856.0000, 'ºC'),
	(226999, 120, '2014-03-01 00:59:56.000000', 'temperatura', 1185.0000, 'ºC'),
	(227000, 120, '2014-03-01 00:59:57.000000', 'temperatura', 957.0000, 'ºC'),
	(227001, 120, '2014-03-01 00:59:58.000000', 'temperatura', 28.0000, 'ºC'),
	(227002, 120, '2014-03-01 00:59:59.000000', 'temperatura', 873.0000, 'ºC'),
	(227003, 120, '2014-03-01 01:00:00.000000', 'temperatura', 681.0000, 'ºC'),
	(227004, 120, '2014-03-01 01:00:01.000000', 'temperatura', 786.0000, 'ºC'),
	(227005, 120, '2014-03-01 01:00:02.000000', 'temperatura', 687.0000, 'ºC'),
	(227006, 120, '2014-03-01 01:00:03.000000', 'temperatura', 1079.0000, 'ºC'),
	(227007, 120, '2014-03-01 01:00:04.000000', 'temperatura', 935.0000, 'ºC'),
	(227008, 120, '2014-03-01 01:00:05.000000', 'temperatura', 237.0000, 'ºC'),
	(227009, 120, '2014-03-01 01:00:06.000000', 'temperatura', 782.0000, 'ºC'),
	(227010, 120, '2014-03-01 01:00:07.000000', 'temperatura', 797.0000, 'ºC'),
	(227011, 120, '2014-03-01 01:00:08.000000', 'temperatura', 441.0000, 'ºC'),
	(227012, 120, '2014-03-01 01:00:09.000000', 'temperatura', 1014.0000, 'ºC'),
	(227013, 120, '2014-03-01 01:00:10.000000', 'temperatura', 147.0000, 'ºC'),
	(227014, 120, '2014-03-01 01:00:11.000000', 'temperatura', 92.0000, 'ºC'),
	(227015, 120, '2014-03-01 01:00:12.000000', 'temperatura', 22.0000, 'ºC'),
	(227016, 120, '2014-03-01 01:00:13.000000', 'temperatura', 1034.0000, 'ºC'),
	(227017, 120, '2014-03-01 01:00:14.000000', 'temperatura', 304.0000, 'ºC'),
	(227018, 120, '2014-03-01 01:00:15.000000', 'temperatura', 820.0000, 'ºC'),
	(227019, 120, '2014-03-01 01:00:16.000000', 'temperatura', 788.0000, 'ºC'),
	(227020, 120, '2014-03-01 01:00:17.000000', 'temperatura', 279.0000, 'ºC'),
	(227021, 120, '2014-03-01 01:00:18.000000', 'temperatura', 231.0000, 'ºC'),
	(227022, 120, '2014-03-01 01:00:19.000000', 'temperatura', 321.0000, 'ºC'),
	(227023, 120, '2014-03-01 01:00:20.000000', 'temperatura', 910.0000, 'ºC'),
	(227024, 120, '2014-03-01 01:00:21.000000', 'temperatura', 1187.0000, 'ºC'),
	(227025, 120, '2014-03-01 01:00:22.000000', 'temperatura', 806.0000, 'ºC'),
	(227026, 120, '2014-03-01 01:00:23.000000', 'temperatura', 471.0000, 'ºC'),
	(227027, 120, '2014-03-01 01:00:24.000000', 'temperatura', 1135.0000, 'ºC'),
	(227028, 120, '2014-03-01 01:00:25.000000', 'temperatura', 662.0000, 'ºC'),
	(227029, 120, '2014-03-01 01:00:26.000000', 'temperatura', 1106.0000, 'ºC'),
	(227030, 120, '2014-03-01 01:00:27.000000', 'temperatura', 1145.0000, 'ºC'),
	(227031, 120, '2014-03-01 01:00:28.000000', 'temperatura', 9.0000, 'ºC'),
	(227032, 120, '2014-03-01 01:00:29.000000', 'temperatura', 210.0000, 'ºC'),
	(227033, 120, '2014-03-01 01:00:30.000000', 'temperatura', 1021.0000, 'ºC'),
	(227034, 120, '2014-03-01 01:00:31.000000', 'temperatura', 878.0000, 'ºC'),
	(227035, 120, '2014-03-01 01:00:32.000000', 'temperatura', 125.0000, 'ºC'),
	(227036, 120, '2014-03-01 01:00:33.000000', 'temperatura', 393.0000, 'ºC'),
	(227037, 120, '2014-03-01 01:00:34.000000', 'temperatura', 390.0000, 'ºC'),
	(227038, 120, '2014-03-01 01:00:35.000000', 'temperatura', 771.0000, 'ºC'),
	(227039, 120, '2014-03-01 01:00:36.000000', 'temperatura', 286.0000, 'ºC'),
	(227040, 120, '2014-03-01 01:00:37.000000', 'temperatura', 319.0000, 'ºC'),
	(227041, 120, '2014-03-01 01:00:38.000000', 'temperatura', 735.0000, 'ºC'),
	(227042, 120, '2014-03-01 01:00:39.000000', 'temperatura', 318.0000, 'ºC'),
	(227043, 120, '2014-03-01 01:00:40.000000', 'temperatura', 587.0000, 'ºC'),
	(227044, 120, '2014-03-01 01:00:41.000000', 'temperatura', 780.0000, 'ºC'),
	(227045, 120, '2014-03-01 01:00:42.000000', 'temperatura', 941.0000, 'ºC'),
	(227046, 120, '2014-03-01 01:00:43.000000', 'temperatura', 1163.0000, 'ºC'),
	(227047, 120, '2014-03-01 01:00:44.000000', 'temperatura', 594.0000, 'ºC'),
	(227048, 120, '2014-03-01 01:00:45.000000', 'temperatura', 683.0000, 'ºC'),
	(227049, 120, '2014-03-01 01:00:46.000000', 'temperatura', 432.0000, 'ºC'),
	(227050, 120, '2014-03-01 01:00:47.000000', 'temperatura', 112.0000, 'ºC'),
	(227051, 120, '2014-03-01 01:00:48.000000', 'temperatura', 464.0000, 'ºC'),
	(227052, 120, '2014-03-01 01:00:49.000000', 'temperatura', 786.0000, 'ºC'),
	(227053, 120, '2014-03-01 01:00:50.000000', 'temperatura', 138.0000, 'ºC'),
	(227054, 120, '2014-03-01 01:00:51.000000', 'temperatura', 732.0000, 'ºC'),
	(227055, 120, '2014-03-01 01:00:52.000000', 'temperatura', 848.0000, 'ºC'),
	(227056, 120, '2014-03-01 01:00:53.000000', 'temperatura', 845.0000, 'ºC'),
	(227057, 120, '2014-03-01 01:00:54.000000', 'temperatura', 482.0000, 'ºC'),
	(227058, 120, '2014-03-01 01:00:55.000000', 'temperatura', 1074.0000, 'ºC'),
	(227059, 120, '2014-03-01 01:00:56.000000', 'temperatura', 323.0000, 'ºC'),
	(227060, 120, '2014-03-01 01:00:57.000000', 'temperatura', 794.0000, 'ºC'),
	(227061, 120, '2014-03-01 01:00:58.000000', 'temperatura', 604.0000, 'ºC'),
	(227062, 120, '2014-03-01 01:00:59.000000', 'temperatura', 637.0000, 'ºC'),
	(227063, 120, '2014-03-01 01:01:00.000000', 'temperatura', 175.0000, 'ºC'),
	(227064, 120, '2014-03-01 01:01:01.000000', 'temperatura', 165.0000, 'ºC'),
	(227065, 120, '2014-03-01 01:01:02.000000', 'temperatura', 300.0000, 'ºC'),
	(227066, 120, '2014-03-01 01:01:03.000000', 'temperatura', 1005.0000, 'ºC'),
	(227067, 120, '2014-03-01 01:01:04.000000', 'temperatura', 525.0000, 'ºC'),
	(227068, 120, '2014-03-01 01:01:05.000000', 'temperatura', 813.0000, 'ºC'),
	(227069, 120, '2014-03-01 01:01:06.000000', 'temperatura', 88.0000, 'ºC'),
	(227070, 120, '2014-03-01 01:01:07.000000', 'temperatura', 401.0000, 'ºC'),
	(227071, 120, '2014-03-01 01:01:08.000000', 'temperatura', 544.0000, 'ºC'),
	(227072, 120, '2014-03-01 01:01:09.000000', 'temperatura', 314.0000, 'ºC'),
	(227073, 120, '2014-03-01 01:01:10.000000', 'temperatura', 1142.0000, 'ºC'),
	(227074, 120, '2014-03-01 01:01:11.000000', 'temperatura', 1167.0000, 'ºC'),
	(227075, 120, '2014-03-01 01:01:12.000000', 'temperatura', 11.0000, 'ºC'),
	(227076, 120, '2014-03-01 01:01:13.000000', 'temperatura', 152.0000, 'ºC'),
	(227077, 120, '2014-03-01 01:01:14.000000', 'temperatura', 728.0000, 'ºC'),
	(227078, 120, '2014-03-01 01:01:15.000000', 'temperatura', 785.0000, 'ºC'),
	(227079, 120, '2014-03-01 01:01:16.000000', 'temperatura', 541.0000, 'ºC'),
	(227080, 120, '2014-03-01 01:01:17.000000', 'temperatura', 350.0000, 'ºC'),
	(227081, 120, '2014-03-01 01:01:18.000000', 'temperatura', 130.0000, 'ºC'),
	(227082, 120, '2014-03-01 01:01:19.000000', 'temperatura', 798.0000, 'ºC'),
	(227083, 120, '2014-03-01 01:01:20.000000', 'temperatura', 3.0000, 'ºC'),
	(227084, 120, '2014-03-01 01:01:21.000000', 'temperatura', 20.0000, 'ºC'),
	(227085, 120, '2014-03-01 01:01:22.000000', 'temperatura', 92.0000, 'ºC'),
	(227086, 120, '2014-03-01 01:01:23.000000', 'temperatura', 399.0000, 'ºC'),
	(227087, 120, '2014-03-01 01:01:24.000000', 'temperatura', 520.0000, 'ºC'),
	(227088, 120, '2014-03-01 01:01:25.000000', 'temperatura', 203.0000, 'ºC'),
	(227089, 120, '2014-03-01 01:01:26.000000', 'temperatura', 658.0000, 'ºC'),
	(227090, 120, '2014-03-01 01:01:27.000000', 'temperatura', 281.0000, 'ºC'),
	(227091, 120, '2014-03-01 01:01:28.000000', 'temperatura', 630.0000, 'ºC'),
	(227092, 120, '2014-03-01 01:01:29.000000', 'temperatura', 1109.0000, 'ºC'),
	(227093, 120, '2014-03-01 01:01:30.000000', 'temperatura', 54.0000, 'ºC'),
	(227094, 120, '2014-03-01 01:01:31.000000', 'temperatura', 544.0000, 'ºC'),
	(227095, 120, '2014-03-01 01:01:32.000000', 'temperatura', 160.0000, 'ºC'),
	(227096, 120, '2014-03-01 01:01:33.000000', 'temperatura', 370.0000, 'ºC'),
	(227097, 120, '2014-03-01 01:01:34.000000', 'temperatura', 167.0000, 'ºC'),
	(227098, 120, '2014-03-01 01:01:35.000000', 'temperatura', 928.0000, 'ºC'),
	(227099, 120, '2014-03-01 01:01:36.000000', 'temperatura', 538.0000, 'ºC'),
	(227100, 120, '2014-03-01 01:01:37.000000', 'temperatura', 1109.0000, 'ºC'),
	(227101, 120, '2014-03-01 01:01:38.000000', 'temperatura', 329.0000, 'ºC'),
	(227102, 120, '2014-03-01 01:01:39.000000', 'temperatura', 718.0000, 'ºC'),
	(227103, 120, '2014-03-01 01:01:40.000000', 'temperatura', 203.0000, 'ºC'),
	(227104, 120, '2014-03-01 01:01:41.000000', 'temperatura', 63.0000, 'ºC'),
	(227105, 120, '2014-03-01 01:01:42.000000', 'temperatura', 908.0000, 'ºC'),
	(227106, 120, '2014-03-01 01:01:43.000000', 'temperatura', 748.0000, 'ºC'),
	(227107, 120, '2014-03-01 01:01:44.000000', 'temperatura', 1019.0000, 'ºC'),
	(227108, 120, '2014-03-01 01:01:45.000000', 'temperatura', 452.0000, 'ºC'),
	(227109, 120, '2014-03-01 01:01:46.000000', 'temperatura', 403.0000, 'ºC'),
	(227110, 120, '2014-03-01 01:01:47.000000', 'temperatura', 661.0000, 'ºC'),
	(227111, 120, '2014-03-01 01:01:48.000000', 'temperatura', 896.0000, 'ºC'),
	(227112, 120, '2014-03-01 01:01:49.000000', 'temperatura', 98.0000, 'ºC'),
	(227113, 120, '2014-03-01 01:01:50.000000', 'temperatura', 202.0000, 'ºC'),
	(227114, 120, '2014-03-01 01:01:51.000000', 'temperatura', 714.0000, 'ºC'),
	(227115, 120, '2014-03-01 01:01:52.000000', 'temperatura', 568.0000, 'ºC'),
	(227116, 120, '2014-03-01 01:01:53.000000', 'temperatura', 695.0000, 'ºC'),
	(227117, 120, '2014-03-01 01:01:54.000000', 'temperatura', 575.0000, 'ºC'),
	(227118, 120, '2014-03-01 01:01:55.000000', 'temperatura', 790.0000, 'ºC'),
	(227119, 120, '2014-03-01 01:01:56.000000', 'temperatura', 1024.0000, 'ºC'),
	(227120, 120, '2014-03-01 01:01:57.000000', 'temperatura', 353.0000, 'ºC'),
	(227121, 120, '2014-03-01 01:01:58.000000', 'temperatura', 1090.0000, 'ºC'),
	(227122, 120, '2014-03-01 01:01:59.000000', 'temperatura', 793.0000, 'ºC'),
	(227123, 120, '2014-03-01 01:02:00.000000', 'temperatura', 697.0000, 'ºC'),
	(227124, 120, '2014-03-01 01:02:01.000000', 'temperatura', 1105.0000, 'ºC'),
	(227125, 120, '2014-03-01 01:02:02.000000', 'temperatura', 1037.0000, 'ºC'),
	(227126, 120, '2014-03-01 01:02:03.000000', 'temperatura', 669.0000, 'ºC'),
	(227127, 120, '2014-03-01 01:02:04.000000', 'temperatura', 233.0000, 'ºC'),
	(227128, 120, '2014-03-01 01:02:05.000000', 'temperatura', 358.0000, 'ºC'),
	(227129, 120, '2014-03-01 01:02:06.000000', 'temperatura', 1094.0000, 'ºC'),
	(227130, 120, '2014-03-01 01:02:07.000000', 'temperatura', 794.0000, 'ºC'),
	(227131, 120, '2014-03-01 01:02:08.000000', 'temperatura', 689.0000, 'ºC'),
	(227132, 120, '2014-03-01 01:02:09.000000', 'temperatura', 1063.0000, 'ºC'),
	(227133, 120, '2014-03-01 01:02:10.000000', 'temperatura', 849.0000, 'ºC'),
	(227134, 120, '2014-03-01 01:02:11.000000', 'temperatura', 1057.0000, 'ºC'),
	(227135, 120, '2014-03-01 01:02:12.000000', 'temperatura', 338.0000, 'ºC'),
	(227136, 120, '2014-03-01 01:02:13.000000', 'temperatura', 920.0000, 'ºC'),
	(227137, 120, '2014-03-01 01:02:14.000000', 'temperatura', 1186.0000, 'ºC'),
	(227138, 120, '2014-03-01 01:02:15.000000', 'temperatura', 769.0000, 'ºC'),
	(227139, 120, '2014-03-01 01:02:16.000000', 'temperatura', 289.0000, 'ºC'),
	(227140, 120, '2014-03-01 01:02:17.000000', 'temperatura', 338.0000, 'ºC'),
	(227141, 120, '2014-03-01 01:02:18.000000', 'temperatura', 824.0000, 'ºC'),
	(227142, 120, '2014-03-01 01:02:19.000000', 'temperatura', 708.0000, 'ºC'),
	(227143, 120, '2014-03-01 01:02:20.000000', 'temperatura', 1065.0000, 'ºC'),
	(227144, 120, '2014-03-01 01:02:21.000000', 'temperatura', 804.0000, 'ºC'),
	(227145, 120, '2014-03-01 01:02:22.000000', 'temperatura', 825.0000, 'ºC'),
	(227146, 120, '2014-03-01 01:02:23.000000', 'temperatura', 514.0000, 'ºC'),
	(227147, 120, '2014-03-01 01:02:24.000000', 'temperatura', 95.0000, 'ºC'),
	(227148, 120, '2014-03-01 01:02:25.000000', 'temperatura', 133.0000, 'ºC'),
	(227149, 120, '2014-03-01 01:02:26.000000', 'temperatura', 380.0000, 'ºC'),
	(227150, 120, '2014-03-01 01:02:27.000000', 'temperatura', 301.0000, 'ºC'),
	(227151, 120, '2014-03-01 01:02:28.000000', 'temperatura', 367.0000, 'ºC'),
	(227152, 120, '2014-03-01 01:02:29.000000', 'temperatura', 931.0000, 'ºC'),
	(227153, 120, '2014-03-01 01:02:30.000000', 'temperatura', 1156.0000, 'ºC'),
	(227154, 120, '2014-03-01 01:02:31.000000', 'temperatura', 586.0000, 'ºC'),
	(227155, 120, '2014-03-01 01:02:32.000000', 'temperatura', 662.0000, 'ºC'),
	(227156, 120, '2014-03-01 01:02:33.000000', 'temperatura', 354.0000, 'ºC'),
	(227157, 120, '2014-03-01 01:02:34.000000', 'temperatura', 982.0000, 'ºC'),
	(227158, 120, '2014-03-01 01:02:35.000000', 'temperatura', 252.0000, 'ºC'),
	(227159, 120, '2014-03-01 01:02:36.000000', 'temperatura', 713.0000, 'ºC'),
	(227160, 120, '2014-03-01 01:02:37.000000', 'temperatura', 410.0000, 'ºC'),
	(227161, 120, '2014-03-01 01:02:38.000000', 'temperatura', 1109.0000, 'ºC'),
	(227162, 120, '2014-03-01 01:02:39.000000', 'temperatura', 717.0000, 'ºC'),
	(227163, 120, '2014-03-01 01:02:40.000000', 'temperatura', 260.0000, 'ºC'),
	(227164, 120, '2014-03-01 01:02:41.000000', 'temperatura', 350.0000, 'ºC'),
	(227165, 120, '2014-03-01 01:02:42.000000', 'temperatura', 968.0000, 'ºC'),
	(227166, 120, '2014-03-01 01:02:43.000000', 'temperatura', 193.0000, 'ºC'),
	(227167, 120, '2014-03-01 01:02:44.000000', 'temperatura', 461.0000, 'ºC'),
	(227168, 120, '2014-03-01 01:02:45.000000', 'temperatura', 526.0000, 'ºC'),
	(227169, 120, '2014-03-01 01:02:46.000000', 'temperatura', 48.0000, 'ºC'),
	(227170, 120, '2014-03-01 01:02:47.000000', 'temperatura', 1064.0000, 'ºC'),
	(227171, 120, '2014-03-01 01:02:48.000000', 'temperatura', 374.0000, 'ºC'),
	(227172, 120, '2014-03-01 01:02:49.000000', 'temperatura', 1078.0000, 'ºC'),
	(227173, 120, '2014-03-01 01:02:50.000000', 'temperatura', 668.0000, 'ºC'),
	(227174, 120, '2014-03-01 01:02:51.000000', 'temperatura', 109.0000, 'ºC'),
	(227175, 120, '2014-03-01 01:02:52.000000', 'temperatura', 941.0000, 'ºC'),
	(227176, 120, '2014-03-01 01:02:53.000000', 'temperatura', 780.0000, 'ºC'),
	(227177, 120, '2014-03-01 01:02:54.000000', 'temperatura', 1075.0000, 'ºC'),
	(227178, 120, '2014-03-01 01:02:55.000000', 'temperatura', 637.0000, 'ºC'),
	(227179, 120, '2014-03-01 01:02:56.000000', 'temperatura', 1162.0000, 'ºC'),
	(227180, 120, '2014-03-01 01:02:57.000000', 'temperatura', 297.0000, 'ºC'),
	(227181, 120, '2014-03-01 01:02:58.000000', 'temperatura', 401.0000, 'ºC'),
	(227182, 120, '2014-03-01 01:02:59.000000', 'temperatura', 1113.0000, 'ºC'),
	(227183, 120, '2014-03-01 01:03:00.000000', 'temperatura', 765.0000, 'ºC'),
	(227184, 120, '2014-03-01 01:03:01.000000', 'temperatura', 485.0000, 'ºC'),
	(227185, 120, '2014-03-01 01:03:02.000000', 'temperatura', 129.0000, 'ºC'),
	(227186, 120, '2014-03-01 01:03:03.000000', 'temperatura', 390.0000, 'ºC'),
	(227187, 120, '2014-03-01 01:03:04.000000', 'temperatura', 366.0000, 'ºC'),
	(227188, 120, '2014-03-01 01:03:05.000000', 'temperatura', 661.0000, 'ºC'),
	(227189, 120, '2014-03-01 01:03:06.000000', 'temperatura', 1006.0000, 'ºC'),
	(227190, 120, '2014-03-01 01:03:07.000000', 'temperatura', 650.0000, 'ºC'),
	(227191, 120, '2014-03-01 01:03:08.000000', 'temperatura', 229.0000, 'ºC'),
	(227192, 120, '2014-03-01 01:03:09.000000', 'temperatura', 398.0000, 'ºC'),
	(227193, 120, '2014-03-01 01:03:10.000000', 'temperatura', 101.0000, 'ºC'),
	(227194, 120, '2014-03-01 01:03:11.000000', 'temperatura', 513.0000, 'ºC'),
	(227195, 120, '2014-03-01 01:03:12.000000', 'temperatura', 1062.0000, 'ºC'),
	(227196, 120, '2014-03-01 01:03:13.000000', 'temperatura', 172.0000, 'ºC'),
	(227197, 120, '2014-03-01 01:03:14.000000', 'temperatura', 75.0000, 'ºC'),
	(227198, 120, '2014-03-01 01:03:15.000000', 'temperatura', 1060.0000, 'ºC'),
	(227199, 120, '2014-03-01 01:03:16.000000', 'temperatura', 275.0000, 'ºC'),
	(227200, 120, '2014-03-01 01:03:17.000000', 'temperatura', 597.0000, 'ºC'),
	(227201, 120, '2014-03-01 01:03:18.000000', 'temperatura', 959.0000, 'ºC'),
	(227202, 120, '2014-03-01 01:03:19.000000', 'temperatura', 604.0000, 'ºC'),
	(227203, 120, '2014-03-01 01:03:20.000000', 'temperatura', 146.0000, 'ºC'),
	(227204, 120, '2014-03-01 01:03:21.000000', 'temperatura', 116.0000, 'ºC'),
	(227205, 120, '2014-03-01 01:03:22.000000', 'temperatura', 142.0000, 'ºC'),
	(227206, 120, '2014-03-01 01:03:23.000000', 'temperatura', 363.0000, 'ºC'),
	(227207, 120, '2014-03-01 01:03:24.000000', 'temperatura', 192.0000, 'ºC'),
	(227208, 120, '2014-03-01 01:03:25.000000', 'temperatura', 1068.0000, 'ºC'),
	(227209, 120, '2014-03-01 01:03:26.000000', 'temperatura', 1167.0000, 'ºC'),
	(227210, 120, '2014-03-01 01:03:27.000000', 'temperatura', 229.0000, 'ºC'),
	(227211, 120, '2014-03-01 01:03:28.000000', 'temperatura', 46.0000, 'ºC'),
	(227212, 120, '2014-03-01 01:03:29.000000', 'temperatura', 743.0000, 'ºC'),
	(227213, 120, '2014-03-01 01:03:30.000000', 'temperatura', 1180.0000, 'ºC'),
	(227214, 120, '2014-03-01 01:03:31.000000', 'temperatura', 69.0000, 'ºC'),
	(227215, 120, '2014-03-01 01:03:32.000000', 'temperatura', 404.0000, 'ºC'),
	(227216, 120, '2014-03-01 01:03:33.000000', 'temperatura', 616.0000, 'ºC'),
	(227217, 120, '2014-03-01 01:03:34.000000', 'temperatura', 667.0000, 'ºC'),
	(227218, 120, '2014-03-01 01:03:35.000000', 'temperatura', 289.0000, 'ºC'),
	(227219, 120, '2014-03-01 01:03:36.000000', 'temperatura', 645.0000, 'ºC'),
	(227220, 120, '2014-03-01 01:03:37.000000', 'temperatura', 1157.0000, 'ºC'),
	(227221, 120, '2014-03-01 01:03:38.000000', 'temperatura', 250.0000, 'ºC'),
	(227222, 120, '2014-03-01 01:03:39.000000', 'temperatura', 179.0000, 'ºC'),
	(227223, 120, '2014-03-01 01:03:40.000000', 'temperatura', 146.0000, 'ºC'),
	(227224, 120, '2014-03-01 01:03:41.000000', 'temperatura', 194.0000, 'ºC'),
	(227225, 120, '2014-03-01 01:03:42.000000', 'temperatura', 534.0000, 'ºC'),
	(227226, 120, '2014-03-01 01:03:43.000000', 'temperatura', 888.0000, 'ºC'),
	(227227, 120, '2014-03-01 01:03:44.000000', 'temperatura', 439.0000, 'ºC'),
	(227228, 120, '2014-03-01 01:03:45.000000', 'temperatura', 732.0000, 'ºC'),
	(227229, 120, '2014-03-01 01:03:46.000000', 'temperatura', 1143.0000, 'ºC'),
	(227230, 120, '2014-03-01 01:03:47.000000', 'temperatura', 1118.0000, 'ºC'),
	(227231, 120, '2014-03-01 01:03:48.000000', 'temperatura', 962.0000, 'ºC'),
	(227232, 120, '2014-03-01 01:03:49.000000', 'temperatura', 258.0000, 'ºC'),
	(227233, 120, '2014-03-01 01:03:50.000000', 'temperatura', 803.0000, 'ºC'),
	(227234, 120, '2014-03-01 01:03:51.000000', 'temperatura', 842.0000, 'ºC'),
	(227235, 120, '2014-03-01 01:03:52.000000', 'temperatura', 603.0000, 'ºC'),
	(227236, 120, '2014-03-01 01:03:53.000000', 'temperatura', 487.0000, 'ºC'),
	(227237, 120, '2014-03-01 01:03:54.000000', 'temperatura', 630.0000, 'ºC'),
	(227238, 120, '2014-03-01 01:03:55.000000', 'temperatura', 486.0000, 'ºC'),
	(227239, 120, '2014-03-01 01:03:56.000000', 'temperatura', 541.0000, 'ºC'),
	(227240, 120, '2014-03-01 01:03:57.000000', 'temperatura', 48.0000, 'ºC'),
	(227241, 120, '2014-03-01 01:03:58.000000', 'temperatura', 1017.0000, 'ºC'),
	(227242, 120, '2014-03-01 01:03:59.000000', 'temperatura', 144.0000, 'ºC'),
	(227243, 120, '2014-03-01 01:04:00.000000', 'temperatura', 67.0000, 'ºC'),
	(227244, 120, '2014-03-01 01:04:01.000000', 'temperatura', 1106.0000, 'ºC'),
	(227245, 120, '2014-03-01 01:04:02.000000', 'temperatura', 526.0000, 'ºC'),
	(227246, 120, '2014-03-01 01:04:03.000000', 'temperatura', 516.0000, 'ºC'),
	(227247, 120, '2014-03-01 01:04:04.000000', 'temperatura', 1002.0000, 'ºC'),
	(227248, 120, '2014-03-01 01:04:05.000000', 'temperatura', 1060.0000, 'ºC'),
	(227249, 120, '2014-03-01 01:04:06.000000', 'temperatura', 1096.0000, 'ºC'),
	(227250, 120, '2014-03-01 01:04:07.000000', 'temperatura', 1100.0000, 'ºC'),
	(227251, 120, '2014-03-01 01:04:08.000000', 'temperatura', 1011.0000, 'ºC'),
	(227252, 120, '2014-03-01 01:04:09.000000', 'temperatura', 558.0000, 'ºC'),
	(227253, 120, '2014-03-01 01:04:10.000000', 'temperatura', 958.0000, 'ºC'),
	(227254, 120, '2014-03-01 01:04:11.000000', 'temperatura', 715.0000, 'ºC'),
	(227255, 120, '2014-03-01 01:04:12.000000', 'temperatura', 701.0000, 'ºC'),
	(227256, 120, '2014-03-01 01:04:13.000000', 'temperatura', 159.0000, 'ºC'),
	(227257, 120, '2014-03-01 01:04:14.000000', 'temperatura', 1095.0000, 'ºC'),
	(227258, 120, '2014-03-01 01:04:15.000000', 'temperatura', 199.0000, 'ºC'),
	(227259, 120, '2014-03-01 01:04:16.000000', 'temperatura', 109.0000, 'ºC'),
	(227260, 120, '2014-03-01 01:04:17.000000', 'temperatura', 1149.0000, 'ºC'),
	(227261, 120, '2014-03-01 01:04:18.000000', 'temperatura', 619.0000, 'ºC'),
	(227262, 120, '2014-03-01 01:04:19.000000', 'temperatura', 846.0000, 'ºC'),
	(227263, 120, '2014-03-01 01:04:20.000000', 'temperatura', 1175.0000, 'ºC'),
	(227264, 120, '2014-03-01 01:04:21.000000', 'temperatura', 939.0000, 'ºC'),
	(227265, 120, '2014-03-01 01:04:22.000000', 'temperatura', 1171.0000, 'ºC'),
	(227266, 120, '2014-03-01 01:04:23.000000', 'temperatura', 637.0000, 'ºC'),
	(227267, 120, '2014-03-01 01:04:24.000000', 'temperatura', 874.0000, 'ºC'),
	(227268, 120, '2014-03-01 01:04:25.000000', 'temperatura', 60.0000, 'ºC'),
	(227269, 120, '2014-03-01 01:04:26.000000', 'temperatura', 80.0000, 'ºC'),
	(227270, 120, '2014-03-01 01:04:27.000000', 'temperatura', 217.0000, 'ºC'),
	(227271, 120, '2014-03-01 01:04:28.000000', 'temperatura', 846.0000, 'ºC'),
	(227272, 120, '2014-03-01 01:04:29.000000', 'temperatura', 1179.0000, 'ºC'),
	(227273, 120, '2014-03-01 01:04:30.000000', 'temperatura', 956.0000, 'ºC'),
	(227274, 120, '2014-03-01 01:04:31.000000', 'temperatura', 47.0000, 'ºC'),
	(227275, 120, '2014-03-01 01:04:32.000000', 'temperatura', 964.0000, 'ºC'),
	(227276, 120, '2014-03-01 01:04:33.000000', 'temperatura', 1082.0000, 'ºC'),
	(227277, 120, '2014-03-01 01:04:34.000000', 'temperatura', 119.0000, 'ºC'),
	(227278, 120, '2014-03-01 01:04:35.000000', 'temperatura', 948.0000, 'ºC'),
	(227279, 120, '2014-03-01 01:04:36.000000', 'temperatura', 784.0000, 'ºC'),
	(227280, 120, '2014-03-01 01:04:37.000000', 'temperatura', 1076.0000, 'ºC'),
	(227281, 120, '2014-03-01 01:04:38.000000', 'temperatura', 630.0000, 'ºC'),
	(227282, 120, '2014-03-01 01:04:39.000000', 'temperatura', 1121.0000, 'ºC'),
	(227283, 120, '2014-03-01 01:04:40.000000', 'temperatura', 115.0000, 'ºC'),
	(227284, 120, '2014-03-01 01:04:41.000000', 'temperatura', 814.0000, 'ºC'),
	(227285, 120, '2014-03-01 01:04:42.000000', 'temperatura', 126.0000, 'ºC'),
	(227286, 120, '2014-03-01 01:04:43.000000', 'temperatura', 589.0000, 'ºC'),
	(227287, 120, '2014-03-01 01:04:44.000000', 'temperatura', 167.0000, 'ºC'),
	(227288, 120, '2014-03-01 01:04:45.000000', 'temperatura', 268.0000, 'ºC'),
	(227289, 120, '2014-03-01 01:04:46.000000', 'temperatura', 840.0000, 'ºC'),
	(227290, 120, '2014-03-01 01:04:47.000000', 'temperatura', 998.0000, 'ºC'),
	(227291, 120, '2014-03-01 01:04:48.000000', 'temperatura', 70.0000, 'ºC'),
	(227292, 120, '2014-03-01 01:04:49.000000', 'temperatura', 956.0000, 'ºC'),
	(227293, 120, '2014-03-01 01:04:50.000000', 'temperatura', 970.0000, 'ºC'),
	(227294, 120, '2014-03-01 01:04:51.000000', 'temperatura', 782.0000, 'ºC'),
	(227295, 120, '2014-03-01 01:04:52.000000', 'temperatura', 1002.0000, 'ºC'),
	(227296, 120, '2014-03-01 01:04:53.000000', 'temperatura', 262.0000, 'ºC'),
	(227297, 120, '2014-03-01 01:04:54.000000', 'temperatura', 705.0000, 'ºC'),
	(227298, 120, '2014-03-01 01:04:55.000000', 'temperatura', 340.0000, 'ºC'),
	(227299, 120, '2014-03-01 01:04:56.000000', 'temperatura', 785.0000, 'ºC'),
	(227300, 120, '2014-03-01 01:04:57.000000', 'temperatura', 506.0000, 'ºC'),
	(227301, 120, '2014-03-01 01:04:58.000000', 'temperatura', 177.0000, 'ºC'),
	(227302, 120, '2014-03-01 01:04:59.000000', 'temperatura', 567.0000, 'ºC'),
	(227303, 120, '2014-03-01 01:05:00.000000', 'temperatura', 1106.0000, 'ºC'),
	(227304, 120, '2014-03-01 01:05:01.000000', 'temperatura', 229.0000, 'ºC'),
	(227305, 120, '2014-03-01 01:05:02.000000', 'temperatura', 227.0000, 'ºC'),
	(227306, 120, '2014-03-01 01:05:03.000000', 'temperatura', 447.0000, 'ºC'),
	(227307, 120, '2014-03-01 01:05:04.000000', 'temperatura', 355.0000, 'ºC'),
	(227308, 120, '2014-03-01 01:05:05.000000', 'temperatura', 434.0000, 'ºC'),
	(227309, 120, '2014-03-01 01:05:06.000000', 'temperatura', 1104.0000, 'ºC'),
	(227310, 120, '2014-03-01 01:05:07.000000', 'temperatura', 621.0000, 'ºC'),
	(227311, 120, '2014-03-01 01:05:08.000000', 'temperatura', 991.0000, 'ºC'),
	(227312, 120, '2014-03-01 01:05:09.000000', 'temperatura', 693.0000, 'ºC'),
	(227313, 120, '2014-03-01 01:05:10.000000', 'temperatura', 491.0000, 'ºC'),
	(227314, 120, '2014-03-01 01:05:11.000000', 'temperatura', 380.0000, 'ºC'),
	(227315, 120, '2014-03-01 01:05:12.000000', 'temperatura', 425.0000, 'ºC'),
	(227316, 120, '2014-03-01 01:05:13.000000', 'temperatura', 988.0000, 'ºC'),
	(227317, 120, '2014-03-01 01:05:14.000000', 'temperatura', 65.0000, 'ºC'),
	(227318, 120, '2014-03-01 01:05:15.000000', 'temperatura', 963.0000, 'ºC'),
	(227319, 120, '2014-03-01 01:05:16.000000', 'temperatura', 1018.0000, 'ºC'),
	(227320, 120, '2014-03-01 01:05:17.000000', 'temperatura', 1004.0000, 'ºC'),
	(227321, 120, '2014-03-01 01:05:18.000000', 'temperatura', 763.0000, 'ºC'),
	(227322, 120, '2014-03-01 01:05:19.000000', 'temperatura', 807.0000, 'ºC'),
	(227323, 120, '2014-03-01 01:05:20.000000', 'temperatura', 543.0000, 'ºC'),
	(227324, 120, '2014-03-01 01:05:21.000000', 'temperatura', 297.0000, 'ºC'),
	(227325, 120, '2014-03-01 01:05:22.000000', 'temperatura', 1056.0000, 'ºC'),
	(227326, 120, '2014-03-01 01:05:23.000000', 'temperatura', 790.0000, 'ºC'),
	(227327, 120, '2014-03-01 01:05:24.000000', 'temperatura', 781.0000, 'ºC'),
	(227328, 120, '2014-03-01 01:05:25.000000', 'temperatura', 334.0000, 'ºC'),
	(227329, 120, '2014-03-01 01:05:26.000000', 'temperatura', 531.0000, 'ºC'),
	(227330, 120, '2014-03-01 01:05:27.000000', 'temperatura', 451.0000, 'ºC'),
	(227331, 120, '2014-03-01 01:05:28.000000', 'temperatura', 661.0000, 'ºC'),
	(227332, 120, '2014-03-01 01:05:29.000000', 'temperatura', 755.0000, 'ºC'),
	(227333, 120, '2014-03-01 01:05:30.000000', 'temperatura', 592.0000, 'ºC'),
	(227334, 120, '2014-03-01 01:05:31.000000', 'temperatura', 696.0000, 'ºC'),
	(227335, 120, '2014-03-01 01:05:32.000000', 'temperatura', 502.0000, 'ºC'),
	(227336, 120, '2014-03-01 01:05:33.000000', 'temperatura', 426.0000, 'ºC'),
	(227337, 120, '2014-03-01 01:05:34.000000', 'temperatura', 621.0000, 'ºC'),
	(227338, 120, '2014-03-01 01:05:35.000000', 'temperatura', 629.0000, 'ºC'),
	(227339, 120, '2014-03-01 01:05:36.000000', 'temperatura', 81.0000, 'ºC'),
	(227340, 120, '2014-03-01 01:05:37.000000', 'temperatura', 920.0000, 'ºC'),
	(227341, 120, '2014-03-01 01:05:38.000000', 'temperatura', 757.0000, 'ºC'),
	(227342, 120, '2014-03-01 01:05:39.000000', 'temperatura', 1024.0000, 'ºC'),
	(227343, 120, '2014-03-01 01:05:40.000000', 'temperatura', 449.0000, 'ºC'),
	(227344, 120, '2014-03-01 01:05:41.000000', 'temperatura', 377.0000, 'ºC'),
	(227345, 120, '2014-03-01 01:05:42.000000', 'temperatura', 535.0000, 'ºC'),
	(227346, 120, '2014-03-01 01:05:43.000000', 'temperatura', 345.0000, 'ºC'),
	(227347, 120, '2014-03-01 01:05:44.000000', 'temperatura', 119.0000, 'ºC'),
	(227348, 120, '2014-03-01 01:05:45.000000', 'temperatura', 762.0000, 'ºC'),
	(227349, 120, '2014-03-01 01:05:46.000000', 'temperatura', 1054.0000, 'ºC'),
	(227350, 120, '2014-03-01 01:05:47.000000', 'temperatura', 586.0000, 'ºC'),
	(227351, 120, '2014-03-01 01:05:48.000000', 'temperatura', 966.0000, 'ºC'),
	(227352, 120, '2014-03-01 01:05:49.000000', 'temperatura', 673.0000, 'ºC'),
	(227353, 120, '2014-03-01 01:05:50.000000', 'temperatura', 469.0000, 'ºC'),
	(227354, 120, '2014-03-01 01:05:51.000000', 'temperatura', 325.0000, 'ºC'),
	(227355, 120, '2014-03-01 01:05:52.000000', 'temperatura', 219.0000, 'ºC'),
	(227356, 120, '2014-03-01 01:05:53.000000', 'temperatura', 122.0000, 'ºC'),
	(227357, 120, '2014-03-01 01:05:54.000000', 'temperatura', 1153.0000, 'ºC'),
	(227358, 120, '2014-03-01 01:05:55.000000', 'temperatura', 600.0000, 'ºC'),
	(227359, 120, '2014-03-01 01:05:56.000000', 'temperatura', 740.0000, 'ºC'),
	(227360, 120, '2014-03-01 01:05:57.000000', 'temperatura', 700.0000, 'ºC'),
	(227361, 120, '2014-03-01 01:05:58.000000', 'temperatura', 83.0000, 'ºC'),
	(227362, 120, '2014-03-01 01:05:59.000000', 'temperatura', 714.0000, 'ºC'),
	(227363, 120, '2014-03-01 01:06:00.000000', 'temperatura', 920.0000, 'ºC'),
	(227364, 120, '2014-03-01 01:06:01.000000', 'temperatura', 61.0000, 'ºC'),
	(227365, 120, '2014-03-01 01:06:02.000000', 'temperatura', 1145.0000, 'ºC'),
	(227366, 120, '2014-03-01 01:06:03.000000', 'temperatura', 743.0000, 'ºC'),
	(227367, 120, '2014-03-01 01:06:04.000000', 'temperatura', 278.0000, 'ºC'),
	(227368, 120, '2014-03-01 01:06:05.000000', 'temperatura', 365.0000, 'ºC'),
	(227369, 120, '2014-03-01 01:06:06.000000', 'temperatura', 989.0000, 'ºC'),
	(227370, 120, '2014-03-01 01:06:07.000000', 'temperatura', 251.0000, 'ºC'),
	(227371, 120, '2014-03-01 01:06:08.000000', 'temperatura', 691.0000, 'ºC'),
	(227372, 120, '2014-03-01 01:06:09.000000', 'temperatura', 299.0000, 'ºC'),
	(227373, 120, '2014-03-01 01:06:10.000000', 'temperatura', 623.0000, 'ºC'),
	(227374, 120, '2014-03-01 01:06:11.000000', 'temperatura', 1019.0000, 'ºC'),
	(227375, 120, '2014-03-01 01:06:12.000000', 'temperatura', 825.0000, 'ºC'),
	(227376, 120, '2014-03-01 01:06:13.000000', 'temperatura', 1068.0000, 'ºC'),
	(227377, 120, '2014-03-01 01:06:14.000000', 'temperatura', 467.0000, 'ºC'),
	(227378, 120, '2014-03-01 01:06:15.000000', 'temperatura', 330.0000, 'ºC'),
	(227379, 120, '2014-03-01 01:06:16.000000', 'temperatura', 249.0000, 'ºC'),
	(227380, 120, '2014-03-01 01:06:17.000000', 'temperatura', 257.0000, 'ºC'),
	(227381, 120, '2014-03-01 01:06:18.000000', 'temperatura', 539.0000, 'ºC'),
	(227382, 120, '2014-03-01 01:06:19.000000', 'temperatura', 724.0000, 'ºC'),
	(227383, 120, '2014-03-01 01:06:20.000000', 'temperatura', 802.0000, 'ºC'),
	(227384, 120, '2014-03-01 01:06:21.000000', 'temperatura', 639.0000, 'ºC'),
	(227385, 120, '2014-03-01 01:06:22.000000', 'temperatura', 790.0000, 'ºC'),
	(227386, 120, '2014-03-01 01:06:23.000000', 'temperatura', 835.0000, 'ºC'),
	(227387, 120, '2014-03-01 01:06:24.000000', 'temperatura', 604.0000, 'ºC'),
	(227388, 120, '2014-03-01 01:06:25.000000', 'temperatura', 517.0000, 'ºC'),
	(227389, 120, '2014-03-01 01:06:26.000000', 'temperatura', 773.0000, 'ºC'),
	(227390, 120, '2014-03-01 01:06:27.000000', 'temperatura', 1115.0000, 'ºC'),
	(227391, 120, '2014-03-01 01:06:28.000000', 'temperatura', 855.0000, 'ºC'),
	(227392, 120, '2014-03-01 01:06:29.000000', 'temperatura', 933.0000, 'ºC'),
	(227393, 120, '2014-03-01 01:06:30.000000', 'temperatura', 899.0000, 'ºC'),
	(227394, 120, '2014-03-01 01:06:31.000000', 'temperatura', 498.0000, 'ºC'),
	(227395, 120, '2014-03-01 01:06:32.000000', 'temperatura', 993.0000, 'ºC'),
	(227396, 120, '2014-03-01 01:06:33.000000', 'temperatura', 1071.0000, 'ºC'),
	(227397, 120, '2014-03-01 01:06:34.000000', 'temperatura', 1175.0000, 'ºC'),
	(227398, 120, '2014-03-01 01:06:35.000000', 'temperatura', 262.0000, 'ºC'),
	(227399, 120, '2014-03-01 01:06:36.000000', 'temperatura', 185.0000, 'ºC'),
	(227400, 120, '2014-03-01 01:06:37.000000', 'temperatura', 141.0000, 'ºC'),
	(227401, 120, '2014-03-01 01:06:38.000000', 'temperatura', 152.0000, 'ºC'),
	(227402, 120, '2014-03-01 01:06:39.000000', 'temperatura', 337.0000, 'ºC'),
	(227403, 120, '2014-03-01 01:06:40.000000', 'temperatura', 30.0000, 'ºC'),
	(227404, 120, '2014-03-01 01:06:41.000000', 'temperatura', 337.0000, 'ºC'),
	(227405, 120, '2014-03-01 01:06:42.000000', 'temperatura', 397.0000, 'ºC'),
	(227406, 120, '2014-03-01 01:06:43.000000', 'temperatura', 976.0000, 'ºC'),
	(227407, 120, '2014-03-01 01:06:44.000000', 'temperatura', 88.0000, 'ºC'),
	(227408, 120, '2014-03-01 01:06:45.000000', 'temperatura', 1113.0000, 'ºC'),
	(227409, 120, '2014-03-01 01:06:46.000000', 'temperatura', 503.0000, 'ºC'),
	(227410, 120, '2014-03-01 01:06:47.000000', 'temperatura', 374.0000, 'ºC'),
	(227411, 120, '2014-03-01 01:06:48.000000', 'temperatura', 364.0000, 'ºC'),
	(227412, 120, '2014-03-01 01:06:49.000000', 'temperatura', 696.0000, 'ºC'),
	(227413, 120, '2014-03-01 01:06:50.000000', 'temperatura', 1190.0000, 'ºC'),
	(227414, 120, '2014-03-01 01:06:51.000000', 'temperatura', 262.0000, 'ºC'),
	(227415, 120, '2014-03-01 01:06:52.000000', 'temperatura', 139.0000, 'ºC'),
	(227416, 120, '2014-03-01 01:06:53.000000', 'temperatura', 1112.0000, 'ºC'),
	(227417, 120, '2014-03-01 01:06:54.000000', 'temperatura', 342.0000, 'ºC'),
	(227418, 120, '2014-03-01 01:06:55.000000', 'temperatura', 775.0000, 'ºC'),
	(227419, 120, '2014-03-01 01:06:56.000000', 'temperatura', 449.0000, 'ºC'),
	(227420, 120, '2014-03-01 01:06:57.000000', 'temperatura', 1121.0000, 'ºC'),
	(227421, 120, '2014-03-01 01:06:58.000000', 'temperatura', 658.0000, 'ºC'),
	(227422, 120, '2014-03-01 01:06:59.000000', 'temperatura', 1126.0000, 'ºC'),
	(227423, 120, '2014-03-01 01:07:00.000000', 'temperatura', 59.0000, 'ºC'),
	(227424, 120, '2014-03-01 01:07:01.000000', 'temperatura', 517.0000, 'ºC'),
	(227425, 120, '2014-03-01 01:07:02.000000', 'temperatura', 9.0000, 'ºC'),
	(227426, 120, '2014-03-01 01:07:03.000000', 'temperatura', 896.0000, 'ºC'),
	(227427, 120, '2014-03-01 01:07:04.000000', 'temperatura', 851.0000, 'ºC'),
	(227428, 120, '2014-03-01 01:07:05.000000', 'temperatura', 368.0000, 'ºC'),
	(227429, 120, '2014-03-01 01:07:06.000000', 'temperatura', 488.0000, 'ºC'),
	(227430, 120, '2014-03-01 01:07:07.000000', 'temperatura', 137.0000, 'ºC'),
	(227431, 120, '2014-03-01 01:07:08.000000', 'temperatura', 420.0000, 'ºC'),
	(227432, 120, '2014-03-01 01:07:09.000000', 'temperatura', 490.0000, 'ºC'),
	(227433, 120, '2014-03-01 01:07:10.000000', 'temperatura', 1190.0000, 'ºC'),
	(227434, 120, '2014-03-01 01:07:11.000000', 'temperatura', 880.0000, 'ºC'),
	(227435, 120, '2014-03-01 01:07:12.000000', 'temperatura', 833.0000, 'ºC'),
	(227436, 120, '2014-03-01 01:07:13.000000', 'temperatura', 323.0000, 'ºC'),
	(227437, 120, '2014-03-01 01:07:14.000000', 'temperatura', 318.0000, 'ºC'),
	(227438, 120, '2014-03-01 01:07:15.000000', 'temperatura', 620.0000, 'ºC'),
	(227439, 120, '2014-03-01 01:07:16.000000', 'temperatura', 947.0000, 'ºC'),
	(227440, 120, '2014-03-01 01:07:17.000000', 'temperatura', 478.0000, 'ºC'),
	(227441, 120, '2014-03-01 01:07:18.000000', 'temperatura', 747.0000, 'ºC'),
	(227442, 120, '2014-03-01 01:07:19.000000', 'temperatura', 1101.0000, 'ºC'),
	(227443, 120, '2014-03-01 01:07:20.000000', 'temperatura', 864.0000, 'ºC'),
	(227444, 120, '2014-03-01 01:07:21.000000', 'temperatura', 1019.0000, 'ºC'),
	(227445, 120, '2014-03-01 01:07:22.000000', 'temperatura', 104.0000, 'ºC'),
	(227446, 120, '2014-03-01 01:07:23.000000', 'temperatura', 1062.0000, 'ºC'),
	(227447, 120, '2014-03-01 01:07:24.000000', 'temperatura', 199.0000, 'ºC'),
	(227448, 120, '2014-03-01 01:07:25.000000', 'temperatura', 211.0000, 'ºC'),
	(227449, 120, '2014-03-01 01:07:26.000000', 'temperatura', 457.0000, 'ºC'),
	(227450, 120, '2014-03-01 01:07:27.000000', 'temperatura', 452.0000, 'ºC'),
	(227451, 120, '2014-03-01 01:07:28.000000', 'temperatura', 889.0000, 'ºC'),
	(227452, 120, '2014-03-01 01:07:29.000000', 'temperatura', 690.0000, 'ºC'),
	(227453, 120, '2014-03-01 01:07:30.000000', 'temperatura', 784.0000, 'ºC'),
	(227454, 120, '2014-03-01 01:07:31.000000', 'temperatura', 649.0000, 'ºC'),
	(227455, 120, '2014-03-01 01:07:32.000000', 'temperatura', 895.0000, 'ºC'),
	(227456, 120, '2014-03-01 01:07:33.000000', 'temperatura', 128.0000, 'ºC'),
	(227457, 120, '2014-03-01 01:07:34.000000', 'temperatura', 353.0000, 'ºC'),
	(227458, 120, '2014-03-01 01:07:35.000000', 'temperatura', 185.0000, 'ºC'),
	(227459, 120, '2014-03-01 01:07:36.000000', 'temperatura', 1066.0000, 'ºC'),
	(227460, 120, '2014-03-01 01:07:37.000000', 'temperatura', 1177.0000, 'ºC'),
	(227461, 120, '2014-03-01 01:07:38.000000', 'temperatura', 286.0000, 'ºC'),
	(227462, 120, '2014-03-01 01:07:39.000000', 'temperatura', 298.0000, 'ºC'),
	(227463, 120, '2014-03-01 01:07:40.000000', 'temperatura', 633.0000, 'ºC'),
	(227464, 120, '2014-03-01 01:07:41.000000', 'temperatura', 1073.0000, 'ºC'),
	(227465, 120, '2014-03-01 01:07:42.000000', 'temperatura', 1067.0000, 'ºC'),
	(227466, 120, '2014-03-01 01:07:43.000000', 'temperatura', 916.0000, 'ºC'),
	(227467, 120, '2014-03-01 01:07:44.000000', 'temperatura', 178.0000, 'ºC'),
	(227468, 120, '2014-03-01 01:07:45.000000', 'temperatura', 543.0000, 'ºC'),
	(227469, 120, '2014-03-01 01:07:46.000000', 'temperatura', 982.0000, 'ºC'),
	(227470, 120, '2014-03-01 01:07:47.000000', 'temperatura', 883.0000, 'ºC'),
	(227471, 120, '2014-03-01 01:07:48.000000', 'temperatura', 267.0000, 'ºC'),
	(227472, 120, '2014-03-01 01:07:49.000000', 'temperatura', 1086.0000, 'ºC'),
	(227473, 120, '2014-03-01 01:07:50.000000', 'temperatura', 1031.0000, 'ºC'),
	(227474, 120, '2014-03-01 01:07:51.000000', 'temperatura', 696.0000, 'ºC'),
	(227475, 120, '2014-03-01 01:07:52.000000', 'temperatura', 388.0000, 'ºC'),
	(227476, 120, '2014-03-01 01:07:53.000000', 'temperatura', 1051.0000, 'ºC'),
	(227477, 120, '2014-03-01 01:07:54.000000', 'temperatura', 494.0000, 'ºC'),
	(227478, 120, '2014-03-01 01:07:55.000000', 'temperatura', 515.0000, 'ºC'),
	(227479, 120, '2014-03-01 01:07:56.000000', 'temperatura', 1095.0000, 'ºC'),
	(227480, 120, '2014-03-01 01:07:57.000000', 'temperatura', 332.0000, 'ºC'),
	(227481, 120, '2014-03-01 01:07:58.000000', 'temperatura', 775.0000, 'ºC'),
	(227482, 120, '2014-03-01 01:07:59.000000', 'temperatura', 477.0000, 'ºC'),
	(227483, 120, '2014-03-01 01:08:00.000000', 'temperatura', 63.0000, 'ºC'),
	(227484, 120, '2014-03-01 01:08:01.000000', 'temperatura', 84.0000, 'ºC'),
	(227485, 120, '2014-03-01 01:08:02.000000', 'temperatura', 229.0000, 'ºC'),
	(227486, 120, '2014-03-01 01:08:03.000000', 'temperatura', 897.0000, 'ºC'),
	(227487, 120, '2014-03-01 01:08:04.000000', 'temperatura', 197.0000, 'ºC'),
	(227488, 120, '2014-03-01 01:08:05.000000', 'temperatura', 696.0000, 'ºC'),
	(227489, 120, '2014-03-01 01:08:06.000000', 'temperatura', 490.0000, 'ºC'),
	(227490, 120, '2014-03-01 01:08:07.000000', 'temperatura', 360.0000, 'ºC'),
	(227491, 120, '2014-03-01 01:08:08.000000', 'temperatura', 331.0000, 'ºC'),
	(227492, 120, '2014-03-01 01:08:09.000000', 'temperatura', 575.0000, 'ºC'),
	(227493, 120, '2014-03-01 01:08:10.000000', 'temperatura', 685.0000, 'ºC'),
	(227494, 120, '2014-03-01 01:08:11.000000', 'temperatura', 499.0000, 'ºC'),
	(227495, 120, '2014-03-01 01:08:12.000000', 'temperatura', 439.0000, 'ºC'),
	(227496, 120, '2014-03-01 01:08:13.000000', 'temperatura', 698.0000, 'ºC'),
	(227497, 120, '2014-03-01 01:08:14.000000', 'temperatura', 973.0000, 'ºC'),
	(227498, 120, '2014-03-01 01:08:15.000000', 'temperatura', 374.0000, 'ºC'),
	(227499, 120, '2014-03-01 01:08:16.000000', 'temperatura', 148.0000, 'ºC'),
	(227500, 120, '2014-03-01 01:08:17.000000', 'temperatura', 822.0000, 'ºC'),
	(227501, 120, '2014-03-01 01:08:18.000000', 'temperatura', 67.0000, 'ºC'),
	(227502, 120, '2014-03-01 01:08:19.000000', 'temperatura', 266.0000, 'ºC'),
	(227503, 120, '2014-03-01 01:08:20.000000', 'temperatura', 1132.0000, 'ºC'),
	(227504, 120, '2014-03-01 01:08:21.000000', 'temperatura', 62.0000, 'ºC'),
	(227505, 120, '2014-03-01 01:08:22.000000', 'temperatura', 514.0000, 'ºC'),
	(227506, 120, '2014-03-01 01:08:23.000000', 'temperatura', 1186.0000, 'ºC'),
	(227507, 120, '2014-03-01 01:08:24.000000', 'temperatura', 789.0000, 'ºC'),
	(227508, 120, '2014-03-01 01:08:25.000000', 'temperatura', 388.0000, 'ºC'),
	(227509, 120, '2014-03-01 01:08:26.000000', 'temperatura', 771.0000, 'ºC'),
	(227510, 120, '2014-03-01 01:08:27.000000', 'temperatura', 293.0000, 'ºC'),
	(227511, 120, '2014-03-01 01:08:28.000000', 'temperatura', 350.0000, 'ºC'),
	(227512, 120, '2014-03-01 01:08:29.000000', 'temperatura', 874.0000, 'ºC'),
	(227513, 120, '2014-03-01 01:08:30.000000', 'temperatura', 921.0000, 'ºC'),
	(227514, 120, '2014-03-01 01:08:31.000000', 'temperatura', 782.0000, 'ºC'),
	(227515, 120, '2014-03-01 01:08:32.000000', 'temperatura', 1146.0000, 'ºC'),
	(227516, 120, '2014-03-01 01:08:33.000000', 'temperatura', 985.0000, 'ºC'),
	(227517, 120, '2014-03-01 01:08:34.000000', 'temperatura', 290.0000, 'ºC'),
	(227518, 120, '2014-03-01 01:08:35.000000', 'temperatura', 895.0000, 'ºC'),
	(227519, 120, '2014-03-01 01:08:36.000000', 'temperatura', 3.0000, 'ºC'),
	(227520, 120, '2014-03-01 01:08:37.000000', 'temperatura', 934.0000, 'ºC'),
	(227521, 120, '2014-03-01 01:08:38.000000', 'temperatura', 1060.0000, 'ºC'),
	(227522, 120, '2014-03-01 01:08:39.000000', 'temperatura', 98.0000, 'ºC'),
	(227523, 120, '2014-03-01 01:08:40.000000', 'temperatura', 912.0000, 'ºC'),
	(227524, 120, '2014-03-01 01:08:41.000000', 'temperatura', 664.0000, 'ºC'),
	(227525, 120, '2014-03-01 01:08:42.000000', 'temperatura', 585.0000, 'ºC'),
	(227526, 120, '2014-03-01 01:08:43.000000', 'temperatura', 936.0000, 'ºC'),
	(227527, 120, '2014-03-01 01:08:44.000000', 'temperatura', 524.0000, 'ºC'),
	(227528, 120, '2014-03-01 01:08:45.000000', 'temperatura', 1014.0000, 'ºC'),
	(227529, 120, '2014-03-01 01:08:46.000000', 'temperatura', 1097.0000, 'ºC'),
	(227530, 120, '2014-03-01 01:08:47.000000', 'temperatura', 42.0000, 'ºC'),
	(227531, 120, '2014-03-01 01:08:48.000000', 'temperatura', 522.0000, 'ºC'),
	(227532, 120, '2014-03-01 01:08:49.000000', 'temperatura', 82.0000, 'ºC'),
	(227533, 120, '2014-03-01 01:08:50.000000', 'temperatura', 46.0000, 'ºC'),
	(227534, 120, '2014-03-01 01:08:51.000000', 'temperatura', 1184.0000, 'ºC'),
	(227535, 120, '2014-03-01 01:08:52.000000', 'temperatura', 983.0000, 'ºC'),
	(227536, 120, '2014-03-01 01:08:53.000000', 'temperatura', 165.0000, 'ºC'),
	(227537, 120, '2014-03-01 01:08:54.000000', 'temperatura', 274.0000, 'ºC'),
	(227538, 120, '2014-03-01 01:08:55.000000', 'temperatura', 877.0000, 'ºC'),
	(227539, 120, '2014-03-01 01:08:56.000000', 'temperatura', 1164.0000, 'ºC'),
	(227540, 120, '2014-03-01 01:08:57.000000', 'temperatura', 790.0000, 'ºC'),
	(227541, 120, '2014-03-01 01:08:58.000000', 'temperatura', 456.0000, 'ºC'),
	(227542, 120, '2014-03-01 01:08:59.000000', 'temperatura', 1112.0000, 'ºC'),
	(227543, 120, '2014-03-01 01:09:00.000000', 'temperatura', 590.0000, 'ºC'),
	(227544, 120, '2014-03-01 01:09:01.000000', 'temperatura', 817.0000, 'ºC'),
	(227545, 120, '2014-03-01 01:09:02.000000', 'temperatura', 1114.0000, 'ºC'),
	(227546, 120, '2014-03-01 01:09:03.000000', 'temperatura', 720.0000, 'ºC'),
	(227547, 120, '2014-03-01 01:09:04.000000', 'temperatura', 259.0000, 'ºC'),
	(227548, 120, '2014-03-01 01:09:05.000000', 'temperatura', 335.0000, 'ºC'),
	(227549, 120, '2014-03-01 01:09:06.000000', 'temperatura', 898.0000, 'ºC'),
	(227550, 120, '2014-03-01 01:09:07.000000', 'temperatura', 1085.0000, 'ºC'),
	(227551, 120, '2014-03-01 01:09:08.000000', 'temperatura', 330.0000, 'ºC'),
	(227552, 120, '2014-03-01 01:09:09.000000', 'temperatura', 799.0000, 'ºC'),
	(227553, 120, '2014-03-01 01:09:10.000000', 'temperatura', 603.0000, 'ºC'),
	(227554, 120, '2014-03-01 01:09:11.000000', 'temperatura', 618.0000, 'ºC'),
	(227555, 120, '2014-03-01 01:09:12.000000', 'temperatura', 80.0000, 'ºC'),
	(227556, 120, '2014-03-01 01:09:13.000000', 'temperatura', 949.0000, 'ºC'),
	(227557, 120, '2014-03-01 01:09:14.000000', 'temperatura', 907.0000, 'ºC'),
	(227558, 120, '2014-03-01 01:09:15.000000', 'temperatura', 485.0000, 'ºC'),
	(227559, 120, '2014-03-01 01:09:16.000000', 'temperatura', 906.0000, 'ºC'),
	(227560, 120, '2014-03-01 01:09:17.000000', 'temperatura', 678.0000, 'ºC'),
	(227561, 120, '2014-03-01 01:09:18.000000', 'temperatura', 669.0000, 'ºC'),
	(227562, 120, '2014-03-01 01:09:19.000000', 'temperatura', 111.0000, 'ºC'),
	(227563, 120, '2014-03-01 01:09:20.000000', 'temperatura', 950.0000, 'ºC'),
	(227564, 120, '2014-03-01 01:09:21.000000', 'temperatura', 819.0000, 'ºC'),
	(227565, 120, '2014-03-01 01:09:22.000000', 'temperatura', 46.0000, 'ºC'),
	(227566, 120, '2014-03-01 01:09:23.000000', 'temperatura', 173.0000, 'ºC'),
	(227567, 120, '2014-03-01 01:09:24.000000', 'temperatura', 726.0000, 'ºC'),
	(227568, 120, '2014-03-01 01:09:25.000000', 'temperatura', 711.0000, 'ºC'),
	(227569, 120, '2014-03-01 01:09:26.000000', 'temperatura', 179.0000, 'ºC'),
	(227570, 120, '2014-03-01 01:09:27.000000', 'temperatura', 1163.0000, 'ºC'),
	(227571, 120, '2014-03-01 01:09:28.000000', 'temperatura', 476.0000, 'ºC'),
	(227572, 120, '2014-03-01 01:09:29.000000', 'temperatura', 94.0000, 'ºC'),
	(227573, 120, '2014-03-01 01:09:30.000000', 'temperatura', 242.0000, 'ºC'),
	(227574, 120, '2014-03-01 01:09:31.000000', 'temperatura', 930.0000, 'ºC'),
	(227575, 120, '2014-03-01 01:09:32.000000', 'temperatura', 325.0000, 'ºC'),
	(227576, 120, '2014-03-01 01:09:33.000000', 'temperatura', 33.0000, 'ºC'),
	(227577, 120, '2014-03-01 01:09:34.000000', 'temperatura', 393.0000, 'ºC'),
	(227578, 120, '2014-03-01 01:09:35.000000', 'temperatura', 665.0000, 'ºC'),
	(227579, 120, '2014-03-01 01:09:36.000000', 'temperatura', 946.0000, 'ºC'),
	(227580, 120, '2014-03-01 01:09:37.000000', 'temperatura', 337.0000, 'ºC'),
	(227581, 120, '2014-03-01 01:09:38.000000', 'temperatura', 48.0000, 'ºC'),
	(227582, 120, '2014-03-01 01:09:39.000000', 'temperatura', 428.0000, 'ºC'),
	(227583, 120, '2014-03-01 01:09:40.000000', 'temperatura', 796.0000, 'ºC'),
	(227584, 120, '2014-03-01 01:09:41.000000', 'temperatura', 299.0000, 'ºC'),
	(227585, 120, '2014-03-01 01:09:42.000000', 'temperatura', 304.0000, 'ºC'),
	(227586, 120, '2014-03-01 01:09:43.000000', 'temperatura', 626.0000, 'ºC'),
	(227587, 120, '2014-03-01 01:09:44.000000', 'temperatura', 1019.0000, 'ºC'),
	(227588, 120, '2014-03-01 01:09:45.000000', 'temperatura', 817.0000, 'ºC'),
	(227589, 120, '2014-03-01 01:09:46.000000', 'temperatura', 1026.0000, 'ºC'),
	(227590, 120, '2014-03-01 01:09:47.000000', 'temperatura', 282.0000, 'ºC'),
	(227591, 120, '2014-03-01 01:09:48.000000', 'temperatura', 731.0000, 'ºC'),
	(227592, 120, '2014-03-01 01:09:49.000000', 'temperatura', 412.0000, 'ºC'),
	(227593, 120, '2014-03-01 01:09:50.000000', 'temperatura', 1067.0000, 'ºC'),
	(227594, 120, '2014-03-01 01:09:51.000000', 'temperatura', 498.0000, 'ºC'),
	(227595, 120, '2014-03-01 01:09:52.000000', 'temperatura', 488.0000, 'ºC'),
	(227596, 120, '2014-03-01 01:09:53.000000', 'temperatura', 950.0000, 'ºC'),
	(227597, 120, '2014-03-01 01:09:54.000000', 'temperatura', 885.0000, 'ºC'),
	(227598, 120, '2014-03-01 01:09:55.000000', 'temperatura', 375.0000, 'ºC'),
	(227599, 120, '2014-03-01 01:09:56.000000', 'temperatura', 422.0000, 'ºC'),
	(227600, 120, '2014-03-01 01:09:57.000000', 'temperatura', 983.0000, 'ºC'),
	(227601, 120, '2014-03-01 01:09:58.000000', 'temperatura', 50.0000, 'ºC'),
	(227602, 120, '2014-03-01 01:09:59.000000', 'temperatura', 903.0000, 'ºC'),
	(227603, 120, '2014-03-01 01:10:00.000000', 'temperatura', 764.0000, 'ºC'),
	(227604, 120, '2014-03-01 01:10:01.000000', 'temperatura', 1113.0000, 'ºC'),
	(227605, 120, '2014-03-01 01:10:02.000000', 'temperatura', 872.0000, 'ºC'),
	(227606, 120, '2014-03-01 01:10:03.000000', 'temperatura', 1020.0000, 'ºC'),
	(227607, 120, '2014-03-01 01:10:04.000000', 'temperatura', 86.0000, 'ºC'),
	(227608, 120, '2014-03-01 01:10:05.000000', 'temperatura', 971.0000, 'ºC'),
	(227609, 120, '2014-03-01 01:10:06.000000', 'temperatura', 995.0000, 'ºC'),
	(227610, 120, '2014-03-01 01:10:07.000000', 'temperatura', 866.0000, 'ºC'),
	(227611, 120, '2014-03-01 01:10:08.000000', 'temperatura', 142.0000, 'ºC'),
	(227612, 120, '2014-03-01 01:10:09.000000', 'temperatura', 515.0000, 'ºC'),
	(227613, 120, '2014-03-01 01:10:10.000000', 'temperatura', 949.0000, 'ºC'),
	(227614, 120, '2014-03-01 01:10:11.000000', 'temperatura', 799.0000, 'ºC'),
	(227615, 120, '2014-03-01 01:10:12.000000', 'temperatura', 1150.0000, 'ºC'),
	(227616, 120, '2014-03-01 01:10:13.000000', 'temperatura', 951.0000, 'ºC'),
	(227617, 120, '2014-03-01 01:10:14.000000', 'temperatura', 109.0000, 'ºC'),
	(227618, 120, '2014-03-01 01:10:15.000000', 'temperatura', 89.0000, 'ºC'),
	(227619, 120, '2014-03-01 01:10:16.000000', 'temperatura', 122.0000, 'ºC'),
	(227620, 120, '2014-03-01 01:10:17.000000', 'temperatura', 341.0000, 'ºC'),
	(227621, 120, '2014-03-01 01:10:18.000000', 'temperatura', 140.0000, 'ºC'),
	(227622, 120, '2014-03-01 01:10:19.000000', 'temperatura', 877.0000, 'ºC'),
	(227623, 120, '2014-03-01 01:10:20.000000', 'temperatura', 366.0000, 'ºC'),
	(227624, 120, '2014-03-01 01:10:21.000000', 'temperatura', 400.0000, 'ºC'),
	(227625, 120, '2014-03-01 01:10:22.000000', 'temperatura', 902.0000, 'ºC'),
	(227626, 120, '2014-03-01 01:10:23.000000', 'temperatura', 912.0000, 'ºC'),
	(227627, 120, '2014-03-01 01:10:24.000000', 'temperatura', 655.0000, 'ºC'),
	(227628, 120, '2014-03-01 01:10:25.000000', 'temperatura', 538.0000, 'ºC'),
	(227629, 120, '2014-03-01 01:10:26.000000', 'temperatura', 724.0000, 'ºC'),
	(227630, 120, '2014-03-01 01:10:27.000000', 'temperatura', 807.0000, 'ºC'),
	(227631, 120, '2014-03-01 01:10:28.000000', 'temperatura', 664.0000, 'ºC'),
	(227632, 120, '2014-03-01 01:10:29.000000', 'temperatura', 901.0000, 'ºC'),
	(227633, 120, '2014-03-01 01:10:30.000000', 'temperatura', 114.0000, 'ºC'),
	(227634, 120, '2014-03-01 01:10:31.000000', 'temperatura', 265.0000, 'ºC'),
	(227635, 120, '2014-03-01 01:10:32.000000', 'temperatura', 984.0000, 'ºC'),
	(227636, 120, '2014-03-01 01:10:33.000000', 'temperatura', 527.0000, 'ºC'),
	(227637, 120, '2014-03-01 01:10:34.000000', 'temperatura', 884.0000, 'ºC'),
	(227638, 120, '2014-03-01 01:10:35.000000', 'temperatura', 438.0000, 'ºC'),
	(227639, 120, '2014-03-01 01:10:36.000000', 'temperatura', 737.0000, 'ºC'),
	(227640, 120, '2014-03-01 01:10:37.000000', 'temperatura', 1174.0000, 'ºC'),
	(227641, 120, '2014-03-01 01:10:38.000000', 'temperatura', 57.0000, 'ºC'),
	(227642, 120, '2014-03-01 01:10:39.000000', 'temperatura', 363.0000, 'ºC'),
	(227643, 120, '2014-03-01 01:10:40.000000', 'temperatura', 444.0000, 'ºC'),
	(227644, 120, '2014-03-01 01:10:41.000000', 'temperatura', 1135.0000, 'ºC'),
	(227645, 120, '2014-03-01 01:10:42.000000', 'temperatura', 740.0000, 'ºC'),
	(227646, 120, '2014-03-01 01:10:43.000000', 'temperatura', 298.0000, 'ºC'),
	(227647, 120, '2014-03-01 01:10:44.000000', 'temperatura', 471.0000, 'ºC'),
	(227648, 120, '2014-03-01 01:10:45.000000', 'temperatura', 262.0000, 'ºC'),
	(227649, 120, '2014-03-01 01:10:46.000000', 'temperatura', 1098.0000, 'ºC'),
	(227650, 120, '2014-03-01 01:10:47.000000', 'temperatura', 1102.0000, 'ºC'),
	(227651, 120, '2014-03-01 01:10:48.000000', 'temperatura', 1016.0000, 'ºC'),
	(227652, 120, '2014-03-01 01:10:49.000000', 'temperatura', 576.0000, 'ºC'),
	(227653, 120, '2014-03-01 01:10:50.000000', 'temperatura', 1031.0000, 'ºC'),
	(227654, 120, '2014-03-01 01:10:51.000000', 'temperatura', 1028.0000, 'ºC'),
	(227655, 120, '2014-03-01 01:10:52.000000', 'temperatura', 847.0000, 'ºC'),
	(227656, 120, '2014-03-01 01:10:53.000000', 'temperatura', 1152.0000, 'ºC'),
	(227657, 120, '2014-03-01 01:10:54.000000', 'temperatura', 822.0000, 'ºC'),
	(227658, 120, '2014-03-01 01:10:55.000000', 'temperatura', 651.0000, 'ºC'),
	(227659, 120, '2014-03-01 01:10:56.000000', 'temperatura', 791.0000, 'ºC'),
	(227660, 120, '2014-03-01 01:10:57.000000', 'temperatura', 802.0000, 'ºC'),
	(227661, 120, '2014-03-01 01:10:58.000000', 'temperatura', 439.0000, 'ºC'),
	(227662, 120, '2014-03-01 01:10:59.000000', 'temperatura', 989.0000, 'ºC'),
	(227663, 120, '2014-03-01 01:11:00.000000', 'temperatura', 29.0000, 'ºC'),
	(227664, 120, '2014-03-01 01:11:01.000000', 'temperatura', 777.0000, 'ºC'),
	(227665, 120, '2014-03-01 01:11:02.000000', 'temperatura', 199.0000, 'ºC'),
	(227666, 120, '2014-03-01 01:11:03.000000', 'temperatura', 1065.0000, 'ºC'),
	(227667, 120, '2014-03-01 01:11:04.000000', 'temperatura', 1127.0000, 'ºC'),
	(227668, 120, '2014-03-01 01:11:05.000000', 'temperatura', 40.0000, 'ºC'),
	(227669, 120, '2014-03-01 01:11:06.000000', 'temperatura', 421.0000, 'ºC'),
	(227670, 120, '2014-03-01 01:11:07.000000', 'temperatura', 785.0000, 'ºC'),
	(227671, 120, '2014-03-01 01:11:08.000000', 'temperatura', 262.0000, 'ºC'),
	(227672, 120, '2014-03-01 01:11:09.000000', 'temperatura', 154.0000, 'ºC'),
	(227673, 120, '2014-03-01 01:11:10.000000', 'temperatura', 1185.0000, 'ºC'),
	(227674, 120, '2014-03-01 01:11:11.000000', 'temperatura', 665.0000, 'ºC'),
	(227675, 120, '2014-03-01 01:11:12.000000', 'temperatura', 969.0000, 'ºC'),
	(227676, 120, '2014-03-01 01:11:13.000000', 'temperatura', 450.0000, 'ºC'),
	(227677, 120, '2014-03-01 01:11:14.000000', 'temperatura', 544.0000, 'ºC'),
	(227678, 120, '2014-03-01 01:11:15.000000', 'temperatura', 171.0000, 'ºC'),
	(227679, 120, '2014-03-01 01:11:16.000000', 'temperatura', 423.0000, 'ºC'),
	(227680, 120, '2014-03-01 01:11:17.000000', 'temperatura', 402.0000, 'ºC'),
	(227681, 120, '2014-03-01 01:11:18.000000', 'temperatura', 744.0000, 'ºC'),
	(227682, 120, '2014-03-01 01:11:19.000000', 'temperatura', 112.0000, 'ºC'),
	(227683, 120, '2014-03-01 01:11:20.000000', 'temperatura', 729.0000, 'ºC'),
	(227684, 120, '2014-03-01 01:11:21.000000', 'temperatura', 908.0000, 'ºC'),
	(227685, 120, '2014-03-01 01:11:22.000000', 'temperatura', 1156.0000, 'ºC'),
	(227686, 120, '2014-03-01 01:11:23.000000', 'temperatura', 657.0000, 'ºC'),
	(227687, 120, '2014-03-01 01:11:24.000000', 'temperatura', 1017.0000, 'ºC'),
	(227688, 120, '2014-03-01 01:11:25.000000', 'temperatura', 712.0000, 'ºC'),
	(227689, 120, '2014-03-01 01:11:26.000000', 'temperatura', 513.0000, 'ºC'),
	(227690, 120, '2014-03-01 01:11:27.000000', 'temperatura', 427.0000, 'ºC'),
	(227691, 120, '2014-03-01 01:11:28.000000', 'temperatura', 599.0000, 'ºC'),
	(227692, 120, '2014-03-01 01:11:29.000000', 'temperatura', 514.0000, 'ºC'),
	(227693, 120, '2014-03-01 01:11:30.000000', 'temperatura', 773.0000, 'ºC'),
	(227694, 120, '2014-03-01 01:11:31.000000', 'temperatura', 1126.0000, 'ºC'),
	(227695, 120, '2014-03-01 01:11:32.000000', 'temperatura', 908.0000, 'ºC'),
	(227696, 120, '2014-03-01 01:11:33.000000', 'temperatura', 1164.0000, 'ºC'),
	(227697, 120, '2014-03-01 01:11:34.000000', 'temperatura', 697.0000, 'ºC'),
	(227698, 120, '2014-03-01 01:11:35.000000', 'temperatura', 1191.0000, 'ºC'),
	(227699, 120, '2014-03-01 01:11:36.000000', 'temperatura', 265.0000, 'ºC'),
	(227700, 120, '2014-03-01 01:11:37.000000', 'temperatura', 155.0000, 'ºC'),
	(227701, 120, '2014-03-01 01:11:38.000000', 'temperatura', 1179.0000, 'ºC'),
	(227702, 120, '2014-03-01 01:11:39.000000', 'temperatura', 630.0000, 'ºC'),
	(227703, 120, '2014-03-01 01:11:40.000000', 'temperatura', 814.0000, 'ºC'),
	(227704, 120, '2014-03-01 01:11:41.000000', 'temperatura', 982.0000, 'ºC'),
	(227705, 120, '2014-03-01 01:11:42.000000', 'temperatura', 67.0000, 'ºC'),
	(227706, 120, '2014-03-01 01:11:43.000000', 'temperatura', 992.0000, 'ºC'),
	(227707, 120, '2014-03-01 01:11:44.000000', 'temperatura', 1157.0000, 'ºC'),
	(227708, 120, '2014-03-01 01:11:45.000000', 'temperatura', 409.0000, 'ºC'),
	(227709, 120, '2014-03-01 01:11:46.000000', 'temperatura', 976.0000, 'ºC'),
	(227710, 120, '2014-03-01 01:11:47.000000', 'temperatura', 55.0000, 'ºC'),
	(227711, 120, '2014-03-01 01:11:48.000000', 'temperatura', 946.0000, 'ºC'),
	(227712, 120, '2014-03-01 01:11:49.000000', 'temperatura', 966.0000, 'ºC'),
	(227713, 120, '2014-03-01 01:11:50.000000', 'temperatura', 792.0000, 'ºC'),
	(227714, 120, '2014-03-01 01:11:51.000000', 'temperatura', 1064.0000, 'ºC'),
	(227715, 120, '2014-03-01 01:11:52.000000', 'temperatura', 542.0000, 'ºC'),
	(227716, 120, '2014-03-01 01:11:53.000000', 'temperatura', 720.0000, 'ºC'),
	(227717, 120, '2014-03-01 01:11:54.000000', 'temperatura', 775.0000, 'ºC'),
	(227718, 120, '2014-03-01 01:11:55.000000', 'temperatura', 516.0000, 'ºC'),
	(227719, 120, '2014-03-01 01:11:56.000000', 'temperatura', 255.0000, 'ºC'),
	(227720, 120, '2014-03-01 01:11:57.000000', 'temperatura', 926.0000, 'ºC'),
	(227721, 120, '2014-03-01 01:11:58.000000', 'temperatura', 267.0000, 'ºC'),
	(227722, 120, '2014-03-01 01:11:59.000000', 'temperatura', 957.0000, 'ºC'),
	(227723, 120, '2014-03-01 01:12:00.000000', 'temperatura', 383.0000, 'ºC'),
	(227724, 120, '2014-03-01 01:12:01.000000', 'temperatura', 245.0000, 'ºC'),
	(227725, 120, '2014-03-01 01:12:02.000000', 'temperatura', 79.0000, 'ºC'),
	(227726, 120, '2014-03-01 01:12:03.000000', 'temperatura', 857.0000, 'ºC'),
	(227727, 120, '2014-03-01 01:12:04.000000', 'temperatura', 451.0000, 'ºC'),
	(227728, 120, '2014-03-01 01:12:05.000000', 'temperatura', 884.0000, 'ºC'),
	(227729, 120, '2014-03-01 01:12:06.000000', 'temperatura', 668.0000, 'ºC'),
	(227730, 120, '2014-03-01 01:12:07.000000', 'temperatura', 689.0000, 'ºC'),
	(227731, 120, '2014-03-01 01:12:08.000000', 'temperatura', 240.0000, 'ºC'),
	(227732, 120, '2014-03-01 01:12:09.000000', 'temperatura', 334.0000, 'ºC'),
	(227733, 120, '2014-03-01 01:12:10.000000', 'temperatura', 950.0000, 'ºC'),
	(227734, 120, '2014-03-01 01:12:11.000000', 'temperatura', 150.0000, 'ºC'),
	(227735, 120, '2014-03-01 01:12:12.000000', 'temperatura', 298.0000, 'ºC'),
	(227736, 120, '2014-03-01 01:12:13.000000', 'temperatura', 1041.0000, 'ºC'),
	(227737, 120, '2014-03-01 01:12:14.000000', 'temperatura', 713.0000, 'ºC'),
	(227738, 120, '2014-03-01 01:12:15.000000', 'temperatura', 443.0000, 'ºC'),
	(227739, 120, '2014-03-01 01:12:16.000000', 'temperatura', 74.0000, 'ºC'),
	(227740, 120, '2014-03-01 01:12:17.000000', 'temperatura', 245.0000, 'ºC'),
	(227741, 120, '2014-03-01 01:12:18.000000', 'temperatura', 1001.0000, 'ºC'),
	(227742, 120, '2014-03-01 01:12:19.000000', 'temperatura', 671.0000, 'ºC'),
	(227743, 120, '2014-03-01 01:12:20.000000', 'temperatura', 352.0000, 'ºC'),
	(227744, 120, '2014-03-01 01:12:21.000000', 'temperatura', 946.0000, 'ºC'),
	(227745, 120, '2014-03-01 01:12:22.000000', 'temperatura', 77.0000, 'ºC'),
	(227746, 120, '2014-03-01 01:12:23.000000', 'temperatura', 1148.0000, 'ºC'),
	(227747, 120, '2014-03-01 01:12:24.000000', 'temperatura', 708.0000, 'ºC'),
	(227748, 120, '2014-03-01 01:12:25.000000', 'temperatura', 95.0000, 'ºC'),
	(227749, 120, '2014-03-01 01:12:26.000000', 'temperatura', 754.0000, 'ºC'),
	(227750, 120, '2014-03-01 01:12:27.000000', 'temperatura', 1084.0000, 'ºC'),
	(227751, 120, '2014-03-01 01:12:28.000000', 'temperatura', 760.0000, 'ºC'),
	(227752, 120, '2014-03-01 01:12:29.000000', 'temperatura', 547.0000, 'ºC'),
	(227753, 120, '2014-03-01 01:12:30.000000', 'temperatura', 458.0000, 'ºC'),
	(227754, 120, '2014-03-01 01:12:31.000000', 'temperatura', 649.0000, 'ºC'),
	(227755, 120, '2014-03-01 01:12:32.000000', 'temperatura', 669.0000, 'ºC'),
	(227756, 120, '2014-03-01 01:12:33.000000', 'temperatura', 201.0000, 'ºC'),
	(227757, 120, '2014-03-01 01:12:34.000000', 'temperatura', 198.0000, 'ºC'),
	(227758, 120, '2014-03-01 01:12:35.000000', 'temperatura', 387.0000, 'ºC'),
	(227759, 120, '2014-03-01 01:12:36.000000', 'temperatura', 140.0000, 'ºC'),
	(227760, 120, '2014-03-01 01:12:37.000000', 'temperatura', 740.0000, 'ºC'),
	(227761, 120, '2014-03-01 01:12:38.000000', 'temperatura', 879.0000, 'ºC'),
	(227762, 120, '2014-03-01 01:12:39.000000', 'temperatura', 977.0000, 'ºC'),
	(227763, 120, '2014-03-01 01:12:40.000000', 'temperatura', 1050.0000, 'ºC'),
	(227764, 120, '2014-03-01 01:12:41.000000', 'temperatura', 1119.0000, 'ºC'),
	(227765, 120, '2014-03-01 01:12:42.000000', 'temperatura', 44.0000, 'ºC'),
	(227766, 120, '2014-03-01 01:12:43.000000', 'temperatura', 464.0000, 'ºC'),
	(227767, 120, '2014-03-01 01:12:44.000000', 'temperatura', 990.0000, 'ºC'),
	(227768, 120, '2014-03-01 01:12:45.000000', 'temperatura', 1156.0000, 'ºC'),
	(227769, 120, '2014-03-01 01:12:46.000000', 'temperatura', 414.0000, 'ºC'),
	(227770, 120, '2014-03-01 01:12:47.000000', 'temperatura', 999.0000, 'ºC'),
	(227771, 120, '2014-03-01 01:12:48.000000', 'temperatura', 157.0000, 'ºC'),
	(227772, 120, '2014-03-01 01:12:49.000000', 'temperatura', 186.0000, 'ºC'),
	(227773, 120, '2014-03-01 01:12:50.000000', 'temperatura', 459.0000, 'ºC'),
	(227774, 120, '2014-03-01 01:12:51.000000', 'temperatura', 539.0000, 'ºC'),
	(227775, 120, '2014-03-01 01:12:52.000000', 'temperatura', 116.0000, 'ºC'),
	(227776, 120, '2014-03-01 01:12:53.000000', 'temperatura', 166.0000, 'ºC'),
	(227777, 120, '2014-03-01 01:12:54.000000', 'temperatura', 481.0000, 'ºC'),
	(227778, 120, '2014-03-01 01:12:55.000000', 'temperatura', 706.0000, 'ºC'),
	(227779, 120, '2014-03-01 01:12:56.000000', 'temperatura', 890.0000, 'ºC'),
	(227780, 120, '2014-03-01 01:12:57.000000', 'temperatura', 1130.0000, 'ºC'),
	(227781, 120, '2014-03-01 01:12:58.000000', 'temperatura', 583.0000, 'ºC'),
	(227782, 120, '2014-03-01 01:12:59.000000', 'temperatura', 724.0000, 'ºC'),
	(227783, 120, '2014-03-01 01:13:00.000000', 'temperatura', 670.0000, 'ºC'),
	(227784, 120, '2014-03-01 01:13:01.000000', 'temperatura', 1179.0000, 'ºC'),
	(227785, 120, '2014-03-01 01:13:02.000000', 'temperatura', 288.0000, 'ºC'),
	(227786, 120, '2014-03-01 01:13:03.000000', 'temperatura', 301.0000, 'ºC'),
	(227787, 120, '2014-03-01 01:13:04.000000', 'temperatura', 644.0000, 'ºC'),
	(227788, 120, '2014-03-01 01:13:05.000000', 'temperatura', 1117.0000, 'ºC'),
	(227789, 120, '2014-03-01 01:13:06.000000', 'temperatura', 54.0000, 'ºC'),
	(227790, 120, '2014-03-01 01:13:07.000000', 'temperatura', 517.0000, 'ºC'),
	(227791, 120, '2014-03-01 01:13:08.000000', 'temperatura', 26.0000, 'ºC'),
	(227792, 120, '2014-03-01 01:13:09.000000', 'temperatura', 981.0000, 'ºC'),
	(227793, 120, '2014-03-01 01:13:10.000000', 'temperatura', 25.0000, 'ºC'),
	(227794, 120, '2014-03-01 01:13:11.000000', 'temperatura', 781.0000, 'ºC'),
	(227795, 120, '2014-03-01 01:13:12.000000', 'temperatura', 233.0000, 'ºC'),
	(227796, 120, '2014-03-01 01:13:13.000000', 'temperatura', 20.0000, 'ºC'),
	(227797, 120, '2014-03-01 01:13:14.000000', 'temperatura', 602.0000, 'ºC'),
	(227798, 120, '2014-03-01 01:13:15.000000', 'temperatura', 550.0000, 'ºC'),
	(227799, 120, '2014-03-01 01:13:16.000000', 'temperatura', 945.0000, 'ºC'),
	(227800, 120, '2014-03-01 01:13:17.000000', 'temperatura', 675.0000, 'ºC'),
	(227801, 120, '2014-03-01 01:13:18.000000', 'temperatura', 541.0000, 'ºC'),
	(227802, 120, '2014-03-01 01:13:19.000000', 'temperatura', 683.0000, 'ºC'),
	(227803, 120, '2014-03-01 01:13:20.000000', 'temperatura', 589.0000, 'ºC'),
	(227804, 120, '2014-03-01 01:13:21.000000', 'temperatura', 897.0000, 'ºC'),
	(227805, 120, '2014-03-01 01:13:22.000000', 'temperatura', 318.0000, 'ºC'),
	(227806, 120, '2014-03-01 01:13:23.000000', 'temperatura', 100.0000, 'ºC'),
	(227807, 120, '2014-03-01 01:13:24.000000', 'temperatura', 747.0000, 'ºC'),
	(227808, 120, '2014-03-01 01:13:25.000000', 'temperatura', 1037.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(227809, 120, '2014-03-01 01:13:26.000000', 'temperatura', 544.0000, 'ºC'),
	(227810, 120, '2014-03-01 01:13:27.000000', 'temperatura', 807.0000, 'ºC'),
	(227811, 120, '2014-03-01 01:13:28.000000', 'temperatura', 7.0000, 'ºC'),
	(227812, 120, '2014-03-01 01:13:29.000000', 'temperatura', 13.0000, 'ºC'),
	(227813, 120, '2014-03-01 01:13:30.000000', 'temperatura', 45.0000, 'ºC'),
	(227814, 120, '2014-03-01 01:13:31.000000', 'temperatura', 185.0000, 'ºC'),
	(227815, 120, '2014-03-01 01:13:32.000000', 'temperatura', 793.0000, 'ºC'),
	(227816, 120, '2014-03-01 01:13:33.000000', 'temperatura', 1008.0000, 'ºC'),
	(227817, 120, '2014-03-01 01:13:34.000000', 'temperatura', 261.0000, 'ºC'),
	(227818, 120, '2014-03-01 01:13:35.000000', 'temperatura', 683.0000, 'ºC'),
	(227819, 120, '2014-03-01 01:13:36.000000', 'temperatura', 233.0000, 'ºC'),
	(227820, 120, '2014-03-01 01:13:37.000000', 'temperatura', 314.0000, 'ºC'),
	(227821, 120, '2014-03-01 01:13:38.000000', 'temperatura', 874.0000, 'ºC'),
	(227822, 120, '2014-03-01 01:13:39.000000', 'temperatura', 1026.0000, 'ºC'),
	(227823, 120, '2014-03-01 01:13:40.000000', 'temperatura', 112.0000, 'ºC'),
	(227824, 120, '2014-03-01 01:13:41.000000', 'temperatura', 1080.0000, 'ºC'),
	(227825, 120, '2014-03-01 01:13:42.000000', 'temperatura', 265.0000, 'ºC'),
	(227826, 120, '2014-03-01 01:13:43.000000', 'temperatura', 487.0000, 'ºC'),
	(227827, 120, '2014-03-01 01:13:44.000000', 'temperatura', 438.0000, 'ºC'),
	(227828, 120, '2014-03-01 01:13:45.000000', 'temperatura', 729.0000, 'ºC'),
	(227829, 120, '2014-03-01 01:13:46.000000', 'temperatura', 1133.0000, 'ºC'),
	(227830, 120, '2014-03-01 01:13:47.000000', 'temperatura', 1079.0000, 'ºC'),
	(227831, 120, '2014-03-01 01:13:48.000000', 'temperatura', 798.0000, 'ºC'),
	(227832, 120, '2014-03-01 01:13:49.000000', 'temperatura', 751.0000, 'ºC'),
	(227833, 120, '2014-03-01 01:13:50.000000', 'temperatura', 163.0000, 'ºC'),
	(227834, 120, '2014-03-01 01:13:51.000000', 'temperatura', 961.0000, 'ºC'),
	(227835, 120, '2014-03-01 01:13:52.000000', 'temperatura', 717.0000, 'ºC'),
	(227836, 120, '2014-03-01 01:13:53.000000', 'temperatura', 704.0000, 'ºC'),
	(227837, 120, '2014-03-01 01:13:54.000000', 'temperatura', 170.0000, 'ºC'),
	(227838, 120, '2014-03-01 01:13:55.000000', 'temperatura', 1136.0000, 'ºC'),
	(227839, 120, '2014-03-01 01:13:56.000000', 'temperatura', 371.0000, 'ºC'),
	(227840, 120, '2014-03-01 01:13:57.000000', 'temperatura', 849.0000, 'ºC'),
	(227841, 120, '2014-03-01 01:13:58.000000', 'temperatura', 730.0000, 'ºC'),
	(227842, 120, '2014-03-01 01:13:59.000000', 'temperatura', 1104.0000, 'ºC'),
	(227843, 120, '2014-03-01 01:14:00.000000', 'temperatura', 930.0000, 'ºC'),
	(227844, 120, '2014-03-01 01:14:01.000000', 'temperatura', 141.0000, 'ºC'),
	(227845, 120, '2014-03-01 01:14:02.000000', 'temperatura', 315.0000, 'ºC'),
	(227846, 120, '2014-03-01 01:14:03.000000', 'temperatura', 1152.0000, 'ºC'),
	(227847, 120, '2014-03-01 01:14:04.000000', 'temperatura', 15.0000, 'ºC'),
	(227848, 120, '2014-03-01 01:14:05.000000', 'temperatura', 221.0000, 'ºC'),
	(227849, 120, '2014-03-01 01:14:06.000000', 'temperatura', 1061.0000, 'ºC'),
	(227850, 120, '2014-03-01 01:14:07.000000', 'temperatura', 1043.0000, 'ºC'),
	(227851, 120, '2014-03-01 01:14:08.000000', 'temperatura', 831.0000, 'ºC'),
	(227852, 120, '2014-03-01 01:14:09.000000', 'temperatura', 1028.0000, 'ºC'),
	(227853, 120, '2014-03-01 01:14:10.000000', 'temperatura', 247.0000, 'ºC'),
	(227854, 120, '2014-03-01 01:14:11.000000', 'temperatura', 551.0000, 'ºC'),
	(227855, 120, '2014-03-01 01:14:12.000000', 'temperatura', 815.0000, 'ºC'),
	(227856, 120, '2014-03-01 01:14:13.000000', 'temperatura', 20.0000, 'ºC'),
	(227857, 120, '2014-03-01 01:14:14.000000', 'temperatura', 59.0000, 'ºC'),
	(227858, 120, '2014-03-01 01:14:15.000000', 'temperatura', 233.0000, 'ºC'),
	(227859, 120, '2014-03-01 01:14:16.000000', 'temperatura', 990.0000, 'ºC'),
	(227860, 120, '2014-03-01 01:14:17.000000', 'temperatura', 649.0000, 'ºC'),
	(227861, 120, '2014-03-01 01:14:18.000000', 'temperatura', 278.0000, 'ºC'),
	(227862, 120, '2014-03-01 01:14:19.000000', 'temperatura', 642.0000, 'ºC'),
	(227863, 120, '2014-03-01 01:14:20.000000', 'temperatura', 1176.0000, 'ºC'),
	(227864, 120, '2014-03-01 01:14:21.000000', 'temperatura', 354.0000, 'ºC'),
	(227865, 120, '2014-03-01 01:14:22.000000', 'temperatura', 642.0000, 'ºC'),
	(227866, 120, '2014-03-01 01:14:23.000000', 'temperatura', 948.0000, 'ºC'),
	(227867, 120, '2014-03-01 01:14:24.000000', 'temperatura', 414.0000, 'ºC'),
	(227868, 120, '2014-03-01 01:14:25.000000', 'temperatura', 428.0000, 'ºC'),
	(227869, 120, '2014-03-01 01:14:26.000000', 'temperatura', 899.0000, 'ºC'),
	(227870, 120, '2014-03-01 01:14:27.000000', 'temperatura', 809.0000, 'ºC'),
	(227871, 120, '2014-03-01 01:14:28.000000', 'temperatura', 152.0000, 'ºC'),
	(227872, 120, '2014-03-01 01:14:29.000000', 'temperatura', 732.0000, 'ºC'),
	(227873, 120, '2014-03-01 01:14:30.000000', 'temperatura', 802.0000, 'ºC'),
	(227874, 120, '2014-03-01 01:14:31.000000', 'temperatura', 618.0000, 'ºC'),
	(227875, 120, '2014-03-01 01:14:32.000000', 'temperatura', 682.0000, 'ºC'),
	(227876, 120, '2014-03-01 01:14:33.000000', 'temperatura', 359.0000, 'ºC'),
	(227877, 120, '2014-03-01 01:14:34.000000', 'temperatura', 949.0000, 'ºC'),
	(227878, 120, '2014-03-01 01:14:35.000000', 'temperatura', 69.0000, 'ºC'),
	(227879, 120, '2014-03-01 01:14:36.000000', 'temperatura', 1099.0000, 'ºC'),
	(227880, 120, '2014-03-01 01:14:37.000000', 'temperatura', 486.0000, 'ºC'),
	(227881, 120, '2014-03-01 01:14:38.000000', 'temperatura', 335.0000, 'ºC'),
	(227882, 120, '2014-03-01 01:14:39.000000', 'temperatura', 216.0000, 'ºC'),
	(227883, 120, '2014-03-01 01:14:40.000000', 'temperatura', 76.0000, 'ºC'),
	(227884, 120, '2014-03-01 01:14:41.000000', 'temperatura', 934.0000, 'ºC'),
	(227885, 120, '2014-03-01 01:14:42.000000', 'temperatura', 843.0000, 'ºC'),
	(227886, 120, '2014-03-01 01:14:43.000000', 'temperatura', 213.0000, 'ºC'),
	(227887, 120, '2014-03-01 01:14:44.000000', 'temperatura', 935.0000, 'ºC'),
	(227888, 120, '2014-03-01 01:14:45.000000', 'temperatura', 438.0000, 'ºC'),
	(227889, 120, '2014-03-01 01:14:46.000000', 'temperatura', 586.0000, 'ºC'),
	(227890, 120, '2014-03-01 01:14:47.000000', 'temperatura', 418.0000, 'ºC'),
	(227891, 120, '2014-03-01 01:14:48.000000', 'temperatura', 331.0000, 'ºC'),
	(227892, 120, '2014-03-01 01:14:49.000000', 'temperatura', 400.0000, 'ºC'),
	(227893, 120, '2014-03-01 01:14:50.000000', 'temperatura', 1009.0000, 'ºC'),
	(227894, 120, '2014-03-01 01:14:51.000000', 'temperatura', 243.0000, 'ºC'),
	(227895, 120, '2014-03-01 01:14:52.000000', 'temperatura', 591.0000, 'ºC'),
	(227896, 120, '2014-03-01 01:14:53.000000', 'temperatura', 1027.0000, 'ºC'),
	(227897, 120, '2014-03-01 01:14:54.000000', 'temperatura', 961.0000, 'ºC'),
	(227898, 120, '2014-03-01 01:14:55.000000', 'temperatura', 525.0000, 'ºC'),
	(227899, 120, '2014-03-01 01:14:56.000000', 'temperatura', 942.0000, 'ºC'),
	(227900, 120, '2014-03-01 01:14:57.000000', 'temperatura', 738.0000, 'ºC'),
	(227901, 120, '2014-03-01 01:14:58.000000', 'temperatura', 862.0000, 'ºC'),
	(227902, 120, '2014-03-01 01:14:59.000000', 'temperatura', 895.0000, 'ºC'),
	(227903, 120, '2014-03-01 01:15:00.000000', 'temperatura', 692.0000, 'ºC'),
	(227904, 120, '2014-03-01 01:15:01.000000', 'temperatura', 775.0000, 'ºC'),
	(227905, 120, '2014-03-01 01:15:02.000000', 'temperatura', 600.0000, 'ºC'),
	(227906, 120, '2014-03-01 01:15:03.000000', 'temperatura', 673.0000, 'ºC'),
	(227907, 120, '2014-03-01 01:15:04.000000', 'temperatura', 367.0000, 'ºC'),
	(227908, 120, '2014-03-01 01:15:05.000000', 'temperatura', 1016.0000, 'ºC'),
	(227909, 120, '2014-03-01 01:15:06.000000', 'temperatura', 379.0000, 'ºC'),
	(227910, 120, '2014-03-01 01:15:07.000000', 'temperatura', 47.0000, 'ºC'),
	(227911, 120, '2014-03-01 01:15:08.000000', 'temperatura', 298.0000, 'ºC'),
	(227912, 120, '2014-03-01 01:15:09.000000', 'temperatura', 149.0000, 'ºC'),
	(227913, 120, '2014-03-01 01:15:10.000000', 'temperatura', 1052.0000, 'ºC'),
	(227914, 120, '2014-03-01 01:15:11.000000', 'temperatura', 14.0000, 'ºC'),
	(227915, 120, '2014-03-01 01:15:12.000000', 'temperatura', 515.0000, 'ºC'),
	(227916, 120, '2014-03-01 01:15:13.000000', 'temperatura', 131.0000, 'ºC'),
	(227917, 120, '2014-03-01 01:15:14.000000', 'temperatura', 313.0000, 'ºC'),
	(227918, 120, '2014-03-01 01:15:15.000000', 'temperatura', 1171.0000, 'ºC'),
	(227919, 120, '2014-03-01 01:15:16.000000', 'temperatura', 119.0000, 'ºC'),
	(227920, 120, '2014-03-01 01:15:17.000000', 'temperatura', 681.0000, 'ºC'),
	(227921, 120, '2014-03-01 01:15:18.000000', 'temperatura', 647.0000, 'ºC'),
	(227922, 120, '2014-03-01 01:15:19.000000', 'temperatura', 1194.0000, 'ºC'),
	(227923, 120, '2014-03-01 01:15:20.000000', 'temperatura', 430.0000, 'ºC'),
	(227924, 120, '2014-03-01 01:15:21.000000', 'temperatura', 967.0000, 'ºC'),
	(227925, 120, '2014-03-01 01:15:22.000000', 'temperatura', 1144.0000, 'ºC'),
	(227926, 120, '2014-03-01 01:15:23.000000', 'temperatura', 422.0000, 'ºC'),
	(227927, 120, '2014-03-01 01:15:24.000000', 'temperatura', 1078.0000, 'ºC'),
	(227928, 120, '2014-03-01 01:15:25.000000', 'temperatura', 526.0000, 'ºC'),
	(227929, 120, '2014-03-01 01:15:26.000000', 'temperatura', 594.0000, 'ºC'),
	(227930, 120, '2014-03-01 01:15:27.000000', 'temperatura', 191.0000, 'ºC'),
	(227931, 120, '2014-03-01 01:15:28.000000', 'temperatura', 377.0000, 'ºC'),
	(227932, 120, '2014-03-01 01:15:29.000000', 'temperatura', 113.0000, 'ºC'),
	(227933, 120, '2014-03-01 01:15:30.000000', 'temperatura', 632.0000, 'ºC'),
	(227934, 120, '2014-03-01 01:15:31.000000', 'temperatura', 422.0000, 'ºC'),
	(227935, 120, '2014-03-01 01:15:32.000000', 'temperatura', 215.0000, 'ºC'),
	(227936, 120, '2014-03-01 01:15:33.000000', 'temperatura', 1010.0000, 'ºC'),
	(227937, 120, '2014-03-01 01:15:34.000000', 'temperatura', 806.0000, 'ºC'),
	(227938, 120, '2014-03-01 01:15:35.000000', 'temperatura', 1000.0000, 'ºC'),
	(227939, 120, '2014-03-01 01:15:36.000000', 'temperatura', 183.0000, 'ºC'),
	(227940, 120, '2014-03-01 01:15:37.000000', 'temperatura', 315.0000, 'ºC'),
	(227941, 120, '2014-03-01 01:15:38.000000', 'temperatura', 1026.0000, 'ºC'),
	(227942, 120, '2014-03-01 01:15:39.000000', 'temperatura', 584.0000, 'ºC'),
	(227943, 120, '2014-03-01 01:15:40.000000', 'temperatura', 1043.0000, 'ºC'),
	(227944, 120, '2014-03-01 01:15:41.000000', 'temperatura', 1066.0000, 'ºC'),
	(227945, 120, '2014-03-01 01:15:42.000000', 'temperatura', 1001.0000, 'ºC'),
	(227946, 120, '2014-03-01 01:15:43.000000', 'temperatura', 605.0000, 'ºC'),
	(227947, 120, '2014-03-01 01:15:44.000000', 'temperatura', 23.0000, 'ºC'),
	(227948, 120, '2014-03-01 01:15:45.000000', 'temperatura', 703.0000, 'ºC'),
	(227949, 120, '2014-03-01 01:15:46.000000', 'temperatura', 1044.0000, 'ºC'),
	(227950, 120, '2014-03-01 01:15:47.000000', 'temperatura', 714.0000, 'ºC'),
	(227951, 120, '2014-03-01 01:15:48.000000', 'temperatura', 437.0000, 'ºC'),
	(227952, 120, '2014-03-01 01:15:49.000000', 'temperatura', 45.0000, 'ºC'),
	(227953, 120, '2014-03-01 01:15:50.000000', 'temperatura', 115.0000, 'ºC'),
	(227954, 120, '2014-03-01 01:15:51.000000', 'temperatura', 440.0000, 'ºC'),
	(227955, 120, '2014-03-01 01:15:52.000000', 'temperatura', 655.0000, 'ºC'),
	(227956, 120, '2014-03-01 01:15:53.000000', 'temperatura', 756.0000, 'ºC'),
	(227957, 120, '2014-03-01 01:15:54.000000', 'temperatura', 614.0000, 'ºC'),
	(227958, 120, '2014-03-01 01:15:55.000000', 'temperatura', 803.0000, 'ºC'),
	(227959, 120, '2014-03-01 01:15:56.000000', 'temperatura', 975.0000, 'ºC'),
	(227960, 120, '2014-03-01 01:15:57.000000', 'temperatura', 66.0000, 'ºC'),
	(227961, 120, '2014-03-01 01:15:58.000000', 'temperatura', 1003.0000, 'ºC'),
	(227962, 120, '2014-03-01 01:15:59.000000', 'temperatura', 20.0000, 'ºC'),
	(227963, 120, '2014-03-01 01:16:00.000000', 'temperatura', 689.0000, 'ºC'),
	(227964, 120, '2014-03-01 01:16:01.000000', 'temperatura', 989.0000, 'ºC'),
	(227965, 120, '2014-03-01 01:16:02.000000', 'temperatura', 476.0000, 'ºC'),
	(227966, 120, '2014-03-01 01:16:03.000000', 'temperatura', 612.0000, 'ºC'),
	(227967, 120, '2014-03-01 01:16:04.000000', 'temperatura', 436.0000, 'ºC'),
	(227968, 120, '2014-03-01 01:16:05.000000', 'temperatura', 343.0000, 'ºC'),
	(227969, 120, '2014-03-01 01:16:06.000000', 'temperatura', 409.0000, 'ºC'),
	(227970, 120, '2014-03-01 01:16:07.000000', 'temperatura', 1017.0000, 'ºC'),
	(227971, 120, '2014-03-01 01:16:08.000000', 'temperatura', 257.0000, 'ºC'),
	(227972, 120, '2014-03-01 01:16:09.000000', 'temperatura', 635.0000, 'ºC'),
	(227973, 120, '2014-03-01 01:16:10.000000', 'temperatura', 3.0000, 'ºC'),
	(227974, 120, '2014-03-01 01:16:11.000000', 'temperatura', 513.0000, 'ºC'),
	(227975, 120, '2014-03-01 01:16:12.000000', 'temperatura', 155.0000, 'ºC'),
	(227976, 120, '2014-03-01 01:16:13.000000', 'temperatura', 437.0000, 'ºC'),
	(227977, 120, '2014-03-01 01:16:14.000000', 'temperatura', 520.0000, 'ºC'),
	(227978, 120, '2014-03-01 01:16:15.000000', 'temperatura', 92.0000, 'ºC'),
	(227979, 120, '2014-03-01 01:16:16.000000', 'temperatura', 97.0000, 'ºC'),
	(227980, 120, '2014-03-01 01:16:17.000000', 'temperatura', 210.0000, 'ºC'),
	(227981, 120, '2014-03-01 01:16:18.000000', 'temperatura', 760.0000, 'ºC'),
	(227982, 120, '2014-03-01 01:16:19.000000', 'temperatura', 770.0000, 'ºC'),
	(227983, 120, '2014-03-01 01:16:20.000000', 'temperatura', 372.0000, 'ºC'),
	(227984, 120, '2014-03-01 01:16:21.000000', 'temperatura', 749.0000, 'ºC'),
	(227985, 120, '2014-03-01 01:16:22.000000', 'temperatura', 231.0000, 'ºC'),
	(227986, 120, '2014-03-01 01:16:23.000000', 'temperatura', 107.0000, 'ºC'),
	(227987, 120, '2014-03-01 01:16:24.000000', 'temperatura', 1044.0000, 'ºC'),
	(227988, 120, '2014-03-01 01:16:25.000000', 'temperatura', 99.0000, 'ºC'),
	(227989, 120, '2014-03-01 01:16:26.000000', 'temperatura', 963.0000, 'ºC'),
	(227990, 120, '2014-03-01 01:16:27.000000', 'temperatura', 919.0000, 'ºC'),
	(227991, 120, '2014-03-01 01:16:28.000000', 'temperatura', 504.0000, 'ºC'),
	(227992, 120, '2014-03-01 01:16:29.000000', 'temperatura', 967.0000, 'ºC'),
	(227993, 120, '2014-03-01 01:16:30.000000', 'temperatura', 921.0000, 'ºC'),
	(227994, 120, '2014-03-01 01:16:31.000000', 'temperatura', 506.0000, 'ºC'),
	(227995, 120, '2014-03-01 01:16:32.000000', 'temperatura', 968.0000, 'ºC'),
	(227996, 120, '2014-03-01 01:16:33.000000', 'temperatura', 921.0000, 'ºC'),
	(227997, 120, '2014-03-01 01:16:34.000000', 'temperatura', 502.0000, 'ºC'),
	(227998, 120, '2014-03-01 01:16:35.000000', 'temperatura', 946.0000, 'ºC'),
	(227999, 120, '2014-03-01 01:16:36.000000', 'temperatura', 824.0000, 'ºC'),
	(228000, 120, '2014-03-01 01:16:37.000000', 'temperatura', 82.0000, 'ºC'),
	(228001, 120, '2014-03-01 01:16:38.000000', 'temperatura', 340.0000, 'ºC'),
	(228002, 120, '2014-03-01 01:16:39.000000', 'temperatura', 256.0000, 'ºC'),
	(228003, 120, '2014-03-01 01:16:40.000000', 'temperatura', 260.0000, 'ºC'),
	(228004, 120, '2014-03-01 01:16:41.000000', 'temperatura', 530.0000, 'ºC'),
	(228005, 120, '2014-03-01 01:16:42.000000', 'temperatura', 673.0000, 'ºC'),
	(228006, 120, '2014-03-01 01:16:43.000000', 'temperatura', 574.0000, 'ºC'),
	(228007, 120, '2014-03-01 01:16:44.000000', 'temperatura', 851.0000, 'ºC'),
	(228008, 120, '2014-03-01 01:16:45.000000', 'temperatura', 136.0000, 'ºC'),
	(228009, 120, '2014-03-01 01:16:46.000000', 'temperatura', 526.0000, 'ºC'),
	(228010, 120, '2014-03-01 01:16:47.000000', 'temperatura', 1025.0000, 'ºC'),
	(228011, 120, '2014-03-01 01:16:48.000000', 'temperatura', 1145.0000, 'ºC'),
	(228012, 120, '2014-03-01 01:16:49.000000', 'temperatura', 252.0000, 'ºC'),
	(228013, 120, '2014-03-01 01:16:50.000000', 'temperatura', 223.0000, 'ºC'),
	(228014, 120, '2014-03-01 01:16:51.000000', 'temperatura', 360.0000, 'ºC'),
	(228015, 120, '2014-03-01 01:16:52.000000', 'temperatura', 1131.0000, 'ºC'),
	(228016, 120, '2014-03-01 01:16:53.000000', 'temperatura', 977.0000, 'ºC'),
	(228017, 120, '2014-03-01 01:16:54.000000', 'temperatura', 293.0000, 'ºC'),
	(228018, 120, '2014-03-01 01:16:55.000000', 'temperatura', 934.0000, 'ºC'),
	(228019, 120, '2014-03-01 01:16:56.000000', 'temperatura', 190.0000, 'ºC'),
	(228020, 120, '2014-03-01 01:16:57.000000', 'temperatura', 548.0000, 'ºC'),
	(228021, 120, '2014-03-01 01:16:58.000000', 'temperatura', 972.0000, 'ºC'),
	(228022, 120, '2014-03-01 01:16:59.000000', 'temperatura', 815.0000, 'ºC'),
	(228023, 120, '2014-03-01 01:17:00.000000', 'temperatura', 1161.0000, 'ºC'),
	(228024, 120, '2014-03-01 01:17:01.000000', 'temperatura', 962.0000, 'ºC'),
	(228025, 120, '2014-03-01 01:17:02.000000', 'temperatura', 125.0000, 'ºC'),
	(228026, 120, '2014-03-01 01:17:03.000000', 'temperatura', 138.0000, 'ºC'),
	(228027, 120, '2014-03-01 01:17:04.000000', 'temperatura', 319.0000, 'ºC'),
	(228028, 120, '2014-03-01 01:17:05.000000', 'temperatura', 1180.0000, 'ºC'),
	(228029, 120, '2014-03-01 01:17:06.000000', 'temperatura', 145.0000, 'ºC'),
	(228030, 120, '2014-03-01 01:17:07.000000', 'temperatura', 783.0000, 'ºC'),
	(228031, 120, '2014-03-01 01:17:08.000000', 'temperatura', 1080.0000, 'ºC'),
	(228032, 120, '2014-03-01 01:17:09.000000', 'temperatura', 651.0000, 'ºC'),
	(228033, 120, '2014-03-01 01:17:10.000000', 'temperatura', 16.0000, 'ºC'),
	(228034, 120, '2014-03-01 01:17:11.000000', 'temperatura', 529.0000, 'ºC'),
	(228035, 120, '2014-03-01 01:17:12.000000', 'temperatura', 195.0000, 'ºC'),
	(228036, 120, '2014-03-01 01:17:13.000000', 'temperatura', 591.0000, 'ºC'),
	(228037, 120, '2014-03-01 01:17:14.000000', 'temperatura', 1169.0000, 'ºC'),
	(228038, 120, '2014-03-01 01:17:15.000000', 'temperatura', 473.0000, 'ºC'),
	(228039, 120, '2014-03-01 01:17:16.000000', 'temperatura', 57.0000, 'ºC'),
	(228040, 120, '2014-03-01 01:17:17.000000', 'temperatura', 68.0000, 'ºC'),
	(228041, 120, '2014-03-01 01:17:18.000000', 'temperatura', 169.0000, 'ºC'),
	(228042, 120, '2014-03-01 01:17:19.000000', 'temperatura', 641.0000, 'ºC'),
	(228043, 120, '2014-03-01 01:17:20.000000', 'temperatura', 300.0000, 'ºC'),
	(228044, 120, '2014-03-01 01:17:21.000000', 'temperatura', 776.0000, 'ºC'),
	(228045, 120, '2014-03-01 01:17:22.000000', 'temperatura', 581.0000, 'ºC'),
	(228046, 120, '2014-03-01 01:17:23.000000', 'temperatura', 579.0000, 'ºC'),
	(228047, 120, '2014-03-01 01:17:24.000000', 'temperatura', 1152.0000, 'ºC'),
	(228048, 120, '2014-03-01 01:17:25.000000', 'temperatura', 424.0000, 'ºC'),
	(228049, 120, '2014-03-01 01:17:26.000000', 'temperatura', 1064.0000, 'ºC'),
	(228050, 120, '2014-03-01 01:17:27.000000', 'temperatura', 449.0000, 'ºC'),
	(228051, 120, '2014-03-01 01:17:28.000000', 'temperatura', 252.0000, 'ºC'),
	(228052, 120, '2014-03-01 01:17:29.000000', 'temperatura', 1113.0000, 'ºC'),
	(228053, 120, '2014-03-01 01:17:30.000000', 'temperatura', 10.0000, 'ºC'),
	(228054, 120, '2014-03-01 01:17:31.000000', 'temperatura', 313.0000, 'ºC'),
	(228055, 120, '2014-03-01 01:17:32.000000', 'temperatura', 335.0000, 'ºC'),
	(228056, 120, '2014-03-01 01:17:33.000000', 'temperatura', 738.0000, 'ºC'),
	(228057, 120, '2014-03-01 01:17:34.000000', 'temperatura', 285.0000, 'ºC'),
	(228058, 120, '2014-03-01 01:17:35.000000', 'temperatura', 412.0000, 'ºC'),
	(228059, 120, '2014-03-01 01:17:36.000000', 'temperatura', 3.0000, 'ºC'),
	(228060, 120, '2014-03-01 01:17:37.000000', 'temperatura', 1180.0000, 'ºC'),
	(228061, 120, '2014-03-01 01:17:38.000000', 'temperatura', 1090.0000, 'ºC'),
	(228062, 120, '2014-03-01 01:17:39.000000', 'temperatura', 712.0000, 'ºC'),
	(228063, 120, '2014-03-01 01:17:40.000000', 'temperatura', 290.0000, 'ºC'),
	(228064, 120, '2014-03-01 01:17:41.000000', 'temperatura', 513.0000, 'ºC'),
	(228065, 120, '2014-03-01 01:17:42.000000', 'temperatura', 499.0000, 'ºC'),
	(228066, 120, '2014-03-01 01:17:43.000000', 'temperatura', 954.0000, 'ºC'),
	(228067, 120, '2014-03-01 01:17:44.000000', 'temperatura', 873.0000, 'ºC'),
	(228068, 120, '2014-03-01 01:17:45.000000', 'temperatura', 305.0000, 'ºC'),
	(228069, 120, '2014-03-01 01:17:46.000000', 'temperatura', 108.0000, 'ºC'),
	(228070, 120, '2014-03-01 01:17:47.000000', 'temperatura', 824.0000, 'ºC'),
	(228071, 120, '2014-03-01 01:17:48.000000', 'temperatura', 197.0000, 'ºC'),
	(228072, 120, '2014-03-01 01:17:49.000000', 'temperatura', 913.0000, 'ºC'),
	(228073, 120, '2014-03-01 01:17:50.000000', 'temperatura', 375.0000, 'ºC'),
	(228074, 120, '2014-03-01 01:17:51.000000', 'temperatura', 336.0000, 'ºC'),
	(228075, 120, '2014-03-01 01:17:52.000000', 'temperatura', 558.0000, 'ºC'),
	(228076, 120, '2014-03-01 01:17:53.000000', 'temperatura', 579.0000, 'ºC'),
	(228077, 120, '2014-03-01 01:17:54.000000', 'temperatura', 22.0000, 'ºC'),
	(228078, 120, '2014-03-01 01:17:55.000000', 'temperatura', 776.0000, 'ºC'),
	(228079, 120, '2014-03-01 01:17:56.000000', 'temperatura', 212.0000, 'ºC'),
	(228080, 120, '2014-03-01 01:17:57.000000', 'temperatura', 1135.0000, 'ºC'),
	(228081, 120, '2014-03-01 01:17:58.000000', 'temperatura', 238.0000, 'ºC'),
	(228082, 120, '2014-03-01 01:17:59.000000', 'temperatura', 186.0000, 'ºC'),
	(228083, 120, '2014-03-01 01:18:00.000000', 'temperatura', 216.0000, 'ºC'),
	(228084, 120, '2014-03-01 01:18:01.000000', 'temperatura', 524.0000, 'ºC'),
	(228085, 120, '2014-03-01 01:18:02.000000', 'temperatura', 771.0000, 'ºC'),
	(228086, 120, '2014-03-01 01:18:03.000000', 'temperatura', 1082.0000, 'ºC'),
	(228087, 120, '2014-03-01 01:18:04.000000', 'temperatura', 700.0000, 'ºC'),
	(228088, 120, '2014-03-01 01:18:05.000000', 'temperatura', 252.0000, 'ºC'),
	(228089, 120, '2014-03-01 01:18:06.000000', 'temperatura', 363.0000, 'ºC'),
	(228090, 120, '2014-03-01 01:18:07.000000', 'temperatura', 1056.0000, 'ºC'),
	(228091, 120, '2014-03-01 01:18:08.000000', 'temperatura', 595.0000, 'ºC'),
	(228092, 120, '2014-03-01 01:18:09.000000', 'temperatura', 1008.0000, 'ºC'),
	(228093, 120, '2014-03-01 01:18:10.000000', 'temperatura', 852.0000, 'ºC'),
	(228094, 120, '2014-03-01 01:18:11.000000', 'temperatura', 39.0000, 'ºC'),
	(228095, 120, '2014-03-01 01:18:12.000000', 'temperatura', 39.0000, 'ºC'),
	(228096, 120, '2014-03-01 01:18:13.000000', 'temperatura', 78.0000, 'ºC'),
	(228097, 120, '2014-03-01 01:18:14.000000', 'temperatura', 275.0000, 'ºC'),
	(228098, 120, '2014-03-01 01:18:15.000000', 'temperatura', 1143.0000, 'ºC'),
	(228099, 120, '2014-03-01 01:18:16.000000', 'temperatura', 87.0000, 'ºC'),
	(228100, 120, '2014-03-01 01:18:17.000000', 'temperatura', 608.0000, 'ºC'),
	(228101, 120, '2014-03-01 01:18:18.000000', 'temperatura', 378.0000, 'ºC'),
	(228102, 120, '2014-03-01 01:18:19.000000', 'temperatura', 66.0000, 'ºC'),
	(228103, 120, '2014-03-01 01:18:20.000000', 'temperatura', 399.0000, 'ºC'),
	(228104, 120, '2014-03-01 01:18:21.000000', 'temperatura', 594.0000, 'ºC'),
	(228105, 120, '2014-03-01 01:18:22.000000', 'temperatura', 577.0000, 'ºC'),
	(228106, 120, '2014-03-01 01:18:23.000000', 'temperatura', 1101.0000, 'ºC'),
	(228107, 120, '2014-03-01 01:18:24.000000', 'temperatura', 177.0000, 'ºC'),
	(228108, 120, '2014-03-01 01:18:25.000000', 'temperatura', 1179.0000, 'ºC'),
	(228109, 120, '2014-03-01 01:18:26.000000', 'temperatura', 568.0000, 'ºC'),
	(228110, 120, '2014-03-01 01:18:27.000000', 'temperatura', 501.0000, 'ºC'),
	(228111, 120, '2014-03-01 01:18:28.000000', 'temperatura', 803.0000, 'ºC'),
	(228112, 120, '2014-03-01 01:18:29.000000', 'temperatura', 110.0000, 'ºC'),
	(228113, 120, '2014-03-01 01:18:30.000000', 'temperatura', 545.0000, 'ºC'),
	(228114, 120, '2014-03-01 01:18:31.000000', 'temperatura', 1194.0000, 'ºC'),
	(228115, 120, '2014-03-01 01:18:32.000000', 'temperatura', 734.0000, 'ºC'),
	(228116, 120, '2014-03-01 01:18:33.000000', 'temperatura', 92.0000, 'ºC'),
	(228117, 120, '2014-03-01 01:18:34.000000', 'temperatura', 655.0000, 'ºC'),
	(228118, 120, '2014-03-01 01:18:35.000000', 'temperatura', 603.0000, 'ºC'),
	(228119, 120, '2014-03-01 01:18:36.000000', 'temperatura', 1047.0000, 'ºC'),
	(228120, 120, '2014-03-01 01:18:37.000000', 'temperatura', 1029.0000, 'ºC'),
	(228121, 120, '2014-03-01 01:18:38.000000', 'temperatura', 804.0000, 'ºC'),
	(228122, 120, '2014-03-01 01:18:39.000000', 'temperatura', 935.0000, 'ºC'),
	(228123, 120, '2014-03-01 01:18:40.000000', 'temperatura', 1061.0000, 'ºC'),
	(228124, 120, '2014-03-01 01:18:41.000000', 'temperatura', 101.0000, 'ºC'),
	(228125, 120, '2014-03-01 01:18:42.000000', 'temperatura', 923.0000, 'ºC'),
	(228126, 120, '2014-03-01 01:18:43.000000', 'temperatura', 712.0000, 'ºC'),
	(228127, 120, '2014-03-01 01:18:44.000000', 'temperatura', 791.0000, 'ºC'),
	(228128, 120, '2014-03-01 01:18:45.000000', 'temperatura', 620.0000, 'ºC'),
	(228129, 120, '2014-03-01 01:18:46.000000', 'temperatura', 729.0000, 'ºC'),
	(228130, 120, '2014-03-01 01:18:47.000000', 'temperatura', 586.0000, 'ºC'),
	(228131, 120, '2014-03-01 01:18:48.000000', 'temperatura', 741.0000, 'ºC'),
	(228132, 120, '2014-03-01 01:18:49.000000', 'temperatura', 748.0000, 'ºC'),
	(228133, 120, '2014-03-01 01:18:50.000000', 'temperatura', 318.0000, 'ºC'),
	(228134, 120, '2014-03-01 01:18:51.000000', 'temperatura', 548.0000, 'ºC'),
	(228135, 120, '2014-03-01 01:18:52.000000', 'temperatura', 586.0000, 'ºC'),
	(228136, 120, '2014-03-01 01:18:53.000000', 'temperatura', 87.0000, 'ºC'),
	(228137, 120, '2014-03-01 01:18:54.000000', 'temperatura', 1075.0000, 'ºC'),
	(228138, 120, '2014-03-01 01:18:55.000000', 'temperatura', 316.0000, 'ºC'),
	(228139, 120, '2014-03-01 01:18:56.000000', 'temperatura', 756.0000, 'ºC'),
	(228140, 120, '2014-03-01 01:18:57.000000', 'temperatura', 432.0000, 'ºC'),
	(228141, 120, '2014-03-01 01:18:58.000000', 'temperatura', 1092.0000, 'ºC'),
	(228142, 120, '2014-03-01 01:18:59.000000', 'temperatura', 563.0000, 'ºC'),
	(228143, 120, '2014-03-01 01:19:00.000000', 'temperatura', 743.0000, 'ºC'),
	(228144, 120, '2014-03-01 01:19:01.000000', 'temperatura', 824.0000, 'ºC'),
	(228145, 120, '2014-03-01 01:19:02.000000', 'temperatura', 692.0000, 'ºC'),
	(228146, 120, '2014-03-01 01:19:03.000000', 'temperatura', 987.0000, 'ºC'),
	(228147, 120, '2014-03-01 01:19:04.000000', 'temperatura', 462.0000, 'ºC'),
	(228148, 120, '2014-03-01 01:19:05.000000', 'temperatura', 548.0000, 'ºC'),
	(228149, 120, '2014-03-01 01:19:06.000000', 'temperatura', 156.0000, 'ºC'),
	(228150, 120, '2014-03-01 01:19:07.000000', 'temperatura', 336.0000, 'ºC'),
	(228151, 120, '2014-03-01 01:19:08.000000', 'temperatura', 11.0000, 'ºC'),
	(228152, 120, '2014-03-01 01:19:09.000000', 'temperatura', 247.0000, 'ºC'),
	(228153, 120, '2014-03-01 01:19:10.000000', 'temperatura', 2.0000, 'ºC'),
	(228154, 120, '2014-03-01 01:19:11.000000', 'temperatura', 472.0000, 'ºC'),
	(228155, 120, '2014-03-01 01:19:12.000000', 'temperatura', 1154.0000, 'ºC'),
	(228156, 120, '2014-03-01 01:19:13.000000', 'temperatura', 753.0000, 'ºC'),
	(228157, 120, '2014-03-01 01:19:14.000000', 'temperatura', 305.0000, 'ºC'),
	(228158, 120, '2014-03-01 01:19:15.000000', 'temperatura', 467.0000, 'ºC'),
	(228159, 120, '2014-03-01 01:19:16.000000', 'temperatura', 220.0000, 'ºC'),
	(228160, 120, '2014-03-01 01:19:17.000000', 'temperatura', 900.0000, 'ºC'),
	(228161, 120, '2014-03-01 01:19:18.000000', 'temperatura', 238.0000, 'ºC'),
	(228162, 120, '2014-03-01 01:19:19.000000', 'temperatura', 892.0000, 'ºC'),
	(228163, 120, '2014-03-01 01:19:20.000000', 'temperatura', 147.0000, 'ºC'),
	(228164, 120, '2014-03-01 01:19:21.000000', 'temperatura', 459.0000, 'ºC'),
	(228165, 120, '2014-03-01 01:19:22.000000', 'temperatura', 654.0000, 'ºC'),
	(228166, 120, '2014-03-01 01:19:23.000000', 'temperatura', 692.0000, 'ºC'),
	(228167, 120, '2014-03-01 01:19:24.000000', 'temperatura', 300.0000, 'ºC'),
	(228168, 120, '2014-03-01 01:19:25.000000', 'temperatura', 627.0000, 'ºC'),
	(228169, 120, '2014-03-01 01:19:26.000000', 'temperatura', 1032.0000, 'ºC'),
	(228170, 120, '2014-03-01 01:19:27.000000', 'temperatura', 879.0000, 'ºC'),
	(228171, 120, '2014-03-01 01:19:28.000000', 'temperatura', 99.0000, 'ºC'),
	(228172, 120, '2014-03-01 01:19:29.000000', 'temperatura', 262.0000, 'ºC'),
	(228173, 120, '2014-03-01 01:19:30.000000', 'temperatura', 1010.0000, 'ºC'),
	(228174, 120, '2014-03-01 01:19:31.000000', 'temperatura', 667.0000, 'ºC'),
	(228175, 120, '2014-03-01 01:19:32.000000', 'temperatura', 306.0000, 'ºC'),
	(228176, 120, '2014-03-01 01:19:33.000000', 'temperatura', 729.0000, 'ºC'),
	(228177, 120, '2014-03-01 01:19:34.000000', 'temperatura', 326.0000, 'ºC'),
	(228178, 120, '2014-03-01 01:19:35.000000', 'temperatura', 644.0000, 'ºC'),
	(228179, 120, '2014-03-01 01:19:36.000000', 'temperatura', 1044.0000, 'ºC'),
	(228180, 120, '2014-03-01 01:19:37.000000', 'temperatura', 889.0000, 'ºC'),
	(228181, 120, '2014-03-01 01:19:38.000000', 'temperatura', 112.0000, 'ºC'),
	(228182, 120, '2014-03-01 01:19:39.000000', 'temperatura', 293.0000, 'ºC'),
	(228183, 120, '2014-03-01 01:19:40.000000', 'temperatura', 1131.0000, 'ºC'),
	(228184, 120, '2014-03-01 01:19:41.000000', 'temperatura', 1175.0000, 'ºC'),
	(228185, 120, '2014-03-01 01:19:42.000000', 'temperatura', 82.0000, 'ºC'),
	(228186, 120, '2014-03-01 01:19:43.000000', 'temperatura', 488.0000, 'ºC'),
	(228187, 120, '2014-03-01 01:19:44.000000', 'temperatura', 993.0000, 'ºC'),
	(228188, 120, '2014-03-01 01:19:45.000000', 'temperatura', 1103.0000, 'ºC'),
	(228189, 120, '2014-03-01 01:19:46.000000', 'temperatura', 134.0000, 'ºC'),
	(228190, 120, '2014-03-01 01:19:47.000000', 'temperatura', 964.0000, 'ºC'),
	(228191, 120, '2014-03-01 01:19:48.000000', 'temperatura', 820.0000, 'ºC'),
	(228192, 120, '2014-03-01 01:19:49.000000', 'temperatura', 5.0000, 'ºC'),
	(228193, 120, '2014-03-01 01:19:50.000000', 'temperatura', 1167.0000, 'ºC'),
	(228194, 120, '2014-03-01 01:19:51.000000', 'temperatura', 1020.0000, 'ºC'),
	(228195, 120, '2014-03-01 01:19:52.000000', 'temperatura', 399.0000, 'ºC'),
	(228196, 120, '2014-03-01 01:19:53.000000', 'temperatura', 135.0000, 'ºC'),
	(228197, 120, '2014-03-01 01:19:54.000000', 'temperatura', 678.0000, 'ºC'),
	(228198, 120, '2014-03-01 01:19:55.000000', 'temperatura', 584.0000, 'ºC'),
	(228199, 120, '2014-03-01 01:19:56.000000', 'temperatura', 890.0000, 'ºC'),
	(228200, 120, '2014-03-01 01:19:57.000000', 'temperatura', 296.0000, 'ºC'),
	(228201, 120, '2014-03-01 01:19:58.000000', 'temperatura', 13.0000, 'ºC'),
	(228202, 120, '2014-03-01 01:19:59.000000', 'temperatura', 375.0000, 'ºC'),
	(228203, 120, '2014-03-01 01:20:00.000000', 'temperatura', 640.0000, 'ºC'),
	(228204, 120, '2014-03-01 01:20:01.000000', 'temperatura', 872.0000, 'ºC'),
	(228205, 120, '2014-03-01 01:20:02.000000', 'temperatura', 40.0000, 'ºC'),
	(228206, 120, '2014-03-01 01:20:03.000000', 'temperatura', 1185.0000, 'ºC'),
	(228207, 120, '2014-03-01 01:20:04.000000', 'temperatura', 1008.0000, 'ºC'),
	(228208, 120, '2014-03-01 01:20:05.000000', 'temperatura', 284.0000, 'ºC'),
	(228209, 120, '2014-03-01 01:20:06.000000', 'temperatura', 797.0000, 'ºC'),
	(228210, 120, '2014-03-01 01:20:07.000000', 'temperatura', 732.0000, 'ºC'),
	(228211, 120, '2014-03-01 01:20:08.000000', 'temperatura', 71.0000, 'ºC'),
	(228212, 120, '2014-03-01 01:20:09.000000', 'temperatura', 561.0000, 'ºC'),
	(228213, 120, '2014-03-01 01:20:10.000000', 'temperatura', 189.0000, 'ºC'),
	(228214, 120, '2014-03-01 01:20:11.000000', 'temperatura', 465.0000, 'ºC'),
	(228215, 120, '2014-03-01 01:20:12.000000', 'temperatura', 558.0000, 'ºC'),
	(228216, 120, '2014-03-01 01:20:13.000000', 'temperatura', 194.0000, 'ºC'),
	(228217, 120, '2014-03-01 01:20:14.000000', 'temperatura', 496.0000, 'ºC'),
	(228218, 120, '2014-03-01 01:20:15.000000', 'temperatura', 699.0000, 'ºC'),
	(228219, 120, '2014-03-01 01:20:16.000000', 'temperatura', 809.0000, 'ºC'),
	(228220, 120, '2014-03-01 01:20:17.000000', 'temperatura', 749.0000, 'ºC'),
	(228221, 120, '2014-03-01 01:20:18.000000', 'temperatura', 116.0000, 'ºC'),
	(228222, 120, '2014-03-01 01:20:19.000000', 'temperatura', 737.0000, 'ºC'),
	(228223, 120, '2014-03-01 01:20:20.000000', 'temperatura', 934.0000, 'ºC'),
	(228224, 120, '2014-03-01 01:20:21.000000', 'temperatura', 60.0000, 'ºC'),
	(228225, 120, '2014-03-01 01:20:22.000000', 'temperatura', 1101.0000, 'ºC'),
	(228226, 120, '2014-03-01 01:20:23.000000', 'temperatura', 522.0000, 'ºC'),
	(228227, 120, '2014-03-01 01:20:24.000000', 'temperatura', 511.0000, 'ºC'),
	(228228, 120, '2014-03-01 01:20:25.000000', 'temperatura', 987.0000, 'ºC'),
	(228229, 120, '2014-03-01 01:20:26.000000', 'temperatura', 1003.0000, 'ºC'),
	(228230, 120, '2014-03-01 01:20:27.000000', 'temperatura', 853.0000, 'ºC'),
	(228231, 120, '2014-03-01 01:20:28.000000', 'temperatura', 56.0000, 'ºC'),
	(228232, 120, '2014-03-01 01:20:29.000000', 'temperatura', 122.0000, 'ºC'),
	(228233, 120, '2014-03-01 01:20:30.000000', 'temperatura', 441.0000, 'ºC'),
	(228234, 120, '2014-03-01 01:20:31.000000', 'temperatura', 643.0000, 'ºC'),
	(228235, 120, '2014-03-01 01:20:32.000000', 'temperatura', 689.0000, 'ºC'),
	(228236, 120, '2014-03-01 01:20:33.000000', 'temperatura', 320.0000, 'ºC'),
	(228237, 120, '2014-03-01 01:20:34.000000', 'temperatura', 730.0000, 'ºC'),
	(228238, 120, '2014-03-01 01:20:35.000000', 'temperatura', 293.0000, 'ºC'),
	(228239, 120, '2014-03-01 01:20:36.000000', 'temperatura', 474.0000, 'ºC'),
	(228240, 120, '2014-03-01 01:20:37.000000', 'temperatura', 290.0000, 'ºC'),
	(228241, 120, '2014-03-01 01:20:38.000000', 'temperatura', 32.0000, 'ºC'),
	(228242, 120, '2014-03-01 01:20:39.000000', 'temperatura', 488.0000, 'ºC'),
	(228243, 120, '2014-03-01 01:20:40.000000', 'temperatura', 1143.0000, 'ºC'),
	(228244, 120, '2014-03-01 01:20:41.000000', 'temperatura', 655.0000, 'ºC'),
	(228245, 120, '2014-03-01 01:20:42.000000', 'temperatura', 1046.0000, 'ºC'),
	(228246, 120, '2014-03-01 01:20:43.000000', 'temperatura', 863.0000, 'ºC'),
	(228247, 120, '2014-03-01 01:20:44.000000', 'temperatura', 1180.0000, 'ºC'),
	(228248, 120, '2014-03-01 01:20:45.000000', 'temperatura', 912.0000, 'ºC'),
	(228249, 120, '2014-03-01 01:20:46.000000', 'temperatura', 1021.0000, 'ºC'),
	(228250, 120, '2014-03-01 01:20:47.000000', 'temperatura', 1169.0000, 'ºC'),
	(228251, 120, '2014-03-01 01:20:48.000000', 'temperatura', 381.0000, 'ºC'),
	(228252, 120, '2014-03-01 01:20:49.000000', 'temperatura', 800.0000, 'ºC'),
	(228253, 120, '2014-03-01 01:20:50.000000', 'temperatura', 457.0000, 'ºC'),
	(228254, 120, '2014-03-01 01:20:51.000000', 'temperatura', 1084.0000, 'ºC'),
	(228255, 120, '2014-03-01 01:20:52.000000', 'temperatura', 452.0000, 'ºC'),
	(228256, 120, '2014-03-01 01:20:53.000000', 'temperatura', 206.0000, 'ºC'),
	(228257, 120, '2014-03-01 01:20:54.000000', 'temperatura', 874.0000, 'ºC'),
	(228258, 120, '2014-03-01 01:20:55.000000', 'temperatura', 151.0000, 'ºC'),
	(228259, 120, '2014-03-01 01:20:56.000000', 'temperatura', 537.0000, 'ºC'),
	(228260, 120, '2014-03-01 01:20:57.000000', 'temperatura', 1032.0000, 'ºC'),
	(228261, 120, '2014-03-01 01:20:58.000000', 'temperatura', 1151.0000, 'ºC'),
	(228262, 120, '2014-03-01 01:20:59.000000', 'temperatura', 257.0000, 'ºC'),
	(228263, 120, '2014-03-01 01:21:00.000000', 'temperatura', 235.0000, 'ºC'),
	(228264, 120, '2014-03-01 01:21:01.000000', 'temperatura', 403.0000, 'ºC'),
	(228265, 120, '2014-03-01 01:21:02.000000', 'temperatura', 109.0000, 'ºC'),
	(228266, 120, '2014-03-01 01:21:03.000000', 'temperatura', 538.0000, 'ºC'),
	(228267, 120, '2014-03-01 01:21:04.000000', 'temperatura', 1163.0000, 'ºC'),
	(228268, 120, '2014-03-01 01:21:05.000000', 'temperatura', 601.0000, 'ºC'),
	(228269, 120, '2014-03-01 01:21:06.000000', 'temperatura', 718.0000, 'ºC'),
	(228270, 120, '2014-03-01 01:21:07.000000', 'temperatura', 585.0000, 'ºC'),
	(228271, 120, '2014-03-01 01:21:08.000000', 'temperatura', 772.0000, 'ºC'),
	(228272, 120, '2014-03-01 01:21:09.000000', 'temperatura', 906.0000, 'ºC'),
	(228273, 120, '2014-03-01 01:21:10.000000', 'temperatura', 1013.0000, 'ºC'),
	(228274, 120, '2014-03-01 01:21:11.000000', 'temperatura', 1148.0000, 'ºC'),
	(228275, 120, '2014-03-01 01:21:12.000000', 'temperatura', 300.0000, 'ºC'),
	(228276, 120, '2014-03-01 01:21:13.000000', 'temperatura', 460.0000, 'ºC'),
	(228277, 120, '2014-03-01 01:21:14.000000', 'temperatura', 197.0000, 'ºC'),
	(228278, 120, '2014-03-01 01:21:15.000000', 'temperatura', 808.0000, 'ºC'),
	(228279, 120, '2014-03-01 01:21:16.000000', 'temperatura', 1048.0000, 'ºC'),
	(228280, 120, '2014-03-01 01:21:17.000000', 'temperatura', 416.0000, 'ºC'),
	(228281, 120, '2014-03-01 01:21:18.000000', 'temperatura', 138.0000, 'ºC'),
	(228282, 120, '2014-03-01 01:21:19.000000', 'temperatura', 642.0000, 'ºC'),
	(228283, 120, '2014-03-01 01:21:20.000000', 'temperatura', 394.0000, 'ºC'),
	(228284, 120, '2014-03-01 01:21:21.000000', 'temperatura', 48.0000, 'ºC'),
	(228285, 120, '2014-03-01 01:21:22.000000', 'temperatura', 256.0000, 'ºC'),
	(228286, 120, '2014-03-01 01:21:23.000000', 'temperatura', 1139.0000, 'ºC'),
	(228287, 120, '2014-03-01 01:21:24.000000', 'temperatura', 124.0000, 'ºC'),
	(228288, 120, '2014-03-01 01:21:25.000000', 'temperatura', 807.0000, 'ºC'),
	(228289, 120, '2014-03-01 01:21:26.000000', 'temperatura', 62.0000, 'ºC'),
	(228290, 120, '2014-03-01 01:21:27.000000', 'temperatura', 292.0000, 'ºC'),
	(228291, 120, '2014-03-01 01:21:28.000000', 'temperatura', 71.0000, 'ºC'),
	(228292, 120, '2014-03-01 01:21:29.000000', 'temperatura', 680.0000, 'ºC'),
	(228293, 120, '2014-03-01 01:21:30.000000', 'temperatura', 790.0000, 'ºC'),
	(228294, 120, '2014-03-01 01:21:31.000000', 'temperatura', 710.0000, 'ºC'),
	(228295, 120, '2014-03-01 01:21:32.000000', 'temperatura', 1179.0000, 'ºC'),
	(228296, 120, '2014-03-01 01:21:33.000000', 'temperatura', 167.0000, 'ºC'),
	(228297, 120, '2014-03-01 01:21:34.000000', 'temperatura', 900.0000, 'ºC'),
	(228298, 120, '2014-03-01 01:21:35.000000', 'temperatura', 396.0000, 'ºC'),
	(228299, 120, '2014-03-01 01:21:36.000000', 'temperatura', 484.0000, 'ºC'),
	(228300, 120, '2014-03-01 01:21:37.000000', 'temperatura', 31.0000, 'ºC'),
	(228301, 120, '2014-03-01 01:21:38.000000', 'temperatura', 1102.0000, 'ºC'),
	(228302, 120, '2014-03-01 01:21:39.000000', 'temperatura', 618.0000, 'ºC'),
	(228303, 120, '2014-03-01 01:21:40.000000', 'temperatura', 987.0000, 'ºC'),
	(228304, 120, '2014-03-01 01:21:41.000000', 'temperatura', 678.0000, 'ºC'),
	(228305, 120, '2014-03-01 01:21:42.000000', 'temperatura', 431.0000, 'ºC'),
	(228306, 120, '2014-03-01 01:21:43.000000', 'temperatura', 120.0000, 'ºC'),
	(228307, 120, '2014-03-01 01:21:44.000000', 'temperatura', 510.0000, 'ºC'),
	(228308, 120, '2014-03-01 01:21:45.000000', 'temperatura', 990.0000, 'ºC'),
	(228309, 120, '2014-03-01 01:21:46.000000', 'temperatura', 1019.0000, 'ºC'),
	(228310, 120, '2014-03-01 01:21:47.000000', 'temperatura', 927.0000, 'ºC'),
	(228311, 120, '2014-03-01 01:21:48.000000', 'temperatura', 379.0000, 'ºC'),
	(228312, 120, '2014-03-01 01:21:49.000000', 'temperatura', 316.0000, 'ºC'),
	(228313, 120, '2014-03-01 01:21:50.000000', 'temperatura', 442.0000, 'ºC'),
	(228314, 120, '2014-03-01 01:21:51.000000', 'temperatura', 61.0000, 'ºC'),
	(228315, 120, '2014-03-01 01:21:52.000000', 'temperatura', 180.0000, 'ºC'),
	(228316, 120, '2014-03-01 01:21:53.000000', 'temperatura', 716.0000, 'ºC'),
	(228317, 120, '2014-03-01 01:21:54.000000', 'temperatura', 643.0000, 'ºC'),
	(228318, 120, '2014-03-01 01:21:55.000000', 'temperatura', 1068.0000, 'ºC'),
	(228319, 120, '2014-03-01 01:21:56.000000', 'temperatura', 1009.0000, 'ºC'),
	(228320, 120, '2014-03-01 01:21:57.000000', 'temperatura', 641.0000, 'ºC'),
	(228321, 120, '2014-03-01 01:21:58.000000', 'temperatura', 178.0000, 'ºC'),
	(228322, 120, '2014-03-01 01:21:59.000000', 'temperatura', 168.0000, 'ºC'),
	(228323, 120, '2014-03-01 01:22:00.000000', 'temperatura', 308.0000, 'ºC'),
	(228324, 120, '2014-03-01 01:22:01.000000', 'temperatura', 1037.0000, 'ºC'),
	(228325, 120, '2014-03-01 01:22:02.000000', 'temperatura', 662.0000, 'ºC'),
	(228326, 120, '2014-03-01 01:22:03.000000', 'temperatura', 201.0000, 'ºC'),
	(228327, 120, '2014-03-01 01:22:04.000000', 'temperatura', 216.0000, 'ºC'),
	(228328, 120, '2014-03-01 01:22:05.000000', 'temperatura', 479.0000, 'ºC'),
	(228329, 120, '2014-03-01 01:22:06.000000', 'temperatura', 545.0000, 'ºC'),
	(228330, 120, '2014-03-01 01:22:07.000000', 'temperatura', 91.0000, 'ºC'),
	(228331, 120, '2014-03-01 01:22:08.000000', 'temperatura', 22.0000, 'ºC'),
	(228332, 120, '2014-03-01 01:22:09.000000', 'temperatura', 1036.0000, 'ºC'),
	(228333, 120, '2014-03-01 01:22:10.000000', 'temperatura', 314.0000, 'ºC'),
	(228334, 120, '2014-03-01 01:22:11.000000', 'temperatura', 864.0000, 'ºC'),
	(228335, 120, '2014-03-01 01:22:12.000000', 'temperatura', 980.0000, 'ºC'),
	(228336, 120, '2014-03-01 01:22:13.000000', 'temperatura', 1105.0000, 'ºC'),
	(228337, 120, '2014-03-01 01:22:14.000000', 'temperatura', 188.0000, 'ºC'),
	(228338, 120, '2014-03-01 01:22:15.000000', 'temperatura', 24.0000, 'ºC'),
	(228339, 120, '2014-03-01 01:22:16.000000', 'temperatura', 758.0000, 'ºC'),
	(228340, 120, '2014-03-01 01:22:17.000000', 'temperatura', 119.0000, 'ºC'),
	(228341, 120, '2014-03-01 01:22:18.000000', 'temperatura', 719.0000, 'ºC'),
	(228342, 120, '2014-03-01 01:22:19.000000', 'temperatura', 840.0000, 'ºC'),
	(228343, 120, '2014-03-01 01:22:20.000000', 'temperatura', 842.0000, 'ºC'),
	(228344, 120, '2014-03-01 01:22:21.000000', 'temperatura', 490.0000, 'ºC'),
	(228345, 120, '2014-03-01 01:22:22.000000', 'temperatura', 1124.0000, 'ºC'),
	(228346, 120, '2014-03-01 01:22:23.000000', 'temperatura', 552.0000, 'ºC'),
	(228347, 120, '2014-03-01 01:22:24.000000', 'temperatura', 587.0000, 'ºC'),
	(228348, 120, '2014-03-01 01:22:25.000000', 'temperatura', 78.0000, 'ºC'),
	(228349, 120, '2014-03-01 01:22:26.000000', 'temperatura', 1033.0000, 'ºC'),
	(228350, 120, '2014-03-01 01:22:27.000000', 'temperatura', 131.0000, 'ºC'),
	(228351, 120, '2014-03-01 01:22:28.000000', 'temperatura', 1155.0000, 'ºC'),
	(228352, 120, '2014-03-01 01:22:29.000000', 'temperatura', 583.0000, 'ºC'),
	(228353, 120, '2014-03-01 01:22:30.000000', 'temperatura', 652.0000, 'ºC'),
	(228354, 120, '2014-03-01 01:22:31.000000', 'temperatura', 308.0000, 'ºC'),
	(228355, 120, '2014-03-01 01:22:32.000000', 'temperatura', 788.0000, 'ºC'),
	(228356, 120, '2014-03-01 01:22:33.000000', 'temperatura', 615.0000, 'ºC'),
	(228357, 120, '2014-03-01 01:22:34.000000', 'temperatura', 712.0000, 'ºC'),
	(228358, 120, '2014-03-01 01:22:35.000000', 'temperatura', 515.0000, 'ºC'),
	(228359, 120, '2014-03-01 01:22:36.000000', 'temperatura', 440.0000, 'ºC'),
	(228360, 120, '2014-03-01 01:22:37.000000', 'temperatura', 656.0000, 'ºC'),
	(228361, 120, '2014-03-01 01:22:38.000000', 'temperatura', 760.0000, 'ºC'),
	(228362, 120, '2014-03-01 01:22:39.000000', 'temperatura', 631.0000, 'ºC'),
	(228363, 120, '2014-03-01 01:22:40.000000', 'temperatura', 875.0000, 'ºC'),
	(228364, 120, '2014-03-01 01:22:41.000000', 'temperatura', 83.0000, 'ºC'),
	(228365, 120, '2014-03-01 01:22:42.000000', 'temperatura', 191.0000, 'ºC'),
	(228366, 120, '2014-03-01 01:22:43.000000', 'temperatura', 705.0000, 'ºC'),
	(228367, 120, '2014-03-01 01:22:44.000000', 'temperatura', 555.0000, 'ºC'),
	(228368, 120, '2014-03-01 01:22:45.000000', 'temperatura', 658.0000, 'ºC'),
	(228369, 120, '2014-03-01 01:22:46.000000', 'temperatura', 427.0000, 'ºC'),
	(228370, 120, '2014-03-01 01:22:47.000000', 'temperatura', 161.0000, 'ºC'),
	(228371, 120, '2014-03-01 01:22:48.000000', 'temperatura', 724.0000, 'ºC'),
	(228372, 120, '2014-03-01 01:22:49.000000', 'temperatura', 739.0000, 'ºC'),
	(228373, 120, '2014-03-01 01:22:50.000000', 'temperatura', 322.0000, 'ºC'),
	(228374, 120, '2014-03-01 01:22:51.000000', 'temperatura', 593.0000, 'ºC'),
	(228375, 120, '2014-03-01 01:22:52.000000', 'temperatura', 800.0000, 'ºC'),
	(228376, 120, '2014-03-01 01:22:53.000000', 'temperatura', 1020.0000, 'ºC'),
	(228377, 120, '2014-03-01 01:22:54.000000', 'temperatura', 301.0000, 'ºC'),
	(228378, 120, '2014-03-01 01:22:55.000000', 'temperatura', 847.0000, 'ºC'),
	(228379, 120, '2014-03-01 01:22:56.000000', 'temperatura', 931.0000, 'ºC'),
	(228380, 120, '2014-03-01 01:22:57.000000', 'temperatura', 916.0000, 'ºC'),
	(228381, 120, '2014-03-01 01:22:58.000000', 'temperatura', 588.0000, 'ºC'),
	(228382, 120, '2014-03-01 01:22:59.000000', 'temperatura', 191.0000, 'ºC'),
	(228383, 120, '2014-03-01 01:23:00.000000', 'temperatura', 394.0000, 'ºC'),
	(228384, 120, '2014-03-01 01:23:01.000000', 'temperatura', 196.0000, 'ºC'),
	(228385, 120, '2014-03-01 01:23:02.000000', 'temperatura', 999.0000, 'ºC'),
	(228386, 120, '2014-03-01 01:23:03.000000', 'temperatura', 806.0000, 'ºC'),
	(228387, 120, '2014-03-01 01:23:04.000000', 'temperatura', 1034.0000, 'ºC'),
	(228388, 120, '2014-03-01 01:23:05.000000', 'temperatura', 353.0000, 'ºC'),
	(228389, 120, '2014-03-01 01:23:06.000000', 'temperatura', 1064.0000, 'ºC'),
	(228390, 120, '2014-03-01 01:23:07.000000', 'temperatura', 662.0000, 'ºC'),
	(228391, 120, '2014-03-01 01:23:08.000000', 'temperatura', 116.0000, 'ºC'),
	(228392, 120, '2014-03-01 01:23:09.000000', 'temperatura', 996.0000, 'ºC'),
	(228393, 120, '2014-03-01 01:23:10.000000', 'temperatura', 1034.0000, 'ºC'),
	(228394, 120, '2014-03-01 01:23:11.000000', 'temperatura', 982.0000, 'ºC'),
	(228395, 120, '2014-03-01 01:23:12.000000', 'temperatura', 607.0000, 'ºC'),
	(228396, 120, '2014-03-01 01:23:13.000000', 'temperatura', 92.0000, 'ºC'),
	(228397, 120, '2014-03-01 01:23:14.000000', 'temperatura', 1038.0000, 'ºC'),
	(228398, 120, '2014-03-01 01:23:15.000000', 'temperatura', 116.0000, 'ºC'),
	(228399, 120, '2014-03-01 01:23:16.000000', 'temperatura', 1066.0000, 'ºC'),
	(228400, 120, '2014-03-01 01:23:17.000000', 'temperatura', 181.0000, 'ºC'),
	(228401, 120, '2014-03-01 01:23:18.000000', 'temperatura', 107.0000, 'ºC'),
	(228402, 120, '2014-03-01 01:23:19.000000', 'temperatura', 1192.0000, 'ºC'),
	(228403, 120, '2014-03-01 01:23:20.000000', 'temperatura', 841.0000, 'ºC'),
	(228404, 120, '2014-03-01 01:23:21.000000', 'temperatura', 628.0000, 'ºC'),
	(228405, 120, '2014-03-01 01:23:22.000000', 'temperatura', 616.0000, 'ºC'),
	(228406, 120, '2014-03-01 01:23:23.000000', 'temperatura', 0.0000, 'ºC'),
	(228407, 120, '2014-03-01 01:23:24.000000', 'temperatura', 551.0000, 'ºC'),
	(228408, 120, '2014-03-01 01:23:25.000000', 'temperatura', 354.0000, 'ºC'),
	(228409, 120, '2014-03-01 01:23:26.000000', 'temperatura', 118.0000, 'ºC'),
	(228410, 120, '2014-03-01 01:23:27.000000', 'temperatura', 727.0000, 'ºC'),
	(228411, 120, '2014-03-01 01:23:28.000000', 'temperatura', 885.0000, 'ºC'),
	(228412, 120, '2014-03-01 01:23:29.000000', 'temperatura', 1043.0000, 'ºC'),
	(228413, 120, '2014-03-01 01:23:30.000000', 'temperatura', 159.0000, 'ºC'),
	(228414, 120, '2014-03-01 01:23:31.000000', 'temperatura', 67.0000, 'ºC'),
	(228415, 120, '2014-03-01 01:23:32.000000', 'temperatura', 1058.0000, 'ºC'),
	(228416, 120, '2014-03-01 01:23:33.000000', 'temperatura', 290.0000, 'ºC'),
	(228417, 120, '2014-03-01 01:23:34.000000', 'temperatura', 675.0000, 'ºC'),
	(228418, 120, '2014-03-01 01:23:35.000000', 'temperatura', 107.0000, 'ºC'),
	(228419, 120, '2014-03-01 01:23:36.000000', 'temperatura', 910.0000, 'ºC'),
	(228420, 120, '2014-03-01 01:23:37.000000', 'temperatura', 628.0000, 'ºC'),
	(228421, 120, '2014-03-01 01:23:38.000000', 'temperatura', 413.0000, 'ºC'),
	(228422, 120, '2014-03-01 01:23:39.000000', 'temperatura', 180.0000, 'ºC'),
	(228423, 120, '2014-03-01 01:23:40.000000', 'temperatura', 861.0000, 'ºC'),
	(228424, 120, '2014-03-01 01:23:41.000000', 'temperatura', 168.0000, 'ºC'),
	(228425, 120, '2014-03-01 01:23:42.000000', 'temperatura', 655.0000, 'ºC'),
	(228426, 120, '2014-03-01 01:23:43.000000', 'temperatura', 373.0000, 'ºC'),
	(228427, 120, '2014-03-01 01:23:44.000000', 'temperatura', 1101.0000, 'ºC'),
	(228428, 120, '2014-03-01 01:23:45.000000', 'temperatura', 784.0000, 'ºC'),
	(228429, 120, '2014-03-01 01:23:46.000000', 'temperatura', 620.0000, 'ºC'),
	(228430, 120, '2014-03-01 01:23:47.000000', 'temperatura', 747.0000, 'ºC'),
	(228431, 120, '2014-03-01 01:23:48.000000', 'temperatura', 678.0000, 'ºC'),
	(228432, 120, '2014-03-01 01:23:49.000000', 'temperatura', 1147.0000, 'ºC'),
	(228433, 120, '2014-03-01 01:23:50.000000', 'temperatura', 104.0000, 'ºC'),
	(228434, 120, '2014-03-01 01:23:51.000000', 'temperatura', 679.0000, 'ºC'),
	(228435, 120, '2014-03-01 01:23:52.000000', 'temperatura', 684.0000, 'ºC'),
	(228436, 120, '2014-03-01 01:23:53.000000', 'temperatura', 184.0000, 'ºC'),
	(228437, 120, '2014-03-01 01:23:54.000000', 'temperatura', 67.0000, 'ºC'),
	(228438, 120, '2014-03-01 01:23:55.000000', 'temperatura', 982.0000, 'ºC'),
	(228439, 120, '2014-03-01 01:23:56.000000', 'temperatura', 1110.0000, 'ºC'),
	(228440, 120, '2014-03-01 01:23:57.000000', 'temperatura', 206.0000, 'ºC'),
	(228441, 120, '2014-03-01 01:23:58.000000', 'temperatura', 99.0000, 'ºC'),
	(228442, 120, '2014-03-01 01:23:59.000000', 'temperatura', 1077.0000, 'ºC'),
	(228443, 120, '2014-03-01 01:24:00.000000', 'temperatura', 290.0000, 'ºC'),
	(228444, 120, '2014-03-01 01:24:01.000000', 'temperatura', 618.0000, 'ºC'),
	(228445, 120, '2014-03-01 01:24:02.000000', 'temperatura', 1020.0000, 'ºC'),
	(228446, 120, '2014-03-01 01:24:03.000000', 'temperatura', 846.0000, 'ºC'),
	(228447, 120, '2014-03-01 01:24:04.000000', 'temperatura', 1170.0000, 'ºC'),
	(228448, 120, '2014-03-01 01:24:05.000000', 'temperatura', 912.0000, 'ºC'),
	(228449, 120, '2014-03-01 01:24:06.000000', 'temperatura', 1050.0000, 'ºC'),
	(228450, 120, '2014-03-01 01:24:07.000000', 'temperatura', 116.0000, 'ºC'),
	(228451, 120, '2014-03-01 01:24:08.000000', 'temperatura', 1032.0000, 'ºC'),
	(228452, 120, '2014-03-01 01:24:09.000000', 'temperatura', 10.0000, 'ºC'),
	(228453, 120, '2014-03-01 01:24:10.000000', 'temperatura', 557.0000, 'ºC'),
	(228454, 120, '2014-03-01 01:24:11.000000', 'temperatura', 356.0000, 'ºC'),
	(228455, 120, '2014-03-01 01:24:12.000000', 'temperatura', 107.0000, 'ºC'),
	(228456, 120, '2014-03-01 01:24:13.000000', 'temperatura', 667.0000, 'ºC'),
	(228457, 120, '2014-03-01 01:24:14.000000', 'temperatura', 614.0000, 'ºC'),
	(228458, 120, '2014-03-01 01:24:15.000000', 'temperatura', 1071.0000, 'ºC'),
	(228459, 120, '2014-03-01 01:24:16.000000', 'temperatura', 1115.0000, 'ºC'),
	(228460, 120, '2014-03-01 01:24:17.000000', 'temperatura', 1161.0000, 'ºC'),
	(228461, 120, '2014-03-01 01:24:18.000000', 'temperatura', 59.0000, 'ºC'),
	(228462, 120, '2014-03-01 01:24:19.000000', 'temperatura', 414.0000, 'ºC'),
	(228463, 120, '2014-03-01 01:24:20.000000', 'temperatura', 692.0000, 'ºC'),
	(228464, 120, '2014-03-01 01:24:21.000000', 'temperatura', 1020.0000, 'ºC'),
	(228465, 120, '2014-03-01 01:24:22.000000', 'temperatura', 625.0000, 'ºC'),
	(228466, 120, '2014-03-01 01:24:23.000000', 'temperatura', 64.0000, 'ºC'),
	(228467, 120, '2014-03-01 01:24:24.000000', 'temperatura', 844.0000, 'ºC'),
	(228468, 120, '2014-03-01 01:24:25.000000', 'temperatura', 430.0000, 'ºC'),
	(228469, 120, '2014-03-01 01:24:26.000000', 'temperatura', 818.0000, 'ºC'),
	(228470, 120, '2014-03-01 01:24:27.000000', 'temperatura', 402.0000, 'ºC'),
	(228471, 120, '2014-03-01 01:24:28.000000', 'temperatura', 754.0000, 'ºC'),
	(228472, 120, '2014-03-01 01:24:29.000000', 'temperatura', 166.0000, 'ºC'),
	(228473, 120, '2014-03-01 01:24:30.000000', 'temperatura', 967.0000, 'ºC'),
	(228474, 120, '2014-03-01 01:24:31.000000', 'temperatura', 737.0000, 'ºC'),
	(228475, 120, '2014-03-01 01:24:32.000000', 'temperatura', 786.0000, 'ºC'),
	(228476, 120, '2014-03-01 01:24:33.000000', 'temperatura', 517.0000, 'ºC'),
	(228477, 120, '2014-03-01 01:24:34.000000', 'temperatura', 231.0000, 'ºC'),
	(228478, 120, '2014-03-01 01:24:35.000000', 'temperatura', 802.0000, 'ºC'),
	(228479, 120, '2014-03-01 01:24:36.000000', 'temperatura', 918.0000, 'ºC'),
	(228480, 120, '2014-03-01 01:24:37.000000', 'temperatura', 985.0000, 'ºC'),
	(228481, 120, '2014-03-01 01:24:38.000000', 'temperatura', 972.0000, 'ºC'),
	(228482, 120, '2014-03-01 01:24:39.000000', 'temperatura', 706.0000, 'ºC'),
	(228483, 120, '2014-03-01 01:24:40.000000', 'temperatura', 614.0000, 'ºC'),
	(228484, 120, '2014-03-01 01:24:41.000000', 'temperatura', 950.0000, 'ºC'),
	(228485, 120, '2014-03-01 01:24:42.000000', 'temperatura', 512.0000, 'ºC'),
	(228486, 120, '2014-03-01 01:24:43.000000', 'temperatura', 909.0000, 'ºC'),
	(228487, 120, '2014-03-01 01:24:44.000000', 'temperatura', 609.0000, 'ºC'),
	(228488, 120, '2014-03-01 01:24:45.000000', 'temperatura', 317.0000, 'ºC'),
	(228489, 120, '2014-03-01 01:24:46.000000', 'temperatura', 960.0000, 'ºC'),
	(228490, 120, '2014-03-01 01:24:47.000000', 'temperatura', 250.0000, 'ºC'),
	(228491, 120, '2014-03-01 01:24:48.000000', 'temperatura', 769.0000, 'ºC'),
	(228492, 120, '2014-03-01 01:24:49.000000', 'temperatura', 696.0000, 'ºC'),
	(228493, 120, '2014-03-01 01:24:50.000000', 'temperatura', 1173.0000, 'ºC'),
	(228494, 120, '2014-03-01 01:24:51.000000', 'temperatura', 180.0000, 'ºC'),
	(228495, 120, '2014-03-01 01:24:52.000000', 'temperatura', 979.0000, 'ºC'),
	(228496, 120, '2014-03-01 01:24:53.000000', 'temperatura', 757.0000, 'ºC'),
	(228497, 120, '2014-03-01 01:24:54.000000', 'temperatura', 847.0000, 'ºC'),
	(228498, 120, '2014-03-01 01:24:55.000000', 'temperatura', 767.0000, 'ºC'),
	(228499, 120, '2014-03-01 01:24:56.000000', 'temperatura', 92.0000, 'ºC'),
	(228500, 120, '2014-03-01 01:24:57.000000', 'temperatura', 561.0000, 'ºC'),
	(228501, 120, '2014-03-01 01:24:58.000000', 'temperatura', 130.0000, 'ºC'),
	(228502, 120, '2014-03-01 01:24:59.000000', 'temperatura', 168.0000, 'ºC'),
	(228503, 120, '2014-03-01 01:25:00.000000', 'temperatura', 448.0000, 'ºC'),
	(228504, 120, '2014-03-01 01:25:01.000000', 'temperatura', 540.0000, 'ºC'),
	(228505, 120, '2014-03-01 01:25:02.000000', 'temperatura', 153.0000, 'ºC'),
	(228506, 120, '2014-03-01 01:25:03.000000', 'temperatura', 347.0000, 'ºC'),
	(228507, 120, '2014-03-01 01:25:04.000000', 'temperatura', 76.0000, 'ºC'),
	(228508, 120, '2014-03-01 01:25:05.000000', 'temperatura', 538.0000, 'ºC'),
	(228509, 120, '2014-03-01 01:25:06.000000', 'temperatura', 65.0000, 'ºC'),
	(228510, 120, '2014-03-01 01:25:07.000000', 'temperatura', 1109.0000, 'ºC'),
	(228511, 120, '2014-03-01 01:25:08.000000', 'temperatura', 551.0000, 'ºC'),
	(228512, 120, '2014-03-01 01:25:09.000000', 'temperatura', 631.0000, 'ºC'),
	(228513, 120, '2014-03-01 01:25:10.000000', 'temperatura', 300.0000, 'ºC'),
	(228514, 120, '2014-03-01 01:25:11.000000', 'temperatura', 809.0000, 'ºC'),
	(228515, 120, '2014-03-01 01:25:12.000000', 'temperatura', 745.0000, 'ºC'),
	(228516, 120, '2014-03-01 01:25:13.000000', 'temperatura', 100.0000, 'ºC'),
	(228517, 120, '2014-03-01 01:25:14.000000', 'temperatura', 664.0000, 'ºC'),
	(228518, 120, '2014-03-01 01:25:15.000000', 'temperatura', 619.0000, 'ºC'),
	(228519, 120, '2014-03-01 01:25:16.000000', 'temperatura', 1106.0000, 'ºC'),
	(228520, 120, '2014-03-01 01:25:17.000000', 'temperatura', 73.0000, 'ºC'),
	(228521, 120, '2014-03-01 01:25:18.000000', 'temperatura', 648.0000, 'ºC'),
	(228522, 120, '2014-03-01 01:25:19.000000', 'temperatura', 620.0000, 'ºC'),
	(228523, 120, '2014-03-01 01:25:20.000000', 'temperatura', 1158.0000, 'ºC'),
	(228524, 120, '2014-03-01 01:25:21.000000', 'temperatura', 331.0000, 'ºC'),
	(228525, 120, '2014-03-01 01:25:22.000000', 'temperatura', 581.0000, 'ºC'),
	(228526, 120, '2014-03-01 01:25:23.000000', 'temperatura', 713.0000, 'ºC'),
	(228527, 120, '2014-03-01 01:25:24.000000', 'temperatura', 622.0000, 'ºC'),
	(228528, 120, '2014-03-01 01:25:25.000000', 'temperatura', 972.0000, 'ºC'),
	(228529, 120, '2014-03-01 01:25:26.000000', 'temperatura', 593.0000, 'ºC'),
	(228530, 120, '2014-03-01 01:25:27.000000', 'temperatura', 52.0000, 'ºC'),
	(228531, 120, '2014-03-01 01:25:28.000000', 'temperatura', 879.0000, 'ºC'),
	(228532, 120, '2014-03-01 01:25:29.000000', 'temperatura', 641.0000, 'ºC'),
	(228533, 120, '2014-03-01 01:25:30.000000', 'temperatura', 566.0000, 'ºC'),
	(228534, 120, '2014-03-01 01:25:31.000000', 'temperatura', 910.0000, 'ºC'),
	(228535, 120, '2014-03-01 01:25:32.000000', 'temperatura', 452.0000, 'ºC'),
	(228536, 120, '2014-03-01 01:25:33.000000', 'temperatura', 730.0000, 'ºC'),
	(228537, 120, '2014-03-01 01:25:34.000000', 'temperatura', 1095.0000, 'ºC'),
	(228538, 120, '2014-03-01 01:25:35.000000', 'temperatura', 885.0000, 'ºC'),
	(228539, 120, '2014-03-01 01:25:36.000000', 'temperatura', 1140.0000, 'ºC'),
	(228540, 120, '2014-03-01 01:25:37.000000', 'temperatura', 648.0000, 'ºC'),
	(228541, 120, '2014-03-01 01:25:38.000000', 'temperatura', 1018.0000, 'ºC'),
	(228542, 120, '2014-03-01 01:25:39.000000', 'temperatura', 748.0000, 'ºC'),
	(228543, 120, '2014-03-01 01:25:40.000000', 'temperatura', 686.0000, 'ºC'),
	(228544, 120, '2014-03-01 01:25:41.000000', 'temperatura', 1188.0000, 'ºC'),
	(228545, 120, '2014-03-01 01:25:42.000000', 'temperatura', 279.0000, 'ºC'),
	(228546, 120, '2014-03-01 01:25:43.000000', 'temperatura', 235.0000, 'ºC'),
	(228547, 120, '2014-03-01 01:25:44.000000', 'temperatura', 336.0000, 'ºC'),
	(228548, 120, '2014-03-01 01:25:45.000000', 'temperatura', 975.0000, 'ºC'),
	(228549, 120, '2014-03-01 01:25:46.000000', 'temperatura', 269.0000, 'ºC'),
	(228550, 120, '2014-03-01 01:25:47.000000', 'temperatura', 822.0000, 'ºC'),
	(228551, 120, '2014-03-01 01:25:48.000000', 'temperatura', 901.0000, 'ºC'),
	(228552, 120, '2014-03-01 01:25:49.000000', 'temperatura', 840.0000, 'ºC'),
	(228553, 120, '2014-03-01 01:25:50.000000', 'temperatura', 300.0000, 'ºC'),
	(228554, 120, '2014-03-01 01:25:51.000000', 'temperatura', 177.0000, 'ºC'),
	(228555, 120, '2014-03-01 01:25:52.000000', 'temperatura', 1186.0000, 'ºC'),
	(228556, 120, '2014-03-01 01:25:53.000000', 'temperatura', 602.0000, 'ºC'),
	(228557, 120, '2014-03-01 01:25:54.000000', 'temperatura', 650.0000, 'ºC'),
	(228558, 120, '2014-03-01 01:25:55.000000', 'temperatura', 245.0000, 'ºC'),
	(228559, 120, '2014-03-01 01:25:56.000000', 'temperatura', 475.0000, 'ºC'),
	(228560, 120, '2014-03-01 01:25:57.000000', 'temperatura', 440.0000, 'ºC'),
	(228561, 120, '2014-03-01 01:25:58.000000', 'temperatura', 777.0000, 'ºC'),
	(228562, 120, '2014-03-01 01:25:59.000000', 'temperatura', 164.0000, 'ºC'),
	(228563, 120, '2014-03-01 01:26:00.000000', 'temperatura', 890.0000, 'ºC'),
	(228564, 120, '2014-03-01 01:26:01.000000', 'temperatura', 358.0000, 'ºC'),
	(228565, 120, '2014-03-01 01:26:02.000000', 'temperatura', 320.0000, 'ºC'),
	(228566, 120, '2014-03-01 01:26:03.000000', 'temperatura', 527.0000, 'ºC'),
	(228567, 120, '2014-03-01 01:26:04.000000', 'temperatura', 477.0000, 'ºC'),
	(228568, 120, '2014-03-01 01:26:05.000000', 'temperatura', 804.0000, 'ºC'),
	(228569, 120, '2014-03-01 01:26:06.000000', 'temperatura', 191.0000, 'ºC'),
	(228570, 120, '2014-03-01 01:26:07.000000', 'temperatura', 942.0000, 'ºC'),
	(228571, 120, '2014-03-01 01:26:08.000000', 'temperatura', 538.0000, 'ºC'),
	(228572, 120, '2014-03-01 01:26:09.000000', 'temperatura', 1066.0000, 'ºC'),
	(228573, 120, '2014-03-01 01:26:10.000000', 'temperatura', 116.0000, 'ºC'),
	(228574, 120, '2014-03-01 01:26:11.000000', 'temperatura', 981.0000, 'ºC'),
	(228575, 120, '2014-03-01 01:26:12.000000', 'temperatura', 960.0000, 'ºC'),
	(228576, 120, '2014-03-01 01:26:13.000000', 'temperatura', 657.0000, 'ºC'),
	(228577, 120, '2014-03-01 01:26:14.000000', 'temperatura', 403.0000, 'ºC'),
	(228578, 120, '2014-03-01 01:26:15.000000', 'temperatura', 46.0000, 'ºC'),
	(228579, 120, '2014-03-01 01:26:16.000000', 'temperatura', 222.0000, 'ºC'),
	(228580, 120, '2014-03-01 01:26:17.000000', 'temperatura', 970.0000, 'ºC'),
	(228581, 120, '2014-03-01 01:26:18.000000', 'temperatura', 586.0000, 'ºC'),
	(228582, 120, '2014-03-01 01:26:19.000000', 'temperatura', 22.0000, 'ºC'),
	(228583, 120, '2014-03-01 01:26:20.000000', 'temperatura', 751.0000, 'ºC'),
	(228584, 120, '2014-03-01 01:26:21.000000', 'temperatura', 91.0000, 'ºC'),
	(228585, 120, '2014-03-01 01:26:22.000000', 'temperatura', 603.0000, 'ºC'),
	(228586, 120, '2014-03-01 01:26:23.000000', 'temperatura', 341.0000, 'ºC'),
	(228587, 120, '2014-03-01 01:26:24.000000', 'temperatura', 1095.0000, 'ºC'),
	(228588, 120, '2014-03-01 01:26:25.000000', 'temperatura', 853.0000, 'ºC'),
	(228589, 120, '2014-03-01 01:26:26.000000', 'temperatura', 983.0000, 'ºC'),
	(228590, 120, '2014-03-01 01:26:27.000000', 'temperatura', 1156.0000, 'ºC'),
	(228591, 120, '2014-03-01 01:26:28.000000', 'temperatura', 429.0000, 'ºC'),
	(228592, 120, '2014-03-01 01:26:29.000000', 'temperatura', 1081.0000, 'ºC'),
	(228593, 120, '2014-03-01 01:26:30.000000', 'temperatura', 515.0000, 'ºC'),
	(228594, 120, '2014-03-01 01:26:31.000000', 'temperatura', 535.0000, 'ºC'),
	(228595, 120, '2014-03-01 01:26:32.000000', 'temperatura', 1128.0000, 'ºC'),
	(228596, 120, '2014-03-01 01:26:33.000000', 'temperatura', 436.0000, 'ºC'),
	(228597, 120, '2014-03-01 01:26:34.000000', 'temperatura', 1199.0000, 'ºC'),
	(228598, 120, '2014-03-01 01:26:35.000000', 'temperatura', 1084.0000, 'ºC'),
	(228599, 120, '2014-03-01 01:26:36.000000', 'temperatura', 627.0000, 'ºC'),
	(228600, 120, '2014-03-01 01:26:37.000000', 'temperatura', 1080.0000, 'ºC'),
	(228601, 120, '2014-03-01 01:26:38.000000', 'temperatura', 1122.0000, 'ºC'),
	(228602, 120, '2014-03-01 01:26:39.000000', 'temperatura', 1169.0000, 'ºC'),
	(228603, 120, '2014-03-01 01:26:40.000000', 'temperatura', 82.0000, 'ºC'),
	(228604, 120, '2014-03-01 01:26:41.000000', 'temperatura', 502.0000, 'ºC'),
	(228605, 120, '2014-03-01 01:26:42.000000', 'temperatura', 1065.0000, 'ºC'),
	(228606, 120, '2014-03-01 01:26:43.000000', 'temperatura', 218.0000, 'ºC'),
	(228607, 120, '2014-03-01 01:26:44.000000', 'temperatura', 295.0000, 'ºC'),
	(228608, 120, '2014-03-01 01:26:45.000000', 'temperatura', 822.0000, 'ºC'),
	(228609, 120, '2014-03-01 01:26:46.000000', 'temperatura', 825.0000, 'ºC'),
	(228610, 120, '2014-03-01 01:26:47.000000', 'temperatura', 462.0000, 'ºC'),
	(228611, 120, '2014-03-01 01:26:48.000000', 'temperatura', 1033.0000, 'ºC'),
	(228612, 120, '2014-03-01 01:26:49.000000', 'temperatura', 180.0000, 'ºC'),
	(228613, 120, '2014-03-01 01:26:50.000000', 'temperatura', 204.0000, 'ºC'),
	(228614, 120, '2014-03-01 01:26:51.000000', 'temperatura', 477.0000, 'ºC'),
	(228615, 120, '2014-03-01 01:26:52.000000', 'temperatura', 575.0000, 'ºC'),
	(228616, 120, '2014-03-01 01:26:53.000000', 'temperatura', 246.0000, 'ºC'),
	(228617, 120, '2014-03-01 01:26:54.000000', 'temperatura', 703.0000, 'ºC'),
	(228618, 120, '2014-03-01 01:26:55.000000', 'temperatura', 379.0000, 'ºC'),
	(228619, 120, '2014-03-01 01:26:56.000000', 'temperatura', 984.0000, 'ºC'),
	(228620, 120, '2014-03-01 01:26:57.000000', 'temperatura', 186.0000, 'ºC'),
	(228621, 120, '2014-03-01 01:26:58.000000', 'temperatura', 378.0000, 'ºC'),
	(228622, 120, '2014-03-01 01:26:59.000000', 'temperatura', 131.0000, 'ºC'),
	(228623, 120, '2014-03-01 01:27:00.000000', 'temperatura', 721.0000, 'ºC'),
	(228624, 120, '2014-03-01 01:27:01.000000', 'temperatura', 816.0000, 'ºC'),
	(228625, 120, '2014-03-01 01:27:02.000000', 'temperatura', 714.0000, 'ºC'),
	(228626, 120, '2014-03-01 01:27:03.000000', 'temperatura', 1123.0000, 'ºC'),
	(228627, 120, '2014-03-01 01:27:04.000000', 'temperatura', 1075.0000, 'ºC'),
	(228628, 120, '2014-03-01 01:27:05.000000', 'temperatura', 808.0000, 'ºC'),
	(228629, 120, '2014-03-01 01:27:06.000000', 'temperatura', 812.0000, 'ºC'),
	(228630, 120, '2014-03-01 01:27:07.000000', 'temperatura', 438.0000, 'ºC'),
	(228631, 120, '2014-03-01 01:27:08.000000', 'temperatura', 953.0000, 'ºC'),
	(228632, 120, '2014-03-01 01:27:09.000000', 'temperatura', 1054.0000, 'ºC'),
	(228633, 120, '2014-03-01 01:27:10.000000', 'temperatura', 12.0000, 'ºC'),
	(228634, 120, '2014-03-01 01:27:11.000000', 'temperatura', 498.0000, 'ºC'),
	(228635, 120, '2014-03-01 01:27:12.000000', 'temperatura', 53.0000, 'ºC'),
	(228636, 120, '2014-03-01 01:27:13.000000', 'temperatura', 1172.0000, 'ºC'),
	(228637, 120, '2014-03-01 01:27:14.000000', 'temperatura', 900.0000, 'ºC'),
	(228638, 120, '2014-03-01 01:27:15.000000', 'temperatura', 984.0000, 'ºC'),
	(228639, 120, '2014-03-01 01:27:16.000000', 'temperatura', 1024.0000, 'ºC'),
	(228640, 120, '2014-03-01 01:27:17.000000', 'temperatura', 966.0000, 'ºC'),
	(228641, 120, '2014-03-01 01:27:18.000000', 'temperatura', 559.0000, 'ºC'),
	(228642, 120, '2014-03-01 01:27:19.000000', 'temperatura', 1097.0000, 'ºC'),
	(228643, 120, '2014-03-01 01:27:20.000000', 'temperatura', 209.0000, 'ºC'),
	(228644, 120, '2014-03-01 01:27:21.000000', 'temperatura', 154.0000, 'ºC'),
	(228645, 120, '2014-03-01 01:27:22.000000', 'temperatura', 145.0000, 'ºC'),
	(228646, 120, '2014-03-01 01:27:23.000000', 'temperatura', 261.0000, 'ºC'),
	(228647, 120, '2014-03-01 01:27:24.000000', 'temperatura', 873.0000, 'ºC'),
	(228648, 120, '2014-03-01 01:27:25.000000', 'temperatura', 1184.0000, 'ºC'),
	(228649, 120, '2014-03-01 01:27:26.000000', 'temperatura', 898.0000, 'ºC'),
	(228650, 120, '2014-03-01 01:27:27.000000', 'temperatura', 941.0000, 'ºC'),
	(228651, 120, '2014-03-01 01:27:28.000000', 'temperatura', 809.0000, 'ºC'),
	(228652, 120, '2014-03-01 01:27:29.000000', 'temperatura', 25.0000, 'ºC'),
	(228653, 120, '2014-03-01 01:27:30.000000', 'temperatura', 97.0000, 'ºC'),
	(228654, 120, '2014-03-01 01:27:31.000000', 'temperatura', 411.0000, 'ºC'),
	(228655, 120, '2014-03-01 01:27:32.000000', 'temperatura', 566.0000, 'ºC'),
	(228656, 120, '2014-03-01 01:27:33.000000', 'temperatura', 398.0000, 'ºC'),
	(228657, 120, '2014-03-01 01:27:34.000000', 'temperatura', 290.0000, 'ºC'),
	(228658, 120, '2014-03-01 01:27:35.000000', 'temperatura', 256.0000, 'ºC'),
	(228659, 120, '2014-03-01 01:27:36.000000', 'temperatura', 412.0000, 'ºC'),
	(228660, 120, '2014-03-01 01:27:37.000000', 'temperatura', 91.0000, 'ºC'),
	(228661, 120, '2014-03-01 01:27:38.000000', 'temperatura', 420.0000, 'ºC'),
	(228662, 120, '2014-03-01 01:27:39.000000', 'temperatura', 627.0000, 'ºC'),
	(228663, 120, '2014-03-01 01:27:40.000000', 'temperatura', 676.0000, 'ºC'),
	(228664, 120, '2014-03-01 01:27:41.000000', 'temperatura', 301.0000, 'ºC'),
	(228665, 120, '2014-03-01 01:27:42.000000', 'temperatura', 676.0000, 'ºC'),
	(228666, 120, '2014-03-01 01:27:43.000000', 'temperatura', 76.0000, 'ºC'),
	(228667, 120, '2014-03-01 01:27:44.000000', 'temperatura', 756.0000, 'ºC'),
	(228668, 120, '2014-03-01 01:27:45.000000', 'temperatura', 1149.0000, 'ºC'),
	(228669, 120, '2014-03-01 01:27:46.000000', 'temperatura', 1078.0000, 'ºC'),
	(228670, 120, '2014-03-01 01:27:47.000000', 'temperatura', 744.0000, 'ºC'),
	(228671, 120, '2014-03-01 01:27:48.000000', 'temperatura', 486.0000, 'ºC'),
	(228672, 120, '2014-03-01 01:27:49.000000', 'temperatura', 201.0000, 'ºC'),
	(228673, 120, '2014-03-01 01:27:50.000000', 'temperatura', 744.0000, 'ºC'),
	(228674, 120, '2014-03-01 01:27:51.000000', 'temperatura', 720.0000, 'ºC'),
	(228675, 120, '2014-03-01 01:27:52.000000', 'temperatura', 168.0000, 'ºC'),
	(228676, 120, '2014-03-01 01:27:53.000000', 'temperatura', 1082.0000, 'ºC'),
	(228677, 120, '2014-03-01 01:27:54.000000', 'temperatura', 107.0000, 'ºC'),
	(228678, 120, '2014-03-01 01:27:55.000000', 'temperatura', 890.0000, 'ºC'),
	(228679, 120, '2014-03-01 01:27:56.000000', 'temperatura', 527.0000, 'ºC'),
	(228680, 120, '2014-03-01 01:27:57.000000', 'temperatura', 1168.0000, 'ºC'),
	(228681, 120, '2014-03-01 01:27:58.000000', 'temperatura', 657.0000, 'ºC'),
	(228682, 120, '2014-03-01 01:27:59.000000', 'temperatura', 984.0000, 'ºC'),
	(228683, 120, '2014-03-01 01:28:00.000000', 'temperatura', 551.0000, 'ºC'),
	(228684, 120, '2014-03-01 01:28:01.000000', 'temperatura', 1000.0000, 'ºC'),
	(228685, 120, '2014-03-01 01:28:02.000000', 'temperatura', 948.0000, 'ºC'),
	(228686, 120, '2014-03-01 01:28:03.000000', 'temperatura', 543.0000, 'ºC'),
	(228687, 120, '2014-03-01 01:28:04.000000', 'temperatura', 1068.0000, 'ºC'),
	(228688, 120, '2014-03-01 01:28:05.000000', 'temperatura', 114.0000, 'ºC'),
	(228689, 120, '2014-03-01 01:28:06.000000', 'temperatura', 965.0000, 'ºC'),
	(228690, 120, '2014-03-01 01:28:07.000000', 'temperatura', 885.0000, 'ºC'),
	(228691, 120, '2014-03-01 01:28:08.000000', 'temperatura', 329.0000, 'ºC'),
	(228692, 120, '2014-03-01 01:28:09.000000', 'temperatura', 192.0000, 'ºC'),
	(228693, 120, '2014-03-01 01:28:10.000000', 'temperatura', 1175.0000, 'ºC'),
	(228694, 120, '2014-03-01 01:28:11.000000', 'temperatura', 498.0000, 'ºC'),
	(228695, 120, '2014-03-01 01:28:12.000000', 'temperatura', 163.0000, 'ºC'),
	(228696, 120, '2014-03-01 01:28:13.000000', 'temperatura', 525.0000, 'ºC'),
	(228697, 120, '2014-03-01 01:28:14.000000', 'temperatura', 936.0000, 'ºC'),
	(228698, 120, '2014-03-01 01:28:15.000000', 'temperatura', 704.0000, 'ºC'),
	(228699, 120, '2014-03-01 01:28:16.000000', 'temperatura', 711.0000, 'ºC'),
	(228700, 120, '2014-03-01 01:28:17.000000', 'temperatura', 246.0000, 'ºC'),
	(228701, 120, '2014-03-01 01:28:18.000000', 'temperatura', 297.0000, 'ºC'),
	(228702, 120, '2014-03-01 01:28:19.000000', 'temperatura', 746.0000, 'ºC'),
	(228703, 120, '2014-03-01 01:28:20.000000', 'temperatura', 440.0000, 'ºC'),
	(228704, 120, '2014-03-01 01:28:21.000000', 'temperatura', 1162.0000, 'ºC'),
	(228705, 120, '2014-03-01 01:28:22.000000', 'temperatura', 890.0000, 'ºC'),
	(228706, 120, '2014-03-01 01:28:23.000000', 'temperatura', 965.0000, 'ºC'),
	(228707, 120, '2014-03-01 01:28:24.000000', 'temperatura', 956.0000, 'ºC'),
	(228708, 120, '2014-03-01 01:28:25.000000', 'temperatura', 686.0000, 'ºC'),
	(228709, 120, '2014-03-01 01:28:26.000000', 'temperatura', 560.0000, 'ºC'),
	(228710, 120, '2014-03-01 01:28:27.000000', 'temperatura', 744.0000, 'ºC'),
	(228711, 120, '2014-03-01 01:28:28.000000', 'temperatura', 840.0000, 'ºC'),
	(228712, 120, '2014-03-01 01:28:29.000000', 'temperatura', 768.0000, 'ºC'),
	(228713, 120, '2014-03-01 01:28:30.000000', 'temperatura', 122.0000, 'ºC'),
	(228714, 120, '2014-03-01 01:28:31.000000', 'temperatura', 705.0000, 'ºC'),
	(228715, 120, '2014-03-01 01:28:32.000000', 'temperatura', 760.0000, 'ºC'),
	(228716, 120, '2014-03-01 01:28:33.000000', 'temperatura', 485.0000, 'ºC'),
	(228717, 120, '2014-03-01 01:28:34.000000', 'temperatura', 146.0000, 'ºC'),
	(228718, 120, '2014-03-01 01:28:35.000000', 'temperatura', 475.0000, 'ºC'),
	(228719, 120, '2014-03-01 01:28:36.000000', 'temperatura', 737.0000, 'ºC'),
	(228720, 120, '2014-03-01 01:28:37.000000', 'temperatura', 1060.0000, 'ºC'),
	(228721, 120, '2014-03-01 01:28:38.000000', 'temperatura', 692.0000, 'ºC'),
	(228722, 120, '2014-03-01 01:28:39.000000', 'temperatura', 279.0000, 'ºC'),
	(228723, 120, '2014-03-01 01:28:40.000000', 'temperatura', 520.0000, 'ºC'),
	(228724, 120, '2014-03-01 01:28:41.000000', 'temperatura', 564.0000, 'ºC'),
	(228725, 120, '2014-03-01 01:28:42.000000', 'temperatura', 62.0000, 'ºC'),
	(228726, 120, '2014-03-01 01:28:43.000000', 'temperatura', 1015.0000, 'ºC'),
	(228727, 120, '2014-03-01 01:28:44.000000', 'temperatura', 91.0000, 'ºC'),
	(228728, 120, '2014-03-01 01:28:45.000000', 'temperatura', 1012.0000, 'ºC'),
	(228729, 120, '2014-03-01 01:28:46.000000', 'temperatura', 1185.0000, 'ºC'),
	(228730, 120, '2014-03-01 01:28:47.000000', 'temperatura', 489.0000, 'ºC'),
	(228731, 120, '2014-03-01 01:28:48.000000', 'temperatura', 90.0000, 'ºC'),
	(228732, 120, '2014-03-01 01:28:49.000000', 'temperatura', 184.0000, 'ºC'),
	(228733, 120, '2014-03-01 01:28:50.000000', 'temperatura', 653.0000, 'ºC'),
	(228734, 120, '2014-03-01 01:28:51.000000', 'temperatura', 312.0000, 'ºC'),
	(228735, 120, '2014-03-01 01:28:52.000000', 'temperatura', 800.0000, 'ºC'),
	(228736, 120, '2014-03-01 01:28:53.000000', 'temperatura', 668.0000, 'ºC'),
	(228737, 120, '2014-03-01 01:28:54.000000', 'temperatura', 938.0000, 'ºC'),
	(228738, 120, '2014-03-01 01:28:55.000000', 'temperatura', 285.0000, 'ºC'),
	(228739, 120, '2014-03-01 01:28:56.000000', 'temperatura', 1014.0000, 'ºC'),
	(228740, 120, '2014-03-01 01:28:57.000000', 'temperatura', 613.0000, 'ºC'),
	(228741, 120, '2014-03-01 01:28:58.000000', 'temperatura', 26.0000, 'ºC'),
	(228742, 120, '2014-03-01 01:28:59.000000', 'temperatura', 692.0000, 'ºC'),
	(228743, 120, '2014-03-01 01:29:00.000000', 'temperatura', 984.0000, 'ºC'),
	(228744, 120, '2014-03-01 01:29:01.000000', 'temperatura', 441.0000, 'ºC'),
	(228745, 120, '2014-03-01 01:29:02.000000', 'temperatura', 455.0000, 'ºC'),
	(228746, 120, '2014-03-01 01:29:03.000000', 'temperatura', 954.0000, 'ºC'),
	(228747, 120, '2014-03-01 01:29:04.000000', 'temperatura', 1006.0000, 'ºC'),
	(228748, 120, '2014-03-01 01:29:05.000000', 'temperatura', 968.0000, 'ºC'),
	(228749, 120, '2014-03-01 01:29:06.000000', 'temperatura', 621.0000, 'ºC'),
	(228750, 120, '2014-03-01 01:29:07.000000', 'temperatura', 203.0000, 'ºC'),
	(228751, 120, '2014-03-01 01:29:08.000000', 'temperatura', 351.0000, 'ºC'),
	(228752, 120, '2014-03-01 01:29:09.000000', 'temperatura', 1147.0000, 'ºC'),
	(228753, 120, '2014-03-01 01:29:10.000000', 'temperatura', 1082.0000, 'ºC'),
	(228754, 120, '2014-03-01 01:29:11.000000', 'temperatura', 769.0000, 'ºC'),
	(228755, 120, '2014-03-01 01:29:12.000000', 'temperatura', 599.0000, 'ºC'),
	(228756, 120, '2014-03-01 01:29:13.000000', 'temperatura', 689.0000, 'ºC'),
	(228757, 120, '2014-03-01 01:29:14.000000', 'temperatura', 447.0000, 'ºC'),
	(228758, 120, '2014-03-01 01:29:15.000000', 'temperatura', 170.0000, 'ºC'),
	(228759, 120, '2014-03-01 01:29:16.000000', 'temperatura', 709.0000, 'ºC'),
	(228760, 120, '2014-03-01 01:29:17.000000', 'temperatura', 636.0000, 'ºC'),
	(228761, 120, '2014-03-01 01:29:18.000000', 'temperatura', 1052.0000, 'ºC'),
	(228762, 120, '2014-03-01 01:29:19.000000', 'temperatura', 953.0000, 'ºC'),
	(228763, 120, '2014-03-01 01:29:20.000000', 'temperatura', 408.0000, 'ºC'),
	(228764, 120, '2014-03-01 01:29:21.000000', 'temperatura', 382.0000, 'ºC'),
	(228765, 120, '2014-03-01 01:29:22.000000', 'temperatura', 686.0000, 'ºC'),
	(228766, 120, '2014-03-01 01:29:23.000000', 'temperatura', 1084.0000, 'ºC'),
	(228767, 120, '2014-03-01 01:29:24.000000', 'temperatura', 962.0000, 'ºC'),
	(228768, 120, '2014-03-01 01:29:25.000000', 'temperatura', 358.0000, 'ºC'),
	(228769, 120, '2014-03-01 01:29:26.000000', 'temperatura', 105.0000, 'ºC'),
	(228770, 120, '2014-03-01 01:29:27.000000', 'temperatura', 650.0000, 'ºC'),
	(228771, 120, '2014-03-01 01:29:28.000000', 'temperatura', 536.0000, 'ºC'),
	(228772, 120, '2014-03-01 01:29:29.000000', 'temperatura', 731.0000, 'ºC'),
	(228773, 120, '2014-03-01 01:29:30.000000', 'temperatura', 846.0000, 'ºC'),
	(228774, 120, '2014-03-01 01:29:31.000000', 'temperatura', 840.0000, 'ºC'),
	(228775, 120, '2014-03-01 01:29:32.000000', 'temperatura', 464.0000, 'ºC'),
	(228776, 120, '2014-03-01 01:29:33.000000', 'temperatura', 997.0000, 'ºC'),
	(228777, 120, '2014-03-01 01:29:34.000000', 'temperatura', 1193.0000, 'ºC'),
	(228778, 120, '2014-03-01 01:29:35.000000', 'temperatura', 576.0000, 'ºC'),
	(228779, 120, '2014-03-01 01:29:36.000000', 'temperatura', 503.0000, 'ºC'),
	(228780, 120, '2014-03-01 01:29:37.000000', 'temperatura', 786.0000, 'ºC'),
	(228781, 120, '2014-03-01 01:29:38.000000', 'temperatura', 20.0000, 'ºC'),
	(228782, 120, '2014-03-01 01:29:39.000000', 'temperatura', 145.0000, 'ºC'),
	(228783, 120, '2014-03-01 01:29:40.000000', 'temperatura', 665.0000, 'ºC'),
	(228784, 120, '2014-03-01 01:29:41.000000', 'temperatura', 490.0000, 'ºC'),
	(228785, 120, '2014-03-01 01:29:42.000000', 'temperatura', 455.0000, 'ºC'),
	(228786, 120, '2014-03-01 01:29:43.000000', 'temperatura', 805.0000, 'ºC'),
	(228787, 120, '2014-03-01 01:29:44.000000', 'temperatura', 260.0000, 'ºC'),
	(228788, 120, '2014-03-01 01:29:45.000000', 'temperatura', 88.0000, 'ºC'),
	(228789, 120, '2014-03-01 01:29:46.000000', 'temperatura', 859.0000, 'ºC'),
	(228790, 120, '2014-03-01 01:29:47.000000', 'temperatura', 431.0000, 'ºC'),
	(228791, 120, '2014-03-01 01:29:48.000000', 'temperatura', 780.0000, 'ºC'),
	(228792, 120, '2014-03-01 01:29:49.000000', 'temperatura', 209.0000, 'ºC'),
	(228793, 120, '2014-03-01 01:29:50.000000', 'temperatura', 1102.0000, 'ºC'),
	(228794, 120, '2014-03-01 01:29:51.000000', 'temperatura', 84.0000, 'ºC'),
	(228795, 120, '2014-03-01 01:29:52.000000', 'temperatura', 717.0000, 'ºC'),
	(228796, 120, '2014-03-01 01:29:53.000000', 'temperatura', 932.0000, 'ºC'),
	(228797, 120, '2014-03-01 01:29:54.000000', 'temperatura', 111.0000, 'ºC'),
	(228798, 120, '2014-03-01 01:29:55.000000', 'temperatura', 159.0000, 'ºC'),
	(228799, 120, '2014-03-01 01:29:56.000000', 'temperatura', 464.0000, 'ºC'),
	(228800, 120, '2014-03-01 01:29:57.000000', 'temperatura', 642.0000, 'ºC'),
	(228801, 120, '2014-03-01 01:29:58.000000', 'temperatura', 617.0000, 'ºC'),
	(228802, 120, '2014-03-01 01:29:59.000000', 'temperatura', 1161.0000, 'ºC'),
	(228803, 120, '2014-03-01 01:30:00.000000', 'temperatura', 354.0000, 'ºC'),
	(228804, 120, '2014-03-01 01:30:01.000000', 'temperatura', 686.0000, 'ºC'),
	(228805, 120, '2014-03-01 01:30:02.000000', 'temperatura', 1168.0000, 'ºC'),
	(228806, 120, '2014-03-01 01:30:03.000000', 'temperatura', 184.0000, 'ºC'),
	(228807, 120, '2014-03-01 01:30:04.000000', 'temperatura', 1017.0000, 'ºC'),
	(228808, 120, '2014-03-01 01:30:05.000000', 'temperatura', 931.0000, 'ºC'),
	(228809, 120, '2014-03-01 01:30:06.000000', 'temperatura', 406.0000, 'ºC'),
	(228810, 120, '2014-03-01 01:30:07.000000', 'temperatura', 439.0000, 'ºC'),
	(228811, 120, '2014-03-01 01:30:08.000000', 'temperatura', 976.0000, 'ºC'),
	(228812, 120, '2014-03-01 01:30:09.000000', 'temperatura', 1166.0000, 'ºC'),
	(228813, 120, '2014-03-01 01:30:10.000000', 'temperatura', 500.0000, 'ºC'),
	(228814, 120, '2014-03-01 01:30:11.000000', 'temperatura', 205.0000, 'ºC'),
	(228815, 120, '2014-03-01 01:30:12.000000', 'temperatura', 723.0000, 'ºC'),
	(228816, 120, '2014-03-01 01:30:13.000000', 'temperatura', 602.0000, 'ºC'),
	(228817, 120, '2014-03-01 01:30:14.000000', 'temperatura', 839.0000, 'ºC'),
	(228818, 120, '2014-03-01 01:30:15.000000', 'temperatura', 1192.0000, 'ºC'),
	(228819, 120, '2014-03-01 01:30:16.000000', 'temperatura', 1044.0000, 'ºC'),
	(228820, 120, '2014-03-01 01:30:17.000000', 'temperatura', 442.0000, 'ºC'),
	(228821, 120, '2014-03-01 01:30:18.000000', 'temperatura', 281.0000, 'ºC'),
	(228822, 120, '2014-03-01 01:30:19.000000', 'temperatura', 80.0000, 'ºC'),
	(228823, 120, '2014-03-01 01:30:20.000000', 'temperatura', 757.0000, 'ºC'),
	(228824, 120, '2014-03-01 01:30:21.000000', 'temperatura', 1146.0000, 'ºC'),
	(228825, 120, '2014-03-01 01:30:22.000000', 'temperatura', 1060.0000, 'ºC'),
	(228826, 120, '2014-03-01 01:30:23.000000', 'temperatura', 660.0000, 'ºC'),
	(228827, 120, '2014-03-01 01:30:24.000000', 'temperatura', 123.0000, 'ºC'),
	(228828, 120, '2014-03-01 01:30:25.000000', 'temperatura', 1036.0000, 'ºC'),
	(228829, 120, '2014-03-01 01:30:26.000000', 'temperatura', 12.0000, 'ºC'),
	(228830, 120, '2014-03-01 01:30:27.000000', 'temperatura', 550.0000, 'ºC'),
	(228831, 120, '2014-03-01 01:30:28.000000', 'temperatura', 313.0000, 'ºC'),
	(228832, 120, '2014-03-01 01:30:29.000000', 'temperatura', 1119.0000, 'ºC'),
	(228833, 120, '2014-03-01 01:30:30.000000', 'temperatura', 1057.0000, 'ºC'),
	(228834, 120, '2014-03-01 01:30:31.000000', 'temperatura', 727.0000, 'ºC'),
	(228835, 120, '2014-03-01 01:30:32.000000', 'temperatura', 464.0000, 'ºC'),
	(228836, 120, '2014-03-01 01:30:33.000000', 'temperatura', 139.0000, 'ºC'),
	(228837, 120, '2014-03-01 01:30:34.000000', 'temperatura', 506.0000, 'ºC'),
	(228838, 120, '2014-03-01 01:30:35.000000', 'temperatura', 912.0000, 'ºC'),
	(228839, 120, '2014-03-01 01:30:36.000000', 'temperatura', 644.0000, 'ºC'),
	(228840, 120, '2014-03-01 01:30:37.000000', 'temperatura', 484.0000, 'ºC'),
	(228841, 120, '2014-03-01 01:30:38.000000', 'temperatura', 490.0000, 'ºC'),
	(228842, 120, '2014-03-01 01:30:39.000000', 'temperatura', 996.0000, 'ºC'),
	(228843, 120, '2014-03-01 01:30:40.000000', 'temperatura', 1113.0000, 'ºC'),
	(228844, 120, '2014-03-01 01:30:41.000000', 'temperatura', 176.0000, 'ºC'),
	(228845, 120, '2014-03-01 01:30:42.000000', 'temperatura', 1144.0000, 'ºC'),
	(228846, 120, '2014-03-01 01:30:43.000000', 'temperatura', 390.0000, 'ºC'),
	(228847, 120, '2014-03-01 01:30:44.000000', 'temperatura', 920.0000, 'ºC'),
	(228848, 120, '2014-03-01 01:30:45.000000', 'temperatura', 1029.0000, 'ºC'),
	(228849, 120, '2014-03-01 01:30:46.000000', 'temperatura', 1185.0000, 'ºC'),
	(228850, 120, '2014-03-01 01:30:47.000000', 'temperatura', 439.0000, 'ºC'),
	(228851, 120, '2014-03-01 01:30:48.000000', 'temperatura', 1041.0000, 'ºC'),
	(228852, 120, '2014-03-01 01:30:49.000000', 'temperatura', 288.0000, 'ºC'),
	(228853, 120, '2014-03-01 01:30:50.000000', 'temperatura', 716.0000, 'ºC'),
	(228854, 120, '2014-03-01 01:30:51.000000', 'temperatura', 316.0000, 'ºC'),
	(228855, 120, '2014-03-01 01:30:52.000000', 'temperatura', 634.0000, 'ºC'),
	(228856, 120, '2014-03-01 01:30:53.000000', 'temperatura', 1024.0000, 'ºC'),
	(228857, 121, '2014-03-01 00:00:00.000000', 'temperatura', 1017.0000, 'ºC'),
	(228858, 121, '2014-03-01 00:00:01.000000', 'temperatura', 234.0000, 'ºC'),
	(228859, 121, '2014-03-01 00:00:02.000000', 'temperatura', 518.0000, 'ºC'),
	(228860, 121, '2014-03-01 00:00:03.000000', 'temperatura', 690.0000, 'ºC'),
	(228861, 121, '2014-03-01 00:00:04.000000', 'temperatura', 694.0000, 'ºC'),
	(228862, 121, '2014-03-01 00:00:05.000000', 'temperatura', 200.0000, 'ºC'),
	(228863, 121, '2014-03-01 00:00:06.000000', 'temperatura', 117.0000, 'ºC'),
	(228864, 121, '2014-03-01 00:00:07.000000', 'temperatura', 1189.0000, 'ºC'),
	(228865, 121, '2014-03-01 00:00:08.000000', 'temperatura', 795.0000, 'ºC'),
	(228866, 121, '2014-03-01 00:00:09.000000', 'temperatura', 407.0000, 'ºC'),
	(228867, 121, '2014-03-01 00:00:10.000000', 'temperatura', 849.0000, 'ºC'),
	(228868, 121, '2014-03-01 00:00:11.000000', 'temperatura', 625.0000, 'ºC'),
	(228869, 121, '2014-03-01 00:00:12.000000', 'temperatura', 580.0000, 'ºC'),
	(228870, 121, '2014-03-01 00:00:13.000000', 'temperatura', 1023.0000, 'ºC'),
	(228871, 121, '2014-03-01 00:00:14.000000', 'temperatura', 977.0000, 'ºC'),
	(228872, 121, '2014-03-01 00:00:15.000000', 'temperatura', 617.0000, 'ºC'),
	(228873, 121, '2014-03-01 00:00:16.000000', 'temperatura', 156.0000, 'ºC'),
	(228874, 121, '2014-03-01 00:00:17.000000', 'temperatura', 129.0000, 'ºC'),
	(228875, 121, '2014-03-01 00:00:18.000000', 'temperatura', 176.0000, 'ºC'),
	(228876, 121, '2014-03-01 00:00:19.000000', 'temperatura', 492.0000, 'ºC'),
	(228877, 121, '2014-03-01 00:00:20.000000', 'temperatura', 736.0000, 'ºC'),
	(228878, 121, '2014-03-01 00:00:21.000000', 'temperatura', 1002.0000, 'ºC'),
	(228879, 121, '2014-03-01 00:00:22.000000', 'temperatura', 402.0000, 'ºC'),
	(228880, 121, '2014-03-01 00:00:23.000000', 'temperatura', 204.0000, 'ºC'),
	(228881, 121, '2014-03-01 00:00:24.000000', 'temperatura', 1018.0000, 'ºC'),
	(228882, 121, '2014-03-01 00:00:25.000000', 'temperatura', 875.0000, 'ºC'),
	(228883, 121, '2014-03-01 00:00:26.000000', 'temperatura', 122.0000, 'ºC'),
	(228884, 121, '2014-03-01 00:00:27.000000', 'temperatura', 384.0000, 'ºC'),
	(228885, 121, '2014-03-01 00:00:28.000000', 'temperatura', 358.0000, 'ºC'),
	(228886, 121, '2014-03-01 00:00:29.000000', 'temperatura', 637.0000, 'ºC'),
	(228887, 121, '2014-03-01 00:00:30.000000', 'temperatura', 911.0000, 'ºC'),
	(228888, 121, '2014-03-01 00:00:31.000000', 'temperatura', 246.0000, 'ºC'),
	(228889, 121, '2014-03-01 00:00:32.000000', 'temperatura', 897.0000, 'ºC'),
	(228890, 121, '2014-03-01 00:00:33.000000', 'temperatura', 148.0000, 'ºC'),
	(228891, 121, '2014-03-01 00:00:34.000000', 'temperatura', 447.0000, 'ºC'),
	(228892, 121, '2014-03-01 00:00:35.000000', 'temperatura', 594.0000, 'ºC'),
	(228893, 121, '2014-03-01 00:00:36.000000', 'temperatura', 430.0000, 'ºC'),
	(228894, 121, '2014-03-01 00:00:37.000000', 'temperatura', 370.0000, 'ºC'),
	(228895, 121, '2014-03-01 00:00:38.000000', 'temperatura', 557.0000, 'ºC'),
	(228896, 121, '2014-03-01 00:00:39.000000', 'temperatura', 479.0000, 'ºC'),
	(228897, 121, '2014-03-01 00:00:40.000000', 'temperatura', 722.0000, 'ºC'),
	(228898, 121, '2014-03-01 00:00:41.000000', 'temperatura', 975.0000, 'ºC'),
	(228899, 121, '2014-03-01 00:00:42.000000', 'temperatura', 309.0000, 'ºC'),
	(228900, 121, '2014-03-01 00:00:43.000000', 'temperatura', 1020.0000, 'ºC'),
	(228901, 121, '2014-03-01 00:00:44.000000', 'temperatura', 575.0000, 'ºC'),
	(228902, 121, '2014-03-01 00:00:45.000000', 'temperatura', 1016.0000, 'ºC'),
	(228903, 121, '2014-03-01 00:00:46.000000', 'temperatura', 955.0000, 'ºC'),
	(228904, 121, '2014-03-01 00:00:47.000000', 'temperatura', 529.0000, 'ºC'),
	(228905, 121, '2014-03-01 00:00:48.000000', 'temperatura', 977.0000, 'ºC'),
	(228906, 121, '2014-03-01 00:00:49.000000', 'temperatura', 901.0000, 'ºC'),
	(228907, 121, '2014-03-01 00:00:50.000000', 'temperatura', 375.0000, 'ºC'),
	(228908, 121, '2014-03-01 00:00:51.000000', 'temperatura', 370.0000, 'ºC'),
	(228909, 121, '2014-03-01 00:00:52.000000', 'temperatura', 727.0000, 'ºC'),
	(228910, 121, '2014-03-01 00:00:53.000000', 'temperatura', 125.0000, 'ºC'),
	(228911, 121, '2014-03-01 00:00:54.000000', 'temperatura', 844.0000, 'ºC'),
	(228912, 121, '2014-03-01 00:00:55.000000', 'temperatura', 247.0000, 'ºC'),
	(228913, 121, '2014-03-01 00:00:56.000000', 'temperatura', 1101.0000, 'ºC'),
	(228914, 121, '2014-03-01 00:00:57.000000', 'temperatura', 1167.0000, 'ºC'),
	(228915, 121, '2014-03-01 00:00:58.000000', 'temperatura', 131.0000, 'ºC'),
	(228916, 121, '2014-03-01 00:00:59.000000', 'temperatura', 756.0000, 'ºC'),
	(228917, 121, '2014-03-01 00:01:00.000000', 'temperatura', 987.0000, 'ºC'),
	(228918, 121, '2014-03-01 00:01:01.000000', 'temperatura', 269.0000, 'ºC'),
	(228919, 121, '2014-03-01 00:01:02.000000', 'temperatura', 783.0000, 'ºC'),
	(228920, 121, '2014-03-01 00:01:03.000000', 'temperatura', 708.0000, 'ºC'),
	(228921, 121, '2014-03-01 00:01:04.000000', 'temperatura', 1193.0000, 'ºC'),
	(228922, 121, '2014-03-01 00:01:05.000000', 'temperatura', 239.0000, 'ºC'),
	(228923, 121, '2014-03-01 00:01:06.000000', 'temperatura', 17.0000, 'ºC'),
	(228924, 121, '2014-03-01 00:01:07.000000', 'temperatura', 568.0000, 'ºC'),
	(228925, 121, '2014-03-01 00:01:08.000000', 'temperatura', 388.0000, 'ºC'),
	(228926, 121, '2014-03-01 00:01:09.000000', 'temperatura', 239.0000, 'ºC'),
	(228927, 121, '2014-03-01 00:01:10.000000', 'temperatura', 31.0000, 'ºC'),
	(228928, 121, '2014-03-01 00:01:11.000000', 'temperatura', 639.0000, 'ºC'),
	(228929, 121, '2014-03-01 00:01:12.000000', 'temperatura', 700.0000, 'ºC'),
	(228930, 121, '2014-03-01 00:01:13.000000', 'temperatura', 386.0000, 'ºC'),
	(228931, 121, '2014-03-01 00:01:14.000000', 'temperatura', 1030.0000, 'ºC'),
	(228932, 121, '2014-03-01 00:01:15.000000', 'temperatura', 394.0000, 'ºC'),
	(228933, 121, '2014-03-01 00:01:16.000000', 'temperatura', 80.0000, 'ºC'),
	(228934, 121, '2014-03-01 00:01:17.000000', 'temperatura', 419.0000, 'ºC'),
	(228935, 121, '2014-03-01 00:01:18.000000', 'temperatura', 653.0000, 'ºC'),
	(228936, 121, '2014-03-01 00:01:19.000000', 'temperatura', 810.0000, 'ºC'),
	(228937, 121, '2014-03-01 00:01:20.000000', 'temperatura', 890.0000, 'ºC'),
	(228938, 121, '2014-03-01 00:01:21.000000', 'temperatura', 823.0000, 'ºC'),
	(228939, 121, '2014-03-01 00:01:22.000000', 'temperatura', 244.0000, 'ºC'),
	(228940, 121, '2014-03-01 00:01:23.000000', 'temperatura', 1151.0000, 'ºC'),
	(228941, 121, '2014-03-01 00:01:24.000000', 'temperatura', 225.0000, 'ºC'),
	(228942, 121, '2014-03-01 00:01:25.000000', 'temperatura', 73.0000, 'ºC'),
	(228943, 121, '2014-03-01 00:01:26.000000', 'temperatura', 891.0000, 'ºC'),
	(228944, 121, '2014-03-01 00:01:27.000000', 'temperatura', 634.0000, 'ºC'),
	(228945, 121, '2014-03-01 00:01:28.000000', 'temperatura', 497.0000, 'ºC'),
	(228946, 121, '2014-03-01 00:01:29.000000', 'temperatura', 586.0000, 'ºC'),
	(228947, 121, '2014-03-01 00:01:30.000000', 'temperatura', 239.0000, 'ºC'),
	(228948, 121, '2014-03-01 00:01:31.000000', 'temperatura', 639.0000, 'ºC'),
	(228949, 121, '2014-03-01 00:01:32.000000', 'temperatura', 77.0000, 'ºC'),
	(228950, 121, '2014-03-01 00:01:33.000000', 'temperatura', 869.0000, 'ºC'),
	(228951, 121, '2014-03-01 00:01:34.000000', 'temperatura', 516.0000, 'ºC'),
	(228952, 121, '2014-03-01 00:01:35.000000', 'temperatura', 1174.0000, 'ºC'),
	(228953, 121, '2014-03-01 00:01:36.000000', 'temperatura', 721.0000, 'ºC'),
	(228954, 121, '2014-03-01 00:01:37.000000', 'temperatura', 82.0000, 'ºC'),
	(228955, 121, '2014-03-01 00:01:38.000000', 'temperatura', 647.0000, 'ºC'),
	(228956, 121, '2014-03-01 00:01:39.000000', 'temperatura', 592.0000, 'ºC'),
	(228957, 121, '2014-03-01 00:01:40.000000', 'temperatura', 1018.0000, 'ºC'),
	(228958, 121, '2014-03-01 00:01:41.000000', 'temperatura', 916.0000, 'ºC'),
	(228959, 121, '2014-03-01 00:01:42.000000', 'temperatura', 326.0000, 'ºC'),
	(228960, 121, '2014-03-01 00:01:43.000000', 'temperatura', 83.0000, 'ºC'),
	(228961, 121, '2014-03-01 00:01:44.000000', 'temperatura', 638.0000, 'ºC'),
	(228962, 121, '2014-03-01 00:01:45.000000', 'temperatura', 539.0000, 'ºC'),
	(228963, 121, '2014-03-01 00:01:46.000000', 'temperatura', 784.0000, 'ºC'),
	(228964, 121, '2014-03-01 00:01:47.000000', 'temperatura', 1103.0000, 'ºC'),
	(228965, 121, '2014-03-01 00:01:48.000000', 'temperatura', 764.0000, 'ºC'),
	(228966, 121, '2014-03-01 00:01:49.000000', 'temperatura', 512.0000, 'ºC'),
	(228967, 121, '2014-03-01 00:01:50.000000', 'temperatura', 266.0000, 'ºC'),
	(228968, 121, '2014-03-01 00:01:51.000000', 'temperatura', 997.0000, 'ºC'),
	(228969, 121, '2014-03-01 00:01:52.000000', 'temperatura', 589.0000, 'ºC'),
	(228970, 121, '2014-03-01 00:01:53.000000', 'temperatura', 1152.0000, 'ºC'),
	(228971, 121, '2014-03-01 00:01:54.000000', 'temperatura', 392.0000, 'ºC'),
	(228972, 121, '2014-03-01 00:01:55.000000', 'temperatura', 908.0000, 'ºC'),
	(228973, 121, '2014-03-01 00:01:56.000000', 'temperatura', 963.0000, 'ºC'),
	(228974, 121, '2014-03-01 00:01:57.000000', 'temperatura', 891.0000, 'ºC'),
	(228975, 121, '2014-03-01 00:01:58.000000', 'temperatura', 368.0000, 'ºC'),
	(228976, 121, '2014-03-01 00:01:59.000000', 'temperatura', 365.0000, 'ºC'),
	(228977, 121, '2014-03-01 00:02:00.000000', 'temperatura', 724.0000, 'ºC'),
	(228978, 121, '2014-03-01 00:02:01.000000', 'temperatura', 126.0000, 'ºC'),
	(228979, 121, '2014-03-01 00:02:02.000000', 'temperatura', 857.0000, 'ºC'),
	(228980, 121, '2014-03-01 00:02:03.000000', 'temperatura', 308.0000, 'ºC'),
	(228981, 121, '2014-03-01 00:02:04.000000', 'temperatura', 170.0000, 'ºC'),
	(228982, 121, '2014-03-01 00:02:05.000000', 'temperatura', 1124.0000, 'ºC'),
	(228983, 121, '2014-03-01 00:02:06.000000', 'temperatura', 313.0000, 'ºC'),
	(228984, 121, '2014-03-01 00:02:07.000000', 'temperatura', 591.0000, 'ºC'),
	(228985, 121, '2014-03-01 00:02:08.000000', 'temperatura', 817.0000, 'ºC'),
	(228986, 121, '2014-03-01 00:02:09.000000', 'temperatura', 1113.0000, 'ºC'),
	(228987, 121, '2014-03-01 00:02:10.000000', 'temperatura', 717.0000, 'ºC'),
	(228988, 121, '2014-03-01 00:02:11.000000', 'temperatura', 243.0000, 'ºC'),
	(228989, 121, '2014-03-01 00:02:12.000000', 'temperatura', 267.0000, 'ºC'),
	(228990, 121, '2014-03-01 00:02:13.000000', 'temperatura', 605.0000, 'ºC'),
	(228991, 121, '2014-03-01 00:02:14.000000', 'temperatura', 1023.0000, 'ºC'),
	(228992, 121, '2014-03-01 00:02:15.000000', 'temperatura', 902.0000, 'ºC'),
	(228993, 121, '2014-03-01 00:02:16.000000', 'temperatura', 241.0000, 'ºC'),
	(228994, 121, '2014-03-01 00:02:17.000000', 'temperatura', 902.0000, 'ºC'),
	(228995, 121, '2014-03-01 00:02:18.000000', 'temperatura', 184.0000, 'ºC'),
	(228996, 121, '2014-03-01 00:02:19.000000', 'temperatura', 617.0000, 'ºC'),
	(228997, 121, '2014-03-01 00:02:20.000000', 'temperatura', 135.0000, 'ºC'),
	(228998, 121, '2014-03-01 00:02:21.000000', 'temperatura', 21.0000, 'ºC'),
	(228999, 121, '2014-03-01 00:02:22.000000', 'temperatura', 904.0000, 'ºC'),
	(229000, 121, '2014-03-01 00:02:23.000000', 'temperatura', 855.0000, 'ºC'),
	(229001, 121, '2014-03-01 00:02:24.000000', 'temperatura', 364.0000, 'ºC'),
	(229002, 121, '2014-03-01 00:02:25.000000', 'temperatura', 455.0000, 'ºC'),
	(229003, 121, '2014-03-01 00:02:26.000000', 'temperatura', 1182.0000, 'ºC'),
	(229004, 121, '2014-03-01 00:02:27.000000', 'temperatura', 946.0000, 'ºC'),
	(229005, 121, '2014-03-01 00:02:28.000000', 'temperatura', 1186.0000, 'ºC'),
	(229006, 121, '2014-03-01 00:02:29.000000', 'temperatura', 691.0000, 'ºC'),
	(229007, 121, '2014-03-01 00:02:30.000000', 'temperatura', 1097.0000, 'ºC'),
	(229008, 121, '2014-03-01 00:02:31.000000', 'temperatura', 1015.0000, 'ºC'),
	(229009, 121, '2014-03-01 00:02:32.000000', 'temperatura', 585.0000, 'ºC'),
	(229010, 121, '2014-03-01 00:02:33.000000', 'temperatura', 1077.0000, 'ºC'),
	(229011, 121, '2014-03-01 00:02:34.000000', 'temperatura', 34.0000, 'ºC'),
	(229012, 121, '2014-03-01 00:02:35.000000', 'temperatura', 538.0000, 'ºC'),
	(229013, 121, '2014-03-01 00:02:36.000000', 'temperatura', 190.0000, 'ºC'),
	(229014, 121, '2014-03-01 00:02:37.000000', 'temperatura', 536.0000, 'ºC'),
	(229015, 121, '2014-03-01 00:02:38.000000', 'temperatura', 912.0000, 'ºC'),
	(229016, 121, '2014-03-01 00:02:39.000000', 'temperatura', 550.0000, 'ºC'),
	(229017, 121, '2014-03-01 00:02:40.000000', 'temperatura', 16.0000, 'ºC'),
	(229018, 121, '2014-03-01 00:02:41.000000', 'temperatura', 829.0000, 'ºC'),
	(229019, 121, '2014-03-01 00:02:42.000000', 'temperatura', 498.0000, 'ºC'),
	(229020, 121, '2014-03-01 00:02:43.000000', 'temperatura', 2.0000, 'ºC'),
	(229021, 121, '2014-03-01 00:02:44.000000', 'temperatura', 919.0000, 'ºC'),
	(229022, 121, '2014-03-01 00:02:45.000000', 'temperatura', 987.0000, 'ºC'),
	(229023, 121, '2014-03-01 00:02:46.000000', 'temperatura', 979.0000, 'ºC'),
	(229024, 121, '2014-03-01 00:02:47.000000', 'temperatura', 736.0000, 'ºC'),
	(229025, 121, '2014-03-01 00:02:48.000000', 'temperatura', 742.0000, 'ºC'),
	(229026, 121, '2014-03-01 00:02:49.000000', 'temperatura', 303.0000, 'ºC'),
	(229027, 121, '2014-03-01 00:02:50.000000', 'temperatura', 489.0000, 'ºC'),
	(229028, 121, '2014-03-01 00:02:51.000000', 'temperatura', 338.0000, 'ºC'),
	(229029, 121, '2014-03-01 00:02:52.000000', 'temperatura', 224.0000, 'ºC'),
	(229030, 121, '2014-03-01 00:02:53.000000', 'temperatura', 104.0000, 'ºC'),
	(229031, 121, '2014-03-01 00:02:54.000000', 'temperatura', 1052.0000, 'ºC'),
	(229032, 121, '2014-03-01 00:02:55.000000', 'temperatura', 146.0000, 'ºC'),
	(229033, 121, '2014-03-01 00:02:56.000000', 'temperatura', 1174.0000, 'ºC'),
	(229034, 121, '2014-03-01 00:02:57.000000', 'temperatura', 631.0000, 'ºC'),
	(229035, 121, '2014-03-01 00:02:58.000000', 'temperatura', 836.0000, 'ºC'),
	(229036, 121, '2014-03-01 00:02:59.000000', 'temperatura', 1086.0000, 'ºC'),
	(229037, 121, '2014-03-01 00:03:00.000000', 'temperatura', 522.0000, 'ºC'),
	(229038, 121, '2014-03-01 00:03:01.000000', 'temperatura', 552.0000, 'ºC'),
	(229039, 121, '2014-03-01 00:03:02.000000', 'temperatura', 1197.0000, 'ºC'),
	(229040, 121, '2014-03-01 00:03:03.000000', 'temperatura', 729.0000, 'ºC'),
	(229041, 121, '2014-03-01 00:03:04.000000', 'temperatura', 55.0000, 'ºC'),
	(229042, 121, '2014-03-01 00:03:05.000000', 'temperatura', 488.0000, 'ºC'),
	(229043, 121, '2014-03-01 00:03:06.000000', 'temperatura', 1075.0000, 'ºC'),
	(229044, 121, '2014-03-01 00:03:07.000000', 'temperatura', 310.0000, 'ºC'),
	(229045, 121, '2014-03-01 00:03:08.000000', 'temperatura', 727.0000, 'ºC'),
	(229046, 121, '2014-03-01 00:03:09.000000', 'temperatura', 304.0000, 'ºC'),
	(229047, 121, '2014-03-01 00:03:10.000000', 'temperatura', 540.0000, 'ºC'),
	(229048, 121, '2014-03-01 00:03:11.000000', 'temperatura', 588.0000, 'ºC'),
	(229049, 121, '2014-03-01 00:03:12.000000', 'temperatura', 121.0000, 'ºC'),
	(229050, 121, '2014-03-01 00:03:13.000000', 'temperatura', 42.0000, 'ºC'),
	(229051, 121, '2014-03-01 00:03:14.000000', 'temperatura', 1048.0000, 'ºC'),
	(229052, 121, '2014-03-01 00:03:15.000000', 'temperatura', 315.0000, 'ºC'),
	(229053, 121, '2014-03-01 00:03:16.000000', 'temperatura', 829.0000, 'ºC'),
	(229054, 121, '2014-03-01 00:03:17.000000', 'temperatura', 802.0000, 'ºC'),
	(229055, 121, '2014-03-01 00:03:18.000000', 'temperatura', 322.0000, 'ºC'),
	(229056, 121, '2014-03-01 00:03:19.000000', 'temperatura', 407.0000, 'ºC'),
	(229057, 121, '2014-03-01 00:03:20.000000', 'temperatura', 1071.0000, 'ºC'),
	(229058, 121, '2014-03-01 00:03:21.000000', 'temperatura', 531.0000, 'ºC'),
	(229059, 121, '2014-03-01 00:03:22.000000', 'temperatura', 642.0000, 'ºC'),
	(229060, 121, '2014-03-01 00:03:23.000000', 'temperatura', 418.0000, 'ºC'),
	(229061, 121, '2014-03-01 00:03:24.000000', 'temperatura', 163.0000, 'ºC'),
	(229062, 121, '2014-03-01 00:03:25.000000', 'temperatura', 763.0000, 'ºC'),
	(229063, 121, '2014-03-01 00:03:26.000000', 'temperatura', 924.0000, 'ºC'),
	(229064, 121, '2014-03-01 00:03:27.000000', 'temperatura', 1135.0000, 'ºC'),
	(229065, 121, '2014-03-01 00:03:28.000000', 'temperatura', 500.0000, 'ºC'),
	(229066, 121, '2014-03-01 00:03:29.000000', 'temperatura', 298.0000, 'ºC'),
	(229067, 121, '2014-03-01 00:03:30.000000', 'temperatura', 1191.0000, 'ºC'),
	(229068, 121, '2014-03-01 00:03:31.000000', 'temperatura', 262.0000, 'ºC'),
	(229069, 121, '2014-03-01 00:03:32.000000', 'temperatura', 136.0000, 'ºC'),
	(229070, 121, '2014-03-01 00:03:33.000000', 'temperatura', 1095.0000, 'ºC'),
	(229071, 121, '2014-03-01 00:03:34.000000', 'temperatura', 269.0000, 'ºC'),
	(229072, 121, '2014-03-01 00:03:35.000000', 'temperatura', 457.0000, 'ºC'),
	(229073, 121, '2014-03-01 00:03:36.000000', 'temperatura', 282.0000, 'ºC'),
	(229074, 121, '2014-03-01 00:03:37.000000', 'temperatura', 39.0000, 'ºC'),
	(229075, 121, '2014-03-01 00:03:38.000000', 'temperatura', 547.0000, 'ºC'),
	(229076, 121, '2014-03-01 00:03:39.000000', 'temperatura', 221.0000, 'ºC'),
	(229077, 121, '2014-03-01 00:03:40.000000', 'temperatura', 662.0000, 'ºC'),
	(229078, 121, '2014-03-01 00:03:41.000000', 'temperatura', 250.0000, 'ºC'),
	(229079, 121, '2014-03-01 00:03:42.000000', 'temperatura', 462.0000, 'ºC'),
	(229080, 121, '2014-03-01 00:03:43.000000', 'temperatura', 361.0000, 'ºC'),
	(229081, 121, '2014-03-01 00:03:44.000000', 'temperatura', 420.0000, 'ºC'),
	(229082, 121, '2014-03-01 00:03:45.000000', 'temperatura', 1017.0000, 'ºC'),
	(229083, 121, '2014-03-01 00:03:46.000000', 'temperatura', 226.0000, 'ºC'),
	(229084, 121, '2014-03-01 00:03:47.000000', 'temperatura', 478.0000, 'ºC'),
	(229085, 121, '2014-03-01 00:03:48.000000', 'temperatura', 516.0000, 'ºC'),
	(229086, 121, '2014-03-01 00:03:49.000000', 'temperatura', 1143.0000, 'ºC'),
	(229087, 121, '2014-03-01 00:03:50.000000', 'temperatura', 569.0000, 'ºC'),
	(229088, 121, '2014-03-01 00:03:51.000000', 'temperatura', 615.0000, 'ºC'),
	(229089, 121, '2014-03-01 00:03:52.000000', 'temperatura', 169.0000, 'ºC'),
	(229090, 121, '2014-03-01 00:03:53.000000', 'temperatura', 200.0000, 'ºC'),
	(229091, 121, '2014-03-01 00:03:54.000000', 'temperatura', 495.0000, 'ºC'),
	(229092, 121, '2014-03-01 00:03:55.000000', 'temperatura', 673.0000, 'ºC'),
	(229093, 121, '2014-03-01 00:03:56.000000', 'temperatura', 683.0000, 'ºC'),
	(229094, 121, '2014-03-01 00:03:57.000000', 'temperatura', 194.0000, 'ºC'),
	(229095, 121, '2014-03-01 00:03:58.000000', 'temperatura', 123.0000, 'ºC'),
	(229096, 121, '2014-03-01 00:03:59.000000', 'temperatura', 32.0000, 'ºC'),
	(229097, 121, '2014-03-01 00:04:00.000000', 'temperatura', 994.0000, 'ºC'),
	(229098, 121, '2014-03-01 00:04:01.000000', 'temperatura', 71.0000, 'ºC'),
	(229099, 121, '2014-03-01 00:04:02.000000', 'temperatura', 977.0000, 'ºC'),
	(229100, 121, '2014-03-01 00:04:03.000000', 'temperatura', 1070.0000, 'ºC'),
	(229101, 121, '2014-03-01 00:04:04.000000', 'temperatura', 19.0000, 'ºC'),
	(229102, 121, '2014-03-01 00:04:05.000000', 'temperatura', 486.0000, 'ºC'),
	(229103, 121, '2014-03-01 00:04:06.000000', 'temperatura', 1173.0000, 'ºC'),
	(229104, 121, '2014-03-01 00:04:07.000000', 'temperatura', 808.0000, 'ºC'),
	(229105, 121, '2014-03-01 00:04:08.000000', 'temperatura', 521.0000, 'ºC'),
	(229106, 121, '2014-03-01 00:04:09.000000', 'temperatura', 182.0000, 'ºC'),
	(229107, 121, '2014-03-01 00:04:10.000000', 'temperatura', 547.0000, 'ºC'),
	(229108, 121, '2014-03-01 00:04:11.000000', 'temperatura', 989.0000, 'ºC'),
	(229109, 121, '2014-03-01 00:04:12.000000', 'temperatura', 905.0000, 'ºC'),
	(229110, 121, '2014-03-01 00:04:13.000000', 'temperatura', 360.0000, 'ºC'),
	(229111, 121, '2014-03-01 00:04:14.000000', 'temperatura', 286.0000, 'ºC'),
	(229112, 121, '2014-03-01 00:04:15.000000', 'temperatura', 351.0000, 'ºC'),
	(229113, 121, '2014-03-01 00:04:16.000000', 'temperatura', 895.0000, 'ºC'),
	(229114, 121, '2014-03-01 00:04:17.000000', 'temperatura', 1025.0000, 'ºC'),
	(229115, 121, '2014-03-01 00:04:18.000000', 'temperatura', 39.0000, 'ºC'),
	(229116, 121, '2014-03-01 00:04:19.000000', 'temperatura', 723.0000, 'ºC'),
	(229117, 121, '2014-03-01 00:04:20.000000', 'temperatura', 1096.0000, 'ºC'),
	(229118, 121, '2014-03-01 00:04:21.000000', 'temperatura', 912.0000, 'ºC'),
	(229119, 121, '2014-03-01 00:04:22.000000', 'temperatura', 72.0000, 'ºC'),
	(229120, 121, '2014-03-01 00:04:23.000000', 'temperatura', 27.0000, 'ºC'),
	(229121, 121, '2014-03-01 00:04:24.000000', 'temperatura', 1117.0000, 'ºC'),
	(229122, 121, '2014-03-01 00:04:25.000000', 'temperatura', 707.0000, 'ºC'),
	(229123, 121, '2014-03-01 00:04:26.000000', 'temperatura', 182.0000, 'ºC'),
	(229124, 121, '2014-03-01 00:04:27.000000', 'temperatura', 1190.0000, 'ºC'),
	(229125, 121, '2014-03-01 00:04:28.000000', 'temperatura', 605.0000, 'ºC'),
	(229126, 121, '2014-03-01 00:04:29.000000', 'temperatura', 657.0000, 'ºC'),
	(229127, 121, '2014-03-01 00:04:30.000000', 'temperatura', 270.0000, 'ºC'),
	(229128, 121, '2014-03-01 00:04:31.000000', 'temperatura', 578.0000, 'ºC'),
	(229129, 121, '2014-03-01 00:04:32.000000', 'temperatura', 882.0000, 'ºC'),
	(229130, 121, '2014-03-01 00:04:33.000000', 'temperatura', 274.0000, 'ºC'),
	(229131, 121, '2014-03-01 00:04:34.000000', 'temperatura', 1127.0000, 'ºC'),
	(229132, 121, '2014-03-01 00:04:35.000000', 'temperatura', 12.0000, 'ºC'),
	(229133, 121, '2014-03-01 00:04:36.000000', 'temperatura', 282.0000, 'ºC'),
	(229134, 121, '2014-03-01 00:04:37.000000', 'temperatura', 173.0000, 'ºC'),
	(229135, 121, '2014-03-01 00:04:38.000000', 'temperatura', 18.0000, 'ºC'),
	(229136, 121, '2014-03-01 00:04:39.000000', 'temperatura', 771.0000, 'ºC'),
	(229137, 121, '2014-03-01 00:04:40.000000', 'temperatura', 204.0000, 'ºC'),
	(229138, 121, '2014-03-01 00:04:41.000000', 'temperatura', 1107.0000, 'ºC'),
	(229139, 121, '2014-03-01 00:04:42.000000', 'temperatura', 125.0000, 'ºC'),
	(229140, 121, '2014-03-01 00:04:43.000000', 'temperatura', 905.0000, 'ºC'),
	(229141, 121, '2014-03-01 00:04:44.000000', 'temperatura', 548.0000, 'ºC'),
	(229142, 121, '2014-03-01 00:04:45.000000', 'temperatura', 25.0000, 'ºC'),
	(229143, 121, '2014-03-01 00:04:46.000000', 'temperatura', 881.0000, 'ºC'),
	(229144, 121, '2014-03-01 00:04:47.000000', 'temperatura', 731.0000, 'ºC'),
	(229145, 121, '2014-03-01 00:04:48.000000', 'temperatura', 1015.0000, 'ºC'),
	(229146, 121, '2014-03-01 00:04:49.000000', 'temperatura', 480.0000, 'ºC'),
	(229147, 121, '2014-03-01 00:04:50.000000', 'temperatura', 558.0000, 'ºC'),
	(229148, 121, '2014-03-01 00:04:51.000000', 'temperatura', 148.0000, 'ºC'),
	(229149, 121, '2014-03-01 00:04:52.000000', 'temperatura', 266.0000, 'ºC'),
	(229150, 121, '2014-03-01 00:04:53.000000', 'temperatura', 887.0000, 'ºC'),
	(229151, 121, '2014-03-01 00:04:54.000000', 'temperatura', 36.0000, 'ºC'),
	(229152, 121, '2014-03-01 00:04:55.000000', 'temperatura', 1122.0000, 'ºC'),
	(229153, 121, '2014-03-01 00:04:56.000000', 'temperatura', 702.0000, 'ºC'),
	(229154, 121, '2014-03-01 00:04:57.000000', 'temperatura', 145.0000, 'ºC'),
	(229155, 121, '2014-03-01 00:04:58.000000', 'temperatura', 1018.0000, 'ºC'),
	(229156, 121, '2014-03-01 00:04:59.000000', 'temperatura', 1058.0000, 'ºC'),
	(229157, 121, '2014-03-01 00:05:00.000000', 'temperatura', 1034.0000, 'ºC'),
	(229158, 121, '2014-03-01 00:05:01.000000', 'temperatura', 796.0000, 'ºC'),
	(229159, 121, '2014-03-01 00:05:02.000000', 'temperatura', 881.0000, 'ºC'),
	(229160, 121, '2014-03-01 00:05:03.000000', 'temperatura', 816.0000, 'ºC'),
	(229161, 121, '2014-03-01 00:05:04.000000', 'temperatura', 239.0000, 'ºC'),
	(229162, 121, '2014-03-01 00:05:05.000000', 'temperatura', 1148.0000, 'ºC'),
	(229163, 121, '2014-03-01 00:05:06.000000', 'temperatura', 223.0000, 'ºC'),
	(229164, 121, '2014-03-01 00:05:07.000000', 'temperatura', 72.0000, 'ºC'),
	(229165, 121, '2014-03-01 00:05:08.000000', 'temperatura', 893.0000, 'ºC'),
	(229166, 121, '2014-03-01 00:05:09.000000', 'temperatura', 646.0000, 'ºC'),
	(229167, 121, '2014-03-01 00:05:10.000000', 'temperatura', 555.0000, 'ºC'),
	(229168, 121, '2014-03-01 00:05:11.000000', 'temperatura', 834.0000, 'ºC'),
	(229169, 121, '2014-03-01 00:05:12.000000', 'temperatura', 107.0000, 'ºC'),
	(229170, 121, '2014-03-01 00:05:13.000000', 'temperatura', 433.0000, 'ºC'),
	(229171, 121, '2014-03-01 00:05:14.000000', 'temperatura', 643.0000, 'ºC'),
	(229172, 121, '2014-03-01 00:05:15.000000', 'temperatura', 718.0000, 'ºC'),
	(229173, 121, '2014-03-01 00:05:16.000000', 'temperatura', 462.0000, 'ºC'),
	(229174, 121, '2014-03-01 00:05:17.000000', 'temperatura', 155.0000, 'ºC'),
	(229175, 121, '2014-03-01 00:05:18.000000', 'temperatura', 590.0000, 'ºC'),
	(229176, 121, '2014-03-01 00:05:19.000000', 'temperatura', 87.0000, 'ºC'),
	(229177, 121, '2014-03-01 00:05:20.000000', 'temperatura', 1065.0000, 'ºC'),
	(229178, 121, '2014-03-01 00:05:21.000000', 'temperatura', 262.0000, 'ºC'),
	(229179, 121, '2014-03-01 00:05:22.000000', 'temperatura', 517.0000, 'ºC'),
	(229180, 121, '2014-03-01 00:05:23.000000', 'temperatura', 601.0000, 'ºC'),
	(229181, 121, '2014-03-01 00:05:24.000000', 'temperatura', 252.0000, 'ºC'),
	(229182, 121, '2014-03-01 00:05:25.000000', 'temperatura', 656.0000, 'ºC'),
	(229183, 121, '2014-03-01 00:05:26.000000', 'temperatura', 128.0000, 'ºC'),
	(229184, 121, '2014-03-01 00:05:27.000000', 'temperatura', 1072.0000, 'ºC'),
	(229185, 121, '2014-03-01 00:05:28.000000', 'temperatura', 177.0000, 'ºC'),
	(229186, 121, '2014-03-01 00:05:29.000000', 'temperatura', 68.0000, 'ºC'),
	(229187, 121, '2014-03-01 00:05:30.000000', 'temperatura', 1010.0000, 'ºC'),
	(229188, 121, '2014-03-01 00:05:31.000000', 'temperatura', 49.0000, 'ºC'),
	(229189, 121, '2014-03-01 00:05:32.000000', 'temperatura', 812.0000, 'ºC'),
	(229190, 121, '2014-03-01 00:05:33.000000', 'temperatura', 315.0000, 'ºC'),
	(229191, 121, '2014-03-01 00:05:34.000000', 'temperatura', 337.0000, 'ºC'),
	(229192, 121, '2014-03-01 00:05:35.000000', 'temperatura', 744.0000, 'ºC'),
	(229193, 121, '2014-03-01 00:05:36.000000', 'temperatura', 308.0000, 'ºC'),
	(229194, 121, '2014-03-01 00:05:37.000000', 'temperatura', 507.0000, 'ºC'),
	(229195, 121, '2014-03-01 00:05:38.000000', 'temperatura', 413.0000, 'ºC'),
	(229196, 121, '2014-03-01 00:05:39.000000', 'temperatura', 545.0000, 'ºC'),
	(229197, 121, '2014-03-01 00:05:40.000000', 'temperatura', 285.0000, 'ºC'),
	(229198, 121, '2014-03-01 00:05:41.000000', 'temperatura', 990.0000, 'ºC'),
	(229199, 121, '2014-03-01 00:05:42.000000', 'temperatura', 497.0000, 'ºC'),
	(229200, 121, '2014-03-01 00:05:43.000000', 'temperatura', 715.0000, 'ºC'),
	(229201, 121, '2014-03-01 00:05:44.000000', 'temperatura', 887.0000, 'ºC'),
	(229202, 121, '2014-03-01 00:05:45.000000', 'temperatura', 1087.0000, 'ºC'),
	(229203, 121, '2014-03-01 00:05:46.000000', 'temperatura', 375.0000, 'ºC'),
	(229204, 121, '2014-03-01 00:05:47.000000', 'temperatura', 1013.0000, 'ºC'),
	(229205, 121, '2014-03-01 00:05:48.000000', 'temperatura', 344.0000, 'ºC'),
	(229206, 121, '2014-03-01 00:05:49.000000', 'temperatura', 1080.0000, 'ºC'),
	(229207, 121, '2014-03-01 00:05:50.000000', 'temperatura', 767.0000, 'ºC'),
	(229208, 121, '2014-03-01 00:05:51.000000', 'temperatura', 598.0000, 'ºC'),
	(229209, 121, '2014-03-01 00:05:52.000000', 'temperatura', 688.0000, 'ºC'),
	(229210, 121, '2014-03-01 00:05:53.000000', 'temperatura', 447.0000, 'ºC'),
	(229211, 121, '2014-03-01 00:05:54.000000', 'temperatura', 170.0000, 'ºC'),
	(229212, 121, '2014-03-01 00:05:55.000000', 'temperatura', 710.0000, 'ºC'),
	(229213, 121, '2014-03-01 00:05:56.000000', 'temperatura', 642.0000, 'ºC'),
	(229214, 121, '2014-03-01 00:05:57.000000', 'temperatura', 1080.0000, 'ºC'),
	(229215, 121, '2014-03-01 00:05:58.000000', 'temperatura', 1072.0000, 'ºC'),
	(229216, 121, '2014-03-01 00:05:59.000000', 'temperatura', 923.0000, 'ºC'),
	(229217, 121, '2014-03-01 00:06:00.000000', 'temperatura', 197.0000, 'ºC'),
	(229218, 121, '2014-03-01 00:06:01.000000', 'temperatura', 620.0000, 'ºC'),
	(229219, 121, '2014-03-01 00:06:02.000000', 'temperatura', 107.0000, 'ºC'),
	(229220, 121, '2014-03-01 00:06:03.000000', 'temperatura', 1078.0000, 'ºC'),
	(229221, 121, '2014-03-01 00:06:04.000000', 'temperatura', 268.0000, 'ºC'),
	(229222, 121, '2014-03-01 00:06:05.000000', 'temperatura', 507.0000, 'ºC'),
	(229223, 121, '2014-03-01 00:06:06.000000', 'temperatura', 532.0000, 'ºC'),
	(229224, 121, '2014-03-01 00:06:07.000000', 'temperatura', 1141.0000, 'ºC'),
	(229225, 121, '2014-03-01 00:06:08.000000', 'temperatura', 507.0000, 'ºC'),
	(229226, 121, '2014-03-01 00:06:09.000000', 'temperatura', 315.0000, 'ºC'),
	(229227, 121, '2014-03-01 00:06:10.000000', 'temperatura', 53.0000, 'ºC'),
	(229228, 121, '2014-03-01 00:06:11.000000', 'temperatura', 523.0000, 'ºC'),
	(229229, 121, '2014-03-01 00:06:12.000000', 'temperatura', 53.0000, 'ºC'),
	(229230, 121, '2014-03-01 00:06:13.000000', 'temperatura', 1098.0000, 'ºC'),
	(229231, 121, '2014-03-01 00:06:14.000000', 'temperatura', 531.0000, 'ºC'),
	(229232, 121, '2014-03-01 00:06:15.000000', 'temperatura', 560.0000, 'ºC'),
	(229233, 121, '2014-03-01 00:06:16.000000', 'temperatura', 9.0000, 'ºC'),
	(229234, 121, '2014-03-01 00:06:17.000000', 'temperatura', 767.0000, 'ºC'),
	(229235, 121, '2014-03-01 00:06:18.000000', 'temperatura', 207.0000, 'ºC'),
	(229236, 121, '2014-03-01 00:06:19.000000', 'temperatura', 1134.0000, 'ºC'),
	(229237, 121, '2014-03-01 00:06:20.000000', 'temperatura', 248.0000, 'ºC'),
	(229238, 121, '2014-03-01 00:06:21.000000', 'temperatura', 240.0000, 'ºC'),
	(229239, 121, '2014-03-01 00:06:22.000000', 'temperatura', 457.0000, 'ºC'),
	(229240, 121, '2014-03-01 00:06:23.000000', 'temperatura', 364.0000, 'ºC'),
	(229241, 121, '2014-03-01 00:06:24.000000', 'temperatura', 450.0000, 'ºC'),
	(229242, 121, '2014-03-01 00:06:25.000000', 'temperatura', 1158.0000, 'ºC'),
	(229243, 121, '2014-03-01 00:06:26.000000', 'temperatura', 839.0000, 'ºC'),
	(229244, 121, '2014-03-01 00:06:27.000000', 'temperatura', 722.0000, 'ºC'),
	(229245, 121, '2014-03-01 00:06:28.000000', 'temperatura', 1096.0000, 'ºC'),
	(229246, 121, '2014-03-01 00:06:29.000000', 'temperatura', 913.0000, 'ºC'),
	(229247, 121, '2014-03-01 00:06:30.000000', 'temperatura', 78.0000, 'ºC'),
	(229248, 121, '2014-03-01 00:06:31.000000', 'temperatura', 52.0000, 'ºC'),
	(229249, 121, '2014-03-01 00:06:32.000000', 'temperatura', 25.0000, 'ºC'),
	(229250, 121, '2014-03-01 00:06:33.000000', 'temperatura', 1171.0000, 'ºC'),
	(229251, 121, '2014-03-01 00:06:34.000000', 'temperatura', 981.0000, 'ºC'),
	(229252, 121, '2014-03-01 00:06:35.000000', 'temperatura', 191.0000, 'ºC'),
	(229253, 121, '2014-03-01 00:06:36.000000', 'temperatura', 414.0000, 'ºC'),
	(229254, 121, '2014-03-01 00:06:37.000000', 'temperatura', 296.0000, 'ºC'),
	(229255, 121, '2014-03-01 00:06:38.000000', 'temperatura', 239.0000, 'ºC'),
	(229256, 121, '2014-03-01 00:06:39.000000', 'temperatura', 309.0000, 'ºC'),
	(229257, 121, '2014-03-01 00:06:40.000000', 'temperatura', 828.0000, 'ºC'),
	(229258, 121, '2014-03-01 00:06:41.000000', 'temperatura', 815.0000, 'ºC'),
	(229259, 121, '2014-03-01 00:06:42.000000', 'temperatura', 389.0000, 'ºC'),
	(229260, 121, '2014-03-01 00:06:43.000000', 'temperatura', 701.0000, 'ºC'),
	(229261, 121, '2014-03-01 00:06:44.000000', 'temperatura', 1139.0000, 'ºC'),
	(229262, 121, '2014-03-01 00:06:45.000000', 'temperatura', 1191.0000, 'ºC'),
	(229263, 121, '2014-03-01 00:06:46.000000', 'temperatura', 140.0000, 'ºC'),
	(229264, 121, '2014-03-01 00:06:47.000000', 'temperatura', 729.0000, 'ºC'),
	(229265, 121, '2014-03-01 00:06:48.000000', 'temperatura', 825.0000, 'ºC'),
	(229266, 121, '2014-03-01 00:06:49.000000', 'temperatura', 736.0000, 'ºC'),
	(229267, 121, '2014-03-01 00:06:50.000000', 'temperatura', 9.0000, 'ºC'),
	(229268, 121, '2014-03-01 00:06:51.000000', 'temperatura', 234.0000, 'ºC'),
	(229269, 121, '2014-03-01 00:06:52.000000', 'temperatura', 1146.0000, 'ºC'),
	(229270, 121, '2014-03-01 00:06:53.000000', 'temperatura', 229.0000, 'ºC'),
	(229271, 121, '2014-03-01 00:06:54.000000', 'temperatura', 108.0000, 'ºC'),
	(229272, 121, '2014-03-01 00:06:55.000000', 'temperatura', 1051.0000, 'ºC'),
	(229273, 121, '2014-03-01 00:06:56.000000', 'temperatura', 135.0000, 'ºC'),
	(229274, 121, '2014-03-01 00:06:57.000000', 'temperatura', 1119.0000, 'ºC'),
	(229275, 121, '2014-03-01 00:06:58.000000', 'temperatura', 393.0000, 'ºC'),
	(229276, 121, '2014-03-01 00:06:59.000000', 'temperatura', 1009.0000, 'ºC'),
	(229277, 121, '2014-03-01 00:07:00.000000', 'temperatura', 267.0000, 'ºC'),
	(229278, 121, '2014-03-01 00:07:01.000000', 'temperatura', 708.0000, 'ºC'),
	(229279, 121, '2014-03-01 00:07:02.000000', 'temperatura', 339.0000, 'ºC'),
	(229280, 121, '2014-03-01 00:07:03.000000', 'temperatura', 772.0000, 'ºC'),
	(229281, 121, '2014-03-01 00:07:04.000000', 'temperatura', 442.0000, 'ºC'),
	(229282, 121, '2014-03-01 00:07:05.000000', 'temperatura', 1094.0000, 'ºC'),
	(229283, 121, '2014-03-01 00:07:06.000000', 'temperatura', 544.0000, 'ºC'),
	(229284, 121, '2014-03-01 00:07:07.000000', 'temperatura', 642.0000, 'ºC'),
	(229285, 121, '2014-03-01 00:07:08.000000', 'temperatura', 375.0000, 'ºC'),
	(229286, 121, '2014-03-01 00:07:09.000000', 'temperatura', 1150.0000, 'ºC'),
	(229287, 121, '2014-03-01 00:07:10.000000', 'temperatura', 1025.0000, 'ºC'),
	(229288, 121, '2014-03-01 00:07:11.000000', 'temperatura', 475.0000, 'ºC'),
	(229289, 121, '2014-03-01 00:07:12.000000', 'temperatura', 500.0000, 'ºC'),
	(229290, 121, '2014-03-01 00:07:13.000000', 'temperatura', 1078.0000, 'ºC'),
	(229291, 121, '2014-03-01 00:07:14.000000', 'temperatura', 290.0000, 'ºC'),
	(229292, 121, '2014-03-01 00:07:15.000000', 'temperatura', 615.0000, 'ºC'),
	(229293, 121, '2014-03-01 00:07:16.000000', 'temperatura', 1008.0000, 'ºC'),
	(229294, 121, '2014-03-01 00:07:17.000000', 'temperatura', 794.0000, 'ºC'),
	(229295, 121, '2014-03-01 00:07:18.000000', 'temperatura', 945.0000, 'ºC'),
	(229296, 121, '2014-03-01 00:07:19.000000', 'temperatura', 1145.0000, 'ºC'),
	(229297, 121, '2014-03-01 00:07:20.000000', 'temperatura', 492.0000, 'ºC'),
	(229298, 121, '2014-03-01 00:07:21.000000', 'temperatura', 224.0000, 'ºC'),
	(229299, 121, '2014-03-01 00:07:22.000000', 'temperatura', 843.0000, 'ºC'),
	(229300, 121, '2014-03-01 00:07:23.000000', 'temperatura', 1147.0000, 'ºC'),
	(229301, 121, '2014-03-01 00:07:24.000000', 'temperatura', 803.0000, 'ºC'),
	(229302, 121, '2014-03-01 00:07:25.000000', 'temperatura', 575.0000, 'ºC'),
	(229303, 121, '2014-03-01 00:07:26.000000', 'temperatura', 468.0000, 'ºC'),
	(229304, 121, '2014-03-01 00:07:27.000000', 'temperatura', 613.0000, 'ºC'),
	(229305, 121, '2014-03-01 00:07:28.000000', 'temperatura', 462.0000, 'ºC'),
	(229306, 121, '2014-03-01 00:07:29.000000', 'temperatura', 470.0000, 'ºC'),
	(229307, 121, '2014-03-01 00:07:30.000000', 'temperatura', 968.0000, 'ºC'),
	(229308, 121, '2014-03-01 00:07:31.000000', 'temperatura', 1028.0000, 'ºC'),
	(229309, 121, '2014-03-01 00:07:32.000000', 'temperatura', 1037.0000, 'ºC'),
	(229310, 121, '2014-03-01 00:07:33.000000', 'temperatura', 900.0000, 'ºC'),
	(229311, 121, '2014-03-01 00:07:34.000000', 'temperatura', 191.0000, 'ºC'),
	(229312, 121, '2014-03-01 00:07:35.000000', 'temperatura', 655.0000, 'ºC'),
	(229313, 121, '2014-03-01 00:07:36.000000', 'temperatura', 302.0000, 'ºC'),
	(229314, 121, '2014-03-01 00:07:37.000000', 'temperatura', 748.0000, 'ºC'),
	(229315, 121, '2014-03-01 00:07:38.000000', 'temperatura', 432.0000, 'ºC'),
	(229316, 121, '2014-03-01 00:07:39.000000', 'temperatura', 1117.0000, 'ºC'),
	(229317, 121, '2014-03-01 00:07:40.000000', 'temperatura', 691.0000, 'ºC'),
	(229318, 121, '2014-03-01 00:07:41.000000', 'temperatura', 106.0000, 'ºC'),
	(229319, 121, '2014-03-01 00:07:42.000000', 'temperatura', 855.0000, 'ºC'),
	(229320, 121, '2014-03-01 00:07:43.000000', 'temperatura', 356.0000, 'ºC'),
	(229321, 121, '2014-03-01 00:07:44.000000', 'temperatura', 418.0000, 'ºC'),
	(229322, 121, '2014-03-01 00:07:45.000000', 'temperatura', 1023.0000, 'ºC'),
	(229323, 121, '2014-03-01 00:07:46.000000', 'temperatura', 262.0000, 'ºC'),
	(229324, 121, '2014-03-01 00:07:47.000000', 'temperatura', 639.0000, 'ºC'),
	(229325, 121, '2014-03-01 00:07:48.000000', 'temperatura', 10.0000, 'ºC'),
	(229326, 121, '2014-03-01 00:07:49.000000', 'temperatura', 536.0000, 'ºC'),
	(229327, 121, '2014-03-01 00:07:50.000000', 'temperatura', 249.0000, 'ºC'),
	(229328, 121, '2014-03-01 00:07:51.000000', 'temperatura', 839.0000, 'ºC'),
	(229329, 121, '2014-03-01 00:07:52.000000', 'temperatura', 1046.0000, 'ºC'),
	(229330, 121, '2014-03-01 00:07:53.000000', 'temperatura', 315.0000, 'ºC'),
	(229331, 121, '2014-03-01 00:07:54.000000', 'temperatura', 838.0000, 'ºC'),
	(229332, 121, '2014-03-01 00:07:55.000000', 'temperatura', 846.0000, 'ºC'),
	(229333, 121, '2014-03-01 00:07:56.000000', 'temperatura', 515.0000, 'ºC'),
	(229334, 121, '2014-03-01 00:07:57.000000', 'temperatura', 40.0000, 'ºC'),
	(229335, 121, '2014-03-01 00:07:58.000000', 'temperatura', 1053.0000, 'ºC'),
	(229336, 121, '2014-03-01 00:07:59.000000', 'temperatura', 347.0000, 'ºC'),
	(229337, 121, '2014-03-01 00:08:00.000000', 'temperatura', 974.0000, 'ºC'),
	(229338, 121, '2014-03-01 00:08:01.000000', 'temperatura', 231.0000, 'ºC'),
	(229339, 121, '2014-03-01 00:08:02.000000', 'temperatura', 632.0000, 'ºC'),
	(229340, 121, '2014-03-01 00:08:03.000000', 'temperatura', 68.0000, 'ºC'),
	(229341, 121, '2014-03-01 00:08:04.000000', 'temperatura', 845.0000, 'ºC'),
	(229342, 121, '2014-03-01 00:08:05.000000', 'temperatura', 424.0000, 'ºC'),
	(229343, 121, '2014-03-01 00:08:06.000000', 'temperatura', 782.0000, 'ºC'),
	(229344, 121, '2014-03-01 00:08:07.000000', 'temperatura', 238.0000, 'ºC'),
	(229345, 121, '2014-03-01 00:08:08.000000', 'temperatura', 48.0000, 'ºC'),
	(229346, 121, '2014-03-01 00:08:09.000000', 'temperatura', 723.0000, 'ºC'),
	(229347, 121, '2014-03-01 00:08:10.000000', 'temperatura', 1072.0000, 'ºC'),
	(229348, 121, '2014-03-01 00:08:11.000000', 'temperatura', 794.0000, 'ºC'),
	(229349, 121, '2014-03-01 00:08:12.000000', 'temperatura', 754.0000, 'ºC'),
	(229350, 121, '2014-03-01 00:08:13.000000', 'temperatura', 187.0000, 'ºC'),
	(229351, 121, '2014-03-01 00:08:14.000000', 'temperatura', 1073.0000, 'ºC'),
	(229352, 121, '2014-03-01 00:08:15.000000', 'temperatura', 4.0000, 'ºC'),
	(229353, 121, '2014-03-01 00:08:16.000000', 'temperatura', 402.0000, 'ºC'),
	(229354, 121, '2014-03-01 00:08:17.000000', 'temperatura', 800.0000, 'ºC'),
	(229355, 121, '2014-03-01 00:08:18.000000', 'temperatura', 393.0000, 'ºC'),
	(229356, 121, '2014-03-01 00:08:19.000000', 'temperatura', 764.0000, 'ºC'),
	(229357, 121, '2014-03-01 00:08:20.000000', 'temperatura', 243.0000, 'ºC'),
	(229358, 121, '2014-03-01 00:08:21.000000', 'temperatura', 126.0000, 'ºC'),
	(229359, 121, '2014-03-01 00:08:22.000000', 'temperatura', 1098.0000, 'ºC'),
	(229360, 121, '2014-03-01 00:08:23.000000', 'temperatura', 313.0000, 'ºC'),
	(229361, 121, '2014-03-01 00:08:24.000000', 'temperatura', 670.0000, 'ºC'),
	(229362, 121, '2014-03-01 00:08:25.000000', 'temperatura', 15.0000, 'ºC'),
	(229363, 121, '2014-03-01 00:08:26.000000', 'temperatura', 463.0000, 'ºC'),
	(229364, 121, '2014-03-01 00:08:27.000000', 'temperatura', 1073.0000, 'ºC'),
	(229365, 121, '2014-03-01 00:08:28.000000', 'temperatura', 373.0000, 'ºC'),
	(229366, 121, '2014-03-01 00:08:29.000000', 'temperatura', 1050.0000, 'ºC'),
	(229367, 121, '2014-03-01 00:08:30.000000', 'temperatura', 528.0000, 'ºC'),
	(229368, 121, '2014-03-01 00:08:31.000000', 'temperatura', 693.0000, 'ºC'),
	(229369, 121, '2014-03-01 00:08:32.000000', 'temperatura', 681.0000, 'ºC'),
	(229370, 121, '2014-03-01 00:08:33.000000', 'temperatura', 125.0000, 'ºC'),
	(229371, 121, '2014-03-01 00:08:34.000000', 'temperatura', 983.0000, 'ºC'),
	(229372, 121, '2014-03-01 00:08:35.000000', 'temperatura', 941.0000, 'ºC'),
	(229373, 121, '2014-03-01 00:08:36.000000', 'temperatura', 556.0000, 'ºC'),
	(229374, 121, '2014-03-01 00:08:37.000000', 'temperatura', 1157.0000, 'ºC'),
	(229375, 121, '2014-03-01 00:08:38.000000', 'temperatura', 520.0000, 'ºC'),
	(229376, 121, '2014-03-01 00:08:39.000000', 'temperatura', 326.0000, 'ºC'),
	(229377, 121, '2014-03-01 00:08:40.000000', 'temperatura', 73.0000, 'ºC'),
	(229378, 121, '2014-03-01 00:08:41.000000', 'temperatura', 589.0000, 'ºC'),
	(229379, 121, '2014-03-01 00:08:42.000000', 'temperatura', 323.0000, 'ºC'),
	(229380, 121, '2014-03-01 00:08:43.000000', 'temperatura', 1050.0000, 'ºC'),
	(229381, 121, '2014-03-01 00:08:44.000000', 'temperatura', 680.0000, 'ºC'),
	(229382, 121, '2014-03-01 00:08:45.000000', 'temperatura', 251.0000, 'ºC'),
	(229383, 121, '2014-03-01 00:08:46.000000', 'temperatura', 417.0000, 'ºC'),
	(229384, 121, '2014-03-01 00:08:47.000000', 'temperatura', 131.0000, 'ºC'),
	(229385, 121, '2014-03-01 00:08:48.000000', 'temperatura', 605.0000, 'ºC'),
	(229386, 121, '2014-03-01 00:08:49.000000', 'temperatura', 234.0000, 'ºC'),
	(229387, 121, '2014-03-01 00:08:50.000000', 'temperatura', 555.0000, 'ºC'),
	(229388, 121, '2014-03-01 00:08:51.000000', 'temperatura', 873.0000, 'ºC'),
	(229389, 121, '2014-03-01 00:08:52.000000', 'temperatura', 301.0000, 'ºC'),
	(229390, 121, '2014-03-01 00:08:53.000000', 'temperatura', 85.0000, 'ºC'),
	(229391, 121, '2014-03-01 00:08:54.000000', 'temperatura', 725.0000, 'ºC'),
	(229392, 121, '2014-03-01 00:08:55.000000', 'temperatura', 971.0000, 'ºC'),
	(229393, 121, '2014-03-01 00:08:56.000000', 'temperatura', 278.0000, 'ºC'),
	(229394, 121, '2014-03-01 00:08:57.000000', 'temperatura', 878.0000, 'ºC'),
	(229395, 121, '2014-03-01 00:08:58.000000', 'temperatura', 1158.0000, 'ºC'),
	(229396, 121, '2014-03-01 00:08:59.000000', 'temperatura', 754.0000, 'ºC'),
	(229397, 121, '2014-03-01 00:09:00.000000', 'temperatura', 299.0000, 'ºC'),
	(229398, 121, '2014-03-01 00:09:01.000000', 'temperatura', 434.0000, 'ºC'),
	(229399, 121, '2014-03-01 00:09:02.000000', 'temperatura', 75.0000, 'ºC'),
	(229400, 121, '2014-03-01 00:09:03.000000', 'temperatura', 270.0000, 'ºC'),
	(229401, 121, '2014-03-01 00:09:04.000000', 'temperatura', 1127.0000, 'ºC'),
	(229402, 121, '2014-03-01 00:09:05.000000', 'temperatura', 23.0000, 'ºC'),
	(229403, 121, '2014-03-01 00:09:06.000000', 'temperatura', 337.0000, 'ºC'),
	(229404, 121, '2014-03-01 00:09:07.000000', 'temperatura', 415.0000, 'ºC'),
	(229405, 121, '2014-03-01 00:09:08.000000', 'temperatura', 1067.0000, 'ºC'),
	(229406, 121, '2014-03-01 00:09:09.000000', 'temperatura', 488.0000, 'ºC'),
	(229407, 121, '2014-03-01 00:09:10.000000', 'temperatura', 442.0000, 'ºC'),
	(229408, 121, '2014-03-01 00:09:11.000000', 'temperatura', 747.0000, 'ºC'),
	(229409, 121, '2014-03-01 00:09:12.000000', 'temperatura', 9.0000, 'ºC'),
	(229410, 121, '2014-03-01 00:09:13.000000', 'temperatura', 204.0000, 'ºC'),
	(229411, 121, '2014-03-01 00:09:14.000000', 'temperatura', 995.0000, 'ºC'),
	(229412, 121, '2014-03-01 00:09:15.000000', 'temperatura', 761.0000, 'ºC'),
	(229413, 121, '2014-03-01 00:09:16.000000', 'temperatura', 822.0000, 'ºC'),
	(229414, 121, '2014-03-01 00:09:17.000000', 'temperatura', 627.0000, 'ºC'),
	(229415, 121, '2014-03-01 00:09:18.000000', 'temperatura', 668.0000, 'ºC'),
	(229416, 121, '2014-03-01 00:09:19.000000', 'temperatura', 259.0000, 'ºC'),
	(229417, 121, '2014-03-01 00:09:20.000000', 'temperatura', 491.0000, 'ºC'),
	(229418, 121, '2014-03-01 00:09:21.000000', 'temperatura', 478.0000, 'ºC'),
	(229419, 121, '2014-03-01 00:09:22.000000', 'temperatura', 918.0000, 'ºC'),
	(229420, 121, '2014-03-01 00:09:23.000000', 'temperatura', 757.0000, 'ºC'),
	(229421, 121, '2014-03-01 00:09:24.000000', 'temperatura', 1031.0000, 'ºC'),
	(229422, 121, '2014-03-01 00:09:25.000000', 'temperatura', 484.0000, 'ºC'),
	(229423, 121, '2014-03-01 00:09:26.000000', 'temperatura', 530.0000, 'ºC'),
	(229424, 121, '2014-03-01 00:09:27.000000', 'temperatura', 1196.0000, 'ºC'),
	(229425, 121, '2014-03-01 00:09:28.000000', 'temperatura', 793.0000, 'ºC'),
	(229426, 121, '2014-03-01 00:09:29.000000', 'temperatura', 375.0000, 'ºC'),
	(229427, 121, '2014-03-01 00:09:30.000000', 'temperatura', 697.0000, 'ºC'),
	(229428, 121, '2014-03-01 00:09:31.000000', 'temperatura', 1163.0000, 'ºC'),
	(229429, 121, '2014-03-01 00:09:32.000000', 'temperatura', 121.0000, 'ºC'),
	(229430, 121, '2014-03-01 00:09:33.000000', 'temperatura', 719.0000, 'ºC'),
	(229431, 121, '2014-03-01 00:09:34.000000', 'temperatura', 831.0000, 'ºC'),
	(229432, 121, '2014-03-01 00:09:35.000000', 'temperatura', 797.0000, 'ºC'),
	(229433, 121, '2014-03-01 00:09:36.000000', 'temperatura', 295.0000, 'ºC'),
	(229434, 121, '2014-03-01 00:09:37.000000', 'temperatura', 285.0000, 'ºC'),
	(229435, 121, '2014-03-01 00:09:38.000000', 'temperatura', 539.0000, 'ºC'),
	(229436, 121, '2014-03-01 00:09:39.000000', 'temperatura', 643.0000, 'ºC'),
	(229437, 121, '2014-03-01 00:09:40.000000', 'temperatura', 396.0000, 'ºC'),
	(229438, 121, '2014-03-01 00:09:41.000000', 'temperatura', 54.0000, 'ºC'),
	(229439, 121, '2014-03-01 00:09:42.000000', 'temperatura', 282.0000, 'ºC'),
	(229440, 121, '2014-03-01 00:09:43.000000', 'temperatura', 46.0000, 'ºC'),
	(229441, 121, '2014-03-01 00:09:44.000000', 'temperatura', 588.0000, 'ºC'),
	(229442, 121, '2014-03-01 00:09:45.000000', 'temperatura', 399.0000, 'ºC'),
	(229443, 121, '2014-03-01 00:09:46.000000', 'temperatura', 235.0000, 'ºC'),
	(229444, 121, '2014-03-01 00:09:47.000000', 'temperatura', 1176.0000, 'ºC'),
	(229445, 121, '2014-03-01 00:09:48.000000', 'temperatura', 375.0000, 'ºC'),
	(229446, 121, '2014-03-01 00:09:49.000000', 'temperatura', 747.0000, 'ºC'),
	(229447, 121, '2014-03-01 00:09:50.000000', 'temperatura', 210.0000, 'ºC'),
	(229448, 121, '2014-03-01 00:09:51.000000', 'temperatura', 11.0000, 'ºC'),
	(229449, 121, '2014-03-01 00:09:52.000000', 'temperatura', 626.0000, 'ºC'),
	(229450, 121, '2014-03-01 00:09:53.000000', 'temperatura', 699.0000, 'ºC'),
	(229451, 121, '2014-03-01 00:09:54.000000', 'temperatura', 416.0000, 'ºC'),
	(229452, 121, '2014-03-01 00:09:55.000000', 'temperatura', 1184.0000, 'ºC'),
	(229453, 121, '2014-03-01 00:09:56.000000', 'temperatura', 1070.0000, 'ºC'),
	(229454, 121, '2014-03-01 00:09:57.000000', 'temperatura', 600.0000, 'ºC'),
	(229455, 121, '2014-03-01 00:09:58.000000', 'temperatura', 991.0000, 'ºC'),
	(229456, 121, '2014-03-01 00:09:59.000000', 'temperatura', 756.0000, 'ºC'),
	(229457, 121, '2014-03-01 00:10:00.000000', 'temperatura', 809.0000, 'ºC'),
	(229458, 121, '2014-03-01 00:10:01.000000', 'temperatura', 574.0000, 'ºC'),
	(229459, 121, '2014-03-01 00:10:02.000000', 'temperatura', 445.0000, 'ºC'),
	(229460, 121, '2014-03-01 00:10:03.000000', 'temperatura', 502.0000, 'ºC'),
	(229461, 121, '2014-03-01 00:10:04.000000', 'temperatura', 1178.0000, 'ºC'),
	(229462, 121, '2014-03-01 00:10:05.000000', 'temperatura', 782.0000, 'ºC'),
	(229463, 121, '2014-03-01 00:10:06.000000', 'temperatura', 378.0000, 'ºC'),
	(229464, 121, '2014-03-01 00:10:07.000000', 'temperatura', 743.0000, 'ºC'),
	(229465, 121, '2014-03-01 00:10:08.000000', 'temperatura', 184.0000, 'ºC'),
	(229466, 121, '2014-03-01 00:10:09.000000', 'temperatura', 1090.0000, 'ºC'),
	(229467, 121, '2014-03-01 00:10:10.000000', 'temperatura', 98.0000, 'ºC'),
	(229468, 121, '2014-03-01 00:10:11.000000', 'temperatura', 821.0000, 'ºC'),
	(229469, 121, '2014-03-01 00:10:12.000000', 'temperatura', 210.0000, 'ºC'),
	(229470, 121, '2014-03-01 00:10:13.000000', 'temperatura', 987.0000, 'ºC'),
	(229471, 121, '2014-03-01 00:10:14.000000', 'temperatura', 708.0000, 'ºC'),
	(229472, 121, '2014-03-01 00:10:15.000000', 'temperatura', 581.0000, 'ºC'),
	(229473, 121, '2014-03-01 00:10:16.000000', 'temperatura', 778.0000, 'ºC'),
	(229474, 121, '2014-03-01 00:10:17.000000', 'temperatura', 948.0000, 'ºC'),
	(229475, 121, '2014-03-01 00:10:18.000000', 'temperatura', 5.0000, 'ºC'),
	(229476, 121, '2014-03-01 00:10:19.000000', 'temperatura', 783.0000, 'ºC'),
	(229477, 121, '2014-03-01 00:10:20.000000', 'temperatura', 301.0000, 'ºC'),
	(229478, 121, '2014-03-01 00:10:21.000000', 'temperatura', 354.0000, 'ºC'),
	(229479, 121, '2014-03-01 00:10:22.000000', 'temperatura', 870.0000, 'ºC'),
	(229480, 121, '2014-03-01 00:10:23.000000', 'temperatura', 886.0000, 'ºC'),
	(229481, 121, '2014-03-01 00:10:24.000000', 'temperatura', 622.0000, 'ºC'),
	(229482, 121, '2014-03-01 00:10:25.000000', 'temperatura', 453.0000, 'ºC'),
	(229483, 121, '2014-03-01 00:10:26.000000', 'temperatura', 401.0000, 'ºC'),
	(229484, 121, '2014-03-01 00:10:27.000000', 'temperatura', 646.0000, 'ºC'),
	(229485, 121, '2014-03-01 00:10:28.000000', 'temperatura', 825.0000, 'ºC'),
	(229486, 121, '2014-03-01 00:10:29.000000', 'temperatura', 989.0000, 'ºC'),
	(229487, 121, '2014-03-01 00:10:30.000000', 'temperatura', 71.0000, 'ºC'),
	(229488, 121, '2014-03-01 00:10:31.000000', 'temperatura', 987.0000, 'ºC'),
	(229489, 121, '2014-03-01 00:10:32.000000', 'temperatura', 1122.0000, 'ºC'),
	(229490, 121, '2014-03-01 00:10:33.000000', 'temperatura', 249.0000, 'ºC'),
	(229491, 121, '2014-03-01 00:10:34.000000', 'temperatura', 281.0000, 'ºC'),
	(229492, 121, '2014-03-01 00:10:35.000000', 'temperatura', 656.0000, 'ºC'),
	(229493, 121, '2014-03-01 00:10:36.000000', 'temperatura', 41.0000, 'ºC'),
	(229494, 121, '2014-03-01 00:10:37.000000', 'temperatura', 635.0000, 'ºC'),
	(229495, 121, '2014-03-01 00:10:38.000000', 'temperatura', 653.0000, 'ºC'),
	(229496, 121, '2014-03-01 00:10:39.000000', 'temperatura', 159.0000, 'ºC'),
	(229497, 121, '2014-03-01 00:10:40.000000', 'temperatura', 38.0000, 'ºC'),
	(229498, 121, '2014-03-01 00:10:41.000000', 'temperatura', 914.0000, 'ºC'),
	(229499, 121, '2014-03-01 00:10:42.000000', 'temperatura', 855.0000, 'ºC'),
	(229500, 121, '2014-03-01 00:10:43.000000', 'temperatura', 335.0000, 'ºC'),
	(229501, 121, '2014-03-01 00:10:44.000000', 'temperatura', 310.0000, 'ºC'),
	(229502, 121, '2014-03-01 00:10:45.000000', 'temperatura', 546.0000, 'ºC'),
	(229503, 121, '2014-03-01 00:10:46.000000', 'temperatura', 601.0000, 'ºC'),
	(229504, 121, '2014-03-01 00:10:47.000000', 'temperatura', 165.0000, 'ºC'),
	(229505, 121, '2014-03-01 00:10:48.000000', 'temperatura', 225.0000, 'ºC'),
	(229506, 121, '2014-03-01 00:10:49.000000', 'temperatura', 630.0000, 'ºC'),
	(229507, 121, '2014-03-01 00:10:50.000000', 'temperatura', 75.0000, 'ºC'),
	(229508, 121, '2014-03-01 00:10:51.000000', 'temperatura', 886.0000, 'ºC'),
	(229509, 121, '2014-03-01 00:10:52.000000', 'temperatura', 606.0000, 'ºC'),
	(229510, 121, '2014-03-01 00:10:53.000000', 'temperatura', 372.0000, 'ºC'),
	(229511, 121, '2014-03-01 00:10:54.000000', 'temperatura', 43.0000, 'ºC'),
	(229512, 121, '2014-03-01 00:10:55.000000', 'temperatura', 298.0000, 'ºC'),
	(229513, 121, '2014-03-01 00:10:56.000000', 'temperatura', 160.0000, 'ºC'),
	(229514, 121, '2014-03-01 00:10:57.000000', 'temperatura', 1109.0000, 'ºC'),
	(229515, 121, '2014-03-01 00:10:58.000000', 'temperatura', 265.0000, 'ºC'),
	(229516, 121, '2014-03-01 00:10:59.000000', 'temperatura', 398.0000, 'ºC'),
	(229517, 121, '2014-03-01 00:11:00.000000', 'temperatura', 1195.0000, 'ºC'),
	(229518, 121, '2014-03-01 00:11:01.000000', 'temperatura', 1181.0000, 'ºC'),
	(229519, 121, '2014-03-01 00:11:02.000000', 'temperatura', 1123.0000, 'ºC'),
	(229520, 121, '2014-03-01 00:11:03.000000', 'temperatura', 871.0000, 'ºC'),
	(229521, 121, '2014-03-01 00:11:04.000000', 'temperatura', 988.0000, 'ºC'),
	(229522, 121, '2014-03-01 00:11:05.000000', 'temperatura', 1126.0000, 'ºC'),
	(229523, 121, '2014-03-01 00:11:06.000000', 'temperatura', 266.0000, 'ºC'),
	(229524, 121, '2014-03-01 00:11:07.000000', 'temperatura', 353.0000, 'ºC'),
	(229525, 121, '2014-03-01 00:11:08.000000', 'temperatura', 969.0000, 'ºC'),
	(229526, 121, '2014-03-01 00:11:09.000000', 'temperatura', 185.0000, 'ºC'),
	(229527, 121, '2014-03-01 00:11:10.000000', 'temperatura', 417.0000, 'ºC'),
	(229528, 121, '2014-03-01 00:11:11.000000', 'temperatura', 334.0000, 'ºC'),
	(229529, 121, '2014-03-01 00:11:12.000000', 'temperatura', 418.0000, 'ºC'),
	(229530, 121, '2014-03-01 00:11:13.000000', 'temperatura', 1087.0000, 'ºC'),
	(229531, 121, '2014-03-01 00:11:14.000000', 'temperatura', 582.0000, 'ºC'),
	(229532, 121, '2014-03-01 00:11:15.000000', 'temperatura', 848.0000, 'ºC'),
	(229533, 121, '2014-03-01 00:11:16.000000', 'temperatura', 96.0000, 'ºC'),
	(229534, 121, '2014-03-01 00:11:17.000000', 'temperatura', 337.0000, 'ºC'),
	(229535, 121, '2014-03-01 00:11:18.000000', 'temperatura', 197.0000, 'ºC'),
	(229536, 121, '2014-03-01 00:11:19.000000', 'temperatura', 1173.0000, 'ºC'),
	(229537, 121, '2014-03-01 00:11:20.000000', 'temperatura', 474.0000, 'ºC'),
	(229538, 121, '2014-03-01 00:11:21.000000', 'temperatura', 55.0000, 'ºC'),
	(229539, 121, '2014-03-01 00:11:22.000000', 'temperatura', 50.0000, 'ºC'),
	(229540, 121, '2014-03-01 00:11:23.000000', 'temperatura', 88.0000, 'ºC'),
	(229541, 121, '2014-03-01 00:11:24.000000', 'temperatura', 288.0000, 'ºC'),
	(229542, 121, '2014-03-01 00:11:25.000000', 'temperatura', 1178.0000, 'ºC'),
	(229543, 121, '2014-03-01 00:11:26.000000', 'temperatura', 228.0000, 'ºC'),
	(229544, 121, '2014-03-01 00:11:27.000000', 'temperatura', 5.0000, 'ºC'),
	(229545, 121, '2014-03-01 00:11:28.000000', 'temperatura', 540.0000, 'ºC'),
	(229546, 121, '2014-03-01 00:11:29.000000', 'temperatura', 285.0000, 'ºC'),
	(229547, 121, '2014-03-01 00:11:30.000000', 'temperatura', 1006.0000, 'ºC'),
	(229548, 121, '2014-03-01 00:11:31.000000', 'temperatura', 574.0000, 'ºC'),
	(229549, 121, '2014-03-01 00:11:32.000000', 'temperatura', 1055.0000, 'ºC'),
	(229550, 121, '2014-03-01 00:11:33.000000', 'temperatura', 1154.0000, 'ºC'),
	(229551, 121, '2014-03-01 00:11:34.000000', 'temperatura', 205.0000, 'ºC'),
	(229552, 121, '2014-03-01 00:11:35.000000', 'temperatura', 1163.0000, 'ºC'),
	(229553, 121, '2014-03-01 00:11:36.000000', 'temperatura', 400.0000, 'ºC'),
	(229554, 121, '2014-03-01 00:11:37.000000', 'temperatura', 912.0000, 'ºC'),
	(229555, 121, '2014-03-01 00:11:38.000000', 'temperatura', 961.0000, 'ºC'),
	(229556, 121, '2014-03-01 00:11:39.000000', 'temperatura', 869.0000, 'ºC'),
	(229557, 121, '2014-03-01 00:11:40.000000', 'temperatura', 262.0000, 'ºC'),
	(229558, 121, '2014-03-01 00:11:41.000000', 'temperatura', 1103.0000, 'ºC'),
	(229559, 121, '2014-03-01 00:11:42.000000', 'temperatura', 1130.0000, 'ºC'),
	(229560, 121, '2014-03-01 00:11:43.000000', 'temperatura', 1141.0000, 'ºC'),
	(229561, 121, '2014-03-01 00:11:44.000000', 'temperatura', 1116.0000, 'ºC'),
	(229562, 121, '2014-03-01 00:11:45.000000', 'temperatura', 956.0000, 'ºC'),
	(229563, 121, '2014-03-01 00:11:46.000000', 'temperatura', 235.0000, 'ºC'),
	(229564, 121, '2014-03-01 00:11:47.000000', 'temperatura', 708.0000, 'ºC'),
	(229565, 121, '2014-03-01 00:11:48.000000', 'temperatura', 435.0000, 'ºC'),
	(229566, 121, '2014-03-01 00:11:49.000000', 'temperatura', 49.0000, 'ºC'),
	(229567, 121, '2014-03-01 00:11:50.000000', 'temperatura', 143.0000, 'ºC'),
	(229568, 121, '2014-03-01 00:11:51.000000', 'temperatura', 567.0000, 'ºC'),
	(229569, 121, '2014-03-01 00:11:52.000000', 'temperatura', 6.0000, 'ºC'),
	(229570, 121, '2014-03-01 00:11:53.000000', 'temperatura', 732.0000, 'ºC'),
	(229571, 121, '2014-03-01 00:11:54.000000', 'temperatura', 40.0000, 'ºC'),
	(229572, 121, '2014-03-01 00:11:55.000000', 'temperatura', 405.0000, 'ºC'),
	(229573, 121, '2014-03-01 00:11:56.000000', 'temperatura', 704.0000, 'ºC'),
	(229574, 121, '2014-03-01 00:11:57.000000', 'temperatura', 1108.0000, 'ºC'),
	(229575, 121, '2014-03-01 00:11:58.000000', 'temperatura', 1030.0000, 'ºC'),
	(229576, 121, '2014-03-01 00:11:59.000000', 'temperatura', 623.0000, 'ºC'),
	(229577, 121, '2014-03-01 00:12:00.000000', 'temperatura', 28.0000, 'ºC'),
	(229578, 121, '2014-03-01 00:12:01.000000', 'temperatura', 672.0000, 'ºC'),
	(229579, 121, '2014-03-01 00:12:02.000000', 'temperatura', 876.0000, 'ºC'),
	(229580, 121, '2014-03-01 00:12:03.000000', 'temperatura', 1164.0000, 'ºC'),
	(229581, 121, '2014-03-01 00:12:04.000000', 'temperatura', 794.0000, 'ºC'),
	(229582, 121, '2014-03-01 00:12:05.000000', 'temperatura', 478.0000, 'ºC'),
	(229583, 121, '2014-03-01 00:12:06.000000', 'temperatura', 8.0000, 'ºC'),
	(229584, 121, '2014-03-01 00:12:07.000000', 'temperatura', 1007.0000, 'ºC'),
	(229585, 121, '2014-03-01 00:12:08.000000', 'temperatura', 211.0000, 'ºC'),
	(229586, 121, '2014-03-01 00:12:09.000000', 'temperatura', 436.0000, 'ºC'),
	(229587, 121, '2014-03-01 00:12:10.000000', 'temperatura', 348.0000, 'ºC'),
	(229588, 121, '2014-03-01 00:12:11.000000', 'temperatura', 431.0000, 'ºC'),
	(229589, 121, '2014-03-01 00:12:12.000000', 'temperatura', 1114.0000, 'ºC'),
	(229590, 121, '2014-03-01 00:12:13.000000', 'temperatura', 674.0000, 'ºC'),
	(229591, 121, '2014-03-01 00:12:14.000000', 'temperatura', 31.0000, 'ºC'),
	(229592, 121, '2014-03-01 00:12:15.000000', 'temperatura', 534.0000, 'ºC'),
	(229593, 121, '2014-03-01 00:12:16.000000', 'temperatura', 175.0000, 'ºC'),
	(229594, 121, '2014-03-01 00:12:17.000000', 'temperatura', 476.0000, 'ºC'),
	(229595, 121, '2014-03-01 00:12:18.000000', 'temperatura', 656.0000, 'ºC'),
	(229596, 121, '2014-03-01 00:12:19.000000', 'temperatura', 650.0000, 'ºC'),
	(229597, 121, '2014-03-01 00:12:20.000000', 'temperatura', 85.0000, 'ºC'),
	(229598, 121, '2014-03-01 00:12:21.000000', 'temperatura', 876.0000, 'ºC'),
	(229599, 121, '2014-03-01 00:12:22.000000', 'temperatura', 526.0000, 'ºC'),
	(229600, 121, '2014-03-01 00:12:23.000000', 'temperatura', 0.0000, 'ºC'),
	(229601, 121, '2014-03-01 00:12:24.000000', 'temperatura', 824.0000, 'ºC'),
	(229602, 121, '2014-03-01 00:12:25.000000', 'temperatura', 521.0000, 'ºC'),
	(229603, 121, '2014-03-01 00:12:26.000000', 'temperatura', 134.0000, 'ºC'),
	(229604, 121, '2014-03-01 00:12:27.000000', 'temperatura', 305.0000, 'ºC'),
	(229605, 121, '2014-03-01 00:12:28.000000', 'temperatura', 1127.0000, 'ºC'),
	(229606, 121, '2014-03-01 00:12:29.000000', 'temperatura', 1118.0000, 'ºC'),
	(229607, 121, '2014-03-01 00:12:30.000000', 'temperatura', 1010.0000, 'ºC'),
	(229608, 121, '2014-03-01 00:12:31.000000', 'temperatura', 495.0000, 'ºC'),
	(229609, 121, '2014-03-01 00:12:32.000000', 'temperatura', 645.0000, 'ºC'),
	(229610, 121, '2014-03-01 00:12:33.000000', 'temperatura', 543.0000, 'ºC'),
	(229611, 121, '2014-03-01 00:12:34.000000', 'temperatura', 781.0000, 'ºC'),
	(229612, 121, '2014-03-01 00:12:35.000000', 'temperatura', 1076.0000, 'ºC'),
	(229613, 121, '2014-03-01 00:12:36.000000', 'temperatura', 635.0000, 'ºC'),
	(229614, 121, '2014-03-01 00:12:37.000000', 'temperatura', 1150.0000, 'ºC'),
	(229615, 121, '2014-03-01 00:12:38.000000', 'temperatura', 246.0000, 'ºC'),
	(229616, 121, '2014-03-01 00:12:39.000000', 'temperatura', 179.0000, 'ºC'),
	(229617, 121, '2014-03-01 00:12:40.000000', 'temperatura', 159.0000, 'ºC'),
	(229618, 121, '2014-03-01 00:12:41.000000', 'temperatura', 257.0000, 'ºC'),
	(229619, 121, '2014-03-01 00:12:42.000000', 'temperatura', 807.0000, 'ºC'),
	(229620, 121, '2014-03-01 00:12:43.000000', 'temperatura', 868.0000, 'ºC'),
	(229621, 121, '2014-03-01 00:12:44.000000', 'temperatura', 717.0000, 'ºC'),
	(229622, 121, '2014-03-01 00:12:45.000000', 'temperatura', 984.0000, 'ºC'),
	(229623, 121, '2014-03-01 00:12:46.000000', 'temperatura', 367.0000, 'ºC'),
	(229624, 121, '2014-03-01 00:12:47.000000', 'temperatura', 85.0000, 'ºC'),
	(229625, 121, '2014-03-01 00:12:48.000000', 'temperatura', 523.0000, 'ºC'),
	(229626, 121, '2014-03-01 00:12:49.000000', 'temperatura', 1159.0000, 'ºC'),
	(229627, 121, '2014-03-01 00:12:50.000000', 'temperatura', 629.0000, 'ºC'),
	(229628, 121, '2014-03-01 00:12:51.000000', 'temperatura', 867.0000, 'ºC'),
	(229629, 121, '2014-03-01 00:12:52.000000', 'temperatura', 49.0000, 'ºC'),
	(229630, 121, '2014-03-01 00:12:53.000000', 'temperatura', 43.0000, 'ºC'),
	(229631, 121, '2014-03-01 00:12:54.000000', 'temperatura', 70.0000, 'ºC'),
	(229632, 121, '2014-03-01 00:12:55.000000', 'temperatura', 223.0000, 'ºC'),
	(229633, 121, '2014-03-01 00:12:56.000000', 'temperatura', 904.0000, 'ºC'),
	(229634, 121, '2014-03-01 00:12:57.000000', 'temperatura', 251.0000, 'ºC'),
	(229635, 121, '2014-03-01 00:12:58.000000', 'temperatura', 944.0000, 'ºC'),
	(229636, 121, '2014-03-01 00:12:59.000000', 'temperatura', 369.0000, 'ºC'),
	(229637, 121, '2014-03-01 00:13:00.000000', 'temperatura', 214.0000, 'ºC'),
	(229638, 121, '2014-03-01 00:13:01.000000', 'temperatura', 1164.0000, 'ºC'),
	(229639, 121, '2014-03-01 00:13:02.000000', 'temperatura', 379.0000, 'ºC'),
	(229640, 121, '2014-03-01 00:13:03.000000', 'temperatura', 801.0000, 'ºC'),
	(229641, 121, '2014-03-01 00:13:04.000000', 'temperatura', 468.0000, 'ºC'),
	(229642, 121, '2014-03-01 00:13:05.000000', 'temperatura', 1137.0000, 'ºC'),
	(229643, 121, '2014-03-01 00:13:06.000000', 'temperatura', 681.0000, 'ºC'),
	(229644, 121, '2014-03-01 00:13:07.000000', 'temperatura', 1197.0000, 'ºC'),
	(229645, 121, '2014-03-01 00:13:08.000000', 'temperatura', 342.0000, 'ºC'),
	(229646, 121, '2014-03-01 00:13:09.000000', 'temperatura', 518.0000, 'ºC'),
	(229647, 121, '2014-03-01 00:13:10.000000', 'temperatura', 367.0000, 'ºC'),
	(229648, 121, '2014-03-01 00:13:11.000000', 'temperatura', 282.0000, 'ºC'),
	(229649, 121, '2014-03-01 00:13:12.000000', 'temperatura', 309.0000, 'ºC'),
	(229650, 121, '2014-03-01 00:13:13.000000', 'temperatura', 701.0000, 'ºC'),
	(229651, 121, '2014-03-01 00:13:14.000000', 'temperatura', 177.0000, 'ºC'),
	(229652, 121, '2014-03-01 00:13:15.000000', 'temperatura', 1181.0000, 'ºC'),
	(229653, 121, '2014-03-01 00:13:16.000000', 'temperatura', 576.0000, 'ºC'),
	(229654, 121, '2014-03-01 00:13:17.000000', 'temperatura', 537.0000, 'ºC'),
	(229655, 121, '2014-03-01 00:13:18.000000', 'temperatura', 958.0000, 'ºC'),
	(229656, 121, '2014-03-01 00:13:19.000000', 'temperatura', 778.0000, 'ºC'),
	(229657, 121, '2014-03-01 00:13:20.000000', 'temperatura', 1019.0000, 'ºC'),
	(229658, 121, '2014-03-01 00:13:21.000000', 'temperatura', 361.0000, 'ºC'),
	(229659, 121, '2014-03-01 00:13:22.000000', 'temperatura', 1149.0000, 'ºC'),
	(229660, 121, '2014-03-01 00:13:23.000000', 'temperatura', 1063.0000, 'ºC'),
	(229661, 121, '2014-03-01 00:13:24.000000', 'temperatura', 668.0000, 'ºC'),
	(229662, 121, '2014-03-01 00:13:25.000000', 'temperatura', 151.0000, 'ºC'),
	(229663, 121, '2014-03-01 00:13:26.000000', 'temperatura', 1150.0000, 'ºC'),
	(229664, 121, '2014-03-01 00:13:27.000000', 'temperatura', 500.0000, 'ºC'),
	(229665, 121, '2014-03-01 00:13:28.000000', 'temperatura', 248.0000, 'ºC'),
	(229666, 121, '2014-03-01 00:13:29.000000', 'temperatura', 941.0000, 'ºC'),
	(229667, 121, '2014-03-01 00:13:30.000000', 'temperatura', 364.0000, 'ºC'),
	(229668, 121, '2014-03-01 00:13:31.000000', 'temperatura', 195.0000, 'ºC'),
	(229669, 121, '2014-03-01 00:13:32.000000', 'temperatura', 1085.0000, 'ºC'),
	(229670, 121, '2014-03-01 00:13:33.000000', 'temperatura', 41.0000, 'ºC'),
	(229671, 121, '2014-03-01 00:13:34.000000', 'temperatura', 551.0000, 'ºC'),
	(229672, 121, '2014-03-01 00:13:35.000000', 'temperatura', 231.0000, 'ºC'),
	(229673, 121, '2014-03-01 00:13:36.000000', 'temperatura', 704.0000, 'ºC'),
	(229674, 121, '2014-03-01 00:13:37.000000', 'temperatura', 427.0000, 'ºC'),
	(229675, 121, '2014-03-01 00:13:38.000000', 'temperatura', 25.0000, 'ºC'),
	(229676, 121, '2014-03-01 00:13:39.000000', 'temperatura', 43.0000, 'ºC'),
	(229677, 121, '2014-03-01 00:13:40.000000', 'temperatura', 139.0000, 'ºC'),
	(229678, 121, '2014-03-01 00:13:41.000000', 'temperatura', 566.0000, 'ºC'),
	(229679, 121, '2014-03-01 00:13:42.000000', 'temperatura', 16.0000, 'ºC'),
	(229680, 121, '2014-03-01 00:13:43.000000', 'temperatura', 780.0000, 'ºC'),
	(229681, 121, '2014-03-01 00:13:44.000000', 'temperatura', 253.0000, 'ºC'),
	(229682, 121, '2014-03-01 00:13:45.000000', 'temperatura', 128.0000, 'ºC'),
	(229683, 121, '2014-03-01 00:13:46.000000', 'temperatura', 1079.0000, 'ºC'),
	(229684, 121, '2014-03-01 00:13:47.000000', 'temperatura', 213.0000, 'ºC'),
	(229685, 121, '2014-03-01 00:13:48.000000', 'temperatura', 230.0000, 'ºC'),
	(229686, 121, '2014-03-01 00:13:49.000000', 'temperatura', 509.0000, 'ºC'),
	(229687, 121, '2014-03-01 00:13:50.000000', 'temperatura', 658.0000, 'ºC'),
	(229688, 121, '2014-03-01 00:13:51.000000', 'temperatura', 561.0000, 'ºC'),
	(229689, 121, '2014-03-01 00:13:52.000000', 'temperatura', 831.0000, 'ºC'),
	(229690, 121, '2014-03-01 00:13:53.000000', 'temperatura', 75.0000, 'ºC'),
	(229691, 121, '2014-03-01 00:13:54.000000', 'temperatura', 282.0000, 'ºC'),
	(229692, 121, '2014-03-01 00:13:55.000000', 'temperatura', 1183.0000, 'ºC'),
	(229693, 121, '2014-03-01 00:13:56.000000', 'temperatura', 273.0000, 'ºC'),
	(229694, 121, '2014-03-01 00:13:57.000000', 'temperatura', 215.0000, 'ºC'),
	(229695, 121, '2014-03-01 00:13:58.000000', 'temperatura', 254.0000, 'ºC'),
	(229696, 121, '2014-03-01 00:13:59.000000', 'temperatura', 629.0000, 'ºC'),
	(229697, 121, '2014-03-01 00:14:00.000000', 'temperatura', 1183.0000, 'ºC'),
	(229698, 121, '2014-03-01 00:14:01.000000', 'temperatura', 429.0000, 'ºC'),
	(229699, 121, '2014-03-01 00:14:02.000000', 'temperatura', 994.0000, 'ºC'),
	(229700, 121, '2014-03-01 00:14:03.000000', 'temperatura', 83.0000, 'ºC'),
	(229701, 121, '2014-03-01 00:14:04.000000', 'temperatura', 1037.0000, 'ºC'),
	(229702, 121, '2014-03-01 00:14:05.000000', 'temperatura', 134.0000, 'ºC'),
	(229703, 121, '2014-03-01 00:14:06.000000', 'temperatura', 1160.0000, 'ºC'),
	(229704, 121, '2014-03-01 00:14:07.000000', 'temperatura', 600.0000, 'ºC'),
	(229705, 121, '2014-03-01 00:14:08.000000', 'temperatura', 721.0000, 'ºC'),
	(229706, 121, '2014-03-01 00:14:09.000000', 'temperatura', 605.0000, 'ºC'),
	(229707, 121, '2014-03-01 00:14:10.000000', 'temperatura', 863.0000, 'ºC'),
	(229708, 121, '2014-03-01 00:14:11.000000', 'temperatura', 99.0000, 'ºC'),
	(229709, 121, '2014-03-01 00:14:12.000000', 'temperatura', 309.0000, 'ºC'),
	(229710, 121, '2014-03-01 00:14:13.000000', 'temperatura', 47.0000, 'ºC'),
	(229711, 121, '2014-03-01 00:14:14.000000', 'temperatura', 509.0000, 'ºC'),
	(229712, 121, '2014-03-01 00:14:15.000000', 'temperatura', 4.0000, 'ºC'),
	(229713, 121, '2014-03-01 00:14:16.000000', 'temperatura', 894.0000, 'ºC'),
	(229714, 121, '2014-03-01 00:14:17.000000', 'temperatura', 858.0000, 'ºC'),
	(229715, 121, '2014-03-01 00:14:18.000000', 'temperatura', 411.0000, 'ºC'),
	(229716, 121, '2014-03-01 00:14:19.000000', 'temperatura', 679.0000, 'ºC'),
	(229717, 121, '2014-03-01 00:14:20.000000', 'temperatura', 962.0000, 'ºC'),
	(229718, 121, '2014-03-01 00:14:21.000000', 'temperatura', 374.0000, 'ºC'),
	(229719, 121, '2014-03-01 00:14:22.000000', 'temperatura', 186.0000, 'ºC'),
	(229720, 121, '2014-03-01 00:14:23.000000', 'temperatura', 1008.0000, 'ºC'),
	(229721, 121, '2014-03-01 00:14:24.000000', 'temperatura', 884.0000, 'ºC'),
	(229722, 121, '2014-03-01 00:14:25.000000', 'temperatura', 196.0000, 'ºC'),
	(229723, 121, '2014-03-01 00:14:26.000000', 'temperatura', 728.0000, 'ºC'),
	(229724, 121, '2014-03-01 00:14:27.000000', 'temperatura', 654.0000, 'ºC'),
	(229725, 121, '2014-03-01 00:14:28.000000', 'temperatura', 1088.0000, 'ºC'),
	(229726, 121, '2014-03-01 00:14:29.000000', 'temperatura', 1075.0000, 'ºC'),
	(229727, 121, '2014-03-01 00:14:30.000000', 'temperatura', 911.0000, 'ºC'),
	(229728, 121, '2014-03-01 00:14:31.000000', 'temperatura', 134.0000, 'ºC'),
	(229729, 121, '2014-03-01 00:14:32.000000', 'temperatura', 335.0000, 'ºC'),
	(229730, 121, '2014-03-01 00:14:33.000000', 'temperatura', 74.0000, 'ºC'),
	(229731, 121, '2014-03-01 00:14:34.000000', 'temperatura', 568.0000, 'ºC'),
	(229732, 121, '2014-03-01 00:14:35.000000', 'temperatura', 216.0000, 'ºC'),
	(229733, 121, '2014-03-01 00:14:36.000000', 'temperatura', 575.0000, 'ºC'),
	(229734, 121, '2014-03-01 00:14:37.000000', 'temperatura', 1031.0000, 'ºC'),
	(229735, 121, '2014-03-01 00:14:38.000000', 'temperatura', 1029.0000, 'ºC'),
	(229736, 121, '2014-03-01 00:14:39.000000', 'temperatura', 851.0000, 'ºC'),
	(229737, 121, '2014-03-01 00:14:40.000000', 'temperatura', 1169.0000, 'ºC'),
	(229738, 121, '2014-03-01 00:14:41.000000', 'temperatura', 891.0000, 'ºC'),
	(229739, 121, '2014-03-01 00:14:42.000000', 'temperatura', 951.0000, 'ºC'),
	(229740, 121, '2014-03-01 00:14:43.000000', 'temperatura', 883.0000, 'ºC'),
	(229741, 121, '2014-03-01 00:14:44.000000', 'temperatura', 364.0000, 'ºC'),
	(229742, 121, '2014-03-01 00:14:45.000000', 'temperatura', 368.0000, 'ºC'),
	(229743, 121, '2014-03-01 00:14:46.000000', 'temperatura', 748.0000, 'ºC'),
	(229744, 121, '2014-03-01 00:14:47.000000', 'temperatura', 240.0000, 'ºC'),
	(229745, 121, '2014-03-01 00:14:48.000000', 'temperatura', 153.0000, 'ºC'),
	(229746, 121, '2014-03-01 00:14:49.000000', 'temperatura', 48.0000, 'ºC'),
	(229747, 121, '2014-03-01 00:14:50.000000', 'temperatura', 980.0000, 'ºC'),
	(229748, 121, '2014-03-01 00:14:51.000000', 'temperatura', 1159.0000, 'ºC'),
	(229749, 121, '2014-03-01 00:14:52.000000', 'temperatura', 453.0000, 'ºC'),
	(229750, 121, '2014-03-01 00:14:53.000000', 'temperatura', 1190.0000, 'ºC'),
	(229751, 121, '2014-03-01 00:14:54.000000', 'temperatura', 991.0000, 'ºC'),
	(229752, 121, '2014-03-01 00:14:55.000000', 'temperatura', 184.0000, 'ºC'),
	(229753, 121, '2014-03-01 00:14:56.000000', 'temperatura', 347.0000, 'ºC'),
	(229754, 121, '2014-03-01 00:14:57.000000', 'temperatura', 1182.0000, 'ºC'),
	(229755, 121, '2014-03-01 00:14:58.000000', 'temperatura', 73.0000, 'ºC'),
	(229756, 121, '2014-03-01 00:14:59.000000', 'temperatura', 419.0000, 'ºC'),
	(229757, 121, '2014-03-01 00:15:00.000000', 'temperatura', 678.0000, 'ºC'),
	(229758, 121, '2014-03-01 00:15:01.000000', 'temperatura', 932.0000, 'ºC'),
	(229759, 121, '2014-03-01 00:15:02.000000', 'temperatura', 228.0000, 'ºC'),
	(229760, 121, '2014-03-01 00:15:03.000000', 'temperatura', 744.0000, 'ºC'),
	(229761, 121, '2014-03-01 00:15:04.000000', 'temperatura', 638.0000, 'ºC'),
	(229762, 121, '2014-03-01 00:15:05.000000', 'temperatura', 955.0000, 'ºC'),
	(229763, 121, '2014-03-01 00:15:06.000000', 'temperatura', 463.0000, 'ºC'),
	(229764, 121, '2014-03-01 00:15:07.000000', 'temperatura', 652.0000, 'ºC'),
	(229765, 121, '2014-03-01 00:15:08.000000', 'temperatura', 671.0000, 'ºC'),
	(229766, 121, '2014-03-01 00:15:09.000000', 'temperatura', 198.0000, 'ºC'),
	(229767, 121, '2014-03-01 00:15:10.000000', 'temperatura', 179.0000, 'ºC'),
	(229768, 121, '2014-03-01 00:15:11.000000', 'temperatura', 300.0000, 'ºC'),
	(229769, 121, '2014-03-01 00:15:12.000000', 'temperatura', 963.0000, 'ºC'),
	(229770, 121, '2014-03-01 00:15:13.000000', 'temperatura', 315.0000, 'ºC'),
	(229771, 121, '2014-03-01 00:15:14.000000', 'temperatura', 1090.0000, 'ºC'),
	(229772, 121, '2014-03-01 00:15:15.000000', 'temperatura', 902.0000, 'ºC'),
	(229773, 121, '2014-03-01 00:15:16.000000', 'temperatura', 41.0000, 'ºC'),
	(229774, 121, '2014-03-01 00:15:17.000000', 'temperatura', 1098.0000, 'ºC'),
	(229775, 121, '2014-03-01 00:15:18.000000', 'temperatura', 568.0000, 'ºC'),
	(229776, 121, '2014-03-01 00:15:19.000000', 'temperatura', 748.0000, 'ºC'),
	(229777, 121, '2014-03-01 00:15:20.000000', 'temperatura', 838.0000, 'ºC'),
	(229778, 121, '2014-03-01 00:15:21.000000', 'temperatura', 743.0000, 'ºC'),
	(229779, 121, '2014-03-01 00:15:22.000000', 'temperatura', 3.0000, 'ºC'),
	(229780, 121, '2014-03-01 00:15:23.000000', 'temperatura', 185.0000, 'ºC'),
	(229781, 121, '2014-03-01 00:15:24.000000', 'temperatura', 916.0000, 'ºC'),
	(229782, 121, '2014-03-01 00:15:25.000000', 'temperatura', 428.0000, 'ºC'),
	(229783, 121, '2014-03-01 00:15:26.000000', 'temperatura', 592.0000, 'ºC'),
	(229784, 121, '2014-03-01 00:15:27.000000', 'temperatura', 478.0000, 'ºC'),
	(229785, 121, '2014-03-01 00:15:28.000000', 'temperatura', 613.0000, 'ºC'),
	(229786, 121, '2014-03-01 00:15:29.000000', 'temperatura', 433.0000, 'ºC'),
	(229787, 121, '2014-03-01 00:15:30.000000', 'temperatura', 325.0000, 'ºC'),
	(229788, 121, '2014-03-01 00:15:31.000000', 'temperatura', 327.0000, 'ºC'),
	(229789, 121, '2014-03-01 00:15:32.000000', 'temperatura', 659.0000, 'ºC'),
	(229790, 121, '2014-03-01 00:15:33.000000', 'temperatura', 1115.0000, 'ºC'),
	(229791, 121, '2014-03-01 00:15:34.000000', 'temperatura', 1199.0000, 'ºC'),
	(229792, 121, '2014-03-01 00:15:35.000000', 'temperatura', 250.0000, 'ºC'),
	(229793, 121, '2014-03-01 00:15:36.000000', 'temperatura', 53.0000, 'ºC'),
	(229794, 121, '2014-03-01 00:15:37.000000', 'temperatura', 718.0000, 'ºC'),
	(229795, 121, '2014-03-01 00:15:38.000000', 'temperatura', 1029.0000, 'ºC'),
	(229796, 121, '2014-03-01 00:15:39.000000', 'temperatura', 592.0000, 'ºC'),
	(229797, 121, '2014-03-01 00:15:40.000000', 'temperatura', 1075.0000, 'ºC'),
	(229798, 121, '2014-03-01 00:15:41.000000', 'temperatura', 1199.0000, 'ºC'),
	(229799, 121, '2014-03-01 00:15:42.000000', 'temperatura', 371.0000, 'ºC'),
	(229800, 121, '2014-03-01 00:15:43.000000', 'temperatura', 660.0000, 'ºC'),
	(229801, 121, '2014-03-01 00:15:44.000000', 'temperatura', 985.0000, 'ºC'),
	(229802, 121, '2014-03-01 00:15:45.000000', 'temperatura', 546.0000, 'ºC'),
	(229803, 121, '2014-03-01 00:15:46.000000', 'temperatura', 974.0000, 'ºC'),
	(229804, 121, '2014-03-01 00:15:47.000000', 'temperatura', 832.0000, 'ºC'),
	(229805, 121, '2014-03-01 00:15:48.000000', 'temperatura', 42.0000, 'ºC'),
	(229806, 121, '2014-03-01 00:15:49.000000', 'temperatura', 112.0000, 'ºC'),
	(229807, 121, '2014-03-01 00:15:50.000000', 'temperatura', 434.0000, 'ºC'),
	(229808, 121, '2014-03-01 00:15:51.000000', 'temperatura', 637.0000, 'ºC'),
	(229809, 121, '2014-03-01 00:15:52.000000', 'temperatura', 683.0000, 'ºC'),
	(229810, 121, '2014-03-01 00:15:53.000000', 'temperatura', 303.0000, 'ºC'),
	(229811, 121, '2014-03-01 00:15:54.000000', 'temperatura', 666.0000, 'ºC'),
	(229812, 121, '2014-03-01 00:15:55.000000', 'temperatura', 24.0000, 'ºC'),
	(229813, 121, '2014-03-01 00:15:56.000000', 'temperatura', 521.0000, 'ºC'),
	(229814, 121, '2014-03-01 00:15:57.000000', 'temperatura', 133.0000, 'ºC'),
	(229815, 121, '2014-03-01 00:15:58.000000', 'temperatura', 304.0000, 'ºC'),
	(229816, 121, '2014-03-01 00:15:59.000000', 'temperatura', 1122.0000, 'ºC'),
	(229817, 121, '2014-03-01 00:16:00.000000', 'temperatura', 1099.0000, 'ºC'),
	(229818, 121, '2014-03-01 00:16:01.000000', 'temperatura', 930.0000, 'ºC'),
	(229819, 121, '2014-03-01 00:16:02.000000', 'temperatura', 151.0000, 'ºC'),
	(229820, 121, '2014-03-01 00:16:03.000000', 'temperatura', 367.0000, 'ºC'),
	(229821, 121, '2014-03-01 00:16:04.000000', 'temperatura', 184.0000, 'ºC'),
	(229822, 121, '2014-03-01 00:16:05.000000', 'temperatura', 1019.0000, 'ºC'),
	(229823, 121, '2014-03-01 00:16:06.000000', 'temperatura', 945.0000, 'ºC'),
	(229824, 121, '2014-03-01 00:16:07.000000', 'temperatura', 466.0000, 'ºC'),
	(229825, 121, '2014-03-01 00:16:08.000000', 'temperatura', 698.0000, 'ºC'),
	(229826, 121, '2014-03-01 00:16:09.000000', 'temperatura', 892.0000, 'ºC'),
	(229827, 121, '2014-03-01 00:16:10.000000', 'temperatura', 1165.0000, 'ºC'),
	(229828, 121, '2014-03-01 00:16:11.000000', 'temperatura', 750.0000, 'ºC'),
	(229829, 121, '2014-03-01 00:16:12.000000', 'temperatura', 256.0000, 'ºC'),
	(229830, 121, '2014-03-01 00:16:13.000000', 'temperatura', 232.0000, 'ºC'),
	(229831, 121, '2014-03-01 00:16:14.000000', 'temperatura', 392.0000, 'ºC'),
	(229832, 121, '2014-03-01 00:16:15.000000', 'temperatura', 62.0000, 'ºC'),
	(229833, 121, '2014-03-01 00:16:16.000000', 'temperatura', 336.0000, 'ºC'),
	(229834, 121, '2014-03-01 00:16:17.000000', 'temperatura', 296.0000, 'ºC'),
	(229835, 121, '2014-03-01 00:16:18.000000', 'temperatura', 473.0000, 'ºC'),
	(229836, 121, '2014-03-01 00:16:19.000000', 'temperatura', 277.0000, 'ºC'),
	(229837, 121, '2014-03-01 00:16:20.000000', 'temperatura', 1168.0000, 'ºC'),
	(229838, 121, '2014-03-01 00:16:21.000000', 'temperatura', 208.0000, 'ºC'),
	(229839, 121, '2014-03-01 00:16:22.000000', 'temperatura', 1135.0000, 'ºC'),
	(229840, 121, '2014-03-01 00:16:23.000000', 'temperatura', 251.0000, 'ºC'),
	(229841, 121, '2014-03-01 00:16:24.000000', 'temperatura', 251.0000, 'ºC'),
	(229842, 121, '2014-03-01 00:16:25.000000', 'temperatura', 504.0000, 'ºC'),
	(229843, 121, '2014-03-01 00:16:26.000000', 'temperatura', 565.0000, 'ºC'),
	(229844, 121, '2014-03-01 00:16:27.000000', 'temperatura', 116.0000, 'ºC'),
	(229845, 121, '2014-03-01 00:16:28.000000', 'temperatura', 85.0000, 'ºC'),
	(229846, 121, '2014-03-01 00:16:29.000000', 'temperatura', 79.0000, 'ºC'),
	(229847, 121, '2014-03-01 00:16:30.000000', 'temperatura', 139.0000, 'ºC'),
	(229848, 121, '2014-03-01 00:16:31.000000', 'temperatura', 459.0000, 'ºC'),
	(229849, 121, '2014-03-01 00:16:32.000000', 'temperatura', 680.0000, 'ºC'),
	(229850, 121, '2014-03-01 00:16:33.000000', 'temperatura', 821.0000, 'ºC'),
	(229851, 121, '2014-03-01 00:16:34.000000', 'temperatura', 867.0000, 'ºC'),
	(229852, 121, '2014-03-01 00:16:35.000000', 'temperatura', 671.0000, 'ºC'),
	(229853, 121, '2014-03-01 00:16:36.000000', 'temperatura', 756.0000, 'ºC'),
	(229854, 121, '2014-03-01 00:16:37.000000', 'temperatura', 569.0000, 'ºC'),
	(229855, 121, '2014-03-01 00:16:38.000000', 'temperatura', 576.0000, 'ºC'),
	(229856, 121, '2014-03-01 00:16:39.000000', 'temperatura', 1175.0000, 'ºC'),
	(229857, 121, '2014-03-01 00:16:40.000000', 'temperatura', 545.0000, 'ºC'),
	(229858, 121, '2014-03-01 00:16:41.000000', 'temperatura', 399.0000, 'ºC'),
	(229859, 121, '2014-03-01 00:16:42.000000', 'temperatura', 364.0000, 'ºC'),
	(229860, 121, '2014-03-01 00:16:43.000000', 'temperatura', 623.0000, 'ºC'),
	(229861, 121, '2014-03-01 00:16:44.000000', 'temperatura', 821.0000, 'ºC'),
	(229862, 121, '2014-03-01 00:16:45.000000', 'temperatura', 1040.0000, 'ºC'),
	(229863, 121, '2014-03-01 00:16:46.000000', 'temperatura', 336.0000, 'ºC'),
	(229864, 121, '2014-03-01 00:16:47.000000', 'temperatura', 961.0000, 'ºC'),
	(229865, 121, '2014-03-01 00:16:48.000000', 'temperatura', 197.0000, 'ºC'),
	(229866, 121, '2014-03-01 00:16:49.000000', 'temperatura', 502.0000, 'ºC'),
	(229867, 121, '2014-03-01 00:16:50.000000', 'temperatura', 719.0000, 'ºC'),
	(229868, 121, '2014-03-01 00:16:51.000000', 'temperatura', 891.0000, 'ºC'),
	(229869, 121, '2014-03-01 00:16:52.000000', 'temperatura', 1098.0000, 'ºC'),
	(229870, 121, '2014-03-01 00:16:53.000000', 'temperatura', 419.0000, 'ºC'),
	(229871, 121, '2014-03-01 00:16:54.000000', 'temperatura', 0.0000, 'ºC'),
	(229872, 121, '2014-03-01 00:16:55.000000', 'temperatura', 1143.0000, 'ºC'),
	(229873, 121, '2014-03-01 00:16:56.000000', 'temperatura', 914.0000, 'ºC'),
	(229874, 121, '2014-03-01 00:16:57.000000', 'temperatura', 1145.0000, 'ºC'),
	(229875, 121, '2014-03-01 00:16:58.000000', 'temperatura', 581.0000, 'ºC'),
	(229876, 121, '2014-03-01 00:16:59.000000', 'temperatura', 670.0000, 'ºC'),
	(229877, 121, '2014-03-01 00:17:00.000000', 'temperatura', 408.0000, 'ºC'),
	(229878, 121, '2014-03-01 00:17:01.000000', 'temperatura', 32.0000, 'ºC'),
	(229879, 121, '2014-03-01 00:17:02.000000', 'temperatura', 135.0000, 'ºC'),
	(229880, 121, '2014-03-01 00:17:03.000000', 'temperatura', 578.0000, 'ºC'),
	(229881, 121, '2014-03-01 00:17:04.000000', 'temperatura', 89.0000, 'ºC'),
	(229882, 121, '2014-03-01 00:17:05.000000', 'temperatura', 1109.0000, 'ºC'),
	(229883, 121, '2014-03-01 00:17:06.000000', 'temperatura', 481.0000, 'ºC'),
	(229884, 121, '2014-03-01 00:17:07.000000', 'temperatura', 278.0000, 'ºC'),
	(229885, 121, '2014-03-01 00:17:08.000000', 'temperatura', 1145.0000, 'ºC'),
	(229886, 121, '2014-03-01 00:17:09.000000', 'temperatura', 92.0000, 'ºC'),
	(229887, 121, '2014-03-01 00:17:10.000000', 'temperatura', 627.0000, 'ºC'),
	(229888, 121, '2014-03-01 00:17:11.000000', 'temperatura', 460.0000, 'ºC'),
	(229889, 121, '2014-03-01 00:17:12.000000', 'temperatura', 418.0000, 'ºC'),
	(229890, 121, '2014-03-01 00:17:13.000000', 'temperatura', 711.0000, 'ºC'),
	(229891, 121, '2014-03-01 00:17:14.000000', 'temperatura', 1100.0000, 'ºC'),
	(229892, 121, '2014-03-01 00:17:15.000000', 'temperatura', 968.0000, 'ºC'),
	(229893, 121, '2014-03-01 00:17:16.000000', 'temperatura', 340.0000, 'ºC'),
	(229894, 121, '2014-03-01 00:17:17.000000', 'temperatura', 1198.0000, 'ºC'),
	(229895, 121, '2014-03-01 00:17:18.000000', 'temperatura', 171.0000, 'ºC'),
	(229896, 121, '2014-03-01 00:17:19.000000', 'temperatura', 860.0000, 'ºC'),
	(229897, 121, '2014-03-01 00:17:20.000000', 'temperatura', 190.0000, 'ºC'),
	(229898, 121, '2014-03-01 00:17:21.000000', 'temperatura', 769.0000, 'ºC'),
	(229899, 121, '2014-03-01 00:17:22.000000', 'temperatura', 877.0000, 'ºC'),
	(229900, 121, '2014-03-01 00:17:23.000000', 'temperatura', 876.0000, 'ºC'),
	(229901, 121, '2014-03-01 00:17:24.000000', 'temperatura', 552.0000, 'ºC'),
	(229902, 121, '2014-03-01 00:17:25.000000', 'temperatura', 131.0000, 'ºC'),
	(229903, 121, '2014-03-01 00:17:26.000000', 'temperatura', 199.0000, 'ºC'),
	(229904, 121, '2014-03-01 00:17:27.000000', 'temperatura', 601.0000, 'ºC'),
	(229905, 121, '2014-03-01 00:17:28.000000', 'temperatura', 11.0000, 'ºC'),
	(229906, 121, '2014-03-01 00:17:29.000000', 'temperatura', 652.0000, 'ºC'),
	(229907, 121, '2014-03-01 00:17:30.000000', 'temperatura', 827.0000, 'ºC'),
	(229908, 121, '2014-03-01 00:17:31.000000', 'temperatura', 980.0000, 'ºC'),
	(229909, 121, '2014-03-01 00:17:32.000000', 'temperatura', 20.0000, 'ºC'),
	(229910, 121, '2014-03-01 00:17:33.000000', 'temperatura', 760.0000, 'ºC'),
	(229911, 121, '2014-03-01 00:17:34.000000', 'temperatura', 139.0000, 'ºC'),
	(229912, 121, '2014-03-01 00:17:35.000000', 'temperatura', 816.0000, 'ºC'),
	(229913, 121, '2014-03-01 00:17:36.000000', 'temperatura', 64.0000, 'ºC'),
	(229914, 121, '2014-03-01 00:17:37.000000', 'temperatura', 273.0000, 'ºC'),
	(229915, 121, '2014-03-01 00:17:38.000000', 'temperatura', 1173.0000, 'ºC'),
	(229916, 121, '2014-03-01 00:17:39.000000', 'temperatura', 247.0000, 'ºC'),
	(229917, 121, '2014-03-01 00:17:40.000000', 'temperatura', 118.0000, 'ºC'),
	(229918, 121, '2014-03-01 00:17:41.000000', 'temperatura', 1049.0000, 'ºC'),
	(229919, 121, '2014-03-01 00:17:42.000000', 'temperatura', 92.0000, 'ºC'),
	(229920, 121, '2014-03-01 00:17:43.000000', 'temperatura', 912.0000, 'ºC'),
	(229921, 121, '2014-03-01 00:17:44.000000', 'temperatura', 686.0000, 'ºC'),
	(229922, 121, '2014-03-01 00:17:45.000000', 'temperatura', 695.0000, 'ºC'),
	(229923, 121, '2014-03-01 00:17:46.000000', 'temperatura', 218.0000, 'ºC'),
	(229924, 121, '2014-03-01 00:17:47.000000', 'temperatura', 205.0000, 'ºC'),
	(229925, 121, '2014-03-01 00:17:48.000000', 'temperatura', 369.0000, 'ºC'),
	(229926, 121, '2014-03-01 00:17:49.000000', 'temperatura', 34.0000, 'ºC'),
	(229927, 121, '2014-03-01 00:17:50.000000', 'temperatura', 261.0000, 'ºC'),
	(229928, 121, '2014-03-01 00:17:51.000000', 'temperatura', 3.0000, 'ºC'),
	(229929, 121, '2014-03-01 00:17:52.000000', 'temperatura', 435.0000, 'ºC'),
	(229930, 121, '2014-03-01 00:17:53.000000', 'temperatura', 963.0000, 'ºC'),
	(229931, 121, '2014-03-01 00:17:54.000000', 'temperatura', 1114.0000, 'ºC'),
	(229932, 121, '2014-03-01 00:17:55.000000', 'temperatura', 281.0000, 'ºC'),
	(229933, 121, '2014-03-01 00:17:56.000000', 'temperatura', 462.0000, 'ºC'),
	(229934, 121, '2014-03-01 00:17:57.000000', 'temperatura', 270.0000, 'ºC'),
	(229935, 121, '2014-03-01 00:17:58.000000', 'temperatura', 1164.0000, 'ºC'),
	(229936, 121, '2014-03-01 00:17:59.000000', 'temperatura', 212.0000, 'ºC'),
	(229937, 121, '2014-03-01 00:18:00.000000', 'temperatura', 1167.0000, 'ºC'),
	(229938, 121, '2014-03-01 00:18:01.000000', 'temperatura', 398.0000, 'ºC'),
	(229939, 121, '2014-03-01 00:18:02.000000', 'temperatura', 891.0000, 'ºC'),
	(229940, 121, '2014-03-01 00:18:03.000000', 'temperatura', 862.0000, 'ºC'),
	(229941, 121, '2014-03-01 00:18:04.000000', 'temperatura', 436.0000, 'ºC'),
	(229942, 121, '2014-03-01 00:18:05.000000', 'temperatura', 795.0000, 'ºC'),
	(229943, 121, '2014-03-01 00:18:06.000000', 'temperatura', 268.0000, 'ºC'),
	(229944, 121, '2014-03-01 00:18:07.000000', 'temperatura', 157.0000, 'ºC'),
	(229945, 121, '2014-03-01 00:18:08.000000', 'temperatura', 1179.0000, 'ºC'),
	(229946, 121, '2014-03-01 00:18:09.000000', 'temperatura', 624.0000, 'ºC'),
	(229947, 121, '2014-03-01 00:18:10.000000', 'temperatura', 786.0000, 'ºC'),
	(229948, 121, '2014-03-01 00:18:11.000000', 'temperatura', 857.0000, 'ºC'),
	(229949, 121, '2014-03-01 00:18:12.000000', 'temperatura', 730.0000, 'ºC'),
	(229950, 121, '2014-03-01 00:18:13.000000', 'temperatura', 1077.0000, 'ºC'),
	(229951, 121, '2014-03-01 00:18:14.000000', 'temperatura', 797.0000, 'ºC'),
	(229952, 121, '2014-03-01 00:18:15.000000', 'temperatura', 752.0000, 'ºC'),
	(229953, 121, '2014-03-01 00:18:16.000000', 'temperatura', 171.0000, 'ºC'),
	(229954, 121, '2014-03-01 00:18:17.000000', 'temperatura', 997.0000, 'ºC'),
	(229955, 121, '2014-03-01 00:18:18.000000', 'temperatura', 876.0000, 'ºC'),
	(229956, 121, '2014-03-01 00:18:19.000000', 'temperatura', 187.0000, 'ºC'),
	(229957, 121, '2014-03-01 00:18:20.000000', 'temperatura', 710.0000, 'ºC'),
	(229958, 121, '2014-03-01 00:18:21.000000', 'temperatura', 589.0000, 'ºC'),
	(229959, 121, '2014-03-01 00:18:22.000000', 'temperatura', 814.0000, 'ºC'),
	(229960, 121, '2014-03-01 00:18:23.000000', 'temperatura', 1104.0000, 'ºC'),
	(229961, 121, '2014-03-01 00:18:24.000000', 'temperatura', 678.0000, 'ºC'),
	(229962, 121, '2014-03-01 00:18:25.000000', 'temperatura', 79.0000, 'ºC'),
	(229963, 121, '2014-03-01 00:18:26.000000', 'temperatura', 759.0000, 'ºC'),
	(229964, 121, '2014-03-01 00:18:27.000000', 'temperatura', 1162.0000, 'ºC'),
	(229965, 121, '2014-03-01 00:18:28.000000', 'temperatura', 1133.0000, 'ºC'),
	(229966, 121, '2014-03-01 00:18:29.000000', 'temperatura', 978.0000, 'ºC'),
	(229967, 121, '2014-03-01 00:18:30.000000', 'temperatura', 294.0000, 'ºC'),
	(229968, 121, '2014-03-01 00:18:31.000000', 'temperatura', 935.0000, 'ºC'),
	(229969, 121, '2014-03-01 00:18:32.000000', 'temperatura', 196.0000, 'ºC'),
	(229970, 121, '2014-03-01 00:18:33.000000', 'temperatura', 572.0000, 'ºC'),
	(229971, 121, '2014-03-01 00:18:34.000000', 'temperatura', 1076.0000, 'ºC'),
	(229972, 121, '2014-03-01 00:18:35.000000', 'temperatura', 62.0000, 'ºC'),
	(229973, 121, '2014-03-01 00:18:36.000000', 'temperatura', 682.0000, 'ºC'),
	(229974, 121, '2014-03-01 00:18:37.000000', 'temperatura', 825.0000, 'ºC'),
	(229975, 121, '2014-03-01 00:18:38.000000', 'temperatura', 878.0000, 'ºC'),
	(229976, 121, '2014-03-01 00:18:39.000000', 'temperatura', 716.0000, 'ºC'),
	(229977, 121, '2014-03-01 00:18:40.000000', 'temperatura', 947.0000, 'ºC'),
	(229978, 121, '2014-03-01 00:18:41.000000', 'temperatura', 189.0000, 'ºC'),
	(229979, 121, '2014-03-01 00:18:42.000000', 'temperatura', 503.0000, 'ºC'),
	(229980, 121, '2014-03-01 00:18:43.000000', 'temperatura', 751.0000, 'ºC'),
	(229981, 121, '2014-03-01 00:18:44.000000', 'temperatura', 1044.0000, 'ºC'),
	(229982, 121, '2014-03-01 00:18:45.000000', 'temperatura', 568.0000, 'ºC'),
	(229983, 121, '2014-03-01 00:18:46.000000', 'temperatura', 908.0000, 'ºC'),
	(229984, 121, '2014-03-01 00:18:47.000000', 'temperatura', 437.0000, 'ºC'),
	(229985, 121, '2014-03-01 00:18:48.000000', 'temperatura', 659.0000, 'ºC'),
	(229986, 121, '2014-03-01 00:18:49.000000', 'temperatura', 788.0000, 'ºC'),
	(229987, 121, '2014-03-01 00:18:50.000000', 'temperatura', 762.0000, 'ºC'),
	(229988, 121, '2014-03-01 00:18:51.000000', 'temperatura', 248.0000, 'ºC'),
	(229989, 121, '2014-03-01 00:18:52.000000', 'temperatura', 154.0000, 'ºC'),
	(229990, 121, '2014-03-01 00:18:53.000000', 'temperatura', 24.0000, 'ºC'),
	(229991, 121, '2014-03-01 00:18:54.000000', 'temperatura', 861.0000, 'ºC'),
	(229992, 121, '2014-03-01 00:18:55.000000', 'temperatura', 633.0000, 'ºC'),
	(229993, 121, '2014-03-01 00:18:56.000000', 'temperatura', 582.0000, 'ºC'),
	(229994, 121, '2014-03-01 00:18:57.000000', 'temperatura', 1012.0000, 'ºC'),
	(229995, 121, '2014-03-01 00:18:58.000000', 'temperatura', 912.0000, 'ºC'),
	(229996, 121, '2014-03-01 00:18:59.000000', 'temperatura', 328.0000, 'ºC'),
	(229997, 121, '2014-03-01 00:19:00.000000', 'temperatura', 103.0000, 'ºC'),
	(229998, 121, '2014-03-01 00:19:01.000000', 'temperatura', 731.0000, 'ºC'),
	(229999, 121, '2014-03-01 00:19:02.000000', 'temperatura', 947.0000, 'ºC'),
	(230000, 121, '2014-03-01 00:19:03.000000', 'temperatura', 144.0000, 'ºC'),
	(230001, 121, '2014-03-01 00:19:04.000000', 'temperatura', 277.0000, 'ºC'),
	(230002, 121, '2014-03-01 00:19:05.000000', 'temperatura', 953.0000, 'ºC'),
	(230003, 121, '2014-03-01 00:19:06.000000', 'temperatura', 335.0000, 'ºC'),
	(230004, 121, '2014-03-01 00:19:07.000000', 'temperatura', 19.0000, 'ºC'),
	(230005, 121, '2014-03-01 00:19:08.000000', 'temperatura', 287.0000, 'ºC'),
	(230006, 121, '2014-03-01 00:19:09.000000', 'temperatura', 180.0000, 'ºC'),
	(230007, 121, '2014-03-01 00:19:10.000000', 'temperatura', 41.0000, 'ºC'),
	(230008, 121, '2014-03-01 00:19:11.000000', 'temperatura', 866.0000, 'ºC'),
	(230009, 121, '2014-03-01 00:19:12.000000', 'temperatura', 607.0000, 'ºC'),
	(230010, 121, '2014-03-01 00:19:13.000000', 'temperatura', 436.0000, 'ºC'),
	(230011, 121, '2014-03-01 00:19:14.000000', 'temperatura', 361.0000, 'ºC'),
	(230012, 121, '2014-03-01 00:19:15.000000', 'temperatura', 499.0000, 'ºC'),
	(230013, 121, '2014-03-01 00:19:16.000000', 'temperatura', 212.0000, 'ºC'),
	(230014, 121, '2014-03-01 00:19:17.000000', 'temperatura', 761.0000, 'ºC'),
	(230015, 121, '2014-03-01 00:19:18.000000', 'temperatura', 771.0000, 'ºC'),
	(230016, 121, '2014-03-01 00:19:19.000000', 'temperatura', 370.0000, 'ºC'),
	(230017, 121, '2014-03-01 00:19:20.000000', 'temperatura', 741.0000, 'ºC'),
	(230018, 121, '2014-03-01 00:19:21.000000', 'temperatura', 195.0000, 'ºC'),
	(230019, 121, '2014-03-01 00:19:22.000000', 'temperatura', 1153.0000, 'ºC'),
	(230020, 121, '2014-03-01 00:19:23.000000', 'temperatura', 382.0000, 'ºC'),
	(230021, 121, '2014-03-01 00:19:24.000000', 'temperatura', 849.0000, 'ºC'),
	(230022, 121, '2014-03-01 00:19:25.000000', 'temperatura', 702.0000, 'ºC'),
	(230023, 121, '2014-03-01 00:19:26.000000', 'temperatura', 961.0000, 'ºC'),
	(230024, 121, '2014-03-01 00:19:27.000000', 'temperatura', 302.0000, 'ºC'),
	(230025, 121, '2014-03-01 00:19:28.000000', 'temperatura', 1027.0000, 'ºC'),
	(230026, 121, '2014-03-01 00:19:29.000000', 'temperatura', 630.0000, 'ºC'),
	(230027, 121, '2014-03-01 00:19:30.000000', 'temperatura', 71.0000, 'ºC'),
	(230028, 121, '2014-03-01 00:19:31.000000', 'temperatura', 863.0000, 'ºC'),
	(230029, 121, '2014-03-01 00:19:32.000000', 'temperatura', 501.0000, 'ºC'),
	(230030, 121, '2014-03-01 00:19:33.000000', 'temperatura', 1120.0000, 'ºC'),
	(230031, 121, '2014-03-01 00:19:34.000000', 'temperatura', 496.0000, 'ºC'),
	(230032, 121, '2014-03-01 00:19:35.000000', 'temperatura', 319.0000, 'ºC'),
	(230033, 121, '2014-03-01 00:19:36.000000', 'temperatura', 107.0000, 'ºC'),
	(230034, 121, '2014-03-01 00:19:37.000000', 'temperatura', 780.0000, 'ºC'),
	(230035, 121, '2014-03-01 00:19:38.000000', 'temperatura', 1179.0000, 'ºC'),
	(230036, 121, '2014-03-01 00:19:39.000000', 'temperatura', 1156.0000, 'ºC'),
	(230037, 121, '2014-03-01 00:19:40.000000', 'temperatura', 1043.0000, 'ºC'),
	(230038, 121, '2014-03-01 00:19:41.000000', 'temperatura', 549.0000, 'ºC'),
	(230039, 121, '2014-03-01 00:19:42.000000', 'temperatura', 815.0000, 'ºC'),
	(230040, 121, '2014-03-01 00:19:43.000000', 'temperatura', 28.0000, 'ºC'),
	(230041, 121, '2014-03-01 00:19:44.000000', 'temperatura', 95.0000, 'ºC'),
	(230042, 121, '2014-03-01 00:19:45.000000', 'temperatura', 392.0000, 'ºC'),
	(230043, 121, '2014-03-01 00:19:46.000000', 'temperatura', 474.0000, 'ºC'),
	(230044, 121, '2014-03-01 00:19:47.000000', 'temperatura', 1195.0000, 'ºC'),
	(230045, 121, '2014-03-01 00:19:48.000000', 'temperatura', 955.0000, 'ºC'),
	(230046, 121, '2014-03-01 00:19:49.000000', 'temperatura', 1191.0000, 'ºC'),
	(230047, 121, '2014-03-01 00:19:50.000000', 'temperatura', 689.0000, 'ºC'),
	(230048, 121, '2014-03-01 00:19:51.000000', 'temperatura', 1072.0000, 'ºC'),
	(230049, 121, '2014-03-01 00:19:52.000000', 'temperatura', 892.0000, 'ºC'),
	(230050, 121, '2014-03-01 00:19:53.000000', 'temperatura', 47.0000, 'ºC'),
	(230051, 121, '2014-03-01 00:19:54.000000', 'temperatura', 1157.0000, 'ºC'),
	(230052, 121, '2014-03-01 00:19:55.000000', 'temperatura', 845.0000, 'ºC'),
	(230053, 121, '2014-03-01 00:19:56.000000', 'temperatura', 756.0000, 'ºC'),
	(230054, 121, '2014-03-01 00:19:57.000000', 'temperatura', 44.0000, 'ºC'),
	(230055, 121, '2014-03-01 00:19:58.000000', 'temperatura', 353.0000, 'ºC'),
	(230056, 121, '2014-03-01 00:19:59.000000', 'temperatura', 432.0000, 'ºC'),
	(230057, 121, '2014-03-01 00:20:00.000000', 'temperatura', 1101.0000, 'ºC'),
	(230058, 121, '2014-03-01 00:20:01.000000', 'temperatura', 609.0000, 'ºC'),
	(230059, 121, '2014-03-01 00:20:02.000000', 'temperatura', 945.0000, 'ºC'),
	(230060, 121, '2014-03-01 00:20:03.000000', 'temperatura', 498.0000, 'ºC'),
	(230061, 121, '2014-03-01 00:20:04.000000', 'temperatura', 855.0000, 'ºC'),
	(230062, 121, '2014-03-01 00:20:05.000000', 'temperatura', 381.0000, 'ºC'),
	(230063, 121, '2014-03-01 00:20:06.000000', 'temperatura', 541.0000, 'ºC'),
	(230064, 121, '2014-03-01 00:20:07.000000', 'temperatura', 362.0000, 'ºC'),
	(230065, 121, '2014-03-01 00:20:08.000000', 'temperatura', 187.0000, 'ºC'),
	(230066, 121, '2014-03-01 00:20:09.000000', 'temperatura', 1050.0000, 'ºC'),
	(230067, 121, '2014-03-01 00:20:10.000000', 'temperatura', 1088.0000, 'ºC'),
	(230068, 121, '2014-03-01 00:20:11.000000', 'temperatura', 1090.0000, 'ºC'),
	(230069, 121, '2014-03-01 00:20:12.000000', 'temperatura', 990.0000, 'ºC'),
	(230070, 121, '2014-03-01 00:20:13.000000', 'temperatura', 477.0000, 'ºC'),
	(230071, 121, '2014-03-01 00:20:14.000000', 'temperatura', 617.0000, 'ºC'),
	(230072, 121, '2014-03-01 00:20:15.000000', 'temperatura', 453.0000, 'ºC'),
	(230073, 121, '2014-03-01 00:20:16.000000', 'temperatura', 414.0000, 'ºC'),
	(230074, 121, '2014-03-01 00:20:17.000000', 'temperatura', 714.0000, 'ºC'),
	(230075, 121, '2014-03-01 00:20:18.000000', 'temperatura', 1125.0000, 'ºC'),
	(230076, 121, '2014-03-01 00:20:19.000000', 'temperatura', 1087.0000, 'ºC'),
	(230077, 121, '2014-03-01 00:20:20.000000', 'temperatura', 858.0000, 'ºC'),
	(230078, 121, '2014-03-01 00:20:21.000000', 'temperatura', 1030.0000, 'ºC'),
	(230079, 121, '2014-03-01 00:20:22.000000', 'temperatura', 175.0000, 'ºC'),
	(230080, 121, '2014-03-01 00:20:23.000000', 'temperatura', 187.0000, 'ºC'),
	(230081, 121, '2014-03-01 00:20:24.000000', 'temperatura', 412.0000, 'ºC'),
	(230082, 121, '2014-03-01 00:20:25.000000', 'temperatura', 298.0000, 'ºC'),
	(230083, 121, '2014-03-01 00:20:26.000000', 'temperatura', 255.0000, 'ºC'),
	(230084, 121, '2014-03-01 00:20:27.000000', 'temperatura', 382.0000, 'ºC'),
	(230085, 121, '2014-03-01 00:20:28.000000', 'temperatura', 1145.0000, 'ºC'),
	(230086, 121, '2014-03-01 00:20:29.000000', 'temperatura', 981.0000, 'ºC'),
	(230087, 121, '2014-03-01 00:20:30.000000', 'temperatura', 267.0000, 'ºC'),
	(230088, 121, '2014-03-01 00:20:31.000000', 'temperatura', 796.0000, 'ºC'),
	(230089, 121, '2014-03-01 00:20:32.000000', 'temperatura', 777.0000, 'ºC'),
	(230090, 121, '2014-03-01 00:20:33.000000', 'temperatura', 297.0000, 'ºC'),
	(230091, 121, '2014-03-01 00:20:34.000000', 'temperatura', 355.0000, 'ºC'),
	(230092, 121, '2014-03-01 00:20:35.000000', 'temperatura', 887.0000, 'ºC'),
	(230093, 121, '2014-03-01 00:20:36.000000', 'temperatura', 969.0000, 'ºC'),
	(230094, 121, '2014-03-01 00:20:37.000000', 'temperatura', 984.0000, 'ºC'),
	(230095, 121, '2014-03-01 00:20:38.000000', 'temperatura', 813.0000, 'ºC'),
	(230096, 121, '2014-03-01 00:20:39.000000', 'temperatura', 1115.0000, 'ºC'),
	(230097, 121, '2014-03-01 00:20:40.000000', 'temperatura', 734.0000, 'ºC'),
	(230098, 121, '2014-03-01 00:20:41.000000', 'temperatura', 329.0000, 'ºC'),
	(230099, 121, '2014-03-01 00:20:42.000000', 'temperatura', 642.0000, 'ºC'),
	(230100, 121, '2014-03-01 00:20:43.000000', 'temperatura', 1022.0000, 'ºC'),
	(230101, 121, '2014-03-01 00:20:44.000000', 'temperatura', 784.0000, 'ºC'),
	(230102, 121, '2014-03-01 00:20:45.000000', 'temperatura', 855.0000, 'ºC'),
	(230103, 121, '2014-03-01 00:20:46.000000', 'temperatura', 724.0000, 'ºC'),
	(230104, 121, '2014-03-01 00:20:47.000000', 'temperatura', 1053.0000, 'ºC'),
	(230105, 121, '2014-03-01 00:20:48.000000', 'temperatura', 697.0000, 'ºC'),
	(230106, 121, '2014-03-01 00:20:49.000000', 'temperatura', 325.0000, 'ºC'),
	(230107, 121, '2014-03-01 00:20:50.000000', 'temperatura', 736.0000, 'ºC'),
	(230108, 121, '2014-03-01 00:20:51.000000', 'temperatura', 304.0000, 'ºC'),
	(230109, 121, '2014-03-01 00:20:52.000000', 'temperatura', 513.0000, 'ºC'),
	(230110, 121, '2014-03-01 00:20:53.000000', 'temperatura', 453.0000, 'ºC'),
	(230111, 121, '2014-03-01 00:20:54.000000', 'temperatura', 728.0000, 'ºC'),
	(230112, 121, '2014-03-01 00:20:55.000000', 'temperatura', 1079.0000, 'ºC'),
	(230113, 121, '2014-03-01 00:20:56.000000', 'temperatura', 811.0000, 'ºC'),
	(230114, 121, '2014-03-01 00:20:57.000000', 'temperatura', 819.0000, 'ºC'),
	(230115, 121, '2014-03-01 00:20:58.000000', 'temperatura', 462.0000, 'ºC'),
	(230116, 121, '2014-03-01 00:20:59.000000', 'temperatura', 1053.0000, 'ºC'),
	(230117, 121, '2014-03-01 00:21:00.000000', 'temperatura', 281.0000, 'ºC'),
	(230118, 121, '2014-03-01 00:21:01.000000', 'temperatura', 644.0000, 'ºC'),
	(230119, 121, '2014-03-01 00:21:02.000000', 'temperatura', 1179.0000, 'ºC'),
	(230120, 121, '2014-03-01 00:21:03.000000', 'temperatura', 363.0000, 'ºC'),
	(230121, 121, '2014-03-01 00:21:04.000000', 'temperatura', 679.0000, 'ºC'),
	(230122, 121, '2014-03-01 00:21:05.000000', 'temperatura', 1105.0000, 'ºC'),
	(230123, 121, '2014-03-01 00:21:06.000000', 'temperatura', 1090.0000, 'ºC'),
	(230124, 121, '2014-03-01 00:21:07.000000', 'temperatura', 934.0000, 'ºC'),
	(230125, 121, '2014-03-01 00:21:08.000000', 'temperatura', 200.0000, 'ºC'),
	(230126, 121, '2014-03-01 00:21:09.000000', 'temperatura', 597.0000, 'ºC'),
	(230127, 121, '2014-03-01 00:21:10.000000', 'temperatura', 1189.0000, 'ºC'),
	(230128, 121, '2014-03-01 00:21:11.000000', 'temperatura', 553.0000, 'ºC'),
	(230129, 121, '2014-03-01 00:21:12.000000', 'temperatura', 397.0000, 'ºC'),
	(230130, 121, '2014-03-01 00:21:13.000000', 'temperatura', 326.0000, 'ºC'),
	(230131, 121, '2014-03-01 00:21:14.000000', 'temperatura', 439.0000, 'ºC'),
	(230132, 121, '2014-03-01 00:21:15.000000', 'temperatura', 20.0000, 'ºC'),
	(230133, 121, '2014-03-01 00:21:16.000000', 'temperatura', 1182.0000, 'ºC'),
	(230134, 121, '2014-03-01 00:21:17.000000', 'temperatura', 1051.0000, 'ºC'),
	(230135, 121, '2014-03-01 00:21:18.000000', 'temperatura', 511.0000, 'ºC'),
	(230136, 121, '2014-03-01 00:21:19.000000', 'temperatura', 599.0000, 'ºC'),
	(230137, 121, '2014-03-01 00:21:20.000000', 'temperatura', 266.0000, 'ºC'),
	(230138, 121, '2014-03-01 00:21:21.000000', 'temperatura', 731.0000, 'ºC'),
	(230139, 121, '2014-03-01 00:21:22.000000', 'temperatura', 459.0000, 'ºC'),
	(230140, 121, '2014-03-01 00:21:23.000000', 'temperatura', 101.0000, 'ºC'),
	(230141, 121, '2014-03-01 00:21:24.000000', 'temperatura', 331.0000, 'ºC'),
	(230142, 121, '2014-03-01 00:21:25.000000', 'temperatura', 151.0000, 'ºC'),
	(230143, 121, '2014-03-01 00:21:26.000000', 'temperatura', 963.0000, 'ºC'),
	(230144, 121, '2014-03-01 00:21:27.000000', 'temperatura', 761.0000, 'ºC'),
	(230145, 121, '2014-03-01 00:21:28.000000', 'temperatura', 918.0000, 'ºC'),
	(230146, 121, '2014-03-01 00:21:29.000000', 'temperatura', 1108.0000, 'ºC'),
	(230147, 121, '2014-03-01 00:21:30.000000', 'temperatura', 385.0000, 'ºC'),
	(230148, 121, '2014-03-01 00:21:31.000000', 'temperatura', 1002.0000, 'ºC'),
	(230149, 121, '2014-03-01 00:21:32.000000', 'temperatura', 255.0000, 'ºC'),
	(230150, 121, '2014-03-01 00:21:33.000000', 'temperatura', 669.0000, 'ºC'),
	(230151, 121, '2014-03-01 00:21:34.000000', 'temperatura', 182.0000, 'ºC'),
	(230152, 121, '2014-03-01 00:21:35.000000', 'temperatura', 104.0000, 'ºC'),
	(230153, 121, '2014-03-01 00:21:36.000000', 'temperatura', 1172.0000, 'ºC'),
	(230154, 121, '2014-03-01 00:21:37.000000', 'temperatura', 750.0000, 'ºC'),
	(230155, 121, '2014-03-01 00:21:38.000000', 'temperatura', 233.0000, 'ºC'),
	(230156, 121, '2014-03-01 00:21:39.000000', 'temperatura', 116.0000, 'ºC'),
	(230157, 121, '2014-03-01 00:21:40.000000', 'temperatura', 1083.0000, 'ºC'),
	(230158, 121, '2014-03-01 00:21:41.000000', 'temperatura', 268.0000, 'ºC'),
	(230159, 121, '2014-03-01 00:21:42.000000', 'temperatura', 492.0000, 'ºC'),
	(230160, 121, '2014-03-01 00:21:43.000000', 'temperatura', 455.0000, 'ºC'),
	(230161, 121, '2014-03-01 00:21:44.000000', 'temperatura', 799.0000, 'ºC'),
	(230162, 121, '2014-03-01 00:21:45.000000', 'temperatura', 231.0000, 'ºC'),
	(230163, 121, '2014-03-01 00:21:46.000000', 'temperatura', 1161.0000, 'ºC'),
	(230164, 121, '2014-03-01 00:21:47.000000', 'temperatura', 309.0000, 'ºC'),
	(230165, 121, '2014-03-01 00:21:48.000000', 'temperatura', 464.0000, 'ºC'),
	(230166, 121, '2014-03-01 00:21:49.000000', 'temperatura', 192.0000, 'ºC'),
	(230167, 121, '2014-03-01 00:21:50.000000', 'temperatura', 770.0000, 'ºC'),
	(230168, 121, '2014-03-01 00:21:51.000000', 'temperatura', 875.0000, 'ºC'),
	(230169, 121, '2014-03-01 00:21:52.000000', 'temperatura', 864.0000, 'ºC'),
	(230170, 121, '2014-03-01 00:21:53.000000', 'temperatura', 496.0000, 'ºC'),
	(230171, 121, '2014-03-01 00:21:54.000000', 'temperatura', 1089.0000, 'ºC'),
	(230172, 121, '2014-03-01 00:21:55.000000', 'temperatura', 357.0000, 'ºC'),
	(230173, 121, '2014-03-01 00:21:56.000000', 'temperatura', 918.0000, 'ºC'),
	(230174, 121, '2014-03-01 00:21:57.000000', 'temperatura', 1119.0000, 'ºC'),
	(230175, 121, '2014-03-01 00:21:58.000000', 'temperatura', 440.0000, 'ºC'),
	(230176, 121, '2014-03-01 00:21:59.000000', 'temperatura', 46.0000, 'ºC'),
	(230177, 121, '2014-03-01 00:22:00.000000', 'temperatura', 111.0000, 'ºC'),
	(230178, 121, '2014-03-01 00:22:01.000000', 'temperatura', 416.0000, 'ºC'),
	(230179, 121, '2014-03-01 00:22:02.000000', 'temperatura', 549.0000, 'ºC'),
	(230180, 121, '2014-03-01 00:22:03.000000', 'temperatura', 295.0000, 'ºC'),
	(230181, 121, '2014-03-01 00:22:04.000000', 'temperatura', 1031.0000, 'ºC'),
	(230182, 121, '2014-03-01 00:22:05.000000', 'temperatura', 668.0000, 'ºC'),
	(230183, 121, '2014-03-01 00:22:06.000000', 'temperatura', 249.0000, 'ºC'),
	(230184, 121, '2014-03-01 00:22:07.000000', 'temperatura', 442.0000, 'ºC'),
	(230185, 121, '2014-03-01 00:22:08.000000', 'temperatura', 262.0000, 'ºC'),
	(230186, 121, '2014-03-01 00:22:09.000000', 'temperatura', 1183.0000, 'ºC'),
	(230187, 121, '2014-03-01 00:22:10.000000', 'temperatura', 332.0000, 'ºC'),
	(230188, 121, '2014-03-01 00:22:11.000000', 'temperatura', 512.0000, 'ºC'),
	(230189, 121, '2014-03-01 00:22:12.000000', 'temperatura', 362.0000, 'ºC'),
	(230190, 121, '2014-03-01 00:22:13.000000', 'temperatura', 277.0000, 'ºC'),
	(230191, 121, '2014-03-01 00:22:14.000000', 'temperatura', 299.0000, 'ºC'),
	(230192, 121, '2014-03-01 00:22:15.000000', 'temperatura', 662.0000, 'ºC'),
	(230193, 121, '2014-03-01 00:22:16.000000', 'temperatura', 17.0000, 'ºC'),
	(230194, 121, '2014-03-01 00:22:17.000000', 'temperatura', 497.0000, 'ºC'),
	(230195, 121, '2014-03-01 00:22:18.000000', 'temperatura', 34.0000, 'ºC'),
	(230196, 121, '2014-03-01 00:22:19.000000', 'temperatura', 1080.0000, 'ºC'),
	(230197, 121, '2014-03-01 00:22:20.000000', 'temperatura', 497.0000, 'ºC'),
	(230198, 121, '2014-03-01 00:22:21.000000', 'temperatura', 449.0000, 'ºC'),
	(230199, 121, '2014-03-01 00:22:22.000000', 'temperatura', 751.0000, 'ºC'),
	(230200, 121, '2014-03-01 00:22:23.000000', 'temperatura', 12.0000, 'ºC'),
	(230201, 121, '2014-03-01 00:22:24.000000', 'temperatura', 205.0000, 'ºC'),
	(230202, 121, '2014-03-01 00:22:25.000000', 'temperatura', 990.0000, 'ºC'),
	(230203, 121, '2014-03-01 00:22:26.000000', 'temperatura', 737.0000, 'ºC'),
	(230204, 121, '2014-03-01 00:22:27.000000', 'temperatura', 716.0000, 'ºC'),
	(230205, 121, '2014-03-01 00:22:28.000000', 'temperatura', 170.0000, 'ºC'),
	(230206, 121, '2014-03-01 00:22:29.000000', 'temperatura', 1101.0000, 'ºC'),
	(230207, 121, '2014-03-01 00:22:30.000000', 'temperatura', 195.0000, 'ºC'),
	(230208, 121, '2014-03-01 00:22:31.000000', 'temperatura', 71.0000, 'ºC'),
	(230209, 121, '2014-03-01 00:22:32.000000', 'temperatura', 974.0000, 'ºC'),
	(230210, 121, '2014-03-01 00:22:33.000000', 'temperatura', 1056.0000, 'ºC'),
	(230211, 121, '2014-03-01 00:22:34.000000', 'temperatura', 1158.0000, 'ºC'),
	(230212, 121, '2014-03-01 00:22:35.000000', 'temperatura', 223.0000, 'ºC'),
	(230213, 121, '2014-03-01 00:22:36.000000', 'temperatura', 43.0000, 'ºC'),
	(230214, 121, '2014-03-01 00:22:37.000000', 'temperatura', 747.0000, 'ºC'),
	(230215, 121, '2014-03-01 00:22:38.000000', 'temperatura', 3.0000, 'ºC'),
	(230216, 121, '2014-03-01 00:22:39.000000', 'temperatura', 178.0000, 'ºC'),
	(230217, 121, '2014-03-01 00:22:40.000000', 'temperatura', 881.0000, 'ºC'),
	(230218, 121, '2014-03-01 00:22:41.000000', 'temperatura', 271.0000, 'ºC'),
	(230219, 121, '2014-03-01 00:22:42.000000', 'temperatura', 1113.0000, 'ºC'),
	(230220, 121, '2014-03-01 00:22:43.000000', 'temperatura', 1150.0000, 'ºC'),
	(230221, 121, '2014-03-01 00:22:44.000000', 'temperatura', 13.0000, 'ºC'),
	(230222, 121, '2014-03-01 00:22:45.000000', 'temperatura', 218.0000, 'ºC'),
	(230223, 121, '2014-03-01 00:22:46.000000', 'temperatura', 1048.0000, 'ºC'),
	(230224, 121, '2014-03-01 00:22:47.000000', 'temperatura', 988.0000, 'ºC'),
	(230225, 121, '2014-03-01 00:22:48.000000', 'temperatura', 596.0000, 'ºC'),
	(230226, 121, '2014-03-01 00:22:49.000000', 'temperatura', 16.0000, 'ºC'),
	(230227, 121, '2014-03-01 00:22:50.000000', 'temperatura', 692.0000, 'ºC'),
	(230228, 121, '2014-03-01 00:22:51.000000', 'temperatura', 1014.0000, 'ºC'),
	(230229, 121, '2014-03-01 00:22:52.000000', 'temperatura', 595.0000, 'ºC'),
	(230230, 121, '2014-03-01 00:22:53.000000', 'temperatura', 1133.0000, 'ºC'),
	(230231, 121, '2014-03-01 00:22:54.000000', 'temperatura', 282.0000, 'ºC'),
	(230232, 121, '2014-03-01 00:22:55.000000', 'temperatura', 409.0000, 'ºC'),
	(230233, 121, '2014-03-01 00:22:56.000000', 'temperatura', 2.0000, 'ºC'),
	(230234, 121, '2014-03-01 00:22:57.000000', 'temperatura', 1181.0000, 'ºC'),
	(230235, 121, '2014-03-01 00:22:58.000000', 'temperatura', 1099.0000, 'ºC'),
	(230236, 121, '2014-03-01 00:22:59.000000', 'temperatura', 753.0000, 'ºC'),
	(230237, 121, '2014-03-01 00:23:00.000000', 'temperatura', 469.0000, 'ºC'),
	(230238, 121, '2014-03-01 00:23:01.000000', 'temperatura', 87.0000, 'ºC'),
	(230239, 121, '2014-03-01 00:23:02.000000', 'temperatura', 227.0000, 'ºC'),
	(230240, 121, '2014-03-01 00:23:03.000000', 'temperatura', 873.0000, 'ºC'),
	(230241, 121, '2014-03-01 00:23:04.000000', 'temperatura', 87.0000, 'ºC'),
	(230242, 121, '2014-03-01 00:23:05.000000', 'temperatura', 216.0000, 'ºC'),
	(230243, 121, '2014-03-01 00:23:06.000000', 'temperatura', 819.0000, 'ºC'),
	(230244, 121, '2014-03-01 00:23:07.000000', 'temperatura', 1046.0000, 'ºC'),
	(230245, 121, '2014-03-01 00:23:08.000000', 'temperatura', 376.0000, 'ºC'),
	(230246, 121, '2014-03-01 00:23:09.000000', 'temperatura', 1144.0000, 'ºC'),
	(230247, 121, '2014-03-01 00:23:10.000000', 'temperatura', 989.0000, 'ºC'),
	(230248, 121, '2014-03-01 00:23:11.000000', 'temperatura', 316.0000, 'ºC'),
	(230249, 121, '2014-03-01 00:23:12.000000', 'temperatura', 1011.0000, 'ºC'),
	(230250, 121, '2014-03-01 00:23:13.000000', 'temperatura', 508.0000, 'ºC'),
	(230251, 121, '2014-03-01 00:23:14.000000', 'temperatura', 707.0000, 'ºC'),
	(230252, 121, '2014-03-01 00:23:15.000000', 'temperatura', 814.0000, 'ºC'),
	(230253, 121, '2014-03-01 00:23:16.000000', 'temperatura', 749.0000, 'ºC'),
	(230254, 121, '2014-03-01 00:23:17.000000', 'temperatura', 101.0000, 'ºC'),
	(230255, 121, '2014-03-01 00:23:18.000000', 'temperatura', 661.0000, 'ºC'),
	(230256, 121, '2014-03-01 00:23:19.000000', 'temperatura', 603.0000, 'ºC'),
	(230257, 121, '2014-03-01 00:23:20.000000', 'temperatura', 1032.0000, 'ºC'),
	(230258, 121, '2014-03-01 00:23:21.000000', 'temperatura', 951.0000, 'ºC'),
	(230259, 121, '2014-03-01 00:23:22.000000', 'temperatura', 461.0000, 'ºC'),
	(230260, 121, '2014-03-01 00:23:23.000000', 'temperatura', 651.0000, 'ºC'),
	(230261, 121, '2014-03-01 00:23:24.000000', 'temperatura', 674.0000, 'ºC'),
	(230262, 121, '2014-03-01 00:23:25.000000', 'temperatura', 217.0000, 'ºC'),
	(230263, 121, '2014-03-01 00:23:26.000000', 'temperatura', 264.0000, 'ºC'),
	(230264, 121, '2014-03-01 00:23:27.000000', 'temperatura', 671.0000, 'ºC'),
	(230265, 121, '2014-03-01 00:23:28.000000', 'temperatura', 160.0000, 'ºC'),
	(230266, 121, '2014-03-01 00:23:29.000000', 'temperatura', 1190.0000, 'ºC'),
	(230267, 121, '2014-03-01 00:23:30.000000', 'temperatura', 672.0000, 'ºC'),
	(230268, 121, '2014-03-01 00:23:31.000000', 'temperatura', 989.0000, 'ºC'),
	(230269, 121, '2014-03-01 00:23:32.000000', 'temperatura', 528.0000, 'ºC'),
	(230270, 121, '2014-03-01 00:23:33.000000', 'temperatura', 874.0000, 'ºC'),
	(230271, 121, '2014-03-01 00:23:34.000000', 'temperatura', 389.0000, 'ºC'),
	(230272, 121, '2014-03-01 00:23:35.000000', 'temperatura', 520.0000, 'ºC'),
	(230273, 121, '2014-03-01 00:23:36.000000', 'temperatura', 236.0000, 'ºC'),
	(230274, 121, '2014-03-01 00:23:37.000000', 'temperatura', 818.0000, 'ºC'),
	(230275, 121, '2014-03-01 00:23:38.000000', 'temperatura', 983.0000, 'ºC'),
	(230276, 121, '2014-03-01 00:23:39.000000', 'temperatura', 61.0000, 'ºC'),
	(230277, 121, '2014-03-01 00:23:40.000000', 'temperatura', 958.0000, 'ºC'),
	(230278, 121, '2014-03-01 00:23:41.000000', 'temperatura', 1007.0000, 'ºC'),
	(230279, 121, '2014-03-01 00:23:42.000000', 'temperatura', 959.0000, 'ºC'),
	(230280, 121, '2014-03-01 00:23:43.000000', 'temperatura', 578.0000, 'ºC'),
	(230281, 121, '2014-03-01 00:23:44.000000', 'temperatura', 11.0000, 'ºC'),
	(230282, 121, '2014-03-01 00:23:45.000000', 'temperatura', 724.0000, 'ºC'),
	(230283, 121, '2014-03-01 00:23:46.000000', 'temperatura', 1187.0000, 'ºC'),
	(230284, 121, '2014-03-01 00:23:47.000000', 'temperatura', 165.0000, 'ºC'),
	(230285, 121, '2014-03-01 00:23:48.000000', 'temperatura', 863.0000, 'ºC'),
	(230286, 121, '2014-03-01 00:23:49.000000', 'temperatura', 219.0000, 'ºC'),
	(230287, 121, '2014-03-01 00:23:50.000000', 'temperatura', 909.0000, 'ºC'),
	(230288, 121, '2014-03-01 00:23:51.000000', 'temperatura', 288.0000, 'ºC'),
	(230289, 121, '2014-03-01 00:23:52.000000', 'temperatura', 1112.0000, 'ºC'),
	(230290, 121, '2014-03-01 00:23:53.000000', 'temperatura', 1095.0000, 'ºC'),
	(230291, 121, '2014-03-01 00:23:54.000000', 'temperatura', 942.0000, 'ºC'),
	(230292, 121, '2014-03-01 00:23:55.000000', 'temperatura', 226.0000, 'ºC'),
	(230293, 121, '2014-03-01 00:23:56.000000', 'temperatura', 703.0000, 'ºC'),
	(230294, 121, '2014-03-01 00:23:57.000000', 'temperatura', 438.0000, 'ºC'),
	(230295, 121, '2014-03-01 00:23:58.000000', 'temperatura', 80.0000, 'ºC'),
	(230296, 121, '2014-03-01 00:23:59.000000', 'temperatura', 287.0000, 'ºC'),
	(230297, 121, '2014-03-01 00:24:00.000000', 'temperatura', 1197.0000, 'ºC'),
	(230298, 121, '2014-03-01 00:24:01.000000', 'temperatura', 323.0000, 'ºC'),
	(230299, 121, '2014-03-01 00:24:02.000000', 'temperatura', 423.0000, 'ºC'),
	(230300, 121, '2014-03-01 00:24:03.000000', 'temperatura', 1148.0000, 'ºC'),
	(230301, 121, '2014-03-01 00:24:04.000000', 'temperatura', 871.0000, 'ºC'),
	(230302, 121, '2014-03-01 00:24:05.000000', 'temperatura', 911.0000, 'ºC'),
	(230303, 121, '2014-03-01 00:24:06.000000', 'temperatura', 744.0000, 'ºC'),
	(230304, 121, '2014-03-01 00:24:07.000000', 'temperatura', 986.0000, 'ºC'),
	(230305, 121, '2014-03-01 00:24:08.000000', 'temperatura', 299.0000, 'ºC'),
	(230306, 121, '2014-03-01 00:24:09.000000', 'temperatura', 936.0000, 'ºC'),
	(230307, 121, '2014-03-01 00:24:10.000000', 'temperatura', 184.0000, 'ºC'),
	(230308, 121, '2014-03-01 00:24:11.000000', 'temperatura', 513.0000, 'ºC'),
	(230309, 121, '2014-03-01 00:24:12.000000', 'temperatura', 815.0000, 'ºC'),
	(230310, 121, '2014-03-01 00:24:13.000000', 'temperatura', 135.0000, 'ºC'),
	(230311, 121, '2014-03-01 00:24:14.000000', 'temperatura', 629.0000, 'ºC'),
	(230312, 121, '2014-03-01 00:24:15.000000', 'temperatura', 342.0000, 'ºC'),
	(230313, 121, '2014-03-01 00:24:16.000000', 'temperatura', 1024.0000, 'ºC'),
	(230314, 121, '2014-03-01 00:24:17.000000', 'temperatura', 496.0000, 'ºC'),
	(230315, 121, '2014-03-01 00:24:18.000000', 'temperatura', 608.0000, 'ºC'),
	(230316, 121, '2014-03-01 00:24:19.000000', 'temperatura', 351.0000, 'ºC'),
	(230317, 121, '2014-03-01 00:24:20.000000', 'temperatura', 1132.0000, 'ºC'),
	(230318, 121, '2014-03-01 00:24:21.000000', 'temperatura', 1009.0000, 'ºC'),
	(230319, 121, '2014-03-01 00:24:22.000000', 'temperatura', 447.0000, 'ºC'),
	(230320, 121, '2014-03-01 00:24:23.000000', 'temperatura', 407.0000, 'ºC'),
	(230321, 121, '2014-03-01 00:24:24.000000', 'temperatura', 698.0000, 'ºC'),
	(230322, 121, '2014-03-01 00:24:25.000000', 'temperatura', 1069.0000, 'ºC'),
	(230323, 121, '2014-03-01 00:24:26.000000', 'temperatura', 853.0000, 'ºC'),
	(230324, 121, '2014-03-01 00:24:27.000000', 'temperatura', 1056.0000, 'ºC'),
	(230325, 121, '2014-03-01 00:24:28.000000', 'temperatura', 323.0000, 'ºC'),
	(230326, 121, '2014-03-01 00:24:29.000000', 'temperatura', 848.0000, 'ºC'),
	(230327, 121, '2014-03-01 00:24:30.000000', 'temperatura', 870.0000, 'ºC'),
	(230328, 121, '2014-03-01 00:24:31.000000', 'temperatura', 605.0000, 'ºC'),
	(230329, 121, '2014-03-01 00:24:32.000000', 'temperatura', 417.0000, 'ºC'),
	(230330, 121, '2014-03-01 00:24:33.000000', 'temperatura', 271.0000, 'ºC'),
	(230331, 121, '2014-03-01 00:24:34.000000', 'temperatura', 106.0000, 'ºC'),
	(230332, 121, '2014-03-01 00:24:35.000000', 'temperatura', 916.0000, 'ºC'),
	(230333, 121, '2014-03-01 00:24:36.000000', 'temperatura', 665.0000, 'ºC'),
	(230334, 121, '2014-03-01 00:24:37.000000', 'temperatura', 574.0000, 'ºC'),
	(230335, 121, '2014-03-01 00:24:38.000000', 'temperatura', 877.0000, 'ºC'),
	(230336, 121, '2014-03-01 00:24:39.000000', 'temperatura', 263.0000, 'ºC'),
	(230337, 121, '2014-03-01 00:24:40.000000', 'temperatura', 1083.0000, 'ºC'),
	(230338, 121, '2014-03-01 00:24:41.000000', 'temperatura', 1029.0000, 'ºC'),
	(230339, 121, '2014-03-01 00:24:42.000000', 'temperatura', 695.0000, 'ºC'),
	(230340, 121, '2014-03-01 00:24:43.000000', 'temperatura', 390.0000, 'ºC'),
	(230341, 121, '2014-03-01 00:24:44.000000', 'temperatura', 1064.0000, 'ºC'),
	(230342, 121, '2014-03-01 00:24:45.000000', 'temperatura', 551.0000, 'ºC'),
	(230343, 121, '2014-03-01 00:24:46.000000', 'temperatura', 765.0000, 'ºC'),
	(230344, 121, '2014-03-01 00:24:47.000000', 'temperatura', 971.0000, 'ºC'),
	(230345, 121, '2014-03-01 00:24:48.000000', 'temperatura', 160.0000, 'ºC'),
	(230346, 121, '2014-03-01 00:24:49.000000', 'temperatura', 286.0000, 'ºC'),
	(230347, 121, '2014-03-01 00:24:50.000000', 'temperatura', 954.0000, 'ºC'),
	(230348, 121, '2014-03-01 00:24:51.000000', 'temperatura', 309.0000, 'ºC'),
	(230349, 121, '2014-03-01 00:24:52.000000', 'temperatura', 1085.0000, 'ºC'),
	(230350, 121, '2014-03-01 00:24:53.000000', 'temperatura', 900.0000, 'ºC'),
	(230351, 121, '2014-03-01 00:24:54.000000', 'temperatura', 43.0000, 'ºC'),
	(230352, 121, '2014-03-01 00:24:55.000000', 'temperatura', 1118.0000, 'ºC'),
	(230353, 121, '2014-03-01 00:24:56.000000', 'temperatura', 661.0000, 'ºC'),
	(230354, 121, '2014-03-01 00:24:57.000000', 'temperatura', 1149.0000, 'ºC'),
	(230355, 121, '2014-03-01 00:24:58.000000', 'temperatura', 164.0000, 'ºC'),
	(230356, 121, '2014-03-01 00:24:59.000000', 'temperatura', 975.0000, 'ºC'),
	(230357, 121, '2014-03-01 00:25:00.000000', 'temperatura', 784.0000, 'ºC'),
	(230358, 121, '2014-03-01 00:25:01.000000', 'temperatura', 994.0000, 'ºC'),
	(230359, 121, '2014-03-01 00:25:02.000000', 'temperatura', 217.0000, 'ºC'),
	(230360, 121, '2014-03-01 00:25:03.000000', 'temperatura', 507.0000, 'ºC'),
	(230361, 121, '2014-03-01 00:25:04.000000', 'temperatura', 681.0000, 'ºC'),
	(230362, 121, '2014-03-01 00:25:05.000000', 'temperatura', 685.0000, 'ºC'),
	(230363, 121, '2014-03-01 00:25:06.000000', 'temperatura', 183.0000, 'ºC'),
	(230364, 121, '2014-03-01 00:25:07.000000', 'temperatura', 63.0000, 'ºC'),
	(230365, 121, '2014-03-01 00:25:08.000000', 'temperatura', 963.0000, 'ºC'),
	(230366, 121, '2014-03-01 00:25:09.000000', 'temperatura', 1028.0000, 'ºC'),
	(230367, 121, '2014-03-01 00:25:10.000000', 'temperatura', 1051.0000, 'ºC'),
	(230368, 121, '2014-03-01 00:25:11.000000', 'temperatura', 970.0000, 'ºC'),
	(230369, 121, '2014-03-01 00:25:12.000000', 'temperatura', 501.0000, 'ºC'),
	(230370, 121, '2014-03-01 00:25:13.000000', 'temperatura', 792.0000, 'ºC'),
	(230371, 121, '2014-03-01 00:25:14.000000', 'temperatura', 59.0000, 'ºC'),
	(230372, 121, '2014-03-01 00:25:15.000000', 'temperatura', 317.0000, 'ºC'),
	(230373, 121, '2014-03-01 00:25:16.000000', 'temperatura', 212.0000, 'ºC'),
	(230374, 121, '2014-03-01 00:25:17.000000', 'temperatura', 109.0000, 'ºC'),
	(230375, 121, '2014-03-01 00:25:18.000000', 'temperatura', 1110.0000, 'ºC'),
	(230376, 121, '2014-03-01 00:25:19.000000', 'temperatura', 422.0000, 'ºC'),
	(230377, 121, '2014-03-01 00:25:20.000000', 'temperatura', 1182.0000, 'ºC'),
	(230378, 121, '2014-03-01 00:25:21.000000', 'temperatura', 1042.0000, 'ºC'),
	(230379, 121, '2014-03-01 00:25:22.000000', 'temperatura', 467.0000, 'ºC'),
	(230380, 121, '2014-03-01 00:25:23.000000', 'temperatura', 410.0000, 'ºC'),
	(230381, 121, '2014-03-01 00:25:24.000000', 'temperatura', 650.0000, 'ºC'),
	(230382, 121, '2014-03-01 00:25:25.000000', 'temperatura', 818.0000, 'ºC'),
	(230383, 121, '2014-03-01 00:25:26.000000', 'temperatura', 943.0000, 'ºC'),
	(230384, 121, '2014-03-01 00:25:27.000000', 'temperatura', 1061.0000, 'ºC'),
	(230385, 121, '2014-03-01 00:25:28.000000', 'temperatura', 74.0000, 'ºC'),
	(230386, 121, '2014-03-01 00:25:29.000000', 'temperatura', 791.0000, 'ºC'),
	(230387, 121, '2014-03-01 00:25:30.000000', 'temperatura', 131.0000, 'ºC'),
	(230388, 121, '2014-03-01 00:25:31.000000', 'temperatura', 684.0000, 'ºC'),
	(230389, 121, '2014-03-01 00:25:32.000000', 'temperatura', 626.0000, 'ºC'),
	(230390, 121, '2014-03-01 00:25:33.000000', 'temperatura', 1077.0000, 'ºC'),
	(230391, 121, '2014-03-01 00:25:34.000000', 'temperatura', 1109.0000, 'ºC'),
	(230392, 121, '2014-03-01 00:25:35.000000', 'temperatura', 1117.0000, 'ºC'),
	(230393, 121, '2014-03-01 00:25:36.000000', 'temperatura', 1055.0000, 'ºC'),
	(230394, 121, '2014-03-01 00:25:37.000000', 'temperatura', 725.0000, 'ºC'),
	(230395, 121, '2014-03-01 00:25:38.000000', 'temperatura', 463.0000, 'ºC'),
	(230396, 121, '2014-03-01 00:25:39.000000', 'temperatura', 139.0000, 'ºC'),
	(230397, 121, '2014-03-01 00:25:40.000000', 'temperatura', 507.0000, 'ºC'),
	(230398, 121, '2014-03-01 00:25:41.000000', 'temperatura', 917.0000, 'ºC'),
	(230399, 121, '2014-03-01 00:25:42.000000', 'temperatura', 665.0000, 'ºC'),
	(230400, 121, '2014-03-01 00:25:43.000000', 'temperatura', 573.0000, 'ºC'),
	(230401, 121, '2014-03-01 00:25:44.000000', 'temperatura', 872.0000, 'ºC'),
	(230402, 121, '2014-03-01 00:25:45.000000', 'temperatura', 240.0000, 'ºC'),
	(230403, 121, '2014-03-01 00:25:46.000000', 'temperatura', 987.0000, 'ºC'),
	(230404, 121, '2014-03-01 00:25:47.000000', 'temperatura', 615.0000, 'ºC'),
	(230405, 121, '2014-03-01 00:25:48.000000', 'temperatura', 115.0000, 'ºC'),
	(230406, 121, '2014-03-01 00:25:49.000000', 'temperatura', 1131.0000, 'ºC'),
	(230407, 121, '2014-03-01 00:25:50.000000', 'temperatura', 512.0000, 'ºC'),
	(230408, 121, '2014-03-01 00:25:51.000000', 'temperatura', 364.0000, 'ºC'),
	(230409, 121, '2014-03-01 00:25:52.000000', 'temperatura', 286.0000, 'ºC'),
	(230410, 121, '2014-03-01 00:25:53.000000', 'temperatura', 337.0000, 'ºC'),
	(230411, 121, '2014-03-01 00:25:54.000000', 'temperatura', 827.0000, 'ºC'),
	(230412, 121, '2014-03-01 00:25:55.000000', 'temperatura', 727.0000, 'ºC'),
	(230413, 121, '2014-03-01 00:25:56.000000', 'temperatura', 1155.0000, 'ºC'),
	(230414, 121, '2014-03-01 00:25:57.000000', 'temperatura', 1194.0000, 'ºC'),
	(230415, 121, '2014-03-01 00:25:58.000000', 'temperatura', 106.0000, 'ºC'),
	(230416, 121, '2014-03-01 00:25:59.000000', 'temperatura', 549.0000, 'ºC'),
	(230417, 121, '2014-03-01 00:26:00.000000', 'temperatura', 28.0000, 'ºC'),
	(230418, 121, '2014-03-01 00:26:01.000000', 'temperatura', 893.0000, 'ºC'),
	(230419, 121, '2014-03-01 00:26:02.000000', 'temperatura', 779.0000, 'ºC'),
	(230420, 121, '2014-03-01 00:26:03.000000', 'temperatura', 18.0000, 'ºC'),
	(230421, 121, '2014-03-01 00:26:04.000000', 'temperatura', 156.0000, 'ºC'),
	(230422, 121, '2014-03-01 00:26:05.000000', 'temperatura', 723.0000, 'ºC'),
	(230423, 121, '2014-03-01 00:26:06.000000', 'temperatura', 750.0000, 'ºC'),
	(230424, 121, '2014-03-01 00:26:07.000000', 'temperatura', 379.0000, 'ºC'),
	(230425, 121, '2014-03-01 00:26:08.000000', 'temperatura', 846.0000, 'ºC'),
	(230426, 121, '2014-03-01 00:26:09.000000', 'temperatura', 694.0000, 'ºC'),
	(230427, 121, '2014-03-01 00:26:10.000000', 'temperatura', 935.0000, 'ºC'),
	(230428, 121, '2014-03-01 00:26:11.000000', 'temperatura', 190.0000, 'ºC'),
	(230429, 121, '2014-03-01 00:26:12.000000', 'temperatura', 545.0000, 'ºC'),
	(230430, 121, '2014-03-01 00:26:13.000000', 'temperatura', 956.0000, 'ºC'),
	(230431, 121, '2014-03-01 00:26:14.000000', 'temperatura', 747.0000, 'ºC'),
	(230432, 121, '2014-03-01 00:26:15.000000', 'temperatura', 868.0000, 'ºC'),
	(230433, 121, '2014-03-01 00:26:16.000000', 'temperatura', 898.0000, 'ºC'),
	(230434, 121, '2014-03-01 00:26:17.000000', 'temperatura', 689.0000, 'ºC'),
	(230435, 121, '2014-03-01 00:26:18.000000', 'temperatura', 749.0000, 'ºC'),
	(230436, 121, '2014-03-01 00:26:19.000000', 'temperatura', 477.0000, 'ºC'),
	(230437, 121, '2014-03-01 00:26:20.000000', 'temperatura', 142.0000, 'ºC'),
	(230438, 121, '2014-03-01 00:26:21.000000', 'temperatura', 477.0000, 'ºC'),
	(230439, 121, '2014-03-01 00:26:22.000000', 'temperatura', 761.0000, 'ºC'),
	(230440, 121, '2014-03-01 00:26:23.000000', 'temperatura', 1172.0000, 'ºC'),
	(230441, 121, '2014-03-01 00:26:24.000000', 'temperatura', 1181.0000, 'ºC'),
	(230442, 121, '2014-03-01 00:26:25.000000', 'temperatura', 1187.0000, 'ºC'),
	(230443, 121, '2014-03-01 00:26:26.000000', 'temperatura', 1195.0000, 'ºC'),
	(230444, 121, '2014-03-01 00:26:27.000000', 'temperatura', 14.0000, 'ºC'),
	(230445, 121, '2014-03-01 00:26:28.000000', 'temperatura', 86.0000, 'ºC'),
	(230446, 121, '2014-03-01 00:26:29.000000', 'temperatura', 388.0000, 'ºC'),
	(230447, 121, '2014-03-01 00:26:30.000000', 'temperatura', 483.0000, 'ºC'),
	(230448, 121, '2014-03-01 00:26:31.000000', 'temperatura', 51.0000, 'ºC'),
	(230449, 121, '2014-03-01 00:26:32.000000', 'temperatura', 6.0000, 'ºC'),
	(230450, 121, '2014-03-01 00:26:33.000000', 'temperatura', 1079.0000, 'ºC'),
	(230451, 121, '2014-03-01 00:26:34.000000', 'temperatura', 578.0000, 'ºC'),
	(230452, 121, '2014-03-01 00:26:35.000000', 'temperatura', 854.0000, 'ºC'),
	(230453, 121, '2014-03-01 00:26:36.000000', 'temperatura', 135.0000, 'ºC'),
	(230454, 121, '2014-03-01 00:26:37.000000', 'temperatura', 513.0000, 'ºC'),
	(230455, 121, '2014-03-01 00:26:38.000000', 'temperatura', 963.0000, 'ºC'),
	(230456, 121, '2014-03-01 00:26:39.000000', 'temperatura', 875.0000, 'ºC'),
	(230457, 121, '2014-03-01 00:26:40.000000', 'temperatura', 287.0000, 'ºC'),
	(230458, 121, '2014-03-01 00:26:41.000000', 'temperatura', 12.0000, 'ºC'),
	(230459, 121, '2014-03-01 00:26:42.000000', 'temperatura', 398.0000, 'ºC'),
	(230460, 121, '2014-03-01 00:26:43.000000', 'temperatura', 754.0000, 'ºC'),
	(230461, 121, '2014-03-01 00:26:44.000000', 'temperatura', 178.0000, 'ºC'),
	(230462, 121, '2014-03-01 00:26:45.000000', 'temperatura', 1028.0000, 'ºC'),
	(230463, 121, '2014-03-01 00:26:46.000000', 'temperatura', 1006.0000, 'ºC'),
	(230464, 121, '2014-03-01 00:26:47.000000', 'temperatura', 749.0000, 'ºC'),
	(230465, 121, '2014-03-01 00:26:48.000000', 'temperatura', 725.0000, 'ºC'),
	(230466, 121, '2014-03-01 00:26:49.000000', 'temperatura', 180.0000, 'ºC'),
	(230467, 121, '2014-03-01 00:26:50.000000', 'temperatura', 1123.0000, 'ºC'),
	(230468, 121, '2014-03-01 00:26:51.000000', 'temperatura', 278.0000, 'ºC'),
	(230469, 121, '2014-03-01 00:26:52.000000', 'temperatura', 419.0000, 'ºC'),
	(230470, 121, '2014-03-01 00:26:53.000000', 'temperatura', 63.0000, 'ºC'),
	(230471, 121, '2014-03-01 00:26:54.000000', 'temperatura', 257.0000, 'ºC'),
	(230472, 121, '2014-03-01 00:26:55.000000', 'temperatura', 1097.0000, 'ºC'),
	(230473, 121, '2014-03-01 00:26:56.000000', 'temperatura', 1114.0000, 'ºC'),
	(230474, 121, '2014-03-01 00:26:57.000000', 'temperatura', 1079.0000, 'ºC'),
	(230475, 121, '2014-03-01 00:26:58.000000', 'temperatura', 853.0000, 'ºC'),
	(230476, 121, '2014-03-01 00:26:59.000000', 'temperatura', 1030.0000, 'ºC'),
	(230477, 121, '2014-03-01 00:27:00.000000', 'temperatura', 192.0000, 'ºC'),
	(230478, 121, '2014-03-01 00:27:01.000000', 'temperatura', 271.0000, 'ºC'),
	(230479, 121, '2014-03-01 00:27:02.000000', 'temperatura', 780.0000, 'ºC'),
	(230480, 121, '2014-03-01 00:27:03.000000', 'temperatura', 687.0000, 'ºC'),
	(230481, 121, '2014-03-01 00:27:04.000000', 'temperatura', 1097.0000, 'ºC'),
	(230482, 121, '2014-03-01 00:27:05.000000', 'temperatura', 1022.0000, 'ºC'),
	(230483, 121, '2014-03-01 00:27:06.000000', 'temperatura', 619.0000, 'ºC'),
	(230484, 121, '2014-03-01 00:27:07.000000', 'temperatura', 30.0000, 'ºC'),
	(230485, 121, '2014-03-01 00:27:08.000000', 'temperatura', 693.0000, 'ºC'),
	(230486, 121, '2014-03-01 00:27:09.000000', 'temperatura', 976.0000, 'ºC'),
	(230487, 121, '2014-03-01 00:27:10.000000', 'temperatura', 402.0000, 'ºC'),
	(230488, 121, '2014-03-01 00:27:11.000000', 'temperatura', 281.0000, 'ºC'),
	(230489, 121, '2014-03-01 00:27:12.000000', 'temperatura', 199.0000, 'ºC'),
	(230490, 121, '2014-03-01 00:27:13.000000', 'temperatura', 153.0000, 'ºC'),
	(230491, 121, '2014-03-01 00:27:14.000000', 'temperatura', 168.0000, 'ºC'),
	(230492, 121, '2014-03-01 00:27:15.000000', 'temperatura', 384.0000, 'ºC'),
	(230493, 121, '2014-03-01 00:27:16.000000', 'temperatura', 215.0000, 'ºC'),
	(230494, 121, '2014-03-01 00:27:17.000000', 'temperatura', 1125.0000, 'ºC'),
	(230495, 121, '2014-03-01 00:27:18.000000', 'temperatura', 178.0000, 'ºC'),
	(230496, 121, '2014-03-01 00:27:19.000000', 'temperatura', 1118.0000, 'ºC'),
	(230497, 121, '2014-03-01 00:27:20.000000', 'temperatura', 254.0000, 'ºC'),
	(230498, 121, '2014-03-01 00:27:21.000000', 'temperatura', 316.0000, 'ºC'),
	(230499, 121, '2014-03-01 00:27:22.000000', 'temperatura', 822.0000, 'ºC'),
	(230500, 121, '2014-03-01 00:27:23.000000', 'temperatura', 759.0000, 'ºC'),
	(230501, 121, '2014-03-01 00:27:24.000000', 'temperatura', 133.0000, 'ºC'),
	(230502, 121, '2014-03-01 00:27:25.000000', 'temperatura', 786.0000, 'ºC'),
	(230503, 121, '2014-03-01 00:27:26.000000', 'temperatura', 1133.0000, 'ºC'),
	(230504, 121, '2014-03-01 00:27:27.000000', 'temperatura', 907.0000, 'ºC'),
	(230505, 121, '2014-03-01 00:27:28.000000', 'temperatura', 1136.0000, 'ºC'),
	(230506, 121, '2014-03-01 00:27:29.000000', 'temperatura', 561.0000, 'ºC'),
	(230507, 121, '2014-03-01 00:27:30.000000', 'temperatura', 596.0000, 'ºC'),
	(230508, 121, '2014-03-01 00:27:31.000000', 'temperatura', 99.0000, 'ºC'),
	(230509, 121, '2014-03-01 00:27:32.000000', 'temperatura', 1105.0000, 'ºC'),
	(230510, 121, '2014-03-01 00:27:33.000000', 'temperatura', 432.0000, 'ºC'),
	(230511, 121, '2014-03-01 00:27:34.000000', 'temperatura', 42.0000, 'ºC'),
	(230512, 121, '2014-03-01 00:27:35.000000', 'temperatura', 118.0000, 'ºC'),
	(230513, 121, '2014-03-01 00:27:36.000000', 'temperatura', 462.0000, 'ºC'),
	(230514, 121, '2014-03-01 00:27:37.000000', 'temperatura', 759.0000, 'ºC'),
	(230515, 121, '2014-03-01 00:27:38.000000', 'temperatura', 8.0000, 'ºC'),
	(230516, 121, '2014-03-01 00:27:39.000000', 'temperatura', 162.0000, 'ºC'),
	(230517, 121, '2014-03-01 00:27:40.000000', 'temperatura', 788.0000, 'ºC'),
	(230518, 121, '2014-03-01 00:27:41.000000', 'temperatura', 1053.0000, 'ºC'),
	(230519, 121, '2014-03-01 00:27:42.000000', 'temperatura', 504.0000, 'ºC'),
	(230520, 121, '2014-03-01 00:27:43.000000', 'temperatura', 560.0000, 'ºC'),
	(230521, 121, '2014-03-01 00:27:44.000000', 'temperatura', 89.0000, 'ºC'),
	(230522, 121, '2014-03-01 00:27:45.000000', 'temperatura', 1164.0000, 'ºC'),
	(230523, 121, '2014-03-01 00:27:46.000000', 'temperatura', 755.0000, 'ºC'),
	(230524, 121, '2014-03-01 00:27:47.000000', 'temperatura', 284.0000, 'ºC'),
	(230525, 121, '2014-03-01 00:27:48.000000', 'temperatura', 353.0000, 'ºC'),
	(230526, 121, '2014-03-01 00:27:49.000000', 'temperatura', 915.0000, 'ºC'),
	(230527, 121, '2014-03-01 00:27:50.000000', 'temperatura', 1118.0000, 'ºC'),
	(230528, 121, '2014-03-01 00:27:51.000000', 'temperatura', 445.0000, 'ºC'),
	(230529, 121, '2014-03-01 00:27:52.000000', 'temperatura', 71.0000, 'ºC'),
	(230530, 121, '2014-03-01 00:27:53.000000', 'temperatura', 221.0000, 'ºC'),
	(230531, 121, '2014-03-01 00:27:54.000000', 'temperatura', 892.0000, 'ºC'),
	(230532, 121, '2014-03-01 00:27:55.000000', 'temperatura', 199.0000, 'ºC'),
	(230533, 121, '2014-03-01 00:27:56.000000', 'temperatura', 717.0000, 'ºC'),
	(230534, 121, '2014-03-01 00:27:57.000000', 'temperatura', 591.0000, 'ºC'),
	(230535, 121, '2014-03-01 00:27:58.000000', 'temperatura', 805.0000, 'ºC'),
	(230536, 121, '2014-03-01 00:27:59.000000', 'temperatura', 1050.0000, 'ºC'),
	(230537, 121, '2014-03-01 00:28:00.000000', 'temperatura', 437.0000, 'ºC'),
	(230538, 121, '2014-03-01 00:28:01.000000', 'temperatura', 234.0000, 'ºC'),
	(230539, 121, '2014-03-01 00:28:02.000000', 'temperatura', 1059.0000, 'ºC'),
	(230540, 121, '2014-03-01 00:28:03.000000', 'temperatura', 993.0000, 'ºC'),
	(230541, 121, '2014-03-01 00:28:04.000000', 'temperatura', 589.0000, 'ºC'),
	(230542, 121, '2014-03-01 00:28:05.000000', 'temperatura', 1165.0000, 'ºC'),
	(230543, 121, '2014-03-01 00:28:06.000000', 'temperatura', 460.0000, 'ºC'),
	(230544, 121, '2014-03-01 00:28:07.000000', 'temperatura', 7.0000, 'ºC'),
	(230545, 121, '2014-03-01 00:28:08.000000', 'temperatura', 1055.0000, 'ºC'),
	(230546, 121, '2014-03-01 00:28:09.000000', 'temperatura', 453.0000, 'ºC'),
	(230547, 121, '2014-03-01 00:28:10.000000', 'temperatura', 300.0000, 'ºC'),
	(230548, 121, '2014-03-01 00:28:11.000000', 'temperatura', 142.0000, 'ºC'),
	(230549, 121, '2014-03-01 00:28:12.000000', 'temperatura', 1009.0000, 'ºC'),
	(230550, 121, '2014-03-01 00:28:13.000000', 'temperatura', 1022.0000, 'ºC'),
	(230551, 121, '2014-03-01 00:28:14.000000', 'temperatura', 883.0000, 'ºC'),
	(230552, 121, '2014-03-01 00:28:15.000000', 'temperatura', 149.0000, 'ºC'),
	(230553, 121, '2014-03-01 00:28:16.000000', 'temperatura', 495.0000, 'ºC'),
	(230554, 121, '2014-03-01 00:28:17.000000', 'temperatura', 830.0000, 'ºC'),
	(230555, 121, '2014-03-01 00:28:18.000000', 'temperatura', 263.0000, 'ºC'),
	(230556, 121, '2014-03-01 00:28:19.000000', 'temperatura', 28.0000, 'ºC'),
	(230557, 121, '2014-03-01 00:28:20.000000', 'temperatura', 551.0000, 'ºC'),
	(230558, 121, '2014-03-01 00:28:21.000000', 'temperatura', 272.0000, 'ºC'),
	(230559, 121, '2014-03-01 00:28:22.000000', 'temperatura', 908.0000, 'ºC'),
	(230560, 121, '2014-03-01 00:28:23.000000', 'temperatura', 123.0000, 'ºC'),
	(230561, 121, '2014-03-01 00:28:24.000000', 'temperatura', 291.0000, 'ºC'),
	(230562, 121, '2014-03-01 00:28:25.000000', 'temperatura', 1088.0000, 'ºC'),
	(230563, 121, '2014-03-01 00:28:26.000000', 'temperatura', 966.0000, 'ºC'),
	(230564, 121, '2014-03-01 00:28:27.000000', 'temperatura', 366.0000, 'ºC'),
	(230565, 121, '2014-03-01 00:28:28.000000', 'temperatura', 131.0000, 'ºC'),
	(230566, 121, '2014-03-01 00:28:29.000000', 'temperatura', 761.0000, 'ºC'),
	(230567, 121, '2014-03-01 00:28:30.000000', 'temperatura', 1012.0000, 'ºC'),
	(230568, 121, '2014-03-01 00:28:31.000000', 'temperatura', 377.0000, 'ºC'),
	(230569, 121, '2014-03-01 00:28:32.000000', 'temperatura', 51.0000, 'ºC'),
	(230570, 121, '2014-03-01 00:28:33.000000', 'temperatura', 324.0000, 'ºC'),
	(230571, 121, '2014-03-01 00:28:34.000000', 'temperatura', 269.0000, 'ºC'),
	(230572, 121, '2014-03-01 00:28:35.000000', 'temperatura', 371.0000, 'ºC'),
	(230573, 121, '2014-03-01 00:28:36.000000', 'temperatura', 1050.0000, 'ºC'),
	(230574, 121, '2014-03-01 00:28:37.000000', 'temperatura', 535.0000, 'ºC'),
	(230575, 121, '2014-03-01 00:28:38.000000', 'temperatura', 727.0000, 'ºC'),
	(230576, 121, '2014-03-01 00:28:39.000000', 'temperatura', 830.0000, 'ºC'),
	(230577, 121, '2014-03-01 00:28:40.000000', 'temperatura', 768.0000, 'ºC'),
	(230578, 121, '2014-03-01 00:28:41.000000', 'temperatura', 151.0000, 'ºC'),
	(230579, 121, '2014-03-01 00:28:42.000000', 'temperatura', 852.0000, 'ºC'),
	(230580, 121, '2014-03-01 00:28:43.000000', 'temperatura', 207.0000, 'ºC'),
	(230581, 121, '2014-03-01 00:28:44.000000', 'temperatura', 882.0000, 'ºC'),
	(230582, 121, '2014-03-01 00:28:45.000000', 'temperatura', 187.0000, 'ºC'),
	(230583, 121, '2014-03-01 00:28:46.000000', 'temperatura', 690.0000, 'ºC'),
	(230584, 121, '2014-03-01 00:28:47.000000', 'temperatura', 490.0000, 'ºC'),
	(230585, 121, '2014-03-01 00:28:48.000000', 'temperatura', 381.0000, 'ºC'),
	(230586, 121, '2014-03-01 00:28:49.000000', 'temperatura', 433.0000, 'ºC'),
	(230587, 121, '2014-03-01 00:28:50.000000', 'temperatura', 1025.0000, 'ºC'),
	(230588, 121, '2014-03-01 00:28:51.000000', 'temperatura', 226.0000, 'ºC'),
	(230589, 121, '2014-03-01 00:28:52.000000', 'temperatura', 453.0000, 'ºC'),
	(230590, 121, '2014-03-01 00:28:53.000000', 'temperatura', 390.0000, 'ºC'),
	(230591, 121, '2014-03-01 00:28:54.000000', 'temperatura', 592.0000, 'ºC'),
	(230592, 121, '2014-03-01 00:28:55.000000', 'temperatura', 589.0000, 'ºC'),
	(230593, 121, '2014-03-01 00:28:56.000000', 'temperatura', 1169.0000, 'ºC'),
	(230594, 121, '2014-03-01 00:28:57.000000', 'temperatura', 481.0000, 'ºC'),
	(230595, 121, '2014-03-01 00:28:58.000000', 'temperatura', 97.0000, 'ºC'),
	(230596, 121, '2014-03-01 00:28:59.000000', 'temperatura', 241.0000, 'ºC'),
	(230597, 121, '2014-03-01 00:29:00.000000', 'temperatura', 916.0000, 'ºC'),
	(230598, 121, '2014-03-01 00:29:01.000000', 'temperatura', 257.0000, 'ºC'),
	(230599, 121, '2014-03-01 00:29:02.000000', 'temperatura', 938.0000, 'ºC'),
	(230600, 121, '2014-03-01 00:29:03.000000', 'temperatura', 317.0000, 'ºC'),
	(230601, 121, '2014-03-01 00:29:04.000000', 'temperatura', 1175.0000, 'ºC'),
	(230602, 121, '2014-03-01 00:29:05.000000', 'temperatura', 122.0000, 'ºC'),
	(230603, 121, '2014-03-01 00:29:06.000000', 'temperatura', 686.0000, 'ºC'),
	(230604, 121, '2014-03-01 00:29:07.000000', 'temperatura', 666.0000, 'ºC'),
	(230605, 121, '2014-03-01 00:29:08.000000', 'temperatura', 70.0000, 'ºC'),
	(230606, 121, '2014-03-01 00:29:09.000000', 'temperatura', 752.0000, 'ºC'),
	(230607, 121, '2014-03-01 00:29:10.000000', 'temperatura', 1154.0000, 'ºC'),
	(230608, 121, '2014-03-01 00:29:11.000000', 'temperatura', 1111.0000, 'ºC'),
	(230609, 121, '2014-03-01 00:29:12.000000', 'temperatura', 894.0000, 'ºC'),
	(230610, 121, '2014-03-01 00:29:13.000000', 'temperatura', 1138.0000, 'ºC'),
	(230611, 121, '2014-03-01 00:29:14.000000', 'temperatura', 610.0000, 'ºC'),
	(230612, 121, '2014-03-01 00:29:15.000000', 'temperatura', 836.0000, 'ºC'),
	(230613, 121, '2014-03-01 00:29:16.000000', 'temperatura', 1151.0000, 'ºC'),
	(230614, 121, '2014-03-01 00:29:17.000000', 'temperatura', 848.0000, 'ºC'),
	(230615, 121, '2014-03-01 00:29:18.000000', 'temperatura', 787.0000, 'ºC'),
	(230616, 121, '2014-03-01 00:29:19.000000', 'temperatura', 191.0000, 'ºC'),
	(230617, 121, '2014-03-01 00:29:20.000000', 'temperatura', 993.0000, 'ºC'),
	(230618, 121, '2014-03-01 00:29:21.000000', 'temperatura', 794.0000, 'ºC'),
	(230619, 121, '2014-03-01 00:29:22.000000', 'temperatura', 991.0000, 'ºC'),
	(230620, 121, '2014-03-01 00:29:23.000000', 'temperatura', 173.0000, 'ºC'),
	(230621, 121, '2014-03-01 00:29:24.000000', 'temperatura', 292.0000, 'ºC'),
	(230622, 121, '2014-03-01 00:29:25.000000', 'temperatura', 941.0000, 'ºC'),
	(230623, 121, '2014-03-01 00:29:26.000000', 'temperatura', 230.0000, 'ºC'),
	(230624, 121, '2014-03-01 00:29:27.000000', 'temperatura', 729.0000, 'ºC'),
	(230625, 121, '2014-03-01 00:29:28.000000', 'temperatura', 556.0000, 'ºC'),
	(230626, 121, '2014-03-01 00:29:29.000000', 'temperatura', 593.0000, 'ºC'),
	(230627, 121, '2014-03-01 00:29:30.000000', 'temperatura', 99.0000, 'ºC'),
	(230628, 121, '2014-03-01 00:29:31.000000', 'temperatura', 1114.0000, 'ºC'),
	(230629, 121, '2014-03-01 00:29:32.000000', 'temperatura', 474.0000, 'ºC'),
	(230630, 121, '2014-03-01 00:29:33.000000', 'temperatura', 229.0000, 'ºC'),
	(230631, 121, '2014-03-01 00:29:34.000000', 'temperatura', 925.0000, 'ºC'),
	(230632, 121, '2014-03-01 00:29:35.000000', 'temperatura', 339.0000, 'ºC'),
	(230633, 121, '2014-03-01 00:29:36.000000', 'temperatura', 121.0000, 'ºC'),
	(230634, 121, '2014-03-01 00:29:37.000000', 'temperatura', 786.0000, 'ºC'),
	(230635, 121, '2014-03-01 00:29:38.000000', 'temperatura', 1167.0000, 'ºC'),
	(230636, 121, '2014-03-01 00:29:39.000000', 'temperatura', 1077.0000, 'ºC'),
	(230637, 121, '2014-03-01 00:29:40.000000', 'temperatura', 685.0000, 'ºC'),
	(230638, 121, '2014-03-01 00:29:41.000000', 'temperatura', 196.0000, 'ºC'),
	(230639, 121, '2014-03-01 00:29:42.000000', 'temperatura', 124.0000, 'ºC'),
	(230640, 121, '2014-03-01 00:29:43.000000', 'temperatura', 33.0000, 'ºC'),
	(230641, 121, '2014-03-01 00:29:44.000000', 'temperatura', 993.0000, 'ºC'),
	(230642, 121, '2014-03-01 00:29:45.000000', 'temperatura', 67.0000, 'ºC'),
	(230643, 121, '2014-03-01 00:29:46.000000', 'temperatura', 957.0000, 'ºC'),
	(230644, 121, '2014-03-01 00:29:47.000000', 'temperatura', 982.0000, 'ºC'),
	(230645, 121, '2014-03-01 00:29:48.000000', 'temperatura', 841.0000, 'ºC'),
	(230646, 121, '2014-03-01 00:29:49.000000', 'temperatura', 59.0000, 'ºC'),
	(230647, 121, '2014-03-01 00:29:50.000000', 'temperatura', 175.0000, 'ºC'),
	(230648, 121, '2014-03-01 00:29:51.000000', 'temperatura', 696.0000, 'ºC'),
	(230649, 121, '2014-03-01 00:29:52.000000', 'temperatura', 557.0000, 'ºC'),
	(230650, 121, '2014-03-01 00:29:53.000000', 'temperatura', 698.0000, 'ºC'),
	(230651, 121, '2014-03-01 00:29:54.000000', 'temperatura', 617.0000, 'ºC'),
	(230652, 121, '2014-03-01 00:29:55.000000', 'temperatura', 991.0000, 'ºC'),
	(230653, 121, '2014-03-01 00:29:56.000000', 'temperatura', 706.0000, 'ºC'),
	(230654, 121, '2014-03-01 00:29:57.000000', 'temperatura', 557.0000, 'ºC'),
	(230655, 121, '2014-03-01 00:29:58.000000', 'temperatura', 668.0000, 'ºC'),
	(230656, 121, '2014-03-01 00:29:59.000000', 'temperatura', 469.0000, 'ºC'),
	(230657, 121, '2014-03-01 00:30:00.000000', 'temperatura', 341.0000, 'ºC'),
	(230658, 121, '2014-03-01 00:30:01.000000', 'temperatura', 300.0000, 'ºC'),
	(230659, 121, '2014-03-01 00:30:02.000000', 'temperatura', 476.0000, 'ºC'),
	(230660, 121, '2014-03-01 00:30:03.000000', 'temperatura', 281.0000, 'ºC'),
	(230661, 121, '2014-03-01 00:30:04.000000', 'temperatura', 1176.0000, 'ºC'),
	(230662, 121, '2014-03-01 00:30:05.000000', 'temperatura', 240.0000, 'ºC'),
	(230663, 121, '2014-03-01 00:30:06.000000', 'temperatura', 71.0000, 'ºC'),
	(230664, 121, '2014-03-01 00:30:07.000000', 'temperatura', 837.0000, 'ºC'),
	(230665, 121, '2014-03-01 00:30:08.000000', 'temperatura', 372.0000, 'ºC'),
	(230666, 121, '2014-03-01 00:30:09.000000', 'temperatura', 548.0000, 'ºC'),
	(230667, 121, '2014-03-01 00:30:10.000000', 'temperatura', 425.0000, 'ºC'),
	(230668, 121, '2014-03-01 00:30:11.000000', 'temperatura', 481.0000, 'ºC'),
	(230669, 121, '2014-03-01 00:30:12.000000', 'temperatura', 1129.0000, 'ºC'),
	(230670, 121, '2014-03-01 00:30:13.000000', 'temperatura', 605.0000, 'ºC'),
	(230671, 121, '2014-03-01 00:30:14.000000', 'temperatura', 839.0000, 'ºC'),
	(230672, 121, '2014-03-01 00:30:15.000000', 'temperatura', 1180.0000, 'ºC'),
	(230673, 121, '2014-03-01 00:30:16.000000', 'temperatura', 982.0000, 'ºC'),
	(230674, 121, '2014-03-01 00:30:17.000000', 'temperatura', 169.0000, 'ºC'),
	(230675, 121, '2014-03-01 00:30:18.000000', 'temperatura', 302.0000, 'ºC'),
	(230676, 121, '2014-03-01 00:30:19.000000', 'temperatura', 1004.0000, 'ºC'),
	(230677, 121, '2014-03-01 00:30:20.000000', 'temperatura', 515.0000, 'ºC'),
	(230678, 121, '2014-03-01 00:30:21.000000', 'temperatura', 762.0000, 'ºC'),
	(230679, 121, '2014-03-01 00:30:22.000000', 'temperatura', 1064.0000, 'ºC'),
	(230680, 121, '2014-03-01 00:30:23.000000', 'temperatura', 636.0000, 'ºC'),
	(230681, 121, '2014-03-01 00:30:24.000000', 'temperatura', 1187.0000, 'ºC'),
	(230682, 121, '2014-03-01 00:30:25.000000', 'temperatura', 430.0000, 'ºC'),
	(230683, 121, '2014-03-01 00:30:26.000000', 'temperatura', 987.0000, 'ºC'),
	(230684, 121, '2014-03-01 00:30:27.000000', 'temperatura', 48.0000, 'ºC'),
	(230685, 121, '2014-03-01 00:30:28.000000', 'temperatura', 876.0000, 'ºC'),
	(230686, 121, '2014-03-01 00:30:29.000000', 'temperatura', 640.0000, 'ºC'),
	(230687, 121, '2014-03-01 00:30:30.000000', 'temperatura', 570.0000, 'ºC'),
	(230688, 121, '2014-03-01 00:30:31.000000', 'temperatura', 932.0000, 'ºC'),
	(230689, 121, '2014-03-01 00:30:32.000000', 'temperatura', 549.0000, 'ºC'),
	(230690, 121, '2014-03-01 00:30:33.000000', 'temperatura', 1148.0000, 'ºC'),
	(230691, 121, '2014-03-01 00:30:34.000000', 'temperatura', 496.0000, 'ºC'),
	(230692, 121, '2014-03-01 00:30:35.000000', 'temperatura', 234.0000, 'ºC'),
	(230693, 121, '2014-03-01 00:30:36.000000', 'temperatura', 883.0000, 'ºC'),
	(230694, 121, '2014-03-01 00:30:37.000000', 'temperatura', 116.0000, 'ºC'),
	(230695, 121, '2014-03-01 00:30:38.000000', 'temperatura', 330.0000, 'ºC'),
	(230696, 121, '2014-03-01 00:30:39.000000', 'temperatura', 102.0000, 'ºC'),
	(230697, 121, '2014-03-01 00:30:40.000000', 'temperatura', 722.0000, 'ºC'),
	(230698, 121, '2014-03-01 00:30:41.000000', 'temperatura', 904.0000, 'ºC'),
	(230699, 121, '2014-03-01 00:30:42.000000', 'temperatura', 1155.0000, 'ºC'),
	(230700, 121, '2014-03-01 00:30:43.000000', 'temperatura', 663.0000, 'ºC'),
	(230701, 121, '2014-03-01 00:30:44.000000', 'temperatura', 1051.0000, 'ºC'),
	(230702, 121, '2014-03-01 00:30:45.000000', 'temperatura', 867.0000, 'ºC'),
	(230703, 121, '2014-03-01 00:30:46.000000', 'temperatura', 1182.0000, 'ºC'),
	(230704, 121, '2014-03-01 00:30:47.000000', 'temperatura', 911.0000, 'ºC'),
	(230705, 121, '2014-03-01 00:30:48.000000', 'temperatura', 1011.0000, 'ºC'),
	(230706, 121, '2014-03-01 00:30:49.000000', 'temperatura', 1119.0000, 'ºC'),
	(230707, 121, '2014-03-01 00:30:50.000000', 'temperatura', 162.0000, 'ºC'),
	(230708, 121, '2014-03-01 00:30:51.000000', 'temperatura', 1054.0000, 'ºC'),
	(230709, 121, '2014-03-01 00:30:52.000000', 'temperatura', 1183.0000, 'ºC'),
	(230710, 121, '2014-03-01 00:30:53.000000', 'temperatura', 356.0000, 'ºC'),
	(230711, 121, '2014-03-01 00:30:54.000000', 'temperatura', 632.0000, 'ºC'),
	(230712, 121, '2014-03-01 00:30:55.000000', 'temperatura', 892.0000, 'ºC'),
	(230713, 121, '2014-03-01 00:30:56.000000', 'temperatura', 165.0000, 'ºC'),
	(230714, 121, '2014-03-01 00:30:57.000000', 'temperatura', 547.0000, 'ºC'),
	(230715, 121, '2014-03-01 00:30:58.000000', 'temperatura', 1043.0000, 'ºC'),
	(230716, 121, '2014-03-01 00:30:59.000000', 'temperatura', 1173.0000, 'ºC'),
	(230717, 121, '2014-03-01 00:31:00.000000', 'temperatura', 335.0000, 'ºC'),
	(230718, 121, '2014-03-01 00:31:01.000000', 'temperatura', 558.0000, 'ºC'),
	(230719, 121, '2014-03-01 00:31:02.000000', 'temperatura', 587.0000, 'ºC'),
	(230720, 121, '2014-03-01 00:31:03.000000', 'temperatura', 62.0000, 'ºC'),
	(230721, 121, '2014-03-01 00:31:04.000000', 'temperatura', 950.0000, 'ºC'),
	(230722, 121, '2014-03-01 00:31:05.000000', 'temperatura', 965.0000, 'ºC'),
	(230723, 121, '2014-03-01 00:31:06.000000', 'temperatura', 775.0000, 'ºC'),
	(230724, 121, '2014-03-01 00:31:07.000000', 'temperatura', 982.0000, 'ºC'),
	(230725, 121, '2014-03-01 00:31:08.000000', 'temperatura', 184.0000, 'ºC'),
	(230726, 121, '2014-03-01 00:31:09.000000', 'temperatura', 375.0000, 'ºC'),
	(230727, 121, '2014-03-01 00:31:10.000000', 'temperatura', 124.0000, 'ºC'),
	(230728, 121, '2014-03-01 00:31:11.000000', 'temperatura', 695.0000, 'ºC'),
	(230729, 121, '2014-03-01 00:31:12.000000', 'temperatura', 705.0000, 'ºC'),
	(230730, 121, '2014-03-01 00:31:13.000000', 'temperatura', 241.0000, 'ºC'),
	(230731, 121, '2014-03-01 00:31:14.000000', 'temperatura', 291.0000, 'ºC'),
	(230732, 121, '2014-03-01 00:31:15.000000', 'temperatura', 733.0000, 'ºC'),
	(230733, 121, '2014-03-01 00:31:16.000000', 'temperatura', 392.0000, 'ºC'),
	(230734, 121, '2014-03-01 00:31:17.000000', 'temperatura', 963.0000, 'ºC'),
	(230735, 121, '2014-03-01 00:31:18.000000', 'temperatura', 37.0000, 'ºC'),
	(230736, 121, '2014-03-01 00:31:19.000000', 'temperatura', 895.0000, 'ºC'),
	(230737, 121, '2014-03-01 00:31:20.000000', 'temperatura', 767.0000, 'ºC'),
	(230738, 121, '2014-03-01 00:31:21.000000', 'temperatura', 1150.0000, 'ºC'),
	(230739, 121, '2014-03-01 00:31:22.000000', 'temperatura', 1050.0000, 'ºC'),
	(230740, 121, '2014-03-01 00:31:23.000000', 'temperatura', 599.0000, 'ºC'),
	(230741, 121, '2014-03-01 00:31:24.000000', 'temperatura', 1046.0000, 'ºC'),
	(230742, 121, '2014-03-01 00:31:25.000000', 'temperatura', 1034.0000, 'ºC'),
	(230743, 121, '2014-03-01 00:31:26.000000', 'temperatura', 833.0000, 'ºC'),
	(230744, 121, '2014-03-01 00:31:27.000000', 'temperatura', 1065.0000, 'ºC'),
	(230745, 121, '2014-03-01 00:31:28.000000', 'temperatura', 424.0000, 'ºC'),
	(230746, 121, '2014-03-01 00:31:29.000000', 'temperatura', 125.0000, 'ºC'),
	(230747, 121, '2014-03-01 00:31:30.000000', 'temperatura', 555.0000, 'ºC'),
	(230748, 121, '2014-03-01 00:31:31.000000', 'temperatura', 1199.0000, 'ºC'),
	(230749, 121, '2014-03-01 00:31:32.000000', 'temperatura', 733.0000, 'ºC'),
	(230750, 121, '2014-03-01 00:31:33.000000', 'temperatura', 68.0000, 'ºC'),
	(230751, 121, '2014-03-01 00:31:34.000000', 'temperatura', 541.0000, 'ºC'),
	(230752, 121, '2014-03-01 00:31:35.000000', 'temperatura', 102.0000, 'ºC'),
	(230753, 121, '2014-03-01 00:31:36.000000', 'temperatura', 87.0000, 'ºC'),
	(230754, 121, '2014-03-01 00:31:37.000000', 'temperatura', 128.0000, 'ºC'),
	(230755, 121, '2014-03-01 00:31:38.000000', 'temperatura', 380.0000, 'ºC'),
	(230756, 121, '2014-03-01 00:31:39.000000', 'temperatura', 317.0000, 'ºC'),
	(230757, 121, '2014-03-01 00:31:40.000000', 'temperatura', 447.0000, 'ºC'),
	(230758, 121, '2014-03-01 00:31:41.000000', 'temperatura', 85.0000, 'ºC'),
	(230759, 121, '2014-03-01 00:31:42.000000', 'temperatura', 283.0000, 'ºC'),
	(230760, 121, '2014-03-01 00:31:43.000000', 'temperatura', 1159.0000, 'ºC'),
	(230761, 121, '2014-03-01 00:31:44.000000', 'temperatura', 147.0000, 'ºC'),
	(230762, 121, '2014-03-01 00:31:45.000000', 'temperatura', 857.0000, 'ºC'),
	(230763, 121, '2014-03-01 00:31:46.000000', 'temperatura', 248.0000, 'ºC'),
	(230764, 121, '2014-03-01 00:31:47.000000', 'temperatura', 1067.0000, 'ºC'),
	(230765, 121, '2014-03-01 00:31:48.000000', 'temperatura', 992.0000, 'ºC'),
	(230766, 121, '2014-03-01 00:31:49.000000', 'temperatura', 559.0000, 'ºC'),
	(230767, 121, '2014-03-01 00:31:50.000000', 'temperatura', 1020.0000, 'ºC'),
	(230768, 121, '2014-03-01 00:31:51.000000', 'temperatura', 1024.0000, 'ºC'),
	(230769, 121, '2014-03-01 00:31:52.000000', 'temperatura', 858.0000, 'ºC'),
	(230770, 121, '2014-03-01 00:31:53.000000', 'temperatura', 20.0000, 'ºC'),
	(230771, 121, '2014-03-01 00:31:54.000000', 'temperatura', 1126.0000, 'ºC'),
	(230772, 121, '2014-03-01 00:31:55.000000', 'temperatura', 772.0000, 'ºC'),
	(230773, 121, '2014-03-01 00:31:56.000000', 'temperatura', 480.0000, 'ºC'),
	(230774, 121, '2014-03-01 00:31:57.000000', 'temperatura', 86.0000, 'ºC'),
	(230775, 121, '2014-03-01 00:31:58.000000', 'temperatura', 191.0000, 'ºC'),
	(230776, 121, '2014-03-01 00:31:59.000000', 'temperatura', 699.0000, 'ºC'),
	(230777, 121, '2014-03-01 00:32:00.000000', 'temperatura', 519.0000, 'ºC'),
	(230778, 121, '2014-03-01 00:32:01.000000', 'temperatura', 502.0000, 'ºC'),
	(230779, 121, '2014-03-01 00:32:02.000000', 'temperatura', 951.0000, 'ºC'),
	(230780, 121, '2014-03-01 00:32:03.000000', 'temperatura', 851.0000, 'ºC'),
	(230781, 121, '2014-03-01 00:32:04.000000', 'temperatura', 200.0000, 'ºC'),
	(230782, 121, '2014-03-01 00:32:05.000000', 'temperatura', 848.0000, 'ºC'),
	(230783, 121, '2014-03-01 00:32:06.000000', 'temperatura', 42.0000, 'ºC'),
	(230784, 121, '2014-03-01 00:32:07.000000', 'temperatura', 65.0000, 'ºC'),
	(230785, 121, '2014-03-01 00:32:08.000000', 'temperatura', 202.0000, 'ºC'),
	(230786, 121, '2014-03-01 00:32:09.000000', 'temperatura', 814.0000, 'ºC'),
	(230787, 121, '2014-03-01 00:32:10.000000', 'temperatura', 1063.0000, 'ºC'),
	(230788, 121, '2014-03-01 00:32:11.000000', 'temperatura', 475.0000, 'ºC'),
	(230789, 121, '2014-03-01 00:32:12.000000', 'temperatura', 384.0000, 'ºC'),
	(230790, 121, '2014-03-01 00:32:13.000000', 'temperatura', 499.0000, 'ºC'),
	(230791, 121, '2014-03-01 00:32:14.000000', 'temperatura', 140.0000, 'ºC'),
	(230792, 121, '2014-03-01 00:32:15.000000', 'temperatura', 406.0000, 'ºC'),
	(230793, 121, '2014-03-01 00:32:16.000000', 'temperatura', 409.0000, 'ºC'),
	(230794, 121, '2014-03-01 00:32:17.000000', 'temperatura', 828.0000, 'ºC'),
	(230795, 121, '2014-03-01 00:32:18.000000', 'temperatura', 515.0000, 'ºC'),
	(230796, 121, '2014-03-01 00:32:19.000000', 'temperatura', 89.0000, 'ºC'),
	(230797, 121, '2014-03-01 00:32:20.000000', 'temperatura', 101.0000, 'ºC'),
	(230798, 121, '2014-03-01 00:32:21.000000', 'temperatura', 239.0000, 'ºC'),
	(230799, 121, '2014-03-01 00:32:22.000000', 'temperatura', 893.0000, 'ºC'),
	(230800, 121, '2014-03-01 00:32:23.000000', 'temperatura', 150.0000, 'ºC'),
	(230801, 121, '2014-03-01 00:32:24.000000', 'temperatura', 469.0000, 'ºC'),
	(230802, 121, '2014-03-01 00:32:25.000000', 'temperatura', 696.0000, 'ºC'),
	(230803, 121, '2014-03-01 00:32:26.000000', 'temperatura', 874.0000, 'ºC'),
	(230804, 121, '2014-03-01 00:32:27.000000', 'temperatura', 1083.0000, 'ºC'),
	(230805, 121, '2014-03-01 00:32:28.000000', 'temperatura', 395.0000, 'ºC'),
	(230806, 121, '2014-03-01 00:32:29.000000', 'temperatura', 1125.0000, 'ºC'),
	(230807, 121, '2014-03-01 00:32:30.000000', 'temperatura', 839.0000, 'ºC'),
	(230808, 121, '2014-03-01 00:32:31.000000', 'temperatura', 823.0000, 'ºC'),
	(230809, 121, '2014-03-01 00:32:32.000000', 'temperatura', 398.0000, 'ºC'),
	(230810, 121, '2014-03-01 00:32:33.000000', 'temperatura', 721.0000, 'ºC'),
	(230811, 121, '2014-03-01 00:32:34.000000', 'temperatura', 13.0000, 'ºC'),
	(230812, 121, '2014-03-01 00:32:35.000000', 'temperatura', 302.0000, 'ºC'),
	(230813, 121, '2014-03-01 00:32:36.000000', 'temperatura', 272.0000, 'ºC'),
	(230814, 121, '2014-03-01 00:32:37.000000', 'temperatura', 455.0000, 'ºC'),
	(230815, 121, '2014-03-01 00:32:38.000000', 'temperatura', 260.0000, 'ºC'),
	(230816, 121, '2014-03-01 00:32:39.000000', 'temperatura', 1134.0000, 'ºC'),
	(230817, 121, '2014-03-01 00:32:40.000000', 'temperatura', 91.0000, 'ºC'),
	(230818, 121, '2014-03-01 00:32:41.000000', 'temperatura', 652.0000, 'ºC'),
	(230819, 121, '2014-03-01 00:32:42.000000', 'temperatura', 587.0000, 'ºC'),
	(230820, 121, '2014-03-01 00:32:43.000000', 'temperatura', 979.0000, 'ºC'),
	(230821, 121, '2014-03-01 00:32:44.000000', 'temperatura', 738.0000, 'ºC'),
	(230822, 121, '2014-03-01 00:32:45.000000', 'temperatura', 750.0000, 'ºC'),
	(230823, 121, '2014-03-01 00:32:46.000000', 'temperatura', 336.0000, 'ºC'),
	(230824, 121, '2014-03-01 00:32:47.000000', 'temperatura', 634.0000, 'ºC'),
	(230825, 121, '2014-03-01 00:32:48.000000', 'temperatura', 960.0000, 'ºC'),
	(230826, 121, '2014-03-01 00:32:49.000000', 'temperatura', 497.0000, 'ºC'),
	(230827, 121, '2014-03-01 00:32:50.000000', 'temperatura', 807.0000, 'ºC'),
	(230828, 121, '2014-03-01 00:32:51.000000', 'temperatura', 146.0000, 'ºC'),
	(230829, 121, '2014-03-01 00:32:52.000000', 'temperatura', 706.0000, 'ºC'),
	(230830, 121, '2014-03-01 00:32:53.000000', 'temperatura', 696.0000, 'ºC'),
	(230831, 121, '2014-03-01 00:32:54.000000', 'temperatura', 161.0000, 'ºC'),
	(230832, 121, '2014-03-01 00:32:55.000000', 'temperatura', 1116.0000, 'ºC'),
	(230833, 121, '2014-03-01 00:32:56.000000', 'temperatura', 297.0000, 'ºC'),
	(230834, 121, '2014-03-01 00:32:57.000000', 'temperatura', 540.0000, 'ºC'),
	(230835, 121, '2014-03-01 00:32:58.000000', 'temperatura', 610.0000, 'ºC'),
	(230836, 121, '2014-03-01 00:32:59.000000', 'temperatura', 230.0000, 'ºC'),
	(230837, 121, '2014-03-01 00:33:00.000000', 'temperatura', 522.0000, 'ºC'),
	(230838, 121, '2014-03-01 00:33:01.000000', 'temperatura', 717.0000, 'ºC'),
	(230839, 121, '2014-03-01 00:33:02.000000', 'temperatura', 822.0000, 'ºC'),
	(230840, 121, '2014-03-01 00:33:03.000000', 'temperatura', 757.0000, 'ºC'),
	(230841, 121, '2014-03-01 00:33:04.000000', 'temperatura', 120.0000, 'ºC'),
	(230842, 121, '2014-03-01 00:33:05.000000', 'temperatura', 730.0000, 'ºC'),
	(230843, 121, '2014-03-01 00:33:06.000000', 'temperatura', 892.0000, 'ºC'),
	(230844, 121, '2014-03-01 00:33:07.000000', 'temperatura', 1068.0000, 'ºC'),
	(230845, 121, '2014-03-01 00:33:08.000000', 'temperatura', 267.0000, 'ºC'),
	(230846, 121, '2014-03-01 00:33:09.000000', 'temperatura', 531.0000, 'ºC'),
	(230847, 121, '2014-03-01 00:33:10.000000', 'temperatura', 652.0000, 'ºC'),
	(230848, 121, '2014-03-01 00:33:11.000000', 'temperatura', 469.0000, 'ºC'),
	(230849, 121, '2014-03-01 00:33:12.000000', 'temperatura', 391.0000, 'ºC'),
	(230850, 121, '2014-03-01 00:33:13.000000', 'temperatura', 546.0000, 'ºC'),
	(230851, 121, '2014-03-01 00:33:14.000000', 'temperatura', 358.0000, 'ºC'),
	(230852, 121, '2014-03-01 00:33:15.000000', 'temperatura', 155.0000, 'ºC'),
	(230853, 121, '2014-03-01 00:33:16.000000', 'temperatura', 899.0000, 'ºC'),
	(230854, 121, '2014-03-01 00:33:17.000000', 'temperatura', 431.0000, 'ºC'),
	(230855, 121, '2014-03-01 00:33:18.000000', 'temperatura', 657.0000, 'ºC'),
	(230856, 121, '2014-03-01 00:33:19.000000', 'temperatura', 795.0000, 'ºC'),
	(230857, 121, '2014-03-01 00:33:20.000000', 'temperatura', 804.0000, 'ºC'),
	(230858, 121, '2014-03-01 00:33:21.000000', 'temperatura', 435.0000, 'ºC'),
	(230859, 121, '2014-03-01 00:33:22.000000', 'temperatura', 966.0000, 'ºC'),
	(230860, 121, '2014-03-01 00:33:23.000000', 'temperatura', 1123.0000, 'ºC'),
	(230861, 121, '2014-03-01 00:33:24.000000', 'temperatura', 317.0000, 'ºC'),
	(230862, 121, '2014-03-01 00:33:25.000000', 'temperatura', 617.0000, 'ºC'),
	(230863, 121, '2014-03-01 00:33:26.000000', 'temperatura', 936.0000, 'ºC'),
	(230864, 121, '2014-03-01 00:33:27.000000', 'temperatura', 428.0000, 'ºC'),
	(230865, 121, '2014-03-01 00:33:28.000000', 'temperatura', 535.0000, 'ºC'),
	(230866, 121, '2014-03-01 00:33:29.000000', 'temperatura', 189.0000, 'ºC'),
	(230867, 121, '2014-03-01 00:33:30.000000', 'temperatura', 542.0000, 'ºC'),
	(230868, 121, '2014-03-01 00:33:31.000000', 'temperatura', 941.0000, 'ºC'),
	(230869, 121, '2014-03-01 00:33:32.000000', 'temperatura', 681.0000, 'ºC'),
	(230870, 121, '2014-03-01 00:33:33.000000', 'temperatura', 581.0000, 'ºC'),
	(230871, 121, '2014-03-01 00:33:34.000000', 'temperatura', 861.0000, 'ºC'),
	(230872, 121, '2014-03-01 00:33:35.000000', 'temperatura', 166.0000, 'ºC'),
	(230873, 121, '2014-03-01 00:33:36.000000', 'temperatura', 648.0000, 'ºC'),
	(230874, 121, '2014-03-01 00:33:37.000000', 'temperatura', 340.0000, 'ºC'),
	(230875, 121, '2014-03-01 00:33:38.000000', 'temperatura', 957.0000, 'ºC'),
	(230876, 121, '2014-03-01 00:33:39.000000', 'temperatura', 164.0000, 'ºC'),
	(230877, 121, '2014-03-01 00:33:40.000000', 'temperatura', 351.0000, 'ºC'),
	(230878, 121, '2014-03-01 00:33:41.000000', 'temperatura', 65.0000, 'ºC'),
	(230879, 121, '2014-03-01 00:33:42.000000', 'temperatura', 472.0000, 'ºC'),
	(230880, 121, '2014-03-01 00:33:43.000000', 'temperatura', 965.0000, 'ºC'),
	(230881, 121, '2014-03-01 00:33:44.000000', 'temperatura', 1009.0000, 'ºC'),
	(230882, 121, '2014-03-01 00:33:45.000000', 'temperatura', 952.0000, 'ºC'),
	(230883, 121, '2014-03-01 00:33:46.000000', 'temperatura', 532.0000, 'ºC'),
	(230884, 121, '2014-03-01 00:33:47.000000', 'temperatura', 1004.0000, 'ºC'),
	(230885, 121, '2014-03-01 00:33:48.000000', 'temperatura', 1026.0000, 'ºC'),
	(230886, 121, '2014-03-01 00:33:49.000000', 'temperatura', 919.0000, 'ºC'),
	(230887, 121, '2014-03-01 00:33:50.000000', 'temperatura', 315.0000, 'ºC'),
	(230888, 121, '2014-03-01 00:33:51.000000', 'temperatura', 20.0000, 'ºC'),
	(230889, 121, '2014-03-01 00:33:52.000000', 'temperatura', 354.0000, 'ºC'),
	(230890, 121, '2014-03-01 00:33:53.000000', 'temperatura', 510.0000, 'ºC'),
	(230891, 121, '2014-03-01 00:33:54.000000', 'temperatura', 289.0000, 'ºC'),
	(230892, 121, '2014-03-01 00:33:55.000000', 'temperatura', 1118.0000, 'ºC'),
	(230893, 121, '2014-03-01 00:33:56.000000', 'temperatura', 1120.0000, 'ºC'),
	(230894, 121, '2014-03-01 00:33:57.000000', 'temperatura', 1048.0000, 'ºC'),
	(230895, 121, '2014-03-01 00:33:58.000000', 'temperatura', 680.0000, 'ºC'),
	(230896, 121, '2014-03-01 00:33:59.000000', 'temperatura', 257.0000, 'ºC'),
	(230897, 121, '2014-03-01 00:34:00.000000', 'temperatura', 446.0000, 'ºC'),
	(230898, 121, '2014-03-01 00:34:01.000000', 'temperatura', 258.0000, 'ºC'),
	(230899, 121, '2014-03-01 00:34:02.000000', 'temperatura', 1153.0000, 'ºC'),
	(230900, 121, '2014-03-01 00:34:03.000000', 'temperatura', 192.0000, 'ºC'),
	(230901, 121, '2014-03-01 00:34:04.000000', 'temperatura', 1101.0000, 'ºC'),
	(230902, 121, '2014-03-01 00:34:05.000000', 'temperatura', 130.0000, 'ºC'),
	(230903, 121, '2014-03-01 00:34:06.000000', 'temperatura', 949.0000, 'ºC'),
	(230904, 121, '2014-03-01 00:34:07.000000', 'temperatura', 753.0000, 'ºC'),
	(230905, 121, '2014-03-01 00:34:08.000000', 'temperatura', 919.0000, 'ºC'),
	(230906, 121, '2014-03-01 00:34:09.000000', 'temperatura', 1139.0000, 'ºC'),
	(230907, 121, '2014-03-01 00:34:10.000000', 'temperatura', 536.0000, 'ºC'),
	(230908, 121, '2014-03-01 00:34:11.000000', 'temperatura', 464.0000, 'ºC'),
	(230909, 121, '2014-03-01 00:34:12.000000', 'temperatura', 713.0000, 'ºC'),
	(230910, 121, '2014-03-01 00:34:13.000000', 'temperatura', 975.0000, 'ºC'),
	(230911, 121, '2014-03-01 00:34:14.000000', 'temperatura', 334.0000, 'ºC'),
	(230912, 121, '2014-03-01 00:34:15.000000', 'temperatura', 1147.0000, 'ºC'),
	(230913, 121, '2014-03-01 00:34:16.000000', 'temperatura', 1133.0000, 'ºC'),
	(230914, 121, '2014-03-01 00:34:17.000000', 'temperatura', 1023.0000, 'ºC'),
	(230915, 121, '2014-03-01 00:34:18.000000', 'temperatura', 518.0000, 'ºC'),
	(230916, 121, '2014-03-01 00:34:19.000000', 'temperatura', 720.0000, 'ºC'),
	(230917, 121, '2014-03-01 00:34:20.000000', 'temperatura', 849.0000, 'ºC'),
	(230918, 121, '2014-03-01 00:34:21.000000', 'temperatura', 883.0000, 'ºC'),
	(230919, 121, '2014-03-01 00:34:22.000000', 'temperatura', 667.0000, 'ºC'),
	(230920, 121, '2014-03-01 00:34:23.000000', 'temperatura', 690.0000, 'ºC'),
	(230921, 121, '2014-03-01 00:34:24.000000', 'temperatura', 247.0000, 'ºC'),
	(230922, 121, '2014-03-01 00:34:25.000000', 'temperatura', 365.0000, 'ºC'),
	(230923, 121, '2014-03-01 00:34:26.000000', 'temperatura', 1084.0000, 'ºC'),
	(230924, 121, '2014-03-01 00:34:27.000000', 'temperatura', 726.0000, 'ºC'),
	(230925, 121, '2014-03-01 00:34:28.000000', 'temperatura', 380.0000, 'ºC'),
	(230926, 121, '2014-03-01 00:34:29.000000', 'temperatura', 921.0000, 'ºC'),
	(230927, 121, '2014-03-01 00:34:30.000000', 'temperatura', 1064.0000, 'ºC'),
	(230928, 121, '2014-03-01 00:34:31.000000', 'temperatura', 161.0000, 'ºC'),
	(230929, 121, '2014-03-01 00:34:32.000000', 'temperatura', 11.0000, 'ºC'),
	(230930, 121, '2014-03-01 00:34:33.000000', 'temperatura', 775.0000, 'ºC'),
	(230931, 121, '2014-03-01 00:34:34.000000', 'temperatura', 241.0000, 'ºC'),
	(230932, 121, '2014-03-01 00:34:35.000000', 'temperatura', 82.0000, 'ºC'),
	(230933, 121, '2014-03-01 00:34:36.000000', 'temperatura', 888.0000, 'ºC'),
	(230934, 121, '2014-03-01 00:34:37.000000', 'temperatura', 594.0000, 'ºC'),
	(230935, 121, '2014-03-01 00:34:38.000000', 'temperatura', 304.0000, 'ºC'),
	(230936, 121, '2014-03-01 00:34:39.000000', 'temperatura', 941.0000, 'ºC'),
	(230937, 121, '2014-03-01 00:34:40.000000', 'temperatura', 195.0000, 'ºC'),
	(230938, 121, '2014-03-01 00:34:41.000000', 'temperatura', 549.0000, 'ºC'),
	(230939, 121, '2014-03-01 00:34:42.000000', 'temperatura', 962.0000, 'ºC'),
	(230940, 121, '2014-03-01 00:34:43.000000', 'temperatura', 765.0000, 'ºC'),
	(230941, 121, '2014-03-01 00:34:44.000000', 'temperatura', 938.0000, 'ºC'),
	(230942, 121, '2014-03-01 00:34:45.000000', 'temperatura', 1197.0000, 'ºC'),
	(230943, 121, '2014-03-01 00:34:46.000000', 'temperatura', 770.0000, 'ºC'),
	(230944, 121, '2014-03-01 00:34:47.000000', 'temperatura', 260.0000, 'ºC'),
	(230945, 121, '2014-03-01 00:34:48.000000', 'temperatura', 192.0000, 'ºC'),
	(230946, 121, '2014-03-01 00:34:49.000000', 'temperatura', 179.0000, 'ºC'),
	(230947, 121, '2014-03-01 00:34:50.000000', 'temperatura', 321.0000, 'ºC'),
	(230948, 121, '2014-03-01 00:34:51.000000', 'temperatura', 1067.0000, 'ºC'),
	(230949, 121, '2014-03-01 00:34:52.000000', 'temperatura', 774.0000, 'ºC'),
	(230950, 121, '2014-03-01 00:34:53.000000', 'temperatura', 670.0000, 'ºC'),
	(230951, 121, '2014-03-01 00:34:54.000000', 'temperatura', 1029.0000, 'ºC'),
	(230952, 121, '2014-03-01 00:34:55.000000', 'temperatura', 735.0000, 'ºC'),
	(230953, 121, '2014-03-01 00:34:56.000000', 'temperatura', 590.0000, 'ºC'),
	(230954, 121, '2014-03-01 00:34:57.000000', 'temperatura', 744.0000, 'ºC'),
	(230955, 121, '2014-03-01 00:34:58.000000', 'temperatura', 752.0000, 'ºC'),
	(230956, 121, '2014-03-01 00:34:59.000000', 'temperatura', 326.0000, 'ºC'),
	(230957, 121, '2014-03-01 00:35:00.000000', 'temperatura', 575.0000, 'ºC'),
	(230958, 121, '2014-03-01 00:35:01.000000', 'temperatura', 696.0000, 'ºC'),
	(230959, 121, '2014-03-01 00:35:02.000000', 'temperatura', 557.0000, 'ºC'),
	(230960, 121, '2014-03-01 00:35:03.000000', 'temperatura', 698.0000, 'ºC'),
	(230961, 121, '2014-03-01 00:35:04.000000', 'temperatura', 621.0000, 'ºC'),
	(230962, 121, '2014-03-01 00:35:05.000000', 'temperatura', 1009.0000, 'ºC'),
	(230963, 121, '2014-03-01 00:35:06.000000', 'temperatura', 784.0000, 'ºC'),
	(230964, 121, '2014-03-01 00:35:07.000000', 'temperatura', 891.0000, 'ºC'),
	(230965, 121, '2014-03-01 00:35:08.000000', 'temperatura', 905.0000, 'ºC'),
	(230966, 121, '2014-03-01 00:35:09.000000', 'temperatura', 651.0000, 'ºC'),
	(230967, 121, '2014-03-01 00:35:10.000000', 'temperatura', 542.0000, 'ºC'),
	(230968, 121, '2014-03-01 00:35:11.000000', 'temperatura', 759.0000, 'ºC'),
	(230969, 121, '2014-03-01 00:35:12.000000', 'temperatura', 967.0000, 'ºC'),
	(230970, 121, '2014-03-01 00:35:13.000000', 'temperatura', 160.0000, 'ºC'),
	(230971, 121, '2014-03-01 00:35:14.000000', 'temperatura', 297.0000, 'ºC'),
	(230972, 121, '2014-03-01 00:35:15.000000', 'temperatura', 1008.0000, 'ºC'),
	(230973, 121, '2014-03-01 00:35:16.000000', 'temperatura', 547.0000, 'ºC'),
	(230974, 121, '2014-03-01 00:35:17.000000', 'temperatura', 912.0000, 'ºC'),
	(230975, 121, '2014-03-01 00:35:18.000000', 'temperatura', 521.0000, 'ºC'),
	(230976, 121, '2014-03-01 00:35:19.000000', 'temperatura', 1071.0000, 'ºC'),
	(230977, 121, '2014-03-01 00:35:20.000000', 'temperatura', 191.0000, 'ºC'),
	(230978, 121, '2014-03-01 00:35:21.000000', 'temperatura', 141.0000, 'ºC'),
	(230979, 121, '2014-03-01 00:35:22.000000', 'temperatura', 134.0000, 'ºC'),
	(230980, 121, '2014-03-01 00:35:23.000000', 'temperatura', 248.0000, 'ºC'),
	(230981, 121, '2014-03-01 00:35:24.000000', 'temperatura', 837.0000, 'ºC'),
	(230982, 121, '2014-03-01 00:35:25.000000', 'temperatura', 1043.0000, 'ºC'),
	(230983, 121, '2014-03-01 00:35:26.000000', 'temperatura', 306.0000, 'ºC'),
	(230984, 121, '2014-03-01 00:35:27.000000', 'temperatura', 798.0000, 'ºC'),
	(230985, 121, '2014-03-01 00:35:28.000000', 'temperatura', 674.0000, 'ºC'),
	(230986, 121, '2014-03-01 00:35:29.000000', 'temperatura', 975.0000, 'ºC'),
	(230987, 121, '2014-03-01 00:35:30.000000', 'temperatura', 453.0000, 'ºC'),
	(230988, 121, '2014-03-01 00:35:31.000000', 'temperatura', 541.0000, 'ºC'),
	(230989, 121, '2014-03-01 00:35:32.000000', 'temperatura', 145.0000, 'ºC'),
	(230990, 121, '2014-03-01 00:35:33.000000', 'temperatura', 305.0000, 'ºC'),
	(230991, 121, '2014-03-01 00:35:34.000000', 'temperatura', 1088.0000, 'ºC'),
	(230992, 121, '2014-03-01 00:35:35.000000', 'temperatura', 926.0000, 'ºC'),
	(230993, 121, '2014-03-01 00:35:36.000000', 'temperatura', 168.0000, 'ºC'),
	(230994, 121, '2014-03-01 00:35:37.000000', 'temperatura', 462.0000, 'ºC'),
	(230995, 121, '2014-03-01 00:35:38.000000', 'temperatura', 606.0000, 'ºC'),
	(230996, 121, '2014-03-01 00:35:39.000000', 'temperatura', 443.0000, 'ºC'),
	(230997, 121, '2014-03-01 00:35:40.000000', 'temperatura', 400.0000, 'ºC'),
	(230998, 121, '2014-03-01 00:35:41.000000', 'temperatura', 671.0000, 'ºC'),
	(230999, 121, '2014-03-01 00:35:42.000000', 'temperatura', 955.0000, 'ºC'),
	(231000, 121, '2014-03-01 00:35:43.000000', 'temperatura', 361.0000, 'ºC'),
	(231001, 121, '2014-03-01 00:35:44.000000', 'temperatura', 140.0000, 'ºC'),
	(231002, 121, '2014-03-01 00:35:45.000000', 'temperatura', 819.0000, 'ºC'),
	(231003, 121, '2014-03-01 00:35:46.000000', 'temperatura', 73.0000, 'ºC'),
	(231004, 121, '2014-03-01 00:35:47.000000', 'temperatura', 311.0000, 'ºC'),
	(231005, 121, '2014-03-01 00:35:48.000000', 'temperatura', 137.0000, 'ºC'),
	(231006, 121, '2014-03-01 00:35:49.000000', 'temperatura', 951.0000, 'ºC'),
	(231007, 121, '2014-03-01 00:35:50.000000', 'temperatura', 745.0000, 'ºC'),
	(231008, 121, '2014-03-01 00:35:51.000000', 'temperatura', 872.0000, 'ºC'),
	(231009, 121, '2014-03-01 00:35:52.000000', 'temperatura', 925.0000, 'ºC'),
	(231010, 121, '2014-03-01 00:35:53.000000', 'temperatura', 811.0000, 'ºC'),
	(231011, 121, '2014-03-01 00:35:54.000000', 'temperatura', 79.0000, 'ºC'),
	(231012, 121, '2014-03-01 00:35:55.000000', 'temperatura', 363.0000, 'ºC'),
	(231013, 121, '2014-03-01 00:35:56.000000', 'temperatura', 378.0000, 'ºC'),
	(231014, 121, '2014-03-01 00:35:57.000000', 'temperatura', 800.0000, 'ºC'),
	(231015, 121, '2014-03-01 00:35:58.000000', 'temperatura', 469.0000, 'ºC'),
	(231016, 121, '2014-03-01 00:35:59.000000', 'temperatura', 1146.0000, 'ºC'),
	(231017, 121, '2014-03-01 00:36:00.000000', 'temperatura', 721.0000, 'ºC'),
	(231018, 121, '2014-03-01 00:36:01.000000', 'temperatura', 171.0000, 'ºC'),
	(231019, 121, '2014-03-01 00:36:02.000000', 'temperatura', 1089.0000, 'ºC'),
	(231020, 121, '2014-03-01 00:36:03.000000', 'temperatura', 134.0000, 'ºC'),
	(231021, 121, '2014-03-01 00:36:04.000000', 'temperatura', 1002.0000, 'ºC'),
	(231022, 121, '2014-03-01 00:36:05.000000', 'temperatura', 1011.0000, 'ºC'),
	(231023, 121, '2014-03-01 00:36:06.000000', 'temperatura', 849.0000, 'ºC'),
	(231024, 121, '2014-03-01 00:36:07.000000', 'temperatura', 11.0000, 'ºC'),
	(231025, 121, '2014-03-01 00:36:08.000000', 'temperatura', 1111.0000, 'ºC'),
	(231026, 121, '2014-03-01 00:36:09.000000', 'temperatura', 721.0000, 'ºC'),
	(231027, 121, '2014-03-01 00:36:10.000000', 'temperatura', 271.0000, 'ºC'),
	(231028, 121, '2014-03-01 00:36:11.000000', 'temperatura', 395.0000, 'ºC'),
	(231029, 121, '2014-03-01 00:36:12.000000', 'temperatura', 1160.0000, 'ºC'),
	(231030, 121, '2014-03-01 00:36:13.000000', 'temperatura', 1016.0000, 'ºC'),
	(231031, 121, '2014-03-01 00:36:14.000000', 'temperatura', 401.0000, 'ºC'),
	(231032, 121, '2014-03-01 00:36:15.000000', 'temperatura', 157.0000, 'ºC'),
	(231033, 121, '2014-03-01 00:36:16.000000', 'temperatura', 785.0000, 'ºC'),
	(231034, 121, '2014-03-01 00:36:17.000000', 'temperatura', 1052.0000, 'ºC'),
	(231035, 121, '2014-03-01 00:36:18.000000', 'temperatura', 504.0000, 'ºC'),
	(231036, 121, '2014-03-01 00:36:19.000000', 'temperatura', 567.0000, 'ºC'),
	(231037, 121, '2014-03-01 00:36:20.000000', 'temperatura', 124.0000, 'ºC'),
	(231038, 121, '2014-03-01 00:36:21.000000', 'temperatura', 117.0000, 'ºC'),
	(231039, 121, '2014-03-01 00:36:22.000000', 'temperatura', 215.0000, 'ºC'),
	(231040, 121, '2014-03-01 00:36:23.000000', 'temperatura', 722.0000, 'ºC'),
	(231041, 121, '2014-03-01 00:36:24.000000', 'temperatura', 568.0000, 'ºC'),
	(231042, 121, '2014-03-01 00:36:25.000000', 'temperatura', 674.0000, 'ºC'),
	(231043, 121, '2014-03-01 00:36:26.000000', 'temperatura', 467.0000, 'ºC'),
	(231044, 121, '2014-03-01 00:36:27.000000', 'temperatura', 314.0000, 'ºC'),
	(231045, 121, '2014-03-01 00:36:28.000000', 'temperatura', 170.0000, 'ºC'),
	(231046, 121, '2014-03-01 00:36:29.000000', 'temperatura', 1109.0000, 'ºC'),
	(231047, 121, '2014-03-01 00:36:30.000000', 'temperatura', 235.0000, 'ºC'),
	(231048, 121, '2014-03-01 00:36:31.000000', 'temperatura', 250.0000, 'ºC'),
	(231049, 121, '2014-03-01 00:36:32.000000', 'temperatura', 543.0000, 'ºC'),
	(231050, 121, '2014-03-01 00:36:33.000000', 'temperatura', 765.0000, 'ºC'),
	(231051, 121, '2014-03-01 00:36:34.000000', 'temperatura', 996.0000, 'ºC'),
	(231052, 121, '2014-03-01 00:36:35.000000', 'temperatura', 288.0000, 'ºC'),
	(231053, 121, '2014-03-01 00:36:36.000000', 'temperatura', 851.0000, 'ºC'),
	(231054, 121, '2014-03-01 00:36:37.000000', 'temperatura', 991.0000, 'ºC'),
	(231055, 121, '2014-03-01 00:36:38.000000', 'temperatura', 1.0000, 'ºC'),
	(231056, 121, '2014-03-01 00:36:39.000000', 'temperatura', 634.0000, 'ºC'),
	(231057, 121, '2014-03-01 00:36:40.000000', 'temperatura', 769.0000, 'ºC'),
	(231058, 121, '2014-03-01 00:36:41.000000', 'temperatura', 741.0000, 'ºC'),
	(231059, 121, '2014-03-01 00:36:42.000000', 'temperatura', 200.0000, 'ºC'),
	(231060, 121, '2014-03-01 00:36:43.000000', 'temperatura', 1176.0000, 'ºC'),
	(231061, 121, '2014-03-01 00:36:44.000000', 'temperatura', 481.0000, 'ºC'),
	(231062, 121, '2014-03-01 00:36:45.000000', 'temperatura', 77.0000, 'ºC'),
	(231063, 121, '2014-03-01 00:36:46.000000', 'temperatura', 141.0000, 'ºC'),
	(231064, 121, '2014-03-01 00:36:47.000000', 'temperatura', 476.0000, 'ºC'),
	(231065, 121, '2014-03-01 00:36:48.000000', 'temperatura', 759.0000, 'ºC'),
	(231066, 121, '2014-03-01 00:36:49.000000', 'temperatura', 1167.0000, 'ºC'),
	(231067, 121, '2014-03-01 00:36:50.000000', 'temperatura', 1159.0000, 'ºC'),
	(231068, 121, '2014-03-01 00:36:51.000000', 'temperatura', 1094.0000, 'ºC'),
	(231069, 121, '2014-03-01 00:36:52.000000', 'temperatura', 794.0000, 'ºC'),
	(231070, 121, '2014-03-01 00:36:53.000000', 'temperatura', 689.0000, 'ºC'),
	(231071, 121, '2014-03-01 00:36:54.000000', 'temperatura', 1064.0000, 'ºC'),
	(231072, 121, '2014-03-01 00:36:55.000000', 'temperatura', 851.0000, 'ºC'),
	(231073, 121, '2014-03-01 00:36:56.000000', 'temperatura', 1065.0000, 'ºC'),
	(231074, 121, '2014-03-01 00:36:57.000000', 'temperatura', 372.0000, 'ºC'),
	(231075, 121, '2014-03-01 00:36:58.000000', 'temperatura', 1065.0000, 'ºC'),
	(231076, 121, '2014-03-01 00:36:59.000000', 'temperatura', 612.0000, 'ºC'),
	(231077, 121, '2014-03-01 00:37:00.000000', 'temperatura', 1063.0000, 'ºC'),
	(231078, 121, '2014-03-01 00:37:01.000000', 'temperatura', 1080.0000, 'ºC'),
	(231079, 121, '2014-03-01 00:37:02.000000', 'temperatura', 1010.0000, 'ºC'),
	(231080, 121, '2014-03-01 00:37:03.000000', 'temperatura', 613.0000, 'ºC'),
	(231081, 121, '2014-03-01 00:37:04.000000', 'temperatura', 35.0000, 'ºC'),
	(231082, 121, '2014-03-01 00:37:05.000000', 'temperatura', 738.0000, 'ºC'),
	(231083, 121, '2014-03-01 00:37:06.000000', 'temperatura', 1182.0000, 'ºC'),
	(231084, 121, '2014-03-01 00:37:07.000000', 'temperatura', 100.0000, 'ºC'),
	(231085, 121, '2014-03-01 00:37:08.000000', 'temperatura', 553.0000, 'ºC'),
	(231086, 121, '2014-03-01 00:37:09.000000', 'temperatura', 68.0000, 'ºC'),
	(231087, 121, '2014-03-01 00:37:10.000000', 'temperatura', 1078.0000, 'ºC'),
	(231088, 121, '2014-03-01 00:37:11.000000', 'temperatura', 387.0000, 'ºC'),
	(231089, 121, '2014-03-01 00:37:12.000000', 'temperatura', 1104.0000, 'ºC'),
	(231090, 121, '2014-03-01 00:37:13.000000', 'temperatura', 757.0000, 'ºC'),
	(231091, 121, '2014-03-01 00:37:14.000000', 'temperatura', 475.0000, 'ºC'),
	(231092, 121, '2014-03-01 00:37:15.000000', 'temperatura', 102.0000, 'ºC'),
	(231093, 121, '2014-03-01 00:37:16.000000', 'temperatura', 289.0000, 'ºC'),
	(231094, 121, '2014-03-01 00:37:17.000000', 'temperatura', 1137.0000, 'ºC'),
	(231095, 121, '2014-03-01 00:37:18.000000', 'temperatura', 17.0000, 'ºC'),
	(231096, 121, '2014-03-01 00:37:19.000000', 'temperatura', 277.0000, 'ºC'),
	(231097, 121, '2014-03-01 00:37:20.000000', 'temperatura', 136.0000, 'ºC'),
	(231098, 121, '2014-03-01 00:37:21.000000', 'temperatura', 1047.0000, 'ºC'),
	(231099, 121, '2014-03-01 00:37:22.000000', 'temperatura', 30.0000, 'ºC'),
	(231100, 121, '2014-03-01 00:37:23.000000', 'temperatura', 609.0000, 'ºC'),
	(231101, 121, '2014-03-01 00:37:24.000000', 'temperatura', 555.0000, 'ºC'),
	(231102, 121, '2014-03-01 00:37:25.000000', 'temperatura', 947.0000, 'ºC'),
	(231103, 121, '2014-03-01 00:37:26.000000', 'temperatura', 673.0000, 'ºC'),
	(231104, 121, '2014-03-01 00:37:27.000000', 'temperatura', 525.0000, 'ºC'),
	(231105, 121, '2014-03-01 00:37:28.000000', 'temperatura', 605.0000, 'ºC'),
	(231106, 121, '2014-03-01 00:37:29.000000', 'temperatura', 251.0000, 'ºC'),
	(231107, 121, '2014-03-01 00:37:30.000000', 'temperatura', 642.0000, 'ºC'),
	(231108, 121, '2014-03-01 00:37:31.000000', 'temperatura', 56.0000, 'ºC'),
	(231109, 121, '2014-03-01 00:37:32.000000', 'temperatura', 756.0000, 'ºC'),
	(231110, 121, '2014-03-01 00:37:33.000000', 'temperatura', 13.0000, 'ºC'),
	(231111, 121, '2014-03-01 00:37:34.000000', 'temperatura', 198.0000, 'ºC'),
	(231112, 121, '2014-03-01 00:37:35.000000', 'temperatura', 949.0000, 'ºC'),
	(231113, 121, '2014-03-01 00:37:36.000000', 'temperatura', 551.0000, 'ºC'),
	(231114, 121, '2014-03-01 00:37:37.000000', 'temperatura', 1110.0000, 'ºC'),
	(231115, 121, '2014-03-01 00:37:38.000000', 'temperatura', 298.0000, 'ºC'),
	(231116, 121, '2014-03-01 00:37:39.000000', 'temperatura', 558.0000, 'ºC'),
	(231117, 121, '2014-03-01 00:37:40.000000', 'temperatura', 699.0000, 'ºC'),
	(231118, 121, '2014-03-01 00:37:41.000000', 'temperatura', 622.0000, 'ºC'),
	(231119, 121, '2014-03-01 00:37:42.000000', 'temperatura', 1012.0000, 'ºC'),
	(231120, 121, '2014-03-01 00:37:43.000000', 'temperatura', 796.0000, 'ºC'),
	(231121, 121, '2014-03-01 00:37:44.000000', 'temperatura', 944.0000, 'ºC'),
	(231122, 121, '2014-03-01 00:37:45.000000', 'temperatura', 1134.0000, 'ºC'),
	(231123, 121, '2014-03-01 00:37:46.000000', 'temperatura', 438.0000, 'ºC'),
	(231124, 121, '2014-03-01 00:37:47.000000', 'temperatura', 1189.0000, 'ºC'),
	(231125, 121, '2014-03-01 00:37:48.000000', 'temperatura', 1031.0000, 'ºC'),
	(231126, 121, '2014-03-01 00:37:49.000000', 'temperatura', 389.0000, 'ºC'),
	(231127, 121, '2014-03-01 00:37:50.000000', 'temperatura', 52.0000, 'ºC'),
	(231128, 121, '2014-03-01 00:37:51.000000', 'temperatura', 293.0000, 'ºC'),
	(231129, 121, '2014-03-01 00:37:52.000000', 'temperatura', 111.0000, 'ºC'),
	(231130, 121, '2014-03-01 00:37:53.000000', 'temperatura', 877.0000, 'ºC'),
	(231131, 121, '2014-03-01 00:37:54.000000', 'temperatura', 453.0000, 'ºC'),
	(231132, 121, '2014-03-01 00:37:55.000000', 'temperatura', 832.0000, 'ºC'),
	(231133, 121, '2014-03-01 00:37:56.000000', 'temperatura', 403.0000, 'ºC'),
	(231134, 121, '2014-03-01 00:37:57.000000', 'temperatura', 718.0000, 'ºC'),
	(231135, 121, '2014-03-01 00:37:58.000000', 'temperatura', 1184.0000, 'ºC'),
	(231136, 121, '2014-03-01 00:37:59.000000', 'temperatura', 167.0000, 'ºC'),
	(231137, 121, '2014-03-01 00:38:00.000000', 'temperatura', 880.0000, 'ºC'),
	(231138, 121, '2014-03-01 00:38:01.000000', 'temperatura', 303.0000, 'ºC'),
	(231139, 121, '2014-03-01 00:38:02.000000', 'temperatura', 74.0000, 'ºC'),
	(231140, 121, '2014-03-01 00:38:03.000000', 'temperatura', 663.0000, 'ºC'),
	(231141, 121, '2014-03-01 00:38:04.000000', 'temperatura', 694.0000, 'ºC'),
	(231142, 121, '2014-03-01 00:38:05.000000', 'temperatura', 281.0000, 'ºC'),
	(231143, 121, '2014-03-01 00:38:06.000000', 'temperatura', 525.0000, 'ºC'),
	(231144, 121, '2014-03-01 00:38:07.000000', 'temperatura', 582.0000, 'ºC'),
	(231145, 121, '2014-03-01 00:38:08.000000', 'temperatura', 136.0000, 'ºC'),
	(231146, 121, '2014-03-01 00:38:09.000000', 'temperatura', 135.0000, 'ºC'),
	(231147, 121, '2014-03-01 00:38:10.000000', 'temperatura', 265.0000, 'ºC'),
	(231148, 121, '2014-03-01 00:38:11.000000', 'temperatura', 922.0000, 'ºC'),
	(231149, 121, '2014-03-01 00:38:12.000000', 'temperatura', 216.0000, 'ºC'),
	(231150, 121, '2014-03-01 00:38:13.000000', 'temperatura', 716.0000, 'ºC'),
	(231151, 121, '2014-03-01 00:38:14.000000', 'temperatura', 529.0000, 'ºC'),
	(231152, 121, '2014-03-01 00:38:15.000000', 'temperatura', 501.0000, 'ºC'),
	(231153, 121, '2014-03-01 00:38:16.000000', 'temperatura', 917.0000, 'ºC'),
	(231154, 121, '2014-03-01 00:38:17.000000', 'temperatura', 683.0000, 'ºC'),
	(231155, 121, '2014-03-01 00:38:18.000000', 'temperatura', 663.0000, 'ºC'),
	(231156, 121, '2014-03-01 00:38:19.000000', 'temperatura', 66.0000, 'ºC'),
	(231157, 121, '2014-03-01 00:38:20.000000', 'temperatura', 743.0000, 'ºC'),
	(231158, 121, '2014-03-01 00:38:21.000000', 'temperatura', 1118.0000, 'ºC'),
	(231159, 121, '2014-03-01 00:38:22.000000', 'temperatura', 960.0000, 'ºC'),
	(231160, 121, '2014-03-01 00:38:23.000000', 'temperatura', 247.0000, 'ºC'),
	(231161, 121, '2014-03-01 00:38:24.000000', 'temperatura', 754.0000, 'ºC'),
	(231162, 121, '2014-03-01 00:38:25.000000', 'temperatura', 629.0000, 'ºC'),
	(231163, 121, '2014-03-01 00:38:26.000000', 'temperatura', 886.0000, 'ºC'),
	(231164, 121, '2014-03-01 00:38:27.000000', 'temperatura', 143.0000, 'ºC'),
	(231165, 121, '2014-03-01 00:38:28.000000', 'temperatura', 457.0000, 'ºC'),
	(231166, 121, '2014-03-01 00:38:29.000000', 'temperatura', 655.0000, 'ºC'),
	(231167, 121, '2014-03-01 00:38:30.000000', 'temperatura', 704.0000, 'ºC'),
	(231168, 121, '2014-03-01 00:38:31.000000', 'temperatura', 358.0000, 'ºC'),
	(231169, 121, '2014-03-01 00:38:32.000000', 'temperatura', 877.0000, 'ºC'),
	(231170, 121, '2014-03-01 00:38:33.000000', 'temperatura', 911.0000, 'ºC'),
	(231171, 121, '2014-03-01 00:38:34.000000', 'temperatura', 723.0000, 'ºC'),
	(231172, 121, '2014-03-01 00:38:35.000000', 'temperatura', 886.0000, 'ºC'),
	(231173, 121, '2014-03-01 00:38:36.000000', 'temperatura', 1059.0000, 'ºC'),
	(231174, 121, '2014-03-01 00:38:37.000000', 'temperatura', 237.0000, 'ºC'),
	(231175, 121, '2014-03-01 00:38:38.000000', 'temperatura', 409.0000, 'ºC'),
	(231176, 121, '2014-03-01 00:38:39.000000', 'temperatura', 135.0000, 'ºC'),
	(231177, 121, '2014-03-01 00:38:40.000000', 'temperatura', 647.0000, 'ºC'),
	(231178, 121, '2014-03-01 00:38:41.000000', 'temperatura', 433.0000, 'ºC'),
	(231179, 121, '2014-03-01 00:38:42.000000', 'temperatura', 225.0000, 'ºC'),
	(231180, 121, '2014-03-01 00:38:43.000000', 'temperatura', 1028.0000, 'ºC'),
	(231181, 121, '2014-03-01 00:38:44.000000', 'temperatura', 862.0000, 'ºC'),
	(231182, 121, '2014-03-01 00:38:45.000000', 'temperatura', 26.0000, 'ºC'),
	(231183, 121, '2014-03-01 00:38:46.000000', 'temperatura', 1144.0000, 'ºC'),
	(231184, 121, '2014-03-01 00:38:47.000000', 'temperatura', 845.0000, 'ºC'),
	(231185, 121, '2014-03-01 00:38:48.000000', 'temperatura', 794.0000, 'ºC'),
	(231186, 121, '2014-03-01 00:38:49.000000', 'temperatura', 232.0000, 'ºC'),
	(231187, 121, '2014-03-01 00:38:50.000000', 'temperatura', 1182.0000, 'ºC'),
	(231188, 121, '2014-03-01 00:38:51.000000', 'temperatura', 413.0000, 'ºC'),
	(231189, 121, '2014-03-01 00:38:52.000000', 'temperatura', 919.0000, 'ºC'),
	(231190, 121, '2014-03-01 00:38:53.000000', 'temperatura', 958.0000, 'ºC'),
	(231191, 121, '2014-03-01 00:38:54.000000', 'temperatura', 835.0000, 'ºC'),
	(231192, 121, '2014-03-01 00:38:55.000000', 'temperatura', 100.0000, 'ºC'),
	(231193, 121, '2014-03-01 00:38:56.000000', 'temperatura', 394.0000, 'ºC'),
	(231194, 121, '2014-03-01 00:38:57.000000', 'temperatura', 471.0000, 'ºC'),
	(231195, 121, '2014-03-01 00:38:58.000000', 'temperatura', 1173.0000, 'ºC'),
	(231196, 121, '2014-03-01 00:38:59.000000', 'temperatura', 854.0000, 'ºC'),
	(231197, 121, '2014-03-01 00:39:00.000000', 'temperatura', 753.0000, 'ºC'),
	(231198, 121, '2014-03-01 00:39:01.000000', 'temperatura', 1.0000, 'ºC'),
	(231199, 121, '2014-03-01 00:39:02.000000', 'temperatura', 149.0000, 'ºC'),
	(231200, 121, '2014-03-01 00:39:03.000000', 'temperatura', 740.0000, 'ºC'),
	(231201, 121, '2014-03-01 00:39:04.000000', 'temperatura', 853.0000, 'ºC'),
	(231202, 121, '2014-03-01 00:39:05.000000', 'temperatura', 847.0000, 'ºC'),
	(231203, 121, '2014-03-01 00:39:06.000000', 'temperatura', 475.0000, 'ºC'),
	(231204, 121, '2014-03-01 00:39:07.000000', 'temperatura', 1036.0000, 'ºC'),
	(231205, 121, '2014-03-01 00:39:08.000000', 'temperatura', 156.0000, 'ºC'),
	(231206, 121, '2014-03-01 00:39:09.000000', 'temperatura', 72.0000, 'ºC'),
	(231207, 121, '2014-03-01 00:39:10.000000', 'temperatura', 1094.0000, 'ºC'),
	(231208, 121, '2014-03-01 00:39:11.000000', 'temperatura', 455.0000, 'ºC'),
	(231209, 121, '2014-03-01 00:39:12.000000', 'temperatura', 193.0000, 'ºC'),
	(231210, 121, '2014-03-01 00:39:13.000000', 'temperatura', 798.0000, 'ºC'),
	(231211, 121, '2014-03-01 00:39:14.000000', 'temperatura', 1013.0000, 'ºC'),
	(231212, 121, '2014-03-01 00:39:15.000000', 'temperatura', 273.0000, 'ºC'),
	(231213, 121, '2014-03-01 00:39:16.000000', 'temperatura', 724.0000, 'ºC'),
	(231214, 121, '2014-03-01 00:39:17.000000', 'temperatura', 402.0000, 'ºC'),
	(231215, 121, '2014-03-01 00:39:18.000000', 'temperatura', 1039.0000, 'ºC'),
	(231216, 121, '2014-03-01 00:39:19.000000', 'temperatura', 387.0000, 'ºC'),
	(231217, 121, '2014-03-01 00:39:20.000000', 'temperatura', 22.0000, 'ºC'),
	(231218, 121, '2014-03-01 00:39:21.000000', 'temperatura', 149.0000, 'ºC'),
	(231219, 121, '2014-03-01 00:39:22.000000', 'temperatura', 679.0000, 'ºC'),
	(231220, 121, '2014-03-01 00:39:23.000000', 'temperatura', 549.0000, 'ºC'),
	(231221, 121, '2014-03-01 00:39:24.000000', 'temperatura', 710.0000, 'ºC'),
	(231222, 121, '2014-03-01 00:39:25.000000', 'temperatura', 701.0000, 'ºC'),
	(231223, 121, '2014-03-01 00:39:26.000000', 'temperatura', 174.0000, 'ºC'),
	(231224, 121, '2014-03-01 00:39:27.000000', 'temperatura', 1170.0000, 'ºC'),
	(231225, 121, '2014-03-01 00:39:28.000000', 'temperatura', 528.0000, 'ºC'),
	(231226, 121, '2014-03-01 00:39:29.000000', 'temperatura', 329.0000, 'ºC'),
	(231227, 121, '2014-03-01 00:39:30.000000', 'temperatura', 61.0000, 'ºC'),
	(231228, 121, '2014-03-01 00:39:31.000000', 'temperatura', 520.0000, 'ºC'),
	(231229, 121, '2014-03-01 00:39:32.000000', 'temperatura', 18.0000, 'ºC'),
	(231230, 121, '2014-03-01 00:39:33.000000', 'temperatura', 931.0000, 'ºC'),
	(231231, 121, '2014-03-01 00:39:34.000000', 'temperatura', 1000.0000, 'ºC'),
	(231232, 121, '2014-03-01 00:39:35.000000', 'temperatura', 1006.0000, 'ºC'),
	(231233, 121, '2014-03-01 00:39:36.000000', 'temperatura', 832.0000, 'ºC'),
	(231234, 121, '2014-03-01 00:39:37.000000', 'temperatura', 1144.0000, 'ºC'),
	(231235, 121, '2014-03-01 00:39:38.000000', 'temperatura', 823.0000, 'ºC'),
	(231236, 121, '2014-03-01 00:39:39.000000', 'temperatura', 682.0000, 'ºC'),
	(231237, 121, '2014-03-01 00:39:40.000000', 'temperatura', 943.0000, 'ºC'),
	(231238, 121, '2014-03-01 00:39:41.000000', 'temperatura', 269.0000, 'ºC'),
	(231239, 121, '2014-03-01 00:39:42.000000', 'temperatura', 917.0000, 'ºC'),
	(231240, 121, '2014-03-01 00:39:43.000000', 'temperatura', 177.0000, 'ºC'),
	(231241, 121, '2014-03-01 00:39:44.000000', 'temperatura', 534.0000, 'ºC'),
	(231242, 121, '2014-03-01 00:39:45.000000', 'temperatura', 942.0000, 'ºC'),
	(231243, 121, '2014-03-01 00:39:46.000000', 'temperatura', 706.0000, 'ºC'),
	(231244, 121, '2014-03-01 00:39:47.000000', 'temperatura', 706.0000, 'ºC'),
	(231245, 121, '2014-03-01 00:39:48.000000', 'temperatura', 213.0000, 'ºC'),
	(231246, 121, '2014-03-01 00:39:49.000000', 'temperatura', 145.0000, 'ºC'),
	(231247, 121, '2014-03-01 00:39:50.000000', 'temperatura', 89.0000, 'ºC'),
	(231248, 121, '2014-03-01 00:39:51.000000', 'temperatura', 11.0000, 'ºC'),
	(231249, 121, '2014-03-01 00:39:52.000000', 'temperatura', 987.0000, 'ºC'),
	(231250, 121, '2014-03-01 00:39:53.000000', 'temperatura', 101.0000, 'ºC'),
	(231251, 121, '2014-03-01 00:39:54.000000', 'temperatura', 1146.0000, 'ºC'),
	(231252, 121, '2014-03-01 00:39:55.000000', 'temperatura', 628.0000, 'ºC'),
	(231253, 121, '2014-03-01 00:39:56.000000', 'temperatura', 903.0000, 'ºC'),
	(231254, 121, '2014-03-01 00:39:57.000000', 'temperatura', 231.0000, 'ºC'),
	(231255, 121, '2014-03-01 00:39:58.000000', 'temperatura', 847.0000, 'ºC'),
	(231256, 121, '2014-03-01 00:39:59.000000', 'temperatura', 1141.0000, 'ºC'),
	(231257, 121, '2014-03-01 00:40:00.000000', 'temperatura', 765.0000, 'ºC'),
	(231258, 121, '2014-03-01 00:40:01.000000', 'temperatura', 403.0000, 'ºC'),
	(231259, 121, '2014-03-01 00:40:02.000000', 'temperatura', 922.0000, 'ºC'),
	(231260, 121, '2014-03-01 00:40:03.000000', 'temperatura', 1002.0000, 'ºC'),
	(231261, 121, '2014-03-01 00:40:04.000000', 'temperatura', 1041.0000, 'ºC'),
	(231262, 121, '2014-03-01 00:40:05.000000', 'temperatura', 1002.0000, 'ºC'),
	(231263, 121, '2014-03-01 00:40:06.000000', 'temperatura', 689.0000, 'ºC'),
	(231264, 121, '2014-03-01 00:40:07.000000', 'temperatura', 436.0000, 'ºC'),
	(231265, 121, '2014-03-01 00:40:08.000000', 'temperatura', 115.0000, 'ºC'),
	(231266, 121, '2014-03-01 00:40:09.000000', 'temperatura', 465.0000, 'ºC'),
	(231267, 121, '2014-03-01 00:40:10.000000', 'temperatura', 784.0000, 'ºC'),
	(231268, 121, '2014-03-01 00:40:11.000000', 'temperatura', 124.0000, 'ºC'),
	(231269, 121, '2014-03-01 00:40:12.000000', 'temperatura', 670.0000, 'ºC'),
	(231270, 121, '2014-03-01 00:40:13.000000', 'temperatura', 579.0000, 'ºC'),
	(231271, 121, '2014-03-01 00:40:14.000000', 'temperatura', 885.0000, 'ºC'),
	(231272, 121, '2014-03-01 00:40:15.000000', 'temperatura', 290.0000, 'ºC'),
	(231273, 121, '2014-03-01 00:40:16.000000', 'temperatura', 1192.0000, 'ºC'),
	(231274, 121, '2014-03-01 00:40:17.000000', 'temperatura', 293.0000, 'ºC'),
	(231275, 121, '2014-03-01 00:40:18.000000', 'temperatura', 290.0000, 'ºC'),
	(231276, 121, '2014-03-01 00:40:19.000000', 'temperatura', 570.0000, 'ºC'),
	(231277, 121, '2014-03-01 00:40:20.000000', 'temperatura', 779.0000, 'ºC'),
	(231278, 121, '2014-03-01 00:40:21.000000', 'temperatura', 986.0000, 'ºC'),
	(231279, 121, '2014-03-01 00:40:22.000000', 'temperatura', 195.0000, 'ºC'),
	(231280, 121, '2014-03-01 00:40:23.000000', 'temperatura', 418.0000, 'ºC'),
	(231281, 121, '2014-03-01 00:40:24.000000', 'temperatura', 304.0000, 'ºC'),
	(231282, 121, '2014-03-01 00:40:25.000000', 'temperatura', 266.0000, 'ºC'),
	(231283, 121, '2014-03-01 00:40:26.000000', 'temperatura', 420.0000, 'ºC'),
	(231284, 121, '2014-03-01 00:40:27.000000', 'temperatura', 100.0000, 'ºC'),
	(231285, 121, '2014-03-01 00:40:28.000000', 'temperatura', 443.0000, 'ºC'),
	(231286, 121, '2014-03-01 00:40:29.000000', 'temperatura', 713.0000, 'ºC'),
	(231287, 121, '2014-03-01 00:40:30.000000', 'temperatura', 1039.0000, 'ºC'),
	(231288, 121, '2014-03-01 00:40:31.000000', 'temperatura', 654.0000, 'ºC'),
	(231289, 121, '2014-03-01 00:40:32.000000', 'temperatura', 156.0000, 'ºC'),
	(231290, 121, '2014-03-01 00:40:33.000000', 'temperatura', 16.0000, 'ºC'),
	(231291, 121, '2014-03-01 00:40:34.000000', 'temperatura', 811.0000, 'ºC'),
	(231292, 121, '2014-03-01 00:40:35.000000', 'temperatura', 411.0000, 'ºC'),
	(231293, 121, '2014-03-01 00:40:36.000000', 'temperatura', 823.0000, 'ºC'),
	(231294, 121, '2014-03-01 00:40:37.000000', 'temperatura', 480.0000, 'ºC'),
	(231295, 121, '2014-03-01 00:40:38.000000', 'temperatura', 1132.0000, 'ºC'),
	(231296, 121, '2014-03-01 00:40:39.000000', 'temperatura', 623.0000, 'ºC'),
	(231297, 121, '2014-03-01 00:40:40.000000', 'temperatura', 917.0000, 'ºC'),
	(231298, 121, '2014-03-01 00:40:41.000000', 'temperatura', 319.0000, 'ºC'),
	(231299, 121, '2014-03-01 00:40:42.000000', 'temperatura', 44.0000, 'ºC'),
	(231300, 121, '2014-03-01 00:40:43.000000', 'temperatura', 465.0000, 'ºC'),
	(231301, 121, '2014-03-01 00:40:44.000000', 'temperatura', 992.0000, 'ºC'),
	(231302, 121, '2014-03-01 00:40:45.000000', 'temperatura', 1167.0000, 'ºC'),
	(231303, 121, '2014-03-01 00:40:46.000000', 'temperatura', 461.0000, 'ºC'),
	(231304, 121, '2014-03-01 00:40:47.000000', 'temperatura', 1.0000, 'ºC'),
	(231305, 121, '2014-03-01 00:40:48.000000', 'temperatura', 1023.0000, 'ºC'),
	(231306, 121, '2014-03-01 00:40:49.000000', 'temperatura', 311.0000, 'ºC'),
	(231307, 121, '2014-03-01 00:40:50.000000', 'temperatura', 890.0000, 'ºC'),
	(231308, 121, '2014-03-01 00:40:51.000000', 'temperatura', 1115.0000, 'ºC'),
	(231309, 121, '2014-03-01 00:40:52.000000', 'temperatura', 506.0000, 'ºC'),
	(231310, 121, '2014-03-01 00:40:53.000000', 'temperatura', 387.0000, 'ºC'),
	(231311, 121, '2014-03-01 00:40:54.000000', 'temperatura', 418.0000, 'ºC'),
	(231312, 121, '2014-03-01 00:40:55.000000', 'temperatura', 931.0000, 'ºC'),
	(231313, 121, '2014-03-01 00:40:56.000000', 'temperatura', 998.0000, 'ºC'),
	(231314, 121, '2014-03-01 00:40:57.000000', 'temperatura', 998.0000, 'ºC'),
	(231315, 121, '2014-03-01 00:40:58.000000', 'temperatura', 795.0000, 'ºC'),
	(231316, 121, '2014-03-01 00:40:59.000000', 'temperatura', 984.0000, 'ºC'),
	(231317, 121, '2014-03-01 00:41:00.000000', 'temperatura', 136.0000, 'ºC'),
	(231318, 121, '2014-03-01 00:41:01.000000', 'temperatura', 127.0000, 'ºC'),
	(231319, 121, '2014-03-01 00:41:02.000000', 'temperatura', 227.0000, 'ºC'),
	(231320, 121, '2014-03-01 00:41:03.000000', 'temperatura', 756.0000, 'ºC'),
	(231321, 121, '2014-03-01 00:41:04.000000', 'temperatura', 701.0000, 'ºC'),
	(231322, 121, '2014-03-01 00:41:05.000000', 'temperatura', 35.0000, 'ºC'),
	(231323, 121, '2014-03-01 00:41:06.000000', 'temperatura', 474.0000, 'ºC'),
	(231324, 121, '2014-03-01 00:41:07.000000', 'temperatura', 1067.0000, 'ºC'),
	(231325, 121, '2014-03-01 00:41:08.000000', 'temperatura', 311.0000, 'ºC'),
	(231326, 121, '2014-03-01 00:41:09.000000', 'temperatura', 757.0000, 'ºC'),
	(231327, 121, '2014-03-01 00:41:10.000000', 'temperatura', 451.0000, 'ºC'),
	(231328, 121, '2014-03-01 00:41:11.000000', 'temperatura', 1185.0000, 'ºC'),
	(231329, 121, '2014-03-01 00:41:12.000000', 'temperatura', 971.0000, 'ºC'),
	(231330, 121, '2014-03-01 00:41:13.000000', 'temperatura', 101.0000, 'ºC'),
	(231331, 121, '2014-03-01 00:41:14.000000', 'temperatura', 1193.0000, 'ºC'),
	(231332, 121, '2014-03-01 00:41:15.000000', 'temperatura', 863.0000, 'ºC'),
	(231333, 121, '2014-03-01 00:41:16.000000', 'temperatura', 737.0000, 'ºC'),
	(231334, 121, '2014-03-01 00:41:17.000000', 'temperatura', 1096.0000, 'ºC'),
	(231335, 121, '2014-03-01 00:41:18.000000', 'temperatura', 870.0000, 'ºC'),
	(231336, 121, '2014-03-01 00:41:19.000000', 'temperatura', 1060.0000, 'ºC'),
	(231337, 121, '2014-03-01 00:41:20.000000', 'temperatura', 292.0000, 'ºC'),
	(231338, 121, '2014-03-01 00:41:21.000000', 'temperatura', 681.0000, 'ºC'),
	(231339, 121, '2014-03-01 00:41:22.000000', 'temperatura', 127.0000, 'ºC'),
	(231340, 121, '2014-03-01 00:41:23.000000', 'temperatura', 995.0000, 'ºC'),
	(231341, 121, '2014-03-01 00:41:24.000000', 'temperatura', 995.0000, 'ºC'),
	(231342, 121, '2014-03-01 00:41:25.000000', 'temperatura', 791.0000, 'ºC'),
	(231343, 121, '2014-03-01 00:41:26.000000', 'temperatura', 967.0000, 'ºC'),
	(231344, 121, '2014-03-01 00:41:27.000000', 'temperatura', 66.0000, 'ºC'),
	(231345, 121, '2014-03-01 00:41:28.000000', 'temperatura', 1030.0000, 'ºC'),
	(231346, 121, '2014-03-01 00:41:29.000000', 'temperatura', 152.0000, 'ºC'),
	(231347, 121, '2014-03-01 00:41:30.000000', 'temperatura', 68.0000, 'ºC'),
	(231348, 121, '2014-03-01 00:41:31.000000', 'temperatura', 1086.0000, 'ºC'),
	(231349, 121, '2014-03-01 00:41:32.000000', 'temperatura', 426.0000, 'ºC'),
	(231350, 121, '2014-03-01 00:41:33.000000', 'temperatura', 71.0000, 'ºC'),
	(231351, 121, '2014-03-01 00:41:34.000000', 'temperatura', 278.0000, 'ºC'),
	(231352, 121, '2014-03-01 00:41:35.000000', 'temperatura', 1176.0000, 'ºC'),
	(231353, 121, '2014-03-01 00:41:36.000000', 'temperatura', 250.0000, 'ºC'),
	(231354, 121, '2014-03-01 00:41:37.000000', 'temperatura', 120.0000, 'ºC'),
	(231355, 121, '2014-03-01 00:41:38.000000', 'temperatura', 1053.0000, 'ºC'),
	(231356, 121, '2014-03-01 00:41:39.000000', 'temperatura', 105.0000, 'ºC'),
	(231357, 121, '2014-03-01 00:41:40.000000', 'temperatura', 966.0000, 'ºC'),
	(231358, 121, '2014-03-01 00:41:41.000000', 'temperatura', 915.0000, 'ºC'),
	(231359, 121, '2014-03-01 00:41:42.000000', 'temperatura', 480.0000, 'ºC'),
	(231360, 121, '2014-03-01 00:41:43.000000', 'temperatura', 854.0000, 'ºC'),
	(231361, 121, '2014-03-01 00:41:44.000000', 'temperatura', 429.0000, 'ºC'),
	(231362, 121, '2014-03-01 00:41:45.000000', 'temperatura', 785.0000, 'ºC'),
	(231363, 121, '2014-03-01 00:41:46.000000', 'temperatura', 237.0000, 'ºC'),
	(231364, 121, '2014-03-01 00:41:47.000000', 'temperatura', 31.0000, 'ºC'),
	(231365, 121, '2014-03-01 00:41:48.000000', 'temperatura', 647.0000, 'ºC'),
	(231366, 121, '2014-03-01 00:41:49.000000', 'temperatura', 739.0000, 'ºC'),
	(231367, 121, '2014-03-01 00:41:50.000000', 'temperatura', 556.0000, 'ºC'),
	(231368, 121, '2014-03-01 00:41:51.000000', 'temperatura', 562.0000, 'ºC'),
	(231369, 121, '2014-03-01 00:41:52.000000', 'temperatura', 1143.0000, 'ºC'),
	(231370, 121, '2014-03-01 00:41:53.000000', 'temperatura', 428.0000, 'ºC'),
	(231371, 121, '2014-03-01 00:41:54.000000', 'temperatura', 1112.0000, 'ºC'),
	(231372, 121, '2014-03-01 00:41:55.000000', 'temperatura', 679.0000, 'ºC'),
	(231373, 121, '2014-03-01 00:41:56.000000', 'temperatura', 58.0000, 'ºC'),
	(231374, 121, '2014-03-01 00:41:57.000000', 'temperatura', 654.0000, 'ºC'),
	(231375, 121, '2014-03-01 00:41:58.000000', 'temperatura', 695.0000, 'ºC'),
	(231376, 121, '2014-03-01 00:41:59.000000', 'temperatura', 314.0000, 'ºC'),
	(231377, 121, '2014-03-01 00:42:00.000000', 'temperatura', 687.0000, 'ºC'),
	(231378, 121, '2014-03-01 00:42:01.000000', 'temperatura', 94.0000, 'ºC'),
	(231379, 121, '2014-03-01 00:42:02.000000', 'temperatura', 810.0000, 'ºC'),
	(231380, 121, '2014-03-01 00:42:03.000000', 'temperatura', 169.0000, 'ºC'),
	(231381, 121, '2014-03-01 00:42:04.000000', 'temperatura', 812.0000, 'ºC'),
	(231382, 121, '2014-03-01 00:42:05.000000', 'temperatura', 1157.0000, 'ºC'),
	(231383, 121, '2014-03-01 00:42:06.000000', 'temperatura', 948.0000, 'ºC'),
	(231384, 121, '2014-03-01 00:42:07.000000', 'temperatura', 68.0000, 'ºC'),
	(231385, 121, '2014-03-01 00:42:08.000000', 'temperatura', 1096.0000, 'ºC'),
	(231386, 121, '2014-03-01 00:42:09.000000', 'temperatura', 476.0000, 'ºC'),
	(231387, 121, '2014-03-01 00:42:10.000000', 'temperatura', 294.0000, 'ºC'),
	(231388, 121, '2014-03-01 00:42:11.000000', 'temperatura', 44.0000, 'ºC'),
	(231389, 121, '2014-03-01 00:42:12.000000', 'temperatura', 536.0000, 'ºC'),
	(231390, 121, '2014-03-01 00:42:13.000000', 'temperatura', 150.0000, 'ºC'),
	(231391, 121, '2014-03-01 00:42:14.000000', 'temperatura', 344.0000, 'ºC'),
	(231392, 121, '2014-03-01 00:42:15.000000', 'temperatura', 67.0000, 'ºC'),
	(231393, 121, '2014-03-01 00:42:16.000000', 'temperatura', 506.0000, 'ºC'),
	(231394, 121, '2014-03-01 00:42:17.000000', 'temperatura', 1127.0000, 'ºC'),
	(231395, 121, '2014-03-01 00:42:18.000000', 'temperatura', 519.0000, 'ºC'),
	(231396, 121, '2014-03-01 00:42:19.000000', 'temperatura', 415.0000, 'ºC'),
	(231397, 121, '2014-03-01 00:42:20.000000', 'temperatura', 519.0000, 'ºC'),
	(231398, 121, '2014-03-01 00:42:21.000000', 'temperatura', 150.0000, 'ºC'),
	(231399, 121, '2014-03-01 00:42:22.000000', 'temperatura', 393.0000, 'ºC'),
	(231400, 121, '2014-03-01 00:42:23.000000', 'temperatura', 317.0000, 'ºC'),
	(231401, 121, '2014-03-01 00:42:24.000000', 'temperatura', 404.0000, 'ºC'),
	(231402, 121, '2014-03-01 00:42:25.000000', 'temperatura', 1069.0000, 'ºC'),
	(231403, 121, '2014-03-01 00:42:26.000000', 'temperatura', 535.0000, 'ºC'),
	(231404, 121, '2014-03-01 00:42:27.000000', 'temperatura', 667.0000, 'ºC'),
	(231405, 121, '2014-03-01 00:42:28.000000', 'temperatura', 531.0000, 'ºC'),
	(231406, 121, '2014-03-01 00:42:29.000000', 'temperatura', 653.0000, 'ºC'),
	(231407, 121, '2014-03-01 00:42:30.000000', 'temperatura', 474.0000, 'ºC'),
	(231408, 121, '2014-03-01 00:42:31.000000', 'temperatura', 412.0000, 'ºC'),
	(231409, 121, '2014-03-01 00:42:32.000000', 'temperatura', 637.0000, 'ºC'),
	(231410, 121, '2014-03-01 00:42:33.000000', 'temperatura', 749.0000, 'ºC'),
	(231411, 121, '2014-03-01 00:42:34.000000', 'temperatura', 637.0000, 'ºC'),
	(231412, 121, '2014-03-01 00:42:35.000000', 'temperatura', 937.0000, 'ºC'),
	(231413, 121, '2014-03-01 00:42:36.000000', 'temperatura', 374.0000, 'ºC'),
	(231414, 121, '2014-03-01 00:42:37.000000', 'temperatura', 261.0000, 'ºC'),
	(231415, 121, '2014-03-01 00:42:38.000000', 'temperatura', 185.0000, 'ºC'),
	(231416, 121, '2014-03-01 00:42:39.000000', 'temperatura', 139.0000, 'ºC'),
	(231417, 121, '2014-03-01 00:42:40.000000', 'temperatura', 141.0000, 'ºC'),
	(231418, 121, '2014-03-01 00:42:41.000000', 'temperatura', 290.0000, 'ºC'),
	(231419, 121, '2014-03-01 00:42:42.000000', 'temperatura', 1027.0000, 'ºC'),
	(231420, 121, '2014-03-01 00:42:43.000000', 'temperatura', 664.0000, 'ºC'),
	(231421, 121, '2014-03-01 00:42:44.000000', 'temperatura', 241.0000, 'ºC'),
	(231422, 121, '2014-03-01 00:42:45.000000', 'temperatura', 415.0000, 'ºC'),
	(231423, 121, '2014-03-01 00:42:46.000000', 'temperatura', 151.0000, 'ºC'),
	(231424, 121, '2014-03-01 00:42:47.000000', 'temperatura', 710.0000, 'ºC'),
	(231425, 121, '2014-03-01 00:42:48.000000', 'temperatura', 699.0000, 'ºC'),
	(231426, 121, '2014-03-01 00:42:49.000000', 'temperatura', 165.0000, 'ºC'),
	(231427, 121, '2014-03-01 00:42:50.000000', 'temperatura', 1130.0000, 'ºC'),
	(231428, 121, '2014-03-01 00:42:51.000000', 'temperatura', 353.0000, 'ºC'),
	(231429, 121, '2014-03-01 00:42:52.000000', 'temperatura', 776.0000, 'ºC'),
	(231430, 121, '2014-03-01 00:42:53.000000', 'temperatura', 424.0000, 'ºC'),
	(231431, 121, '2014-03-01 00:42:54.000000', 'temperatura', 989.0000, 'ºC'),
	(231432, 121, '2014-03-01 00:42:55.000000', 'temperatura', 76.0000, 'ºC'),
	(231433, 121, '2014-03-01 00:42:56.000000', 'temperatura', 1014.0000, 'ºC'),
	(231434, 121, '2014-03-01 00:42:57.000000', 'temperatura', 43.0000, 'ºC'),
	(231435, 121, '2014-03-01 00:42:58.000000', 'temperatura', 772.0000, 'ºC'),
	(231436, 121, '2014-03-01 00:42:59.000000', 'temperatura', 131.0000, 'ºC'),
	(231437, 121, '2014-03-01 00:43:00.000000', 'temperatura', 739.0000, 'ºC'),
	(231438, 121, '2014-03-01 00:43:01.000000', 'temperatura', 905.0000, 'ºC'),
	(231439, 121, '2014-03-01 00:43:02.000000', 'temperatura', 1106.0000, 'ºC'),
	(231440, 121, '2014-03-01 00:43:03.000000', 'temperatura', 418.0000, 'ºC'),
	(231441, 121, '2014-03-01 00:43:04.000000', 'temperatura', 1171.0000, 'ºC'),
	(231442, 121, '2014-03-01 00:43:05.000000', 'temperatura', 1001.0000, 'ºC'),
	(231443, 121, '2014-03-01 00:43:06.000000', 'temperatura', 292.0000, 'ºC'),
	(231444, 121, '2014-03-01 00:43:07.000000', 'temperatura', 856.0000, 'ºC'),
	(231445, 121, '2014-03-01 00:43:08.000000', 'temperatura', 1008.0000, 'ºC'),
	(231446, 121, '2014-03-01 00:43:09.000000', 'temperatura', 70.0000, 'ºC'),
	(231447, 121, '2014-03-01 00:43:10.000000', 'temperatura', 929.0000, 'ºC'),
	(231448, 121, '2014-03-01 00:43:11.000000', 'temperatura', 836.0000, 'ºC'),
	(231449, 121, '2014-03-01 00:43:12.000000', 'temperatura', 191.0000, 'ºC'),
	(231450, 121, '2014-03-01 00:43:13.000000', 'temperatura', 848.0000, 'ºC'),
	(231451, 121, '2014-03-01 00:43:14.000000', 'temperatura', 69.0000, 'ºC'),
	(231452, 121, '2014-03-01 00:43:15.000000', 'temperatura', 200.0000, 'ºC'),
	(231453, 121, '2014-03-01 00:43:16.000000', 'temperatura', 794.0000, 'ºC'),
	(231454, 121, '2014-03-01 00:43:17.000000', 'temperatura', 972.0000, 'ºC'),
	(231455, 121, '2014-03-01 00:43:18.000000', 'temperatura', 77.0000, 'ºC'),
	(231456, 121, '2014-03-01 00:43:19.000000', 'temperatura', 1072.0000, 'ºC'),
	(231457, 121, '2014-03-01 00:43:20.000000', 'temperatura', 327.0000, 'ºC'),
	(231458, 121, '2014-03-01 00:43:21.000000', 'temperatura', 819.0000, 'ºC'),
	(231459, 121, '2014-03-01 00:43:22.000000', 'temperatura', 717.0000, 'ºC'),
	(231460, 121, '2014-03-01 00:43:23.000000', 'temperatura', 1129.0000, 'ºC'),
	(231461, 121, '2014-03-01 00:43:24.000000', 'temperatura', 1093.0000, 'ºC'),
	(231462, 121, '2014-03-01 00:43:25.000000', 'temperatura', 881.0000, 'ºC'),
	(231463, 121, '2014-03-01 00:43:26.000000', 'temperatura', 1124.0000, 'ºC'),
	(231464, 121, '2014-03-01 00:43:27.000000', 'temperatura', 577.0000, 'ºC'),
	(231465, 121, '2014-03-01 00:43:28.000000', 'temperatura', 712.0000, 'ºC'),
	(231466, 121, '2014-03-01 00:43:29.000000', 'temperatura', 632.0000, 'ºC'),
	(231467, 121, '2014-03-01 00:43:30.000000', 'temperatura', 1024.0000, 'ºC'),
	(231468, 121, '2014-03-01 00:43:31.000000', 'temperatura', 825.0000, 'ºC'),
	(231469, 121, '2014-03-01 00:43:32.000000', 'temperatura', 1054.0000, 'ºC'),
	(231470, 121, '2014-03-01 00:43:33.000000', 'temperatura', 394.0000, 'ºC'),
	(231471, 121, '2014-03-01 00:43:34.000000', 'temperatura', 11.0000, 'ºC'),
	(231472, 121, '2014-03-01 00:43:35.000000', 'temperatura', 70.0000, 'ºC'),
	(231473, 121, '2014-03-01 00:43:36.000000', 'temperatura', 319.0000, 'ºC'),
	(231474, 121, '2014-03-01 00:43:37.000000', 'temperatura', 187.0000, 'ºC'),
	(231475, 121, '2014-03-01 00:43:38.000000', 'temperatura', 1178.0000, 'ºC'),
	(231476, 121, '2014-03-01 00:43:39.000000', 'temperatura', 528.0000, 'ºC'),
	(231477, 121, '2014-03-01 00:43:40.000000', 'temperatura', 308.0000, 'ºC'),
	(231478, 121, '2014-03-01 00:43:41.000000', 'temperatura', 1158.0000, 'ºC'),
	(231479, 121, '2014-03-01 00:43:42.000000', 'temperatura', 64.0000, 'ºC'),
	(231480, 121, '2014-03-01 00:43:43.000000', 'temperatura', 449.0000, 'ºC'),
	(231481, 121, '2014-03-01 00:43:44.000000', 'temperatura', 851.0000, 'ºC'),
	(231482, 121, '2014-03-01 00:43:45.000000', 'temperatura', 509.0000, 'ºC'),
	(231483, 121, '2014-03-01 00:43:46.000000', 'temperatura', 1193.0000, 'ºC'),
	(231484, 121, '2014-03-01 00:43:47.000000', 'temperatura', 840.0000, 'ºC'),
	(231485, 121, '2014-03-01 00:43:48.000000', 'temperatura', 622.0000, 'ºC'),
	(231486, 121, '2014-03-01 00:43:49.000000', 'temperatura', 591.0000, 'ºC'),
	(231487, 121, '2014-03-01 00:43:50.000000', 'temperatura', 1090.0000, 'ºC'),
	(231488, 121, '2014-03-01 00:43:51.000000', 'temperatura', 75.0000, 'ºC'),
	(231489, 121, '2014-03-01 00:43:52.000000', 'temperatura', 705.0000, 'ºC'),
	(231490, 121, '2014-03-01 00:43:53.000000', 'temperatura', 901.0000, 'ºC'),
	(231491, 121, '2014-03-01 00:43:54.000000', 'temperatura', 1192.0000, 'ºC'),
	(231492, 121, '2014-03-01 00:43:55.000000', 'temperatura', 855.0000, 'ºC'),
	(231493, 121, '2014-03-01 00:43:56.000000', 'temperatura', 702.0000, 'ºC'),
	(231494, 121, '2014-03-01 00:43:57.000000', 'temperatura', 946.0000, 'ºC'),
	(231495, 121, '2014-03-01 00:43:58.000000', 'temperatura', 225.0000, 'ºC'),
	(231496, 121, '2014-03-01 00:43:59.000000', 'temperatura', 689.0000, 'ºC'),
	(231497, 121, '2014-03-01 00:44:00.000000', 'temperatura', 367.0000, 'ºC'),
	(231498, 121, '2014-03-01 00:44:01.000000', 'temperatura', 970.0000, 'ºC'),
	(231499, 121, '2014-03-01 00:44:02.000000', 'temperatura', 148.0000, 'ºC'),
	(231500, 121, '2014-03-01 00:44:03.000000', 'temperatura', 231.0000, 'ºC'),
	(231501, 121, '2014-03-01 00:44:04.000000', 'temperatura', 710.0000, 'ºC'),
	(231502, 121, '2014-03-01 00:44:05.000000', 'temperatura', 459.0000, 'ºC'),
	(231503, 121, '2014-03-01 00:44:06.000000', 'temperatura', 165.0000, 'ºC'),
	(231504, 121, '2014-03-01 00:44:07.000000', 'temperatura', 651.0000, 'ºC'),
	(231505, 121, '2014-03-01 00:44:08.000000', 'temperatura', 358.0000, 'ºC'),
	(231506, 121, '2014-03-01 00:44:09.000000', 'temperatura', 1038.0000, 'ºC'),
	(231507, 121, '2014-03-01 00:44:10.000000', 'temperatura', 515.0000, 'ºC'),
	(231508, 121, '2014-03-01 00:44:11.000000', 'temperatura', 663.0000, 'ºC'),
	(231509, 121, '2014-03-01 00:44:12.000000', 'temperatura', 571.0000, 'ºC'),
	(231510, 121, '2014-03-01 00:44:13.000000', 'temperatura', 866.0000, 'ºC'),
	(231511, 121, '2014-03-01 00:44:14.000000', 'temperatura', 216.0000, 'ºC'),
	(231512, 121, '2014-03-01 00:44:15.000000', 'temperatura', 885.0000, 'ºC'),
	(231513, 121, '2014-03-01 00:44:16.000000', 'temperatura', 178.0000, 'ºC'),
	(231514, 121, '2014-03-01 00:44:17.000000', 'temperatura', 635.0000, 'ºC'),
	(231515, 121, '2014-03-01 00:44:18.000000', 'temperatura', 242.0000, 'ºC'),
	(231516, 121, '2014-03-01 00:44:19.000000', 'temperatura', 506.0000, 'ºC'),
	(231517, 121, '2014-03-01 00:44:20.000000', 'temperatura', 604.0000, 'ºC'),
	(231518, 121, '2014-03-01 00:44:21.000000', 'temperatura', 302.0000, 'ºC'),
	(231519, 121, '2014-03-01 00:44:22.000000', 'temperatura', 899.0000, 'ºC'),
	(231520, 121, '2014-03-01 00:44:23.000000', 'temperatura', 1188.0000, 'ºC'),
	(231521, 121, '2014-03-01 00:44:24.000000', 'temperatura', 843.0000, 'ºC'),
	(231522, 121, '2014-03-01 00:44:25.000000', 'temperatura', 651.0000, 'ºC'),
	(231523, 121, '2014-03-01 00:44:26.000000', 'temperatura', 726.0000, 'ºC'),
	(231524, 121, '2014-03-01 00:44:27.000000', 'temperatura', 478.0000, 'ºC'),
	(231525, 121, '2014-03-01 00:44:28.000000', 'temperatura', 212.0000, 'ºC'),
	(231526, 121, '2014-03-01 00:44:29.000000', 'temperatura', 825.0000, 'ºC'),
	(231527, 121, '2014-03-01 00:44:30.000000', 'temperatura', 1092.0000, 'ºC'),
	(231528, 121, '2014-03-01 00:44:31.000000', 'temperatura', 586.0000, 'ºC'),
	(231529, 121, '2014-03-01 00:44:32.000000', 'temperatura', 855.0000, 'ºC'),
	(231530, 121, '2014-03-01 00:44:33.000000', 'temperatura', 116.0000, 'ºC'),
	(231531, 121, '2014-03-01 00:44:34.000000', 'temperatura', 417.0000, 'ºC'),
	(231532, 121, '2014-03-01 00:44:35.000000', 'temperatura', 535.0000, 'ºC'),
	(231533, 121, '2014-03-01 00:44:36.000000', 'temperatura', 225.0000, 'ºC'),
	(231534, 121, '2014-03-01 00:44:37.000000', 'temperatura', 719.0000, 'ºC'),
	(231535, 121, '2014-03-01 00:44:38.000000', 'temperatura', 523.0000, 'ºC'),
	(231536, 121, '2014-03-01 00:44:39.000000', 'temperatura', 457.0000, 'ºC'),
	(231537, 121, '2014-03-01 00:44:40.000000', 'temperatura', 719.0000, 'ºC'),
	(231538, 121, '2014-03-01 00:44:41.000000', 'temperatura', 1022.0000, 'ºC'),
	(231539, 121, '2014-03-01 00:44:42.000000', 'temperatura', 556.0000, 'ºC'),
	(231540, 121, '2014-03-01 00:44:43.000000', 'temperatura', 912.0000, 'ºC'),
	(231541, 121, '2014-03-01 00:44:44.000000', 'temperatura', 493.0000, 'ºC'),
	(231542, 121, '2014-03-01 00:44:45.000000', 'temperatura', 930.0000, 'ºC'),
	(231543, 121, '2014-03-01 00:44:46.000000', 'temperatura', 773.0000, 'ºC'),
	(231544, 121, '2014-03-01 00:44:47.000000', 'temperatura', 1075.0000, 'ºC'),
	(231545, 121, '2014-03-01 00:44:48.000000', 'temperatura', 656.0000, 'ºC'),
	(231546, 121, '2014-03-01 00:44:49.000000', 'temperatura', 56.0000, 'ºC'),
	(231547, 121, '2014-03-01 00:44:50.000000', 'temperatura', 710.0000, 'ºC'),
	(231548, 121, '2014-03-01 00:44:51.000000', 'temperatura', 985.0000, 'ºC'),
	(231549, 121, '2014-03-01 00:44:52.000000', 'temperatura', 396.0000, 'ºC'),
	(231550, 121, '2014-03-01 00:44:53.000000', 'temperatura', 225.0000, 'ºC'),
	(231551, 121, '2014-03-01 00:44:54.000000', 'temperatura', 1135.0000, 'ºC'),
	(231552, 121, '2014-03-01 00:44:55.000000', 'temperatura', 204.0000, 'ºC'),
	(231553, 121, '2014-03-01 00:44:56.000000', 'temperatura', 12.0000, 'ºC'),
	(231554, 121, '2014-03-01 00:44:57.000000', 'temperatura', 651.0000, 'ºC'),
	(231555, 121, '2014-03-01 00:44:58.000000', 'temperatura', 819.0000, 'ºC'),
	(231556, 121, '2014-03-01 00:44:59.000000', 'temperatura', 944.0000, 'ºC'),
	(231557, 121, '2014-03-01 00:45:00.000000', 'temperatura', 1064.0000, 'ºC'),
	(231558, 121, '2014-03-01 00:45:01.000000', 'temperatura', 87.0000, 'ºC'),
	(231559, 121, '2014-03-01 00:45:02.000000', 'temperatura', 846.0000, 'ºC'),
	(231560, 121, '2014-03-01 00:45:03.000000', 'temperatura', 366.0000, 'ºC'),
	(231561, 121, '2014-03-01 00:45:04.000000', 'temperatura', 496.0000, 'ºC'),
	(231562, 121, '2014-03-01 00:45:05.000000', 'temperatura', 180.0000, 'ºC'),
	(231563, 121, '2014-03-01 00:45:06.000000', 'temperatura', 612.0000, 'ºC'),
	(231564, 121, '2014-03-01 00:45:07.000000', 'temperatura', 121.0000, 'ºC'),
	(231565, 121, '2014-03-01 00:45:08.000000', 'temperatura', 1169.0000, 'ºC'),
	(231566, 121, '2014-03-01 00:45:09.000000', 'temperatura', 681.0000, 'ºC'),
	(231567, 121, '2014-03-01 00:45:10.000000', 'temperatura', 1102.0000, 'ºC'),
	(231568, 121, '2014-03-01 00:45:11.000000', 'temperatura', 1066.0000, 'ºC'),
	(231569, 121, '2014-03-01 00:45:12.000000', 'temperatura', 825.0000, 'ºC'),
	(231570, 121, '2014-03-01 00:45:13.000000', 'temperatura', 928.0000, 'ºC'),
	(231571, 121, '2014-03-01 00:45:14.000000', 'temperatura', 967.0000, 'ºC'),
	(231572, 121, '2014-03-01 00:45:15.000000', 'temperatura', 849.0000, 'ºC'),
	(231573, 121, '2014-03-01 00:45:16.000000', 'temperatura', 145.0000, 'ºC'),
	(231574, 121, '2014-03-01 00:45:17.000000', 'temperatura', 579.0000, 'ºC'),
	(231575, 121, '2014-03-01 00:45:18.000000', 'temperatura', 58.0000, 'ºC'),
	(231576, 121, '2014-03-01 00:45:19.000000', 'temperatura', 956.0000, 'ºC'),
	(231577, 121, '2014-03-01 00:45:20.000000', 'temperatura', 1006.0000, 'ºC'),
	(231578, 121, '2014-03-01 00:45:21.000000', 'temperatura', 961.0000, 'ºC'),
	(231579, 121, '2014-03-01 00:45:22.000000', 'temperatura', 590.0000, 'ºC'),
	(231580, 121, '2014-03-01 00:45:23.000000', 'temperatura', 65.0000, 'ºC'),
	(231581, 121, '2014-03-01 00:45:24.000000', 'temperatura', 958.0000, 'ºC'),
	(231582, 121, '2014-03-01 00:45:25.000000', 'temperatura', 994.0000, 'ºC'),
	(231583, 121, '2014-03-01 00:45:26.000000', 'temperatura', 898.0000, 'ºC'),
	(231584, 121, '2014-03-01 00:45:27.000000', 'temperatura', 307.0000, 'ºC'),
	(231585, 121, '2014-03-01 00:45:28.000000', 'temperatura', 44.0000, 'ºC'),
	(231586, 121, '2014-03-01 00:45:29.000000', 'temperatura', 498.0000, 'ºC'),
	(231587, 121, '2014-03-01 00:45:30.000000', 'temperatura', 1159.0000, 'ºC'),
	(231588, 121, '2014-03-01 00:45:31.000000', 'temperatura', 703.0000, 'ºC'),
	(231589, 121, '2014-03-01 00:45:32.000000', 'temperatura', 38.0000, 'ºC'),
	(231590, 121, '2014-03-01 00:45:33.000000', 'temperatura', 480.0000, 'ºC'),
	(231591, 121, '2014-03-01 00:45:34.000000', 'temperatura', 1088.0000, 'ºC'),
	(231592, 121, '2014-03-01 00:45:35.000000', 'temperatura', 401.0000, 'ºC'),
	(231593, 121, '2014-03-01 00:45:36.000000', 'temperatura', 1141.0000, 'ºC'),
	(231594, 121, '2014-03-01 00:45:37.000000', 'temperatura', 900.0000, 'ºC'),
	(231595, 121, '2014-03-01 00:45:38.000000', 'temperatura', 1080.0000, 'ºC'),
	(231596, 121, '2014-03-01 00:45:39.000000', 'temperatura', 301.0000, 'ºC'),
	(231597, 121, '2014-03-01 00:45:40.000000', 'temperatura', 665.0000, 'ºC'),
	(231598, 121, '2014-03-01 00:45:41.000000', 'temperatura', 24.0000, 'ºC'),
	(231599, 121, '2014-03-01 00:45:42.000000', 'temperatura', 525.0000, 'ºC'),
	(231600, 121, '2014-03-01 00:45:43.000000', 'temperatura', 154.0000, 'ºC'),
	(231601, 121, '2014-03-01 00:45:44.000000', 'temperatura', 393.0000, 'ºC'),
	(231602, 121, '2014-03-01 00:45:45.000000', 'temperatura', 304.0000, 'ºC'),
	(231603, 121, '2014-03-01 00:45:46.000000', 'temperatura', 342.0000, 'ºC'),
	(231604, 121, '2014-03-01 00:45:47.000000', 'temperatura', 800.0000, 'ºC'),
	(231605, 121, '2014-03-01 00:45:48.000000', 'temperatura', 573.0000, 'ºC'),
	(231606, 121, '2014-03-01 00:45:49.000000', 'temperatura', 468.0000, 'ºC'),
	(231607, 121, '2014-03-01 00:45:50.000000', 'temperatura', 619.0000, 'ºC'),
	(231608, 121, '2014-03-01 00:45:51.000000', 'temperatura', 493.0000, 'ºC'),
	(231609, 121, '2014-03-01 00:45:52.000000', 'temperatura', 610.0000, 'ºC'),
	(231610, 121, '2014-03-01 00:45:53.000000', 'temperatura', 368.0000, 'ºC'),
	(231611, 121, '2014-03-01 00:45:54.000000', 'temperatura', 14.0000, 'ºC'),
	(231612, 121, '2014-03-01 00:45:55.000000', 'temperatura', 164.0000, 'ºC'),
	(231613, 121, '2014-03-01 00:45:56.000000', 'temperatura', 778.0000, 'ºC'),
	(231614, 121, '2014-03-01 00:45:57.000000', 'temperatura', 1000.0000, 'ºC'),
	(231615, 121, '2014-03-01 00:45:58.000000', 'temperatura', 266.0000, 'ºC'),
	(231616, 121, '2014-03-01 00:45:59.000000', 'temperatura', 732.0000, 'ºC'),
	(231617, 121, '2014-03-01 00:46:00.000000', 'temperatura', 461.0000, 'ºC'),
	(231618, 121, '2014-03-01 00:46:01.000000', 'temperatura', 111.0000, 'ºC'),
	(231619, 121, '2014-03-01 00:46:02.000000', 'temperatura', 371.0000, 'ºC'),
	(231620, 121, '2014-03-01 00:46:03.000000', 'temperatura', 325.0000, 'ºC'),
	(231621, 121, '2014-03-01 00:46:04.000000', 'temperatura', 510.0000, 'ºC'),
	(231622, 121, '2014-03-01 00:46:05.000000', 'temperatura', 378.0000, 'ºC'),
	(231623, 121, '2014-03-01 00:46:06.000000', 'temperatura', 360.0000, 'ºC'),
	(231624, 121, '2014-03-01 00:46:07.000000', 'temperatura', 665.0000, 'ºC'),
	(231625, 121, '2014-03-01 00:46:08.000000', 'temperatura', 1045.0000, 'ºC'),
	(231626, 121, '2014-03-01 00:46:09.000000', 'temperatura', 830.0000, 'ºC'),
	(231627, 121, '2014-03-01 00:46:10.000000', 'temperatura', 1017.0000, 'ºC'),
	(231628, 121, '2014-03-01 00:46:11.000000', 'temperatura', 194.0000, 'ºC'),
	(231629, 121, '2014-03-01 00:46:12.000000', 'temperatura', 322.0000, 'ºC'),
	(231630, 121, '2014-03-01 00:46:13.000000', 'temperatura', 1027.0000, 'ºC'),
	(231631, 121, '2014-03-01 00:46:14.000000', 'temperatura', 572.0000, 'ºC'),
	(231632, 121, '2014-03-01 00:46:15.000000', 'temperatura', 976.0000, 'ºC'),
	(231633, 121, '2014-03-01 00:46:16.000000', 'temperatura', 767.0000, 'ºC'),
	(231634, 121, '2014-03-01 00:46:17.000000', 'temperatura', 905.0000, 'ºC'),
	(231635, 121, '2014-03-01 00:46:18.000000', 'temperatura', 1027.0000, 'ºC'),
	(231636, 121, '2014-03-01 00:46:19.000000', 'temperatura', 18.0000, 'ºC'),
	(231637, 121, '2014-03-01 00:46:20.000000', 'temperatura', 608.0000, 'ºC'),
	(231638, 121, '2014-03-01 00:46:21.000000', 'temperatura', 590.0000, 'ºC'),
	(231639, 121, '2014-03-01 00:46:22.000000', 'temperatura', 1127.0000, 'ºC'),
	(231640, 121, '2014-03-01 00:46:23.000000', 'temperatura', 264.0000, 'ºC'),
	(231641, 121, '2014-03-01 00:46:24.000000', 'temperatura', 341.0000, 'ºC'),
	(231642, 121, '2014-03-01 00:46:25.000000', 'temperatura', 911.0000, 'ºC'),
	(231643, 121, '2014-03-01 00:46:26.000000', 'temperatura', 1135.0000, 'ºC'),
	(231644, 121, '2014-03-01 00:46:27.000000', 'temperatura', 542.0000, 'ºC'),
	(231645, 121, '2014-03-01 00:46:28.000000', 'temperatura', 505.0000, 'ºC'),
	(231646, 121, '2014-03-01 00:46:29.000000', 'temperatura', 900.0000, 'ºC'),
	(231647, 121, '2014-03-01 00:46:30.000000', 'temperatura', 587.0000, 'ºC'),
	(231648, 121, '2014-03-01 00:46:31.000000', 'temperatura', 235.0000, 'ºC'),
	(231649, 121, '2014-03-01 00:46:32.000000', 'temperatura', 615.0000, 'ºC'),
	(231650, 121, '2014-03-01 00:46:33.000000', 'temperatura', 1170.0000, 'ºC'),
	(231651, 121, '2014-03-01 00:46:34.000000', 'temperatura', 406.0000, 'ºC'),
	(231652, 121, '2014-03-01 00:46:35.000000', 'temperatura', 920.0000, 'ºC'),
	(231653, 121, '2014-03-01 00:46:36.000000', 'temperatura', 983.0000, 'ºC'),
	(231654, 121, '2014-03-01 00:46:37.000000', 'temperatura', 956.0000, 'ºC'),
	(231655, 121, '2014-03-01 00:46:38.000000', 'temperatura', 631.0000, 'ºC'),
	(231656, 121, '2014-03-01 00:46:39.000000', 'temperatura', 286.0000, 'ºC'),
	(231657, 121, '2014-03-01 00:46:40.000000', 'temperatura', 738.0000, 'ºC'),
	(231658, 121, '2014-03-01 00:46:41.000000', 'temperatura', 433.0000, 'ºC'),
	(231659, 121, '2014-03-01 00:46:42.000000', 'temperatura', 1152.0000, 'ºC'),
	(231660, 121, '2014-03-01 00:46:43.000000', 'temperatura', 861.0000, 'ºC'),
	(231661, 121, '2014-03-01 00:46:44.000000', 'temperatura', 849.0000, 'ºC'),
	(231662, 121, '2014-03-01 00:46:45.000000', 'temperatura', 463.0000, 'ºC'),
	(231663, 121, '2014-03-01 00:46:46.000000', 'temperatura', 971.0000, 'ºC'),
	(231664, 121, '2014-03-01 00:46:47.000000', 'temperatura', 1063.0000, 'ºC'),
	(231665, 121, '2014-03-01 00:46:48.000000', 'temperatura', 2.0000, 'ºC'),
	(231666, 121, '2014-03-01 00:46:49.000000', 'temperatura', 423.0000, 'ºC'),
	(231667, 121, '2014-03-01 00:46:50.000000', 'temperatura', 911.0000, 'ºC'),
	(231668, 121, '2014-03-01 00:46:51.000000', 'temperatura', 885.0000, 'ºC'),
	(231669, 121, '2014-03-01 00:46:52.000000', 'temperatura', 493.0000, 'ºC'),
	(231670, 121, '2014-03-01 00:46:53.000000', 'temperatura', 1011.0000, 'ºC'),
	(231671, 121, '2014-03-01 00:46:54.000000', 'temperatura', 1177.0000, 'ºC'),
	(231672, 121, '2014-03-01 00:46:55.000000', 'temperatura', 454.0000, 'ºC'),
	(231673, 121, '2014-03-01 00:46:56.000000', 'temperatura', 1137.0000, 'ºC'),
	(231674, 121, '2014-03-01 00:46:57.000000', 'temperatura', 726.0000, 'ºC'),
	(231675, 121, '2014-03-01 00:46:58.000000', 'temperatura', 218.0000, 'ºC'),
	(231676, 121, '2014-03-01 00:46:59.000000', 'temperatura', 113.0000, 'ºC'),
	(231677, 121, '2014-03-01 00:47:00.000000', 'temperatura', 1112.0000, 'ºC'),
	(231678, 121, '2014-03-01 00:47:01.000000', 'temperatura', 421.0000, 'ºC'),
	(231679, 121, '2014-03-01 00:47:02.000000', 'temperatura', 1169.0000, 'ºC'),
	(231680, 121, '2014-03-01 00:47:03.000000', 'temperatura', 983.0000, 'ºC'),
	(231681, 121, '2014-03-01 00:47:04.000000', 'temperatura', 207.0000, 'ºC'),
	(231682, 121, '2014-03-01 00:47:05.000000', 'temperatura', 489.0000, 'ºC'),
	(231683, 121, '2014-03-01 00:47:06.000000', 'temperatura', 624.0000, 'ºC'),
	(231684, 121, '2014-03-01 00:47:07.000000', 'temperatura', 454.0000, 'ºC'),
	(231685, 121, '2014-03-01 00:47:08.000000', 'temperatura', 399.0000, 'ºC'),
	(231686, 121, '2014-03-01 00:47:09.000000', 'temperatura', 634.0000, 'ºC'),
	(231687, 121, '2014-03-01 00:47:10.000000', 'temperatura', 774.0000, 'ºC'),
	(231688, 121, '2014-03-01 00:47:11.000000', 'temperatura', 768.0000, 'ºC'),
	(231689, 121, '2014-03-01 00:47:12.000000', 'temperatura', 319.0000, 'ºC'),
	(231690, 121, '2014-03-01 00:47:13.000000', 'temperatura', 492.0000, 'ºC'),
	(231691, 121, '2014-03-01 00:47:14.000000', 'temperatura', 302.0000, 'ºC'),
	(231692, 121, '2014-03-01 00:47:15.000000', 'temperatura', 33.0000, 'ºC'),
	(231693, 121, '2014-03-01 00:47:16.000000', 'temperatura', 463.0000, 'ºC'),
	(231694, 121, '2014-03-01 00:47:17.000000', 'temperatura', 1014.0000, 'ºC'),
	(231695, 121, '2014-03-01 00:47:18.000000', 'temperatura', 83.0000, 'ºC'),
	(231696, 121, '2014-03-01 00:47:19.000000', 'temperatura', 971.0000, 'ºC'),
	(231697, 121, '2014-03-01 00:47:20.000000', 'temperatura', 1010.0000, 'ºC'),
	(231698, 121, '2014-03-01 00:47:21.000000', 'temperatura', 934.0000, 'ºC'),
	(231699, 121, '2014-03-01 00:47:22.000000', 'temperatura', 443.0000, 'ºC'),
	(231700, 121, '2014-03-01 00:47:23.000000', 'temperatura', 612.0000, 'ºC'),
	(231701, 121, '2014-03-01 00:47:24.000000', 'temperatura', 533.0000, 'ºC'),
	(231702, 121, '2014-03-01 00:47:25.000000', 'temperatura', 831.0000, 'ºC'),
	(231703, 121, '2014-03-01 00:47:26.000000', 'temperatura', 155.0000, 'ºC'),
	(231704, 121, '2014-03-01 00:47:27.000000', 'temperatura', 681.0000, 'ºC'),
	(231705, 121, '2014-03-01 00:47:28.000000', 'temperatura', 541.0000, 'ºC'),
	(231706, 121, '2014-03-01 00:47:29.000000', 'temperatura', 665.0000, 'ºC'),
	(231707, 121, '2014-03-01 00:47:30.000000', 'temperatura', 501.0000, 'ºC'),
	(231708, 121, '2014-03-01 00:47:31.000000', 'temperatura', 511.0000, 'ºC'),
	(231709, 121, '2014-03-01 00:47:32.000000', 'temperatura', 1051.0000, 'ºC'),
	(231710, 121, '2014-03-01 00:47:33.000000', 'temperatura', 121.0000, 'ºC'),
	(231711, 121, '2014-03-01 00:47:34.000000', 'temperatura', 1056.0000, 'ºC'),
	(231712, 121, '2014-03-01 00:47:35.000000', 'temperatura', 115.0000, 'ºC'),
	(231713, 121, '2014-03-01 00:47:36.000000', 'temperatura', 1008.0000, 'ºC'),
	(231714, 121, '2014-03-01 00:47:37.000000', 'temperatura', 1095.0000, 'ºC'),
	(231715, 121, '2014-03-01 00:47:38.000000', 'temperatura', 52.0000, 'ºC'),
	(231716, 121, '2014-03-01 00:47:39.000000', 'temperatura', 575.0000, 'ºC'),
	(231717, 121, '2014-03-01 00:47:40.000000', 'temperatura', 322.0000, 'ºC'),
	(231718, 121, '2014-03-01 00:47:41.000000', 'temperatura', 1083.0000, 'ºC'),
	(231719, 121, '2014-03-01 00:47:42.000000', 'temperatura', 849.0000, 'ºC'),
	(231720, 121, '2014-03-01 00:47:43.000000', 'temperatura', 999.0000, 'ºC'),
	(231721, 121, '2014-03-01 00:47:44.000000', 'temperatura', 49.0000, 'ºC'),
	(231722, 121, '2014-03-01 00:47:45.000000', 'temperatura', 847.0000, 'ºC'),
	(231723, 121, '2014-03-01 00:47:46.000000', 'temperatura', 491.0000, 'ºC'),
	(231724, 121, '2014-03-01 00:47:47.000000', 'temperatura', 1112.0000, 'ºC'),
	(231725, 121, '2014-03-01 00:47:48.000000', 'temperatura', 489.0000, 'ºC'),
	(231726, 121, '2014-03-01 00:47:49.000000', 'temperatura', 309.0000, 'ºC'),
	(231727, 121, '2014-03-01 00:47:50.000000', 'temperatura', 78.0000, 'ºC'),
	(231728, 121, '2014-03-01 00:47:51.000000', 'temperatura', 662.0000, 'ºC'),
	(231729, 121, '2014-03-01 00:47:52.000000', 'temperatura', 679.0000, 'ºC'),
	(231730, 121, '2014-03-01 00:47:53.000000', 'temperatura', 207.0000, 'ºC'),
	(231731, 121, '2014-03-01 00:47:54.000000', 'temperatura', 199.0000, 'ºC'),
	(231732, 121, '2014-03-01 00:47:55.000000', 'temperatura', 373.0000, 'ºC'),
	(231733, 121, '2014-03-01 00:47:56.000000', 'temperatura', 72.0000, 'ºC'),
	(231734, 121, '2014-03-01 00:47:57.000000', 'temperatura', 438.0000, 'ºC'),
	(231735, 121, '2014-03-01 00:47:58.000000', 'temperatura', 777.0000, 'ºC'),
	(231736, 121, '2014-03-01 00:47:59.000000', 'temperatura', 169.0000, 'ºC'),
	(231737, 121, '2014-03-01 00:48:00.000000', 'temperatura', 915.0000, 'ºC'),
	(231738, 121, '2014-03-01 00:48:01.000000', 'temperatura', 470.0000, 'ºC'),
	(231739, 121, '2014-03-01 00:48:02.000000', 'temperatura', 805.0000, 'ºC'),
	(231740, 121, '2014-03-01 00:48:03.000000', 'temperatura', 216.0000, 'ºC'),
	(231741, 121, '2014-03-01 00:48:04.000000', 'temperatura', 1066.0000, 'ºC'),
	(231742, 121, '2014-03-01 00:48:05.000000', 'temperatura', 1082.0000, 'ºC'),
	(231743, 121, '2014-03-01 00:48:06.000000', 'temperatura', 1012.0000, 'ºC'),
	(231744, 121, '2014-03-01 00:48:07.000000', 'temperatura', 617.0000, 'ºC'),
	(231745, 121, '2014-03-01 00:48:08.000000', 'temperatura', 46.0000, 'ºC'),
	(231746, 121, '2014-03-01 00:48:09.000000', 'temperatura', 781.0000, 'ºC'),
	(231747, 121, '2014-03-01 00:48:10.000000', 'temperatura', 166.0000, 'ºC'),
	(231748, 121, '2014-03-01 00:48:11.000000', 'temperatura', 888.0000, 'ºC'),
	(231749, 121, '2014-03-01 00:48:12.000000', 'temperatura', 343.0000, 'ºC'),
	(231750, 121, '2014-03-01 00:48:13.000000', 'temperatura', 252.0000, 'ºC'),
	(231751, 121, '2014-03-01 00:48:14.000000', 'temperatura', 231.0000, 'ºC'),
	(231752, 121, '2014-03-01 00:48:15.000000', 'temperatura', 398.0000, 'ºC'),
	(231753, 121, '2014-03-01 00:48:16.000000', 'temperatura', 98.0000, 'ºC'),
	(231754, 121, '2014-03-01 00:48:17.000000', 'temperatura', 499.0000, 'ºC'),
	(231755, 121, '2014-03-01 00:48:18.000000', 'temperatura', 1000.0000, 'ºC'),
	(231756, 121, '2014-03-01 00:48:19.000000', 'temperatura', 1102.0000, 'ºC'),
	(231757, 121, '2014-03-01 00:48:20.000000', 'temperatura', 111.0000, 'ºC'),
	(231758, 121, '2014-03-01 00:48:21.000000', 'temperatura', 848.0000, 'ºC'),
	(231759, 121, '2014-03-01 00:48:22.000000', 'temperatura', 309.0000, 'ºC'),
	(231760, 121, '2014-03-01 00:48:23.000000', 'temperatura', 201.0000, 'ºC'),
	(231761, 121, '2014-03-01 00:48:24.000000', 'temperatura', 79.0000, 'ºC'),
	(231762, 121, '2014-03-01 00:48:25.000000', 'temperatura', 992.0000, 'ºC'),
	(231763, 121, '2014-03-01 00:48:26.000000', 'temperatura', 1125.0000, 'ºC'),
	(231764, 121, '2014-03-01 00:48:27.000000', 'temperatura', 247.0000, 'ºC'),
	(231765, 121, '2014-03-01 00:48:28.000000', 'temperatura', 264.0000, 'ºC'),
	(231766, 121, '2014-03-01 00:48:29.000000', 'temperatura', 576.0000, 'ºC'),
	(231767, 121, '2014-03-01 00:48:30.000000', 'temperatura', 889.0000, 'ºC'),
	(231768, 121, '2014-03-01 00:48:31.000000', 'temperatura', 318.0000, 'ºC'),
	(231769, 121, '2014-03-01 00:48:32.000000', 'temperatura', 124.0000, 'ºC'),
	(231770, 121, '2014-03-01 00:48:33.000000', 'temperatura', 865.0000, 'ºC'),
	(231771, 121, '2014-03-01 00:48:34.000000', 'temperatura', 356.0000, 'ºC'),
	(231772, 121, '2014-03-01 00:48:35.000000', 'temperatura', 384.0000, 'ºC'),
	(231773, 121, '2014-03-01 00:48:36.000000', 'temperatura', 852.0000, 'ºC'),
	(231774, 121, '2014-03-01 00:48:37.000000', 'temperatura', 710.0000, 'ºC'),
	(231775, 121, '2014-03-01 00:48:38.000000', 'temperatura', 995.0000, 'ºC'),
	(231776, 121, '2014-03-01 00:48:39.000000', 'temperatura', 443.0000, 'ºC'),
	(231777, 121, '2014-03-01 00:48:40.000000', 'temperatura', 431.0000, 'ºC'),
	(231778, 121, '2014-03-01 00:48:41.000000', 'temperatura', 828.0000, 'ºC'),
	(231779, 121, '2014-03-01 00:48:42.000000', 'temperatura', 445.0000, 'ºC'),
	(231780, 121, '2014-03-01 00:48:43.000000', 'temperatura', 944.0000, 'ºC'),
	(231781, 121, '2014-03-01 00:48:44.000000', 'temperatura', 984.0000, 'ºC'),
	(231782, 121, '2014-03-01 00:48:45.000000', 'temperatura', 889.0000, 'ºC'),
	(231783, 121, '2014-03-01 00:48:46.000000', 'temperatura', 292.0000, 'ºC'),
	(231784, 121, '2014-03-01 00:48:47.000000', 'temperatura', 1194.0000, 'ºC'),
	(231785, 121, '2014-03-01 00:48:48.000000', 'temperatura', 297.0000, 'ºC'),
	(231786, 121, '2014-03-01 00:48:49.000000', 'temperatura', 301.0000, 'ºC'),
	(231787, 121, '2014-03-01 00:48:50.000000', 'temperatura', 616.0000, 'ºC'),
	(231788, 121, '2014-03-01 00:48:51.000000', 'temperatura', 977.0000, 'ºC'),
	(231789, 121, '2014-03-01 00:48:52.000000', 'temperatura', 640.0000, 'ºC'),
	(231790, 121, '2014-03-01 00:48:53.000000', 'temperatura', 266.0000, 'ºC'),
	(231791, 121, '2014-03-01 00:48:54.000000', 'temperatura', 611.0000, 'ºC'),
	(231792, 121, '2014-03-01 00:48:55.000000', 'temperatura', 1056.0000, 'ºC'),
	(231793, 121, '2014-03-01 00:48:56.000000', 'temperatura', 1049.0000, 'ºC'),
	(231794, 121, '2014-03-01 00:48:57.000000', 'temperatura', 880.0000, 'ºC'),
	(231795, 121, '2014-03-01 00:48:58.000000', 'temperatura', 50.0000, 'ºC'),
	(231796, 121, '2014-03-01 00:48:59.000000', 'temperatura', 10.0000, 'ºC'),
	(231797, 121, '2014-03-01 00:49:00.000000', 'temperatura', 1101.0000, 'ºC'),
	(231798, 121, '2014-03-01 00:49:01.000000', 'temperatura', 676.0000, 'ºC'),
	(231799, 121, '2014-03-01 00:49:02.000000', 'temperatura', 79.0000, 'ºC'),
	(231800, 121, '2014-03-01 00:49:03.000000', 'temperatura', 767.0000, 'ºC'),
	(231801, 121, '2014-03-01 00:49:04.000000', 'temperatura', 1197.0000, 'ºC'),
	(231802, 121, '2014-03-01 00:49:05.000000', 'temperatura', 86.0000, 'ºC'),
	(231803, 121, '2014-03-01 00:49:06.000000', 'temperatura', 438.0000, 'ºC'),
	(231804, 121, '2014-03-01 00:49:07.000000', 'temperatura', 734.0000, 'ºC'),
	(231805, 121, '2014-03-01 00:49:08.000000', 'temperatura', 1157.0000, 'ºC'),
	(231806, 121, '2014-03-01 00:49:09.000000', 'temperatura', 1183.0000, 'ºC'),
	(231807, 121, '2014-03-01 00:49:10.000000', 'temperatura', 46.0000, 'ºC'),
	(231808, 121, '2014-03-01 00:49:11.000000', 'temperatura', 281.0000, 'ºC'),
	(231809, 121, '2014-03-01 00:49:12.000000', 'temperatura', 65.0000, 'ºC'),
	(231810, 121, '2014-03-01 00:49:13.000000', 'temperatura', 685.0000, 'ºC'),
	(231811, 121, '2014-03-01 00:49:14.000000', 'temperatura', 828.0000, 'ºC'),
	(231812, 121, '2014-03-01 00:49:15.000000', 'temperatura', 886.0000, 'ºC'),
	(231813, 121, '2014-03-01 00:49:16.000000', 'temperatura', 746.0000, 'ºC'),
	(231814, 121, '2014-03-01 00:49:17.000000', 'temperatura', 1072.0000, 'ºC'),
	(231815, 121, '2014-03-01 00:49:18.000000', 'temperatura', 725.0000, 'ºC'),
	(231816, 121, '2014-03-01 00:49:19.000000', 'temperatura', 408.0000, 'ºC'),
	(231817, 121, '2014-03-01 00:49:20.000000', 'temperatura', 1064.0000, 'ºC'),
	(231818, 121, '2014-03-01 00:49:21.000000', 'temperatura', 496.0000, 'ºC'),
	(231819, 121, '2014-03-01 00:49:22.000000', 'temperatura', 491.0000, 'ºC'),
	(231820, 121, '2014-03-01 00:49:23.000000', 'temperatura', 965.0000, 'ºC'),
	(231821, 121, '2014-03-01 00:49:24.000000', 'temperatura', 955.0000, 'ºC'),
	(231822, 121, '2014-03-01 00:49:25.000000', 'temperatura', 679.0000, 'ºC'),
	(231823, 121, '2014-03-01 00:49:26.000000', 'temperatura', 531.0000, 'ºC'),
	(231824, 121, '2014-03-01 00:49:27.000000', 'temperatura', 618.0000, 'ºC'),
	(231825, 121, '2014-03-01 00:49:28.000000', 'temperatura', 299.0000, 'ºC'),
	(231826, 121, '2014-03-01 00:49:29.000000', 'temperatura', 841.0000, 'ºC'),
	(231827, 121, '2014-03-01 00:49:30.000000', 'temperatura', 910.0000, 'ºC'),
	(231828, 121, '2014-03-01 00:49:31.000000', 'temperatura', 826.0000, 'ºC'),
	(231829, 121, '2014-03-01 00:49:32.000000', 'temperatura', 201.0000, 'ºC'),
	(231830, 121, '2014-03-01 00:49:33.000000', 'temperatura', 929.0000, 'ºC'),
	(231831, 121, '2014-03-01 00:49:34.000000', 'temperatura', 442.0000, 'ºC'),
	(231832, 121, '2014-03-01 00:49:35.000000', 'temperatura', 621.0000, 'ºC'),
	(231833, 121, '2014-03-01 00:49:36.000000', 'temperatura', 583.0000, 'ºC'),
	(231834, 121, '2014-03-01 00:49:37.000000', 'temperatura', 1051.0000, 'ºC'),
	(231835, 121, '2014-03-01 00:49:38.000000', 'temperatura', 1105.0000, 'ºC'),
	(231836, 121, '2014-03-01 00:49:39.000000', 'temperatura', 1173.0000, 'ºC'),
	(231837, 121, '2014-03-01 00:49:40.000000', 'temperatura', 152.0000, 'ºC'),
	(231838, 121, '2014-03-01 00:49:41.000000', 'temperatura', 843.0000, 'ºC'),
	(231839, 121, '2014-03-01 00:49:42.000000', 'temperatura', 156.0000, 'ºC'),
	(231840, 121, '2014-03-01 00:49:43.000000', 'temperatura', 654.0000, 'ºC'),
	(231841, 121, '2014-03-01 00:49:44.000000', 'temperatura', 401.0000, 'ºC'),
	(231842, 121, '2014-03-01 00:49:45.000000', 'temperatura', 46.0000, 'ºC'),
	(231843, 121, '2014-03-01 00:49:46.000000', 'temperatura', 225.0000, 'ºC'),
	(231844, 121, '2014-03-01 00:49:47.000000', 'temperatura', 989.0000, 'ºC'),
	(231845, 121, '2014-03-01 00:49:48.000000', 'temperatura', 672.0000, 'ºC'),
	(231846, 121, '2014-03-01 00:49:49.000000', 'temperatura', 391.0000, 'ºC'),
	(231847, 121, '2014-03-01 00:49:50.000000', 'temperatura', 1142.0000, 'ºC'),
	(231848, 121, '2014-03-01 00:49:51.000000', 'temperatura', 937.0000, 'ºC'),
	(231849, 121, '2014-03-01 00:49:52.000000', 'temperatura', 59.0000, 'ºC'),
	(231850, 121, '2014-03-01 00:49:53.000000', 'temperatura', 1084.0000, 'ºC'),
	(231851, 121, '2014-03-01 00:49:54.000000', 'temperatura', 445.0000, 'ºC'),
	(231852, 121, '2014-03-01 00:49:55.000000', 'temperatura', 172.0000, 'ºC'),
	(231853, 121, '2014-03-01 00:49:56.000000', 'temperatura', 724.0000, 'ºC'),
	(231854, 121, '2014-03-01 00:49:57.000000', 'temperatura', 706.0000, 'ºC'),
	(231855, 121, '2014-03-01 00:49:58.000000', 'temperatura', 159.0000, 'ºC'),
	(231856, 121, '2014-03-01 00:49:59.000000', 'temperatura', 1078.0000, 'ºC'),
	(231857, 121, '2014-03-01 00:50:00.000000', 'temperatura', 114.0000, 'ºC'),
	(231858, 121, '2014-03-01 00:50:01.000000', 'temperatura', 935.0000, 'ºC'),
	(231859, 121, '2014-03-01 00:50:02.000000', 'temperatura', 734.0000, 'ºC'),
	(231860, 121, '2014-03-01 00:50:03.000000', 'temperatura', 866.0000, 'ºC'),
	(231861, 121, '2014-03-01 00:50:04.000000', 'temperatura', 929.0000, 'ºC'),
	(231862, 121, '2014-03-01 00:50:05.000000', 'temperatura', 849.0000, 'ºC'),
	(231863, 121, '2014-03-01 00:50:06.000000', 'temperatura', 256.0000, 'ºC'),
	(231864, 121, '2014-03-01 00:50:07.000000', 'temperatura', 1133.0000, 'ºC'),
	(231865, 121, '2014-03-01 00:50:08.000000', 'temperatura', 98.0000, 'ºC'),
	(231866, 121, '2014-03-01 00:50:09.000000', 'temperatura', 690.0000, 'ºC'),
	(231867, 121, '2014-03-01 00:50:10.000000', 'temperatura', 759.0000, 'ºC'),
	(231868, 121, '2014-03-01 00:50:11.000000', 'temperatura', 524.0000, 'ºC'),
	(231869, 121, '2014-03-01 00:50:12.000000', 'temperatura', 344.0000, 'ºC'),
	(231870, 121, '2014-03-01 00:50:13.000000', 'temperatura', 148.0000, 'ºC'),
	(231871, 121, '2014-03-01 00:50:14.000000', 'temperatura', 907.0000, 'ºC'),
	(231872, 121, '2014-03-01 00:50:15.000000', 'temperatura', 495.0000, 'ºC'),
	(231873, 121, '2014-03-01 00:50:16.000000', 'temperatura', 952.0000, 'ºC'),
	(231874, 121, '2014-03-01 00:50:17.000000', 'temperatura', 877.0000, 'ºC'),
	(231875, 121, '2014-03-01 00:50:18.000000', 'temperatura', 330.0000, 'ºC'),
	(231876, 121, '2014-03-01 00:50:19.000000', 'temperatura', 218.0000, 'ºC'),
	(231877, 121, '2014-03-01 00:50:20.000000', 'temperatura', 101.0000, 'ºC'),
	(231878, 121, '2014-03-01 00:50:21.000000', 'temperatura', 1053.0000, 'ºC'),
	(231879, 121, '2014-03-01 00:50:22.000000', 'temperatura', 160.0000, 'ºC'),
	(231880, 121, '2014-03-01 00:50:23.000000', 'temperatura', 44.0000, 'ºC'),
	(231881, 121, '2014-03-01 00:50:24.000000', 'temperatura', 941.0000, 'ºC'),
	(231882, 121, '2014-03-01 00:50:25.000000', 'temperatura', 972.0000, 'ºC'),
	(231883, 121, '2014-03-01 00:50:26.000000', 'temperatura', 839.0000, 'ºC'),
	(231884, 121, '2014-03-01 00:50:27.000000', 'temperatura', 79.0000, 'ºC'),
	(231885, 121, '2014-03-01 00:50:28.000000', 'temperatura', 278.0000, 'ºC'),
	(231886, 121, '2014-03-01 00:50:29.000000', 'temperatura', 1153.0000, 'ºC'),
	(231887, 121, '2014-03-01 00:50:30.000000', 'temperatura', 134.0000, 'ºC'),
	(231888, 121, '2014-03-01 00:50:31.000000', 'temperatura', 809.0000, 'ºC'),
	(231889, 121, '2014-03-01 00:50:32.000000', 'temperatura', 42.0000, 'ºC'),
	(231890, 121, '2014-03-01 00:50:33.000000', 'temperatura', 187.0000, 'ºC'),
	(231891, 121, '2014-03-01 00:50:34.000000', 'temperatura', 808.0000, 'ºC'),
	(231892, 121, '2014-03-01 00:50:35.000000', 'temperatura', 1080.0000, 'ºC'),
	(231893, 121, '2014-03-01 00:50:36.000000', 'temperatura', 575.0000, 'ºC'),
	(231894, 121, '2014-03-01 00:50:37.000000', 'temperatura', 838.0000, 'ºC'),
	(231895, 121, '2014-03-01 00:50:38.000000', 'temperatura', 65.0000, 'ºC'),
	(231896, 121, '2014-03-01 00:50:39.000000', 'temperatura', 213.0000, 'ºC'),
	(231897, 121, '2014-03-01 00:50:40.000000', 'temperatura', 869.0000, 'ºC'),
	(231898, 121, '2014-03-01 00:50:41.000000', 'temperatura', 106.0000, 'ºC'),
	(231899, 121, '2014-03-01 00:50:42.000000', 'temperatura', 323.0000, 'ºC'),
	(231900, 121, '2014-03-01 00:50:43.000000', 'temperatura', 99.0000, 'ºC'),
	(231901, 121, '2014-03-01 00:50:44.000000', 'temperatura', 724.0000, 'ºC'),
	(231902, 121, '2014-03-01 00:50:45.000000', 'temperatura', 925.0000, 'ºC'),
	(231903, 121, '2014-03-01 00:50:46.000000', 'temperatura', 52.0000, 'ºC'),
	(231904, 121, '2014-03-01 00:50:47.000000', 'temperatura', 1085.0000, 'ºC'),
	(231905, 121, '2014-03-01 00:50:48.000000', 'temperatura', 471.0000, 'ºC'),
	(231906, 121, '2014-03-01 00:50:49.000000', 'temperatura', 301.0000, 'ºC'),
	(231907, 121, '2014-03-01 00:50:50.000000', 'temperatura', 90.0000, 'ºC'),
	(231908, 121, '2014-03-01 00:50:51.000000', 'temperatura', 749.0000, 'ºC'),
	(231909, 121, '2014-03-01 00:50:52.000000', 'temperatura', 1075.0000, 'ºC'),
	(231910, 121, '2014-03-01 00:50:53.000000', 'temperatura', 728.0000, 'ºC'),
	(231911, 121, '2014-03-01 00:50:54.000000', 'temperatura', 414.0000, 'ºC'),
	(231912, 121, '2014-03-01 00:50:55.000000', 'temperatura', 1089.0000, 'ºC'),
	(231913, 121, '2014-03-01 00:50:56.000000', 'temperatura', 602.0000, 'ºC'),
	(231914, 121, '2014-03-01 00:50:57.000000', 'temperatura', 944.0000, 'ºC'),
	(231915, 121, '2014-03-01 00:50:58.000000', 'temperatura', 513.0000, 'ºC'),
	(231916, 121, '2014-03-01 00:50:59.000000', 'temperatura', 936.0000, 'ºC'),
	(231917, 121, '2014-03-01 00:51:00.000000', 'temperatura', 739.0000, 'ºC'),
	(231918, 121, '2014-03-01 00:51:01.000000', 'temperatura', 887.0000, 'ºC'),
	(231919, 121, '2014-03-01 00:51:02.000000', 'temperatura', 1022.0000, 'ºC'),
	(231920, 121, '2014-03-01 00:51:03.000000', 'temperatura', 46.0000, 'ºC'),
	(231921, 121, '2014-03-01 00:51:04.000000', 'temperatura', 766.0000, 'ºC'),
	(231922, 121, '2014-03-01 00:51:05.000000', 'temperatura', 92.0000, 'ºC'),
	(231923, 121, '2014-03-01 00:51:06.000000', 'temperatura', 565.0000, 'ºC'),
	(231924, 121, '2014-03-01 00:51:07.000000', 'temperatura', 146.0000, 'ºC'),
	(231925, 121, '2014-03-01 00:51:08.000000', 'temperatura', 237.0000, 'ºC'),
	(231926, 121, '2014-03-01 00:51:09.000000', 'temperatura', 749.0000, 'ºC'),
	(231927, 121, '2014-03-01 00:51:10.000000', 'temperatura', 633.0000, 'ºC'),
	(231928, 121, '2014-03-01 00:51:11.000000', 'temperatura', 919.0000, 'ºC'),
	(231929, 121, '2014-03-01 00:51:12.000000', 'temperatura', 296.0000, 'ºC'),
	(231930, 121, '2014-03-01 00:51:13.000000', 'temperatura', 1123.0000, 'ºC'),
	(231931, 121, '2014-03-01 00:51:14.000000', 'temperatura', 1127.0000, 'ºC'),
	(231932, 121, '2014-03-01 00:51:15.000000', 'temperatura', 1068.0000, 'ºC'),
	(231933, 121, '2014-03-01 00:51:16.000000', 'temperatura', 757.0000, 'ºC'),
	(231934, 121, '2014-03-01 00:51:17.000000', 'temperatura', 582.0000, 'ºC'),
	(231935, 121, '2014-03-01 00:51:18.000000', 'temperatura', 642.0000, 'ºC'),
	(231936, 121, '2014-03-01 00:51:19.000000', 'temperatura', 263.0000, 'ºC'),
	(231937, 121, '2014-03-01 00:51:20.000000', 'temperatura', 588.0000, 'ºC'),
	(231938, 121, '2014-03-01 00:51:21.000000', 'temperatura', 953.0000, 'ºC'),
	(231939, 121, '2014-03-01 00:51:22.000000', 'temperatura', 601.0000, 'ºC'),
	(231940, 121, '2014-03-01 00:51:23.000000', 'temperatura', 148.0000, 'ºC'),
	(231941, 121, '2014-03-01 00:51:24.000000', 'temperatura', 136.0000, 'ºC'),
	(231942, 121, '2014-03-01 00:51:25.000000', 'temperatura', 239.0000, 'ºC'),
	(231943, 121, '2014-03-01 00:51:26.000000', 'temperatura', 785.0000, 'ºC'),
	(231944, 121, '2014-03-01 00:51:27.000000', 'temperatura', 811.0000, 'ºC'),
	(231945, 121, '2014-03-01 00:51:28.000000', 'temperatura', 501.0000, 'ºC'),
	(231946, 121, '2014-03-01 00:51:29.000000', 'temperatura', 71.0000, 'ºC'),
	(231947, 121, '2014-03-01 00:51:30.000000', 'temperatura', 51.0000, 'ºC'),
	(231948, 121, '2014-03-01 00:51:31.000000', 'temperatura', 42.0000, 'ºC'),
	(231949, 121, '2014-03-01 00:51:32.000000', 'temperatura', 60.0000, 'ºC'),
	(231950, 121, '2014-03-01 00:51:33.000000', 'temperatura', 175.0000, 'ºC'),
	(231951, 121, '2014-03-01 00:51:34.000000', 'temperatura', 695.0000, 'ºC'),
	(231952, 121, '2014-03-01 00:51:35.000000', 'temperatura', 550.0000, 'ºC'),
	(231953, 121, '2014-03-01 00:51:36.000000', 'temperatura', 666.0000, 'ºC'),
	(231954, 121, '2014-03-01 00:51:37.000000', 'temperatura', 479.0000, 'ºC'),
	(231955, 121, '2014-03-01 00:51:38.000000', 'temperatura', 398.0000, 'ºC'),
	(231956, 121, '2014-03-01 00:51:39.000000', 'temperatura', 554.0000, 'ºC'),
	(231957, 121, '2014-03-01 00:51:40.000000', 'temperatura', 377.0000, 'ºC'),
	(231958, 121, '2014-03-01 00:51:41.000000', 'temperatura', 222.0000, 'ºC'),
	(231959, 121, '2014-03-01 00:51:42.000000', 'temperatura', 1181.0000, 'ºC'),
	(231960, 121, '2014-03-01 00:51:43.000000', 'temperatura', 440.0000, 'ºC'),
	(231961, 121, '2014-03-01 00:51:44.000000', 'temperatura', 1056.0000, 'ºC'),
	(231962, 121, '2014-03-01 00:51:45.000000', 'temperatura', 360.0000, 'ºC'),
	(231963, 121, '2014-03-01 00:51:46.000000', 'temperatura', 1035.0000, 'ºC'),
	(231964, 121, '2014-03-01 00:51:47.000000', 'temperatura', 496.0000, 'ºC'),
	(231965, 121, '2014-03-01 00:51:48.000000', 'temperatura', 573.0000, 'ºC'),
	(231966, 121, '2014-03-01 00:51:49.000000', 'temperatura', 179.0000, 'ºC'),
	(231967, 121, '2014-03-01 00:51:50.000000', 'temperatura', 374.0000, 'ºC'),
	(231968, 121, '2014-03-01 00:51:51.000000', 'temperatura', 137.0000, 'ºC'),
	(231969, 121, '2014-03-01 00:51:52.000000', 'temperatura', 761.0000, 'ºC'),
	(231970, 121, '2014-03-01 00:51:53.000000', 'temperatura', 997.0000, 'ºC'),
	(231971, 121, '2014-03-01 00:51:54.000000', 'temperatura', 300.0000, 'ºC'),
	(231972, 121, '2014-03-01 00:51:55.000000', 'temperatura', 909.0000, 'ºC'),
	(231973, 121, '2014-03-01 00:51:56.000000', 'temperatura', 47.0000, 'ºC'),
	(231974, 121, '2014-03-01 00:51:57.000000', 'temperatura', 1109.0000, 'ºC'),
	(231975, 121, '2014-03-01 00:51:58.000000', 'temperatura', 603.0000, 'ºC'),
	(231976, 121, '2014-03-01 00:51:59.000000', 'temperatura', 889.0000, 'ºC'),
	(231977, 121, '2014-03-01 00:52:00.000000', 'temperatura', 236.0000, 'ºC'),
	(231978, 121, '2014-03-01 00:52:01.000000', 'temperatura', 913.0000, 'ºC'),
	(231979, 121, '2014-03-01 00:52:02.000000', 'temperatura', 258.0000, 'ºC'),
	(231980, 121, '2014-03-01 00:52:03.000000', 'temperatura', 953.0000, 'ºC'),
	(231981, 121, '2014-03-01 00:52:04.000000', 'temperatura', 392.0000, 'ºC'),
	(231982, 121, '2014-03-01 00:52:05.000000', 'temperatura', 298.0000, 'ºC'),
	(231983, 121, '2014-03-01 00:52:06.000000', 'temperatura', 318.0000, 'ºC'),
	(231984, 121, '2014-03-01 00:52:07.000000', 'temperatura', 695.0000, 'ºC'),
	(231985, 121, '2014-03-01 00:52:08.000000', 'temperatura', 123.0000, 'ºC'),
	(231986, 121, '2014-03-01 00:52:09.000000', 'temperatura', 928.0000, 'ºC'),
	(231987, 121, '2014-03-01 00:52:10.000000', 'temperatura', 673.0000, 'ºC'),
	(231988, 121, '2014-03-01 00:52:11.000000', 'temperatura', 580.0000, 'ºC'),
	(231989, 121, '2014-03-01 00:52:12.000000', 'temperatura', 882.0000, 'ºC'),
	(231990, 121, '2014-03-01 00:52:13.000000', 'temperatura', 270.0000, 'ºC'),
	(231991, 121, '2014-03-01 00:52:14.000000', 'temperatura', 1107.0000, 'ºC'),
	(231992, 121, '2014-03-01 00:52:15.000000', 'temperatura', 1124.0000, 'ºC'),
	(231993, 121, '2014-03-01 00:52:16.000000', 'temperatura', 1100.0000, 'ºC'),
	(231994, 121, '2014-03-01 00:52:17.000000', 'temperatura', 929.0000, 'ºC'),
	(231995, 121, '2014-03-01 00:52:18.000000', 'temperatura', 147.0000, 'ºC'),
	(231996, 121, '2014-03-01 00:52:19.000000', 'temperatura', 345.0000, 'ºC'),
	(231997, 121, '2014-03-01 00:52:20.000000', 'temperatura', 87.0000, 'ºC'),
	(231998, 121, '2014-03-01 00:52:21.000000', 'temperatura', 598.0000, 'ºC'),
	(231999, 121, '2014-03-01 00:52:22.000000', 'temperatura', 332.0000, 'ºC'),
	(232000, 121, '2014-03-01 00:52:23.000000', 'temperatura', 1067.0000, 'ºC'),
	(232001, 121, '2014-03-01 00:52:24.000000', 'temperatura', 739.0000, 'ºC'),
	(232002, 121, '2014-03-01 00:52:25.000000', 'temperatura', 494.0000, 'ºC'),
	(232003, 121, '2014-03-01 00:52:26.000000', 'temperatura', 252.0000, 'ºC'),
	(232004, 121, '2014-03-01 00:52:27.000000', 'temperatura', 979.0000, 'ºC'),
	(232005, 121, '2014-03-01 00:52:28.000000', 'temperatura', 538.0000, 'ºC'),
	(232006, 121, '2014-03-01 00:52:29.000000', 'temperatura', 954.0000, 'ºC'),
	(232007, 121, '2014-03-01 00:52:30.000000', 'temperatura', 757.0000, 'ºC'),
	(232008, 121, '2014-03-01 00:52:31.000000', 'temperatura', 926.0000, 'ºC'),
	(232009, 121, '2014-03-01 00:52:32.000000', 'temperatura', 1157.0000, 'ºC'),
	(232010, 121, '2014-03-01 00:52:33.000000', 'temperatura', 606.0000, 'ºC'),
	(232011, 121, '2014-03-01 00:52:34.000000', 'temperatura', 762.0000, 'ºC'),
	(232012, 121, '2014-03-01 00:52:35.000000', 'temperatura', 792.0000, 'ºC'),
	(232013, 121, '2014-03-01 00:52:36.000000', 'temperatura', 473.0000, 'ºC'),
	(232014, 121, '2014-03-01 00:52:37.000000', 'temperatura', 1192.0000, 'ºC'),
	(232015, 121, '2014-03-01 00:52:38.000000', 'temperatura', 938.0000, 'ºC'),
	(232016, 121, '2014-03-01 00:52:39.000000', 'temperatura', 1118.0000, 'ºC'),
	(232017, 121, '2014-03-01 00:52:40.000000', 'temperatura', 373.0000, 'ºC'),
	(232018, 121, '2014-03-01 00:52:41.000000', 'temperatura', 915.0000, 'ºC'),
	(232019, 121, '2014-03-01 00:52:42.000000', 'temperatura', 1053.0000, 'ºC'),
	(232020, 121, '2014-03-01 00:52:43.000000', 'temperatura', 123.0000, 'ºC'),
	(232021, 121, '2014-03-01 00:52:44.000000', 'temperatura', 1054.0000, 'ºC'),
	(232022, 121, '2014-03-01 00:52:45.000000', 'temperatura', 104.0000, 'ºC'),
	(232023, 121, '2014-03-01 00:52:46.000000', 'temperatura', 958.0000, 'ºC'),
	(232024, 121, '2014-03-01 00:52:47.000000', 'temperatura', 880.0000, 'ºC'),
	(232025, 121, '2014-03-01 00:52:48.000000', 'temperatura', 327.0000, 'ºC'),
	(232026, 121, '2014-03-01 00:52:49.000000', 'temperatura', 193.0000, 'ºC'),
	(232027, 121, '2014-03-01 00:52:50.000000', 'temperatura', 1186.0000, 'ºC'),
	(232028, 121, '2014-03-01 00:52:51.000000', 'temperatura', 552.0000, 'ºC'),
	(232029, 121, '2014-03-01 00:52:52.000000', 'temperatura', 401.0000, 'ºC'),
	(232030, 121, '2014-03-01 00:52:53.000000', 'temperatura', 352.0000, 'ºC'),
	(232031, 121, '2014-03-01 00:52:54.000000', 'temperatura', 554.0000, 'ºC'),
	(232032, 121, '2014-03-01 00:52:55.000000', 'temperatura', 518.0000, 'ºC'),
	(232033, 121, '2014-03-01 00:52:56.000000', 'temperatura', 926.0000, 'ºC'),
	(232034, 121, '2014-03-01 00:52:57.000000', 'temperatura', 676.0000, 'ºC'),
	(232035, 121, '2014-03-01 00:52:58.000000', 'temperatura', 603.0000, 'ºC'),
	(232036, 121, '2014-03-01 00:52:59.000000', 'temperatura', 986.0000, 'ºC'),
	(232037, 121, '2014-03-01 00:53:00.000000', 'temperatura', 725.0000, 'ºC'),
	(232038, 121, '2014-03-01 00:53:01.000000', 'temperatura', 665.0000, 'ºC'),
	(232039, 121, '2014-03-01 00:53:02.000000', 'temperatura', 1151.0000, 'ºC'),
	(232040, 121, '2014-03-01 00:53:03.000000', 'temperatura', 160.0000, 'ºC'),
	(232041, 121, '2014-03-01 00:53:04.000000', 'temperatura', 948.0000, 'ºC'),
	(232042, 121, '2014-03-01 00:53:05.000000', 'temperatura', 659.0000, 'ºC'),
	(232043, 121, '2014-03-01 00:53:06.000000', 'temperatura', 453.0000, 'ºC'),
	(232044, 121, '2014-03-01 00:53:07.000000', 'temperatura', 290.0000, 'ºC'),
	(232045, 121, '2014-03-01 00:53:08.000000', 'temperatura', 91.0000, 'ºC'),
	(232046, 121, '2014-03-01 00:53:09.000000', 'temperatura', 783.0000, 'ºC'),
	(232047, 121, '2014-03-01 00:53:10.000000', 'temperatura', 46.0000, 'ºC'),
	(232048, 121, '2014-03-01 00:53:11.000000', 'temperatura', 279.0000, 'ºC'),
	(232049, 121, '2014-03-01 00:53:12.000000', 'temperatura', 59.0000, 'ºC'),
	(232050, 121, '2014-03-01 00:53:13.000000', 'temperatura', 660.0000, 'ºC'),
	(232051, 121, '2014-03-01 00:53:14.000000', 'temperatura', 721.0000, 'ºC'),
	(232052, 121, '2014-03-01 00:53:15.000000', 'temperatura', 427.0000, 'ºC'),
	(232053, 121, '2014-03-01 00:53:16.000000', 'temperatura', 1172.0000, 'ºC'),
	(232054, 121, '2014-03-01 00:53:17.000000', 'temperatura', 980.0000, 'ºC'),
	(232055, 121, '2014-03-01 00:53:18.000000', 'temperatura', 182.0000, 'ºC'),
	(232056, 121, '2014-03-01 00:53:19.000000', 'temperatura', 374.0000, 'ºC'),
	(232057, 121, '2014-03-01 00:53:20.000000', 'temperatura', 121.0000, 'ºC'),
	(232058, 121, '2014-03-01 00:53:21.000000', 'temperatura', 686.0000, 'ºC'),
	(232059, 121, '2014-03-01 00:53:22.000000', 'temperatura', 668.0000, 'ºC'),
	(232060, 121, '2014-03-01 00:53:23.000000', 'temperatura', 81.0000, 'ºC'),
	(232061, 121, '2014-03-01 00:53:24.000000', 'temperatura', 803.0000, 'ºC'),
	(232062, 121, '2014-03-01 00:53:25.000000', 'temperatura', 173.0000, 'ºC'),
	(232063, 121, '2014-03-01 00:53:26.000000', 'temperatura', 855.0000, 'ºC'),
	(232064, 121, '2014-03-01 00:53:27.000000', 'temperatura', 157.0000, 'ºC'),
	(232065, 121, '2014-03-01 00:53:28.000000', 'temperatura', 619.0000, 'ºC'),
	(232066, 121, '2014-03-01 00:53:29.000000', 'temperatura', 226.0000, 'ºC'),
	(232067, 121, '2014-03-01 00:53:30.000000', 'temperatura', 474.0000, 'ºC'),
	(232068, 121, '2014-03-01 00:53:31.000000', 'temperatura', 494.0000, 'ºC'),
	(232069, 121, '2014-03-01 00:53:32.000000', 'temperatura', 1046.0000, 'ºC'),
	(232070, 121, '2014-03-01 00:53:33.000000', 'temperatura', 149.0000, 'ºC'),
	(232071, 121, '2014-03-01 00:53:34.000000', 'temperatura', 6.0000, 'ºC'),
	(232072, 121, '2014-03-01 00:53:35.000000', 'temperatura', 786.0000, 'ºC'),
	(232073, 121, '2014-03-01 00:53:36.000000', 'temperatura', 313.0000, 'ºC'),
	(232074, 121, '2014-03-01 00:53:37.000000', 'temperatura', 405.0000, 'ºC'),
	(232075, 121, '2014-03-01 00:53:38.000000', 'temperatura', 1087.0000, 'ºC'),
	(232076, 121, '2014-03-01 00:53:39.000000', 'temperatura', 622.0000, 'ºC'),
	(232077, 121, '2014-03-01 00:53:40.000000', 'temperatura', 1050.0000, 'ºC'),
	(232078, 121, '2014-03-01 00:53:41.000000', 'temperatura', 984.0000, 'ºC'),
	(232079, 121, '2014-03-01 00:53:42.000000', 'temperatura', 570.0000, 'ºC'),
	(232080, 121, '2014-03-01 00:53:43.000000', 'temperatura', 1099.0000, 'ºC'),
	(232081, 121, '2014-03-01 00:53:44.000000', 'temperatura', 185.0000, 'ºC'),
	(232082, 121, '2014-03-01 00:53:45.000000', 'temperatura', 29.0000, 'ºC'),
	(232083, 121, '2014-03-01 00:53:46.000000', 'temperatura', 789.0000, 'ºC'),
	(232084, 121, '2014-03-01 00:53:47.000000', 'temperatura', 260.0000, 'ºC'),
	(232085, 121, '2014-03-01 00:53:48.000000', 'temperatura', 131.0000, 'ºC'),
	(232086, 121, '2014-03-01 00:53:49.000000', 'temperatura', 1078.0000, 'ºC'),
	(232087, 121, '2014-03-01 00:53:50.000000', 'temperatura', 196.0000, 'ºC'),
	(232088, 121, '2014-03-01 00:53:51.000000', 'temperatura', 145.0000, 'ºC'),
	(232089, 121, '2014-03-01 00:53:52.000000', 'temperatura', 140.0000, 'ºC'),
	(232090, 121, '2014-03-01 00:53:53.000000', 'temperatura', 264.0000, 'ºC'),
	(232091, 121, '2014-03-01 00:53:54.000000', 'temperatura', 901.0000, 'ºC'),
	(232092, 121, '2014-03-01 00:53:55.000000', 'temperatura', 112.0000, 'ºC'),
	(232093, 121, '2014-03-01 00:53:56.000000', 'temperatura', 258.0000, 'ºC'),
	(232094, 121, '2014-03-01 00:53:57.000000', 'temperatura', 955.0000, 'ºC'),
	(232095, 121, '2014-03-01 00:53:58.000000', 'temperatura', 402.0000, 'ºC'),
	(232096, 121, '2014-03-01 00:53:59.000000', 'temperatura', 345.0000, 'ºC'),
	(232097, 121, '2014-03-01 00:54:00.000000', 'temperatura', 518.0000, 'ºC'),
	(232098, 121, '2014-03-01 00:54:01.000000', 'temperatura', 357.0000, 'ºC'),
	(232099, 121, '2014-03-01 00:54:02.000000', 'temperatura', 231.0000, 'ºC'),
	(232100, 121, '2014-03-01 00:54:03.000000', 'temperatura', 86.0000, 'ºC'),
	(232101, 121, '2014-03-01 00:54:04.000000', 'temperatura', 936.0000, 'ºC'),
	(232102, 121, '2014-03-01 00:54:05.000000', 'temperatura', 825.0000, 'ºC'),
	(232103, 121, '2014-03-01 00:54:06.000000', 'temperatura', 115.0000, 'ºC'),
	(232104, 121, '2014-03-01 00:54:07.000000', 'temperatura', 501.0000, 'ºC'),
	(232105, 121, '2014-03-01 00:54:08.000000', 'temperatura', 962.0000, 'ºC'),
	(232106, 121, '2014-03-01 00:54:09.000000', 'temperatura', 907.0000, 'ºC'),
	(232107, 121, '2014-03-01 00:54:10.000000', 'temperatura', 451.0000, 'ºC'),
	(232108, 121, '2014-03-01 00:54:11.000000', 'temperatura', 733.0000, 'ºC'),
	(232109, 121, '2014-03-01 00:54:12.000000', 'temperatura', 1111.0000, 'ºC'),
	(232110, 121, '2014-03-01 00:54:13.000000', 'temperatura', 958.0000, 'ºC'),
	(232111, 121, '2014-03-01 00:54:14.000000', 'temperatura', 256.0000, 'ºC'),
	(232112, 121, '2014-03-01 00:54:15.000000', 'temperatura', 807.0000, 'ºC'),
	(232113, 121, '2014-03-01 00:54:16.000000', 'temperatura', 870.0000, 'ºC'),
	(232114, 121, '2014-03-01 00:54:17.000000', 'temperatura', 726.0000, 'ºC'),
	(232115, 121, '2014-03-01 00:54:18.000000', 'temperatura', 1022.0000, 'ºC'),
	(232116, 121, '2014-03-01 00:54:19.000000', 'temperatura', 533.0000, 'ºC'),
	(232117, 121, '2014-03-01 00:54:20.000000', 'temperatura', 797.0000, 'ºC'),
	(232118, 121, '2014-03-01 00:54:21.000000', 'temperatura', 1190.0000, 'ºC'),
	(232119, 121, '2014-03-01 00:54:22.000000', 'temperatura', 1157.0000, 'ºC'),
	(232120, 121, '2014-03-01 00:54:23.000000', 'temperatura', 1018.0000, 'ºC'),
	(232121, 121, '2014-03-01 00:54:24.000000', 'temperatura', 418.0000, 'ºC'),
	(232122, 121, '2014-03-01 00:54:25.000000', 'temperatura', 237.0000, 'ºC'),
	(232123, 121, '2014-03-01 00:54:26.000000', 'temperatura', 1132.0000, 'ºC'),
	(232124, 121, '2014-03-01 00:54:27.000000', 'temperatura', 147.0000, 'ºC'),
	(232125, 121, '2014-03-01 00:54:28.000000', 'temperatura', 941.0000, 'ºC'),
	(232126, 121, '2014-03-01 00:54:29.000000', 'temperatura', 663.0000, 'ºC'),
	(232127, 121, '2014-03-01 00:54:30.000000', 'temperatura', 493.0000, 'ºC'),
	(232128, 121, '2014-03-01 00:54:31.000000', 'temperatura', 475.0000, 'ºC'),
	(232129, 121, '2014-03-01 00:54:32.000000', 'temperatura', 899.0000, 'ºC'),
	(232130, 121, '2014-03-01 00:54:33.000000', 'temperatura', 669.0000, 'ºC'),
	(232131, 121, '2014-03-01 00:54:34.000000', 'temperatura', 650.0000, 'ºC'),
	(232132, 121, '2014-03-01 00:54:35.000000', 'temperatura', 41.0000, 'ºC'),
	(232133, 121, '2014-03-01 00:54:36.000000', 'temperatura', 658.0000, 'ºC'),
	(232134, 121, '2014-03-01 00:54:37.000000', 'temperatura', 767.0000, 'ºC'),
	(232135, 121, '2014-03-01 00:54:38.000000', 'temperatura', 662.0000, 'ºC'),
	(232136, 121, '2014-03-01 00:54:39.000000', 'temperatura', 1008.0000, 'ºC'),
	(232137, 121, '2014-03-01 00:54:40.000000', 'temperatura', 656.0000, 'ºC'),
	(232138, 121, '2014-03-01 00:54:41.000000', 'temperatura', 254.0000, 'ºC'),
	(232139, 121, '2014-03-01 00:54:42.000000', 'temperatura', 505.0000, 'ºC'),
	(232140, 121, '2014-03-01 00:54:43.000000', 'temperatura', 565.0000, 'ºC'),
	(232141, 121, '2014-03-01 00:54:44.000000', 'temperatura', 108.0000, 'ºC'),
	(232142, 121, '2014-03-01 00:54:45.000000', 'temperatura', 44.0000, 'ºC'),
	(232143, 121, '2014-03-01 00:54:46.000000', 'temperatura', 1098.0000, 'ºC'),
	(232144, 121, '2014-03-01 00:54:47.000000', 'temperatura', 559.0000, 'ºC'),
	(232145, 121, '2014-03-01 00:54:48.000000', 'temperatura', 700.0000, 'ºC'),
	(232146, 121, '2014-03-01 00:54:49.000000', 'temperatura', 624.0000, 'ºC'),
	(232147, 121, '2014-03-01 00:54:50.000000', 'temperatura', 1019.0000, 'ºC'),
	(232148, 121, '2014-03-01 00:54:51.000000', 'temperatura', 824.0000, 'ºC'),
	(232149, 121, '2014-03-01 00:54:52.000000', 'temperatura', 1062.0000, 'ºC'),
	(232150, 121, '2014-03-01 00:54:53.000000', 'temperatura', 441.0000, 'ºC'),
	(232151, 121, '2014-03-01 00:54:54.000000', 'temperatura', 220.0000, 'ºC'),
	(232152, 121, '2014-03-01 00:54:55.000000', 'temperatura', 978.0000, 'ºC'),
	(232153, 121, '2014-03-01 00:54:56.000000', 'temperatura', 631.0000, 'ºC'),
	(232154, 121, '2014-03-01 00:54:57.000000', 'temperatura', 219.0000, 'ºC'),
	(232155, 121, '2014-03-01 00:54:58.000000', 'temperatura', 403.0000, 'ºC'),
	(232156, 121, '2014-03-01 00:54:59.000000', 'temperatura', 161.0000, 'ºC'),
	(232157, 121, '2014-03-01 00:55:00.000000', 'temperatura', 793.0000, 'ºC'),
	(232158, 121, '2014-03-01 00:55:01.000000', 'temperatura', 1084.0000, 'ºC'),
	(232159, 121, '2014-03-01 00:55:02.000000', 'temperatura', 642.0000, 'ºC'),
	(232160, 121, '2014-03-01 00:55:03.000000', 'temperatura', 1158.0000, 'ºC'),
	(232161, 121, '2014-03-01 00:55:04.000000', 'temperatura', 266.0000, 'ºC'),
	(232162, 121, '2014-03-01 00:55:05.000000', 'temperatura', 255.0000, 'ºC'),
	(232163, 121, '2014-03-01 00:55:06.000000', 'temperatura', 479.0000, 'ºC'),
	(232164, 121, '2014-03-01 00:55:07.000000', 'temperatura', 431.0000, 'ºC'),
	(232165, 121, '2014-03-01 00:55:08.000000', 'temperatura', 717.0000, 'ºC'),
	(232166, 121, '2014-03-01 00:55:09.000000', 'temperatura', 1092.0000, 'ºC'),
	(232167, 121, '2014-03-01 00:55:10.000000', 'temperatura', 912.0000, 'ºC'),
	(232168, 121, '2014-03-01 00:55:11.000000', 'temperatura', 81.0000, 'ºC'),
	(232169, 121, '2014-03-01 00:55:12.000000', 'temperatura', 72.0000, 'ºC'),
	(232170, 121, '2014-03-01 00:55:13.000000', 'temperatura', 119.0000, 'ºC'),
	(232171, 121, '2014-03-01 00:55:14.000000', 'temperatura', 376.0000, 'ºC'),
	(232172, 121, '2014-03-01 00:55:15.000000', 'temperatura', 325.0000, 'ºC'),
	(232173, 121, '2014-03-01 00:55:16.000000', 'temperatura', 498.0000, 'ºC'),
	(232174, 121, '2014-03-01 00:55:17.000000', 'temperatura', 314.0000, 'ºC'),
	(232175, 121, '2014-03-01 00:55:18.000000', 'temperatura', 79.0000, 'ºC'),
	(232176, 121, '2014-03-01 00:55:19.000000', 'temperatura', 653.0000, 'ºC'),
	(232177, 121, '2014-03-01 00:55:20.000000', 'temperatura', 628.0000, 'ºC'),
	(232178, 121, '2014-03-01 00:55:21.000000', 'temperatura', 1182.0000, 'ºC'),
	(232179, 121, '2014-03-01 00:55:22.000000', 'temperatura', 427.0000, 'ºC'),
	(232180, 121, '2014-03-01 00:55:23.000000', 'temperatura', 989.0000, 'ºC'),
	(232181, 121, '2014-03-01 00:55:24.000000', 'temperatura', 64.0000, 'ºC'),
	(232182, 121, '2014-03-01 00:55:25.000000', 'temperatura', 953.0000, 'ºC'),
	(232183, 121, '2014-03-01 00:55:26.000000', 'temperatura', 974.0000, 'ºC'),
	(232184, 121, '2014-03-01 00:55:27.000000', 'temperatura', 811.0000, 'ºC'),
	(232185, 121, '2014-03-01 00:55:28.000000', 'temperatura', 1136.0000, 'ºC'),
	(232186, 121, '2014-03-01 00:55:29.000000', 'temperatura', 845.0000, 'ºC'),
	(232187, 121, '2014-03-01 00:55:30.000000', 'temperatura', 819.0000, 'ºC'),
	(232188, 121, '2014-03-01 00:55:31.000000', 'temperatura', 361.0000, 'ºC'),
	(232189, 121, '2014-03-01 00:55:32.000000', 'temperatura', 548.0000, 'ºC'),
	(232190, 121, '2014-03-01 00:55:33.000000', 'temperatura', 459.0000, 'ºC'),
	(232191, 121, '2014-03-01 00:55:34.000000', 'temperatura', 649.0000, 'ºC'),
	(232192, 121, '2014-03-01 00:55:35.000000', 'temperatura', 669.0000, 'ºC'),
	(232193, 121, '2014-03-01 00:55:36.000000', 'temperatura', 198.0000, 'ºC'),
	(232194, 121, '2014-03-01 00:55:37.000000', 'temperatura', 184.0000, 'ºC'),
	(232195, 121, '2014-03-01 00:55:38.000000', 'temperatura', 325.0000, 'ºC'),
	(232196, 121, '2014-03-01 00:55:39.000000', 'temperatura', 1074.0000, 'ºC'),
	(232197, 121, '2014-03-01 00:55:40.000000', 'temperatura', 798.0000, 'ºC'),
	(232198, 121, '2014-03-01 00:55:41.000000', 'temperatura', 767.0000, 'ºC'),
	(232199, 121, '2014-03-01 00:55:42.000000', 'temperatura', 242.0000, 'ºC'),
	(232200, 121, '2014-03-01 00:55:43.000000', 'temperatura', 110.0000, 'ºC'),
	(232201, 121, '2014-03-01 00:55:44.000000', 'temperatura', 1023.0000, 'ºC'),
	(232202, 121, '2014-03-01 00:55:45.000000', 'temperatura', 1186.0000, 'ºC'),
	(232203, 121, '2014-03-01 00:55:46.000000', 'temperatura', 463.0000, 'ºC'),
	(232204, 121, '2014-03-01 00:55:47.000000', 'temperatura', 1158.0000, 'ºC'),
	(232205, 121, '2014-03-01 00:55:48.000000', 'temperatura', 800.0000, 'ºC'),
	(232206, 121, '2014-03-01 00:55:49.000000', 'temperatura', 526.0000, 'ºC'),
	(232207, 121, '2014-03-01 00:55:50.000000', 'temperatura', 233.0000, 'ºC'),
	(232208, 121, '2014-03-01 00:55:51.000000', 'temperatura', 785.0000, 'ºC'),
	(232209, 121, '2014-03-01 00:55:52.000000', 'temperatura', 827.0000, 'ºC'),
	(232210, 121, '2014-03-01 00:55:53.000000', 'temperatura', 580.0000, 'ºC'),
	(232211, 121, '2014-03-01 00:55:54.000000', 'temperatura', 420.0000, 'ºC'),
	(232212, 121, '2014-03-01 00:55:55.000000', 'temperatura', 361.0000, 'ºC'),
	(232213, 121, '2014-03-01 00:55:56.000000', 'temperatura', 546.0000, 'ºC'),
	(232214, 121, '2014-03-01 00:55:57.000000', 'temperatura', 449.0000, 'ºC'),
	(232215, 121, '2014-03-01 00:55:58.000000', 'temperatura', 605.0000, 'ºC'),
	(232216, 121, '2014-03-01 00:55:59.000000', 'temperatura', 479.0000, 'ºC'),
	(232217, 121, '2014-03-01 00:56:00.000000', 'temperatura', 579.0000, 'ºC'),
	(232218, 121, '2014-03-01 00:56:01.000000', 'temperatura', 259.0000, 'ºC'),
	(232219, 121, '2014-03-01 00:56:02.000000', 'temperatura', 760.0000, 'ºC'),
	(232220, 121, '2014-03-01 00:56:03.000000', 'temperatura', 624.0000, 'ºC'),
	(232221, 121, '2014-03-01 00:56:04.000000', 'temperatura', 840.0000, 'ºC'),
	(232222, 121, '2014-03-01 00:56:05.000000', 'temperatura', 1130.0000, 'ºC'),
	(232223, 121, '2014-03-01 00:56:06.000000', 'temperatura', 728.0000, 'ºC'),
	(232224, 121, '2014-03-01 00:56:07.000000', 'temperatura', 250.0000, 'ºC'),
	(232225, 121, '2014-03-01 00:56:08.000000', 'temperatura', 266.0000, 'ºC'),
	(232226, 121, '2014-03-01 00:56:09.000000', 'temperatura', 580.0000, 'ºC'),
	(232227, 121, '2014-03-01 00:56:10.000000', 'temperatura', 902.0000, 'ºC'),
	(232228, 121, '2014-03-01 00:56:11.000000', 'temperatura', 371.0000, 'ºC'),
	(232229, 121, '2014-03-01 00:56:12.000000', 'temperatura', 349.0000, 'ºC'),
	(232230, 121, '2014-03-01 00:56:13.000000', 'temperatura', 632.0000, 'ºC'),
	(232231, 121, '2014-03-01 00:56:14.000000', 'temperatura', 915.0000, 'ºC'),
	(232232, 121, '2014-03-01 00:56:15.000000', 'temperatura', 277.0000, 'ºC'),
	(232233, 121, '2014-03-01 00:56:16.000000', 'temperatura', 1042.0000, 'ºC'),
	(232234, 121, '2014-03-01 00:56:17.000000', 'temperatura', 780.0000, 'ºC'),
	(232235, 121, '2014-03-01 00:56:18.000000', 'temperatura', 773.0000, 'ºC'),
	(232236, 121, '2014-03-01 00:56:19.000000', 'temperatura', 326.0000, 'ºC'),
	(232237, 121, '2014-03-01 00:56:20.000000', 'temperatura', 512.0000, 'ºC'),
	(232238, 121, '2014-03-01 00:56:21.000000', 'temperatura', 381.0000, 'ºC'),
	(232239, 121, '2014-03-01 00:56:22.000000', 'temperatura', 369.0000, 'ºC'),
	(232240, 121, '2014-03-01 00:56:23.000000', 'temperatura', 702.0000, 'ºC'),
	(232241, 121, '2014-03-01 00:56:24.000000', 'temperatura', 5.0000, 'ºC'),
	(232242, 121, '2014-03-01 00:56:25.000000', 'temperatura', 319.0000, 'ºC'),
	(232243, 121, '2014-03-01 00:56:26.000000', 'temperatura', 379.0000, 'ºC'),
	(232244, 121, '2014-03-01 00:56:27.000000', 'temperatura', 938.0000, 'ºC'),
	(232245, 121, '2014-03-01 00:56:28.000000', 'temperatura', 1154.0000, 'ºC'),
	(232246, 121, '2014-03-01 00:56:29.000000', 'temperatura', 557.0000, 'ºC'),
	(232247, 121, '2014-03-01 00:56:30.000000', 'temperatura', 522.0000, 'ºC'),
	(232248, 121, '2014-03-01 00:56:31.000000', 'temperatura', 942.0000, 'ºC'),
	(232249, 121, '2014-03-01 00:56:32.000000', 'temperatura', 743.0000, 'ºC'),
	(232250, 121, '2014-03-01 00:56:33.000000', 'temperatura', 892.0000, 'ºC'),
	(232251, 121, '2014-03-01 00:56:34.000000', 'temperatura', 1028.0000, 'ºC'),
	(232252, 121, '2014-03-01 00:56:35.000000', 'temperatura', 68.0000, 'ºC'),
	(232253, 121, '2014-03-01 00:56:36.000000', 'temperatura', 853.0000, 'ºC'),
	(232254, 121, '2014-03-01 00:56:37.000000', 'temperatura', 464.0000, 'ºC'),
	(232255, 121, '2014-03-01 00:56:38.000000', 'temperatura', 960.0000, 'ºC'),
	(232256, 121, '2014-03-01 00:56:39.000000', 'temperatura', 1011.0000, 'ºC'),
	(232257, 121, '2014-03-01 00:56:40.000000', 'temperatura', 974.0000, 'ºC'),
	(232258, 121, '2014-03-01 00:56:41.000000', 'temperatura', 636.0000, 'ºC'),
	(232259, 121, '2014-03-01 00:56:42.000000', 'temperatura', 261.0000, 'ºC'),
	(232260, 121, '2014-03-01 00:56:43.000000', 'temperatura', 596.0000, 'ºC'),
	(232261, 121, '2014-03-01 00:56:44.000000', 'temperatura', 997.0000, 'ºC'),
	(232262, 121, '2014-03-01 00:56:45.000000', 'temperatura', 799.0000, 'ºC'),
	(232263, 121, '2014-03-01 00:56:46.000000', 'temperatura', 1003.0000, 'ºC'),
	(232264, 121, '2014-03-01 00:56:47.000000', 'temperatura', 220.0000, 'ºC'),
	(232265, 121, '2014-03-01 00:56:48.000000', 'temperatura', 492.0000, 'ºC'),
	(232266, 121, '2014-03-01 00:56:49.000000', 'temperatura', 601.0000, 'ºC'),
	(232267, 121, '2014-03-01 00:56:50.000000', 'temperatura', 329.0000, 'ºC'),
	(232268, 121, '2014-03-01 00:56:51.000000', 'temperatura', 1042.0000, 'ºC'),
	(232269, 121, '2014-03-01 00:56:52.000000', 'temperatura', 626.0000, 'ºC'),
	(232270, 121, '2014-03-01 00:56:53.000000', 'temperatura', 2.0000, 'ºC'),
	(232271, 121, '2014-03-01 00:56:54.000000', 'temperatura', 532.0000, 'ºC'),
	(232272, 121, '2014-03-01 00:56:55.000000', 'temperatura', 257.0000, 'ºC'),
	(232273, 121, '2014-03-01 00:56:56.000000', 'temperatura', 890.0000, 'ºC'),
	(232274, 121, '2014-03-01 00:56:57.000000', 'temperatura', 78.0000, 'ºC'),
	(232275, 121, '2014-03-01 00:56:58.000000', 'temperatura', 121.0000, 'ºC'),
	(232276, 121, '2014-03-01 00:56:59.000000', 'temperatura', 373.0000, 'ºC'),
	(232277, 121, '2014-03-01 00:57:00.000000', 'temperatura', 301.0000, 'ºC'),
	(232278, 121, '2014-03-01 00:57:01.000000', 'temperatura', 387.0000, 'ºC'),
	(232279, 121, '2014-03-01 00:57:02.000000', 'temperatura', 1032.0000, 'ºC'),
	(232280, 121, '2014-03-01 00:57:03.000000', 'temperatura', 398.0000, 'ºC'),
	(232281, 121, '2014-03-01 00:57:04.000000', 'temperatura', 97.0000, 'ºC'),
	(232282, 121, '2014-03-01 00:57:05.000000', 'temperatura', 489.0000, 'ºC'),
	(232283, 121, '2014-03-01 00:57:06.000000', 'temperatura', 957.0000, 'ºC'),
	(232284, 121, '2014-03-01 00:57:07.000000', 'temperatura', 916.0000, 'ºC'),
	(232285, 121, '2014-03-01 00:57:08.000000', 'temperatura', 509.0000, 'ºC'),
	(232286, 121, '2014-03-01 00:57:09.000000', 'temperatura', 999.0000, 'ºC'),
	(232287, 121, '2014-03-01 00:57:10.000000', 'temperatura', 1068.0000, 'ºC'),
	(232288, 121, '2014-03-01 00:57:11.000000', 'temperatura', 1144.0000, 'ºC'),
	(232289, 121, '2014-03-01 00:57:12.000000', 'temperatura', 114.0000, 'ºC'),
	(232290, 121, '2014-03-01 00:57:13.000000', 'temperatura', 742.0000, 'ºC'),
	(232291, 121, '2014-03-01 00:57:14.000000', 'temperatura', 967.0000, 'ºC'),
	(232292, 121, '2014-03-01 00:57:15.000000', 'temperatura', 211.0000, 'ºC'),
	(232293, 121, '2014-03-01 00:57:16.000000', 'temperatura', 552.0000, 'ºC'),
	(232294, 121, '2014-03-01 00:57:17.000000', 'temperatura', 930.0000, 'ºC'),
	(232295, 121, '2014-03-01 00:57:18.000000', 'temperatura', 593.0000, 'ºC'),
	(232296, 121, '2014-03-01 00:57:19.000000', 'temperatura', 175.0000, 'ºC'),
	(232297, 121, '2014-03-01 00:57:20.000000', 'temperatura', 297.0000, 'ºC'),
	(232298, 121, '2014-03-01 00:57:21.000000', 'temperatura', 962.0000, 'ºC'),
	(232299, 121, '2014-03-01 00:57:22.000000', 'temperatura', 319.0000, 'ºC'),
	(232300, 121, '2014-03-01 00:57:23.000000', 'temperatura', 1111.0000, 'ºC'),
	(232301, 121, '2014-03-01 00:57:24.000000', 'temperatura', 996.0000, 'ºC'),
	(232302, 121, '2014-03-01 00:57:25.000000', 'temperatura', 450.0000, 'ºC'),
	(232303, 121, '2014-03-01 00:57:26.000000', 'temperatura', 462.0000, 'ºC'),
	(232304, 121, '2014-03-01 00:57:27.000000', 'temperatura', 959.0000, 'ºC'),
	(232305, 121, '2014-03-01 00:57:28.000000', 'temperatura', 1008.0000, 'ºC'),
	(232306, 121, '2014-03-01 00:57:29.000000', 'temperatura', 966.0000, 'ºC'),
	(232307, 121, '2014-03-01 00:57:30.000000', 'temperatura', 604.0000, 'ºC'),
	(232308, 121, '2014-03-01 00:57:31.000000', 'temperatura', 124.0000, 'ºC'),
	(232309, 121, '2014-03-01 00:57:32.000000', 'temperatura', 10.0000, 'ºC'),
	(232310, 121, '2014-03-01 00:57:33.000000', 'temperatura', 876.0000, 'ºC'),
	(232311, 121, '2014-03-01 00:57:34.000000', 'temperatura', 750.0000, 'ºC'),
	(232312, 121, '2014-03-01 00:57:35.000000', 'temperatura', 1124.0000, 'ºC'),
	(232313, 121, '2014-03-01 00:57:36.000000', 'temperatura', 968.0000, 'ºC'),
	(232314, 121, '2014-03-01 00:57:37.000000', 'temperatura', 271.0000, 'ºC'),
	(232315, 121, '2014-03-01 00:57:38.000000', 'temperatura', 851.0000, 'ºC'),
	(232316, 121, '2014-03-01 00:57:39.000000', 'temperatura', 1044.0000, 'ºC'),
	(232317, 121, '2014-03-01 00:57:40.000000', 'temperatura', 266.0000, 'ºC'),
	(232318, 121, '2014-03-01 00:57:41.000000', 'temperatura', 600.0000, 'ºC'),
	(232319, 121, '2014-03-01 00:57:42.000000', 'temperatura', 1001.0000, 'ºC'),
	(232320, 121, '2014-03-01 00:57:43.000000', 'temperatura', 806.0000, 'ºC'),
	(232321, 121, '2014-03-01 00:57:44.000000', 'temperatura', 1026.0000, 'ºC'),
	(232322, 121, '2014-03-01 00:57:45.000000', 'temperatura', 312.0000, 'ºC'),
	(232323, 121, '2014-03-01 00:57:46.000000', 'temperatura', 885.0000, 'ºC'),
	(232324, 121, '2014-03-01 00:57:47.000000', 'temperatura', 1088.0000, 'ºC'),
	(232325, 121, '2014-03-01 00:57:48.000000', 'temperatura', 385.0000, 'ºC'),
	(232326, 121, '2014-03-01 00:57:49.000000', 'temperatura', 1064.0000, 'ºC'),
	(232327, 121, '2014-03-01 00:57:50.000000', 'temperatura', 563.0000, 'ºC'),
	(232328, 121, '2014-03-01 00:57:51.000000', 'temperatura', 826.0000, 'ºC'),
	(232329, 121, '2014-03-01 00:57:52.000000', 'temperatura', 38.0000, 'ºC'),
	(232330, 121, '2014-03-01 00:57:53.000000', 'temperatura', 116.0000, 'ºC'),
	(232331, 121, '2014-03-01 00:57:54.000000', 'temperatura', 465.0000, 'ºC'),
	(232332, 121, '2014-03-01 00:57:55.000000', 'temperatura', 776.0000, 'ºC'),
	(232333, 121, '2014-03-01 00:57:56.000000', 'temperatura', 86.0000, 'ºC'),
	(232334, 121, '2014-03-01 00:57:57.000000', 'temperatura', 501.0000, 'ºC'),
	(232335, 121, '2014-03-01 00:57:58.000000', 'temperatura', 1050.0000, 'ºC'),
	(232336, 121, '2014-03-01 00:57:59.000000', 'temperatura', 145.0000, 'ºC'),
	(232337, 121, '2014-03-01 00:58:00.000000', 'temperatura', 1178.0000, 'ºC'),
	(232338, 121, '2014-03-01 00:58:01.000000', 'temperatura', 654.0000, 'ºC'),
	(232339, 121, '2014-03-01 00:58:02.000000', 'temperatura', 938.0000, 'ºC'),
	(232340, 121, '2014-03-01 00:58:03.000000', 'temperatura', 329.0000, 'ºC'),
	(232341, 121, '2014-03-01 00:58:04.000000', 'temperatura', 32.0000, 'ºC'),
	(232342, 121, '2014-03-01 00:58:05.000000', 'temperatura', 371.0000, 'ºC'),
	(232343, 121, '2014-03-01 00:58:06.000000', 'temperatura', 562.0000, 'ºC'),
	(232344, 121, '2014-03-01 00:58:07.000000', 'temperatura', 499.0000, 'ºC'),
	(232345, 121, '2014-03-01 00:58:08.000000', 'temperatura', 806.0000, 'ºC'),
	(232346, 121, '2014-03-01 00:58:09.000000', 'temperatura', 133.0000, 'ºC'),
	(232347, 121, '2014-03-01 00:58:10.000000', 'temperatura', 650.0000, 'ºC'),
	(232348, 121, '2014-03-01 00:58:11.000000', 'temperatura', 453.0000, 'ºC'),
	(232349, 121, '2014-03-01 00:58:12.000000', 'temperatura', 312.0000, 'ºC'),
	(232350, 121, '2014-03-01 00:58:13.000000', 'temperatura', 202.0000, 'ºC'),
	(232351, 121, '2014-03-01 00:58:14.000000', 'temperatura', 75.0000, 'ºC'),
	(232352, 121, '2014-03-01 00:58:15.000000', 'temperatura', 968.0000, 'ºC'),
	(232353, 121, '2014-03-01 00:58:16.000000', 'temperatura', 1018.0000, 'ºC'),
	(232354, 121, '2014-03-01 00:58:17.000000', 'temperatura', 987.0000, 'ºC'),
	(232355, 121, '2014-03-01 00:58:18.000000', 'temperatura', 683.0000, 'ºC'),
	(232356, 121, '2014-03-01 00:58:19.000000', 'temperatura', 451.0000, 'ºC'),
	(232357, 121, '2014-03-01 00:58:20.000000', 'temperatura', 207.0000, 'ºC'),
	(232358, 121, '2014-03-01 00:58:21.000000', 'temperatura', 883.0000, 'ºC'),
	(232359, 121, '2014-03-01 00:58:22.000000', 'temperatura', 196.0000, 'ºC'),
	(232360, 121, '2014-03-01 00:58:23.000000', 'temperatura', 732.0000, 'ºC'),
	(232361, 121, '2014-03-01 00:58:24.000000', 'temperatura', 671.0000, 'ºC'),
	(232362, 121, '2014-03-01 00:58:25.000000', 'temperatura', 1161.0000, 'ºC'),
	(232363, 121, '2014-03-01 00:58:26.000000', 'temperatura', 191.0000, 'ºC'),
	(232364, 121, '2014-03-01 00:58:27.000000', 'temperatura', 1073.0000, 'ºC'),
	(232365, 121, '2014-03-01 00:58:28.000000', 'temperatura', 1194.0000, 'ºC'),
	(232366, 121, '2014-03-01 00:58:29.000000', 'temperatura', 349.0000, 'ºC'),
	(232367, 121, '2014-03-01 00:58:30.000000', 'temperatura', 564.0000, 'ºC'),
	(232368, 121, '2014-03-01 00:58:31.000000', 'temperatura', 574.0000, 'ºC'),
	(232369, 121, '2014-03-01 00:58:32.000000', 'temperatura', 1180.0000, 'ºC'),
	(232370, 121, '2014-03-01 00:58:33.000000', 'temperatura', 578.0000, 'ºC'),
	(232371, 121, '2014-03-01 00:58:34.000000', 'temperatura', 550.0000, 'ºC'),
	(232372, 121, '2014-03-01 00:58:35.000000', 'temperatura', 1016.0000, 'ºC'),
	(232373, 121, '2014-03-01 00:58:36.000000', 'temperatura', 1029.0000, 'ºC'),
	(232374, 121, '2014-03-01 00:58:37.000000', 'temperatura', 900.0000, 'ºC'),
	(232375, 121, '2014-03-01 00:58:38.000000', 'temperatura', 215.0000, 'ºC'),
	(232376, 121, '2014-03-01 00:58:39.000000', 'temperatura', 773.0000, 'ºC'),
	(232377, 121, '2014-03-01 00:58:40.000000', 'temperatura', 819.0000, 'ºC'),
	(232378, 121, '2014-03-01 00:58:41.000000', 'temperatura', 578.0000, 'ºC'),
	(232379, 121, '2014-03-01 00:58:42.000000', 'temperatura', 434.0000, 'ºC'),
	(232380, 121, '2014-03-01 00:58:43.000000', 'temperatura', 435.0000, 'ºC'),
	(232381, 121, '2014-03-01 00:58:44.000000', 'temperatura', 875.0000, 'ºC'),
	(232382, 121, '2014-03-01 00:58:45.000000', 'temperatura', 671.0000, 'ºC'),
	(232383, 121, '2014-03-01 00:58:46.000000', 'temperatura', 732.0000, 'ºC'),
	(232384, 121, '2014-03-01 00:58:47.000000', 'temperatura', 444.0000, 'ºC'),
	(232385, 121, '2014-03-01 00:58:48.000000', 'temperatura', 27.0000, 'ºC'),
	(232386, 121, '2014-03-01 00:58:49.000000', 'temperatura', 4.0000, 'ºC'),
	(232387, 121, '2014-03-01 00:58:50.000000', 'temperatura', 1140.0000, 'ºC'),
	(232388, 121, '2014-03-01 00:58:51.000000', 'temperatura', 888.0000, 'ºC'),
	(232389, 121, '2014-03-01 00:58:52.000000', 'temperatura', 1019.0000, 'ºC'),
	(232390, 121, '2014-03-01 00:58:53.000000', 'temperatura', 31.0000, 'ºC'),
	(232391, 121, '2014-03-01 00:58:54.000000', 'temperatura', 701.0000, 'ºC'),
	(232392, 121, '2014-03-01 00:58:55.000000', 'temperatura', 1013.0000, 'ºC'),
	(232393, 121, '2014-03-01 00:58:56.000000', 'temperatura', 560.0000, 'ºC'),
	(232394, 121, '2014-03-01 00:58:57.000000', 'temperatura', 961.0000, 'ºC'),
	(232395, 121, '2014-03-01 00:58:58.000000', 'temperatura', 728.0000, 'ºC'),
	(232396, 121, '2014-03-01 00:58:59.000000', 'temperatura', 759.0000, 'ºC'),
	(232397, 121, '2014-03-01 00:59:00.000000', 'temperatura', 408.0000, 'ºC'),
	(232398, 121, '2014-03-01 00:59:01.000000', 'temperatura', 965.0000, 'ºC'),
	(232399, 121, '2014-03-01 00:59:02.000000', 'temperatura', 0.0000, 'ºC'),
	(232400, 121, '2014-03-01 00:59:03.000000', 'temperatura', 705.0000, 'ºC'),
	(232401, 121, '2014-03-01 00:59:04.000000', 'temperatura', 1125.0000, 'ºC'),
	(232402, 121, '2014-03-01 00:59:05.000000', 'temperatura', 1113.0000, 'ºC'),
	(232403, 121, '2014-03-01 00:59:06.000000', 'temperatura', 989.0000, 'ºC'),
	(232404, 121, '2014-03-01 00:59:07.000000', 'temperatura', 409.0000, 'ºC'),
	(232405, 121, '2014-03-01 00:59:08.000000', 'temperatura', 277.0000, 'ºC'),
	(232406, 121, '2014-03-01 00:59:09.000000', 'temperatura', 156.0000, 'ºC'),
	(232407, 121, '2014-03-01 00:59:10.000000', 'temperatura', 1153.0000, 'ºC'),
	(232408, 121, '2014-03-01 00:59:11.000000', 'temperatura', 495.0000, 'ºC'),
	(232409, 121, '2014-03-01 00:59:12.000000', 'temperatura', 218.0000, 'ºC'),
	(232410, 121, '2014-03-01 00:59:13.000000', 'temperatura', 806.0000, 'ºC'),
	(232411, 121, '2014-03-01 00:59:14.000000', 'temperatura', 975.0000, 'ºC'),
	(232412, 121, '2014-03-01 00:59:15.000000', 'temperatura', 59.0000, 'ºC'),
	(232413, 121, '2014-03-01 00:59:16.000000', 'temperatura', 972.0000, 'ºC'),
	(232414, 121, '2014-03-01 00:59:17.000000', 'temperatura', 1081.0000, 'ºC'),
	(232415, 121, '2014-03-01 00:59:18.000000', 'temperatura', 89.0000, 'ºC'),
	(232416, 121, '2014-03-01 00:59:19.000000', 'temperatura', 802.0000, 'ºC'),
	(232417, 121, '2014-03-01 00:59:20.000000', 'temperatura', 146.0000, 'ºC'),
	(232418, 121, '2014-03-01 00:59:21.000000', 'temperatura', 724.0000, 'ºC'),
	(232419, 121, '2014-03-01 00:59:22.000000', 'temperatura', 783.0000, 'ºC'),
	(232420, 121, '2014-03-01 00:59:23.000000', 'temperatura', 542.0000, 'ºC'),
	(232421, 121, '2014-03-01 00:59:24.000000', 'temperatura', 360.0000, 'ºC'),
	(232422, 121, '2014-03-01 00:59:25.000000', 'temperatura', 177.0000, 'ºC'),
	(232423, 121, '2014-03-01 00:59:26.000000', 'temperatura', 1005.0000, 'ºC'),
	(232424, 121, '2014-03-01 00:59:27.000000', 'temperatura', 895.0000, 'ºC'),
	(232425, 121, '2014-03-01 00:59:28.000000', 'temperatura', 262.0000, 'ºC'),
	(232426, 121, '2014-03-01 00:59:29.000000', 'temperatura', 1024.0000, 'ºC'),
	(232427, 121, '2014-03-01 00:59:30.000000', 'temperatura', 735.0000, 'ºC'),
	(232428, 121, '2014-03-01 00:59:31.000000', 'temperatura', 605.0000, 'ºC'),
	(232429, 121, '2014-03-01 00:59:32.000000', 'temperatura', 817.0000, 'ºC'),
	(232430, 121, '2014-03-01 00:59:33.000000', 'temperatura', 1073.0000, 'ºC'),
	(232431, 121, '2014-03-01 00:59:34.000000', 'temperatura', 513.0000, 'ºC'),
	(232432, 121, '2014-03-01 00:59:35.000000', 'temperatura', 547.0000, 'ºC'),
	(232433, 121, '2014-03-01 00:59:36.000000', 'temperatura', 1197.0000, 'ºC'),
	(232434, 121, '2014-03-01 00:59:37.000000', 'temperatura', 744.0000, 'ºC'),
	(232435, 121, '2014-03-01 00:59:38.000000', 'temperatura', 130.0000, 'ºC'),
	(232436, 121, '2014-03-01 00:59:39.000000', 'temperatura', 818.0000, 'ºC'),
	(232437, 121, '2014-03-01 00:59:40.000000', 'temperatura', 100.0000, 'ºC'),
	(232438, 121, '2014-03-01 00:59:41.000000', 'temperatura', 448.0000, 'ºC'),
	(232439, 121, '2014-03-01 00:59:42.000000', 'temperatura', 741.0000, 'ºC'),
	(232440, 121, '2014-03-01 00:59:43.000000', 'temperatura', 1159.0000, 'ºC'),
	(232441, 121, '2014-03-01 00:59:44.000000', 'temperatura', 1175.0000, 'ºC'),
	(232442, 121, '2014-03-01 00:59:45.000000', 'temperatura', 1196.0000, 'ºC'),
	(232443, 121, '2014-03-01 00:59:46.000000', 'temperatura', 55.0000, 'ºC'),
	(232444, 121, '2014-03-01 00:59:47.000000', 'temperatura', 290.0000, 'ºC'),
	(232445, 121, '2014-03-01 00:59:48.000000', 'temperatura', 83.0000, 'ºC'),
	(232446, 121, '2014-03-01 00:59:49.000000', 'temperatura', 745.0000, 'ºC'),
	(232447, 121, '2014-03-01 00:59:50.000000', 'temperatura', 1079.0000, 'ºC'),
	(232448, 121, '2014-03-01 00:59:51.000000', 'temperatura', 759.0000, 'ºC'),
	(232449, 121, '2014-03-01 00:59:52.000000', 'temperatura', 558.0000, 'ºC'),
	(232450, 121, '2014-03-01 00:59:53.000000', 'temperatura', 513.0000, 'ºC'),
	(232451, 121, '2014-03-01 00:59:54.000000', 'temperatura', 894.0000, 'ºC'),
	(232452, 121, '2014-03-01 00:59:55.000000', 'temperatura', 531.0000, 'ºC'),
	(232453, 121, '2014-03-01 00:59:56.000000', 'temperatura', 1174.0000, 'ºC'),
	(232454, 121, '2014-03-01 00:59:57.000000', 'temperatura', 676.0000, 'ºC'),
	(232455, 121, '2014-03-01 00:59:58.000000', 'temperatura', 1057.0000, 'ºC'),
	(232456, 121, '2014-03-01 00:59:59.000000', 'temperatura', 860.0000, 'ºC'),
	(232457, 121, '2014-03-01 01:00:00.000000', 'temperatura', 1128.0000, 'ºC'),
	(232458, 121, '2014-03-01 01:00:01.000000', 'temperatura', 660.0000, 'ºC'),
	(232459, 121, '2014-03-01 01:00:02.000000', 'temperatura', 1118.0000, 'ºC'),
	(232460, 121, '2014-03-01 01:00:03.000000', 'temperatura', 11.0000, 'ºC'),
	(232461, 121, '2014-03-01 01:00:04.000000', 'temperatura', 300.0000, 'ºC'),
	(232462, 121, '2014-03-01 01:00:05.000000', 'temperatura', 267.0000, 'ºC'),
	(232463, 121, '2014-03-01 01:00:06.000000', 'temperatura', 437.0000, 'ºC'),
	(232464, 121, '2014-03-01 01:00:07.000000', 'temperatura', 184.0000, 'ºC'),
	(232465, 121, '2014-03-01 01:00:08.000000', 'temperatura', 809.0000, 'ºC'),
	(232466, 121, '2014-03-01 01:00:09.000000', 'temperatura', 1095.0000, 'ºC'),
	(232467, 121, '2014-03-01 01:00:10.000000', 'temperatura', 646.0000, 'ºC'),
	(232468, 121, '2014-03-01 01:00:11.000000', 'temperatura', 1145.0000, 'ºC'),
	(232469, 121, '2014-03-01 01:00:12.000000', 'temperatura', 190.0000, 'ºC'),
	(232470, 121, '2014-03-01 01:00:13.000000', 'temperatura', 1115.0000, 'ºC'),
	(232471, 121, '2014-03-01 01:00:14.000000', 'temperatura', 206.0000, 'ºC'),
	(232472, 121, '2014-03-01 01:00:15.000000', 'temperatura', 85.0000, 'ºC'),
	(232473, 121, '2014-03-01 01:00:16.000000', 'temperatura', 1007.0000, 'ºC'),
	(232474, 121, '2014-03-01 01:00:17.000000', 'temperatura', 1183.0000, 'ºC'),
	(232475, 121, '2014-03-01 01:00:18.000000', 'temperatura', 493.0000, 'ºC'),
	(232476, 121, '2014-03-01 01:00:19.000000', 'temperatura', 115.0000, 'ºC'),
	(232477, 121, '2014-03-01 01:00:20.000000', 'temperatura', 299.0000, 'ºC'),
	(232478, 121, '2014-03-01 01:00:21.000000', 'temperatura', 1150.0000, 'ºC'),
	(232479, 121, '2014-03-01 01:00:22.000000', 'temperatura', 51.0000, 'ºC'),
	(232480, 121, '2014-03-01 01:00:23.000000', 'temperatura', 409.0000, 'ºC'),
	(232481, 121, '2014-03-01 01:00:24.000000', 'temperatura', 691.0000, 'ºC'),
	(232482, 121, '2014-03-01 01:00:25.000000', 'temperatura', 1030.0000, 'ºC'),
	(232483, 121, '2014-03-01 01:00:26.000000', 'temperatura', 678.0000, 'ºC'),
	(232484, 121, '2014-03-01 01:00:27.000000', 'temperatura', 300.0000, 'ºC'),
	(232485, 121, '2014-03-01 01:00:28.000000', 'temperatura', 668.0000, 'ºC'),
	(232486, 121, '2014-03-01 01:00:29.000000', 'temperatura', 38.0000, 'ºC'),
	(232487, 121, '2014-03-01 01:00:30.000000', 'temperatura', 587.0000, 'ºC'),
	(232488, 121, '2014-03-01 01:00:31.000000', 'temperatura', 420.0000, 'ºC'),
	(232489, 121, '2014-03-01 01:00:32.000000', 'temperatura', 340.0000, 'ºC'),
	(232490, 121, '2014-03-01 01:00:33.000000', 'temperatura', 440.0000, 'ºC'),
	(232491, 121, '2014-03-01 01:00:34.000000', 'temperatura', 1182.0000, 'ºC'),
	(232492, 121, '2014-03-01 01:00:35.000000', 'temperatura', 988.0000, 'ºC'),
	(232493, 121, '2014-03-01 01:00:36.000000', 'temperatura', 196.0000, 'ºC'),
	(232494, 121, '2014-03-01 01:00:37.000000', 'temperatura', 415.0000, 'ºC'),
	(232495, 121, '2014-03-01 01:00:38.000000', 'temperatura', 289.0000, 'ºC'),
	(232496, 121, '2014-03-01 01:00:39.000000', 'temperatura', 199.0000, 'ºC'),
	(232497, 121, '2014-03-01 01:00:40.000000', 'temperatura', 128.0000, 'ºC'),
	(232498, 121, '2014-03-01 01:00:41.000000', 'temperatura', 45.0000, 'ºC'),
	(232499, 121, '2014-03-01 01:00:42.000000', 'temperatura', 1040.0000, 'ºC'),
	(232500, 121, '2014-03-01 01:00:43.000000', 'temperatura', 268.0000, 'ºC'),
	(232501, 121, '2014-03-01 01:00:44.000000', 'temperatura', 617.0000, 'ºC'),
	(232502, 121, '2014-03-01 01:00:45.000000', 'temperatura', 1085.0000, 'ºC'),
	(232503, 121, '2014-03-01 01:00:46.000000', 'temperatura', 1174.0000, 'ºC'),
	(232504, 121, '2014-03-01 01:00:47.000000', 'temperatura', 215.0000, 'ºC'),
	(232505, 121, '2014-03-01 01:00:48.000000', 'temperatura', 1154.0000, 'ºC'),
	(232506, 121, '2014-03-01 01:00:49.000000', 'temperatura', 326.0000, 'ºC'),
	(232507, 121, '2014-03-01 01:00:50.000000', 'temperatura', 566.0000, 'ºC'),
	(232508, 121, '2014-03-01 01:00:51.000000', 'temperatura', 653.0000, 'ºC'),
	(232509, 121, '2014-03-01 01:00:52.000000', 'temperatura', 370.0000, 'ºC'),
	(232510, 121, '2014-03-01 01:00:53.000000', 'temperatura', 1091.0000, 'ºC'),
	(232511, 121, '2014-03-01 01:00:54.000000', 'temperatura', 744.0000, 'ºC'),
	(232512, 121, '2014-03-01 01:00:55.000000', 'temperatura', 449.0000, 'ºC'),
	(232513, 121, '2014-03-01 01:00:56.000000', 'temperatura', 14.0000, 'ºC'),
	(232514, 121, '2014-03-01 01:00:57.000000', 'temperatura', 1123.0000, 'ºC'),
	(232515, 121, '2014-03-01 01:00:58.000000', 'temperatura', 771.0000, 'ºC'),
	(232516, 121, '2014-03-01 01:00:59.000000', 'temperatura', 489.0000, 'ºC'),
	(232517, 121, '2014-03-01 01:01:00.000000', 'temperatura', 131.0000, 'ºC'),
	(232518, 121, '2014-03-01 01:01:01.000000', 'temperatura', 389.0000, 'ºC'),
	(232519, 121, '2014-03-01 01:01:02.000000', 'temperatura', 354.0000, 'ºC'),
	(232520, 121, '2014-03-01 01:01:03.000000', 'temperatura', 604.0000, 'ºC'),
	(232521, 121, '2014-03-01 01:01:04.000000', 'temperatura', 759.0000, 'ºC'),
	(232522, 121, '2014-03-01 01:01:05.000000', 'temperatura', 782.0000, 'ºC'),
	(232523, 121, '2014-03-01 01:01:06.000000', 'temperatura', 434.0000, 'ºC'),
	(232524, 121, '2014-03-01 01:01:07.000000', 'temperatura', 1024.0000, 'ºC'),
	(232525, 121, '2014-03-01 01:01:08.000000', 'temperatura', 219.0000, 'ºC'),
	(232526, 121, '2014-03-01 01:01:09.000000', 'temperatura', 423.0000, 'ºC'),
	(232527, 121, '2014-03-01 01:01:10.000000', 'temperatura', 261.0000, 'ºC'),
	(232528, 121, '2014-03-01 01:01:11.000000', 'temperatura', 34.0000, 'ºC'),
	(232529, 121, '2014-03-01 01:01:12.000000', 'temperatura', 589.0000, 'ºC'),
	(232530, 121, '2014-03-01 01:01:13.000000', 'temperatura', 444.0000, 'ºC'),
	(232531, 121, '2014-03-01 01:01:14.000000', 'temperatura', 453.0000, 'ºC'),
	(232532, 121, '2014-03-01 01:01:15.000000', 'temperatura', 934.0000, 'ºC'),
	(232533, 121, '2014-03-01 01:01:16.000000', 'temperatura', 912.0000, 'ºC'),
	(232534, 121, '2014-03-01 01:01:17.000000', 'temperatura', 558.0000, 'ºC'),
	(232535, 121, '2014-03-01 01:01:18.000000', 'temperatura', 53.0000, 'ºC'),
	(232536, 121, '2014-03-01 01:01:19.000000', 'temperatura', 992.0000, 'ºC'),
	(232537, 121, '2014-03-01 01:01:20.000000', 'temperatura', 2.0000, 'ºC'),
	(232538, 121, '2014-03-01 01:01:21.000000', 'temperatura', 634.0000, 'ºC'),
	(232539, 121, '2014-03-01 01:01:22.000000', 'temperatura', 766.0000, 'ºC'),
	(232540, 121, '2014-03-01 01:01:23.000000', 'temperatura', 727.0000, 'ºC'),
	(232541, 121, '2014-03-01 01:01:24.000000', 'temperatura', 137.0000, 'ºC'),
	(232542, 121, '2014-03-01 01:01:25.000000', 'temperatura', 905.0000, 'ºC'),
	(232543, 121, '2014-03-01 01:01:26.000000', 'temperatura', 516.0000, 'ºC'),
	(232544, 121, '2014-03-01 01:01:27.000000', 'temperatura', 1064.0000, 'ºC'),
	(232545, 121, '2014-03-01 01:01:28.000000', 'temperatura', 174.0000, 'ºC'),
	(232546, 121, '2014-03-01 01:01:29.000000', 'temperatura', 78.0000, 'ºC'),
	(232547, 121, '2014-03-01 01:01:30.000000', 'temperatura', 1070.0000, 'ºC'),
	(232548, 121, '2014-03-01 01:01:31.000000', 'temperatura', 313.0000, 'ºC'),
	(232549, 121, '2014-03-01 01:01:32.000000', 'temperatura', 759.0000, 'ºC'),
	(232550, 121, '2014-03-01 01:01:33.000000', 'temperatura', 453.0000, 'ºC'),
	(232551, 121, '2014-03-01 01:01:34.000000', 'temperatura', 1190.0000, 'ºC'),
	(232552, 121, '2014-03-01 01:01:35.000000', 'temperatura', 993.0000, 'ºC'),
	(232553, 121, '2014-03-01 01:01:36.000000', 'temperatura', 196.0000, 'ºC'),
	(232554, 121, '2014-03-01 01:01:37.000000', 'temperatura', 400.0000, 'ºC'),
	(232555, 121, '2014-03-01 01:01:38.000000', 'temperatura', 212.0000, 'ºC'),
	(232556, 121, '2014-03-01 01:01:39.000000', 'temperatura', 1061.0000, 'ºC'),
	(232557, 121, '2014-03-01 01:01:40.000000', 'temperatura', 1071.0000, 'ºC'),
	(232558, 121, '2014-03-01 01:01:41.000000', 'temperatura', 971.0000, 'ºC'),
	(232559, 121, '2014-03-01 01:01:42.000000', 'temperatura', 441.0000, 'ºC'),
	(232560, 121, '2014-03-01 01:01:43.000000', 'temperatura', 495.0000, 'ºC'),
	(232561, 121, '2014-03-01 01:01:44.000000', 'temperatura', 1152.0000, 'ºC'),
	(232562, 121, '2014-03-01 01:01:45.000000', 'temperatura', 677.0000, 'ºC'),
	(232563, 121, '2014-03-01 01:01:46.000000', 'temperatura', 1129.0000, 'ºC'),
	(232564, 121, '2014-03-01 01:01:47.000000', 'temperatura', 15.0000, 'ºC'),
	(232565, 121, '2014-03-01 01:01:48.000000', 'temperatura', 290.0000, 'ºC'),
	(232566, 121, '2014-03-01 01:01:49.000000', 'temperatura', 203.0000, 'ºC'),
	(232567, 121, '2014-03-01 01:01:50.000000', 'temperatura', 146.0000, 'ºC'),
	(232568, 121, '2014-03-01 01:01:51.000000', 'temperatura', 120.0000, 'ºC'),
	(232569, 121, '2014-03-01 01:01:52.000000', 'temperatura', 165.0000, 'ºC'),
	(232570, 121, '2014-03-01 01:01:53.000000', 'temperatura', 467.0000, 'ºC'),
	(232571, 121, '2014-03-01 01:01:54.000000', 'temperatura', 637.0000, 'ºC'),
	(232572, 121, '2014-03-01 01:01:55.000000', 'temperatura', 587.0000, 'ºC'),
	(232573, 121, '2014-03-01 01:01:56.000000', 'temperatura', 1026.0000, 'ºC'),
	(232574, 121, '2014-03-01 01:01:57.000000', 'temperatura', 967.0000, 'ºC'),
	(232575, 121, '2014-03-01 01:01:58.000000', 'temperatura', 557.0000, 'ºC'),
	(232576, 121, '2014-03-01 01:01:59.000000', 'temperatura', 1083.0000, 'ºC'),
	(232577, 121, '2014-03-01 01:02:00.000000', 'temperatura', 147.0000, 'ºC'),
	(232578, 121, '2014-03-01 01:02:01.000000', 'temperatura', 1088.0000, 'ºC'),
	(232579, 121, '2014-03-01 01:02:02.000000', 'temperatura', 197.0000, 'ºC'),
	(232580, 121, '2014-03-01 01:02:03.000000', 'temperatura', 123.0000, 'ºC'),
	(232581, 121, '2014-03-01 01:02:04.000000', 'temperatura', 25.0000, 'ºC'),
	(232582, 121, '2014-03-01 01:02:05.000000', 'temperatura', 956.0000, 'ºC'),
	(232583, 121, '2014-03-01 01:02:06.000000', 'temperatura', 1106.0000, 'ºC'),
	(232584, 121, '2014-03-01 01:02:07.000000', 'temperatura', 261.0000, 'ºC'),
	(232585, 121, '2014-03-01 01:02:08.000000', 'temperatura', 389.0000, 'ºC'),
	(232586, 121, '2014-03-01 01:02:09.000000', 'temperatura', 1163.0000, 'ºC'),
	(232587, 121, '2014-03-01 01:02:10.000000', 'temperatura', 1049.0000, 'ºC'),
	(232588, 121, '2014-03-01 01:02:11.000000', 'temperatura', 556.0000, 'ºC'),
	(232589, 121, '2014-03-01 01:02:12.000000', 'temperatura', 832.0000, 'ºC'),
	(232590, 121, '2014-03-01 01:02:13.000000', 'temperatura', 95.0000, 'ºC'),
	(232591, 121, '2014-03-01 01:02:14.000000', 'temperatura', 378.0000, 'ºC'),
	(232592, 121, '2014-03-01 01:02:15.000000', 'temperatura', 407.0000, 'ºC'),
	(232593, 121, '2014-03-01 01:02:16.000000', 'temperatura', 900.0000, 'ºC'),
	(232594, 121, '2014-03-01 01:02:17.000000', 'temperatura', 880.0000, 'ºC'),
	(232595, 121, '2014-03-01 01:02:18.000000', 'temperatura', 501.0000, 'ºC'),
	(232596, 121, '2014-03-01 01:02:19.000000', 'temperatura', 1066.0000, 'ºC'),
	(232597, 121, '2014-03-01 01:02:20.000000', 'temperatura', 225.0000, 'ºC'),
	(232598, 121, '2014-03-01 01:02:21.000000', 'temperatura', 331.0000, 'ºC'),
	(232599, 121, '2014-03-01 01:02:22.000000', 'temperatura', 979.0000, 'ºC'),
	(232600, 121, '2014-03-01 01:02:23.000000', 'temperatura', 301.0000, 'ºC'),
	(232601, 121, '2014-03-01 01:02:24.000000', 'temperatura', 969.0000, 'ºC'),
	(232602, 121, '2014-03-01 01:02:25.000000', 'temperatura', 343.0000, 'ºC'),
	(232603, 121, '2014-03-01 01:02:26.000000', 'temperatura', 7.0000, 'ºC'),
	(232604, 121, '2014-03-01 01:02:27.000000', 'temperatura', 207.0000, 'ºC'),
	(232605, 121, '2014-03-01 01:02:28.000000', 'temperatura', 1016.0000, 'ºC'),
	(232606, 121, '2014-03-01 01:02:29.000000', 'temperatura', 860.0000, 'ºC'),
	(232607, 121, '2014-03-01 01:02:30.000000', 'temperatura', 52.0000, 'ºC'),
	(232608, 121, '2014-03-01 01:02:31.000000', 'temperatura', 78.0000, 'ºC'),
	(232609, 121, '2014-03-01 01:02:32.000000', 'temperatura', 237.0000, 'ºC'),
	(232610, 121, '2014-03-01 01:02:33.000000', 'temperatura', 949.0000, 'ºC'),
	(232611, 121, '2014-03-01 01:02:34.000000', 'temperatura', 435.0000, 'ºC'),
	(232612, 121, '2014-03-01 01:02:35.000000', 'temperatura', 529.0000, 'ºC'),
	(232613, 121, '2014-03-01 01:02:36.000000', 'temperatura', 140.0000, 'ºC'),
	(232614, 121, '2014-03-01 01:02:37.000000', 'temperatura', 315.0000, 'ºC'),
	(232615, 121, '2014-03-01 01:02:38.000000', 'temperatura', 1155.0000, 'ºC'),
	(232616, 121, '2014-03-01 01:02:39.000000', 'temperatura', 31.0000, 'ºC'),
	(232617, 121, '2014-03-01 01:02:40.000000', 'temperatura', 290.0000, 'ºC'),
	(232618, 121, '2014-03-01 01:02:41.000000', 'temperatura', 158.0000, 'ºC'),
	(232619, 121, '2014-03-01 01:02:42.000000', 'temperatura', 1119.0000, 'ºC'),
	(232620, 121, '2014-03-01 01:02:43.000000', 'temperatura', 324.0000, 'ºC'),
	(232621, 121, '2014-03-01 01:02:44.000000', 'temperatura', 664.0000, 'ºC'),
	(232622, 121, '2014-03-01 01:02:45.000000', 'temperatura', 1147.0000, 'ºC'),
	(232623, 121, '2014-03-01 01:02:46.000000', 'temperatura', 142.0000, 'ºC'),
	(232624, 121, '2014-03-01 01:02:47.000000', 'temperatura', 869.0000, 'ºC'),
	(232625, 121, '2014-03-01 01:02:48.000000', 'temperatura', 322.0000, 'ºC'),
	(232626, 121, '2014-03-01 01:02:49.000000', 'temperatura', 203.0000, 'ºC'),
	(232627, 121, '2014-03-01 01:02:50.000000', 'temperatura', 49.0000, 'ºC'),
	(232628, 121, '2014-03-01 01:02:51.000000', 'temperatura', 837.0000, 'ºC'),
	(232629, 121, '2014-03-01 01:02:52.000000', 'temperatura', 438.0000, 'ºC'),
	(232630, 121, '2014-03-01 01:02:53.000000', 'temperatura', 879.0000, 'ºC'),
	(232631, 121, '2014-03-01 01:02:54.000000', 'temperatura', 681.0000, 'ºC'),
	(232632, 121, '2014-03-01 01:02:55.000000', 'temperatura', 769.0000, 'ºC'),
	(232633, 121, '2014-03-01 01:02:56.000000', 'temperatura', 601.0000, 'ºC'),
	(232634, 121, '2014-03-01 01:02:57.000000', 'temperatura', 698.0000, 'ºC'),
	(232635, 121, '2014-03-01 01:02:58.000000', 'temperatura', 489.0000, 'ºC'),
	(232636, 121, '2014-03-01 01:02:59.000000', 'temperatura', 350.0000, 'ºC'),
	(232637, 121, '2014-03-01 01:03:00.000000', 'temperatura', 283.0000, 'ºC'),
	(232638, 121, '2014-03-01 01:03:01.000000', 'temperatura', 368.0000, 'ºC'),
	(232639, 121, '2014-03-01 01:03:02.000000', 'temperatura', 989.0000, 'ºC'),
	(232640, 121, '2014-03-01 01:03:03.000000', 'temperatura', 244.0000, 'ºC'),
	(232641, 121, '2014-03-01 01:03:04.000000', 'temperatura', 652.0000, 'ºC'),
	(232642, 121, '2014-03-01 01:03:05.000000', 'temperatura', 130.0000, 'ºC'),
	(232643, 121, '2014-03-01 01:03:06.000000', 'temperatura', 1096.0000, 'ºC'),
	(232644, 121, '2014-03-01 01:03:07.000000', 'temperatura', 288.0000, 'ºC'),
	(232645, 121, '2014-03-01 01:03:08.000000', 'temperatura', 552.0000, 'ºC'),
	(232646, 121, '2014-03-01 01:03:09.000000', 'temperatura', 697.0000, 'ºC'),
	(232647, 121, '2014-03-01 01:03:10.000000', 'temperatura', 630.0000, 'ºC'),
	(232648, 121, '2014-03-01 01:03:11.000000', 'temperatura', 1058.0000, 'ºC'),
	(232649, 121, '2014-03-01 01:03:12.000000', 'temperatura', 1001.0000, 'ºC'),
	(232650, 121, '2014-03-01 01:03:13.000000', 'temperatura', 634.0000, 'ºC'),
	(232651, 121, '2014-03-01 01:03:14.000000', 'temperatura', 164.0000, 'ºC'),
	(232652, 121, '2014-03-01 01:03:15.000000', 'temperatura', 120.0000, 'ºC'),
	(232653, 121, '2014-03-01 01:03:16.000000', 'temperatura', 107.0000, 'ºC'),
	(232654, 121, '2014-03-01 01:03:17.000000', 'temperatura', 177.0000, 'ºC'),
	(232655, 121, '2014-03-01 01:03:18.000000', 'temperatura', 564.0000, 'ºC'),
	(232656, 121, '2014-03-01 01:03:19.000000', 'temperatura', 1089.0000, 'ºC'),
	(232657, 121, '2014-03-01 01:03:20.000000', 'temperatura', 155.0000, 'ºC'),
	(232658, 121, '2014-03-01 01:03:21.000000', 'temperatura', 1106.0000, 'ºC'),
	(232659, 121, '2014-03-01 01:03:22.000000', 'temperatura', 267.0000, 'ºC'),
	(232660, 121, '2014-03-01 01:03:23.000000', 'temperatura', 418.0000, 'ºC'),
	(232661, 121, '2014-03-01 01:03:24.000000', 'temperatura', 90.0000, 'ºC'),
	(232662, 121, '2014-03-01 01:03:25.000000', 'temperatura', 395.0000, 'ºC'),
	(232663, 121, '2014-03-01 01:03:26.000000', 'temperatura', 508.0000, 'ºC'),
	(232664, 121, '2014-03-01 01:03:27.000000', 'temperatura', 153.0000, 'ºC'),
	(232665, 121, '2014-03-01 01:03:28.000000', 'temperatura', 441.0000, 'ºC'),
	(232666, 121, '2014-03-01 01:03:29.000000', 'temperatura', 549.0000, 'ºC'),
	(232667, 121, '2014-03-01 01:03:30.000000', 'temperatura', 222.0000, 'ºC'),
	(232668, 121, '2014-03-01 01:03:31.000000', 'temperatura', 663.0000, 'ºC'),
	(232669, 121, '2014-03-01 01:03:32.000000', 'temperatura', 249.0000, 'ºC'),
	(232670, 121, '2014-03-01 01:03:33.000000', 'temperatura', 458.0000, 'ºC'),
	(232671, 121, '2014-03-01 01:03:34.000000', 'temperatura', 343.0000, 'ºC'),
	(232672, 121, '2014-03-01 01:03:35.000000', 'temperatura', 343.0000, 'ºC'),
	(232673, 121, '2014-03-01 01:03:36.000000', 'temperatura', 684.0000, 'ºC'),
	(232674, 121, '2014-03-01 01:03:37.000000', 'temperatura', 1194.0000, 'ºC'),
	(232675, 121, '2014-03-01 01:03:38.000000', 'temperatura', 319.0000, 'ºC'),
	(232676, 121, '2014-03-01 01:03:39.000000', 'temperatura', 414.0000, 'ºC'),
	(232677, 121, '2014-03-01 01:03:40.000000', 'temperatura', 1113.0000, 'ºC'),
	(232678, 121, '2014-03-01 01:03:41.000000', 'temperatura', 722.0000, 'ºC'),
	(232679, 121, '2014-03-01 01:03:42.000000', 'temperatura', 273.0000, 'ºC'),
	(232680, 121, '2014-03-01 01:03:43.000000', 'temperatura', 398.0000, 'ºC'),
	(232681, 121, '2014-03-01 01:03:44.000000', 'temperatura', 1172.0000, 'ºC'),
	(232682, 121, '2014-03-01 01:03:45.000000', 'temperatura', 1066.0000, 'ºC'),
	(232683, 121, '2014-03-01 01:03:46.000000', 'temperatura', 614.0000, 'ºC'),
	(232684, 121, '2014-03-01 01:03:47.000000', 'temperatura', 1074.0000, 'ºC'),
	(232685, 121, '2014-03-01 01:03:48.000000', 'temperatura', 1130.0000, 'ºC'),
	(232686, 121, '2014-03-01 01:03:49.000000', 'temperatura', 25.0000, 'ºC'),
	(232687, 121, '2014-03-01 01:03:50.000000', 'temperatura', 337.0000, 'ºC'),
	(232688, 121, '2014-03-01 01:03:51.000000', 'temperatura', 411.0000, 'ºC'),
	(232689, 121, '2014-03-01 01:03:52.000000', 'temperatura', 1046.0000, 'ºC'),
	(232690, 121, '2014-03-01 01:03:53.000000', 'temperatura', 397.0000, 'ºC'),
	(232691, 121, '2014-03-01 01:03:54.000000', 'temperatura', 45.0000, 'ºC'),
	(232692, 121, '2014-03-01 01:03:55.000000', 'temperatura', 237.0000, 'ºC'),
	(232693, 121, '2014-03-01 01:03:56.000000', 'temperatura', 1049.0000, 'ºC'),
	(232694, 121, '2014-03-01 01:03:57.000000', 'temperatura', 936.0000, 'ºC'),
	(232695, 121, '2014-03-01 01:03:58.000000', 'temperatura', 334.0000, 'ºC'),
	(232696, 121, '2014-03-01 01:03:59.000000', 'temperatura', 61.0000, 'ºC'),
	(232697, 121, '2014-03-01 01:04:00.000000', 'temperatura', 504.0000, 'ºC'),
	(232698, 121, '2014-03-01 01:04:01.000000', 'temperatura', 1139.0000, 'ºC'),
	(232699, 121, '2014-03-01 01:04:02.000000', 'temperatura', 583.0000, 'ºC'),
	(232700, 121, '2014-03-01 01:04:03.000000', 'temperatura', 696.0000, 'ºC'),
	(232701, 121, '2014-03-01 01:04:04.000000', 'temperatura', 534.0000, 'ºC'),
	(232702, 121, '2014-03-01 01:04:05.000000', 'temperatura', 584.0000, 'ºC'),
	(232703, 121, '2014-03-01 01:04:06.000000', 'temperatura', 115.0000, 'ºC'),
	(232704, 121, '2014-03-01 01:04:07.000000', 'temperatura', 26.0000, 'ºC'),
	(232705, 121, '2014-03-01 01:04:08.000000', 'temperatura', 986.0000, 'ºC'),
	(232706, 121, '2014-03-01 01:04:09.000000', 'temperatura', 52.0000, 'ºC'),
	(232707, 121, '2014-03-01 01:04:10.000000', 'temperatura', 900.0000, 'ºC'),
	(232708, 121, '2014-03-01 01:04:11.000000', 'temperatura', 747.0000, 'ºC'),
	(232709, 121, '2014-03-01 01:04:12.000000', 'temperatura', 1034.0000, 'ºC'),
	(232710, 121, '2014-03-01 01:04:13.000000', 'temperatura', 528.0000, 'ºC'),
	(232711, 121, '2014-03-01 01:04:14.000000', 'temperatura', 741.0000, 'ºC'),
	(232712, 121, '2014-03-01 01:04:15.000000', 'temperatura', 919.0000, 'ºC'),
	(232713, 121, '2014-03-01 01:04:16.000000', 'temperatura', 1174.0000, 'ºC'),
	(232714, 121, '2014-03-01 01:04:17.000000', 'temperatura', 712.0000, 'ºC'),
	(232715, 121, '2014-03-01 01:04:18.000000', 'temperatura', 40.0000, 'ºC'),
	(232716, 121, '2014-03-01 01:04:19.000000', 'temperatura', 463.0000, 'ºC'),
	(232717, 121, '2014-03-01 01:04:20.000000', 'temperatura', 996.0000, 'ºC'),
	(232718, 121, '2014-03-01 01:04:21.000000', 'temperatura', 1192.0000, 'ºC'),
	(232719, 121, '2014-03-01 01:04:22.000000', 'temperatura', 570.0000, 'ºC'),
	(232720, 121, '2014-03-01 01:04:23.000000', 'temperatura', 478.0000, 'ºC'),
	(232721, 121, '2014-03-01 01:04:24.000000', 'temperatura', 679.0000, 'ºC'),
	(232722, 121, '2014-03-01 01:04:25.000000', 'temperatura', 761.0000, 'ºC'),
	(232723, 121, '2014-03-01 01:04:26.000000', 'temperatura', 570.0000, 'ºC'),
	(232724, 121, '2014-03-01 01:04:27.000000', 'temperatura', 569.0000, 'ºC'),
	(232725, 121, '2014-03-01 01:04:28.000000', 'temperatura', 1133.0000, 'ºC'),
	(232726, 121, '2014-03-01 01:04:29.000000', 'temperatura', 360.0000, 'ºC'),
	(232727, 121, '2014-03-01 01:04:30.000000', 'temperatura', 799.0000, 'ºC'),
	(232728, 121, '2014-03-01 01:04:31.000000', 'temperatura', 517.0000, 'ºC'),
	(232729, 121, '2014-03-01 01:04:32.000000', 'temperatura', 187.0000, 'ºC'),
	(232730, 121, '2014-03-01 01:04:33.000000', 'temperatura', 584.0000, 'ºC'),
	(232731, 121, '2014-03-01 01:04:34.000000', 'temperatura', 1160.0000, 'ºC'),
	(232732, 121, '2014-03-01 01:04:35.000000', 'temperatura', 450.0000, 'ºC'),
	(232733, 121, '2014-03-01 01:04:36.000000', 'temperatura', 1169.0000, 'ºC'),
	(232734, 121, '2014-03-01 01:04:37.000000', 'temperatura', 896.0000, 'ºC'),
	(232735, 121, '2014-03-01 01:04:38.000000', 'temperatura', 974.0000, 'ºC'),
	(232736, 121, '2014-03-01 01:04:39.000000', 'temperatura', 984.0000, 'ºC'),
	(232737, 121, '2014-03-01 01:04:40.000000', 'temperatura', 796.0000, 'ºC'),
	(232738, 121, '2014-03-01 01:04:41.000000', 'temperatura', 1030.0000, 'ºC'),
	(232739, 121, '2014-03-01 01:04:42.000000', 'temperatura', 361.0000, 'ºC'),
	(232740, 121, '2014-03-01 01:04:43.000000', 'temperatura', 1114.0000, 'ºC'),
	(232741, 121, '2014-03-01 01:04:44.000000', 'temperatura', 891.0000, 'ºC'),
	(232742, 121, '2014-03-01 01:04:45.000000', 'temperatura', 1111.0000, 'ºC'),
	(232743, 121, '2014-03-01 01:04:46.000000', 'temperatura', 484.0000, 'ºC'),
	(232744, 121, '2014-03-01 01:04:47.000000', 'temperatura', 288.0000, 'ºC'),
	(232745, 121, '2014-03-01 01:04:48.000000', 'temperatura', 1186.0000, 'ºC'),
	(232746, 121, '2014-03-01 01:04:49.000000', 'temperatura', 270.0000, 'ºC'),
	(232747, 121, '2014-03-01 01:04:50.000000', 'temperatura', 189.0000, 'ºC'),
	(232748, 121, '2014-03-01 01:04:51.000000', 'temperatura', 138.0000, 'ºC'),
	(232749, 121, '2014-03-01 01:04:52.000000', 'temperatura', 121.0000, 'ºC'),
	(232750, 121, '2014-03-01 01:04:53.000000', 'temperatura', 194.0000, 'ºC'),
	(232751, 121, '2014-03-01 01:04:54.000000', 'temperatura', 608.0000, 'ºC'),
	(232752, 121, '2014-03-01 01:04:55.000000', 'temperatura', 57.0000, 'ºC'),
	(232753, 121, '2014-03-01 01:04:56.000000', 'temperatura', 861.0000, 'ºC'),
	(232754, 121, '2014-03-01 01:04:57.000000', 'temperatura', 533.0000, 'ºC'),
	(232755, 121, '2014-03-01 01:04:58.000000', 'temperatura', 84.0000, 'ºC'),
	(232756, 121, '2014-03-01 01:04:59.000000', 'temperatura', 21.0000, 'ºC'),
	(232757, 121, '2014-03-01 01:05:00.000000', 'temperatura', 1054.0000, 'ºC'),
	(232758, 121, '2014-03-01 01:05:01.000000', 'temperatura', 406.0000, 'ºC'),
	(232759, 121, '2014-03-01 01:05:02.000000', 'temperatura', 71.0000, 'ºC'),
	(232760, 121, '2014-03-01 01:05:03.000000', 'temperatura', 335.0000, 'ºC'),
	(232761, 121, '2014-03-01 01:05:04.000000', 'temperatura', 264.0000, 'ºC'),
	(232762, 121, '2014-03-01 01:05:05.000000', 'temperatura', 317.0000, 'ºC'),
	(232763, 121, '2014-03-01 01:05:06.000000', 'temperatura', 793.0000, 'ºC'),
	(232764, 121, '2014-03-01 01:05:07.000000', 'temperatura', 616.0000, 'ºC'),
	(232765, 121, '2014-03-01 01:05:08.000000', 'temperatura', 699.0000, 'ºC'),
	(232766, 121, '2014-03-01 01:05:09.000000', 'temperatura', 446.0000, 'ºC'),
	(232767, 121, '2014-03-01 01:05:10.000000', 'temperatura', 137.0000, 'ºC'),
	(232768, 121, '2014-03-01 01:05:11.000000', 'temperatura', 546.0000, 'ºC'),
	(232769, 121, '2014-03-01 01:05:12.000000', 'temperatura', 1118.0000, 'ºC'),
	(232770, 121, '2014-03-01 01:05:13.000000', 'temperatura', 352.0000, 'ºC'),
	(232771, 121, '2014-03-01 01:05:14.000000', 'temperatura', 806.0000, 'ºC'),
	(232772, 121, '2014-03-01 01:05:15.000000', 'temperatura', 578.0000, 'ºC'),
	(232773, 121, '2014-03-01 01:05:16.000000', 'temperatura', 469.0000, 'ºC'),
	(232774, 121, '2014-03-01 01:05:17.000000', 'temperatura', 613.0000, 'ºC'),
	(232775, 121, '2014-03-01 01:05:18.000000', 'temperatura', 457.0000, 'ºC'),
	(232776, 121, '2014-03-01 01:05:19.000000', 'temperatura', 447.0000, 'ºC'),
	(232777, 121, '2014-03-01 01:05:20.000000', 'temperatura', 867.0000, 'ºC'),
	(232778, 121, '2014-03-01 01:05:21.000000', 'temperatura', 593.0000, 'ºC'),
	(232779, 121, '2014-03-01 01:05:22.000000', 'temperatura', 363.0000, 'ºC'),
	(232780, 121, '2014-03-01 01:05:23.000000', 'temperatura', 38.0000, 'ºC'),
	(232781, 121, '2014-03-01 01:05:24.000000', 'temperatura', 299.0000, 'ºC'),
	(232782, 121, '2014-03-01 01:05:25.000000', 'temperatura', 183.0000, 'ºC'),
	(232783, 121, '2014-03-01 01:05:26.000000', 'temperatura', 20.0000, 'ºC'),
	(232784, 121, '2014-03-01 01:05:27.000000', 'temperatura', 750.0000, 'ºC'),
	(232785, 121, '2014-03-01 01:05:28.000000', 'temperatura', 92.0000, 'ºC'),
	(232786, 121, '2014-03-01 01:05:29.000000', 'temperatura', 609.0000, 'ºC'),
	(232787, 121, '2014-03-01 01:05:30.000000', 'temperatura', 369.0000, 'ºC'),
	(232788, 121, '2014-03-01 01:05:31.000000', 'temperatura', 21.0000, 'ºC'),
	(232789, 121, '2014-03-01 01:05:32.000000', 'temperatura', 195.0000, 'ºC'),
	(232790, 121, '2014-03-01 01:05:33.000000', 'temperatura', 915.0000, 'ºC'),
	(232791, 121, '2014-03-01 01:05:34.000000', 'temperatura', 389.0000, 'ºC'),
	(232792, 121, '2014-03-01 01:05:35.000000', 'temperatura', 399.0000, 'ºC'),
	(232793, 121, '2014-03-01 01:05:36.000000', 'temperatura', 830.0000, 'ºC'),
	(232794, 121, '2014-03-01 01:05:37.000000', 'temperatura', 555.0000, 'ºC'),
	(232795, 121, '2014-03-01 01:05:38.000000', 'temperatura', 282.0000, 'ºC'),
	(232796, 121, '2014-03-01 01:05:39.000000', 'temperatura', 949.0000, 'ºC'),
	(232797, 121, '2014-03-01 01:05:40.000000', 'temperatura', 298.0000, 'ºC'),
	(232798, 121, '2014-03-01 01:05:41.000000', 'temperatura', 1045.0000, 'ºC'),
	(232799, 121, '2014-03-01 01:05:42.000000', 'temperatura', 731.0000, 'ºC'),
	(232800, 121, '2014-03-01 01:05:43.000000', 'temperatura', 519.0000, 'ºC'),
	(232801, 121, '2014-03-01 01:05:44.000000', 'temperatura', 403.0000, 'ºC'),
	(232802, 121, '2014-03-01 01:05:45.000000', 'temperatura', 460.0000, 'ºC'),
	(232803, 121, '2014-03-01 01:05:46.000000', 'temperatura', 1092.0000, 'ºC'),
	(232804, 121, '2014-03-01 01:05:47.000000', 'temperatura', 480.0000, 'ºC'),
	(232805, 121, '2014-03-01 01:05:48.000000', 'temperatura', 323.0000, 'ºC'),
	(232806, 121, '2014-03-01 01:05:49.000000', 'temperatura', 175.0000, 'ºC'),
	(232807, 121, '2014-03-01 01:05:50.000000', 'temperatura', 1107.0000, 'ºC'),
	(232808, 121, '2014-03-01 01:05:51.000000', 'temperatura', 210.0000, 'ºC'),
	(232809, 121, '2014-03-01 01:05:52.000000', 'temperatura', 130.0000, 'ºC'),
	(232810, 121, '2014-03-01 01:05:53.000000', 'temperatura', 19.0000, 'ºC'),
	(232811, 121, '2014-03-01 01:05:54.000000', 'temperatura', 907.0000, 'ºC'),
	(232812, 121, '2014-03-01 01:05:55.000000', 'temperatura', 880.0000, 'ºC'),
	(232813, 121, '2014-03-01 01:05:56.000000', 'temperatura', 477.0000, 'ºC'),
	(232814, 121, '2014-03-01 01:05:57.000000', 'temperatura', 948.0000, 'ºC'),
	(232815, 121, '2014-03-01 01:05:58.000000', 'temperatura', 907.0000, 'ºC'),
	(232816, 121, '2014-03-01 01:05:59.000000', 'temperatura', 491.0000, 'ºC'),
	(232817, 121, '2014-03-01 01:06:00.000000', 'temperatura', 934.0000, 'ºC'),
	(232818, 121, '2014-03-01 01:06:01.000000', 'temperatura', 798.0000, 'ºC'),
	(232819, 121, '2014-03-01 01:06:02.000000', 'temperatura', 1188.0000, 'ºC'),
	(232820, 121, '2014-03-01 01:06:03.000000', 'temperatura', 1146.0000, 'ºC'),
	(232821, 121, '2014-03-01 01:06:04.000000', 'temperatura', 966.0000, 'ºC'),
	(232822, 121, '2014-03-01 01:06:05.000000', 'temperatura', 191.0000, 'ºC'),
	(232823, 121, '2014-03-01 01:06:06.000000', 'temperatura', 461.0000, 'ºC'),
	(232824, 121, '2014-03-01 01:06:07.000000', 'temperatura', 530.0000, 'ºC'),
	(232825, 121, '2014-03-01 01:06:08.000000', 'temperatura', 67.0000, 'ºC'),
	(232826, 121, '2014-03-01 01:06:09.000000', 'temperatura', 1145.0000, 'ºC'),
	(232827, 121, '2014-03-01 01:06:10.000000', 'temperatura', 724.0000, 'ºC'),
	(232828, 121, '2014-03-01 01:06:11.000000', 'temperatura', 185.0000, 'ºC'),
	(232829, 121, '2014-03-01 01:06:12.000000', 'temperatura', 1154.0000, 'ºC'),
	(232830, 121, '2014-03-01 01:06:13.000000', 'temperatura', 418.0000, 'ºC'),
	(232831, 121, '2014-03-01 01:06:14.000000', 'temperatura', 1026.0000, 'ºC'),
	(232832, 121, '2014-03-01 01:06:15.000000', 'temperatura', 278.0000, 'ºC'),
	(232833, 121, '2014-03-01 01:06:16.000000', 'temperatura', 713.0000, 'ºC'),
	(232834, 121, '2014-03-01 01:06:17.000000', 'temperatura', 332.0000, 'ºC'),
	(232835, 121, '2014-03-01 01:06:18.000000', 'temperatura', 722.0000, 'ºC'),
	(232836, 121, '2014-03-01 01:06:19.000000', 'temperatura', 213.0000, 'ºC'),
	(232837, 121, '2014-03-01 01:06:20.000000', 'temperatura', 102.0000, 'ºC'),
	(232838, 121, '2014-03-01 01:06:21.000000', 'temperatura', 1068.0000, 'ºC'),
	(232839, 121, '2014-03-01 01:06:22.000000', 'temperatura', 236.0000, 'ºC'),
	(232840, 121, '2014-03-01 01:06:23.000000', 'temperatura', 376.0000, 'ºC'),
	(232841, 121, '2014-03-01 01:06:24.000000', 'temperatura', 1173.0000, 'ºC'),
	(232842, 121, '2014-03-01 01:06:25.000000', 'temperatura', 1139.0000, 'ºC'),
	(232843, 121, '2014-03-01 01:06:26.000000', 'temperatura', 977.0000, 'ºC'),
	(232844, 121, '2014-03-01 01:06:27.000000', 'temperatura', 268.0000, 'ºC'),
	(232845, 121, '2014-03-01 01:06:28.000000', 'temperatura', 807.0000, 'ºC'),
	(232846, 121, '2014-03-01 01:06:29.000000', 'temperatura', 835.0000, 'ºC'),
	(232847, 121, '2014-03-01 01:06:30.000000', 'temperatura', 553.0000, 'ºC'),
	(232848, 121, '2014-03-01 01:06:31.000000', 'temperatura', 260.0000, 'ºC'),
	(232849, 121, '2014-03-01 01:06:32.000000', 'temperatura', 844.0000, 'ºC'),
	(232850, 121, '2014-03-01 01:06:33.000000', 'temperatura', 1037.0000, 'ºC'),
	(232851, 121, '2014-03-01 01:06:34.000000', 'temperatura', 256.0000, 'ºC'),
	(232852, 121, '2014-03-01 01:06:35.000000', 'temperatura', 570.0000, 'ºC'),
	(232853, 121, '2014-03-01 01:06:36.000000', 'temperatura', 880.0000, 'ºC'),
	(232854, 121, '2014-03-01 01:06:37.000000', 'temperatura', 293.0000, 'ºC'),
	(232855, 121, '2014-03-01 01:06:38.000000', 'temperatura', 24.0000, 'ºC'),
	(232856, 121, '2014-03-01 01:06:39.000000', 'temperatura', 443.0000, 'ºC'),
	(232857, 121, '2014-03-01 01:06:40.000000', 'temperatura', 944.0000, 'ºC'),
	(232858, 121, '2014-03-01 01:06:41.000000', 'temperatura', 993.0000, 'ºC'),
	(232859, 121, '2014-03-01 01:06:42.000000', 'temperatura', 931.0000, 'ºC'),
	(232860, 121, '2014-03-01 01:06:43.000000', 'temperatura', 476.0000, 'ºC'),
	(232861, 121, '2014-03-01 01:06:44.000000', 'temperatura', 787.0000, 'ºC'),
	(232862, 121, '2014-03-01 01:06:45.000000', 'temperatura', 107.0000, 'ºC'),
	(232863, 121, '2014-03-01 01:06:46.000000', 'temperatura', 577.0000, 'ºC'),
	(232864, 121, '2014-03-01 01:06:47.000000', 'temperatura', 165.0000, 'ºC'),
	(232865, 121, '2014-03-01 01:06:48.000000', 'temperatura', 293.0000, 'ºC'),
	(232866, 121, '2014-03-01 01:06:49.000000', 'temperatura', 969.0000, 'ºC'),
	(232867, 121, '2014-03-01 01:06:50.000000', 'temperatura', 368.0000, 'ºC'),
	(232868, 121, '2014-03-01 01:06:51.000000', 'temperatura', 134.0000, 'ºC'),
	(232869, 121, '2014-03-01 01:06:52.000000', 'temperatura', 765.0000, 'ºC'),
	(232870, 121, '2014-03-01 01:06:53.000000', 'temperatura', 1026.0000, 'ºC'),
	(232871, 121, '2014-03-01 01:06:54.000000', 'temperatura', 434.0000, 'ºC'),
	(232872, 121, '2014-03-01 01:06:55.000000', 'temperatura', 292.0000, 'ºC'),
	(232873, 121, '2014-03-01 01:06:56.000000', 'temperatura', 158.0000, 'ºC'),
	(232874, 121, '2014-03-01 01:06:57.000000', 'temperatura', 1114.0000, 'ºC'),
	(232875, 121, '2014-03-01 01:06:58.000000', 'temperatura', 297.0000, 'ºC'),
	(232876, 121, '2014-03-01 01:06:59.000000', 'temperatura', 544.0000, 'ºC'),
	(232877, 121, '2014-03-01 01:07:00.000000', 'temperatura', 628.0000, 'ºC'),
	(232878, 121, '2014-03-01 01:07:01.000000', 'temperatura', 311.0000, 'ºC'),
	(232879, 121, '2014-03-01 01:07:02.000000', 'temperatura', 871.0000, 'ºC'),
	(232880, 121, '2014-03-01 01:07:03.000000', 'temperatura', 1022.0000, 'ºC'),
	(232881, 121, '2014-03-01 01:07:04.000000', 'temperatura', 99.0000, 'ºC'),
	(232882, 121, '2014-03-01 01:07:05.000000', 'temperatura', 1028.0000, 'ºC'),
	(232883, 121, '2014-03-01 01:07:06.000000', 'temperatura', 45.0000, 'ºC'),
	(232884, 121, '2014-03-01 01:07:07.000000', 'temperatura', 739.0000, 'ºC'),
	(232885, 121, '2014-03-01 01:07:08.000000', 'temperatura', 1162.0000, 'ºC'),
	(232886, 121, '2014-03-01 01:07:09.000000', 'temperatura', 1195.0000, 'ºC'),
	(232887, 121, '2014-03-01 01:07:10.000000', 'temperatura', 87.0000, 'ºC'),
	(232888, 121, '2014-03-01 01:07:11.000000', 'temperatura', 450.0000, 'ºC'),
	(232889, 121, '2014-03-01 01:07:12.000000', 'temperatura', 789.0000, 'ºC'),
	(232890, 121, '2014-03-01 01:07:13.000000', 'temperatura', 195.0000, 'ºC'),
	(232891, 121, '2014-03-01 01:07:14.000000', 'temperatura', 1011.0000, 'ºC'),
	(232892, 121, '2014-03-01 01:07:15.000000', 'temperatura', 869.0000, 'ºC'),
	(232893, 121, '2014-03-01 01:07:16.000000', 'temperatura', 111.0000, 'ºC'),
	(232894, 121, '2014-03-01 01:07:17.000000', 'temperatura', 351.0000, 'ºC'),
	(232895, 121, '2014-03-01 01:07:18.000000', 'temperatura', 221.0000, 'ºC'),
	(232896, 121, '2014-03-01 01:07:19.000000', 'temperatura', 55.0000, 'ºC'),
	(232897, 121, '2014-03-01 01:07:20.000000', 'temperatura', 810.0000, 'ºC'),
	(232898, 121, '2014-03-01 01:07:21.000000', 'temperatura', 285.0000, 'ºC'),
	(232899, 121, '2014-03-01 01:07:22.000000', 'temperatura', 198.0000, 'ºC'),
	(232900, 121, '2014-03-01 01:07:23.000000', 'temperatura', 134.0000, 'ºC'),
	(232901, 121, '2014-03-01 01:07:24.000000', 'temperatura', 76.0000, 'ºC'),
	(232902, 121, '2014-03-01 01:07:25.000000', 'temperatura', 1177.0000, 'ºC'),
	(232903, 121, '2014-03-01 01:07:26.000000', 'temperatura', 861.0000, 'ºC'),
	(232904, 121, '2014-03-01 01:07:27.000000', 'temperatura', 771.0000, 'ºC'),
	(232905, 121, '2014-03-01 01:07:28.000000', 'temperatura', 75.0000, 'ºC'),
	(232906, 121, '2014-03-01 01:07:29.000000', 'temperatura', 463.0000, 'ºC'),
	(232907, 121, '2014-03-01 01:07:30.000000', 'temperatura', 890.0000, 'ºC'),
	(232908, 121, '2014-03-01 01:07:31.000000', 'temperatura', 659.0000, 'ºC'),
	(232909, 121, '2014-03-01 01:07:32.000000', 'temperatura', 629.0000, 'ºC'),
	(232910, 121, '2014-03-01 01:07:33.000000', 'temperatura', 1167.0000, 'ºC'),
	(232911, 121, '2014-03-01 01:07:34.000000', 'temperatura', 347.0000, 'ºC'),
	(232912, 121, '2014-03-01 01:07:35.000000', 'temperatura', 637.0000, 'ºC'),
	(232913, 121, '2014-03-01 01:07:36.000000', 'temperatura', 942.0000, 'ºC'),
	(232914, 121, '2014-03-01 01:07:37.000000', 'temperatura', 401.0000, 'ºC'),
	(232915, 121, '2014-03-01 01:07:38.000000', 'temperatura', 380.0000, 'ºC'),
	(232916, 121, '2014-03-01 01:07:39.000000', 'temperatura', 695.0000, 'ºC'),
	(232917, 121, '2014-03-01 01:07:40.000000', 'temperatura', 1136.0000, 'ºC'),
	(232918, 121, '2014-03-01 01:07:41.000000', 'temperatura', 1198.0000, 'ºC'),
	(232919, 121, '2014-03-01 01:07:42.000000', 'temperatura', 181.0000, 'ºC'),
	(232920, 121, '2014-03-01 01:07:43.000000', 'temperatura', 912.0000, 'ºC'),
	(232921, 121, '2014-03-01 01:07:44.000000', 'temperatura', 417.0000, 'ºC'),
	(232922, 121, '2014-03-01 01:07:45.000000', 'temperatura', 551.0000, 'ºC'),
	(232923, 121, '2014-03-01 01:07:46.000000', 'temperatura', 304.0000, 'ºC'),
	(232924, 121, '2014-03-01 01:07:47.000000', 'temperatura', 1069.0000, 'ºC'),
	(232925, 121, '2014-03-01 01:07:48.000000', 'temperatura', 830.0000, 'ºC'),
	(232926, 121, '2014-03-01 01:07:49.000000', 'temperatura', 946.0000, 'ºC'),
	(232927, 121, '2014-03-01 01:07:50.000000', 'temperatura', 1039.0000, 'ºC'),
	(232928, 121, '2014-03-01 01:07:51.000000', 'temperatura', 1159.0000, 'ºC'),
	(232929, 121, '2014-03-01 01:07:52.000000', 'temperatura', 280.0000, 'ºC'),
	(232930, 121, '2014-03-01 01:07:53.000000', 'temperatura', 322.0000, 'ºC'),
	(232931, 121, '2014-03-01 01:07:54.000000', 'temperatura', 769.0000, 'ºC'),
	(232932, 121, '2014-03-01 01:07:55.000000', 'temperatura', 479.0000, 'ºC'),
	(232933, 121, '2014-03-01 01:07:56.000000', 'temperatura', 88.0000, 'ºC'),
	(232934, 121, '2014-03-01 01:07:57.000000', 'temperatura', 205.0000, 'ºC'),
	(232935, 121, '2014-03-01 01:07:58.000000', 'temperatura', 763.0000, 'ºC'),
	(232936, 121, '2014-03-01 01:07:59.000000', 'temperatura', 799.0000, 'ºC'),
	(232937, 121, '2014-03-01 01:08:00.000000', 'temperatura', 506.0000, 'ºC'),
	(232938, 121, '2014-03-01 01:08:01.000000', 'temperatura', 132.0000, 'ºC'),
	(232939, 121, '2014-03-01 01:08:02.000000', 'temperatura', 344.0000, 'ºC'),
	(232940, 121, '2014-03-01 01:08:03.000000', 'temperatura', 124.0000, 'ºC'),
	(232941, 121, '2014-03-01 01:08:04.000000', 'temperatura', 790.0000, 'ºC'),
	(232942, 121, '2014-03-01 01:08:05.000000', 'temperatura', 1176.0000, 'ºC'),
	(232943, 121, '2014-03-01 01:08:06.000000', 'temperatura', 1112.0000, 'ºC'),
	(232944, 121, '2014-03-01 01:08:07.000000', 'temperatura', 833.0000, 'ºC'),
	(232945, 121, '2014-03-01 01:08:08.000000', 'temperatura', 828.0000, 'ºC'),
	(232946, 121, '2014-03-01 01:08:09.000000', 'temperatura', 444.0000, 'ºC'),
	(232947, 121, '2014-03-01 01:08:10.000000', 'temperatura', 935.0000, 'ºC'),
	(232948, 121, '2014-03-01 01:08:11.000000', 'temperatura', 944.0000, 'ºC'),
	(232949, 121, '2014-03-01 01:08:12.000000', 'temperatura', 714.0000, 'ºC'),
	(232950, 121, '2014-03-01 01:08:13.000000', 'temperatura', 740.0000, 'ºC'),
	(232951, 121, '2014-03-01 01:08:14.000000', 'temperatura', 358.0000, 'ºC'),
	(232952, 121, '2014-03-01 01:08:15.000000', 'temperatura', 770.0000, 'ºC'),
	(232953, 121, '2014-03-01 01:08:16.000000', 'temperatura', 377.0000, 'ºC'),
	(232954, 121, '2014-03-01 01:08:17.000000', 'temperatura', 777.0000, 'ºC'),
	(232955, 121, '2014-03-01 01:08:18.000000', 'temperatura', 354.0000, 'ºC'),
	(232956, 121, '2014-03-01 01:08:19.000000', 'temperatura', 639.0000, 'ºC'),
	(232957, 121, '2014-03-01 01:08:20.000000', 'temperatura', 935.0000, 'ºC'),
	(232958, 121, '2014-03-01 01:08:21.000000', 'temperatura', 358.0000, 'ºC'),
	(232959, 121, '2014-03-01 01:08:22.000000', 'temperatura', 186.0000, 'ºC'),
	(232960, 121, '2014-03-01 01:08:23.000000', 'temperatura', 1057.0000, 'ºC'),
	(232961, 121, '2014-03-01 01:08:24.000000', 'temperatura', 1129.0000, 'ºC'),
	(232962, 121, '2014-03-01 01:08:25.000000', 'temperatura', 72.0000, 'ºC'),
	(232963, 121, '2014-03-01 01:08:26.000000', 'temperatura', 574.0000, 'ºC'),
	(232964, 121, '2014-03-01 01:08:27.000000', 'temperatura', 254.0000, 'ºC'),
	(232965, 121, '2014-03-01 01:08:28.000000', 'temperatura', 747.0000, 'ºC'),
	(232966, 121, '2014-03-01 01:08:29.000000', 'temperatura', 576.0000, 'ºC'),
	(232967, 121, '2014-03-01 01:08:30.000000', 'temperatura', 639.0000, 'ºC'),
	(232968, 121, '2014-03-01 01:08:31.000000', 'temperatura', 269.0000, 'ºC'),
	(232969, 121, '2014-03-01 01:08:32.000000', 'temperatura', 626.0000, 'ºC'),
	(232970, 121, '2014-03-01 01:08:33.000000', 'temperatura', 1122.0000, 'ºC'),
	(232971, 121, '2014-03-01 01:08:34.000000', 'temperatura', 136.0000, 'ºC'),
	(232972, 121, '2014-03-01 01:08:35.000000', 'temperatura', 912.0000, 'ºC'),
	(232973, 121, '2014-03-01 01:08:36.000000', 'temperatura', 553.0000, 'ºC'),
	(232974, 121, '2014-03-01 01:08:37.000000', 'temperatura', 28.0000, 'ºC'),
	(232975, 121, '2014-03-01 01:08:38.000000', 'temperatura', 882.0000, 'ºC'),
	(232976, 121, '2014-03-01 01:08:39.000000', 'temperatura', 729.0000, 'ºC'),
	(232977, 121, '2014-03-01 01:08:40.000000', 'temperatura', 998.0000, 'ºC'),
	(232978, 121, '2014-03-01 01:08:41.000000', 'temperatura', 403.0000, 'ºC'),
	(232979, 121, '2014-03-01 01:08:42.000000', 'temperatura', 222.0000, 'ºC'),
	(232980, 121, '2014-03-01 01:08:43.000000', 'temperatura', 1103.0000, 'ºC'),
	(232981, 121, '2014-03-01 01:08:44.000000', 'temperatura', 49.0000, 'ºC'),
	(232982, 121, '2014-03-01 01:08:45.000000', 'temperatura', 538.0000, 'ºC'),
	(232983, 121, '2014-03-01 01:08:46.000000', 'temperatura', 140.0000, 'ºC'),
	(232984, 121, '2014-03-01 01:08:47.000000', 'temperatura', 289.0000, 'ºC'),
	(232985, 121, '2014-03-01 01:08:48.000000', 'temperatura', 1024.0000, 'ºC'),
	(232986, 121, '2014-03-01 01:08:49.000000', 'temperatura', 654.0000, 'ºC'),
	(232987, 121, '2014-03-01 01:08:50.000000', 'temperatura', 198.0000, 'ºC'),
	(232988, 121, '2014-03-01 01:08:51.000000', 'temperatura', 230.0000, 'ºC'),
	(232989, 121, '2014-03-01 01:08:52.000000', 'temperatura', 554.0000, 'ºC'),
	(232990, 121, '2014-03-01 01:08:53.000000', 'temperatura', 883.0000, 'ºC'),
	(232991, 121, '2014-03-01 01:08:54.000000', 'temperatura', 353.0000, 'ºC'),
	(232992, 121, '2014-03-01 01:08:55.000000', 'temperatura', 317.0000, 'ºC'),
	(232993, 121, '2014-03-01 01:08:56.000000', 'temperatura', 525.0000, 'ºC'),
	(232994, 121, '2014-03-01 01:08:57.000000', 'temperatura', 474.0000, 'ºC'),
	(232995, 121, '2014-03-01 01:08:58.000000', 'temperatura', 796.0000, 'ºC'),
	(232996, 121, '2014-03-01 01:08:59.000000', 'temperatura', 157.0000, 'ºC'),
	(232997, 121, '2014-03-01 01:09:00.000000', 'temperatura', 798.0000, 'ºC'),
	(232998, 121, '2014-03-01 01:09:01.000000', 'temperatura', 1120.0000, 'ºC'),
	(232999, 121, '2014-03-01 01:09:02.000000', 'temperatura', 806.0000, 'ºC'),
	(233000, 121, '2014-03-01 01:09:03.000000', 'temperatura', 673.0000, 'ºC'),
	(233001, 121, '2014-03-01 01:09:04.000000', 'temperatura', 944.0000, 'ºC'),
	(233002, 121, '2014-03-01 01:09:05.000000', 'temperatura', 303.0000, 'ºC'),
	(233003, 121, '2014-03-01 01:09:06.000000', 'temperatura', 1082.0000, 'ºC'),
	(233004, 121, '2014-03-01 01:09:07.000000', 'temperatura', 902.0000, 'ºC'),
	(233005, 121, '2014-03-01 01:09:08.000000', 'temperatura', 66.0000, 'ºC'),
	(233006, 121, '2014-03-01 01:09:09.000000', 'temperatura', 25.0000, 'ºC'),
	(233007, 121, '2014-03-01 01:09:10.000000', 'temperatura', 1126.0000, 'ºC'),
	(233008, 121, '2014-03-01 01:09:11.000000', 'temperatura', 757.0000, 'ºC'),
	(233009, 121, '2014-03-01 01:09:12.000000', 'temperatura', 406.0000, 'ºC'),
	(233010, 121, '2014-03-01 01:09:13.000000', 'temperatura', 960.0000, 'ºC'),
	(233011, 121, '2014-03-01 01:09:14.000000', 'temperatura', 1184.0000, 'ºC'),
	(233012, 121, '2014-03-01 01:09:15.000000', 'temperatura', 641.0000, 'ºC'),
	(233013, 121, '2014-03-01 01:09:16.000000', 'temperatura', 853.0000, 'ºC'),
	(233014, 121, '2014-03-01 01:09:17.000000', 'temperatura', 1142.0000, 'ºC'),
	(233015, 121, '2014-03-01 01:09:18.000000', 'temperatura', 751.0000, 'ºC'),
	(233016, 121, '2014-03-01 01:09:19.000000', 'temperatura', 332.0000, 'ºC'),
	(233017, 121, '2014-03-01 01:09:20.000000', 'temperatura', 605.0000, 'ºC'),
	(233018, 121, '2014-03-01 01:09:21.000000', 'temperatura', 828.0000, 'ºC'),
	(233019, 121, '2014-03-01 01:09:22.000000', 'temperatura', 1129.0000, 'ºC'),
	(233020, 121, '2014-03-01 01:09:23.000000', 'temperatura', 760.0000, 'ºC'),
	(233021, 121, '2014-03-01 01:09:24.000000', 'temperatura', 412.0000, 'ºC'),
	(233022, 121, '2014-03-01 01:09:25.000000', 'temperatura', 981.0000, 'ºC'),
	(233023, 121, '2014-03-01 01:09:26.000000', 'temperatura', 69.0000, 'ºC'),
	(233024, 121, '2014-03-01 01:09:27.000000', 'temperatura', 1003.0000, 'ºC'),
	(233025, 121, '2014-03-01 01:09:28.000000', 'temperatura', 8.0000, 'ºC'),
	(233026, 121, '2014-03-01 01:09:29.000000', 'temperatura', 632.0000, 'ºC'),
	(233027, 121, '2014-03-01 01:09:30.000000', 'temperatura', 736.0000, 'ºC'),
	(233028, 121, '2014-03-01 01:09:31.000000', 'temperatura', 584.0000, 'ºC'),
	(233029, 121, '2014-03-01 01:09:32.000000', 'temperatura', 711.0000, 'ºC'),
	(233030, 121, '2014-03-01 01:09:33.000000', 'temperatura', 606.0000, 'ºC'),
	(233031, 121, '2014-03-01 01:09:34.000000', 'temperatura', 896.0000, 'ºC'),
	(233032, 121, '2014-03-01 01:09:35.000000', 'temperatura', 264.0000, 'ºC'),
	(233033, 121, '2014-03-01 01:09:36.000000', 'temperatura', 1030.0000, 'ºC'),
	(233034, 121, '2014-03-01 01:09:37.000000', 'temperatura', 761.0000, 'ºC'),
	(233035, 121, '2014-03-01 01:09:38.000000', 'temperatura', 717.0000, 'ºC'),
	(233036, 121, '2014-03-01 01:09:39.000000', 'temperatura', 99.0000, 'ºC'),
	(233037, 121, '2014-03-01 01:09:40.000000', 'temperatura', 747.0000, 'ºC'),
	(233038, 121, '2014-03-01 01:09:41.000000', 'temperatura', 1038.0000, 'ºC'),
	(233039, 121, '2014-03-01 01:09:42.000000', 'temperatura', 548.0000, 'ºC'),
	(233040, 121, '2014-03-01 01:09:43.000000', 'temperatura', 826.0000, 'ºC'),
	(233041, 121, '2014-03-01 01:09:44.000000', 'temperatura', 87.0000, 'ºC'),
	(233042, 121, '2014-03-01 01:09:45.000000', 'temperatura', 357.0000, 'ºC'),
	(233043, 121, '2014-03-01 01:09:46.000000', 'temperatura', 324.0000, 'ºC'),
	(233044, 121, '2014-03-01 01:09:47.000000', 'temperatura', 551.0000, 'ºC'),
	(233045, 121, '2014-03-01 01:09:48.000000', 'temperatura', 583.0000, 'ºC'),
	(233046, 121, '2014-03-01 01:09:49.000000', 'temperatura', 64.0000, 'ºC'),
	(233047, 121, '2014-03-01 01:09:50.000000', 'temperatura', 972.0000, 'ºC'),
	(233048, 121, '2014-03-01 01:09:51.000000', 'temperatura', 1066.0000, 'ºC'),
	(233049, 121, '2014-03-01 01:09:52.000000', 'temperatura', 15.0000, 'ºC'),
	(233050, 121, '2014-03-01 01:09:53.000000', 'temperatura', 476.0000, 'ºC'),
	(233051, 121, '2014-03-01 01:09:54.000000', 'temperatura', 1137.0000, 'ºC'),
	(233052, 121, '2014-03-01 01:09:55.000000', 'temperatura', 656.0000, 'ºC'),
	(233053, 121, '2014-03-01 01:09:56.000000', 'temperatura', 1073.0000, 'ºC'),
	(233054, 121, '2014-03-01 01:09:57.000000', 'temperatura', 994.0000, 'ºC'),
	(233055, 121, '2014-03-01 01:09:58.000000', 'temperatura', 551.0000, 'ºC'),
	(233056, 121, '2014-03-01 01:09:59.000000', 'temperatura', 975.0000, 'ºC'),
	(233057, 121, '2014-03-01 01:10:00.000000', 'temperatura', 822.0000, 'ºC'),
	(233058, 121, '2014-03-01 01:10:01.000000', 'temperatura', 1186.0000, 'ºC'),
	(233059, 121, '2014-03-01 01:10:02.000000', 'temperatura', 1066.0000, 'ºC'),
	(233060, 121, '2014-03-01 01:10:03.000000', 'temperatura', 570.0000, 'ºC'),
	(233061, 121, '2014-03-01 01:10:04.000000', 'temperatura', 855.0000, 'ºC'),
	(233062, 121, '2014-03-01 01:10:05.000000', 'temperatura', 163.0000, 'ºC'),
	(233063, 121, '2014-03-01 01:10:06.000000', 'temperatura', 653.0000, 'ºC'),
	(233064, 121, '2014-03-01 01:10:07.000000', 'temperatura', 373.0000, 'ºC'),
	(233065, 121, '2014-03-01 01:10:08.000000', 'temperatura', 1110.0000, 'ºC'),
	(233066, 121, '2014-03-01 01:10:09.000000', 'temperatura', 830.0000, 'ºC'),
	(233067, 121, '2014-03-01 01:10:10.000000', 'temperatura', 819.0000, 'ºC'),
	(233068, 121, '2014-03-01 01:10:11.000000', 'temperatura', 408.0000, 'ºC'),
	(233069, 121, '2014-03-01 01:10:12.000000', 'temperatura', 783.0000, 'ºC'),
	(233070, 121, '2014-03-01 01:10:13.000000', 'temperatura', 292.0000, 'ºC'),
	(233071, 121, '2014-03-01 01:10:14.000000', 'temperatura', 312.0000, 'ºC'),
	(233072, 121, '2014-03-01 01:10:15.000000', 'temperatura', 683.0000, 'ºC'),
	(233073, 121, '2014-03-01 01:10:16.000000', 'temperatura', 81.0000, 'ºC'),
	(233074, 121, '2014-03-01 01:10:17.000000', 'temperatura', 758.0000, 'ºC'),
	(233075, 121, '2014-03-01 01:10:18.000000', 'temperatura', 1146.0000, 'ºC'),
	(233076, 121, '2014-03-01 01:10:19.000000', 'temperatura', 1055.0000, 'ºC'),
	(233077, 121, '2014-03-01 01:10:20.000000', 'temperatura', 637.0000, 'ºC'),
	(233078, 121, '2014-03-01 01:10:21.000000', 'temperatura', 22.0000, 'ºC'),
	(233079, 121, '2014-03-01 01:10:22.000000', 'temperatura', 600.0000, 'ºC'),
	(233080, 121, '2014-03-01 01:10:23.000000', 'temperatura', 533.0000, 'ºC'),
	(233081, 121, '2014-03-01 01:10:24.000000', 'temperatura', 866.0000, 'ºC'),
	(233082, 121, '2014-03-01 01:10:25.000000', 'temperatura', 333.0000, 'ºC'),
	(233083, 121, '2014-03-01 01:10:26.000000', 'temperatura', 265.0000, 'ºC'),
	(233084, 121, '2014-03-01 01:10:27.000000', 'temperatura', 327.0000, 'ºC'),
	(233085, 121, '2014-03-01 01:10:28.000000', 'temperatura', 843.0000, 'ºC'),
	(233086, 121, '2014-03-01 01:10:29.000000', 'temperatura', 831.0000, 'ºC'),
	(233087, 121, '2014-03-01 01:10:30.000000', 'temperatura', 429.0000, 'ºC'),
	(233088, 121, '2014-03-01 01:10:31.000000', 'temperatura', 850.0000, 'ºC'),
	(233089, 121, '2014-03-01 01:10:32.000000', 'temperatura', 566.0000, 'ºC'),
	(233090, 121, '2014-03-01 01:10:33.000000', 'temperatura', 280.0000, 'ºC'),
	(233091, 121, '2014-03-01 01:10:34.000000', 'temperatura', 903.0000, 'ºC'),
	(233092, 121, '2014-03-01 01:10:35.000000', 'temperatura', 74.0000, 'ºC'),
	(233093, 121, '2014-03-01 01:10:36.000000', 'temperatura', 62.0000, 'ºC'),
	(233094, 121, '2014-03-01 01:10:37.000000', 'temperatura', 87.0000, 'ºC'),
	(233095, 121, '2014-03-01 01:10:38.000000', 'temperatura', 249.0000, 'ºC'),
	(233096, 121, '2014-03-01 01:10:39.000000', 'temperatura', 986.0000, 'ºC'),
	(233097, 121, '2014-03-01 01:10:40.000000', 'temperatura', 583.0000, 'ºC'),
	(233098, 121, '2014-03-01 01:10:41.000000', 'temperatura', 1159.0000, 'ºC'),
	(233099, 121, '2014-03-01 01:10:42.000000', 'temperatura', 444.0000, 'ºC'),
	(233100, 121, '2014-03-01 01:10:43.000000', 'temperatura', 1145.0000, 'ºC'),
	(233101, 121, '2014-03-01 01:10:44.000000', 'temperatura', 793.0000, 'ºC'),
	(233102, 121, '2014-03-01 01:10:45.000000', 'temperatura', 532.0000, 'ºC'),
	(233103, 121, '2014-03-01 01:10:46.000000', 'temperatura', 279.0000, 'ºC'),
	(233104, 121, '2014-03-01 01:10:47.000000', 'temperatura', 1001.0000, 'ºC'),
	(233105, 121, '2014-03-01 01:10:48.000000', 'temperatura', 569.0000, 'ºC'),
	(233106, 121, '2014-03-01 01:10:49.000000', 'temperatura', 1041.0000, 'ºC'),
	(233107, 121, '2014-03-01 01:10:50.000000', 'temperatura', 1097.0000, 'ºC'),
	(233108, 121, '2014-03-01 01:10:51.000000', 'temperatura', 1166.0000, 'ºC'),
	(233109, 121, '2014-03-01 01:10:52.000000', 'temperatura', 138.0000, 'ºC'),
	(233110, 121, '2014-03-01 01:10:53.000000', 'temperatura', 794.0000, 'ºC'),
	(233111, 121, '2014-03-01 01:10:54.000000', 'temperatura', 1156.0000, 'ºC'),
	(233112, 121, '2014-03-01 01:10:55.000000', 'temperatura', 1000.0000, 'ºC'),
	(233113, 121, '2014-03-01 01:10:56.000000', 'temperatura', 332.0000, 'ºC'),
	(233114, 121, '2014-03-01 01:10:57.000000', 'temperatura', 1060.0000, 'ºC'),
	(233115, 121, '2014-03-01 01:10:58.000000', 'temperatura', 706.0000, 'ºC'),
	(233116, 121, '2014-03-01 01:10:59.000000', 'temperatura', 350.0000, 'ºC'),
	(233117, 121, '2014-03-01 01:11:00.000000', 'temperatura', 831.0000, 'ºC'),
	(233118, 121, '2014-03-01 01:11:01.000000', 'temperatura', 704.0000, 'ºC'),
	(233119, 121, '2014-03-01 01:11:02.000000', 'temperatura', 1031.0000, 'ºC'),
	(233120, 121, '2014-03-01 01:11:03.000000', 'temperatura', 641.0000, 'ºC'),
	(233121, 121, '2014-03-01 01:11:04.000000', 'temperatura', 112.0000, 'ºC'),
	(233122, 121, '2014-03-01 01:11:05.000000', 'temperatura', 1039.0000, 'ºC'),
	(233123, 121, '2014-03-01 01:11:06.000000', 'temperatura', 58.0000, 'ºC'),
	(233124, 121, '2014-03-01 01:11:07.000000', 'temperatura', 773.0000, 'ºC'),
	(233125, 121, '2014-03-01 01:11:08.000000', 'temperatura', 92.0000, 'ºC'),
	(233126, 121, '2014-03-01 01:11:09.000000', 'temperatura', 542.0000, 'ºC'),
	(233127, 121, '2014-03-01 01:11:10.000000', 'temperatura', 33.0000, 'ºC'),
	(233128, 121, '2014-03-01 01:11:11.000000', 'temperatura', 942.0000, 'ºC'),
	(233129, 121, '2014-03-01 01:11:12.000000', 'temperatura', 1011.0000, 'ºC'),
	(233130, 121, '2014-03-01 01:11:13.000000', 'temperatura', 1028.0000, 'ºC'),
	(233131, 121, '2014-03-01 01:11:14.000000', 'temperatura', 907.0000, 'ºC'),
	(233132, 121, '2014-03-01 01:11:15.000000', 'temperatura', 254.0000, 'ºC'),
	(233133, 121, '2014-03-01 01:11:16.000000', 'temperatura', 949.0000, 'ºC'),
	(233134, 121, '2014-03-01 01:11:17.000000', 'temperatura', 382.0000, 'ºC'),
	(233135, 121, '2014-03-01 01:11:18.000000', 'temperatura', 264.0000, 'ºC'),
	(233136, 121, '2014-03-01 01:11:19.000000', 'temperatura', 173.0000, 'ºC'),
	(233137, 121, '2014-03-01 01:11:20.000000', 'temperatura', 73.0000, 'ºC'),
	(233138, 121, '2014-03-01 01:11:21.000000', 'temperatura', 1049.0000, 'ºC'),
	(233139, 121, '2014-03-01 01:11:22.000000', 'temperatura', 226.0000, 'ºC'),
	(233140, 121, '2014-03-01 01:11:23.000000', 'temperatura', 381.0000, 'ºC'),
	(233141, 121, '2014-03-01 01:11:24.000000', 'temperatura', 30.0000, 'ºC'),
	(233142, 121, '2014-03-01 01:11:25.000000', 'temperatura', 206.0000, 'ºC'),
	(233143, 121, '2014-03-01 01:11:26.000000', 'temperatura', 939.0000, 'ºC'),
	(233144, 121, '2014-03-01 01:11:27.000000', 'temperatura', 480.0000, 'ºC'),
	(233145, 121, '2014-03-01 01:11:28.000000', 'temperatura', 785.0000, 'ºC'),
	(233146, 121, '2014-03-01 01:11:29.000000', 'temperatura', 83.0000, 'ºC'),
	(233147, 121, '2014-03-01 01:11:30.000000', 'temperatura', 463.0000, 'ºC'),
	(233148, 121, '2014-03-01 01:11:31.000000', 'temperatura', 863.0000, 'ºC'),
	(233149, 121, '2014-03-01 01:11:32.000000', 'temperatura', 529.0000, 'ºC'),
	(233150, 121, '2014-03-01 01:11:33.000000', 'temperatura', 55.0000, 'ºC'),
	(233151, 121, '2014-03-01 01:11:34.000000', 'temperatura', 1087.0000, 'ºC'),
	(233152, 121, '2014-03-01 01:11:35.000000', 'temperatura', 474.0000, 'ºC'),
	(233153, 121, '2014-03-01 01:11:36.000000', 'temperatura', 306.0000, 'ºC'),
	(233154, 121, '2014-03-01 01:11:37.000000', 'temperatura', 111.0000, 'ºC'),
	(233155, 121, '2014-03-01 01:11:38.000000', 'temperatura', 836.0000, 'ºC'),
	(233156, 121, '2014-03-01 01:11:39.000000', 'temperatura', 250.0000, 'ºC'),
	(233157, 121, '2014-03-01 01:11:40.000000', 'temperatura', 1142.0000, 'ºC'),
	(233158, 121, '2014-03-01 01:11:41.000000', 'temperatura', 159.0000, 'ºC'),
	(233159, 121, '2014-03-01 01:11:42.000000', 'temperatura', 971.0000, 'ºC'),
	(233160, 121, '2014-03-01 01:11:43.000000', 'temperatura', 778.0000, 'ºC'),
	(233161, 121, '2014-03-01 01:11:44.000000', 'temperatura', 975.0000, 'ºC'),
	(233162, 121, '2014-03-01 01:11:45.000000', 'temperatura', 145.0000, 'ºC'),
	(233163, 121, '2014-03-01 01:11:46.000000', 'temperatura', 200.0000, 'ºC'),
	(233164, 121, '2014-03-01 01:11:47.000000', 'temperatura', 564.0000, 'ºC'),
	(233165, 121, '2014-03-01 01:11:48.000000', 'temperatura', 1021.0000, 'ºC'),
	(233166, 121, '2014-03-01 01:11:49.000000', 'temperatura', 1013.0000, 'ºC'),
	(233167, 121, '2014-03-01 01:11:50.000000', 'temperatura', 805.0000, 'ºC'),
	(233168, 121, '2014-03-01 01:11:51.000000', 'temperatura', 985.0000, 'ºC'),
	(233169, 121, '2014-03-01 01:11:52.000000', 'temperatura', 112.0000, 'ºC'),
	(233170, 121, '2014-03-01 01:11:53.000000', 'temperatura', 6.0000, 'ºC'),
	(233171, 121, '2014-03-01 01:11:54.000000', 'temperatura', 893.0000, 'ºC'),
	(233172, 121, '2014-03-01 01:11:55.000000', 'temperatura', 848.0000, 'ºC'),
	(233173, 121, '2014-03-01 01:11:56.000000', 'temperatura', 362.0000, 'ºC'),
	(233174, 121, '2014-03-01 01:11:57.000000', 'temperatura', 465.0000, 'ºC'),
	(233175, 121, '2014-03-01 01:11:58.000000', 'temperatura', 41.0000, 'ºC'),
	(233176, 121, '2014-03-01 01:11:59.000000', 'temperatura', 12.0000, 'ºC'),
	(233177, 121, '2014-03-01 01:12:00.000000', 'temperatura', 1134.0000, 'ºC'),
	(233178, 121, '2014-03-01 01:12:01.000000', 'temperatura', 838.0000, 'ºC'),
	(233179, 121, '2014-03-01 01:12:02.000000', 'temperatura', 786.0000, 'ºC'),
	(233180, 121, '2014-03-01 01:12:03.000000', 'temperatura', 219.0000, 'ºC'),
	(233181, 121, '2014-03-01 01:12:04.000000', 'temperatura', 1138.0000, 'ºC'),
	(233182, 121, '2014-03-01 01:12:05.000000', 'temperatura', 232.0000, 'ºC'),
	(233183, 121, '2014-03-01 01:12:06.000000', 'temperatura', 145.0000, 'ºC'),
	(233184, 121, '2014-03-01 01:12:07.000000', 'temperatura', 30.0000, 'ºC'),
	(233185, 121, '2014-03-01 01:12:08.000000', 'temperatura', 918.0000, 'ºC'),
	(233186, 121, '2014-03-01 01:12:09.000000', 'temperatura', 899.0000, 'ºC'),
	(233187, 121, '2014-03-01 01:12:10.000000', 'temperatura', 540.0000, 'ºC'),
	(233188, 121, '2014-03-01 01:12:11.000000', 'temperatura', 5.0000, 'ºC'),
	(233189, 121, '2014-03-01 01:12:12.000000', 'temperatura', 806.0000, 'ºC'),
	(233190, 121, '2014-03-01 01:12:13.000000', 'temperatura', 416.0000, 'ºC'),
	(233191, 121, '2014-03-01 01:12:14.000000', 'temperatura', 862.0000, 'ºC'),
	(233192, 121, '2014-03-01 01:12:15.000000', 'temperatura', 661.0000, 'ºC'),
	(233193, 121, '2014-03-01 01:12:16.000000', 'temperatura', 722.0000, 'ºC'),
	(233194, 121, '2014-03-01 01:12:17.000000', 'temperatura', 426.0000, 'ºC'),
	(233195, 121, '2014-03-01 01:12:18.000000', 'temperatura', 1166.0000, 'ºC'),
	(233196, 121, '2014-03-01 01:12:19.000000', 'temperatura', 950.0000, 'ºC'),
	(233197, 121, '2014-03-01 01:12:20.000000', 'temperatura', 56.0000, 'ºC'),
	(233198, 121, '2014-03-01 01:12:21.000000', 'temperatura', 1027.0000, 'ºC'),
	(233199, 121, '2014-03-01 01:12:22.000000', 'temperatura', 170.0000, 'ºC'),
	(233200, 121, '2014-03-01 01:12:23.000000', 'temperatura', 168.0000, 'ºC'),
	(233201, 121, '2014-03-01 01:12:24.000000', 'temperatura', 332.0000, 'ºC'),
	(233202, 121, '2014-03-01 01:12:25.000000', 'temperatura', 1158.0000, 'ºC'),
	(233203, 121, '2014-03-01 01:12:26.000000', 'temperatura', 1192.0000, 'ºC'),
	(233204, 121, '2014-03-01 01:12:27.000000', 'temperatura', 88.0000, 'ºC'),
	(233205, 121, '2014-03-01 01:12:28.000000', 'temperatura', 465.0000, 'ºC'),
	(233206, 121, '2014-03-01 01:12:29.000000', 'temperatura', 861.0000, 'ºC'),
	(233207, 121, '2014-03-01 01:12:30.000000', 'temperatura', 509.0000, 'ºC'),
	(233208, 121, '2014-03-01 01:12:31.000000', 'temperatura', 1165.0000, 'ºC'),
	(233209, 121, '2014-03-01 01:12:32.000000', 'temperatura', 698.0000, 'ºC'),
	(233210, 121, '2014-03-01 01:12:33.000000', 'temperatura', 1197.0000, 'ºC'),
	(233211, 121, '2014-03-01 01:12:34.000000', 'temperatura', 291.0000, 'ºC'),
	(233212, 121, '2014-03-01 01:12:35.000000', 'temperatura', 263.0000, 'ºC'),
	(233213, 121, '2014-03-01 01:12:36.000000', 'temperatura', 441.0000, 'ºC'),
	(233214, 121, '2014-03-01 01:12:37.000000', 'temperatura', 220.0000, 'ºC'),
	(233215, 121, '2014-03-01 01:12:38.000000', 'temperatura', 974.0000, 'ºC'),
	(233216, 121, '2014-03-01 01:12:39.000000', 'temperatura', 612.0000, 'ºC'),
	(233217, 121, '2014-03-01 01:12:40.000000', 'temperatura', 141.0000, 'ºC'),
	(233218, 121, '2014-03-01 01:12:41.000000', 'temperatura', 66.0000, 'ºC'),
	(233219, 121, '2014-03-01 01:12:42.000000', 'temperatura', 1109.0000, 'ºC'),
	(233220, 121, '2014-03-01 01:12:43.000000', 'temperatura', 547.0000, 'ºC'),
	(233221, 121, '2014-03-01 01:12:44.000000', 'temperatura', 608.0000, 'ºC'),
	(233222, 121, '2014-03-01 01:12:45.000000', 'temperatura', 202.0000, 'ºC'),
	(233223, 121, '2014-03-01 01:12:46.000000', 'temperatura', 384.0000, 'ºC'),
	(233224, 121, '2014-03-01 01:12:47.000000', 'temperatura', 116.0000, 'ºC'),
	(233225, 121, '2014-03-01 01:12:48.000000', 'temperatura', 630.0000, 'ºC'),
	(233226, 121, '2014-03-01 01:12:49.000000', 'temperatura', 399.0000, 'ºC'),
	(233227, 121, '2014-03-01 01:12:50.000000', 'temperatura', 109.0000, 'ºC'),
	(233228, 121, '2014-03-01 01:12:51.000000', 'temperatura', 546.0000, 'ºC'),
	(233229, 121, '2014-03-01 01:12:52.000000', 'temperatura', 3.0000, 'ºC'),
	(233230, 121, '2014-03-01 01:12:53.000000', 'temperatura', 780.0000, 'ºC'),
	(233231, 121, '2014-03-01 01:12:54.000000', 'temperatura', 292.0000, 'ºC'),
	(233232, 121, '2014-03-01 01:12:55.000000', 'temperatura', 318.0000, 'ºC'),
	(233233, 121, '2014-03-01 01:12:56.000000', 'temperatura', 715.0000, 'ºC'),
	(233234, 121, '2014-03-01 01:12:57.000000', 'temperatura', 224.0000, 'ºC'),
	(233235, 121, '2014-03-01 01:12:58.000000', 'temperatura', 172.0000, 'ºC'),
	(233236, 121, '2014-03-01 01:12:59.000000', 'temperatura', 189.0000, 'ºC'),
	(233237, 121, '2014-03-01 01:13:00.000000', 'temperatura', 431.0000, 'ºC'),
	(233238, 121, '2014-03-01 01:13:01.000000', 'temperatura', 388.0000, 'ºC'),
	(233239, 121, '2014-03-01 01:13:02.000000', 'temperatura', 648.0000, 'ºC'),
	(233240, 121, '2014-03-01 01:13:03.000000', 'temperatura', 874.0000, 'ºC'),
	(233241, 121, '2014-03-01 01:13:04.000000', 'temperatura', 30.0000, 'ºC'),
	(233242, 121, '2014-03-01 01:13:05.000000', 'temperatura', 1128.0000, 'ºC'),
	(233243, 121, '2014-03-01 01:13:06.000000', 'temperatura', 748.0000, 'ºC'),
	(233244, 121, '2014-03-01 01:13:07.000000', 'temperatura', 357.0000, 'ºC'),
	(233245, 121, '2014-03-01 01:13:08.000000', 'temperatura', 742.0000, 'ºC'),
	(233246, 121, '2014-03-01 01:13:09.000000', 'temperatura', 241.0000, 'ºC'),
	(233247, 121, '2014-03-01 01:13:10.000000', 'temperatura', 178.0000, 'ºC'),
	(233248, 121, '2014-03-01 01:13:11.000000', 'temperatura', 167.0000, 'ºC'),
	(233249, 121, '2014-03-01 01:13:12.000000', 'temperatura', 303.0000, 'ºC'),
	(233250, 121, '2014-03-01 01:13:13.000000', 'temperatura', 1015.0000, 'ºC'),
	(233251, 121, '2014-03-01 01:13:14.000000', 'temperatura', 566.0000, 'ºC'),
	(233252, 121, '2014-03-01 01:13:15.000000', 'temperatura', 984.0000, 'ºC'),
	(233253, 121, '2014-03-01 01:13:16.000000', 'temperatura', 822.0000, 'ºC'),
	(233254, 121, '2014-03-01 01:13:17.000000', 'temperatura', 1160.0000, 'ºC'),
	(233255, 121, '2014-03-01 01:13:18.000000', 'temperatura', 935.0000, 'ºC'),
	(233256, 121, '2014-03-01 01:13:19.000000', 'temperatura', 1194.0000, 'ºC'),
	(233257, 121, '2014-03-01 01:13:20.000000', 'temperatura', 767.0000, 'ºC'),
	(233258, 121, '2014-03-01 01:13:21.000000', 'temperatura', 252.0000, 'ºC'),
	(233259, 121, '2014-03-01 01:13:22.000000', 'temperatura', 160.0000, 'ºC'),
	(233260, 121, '2014-03-01 01:13:23.000000', 'temperatura', 46.0000, 'ºC'),
	(233261, 121, '2014-03-01 01:13:24.000000', 'temperatura', 951.0000, 'ºC'),
	(233262, 121, '2014-03-01 01:13:25.000000', 'temperatura', 1016.0000, 'ºC'),
	(233263, 121, '2014-03-01 01:13:26.000000', 'temperatura', 1026.0000, 'ºC'),
	(233264, 121, '2014-03-01 01:13:27.000000', 'temperatura', 883.0000, 'ºC'),
	(233265, 121, '2014-03-01 01:13:28.000000', 'temperatura', 138.0000, 'ºC'),
	(233266, 121, '2014-03-01 01:13:29.000000', 'temperatura', 441.0000, 'ºC'),
	(233267, 121, '2014-03-01 01:13:30.000000', 'temperatura', 591.0000, 'ºC'),
	(233268, 121, '2014-03-01 01:13:31.000000', 'temperatura', 434.0000, 'ºC'),
	(233269, 121, '2014-03-01 01:13:32.000000', 'temperatura', 398.0000, 'ºC'),
	(233270, 121, '2014-03-01 01:13:33.000000', 'temperatura', 686.0000, 'ºC'),
	(233271, 121, '2014-03-01 01:13:34.000000', 'temperatura', 1039.0000, 'ºC'),
	(233272, 121, '2014-03-01 01:13:35.000000', 'temperatura', 734.0000, 'ºC'),
	(233273, 121, '2014-03-01 01:13:36.000000', 'temperatura', 557.0000, 'ºC'),
	(233274, 121, '2014-03-01 01:13:37.000000', 'temperatura', 584.0000, 'ºC'),
	(233275, 121, '2014-03-01 01:13:38.000000', 'temperatura', 47.0000, 'ºC'),
	(233276, 121, '2014-03-01 01:13:39.000000', 'temperatura', 885.0000, 'ºC'),
	(233277, 121, '2014-03-01 01:13:40.000000', 'temperatura', 683.0000, 'ºC'),
	(233278, 121, '2014-03-01 01:13:41.000000', 'temperatura', 761.0000, 'ºC'),
	(233279, 121, '2014-03-01 01:13:42.000000', 'temperatura', 556.0000, 'ºC'),
	(233280, 121, '2014-03-01 01:13:43.000000', 'temperatura', 498.0000, 'ºC'),
	(233281, 121, '2014-03-01 01:13:44.000000', 'temperatura', 824.0000, 'ºC'),
	(233282, 121, '2014-03-01 01:13:45.000000', 'temperatura', 227.0000, 'ºC'),
	(233283, 121, '2014-03-01 01:13:46.000000', 'temperatura', 1061.0000, 'ºC'),
	(233284, 121, '2014-03-01 01:13:47.000000', 'temperatura', 1027.0000, 'ºC'),
	(233285, 121, '2014-03-01 01:13:48.000000', 'temperatura', 752.0000, 'ºC'),
	(233286, 121, '2014-03-01 01:13:49.000000', 'temperatura', 679.0000, 'ºC'),
	(233287, 121, '2014-03-01 01:13:50.000000', 'temperatura', 1138.0000, 'ºC'),
	(233288, 121, '2014-03-01 01:13:51.000000', 'temperatura', 55.0000, 'ºC'),
	(233289, 121, '2014-03-01 01:13:52.000000', 'temperatura', 462.0000, 'ºC'),
	(233290, 121, '2014-03-01 01:13:53.000000', 'temperatura', 945.0000, 'ºC'),
	(233291, 121, '2014-03-01 01:13:54.000000', 'temperatura', 941.0000, 'ºC'),
	(233292, 121, '2014-03-01 01:13:55.000000', 'temperatura', 667.0000, 'ºC'),
	(233293, 121, '2014-03-01 01:13:56.000000', 'temperatura', 516.0000, 'ºC'),
	(233294, 121, '2014-03-01 01:13:57.000000', 'temperatura', 579.0000, 'ºC'),
	(233295, 121, '2014-03-01 01:13:58.000000', 'temperatura', 148.0000, 'ºC'),
	(233296, 121, '2014-03-01 01:13:59.000000', 'temperatura', 204.0000, 'ºC'),
	(233297, 121, '2014-03-01 01:14:00.000000', 'temperatura', 575.0000, 'ºC'),
	(233298, 121, '2014-03-01 01:14:01.000000', 'temperatura', 1062.0000, 'ºC'),
	(233299, 121, '2014-03-01 01:14:02.000000', 'temperatura', 1188.0000, 'ºC'),
	(233300, 121, '2014-03-01 01:14:03.000000', 'temperatura', 353.0000, 'ºC'),
	(233301, 121, '2014-03-01 01:14:04.000000', 'temperatura', 600.0000, 'ºC'),
	(233302, 121, '2014-03-01 01:14:05.000000', 'temperatura', 744.0000, 'ºC'),
	(233303, 121, '2014-03-01 01:14:06.000000', 'temperatura', 718.0000, 'ºC'),
	(233304, 121, '2014-03-01 01:14:07.000000', 'temperatura', 159.0000, 'ºC'),
	(233305, 121, '2014-03-01 01:14:08.000000', 'temperatura', 1044.0000, 'ºC'),
	(233306, 121, '2014-03-01 01:14:09.000000', 'temperatura', 1141.0000, 'ºC'),
	(233307, 121, '2014-03-01 01:14:10.000000', 'temperatura', 173.0000, 'ºC'),
	(233308, 121, '2014-03-01 01:14:11.000000', 'temperatura', 1043.0000, 'ºC'),
	(233309, 121, '2014-03-01 01:14:12.000000', 'temperatura', 1097.0000, 'ºC'),
	(233310, 121, '2014-03-01 01:14:13.000000', 'temperatura', 1155.0000, 'ºC'),
	(233311, 121, '2014-03-01 01:14:14.000000', 'temperatura', 86.0000, 'ºC'),
	(233312, 121, '2014-03-01 01:14:15.000000', 'temperatura', 564.0000, 'ºC'),
	(233313, 121, '2014-03-01 01:14:16.000000', 'temperatura', 165.0000, 'ºC'),
	(233314, 121, '2014-03-01 01:14:17.000000', 'temperatura', 333.0000, 'ºC'),
	(233315, 121, '2014-03-01 01:14:18.000000', 'temperatura', 1168.0000, 'ºC'),
	(233316, 121, '2014-03-01 01:14:19.000000', 'temperatura', 43.0000, 'ºC'),
	(233317, 121, '2014-03-01 01:14:20.000000', 'temperatura', 312.0000, 'ºC'),
	(233318, 121, '2014-03-01 01:14:21.000000', 'temperatura', 231.0000, 'ºC'),
	(233319, 121, '2014-03-01 01:14:22.000000', 'temperatura', 220.0000, 'ºC'),
	(233320, 121, '2014-03-01 01:14:23.000000', 'temperatura', 409.0000, 'ºC'),
	(233321, 121, '2014-03-01 01:14:24.000000', 'temperatura', 185.0000, 'ºC'),
	(233322, 121, '2014-03-01 01:14:25.000000', 'temperatura', 896.0000, 'ºC'),
	(233323, 121, '2014-03-01 01:14:26.000000', 'temperatura', 326.0000, 'ºC'),
	(233324, 121, '2014-03-01 01:14:27.000000', 'temperatura', 145.0000, 'ºC'),
	(233325, 121, '2014-03-01 01:14:28.000000', 'temperatura', 944.0000, 'ºC'),
	(233326, 121, '2014-03-01 01:14:29.000000', 'temperatura', 689.0000, 'ºC'),
	(233327, 121, '2014-03-01 01:14:30.000000', 'temperatura', 610.0000, 'ºC'),
	(233328, 121, '2014-03-01 01:14:31.000000', 'temperatura', 986.0000, 'ºC'),
	(233329, 121, '2014-03-01 01:14:32.000000', 'temperatura', 700.0000, 'ºC'),
	(233330, 121, '2014-03-01 01:14:33.000000', 'temperatura', 544.0000, 'ºC'),
	(233331, 121, '2014-03-01 01:14:34.000000', 'temperatura', 621.0000, 'ºC'),
	(233332, 121, '2014-03-01 01:14:35.000000', 'temperatura', 273.0000, 'ºC'),
	(233333, 121, '2014-03-01 01:14:36.000000', 'temperatura', 700.0000, 'ºC'),
	(233334, 121, '2014-03-01 01:14:37.000000', 'temperatura', 284.0000, 'ºC'),
	(233335, 121, '2014-03-01 01:14:38.000000', 'temperatura', 519.0000, 'ºC'),
	(233336, 121, '2014-03-01 01:14:39.000000', 'temperatura', 543.0000, 'ºC'),
	(233337, 121, '2014-03-01 01:14:40.000000', 'temperatura', 1159.0000, 'ºC'),
	(233338, 121, '2014-03-01 01:14:41.000000', 'temperatura', 567.0000, 'ºC'),
	(233339, 121, '2014-03-01 01:14:42.000000', 'temperatura', 560.0000, 'ºC'),
	(233340, 121, '2014-03-01 01:14:43.000000', 'temperatura', 1097.0000, 'ºC'),
	(233341, 121, '2014-03-01 01:14:44.000000', 'temperatura', 207.0000, 'ºC'),
	(233342, 121, '2014-03-01 01:14:45.000000', 'temperatura', 143.0000, 'ºC'),
	(233343, 121, '2014-03-01 01:14:46.000000', 'temperatura', 95.0000, 'ºC'),
	(233344, 121, '2014-03-01 01:14:47.000000', 'temperatura', 46.0000, 'ºC'),
	(233345, 121, '2014-03-01 01:14:48.000000', 'temperatura', 1144.0000, 'ºC'),
	(233346, 121, '2014-03-01 01:14:49.000000', 'temperatura', 785.0000, 'ºC'),
	(233347, 121, '2014-03-01 01:14:50.000000', 'temperatura', 495.0000, 'ºC'),
	(233348, 121, '2014-03-01 01:14:51.000000', 'temperatura', 118.0000, 'ºC'),
	(233349, 121, '2014-03-01 01:14:52.000000', 'temperatura', 307.0000, 'ºC'),
	(233350, 121, '2014-03-01 01:14:53.000000', 'temperatura', 1181.0000, 'ºC'),
	(233351, 121, '2014-03-01 01:14:54.000000', 'temperatura', 185.0000, 'ºC'),
	(233352, 121, '2014-03-01 01:14:55.000000', 'temperatura', 981.0000, 'ºC'),
	(233353, 121, '2014-03-01 01:14:56.000000', 'temperatura', 752.0000, 'ºC'),
	(233354, 121, '2014-03-01 01:14:57.000000', 'temperatura', 818.0000, 'ºC'),
	(233355, 121, '2014-03-01 01:14:58.000000', 'temperatura', 635.0000, 'ºC'),
	(233356, 121, '2014-03-01 01:14:59.000000', 'temperatura', 722.0000, 'ºC'),
	(233357, 121, '2014-03-01 01:15:00.000000', 'temperatura', 506.0000, 'ºC'),
	(233358, 121, '2014-03-01 01:15:01.000000', 'temperatura', 361.0000, 'ºC'),
	(233359, 121, '2014-03-01 01:15:02.000000', 'temperatura', 291.0000, 'ºC'),
	(233360, 121, '2014-03-01 01:15:03.000000', 'temperatura', 370.0000, 'ºC'),
	(233361, 121, '2014-03-01 01:15:04.000000', 'temperatura', 980.0000, 'ºC'),
	(233362, 121, '2014-03-01 01:15:05.000000', 'temperatura', 188.0000, 'ºC'),
	(233363, 121, '2014-03-01 01:15:06.000000', 'temperatura', 401.0000, 'ºC'),
	(233364, 121, '2014-03-01 01:15:07.000000', 'temperatura', 240.0000, 'ºC'),
	(233365, 121, '2014-03-01 01:15:08.000000', 'temperatura', 1198.0000, 'ºC'),
	(233366, 121, '2014-03-01 01:15:09.000000', 'temperatura', 471.0000, 'ºC'),
	(233367, 121, '2014-03-01 01:15:10.000000', 'temperatura', 1161.0000, 'ºC'),
	(233368, 121, '2014-03-01 01:15:11.000000', 'temperatura', 794.0000, 'ºC'),
	(233369, 121, '2014-03-01 01:15:12.000000', 'temperatura', 485.0000, 'ºC'),
	(233370, 121, '2014-03-01 01:15:13.000000', 'temperatura', 45.0000, 'ºC'),
	(233371, 121, '2014-03-01 01:15:14.000000', 'temperatura', 1170.0000, 'ºC'),
	(233372, 121, '2014-03-01 01:15:15.000000', 'temperatura', 917.0000, 'ºC'),
	(233373, 121, '2014-03-01 01:15:16.000000', 'temperatura', 1074.0000, 'ºC'),
	(233374, 121, '2014-03-01 01:15:17.000000', 'temperatura', 221.0000, 'ºC'),
	(233375, 121, '2014-03-01 01:15:18.000000', 'temperatura', 284.0000, 'ºC'),
	(233376, 121, '2014-03-01 01:15:19.000000', 'temperatura', 755.0000, 'ºC'),
	(233377, 121, '2014-03-01 01:15:20.000000', 'temperatura', 525.0000, 'ºC'),
	(233378, 121, '2014-03-01 01:15:21.000000', 'temperatura', 362.0000, 'ºC'),
	(233379, 121, '2014-03-01 01:15:22.000000', 'temperatura', 234.0000, 'ºC'),
	(233380, 121, '2014-03-01 01:15:23.000000', 'temperatura', 85.0000, 'ºC'),
	(233381, 121, '2014-03-01 01:15:24.000000', 'temperatura', 922.0000, 'ºC'),
	(233382, 121, '2014-03-01 01:15:25.000000', 'temperatura', 758.0000, 'ºC'),
	(233383, 121, '2014-03-01 01:15:26.000000', 'temperatura', 1022.0000, 'ºC'),
	(233384, 121, '2014-03-01 01:15:27.000000', 'temperatura', 439.0000, 'ºC'),
	(233385, 121, '2014-03-01 01:15:28.000000', 'temperatura', 329.0000, 'ºC'),
	(233386, 121, '2014-03-01 01:15:29.000000', 'temperatura', 329.0000, 'ºC'),
	(233387, 121, '2014-03-01 01:15:30.000000', 'temperatura', 658.0000, 'ºC'),
	(233388, 121, '2014-03-01 01:15:31.000000', 'temperatura', 1105.0000, 'ºC'),
	(233389, 121, '2014-03-01 01:15:32.000000', 'temperatura', 1149.0000, 'ºC'),
	(233390, 121, '2014-03-01 01:15:33.000000', 'temperatura', 32.0000, 'ºC'),
	(233391, 121, '2014-03-01 01:15:34.000000', 'temperatura', 314.0000, 'ºC'),
	(233392, 121, '2014-03-01 01:15:35.000000', 'temperatura', 276.0000, 'ºC'),
	(233393, 121, '2014-03-01 01:15:36.000000', 'temperatura', 435.0000, 'ºC'),
	(233394, 121, '2014-03-01 01:15:37.000000', 'temperatura', 150.0000, 'ºC'),
	(233395, 121, '2014-03-01 01:15:38.000000', 'temperatura', 646.0000, 'ºC'),
	(233396, 121, '2014-03-01 01:15:39.000000', 'temperatura', 378.0000, 'ºC'),
	(233397, 121, '2014-03-01 01:15:40.000000', 'temperatura', 1155.0000, 'ºC'),
	(233398, 121, '2014-03-01 01:15:41.000000', 'temperatura', 1042.0000, 'ºC'),
	(233399, 121, '2014-03-01 01:15:42.000000', 'temperatura', 543.0000, 'ºC'),
	(233400, 121, '2014-03-01 01:15:43.000000', 'temperatura', 790.0000, 'ºC'),
	(233401, 121, '2014-03-01 01:15:44.000000', 'temperatura', 1121.0000, 'ºC'),
	(233402, 121, '2014-03-01 01:15:45.000000', 'temperatura', 836.0000, 'ºC'),
	(233403, 121, '2014-03-01 01:15:46.000000', 'temperatura', 819.0000, 'ºC'),
	(233404, 121, '2014-03-01 01:15:47.000000', 'temperatura', 386.0000, 'ºC'),
	(233405, 121, '2014-03-01 01:15:48.000000', 'temperatura', 675.0000, 'ºC'),
	(233406, 121, '2014-03-01 01:15:49.000000', 'temperatura', 1016.0000, 'ºC'),
	(233407, 121, '2014-03-01 01:15:50.000000', 'temperatura', 655.0000, 'ºC'),
	(233408, 121, '2014-03-01 01:15:51.000000', 'temperatura', 227.0000, 'ºC'),
	(233409, 121, '2014-03-01 01:15:52.000000', 'temperatura', 371.0000, 'ºC'),
	(233410, 121, '2014-03-01 01:15:53.000000', 'temperatura', 1175.0000, 'ºC'),
	(233411, 121, '2014-03-01 01:15:54.000000', 'temperatura', 1160.0000, 'ºC'),
	(233412, 121, '2014-03-01 01:15:55.000000', 'temperatura', 1079.0000, 'ºC'),
	(233413, 121, '2014-03-01 01:15:56.000000', 'temperatura', 714.0000, 'ºC'),
	(233414, 121, '2014-03-01 01:15:57.000000', 'temperatura', 334.0000, 'ºC'),
	(233415, 121, '2014-03-01 01:15:58.000000', 'temperatura', 730.0000, 'ºC'),
	(233416, 121, '2014-03-01 01:15:59.000000', 'temperatura', 249.0000, 'ºC'),
	(233417, 121, '2014-03-01 01:16:00.000000', 'temperatura', 254.0000, 'ºC'),
	(233418, 121, '2014-03-01 01:16:01.000000', 'temperatura', 522.0000, 'ºC'),
	(233419, 121, '2014-03-01 01:16:02.000000', 'temperatura', 648.0000, 'ºC'),
	(233420, 121, '2014-03-01 01:16:03.000000', 'temperatura', 476.0000, 'ºC'),
	(233421, 121, '2014-03-01 01:16:04.000000', 'temperatura', 438.0000, 'ºC'),
	(233422, 121, '2014-03-01 01:16:05.000000', 'temperatura', 761.0000, 'ºC'),
	(233423, 121, '2014-03-01 01:16:06.000000', 'temperatura', 92.0000, 'ºC'),
	(233424, 121, '2014-03-01 01:16:07.000000', 'temperatura', 576.0000, 'ºC'),
	(233425, 121, '2014-03-01 01:16:08.000000', 'temperatura', 204.0000, 'ºC'),
	(233426, 121, '2014-03-01 01:16:09.000000', 'temperatura', 491.0000, 'ºC'),
	(233427, 121, '2014-03-01 01:16:10.000000', 'temperatura', 647.0000, 'ºC'),
	(233428, 121, '2014-03-01 01:16:11.000000', 'temperatura', 562.0000, 'ºC'),
	(233429, 121, '2014-03-01 01:16:12.000000', 'temperatura', 871.0000, 'ºC'),
	(233430, 121, '2014-03-01 01:16:13.000000', 'temperatura', 268.0000, 'ºC'),
	(233431, 121, '2014-03-01 01:16:14.000000', 'temperatura', 1127.0000, 'ºC'),
	(233432, 121, '2014-03-01 01:16:15.000000', 'temperatura', 30.0000, 'ºC'),
	(233433, 121, '2014-03-01 01:16:16.000000', 'temperatura', 371.0000, 'ºC'),
	(233434, 121, '2014-03-01 01:16:17.000000', 'temperatura', 564.0000, 'ºC'),
	(233435, 121, '2014-03-01 01:16:18.000000', 'temperatura', 507.0000, 'ºC'),
	(233436, 121, '2014-03-01 01:16:19.000000', 'temperatura', 847.0000, 'ºC'),
	(233437, 121, '2014-03-01 01:16:20.000000', 'temperatura', 311.0000, 'ºC'),
	(233438, 121, '2014-03-01 01:16:21.000000', 'temperatura', 215.0000, 'ºC'),
	(233439, 121, '2014-03-01 01:16:22.000000', 'temperatura', 145.0000, 'ºC'),
	(233440, 121, '2014-03-01 01:16:23.000000', 'temperatura', 77.0000, 'ºC'),
	(233441, 121, '2014-03-01 01:16:24.000000', 'temperatura', 1154.0000, 'ºC'),
	(233442, 121, '2014-03-01 01:16:25.000000', 'temperatura', 738.0000, 'ºC'),
	(233443, 121, '2014-03-01 01:16:26.000000', 'temperatura', 228.0000, 'ºC'),
	(233444, 121, '2014-03-01 01:16:27.000000', 'temperatura', 128.0000, 'ºC'),
	(233445, 121, '2014-03-01 01:16:28.000000', 'temperatura', 1155.0000, 'ºC'),
	(233446, 121, '2014-03-01 01:16:29.000000', 'temperatura', 591.0000, 'ºC'),
	(233447, 121, '2014-03-01 01:16:30.000000', 'temperatura', 692.0000, 'ºC'),
	(233448, 121, '2014-03-01 01:16:31.000000', 'temperatura', 486.0000, 'ºC'),
	(233449, 121, '2014-03-01 01:16:32.000000', 'temperatura', 357.0000, 'ºC'),
	(233450, 121, '2014-03-01 01:16:33.000000', 'temperatura', 326.0000, 'ºC'),
	(233451, 121, '2014-03-01 01:16:34.000000', 'temperatura', 559.0000, 'ºC'),
	(233452, 121, '2014-03-01 01:16:35.000000', 'temperatura', 619.0000, 'ºC'),
	(233453, 121, '2014-03-01 01:16:36.000000', 'temperatura', 219.0000, 'ºC'),
	(233454, 121, '2014-03-01 01:16:37.000000', 'temperatura', 437.0000, 'ºC'),
	(233455, 121, '2014-03-01 01:16:38.000000', 'temperatura', 327.0000, 'ºC'),
	(233456, 121, '2014-03-01 01:16:39.000000', 'temperatura', 327.0000, 'ºC'),
	(233457, 121, '2014-03-01 01:16:40.000000', 'temperatura', 654.0000, 'ºC'),
	(233458, 121, '2014-03-01 01:16:41.000000', 'temperatura', 1087.0000, 'ºC'),
	(233459, 121, '2014-03-01 01:16:42.000000', 'temperatura', 1076.0000, 'ºC'),
	(233460, 121, '2014-03-01 01:16:43.000000', 'temperatura', 919.0000, 'ºC'),
	(233461, 121, '2014-03-01 01:16:44.000000', 'temperatura', 166.0000, 'ºC'),
	(233462, 121, '2014-03-01 01:16:45.000000', 'temperatura', 475.0000, 'ºC'),
	(233463, 121, '2014-03-01 01:16:46.000000', 'temperatura', 678.0000, 'ºC'),
	(233464, 121, '2014-03-01 01:16:47.000000', 'temperatura', 765.0000, 'ºC'),
	(233465, 121, '2014-03-01 01:16:48.000000', 'temperatura', 591.0000, 'ºC'),
	(233466, 121, '2014-03-01 01:16:49.000000', 'temperatura', 663.0000, 'ºC'),
	(233467, 121, '2014-03-01 01:16:50.000000', 'temperatura', 340.0000, 'ºC'),
	(233468, 121, '2014-03-01 01:16:51.000000', 'temperatura', 913.0000, 'ºC'),
	(233469, 121, '2014-03-01 01:16:52.000000', 'temperatura', 1145.0000, 'ºC'),
	(233470, 121, '2014-03-01 01:16:53.000000', 'temperatura', 588.0000, 'ºC'),
	(233471, 121, '2014-03-01 01:16:54.000000', 'temperatura', 704.0000, 'ºC'),
	(233472, 121, '2014-03-01 01:16:55.000000', 'temperatura', 557.0000, 'ºC'),
	(233473, 121, '2014-03-01 01:16:56.000000', 'temperatura', 675.0000, 'ºC'),
	(233474, 121, '2014-03-01 01:16:57.000000', 'temperatura', 502.0000, 'ºC'),
	(233475, 121, '2014-03-01 01:16:58.000000', 'temperatura', 485.0000, 'ºC'),
	(233476, 121, '2014-03-01 01:16:59.000000', 'temperatura', 918.0000, 'ºC'),
	(233477, 121, '2014-03-01 01:17:00.000000', 'temperatura', 739.0000, 'ºC'),
	(233478, 121, '2014-03-01 01:17:01.000000', 'temperatura', 941.0000, 'ºC'),
	(233479, 121, '2014-03-01 01:17:02.000000', 'temperatura', 87.0000, 'ºC'),
	(233480, 121, '2014-03-01 01:17:03.000000', 'temperatura', 12.0000, 'ºC'),
	(233481, 121, '2014-03-01 01:17:04.000000', 'temperatura', 1002.0000, 'ºC'),
	(233482, 121, '2014-03-01 01:17:05.000000', 'temperatura', 174.0000, 'ºC'),
	(233483, 121, '2014-03-01 01:17:06.000000', 'temperatura', 263.0000, 'ºC'),
	(233484, 121, '2014-03-01 01:17:07.000000', 'temperatura', 796.0000, 'ºC'),
	(233485, 121, '2014-03-01 01:17:08.000000', 'temperatura', 790.0000, 'ºC'),
	(233486, 121, '2014-03-01 01:17:09.000000', 'temperatura', 364.0000, 'ºC'),
	(233487, 121, '2014-03-01 01:17:10.000000', 'temperatura', 651.0000, 'ºC'),
	(233488, 121, '2014-03-01 01:17:11.000000', 'temperatura', 963.0000, 'ºC'),
	(233489, 121, '2014-03-01 01:17:12.000000', 'temperatura', 460.0000, 'ºC'),
	(233490, 121, '2014-03-01 01:17:13.000000', 'temperatura', 615.0000, 'ºC'),
	(233491, 121, '2014-03-01 01:17:14.000000', 'temperatura', 494.0000, 'ºC'),
	(233492, 121, '2014-03-01 01:17:15.000000', 'temperatura', 625.0000, 'ºC'),
	(233493, 121, '2014-03-01 01:17:16.000000', 'temperatura', 443.0000, 'ºC'),
	(233494, 121, '2014-03-01 01:17:17.000000', 'temperatura', 342.0000, 'ºC'),
	(233495, 121, '2014-03-01 01:17:18.000000', 'temperatura', 383.0000, 'ºC'),
	(233496, 121, '2014-03-01 01:17:19.000000', 'temperatura', 887.0000, 'ºC'),
	(233497, 121, '2014-03-01 01:17:20.000000', 'temperatura', 888.0000, 'ºC'),
	(233498, 121, '2014-03-01 01:17:21.000000', 'temperatura', 578.0000, 'ºC'),
	(233499, 121, '2014-03-01 01:17:22.000000', 'temperatura', 226.0000, 'ºC'),
	(233500, 121, '2014-03-01 01:17:23.000000', 'temperatura', 597.0000, 'ºC'),
	(233501, 121, '2014-03-01 01:17:24.000000', 'temperatura', 1109.0000, 'ºC'),
	(233502, 121, '2014-03-01 01:17:25.000000', 'temperatura', 152.0000, 'ºC'),
	(233503, 121, '2014-03-01 01:17:26.000000', 'temperatura', 1037.0000, 'ºC'),
	(233504, 121, '2014-03-01 01:17:27.000000', 'temperatura', 1126.0000, 'ºC'),
	(233505, 121, '2014-03-01 01:17:28.000000', 'temperatura', 121.0000, 'ºC'),
	(233506, 121, '2014-03-01 01:17:29.000000', 'temperatura', 827.0000, 'ºC'),
	(233507, 121, '2014-03-01 01:17:30.000000', 'temperatura', 174.0000, 'ºC'),
	(233508, 121, '2014-03-01 01:17:31.000000', 'temperatura', 788.0000, 'ºC'),
	(233509, 121, '2014-03-01 01:17:32.000000', 'temperatura', 1018.0000, 'ºC'),
	(233510, 121, '2014-03-01 01:17:33.000000', 'temperatura', 329.0000, 'ºC'),
	(233511, 121, '2014-03-01 01:17:34.000000', 'temperatura', 991.0000, 'ºC'),
	(233512, 121, '2014-03-01 01:17:35.000000', 'temperatura', 367.0000, 'ºC'),
	(233513, 121, '2014-03-01 01:17:36.000000', 'temperatura', 63.0000, 'ºC'),
	(233514, 121, '2014-03-01 01:17:37.000000', 'temperatura', 416.0000, 'ºC'),
	(233515, 121, '2014-03-01 01:17:38.000000', 'temperatura', 689.0000, 'ºC'),
	(233516, 121, '2014-03-01 01:17:39.000000', 'temperatura', 1000.0000, 'ºC'),
	(233517, 121, '2014-03-01 01:17:40.000000', 'temperatura', 532.0000, 'ºC'),
	(233518, 121, '2014-03-01 01:17:41.000000', 'temperatura', 863.0000, 'ºC'),
	(233519, 121, '2014-03-01 01:17:42.000000', 'temperatura', 318.0000, 'ºC'),
	(233520, 121, '2014-03-01 01:17:43.000000', 'temperatura', 201.0000, 'ºC'),
	(233521, 121, '2014-03-01 01:17:44.000000', 'temperatura', 53.0000, 'ºC'),
	(233522, 121, '2014-03-01 01:17:45.000000', 'temperatura', 864.0000, 'ºC'),
	(233523, 121, '2014-03-01 01:17:46.000000', 'temperatura', 558.0000, 'ºC'),
	(233524, 121, '2014-03-01 01:17:47.000000', 'temperatura', 199.0000, 'ºC'),
	(233525, 121, '2014-03-01 01:17:48.000000', 'temperatura', 521.0000, 'ºC'),
	(233526, 121, '2014-03-01 01:17:49.000000', 'temperatura', 811.0000, 'ºC'),
	(233527, 121, '2014-03-01 01:17:50.000000', 'temperatura', 92.0000, 'ºC'),
	(233528, 121, '2014-03-01 01:17:51.000000', 'temperatura', 428.0000, 'ºC'),
	(233529, 121, '2014-03-01 01:17:52.000000', 'temperatura', 665.0000, 'ºC'),
	(233530, 121, '2014-03-01 01:17:53.000000', 'temperatura', 841.0000, 'ºC'),
	(233531, 121, '2014-03-01 01:17:54.000000', 'temperatura', 1011.0000, 'ºC'),
	(233532, 121, '2014-03-01 01:17:55.000000', 'temperatura', 131.0000, 'ºC'),
	(233533, 121, '2014-03-01 01:17:56.000000', 'temperatura', 22.0000, 'ºC'),
	(233534, 121, '2014-03-01 01:17:57.000000', 'temperatura', 918.0000, 'ºC'),
	(233535, 121, '2014-03-01 01:17:58.000000', 'temperatura', 923.0000, 'ºC'),
	(233536, 121, '2014-03-01 01:17:59.000000', 'temperatura', 664.0000, 'ºC'),
	(233537, 121, '2014-03-01 01:18:00.000000', 'temperatura', 552.0000, 'ºC'),
	(233538, 121, '2014-03-01 01:18:01.000000', 'temperatura', 768.0000, 'ºC'),
	(233539, 121, '2014-03-01 01:18:02.000000', 'temperatura', 985.0000, 'ºC'),
	(233540, 121, '2014-03-01 01:18:03.000000', 'temperatura', 221.0000, 'ºC'),
	(233541, 121, '2014-03-01 01:18:04.000000', 'temperatura', 550.0000, 'ºC'),
	(233542, 121, '2014-03-01 01:18:05.000000', 'temperatura', 887.0000, 'ºC'),
	(233543, 121, '2014-03-01 01:18:06.000000', 'temperatura', 387.0000, 'ºC'),
	(233544, 121, '2014-03-01 01:18:07.000000', 'temperatura', 473.0000, 'ºC'),
	(233545, 121, '2014-03-01 01:18:08.000000', 'temperatura', 4.0000, 'ºC'),
	(233546, 121, '2014-03-01 01:18:09.000000', 'temperatura', 1002.0000, 'ºC'),
	(233547, 121, '2014-03-01 01:18:10.000000', 'temperatura', 200.0000, 'ºC'),
	(233548, 121, '2014-03-01 01:18:11.000000', 'temperatura', 394.0000, 'ºC'),
	(233549, 121, '2014-03-01 01:18:12.000000', 'temperatura', 169.0000, 'ºC'),
	(233550, 121, '2014-03-01 01:18:13.000000', 'temperatura', 864.0000, 'ºC'),
	(233551, 121, '2014-03-01 01:18:14.000000', 'temperatura', 213.0000, 'ºC'),
	(233552, 121, '2014-03-01 01:18:15.000000', 'temperatura', 872.0000, 'ºC'),
	(233553, 121, '2014-03-01 01:18:16.000000', 'temperatura', 123.0000, 'ºC'),
	(233554, 121, '2014-03-01 01:18:17.000000', 'temperatura', 400.0000, 'ºC'),
	(233555, 121, '2014-03-01 01:18:18.000000', 'temperatura', 432.0000, 'ºC'),
	(233556, 121, '2014-03-01 01:18:19.000000', 'temperatura', 960.0000, 'ºC'),
	(233557, 121, '2014-03-01 01:18:20.000000', 'temperatura', 1106.0000, 'ºC'),
	(233558, 121, '2014-03-01 01:18:21.000000', 'temperatura', 250.0000, 'ºC'),
	(233559, 121, '2014-03-01 01:18:22.000000', 'temperatura', 333.0000, 'ºC'),
	(233560, 121, '2014-03-01 01:18:23.000000', 'temperatura', 917.0000, 'ºC'),
	(233561, 121, '2014-03-01 01:18:24.000000', 'temperatura', 1184.0000, 'ºC'),
	(233562, 121, '2014-03-01 01:18:25.000000', 'temperatura', 771.0000, 'ºC'),
	(233563, 121, '2014-03-01 01:18:26.000000', 'temperatura', 302.0000, 'ºC'),
	(233564, 121, '2014-03-01 01:18:27.000000', 'temperatura', 397.0000, 'ºC'),
	(233565, 121, '2014-03-01 01:18:28.000000', 'temperatura', 1081.0000, 'ºC'),
	(233566, 121, '2014-03-01 01:18:29.000000', 'temperatura', 613.0000, 'ºC'),
	(233567, 121, '2014-03-01 01:18:30.000000', 'temperatura', 1021.0000, 'ºC'),
	(233568, 121, '2014-03-01 01:18:31.000000', 'temperatura', 870.0000, 'ºC'),
	(233569, 121, '2014-03-01 01:18:32.000000', 'temperatura', 86.0000, 'ºC'),
	(233570, 121, '2014-03-01 01:18:33.000000', 'temperatura', 221.0000, 'ºC'),
	(233571, 121, '2014-03-01 01:18:34.000000', 'temperatura', 848.0000, 'ºC'),
	(233572, 121, '2014-03-01 01:18:35.000000', 'temperatura', 1179.0000, 'ºC'),
	(233573, 121, '2014-03-01 01:18:36.000000', 'temperatura', 950.0000, 'ºC'),
	(233574, 121, '2014-03-01 01:18:37.000000', 'temperatura', 13.0000, 'ºC'),
	(233575, 121, '2014-03-01 01:18:38.000000', 'temperatura', 815.0000, 'ºC'),
	(233576, 121, '2014-03-01 01:18:39.000000', 'temperatura', 437.0000, 'ºC'),
	(233577, 121, '2014-03-01 01:18:40.000000', 'temperatura', 942.0000, 'ºC'),
	(233578, 121, '2014-03-01 01:18:41.000000', 'temperatura', 999.0000, 'ºC'),
	(233579, 121, '2014-03-01 01:18:42.000000', 'temperatura', 968.0000, 'ºC'),
	(233580, 121, '2014-03-01 01:18:43.000000', 'temperatura', 646.0000, 'ºC'),
	(233581, 121, '2014-03-01 01:18:44.000000', 'temperatura', 324.0000, 'ºC'),
	(233582, 121, '2014-03-01 01:18:45.000000', 'temperatura', 885.0000, 'ºC'),
	(233583, 121, '2014-03-01 01:18:46.000000', 'temperatura', 1051.0000, 'ºC'),
	(233584, 121, '2014-03-01 01:18:47.000000', 'temperatura', 200.0000, 'ºC'),
	(233585, 121, '2014-03-01 01:18:48.000000', 'temperatura', 250.0000, 'ºC'),
	(233586, 121, '2014-03-01 01:18:49.000000', 'temperatura', 648.0000, 'ºC'),
	(233587, 121, '2014-03-01 01:18:50.000000', 'temperatura', 90.0000, 'ºC'),
	(233588, 121, '2014-03-01 01:18:51.000000', 'temperatura', 906.0000, 'ºC'),
	(233589, 121, '2014-03-01 01:18:52.000000', 'temperatura', 662.0000, 'ºC'),
	(233590, 121, '2014-03-01 01:18:53.000000', 'temperatura', 592.0000, 'ºC'),
	(233591, 121, '2014-03-01 01:18:54.000000', 'temperatura', 975.0000, 'ºC'),
	(233592, 121, '2014-03-01 01:18:55.000000', 'temperatura', 698.0000, 'ºC'),
	(233593, 121, '2014-03-01 01:18:56.000000', 'temperatura', 567.0000, 'ºC'),
	(233594, 121, '2014-03-01 01:18:57.000000', 'temperatura', 741.0000, 'ºC'),
	(233595, 121, '2014-03-01 01:18:58.000000', 'temperatura', 806.0000, 'ºC'),
	(233596, 121, '2014-03-01 01:18:59.000000', 'temperatura', 608.0000, 'ºC'),
	(233597, 121, '2014-03-01 01:19:00.000000', 'temperatura', 621.0000, 'ºC'),
	(233598, 121, '2014-03-01 01:19:01.000000', 'temperatura', 81.0000, 'ºC'),
	(233599, 121, '2014-03-01 01:19:02.000000', 'temperatura', 943.0000, 'ºC'),
	(233600, 121, '2014-03-01 01:19:03.000000', 'temperatura', 872.0000, 'ºC'),
	(233601, 121, '2014-03-01 01:19:04.000000', 'temperatura', 330.0000, 'ºC'),
	(233602, 121, '2014-03-01 01:19:05.000000', 'temperatura', 238.0000, 'ºC'),
	(233603, 121, '2014-03-01 01:19:06.000000', 'temperatura', 197.0000, 'ºC'),
	(233604, 121, '2014-03-01 01:19:07.000000', 'temperatura', 273.0000, 'ºC'),
	(233605, 121, '2014-03-01 01:19:08.000000', 'temperatura', 773.0000, 'ºC'),
	(233606, 121, '2014-03-01 01:19:09.000000', 'temperatura', 649.0000, 'ºC'),
	(233607, 121, '2014-03-01 01:19:10.000000', 'temperatura', 927.0000, 'ºC'),
	(233608, 121, '2014-03-01 01:19:11.000000', 'temperatura', 286.0000, 'ºC'),
	(233609, 121, '2014-03-01 01:19:12.000000', 'temperatura', 1051.0000, 'ºC'),
	(233610, 121, '2014-03-01 01:19:13.000000', 'temperatura', 799.0000, 'ºC'),
	(233611, 121, '2014-03-01 01:19:14.000000', 'temperatura', 840.0000, 'ºC'),
	(233612, 121, '2014-03-01 01:19:15.000000', 'temperatura', 605.0000, 'ºC'),
	(233613, 121, '2014-03-01 01:19:16.000000', 'temperatura', 504.0000, 'ºC'),
	(233614, 121, '2014-03-01 01:19:17.000000', 'temperatura', 707.0000, 'ºC'),
	(233615, 121, '2014-03-01 01:19:18.000000', 'temperatura', 823.0000, 'ºC'),
	(233616, 121, '2014-03-01 01:19:19.000000', 'temperatura', 796.0000, 'ºC'),
	(233617, 121, '2014-03-01 01:19:20.000000', 'temperatura', 308.0000, 'ºC'),
	(233618, 121, '2014-03-01 01:19:21.000000', 'temperatura', 356.0000, 'ºC'),
	(233619, 121, '2014-03-01 01:19:22.000000', 'temperatura', 855.0000, 'ºC'),
	(233620, 121, '2014-03-01 01:19:23.000000', 'temperatura', 809.0000, 'ºC'),
	(233621, 121, '2014-03-01 01:19:24.000000', 'temperatura', 280.0000, 'ºC'),
	(233622, 121, '2014-03-01 01:19:25.000000', 'temperatura', 174.0000, 'ºC'),
	(233623, 121, '2014-03-01 01:19:26.000000', 'temperatura', 28.0000, 'ºC'),
	(233624, 121, '2014-03-01 01:19:27.000000', 'temperatura', 821.0000, 'ºC'),
	(233625, 121, '2014-03-01 01:19:28.000000', 'temperatura', 422.0000, 'ºC'),
	(233626, 121, '2014-03-01 01:19:29.000000', 'temperatura', 847.0000, 'ºC'),
	(233627, 121, '2014-03-01 01:19:30.000000', 'temperatura', 569.0000, 'ºC'),
	(233628, 121, '2014-03-01 01:19:31.000000', 'temperatura', 306.0000, 'ºC'),
	(233629, 121, '2014-03-01 01:19:32.000000', 'temperatura', 1022.0000, 'ºC'),
	(233630, 121, '2014-03-01 01:19:33.000000', 'temperatura', 593.0000, 'ºC'),
	(233631, 121, '2014-03-01 01:19:34.000000', 'temperatura', 1099.0000, 'ºC'),
	(233632, 121, '2014-03-01 01:19:35.000000', 'temperatura', 119.0000, 'ºC'),
	(233633, 121, '2014-03-01 01:19:36.000000', 'temperatura', 896.0000, 'ºC'),
	(233634, 121, '2014-03-01 01:19:37.000000', 'temperatura', 523.0000, 'ºC'),
	(233635, 121, '2014-03-01 01:19:38.000000', 'temperatura', 1127.0000, 'ºC'),
	(233636, 121, '2014-03-01 01:19:39.000000', 'temperatura', 470.0000, 'ºC'),
	(233637, 121, '2014-03-01 01:19:40.000000', 'temperatura', 166.0000, 'ºC'),
	(233638, 121, '2014-03-01 01:19:41.000000', 'temperatura', 621.0000, 'ºC'),
	(233639, 121, '2014-03-01 01:19:42.000000', 'temperatura', 207.0000, 'ºC'),
	(233640, 121, '2014-03-01 01:19:43.000000', 'temperatura', 373.0000, 'ºC'),
	(233641, 121, '2014-03-01 01:19:44.000000', 'temperatura', 46.0000, 'ºC'),
	(233642, 121, '2014-03-01 01:19:45.000000', 'temperatura', 309.0000, 'ºC'),
	(233643, 121, '2014-03-01 01:19:46.000000', 'temperatura', 210.0000, 'ºC'),
	(233644, 121, '2014-03-01 01:19:47.000000', 'temperatura', 125.0000, 'ºC'),
	(233645, 121, '2014-03-01 01:19:48.000000', 'temperatura', 1192.0000, 'ºC'),
	(233646, 121, '2014-03-01 01:19:49.000000', 'temperatura', 786.0000, 'ºC'),
	(233647, 121, '2014-03-01 01:19:50.000000', 'temperatura', 355.0000, 'ºC'),
	(233648, 121, '2014-03-01 01:19:51.000000', 'temperatura', 619.0000, 'ºC'),
	(233649, 121, '2014-03-01 01:19:52.000000', 'temperatura', 828.0000, 'ºC'),
	(233650, 121, '2014-03-01 01:19:53.000000', 'temperatura', 1086.0000, 'ºC'),
	(233651, 121, '2014-03-01 01:19:54.000000', 'temperatura', 547.0000, 'ºC'),
	(233652, 121, '2014-03-01 01:19:55.000000', 'temperatura', 675.0000, 'ºC'),
	(233653, 121, '2014-03-01 01:19:56.000000', 'temperatura', 535.0000, 'ºC'),
	(233654, 121, '2014-03-01 01:19:57.000000', 'temperatura', 650.0000, 'ºC'),
	(233655, 121, '2014-03-01 01:19:58.000000', 'temperatura', 446.0000, 'ºC'),
	(233656, 121, '2014-03-01 01:19:59.000000', 'temperatura', 279.0000, 'ºC'),
	(233657, 121, '2014-03-01 01:20:00.000000', 'temperatura', 58.0000, 'ºC'),
	(233658, 121, '2014-03-01 01:20:01.000000', 'temperatura', 656.0000, 'ºC'),
	(233659, 121, '2014-03-01 01:20:02.000000', 'temperatura', 705.0000, 'ºC'),
	(233660, 121, '2014-03-01 01:20:03.000000', 'temperatura', 358.0000, 'ºC'),
	(233661, 121, '2014-03-01 01:20:04.000000', 'temperatura', 876.0000, 'ºC'),
	(233662, 121, '2014-03-01 01:20:05.000000', 'temperatura', 904.0000, 'ºC'),
	(233663, 121, '2014-03-01 01:20:06.000000', 'temperatura', 695.0000, 'ºC'),
	(233664, 121, '2014-03-01 01:20:07.000000', 'temperatura', 761.0000, 'ºC'),
	(233665, 121, '2014-03-01 01:20:08.000000', 'temperatura', 523.0000, 'ºC'),
	(233666, 121, '2014-03-01 01:20:09.000000', 'temperatura', 331.0000, 'ºC'),
	(233667, 121, '2014-03-01 01:20:10.000000', 'temperatura', 88.0000, 'ºC'),
	(233668, 121, '2014-03-01 01:20:11.000000', 'temperatura', 646.0000, 'ºC'),
	(233669, 121, '2014-03-01 01:20:12.000000', 'temperatura', 568.0000, 'ºC'),
	(233670, 121, '2014-03-01 01:20:13.000000', 'temperatura', 901.0000, 'ºC'),
	(233671, 121, '2014-03-01 01:20:14.000000', 'temperatura', 403.0000, 'ºC'),
	(233672, 121, '2014-03-01 01:20:15.000000', 'temperatura', 512.0000, 'ºC'),
	(233673, 121, '2014-03-01 01:20:16.000000', 'temperatura', 153.0000, 'ºC'),
	(233674, 121, '2014-03-01 01:20:17.000000', 'temperatura', 430.0000, 'ºC'),
	(233675, 121, '2014-03-01 01:20:18.000000', 'temperatura', 489.0000, 'ºC'),
	(233676, 121, '2014-03-01 01:20:19.000000', 'temperatura', 1158.0000, 'ºC'),
	(233677, 121, '2014-03-01 01:20:20.000000', 'temperatura', 723.0000, 'ºC'),
	(233678, 121, '2014-03-01 01:20:21.000000', 'temperatura', 142.0000, 'ºC'),
	(233679, 121, '2014-03-01 01:20:22.000000', 'temperatura', 939.0000, 'ºC'),
	(233680, 121, '2014-03-01 01:20:23.000000', 'temperatura', 673.0000, 'ºC'),
	(233681, 121, '2014-03-01 01:20:24.000000', 'temperatura', 546.0000, 'ºC'),
	(233682, 121, '2014-03-01 01:20:25.000000', 'temperatura', 714.0000, 'ºC'),
	(233683, 121, '2014-03-01 01:20:26.000000', 'temperatura', 730.0000, 'ºC'),
	(233684, 121, '2014-03-01 01:20:27.000000', 'temperatura', 308.0000, 'ºC'),
	(233685, 121, '2014-03-01 01:20:28.000000', 'temperatura', 550.0000, 'ºC'),
	(233686, 121, '2014-03-01 01:20:29.000000', 'temperatura', 630.0000, 'ºC'),
	(233687, 121, '2014-03-01 01:20:30.000000', 'temperatura', 297.0000, 'ºC'),
	(233688, 121, '2014-03-01 01:20:31.000000', 'temperatura', 797.0000, 'ºC'),
	(233689, 121, '2014-03-01 01:20:32.000000', 'temperatura', 694.0000, 'ºC'),
	(233690, 121, '2014-03-01 01:20:33.000000', 'temperatura', 1079.0000, 'ºC'),
	(233691, 121, '2014-03-01 01:20:34.000000', 'temperatura', 913.0000, 'ºC'),
	(233692, 121, '2014-03-01 01:20:35.000000', 'temperatura', 130.0000, 'ºC'),
	(233693, 121, '2014-03-01 01:20:36.000000', 'temperatura', 311.0000, 'ºC'),
	(233694, 121, '2014-03-01 01:20:37.000000', 'temperatura', 1164.0000, 'ºC'),
	(233695, 121, '2014-03-01 01:20:38.000000', 'temperatura', 90.0000, 'ºC'),
	(233696, 121, '2014-03-01 01:20:39.000000', 'temperatura', 556.0000, 'ºC'),
	(233697, 121, '2014-03-01 01:20:40.000000', 'temperatura', 111.0000, 'ºC'),
	(233698, 121, '2014-03-01 01:20:41.000000', 'temperatura', 90.0000, 'ºC'),
	(233699, 121, '2014-03-01 01:20:42.000000', 'temperatura', 116.0000, 'ºC'),
	(233700, 121, '2014-03-01 01:20:43.000000', 'temperatura', 309.0000, 'ºC'),
	(233701, 121, '2014-03-01 01:20:44.000000', 'temperatura', 1199.0000, 'ºC'),
	(233702, 121, '2014-03-01 01:20:45.000000', 'temperatura', 267.0000, 'ºC'),
	(233703, 121, '2014-03-01 01:20:46.000000', 'temperatura', 139.0000, 'ºC'),
	(233704, 121, '2014-03-01 01:20:47.000000', 'temperatura', 1096.0000, 'ºC'),
	(233705, 121, '2014-03-01 01:20:48.000000', 'temperatura', 262.0000, 'ºC'),
	(233706, 121, '2014-03-01 01:20:49.000000', 'temperatura', 425.0000, 'ºC'),
	(233707, 121, '2014-03-01 01:20:50.000000', 'temperatura', 138.0000, 'ºC'),
	(233708, 121, '2014-03-01 01:20:51.000000', 'temperatura', 616.0000, 'ºC'),
	(233709, 121, '2014-03-01 01:20:52.000000', 'temperatura', 266.0000, 'ºC'),
	(233710, 121, '2014-03-01 01:20:53.000000', 'temperatura', 681.0000, 'ºC'),
	(233711, 121, '2014-03-01 01:20:54.000000', 'temperatura', 209.0000, 'ºC'),
	(233712, 121, '2014-03-01 01:20:55.000000', 'temperatura', 204.0000, 'ºC'),
	(233713, 121, '2014-03-01 01:20:56.000000', 'temperatura', 393.0000, 'ºC'),
	(233714, 121, '2014-03-01 01:20:57.000000', 'temperatura', 153.0000, 'ºC'),
	(233715, 121, '2014-03-01 01:20:58.000000', 'temperatura', 787.0000, 'ºC'),
	(233716, 121, '2014-03-01 01:20:59.000000', 'temperatura', 1076.0000, 'ºC'),
	(233717, 121, '2014-03-01 01:21:00.000000', 'temperatura', 620.0000, 'ºC'),
	(233718, 121, '2014-03-01 01:21:01.000000', 'temperatura', 1071.0000, 'ºC'),
	(233719, 121, '2014-03-01 01:21:02.000000', 'temperatura', 1095.0000, 'ºC'),
	(233720, 121, '2014-03-01 01:21:03.000000', 'temperatura', 1065.0000, 'ºC'),
	(233721, 121, '2014-03-01 01:21:04.000000', 'temperatura', 839.0000, 'ºC'),
	(233722, 121, '2014-03-01 01:21:05.000000', 'temperatura', 1002.0000, 'ºC'),
	(233723, 121, '2014-03-01 01:21:06.000000', 'temperatura', 94.0000, 'ºC'),
	(233724, 121, '2014-03-01 01:21:07.000000', 'temperatura', 1065.0000, 'ºC'),
	(233725, 121, '2014-03-01 01:21:08.000000', 'temperatura', 241.0000, 'ºC'),
	(233726, 121, '2014-03-01 01:21:09.000000', 'temperatura', 413.0000, 'ºC'),
	(233727, 121, '2014-03-01 01:21:10.000000', 'temperatura', 142.0000, 'ºC'),
	(233728, 121, '2014-03-01 01:21:11.000000', 'temperatura', 673.0000, 'ºC'),
	(233729, 121, '2014-03-01 01:21:12.000000', 'temperatura', 539.0000, 'ºC'),
	(233730, 121, '2014-03-01 01:21:13.000000', 'temperatura', 678.0000, 'ºC'),
	(233731, 121, '2014-03-01 01:21:14.000000', 'temperatura', 571.0000, 'ºC'),
	(233732, 121, '2014-03-01 01:21:15.000000', 'temperatura', 820.0000, 'ºC'),
	(233733, 121, '2014-03-01 01:21:16.000000', 'temperatura', 1191.0000, 'ºC'),
	(233734, 121, '2014-03-01 01:21:17.000000', 'temperatura', 1092.0000, 'ºC'),
	(233735, 121, '2014-03-01 01:21:18.000000', 'temperatura', 690.0000, 'ºC'),
	(233736, 121, '2014-03-01 01:21:19.000000', 'temperatura', 173.0000, 'ºC'),
	(233737, 121, '2014-03-01 01:21:20.000000', 'temperatura', 1197.0000, 'ºC'),
	(233738, 121, '2014-03-01 01:21:21.000000', 'temperatura', 665.0000, 'ºC'),
	(233739, 121, '2014-03-01 01:21:22.000000', 'temperatura', 934.0000, 'ºC'),
	(233740, 121, '2014-03-01 01:21:23.000000', 'temperatura', 278.0000, 'ºC'),
	(233741, 121, '2014-03-01 01:21:24.000000', 'temperatura', 986.0000, 'ºC'),
	(233742, 121, '2014-03-01 01:21:25.000000', 'temperatura', 498.0000, 'ºC'),
	(233743, 121, '2014-03-01 01:21:26.000000', 'temperatura', 731.0000, 'ºC'),
	(233744, 121, '2014-03-01 01:21:27.000000', 'temperatura', 963.0000, 'ºC'),
	(233745, 121, '2014-03-01 01:21:28.000000', 'temperatura', 223.0000, 'ºC'),
	(233746, 121, '2014-03-01 01:21:29.000000', 'temperatura', 627.0000, 'ºC'),
	(233747, 121, '2014-03-01 01:21:30.000000', 'temperatura', 64.0000, 'ºC'),
	(233748, 121, '2014-03-01 01:21:31.000000', 'temperatura', 842.0000, 'ºC'),
	(233749, 121, '2014-03-01 01:21:32.000000', 'temperatura', 417.0000, 'ºC'),
	(233750, 121, '2014-03-01 01:21:33.000000', 'temperatura', 761.0000, 'ºC'),
	(233751, 121, '2014-03-01 01:21:34.000000', 'temperatura', 155.0000, 'ºC'),
	(233752, 121, '2014-03-01 01:21:35.000000', 'temperatura', 890.0000, 'ºC'),
	(233753, 121, '2014-03-01 01:21:36.000000', 'temperatura', 386.0000, 'ºC'),
	(233754, 121, '2014-03-01 01:21:37.000000', 'temperatura', 462.0000, 'ºC'),
	(233755, 121, '2014-03-01 01:21:38.000000', 'temperatura', 1154.0000, 'ºC'),
	(233756, 121, '2014-03-01 01:21:39.000000', 'temperatura', 781.0000, 'ºC'),
	(233757, 121, '2014-03-01 01:21:40.000000', 'temperatura', 444.0000, 'ºC'),
	(233758, 121, '2014-03-01 01:21:41.000000', 'temperatura', 1080.0000, 'ºC'),
	(233759, 121, '2014-03-01 01:21:42.000000', 'temperatura', 465.0000, 'ºC'),
	(233760, 121, '2014-03-01 01:21:43.000000', 'temperatura', 288.0000, 'ºC'),
	(233761, 121, '2014-03-01 01:21:44.000000', 'temperatura', 46.0000, 'ºC'),
	(233762, 121, '2014-03-01 01:21:45.000000', 'temperatura', 564.0000, 'ºC'),
	(233763, 121, '2014-03-01 01:21:46.000000', 'temperatura', 285.0000, 'ºC'),
	(233764, 121, '2014-03-01 01:21:47.000000', 'temperatura', 934.0000, 'ºC'),
	(233765, 121, '2014-03-01 01:21:48.000000', 'temperatura', 216.0000, 'ºC'),
	(233766, 121, '2014-03-01 01:21:49.000000', 'temperatura', 678.0000, 'ºC'),
	(233767, 121, '2014-03-01 01:21:50.000000', 'temperatura', 340.0000, 'ºC'),
	(233768, 121, '2014-03-01 01:21:51.000000', 'temperatura', 870.0000, 'ºC'),
	(233769, 121, '2014-03-01 01:21:52.000000', 'temperatura', 928.0000, 'ºC'),
	(233770, 121, '2014-03-01 01:21:53.000000', 'temperatura', 832.0000, 'ºC'),
	(233771, 121, '2014-03-01 01:21:54.000000', 'temperatura', 177.0000, 'ºC'),
	(233772, 121, '2014-03-01 01:21:55.000000', 'temperatura', 791.0000, 'ºC'),
	(233773, 121, '2014-03-01 01:21:56.000000', 'temperatura', 1023.0000, 'ºC'),
	(233774, 121, '2014-03-01 01:21:57.000000', 'temperatura', 340.0000, 'ºC'),
	(233775, 121, '2014-03-01 01:21:58.000000', 'temperatura', 1035.0000, 'ºC'),
	(233776, 121, '2014-03-01 01:21:59.000000', 'temperatura', 553.0000, 'ºC'),
	(233777, 121, '2014-03-01 01:22:00.000000', 'temperatura', 861.0000, 'ºC'),
	(233778, 121, '2014-03-01 01:22:01.000000', 'temperatura', 248.0000, 'ºC'),
	(233779, 121, '2014-03-01 01:22:02.000000', 'temperatura', 1059.0000, 'ºC'),
	(233780, 121, '2014-03-01 01:22:03.000000', 'temperatura', 948.0000, 'ºC'),
	(233781, 121, '2014-03-01 01:22:04.000000', 'temperatura', 365.0000, 'ºC'),
	(233782, 121, '2014-03-01 01:22:05.000000', 'temperatura', 183.0000, 'ºC'),
	(233783, 121, '2014-03-01 01:22:06.000000', 'temperatura', 1018.0000, 'ºC'),
	(233784, 121, '2014-03-01 01:22:07.000000', 'temperatura', 941.0000, 'ºC'),
	(233785, 121, '2014-03-01 01:22:08.000000', 'temperatura', 454.0000, 'ºC'),
	(233786, 121, '2014-03-01 01:22:09.000000', 'temperatura', 645.0000, 'ºC'),
	(233787, 121, '2014-03-01 01:22:10.000000', 'temperatura', 665.0000, 'ºC'),
	(233788, 121, '2014-03-01 01:22:11.000000', 'temperatura', 188.0000, 'ºC'),
	(233789, 121, '2014-03-01 01:22:12.000000', 'temperatura', 148.0000, 'ºC'),
	(233790, 121, '2014-03-01 01:22:13.000000', 'temperatura', 175.0000, 'ºC'),
	(233791, 121, '2014-03-01 01:22:14.000000', 'temperatura', 434.0000, 'ºC'),
	(233792, 121, '2014-03-01 01:22:15.000000', 'temperatura', 444.0000, 'ºC'),
	(233793, 121, '2014-03-01 01:22:16.000000', 'temperatura', 917.0000, 'ºC'),
	(233794, 121, '2014-03-01 01:22:17.000000', 'temperatura', 855.0000, 'ºC'),
	(233795, 121, '2014-03-01 01:22:18.000000', 'temperatura', 323.0000, 'ºC'),
	(233796, 121, '2014-03-01 01:22:19.000000', 'temperatura', 250.0000, 'ºC'),
	(233797, 121, '2014-03-01 01:22:20.000000', 'temperatura', 281.0000, 'ºC'),
	(233798, 121, '2014-03-01 01:22:21.000000', 'temperatura', 657.0000, 'ºC'),
	(233799, 121, '2014-03-01 01:22:22.000000', 'temperatura', 44.0000, 'ºC'),
	(233800, 121, '2014-03-01 01:22:23.000000', 'temperatura', 646.0000, 'ºC'),
	(233801, 121, '2014-03-01 01:22:24.000000', 'temperatura', 702.0000, 'ºC'),
	(233802, 121, '2014-03-01 01:22:25.000000', 'temperatura', 370.0000, 'ºC'),
	(233803, 121, '2014-03-01 01:22:26.000000', 'temperatura', 944.0000, 'ºC'),
	(233804, 121, '2014-03-01 01:22:27.000000', 'temperatura', 12.0000, 'ºC'),
	(233805, 121, '2014-03-01 01:22:28.000000', 'temperatura', 826.0000, 'ºC'),
	(233806, 121, '2014-03-01 01:22:29.000000', 'temperatura', 498.0000, 'ºC'),
	(233807, 121, '2014-03-01 01:22:30.000000', 'temperatura', 11.0000, 'ºC'),
	(233808, 121, '2014-03-01 01:22:31.000000', 'temperatura', 961.0000, 'ºC'),
	(233809, 121, '2014-03-01 01:22:32.000000', 'temperatura', 1174.0000, 'ºC'),
	(233810, 121, '2014-03-01 01:22:33.000000', 'temperatura', 585.0000, 'ºC'),
	(233811, 121, '2014-03-01 01:22:34.000000', 'temperatura', 606.0000, 'ºC'),
	(233812, 121, '2014-03-01 01:22:35.000000', 'temperatura', 73.0000, 'ºC'),
	(233813, 121, '2014-03-01 01:22:36.000000', 'temperatura', 950.0000, 'ºC'),
	(233814, 121, '2014-03-01 01:22:37.000000', 'temperatura', 932.0000, 'ºC'),
	(233815, 121, '2014-03-01 01:22:38.000000', 'temperatura', 610.0000, 'ºC'),
	(233816, 121, '2014-03-01 01:22:39.000000', 'temperatura', 252.0000, 'ºC'),
	(233817, 121, '2014-03-01 01:22:40.000000', 'temperatura', 632.0000, 'ºC'),
	(233818, 121, '2014-03-01 01:22:41.000000', 'temperatura', 5.0000, 'ºC'),
	(233819, 121, '2014-03-01 01:22:42.000000', 'temperatura', 528.0000, 'ºC'),
	(233820, 121, '2014-03-01 01:22:43.000000', 'temperatura', 225.0000, 'ºC'),
	(233821, 121, '2014-03-01 01:22:44.000000', 'temperatura', 742.0000, 'ºC'),
	(233822, 121, '2014-03-01 01:22:45.000000', 'temperatura', 636.0000, 'ºC'),
	(233823, 121, '2014-03-01 01:22:46.000000', 'temperatura', 953.0000, 'ºC'),
	(233824, 121, '2014-03-01 01:22:47.000000', 'temperatura', 461.0000, 'ºC'),
	(233825, 121, '2014-03-01 01:22:48.000000', 'temperatura', 643.0000, 'ºC'),
	(233826, 121, '2014-03-01 01:22:49.000000', 'temperatura', 633.0000, 'ºC'),
	(233827, 121, '2014-03-01 01:22:50.000000', 'temperatura', 39.0000, 'ºC'),
	(233828, 121, '2014-03-01 01:22:51.000000', 'temperatura', 693.0000, 'ºC'),
	(233829, 121, '2014-03-01 01:22:52.000000', 'temperatura', 951.0000, 'ºC'),
	(233830, 121, '2014-03-01 01:22:53.000000', 'temperatura', 276.0000, 'ºC'),
	(233831, 121, '2014-03-01 01:22:54.000000', 'temperatura', 928.0000, 'ºC'),
	(233832, 121, '2014-03-01 01:22:55.000000', 'temperatura', 213.0000, 'ºC'),
	(233833, 121, '2014-03-01 01:22:56.000000', 'temperatura', 681.0000, 'ºC'),
	(233834, 121, '2014-03-01 01:22:57.000000', 'temperatura', 365.0000, 'ºC'),
	(233835, 121, '2014-03-01 01:22:58.000000', 'temperatura', 985.0000, 'ºC'),
	(233836, 121, '2014-03-01 01:22:59.000000', 'temperatura', 228.0000, 'ºC'),
	(233837, 121, '2014-03-01 01:23:00.000000', 'temperatura', 588.0000, 'ºC'),
	(233838, 121, '2014-03-01 01:23:01.000000', 'temperatura', 1056.0000, 'ºC'),
	(233839, 121, '2014-03-01 01:23:02.000000', 'temperatura', 1116.0000, 'ºC'),
	(233840, 121, '2014-03-01 01:23:03.000000', 'temperatura', 14.0000, 'ºC'),
	(233841, 121, '2014-03-01 01:23:04.000000', 'temperatura', 322.0000, 'ºC'),
	(233842, 121, '2014-03-01 01:23:05.000000', 'temperatura', 370.0000, 'ºC'),
	(233843, 121, '2014-03-01 01:23:06.000000', 'temperatura', 884.0000, 'ºC'),
	(233844, 121, '2014-03-01 01:23:07.000000', 'temperatura', 911.0000, 'ºC'),
	(233845, 121, '2014-03-01 01:23:08.000000', 'temperatura', 701.0000, 'ºC'),
	(233846, 121, '2014-03-01 01:23:09.000000', 'temperatura', 773.0000, 'ºC'),
	(233847, 121, '2014-03-01 01:23:10.000000', 'temperatura', 565.0000, 'ºC'),
	(233848, 121, '2014-03-01 01:23:11.000000', 'temperatura', 504.0000, 'ºC'),
	(233849, 121, '2014-03-01 01:23:12.000000', 'temperatura', 827.0000, 'ºC'),
	(233850, 121, '2014-03-01 01:23:13.000000', 'temperatura', 222.0000, 'ºC'),
	(233851, 121, '2014-03-01 01:23:14.000000', 'temperatura', 1030.0000, 'ºC'),
	(233852, 121, '2014-03-01 01:23:15.000000', 'temperatura', 885.0000, 'ºC'),
	(233853, 121, '2014-03-01 01:23:16.000000', 'temperatura', 136.0000, 'ºC'),
	(233854, 121, '2014-03-01 01:23:17.000000', 'temperatura', 425.0000, 'ºC'),
	(233855, 121, '2014-03-01 01:23:18.000000', 'temperatura', 517.0000, 'ºC'),
	(233856, 121, '2014-03-01 01:23:19.000000', 'temperatura', 112.0000, 'ºC'),
	(233857, 121, '2014-03-01 01:23:20.000000', 'temperatura', 210.0000, 'ºC'),
	(233858, 121, '2014-03-01 01:23:21.000000', 'temperatura', 712.0000, 'ºC'),
	(233859, 121, '2014-03-01 01:23:22.000000', 'temperatura', 530.0000, 'ºC'),
	(233860, 121, '2014-03-01 01:23:23.000000', 'temperatura', 517.0000, 'ºC'),
	(233861, 121, '2014-03-01 01:23:24.000000', 'temperatura', 994.0000, 'ºC'),
	(233862, 121, '2014-03-01 01:23:25.000000', 'temperatura', 1021.0000, 'ºC'),
	(233863, 121, '2014-03-01 01:23:26.000000', 'temperatura', 924.0000, 'ºC'),
	(233864, 121, '2014-03-01 01:23:27.000000', 'temperatura', 355.0000, 'ºC'),
	(233865, 121, '2014-03-01 01:23:28.000000', 'temperatura', 203.0000, 'ºC'),
	(233866, 121, '2014-03-01 01:23:29.000000', 'temperatura', 1151.0000, 'ºC'),
	(233867, 121, '2014-03-01 01:23:30.000000', 'temperatura', 345.0000, 'ºC'),
	(233868, 121, '2014-03-01 01:23:31.000000', 'temperatura', 674.0000, 'ºC'),
	(233869, 121, '2014-03-01 01:23:32.000000', 'temperatura', 1136.0000, 'ºC'),
	(233870, 121, '2014-03-01 01:23:33.000000', 'temperatura', 57.0000, 'ºC'),
	(233871, 121, '2014-03-01 01:23:34.000000', 'temperatura', 477.0000, 'ºC'),
	(233872, 121, '2014-03-01 01:23:35.000000', 'temperatura', 1017.0000, 'ºC'),
	(233873, 121, '2014-03-01 01:23:36.000000', 'temperatura', 53.0000, 'ºC'),
	(233874, 121, '2014-03-01 01:23:37.000000', 'temperatura', 814.0000, 'ºC'),
	(233875, 121, '2014-03-01 01:23:38.000000', 'temperatura', 312.0000, 'ºC'),
	(233876, 121, '2014-03-01 01:23:39.000000', 'temperatura', 320.0000, 'ºC'),
	(233877, 121, '2014-03-01 01:23:40.000000', 'temperatura', 664.0000, 'ºC'),
	(233878, 121, '2014-03-01 01:23:41.000000', 'temperatura', 1160.0000, 'ºC'),
	(233879, 121, '2014-03-01 01:23:42.000000', 'temperatura', 209.0000, 'ºC'),
	(233880, 121, '2014-03-01 01:23:43.000000', 'temperatura', 1165.0000, 'ºC'),
	(233881, 121, '2014-03-01 01:23:44.000000', 'temperatura', 398.0000, 'ºC'),
	(233882, 121, '2014-03-01 01:23:45.000000', 'temperatura', 895.0000, 'ºC'),
	(233883, 121, '2014-03-01 01:23:46.000000', 'temperatura', 880.0000, 'ºC'),
	(233884, 121, '2014-03-01 01:23:47.000000', 'temperatura', 517.0000, 'ºC'),
	(233885, 121, '2014-03-01 01:23:48.000000', 'temperatura', 1146.0000, 'ºC'),
	(233886, 121, '2014-03-01 01:23:49.000000', 'temperatura', 579.0000, 'ºC'),
	(233887, 121, '2014-03-01 01:23:50.000000', 'temperatura', 657.0000, 'ºC'),
	(233888, 121, '2014-03-01 01:23:51.000000', 'temperatura', 351.0000, 'ºC'),
	(233889, 121, '2014-03-01 01:23:52.000000', 'temperatura', 983.0000, 'ºC'),
	(233890, 121, '2014-03-01 01:23:53.000000', 'temperatura', 263.0000, 'ºC'),
	(233891, 121, '2014-03-01 01:23:54.000000', 'temperatura', 764.0000, 'ºC'),
	(233892, 121, '2014-03-01 01:23:55.000000', 'temperatura', 634.0000, 'ºC'),
	(233893, 121, '2014-03-01 01:23:56.000000', 'temperatura', 877.0000, 'ºC'),
	(233894, 121, '2014-03-01 01:23:57.000000', 'temperatura', 83.0000, 'ºC'),
	(233895, 121, '2014-03-01 01:23:58.000000', 'temperatura', 185.0000, 'ºC'),
	(233896, 121, '2014-03-01 01:23:59.000000', 'temperatura', 677.0000, 'ºC'),
	(233897, 121, '2014-03-01 01:24:00.000000', 'temperatura', 428.0000, 'ºC'),
	(233898, 121, '2014-03-01 01:24:01.000000', 'temperatura', 113.0000, 'ºC'),
	(233899, 121, '2014-03-01 01:24:02.000000', 'temperatura', 480.0000, 'ºC'),
	(233900, 121, '2014-03-01 01:24:03.000000', 'temperatura', 863.0000, 'ºC'),
	(233901, 121, '2014-03-01 01:24:04.000000', 'temperatura', 474.0000, 'ºC'),
	(233902, 122, '2014-03-01 00:00:00.000000', 'temperatura', 1081.0000, 'ºC'),
	(233903, 122, '2014-03-01 00:00:01.000000', 'temperatura', 65.0000, 'ºC'),
	(233904, 122, '2014-03-01 00:00:02.000000', 'temperatura', 682.0000, 'ºC'),
	(233905, 122, '2014-03-01 00:00:03.000000', 'temperatura', 817.0000, 'ºC'),
	(233906, 122, '2014-03-01 00:00:04.000000', 'temperatura', 837.0000, 'ºC'),
	(233907, 122, '2014-03-01 00:00:05.000000', 'temperatura', 534.0000, 'ºC'),
	(233908, 122, '2014-03-01 00:00:06.000000', 'temperatura', 159.0000, 'ºC'),
	(233909, 122, '2014-03-01 00:00:07.000000', 'temperatura', 394.0000, 'ºC'),
	(233910, 122, '2014-03-01 00:00:08.000000', 'temperatura', 294.0000, 'ºC'),
	(233911, 122, '2014-03-01 00:00:09.000000', 'temperatura', 288.0000, 'ºC'),
	(233912, 122, '2014-03-01 00:00:10.000000', 'temperatura', 559.0000, 'ºC'),
	(233913, 122, '2014-03-01 00:00:11.000000', 'temperatura', 730.0000, 'ºC'),
	(233914, 122, '2014-03-01 00:00:12.000000', 'temperatura', 777.0000, 'ºC'),
	(233915, 122, '2014-03-01 00:00:13.000000', 'temperatura', 492.0000, 'ºC'),
	(233916, 122, '2014-03-01 00:00:14.000000', 'temperatura', 130.0000, 'ºC'),
	(233917, 122, '2014-03-01 00:00:15.000000', 'temperatura', 373.0000, 'ºC'),
	(233918, 122, '2014-03-01 00:00:16.000000', 'temperatura', 276.0000, 'ºC'),
	(233919, 122, '2014-03-01 00:00:17.000000', 'temperatura', 264.0000, 'ºC'),
	(233920, 122, '2014-03-01 00:00:18.000000', 'temperatura', 490.0000, 'ºC'),
	(233921, 122, '2014-03-01 00:00:19.000000', 'temperatura', 459.0000, 'ºC'),
	(233922, 122, '2014-03-01 00:00:20.000000', 'temperatura', 828.0000, 'ºC'),
	(233923, 122, '2014-03-01 00:00:21.000000', 'temperatura', 360.0000, 'ºC'),
	(233924, 122, '2014-03-01 00:00:22.000000', 'temperatura', 520.0000, 'ºC'),
	(233925, 122, '2014-03-01 00:00:23.000000', 'temperatura', 317.0000, 'ºC'),
	(233926, 122, '2014-03-01 00:00:24.000000', 'temperatura', 27.0000, 'ºC'),
	(233927, 122, '2014-03-01 00:00:25.000000', 'temperatura', 383.0000, 'ºC'),
	(233928, 122, '2014-03-01 00:00:26.000000', 'temperatura', 637.0000, 'ºC'),
	(233929, 122, '2014-03-01 00:00:27.000000', 'temperatura', 834.0000, 'ºC'),
	(233930, 122, '2014-03-01 00:00:28.000000', 'temperatura', 1061.0000, 'ºC'),
	(233931, 122, '2014-03-01 00:00:29.000000', 'temperatura', 403.0000, 'ºC'),
	(233932, 122, '2014-03-01 00:00:30.000000', 'temperatura', 32.0000, 'ºC'),
	(233933, 122, '2014-03-01 00:00:31.000000', 'temperatura', 150.0000, 'ºC'),
	(233934, 122, '2014-03-01 00:00:32.000000', 'temperatura', 658.0000, 'ºC'),
	(233935, 122, '2014-03-01 00:00:33.000000', 'temperatura', 438.0000, 'ºC'),
	(233936, 122, '2014-03-01 00:00:34.000000', 'temperatura', 216.0000, 'ºC'),
	(233937, 122, '2014-03-01 00:00:35.000000', 'temperatura', 967.0000, 'ºC'),
	(233938, 122, '2014-03-01 00:00:36.000000', 'temperatura', 589.0000, 'ºC'),
	(233939, 122, '2014-03-01 00:00:37.000000', 'temperatura', 43.0000, 'ºC'),
	(233940, 122, '2014-03-01 00:00:38.000000', 'temperatura', 851.0000, 'ºC'),
	(233941, 122, '2014-03-01 00:00:39.000000', 'temperatura', 525.0000, 'ºC'),
	(233942, 122, '2014-03-01 00:00:40.000000', 'temperatura', 71.0000, 'ºC'),
	(233943, 122, '2014-03-01 00:00:41.000000', 'temperatura', 1180.0000, 'ºC'),
	(233944, 122, '2014-03-01 00:00:42.000000', 'temperatura', 888.0000, 'ºC'),
	(233945, 122, '2014-03-01 00:00:43.000000', 'temperatura', 901.0000, 'ºC'),
	(233946, 122, '2014-03-01 00:00:44.000000', 'temperatura', 642.0000, 'ºC'),
	(233947, 122, '2014-03-01 00:00:45.000000', 'temperatura', 509.0000, 'ºC'),
	(233948, 122, '2014-03-01 00:00:46.000000', 'temperatura', 618.0000, 'ºC'),
	(233949, 122, '2014-03-01 00:00:47.000000', 'temperatura', 365.0000, 'ºC'),
	(233950, 122, '2014-03-01 00:00:48.000000', 'temperatura', 1172.0000, 'ºC'),
	(233951, 122, '2014-03-01 00:00:49.000000', 'temperatura', 1164.0000, 'ºC'),
	(233952, 122, '2014-03-01 00:00:50.000000', 'temperatura', 1103.0000, 'ºC'),
	(233953, 122, '2014-03-01 00:00:51.000000', 'temperatura', 826.0000, 'ºC'),
	(233954, 122, '2014-03-01 00:00:52.000000', 'temperatura', 820.0000, 'ºC'),
	(233955, 122, '2014-03-01 00:00:53.000000', 'temperatura', 422.0000, 'ºC'),
	(233956, 122, '2014-03-01 00:00:54.000000', 'temperatura', 851.0000, 'ºC'),
	(233957, 122, '2014-03-01 00:00:55.000000', 'temperatura', 591.0000, 'ºC'),
	(233958, 122, '2014-03-01 00:00:56.000000', 'temperatura', 402.0000, 'ºC'),
	(233959, 122, '2014-03-01 00:00:57.000000', 'temperatura', 237.0000, 'ºC'),
	(233960, 122, '2014-03-01 00:00:58.000000', 'temperatura', 1180.0000, 'ºC'),
	(233961, 122, '2014-03-01 00:00:59.000000', 'temperatura', 389.0000, 'ºC'),
	(233962, 122, '2014-03-01 00:01:00.000000', 'temperatura', 807.0000, 'ºC'),
	(233963, 122, '2014-03-01 00:01:01.000000', 'temperatura', 468.0000, 'ºC'),
	(233964, 122, '2014-03-01 00:01:02.000000', 'temperatura', 1121.0000, 'ºC'),
	(233965, 122, '2014-03-01 00:01:03.000000', 'temperatura', 601.0000, 'ºC'),
	(233966, 122, '2014-03-01 00:01:04.000000', 'temperatura', 841.0000, 'ºC'),
	(233967, 122, '2014-03-01 00:01:05.000000', 'temperatura', 1.0000, 'ºC'),
	(233968, 122, '2014-03-01 00:01:06.000000', 'temperatura', 1086.0000, 'ºC'),
	(233969, 122, '2014-03-01 00:01:07.000000', 'temperatura', 625.0000, 'ºC'),
	(233970, 122, '2014-03-01 00:01:08.000000', 'temperatura', 1067.0000, 'ºC'),
	(233971, 122, '2014-03-01 00:01:09.000000', 'temperatura', 1060.0000, 'ºC'),
	(233972, 122, '2014-03-01 00:01:10.000000', 'temperatura', 900.0000, 'ºC'),
	(233973, 122, '2014-03-01 00:01:11.000000', 'temperatura', 120.0000, 'ºC'),
	(233974, 122, '2014-03-01 00:01:12.000000', 'temperatura', 303.0000, 'ºC'),
	(233975, 122, '2014-03-01 00:01:13.000000', 'temperatura', 1154.0000, 'ºC'),
	(233976, 122, '2014-03-01 00:01:14.000000', 'temperatura', 60.0000, 'ºC'),
	(233977, 122, '2014-03-01 00:01:15.000000', 'temperatura', 441.0000, 'ºC'),
	(233978, 122, '2014-03-01 00:01:16.000000', 'temperatura', 825.0000, 'ºC'),
	(233979, 122, '2014-03-01 00:01:17.000000', 'temperatura', 404.0000, 'ºC'),
	(233980, 122, '2014-03-01 00:01:18.000000', 'temperatura', 744.0000, 'ºC'),
	(233981, 122, '2014-03-01 00:01:19.000000', 'temperatura', 109.0000, 'ºC'),
	(233982, 122, '2014-03-01 00:01:20.000000', 'temperatura', 715.0000, 'ºC'),
	(233983, 122, '2014-03-01 00:01:21.000000', 'temperatura', 846.0000, 'ºC'),
	(233984, 122, '2014-03-01 00:01:22.000000', 'temperatura', 888.0000, 'ºC'),
	(233985, 122, '2014-03-01 00:01:23.000000', 'temperatura', 703.0000, 'ºC'),
	(233986, 122, '2014-03-01 00:01:24.000000', 'temperatura', 848.0000, 'ºC'),
	(233987, 122, '2014-03-01 00:01:25.000000', 'temperatura', 935.0000, 'ºC'),
	(233988, 122, '2014-03-01 00:01:26.000000', 'temperatura', 931.0000, 'ºC'),
	(233989, 122, '2014-03-01 00:01:27.000000', 'temperatura', 651.0000, 'ºC'),
	(233990, 122, '2014-03-01 00:01:28.000000', 'temperatura', 461.0000, 'ºC'),
	(233991, 122, '2014-03-01 00:01:29.000000', 'temperatura', 354.0000, 'ºC'),
	(233992, 122, '2014-03-01 00:01:30.000000', 'temperatura', 385.0000, 'ºC'),
	(233993, 122, '2014-03-01 00:01:31.000000', 'temperatura', 865.0000, 'ºC'),
	(233994, 122, '2014-03-01 00:01:32.000000', 'temperatura', 770.0000, 'ºC'),
	(233995, 122, '2014-03-01 00:01:33.000000', 'temperatura', 55.0000, 'ºC'),
	(233996, 122, '2014-03-01 00:01:34.000000', 'temperatura', 367.0000, 'ºC'),
	(233997, 122, '2014-03-01 00:01:35.000000', 'temperatura', 470.0000, 'ºC'),
	(233998, 122, '2014-03-01 00:01:36.000000', 'temperatura', 50.0000, 'ºC'),
	(233999, 122, '2014-03-01 00:01:37.000000', 'temperatura', 40.0000, 'ºC'),
	(234000, 122, '2014-03-01 00:01:38.000000', 'temperatura', 49.0000, 'ºC'),
	(234001, 122, '2014-03-01 00:01:39.000000', 'temperatura', 125.0000, 'ºC'),
	(234002, 122, '2014-03-01 00:01:40.000000', 'temperatura', 480.0000, 'ºC'),
	(234003, 122, '2014-03-01 00:01:41.000000', 'temperatura', 826.0000, 'ºC'),
	(234004, 122, '2014-03-01 00:01:42.000000', 'temperatura', 288.0000, 'ºC'),
	(234005, 122, '2014-03-01 00:01:43.000000', 'temperatura', 163.0000, 'ºC'),
	(234006, 122, '2014-03-01 00:01:44.000000', 'temperatura', 1152.0000, 'ºC'),
	(234007, 122, '2014-03-01 00:01:45.000000', 'temperatura', 473.0000, 'ºC'),
	(234008, 122, '2014-03-01 00:01:46.000000', 'temperatura', 110.0000, 'ºC'),
	(234009, 122, '2014-03-01 00:01:47.000000', 'temperatura', 330.0000, 'ºC'),
	(234010, 122, '2014-03-01 00:01:48.000000', 'temperatura', 122.0000, 'ºC'),
	(234011, 122, '2014-03-01 00:01:49.000000', 'temperatura', 820.0000, 'ºC'),
	(234012, 122, '2014-03-01 00:01:50.000000', 'temperatura', 134.0000, 'ºC'),
	(234013, 122, '2014-03-01 00:01:51.000000', 'temperatura', 612.0000, 'ºC'),
	(234014, 122, '2014-03-01 00:01:52.000000', 'temperatura', 258.0000, 'ºC'),
	(234015, 122, '2014-03-01 00:01:53.000000', 'temperatura', 653.0000, 'ºC'),
	(234016, 122, '2014-03-01 00:01:54.000000', 'temperatura', 92.0000, 'ºC'),
	(234017, 122, '2014-03-01 00:01:55.000000', 'temperatura', 900.0000, 'ºC'),
	(234018, 122, '2014-03-01 00:01:56.000000', 'temperatura', 625.0000, 'ºC'),
	(234019, 122, '2014-03-01 00:01:57.000000', 'temperatura', 426.0000, 'ºC'),
	(234020, 122, '2014-03-01 00:01:58.000000', 'temperatura', 254.0000, 'ºC'),
	(234021, 122, '2014-03-01 00:01:59.000000', 'temperatura', 1195.0000, 'ºC'),
	(234022, 122, '2014-03-01 00:02:00.000000', 'temperatura', 412.0000, 'ºC'),
	(234023, 122, '2014-03-01 00:02:01.000000', 'temperatura', 876.0000, 'ºC'),
	(234024, 122, '2014-03-01 00:02:02.000000', 'temperatura', 744.0000, 'ºC'),
	(234025, 122, '2014-03-01 00:02:03.000000', 'temperatura', 1093.0000, 'ºC'),
	(234026, 122, '2014-03-01 00:02:04.000000', 'temperatura', 835.0000, 'ºC'),
	(234027, 122, '2014-03-01 00:02:05.000000', 'temperatura', 897.0000, 'ºC'),
	(234028, 122, '2014-03-01 00:02:06.000000', 'temperatura', 780.0000, 'ºC'),
	(234029, 122, '2014-03-01 00:02:07.000000', 'temperatura', 8.0000, 'ºC'),
	(234030, 122, '2014-03-01 00:02:08.000000', 'temperatura', 102.0000, 'ºC'),
	(234031, 122, '2014-03-01 00:02:09.000000', 'temperatura', 484.0000, 'ºC'),
	(234032, 122, '2014-03-01 00:02:10.000000', 'temperatura', 918.0000, 'ºC'),
	(234033, 122, '2014-03-01 00:02:11.000000', 'temperatura', 737.0000, 'ºC'),
	(234034, 122, '2014-03-01 00:02:12.000000', 'temperatura', 930.0000, 'ºC'),
	(234035, 122, '2014-03-01 00:02:13.000000', 'temperatura', 38.0000, 'ºC'),
	(234036, 122, '2014-03-01 00:02:14.000000', 'temperatura', 1004.0000, 'ºC'),
	(234037, 122, '2014-03-01 00:02:15.000000', 'temperatura', 107.0000, 'ºC'),
	(234038, 122, '2014-03-01 00:02:16.000000', 'temperatura', 1122.0000, 'ºC'),
	(234039, 122, '2014-03-01 00:02:17.000000', 'temperatura', 489.0000, 'ºC'),
	(234040, 122, '2014-03-01 00:02:18.000000', 'temperatura', 282.0000, 'ºC'),
	(234041, 122, '2014-03-01 00:02:19.000000', 'temperatura', 1142.0000, 'ºC'),
	(234042, 122, '2014-03-01 00:02:20.000000', 'temperatura', 63.0000, 'ºC'),
	(234043, 122, '2014-03-01 00:02:21.000000', 'temperatura', 492.0000, 'ºC'),
	(234044, 122, '2014-03-01 00:02:22.000000', 'temperatura', 1069.0000, 'ºC'),
	(234045, 122, '2014-03-01 00:02:23.000000', 'temperatura', 272.0000, 'ºC'),
	(234046, 122, '2014-03-01 00:02:24.000000', 'temperatura', 551.0000, 'ºC'),
	(234047, 122, '2014-03-01 00:02:25.000000', 'temperatura', 741.0000, 'ºC'),
	(234048, 122, '2014-03-01 00:02:26.000000', 'temperatura', 853.0000, 'ºC'),
	(234049, 122, '2014-03-01 00:02:27.000000', 'temperatura', 843.0000, 'ºC'),
	(234050, 122, '2014-03-01 00:02:28.000000', 'temperatura', 456.0000, 'ºC'),
	(234051, 122, '2014-03-01 00:02:29.000000', 'temperatura', 952.0000, 'ºC'),
	(234052, 122, '2014-03-01 00:02:30.000000', 'temperatura', 991.0000, 'ºC'),
	(234053, 122, '2014-03-01 00:02:31.000000', 'temperatura', 902.0000, 'ºC'),
	(234054, 122, '2014-03-01 00:02:32.000000', 'temperatura', 337.0000, 'ºC'),
	(234055, 122, '2014-03-01 00:02:33.000000', 'temperatura', 180.0000, 'ºC'),
	(234056, 122, '2014-03-01 00:02:34.000000', 'temperatura', 1087.0000, 'ºC'),
	(234057, 122, '2014-03-01 00:02:35.000000', 'temperatura', 98.0000, 'ºC'),
	(234058, 122, '2014-03-01 00:02:36.000000', 'temperatura', 827.0000, 'ºC'),
	(234059, 122, '2014-03-01 00:02:37.000000', 'temperatura', 241.0000, 'ºC'),
	(234060, 122, '2014-03-01 00:02:38.000000', 'temperatura', 1125.0000, 'ºC'),
	(234061, 122, '2014-03-01 00:02:39.000000', 'temperatura', 103.0000, 'ºC'),
	(234062, 122, '2014-03-01 00:02:40.000000', 'temperatura', 740.0000, 'ºC'),
	(234063, 122, '2014-03-01 00:02:41.000000', 'temperatura', 990.0000, 'ºC'),
	(234064, 122, '2014-03-01 00:02:42.000000', 'temperatura', 333.0000, 'ºC'),
	(234065, 122, '2014-03-01 00:02:43.000000', 'temperatura', 1096.0000, 'ºC'),
	(234066, 122, '2014-03-01 00:02:44.000000', 'temperatura', 882.0000, 'ºC'),
	(234067, 122, '2014-03-01 00:02:45.000000', 'temperatura', 1122.0000, 'ºC'),
	(234068, 122, '2014-03-01 00:02:46.000000', 'temperatura', 564.0000, 'ºC'),
	(234069, 122, '2014-03-01 00:02:47.000000', 'temperatura', 653.0000, 'ºC'),
	(234070, 122, '2014-03-01 00:02:48.000000', 'temperatura', 375.0000, 'ºC'),
	(234071, 122, '2014-03-01 00:02:49.000000', 'temperatura', 1117.0000, 'ºC'),
	(234072, 122, '2014-03-01 00:02:50.000000', 'temperatura', 859.0000, 'ºC'),
	(234073, 122, '2014-03-01 00:02:51.000000', 'temperatura', 947.0000, 'ºC'),
	(234074, 122, '2014-03-01 00:02:52.000000', 'temperatura', 956.0000, 'ºC'),
	(234075, 122, '2014-03-01 00:02:53.000000', 'temperatura', 742.0000, 'ºC'),
	(234076, 122, '2014-03-01 00:02:54.000000', 'temperatura', 843.0000, 'ºC'),
	(234077, 122, '2014-03-01 00:02:55.000000', 'temperatura', 790.0000, 'ºC'),
	(234078, 122, '2014-03-01 00:02:56.000000', 'temperatura', 219.0000, 'ºC'),
	(234079, 122, '2014-03-01 00:02:57.000000', 'temperatura', 1126.0000, 'ºC'),
	(234080, 122, '2014-03-01 00:02:58.000000', 'temperatura', 175.0000, 'ºC'),
	(234081, 122, '2014-03-01 00:02:59.000000', 'temperatura', 1095.0000, 'ºC'),
	(234082, 122, '2014-03-01 00:03:00.000000', 'temperatura', 151.0000, 'ºC'),
	(234083, 122, '2014-03-01 00:03:01.000000', 'temperatura', 1069.0000, 'ºC'),
	(234084, 122, '2014-03-01 00:03:02.000000', 'temperatura', 95.0000, 'ºC'),
	(234085, 122, '2014-03-01 00:03:03.000000', 'temperatura', 869.0000, 'ºC'),
	(234086, 122, '2014-03-01 00:03:04.000000', 'temperatura', 461.0000, 'ºC'),
	(234087, 122, '2014-03-01 00:03:05.000000', 'temperatura', 899.0000, 'ºC'),
	(234088, 122, '2014-03-01 00:03:06.000000', 'temperatura', 710.0000, 'ºC'),
	(234089, 122, '2014-03-01 00:03:07.000000', 'temperatura', 853.0000, 'ºC'),
	(234090, 122, '2014-03-01 00:03:08.000000', 'temperatura', 938.0000, 'ºC'),
	(234091, 122, '2014-03-01 00:03:09.000000', 'temperatura', 929.0000, 'ºC'),
	(234092, 122, '2014-03-01 00:03:10.000000', 'temperatura', 631.0000, 'ºC'),
	(234093, 122, '2014-03-01 00:03:11.000000', 'temperatura', 368.0000, 'ºC'),
	(234094, 122, '2014-03-01 00:03:12.000000', 'temperatura', 1150.0000, 'ºC'),
	(234095, 122, '2014-03-01 00:03:13.000000', 'temperatura', 1044.0000, 'ºC'),
	(234096, 122, '2014-03-01 00:03:14.000000', 'temperatura', 572.0000, 'ºC'),
	(234097, 122, '2014-03-01 00:03:15.000000', 'temperatura', 928.0000, 'ºC'),
	(234098, 122, '2014-03-01 00:03:16.000000', 'temperatura', 525.0000, 'ºC'),
	(234099, 122, '2014-03-01 00:03:17.000000', 'temperatura', 1042.0000, 'ºC'),
	(234100, 122, '2014-03-01 00:03:18.000000', 'temperatura', 33.0000, 'ºC'),
	(234101, 122, '2014-03-01 00:03:19.000000', 'temperatura', 642.0000, 'ºC'),
	(234102, 122, '2014-03-01 00:03:20.000000', 'temperatura', 713.0000, 'ºC'),
	(234103, 122, '2014-03-01 00:03:21.000000', 'temperatura', 436.0000, 'ºC'),
	(234104, 122, '2014-03-01 00:03:22.000000', 'temperatura', 44.0000, 'ºC'),
	(234105, 122, '2014-03-01 00:03:23.000000', 'temperatura', 113.0000, 'ºC'),
	(234106, 122, '2014-03-01 00:03:24.000000', 'temperatura', 434.0000, 'ºC'),
	(234107, 122, '2014-03-01 00:03:25.000000', 'temperatura', 629.0000, 'ºC'),
	(234108, 122, '2014-03-01 00:03:26.000000', 'temperatura', 645.0000, 'ºC'),
	(234109, 122, '2014-03-01 00:03:27.000000', 'temperatura', 139.0000, 'ºC'),
	(234110, 122, '2014-03-01 00:03:28.000000', 'temperatura', 1161.0000, 'ºC'),
	(234111, 122, '2014-03-01 00:03:29.000000', 'temperatura', 588.0000, 'ºC'),
	(234112, 122, '2014-03-01 00:03:30.000000', 'temperatura', 659.0000, 'ºC'),
	(234113, 122, '2014-03-01 00:03:31.000000', 'temperatura', 331.0000, 'ºC'),
	(234114, 122, '2014-03-01 00:03:32.000000', 'temperatura', 879.0000, 'ºC'),
	(234115, 122, '2014-03-01 00:03:33.000000', 'temperatura', 1000.0000, 'ºC'),
	(234116, 122, '2014-03-01 00:03:34.000000', 'temperatura', 1167.0000, 'ºC'),
	(234117, 122, '2014-03-01 00:03:35.000000', 'temperatura', 433.0000, 'ºC'),
	(234118, 122, '2014-03-01 00:03:36.000000', 'temperatura', 1064.0000, 'ºC'),
	(234119, 122, '2014-03-01 00:03:37.000000', 'temperatura', 422.0000, 'ºC'),
	(234120, 122, '2014-03-01 00:03:38.000000', 'temperatura', 117.0000, 'ºC'),
	(234121, 122, '2014-03-01 00:03:39.000000', 'temperatura', 523.0000, 'ºC'),
	(234122, 122, '2014-03-01 00:03:40.000000', 'temperatura', 1061.0000, 'ºC'),
	(234123, 122, '2014-03-01 00:03:41.000000', 'temperatura', 138.0000, 'ºC'),
	(234124, 122, '2014-03-01 00:03:42.000000', 'temperatura', 1107.0000, 'ºC'),
	(234125, 122, '2014-03-01 00:03:43.000000', 'temperatura', 324.0000, 'ºC'),
	(234126, 122, '2014-03-01 00:03:44.000000', 'temperatura', 696.0000, 'ºC'),
	(234127, 122, '2014-03-01 00:03:45.000000', 'temperatura', 109.0000, 'ºC'),
	(234128, 122, '2014-03-01 00:03:46.000000', 'temperatura', 858.0000, 'ºC'),
	(234129, 122, '2014-03-01 00:03:47.000000', 'temperatura', 363.0000, 'ºC'),
	(234130, 122, '2014-03-01 00:03:48.000000', 'temperatura', 443.0000, 'ºC'),
	(234131, 122, '2014-03-01 00:03:49.000000', 'temperatura', 1126.0000, 'ºC'),
	(234132, 122, '2014-03-01 00:03:50.000000', 'temperatura', 703.0000, 'ºC'),
	(234133, 122, '2014-03-01 00:03:51.000000', 'temperatura', 135.0000, 'ºC'),
	(234134, 122, '2014-03-01 00:03:52.000000', 'temperatura', 968.0000, 'ºC'),
	(234135, 122, '2014-03-01 00:03:53.000000', 'temperatura', 833.0000, 'ºC'),
	(234136, 122, '2014-03-01 00:03:54.000000', 'temperatura', 63.0000, 'ºC'),
	(234137, 122, '2014-03-01 00:03:55.000000', 'temperatura', 216.0000, 'ºC'),
	(234138, 122, '2014-03-01 00:03:56.000000', 'temperatura', 893.0000, 'ºC'),
	(234139, 122, '2014-03-01 00:03:57.000000', 'temperatura', 216.0000, 'ºC'),
	(234140, 122, '2014-03-01 00:03:58.000000', 'temperatura', 801.0000, 'ºC'),
	(234141, 122, '2014-03-01 00:03:59.000000', 'temperatura', 958.0000, 'ºC'),
	(234142, 122, '2014-03-01 00:04:00.000000', 'temperatura', 1185.0000, 'ºC'),
	(234143, 122, '2014-03-01 00:04:01.000000', 'temperatura', 655.0000, 'ºC'),
	(234144, 122, '2014-03-01 00:04:02.000000', 'temperatura', 921.0000, 'ºC'),
	(234145, 122, '2014-03-01 00:04:03.000000', 'temperatura', 241.0000, 'ºC'),
	(234146, 122, '2014-03-01 00:04:04.000000', 'temperatura', 841.0000, 'ºC'),
	(234147, 122, '2014-03-01 00:04:05.000000', 'temperatura', 1084.0000, 'ºC'),
	(234148, 122, '2014-03-01 00:04:06.000000', 'temperatura', 497.0000, 'ºC'),
	(234149, 122, '2014-03-01 00:04:07.000000', 'temperatura', 432.0000, 'ºC'),
	(234150, 122, '2014-03-01 00:04:08.000000', 'temperatura', 670.0000, 'ºC'),
	(234151, 122, '2014-03-01 00:04:09.000000', 'temperatura', 855.0000, 'ºC'),
	(234152, 122, '2014-03-01 00:04:10.000000', 'temperatura', 1064.0000, 'ºC'),
	(234153, 122, '2014-03-01 00:04:11.000000', 'temperatura', 358.0000, 'ºC'),
	(234154, 122, '2014-03-01 00:04:12.000000', 'temperatura', 999.0000, 'ºC'),
	(234155, 122, '2014-03-01 00:04:13.000000', 'temperatura', 320.0000, 'ºC'),
	(234156, 122, '2014-03-01 00:04:14.000000', 'temperatura', 1003.0000, 'ºC'),
	(234157, 122, '2014-03-01 00:04:15.000000', 'temperatura', 457.0000, 'ºC'),
	(234158, 122, '2014-03-01 00:04:16.000000', 'temperatura', 477.0000, 'ºC'),
	(234159, 122, '2014-03-01 00:04:17.000000', 'temperatura', 1012.0000, 'ºC'),
	(234160, 122, '2014-03-01 00:04:18.000000', 'temperatura', 31.0000, 'ºC'),
	(234161, 122, '2014-03-01 00:04:19.000000', 'temperatura', 721.0000, 'ºC'),
	(234162, 122, '2014-03-01 00:04:20.000000', 'temperatura', 1110.0000, 'ºC'),
	(234163, 122, '2014-03-01 00:04:21.000000', 'temperatura', 989.0000, 'ºC'),
	(234164, 122, '2014-03-01 00:04:22.000000', 'temperatura', 413.0000, 'ºC'),
	(234165, 122, '2014-03-01 00:04:23.000000', 'temperatura', 300.0000, 'ºC'),
	(234166, 122, '2014-03-01 00:04:24.000000', 'temperatura', 260.0000, 'ºC'),
	(234167, 122, '2014-03-01 00:04:25.000000', 'temperatura', 402.0000, 'ºC'),
	(234168, 122, '2014-03-01 00:04:26.000000', 'temperatura', 29.0000, 'ºC'),
	(234169, 122, '2014-03-01 00:04:27.000000', 'temperatura', 142.0000, 'ºC'),
	(234170, 122, '2014-03-01 00:04:28.000000', 'temperatura', 621.0000, 'ºC'),
	(234171, 122, '2014-03-01 00:04:29.000000', 'temperatura', 282.0000, 'ºC'),
	(234172, 122, '2014-03-01 00:04:30.000000', 'temperatura', 746.0000, 'ºC'),
	(234173, 122, '2014-03-01 00:04:31.000000', 'temperatura', 487.0000, 'ºC'),
	(234174, 122, '2014-03-01 00:04:32.000000', 'temperatura', 195.0000, 'ºC'),
	(234175, 122, '2014-03-01 00:04:33.000000', 'temperatura', 714.0000, 'ºC'),
	(234176, 122, '2014-03-01 00:04:34.000000', 'temperatura', 584.0000, 'ºC'),
	(234177, 122, '2014-03-01 00:04:35.000000', 'temperatura', 781.0000, 'ºC'),
	(234178, 122, '2014-03-01 00:04:36.000000', 'temperatura', 954.0000, 'ºC'),
	(234179, 122, '2014-03-01 00:04:37.000000', 'temperatura', 27.0000, 'ºC'),
	(234180, 122, '2014-03-01 00:04:38.000000', 'temperatura', 874.0000, 'ºC'),
	(234181, 122, '2014-03-01 00:04:39.000000', 'temperatura', 687.0000, 'ºC'),
	(234182, 122, '2014-03-01 00:04:40.000000', 'temperatura', 816.0000, 'ºC'),
	(234183, 122, '2014-03-01 00:04:41.000000', 'temperatura', 818.0000, 'ºC'),
	(234184, 122, '2014-03-01 00:04:42.000000', 'temperatura', 442.0000, 'ºC'),
	(234185, 122, '2014-03-01 00:04:43.000000', 'temperatura', 955.0000, 'ºC'),
	(234186, 122, '2014-03-01 00:04:44.000000', 'temperatura', 1052.0000, 'ºC'),
	(234187, 122, '2014-03-01 00:04:45.000000', 'temperatura', 1195.0000, 'ºC'),
	(234188, 122, '2014-03-01 00:04:46.000000', 'temperatura', 420.0000, 'ºC'),
	(234189, 122, '2014-03-01 00:04:47.000000', 'temperatura', 915.0000, 'ºC'),
	(234190, 122, '2014-03-01 00:04:48.000000', 'temperatura', 916.0000, 'ºC'),
	(234191, 122, '2014-03-01 00:04:49.000000', 'temperatura', 633.0000, 'ºC'),
	(234192, 122, '2014-03-01 00:04:50.000000', 'temperatura', 420.0000, 'ºC'),
	(234193, 122, '2014-03-01 00:04:51.000000', 'temperatura', 200.0000, 'ºC'),
	(234194, 122, '2014-03-01 00:04:52.000000', 'temperatura', 941.0000, 'ºC'),
	(234195, 122, '2014-03-01 00:04:53.000000', 'temperatura', 505.0000, 'ºC'),
	(234196, 122, '2014-03-01 00:04:54.000000', 'temperatura', 901.0000, 'ºC'),
	(234197, 122, '2014-03-01 00:04:55.000000', 'temperatura', 591.0000, 'ºC'),
	(234198, 122, '2014-03-01 00:04:56.000000', 'temperatura', 254.0000, 'ºC'),
	(234199, 122, '2014-03-01 00:04:57.000000', 'temperatura', 696.0000, 'ºC'),
	(234200, 122, '2014-03-01 00:04:58.000000', 'temperatura', 319.0000, 'ºC'),
	(234201, 122, '2014-03-01 00:04:59.000000', 'temperatura', 706.0000, 'ºC'),
	(234202, 122, '2014-03-01 00:05:00.000000', 'temperatura', 177.0000, 'ºC'),
	(234203, 122, '2014-03-01 00:05:01.000000', 'temperatura', 1164.0000, 'ºC'),
	(234204, 122, '2014-03-01 00:05:02.000000', 'temperatura', 490.0000, 'ºC'),
	(234205, 122, '2014-03-01 00:05:03.000000', 'temperatura', 161.0000, 'ºC'),
	(234206, 122, '2014-03-01 00:05:04.000000', 'temperatura', 533.0000, 'ºC'),
	(234207, 122, '2014-03-01 00:05:05.000000', 'temperatura', 982.0000, 'ºC'),
	(234208, 122, '2014-03-01 00:05:06.000000', 'temperatura', 912.0000, 'ºC'),
	(234209, 122, '2014-03-01 00:05:07.000000', 'temperatura', 416.0000, 'ºC'),
	(234210, 122, '2014-03-01 00:05:08.000000', 'temperatura', 546.0000, 'ºC'),
	(234211, 122, '2014-03-01 00:05:09.000000', 'temperatura', 280.0000, 'ºC'),
	(234212, 122, '2014-03-01 00:05:10.000000', 'temperatura', 962.0000, 'ºC'),
	(234213, 122, '2014-03-01 00:05:11.000000', 'temperatura', 370.0000, 'ºC'),
	(234214, 122, '2014-03-01 00:05:12.000000', 'temperatura', 167.0000, 'ºC'),
	(234215, 122, '2014-03-01 00:05:13.000000', 'temperatura', 923.0000, 'ºC'),
	(234216, 122, '2014-03-01 00:05:14.000000', 'temperatura', 514.0000, 'ºC'),
	(234217, 122, '2014-03-01 00:05:15.000000', 'temperatura', 1003.0000, 'ºC'),
	(234218, 122, '2014-03-01 00:05:16.000000', 'temperatura', 1073.0000, 'ºC'),
	(234219, 122, '2014-03-01 00:05:17.000000', 'temperatura', 1157.0000, 'ºC'),
	(234220, 122, '2014-03-01 00:05:18.000000', 'temperatura', 167.0000, 'ºC'),
	(234221, 122, '2014-03-01 00:05:19.000000', 'temperatura', 966.0000, 'ºC'),
	(234222, 122, '2014-03-01 00:05:20.000000', 'temperatura', 727.0000, 'ºC'),
	(234223, 122, '2014-03-01 00:05:21.000000', 'temperatura', 736.0000, 'ºC'),
	(234224, 122, '2014-03-01 00:05:22.000000', 'temperatura', 302.0000, 'ºC'),
	(234225, 122, '2014-03-01 00:05:23.000000', 'temperatura', 503.0000, 'ºC'),
	(234226, 122, '2014-03-01 00:05:24.000000', 'temperatura', 407.0000, 'ºC'),
	(234227, 122, '2014-03-01 00:05:25.000000', 'temperatura', 529.0000, 'ºC'),
	(234228, 122, '2014-03-01 00:05:26.000000', 'temperatura', 222.0000, 'ºC'),
	(234229, 122, '2014-03-01 00:05:27.000000', 'temperatura', 725.0000, 'ºC'),
	(234230, 122, '2014-03-01 00:05:28.000000', 'temperatura', 557.0000, 'ºC'),
	(234231, 122, '2014-03-01 00:05:29.000000', 'temperatura', 614.0000, 'ºC'),
	(234232, 122, '2014-03-01 00:05:30.000000', 'temperatura', 197.0000, 'ºC'),
	(234233, 122, '2014-03-01 00:05:31.000000', 'temperatura', 346.0000, 'ºC'),
	(234234, 122, '2014-03-01 00:05:32.000000', 'temperatura', 1138.0000, 'ºC'),
	(234235, 122, '2014-03-01 00:05:33.000000', 'temperatura', 1053.0000, 'ºC'),
	(234236, 122, '2014-03-01 00:05:34.000000', 'temperatura', 650.0000, 'ºC'),
	(234237, 122, '2014-03-01 00:05:35.000000', 'temperatura', 91.0000, 'ºC'),
	(234238, 122, '2014-03-01 00:05:36.000000', 'temperatura', 904.0000, 'ºC'),
	(234239, 122, '2014-03-01 00:05:37.000000', 'temperatura', 651.0000, 'ºC'),
	(234240, 122, '2014-03-01 00:05:38.000000', 'temperatura', 541.0000, 'ºC'),
	(234241, 122, '2014-03-01 00:05:39.000000', 'temperatura', 754.0000, 'ºC'),
	(234242, 122, '2014-03-01 00:05:40.000000', 'temperatura', 949.0000, 'ºC'),
	(234243, 122, '2014-03-01 00:05:41.000000', 'temperatura', 81.0000, 'ºC'),
	(234244, 122, '2014-03-01 00:05:42.000000', 'temperatura', 1161.0000, 'ºC'),
	(234245, 122, '2014-03-01 00:05:43.000000', 'temperatura', 761.0000, 'ºC'),
	(234246, 122, '2014-03-01 00:05:44.000000', 'temperatura', 323.0000, 'ºC'),
	(234247, 122, '2014-03-01 00:05:45.000000', 'temperatura', 534.0000, 'ºC'),
	(234248, 122, '2014-03-01 00:05:46.000000', 'temperatura', 501.0000, 'ºC'),
	(234249, 122, '2014-03-01 00:05:47.000000', 'temperatura', 902.0000, 'ºC'),
	(234250, 122, '2014-03-01 00:05:48.000000', 'temperatura', 607.0000, 'ºC'),
	(234251, 122, '2014-03-01 00:05:49.000000', 'temperatura', 329.0000, 'ºC'),
	(234252, 122, '2014-03-01 00:05:50.000000', 'temperatura', 1024.0000, 'ºC'),
	(234253, 122, '2014-03-01 00:05:51.000000', 'temperatura', 534.0000, 'ºC'),
	(234254, 122, '2014-03-01 00:05:52.000000', 'temperatura', 799.0000, 'ºC'),
	(234255, 122, '2014-03-01 00:05:53.000000', 'temperatura', 1192.0000, 'ºC'),
	(234256, 122, '2014-03-01 00:05:54.000000', 'temperatura', 1163.0000, 'ºC'),
	(234257, 122, '2014-03-01 00:05:55.000000', 'temperatura', 1040.0000, 'ºC'),
	(234258, 122, '2014-03-01 00:05:56.000000', 'temperatura', 510.0000, 'ºC'),
	(234259, 122, '2014-03-01 00:05:57.000000', 'temperatura', 633.0000, 'ºC'),
	(234260, 122, '2014-03-01 00:05:58.000000', 'temperatura', 435.0000, 'ºC'),
	(234261, 122, '2014-03-01 00:05:59.000000', 'temperatura', 276.0000, 'ºC'),
	(234262, 122, '2014-03-01 00:06:00.000000', 'temperatura', 76.0000, 'ºC'),
	(234263, 122, '2014-03-01 00:06:01.000000', 'temperatura', 754.0000, 'ºC'),
	(234264, 122, '2014-03-01 00:06:02.000000', 'temperatura', 1142.0000, 'ºC'),
	(234265, 122, '2014-03-01 00:06:03.000000', 'temperatura', 1047.0000, 'ºC'),
	(234266, 122, '2014-03-01 00:06:04.000000', 'temperatura', 611.0000, 'ºC'),
	(234267, 122, '2014-03-01 00:06:05.000000', 'temperatura', 1115.0000, 'ºC'),
	(234268, 122, '2014-03-01 00:06:06.000000', 'temperatura', 142.0000, 'ºC'),
	(234269, 122, '2014-03-01 00:06:07.000000', 'temperatura', 964.0000, 'ºC'),
	(234270, 122, '2014-03-01 00:06:08.000000', 'temperatura', 796.0000, 'ºC'),
	(234271, 122, '2014-03-01 00:06:09.000000', 'temperatura', 1088.0000, 'ºC'),
	(234272, 122, '2014-03-01 00:06:10.000000', 'temperatura', 654.0000, 'ºC'),
	(234273, 122, '2014-03-01 00:06:11.000000', 'temperatura', 7.0000, 'ºC'),
	(234274, 122, '2014-03-01 00:06:12.000000', 'temperatura', 475.0000, 'ºC'),
	(234275, 122, '2014-03-01 00:06:13.000000', 'temperatura', 1151.0000, 'ºC'),
	(234276, 122, '2014-03-01 00:06:14.000000', 'temperatura', 731.0000, 'ºC'),
	(234277, 122, '2014-03-01 00:06:15.000000', 'temperatura', 202.0000, 'ºC'),
	(234278, 122, '2014-03-01 00:06:16.000000', 'temperatura', 19.0000, 'ºC'),
	(234279, 122, '2014-03-01 00:06:17.000000', 'temperatura', 691.0000, 'ºC'),
	(234280, 122, '2014-03-01 00:06:18.000000', 'temperatura', 997.0000, 'ºC'),
	(234281, 122, '2014-03-01 00:06:19.000000', 'temperatura', 511.0000, 'ºC'),
	(234282, 122, '2014-03-01 00:06:20.000000', 'temperatura', 764.0000, 'ºC'),
	(234283, 122, '2014-03-01 00:06:21.000000', 'temperatura', 1088.0000, 'ºC'),
	(234284, 122, '2014-03-01 00:06:22.000000', 'temperatura', 749.0000, 'ºC'),
	(234285, 122, '2014-03-01 00:06:23.000000', 'temperatura', 481.0000, 'ºC'),
	(234286, 122, '2014-03-01 00:06:24.000000', 'temperatura', 158.0000, 'ºC'),
	(234287, 122, '2014-03-01 00:06:25.000000', 'temperatura', 550.0000, 'ºC'),
	(234288, 122, '2014-03-01 00:06:26.000000', 'temperatura', 1075.0000, 'ºC'),
	(234289, 122, '2014-03-01 00:06:27.000000', 'temperatura', 126.0000, 'ºC'),
	(234290, 122, '2014-03-01 00:06:28.000000', 'temperatura', 1005.0000, 'ºC'),
	(234291, 122, '2014-03-01 00:06:29.000000', 'temperatura', 1048.0000, 'ºC'),
	(234292, 122, '2014-03-01 00:06:30.000000', 'temperatura', 1027.0000, 'ºC'),
	(234293, 122, '2014-03-01 00:06:31.000000', 'temperatura', 790.0000, 'ºC'),
	(234294, 122, '2014-03-01 00:06:32.000000', 'temperatura', 871.0000, 'ºC'),
	(234295, 122, '2014-03-01 00:06:33.000000', 'temperatura', 783.0000, 'ºC'),
	(234296, 122, '2014-03-01 00:06:34.000000', 'temperatura', 104.0000, 'ºC'),
	(234297, 122, '2014-03-01 00:06:35.000000', 'temperatura', 570.0000, 'ºC'),
	(234298, 122, '2014-03-01 00:06:36.000000', 'temperatura', 140.0000, 'ºC'),
	(234299, 122, '2014-03-01 00:06:37.000000', 'temperatura', 190.0000, 'ºC'),
	(234300, 122, '2014-03-01 00:06:38.000000', 'temperatura', 529.0000, 'ºC'),
	(234301, 122, '2014-03-01 00:06:39.000000', 'temperatura', 876.0000, 'ºC'),
	(234302, 122, '2014-03-01 00:06:40.000000', 'temperatura', 393.0000, 'ºC'),
	(234303, 122, '2014-03-01 00:06:41.000000', 'temperatura', 539.0000, 'ºC'),
	(234304, 122, '2014-03-01 00:06:42.000000', 'temperatura', 316.0000, 'ºC'),
	(234305, 122, '2014-03-01 00:06:43.000000', 'temperatura', 1162.0000, 'ºC'),
	(234306, 122, '2014-03-01 00:06:44.000000', 'temperatura', 63.0000, 'ºC'),
	(234307, 122, '2014-03-01 00:06:45.000000', 'temperatura', 431.0000, 'ºC'),
	(234308, 122, '2014-03-01 00:06:46.000000', 'temperatura', 764.0000, 'ºC'),
	(234309, 122, '2014-03-01 00:06:47.000000', 'temperatura', 131.0000, 'ºC'),
	(234310, 122, '2014-03-01 00:06:48.000000', 'temperatura', 761.0000, 'ºC'),
	(234311, 122, '2014-03-01 00:06:49.000000', 'temperatura', 1011.0000, 'ºC'),
	(234312, 122, '2014-03-01 00:06:50.000000', 'temperatura', 375.0000, 'ºC'),
	(234313, 122, '2014-03-01 00:06:51.000000', 'temperatura', 40.0000, 'ºC'),
	(234314, 122, '2014-03-01 00:06:52.000000', 'temperatura', 276.0000, 'ºC'),
	(234315, 122, '2014-03-01 00:06:53.000000', 'temperatura', 62.0000, 'ºC'),
	(234316, 122, '2014-03-01 00:06:54.000000', 'temperatura', 683.0000, 'ºC'),
	(234317, 122, '2014-03-01 00:06:55.000000', 'temperatura', 828.0000, 'ºC'),
	(234318, 122, '2014-03-01 00:06:56.000000', 'temperatura', 891.0000, 'ºC'),
	(234319, 122, '2014-03-01 00:06:57.000000', 'temperatura', 774.0000, 'ºC'),
	(234320, 122, '2014-03-01 00:06:58.000000', 'temperatura', 1195.0000, 'ºC'),
	(234321, 122, '2014-03-01 00:06:59.000000', 'temperatura', 53.0000, 'ºC'),
	(234322, 122, '2014-03-01 00:07:00.000000', 'temperatura', 280.0000, 'ºC'),
	(234323, 122, '2014-03-01 00:07:01.000000', 'temperatura', 41.0000, 'ºC'),
	(234324, 122, '2014-03-01 00:07:02.000000', 'temperatura', 565.0000, 'ºC'),
	(234325, 122, '2014-03-01 00:07:03.000000', 'temperatura', 304.0000, 'ºC'),
	(234326, 122, '2014-03-01 00:07:04.000000', 'temperatura', 1027.0000, 'ºC'),
	(234327, 122, '2014-03-01 00:07:05.000000', 'temperatura', 622.0000, 'ºC'),
	(234328, 122, '2014-03-01 00:07:06.000000', 'temperatura', 29.0000, 'ºC'),
	(234329, 122, '2014-03-01 00:07:07.000000', 'temperatura', 679.0000, 'ºC'),
	(234330, 122, '2014-03-01 00:07:08.000000', 'temperatura', 909.0000, 'ºC'),
	(234331, 122, '2014-03-01 00:07:09.000000', 'temperatura', 108.0000, 'ºC'),
	(234332, 122, '2014-03-01 00:07:10.000000', 'temperatura', 213.0000, 'ºC'),
	(234333, 122, '2014-03-01 00:07:11.000000', 'temperatura', 742.0000, 'ºC'),
	(234334, 122, '2014-03-01 00:07:12.000000', 'temperatura', 672.0000, 'ºC'),
	(234335, 122, '2014-03-01 00:07:13.000000', 'temperatura', 1133.0000, 'ºC'),
	(234336, 122, '2014-03-01 00:07:14.000000', 'temperatura', 52.0000, 'ºC'),
	(234337, 122, '2014-03-01 00:07:15.000000', 'temperatura', 460.0000, 'ºC'),
	(234338, 122, '2014-03-01 00:07:16.000000', 'temperatura', 943.0000, 'ºC'),
	(234339, 122, '2014-03-01 00:07:17.000000', 'temperatura', 938.0000, 'ºC'),
	(234340, 122, '2014-03-01 00:07:18.000000', 'temperatura', 660.0000, 'ºC'),
	(234341, 122, '2014-03-01 00:07:19.000000', 'temperatura', 488.0000, 'ºC'),
	(234342, 122, '2014-03-01 00:07:20.000000', 'temperatura', 458.0000, 'ºC'),
	(234343, 122, '2014-03-01 00:07:21.000000', 'temperatura', 826.0000, 'ºC'),
	(234344, 122, '2014-03-01 00:07:22.000000', 'temperatura', 360.0000, 'ºC'),
	(234345, 122, '2014-03-01 00:07:23.000000', 'temperatura', 519.0000, 'ºC'),
	(234346, 122, '2014-03-01 00:07:24.000000', 'temperatura', 319.0000, 'ºC'),
	(234347, 122, '2014-03-01 00:07:25.000000', 'temperatura', 35.0000, 'ºC'),
	(234348, 122, '2014-03-01 00:07:26.000000', 'temperatura', 420.0000, 'ºC'),
	(234349, 122, '2014-03-01 00:07:27.000000', 'temperatura', 794.0000, 'ºC'),
	(234350, 122, '2014-03-01 00:07:28.000000', 'temperatura', 311.0000, 'ºC'),
	(234351, 122, '2014-03-01 00:07:29.000000', 'temperatura', 374.0000, 'ºC'),
	(234352, 122, '2014-03-01 00:07:30.000000', 'temperatura', 939.0000, 'ºC'),
	(234353, 122, '2014-03-01 00:07:31.000000', 'temperatura', 1171.0000, 'ºC'),
	(234354, 122, '2014-03-01 00:07:32.000000', 'temperatura', 639.0000, 'ºC'),
	(234355, 122, '2014-03-01 00:07:33.000000', 'temperatura', 885.0000, 'ºC'),
	(234356, 122, '2014-03-01 00:07:34.000000', 'temperatura', 106.0000, 'ºC'),
	(234357, 122, '2014-03-01 00:07:35.000000', 'temperatura', 275.0000, 'ºC'),
	(234358, 122, '2014-03-01 00:07:36.000000', 'temperatura', 1060.0000, 'ºC'),
	(234359, 122, '2014-03-01 00:07:37.000000', 'temperatura', 874.0000, 'ºC'),
	(234360, 122, '2014-03-01 00:07:38.000000', 'temperatura', 1190.0000, 'ºC'),
	(234361, 122, '2014-03-01 00:07:39.000000', 'temperatura', 930.0000, 'ºC'),
	(234362, 122, '2014-03-01 00:07:40.000000', 'temperatura', 1078.0000, 'ºC'),
	(234363, 122, '2014-03-01 00:07:41.000000', 'temperatura', 203.0000, 'ºC'),
	(234364, 122, '2014-03-01 00:07:42.000000', 'temperatura', 180.0000, 'ºC'),
	(234365, 122, '2014-03-01 00:07:43.000000', 'temperatura', 292.0000, 'ºC'),
	(234366, 122, '2014-03-01 00:07:44.000000', 'temperatura', 920.0000, 'ºC'),
	(234367, 122, '2014-03-01 00:07:45.000000', 'temperatura', 127.0000, 'ºC'),
	(234368, 122, '2014-03-01 00:07:46.000000', 'temperatura', 273.0000, 'ºC'),
	(234369, 122, '2014-03-01 00:07:47.000000', 'temperatura', 984.0000, 'ºC'),
	(234370, 122, '2014-03-01 00:07:48.000000', 'temperatura', 502.0000, 'ºC'),
	(234371, 122, '2014-03-01 00:07:49.000000', 'temperatura', 758.0000, 'ºC'),
	(234372, 122, '2014-03-01 00:07:50.000000', 'temperatura', 1083.0000, 'ºC'),
	(234373, 122, '2014-03-01 00:07:51.000000', 'temperatura', 743.0000, 'ºC'),
	(234374, 122, '2014-03-01 00:07:52.000000', 'temperatura', 467.0000, 'ºC'),
	(234375, 122, '2014-03-01 00:07:53.000000', 'temperatura', 106.0000, 'ºC'),
	(234376, 122, '2014-03-01 00:07:54.000000', 'temperatura', 330.0000, 'ºC'),
	(234377, 122, '2014-03-01 00:07:55.000000', 'temperatura', 131.0000, 'ºC'),
	(234378, 122, '2014-03-01 00:07:56.000000', 'temperatura', 865.0000, 'ºC'),
	(234379, 122, '2014-03-01 00:07:57.000000', 'temperatura', 332.0000, 'ºC'),
	(234380, 122, '2014-03-01 00:07:58.000000', 'temperatura', 266.0000, 'ºC'),
	(234381, 122, '2014-03-01 00:07:59.000000', 'temperatura', 336.0000, 'ºC'),
	(234382, 122, '2014-03-01 00:08:00.000000', 'temperatura', 882.0000, 'ºC'),
	(234383, 122, '2014-03-01 00:08:01.000000', 'temperatura', 1000.0000, 'ºC'),
	(234384, 122, '2014-03-01 00:08:02.000000', 'temperatura', 1158.0000, 'ºC'),
	(234385, 122, '2014-03-01 00:08:03.000000', 'temperatura', 387.0000, 'ºC'),
	(234386, 122, '2014-03-01 00:08:04.000000', 'temperatura', 864.0000, 'ºC'),
	(234387, 122, '2014-03-01 00:08:05.000000', 'temperatura', 758.0000, 'ºC'),
	(234388, 122, '2014-03-01 00:08:06.000000', 'temperatura', 1199.0000, 'ºC'),
	(234389, 122, '2014-03-01 00:08:07.000000', 'temperatura', 120.0000, 'ºC'),
	(234390, 122, '2014-03-01 00:08:08.000000', 'temperatura', 605.0000, 'ºC'),
	(234391, 122, '2014-03-01 00:08:09.000000', 'temperatura', 266.0000, 'ºC'),
	(234392, 122, '2014-03-01 00:08:10.000000', 'temperatura', 714.0000, 'ºC'),
	(234393, 122, '2014-03-01 00:08:11.000000', 'temperatura', 374.0000, 'ºC'),
	(234394, 122, '2014-03-01 00:08:12.000000', 'temperatura', 928.0000, 'ºC'),
	(234395, 122, '2014-03-01 00:08:13.000000', 'temperatura', 1116.0000, 'ºC'),
	(234396, 122, '2014-03-01 00:08:14.000000', 'temperatura', 400.0000, 'ºC'),
	(234397, 122, '2014-03-01 00:08:15.000000', 'temperatura', 1050.0000, 'ºC'),
	(234398, 122, '2014-03-01 00:08:16.000000', 'temperatura', 452.0000, 'ºC'),
	(234399, 122, '2014-03-01 00:08:17.000000', 'temperatura', 310.0000, 'ºC'),
	(234400, 122, '2014-03-01 00:08:18.000000', 'temperatura', 197.0000, 'ºC'),
	(234401, 122, '2014-03-01 00:08:19.000000', 'temperatura', 52.0000, 'ºC'),
	(234402, 122, '2014-03-01 00:08:20.000000', 'temperatura', 872.0000, 'ºC'),
	(234403, 122, '2014-03-01 00:08:21.000000', 'temperatura', 605.0000, 'ºC'),
	(234404, 122, '2014-03-01 00:08:22.000000', 'temperatura', 408.0000, 'ºC'),
	(234405, 122, '2014-03-01 00:08:23.000000', 'temperatura', 227.0000, 'ºC'),
	(234406, 122, '2014-03-01 00:08:24.000000', 'temperatura', 1109.0000, 'ºC'),
	(234407, 122, '2014-03-01 00:08:25.000000', 'temperatura', 68.0000, 'ºC'),
	(234408, 122, '2014-03-01 00:08:26.000000', 'temperatura', 610.0000, 'ºC'),
	(234409, 122, '2014-03-01 00:08:27.000000', 'temperatura', 447.0000, 'ºC'),
	(234410, 122, '2014-03-01 00:08:28.000000', 'temperatura', 405.0000, 'ºC'),
	(234411, 122, '2014-03-01 00:08:29.000000', 'temperatura', 685.0000, 'ºC'),
	(234412, 122, '2014-03-01 00:08:30.000000', 'temperatura', 1010.0000, 'ºC'),
	(234413, 122, '2014-03-01 00:08:31.000000', 'temperatura', 597.0000, 'ºC'),
	(234414, 122, '2014-03-01 00:08:32.000000', 'temperatura', 1154.0000, 'ºC'),
	(234415, 122, '2014-03-01 00:08:33.000000', 'temperatura', 382.0000, 'ºC'),
	(234416, 122, '2014-03-01 00:08:34.000000', 'temperatura', 846.0000, 'ºC'),
	(234417, 122, '2014-03-01 00:08:35.000000', 'temperatura', 687.0000, 'ºC'),
	(234418, 122, '2014-03-01 00:08:36.000000', 'temperatura', 897.0000, 'ºC'),
	(234419, 122, '2014-03-01 00:08:37.000000', 'temperatura', 25.0000, 'ºC'),
	(234420, 122, '2014-03-01 00:08:38.000000', 'temperatura', 1035.0000, 'ºC'),
	(234421, 122, '2014-03-01 00:08:39.000000', 'temperatura', 301.0000, 'ºC'),
	(234422, 122, '2014-03-01 00:08:40.000000', 'temperatura', 800.0000, 'ºC'),
	(234423, 122, '2014-03-01 00:08:41.000000', 'temperatura', 698.0000, 'ºC'),
	(234424, 122, '2014-03-01 00:08:42.000000', 'temperatura', 1092.0000, 'ºC'),
	(234425, 122, '2014-03-01 00:08:43.000000', 'temperatura', 964.0000, 'ºC'),
	(234426, 122, '2014-03-01 00:08:44.000000', 'temperatura', 344.0000, 'ºC'),
	(234427, 122, '2014-03-01 00:08:45.000000', 'temperatura', 31.0000, 'ºC'),
	(234428, 122, '2014-03-01 00:08:46.000000', 'temperatura', 321.0000, 'ºC'),
	(234429, 122, '2014-03-01 00:08:47.000000', 'temperatura', 313.0000, 'ºC'),
	(234430, 122, '2014-03-01 00:08:48.000000', 'temperatura', 601.0000, 'ºC'),
	(234431, 122, '2014-03-01 00:08:49.000000', 'temperatura', 870.0000, 'ºC'),
	(234432, 122, '2014-03-01 00:08:50.000000', 'temperatura', 145.0000, 'ºC'),
	(234433, 122, '2014-03-01 00:08:51.000000', 'temperatura', 517.0000, 'ºC'),
	(234434, 122, '2014-03-01 00:08:52.000000', 'temperatura', 949.0000, 'ºC'),
	(234435, 122, '2014-03-01 00:08:53.000000', 'temperatura', 794.0000, 'ºC'),
	(234436, 122, '2014-03-01 00:08:54.000000', 'temperatura', 1124.0000, 'ºC'),
	(234437, 122, '2014-03-01 00:08:55.000000', 'temperatura', 840.0000, 'ºC'),
	(234438, 122, '2014-03-01 00:08:56.000000', 'temperatura', 827.0000, 'ºC'),
	(234439, 122, '2014-03-01 00:08:57.000000', 'temperatura', 415.0000, 'ºC'),
	(234440, 122, '2014-03-01 00:08:58.000000', 'temperatura', 795.0000, 'ºC'),
	(234441, 122, '2014-03-01 00:08:59.000000', 'temperatura', 333.0000, 'ºC'),
	(234442, 122, '2014-03-01 00:09:00.000000', 'temperatura', 477.0000, 'ºC'),
	(234443, 122, '2014-03-01 00:09:01.000000', 'temperatura', 187.0000, 'ºC'),
	(234444, 122, '2014-03-01 00:09:02.000000', 'temperatura', 705.0000, 'ºC'),
	(234445, 122, '2014-03-01 00:09:03.000000', 'temperatura', 564.0000, 'ºC'),
	(234446, 122, '2014-03-01 00:09:04.000000', 'temperatura', 706.0000, 'ºC'),
	(234447, 122, '2014-03-01 00:09:05.000000', 'temperatura', 639.0000, 'ºC'),
	(234448, 122, '2014-03-01 00:09:06.000000', 'temperatura', 1075.0000, 'ºC'),
	(234449, 122, '2014-03-01 00:09:07.000000', 'temperatura', 1062.0000, 'ºC'),
	(234450, 122, '2014-03-01 00:09:08.000000', 'temperatura', 884.0000, 'ºC'),
	(234451, 122, '2014-03-01 00:09:09.000000', 'temperatura', 34.0000, 'ºC'),
	(234452, 122, '2014-03-01 00:09:10.000000', 'temperatura', 1120.0000, 'ºC'),
	(234453, 122, '2014-03-01 00:09:11.000000', 'temperatura', 696.0000, 'ºC'),
	(234454, 122, '2014-03-01 00:09:12.000000', 'temperatura', 122.0000, 'ºC'),
	(234455, 122, '2014-03-01 00:09:13.000000', 'temperatura', 921.0000, 'ºC'),
	(234456, 122, '2014-03-01 00:09:14.000000', 'temperatura', 638.0000, 'ºC'),
	(234457, 122, '2014-03-01 00:09:15.000000', 'temperatura', 431.0000, 'ºC'),
	(234458, 122, '2014-03-01 00:09:16.000000', 'temperatura', 240.0000, 'ºC'),
	(234459, 122, '2014-03-01 00:09:17.000000', 'temperatura', 1107.0000, 'ºC'),
	(234460, 122, '2014-03-01 00:09:18.000000', 'temperatura', 16.0000, 'ºC'),
	(234461, 122, '2014-03-01 00:09:19.000000', 'temperatura', 358.0000, 'ºC'),
	(234462, 122, '2014-03-01 00:09:20.000000', 'temperatura', 545.0000, 'ºC'),
	(234463, 122, '2014-03-01 00:09:21.000000', 'temperatura', 451.0000, 'ºC'),
	(234464, 122, '2014-03-01 00:09:22.000000', 'temperatura', 619.0000, 'ºC'),
	(234465, 122, '2014-03-01 00:09:23.000000', 'temperatura', 544.0000, 'ºC'),
	(234466, 122, '2014-03-01 00:09:24.000000', 'temperatura', 862.0000, 'ºC'),
	(234467, 122, '2014-03-01 00:09:25.000000', 'temperatura', 280.0000, 'ºC'),
	(234468, 122, '2014-03-01 00:09:26.000000', 'temperatura', 13.0000, 'ºC'),
	(234469, 122, '2014-03-01 00:09:27.000000', 'temperatura', 427.0000, 'ºC'),
	(234470, 122, '2014-03-01 00:09:28.000000', 'temperatura', 896.0000, 'ºC'),
	(234471, 122, '2014-03-01 00:09:29.000000', 'temperatura', 801.0000, 'ºC'),
	(234472, 122, '2014-03-01 00:09:30.000000', 'temperatura', 117.0000, 'ºC'),
	(234473, 122, '2014-03-01 00:09:31.000000', 'temperatura', 583.0000, 'ºC'),
	(234474, 122, '2014-03-01 00:09:32.000000', 'temperatura', 163.0000, 'ºC'),
	(234475, 122, '2014-03-01 00:09:33.000000', 'temperatura', 268.0000, 'ºC'),
	(234476, 122, '2014-03-01 00:09:34.000000', 'temperatura', 853.0000, 'ºC'),
	(234477, 122, '2014-03-01 00:09:35.000000', 'temperatura', 1059.0000, 'ºC'),
	(234478, 122, '2014-03-01 00:09:36.000000', 'temperatura', 339.0000, 'ºC'),
	(234479, 122, '2014-03-01 00:09:37.000000', 'temperatura', 918.0000, 'ºC'),
	(234480, 122, '2014-03-01 00:09:38.000000', 'temperatura', 1175.0000, 'ºC'),
	(234481, 122, '2014-03-01 00:09:39.000000', 'temperatura', 721.0000, 'ºC'),
	(234482, 122, '2014-03-01 00:09:40.000000', 'temperatura', 78.0000, 'ºC'),
	(234483, 122, '2014-03-01 00:09:41.000000', 'temperatura', 628.0000, 'ºC'),
	(234484, 122, '2014-03-01 00:09:42.000000', 'temperatura', 508.0000, 'ºC'),
	(234485, 122, '2014-03-01 00:09:43.000000', 'temperatura', 655.0000, 'ºC'),
	(234486, 122, '2014-03-01 00:09:44.000000', 'temperatura', 553.0000, 'ºC'),
	(234487, 122, '2014-03-01 00:09:45.000000', 'temperatura', 801.0000, 'ºC'),
	(234488, 122, '2014-03-01 00:09:46.000000', 'temperatura', 1148.0000, 'ºC'),
	(234489, 122, '2014-03-01 00:09:47.000000', 'temperatura', 935.0000, 'ºC'),
	(234490, 122, '2014-03-01 00:09:48.000000', 'temperatura', 32.0000, 'ºC'),
	(234491, 122, '2014-03-01 00:09:49.000000', 'temperatura', 953.0000, 'ºC'),
	(234492, 122, '2014-03-01 00:09:50.000000', 'temperatura', 1073.0000, 'ºC'),
	(234493, 122, '2014-03-01 00:09:51.000000', 'temperatura', 107.0000, 'ºC'),
	(234494, 122, '2014-03-01 00:09:52.000000', 'temperatura', 915.0000, 'ºC'),
	(234495, 122, '2014-03-01 00:09:53.000000', 'temperatura', 655.0000, 'ºC'),
	(234496, 122, '2014-03-01 00:09:54.000000', 'temperatura', 531.0000, 'ºC'),
	(234497, 122, '2014-03-01 00:09:55.000000', 'temperatura', 690.0000, 'ºC'),
	(234498, 122, '2014-03-01 00:09:56.000000', 'temperatura', 658.0000, 'ºC'),
	(234499, 122, '2014-03-01 00:09:57.000000', 'temperatura', 21.0000, 'ºC'),
	(234500, 122, '2014-03-01 00:09:58.000000', 'temperatura', 529.0000, 'ºC'),
	(234501, 122, '2014-03-01 00:09:59.000000', 'temperatura', 185.0000, 'ºC'),
	(234502, 122, '2014-03-01 00:10:00.000000', 'temperatura', 536.0000, 'ºC'),
	(234503, 122, '2014-03-01 00:10:01.000000', 'temperatura', 928.0000, 'ºC'),
	(234504, 122, '2014-03-01 00:10:02.000000', 'temperatura', 633.0000, 'ºC'),
	(234505, 122, '2014-03-01 00:10:03.000000', 'temperatura', 381.0000, 'ºC'),
	(234506, 122, '2014-03-01 00:10:04.000000', 'temperatura', 7.0000, 'ºC'),
	(234507, 122, '2014-03-01 00:10:05.000000', 'temperatura', 93.0000, 'ºC'),
	(234508, 122, '2014-03-01 00:10:06.000000', 'temperatura', 443.0000, 'ºC'),
	(234509, 122, '2014-03-01 00:10:07.000000', 'temperatura', 737.0000, 'ºC'),
	(234510, 122, '2014-03-01 00:10:08.000000', 'temperatura', 1155.0000, 'ºC'),
	(234511, 122, '2014-03-01 00:10:09.000000', 'temperatura', 1164.0000, 'ºC'),
	(234512, 122, '2014-03-01 00:10:10.000000', 'temperatura', 1157.0000, 'ºC'),
	(234513, 122, '2014-03-01 00:10:11.000000', 'temperatura', 1094.0000, 'ºC'),
	(234514, 122, '2014-03-01 00:10:12.000000', 'temperatura', 797.0000, 'ºC'),
	(234515, 122, '2014-03-01 00:10:13.000000', 'temperatura', 704.0000, 'ºC'),
	(234516, 122, '2014-03-01 00:10:14.000000', 'temperatura', 1130.0000, 'ºC'),
	(234517, 122, '2014-03-01 00:10:15.000000', 'temperatura', 1139.0000, 'ºC'),
	(234518, 122, '2014-03-01 00:10:16.000000', 'temperatura', 1105.0000, 'ºC'),
	(234519, 122, '2014-03-01 00:10:17.000000', 'temperatura', 910.0000, 'ºC'),
	(234520, 122, '2014-03-01 00:10:18.000000', 'temperatura', 34.0000, 'ºC'),
	(234521, 122, '2014-03-01 00:10:19.000000', 'temperatura', 1040.0000, 'ºC'),
	(234522, 122, '2014-03-01 00:10:20.000000', 'temperatura', 298.0000, 'ºC'),
	(234523, 122, '2014-03-01 00:10:21.000000', 'temperatura', 770.0000, 'ºC'),
	(234524, 122, '2014-03-01 00:10:22.000000', 'temperatura', 559.0000, 'ºC'),
	(234525, 122, '2014-03-01 00:10:23.000000', 'temperatura', 486.0000, 'ºC'),
	(234526, 122, '2014-03-01 00:10:24.000000', 'temperatura', 753.0000, 'ºC'),
	(234527, 122, '2014-03-01 00:10:25.000000', 'temperatura', 1109.0000, 'ºC'),
	(234528, 122, '2014-03-01 00:10:26.000000', 'temperatura', 884.0000, 'ºC'),
	(234529, 122, '2014-03-01 00:10:27.000000', 'temperatura', 1093.0000, 'ºC'),
	(234530, 122, '2014-03-01 00:10:28.000000', 'temperatura', 414.0000, 'ºC'),
	(234531, 122, '2014-03-01 00:10:29.000000', 'temperatura', 1192.0000, 'ºC'),
	(234532, 122, '2014-03-01 00:10:30.000000', 'temperatura', 1116.0000, 'ºC'),
	(234533, 122, '2014-03-01 00:10:31.000000', 'temperatura', 808.0000, 'ºC'),
	(234534, 122, '2014-03-01 00:10:32.000000', 'temperatura', 691.0000, 'ºC'),
	(234535, 122, '2014-03-01 00:10:33.000000', 'temperatura', 1030.0000, 'ºC'),
	(234536, 122, '2014-03-01 00:10:34.000000', 'temperatura', 679.0000, 'ºC'),
	(234537, 122, '2014-03-01 00:10:35.000000', 'temperatura', 305.0000, 'ºC'),
	(234538, 122, '2014-03-01 00:10:36.000000', 'temperatura', 690.0000, 'ºC'),
	(234539, 122, '2014-03-01 00:10:37.000000', 'temperatura', 134.0000, 'ºC'),
	(234540, 122, '2014-03-01 00:10:38.000000', 'temperatura', 999.0000, 'ºC'),
	(234541, 122, '2014-03-01 00:10:39.000000', 'temperatura', 996.0000, 'ºC'),
	(234542, 122, '2014-03-01 00:10:40.000000', 'temperatura', 784.0000, 'ºC'),
	(234543, 122, '2014-03-01 00:10:41.000000', 'temperatura', 933.0000, 'ºC'),
	(234544, 122, '2014-03-01 00:10:42.000000', 'temperatura', 1113.0000, 'ºC'),
	(234545, 122, '2014-03-01 00:10:43.000000', 'temperatura', 368.0000, 'ºC'),
	(234546, 122, '2014-03-01 00:10:44.000000', 'temperatura', 900.0000, 'ºC'),
	(234547, 122, '2014-03-01 00:10:45.000000', 'temperatura', 998.0000, 'ºC'),
	(234548, 122, '2014-03-01 00:10:46.000000', 'temperatura', 1088.0000, 'ºC'),
	(234549, 122, '2014-03-01 00:10:47.000000', 'temperatura', 47.0000, 'ºC'),
	(234550, 122, '2014-03-01 00:10:48.000000', 'temperatura', 574.0000, 'ºC'),
	(234551, 122, '2014-03-01 00:10:49.000000', 'temperatura', 328.0000, 'ºC'),
	(234552, 122, '2014-03-01 00:10:50.000000', 'temperatura', 1118.0000, 'ºC'),
	(234553, 122, '2014-03-01 00:10:51.000000', 'temperatura', 1005.0000, 'ºC'),
	(234554, 122, '2014-03-01 00:10:52.000000', 'temperatura', 473.0000, 'ºC'),
	(234555, 122, '2014-03-01 00:10:53.000000', 'temperatura', 549.0000, 'ºC'),
	(234556, 122, '2014-03-01 00:10:54.000000', 'temperatura', 128.0000, 'ºC'),
	(234557, 122, '2014-03-01 00:10:55.000000', 'temperatura', 195.0000, 'ºC'),
	(234558, 122, '2014-03-01 00:10:56.000000', 'temperatura', 589.0000, 'ºC'),
	(234559, 122, '2014-03-01 00:10:57.000000', 'temperatura', 1163.0000, 'ºC'),
	(234560, 122, '2014-03-01 00:10:58.000000', 'temperatura', 447.0000, 'ºC'),
	(234561, 122, '2014-03-01 00:10:59.000000', 'temperatura', 1147.0000, 'ºC'),
	(234562, 122, '2014-03-01 00:11:00.000000', 'temperatura', 796.0000, 'ºC'),
	(234563, 122, '2014-03-01 00:11:01.000000', 'temperatura', 539.0000, 'ºC'),
	(234564, 122, '2014-03-01 00:11:02.000000', 'temperatura', 306.0000, 'ºC'),
	(234565, 122, '2014-03-01 00:11:03.000000', 'temperatura', 1112.0000, 'ºC'),
	(234566, 122, '2014-03-01 00:11:04.000000', 'temperatura', 1044.0000, 'ºC'),
	(234567, 122, '2014-03-01 00:11:05.000000', 'temperatura', 687.0000, 'ºC'),
	(234568, 122, '2014-03-01 00:11:06.000000', 'temperatura', 300.0000, 'ºC'),
	(234569, 122, '2014-03-01 00:11:07.000000', 'temperatura', 639.0000, 'ºC'),
	(234570, 122, '2014-03-01 00:11:08.000000', 'temperatura', 1098.0000, 'ºC'),
	(234571, 122, '2014-03-01 00:11:09.000000', 'temperatura', 1173.0000, 'ºC'),
	(234572, 122, '2014-03-01 00:11:10.000000', 'temperatura', 172.0000, 'ºC'),
	(234573, 122, '2014-03-01 00:11:11.000000', 'temperatura', 939.0000, 'ºC'),
	(234574, 122, '2014-03-01 00:11:12.000000', 'temperatura', 581.0000, 'ºC'),
	(234575, 122, '2014-03-01 00:11:13.000000', 'temperatura', 88.0000, 'ºC'),
	(234576, 122, '2014-03-01 00:11:14.000000', 'temperatura', 1099.0000, 'ºC'),
	(234577, 122, '2014-03-01 00:11:15.000000', 'temperatura', 429.0000, 'ºC'),
	(234578, 122, '2014-03-01 00:11:16.000000', 'temperatura', 48.0000, 'ºC'),
	(234579, 122, '2014-03-01 00:11:17.000000', 'temperatura', 156.0000, 'ºC'),
	(234580, 122, '2014-03-01 00:11:18.000000', 'temperatura', 634.0000, 'ºC'),
	(234581, 122, '2014-03-01 00:11:19.000000', 'temperatura', 305.0000, 'ºC'),
	(234582, 122, '2014-03-01 00:11:20.000000', 'temperatura', 823.0000, 'ºC'),
	(234583, 122, '2014-03-01 00:11:21.000000', 'temperatura', 798.0000, 'ºC'),
	(234584, 122, '2014-03-01 00:11:22.000000', 'temperatura', 324.0000, 'ºC'),
	(234585, 122, '2014-03-01 00:11:23.000000', 'temperatura', 425.0000, 'ºC'),
	(234586, 122, '2014-03-01 00:11:24.000000', 'temperatura', 1153.0000, 'ºC'),
	(234587, 122, '2014-03-01 00:11:25.000000', 'temperatura', 893.0000, 'ºC'),
	(234588, 122, '2014-03-01 00:11:26.000000', 'temperatura', 1006.0000, 'ºC'),
	(234589, 122, '2014-03-01 00:11:27.000000', 'temperatura', 1153.0000, 'ºC'),
	(234590, 122, '2014-03-01 00:11:28.000000', 'temperatura', 347.0000, 'ºC'),
	(234591, 122, '2014-03-01 00:11:29.000000', 'temperatura', 674.0000, 'ºC'),
	(234592, 122, '2014-03-01 00:11:30.000000', 'temperatura', 1131.0000, 'ºC'),
	(234593, 122, '2014-03-01 00:11:31.000000', 'temperatura', 34.0000, 'ºC'),
	(234594, 122, '2014-03-01 00:11:32.000000', 'temperatura', 379.0000, 'ºC'),
	(234595, 122, '2014-03-01 00:11:33.000000', 'temperatura', 593.0000, 'ºC'),
	(234596, 122, '2014-03-01 00:11:34.000000', 'temperatura', 627.0000, 'ºC'),
	(234597, 122, '2014-03-01 00:11:35.000000', 'temperatura', 158.0000, 'ºC'),
	(234598, 122, '2014-03-01 00:11:36.000000', 'temperatura', 107.0000, 'ºC'),
	(234599, 122, '2014-03-01 00:11:37.000000', 'temperatura', 65.0000, 'ºC'),
	(234600, 122, '2014-03-01 00:11:38.000000', 'temperatura', 2.0000, 'ºC'),
	(234601, 122, '2014-03-01 00:11:39.000000', 'temperatura', 1016.0000, 'ºC'),
	(234602, 122, '2014-03-01 00:11:40.000000', 'temperatura', 275.0000, 'ºC'),
	(234603, 122, '2014-03-01 00:11:41.000000', 'temperatura', 727.0000, 'ºC'),
	(234604, 122, '2014-03-01 00:11:42.000000', 'temperatura', 411.0000, 'ºC'),
	(234605, 122, '2014-03-01 00:11:43.000000', 'temperatura', 1074.0000, 'ºC'),
	(234606, 122, '2014-03-01 00:11:44.000000', 'temperatura', 540.0000, 'ºC'),
	(234607, 122, '2014-03-01 00:11:45.000000', 'temperatura', 676.0000, 'ºC'),
	(234608, 122, '2014-03-01 00:11:46.000000', 'temperatura', 559.0000, 'ºC'),
	(234609, 122, '2014-03-01 00:11:47.000000', 'temperatura', 769.0000, 'ºC'),
	(234610, 122, '2014-03-01 00:11:48.000000', 'temperatura', 969.0000, 'ºC'),
	(234611, 122, '2014-03-01 00:11:49.000000', 'temperatura', 138.0000, 'ºC'),
	(234612, 122, '2014-03-01 00:11:50.000000', 'temperatura', 181.0000, 'ºC'),
	(234613, 122, '2014-03-01 00:11:51.000000', 'temperatura', 495.0000, 'ºC'),
	(234614, 122, '2014-03-01 00:11:52.000000', 'temperatura', 733.0000, 'ºC'),
	(234615, 122, '2014-03-01 00:11:53.000000', 'temperatura', 979.0000, 'ºC'),
	(234616, 122, '2014-03-01 00:11:54.000000', 'temperatura', 299.0000, 'ºC'),
	(234617, 122, '2014-03-01 00:11:55.000000', 'temperatura', 955.0000, 'ºC'),
	(234618, 122, '2014-03-01 00:11:56.000000', 'temperatura', 279.0000, 'ºC'),
	(234619, 122, '2014-03-01 00:11:57.000000', 'temperatura', 933.0000, 'ºC'),
	(234620, 122, '2014-03-01 00:11:58.000000', 'temperatura', 227.0000, 'ºC'),
	(234621, 122, '2014-03-01 00:11:59.000000', 'temperatura', 738.0000, 'ºC'),
	(234622, 122, '2014-03-01 00:12:00.000000', 'temperatura', 607.0000, 'ºC'),
	(234623, 122, '2014-03-01 00:12:01.000000', 'temperatura', 824.0000, 'ºC'),
	(234624, 122, '2014-03-01 00:12:02.000000', 'temperatura', 1098.0000, 'ºC'),
	(234625, 122, '2014-03-01 00:12:03.000000', 'temperatura', 619.0000, 'ºC'),
	(234626, 122, '2014-03-01 00:12:04.000000', 'temperatura', 1000.0000, 'ºC'),
	(234627, 122, '2014-03-01 00:12:05.000000', 'temperatura', 746.0000, 'ºC'),
	(234628, 122, '2014-03-01 00:12:06.000000', 'temperatura', 731.0000, 'ºC'),
	(234629, 122, '2014-03-01 00:12:07.000000', 'temperatura', 218.0000, 'ºC'),
	(234630, 122, '2014-03-01 00:12:08.000000', 'temperatura', 97.0000, 'ºC'),
	(234631, 122, '2014-03-01 00:12:09.000000', 'temperatura', 1032.0000, 'ºC'),
	(234632, 122, '2014-03-01 00:12:10.000000', 'temperatura', 71.0000, 'ºC'),
	(234633, 122, '2014-03-01 00:12:11.000000', 'temperatura', 856.0000, 'ºC'),
	(234634, 122, '2014-03-01 00:12:12.000000', 'temperatura', 471.0000, 'ºC'),
	(234635, 122, '2014-03-01 00:12:13.000000', 'temperatura', 985.0000, 'ºC'),
	(234636, 122, '2014-03-01 00:12:14.000000', 'temperatura', 1114.0000, 'ºC'),
	(234637, 122, '2014-03-01 00:12:15.000000', 'temperatura', 214.0000, 'ºC'),
	(234638, 122, '2014-03-01 00:12:16.000000', 'temperatura', 129.0000, 'ºC'),
	(234639, 122, '2014-03-01 00:12:17.000000', 'temperatura', 5.0000, 'ºC'),
	(234640, 122, '2014-03-01 00:12:18.000000', 'temperatura', 838.0000, 'ºC'),
	(234641, 122, '2014-03-01 00:12:19.000000', 'temperatura', 574.0000, 'ºC'),
	(234642, 122, '2014-03-01 00:12:20.000000', 'temperatura', 359.0000, 'ºC'),
	(234643, 122, '2014-03-01 00:12:21.000000', 'temperatura', 72.0000, 'ºC'),
	(234644, 122, '2014-03-01 00:12:22.000000', 'temperatura', 482.0000, 'ºC'),
	(234645, 122, '2014-03-01 00:12:23.000000', 'temperatura', 996.0000, 'ºC'),
	(234646, 122, '2014-03-01 00:12:24.000000', 'temperatura', 1135.0000, 'ºC'),
	(234647, 122, '2014-03-01 00:12:25.000000', 'temperatura', 287.0000, 'ºC'),
	(234648, 122, '2014-03-01 00:12:26.000000', 'temperatura', 431.0000, 'ºC'),
	(234649, 122, '2014-03-01 00:12:27.000000', 'temperatura', 94.0000, 'ºC'),
	(234650, 122, '2014-03-01 00:12:28.000000', 'temperatura', 378.0000, 'ºC'),
	(234651, 122, '2014-03-01 00:12:29.000000', 'temperatura', 410.0000, 'ºC'),
	(234652, 122, '2014-03-01 00:12:30.000000', 'temperatura', 916.0000, 'ºC'),
	(234653, 122, '2014-03-01 00:12:31.000000', 'temperatura', 949.0000, 'ºC'),
	(234654, 122, '2014-03-01 00:12:32.000000', 'temperatura', 800.0000, 'ºC'),
	(234655, 122, '2014-03-01 00:12:33.000000', 'temperatura', 1151.0000, 'ºC'),
	(234656, 122, '2014-03-01 00:12:34.000000', 'temperatura', 955.0000, 'ºC'),
	(234657, 122, '2014-03-01 00:12:35.000000', 'temperatura', 123.0000, 'ºC'),
	(234658, 122, '2014-03-01 00:12:36.000000', 'temperatura', 150.0000, 'ºC'),
	(234659, 122, '2014-03-01 00:12:37.000000', 'temperatura', 382.0000, 'ºC'),
	(234660, 122, '2014-03-01 00:12:38.000000', 'temperatura', 259.0000, 'ºC'),
	(234661, 122, '2014-03-01 00:12:39.000000', 'temperatura', 150.0000, 'ºC'),
	(234662, 122, '2014-03-01 00:12:40.000000', 'temperatura', 1175.0000, 'ºC'),
	(234663, 122, '2014-03-01 00:12:41.000000', 'temperatura', 623.0000, 'ºC'),
	(234664, 122, '2014-03-01 00:12:42.000000', 'temperatura', 794.0000, 'ºC'),
	(234665, 122, '2014-03-01 00:12:43.000000', 'temperatura', 899.0000, 'ºC'),
	(234666, 122, '2014-03-01 00:12:44.000000', 'temperatura', 913.0000, 'ºC'),
	(234667, 122, '2014-03-01 00:12:45.000000', 'temperatura', 670.0000, 'ºC'),
	(234668, 122, '2014-03-01 00:12:46.000000', 'temperatura', 609.0000, 'ºC'),
	(234669, 122, '2014-03-01 00:12:47.000000', 'temperatura', 1038.0000, 'ºC'),
	(234670, 122, '2014-03-01 00:12:48.000000', 'temperatura', 962.0000, 'ºC'),
	(234671, 122, '2014-03-01 00:12:49.000000', 'temperatura', 499.0000, 'ºC'),
	(234672, 122, '2014-03-01 00:12:50.000000', 'temperatura', 806.0000, 'ºC'),
	(234673, 122, '2014-03-01 00:12:51.000000', 'temperatura', 137.0000, 'ºC'),
	(234674, 122, '2014-03-01 00:12:52.000000', 'temperatura', 666.0000, 'ºC'),
	(234675, 122, '2014-03-01 00:12:53.000000', 'temperatura', 521.0000, 'ºC'),
	(234676, 122, '2014-03-01 00:12:54.000000', 'temperatura', 608.0000, 'ºC'),
	(234677, 122, '2014-03-01 00:12:55.000000', 'temperatura', 275.0000, 'ºC'),
	(234678, 122, '2014-03-01 00:12:56.000000', 'temperatura', 752.0000, 'ºC'),
	(234679, 122, '2014-03-01 00:12:57.000000', 'temperatura', 534.0000, 'ºC'),
	(234680, 122, '2014-03-01 00:12:58.000000', 'temperatura', 415.0000, 'ºC'),
	(234681, 122, '2014-03-01 00:12:59.000000', 'temperatura', 474.0000, 'ºC'),
	(234682, 122, '2014-03-01 00:13:00.000000', 'temperatura', 1125.0000, 'ºC'),
	(234683, 122, '2014-03-01 00:13:01.000000', 'temperatura', 606.0000, 'ºC'),
	(234684, 122, '2014-03-01 00:13:02.000000', 'temperatura', 854.0000, 'ºC'),
	(234685, 122, '2014-03-01 00:13:03.000000', 'temperatura', 50.0000, 'ºC'),
	(234686, 122, '2014-03-01 00:13:04.000000', 'temperatura', 92.0000, 'ºC'),
	(234687, 122, '2014-03-01 00:13:05.000000', 'temperatura', 309.0000, 'ºC'),
	(234688, 122, '2014-03-01 00:13:06.000000', 'temperatura', 69.0000, 'ºC'),
	(234689, 122, '2014-03-01 00:13:07.000000', 'temperatura', 620.0000, 'ºC'),
	(234690, 122, '2014-03-01 00:13:08.000000', 'temperatura', 493.0000, 'ºC'),
	(234691, 122, '2014-03-01 00:13:09.000000', 'temperatura', 604.0000, 'ºC'),
	(234692, 122, '2014-03-01 00:13:10.000000', 'temperatura', 341.0000, 'ºC'),
	(234693, 122, '2014-03-01 00:13:11.000000', 'temperatura', 1094.0000, 'ºC'),
	(234694, 122, '2014-03-01 00:13:12.000000', 'temperatura', 848.0000, 'ºC'),
	(234695, 122, '2014-03-01 00:13:13.000000', 'temperatura', 958.0000, 'ºC'),
	(234696, 122, '2014-03-01 00:13:14.000000', 'temperatura', 1048.0000, 'ºC'),
	(234697, 122, '2014-03-01 00:13:15.000000', 'temperatura', 1164.0000, 'ºC'),
	(234698, 122, '2014-03-01 00:13:16.000000', 'temperatura', 277.0000, 'ºC'),
	(234699, 122, '2014-03-01 00:13:17.000000', 'temperatura', 295.0000, 'ºC'),
	(234700, 122, '2014-03-01 00:13:18.000000', 'temperatura', 644.0000, 'ºC'),
	(234701, 122, '2014-03-01 00:13:19.000000', 'temperatura', 1134.0000, 'ºC'),
	(234702, 122, '2014-03-01 00:13:20.000000', 'temperatura', 138.0000, 'ºC'),
	(234703, 122, '2014-03-01 00:13:21.000000', 'temperatura', 889.0000, 'ºC'),
	(234704, 122, '2014-03-01 00:13:22.000000', 'temperatura', 432.0000, 'ºC'),
	(234705, 122, '2014-03-01 00:13:23.000000', 'temperatura', 692.0000, 'ºC'),
	(234706, 122, '2014-03-01 00:13:24.000000', 'temperatura', 967.0000, 'ºC'),
	(234707, 122, '2014-03-01 00:13:25.000000', 'temperatura', 358.0000, 'ºC'),
	(234708, 122, '2014-03-01 00:13:26.000000', 'temperatura', 89.0000, 'ºC'),
	(234709, 122, '2014-03-01 00:13:27.000000', 'temperatura', 574.0000, 'ºC'),
	(234710, 122, '2014-03-01 00:13:28.000000', 'temperatura', 200.0000, 'ºC'),
	(234711, 122, '2014-03-01 00:13:29.000000', 'temperatura', 480.0000, 'ºC'),
	(234712, 122, '2014-03-01 00:13:30.000000', 'temperatura', 602.0000, 'ºC'),
	(234713, 122, '2014-03-01 00:13:31.000000', 'temperatura', 371.0000, 'ºC'),
	(234714, 122, '2014-03-01 00:13:32.000000', 'temperatura', 51.0000, 'ºC'),
	(234715, 122, '2014-03-01 00:13:33.000000', 'temperatura', 339.0000, 'ºC'),
	(234716, 122, '2014-03-01 00:13:34.000000', 'temperatura', 342.0000, 'ºC'),
	(234717, 122, '2014-03-01 00:13:35.000000', 'temperatura', 695.0000, 'ºC'),
	(234718, 122, '2014-03-01 00:13:36.000000', 'temperatura', 50.0000, 'ºC'),
	(234719, 122, '2014-03-01 00:13:37.000000', 'temperatura', 565.0000, 'ºC'),
	(234720, 122, '2014-03-01 00:13:38.000000', 'temperatura', 274.0000, 'ºC'),
	(234721, 122, '2014-03-01 00:13:39.000000', 'temperatura', 876.0000, 'ºC'),
	(234722, 122, '2014-03-01 00:13:40.000000', 'temperatura', 1161.0000, 'ºC'),
	(234723, 122, '2014-03-01 00:13:41.000000', 'temperatura', 776.0000, 'ºC'),
	(234724, 122, '2014-03-01 00:13:42.000000', 'temperatura', 396.0000, 'ºC'),
	(234725, 122, '2014-03-01 00:13:43.000000', 'temperatura', 855.0000, 'ºC'),
	(234726, 122, '2014-03-01 00:13:44.000000', 'temperatura', 687.0000, 'ºC'),
	(234727, 122, '2014-03-01 00:13:45.000000', 'temperatura', 869.0000, 'ºC'),
	(234728, 122, '2014-03-01 00:13:46.000000', 'temperatura', 1083.0000, 'ºC'),
	(234729, 122, '2014-03-01 00:13:47.000000', 'temperatura', 412.0000, 'ºC'),
	(234730, 122, '2014-03-01 00:13:48.000000', 'temperatura', 11.0000, 'ºC'),
	(234731, 122, '2014-03-01 00:13:49.000000', 'temperatura', 20.0000, 'ºC'),
	(234732, 122, '2014-03-01 00:13:50.000000', 'temperatura', 66.0000, 'ºC'),
	(234733, 122, '2014-03-01 00:13:51.000000', 'temperatura', 270.0000, 'ºC'),
	(234734, 122, '2014-03-01 00:13:52.000000', 'temperatura', 1155.0000, 'ºC'),
	(234735, 122, '2014-03-01 00:13:53.000000', 'temperatura', 165.0000, 'ºC'),
	(234736, 122, '2014-03-01 00:13:54.000000', 'temperatura', 958.0000, 'ºC'),
	(234737, 122, '2014-03-01 00:13:55.000000', 'temperatura', 697.0000, 'ºC'),
	(234738, 122, '2014-03-01 00:13:56.000000', 'temperatura', 611.0000, 'ºC'),
	(234739, 122, '2014-03-01 00:13:57.000000', 'temperatura', 963.0000, 'ºC'),
	(234740, 122, '2014-03-01 00:13:58.000000', 'temperatura', 583.0000, 'ºC'),
	(234741, 122, '2014-03-01 00:13:59.000000', 'temperatura', 29.0000, 'ºC'),
	(234742, 122, '2014-03-01 00:14:00.000000', 'temperatura', 793.0000, 'ºC'),
	(234743, 122, '2014-03-01 00:14:01.000000', 'temperatura', 280.0000, 'ºC'),
	(234744, 122, '2014-03-01 00:14:02.000000', 'temperatura', 221.0000, 'ºC'),
	(234745, 122, '2014-03-01 00:14:03.000000', 'temperatura', 268.0000, 'ºC'),
	(234746, 122, '2014-03-01 00:14:04.000000', 'temperatura', 675.0000, 'ºC'),
	(234747, 122, '2014-03-01 00:14:05.000000', 'temperatura', 170.0000, 'ºC'),
	(234748, 122, '2014-03-01 00:14:06.000000', 'temperatura', 27.0000, 'ºC'),
	(234749, 122, '2014-03-01 00:14:07.000000', 'temperatura', 827.0000, 'ºC'),
	(234750, 122, '2014-03-01 00:14:08.000000', 'temperatura', 454.0000, 'ºC'),
	(234751, 122, '2014-03-01 00:14:09.000000', 'temperatura', 990.0000, 'ºC'),
	(234752, 122, '2014-03-01 00:14:10.000000', 'temperatura', 1188.0000, 'ºC'),
	(234753, 122, '2014-03-01 00:14:11.000000', 'temperatura', 571.0000, 'ºC'),
	(234754, 122, '2014-03-01 00:14:12.000000', 'temperatura', 491.0000, 'ºC'),
	(234755, 122, '2014-03-01 00:14:13.000000', 'temperatura', 741.0000, 'ºC'),
	(234756, 122, '2014-03-01 00:14:14.000000', 'temperatura', 1035.0000, 'ºC'),
	(234757, 122, '2014-03-01 00:14:15.000000', 'temperatura', 551.0000, 'ºC'),
	(234758, 122, '2014-03-01 00:14:16.000000', 'temperatura', 851.0000, 'ºC'),
	(234759, 122, '2014-03-01 00:14:17.000000', 'temperatura', 200.0000, 'ºC'),
	(234760, 122, '2014-03-01 00:14:18.000000', 'temperatura', 851.0000, 'ºC'),
	(234761, 122, '2014-03-01 00:14:19.000000', 'temperatura', 53.0000, 'ºC'),
	(234762, 122, '2014-03-01 00:14:20.000000', 'temperatura', 112.0000, 'ºC'),
	(234763, 122, '2014-03-01 00:14:21.000000', 'temperatura', 401.0000, 'ºC'),
	(234764, 122, '2014-03-01 00:14:22.000000', 'temperatura', 470.0000, 'ºC'),
	(234765, 122, '2014-03-01 00:14:23.000000', 'temperatura', 1147.0000, 'ºC'),
	(234766, 122, '2014-03-01 00:14:24.000000', 'temperatura', 728.0000, 'ºC'),
	(234767, 122, '2014-03-01 00:14:25.000000', 'temperatura', 198.0000, 'ºC'),
	(234768, 122, '2014-03-01 00:14:26.000000', 'temperatura', 9.0000, 'ºC'),
	(234769, 122, '2014-03-01 00:14:27.000000', 'temperatura', 648.0000, 'ºC'),
	(234770, 122, '2014-03-01 00:14:28.000000', 'temperatura', 815.0000, 'ºC'),
	(234771, 122, '2014-03-01 00:14:29.000000', 'temperatura', 932.0000, 'ºC'),
	(234772, 122, '2014-03-01 00:14:30.000000', 'temperatura', 1014.0000, 'ºC'),
	(234773, 122, '2014-03-01 00:14:31.000000', 'temperatura', 1074.0000, 'ºC'),
	(234774, 122, '2014-03-01 00:14:32.000000', 'temperatura', 1130.0000, 'ºC'),
	(234775, 122, '2014-03-01 00:14:33.000000', 'temperatura', 30.0000, 'ºC'),
	(234776, 122, '2014-03-01 00:14:34.000000', 'temperatura', 360.0000, 'ºC'),
	(234777, 122, '2014-03-01 00:14:35.000000', 'temperatura', 508.0000, 'ºC'),
	(234778, 122, '2014-03-01 00:14:36.000000', 'temperatura', 264.0000, 'ºC'),
	(234779, 122, '2014-03-01 00:14:37.000000', 'temperatura', 993.0000, 'ºC'),
	(234780, 122, '2014-03-01 00:14:38.000000', 'temperatura', 576.0000, 'ºC'),
	(234781, 122, '2014-03-01 00:14:39.000000', 'temperatura', 1103.0000, 'ºC'),
	(234782, 122, '2014-03-01 00:14:40.000000', 'temperatura', 185.0000, 'ºC'),
	(234783, 122, '2014-03-01 00:14:41.000000', 'temperatura', 16.0000, 'ºC'),
	(234784, 122, '2014-03-01 00:14:42.000000', 'temperatura', 725.0000, 'ºC'),
	(234785, 122, '2014-03-01 00:14:43.000000', 'temperatura', 1177.0000, 'ºC'),
	(234786, 122, '2014-03-01 00:14:44.000000', 'temperatura', 113.0000, 'ºC'),
	(234787, 122, '2014-03-01 00:14:45.000000', 'temperatura', 635.0000, 'ºC'),
	(234788, 122, '2014-03-01 00:14:46.000000', 'temperatura', 434.0000, 'ºC'),
	(234789, 122, '2014-03-01 00:14:47.000000', 'temperatura', 265.0000, 'ºC'),
	(234790, 122, '2014-03-01 00:14:48.000000', 'temperatura', 24.0000, 'ºC'),
	(234791, 122, '2014-03-01 00:14:49.000000', 'temperatura', 526.0000, 'ºC'),
	(234792, 122, '2014-03-01 00:14:50.000000', 'temperatura', 159.0000, 'ºC'),
	(234793, 122, '2014-03-01 00:14:51.000000', 'temperatura', 419.0000, 'ºC'),
	(234794, 122, '2014-03-01 00:14:52.000000', 'temperatura', 416.0000, 'ºC'),
	(234795, 122, '2014-03-01 00:14:53.000000', 'temperatura', 825.0000, 'ºC'),
	(234796, 122, '2014-03-01 00:14:54.000000', 'temperatura', 477.0000, 'ºC'),
	(234797, 122, '2014-03-01 00:14:55.000000', 'temperatura', 1112.0000, 'ºC'),
	(234798, 122, '2014-03-01 00:14:56.000000', 'temperatura', 527.0000, 'ºC'),
	(234799, 122, '2014-03-01 00:14:57.000000', 'temperatura', 501.0000, 'ºC'),
	(234800, 122, '2014-03-01 00:14:58.000000', 'temperatura', 923.0000, 'ºC'),
	(234801, 122, '2014-03-01 00:14:59.000000', 'temperatura', 712.0000, 'ºC'),
	(234802, 122, '2014-03-01 00:15:00.000000', 'temperatura', 792.0000, 'ºC'),
	(234803, 122, '2014-03-01 00:15:01.000000', 'temperatura', 624.0000, 'ºC'),
	(234804, 122, '2014-03-01 00:15:02.000000', 'temperatura', 743.0000, 'ºC'),
	(234805, 122, '2014-03-01 00:15:03.000000', 'temperatura', 647.0000, 'ºC'),
	(234806, 122, '2014-03-01 00:15:04.000000', 'temperatura', 1005.0000, 'ºC'),
	(234807, 122, '2014-03-01 00:15:05.000000', 'temperatura', 686.0000, 'ºC'),
	(234808, 122, '2014-03-01 00:15:06.000000', 'temperatura', 413.0000, 'ºC'),
	(234809, 122, '2014-03-01 00:15:07.000000', 'temperatura', 9.0000, 'ºC'),
	(234810, 122, '2014-03-01 00:15:08.000000', 'temperatura', 5.0000, 'ºC'),
	(234811, 122, '2014-03-01 00:15:09.000000', 'temperatura', 1.0000, 'ºC'),
	(234812, 122, '2014-03-01 00:15:10.000000', 'temperatura', 1188.0000, 'ºC'),
	(234813, 122, '2014-03-01 00:15:11.000000', 'temperatura', 1140.0000, 'ºC'),
	(234814, 122, '2014-03-01 00:15:12.000000', 'temperatura', 937.0000, 'ºC'),
	(234815, 122, '2014-03-01 00:15:13.000000', 'temperatura', 65.0000, 'ºC'),
	(234816, 122, '2014-03-01 00:15:14.000000', 'temperatura', 1114.0000, 'ºC'),
	(234817, 122, '2014-03-01 00:15:15.000000', 'temperatura', 578.0000, 'ºC'),
	(234818, 122, '2014-03-01 00:15:16.000000', 'temperatura', 745.0000, 'ºC'),
	(234819, 122, '2014-03-01 00:15:17.000000', 'temperatura', 794.0000, 'ºC'),
	(234820, 122, '2014-03-01 00:15:18.000000', 'temperatura', 535.0000, 'ºC'),
	(234821, 122, '2014-03-01 00:15:19.000000', 'temperatura', 293.0000, 'ºC'),
	(234822, 122, '2014-03-01 00:15:20.000000', 'temperatura', 1061.0000, 'ºC'),
	(234823, 122, '2014-03-01 00:15:21.000000', 'temperatura', 828.0000, 'ºC'),
	(234824, 122, '2014-03-01 00:15:22.000000', 'temperatura', 957.0000, 'ºC'),
	(234825, 122, '2014-03-01 00:15:23.000000', 'temperatura', 1102.0000, 'ºC'),
	(234826, 122, '2014-03-01 00:15:24.000000', 'temperatura', 241.0000, 'ºC'),
	(234827, 122, '2014-03-01 00:15:25.000000', 'temperatura', 297.0000, 'ºC'),
	(234828, 122, '2014-03-01 00:15:26.000000', 'temperatura', 762.0000, 'ºC'),
	(234829, 122, '2014-03-01 00:15:27.000000', 'temperatura', 522.0000, 'ºC'),
	(234830, 122, '2014-03-01 00:15:28.000000', 'temperatura', 323.0000, 'ºC'),
	(234831, 122, '2014-03-01 00:15:29.000000', 'temperatura', 51.0000, 'ºC'),
	(234832, 122, '2014-03-01 00:15:30.000000', 'temperatura', 484.0000, 'ºC'),
	(234833, 122, '2014-03-01 00:15:31.000000', 'temperatura', 1067.0000, 'ºC'),
	(234834, 122, '2014-03-01 00:15:32.000000', 'temperatura', 284.0000, 'ºC'),
	(234835, 122, '2014-03-01 00:15:33.000000', 'temperatura', 622.0000, 'ºC'),
	(234836, 122, '2014-03-01 00:15:34.000000', 'temperatura', 1057.0000, 'ºC'),
	(234837, 122, '2014-03-01 00:15:35.000000', 'temperatura', 1021.0000, 'ºC'),
	(234838, 122, '2014-03-01 00:15:36.000000', 'temperatura', 735.0000, 'ºC'),
	(234839, 122, '2014-03-01 00:15:37.000000', 'temperatura', 612.0000, 'ºC'),
	(234840, 122, '2014-03-01 00:15:38.000000', 'temperatura', 854.0000, 'ºC'),
	(234841, 122, '2014-03-01 00:15:39.000000', 'temperatura', 36.0000, 'ºC'),
	(234842, 122, '2014-03-01 00:15:40.000000', 'temperatura', 19.0000, 'ºC'),
	(234843, 122, '2014-03-01 00:15:41.000000', 'temperatura', 1187.0000, 'ºC'),
	(234844, 122, '2014-03-01 00:15:42.000000', 'temperatura', 1077.0000, 'ºC'),
	(234845, 122, '2014-03-01 00:15:43.000000', 'temperatura', 624.0000, 'ºC'),
	(234846, 122, '2014-03-01 00:15:44.000000', 'temperatura', 1092.0000, 'ºC'),
	(234847, 122, '2014-03-01 00:15:45.000000', 'temperatura', 1187.0000, 'ºC'),
	(234848, 122, '2014-03-01 00:15:46.000000', 'temperatura', 260.0000, 'ºC'),
	(234849, 122, '2014-03-01 00:15:47.000000', 'temperatura', 139.0000, 'ºC'),
	(234850, 122, '2014-03-01 00:15:48.000000', 'temperatura', 1117.0000, 'ºC'),
	(234851, 122, '2014-03-01 00:15:49.000000', 'temperatura', 366.0000, 'ºC'),
	(234852, 122, '2014-03-01 00:15:50.000000', 'temperatura', 882.0000, 'ºC'),
	(234853, 122, '2014-03-01 00:15:51.000000', 'temperatura', 914.0000, 'ºC'),
	(234854, 122, '2014-03-01 00:15:52.000000', 'temperatura', 722.0000, 'ºC'),
	(234855, 122, '2014-03-01 00:15:53.000000', 'temperatura', 867.0000, 'ºC'),
	(234856, 122, '2014-03-01 00:15:54.000000', 'temperatura', 971.0000, 'ºC'),
	(234857, 122, '2014-03-01 00:15:55.000000', 'temperatura', 1053.0000, 'ºC'),
	(234858, 122, '2014-03-01 00:15:56.000000', 'temperatura', 1154.0000, 'ºC'),
	(234859, 122, '2014-03-01 00:15:57.000000', 'temperatura', 212.0000, 'ºC'),
	(234860, 122, '2014-03-01 00:15:58.000000', 'temperatura', 1197.0000, 'ºC'),
	(234861, 122, '2014-03-01 00:15:59.000000', 'temperatura', 551.0000, 'ºC'),
	(234862, 122, '2014-03-01 00:16:00.000000', 'temperatura', 366.0000, 'ºC'),
	(234863, 122, '2014-03-01 00:16:01.000000', 'temperatura', 174.0000, 'ºC'),
	(234864, 122, '2014-03-01 00:16:02.000000', 'temperatura', 975.0000, 'ºC'),
	(234865, 122, '2014-03-01 00:16:03.000000', 'temperatura', 754.0000, 'ºC'),
	(234866, 122, '2014-03-01 00:16:04.000000', 'temperatura', 845.0000, 'ºC'),
	(234867, 122, '2014-03-01 00:16:05.000000', 'temperatura', 762.0000, 'ºC'),
	(234868, 122, '2014-03-01 00:16:06.000000', 'temperatura', 77.0000, 'ºC'),
	(234869, 122, '2014-03-01 00:16:07.000000', 'temperatura', 499.0000, 'ºC'),
	(234870, 122, '2014-03-01 00:16:08.000000', 'temperatura', 1064.0000, 'ºC'),
	(234871, 122, '2014-03-01 00:16:09.000000', 'temperatura', 222.0000, 'ºC'),
	(234872, 122, '2014-03-01 00:16:10.000000', 'temperatura', 319.0000, 'ºC'),
	(234873, 122, '2014-03-01 00:16:11.000000', 'temperatura', 931.0000, 'ºC'),
	(234874, 122, '2014-03-01 00:16:12.000000', 'temperatura', 97.0000, 'ºC'),
	(234875, 122, '2014-03-01 00:16:13.000000', 'temperatura', 92.0000, 'ºC'),
	(234876, 122, '2014-03-01 00:16:14.000000', 'temperatura', 170.0000, 'ºC'),
	(234877, 122, '2014-03-01 00:16:15.000000', 'temperatura', 575.0000, 'ºC'),
	(234878, 122, '2014-03-01 00:16:16.000000', 'temperatura', 1166.0000, 'ºC'),
	(234879, 122, '2014-03-01 00:16:17.000000', 'temperatura', 507.0000, 'ºC'),
	(234880, 122, '2014-03-01 00:16:18.000000', 'temperatura', 234.0000, 'ºC'),
	(234881, 122, '2014-03-01 00:16:19.000000', 'temperatura', 852.0000, 'ºC'),
	(234882, 122, '2014-03-01 00:16:20.000000', 'temperatura', 1159.0000, 'ºC'),
	(234883, 122, '2014-03-01 00:16:21.000000', 'temperatura', 839.0000, 'ºC'),
	(234884, 122, '2014-03-01 00:16:22.000000', 'temperatura', 717.0000, 'ºC'),
	(234885, 122, '2014-03-01 00:16:23.000000', 'temperatura', 1068.0000, 'ºC'),
	(234886, 122, '2014-03-01 00:16:24.000000', 'temperatura', 790.0000, 'ºC'),
	(234887, 122, '2014-03-01 00:16:25.000000', 'temperatura', 748.0000, 'ºC'),
	(234888, 122, '2014-03-01 00:16:26.000000', 'temperatura', 169.0000, 'ºC'),
	(234889, 122, '2014-03-01 00:16:27.000000', 'temperatura', 1001.0000, 'ºC'),
	(234890, 122, '2014-03-01 00:16:28.000000', 'temperatura', 899.0000, 'ºC'),
	(234891, 122, '2014-03-01 00:16:29.000000', 'temperatura', 291.0000, 'ºC'),
	(234892, 122, '2014-03-01 00:16:30.000000', 'temperatura', 1161.0000, 'ºC'),
	(234893, 122, '2014-03-01 00:16:31.000000', 'temperatura', 130.0000, 'ºC'),
	(234894, 122, '2014-03-01 00:16:32.000000', 'temperatura', 770.0000, 'ºC'),
	(234895, 122, '2014-03-01 00:16:33.000000', 'temperatura', 1061.0000, 'ºC'),
	(234896, 122, '2014-03-01 00:16:34.000000', 'temperatura', 592.0000, 'ºC'),
	(234897, 122, '2014-03-01 00:16:35.000000', 'temperatura', 981.0000, 'ºC'),
	(234898, 122, '2014-03-01 00:16:36.000000', 'temperatura', 728.0000, 'ºC'),
	(234899, 122, '2014-03-01 00:16:37.000000', 'temperatura', 696.0000, 'ºC'),
	(234900, 122, '2014-03-01 00:16:38.000000', 'temperatura', 98.0000, 'ºC'),
	(234901, 122, '2014-03-01 00:16:39.000000', 'temperatura', 801.0000, 'ºC'),
	(234902, 122, '2014-03-01 00:16:40.000000', 'temperatura', 113.0000, 'ºC'),
	(234903, 122, '2014-03-01 00:16:41.000000', 'temperatura', 564.0000, 'ºC'),
	(234904, 122, '2014-03-01 00:16:42.000000', 'temperatura', 81.0000, 'ºC'),
	(234905, 122, '2014-03-01 00:16:43.000000', 'temperatura', 1112.0000, 'ºC'),
	(234906, 122, '2014-03-01 00:16:44.000000', 'temperatura', 520.0000, 'ºC'),
	(234907, 122, '2014-03-01 00:16:45.000000', 'temperatura', 461.0000, 'ºC'),
	(234908, 122, '2014-03-01 00:16:46.000000', 'temperatura', 748.0000, 'ºC'),
	(234909, 122, '2014-03-01 00:16:47.000000', 'temperatura', 1155.0000, 'ºC'),
	(234910, 122, '2014-03-01 00:16:48.000000', 'temperatura', 1135.0000, 'ºC'),
	(234911, 122, '2014-03-01 00:16:49.000000', 'temperatura', 1007.0000, 'ºC'),
	(234912, 122, '2014-03-01 00:16:50.000000', 'temperatura', 433.0000, 'ºC'),
	(234913, 122, '2014-03-01 00:16:51.000000', 'temperatura', 346.0000, 'ºC'),
	(234914, 122, '2014-03-01 00:16:52.000000', 'temperatura', 429.0000, 'ºC'),
	(234915, 122, '2014-03-01 00:16:53.000000', 'temperatura', 1108.0000, 'ºC'),
	(234916, 122, '2014-03-01 00:16:54.000000', 'temperatura', 652.0000, 'ºC'),
	(234917, 122, '2014-03-01 00:16:55.000000', 'temperatura', 1137.0000, 'ºC'),
	(234918, 122, '2014-03-01 00:16:56.000000', 'temperatura', 128.0000, 'ºC'),
	(234919, 122, '2014-03-01 00:16:57.000000', 'temperatura', 831.0000, 'ºC'),
	(234920, 122, '2014-03-01 00:16:58.000000', 'temperatura', 172.0000, 'ºC'),
	(234921, 122, '2014-03-01 00:16:59.000000', 'temperatura', 766.0000, 'ºC'),
	(234922, 122, '2014-03-01 00:17:00.000000', 'temperatura', 917.0000, 'ºC'),
	(234923, 122, '2014-03-01 00:17:01.000000', 'temperatura', 1086.0000, 'ºC'),
	(234924, 122, '2014-03-01 00:17:02.000000', 'temperatura', 278.0000, 'ºC'),
	(234925, 122, '2014-03-01 00:17:03.000000', 'temperatura', 534.0000, 'ºC'),
	(234926, 122, '2014-03-01 00:17:04.000000', 'temperatura', 638.0000, 'ºC'),
	(234927, 122, '2014-03-01 00:17:05.000000', 'temperatura', 387.0000, 'ºC'),
	(234928, 122, '2014-03-01 00:17:06.000000', 'temperatura', 22.0000, 'ºC'),
	(234929, 122, '2014-03-01 00:17:07.000000', 'temperatura', 149.0000, 'ºC'),
	(234930, 122, '2014-03-01 00:17:08.000000', 'temperatura', 681.0000, 'ºC'),
	(234931, 122, '2014-03-01 00:17:09.000000', 'temperatura', 556.0000, 'ºC'),
	(234932, 122, '2014-03-01 00:17:10.000000', 'temperatura', 737.0000, 'ºC'),
	(234933, 122, '2014-03-01 00:17:11.000000', 'temperatura', 818.0000, 'ºC'),
	(234934, 122, '2014-03-01 00:17:12.000000', 'temperatura', 679.0000, 'ºC'),
	(234935, 122, '2014-03-01 00:17:13.000000', 'temperatura', 943.0000, 'ºC'),
	(234936, 122, '2014-03-01 00:17:14.000000', 'temperatura', 277.0000, 'ºC'),
	(234937, 122, '2014-03-01 00:17:15.000000', 'temperatura', 957.0000, 'ºC'),
	(234938, 122, '2014-03-01 00:17:16.000000', 'temperatura', 353.0000, 'ºC'),
	(234939, 122, '2014-03-01 00:17:17.000000', 'temperatura', 97.0000, 'ºC'),
	(234940, 122, '2014-03-01 00:17:18.000000', 'temperatura', 627.0000, 'ºC'),
	(234941, 122, '2014-03-01 00:17:19.000000', 'temperatura', 445.0000, 'ºC'),
	(234942, 122, '2014-03-01 00:17:20.000000', 'temperatura', 344.0000, 'ºC'),
	(234943, 122, '2014-03-01 00:17:21.000000', 'temperatura', 387.0000, 'ºC'),
	(234944, 122, '2014-03-01 00:17:22.000000', 'temperatura', 901.0000, 'ºC'),
	(234945, 122, '2014-03-01 00:17:23.000000', 'temperatura', 946.0000, 'ºC'),
	(234946, 122, '2014-03-01 00:17:24.000000', 'temperatura', 829.0000, 'ºC'),
	(234947, 122, '2014-03-01 00:17:25.000000', 'temperatura', 104.0000, 'ºC'),
	(234948, 122, '2014-03-01 00:17:26.000000', 'temperatura', 435.0000, 'ºC'),
	(234949, 122, '2014-03-01 00:17:27.000000', 'temperatura', 665.0000, 'ºC'),
	(234950, 122, '2014-03-01 00:17:28.000000', 'temperatura', 821.0000, 'ºC'),
	(234951, 122, '2014-03-01 00:17:29.000000', 'temperatura', 910.0000, 'ºC'),
	(234952, 122, '2014-03-01 00:17:30.000000', 'temperatura', 888.0000, 'ºC'),
	(234953, 122, '2014-03-01 00:17:31.000000', 'temperatura', 509.0000, 'ºC'),
	(234954, 122, '2014-03-01 00:17:32.000000', 'temperatura', 1080.0000, 'ºC'),
	(234955, 122, '2014-03-01 00:17:33.000000', 'temperatura', 275.0000, 'ºC'),
	(234956, 122, '2014-03-01 00:17:34.000000', 'temperatura', 535.0000, 'ºC'),
	(234957, 122, '2014-03-01 00:17:35.000000', 'temperatura', 649.0000, 'ºC'),
	(234958, 122, '2014-03-01 00:17:36.000000', 'temperatura', 443.0000, 'ºC'),
	(234959, 122, '2014-03-01 00:17:37.000000', 'temperatura', 269.0000, 'ºC'),
	(234960, 122, '2014-03-01 00:17:38.000000', 'temperatura', 15.0000, 'ºC'),
	(234961, 122, '2014-03-01 00:17:39.000000', 'temperatura', 468.0000, 'ºC'),
	(234962, 122, '2014-03-01 00:17:40.000000', 'temperatura', 1096.0000, 'ºC'),
	(234963, 122, '2014-03-01 00:17:41.000000', 'temperatura', 478.0000, 'ºC'),
	(234964, 122, '2014-03-01 00:17:42.000000', 'temperatura', 302.0000, 'ºC'),
	(234965, 122, '2014-03-01 00:17:43.000000', 'temperatura', 76.0000, 'ºC'),
	(234966, 122, '2014-03-01 00:17:44.000000', 'temperatura', 675.0000, 'ºC'),
	(234967, 122, '2014-03-01 00:17:45.000000', 'temperatura', 749.0000, 'ºC'),
	(234968, 122, '2014-03-01 00:17:46.000000', 'temperatura', 519.0000, 'ºC'),
	(234969, 122, '2014-03-01 00:17:47.000000', 'temperatura', 349.0000, 'ºC'),
	(234970, 122, '2014-03-01 00:17:48.000000', 'temperatura', 187.0000, 'ºC'),
	(234971, 122, '2014-03-01 00:17:49.000000', 'temperatura', 1089.0000, 'ºC'),
	(234972, 122, '2014-03-01 00:17:50.000000', 'temperatura', 87.0000, 'ºC'),
	(234973, 122, '2014-03-01 00:17:51.000000', 'temperatura', 766.0000, 'ºC'),
	(234974, 122, '2014-03-01 00:17:52.000000', 'temperatura', 1172.0000, 'ºC'),
	(234975, 122, '2014-03-01 00:17:53.000000', 'temperatura', 1160.0000, 'ºC'),
	(234976, 122, '2014-03-01 00:17:54.000000', 'temperatura', 1086.0000, 'ºC'),
	(234977, 122, '2014-03-01 00:17:55.000000', 'temperatura', 752.0000, 'ºC'),
	(234978, 122, '2014-03-01 00:17:56.000000', 'temperatura', 500.0000, 'ºC'),
	(234979, 122, '2014-03-01 00:17:57.000000', 'temperatura', 247.0000, 'ºC'),
	(234980, 122, '2014-03-01 00:17:58.000000', 'temperatura', 936.0000, 'ºC'),
	(234981, 122, '2014-03-01 00:17:59.000000', 'temperatura', 339.0000, 'ºC'),
	(234982, 122, '2014-03-01 00:18:00.000000', 'temperatura', 87.0000, 'ºC'),
	(234983, 122, '2014-03-01 00:18:01.000000', 'temperatura', 620.0000, 'ºC'),
	(234984, 122, '2014-03-01 00:18:02.000000', 'temperatura', 438.0000, 'ºC'),
	(234985, 122, '2014-03-01 00:18:03.000000', 'temperatura', 329.0000, 'ºC'),
	(234986, 122, '2014-03-01 00:18:04.000000', 'temperatura', 335.0000, 'ºC'),
	(234987, 122, '2014-03-01 00:18:05.000000', 'temperatura', 686.0000, 'ºC'),
	(234988, 122, '2014-03-01 00:18:06.000000', 'temperatura', 28.0000, 'ºC'),
	(234989, 122, '2014-03-01 00:18:07.000000', 'temperatura', 480.0000, 'ºC'),
	(234990, 122, '2014-03-01 00:18:08.000000', 'temperatura', 1118.0000, 'ºC'),
	(234991, 122, '2014-03-01 00:18:09.000000', 'temperatura', 551.0000, 'ºC'),
	(234992, 122, '2014-03-01 00:18:10.000000', 'temperatura', 602.0000, 'ºC'),
	(234993, 122, '2014-03-01 00:18:11.000000', 'temperatura', 156.0000, 'ºC'),
	(234994, 122, '2014-03-01 00:18:12.000000', 'temperatura', 174.0000, 'ºC'),
	(234995, 122, '2014-03-01 00:18:13.000000', 'temperatura', 401.0000, 'ºC'),
	(234996, 122, '2014-03-01 00:18:14.000000', 'temperatura', 286.0000, 'ºC'),
	(234997, 122, '2014-03-01 00:18:15.000000', 'temperatura', 225.0000, 'ºC'),
	(234998, 122, '2014-03-01 00:18:16.000000', 'temperatura', 268.0000, 'ºC'),
	(234999, 122, '2014-03-01 00:18:17.000000', 'temperatura', 666.0000, 'ºC'),
	(235000, 122, '2014-03-01 00:18:18.000000', 'temperatura', 129.0000, 'ºC'),
	(235001, 122, '2014-03-01 00:18:19.000000', 'temperatura', 1044.0000, 'ºC'),
	(235002, 122, '2014-03-01 00:18:20.000000', 'temperatura', 33.0000, 'ºC'),
	(235003, 122, '2014-03-01 00:18:21.000000', 'temperatura', 636.0000, 'ºC'),
	(235004, 122, '2014-03-01 00:18:22.000000', 'temperatura', 681.0000, 'ºC'),
	(235005, 122, '2014-03-01 00:18:23.000000', 'temperatura', 295.0000, 'ºC'),
	(235006, 122, '2014-03-01 00:18:24.000000', 'temperatura', 634.0000, 'ºC'),
	(235007, 122, '2014-03-01 00:18:25.000000', 'temperatura', 1088.0000, 'ºC'),
	(235008, 122, '2014-03-01 00:18:26.000000', 'temperatura', 1135.0000, 'ºC'),
	(235009, 122, '2014-03-01 00:18:27.000000', 'temperatura', 13.0000, 'ºC'),
	(235010, 122, '2014-03-01 00:18:28.000000', 'temperatura', 259.0000, 'ºC'),
	(235011, 122, '2014-03-01 00:18:29.000000', 'temperatura', 58.0000, 'ºC'),
	(235012, 122, '2014-03-01 00:18:30.000000', 'temperatura', 712.0000, 'ºC'),
	(235013, 122, '2014-03-01 00:18:31.000000', 'temperatura', 986.0000, 'ºC'),
	(235014, 122, '2014-03-01 00:18:32.000000', 'temperatura', 395.0000, 'ºC'),
	(235015, 122, '2014-03-01 00:18:33.000000', 'temperatura', 218.0000, 'ºC'),
	(235016, 122, '2014-03-01 00:18:34.000000', 'temperatura', 1104.0000, 'ºC'),
	(235017, 122, '2014-03-01 00:18:35.000000', 'temperatura', 66.0000, 'ºC'),
	(235018, 122, '2014-03-01 00:18:36.000000', 'temperatura', 619.0000, 'ºC'),
	(235019, 122, '2014-03-01 00:18:37.000000', 'temperatura', 499.0000, 'ºC'),
	(235020, 122, '2014-03-01 00:18:38.000000', 'temperatura', 636.0000, 'ºC'),
	(235021, 122, '2014-03-01 00:18:39.000000', 'temperatura', 486.0000, 'ºC'),
	(235022, 122, '2014-03-01 00:18:40.000000', 'temperatura', 522.0000, 'ºC'),
	(235023, 122, '2014-03-01 00:18:41.000000', 'temperatura', 1151.0000, 'ºC'),
	(235024, 122, '2014-03-01 00:18:42.000000', 'temperatura', 590.0000, 'ºC'),
	(235025, 122, '2014-03-01 00:18:43.000000', 'temperatura', 697.0000, 'ºC'),
	(235026, 122, '2014-03-01 00:18:44.000000', 'temperatura', 514.0000, 'ºC'),
	(235027, 122, '2014-03-01 00:18:45.000000', 'temperatura', 481.0000, 'ºC'),
	(235028, 122, '2014-03-01 00:18:46.000000', 'temperatura', 863.0000, 'ºC'),
	(235029, 122, '2014-03-01 00:18:47.000000', 'temperatura', 474.0000, 'ºC'),
	(235030, 122, '2014-03-01 00:18:48.000000', 'temperatura', 979.0000, 'ºC'),
	(235031, 122, '2014-03-01 00:18:49.000000', 'temperatura', 1073.0000, 'ºC'),
	(235032, 122, '2014-03-01 00:18:50.000000', 'temperatura', 31.0000, 'ºC'),
	(235033, 122, '2014-03-01 00:18:51.000000', 'temperatura', 534.0000, 'ºC'),
	(235034, 122, '2014-03-01 00:18:52.000000', 'temperatura', 178.0000, 'ºC'),
	(235035, 122, '2014-03-01 00:18:53.000000', 'temperatura', 488.0000, 'ºC'),
	(235036, 122, '2014-03-01 00:18:54.000000', 'temperatura', 706.0000, 'ºC'),
	(235037, 122, '2014-03-01 00:18:55.000000', 'temperatura', 867.0000, 'ºC'),
	(235038, 122, '2014-03-01 00:18:56.000000', 'temperatura', 1019.0000, 'ºC'),
	(235039, 122, '2014-03-01 00:18:57.000000', 'temperatura', 95.0000, 'ºC'),
	(235040, 122, '2014-03-01 00:18:58.000000', 'temperatura', 1018.0000, 'ºC'),
	(235041, 122, '2014-03-01 00:18:59.000000', 'temperatura', 7.0000, 'ºC'),
	(235042, 122, '2014-03-01 00:19:00.000000', 'temperatura', 581.0000, 'ºC'),
	(235043, 122, '2014-03-01 00:19:01.000000', 'temperatura', 485.0000, 'ºC'),
	(235044, 122, '2014-03-01 00:19:02.000000', 'temperatura', 680.0000, 'ºC'),
	(235045, 122, '2014-03-01 00:19:03.000000', 'temperatura', 748.0000, 'ºC'),
	(235046, 122, '2014-03-01 00:19:04.000000', 'temperatura', 498.0000, 'ºC'),
	(235047, 122, '2014-03-01 00:19:05.000000', 'temperatura', 247.0000, 'ºC'),
	(235048, 122, '2014-03-01 00:19:06.000000', 'temperatura', 943.0000, 'ºC'),
	(235049, 122, '2014-03-01 00:19:07.000000', 'temperatura', 375.0000, 'ºC'),
	(235050, 122, '2014-03-01 00:19:08.000000', 'temperatura', 248.0000, 'ºC'),
	(235051, 122, '2014-03-01 00:19:09.000000', 'temperatura', 113.0000, 'ºC'),
	(235052, 122, '2014-03-01 00:19:10.000000', 'temperatura', 1021.0000, 'ºC'),
	(235053, 122, '2014-03-01 00:19:11.000000', 'temperatura', 1169.0000, 'ºC'),
	(235054, 122, '2014-03-01 00:19:12.000000', 'temperatura', 383.0000, 'ºC'),
	(235055, 122, '2014-03-01 00:19:13.000000', 'temperatura', 807.0000, 'ºC'),
	(235056, 122, '2014-03-01 00:19:14.000000', 'temperatura', 485.0000, 'ºC'),
	(235057, 122, '2014-03-01 00:19:15.000000', 'temperatura', 6.0000, 'ºC'),
	(235058, 122, '2014-03-01 00:19:16.000000', 'temperatura', 976.0000, 'ºC'),
	(235059, 122, '2014-03-01 00:19:17.000000', 'temperatura', 60.0000, 'ºC'),
	(235060, 122, '2014-03-01 00:19:18.000000', 'temperatura', 976.0000, 'ºC'),
	(235061, 122, '2014-03-01 00:19:19.000000', 'temperatura', 1099.0000, 'ºC'),
	(235062, 122, '2014-03-01 00:19:20.000000', 'temperatura', 166.0000, 'ºC'),
	(235063, 122, '2014-03-01 00:19:21.000000', 'temperatura', 1135.0000, 'ºC'),
	(235064, 122, '2014-03-01 00:19:22.000000', 'temperatura', 377.0000, 'ºC'),
	(235065, 122, '2014-03-01 00:19:23.000000', 'temperatura', 881.0000, 'ºC'),
	(235066, 122, '2014-03-01 00:19:24.000000', 'temperatura', 874.0000, 'ºC'),
	(235067, 122, '2014-03-01 00:19:25.000000', 'temperatura', 529.0000, 'ºC'),
	(235068, 122, '2014-03-01 00:19:26.000000', 'temperatura', 21.0000, 'ºC'),
	(235069, 122, '2014-03-01 00:19:27.000000', 'temperatura', 920.0000, 'ºC'),
	(235070, 122, '2014-03-01 00:19:28.000000', 'temperatura', 938.0000, 'ºC'),
	(235071, 122, '2014-03-01 00:19:29.000000', 'temperatura', 728.0000, 'ºC'),
	(235072, 122, '2014-03-01 00:19:30.000000', 'temperatura', 829.0000, 'ºC'),
	(235073, 122, '2014-03-01 00:19:31.000000', 'temperatura', 759.0000, 'ºC'),
	(235074, 122, '2014-03-01 00:19:32.000000', 'temperatura', 109.0000, 'ºC'),
	(235075, 122, '2014-03-01 00:19:33.000000', 'temperatura', 670.0000, 'ºC'),
	(235076, 122, '2014-03-01 00:19:34.000000', 'temperatura', 621.0000, 'ºC'),
	(235077, 122, '2014-03-01 00:19:35.000000', 'temperatura', 1097.0000, 'ºC'),
	(235078, 122, '2014-03-01 00:19:36.000000', 'temperatura', 21.0000, 'ºC'),
	(235079, 122, '2014-03-01 00:19:37.000000', 'temperatura', 415.0000, 'ºC'),
	(235080, 122, '2014-03-01 00:19:38.000000', 'temperatura', 813.0000, 'ºC'),
	(235081, 122, '2014-03-01 00:19:39.000000', 'temperatura', 420.0000, 'ºC'),
	(235082, 122, '2014-03-01 00:19:40.000000', 'temperatura', 860.0000, 'ºC'),
	(235083, 122, '2014-03-01 00:19:41.000000', 'temperatura', 641.0000, 'ºC'),
	(235084, 122, '2014-03-01 00:19:42.000000', 'temperatura', 625.0000, 'ºC'),
	(235085, 122, '2014-03-01 00:19:43.000000', 'temperatura', 5.0000, 'ºC'),
	(235086, 122, '2014-03-01 00:19:44.000000', 'temperatura', 548.0000, 'ºC'),
	(235087, 122, '2014-03-01 00:19:45.000000', 'temperatura', 328.0000, 'ºC'),
	(235088, 122, '2014-03-01 00:19:46.000000', 'temperatura', 1196.0000, 'ºC'),
	(235089, 122, '2014-03-01 00:19:47.000000', 'temperatura', 195.0000, 'ºC'),
	(235090, 122, '2014-03-01 00:19:48.000000', 'temperatura', 988.0000, 'ºC'),
	(235091, 122, '2014-03-01 00:19:49.000000', 'temperatura', 758.0000, 'ºC'),
	(235092, 122, '2014-03-01 00:19:50.000000', 'temperatura', 824.0000, 'ºC'),
	(235093, 122, '2014-03-01 00:19:51.000000', 'temperatura', 646.0000, 'ºC'),
	(235094, 122, '2014-03-01 00:19:52.000000', 'temperatura', 759.0000, 'ºC'),
	(235095, 122, '2014-03-01 00:19:53.000000', 'temperatura', 658.0000, 'ºC'),
	(235096, 122, '2014-03-01 00:19:54.000000', 'temperatura', 1012.0000, 'ºC'),
	(235097, 122, '2014-03-01 00:19:55.000000', 'temperatura', 687.0000, 'ºC'),
	(235098, 122, '2014-03-01 00:19:56.000000', 'temperatura', 398.0000, 'ºC'),
	(235099, 122, '2014-03-01 00:19:57.000000', 'temperatura', 1130.0000, 'ºC'),
	(235100, 122, '2014-03-01 00:19:58.000000', 'temperatura', 858.0000, 'ºC'),
	(235101, 122, '2014-03-01 00:19:59.000000', 'temperatura', 900.0000, 'ºC'),
	(235102, 122, '2014-03-01 00:20:00.000000', 'temperatura', 725.0000, 'ºC'),
	(235103, 122, '2014-03-01 00:20:01.000000', 'temperatura', 926.0000, 'ºC'),
	(235104, 122, '2014-03-01 00:20:02.000000', 'temperatura', 55.0000, 'ºC'),
	(235105, 122, '2014-03-01 00:20:03.000000', 'temperatura', 1097.0000, 'ºC'),
	(235106, 122, '2014-03-01 00:20:04.000000', 'temperatura', 521.0000, 'ºC'),
	(235107, 122, '2014-03-01 00:20:05.000000', 'temperatura', 514.0000, 'ºC'),
	(235108, 122, '2014-03-01 00:20:06.000000', 'temperatura', 1007.0000, 'ºC'),
	(235109, 122, '2014-03-01 00:20:07.000000', 'temperatura', 1093.0000, 'ºC'),
	(235110, 122, '2014-03-01 00:20:08.000000', 'temperatura', 45.0000, 'ºC'),
	(235111, 122, '2014-03-01 00:20:09.000000', 'temperatura', 546.0000, 'ºC'),
	(235112, 122, '2014-03-01 00:20:10.000000', 'temperatura', 194.0000, 'ºC'),
	(235113, 122, '2014-03-01 00:20:11.000000', 'temperatura', 535.0000, 'ºC'),
	(235114, 122, '2014-03-01 00:20:12.000000', 'temperatura', 894.0000, 'ºC'),
	(235115, 122, '2014-03-01 00:20:13.000000', 'temperatura', 463.0000, 'ºC'),
	(235116, 122, '2014-03-01 00:20:14.000000', 'temperatura', 836.0000, 'ºC'),
	(235117, 122, '2014-03-01 00:20:15.000000', 'temperatura', 389.0000, 'ºC'),
	(235118, 122, '2014-03-01 00:20:16.000000', 'temperatura', 637.0000, 'ºC'),
	(235119, 122, '2014-03-01 00:20:17.000000', 'temperatura', 820.0000, 'ºC'),
	(235120, 122, '2014-03-01 00:20:18.000000', 'temperatura', 990.0000, 'ºC'),
	(235121, 122, '2014-03-01 00:20:19.000000', 'temperatura', 91.0000, 'ºC'),
	(235122, 122, '2014-03-01 00:20:20.000000', 'temperatura', 1084.0000, 'ºC'),
	(235123, 122, '2014-03-01 00:20:21.000000', 'temperatura', 347.0000, 'ºC'),
	(235124, 122, '2014-03-01 00:20:22.000000', 'temperatura', 883.0000, 'ºC'),
	(235125, 122, '2014-03-01 00:20:23.000000', 'temperatura', 977.0000, 'ºC'),
	(235126, 122, '2014-03-01 00:20:24.000000', 'temperatura', 1034.0000, 'ºC'),
	(235127, 122, '2014-03-01 00:20:25.000000', 'temperatura', 1040.0000, 'ºC'),
	(235128, 122, '2014-03-01 00:20:26.000000', 'temperatura', 897.0000, 'ºC'),
	(235129, 122, '2014-03-01 00:20:27.000000', 'temperatura', 166.0000, 'ºC'),
	(235130, 122, '2014-03-01 00:20:28.000000', 'temperatura', 538.0000, 'ºC'),
	(235131, 122, '2014-03-01 00:20:29.000000', 'temperatura', 994.0000, 'ºC'),
	(235132, 122, '2014-03-01 00:20:30.000000', 'temperatura', 958.0000, 'ºC'),
	(235133, 122, '2014-03-01 00:20:31.000000', 'temperatura', 606.0000, 'ºC'),
	(235134, 122, '2014-03-01 00:20:32.000000', 'temperatura', 156.0000, 'ºC'),
	(235135, 122, '2014-03-01 00:20:33.000000', 'temperatura', 163.0000, 'ºC'),
	(235136, 122, '2014-03-01 00:20:34.000000', 'temperatura', 346.0000, 'ºC'),
	(235137, 122, '2014-03-01 00:20:35.000000', 'temperatura', 45.0000, 'ºC'),
	(235138, 122, '2014-03-01 00:20:36.000000', 'temperatura', 384.0000, 'ºC'),
	(235139, 122, '2014-03-01 00:20:37.000000', 'temperatura', 588.0000, 'ºC'),
	(235140, 122, '2014-03-01 00:20:38.000000', 'temperatura', 586.0000, 'ºC'),
	(235141, 122, '2014-03-01 00:20:39.000000', 'temperatura', 1168.0000, 'ºC'),
	(235142, 122, '2014-03-01 00:20:40.000000', 'temperatura', 483.0000, 'ºC'),
	(235143, 122, '2014-03-01 00:20:41.000000', 'temperatura', 112.0000, 'ºC'),
	(235144, 122, '2014-03-01 00:20:42.000000', 'temperatura', 309.0000, 'ºC'),
	(235145, 122, '2014-03-01 00:20:43.000000', 'temperatura', 10.0000, 'ºC'),
	(235146, 122, '2014-03-01 00:20:44.000000', 'temperatura', 325.0000, 'ºC'),
	(235147, 122, '2014-03-01 00:20:45.000000', 'temperatura', 394.0000, 'ºC'),
	(235148, 122, '2014-03-01 00:20:46.000000', 'temperatura', 997.0000, 'ºC'),
	(235149, 122, '2014-03-01 00:20:47.000000', 'temperatura', 203.0000, 'ºC'),
	(235150, 122, '2014-03-01 00:20:48.000000', 'temperatura', 424.0000, 'ºC'),
	(235151, 122, '2014-03-01 00:20:49.000000', 'temperatura', 312.0000, 'ºC'),
	(235152, 122, '2014-03-01 00:20:50.000000', 'temperatura', 290.0000, 'ºC'),
	(235153, 122, '2014-03-01 00:20:51.000000', 'temperatura', 511.0000, 'ºC'),
	(235154, 122, '2014-03-01 00:20:52.000000', 'temperatura', 488.0000, 'ºC'),
	(235155, 122, '2014-03-01 00:20:53.000000', 'temperatura', 908.0000, 'ºC'),
	(235156, 122, '2014-03-01 00:20:54.000000', 'temperatura', 677.0000, 'ºC'),
	(235157, 122, '2014-03-01 00:20:55.000000', 'temperatura', 661.0000, 'ºC'),
	(235158, 122, '2014-03-01 00:20:56.000000', 'temperatura', 76.0000, 'ºC'),
	(235159, 122, '2014-03-01 00:20:57.000000', 'temperatura', 796.0000, 'ºC'),
	(235160, 122, '2014-03-01 00:20:58.000000', 'temperatura', 152.0000, 'ºC'),
	(235161, 122, '2014-03-01 00:20:59.000000', 'temperatura', 775.0000, 'ºC'),
	(235162, 122, '2014-03-01 00:21:00.000000', 'temperatura', 1017.0000, 'ºC'),
	(235163, 122, '2014-03-01 00:21:01.000000', 'temperatura', 363.0000, 'ºC'),
	(235164, 122, '2014-03-01 00:21:02.000000', 'temperatura', 1163.0000, 'ºC'),
	(235165, 122, '2014-03-01 00:21:03.000000', 'temperatura', 1126.0000, 'ºC'),
	(235166, 122, '2014-03-01 00:21:04.000000', 'temperatura', 942.0000, 'ºC'),
	(235167, 122, '2014-03-01 00:21:05.000000', 'temperatura', 132.0000, 'ºC'),
	(235168, 122, '2014-03-01 00:21:06.000000', 'temperatura', 233.0000, 'ºC'),
	(235169, 122, '2014-03-01 00:21:07.000000', 'temperatura', 771.0000, 'ºC'),
	(235170, 122, '2014-03-01 00:21:08.000000', 'temperatura', 757.0000, 'ºC'),
	(235171, 122, '2014-03-01 00:21:09.000000', 'temperatura', 274.0000, 'ºC'),
	(235172, 122, '2014-03-01 00:21:10.000000', 'temperatura', 297.0000, 'ºC'),
	(235173, 122, '2014-03-01 00:21:11.000000', 'temperatura', 664.0000, 'ºC'),
	(235174, 122, '2014-03-01 00:21:12.000000', 'temperatura', 31.0000, 'ºC'),
	(235175, 122, '2014-03-01 00:21:13.000000', 'temperatura', 563.0000, 'ºC'),
	(235176, 122, '2014-03-01 00:21:14.000000', 'temperatura', 322.0000, 'ºC'),
	(235177, 122, '2014-03-01 00:21:15.000000', 'temperatura', 1123.0000, 'ºC'),
	(235178, 122, '2014-03-01 00:21:16.000000', 'temperatura', 1049.0000, 'ºC'),
	(235179, 122, '2014-03-01 00:21:17.000000', 'temperatura', 677.0000, 'ºC'),
	(235180, 122, '2014-03-01 00:21:18.000000', 'temperatura', 239.0000, 'ºC'),
	(235181, 122, '2014-03-01 00:21:19.000000', 'temperatura', 365.0000, 'ºC'),
	(235182, 122, '2014-03-01 00:21:20.000000', 'temperatura', 1109.0000, 'ºC'),
	(235183, 122, '2014-03-01 00:21:21.000000', 'temperatura', 848.0000, 'ºC'),
	(235184, 122, '2014-03-01 00:21:22.000000', 'temperatura', 915.0000, 'ºC'),
	(235185, 122, '2014-03-01 00:21:23.000000', 'temperatura', 833.0000, 'ºC'),
	(235186, 122, '2014-03-01 00:21:24.000000', 'temperatura', 221.0000, 'ºC'),
	(235187, 122, '2014-03-01 00:21:25.000000', 'temperatura', 1004.0000, 'ºC'),
	(235188, 122, '2014-03-01 00:21:26.000000', 'temperatura', 760.0000, 'ºC'),
	(235189, 122, '2014-03-01 00:21:27.000000', 'temperatura', 787.0000, 'ºC'),
	(235190, 122, '2014-03-01 00:21:28.000000', 'temperatura', 457.0000, 'ºC'),
	(235191, 122, '2014-03-01 00:21:29.000000', 'temperatura', 1125.0000, 'ºC'),
	(235192, 122, '2014-03-01 00:21:30.000000', 'temperatura', 652.0000, 'ºC'),
	(235193, 122, '2014-03-01 00:21:31.000000', 'temperatura', 1086.0000, 'ºC'),
	(235194, 122, '2014-03-01 00:21:32.000000', 'temperatura', 1074.0000, 'ºC'),
	(235195, 122, '2014-03-01 00:21:33.000000', 'temperatura', 912.0000, 'ºC'),
	(235196, 122, '2014-03-01 00:21:34.000000', 'temperatura', 138.0000, 'ºC'),
	(235197, 122, '2014-03-01 00:21:35.000000', 'temperatura', 356.0000, 'ºC'),
	(235198, 122, '2014-03-01 00:21:36.000000', 'temperatura', 166.0000, 'ºC'),
	(235199, 122, '2014-03-01 00:21:37.000000', 'temperatura', 963.0000, 'ºC'),
	(235200, 122, '2014-03-01 00:21:38.000000', 'temperatura', 717.0000, 'ºC'),
	(235201, 122, '2014-03-01 00:21:39.000000', 'temperatura', 695.0000, 'ºC'),
	(235202, 122, '2014-03-01 00:21:40.000000', 'temperatura', 127.0000, 'ºC'),
	(235203, 122, '2014-03-01 00:21:41.000000', 'temperatura', 948.0000, 'ºC'),
	(235204, 122, '2014-03-01 00:21:42.000000', 'temperatura', 760.0000, 'ºC'),
	(235205, 122, '2014-03-01 00:21:43.000000', 'temperatura', 957.0000, 'ºC'),
	(235206, 122, '2014-03-01 00:21:44.000000', 'temperatura', 104.0000, 'ºC'),
	(235207, 122, '2014-03-01 00:21:45.000000', 'temperatura', 50.0000, 'ºC'),
	(235208, 122, '2014-03-01 00:21:46.000000', 'temperatura', 1139.0000, 'ºC'),
	(235209, 122, '2014-03-01 00:21:47.000000', 'temperatura', 746.0000, 'ºC'),
	(235210, 122, '2014-03-01 00:21:48.000000', 'temperatura', 312.0000, 'ºC'),
	(235211, 122, '2014-03-01 00:21:49.000000', 'temperatura', 525.0000, 'ºC'),
	(235212, 122, '2014-03-01 00:21:50.000000', 'temperatura', 487.0000, 'ºC'),
	(235213, 122, '2014-03-01 00:21:51.000000', 'temperatura', 862.0000, 'ºC'),
	(235214, 122, '2014-03-01 00:21:52.000000', 'temperatura', 450.0000, 'ºC'),
	(235215, 122, '2014-03-01 00:21:53.000000', 'temperatura', 862.0000, 'ºC'),
	(235216, 122, '2014-03-01 00:21:54.000000', 'temperatura', 562.0000, 'ºC'),
	(235217, 122, '2014-03-01 00:21:55.000000', 'temperatura', 225.0000, 'ºC'),
	(235218, 122, '2014-03-01 00:21:56.000000', 'temperatura', 639.0000, 'ºC'),
	(235219, 122, '2014-03-01 00:21:57.000000', 'temperatura', 121.0000, 'ºC'),
	(235220, 122, '2014-03-01 00:21:58.000000', 'temperatura', 1089.0000, 'ºC'),
	(235221, 122, '2014-03-01 00:21:59.000000', 'temperatura', 284.0000, 'ºC'),
	(235222, 122, '2014-03-01 00:22:00.000000', 'temperatura', 551.0000, 'ºC'),
	(235223, 122, '2014-03-01 00:22:01.000000', 'temperatura', 706.0000, 'ºC'),
	(235224, 122, '2014-03-01 00:22:02.000000', 'temperatura', 675.0000, 'ºC'),
	(235225, 122, '2014-03-01 00:22:03.000000', 'temperatura', 57.0000, 'ºC'),
	(235226, 122, '2014-03-01 00:22:04.000000', 'temperatura', 663.0000, 'ºC'),
	(235227, 122, '2014-03-01 00:22:05.000000', 'temperatura', 742.0000, 'ºC'),
	(235228, 122, '2014-03-01 00:22:06.000000', 'temperatura', 524.0000, 'ºC'),
	(235229, 122, '2014-03-01 00:22:07.000000', 'temperatura', 393.0000, 'ºC'),
	(235230, 122, '2014-03-01 00:22:08.000000', 'temperatura', 393.0000, 'ºC'),
	(235231, 122, '2014-03-01 00:22:09.000000', 'temperatura', 789.0000, 'ºC'),
	(235232, 122, '2014-03-01 00:22:10.000000', 'temperatura', 366.0000, 'ºC'),
	(235233, 122, '2014-03-01 00:22:11.000000', 'temperatura', 663.0000, 'ºC'),
	(235234, 122, '2014-03-01 00:22:12.000000', 'temperatura', 1016.0000, 'ºC'),
	(235235, 122, '2014-03-01 00:22:13.000000', 'temperatura', 694.0000, 'ºC'),
	(235236, 122, '2014-03-01 00:22:14.000000', 'temperatura', 423.0000, 'ºC'),
	(235237, 122, '2014-03-01 00:22:15.000000', 'temperatura', 33.0000, 'ºC'),
	(235238, 122, '2014-03-01 00:22:16.000000', 'temperatura', 96.0000, 'ºC'),
	(235239, 122, '2014-03-01 00:22:17.000000', 'temperatura', 380.0000, 'ºC'),
	(235240, 122, '2014-03-01 00:22:18.000000', 'temperatura', 415.0000, 'ºC'),
	(235241, 122, '2014-03-01 00:22:19.000000', 'temperatura', 934.0000, 'ºC'),
	(235242, 122, '2014-03-01 00:22:20.000000', 'temperatura', 1026.0000, 'ºC'),
	(235243, 122, '2014-03-01 00:22:21.000000', 'temperatura', 1128.0000, 'ºC'),
	(235244, 122, '2014-03-01 00:22:22.000000', 'temperatura', 162.0000, 'ºC'),
	(235245, 122, '2014-03-01 00:22:23.000000', 'temperatura', 1028.0000, 'ºC'),
	(235246, 122, '2014-03-01 00:22:24.000000', 'temperatura', 1052.0000, 'ºC'),
	(235247, 122, '2014-03-01 00:22:25.000000', 'temperatura', 977.0000, 'ºC'),
	(235248, 122, '2014-03-01 00:22:26.000000', 'temperatura', 532.0000, 'ºC'),
	(235249, 122, '2014-03-01 00:22:27.000000', 'temperatura', 928.0000, 'ºC'),
	(235250, 122, '2014-03-01 00:22:28.000000', 'temperatura', 644.0000, 'ºC'),
	(235251, 122, '2014-03-01 00:22:29.000000', 'temperatura', 438.0000, 'ºC'),
	(235252, 122, '2014-03-01 00:22:30.000000', 'temperatura', 259.0000, 'ºC'),
	(235253, 122, '2014-03-01 00:22:31.000000', 'temperatura', 1182.0000, 'ºC'),
	(235254, 122, '2014-03-01 00:22:32.000000', 'temperatura', 333.0000, 'ºC'),
	(235255, 122, '2014-03-01 00:22:33.000000', 'temperatura', 521.0000, 'ºC'),
	(235256, 122, '2014-03-01 00:22:34.000000', 'temperatura', 404.0000, 'ºC'),
	(235257, 122, '2014-03-01 00:22:35.000000', 'temperatura', 459.0000, 'ºC'),
	(235258, 122, '2014-03-01 00:22:36.000000', 'temperatura', 1082.0000, 'ºC'),
	(235259, 122, '2014-03-01 00:22:37.000000', 'temperatura', 433.0000, 'ºC'),
	(235260, 122, '2014-03-01 00:22:38.000000', 'temperatura', 119.0000, 'ºC'),
	(235261, 122, '2014-03-01 00:22:39.000000', 'temperatura', 499.0000, 'ºC'),
	(235262, 122, '2014-03-01 00:22:40.000000', 'temperatura', 936.0000, 'ºC'),
	(235263, 122, '2014-03-01 00:22:41.000000', 'temperatura', 782.0000, 'ºC'),
	(235264, 122, '2014-03-01 00:22:42.000000', 'temperatura', 1106.0000, 'ºC'),
	(235265, 122, '2014-03-01 00:22:43.000000', 'temperatura', 783.0000, 'ºC'),
	(235266, 122, '2014-03-01 00:22:44.000000', 'temperatura', 596.0000, 'ºC'),
	(235267, 122, '2014-03-01 00:22:45.000000', 'temperatura', 632.0000, 'ºC'),
	(235268, 122, '2014-03-01 00:22:46.000000', 'temperatura', 174.0000, 'ºC'),
	(235269, 122, '2014-03-01 00:22:47.000000', 'temperatura', 175.0000, 'ºC'),
	(235270, 122, '2014-03-01 00:22:48.000000', 'temperatura', 354.0000, 'ºC'),
	(235271, 122, '2014-03-01 00:22:49.000000', 'temperatura', 44.0000, 'ºC'),
	(235272, 122, '2014-03-01 00:22:50.000000', 'temperatura', 358.0000, 'ºC'),
	(235273, 122, '2014-03-01 00:22:51.000000', 'temperatura', 459.0000, 'ºC'),
	(235274, 122, '2014-03-01 00:22:52.000000', 'temperatura', 23.0000, 'ºC'),
	(235275, 122, '2014-03-01 00:22:53.000000', 'temperatura', 1139.0000, 'ºC'),
	(235276, 122, '2014-03-01 00:22:54.000000', 'temperatura', 825.0000, 'ºC'),
	(235277, 122, '2014-03-01 00:22:55.000000', 'temperatura', 709.0000, 'ºC'),
	(235278, 122, '2014-03-01 00:22:56.000000', 'temperatura', 1070.0000, 'ºC'),
	(235279, 122, '2014-03-01 00:22:57.000000', 'temperatura', 823.0000, 'ºC'),
	(235280, 122, '2014-03-01 00:22:58.000000', 'temperatura', 907.0000, 'ºC'),
	(235281, 122, '2014-03-01 00:22:59.000000', 'temperatura', 867.0000, 'ºC'),
	(235282, 122, '2014-03-01 00:23:00.000000', 'temperatura', 414.0000, 'ºC'),
	(235283, 122, '2014-03-01 00:23:01.000000', 'temperatura', 669.0000, 'ºC'),
	(235284, 122, '2014-03-01 00:23:02.000000', 'temperatura', 905.0000, 'ºC'),
	(235285, 122, '2014-03-01 00:23:03.000000', 'temperatura', 117.0000, 'ºC'),
	(235286, 122, '2014-03-01 00:23:04.000000', 'temperatura', 272.0000, 'ºC'),
	(235287, 122, '2014-03-01 00:23:05.000000', 'temperatura', 1010.0000, 'ºC'),
	(235288, 122, '2014-03-01 00:23:06.000000', 'temperatura', 635.0000, 'ºC'),
	(235289, 122, '2014-03-01 00:23:07.000000', 'temperatura', 144.0000, 'ºC'),
	(235290, 122, '2014-03-01 00:23:08.000000', 'temperatura', 15.0000, 'ºC'),
	(235291, 122, '2014-03-01 00:23:09.000000', 'temperatura', 843.0000, 'ºC'),
	(235292, 122, '2014-03-01 00:23:10.000000', 'temperatura', 572.0000, 'ºC'),
	(235293, 122, '2014-03-01 00:23:11.000000', 'temperatura', 332.0000, 'ºC'),
	(235294, 122, '2014-03-01 00:23:12.000000', 'temperatura', 1146.0000, 'ºC'),
	(235295, 122, '2014-03-01 00:23:13.000000', 'temperatura', 1132.0000, 'ºC'),
	(235296, 122, '2014-03-01 00:23:14.000000', 'temperatura', 1024.0000, 'ºC'),
	(235297, 122, '2014-03-01 00:23:15.000000', 'temperatura', 525.0000, 'ºC'),
	(235298, 122, '2014-03-01 00:23:16.000000', 'temperatura', 752.0000, 'ºC'),
	(235299, 122, '2014-03-01 00:23:17.000000', 'temperatura', 986.0000, 'ºC'),
	(235300, 122, '2014-03-01 00:23:18.000000', 'temperatura', 274.0000, 'ºC'),
	(235301, 122, '2014-03-01 00:23:19.000000', 'temperatura', 813.0000, 'ºC'),
	(235302, 122, '2014-03-01 00:23:20.000000', 'temperatura', 843.0000, 'ºC'),
	(235303, 122, '2014-03-01 00:23:21.000000', 'temperatura', 578.0000, 'ºC'),
	(235304, 122, '2014-03-01 00:23:22.000000', 'temperatura', 360.0000, 'ºC'),
	(235305, 122, '2014-03-01 00:23:23.000000', 'temperatura', 69.0000, 'ºC'),
	(235306, 122, '2014-03-01 00:23:24.000000', 'temperatura', 462.0000, 'ºC'),
	(235307, 122, '2014-03-01 00:23:25.000000', 'temperatura', 906.0000, 'ºC'),
	(235308, 122, '2014-03-01 00:23:26.000000', 'temperatura', 742.0000, 'ºC'),
	(235309, 122, '2014-03-01 00:23:27.000000', 'temperatura', 994.0000, 'ºC'),
	(235310, 122, '2014-03-01 00:23:28.000000', 'temperatura', 343.0000, 'ºC'),
	(235311, 122, '2014-03-01 00:23:29.000000', 'temperatura', 1135.0000, 'ºC'),
	(235312, 122, '2014-03-01 00:23:30.000000', 'temperatura', 1045.0000, 'ºC'),
	(235313, 122, '2014-03-01 00:23:31.000000', 'temperatura', 622.0000, 'ºC'),
	(235314, 122, '2014-03-01 00:23:32.000000', 'temperatura', 1175.0000, 'ºC'),
	(235315, 122, '2014-03-01 00:23:33.000000', 'temperatura', 410.0000, 'ºC'),
	(235316, 122, '2014-03-01 00:23:34.000000', 'temperatura', 927.0000, 'ºC'),
	(235317, 122, '2014-03-01 00:23:35.000000', 'temperatura', 1003.0000, 'ºC'),
	(235318, 122, '2014-03-01 00:23:36.000000', 'temperatura', 1036.0000, 'ºC'),
	(235319, 122, '2014-03-01 00:23:37.000000', 'temperatura', 973.0000, 'ºC'),
	(235320, 122, '2014-03-01 00:23:38.000000', 'temperatura', 555.0000, 'ºC'),
	(235321, 122, '2014-03-01 00:23:39.000000', 'temperatura', 1059.0000, 'ºC'),
	(235322, 122, '2014-03-01 00:23:40.000000', 'temperatura', 27.0000, 'ºC'),
	(235323, 122, '2014-03-01 00:23:41.000000', 'temperatura', 562.0000, 'ºC'),
	(235324, 122, '2014-03-01 00:23:42.000000', 'temperatura', 328.0000, 'ºC'),
	(235325, 122, '2014-03-01 00:23:43.000000', 'temperatura', 1156.0000, 'ºC'),
	(235326, 122, '2014-03-01 00:23:44.000000', 'temperatura', 1195.0000, 'ºC'),
	(235327, 122, '2014-03-01 00:23:45.000000', 'temperatura', 110.0000, 'ºC'),
	(235328, 122, '2014-03-01 00:23:46.000000', 'temperatura', 564.0000, 'ºC'),
	(235329, 122, '2014-03-01 00:23:47.000000', 'temperatura', 90.0000, 'ºC'),
	(235330, 122, '2014-03-01 00:23:48.000000', 'temperatura', 1159.0000, 'ºC'),
	(235331, 122, '2014-03-01 00:23:49.000000', 'temperatura', 724.0000, 'ºC'),
	(235332, 122, '2014-03-01 00:23:50.000000', 'temperatura', 146.0000, 'ºC'),
	(235333, 122, '2014-03-01 00:23:51.000000', 'temperatura', 958.0000, 'ºC'),
	(235334, 122, '2014-03-01 00:23:52.000000', 'temperatura', 751.0000, 'ºC'),
	(235335, 122, '2014-03-01 00:23:53.000000', 'temperatura', 881.0000, 'ºC'),
	(235336, 122, '2014-03-01 00:23:54.000000', 'temperatura', 951.0000, 'ºC'),
	(235337, 122, '2014-03-01 00:23:55.000000', 'temperatura', 916.0000, 'ºC'),
	(235338, 122, '2014-03-01 00:23:56.000000', 'temperatura', 527.0000, 'ºC'),
	(235339, 122, '2014-03-01 00:23:57.000000', 'temperatura', 1085.0000, 'ºC'),
	(235340, 122, '2014-03-01 00:23:58.000000', 'temperatura', 245.0000, 'ºC'),
	(235341, 122, '2014-03-01 00:23:59.000000', 'temperatura', 372.0000, 'ºC'),
	(235342, 122, '2014-03-01 00:24:00.000000', 'temperatura', 1125.0000, 'ºC'),
	(235343, 122, '2014-03-01 00:24:01.000000', 'temperatura', 908.0000, 'ºC'),
	(235344, 122, '2014-03-01 00:24:02.000000', 'temperatura', 1169.0000, 'ºC'),
	(235345, 122, '2014-03-01 00:24:03.000000', 'temperatura', 718.0000, 'ºC'),
	(235346, 122, '2014-03-01 00:24:04.000000', 'temperatura', 84.0000, 'ºC'),
	(235347, 122, '2014-03-01 00:24:05.000000', 'temperatura', 665.0000, 'ºC'),
	(235348, 122, '2014-03-01 00:24:06.000000', 'temperatura', 676.0000, 'ºC'),
	(235349, 122, '2014-03-01 00:24:07.000000', 'temperatura', 184.0000, 'ºC'),
	(235350, 122, '2014-03-01 00:24:08.000000', 'temperatura', 94.0000, 'ºC'),
	(235351, 122, '2014-03-01 00:24:09.000000', 'temperatura', 1119.0000, 'ºC'),
	(235352, 122, '2014-03-01 00:24:10.000000', 'temperatura', 512.0000, 'ºC'),
	(235353, 122, '2014-03-01 00:24:11.000000', 'temperatura', 403.0000, 'ºC'),
	(235354, 122, '2014-03-01 00:24:12.000000', 'temperatura', 480.0000, 'ºC'),
	(235355, 122, '2014-03-01 00:24:13.000000', 'temperatura', 1192.0000, 'ºC'),
	(235356, 122, '2014-03-01 00:24:14.000000', 'temperatura', 922.0000, 'ºC'),
	(235357, 122, '2014-03-01 00:24:15.000000', 'temperatura', 1035.0000, 'ºC'),
	(235358, 122, '2014-03-01 00:24:16.000000', 'temperatura', 7.0000, 'ºC'),
	(235359, 122, '2014-03-01 00:24:17.000000', 'temperatura', 533.0000, 'ºC'),
	(235360, 122, '2014-03-01 00:24:18.000000', 'temperatura', 245.0000, 'ºC'),
	(235361, 122, '2014-03-01 00:24:19.000000', 'temperatura', 825.0000, 'ºC'),
	(235362, 122, '2014-03-01 00:24:20.000000', 'temperatura', 990.0000, 'ºC'),
	(235363, 122, '2014-03-01 00:24:21.000000', 'temperatura', 77.0000, 'ºC'),
	(235364, 122, '2014-03-01 00:24:22.000000', 'temperatura', 1013.0000, 'ºC'),
	(235365, 122, '2014-03-01 00:24:23.000000', 'temperatura', 37.0000, 'ºC'),
	(235366, 122, '2014-03-01 00:24:24.000000', 'temperatura', 744.0000, 'ºC'),
	(235367, 122, '2014-03-01 00:24:25.000000', 'temperatura', 11.0000, 'ºC'),
	(235368, 122, '2014-03-01 00:24:26.000000', 'temperatura', 222.0000, 'ºC'),
	(235369, 122, '2014-03-01 00:24:27.000000', 'temperatura', 1077.0000, 'ºC'),
	(235370, 122, '2014-03-01 00:24:28.000000', 'temperatura', 1121.0000, 'ºC'),
	(235371, 122, '2014-03-01 00:24:29.000000', 'temperatura', 1176.0000, 'ºC'),
	(235372, 122, '2014-03-01 00:24:30.000000', 'temperatura', 117.0000, 'ºC'),
	(235373, 122, '2014-03-01 00:24:31.000000', 'temperatura', 656.0000, 'ºC'),
	(235374, 122, '2014-03-01 00:24:32.000000', 'temperatura', 531.0000, 'ºC'),
	(235375, 122, '2014-03-01 00:24:33.000000', 'temperatura', 686.0000, 'ºC'),
	(235376, 122, '2014-03-01 00:24:34.000000', 'temperatura', 638.0000, 'ºC'),
	(235377, 122, '2014-03-01 00:24:35.000000', 'temperatura', 1133.0000, 'ºC'),
	(235378, 122, '2014-03-01 00:24:36.000000', 'temperatura', 149.0000, 'ºC'),
	(235379, 122, '2014-03-01 00:24:37.000000', 'temperatura', 948.0000, 'ºC'),
	(235380, 122, '2014-03-01 00:24:38.000000', 'temperatura', 695.0000, 'ºC'),
	(235381, 122, '2014-03-01 00:24:39.000000', 'temperatura', 632.0000, 'ºC'),
	(235382, 122, '2014-03-01 00:24:40.000000', 'temperatura', 1075.0000, 'ºC'),
	(235383, 122, '2014-03-01 00:24:41.000000', 'temperatura', 1080.0000, 'ºC'),
	(235384, 122, '2014-03-01 00:24:42.000000', 'temperatura', 977.0000, 'ºC'),
	(235385, 122, '2014-03-01 00:24:43.000000', 'temperatura', 443.0000, 'ºC'),
	(235386, 122, '2014-03-01 00:24:44.000000', 'temperatura', 484.0000, 'ºC'),
	(235387, 122, '2014-03-01 00:24:45.000000', 'temperatura', 1090.0000, 'ºC'),
	(235388, 122, '2014-03-01 00:24:46.000000', 'temperatura', 402.0000, 'ºC'),
	(235389, 122, '2014-03-01 00:24:47.000000', 'temperatura', 1139.0000, 'ºC'),
	(235390, 122, '2014-03-01 00:24:48.000000', 'temperatura', 888.0000, 'ºC'),
	(235391, 122, '2014-03-01 00:24:49.000000', 'temperatura', 1026.0000, 'ºC'),
	(235392, 122, '2014-03-01 00:24:50.000000', 'temperatura', 64.0000, 'ºC'),
	(235393, 122, '2014-03-01 00:24:51.000000', 'temperatura', 844.0000, 'ºC'),
	(235394, 122, '2014-03-01 00:24:52.000000', 'temperatura', 430.0000, 'ºC'),
	(235395, 122, '2014-03-01 00:24:53.000000', 'temperatura', 816.0000, 'ºC'),
	(235396, 122, '2014-03-01 00:24:54.000000', 'temperatura', 390.0000, 'ºC'),
	(235397, 122, '2014-03-01 00:24:55.000000', 'temperatura', 703.0000, 'ºC'),
	(235398, 122, '2014-03-01 00:24:56.000000', 'temperatura', 1147.0000, 'ºC'),
	(235399, 122, '2014-03-01 00:24:57.000000', 'temperatura', 26.0000, 'ºC'),
	(235400, 122, '2014-03-01 00:24:58.000000', 'temperatura', 290.0000, 'ºC'),
	(235401, 122, '2014-03-01 00:24:59.000000', 'temperatura', 172.0000, 'ºC'),
	(235402, 122, '2014-03-01 00:25:00.000000', 'temperatura', 1189.0000, 'ºC'),
	(235403, 122, '2014-03-01 00:25:01.000000', 'temperatura', 630.0000, 'ºC'),
	(235404, 122, '2014-03-01 00:25:02.000000', 'temperatura', 784.0000, 'ºC'),
	(235405, 122, '2014-03-01 00:25:03.000000', 'temperatura', 830.0000, 'ºC'),
	(235406, 122, '2014-03-01 00:25:04.000000', 'temperatura', 599.0000, 'ºC'),
	(235407, 122, '2014-03-01 00:25:05.000000', 'temperatura', 504.0000, 'ºC'),
	(235408, 122, '2014-03-01 00:25:06.000000', 'temperatura', 726.0000, 'ºC'),
	(235409, 122, '2014-03-01 00:25:07.000000', 'temperatura', 916.0000, 'ºC'),
	(235410, 122, '2014-03-01 00:25:08.000000', 'temperatura', 4.0000, 'ºC'),
	(235411, 122, '2014-03-01 00:25:09.000000', 'temperatura', 872.0000, 'ºC'),
	(235412, 122, '2014-03-01 00:25:10.000000', 'temperatura', 750.0000, 'ºC'),
	(235413, 122, '2014-03-01 00:25:11.000000', 'temperatura', 1134.0000, 'ºC'),
	(235414, 122, '2014-03-01 00:25:12.000000', 'temperatura', 1020.0000, 'ºC'),
	(235415, 122, '2014-03-01 00:25:13.000000', 'temperatura', 498.0000, 'ºC'),
	(235416, 122, '2014-03-01 00:25:14.000000', 'temperatura', 631.0000, 'ºC'),
	(235417, 122, '2014-03-01 00:25:15.000000', 'temperatura', 460.0000, 'ºC'),
	(235418, 122, '2014-03-01 00:25:16.000000', 'temperatura', 410.0000, 'ºC'),
	(235419, 122, '2014-03-01 00:25:17.000000', 'temperatura', 668.0000, 'ºC'),
	(235420, 122, '2014-03-01 00:25:18.000000', 'temperatura', 910.0000, 'ºC'),
	(235421, 122, '2014-03-01 00:25:19.000000', 'temperatura', 148.0000, 'ºC'),
	(235422, 122, '2014-03-01 00:25:20.000000', 'temperatura', 409.0000, 'ºC'),
	(235423, 122, '2014-03-01 00:25:21.000000', 'temperatura', 402.0000, 'ºC'),
	(235424, 122, '2014-03-01 00:25:22.000000', 'temperatura', 784.0000, 'ºC'),
	(235425, 122, '2014-03-01 00:25:23.000000', 'temperatura', 312.0000, 'ºC'),
	(235426, 122, '2014-03-01 00:25:24.000000', 'temperatura', 411.0000, 'ºC'),
	(235427, 122, '2014-03-01 00:25:25.000000', 'temperatura', 1121.0000, 'ºC'),
	(235428, 122, '2014-03-01 00:25:26.000000', 'temperatura', 770.0000, 'ºC'),
	(235429, 122, '2014-03-01 00:25:27.000000', 'temperatura', 487.0000, 'ºC'),
	(235430, 122, '2014-03-01 00:25:28.000000', 'temperatura', 127.0000, 'ºC'),
	(235431, 122, '2014-03-01 00:25:29.000000', 'temperatura', 374.0000, 'ºC'),
	(235432, 122, '2014-03-01 00:25:30.000000', 'temperatura', 289.0000, 'ºC'),
	(235433, 122, '2014-03-01 00:25:31.000000', 'temperatura', 322.0000, 'ºC'),
	(235434, 122, '2014-03-01 00:25:32.000000', 'temperatura', 744.0000, 'ºC'),
	(235435, 122, '2014-03-01 00:25:33.000000', 'temperatura', 356.0000, 'ºC'),
	(235436, 122, '2014-03-01 00:25:34.000000', 'temperatura', 748.0000, 'ºC'),
	(235437, 122, '2014-03-01 00:25:35.000000', 'temperatura', 274.0000, 'ºC'),
	(235438, 122, '2014-03-01 00:25:36.000000', 'temperatura', 323.0000, 'ºC'),
	(235439, 122, '2014-03-01 00:25:37.000000', 'temperatura', 797.0000, 'ºC'),
	(235440, 122, '2014-03-01 00:25:38.000000', 'temperatura', 615.0000, 'ºC'),
	(235441, 122, '2014-03-01 00:25:39.000000', 'temperatura', 685.0000, 'ºC'),
	(235442, 122, '2014-03-01 00:25:40.000000', 'temperatura', 380.0000, 'ºC'),
	(235443, 122, '2014-03-01 00:25:41.000000', 'temperatura', 1044.0000, 'ºC'),
	(235444, 122, '2014-03-01 00:25:42.000000', 'temperatura', 480.0000, 'ºC'),
	(235445, 122, '2014-03-01 00:25:43.000000', 'temperatura', 471.0000, 'ºC'),
	(235446, 122, '2014-03-01 00:25:44.000000', 'temperatura', 913.0000, 'ºC'),
	(235447, 122, '2014-03-01 00:25:45.000000', 'temperatura', 755.0000, 'ºC'),
	(235448, 122, '2014-03-01 00:25:46.000000', 'temperatura', 1034.0000, 'ºC'),
	(235449, 122, '2014-03-01 00:25:47.000000', 'temperatura', 507.0000, 'ºC'),
	(235450, 122, '2014-03-01 00:25:48.000000', 'temperatura', 632.0000, 'ºC'),
	(235451, 122, '2014-03-01 00:25:49.000000', 'temperatura', 441.0000, 'ºC'),
	(235452, 122, '2014-03-01 00:25:50.000000', 'temperatura', 310.0000, 'ºC'),
	(235453, 122, '2014-03-01 00:25:51.000000', 'temperatura', 228.0000, 'ºC'),
	(235454, 122, '2014-03-01 00:25:52.000000', 'temperatura', 208.0000, 'ºC'),
	(235455, 122, '2014-03-01 00:25:53.000000', 'temperatura', 359.0000, 'ºC'),
	(235456, 122, '2014-03-01 00:25:54.000000', 'temperatura', 1171.0000, 'ºC'),
	(235457, 122, '2014-03-01 00:25:55.000000', 'temperatura', 1179.0000, 'ºC'),
	(235458, 122, '2014-03-01 00:25:56.000000', 'temperatura', 1183.0000, 'ºC'),
	(235459, 122, '2014-03-01 00:25:57.000000', 'temperatura', 1179.0000, 'ºC'),
	(235460, 122, '2014-03-01 00:25:58.000000', 'temperatura', 1145.0000, 'ºC'),
	(235461, 122, '2014-03-01 00:25:59.000000', 'temperatura', 987.0000, 'ºC'),
	(235462, 122, '2014-03-01 00:26:00.000000', 'temperatura', 302.0000, 'ºC'),
	(235463, 122, '2014-03-01 00:26:01.000000', 'temperatura', 951.0000, 'ºC'),
	(235464, 122, '2014-03-01 00:26:02.000000', 'temperatura', 249.0000, 'ºC'),
	(235465, 122, '2014-03-01 00:26:03.000000', 'temperatura', 794.0000, 'ºC'),
	(235466, 122, '2014-03-01 00:26:04.000000', 'temperatura', 821.0000, 'ºC'),
	(235467, 122, '2014-03-01 00:26:05.000000', 'temperatura', 522.0000, 'ºC'),
	(235468, 122, '2014-03-01 00:26:06.000000', 'temperatura', 151.0000, 'ºC'),
	(235469, 122, '2014-03-01 00:26:07.000000', 'temperatura', 386.0000, 'ºC'),
	(235470, 122, '2014-03-01 00:26:08.000000', 'temperatura', 279.0000, 'ºC'),
	(235471, 122, '2014-03-01 00:26:09.000000', 'temperatura', 239.0000, 'ºC'),
	(235472, 122, '2014-03-01 00:26:10.000000', 'temperatura', 358.0000, 'ºC'),
	(235473, 122, '2014-03-01 00:26:11.000000', 'temperatura', 1074.0000, 'ºC'),
	(235474, 122, '2014-03-01 00:26:12.000000', 'temperatura', 697.0000, 'ºC'),
	(235475, 122, '2014-03-01 00:26:13.000000', 'temperatura', 262.0000, 'ºC'),
	(235476, 122, '2014-03-01 00:26:14.000000', 'temperatura', 422.0000, 'ºC'),
	(235477, 122, '2014-03-01 00:26:15.000000', 'temperatura', 124.0000, 'ºC'),
	(235478, 122, '2014-03-01 00:26:16.000000', 'temperatura', 553.0000, 'ºC'),
	(235479, 122, '2014-03-01 00:26:17.000000', 'temperatura', 1193.0000, 'ºC'),
	(235480, 122, '2014-03-01 00:26:18.000000', 'temperatura', 708.0000, 'ºC'),
	(235481, 122, '2014-03-01 00:26:19.000000', 'temperatura', 1160.0000, 'ºC'),
	(235482, 122, '2014-03-01 00:26:20.000000', 'temperatura', 79.0000, 'ºC'),
	(235483, 122, '2014-03-01 00:26:21.000000', 'temperatura', 515.0000, 'ºC'),
	(235484, 122, '2014-03-01 00:26:22.000000', 'temperatura', 1138.0000, 'ºC'),
	(235485, 122, '2014-03-01 00:26:23.000000', 'temperatura', 546.0000, 'ºC'),
	(235486, 122, '2014-03-01 00:26:24.000000', 'temperatura', 517.0000, 'ºC'),
	(235487, 122, '2014-03-01 00:26:25.000000', 'temperatura', 945.0000, 'ºC'),
	(235488, 122, '2014-03-01 00:26:26.000000', 'temperatura', 777.0000, 'ºC'),
	(235489, 122, '2014-03-01 00:26:27.000000', 'temperatura', 1049.0000, 'ºC'),
	(235490, 122, '2014-03-01 00:26:28.000000', 'temperatura', 516.0000, 'ºC'),
	(235491, 122, '2014-03-01 00:26:29.000000', 'temperatura', 633.0000, 'ºC'),
	(235492, 122, '2014-03-01 00:26:30.000000', 'temperatura', 419.0000, 'ºC'),
	(235493, 122, '2014-03-01 00:26:31.000000', 'temperatura', 194.0000, 'ºC'),
	(235494, 122, '2014-03-01 00:26:32.000000', 'temperatura', 916.0000, 'ºC'),
	(235495, 122, '2014-03-01 00:26:33.000000', 'temperatura', 399.0000, 'ºC'),
	(235496, 122, '2014-03-01 00:26:34.000000', 'temperatura', 447.0000, 'ºC'),
	(235497, 122, '2014-03-01 00:26:35.000000', 'temperatura', 1040.0000, 'ºC'),
	(235498, 122, '2014-03-01 00:26:36.000000', 'temperatura', 256.0000, 'ºC'),
	(235499, 122, '2014-03-01 00:26:37.000000', 'temperatura', 563.0000, 'ºC'),
	(235500, 122, '2014-03-01 00:26:38.000000', 'temperatura', 845.0000, 'ºC'),
	(235501, 122, '2014-03-01 00:26:39.000000', 'temperatura', 137.0000, 'ºC'),
	(235502, 122, '2014-03-01 00:26:40.000000', 'temperatura', 553.0000, 'ºC'),
	(235503, 122, '2014-03-01 00:26:41.000000', 'temperatura', 1154.0000, 'ºC'),
	(235504, 122, '2014-03-01 00:26:42.000000', 'temperatura', 510.0000, 'ºC'),
	(235505, 122, '2014-03-01 00:26:43.000000', 'temperatura', 289.0000, 'ºC'),
	(235506, 122, '2014-03-01 00:26:44.000000', 'temperatura', 1114.0000, 'ºC'),
	(235507, 122, '2014-03-01 00:26:45.000000', 'temperatura', 1103.0000, 'ºC'),
	(235508, 122, '2014-03-01 00:26:46.000000', 'temperatura', 974.0000, 'ºC'),
	(235509, 122, '2014-03-01 00:26:47.000000', 'temperatura', 360.0000, 'ºC'),
	(235510, 122, '2014-03-01 00:26:48.000000', 'temperatura', 81.0000, 'ºC'),
	(235511, 122, '2014-03-01 00:26:49.000000', 'temperatura', 525.0000, 'ºC'),
	(235512, 122, '2014-03-01 00:26:50.000000', 'temperatura', 1182.0000, 'ºC'),
	(235513, 122, '2014-03-01 00:26:51.000000', 'temperatura', 738.0000, 'ºC'),
	(235514, 122, '2014-03-01 00:26:52.000000', 'temperatura', 141.0000, 'ºC'),
	(235515, 122, '2014-03-01 00:26:53.000000', 'temperatura', 893.0000, 'ºC'),
	(235516, 122, '2014-03-01 00:26:54.000000', 'temperatura', 443.0000, 'ºC'),
	(235517, 122, '2014-03-01 00:26:55.000000', 'temperatura', 734.0000, 'ºC'),
	(235518, 122, '2014-03-01 00:26:56.000000', 'temperatura', 1143.0000, 'ºC'),
	(235519, 122, '2014-03-01 00:26:57.000000', 'temperatura', 1112.0000, 'ºC'),
	(235520, 122, '2014-03-01 00:26:58.000000', 'temperatura', 933.0000, 'ºC'),
	(235521, 122, '2014-03-01 00:26:59.000000', 'temperatura', 128.0000, 'ºC'),
	(235522, 122, '2014-03-01 00:27:00.000000', 'temperatura', 241.0000, 'ºC'),
	(235523, 122, '2014-03-01 00:27:01.000000', 'temperatura', 823.0000, 'ºC'),
	(235524, 122, '2014-03-01 00:27:02.000000', 'temperatura', 993.0000, 'ºC'),
	(235525, 122, '2014-03-01 00:27:03.000000', 'temperatura', 97.0000, 'ºC'),
	(235526, 122, '2014-03-01 00:27:04.000000', 'temperatura', 1106.0000, 'ºC'),
	(235527, 122, '2014-03-01 00:27:05.000000', 'temperatura', 439.0000, 'ºC'),
	(235528, 122, '2014-03-01 00:27:06.000000', 'temperatura', 77.0000, 'ºC'),
	(235529, 122, '2014-03-01 00:27:07.000000', 'temperatura', 268.0000, 'ºC'),
	(235530, 122, '2014-03-01 00:27:08.000000', 'temperatura', 1108.0000, 'ºC'),
	(235531, 122, '2014-03-01 00:27:09.000000', 'temperatura', 1140.0000, 'ºC'),
	(235532, 122, '2014-03-01 00:27:10.000000', 'temperatura', 1175.0000, 'ºC'),
	(235533, 122, '2014-03-01 00:27:11.000000', 'temperatura', 54.0000, 'ºC'),
	(235534, 122, '2014-03-01 00:27:12.000000', 'temperatura', 347.0000, 'ºC'),
	(235535, 122, '2014-03-01 00:27:13.000000', 'temperatura', 375.0000, 'ºC'),
	(235536, 122, '2014-03-01 00:27:14.000000', 'temperatura', 833.0000, 'ºC'),
	(235537, 122, '2014-03-01 00:27:15.000000', 'temperatura', 642.0000, 'ºC'),
	(235538, 122, '2014-03-01 00:27:16.000000', 'temperatura', 709.0000, 'ºC'),
	(235539, 122, '2014-03-01 00:27:17.000000', 'temperatura', 420.0000, 'ºC'),
	(235540, 122, '2014-03-01 00:27:18.000000', 'temperatura', 1175.0000, 'ºC'),
	(235541, 122, '2014-03-01 00:27:19.000000', 'temperatura', 1014.0000, 'ºC'),
	(235542, 122, '2014-03-01 00:27:20.000000', 'temperatura', 345.0000, 'ºC'),
	(235543, 122, '2014-03-01 00:27:21.000000', 'temperatura', 1085.0000, 'ºC'),
	(235544, 122, '2014-03-01 00:27:22.000000', 'temperatura', 788.0000, 'ºC'),
	(235545, 122, '2014-03-01 00:27:23.000000', 'temperatura', 686.0000, 'ºC'),
	(235546, 122, '2014-03-01 00:27:24.000000', 'temperatura', 1068.0000, 'ºC'),
	(235547, 122, '2014-03-01 00:27:25.000000', 'temperatura', 882.0000, 'ºC'),
	(235548, 122, '2014-03-01 00:27:26.000000', 'temperatura', 7.0000, 'ºC'),
	(235549, 122, '2014-03-01 00:27:27.000000', 'temperatura', 990.0000, 'ºC'),
	(235550, 122, '2014-03-01 00:27:28.000000', 'temperatura', 129.0000, 'ºC'),
	(235551, 122, '2014-03-01 00:27:29.000000', 'temperatura', 77.0000, 'ºC'),
	(235552, 122, '2014-03-01 00:27:30.000000', 'temperatura', 1195.0000, 'ºC'),
	(235553, 122, '2014-03-01 00:27:31.000000', 'temperatura', 948.0000, 'ºC'),
	(235554, 122, '2014-03-01 00:27:32.000000', 'temperatura', 1152.0000, 'ºC'),
	(235555, 122, '2014-03-01 00:27:33.000000', 'temperatura', 519.0000, 'ºC'),
	(235556, 122, '2014-03-01 00:27:34.000000', 'temperatura', 338.0000, 'ºC'),
	(235557, 122, '2014-03-01 00:27:35.000000', 'temperatura', 136.0000, 'ºC'),
	(235558, 122, '2014-03-01 00:27:36.000000', 'temperatura', 866.0000, 'ºC'),
	(235559, 122, '2014-03-01 00:27:37.000000', 'temperatura', 322.0000, 'ºC'),
	(235560, 122, '2014-03-01 00:27:38.000000', 'temperatura', 211.0000, 'ºC'),
	(235561, 122, '2014-03-01 00:27:39.000000', 'temperatura', 89.0000, 'ºC'),
	(235562, 122, '2014-03-01 00:27:40.000000', 'temperatura', 1014.0000, 'ºC'),
	(235563, 122, '2014-03-01 00:27:41.000000', 'temperatura', 4.0000, 'ºC'),
	(235564, 122, '2014-03-01 00:27:42.000000', 'temperatura', 579.0000, 'ºC'),
	(235565, 122, '2014-03-01 00:27:43.000000', 'temperatura', 481.0000, 'ºC'),
	(235566, 122, '2014-03-01 00:27:44.000000', 'temperatura', 671.0000, 'ºC'),
	(235567, 122, '2014-03-01 00:27:45.000000', 'temperatura', 713.0000, 'ºC'),
	(235568, 122, '2014-03-01 00:27:46.000000', 'temperatura', 351.0000, 'ºC'),
	(235569, 122, '2014-03-01 00:27:47.000000', 'temperatura', 817.0000, 'ºC'),
	(235570, 122, '2014-03-01 00:27:48.000000', 'temperatura', 633.0000, 'ºC'),
	(235571, 122, '2014-03-01 00:27:49.000000', 'temperatura', 716.0000, 'ºC'),
	(235572, 122, '2014-03-01 00:27:50.000000', 'temperatura', 479.0000, 'ºC'),
	(235573, 122, '2014-03-01 00:27:51.000000', 'temperatura', 248.0000, 'ºC'),
	(235574, 122, '2014-03-01 00:27:52.000000', 'temperatura', 1002.0000, 'ºC'),
	(235575, 122, '2014-03-01 00:27:53.000000', 'temperatura', 670.0000, 'ºC'),
	(235576, 122, '2014-03-01 00:27:54.000000', 'temperatura', 342.0000, 'ºC'),
	(235577, 122, '2014-03-01 00:27:55.000000', 'temperatura', 902.0000, 'ºC'),
	(235578, 122, '2014-03-01 00:27:56.000000', 'temperatura', 1084.0000, 'ºC'),
	(235579, 122, '2014-03-01 00:27:57.000000', 'temperatura', 316.0000, 'ºC'),
	(235580, 122, '2014-03-01 00:27:58.000000', 'temperatura', 728.0000, 'ºC'),
	(235581, 122, '2014-03-01 00:27:59.000000', 'temperatura', 291.0000, 'ºC'),
	(235582, 122, '2014-03-01 00:28:00.000000', 'temperatura', 471.0000, 'ºC'),
	(235583, 122, '2014-03-01 00:28:01.000000', 'temperatura', 281.0000, 'ºC'),
	(235584, 122, '2014-03-01 00:28:02.000000', 'temperatura', 1195.0000, 'ºC'),
	(235585, 122, '2014-03-01 00:28:03.000000', 'temperatura', 332.0000, 'ºC'),
	(235586, 122, '2014-03-01 00:28:04.000000', 'temperatura', 477.0000, 'ºC'),
	(235587, 122, '2014-03-01 00:28:05.000000', 'temperatura', 190.0000, 'ºC'),
	(235588, 122, '2014-03-01 00:28:06.000000', 'temperatura', 719.0000, 'ºC'),
	(235589, 122, '2014-03-01 00:28:07.000000', 'temperatura', 623.0000, 'ºC'),
	(235590, 122, '2014-03-01 00:28:08.000000', 'temperatura', 960.0000, 'ºC'),
	(235591, 122, '2014-03-01 00:28:09.000000', 'temperatura', 530.0000, 'ºC'),
	(235592, 122, '2014-03-01 00:28:10.000000', 'temperatura', 972.0000, 'ºC'),
	(235593, 122, '2014-03-01 00:28:11.000000', 'temperatura', 869.0000, 'ºC'),
	(235594, 122, '2014-03-01 00:28:12.000000', 'temperatura', 230.0000, 'ºC'),
	(235595, 122, '2014-03-01 00:28:13.000000', 'temperatura', 945.0000, 'ºC'),
	(235596, 122, '2014-03-01 00:28:14.000000', 'temperatura', 433.0000, 'ºC'),
	(235597, 122, '2014-03-01 00:28:15.000000', 'temperatura', 530.0000, 'ºC'),
	(235598, 122, '2014-03-01 00:28:16.000000', 'temperatura', 154.0000, 'ºC'),
	(235599, 122, '2014-03-01 00:28:17.000000', 'temperatura', 379.0000, 'ºC'),
	(235600, 122, '2014-03-01 00:28:18.000000', 'temperatura', 236.0000, 'ºC'),
	(235601, 122, '2014-03-01 00:28:19.000000', 'temperatura', 41.0000, 'ºC'),
	(235602, 122, '2014-03-01 00:28:20.000000', 'temperatura', 696.0000, 'ºC'),
	(235603, 122, '2014-03-01 00:28:21.000000', 'temperatura', 960.0000, 'ºC'),
	(235604, 122, '2014-03-01 00:28:22.000000', 'temperatura', 313.0000, 'ºC'),
	(235605, 122, '2014-03-01 00:28:23.000000', 'temperatura', 1086.0000, 'ºC'),
	(235606, 122, '2014-03-01 00:28:24.000000', 'temperatura', 893.0000, 'ºC'),
	(235607, 122, '2014-03-01 00:28:25.000000', 'temperatura', 5.0000, 'ºC'),
	(235608, 122, '2014-03-01 00:28:26.000000', 'temperatura', 945.0000, 'ºC'),
	(235609, 122, '2014-03-01 00:28:27.000000', 'temperatura', 1112.0000, 'ºC'),
	(235610, 122, '2014-03-01 00:28:28.000000', 'temperatura', 326.0000, 'ºC'),
	(235611, 122, '2014-03-01 00:28:29.000000', 'temperatura', 694.0000, 'ºC'),
	(235612, 122, '2014-03-01 00:28:30.000000', 'temperatura', 94.0000, 'ºC'),
	(235613, 122, '2014-03-01 00:28:31.000000', 'temperatura', 786.0000, 'ºC'),
	(235614, 122, '2014-03-01 00:28:32.000000', 'temperatura', 51.0000, 'ºC'),
	(235615, 122, '2014-03-01 00:28:33.000000', 'temperatura', 295.0000, 'ºC'),
	(235616, 122, '2014-03-01 00:28:34.000000', 'temperatura', 122.0000, 'ºC'),
	(235617, 122, '2014-03-01 00:28:35.000000', 'temperatura', 929.0000, 'ºC'),
	(235618, 122, '2014-03-01 00:28:36.000000', 'temperatura', 676.0000, 'ºC'),
	(235619, 122, '2014-03-01 00:28:37.000000', 'temperatura', 593.0000, 'ºC'),
	(235620, 122, '2014-03-01 00:28:38.000000', 'temperatura', 941.0000, 'ºC'),
	(235621, 122, '2014-03-01 00:28:39.000000', 'temperatura', 524.0000, 'ºC'),
	(235622, 122, '2014-03-01 00:28:40.000000', 'temperatura', 996.0000, 'ºC'),
	(235623, 122, '2014-03-01 00:28:41.000000', 'temperatura', 1010.0000, 'ºC'),
	(235624, 122, '2014-03-01 00:28:42.000000', 'temperatura', 863.0000, 'ºC'),
	(235625, 122, '2014-03-01 00:28:43.000000', 'temperatura', 83.0000, 'ºC'),
	(235626, 122, '2014-03-01 00:28:44.000000', 'temperatura', 229.0000, 'ºC'),
	(235627, 122, '2014-03-01 00:28:45.000000', 'temperatura', 897.0000, 'ºC'),
	(235628, 122, '2014-03-01 00:28:46.000000', 'temperatura', 197.0000, 'ºC'),
	(235629, 122, '2014-03-01 00:28:47.000000', 'temperatura', 693.0000, 'ºC'),
	(235630, 122, '2014-03-01 00:28:48.000000', 'temperatura', 476.0000, 'ºC'),
	(235631, 122, '2014-03-01 00:28:49.000000', 'temperatura', 301.0000, 'ºC'),
	(235632, 122, '2014-03-01 00:28:50.000000', 'temperatura', 77.0000, 'ºC'),
	(235633, 122, '2014-03-01 00:28:51.000000', 'temperatura', 684.0000, 'ºC'),
	(235634, 122, '2014-03-01 00:28:52.000000', 'temperatura', 790.0000, 'ºC'),
	(235635, 122, '2014-03-01 00:28:53.000000', 'temperatura', 698.0000, 'ºC'),
	(235636, 122, '2014-03-01 00:28:54.000000', 'temperatura', 1118.0000, 'ºC'),
	(235637, 122, '2014-03-01 00:28:55.000000', 'temperatura', 1100.0000, 'ºC'),
	(235638, 122, '2014-03-01 00:28:56.000000', 'temperatura', 944.0000, 'ºC'),
	(235639, 122, '2014-03-01 00:28:57.000000', 'temperatura', 221.0000, 'ºC'),
	(235640, 122, '2014-03-01 00:28:58.000000', 'temperatura', 675.0000, 'ºC'),
	(235641, 122, '2014-03-01 00:28:59.000000', 'temperatura', 310.0000, 'ºC'),
	(235642, 122, '2014-03-01 00:29:00.000000', 'temperatura', 729.0000, 'ºC'),
	(235643, 122, '2014-03-01 00:29:01.000000', 'temperatura', 313.0000, 'ºC'),
	(235644, 122, '2014-03-01 00:29:02.000000', 'temperatura', 577.0000, 'ºC'),
	(235645, 122, '2014-03-01 00:29:03.000000', 'temperatura', 748.0000, 'ºC'),
	(235646, 122, '2014-03-01 00:29:04.000000', 'temperatura', 809.0000, 'ºC'),
	(235647, 122, '2014-03-01 00:29:05.000000', 'temperatura', 602.0000, 'ºC'),
	(235648, 122, '2014-03-01 00:29:06.000000', 'temperatura', 585.0000, 'ºC'),
	(235649, 122, '2014-03-01 00:29:07.000000', 'temperatura', 1119.0000, 'ºC'),
	(235650, 122, '2014-03-01 00:29:08.000000', 'temperatura', 239.0000, 'ºC'),
	(235651, 122, '2014-03-01 00:29:09.000000', 'temperatura', 241.0000, 'ºC'),
	(235652, 122, '2014-03-01 00:29:10.000000', 'temperatura', 487.0000, 'ºC'),
	(235653, 122, '2014-03-01 00:29:11.000000', 'temperatura', 511.0000, 'ºC'),
	(235654, 122, '2014-03-01 00:29:12.000000', 'temperatura', 1097.0000, 'ºC'),
	(235655, 122, '2014-03-01 00:29:13.000000', 'temperatura', 351.0000, 'ºC'),
	(235656, 122, '2014-03-01 00:29:14.000000', 'temperatura', 865.0000, 'ºC'),
	(235657, 122, '2014-03-01 00:29:15.000000', 'temperatura', 871.0000, 'ºC'),
	(235658, 122, '2014-03-01 00:29:16.000000', 'temperatura', 562.0000, 'ºC'),
	(235659, 122, '2014-03-01 00:29:17.000000', 'temperatura', 197.0000, 'ºC'),
	(235660, 122, '2014-03-01 00:29:18.000000', 'temperatura', 500.0000, 'ºC'),
	(235661, 122, '2014-03-01 00:29:19.000000', 'temperatura', 709.0000, 'ºC'),
	(235662, 122, '2014-03-01 00:29:20.000000', 'temperatura', 845.0000, 'ºC'),
	(235663, 122, '2014-03-01 00:29:21.000000', 'temperatura', 901.0000, 'ºC'),
	(235664, 122, '2014-03-01 00:29:22.000000', 'temperatura', 768.0000, 'ºC'),
	(235665, 122, '2014-03-01 00:29:23.000000', 'temperatura', 1137.0000, 'ºC'),
	(235666, 122, '2014-03-01 00:29:24.000000', 'temperatura', 983.0000, 'ºC'),
	(235667, 122, '2014-03-01 00:29:25.000000', 'temperatura', 305.0000, 'ºC'),
	(235668, 122, '2014-03-01 00:29:26.000000', 'temperatura', 977.0000, 'ºC'),
	(235669, 122, '2014-03-01 00:29:27.000000', 'temperatura', 371.0000, 'ºC'),
	(235670, 122, '2014-03-01 00:29:28.000000', 'temperatura', 123.0000, 'ºC'),
	(235671, 122, '2014-03-01 00:29:29.000000', 'temperatura', 705.0000, 'ºC'),
	(235672, 122, '2014-03-01 00:29:30.000000', 'temperatura', 754.0000, 'ºC'),
	(235673, 122, '2014-03-01 00:29:31.000000', 'temperatura', 456.0000, 'ºC'),
	(235674, 122, '2014-03-01 00:29:32.000000', 'temperatura', 17.0000, 'ºC'),
	(235675, 122, '2014-03-01 00:29:33.000000', 'temperatura', 1120.0000, 'ºC'),
	(235676, 122, '2014-03-01 00:29:34.000000', 'temperatura', 749.0000, 'ºC'),
	(235677, 122, '2014-03-01 00:29:35.000000', 'temperatura', 384.0000, 'ºC'),
	(235678, 122, '2014-03-01 00:29:36.000000', 'temperatura', 872.0000, 'ºC'),
	(235679, 122, '2014-03-01 00:29:37.000000', 'temperatura', 811.0000, 'ºC'),
	(235680, 122, '2014-03-01 00:29:38.000000', 'temperatura', 239.0000, 'ºC'),
	(235681, 122, '2014-03-01 00:29:39.000000', 'temperatura', 1164.0000, 'ºC'),
	(235682, 122, '2014-03-01 00:29:40.000000', 'temperatura', 304.0000, 'ºC'),
	(235683, 122, '2014-03-01 00:29:41.000000', 'temperatura', 426.0000, 'ºC'),
	(235684, 122, '2014-03-01 00:29:42.000000', 'temperatura', 20.0000, 'ºC'),
	(235685, 122, '2014-03-01 00:29:43.000000', 'temperatura', 20.0000, 'ºC'),
	(235686, 122, '2014-03-01 00:29:44.000000', 'temperatura', 44.0000, 'ºC'),
	(235687, 122, '2014-03-01 00:29:45.000000', 'temperatura', 159.0000, 'ºC'),
	(235688, 122, '2014-03-01 00:29:46.000000', 'temperatura', 665.0000, 'ºC'),
	(235689, 122, '2014-03-01 00:29:47.000000', 'temperatura', 446.0000, 'ºC'),
	(235690, 122, '2014-03-01 00:29:48.000000', 'temperatura', 235.0000, 'ºC'),
	(235691, 122, '2014-03-01 00:29:49.000000', 'temperatura', 1038.0000, 'ºC'),
	(235692, 122, '2014-03-01 00:29:50.000000', 'temperatura', 886.0000, 'ºC'),
	(235693, 122, '2014-03-01 00:29:51.000000', 'temperatura', 116.0000, 'ºC'),
	(235694, 122, '2014-03-01 00:29:52.000000', 'temperatura', 324.0000, 'ºC'),
	(235695, 122, '2014-03-01 00:29:53.000000', 'temperatura', 74.0000, 'ºC'),
	(235696, 122, '2014-03-01 00:29:54.000000', 'temperatura', 596.0000, 'ºC'),
	(235697, 122, '2014-03-01 00:29:55.000000', 'temperatura', 357.0000, 'ºC'),
	(235698, 122, '2014-03-01 00:29:56.000000', 'temperatura', 1199.0000, 'ºC'),
	(235699, 122, '2014-03-01 00:29:57.000000', 'temperatura', 125.0000, 'ºC'),
	(235700, 122, '2014-03-01 00:29:58.000000', 'temperatura', 627.0000, 'ºC'),
	(235701, 122, '2014-03-01 00:29:59.000000', 'temperatura', 362.0000, 'ºC'),
	(235702, 122, '2014-03-01 00:30:00.000000', 'temperatura', 1131.0000, 'ºC'),
	(235703, 122, '2014-03-01 00:30:01.000000', 'temperatura', 967.0000, 'ºC'),
	(235704, 122, '2014-03-01 00:30:02.000000', 'temperatura', 243.0000, 'ºC'),
	(235705, 122, '2014-03-01 00:30:03.000000', 'temperatura', 716.0000, 'ºC'),
	(235706, 122, '2014-03-01 00:30:04.000000', 'temperatura', 449.0000, 'ºC'),
	(235707, 122, '2014-03-01 00:30:05.000000', 'temperatura', 97.0000, 'ºC'),
	(235708, 122, '2014-03-01 00:30:06.000000', 'temperatura', 340.0000, 'ºC'),
	(235709, 122, '2014-03-01 00:30:07.000000', 'temperatura', 208.0000, 'ºC'),
	(235710, 122, '2014-03-01 00:30:08.000000', 'temperatura', 21.0000, 'ºC'),
	(235711, 122, '2014-03-01 00:30:09.000000', 'temperatura', 684.0000, 'ºC'),
	(235712, 122, '2014-03-01 00:30:10.000000', 'temperatura', 955.0000, 'ºC'),
	(235713, 122, '2014-03-01 00:30:11.000000', 'temperatura', 324.0000, 'ºC'),
	(235714, 122, '2014-03-01 00:30:12.000000', 'temperatura', 1157.0000, 'ºC'),
	(235715, 122, '2014-03-01 00:30:13.000000', 'temperatura', 12.0000, 'ºC'),
	(235716, 122, '2014-03-01 00:30:14.000000', 'temperatura', 189.0000, 'ºC'),
	(235717, 122, '2014-03-01 00:30:15.000000', 'temperatura', 911.0000, 'ºC'),
	(235718, 122, '2014-03-01 00:30:16.000000', 'temperatura', 386.0000, 'ºC'),
	(235719, 122, '2014-03-01 00:30:17.000000', 'temperatura', 399.0000, 'ºC'),
	(235720, 122, '2014-03-01 00:30:18.000000', 'temperatura', 839.0000, 'ºC'),
	(235721, 122, '2014-03-01 00:30:19.000000', 'temperatura', 599.0000, 'ºC'),
	(235722, 122, '2014-03-01 00:30:20.000000', 'temperatura', 479.0000, 'ºC'),
	(235723, 122, '2014-03-01 00:30:21.000000', 'temperatura', 598.0000, 'ºC'),
	(235724, 122, '2014-03-01 00:30:22.000000', 'temperatura', 354.0000, 'ºC'),
	(235725, 122, '2014-03-01 00:30:23.000000', 'temperatura', 1177.0000, 'ºC'),
	(235726, 122, '2014-03-01 00:30:24.000000', 'temperatura', 21.0000, 'ºC'),
	(235727, 122, '2014-03-01 00:30:25.000000', 'temperatura', 176.0000, 'ºC'),
	(235728, 122, '2014-03-01 00:30:26.000000', 'temperatura', 818.0000, 'ºC'),
	(235729, 122, '2014-03-01 00:30:27.000000', 'temperatura', 1160.0000, 'ºC'),
	(235730, 122, '2014-03-01 00:30:28.000000', 'temperatura', 950.0000, 'ºC'),
	(235731, 122, '2014-03-01 00:30:29.000000', 'temperatura', 67.0000, 'ºC'),
	(235732, 122, '2014-03-01 00:30:30.000000', 'temperatura', 1087.0000, 'ºC'),
	(235733, 122, '2014-03-01 00:30:31.000000', 'temperatura', 433.0000, 'ºC'),
	(235734, 122, '2014-03-01 00:30:32.000000', 'temperatura', 104.0000, 'ºC'),
	(235735, 122, '2014-03-01 00:30:33.000000', 'temperatura', 421.0000, 'ºC'),
	(235736, 122, '2014-03-01 00:30:34.000000', 'temperatura', 597.0000, 'ºC'),
	(235737, 122, '2014-03-01 00:30:35.000000', 'temperatura', 520.0000, 'ºC'),
	(235738, 122, '2014-03-01 00:30:36.000000', 'temperatura', 808.0000, 'ºC'),
	(235739, 122, '2014-03-01 00:30:37.000000', 'temperatura', 82.0000, 'ºC'),
	(235740, 122, '2014-03-01 00:30:38.000000', 'temperatura', 385.0000, 'ºC'),
	(235741, 122, '2014-03-01 00:30:39.000000', 'temperatura', 482.0000, 'ºC'),
	(235742, 122, '2014-03-01 00:30:40.000000', 'temperatura', 56.0000, 'ºC'),
	(235743, 122, '2014-03-01 00:30:41.000000', 'temperatura', 35.0000, 'ºC'),
	(235744, 122, '2014-03-01 00:30:42.000000', 'temperatura', 6.0000, 'ºC'),
	(235745, 122, '2014-03-01 00:30:43.000000', 'temperatura', 1124.0000, 'ºC'),
	(235746, 122, '2014-03-01 00:30:44.000000', 'temperatura', 805.0000, 'ºC'),
	(235747, 122, '2014-03-01 00:30:45.000000', 'temperatura', 654.0000, 'ºC'),
	(235748, 122, '2014-03-01 00:30:46.000000', 'temperatura', 856.0000, 'ºC'),
	(235749, 122, '2014-03-01 00:30:47.000000', 'temperatura', 1116.0000, 'ºC'),
	(235750, 122, '2014-03-01 00:30:48.000000', 'temperatura', 613.0000, 'ºC'),
	(235751, 122, '2014-03-01 00:30:49.000000', 'temperatura', 917.0000, 'ºC'),
	(235752, 122, '2014-03-01 00:30:50.000000', 'temperatura', 347.0000, 'ºC'),
	(235753, 122, '2014-03-01 00:30:51.000000', 'temperatura', 184.0000, 'ºC'),
	(235754, 122, '2014-03-01 00:30:52.000000', 'temperatura', 1081.0000, 'ºC'),
	(235755, 122, '2014-03-01 00:30:53.000000', 'temperatura', 51.0000, 'ºC'),
	(235756, 122, '2014-03-01 00:30:54.000000', 'temperatura', 613.0000, 'ºC'),
	(235757, 122, '2014-03-01 00:30:55.000000', 'temperatura', 513.0000, 'ºC'),
	(235758, 122, '2014-03-01 00:30:56.000000', 'temperatura', 725.0000, 'ºC'),
	(235759, 122, '2014-03-01 00:30:57.000000', 'temperatura', 886.0000, 'ºC'),
	(235760, 122, '2014-03-01 00:30:58.000000', 'temperatura', 1054.0000, 'ºC'),
	(235761, 122, '2014-03-01 00:30:59.000000', 'temperatura', 216.0000, 'ºC'),
	(235762, 122, '2014-03-01 00:31:00.000000', 'temperatura', 319.0000, 'ºC'),
	(235763, 122, '2014-03-01 00:31:01.000000', 'temperatura', 947.0000, 'ºC'),
	(235764, 122, '2014-03-01 00:31:02.000000', 'temperatura', 177.0000, 'ºC'),
	(235765, 122, '2014-03-01 00:31:03.000000', 'temperatura', 444.0000, 'ºC'),
	(235766, 122, '2014-03-01 00:31:04.000000', 'temperatura', 491.0000, 'ºC'),
	(235767, 122, '2014-03-01 00:31:05.000000', 'temperatura', 1123.0000, 'ºC'),
	(235768, 122, '2014-03-01 00:31:06.000000', 'temperatura', 544.0000, 'ºC'),
	(235769, 122, '2014-03-01 00:31:07.000000', 'temperatura', 552.0000, 'ºC'),
	(235770, 122, '2014-03-01 00:31:08.000000', 'temperatura', 1126.0000, 'ºC'),
	(235771, 122, '2014-03-01 00:31:09.000000', 'temperatura', 375.0000, 'ºC'),
	(235772, 122, '2014-03-01 00:31:10.000000', 'temperatura', 899.0000, 'ºC'),
	(235773, 122, '2014-03-01 00:31:11.000000', 'temperatura', 970.0000, 'ºC'),
	(235774, 122, '2014-03-01 00:31:12.000000', 'temperatura', 952.0000, 'ºC'),
	(235775, 122, '2014-03-01 00:31:13.000000', 'temperatura', 652.0000, 'ºC'),
	(235776, 122, '2014-03-01 00:31:14.000000', 'temperatura', 404.0000, 'ºC'),
	(235777, 122, '2014-03-01 00:31:15.000000', 'temperatura', 64.0000, 'ºC'),
	(235778, 122, '2014-03-01 00:31:16.000000', 'temperatura', 307.0000, 'ºC'),
	(235779, 122, '2014-03-01 00:31:17.000000', 'temperatura', 145.0000, 'ºC'),
	(235780, 122, '2014-03-01 00:31:18.000000', 'temperatura', 1004.0000, 'ºC'),
	(235781, 122, '2014-03-01 00:31:19.000000', 'temperatura', 988.0000, 'ºC'),
	(235782, 122, '2014-03-01 00:31:20.000000', 'temperatura', 726.0000, 'ºC'),
	(235783, 122, '2014-03-01 00:31:21.000000', 'temperatura', 666.0000, 'ºC'),
	(235784, 122, '2014-03-01 00:31:22.000000', 'temperatura', 1155.0000, 'ºC'),
	(235785, 122, '2014-03-01 00:31:23.000000', 'temperatura', 177.0000, 'ºC'),
	(235786, 122, '2014-03-01 00:31:24.000000', 'temperatura', 1021.0000, 'ºC'),
	(235787, 122, '2014-03-01 00:31:25.000000', 'temperatura', 974.0000, 'ºC'),
	(235788, 122, '2014-03-01 00:31:26.000000', 'temperatura', 609.0000, 'ºC'),
	(235789, 122, '2014-03-01 00:31:27.000000', 'temperatura', 122.0000, 'ºC'),
	(235790, 122, '2014-03-01 00:31:28.000000', 'temperatura', 1183.0000, 'ºC'),
	(235791, 122, '2014-03-01 00:31:29.000000', 'temperatura', 751.0000, 'ºC'),
	(235792, 122, '2014-03-01 00:31:30.000000', 'temperatura', 208.0000, 'ºC'),
	(235793, 122, '2014-03-01 00:31:31.000000', 'temperatura', 1186.0000, 'ºC'),
	(235794, 122, '2014-03-01 00:31:32.000000', 'temperatura', 504.0000, 'ºC'),
	(235795, 122, '2014-03-01 00:31:33.000000', 'temperatura', 166.0000, 'ºC'),
	(235796, 122, '2014-03-01 00:31:34.000000', 'temperatura', 518.0000, 'ºC'),
	(235797, 122, '2014-03-01 00:31:35.000000', 'temperatura', 892.0000, 'ºC'),
	(235798, 122, '2014-03-01 00:31:36.000000', 'temperatura', 505.0000, 'ºC'),
	(235799, 122, '2014-03-01 00:31:37.000000', 'temperatura', 1050.0000, 'ºC'),
	(235800, 122, '2014-03-01 00:31:38.000000', 'temperatura', 136.0000, 'ºC'),
	(235801, 122, '2014-03-01 00:31:39.000000', 'temperatura', 1130.0000, 'ºC'),
	(235802, 122, '2014-03-01 00:31:40.000000', 'temperatura', 445.0000, 'ºC'),
	(235803, 122, '2014-03-01 00:31:41.000000', 'temperatura', 33.0000, 'ºC'),
	(235804, 122, '2014-03-01 00:31:42.000000', 'temperatura', 31.0000, 'ºC'),
	(235805, 122, '2014-03-01 00:31:43.000000', 'temperatura', 58.0000, 'ºC'),
	(235806, 122, '2014-03-01 00:31:44.000000', 'temperatura', 196.0000, 'ºC'),
	(235807, 122, '2014-03-01 00:31:45.000000', 'temperatura', 808.0000, 'ºC'),
	(235808, 122, '2014-03-01 00:31:46.000000', 'temperatura', 1053.0000, 'ºC'),
	(235809, 122, '2014-03-01 00:31:47.000000', 'temperatura', 439.0000, 'ºC'),
	(235810, 122, '2014-03-01 00:31:48.000000', 'temperatura', 238.0000, 'ºC'),
	(235811, 122, '2014-03-01 00:31:49.000000', 'temperatura', 1073.0000, 'ºC'),
	(235812, 122, '2014-03-01 00:31:50.000000', 'temperatura', 1053.0000, 'ºC'),
	(235813, 122, '2014-03-01 00:31:51.000000', 'temperatura', 847.0000, 'ºC'),
	(235814, 122, '2014-03-01 00:31:52.000000', 'temperatura', 1075.0000, 'ºC'),
	(235815, 122, '2014-03-01 00:31:53.000000', 'temperatura', 434.0000, 'ºC'),
	(235816, 122, '2014-03-01 00:31:54.000000', 'temperatura', 148.0000, 'ºC'),
	(235817, 122, '2014-03-01 00:31:55.000000', 'temperatura', 637.0000, 'ºC'),
	(235818, 122, '2014-03-01 00:31:56.000000', 'temperatura', 341.0000, 'ºC'),
	(235819, 122, '2014-03-01 00:31:57.000000', 'temperatura', 993.0000, 'ºC'),
	(235820, 122, '2014-03-01 00:31:58.000000', 'temperatura', 345.0000, 'ºC'),
	(235821, 122, '2014-03-01 00:31:59.000000', 'temperatura', 1144.0000, 'ºC'),
	(235822, 122, '2014-03-01 00:32:00.000000', 'temperatura', 1085.0000, 'ºC'),
	(235823, 122, '2014-03-01 00:32:01.000000', 'temperatura', 796.0000, 'ºC'),
	(235824, 122, '2014-03-01 00:32:02.000000', 'temperatura', 726.0000, 'ºC'),
	(235825, 122, '2014-03-01 00:32:03.000000', 'temperatura', 42.0000, 'ºC'),
	(235826, 122, '2014-03-01 00:32:04.000000', 'temperatura', 433.0000, 'ºC'),
	(235827, 122, '2014-03-01 00:32:05.000000', 'temperatura', 840.0000, 'ºC'),
	(235828, 122, '2014-03-01 00:32:06.000000', 'temperatura', 502.0000, 'ºC'),
	(235829, 122, '2014-03-01 00:32:07.000000', 'temperatura', 1192.0000, 'ºC'),
	(235830, 122, '2014-03-01 00:32:08.000000', 'temperatura', 851.0000, 'ºC'),
	(235831, 122, '2014-03-01 00:32:09.000000', 'temperatura', 682.0000, 'ºC'),
	(235832, 122, '2014-03-01 00:32:10.000000', 'temperatura', 857.0000, 'ºC'),
	(235833, 122, '2014-03-01 00:32:11.000000', 'temperatura', 1040.0000, 'ºC'),
	(235834, 122, '2014-03-01 00:32:12.000000', 'temperatura', 230.0000, 'ºC'),
	(235835, 122, '2014-03-01 00:32:13.000000', 'temperatura', 428.0000, 'ºC'),
	(235836, 122, '2014-03-01 00:32:14.000000', 'temperatura', 251.0000, 'ºC'),
	(235837, 122, '2014-03-01 00:32:15.000000', 'temperatura', 1171.0000, 'ºC'),
	(235838, 122, '2014-03-01 00:32:16.000000', 'temperatura', 304.0000, 'ºC'),
	(235839, 122, '2014-03-01 00:32:17.000000', 'temperatura', 409.0000, 'ºC'),
	(235840, 122, '2014-03-01 00:32:18.000000', 'temperatura', 1131.0000, 'ºC'),
	(235841, 122, '2014-03-01 00:32:19.000000', 'temperatura', 829.0000, 'ºC'),
	(235842, 122, '2014-03-01 00:32:20.000000', 'temperatura', 753.0000, 'ºC'),
	(235843, 122, '2014-03-01 00:32:21.000000', 'temperatura', 79.0000, 'ºC'),
	(235844, 122, '2014-03-01 00:32:22.000000', 'temperatura', 538.0000, 'ºC'),
	(235845, 122, '2014-03-01 00:32:23.000000', 'temperatura', 51.0000, 'ºC'),
	(235846, 122, '2014-03-01 00:32:24.000000', 'temperatura', 1043.0000, 'ºC'),
	(235847, 122, '2014-03-01 00:32:25.000000', 'temperatura', 261.0000, 'ºC'),
	(235848, 122, '2014-03-01 00:32:26.000000', 'temperatura', 579.0000, 'ºC'),
	(235849, 122, '2014-03-01 00:32:27.000000', 'temperatura', 910.0000, 'ºC'),
	(235850, 122, '2014-03-01 00:32:28.000000', 'temperatura', 413.0000, 'ºC'),
	(235851, 122, '2014-03-01 00:32:29.000000', 'temperatura', 536.0000, 'ºC'),
	(235852, 122, '2014-03-01 00:32:30.000000', 'temperatura', 241.0000, 'ºC'),
	(235853, 122, '2014-03-01 00:32:31.000000', 'temperatura', 799.0000, 'ºC'),
	(235854, 122, '2014-03-01 00:32:32.000000', 'temperatura', 870.0000, 'ºC'),
	(235855, 122, '2014-03-01 00:32:33.000000', 'temperatura', 754.0000, 'ºC'),
	(235856, 122, '2014-03-01 00:32:34.000000', 'temperatura', 1162.0000, 'ºC'),
	(235857, 122, '2014-03-01 00:32:35.000000', 'temperatura', 1146.0000, 'ºC'),
	(235858, 122, '2014-03-01 00:32:36.000000', 'temperatura', 1047.0000, 'ºC'),
	(235859, 122, '2014-03-01 00:32:37.000000', 'temperatura', 596.0000, 'ºC'),
	(235860, 122, '2014-03-01 00:32:38.000000', 'temperatura', 1042.0000, 'ºC'),
	(235861, 122, '2014-03-01 00:32:39.000000', 'temperatura', 1021.0000, 'ºC'),
	(235862, 122, '2014-03-01 00:32:40.000000', 'temperatura', 780.0000, 'ºC'),
	(235863, 122, '2014-03-01 00:32:41.000000', 'temperatura', 838.0000, 'ºC'),
	(235864, 122, '2014-03-01 00:32:42.000000', 'temperatura', 651.0000, 'ºC'),
	(235865, 122, '2014-03-01 00:32:43.000000', 'temperatura', 739.0000, 'ºC'),
	(235866, 122, '2014-03-01 00:32:44.000000', 'temperatura', 542.0000, 'ºC'),
	(235867, 122, '2014-03-01 00:32:45.000000', 'temperatura', 495.0000, 'ºC'),
	(235868, 122, '2014-03-01 00:32:46.000000', 'temperatura', 850.0000, 'ºC'),
	(235869, 122, '2014-03-01 00:32:47.000000', 'temperatura', 364.0000, 'ºC'),
	(235870, 122, '2014-03-01 00:32:48.000000', 'temperatura', 470.0000, 'ºC'),
	(235871, 122, '2014-03-01 00:32:49.000000', 'temperatura', 60.0000, 'ºC'),
	(235872, 122, '2014-03-01 00:32:50.000000', 'temperatura', 92.0000, 'ºC'),
	(235873, 122, '2014-03-01 00:32:51.000000', 'temperatura', 279.0000, 'ºC'),
	(235874, 122, '2014-03-01 00:32:52.000000', 'temperatura', 1118.0000, 'ºC'),
	(235875, 122, '2014-03-01 00:32:53.000000', 'temperatura', 1156.0000, 'ºC'),
	(235876, 122, '2014-03-01 00:32:54.000000', 'temperatura', 25.0000, 'ºC'),
	(235877, 122, '2014-03-01 00:32:55.000000', 'temperatura', 260.0000, 'ºC'),
	(235878, 122, '2014-03-01 00:32:56.000000', 'temperatura', 23.0000, 'ºC'),
	(235879, 122, '2014-03-01 00:32:57.000000', 'temperatura', 536.0000, 'ºC'),
	(235880, 122, '2014-03-01 00:32:58.000000', 'temperatura', 210.0000, 'ºC'),
	(235881, 122, '2014-03-01 00:32:59.000000', 'temperatura', 643.0000, 'ºC'),
	(235882, 122, '2014-03-01 00:33:00.000000', 'temperatura', 185.0000, 'ºC'),
	(235883, 122, '2014-03-01 00:33:01.000000', 'temperatura', 199.0000, 'ºC'),
	(235884, 122, '2014-03-01 00:33:02.000000', 'temperatura', 439.0000, 'ºC'),
	(235885, 122, '2014-03-01 00:33:03.000000', 'temperatura', 397.0000, 'ºC'),
	(235886, 122, '2014-03-01 00:33:04.000000', 'temperatura', 668.0000, 'ºC'),
	(235887, 122, '2014-03-01 00:33:05.000000', 'temperatura', 952.0000, 'ºC'),
	(235888, 122, '2014-03-01 00:33:06.000000', 'temperatura', 356.0000, 'ºC'),
	(235889, 122, '2014-03-01 00:33:07.000000', 'temperatura', 124.0000, 'ºC'),
	(235890, 122, '2014-03-01 00:33:08.000000', 'temperatura', 755.0000, 'ºC'),
	(235891, 122, '2014-03-01 00:33:09.000000', 'temperatura', 1000.0000, 'ºC'),
	(235892, 122, '2014-03-01 00:33:10.000000', 'temperatura', 338.0000, 'ºC'),
	(235893, 122, '2014-03-01 00:33:11.000000', 'temperatura', 1089.0000, 'ºC'),
	(235894, 122, '2014-03-01 00:33:12.000000', 'temperatura', 831.0000, 'ºC'),
	(235895, 122, '2014-03-01 00:33:13.000000', 'temperatura', 888.0000, 'ºC'),
	(235896, 122, '2014-03-01 00:33:14.000000', 'temperatura', 748.0000, 'ºC'),
	(235897, 122, '2014-03-01 00:33:15.000000', 'temperatura', 1077.0000, 'ºC'),
	(235898, 122, '2014-03-01 00:33:16.000000', 'temperatura', 740.0000, 'ºC'),
	(235899, 122, '2014-03-01 00:33:17.000000', 'temperatura', 472.0000, 'ºC'),
	(235900, 122, '2014-03-01 00:33:18.000000', 'temperatura', 139.0000, 'ºC'),
	(235901, 122, '2014-03-01 00:33:19.000000', 'temperatura', 478.0000, 'ºC'),
	(235902, 122, '2014-03-01 00:33:20.000000', 'temperatura', 776.0000, 'ºC'),
	(235903, 122, '2014-03-01 00:33:21.000000', 'temperatura', 47.0000, 'ºC'),
	(235904, 122, '2014-03-01 00:33:22.000000', 'temperatura', 307.0000, 'ºC'),
	(235905, 122, '2014-03-01 00:33:23.000000', 'temperatura', 195.0000, 'ºC'),
	(235906, 122, '2014-03-01 00:33:24.000000', 'temperatura', 56.0000, 'ºC'),
	(235907, 122, '2014-03-01 00:33:25.000000', 'temperatura', 892.0000, 'ºC'),
	(235908, 122, '2014-03-01 00:33:26.000000', 'temperatura', 694.0000, 'ºC'),
	(235909, 122, '2014-03-01 00:33:27.000000', 'temperatura', 793.0000, 'ºC'),
	(235910, 122, '2014-03-01 00:33:28.000000', 'temperatura', 685.0000, 'ºC'),
	(235911, 122, '2014-03-01 00:33:29.000000', 'temperatura', 1046.0000, 'ºC'),
	(235912, 122, '2014-03-01 00:33:30.000000', 'temperatura', 776.0000, 'ºC'),
	(235913, 122, '2014-03-01 00:33:31.000000', 'temperatura', 741.0000, 'ºC'),
	(235914, 122, '2014-03-01 00:33:32.000000', 'temperatura', 177.0000, 'ºC'),
	(235915, 122, '2014-03-01 00:33:33.000000', 'temperatura', 1063.0000, 'ºC'),
	(235916, 122, '2014-03-01 00:33:34.000000', 'temperatura', 1184.0000, 'ºC'),
	(235917, 122, '2014-03-01 00:33:35.000000', 'temperatura', 331.0000, 'ºC'),
	(235918, 122, '2014-03-01 00:33:36.000000', 'temperatura', 503.0000, 'ºC'),
	(235919, 122, '2014-03-01 00:33:37.000000', 'temperatura', 324.0000, 'ºC'),
	(235920, 122, '2014-03-01 00:33:38.000000', 'temperatura', 111.0000, 'ºC'),
	(235921, 122, '2014-03-01 00:33:39.000000', 'temperatura', 784.0000, 'ºC'),
	(235922, 122, '2014-03-01 00:33:40.000000', 'temperatura', 1188.0000, 'ºC'),
	(235923, 122, '2014-03-01 00:33:41.000000', 'temperatura', 1188.0000, 'ºC'),
	(235924, 122, '2014-03-01 00:33:42.000000', 'temperatura', 1177.0000, 'ºC'),
	(235925, 122, '2014-03-01 00:33:43.000000', 'temperatura', 1123.0000, 'ºC'),
	(235926, 122, '2014-03-01 00:33:44.000000', 'temperatura', 883.0000, 'ºC'),
	(235927, 122, '2014-03-01 00:33:45.000000', 'temperatura', 1048.0000, 'ºC'),
	(235928, 122, '2014-03-01 00:33:46.000000', 'temperatura', 192.0000, 'ºC'),
	(235929, 122, '2014-03-01 00:33:47.000000', 'temperatura', 217.0000, 'ºC'),
	(235930, 122, '2014-03-01 00:33:48.000000', 'temperatura', 507.0000, 'ºC'),
	(235931, 122, '2014-03-01 00:33:49.000000', 'temperatura', 687.0000, 'ºC'),
	(235932, 122, '2014-03-01 00:33:50.000000', 'temperatura', 712.0000, 'ºC'),
	(235933, 122, '2014-03-01 00:33:51.000000', 'temperatura', 301.0000, 'ºC'),
	(235934, 122, '2014-03-01 00:33:52.000000', 'temperatura', 571.0000, 'ºC'),
	(235935, 122, '2014-03-01 00:33:53.000000', 'temperatura', 751.0000, 'ºC'),
	(235936, 122, '2014-03-01 00:33:54.000000', 'temperatura', 843.0000, 'ºC'),
	(235937, 122, '2014-03-01 00:33:55.000000', 'temperatura', 761.0000, 'ºC'),
	(235938, 122, '2014-03-01 00:33:56.000000', 'temperatura', 76.0000, 'ºC'),
	(235939, 122, '2014-03-01 00:33:57.000000', 'temperatura', 496.0000, 'ºC'),
	(235940, 122, '2014-03-01 00:33:58.000000', 'temperatura', 1056.0000, 'ºC'),
	(235941, 122, '2014-03-01 00:33:59.000000', 'temperatura', 190.0000, 'ºC'),
	(235942, 122, '2014-03-01 00:34:00.000000', 'temperatura', 184.0000, 'ºC'),
	(235943, 122, '2014-03-01 00:34:01.000000', 'temperatura', 352.0000, 'ºC'),
	(235944, 122, '2014-03-01 00:34:02.000000', 'temperatura', 6.0000, 'ºC'),
	(235945, 122, '2014-03-01 00:34:03.000000', 'temperatura', 174.0000, 'ºC'),
	(235946, 122, '2014-03-01 00:34:04.000000', 'temperatura', 853.0000, 'ºC'),
	(235947, 122, '2014-03-01 00:34:05.000000', 'temperatura', 145.0000, 'ºC'),
	(235948, 122, '2014-03-01 00:34:06.000000', 'temperatura', 566.0000, 'ºC'),
	(235949, 122, '2014-03-01 00:34:07.000000', 'temperatura', 1197.0000, 'ºC'),
	(235950, 122, '2014-03-01 00:34:08.000000', 'temperatura', 685.0000, 'ºC'),
	(235951, 122, '2014-03-01 00:34:09.000000', 'temperatura', 1036.0000, 'ºC'),
	(235952, 122, '2014-03-01 00:34:10.000000', 'temperatura', 724.0000, 'ºC'),
	(235953, 122, '2014-03-01 00:34:11.000000', 'temperatura', 513.0000, 'ºC'),
	(235954, 122, '2014-03-01 00:34:12.000000', 'temperatura', 392.0000, 'ºC'),
	(235955, 122, '2014-03-01 00:34:13.000000', 'temperatura', 424.0000, 'ºC'),
	(235956, 122, '2014-03-01 00:34:14.000000', 'temperatura', 945.0000, 'ºC'),
	(235957, 122, '2014-03-01 00:34:15.000000', 'temperatura', 1053.0000, 'ºC'),
	(235958, 122, '2014-03-01 00:34:16.000000', 'temperatura', 28.0000, 'ºC'),
	(235959, 122, '2014-03-01 00:34:17.000000', 'temperatura', 585.0000, 'ºC'),
	(235960, 122, '2014-03-01 00:34:18.000000', 'temperatura', 440.0000, 'ºC'),
	(235961, 122, '2014-03-01 00:34:19.000000', 'temperatura', 446.0000, 'ºC'),
	(235962, 122, '2014-03-01 00:34:20.000000', 'temperatura', 910.0000, 'ºC'),
	(235963, 122, '2014-03-01 00:34:21.000000', 'temperatura', 814.0000, 'ºC'),
	(235964, 122, '2014-03-01 00:34:22.000000', 'temperatura', 138.0000, 'ºC'),
	(235965, 122, '2014-03-01 00:34:23.000000', 'temperatura', 649.0000, 'ºC'),
	(235966, 122, '2014-03-01 00:34:24.000000', 'temperatura', 433.0000, 'ºC'),
	(235967, 122, '2014-03-01 00:34:25.000000', 'temperatura', 218.0000, 'ºC'),
	(235968, 122, '2014-03-01 00:34:26.000000', 'temperatura', 990.0000, 'ºC'),
	(235969, 122, '2014-03-01 00:34:27.000000', 'temperatura', 699.0000, 'ºC'),
	(235970, 122, '2014-03-01 00:34:28.000000', 'temperatura', 526.0000, 'ºC'),
	(235971, 122, '2014-03-01 00:34:29.000000', 'temperatura', 535.0000, 'ºC'),
	(235972, 122, '2014-03-01 00:34:30.000000', 'temperatura', 1094.0000, 'ºC'),
	(235973, 122, '2014-03-01 00:34:31.000000', 'temperatura', 265.0000, 'ºC'),
	(235974, 122, '2014-03-01 00:34:32.000000', 'temperatura', 444.0000, 'ºC'),
	(235975, 122, '2014-03-01 00:34:33.000000', 'temperatura', 228.0000, 'ºC'),
	(235976, 122, '2014-03-01 00:34:34.000000', 'temperatura', 1005.0000, 'ºC'),
	(235977, 122, '2014-03-01 00:34:35.000000', 'temperatura', 744.0000, 'ºC'),
	(235978, 122, '2014-03-01 00:34:36.000000', 'temperatura', 705.0000, 'ºC'),
	(235979, 122, '2014-03-01 00:34:37.000000', 'temperatura', 92.0000, 'ºC'),
	(235980, 122, '2014-03-01 00:34:38.000000', 'temperatura', 746.0000, 'ºC'),
	(235981, 122, '2014-03-01 00:34:39.000000', 'temperatura', 1053.0000, 'ºC'),
	(235982, 122, '2014-03-01 00:34:40.000000', 'temperatura', 628.0000, 'ºC'),
	(235983, 122, '2014-03-01 00:34:41.000000', 'temperatura', 1183.0000, 'ºC'),
	(235984, 122, '2014-03-01 00:34:42.000000', 'temperatura', 431.0000, 'ºC'),
	(235985, 122, '2014-03-01 00:34:43.000000', 'temperatura', 1007.0000, 'ºC'),
	(235986, 122, '2014-03-01 00:34:44.000000', 'temperatura', 140.0000, 'ºC'),
	(235987, 122, '2014-03-01 00:34:45.000000', 'temperatura', 82.0000, 'ºC'),
	(235988, 122, '2014-03-01 00:34:46.000000', 'temperatura', 1189.0000, 'ºC'),
	(235989, 122, '2014-03-01 00:34:47.000000', 'temperatura', 898.0000, 'ºC'),
	(235990, 122, '2014-03-01 00:34:48.000000', 'temperatura', 927.0000, 'ºC'),
	(235991, 122, '2014-03-01 00:34:49.000000', 'temperatura', 740.0000, 'ºC'),
	(235992, 122, '2014-03-01 00:34:50.000000', 'temperatura', 919.0000, 'ºC'),
	(235993, 122, '2014-03-01 00:34:51.000000', 'temperatura', 1175.0000, 'ºC'),
	(235994, 122, '2014-03-01 00:34:52.000000', 'temperatura', 719.0000, 'ºC'),
	(235995, 122, '2014-03-01 00:34:53.000000', 'temperatura', 70.0000, 'ºC'),
	(235996, 122, '2014-03-01 00:34:54.000000', 'temperatura', 594.0000, 'ºC'),
	(235997, 122, '2014-03-01 00:34:55.000000', 'temperatura', 358.0000, 'ºC'),
	(235998, 122, '2014-03-01 00:34:56.000000', 'temperatura', 12.0000, 'ºC'),
	(235999, 122, '2014-03-01 00:34:57.000000', 'temperatura', 184.0000, 'ºC'),
	(236000, 122, '2014-03-01 00:34:58.000000', 'temperatura', 885.0000, 'ºC'),
	(236001, 122, '2014-03-01 00:34:59.000000', 'temperatura', 274.0000, 'ºC'),
	(236002, 122, '2014-03-01 00:35:00.000000', 'temperatura', 1114.0000, 'ºC'),
	(236003, 122, '2014-03-01 00:35:01.000000', 'temperatura', 1149.0000, 'ºC'),
	(236004, 122, '2014-03-01 00:35:02.000000', 'temperatura', 6.0000, 'ºC'),
	(236005, 122, '2014-03-01 00:35:03.000000', 'temperatura', 182.0000, 'ºC'),
	(236006, 122, '2014-03-01 00:35:04.000000', 'temperatura', 891.0000, 'ºC'),
	(236007, 122, '2014-03-01 00:35:05.000000', 'temperatura', 311.0000, 'ºC'),
	(236008, 122, '2014-03-01 00:35:06.000000', 'temperatura', 81.0000, 'ºC'),
	(236009, 122, '2014-03-01 00:35:07.000000', 'temperatura', 672.0000, 'ºC'),
	(236010, 122, '2014-03-01 00:35:08.000000', 'temperatura', 720.0000, 'ºC'),
	(236011, 122, '2014-03-01 00:35:09.000000', 'temperatura', 383.0000, 'ºC'),
	(236012, 122, '2014-03-01 00:35:10.000000', 'temperatura', 958.0000, 'ºC'),
	(236013, 122, '2014-03-01 00:35:11.000000', 'temperatura', 38.0000, 'ºC'),
	(236014, 122, '2014-03-01 00:35:12.000000', 'temperatura', 918.0000, 'ºC'),
	(236015, 122, '2014-03-01 00:35:13.000000', 'temperatura', 878.0000, 'ºC'),
	(236016, 122, '2014-03-01 00:35:14.000000', 'temperatura', 436.0000, 'ºC'),
	(236017, 122, '2014-03-01 00:35:15.000000', 'temperatura', 745.0000, 'ºC'),
	(236018, 122, '2014-03-01 00:35:16.000000', 'temperatura', 17.0000, 'ºC'),
	(236019, 122, '2014-03-01 00:35:17.000000', 'temperatura', 253.0000, 'ºC'),
	(236020, 122, '2014-03-01 00:35:18.000000', 'temperatura', 13.0000, 'ºC'),
	(236021, 122, '2014-03-01 00:35:19.000000', 'temperatura', 507.0000, 'ºC'),
	(236022, 122, '2014-03-01 00:35:20.000000', 'temperatura', 98.0000, 'ºC'),
	(236023, 122, '2014-03-01 00:35:21.000000', 'temperatura', 168.0000, 'ºC'),
	(236024, 122, '2014-03-01 00:35:22.000000', 'temperatura', 549.0000, 'ºC'),
	(236025, 122, '2014-03-01 00:35:23.000000', 'temperatura', 1039.0000, 'ºC'),
	(236026, 122, '2014-03-01 00:35:24.000000', 'temperatura', 1148.0000, 'ºC'),
	(236027, 122, '2014-03-01 00:35:25.000000', 'temperatura', 224.0000, 'ºC'),
	(236028, 122, '2014-03-01 00:35:26.000000', 'temperatura', 78.0000, 'ºC'),
	(236029, 122, '2014-03-01 00:35:27.000000', 'temperatura', 918.0000, 'ºC'),
	(236030, 122, '2014-03-01 00:35:28.000000', 'temperatura', 756.0000, 'ºC'),
	(236031, 122, '2014-03-01 00:35:29.000000', 'temperatura', 1027.0000, 'ºC'),
	(236032, 122, '2014-03-01 00:35:30.000000', 'temperatura', 468.0000, 'ºC'),
	(236033, 122, '2014-03-01 00:35:31.000000', 'temperatura', 457.0000, 'ºC'),
	(236034, 122, '2014-03-01 00:35:32.000000', 'temperatura', 884.0000, 'ºC'),
	(236035, 122, '2014-03-01 00:35:33.000000', 'temperatura', 648.0000, 'ºC'),
	(236036, 122, '2014-03-01 00:35:34.000000', 'temperatura', 591.0000, 'ºC'),
	(236037, 122, '2014-03-01 00:35:35.000000', 'temperatura', 1010.0000, 'ºC'),
	(236038, 122, '2014-03-01 00:35:36.000000', 'temperatura', 877.0000, 'ºC'),
	(236039, 122, '2014-03-01 00:35:37.000000', 'temperatura', 156.0000, 'ºC'),
	(236040, 122, '2014-03-01 00:35:38.000000', 'temperatura', 550.0000, 'ºC'),
	(236041, 122, '2014-03-01 00:35:39.000000', 'temperatura', 1081.0000, 'ºC'),
	(236042, 122, '2014-03-01 00:35:40.000000', 'temperatura', 158.0000, 'ºC'),
	(236043, 122, '2014-03-01 00:35:41.000000', 'temperatura', 1145.0000, 'ºC'),
	(236044, 122, '2014-03-01 00:35:42.000000', 'temperatura', 451.0000, 'ºC'),
	(236045, 122, '2014-03-01 00:35:43.000000', 'temperatura', 20.0000, 'ºC'),
	(236046, 122, '2014-03-01 00:35:44.000000', 'temperatura', 1148.0000, 'ºC'),
	(236047, 122, '2014-03-01 00:35:45.000000', 'temperatura', 881.0000, 'ºC'),
	(236048, 122, '2014-03-01 00:35:46.000000', 'temperatura', 963.0000, 'ºC'),
	(236049, 122, '2014-03-01 00:35:47.000000', 'temperatura', 972.0000, 'ºC'),
	(236050, 122, '2014-03-01 00:35:48.000000', 'temperatura', 772.0000, 'ºC'),
	(236051, 122, '2014-03-01 00:35:49.000000', 'temperatura', 942.0000, 'ºC'),
	(236052, 122, '2014-03-01 00:35:50.000000', 'temperatura', 1196.0000, 'ºC'),
	(236053, 122, '2014-03-01 00:35:51.000000', 'temperatura', 753.0000, 'ºC'),
	(236054, 122, '2014-03-01 00:35:52.000000', 'temperatura', 177.0000, 'ºC'),
	(236055, 122, '2014-03-01 00:35:53.000000', 'temperatura', 1027.0000, 'ºC'),
	(236056, 122, '2014-03-01 00:35:54.000000', 'temperatura', 1006.0000, 'ºC'),
	(236057, 122, '2014-03-01 00:35:55.000000', 'temperatura', 750.0000, 'ºC'),
	(236058, 122, '2014-03-01 00:35:56.000000', 'temperatura', 733.0000, 'ºC'),
	(236059, 122, '2014-03-01 00:35:57.000000', 'temperatura', 213.0000, 'ºC'),
	(236060, 122, '2014-03-01 00:35:58.000000', 'temperatura', 67.0000, 'ºC'),
	(236061, 122, '2014-03-01 00:35:59.000000', 'temperatura', 895.0000, 'ºC'),
	(236062, 122, '2014-03-01 00:36:00.000000', 'temperatura', 675.0000, 'ºC'),
	(236063, 122, '2014-03-01 00:36:01.000000', 'temperatura', 692.0000, 'ºC'),
	(236064, 122, '2014-03-01 00:36:02.000000', 'temperatura', 233.0000, 'ºC'),
	(236065, 122, '2014-03-01 00:36:03.000000', 'temperatura', 292.0000, 'ºC'),
	(236066, 122, '2014-03-01 00:36:04.000000', 'temperatura', 762.0000, 'ºC'),
	(236067, 122, '2014-03-01 00:36:05.000000', 'temperatura', 536.0000, 'ºC'),
	(236068, 122, '2014-03-01 00:36:06.000000', 'temperatura', 391.0000, 'ºC'),
	(236069, 122, '2014-03-01 00:36:07.000000', 'temperatura', 347.0000, 'ºC'),
	(236070, 122, '2014-03-01 00:36:08.000000', 'temperatura', 565.0000, 'ºC'),
	(236071, 122, '2014-03-01 00:36:09.000000', 'temperatura', 584.0000, 'ºC'),
	(236072, 122, '2014-03-01 00:36:10.000000', 'temperatura', 27.0000, 'ºC'),
	(236073, 122, '2014-03-01 00:36:11.000000', 'temperatura', 780.0000, 'ºC'),
	(236074, 122, '2014-03-01 00:36:12.000000', 'temperatura', 223.0000, 'ºC'),
	(236075, 122, '2014-03-01 00:36:13.000000', 'temperatura', 1172.0000, 'ºC'),
	(236076, 122, '2014-03-01 00:36:14.000000', 'temperatura', 395.0000, 'ºC'),
	(236077, 122, '2014-03-01 00:36:15.000000', 'temperatura', 857.0000, 'ºC'),
	(236078, 122, '2014-03-01 00:36:16.000000', 'temperatura', 703.0000, 'ºC'),
	(236079, 122, '2014-03-01 00:36:17.000000', 'temperatura', 943.0000, 'ºC'),
	(236080, 122, '2014-03-01 00:36:18.000000', 'temperatura', 206.0000, 'ºC'),
	(236081, 122, '2014-03-01 00:36:19.000000', 'temperatura', 601.0000, 'ºC'),
	(236082, 122, '2014-03-01 00:36:20.000000', 'temperatura', 1189.0000, 'ºC'),
	(236083, 122, '2014-03-01 00:36:21.000000', 'temperatura', 541.0000, 'ºC'),
	(236084, 122, '2014-03-01 00:36:22.000000', 'temperatura', 341.0000, 'ºC'),
	(236085, 122, '2014-03-01 00:36:23.000000', 'temperatura', 82.0000, 'ºC'),
	(236086, 122, '2014-03-01 00:36:24.000000', 'temperatura', 587.0000, 'ºC'),
	(236087, 122, '2014-03-01 00:36:25.000000', 'temperatura', 290.0000, 'ºC'),
	(236088, 122, '2014-03-01 00:36:26.000000', 'temperatura', 890.0000, 'ºC'),
	(236089, 122, '2014-03-01 00:36:27.000000', 'temperatura', 1181.0000, 'ºC'),
	(236090, 122, '2014-03-01 00:36:28.000000', 'temperatura', 837.0000, 'ºC'),
	(236091, 122, '2014-03-01 00:36:29.000000', 'temperatura', 639.0000, 'ºC'),
	(236092, 122, '2014-03-01 00:36:30.000000', 'temperatura', 686.0000, 'ºC'),
	(236093, 122, '2014-03-01 00:36:31.000000', 'temperatura', 311.0000, 'ºC'),
	(236094, 122, '2014-03-01 00:36:32.000000', 'temperatura', 701.0000, 'ºC'),
	(236095, 122, '2014-03-01 00:36:33.000000', 'temperatura', 170.0000, 'ºC'),
	(236096, 122, '2014-03-01 00:36:34.000000', 'temperatura', 1150.0000, 'ºC'),
	(236097, 122, '2014-03-01 00:36:35.000000', 'temperatura', 437.0000, 'ºC'),
	(236098, 122, '2014-03-01 00:36:36.000000', 'temperatura', 1138.0000, 'ºC'),
	(236099, 122, '2014-03-01 00:36:37.000000', 'temperatura', 780.0000, 'ºC'),
	(236100, 122, '2014-03-01 00:36:38.000000', 'temperatura', 487.0000, 'ºC'),
	(236101, 122, '2014-03-01 00:36:39.000000', 'temperatura', 95.0000, 'ºC'),
	(236102, 122, '2014-03-01 00:36:40.000000', 'temperatura', 213.0000, 'ºC'),
	(236103, 122, '2014-03-01 00:36:41.000000', 'temperatura', 782.0000, 'ºC'),
	(236104, 122, '2014-03-01 00:36:42.000000', 'temperatura', 871.0000, 'ºC'),
	(236105, 122, '2014-03-01 00:36:43.000000', 'temperatura', 809.0000, 'ºC'),
	(236106, 122, '2014-03-01 00:36:44.000000', 'temperatura', 235.0000, 'ºC'),
	(236107, 122, '2014-03-01 00:36:45.000000', 'temperatura', 1145.0000, 'ºC'),
	(236108, 122, '2014-03-01 00:36:46.000000', 'temperatura', 224.0000, 'ºC'),
	(236109, 122, '2014-03-01 00:36:47.000000', 'temperatura', 83.0000, 'ºC'),
	(236110, 122, '2014-03-01 00:36:48.000000', 'temperatura', 945.0000, 'ºC'),
	(236111, 122, '2014-03-01 00:36:49.000000', 'temperatura', 876.0000, 'ºC'),
	(236112, 122, '2014-03-01 00:36:50.000000', 'temperatura', 347.0000, 'ºC'),
	(236113, 122, '2014-03-01 00:36:51.000000', 'temperatura', 306.0000, 'ºC'),
	(236114, 122, '2014-03-01 00:36:52.000000', 'temperatura', 491.0000, 'ºC'),
	(236115, 122, '2014-03-01 00:36:53.000000', 'temperatura', 336.0000, 'ºC'),
	(236116, 122, '2014-03-01 00:36:54.000000', 'temperatura', 206.0000, 'ºC'),
	(236117, 122, '2014-03-01 00:36:55.000000', 'temperatura', 24.0000, 'ºC'),
	(236118, 122, '2014-03-01 00:36:56.000000', 'temperatura', 701.0000, 'ºC'),
	(236119, 122, '2014-03-01 00:36:57.000000', 'temperatura', 1033.0000, 'ºC'),
	(236120, 122, '2014-03-01 00:36:58.000000', 'temperatura', 661.0000, 'ºC'),
	(236121, 122, '2014-03-01 00:36:59.000000', 'temperatura', 210.0000, 'ºC'),
	(236122, 122, '2014-03-01 00:37:00.000000', 'temperatura', 268.0000, 'ºC'),
	(236123, 122, '2014-03-01 00:37:01.000000', 'temperatura', 709.0000, 'ºC'),
	(236124, 122, '2014-03-01 00:37:02.000000', 'temperatura', 344.0000, 'ºC'),
	(236125, 122, '2014-03-01 00:37:03.000000', 'temperatura', 790.0000, 'ºC'),
	(236126, 122, '2014-03-01 00:37:04.000000', 'temperatura', 521.0000, 'ºC'),
	(236127, 122, '2014-03-01 00:37:05.000000', 'temperatura', 234.0000, 'ºC'),
	(236128, 122, '2014-03-01 00:37:06.000000', 'temperatura', 808.0000, 'ºC'),
	(236129, 122, '2014-03-01 00:37:07.000000', 'temperatura', 938.0000, 'ºC'),
	(236130, 122, '2014-03-01 00:37:08.000000', 'temperatura', 1068.0000, 'ºC'),
	(236131, 122, '2014-03-01 00:37:09.000000', 'temperatura', 126.0000, 'ºC'),
	(236132, 122, '2014-03-01 00:37:10.000000', 'temperatura', 1027.0000, 'ºC'),
	(236133, 122, '2014-03-01 00:37:11.000000', 'temperatura', 1158.0000, 'ºC'),
	(236134, 122, '2014-03-01 00:37:12.000000', 'temperatura', 307.0000, 'ºC'),
	(236135, 122, '2014-03-01 00:37:13.000000', 'temperatura', 464.0000, 'ºC'),
	(236136, 122, '2014-03-01 00:37:14.000000', 'temperatura', 198.0000, 'ºC'),
	(236137, 122, '2014-03-01 00:37:15.000000', 'temperatura', 799.0000, 'ºC'),
	(236138, 122, '2014-03-01 00:37:16.000000', 'temperatura', 1001.0000, 'ºC'),
	(236139, 122, '2014-03-01 00:37:17.000000', 'temperatura', 208.0000, 'ºC'),
	(236140, 122, '2014-03-01 00:37:18.000000', 'temperatura', 440.0000, 'ºC'),
	(236141, 122, '2014-03-01 00:37:19.000000', 'temperatura', 375.0000, 'ºC'),
	(236142, 122, '2014-03-01 00:37:20.000000', 'temperatura', 555.0000, 'ºC'),
	(236143, 122, '2014-03-01 00:37:21.000000', 'temperatura', 450.0000, 'ºC'),
	(236144, 122, '2014-03-01 00:37:22.000000', 'temperatura', 586.0000, 'ºC'),
	(236145, 122, '2014-03-01 00:37:23.000000', 'temperatura', 379.0000, 'ºC'),
	(236146, 122, '2014-03-01 00:37:24.000000', 'temperatura', 137.0000, 'ºC'),
	(236147, 122, '2014-03-01 00:37:25.000000', 'temperatura', 748.0000, 'ºC'),
	(236148, 122, '2014-03-01 00:37:26.000000', 'temperatura', 930.0000, 'ºC'),
	(236149, 122, '2014-03-01 00:37:27.000000', 'temperatura', 7.0000, 'ºC'),
	(236150, 122, '2014-03-01 00:37:28.000000', 'temperatura', 846.0000, 'ºC'),
	(236151, 122, '2014-03-01 00:37:29.000000', 'temperatura', 608.0000, 'ºC'),
	(236152, 122, '2014-03-01 00:37:30.000000', 'temperatura', 501.0000, 'ºC'),
	(236153, 122, '2014-03-01 00:37:31.000000', 'temperatura', 685.0000, 'ºC'),
	(236154, 122, '2014-03-01 00:37:32.000000', 'temperatura', 722.0000, 'ºC'),
	(236155, 122, '2014-03-01 00:37:33.000000', 'temperatura', 354.0000, 'ºC'),
	(236156, 122, '2014-03-01 00:37:34.000000', 'temperatura', 805.0000, 'ºC'),
	(236157, 122, '2014-03-01 00:37:35.000000', 'temperatura', 565.0000, 'ºC'),
	(236158, 122, '2014-03-01 00:37:36.000000', 'temperatura', 410.0000, 'ºC'),
	(236159, 122, '2014-03-01 00:37:37.000000', 'temperatura', 355.0000, 'ºC'),
	(236160, 122, '2014-03-01 00:37:38.000000', 'temperatura', 547.0000, 'ºC'),
	(236161, 122, '2014-03-01 00:37:39.000000', 'temperatura', 469.0000, 'ºC'),
	(236162, 122, '2014-03-01 00:37:40.000000', 'temperatura', 706.0000, 'ºC'),
	(236163, 122, '2014-03-01 00:37:41.000000', 'temperatura', 922.0000, 'ºC'),
	(236164, 122, '2014-03-01 00:37:42.000000', 'temperatura', 93.0000, 'ºC'),
	(236165, 122, '2014-03-01 00:37:43.000000', 'temperatura', 101.0000, 'ºC'),
	(236166, 122, '2014-03-01 00:37:44.000000', 'temperatura', 224.0000, 'ºC'),
	(236167, 122, '2014-03-01 00:37:45.000000', 'temperatura', 819.0000, 'ºC'),
	(236168, 122, '2014-03-01 00:37:46.000000', 'temperatura', 1024.0000, 'ºC'),
	(236169, 122, '2014-03-01 00:37:47.000000', 'temperatura', 261.0000, 'ºC'),
	(236170, 122, '2014-03-01 00:37:48.000000', 'temperatura', 635.0000, 'ºC'),
	(236171, 122, '2014-03-01 00:37:49.000000', 'temperatura', 1193.0000, 'ºC'),
	(236172, 122, '2014-03-01 00:37:50.000000', 'temperatura', 459.0000, 'ºC'),
	(236173, 122, '2014-03-01 00:37:51.000000', 'temperatura', 1119.0000, 'ºC'),
	(236174, 122, '2014-03-01 00:37:52.000000', 'temperatura', 615.0000, 'ºC'),
	(236175, 122, '2014-03-01 00:37:53.000000', 'temperatura', 921.0000, 'ºC'),
	(236176, 122, '2014-03-01 00:37:54.000000', 'temperatura', 359.0000, 'ºC'),
	(236177, 122, '2014-03-01 00:37:55.000000', 'temperatura', 234.0000, 'ºC'),
	(236178, 122, '2014-03-01 00:37:56.000000', 'temperatura', 94.0000, 'ºC'),
	(236179, 122, '2014-03-01 00:37:57.000000', 'temperatura', 967.0000, 'ºC'),
	(236180, 122, '2014-03-01 00:37:58.000000', 'temperatura', 952.0000, 'ºC'),
	(236181, 122, '2014-03-01 00:37:59.000000', 'temperatura', 662.0000, 'ºC'),
	(236182, 122, '2014-03-01 00:38:00.000000', 'temperatura', 453.0000, 'ºC'),
	(236183, 122, '2014-03-01 00:38:01.000000', 'temperatura', 279.0000, 'ºC'),
	(236184, 122, '2014-03-01 00:38:02.000000', 'temperatura', 38.0000, 'ºC'),
	(236185, 122, '2014-03-01 00:38:03.000000', 'temperatura', 552.0000, 'ºC'),
	(236186, 122, '2014-03-01 00:38:04.000000', 'temperatura', 246.0000, 'ºC'),
	(236187, 122, '2014-03-01 00:38:05.000000', 'temperatura', 777.0000, 'ºC'),
	(236188, 122, '2014-03-01 00:38:06.000000', 'temperatura', 746.0000, 'ºC'),
	(236189, 122, '2014-03-01 00:38:07.000000', 'temperatura', 198.0000, 'ºC'),
	(236190, 122, '2014-03-01 00:38:08.000000', 'temperatura', 1153.0000, 'ºC'),
	(236191, 122, '2014-03-01 00:38:09.000000', 'temperatura', 371.0000, 'ºC'),
	(236192, 122, '2014-03-01 00:38:10.000000', 'temperatura', 799.0000, 'ºC'),
	(236193, 122, '2014-03-01 00:38:11.000000', 'temperatura', 480.0000, 'ºC'),
	(236194, 122, '2014-03-01 00:38:12.000000', 'temperatura', 5.0000, 'ºC'),
	(236195, 122, '2014-03-01 00:38:13.000000', 'temperatura', 984.0000, 'ºC'),
	(236196, 122, '2014-03-01 00:38:14.000000', 'temperatura', 106.0000, 'ºC'),
	(236197, 122, '2014-03-01 00:38:15.000000', 'temperatura', 1177.0000, 'ºC'),
	(236198, 122, '2014-03-01 00:38:16.000000', 'temperatura', 767.0000, 'ºC'),
	(236199, 122, '2014-03-01 00:38:17.000000', 'temperatura', 307.0000, 'ºC'),
	(236200, 122, '2014-03-01 00:38:18.000000', 'temperatura', 435.0000, 'ºC'),
	(236201, 122, '2014-03-01 00:38:19.000000', 'temperatura', 53.0000, 'ºC'),
	(236202, 122, '2014-03-01 00:38:20.000000', 'temperatura', 161.0000, 'ºC'),
	(236203, 122, '2014-03-01 00:38:21.000000', 'temperatura', 647.0000, 'ºC'),
	(236204, 122, '2014-03-01 00:38:22.000000', 'temperatura', 353.0000, 'ºC'),
	(236205, 122, '2014-03-01 00:38:23.000000', 'temperatura', 1025.0000, 'ºC'),
	(236206, 122, '2014-03-01 00:38:24.000000', 'temperatura', 466.0000, 'ºC'),
	(236207, 122, '2014-03-01 00:38:25.000000', 'temperatura', 455.0000, 'ºC'),
	(236208, 122, '2014-03-01 00:38:26.000000', 'temperatura', 878.0000, 'ºC'),
	(236209, 122, '2014-03-01 00:38:27.000000', 'temperatura', 626.0000, 'ºC'),
	(236210, 122, '2014-03-01 00:38:28.000000', 'temperatura', 496.0000, 'ºC'),
	(236211, 122, '2014-03-01 00:38:29.000000', 'temperatura', 601.0000, 'ºC'),
	(236212, 122, '2014-03-01 00:38:30.000000', 'temperatura', 318.0000, 'ºC'),
	(236213, 122, '2014-03-01 00:38:31.000000', 'temperatura', 987.0000, 'ºC'),
	(236214, 122, '2014-03-01 00:38:32.000000', 'temperatura', 380.0000, 'ºC'),
	(236215, 122, '2014-03-01 00:38:33.000000', 'temperatura', 141.0000, 'ºC'),
	(236216, 122, '2014-03-01 00:38:34.000000', 'temperatura', 766.0000, 'ºC'),
	(236217, 122, '2014-03-01 00:38:35.000000', 'temperatura', 1007.0000, 'ºC'),
	(236218, 122, '2014-03-01 00:38:36.000000', 'temperatura', 338.0000, 'ºC'),
	(236219, 122, '2014-03-01 00:38:37.000000', 'temperatura', 1071.0000, 'ºC'),
	(236220, 122, '2014-03-01 00:38:38.000000', 'temperatura', 740.0000, 'ºC'),
	(236221, 122, '2014-03-01 00:38:39.000000', 'temperatura', 488.0000, 'ºC'),
	(236222, 122, '2014-03-01 00:38:40.000000', 'temperatura', 220.0000, 'ºC'),
	(236223, 122, '2014-03-01 00:38:41.000000', 'temperatura', 837.0000, 'ºC'),
	(236224, 122, '2014-03-01 00:38:42.000000', 'temperatura', 1125.0000, 'ºC'),
	(236225, 122, '2014-03-01 00:38:43.000000', 'temperatura', 713.0000, 'ºC'),
	(236226, 122, '2014-03-01 00:38:44.000000', 'temperatura', 192.0000, 'ºC'),
	(236227, 122, '2014-03-01 00:38:45.000000', 'temperatura', 23.0000, 'ºC'),
	(236228, 122, '2014-03-01 00:38:46.000000', 'temperatura', 737.0000, 'ºC'),
	(236229, 122, '2014-03-01 00:38:47.000000', 'temperatura', 19.0000, 'ºC'),
	(236230, 122, '2014-03-01 00:38:48.000000', 'temperatura', 283.0000, 'ºC'),
	(236231, 122, '2014-03-01 00:38:49.000000', 'temperatura', 158.0000, 'ºC'),
	(236232, 122, '2014-03-01 00:38:50.000000', 'temperatura', 1141.0000, 'ºC'),
	(236233, 122, '2014-03-01 00:38:51.000000', 'temperatura', 432.0000, 'ºC'),
	(236234, 122, '2014-03-01 00:38:52.000000', 'temperatura', 1136.0000, 'ºC'),
	(236235, 122, '2014-03-01 00:38:53.000000', 'temperatura', 788.0000, 'ºC'),
	(236236, 122, '2014-03-01 00:38:54.000000', 'temperatura', 529.0000, 'ºC'),
	(236237, 122, '2014-03-01 00:38:55.000000', 'temperatura', 284.0000, 'ºC'),
	(236238, 122, '2014-03-01 00:38:56.000000', 'temperatura', 1032.0000, 'ºC'),
	(236239, 122, '2014-03-01 00:38:57.000000', 'temperatura', 707.0000, 'ºC'),
	(236240, 122, '2014-03-01 00:38:58.000000', 'temperatura', 442.0000, 'ºC'),
	(236241, 122, '2014-03-01 00:38:59.000000', 'temperatura', 90.0000, 'ºC'),
	(236242, 122, '2014-03-01 00:39:00.000000', 'temperatura', 323.0000, 'ºC'),
	(236243, 122, '2014-03-01 00:39:01.000000', 'temperatura', 147.0000, 'ºC'),
	(236244, 122, '2014-03-01 00:39:02.000000', 'temperatura', 966.0000, 'ºC'),
	(236245, 122, '2014-03-01 00:39:03.000000', 'temperatura', 790.0000, 'ºC'),
	(236246, 122, '2014-03-01 00:39:04.000000', 'temperatura', 1052.0000, 'ºC'),
	(236247, 122, '2014-03-01 00:39:05.000000', 'temperatura', 489.0000, 'ºC'),
	(236248, 122, '2014-03-01 00:39:06.000000', 'temperatura', 492.0000, 'ºC'),
	(236249, 122, '2014-03-01 00:39:07.000000', 'temperatura', 992.0000, 'ºC'),
	(236250, 122, '2014-03-01 00:39:08.000000', 'temperatura', 1085.0000, 'ºC'),
	(236251, 122, '2014-03-01 00:39:09.000000', 'temperatura', 47.0000, 'ºC'),
	(236252, 122, '2014-03-01 00:39:10.000000', 'temperatura', 583.0000, 'ºC'),
	(236253, 122, '2014-03-01 00:39:11.000000', 'temperatura', 375.0000, 'ºC'),
	(236254, 122, '2014-03-01 00:39:12.000000', 'temperatura', 126.0000, 'ºC'),
	(236255, 122, '2014-03-01 00:39:13.000000', 'temperatura', 704.0000, 'ºC'),
	(236256, 122, '2014-03-01 00:39:14.000000', 'temperatura', 742.0000, 'ºC'),
	(236257, 122, '2014-03-01 00:39:15.000000', 'temperatura', 399.0000, 'ºC'),
	(236258, 122, '2014-03-01 00:39:16.000000', 'temperatura', 971.0000, 'ºC'),
	(236259, 122, '2014-03-01 00:39:17.000000', 'temperatura', 56.0000, 'ºC'),
	(236260, 122, '2014-03-01 00:39:18.000000', 'temperatura', 971.0000, 'ºC'),
	(236261, 122, '2014-03-01 00:39:19.000000', 'temperatura', 1085.0000, 'ºC'),
	(236262, 122, '2014-03-01 00:39:20.000000', 'temperatura', 111.0000, 'ºC'),
	(236263, 122, '2014-03-01 00:39:21.000000', 'temperatura', 903.0000, 'ºC'),
	(236264, 122, '2014-03-01 00:39:22.000000', 'temperatura', 583.0000, 'ºC'),
	(236265, 122, '2014-03-01 00:39:23.000000', 'temperatura', 207.0000, 'ºC'),
	(236266, 122, '2014-03-01 00:39:24.000000', 'temperatura', 487.0000, 'ºC'),
	(236267, 122, '2014-03-01 00:39:25.000000', 'temperatura', 616.0000, 'ºC'),
	(236268, 122, '2014-03-01 00:39:26.000000', 'temperatura', 416.0000, 'ºC'),
	(236269, 122, '2014-03-01 00:39:27.000000', 'temperatura', 233.0000, 'ºC'),
	(236270, 122, '2014-03-01 00:39:28.000000', 'temperatura', 1118.0000, 'ºC'),
	(236271, 122, '2014-03-01 00:39:29.000000', 'temperatura', 93.0000, 'ºC'),
	(236272, 122, '2014-03-01 00:39:30.000000', 'temperatura', 713.0000, 'ºC'),
	(236273, 122, '2014-03-01 00:39:31.000000', 'temperatura', 883.0000, 'ºC'),
	(236274, 122, '2014-03-01 00:39:32.000000', 'temperatura', 1077.0000, 'ºC'),
	(236275, 122, '2014-03-01 00:39:33.000000', 'temperatura', 337.0000, 'ºC'),
	(236276, 122, '2014-03-01 00:39:34.000000', 'temperatura', 855.0000, 'ºC'),
	(236277, 122, '2014-03-01 00:39:35.000000', 'temperatura', 863.0000, 'ºC'),
	(236278, 122, '2014-03-01 00:39:36.000000', 'temperatura', 549.0000, 'ºC'),
	(236279, 122, '2014-03-01 00:39:37.000000', 'temperatura', 160.0000, 'ºC'),
	(236280, 122, '2014-03-01 00:39:38.000000', 'temperatura', 351.0000, 'ºC'),
	(236281, 122, '2014-03-01 00:39:39.000000', 'temperatura', 77.0000, 'ºC'),
	(236282, 122, '2014-03-01 00:39:40.000000', 'temperatura', 532.0000, 'ºC'),
	(236283, 122, '2014-03-01 00:39:41.000000', 'temperatura', 29.0000, 'ºC'),
	(236284, 122, '2014-03-01 00:39:42.000000', 'temperatura', 949.0000, 'ºC'),
	(236285, 122, '2014-03-01 00:39:43.000000', 'temperatura', 1059.0000, 'ºC'),
	(236286, 122, '2014-03-01 00:39:44.000000', 'temperatura', 48.0000, 'ºC'),
	(236287, 122, '2014-03-01 00:39:45.000000', 'temperatura', 664.0000, 'ºC'),
	(236288, 122, '2014-03-01 00:39:46.000000', 'temperatura', 778.0000, 'ºC'),
	(236289, 122, '2014-03-01 00:39:47.000000', 'temperatura', 698.0000, 'ºC'),
	(236290, 122, '2014-03-01 00:39:48.000000', 'temperatura', 1155.0000, 'ºC'),
	(236291, 122, '2014-03-01 00:39:49.000000', 'temperatura', 83.0000, 'ºC'),
	(236292, 122, '2014-03-01 00:39:50.000000', 'temperatura', 548.0000, 'ºC'),
	(236293, 122, '2014-03-01 00:39:51.000000', 'temperatura', 94.0000, 'ºC'),
	(236294, 122, '2014-03-01 00:39:52.000000', 'temperatura', 28.0000, 'ºC'),
	(236295, 122, '2014-03-01 00:39:53.000000', 'temperatura', 1056.0000, 'ºC'),
	(236296, 122, '2014-03-01 00:39:54.000000', 'temperatura', 397.0000, 'ºC'),
	(236297, 122, '2014-03-01 00:39:55.000000', 'temperatura', 16.0000, 'ºC'),
	(236298, 122, '2014-03-01 00:39:56.000000', 'temperatura', 89.0000, 'ºC'),
	(236299, 122, '2014-03-01 00:39:57.000000', 'temperatura', 399.0000, 'ºC'),
	(236300, 122, '2014-03-01 00:39:58.000000', 'temperatura', 527.0000, 'ºC'),
	(236301, 122, '2014-03-01 00:39:59.000000', 'temperatura', 239.0000, 'ºC'),
	(236302, 122, '2014-03-01 00:40:00.000000', 'temperatura', 815.0000, 'ºC'),
	(236303, 122, '2014-03-01 00:40:01.000000', 'temperatura', 956.0000, 'ºC'),
	(236304, 122, '2014-03-01 00:40:02.000000', 'temperatura', 1138.0000, 'ºC'),
	(236305, 122, '2014-03-01 00:40:03.000000', 'temperatura', 422.0000, 'ºC'),
	(236306, 122, '2014-03-01 00:40:04.000000', 'temperatura', 1098.0000, 'ºC'),
	(236307, 122, '2014-03-01 00:40:05.000000', 'temperatura', 624.0000, 'ºC'),
	(236308, 122, '2014-03-01 00:40:06.000000', 'temperatura', 1024.0000, 'ºC'),
	(236309, 122, '2014-03-01 00:40:07.000000', 'temperatura', 852.0000, 'ºC'),
	(236310, 122, '2014-03-01 00:40:08.000000', 'temperatura', 1185.0000, 'ºC'),
	(236311, 122, '2014-03-01 00:40:09.000000', 'temperatura', 971.0000, 'ºC'),
	(236312, 122, '2014-03-01 00:40:10.000000', 'temperatura', 100.0000, 'ºC'),
	(236313, 122, '2014-03-01 00:40:11.000000', 'temperatura', 1190.0000, 'ºC'),
	(236314, 122, '2014-03-01 00:40:12.000000', 'temperatura', 848.0000, 'ºC'),
	(236315, 122, '2014-03-01 00:40:13.000000', 'temperatura', 669.0000, 'ºC'),
	(236316, 122, '2014-03-01 00:40:14.000000', 'temperatura', 804.0000, 'ºC'),
	(236317, 122, '2014-03-01 00:40:15.000000', 'temperatura', 813.0000, 'ºC'),
	(236318, 122, '2014-03-01 00:40:16.000000', 'temperatura', 452.0000, 'ºC'),
	(236319, 122, '2014-03-01 00:40:17.000000', 'temperatura', 1021.0000, 'ºC'),
	(236320, 122, '2014-03-01 00:40:18.000000', 'temperatura', 148.0000, 'ºC'),
	(236321, 122, '2014-03-01 00:40:19.000000', 'temperatura', 81.0000, 'ºC'),
	(236322, 122, '2014-03-01 00:40:20.000000', 'temperatura', 1161.0000, 'ºC'),
	(236323, 122, '2014-03-01 00:40:21.000000', 'temperatura', 761.0000, 'ºC'),
	(236324, 122, '2014-03-01 00:40:22.000000', 'temperatura', 324.0000, 'ºC'),
	(236325, 122, '2014-03-01 00:40:23.000000', 'temperatura', 538.0000, 'ºC'),
	(236326, 122, '2014-03-01 00:40:24.000000', 'temperatura', 516.0000, 'ºC'),
	(236327, 122, '2014-03-01 00:40:25.000000', 'temperatura', 966.0000, 'ºC'),
	(236328, 122, '2014-03-01 00:40:26.000000', 'temperatura', 886.0000, 'ºC'),
	(236329, 122, '2014-03-01 00:40:27.000000', 'temperatura', 329.0000, 'ºC'),
	(236330, 122, '2014-03-01 00:40:28.000000', 'temperatura', 188.0000, 'ºC'),
	(236331, 122, '2014-03-01 00:40:29.000000', 'temperatura', 1156.0000, 'ºC'),
	(236332, 122, '2014-03-01 00:40:30.000000', 'temperatura', 416.0000, 'ºC'),
	(236333, 122, '2014-03-01 00:40:31.000000', 'temperatura', 1011.0000, 'ºC'),
	(236334, 122, '2014-03-01 00:40:32.000000', 'temperatura', 206.0000, 'ºC'),
	(236335, 122, '2014-03-01 00:40:33.000000', 'temperatura', 400.0000, 'ºC'),
	(236336, 122, '2014-03-01 00:40:34.000000', 'temperatura', 181.0000, 'ºC'),
	(236337, 122, '2014-03-01 00:40:35.000000', 'temperatura', 905.0000, 'ºC'),
	(236338, 122, '2014-03-01 00:40:36.000000', 'temperatura', 383.0000, 'ºC'),
	(236339, 122, '2014-03-01 00:40:37.000000', 'temperatura', 399.0000, 'ºC'),
	(236340, 122, '2014-03-01 00:40:38.000000', 'temperatura', 849.0000, 'ºC'),
	(236341, 122, '2014-03-01 00:40:39.000000', 'temperatura', 649.0000, 'ºC'),
	(236342, 122, '2014-03-01 00:40:40.000000', 'temperatura', 696.0000, 'ºC'),
	(236343, 122, '2014-03-01 00:40:41.000000', 'temperatura', 334.0000, 'ºC'),
	(236344, 122, '2014-03-01 00:40:42.000000', 'temperatura', 785.0000, 'ºC'),
	(236345, 122, '2014-03-01 00:40:43.000000', 'temperatura', 522.0000, 'ºC'),
	(236346, 122, '2014-03-01 00:40:44.000000', 'temperatura', 254.0000, 'ºC'),
	(236347, 122, '2014-03-01 00:40:45.000000', 'temperatura', 907.0000, 'ºC'),
	(236348, 122, '2014-03-01 00:40:46.000000', 'temperatura', 174.0000, 'ºC'),
	(236349, 122, '2014-03-01 00:40:47.000000', 'temperatura', 550.0000, 'ºC'),
	(236350, 122, '2014-03-01 00:40:48.000000', 'temperatura', 1025.0000, 'ºC'),
	(236351, 122, '2014-03-01 00:40:49.000000', 'temperatura', 1079.0000, 'ºC'),
	(236352, 122, '2014-03-01 00:40:50.000000', 'temperatura', 1118.0000, 'ºC'),
	(236353, 122, '2014-03-01 00:40:51.000000', 'temperatura', 1153.0000, 'ºC'),
	(236354, 122, '2014-03-01 00:40:52.000000', 'temperatura', 11.0000, 'ºC'),
	(236355, 122, '2014-03-01 00:40:53.000000', 'temperatura', 197.0000, 'ºC'),
	(236356, 122, '2014-03-01 00:40:54.000000', 'temperatura', 953.0000, 'ºC'),
	(236357, 122, '2014-03-01 00:40:55.000000', 'temperatura', 573.0000, 'ºC'),
	(236358, 122, '2014-03-01 00:40:56.000000', 'temperatura', 6.0000, 'ºC'),
	(236359, 122, '2014-03-01 00:40:57.000000', 'temperatura', 710.0000, 'ºC'),
	(236360, 122, '2014-03-01 00:40:58.000000', 'temperatura', 1136.0000, 'ºC'),
	(236361, 122, '2014-03-01 00:40:59.000000', 'temperatura', 1151.0000, 'ºC'),
	(236362, 122, '2014-03-01 00:41:00.000000', 'temperatura', 1145.0000, 'ºC'),
	(236363, 122, '2014-03-01 00:41:01.000000', 'temperatura', 1074.0000, 'ºC'),
	(236364, 122, '2014-03-01 00:41:02.000000', 'temperatura', 734.0000, 'ºC'),
	(236365, 122, '2014-03-01 00:41:03.000000', 'temperatura', 450.0000, 'ºC'),
	(236366, 122, '2014-03-01 00:41:04.000000', 'temperatura', 46.0000, 'ºC'),
	(236367, 122, '2014-03-01 00:41:05.000000', 'temperatura', 83.0000, 'ºC'),
	(236368, 122, '2014-03-01 00:41:06.000000', 'temperatura', 278.0000, 'ºC'),
	(236369, 122, '2014-03-01 00:41:07.000000', 'temperatura', 1141.0000, 'ºC'),
	(236370, 122, '2014-03-01 00:41:08.000000', 'temperatura', 69.0000, 'ºC'),
	(236371, 122, '2014-03-01 00:41:09.000000', 'temperatura', 525.0000, 'ºC'),
	(236372, 122, '2014-03-01 00:41:10.000000', 'temperatura', 17.0000, 'ºC'),
	(236373, 122, '2014-03-01 00:41:11.000000', 'temperatura', 910.0000, 'ºC'),
	(236374, 122, '2014-03-01 00:41:12.000000', 'temperatura', 900.0000, 'ºC'),
	(236375, 122, '2014-03-01 00:41:13.000000', 'temperatura', 571.0000, 'ºC'),
	(236376, 122, '2014-03-01 00:41:14.000000', 'temperatura', 154.0000, 'ºC'),
	(236377, 122, '2014-03-01 00:41:15.000000', 'temperatura', 259.0000, 'ºC'),
	(236378, 122, '2014-03-01 00:41:16.000000', 'temperatura', 834.0000, 'ºC'),
	(236379, 122, '2014-03-01 00:41:17.000000', 'temperatura', 992.0000, 'ºC'),
	(236380, 122, '2014-03-01 00:41:18.000000', 'temperatura', 61.0000, 'ºC'),
	(236381, 122, '2014-03-01 00:41:19.000000', 'temperatura', 929.0000, 'ºC'),
	(236382, 122, '2014-03-01 00:41:20.000000', 'temperatura', 863.0000, 'ºC'),
	(236383, 122, '2014-03-01 00:41:21.000000', 'temperatura', 327.0000, 'ºC'),
	(236384, 122, '2014-03-01 00:41:22.000000', 'temperatura', 246.0000, 'ºC'),
	(236385, 122, '2014-03-01 00:41:23.000000', 'temperatura', 251.0000, 'ºC'),
	(236386, 122, '2014-03-01 00:41:24.000000', 'temperatura', 517.0000, 'ºC'),
	(236387, 122, '2014-03-01 00:41:25.000000', 'temperatura', 632.0000, 'ºC'),
	(236388, 122, '2014-03-01 00:41:26.000000', 'temperatura', 412.0000, 'ºC'),
	(236389, 122, '2014-03-01 00:41:27.000000', 'temperatura', 162.0000, 'ºC'),
	(236390, 122, '2014-03-01 00:41:28.000000', 'temperatura', 773.0000, 'ºC'),
	(236391, 122, '2014-03-01 00:41:29.000000', 'temperatura', 983.0000, 'ºC'),
	(236392, 122, '2014-03-01 00:41:30.000000', 'temperatura', 195.0000, 'ºC'),
	(236393, 122, '2014-03-01 00:41:31.000000', 'temperatura', 427.0000, 'ºC'),
	(236394, 122, '2014-03-01 00:41:32.000000', 'temperatura', 349.0000, 'ºC'),
	(236395, 122, '2014-03-01 00:41:33.000000', 'temperatura', 464.0000, 'ºC'),
	(236396, 122, '2014-03-01 00:41:34.000000', 'temperatura', 76.0000, 'ºC'),
	(236397, 122, '2014-03-01 00:41:35.000000', 'temperatura', 189.0000, 'ºC'),
	(236398, 122, '2014-03-01 00:41:36.000000', 'temperatura', 715.0000, 'ºC'),
	(236399, 122, '2014-03-01 00:41:37.000000', 'temperatura', 608.0000, 'ºC'),
	(236400, 122, '2014-03-01 00:41:38.000000', 'temperatura', 897.0000, 'ºC'),
	(236401, 122, '2014-03-01 00:41:39.000000', 'temperatura', 260.0000, 'ºC'),
	(236402, 122, '2014-03-01 00:41:40.000000', 'temperatura', 1011.0000, 'ºC'),
	(236403, 122, '2014-03-01 00:41:41.000000', 'temperatura', 675.0000, 'ºC'),
	(236404, 122, '2014-03-01 00:41:42.000000', 'temperatura', 343.0000, 'ºC'),
	(236405, 122, '2014-03-01 00:41:43.000000', 'temperatura', 888.0000, 'ºC'),
	(236406, 122, '2014-03-01 00:41:44.000000', 'temperatura', 1014.0000, 'ºC'),
	(236407, 122, '2014-03-01 00:41:45.000000', 'temperatura', 5.0000, 'ºC'),
	(236408, 122, '2014-03-01 00:41:46.000000', 'temperatura', 586.0000, 'ºC'),
	(236409, 122, '2014-03-01 00:41:47.000000', 'temperatura', 514.0000, 'ºC'),
	(236410, 122, '2014-03-01 00:41:48.000000', 'temperatura', 814.0000, 'ºC'),
	(236411, 122, '2014-03-01 00:41:49.000000', 'temperatura', 126.0000, 'ºC'),
	(236412, 122, '2014-03-01 00:41:50.000000', 'temperatura', 588.0000, 'ºC'),
	(236413, 122, '2014-03-01 00:41:51.000000', 'temperatura', 162.0000, 'ºC'),
	(236414, 122, '2014-03-01 00:41:52.000000', 'temperatura', 246.0000, 'ºC'),
	(236415, 122, '2014-03-01 00:41:53.000000', 'temperatura', 745.0000, 'ºC'),
	(236416, 122, '2014-03-01 00:41:54.000000', 'temperatura', 586.0000, 'ºC'),
	(236417, 122, '2014-03-01 00:41:55.000000', 'temperatura', 697.0000, 'ºC'),
	(236418, 122, '2014-03-01 00:41:56.000000', 'temperatura', 527.0000, 'ºC'),
	(236419, 122, '2014-03-01 00:41:57.000000', 'temperatura', 544.0000, 'ºC'),
	(236420, 122, '2014-03-01 00:41:58.000000', 'temperatura', 1141.0000, 'ºC'),
	(236421, 122, '2014-03-01 00:41:59.000000', 'temperatura', 474.0000, 'ºC'),
	(236422, 122, '2014-03-01 00:42:00.000000', 'temperatura', 149.0000, 'ºC'),
	(236423, 122, '2014-03-01 00:42:01.000000', 'temperatura', 521.0000, 'ºC'),
	(236424, 122, '2014-03-01 00:42:02.000000', 'temperatura', 959.0000, 'ºC'),
	(236425, 122, '2014-03-01 00:42:03.000000', 'temperatura', 833.0000, 'ºC'),
	(236426, 122, '2014-03-01 00:42:04.000000', 'temperatura', 87.0000, 'ºC'),
	(236427, 122, '2014-03-01 00:42:05.000000', 'temperatura', 339.0000, 'ºC'),
	(236428, 122, '2014-03-01 00:42:06.000000', 'temperatura', 231.0000, 'ºC'),
	(236429, 122, '2014-03-01 00:42:07.000000', 'temperatura', 142.0000, 'ºC'),
	(236430, 122, '2014-03-01 00:42:08.000000', 'temperatura', 15.0000, 'ºC'),
	(236431, 122, '2014-03-01 00:42:09.000000', 'temperatura', 849.0000, 'ºC'),
	(236432, 122, '2014-03-01 00:42:10.000000', 'temperatura', 601.0000, 'ºC'),
	(236433, 122, '2014-03-01 00:42:11.000000', 'temperatura', 461.0000, 'ºC'),
	(236434, 122, '2014-03-01 00:42:12.000000', 'temperatura', 499.0000, 'ºC'),
	(236435, 122, '2014-03-01 00:42:13.000000', 'temperatura', 1114.0000, 'ºC'),
	(236436, 122, '2014-03-01 00:42:14.000000', 'temperatura', 471.0000, 'ºC'),
	(236437, 122, '2014-03-01 00:42:15.000000', 'temperatura', 217.0000, 'ºC'),
	(236438, 122, '2014-03-01 00:42:16.000000', 'temperatura', 870.0000, 'ºC'),
	(236439, 122, '2014-03-01 00:42:17.000000', 'temperatura', 101.0000, 'ºC'),
	(236440, 122, '2014-03-01 00:42:18.000000', 'temperatura', 296.0000, 'ºC'),
	(236441, 122, '2014-03-01 00:42:19.000000', 'temperatura', 1175.0000, 'ºC'),
	(236442, 122, '2014-03-01 00:42:20.000000', 'temperatura', 188.0000, 'ºC'),
	(236443, 122, '2014-03-01 00:42:21.000000', 'temperatura', 1015.0000, 'ºC'),
	(236444, 122, '2014-03-01 00:42:22.000000', 'temperatura', 913.0000, 'ºC'),
	(236445, 122, '2014-03-01 00:42:23.000000', 'temperatura', 320.0000, 'ºC'),
	(236446, 122, '2014-03-01 00:42:24.000000', 'temperatura', 63.0000, 'ºC'),
	(236447, 122, '2014-03-01 00:42:25.000000', 'temperatura', 554.0000, 'ºC'),
	(236448, 122, '2014-03-01 00:42:26.000000', 'temperatura', 182.0000, 'ºC'),
	(236449, 122, '2014-03-01 00:42:27.000000', 'temperatura', 447.0000, 'ºC'),
	(236450, 122, '2014-03-01 00:42:28.000000', 'temperatura', 491.0000, 'ºC'),
	(236451, 122, '2014-03-01 00:42:29.000000', 'temperatura', 1113.0000, 'ºC'),
	(236452, 122, '2014-03-01 00:42:30.000000', 'temperatura', 492.0000, 'ºC'),
	(236453, 122, '2014-03-01 00:42:31.000000', 'temperatura', 321.0000, 'ºC'),
	(236454, 122, '2014-03-01 00:42:32.000000', 'temperatura', 131.0000, 'ºC'),
	(236455, 122, '2014-03-01 00:42:33.000000', 'temperatura', 891.0000, 'ºC'),
	(236456, 122, '2014-03-01 00:42:34.000000', 'temperatura', 461.0000, 'ºC'),
	(236457, 122, '2014-03-01 00:42:35.000000', 'temperatura', 835.0000, 'ºC'),
	(236458, 122, '2014-03-01 00:42:36.000000', 'temperatura', 392.0000, 'ºC'),
	(236459, 122, '2014-03-01 00:42:37.000000', 'temperatura', 655.0000, 'ºC'),
	(236460, 122, '2014-03-01 00:42:38.000000', 'temperatura', 901.0000, 'ºC'),
	(236461, 122, '2014-03-01 00:42:39.000000', 'temperatura', 138.0000, 'ºC'),
	(236462, 122, '2014-03-01 00:42:40.000000', 'temperatura', 389.0000, 'ºC'),
	(236463, 122, '2014-03-01 00:42:41.000000', 'temperatura', 330.0000, 'ºC'),
	(236464, 122, '2014-03-01 00:42:42.000000', 'temperatura', 483.0000, 'ºC'),
	(236465, 122, '2014-03-01 00:42:43.000000', 'temperatura', 227.0000, 'ºC'),
	(236466, 122, '2014-03-01 00:42:44.000000', 'temperatura', 885.0000, 'ºC'),
	(236467, 122, '2014-03-01 00:42:45.000000', 'temperatura', 146.0000, 'ºC'),
	(236468, 122, '2014-03-01 00:42:46.000000', 'temperatura', 473.0000, 'ºC'),
	(236469, 122, '2014-03-01 00:42:47.000000', 'temperatura', 730.0000, 'ºC'),
	(236470, 122, '2014-03-01 00:42:48.000000', 'temperatura', 1033.0000, 'ºC'),
	(236471, 122, '2014-03-01 00:42:49.000000', 'temperatura', 573.0000, 'ºC'),
	(236472, 122, '2014-03-01 00:42:50.000000', 'temperatura', 966.0000, 'ºC'),
	(236473, 122, '2014-03-01 00:42:51.000000', 'temperatura', 711.0000, 'ºC'),
	(236474, 122, '2014-03-01 00:42:52.000000', 'temperatura', 657.0000, 'ºC'),
	(236475, 122, '2014-03-01 00:42:53.000000', 'temperatura', 1152.0000, 'ºC'),
	(236476, 122, '2014-03-01 00:42:54.000000', 'temperatura', 192.0000, 'ºC'),
	(236477, 122, '2014-03-01 00:42:55.000000', 'temperatura', 1102.0000, 'ºC'),
	(236478, 122, '2014-03-01 00:42:56.000000', 'temperatura', 135.0000, 'ºC'),
	(236479, 122, '2014-03-01 00:42:57.000000', 'temperatura', 970.0000, 'ºC'),
	(236480, 122, '2014-03-01 00:42:58.000000', 'temperatura', 847.0000, 'ºC'),
	(236481, 122, '2014-03-01 00:42:59.000000', 'temperatura', 123.0000, 'ºC'),
	(236482, 122, '2014-03-01 00:43:00.000000', 'temperatura', 477.0000, 'ºC'),
	(236483, 122, '2014-03-01 00:43:01.000000', 'temperatura', 814.0000, 'ºC'),
	(236484, 122, '2014-03-01 00:43:02.000000', 'temperatura', 240.0000, 'ºC'),
	(236485, 122, '2014-03-01 00:43:03.000000', 'temperatura', 1160.0000, 'ºC'),
	(236486, 122, '2014-03-01 00:43:04.000000', 'temperatura', 281.0000, 'ºC'),
	(236487, 122, '2014-03-01 00:43:05.000000', 'temperatura', 323.0000, 'ºC'),
	(236488, 122, '2014-03-01 00:43:06.000000', 'temperatura', 775.0000, 'ºC'),
	(236489, 122, '2014-03-01 00:43:07.000000', 'temperatura', 506.0000, 'ºC'),
	(236490, 122, '2014-03-01 00:43:08.000000', 'temperatura', 203.0000, 'ºC'),
	(236491, 122, '2014-03-01 00:43:09.000000', 'temperatura', 700.0000, 'ºC'),
	(236492, 122, '2014-03-01 00:43:10.000000', 'temperatura', 491.0000, 'ºC'),
	(236493, 122, '2014-03-01 00:43:11.000000', 'temperatura', 354.0000, 'ºC'),
	(236494, 122, '2014-03-01 00:43:12.000000', 'temperatura', 297.0000, 'ºC'),
	(236495, 122, '2014-03-01 00:43:13.000000', 'temperatura', 425.0000, 'ºC'),
	(236496, 122, '2014-03-01 00:43:14.000000', 'temperatura', 33.0000, 'ºC'),
	(236497, 122, '2014-03-01 00:43:15.000000', 'temperatura', 92.0000, 'ºC'),
	(236498, 122, '2014-03-01 00:43:16.000000', 'temperatura', 362.0000, 'ºC'),
	(236499, 122, '2014-03-01 00:43:17.000000', 'temperatura', 335.0000, 'ºC'),
	(236500, 122, '2014-03-01 00:43:18.000000', 'temperatura', 590.0000, 'ºC'),
	(236501, 122, '2014-03-01 00:43:19.000000', 'temperatura', 744.0000, 'ºC'),
	(236502, 122, '2014-03-01 00:43:20.000000', 'temperatura', 749.0000, 'ºC'),
	(236503, 122, '2014-03-01 00:43:21.000000', 'temperatura', 315.0000, 'ºC'),
	(236504, 122, '2014-03-01 00:43:22.000000', 'temperatura', 529.0000, 'ºC'),
	(236505, 122, '2014-03-01 00:43:23.000000', 'temperatura', 502.0000, 'ºC'),
	(236506, 122, '2014-03-01 00:43:24.000000', 'temperatura', 921.0000, 'ºC'),
	(236507, 122, '2014-03-01 00:43:25.000000', 'temperatura', 701.0000, 'ºC'),
	(236508, 122, '2014-03-01 00:43:26.000000', 'temperatura', 742.0000, 'ºC'),
	(236509, 122, '2014-03-01 00:43:27.000000', 'temperatura', 406.0000, 'ºC'),
	(236510, 122, '2014-03-01 00:43:28.000000', 'temperatura', 1004.0000, 'ºC'),
	(236511, 122, '2014-03-01 00:43:29.000000', 'temperatura', 204.0000, 'ºC'),
	(236512, 122, '2014-03-01 00:43:30.000000', 'temperatura', 410.0000, 'ºC'),
	(236513, 122, '2014-03-01 00:43:31.000000', 'temperatura', 238.0000, 'ºC'),
	(236514, 122, '2014-03-01 00:43:32.000000', 'temperatura', 1159.0000, 'ºC'),
	(236515, 122, '2014-03-01 00:43:33.000000', 'temperatura', 280.0000, 'ºC'),
	(236516, 122, '2014-03-01 00:43:34.000000', 'temperatura', 327.0000, 'ºC'),
	(236517, 122, '2014-03-01 00:43:35.000000', 'temperatura', 793.0000, 'ºC'),
	(236518, 122, '2014-03-01 00:43:36.000000', 'temperatura', 586.0000, 'ºC'),
	(236519, 122, '2014-03-01 00:43:37.000000', 'temperatura', 552.0000, 'ºC'),
	(236520, 122, '2014-03-01 00:43:38.000000', 'temperatura', 1003.0000, 'ºC'),
	(236521, 122, '2014-03-01 00:43:39.000000', 'temperatura', 958.0000, 'ºC'),
	(236522, 122, '2014-03-01 00:43:40.000000', 'temperatura', 582.0000, 'ºC'),
	(236523, 122, '2014-03-01 00:43:41.000000', 'temperatura', 38.0000, 'ºC'),
	(236524, 122, '2014-03-01 00:43:42.000000', 'temperatura', 844.0000, 'ºC'),
	(236525, 122, '2014-03-01 00:43:43.000000', 'temperatura', 505.0000, 'ºC'),
	(236526, 122, '2014-03-01 00:43:44.000000', 'temperatura', 1196.0000, 'ºC'),
	(236527, 122, '2014-03-01 00:43:45.000000', 'temperatura', 866.0000, 'ºC'),
	(236528, 122, '2014-03-01 00:43:46.000000', 'temperatura', 741.0000, 'ºC'),
	(236529, 122, '2014-03-01 00:43:47.000000', 'temperatura', 1110.0000, 'ºC'),
	(236530, 122, '2014-03-01 00:43:48.000000', 'temperatura', 924.0000, 'ºC'),
	(236531, 122, '2014-03-01 00:43:49.000000', 'temperatura', 91.0000, 'ºC'),
	(236532, 122, '2014-03-01 00:43:50.000000', 'temperatura', 86.0000, 'ºC'),
	(236533, 122, '2014-03-01 00:43:51.000000', 'temperatura', 156.0000, 'ºC'),
	(236534, 122, '2014-03-01 00:43:52.000000', 'temperatura', 522.0000, 'ºC'),
	(236535, 122, '2014-03-01 00:43:53.000000', 'temperatura', 945.0000, 'ºC'),
	(236536, 122, '2014-03-01 00:43:54.000000', 'temperatura', 757.0000, 'ºC'),
	(236537, 122, '2014-03-01 00:43:55.000000', 'temperatura', 950.0000, 'ºC'),
	(236538, 122, '2014-03-01 00:43:56.000000', 'temperatura', 81.0000, 'ºC'),
	(236539, 122, '2014-03-01 00:43:57.000000', 'temperatura', 1157.0000, 'ºC'),
	(236540, 122, '2014-03-01 00:43:58.000000', 'temperatura', 741.0000, 'ºC'),
	(236541, 122, '2014-03-01 00:43:59.000000', 'temperatura', 235.0000, 'ºC'),
	(236542, 122, '2014-03-01 00:44:00.000000', 'temperatura', 151.0000, 'ºC'),
	(236543, 122, '2014-03-01 00:44:01.000000', 'temperatura', 53.0000, 'ºC'),
	(236544, 122, '2014-03-01 00:44:02.000000', 'temperatura', 1012.0000, 'ºC'),
	(236545, 122, '2014-03-01 00:44:03.000000', 'temperatura', 103.0000, 'ºC'),
	(236546, 122, '2014-03-01 00:44:04.000000', 'temperatura', 1078.0000, 'ºC'),
	(236547, 122, '2014-03-01 00:44:05.000000', 'temperatura', 283.0000, 'ºC'),
	(236548, 122, '2014-03-01 00:44:06.000000', 'temperatura', 580.0000, 'ºC'),
	(236549, 122, '2014-03-01 00:44:07.000000', 'temperatura', 854.0000, 'ºC'),
	(236550, 122, '2014-03-01 00:44:08.000000', 'temperatura', 129.0000, 'ºC'),
	(236551, 122, '2014-03-01 00:44:09.000000', 'temperatura', 482.0000, 'ºC'),
	(236552, 122, '2014-03-01 00:44:10.000000', 'temperatura', 824.0000, 'ºC'),
	(236553, 122, '2014-03-01 00:44:11.000000', 'temperatura', 273.0000, 'ºC'),
	(236554, 122, '2014-03-01 00:44:12.000000', 'temperatura', 94.0000, 'ºC'),
	(236555, 122, '2014-03-01 00:44:13.000000', 'temperatura', 854.0000, 'ºC'),
	(236556, 122, '2014-03-01 00:44:14.000000', 'temperatura', 386.0000, 'ºC'),
	(236557, 122, '2014-03-01 00:44:15.000000', 'temperatura', 568.0000, 'ºC'),
	(236558, 122, '2014-03-01 00:44:16.000000', 'temperatura', 485.0000, 'ºC'),
	(236559, 122, '2014-03-01 00:44:17.000000', 'temperatura', 720.0000, 'ºC'),
	(236560, 122, '2014-03-01 00:44:18.000000', 'temperatura', 947.0000, 'ºC'),
	(236561, 122, '2014-03-01 00:44:19.000000', 'temperatura', 175.0000, 'ºC'),
	(236562, 122, '2014-03-01 00:44:20.000000', 'temperatura', 435.0000, 'ºC'),
	(236563, 122, '2014-03-01 00:44:21.000000', 'temperatura', 452.0000, 'ºC'),
	(236564, 122, '2014-03-01 00:44:22.000000', 'temperatura', 953.0000, 'ºC'),
	(236565, 122, '2014-03-01 00:44:23.000000', 'temperatura', 1011.0000, 'ºC'),
	(236566, 122, '2014-03-01 00:44:24.000000', 'temperatura', 998.0000, 'ºC'),
	(236567, 122, '2014-03-01 00:44:25.000000', 'temperatura', 755.0000, 'ºC'),
	(236568, 122, '2014-03-01 00:44:26.000000', 'temperatura', 781.0000, 'ºC'),
	(236569, 122, '2014-03-01 00:44:27.000000', 'temperatura', 441.0000, 'ºC'),
	(236570, 122, '2014-03-01 00:44:28.000000', 'temperatura', 1062.0000, 'ºC'),
	(236571, 122, '2014-03-01 00:44:29.000000', 'temperatura', 386.0000, 'ºC'),
	(236572, 122, '2014-03-01 00:44:30.000000', 'temperatura', 1146.0000, 'ºC'),
	(236573, 122, '2014-03-01 00:44:31.000000', 'temperatura', 974.0000, 'ºC'),
	(236574, 122, '2014-03-01 00:44:32.000000', 'temperatura', 231.0000, 'ºC'),
	(236575, 122, '2014-03-01 00:44:33.000000', 'temperatura', 635.0000, 'ºC'),
	(236576, 122, '2014-03-01 00:44:34.000000', 'temperatura', 84.0000, 'ºC'),
	(236577, 122, '2014-03-01 00:44:35.000000', 'temperatura', 912.0000, 'ºC'),
	(236578, 122, '2014-03-01 00:44:36.000000', 'temperatura', 709.0000, 'ºC'),
	(236579, 122, '2014-03-01 00:44:37.000000', 'temperatura', 811.0000, 'ºC'),
	(236580, 122, '2014-03-01 00:44:38.000000', 'temperatura', 726.0000, 'ºC'),
	(236581, 122, '2014-03-01 00:44:39.000000', 'temperatura', 0.0000, 'ºC'),
	(236582, 122, '2014-03-01 00:44:40.000000', 'temperatura', 224.0000, 'ºC'),
	(236583, 122, '2014-03-01 00:44:41.000000', 'temperatura', 1117.0000, 'ºC'),
	(236584, 122, '2014-03-01 00:44:42.000000', 'temperatura', 116.0000, 'ºC'),
	(236585, 122, '2014-03-01 00:44:43.000000', 'temperatura', 831.0000, 'ºC'),
	(236586, 122, '2014-03-01 00:44:44.000000', 'temperatura', 204.0000, 'ºC'),
	(236587, 122, '2014-03-01 00:44:45.000000', 'temperatura', 930.0000, 'ºC'),
	(236588, 122, '2014-03-01 00:44:46.000000', 'temperatura', 438.0000, 'ºC'),
	(236589, 122, '2014-03-01 00:44:47.000000', 'temperatura', 602.0000, 'ºC'),
	(236590, 122, '2014-03-01 00:44:48.000000', 'temperatura', 496.0000, 'ºC'),
	(236591, 122, '2014-03-01 00:44:49.000000', 'temperatura', 676.0000, 'ºC'),
	(236592, 122, '2014-03-01 00:44:50.000000', 'temperatura', 689.0000, 'ºC'),
	(236593, 122, '2014-03-01 00:44:51.000000', 'temperatura', 220.0000, 'ºC'),
	(236594, 122, '2014-03-01 00:44:52.000000', 'temperatura', 231.0000, 'ºC'),
	(236595, 122, '2014-03-01 00:44:53.000000', 'temperatura', 498.0000, 'ºC'),
	(236596, 122, '2014-03-01 00:44:54.000000', 'temperatura', 595.0000, 'ºC'),
	(236597, 122, '2014-03-01 00:44:55.000000', 'temperatura', 285.0000, 'ºC'),
	(236598, 122, '2014-03-01 00:44:56.000000', 'temperatura', 837.0000, 'ºC'),
	(236599, 122, '2014-03-01 00:44:57.000000', 'temperatura', 933.0000, 'ºC'),
	(236600, 122, '2014-03-01 00:44:58.000000', 'temperatura', 952.0000, 'ºC'),
	(236601, 122, '2014-03-01 00:44:59.000000', 'temperatura', 762.0000, 'ºC'),
	(236602, 122, '2014-03-01 00:45:00.000000', 'temperatura', 957.0000, 'ºC'),
	(236603, 122, '2014-03-01 00:45:01.000000', 'temperatura', 97.0000, 'ºC'),
	(236604, 122, '2014-03-01 00:45:02.000000', 'temperatura', 16.0000, 'ºC'),
	(236605, 122, '2014-03-01 00:45:03.000000', 'temperatura', 990.0000, 'ºC'),
	(236606, 122, '2014-03-01 00:45:04.000000', 'temperatura', 101.0000, 'ºC'),
	(236607, 122, '2014-03-01 00:45:05.000000', 'temperatura', 1137.0000, 'ºC'),
	(236608, 122, '2014-03-01 00:45:06.000000', 'temperatura', 583.0000, 'ºC'),
	(236609, 122, '2014-03-01 00:45:07.000000', 'temperatura', 705.0000, 'ºC'),
	(236610, 122, '2014-03-01 00:45:08.000000', 'temperatura', 574.0000, 'ºC'),
	(236611, 122, '2014-03-01 00:45:09.000000', 'temperatura', 758.0000, 'ºC'),
	(236612, 122, '2014-03-01 00:45:10.000000', 'temperatura', 868.0000, 'ºC'),
	(236613, 122, '2014-03-01 00:45:11.000000', 'temperatura', 864.0000, 'ºC'),
	(236614, 122, '2014-03-01 00:45:12.000000', 'temperatura', 520.0000, 'ºC'),
	(236615, 122, '2014-03-01 00:45:13.000000', 'temperatura', 7.0000, 'ºC'),
	(236616, 122, '2014-03-01 00:45:14.000000', 'temperatura', 875.0000, 'ºC'),
	(236617, 122, '2014-03-01 00:45:15.000000', 'temperatura', 755.0000, 'ºC'),
	(236618, 122, '2014-03-01 00:45:16.000000', 'temperatura', 1149.0000, 'ºC'),
	(236619, 122, '2014-03-01 00:45:17.000000', 'temperatura', 1082.0000, 'ºC'),
	(236620, 122, '2014-03-01 00:45:18.000000', 'temperatura', 761.0000, 'ºC'),
	(236621, 122, '2014-03-01 00:45:19.000000', 'temperatura', 561.0000, 'ºC'),
	(236622, 122, '2014-03-01 00:45:20.000000', 'temperatura', 524.0000, 'ºC'),
	(236623, 122, '2014-03-01 00:45:21.000000', 'temperatura', 938.0000, 'ºC'),
	(236624, 122, '2014-03-01 00:45:22.000000', 'temperatura', 719.0000, 'ºC'),
	(236625, 122, '2014-03-01 00:45:23.000000', 'temperatura', 781.0000, 'ºC'),
	(236626, 122, '2014-03-01 00:45:24.000000', 'temperatura', 547.0000, 'ºC'),
	(236627, 122, '2014-03-01 00:45:25.000000', 'temperatura', 394.0000, 'ºC'),
	(236628, 122, '2014-03-01 00:45:26.000000', 'temperatura', 330.0000, 'ºC'),
	(236629, 122, '2014-03-01 00:45:27.000000', 'temperatura', 467.0000, 'ºC'),
	(236630, 122, '2014-03-01 00:45:28.000000', 'temperatura', 146.0000, 'ºC'),
	(236631, 122, '2014-03-01 00:45:29.000000', 'temperatura', 530.0000, 'ºC'),
	(236632, 122, '2014-03-01 00:45:30.000000', 'temperatura', 1011.0000, 'ºC'),
	(236633, 122, '2014-03-01 00:45:31.000000', 'temperatura', 1066.0000, 'ºC'),
	(236634, 122, '2014-03-01 00:45:32.000000', 'temperatura', 1097.0000, 'ºC'),
	(236635, 122, '2014-03-01 00:45:33.000000', 'temperatura', 1088.0000, 'ºC'),
	(236636, 122, '2014-03-01 00:45:34.000000', 'temperatura', 951.0000, 'ºC'),
	(236637, 122, '2014-03-01 00:45:35.000000', 'temperatura', 292.0000, 'ºC'),
	(236638, 122, '2014-03-01 00:45:36.000000', 'temperatura', 1007.0000, 'ºC'),
	(236639, 122, '2014-03-01 00:45:37.000000', 'temperatura', 559.0000, 'ºC'),
	(236640, 122, '2014-03-01 00:45:38.000000', 'temperatura', 975.0000, 'ºC'),
	(236641, 122, '2014-03-01 00:45:39.000000', 'temperatura', 798.0000, 'ºC'),
	(236642, 122, '2014-03-01 00:45:40.000000', 'temperatura', 1065.0000, 'ºC'),
	(236643, 122, '2014-03-01 00:45:41.000000', 'temperatura', 531.0000, 'ºC'),
	(236644, 122, '2014-03-01 00:45:42.000000', 'temperatura', 661.0000, 'ºC'),
	(236645, 122, '2014-03-01 00:45:43.000000', 'temperatura', 513.0000, 'ºC'),
	(236646, 122, '2014-03-01 00:45:44.000000', 'temperatura', 582.0000, 'ºC'),
	(236647, 122, '2014-03-01 00:45:45.000000', 'temperatura', 171.0000, 'ºC'),
	(236648, 122, '2014-03-01 00:45:46.000000', 'temperatura', 309.0000, 'ºC'),
	(236649, 122, '2014-03-01 00:45:47.000000', 'temperatura', 1035.0000, 'ºC'),
	(236650, 122, '2014-03-01 00:45:48.000000', 'temperatura', 645.0000, 'ºC'),
	(236651, 122, '2014-03-01 00:45:49.000000', 'temperatura', 123.0000, 'ºC'),
	(236652, 122, '2014-03-01 00:45:50.000000', 'temperatura', 1081.0000, 'ºC'),
	(236653, 122, '2014-03-01 00:45:51.000000', 'temperatura', 238.0000, 'ºC'),
	(236654, 122, '2014-03-01 00:45:52.000000', 'temperatura', 344.0000, 'ºC'),
	(236655, 122, '2014-03-01 00:45:53.000000', 'temperatura', 1007.0000, 'ºC'),
	(236656, 122, '2014-03-01 00:45:54.000000', 'temperatura', 404.0000, 'ºC'),
	(236657, 122, '2014-03-01 00:45:55.000000', 'temperatura', 199.0000, 'ºC'),
	(236658, 122, '2014-03-01 00:45:56.000000', 'temperatura', 983.0000, 'ºC'),
	(236659, 122, '2014-03-01 00:45:57.000000', 'temperatura', 719.0000, 'ºC'),
	(236660, 122, '2014-03-01 00:45:58.000000', 'temperatura', 648.0000, 'ºC'),
	(236661, 122, '2014-03-01 00:45:59.000000', 'temperatura', 1082.0000, 'ºC'),
	(236662, 122, '2014-03-01 00:46:00.000000', 'temperatura', 1066.0000, 'ºC'),
	(236663, 122, '2014-03-01 00:46:01.000000', 'temperatura', 883.0000, 'ºC'),
	(236664, 122, '2014-03-01 00:46:02.000000', 'temperatura', 19.0000, 'ºC'),
	(236665, 122, '2014-03-01 00:46:03.000000', 'temperatura', 1048.0000, 'ºC'),
	(236666, 122, '2014-03-01 00:46:04.000000', 'temperatura', 381.0000, 'ºC'),
	(236667, 122, '2014-03-01 00:46:05.000000', 'temperatura', 1162.0000, 'ºC'),
	(236668, 122, '2014-03-01 00:46:06.000000', 'temperatura', 1066.0000, 'ºC'),
	(236669, 122, '2014-03-01 00:46:07.000000', 'temperatura', 646.0000, 'ºC'),
	(236670, 122, '2014-03-01 00:46:08.000000', 'temperatura', 31.0000, 'ºC'),
	(236671, 122, '2014-03-01 00:46:09.000000', 'temperatura', 618.0000, 'ºC'),
	(236672, 122, '2014-03-01 00:46:10.000000', 'temperatura', 598.0000, 'ºC'),
	(236673, 122, '2014-03-01 00:46:11.000000', 'temperatura', 1137.0000, 'ºC'),
	(236674, 122, '2014-03-01 00:46:12.000000', 'temperatura', 289.0000, 'ºC'),
	(236675, 122, '2014-03-01 00:46:13.000000', 'temperatura', 436.0000, 'ºC'),
	(236676, 122, '2014-03-01 00:46:14.000000', 'temperatura', 115.0000, 'ºC'),
	(236677, 122, '2014-03-01 00:46:15.000000', 'temperatura', 465.0000, 'ºC'),
	(236678, 122, '2014-03-01 00:46:16.000000', 'temperatura', 780.0000, 'ºC'),
	(236679, 122, '2014-03-01 00:46:17.000000', 'temperatura', 105.0000, 'ºC'),
	(236680, 122, '2014-03-01 00:46:18.000000', 'temperatura', 586.0000, 'ºC'),
	(236681, 122, '2014-03-01 00:46:19.000000', 'temperatura', 215.0000, 'ºC'),
	(236682, 122, '2014-03-01 00:46:20.000000', 'temperatura', 517.0000, 'ºC'),
	(236683, 122, '2014-03-01 00:46:21.000000', 'temperatura', 741.0000, 'ºC'),
	(236684, 122, '2014-03-01 00:46:22.000000', 'temperatura', 956.0000, 'ºC'),
	(236685, 122, '2014-03-01 00:46:23.000000', 'temperatura', 155.0000, 'ºC'),
	(236686, 122, '2014-03-01 00:46:24.000000', 'temperatura', 307.0000, 'ºC'),
	(236687, 122, '2014-03-01 00:46:25.000000', 'temperatura', 1070.0000, 'ºC'),
	(236688, 122, '2014-03-01 00:46:26.000000', 'temperatura', 829.0000, 'ºC'),
	(236689, 122, '2014-03-01 00:46:27.000000', 'temperatura', 935.0000, 'ºC'),
	(236690, 122, '2014-03-01 00:46:28.000000', 'temperatura', 990.0000, 'ºC'),
	(236691, 122, '2014-03-01 00:46:29.000000', 'temperatura', 944.0000, 'ºC'),
	(236692, 122, '2014-03-01 00:46:30.000000', 'temperatura', 550.0000, 'ºC'),
	(236693, 122, '2014-03-01 00:46:31.000000', 'temperatura', 1121.0000, 'ºC'),
	(236694, 122, '2014-03-01 00:46:32.000000', 'temperatura', 354.0000, 'ºC'),
	(236695, 122, '2014-03-01 00:46:33.000000', 'temperatura', 807.0000, 'ºC'),
	(236696, 122, '2014-03-01 00:46:34.000000', 'temperatura', 574.0000, 'ºC'),
	(236697, 122, '2014-03-01 00:46:35.000000', 'temperatura', 451.0000, 'ºC'),
	(236698, 122, '2014-03-01 00:46:36.000000', 'temperatura', 533.0000, 'ºC'),
	(236699, 122, '2014-03-01 00:46:37.000000', 'temperatura', 114.0000, 'ºC'),
	(236700, 122, '2014-03-01 00:46:38.000000', 'temperatura', 171.0000, 'ºC'),
	(236701, 122, '2014-03-01 00:46:39.000000', 'temperatura', 512.0000, 'ºC'),
	(236702, 122, '2014-03-01 00:46:40.000000', 'temperatura', 848.0000, 'ºC'),
	(236703, 122, '2014-03-01 00:46:41.000000', 'temperatura', 303.0000, 'ºC'),
	(236704, 122, '2014-03-01 00:46:42.000000', 'temperatura', 174.0000, 'ºC'),
	(236705, 122, '2014-03-01 00:46:43.000000', 'temperatura', 1160.0000, 'ºC'),
	(236706, 122, '2014-03-01 00:46:44.000000', 'temperatura', 478.0000, 'ºC'),
	(236707, 122, '2014-03-01 00:46:45.000000', 'temperatura', 110.0000, 'ºC'),
	(236708, 122, '2014-03-01 00:46:46.000000', 'temperatura', 316.0000, 'ºC'),
	(236709, 122, '2014-03-01 00:46:47.000000', 'temperatura', 52.0000, 'ºC'),
	(236710, 122, '2014-03-01 00:46:48.000000', 'temperatura', 511.0000, 'ºC'),
	(236711, 122, '2014-03-01 00:46:49.000000', 'temperatura', 0.0000, 'ºC'),
	(236712, 122, '2014-03-01 00:46:50.000000', 'temperatura', 868.0000, 'ºC'),
	(236713, 122, '2014-03-01 00:46:51.000000', 'temperatura', 741.0000, 'ºC'),
	(236714, 122, '2014-03-01 00:46:52.000000', 'temperatura', 1099.0000, 'ºC'),
	(236715, 122, '2014-03-01 00:46:53.000000', 'temperatura', 874.0000, 'ºC'),
	(236716, 122, '2014-03-01 00:46:54.000000', 'temperatura', 1075.0000, 'ºC'),
	(236717, 122, '2014-03-01 00:46:55.000000', 'temperatura', 352.0000, 'ºC'),
	(236718, 122, '2014-03-01 00:46:56.000000', 'temperatura', 938.0000, 'ºC'),
	(236719, 122, '2014-03-01 00:46:57.000000', 'temperatura', 33.0000, 'ºC'),
	(236720, 122, '2014-03-01 00:46:58.000000', 'temperatura', 950.0000, 'ºC'),
	(236721, 122, '2014-03-01 00:46:59.000000', 'temperatura', 1052.0000, 'ºC'),
	(236722, 122, '2014-03-01 00:47:00.000000', 'temperatura', 10.0000, 'ºC'),
	(236723, 122, '2014-03-01 00:47:01.000000', 'temperatura', 494.0000, 'ºC'),
	(236724, 122, '2014-03-01 00:47:02.000000', 'temperatura', 39.0000, 'ºC'),
	(236725, 122, '2014-03-01 00:47:03.000000', 'temperatura', 1116.0000, 'ºC'),
	(236726, 122, '2014-03-01 00:47:04.000000', 'temperatura', 664.0000, 'ºC'),
	(236727, 122, '2014-03-01 00:47:05.000000', 'temperatura', 1170.0000, 'ºC'),
	(236728, 122, '2014-03-01 00:47:06.000000', 'temperatura', 261.0000, 'ºC'),
	(236729, 122, '2014-03-01 00:47:07.000000', 'temperatura', 194.0000, 'ºC'),
	(236730, 122, '2014-03-01 00:47:08.000000', 'temperatura', 186.0000, 'ºC'),
	(236731, 122, '2014-03-01 00:47:09.000000', 'temperatura', 349.0000, 'ºC'),
	(236732, 122, '2014-03-01 00:47:10.000000', 'temperatura', 1188.0000, 'ºC'),
	(236733, 122, '2014-03-01 00:47:11.000000', 'temperatura', 93.0000, 'ºC'),
	(236734, 122, '2014-03-01 00:47:12.000000', 'temperatura', 502.0000, 'ºC'),
	(236735, 122, '2014-03-01 00:47:13.000000', 'temperatura', 1032.0000, 'ºC'),
	(236736, 122, '2014-03-01 00:47:14.000000', 'temperatura', 54.0000, 'ºC'),
	(236737, 122, '2014-03-01 00:47:15.000000', 'temperatura', 776.0000, 'ºC'),
	(236738, 122, '2014-03-01 00:47:16.000000', 'temperatura', 116.0000, 'ºC'),
	(236739, 122, '2014-03-01 00:47:17.000000', 'temperatura', 655.0000, 'ºC'),
	(236740, 122, '2014-03-01 00:47:18.000000', 'temperatura', 527.0000, 'ºC'),
	(236741, 122, '2014-03-01 00:47:19.000000', 'temperatura', 668.0000, 'ºC'),
	(236742, 122, '2014-03-01 00:47:20.000000', 'temperatura', 563.0000, 'ºC'),
	(236743, 122, '2014-03-01 00:47:21.000000', 'temperatura', 808.0000, 'ºC'),
	(236744, 122, '2014-03-01 00:47:22.000000', 'temperatura', 1153.0000, 'ºC'),
	(236745, 122, '2014-03-01 00:47:23.000000', 'temperatura', 940.0000, 'ºC'),
	(236746, 122, '2014-03-01 00:47:24.000000', 'temperatura', 45.0000, 'ºC'),
	(236747, 122, '2014-03-01 00:47:25.000000', 'temperatura', 1002.0000, 'ºC'),
	(236748, 122, '2014-03-01 00:47:26.000000', 'temperatura', 77.0000, 'ºC'),
	(236749, 122, '2014-03-01 00:47:27.000000', 'temperatura', 979.0000, 'ºC'),
	(236750, 122, '2014-03-01 00:47:28.000000', 'temperatura', 1066.0000, 'ºC'),
	(236751, 122, '2014-03-01 00:47:29.000000', 'temperatura', 1193.0000, 'ºC'),
	(236752, 122, '2014-03-01 00:47:30.000000', 'temperatura', 365.0000, 'ºC'),
	(236753, 122, '2014-03-01 00:47:31.000000', 'temperatura', 649.0000, 'ºC'),
	(236754, 122, '2014-03-01 00:47:32.000000', 'temperatura', 950.0000, 'ºC'),
	(236755, 122, '2014-03-01 00:47:33.000000', 'temperatura', 401.0000, 'ºC'),
	(236756, 122, '2014-03-01 00:47:34.000000', 'temperatura', 358.0000, 'ºC'),
	(236757, 122, '2014-03-01 00:47:35.000000', 'temperatura', 588.0000, 'ºC'),
	(236758, 122, '2014-03-01 00:47:36.000000', 'temperatura', 665.0000, 'ºC'),
	(236759, 122, '2014-03-01 00:47:37.000000', 'temperatura', 364.0000, 'ºC'),
	(236760, 122, '2014-03-01 00:47:38.000000', 'temperatura', 1022.0000, 'ºC'),
	(236761, 122, '2014-03-01 00:47:39.000000', 'temperatura', 421.0000, 'ºC'),
	(236762, 122, '2014-03-01 00:47:40.000000', 'temperatura', 239.0000, 'ºC'),
	(236763, 122, '2014-03-01 00:47:41.000000', 'temperatura', 1131.0000, 'ºC'),
	(236764, 122, '2014-03-01 00:47:42.000000', 'temperatura', 141.0000, 'ºC'),
	(236765, 122, '2014-03-01 00:47:43.000000', 'temperatura', 911.0000, 'ºC'),
	(236766, 122, '2014-03-01 00:47:44.000000', 'temperatura', 532.0000, 'ºC'),
	(236767, 122, '2014-03-01 00:47:45.000000', 'temperatura', 1128.0000, 'ºC'),
	(236768, 122, '2014-03-01 00:47:46.000000', 'temperatura', 445.0000, 'ºC'),
	(236769, 122, '2014-03-01 00:47:47.000000', 'temperatura', 43.0000, 'ºC'),
	(236770, 122, '2014-03-01 00:47:48.000000', 'temperatura', 78.0000, 'ºC'),
	(236771, 122, '2014-03-01 00:47:49.000000', 'temperatura', 261.0000, 'ºC'),
	(236772, 122, '2014-03-01 00:47:50.000000', 'temperatura', 1072.0000, 'ºC'),
	(236773, 122, '2014-03-01 00:47:51.000000', 'temperatura', 977.0000, 'ºC'),
	(236774, 122, '2014-03-01 00:47:52.000000', 'temperatura', 471.0000, 'ºC'),
	(236775, 122, '2014-03-01 00:47:53.000000', 'temperatura', 624.0000, 'ºC'),
	(236776, 122, '2014-03-01 00:47:54.000000', 'temperatura', 506.0000, 'ºC'),
	(236777, 122, '2014-03-01 00:47:55.000000', 'temperatura', 659.0000, 'ºC'),
	(236778, 122, '2014-03-01 00:47:56.000000', 'temperatura', 577.0000, 'ºC'),
	(236779, 122, '2014-03-01 00:47:57.000000', 'temperatura', 908.0000, 'ºC'),
	(236780, 122, '2014-03-01 00:47:58.000000', 'temperatura', 411.0000, 'ºC'),
	(236781, 122, '2014-03-01 00:47:59.000000', 'temperatura', 529.0000, 'ºC'),
	(236782, 122, '2014-03-01 00:48:00.000000', 'temperatura', 214.0000, 'ºC'),
	(236783, 122, '2014-03-01 00:48:01.000000', 'temperatura', 685.0000, 'ºC'),
	(236784, 122, '2014-03-01 00:48:02.000000', 'temperatura', 381.0000, 'ºC'),
	(236785, 122, '2014-03-01 00:48:03.000000', 'temperatura', 1050.0000, 'ºC'),
	(236786, 122, '2014-03-01 00:48:04.000000', 'temperatura', 508.0000, 'ºC'),
	(236787, 122, '2014-03-01 00:48:05.000000', 'temperatura', 590.0000, 'ºC'),
	(236788, 122, '2014-03-01 00:48:06.000000', 'temperatura', 226.0000, 'ºC'),
	(236789, 122, '2014-03-01 00:48:07.000000', 'temperatura', 562.0000, 'ºC'),
	(236790, 122, '2014-03-01 00:48:08.000000', 'temperatura', 933.0000, 'ºC'),
	(236791, 122, '2014-03-01 00:48:09.000000', 'temperatura', 579.0000, 'ºC'),
	(236792, 122, '2014-03-01 00:48:10.000000', 'temperatura', 94.0000, 'ºC'),
	(236793, 122, '2014-03-01 00:48:11.000000', 'temperatura', 1137.0000, 'ºC'),
	(236794, 122, '2014-03-01 00:48:12.000000', 'temperatura', 602.0000, 'ºC'),
	(236795, 122, '2014-03-01 00:48:13.000000', 'temperatura', 801.0000, 'ºC'),
	(236796, 122, '2014-03-01 00:48:14.000000', 'temperatura', 997.0000, 'ºC'),
	(236797, 122, '2014-03-01 00:48:15.000000', 'temperatura', 183.0000, 'ºC'),
	(236798, 122, '2014-03-01 00:48:16.000000', 'temperatura', 326.0000, 'ºC'),
	(236799, 122, '2014-03-01 00:48:17.000000', 'temperatura', 1082.0000, 'ºC'),
	(236800, 122, '2014-03-01 00:48:18.000000', 'temperatura', 830.0000, 'ºC'),
	(236801, 122, '2014-03-01 00:48:19.000000', 'temperatura', 907.0000, 'ºC'),
	(236802, 122, '2014-03-01 00:48:20.000000', 'temperatura', 843.0000, 'ºC'),
	(236803, 122, '2014-03-01 00:48:21.000000', 'temperatura', 294.0000, 'ºC'),
	(236804, 122, '2014-03-01 00:48:22.000000', 'temperatura', 142.0000, 'ºC'),
	(236805, 122, '2014-03-01 00:48:23.000000', 'temperatura', 1027.0000, 'ºC'),
	(236806, 122, '2014-03-01 00:48:24.000000', 'temperatura', 1112.0000, 'ºC'),
	(236807, 122, '2014-03-01 00:48:25.000000', 'temperatura', 77.0000, 'ºC'),
	(236808, 122, '2014-03-01 00:48:26.000000', 'temperatura', 653.0000, 'ºC'),
	(236809, 122, '2014-03-01 00:48:27.000000', 'temperatura', 631.0000, 'ºC'),
	(236810, 122, '2014-03-01 00:48:28.000000', 'temperatura', 1197.0000, 'ºC'),
	(236811, 122, '2014-03-01 00:48:29.000000', 'temperatura', 492.0000, 'ºC'),
	(236812, 122, '2014-03-01 00:48:30.000000', 'temperatura', 71.0000, 'ºC'),
	(236813, 122, '2014-03-01 00:48:31.000000', 'temperatura', 78.0000, 'ºC'),
	(236814, 122, '2014-03-01 00:48:32.000000', 'temperatura', 178.0000, 'ºC'),
	(236815, 122, '2014-03-01 00:48:33.000000', 'temperatura', 655.0000, 'ºC'),
	(236816, 122, '2014-03-01 00:48:34.000000', 'temperatura', 341.0000, 'ºC'),
	(236817, 122, '2014-03-01 00:48:35.000000', 'temperatura', 942.0000, 'ºC'),
	(236818, 122, '2014-03-01 00:48:36.000000', 'temperatura', 89.0000, 'ºC'),
	(236819, 122, '2014-03-01 00:48:37.000000', 'temperatura', 20.0000, 'ºC'),
	(236820, 122, '2014-03-01 00:48:38.000000', 'temperatura', 1031.0000, 'ºC'),
	(236821, 122, '2014-03-01 00:48:39.000000', 'temperatura', 297.0000, 'ºC'),
	(236822, 122, '2014-03-01 00:48:40.000000', 'temperatura', 790.0000, 'ºC'),
	(236823, 122, '2014-03-01 00:48:41.000000', 'temperatura', 663.0000, 'ºC'),
	(236824, 122, '2014-03-01 00:48:42.000000', 'temperatura', 943.0000, 'ºC'),
	(236825, 122, '2014-03-01 00:48:43.000000', 'temperatura', 326.0000, 'ºC'),
	(236826, 122, '2014-03-01 00:48:44.000000', 'temperatura', 2.0000, 'ºC'),
	(236827, 122, '2014-03-01 00:48:45.000000', 'temperatura', 231.0000, 'ºC'),
	(236828, 122, '2014-03-01 00:48:46.000000', 'temperatura', 1152.0000, 'ºC'),
	(236829, 122, '2014-03-01 00:48:47.000000', 'temperatura', 266.0000, 'ºC'),
	(236830, 122, '2014-03-01 00:48:48.000000', 'temperatura', 273.0000, 'ºC'),
	(236831, 122, '2014-03-01 00:48:49.000000', 'temperatura', 569.0000, 'ºC'),
	(236832, 122, '2014-03-01 00:48:50.000000', 'temperatura', 824.0000, 'ºC'),
	(236833, 122, '2014-03-01 00:48:51.000000', 'temperatura', 16.0000, 'ºC'),
	(236834, 122, '2014-03-01 00:48:52.000000', 'temperatura', 10.0000, 'ºC'),
	(236835, 122, '2014-03-01 00:48:53.000000', 'temperatura', 0.0000, 'ºC'),
	(236836, 122, '2014-03-01 00:48:54.000000', 'temperatura', 1173.0000, 'ºC'),
	(236837, 122, '2014-03-01 00:48:55.000000', 'temperatura', 1065.0000, 'ºC'),
	(236838, 122, '2014-03-01 00:48:56.000000', 'temperatura', 607.0000, 'ºC'),
	(236839, 122, '2014-03-01 00:48:57.000000', 'temperatura', 1041.0000, 'ºC'),
	(236840, 122, '2014-03-01 00:48:58.000000', 'temperatura', 982.0000, 'ºC'),
	(236841, 122, '2014-03-01 00:48:59.000000', 'temperatura', 590.0000, 'ºC'),
	(236842, 122, '2014-03-01 00:49:00.000000', 'temperatura', 5.0000, 'ºC'),
	(236843, 122, '2014-03-01 00:49:01.000000', 'temperatura', 654.0000, 'ºC'),
	(236844, 122, '2014-03-01 00:49:02.000000', 'temperatura', 856.0000, 'ºC'),
	(236845, 122, '2014-03-01 00:49:03.000000', 'temperatura', 1120.0000, 'ºC'),
	(236846, 122, '2014-03-01 00:49:04.000000', 'temperatura', 632.0000, 'ºC'),
	(236847, 122, '2014-03-01 00:49:05.000000', 'temperatura', 1000.0000, 'ºC'),
	(236848, 122, '2014-03-01 00:49:06.000000', 'temperatura', 702.0000, 'ºC'),
	(236849, 122, '2014-03-01 00:49:07.000000', 'temperatura', 514.0000, 'ºC'),
	(236850, 122, '2014-03-01 00:49:08.000000', 'temperatura', 464.0000, 'ºC'),
	(236851, 122, '2014-03-01 00:49:09.000000', 'temperatura', 778.0000, 'ºC'),
	(236852, 122, '2014-03-01 00:49:10.000000', 'temperatura', 100.0000, 'ºC'),
	(236853, 122, '2014-03-01 00:49:11.000000', 'temperatura', 564.0000, 'ºC'),
	(236854, 122, '2014-03-01 00:49:12.000000', 'temperatura', 123.0000, 'ºC'),
	(236855, 122, '2014-03-01 00:49:13.000000', 'temperatura', 123.0000, 'ºC'),
	(236856, 122, '2014-03-01 00:49:14.000000', 'temperatura', 248.0000, 'ºC'),
	(236857, 122, '2014-03-01 00:49:15.000000', 'temperatura', 871.0000, 'ºC'),
	(236858, 122, '2014-03-01 00:49:16.000000', 'temperatura', 11.0000, 'ºC'),
	(236859, 122, '2014-03-01 00:49:17.000000', 'temperatura', 1042.0000, 'ºC'),
	(236860, 122, '2014-03-01 00:49:18.000000', 'temperatura', 380.0000, 'ºC'),
	(236861, 122, '2014-03-01 00:49:19.000000', 'temperatura', 1173.0000, 'ºC'),
	(236862, 122, '2014-03-01 00:49:20.000000', 'temperatura', 1123.0000, 'ºC'),
	(236863, 122, '2014-03-01 00:49:21.000000', 'temperatura', 900.0000, 'ºC'),
	(236864, 122, '2014-03-01 00:49:22.000000', 'temperatura', 1131.0000, 'ºC'),
	(236865, 122, '2014-03-01 00:49:23.000000', 'temperatura', 556.0000, 'ºC'),
	(236866, 122, '2014-03-01 00:49:24.000000', 'temperatura', 586.0000, 'ºC'),
	(236867, 122, '2014-03-01 00:49:25.000000', 'temperatura', 64.0000, 'ºC'),
	(236868, 122, '2014-03-01 00:49:26.000000', 'temperatura', 960.0000, 'ºC'),
	(236869, 122, '2014-03-01 00:49:27.000000', 'temperatura', 1009.0000, 'ºC'),
	(236870, 122, '2014-03-01 00:49:28.000000', 'temperatura', 966.0000, 'ºC'),
	(236871, 122, '2014-03-01 00:49:29.000000', 'temperatura', 605.0000, 'ºC'),
	(236872, 122, '2014-03-01 00:49:30.000000', 'temperatura', 124.0000, 'ºC'),
	(236873, 122, '2014-03-01 00:49:31.000000', 'temperatura', 9.0000, 'ºC'),
	(236874, 122, '2014-03-01 00:49:32.000000', 'temperatura', 873.0000, 'ºC'),
	(236875, 122, '2014-03-01 00:49:33.000000', 'temperatura', 736.0000, 'ºC'),
	(236876, 122, '2014-03-01 00:49:34.000000', 'temperatura', 1065.0000, 'ºC'),
	(236877, 122, '2014-03-01 00:49:35.000000', 'temperatura', 715.0000, 'ºC'),
	(236878, 122, '2014-03-01 00:49:36.000000', 'temperatura', 383.0000, 'ºC'),
	(236879, 122, '2014-03-01 00:49:37.000000', 'temperatura', 968.0000, 'ºC'),
	(236880, 122, '2014-03-01 00:49:38.000000', 'temperatura', 94.0000, 'ºC'),
	(236881, 122, '2014-03-01 00:49:39.000000', 'temperatura', 1167.0000, 'ºC'),
	(236882, 122, '2014-03-01 00:49:40.000000', 'temperatura', 753.0000, 'ºC'),
	(236883, 122, '2014-03-01 00:49:41.000000', 'temperatura', 265.0000, 'ºC'),
	(236884, 122, '2014-03-01 00:49:42.000000', 'temperatura', 264.0000, 'ºC'),
	(236885, 122, '2014-03-01 00:49:43.000000', 'temperatura', 527.0000, 'ºC'),
	(236886, 122, '2014-03-01 00:49:44.000000', 'temperatura', 643.0000, 'ºC'),
	(236887, 122, '2014-03-01 00:49:45.000000', 'temperatura', 434.0000, 'ºC'),
	(236888, 122, '2014-03-01 00:49:46.000000', 'temperatura', 242.0000, 'ºC'),
	(236889, 122, '2014-03-01 00:49:47.000000', 'temperatura', 1110.0000, 'ºC'),
	(236890, 122, '2014-03-01 00:49:48.000000', 'temperatura', 22.0000, 'ºC'),
	(236891, 122, '2014-03-01 00:49:49.000000', 'temperatura', 382.0000, 'ºC'),
	(236892, 122, '2014-03-01 00:49:50.000000', 'temperatura', 645.0000, 'ºC'),
	(236893, 122, '2014-03-01 00:49:51.000000', 'temperatura', 880.0000, 'ºC'),
	(236894, 122, '2014-03-01 00:49:52.000000', 'temperatura', 66.0000, 'ºC'),
	(236895, 122, '2014-03-01 00:49:53.000000', 'temperatura', 92.0000, 'ºC'),
	(236896, 122, '2014-03-01 00:49:54.000000', 'temperatura', 259.0000, 'ºC'),
	(236897, 122, '2014-03-01 00:49:55.000000', 'temperatura', 1020.0000, 'ºC'),
	(236898, 122, '2014-03-01 00:49:56.000000', 'temperatura', 724.0000, 'ºC'),
	(236899, 122, '2014-03-01 00:49:57.000000', 'temperatura', 561.0000, 'ºC'),
	(236900, 122, '2014-03-01 00:49:58.000000', 'temperatura', 635.0000, 'ºC'),
	(236901, 122, '2014-03-01 00:49:59.000000', 'temperatura', 290.0000, 'ºC'),
	(236902, 122, '2014-03-01 00:50:00.000000', 'temperatura', 746.0000, 'ºC'),
	(236903, 122, '2014-03-01 00:50:01.000000', 'temperatura', 460.0000, 'ºC'),
	(236904, 122, '2014-03-01 00:50:02.000000', 'temperatura', 64.0000, 'ºC'),
	(236905, 122, '2014-03-01 00:50:03.000000', 'temperatura', 141.0000, 'ºC'),
	(236906, 122, '2014-03-01 00:50:04.000000', 'temperatura', 514.0000, 'ºC'),
	(236907, 122, '2014-03-01 00:50:05.000000', 'temperatura', 945.0000, 'ºC'),
	(236908, 122, '2014-03-01 00:50:06.000000', 'temperatura', 783.0000, 'ºC'),
	(236909, 122, '2014-03-01 00:50:07.000000', 'temperatura', 1083.0000, 'ºC'),
	(236910, 122, '2014-03-01 00:50:08.000000', 'temperatura', 666.0000, 'ºC'),
	(236911, 122, '2014-03-01 00:50:09.000000', 'temperatura', 82.0000, 'ºC'),
	(236912, 122, '2014-03-01 00:50:10.000000', 'temperatura', 812.0000, 'ºC'),
	(236913, 122, '2014-03-01 00:50:11.000000', 'temperatura', 215.0000, 'ºC'),
	(236914, 122, '2014-03-01 00:50:12.000000', 'temperatura', 1040.0000, 'ºC'),
	(236915, 122, '2014-03-01 00:50:13.000000', 'temperatura', 953.0000, 'ºC'),
	(236916, 122, '2014-03-01 00:50:14.000000', 'temperatura', 447.0000, 'ºC'),
	(236917, 122, '2014-03-01 00:50:15.000000', 'temperatura', 577.0000, 'ºC'),
	(236918, 122, '2014-03-01 00:50:16.000000', 'temperatura', 343.0000, 'ºC'),
	(236919, 122, '2014-03-01 00:50:17.000000', 'temperatura', 1186.0000, 'ºC'),
	(236920, 122, '2014-03-01 00:50:18.000000', 'temperatura', 101.0000, 'ºC'),
	(236921, 122, '2014-03-01 00:50:19.000000', 'temperatura', 547.0000, 'ºC'),
	(236922, 122, '2014-03-01 00:50:20.000000', 'temperatura', 34.0000, 'ºC'),
	(236923, 122, '2014-03-01 00:50:21.000000', 'temperatura', 928.0000, 'ºC'),
	(236924, 122, '2014-03-01 00:50:22.000000', 'temperatura', 940.0000, 'ºC'),
	(236925, 122, '2014-03-01 00:50:23.000000', 'temperatura', 718.0000, 'ºC'),
	(236926, 122, '2014-03-01 00:50:24.000000', 'temperatura', 767.0000, 'ºC'),
	(236927, 122, '2014-03-01 00:50:25.000000', 'temperatura', 485.0000, 'ºC'),
	(236928, 122, '2014-03-01 00:50:26.000000', 'temperatura', 121.0000, 'ºC'),
	(236929, 122, '2014-03-01 00:50:27.000000', 'temperatura', 352.0000, 'ºC'),
	(236930, 122, '2014-03-01 00:50:28.000000', 'temperatura', 198.0000, 'ºC'),
	(236931, 122, '2014-03-01 00:50:29.000000', 'temperatura', 1135.0000, 'ºC'),
	(236932, 122, '2014-03-01 00:50:30.000000', 'temperatura', 280.0000, 'ºC'),
	(236933, 122, '2014-03-01 00:50:31.000000', 'temperatura', 397.0000, 'ºC'),
	(236934, 122, '2014-03-01 00:50:32.000000', 'temperatura', 1145.0000, 'ºC'),
	(236935, 122, '2014-03-01 00:50:33.000000', 'temperatura', 933.0000, 'ºC'),
	(236936, 122, '2014-03-01 00:50:34.000000', 'temperatura', 30.0000, 'ºC'),
	(236937, 122, '2014-03-01 00:50:35.000000', 'temperatura', 953.0000, 'ºC'),
	(236938, 122, '2014-03-01 00:50:36.000000', 'temperatura', 1076.0000, 'ºC'),
	(236939, 122, '2014-03-01 00:50:37.000000', 'temperatura', 123.0000, 'ºC'),
	(236940, 122, '2014-03-01 00:50:38.000000', 'temperatura', 986.0000, 'ºC'),
	(236941, 122, '2014-03-01 00:50:39.000000', 'temperatura', 963.0000, 'ºC'),
	(236942, 122, '2014-03-01 00:50:40.000000', 'temperatura', 656.0000, 'ºC'),
	(236943, 122, '2014-03-01 00:50:41.000000', 'temperatura', 390.0000, 'ºC'),
	(236944, 122, '2014-03-01 00:50:42.000000', 'temperatura', 1184.0000, 'ºC'),
	(236945, 122, '2014-03-01 00:50:43.000000', 'temperatura', 1152.0000, 'ºC'),
	(236946, 122, '2014-03-01 00:50:44.000000', 'temperatura', 1008.0000, 'ºC'),
	(236947, 122, '2014-03-01 00:50:45.000000', 'temperatura', 385.0000, 'ºC'),
	(236948, 122, '2014-03-01 00:50:46.000000', 'temperatura', 99.0000, 'ºC'),
	(236949, 122, '2014-03-01 00:50:47.000000', 'temperatura', 541.0000, 'ºC'),
	(236950, 122, '2014-03-01 00:50:48.000000', 'temperatura', 10.0000, 'ºC'),
	(236951, 122, '2014-03-01 00:50:49.000000', 'temperatura', 826.0000, 'ºC'),
	(236952, 122, '2014-03-01 00:50:50.000000', 'temperatura', 502.0000, 'ºC'),
	(236953, 122, '2014-03-01 00:50:51.000000', 'temperatura', 33.0000, 'ºC'),
	(236954, 122, '2014-03-01 00:50:52.000000', 'temperatura', 1059.0000, 'ºC'),
	(236955, 122, '2014-03-01 00:50:53.000000', 'temperatura', 398.0000, 'ºC'),
	(236956, 122, '2014-03-01 00:50:54.000000', 'temperatura', 10.0000, 'ºC'),
	(236957, 122, '2014-03-01 00:50:55.000000', 'temperatura', 60.0000, 'ºC'),
	(236958, 122, '2014-03-01 00:50:56.000000', 'temperatura', 269.0000, 'ºC'),
	(236959, 122, '2014-03-01 00:50:57.000000', 'temperatura', 1166.0000, 'ºC'),
	(236960, 122, '2014-03-01 00:50:58.000000', 'temperatura', 222.0000, 'ºC'),
	(236961, 122, '2014-03-01 00:50:59.000000', 'temperatura', 13.0000, 'ºC'),
	(236962, 122, '2014-03-01 00:51:00.000000', 'temperatura', 602.0000, 'ºC'),
	(236963, 122, '2014-03-01 00:51:01.000000', 'temperatura', 569.0000, 'ºC'),
	(236964, 122, '2014-03-01 00:51:02.000000', 'temperatura', 1039.0000, 'ºC'),
	(236965, 122, '2014-03-01 00:51:03.000000', 'temperatura', 1090.0000, 'ºC'),
	(236966, 122, '2014-03-01 00:51:04.000000', 'temperatura', 1134.0000, 'ºC'),
	(236967, 122, '2014-03-01 00:51:05.000000', 'temperatura', 1.0000, 'ºC'),
	(236968, 122, '2014-03-01 00:51:06.000000', 'temperatura', 204.0000, 'ºC'),
	(236969, 122, '2014-03-01 00:51:07.000000', 'temperatura', 1018.0000, 'ºC'),
	(236970, 122, '2014-03-01 00:51:08.000000', 'temperatura', 878.0000, 'ºC'),
	(236971, 122, '2014-03-01 00:51:09.000000', 'temperatura', 136.0000, 'ºC'),
	(236972, 122, '2014-03-01 00:51:10.000000', 'temperatura', 446.0000, 'ºC'),
	(236973, 122, '2014-03-01 00:51:11.000000', 'temperatura', 623.0000, 'ºC'),
	(236974, 122, '2014-03-01 00:51:12.000000', 'temperatura', 579.0000, 'ºC'),
	(236975, 122, '2014-03-01 00:51:13.000000', 'temperatura', 1026.0000, 'ºC'),
	(236976, 122, '2014-03-01 00:51:14.000000', 'temperatura', 993.0000, 'ºC'),
	(236977, 122, '2014-03-01 00:51:15.000000', 'temperatura', 688.0000, 'ºC'),
	(236978, 122, '2014-03-01 00:51:16.000000', 'temperatura', 462.0000, 'ºC'),
	(236979, 122, '2014-03-01 00:51:17.000000', 'temperatura', 248.0000, 'ºC'),
	(236980, 122, '2014-03-01 00:51:18.000000', 'temperatura', 1053.0000, 'ºC'),
	(236981, 122, '2014-03-01 00:51:19.000000', 'temperatura', 923.0000, 'ºC'),
	(236982, 122, '2014-03-01 00:51:20.000000', 'temperatura', 256.0000, 'ºC'),
	(236983, 122, '2014-03-01 00:51:21.000000', 'temperatura', 913.0000, 'ºC'),
	(236984, 122, '2014-03-01 00:51:22.000000', 'temperatura', 197.0000, 'ºC'),
	(236985, 122, '2014-03-01 00:51:23.000000', 'temperatura', 647.0000, 'ºC'),
	(236986, 122, '2014-03-01 00:51:24.000000', 'temperatura', 244.0000, 'ºC'),
	(236987, 122, '2014-03-01 00:51:25.000000', 'temperatura', 481.0000, 'ºC'),
	(236988, 122, '2014-03-01 00:51:26.000000', 'temperatura', 473.0000, 'ºC'),
	(236989, 122, '2014-03-01 00:51:27.000000', 'temperatura', 920.0000, 'ºC'),
	(236990, 122, '2014-03-01 00:51:28.000000', 'temperatura', 783.0000, 'ºC'),
	(236991, 122, '2014-03-01 00:51:29.000000', 'temperatura', 1158.0000, 'ºC'),
	(236992, 122, '2014-03-01 00:51:30.000000', 'temperatura', 1038.0000, 'ºC'),
	(236993, 122, '2014-03-01 00:51:31.000000', 'temperatura', 517.0000, 'ºC'),
	(236994, 122, '2014-03-01 00:51:32.000000', 'temperatura', 672.0000, 'ºC'),
	(236995, 122, '2014-03-01 00:51:33.000000', 'temperatura', 611.0000, 'ºC'),
	(236996, 122, '2014-03-01 00:51:34.000000', 'temperatura', 1040.0000, 'ºC'),
	(236997, 122, '2014-03-01 00:51:35.000000', 'temperatura', 965.0000, 'ºC'),
	(236998, 122, '2014-03-01 00:51:36.000000', 'temperatura', 507.0000, 'ºC'),
	(236999, 122, '2014-03-01 00:51:37.000000', 'temperatura', 838.0000, 'ºC'),
	(237000, 122, '2014-03-01 00:51:38.000000', 'temperatura', 273.0000, 'ºC'),
	(237001, 122, '2014-03-01 00:51:39.000000', 'temperatura', 50.0000, 'ºC'),
	(237002, 122, '2014-03-01 00:51:40.000000', 'temperatura', 631.0000, 'ºC'),
	(237003, 122, '2014-03-01 00:51:41.000000', 'temperatura', 606.0000, 'ºC'),
	(237004, 122, '2014-03-01 00:51:42.000000', 'temperatura', 1136.0000, 'ºC'),
	(237005, 122, '2014-03-01 00:51:43.000000', 'temperatura', 263.0000, 'ºC'),
	(237006, 122, '2014-03-01 00:51:44.000000', 'temperatura', 309.0000, 'ºC'),
	(237007, 122, '2014-03-01 00:51:45.000000', 'temperatura', 756.0000, 'ºC'),
	(237008, 122, '2014-03-01 00:51:46.000000', 'temperatura', 453.0000, 'ºC'),
	(237009, 122, '2014-03-01 00:51:47.000000', 'temperatura', 0.0000, 'ºC'),
	(237010, 122, '2014-03-01 00:51:48.000000', 'temperatura', 1038.0000, 'ºC'),
	(237011, 122, '2014-03-01 00:51:49.000000', 'temperatura', 392.0000, 'ºC'),
	(237012, 122, '2014-03-01 00:51:50.000000', 'temperatura', 45.0000, 'ºC'),
	(237013, 122, '2014-03-01 00:51:51.000000', 'temperatura', 250.0000, 'ºC'),
	(237014, 122, '2014-03-01 00:51:52.000000', 'temperatura', 1117.0000, 'ºC'),
	(237015, 122, '2014-03-01 00:51:53.000000', 'temperatura', 34.0000, 'ºC'),
	(237016, 122, '2014-03-01 00:51:54.000000', 'temperatura', 418.0000, 'ºC'),
	(237017, 122, '2014-03-01 00:51:55.000000', 'temperatura', 791.0000, 'ºC'),
	(237018, 122, '2014-03-01 00:51:56.000000', 'temperatura', 301.0000, 'ºC'),
	(237019, 122, '2014-03-01 00:51:57.000000', 'temperatura', 334.0000, 'ºC'),
	(237020, 122, '2014-03-01 00:51:58.000000', 'temperatura', 767.0000, 'ºC'),
	(237021, 122, '2014-03-01 00:51:59.000000', 'temperatura', 433.0000, 'ºC'),
	(237022, 122, '2014-03-01 00:52:00.000000', 'temperatura', 1066.0000, 'ºC'),
	(237023, 122, '2014-03-01 00:52:01.000000', 'temperatura', 429.0000, 'ºC'),
	(237024, 122, '2014-03-01 00:52:02.000000', 'temperatura', 150.0000, 'ºC'),
	(237025, 122, '2014-03-01 00:52:03.000000', 'temperatura', 665.0000, 'ºC'),
	(237026, 122, '2014-03-01 00:52:04.000000', 'temperatura', 472.0000, 'ºC'),
	(237027, 122, '2014-03-01 00:52:05.000000', 'temperatura', 365.0000, 'ºC'),
	(237028, 122, '2014-03-01 00:52:06.000000', 'temperatura', 411.0000, 'ºC'),
	(237029, 122, '2014-03-01 00:52:07.000000', 'temperatura', 961.0000, 'ºC'),
	(237030, 122, '2014-03-01 00:52:08.000000', 'temperatura', 1172.0000, 'ºC'),
	(237031, 122, '2014-03-01 00:52:09.000000', 'temperatura', 578.0000, 'ºC'),
	(237032, 122, '2014-03-01 00:52:10.000000', 'temperatura', 575.0000, 'ºC'),
	(237033, 122, '2014-03-01 00:52:11.000000', 'temperatura', 1139.0000, 'ºC'),
	(237034, 122, '2014-03-01 00:52:12.000000', 'temperatura', 372.0000, 'ºC'),
	(237035, 122, '2014-03-01 00:52:13.000000', 'temperatura', 841.0000, 'ºC'),
	(237036, 122, '2014-03-01 00:52:14.000000', 'temperatura', 693.0000, 'ºC'),
	(237037, 122, '2014-03-01 00:52:15.000000', 'temperatura', 940.0000, 'ºC'),
	(237038, 122, '2014-03-01 00:52:16.000000', 'temperatura', 220.0000, 'ºC'),
	(237039, 122, '2014-03-01 00:52:17.000000', 'temperatura', 684.0000, 'ºC'),
	(237040, 122, '2014-03-01 00:52:18.000000', 'temperatura', 359.0000, 'ºC'),
	(237041, 122, '2014-03-01 00:52:19.000000', 'temperatura', 945.0000, 'ºC'),
	(237042, 122, '2014-03-01 00:52:20.000000', 'temperatura', 49.0000, 'ºC'),
	(237043, 122, '2014-03-01 00:52:21.000000', 'temperatura', 1009.0000, 'ºC'),
	(237044, 122, '2014-03-01 00:52:22.000000', 'temperatura', 101.0000, 'ºC'),
	(237045, 122, '2014-03-01 00:52:23.000000', 'temperatura', 1076.0000, 'ºC'),
	(237046, 122, '2014-03-01 00:52:24.000000', 'temperatura', 277.0000, 'ºC'),
	(237047, 122, '2014-03-01 00:52:25.000000', 'temperatura', 560.0000, 'ºC'),
	(237048, 122, '2014-03-01 00:52:26.000000', 'temperatura', 767.0000, 'ºC'),
	(237049, 122, '2014-03-01 00:52:27.000000', 'temperatura', 956.0000, 'ºC'),
	(237050, 122, '2014-03-01 00:52:28.000000', 'temperatura', 78.0000, 'ºC'),
	(237051, 122, '2014-03-01 00:52:29.000000', 'temperatura', 1124.0000, 'ºC'),
	(237052, 122, '2014-03-01 00:52:30.000000', 'temperatura', 586.0000, 'ºC'),
	(237053, 122, '2014-03-01 00:52:31.000000', 'temperatura', 759.0000, 'ºC'),
	(237054, 122, '2014-03-01 00:52:32.000000', 'temperatura', 837.0000, 'ºC'),
	(237055, 122, '2014-03-01 00:52:33.000000', 'temperatura', 710.0000, 'ºC'),
	(237056, 122, '2014-03-01 00:52:34.000000', 'temperatura', 1039.0000, 'ºC'),
	(237057, 122, '2014-03-01 00:52:35.000000', 'temperatura', 665.0000, 'ºC'),
	(237058, 122, '2014-03-01 00:52:36.000000', 'temperatura', 210.0000, 'ºC'),
	(237059, 122, '2014-03-01 00:52:37.000000', 'temperatura', 253.0000, 'ºC'),
	(237060, 122, '2014-03-01 00:52:38.000000', 'temperatura', 638.0000, 'ºC'),
	(237061, 122, '2014-03-01 00:52:39.000000', 'temperatura', 30.0000, 'ºC'),
	(237062, 122, '2014-03-01 00:52:40.000000', 'temperatura', 635.0000, 'ºC'),
	(237063, 122, '2014-03-01 00:52:41.000000', 'temperatura', 687.0000, 'ºC'),
	(237064, 122, '2014-03-01 00:52:42.000000', 'temperatura', 331.0000, 'ºC'),
	(237065, 122, '2014-03-01 00:52:43.000000', 'temperatura', 794.0000, 'ºC'),
	(237066, 122, '2014-03-01 00:52:44.000000', 'temperatura', 577.0000, 'ºC'),
	(237067, 122, '2014-03-01 00:52:45.000000', 'temperatura', 506.0000, 'ºC'),
	(237068, 122, '2014-03-01 00:52:46.000000', 'temperatura', 796.0000, 'ºC'),
	(237069, 122, '2014-03-01 00:52:47.000000', 'temperatura', 66.0000, 'ºC'),
	(237070, 122, '2014-03-01 00:52:48.000000', 'temperatura', 341.0000, 'ºC'),
	(237071, 122, '2014-03-01 00:52:49.000000', 'temperatura', 308.0000, 'ºC'),
	(237072, 122, '2014-03-01 00:52:50.000000', 'temperatura', 519.0000, 'ºC'),
	(237073, 122, '2014-03-01 00:52:51.000000', 'temperatura', 469.0000, 'ºC'),
	(237074, 122, '2014-03-01 00:52:52.000000', 'temperatura', 787.0000, 'ºC'),
	(237075, 122, '2014-03-01 00:52:53.000000', 'temperatura', 132.0000, 'ºC'),
	(237076, 122, '2014-03-01 00:52:54.000000', 'temperatura', 699.0000, 'ºC'),
	(237077, 122, '2014-03-01 00:52:55.000000', 'temperatura', 700.0000, 'ºC'),
	(237078, 122, '2014-03-01 00:52:56.000000', 'temperatura', 203.0000, 'ºC'),
	(237079, 122, '2014-03-01 00:52:57.000000', 'temperatura', 114.0000, 'ºC'),
	(237080, 122, '2014-03-01 00:52:58.000000', 'temperatura', 1164.0000, 'ºC'),
	(237081, 122, '2014-03-01 00:52:59.000000', 'temperatura', 677.0000, 'ºC'),
	(237082, 122, '2014-03-01 00:53:00.000000', 'temperatura', 1092.0000, 'ºC'),
	(237083, 122, '2014-03-01 00:53:01.000000', 'temperatura', 1031.0000, 'ºC'),
	(237084, 122, '2014-03-01 00:53:02.000000', 'temperatura', 680.0000, 'ºC'),
	(237085, 122, '2014-03-01 00:53:03.000000', 'temperatura', 309.0000, 'ºC'),
	(237086, 122, '2014-03-01 00:53:04.000000', 'temperatura', 704.0000, 'ºC'),
	(237087, 122, '2014-03-01 00:53:05.000000', 'temperatura', 192.0000, 'ºC'),
	(237088, 122, '2014-03-01 00:53:06.000000', 'temperatura', 51.0000, 'ºC'),
	(237089, 122, '2014-03-01 00:53:07.000000', 'temperatura', 877.0000, 'ºC'),
	(237090, 122, '2014-03-01 00:53:08.000000', 'temperatura', 636.0000, 'ºC'),
	(237091, 122, '2014-03-01 00:53:09.000000', 'temperatura', 546.0000, 'ºC'),
	(237092, 122, '2014-03-01 00:53:10.000000', 'temperatura', 825.0000, 'ºC'),
	(237093, 122, '2014-03-01 00:53:11.000000', 'temperatura', 86.0000, 'ºC'),
	(237094, 122, '2014-03-01 00:53:12.000000', 'temperatura', 357.0000, 'ºC'),
	(237095, 122, '2014-03-01 00:53:13.000000', 'temperatura', 326.0000, 'ºC'),
	(237096, 122, '2014-03-01 00:53:14.000000', 'temperatura', 558.0000, 'ºC'),
	(237097, 122, '2014-03-01 00:53:15.000000', 'temperatura', 616.0000, 'ºC'),
	(237098, 122, '2014-03-01 00:53:16.000000', 'temperatura', 204.0000, 'ºC'),
	(237099, 122, '2014-03-01 00:53:17.000000', 'temperatura', 374.0000, 'ºC'),
	(237100, 122, '2014-03-01 00:53:18.000000', 'temperatura', 56.0000, 'ºC'),
	(237101, 122, '2014-03-01 00:53:19.000000', 'temperatura', 362.0000, 'ºC'),
	(237102, 122, '2014-03-01 00:53:20.000000', 'temperatura', 439.0000, 'ºC'),
	(237103, 122, '2014-03-01 00:53:21.000000', 'temperatura', 1112.0000, 'ºC'),
	(237104, 122, '2014-03-01 00:53:22.000000', 'temperatura', 641.0000, 'ºC'),
	(237105, 122, '2014-03-01 00:53:23.000000', 'temperatura', 1072.0000, 'ºC'),
	(237106, 122, '2014-03-01 00:53:24.000000', 'temperatura', 1035.0000, 'ºC'),
	(237107, 122, '2014-03-01 00:53:25.000000', 'temperatura', 759.0000, 'ºC'),
	(237108, 122, '2014-03-01 00:53:26.000000', 'temperatura', 693.0000, 'ºC'),
	(237109, 122, '2014-03-01 00:53:27.000000', 'temperatura', 1186.0000, 'ºC'),
	(237110, 122, '2014-03-01 00:53:28.000000', 'temperatura', 251.0000, 'ºC'),
	(237111, 122, '2014-03-01 00:53:29.000000', 'temperatura', 98.0000, 'ºC'),
	(237112, 122, '2014-03-01 00:53:30.000000', 'temperatura', 938.0000, 'ºC'),
	(237113, 122, '2014-03-01 00:53:31.000000', 'temperatura', 796.0000, 'ºC'),
	(237114, 122, '2014-03-01 00:53:32.000000', 'temperatura', 1168.0000, 'ºC'),
	(237115, 122, '2014-03-01 00:53:33.000000', 'temperatura', 1052.0000, 'ºC'),
	(237116, 122, '2014-03-01 00:53:34.000000', 'temperatura', 555.0000, 'ºC'),
	(237117, 122, '2014-03-01 00:53:35.000000', 'temperatura', 822.0000, 'ºC'),
	(237118, 122, '2014-03-01 00:53:36.000000', 'temperatura', 45.0000, 'ºC'),
	(237119, 122, '2014-03-01 00:53:37.000000', 'temperatura', 160.0000, 'ºC'),
	(237120, 122, '2014-03-01 00:53:38.000000', 'temperatura', 664.0000, 'ºC'),
	(237121, 122, '2014-03-01 00:53:39.000000', 'temperatura', 441.0000, 'ºC'),
	(237122, 122, '2014-03-01 00:53:40.000000', 'temperatura', 212.0000, 'ºC'),
	(237123, 122, '2014-03-01 00:53:41.000000', 'temperatura', 937.0000, 'ºC'),
	(237124, 122, '2014-03-01 00:53:42.000000', 'temperatura', 451.0000, 'ºC'),
	(237125, 122, '2014-03-01 00:53:43.000000', 'temperatura', 646.0000, 'ºC'),
	(237126, 122, '2014-03-01 00:53:44.000000', 'temperatura', 675.0000, 'ºC'),
	(237127, 122, '2014-03-01 00:53:45.000000', 'temperatura', 237.0000, 'ºC'),
	(237128, 122, '2014-03-01 00:53:46.000000', 'temperatura', 361.0000, 'ºC'),
	(237129, 122, '2014-03-01 00:53:47.000000', 'temperatura', 1096.0000, 'ºC'),
	(237130, 122, '2014-03-01 00:53:48.000000', 'temperatura', 796.0000, 'ºC'),
	(237131, 122, '2014-03-01 00:53:49.000000', 'temperatura', 692.0000, 'ºC'),
	(237132, 122, '2014-03-01 00:53:50.000000', 'temperatura', 1075.0000, 'ºC'),
	(237133, 122, '2014-03-01 00:53:51.000000', 'temperatura', 898.0000, 'ºC'),
	(237134, 122, '2014-03-01 00:53:52.000000', 'temperatura', 65.0000, 'ºC'),
	(237135, 122, '2014-03-01 00:53:53.000000', 'temperatura', 30.0000, 'ºC'),
	(237136, 122, '2014-03-01 00:53:54.000000', 'temperatura', 1157.0000, 'ºC'),
	(237137, 122, '2014-03-01 00:53:55.000000', 'temperatura', 898.0000, 'ºC'),
	(237138, 122, '2014-03-01 00:53:56.000000', 'temperatura', 1016.0000, 'ºC'),
	(237139, 122, '2014-03-01 00:53:57.000000', 'temperatura', 1186.0000, 'ºC'),
	(237140, 122, '2014-03-01 00:53:58.000000', 'temperatura', 482.0000, 'ºC'),
	(237141, 122, '2014-03-01 00:53:59.000000', 'temperatura', 56.0000, 'ºC'),
	(237142, 122, '2014-03-01 00:54:00.000000', 'temperatura', 31.0000, 'ºC'),
	(237143, 122, '2014-03-01 00:54:01.000000', 'temperatura', 1189.0000, 'ºC'),
	(237144, 122, '2014-03-01 00:54:02.000000', 'temperatura', 1052.0000, 'ºC'),
	(237145, 122, '2014-03-01 00:54:03.000000', 'temperatura', 496.0000, 'ºC'),
	(237146, 122, '2014-03-01 00:54:04.000000', 'temperatura', 522.0000, 'ºC'),
	(237147, 122, '2014-03-01 00:54:05.000000', 'temperatura', 1122.0000, 'ºC'),
	(237148, 122, '2014-03-01 00:54:06.000000', 'temperatura', 446.0000, 'ºC'),
	(237149, 122, '2014-03-01 00:54:07.000000', 'temperatura', 63.0000, 'ºC'),
	(237150, 122, '2014-03-01 00:54:08.000000', 'temperatura', 179.0000, 'ºC'),
	(237151, 122, '2014-03-01 00:54:09.000000', 'temperatura', 707.0000, 'ºC'),
	(237152, 122, '2014-03-01 00:54:10.000000', 'temperatura', 599.0000, 'ºC'),
	(237153, 122, '2014-03-01 00:54:11.000000', 'temperatura', 873.0000, 'ºC'),
	(237154, 122, '2014-03-01 00:54:12.000000', 'temperatura', 170.0000, 'ºC'),
	(237155, 122, '2014-03-01 00:54:13.000000', 'temperatura', 632.0000, 'ºC'),
	(237156, 122, '2014-03-01 00:54:14.000000', 'temperatura', 251.0000, 'ºC'),
	(237157, 122, '2014-03-01 00:54:15.000000', 'temperatura', 558.0000, 'ºC'),
	(237158, 122, '2014-03-01 00:54:16.000000', 'temperatura', 839.0000, 'ºC'),
	(237159, 122, '2014-03-01 00:54:17.000000', 'temperatura', 120.0000, 'ºC'),
	(237160, 122, '2014-03-01 00:54:18.000000', 'temperatura', 483.0000, 'ºC'),
	(237161, 122, '2014-03-01 00:54:19.000000', 'temperatura', 855.0000, 'ºC'),
	(237162, 122, '2014-03-01 00:54:20.000000', 'temperatura', 427.0000, 'ºC'),
	(237163, 122, '2014-03-01 00:54:21.000000', 'temperatura', 773.0000, 'ºC'),
	(237164, 122, '2014-03-01 00:54:22.000000', 'temperatura', 182.0000, 'ºC'),
	(237165, 122, '2014-03-01 00:54:23.000000', 'temperatura', 993.0000, 'ºC'),
	(237166, 122, '2014-03-01 00:54:24.000000', 'temperatura', 820.0000, 'ºC'),
	(237167, 122, '2014-03-01 00:54:25.000000', 'temperatura', 1121.0000, 'ºC'),
	(237168, 122, '2014-03-01 00:54:26.000000', 'temperatura', 745.0000, 'ºC'),
	(237169, 122, '2014-03-01 00:54:27.000000', 'temperatura', 364.0000, 'ºC'),
	(237170, 122, '2014-03-01 00:54:28.000000', 'temperatura', 786.0000, 'ºC'),
	(237171, 122, '2014-03-01 00:54:29.000000', 'temperatura', 439.0000, 'ºC'),
	(237172, 122, '2014-03-01 00:54:30.000000', 'temperatura', 1038.0000, 'ºC'),
	(237173, 122, '2014-03-01 00:54:31.000000', 'temperatura', 273.0000, 'ºC'),
	(237174, 122, '2014-03-01 00:54:32.000000', 'temperatura', 649.0000, 'ºC'),
	(237175, 122, '2014-03-01 00:54:33.000000', 'temperatura', 29.0000, 'ºC'),
	(237176, 122, '2014-03-01 00:54:34.000000', 'temperatura', 597.0000, 'ºC'),
	(237177, 122, '2014-03-01 00:54:35.000000', 'temperatura', 499.0000, 'ºC'),
	(237178, 122, '2014-03-01 00:54:36.000000', 'temperatura', 706.0000, 'ºC'),
	(237179, 122, '2014-03-01 00:54:37.000000', 'temperatura', 832.0000, 'ºC'),
	(237180, 122, '2014-03-01 00:54:38.000000', 'temperatura', 841.0000, 'ºC'),
	(237181, 122, '2014-03-01 00:54:39.000000', 'temperatura', 513.0000, 'ºC'),
	(237182, 122, '2014-03-01 00:54:40.000000', 'temperatura', 40.0000, 'ºC'),
	(237183, 122, '2014-03-01 00:54:41.000000', 'temperatura', 1061.0000, 'ºC'),
	(237184, 122, '2014-03-01 00:54:42.000000', 'temperatura', 387.0000, 'ºC'),
	(237185, 122, '2014-03-01 00:54:43.000000', 'temperatura', 1151.0000, 'ºC'),
	(237186, 122, '2014-03-01 00:54:44.000000', 'temperatura', 994.0000, 'ºC'),
	(237187, 122, '2014-03-01 00:54:45.000000', 'temperatura', 320.0000, 'ºC'),
	(237188, 122, '2014-03-01 00:54:46.000000', 'temperatura', 1018.0000, 'ºC'),
	(237189, 122, '2014-03-01 00:54:47.000000', 'temperatura', 530.0000, 'ºC'),
	(237190, 122, '2014-03-01 00:54:48.000000', 'temperatura', 797.0000, 'ºC'),
	(237191, 122, '2014-03-01 00:54:49.000000', 'temperatura', 1194.0000, 'ºC'),
	(237192, 122, '2014-03-01 00:54:50.000000', 'temperatura', 1181.0000, 'ºC'),
	(237193, 122, '2014-03-01 00:54:51.000000', 'temperatura', 1123.0000, 'ºC'),
	(237194, 122, '2014-03-01 00:54:52.000000', 'temperatura', 874.0000, 'ºC'),
	(237195, 122, '2014-03-01 00:54:53.000000', 'temperatura', 1002.0000, 'ºC'),
	(237196, 122, '2014-03-01 00:54:54.000000', 'temperatura', 1189.0000, 'ºC'),
	(237197, 122, '2014-03-01 00:54:55.000000', 'temperatura', 539.0000, 'ºC'),
	(237198, 122, '2014-03-01 00:54:56.000000', 'temperatura', 327.0000, 'ºC'),
	(237199, 122, '2014-03-01 00:54:57.000000', 'temperatura', 18.0000, 'ºC'),
	(237200, 122, '2014-03-01 00:54:58.000000', 'temperatura', 311.0000, 'ºC'),
	(237201, 122, '2014-03-01 00:54:59.000000', 'temperatura', 301.0000, 'ºC'),
	(237202, 122, '2014-03-01 00:55:00.000000', 'temperatura', 571.0000, 'ºC'),
	(237203, 122, '2014-03-01 00:55:01.000000', 'temperatura', 754.0000, 'ºC'),
	(237204, 122, '2014-03-01 00:55:02.000000', 'temperatura', 856.0000, 'ºC'),
	(237205, 122, '2014-03-01 00:55:03.000000', 'temperatura', 820.0000, 'ºC'),
	(237206, 122, '2014-03-01 00:55:04.000000', 'temperatura', 334.0000, 'ºC'),
	(237207, 122, '2014-03-01 00:55:05.000000', 'temperatura', 408.0000, 'ºC'),
	(237208, 122, '2014-03-01 00:55:06.000000', 'temperatura', 1041.0000, 'ºC'),
	(237209, 122, '2014-03-01 00:55:07.000000', 'temperatura', 382.0000, 'ºC'),
	(237210, 122, '2014-03-01 00:55:08.000000', 'temperatura', 1184.0000, 'ºC'),
	(237211, 122, '2014-03-01 00:55:09.000000', 'temperatura', 1178.0000, 'ºC'),
	(237212, 122, '2014-03-01 00:55:10.000000', 'temperatura', 1137.0000, 'ºC'),
	(237213, 122, '2014-03-01 00:55:11.000000', 'temperatura', 952.0000, 'ºC'),
	(237214, 122, '2014-03-01 00:55:12.000000', 'temperatura', 148.0000, 'ºC'),
	(237215, 122, '2014-03-01 00:55:13.000000', 'temperatura', 285.0000, 'ºC'),
	(237216, 122, '2014-03-01 00:55:14.000000', 'temperatura', 982.0000, 'ºC'),
	(237217, 122, '2014-03-01 00:55:15.000000', 'temperatura', 454.0000, 'ºC'),
	(237218, 122, '2014-03-01 00:55:16.000000', 'temperatura', 527.0000, 'ºC'),
	(237219, 122, '2014-03-01 00:55:17.000000', 'temperatura', 73.0000, 'ºC'),
	(237220, 122, '2014-03-01 00:55:18.000000', 'temperatura', 1184.0000, 'ºC'),
	(237221, 122, '2014-03-01 00:55:19.000000', 'temperatura', 903.0000, 'ºC'),
	(237222, 122, '2014-03-01 00:55:20.000000', 'temperatura', 961.0000, 'ºC'),
	(237223, 122, '2014-03-01 00:55:21.000000', 'temperatura', 896.0000, 'ºC'),
	(237224, 122, '2014-03-01 00:55:22.000000', 'temperatura', 399.0000, 'ºC'),
	(237225, 122, '2014-03-01 00:55:23.000000', 'temperatura', 506.0000, 'ºC'),
	(237226, 122, '2014-03-01 00:55:24.000000', 'temperatura', 134.0000, 'ºC'),
	(237227, 122, '2014-03-01 00:55:25.000000', 'temperatura', 354.0000, 'ºC'),
	(237228, 122, '2014-03-01 00:55:26.000000', 'temperatura', 166.0000, 'ºC'),
	(237229, 122, '2014-03-01 00:55:27.000000', 'temperatura', 972.0000, 'ºC'),
	(237230, 122, '2014-03-01 00:55:28.000000', 'temperatura', 760.0000, 'ºC'),
	(237231, 122, '2014-03-01 00:55:29.000000', 'temperatura', 884.0000, 'ºC'),
	(237232, 122, '2014-03-01 00:55:30.000000', 'temperatura', 943.0000, 'ºC'),
	(237233, 122, '2014-03-01 00:55:31.000000', 'temperatura', 864.0000, 'ºC'),
	(237234, 122, '2014-03-01 00:55:32.000000', 'temperatura', 290.0000, 'ºC'),
	(237235, 122, '2014-03-01 00:55:33.000000', 'temperatura', 59.0000, 'ºC'),
	(237236, 122, '2014-03-01 00:55:34.000000', 'temperatura', 625.0000, 'ºC'),
	(237237, 122, '2014-03-01 00:55:35.000000', 'temperatura', 550.0000, 'ºC'),
	(237238, 122, '2014-03-01 00:55:36.000000', 'temperatura', 873.0000, 'ºC'),
	(237239, 122, '2014-03-01 00:55:37.000000', 'temperatura', 317.0000, 'ºC'),
	(237240, 122, '2014-03-01 00:55:38.000000', 'temperatura', 168.0000, 'ºC'),
	(237241, 122, '2014-03-01 00:55:39.000000', 'temperatura', 1087.0000, 'ºC'),
	(237242, 122, '2014-03-01 00:55:40.000000', 'temperatura', 133.0000, 'ºC'),
	(237243, 122, '2014-03-01 00:55:41.000000', 'temperatura', 1006.0000, 'ºC'),
	(237244, 122, '2014-03-01 00:55:42.000000', 'temperatura', 1031.0000, 'ºC'),
	(237245, 122, '2014-03-01 00:55:43.000000', 'temperatura', 937.0000, 'ºC'),
	(237246, 122, '2014-03-01 00:55:44.000000', 'temperatura', 392.0000, 'ºC'),
	(237247, 122, '2014-03-01 00:55:45.000000', 'temperatura', 351.0000, 'ºC'),
	(237248, 122, '2014-03-01 00:55:46.000000', 'temperatura', 580.0000, 'ºC'),
	(237249, 122, '2014-03-01 00:55:47.000000', 'temperatura', 645.0000, 'ºC'),
	(237250, 122, '2014-03-01 00:55:48.000000', 'temperatura', 287.0000, 'ºC'),
	(237251, 122, '2014-03-01 00:55:49.000000', 'temperatura', 702.0000, 'ºC'),
	(237252, 122, '2014-03-01 00:55:50.000000', 'temperatura', 246.0000, 'ºC'),
	(237253, 122, '2014-03-01 00:55:51.000000', 'temperatura', 327.0000, 'ºC'),
	(237254, 122, '2014-03-01 00:55:52.000000', 'temperatura', 896.0000, 'ºC'),
	(237255, 122, '2014-03-01 00:55:53.000000', 'temperatura', 1098.0000, 'ºC'),
	(237256, 122, '2014-03-01 00:55:54.000000', 'temperatura', 404.0000, 'ºC'),
	(237257, 122, '2014-03-01 00:55:55.000000', 'temperatura', 1127.0000, 'ºC'),
	(237258, 122, '2014-03-01 00:55:56.000000', 'temperatura', 822.0000, 'ºC'),
	(237259, 122, '2014-03-01 00:55:57.000000', 'temperatura', 730.0000, 'ºC'),
	(237260, 122, '2014-03-01 00:55:58.000000', 'temperatura', 1185.0000, 'ºC'),
	(237261, 122, '2014-03-01 00:55:59.000000', 'temperatura', 135.0000, 'ºC'),
	(237262, 122, '2014-03-01 00:56:00.000000', 'temperatura', 720.0000, 'ºC'),
	(237263, 122, '2014-03-01 00:56:01.000000', 'temperatura', 794.0000, 'ºC'),
	(237264, 122, '2014-03-01 00:56:02.000000', 'temperatura', 613.0000, 'ºC'),
	(237265, 122, '2014-03-01 00:56:03.000000', 'temperatura', 683.0000, 'ºC'),
	(237266, 122, '2014-03-01 00:56:04.000000', 'temperatura', 378.0000, 'ºC'),
	(237267, 122, '2014-03-01 00:56:05.000000', 'temperatura', 1038.0000, 'ºC'),
	(237268, 122, '2014-03-01 00:56:06.000000', 'temperatura', 459.0000, 'ºC'),
	(237269, 122, '2014-03-01 00:56:07.000000', 'temperatura', 383.0000, 'ºC'),
	(237270, 122, '2014-03-01 00:56:08.000000', 'temperatura', 536.0000, 'ºC'),
	(237271, 122, '2014-03-01 00:56:09.000000', 'temperatura', 334.0000, 'ºC'),
	(237272, 122, '2014-03-01 00:56:10.000000', 'temperatura', 60.0000, 'ºC'),
	(237273, 122, '2014-03-01 00:56:11.000000', 'temperatura', 498.0000, 'ºC'),
	(237274, 122, '2014-03-01 00:56:12.000000', 'temperatura', 1112.0000, 'ºC'),
	(237275, 122, '2014-03-01 00:56:13.000000', 'temperatura', 468.0000, 'ºC'),
	(237276, 122, '2014-03-01 00:56:14.000000', 'temperatura', 203.0000, 'ºC'),
	(237277, 122, '2014-03-01 00:56:15.000000', 'temperatura', 812.0000, 'ºC'),
	(237278, 122, '2014-03-01 00:56:16.000000', 'temperatura', 1053.0000, 'ºC'),
	(237279, 122, '2014-03-01 00:56:17.000000', 'temperatura', 427.0000, 'ºC'),
	(237280, 122, '2014-03-01 00:56:18.000000', 'temperatura', 177.0000, 'ºC'),
	(237281, 122, '2014-03-01 00:56:19.000000', 'temperatura', 805.0000, 'ºC'),
	(237282, 122, '2014-03-01 00:56:20.000000', 'temperatura', 1096.0000, 'ºC'),
	(237283, 122, '2014-03-01 00:56:21.000000', 'temperatura', 663.0000, 'ºC'),
	(237284, 122, '2014-03-01 00:56:22.000000', 'temperatura', 28.0000, 'ºC'),
	(237285, 122, '2014-03-01 00:56:23.000000', 'temperatura', 553.0000, 'ºC'),
	(237286, 122, '2014-03-01 00:56:24.000000', 'temperatura', 281.0000, 'ºC'),
	(237287, 122, '2014-03-01 00:56:25.000000', 'temperatura', 948.0000, 'ºC'),
	(237288, 122, '2014-03-01 00:56:26.000000', 'temperatura', 297.0000, 'ºC'),
	(237289, 122, '2014-03-01 00:56:27.000000', 'temperatura', 1039.0000, 'ºC'),
	(237290, 122, '2014-03-01 00:56:28.000000', 'temperatura', 706.0000, 'ºC'),
	(237291, 122, '2014-03-01 00:56:29.000000', 'temperatura', 414.0000, 'ºC'),
	(237292, 122, '2014-03-01 00:56:30.000000', 'temperatura', 1153.0000, 'ºC'),
	(237293, 122, '2014-03-01 00:56:31.000000', 'temperatura', 921.0000, 'ºC'),
	(237294, 122, '2014-03-01 00:56:32.000000', 'temperatura', 1149.0000, 'ºC'),
	(237295, 122, '2014-03-01 00:56:33.000000', 'temperatura', 581.0000, 'ºC'),
	(237296, 122, '2014-03-01 00:56:34.000000', 'temperatura', 658.0000, 'ºC'),
	(237297, 122, '2014-03-01 00:56:35.000000', 'temperatura', 349.0000, 'ºC'),
	(237298, 122, '2014-03-01 00:56:36.000000', 'temperatura', 970.0000, 'ºC'),
	(237299, 122, '2014-03-01 00:56:37.000000', 'temperatura', 203.0000, 'ºC'),
	(237300, 122, '2014-03-01 00:56:38.000000', 'temperatura', 505.0000, 'ºC'),
	(237301, 122, '2014-03-01 00:56:39.000000', 'temperatura', 716.0000, 'ºC'),
	(237302, 122, '2014-03-01 00:56:40.000000', 'temperatura', 868.0000, 'ºC'),
	(237303, 122, '2014-03-01 00:56:41.000000', 'temperatura', 991.0000, 'ºC'),
	(237304, 122, '2014-03-01 00:56:42.000000', 'temperatura', 1150.0000, 'ºC'),
	(237305, 122, '2014-03-01 00:56:43.000000', 'temperatura', 378.0000, 'ºC'),
	(237306, 122, '2014-03-01 00:56:44.000000', 'temperatura', 842.0000, 'ºC'),
	(237307, 122, '2014-03-01 00:56:45.000000', 'temperatura', 676.0000, 'ºC'),
	(237308, 122, '2014-03-01 00:56:46.000000', 'temperatura', 853.0000, 'ºC'),
	(237309, 122, '2014-03-01 00:56:47.000000', 'temperatura', 1040.0000, 'ºC'),
	(237310, 122, '2014-03-01 00:56:48.000000', 'temperatura', 239.0000, 'ºC'),
	(237311, 122, '2014-03-01 00:56:49.000000', 'temperatura', 476.0000, 'ºC'),
	(237312, 122, '2014-03-01 00:56:50.000000', 'temperatura', 463.0000, 'ºC'),
	(237313, 122, '2014-03-01 00:56:51.000000', 'temperatura', 890.0000, 'ºC'),
	(237314, 122, '2014-03-01 00:56:52.000000', 'temperatura', 661.0000, 'ºC'),
	(237315, 122, '2014-03-01 00:56:53.000000', 'temperatura', 635.0000, 'ºC'),
	(237316, 122, '2014-03-01 00:56:54.000000', 'temperatura', 1194.0000, 'ºC'),
	(237317, 122, '2014-03-01 00:56:55.000000', 'temperatura', 463.0000, 'ºC'),
	(237318, 122, '2014-03-01 00:56:56.000000', 'temperatura', 1133.0000, 'ºC'),
	(237319, 122, '2014-03-01 00:56:57.000000', 'temperatura', 678.0000, 'ºC'),
	(237320, 122, '2014-03-01 00:56:58.000000', 'temperatura', 1191.0000, 'ºC'),
	(237321, 122, '2014-03-01 00:56:59.000000', 'temperatura', 323.0000, 'ºC'),
	(237322, 122, '2014-03-01 00:57:00.000000', 'temperatura', 441.0000, 'ºC'),
	(237323, 122, '2014-03-01 00:57:01.000000', 'temperatura', 35.0000, 'ºC'),
	(237324, 122, '2014-03-01 00:57:02.000000', 'temperatura', 53.0000, 'ºC'),
	(237325, 122, '2014-03-01 00:57:03.000000', 'temperatura', 160.0000, 'ºC'),
	(237326, 122, '2014-03-01 00:57:04.000000', 'temperatura', 644.0000, 'ºC'),
	(237327, 122, '2014-03-01 00:57:05.000000', 'temperatura', 337.0000, 'ºC'),
	(237328, 122, '2014-03-01 00:57:06.000000', 'temperatura', 957.0000, 'ºC'),
	(237329, 122, '2014-03-01 00:57:07.000000', 'temperatura', 172.0000, 'ºC'),
	(237330, 122, '2014-03-01 00:57:08.000000', 'temperatura', 388.0000, 'ºC'),
	(237331, 122, '2014-03-01 00:57:09.000000', 'temperatura', 227.0000, 'ºC'),
	(237332, 122, '2014-03-01 00:57:10.000000', 'temperatura', 1173.0000, 'ºC'),
	(237333, 122, '2014-03-01 00:57:11.000000', 'temperatura', 382.0000, 'ºC'),
	(237334, 122, '2014-03-01 00:57:12.000000', 'temperatura', 794.0000, 'ºC'),
	(237335, 122, '2014-03-01 00:57:13.000000', 'temperatura', 424.0000, 'ºC'),
	(237336, 122, '2014-03-01 00:57:14.000000', 'temperatura', 939.0000, 'ºC'),
	(237337, 122, '2014-03-01 00:57:15.000000', 'temperatura', 1021.0000, 'ºC'),
	(237338, 122, '2014-03-01 00:57:16.000000', 'temperatura', 1090.0000, 'ºC'),
	(237339, 122, '2014-03-01 00:57:17.000000', 'temperatura', 1189.0000, 'ºC'),
	(237340, 122, '2014-03-01 00:57:18.000000', 'temperatura', 272.0000, 'ºC'),
	(237341, 122, '2014-03-01 00:57:19.000000', 'temperatura', 197.0000, 'ºC'),
	(237342, 122, '2014-03-01 00:57:20.000000', 'temperatura', 168.0000, 'ºC'),
	(237343, 122, '2014-03-01 00:57:21.000000', 'temperatura', 249.0000, 'ºC'),
	(237344, 122, '2014-03-01 00:57:22.000000', 'temperatura', 744.0000, 'ºC'),
	(237345, 122, '2014-03-01 00:57:23.000000', 'temperatura', 572.0000, 'ºC'),
	(237346, 122, '2014-03-01 00:57:24.000000', 'temperatura', 626.0000, 'ºC'),
	(237347, 122, '2014-03-01 00:57:25.000000', 'temperatura', 218.0000, 'ºC'),
	(237348, 122, '2014-03-01 00:57:26.000000', 'temperatura', 412.0000, 'ºC'),
	(237349, 122, '2014-03-01 00:57:27.000000', 'temperatura', 205.0000, 'ºC'),
	(237350, 122, '2014-03-01 00:57:28.000000', 'temperatura', 990.0000, 'ºC'),
	(237351, 122, '2014-03-01 00:57:29.000000', 'temperatura', 735.0000, 'ºC'),
	(237352, 122, '2014-03-01 00:57:30.000000', 'temperatura', 707.0000, 'ºC'),
	(237353, 122, '2014-03-01 00:57:31.000000', 'temperatura', 131.0000, 'ºC'),
	(237354, 122, '2014-03-01 00:57:32.000000', 'temperatura', 933.0000, 'ºC'),
	(237355, 122, '2014-03-01 00:57:33.000000', 'temperatura', 671.0000, 'ºC'),
	(237356, 122, '2014-03-01 00:57:34.000000', 'temperatura', 559.0000, 'ºC'),
	(237357, 122, '2014-03-01 00:57:35.000000', 'temperatura', 780.0000, 'ºC'),
	(237358, 122, '2014-03-01 00:57:36.000000', 'temperatura', 1026.0000, 'ºC'),
	(237359, 122, '2014-03-01 00:57:37.000000', 'temperatura', 391.0000, 'ºC'),
	(237360, 122, '2014-03-01 00:57:38.000000', 'temperatura', 76.0000, 'ºC'),
	(237361, 122, '2014-03-01 00:57:39.000000', 'temperatura', 409.0000, 'ºC'),
	(237362, 122, '2014-03-01 00:57:40.000000', 'temperatura', 615.0000, 'ºC'),
	(237363, 122, '2014-03-01 00:57:41.000000', 'temperatura', 648.0000, 'ºC'),
	(237364, 122, '2014-03-01 00:57:42.000000', 'temperatura', 198.0000, 'ºC'),
	(237365, 122, '2014-03-01 00:57:43.000000', 'temperatura', 247.0000, 'ºC'),
	(237366, 122, '2014-03-01 00:57:44.000000', 'temperatura', 642.0000, 'ºC'),
	(237367, 122, '2014-03-01 00:57:45.000000', 'temperatura', 69.0000, 'ºC'),
	(237368, 122, '2014-03-01 00:57:46.000000', 'temperatura', 820.0000, 'ºC'),
	(237369, 122, '2014-03-01 00:57:47.000000', 'temperatura', 292.0000, 'ºC'),
	(237370, 122, '2014-03-01 00:57:48.000000', 'temperatura', 201.0000, 'ºC'),
	(237371, 122, '2014-03-01 00:57:49.000000', 'temperatura', 128.0000, 'ºC'),
	(237372, 122, '2014-03-01 00:57:50.000000', 'temperatura', 39.0000, 'ºC'),
	(237373, 122, '2014-03-01 00:57:51.000000', 'temperatura', 1011.0000, 'ºC'),
	(237374, 122, '2014-03-01 00:57:52.000000', 'temperatura', 140.0000, 'ºC'),
	(237375, 122, '2014-03-01 00:57:53.000000', 'temperatura', 66.0000, 'ºC'),
	(237376, 122, '2014-03-01 00:57:54.000000', 'temperatura', 1112.0000, 'ºC'),
	(237377, 122, '2014-03-01 00:57:55.000000', 'temperatura', 563.0000, 'ºC'),
	(237378, 122, '2014-03-01 00:57:56.000000', 'temperatura', 678.0000, 'ºC'),
	(237379, 122, '2014-03-01 00:57:57.000000', 'temperatura', 502.0000, 'ºC'),
	(237380, 122, '2014-03-01 00:57:58.000000', 'temperatura', 477.0000, 'ºC'),
	(237381, 122, '2014-03-01 00:57:59.000000', 'temperatura', 878.0000, 'ºC'),
	(237382, 122, '2014-03-01 00:58:00.000000', 'temperatura', 559.0000, 'ºC'),
	(237383, 122, '2014-03-01 00:58:01.000000', 'temperatura', 164.0000, 'ºC'),
	(237384, 122, '2014-03-01 00:58:02.000000', 'temperatura', 343.0000, 'ºC'),
	(237385, 122, '2014-03-01 00:58:03.000000', 'temperatura', 22.0000, 'ºC'),
	(237386, 122, '2014-03-01 00:58:04.000000', 'temperatura', 282.0000, 'ºC'),
	(237387, 122, '2014-03-01 00:58:05.000000', 'temperatura', 146.0000, 'ºC'),
	(237388, 122, '2014-03-01 00:58:06.000000', 'temperatura', 1084.0000, 'ºC'),
	(237389, 122, '2014-03-01 00:58:07.000000', 'temperatura', 182.0000, 'ºC'),
	(237390, 122, '2014-03-01 00:58:08.000000', 'temperatura', 58.0000, 'ºC'),
	(237391, 122, '2014-03-01 00:58:09.000000', 'temperatura', 945.0000, 'ºC'),
	(237392, 122, '2014-03-01 00:58:10.000000', 'temperatura', 950.0000, 'ºC'),
	(237393, 122, '2014-03-01 00:58:11.000000', 'temperatura', 718.0000, 'ºC'),
	(237394, 122, '2014-03-01 00:58:12.000000', 'temperatura', 740.0000, 'ºC'),
	(237395, 122, '2014-03-01 00:58:13.000000', 'temperatura', 344.0000, 'ºC'),
	(237396, 122, '2014-03-01 00:58:14.000000', 'temperatura', 703.0000, 'ºC'),
	(237397, 122, '2014-03-01 00:58:15.000000', 'temperatura', 83.0000, 'ºC'),
	(237398, 122, '2014-03-01 00:58:16.000000', 'temperatura', 706.0000, 'ºC'),
	(237399, 122, '2014-03-01 00:58:17.000000', 'temperatura', 884.0000, 'ºC'),
	(237400, 122, '2014-03-01 00:58:18.000000', 'temperatura', 1100.0000, 'ºC'),
	(237401, 122, '2014-03-01 00:58:19.000000', 'temperatura', 448.0000, 'ºC'),
	(237402, 122, '2014-03-01 00:58:20.000000', 'temperatura', 140.0000, 'ºC'),
	(237403, 122, '2014-03-01 00:58:21.000000', 'temperatura', 559.0000, 'ºC'),
	(237404, 122, '2014-03-01 00:58:22.000000', 'temperatura', 1174.0000, 'ºC'),
	(237405, 122, '2014-03-01 00:58:23.000000', 'temperatura', 593.0000, 'ºC'),
	(237406, 122, '2014-03-01 00:58:24.000000', 'temperatura', 643.0000, 'ºC'),
	(237407, 122, '2014-03-01 00:58:25.000000', 'temperatura', 238.0000, 'ºC'),
	(237408, 122, '2014-03-01 00:58:26.000000', 'temperatura', 462.0000, 'ºC'),
	(237409, 122, '2014-03-01 00:58:27.000000', 'temperatura', 394.0000, 'ºC'),
	(237410, 122, '2014-03-01 00:58:28.000000', 'temperatura', 587.0000, 'ºC'),
	(237411, 122, '2014-03-01 00:58:29.000000', 'temperatura', 551.0000, 'ºC'),
	(237412, 122, '2014-03-01 00:58:30.000000', 'temperatura', 997.0000, 'ºC'),
	(237413, 122, '2014-03-01 00:58:31.000000', 'temperatura', 933.0000, 'ºC'),
	(237414, 122, '2014-03-01 00:58:32.000000', 'temperatura', 473.0000, 'ºC'),
	(237415, 122, '2014-03-01 00:58:33.000000', 'temperatura', 767.0000, 'ºC'),
	(237416, 122, '2014-03-01 00:58:34.000000', 'temperatura', 17.0000, 'ºC'),
	(237417, 122, '2014-03-01 00:58:35.000000', 'temperatura', 186.0000, 'ºC'),
	(237418, 122, '2014-03-01 00:58:36.000000', 'temperatura', 877.0000, 'ºC'),
	(237419, 122, '2014-03-01 00:58:37.000000', 'temperatura', 228.0000, 'ºC'),
	(237420, 122, '2014-03-01 00:58:38.000000', 'temperatura', 910.0000, 'ºC'),
	(237421, 122, '2014-03-01 00:58:39.000000', 'temperatura', 265.0000, 'ºC'),
	(237422, 122, '2014-03-01 00:58:40.000000', 'temperatura', 998.0000, 'ºC'),
	(237423, 122, '2014-03-01 00:58:41.000000', 'temperatura', 597.0000, 'ºC'),
	(237424, 122, '2014-03-01 00:58:42.000000', 'temperatura', 1188.0000, 'ºC'),
	(237425, 122, '2014-03-01 00:58:43.000000', 'temperatura', 549.0000, 'ºC'),
	(237426, 122, '2014-03-01 00:58:44.000000', 'temperatura', 382.0000, 'ºC'),
	(237427, 122, '2014-03-01 00:58:45.000000', 'temperatura', 263.0000, 'ºC'),
	(237428, 122, '2014-03-01 00:58:46.000000', 'temperatura', 172.0000, 'ºC'),
	(237429, 122, '2014-03-01 00:58:47.000000', 'temperatura', 70.0000, 'ºC'),
	(237430, 122, '2014-03-01 00:58:48.000000', 'temperatura', 1034.0000, 'ºC'),
	(237431, 122, '2014-03-01 00:58:49.000000', 'temperatura', 162.0000, 'ºC'),
	(237432, 122, '2014-03-01 00:58:50.000000', 'temperatura', 109.0000, 'ºC'),
	(237433, 122, '2014-03-01 00:58:51.000000', 'temperatura', 59.0000, 'ºC'),
	(237434, 122, '2014-03-01 00:58:52.000000', 'temperatura', 1168.0000, 'ºC'),
	(237435, 122, '2014-03-01 00:58:53.000000', 'temperatura', 865.0000, 'ºC'),
	(237436, 122, '2014-03-01 00:58:54.000000', 'temperatura', 820.0000, 'ºC'),
	(237437, 122, '2014-03-01 00:58:55.000000', 'temperatura', 304.0000, 'ºC'),
	(237438, 122, '2014-03-01 00:58:56.000000', 'temperatura', 262.0000, 'ºC'),
	(237439, 122, '2014-03-01 00:58:57.000000', 'temperatura', 400.0000, 'ºC'),
	(237440, 122, '2014-03-01 00:58:58.000000', 'temperatura', 15.0000, 'ºC'),
	(237441, 122, '2014-03-01 00:58:59.000000', 'temperatura', 75.0000, 'ºC'),
	(237442, 122, '2014-03-01 00:59:00.000000', 'temperatura', 329.0000, 'ºC'),
	(237443, 122, '2014-03-01 00:59:01.000000', 'temperatura', 223.0000, 'ºC'),
	(237444, 122, '2014-03-01 00:59:02.000000', 'temperatura', 127.0000, 'ºC'),
	(237445, 122, '2014-03-01 00:59:03.000000', 'temperatura', 1168.0000, 'ºC'),
	(237446, 122, '2014-03-01 00:59:04.000000', 'temperatura', 658.0000, 'ºC'),
	(237447, 122, '2014-03-01 00:59:05.000000', 'temperatura', 986.0000, 'ºC'),
	(237448, 122, '2014-03-01 00:59:06.000000', 'temperatura', 558.0000, 'ºC'),
	(237449, 122, '2014-03-01 00:59:07.000000', 'temperatura', 1030.0000, 'ºC'),
	(237450, 122, '2014-03-01 00:59:08.000000', 'temperatura', 1079.0000, 'ºC'),
	(237451, 122, '2014-03-01 00:59:09.000000', 'temperatura', 1107.0000, 'ºC'),
	(237452, 122, '2014-03-01 00:59:10.000000', 'temperatura', 1096.0000, 'ºC'),
	(237453, 122, '2014-03-01 00:59:11.000000', 'temperatura', 959.0000, 'ºC'),
	(237454, 122, '2014-03-01 00:59:12.000000', 'temperatura', 309.0000, 'ºC'),
	(237455, 122, '2014-03-01 00:59:13.000000', 'temperatura', 1066.0000, 'ºC'),
	(237456, 122, '2014-03-01 00:59:14.000000', 'temperatura', 805.0000, 'ºC'),
	(237457, 122, '2014-03-01 00:59:15.000000', 'temperatura', 829.0000, 'ºC'),
	(237458, 122, '2014-03-01 00:59:16.000000', 'temperatura', 530.0000, 'ºC'),
	(237459, 122, '2014-03-01 00:59:17.000000', 'temperatura', 162.0000, 'ºC'),
	(237460, 122, '2014-03-01 00:59:18.000000', 'temperatura', 423.0000, 'ºC'),
	(237461, 122, '2014-03-01 00:59:19.000000', 'temperatura', 427.0000, 'ºC'),
	(237462, 122, '2014-03-01 00:59:20.000000', 'temperatura', 866.0000, 'ºC'),
	(237463, 122, '2014-03-01 00:59:21.000000', 'temperatura', 650.0000, 'ºC'),
	(237464, 122, '2014-03-01 00:59:22.000000', 'temperatura', 652.0000, 'ºC'),
	(237465, 122, '2014-03-01 00:59:23.000000', 'temperatura', 110.0000, 'ºC'),
	(237466, 122, '2014-03-01 00:59:24.000000', 'temperatura', 994.0000, 'ºC'),
	(237467, 122, '2014-03-01 00:59:25.000000', 'temperatura', 1041.0000, 'ºC'),
	(237468, 122, '2014-03-01 00:59:26.000000', 'temperatura', 1022.0000, 'ºC'),
	(237469, 122, '2014-03-01 00:59:27.000000', 'temperatura', 790.0000, 'ºC'),
	(237470, 122, '2014-03-01 00:59:28.000000', 'temperatura', 885.0000, 'ºC'),
	(237471, 122, '2014-03-01 00:59:29.000000', 'temperatura', 854.0000, 'ºC'),
	(237472, 122, '2014-03-01 00:59:30.000000', 'temperatura', 415.0000, 'ºC'),
	(237473, 122, '2014-03-01 00:59:31.000000', 'temperatura', 716.0000, 'ºC'),
	(237474, 122, '2014-03-01 00:59:32.000000', 'temperatura', 1133.0000, 'ºC'),
	(237475, 122, '2014-03-01 00:59:33.000000', 'temperatura', 1119.0000, 'ºC'),
	(237476, 122, '2014-03-01 00:59:34.000000', 'temperatura', 995.0000, 'ºC'),
	(237477, 122, '2014-03-01 00:59:35.000000', 'temperatura', 418.0000, 'ºC'),
	(237478, 122, '2014-03-01 00:59:36.000000', 'temperatura', 308.0000, 'ºC'),
	(237479, 122, '2014-03-01 00:59:37.000000', 'temperatura', 285.0000, 'ºC'),
	(237480, 122, '2014-03-01 00:59:38.000000', 'temperatura', 501.0000, 'ºC'),
	(237481, 122, '2014-03-01 00:59:39.000000', 'temperatura', 451.0000, 'ºC'),
	(237482, 122, '2014-03-01 00:59:40.000000', 'temperatura', 753.0000, 'ºC'),
	(237483, 122, '2014-03-01 00:59:41.000000', 'temperatura', 13.0000, 'ºC'),
	(237484, 122, '2014-03-01 00:59:42.000000', 'temperatura', 205.0000, 'ºC'),
	(237485, 122, '2014-03-01 00:59:43.000000', 'temperatura', 986.0000, 'ºC'),
	(237486, 122, '2014-03-01 00:59:44.000000', 'temperatura', 716.0000, 'ºC'),
	(237487, 122, '2014-03-01 00:59:45.000000', 'temperatura', 622.0000, 'ºC'),
	(237488, 122, '2014-03-01 00:59:46.000000', 'temperatura', 963.0000, 'ºC'),
	(237489, 122, '2014-03-01 00:59:47.000000', 'temperatura', 549.0000, 'ºC'),
	(237490, 122, '2014-03-01 00:59:48.000000', 'temperatura', 1059.0000, 'ºC'),
	(237491, 122, '2014-03-01 00:59:49.000000', 'temperatura', 45.0000, 'ºC'),
	(237492, 122, '2014-03-01 00:59:50.000000', 'temperatura', 651.0000, 'ºC'),
	(237493, 122, '2014-03-01 00:59:51.000000', 'temperatura', 718.0000, 'ºC'),
	(237494, 122, '2014-03-01 00:59:52.000000', 'temperatura', 439.0000, 'ºC'),
	(237495, 122, '2014-03-01 00:59:53.000000', 'temperatura', 42.0000, 'ºC'),
	(237496, 122, '2014-03-01 00:59:54.000000', 'temperatura', 93.0000, 'ºC'),
	(237497, 122, '2014-03-01 00:59:55.000000', 'temperatura', 338.0000, 'ºC'),
	(237498, 122, '2014-03-01 00:59:56.000000', 'temperatura', 214.0000, 'ºC'),
	(237499, 122, '2014-03-01 00:59:57.000000', 'temperatura', 55.0000, 'ºC'),
	(237500, 122, '2014-03-01 00:59:58.000000', 'temperatura', 836.0000, 'ºC'),
	(237501, 122, '2014-03-01 00:59:59.000000', 'temperatura', 412.0000, 'ºC'),
	(237502, 122, '2014-03-01 01:00:00.000000', 'temperatura', 754.0000, 'ºC'),
	(237503, 122, '2014-03-01 01:00:01.000000', 'temperatura', 133.0000, 'ºC'),
	(237504, 122, '2014-03-01 01:00:02.000000', 'temperatura', 805.0000, 'ºC'),
	(237505, 122, '2014-03-01 01:00:03.000000', 'temperatura', 27.0000, 'ºC'),
	(237506, 122, '2014-03-01 01:00:04.000000', 'temperatura', 122.0000, 'ºC'),
	(237507, 122, '2014-03-01 01:00:05.000000', 'temperatura', 526.0000, 'ºC'),
	(237508, 122, '2014-03-01 01:00:06.000000', 'temperatura', 1067.0000, 'ºC'),
	(237509, 122, '2014-03-01 01:00:07.000000', 'temperatura', 157.0000, 'ºC'),
	(237510, 122, '2014-03-01 01:00:08.000000', 'temperatura', 1183.0000, 'ºC'),
	(237511, 122, '2014-03-01 01:00:09.000000', 'temperatura', 646.0000, 'ºC'),
	(237512, 122, '2014-03-01 01:00:10.000000', 'temperatura', 881.0000, 'ºC'),
	(237513, 122, '2014-03-01 01:00:11.000000', 'temperatura', 69.0000, 'ºC'),
	(237514, 122, '2014-03-01 01:00:12.000000', 'temperatura', 102.0000, 'ºC'),
	(237515, 122, '2014-03-01 01:00:13.000000', 'temperatura', 303.0000, 'ºC'),
	(237516, 122, '2014-03-01 01:00:14.000000', 'temperatura', 8.0000, 'ºC'),
	(237517, 122, '2014-03-01 01:00:15.000000', 'temperatura', 332.0000, 'ºC'),
	(237518, 122, '2014-03-01 01:00:16.000000', 'temperatura', 436.0000, 'ºC'),
	(237519, 122, '2014-03-01 01:00:17.000000', 'temperatura', 1183.0000, 'ºC'),
	(237520, 122, '2014-03-01 01:00:18.000000', 'temperatura', 1010.0000, 'ºC'),
	(237521, 122, '2014-03-01 01:00:19.000000', 'temperatura', 302.0000, 'ºC'),
	(237522, 122, '2014-03-01 01:00:20.000000', 'temperatura', 881.0000, 'ºC'),
	(237523, 122, '2014-03-01 01:00:21.000000', 'temperatura', 1098.0000, 'ºC'),
	(237524, 122, '2014-03-01 01:00:22.000000', 'temperatura', 446.0000, 'ºC'),
	(237525, 122, '2014-03-01 01:00:23.000000', 'temperatura', 138.0000, 'ºC'),
	(237526, 122, '2014-03-01 01:00:24.000000', 'temperatura', 553.0000, 'ºC'),
	(237527, 122, '2014-03-01 01:00:25.000000', 'temperatura', 1153.0000, 'ºC'),
	(237528, 122, '2014-03-01 01:00:26.000000', 'temperatura', 503.0000, 'ºC'),
	(237529, 122, '2014-03-01 01:00:27.000000', 'temperatura', 260.0000, 'ºC'),
	(237530, 122, '2014-03-01 01:00:28.000000', 'temperatura', 989.0000, 'ºC'),
	(237531, 122, '2014-03-01 01:00:29.000000', 'temperatura', 567.0000, 'ºC'),
	(237532, 122, '2014-03-01 01:00:30.000000', 'temperatura', 1070.0000, 'ºC'),
	(237533, 122, '2014-03-01 01:00:31.000000', 'temperatura', 49.0000, 'ºC'),
	(237534, 122, '2014-03-01 01:00:32.000000', 'temperatura', 633.0000, 'ºC'),
	(237535, 122, '2014-03-01 01:00:33.000000', 'temperatura', 620.0000, 'ºC'),
	(237536, 122, '2014-03-01 01:00:34.000000', 'temperatura', 0.0000, 'ºC'),
	(237537, 122, '2014-03-01 01:00:35.000000', 'temperatura', 542.0000, 'ºC'),
	(237538, 122, '2014-03-01 01:00:36.000000', 'temperatura', 312.0000, 'ºC'),
	(237539, 122, '2014-03-01 01:00:37.000000', 'temperatura', 1132.0000, 'ºC'),
	(237540, 122, '2014-03-01 01:00:38.000000', 'temperatura', 1127.0000, 'ºC'),
	(237541, 122, '2014-03-01 01:00:39.000000', 'temperatura', 1038.0000, 'ºC'),
	(237542, 122, '2014-03-01 01:00:40.000000', 'temperatura', 611.0000, 'ºC'),
	(237543, 122, '2014-03-01 01:00:41.000000', 'temperatura', 1140.0000, 'ºC'),
	(237544, 122, '2014-03-01 01:00:42.000000', 'temperatura', 268.0000, 'ºC'),
	(237545, 122, '2014-03-01 01:00:43.000000', 'temperatura', 320.0000, 'ºC'),
	(237546, 122, '2014-03-01 01:00:44.000000', 'temperatura', 796.0000, 'ºC'),
	(237547, 122, '2014-03-01 01:00:45.000000', 'temperatura', 620.0000, 'ºC'),
	(237548, 122, '2014-03-01 01:00:46.000000', 'temperatura', 713.0000, 'ºC'),
	(237549, 122, '2014-03-01 01:00:47.000000', 'temperatura', 506.0000, 'ºC'),
	(237550, 122, '2014-03-01 01:00:48.000000', 'temperatura', 389.0000, 'ºC'),
	(237551, 122, '2014-03-01 01:00:49.000000', 'temperatura', 431.0000, 'ºC'),
	(237552, 122, '2014-03-01 01:00:50.000000', 'temperatura', 988.0000, 'ºC'),
	(237553, 122, '2014-03-01 01:00:51.000000', 'temperatura', 47.0000, 'ºC'),
	(237554, 122, '2014-03-01 01:00:52.000000', 'temperatura', 872.0000, 'ºC'),
	(237555, 122, '2014-03-01 01:00:53.000000', 'temperatura', 619.0000, 'ºC'),
	(237556, 122, '2014-03-01 01:00:54.000000', 'temperatura', 478.0000, 'ºC'),
	(237557, 122, '2014-03-01 01:00:55.000000', 'temperatura', 536.0000, 'ºC'),
	(237558, 122, '2014-03-01 01:00:56.000000', 'temperatura', 48.0000, 'ºC'),
	(237559, 122, '2014-03-01 01:00:57.000000', 'temperatura', 1029.0000, 'ºC'),
	(237560, 122, '2014-03-01 01:00:58.000000', 'temperatura', 204.0000, 'ºC'),
	(237561, 122, '2014-03-01 01:00:59.000000', 'temperatura', 332.0000, 'ºC'),
	(237562, 122, '2014-03-01 01:01:00.000000', 'temperatura', 1049.0000, 'ºC'),
	(237563, 122, '2014-03-01 01:01:01.000000', 'temperatura', 650.0000, 'ºC'),
	(237564, 122, '2014-03-01 01:01:02.000000', 'temperatura', 105.0000, 'ºC'),
	(237565, 122, '2014-03-01 01:01:03.000000', 'temperatura', 973.0000, 'ºC'),
	(237566, 122, '2014-03-01 01:01:04.000000', 'temperatura', 951.0000, 'ºC'),
	(237567, 122, '2014-03-01 01:01:05.000000', 'temperatura', 637.0000, 'ºC'),
	(237568, 122, '2014-03-01 01:01:06.000000', 'temperatura', 332.0000, 'ºC'),
	(237569, 122, '2014-03-01 01:01:07.000000', 'temperatura', 950.0000, 'ºC'),
	(237570, 122, '2014-03-01 01:01:08.000000', 'temperatura', 155.0000, 'ºC'),
	(237571, 122, '2014-03-01 01:01:09.000000', 'temperatura', 325.0000, 'ºC'),
	(237572, 122, '2014-03-01 01:01:10.000000', 'temperatura', 1160.0000, 'ºC'),
	(237573, 122, '2014-03-01 01:01:11.000000', 'temperatura', 25.0000, 'ºC'),
	(237574, 122, '2014-03-01 01:01:12.000000', 'temperatura', 247.0000, 'ºC'),
	(237575, 122, '2014-03-01 01:01:13.000000', 'temperatura', 1159.0000, 'ºC'),
	(237576, 122, '2014-03-01 01:01:14.000000', 'temperatura', 255.0000, 'ºC'),
	(237577, 122, '2014-03-01 01:01:15.000000', 'temperatura', 198.0000, 'ºC'),
	(237578, 122, '2014-03-01 01:01:16.000000', 'temperatura', 227.0000, 'ºC'),
	(237579, 122, '2014-03-01 01:01:17.000000', 'temperatura', 539.0000, 'ºC'),
	(237580, 122, '2014-03-01 01:01:18.000000', 'temperatura', 818.0000, 'ºC'),
	(237581, 122, '2014-03-01 01:01:19.000000', 'temperatura', 70.0000, 'ºC'),
	(237582, 122, '2014-03-01 01:01:20.000000', 'temperatura', 297.0000, 'ºC'),
	(237583, 122, '2014-03-01 01:01:21.000000', 'temperatura', 77.0000, 'ºC'),
	(237584, 122, '2014-03-01 01:01:22.000000', 'temperatura', 695.0000, 'ºC'),
	(237585, 122, '2014-03-01 01:01:23.000000', 'temperatura', 842.0000, 'ºC'),
	(237586, 122, '2014-03-01 01:01:24.000000', 'temperatura', 925.0000, 'ºC'),
	(237587, 122, '2014-03-01 01:01:25.000000', 'temperatura', 902.0000, 'ºC'),
	(237588, 122, '2014-03-01 01:01:26.000000', 'temperatura', 535.0000, 'ºC'),
	(237589, 122, '2014-03-01 01:01:27.000000', 'temperatura', 1170.0000, 'ºC'),
	(237590, 122, '2014-03-01 01:01:28.000000', 'temperatura', 644.0000, 'ºC'),
	(237591, 122, '2014-03-01 01:01:29.000000', 'temperatura', 912.0000, 'ºC'),
	(237592, 122, '2014-03-01 01:01:30.000000', 'temperatura', 227.0000, 'ºC'),
	(237593, 122, '2014-03-01 01:01:31.000000', 'temperatura', 801.0000, 'ºC'),
	(237594, 122, '2014-03-01 01:01:32.000000', 'temperatura', 924.0000, 'ºC'),
	(237595, 122, '2014-03-01 01:01:33.000000', 'temperatura', 1016.0000, 'ºC'),
	(237596, 122, '2014-03-01 01:01:34.000000', 'temperatura', 1109.0000, 'ºC'),
	(237597, 122, '2014-03-01 01:01:35.000000', 'temperatura', 97.0000, 'ºC'),
	(237598, 122, '2014-03-01 01:01:36.000000', 'temperatura', 761.0000, 'ºC'),
	(237599, 122, '2014-03-01 01:01:37.000000', 'temperatura', 1112.0000, 'ºC'),
	(237600, 122, '2014-03-01 01:01:38.000000', 'temperatura', 878.0000, 'ºC'),
	(237601, 122, '2014-03-01 01:01:39.000000', 'temperatura', 1053.0000, 'ºC'),
	(237602, 122, '2014-03-01 01:01:40.000000', 'temperatura', 231.0000, 'ºC'),
	(237603, 122, '2014-03-01 01:01:41.000000', 'temperatura', 399.0000, 'ºC'),
	(237604, 122, '2014-03-01 01:01:42.000000', 'temperatura', 102.0000, 'ºC'),
	(237605, 122, '2014-03-01 01:01:43.000000', 'temperatura', 513.0000, 'ºC'),
	(237606, 122, '2014-03-01 01:01:44.000000', 'temperatura', 1059.0000, 'ºC'),
	(237607, 122, '2014-03-01 01:01:45.000000', 'temperatura', 155.0000, 'ºC'),
	(237608, 122, '2014-03-01 01:01:46.000000', 'temperatura', 1.0000, 'ºC'),
	(237609, 122, '2014-03-01 01:01:47.000000', 'temperatura', 740.0000, 'ºC'),
	(237610, 122, '2014-03-01 01:01:48.000000', 'temperatura', 96.0000, 'ºC'),
	(237611, 122, '2014-03-01 01:01:49.000000', 'temperatura', 663.0000, 'ºC'),
	(237612, 122, '2014-03-01 01:01:50.000000', 'temperatura', 627.0000, 'ºC'),
	(237613, 122, '2014-03-01 01:01:51.000000', 'temperatura', 1146.0000, 'ºC'),
	(237614, 122, '2014-03-01 01:01:52.000000', 'temperatura', 252.0000, 'ºC'),
	(237615, 122, '2014-03-01 01:01:53.000000', 'temperatura', 219.0000, 'ºC'),
	(237616, 122, '2014-03-01 01:01:54.000000', 'temperatura', 343.0000, 'ºC'),
	(237617, 122, '2014-03-01 01:01:55.000000', 'temperatura', 1056.0000, 'ºC'),
	(237618, 122, '2014-03-01 01:01:56.000000', 'temperatura', 654.0000, 'ºC'),
	(237619, 122, '2014-03-01 01:01:57.000000', 'temperatura', 100.0000, 'ºC'),
	(237620, 122, '2014-03-01 01:01:58.000000', 'temperatura', 939.0000, 'ºC'),
	(237621, 122, '2014-03-01 01:01:59.000000', 'temperatura', 796.0000, 'ºC'),
	(237622, 122, '2014-03-01 01:02:00.000000', 'temperatura', 1164.0000, 'ºC'),
	(237623, 122, '2014-03-01 01:02:01.000000', 'temperatura', 1033.0000, 'ºC'),
	(237624, 122, '2014-03-01 01:02:02.000000', 'temperatura', 474.0000, 'ºC'),
	(237625, 122, '2014-03-01 01:02:03.000000', 'temperatura', 470.0000, 'ºC'),
	(237626, 122, '2014-03-01 01:02:04.000000', 'temperatura', 928.0000, 'ºC'),
	(237627, 122, '2014-03-01 01:02:05.000000', 'temperatura', 831.0000, 'ºC'),
	(237628, 122, '2014-03-01 01:02:06.000000', 'temperatura', 170.0000, 'ºC'),
	(237629, 122, '2014-03-01 01:02:07.000000', 'temperatura', 757.0000, 'ºC'),
	(237630, 122, '2014-03-01 01:02:08.000000', 'temperatura', 878.0000, 'ºC'),
	(237631, 122, '2014-03-01 01:02:09.000000', 'temperatura', 918.0000, 'ºC'),
	(237632, 122, '2014-03-01 01:02:10.000000', 'temperatura', 757.0000, 'ºC'),
	(237633, 122, '2014-03-01 01:02:11.000000', 'temperatura', 1030.0000, 'ºC'),
	(237634, 122, '2014-03-01 01:02:12.000000', 'temperatura', 479.0000, 'ºC'),
	(237635, 122, '2014-03-01 01:02:13.000000', 'temperatura', 505.0000, 'ºC'),
	(237636, 122, '2014-03-01 01:02:14.000000', 'temperatura', 1090.0000, 'ºC'),
	(237637, 122, '2014-03-01 01:02:15.000000', 'temperatura', 336.0000, 'ºC'),
	(237638, 122, '2014-03-01 01:02:16.000000', 'temperatura', 810.0000, 'ºC'),
	(237639, 122, '2014-03-01 01:02:17.000000', 'temperatura', 642.0000, 'ºC'),
	(237640, 122, '2014-03-01 01:02:18.000000', 'temperatura', 779.0000, 'ºC'),
	(237641, 122, '2014-03-01 01:02:19.000000', 'temperatura', 771.0000, 'ºC'),
	(237642, 122, '2014-03-01 01:02:20.000000', 'temperatura', 319.0000, 'ºC'),
	(237643, 122, '2014-03-01 01:02:21.000000', 'temperatura', 483.0000, 'ºC'),
	(237644, 122, '2014-03-01 01:02:22.000000', 'temperatura', 257.0000, 'ºC'),
	(237645, 122, '2014-03-01 01:02:23.000000', 'temperatura', 1036.0000, 'ºC'),
	(237646, 122, '2014-03-01 01:02:24.000000', 'temperatura', 811.0000, 'ºC'),
	(237647, 122, '2014-03-01 01:02:25.000000', 'temperatura', 946.0000, 'ºC'),
	(237648, 122, '2014-03-01 01:02:26.000000', 'temperatura', 1099.0000, 'ºC'),
	(237649, 122, '2014-03-01 01:02:27.000000', 'temperatura', 256.0000, 'ºC'),
	(237650, 122, '2014-03-01 01:02:28.000000', 'temperatura', 383.0000, 'ºC'),
	(237651, 122, '2014-03-01 01:02:29.000000', 'temperatura', 1148.0000, 'ºC'),
	(237652, 122, '2014-03-01 01:02:30.000000', 'temperatura', 993.0000, 'ºC'),
	(237653, 122, '2014-03-01 01:02:31.000000', 'temperatura', 322.0000, 'ºC'),
	(237654, 122, '2014-03-01 01:02:32.000000', 'temperatura', 1030.0000, 'ºC'),
	(237655, 122, '2014-03-01 01:02:33.000000', 'temperatura', 583.0000, 'ºC'),
	(237656, 122, '2014-03-01 01:02:34.000000', 'temperatura', 1026.0000, 'ºC'),
	(237657, 122, '2014-03-01 01:02:35.000000', 'temperatura', 982.0000, 'ºC'),
	(237658, 122, '2014-03-01 01:02:36.000000', 'temperatura', 632.0000, 'ºC'),
	(237659, 122, '2014-03-01 01:02:37.000000', 'temperatura', 217.0000, 'ºC'),
	(237660, 122, '2014-03-01 01:02:38.000000', 'temperatura', 387.0000, 'ºC'),
	(237661, 122, '2014-03-01 01:02:39.000000', 'temperatura', 84.0000, 'ºC'),
	(237662, 122, '2014-03-01 01:02:40.000000', 'temperatura', 462.0000, 'ºC'),
	(237663, 122, '2014-03-01 01:02:41.000000', 'temperatura', 858.0000, 'ºC'),
	(237664, 122, '2014-03-01 01:02:42.000000', 'temperatura', 503.0000, 'ºC'),
	(237665, 122, '2014-03-01 01:02:43.000000', 'temperatura', 1143.0000, 'ºC'),
	(237666, 122, '2014-03-01 01:02:44.000000', 'temperatura', 605.0000, 'ºC'),
	(237667, 122, '2014-03-01 01:02:45.000000', 'temperatura', 798.0000, 'ºC'),
	(237668, 122, '2014-03-01 01:02:46.000000', 'temperatura', 977.0000, 'ºC'),
	(237669, 122, '2014-03-01 01:02:47.000000', 'temperatura', 89.0000, 'ºC'),
	(237670, 122, '2014-03-01 01:02:48.000000', 'temperatura', 1113.0000, 'ºC'),
	(237671, 122, '2014-03-01 01:02:49.000000', 'temperatura', 501.0000, 'ºC'),
	(237672, 122, '2014-03-01 01:02:50.000000', 'temperatura', 365.0000, 'ºC'),
	(237673, 122, '2014-03-01 01:02:51.000000', 'temperatura', 324.0000, 'ºC'),
	(237674, 122, '2014-03-01 01:02:52.000000', 'temperatura', 525.0000, 'ºC'),
	(237675, 122, '2014-03-01 01:02:53.000000', 'temperatura', 452.0000, 'ºC'),
	(237676, 122, '2014-03-01 01:02:54.000000', 'temperatura', 685.0000, 'ºC'),
	(237677, 122, '2014-03-01 01:02:55.000000', 'temperatura', 869.0000, 'ºC'),
	(237678, 122, '2014-03-01 01:02:56.000000', 'temperatura', 1091.0000, 'ºC'),
	(237679, 122, '2014-03-01 01:02:57.000000', 'temperatura', 451.0000, 'ºC'),
	(237680, 122, '2014-03-01 01:02:58.000000', 'temperatura', 179.0000, 'ºC'),
	(237681, 122, '2014-03-01 01:02:59.000000', 'temperatura', 745.0000, 'ºC'),
	(237682, 122, '2014-03-01 01:03:00.000000', 'temperatura', 786.0000, 'ºC'),
	(237683, 122, '2014-03-01 01:03:01.000000', 'temperatura', 498.0000, 'ºC'),
	(237684, 122, '2014-03-01 01:03:02.000000', 'temperatura', 130.0000, 'ºC'),
	(237685, 122, '2014-03-01 01:03:03.000000', 'temperatura', 356.0000, 'ºC'),
	(237686, 122, '2014-03-01 01:03:04.000000', 'temperatura', 190.0000, 'ºC'),
	(237687, 122, '2014-03-01 01:03:05.000000', 'temperatura', 1083.0000, 'ºC'),
	(237688, 122, '2014-03-01 01:03:06.000000', 'temperatura', 47.0000, 'ºC'),
	(237689, 122, '2014-03-01 01:03:07.000000', 'temperatura', 586.0000, 'ºC'),
	(237690, 122, '2014-03-01 01:03:08.000000', 'temperatura', 390.0000, 'ºC'),
	(237691, 122, '2014-03-01 01:03:09.000000', 'temperatura', 190.0000, 'ºC'),
	(237692, 122, '2014-03-01 01:03:10.000000', 'temperatura', 983.0000, 'ºC'),
	(237693, 122, '2014-03-01 01:03:11.000000', 'temperatura', 745.0000, 'ºC'),
	(237694, 122, '2014-03-01 01:03:12.000000', 'temperatura', 776.0000, 'ºC'),
	(237695, 122, '2014-03-01 01:03:13.000000', 'temperatura', 444.0000, 'ºC'),
	(237696, 122, '2014-03-01 01:03:14.000000', 'temperatura', 1092.0000, 'ºC'),
	(237697, 122, '2014-03-01 01:03:15.000000', 'temperatura', 530.0000, 'ºC'),
	(237698, 122, '2014-03-01 01:03:16.000000', 'temperatura', 575.0000, 'ºC'),
	(237699, 122, '2014-03-01 01:03:17.000000', 'temperatura', 83.0000, 'ºC'),
	(237700, 122, '2014-03-01 01:03:18.000000', 'temperatura', 1093.0000, 'ºC'),
	(237701, 122, '2014-03-01 01:03:19.000000', 'temperatura', 415.0000, 'ºC'),
	(237702, 122, '2014-03-01 01:03:20.000000', 'temperatura', 1195.0000, 'ºC'),
	(237703, 122, '2014-03-01 01:03:21.000000', 'temperatura', 1134.0000, 'ºC'),
	(237704, 122, '2014-03-01 01:03:22.000000', 'temperatura', 882.0000, 'ºC'),
	(237705, 122, '2014-03-01 01:03:23.000000', 'temperatura', 1010.0000, 'ºC'),
	(237706, 122, '2014-03-01 01:03:24.000000', 'temperatura', 5.0000, 'ºC'),
	(237707, 122, '2014-03-01 01:03:25.000000', 'temperatura', 596.0000, 'ºC'),
	(237708, 122, '2014-03-01 01:03:26.000000', 'temperatura', 567.0000, 'ºC'),
	(237709, 122, '2014-03-01 01:03:27.000000', 'temperatura', 1046.0000, 'ºC'),
	(237710, 122, '2014-03-01 01:03:28.000000', 'temperatura', 1130.0000, 'ºC'),
	(237711, 122, '2014-03-01 01:03:29.000000', 'temperatura', 112.0000, 'ºC'),
	(237712, 122, '2014-03-01 01:03:30.000000', 'temperatura', 771.0000, 'ºC'),
	(237713, 122, '2014-03-01 01:03:31.000000', 'temperatura', 1120.0000, 'ºC'),
	(237714, 122, '2014-03-01 01:03:32.000000', 'temperatura', 886.0000, 'ºC'),
	(237715, 122, '2014-03-01 01:03:33.000000', 'temperatura', 1071.0000, 'ºC'),
	(237716, 122, '2014-03-01 01:03:34.000000', 'temperatura', 297.0000, 'ºC'),
	(237717, 122, '2014-03-01 01:03:35.000000', 'temperatura', 675.0000, 'ºC'),
	(237718, 122, '2014-03-01 01:03:36.000000', 'temperatura', 82.0000, 'ºC'),
	(237719, 122, '2014-03-01 01:03:37.000000', 'temperatura', 788.0000, 'ºC'),
	(237720, 122, '2014-03-01 01:03:38.000000', 'temperatura', 91.0000, 'ºC'),
	(237721, 122, '2014-03-01 01:03:39.000000', 'temperatura', 494.0000, 'ºC'),
	(237722, 122, '2014-03-01 01:03:40.000000', 'temperatura', 996.0000, 'ºC'),
	(237723, 122, '2014-03-01 01:03:41.000000', 'temperatura', 1101.0000, 'ºC'),
	(237724, 122, '2014-03-01 01:03:42.000000', 'temperatura', 115.0000, 'ºC'),
	(237725, 122, '2014-03-01 01:03:43.000000', 'temperatura', 873.0000, 'ºC'),
	(237726, 122, '2014-03-01 01:03:44.000000', 'temperatura', 420.0000, 'ºC'),
	(237727, 122, '2014-03-01 01:03:45.000000', 'temperatura', 680.0000, 'ºC'),
	(237728, 122, '2014-03-01 01:03:46.000000', 'temperatura', 942.0000, 'ºC'),
	(237729, 122, '2014-03-01 01:03:47.000000', 'temperatura', 269.0000, 'ºC'),
	(237730, 122, '2014-03-01 01:03:48.000000', 'temperatura', 922.0000, 'ºC'),
	(237731, 122, '2014-03-01 01:03:49.000000', 'temperatura', 201.0000, 'ºC'),
	(237732, 122, '2014-03-01 01:03:50.000000', 'temperatura', 639.0000, 'ºC'),
	(237733, 122, '2014-03-01 01:03:51.000000', 'temperatura', 195.0000, 'ºC'),
	(237734, 122, '2014-03-01 01:03:52.000000', 'temperatura', 257.0000, 'ºC'),
	(237735, 122, '2014-03-01 01:03:53.000000', 'temperatura', 701.0000, 'ºC'),
	(237736, 122, '2014-03-01 01:03:54.000000', 'temperatura', 334.0000, 'ºC'),
	(237737, 122, '2014-03-01 01:03:55.000000', 'temperatura', 769.0000, 'ºC'),
	(237738, 122, '2014-03-01 01:03:56.000000', 'temperatura', 442.0000, 'ºC'),
	(237739, 122, '2014-03-01 01:03:57.000000', 'temperatura', 1105.0000, 'ºC'),
	(237740, 122, '2014-03-01 01:03:58.000000', 'temperatura', 599.0000, 'ºC'),
	(237741, 122, '2014-03-01 01:03:59.000000', 'temperatura', 879.0000, 'ºC'),
	(237742, 122, '2014-03-01 01:04:00.000000', 'temperatura', 200.0000, 'ºC'),
	(237743, 122, '2014-03-01 01:04:01.000000', 'temperatura', 765.0000, 'ºC'),
	(237744, 122, '2014-03-01 01:04:02.000000', 'temperatura', 825.0000, 'ºC'),
	(237745, 122, '2014-03-01 01:04:03.000000', 'temperatura', 628.0000, 'ºC'),
	(237746, 122, '2014-03-01 01:04:04.000000', 'temperatura', 669.0000, 'ºC'),
	(237747, 122, '2014-03-01 01:04:05.000000', 'temperatura', 260.0000, 'ºC'),
	(237748, 122, '2014-03-01 01:04:06.000000', 'temperatura', 492.0000, 'ºC'),
	(237749, 122, '2014-03-01 01:04:07.000000', 'temperatura', 482.0000, 'ºC'),
	(237750, 122, '2014-03-01 01:04:08.000000', 'temperatura', 934.0000, 'ºC'),
	(237751, 122, '2014-03-01 01:04:09.000000', 'temperatura', 823.0000, 'ºC'),
	(237752, 122, '2014-03-01 01:04:10.000000', 'temperatura', 114.0000, 'ºC'),
	(237753, 122, '2014-03-01 01:04:11.000000', 'temperatura', 502.0000, 'ºC'),
	(237754, 122, '2014-03-01 01:04:12.000000', 'temperatura', 970.0000, 'ºC'),
	(237755, 122, '2014-03-01 01:04:13.000000', 'temperatura', 941.0000, 'ºC'),
	(237756, 122, '2014-03-01 01:04:14.000000', 'temperatura', 599.0000, 'ºC'),
	(237757, 122, '2014-03-01 01:04:15.000000', 'temperatura', 172.0000, 'ºC'),
	(237758, 122, '2014-03-01 01:04:16.000000', 'temperatura', 263.0000, 'ºC'),
	(237759, 122, '2014-03-01 01:04:17.000000', 'temperatura', 799.0000, 'ºC'),
	(237760, 122, '2014-03-01 01:04:18.000000', 'temperatura', 808.0000, 'ºC'),
	(237761, 122, '2014-03-01 01:04:19.000000', 'temperatura', 443.0000, 'ºC'),
	(237762, 122, '2014-03-01 01:04:20.000000', 'temperatura', 990.0000, 'ºC'),
	(237763, 122, '2014-03-01 01:04:21.000000', 'temperatura', 24.0000, 'ºC'),
	(237764, 122, '2014-03-01 01:04:22.000000', 'temperatura', 751.0000, 'ºC'),
	(237765, 122, '2014-03-01 01:04:23.000000', 'temperatura', 82.0000, 'ºC'),
	(237766, 122, '2014-03-01 01:04:24.000000', 'temperatura', 556.0000, 'ºC'),
	(237767, 122, '2014-03-01 01:04:25.000000', 'temperatura', 137.0000, 'ºC'),
	(237768, 122, '2014-03-01 01:04:26.000000', 'temperatura', 216.0000, 'ºC'),
	(237769, 122, '2014-03-01 01:04:27.000000', 'temperatura', 669.0000, 'ºC'),
	(237770, 122, '2014-03-01 01:04:28.000000', 'temperatura', 299.0000, 'ºC'),
	(237771, 122, '2014-03-01 01:04:29.000000', 'temperatura', 690.0000, 'ºC'),
	(237772, 122, '2014-03-01 01:04:30.000000', 'temperatura', 151.0000, 'ºC'),
	(237773, 122, '2014-03-01 01:04:31.000000', 'temperatura', 1085.0000, 'ºC'),
	(237774, 122, '2014-03-01 01:04:32.000000', 'temperatura', 173.0000, 'ºC'),
	(237775, 122, '2014-03-01 01:04:33.000000', 'temperatura', 10.0000, 'ºC'),
	(237776, 122, '2014-03-01 01:04:34.000000', 'temperatura', 733.0000, 'ºC'),
	(237777, 122, '2014-03-01 01:04:35.000000', 'temperatura', 35.0000, 'ºC'),
	(237778, 122, '2014-03-01 01:04:36.000000', 'temperatura', 378.0000, 'ºC'),
	(237779, 122, '2014-03-01 01:04:37.000000', 'temperatura', 586.0000, 'ºC'),
	(237780, 122, '2014-03-01 01:04:38.000000', 'temperatura', 594.0000, 'ºC'),
	(237781, 122, '2014-03-01 01:04:39.000000', 'temperatura', 12.0000, 'ºC'),
	(237782, 122, '2014-03-01 01:04:40.000000', 'temperatura', 677.0000, 'ºC'),
	(237783, 122, '2014-03-01 01:04:41.000000', 'temperatura', 953.0000, 'ºC'),
	(237784, 122, '2014-03-01 01:04:42.000000', 'temperatura', 334.0000, 'ºC'),
	(237785, 122, '2014-03-01 01:04:43.000000', 'temperatura', 12.0000, 'ºC'),
	(237786, 122, '2014-03-01 01:04:44.000000', 'temperatura', 259.0000, 'ºC'),
	(237787, 122, '2014-03-01 01:04:45.000000', 'temperatura', 57.0000, 'ºC'),
	(237788, 122, '2014-03-01 01:04:46.000000', 'temperatura', 711.0000, 'ºC'),
	(237789, 122, '2014-03-01 01:04:47.000000', 'temperatura', 982.0000, 'ºC'),
	(237790, 122, '2014-03-01 01:04:48.000000', 'temperatura', 378.0000, 'ºC'),
	(237791, 122, '2014-03-01 01:04:49.000000', 'temperatura', 145.0000, 'ºC'),
	(237792, 122, '2014-03-01 01:04:50.000000', 'temperatura', 792.0000, 'ºC'),
	(237793, 122, '2014-03-01 01:04:51.000000', 'temperatura', 1124.0000, 'ºC'),
	(237794, 122, '2014-03-01 01:04:52.000000', 'temperatura', 845.0000, 'ºC'),
	(237795, 122, '2014-03-01 01:04:53.000000', 'temperatura', 853.0000, 'ºC'),
	(237796, 122, '2014-03-01 01:04:54.000000', 'temperatura', 531.0000, 'ºC'),
	(237797, 122, '2014-03-01 01:04:55.000000', 'temperatura', 96.0000, 'ºC'),
	(237798, 122, '2014-03-01 01:04:56.000000', 'temperatura', 86.0000, 'ºC'),
	(237799, 122, '2014-03-01 01:04:57.000000', 'temperatura', 145.0000, 'ºC'),
	(237800, 122, '2014-03-01 01:04:58.000000', 'temperatura', 466.0000, 'ºC'),
	(237801, 122, '2014-03-01 01:04:59.000000', 'temperatura', 695.0000, 'ºC'),
	(237802, 122, '2014-03-01 01:05:00.000000', 'temperatura', 879.0000, 'ºC'),
	(237803, 122, '2014-03-01 01:05:01.000000', 'temperatura', 1108.0000, 'ºC'),
	(237804, 122, '2014-03-01 01:05:02.000000', 'temperatura', 507.0000, 'ºC'),
	(237805, 122, '2014-03-01 01:05:03.000000', 'temperatura', 409.0000, 'ºC'),
	(237806, 122, '2014-03-01 01:05:04.000000', 'temperatura', 524.0000, 'ºC'),
	(237807, 122, '2014-03-01 01:05:05.000000', 'temperatura', 193.0000, 'ºC'),
	(237808, 122, '2014-03-01 01:05:06.000000', 'temperatura', 593.0000, 'ºC'),
	(237809, 122, '2014-03-01 01:05:07.000000', 'temperatura', 1186.0000, 'ºC'),
	(237810, 122, '2014-03-01 01:05:08.000000', 'temperatura', 551.0000, 'ºC'),
	(237811, 122, '2014-03-01 01:05:09.000000', 'temperatura', 397.0000, 'ºC'),
	(237812, 122, '2014-03-01 01:05:10.000000', 'temperatura', 335.0000, 'ºC'),
	(237813, 122, '2014-03-01 01:05:11.000000', 'temperatura', 482.0000, 'ºC'),
	(237814, 122, '2014-03-01 01:05:12.000000', 'temperatura', 206.0000, 'ºC'),
	(237815, 122, '2014-03-01 01:05:13.000000', 'temperatura', 786.0000, 'ºC'),
	(237816, 122, '2014-03-01 01:05:14.000000', 'temperatura', 914.0000, 'ºC'),
	(237817, 122, '2014-03-01 01:05:15.000000', 'temperatura', 1009.0000, 'ºC'),
	(237818, 122, '2014-03-01 01:05:16.000000', 'temperatura', 1104.0000, 'ºC'),
	(237819, 122, '2014-03-01 01:05:17.000000', 'temperatura', 96.0000, 'ºC'),
	(237820, 122, '2014-03-01 01:05:18.000000', 'temperatura', 766.0000, 'ºC'),
	(237821, 122, '2014-03-01 01:05:19.000000', 'temperatura', 1145.0000, 'ºC'),
	(237822, 122, '2014-03-01 01:05:20.000000', 'temperatura', 1027.0000, 'ºC'),
	(237823, 122, '2014-03-01 01:05:21.000000', 'temperatura', 499.0000, 'ºC'),
	(237824, 122, '2014-03-01 01:05:22.000000', 'temperatura', 616.0000, 'ºC'),
	(237825, 122, '2014-03-01 01:05:23.000000', 'temperatura', 383.0000, 'ºC'),
	(237826, 122, '2014-03-01 01:05:24.000000', 'temperatura', 66.0000, 'ºC'),
	(237827, 122, '2014-03-01 01:05:25.000000', 'temperatura', 383.0000, 'ºC'),
	(237828, 122, '2014-03-01 01:05:26.000000', 'temperatura', 517.0000, 'ºC'),
	(237829, 122, '2014-03-01 01:05:27.000000', 'temperatura', 238.0000, 'ºC'),
	(237830, 122, '2014-03-01 01:05:28.000000', 'temperatura', 839.0000, 'ºC'),
	(237831, 122, '2014-03-01 01:05:29.000000', 'temperatura', 1083.0000, 'ºC'),
	(237832, 122, '2014-03-01 01:05:30.000000', 'temperatura', 495.0000, 'ºC'),
	(237833, 122, '2014-03-01 01:05:31.000000', 'temperatura', 429.0000, 'ºC'),
	(237834, 122, '2014-03-01 01:05:32.000000', 'temperatura', 661.0000, 'ºC'),
	(237835, 122, '2014-03-01 01:05:33.000000', 'temperatura', 817.0000, 'ºC'),
	(237836, 122, '2014-03-01 01:05:34.000000', 'temperatura', 904.0000, 'ºC'),
	(237837, 122, '2014-03-01 01:05:35.000000', 'temperatura', 870.0000, 'ºC'),
	(237838, 122, '2014-03-01 01:05:36.000000', 'temperatura', 437.0000, 'ºC'),
	(237839, 122, '2014-03-01 01:05:37.000000', 'temperatura', 776.0000, 'ºC'),
	(237840, 122, '2014-03-01 01:05:38.000000', 'temperatura', 171.0000, 'ºC'),
	(237841, 122, '2014-03-01 01:05:39.000000', 'temperatura', 927.0000, 'ºC'),
	(237842, 122, '2014-03-01 01:05:40.000000', 'temperatura', 523.0000, 'ºC'),
	(237843, 122, '2014-03-01 01:05:41.000000', 'temperatura', 1036.0000, 'ºC'),
	(237844, 122, '2014-03-01 01:05:42.000000', 'temperatura', 8.0000, 'ºC'),
	(237845, 122, '2014-03-01 01:05:43.000000', 'temperatura', 535.0000, 'ºC'),
	(237846, 122, '2014-03-01 01:05:44.000000', 'temperatura', 252.0000, 'ºC'),
	(237847, 122, '2014-03-01 01:05:45.000000', 'temperatura', 855.0000, 'ºC'),
	(237848, 122, '2014-03-01 01:05:46.000000', 'temperatura', 1119.0000, 'ºC'),
	(237849, 122, '2014-03-01 01:05:47.000000', 'temperatura', 630.0000, 'ºC'),
	(237850, 122, '2014-03-01 01:05:48.000000', 'temperatura', 994.0000, 'ºC'),
	(237851, 122, '2014-03-01 01:05:49.000000', 'temperatura', 683.0000, 'ºC'),
	(237852, 122, '2014-03-01 01:05:50.000000', 'temperatura', 430.0000, 'ºC'),
	(237853, 122, '2014-03-01 01:05:51.000000', 'temperatura', 101.0000, 'ºC'),
	(237854, 122, '2014-03-01 01:05:52.000000', 'temperatura', 417.0000, 'ºC'),
	(237855, 122, '2014-03-01 01:05:53.000000', 'temperatura', 582.0000, 'ºC'),
	(237856, 122, '2014-03-01 01:05:54.000000', 'temperatura', 462.0000, 'ºC'),
	(237857, 122, '2014-03-01 01:05:55.000000', 'temperatura', 562.0000, 'ºC'),
	(237858, 122, '2014-03-01 01:05:56.000000', 'temperatura', 226.0000, 'ºC'),
	(237859, 122, '2014-03-01 01:05:57.000000', 'temperatura', 643.0000, 'ºC'),
	(237860, 122, '2014-03-01 01:05:58.000000', 'temperatura', 136.0000, 'ºC'),
	(237861, 122, '2014-03-01 01:05:59.000000', 'temperatura', 1154.0000, 'ºC'),
	(237862, 122, '2014-03-01 01:06:00.000000', 'temperatura', 561.0000, 'ºC'),
	(237863, 122, '2014-03-01 01:06:01.000000', 'temperatura', 544.0000, 'ºC'),
	(237864, 122, '2014-03-01 01:06:02.000000', 'temperatura', 1036.0000, 'ºC'),
	(237865, 122, '2014-03-01 01:06:03.000000', 'temperatura', 1148.0000, 'ºC'),
	(237866, 122, '2014-03-01 01:06:04.000000', 'temperatura', 232.0000, 'ºC'),
	(237867, 122, '2014-03-01 01:06:05.000000', 'temperatura', 119.0000, 'ºC'),
	(237868, 122, '2014-03-01 01:06:06.000000', 'temperatura', 1098.0000, 'ºC'),
	(237869, 122, '2014-03-01 01:06:07.000000', 'temperatura', 332.0000, 'ºC'),
	(237870, 122, '2014-03-01 01:06:08.000000', 'temperatura', 770.0000, 'ºC'),
	(237871, 122, '2014-03-01 01:06:09.000000', 'temperatura', 451.0000, 'ºC'),
	(237872, 122, '2014-03-01 01:06:10.000000', 'temperatura', 1148.0000, 'ºC'),
	(237873, 122, '2014-03-01 01:06:11.000000', 'temperatura', 785.0000, 'ºC'),
	(237874, 122, '2014-03-01 01:06:12.000000', 'temperatura', 485.0000, 'ºC'),
	(237875, 122, '2014-03-01 01:06:13.000000', 'temperatura', 67.0000, 'ºC'),
	(237876, 122, '2014-03-01 01:06:14.000000', 'temperatura', 83.0000, 'ºC'),
	(237877, 122, '2014-03-01 01:06:15.000000', 'temperatura', 212.0000, 'ºC'),
	(237878, 122, '2014-03-01 01:06:16.000000', 'temperatura', 814.0000, 'ºC'),
	(237879, 122, '2014-03-01 01:06:17.000000', 'temperatura', 1034.0000, 'ºC'),
	(237880, 122, '2014-03-01 01:06:18.000000', 'temperatura', 328.0000, 'ºC'),
	(237881, 122, '2014-03-01 01:06:19.000000', 'temperatura', 941.0000, 'ºC'),
	(237882, 122, '2014-03-01 01:06:20.000000', 'temperatura', 119.0000, 'ºC'),
	(237883, 122, '2014-03-01 01:06:21.000000', 'temperatura', 171.0000, 'ºC'),
	(237884, 122, '2014-03-01 01:06:22.000000', 'temperatura', 502.0000, 'ºC'),
	(237885, 122, '2014-03-01 01:06:23.000000', 'temperatura', 796.0000, 'ºC'),
	(237886, 122, '2014-03-01 01:06:24.000000', 'temperatura', 75.0000, 'ºC'),
	(237887, 122, '2014-03-01 01:06:25.000000', 'temperatura', 387.0000, 'ºC'),
	(237888, 122, '2014-03-01 01:06:26.000000', 'temperatura', 509.0000, 'ºC'),
	(237889, 122, '2014-03-01 01:06:27.000000', 'temperatura', 186.0000, 'ºC'),
	(237890, 122, '2014-03-01 01:06:28.000000', 'temperatura', 603.0000, 'ºC'),
	(237891, 122, '2014-03-01 01:06:29.000000', 'temperatura', 58.0000, 'ºC'),
	(237892, 122, '2014-03-01 01:06:30.000000', 'temperatura', 881.0000, 'ºC'),
	(237893, 122, '2014-03-01 01:06:31.000000', 'temperatura', 632.0000, 'ºC'),
	(237894, 122, '2014-03-01 01:06:32.000000', 'temperatura', 516.0000, 'ºC'),
	(237895, 122, '2014-03-01 01:06:33.000000', 'temperatura', 685.0000, 'ºC'),
	(237896, 122, '2014-03-01 01:06:34.000000', 'temperatura', 677.0000, 'ºC'),
	(237897, 122, '2014-03-01 01:06:35.000000', 'temperatura', 132.0000, 'ºC'),
	(237898, 122, '2014-03-01 01:06:36.000000', 'temperatura', 1027.0000, 'ºC'),
	(237899, 122, '2014-03-01 01:06:37.000000', 'temperatura', 1141.0000, 'ºC'),
	(237900, 122, '2014-03-01 01:06:38.000000', 'temperatura', 225.0000, 'ºC'),
	(237901, 122, '2014-03-01 01:06:39.000000', 'temperatura', 102.0000, 'ºC'),
	(237902, 122, '2014-03-01 01:06:40.000000', 'temperatura', 1035.0000, 'ºC'),
	(237903, 122, '2014-03-01 01:06:41.000000', 'temperatura', 68.0000, 'ºC'),
	(237904, 122, '2014-03-01 01:06:42.000000', 'temperatura', 837.0000, 'ºC'),
	(237905, 122, '2014-03-01 01:06:43.000000', 'temperatura', 383.0000, 'ºC'),
	(237906, 122, '2014-03-01 01:06:44.000000', 'temperatura', 602.0000, 'ºC'),
	(237907, 122, '2014-03-01 01:06:45.000000', 'temperatura', 662.0000, 'ºC'),
	(237908, 122, '2014-03-01 01:06:46.000000', 'temperatura', 305.0000, 'ºC'),
	(237909, 122, '2014-03-01 01:06:47.000000', 'temperatura', 739.0000, 'ºC'),
	(237910, 122, '2014-03-01 01:06:48.000000', 'temperatura', 382.0000, 'ºC'),
	(237911, 122, '2014-03-01 01:06:49.000000', 'temperatura', 893.0000, 'ºC'),
	(237912, 122, '2014-03-01 01:06:50.000000', 'temperatura', 918.0000, 'ºC'),
	(237913, 122, '2014-03-01 01:06:51.000000', 'temperatura', 712.0000, 'ºC'),
	(237914, 122, '2014-03-01 01:06:52.000000', 'temperatura', 807.0000, 'ºC'),
	(237915, 122, '2014-03-01 01:06:53.000000', 'temperatura', 699.0000, 'ºC'),
	(237916, 122, '2014-03-01 01:06:54.000000', 'temperatura', 1073.0000, 'ºC'),
	(237917, 122, '2014-03-01 01:06:55.000000', 'temperatura', 870.0000, 'ºC'),
	(237918, 122, '2014-03-01 01:06:56.000000', 'temperatura', 1133.0000, 'ºC'),
	(237919, 122, '2014-03-01 01:06:57.000000', 'temperatura', 655.0000, 'ºC'),
	(237920, 122, '2014-03-01 01:06:58.000000', 'temperatura', 1076.0000, 'ºC'),
	(237921, 122, '2014-03-01 01:06:59.000000', 'temperatura', 1017.0000, 'ºC'),
	(237922, 122, '2014-03-01 01:07:00.000000', 'temperatura', 658.0000, 'ºC'),
	(237923, 122, '2014-03-01 01:07:01.000000', 'temperatura', 237.0000, 'ºC'),
	(237924, 122, '2014-03-01 01:07:02.000000', 'temperatura', 413.0000, 'ºC'),
	(237925, 122, '2014-03-01 01:07:03.000000', 'temperatura', 153.0000, 'ºC'),
	(237926, 122, '2014-03-01 01:07:04.000000', 'temperatura', 725.0000, 'ºC'),
	(237927, 122, '2014-03-01 01:07:05.000000', 'temperatura', 769.0000, 'ºC'),
	(237928, 122, '2014-03-01 01:07:06.000000', 'temperatura', 470.0000, 'ºC'),
	(237929, 122, '2014-03-01 01:07:07.000000', 'temperatura', 44.0000, 'ºC'),
	(237930, 122, '2014-03-01 01:07:08.000000', 'temperatura', 12.0000, 'ºC'),
	(237931, 122, '2014-03-01 01:07:09.000000', 'temperatura', 1127.0000, 'ºC'),
	(237932, 122, '2014-03-01 01:07:10.000000', 'temperatura', 798.0000, 'ºC'),
	(237933, 122, '2014-03-01 01:07:11.000000', 'temperatura', 609.0000, 'ºC'),
	(237934, 122, '2014-03-01 01:07:12.000000', 'temperatura', 654.0000, 'ºC'),
	(237935, 122, '2014-03-01 01:07:13.000000', 'temperatura', 241.0000, 'ºC'),
	(237936, 122, '2014-03-01 01:07:14.000000', 'temperatura', 444.0000, 'ºC'),
	(237937, 122, '2014-03-01 01:07:15.000000', 'temperatura', 298.0000, 'ºC'),
	(237938, 122, '2014-03-01 01:07:16.000000', 'temperatura', 160.0000, 'ºC'),
	(237939, 122, '2014-03-01 01:07:17.000000', 'temperatura', 1107.0000, 'ºC'),
	(237940, 122, '2014-03-01 01:07:18.000000', 'temperatura', 256.0000, 'ºC'),
	(237941, 122, '2014-03-01 01:07:19.000000', 'temperatura', 357.0000, 'ºC'),
	(237942, 122, '2014-03-01 01:07:20.000000', 'temperatura', 1018.0000, 'ºC'),
	(237943, 122, '2014-03-01 01:07:21.000000', 'temperatura', 419.0000, 'ºC'),
	(237944, 122, '2014-03-01 01:07:22.000000', 'temperatura', 241.0000, 'ºC'),
	(237945, 122, '2014-03-01 01:07:23.000000', 'temperatura', 1149.0000, 'ºC'),
	(237946, 122, '2014-03-01 01:07:24.000000', 'temperatura', 222.0000, 'ºC'),
	(237947, 122, '2014-03-01 01:07:25.000000', 'temperatura', 66.0000, 'ºC'),
	(237948, 122, '2014-03-01 01:07:26.000000', 'temperatura', 862.0000, 'ºC'),
	(237949, 122, '2014-03-01 01:07:27.000000', 'temperatura', 513.0000, 'ºC'),
	(237950, 122, '2014-03-01 01:07:28.000000', 'temperatura', 1178.0000, 'ºC'),
	(237951, 122, '2014-03-01 01:07:29.000000', 'temperatura', 754.0000, 'ºC'),
	(237952, 122, '2014-03-01 01:07:30.000000', 'temperatura', 235.0000, 'ºC'),
	(237953, 122, '2014-03-01 01:07:31.000000', 'temperatura', 114.0000, 'ºC'),
	(237954, 122, '2014-03-01 01:07:32.000000', 'temperatura', 1064.0000, 'ºC'),
	(237955, 122, '2014-03-01 01:07:33.000000', 'temperatura', 180.0000, 'ºC'),
	(237956, 122, '2014-03-01 01:07:34.000000', 'temperatura', 107.0000, 'ºC'),
	(237957, 122, '2014-03-01 01:07:35.000000', 'temperatura', 1194.0000, 'ºC'),
	(237958, 122, '2014-03-01 01:07:36.000000', 'temperatura', 852.0000, 'ºC'),
	(237959, 122, '2014-03-01 01:07:37.000000', 'temperatura', 680.0000, 'ºC'),
	(237960, 122, '2014-03-01 01:07:38.000000', 'temperatura', 842.0000, 'ºC'),
	(237961, 122, '2014-03-01 01:07:39.000000', 'temperatura', 973.0000, 'ºC'),
	(237962, 122, '2014-03-01 01:07:40.000000', 'temperatura', 1137.0000, 'ºC'),
	(237963, 122, '2014-03-01 01:07:41.000000', 'temperatura', 369.0000, 'ºC'),
	(237964, 122, '2014-03-01 01:07:42.000000', 'temperatura', 833.0000, 'ºC'),
	(237965, 122, '2014-03-01 01:07:43.000000', 'temperatura', 658.0000, 'ºC'),
	(237966, 122, '2014-03-01 01:07:44.000000', 'temperatura', 790.0000, 'ºC'),
	(237967, 122, '2014-03-01 01:07:45.000000', 'temperatura', 780.0000, 'ºC'),
	(237968, 122, '2014-03-01 01:07:46.000000', 'temperatura', 329.0000, 'ºC'),
	(237969, 122, '2014-03-01 01:07:47.000000', 'temperatura', 504.0000, 'ºC'),
	(237970, 122, '2014-03-01 01:07:48.000000', 'temperatura', 334.0000, 'ºC'),
	(237971, 122, '2014-03-01 01:07:49.000000', 'temperatura', 158.0000, 'ºC'),
	(237972, 122, '2014-03-01 01:07:50.000000', 'temperatura', 991.0000, 'ºC'),
	(237973, 122, '2014-03-01 01:07:51.000000', 'temperatura', 879.0000, 'ºC'),
	(237974, 122, '2014-03-01 01:07:52.000000', 'temperatura', 221.0000, 'ºC'),
	(237975, 122, '2014-03-01 01:07:53.000000', 'temperatura', 872.0000, 'ºC'),
	(237976, 122, '2014-03-01 01:07:54.000000', 'temperatura', 94.0000, 'ºC'),
	(237977, 122, '2014-03-01 01:07:55.000000', 'temperatura', 257.0000, 'ºC'),
	(237978, 122, '2014-03-01 01:07:56.000000', 'temperatura', 1004.0000, 'ºC'),
	(237979, 122, '2014-03-01 01:07:57.000000', 'temperatura', 647.0000, 'ºC'),
	(237980, 122, '2014-03-01 01:07:58.000000', 'temperatura', 226.0000, 'ºC'),
	(237981, 122, '2014-03-01 01:07:59.000000', 'temperatura', 390.0000, 'ºC'),
	(237982, 122, '2014-03-01 01:08:00.000000', 'temperatura', 72.0000, 'ºC'),
	(237983, 122, '2014-03-01 01:08:01.000000', 'temperatura', 392.0000, 'ºC'),
	(237984, 122, '2014-03-01 01:08:02.000000', 'temperatura', 542.0000, 'ºC'),
	(237985, 122, '2014-03-01 01:08:03.000000', 'temperatura', 333.0000, 'ºC'),
	(237986, 122, '2014-03-01 01:08:04.000000', 'temperatura', 43.0000, 'ºC'),
	(237987, 122, '2014-03-01 01:08:05.000000', 'temperatura', 415.0000, 'ºC'),
	(237988, 122, '2014-03-01 01:08:06.000000', 'temperatura', 749.0000, 'ºC'),
	(237989, 122, '2014-03-01 01:08:07.000000', 'temperatura', 98.0000, 'ºC'),
	(237990, 122, '2014-03-01 01:08:08.000000', 'temperatura', 643.0000, 'ºC'),
	(237991, 122, '2014-03-01 01:08:09.000000', 'temperatura', 520.0000, 'ºC'),
	(237992, 122, '2014-03-01 01:08:10.000000', 'temperatura', 674.0000, 'ºC'),
	(237993, 122, '2014-03-01 01:08:11.000000', 'temperatura', 611.0000, 'ºC'),
	(237994, 122, '2014-03-01 01:08:12.000000', 'temperatura', 1035.0000, 'ºC'),
	(237995, 122, '2014-03-01 01:08:13.000000', 'temperatura', 939.0000, 'ºC'),
	(237996, 122, '2014-03-01 01:08:14.000000', 'temperatura', 393.0000, 'ºC'),
	(237997, 122, '2014-03-01 01:08:15.000000', 'temperatura', 349.0000, 'ºC'),
	(237998, 122, '2014-03-01 01:08:16.000000', 'temperatura', 564.0000, 'ºC'),
	(237999, 122, '2014-03-01 01:08:17.000000', 'temperatura', 573.0000, 'ºC'),
	(238000, 122, '2014-03-01 01:08:18.000000', 'temperatura', 1173.0000, 'ºC'),
	(238001, 122, '2014-03-01 01:08:19.000000', 'temperatura', 547.0000, 'ºC'),
	(238002, 122, '2014-03-01 01:08:20.000000', 'temperatura', 417.0000, 'ºC'),
	(238003, 122, '2014-03-01 01:08:21.000000', 'temperatura', 445.0000, 'ºC'),
	(238004, 122, '2014-03-01 01:08:22.000000', 'temperatura', 976.0000, 'ºC'),
	(238005, 122, '2014-03-01 01:08:23.000000', 'temperatura', 1145.0000, 'ºC'),
	(238006, 122, '2014-03-01 01:08:24.000000', 'temperatura', 397.0000, 'ºC'),
	(238007, 122, '2014-03-01 01:08:25.000000', 'temperatura', 952.0000, 'ºC'),
	(238008, 122, '2014-03-01 01:08:26.000000', 'temperatura', 1169.0000, 'ºC'),
	(238009, 122, '2014-03-01 01:08:27.000000', 'temperatura', 590.0000, 'ºC'),
	(238010, 122, '2014-03-01 01:08:28.000000', 'temperatura', 642.0000, 'ºC'),
	(238011, 122, '2014-03-01 01:08:29.000000', 'temperatura', 240.0000, 'ºC'),
	(238012, 122, '2014-03-01 01:08:30.000000', 'temperatura', 475.0000, 'ºC'),
	(238013, 122, '2014-03-01 01:08:31.000000', 'temperatura', 458.0000, 'ºC'),
	(238014, 122, '2014-03-01 01:08:32.000000', 'temperatura', 862.0000, 'ºC'),
	(238015, 122, '2014-03-01 01:08:33.000000', 'temperatura', 539.0000, 'ºC'),
	(238016, 122, '2014-03-01 01:08:34.000000', 'temperatura', 110.0000, 'ºC'),
	(238017, 122, '2014-03-01 01:08:35.000000', 'temperatura', 132.0000, 'ºC'),
	(238018, 122, '2014-03-01 01:08:36.000000', 'temperatura', 330.0000, 'ºC'),
	(238019, 122, '2014-03-01 01:08:37.000000', 'temperatura', 56.0000, 'ºC'),
	(238020, 122, '2014-03-01 01:08:38.000000', 'temperatura', 489.0000, 'ºC'),
	(238021, 122, '2014-03-01 01:08:39.000000', 'temperatura', 1080.0000, 'ºC'),
	(238022, 122, '2014-03-01 01:08:40.000000', 'temperatura', 333.0000, 'ºC'),
	(238023, 122, '2014-03-01 01:08:41.000000', 'temperatura', 823.0000, 'ºC'),
	(238024, 122, '2014-03-01 01:08:42.000000', 'temperatura', 718.0000, 'ºC'),
	(238025, 122, '2014-03-01 01:08:43.000000', 'temperatura', 1120.0000, 'ºC'),
	(238026, 122, '2014-03-01 01:08:44.000000', 'temperatura', 1048.0000, 'ºC'),
	(238027, 122, '2014-03-01 01:08:45.000000', 'temperatura', 679.0000, 'ºC'),
	(238028, 122, '2014-03-01 01:08:46.000000', 'temperatura', 254.0000, 'ºC'),
	(238029, 122, '2014-03-01 01:08:47.000000', 'temperatura', 434.0000, 'ºC'),
	(238030, 122, '2014-03-01 01:08:48.000000', 'temperatura', 206.0000, 'ºC'),
	(238031, 122, '2014-03-01 01:08:49.000000', 'temperatura', 929.0000, 'ºC'),
	(238032, 122, '2014-03-01 01:08:50.000000', 'temperatura', 429.0000, 'ºC'),
	(238033, 122, '2014-03-01 01:08:51.000000', 'temperatura', 558.0000, 'ºC'),
	(238034, 122, '2014-03-01 01:08:52.000000', 'temperatura', 302.0000, 'ºC'),
	(238035, 122, '2014-03-01 01:08:53.000000', 'temperatura', 1037.0000, 'ºC'),
	(238036, 122, '2014-03-01 01:08:54.000000', 'temperatura', 682.0000, 'ºC'),
	(238037, 122, '2014-03-01 01:08:55.000000', 'temperatura', 297.0000, 'ºC'),
	(238038, 122, '2014-03-01 01:08:56.000000', 'temperatura', 641.0000, 'ºC'),
	(238039, 122, '2014-03-01 01:08:57.000000', 'temperatura', 1115.0000, 'ºC'),
	(238040, 122, '2014-03-01 01:08:58.000000', 'temperatura', 51.0000, 'ºC'),
	(238041, 122, '2014-03-01 01:08:59.000000', 'temperatura', 512.0000, 'ºC'),
	(238042, 122, '2014-03-01 01:09:00.000000', 'temperatura', 5.0000, 'ºC'),
	(238043, 122, '2014-03-01 01:09:01.000000', 'temperatura', 889.0000, 'ºC'),
	(238044, 122, '2014-03-01 01:09:02.000000', 'temperatura', 833.0000, 'ºC'),
	(238045, 122, '2014-03-01 01:09:03.000000', 'temperatura', 299.0000, 'ºC'),
	(238046, 122, '2014-03-01 01:09:04.000000', 'temperatura', 195.0000, 'ºC'),
	(238047, 122, '2014-03-01 01:09:05.000000', 'temperatura', 80.0000, 'ºC'),
	(238048, 122, '2014-03-01 01:09:06.000000', 'temperatura', 1013.0000, 'ºC'),
	(238049, 122, '2014-03-01 01:09:07.000000', 'temperatura', 26.0000, 'ºC'),
	(238050, 122, '2014-03-01 01:09:08.000000', 'temperatura', 690.0000, 'ºC'),
	(238051, 122, '2014-03-01 01:09:09.000000', 'temperatura', 976.0000, 'ºC'),
	(238052, 122, '2014-03-01 01:09:10.000000', 'temperatura', 408.0000, 'ºC'),
	(238053, 122, '2014-03-01 01:09:11.000000', 'temperatura', 313.0000, 'ºC'),
	(238054, 122, '2014-03-01 01:09:12.000000', 'temperatura', 341.0000, 'ºC'),
	(238055, 122, '2014-03-01 01:09:13.000000', 'temperatura', 766.0000, 'ºC'),
	(238056, 122, '2014-03-01 01:09:14.000000', 'temperatura', 409.0000, 'ºC'),
	(238057, 122, '2014-03-01 01:09:15.000000', 'temperatura', 947.0000, 'ºC'),
	(238058, 122, '2014-03-01 01:09:16.000000', 'temperatura', 1106.0000, 'ºC'),
	(238059, 122, '2014-03-01 01:09:17.000000', 'temperatura', 293.0000, 'ºC'),
	(238060, 122, '2014-03-01 01:09:18.000000', 'temperatura', 544.0000, 'ºC'),
	(238061, 122, '2014-03-01 01:09:19.000000', 'temperatura', 644.0000, 'ºC'),
	(238062, 122, '2014-03-01 01:09:20.000000', 'temperatura', 388.0000, 'ºC'),
	(238063, 122, '2014-03-01 01:09:21.000000', 'temperatura', 9.0000, 'ºC'),
	(238064, 122, '2014-03-01 01:09:22.000000', 'temperatura', 83.0000, 'ºC'),
	(238065, 122, '2014-03-01 01:09:23.000000', 'temperatura', 386.0000, 'ºC'),
	(238066, 122, '2014-03-01 01:09:24.000000', 'temperatura', 480.0000, 'ºC'),
	(238067, 122, '2014-03-01 01:09:25.000000', 'temperatura', 46.0000, 'ºC'),
	(238068, 122, '2014-03-01 01:09:26.000000', 'temperatura', 1187.0000, 'ºC'),
	(238069, 122, '2014-03-01 01:09:27.000000', 'temperatura', 1000.0000, 'ºC'),
	(238070, 122, '2014-03-01 01:09:28.000000', 'temperatura', 237.0000, 'ºC'),
	(238071, 122, '2014-03-01 01:09:29.000000', 'temperatura', 585.0000, 'ºC'),
	(238072, 122, '2014-03-01 01:09:30.000000', 'temperatura', 1018.0000, 'ºC'),
	(238073, 122, '2014-03-01 01:09:31.000000', 'temperatura', 933.0000, 'ºC'),
	(238074, 122, '2014-03-01 01:09:32.000000', 'temperatura', 411.0000, 'ºC'),
	(238075, 122, '2014-03-01 01:09:33.000000', 'temperatura', 459.0000, 'ºC'),
	(238076, 122, '2014-03-01 01:09:34.000000', 'temperatura', 1061.0000, 'ºC'),
	(238077, 122, '2014-03-01 01:09:35.000000', 'temperatura', 329.0000, 'ºC'),
	(238078, 122, '2014-03-01 01:09:36.000000', 'temperatura', 862.0000, 'ºC'),
	(238079, 122, '2014-03-01 01:09:37.000000', 'temperatura', 926.0000, 'ºC'),
	(238080, 122, '2014-03-01 01:09:38.000000', 'temperatura', 842.0000, 'ºC'),
	(238081, 122, '2014-03-01 01:09:39.000000', 'temperatura', 231.0000, 'ºC'),
	(238082, 122, '2014-03-01 01:09:40.000000', 'temperatura', 1032.0000, 'ºC'),
	(238083, 122, '2014-03-01 01:09:41.000000', 'temperatura', 867.0000, 'ºC'),
	(238084, 122, '2014-03-01 01:09:42.000000', 'temperatura', 41.0000, 'ºC'),
	(238085, 122, '2014-03-01 01:09:43.000000', 'temperatura', 5.0000, 'ºC'),
	(238086, 122, '2014-03-01 01:09:44.000000', 'temperatura', 1101.0000, 'ºC'),
	(238087, 122, '2014-03-01 01:09:45.000000', 'temperatura', 691.0000, 'ºC'),
	(238088, 122, '2014-03-01 01:09:46.000000', 'temperatura', 153.0000, 'ºC'),
	(238089, 122, '2014-03-01 01:09:47.000000', 'temperatura', 1094.0000, 'ºC'),
	(238090, 122, '2014-03-01 01:09:48.000000', 'temperatura', 209.0000, 'ºC'),
	(238091, 122, '2014-03-01 01:09:49.000000', 'temperatura', 163.0000, 'ºC'),
	(238092, 122, '2014-03-01 01:09:50.000000', 'temperatura', 190.0000, 'ºC'),
	(238093, 122, '2014-03-01 01:09:51.000000', 'temperatura', 460.0000, 'ºC'),
	(238094, 122, '2014-03-01 01:09:52.000000', 'temperatura', 532.0000, 'ºC'),
	(238095, 122, '2014-03-01 01:09:53.000000', 'temperatura', 80.0000, 'ºC'),
	(238096, 122, '2014-03-01 01:09:54.000000', 'temperatura', 5.0000, 'ºC'),
	(238097, 122, '2014-03-01 01:09:55.000000', 'temperatura', 985.0000, 'ºC'),
	(238098, 122, '2014-03-01 01:09:56.000000', 'temperatura', 112.0000, 'ºC'),
	(238099, 122, '2014-03-01 01:09:57.000000', 'temperatura', 5.0000, 'ºC'),
	(238100, 122, '2014-03-01 01:09:58.000000', 'temperatura', 889.0000, 'ºC'),
	(238101, 122, '2014-03-01 01:09:59.000000', 'temperatura', 831.0000, 'ºC'),
	(238102, 122, '2014-03-01 01:10:00.000000', 'temperatura', 287.0000, 'ºC'),
	(238103, 122, '2014-03-01 01:10:01.000000', 'temperatura', 145.0000, 'ºC'),
	(238104, 122, '2014-03-01 01:10:02.000000', 'temperatura', 1062.0000, 'ºC'),
	(238105, 122, '2014-03-01 01:10:03.000000', 'temperatura', 76.0000, 'ºC'),
	(238106, 122, '2014-03-01 01:10:04.000000', 'temperatura', 794.0000, 'ºC'),
	(238107, 122, '2014-03-01 01:10:05.000000', 'temperatura', 143.0000, 'ºC'),
	(238108, 122, '2014-03-01 01:10:06.000000', 'temperatura', 732.0000, 'ºC'),
	(238109, 122, '2014-03-01 01:10:07.000000', 'temperatura', 831.0000, 'ºC'),
	(238110, 122, '2014-03-01 01:10:08.000000', 'temperatura', 760.0000, 'ºC'),
	(238111, 122, '2014-03-01 01:10:09.000000', 'temperatura', 108.0000, 'ºC'),
	(238112, 122, '2014-03-01 01:10:10.000000', 'temperatura', 661.0000, 'ºC'),
	(238113, 122, '2014-03-01 01:10:11.000000', 'temperatura', 582.0000, 'ºC'),
	(238114, 122, '2014-03-01 01:10:12.000000', 'temperatura', 928.0000, 'ºC'),
	(238115, 122, '2014-03-01 01:10:13.000000', 'temperatura', 495.0000, 'ºC'),
	(238116, 122, '2014-03-01 01:10:14.000000', 'temperatura', 889.0000, 'ºC'),
	(238117, 122, '2014-03-01 01:10:15.000000', 'temperatura', 563.0000, 'ºC'),
	(238118, 122, '2014-03-01 01:10:16.000000', 'temperatura', 148.0000, 'ºC'),
	(238119, 122, '2014-03-01 01:10:17.000000', 'temperatura', 249.0000, 'ºC'),
	(238120, 122, '2014-03-01 01:10:18.000000', 'temperatura', 804.0000, 'ºC'),
	(238121, 122, '2014-03-01 01:10:19.000000', 'temperatura', 874.0000, 'ºC'),
	(238122, 122, '2014-03-01 01:10:20.000000', 'temperatura', 759.0000, 'ºC'),
	(238123, 122, '2014-03-01 01:10:21.000000', 'temperatura', 1171.0000, 'ºC'),
	(238124, 122, '2014-03-01 01:10:22.000000', 'temperatura', 1181.0000, 'ºC'),
	(238125, 122, '2014-03-01 01:10:23.000000', 'temperatura', 1192.0000, 'ºC'),
	(238126, 122, '2014-03-01 01:10:24.000000', 'temperatura', 19.0000, 'ºC'),
	(238127, 122, '2014-03-01 01:10:25.000000', 'temperatura', 118.0000, 'ºC'),
	(238128, 122, '2014-03-01 01:10:26.000000', 'temperatura', 535.0000, 'ºC'),
	(238129, 122, '2014-03-01 01:10:27.000000', 'temperatura', 1119.0000, 'ºC'),
	(238130, 122, '2014-03-01 01:10:28.000000', 'temperatura', 392.0000, 'ºC'),
	(238131, 122, '2014-03-01 01:10:29.000000', 'temperatura', 1002.0000, 'ºC'),
	(238132, 122, '2014-03-01 01:10:30.000000', 'temperatura', 235.0000, 'ºC'),
	(238133, 122, '2014-03-01 01:10:31.000000', 'temperatura', 571.0000, 'ºC'),
	(238134, 122, '2014-03-01 01:10:32.000000', 'temperatura', 950.0000, 'ºC'),
	(238135, 122, '2014-03-01 01:10:33.000000', 'temperatura', 637.0000, 'ºC'),
	(238136, 122, '2014-03-01 01:10:34.000000', 'temperatura', 335.0000, 'ºC'),
	(238137, 122, '2014-03-01 01:10:35.000000', 'temperatura', 964.0000, 'ºC'),
	(238138, 122, '2014-03-01 01:10:36.000000', 'temperatura', 214.0000, 'ºC'),
	(238139, 122, '2014-03-01 01:10:37.000000', 'temperatura', 580.0000, 'ºC'),
	(238140, 122, '2014-03-01 01:10:38.000000', 'temperatura', 1060.0000, 'ºC'),
	(238141, 122, '2014-03-01 01:10:39.000000', 'temperatura', 1160.0000, 'ºC'),
	(238142, 122, '2014-03-01 01:10:40.000000', 'temperatura', 220.0000, 'ºC'),
	(238143, 122, '2014-03-01 01:10:41.000000', 'temperatura', 21.0000, 'ºC'),
	(238144, 122, '2014-03-01 01:10:42.000000', 'temperatura', 646.0000, 'ºC'),
	(238145, 122, '2014-03-01 01:10:43.000000', 'temperatura', 768.0000, 'ºC'),
	(238146, 122, '2014-03-01 01:10:44.000000', 'temperatura', 703.0000, 'ºC'),
	(238147, 122, '2014-03-01 01:10:45.000000', 'temperatura', 12.0000, 'ºC'),
	(238148, 122, '2014-03-01 01:10:46.000000', 'temperatura', 352.0000, 'ºC'),
	(238149, 122, '2014-03-01 01:10:47.000000', 'temperatura', 523.0000, 'ºC'),
	(238150, 122, '2014-03-01 01:10:48.000000', 'temperatura', 358.0000, 'ºC'),
	(238151, 122, '2014-03-01 01:10:49.000000', 'temperatura', 222.0000, 'ºC'),
	(238152, 122, '2014-03-01 01:10:50.000000', 'temperatura', 36.0000, 'ºC'),
	(238153, 122, '2014-03-01 01:10:51.000000', 'temperatura', 715.0000, 'ºC'),
	(238154, 122, '2014-03-01 01:10:52.000000', 'temperatura', 1069.0000, 'ºC'),
	(238155, 122, '2014-03-01 01:10:53.000000', 'temperatura', 801.0000, 'ºC'),
	(238156, 122, '2014-03-01 01:10:54.000000', 'temperatura', 796.0000, 'ºC'),
	(238157, 122, '2014-03-01 01:10:55.000000', 'temperatura', 377.0000, 'ºC'),
	(238158, 122, '2014-03-01 01:10:56.000000', 'temperatura', 698.0000, 'ºC'),
	(238159, 122, '2014-03-01 01:10:57.000000', 'temperatura', 1159.0000, 'ºC'),
	(238160, 122, '2014-03-01 01:10:58.000000', 'temperatura', 104.0000, 'ºC'),
	(238161, 122, '2014-03-01 01:10:59.000000', 'temperatura', 642.0000, 'ºC'),
	(238162, 122, '2014-03-01 01:11:00.000000', 'temperatura', 500.0000, 'ºC'),
	(238163, 122, '2014-03-01 01:11:01.000000', 'temperatura', 575.0000, 'ºC'),
	(238164, 122, '2014-03-01 01:11:02.000000', 'temperatura', 173.0000, 'ºC'),
	(238165, 122, '2014-03-01 01:11:03.000000', 'temperatura', 341.0000, 'ºC'),
	(238166, 122, '2014-03-01 01:11:04.000000', 'temperatura', 1185.0000, 'ºC'),
	(238167, 122, '2014-03-01 01:11:05.000000', 'temperatura', 103.0000, 'ºC'),
	(238168, 122, '2014-03-01 01:11:06.000000', 'temperatura', 559.0000, 'ºC'),
	(238169, 122, '2014-03-01 01:11:07.000000', 'temperatura', 90.0000, 'ºC'),
	(238170, 122, '2014-03-01 01:11:08.000000', 'temperatura', 1172.0000, 'ºC'),
	(238171, 122, '2014-03-01 01:11:09.000000', 'temperatura', 792.0000, 'ºC'),
	(238172, 122, '2014-03-01 01:11:10.000000', 'temperatura', 446.0000, 'ºC'),
	(238173, 122, '2014-03-01 01:11:11.000000', 'temperatura', 1051.0000, 'ºC'),
	(238174, 122, '2014-03-01 01:11:12.000000', 'temperatura', 317.0000, 'ºC'),
	(238175, 122, '2014-03-01 01:11:13.000000', 'temperatura', 834.0000, 'ºC'),
	(238176, 122, '2014-03-01 01:11:14.000000', 'temperatura', 819.0000, 'ºC'),
	(238177, 122, '2014-03-01 01:11:15.000000', 'temperatura', 392.0000, 'ºC'),
	(238178, 122, '2014-03-01 01:11:16.000000', 'temperatura', 706.0000, 'ºC'),
	(238179, 122, '2014-03-01 01:11:17.000000', 'temperatura', 1153.0000, 'ºC'),
	(238180, 122, '2014-03-01 01:11:18.000000', 'temperatura', 47.0000, 'ºC'),
	(238181, 122, '2014-03-01 01:11:19.000000', 'temperatura', 378.0000, 'ºC'),
	(238182, 122, '2014-03-01 01:11:20.000000', 'temperatura', 548.0000, 'ºC'),
	(238183, 122, '2014-03-01 01:11:21.000000', 'temperatura', 406.0000, 'ºC'),
	(238184, 122, '2014-03-01 01:11:22.000000', 'temperatura', 387.0000, 'ºC'),
	(238185, 122, '2014-03-01 01:11:23.000000', 'temperatura', 719.0000, 'ºC'),
	(238186, 122, '2014-03-01 01:11:24.000000', 'temperatura', 34.0000, 'ºC'),
	(238187, 122, '2014-03-01 01:11:25.000000', 'temperatura', 412.0000, 'ºC'),
	(238188, 122, '2014-03-01 01:11:26.000000', 'temperatura', 760.0000, 'ºC'),
	(238189, 122, '2014-03-01 01:11:27.000000', 'temperatura', 162.0000, 'ºC'),
	(238190, 122, '2014-03-01 01:11:28.000000', 'temperatura', 933.0000, 'ºC'),
	(238191, 122, '2014-03-01 01:11:29.000000', 'temperatura', 580.0000, 'ºC'),
	(238192, 122, '2014-03-01 01:11:30.000000', 'temperatura', 100.0000, 'ºC'),
	(238193, 122, '2014-03-01 01:11:31.000000', 'temperatura', 1159.0000, 'ºC'),
	(238194, 122, '2014-03-01 01:11:32.000000', 'temperatura', 697.0000, 'ºC'),
	(238195, 122, '2014-03-01 01:11:33.000000', 'temperatura', 7.0000, 'ºC'),
	(238196, 122, '2014-03-01 01:11:34.000000', 'temperatura', 344.0000, 'ºC'),
	(238197, 122, '2014-03-01 01:11:35.000000', 'temperatura', 502.0000, 'ºC'),
	(238198, 122, '2014-03-01 01:11:36.000000', 'temperatura', 276.0000, 'ºC'),
	(238199, 122, '2014-03-01 01:11:37.000000', 'temperatura', 1074.0000, 'ºC'),
	(238200, 122, '2014-03-01 01:11:38.000000', 'temperatura', 944.0000, 'ºC'),
	(238201, 122, '2014-03-01 01:11:39.000000', 'temperatura', 297.0000, 'ºC'),
	(238202, 122, '2014-03-01 01:11:40.000000', 'temperatura', 1056.0000, 'ºC'),
	(238203, 122, '2014-03-01 01:11:41.000000', 'temperatura', 786.0000, 'ºC'),
	(238204, 122, '2014-03-01 01:11:42.000000', 'temperatura', 766.0000, 'ºC'),
	(238205, 122, '2014-03-01 01:11:43.000000', 'temperatura', 272.0000, 'ºC'),
	(238206, 122, '2014-03-01 01:11:44.000000', 'temperatura', 261.0000, 'ºC'),
	(238207, 122, '2014-03-01 01:11:45.000000', 'temperatura', 491.0000, 'ºC'),
	(238208, 122, '2014-03-01 01:11:46.000000', 'temperatura', 472.0000, 'ºC'),
	(238209, 122, '2014-03-01 01:11:47.000000', 'temperatura', 887.0000, 'ºC'),
	(238210, 122, '2014-03-01 01:11:48.000000', 'temperatura', 619.0000, 'ºC'),
	(238211, 122, '2014-03-01 01:11:49.000000', 'temperatura', 436.0000, 'ºC'),
	(238212, 122, '2014-03-01 01:11:50.000000', 'temperatura', 325.0000, 'ºC'),
	(238213, 122, '2014-03-01 01:11:51.000000', 'temperatura', 315.0000, 'ºC'),
	(238214, 122, '2014-03-01 01:11:52.000000', 'temperatura', 601.0000, 'ºC'),
	(238215, 122, '2014-03-01 01:11:53.000000', 'temperatura', 862.0000, 'ºC'),
	(238216, 122, '2014-03-01 01:11:54.000000', 'temperatura', 106.0000, 'ºC'),
	(238217, 122, '2014-03-01 01:11:55.000000', 'temperatura', 345.0000, 'ºC'),
	(238218, 122, '2014-03-01 01:11:56.000000', 'temperatura', 207.0000, 'ºC'),
	(238219, 122, '2014-03-01 01:11:57.000000', 'temperatura', 1199.0000, 'ºC'),
	(238220, 122, '2014-03-01 01:11:58.000000', 'temperatura', 577.0000, 'ºC'),
	(238221, 122, '2014-03-01 01:11:59.000000', 'temperatura', 486.0000, 'ºC'),
	(238222, 122, '2014-03-01 01:12:00.000000', 'temperatura', 702.0000, 'ºC'),
	(238223, 122, '2014-03-01 01:12:01.000000', 'temperatura', 854.0000, 'ºC'),
	(238224, 122, '2014-03-01 01:12:02.000000', 'temperatura', 961.0000, 'ºC'),
	(238225, 122, '2014-03-01 01:12:03.000000', 'temperatura', 1046.0000, 'ºC'),
	(238226, 122, '2014-03-01 01:12:04.000000', 'temperatura', 1146.0000, 'ºC'),
	(238227, 122, '2014-03-01 01:12:05.000000', 'temperatura', 191.0000, 'ºC'),
	(238228, 122, '2014-03-01 01:12:06.000000', 'temperatura', 1121.0000, 'ºC'),
	(238229, 122, '2014-03-01 01:12:07.000000', 'temperatura', 230.0000, 'ºC'),
	(238230, 122, '2014-03-01 01:12:08.000000', 'temperatura', 189.0000, 'ºC'),
	(238231, 122, '2014-03-01 01:12:09.000000', 'temperatura', 257.0000, 'ºC'),
	(238232, 122, '2014-03-01 01:12:10.000000', 'temperatura', 716.0000, 'ºC'),
	(238233, 122, '2014-03-01 01:12:11.000000', 'temperatura', 411.0000, 'ºC'),
	(238234, 122, '2014-03-01 01:12:12.000000', 'temperatura', 1105.0000, 'ºC'),
	(238235, 122, '2014-03-01 01:12:13.000000', 'temperatura', 694.0000, 'ºC'),
	(238236, 122, '2014-03-01 01:12:14.000000', 'temperatura', 155.0000, 'ºC'),
	(238237, 122, '2014-03-01 01:12:15.000000', 'temperatura', 1095.0000, 'ºC'),
	(238238, 122, '2014-03-01 01:12:16.000000', 'temperatura', 208.0000, 'ºC'),
	(238239, 122, '2014-03-01 01:12:17.000000', 'temperatura', 155.0000, 'ºC'),
	(238240, 122, '2014-03-01 01:12:18.000000', 'temperatura', 152.0000, 'ºC'),
	(238241, 122, '2014-03-01 01:12:19.000000', 'temperatura', 295.0000, 'ºC'),
	(238242, 122, '2014-03-01 01:12:20.000000', 'temperatura', 1020.0000, 'ºC'),
	(238243, 122, '2014-03-01 01:12:21.000000', 'temperatura', 616.0000, 'ºC'),
	(238244, 122, '2014-03-01 01:12:22.000000', 'temperatura', 20.0000, 'ºC'),
	(238245, 122, '2014-03-01 01:12:23.000000', 'temperatura', 651.0000, 'ºC'),
	(238246, 122, '2014-03-01 01:12:24.000000', 'temperatura', 796.0000, 'ºC'),
	(238247, 122, '2014-03-01 01:12:25.000000', 'temperatura', 826.0000, 'ºC'),
	(238248, 122, '2014-03-01 01:12:26.000000', 'temperatura', 544.0000, 'ºC'),
	(238249, 122, '2014-03-01 01:12:27.000000', 'temperatura', 244.0000, 'ºC'),
	(238250, 122, '2014-03-01 01:12:28.000000', 'temperatura', 787.0000, 'ºC'),
	(238251, 122, '2014-03-01 01:12:29.000000', 'temperatura', 805.0000, 'ºC'),
	(238252, 122, '2014-03-01 01:12:30.000000', 'temperatura', 465.0000, 'ºC'),
	(238253, 122, '2014-03-01 01:12:31.000000', 'temperatura', 1112.0000, 'ºC'),
	(238254, 122, '2014-03-01 01:12:32.000000', 'temperatura', 562.0000, 'ºC'),
	(238255, 122, '2014-03-01 01:12:33.000000', 'temperatura', 674.0000, 'ºC'),
	(238256, 122, '2014-03-01 01:12:34.000000', 'temperatura', 487.0000, 'ºC'),
	(238257, 122, '2014-03-01 01:12:35.000000', 'temperatura', 412.0000, 'ºC'),
	(238258, 122, '2014-03-01 01:12:36.000000', 'temperatura', 601.0000, 'ºC'),
	(238259, 122, '2014-03-01 01:12:37.000000', 'temperatura', 567.0000, 'ºC'),
	(238260, 122, '2014-03-01 01:12:38.000000', 'temperatura', 1032.0000, 'ºC'),
	(238261, 122, '2014-03-01 01:12:39.000000', 'temperatura', 1061.0000, 'ºC'),
	(238262, 122, '2014-03-01 01:12:40.000000', 'temperatura', 1011.0000, 'ºC'),
	(238263, 122, '2014-03-01 01:12:41.000000', 'temperatura', 672.0000, 'ºC'),
	(238264, 122, '2014-03-01 01:12:42.000000', 'temperatura', 329.0000, 'ºC'),
	(238265, 122, '2014-03-01 01:12:43.000000', 'temperatura', 828.0000, 'ºC'),
	(238266, 122, '2014-03-01 01:12:44.000000', 'temperatura', 755.0000, 'ºC'),
	(238267, 122, '2014-03-01 01:12:45.000000', 'temperatura', 93.0000, 'ºC'),
	(238268, 122, '2014-03-01 01:12:46.000000', 'temperatura', 597.0000, 'ºC'),
	(238269, 122, '2014-03-01 01:12:47.000000', 'temperatura', 307.0000, 'ºC'),
	(238270, 122, '2014-03-01 01:12:48.000000', 'temperatura', 946.0000, 'ºC'),
	(238271, 122, '2014-03-01 01:12:49.000000', 'temperatura', 209.0000, 'ºC'),
	(238272, 122, '2014-03-01 01:12:50.000000', 'temperatura', 605.0000, 'ºC'),
	(238273, 122, '2014-03-01 01:12:51.000000', 'temperatura', 2.0000, 'ºC'),
	(238274, 122, '2014-03-01 01:12:52.000000', 'temperatura', 593.0000, 'ºC'),
	(238275, 122, '2014-03-01 01:12:53.000000', 'temperatura', 558.0000, 'ºC'),
	(238276, 122, '2014-03-01 01:12:54.000000', 'temperatura', 1015.0000, 'ºC'),
	(238277, 122, '2014-03-01 01:12:55.000000', 'temperatura', 999.0000, 'ºC'),
	(238278, 122, '2014-03-01 01:12:56.000000', 'temperatura', 749.0000, 'ºC'),
	(238279, 122, '2014-03-01 01:12:57.000000', 'temperatura', 751.0000, 'ºC'),
	(238280, 122, '2014-03-01 01:12:58.000000', 'temperatura', 309.0000, 'ºC'),
	(238281, 122, '2014-03-01 01:12:59.000000', 'temperatura', 491.0000, 'ºC'),
	(238282, 122, '2014-03-01 01:13:00.000000', 'temperatura', 329.0000, 'ºC'),
	(238283, 122, '2014-03-01 01:13:01.000000', 'temperatura', 175.0000, 'ºC'),
	(238284, 122, '2014-03-01 01:13:02.000000', 'temperatura', 1085.0000, 'ºC'),
	(238285, 122, '2014-03-01 01:13:03.000000', 'temperatura', 102.0000, 'ºC'),
	(238286, 122, '2014-03-01 01:13:04.000000', 'temperatura', 857.0000, 'ºC'),
	(238287, 122, '2014-03-01 01:13:05.000000', 'temperatura', 377.0000, 'ºC'),
	(238288, 122, '2014-03-01 01:13:06.000000', 'temperatura', 517.0000, 'ºC'),
	(238289, 122, '2014-03-01 01:13:07.000000', 'temperatura', 255.0000, 'ºC'),
	(238290, 122, '2014-03-01 01:13:08.000000', 'temperatura', 925.0000, 'ºC'),
	(238291, 122, '2014-03-01 01:13:09.000000', 'temperatura', 260.0000, 'ºC'),
	(238292, 122, '2014-03-01 01:13:10.000000', 'temperatura', 926.0000, 'ºC'),
	(238293, 122, '2014-03-01 01:13:11.000000', 'temperatura', 251.0000, 'ºC'),
	(238294, 122, '2014-03-01 01:13:12.000000', 'temperatura', 875.0000, 'ºC'),
	(238295, 122, '2014-03-01 01:13:13.000000', 'temperatura', 24.0000, 'ºC'),
	(238296, 122, '2014-03-01 01:13:14.000000', 'temperatura', 1094.0000, 'ºC'),
	(238297, 122, '2014-03-01 01:13:15.000000', 'temperatura', 599.0000, 'ºC'),
	(238298, 122, '2014-03-01 01:13:16.000000', 'temperatura', 913.0000, 'ºC'),
	(238299, 122, '2014-03-01 01:13:17.000000', 'temperatura', 370.0000, 'ºC'),
	(238300, 122, '2014-03-01 01:13:18.000000', 'temperatura', 311.0000, 'ºC'),
	(238301, 122, '2014-03-01 01:13:19.000000', 'temperatura', 446.0000, 'ºC'),
	(238302, 122, '2014-03-01 01:13:20.000000', 'temperatura', 98.0000, 'ºC'),
	(238303, 122, '2014-03-01 01:13:21.000000', 'temperatura', 352.0000, 'ºC'),
	(238304, 122, '2014-03-01 01:13:22.000000', 'temperatura', 267.0000, 'ºC'),
	(238305, 122, '2014-03-01 01:13:23.000000', 'temperatura', 279.0000, 'ºC'),
	(238306, 122, '2014-03-01 01:13:24.000000', 'temperatura', 594.0000, 'ºC'),
	(238307, 122, '2014-03-01 01:13:25.000000', 'temperatura', 936.0000, 'ºC'),
	(238308, 122, '2014-03-01 01:13:26.000000', 'temperatura', 497.0000, 'ºC'),
	(238309, 122, '2014-03-01 01:13:27.000000', 'temperatura', 876.0000, 'ºC'),
	(238310, 122, '2014-03-01 01:13:28.000000', 'temperatura', 490.0000, 'ºC'),
	(238311, 122, '2014-03-01 01:13:29.000000', 'temperatura', 1023.0000, 'ºC'),
	(238312, 122, '2014-03-01 01:13:30.000000', 'temperatura', 47.0000, 'ºC'),
	(238313, 122, '2014-03-01 01:13:31.000000', 'temperatura', 764.0000, 'ºC'),
	(238314, 122, '2014-03-01 01:13:32.000000', 'temperatura', 82.0000, 'ºC'),
	(238315, 122, '2014-03-01 01:13:33.000000', 'temperatura', 518.0000, 'ºC'),
	(238316, 122, '2014-03-01 01:13:34.000000', 'temperatura', 1144.0000, 'ºC'),
	(238317, 122, '2014-03-01 01:13:35.000000', 'temperatura', 566.0000, 'ºC'),
	(238318, 122, '2014-03-01 01:13:36.000000', 'temperatura', 599.0000, 'ºC'),
	(238319, 122, '2014-03-01 01:13:37.000000', 'temperatura', 97.0000, 'ºC'),
	(238320, 122, '2014-03-01 01:13:38.000000', 'temperatura', 1089.0000, 'ºC'),
	(238321, 122, '2014-03-01 01:13:39.000000', 'temperatura', 353.0000, 'ºC'),
	(238322, 122, '2014-03-01 01:13:40.000000', 'temperatura', 901.0000, 'ºC'),
	(238323, 122, '2014-03-01 01:13:41.000000', 'temperatura', 1047.0000, 'ºC'),
	(238324, 122, '2014-03-01 01:13:42.000000', 'temperatura', 132.0000, 'ºC'),
	(238325, 122, '2014-03-01 01:13:43.000000', 'temperatura', 1121.0000, 'ºC'),
	(238326, 122, '2014-03-01 01:13:44.000000', 'temperatura', 406.0000, 'ºC'),
	(238327, 122, '2014-03-01 01:13:45.000000', 'temperatura', 1070.0000, 'ºC'),
	(238328, 122, '2014-03-01 01:13:46.000000', 'temperatura', 533.0000, 'ºC'),
	(238329, 122, '2014-03-01 01:13:47.000000', 'temperatura', 657.0000, 'ºC'),
	(238330, 122, '2014-03-01 01:13:48.000000', 'temperatura', 483.0000, 'ºC'),
	(238331, 122, '2014-03-01 01:13:49.000000', 'temperatura', 445.0000, 'ºC'),
	(238332, 122, '2014-03-01 01:13:50.000000', 'temperatura', 779.0000, 'ºC'),
	(238333, 122, '2014-03-01 01:13:51.000000', 'temperatura', 158.0000, 'ºC'),
	(238334, 122, '2014-03-01 01:13:52.000000', 'temperatura', 855.0000, 'ºC'),
	(238335, 122, '2014-03-01 01:13:53.000000', 'temperatura', 202.0000, 'ºC'),
	(238336, 122, '2014-03-01 01:13:54.000000', 'temperatura', 846.0000, 'ºC'),
	(238337, 122, '2014-03-01 01:13:55.000000', 'temperatura', 24.0000, 'ºC'),
	(238338, 122, '2014-03-01 01:13:56.000000', 'temperatura', 1181.0000, 'ºC'),
	(238339, 122, '2014-03-01 01:13:57.000000', 'temperatura', 1036.0000, 'ºC'),
	(238340, 122, '2014-03-01 01:13:58.000000', 'temperatura', 436.0000, 'ºC'),
	(238341, 122, '2014-03-01 01:13:59.000000', 'temperatura', 273.0000, 'ºC'),
	(238342, 122, '2014-03-01 01:14:00.000000', 'temperatura', 57.0000, 'ºC'),
	(238343, 122, '2014-03-01 01:14:01.000000', 'temperatura', 667.0000, 'ºC'),
	(238344, 122, '2014-03-01 01:14:02.000000', 'temperatura', 766.0000, 'ºC'),
	(238345, 122, '2014-03-01 01:14:03.000000', 'temperatura', 628.0000, 'ºC'),
	(238346, 122, '2014-03-01 01:14:04.000000', 'temperatura', 842.0000, 'ºC'),
	(238347, 122, '2014-03-01 01:14:05.000000', 'temperatura', 1128.0000, 'ºC'),
	(238348, 122, '2014-03-01 01:14:06.000000', 'temperatura', 712.0000, 'ºC'),
	(238349, 122, '2014-03-01 01:14:07.000000', 'temperatura', 179.0000, 'ºC'),
	(238350, 122, '2014-03-01 01:14:08.000000', 'temperatura', 1158.0000, 'ºC'),
	(238351, 122, '2014-03-01 01:14:09.000000', 'temperatura', 456.0000, 'ºC'),
	(238352, 122, '2014-03-01 01:14:10.000000', 'temperatura', 5.0000, 'ºC'),
	(238353, 122, '2014-03-01 01:14:11.000000', 'temperatura', 1056.0000, 'ºC'),
	(238354, 122, '2014-03-01 01:14:12.000000', 'temperatura', 468.0000, 'ºC'),
	(238355, 122, '2014-03-01 01:14:13.000000', 'temperatura', 370.0000, 'ºC'),
	(238356, 122, '2014-03-01 01:14:14.000000', 'temperatura', 449.0000, 'ºC'),
	(238357, 122, '2014-03-01 01:14:15.000000', 'temperatura', 1133.0000, 'ºC'),
	(238358, 122, '2014-03-01 01:14:16.000000', 'temperatura', 719.0000, 'ºC'),
	(238359, 122, '2014-03-01 01:14:17.000000', 'temperatura', 197.0000, 'ºC'),
	(238360, 122, '2014-03-01 01:14:18.000000', 'temperatura', 29.0000, 'ºC'),
	(238361, 122, '2014-03-01 01:14:19.000000', 'temperatura', 756.0000, 'ºC'),
	(238362, 122, '2014-03-01 01:14:20.000000', 'temperatura', 92.0000, 'ºC'),
	(238363, 122, '2014-03-01 01:14:21.000000', 'temperatura', 594.0000, 'ºC'),
	(238364, 122, '2014-03-01 01:14:22.000000', 'temperatura', 293.0000, 'ºC'),
	(238365, 122, '2014-03-01 01:14:23.000000', 'temperatura', 884.0000, 'ºC'),
	(238366, 122, '2014-03-01 01:14:24.000000', 'temperatura', 1142.0000, 'ºC'),
	(238367, 122, '2014-03-01 01:14:25.000000', 'temperatura', 657.0000, 'ºC'),
	(238368, 122, '2014-03-01 01:14:26.000000', 'temperatura', 1061.0000, 'ºC'),
	(238369, 122, '2014-03-01 01:14:27.000000', 'temperatura', 934.0000, 'ºC'),
	(238370, 122, '2014-03-01 01:14:28.000000', 'temperatura', 289.0000, 'ºC'),
	(238371, 122, '2014-03-01 01:14:29.000000', 'temperatura', 1042.0000, 'ºC'),
	(238372, 122, '2014-03-01 01:14:30.000000', 'temperatura', 743.0000, 'ºC'),
	(238373, 122, '2014-03-01 01:14:31.000000', 'temperatura', 589.0000, 'ºC'),
	(238374, 122, '2014-03-01 01:14:32.000000', 'temperatura', 715.0000, 'ºC'),
	(238375, 122, '2014-03-01 01:14:33.000000', 'temperatura', 612.0000, 'ºC'),
	(238376, 122, '2014-03-01 01:14:34.000000', 'temperatura', 913.0000, 'ºC'),
	(238377, 122, '2014-03-01 01:14:35.000000', 'temperatura', 331.0000, 'ºC'),
	(238378, 122, '2014-03-01 01:14:36.000000', 'temperatura', 114.0000, 'ºC'),
	(238379, 122, '2014-03-01 01:14:37.000000', 'temperatura', 780.0000, 'ºC'),
	(238380, 122, '2014-03-01 01:14:38.000000', 'temperatura', 1157.0000, 'ºC'),
	(238381, 122, '2014-03-01 01:14:39.000000', 'temperatura', 1048.0000, 'ºC'),
	(238382, 122, '2014-03-01 01:14:40.000000', 'temperatura', 567.0000, 'ºC'),
	(238383, 122, '2014-03-01 01:14:41.000000', 'temperatura', 892.0000, 'ºC'),
	(238384, 122, '2014-03-01 01:14:42.000000', 'temperatura', 358.0000, 'ºC'),
	(238385, 122, '2014-03-01 01:14:43.000000', 'temperatura', 315.0000, 'ºC'),
	(238386, 122, '2014-03-01 01:14:44.000000', 'temperatura', 501.0000, 'ºC'),
	(238387, 122, '2014-03-01 01:14:45.000000', 'temperatura', 361.0000, 'ºC'),
	(238388, 122, '2014-03-01 01:14:46.000000', 'temperatura', 303.0000, 'ºC'),
	(238389, 122, '2014-03-01 01:14:47.000000', 'temperatura', 434.0000, 'ºC'),
	(238390, 122, '2014-03-01 01:14:48.000000', 'temperatura', 61.0000, 'ºC'),
	(238391, 122, '2014-03-01 01:14:49.000000', 'temperatura', 205.0000, 'ºC'),
	(238392, 122, '2014-03-01 01:14:50.000000', 'temperatura', 841.0000, 'ºC'),
	(238393, 122, '2014-03-01 01:14:51.000000', 'temperatura', 1193.0000, 'ºC'),
	(238394, 122, '2014-03-01 01:14:52.000000', 'temperatura', 1039.0000, 'ºC'),
	(238395, 122, '2014-03-01 01:14:53.000000', 'temperatura', 419.0000, 'ºC'),
	(238396, 122, '2014-03-01 01:14:54.000000', 'temperatura', 177.0000, 'ºC'),
	(238397, 122, '2014-03-01 01:14:55.000000', 'temperatura', 829.0000, 'ºC'),
	(238398, 122, '2014-03-01 01:14:56.000000', 'temperatura', 14.0000, 'ºC'),
	(238399, 122, '2014-03-01 01:14:57.000000', 'temperatura', 1184.0000, 'ºC'),
	(238400, 122, '2014-03-01 01:14:58.000000', 'temperatura', 1078.0000, 'ºC'),
	(238401, 122, '2014-03-01 01:14:59.000000', 'temperatura', 637.0000, 'ºC'),
	(238402, 122, '2014-03-01 01:15:00.000000', 'temperatura', 1153.0000, 'ºC'),
	(238403, 122, '2014-03-01 01:15:01.000000', 'temperatura', 255.0000, 'ºC'),
	(238404, 122, '2014-03-01 01:15:02.000000', 'temperatura', 216.0000, 'ºC'),
	(238405, 122, '2014-03-01 01:15:03.000000', 'temperatura', 314.0000, 'ºC'),
	(238406, 122, '2014-03-01 01:15:04.000000', 'temperatura', 923.0000, 'ºC'),
	(238407, 122, '2014-03-01 01:15:05.000000', 'temperatura', 74.0000, 'ºC'),
	(238408, 122, '2014-03-01 01:15:06.000000', 'temperatura', 0.0000, 'ºC'),
	(238409, 122, '2014-03-01 01:15:07.000000', 'temperatura', 981.0000, 'ºC'),
	(238410, 122, '2014-03-01 01:15:08.000000', 'temperatura', 106.0000, 'ºC'),
	(238411, 122, '2014-03-01 01:15:09.000000', 'temperatura', 1187.0000, 'ºC'),
	(238412, 122, '2014-03-01 01:15:10.000000', 'temperatura', 818.0000, 'ºC'),
	(238413, 122, '2014-03-01 01:15:11.000000', 'temperatura', 530.0000, 'ºC'),
	(238414, 122, '2014-03-01 01:15:12.000000', 'temperatura', 195.0000, 'ºC'),
	(238415, 122, '2014-03-01 01:15:13.000000', 'temperatura', 587.0000, 'ºC'),
	(238416, 122, '2014-03-01 01:15:14.000000', 'temperatura', 1149.0000, 'ºC'),
	(238417, 122, '2014-03-01 01:15:15.000000', 'temperatura', 385.0000, 'ºC'),
	(238418, 122, '2014-03-01 01:15:16.000000', 'temperatura', 879.0000, 'ºC'),
	(238419, 122, '2014-03-01 01:15:17.000000', 'temperatura', 842.0000, 'ºC'),
	(238420, 122, '2014-03-01 01:15:18.000000', 'temperatura', 371.0000, 'ºC'),
	(238421, 122, '2014-03-01 01:15:19.000000', 'temperatura', 531.0000, 'ºC'),
	(238422, 122, '2014-03-01 01:15:20.000000', 'temperatura', 344.0000, 'ºC'),
	(238423, 122, '2014-03-01 01:15:21.000000', 'temperatura', 127.0000, 'ºC'),
	(238424, 122, '2014-03-01 01:15:22.000000', 'temperatura', 802.0000, 'ºC'),
	(238425, 122, '2014-03-01 01:15:23.000000', 'temperatura', 29.0000, 'ºC'),
	(238426, 122, '2014-03-01 01:15:24.000000', 'temperatura', 139.0000, 'ºC'),
	(238427, 122, '2014-03-01 01:15:25.000000', 'temperatura', 611.0000, 'ºC'),
	(238428, 122, '2014-03-01 01:15:26.000000', 'temperatura', 235.0000, 'ºC'),
	(238429, 122, '2014-03-01 01:15:27.000000', 'temperatura', 545.0000, 'ºC'),
	(238430, 122, '2014-03-01 01:15:28.000000', 'temperatura', 821.0000, 'ºC'),
	(238431, 122, '2014-03-01 01:15:29.000000', 'temperatura', 69.0000, 'ºC'),
	(238432, 122, '2014-03-01 01:15:30.000000', 'temperatura', 284.0000, 'ºC'),
	(238433, 122, '2014-03-01 01:15:31.000000', 'temperatura', 14.0000, 'ºC'),
	(238434, 122, '2014-03-01 01:15:32.000000', 'temperatura', 416.0000, 'ºC'),
	(238435, 122, '2014-03-01 01:15:33.000000', 'temperatura', 839.0000, 'ºC'),
	(238436, 122, '2014-03-01 01:15:34.000000', 'temperatura', 546.0000, 'ºC'),
	(238437, 122, '2014-03-01 01:15:35.000000', 'temperatura', 215.0000, 'ºC'),
	(238438, 122, '2014-03-01 01:15:36.000000', 'temperatura', 639.0000, 'ºC'),
	(238439, 122, '2014-03-01 01:15:37.000000', 'temperatura', 151.0000, 'ºC'),
	(238440, 122, '2014-03-01 01:15:38.000000', 'temperatura', 39.0000, 'ºC'),
	(238441, 122, '2014-03-01 01:15:39.000000', 'temperatura', 942.0000, 'ºC'),
	(238442, 122, '2014-03-01 01:15:40.000000', 'temperatura', 993.0000, 'ºC'),
	(238443, 122, '2014-03-01 01:15:41.000000', 'temperatura', 941.0000, 'ºC'),
	(238444, 122, '2014-03-01 01:15:42.000000', 'temperatura', 527.0000, 'ºC'),
	(238445, 122, '2014-03-01 01:15:43.000000', 'temperatura', 1011.0000, 'ºC'),
	(238446, 122, '2014-03-01 01:15:44.000000', 'temperatura', 1074.0000, 'ºC'),
	(238447, 122, '2014-03-01 01:15:45.000000', 'temperatura', 1139.0000, 'ºC'),
	(238448, 122, '2014-03-01 01:15:46.000000', 'temperatura', 73.0000, 'ºC'),
	(238449, 122, '2014-03-01 01:15:47.000000', 'temperatura', 548.0000, 'ºC'),
	(238450, 122, '2014-03-01 01:15:48.000000', 'temperatura', 121.0000, 'ºC'),
	(238451, 122, '2014-03-01 01:15:49.000000', 'temperatura', 164.0000, 'ºC'),
	(238452, 122, '2014-03-01 01:15:50.000000', 'temperatura', 455.0000, 'ºC'),
	(238453, 122, '2014-03-01 01:15:51.000000', 'temperatura', 585.0000, 'ºC'),
	(238454, 122, '2014-03-01 01:15:52.000000', 'temperatura', 360.0000, 'ºC'),
	(238455, 122, '2014-03-01 01:15:53.000000', 'temperatura', 45.0000, 'ºC'),
	(238456, 122, '2014-03-01 01:15:54.000000', 'temperatura', 348.0000, 'ºC'),
	(238457, 122, '2014-03-01 01:15:55.000000', 'temperatura', 403.0000, 'ºC'),
	(238458, 122, '2014-03-01 01:15:56.000000', 'temperatura', 974.0000, 'ºC'),
	(238459, 122, '2014-03-01 01:15:57.000000', 'temperatura', 59.0000, 'ºC'),
	(238460, 122, '2014-03-01 01:15:58.000000', 'temperatura', 974.0000, 'ºC'),
	(238461, 122, '2014-03-01 01:15:59.000000', 'temperatura', 1094.0000, 'ºC'),
	(238462, 122, '2014-03-01 01:16:00.000000', 'temperatura', 150.0000, 'ºC'),
	(238463, 122, '2014-03-01 01:16:01.000000', 'temperatura', 1066.0000, 'ºC'),
	(238464, 122, '2014-03-01 01:16:02.000000', 'temperatura', 82.0000, 'ºC'),
	(238465, 122, '2014-03-01 01:16:03.000000', 'temperatura', 812.0000, 'ºC'),
	(238466, 122, '2014-03-01 01:16:04.000000', 'temperatura', 213.0000, 'ºC'),
	(238467, 122, '2014-03-01 01:16:05.000000', 'temperatura', 1031.0000, 'ºC'),
	(238468, 122, '2014-03-01 01:16:06.000000', 'temperatura', 916.0000, 'ºC'),
	(238469, 122, '2014-03-01 01:16:07.000000', 'temperatura', 286.0000, 'ºC'),
	(238470, 122, '2014-03-01 01:16:08.000000', 'temperatura', 1083.0000, 'ºC'),
	(238471, 122, '2014-03-01 01:16:09.000000', 'temperatura', 957.0000, 'ºC'),
	(238472, 122, '2014-03-01 01:16:10.000000', 'temperatura', 337.0000, 'ºC'),
	(238473, 122, '2014-03-01 01:16:11.000000', 'temperatura', 16.0000, 'ºC'),
	(238474, 122, '2014-03-01 01:16:12.000000', 'temperatura', 270.0000, 'ºC'),
	(238475, 122, '2014-03-01 01:16:13.000000', 'temperatura', 100.0000, 'ºC'),
	(238476, 122, '2014-03-01 01:16:14.000000', 'temperatura', 890.0000, 'ºC'),
	(238477, 122, '2014-03-01 01:16:15.000000', 'temperatura', 551.0000, 'ºC'),
	(238478, 122, '2014-03-01 01:16:16.000000', 'temperatura', 87.0000, 'ºC'),
	(238479, 122, '2014-03-01 01:16:17.000000', 'temperatura', 1182.0000, 'ºC'),
	(238480, 122, '2014-03-01 01:16:18.000000', 'temperatura', 847.0000, 'ºC'),
	(238481, 122, '2014-03-01 01:16:19.000000', 'temperatura', 693.0000, 'ºC'),
	(238482, 122, '2014-03-01 01:16:20.000000', 'temperatura', 923.0000, 'ºC'),
	(238483, 122, '2014-03-01 01:16:21.000000', 'temperatura', 135.0000, 'ºC'),
	(238484, 122, '2014-03-01 01:16:22.000000', 'temperatura', 309.0000, 'ºC'),
	(238485, 122, '2014-03-01 01:16:23.000000', 'temperatura', 1139.0000, 'ºC'),
	(238486, 122, '2014-03-01 01:16:24.000000', 'temperatura', 1170.0000, 'ºC'),
	(238487, 122, '2014-03-01 01:16:25.000000', 'temperatura', 31.0000, 'ºC'),
	(238488, 122, '2014-03-01 01:16:26.000000', 'temperatura', 245.0000, 'ºC'),
	(238489, 122, '2014-03-01 01:16:27.000000', 'temperatura', 1133.0000, 'ºC'),
	(238490, 122, '2014-03-01 01:16:28.000000', 'temperatura', 132.0000, 'ºC'),
	(238491, 122, '2014-03-01 01:16:29.000000', 'temperatura', 860.0000, 'ºC'),
	(238492, 122, '2014-03-01 01:16:30.000000', 'temperatura', 306.0000, 'ºC'),
	(238493, 122, '2014-03-01 01:16:31.000000', 'temperatura', 152.0000, 'ºC'),
	(238494, 122, '2014-03-01 01:16:32.000000', 'temperatura', 1040.0000, 'ºC'),
	(238495, 122, '2014-03-01 01:16:33.000000', 'temperatura', 1147.0000, 'ºC'),
	(238496, 122, '2014-03-01 01:16:34.000000', 'temperatura', 215.0000, 'ºC'),
	(238497, 122, '2014-03-01 01:16:35.000000', 'temperatura', 32.0000, 'ºC'),
	(238498, 122, '2014-03-01 01:16:36.000000', 'temperatura', 719.0000, 'ºC'),
	(238499, 122, '2014-03-01 01:16:37.000000', 'temperatura', 1097.0000, 'ºC'),
	(238500, 122, '2014-03-01 01:16:38.000000', 'temperatura', 929.0000, 'ºC'),
	(238501, 122, '2014-03-01 01:16:39.000000', 'temperatura', 156.0000, 'ºC'),
	(238502, 122, '2014-03-01 01:16:40.000000', 'temperatura', 392.0000, 'ºC'),
	(238503, 122, '2014-03-01 01:16:41.000000', 'temperatura', 293.0000, 'ºC'),
	(238504, 122, '2014-03-01 01:16:42.000000', 'temperatura', 291.0000, 'ºC'),
	(238505, 122, '2014-03-01 01:16:43.000000', 'temperatura', 577.0000, 'ºC'),
	(238506, 122, '2014-03-01 01:16:44.000000', 'temperatura', 810.0000, 'ºC'),
	(238507, 122, '2014-03-01 01:16:45.000000', 'temperatura', 1122.0000, 'ºC'),
	(238508, 122, '2014-03-01 01:16:46.000000', 'temperatura', 780.0000, 'ºC'),
	(238509, 122, '2014-03-01 01:16:47.000000', 'temperatura', 534.0000, 'ºC'),
	(238510, 122, '2014-03-01 01:16:48.000000', 'temperatura', 329.0000, 'ºC'),
	(238511, 122, '2014-03-01 01:16:49.000000', 'temperatura', 47.0000, 'ºC'),
	(238512, 122, '2014-03-01 01:16:50.000000', 'temperatura', 446.0000, 'ºC'),
	(238513, 122, '2014-03-01 01:16:51.000000', 'temperatura', 888.0000, 'ºC'),
	(238514, 122, '2014-03-01 01:16:52.000000', 'temperatura', 706.0000, 'ºC'),
	(238515, 122, '2014-03-01 01:16:53.000000', 'temperatura', 865.0000, 'ºC'),
	(238516, 122, '2014-03-01 01:16:54.000000', 'temperatura', 1008.0000, 'ºC'),
	(238517, 122, '2014-03-01 01:16:55.000000', 'temperatura', 47.0000, 'ºC'),
	(238518, 122, '2014-03-01 01:16:56.000000', 'temperatura', 811.0000, 'ºC'),
	(238519, 122, '2014-03-01 01:16:57.000000', 'temperatura', 314.0000, 'ºC'),
	(238520, 122, '2014-03-01 01:16:58.000000', 'temperatura', 338.0000, 'ºC'),
	(238521, 122, '2014-03-01 01:16:59.000000', 'temperatura', 749.0000, 'ºC'),
	(238522, 122, '2014-03-01 01:17:00.000000', 'temperatura', 330.0000, 'ºC'),
	(238523, 122, '2014-03-01 01:17:01.000000', 'temperatura', 602.0000, 'ºC'),
	(238524, 122, '2014-03-01 01:17:02.000000', 'temperatura', 823.0000, 'ºC'),
	(238525, 122, '2014-03-01 01:17:03.000000', 'temperatura', 1111.0000, 'ºC'),
	(238526, 122, '2014-03-01 01:17:04.000000', 'temperatura', 685.0000, 'ºC'),
	(238527, 122, '2014-03-01 01:17:05.000000', 'temperatura', 91.0000, 'ºC'),
	(238528, 122, '2014-03-01 01:17:06.000000', 'temperatura', 800.0000, 'ºC'),
	(238529, 122, '2014-03-01 01:17:07.000000', 'temperatura', 130.0000, 'ºC'),
	(238530, 122, '2014-03-01 01:17:08.000000', 'temperatura', 651.0000, 'ºC'),
	(238531, 122, '2014-03-01 01:17:09.000000', 'temperatura', 465.0000, 'ºC'),
	(238532, 122, '2014-03-01 01:17:10.000000', 'temperatura', 373.0000, 'ºC'),
	(238533, 122, '2014-03-01 01:17:11.000000', 'temperatura', 468.0000, 'ºC'),
	(238534, 122, '2014-03-01 01:17:12.000000', 'temperatura', 25.0000, 'ºC'),
	(238535, 122, '2014-03-01 01:17:13.000000', 'temperatura', 1120.0000, 'ºC'),
	(238536, 122, '2014-03-01 01:17:14.000000', 'temperatura', 724.0000, 'ºC'),
	(238537, 122, '2014-03-01 01:17:15.000000', 'temperatura', 261.0000, 'ºC'),
	(238538, 122, '2014-03-01 01:17:16.000000', 'temperatura', 334.0000, 'ºC'),
	(238539, 122, '2014-03-01 01:17:17.000000', 'temperatura', 887.0000, 'ºC'),
	(238540, 122, '2014-03-01 01:17:18.000000', 'temperatura', 1035.0000, 'ºC'),
	(238541, 122, '2014-03-01 01:17:19.000000', 'temperatura', 112.0000, 'ºC'),
	(238542, 122, '2014-03-01 01:17:20.000000', 'temperatura', 1055.0000, 'ºC'),
	(238543, 122, '2014-03-01 01:17:21.000000', 'temperatura', 140.0000, 'ºC'),
	(238544, 122, '2014-03-01 01:17:22.000000', 'temperatura', 1137.0000, 'ºC'),
	(238545, 122, '2014-03-01 01:17:23.000000', 'temperatura', 465.0000, 'ºC'),
	(238546, 122, '2014-03-01 01:17:24.000000', 'temperatura', 114.0000, 'ºC'),
	(238547, 122, '2014-03-01 01:17:25.000000', 'temperatura', 376.0000, 'ºC'),
	(238548, 122, '2014-03-01 01:17:26.000000', 'temperatura', 340.0000, 'ºC'),
	(238549, 122, '2014-03-01 01:17:27.000000', 'temperatura', 572.0000, 'ºC'),
	(238550, 122, '2014-03-01 01:17:28.000000', 'temperatura', 642.0000, 'ºC'),
	(238551, 122, '2014-03-01 01:17:29.000000', 'temperatura', 293.0000, 'ºC'),
	(238552, 122, '2014-03-01 01:17:30.000000', 'temperatura', 739.0000, 'ºC'),
	(238553, 122, '2014-03-01 01:17:31.000000', 'temperatura', 418.0000, 'ºC'),
	(238554, 122, '2014-03-01 01:17:32.000000', 'temperatura', 1071.0000, 'ºC'),
	(238555, 122, '2014-03-01 01:17:33.000000', 'temperatura', 503.0000, 'ºC'),
	(238556, 122, '2014-03-01 01:17:34.000000', 'temperatura', 500.0000, 'ºC'),
	(238557, 122, '2014-03-01 01:17:35.000000', 'temperatura', 994.0000, 'ºC'),
	(238558, 122, '2014-03-01 01:17:36.000000', 'temperatura', 1070.0000, 'ºC'),
	(238559, 122, '2014-03-01 01:17:37.000000', 'temperatura', 1170.0000, 'ºC'),
	(238560, 122, '2014-03-01 01:17:38.000000', 'temperatura', 239.0000, 'ºC'),
	(238561, 122, '2014-03-01 01:17:39.000000', 'temperatura', 86.0000, 'ºC'),
	(238562, 122, '2014-03-01 01:17:40.000000', 'temperatura', 915.0000, 'ºC'),
	(238563, 122, '2014-03-01 01:17:41.000000', 'temperatura', 717.0000, 'ºC'),
	(238564, 122, '2014-03-01 01:17:42.000000', 'temperatura', 839.0000, 'ºC'),
	(238565, 122, '2014-03-01 01:17:43.000000', 'temperatura', 846.0000, 'ºC'),
	(238566, 122, '2014-03-01 01:17:44.000000', 'temperatura', 512.0000, 'ºC'),
	(238567, 122, '2014-03-01 01:17:45.000000', 'temperatura', 23.0000, 'ºC'),
	(238568, 122, '2014-03-01 01:17:46.000000', 'temperatura', 978.0000, 'ºC'),
	(238569, 122, '2014-03-01 01:17:47.000000', 'temperatura', 21.0000, 'ºC'),
	(238570, 122, '2014-03-01 01:17:48.000000', 'temperatura', 772.0000, 'ºC'),
	(238571, 122, '2014-03-01 01:17:49.000000', 'temperatura', 196.0000, 'ºC'),
	(238572, 122, '2014-03-01 01:17:50.000000', 'temperatura', 1068.0000, 'ºC'),
	(238573, 122, '2014-03-01 01:17:51.000000', 'temperatura', 1149.0000, 'ºC'),
	(238574, 122, '2014-03-01 01:17:52.000000', 'temperatura', 144.0000, 'ºC'),
	(238575, 122, '2014-03-01 01:17:53.000000', 'temperatura', 873.0000, 'ºC'),
	(238576, 122, '2014-03-01 01:17:54.000000', 'temperatura', 332.0000, 'ºC'),
	(238577, 122, '2014-03-01 01:17:55.000000', 'temperatura', 244.0000, 'ºC'),
	(238578, 122, '2014-03-01 01:17:56.000000', 'temperatura', 225.0000, 'ºC'),
	(238579, 122, '2014-03-01 01:17:57.000000', 'temperatura', 394.0000, 'ºC'),
	(238580, 122, '2014-03-01 01:17:58.000000', 'temperatura', 93.0000, 'ºC'),
	(238581, 122, '2014-03-01 01:17:59.000000', 'temperatura', 485.0000, 'ºC'),
	(238582, 122, '2014-03-01 01:18:00.000000', 'temperatura', 947.0000, 'ºC'),
	(238583, 122, '2014-03-01 01:18:01.000000', 'temperatura', 880.0000, 'ºC'),
	(238584, 122, '2014-03-01 01:18:02.000000', 'temperatura', 359.0000, 'ºC'),
	(238585, 122, '2014-03-01 01:18:03.000000', 'temperatura', 357.0000, 'ºC'),
	(238586, 122, '2014-03-01 01:18:04.000000', 'temperatura', 708.0000, 'ºC'),
	(238587, 122, '2014-03-01 01:18:05.000000', 'temperatura', 70.0000, 'ºC'),
	(238588, 122, '2014-03-01 01:18:06.000000', 'temperatura', 626.0000, 'ºC'),
	(238589, 122, '2014-03-01 01:18:07.000000', 'temperatura', 518.0000, 'ºC'),
	(238590, 122, '2014-03-01 01:18:08.000000', 'temperatura', 716.0000, 'ºC'),
	(238591, 122, '2014-03-01 01:18:09.000000', 'temperatura', 826.0000, 'ºC'),
	(238592, 122, '2014-03-01 01:18:10.000000', 'temperatura', 781.0000, 'ºC'),
	(238593, 122, '2014-03-01 01:18:11.000000', 'temperatura', 229.0000, 'ºC'),
	(238594, 122, '2014-03-01 01:18:12.000000', 'temperatura', 3.0000, 'ºC'),
	(238595, 122, '2014-03-01 01:18:13.000000', 'temperatura', 528.0000, 'ºC'),
	(238596, 122, '2014-03-01 01:18:14.000000', 'temperatura', 233.0000, 'ºC'),
	(238597, 122, '2014-03-01 01:18:15.000000', 'temperatura', 781.0000, 'ºC'),
	(238598, 122, '2014-03-01 01:18:16.000000', 'temperatura', 805.0000, 'ºC'),
	(238599, 122, '2014-03-01 01:18:17.000000', 'temperatura', 481.0000, 'ºC'),
	(238600, 122, '2014-03-01 01:18:18.000000', 'temperatura', 1194.0000, 'ºC'),
	(238601, 122, '2014-03-01 01:18:19.000000', 'temperatura', 926.0000, 'ºC'),
	(238602, 122, '2014-03-01 01:18:20.000000', 'temperatura', 1050.0000, 'ºC'),
	(238603, 122, '2014-03-01 01:18:21.000000', 'temperatura', 70.0000, 'ºC'),
	(238604, 122, '2014-03-01 01:18:22.000000', 'temperatura', 802.0000, 'ºC'),
	(238605, 122, '2014-03-01 01:18:23.000000', 'temperatura', 198.0000, 'ºC'),
	(238606, 122, '2014-03-01 01:18:24.000000', 'temperatura', 987.0000, 'ºC'),
	(238607, 122, '2014-03-01 01:18:25.000000', 'temperatura', 739.0000, 'ºC'),
	(238608, 122, '2014-03-01 01:18:26.000000', 'temperatura', 737.0000, 'ºC'),
	(238609, 122, '2014-03-01 01:18:27.000000', 'temperatura', 266.0000, 'ºC'),
	(238610, 122, '2014-03-01 01:18:28.000000', 'temperatura', 320.0000, 'ºC'),
	(238611, 122, '2014-03-01 01:18:29.000000', 'temperatura', 804.0000, 'ºC'),
	(238612, 122, '2014-03-01 01:18:30.000000', 'temperatura', 659.0000, 'ºC'),
	(238613, 122, '2014-03-01 01:18:31.000000', 'temperatura', 882.0000, 'ºC'),
	(238614, 122, '2014-03-01 01:18:32.000000', 'temperatura', 37.0000, 'ºC'),
	(238615, 122, '2014-03-01 01:18:33.000000', 'temperatura', 1137.0000, 'ºC'),
	(238616, 122, '2014-03-01 01:18:34.000000', 'temperatura', 777.0000, 'ºC'),
	(238617, 122, '2014-03-01 01:18:35.000000', 'temperatura', 474.0000, 'ºC'),
	(238618, 122, '2014-03-01 01:18:36.000000', 'temperatura', 40.0000, 'ºC'),
	(238619, 122, '2014-03-01 01:18:37.000000', 'temperatura', 1179.0000, 'ºC'),
	(238620, 122, '2014-03-01 01:18:38.000000', 'temperatura', 977.0000, 'ºC'),
	(238621, 122, '2014-03-01 01:18:39.000000', 'temperatura', 145.0000, 'ºC'),
	(238622, 122, '2014-03-01 01:18:40.000000', 'temperatura', 197.0000, 'ºC'),
	(238623, 122, '2014-03-01 01:18:41.000000', 'temperatura', 551.0000, 'ºC'),
	(238624, 122, '2014-03-01 01:18:42.000000', 'temperatura', 963.0000, 'ºC'),
	(238625, 122, '2014-03-01 01:18:43.000000', 'temperatura', 763.0000, 'ºC'),
	(238626, 122, '2014-03-01 01:18:44.000000', 'temperatura', 927.0000, 'ºC'),
	(238627, 122, '2014-03-01 01:18:45.000000', 'temperatura', 1147.0000, 'ºC'),
	(238628, 122, '2014-03-01 01:18:46.000000', 'temperatura', 552.0000, 'ºC'),
	(238629, 122, '2014-03-01 01:18:47.000000', 'temperatura', 522.0000, 'ºC'),
	(238630, 122, '2014-03-01 01:18:48.000000', 'temperatura', 956.0000, 'ºC'),
	(238631, 122, '2014-03-01 01:18:49.000000', 'temperatura', 811.0000, 'ºC'),
	(238632, 122, '2014-03-01 01:18:50.000000', 'temperatura', 1189.0000, 'ºC'),
	(238633, 122, '2014-03-01 01:18:51.000000', 'temperatura', 1112.0000, 'ºC'),
	(238634, 122, '2014-03-01 01:18:52.000000', 'temperatura', 792.0000, 'ºC'),
	(238635, 122, '2014-03-01 01:18:53.000000', 'temperatura', 625.0000, 'ºC'),
	(238636, 122, '2014-03-01 01:18:54.000000', 'temperatura', 748.0000, 'ºC'),
	(238637, 122, '2014-03-01 01:18:55.000000', 'temperatura', 667.0000, 'ºC'),
	(238638, 122, '2014-03-01 01:18:56.000000', 'temperatura', 1091.0000, 'ºC'),
	(238639, 122, '2014-03-01 01:18:57.000000', 'temperatura', 1054.0000, 'ºC'),
	(238640, 122, '2014-03-01 01:18:58.000000', 'temperatura', 799.0000, 'ºC'),
	(238641, 122, '2014-03-01 01:18:59.000000', 'temperatura', 834.0000, 'ºC'),
	(238642, 122, '2014-03-01 01:19:00.000000', 'temperatura', 574.0000, 'ºC'),
	(238643, 122, '2014-03-01 01:19:01.000000', 'temperatura', 368.0000, 'ºC'),
	(238644, 122, '2014-03-01 01:19:02.000000', 'temperatura', 119.0000, 'ºC'),
	(238645, 122, '2014-03-01 01:19:03.000000', 'temperatura', 691.0000, 'ºC'),
	(238646, 122, '2014-03-01 01:19:04.000000', 'temperatura', 698.0000, 'ºC'),
	(238647, 122, '2014-03-01 01:19:05.000000', 'temperatura', 218.0000, 'ºC'),
	(238648, 122, '2014-03-01 01:19:06.000000', 'temperatura', 197.0000, 'ºC'),
	(238649, 122, '2014-03-01 01:19:07.000000', 'temperatura', 332.0000, 'ºC'),
	(238650, 122, '2014-03-01 01:19:08.000000', 'temperatura', 1070.0000, 'ºC'),
	(238651, 122, '2014-03-01 01:19:09.000000', 'temperatura', 755.0000, 'ºC'),
	(238652, 122, '2014-03-01 01:19:10.000000', 'temperatura', 564.0000, 'ºC'),
	(238653, 122, '2014-03-01 01:19:11.000000', 'temperatura', 556.0000, 'ºC'),
	(238654, 122, '2014-03-01 01:19:12.000000', 'temperatura', 1087.0000, 'ºC'),
	(238655, 122, '2014-03-01 01:19:13.000000', 'temperatura', 170.0000, 'ºC'),
	(238656, 122, '2014-03-01 01:19:14.000000', 'temperatura', 1188.0000, 'ºC'),
	(238657, 122, '2014-03-01 01:19:15.000000', 'temperatura', 630.0000, 'ºC'),
	(238658, 122, '2014-03-01 01:19:16.000000', 'temperatura', 789.0000, 'ºC'),
	(238659, 122, '2014-03-01 01:19:17.000000', 'temperatura', 854.0000, 'ºC'),
	(238660, 122, '2014-03-01 01:19:18.000000', 'temperatura', 703.0000, 'ºC'),
	(238661, 122, '2014-03-01 01:19:19.000000', 'temperatura', 952.0000, 'ºC'),
	(238662, 122, '2014-03-01 01:19:20.000000', 'temperatura', 254.0000, 'ºC'),
	(238663, 122, '2014-03-01 01:19:21.000000', 'temperatura', 814.0000, 'ºC'),
	(238664, 122, '2014-03-01 01:19:22.000000', 'temperatura', 908.0000, 'ºC'),
	(238665, 122, '2014-03-01 01:19:23.000000', 'temperatura', 899.0000, 'ºC'),
	(238666, 122, '2014-03-01 01:19:24.000000', 'temperatura', 570.0000, 'ºC'),
	(238667, 122, '2014-03-01 01:19:25.000000', 'temperatura', 154.0000, 'ºC'),
	(238668, 122, '2014-03-01 01:19:26.000000', 'temperatura', 261.0000, 'ºC'),
	(238669, 122, '2014-03-01 01:19:27.000000', 'temperatura', 843.0000, 'ºC'),
	(238670, 122, '2014-03-01 01:19:28.000000', 'temperatura', 1035.0000, 'ºC'),
	(238671, 122, '2014-03-01 01:19:29.000000', 'temperatura', 244.0000, 'ºC'),
	(238672, 122, '2014-03-01 01:19:30.000000', 'temperatura', 514.0000, 'ºC'),
	(238673, 122, '2014-03-01 01:19:31.000000', 'temperatura', 640.0000, 'ºC'),
	(238674, 122, '2014-03-01 01:19:32.000000', 'temperatura', 460.0000, 'ºC'),
	(238675, 122, '2014-03-01 01:19:33.000000', 'temperatura', 379.0000, 'ºC'),
	(238676, 122, '2014-03-01 01:19:34.000000', 'temperatura', 518.0000, 'ºC'),
	(238677, 122, '2014-03-01 01:19:35.000000', 'temperatura', 251.0000, 'ºC'),
	(238678, 122, '2014-03-01 01:19:36.000000', 'temperatura', 903.0000, 'ºC'),
	(238679, 122, '2014-03-01 01:19:37.000000', 'temperatura', 164.0000, 'ºC'),
	(238680, 122, '2014-03-01 01:19:38.000000', 'temperatura', 510.0000, 'ºC'),
	(238681, 122, '2014-03-01 01:19:39.000000', 'temperatura', 859.0000, 'ºC'),
	(238682, 122, '2014-03-01 01:19:40.000000', 'temperatura', 364.0000, 'ºC'),
	(238683, 122, '2014-03-01 01:19:41.000000', 'temperatura', 445.0000, 'ºC'),
	(238684, 122, '2014-03-01 01:19:42.000000', 'temperatura', 1132.0000, 'ºC'),
	(238685, 122, '2014-03-01 01:19:43.000000', 'temperatura', 727.0000, 'ºC'),
	(238686, 122, '2014-03-01 01:19:44.000000', 'temperatura', 240.0000, 'ºC'),
	(238687, 122, '2014-03-01 01:19:45.000000', 'temperatura', 218.0000, 'ºC'),
	(238688, 122, '2014-03-01 01:19:46.000000', 'temperatura', 369.0000, 'ºC'),
	(238689, 122, '2014-03-01 01:19:47.000000', 'temperatura', 1194.0000, 'ºC'),
	(238690, 122, '2014-03-01 01:19:48.000000', 'temperatura', 61.0000, 'ºC'),
	(238691, 122, '2014-03-01 01:19:49.000000', 'temperatura', 327.0000, 'ºC'),
	(238692, 122, '2014-03-01 01:19:50.000000', 'temperatura', 250.0000, 'ºC'),
	(238693, 122, '2014-03-01 01:19:51.000000', 'temperatura', 269.0000, 'ºC'),
	(238694, 122, '2014-03-01 01:19:52.000000', 'temperatura', 598.0000, 'ºC'),
	(238695, 122, '2014-03-01 01:19:53.000000', 'temperatura', 981.0000, 'ºC'),
	(238696, 122, '2014-03-01 01:19:54.000000', 'temperatura', 712.0000, 'ºC'),
	(238697, 122, '2014-03-01 01:19:55.000000', 'temperatura', 618.0000, 'ºC'),
	(238698, 122, '2014-03-01 01:19:56.000000', 'temperatura', 953.0000, 'ºC'),
	(238699, 122, '2014-03-01 01:19:57.000000', 'temperatura', 510.0000, 'ºC'),
	(238700, 122, '2014-03-01 01:19:58.000000', 'temperatura', 895.0000, 'ºC'),
	(238701, 122, '2014-03-01 01:19:59.000000', 'temperatura', 545.0000, 'ºC'),
	(238702, 122, '2014-03-01 01:20:00.000000', 'temperatura', 38.0000, 'ºC'),
	(238703, 122, '2014-03-01 01:20:01.000000', 'temperatura', 957.0000, 'ºC'),
	(238704, 122, '2014-03-01 01:20:02.000000', 'temperatura', 1070.0000, 'ºC'),
	(238705, 122, '2014-03-01 01:20:03.000000', 'temperatura', 80.0000, 'ºC'),
	(238706, 122, '2014-03-01 01:20:04.000000', 'temperatura', 792.0000, 'ºC'),
	(238707, 122, '2014-03-01 01:20:05.000000', 'temperatura', 119.0000, 'ºC'),
	(238708, 122, '2014-03-01 01:20:06.000000', 'temperatura', 620.0000, 'ºC'),
	(238709, 122, '2014-03-01 01:20:07.000000', 'temperatura', 344.0000, 'ºC'),
	(238710, 122, '2014-03-01 01:20:08.000000', 'temperatura', 1061.0000, 'ºC'),
	(238711, 122, '2014-03-01 01:20:09.000000', 'temperatura', 675.0000, 'ºC'),
	(238712, 122, '2014-03-01 01:20:10.000000', 'temperatura', 189.0000, 'ºC'),
	(238713, 122, '2014-03-01 01:20:11.000000', 'temperatura', 123.0000, 'ºC'),
	(238714, 122, '2014-03-01 01:20:12.000000', 'temperatura', 48.0000, 'ºC'),
	(238715, 122, '2014-03-01 01:20:13.000000', 'temperatura', 1072.0000, 'ºC'),
	(238716, 122, '2014-03-01 01:20:14.000000', 'temperatura', 414.0000, 'ºC'),
	(238717, 122, '2014-03-01 01:20:15.000000', 'temperatura', 58.0000, 'ºC'),
	(238718, 122, '2014-03-01 01:20:16.000000', 'temperatura', 247.0000, 'ºC'),
	(238719, 122, '2014-03-01 01:20:17.000000', 'temperatura', 1061.0000, 'ºC'),
	(238720, 122, '2014-03-01 01:20:18.000000', 'temperatura', 964.0000, 'ºC'),
	(238721, 122, '2014-03-01 01:20:19.000000', 'temperatura', 439.0000, 'ºC'),
	(238722, 122, '2014-03-01 01:20:20.000000', 'temperatura', 504.0000, 'ºC'),
	(238723, 122, '2014-03-01 01:20:21.000000', 'temperatura', 2.0000, 'ºC'),
	(238724, 122, '2014-03-01 01:20:22.000000', 'temperatura', 898.0000, 'ºC'),
	(238725, 122, '2014-03-01 01:20:23.000000', 'temperatura', 884.0000, 'ºC'),
	(238726, 122, '2014-03-01 01:20:24.000000', 'temperatura', 527.0000, 'ºC'),
	(238727, 122, '2014-03-01 01:20:25.000000', 'temperatura', 1183.0000, 'ºC'),
	(238728, 122, '2014-03-01 01:20:26.000000', 'temperatura', 736.0000, 'ºC'),
	(238729, 122, '2014-03-01 01:20:27.000000', 'temperatura', 130.0000, 'ºC'),
	(238730, 122, '2014-03-01 01:20:28.000000', 'temperatura', 841.0000, 'ºC'),
	(238731, 122, '2014-03-01 01:20:29.000000', 'temperatura', 219.0000, 'ºC'),
	(238732, 122, '2014-03-01 01:20:30.000000', 'temperatura', 970.0000, 'ºC'),
	(238733, 122, '2014-03-01 01:20:31.000000', 'temperatura', 594.0000, 'ºC'),
	(238734, 122, '2014-03-01 01:20:32.000000', 'temperatura', 61.0000, 'ºC'),
	(238735, 122, '2014-03-01 01:20:33.000000', 'temperatura', 925.0000, 'ºC'),
	(238736, 122, '2014-03-01 01:20:34.000000', 'temperatura', 839.0000, 'ºC'),
	(238737, 122, '2014-03-01 01:20:35.000000', 'temperatura', 223.0000, 'ºC'),
	(238738, 122, '2014-03-01 01:20:36.000000', 'temperatura', 999.0000, 'ºC'),
	(238739, 122, '2014-03-01 01:20:37.000000', 'temperatura', 725.0000, 'ºC'),
	(238740, 122, '2014-03-01 01:20:38.000000', 'temperatura', 631.0000, 'ºC'),
	(238741, 122, '2014-03-01 01:20:39.000000', 'temperatura', 977.0000, 'ºC'),
	(238742, 122, '2014-03-01 01:20:40.000000', 'temperatura', 595.0000, 'ºC'),
	(238743, 122, '2014-03-01 01:20:41.000000', 'temperatura', 42.0000, 'ºC'),
	(238744, 122, '2014-03-01 01:20:42.000000', 'temperatura', 829.0000, 'ºC'),
	(238745, 122, '2014-03-01 01:20:43.000000', 'temperatura', 417.0000, 'ºC'),
	(238746, 122, '2014-03-01 01:20:44.000000', 'temperatura', 801.0000, 'ºC'),
	(238747, 122, '2014-03-01 01:20:45.000000', 'temperatura', 352.0000, 'ºC'),
	(238748, 122, '2014-03-01 01:20:46.000000', 'temperatura', 557.0000, 'ºC'),
	(238749, 122, '2014-03-01 01:20:47.000000', 'temperatura', 532.0000, 'ºC'),
	(238750, 122, '2014-03-01 01:20:48.000000', 'temperatura', 990.0000, 'ºC'),
	(238751, 122, '2014-03-01 01:20:49.000000', 'temperatura', 952.0000, 'ºC'),
	(238752, 122, '2014-03-01 01:20:50.000000', 'temperatura', 590.0000, 'ºC'),
	(238753, 122, '2014-03-01 01:20:51.000000', 'temperatura', 95.0000, 'ºC'),
	(238754, 122, '2014-03-01 01:20:52.000000', 'temperatura', 1108.0000, 'ºC'),
	(238755, 122, '2014-03-01 01:20:53.000000', 'temperatura', 452.0000, 'ºC'),
	(238756, 122, '2014-03-01 01:20:54.000000', 'temperatura', 138.0000, 'ºC'),
	(238757, 122, '2014-03-01 01:20:55.000000', 'temperatura', 536.0000, 'ºC'),
	(238758, 122, '2014-03-01 01:20:56.000000', 'temperatura', 1067.0000, 'ºC'),
	(238759, 122, '2014-03-01 01:20:57.000000', 'temperatura', 126.0000, 'ºC'),
	(238760, 122, '2014-03-01 01:20:58.000000', 'temperatura', 1029.0000, 'ºC'),
	(238761, 122, '2014-03-01 01:20:59.000000', 'temperatura', 1168.0000, 'ºC'),
	(238762, 122, '2014-03-01 01:21:00.000000', 'temperatura', 353.0000, 'ºC'),
	(238763, 122, '2014-03-01 01:21:01.000000', 'temperatura', 662.0000, 'ºC'),
	(238764, 122, '2014-03-01 01:21:02.000000', 'temperatura', 1051.0000, 'ºC'),
	(238765, 122, '2014-03-01 01:21:03.000000', 'temperatura', 869.0000, 'ºC'),
	(238766, 122, '2014-03-01 01:21:04.000000', 'temperatura', 1193.0000, 'ºC'),
	(238767, 122, '2014-03-01 01:21:05.000000', 'temperatura', 957.0000, 'ºC'),
	(238768, 122, '2014-03-01 01:21:06.000000', 'temperatura', 9.0000, 'ºC'),
	(238769, 122, '2014-03-01 01:21:07.000000', 'temperatura', 776.0000, 'ºC'),
	(238770, 122, '2014-03-01 01:21:08.000000', 'temperatura', 250.0000, 'ºC'),
	(238771, 122, '2014-03-01 01:21:09.000000', 'temperatura', 124.0000, 'ºC'),
	(238772, 122, '2014-03-01 01:21:10.000000', 'temperatura', 1071.0000, 'ºC'),
	(238773, 122, '2014-03-01 01:21:11.000000', 'temperatura', 183.0000, 'ºC'),
	(238774, 122, '2014-03-01 01:21:12.000000', 'temperatura', 101.0000, 'ºC'),
	(238775, 122, '2014-03-01 01:21:13.000000', 'temperatura', 1156.0000, 'ºC'),
	(238776, 122, '2014-03-01 01:21:14.000000', 'temperatura', 680.0000, 'ºC'),
	(238777, 122, '2014-03-01 01:21:15.000000', 'temperatura', 1131.0000, 'ºC'),
	(238778, 122, '2014-03-01 01:21:16.000000', 'temperatura', 18.0000, 'ºC'),
	(238779, 122, '2014-03-01 01:21:17.000000', 'temperatura', 296.0000, 'ºC'),
	(238780, 122, '2014-03-01 01:21:18.000000', 'temperatura', 226.0000, 'ºC'),
	(238781, 122, '2014-03-01 01:21:19.000000', 'temperatura', 243.0000, 'ºC'),
	(238782, 122, '2014-03-01 01:21:20.000000', 'temperatura', 536.0000, 'ºC'),
	(238783, 122, '2014-03-01 01:21:21.000000', 'temperatura', 752.0000, 'ºC'),
	(238784, 122, '2014-03-01 01:21:22.000000', 'temperatura', 951.0000, 'ºC'),
	(238785, 122, '2014-03-01 01:21:23.000000', 'temperatura', 103.0000, 'ºC'),
	(238786, 122, '2014-03-01 01:21:24.000000', 'temperatura', 59.0000, 'ºC'),
	(238787, 122, '2014-03-01 01:21:25.000000', 'temperatura', 1188.0000, 'ºC'),
	(238788, 122, '2014-03-01 01:21:26.000000', 'temperatura', 965.0000, 'ºC'),
	(238789, 122, '2014-03-01 01:21:27.000000', 'temperatura', 60.0000, 'ºC'),
	(238790, 122, '2014-03-01 01:21:28.000000', 'temperatura', 1005.0000, 'ºC'),
	(238791, 122, '2014-03-01 01:21:29.000000', 'temperatura', 44.0000, 'ºC'),
	(238792, 122, '2014-03-01 01:21:30.000000', 'temperatura', 808.0000, 'ºC'),
	(238793, 122, '2014-03-01 01:21:31.000000', 'temperatura', 307.0000, 'ºC'),
	(238794, 122, '2014-03-01 01:21:32.000000', 'temperatura', 311.0000, 'ºC'),
	(238795, 122, '2014-03-01 01:21:33.000000', 'temperatura', 636.0000, 'ºC'),
	(238796, 122, '2014-03-01 01:21:34.000000', 'temperatura', 1047.0000, 'ºC'),
	(238797, 122, '2014-03-01 01:21:35.000000', 'temperatura', 926.0000, 'ºC'),
	(238798, 122, '2014-03-01 01:21:36.000000', 'temperatura', 290.0000, 'ºC'),
	(238799, 122, '2014-03-01 01:21:37.000000', 'temperatura', 1074.0000, 'ºC'),
	(238800, 122, '2014-03-01 01:21:38.000000', 'temperatura', 901.0000, 'ºC'),
	(238801, 122, '2014-03-01 01:21:39.000000', 'temperatura', 83.0000, 'ºC'),
	(238802, 122, '2014-03-01 01:21:40.000000', 'temperatura', 111.0000, 'ºC'),
	(238803, 122, '2014-03-01 01:21:41.000000', 'temperatura', 308.0000, 'ºC'),
	(238804, 122, '2014-03-01 01:21:42.000000', 'temperatura', 6.0000, 'ºC'),
	(238805, 122, '2014-03-01 01:21:43.000000', 'temperatura', 305.0000, 'ºC'),
	(238806, 122, '2014-03-01 01:21:44.000000', 'temperatura', 310.0000, 'ºC'),
	(238807, 122, '2014-03-01 01:21:45.000000', 'temperatura', 635.0000, 'ºC'),
	(238808, 122, '2014-03-01 01:21:46.000000', 'temperatura', 1047.0000, 'ºC'),
	(238809, 122, '2014-03-01 01:21:47.000000', 'temperatura', 931.0000, 'ºC'),
	(238810, 122, '2014-03-01 01:21:48.000000', 'temperatura', 314.0000, 'ºC'),
	(238811, 122, '2014-03-01 01:21:49.000000', 'temperatura', 1178.0000, 'ºC'),
	(238812, 122, '2014-03-01 01:21:50.000000', 'temperatura', 147.0000, 'ºC'),
	(238813, 122, '2014-03-01 01:21:51.000000', 'temperatura', 804.0000, 'ºC'),
	(238814, 122, '2014-03-01 01:21:52.000000', 'temperatura', 1179.0000, 'ºC'),
	(238815, 122, '2014-03-01 01:21:53.000000', 'temperatura', 1081.0000, 'ºC'),
	(238816, 122, '2014-03-01 01:21:54.000000', 'temperatura', 670.0000, 'ºC'),
	(238817, 122, '2014-03-01 01:21:55.000000', 'temperatura', 108.0000, 'ºC'),
	(238818, 122, '2014-03-01 01:21:56.000000', 'temperatura', 930.0000, 'ºC'),
	(238819, 122, '2014-03-01 01:21:57.000000', 'temperatura', 726.0000, 'ºC'),
	(238820, 122, '2014-03-01 01:21:58.000000', 'temperatura', 839.0000, 'ºC'),
	(238821, 122, '2014-03-01 01:21:59.000000', 'temperatura', 818.0000, 'ºC'),
	(238822, 122, '2014-03-01 01:22:00.000000', 'temperatura', 373.0000, 'ºC'),
	(238823, 122, '2014-03-01 01:22:01.000000', 'temperatura', 611.0000, 'ºC'),
	(238824, 122, '2014-03-01 01:22:02.000000', 'temperatura', 739.0000, 'ºC'),
	(238825, 122, '2014-03-01 01:22:03.000000', 'temperatura', 663.0000, 'ºC'),
	(238826, 122, '2014-03-01 01:22:04.000000', 'temperatura', 1097.0000, 'ºC'),
	(238827, 122, '2014-03-01 01:22:05.000000', 'temperatura', 1097.0000, 'ºC'),
	(238828, 122, '2014-03-01 01:22:06.000000', 'temperatura', 994.0000, 'ºC'),
	(238829, 122, '2014-03-01 01:22:07.000000', 'temperatura', 479.0000, 'ºC'),
	(238830, 122, '2014-03-01 01:22:08.000000', 'temperatura', 616.0000, 'ºC'),
	(238831, 122, '2014-03-01 01:22:09.000000', 'temperatura', 440.0000, 'ºC'),
	(238832, 122, '2014-03-01 01:22:10.000000', 'temperatura', 356.0000, 'ºC'),
	(238833, 122, '2014-03-01 01:22:11.000000', 'temperatura', 459.0000, 'ºC'),
	(238834, 122, '2014-03-01 01:22:12.000000', 'temperatura', 27.0000, 'ºC'),
	(238835, 122, '2014-03-01 01:22:13.000000', 'temperatura', 1159.0000, 'ºC'),
	(238836, 122, '2014-03-01 01:22:14.000000', 'temperatura', 916.0000, 'ºC'),
	(238837, 122, '2014-03-01 01:22:15.000000', 'temperatura', 1103.0000, 'ºC'),
	(238838, 122, '2014-03-01 01:22:16.000000', 'temperatura', 365.0000, 'ºC'),
	(238839, 122, '2014-03-01 01:22:17.000000', 'temperatura', 919.0000, 'ºC'),
	(238840, 122, '2014-03-01 01:22:18.000000', 'temperatura', 1101.0000, 'ºC'),
	(238841, 122, '2014-03-01 01:22:19.000000', 'temperatura', 350.0000, 'ºC'),
	(238842, 122, '2014-03-01 01:22:20.000000', 'temperatura', 845.0000, 'ºC'),
	(238843, 122, '2014-03-01 01:22:21.000000', 'temperatura', 774.0000, 'ºC'),
	(238844, 122, '2014-03-01 01:22:22.000000', 'temperatura', 138.0000, 'ºC'),
	(238845, 122, '2014-03-01 01:22:23.000000', 'temperatura', 769.0000, 'ºC'),
	(238846, 122, '2014-03-01 01:22:24.000000', 'temperatura', 1032.0000, 'ºC'),
	(238847, 122, '2014-03-01 01:22:25.000000', 'temperatura', 451.0000, 'ºC'),
	(238848, 122, '2014-03-01 01:22:26.000000', 'temperatura', 359.0000, 'ºC'),
	(238849, 122, '2014-03-01 01:22:27.000000', 'temperatura', 443.0000, 'ºC'),
	(238850, 122, '2014-03-01 01:22:28.000000', 'temperatura', 1137.0000, 'ºC'),
	(238851, 122, '2014-03-01 01:22:29.000000', 'temperatura', 758.0000, 'ºC'),
	(238852, 122, '2014-03-01 01:22:30.000000', 'temperatura', 378.0000, 'ºC'),
	(238853, 122, '2014-03-01 01:22:31.000000', 'temperatura', 817.0000, 'ºC'),
	(238854, 122, '2014-03-01 01:22:32.000000', 'temperatura', 550.0000, 'ºC'),
	(238855, 122, '2014-03-01 01:22:33.000000', 'temperatura', 302.0000, 'ºC'),
	(238856, 122, '2014-03-01 01:22:34.000000', 'temperatura', 1061.0000, 'ºC'),
	(238857, 122, '2014-03-01 01:22:35.000000', 'temperatura', 800.0000, 'ºC'),
	(238858, 122, '2014-03-01 01:22:36.000000', 'temperatura', 816.0000, 'ºC'),
	(238859, 122, '2014-03-01 01:22:37.000000', 'temperatura', 480.0000, 'ºC'),
	(238860, 122, '2014-03-01 01:22:38.000000', 'temperatura', 1153.0000, 'ºC'),
	(238861, 122, '2014-03-01 01:22:39.000000', 'temperatura', 726.0000, 'ºC'),
	(238862, 122, '2014-03-01 01:22:40.000000', 'temperatura', 171.0000, 'ºC'),
	(238863, 122, '2014-03-01 01:22:41.000000', 'temperatura', 1077.0000, 'ºC'),
	(238864, 122, '2014-03-01 01:22:42.000000', 'temperatura', 73.0000, 'ºC'),
	(238865, 122, '2014-03-01 01:22:43.000000', 'temperatura', 735.0000, 'ºC'),
	(238866, 122, '2014-03-01 01:22:44.000000', 'temperatura', 1057.0000, 'ºC'),
	(238867, 122, '2014-03-01 01:22:45.000000', 'temperatura', 679.0000, 'ºC'),
	(238868, 122, '2014-03-01 01:22:46.000000', 'temperatura', 226.0000, 'ºC'),
	(238869, 122, '2014-03-01 01:22:47.000000', 'temperatura', 292.0000, 'ºC'),
	(238870, 122, '2014-03-01 01:22:48.000000', 'temperatura', 783.0000, 'ºC'),
	(238871, 122, '2014-03-01 01:22:49.000000', 'temperatura', 641.0000, 'ºC'),
	(238872, 122, '2014-03-01 01:22:50.000000', 'temperatura', 854.0000, 'ºC'),
	(238873, 122, '2014-03-01 01:22:51.000000', 'temperatura', 1147.0000, 'ºC'),
	(238874, 122, '2014-03-01 01:22:52.000000', 'temperatura', 775.0000, 'ºC'),
	(238875, 122, '2014-03-01 01:22:53.000000', 'temperatura', 435.0000, 'ºC'),
	(238876, 122, '2014-03-01 01:22:54.000000', 'temperatura', 1050.0000, 'ºC'),
	(238877, 122, '2014-03-01 01:22:55.000000', 'temperatura', 344.0000, 'ºC'),
	(238878, 122, '2014-03-01 01:22:56.000000', 'temperatura', 973.0000, 'ºC'),
	(238879, 122, '2014-03-01 01:22:57.000000', 'temperatura', 230.0000, 'ºC'),
	(238880, 122, '2014-03-01 01:22:58.000000', 'temperatura', 635.0000, 'ºC'),
	(238881, 122, '2014-03-01 01:22:59.000000', 'temperatura', 83.0000, 'ºC'),
	(238882, 122, '2014-03-01 01:23:00.000000', 'temperatura', 913.0000, 'ºC'),
	(238883, 122, '2014-03-01 01:23:01.000000', 'temperatura', 717.0000, 'ºC'),
	(238884, 122, '2014-03-01 01:23:02.000000', 'temperatura', 844.0000, 'ºC'),
	(238885, 122, '2014-03-01 01:23:03.000000', 'temperatura', 870.0000, 'ºC'),
	(238886, 122, '2014-03-01 01:23:04.000000', 'temperatura', 619.0000, 'ºC'),
	(238887, 122, '2014-03-01 01:23:05.000000', 'temperatura', 485.0000, 'ºC'),
	(238888, 122, '2014-03-01 01:23:06.000000', 'temperatura', 567.0000, 'ºC'),
	(238889, 122, '2014-03-01 01:23:07.000000', 'temperatura', 184.0000, 'ºC'),
	(238890, 122, '2014-03-01 01:23:08.000000', 'temperatura', 416.0000, 'ºC'),
	(238891, 122, '2014-03-01 01:23:09.000000', 'temperatura', 331.0000, 'ºC'),
	(238892, 122, '2014-03-01 01:23:10.000000', 'temperatura', 408.0000, 'ºC'),
	(238893, 122, '2014-03-01 01:23:11.000000', 'temperatura', 1048.0000, 'ºC'),
	(238894, 122, '2014-03-01 01:23:12.000000', 'temperatura', 416.0000, 'ºC'),
	(238895, 122, '2014-03-01 01:23:13.000000', 'temperatura', 137.0000, 'ºC'),
	(238896, 122, '2014-03-01 01:23:14.000000', 'temperatura', 637.0000, 'ºC'),
	(238897, 122, '2014-03-01 01:23:15.000000', 'temperatura', 376.0000, 'ºC'),
	(238898, 122, '2014-03-01 01:23:16.000000', 'temperatura', 1167.0000, 'ºC'),
	(238899, 122, '2014-03-01 01:23:17.000000', 'temperatura', 1106.0000, 'ºC'),
	(238900, 122, '2014-03-01 01:23:18.000000', 'temperatura', 833.0000, 'ºC'),
	(238901, 122, '2014-03-01 01:23:19.000000', 'temperatura', 846.0000, 'ºC'),
	(238902, 122, '2014-03-01 01:23:20.000000', 'temperatura', 532.0000, 'ºC'),
	(238903, 122, '2014-03-01 01:23:21.000000', 'temperatura', 123.0000, 'ºC'),
	(238904, 122, '2014-03-01 01:23:22.000000', 'temperatura', 219.0000, 'ºC'),
	(238905, 122, '2014-03-01 01:23:23.000000', 'temperatura', 728.0000, 'ºC'),
	(238906, 122, '2014-03-01 01:23:24.000000', 'temperatura', 583.0000, 'ºC'),
	(238907, 122, '2014-03-01 01:23:25.000000', 'temperatura', 730.0000, 'ºC'),
	(238908, 122, '2014-03-01 01:23:26.000000', 'temperatura', 704.0000, 'ºC'),
	(238909, 122, '2014-03-01 01:23:27.000000', 'temperatura', 127.0000, 'ºC'),
	(238910, 122, '2014-03-01 01:23:28.000000', 'temperatura', 926.0000, 'ºC'),
	(238911, 122, '2014-03-01 01:23:29.000000', 'temperatura', 650.0000, 'ºC'),
	(238912, 122, '2014-03-01 01:23:30.000000', 'temperatura', 471.0000, 'ºC'),
	(238913, 122, '2014-03-01 01:23:31.000000', 'temperatura', 404.0000, 'ºC'),
	(238914, 122, '2014-03-01 01:23:32.000000', 'temperatura', 611.0000, 'ºC'),
	(238915, 122, '2014-03-01 01:23:33.000000', 'temperatura', 642.0000, 'ºC'),
	(238916, 122, '2014-03-01 01:23:34.000000', 'temperatura', 176.0000, 'ºC'),
	(238917, 122, '2014-03-01 01:23:35.000000', 'temperatura', 157.0000, 'ºC'),
	(238918, 122, '2014-03-01 01:23:36.000000', 'temperatura', 257.0000, 'ºC'),
	(238919, 122, '2014-03-01 01:23:37.000000', 'temperatura', 814.0000, 'ºC'),
	(238920, 122, '2014-03-01 01:23:38.000000', 'temperatura', 899.0000, 'ºC'),
	(238921, 122, '2014-03-01 01:23:39.000000', 'temperatura', 852.0000, 'ºC'),
	(238922, 122, '2014-03-01 01:23:40.000000', 'temperatura', 366.0000, 'ºC'),
	(238923, 122, '2014-03-01 01:23:41.000000', 'temperatura', 474.0000, 'ºC'),
	(238924, 122, '2014-03-01 01:23:42.000000', 'temperatura', 72.0000, 'ºC'),
	(238925, 122, '2014-03-01 01:23:43.000000', 'temperatura', 140.0000, 'ºC'),
	(238926, 122, '2014-03-01 01:23:44.000000', 'temperatura', 484.0000, 'ºC'),
	(238927, 122, '2014-03-01 01:23:45.000000', 'temperatura', 802.0000, 'ºC'),
	(238928, 122, '2014-03-01 01:23:46.000000', 'temperatura', 157.0000, 'ºC'),
	(238929, 122, '2014-03-01 01:23:47.000000', 'temperatura', 781.0000, 'ºC'),
	(238930, 122, '2014-03-01 01:23:48.000000', 'temperatura', 1033.0000, 'ºC'),
	(238931, 122, '2014-03-01 01:23:49.000000', 'temperatura', 425.0000, 'ºC'),
	(238932, 122, '2014-03-01 01:23:50.000000', 'temperatura', 225.0000, 'ºC'),
	(238933, 122, '2014-03-01 01:23:51.000000', 'temperatura', 1050.0000, 'ºC'),
	(238934, 122, '2014-03-01 01:23:52.000000', 'temperatura', 974.0000, 'ºC'),
	(238935, 122, '2014-03-01 01:23:53.000000', 'temperatura', 523.0000, 'ºC'),
	(238936, 122, '2014-03-01 01:23:54.000000', 'temperatura', 894.0000, 'ºC'),
	(238937, 122, '2014-03-01 01:23:55.000000', 'temperatura', 501.0000, 'ºC'),
	(238938, 122, '2014-03-01 01:23:56.000000', 'temperatura', 1023.0000, 'ºC'),
	(238939, 122, '2014-03-01 01:23:57.000000', 'temperatura', 11.0000, 'ºC'),
	(238940, 122, '2014-03-01 01:23:58.000000', 'temperatura', 586.0000, 'ºC'),
	(238941, 122, '2014-03-01 01:23:59.000000', 'temperatura', 500.0000, 'ºC'),
	(238942, 122, '2014-03-01 01:24:00.000000', 'temperatura', 742.0000, 'ºC'),
	(238943, 122, '2014-03-01 01:24:01.000000', 'temperatura', 1011.0000, 'ºC'),
	(238944, 122, '2014-03-01 01:24:02.000000', 'temperatura', 428.0000, 'ºC'),
	(238945, 122, '2014-03-01 01:24:03.000000', 'temperatura', 307.0000, 'ºC'),
	(238946, 122, '2014-03-01 01:24:04.000000', 'temperatura', 252.0000, 'ºC'),
	(238947, 122, '2014-03-01 01:24:05.000000', 'temperatura', 339.0000, 'ºC'),
	(238948, 122, '2014-03-01 01:24:06.000000', 'temperatura', 940.0000, 'ºC'),
	(238949, 122, '2014-03-01 01:24:07.000000', 'temperatura', 85.0000, 'ºC'),
	(238950, 122, '2014-03-01 01:24:08.000000', 'temperatura', 3.0000, 'ºC'),
	(238951, 122, '2014-03-01 01:24:09.000000', 'temperatura', 961.0000, 'ºC'),
	(238952, 122, '2014-03-01 01:24:10.000000', 'temperatura', 1196.0000, 'ºC'),
	(238953, 122, '2014-03-01 01:24:11.000000', 'temperatura', 699.0000, 'ºC'),
	(238954, 122, '2014-03-01 01:24:12.000000', 'temperatura', 1106.0000, 'ºC'),
	(238955, 122, '2014-03-01 01:24:13.000000', 'temperatura', 1036.0000, 'ºC'),
	(238956, 122, '2014-03-01 01:24:14.000000', 'temperatura', 660.0000, 'ºC'),
	(238957, 122, '2014-03-01 01:24:15.000000', 'temperatura', 195.0000, 'ºC'),
	(238958, 122, '2014-03-01 01:24:16.000000', 'temperatura', 194.0000, 'ºC'),
	(238959, 122, '2014-03-01 01:24:17.000000', 'temperatura', 386.0000, 'ºC'),
	(238960, 122, '2014-03-01 01:24:18.000000', 'temperatura', 146.0000, 'ºC'),
	(238961, 122, '2014-03-01 01:24:19.000000', 'temperatura', 776.0000, 'ºC'),
	(238962, 122, '2014-03-01 01:24:20.000000', 'temperatura', 1041.0000, 'ºC'),
	(238963, 122, '2014-03-01 01:24:21.000000', 'temperatura', 478.0000, 'ºC'),
	(238964, 122, '2014-03-01 01:24:22.000000', 'temperatura', 467.0000, 'ºC'),
	(238965, 122, '2014-03-01 01:24:23.000000', 'temperatura', 901.0000, 'ºC'),
	(238966, 122, '2014-03-01 01:24:24.000000', 'temperatura', 706.0000, 'ºC'),
	(238967, 122, '2014-03-01 01:24:25.000000', 'temperatura', 827.0000, 'ºC'),
	(238968, 122, '2014-03-01 01:24:26.000000', 'temperatura', 819.0000, 'ºC'),
	(238969, 122, '2014-03-01 01:24:27.000000', 'temperatura', 413.0000, 'ºC'),
	(238970, 122, '2014-03-01 01:24:28.000000', 'temperatura', 807.0000, 'ºC'),
	(238971, 122, '2014-03-01 01:24:29.000000', 'temperatura', 398.0000, 'ºC'),
	(238972, 122, '2014-03-01 01:24:30.000000', 'temperatura', 770.0000, 'ºC'),
	(238973, 122, '2014-03-01 01:24:31.000000', 'temperatura', 258.0000, 'ºC'),
	(238974, 122, '2014-03-01 01:24:32.000000', 'temperatura', 179.0000, 'ºC'),
	(238975, 122, '2014-03-01 01:24:33.000000', 'temperatura', 119.0000, 'ºC'),
	(238976, 122, '2014-03-01 01:24:34.000000', 'temperatura', 62.0000, 'ºC'),
	(238977, 122, '2014-03-01 01:24:35.000000', 'temperatura', 1154.0000, 'ºC'),
	(238978, 122, '2014-03-01 01:24:36.000000', 'temperatura', 782.0000, 'ºC'),
	(238979, 122, '2014-03-01 01:24:37.000000', 'temperatura', 449.0000, 'ºC'),
	(238980, 122, '2014-03-01 01:24:38.000000', 'temperatura', 1099.0000, 'ºC'),
	(238981, 122, '2014-03-01 01:24:39.000000', 'temperatura', 549.0000, 'ºC'),
	(238982, 122, '2014-03-01 01:24:40.000000', 'temperatura', 650.0000, 'ºC'),
	(238983, 122, '2014-03-01 01:24:41.000000', 'temperatura', 403.0000, 'ºC'),
	(238984, 122, '2014-03-01 01:24:42.000000', 'temperatura', 65.0000, 'ºC'),
	(238985, 122, '2014-03-01 01:24:43.000000', 'temperatura', 314.0000, 'ºC'),
	(238986, 122, '2014-03-01 01:24:44.000000', 'temperatura', 179.0000, 'ºC'),
	(238987, 122, '2014-03-01 01:24:45.000000', 'temperatura', 1154.0000, 'ºC'),
	(238988, 122, '2014-03-01 01:24:46.000000', 'temperatura', 431.0000, 'ºC'),
	(238989, 122, '2014-03-01 01:24:47.000000', 'temperatura', 1092.0000, 'ºC'),
	(238990, 122, '2014-03-01 01:24:48.000000', 'temperatura', 571.0000, 'ºC'),
	(238991, 122, '2014-03-01 01:24:49.000000', 'temperatura', 777.0000, 'ºC'),
	(238992, 122, '2014-03-01 01:24:50.000000', 'temperatura', 975.0000, 'ºC'),
	(238993, 122, '2014-03-01 01:24:51.000000', 'temperatura', 144.0000, 'ºC'),
	(238994, 122, '2014-03-01 01:24:52.000000', 'temperatura', 196.0000, 'ºC'),
	(238995, 122, '2014-03-01 01:24:53.000000', 'temperatura', 548.0000, 'ºC'),
	(238996, 122, '2014-03-01 01:24:54.000000', 'temperatura', 950.0000, 'ºC'),
	(238997, 122, '2014-03-01 01:24:55.000000', 'temperatura', 710.0000, 'ºC'),
	(238998, 122, '2014-03-01 01:24:56.000000', 'temperatura', 698.0000, 'ºC'),
	(238999, 122, '2014-03-01 01:24:57.000000', 'temperatura', 161.0000, 'ºC'),
	(239000, 122, '2014-03-01 01:24:58.000000', 'temperatura', 1112.0000, 'ºC'),
	(239001, 122, '2014-03-01 01:24:59.000000', 'temperatura', 277.0000, 'ºC'),
	(239002, 122, '2014-03-01 01:25:00.000000', 'temperatura', 450.0000, 'ºC'),
	(239003, 122, '2014-03-01 01:25:01.000000', 'temperatura', 219.0000, 'ºC'),
	(239004, 122, '2014-03-01 01:25:02.000000', 'temperatura', 944.0000, 'ºC'),
	(239005, 122, '2014-03-01 01:25:03.000000', 'temperatura', 466.0000, 'ºC'),
	(239006, 122, '2014-03-01 01:25:04.000000', 'temperatura', 697.0000, 'ºC'),
	(239007, 122, '2014-03-01 01:25:05.000000', 'temperatura', 890.0000, 'ºC'),
	(239008, 122, '2014-03-01 01:25:06.000000', 'temperatura', 1157.0000, 'ºC'),
	(239009, 122, '2014-03-01 01:25:07.000000', 'temperatura', 718.0000, 'ºC'),
	(239010, 122, '2014-03-01 01:25:08.000000', 'temperatura', 118.0000, 'ºC'),
	(239011, 122, '2014-03-01 01:25:09.000000', 'temperatura', 838.0000, 'ºC'),
	(239012, 122, '2014-03-01 01:25:10.000000', 'temperatura', 234.0000, 'ºC'),
	(239013, 122, '2014-03-01 01:25:11.000000', 'temperatura', 1058.0000, 'ºC'),
	(239014, 122, '2014-03-01 01:25:12.000000', 'temperatura', 987.0000, 'ºC'),
	(239015, 122, '2014-03-01 01:25:13.000000', 'temperatura', 563.0000, 'ºC'),
	(239016, 122, '2014-03-01 01:25:14.000000', 'temperatura', 1053.0000, 'ºC'),
	(239017, 122, '2014-03-01 01:25:15.000000', 'temperatura', 1177.0000, 'ºC'),
	(239018, 122, '2014-03-01 01:25:16.000000', 'temperatura', 328.0000, 'ºC'),
	(239019, 122, '2014-03-01 01:25:17.000000', 'temperatura', 511.0000, 'ºC'),
	(239020, 122, '2014-03-01 01:25:18.000000', 'temperatura', 368.0000, 'ºC'),
	(239021, 122, '2014-03-01 01:25:19.000000', 'temperatura', 310.0000, 'ºC'),
	(239022, 122, '2014-03-01 01:25:20.000000', 'temperatura', 446.0000, 'ºC'),
	(239023, 122, '2014-03-01 01:25:21.000000', 'temperatura', 101.0000, 'ºC'),
	(239024, 122, '2014-03-01 01:25:22.000000', 'temperatura', 368.0000, 'ºC'),
	(239025, 122, '2014-03-01 01:25:23.000000', 'temperatura', 339.0000, 'ºC'),
	(239026, 122, '2014-03-01 01:25:24.000000', 'temperatura', 588.0000, 'ºC'),
	(239027, 122, '2014-03-01 01:25:25.000000', 'temperatura', 726.0000, 'ºC'),
	(239028, 122, '2014-03-01 01:25:26.000000', 'temperatura', 667.0000, 'ºC'),
	(239029, 122, '2014-03-01 01:25:27.000000', 'temperatura', 1157.0000, 'ºC'),
	(239030, 122, '2014-03-01 01:25:28.000000', 'temperatura', 186.0000, 'ºC'),
	(239031, 122, '2014-03-01 01:25:29.000000', 'temperatura', 1059.0000, 'ºC'),
	(239032, 122, '2014-03-01 01:25:30.000000', 'temperatura', 1136.0000, 'ºC'),
	(239033, 122, '2014-03-01 01:25:31.000000', 'temperatura', 104.0000, 'ºC'),
	(239034, 122, '2014-03-01 01:25:32.000000', 'temperatura', 711.0000, 'ºC'),
	(239035, 122, '2014-03-01 01:25:33.000000', 'temperatura', 843.0000, 'ºC'),
	(239036, 122, '2014-03-01 01:25:34.000000', 'temperatura', 883.0000, 'ºC'),
	(239037, 122, '2014-03-01 01:25:35.000000', 'temperatura', 687.0000, 'ºC'),
	(239038, 122, '2014-03-01 01:25:36.000000', 'temperatura', 786.0000, 'ºC'),
	(239039, 122, '2014-03-01 01:25:37.000000', 'temperatura', 671.0000, 'ºC'),
	(239040, 122, '2014-03-01 01:25:38.000000', 'temperatura', 995.0000, 'ºC'),
	(239041, 122, '2014-03-01 01:25:39.000000', 'temperatura', 566.0000, 'ºC'),
	(239042, 122, '2014-03-01 01:25:40.000000', 'temperatura', 1042.0000, 'ºC'),
	(239043, 122, '2014-03-01 01:25:41.000000', 'temperatura', 1114.0000, 'ºC'),
	(239044, 122, '2014-03-01 01:25:42.000000', 'temperatura', 44.0000, 'ºC'),
	(239045, 122, '2014-03-01 01:25:43.000000', 'temperatura', 481.0000, 'ºC'),
	(239046, 122, '2014-03-01 01:25:44.000000', 'temperatura', 1070.0000, 'ºC'),
	(239047, 122, '2014-03-01 01:25:45.000000', 'temperatura', 311.0000, 'ºC'),
	(239048, 122, '2014-03-01 01:25:46.000000', 'temperatura', 744.0000, 'ºC'),
	(239049, 122, '2014-03-01 01:25:47.000000', 'temperatura', 386.0000, 'ºC'),
	(239050, 122, '2014-03-01 01:25:48.000000', 'temperatura', 899.0000, 'ºC'),
	(239051, 122, '2014-03-01 01:25:49.000000', 'temperatura', 940.0000, 'ºC'),
	(239052, 122, '2014-03-01 01:25:50.000000', 'temperatura', 802.0000, 'ºC'),
	(239053, 122, '2014-03-01 01:25:51.000000', 'temperatura', 1188.0000, 'ºC'),
	(239054, 122, '2014-03-01 01:25:52.000000', 'temperatura', 1138.0000, 'ºC'),
	(239055, 122, '2014-03-01 01:25:53.000000', 'temperatura', 926.0000, 'ºC'),
	(239056, 122, '2014-03-01 01:25:54.000000', 'temperatura', 17.0000, 'ºC'),
	(239057, 122, '2014-03-01 01:25:55.000000', 'temperatura', 905.0000, 'ºC'),
	(239058, 122, '2014-03-01 01:25:56.000000', 'temperatura', 874.0000, 'ºC'),
	(239059, 122, '2014-03-01 01:25:57.000000', 'temperatura', 458.0000, 'ºC'),
	(239060, 122, '2014-03-01 01:25:58.000000', 'temperatura', 867.0000, 'ºC'),
	(239061, 122, '2014-03-01 01:25:59.000000', 'temperatura', 563.0000, 'ºC'),
	(239062, 122, '2014-03-01 01:26:00.000000', 'temperatura', 213.0000, 'ºC'),
	(239063, 122, '2014-03-01 01:26:01.000000', 'temperatura', 576.0000, 'ºC'),
	(239064, 122, '2014-03-01 01:26:02.000000', 'temperatura', 1040.0000, 'ºC'),
	(239065, 122, '2014-03-01 01:26:03.000000', 'temperatura', 1075.0000, 'ºC'),
	(239066, 122, '2014-03-01 01:26:04.000000', 'temperatura', 1055.0000, 'ºC'),
	(239067, 122, '2014-03-01 01:26:05.000000', 'temperatura', 851.0000, 'ºC'),
	(239068, 122, '2014-03-01 01:26:06.000000', 'temperatura', 1090.0000, 'ºC'),
	(239069, 122, '2014-03-01 01:26:07.000000', 'temperatura', 496.0000, 'ºC'),
	(239070, 122, '2014-03-01 01:26:08.000000', 'temperatura', 413.0000, 'ºC'),
	(239071, 122, '2014-03-01 01:26:09.000000', 'temperatura', 575.0000, 'ºC'),
	(239072, 122, '2014-03-01 01:26:10.000000', 'temperatura', 438.0000, 'ºC'),
	(239073, 122, '2014-03-01 01:26:11.000000', 'temperatura', 467.0000, 'ºC'),
	(239074, 122, '2014-03-01 01:26:12.000000', 'temperatura', 1022.0000, 'ºC'),
	(239075, 122, '2014-03-01 01:26:13.000000', 'temperatura', 107.0000, 'ºC'),
	(239076, 122, '2014-03-01 01:26:14.000000', 'temperatura', 1070.0000, 'ºC'),
	(239077, 122, '2014-03-01 01:26:15.000000', 'temperatura', 229.0000, 'ºC'),
	(239078, 122, '2014-03-01 01:26:16.000000', 'temperatura', 335.0000, 'ºC'),
	(239079, 122, '2014-03-01 01:26:17.000000', 'temperatura', 990.0000, 'ºC'),
	(239080, 122, '2014-03-01 01:26:18.000000', 'temperatura', 345.0000, 'ºC'),
	(239081, 122, '2014-03-01 01:26:19.000000', 'temperatura', 1155.0000, 'ºC'),
	(239082, 122, '2014-03-01 01:26:20.000000', 'temperatura', 1139.0000, 'ºC'),
	(239083, 122, '2014-03-01 01:26:21.000000', 'temperatura', 1032.0000, 'ºC'),
	(239084, 122, '2014-03-01 01:26:22.000000', 'temperatura', 544.0000, 'ºC'),
	(239085, 122, '2014-03-01 01:26:23.000000', 'temperatura', 825.0000, 'ºC'),
	(239086, 122, '2014-03-01 01:26:24.000000', 'temperatura', 92.0000, 'ºC'),
	(239087, 122, '2014-03-01 01:26:25.000000', 'temperatura', 386.0000, 'ºC'),
	(239088, 122, '2014-03-01 01:26:26.000000', 'temperatura', 454.0000, 'ºC'),
	(239089, 122, '2014-03-01 01:26:27.000000', 'temperatura', 1114.0000, 'ºC'),
	(239090, 122, '2014-03-01 01:26:28.000000', 'temperatura', 608.0000, 'ºC'),
	(239091, 122, '2014-03-01 01:26:29.000000', 'temperatura', 897.0000, 'ºC'),
	(239092, 122, '2014-03-01 01:26:30.000000', 'temperatura', 264.0000, 'ºC'),
	(239093, 122, '2014-03-01 01:26:31.000000', 'temperatura', 1028.0000, 'ºC'),
	(239094, 122, '2014-03-01 01:26:32.000000', 'temperatura', 748.0000, 'ºC'),
	(239095, 122, '2014-03-01 01:26:33.000000', 'temperatura', 656.0000, 'ºC'),
	(239096, 122, '2014-03-01 01:26:34.000000', 'temperatura', 1037.0000, 'ºC'),
	(239097, 122, '2014-03-01 01:26:35.000000', 'temperatura', 819.0000, 'ºC'),
	(239098, 122, '2014-03-01 01:26:36.000000', 'temperatura', 982.0000, 'ºC'),
	(239099, 122, '2014-03-01 01:26:37.000000', 'temperatura', 54.0000, 'ºC'),
	(239100, 122, '2014-03-01 01:26:38.000000', 'temperatura', 924.0000, 'ºC'),
	(239101, 122, '2014-03-01 01:26:39.000000', 'temperatura', 860.0000, 'ºC'),
	(239102, 122, '2014-03-01 01:26:40.000000', 'temperatura', 328.0000, 'ºC'),
	(239103, 122, '2014-03-01 01:26:41.000000', 'temperatura', 259.0000, 'ºC'),
	(239104, 122, '2014-03-01 01:26:42.000000', 'temperatura', 312.0000, 'ºC'),
	(239105, 122, '2014-03-01 01:26:43.000000', 'temperatura', 784.0000, 'ºC'),
	(239106, 122, '2014-03-01 01:26:44.000000', 'temperatura', 585.0000, 'ºC'),
	(239107, 122, '2014-03-01 01:26:45.000000', 'temperatura', 574.0000, 'ºC'),
	(239108, 122, '2014-03-01 01:26:46.000000', 'temperatura', 1113.0000, 'ºC'),
	(239109, 122, '2014-03-01 01:26:47.000000', 'temperatura', 247.0000, 'ºC'),
	(239110, 122, '2014-03-01 01:26:48.000000', 'temperatura', 293.0000, 'ºC'),
	(239111, 122, '2014-03-01 01:26:49.000000', 'temperatura', 727.0000, 'ºC'),
	(239112, 122, '2014-03-01 01:26:50.000000', 'temperatura', 354.0000, 'ºC'),
	(239113, 122, '2014-03-01 01:26:51.000000', 'temperatura', 789.0000, 'ºC'),
	(239114, 122, '2014-03-01 01:26:52.000000', 'temperatura', 486.0000, 'ºC'),
	(239115, 122, '2014-03-01 01:26:53.000000', 'temperatura', 64.0000, 'ºC'),
	(239116, 122, '2014-03-01 01:26:54.000000', 'temperatura', 62.0000, 'ºC'),
	(239117, 122, '2014-03-01 01:26:55.000000', 'temperatura', 117.0000, 'ºC'),
	(239118, 122, '2014-03-01 01:26:56.000000', 'temperatura', 399.0000, 'ºC'),
	(239119, 122, '2014-03-01 01:26:57.000000', 'temperatura', 444.0000, 'ºC'),
	(239120, 122, '2014-03-01 01:26:58.000000', 'temperatura', 1025.0000, 'ºC'),
	(239121, 122, '2014-03-01 01:26:59.000000', 'temperatura', 194.0000, 'ºC'),
	(239122, 122, '2014-03-01 01:27:00.000000', 'temperatura', 297.0000, 'ºC'),
	(239123, 122, '2014-03-01 01:27:01.000000', 'temperatura', 901.0000, 'ºC'),
	(239124, 122, '2014-03-01 01:27:02.000000', 'temperatura', 14.0000, 'ºC'),
	(239125, 122, '2014-03-01 01:27:03.000000', 'temperatura', 967.0000, 'ºC'),
	(239126, 122, '2014-03-01 01:27:04.000000', 'temperatura', 1192.0000, 'ºC'),
	(239127, 122, '2014-03-01 01:27:05.000000', 'temperatura', 663.0000, 'ºC'),
	(239128, 122, '2014-03-01 01:27:06.000000', 'temperatura', 939.0000, 'ºC'),
	(239129, 122, '2014-03-01 01:27:07.000000', 'temperatura', 306.0000, 'ºC'),
	(239130, 122, '2014-03-01 01:27:08.000000', 'temperatura', 1114.0000, 'ºC'),
	(239131, 122, '2014-03-01 01:27:09.000000', 'temperatura', 1050.0000, 'ºC'),
	(239132, 122, '2014-03-01 01:27:10.000000', 'temperatura', 712.0000, 'ºC'),
	(239133, 122, '2014-03-01 01:27:11.000000', 'temperatura', 408.0000, 'ºC'),
	(239134, 122, '2014-03-01 01:27:12.000000', 'temperatura', 1107.0000, 'ºC'),
	(239135, 122, '2014-03-01 01:27:13.000000', 'temperatura', 708.0000, 'ºC'),
	(239136, 122, '2014-03-01 01:27:14.000000', 'temperatura', 222.0000, 'ºC'),
	(239137, 122, '2014-03-01 01:27:15.000000', 'temperatura', 187.0000, 'ºC'),
	(239138, 122, '2014-03-01 01:27:16.000000', 'temperatura', 268.0000, 'ºC'),
	(239139, 122, '2014-03-01 01:27:17.000000', 'temperatura', 781.0000, 'ºC'),
	(239140, 122, '2014-03-01 01:27:18.000000', 'temperatura', 699.0000, 'ºC'),
	(239141, 122, '2014-03-01 01:27:19.000000', 'temperatura', 1154.0000, 'ºC'),
	(239142, 122, '2014-03-01 01:27:20.000000', 'temperatura', 72.0000, 'ºC'),
	(239143, 122, '2014-03-01 01:27:21.000000', 'temperatura', 501.0000, 'ºC'),
	(239144, 122, '2014-03-01 01:27:22.000000', 'temperatura', 1091.0000, 'ºC'),
	(239145, 122, '2014-03-01 01:27:23.000000', 'temperatura', 349.0000, 'ºC'),
	(239146, 122, '2014-03-01 01:27:24.000000', 'temperatura', 872.0000, 'ºC'),
	(239147, 122, '2014-03-01 01:27:25.000000', 'temperatura', 914.0000, 'ºC'),
	(239148, 122, '2014-03-01 01:27:26.000000', 'temperatura', 757.0000, 'ºC'),
	(239149, 122, '2014-03-01 01:27:27.000000', 'temperatura', 1041.0000, 'ºC'),
	(239150, 122, '2014-03-01 01:27:28.000000', 'temperatura', 534.0000, 'ºC'),
	(239151, 122, '2014-03-01 01:27:29.000000', 'temperatura', 749.0000, 'ºC'),
	(239152, 122, '2014-03-01 01:27:30.000000', 'temperatura', 944.0000, 'ºC'),
	(239153, 122, '2014-03-01 01:27:31.000000', 'temperatura', 71.0000, 'ºC'),
	(239154, 122, '2014-03-01 01:27:32.000000', 'temperatura', 1126.0000, 'ºC'),
	(239155, 122, '2014-03-01 01:27:33.000000', 'temperatura', 616.0000, 'ºC'),
	(239156, 122, '2014-03-01 01:27:34.000000', 'temperatura', 902.0000, 'ºC'),
	(239157, 122, '2014-03-01 01:27:35.000000', 'temperatura', 263.0000, 'ºC'),
	(239158, 122, '2014-03-01 01:27:36.000000', 'temperatura', 1010.0000, 'ºC'),
	(239159, 122, '2014-03-01 01:27:37.000000', 'temperatura', 663.0000, 'ºC'),
	(239160, 122, '2014-03-01 01:27:38.000000', 'temperatura', 283.0000, 'ºC'),
	(239161, 122, '2014-03-01 01:27:39.000000', 'temperatura', 627.0000, 'ºC'),
	(239162, 122, '2014-03-01 01:27:40.000000', 'temperatura', 1086.0000, 'ºC'),
	(239163, 122, '2014-03-01 01:27:41.000000', 'temperatura', 1152.0000, 'ºC'),
	(239164, 122, '2014-03-01 01:27:42.000000', 'temperatura', 100.0000, 'ºC'),
	(239165, 122, '2014-03-01 01:27:43.000000', 'temperatura', 643.0000, 'ºC'),
	(239166, 122, '2014-03-01 01:27:44.000000', 'temperatura', 518.0000, 'ºC'),
	(239167, 122, '2014-03-01 01:27:45.000000', 'temperatura', 660.0000, 'ºC'),
	(239168, 122, '2014-03-01 01:27:46.000000', 'temperatura', 548.0000, 'ºC'),
	(239169, 122, '2014-03-01 01:27:47.000000', 'temperatura', 760.0000, 'ºC'),
	(239170, 122, '2014-03-01 01:27:48.000000', 'temperatura', 958.0000, 'ºC'),
	(239171, 122, '2014-03-01 01:27:49.000000', 'temperatura', 108.0000, 'ºC'),
	(239172, 122, '2014-03-01 01:27:50.000000', 'temperatura', 69.0000, 'ºC'),
	(239173, 122, '2014-03-01 01:27:51.000000', 'temperatura', 20.0000, 'ºC'),
	(239174, 122, '2014-03-01 01:27:52.000000', 'temperatura', 1094.0000, 'ºC'),
	(239175, 122, '2014-03-01 01:27:53.000000', 'temperatura', 612.0000, 'ºC'),
	(239176, 122, '2014-03-01 01:27:54.000000', 'temperatura', 978.0000, 'ºC'),
	(239177, 122, '2014-03-01 01:27:55.000000', 'temperatura', 654.0000, 'ºC'),
	(239178, 122, '2014-03-01 01:27:56.000000', 'temperatura', 335.0000, 'ºC'),
	(239179, 122, '2014-03-01 01:27:57.000000', 'temperatura', 914.0000, 'ºC'),
	(239180, 122, '2014-03-01 01:27:58.000000', 'temperatura', 1167.0000, 'ºC'),
	(239181, 122, '2014-03-01 01:27:59.000000', 'temperatura', 692.0000, 'ºC'),
	(239182, 122, '2014-03-01 01:28:00.000000', 'temperatura', 1160.0000, 'ºC'),
	(239183, 122, '2014-03-01 01:28:01.000000', 'temperatura', 124.0000, 'ºC'),
	(239184, 122, '2014-03-01 01:28:02.000000', 'temperatura', 739.0000, 'ºC'),
	(239185, 122, '2014-03-01 01:28:03.000000', 'temperatura', 925.0000, 'ºC'),
	(239186, 122, '2014-03-01 01:28:04.000000', 'temperatura', 9.0000, 'ºC'),
	(239187, 122, '2014-03-01 01:28:05.000000', 'temperatura', 872.0000, 'ºC'),
	(239188, 122, '2014-03-01 01:28:06.000000', 'temperatura', 732.0000, 'ºC'),
	(239189, 122, '2014-03-01 01:28:07.000000', 'temperatura', 1043.0000, 'ºC'),
	(239190, 122, '2014-03-01 01:28:08.000000', 'temperatura', 620.0000, 'ºC'),
	(239191, 122, '2014-03-01 01:28:09.000000', 'temperatura', 1174.0000, 'ºC'),
	(239192, 122, '2014-03-01 01:28:10.000000', 'temperatura', 409.0000, 'ºC'),
	(239193, 122, '2014-03-01 01:28:11.000000', 'temperatura', 924.0000, 'ºC'),
	(239194, 122, '2014-03-01 01:28:12.000000', 'temperatura', 993.0000, 'ºC'),
	(239195, 122, '2014-03-01 01:28:13.000000', 'temperatura', 995.0000, 'ºC'),
	(239196, 122, '2014-03-01 01:28:14.000000', 'temperatura', 795.0000, 'ºC'),
	(239197, 122, '2014-03-01 01:28:15.000000', 'temperatura', 992.0000, 'ºC'),
	(239198, 122, '2014-03-01 01:28:16.000000', 'temperatura', 174.0000, 'ºC'),
	(239199, 122, '2014-03-01 01:28:17.000000', 'temperatura', 294.0000, 'ºC'),
	(239200, 122, '2014-03-01 01:28:18.000000', 'temperatura', 947.0000, 'ºC'),
	(239201, 122, '2014-03-01 01:28:19.000000', 'temperatura', 256.0000, 'ºC'),
	(239202, 122, '2014-03-01 01:28:20.000000', 'temperatura', 841.0000, 'ºC'),
	(239203, 122, '2014-03-01 01:28:21.000000', 'temperatura', 1036.0000, 'ºC'),
	(239204, 122, '2014-03-01 01:28:22.000000', 'temperatura', 256.0000, 'ºC'),
	(239205, 122, '2014-03-01 01:28:23.000000', 'temperatura', 573.0000, 'ºC'),
	(239206, 122, '2014-03-01 01:28:24.000000', 'temperatura', 899.0000, 'ºC'),
	(239207, 122, '2014-03-01 01:28:25.000000', 'temperatura', 377.0000, 'ºC'),
	(239208, 122, '2014-03-01 01:28:26.000000', 'temperatura', 387.0000, 'ºC'),
	(239209, 122, '2014-03-01 01:28:27.000000', 'temperatura', 803.0000, 'ºC'),
	(239210, 122, '2014-03-01 01:28:28.000000', 'temperatura', 456.0000, 'ºC'),
	(239211, 122, '2014-03-01 01:28:29.000000', 'temperatura', 1073.0000, 'ºC'),
	(239212, 122, '2014-03-01 01:28:30.000000', 'temperatura', 396.0000, 'ºC'),
	(239213, 122, '2014-03-01 01:28:31.000000', 'temperatura', 1163.0000, 'ºC'),
	(239214, 122, '2014-03-01 01:28:32.000000', 'temperatura', 1027.0000, 'ºC'),
	(239215, 122, '2014-03-01 01:28:33.000000', 'temperatura', 444.0000, 'ºC'),
	(239216, 122, '2014-03-01 01:28:34.000000', 'temperatura', 342.0000, 'ºC'),
	(239217, 122, '2014-03-01 01:28:35.000000', 'temperatura', 379.0000, 'ºC'),
	(239218, 122, '2014-03-01 01:28:36.000000', 'temperatura', 869.0000, 'ºC'),
	(239219, 122, '2014-03-01 01:28:37.000000', 'temperatura', 810.0000, 'ºC'),
	(239220, 122, '2014-03-01 01:28:38.000000', 'temperatura', 243.0000, 'ºC'),
	(239221, 122, '2014-03-01 01:28:39.000000', 'temperatura', 1185.0000, 'ºC'),
	(239222, 122, '2014-03-01 01:28:40.000000', 'temperatura', 397.0000, 'ºC'),
	(239223, 122, '2014-03-01 01:28:41.000000', 'temperatura', 830.0000, 'ºC'),
	(239224, 122, '2014-03-01 01:28:42.000000', 'temperatura', 560.0000, 'ºC'),
	(239225, 122, '2014-03-01 01:28:43.000000', 'temperatura', 309.0000, 'ºC'),
	(239226, 122, '2014-03-01 01:28:44.000000', 'temperatura', 1068.0000, 'ºC'),
	(239227, 122, '2014-03-01 01:28:45.000000', 'temperatura', 814.0000, 'ºC'),
	(239228, 122, '2014-03-01 01:28:46.000000', 'temperatura', 866.0000, 'ºC'),
	(239229, 122, '2014-03-01 01:28:47.000000', 'temperatura', 689.0000, 'ºC'),
	(239230, 122, '2014-03-01 01:28:48.000000', 'temperatura', 849.0000, 'ºC'),
	(239231, 122, '2014-03-01 01:28:49.000000', 'temperatura', 977.0000, 'ºC'),
	(239232, 122, '2014-03-01 01:28:50.000000', 'temperatura', 1137.0000, 'ºC'),
	(239233, 122, '2014-03-01 01:28:51.000000', 'temperatura', 357.0000, 'ºC'),
	(239234, 122, '2014-03-01 01:28:52.000000', 'temperatura', 773.0000, 'ºC'),
	(239235, 122, '2014-03-01 01:28:53.000000', 'temperatura', 395.0000, 'ºC'),
	(239236, 122, '2014-03-01 01:28:54.000000', 'temperatura', 855.0000, 'ºC'),
	(239237, 122, '2014-03-01 01:28:55.000000', 'temperatura', 690.0000, 'ºC'),
	(239238, 122, '2014-03-01 01:28:56.000000', 'temperatura', 885.0000, 'ºC'),
	(239239, 122, '2014-03-01 01:28:57.000000', 'temperatura', 1156.0000, 'ºC'),
	(239240, 122, '2014-03-01 01:28:58.000000', 'temperatura', 724.0000, 'ºC'),
	(239241, 122, '2014-03-01 01:28:59.000000', 'temperatura', 153.0000, 'ºC'),
	(239242, 122, '2014-03-01 01:29:00.000000', 'temperatura', 996.0000, 'ºC'),
	(239243, 122, '2014-03-01 01:29:01.000000', 'temperatura', 919.0000, 'ºC'),
	(239244, 122, '2014-03-01 01:29:02.000000', 'temperatura', 409.0000, 'ºC'),
	(239245, 122, '2014-03-01 01:29:03.000000', 'temperatura', 490.0000, 'ºC'),
	(239246, 122, '2014-03-01 01:29:04.000000', 'temperatura', 22.0000, 'ºC'),
	(239247, 122, '2014-03-01 01:29:05.000000', 'temperatura', 1041.0000, 'ºC'),
	(239248, 122, '2014-03-01 01:29:06.000000', 'temperatura', 338.0000, 'ºC'),
	(239249, 122, '2014-03-01 01:29:07.000000', 'temperatura', 966.0000, 'ºC'),
	(239250, 122, '2014-03-01 01:29:08.000000', 'temperatura', 219.0000, 'ºC'),
	(239251, 122, '2014-03-01 01:29:09.000000', 'temperatura', 598.0000, 'ºC'),
	(239252, 122, '2014-03-01 01:29:10.000000', 'temperatura', 1135.0000, 'ºC'),
	(239253, 122, '2014-03-01 01:29:11.000000', 'temperatura', 279.0000, 'ºC'),
	(239254, 122, '2014-03-01 01:29:12.000000', 'temperatura', 389.0000, 'ºC'),
	(239255, 122, '2014-03-01 01:29:13.000000', 'temperatura', 1110.0000, 'ºC'),
	(239256, 122, '2014-03-01 01:29:14.000000', 'temperatura', 784.0000, 'ºC'),
	(239257, 122, '2014-03-01 01:29:15.000000', 'temperatura', 588.0000, 'ºC'),
	(239258, 122, '2014-03-01 01:29:16.000000', 'temperatura', 591.0000, 'ºC'),
	(239259, 122, '2014-03-01 01:29:17.000000', 'temperatura', 1191.0000, 'ºC'),
	(239260, 122, '2014-03-01 01:29:18.000000', 'temperatura', 584.0000, 'ºC'),
	(239261, 122, '2014-03-01 01:29:19.000000', 'temperatura', 547.0000, 'ºC'),
	(239262, 122, '2014-03-01 01:29:20.000000', 'temperatura', 981.0000, 'ºC'),
	(239263, 122, '2014-03-01 01:29:21.000000', 'temperatura', 866.0000, 'ºC'),
	(239264, 122, '2014-03-01 01:29:22.000000', 'temperatura', 187.0000, 'ºC'),
	(239265, 122, '2014-03-01 01:29:23.000000', 'temperatura', 737.0000, 'ºC'),
	(239266, 122, '2014-03-01 01:29:24.000000', 'temperatura', 724.0000, 'ºC'),
	(239267, 122, '2014-03-01 01:29:25.000000', 'temperatura', 209.0000, 'ºC'),
	(239268, 122, '2014-03-01 01:29:26.000000', 'temperatura', 75.0000, 'ºC'),
	(239269, 122, '2014-03-01 01:29:27.000000', 'temperatura', 947.0000, 'ºC'),
	(239270, 122, '2014-03-01 01:29:28.000000', 'temperatura', 912.0000, 'ºC'),
	(239271, 122, '2014-03-01 01:29:29.000000', 'temperatura', 520.0000, 'ºC'),
	(239272, 122, '2014-03-01 01:29:30.000000', 'temperatura', 1063.0000, 'ºC'),
	(239273, 122, '2014-03-01 01:29:31.000000', 'temperatura', 156.0000, 'ºC'),
	(239274, 122, '2014-03-01 01:29:32.000000', 'temperatura', 1193.0000, 'ºC'),
	(239275, 122, '2014-03-01 01:29:33.000000', 'temperatura', 698.0000, 'ºC'),
	(239276, 122, '2014-03-01 01:29:34.000000', 'temperatura', 1112.0000, 'ºC'),
	(239277, 122, '2014-03-01 01:29:35.000000', 'temperatura', 1066.0000, 'ºC'),
	(239278, 122, '2014-03-01 01:29:36.000000', 'temperatura', 796.0000, 'ºC'),
	(239279, 122, '2014-03-01 01:29:37.000000', 'temperatura', 782.0000, 'ºC'),
	(239280, 122, '2014-03-01 01:29:38.000000', 'temperatura', 320.0000, 'ºC'),
	(239281, 122, '2014-03-01 01:29:39.000000', 'temperatura', 457.0000, 'ºC'),
	(239282, 122, '2014-03-01 01:29:40.000000', 'temperatura', 127.0000, 'ºC'),
	(239283, 122, '2014-03-01 01:29:41.000000', 'temperatura', 462.0000, 'ºC'),
	(239284, 122, '2014-03-01 01:29:42.000000', 'temperatura', 728.0000, 'ºC'),
	(239285, 122, '2014-03-01 01:29:43.000000', 'temperatura', 1057.0000, 'ºC'),
	(239286, 122, '2014-03-01 01:29:44.000000', 'temperatura', 701.0000, 'ºC'),
	(239287, 122, '2014-03-01 01:29:45.000000', 'temperatura', 335.0000, 'ºC'),
	(239288, 122, '2014-03-01 01:29:46.000000', 'temperatura', 771.0000, 'ºC'),
	(239289, 122, '2014-03-01 01:29:47.000000', 'temperatura', 450.0000, 'ºC'),
	(239290, 122, '2014-03-01 01:29:48.000000', 'temperatura', 1138.0000, 'ºC'),
	(239291, 122, '2014-03-01 01:29:49.000000', 'temperatura', 743.0000, 'ºC'),
	(239292, 122, '2014-03-01 01:29:50.000000', 'temperatura', 298.0000, 'ºC'),
	(239293, 122, '2014-03-01 01:29:51.000000', 'temperatura', 463.0000, 'ºC'),
	(239294, 122, '2014-03-01 01:29:52.000000', 'temperatura', 223.0000, 'ºC'),
	(239295, 122, '2014-03-01 01:29:53.000000', 'temperatura', 927.0000, 'ºC'),
	(239296, 122, '2014-03-01 01:29:54.000000', 'temperatura', 367.0000, 'ºC'),
	(239297, 122, '2014-03-01 01:29:55.000000', 'temperatura', 254.0000, 'ºC'),
	(239298, 122, '2014-03-01 01:29:56.000000', 'temperatura', 168.0000, 'ºC'),
	(239299, 122, '2014-03-01 01:29:57.000000', 'temperatura', 81.0000, 'ºC'),
	(239300, 122, '2014-03-01 01:29:58.000000', 'temperatura', 1102.0000, 'ºC'),
	(239301, 122, '2014-03-01 01:29:59.000000', 'temperatura', 465.0000, 'ºC'),
	(239302, 122, '2014-03-01 01:30:00.000000', 'temperatura', 219.0000, 'ºC'),
	(239303, 122, '2014-03-01 01:30:01.000000', 'temperatura', 904.0000, 'ºC'),
	(239304, 122, '2014-03-01 01:30:02.000000', 'temperatura', 260.0000, 'ºC'),
	(239305, 122, '2014-03-01 01:30:03.000000', 'temperatura', 990.0000, 'ºC'),
	(239306, 122, '2014-03-01 01:30:04.000000', 'temperatura', 571.0000, 'ºC'),
	(239307, 122, '2014-03-01 01:30:05.000000', 'temperatura', 1084.0000, 'ºC'),
	(239308, 122, '2014-03-01 01:30:06.000000', 'temperatura', 109.0000, 'ºC'),
	(239309, 122, '2014-03-01 01:30:07.000000', 'temperatura', 892.0000, 'ºC'),
	(239310, 122, '2014-03-01 01:30:08.000000', 'temperatura', 535.0000, 'ºC'),
	(239311, 122, '2014-03-01 01:30:09.000000', 'temperatura', 1198.0000, 'ºC'),
	(239312, 122, '2014-03-01 01:30:10.000000', 'temperatura', 785.0000, 'ºC'),
	(239313, 122, '2014-03-01 01:30:11.000000', 'temperatura', 330.0000, 'ºC'),
	(239314, 122, '2014-03-01 01:30:12.000000', 'temperatura', 498.0000, 'ºC'),
	(239315, 122, '2014-03-01 01:30:13.000000', 'temperatura', 302.0000, 'ºC'),
	(239316, 122, '2014-03-01 01:30:14.000000', 'temperatura', 15.0000, 'ºC'),
	(239317, 122, '2014-03-01 01:30:15.000000', 'temperatura', 369.0000, 'ºC'),
	(239318, 122, '2014-03-01 01:30:16.000000', 'temperatura', 601.0000, 'ºC'),
	(239319, 122, '2014-03-01 01:30:17.000000', 'temperatura', 698.0000, 'ºC'),
	(239320, 122, '2014-03-01 01:30:18.000000', 'temperatura', 487.0000, 'ºC'),
	(239321, 122, '2014-03-01 01:30:19.000000', 'temperatura', 340.0000, 'ºC'),
	(239322, 122, '2014-03-01 01:30:20.000000', 'temperatura', 241.0000, 'ºC'),
	(239323, 122, '2014-03-01 01:30:21.000000', 'temperatura', 186.0000, 'ºC'),
	(239324, 122, '2014-03-01 01:30:22.000000', 'temperatura', 207.0000, 'ºC'),
	(239325, 122, '2014-03-01 01:30:23.000000', 'temperatura', 478.0000, 'ºC'),
	(239326, 122, '2014-03-01 01:30:24.000000', 'temperatura', 569.0000, 'ºC'),
	(239327, 122, '2014-03-01 01:30:25.000000', 'temperatura', 212.0000, 'ºC'),
	(239328, 122, '2014-03-01 01:30:26.000000', 'temperatura', 555.0000, 'ºC'),
	(239329, 122, '2014-03-01 01:30:27.000000', 'temperatura', 940.0000, 'ºC'),
	(239330, 122, '2014-03-01 01:30:28.000000', 'temperatura', 634.0000, 'ºC'),
	(239331, 122, '2014-03-01 01:30:29.000000', 'temperatura', 350.0000, 'ºC'),
	(239332, 122, '2014-03-01 01:30:30.000000', 'temperatura', 1048.0000, 'ºC'),
	(239333, 122, '2014-03-01 01:30:31.000000', 'temperatura', 592.0000, 'ºC'),
	(239334, 122, '2014-03-01 01:30:32.000000', 'temperatura', 1018.0000, 'ºC'),
	(239335, 122, '2014-03-01 01:30:33.000000', 'temperatura', 912.0000, 'ºC'),
	(239336, 122, '2014-03-01 01:30:34.000000', 'temperatura', 308.0000, 'ºC'),
	(239337, 122, '2014-03-01 01:30:35.000000', 'temperatura', 5.0000, 'ºC'),
	(239338, 122, '2014-03-01 01:30:36.000000', 'temperatura', 302.0000, 'ºC'),
	(239339, 122, '2014-03-01 01:30:37.000000', 'temperatura', 294.0000, 'ºC'),
	(239340, 122, '2014-03-01 01:30:38.000000', 'temperatura', 566.0000, 'ºC'),
	(239341, 122, '2014-03-01 01:30:39.000000', 'temperatura', 749.0000, 'ºC'),
	(239342, 122, '2014-03-01 01:30:40.000000', 'temperatura', 845.0000, 'ºC'),
	(239343, 122, '2014-03-01 01:30:41.000000', 'temperatura', 779.0000, 'ºC'),
	(239344, 122, '2014-03-01 01:30:42.000000', 'temperatura', 162.0000, 'ºC'),
	(239345, 122, '2014-03-01 01:30:43.000000', 'temperatura', 873.0000, 'ºC'),
	(239346, 122, '2014-03-01 01:30:44.000000', 'temperatura', 278.0000, 'ºC'),
	(239347, 122, '2014-03-01 01:30:45.000000', 'temperatura', 1173.0000, 'ºC'),
	(239348, 122, '2014-03-01 01:30:46.000000', 'temperatura', 233.0000, 'ºC'),
	(239349, 122, '2014-03-01 01:30:47.000000', 'temperatura', 46.0000, 'ºC'),
	(239350, 122, '2014-03-01 01:30:48.000000', 'temperatura', 732.0000, 'ºC'),
	(239351, 122, '2014-03-01 01:30:49.000000', 'temperatura', 1122.0000, 'ºC'),
	(239352, 122, '2014-03-01 01:30:50.000000', 'temperatura', 1013.0000, 'ºC'),
	(239353, 118, '2014-03-15 00:00:00.000000', 'temperatura', 665.0000, 'ºC'),
	(239354, 118, '2014-03-15 00:00:01.000000', 'temperatura', 623.0000, 'ºC'),
	(239355, 118, '2014-03-15 00:00:02.000000', 'temperatura', 1122.0000, 'ºC'),
	(239356, 118, '2014-03-15 00:00:03.000000', 'temperatura', 140.0000, 'ºC'),
	(239357, 118, '2014-03-15 00:00:04.000000', 'temperatura', 934.0000, 'ºC'),
	(239358, 118, '2014-03-15 00:00:05.000000', 'temperatura', 651.0000, 'ºC'),
	(239359, 118, '2014-03-15 00:00:06.000000', 'temperatura', 456.0000, 'ºC'),
	(239360, 118, '2014-03-15 00:00:07.000000', 'temperatura', 324.0000, 'ºC'),
	(239361, 118, '2014-03-15 00:00:08.000000', 'temperatura', 254.0000, 'ºC'),
	(239362, 118, '2014-03-15 00:00:09.000000', 'temperatura', 300.0000, 'ºC'),
	(239363, 118, '2014-03-15 00:00:10.000000', 'temperatura', 737.0000, 'ºC'),
	(239364, 118, '2014-03-15 00:00:11.000000', 'temperatura', 385.0000, 'ºC'),
	(239365, 118, '2014-03-15 00:00:12.000000', 'temperatura', 915.0000, 'ºC'),
	(239366, 118, '2014-03-15 00:00:13.000000', 'temperatura', 1019.0000, 'ºC'),
	(239367, 118, '2014-03-15 00:00:14.000000', 'temperatura', 1151.0000, 'ºC'),
	(239368, 118, '2014-03-15 00:00:15.000000', 'temperatura', 299.0000, 'ºC'),
	(239369, 118, '2014-03-15 00:00:16.000000', 'temperatura', 442.0000, 'ºC'),
	(239370, 118, '2014-03-15 00:00:17.000000', 'temperatura', 112.0000, 'ºC'),
	(239371, 118, '2014-03-15 00:00:18.000000', 'temperatura', 437.0000, 'ºC'),
	(239372, 118, '2014-03-15 00:00:19.000000', 'temperatura', 651.0000, 'ºC'),
	(239373, 118, '2014-03-15 00:00:20.000000', 'temperatura', 741.0000, 'ºC'),
	(239374, 118, '2014-03-15 00:00:21.000000', 'temperatura', 556.0000, 'ºC'),
	(239375, 118, '2014-03-15 00:00:22.000000', 'temperatura', 554.0000, 'ºC'),
	(239376, 118, '2014-03-15 00:00:23.000000', 'temperatura', 1105.0000, 'ºC'),
	(239377, 118, '2014-03-15 00:00:24.000000', 'temperatura', 263.0000, 'ºC'),
	(239378, 118, '2014-03-15 00:00:25.000000', 'temperatura', 400.0000, 'ºC'),
	(239379, 118, '2014-03-15 00:00:26.000000', 'temperatura', 12.0000, 'ºC'),
	(239380, 118, '2014-03-15 00:00:27.000000', 'temperatura', 61.0000, 'ºC'),
	(239381, 118, '2014-03-15 00:00:28.000000', 'temperatura', 271.0000, 'ºC'),
	(239382, 118, '2014-03-15 00:00:29.000000', 'temperatura', 1170.0000, 'ºC'),
	(239383, 118, '2014-03-15 00:00:30.000000', 'temperatura', 237.0000, 'ºC'),
	(239384, 118, '2014-03-15 00:00:31.000000', 'temperatura', 76.0000, 'ºC'),
	(239385, 118, '2014-03-15 00:00:32.000000', 'temperatura', 869.0000, 'ºC'),
	(239386, 118, '2014-03-15 00:00:33.000000', 'temperatura', 518.0000, 'ºC'),
	(239387, 118, '2014-03-15 00:00:34.000000', 'temperatura', 1184.0000, 'ºC'),
	(239388, 118, '2014-03-15 00:00:35.000000', 'temperatura', 764.0000, 'ºC'),
	(239389, 118, '2014-03-15 00:00:36.000000', 'temperatura', 270.0000, 'ºC'),
	(239390, 118, '2014-03-15 00:00:37.000000', 'temperatura', 260.0000, 'ºC'),
	(239391, 118, '2014-03-15 00:00:38.000000', 'temperatura', 489.0000, 'ºC'),
	(239392, 118, '2014-03-15 00:00:39.000000', 'temperatura', 465.0000, 'ºC'),
	(239393, 118, '2014-03-15 00:00:40.000000', 'temperatura', 859.0000, 'ºC'),
	(239394, 118, '2014-03-15 00:00:41.000000', 'temperatura', 502.0000, 'ºC'),
	(239395, 118, '2014-03-15 00:00:42.000000', 'temperatura', 1133.0000, 'ºC'),
	(239396, 118, '2014-03-15 00:00:43.000000', 'temperatura', 559.0000, 'ºC'),
	(239397, 118, '2014-03-15 00:00:44.000000', 'temperatura', 597.0000, 'ºC'),
	(239398, 118, '2014-03-15 00:00:45.000000', 'temperatura', 107.0000, 'ºC'),
	(239399, 118, '2014-03-15 00:00:46.000000', 'temperatura', 1145.0000, 'ºC'),
	(239400, 118, '2014-03-15 00:00:47.000000', 'temperatura', 606.0000, 'ºC'),
	(239401, 118, '2014-03-15 00:00:48.000000', 'temperatura', 794.0000, 'ºC'),
	(239402, 118, '2014-03-15 00:00:49.000000', 'temperatura', 952.0000, 'ºC'),
	(239403, 118, '2014-03-15 00:00:50.000000', 'temperatura', 1178.0000, 'ºC'),
	(239404, 118, '2014-03-15 00:00:51.000000', 'temperatura', 634.0000, 'ºC'),
	(239405, 118, '2014-03-15 00:00:52.000000', 'temperatura', 838.0000, 'ºC'),
	(239406, 118, '2014-03-15 00:00:53.000000', 'temperatura', 1088.0000, 'ºC'),
	(239407, 118, '2014-03-15 00:00:54.000000', 'temperatura', 527.0000, 'ºC'),
	(239408, 118, '2014-03-15 00:00:55.000000', 'temperatura', 570.0000, 'ºC'),
	(239409, 118, '2014-03-15 00:00:56.000000', 'temperatura', 72.0000, 'ºC'),
	(239410, 118, '2014-03-15 00:00:57.000000', 'temperatura', 1051.0000, 'ºC'),
	(239411, 118, '2014-03-15 00:00:58.000000', 'temperatura', 237.0000, 'ºC'),
	(239412, 118, '2014-03-15 00:00:59.000000', 'temperatura', 433.0000, 'ºC'),
	(239413, 118, '2014-03-15 00:01:00.000000', 'temperatura', 253.0000, 'ºC'),
	(239414, 118, '2014-03-15 00:01:01.000000', 'temperatura', 1170.0000, 'ºC'),
	(239415, 118, '2014-03-15 00:01:02.000000', 'temperatura', 288.0000, 'ºC'),
	(239416, 118, '2014-03-15 00:01:03.000000', 'temperatura', 334.0000, 'ºC'),
	(239417, 118, '2014-03-15 00:01:04.000000', 'temperatura', 803.0000, 'ºC'),
	(239418, 118, '2014-03-15 00:01:05.000000', 'temperatura', 616.0000, 'ºC'),
	(239419, 118, '2014-03-15 00:01:06.000000', 'temperatura', 669.0000, 'ºC'),
	(239420, 118, '2014-03-15 00:01:07.000000', 'temperatura', 300.0000, 'ºC'),
	(239421, 118, '2014-03-15 00:01:08.000000', 'temperatura', 695.0000, 'ºC'),
	(239422, 118, '2014-03-15 00:01:09.000000', 'temperatura', 172.0000, 'ºC'),
	(239423, 118, '2014-03-15 00:01:10.000000', 'temperatura', 1177.0000, 'ºC'),
	(239424, 118, '2014-03-15 00:01:11.000000', 'temperatura', 569.0000, 'ºC'),
	(239425, 118, '2014-03-15 00:01:12.000000', 'temperatura', 513.0000, 'ºC'),
	(239426, 118, '2014-03-15 00:01:13.000000', 'temperatura', 858.0000, 'ºC'),
	(239427, 118, '2014-03-15 00:01:14.000000', 'temperatura', 353.0000, 'ºC'),
	(239428, 118, '2014-03-15 00:01:15.000000', 'temperatura', 391.0000, 'ºC'),
	(239429, 118, '2014-03-15 00:01:16.000000', 'temperatura', 899.0000, 'ºC'),
	(239430, 118, '2014-03-15 00:01:17.000000', 'temperatura', 919.0000, 'ºC'),
	(239431, 118, '2014-03-15 00:01:18.000000', 'temperatura', 700.0000, 'ºC'),
	(239432, 118, '2014-03-15 00:01:19.000000', 'temperatura', 745.0000, 'ºC'),
	(239433, 118, '2014-03-15 00:01:20.000000', 'temperatura', 425.0000, 'ºC'),
	(239434, 118, '2014-03-15 00:01:21.000000', 'temperatura', 1091.0000, 'ºC'),
	(239435, 118, '2014-03-15 00:01:22.000000', 'temperatura', 579.0000, 'ºC'),
	(239436, 118, '2014-03-15 00:01:23.000000', 'temperatura', 821.0000, 'ºC'),
	(239437, 118, '2014-03-15 00:01:24.000000', 'temperatura', 1171.0000, 'ºC'),
	(239438, 118, '2014-03-15 00:01:25.000000', 'temperatura', 990.0000, 'ºC'),
	(239439, 118, '2014-03-15 00:01:26.000000', 'temperatura', 240.0000, 'ºC'),
	(239440, 118, '2014-03-15 00:01:27.000000', 'temperatura', 628.0000, 'ºC'),
	(239441, 118, '2014-03-15 00:01:28.000000', 'temperatura', 22.0000, 'ºC'),
	(239442, 118, '2014-03-15 00:01:29.000000', 'temperatura', 624.0000, 'ºC'),
	(239443, 118, '2014-03-15 00:01:30.000000', 'temperatura', 658.0000, 'ºC'),
	(239444, 118, '2014-03-15 00:01:31.000000', 'temperatura', 217.0000, 'ºC'),
	(239445, 118, '2014-03-15 00:01:32.000000', 'temperatura', 311.0000, 'ºC'),
	(239446, 118, '2014-03-15 00:01:33.000000', 'temperatura', 904.0000, 'ºC'),
	(239447, 118, '2014-03-15 00:01:34.000000', 'temperatura', 1190.0000, 'ºC'),
	(239448, 118, '2014-03-15 00:01:35.000000', 'temperatura', 837.0000, 'ºC'),
	(239449, 118, '2014-03-15 00:01:36.000000', 'temperatura', 617.0000, 'ºC'),
	(239450, 118, '2014-03-15 00:01:37.000000', 'temperatura', 574.0000, 'ºC'),
	(239451, 118, '2014-03-15 00:01:38.000000', 'temperatura', 1020.0000, 'ºC'),
	(239452, 118, '2014-03-15 00:01:39.000000', 'temperatura', 978.0000, 'ºC'),
	(239453, 118, '2014-03-15 00:01:40.000000', 'temperatura', 628.0000, 'ºC'),
	(239454, 118, '2014-03-15 00:01:41.000000', 'temperatura', 210.0000, 'ºC'),
	(239455, 118, '2014-03-15 00:01:42.000000', 'temperatura', 365.0000, 'ºC'),
	(239456, 118, '2014-03-15 00:01:43.000000', 'temperatura', 1195.0000, 'ºC'),
	(239457, 118, '2014-03-15 00:01:44.000000', 'temperatura', 82.0000, 'ºC'),
	(239458, 118, '2014-03-15 00:01:45.000000', 'temperatura', 426.0000, 'ºC'),
	(239459, 118, '2014-03-15 00:01:46.000000', 'temperatura', 685.0000, 'ºC'),
	(239460, 118, '2014-03-15 00:01:47.000000', 'temperatura', 947.0000, 'ºC'),
	(239461, 118, '2014-03-15 00:01:48.000000', 'temperatura', 279.0000, 'ºC'),
	(239462, 118, '2014-03-15 00:01:49.000000', 'temperatura', 956.0000, 'ºC'),
	(239463, 118, '2014-03-15 00:01:50.000000', 'temperatura', 343.0000, 'ºC'),
	(239464, 118, '2014-03-15 00:01:51.000000', 'temperatura', 48.0000, 'ºC'),
	(239465, 118, '2014-03-15 00:01:52.000000', 'temperatura', 413.0000, 'ºC'),
	(239466, 118, '2014-03-15 00:01:53.000000', 'temperatura', 721.0000, 'ºC'),
	(239467, 118, '2014-03-15 00:01:54.000000', 'temperatura', 1168.0000, 'ºC'),
	(239468, 118, '2014-03-15 00:01:55.000000', 'temperatura', 76.0000, 'ºC'),
	(239469, 118, '2014-03-15 00:01:56.000000', 'temperatura', 479.0000, 'ºC'),
	(239470, 118, '2014-03-15 00:01:57.000000', 'temperatura', 964.0000, 'ºC'),
	(239471, 118, '2014-03-15 00:01:58.000000', 'temperatura', 987.0000, 'ºC'),
	(239472, 118, '2014-03-15 00:01:59.000000', 'temperatura', 841.0000, 'ºC'),
	(239473, 118, '2014-03-15 00:02:00.000000', 'temperatura', 43.0000, 'ºC'),
	(239474, 118, '2014-03-15 00:02:01.000000', 'temperatura', 95.0000, 'ºC'),
	(239475, 118, '2014-03-15 00:02:02.000000', 'temperatura', 345.0000, 'ºC'),
	(239476, 118, '2014-03-15 00:02:03.000000', 'temperatura', 239.0000, 'ºC'),
	(239477, 118, '2014-03-15 00:02:04.000000', 'temperatura', 163.0000, 'ºC'),
	(239478, 118, '2014-03-15 00:02:05.000000', 'temperatura', 97.0000, 'ºC'),
	(239479, 118, '2014-03-15 00:02:06.000000', 'temperatura', 1196.0000, 'ºC'),
	(239480, 118, '2014-03-15 00:02:07.000000', 'temperatura', 889.0000, 'ºC'),
	(239481, 118, '2014-03-15 00:02:08.000000', 'temperatura', 857.0000, 'ºC'),
	(239482, 118, '2014-03-15 00:02:09.000000', 'temperatura', 419.0000, 'ºC'),
	(239483, 118, '2014-03-15 00:02:10.000000', 'temperatura', 725.0000, 'ºC'),
	(239484, 118, '2014-03-15 00:02:11.000000', 'temperatura', 1170.0000, 'ºC'),
	(239485, 118, '2014-03-15 00:02:12.000000', 'temperatura', 73.0000, 'ºC'),
	(239486, 118, '2014-03-15 00:02:13.000000', 'temperatura', 456.0000, 'ºC'),
	(239487, 118, '2014-03-15 00:02:14.000000', 'temperatura', 860.0000, 'ºC'),
	(239488, 118, '2014-03-15 00:02:15.000000', 'temperatura', 536.0000, 'ºC'),
	(239489, 118, '2014-03-15 00:02:16.000000', 'temperatura', 98.0000, 'ºC'),
	(239490, 118, '2014-03-15 00:02:17.000000', 'temperatura', 81.0000, 'ºC'),
	(239491, 118, '2014-03-15 00:02:18.000000', 'temperatura', 114.0000, 'ºC'),
	(239492, 118, '2014-03-15 00:02:19.000000', 'temperatura', 329.0000, 'ºC'),
	(239493, 118, '2014-03-15 00:02:20.000000', 'temperatura', 101.0000, 'ºC'),
	(239494, 118, '2014-03-15 00:02:21.000000', 'temperatura', 721.0000, 'ºC'),
	(239495, 118, '2014-03-15 00:02:22.000000', 'temperatura', 901.0000, 'ºC'),
	(239496, 118, '2014-03-15 00:02:23.000000', 'temperatura', 1145.0000, 'ºC'),
	(239497, 118, '2014-03-15 00:02:24.000000', 'temperatura', 619.0000, 'ºC'),
	(239498, 118, '2014-03-15 00:02:25.000000', 'temperatura', 862.0000, 'ºC'),
	(239499, 118, '2014-03-15 00:02:26.000000', 'temperatura', 55.0000, 'ºC'),
	(239500, 118, '2014-03-15 00:02:27.000000', 'temperatura', 89.0000, 'ºC'),
	(239501, 118, '2014-03-15 00:02:28.000000', 'temperatura', 282.0000, 'ºC'),
	(239502, 118, '2014-03-15 00:02:29.000000', 'temperatura', 1143.0000, 'ºC'),
	(239503, 118, '2014-03-15 00:02:30.000000', 'temperatura', 68.0000, 'ºC'),
	(239504, 118, '2014-03-15 00:02:31.000000', 'temperatura', 510.0000, 'ºC'),
	(239505, 118, '2014-03-15 00:02:32.000000', 'temperatura', 1149.0000, 'ºC'),
	(239506, 118, '2014-03-15 00:02:33.000000', 'temperatura', 613.0000, 'ºC'),
	(239507, 118, '2014-03-15 00:02:34.000000', 'temperatura', 818.0000, 'ºC'),
	(239508, 118, '2014-03-15 00:02:35.000000', 'temperatura', 1054.0000, 'ºC'),
	(239509, 118, '2014-03-15 00:02:36.000000', 'temperatura', 415.0000, 'ºC'),
	(239510, 118, '2014-03-15 00:02:37.000000', 'temperatura', 113.0000, 'ºC'),
	(239511, 118, '2014-03-15 00:02:38.000000', 'temperatura', 523.0000, 'ºC'),
	(239512, 118, '2014-03-15 00:02:39.000000', 'temperatura', 1074.0000, 'ºC'),
	(239513, 118, '2014-03-15 00:02:40.000000', 'temperatura', 202.0000, 'ºC'),
	(239514, 118, '2014-03-15 00:02:41.000000', 'temperatura', 188.0000, 'ºC'),
	(239515, 118, '2014-03-15 00:02:42.000000', 'temperatura', 334.0000, 'ºC'),
	(239516, 118, '2014-03-15 00:02:43.000000', 'temperatura', 1109.0000, 'ºC'),
	(239517, 118, '2014-03-15 00:02:44.000000', 'temperatura', 944.0000, 'ºC'),
	(239518, 118, '2014-03-15 00:02:45.000000', 'temperatura', 191.0000, 'ºC'),
	(239519, 118, '2014-03-15 00:02:46.000000', 'temperatura', 526.0000, 'ºC'),
	(239520, 118, '2014-03-15 00:02:47.000000', 'temperatura', 856.0000, 'ºC'),
	(239521, 118, '2014-03-15 00:02:48.000000', 'temperatura', 301.0000, 'ºC'),
	(239522, 118, '2014-03-15 00:02:49.000000', 'temperatura', 139.0000, 'ºC'),
	(239523, 118, '2014-03-15 00:02:50.000000', 'temperatura', 991.0000, 'ºC'),
	(239524, 118, '2014-03-15 00:02:51.000000', 'temperatura', 940.0000, 'ºC'),
	(239525, 118, '2014-03-15 00:02:52.000000', 'temperatura', 526.0000, 'ºC'),
	(239526, 118, '2014-03-15 00:02:53.000000', 'temperatura', 1013.0000, 'ºC'),
	(239527, 118, '2014-03-15 00:02:54.000000', 'temperatura', 1086.0000, 'ºC'),
	(239528, 118, '2014-03-15 00:02:55.000000', 'temperatura', 1191.0000, 'ºC'),
	(239529, 118, '2014-03-15 00:02:56.000000', 'temperatura', 296.0000, 'ºC'),
	(239530, 118, '2014-03-15 00:02:57.000000', 'temperatura', 311.0000, 'ºC'),
	(239531, 118, '2014-03-15 00:02:58.000000', 'temperatura', 665.0000, 'ºC'),
	(239532, 118, '2014-03-15 00:02:59.000000', 'temperatura', 1193.0000, 'ºC'),
	(239533, 118, '2014-03-15 00:03:00.000000', 'temperatura', 370.0000, 'ºC'),
	(239534, 118, '2014-03-15 00:03:01.000000', 'temperatura', 670.0000, 'ºC'),
	(239535, 118, '2014-03-15 00:03:02.000000', 'temperatura', 1042.0000, 'ºC'),
	(239536, 118, '2014-03-15 00:03:03.000000', 'temperatura', 799.0000, 'ºC'),
	(239537, 118, '2014-03-15 00:03:04.000000', 'temperatura', 870.0000, 'ºC'),
	(239538, 118, '2014-03-15 00:03:05.000000', 'temperatura', 754.0000, 'ºC'),
	(239539, 118, '2014-03-15 00:03:06.000000', 'temperatura', 1162.0000, 'ºC'),
	(239540, 118, '2014-03-15 00:03:07.000000', 'temperatura', 1145.0000, 'ºC'),
	(239541, 118, '2014-03-15 00:03:08.000000', 'temperatura', 1043.0000, 'ºC'),
	(239542, 118, '2014-03-15 00:03:09.000000', 'temperatura', 578.0000, 'ºC'),
	(239543, 118, '2014-03-15 00:03:10.000000', 'temperatura', 962.0000, 'ºC'),
	(239544, 118, '2014-03-15 00:03:11.000000', 'temperatura', 678.0000, 'ºC'),
	(239545, 118, '2014-03-15 00:03:12.000000', 'temperatura', 505.0000, 'ºC'),
	(239546, 118, '2014-03-15 00:03:13.000000', 'temperatura', 493.0000, 'ºC'),
	(239547, 118, '2014-03-15 00:03:14.000000', 'temperatura', 947.0000, 'ºC'),
	(239548, 118, '2014-03-15 00:03:15.000000', 'temperatura', 857.0000, 'ºC'),
	(239549, 118, '2014-03-15 00:03:16.000000', 'temperatura', 243.0000, 'ºC'),
	(239550, 118, '2014-03-15 00:03:17.000000', 'temperatura', 1048.0000, 'ºC'),
	(239551, 118, '2014-03-15 00:03:18.000000', 'temperatura', 909.0000, 'ºC'),
	(239552, 118, '2014-03-15 00:03:19.000000', 'temperatura', 203.0000, 'ºC'),
	(239553, 118, '2014-03-15 00:03:20.000000', 'temperatura', 687.0000, 'ºC'),
	(239554, 118, '2014-03-15 00:03:21.000000', 'temperatura', 429.0000, 'ºC'),
	(239555, 118, '2014-03-15 00:03:22.000000', 'temperatura', 83.0000, 'ºC'),
	(239556, 118, '2014-03-15 00:03:23.000000', 'temperatura', 328.0000, 'ºC'),
	(239557, 118, '2014-03-15 00:03:24.000000', 'temperatura', 194.0000, 'ºC'),
	(239558, 118, '2014-03-15 00:03:25.000000', 'temperatura', 1184.0000, 'ºC'),
	(239559, 118, '2014-03-15 00:03:26.000000', 'temperatura', 540.0000, 'ºC'),
	(239560, 118, '2014-03-15 00:03:27.000000', 'temperatura', 349.0000, 'ºC'),
	(239561, 118, '2014-03-15 00:03:28.000000', 'temperatura', 123.0000, 'ºC'),
	(239562, 118, '2014-03-15 00:03:29.000000', 'temperatura', 769.0000, 'ºC'),
	(239563, 118, '2014-03-15 00:03:30.000000', 'temperatura', 1078.0000, 'ºC'),
	(239564, 118, '2014-03-15 00:03:31.000000', 'temperatura', 684.0000, 'ºC'),
	(239565, 118, '2014-03-15 00:03:32.000000', 'temperatura', 185.0000, 'ºC'),
	(239566, 118, '2014-03-15 00:03:33.000000', 'temperatura', 73.0000, 'ºC'),
	(239567, 118, '2014-03-15 00:03:34.000000', 'temperatura', 1011.0000, 'ºC'),
	(239568, 118, '2014-03-15 00:03:35.000000', 'temperatura', 38.0000, 'ºC'),
	(239569, 118, '2014-03-15 00:03:36.000000', 'temperatura', 758.0000, 'ºC'),
	(239570, 118, '2014-03-15 00:03:37.000000', 'temperatura', 78.0000, 'ºC'),
	(239571, 118, '2014-03-15 00:03:38.000000', 'temperatura', 513.0000, 'ºC'),
	(239572, 118, '2014-03-15 00:03:39.000000', 'temperatura', 1133.0000, 'ºC'),
	(239573, 118, '2014-03-15 00:03:40.000000', 'temperatura', 526.0000, 'ºC'),
	(239574, 118, '2014-03-15 00:03:41.000000', 'temperatura', 431.0000, 'ºC'),
	(239575, 118, '2014-03-15 00:03:42.000000', 'temperatura', 578.0000, 'ºC'),
	(239576, 118, '2014-03-15 00:03:43.000000', 'temperatura', 397.0000, 'ºC'),
	(239577, 118, '2014-03-15 00:03:44.000000', 'temperatura', 254.0000, 'ºC'),
	(239578, 118, '2014-03-15 00:03:45.000000', 'temperatura', 77.0000, 'ºC'),
	(239579, 118, '2014-03-15 00:03:46.000000', 'temperatura', 826.0000, 'ºC'),
	(239580, 118, '2014-03-15 00:03:47.000000', 'temperatura', 299.0000, 'ºC'),
	(239581, 118, '2014-03-15 00:03:48.000000', 'temperatura', 217.0000, 'ºC'),
	(239582, 118, '2014-03-15 00:03:49.000000', 'temperatura', 191.0000, 'ºC'),
	(239583, 118, '2014-03-15 00:03:50.000000', 'temperatura', 301.0000, 'ºC'),
	(239584, 118, '2014-03-15 00:03:51.000000', 'temperatura', 934.0000, 'ºC'),
	(239585, 118, '2014-03-15 00:03:52.000000', 'temperatura', 168.0000, 'ºC'),
	(239586, 118, '2014-03-15 00:03:53.000000', 'temperatura', 440.0000, 'ºC'),
	(239587, 118, '2014-03-15 00:03:54.000000', 'temperatura', 496.0000, 'ºC'),
	(239588, 118, '2014-03-15 00:03:55.000000', 'temperatura', 1158.0000, 'ºC'),
	(239589, 118, '2014-03-15 00:03:56.000000', 'temperatura', 704.0000, 'ºC'),
	(239590, 118, '2014-03-15 00:03:57.000000', 'temperatura', 48.0000, 'ºC'),
	(239591, 118, '2014-03-15 00:03:58.000000', 'temperatura', 529.0000, 'ºC'),
	(239592, 118, '2014-03-15 00:03:59.000000', 'temperatura', 101.0000, 'ºC'),
	(239593, 118, '2014-03-15 00:04:00.000000', 'temperatura', 119.0000, 'ºC'),
	(239594, 118, '2014-03-15 00:04:01.000000', 'temperatura', 290.0000, 'ºC'),
	(239595, 118, '2014-03-15 00:04:02.000000', 'temperatura', 1095.0000, 'ºC'),
	(239596, 118, '2014-03-15 00:04:03.000000', 'temperatura', 1007.0000, 'ºC'),
	(239597, 118, '2014-03-15 00:04:04.000000', 'temperatura', 549.0000, 'ºC'),
	(239598, 118, '2014-03-15 00:04:05.000000', 'temperatura', 924.0000, 'ºC'),
	(239599, 118, '2014-03-15 00:04:06.000000', 'temperatura', 575.0000, 'ºC'),
	(239600, 118, '2014-03-15 00:04:07.000000', 'temperatura', 103.0000, 'ºC'),
	(239601, 118, '2014-03-15 00:04:08.000000', 'temperatura', 1189.0000, 'ºC'),
	(239602, 118, '2014-03-15 00:04:09.000000', 'temperatura', 837.0000, 'ºC'),
	(239603, 118, '2014-03-15 00:04:10.000000', 'temperatura', 617.0000, 'ºC'),
	(239604, 118, '2014-03-15 00:04:11.000000', 'temperatura', 576.0000, 'ºC'),
	(239605, 118, '2014-03-15 00:04:12.000000', 'temperatura', 1028.0000, 'ºC'),
	(239606, 118, '2014-03-15 00:04:13.000000', 'temperatura', 1014.0000, 'ºC'),
	(239607, 118, '2014-03-15 00:04:14.000000', 'temperatura', 786.0000, 'ºC'),
	(239608, 118, '2014-03-15 00:04:15.000000', 'temperatura', 888.0000, 'ºC'),
	(239609, 118, '2014-03-15 00:04:16.000000', 'temperatura', 883.0000, 'ºC'),
	(239610, 118, '2014-03-15 00:04:17.000000', 'temperatura', 552.0000, 'ºC'),
	(239611, 118, '2014-03-15 00:04:18.000000', 'temperatura', 110.0000, 'ºC'),
	(239612, 118, '2014-03-15 00:04:19.000000', 'temperatura', 97.0000, 'ºC'),
	(239613, 118, '2014-03-15 00:04:20.000000', 'temperatura', 154.0000, 'ºC'),
	(239614, 118, '2014-03-15 00:04:21.000000', 'temperatura', 479.0000, 'ºC'),
	(239615, 118, '2014-03-15 00:04:22.000000', 'temperatura', 735.0000, 'ºC'),
	(239616, 118, '2014-03-15 00:04:23.000000', 'temperatura', 1036.0000, 'ºC'),
	(239617, 118, '2014-03-15 00:04:24.000000', 'temperatura', 577.0000, 'ºC'),
	(239618, 118, '2014-03-15 00:04:25.000000', 'temperatura', 975.0000, 'ºC'),
	(239619, 118, '2014-03-15 00:04:26.000000', 'temperatura', 747.0000, 'ºC'),
	(239620, 118, '2014-03-15 00:04:27.000000', 'temperatura', 810.0000, 'ºC'),
	(239621, 118, '2014-03-15 00:04:28.000000', 'temperatura', 607.0000, 'ºC'),
	(239622, 118, '2014-03-15 00:04:29.000000', 'temperatura', 609.0000, 'ºC'),
	(239623, 118, '2014-03-15 00:04:30.000000', 'temperatura', 22.0000, 'ºC'),
	(239624, 118, '2014-03-15 00:04:31.000000', 'temperatura', 686.0000, 'ºC'),
	(239625, 118, '2014-03-15 00:04:32.000000', 'temperatura', 963.0000, 'ºC'),
	(239626, 118, '2014-03-15 00:04:33.000000', 'temperatura', 359.0000, 'ºC'),
	(239627, 118, '2014-03-15 00:04:34.000000', 'temperatura', 104.0000, 'ºC'),
	(239628, 118, '2014-03-15 00:04:35.000000', 'temperatura', 644.0000, 'ºC'),
	(239629, 118, '2014-03-15 00:04:36.000000', 'temperatura', 507.0000, 'ºC'),
	(239630, 118, '2014-03-15 00:04:37.000000', 'temperatura', 606.0000, 'ºC'),
	(239631, 118, '2014-03-15 00:04:38.000000', 'temperatura', 310.0000, 'ºC'),
	(239632, 118, '2014-03-15 00:04:39.000000', 'temperatura', 930.0000, 'ºC'),
	(239633, 118, '2014-03-15 00:04:40.000000', 'temperatura', 121.0000, 'ºC'),
	(239634, 118, '2014-03-15 00:04:41.000000', 'temperatura', 214.0000, 'ºC'),
	(239635, 118, '2014-03-15 00:04:42.000000', 'temperatura', 709.0000, 'ºC'),
	(239636, 118, '2014-03-15 00:04:43.000000', 'temperatura', 504.0000, 'ºC'),
	(239637, 118, '2014-03-15 00:04:44.000000', 'temperatura', 391.0000, 'ºC'),
	(239638, 118, '2014-03-15 00:04:45.000000', 'temperatura', 447.0000, 'ºC'),
	(239639, 118, '2014-03-15 00:04:46.000000', 'temperatura', 1060.0000, 'ºC'),
	(239640, 118, '2014-03-15 00:04:47.000000', 'temperatura', 360.0000, 'ºC'),
	(239641, 118, '2014-03-15 00:04:48.000000', 'temperatura', 1020.0000, 'ºC'),
	(239642, 118, '2014-03-15 00:04:49.000000', 'temperatura', 421.0000, 'ºC'),
	(239643, 118, '2014-03-15 00:04:50.000000', 'temperatura', 245.0000, 'ºC'),
	(239644, 118, '2014-03-15 00:04:51.000000', 'temperatura', 1164.0000, 'ºC'),
	(239645, 118, '2014-03-15 00:04:52.000000', 'temperatura', 284.0000, 'ºC'),
	(239646, 118, '2014-03-15 00:04:53.000000', 'temperatura', 331.0000, 'ºC'),
	(239647, 118, '2014-03-15 00:04:54.000000', 'temperatura', 800.0000, 'ºC'),
	(239648, 118, '2014-03-15 00:04:55.000000', 'temperatura', 611.0000, 'ºC'),
	(239649, 118, '2014-03-15 00:04:56.000000', 'temperatura', 652.0000, 'ºC'),
	(239650, 118, '2014-03-15 00:04:57.000000', 'temperatura', 231.0000, 'ºC'),
	(239651, 118, '2014-03-15 00:04:58.000000', 'temperatura', 397.0000, 'ºC'),
	(239652, 118, '2014-03-15 00:04:59.000000', 'temperatura', 94.0000, 'ºC'),
	(239653, 118, '2014-03-15 00:05:00.000000', 'temperatura', 480.0000, 'ºC'),
	(239654, 118, '2014-03-15 00:05:01.000000', 'temperatura', 917.0000, 'ºC'),
	(239655, 118, '2014-03-15 00:05:02.000000', 'temperatura', 748.0000, 'ºC'),
	(239656, 118, '2014-03-15 00:05:03.000000', 'temperatura', 989.0000, 'ºC'),
	(239657, 118, '2014-03-15 00:05:04.000000', 'temperatura', 300.0000, 'ºC'),
	(239658, 118, '2014-03-15 00:05:05.000000', 'temperatura', 933.0000, 'ºC'),
	(239659, 118, '2014-03-15 00:05:06.000000', 'temperatura', 165.0000, 'ºC'),
	(239660, 118, '2014-03-15 00:05:07.000000', 'temperatura', 426.0000, 'ºC'),
	(239661, 118, '2014-03-15 00:05:08.000000', 'temperatura', 437.0000, 'ºC'),
	(239662, 118, '2014-03-15 00:05:09.000000', 'temperatura', 907.0000, 'ºC'),
	(239663, 118, '2014-03-15 00:05:10.000000', 'temperatura', 827.0000, 'ºC'),
	(239664, 118, '2014-03-15 00:05:11.000000', 'temperatura', 211.0000, 'ºC'),
	(239665, 118, '2014-03-15 00:05:12.000000', 'temperatura', 976.0000, 'ºC'),
	(239666, 118, '2014-03-15 00:05:13.000000', 'temperatura', 647.0000, 'ºC'),
	(239667, 118, '2014-03-15 00:05:14.000000', 'temperatura', 308.0000, 'ºC'),
	(239668, 118, '2014-03-15 00:05:15.000000', 'temperatura', 799.0000, 'ºC'),
	(239669, 118, '2014-03-15 00:05:16.000000', 'temperatura', 671.0000, 'ºC'),
	(239670, 118, '2014-03-15 00:05:17.000000', 'temperatura', 958.0000, 'ºC'),
	(239671, 118, '2014-03-15 00:05:18.000000', 'temperatura', 379.0000, 'ºC'),
	(239672, 118, '2014-03-15 00:05:19.000000', 'temperatura', 219.0000, 'ºC'),
	(239673, 118, '2014-03-15 00:05:20.000000', 'temperatura', 1160.0000, 'ºC'),
	(239674, 118, '2014-03-15 00:05:21.000000', 'temperatura', 345.0000, 'ºC'),
	(239675, 118, '2014-03-15 00:05:22.000000', 'temperatura', 646.0000, 'ºC'),
	(239676, 118, '2014-03-15 00:05:23.000000', 'temperatura', 993.0000, 'ºC'),
	(239677, 118, '2014-03-15 00:05:24.000000', 'temperatura', 628.0000, 'ºC'),
	(239678, 118, '2014-03-15 00:05:25.000000', 'temperatura', 160.0000, 'ºC'),
	(239679, 118, '2014-03-15 00:05:26.000000', 'temperatura', 118.0000, 'ºC'),
	(239680, 118, '2014-03-15 00:05:27.000000', 'temperatura', 110.0000, 'ºC'),
	(239681, 118, '2014-03-15 00:05:28.000000', 'temperatura', 195.0000, 'ºC'),
	(239682, 118, '2014-03-15 00:05:29.000000', 'temperatura', 646.0000, 'ºC'),
	(239683, 118, '2014-03-15 00:05:30.000000', 'temperatura', 244.0000, 'ºC'),
	(239684, 118, '2014-03-15 00:05:31.000000', 'temperatura', 485.0000, 'ºC'),
	(239685, 118, '2014-03-15 00:05:32.000000', 'temperatura', 493.0000, 'ºC'),
	(239686, 118, '2014-03-15 00:05:33.000000', 'temperatura', 1010.0000, 'ºC'),
	(239687, 118, '2014-03-15 00:05:34.000000', 'temperatura', 1170.0000, 'ºC'),
	(239688, 118, '2014-03-15 00:05:35.000000', 'temperatura', 423.0000, 'ºC'),
	(239689, 118, '2014-03-15 00:05:36.000000', 'temperatura', 1003.0000, 'ºC'),
	(239690, 118, '2014-03-15 00:05:37.000000', 'temperatura', 148.0000, 'ºC'),
	(239691, 118, '2014-03-15 00:05:38.000000', 'temperatura', 129.0000, 'ºC'),
	(239692, 118, '2014-03-15 00:05:39.000000', 'temperatura', 204.0000, 'ºC'),
	(239693, 118, '2014-03-15 00:05:40.000000', 'temperatura', 631.0000, 'ºC'),
	(239694, 118, '2014-03-15 00:05:41.000000', 'temperatura', 146.0000, 'ºC'),
	(239695, 118, '2014-03-15 00:05:42.000000', 'temperatura', 35.0000, 'ºC'),
	(239696, 118, '2014-03-15 00:05:43.000000', 'temperatura', 937.0000, 'ºC'),
	(239697, 118, '2014-03-15 00:05:44.000000', 'temperatura', 982.0000, 'ºC'),
	(239698, 118, '2014-03-15 00:05:45.000000', 'temperatura', 898.0000, 'ºC'),
	(239699, 118, '2014-03-15 00:05:46.000000', 'temperatura', 347.0000, 'ºC'),
	(239700, 118, '2014-03-15 00:05:47.000000', 'temperatura', 241.0000, 'ºC'),
	(239701, 118, '2014-03-15 00:05:48.000000', 'temperatura', 163.0000, 'ºC'),
	(239702, 118, '2014-03-15 00:05:49.000000', 'temperatura', 92.0000, 'ºC'),
	(239703, 118, '2014-03-15 00:05:50.000000', 'temperatura', 1173.0000, 'ºC'),
	(239704, 118, '2014-03-15 00:05:51.000000', 'temperatura', 788.0000, 'ºC'),
	(239705, 118, '2014-03-15 00:05:52.000000', 'temperatura', 421.0000, 'ºC'),
	(239706, 118, '2014-03-15 00:05:53.000000', 'temperatura', 942.0000, 'ºC'),
	(239707, 118, '2014-03-15 00:05:54.000000', 'temperatura', 1046.0000, 'ºC'),
	(239708, 118, '2014-03-15 00:05:55.000000', 'temperatura', 6.0000, 'ºC'),
	(239709, 118, '2014-03-15 00:05:56.000000', 'temperatura', 491.0000, 'ºC'),
	(239710, 118, '2014-03-15 00:05:57.000000', 'temperatura', 40.0000, 'ºC'),
	(239711, 118, '2014-03-15 00:05:58.000000', 'temperatura', 1126.0000, 'ºC'),
	(239712, 118, '2014-03-15 00:05:59.000000', 'temperatura', 712.0000, 'ºC'),
	(239713, 118, '2014-03-15 00:06:00.000000', 'temperatura', 180.0000, 'ºC'),
	(239714, 118, '2014-03-15 00:06:01.000000', 'temperatura', 1165.0000, 'ºC'),
	(239715, 118, '2014-03-15 00:06:02.000000', 'temperatura', 486.0000, 'ºC'),
	(239716, 118, '2014-03-15 00:06:03.000000', 'temperatura', 137.0000, 'ºC'),
	(239717, 118, '2014-03-15 00:06:04.000000', 'temperatura', 427.0000, 'ºC'),
	(239718, 118, '2014-03-15 00:06:05.000000', 'temperatura', 524.0000, 'ºC'),
	(239719, 118, '2014-03-15 00:06:06.000000', 'temperatura', 139.0000, 'ºC'),
	(239720, 118, '2014-03-15 00:06:07.000000', 'temperatura', 322.0000, 'ºC'),
	(239721, 118, '2014-03-15 00:06:08.000000', 'temperatura', 1197.0000, 'ºC'),
	(239722, 118, '2014-03-15 00:06:09.000000', 'temperatura', 216.0000, 'ºC'),
	(239723, 118, '2014-03-15 00:06:10.000000', 'temperatura', 1093.0000, 'ºC'),
	(239724, 118, '2014-03-15 00:06:11.000000', 'temperatura', 14.0000, 'ºC'),
	(239725, 118, '2014-03-15 00:06:12.000000', 'temperatura', 394.0000, 'ºC'),
	(239726, 118, '2014-03-15 00:06:13.000000', 'temperatura', 727.0000, 'ºC'),
	(239727, 118, '2014-03-15 00:06:14.000000', 'temperatura', 53.0000, 'ºC'),
	(239728, 118, '2014-03-15 00:06:15.000000', 'temperatura', 487.0000, 'ºC'),
	(239729, 118, '2014-03-15 00:06:16.000000', 'temperatura', 1075.0000, 'ºC'),
	(239730, 118, '2014-03-15 00:06:17.000000', 'temperatura', 317.0000, 'ºC'),
	(239731, 118, '2014-03-15 00:06:18.000000', 'temperatura', 757.0000, 'ºC'),
	(239732, 118, '2014-03-15 00:06:19.000000', 'temperatura', 437.0000, 'ºC'),
	(239733, 118, '2014-03-15 00:06:20.000000', 'temperatura', 1115.0000, 'ºC'),
	(239734, 118, '2014-03-15 00:06:21.000000', 'temperatura', 663.0000, 'ºC'),
	(239735, 118, '2014-03-15 00:06:22.000000', 'temperatura', 1170.0000, 'ºC'),
	(239736, 118, '2014-03-15 00:06:23.000000', 'temperatura', 264.0000, 'ºC'),
	(239737, 118, '2014-03-15 00:06:24.000000', 'temperatura', 207.0000, 'ºC'),
	(239738, 118, '2014-03-15 00:06:25.000000', 'temperatura', 246.0000, 'ºC'),
	(239739, 118, '2014-03-15 00:06:26.000000', 'temperatura', 610.0000, 'ºC'),
	(239740, 118, '2014-03-15 00:06:27.000000', 'temperatura', 1113.0000, 'ºC'),
	(239741, 118, '2014-03-15 00:06:28.000000', 'temperatura', 134.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(239742, 118, '2014-03-15 00:06:29.000000', 'temperatura', 933.0000, 'ºC'),
	(239743, 118, '2014-03-15 00:06:30.000000', 'temperatura', 662.0000, 'ºC'),
	(239744, 118, '2014-03-15 00:06:31.000000', 'temperatura', 512.0000, 'ºC'),
	(239745, 118, '2014-03-15 00:06:32.000000', 'temperatura', 574.0000, 'ºC'),
	(239746, 118, '2014-03-15 00:06:33.000000', 'temperatura', 134.0000, 'ºC'),
	(239747, 118, '2014-03-15 00:06:34.000000', 'temperatura', 151.0000, 'ºC'),
	(239748, 118, '2014-03-15 00:06:35.000000', 'temperatura', 351.0000, 'ºC'),
	(239749, 118, '2014-03-15 00:06:36.000000', 'temperatura', 104.0000, 'ºC'),
	(239750, 118, '2014-03-15 00:06:37.000000', 'temperatura', 665.0000, 'ºC'),
	(239751, 118, '2014-03-15 00:06:38.000000', 'temperatura', 617.0000, 'ºC'),
	(239752, 118, '2014-03-15 00:06:39.000000', 'temperatura', 1088.0000, 'ºC'),
	(239753, 118, '2014-03-15 00:06:40.000000', 'temperatura', 1191.0000, 'ºC'),
	(239754, 118, '2014-03-15 00:06:41.000000', 'temperatura', 290.0000, 'ºC'),
	(239755, 118, '2014-03-15 00:06:42.000000', 'temperatura', 278.0000, 'ºC'),
	(239756, 118, '2014-03-15 00:06:43.000000', 'temperatura', 522.0000, 'ºC'),
	(239757, 118, '2014-03-15 00:06:44.000000', 'temperatura', 577.0000, 'ºC'),
	(239758, 118, '2014-03-15 00:06:45.000000', 'temperatura', 119.0000, 'ºC'),
	(239759, 118, '2014-03-15 00:06:46.000000', 'temperatura', 64.0000, 'ºC'),
	(239760, 118, '2014-03-15 00:06:47.000000', 'temperatura', 1163.0000, 'ºC'),
	(239761, 118, '2014-03-15 00:06:48.000000', 'temperatura', 822.0000, 'ºC'),
	(239762, 118, '2014-03-15 00:06:49.000000', 'temperatura', 623.0000, 'ºC'),
	(239763, 118, '2014-03-15 00:06:50.000000', 'temperatura', 650.0000, 'ºC'),
	(239764, 118, '2014-03-15 00:06:51.000000', 'temperatura', 179.0000, 'ºC'),
	(239765, 118, '2014-03-15 00:06:52.000000', 'temperatura', 149.0000, 'ºC'),
	(239766, 118, '2014-03-15 00:06:53.000000', 'temperatura', 207.0000, 'ºC'),
	(239767, 118, '2014-03-15 00:06:54.000000', 'temperatura', 590.0000, 'ºC'),
	(239768, 118, '2014-03-15 00:06:55.000000', 'temperatura', 1129.0000, 'ºC'),
	(239769, 118, '2014-03-15 00:06:56.000000', 'temperatura', 275.0000, 'ºC'),
	(239770, 118, '2014-03-15 00:06:57.000000', 'temperatura', 389.0000, 'ºC'),
	(239771, 118, '2014-03-15 00:06:58.000000', 'temperatura', 1121.0000, 'ºC'),
	(239772, 118, '2014-03-15 00:06:59.000000', 'temperatura', 840.0000, 'ºC'),
	(239773, 118, '2014-03-15 00:07:00.000000', 'temperatura', 836.0000, 'ºC'),
	(239774, 118, '2014-03-15 00:07:01.000000', 'temperatura', 458.0000, 'ºC'),
	(239775, 118, '2014-03-15 00:07:02.000000', 'temperatura', 986.0000, 'ºC'),
	(239776, 118, '2014-03-15 00:07:03.000000', 'temperatura', 1156.0000, 'ºC'),
	(239777, 118, '2014-03-15 00:07:04.000000', 'temperatura', 420.0000, 'ºC'),
	(239778, 118, '2014-03-15 00:07:05.000000', 'temperatura', 1034.0000, 'ºC'),
	(239779, 118, '2014-03-15 00:07:06.000000', 'temperatura', 313.0000, 'ºC'),
	(239780, 118, '2014-03-15 00:07:07.000000', 'temperatura', 860.0000, 'ºC'),
	(239781, 118, '2014-03-15 00:07:08.000000', 'temperatura', 962.0000, 'ºC'),
	(239782, 118, '2014-03-15 00:07:09.000000', 'temperatura', 1032.0000, 'ºC'),
	(239783, 118, '2014-03-15 00:07:10.000000', 'temperatura', 1076.0000, 'ºC'),
	(239784, 118, '2014-03-15 00:07:11.000000', 'temperatura', 1082.0000, 'ºC'),
	(239785, 118, '2014-03-15 00:07:12.000000', 'temperatura', 981.0000, 'ºC'),
	(239786, 118, '2014-03-15 00:07:13.000000', 'temperatura', 463.0000, 'ºC'),
	(239787, 118, '2014-03-15 00:07:14.000000', 'temperatura', 571.0000, 'ºC'),
	(239788, 118, '2014-03-15 00:07:15.000000', 'temperatura', 265.0000, 'ºC'),
	(239789, 118, '2014-03-15 00:07:16.000000', 'temperatura', 812.0000, 'ºC'),
	(239790, 118, '2014-03-15 00:07:17.000000', 'temperatura', 868.0000, 'ºC'),
	(239791, 118, '2014-03-15 00:07:18.000000', 'temperatura', 704.0000, 'ºC'),
	(239792, 118, '2014-03-15 00:07:19.000000', 'temperatura', 916.0000, 'ºC'),
	(239793, 118, '2014-03-15 00:07:20.000000', 'temperatura', 70.0000, 'ºC'),
	(239794, 118, '2014-03-15 00:07:21.000000', 'temperatura', 0.0000, 'ºC'),
	(239795, 118, '2014-03-15 00:07:22.000000', 'temperatura', 992.0000, 'ºC'),
	(239796, 118, '2014-03-15 00:07:23.000000', 'temperatura', 161.0000, 'ºC'),
	(239797, 118, '2014-03-15 00:07:24.000000', 'temperatura', 231.0000, 'ºC'),
	(239798, 118, '2014-03-15 00:07:25.000000', 'temperatura', 671.0000, 'ºC'),
	(239799, 118, '2014-03-15 00:07:26.000000', 'temperatura', 263.0000, 'ºC'),
	(239800, 118, '2014-03-15 00:07:27.000000', 'temperatura', 504.0000, 'ºC'),
	(239801, 118, '2014-03-15 00:07:28.000000', 'temperatura', 529.0000, 'ºC'),
	(239802, 118, '2014-03-15 00:07:29.000000', 'temperatura', 1135.0000, 'ºC'),
	(239803, 118, '2014-03-15 00:07:30.000000', 'temperatura', 490.0000, 'ºC'),
	(239804, 118, '2014-03-15 00:07:31.000000', 'temperatura', 244.0000, 'ºC'),
	(239805, 118, '2014-03-15 00:07:32.000000', 'temperatura', 950.0000, 'ºC'),
	(239806, 118, '2014-03-15 00:07:33.000000', 'temperatura', 420.0000, 'ºC'),
	(239807, 118, '2014-03-15 00:07:34.000000', 'temperatura', 449.0000, 'ºC'),
	(239808, 118, '2014-03-15 00:07:35.000000', 'temperatura', 987.0000, 'ºC'),
	(239809, 118, '2014-03-15 00:07:36.000000', 'temperatura', 1187.0000, 'ºC'),
	(239810, 118, '2014-03-15 00:07:37.000000', 'temperatura', 574.0000, 'ºC'),
	(239811, 118, '2014-03-15 00:07:38.000000', 'temperatura', 511.0000, 'ºC'),
	(239812, 118, '2014-03-15 00:07:39.000000', 'temperatura', 831.0000, 'ºC'),
	(239813, 118, '2014-03-15 00:07:40.000000', 'temperatura', 225.0000, 'ºC'),
	(239814, 118, '2014-03-15 00:07:41.000000', 'temperatura', 1032.0000, 'ºC'),
	(239815, 118, '2014-03-15 00:07:42.000000', 'temperatura', 886.0000, 'ºC'),
	(239816, 118, '2014-03-15 00:07:43.000000', 'temperatura', 134.0000, 'ºC'),
	(239817, 118, '2014-03-15 00:07:44.000000', 'temperatura', 411.0000, 'ºC'),
	(239818, 118, '2014-03-15 00:07:45.000000', 'temperatura', 454.0000, 'ºC'),
	(239819, 118, '2014-03-15 00:07:46.000000', 'temperatura', 1039.0000, 'ºC'),
	(239820, 118, '2014-03-15 00:07:47.000000', 'temperatura', 233.0000, 'ºC'),
	(239821, 118, '2014-03-15 00:07:48.000000', 'temperatura', 449.0000, 'ºC'),
	(239822, 118, '2014-03-15 00:07:49.000000', 'temperatura', 347.0000, 'ºC'),
	(239823, 118, '2014-03-15 00:07:50.000000', 'temperatura', 387.0000, 'ºC'),
	(239824, 118, '2014-03-15 00:07:51.000000', 'temperatura', 896.0000, 'ºC'),
	(239825, 118, '2014-03-15 00:07:52.000000', 'temperatura', 921.0000, 'ºC'),
	(239826, 118, '2014-03-15 00:07:53.000000', 'temperatura', 715.0000, 'ºC'),
	(239827, 118, '2014-03-15 00:07:54.000000', 'temperatura', 814.0000, 'ºC'),
	(239828, 118, '2014-03-15 00:07:55.000000', 'temperatura', 726.0000, 'ºC'),
	(239829, 118, '2014-03-15 00:07:56.000000', 'temperatura', 1186.0000, 'ºC'),
	(239830, 118, '2014-03-15 00:07:57.000000', 'temperatura', 153.0000, 'ºC'),
	(239831, 118, '2014-03-15 00:07:58.000000', 'temperatura', 809.0000, 'ºC'),
	(239832, 118, '2014-03-15 00:07:59.000000', 'temperatura', 1184.0000, 'ºC'),
	(239833, 118, '2014-03-15 00:08:00.000000', 'temperatura', 1095.0000, 'ºC'),
	(239834, 118, '2014-03-15 00:08:01.000000', 'temperatura', 724.0000, 'ºC'),
	(239835, 118, '2014-03-15 00:08:02.000000', 'temperatura', 337.0000, 'ºC'),
	(239836, 118, '2014-03-15 00:08:03.000000', 'temperatura', 710.0000, 'ºC'),
	(239837, 118, '2014-03-15 00:08:04.000000', 'temperatura', 142.0000, 'ºC'),
	(239838, 118, '2014-03-15 00:08:05.000000', 'temperatura', 979.0000, 'ºC'),
	(239839, 118, '2014-03-15 00:08:06.000000', 'temperatura', 869.0000, 'ºC'),
	(239840, 118, '2014-03-15 00:08:07.000000', 'temperatura', 208.0000, 'ºC'),
	(239841, 118, '2014-03-15 00:08:08.000000', 'temperatura', 836.0000, 'ºC'),
	(239842, 118, '2014-03-15 00:08:09.000000', 'temperatura', 1156.0000, 'ºC'),
	(239843, 118, '2014-03-15 00:08:10.000000', 'temperatura', 870.0000, 'ºC'),
	(239844, 118, '2014-03-15 00:08:11.000000', 'temperatura', 884.0000, 'ºC'),
	(239845, 118, '2014-03-15 00:08:12.000000', 'temperatura', 610.0000, 'ºC'),
	(239846, 118, '2014-03-15 00:08:13.000000', 'temperatura', 399.0000, 'ºC'),
	(239847, 118, '2014-03-15 00:08:14.000000', 'temperatura', 166.0000, 'ºC'),
	(239848, 118, '2014-03-15 00:08:15.000000', 'temperatura', 831.0000, 'ºC'),
	(239849, 118, '2014-03-15 00:08:16.000000', 'temperatura', 60.0000, 'ºC'),
	(239850, 118, '2014-03-15 00:08:17.000000', 'temperatura', 209.0000, 'ºC'),
	(239851, 118, '2014-03-15 00:08:18.000000', 'temperatura', 863.0000, 'ºC'),
	(239852, 118, '2014-03-15 00:08:19.000000', 'temperatura', 89.0000, 'ºC'),
	(239853, 118, '2014-03-15 00:08:20.000000', 'temperatura', 259.0000, 'ºC'),
	(239854, 118, '2014-03-15 00:08:21.000000', 'temperatura', 1025.0000, 'ºC'),
	(239855, 118, '2014-03-15 00:08:22.000000', 'temperatura', 751.0000, 'ºC'),
	(239856, 118, '2014-03-15 00:08:23.000000', 'temperatura', 682.0000, 'ºC'),
	(239857, 118, '2014-03-15 00:08:24.000000', 'temperatura', 1154.0000, 'ºC'),
	(239858, 118, '2014-03-15 00:08:25.000000', 'temperatura', 128.0000, 'ºC'),
	(239859, 118, '2014-03-15 00:08:26.000000', 'temperatura', 776.0000, 'ºC'),
	(239860, 118, '2014-03-15 00:08:27.000000', 'temperatura', 1097.0000, 'ºC'),
	(239861, 118, '2014-03-15 00:08:28.000000', 'temperatura', 760.0000, 'ºC'),
	(239862, 118, '2014-03-15 00:08:29.000000', 'temperatura', 506.0000, 'ºC'),
	(239863, 118, '2014-03-15 00:08:30.000000', 'temperatura', 251.0000, 'ºC'),
	(239864, 118, '2014-03-15 00:08:31.000000', 'temperatura', 938.0000, 'ºC'),
	(239865, 118, '2014-03-15 00:08:32.000000', 'temperatura', 338.0000, 'ºC'),
	(239866, 118, '2014-03-15 00:08:33.000000', 'temperatura', 74.0000, 'ºC'),
	(239867, 118, '2014-03-15 00:08:34.000000', 'temperatura', 558.0000, 'ºC'),
	(239868, 118, '2014-03-15 00:08:35.000000', 'temperatura', 169.0000, 'ºC'),
	(239869, 118, '2014-03-15 00:08:36.000000', 'temperatura', 373.0000, 'ºC'),
	(239870, 118, '2014-03-15 00:08:37.000000', 'temperatura', 158.0000, 'ºC'),
	(239871, 118, '2014-03-15 00:08:38.000000', 'temperatura', 870.0000, 'ºC'),
	(239872, 118, '2014-03-15 00:08:39.000000', 'temperatura', 279.0000, 'ºC'),
	(239873, 118, '2014-03-15 00:08:40.000000', 'temperatura', 1184.0000, 'ºC'),
	(239874, 118, '2014-03-15 00:08:41.000000', 'temperatura', 284.0000, 'ºC'),
	(239875, 118, '2014-03-15 00:08:42.000000', 'temperatura', 269.0000, 'ºC'),
	(239876, 118, '2014-03-15 00:08:43.000000', 'temperatura', 493.0000, 'ºC'),
	(239877, 118, '2014-03-15 00:08:44.000000', 'temperatura', 459.0000, 'ºC'),
	(239878, 118, '2014-03-15 00:08:45.000000', 'temperatura', 818.0000, 'ºC'),
	(239879, 118, '2014-03-15 00:08:46.000000', 'temperatura', 313.0000, 'ºC'),
	(239880, 118, '2014-03-15 00:08:47.000000', 'temperatura', 309.0000, 'ºC'),
	(239881, 118, '2014-03-15 00:08:48.000000', 'temperatura', 609.0000, 'ºC'),
	(239882, 118, '2014-03-15 00:08:49.000000', 'temperatura', 917.0000, 'ºC'),
	(239883, 118, '2014-03-15 00:08:50.000000', 'temperatura', 361.0000, 'ºC'),
	(239884, 118, '2014-03-15 00:08:51.000000', 'temperatura', 252.0000, 'ºC'),
	(239885, 118, '2014-03-15 00:08:52.000000', 'temperatura', 177.0000, 'ºC'),
	(239886, 118, '2014-03-15 00:08:53.000000', 'temperatura', 130.0000, 'ºC'),
	(239887, 118, '2014-03-15 00:08:54.000000', 'temperatura', 120.0000, 'ºC'),
	(239888, 118, '2014-03-15 00:08:55.000000', 'temperatura', 211.0000, 'ºC'),
	(239889, 118, '2014-03-15 00:08:56.000000', 'temperatura', 695.0000, 'ºC'),
	(239890, 118, '2014-03-15 00:08:57.000000', 'temperatura', 443.0000, 'ºC'),
	(239891, 118, '2014-03-15 00:08:58.000000', 'temperatura', 131.0000, 'ºC'),
	(239892, 118, '2014-03-15 00:08:59.000000', 'temperatura', 525.0000, 'ºC'),
	(239893, 118, '2014-03-15 00:09:00.000000', 'temperatura', 1031.0000, 'ºC'),
	(239894, 118, '2014-03-15 00:09:01.000000', 'temperatura', 1183.0000, 'ºC'),
	(239895, 118, '2014-03-15 00:09:02.000000', 'temperatura', 421.0000, 'ºC'),
	(239896, 118, '2014-03-15 00:09:03.000000', 'temperatura', 956.0000, 'ºC'),
	(239897, 118, '2014-03-15 00:09:04.000000', 'temperatura', 1120.0000, 'ºC'),
	(239898, 118, '2014-03-15 00:09:05.000000', 'temperatura', 333.0000, 'ºC'),
	(239899, 118, '2014-03-15 00:09:06.000000', 'temperatura', 704.0000, 'ºC'),
	(239900, 118, '2014-03-15 00:09:07.000000', 'temperatura', 120.0000, 'ºC'),
	(239901, 118, '2014-03-15 00:09:08.000000', 'temperatura', 889.0000, 'ºC'),
	(239902, 118, '2014-03-15 00:09:09.000000', 'temperatura', 485.0000, 'ºC'),
	(239903, 118, '2014-03-15 00:09:10.000000', 'temperatura', 960.0000, 'ºC'),
	(239904, 118, '2014-03-15 00:09:11.000000', 'temperatura', 947.0000, 'ºC'),
	(239905, 118, '2014-03-15 00:09:12.000000', 'temperatura', 654.0000, 'ºC'),
	(239906, 118, '2014-03-15 00:09:13.000000', 'temperatura', 429.0000, 'ºC'),
	(239907, 118, '2014-03-15 00:09:14.000000', 'temperatura', 184.0000, 'ºC'),
	(239908, 118, '2014-03-15 00:09:15.000000', 'temperatura', 832.0000, 'ºC'),
	(239909, 118, '2014-03-15 00:09:16.000000', 'temperatura', 8.0000, 'ºC'),
	(239910, 118, '2014-03-15 00:09:17.000000', 'temperatura', 1144.0000, 'ºC'),
	(239911, 118, '2014-03-15 00:09:18.000000', 'temperatura', 896.0000, 'ºC'),
	(239912, 118, '2014-03-15 00:09:19.000000', 'temperatura', 1049.0000, 'ºC'),
	(239913, 118, '2014-03-15 00:09:20.000000', 'temperatura', 158.0000, 'ºC'),
	(239914, 118, '2014-03-15 00:09:21.000000', 'temperatura', 42.0000, 'ºC'),
	(239915, 118, '2014-03-15 00:09:22.000000', 'temperatura', 939.0000, 'ºC'),
	(239916, 118, '2014-03-15 00:09:23.000000', 'temperatura', 971.0000, 'ºC'),
	(239917, 118, '2014-03-15 00:09:24.000000', 'temperatura', 835.0000, 'ºC'),
	(239918, 118, '2014-03-15 00:09:25.000000', 'temperatura', 62.0000, 'ºC'),
	(239919, 118, '2014-03-15 00:09:26.000000', 'temperatura', 207.0000, 'ºC'),
	(239920, 118, '2014-03-15 00:09:27.000000', 'temperatura', 847.0000, 'ºC'),
	(239921, 118, '2014-03-15 00:09:28.000000', 'temperatura', 18.0000, 'ºC'),
	(239922, 118, '2014-03-15 00:09:29.000000', 'temperatura', 1146.0000, 'ºC'),
	(239923, 118, '2014-03-15 00:09:30.000000', 'temperatura', 880.0000, 'ºC'),
	(239924, 118, '2014-03-15 00:09:31.000000', 'temperatura', 961.0000, 'ºC'),
	(239925, 118, '2014-03-15 00:09:32.000000', 'temperatura', 968.0000, 'ºC'),
	(239926, 118, '2014-03-15 00:09:33.000000', 'temperatura', 754.0000, 'ºC'),
	(239927, 118, '2014-03-15 00:09:34.000000', 'temperatura', 868.0000, 'ºC'),
	(239928, 118, '2014-03-15 00:09:35.000000', 'temperatura', 876.0000, 'ºC'),
	(239929, 118, '2014-03-15 00:09:36.000000', 'temperatura', 580.0000, 'ºC'),
	(239930, 118, '2014-03-15 00:09:37.000000', 'temperatura', 270.0000, 'ºC'),
	(239931, 118, '2014-03-15 00:09:38.000000', 'temperatura', 812.0000, 'ºC'),
	(239932, 118, '2014-03-15 00:09:39.000000', 'temperatura', 852.0000, 'ºC'),
	(239933, 118, '2014-03-15 00:09:40.000000', 'temperatura', 624.0000, 'ºC'),
	(239934, 118, '2014-03-15 00:09:41.000000', 'temperatura', 563.0000, 'ºC'),
	(239935, 118, '2014-03-15 00:09:42.000000', 'temperatura', 944.0000, 'ºC'),
	(239936, 118, '2014-03-15 00:09:43.000000', 'temperatura', 633.0000, 'ºC'),
	(239937, 118, '2014-03-15 00:09:44.000000', 'temperatura', 334.0000, 'ºC'),
	(239938, 118, '2014-03-15 00:09:45.000000', 'temperatura', 968.0000, 'ºC'),
	(239939, 118, '2014-03-15 00:09:46.000000', 'temperatura', 242.0000, 'ºC'),
	(239940, 118, '2014-03-15 00:09:47.000000', 'temperatura', 707.0000, 'ºC'),
	(239941, 118, '2014-03-15 00:09:48.000000', 'temperatura', 406.0000, 'ºC'),
	(239942, 118, '2014-03-15 00:09:49.000000', 'temperatura', 1113.0000, 'ºC'),
	(239943, 118, '2014-03-15 00:09:50.000000', 'temperatura', 746.0000, 'ºC'),
	(239944, 118, '2014-03-15 00:09:51.000000', 'temperatura', 392.0000, 'ºC'),
	(239945, 118, '2014-03-15 00:09:52.000000', 'temperatura', 923.0000, 'ºC'),
	(239946, 118, '2014-03-15 00:09:53.000000', 'temperatura', 1040.0000, 'ºC'),
	(239947, 118, '2014-03-15 00:09:54.000000', 'temperatura', 32.0000, 'ºC'),
	(239948, 118, '2014-03-15 00:09:55.000000', 'temperatura', 640.0000, 'ºC'),
	(239949, 118, '2014-03-15 00:09:56.000000', 'temperatura', 704.0000, 'ºC'),
	(239950, 118, '2014-03-15 00:09:57.000000', 'temperatura', 403.0000, 'ºC'),
	(239951, 118, '2014-03-15 00:09:58.000000', 'temperatura', 1100.0000, 'ºC'),
	(239952, 118, '2014-03-15 00:09:59.000000', 'temperatura', 693.0000, 'ºC'),
	(239953, 118, '2014-03-15 00:10:00.000000', 'temperatura', 167.0000, 'ºC'),
	(239954, 118, '2014-03-15 00:10:01.000000', 'temperatura', 1156.0000, 'ºC'),
	(239955, 118, '2014-03-15 00:10:02.000000', 'temperatura', 479.0000, 'ºC'),
	(239956, 118, '2014-03-15 00:10:03.000000', 'temperatura', 127.0000, 'ºC'),
	(239957, 118, '2014-03-15 00:10:04.000000', 'temperatura', 400.0000, 'ºC'),
	(239958, 118, '2014-03-15 00:10:05.000000', 'temperatura', 417.0000, 'ºC'),
	(239959, 118, '2014-03-15 00:10:06.000000', 'temperatura', 887.0000, 'ºC'),
	(239960, 118, '2014-03-15 00:10:07.000000', 'temperatura', 782.0000, 'ºC'),
	(239961, 118, '2014-03-15 00:10:08.000000', 'temperatura', 52.0000, 'ºC'),
	(239962, 118, '2014-03-15 00:10:09.000000', 'temperatura', 313.0000, 'ºC'),
	(239963, 118, '2014-03-15 00:10:10.000000', 'temperatura', 212.0000, 'ºC'),
	(239964, 118, '2014-03-15 00:10:11.000000', 'temperatura', 118.0000, 'ºC'),
	(239965, 118, '2014-03-15 00:10:12.000000', 'temperatura', 1157.0000, 'ºC'),
	(239966, 118, '2014-03-15 00:10:13.000000', 'temperatura', 632.0000, 'ºC'),
	(239967, 118, '2014-03-15 00:10:14.000000', 'temperatura', 889.0000, 'ºC'),
	(239968, 118, '2014-03-15 00:10:15.000000', 'temperatura', 148.0000, 'ºC'),
	(239969, 118, '2014-03-15 00:10:16.000000', 'temperatura', 473.0000, 'ºC'),
	(239970, 118, '2014-03-15 00:10:17.000000', 'temperatura', 724.0000, 'ºC'),
	(239971, 118, '2014-03-15 00:10:18.000000', 'temperatura', 1001.0000, 'ºC'),
	(239972, 118, '2014-03-15 00:10:19.000000', 'temperatura', 435.0000, 'ºC'),
	(239973, 118, '2014-03-15 00:10:20.000000', 'temperatura', 372.0000, 'ºC'),
	(239974, 118, '2014-03-15 00:10:21.000000', 'temperatura', 555.0000, 'ºC'),
	(239975, 118, '2014-03-15 00:10:22.000000', 'temperatura', 458.0000, 'ºC'),
	(239976, 118, '2014-03-15 00:10:23.000000', 'temperatura', 628.0000, 'ºC'),
	(239977, 118, '2014-03-15 00:10:24.000000', 'temperatura', 566.0000, 'ºC'),
	(239978, 118, '2014-03-15 00:10:25.000000', 'temperatura', 945.0000, 'ºC'),
	(239979, 118, '2014-03-15 00:10:26.000000', 'temperatura', 629.0000, 'ºC'),
	(239980, 118, '2014-03-15 00:10:27.000000', 'temperatura', 309.0000, 'ºC'),
	(239981, 118, '2014-03-15 00:10:28.000000', 'temperatura', 860.0000, 'ºC'),
	(239982, 118, '2014-03-15 00:10:29.000000', 'temperatura', 974.0000, 'ºC'),
	(239983, 118, '2014-03-15 00:10:30.000000', 'temperatura', 1089.0000, 'ºC'),
	(239984, 118, '2014-03-15 00:10:31.000000', 'temperatura', 123.0000, 'ºC'),
	(239985, 118, '2014-03-15 00:10:32.000000', 'temperatura', 950.0000, 'ºC'),
	(239986, 118, '2014-03-15 00:10:33.000000', 'temperatura', 782.0000, 'ºC'),
	(239987, 118, '2014-03-15 00:10:34.000000', 'temperatura', 1062.0000, 'ºC'),
	(239988, 118, '2014-03-15 00:10:35.000000', 'temperatura', 562.0000, 'ºC'),
	(239989, 118, '2014-03-15 00:10:36.000000', 'temperatura', 826.0000, 'ºC'),
	(239990, 118, '2014-03-15 00:10:37.000000', 'temperatura', 45.0000, 'ºC'),
	(239991, 118, '2014-03-15 00:10:38.000000', 'temperatura', 145.0000, 'ºC'),
	(239992, 118, '2014-03-15 00:10:39.000000', 'temperatura', 591.0000, 'ºC'),
	(239993, 118, '2014-03-15 00:10:40.000000', 'temperatura', 120.0000, 'ºC'),
	(239994, 118, '2014-03-15 00:10:41.000000', 'temperatura', 28.0000, 'ºC'),
	(239995, 118, '2014-03-15 00:10:42.000000', 'temperatura', 979.0000, 'ºC'),
	(239996, 118, '2014-03-15 00:10:43.000000', 'temperatura', 14.0000, 'ºC'),
	(239997, 118, '2014-03-15 00:10:44.000000', 'temperatura', 734.0000, 'ºC'),
	(239998, 118, '2014-03-15 00:10:45.000000', 'temperatura', 30.0000, 'ºC'),
	(239999, 118, '2014-03-15 00:10:46.000000', 'temperatura', 345.0000, 'ºC'),
	(240000, 118, '2014-03-15 00:10:47.000000', 'temperatura', 435.0000, 'ºC'),
	(240001, 118, '2014-03-15 00:10:48.000000', 'temperatura', 1142.0000, 'ºC'),
	(240002, 118, '2014-03-15 00:10:49.000000', 'temperatura', 804.0000, 'ºC'),
	(240003, 118, '2014-03-15 00:10:50.000000', 'temperatura', 596.0000, 'ºC'),
	(240004, 118, '2014-03-15 00:10:51.000000', 'temperatura', 570.0000, 'ºC'),
	(240005, 118, '2014-03-15 00:10:52.000000', 'temperatura', 1062.0000, 'ºC'),
	(240006, 118, '2014-03-15 00:10:53.000000', 'temperatura', 1199.0000, 'ºC'),
	(240007, 118, '2014-03-15 00:10:54.000000', 'temperatura', 412.0000, 'ºC'),
	(240008, 118, '2014-03-15 00:10:55.000000', 'temperatura', 862.0000, 'ºC'),
	(240009, 118, '2014-03-15 00:10:56.000000', 'temperatura', 675.0000, 'ºC'),
	(240010, 118, '2014-03-15 00:10:57.000000', 'temperatura', 788.0000, 'ºC'),
	(240011, 118, '2014-03-15 00:10:58.000000', 'temperatura', 718.0000, 'ºC'),
	(240012, 118, '2014-03-15 00:10:59.000000', 'temperatura', 25.0000, 'ºC'),
	(240013, 118, '2014-03-15 00:11:00.000000', 'temperatura', 370.0000, 'ºC'),
	(240014, 118, '2014-03-15 00:11:01.000000', 'temperatura', 577.0000, 'ºC'),
	(240015, 118, '2014-03-15 00:11:02.000000', 'temperatura', 575.0000, 'ºC'),
	(240016, 118, '2014-03-15 00:11:03.000000', 'temperatura', 1146.0000, 'ºC'),
	(240017, 118, '2014-03-15 00:11:04.000000', 'temperatura', 407.0000, 'ºC'),
	(240018, 118, '2014-03-15 00:11:05.000000', 'temperatura', 994.0000, 'ºC'),
	(240019, 118, '2014-03-15 00:11:06.000000', 'temperatura', 152.0000, 'ºC'),
	(240020, 118, '2014-03-15 00:11:07.000000', 'temperatura', 178.0000, 'ºC'),
	(240021, 118, '2014-03-15 00:11:08.000000', 'temperatura', 435.0000, 'ºC'),
	(240022, 118, '2014-03-15 00:11:09.000000', 'temperatura', 441.0000, 'ºC'),
	(240023, 118, '2014-03-15 00:11:10.000000', 'temperatura', 902.0000, 'ºC'),
	(240024, 118, '2014-03-15 00:11:11.000000', 'temperatura', 786.0000, 'ºC'),
	(240025, 118, '2014-03-15 00:11:12.000000', 'temperatura', 23.0000, 'ºC'),
	(240026, 118, '2014-03-15 00:11:13.000000', 'temperatura', 159.0000, 'ºC'),
	(240027, 118, '2014-03-15 00:11:14.000000', 'temperatura', 726.0000, 'ºC'),
	(240028, 118, '2014-03-15 00:11:15.000000', 'temperatura', 754.0000, 'ºC'),
	(240029, 118, '2014-03-15 00:11:16.000000', 'temperatura', 393.0000, 'ºC'),
	(240030, 118, '2014-03-15 00:11:17.000000', 'temperatura', 904.0000, 'ºC'),
	(240031, 118, '2014-03-15 00:11:18.000000', 'temperatura', 939.0000, 'ºC'),
	(240032, 118, '2014-03-15 00:11:19.000000', 'temperatura', 785.0000, 'ºC'),
	(240033, 118, '2014-03-15 00:11:20.000000', 'temperatura', 1109.0000, 'ºC'),
	(240034, 118, '2014-03-15 00:11:21.000000', 'temperatura', 788.0000, 'ºC'),
	(240035, 118, '2014-03-15 00:11:22.000000', 'temperatura', 615.0000, 'ºC'),
	(240036, 118, '2014-03-15 00:11:23.000000', 'temperatura', 712.0000, 'ºC'),
	(240037, 118, '2014-03-15 00:11:24.000000', 'temperatura', 515.0000, 'ºC'),
	(240038, 118, '2014-03-15 00:11:25.000000', 'temperatura', 439.0000, 'ºC'),
	(240039, 118, '2014-03-15 00:11:26.000000', 'temperatura', 650.0000, 'ºC'),
	(240040, 118, '2014-03-15 00:11:27.000000', 'temperatura', 735.0000, 'ºC'),
	(240041, 118, '2014-03-15 00:11:28.000000', 'temperatura', 527.0000, 'ºC'),
	(240042, 118, '2014-03-15 00:11:29.000000', 'temperatura', 427.0000, 'ºC'),
	(240043, 118, '2014-03-15 00:11:30.000000', 'temperatura', 555.0000, 'ºC'),
	(240044, 118, '2014-03-15 00:11:31.000000', 'temperatura', 297.0000, 'ºC'),
	(240045, 118, '2014-03-15 00:11:32.000000', 'temperatura', 1020.0000, 'ºC'),
	(240046, 118, '2014-03-15 00:11:33.000000', 'temperatura', 610.0000, 'ºC'),
	(240047, 118, '2014-03-15 00:11:34.000000', 'temperatura', 1188.0000, 'ºC'),
	(240048, 118, '2014-03-15 00:11:35.000000', 'temperatura', 512.0000, 'ºC'),
	(240049, 118, '2014-03-15 00:11:36.000000', 'temperatura', 198.0000, 'ºC'),
	(240050, 118, '2014-03-15 00:11:37.000000', 'temperatura', 653.0000, 'ºC'),
	(240051, 118, '2014-03-15 00:11:38.000000', 'temperatura', 271.0000, 'ºC'),
	(240052, 118, '2014-03-15 00:11:39.000000', 'temperatura', 597.0000, 'ºC'),
	(240053, 118, '2014-03-15 00:11:40.000000', 'temperatura', 974.0000, 'ºC'),
	(240054, 118, '2014-03-15 00:11:41.000000', 'temperatura', 679.0000, 'ºC'),
	(240055, 118, '2014-03-15 00:11:42.000000', 'temperatura', 471.0000, 'ºC'),
	(240056, 118, '2014-03-15 00:11:43.000000', 'temperatura', 321.0000, 'ºC'),
	(240057, 118, '2014-03-15 00:11:44.000000', 'temperatura', 190.0000, 'ºC'),
	(240058, 118, '2014-03-15 00:11:45.000000', 'temperatura', 1190.0000, 'ºC'),
	(240059, 118, '2014-03-15 00:11:46.000000', 'temperatura', 579.0000, 'ºC'),
	(240060, 118, '2014-03-15 00:11:47.000000', 'temperatura', 527.0000, 'ºC'),
	(240061, 118, '2014-03-15 00:11:48.000000', 'temperatura', 896.0000, 'ºC'),
	(240062, 118, '2014-03-15 00:11:49.000000', 'temperatura', 503.0000, 'ºC'),
	(240063, 118, '2014-03-15 00:11:50.000000', 'temperatura', 1024.0000, 'ºC'),
	(240064, 118, '2014-03-15 00:11:51.000000', 'temperatura', 14.0000, 'ºC'),
	(240065, 118, '2014-03-15 00:11:52.000000', 'temperatura', 600.0000, 'ºC'),
	(240066, 118, '2014-03-15 00:11:53.000000', 'temperatura', 556.0000, 'ºC'),
	(240067, 118, '2014-03-15 00:11:54.000000', 'temperatura', 979.0000, 'ºC'),
	(240068, 118, '2014-03-15 00:11:55.000000', 'temperatura', 830.0000, 'ºC'),
	(240069, 118, '2014-03-15 00:11:56.000000', 'temperatura', 11.0000, 'ºC'),
	(240070, 118, '2014-03-15 00:11:57.000000', 'temperatura', 1166.0000, 'ºC'),
	(240071, 118, '2014-03-15 00:11:58.000000', 'temperatura', 998.0000, 'ºC'),
	(240072, 118, '2014-03-15 00:11:59.000000', 'temperatura', 293.0000, 'ºC'),
	(240073, 118, '2014-03-15 00:12:00.000000', 'temperatura', 871.0000, 'ºC'),
	(240074, 118, '2014-03-15 00:12:01.000000', 'temperatura', 1076.0000, 'ºC'),
	(240075, 118, '2014-03-15 00:12:02.000000', 'temperatura', 369.0000, 'ºC'),
	(240076, 118, '2014-03-15 00:12:03.000000', 'temperatura', 1019.0000, 'ºC'),
	(240077, 118, '2014-03-15 00:12:04.000000', 'temperatura', 385.0000, 'ºC'),
	(240078, 118, '2014-03-15 00:12:05.000000', 'temperatura', 72.0000, 'ºC'),
	(240079, 118, '2014-03-15 00:12:06.000000', 'temperatura', 403.0000, 'ºC'),
	(240080, 118, '2014-03-15 00:12:07.000000', 'temperatura', 600.0000, 'ºC'),
	(240081, 118, '2014-03-15 00:12:08.000000', 'temperatura', 590.0000, 'ºC'),
	(240082, 118, '2014-03-15 00:12:09.000000', 'temperatura', 1151.0000, 'ºC'),
	(240083, 118, '2014-03-15 00:12:10.000000', 'temperatura', 386.0000, 'ºC'),
	(240084, 118, '2014-03-15 00:12:11.000000', 'temperatura', 879.0000, 'ºC'),
	(240085, 118, '2014-03-15 00:12:12.000000', 'temperatura', 835.0000, 'ºC'),
	(240086, 118, '2014-03-15 00:12:13.000000', 'temperatura', 341.0000, 'ºC'),
	(240087, 118, '2014-03-15 00:12:14.000000', 'temperatura', 399.0000, 'ºC'),
	(240088, 118, '2014-03-15 00:12:15.000000', 'temperatura', 971.0000, 'ºC'),
	(240089, 118, '2014-03-15 00:12:16.000000', 'temperatura', 59.0000, 'ºC'),
	(240090, 118, '2014-03-15 00:12:17.000000', 'temperatura', 982.0000, 'ºC'),
	(240091, 118, '2014-03-15 00:12:18.000000', 'temperatura', 1132.0000, 'ºC'),
	(240092, 118, '2014-03-15 00:12:19.000000', 'temperatura', 318.0000, 'ºC'),
	(240093, 118, '2014-03-15 00:12:20.000000', 'temperatura', 593.0000, 'ºC'),
	(240094, 118, '2014-03-15 00:12:21.000000', 'temperatura', 812.0000, 'ºC'),
	(240095, 118, '2014-03-15 00:12:22.000000', 'temperatura', 1082.0000, 'ºC'),
	(240096, 118, '2014-03-15 00:12:23.000000', 'temperatura', 573.0000, 'ºC'),
	(240097, 118, '2014-03-15 00:12:24.000000', 'temperatura', 818.0000, 'ºC'),
	(240098, 118, '2014-03-15 00:12:25.000000', 'temperatura', 1173.0000, 'ºC'),
	(240099, 118, '2014-03-15 00:12:26.000000', 'temperatura', 1012.0000, 'ºC'),
	(240100, 118, '2014-03-15 00:12:27.000000', 'temperatura', 341.0000, 'ºC'),
	(240101, 118, '2014-03-15 00:12:28.000000', 'temperatura', 1068.0000, 'ºC'),
	(240102, 118, '2014-03-15 00:12:29.000000', 'temperatura', 718.0000, 'ºC'),
	(240103, 118, '2014-03-15 00:12:30.000000', 'temperatura', 389.0000, 'ºC'),
	(240104, 118, '2014-03-15 00:12:31.000000', 'temperatura', 988.0000, 'ºC'),
	(240105, 118, '2014-03-15 00:12:32.000000', 'temperatura', 177.0000, 'ºC'),
	(240106, 118, '2014-03-15 00:12:33.000000', 'temperatura', 318.0000, 'ºC'),
	(240107, 118, '2014-03-15 00:12:34.000000', 'temperatura', 1061.0000, 'ºC'),
	(240108, 118, '2014-03-15 00:12:35.000000', 'temperatura', 751.0000, 'ºC'),
	(240109, 118, '2014-03-15 00:12:36.000000', 'temperatura', 571.0000, 'ºC'),
	(240110, 118, '2014-03-15 00:12:37.000000', 'temperatura', 603.0000, 'ºC'),
	(240111, 118, '2014-03-15 00:12:38.000000', 'temperatura', 104.0000, 'ºC'),
	(240112, 118, '2014-03-15 00:12:39.000000', 'temperatura', 1112.0000, 'ºC'),
	(240113, 118, '2014-03-15 00:12:40.000000', 'temperatura', 447.0000, 'ºC'),
	(240114, 118, '2014-03-15 00:12:41.000000', 'temperatura', 99.0000, 'ºC'),
	(240115, 118, '2014-03-15 00:12:42.000000', 'temperatura', 353.0000, 'ºC'),
	(240116, 118, '2014-03-15 00:12:43.000000', 'temperatura', 271.0000, 'ºC'),
	(240117, 118, '2014-03-15 00:12:44.000000', 'temperatura', 298.0000, 'ºC'),
	(240118, 118, '2014-03-15 00:12:45.000000', 'temperatura', 676.0000, 'ºC'),
	(240119, 118, '2014-03-15 00:12:46.000000', 'temperatura', 86.0000, 'ºC'),
	(240120, 118, '2014-03-15 00:12:47.000000', 'temperatura', 801.0000, 'ºC'),
	(240121, 118, '2014-03-15 00:12:48.000000', 'temperatura', 151.0000, 'ºC'),
	(240122, 118, '2014-03-15 00:12:49.000000', 'temperatura', 750.0000, 'ºC'),
	(240123, 118, '2014-03-15 00:12:50.000000', 'temperatura', 897.0000, 'ºC'),
	(240124, 118, '2014-03-15 00:12:51.000000', 'temperatura', 1038.0000, 'ºC'),
	(240125, 118, '2014-03-15 00:12:52.000000', 'temperatura', 97.0000, 'ºC'),
	(240126, 118, '2014-03-15 00:12:53.000000', 'temperatura', 973.0000, 'ºC'),
	(240127, 118, '2014-03-15 00:12:54.000000', 'temperatura', 976.0000, 'ºC'),
	(240128, 118, '2014-03-15 00:12:55.000000', 'temperatura', 758.0000, 'ºC'),
	(240129, 118, '2014-03-15 00:12:56.000000', 'temperatura', 865.0000, 'ºC'),
	(240130, 118, '2014-03-15 00:12:57.000000', 'temperatura', 850.0000, 'ºC'),
	(240131, 118, '2014-03-15 00:12:58.000000', 'temperatura', 455.0000, 'ºC'),
	(240132, 118, '2014-03-15 00:12:59.000000', 'temperatura', 927.0000, 'ºC'),
	(240133, 118, '2014-03-15 00:13:00.000000', 'temperatura', 872.0000, 'ºC'),
	(240134, 118, '2014-03-15 00:13:01.000000', 'temperatura', 376.0000, 'ºC'),
	(240135, 118, '2014-03-15 00:13:02.000000', 'temperatura', 467.0000, 'ºC'),
	(240136, 118, '2014-03-15 00:13:03.000000', 'temperatura', 8.0000, 'ºC'),
	(240137, 118, '2014-03-15 00:13:04.000000', 'temperatura', 1037.0000, 'ºC'),
	(240138, 118, '2014-03-15 00:13:05.000000', 'temperatura', 361.0000, 'ºC'),
	(240139, 118, '2014-03-15 00:13:06.000000', 'temperatura', 1096.0000, 'ºC'),
	(240140, 118, '2014-03-15 00:13:07.000000', 'temperatura', 799.0000, 'ºC'),
	(240141, 118, '2014-03-15 00:13:08.000000', 'temperatura', 705.0000, 'ºC'),
	(240142, 118, '2014-03-15 00:13:09.000000', 'temperatura', 1131.0000, 'ºC'),
	(240143, 118, '2014-03-15 00:13:10.000000', 'temperatura', 1137.0000, 'ºC'),
	(240144, 118, '2014-03-15 00:13:11.000000', 'temperatura', 1096.0000, 'ºC'),
	(240145, 118, '2014-03-15 00:13:12.000000', 'temperatura', 869.0000, 'ºC'),
	(240146, 118, '2014-03-15 00:13:13.000000', 'temperatura', 1059.0000, 'ºC'),
	(240147, 118, '2014-03-15 00:13:14.000000', 'temperatura', 285.0000, 'ºC'),
	(240148, 118, '2014-03-15 00:13:15.000000', 'temperatura', 650.0000, 'ºC'),
	(240149, 118, '2014-03-15 00:13:16.000000', 'temperatura', 1194.0000, 'ºC'),
	(240150, 118, '2014-03-15 00:13:17.000000', 'temperatura', 421.0000, 'ºC'),
	(240151, 118, '2014-03-15 00:13:18.000000', 'temperatura', 925.0000, 'ºC'),
	(240152, 118, '2014-03-15 00:13:19.000000', 'temperatura', 964.0000, 'ºC'),
	(240153, 118, '2014-03-15 00:13:20.000000', 'temperatura', 843.0000, 'ºC'),
	(240154, 118, '2014-03-15 00:13:21.000000', 'temperatura', 124.0000, 'ºC'),
	(240155, 118, '2014-03-15 00:13:22.000000', 'temperatura', 490.0000, 'ºC'),
	(240156, 118, '2014-03-15 00:13:23.000000', 'temperatura', 880.0000, 'ºC'),
	(240157, 118, '2014-03-15 00:13:24.000000', 'temperatura', 529.0000, 'ºC'),
	(240158, 118, '2014-03-15 00:13:25.000000', 'temperatura', 4.0000, 'ºC'),
	(240159, 118, '2014-03-15 00:13:26.000000', 'temperatura', 837.0000, 'ºC'),
	(240160, 118, '2014-03-15 00:13:27.000000', 'temperatura', 572.0000, 'ºC'),
	(240161, 118, '2014-03-15 00:13:28.000000', 'temperatura', 348.0000, 'ºC'),
	(240162, 118, '2014-03-15 00:13:29.000000', 'temperatura', 26.0000, 'ºC'),
	(240163, 118, '2014-03-15 00:13:30.000000', 'temperatura', 288.0000, 'ºC'),
	(240164, 118, '2014-03-15 00:13:31.000000', 'temperatura', 160.0000, 'ºC'),
	(240165, 118, '2014-03-15 00:13:32.000000', 'temperatura', 1136.0000, 'ºC'),
	(240166, 118, '2014-03-15 00:13:33.000000', 'temperatura', 403.0000, 'ºC'),
	(240167, 118, '2014-03-15 00:13:34.000000', 'temperatura', 1005.0000, 'ºC'),
	(240168, 118, '2014-03-15 00:13:35.000000', 'temperatura', 216.0000, 'ºC'),
	(240169, 118, '2014-03-15 00:13:36.000000', 'temperatura', 467.0000, 'ºC'),
	(240170, 118, '2014-03-15 00:13:37.000000', 'temperatura', 489.0000, 'ºC'),
	(240171, 118, '2014-03-15 00:13:38.000000', 'temperatura', 1043.0000, 'ºC'),
	(240172, 118, '2014-03-15 00:13:39.000000', 'temperatura', 147.0000, 'ºC'),
	(240173, 118, '2014-03-15 00:13:40.000000', 'temperatura', 8.0000, 'ºC'),
	(240174, 118, '2014-03-15 00:13:41.000000', 'temperatura', 799.0000, 'ºC'),
	(240175, 118, '2014-03-15 00:13:42.000000', 'temperatura', 373.0000, 'ºC'),
	(240176, 118, '2014-03-15 00:13:43.000000', 'temperatura', 667.0000, 'ºC'),
	(240177, 118, '2014-03-15 00:13:44.000000', 'temperatura', 1018.0000, 'ºC'),
	(240178, 118, '2014-03-15 00:13:45.000000', 'temperatura', 688.0000, 'ºC'),
	(240179, 118, '2014-03-15 00:13:46.000000', 'temperatura', 388.0000, 'ºC'),
	(240180, 118, '2014-03-15 00:13:47.000000', 'temperatura', 1078.0000, 'ºC'),
	(240181, 118, '2014-03-15 00:13:48.000000', 'temperatura', 625.0000, 'ºC'),
	(240182, 118, '2014-03-15 00:13:49.000000', 'temperatura', 1090.0000, 'ºC'),
	(240183, 118, '2014-03-15 00:13:50.000000', 'temperatura', 1177.0000, 'ºC'),
	(240184, 118, '2014-03-15 00:13:51.000000', 'temperatura', 215.0000, 'ºC'),
	(240185, 118, '2014-03-15 00:13:52.000000', 'temperatura', 1144.0000, 'ºC'),
	(240186, 118, '2014-03-15 00:13:53.000000', 'temperatura', 277.0000, 'ºC'),
	(240187, 118, '2014-03-15 00:13:54.000000', 'temperatura', 351.0000, 'ºC'),
	(240188, 118, '2014-03-15 00:13:55.000000', 'temperatura', 924.0000, 'ºC'),
	(240189, 118, '2014-03-15 00:13:56.000000', 'temperatura', 1170.0000, 'ºC'),
	(240190, 118, '2014-03-15 00:13:57.000000', 'temperatura', 679.0000, 'ºC'),
	(240191, 118, '2014-03-15 00:13:58.000000', 'temperatura', 1086.0000, 'ºC'),
	(240192, 118, '2014-03-15 00:13:59.000000', 'temperatura', 992.0000, 'ºC'),
	(240193, 118, '2014-03-15 00:14:00.000000', 'temperatura', 501.0000, 'ºC'),
	(240194, 118, '2014-03-15 00:14:01.000000', 'temperatura', 732.0000, 'ºC'),
	(240195, 118, '2014-03-15 00:14:02.000000', 'temperatura', 957.0000, 'ºC'),
	(240196, 118, '2014-03-15 00:14:03.000000', 'temperatura', 191.0000, 'ºC'),
	(240197, 118, '2014-03-15 00:14:04.000000', 'temperatura', 483.0000, 'ºC'),
	(240198, 118, '2014-03-15 00:14:05.000000', 'temperatura', 641.0000, 'ºC'),
	(240199, 118, '2014-03-15 00:14:06.000000', 'temperatura', 558.0000, 'ºC'),
	(240200, 118, '2014-03-15 00:14:07.000000', 'temperatura', 868.0000, 'ºC'),
	(240201, 118, '2014-03-15 00:14:08.000000', 'temperatura', 266.0000, 'ºC'),
	(240202, 118, '2014-03-15 00:14:09.000000', 'temperatura', 1128.0000, 'ºC'),
	(240203, 118, '2014-03-15 00:14:10.000000', 'temperatura', 43.0000, 'ºC'),
	(240204, 118, '2014-03-15 00:14:11.000000', 'temperatura', 431.0000, 'ºC'),
	(240205, 118, '2014-03-15 00:14:12.000000', 'temperatura', 828.0000, 'ºC'),
	(240206, 118, '2014-03-15 00:14:13.000000', 'temperatura', 445.0000, 'ºC'),
	(240207, 118, '2014-03-15 00:14:14.000000', 'temperatura', 941.0000, 'ºC'),
	(240208, 118, '2014-03-15 00:14:15.000000', 'temperatura', 973.0000, 'ºC'),
	(240209, 118, '2014-03-15 00:14:16.000000', 'temperatura', 843.0000, 'ºC'),
	(240210, 118, '2014-03-15 00:14:17.000000', 'temperatura', 95.0000, 'ºC'),
	(240211, 118, '2014-03-15 00:14:18.000000', 'temperatura', 346.0000, 'ºC'),
	(240212, 118, '2014-03-15 00:14:19.000000', 'temperatura', 247.0000, 'ºC'),
	(240213, 118, '2014-03-15 00:14:20.000000', 'temperatura', 196.0000, 'ºC'),
	(240214, 118, '2014-03-15 00:14:21.000000', 'temperatura', 239.0000, 'ºC'),
	(240215, 118, '2014-03-15 00:14:22.000000', 'temperatura', 607.0000, 'ºC'),
	(240216, 118, '2014-03-15 00:14:23.000000', 'temperatura', 1121.0000, 'ºC'),
	(240217, 118, '2014-03-15 00:14:24.000000', 'temperatura', 185.0000, 'ºC'),
	(240218, 118, '2014-03-15 00:14:25.000000', 'temperatura', 1162.0000, 'ºC'),
	(240219, 118, '2014-03-15 00:14:26.000000', 'temperatura', 457.0000, 'ºC'),
	(240220, 118, '2014-03-15 00:14:27.000000', 'temperatura', 1197.0000, 'ºC'),
	(240221, 118, '2014-03-15 00:14:28.000000', 'temperatura', 1015.0000, 'ºC'),
	(240222, 118, '2014-03-15 00:14:29.000000', 'temperatura', 285.0000, 'ºC'),
	(240223, 118, '2014-03-15 00:14:30.000000', 'temperatura', 779.0000, 'ºC'),
	(240224, 118, '2014-03-15 00:14:31.000000', 'temperatura', 640.0000, 'ºC'),
	(240225, 118, '2014-03-15 00:14:32.000000', 'temperatura', 862.0000, 'ºC'),
	(240226, 118, '2014-03-15 00:14:33.000000', 'temperatura', 1194.0000, 'ºC'),
	(240227, 118, '2014-03-15 00:14:34.000000', 'temperatura', 984.0000, 'ºC'),
	(240228, 118, '2014-03-15 00:14:35.000000', 'temperatura', 137.0000, 'ºC'),
	(240229, 118, '2014-03-15 00:14:36.000000', 'temperatura', 133.0000, 'ºC'),
	(240230, 118, '2014-03-15 00:14:37.000000', 'temperatura', 254.0000, 'ºC'),
	(240231, 118, '2014-03-15 00:14:38.000000', 'temperatura', 874.0000, 'ºC'),
	(240232, 118, '2014-03-15 00:14:39.000000', 'temperatura', 9.0000, 'ºC'),
	(240233, 118, '2014-03-15 00:14:40.000000', 'temperatura', 1022.0000, 'ºC'),
	(240234, 118, '2014-03-15 00:14:41.000000', 'temperatura', 282.0000, 'ºC'),
	(240235, 118, '2014-03-15 00:14:42.000000', 'temperatura', 748.0000, 'ºC'),
	(240236, 118, '2014-03-15 00:14:43.000000', 'temperatura', 491.0000, 'ºC'),
	(240237, 118, '2014-03-15 00:14:44.000000', 'temperatura', 214.0000, 'ºC'),
	(240238, 118, '2014-03-15 00:14:45.000000', 'temperatura', 797.0000, 'ºC'),
	(240239, 118, '2014-03-15 00:14:46.000000', 'temperatura', 943.0000, 'ºC'),
	(240240, 118, '2014-03-15 00:14:47.000000', 'temperatura', 1125.0000, 'ºC'),
	(240241, 118, '2014-03-15 00:14:48.000000', 'temperatura', 395.0000, 'ºC'),
	(240242, 118, '2014-03-15 00:14:49.000000', 'temperatura', 1002.0000, 'ºC'),
	(240243, 118, '2014-03-15 00:14:50.000000', 'temperatura', 225.0000, 'ºC'),
	(240244, 118, '2014-03-15 00:14:51.000000', 'temperatura', 518.0000, 'ºC'),
	(240245, 118, '2014-03-15 00:14:52.000000', 'temperatura', 716.0000, 'ºC'),
	(240246, 118, '2014-03-15 00:14:53.000000', 'temperatura', 827.0000, 'ºC'),
	(240247, 118, '2014-03-15 00:14:54.000000', 'temperatura', 789.0000, 'ºC'),
	(240248, 118, '2014-03-15 00:14:55.000000', 'temperatura', 266.0000, 'ºC'),
	(240249, 118, '2014-03-15 00:14:56.000000', 'temperatura', 160.0000, 'ºC'),
	(240250, 118, '2014-03-15 00:14:57.000000', 'temperatura', 2.0000, 'ºC'),
	(240251, 118, '2014-03-15 00:14:58.000000', 'temperatura', 733.0000, 'ºC'),
	(240252, 118, '2014-03-15 00:14:59.000000', 'temperatura', 58.0000, 'ºC'),
	(240253, 118, '2014-03-15 00:15:00.000000', 'temperatura', 491.0000, 'ºC'),
	(240254, 118, '2014-03-15 00:15:01.000000', 'temperatura', 1081.0000, 'ºC'),
	(240255, 118, '2014-03-15 00:15:02.000000', 'temperatura', 335.0000, 'ºC'),
	(240256, 118, '2014-03-15 00:15:03.000000', 'temperatura', 832.0000, 'ºC'),
	(240257, 118, '2014-03-15 00:15:04.000000', 'temperatura', 754.0000, 'ºC'),
	(240258, 118, '2014-03-15 00:15:05.000000', 'temperatura', 76.0000, 'ºC'),
	(240259, 118, '2014-03-15 00:15:06.000000', 'temperatura', 517.0000, 'ºC'),
	(240260, 118, '2014-03-15 00:15:07.000000', 'temperatura', 1157.0000, 'ºC'),
	(240261, 118, '2014-03-15 00:15:08.000000', 'temperatura', 634.0000, 'ºC'),
	(240262, 118, '2014-03-15 00:15:09.000000', 'temperatura', 901.0000, 'ºC'),
	(240263, 118, '2014-03-15 00:15:10.000000', 'temperatura', 204.0000, 'ºC'),
	(240264, 118, '2014-03-15 00:15:11.000000', 'temperatura', 715.0000, 'ºC'),
	(240265, 118, '2014-03-15 00:15:12.000000', 'temperatura', 564.0000, 'ºC'),
	(240266, 118, '2014-03-15 00:15:13.000000', 'temperatura', 675.0000, 'ºC'),
	(240267, 118, '2014-03-15 00:15:14.000000', 'temperatura', 482.0000, 'ºC'),
	(240268, 118, '2014-03-15 00:15:15.000000', 'temperatura', 388.0000, 'ºC'),
	(240269, 118, '2014-03-15 00:15:16.000000', 'temperatura', 493.0000, 'ºC'),
	(240270, 118, '2014-03-15 00:15:17.000000', 'temperatura', 102.0000, 'ºC'),
	(240271, 118, '2014-03-15 00:15:18.000000', 'temperatura', 233.0000, 'ºC'),
	(240272, 118, '2014-03-15 00:15:19.000000', 'temperatura', 858.0000, 'ºC'),
	(240273, 118, '2014-03-15 00:15:20.000000', 'temperatura', 1190.0000, 'ºC'),
	(240274, 118, '2014-03-15 00:15:21.000000', 'temperatura', 978.0000, 'ºC'),
	(240275, 118, '2014-03-15 00:15:22.000000', 'temperatura', 121.0000, 'ºC'),
	(240276, 118, '2014-03-15 00:15:23.000000', 'temperatura', 70.0000, 'ºC'),
	(240277, 118, '2014-03-15 00:15:24.000000', 'temperatura', 1188.0000, 'ºC'),
	(240278, 118, '2014-03-15 00:15:25.000000', 'temperatura', 930.0000, 'ºC'),
	(240279, 118, '2014-03-15 00:15:26.000000', 'temperatura', 1087.0000, 'ºC'),
	(240280, 118, '2014-03-15 00:15:27.000000', 'temperatura', 247.0000, 'ºC'),
	(240281, 118, '2014-03-15 00:15:28.000000', 'temperatura', 372.0000, 'ºC'),
	(240282, 118, '2014-03-15 00:15:29.000000', 'temperatura', 1120.0000, 'ºC'),
	(240283, 118, '2014-03-15 00:15:30.000000', 'temperatura', 884.0000, 'ºC'),
	(240284, 118, '2014-03-15 00:15:31.000000', 'temperatura', 1061.0000, 'ºC'),
	(240285, 118, '2014-03-15 00:15:32.000000', 'temperatura', 252.0000, 'ºC'),
	(240286, 118, '2014-03-15 00:15:33.000000', 'temperatura', 480.0000, 'ºC'),
	(240287, 118, '2014-03-15 00:15:34.000000', 'temperatura', 444.0000, 'ºC'),
	(240288, 118, '2014-03-15 00:15:35.000000', 'temperatura', 782.0000, 'ºC'),
	(240289, 118, '2014-03-15 00:15:36.000000', 'temperatura', 176.0000, 'ºC'),
	(240290, 118, '2014-03-15 00:15:37.000000', 'temperatura', 935.0000, 'ºC'),
	(240291, 118, '2014-03-15 00:15:38.000000', 'temperatura', 547.0000, 'ºC'),
	(240292, 118, '2014-03-15 00:15:39.000000', 'temperatura', 1130.0000, 'ºC'),
	(240293, 118, '2014-03-15 00:15:40.000000', 'temperatura', 412.0000, 'ºC'),
	(240294, 118, '2014-03-15 00:15:41.000000', 'temperatura', 1069.0000, 'ºC'),
	(240295, 118, '2014-03-15 00:15:42.000000', 'temperatura', 510.0000, 'ºC'),
	(240296, 118, '2014-03-15 00:15:43.000000', 'temperatura', 544.0000, 'ºC'),
	(240297, 118, '2014-03-15 00:15:44.000000', 'temperatura', 1189.0000, 'ºC'),
	(240298, 118, '2014-03-15 00:15:45.000000', 'temperatura', 713.0000, 'ºC'),
	(240299, 118, '2014-03-15 00:15:46.000000', 'temperatura', 1198.0000, 'ºC'),
	(240300, 118, '2014-03-15 00:15:47.000000', 'temperatura', 254.0000, 'ºC'),
	(240301, 118, '2014-03-15 00:15:48.000000', 'temperatura', 75.0000, 'ºC'),
	(240302, 118, '2014-03-15 00:15:49.000000', 'temperatura', 813.0000, 'ºC'),
	(240303, 118, '2014-03-15 00:15:50.000000', 'temperatura', 239.0000, 'ºC'),
	(240304, 118, '2014-03-15 00:15:51.000000', 'temperatura', 1159.0000, 'ºC'),
	(240305, 118, '2014-03-15 00:15:52.000000', 'temperatura', 277.0000, 'ºC'),
	(240306, 118, '2014-03-15 00:15:53.000000', 'temperatura', 307.0000, 'ºC'),
	(240307, 118, '2014-03-15 00:15:54.000000', 'temperatura', 706.0000, 'ºC'),
	(240308, 118, '2014-03-15 00:15:55.000000', 'temperatura', 210.0000, 'ºC'),
	(240309, 118, '2014-03-15 00:15:56.000000', 'temperatura', 133.0000, 'ºC'),
	(240310, 118, '2014-03-15 00:15:57.000000', 'temperatura', 33.0000, 'ºC'),
	(240311, 118, '2014-03-15 00:15:58.000000', 'temperatura', 968.0000, 'ºC'),
	(240312, 118, '2014-03-15 00:15:59.000000', 'temperatura', 1142.0000, 'ºC'),
	(240313, 118, '2014-03-15 00:16:00.000000', 'temperatura', 405.0000, 'ºC'),
	(240314, 118, '2014-03-15 00:16:01.000000', 'temperatura', 1000.0000, 'ºC'),
	(240315, 118, '2014-03-15 00:16:02.000000', 'temperatura', 184.0000, 'ºC'),
	(240316, 118, '2014-03-15 00:16:03.000000', 'temperatura', 320.0000, 'ºC'),
	(240317, 118, '2014-03-15 00:16:04.000000', 'temperatura', 1051.0000, 'ºC'),
	(240318, 118, '2014-03-15 00:16:05.000000', 'temperatura', 693.0000, 'ºC'),
	(240319, 118, '2014-03-15 00:16:06.000000', 'temperatura', 312.0000, 'ºC'),
	(240320, 118, '2014-03-15 00:16:07.000000', 'temperatura', 684.0000, 'ºC'),
	(240321, 118, '2014-03-15 00:16:08.000000', 'temperatura', 84.0000, 'ºC'),
	(240322, 118, '2014-03-15 00:16:09.000000', 'temperatura', 770.0000, 'ºC'),
	(240323, 118, '2014-03-15 00:16:10.000000', 'temperatura', 1197.0000, 'ºC'),
	(240324, 118, '2014-03-15 00:16:11.000000', 'temperatura', 74.0000, 'ºC'),
	(240325, 118, '2014-03-15 00:16:12.000000', 'temperatura', 382.0000, 'ºC'),
	(240326, 118, '2014-03-15 00:16:13.000000', 'temperatura', 489.0000, 'ºC'),
	(240327, 118, '2014-03-15 00:16:14.000000', 'temperatura', 97.0000, 'ºC'),
	(240328, 118, '2014-03-15 00:16:15.000000', 'temperatura', 220.0000, 'ºC'),
	(240329, 118, '2014-03-15 00:16:16.000000', 'temperatura', 811.0000, 'ºC'),
	(240330, 118, '2014-03-15 00:16:17.000000', 'temperatura', 994.0000, 'ºC'),
	(240331, 118, '2014-03-15 00:16:18.000000', 'temperatura', 138.0000, 'ºC'),
	(240332, 118, '2014-03-15 00:16:19.000000', 'temperatura', 108.0000, 'ºC'),
	(240333, 118, '2014-03-15 00:16:20.000000', 'temperatura', 127.0000, 'ºC'),
	(240334, 118, '2014-03-15 00:16:21.000000', 'temperatura', 310.0000, 'ºC'),
	(240335, 118, '2014-03-15 00:16:22.000000', 'temperatura', 1169.0000, 'ºC'),
	(240336, 118, '2014-03-15 00:16:23.000000', 'temperatura', 118.0000, 'ºC'),
	(240337, 118, '2014-03-15 00:16:24.000000', 'temperatura', 682.0000, 'ºC'),
	(240338, 118, '2014-03-15 00:16:25.000000', 'temperatura', 658.0000, 'ºC'),
	(240339, 118, '2014-03-15 00:16:26.000000', 'temperatura', 42.0000, 'ºC'),
	(240340, 118, '2014-03-15 00:16:27.000000', 'temperatura', 639.0000, 'ºC'),
	(240341, 118, '2014-03-15 00:16:28.000000', 'temperatura', 669.0000, 'ºC'),
	(240342, 118, '2014-03-15 00:16:29.000000', 'temperatura', 230.0000, 'ºC'),
	(240343, 118, '2014-03-15 00:16:30.000000', 'temperatura', 343.0000, 'ºC'),
	(240344, 118, '2014-03-15 00:16:31.000000', 'temperatura', 1027.0000, 'ºC'),
	(240345, 118, '2014-03-15 00:16:32.000000', 'temperatura', 504.0000, 'ºC'),
	(240346, 118, '2014-03-15 00:16:33.000000', 'temperatura', 639.0000, 'ºC'),
	(240347, 118, '2014-03-15 00:16:34.000000', 'temperatura', 484.0000, 'ºC'),
	(240348, 118, '2014-03-15 00:16:35.000000', 'temperatura', 504.0000, 'ºC'),
	(240349, 118, '2014-03-15 00:16:36.000000', 'temperatura', 1069.0000, 'ºC'),
	(240350, 118, '2014-03-15 00:16:37.000000', 'temperatura', 232.0000, 'ºC'),
	(240351, 118, '2014-03-15 00:16:38.000000', 'temperatura', 354.0000, 'ºC'),
	(240352, 118, '2014-03-15 00:16:39.000000', 'temperatura', 1076.0000, 'ºC'),
	(240353, 118, '2014-03-15 00:16:40.000000', 'temperatura', 716.0000, 'ºC'),
	(240354, 118, '2014-03-15 00:16:41.000000', 'temperatura', 354.0000, 'ºC'),
	(240355, 118, '2014-03-15 00:16:42.000000', 'temperatura', 821.0000, 'ºC'),
	(240356, 118, '2014-03-15 00:16:43.000000', 'temperatura', 644.0000, 'ºC'),
	(240357, 118, '2014-03-15 00:16:44.000000', 'temperatura', 759.0000, 'ºC'),
	(240358, 118, '2014-03-15 00:16:45.000000', 'temperatura', 662.0000, 'ºC'),
	(240359, 118, '2014-03-15 00:16:46.000000', 'temperatura', 1032.0000, 'ºC'),
	(240360, 118, '2014-03-15 00:16:47.000000', 'temperatura', 776.0000, 'ºC'),
	(240361, 118, '2014-03-15 00:16:48.000000', 'temperatura', 783.0000, 'ºC'),
	(240362, 118, '2014-03-15 00:16:49.000000', 'temperatura', 387.0000, 'ºC'),
	(240363, 118, '2014-03-15 00:16:50.000000', 'temperatura', 788.0000, 'ºC'),
	(240364, 118, '2014-03-15 00:16:51.000000', 'temperatura', 379.0000, 'ºC'),
	(240365, 118, '2014-03-15 00:16:52.000000', 'temperatura', 733.0000, 'ºC'),
	(240366, 118, '2014-03-15 00:16:53.000000', 'temperatura', 128.0000, 'ºC'),
	(240367, 118, '2014-03-15 00:16:54.000000', 'temperatura', 840.0000, 'ºC'),
	(240368, 118, '2014-03-15 00:16:55.000000', 'temperatura', 216.0000, 'ºC'),
	(240369, 118, '2014-03-15 00:16:56.000000', 'temperatura', 961.0000, 'ºC'),
	(240370, 118, '2014-03-15 00:16:57.000000', 'temperatura', 558.0000, 'ºC'),
	(240371, 118, '2014-03-15 00:16:58.000000', 'temperatura', 1106.0000, 'ºC'),
	(240372, 118, '2014-03-15 00:16:59.000000', 'temperatura', 256.0000, 'ºC'),
	(240373, 118, '2014-03-15 00:17:00.000000', 'temperatura', 363.0000, 'ºC'),
	(240374, 118, '2014-03-15 00:17:01.000000', 'temperatura', 1046.0000, 'ºC'),
	(240375, 118, '2014-03-15 00:17:02.000000', 'temperatura', 545.0000, 'ºC'),
	(240376, 118, '2014-03-15 00:17:03.000000', 'temperatura', 785.0000, 'ºC'),
	(240377, 118, '2014-03-15 00:17:04.000000', 'temperatura', 1092.0000, 'ºC'),
	(240378, 118, '2014-03-15 00:17:05.000000', 'temperatura', 707.0000, 'ºC'),
	(240379, 118, '2014-03-15 00:17:06.000000', 'temperatura', 256.0000, 'ºC'),
	(240380, 118, '2014-03-15 00:17:07.000000', 'temperatura', 363.0000, 'ºC'),
	(240381, 118, '2014-03-15 00:17:08.000000', 'temperatura', 1046.0000, 'ºC'),
	(240382, 118, '2014-03-15 00:17:09.000000', 'temperatura', 543.0000, 'ºC'),
	(240383, 118, '2014-03-15 00:17:10.000000', 'temperatura', 777.0000, 'ºC'),
	(240384, 118, '2014-03-15 00:17:11.000000', 'temperatura', 1057.0000, 'ºC'),
	(240385, 118, '2014-03-15 00:17:12.000000', 'temperatura', 556.0000, 'ºC'),
	(240386, 118, '2014-03-15 00:17:13.000000', 'temperatura', 807.0000, 'ºC'),
	(240387, 118, '2014-03-15 00:17:14.000000', 'temperatura', 1166.0000, 'ºC'),
	(240388, 118, '2014-03-15 00:17:15.000000', 'temperatura', 1011.0000, 'ºC'),
	(240389, 118, '2014-03-15 00:17:16.000000', 'temperatura', 360.0000, 'ºC'),
	(240390, 118, '2014-03-15 00:17:17.000000', 'temperatura', 1164.0000, 'ºC'),
	(240391, 118, '2014-03-15 00:17:18.000000', 'temperatura', 1144.0000, 'ºC'),
	(240392, 118, '2014-03-15 00:17:19.000000', 'temperatura', 1025.0000, 'ºC'),
	(240393, 118, '2014-03-15 00:17:20.000000', 'temperatura', 494.0000, 'ºC'),
	(240394, 118, '2014-03-15 00:17:21.000000', 'temperatura', 598.0000, 'ºC'),
	(240395, 118, '2014-03-15 00:17:22.000000', 'temperatura', 308.0000, 'ºC'),
	(240396, 118, '2014-03-15 00:17:23.000000', 'temperatura', 944.0000, 'ºC'),
	(240397, 118, '2014-03-15 00:17:24.000000', 'temperatura', 197.0000, 'ºC'),
	(240398, 118, '2014-03-15 00:17:25.000000', 'temperatura', 554.0000, 'ºC'),
	(240399, 118, '2014-03-15 00:17:26.000000', 'temperatura', 981.0000, 'ºC'),
	(240400, 118, '2014-03-15 00:17:27.000000', 'temperatura', 843.0000, 'ºC'),
	(240401, 118, '2014-03-15 00:17:28.000000', 'temperatura', 73.0000, 'ºC'),
	(240402, 118, '2014-03-15 00:17:29.000000', 'temperatura', 234.0000, 'ºC'),
	(240403, 118, '2014-03-15 00:17:30.000000', 'temperatura', 954.0000, 'ºC'),
	(240404, 118, '2014-03-15 00:17:31.000000', 'temperatura', 468.0000, 'ºC'),
	(240405, 118, '2014-03-15 00:17:32.000000', 'temperatura', 678.0000, 'ºC'),
	(240406, 118, '2014-03-15 00:17:33.000000', 'temperatura', 786.0000, 'ºC'),
	(240407, 118, '2014-03-15 00:17:34.000000', 'temperatura', 699.0000, 'ºC'),
	(240408, 118, '2014-03-15 00:17:35.000000', 'temperatura', 1135.0000, 'ºC'),
	(240409, 118, '2014-03-15 00:17:36.000000', 'temperatura', 1181.0000, 'ºC'),
	(240410, 118, '2014-03-15 00:17:37.000000', 'temperatura', 101.0000, 'ºC'),
	(240411, 118, '2014-03-15 00:17:38.000000', 'temperatura', 559.0000, 'ºC'),
	(240412, 118, '2014-03-15 00:17:39.000000', 'temperatura', 95.0000, 'ºC'),
	(240413, 118, '2014-03-15 00:17:40.000000', 'temperatura', 1198.0000, 'ºC'),
	(240414, 118, '2014-03-15 00:17:41.000000', 'temperatura', 906.0000, 'ºC'),
	(240415, 118, '2014-03-15 00:17:42.000000', 'temperatura', 935.0000, 'ºC'),
	(240416, 118, '2014-03-15 00:17:43.000000', 'temperatura', 757.0000, 'ºC'),
	(240417, 118, '2014-03-15 00:17:44.000000', 'temperatura', 982.0000, 'ºC'),
	(240418, 118, '2014-03-15 00:17:45.000000', 'temperatura', 238.0000, 'ºC'),
	(240419, 118, '2014-03-15 00:17:46.000000', 'temperatura', 645.0000, 'ºC'),
	(240420, 118, '2014-03-15 00:17:47.000000', 'temperatura', 112.0000, 'ºC'),
	(240421, 118, '2014-03-15 00:17:48.000000', 'temperatura', 1024.0000, 'ºC'),
	(240422, 118, '2014-03-15 00:17:49.000000', 'temperatura', 1187.0000, 'ºC'),
	(240423, 118, '2014-03-15 00:17:50.000000', 'temperatura', 461.0000, 'ºC'),
	(240424, 118, '2014-03-15 00:17:51.000000', 'temperatura', 1144.0000, 'ºC'),
	(240425, 118, '2014-03-15 00:17:52.000000', 'temperatura', 741.0000, 'ºC'),
	(240426, 118, '2014-03-15 00:17:53.000000', 'temperatura', 270.0000, 'ºC'),
	(240427, 118, '2014-03-15 00:17:54.000000', 'temperatura', 329.0000, 'ºC'),
	(240428, 118, '2014-03-15 00:17:55.000000', 'temperatura', 836.0000, 'ºC'),
	(240429, 118, '2014-03-15 00:17:56.000000', 'temperatura', 793.0000, 'ºC'),
	(240430, 118, '2014-03-15 00:17:57.000000', 'temperatura', 259.0000, 'ºC'),
	(240431, 118, '2014-03-15 00:17:58.000000', 'temperatura', 113.0000, 'ºC'),
	(240432, 118, '2014-03-15 00:17:59.000000', 'temperatura', 992.0000, 'ºC'),
	(240433, 118, '2014-03-15 00:18:00.000000', 'temperatura', 1019.0000, 'ºC'),
	(240434, 118, '2014-03-15 00:18:01.000000', 'temperatura', 920.0000, 'ºC'),
	(240435, 118, '2014-03-15 00:18:02.000000', 'temperatura', 345.0000, 'ºC'),
	(240436, 118, '2014-03-15 00:18:03.000000', 'temperatura', 164.0000, 'ºC'),
	(240437, 118, '2014-03-15 00:18:04.000000', 'temperatura', 985.0000, 'ºC'),
	(240438, 118, '2014-03-15 00:18:05.000000', 'temperatura', 835.0000, 'ºC'),
	(240439, 118, '2014-03-15 00:18:06.000000', 'temperatura', 18.0000, 'ºC'),
	(240440, 118, '2014-03-15 00:18:07.000000', 'temperatura', 1186.0000, 'ºC'),
	(240441, 118, '2014-03-15 00:18:08.000000', 'temperatura', 1078.0000, 'ºC'),
	(240442, 118, '2014-03-15 00:18:09.000000', 'temperatura', 633.0000, 'ºC'),
	(240443, 118, '2014-03-15 00:18:10.000000', 'temperatura', 1132.0000, 'ºC'),
	(240444, 118, '2014-03-15 00:18:11.000000', 'temperatura', 159.0000, 'ºC'),
	(240445, 118, '2014-03-15 00:18:12.000000', 'temperatura', 1000.0000, 'ºC'),
	(240446, 118, '2014-03-15 00:18:13.000000', 'temperatura', 923.0000, 'ºC'),
	(240447, 118, '2014-03-15 00:18:14.000000', 'temperatura', 414.0000, 'ºC'),
	(240448, 118, '2014-03-15 00:18:15.000000', 'temperatura', 505.0000, 'ºC'),
	(240449, 118, '2014-03-15 00:18:16.000000', 'temperatura', 82.0000, 'ºC'),
	(240450, 118, '2014-03-15 00:18:17.000000', 'temperatura', 97.0000, 'ºC'),
	(240451, 118, '2014-03-15 00:18:18.000000', 'temperatura', 238.0000, 'ºC'),
	(240452, 118, '2014-03-15 00:18:19.000000', 'temperatura', 900.0000, 'ºC'),
	(240453, 118, '2014-03-15 00:18:20.000000', 'temperatura', 187.0000, 'ºC'),
	(240454, 118, '2014-03-15 00:18:21.000000', 'temperatura', 636.0000, 'ºC'),
	(240455, 118, '2014-03-15 00:18:22.000000', 'temperatura', 219.0000, 'ºC'),
	(240456, 118, '2014-03-15 00:18:23.000000', 'temperatura', 389.0000, 'ºC'),
	(240457, 118, '2014-03-15 00:18:24.000000', 'temperatura', 88.0000, 'ºC'),
	(240458, 118, '2014-03-15 00:18:25.000000', 'temperatura', 475.0000, 'ºC'),
	(240459, 118, '2014-03-15 00:18:26.000000', 'temperatura', 908.0000, 'ºC'),
	(240460, 118, '2014-03-15 00:18:27.000000', 'temperatura', 719.0000, 'ºC'),
	(240461, 118, '2014-03-15 00:18:28.000000', 'temperatura', 869.0000, 'ºC'),
	(240462, 118, '2014-03-15 00:18:29.000000', 'temperatura', 991.0000, 'ºC'),
	(240463, 118, '2014-03-15 00:18:30.000000', 'temperatura', 1147.0000, 'ºC'),
	(240464, 118, '2014-03-15 00:18:31.000000', 'temperatura', 363.0000, 'ºC'),
	(240465, 118, '2014-03-15 00:18:32.000000', 'temperatura', 774.0000, 'ºC'),
	(240466, 118, '2014-03-15 00:18:33.000000', 'temperatura', 382.0000, 'ºC'),
	(240467, 118, '2014-03-15 00:18:34.000000', 'temperatura', 788.0000, 'ºC'),
	(240468, 118, '2014-03-15 00:18:35.000000', 'temperatura', 395.0000, 'ºC'),
	(240469, 118, '2014-03-15 00:18:36.000000', 'temperatura', 811.0000, 'ºC'),
	(240470, 118, '2014-03-15 00:18:37.000000', 'temperatura', 473.0000, 'ºC'),
	(240471, 118, '2014-03-15 00:18:38.000000', 'temperatura', 1130.0000, 'ºC'),
	(240472, 118, '2014-03-15 00:18:39.000000', 'temperatura', 631.0000, 'ºC'),
	(240473, 118, '2014-03-15 00:18:40.000000', 'temperatura', 968.0000, 'ºC'),
	(240474, 118, '2014-03-15 00:18:41.000000', 'temperatura', 547.0000, 'ºC'),
	(240475, 118, '2014-03-15 00:18:42.000000', 'temperatura', 1029.0000, 'ºC'),
	(240476, 118, '2014-03-15 00:18:43.000000', 'temperatura', 1106.0000, 'ºC'),
	(240477, 118, '2014-03-15 00:18:44.000000', 'temperatura', 43.0000, 'ºC'),
	(240478, 118, '2014-03-15 00:18:45.000000', 'temperatura', 497.0000, 'ºC'),
	(240479, 118, '2014-03-15 00:18:46.000000', 'temperatura', 1157.0000, 'ºC'),
	(240480, 118, '2014-03-15 00:18:47.000000', 'temperatura', 693.0000, 'ºC'),
	(240481, 118, '2014-03-15 00:18:48.000000', 'temperatura', 1195.0000, 'ºC'),
	(240482, 118, '2014-03-15 00:18:49.000000', 'temperatura', 297.0000, 'ºC'),
	(240483, 118, '2014-03-15 00:18:50.000000', 'temperatura', 299.0000, 'ºC'),
	(240484, 118, '2014-03-15 00:18:51.000000', 'temperatura', 606.0000, 'ºC'),
	(240485, 118, '2014-03-15 00:18:52.000000', 'temperatura', 933.0000, 'ºC'),
	(240486, 118, '2014-03-15 00:18:53.000000', 'temperatura', 449.0000, 'ºC'),
	(240487, 118, '2014-03-15 00:18:54.000000', 'temperatura', 647.0000, 'ºC'),
	(240488, 118, '2014-03-15 00:18:55.000000', 'temperatura', 687.0000, 'ºC'),
	(240489, 118, '2014-03-15 00:18:56.000000', 'temperatura', 296.0000, 'ºC'),
	(240490, 118, '2014-03-15 00:18:57.000000', 'temperatura', 619.0000, 'ºC'),
	(240491, 118, '2014-03-15 00:18:58.000000', 'temperatura', 1009.0000, 'ºC'),
	(240492, 118, '2014-03-15 00:18:59.000000', 'temperatura', 787.0000, 'ºC'),
	(240493, 118, '2014-03-15 00:19:00.000000', 'temperatura', 910.0000, 'ºC'),
	(240494, 118, '2014-03-15 00:19:01.000000', 'temperatura', 988.0000, 'ºC'),
	(240495, 118, '2014-03-15 00:19:02.000000', 'temperatura', 1010.0000, 'ºC'),
	(240496, 118, '2014-03-15 00:19:03.000000', 'temperatura', 885.0000, 'ºC'),
	(240497, 118, '2014-03-15 00:19:04.000000', 'temperatura', 198.0000, 'ºC'),
	(240498, 118, '2014-03-15 00:19:05.000000', 'temperatura', 736.0000, 'ºC'),
	(240499, 118, '2014-03-15 00:19:06.000000', 'temperatura', 687.0000, 'ºC'),
	(240500, 118, '2014-03-15 00:19:07.000000', 'temperatura', 28.0000, 'ºC'),
	(240501, 118, '2014-03-15 00:19:08.000000', 'temperatura', 480.0000, 'ºC'),
	(240502, 118, '2014-03-15 00:19:09.000000', 'temperatura', 1114.0000, 'ºC'),
	(240503, 118, '2014-03-15 00:19:10.000000', 'temperatura', 533.0000, 'ºC'),
	(240504, 118, '2014-03-15 00:19:11.000000', 'temperatura', 523.0000, 'ºC'),
	(240505, 118, '2014-03-15 00:19:12.000000', 'temperatura', 1018.0000, 'ºC'),
	(240506, 118, '2014-03-15 00:19:13.000000', 'temperatura', 1120.0000, 'ºC'),
	(240507, 118, '2014-03-15 00:19:14.000000', 'temperatura', 149.0000, 'ºC'),
	(240508, 118, '2014-03-15 00:19:15.000000', 'temperatura', 982.0000, 'ºC'),
	(240509, 118, '2014-03-15 00:19:16.000000', 'temperatura', 864.0000, 'ºC'),
	(240510, 118, '2014-03-15 00:19:17.000000', 'temperatura', 174.0000, 'ºC'),
	(240511, 118, '2014-03-15 00:19:18.000000', 'temperatura', 678.0000, 'ºC'),
	(240512, 118, '2014-03-15 00:19:19.000000', 'temperatura', 469.0000, 'ºC'),
	(240513, 118, '2014-03-15 00:19:20.000000', 'temperatura', 314.0000, 'ºC'),
	(240514, 118, '2014-03-15 00:19:21.000000', 'temperatura', 160.0000, 'ºC'),
	(240515, 118, '2014-03-15 00:19:22.000000', 'temperatura', 1060.0000, 'ºC'),
	(240516, 118, '2014-03-15 00:19:23.000000', 'temperatura', 21.0000, 'ºC'),
	(240517, 118, '2014-03-15 00:19:24.000000', 'temperatura', 524.0000, 'ºC'),
	(240518, 118, '2014-03-15 00:19:25.000000', 'temperatura', 159.0000, 'ºC'),
	(240519, 118, '2014-03-15 00:19:26.000000', 'temperatura', 424.0000, 'ºC'),
	(240520, 118, '2014-03-15 00:19:27.000000', 'temperatura', 441.0000, 'ºC'),
	(240521, 118, '2014-03-15 00:19:28.000000', 'temperatura', 936.0000, 'ºC'),
	(240522, 118, '2014-03-15 00:19:29.000000', 'temperatura', 958.0000, 'ºC'),
	(240523, 118, '2014-03-15 00:19:30.000000', 'temperatura', 781.0000, 'ºC'),
	(240524, 118, '2014-03-15 00:19:31.000000', 'temperatura', 1031.0000, 'ºC'),
	(240525, 118, '2014-03-15 00:19:32.000000', 'temperatura', 411.0000, 'ºC'),
	(240526, 118, '2014-03-15 00:19:33.000000', 'temperatura', 164.0000, 'ºC'),
	(240527, 118, '2014-03-15 00:19:34.000000', 'temperatura', 787.0000, 'ºC'),
	(240528, 118, '2014-03-15 00:19:35.000000', 'temperatura', 1046.0000, 'ºC'),
	(240529, 118, '2014-03-15 00:19:36.000000', 'temperatura', 466.0000, 'ºC'),
	(240530, 118, '2014-03-15 00:19:37.000000', 'temperatura', 394.0000, 'ºC'),
	(240531, 118, '2014-03-15 00:19:38.000000', 'temperatura', 572.0000, 'ºC'),
	(240532, 118, '2014-03-15 00:19:39.000000', 'temperatura', 480.0000, 'ºC'),
	(240533, 118, '2014-03-15 00:19:40.000000', 'temperatura', 682.0000, 'ºC'),
	(240534, 118, '2014-03-15 00:19:41.000000', 'temperatura', 772.0000, 'ºC'),
	(240535, 118, '2014-03-15 00:19:42.000000', 'temperatura', 616.0000, 'ºC'),
	(240536, 118, '2014-03-15 00:19:43.000000', 'temperatura', 762.0000, 'ºC'),
	(240537, 118, '2014-03-15 00:19:44.000000', 'temperatura', 764.0000, 'ºC'),
	(240538, 118, '2014-03-15 00:19:45.000000', 'temperatura', 332.0000, 'ºC'),
	(240539, 118, '2014-03-15 00:19:46.000000', 'temperatura', 572.0000, 'ºC'),
	(240540, 118, '2014-03-15 00:19:47.000000', 'temperatura', 662.0000, 'ºC'),
	(240541, 118, '2014-03-15 00:19:48.000000', 'temperatura', 395.0000, 'ºC'),
	(240542, 118, '2014-03-15 00:19:49.000000', 'temperatura', 1191.0000, 'ºC'),
	(240543, 118, '2014-03-15 00:19:50.000000', 'temperatura', 1170.0000, 'ºC'),
	(240544, 118, '2014-03-15 00:19:51.000000', 'temperatura', 1077.0000, 'ºC'),
	(240545, 118, '2014-03-15 00:19:52.000000', 'temperatura', 677.0000, 'ºC'),
	(240546, 118, '2014-03-15 00:19:53.000000', 'temperatura', 155.0000, 'ºC'),
	(240547, 118, '2014-03-15 00:19:54.000000', 'temperatura', 1144.0000, 'ºC'),
	(240548, 118, '2014-03-15 00:19:55.000000', 'temperatura', 453.0000, 'ºC'),
	(240549, 118, '2014-03-15 00:19:56.000000', 'temperatura', 35.0000, 'ºC'),
	(240550, 118, '2014-03-15 00:19:57.000000', 'temperatura', 17.0000, 'ºC'),
	(240551, 118, '2014-03-15 00:19:58.000000', 'temperatura', 1180.0000, 'ºC'),
	(240552, 118, '2014-03-15 00:19:59.000000', 'temperatura', 1051.0000, 'ºC'),
	(240553, 118, '2014-03-15 00:20:00.000000', 'temperatura', 515.0000, 'ºC'),
	(240554, 118, '2014-03-15 00:20:01.000000', 'temperatura', 621.0000, 'ºC'),
	(240555, 118, '2014-03-15 00:20:02.000000', 'temperatura', 360.0000, 'ºC'),
	(240556, 118, '2014-03-15 00:20:03.000000', 'temperatura', 1137.0000, 'ºC'),
	(240557, 118, '2014-03-15 00:20:04.000000', 'temperatura', 1005.0000, 'ºC'),
	(240558, 118, '2014-03-15 00:20:05.000000', 'temperatura', 414.0000, 'ºC'),
	(240559, 118, '2014-03-15 00:20:06.000000', 'temperatura', 258.0000, 'ºC'),
	(240560, 118, '2014-03-15 00:20:07.000000', 'temperatura', 47.0000, 'ºC'),
	(240561, 118, '2014-03-15 00:20:08.000000', 'temperatura', 662.0000, 'ºC'),
	(240562, 118, '2014-03-15 00:20:09.000000', 'temperatura', 772.0000, 'ºC'),
	(240563, 118, '2014-03-15 00:20:10.000000', 'temperatura', 671.0000, 'ºC'),
	(240564, 118, '2014-03-15 00:20:11.000000', 'temperatura', 1039.0000, 'ºC'),
	(240565, 118, '2014-03-15 00:20:12.000000', 'temperatura', 783.0000, 'ºC'),
	(240566, 118, '2014-03-15 00:20:13.000000', 'temperatura', 799.0000, 'ºC'),
	(240567, 118, '2014-03-15 00:20:14.000000', 'temperatura', 447.0000, 'ºC'),
	(240568, 118, '2014-03-15 00:20:15.000000', 'temperatura', 1038.0000, 'ºC'),
	(240569, 118, '2014-03-15 00:20:16.000000', 'temperatura', 250.0000, 'ºC'),
	(240570, 118, '2014-03-15 00:20:17.000000', 'temperatura', 534.0000, 'ºC'),
	(240571, 118, '2014-03-15 00:20:18.000000', 'temperatura', 723.0000, 'ºC'),
	(240572, 118, '2014-03-15 00:20:19.000000', 'temperatura', 811.0000, 'ºC'),
	(240573, 118, '2014-03-15 00:20:20.000000', 'temperatura', 689.0000, 'ºC'),
	(240574, 118, '2014-03-15 00:20:21.000000', 'temperatura', 1011.0000, 'ºC'),
	(240575, 118, '2014-03-15 00:20:22.000000', 'temperatura', 591.0000, 'ºC'),
	(240576, 118, '2014-03-15 00:20:23.000000', 'temperatura', 1119.0000, 'ºC'),
	(240577, 118, '2014-03-15 00:20:24.000000', 'temperatura', 224.0000, 'ºC'),
	(240578, 118, '2014-03-15 00:20:25.000000', 'temperatura', 165.0000, 'ºC'),
	(240579, 118, '2014-03-15 00:20:26.000000', 'temperatura', 152.0000, 'ºC'),
	(240580, 118, '2014-03-15 00:20:27.000000', 'temperatura', 264.0000, 'ºC'),
	(240581, 118, '2014-03-15 00:20:28.000000', 'temperatura', 866.0000, 'ºC'),
	(240582, 118, '2014-03-15 00:20:29.000000', 'temperatura', 1138.0000, 'ºC'),
	(240583, 118, '2014-03-15 00:20:30.000000', 'temperatura', 691.0000, 'ºC'),
	(240584, 118, '2014-03-15 00:20:31.000000', 'temperatura', 41.0000, 'ºC'),
	(240585, 118, '2014-03-15 00:20:32.000000', 'temperatura', 533.0000, 'ºC'),
	(240586, 118, '2014-03-15 00:20:33.000000', 'temperatura', 145.0000, 'ºC'),
	(240587, 118, '2014-03-15 00:20:34.000000', 'temperatura', 326.0000, 'ºC'),
	(240588, 118, '2014-03-15 00:20:35.000000', 'temperatura', 1193.0000, 'ºC'),
	(240589, 118, '2014-03-15 00:20:36.000000', 'temperatura', 190.0000, 'ºC'),
	(240590, 118, '2014-03-15 00:20:37.000000', 'temperatura', 971.0000, 'ºC'),
	(240591, 118, '2014-03-15 00:20:38.000000', 'temperatura', 684.0000, 'ºC'),
	(240592, 118, '2014-03-15 00:20:39.000000', 'temperatura', 510.0000, 'ºC'),
	(240593, 118, '2014-03-15 00:20:40.000000', 'temperatura', 498.0000, 'ºC'),
	(240594, 118, '2014-03-15 00:20:41.000000', 'temperatura', 961.0000, 'ºC'),
	(240595, 118, '2014-03-15 00:20:42.000000', 'temperatura', 913.0000, 'ºC'),
	(240596, 118, '2014-03-15 00:20:43.000000', 'temperatura', 480.0000, 'ºC'),
	(240597, 118, '2014-03-15 00:20:44.000000', 'temperatura', 863.0000, 'ºC'),
	(240598, 118, '2014-03-15 00:20:45.000000', 'temperatura', 474.0000, 'ºC'),
	(240599, 118, '2014-03-15 00:20:46.000000', 'temperatura', 980.0000, 'ºC'),
	(240600, 118, '2014-03-15 00:20:47.000000', 'temperatura', 1080.0000, 'ºC'),
	(240601, 118, '2014-03-15 00:20:48.000000', 'temperatura', 61.0000, 'ºC'),
	(240602, 118, '2014-03-15 00:20:49.000000', 'temperatura', 663.0000, 'ºC'),
	(240603, 118, '2014-03-15 00:20:50.000000', 'temperatura', 736.0000, 'ºC'),
	(240604, 118, '2014-03-15 00:20:51.000000', 'temperatura', 489.0000, 'ºC'),
	(240605, 118, '2014-03-15 00:20:52.000000', 'temperatura', 237.0000, 'ºC'),
	(240606, 118, '2014-03-15 00:20:53.000000', 'temperatura', 921.0000, 'ºC'),
	(240607, 118, '2014-03-15 00:20:54.000000', 'temperatura', 291.0000, 'ºC'),
	(240608, 118, '2014-03-15 00:20:55.000000', 'temperatura', 1096.0000, 'ºC'),
	(240609, 118, '2014-03-15 00:20:56.000000', 'temperatura', 1007.0000, 'ºC'),
	(240610, 118, '2014-03-15 00:20:57.000000', 'temperatura', 546.0000, 'ºC'),
	(240611, 118, '2014-03-15 00:20:58.000000', 'temperatura', 912.0000, 'ºC'),
	(240612, 118, '2014-03-15 00:20:59.000000', 'temperatura', 521.0000, 'ºC'),
	(240613, 118, '2014-03-15 00:21:00.000000', 'temperatura', 1071.0000, 'ºC'),
	(240614, 118, '2014-03-15 00:21:01.000000', 'temperatura', 190.0000, 'ºC'),
	(240615, 118, '2014-03-15 00:21:02.000000', 'temperatura', 140.0000, 'ºC'),
	(240616, 118, '2014-03-15 00:21:03.000000', 'temperatura', 130.0000, 'ºC'),
	(240617, 118, '2014-03-15 00:21:04.000000', 'temperatura', 231.0000, 'ºC'),
	(240618, 118, '2014-03-15 00:21:05.000000', 'temperatura', 766.0000, 'ºC'),
	(240619, 118, '2014-03-15 00:21:06.000000', 'temperatura', 738.0000, 'ºC'),
	(240620, 118, '2014-03-15 00:21:07.000000', 'temperatura', 190.0000, 'ºC'),
	(240621, 118, '2014-03-15 00:21:08.000000', 'temperatura', 1137.0000, 'ºC'),
	(240622, 118, '2014-03-15 00:21:09.000000', 'temperatura', 318.0000, 'ºC'),
	(240623, 118, '2014-03-15 00:21:10.000000', 'temperatura', 578.0000, 'ºC'),
	(240624, 118, '2014-03-15 00:21:11.000000', 'temperatura', 736.0000, 'ºC'),
	(240625, 118, '2014-03-15 00:21:12.000000', 'temperatura', 748.0000, 'ºC'),
	(240626, 118, '2014-03-15 00:21:13.000000', 'temperatura', 331.0000, 'ºC'),
	(240627, 118, '2014-03-15 00:21:14.000000', 'temperatura', 611.0000, 'ºC'),
	(240628, 118, '2014-03-15 00:21:15.000000', 'temperatura', 864.0000, 'ºC'),
	(240629, 118, '2014-03-15 00:21:16.000000', 'temperatura', 89.0000, 'ºC'),
	(240630, 118, '2014-03-15 00:21:17.000000', 'temperatura', 251.0000, 'ºC'),
	(240631, 118, '2014-03-15 00:21:18.000000', 'temperatura', 988.0000, 'ºC'),
	(240632, 118, '2014-03-15 00:21:19.000000', 'temperatura', 587.0000, 'ºC'),
	(240633, 118, '2014-03-15 00:21:20.000000', 'temperatura', 1170.0000, 'ºC'),
	(240634, 118, '2014-03-15 00:21:21.000000', 'temperatura', 493.0000, 'ºC'),
	(240635, 118, '2014-03-15 00:21:22.000000', 'temperatura', 154.0000, 'ºC'),
	(240636, 118, '2014-03-15 00:21:23.000000', 'temperatura', 492.0000, 'ºC'),
	(240637, 118, '2014-03-15 00:21:24.000000', 'temperatura', 797.0000, 'ºC'),
	(240638, 118, '2014-03-15 00:21:25.000000', 'temperatura', 112.0000, 'ºC'),
	(240639, 118, '2014-03-15 00:21:26.000000', 'temperatura', 567.0000, 'ºC'),
	(240640, 118, '2014-03-15 00:21:27.000000', 'temperatura', 100.0000, 'ºC'),
	(240641, 118, '2014-03-15 00:21:28.000000', 'temperatura', 2.0000, 'ºC'),
	(240642, 118, '2014-03-15 00:21:29.000000', 'temperatura', 908.0000, 'ºC'),
	(240643, 118, '2014-03-15 00:21:30.000000', 'temperatura', 936.0000, 'ºC'),
	(240644, 118, '2014-03-15 00:21:31.000000', 'temperatura', 755.0000, 'ºC'),
	(240645, 118, '2014-03-15 00:21:32.000000', 'temperatura', 968.0000, 'ºC'),
	(240646, 118, '2014-03-15 00:21:33.000000', 'temperatura', 176.0000, 'ºC'),
	(240647, 118, '2014-03-15 00:21:34.000000', 'temperatura', 374.0000, 'ºC'),
	(240648, 118, '2014-03-15 00:21:35.000000', 'temperatura', 145.0000, 'ºC'),
	(240649, 118, '2014-03-15 00:21:36.000000', 'temperatura', 804.0000, 'ºC'),
	(240650, 118, '2014-03-15 00:21:37.000000', 'temperatura', 1185.0000, 'ºC'),
	(240651, 118, '2014-03-15 00:21:38.000000', 'temperatura', 1114.0000, 'ºC'),
	(240652, 118, '2014-03-15 00:21:39.000000', 'temperatura', 815.0000, 'ºC'),
	(240653, 118, '2014-03-15 00:21:40.000000', 'temperatura', 733.0000, 'ºC'),
	(240654, 118, '2014-03-15 00:21:41.000000', 'temperatura', 22.0000, 'ºC'),
	(240655, 118, '2014-03-15 00:21:42.000000', 'temperatura', 310.0000, 'ºC'),
	(240656, 118, '2014-03-15 00:21:43.000000', 'temperatura', 284.0000, 'ºC'),
	(240657, 118, '2014-03-15 00:21:44.000000', 'temperatura', 489.0000, 'ºC'),
	(240658, 118, '2014-03-15 00:21:45.000000', 'temperatura', 397.0000, 'ºC'),
	(240659, 118, '2014-03-15 00:21:46.000000', 'temperatura', 516.0000, 'ºC'),
	(240660, 118, '2014-03-15 00:21:47.000000', 'temperatura', 188.0000, 'ºC'),
	(240661, 118, '2014-03-15 00:21:48.000000', 'temperatura', 595.0000, 'ºC'),
	(240662, 118, '2014-03-15 00:21:49.000000', 'temperatura', 11.0000, 'ºC'),
	(240663, 118, '2014-03-15 00:21:50.000000', 'temperatura', 671.0000, 'ºC'),
	(240664, 118, '2014-03-15 00:21:51.000000', 'temperatura', 924.0000, 'ºC'),
	(240665, 118, '2014-03-15 00:21:52.000000', 'temperatura', 206.0000, 'ºC'),
	(240666, 118, '2014-03-15 00:21:53.000000', 'temperatura', 657.0000, 'ºC'),
	(240667, 118, '2014-03-15 00:21:54.000000', 'temperatura', 269.0000, 'ºC'),
	(240668, 118, '2014-03-15 00:21:55.000000', 'temperatura', 573.0000, 'ºC'),
	(240669, 118, '2014-03-15 00:21:56.000000', 'temperatura', 859.0000, 'ºC'),
	(240670, 118, '2014-03-15 00:21:57.000000', 'temperatura', 177.0000, 'ºC'),
	(240671, 118, '2014-03-15 00:21:58.000000', 'temperatura', 708.0000, 'ºC'),
	(240672, 118, '2014-03-15 00:21:59.000000', 'temperatura', 609.0000, 'ºC'),
	(240673, 118, '2014-03-15 00:22:00.000000', 'temperatura', 923.0000, 'ºC'),
	(240674, 118, '2014-03-15 00:22:01.000000', 'temperatura', 389.0000, 'ºC'),
	(240675, 118, '2014-03-15 00:22:02.000000', 'temperatura', 377.0000, 'ºC'),
	(240676, 118, '2014-03-15 00:22:03.000000', 'temperatura', 717.0000, 'ºC'),
	(240677, 118, '2014-03-15 00:22:04.000000', 'temperatura', 54.0000, 'ºC'),
	(240678, 118, '2014-03-15 00:22:05.000000', 'temperatura', 521.0000, 'ºC'),
	(240679, 118, '2014-03-15 00:22:06.000000', 'temperatura', 43.0000, 'ºC'),
	(240680, 118, '2014-03-15 00:22:07.000000', 'temperatura', 1052.0000, 'ºC'),
	(240681, 118, '2014-03-15 00:22:08.000000', 'temperatura', 334.0000, 'ºC'),
	(240682, 118, '2014-03-15 00:22:09.000000', 'temperatura', 912.0000, 'ºC'),
	(240683, 118, '2014-03-15 00:22:10.000000', 'temperatura', 1158.0000, 'ºC'),
	(240684, 118, '2014-03-15 00:22:11.000000', 'temperatura', 654.0000, 'ºC'),
	(240685, 118, '2014-03-15 00:22:12.000000', 'temperatura', 997.0000, 'ºC'),
	(240686, 118, '2014-03-15 00:22:13.000000', 'temperatura', 623.0000, 'ºC'),
	(240687, 118, '2014-03-15 00:22:14.000000', 'temperatura', 127.0000, 'ºC'),
	(240688, 118, '2014-03-15 00:22:15.000000', 'temperatura', 1164.0000, 'ºC'),
	(240689, 118, '2014-03-15 00:22:16.000000', 'temperatura', 640.0000, 'ºC'),
	(240690, 118, '2014-03-15 00:22:17.000000', 'temperatura', 907.0000, 'ºC'),
	(240691, 118, '2014-03-15 00:22:18.000000', 'temperatura', 219.0000, 'ºC'),
	(240692, 118, '2014-03-15 00:22:19.000000', 'temperatura', 772.0000, 'ºC'),
	(240693, 118, '2014-03-15 00:22:20.000000', 'temperatura', 804.0000, 'ºC'),
	(240694, 118, '2014-03-15 00:22:21.000000', 'temperatura', 503.0000, 'ºC'),
	(240695, 118, '2014-03-15 00:22:22.000000', 'temperatura', 105.0000, 'ºC'),
	(240696, 118, '2014-03-15 00:22:23.000000', 'temperatura', 214.0000, 'ºC'),
	(240697, 118, '2014-03-15 00:22:24.000000', 'temperatura', 759.0000, 'ºC'),
	(240698, 118, '2014-03-15 00:22:25.000000', 'temperatura', 751.0000, 'ºC'),
	(240699, 118, '2014-03-15 00:22:26.000000', 'temperatura', 277.0000, 'ºC'),
	(240700, 118, '2014-03-15 00:22:27.000000', 'temperatura', 335.0000, 'ºC'),
	(240701, 118, '2014-03-15 00:22:28.000000', 'temperatura', 845.0000, 'ºC'),
	(240702, 118, '2014-03-15 00:22:29.000000', 'temperatura', 821.0000, 'ºC'),
	(240703, 118, '2014-03-15 00:22:30.000000', 'temperatura', 368.0000, 'ºC'),
	(240704, 118, '2014-03-15 00:22:31.000000', 'temperatura', 577.0000, 'ºC'),
	(240705, 118, '2014-03-15 00:22:32.000000', 'temperatura', 584.0000, 'ºC'),
	(240706, 118, '2014-03-15 00:22:33.000000', 'temperatura', 1187.0000, 'ºC'),
	(240707, 118, '2014-03-15 00:22:34.000000', 'temperatura', 586.0000, 'ºC'),
	(240708, 118, '2014-03-15 00:22:35.000000', 'temperatura', 570.0000, 'ºC'),
	(240709, 118, '2014-03-15 00:22:36.000000', 'temperatura', 1090.0000, 'ºC'),
	(240710, 118, '2014-03-15 00:22:37.000000', 'temperatura', 144.0000, 'ºC'),
	(240711, 118, '2014-03-15 00:22:38.000000', 'temperatura', 1047.0000, 'ºC'),
	(240712, 118, '2014-03-15 00:22:39.000000', 'temperatura', 4.0000, 'ºC'),
	(240713, 118, '2014-03-15 00:22:40.000000', 'temperatura', 482.0000, 'ºC'),
	(240714, 118, '2014-03-15 00:22:41.000000', 'temperatura', 1197.0000, 'ºC'),
	(240715, 118, '2014-03-15 00:22:42.000000', 'temperatura', 939.0000, 'ºC'),
	(240716, 118, '2014-03-15 00:22:43.000000', 'temperatura', 1107.0000, 'ºC'),
	(240717, 118, '2014-03-15 00:22:44.000000', 'temperatura', 317.0000, 'ºC'),
	(240718, 118, '2014-03-15 00:22:45.000000', 'temperatura', 664.0000, 'ºC'),
	(240719, 118, '2014-03-15 00:22:46.000000', 'temperatura', 1168.0000, 'ºC'),
	(240720, 118, '2014-03-15 00:22:47.000000', 'temperatura', 249.0000, 'ºC'),
	(240721, 118, '2014-03-15 00:22:48.000000', 'temperatura', 143.0000, 'ºC'),
	(240722, 118, '2014-03-15 00:22:49.000000', 'temperatura', 1168.0000, 'ºC'),
	(240723, 118, '2014-03-15 00:22:50.000000', 'temperatura', 612.0000, 'ºC'),
	(240724, 118, '2014-03-15 00:22:51.000000', 'temperatura', 756.0000, 'ºC'),
	(240725, 118, '2014-03-15 00:22:52.000000', 'temperatura', 746.0000, 'ºC'),
	(240726, 118, '2014-03-15 00:22:53.000000', 'temperatura', 263.0000, 'ºC'),
	(240727, 118, '2014-03-15 00:22:54.000000', 'temperatura', 278.0000, 'ºC'),
	(240728, 118, '2014-03-15 00:22:55.000000', 'temperatura', 599.0000, 'ºC'),
	(240729, 118, '2014-03-15 00:22:56.000000', 'temperatura', 962.0000, 'ºC'),
	(240730, 118, '2014-03-15 00:22:57.000000', 'temperatura', 616.0000, 'ºC'),
	(240731, 118, '2014-03-15 00:22:58.000000', 'temperatura', 191.0000, 'ºC'),
	(240732, 118, '2014-03-15 00:22:59.000000', 'temperatura', 309.0000, 'ºC'),
	(240733, 118, '2014-03-15 00:23:00.000000', 'temperatura', 973.0000, 'ºC'),
	(240734, 118, '2014-03-15 00:23:01.000000', 'temperatura', 337.0000, 'ºC'),
	(240735, 118, '2014-03-15 00:23:02.000000', 'temperatura', 1167.0000, 'ºC'),
	(240736, 118, '2014-03-15 00:23:03.000000', 'temperatura', 25.0000, 'ºC'),
	(240737, 118, '2014-03-15 00:23:04.000000', 'temperatura', 226.0000, 'ºC'),
	(240738, 118, '2014-03-15 00:23:05.000000', 'temperatura', 1054.0000, 'ºC'),
	(240739, 118, '2014-03-15 00:23:06.000000', 'temperatura', 993.0000, 'ºC'),
	(240740, 118, '2014-03-15 00:23:07.000000', 'temperatura', 602.0000, 'ºC'),
	(240741, 118, '2014-03-15 00:23:08.000000', 'temperatura', 32.0000, 'ºC'),
	(240742, 118, '2014-03-15 00:23:09.000000', 'temperatura', 756.0000, 'ºC'),
	(240743, 118, '2014-03-15 00:23:10.000000', 'temperatura', 83.0000, 'ºC'),
	(240744, 118, '2014-03-15 00:23:11.000000', 'temperatura', 548.0000, 'ºC'),
	(240745, 118, '2014-03-15 00:23:12.000000', 'temperatura', 92.0000, 'ºC'),
	(240746, 118, '2014-03-15 00:23:13.000000', 'temperatura', 15.0000, 'ºC'),
	(240747, 118, '2014-03-15 00:23:14.000000', 'temperatura', 1001.0000, 'ºC'),
	(240748, 118, '2014-03-15 00:23:15.000000', 'temperatura', 158.0000, 'ºC'),
	(240749, 118, '2014-03-15 00:23:16.000000', 'temperatura', 189.0000, 'ºC'),
	(240750, 118, '2014-03-15 00:23:17.000000', 'temperatura', 470.0000, 'ºC'),
	(240751, 118, '2014-03-15 00:23:18.000000', 'temperatura', 584.0000, 'ºC'),
	(240752, 118, '2014-03-15 00:23:19.000000', 'temperatura', 311.0000, 'ºC'),
	(240753, 118, '2014-03-15 00:23:20.000000', 'temperatura', 1002.0000, 'ºC'),
	(240754, 118, '2014-03-15 00:23:21.000000', 'temperatura', 477.0000, 'ºC'),
	(240755, 118, '2014-03-15 00:23:22.000000', 'temperatura', 582.0000, 'ºC'),
	(240756, 118, '2014-03-15 00:23:23.000000', 'temperatura', 279.0000, 'ºC'),
	(240757, 118, '2014-03-15 00:23:24.000000', 'temperatura', 847.0000, 'ºC'),
	(240758, 118, '2014-03-15 00:23:25.000000', 'temperatura', 1002.0000, 'ºC'),
	(240759, 118, '2014-03-15 00:23:26.000000', 'temperatura', 67.0000, 'ºC'),
	(240760, 118, '2014-03-15 00:23:27.000000', 'temperatura', 931.0000, 'ºC'),
	(240761, 118, '2014-03-15 00:23:28.000000', 'temperatura', 853.0000, 'ºC'),
	(240762, 118, '2014-03-15 00:23:29.000000', 'temperatura', 273.0000, 'ºC'),
	(240763, 118, '2014-03-15 00:23:30.000000', 'temperatura', 8.0000, 'ºC'),
	(240764, 118, '2014-03-15 00:23:31.000000', 'temperatura', 419.0000, 'ºC'),
	(240765, 118, '2014-03-15 00:23:32.000000', 'temperatura', 874.0000, 'ºC'),
	(240766, 118, '2014-03-15 00:23:33.000000', 'temperatura', 711.0000, 'ºC'),
	(240767, 118, '2014-03-15 00:23:34.000000', 'temperatura', 935.0000, 'ºC'),
	(240768, 118, '2014-03-15 00:23:35.000000', 'temperatura', 141.0000, 'ºC'),
	(240769, 118, '2014-03-15 00:23:36.000000', 'temperatura', 300.0000, 'ºC'),
	(240770, 118, '2014-03-15 00:23:37.000000', 'temperatura', 1079.0000, 'ºC'),
	(240771, 118, '2014-03-15 00:23:38.000000', 'temperatura', 895.0000, 'ºC'),
	(240772, 118, '2014-03-15 00:23:39.000000', 'temperatura', 39.0000, 'ºC'),
	(240773, 118, '2014-03-15 00:23:40.000000', 'temperatura', 1112.0000, 'ºC'),
	(240774, 118, '2014-03-15 00:23:41.000000', 'temperatura', 641.0000, 'ºC'),
	(240775, 118, '2014-03-15 00:23:42.000000', 'temperatura', 1072.0000, 'ºC'),
	(240776, 118, '2014-03-15 00:23:43.000000', 'temperatura', 1035.0000, 'ºC'),
	(240777, 118, '2014-03-15 00:23:44.000000', 'temperatura', 760.0000, 'ºC'),
	(240778, 118, '2014-03-15 00:23:45.000000', 'temperatura', 695.0000, 'ºC'),
	(240779, 118, '2014-03-15 00:23:46.000000', 'temperatura', 1195.0000, 'ºC'),
	(240780, 118, '2014-03-15 00:23:47.000000', 'temperatura', 292.0000, 'ºC'),
	(240781, 118, '2014-03-15 00:23:48.000000', 'temperatura', 276.0000, 'ºC'),
	(240782, 118, '2014-03-15 00:23:49.000000', 'temperatura', 505.0000, 'ºC'),
	(240783, 118, '2014-03-15 00:23:50.000000', 'temperatura', 496.0000, 'ºC'),
	(240784, 118, '2014-03-15 00:23:51.000000', 'temperatura', 965.0000, 'ºC'),
	(240785, 118, '2014-03-15 00:23:52.000000', 'temperatura', 940.0000, 'ºC'),
	(240786, 118, '2014-03-15 00:23:53.000000', 'temperatura', 604.0000, 'ºC'),
	(240787, 118, '2014-03-15 00:23:54.000000', 'temperatura', 199.0000, 'ºC'),
	(240788, 118, '2014-03-15 00:23:55.000000', 'temperatura', 383.0000, 'ºC'),
	(240789, 118, '2014-03-15 00:23:56.000000', 'temperatura', 118.0000, 'ºC'),
	(240790, 118, '2014-03-15 00:23:57.000000', 'temperatura', 643.0000, 'ºC'),
	(240791, 118, '2014-03-15 00:23:58.000000', 'temperatura', 459.0000, 'ºC'),
	(240792, 118, '2014-03-15 00:23:59.000000', 'temperatura', 370.0000, 'ºC'),
	(240793, 118, '2014-03-15 00:24:00.000000', 'temperatura', 473.0000, 'ºC'),
	(240794, 118, '2014-03-15 00:24:01.000000', 'temperatura', 55.0000, 'ºC'),
	(240795, 118, '2014-03-15 00:24:02.000000', 'temperatura', 55.0000, 'ºC'),
	(240796, 118, '2014-03-15 00:24:03.000000', 'temperatura', 110.0000, 'ºC'),
	(240797, 118, '2014-03-15 00:24:04.000000', 'temperatura', 385.0000, 'ºC'),
	(240798, 118, '2014-03-15 00:24:05.000000', 'temperatura', 398.0000, 'ºC'),
	(240799, 118, '2014-03-15 00:24:06.000000', 'temperatura', 834.0000, 'ºC'),
	(240800, 118, '2014-03-15 00:24:07.000000', 'temperatura', 576.0000, 'ºC'),
	(240801, 118, '2014-03-15 00:24:08.000000', 'temperatura', 381.0000, 'ºC'),
	(240802, 118, '2014-03-15 00:24:09.000000', 'temperatura', 175.0000, 'ºC'),
	(240803, 118, '2014-03-15 00:24:10.000000', 'temperatura', 935.0000, 'ºC'),
	(240804, 118, '2014-03-15 00:24:11.000000', 'temperatura', 550.0000, 'ºC'),
	(240805, 118, '2014-03-15 00:24:12.000000', 'temperatura', 1145.0000, 'ºC'),
	(240806, 118, '2014-03-15 00:24:13.000000', 'temperatura', 474.0000, 'ºC'),
	(240807, 118, '2014-03-15 00:24:14.000000', 'temperatura', 135.0000, 'ºC'),
	(240808, 118, '2014-03-15 00:24:15.000000', 'temperatura', 455.0000, 'ºC'),
	(240809, 118, '2014-03-15 00:24:16.000000', 'temperatura', 671.0000, 'ºC'),
	(240810, 118, '2014-03-15 00:24:17.000000', 'temperatura', 792.0000, 'ºC'),
	(240811, 118, '2014-03-15 00:24:18.000000', 'temperatura', 745.0000, 'ºC'),
	(240812, 118, '2014-03-15 00:24:19.000000', 'temperatura', 150.0000, 'ºC'),
	(240813, 118, '2014-03-15 00:24:20.000000', 'temperatura', 914.0000, 'ºC'),
	(240814, 118, '2014-03-15 00:24:21.000000', 'temperatura', 522.0000, 'ºC'),
	(240815, 118, '2014-03-15 00:24:22.000000', 'temperatura', 1068.0000, 'ºC'),
	(240816, 118, '2014-03-15 00:24:23.000000', 'temperatura', 173.0000, 'ºC'),
	(240817, 118, '2014-03-15 00:24:24.000000', 'temperatura', 63.0000, 'ºC'),
	(240818, 118, '2014-03-15 00:24:25.000000', 'temperatura', 996.0000, 'ºC'),
	(240819, 118, '2014-03-15 00:24:26.000000', 'temperatura', 1192.0000, 'ºC'),
	(240820, 118, '2014-03-15 00:24:27.000000', 'temperatura', 573.0000, 'ºC'),
	(240821, 118, '2014-03-15 00:24:28.000000', 'temperatura', 489.0000, 'ºC'),
	(240822, 118, '2014-03-15 00:24:29.000000', 'temperatura', 725.0000, 'ºC'),
	(240823, 118, '2014-03-15 00:24:30.000000', 'temperatura', 957.0000, 'ºC'),
	(240824, 118, '2014-03-15 00:24:31.000000', 'temperatura', 214.0000, 'ºC'),
	(240825, 118, '2014-03-15 00:24:32.000000', 'temperatura', 599.0000, 'ºC'),
	(240826, 118, '2014-03-15 00:24:33.000000', 'temperatura', 1154.0000, 'ºC'),
	(240827, 118, '2014-03-15 00:24:34.000000', 'temperatura', 375.0000, 'ºC'),
	(240828, 118, '2014-03-15 00:24:35.000000', 'temperatura', 810.0000, 'ºC'),
	(240829, 118, '2014-03-15 00:24:36.000000', 'temperatura', 528.0000, 'ºC'),
	(240830, 118, '2014-03-15 00:24:37.000000', 'temperatura', 208.0000, 'ºC'),
	(240831, 118, '2014-03-15 00:24:38.000000', 'temperatura', 656.0000, 'ºC'),
	(240832, 118, '2014-03-15 00:24:39.000000', 'temperatura', 258.0000, 'ºC'),
	(240833, 118, '2014-03-15 00:24:40.000000', 'temperatura', 520.0000, 'ºC'),
	(240834, 118, '2014-03-15 00:24:41.000000', 'temperatura', 630.0000, 'ºC'),
	(240835, 118, '2014-03-15 00:24:42.000000', 'temperatura', 388.0000, 'ºC'),
	(240836, 118, '2014-03-15 00:24:43.000000', 'temperatura', 52.0000, 'ºC'),
	(240837, 118, '2014-03-15 00:24:44.000000', 'temperatura', 297.0000, 'ºC'),
	(240838, 118, '2014-03-15 00:24:45.000000', 'temperatura', 127.0000, 'ºC'),
	(240839, 118, '2014-03-15 00:24:46.000000', 'temperatura', 946.0000, 'ºC'),
	(240840, 118, '2014-03-15 00:24:47.000000', 'temperatura', 748.0000, 'ºC'),
	(240841, 118, '2014-03-15 00:24:48.000000', 'temperatura', 904.0000, 'ºC'),
	(240842, 118, '2014-03-15 00:24:49.000000', 'temperatura', 1077.0000, 'ºC'),
	(240843, 118, '2014-03-15 00:24:50.000000', 'temperatura', 271.0000, 'ºC'),
	(240844, 118, '2014-03-15 00:24:51.000000', 'temperatura', 527.0000, 'ºC'),
	(240845, 118, '2014-03-15 00:24:52.000000', 'temperatura', 621.0000, 'ºC'),
	(240846, 118, '2014-03-15 00:24:53.000000', 'temperatura', 325.0000, 'ºC'),
	(240847, 118, '2014-03-15 00:24:54.000000', 'temperatura', 962.0000, 'ºC'),
	(240848, 118, '2014-03-15 00:24:55.000000', 'temperatura', 234.0000, 'ºC'),
	(240849, 118, '2014-03-15 00:24:56.000000', 'temperatura', 685.0000, 'ºC'),
	(240850, 118, '2014-03-15 00:24:57.000000', 'temperatura', 324.0000, 'ºC'),
	(240851, 118, '2014-03-15 00:24:58.000000', 'temperatura', 767.0000, 'ºC'),
	(240852, 118, '2014-03-15 00:24:59.000000', 'temperatura', 461.0000, 'ºC'),
	(240853, 118, '2014-03-15 00:25:00.000000', 'temperatura', 6.0000, 'ºC'),
	(240854, 118, '2014-03-15 00:25:01.000000', 'temperatura', 1049.0000, 'ºC'),
	(240855, 118, '2014-03-15 00:25:02.000000', 'temperatura', 426.0000, 'ºC'),
	(240856, 118, '2014-03-15 00:25:03.000000', 'temperatura', 185.0000, 'ºC'),
	(240857, 118, '2014-03-15 00:25:04.000000', 'temperatura', 845.0000, 'ºC'),
	(240858, 118, '2014-03-15 00:25:05.000000', 'temperatura', 73.0000, 'ºC'),
	(240859, 118, '2014-03-15 00:25:06.000000', 'temperatura', 230.0000, 'ºC'),
	(240860, 118, '2014-03-15 00:25:07.000000', 'temperatura', 932.0000, 'ºC'),
	(240861, 118, '2014-03-15 00:25:08.000000', 'temperatura', 369.0000, 'ºC'),
	(240862, 118, '2014-03-15 00:25:09.000000', 'temperatura', 250.0000, 'ºC'),
	(240863, 118, '2014-03-15 00:25:10.000000', 'temperatura', 145.0000, 'ºC'),
	(240864, 118, '2014-03-15 00:25:11.000000', 'temperatura', 1173.0000, 'ºC'),
	(240865, 118, '2014-03-15 00:25:12.000000', 'temperatura', 630.0000, 'ºC'),
	(240866, 118, '2014-03-15 00:25:13.000000', 'temperatura', 833.0000, 'ºC'),
	(240867, 118, '2014-03-15 00:25:14.000000', 'temperatura', 1076.0000, 'ºC'),
	(240868, 118, '2014-03-15 00:25:15.000000', 'temperatura', 479.0000, 'ºC'),
	(240869, 118, '2014-03-15 00:25:16.000000', 'temperatura', 369.0000, 'ºC'),
	(240870, 118, '2014-03-15 00:25:17.000000', 'temperatura', 406.0000, 'ºC'),
	(240871, 118, '2014-03-15 00:25:18.000000', 'temperatura', 927.0000, 'ºC'),
	(240872, 118, '2014-03-15 00:25:19.000000', 'temperatura', 1017.0000, 'ºC'),
	(240873, 118, '2014-03-15 00:25:20.000000', 'temperatura', 1105.0000, 'ºC'),
	(240874, 118, '2014-03-15 00:25:21.000000', 'temperatura', 72.0000, 'ºC'),
	(240875, 118, '2014-03-15 00:25:22.000000', 'temperatura', 646.0000, 'ºC'),
	(240876, 118, '2014-03-15 00:25:23.000000', 'temperatura', 613.0000, 'ºC'),
	(240877, 118, '2014-03-15 00:25:24.000000', 'temperatura', 1129.0000, 'ºC'),
	(240878, 118, '2014-03-15 00:25:25.000000', 'temperatura', 208.0000, 'ºC'),
	(240879, 118, '2014-03-15 00:25:26.000000', 'temperatura', 52.0000, 'ºC'),
	(240880, 118, '2014-03-15 00:25:27.000000', 'temperatura', 838.0000, 'ºC'),
	(240881, 118, '2014-03-15 00:25:28.000000', 'temperatura', 433.0000, 'ºC'),
	(240882, 118, '2014-03-15 00:25:29.000000', 'temperatura', 854.0000, 'ºC'),
	(240883, 118, '2014-03-15 00:25:30.000000', 'temperatura', 569.0000, 'ºC'),
	(240884, 118, '2014-03-15 00:25:31.000000', 'temperatura', 283.0000, 'ºC'),
	(240885, 118, '2014-03-15 00:25:32.000000', 'temperatura', 908.0000, 'ºC'),
	(240886, 118, '2014-03-15 00:25:33.000000', 'temperatura', 92.0000, 'ºC'),
	(240887, 118, '2014-03-15 00:25:34.000000', 'temperatura', 138.0000, 'ºC'),
	(240888, 118, '2014-03-15 00:25:35.000000', 'temperatura', 415.0000, 'ºC'),
	(240889, 118, '2014-03-15 00:25:36.000000', 'temperatura', 461.0000, 'ºC'),
	(240890, 118, '2014-03-15 00:25:37.000000', 'temperatura', 1061.0000, 'ºC'),
	(240891, 118, '2014-03-15 00:25:38.000000', 'temperatura', 322.0000, 'ºC'),
	(240892, 118, '2014-03-15 00:25:39.000000', 'temperatura', 829.0000, 'ºC'),
	(240893, 118, '2014-03-15 00:25:40.000000', 'temperatura', 777.0000, 'ºC'),
	(240894, 118, '2014-03-15 00:25:41.000000', 'temperatura', 201.0000, 'ºC'),
	(240895, 118, '2014-03-15 00:25:42.000000', 'temperatura', 1073.0000, 'ºC'),
	(240896, 118, '2014-03-15 00:25:43.000000', 'temperatura', 1164.0000, 'ºC'),
	(240897, 118, '2014-03-15 00:25:44.000000', 'temperatura', 202.0000, 'ºC'),
	(240898, 118, '2014-03-15 00:25:45.000000', 'temperatura', 1119.0000, 'ºC'),
	(240899, 118, '2014-03-15 00:25:46.000000', 'temperatura', 187.0000, 'ºC'),
	(240900, 118, '2014-03-15 00:25:47.000000', 'temperatura', 1180.0000, 'ºC'),
	(240901, 118, '2014-03-15 00:25:48.000000', 'temperatura', 540.0000, 'ºC'),
	(240902, 118, '2014-03-15 00:25:49.000000', 'temperatura', 361.0000, 'ºC'),
	(240903, 118, '2014-03-15 00:25:50.000000', 'temperatura', 183.0000, 'ºC'),
	(240904, 118, '2014-03-15 00:25:51.000000', 'temperatura', 1033.0000, 'ºC'),
	(240905, 118, '2014-03-15 00:25:52.000000', 'temperatura', 1019.0000, 'ºC'),
	(240906, 118, '2014-03-15 00:25:53.000000', 'temperatura', 793.0000, 'ºC'),
	(240907, 118, '2014-03-15 00:25:54.000000', 'temperatura', 911.0000, 'ºC'),
	(240908, 118, '2014-03-15 00:25:55.000000', 'temperatura', 977.0000, 'ºC'),
	(240909, 118, '2014-03-15 00:25:56.000000', 'temperatura', 951.0000, 'ºC'),
	(240910, 118, '2014-03-15 00:25:57.000000', 'temperatura', 626.0000, 'ºC'),
	(240911, 118, '2014-03-15 00:25:58.000000', 'temperatura', 276.0000, 'ºC'),
	(240912, 118, '2014-03-15 00:25:59.000000', 'temperatura', 702.0000, 'ºC'),
	(240913, 118, '2014-03-15 00:26:00.000000', 'temperatura', 283.0000, 'ºC'),
	(240914, 118, '2014-03-15 00:26:01.000000', 'temperatura', 509.0000, 'ºC'),
	(240915, 118, '2014-03-15 00:26:02.000000', 'temperatura', 497.0000, 'ºC'),
	(240916, 118, '2014-03-15 00:26:03.000000', 'temperatura', 958.0000, 'ºC'),
	(240917, 118, '2014-03-15 00:26:04.000000', 'temperatura', 899.0000, 'ºC'),
	(240918, 118, '2014-03-15 00:26:05.000000', 'temperatura', 420.0000, 'ºC'),
	(240919, 118, '2014-03-15 00:26:06.000000', 'temperatura', 606.0000, 'ºC'),
	(240920, 118, '2014-03-15 00:26:07.000000', 'temperatura', 572.0000, 'ºC'),
	(240921, 118, '2014-03-15 00:26:08.000000', 'temperatura', 1039.0000, 'ºC'),
	(240922, 118, '2014-03-15 00:26:09.000000', 'temperatura', 1081.0000, 'ºC'),
	(240923, 118, '2014-03-15 00:26:10.000000', 'temperatura', 1090.0000, 'ºC'),
	(240924, 118, '2014-03-15 00:26:11.000000', 'temperatura', 1005.0000, 'ºC'),
	(240925, 118, '2014-03-15 00:26:12.000000', 'temperatura', 558.0000, 'ºC'),
	(240926, 118, '2014-03-15 00:26:13.000000', 'temperatura', 975.0000, 'ºC'),
	(240927, 118, '2014-03-15 00:26:14.000000', 'temperatura', 801.0000, 'ºC'),
	(240928, 118, '2014-03-15 00:26:15.000000', 'temperatura', 1079.0000, 'ºC'),
	(240929, 118, '2014-03-15 00:26:16.000000', 'temperatura', 592.0000, 'ºC'),
	(240930, 118, '2014-03-15 00:26:17.000000', 'temperatura', 924.0000, 'ºC'),
	(240931, 118, '2014-03-15 00:26:18.000000', 'temperatura', 444.0000, 'ºC'),
	(240932, 118, '2014-03-15 00:26:19.000000', 'temperatura', 649.0000, 'ºC'),
	(240933, 118, '2014-03-15 00:26:20.000000', 'temperatura', 712.0000, 'ºC'),
	(240934, 118, '2014-03-15 00:26:21.000000', 'temperatura', 416.0000, 'ºC'),
	(240935, 118, '2014-03-15 00:26:22.000000', 'temperatura', 1143.0000, 'ºC'),
	(240936, 118, '2014-03-15 00:26:23.000000', 'temperatura', 867.0000, 'ºC'),
	(240937, 118, '2014-03-15 00:26:24.000000', 'temperatura', 909.0000, 'ºC'),
	(240938, 118, '2014-03-15 00:26:25.000000', 'temperatura', 744.0000, 'ºC'),
	(240939, 118, '2014-03-15 00:26:26.000000', 'temperatura', 993.0000, 'ºC'),
	(240940, 118, '2014-03-15 00:26:27.000000', 'temperatura', 335.0000, 'ºC'),
	(240941, 118, '2014-03-15 00:26:28.000000', 'temperatura', 1097.0000, 'ºC'),
	(240942, 118, '2014-03-15 00:26:29.000000', 'temperatura', 880.0000, 'ºC'),
	(240943, 118, '2014-03-15 00:26:30.000000', 'temperatura', 1107.0000, 'ºC'),
	(240944, 118, '2014-03-15 00:26:31.000000', 'temperatura', 498.0000, 'ºC'),
	(240945, 118, '2014-03-15 00:26:32.000000', 'temperatura', 370.0000, 'ºC'),
	(240946, 118, '2014-03-15 00:26:33.000000', 'temperatura', 357.0000, 'ºC'),
	(240947, 118, '2014-03-15 00:26:34.000000', 'temperatura', 676.0000, 'ºC'),
	(240948, 118, '2014-03-15 00:26:35.000000', 'temperatura', 1110.0000, 'ºC'),
	(240949, 118, '2014-03-15 00:26:36.000000', 'temperatura', 1122.0000, 'ºC'),
	(240950, 118, '2014-03-15 00:26:37.000000', 'temperatura', 1079.0000, 'ºC'),
	(240951, 118, '2014-03-15 00:26:38.000000', 'temperatura', 830.0000, 'ºC'),
	(240952, 118, '2014-03-15 00:26:39.000000', 'temperatura', 915.0000, 'ºC'),
	(240953, 118, '2014-03-15 00:26:40.000000', 'temperatura', 886.0000, 'ºC'),
	(240954, 118, '2014-03-15 00:26:41.000000', 'temperatura', 484.0000, 'ºC'),
	(240955, 118, '2014-03-15 00:26:42.000000', 'temperatura', 965.0000, 'ºC'),
	(240956, 118, '2014-03-15 00:26:43.000000', 'temperatura', 970.0000, 'ºC'),
	(240957, 118, '2014-03-15 00:26:44.000000', 'temperatura', 757.0000, 'ºC'),
	(240958, 118, '2014-03-15 00:26:45.000000', 'temperatura', 877.0000, 'ºC'),
	(240959, 118, '2014-03-15 00:26:46.000000', 'temperatura', 913.0000, 'ºC'),
	(240960, 118, '2014-03-15 00:26:47.000000', 'temperatura', 735.0000, 'ºC'),
	(240961, 118, '2014-03-15 00:26:48.000000', 'temperatura', 937.0000, 'ºC'),
	(240962, 118, '2014-03-15 00:26:49.000000', 'temperatura', 80.0000, 'ºC'),
	(240963, 118, '2014-03-15 00:26:50.000000', 'temperatura', 1192.0000, 'ºC'),
	(240964, 118, '2014-03-15 00:26:51.000000', 'temperatura', 917.0000, 'ºC'),
	(240965, 118, '2014-03-15 00:26:52.000000', 'temperatura', 1012.0000, 'ºC'),
	(240966, 118, '2014-03-15 00:26:53.000000', 'temperatura', 1110.0000, 'ºC'),
	(240967, 118, '2014-03-15 00:26:54.000000', 'temperatura', 113.0000, 'ºC'),
	(240968, 118, '2014-03-15 00:26:55.000000', 'temperatura', 837.0000, 'ºC'),
	(240969, 118, '2014-03-15 00:26:56.000000', 'temperatura', 246.0000, 'ºC'),
	(240970, 118, '2014-03-15 00:26:57.000000', 'temperatura', 1120.0000, 'ºC'),
	(240971, 118, '2014-03-15 00:26:58.000000', 'temperatura', 63.0000, 'ºC'),
	(240972, 118, '2014-03-15 00:26:59.000000', 'temperatura', 554.0000, 'ºC'),
	(240973, 118, '2014-03-15 00:27:00.000000', 'temperatura', 181.0000, 'ºC'),
	(240974, 118, '2014-03-15 00:27:01.000000', 'temperatura', 443.0000, 'ºC'),
	(240975, 118, '2014-03-15 00:27:02.000000', 'temperatura', 472.0000, 'ºC'),
	(240976, 118, '2014-03-15 00:27:03.000000', 'temperatura', 1034.0000, 'ºC'),
	(240977, 118, '2014-03-15 00:27:04.000000', 'temperatura', 155.0000, 'ºC'),
	(240978, 118, '2014-03-15 00:27:05.000000', 'temperatura', 73.0000, 'ºC'),
	(240979, 118, '2014-03-15 00:27:06.000000', 'temperatura', 1102.0000, 'ºC'),
	(240980, 118, '2014-03-15 00:27:07.000000', 'temperatura', 491.0000, 'ºC'),
	(240981, 118, '2014-03-15 00:27:08.000000', 'temperatura', 347.0000, 'ºC'),
	(240982, 118, '2014-03-15 00:27:09.000000', 'temperatura', 264.0000, 'ºC'),
	(240983, 118, '2014-03-15 00:27:10.000000', 'temperatura', 280.0000, 'ºC'),
	(240984, 118, '2014-03-15 00:27:11.000000', 'temperatura', 609.0000, 'ºC'),
	(240985, 118, '2014-03-15 00:27:12.000000', 'temperatura', 1005.0000, 'ºC'),
	(240986, 118, '2014-03-15 00:27:13.000000', 'temperatura', 797.0000, 'ºC'),
	(240987, 118, '2014-03-15 00:27:14.000000', 'temperatura', 971.0000, 'ºC'),
	(240988, 118, '2014-03-15 00:27:15.000000', 'temperatura', 65.0000, 'ºC'),
	(240989, 118, '2014-03-15 00:27:16.000000', 'temperatura', 1014.0000, 'ºC'),
	(240990, 118, '2014-03-15 00:27:17.000000', 'temperatura', 74.0000, 'ºC'),
	(240991, 118, '2014-03-15 00:27:18.000000', 'temperatura', 928.0000, 'ºC'),
	(240992, 118, '2014-03-15 00:27:19.000000', 'temperatura', 818.0000, 'ºC'),
	(240993, 118, '2014-03-15 00:27:20.000000', 'temperatura', 109.0000, 'ºC'),
	(240994, 118, '2014-03-15 00:27:21.000000', 'temperatura', 490.0000, 'ºC'),
	(240995, 118, '2014-03-15 00:27:22.000000', 'temperatura', 923.0000, 'ºC'),
	(240996, 118, '2014-03-15 00:27:23.000000', 'temperatura', 747.0000, 'ºC'),
	(240997, 118, '2014-03-15 00:27:24.000000', 'temperatura', 966.0000, 'ºC'),
	(240998, 118, '2014-03-15 00:27:25.000000', 'temperatura', 189.0000, 'ºC'),
	(240999, 118, '2014-03-15 00:27:26.000000', 'temperatura', 448.0000, 'ºC'),
	(241000, 118, '2014-03-15 00:27:27.000000', 'temperatura', 474.0000, 'ºC'),
	(241001, 118, '2014-03-15 00:27:28.000000', 'temperatura', 1026.0000, 'ºC'),
	(241002, 118, '2014-03-15 00:27:29.000000', 'temperatura', 107.0000, 'ºC'),
	(241003, 118, '2014-03-15 00:27:30.000000', 'temperatura', 1057.0000, 'ºC'),
	(241004, 118, '2014-03-15 00:27:31.000000', 'temperatura', 165.0000, 'ºC'),
	(241005, 118, '2014-03-15 00:27:32.000000', 'temperatura', 56.0000, 'ºC'),
	(241006, 118, '2014-03-15 00:27:33.000000', 'temperatura', 984.0000, 'ºC'),
	(241007, 118, '2014-03-15 00:27:34.000000', 'temperatura', 1154.0000, 'ºC'),
	(241008, 118, '2014-03-15 00:27:35.000000', 'temperatura', 416.0000, 'ºC'),
	(241009, 118, '2014-03-15 00:27:36.000000', 'temperatura', 1019.0000, 'ºC'),
	(241010, 118, '2014-03-15 00:27:37.000000', 'temperatura', 247.0000, 'ºC'),
	(241011, 118, '2014-03-15 00:27:38.000000', 'temperatura', 580.0000, 'ºC'),
	(241012, 118, '2014-03-15 00:27:39.000000', 'temperatura', 960.0000, 'ºC'),
	(241013, 118, '2014-03-15 00:27:40.000000', 'temperatura', 658.0000, 'ºC'),
	(241014, 118, '2014-03-15 00:27:41.000000', 'temperatura', 412.0000, 'ºC'),
	(241015, 118, '2014-03-15 00:27:42.000000', 'temperatura', 86.0000, 'ºC'),
	(241016, 118, '2014-03-15 00:27:43.000000', 'temperatura', 396.0000, 'ºC'),
	(241017, 118, '2014-03-15 00:27:44.000000', 'temperatura', 521.0000, 'ºC'),
	(241018, 118, '2014-03-15 00:27:45.000000', 'temperatura', 220.0000, 'ºC'),
	(241019, 118, '2014-03-15 00:27:46.000000', 'temperatura', 735.0000, 'ºC'),
	(241020, 118, '2014-03-15 00:27:47.000000', 'temperatura', 618.0000, 'ºC'),
	(241021, 118, '2014-03-15 00:27:48.000000', 'temperatura', 885.0000, 'ºC'),
	(241022, 118, '2014-03-15 00:27:49.000000', 'temperatura', 169.0000, 'ºC'),
	(241023, 118, '2014-03-15 00:27:50.000000', 'temperatura', 593.0000, 'ºC'),
	(241024, 118, '2014-03-15 00:27:51.000000', 'temperatura', 57.0000, 'ºC'),
	(241025, 118, '2014-03-15 00:27:52.000000', 'temperatura', 906.0000, 'ºC'),
	(241026, 118, '2014-03-15 00:27:53.000000', 'temperatura', 759.0000, 'ºC'),
	(241027, 118, '2014-03-15 00:27:54.000000', 'temperatura', 1080.0000, 'ºC'),
	(241028, 118, '2014-03-15 00:27:55.000000', 'temperatura', 722.0000, 'ºC'),
	(241029, 118, '2014-03-15 00:27:56.000000', 'temperatura', 369.0000, 'ºC'),
	(241030, 118, '2014-03-15 00:27:57.000000', 'temperatura', 883.0000, 'ºC'),
	(241031, 118, '2014-03-15 00:27:58.000000', 'temperatura', 905.0000, 'ºC'),
	(241032, 118, '2014-03-15 00:27:59.000000', 'temperatura', 678.0000, 'ºC'),
	(241033, 118, '2014-03-15 00:28:00.000000', 'temperatura', 675.0000, 'ºC'),
	(241034, 118, '2014-03-15 00:28:01.000000', 'temperatura', 144.0000, 'ºC'),
	(241035, 118, '2014-03-15 00:28:02.000000', 'temperatura', 1092.0000, 'ºC'),
	(241036, 118, '2014-03-15 00:28:03.000000', 'temperatura', 229.0000, 'ºC'),
	(241037, 118, '2014-03-15 00:28:04.000000', 'temperatura', 272.0000, 'ºC'),
	(241038, 118, '2014-03-15 00:28:05.000000', 'temperatura', 672.0000, 'ºC'),
	(241039, 118, '2014-03-15 00:28:06.000000', 'temperatura', 144.0000, 'ºC'),
	(241040, 118, '2014-03-15 00:28:07.000000', 'temperatura', 1105.0000, 'ºC'),
	(241041, 118, '2014-03-15 00:28:08.000000', 'temperatura', 292.0000, 'ºC'),
	(241042, 118, '2014-03-15 00:28:09.000000', 'temperatura', 547.0000, 'ºC'),
	(241043, 118, '2014-03-15 00:28:10.000000', 'temperatura', 660.0000, 'ºC'),
	(241044, 118, '2014-03-15 00:28:11.000000', 'temperatura', 457.0000, 'ºC'),
	(241045, 118, '2014-03-15 00:28:12.000000', 'temperatura', 306.0000, 'ºC'),
	(241046, 118, '2014-03-15 00:28:13.000000', 'temperatura', 161.0000, 'ºC'),
	(241047, 118, '2014-03-15 00:28:14.000000', 'temperatura', 1086.0000, 'ºC'),
	(241048, 118, '2014-03-15 00:28:15.000000', 'temperatura', 150.0000, 'ºC'),
	(241049, 118, '2014-03-15 00:28:16.000000', 'temperatura', 1090.0000, 'ºC'),
	(241050, 118, '2014-03-15 00:28:17.000000', 'temperatura', 200.0000, 'ºC'),
	(241051, 118, '2014-03-15 00:28:18.000000', 'temperatura', 130.0000, 'ºC'),
	(241052, 118, '2014-03-15 00:28:19.000000', 'temperatura', 50.0000, 'ºC'),
	(241053, 118, '2014-03-15 00:28:20.000000', 'temperatura', 1059.0000, 'ºC'),
	(241054, 118, '2014-03-15 00:28:21.000000', 'temperatura', 349.0000, 'ºC'),
	(241055, 118, '2014-03-15 00:28:22.000000', 'temperatura', 969.0000, 'ºC'),
	(241056, 118, '2014-03-15 00:28:23.000000', 'temperatura', 197.0000, 'ºC'),
	(241057, 118, '2014-03-15 00:28:24.000000', 'temperatura', 480.0000, 'ºC'),
	(241058, 118, '2014-03-15 00:28:25.000000', 'temperatura', 610.0000, 'ºC'),
	(241059, 118, '2014-03-15 00:28:26.000000', 'temperatura', 408.0000, 'ºC'),
	(241060, 118, '2014-03-15 00:28:27.000000', 'temperatura', 213.0000, 'ºC'),
	(241061, 118, '2014-03-15 00:28:28.000000', 'temperatura', 1040.0000, 'ºC'),
	(241062, 118, '2014-03-15 00:28:29.000000', 'temperatura', 960.0000, 'ºC'),
	(241063, 118, '2014-03-15 00:28:30.000000', 'temperatura', 482.0000, 'ºC'),
	(241064, 118, '2014-03-15 00:28:31.000000', 'temperatura', 731.0000, 'ºC'),
	(241065, 118, '2014-03-15 00:28:32.000000', 'temperatura', 1009.0000, 'ºC'),
	(241066, 118, '2014-03-15 00:28:33.000000', 'temperatura', 454.0000, 'ºC'),
	(241067, 118, '2014-03-15 00:28:34.000000', 'temperatura', 444.0000, 'ºC'),
	(241068, 118, '2014-03-15 00:28:35.000000', 'temperatura', 857.0000, 'ºC'),
	(241069, 118, '2014-03-15 00:28:36.000000', 'temperatura', 552.0000, 'ºC'),
	(241070, 118, '2014-03-15 00:28:37.000000', 'temperatura', 193.0000, 'ºC'),
	(241071, 118, '2014-03-15 00:28:38.000000', 'temperatura', 507.0000, 'ºC'),
	(241072, 118, '2014-03-15 00:28:39.000000', 'temperatura', 759.0000, 'ºC'),
	(241073, 118, '2014-03-15 00:28:40.000000', 'temperatura', 1074.0000, 'ºC'),
	(241074, 118, '2014-03-15 00:28:41.000000', 'temperatura', 691.0000, 'ºC'),
	(241075, 118, '2014-03-15 00:28:42.000000', 'temperatura', 236.0000, 'ºC'),
	(241076, 118, '2014-03-15 00:28:43.000000', 'temperatura', 308.0000, 'ºC'),
	(241077, 118, '2014-03-15 00:28:44.000000', 'temperatura', 832.0000, 'ºC'),
	(241078, 118, '2014-03-15 00:28:45.000000', 'temperatura', 834.0000, 'ºC'),
	(241079, 118, '2014-03-15 00:28:46.000000', 'temperatura', 478.0000, 'ºC'),
	(241080, 118, '2014-03-15 00:28:47.000000', 'temperatura', 1085.0000, 'ºC'),
	(241081, 118, '2014-03-15 00:28:48.000000', 'temperatura', 394.0000, 'ºC'),
	(241082, 118, '2014-03-15 00:28:49.000000', 'temperatura', 1113.0000, 'ºC'),
	(241083, 118, '2014-03-15 00:28:50.000000', 'temperatura', 783.0000, 'ºC'),
	(241084, 118, '2014-03-15 00:28:51.000000', 'temperatura', 580.0000, 'ºC'),
	(241085, 118, '2014-03-15 00:28:52.000000', 'temperatura', 549.0000, 'ºC'),
	(241086, 118, '2014-03-15 00:28:53.000000', 'temperatura', 1006.0000, 'ºC'),
	(241087, 118, '2014-03-15 00:28:54.000000', 'temperatura', 984.0000, 'ºC'),
	(241088, 118, '2014-03-15 00:28:55.000000', 'temperatura', 704.0000, 'ºC'),
	(241089, 118, '2014-03-15 00:28:56.000000', 'temperatura', 568.0000, 'ºC'),
	(241090, 118, '2014-03-15 00:28:57.000000', 'temperatura', 729.0000, 'ºC'),
	(241091, 118, '2014-03-15 00:28:58.000000', 'temperatura', 741.0000, 'ºC'),
	(241092, 118, '2014-03-15 00:28:59.000000', 'temperatura', 317.0000, 'ºC'),
	(241093, 118, '2014-03-15 00:29:00.000000', 'temperatura', 563.0000, 'ºC'),
	(241094, 118, '2014-03-15 00:29:01.000000', 'temperatura', 667.0000, 'ºC'),
	(241095, 118, '2014-03-15 00:29:02.000000', 'temperatura', 443.0000, 'ºC'),
	(241096, 118, '2014-03-15 00:29:03.000000', 'temperatura', 216.0000, 'ºC'),
	(241097, 118, '2014-03-15 00:29:04.000000', 'temperatura', 950.0000, 'ºC'),
	(241098, 118, '2014-03-15 00:29:05.000000', 'temperatura', 504.0000, 'ºC'),
	(241099, 118, '2014-03-15 00:29:06.000000', 'temperatura', 868.0000, 'ºC'),
	(241100, 118, '2014-03-15 00:29:07.000000', 'temperatura', 430.0000, 'ºC'),
	(241101, 118, '2014-03-15 00:29:08.000000', 'temperatura', 747.0000, 'ºC'),
	(241102, 118, '2014-03-15 00:29:09.000000', 'temperatura', 47.0000, 'ºC'),
	(241103, 118, '2014-03-15 00:29:10.000000', 'temperatura', 392.0000, 'ºC'),
	(241104, 118, '2014-03-15 00:29:11.000000', 'temperatura', 620.0000, 'ºC'),
	(241105, 118, '2014-03-15 00:29:12.000000', 'temperatura', 724.0000, 'ºC'),
	(241106, 118, '2014-03-15 00:29:13.000000', 'temperatura', 561.0000, 'ºC'),
	(241107, 118, '2014-03-15 00:29:14.000000', 'temperatura', 636.0000, 'ºC'),
	(241108, 118, '2014-03-15 00:29:15.000000', 'temperatura', 294.0000, 'ºC'),
	(241109, 118, '2014-03-15 00:29:16.000000', 'temperatura', 762.0000, 'ºC'),
	(241110, 118, '2014-03-15 00:29:17.000000', 'temperatura', 531.0000, 'ºC'),
	(241111, 118, '2014-03-15 00:29:18.000000', 'temperatura', 369.0000, 'ºC'),
	(241112, 118, '2014-03-15 00:29:19.000000', 'temperatura', 251.0000, 'ºC'),
	(241113, 118, '2014-03-15 00:29:20.000000', 'temperatura', 149.0000, 'ºC'),
	(241114, 118, '2014-03-15 00:29:21.000000', 'temperatura', 1193.0000, 'ºC'),
	(241115, 118, '2014-03-15 00:29:22.000000', 'temperatura', 720.0000, 'ºC'),
	(241116, 118, '2014-03-15 00:29:23.000000', 'temperatura', 21.0000, 'ºC'),
	(241117, 118, '2014-03-15 00:29:24.000000', 'temperatura', 347.0000, 'ºC'),
	(241118, 118, '2014-03-15 00:29:25.000000', 'temperatura', 472.0000, 'ºC'),
	(241119, 118, '2014-03-15 00:29:26.000000', 'temperatura', 118.0000, 'ºC'),
	(241120, 118, '2014-03-15 00:29:27.000000', 'temperatura', 377.0000, 'ºC'),
	(241121, 118, '2014-03-15 00:29:28.000000', 'temperatura', 331.0000, 'ºC'),
	(241122, 118, '2014-03-15 00:29:29.000000', 'temperatura', 525.0000, 'ºC'),
	(241123, 118, '2014-03-15 00:29:30.000000', 'temperatura', 432.0000, 'ºC'),
	(241124, 118, '2014-03-15 00:29:31.000000', 'temperatura', 587.0000, 'ºC'),
	(241125, 118, '2014-03-15 00:29:32.000000', 'temperatura', 438.0000, 'ºC'),
	(241126, 118, '2014-03-15 00:29:33.000000', 'temperatura', 428.0000, 'ºC'),
	(241127, 118, '2014-03-15 00:29:34.000000', 'temperatura', 826.0000, 'ºC'),
	(241128, 118, '2014-03-15 00:29:35.000000', 'temperatura', 449.0000, 'ºC'),
	(241129, 118, '2014-03-15 00:29:36.000000', 'temperatura', 968.0000, 'ºC'),
	(241130, 118, '2014-03-15 00:29:37.000000', 'temperatura', 1091.0000, 'ºC'),
	(241131, 118, '2014-03-15 00:29:38.000000', 'temperatura', 151.0000, 'ºC'),
	(241132, 118, '2014-03-15 00:29:39.000000', 'temperatura', 1084.0000, 'ºC'),
	(241133, 118, '2014-03-15 00:29:40.000000', 'temperatura', 168.0000, 'ºC'),
	(241134, 118, '2014-03-15 00:29:41.000000', 'temperatura', 1189.0000, 'ºC'),
	(241135, 118, '2014-03-15 00:29:42.000000', 'temperatura', 640.0000, 'ºC'),
	(241136, 118, '2014-03-15 00:29:43.000000', 'temperatura', 833.0000, 'ºC'),
	(241137, 118, '2014-03-15 00:29:44.000000', 'temperatura', 1048.0000, 'ºC'),
	(241138, 118, '2014-03-15 00:29:45.000000', 'temperatura', 340.0000, 'ºC'),
	(241139, 118, '2014-03-15 00:29:46.000000', 'temperatura', 957.0000, 'ºC'),
	(241140, 118, '2014-03-15 00:29:47.000000', 'temperatura', 164.0000, 'ºC'),
	(241141, 118, '2014-03-15 00:29:48.000000', 'temperatura', 352.0000, 'ºC'),
	(241142, 118, '2014-03-15 00:29:49.000000', 'temperatura', 65.0000, 'ºC'),
	(241143, 118, '2014-03-15 00:29:50.000000', 'temperatura', 473.0000, 'ºC'),
	(241144, 118, '2014-03-15 00:29:51.000000', 'temperatura', 968.0000, 'ºC'),
	(241145, 118, '2014-03-15 00:29:52.000000', 'temperatura', 1020.0000, 'ºC'),
	(241146, 118, '2014-03-15 00:29:53.000000', 'temperatura', 999.0000, 'ºC'),
	(241147, 118, '2014-03-15 00:29:54.000000', 'temperatura', 735.0000, 'ºC'),
	(241148, 118, '2014-03-15 00:29:55.000000', 'temperatura', 678.0000, 'ºC'),
	(241149, 118, '2014-03-15 00:29:56.000000', 'temperatura', 1186.0000, 'ºC'),
	(241150, 118, '2014-03-15 00:29:57.000000', 'temperatura', 296.0000, 'ºC'),
	(241151, 118, '2014-03-15 00:29:58.000000', 'temperatura', 323.0000, 'ºC'),
	(241152, 118, '2014-03-15 00:29:59.000000', 'temperatura', 729.0000, 'ºC'),
	(241153, 118, '2014-03-15 00:30:00.000000', 'temperatura', 276.0000, 'ºC'),
	(241154, 118, '2014-03-15 00:30:01.000000', 'temperatura', 395.0000, 'ºC'),
	(241155, 118, '2014-03-15 00:30:02.000000', 'temperatura', 1146.0000, 'ºC'),
	(241156, 118, '2014-03-15 00:30:03.000000', 'temperatura', 944.0000, 'ºC'),
	(241157, 118, '2014-03-15 00:30:04.000000', 'temperatura', 84.0000, 'ºC'),
	(241158, 118, '2014-03-15 00:30:05.000000', 'temperatura', 1188.0000, 'ºC'),
	(241159, 118, '2014-03-15 00:30:06.000000', 'temperatura', 889.0000, 'ºC'),
	(241160, 118, '2014-03-15 00:30:07.000000', 'temperatura', 883.0000, 'ºC'),
	(241161, 118, '2014-03-15 00:30:08.000000', 'temperatura', 547.0000, 'ºC'),
	(241162, 118, '2014-03-15 00:30:09.000000', 'temperatura', 86.0000, 'ºC'),
	(241163, 118, '2014-03-15 00:30:10.000000', 'temperatura', 1188.0000, 'ºC'),
	(241164, 118, '2014-03-15 00:30:11.000000', 'temperatura', 884.0000, 'ºC'),
	(241165, 118, '2014-03-15 00:30:12.000000', 'temperatura', 855.0000, 'ºC'),
	(241166, 118, '2014-03-15 00:30:13.000000', 'temperatura', 425.0000, 'ºC'),
	(241167, 118, '2014-03-15 00:30:14.000000', 'temperatura', 758.0000, 'ºC'),
	(241168, 118, '2014-03-15 00:30:15.000000', 'temperatura', 119.0000, 'ºC'),
	(241169, 118, '2014-03-15 00:30:16.000000', 'temperatura', 720.0000, 'ºC'),
	(241170, 118, '2014-03-15 00:30:17.000000', 'temperatura', 843.0000, 'ºC'),
	(241171, 118, '2014-03-15 00:30:18.000000', 'temperatura', 855.0000, 'ºC'),
	(241172, 118, '2014-03-15 00:30:19.000000', 'temperatura', 546.0000, 'ºC'),
	(241173, 118, '2014-03-15 00:30:20.000000', 'temperatura', 167.0000, 'ºC'),
	(241174, 118, '2014-03-15 00:30:21.000000', 'temperatura', 399.0000, 'ºC'),
	(241175, 118, '2014-03-15 00:30:22.000000', 'temperatura', 291.0000, 'ºC'),
	(241176, 118, '2014-03-15 00:30:23.000000', 'temperatura', 262.0000, 'ºC'),
	(241177, 118, '2014-03-15 00:30:24.000000', 'temperatura', 437.0000, 'ºC'),
	(241178, 118, '2014-03-15 00:30:25.000000', 'temperatura', 197.0000, 'ºC'),
	(241179, 118, '2014-03-15 00:30:26.000000', 'temperatura', 875.0000, 'ºC'),
	(241180, 118, '2014-03-15 00:30:27.000000', 'temperatura', 185.0000, 'ºC'),
	(241181, 118, '2014-03-15 00:30:28.000000', 'temperatura', 699.0000, 'ºC'),
	(241182, 118, '2014-03-15 00:30:29.000000', 'temperatura', 540.0000, 'ºC'),
	(241183, 118, '2014-03-15 00:30:30.000000', 'temperatura', 605.0000, 'ºC'),
	(241184, 118, '2014-03-15 00:30:31.000000', 'temperatura', 203.0000, 'ºC'),
	(241185, 118, '2014-03-15 00:30:32.000000', 'temperatura', 403.0000, 'ºC'),
	(241186, 118, '2014-03-15 00:30:33.000000', 'temperatura', 205.0000, 'ºC'),
	(241187, 118, '2014-03-15 00:30:34.000000', 'temperatura', 1016.0000, 'ºC'),
	(241188, 118, '2014-03-15 00:30:35.000000', 'temperatura', 865.0000, 'ºC'),
	(241189, 118, '2014-03-15 00:30:36.000000', 'temperatura', 79.0000, 'ºC'),
	(241190, 118, '2014-03-15 00:30:37.000000', 'temperatura', 199.0000, 'ºC'),
	(241191, 118, '2014-03-15 00:30:38.000000', 'temperatura', 757.0000, 'ºC'),
	(241192, 118, '2014-03-15 00:30:39.000000', 'temperatura', 792.0000, 'ºC'),
	(241193, 118, '2014-03-15 00:30:40.000000', 'temperatura', 487.0000, 'ºC'),
	(241194, 118, '2014-03-15 00:30:41.000000', 'temperatura', 62.0000, 'ºC'),
	(241195, 118, '2014-03-15 00:30:42.000000', 'temperatura', 48.0000, 'ºC'),
	(241196, 118, '2014-03-15 00:30:43.000000', 'temperatura', 56.0000, 'ºC'),
	(241197, 118, '2014-03-15 00:30:44.000000', 'temperatura', 135.0000, 'ºC'),
	(241198, 118, '2014-03-15 00:30:45.000000', 'temperatura', 507.0000, 'ºC'),
	(241199, 118, '2014-03-15 00:30:46.000000', 'temperatura', 933.0000, 'ºC'),
	(241200, 118, '2014-03-15 00:30:47.000000', 'temperatura', 742.0000, 'ºC'),
	(241201, 118, '2014-03-15 00:30:48.000000', 'temperatura', 914.0000, 'ºC'),
	(241202, 118, '2014-03-15 00:30:49.000000', 'temperatura', 1143.0000, 'ºC'),
	(241203, 118, '2014-03-15 00:30:50.000000', 'temperatura', 573.0000, 'ºC'),
	(241204, 118, '2014-03-15 00:30:51.000000', 'temperatura', 637.0000, 'ºC'),
	(241205, 118, '2014-03-15 00:30:52.000000', 'temperatura', 266.0000, 'ºC'),
	(241206, 118, '2014-03-15 00:30:53.000000', 'temperatura', 621.0000, 'ºC'),
	(241207, 118, '2014-03-15 00:30:54.000000', 'temperatura', 1108.0000, 'ºC'),
	(241208, 118, '2014-03-15 00:30:55.000000', 'temperatura', 75.0000, 'ºC'),
	(241209, 118, '2014-03-15 00:30:56.000000', 'temperatura', 655.0000, 'ºC'),
	(241210, 118, '2014-03-15 00:30:57.000000', 'temperatura', 647.0000, 'ºC'),
	(241211, 118, '2014-03-15 00:30:58.000000', 'temperatura', 71.0000, 'ºC'),
	(241212, 118, '2014-03-15 00:30:59.000000', 'temperatura', 816.0000, 'ºC'),
	(241213, 118, '2014-03-15 00:31:00.000000', 'temperatura', 268.0000, 'ºC'),
	(241214, 118, '2014-03-15 00:31:01.000000', 'temperatura', 92.0000, 'ºC'),
	(241215, 118, '2014-03-15 00:31:02.000000', 'temperatura', 855.0000, 'ºC'),
	(241216, 118, '2014-03-15 00:31:03.000000', 'temperatura', 401.0000, 'ºC'),
	(241217, 118, '2014-03-15 00:31:04.000000', 'temperatura', 639.0000, 'ºC'),
	(241218, 118, '2014-03-15 00:31:05.000000', 'temperatura', 793.0000, 'ºC'),
	(241219, 118, '2014-03-15 00:31:06.000000', 'temperatura', 848.0000, 'ºC'),
	(241220, 118, '2014-03-15 00:31:07.000000', 'temperatura', 663.0000, 'ºC'),
	(241221, 118, '2014-03-15 00:31:08.000000', 'temperatura', 771.0000, 'ºC'),
	(241222, 118, '2014-03-15 00:31:09.000000', 'temperatura', 667.0000, 'ºC'),
	(241223, 118, '2014-03-15 00:31:10.000000', 'temperatura', 1022.0000, 'ºC'),
	(241224, 118, '2014-03-15 00:31:11.000000', 'temperatura', 708.0000, 'ºC'),
	(241225, 118, '2014-03-15 00:31:12.000000', 'temperatura', 476.0000, 'ºC'),
	(241226, 118, '2014-03-15 00:31:13.000000', 'temperatura', 256.0000, 'ºC'),
	(241227, 118, '2014-03-15 00:31:14.000000', 'temperatura', 1052.0000, 'ºC'),
	(241228, 118, '2014-03-15 00:31:15.000000', 'temperatura', 892.0000, 'ºC'),
	(241229, 118, '2014-03-15 00:31:16.000000', 'temperatura', 107.0000, 'ºC'),
	(241230, 118, '2014-03-15 00:31:17.000000', 'temperatura', 259.0000, 'ºC'),
	(241231, 118, '2014-03-15 00:31:18.000000', 'temperatura', 973.0000, 'ºC'),
	(241232, 118, '2014-03-15 00:31:19.000000', 'temperatura', 490.0000, 'ºC'),
	(241233, 118, '2014-03-15 00:31:20.000000', 'temperatura', 733.0000, 'ºC'),
	(241234, 118, '2014-03-15 00:31:21.000000', 'temperatura', 994.0000, 'ºC'),
	(241235, 118, '2014-03-15 00:31:22.000000', 'temperatura', 370.0000, 'ºC'),
	(241236, 118, '2014-03-15 00:31:23.000000', 'temperatura', 70.0000, 'ºC'),
	(241237, 118, '2014-03-15 00:31:24.000000', 'temperatura', 441.0000, 'ºC'),
	(241238, 118, '2014-03-15 00:31:25.000000', 'temperatura', 793.0000, 'ºC'),
	(241239, 118, '2014-03-15 00:31:26.000000', 'temperatura', 244.0000, 'ºC'),
	(241240, 118, '2014-03-15 00:31:27.000000', 'temperatura', 41.0000, 'ºC'),
	(241241, 118, '2014-03-15 00:31:28.000000', 'temperatura', 675.0000, 'ºC'),
	(241242, 118, '2014-03-15 00:31:29.000000', 'temperatura', 852.0000, 'ºC'),
	(241243, 118, '2014-03-15 00:31:30.000000', 'temperatura', 1033.0000, 'ºC'),
	(241244, 118, '2014-03-15 00:31:31.000000', 'temperatura', 212.0000, 'ºC'),
	(241245, 118, '2014-03-15 00:31:32.000000', 'temperatura', 361.0000, 'ºC'),
	(241246, 118, '2014-03-15 00:31:33.000000', 'temperatura', 1170.0000, 'ºC'),
	(241247, 118, '2014-03-15 00:31:34.000000', 'temperatura', 1166.0000, 'ºC'),
	(241248, 118, '2014-03-15 00:31:35.000000', 'temperatura', 1120.0000, 'ºC'),
	(241249, 118, '2014-03-15 00:31:36.000000', 'temperatura', 902.0000, 'ºC'),
	(241250, 118, '2014-03-15 00:31:37.000000', 'temperatura', 1152.0000, 'ºC'),
	(241251, 118, '2014-03-15 00:31:38.000000', 'temperatura', 652.0000, 'ºC'),
	(241252, 118, '2014-03-15 00:31:39.000000', 'temperatura', 1007.0000, 'ºC'),
	(241253, 118, '2014-03-15 00:31:40.000000', 'temperatura', 680.0000, 'ºC'),
	(241254, 118, '2014-03-15 00:31:41.000000', 'temperatura', 377.0000, 'ºC'),
	(241255, 118, '2014-03-15 00:31:42.000000', 'temperatura', 1047.0000, 'ºC'),
	(241256, 118, '2014-03-15 00:31:43.000000', 'temperatura', 503.0000, 'ºC'),
	(241257, 118, '2014-03-15 00:31:44.000000', 'temperatura', 575.0000, 'ºC'),
	(241258, 118, '2014-03-15 00:31:45.000000', 'temperatura', 168.0000, 'ºC'),
	(241259, 118, '2014-03-15 00:31:46.000000', 'temperatura', 314.0000, 'ºC'),
	(241260, 118, '2014-03-15 00:31:47.000000', 'temperatura', 1067.0000, 'ºC'),
	(241261, 118, '2014-03-15 00:31:48.000000', 'temperatura', 795.0000, 'ºC'),
	(241262, 118, '2014-03-15 00:31:49.000000', 'temperatura', 775.0000, 'ºC'),
	(241263, 118, '2014-03-15 00:31:50.000000', 'temperatura', 291.0000, 'ºC'),
	(241264, 118, '2014-03-15 00:31:51.000000', 'temperatura', 329.0000, 'ºC'),
	(241265, 118, '2014-03-15 00:31:52.000000', 'temperatura', 773.0000, 'ºC'),
	(241266, 118, '2014-03-15 00:31:53.000000', 'temperatura', 478.0000, 'ºC'),
	(241267, 118, '2014-03-15 00:31:54.000000', 'temperatura', 74.0000, 'ºC'),
	(241268, 118, '2014-03-15 00:31:55.000000', 'temperatura', 134.0000, 'ºC'),
	(241269, 118, '2014-03-15 00:31:56.000000', 'temperatura', 448.0000, 'ºC'),
	(241270, 118, '2014-03-15 00:31:57.000000', 'temperatura', 638.0000, 'ºC'),
	(241271, 118, '2014-03-15 00:31:58.000000', 'temperatura', 647.0000, 'ºC'),
	(241272, 118, '2014-03-15 00:31:59.000000', 'temperatura', 123.0000, 'ºC'),
	(241273, 118, '2014-03-15 00:32:00.000000', 'temperatura', 1076.0000, 'ºC'),
	(241274, 118, '2014-03-15 00:32:01.000000', 'temperatura', 208.0000, 'ºC'),
	(241275, 118, '2014-03-15 00:32:02.000000', 'temperatura', 215.0000, 'ºC'),
	(241276, 118, '2014-03-15 00:32:03.000000', 'temperatura', 452.0000, 'ºC'),
	(241277, 118, '2014-03-15 00:32:04.000000', 'temperatura', 415.0000, 'ºC'),
	(241278, 118, '2014-03-15 00:32:05.000000', 'temperatura', 721.0000, 'ºC'),
	(241279, 118, '2014-03-15 00:32:06.000000', 'temperatura', 1159.0000, 'ºC'),
	(241280, 118, '2014-03-15 00:32:07.000000', 'temperatura', 31.0000, 'ºC'),
	(241281, 118, '2014-03-15 00:32:08.000000', 'temperatura', 280.0000, 'ºC'),
	(241282, 118, '2014-03-15 00:32:09.000000', 'temperatura', 106.0000, 'ºC'),
	(241283, 118, '2014-03-15 00:32:10.000000', 'temperatura', 893.0000, 'ºC'),
	(241284, 118, '2014-03-15 00:32:11.000000', 'temperatura', 547.0000, 'ºC'),
	(241285, 118, '2014-03-15 00:32:12.000000', 'temperatura', 58.0000, 'ºC'),
	(241286, 118, '2014-03-15 00:32:13.000000', 'temperatura', 1048.0000, 'ºC'),
	(241287, 118, '2014-03-15 00:32:14.000000', 'temperatura', 267.0000, 'ºC'),
	(241288, 118, '2014-03-15 00:32:15.000000', 'temperatura', 592.0000, 'ºC'),
	(241289, 118, '2014-03-15 00:32:16.000000', 'temperatura', 959.0000, 'ºC'),
	(241290, 118, '2014-03-15 00:32:17.000000', 'temperatura', 620.0000, 'ºC'),
	(241291, 118, '2014-03-15 00:32:18.000000', 'temperatura', 222.0000, 'ºC'),
	(241292, 118, '2014-03-15 00:32:19.000000', 'temperatura', 452.0000, 'ºC'),
	(241293, 118, '2014-03-15 00:32:20.000000', 'temperatura', 395.0000, 'ºC'),
	(241294, 118, '2014-03-15 00:32:21.000000', 'temperatura', 618.0000, 'ºC'),
	(241295, 118, '2014-03-15 00:32:22.000000', 'temperatura', 706.0000, 'ºC'),
	(241296, 118, '2014-03-15 00:32:23.000000', 'temperatura', 476.0000, 'ºC'),
	(241297, 118, '2014-03-15 00:32:24.000000', 'temperatura', 263.0000, 'ºC'),
	(241298, 118, '2014-03-15 00:32:25.000000', 'temperatura', 1089.0000, 'ºC'),
	(241299, 118, '2014-03-15 00:32:26.000000', 'temperatura', 1054.0000, 'ºC'),
	(241300, 118, '2014-03-15 00:32:27.000000', 'temperatura', 803.0000, 'ºC'),
	(241301, 118, '2014-03-15 00:32:28.000000', 'temperatura', 854.0000, 'ºC'),
	(241302, 118, '2014-03-15 00:32:29.000000', 'temperatura', 662.0000, 'ºC'),
	(241303, 118, '2014-03-15 00:32:30.000000', 'temperatura', 746.0000, 'ºC'),
	(241304, 118, '2014-03-15 00:32:31.000000', 'temperatura', 548.0000, 'ºC'),
	(241305, 118, '2014-03-15 00:32:32.000000', 'temperatura', 500.0000, 'ºC'),
	(241306, 118, '2014-03-15 00:32:33.000000', 'temperatura', 856.0000, 'ºC'),
	(241307, 118, '2014-03-15 00:32:34.000000', 'temperatura', 382.0000, 'ºC'),
	(241308, 118, '2014-03-15 00:32:35.000000', 'temperatura', 541.0000, 'ºC'),
	(241309, 118, '2014-03-15 00:32:36.000000', 'temperatura', 362.0000, 'ºC'),
	(241310, 118, '2014-03-15 00:32:37.000000', 'temperatura', 187.0000, 'ºC'),
	(241311, 118, '2014-03-15 00:32:38.000000', 'temperatura', 1050.0000, 'ºC'),
	(241312, 118, '2014-03-15 00:32:39.000000', 'temperatura', 1091.0000, 'ºC'),
	(241313, 118, '2014-03-15 00:32:40.000000', 'temperatura', 1104.0000, 'ºC'),
	(241314, 118, '2014-03-15 00:32:41.000000', 'temperatura', 1046.0000, 'ºC'),
	(241315, 118, '2014-03-15 00:32:42.000000', 'temperatura', 720.0000, 'ºC'),
	(241316, 118, '2014-03-15 00:32:43.000000', 'temperatura', 464.0000, 'ºC'),
	(241317, 118, '2014-03-15 00:32:44.000000', 'temperatura', 159.0000, 'ºC'),
	(241318, 118, '2014-03-15 00:32:45.000000', 'temperatura', 605.0000, 'ºC'),
	(241319, 118, '2014-03-15 00:32:46.000000', 'temperatura', 146.0000, 'ºC'),
	(241320, 118, '2014-03-15 00:32:47.000000', 'temperatura', 116.0000, 'ºC'),
	(241321, 118, '2014-03-15 00:32:48.000000', 'temperatura', 142.0000, 'ºC'),
	(241322, 118, '2014-03-15 00:32:49.000000', 'temperatura', 361.0000, 'ºC'),
	(241323, 118, '2014-03-15 00:32:50.000000', 'temperatura', 182.0000, 'ºC'),
	(241324, 118, '2014-03-15 00:32:51.000000', 'temperatura', 1028.0000, 'ºC'),
	(241325, 118, '2014-03-15 00:32:52.000000', 'temperatura', 992.0000, 'ºC'),
	(241326, 118, '2014-03-15 00:32:53.000000', 'temperatura', 680.0000, 'ºC'),
	(241327, 118, '2014-03-15 00:32:54.000000', 'temperatura', 421.0000, 'ºC'),
	(241328, 118, '2014-03-15 00:32:55.000000', 'temperatura', 67.0000, 'ºC'),
	(241329, 118, '2014-03-15 00:32:56.000000', 'temperatura', 272.0000, 'ºC'),
	(241330, 118, '2014-03-15 00:32:57.000000', 'temperatura', 1159.0000, 'ºC'),
	(241331, 118, '2014-03-15 00:32:58.000000', 'temperatura', 181.0000, 'ºC'),
	(241332, 118, '2014-03-15 00:32:59.000000', 'temperatura', 1029.0000, 'ºC'),
	(241333, 118, '2014-03-15 00:33:00.000000', 'temperatura', 1002.0000, 'ºC'),
	(241334, 118, '2014-03-15 00:33:01.000000', 'temperatura', 721.0000, 'ºC'),
	(241335, 118, '2014-03-15 00:33:02.000000', 'temperatura', 603.0000, 'ºC'),
	(241336, 118, '2014-03-15 00:33:03.000000', 'temperatura', 850.0000, 'ºC'),
	(241337, 118, '2014-03-15 00:33:04.000000', 'temperatura', 43.0000, 'ºC'),
	(241338, 118, '2014-03-15 00:33:05.000000', 'temperatura', 66.0000, 'ºC'),
	(241339, 118, '2014-03-15 00:33:06.000000', 'temperatura', 200.0000, 'ºC'),
	(241340, 118, '2014-03-15 00:33:07.000000', 'temperatura', 804.0000, 'ºC'),
	(241341, 118, '2014-03-15 00:33:08.000000', 'temperatura', 1022.0000, 'ºC'),
	(241342, 118, '2014-03-15 00:33:09.000000', 'temperatura', 296.0000, 'ºC'),
	(241343, 118, '2014-03-15 00:33:10.000000', 'temperatura', 814.0000, 'ºC'),
	(241344, 118, '2014-03-15 00:33:11.000000', 'temperatura', 785.0000, 'ºC'),
	(241345, 118, '2014-03-15 00:33:12.000000', 'temperatura', 283.0000, 'ºC'),
	(241346, 118, '2014-03-15 00:33:13.000000', 'temperatura', 261.0000, 'ºC'),
	(241347, 118, '2014-03-15 00:33:14.000000', 'temperatura', 457.0000, 'ºC'),
	(241348, 118, '2014-03-15 00:33:15.000000', 'temperatura', 300.0000, 'ºC'),
	(241349, 118, '2014-03-15 00:33:16.000000', 'temperatura', 129.0000, 'ºC'),
	(241350, 118, '2014-03-15 00:33:17.000000', 'temperatura', 948.0000, 'ºC'),
	(241351, 118, '2014-03-15 00:33:18.000000', 'temperatura', 754.0000, 'ºC'),
	(241352, 118, '2014-03-15 00:33:19.000000', 'temperatura', 926.0000, 'ºC'),
	(241353, 118, '2014-03-15 00:33:20.000000', 'temperatura', 1166.0000, 'ºC'),
	(241354, 118, '2014-03-15 00:33:21.000000', 'temperatura', 655.0000, 'ºC'),
	(241355, 118, '2014-03-15 00:33:22.000000', 'temperatura', 976.0000, 'ºC'),
	(241356, 118, '2014-03-15 00:33:23.000000', 'temperatura', 514.0000, 'ºC'),
	(241357, 118, '2014-03-15 00:33:24.000000', 'temperatura', 845.0000, 'ºC'),
	(241358, 118, '2014-03-15 00:33:25.000000', 'temperatura', 284.0000, 'ºC'),
	(241359, 118, '2014-03-15 00:33:26.000000', 'temperatura', 83.0000, 'ºC'),
	(241360, 118, '2014-03-15 00:33:27.000000', 'temperatura', 766.0000, 'ºC'),
	(241361, 118, '2014-03-15 00:33:28.000000', 'temperatura', 1180.0000, 'ºC'),
	(241362, 118, '2014-03-15 00:33:29.000000', 'temperatura', 4.0000, 'ºC'),
	(241363, 118, '2014-03-15 00:33:30.000000', 'temperatura', 79.0000, 'ºC'),
	(241364, 118, '2014-03-15 00:33:31.000000', 'temperatura', 383.0000, 'ºC'),
	(241365, 118, '2014-03-15 00:33:32.000000', 'temperatura', 481.0000, 'ºC'),
	(241366, 118, '2014-03-15 00:33:33.000000', 'temperatura', 54.0000, 'ºC'),
	(241367, 118, '2014-03-15 00:33:34.000000', 'temperatura', 29.0000, 'ºC'),
	(241368, 118, '2014-03-15 00:33:35.000000', 'temperatura', 1184.0000, 'ºC'),
	(241369, 118, '2014-03-15 00:33:36.000000', 'temperatura', 1031.0000, 'ºC'),
	(241370, 118, '2014-03-15 00:33:37.000000', 'temperatura', 407.0000, 'ºC'),
	(241371, 118, '2014-03-15 00:33:38.000000', 'temperatura', 140.0000, 'ºC'),
	(241372, 118, '2014-03-15 00:33:39.000000', 'temperatura', 681.0000, 'ºC'),
	(241373, 118, '2014-03-15 00:33:40.000000', 'temperatura', 583.0000, 'ºC'),
	(241374, 118, '2014-03-15 00:33:41.000000', 'temperatura', 874.0000, 'ºC'),
	(241375, 118, '2014-03-15 00:33:42.000000', 'temperatura', 221.0000, 'ºC'),
	(241376, 118, '2014-03-15 00:33:43.000000', 'temperatura', 882.0000, 'ºC'),
	(241377, 118, '2014-03-15 00:33:44.000000', 'temperatura', 149.0000, 'ºC'),
	(241378, 118, '2014-03-15 00:33:45.000000', 'temperatura', 501.0000, 'ºC'),
	(241379, 118, '2014-03-15 00:33:46.000000', 'temperatura', 857.0000, 'ºC'),
	(241380, 118, '2014-03-15 00:33:47.000000', 'temperatura', 382.0000, 'ºC'),
	(241381, 118, '2014-03-15 00:33:48.000000', 'temperatura', 541.0000, 'ºC'),
	(241382, 118, '2014-03-15 00:33:49.000000', 'temperatura', 358.0000, 'ºC'),
	(241383, 118, '2014-03-15 00:33:50.000000', 'temperatura', 170.0000, 'ºC'),
	(241384, 118, '2014-03-15 00:33:51.000000', 'temperatura', 975.0000, 'ºC'),
	(241385, 118, '2014-03-15 00:33:52.000000', 'temperatura', 765.0000, 'ºC'),
	(241386, 118, '2014-03-15 00:33:53.000000', 'temperatura', 901.0000, 'ºC'),
	(241387, 118, '2014-03-15 00:33:54.000000', 'temperatura', 1008.0000, 'ºC'),
	(241388, 118, '2014-03-15 00:33:55.000000', 'temperatura', 1141.0000, 'ºC'),
	(241389, 118, '2014-03-15 00:33:56.000000', 'temperatura', 281.0000, 'ºC'),
	(241390, 118, '2014-03-15 00:33:57.000000', 'temperatura', 380.0000, 'ºC'),
	(241391, 118, '2014-03-15 00:33:58.000000', 'temperatura', 1060.0000, 'ºC'),
	(241392, 118, '2014-03-15 00:33:59.000000', 'temperatura', 561.0000, 'ºC'),
	(241393, 118, '2014-03-15 00:34:00.000000', 'temperatura', 823.0000, 'ºC'),
	(241394, 118, '2014-03-15 00:34:01.000000', 'temperatura', 32.0000, 'ºC'),
	(241395, 118, '2014-03-15 00:34:02.000000', 'temperatura', 93.0000, 'ºC'),
	(241396, 118, '2014-03-15 00:34:03.000000', 'temperatura', 369.0000, 'ºC'),
	(241397, 118, '2014-03-15 00:34:04.000000', 'temperatura', 369.0000, 'ºC'),
	(241398, 118, '2014-03-15 00:34:05.000000', 'temperatura', 735.0000, 'ºC'),
	(241399, 118, '2014-03-15 00:34:06.000000', 'temperatura', 170.0000, 'ºC'),
	(241400, 118, '2014-03-15 00:34:07.000000', 'temperatura', 1044.0000, 'ºC'),
	(241401, 118, '2014-03-15 00:34:08.000000', 'temperatura', 1111.0000, 'ºC'),
	(241402, 118, '2014-03-15 00:34:09.000000', 'temperatura', 22.0000, 'ºC'),
	(241403, 118, '2014-03-15 00:34:10.000000', 'temperatura', 378.0000, 'ºC'),
	(241404, 118, '2014-03-15 00:34:11.000000', 'temperatura', 627.0000, 'ºC'),
	(241405, 118, '2014-03-15 00:34:12.000000', 'temperatura', 798.0000, 'ºC'),
	(241406, 118, '2014-03-15 00:34:13.000000', 'temperatura', 913.0000, 'ºC'),
	(241407, 118, '2014-03-15 00:34:14.000000', 'temperatura', 969.0000, 'ºC'),
	(241408, 118, '2014-03-15 00:34:15.000000', 'temperatura', 909.0000, 'ºC'),
	(241409, 118, '2014-03-15 00:34:16.000000', 'temperatura', 435.0000, 'ºC'),
	(241410, 118, '2014-03-15 00:34:17.000000', 'temperatura', 652.0000, 'ºC'),
	(241411, 118, '2014-03-15 00:34:18.000000', 'temperatura', 754.0000, 'ºC'),
	(241412, 118, '2014-03-15 00:34:19.000000', 'temperatura', 615.0000, 'ºC'),
	(241413, 118, '2014-03-15 00:34:20.000000', 'temperatura', 812.0000, 'ºC'),
	(241414, 118, '2014-03-15 00:34:21.000000', 'temperatura', 1018.0000, 'ºC'),
	(241415, 118, '2014-03-15 00:34:22.000000', 'temperatura', 251.0000, 'ºC'),
	(241416, 118, '2014-03-15 00:34:23.000000', 'temperatura', 605.0000, 'ºC'),
	(241417, 118, '2014-03-15 00:34:24.000000', 'temperatura', 1070.0000, 'ºC'),
	(241418, 118, '2014-03-15 00:34:25.000000', 'temperatura', 1137.0000, 'ºC'),
	(241419, 118, '2014-03-15 00:34:26.000000', 'temperatura', 77.0000, 'ºC'),
	(241420, 118, '2014-03-15 00:34:27.000000', 'temperatura', 573.0000, 'ºC'),
	(241421, 118, '2014-03-15 00:34:28.000000', 'temperatura', 234.0000, 'ºC'),
	(241422, 118, '2014-03-15 00:34:29.000000', 'temperatura', 652.0000, 'ºC'),
	(241423, 118, '2014-03-15 00:34:30.000000', 'temperatura', 160.0000, 'ºC'),
	(241424, 118, '2014-03-15 00:34:31.000000', 'temperatura', 42.0000, 'ºC'),
	(241425, 118, '2014-03-15 00:34:32.000000', 'temperatura', 930.0000, 'ºC'),
	(241426, 118, '2014-03-15 00:34:33.000000', 'temperatura', 927.0000, 'ºC'),
	(241427, 118, '2014-03-15 00:34:34.000000', 'temperatura', 644.0000, 'ºC'),
	(241428, 118, '2014-03-15 00:34:35.000000', 'temperatura', 439.0000, 'ºC'),
	(241429, 118, '2014-03-15 00:34:36.000000', 'temperatura', 265.0000, 'ºC'),
	(241430, 118, '2014-03-15 00:34:37.000000', 'temperatura', 10.0000, 'ºC'),
	(241431, 118, '2014-03-15 00:34:38.000000', 'temperatura', 453.0000, 'ºC'),
	(241432, 118, '2014-03-15 00:34:39.000000', 'temperatura', 1036.0000, 'ºC'),
	(241433, 118, '2014-03-15 00:34:40.000000', 'temperatura', 220.0000, 'ºC'),
	(241434, 118, '2014-03-15 00:34:41.000000', 'temperatura', 394.0000, 'ºC'),
	(241435, 118, '2014-03-15 00:34:42.000000', 'temperatura', 111.0000, 'ºC'),
	(241436, 118, '2014-03-15 00:34:43.000000', 'temperatura', 575.0000, 'ºC'),
	(241437, 118, '2014-03-15 00:34:44.000000', 'temperatura', 139.0000, 'ºC'),
	(241438, 118, '2014-03-15 00:34:45.000000', 'temperatura', 174.0000, 'ºC'),
	(241439, 118, '2014-03-15 00:34:46.000000', 'temperatura', 452.0000, 'ºC'),
	(241440, 118, '2014-03-15 00:34:47.000000', 'temperatura', 539.0000, 'ºC'),
	(241441, 118, '2014-03-15 00:34:48.000000', 'temperatura', 138.0000, 'ºC'),
	(241442, 118, '2014-03-15 00:34:49.000000', 'temperatura', 276.0000, 'ºC'),
	(241443, 118, '2014-03-15 00:34:50.000000', 'temperatura', 965.0000, 'ºC'),
	(241444, 118, '2014-03-15 00:34:51.000000', 'temperatura', 399.0000, 'ºC'),
	(241445, 118, '2014-03-15 00:34:52.000000', 'temperatura', 299.0000, 'ºC'),
	(241446, 118, '2014-03-15 00:34:53.000000', 'temperatura', 297.0000, 'ºC'),
	(241447, 118, '2014-03-15 00:34:54.000000', 'temperatura', 591.0000, 'ºC'),
	(241448, 118, '2014-03-15 00:34:55.000000', 'temperatura', 863.0000, 'ºC'),
	(241449, 118, '2014-03-15 00:34:56.000000', 'temperatura', 141.0000, 'ºC'),
	(241450, 118, '2014-03-15 00:34:57.000000', 'temperatura', 520.0000, 'ºC'),
	(241451, 118, '2014-03-15 00:34:58.000000', 'temperatura', 976.0000, 'ºC'),
	(241452, 118, '2014-03-15 00:34:59.000000', 'temperatura', 919.0000, 'ºC'),
	(241453, 118, '2014-03-15 00:35:00.000000', 'temperatura', 470.0000, 'ºC'),
	(241454, 118, '2014-03-15 00:35:01.000000', 'temperatura', 791.0000, 'ºC'),
	(241455, 118, '2014-03-15 00:35:02.000000', 'temperatura', 148.0000, 'ºC'),
	(241456, 118, '2014-03-15 00:35:03.000000', 'temperatura', 768.0000, 'ºC'),
	(241457, 118, '2014-03-15 00:35:04.000000', 'temperatura', 995.0000, 'ºC'),
	(241458, 118, '2014-03-15 00:35:05.000000', 'temperatura', 271.0000, 'ºC'),
	(241459, 118, '2014-03-15 00:35:06.000000', 'temperatura', 772.0000, 'ºC'),
	(241460, 118, '2014-03-15 00:35:07.000000', 'temperatura', 648.0000, 'ºC'),
	(241461, 118, '2014-03-15 00:35:08.000000', 'temperatura', 923.0000, 'ºC'),
	(241462, 118, '2014-03-15 00:35:09.000000', 'temperatura', 273.0000, 'ºC'),
	(241463, 118, '2014-03-15 00:35:10.000000', 'temperatura', 998.0000, 'ºC'),
	(241464, 118, '2014-03-15 00:35:11.000000', 'temperatura', 569.0000, 'ºC'),
	(241465, 118, '2014-03-15 00:35:12.000000', 'temperatura', 1054.0000, 'ºC'),
	(241466, 118, '2014-03-15 00:35:13.000000', 'temperatura', 1160.0000, 'ºC'),
	(241467, 118, '2014-03-15 00:35:14.000000', 'temperatura', 242.0000, 'ºC'),
	(241468, 118, '2014-03-15 00:35:15.000000', 'temperatura', 129.0000, 'ºC'),
	(241469, 118, '2014-03-15 00:35:16.000000', 'temperatura', 1121.0000, 'ºC'),
	(241470, 118, '2014-03-15 00:35:17.000000', 'temperatura', 416.0000, 'ºC'),
	(241471, 118, '2014-03-15 00:35:18.000000', 'temperatura', 1119.0000, 'ºC'),
	(241472, 118, '2014-03-15 00:35:19.000000', 'temperatura', 748.0000, 'ºC'),
	(241473, 118, '2014-03-15 00:35:20.000000', 'temperatura', 384.0000, 'ºC'),
	(241474, 118, '2014-03-15 00:35:21.000000', 'temperatura', 877.0000, 'ºC'),
	(241475, 118, '2014-03-15 00:35:22.000000', 'temperatura', 831.0000, 'ºC'),
	(241476, 118, '2014-03-15 00:35:23.000000', 'temperatura', 324.0000, 'ºC'),
	(241477, 118, '2014-03-15 00:35:24.000000', 'temperatura', 327.0000, 'ºC'),
	(241478, 118, '2014-03-15 00:35:25.000000', 'temperatura', 666.0000, 'ºC'),
	(241479, 118, '2014-03-15 00:35:26.000000', 'temperatura', 1147.0000, 'ºC'),
	(241480, 118, '2014-03-15 00:35:27.000000', 'temperatura', 139.0000, 'ºC'),
	(241481, 118, '2014-03-15 00:35:28.000000', 'temperatura', 856.0000, 'ºC'),
	(241482, 118, '2014-03-15 00:35:29.000000', 'temperatura', 261.0000, 'ºC'),
	(241483, 118, '2014-03-15 00:35:30.000000', 'temperatura', 1140.0000, 'ºC'),
	(241484, 118, '2014-03-15 00:35:31.000000', 'temperatura', 116.0000, 'ºC'),
	(241485, 118, '2014-03-15 00:35:32.000000', 'temperatura', 761.0000, 'ºC'),
	(241486, 118, '2014-03-15 00:35:33.000000', 'temperatura', 1059.0000, 'ºC'),
	(241487, 118, '2014-03-15 00:35:34.000000', 'temperatura', 613.0000, 'ºC'),
	(241488, 118, '2014-03-15 00:35:35.000000', 'temperatura', 1088.0000, 'ºC'),
	(241489, 118, '2014-03-15 00:35:36.000000', 'temperatura', 1.0000, 'ºC'),
	(241490, 118, '2014-03-15 00:35:37.000000', 'temperatura', 342.0000, 'ºC'),
	(241491, 118, '2014-03-15 00:35:38.000000', 'temperatura', 509.0000, 'ºC'),
	(241492, 118, '2014-03-15 00:35:39.000000', 'temperatura', 317.0000, 'ºC'),
	(241493, 118, '2014-03-15 00:35:40.000000', 'temperatura', 61.0000, 'ºC'),
	(241494, 118, '2014-03-15 00:35:41.000000', 'temperatura', 552.0000, 'ºC'),
	(241495, 118, '2014-03-15 00:35:42.000000', 'temperatura', 180.0000, 'ºC'),
	(241496, 118, '2014-03-15 00:35:43.000000', 'temperatura', 442.0000, 'ºC'),
	(241497, 118, '2014-03-15 00:35:44.000000', 'temperatura', 472.0000, 'ºC'),
	(241498, 118, '2014-03-15 00:35:45.000000', 'temperatura', 1035.0000, 'ºC'),
	(241499, 118, '2014-03-15 00:35:46.000000', 'temperatura', 158.0000, 'ºC'),
	(241500, 118, '2014-03-15 00:35:47.000000', 'temperatura', 86.0000, 'ºC'),
	(241501, 118, '2014-03-15 00:35:48.000000', 'temperatura', 1155.0000, 'ºC'),
	(241502, 118, '2014-03-15 00:35:49.000000', 'temperatura', 717.0000, 'ºC'),
	(241503, 118, '2014-03-15 00:35:50.000000', 'temperatura', 121.0000, 'ºC'),
	(241504, 118, '2014-03-15 00:35:51.000000', 'temperatura', 855.0000, 'ºC'),
	(241505, 118, '2014-03-15 00:35:52.000000', 'temperatura', 314.0000, 'ºC'),
	(241506, 118, '2014-03-15 00:35:53.000000', 'temperatura', 205.0000, 'ºC'),
	(241507, 118, '2014-03-15 00:35:54.000000', 'temperatura', 84.0000, 'ºC'),
	(241508, 118, '2014-03-15 00:35:55.000000', 'temperatura', 1006.0000, 'ºC'),
	(241509, 118, '2014-03-15 00:35:56.000000', 'temperatura', 1178.0000, 'ºC'),
	(241510, 118, '2014-03-15 00:35:57.000000', 'temperatura', 474.0000, 'ºC'),
	(241511, 118, '2014-03-15 00:35:58.000000', 'temperatura', 35.0000, 'ºC'),
	(241512, 118, '2014-03-15 00:35:59.000000', 'temperatura', 1153.0000, 'ºC'),
	(241513, 118, '2014-03-15 00:36:00.000000', 'temperatura', 861.0000, 'ºC'),
	(241514, 118, '2014-03-15 00:36:01.000000', 'temperatura', 846.0000, 'ºC'),
	(241515, 118, '2014-03-15 00:36:02.000000', 'temperatura', 449.0000, 'ºC'),
	(241516, 118, '2014-03-15 00:36:03.000000', 'temperatura', 908.0000, 'ºC'),
	(241517, 118, '2014-03-15 00:36:04.000000', 'temperatura', 794.0000, 'ºC'),
	(241518, 118, '2014-03-15 00:36:05.000000', 'temperatura', 45.0000, 'ºC'),
	(241519, 118, '2014-03-15 00:36:06.000000', 'temperatura', 243.0000, 'ºC'),
	(241520, 118, '2014-03-15 00:36:07.000000', 'temperatura', 1080.0000, 'ºC'),
	(241521, 118, '2014-03-15 00:36:08.000000', 'temperatura', 1072.0000, 'ºC'),
	(241522, 118, '2014-03-15 00:36:09.000000', 'temperatura', 922.0000, 'ºC'),
	(241523, 118, '2014-03-15 00:36:10.000000', 'temperatura', 193.0000, 'ºC'),
	(241524, 118, '2014-03-15 00:36:11.000000', 'temperatura', 598.0000, 'ºC'),
	(241525, 118, '2014-03-15 00:36:12.000000', 'temperatura', 15.0000, 'ºC'),
	(241526, 118, '2014-03-15 00:36:13.000000', 'temperatura', 678.0000, 'ºC'),
	(241527, 118, '2014-03-15 00:36:14.000000', 'temperatura', 948.0000, 'ºC'),
	(241528, 118, '2014-03-15 00:36:15.000000', 'temperatura', 304.0000, 'ºC'),
	(241529, 118, '2014-03-15 00:36:16.000000', 'temperatura', 1077.0000, 'ºC'),
	(241530, 118, '2014-03-15 00:36:17.000000', 'temperatura', 873.0000, 'ºC'),
	(241531, 118, '2014-03-15 00:36:18.000000', 'temperatura', 1137.0000, 'ºC'),
	(241532, 118, '2014-03-15 00:36:19.000000', 'temperatura', 665.0000, 'ºC'),
	(241533, 118, '2014-03-15 00:36:20.000000', 'temperatura', 1117.0000, 'ºC'),
	(241534, 118, '2014-03-15 00:36:21.000000', 'temperatura', 1188.0000, 'ºC'),
	(241535, 118, '2014-03-15 00:36:22.000000', 'temperatura', 189.0000, 'ºC'),
	(241536, 118, '2014-03-15 00:36:23.000000', 'temperatura', 984.0000, 'ºC'),
	(241537, 118, '2014-03-15 00:36:24.000000', 'temperatura', 750.0000, 'ºC'),
	(241538, 118, '2014-03-15 00:36:25.000000', 'temperatura', 802.0000, 'ºC'),
	(241539, 118, '2014-03-15 00:36:26.000000', 'temperatura', 558.0000, 'ºC'),
	(241540, 118, '2014-03-15 00:36:27.000000', 'temperatura', 385.0000, 'ºC'),
	(241541, 118, '2014-03-15 00:36:28.000000', 'temperatura', 252.0000, 'ºC'),
	(241542, 118, '2014-03-15 00:36:29.000000', 'temperatura', 107.0000, 'ºC'),
	(241543, 118, '2014-03-15 00:36:30.000000', 'temperatura', 979.0000, 'ºC'),
	(241544, 118, '2014-03-15 00:36:31.000000', 'temperatura', 973.0000, 'ºC'),
	(241545, 118, '2014-03-15 00:36:32.000000', 'temperatura', 731.0000, 'ºC'),
	(241546, 118, '2014-03-15 00:36:33.000000', 'temperatura', 736.0000, 'ºC'),
	(241547, 118, '2014-03-15 00:36:34.000000', 'temperatura', 288.0000, 'ºC'),
	(241548, 118, '2014-03-15 00:36:35.000000', 'temperatura', 433.0000, 'ºC'),
	(241549, 118, '2014-03-15 00:36:36.000000', 'temperatura', 99.0000, 'ºC'),
	(241550, 118, '2014-03-15 00:36:37.000000', 'temperatura', 397.0000, 'ºC'),
	(241551, 118, '2014-03-15 00:36:38.000000', 'temperatura', 487.0000, 'ºC'),
	(241552, 118, '2014-03-15 00:36:39.000000', 'temperatura', 46.0000, 'ºC'),
	(241553, 118, '2014-03-15 00:36:40.000000', 'temperatura', 1171.0000, 'ºC'),
	(241554, 118, '2014-03-15 00:36:41.000000', 'temperatura', 919.0000, 'ºC'),
	(241555, 118, '2014-03-15 00:36:42.000000', 'temperatura', 1079.0000, 'ºC'),
	(241556, 118, '2014-03-15 00:36:43.000000', 'temperatura', 238.0000, 'ºC'),
	(241557, 118, '2014-03-15 00:36:44.000000', 'temperatura', 353.0000, 'ºC'),
	(241558, 118, '2014-03-15 00:36:45.000000', 'temperatura', 1053.0000, 'ºC'),
	(241559, 118, '2014-03-15 00:36:46.000000', 'temperatura', 607.0000, 'ºC'),
	(241560, 118, '2014-03-15 00:36:47.000000', 'temperatura', 1076.0000, 'ºC'),
	(241561, 118, '2014-03-15 00:36:48.000000', 'temperatura', 1160.0000, 'ºC'),
	(241562, 118, '2014-03-15 00:36:49.000000', 'temperatura', 171.0000, 'ºC'),
	(241563, 118, '2014-03-15 00:36:50.000000', 'temperatura', 978.0000, 'ºC'),
	(241564, 118, '2014-03-15 00:36:51.000000', 'temperatura', 778.0000, 'ºC'),
	(241565, 118, '2014-03-15 00:36:52.000000', 'temperatura', 956.0000, 'ºC'),
	(241566, 118, '2014-03-15 00:36:53.000000', 'temperatura', 45.0000, 'ºC'),
	(241567, 118, '2014-03-15 00:36:54.000000', 'temperatura', 960.0000, 'ºC'),
	(241568, 118, '2014-03-15 00:36:55.000000', 'temperatura', 1065.0000, 'ºC'),
	(241569, 118, '2014-03-15 00:36:56.000000', 'temperatura', 44.0000, 'ºC'),
	(241570, 118, '2014-03-15 00:36:57.000000', 'temperatura', 628.0000, 'ºC'),
	(241571, 118, '2014-03-15 00:36:58.000000', 'temperatura', 607.0000, 'ºC'),
	(241572, 118, '2014-03-15 00:36:59.000000', 'temperatura', 1153.0000, 'ºC'),
	(241573, 118, '2014-03-15 00:37:00.000000', 'temperatura', 343.0000, 'ºC'),
	(241574, 118, '2014-03-15 00:37:01.000000', 'temperatura', 657.0000, 'ºC'),
	(241575, 118, '2014-03-15 00:37:02.000000', 'temperatura', 1057.0000, 'ºC'),
	(241576, 118, '2014-03-15 00:37:03.000000', 'temperatura', 914.0000, 'ºC'),
	(241577, 118, '2014-03-15 00:37:04.000000', 'temperatura', 200.0000, 'ºC'),
	(241578, 118, '2014-03-15 00:37:05.000000', 'temperatura', 657.0000, 'ºC'),
	(241579, 118, '2014-03-15 00:37:06.000000', 'temperatura', 287.0000, 'ºC'),
	(241580, 118, '2014-03-15 00:37:07.000000', 'temperatura', 664.0000, 'ºC'),
	(241581, 118, '2014-03-15 00:37:08.000000', 'temperatura', 58.0000, 'ºC'),
	(241582, 118, '2014-03-15 00:37:09.000000', 'temperatura', 698.0000, 'ºC'),
	(241583, 118, '2014-03-15 00:37:10.000000', 'temperatura', 918.0000, 'ºC'),
	(241584, 118, '2014-03-15 00:37:11.000000', 'temperatura', 96.0000, 'ºC'),
	(241585, 118, '2014-03-15 00:37:12.000000', 'temperatura', 128.0000, 'ºC'),
	(241586, 118, '2014-03-15 00:37:13.000000', 'temperatura', 353.0000, 'ºC'),
	(241587, 118, '2014-03-15 00:37:14.000000', 'temperatura', 179.0000, 'ºC'),
	(241588, 118, '2014-03-15 00:37:15.000000', 'temperatura', 1036.0000, 'ºC'),
	(241589, 118, '2014-03-15 00:37:16.000000', 'temperatura', 1046.0000, 'ºC'),
	(241590, 118, '2014-03-15 00:37:17.000000', 'temperatura', 921.0000, 'ºC'),
	(241591, 118, '2014-03-15 00:37:18.000000', 'temperatura', 266.0000, 'ºC'),
	(241592, 118, '2014-03-15 00:37:19.000000', 'temperatura', 969.0000, 'ºC'),
	(241593, 118, '2014-03-15 00:37:20.000000', 'temperatura', 448.0000, 'ºC'),
	(241594, 118, '2014-03-15 00:37:21.000000', 'temperatura', 532.0000, 'ºC'),
	(241595, 118, '2014-03-15 00:37:22.000000', 'temperatura', 119.0000, 'ºC'),
	(241596, 118, '2014-03-15 00:37:23.000000', 'temperatura', 196.0000, 'ºC'),
	(241597, 118, '2014-03-15 00:37:24.000000', 'temperatura', 626.0000, 'ºC'),
	(241598, 118, '2014-03-15 00:37:25.000000', 'temperatura', 141.0000, 'ºC'),
	(241599, 118, '2014-03-15 00:37:26.000000', 'temperatura', 29.0000, 'ºC'),
	(241600, 118, '2014-03-15 00:37:27.000000', 'temperatura', 920.0000, 'ºC'),
	(241601, 118, '2014-03-15 00:37:28.000000', 'temperatura', 915.0000, 'ºC'),
	(241602, 118, '2014-03-15 00:37:29.000000', 'temperatura', 617.0000, 'ºC'),
	(241603, 118, '2014-03-15 00:37:30.000000', 'temperatura', 339.0000, 'ºC'),
	(241604, 118, '2014-03-15 00:37:31.000000', 'temperatura', 1046.0000, 'ºC'),
	(241605, 118, '2014-03-15 00:37:32.000000', 'temperatura', 612.0000, 'ºC'),
	(241606, 118, '2014-03-15 00:37:33.000000', 'temperatura', 1124.0000, 'ºC'),
	(241607, 118, '2014-03-15 00:37:34.000000', 'temperatura', 183.0000, 'ºC'),
	(241608, 118, '2014-03-15 00:37:35.000000', 'temperatura', 1145.0000, 'ºC'),
	(241609, 118, '2014-03-15 00:37:36.000000', 'temperatura', 377.0000, 'ºC'),
	(241610, 118, '2014-03-15 00:37:37.000000', 'temperatura', 848.0000, 'ºC'),
	(241611, 118, '2014-03-15 00:37:38.000000', 'temperatura', 712.0000, 'ºC'),
	(241612, 118, '2014-03-15 00:37:39.000000', 'temperatura', 1017.0000, 'ºC'),
	(241613, 118, '2014-03-15 00:37:40.000000', 'temperatura', 549.0000, 'ºC'),
	(241614, 118, '2014-03-15 00:37:41.000000', 'temperatura', 892.0000, 'ºC'),
	(241615, 118, '2014-03-15 00:37:42.000000', 'temperatura', 417.0000, 'ºC'),
	(241616, 118, '2014-03-15 00:37:43.000000', 'temperatura', 606.0000, 'ºC'),
	(241617, 118, '2014-03-15 00:37:44.000000', 'temperatura', 581.0000, 'ºC'),
	(241618, 118, '2014-03-15 00:37:45.000000', 'temperatura', 1090.0000, 'ºC'),
	(241619, 118, '2014-03-15 00:37:46.000000', 'temperatura', 104.0000, 'ºC'),
	(241620, 118, '2014-03-15 00:37:47.000000', 'temperatura', 850.0000, 'ºC'),
	(241621, 118, '2014-03-15 00:37:48.000000', 'temperatura', 340.0000, 'ºC'),
	(241622, 118, '2014-03-15 00:37:49.000000', 'temperatura', 351.0000, 'ºC'),
	(241623, 118, '2014-03-15 00:37:50.000000', 'temperatura', 734.0000, 'ºC'),
	(241624, 118, '2014-03-15 00:37:51.000000', 'temperatura', 216.0000, 'ºC'),
	(241625, 118, '2014-03-15 00:37:52.000000', 'temperatura', 80.0000, 'ºC'),
	(241626, 118, '2014-03-15 00:37:53.000000', 'temperatura', 954.0000, 'ºC'),
	(241627, 118, '2014-03-15 00:37:54.000000', 'temperatura', 929.0000, 'ºC'),
	(241628, 118, '2014-03-15 00:37:55.000000', 'temperatura', 582.0000, 'ºC'),
	(241629, 118, '2014-03-15 00:37:56.000000', 'temperatura', 127.0000, 'ºC'),
	(241630, 118, '2014-03-15 00:37:57.000000', 'temperatura', 87.0000, 'ºC'),
	(241631, 118, '2014-03-15 00:37:58.000000', 'temperatura', 54.0000, 'ºC'),
	(241632, 118, '2014-03-15 00:37:59.000000', 'temperatura', 12.0000, 'ºC'),
	(241633, 118, '2014-03-15 00:38:00.000000', 'temperatura', 1095.0000, 'ºC'),
	(241634, 118, '2014-03-15 00:38:01.000000', 'temperatura', 642.0000, 'ºC'),
	(241635, 118, '2014-03-15 00:38:02.000000', 'temperatura', 1125.0000, 'ºC'),
	(241636, 118, '2014-03-15 00:38:03.000000', 'temperatura', 98.0000, 'ºC'),
	(241637, 118, '2014-03-15 00:38:04.000000', 'temperatura', 718.0000, 'ºC'),
	(241638, 118, '2014-03-15 00:38:05.000000', 'temperatura', 894.0000, 'ºC'),
	(241639, 118, '2014-03-15 00:38:06.000000', 'temperatura', 1119.0000, 'ºC'),
	(241640, 118, '2014-03-15 00:38:07.000000', 'temperatura', 513.0000, 'ºC'),
	(241641, 118, '2014-03-15 00:38:08.000000', 'temperatura', 408.0000, 'ºC'),
	(241642, 118, '2014-03-15 00:38:09.000000', 'temperatura', 500.0000, 'ºC'),
	(241643, 118, '2014-03-15 00:38:10.000000', 'temperatura', 76.0000, 'ºC'),
	(241644, 118, '2014-03-15 00:38:11.000000', 'temperatura', 80.0000, 'ºC'),
	(241645, 118, '2014-03-15 00:38:12.000000', 'temperatura', 173.0000, 'ºC'),
	(241646, 118, '2014-03-15 00:38:13.000000', 'temperatura', 627.0000, 'ºC'),
	(241647, 118, '2014-03-15 00:38:14.000000', 'temperatura', 214.0000, 'ºC'),
	(241648, 118, '2014-03-15 00:38:15.000000', 'temperatura', 393.0000, 'ºC'),
	(241649, 118, '2014-03-15 00:38:16.000000', 'temperatura', 121.0000, 'ºC'),
	(241650, 118, '2014-03-15 00:38:17.000000', 'temperatura', 625.0000, 'ºC'),
	(241651, 118, '2014-03-15 00:38:18.000000', 'temperatura', 366.0000, 'ºC'),
	(241652, 118, '2014-03-15 00:38:19.000000', 'temperatura', 1152.0000, 'ºC'),
	(241653, 118, '2014-03-15 00:38:20.000000', 'temperatura', 1066.0000, 'ºC'),
	(241654, 118, '2014-03-15 00:38:21.000000', 'temperatura', 672.0000, 'ºC'),
	(241655, 118, '2014-03-15 00:38:22.000000', 'temperatura', 163.0000, 'ºC'),
	(241656, 118, '2014-03-15 00:38:23.000000', 'temperatura', 1198.0000, 'ºC'),
	(241657, 118, '2014-03-15 00:38:24.000000', 'temperatura', 702.0000, 'ºC'),
	(241658, 118, '2014-03-15 00:38:25.000000', 'temperatura', 1119.0000, 'ºC'),
	(241659, 118, '2014-03-15 00:38:26.000000', 'temperatura', 1088.0000, 'ºC'),
	(241660, 118, '2014-03-15 00:38:27.000000', 'temperatura', 882.0000, 'ºC'),
	(241661, 118, '2014-03-15 00:38:28.000000', 'temperatura', 1146.0000, 'ºC'),
	(241662, 118, '2014-03-15 00:38:29.000000', 'temperatura', 687.0000, 'ºC'),
	(241663, 118, '2014-03-15 00:38:30.000000', 'temperatura', 1195.0000, 'ºC'),
	(241664, 118, '2014-03-15 00:38:31.000000', 'temperatura', 314.0000, 'ºC'),
	(241665, 118, '2014-03-15 00:38:32.000000', 'temperatura', 386.0000, 'ºC'),
	(241666, 118, '2014-03-15 00:38:33.000000', 'temperatura', 991.0000, 'ºC'),
	(241667, 118, '2014-03-15 00:38:34.000000', 'temperatura', 196.0000, 'ºC'),
	(241668, 118, '2014-03-15 00:38:35.000000', 'temperatura', 407.0000, 'ºC'),
	(241669, 118, '2014-03-15 00:38:36.000000', 'temperatura', 248.0000, 'ºC'),
	(241670, 118, '2014-03-15 00:38:37.000000', 'temperatura', 17.0000, 'ºC'),
	(241671, 118, '2014-03-15 00:38:38.000000', 'temperatura', 545.0000, 'ºC'),
	(241672, 118, '2014-03-15 00:38:39.000000', 'temperatura', 272.0000, 'ºC'),
	(241673, 118, '2014-03-15 00:38:40.000000', 'temperatura', 925.0000, 'ºC'),
	(241674, 118, '2014-03-15 00:38:41.000000', 'temperatura', 209.0000, 'ºC'),
	(241675, 118, '2014-03-15 00:38:42.000000', 'temperatura', 669.0000, 'ºC'),
	(241676, 118, '2014-03-15 00:38:43.000000', 'temperatura', 322.0000, 'ºC'),
	(241677, 118, '2014-03-15 00:38:44.000000', 'temperatura', 803.0000, 'ºC'),
	(241678, 118, '2014-03-15 00:38:45.000000', 'temperatura', 649.0000, 'ºC'),
	(241679, 118, '2014-03-15 00:38:46.000000', 'temperatura', 835.0000, 'ºC'),
	(241680, 118, '2014-03-15 00:38:47.000000', 'temperatura', 1030.0000, 'ºC'),
	(241681, 118, '2014-03-15 00:38:48.000000', 'temperatura', 247.0000, 'ºC'),
	(241682, 118, '2014-03-15 00:38:49.000000', 'temperatura', 544.0000, 'ºC'),
	(241683, 118, '2014-03-15 00:38:50.000000', 'temperatura', 779.0000, 'ºC'),
	(241684, 118, '2014-03-15 00:38:51.000000', 'temperatura', 1062.0000, 'ºC'),
	(241685, 118, '2014-03-15 00:38:52.000000', 'temperatura', 576.0000, 'ºC'),
	(241686, 118, '2014-03-15 00:38:53.000000', 'temperatura', 894.0000, 'ºC'),
	(241687, 118, '2014-03-15 00:38:54.000000', 'temperatura', 343.0000, 'ºC'),
	(241688, 118, '2014-03-15 00:38:55.000000', 'temperatura', 232.0000, 'ºC'),
	(241689, 118, '2014-03-15 00:38:56.000000', 'temperatura', 133.0000, 'ºC'),
	(241690, 118, '2014-03-15 00:38:57.000000', 'temperatura', 1170.0000, 'ºC'),
	(241691, 118, '2014-03-15 00:38:58.000000', 'temperatura', 652.0000, 'ºC'),
	(241692, 118, '2014-03-15 00:38:59.000000', 'temperatura', 952.0000, 'ºC'),
	(241693, 118, '2014-03-15 00:39:00.000000', 'temperatura', 401.0000, 'ºC'),
	(241694, 118, '2014-03-15 00:39:01.000000', 'temperatura', 353.0000, 'ºC'),
	(241695, 118, '2014-03-15 00:39:02.000000', 'temperatura', 560.0000, 'ºC'),
	(241696, 118, '2014-03-15 00:39:03.000000', 'temperatura', 543.0000, 'ºC'),
	(241697, 118, '2014-03-15 00:39:04.000000', 'temperatura', 1033.0000, 'ºC'),
	(241698, 118, '2014-03-15 00:39:05.000000', 'temperatura', 1138.0000, 'ºC'),
	(241699, 118, '2014-03-15 00:39:06.000000', 'temperatura', 192.0000, 'ºC'),
	(241700, 118, '2014-03-15 00:39:07.000000', 'temperatura', 1144.0000, 'ºC'),
	(241701, 118, '2014-03-15 00:39:08.000000', 'temperatura', 346.0000, 'ºC'),
	(241702, 118, '2014-03-15 00:39:09.000000', 'temperatura', 697.0000, 'ºC'),
	(241703, 118, '2014-03-15 00:39:10.000000', 'temperatura', 49.0000, 'ºC'),
	(241704, 118, '2014-03-15 00:39:11.000000', 'temperatura', 556.0000, 'ºC'),
	(241705, 118, '2014-03-15 00:39:12.000000', 'temperatura', 233.0000, 'ºC'),
	(241706, 118, '2014-03-15 00:39:13.000000', 'temperatura', 698.0000, 'ºC'),
	(241707, 118, '2014-03-15 00:39:14.000000', 'temperatura', 392.0000, 'ºC'),
	(241708, 118, '2014-03-15 00:39:15.000000', 'temperatura', 1066.0000, 'ºC'),
	(241709, 118, '2014-03-15 00:39:16.000000', 'temperatura', 552.0000, 'ºC'),
	(241710, 118, '2014-03-15 00:39:17.000000', 'temperatura', 766.0000, 'ºC'),
	(241711, 118, '2014-03-15 00:39:18.000000', 'temperatura', 973.0000, 'ºC'),
	(241712, 118, '2014-03-15 00:39:19.000000', 'temperatura', 168.0000, 'ºC'),
	(241713, 118, '2014-03-15 00:39:20.000000', 'temperatura', 322.0000, 'ºC'),
	(241714, 118, '2014-03-15 00:39:21.000000', 'temperatura', 1108.0000, 'ºC'),
	(241715, 118, '2014-03-15 00:39:22.000000', 'temperatura', 973.0000, 'ºC'),
	(241716, 118, '2014-03-15 00:39:23.000000', 'temperatura', 342.0000, 'ºC'),
	(241717, 118, '2014-03-15 00:39:24.000000', 'temperatura', 1191.0000, 'ºC'),
	(241718, 118, '2014-03-15 00:39:25.000000', 'temperatura', 128.0000, 'ºC'),
	(241719, 118, '2014-03-15 00:39:26.000000', 'temperatura', 667.0000, 'ºC'),
	(241720, 118, '2014-03-15 00:39:27.000000', 'temperatura', 551.0000, 'ºC'),
	(241721, 118, '2014-03-15 00:39:28.000000', 'temperatura', 754.0000, 'ºC'),
	(241722, 118, '2014-03-15 00:39:29.000000', 'temperatura', 917.0000, 'ºC'),
	(241723, 118, '2014-03-15 00:39:30.000000', 'temperatura', 1124.0000, 'ºC'),
	(241724, 118, '2014-03-15 00:39:31.000000', 'temperatura', 469.0000, 'ºC'),
	(241725, 118, '2014-03-15 00:39:32.000000', 'temperatura', 173.0000, 'ºC'),
	(241726, 118, '2014-03-15 00:39:33.000000', 'temperatura', 661.0000, 'ºC'),
	(241727, 118, '2014-03-15 00:39:34.000000', 'temperatura', 386.0000, 'ºC'),
	(241728, 118, '2014-03-15 00:39:35.000000', 'temperatura', 1147.0000, 'ºC'),
	(241729, 118, '2014-03-15 00:39:36.000000', 'temperatura', 978.0000, 'ºC'),
	(241730, 118, '2014-03-15 00:39:37.000000', 'temperatura', 248.0000, 'ºC'),
	(241731, 118, '2014-03-15 00:39:38.000000', 'temperatura', 707.0000, 'ºC'),
	(241732, 118, '2014-03-15 00:39:39.000000', 'temperatura', 391.0000, 'ºC'),
	(241733, 118, '2014-03-15 00:39:40.000000', 'temperatura', 1034.0000, 'ºC'),
	(241734, 118, '2014-03-15 00:39:41.000000', 'temperatura', 397.0000, 'ºC'),
	(241735, 118, '2014-03-15 00:39:42.000000', 'temperatura', 84.0000, 'ºC'),
	(241736, 118, '2014-03-15 00:39:43.000000', 'temperatura', 428.0000, 'ºC'),
	(241737, 118, '2014-03-15 00:39:44.000000', 'temperatura', 688.0000, 'ºC'),
	(241738, 118, '2014-03-15 00:39:45.000000', 'temperatura', 959.0000, 'ºC'),
	(241739, 118, '2014-03-15 00:39:46.000000', 'temperatura', 333.0000, 'ºC'),
	(241740, 118, '2014-03-15 00:39:47.000000', 'temperatura', 1185.0000, 'ºC'),
	(241741, 118, '2014-03-15 00:39:48.000000', 'temperatura', 128.0000, 'ºC'),
	(241742, 118, '2014-03-15 00:39:49.000000', 'temperatura', 684.0000, 'ºC'),
	(241743, 118, '2014-03-15 00:39:50.000000', 'temperatura', 637.0000, 'ºC'),
	(241744, 118, '2014-03-15 00:39:51.000000', 'temperatura', 1134.0000, 'ºC'),
	(241745, 118, '2014-03-15 00:39:52.000000', 'temperatura', 161.0000, 'ºC'),
	(241746, 118, '2014-03-15 00:39:53.000000', 'temperatura', 1001.0000, 'ºC'),
	(241747, 118, '2014-03-15 00:39:54.000000', 'temperatura', 922.0000, 'ºC'),
	(241748, 118, '2014-03-15 00:39:55.000000', 'temperatura', 409.0000, 'ºC'),
	(241749, 118, '2014-03-15 00:39:56.000000', 'temperatura', 481.0000, 'ºC'),
	(241750, 118, '2014-03-15 00:39:57.000000', 'temperatura', 1177.0000, 'ºC'),
	(241751, 118, '2014-03-15 00:39:58.000000', 'temperatura', 842.0000, 'ºC'),
	(241752, 118, '2014-03-15 00:39:59.000000', 'temperatura', 679.0000, 'ºC'),
	(241753, 118, '2014-03-15 00:40:00.000000', 'temperatura', 872.0000, 'ºC'),
	(241754, 118, '2014-03-15 00:40:01.000000', 'temperatura', 1121.0000, 'ºC'),
	(241755, 118, '2014-03-15 00:40:02.000000', 'temperatura', 589.0000, 'ºC'),
	(241756, 118, '2014-03-15 00:40:03.000000', 'temperatura', 783.0000, 'ºC'),
	(241757, 118, '2014-03-15 00:40:04.000000', 'temperatura', 949.0000, 'ºC'),
	(241758, 118, '2014-03-15 00:40:05.000000', 'temperatura', 1198.0000, 'ºC'),
	(241759, 118, '2014-03-15 00:40:06.000000', 'temperatura', 743.0000, 'ºC'),
	(241760, 118, '2014-03-15 00:40:07.000000', 'temperatura', 121.0000, 'ºC'),
	(241761, 118, '2014-03-15 00:40:08.000000', 'temperatura', 777.0000, 'ºC'),
	(241762, 118, '2014-03-15 00:40:09.000000', 'temperatura', 1123.0000, 'ºC'),
	(241763, 118, '2014-03-15 00:40:10.000000', 'temperatura', 883.0000, 'ºC'),
	(241764, 118, '2014-03-15 00:40:11.000000', 'temperatura', 1047.0000, 'ºC'),
	(241765, 118, '2014-03-15 00:40:12.000000', 'temperatura', 188.0000, 'ºC'),
	(241766, 118, '2014-03-15 00:40:13.000000', 'temperatura', 200.0000, 'ºC'),
	(241767, 118, '2014-03-15 00:40:14.000000', 'temperatura', 434.0000, 'ºC'),
	(241768, 118, '2014-03-15 00:40:15.000000', 'temperatura', 372.0000, 'ºC'),
	(241769, 118, '2014-03-15 00:40:16.000000', 'temperatura', 556.0000, 'ºC'),
	(241770, 118, '2014-03-15 00:40:17.000000', 'temperatura', 467.0000, 'ºC'),
	(241771, 118, '2014-03-15 00:40:18.000000', 'temperatura', 666.0000, 'ºC'),
	(241772, 118, '2014-03-15 00:40:19.000000', 'temperatura', 729.0000, 'ºC'),
	(241773, 118, '2014-03-15 00:40:20.000000', 'temperatura', 446.0000, 'ºC'),
	(241774, 118, '2014-03-15 00:40:21.000000', 'temperatura', 46.0000, 'ºC'),
	(241775, 118, '2014-03-15 00:40:22.000000', 'temperatura', 94.0000, 'ºC'),
	(241776, 118, '2014-03-15 00:40:23.000000', 'temperatura', 330.0000, 'ºC'),
	(241777, 118, '2014-03-15 00:40:24.000000', 'temperatura', 169.0000, 'ºC'),
	(241778, 118, '2014-03-15 00:40:25.000000', 'temperatura', 1056.0000, 'ºC'),
	(241779, 118, '2014-03-15 00:40:26.000000', 'temperatura', 1175.0000, 'ºC'),
	(241780, 118, '2014-03-15 00:40:27.000000', 'temperatura', 304.0000, 'ºC'),
	(241781, 118, '2014-03-15 00:40:28.000000', 'temperatura', 398.0000, 'ºC'),
	(241782, 118, '2014-03-15 00:40:29.000000', 'temperatura', 1078.0000, 'ºC'),
	(241783, 118, '2014-03-15 00:40:30.000000', 'temperatura', 595.0000, 'ºC'),
	(241784, 118, '2014-03-15 00:40:31.000000', 'temperatura', 944.0000, 'ºC'),
	(241785, 118, '2014-03-15 00:40:32.000000', 'temperatura', 535.0000, 'ºC'),
	(241786, 118, '2014-03-15 00:40:33.000000', 'temperatura', 1042.0000, 'ºC'),
	(241787, 118, '2014-03-15 00:40:34.000000', 'temperatura', 8.0000, 'ºC'),
	(241788, 118, '2014-03-15 00:40:35.000000', 'temperatura', 513.0000, 'ºC'),
	(241789, 118, '2014-03-15 00:40:36.000000', 'temperatura', 144.0000, 'ºC'),
	(241790, 118, '2014-03-15 00:40:37.000000', 'temperatura', 378.0000, 'ºC'),
	(241791, 118, '2014-03-15 00:40:38.000000', 'temperatura', 259.0000, 'ºC'),
	(241792, 118, '2014-03-15 00:40:39.000000', 'temperatura', 161.0000, 'ºC'),
	(241793, 118, '2014-03-15 00:40:40.000000', 'temperatura', 31.0000, 'ºC'),
	(241794, 118, '2014-03-15 00:40:41.000000', 'temperatura', 873.0000, 'ºC'),
	(241795, 118, '2014-03-15 00:40:42.000000', 'temperatura', 669.0000, 'ºC'),
	(241796, 118, '2014-03-15 00:40:43.000000', 'temperatura', 730.0000, 'ºC'),
	(241797, 118, '2014-03-15 00:40:44.000000', 'temperatura', 443.0000, 'ºC'),
	(241798, 118, '2014-03-15 00:40:45.000000', 'temperatura', 25.0000, 'ºC'),
	(241799, 118, '2014-03-15 00:40:46.000000', 'temperatura', 1194.0000, 'ºC'),
	(241800, 118, '2014-03-15 00:40:47.000000', 'temperatura', 1099.0000, 'ºC'),
	(241801, 118, '2014-03-15 00:40:48.000000', 'temperatura', 714.0000, 'ºC'),
	(241802, 118, '2014-03-15 00:40:49.000000', 'temperatura', 270.0000, 'ºC'),
	(241803, 118, '2014-03-15 00:40:50.000000', 'temperatura', 411.0000, 'ºC'),
	(241804, 118, '2014-03-15 00:40:51.000000', 'temperatura', 44.0000, 'ºC'),
	(241805, 118, '2014-03-15 00:40:52.000000', 'temperatura', 189.0000, 'ºC'),
	(241806, 118, '2014-03-15 00:40:53.000000', 'temperatura', 813.0000, 'ºC'),
	(241807, 118, '2014-03-15 00:40:54.000000', 'temperatura', 1099.0000, 'ºC'),
	(241808, 118, '2014-03-15 00:40:55.000000', 'temperatura', 658.0000, 'ºC'),
	(241809, 118, '2014-03-15 00:40:56.000000', 'temperatura', 1191.0000, 'ºC'),
	(241810, 118, '2014-03-15 00:40:57.000000', 'temperatura', 382.0000, 'ºC'),
	(241811, 118, '2014-03-15 00:40:58.000000', 'temperatura', 736.0000, 'ºC'),
	(241812, 118, '2014-03-15 00:40:59.000000', 'temperatura', 135.0000, 'ºC'),
	(241813, 118, '2014-03-15 00:41:00.000000', 'temperatura', 870.0000, 'ºC'),
	(241814, 118, '2014-03-15 00:41:01.000000', 'temperatura', 342.0000, 'ºC'),
	(241815, 118, '2014-03-15 00:41:02.000000', 'temperatura', 304.0000, 'ºC'),
	(241816, 118, '2014-03-15 00:41:03.000000', 'temperatura', 493.0000, 'ºC'),
	(241817, 118, '2014-03-15 00:41:04.000000', 'temperatura', 355.0000, 'ºC'),
	(241818, 118, '2014-03-15 00:41:05.000000', 'temperatura', 296.0000, 'ºC'),
	(241819, 118, '2014-03-15 00:41:06.000000', 'temperatura', 415.0000, 'ºC'),
	(241820, 118, '2014-03-15 00:41:07.000000', 'temperatura', 1186.0000, 'ºC'),
	(241821, 118, '2014-03-15 00:41:08.000000', 'temperatura', 1088.0000, 'ºC'),
	(241822, 118, '2014-03-15 00:41:09.000000', 'temperatura', 684.0000, 'ºC'),
	(241823, 118, '2014-03-15 00:41:10.000000', 'temperatura', 153.0000, 'ºC'),
	(241824, 118, '2014-03-15 00:41:11.000000', 'temperatura', 1115.0000, 'ºC'),
	(241825, 118, '2014-03-15 00:41:12.000000', 'temperatura', 316.0000, 'ºC'),
	(241826, 118, '2014-03-15 00:41:13.000000', 'temperatura', 634.0000, 'ºC'),
	(241827, 118, '2014-03-15 00:41:14.000000', 'temperatura', 1023.0000, 'ºC'),
	(241828, 118, '2014-03-15 00:41:15.000000', 'temperatura', 815.0000, 'ºC'),
	(241829, 118, '2014-03-15 00:41:16.000000', 'temperatura', 1004.0000, 'ºC'),
	(241830, 118, '2014-03-15 00:41:17.000000', 'temperatura', 177.0000, 'ºC'),
	(241831, 118, '2014-03-15 00:41:18.000000', 'temperatura', 274.0000, 'ºC'),
	(241832, 118, '2014-03-15 00:41:19.000000', 'temperatura', 837.0000, 'ºC'),
	(241833, 118, '2014-03-15 00:41:20.000000', 'temperatura', 966.0000, 'ºC'),
	(241834, 118, '2014-03-15 00:41:21.000000', 'temperatura', 1121.0000, 'ºC'),
	(241835, 118, '2014-03-15 00:41:22.000000', 'temperatura', 304.0000, 'ºC'),
	(241836, 118, '2014-03-15 00:41:23.000000', 'temperatura', 559.0000, 'ºC'),
	(241837, 118, '2014-03-15 00:41:24.000000', 'temperatura', 684.0000, 'ºC'),
	(241838, 118, '2014-03-15 00:41:25.000000', 'temperatura', 542.0000, 'ºC'),
	(241839, 118, '2014-03-15 00:41:26.000000', 'temperatura', 657.0000, 'ºC'),
	(241840, 118, '2014-03-15 00:41:27.000000', 'temperatura', 463.0000, 'ºC'),
	(241841, 118, '2014-03-15 00:41:28.000000', 'temperatura', 343.0000, 'ºC'),
	(241842, 118, '2014-03-15 00:41:29.000000', 'temperatura', 325.0000, 'ºC'),
	(241843, 118, '2014-03-15 00:41:30.000000', 'temperatura', 597.0000, 'ºC'),
	(241844, 118, '2014-03-15 00:41:31.000000', 'temperatura', 811.0000, 'ºC'),
	(241845, 118, '2014-03-15 00:41:32.000000', 'temperatura', 1065.0000, 'ºC'),
	(241846, 118, '2014-03-15 00:41:33.000000', 'temperatura', 491.0000, 'ºC'),
	(241847, 118, '2014-03-15 00:41:34.000000', 'temperatura', 463.0000, 'ºC'),
	(241848, 118, '2014-03-15 00:41:35.000000', 'temperatura', 843.0000, 'ºC'),
	(241849, 118, '2014-03-15 00:41:36.000000', 'temperatura', 425.0000, 'ºC'),
	(241850, 118, '2014-03-15 00:41:37.000000', 'temperatura', 795.0000, 'ºC'),
	(241851, 118, '2014-03-15 00:41:38.000000', 'temperatura', 301.0000, 'ºC'),
	(241852, 118, '2014-03-15 00:41:39.000000', 'temperatura', 319.0000, 'ºC'),
	(241853, 118, '2014-03-15 00:41:40.000000', 'temperatura', 695.0000, 'ºC'),
	(241854, 118, '2014-03-15 00:41:41.000000', 'temperatura', 119.0000, 'ºC'),
	(241855, 118, '2014-03-15 00:41:42.000000', 'temperatura', 911.0000, 'ºC'),
	(241856, 118, '2014-03-15 00:41:43.000000', 'temperatura', 598.0000, 'ºC'),
	(241857, 118, '2014-03-15 00:41:44.000000', 'temperatura', 257.0000, 'ºC'),
	(241858, 118, '2014-03-15 00:41:45.000000', 'temperatura', 692.0000, 'ºC'),
	(241859, 118, '2014-03-15 00:41:46.000000', 'temperatura', 290.0000, 'ºC'),
	(241860, 118, '2014-03-15 00:41:47.000000', 'temperatura', 575.0000, 'ºC'),
	(241861, 118, '2014-03-15 00:41:48.000000', 'temperatura', 805.0000, 'ºC'),
	(241862, 118, '2014-03-15 00:41:49.000000', 'temperatura', 1100.0000, 'ºC'),
	(241863, 118, '2014-03-15 00:41:50.000000', 'temperatura', 687.0000, 'ºC'),
	(241864, 118, '2014-03-15 00:41:51.000000', 'temperatura', 135.0000, 'ºC'),
	(241865, 118, '2014-03-15 00:41:52.000000', 'temperatura', 1015.0000, 'ºC'),
	(241866, 118, '2014-03-15 00:41:53.000000', 'temperatura', 1068.0000, 'ºC'),
	(241867, 118, '2014-03-15 00:41:54.000000', 'temperatura', 1098.0000, 'ºC'),
	(241868, 118, '2014-03-15 00:41:55.000000', 'temperatura', 1087.0000, 'ºC'),
	(241869, 118, '2014-03-15 00:41:56.000000', 'temperatura', 940.0000, 'ºC'),
	(241870, 118, '2014-03-15 00:41:57.000000', 'temperatura', 240.0000, 'ºC'),
	(241871, 118, '2014-03-15 00:41:58.000000', 'temperatura', 780.0000, 'ºC'),
	(241872, 118, '2014-03-15 00:41:59.000000', 'temperatura', 779.0000, 'ºC'),
	(241873, 118, '2014-03-15 00:42:00.000000', 'temperatura', 358.0000, 'ºC'),
	(241874, 118, '2014-03-15 00:42:01.000000', 'temperatura', 652.0000, 'ºC'),
	(241875, 118, '2014-03-15 00:42:02.000000', 'temperatura', 988.0000, 'ºC'),
	(241876, 118, '2014-03-15 00:42:03.000000', 'temperatura', 584.0000, 'ºC'),
	(241877, 118, '2014-03-15 00:42:04.000000', 'temperatura', 1158.0000, 'ºC'),
	(241878, 118, '2014-03-15 00:42:05.000000', 'temperatura', 438.0000, 'ºC'),
	(241879, 118, '2014-03-15 00:42:06.000000', 'temperatura', 1114.0000, 'ºC'),
	(241880, 118, '2014-03-15 00:42:07.000000', 'temperatura', 658.0000, 'ºC'),
	(241881, 118, '2014-03-15 00:42:08.000000', 'temperatura', 1147.0000, 'ºC'),
	(241882, 118, '2014-03-15 00:42:09.000000', 'temperatura', 161.0000, 'ºC'),
	(241883, 118, '2014-03-15 00:42:10.000000', 'temperatura', 967.0000, 'ºC'),
	(241884, 118, '2014-03-15 00:42:11.000000', 'temperatura', 751.0000, 'ºC'),
	(241885, 118, '2014-03-15 00:42:12.000000', 'temperatura', 853.0000, 'ºC'),
	(241886, 118, '2014-03-15 00:42:13.000000', 'temperatura', 814.0000, 'ºC'),
	(241887, 118, '2014-03-15 00:42:14.000000', 'temperatura', 312.0000, 'ºC'),
	(241888, 118, '2014-03-15 00:42:15.000000', 'temperatura', 319.0000, 'ºC'),
	(241889, 118, '2014-03-15 00:42:16.000000', 'temperatura', 661.0000, 'ºC'),
	(241890, 118, '2014-03-15 00:42:17.000000', 'temperatura', 1145.0000, 'ºC'),
	(241891, 118, '2014-03-15 00:42:18.000000', 'temperatura', 143.0000, 'ºC'),
	(241892, 118, '2014-03-15 00:42:19.000000', 'temperatura', 883.0000, 'ºC'),
	(241893, 118, '2014-03-15 00:42:20.000000', 'temperatura', 386.0000, 'ºC'),
	(241894, 118, '2014-03-15 00:42:21.000000', 'temperatura', 482.0000, 'ºC'),
	(241895, 118, '2014-03-15 00:42:22.000000', 'temperatura', 51.0000, 'ºC'),
	(241896, 118, '2014-03-15 00:42:23.000000', 'temperatura', 11.0000, 'ºC'),
	(241897, 118, '2014-03-15 00:42:24.000000', 'temperatura', 1102.0000, 'ºC'),
	(241898, 118, '2014-03-15 00:42:25.000000', 'temperatura', 678.0000, 'ºC'),
	(241899, 118, '2014-03-15 00:42:26.000000', 'temperatura', 83.0000, 'ºC'),
	(241900, 118, '2014-03-15 00:42:27.000000', 'temperatura', 782.0000, 'ºC'),
	(241901, 118, '2014-03-15 00:42:28.000000', 'temperatura', 61.0000, 'ºC'),
	(241902, 118, '2014-03-15 00:42:29.000000', 'temperatura', 361.0000, 'ºC'),
	(241903, 118, '2014-03-15 00:42:30.000000', 'temperatura', 424.0000, 'ºC'),
	(241904, 118, '2014-03-15 00:42:31.000000', 'temperatura', 1034.0000, 'ºC'),
	(241905, 118, '2014-03-15 00:42:32.000000', 'temperatura', 301.0000, 'ºC'),
	(241906, 118, '2014-03-15 00:42:33.000000', 'temperatura', 804.0000, 'ºC'),
	(241907, 118, '2014-03-15 00:42:34.000000', 'temperatura', 717.0000, 'ºC'),
	(241908, 118, '2014-03-15 00:42:35.000000', 'temperatura', 1173.0000, 'ºC'),
	(241909, 118, '2014-03-15 00:42:36.000000', 'temperatura', 113.0000, 'ºC'),
	(241910, 118, '2014-03-15 00:42:37.000000', 'temperatura', 648.0000, 'ºC'),
	(241911, 118, '2014-03-15 00:42:38.000000', 'temperatura', 503.0000, 'ºC'),
	(241912, 118, '2014-03-15 00:42:39.000000', 'temperatura', 572.0000, 'ºC'),
	(241913, 118, '2014-03-15 00:42:40.000000', 'temperatura', 150.0000, 'ºC'),
	(241914, 118, '2014-03-15 00:42:41.000000', 'temperatura', 234.0000, 'ºC'),
	(241915, 118, '2014-03-15 00:42:42.000000', 'temperatura', 721.0000, 'ºC'),
	(241916, 118, '2014-03-15 00:42:43.000000', 'temperatura', 505.0000, 'ºC'),
	(241917, 118, '2014-03-15 00:42:44.000000', 'temperatura', 361.0000, 'ºC'),
	(241918, 118, '2014-03-15 00:42:45.000000', 'temperatura', 291.0000, 'ºC'),
	(241919, 118, '2014-03-15 00:42:46.000000', 'temperatura', 370.0000, 'ºC'),
	(241920, 118, '2014-03-15 00:42:47.000000', 'temperatura', 981.0000, 'ºC'),
	(241921, 118, '2014-03-15 00:42:48.000000', 'temperatura', 193.0000, 'ºC'),
	(241922, 118, '2014-03-15 00:42:49.000000', 'temperatura', 422.0000, 'ºC'),
	(241923, 118, '2014-03-15 00:42:50.000000', 'temperatura', 330.0000, 'ºC'),
	(241924, 118, '2014-03-15 00:42:51.000000', 'temperatura', 388.0000, 'ºC'),
	(241925, 118, '2014-03-15 00:42:52.000000', 'temperatura', 951.0000, 'ºC'),
	(241926, 118, '2014-03-15 00:42:53.000000', 'temperatura', 1188.0000, 'ºC'),
	(241927, 118, '2014-03-15 00:42:54.000000', 'temperatura', 690.0000, 'ºC'),
	(241928, 118, '2014-03-15 00:42:55.000000', 'temperatura', 1087.0000, 'ºC'),
	(241929, 118, '2014-03-15 00:42:56.000000', 'temperatura', 964.0000, 'ºC'),
	(241930, 118, '2014-03-15 00:42:57.000000', 'temperatura', 358.0000, 'ºC'),
	(241931, 118, '2014-03-15 00:42:58.000000', 'temperatura', 101.0000, 'ºC'),
	(241932, 118, '2014-03-15 00:42:59.000000', 'temperatura', 629.0000, 'ºC'),
	(241933, 118, '2014-03-15 00:43:00.000000', 'temperatura', 442.0000, 'ºC'),
	(241934, 118, '2014-03-15 00:43:01.000000', 'temperatura', 324.0000, 'ºC'),
	(241935, 118, '2014-03-15 00:43:02.000000', 'temperatura', 296.0000, 'ºC'),
	(241936, 118, '2014-03-15 00:43:03.000000', 'temperatura', 509.0000, 'ºC'),
	(241937, 118, '2014-03-15 00:43:04.000000', 'temperatura', 455.0000, 'ºC'),
	(241938, 118, '2014-03-15 00:43:05.000000', 'temperatura', 749.0000, 'ºC'),
	(241939, 118, '2014-03-15 00:43:06.000000', 'temperatura', 1181.0000, 'ºC'),
	(241940, 118, '2014-03-15 00:43:07.000000', 'temperatura', 57.0000, 'ºC'),
	(241941, 118, '2014-03-15 00:43:08.000000', 'temperatura', 344.0000, 'ºC'),
	(241942, 118, '2014-03-15 00:43:09.000000', 'temperatura', 351.0000, 'ºC'),
	(241943, 118, '2014-03-15 00:43:10.000000', 'temperatura', 720.0000, 'ºC'),
	(241944, 118, '2014-03-15 00:43:11.000000', 'temperatura', 150.0000, 'ºC'),
	(241945, 118, '2014-03-15 00:43:12.000000', 'temperatura', 991.0000, 'ºC'),
	(241946, 118, '2014-03-15 00:43:13.000000', 'temperatura', 905.0000, 'ºC'),
	(241947, 118, '2014-03-15 00:43:14.000000', 'temperatura', 354.0000, 'ºC'),
	(241948, 118, '2014-03-15 00:43:15.000000', 'temperatura', 254.0000, 'ºC'),
	(241949, 118, '2014-03-15 00:43:16.000000', 'temperatura', 209.0000, 'ºC'),
	(241950, 118, '2014-03-15 00:43:17.000000', 'temperatura', 285.0000, 'ºC'),
	(241951, 118, '2014-03-15 00:43:18.000000', 'temperatura', 797.0000, 'ºC'),
	(241952, 118, '2014-03-15 00:43:19.000000', 'temperatura', 730.0000, 'ºC'),
	(241953, 118, '2014-03-15 00:43:20.000000', 'temperatura', 59.0000, 'ºC'),
	(241954, 118, '2014-03-15 00:43:21.000000', 'temperatura', 507.0000, 'ºC'),
	(241955, 118, '2014-03-15 00:43:22.000000', 'temperatura', 1157.0000, 'ºC'),
	(241956, 118, '2014-03-15 00:43:23.000000', 'temperatura', 666.0000, 'ºC'),
	(241957, 118, '2014-03-15 00:43:24.000000', 'temperatura', 1059.0000, 'ºC'),
	(241958, 118, '2014-03-15 00:43:25.000000', 'temperatura', 897.0000, 'ºC'),
	(241959, 118, '2014-03-15 00:43:26.000000', 'temperatura', 108.0000, 'ºC'),
	(241960, 118, '2014-03-15 00:43:27.000000', 'temperatura', 248.0000, 'ºC'),
	(241961, 118, '2014-03-15 00:43:28.000000', 'temperatura', 919.0000, 'ºC'),
	(241962, 118, '2014-03-15 00:43:29.000000', 'temperatura', 250.0000, 'ºC'),
	(241963, 118, '2014-03-15 00:43:30.000000', 'temperatura', 892.0000, 'ºC'),
	(241964, 118, '2014-03-15 00:43:31.000000', 'temperatura', 112.0000, 'ºC'),
	(241965, 118, '2014-03-15 00:43:32.000000', 'temperatura', 285.0000, 'ºC'),
	(241966, 118, '2014-03-15 00:43:33.000000', 'temperatura', 1091.0000, 'ºC'),
	(241967, 118, '2014-03-15 00:43:34.000000', 'temperatura', 997.0000, 'ºC'),
	(241968, 118, '2014-03-15 00:43:35.000000', 'temperatura', 515.0000, 'ºC'),
	(241969, 118, '2014-03-15 00:43:36.000000', 'temperatura', 784.0000, 'ºC'),
	(241970, 118, '2014-03-15 00:43:37.000000', 'temperatura', 1177.0000, 'ºC'),
	(241971, 118, '2014-03-15 00:43:38.000000', 'temperatura', 1130.0000, 'ºC'),
	(241972, 118, '2014-03-15 00:43:39.000000', 'temperatura', 922.0000, 'ºC'),
	(241973, 118, '2014-03-15 00:43:40.000000', 'temperatura', 21.0000, 'ºC'),
	(241974, 118, '2014-03-15 00:43:41.000000', 'temperatura', 940.0000, 'ºC'),
	(241975, 118, '2014-03-15 00:43:42.000000', 'temperatura', 1036.0000, 'ºC'),
	(241976, 118, '2014-03-15 00:43:43.000000', 'temperatura', 1161.0000, 'ºC'),
	(241977, 118, '2014-03-15 00:43:44.000000', 'temperatura', 299.0000, 'ºC'),
	(241978, 118, '2014-03-15 00:43:45.000000', 'temperatura', 413.0000, 'ºC'),
	(241979, 118, '2014-03-15 00:43:46.000000', 'temperatura', 1166.0000, 'ºC'),
	(241980, 118, '2014-03-15 00:43:47.000000', 'temperatura', 991.0000, 'ºC'),
	(241981, 118, '2014-03-15 00:43:48.000000', 'temperatura', 257.0000, 'ºC'),
	(241982, 118, '2014-03-15 00:43:49.000000', 'temperatura', 714.0000, 'ºC'),
	(241983, 118, '2014-03-15 00:43:50.000000', 'temperatura', 398.0000, 'ºC'),
	(241984, 118, '2014-03-15 00:43:51.000000', 'temperatura', 1047.0000, 'ºC'),
	(241985, 118, '2014-03-15 00:43:52.000000', 'temperatura', 444.0000, 'ºC'),
	(241986, 118, '2014-03-15 00:43:53.000000', 'temperatura', 280.0000, 'ºC'),
	(241987, 118, '2014-03-15 00:43:54.000000', 'temperatura', 70.0000, 'ºC'),
	(241988, 118, '2014-03-15 00:43:55.000000', 'temperatura', 708.0000, 'ºC'),
	(241989, 118, '2014-03-15 00:43:56.000000', 'temperatura', 932.0000, 'ºC'),
	(241990, 118, '2014-03-15 00:43:57.000000', 'temperatura', 136.0000, 'ºC'),
	(241991, 118, '2014-03-15 00:43:58.000000', 'temperatura', 284.0000, 'ºC'),
	(241992, 118, '2014-03-15 00:43:59.000000', 'temperatura', 1014.0000, 'ºC'),
	(241993, 118, '2014-03-15 00:44:00.000000', 'temperatura', 617.0000, 'ºC'),
	(241994, 118, '2014-03-15 00:44:01.000000', 'temperatura', 44.0000, 'ºC'),
	(241995, 118, '2014-03-15 00:44:02.000000', 'temperatura', 767.0000, 'ºC'),
	(241996, 118, '2014-03-15 00:44:03.000000', 'temperatura', 107.0000, 'ºC'),
	(241997, 118, '2014-03-15 00:44:04.000000', 'temperatura', 634.0000, 'ºC'),
	(241998, 118, '2014-03-15 00:44:05.000000', 'temperatura', 448.0000, 'ºC'),
	(241999, 118, '2014-03-15 00:44:06.000000', 'temperatura', 340.0000, 'ºC'),
	(242000, 118, '2014-03-15 00:44:07.000000', 'temperatura', 354.0000, 'ºC'),
	(242001, 118, '2014-03-15 00:44:08.000000', 'temperatura', 751.0000, 'ºC'),
	(242002, 118, '2014-03-15 00:44:09.000000', 'temperatura', 296.0000, 'ºC'),
	(242003, 118, '2014-03-15 00:44:10.000000', 'temperatura', 424.0000, 'ºC'),
	(242004, 118, '2014-03-15 00:44:11.000000', 'temperatura', 34.0000, 'ºC'),
	(242005, 118, '2014-03-15 00:44:12.000000', 'temperatura', 100.0000, 'ºC'),
	(242006, 118, '2014-03-15 00:44:13.000000', 'temperatura', 398.0000, 'ºC'),
	(242007, 118, '2014-03-15 00:44:14.000000', 'temperatura', 491.0000, 'ºC'),
	(242008, 118, '2014-03-15 00:44:15.000000', 'temperatura', 60.0000, 'ºC'),
	(242009, 118, '2014-03-15 00:44:16.000000', 'temperatura', 29.0000, 'ºC'),
	(242010, 118, '2014-03-15 00:44:17.000000', 'temperatura', 1164.0000, 'ºC'),
	(242011, 118, '2014-03-15 00:44:18.000000', 'temperatura', 936.0000, 'ºC'),
	(242012, 118, '2014-03-15 00:44:19.000000', 'temperatura', 1185.0000, 'ºC'),
	(242013, 118, '2014-03-15 00:44:20.000000', 'temperatura', 719.0000, 'ºC'),
	(242014, 118, '2014-03-15 00:44:21.000000', 'temperatura', 42.0000, 'ºC'),
	(242015, 118, '2014-03-15 00:44:22.000000', 'temperatura', 451.0000, 'ºC'),
	(242016, 118, '2014-03-15 00:44:23.000000', 'temperatura', 932.0000, 'ºC'),
	(242017, 118, '2014-03-15 00:44:24.000000', 'temperatura', 907.0000, 'ºC'),
	(242018, 118, '2014-03-15 00:44:25.000000', 'temperatura', 539.0000, 'ºC'),
	(242019, 118, '2014-03-15 00:44:26.000000', 'temperatura', 1176.0000, 'ºC'),
	(242020, 118, '2014-03-15 00:44:27.000000', 'temperatura', 662.0000, 'ºC'),
	(242021, 118, '2014-03-15 00:44:28.000000', 'temperatura', 984.0000, 'ºC'),
	(242022, 118, '2014-03-15 00:44:29.000000', 'temperatura', 535.0000, 'ºC'),
	(242023, 118, '2014-03-15 00:44:30.000000', 'temperatura', 921.0000, 'ºC'),
	(242024, 118, '2014-03-15 00:44:31.000000', 'temperatura', 601.0000, 'ºC'),
	(242025, 118, '2014-03-15 00:44:32.000000', 'temperatura', 241.0000, 'ºC'),
	(242026, 118, '2014-03-15 00:44:33.000000', 'temperatura', 605.0000, 'ºC'),
	(242027, 118, '2014-03-15 00:44:34.000000', 'temperatura', 1102.0000, 'ºC'),
	(242028, 118, '2014-03-15 00:44:35.000000', 'temperatura', 96.0000, 'ºC'),
	(242029, 118, '2014-03-15 00:44:36.000000', 'temperatura', 773.0000, 'ºC'),
	(242030, 118, '2014-03-15 00:44:37.000000', 'temperatura', 1176.0000, 'ºC'),
	(242031, 118, '2014-03-15 00:44:38.000000', 'temperatura', 1164.0000, 'ºC'),
	(242032, 118, '2014-03-15 00:44:39.000000', 'temperatura', 1090.0000, 'ºC'),
	(242033, 118, '2014-03-15 00:44:40.000000', 'temperatura', 758.0000, 'ºC'),
	(242034, 118, '2014-03-15 00:44:41.000000', 'temperatura', 523.0000, 'ºC'),
	(242035, 118, '2014-03-15 00:44:42.000000', 'temperatura', 342.0000, 'ºC'),
	(242036, 118, '2014-03-15 00:44:43.000000', 'temperatura', 142.0000, 'ºC'),
	(242037, 118, '2014-03-15 00:44:44.000000', 'temperatura', 883.0000, 'ºC'),
	(242038, 118, '2014-03-15 00:44:45.000000', 'temperatura', 389.0000, 'ºC'),
	(242039, 118, '2014-03-15 00:44:46.000000', 'temperatura', 496.0000, 'ºC'),
	(242040, 118, '2014-03-15 00:44:47.000000', 'temperatura', 113.0000, 'ºC'),
	(242041, 118, '2014-03-15 00:44:48.000000', 'temperatura', 277.0000, 'ºC'),
	(242042, 118, '2014-03-15 00:44:49.000000', 'temperatura', 1047.0000, 'ºC'),
	(242043, 118, '2014-03-15 00:44:50.000000', 'temperatura', 807.0000, 'ºC'),
	(242044, 118, '2014-03-15 00:44:51.000000', 'temperatura', 892.0000, 'ºC'),
	(242045, 118, '2014-03-15 00:44:52.000000', 'temperatura', 840.0000, 'ºC'),
	(242046, 118, '2014-03-15 00:44:53.000000', 'temperatura', 323.0000, 'ºC'),
	(242047, 118, '2014-03-15 00:44:54.000000', 'temperatura', 298.0000, 'ºC'),
	(242048, 118, '2014-03-15 00:44:55.000000', 'temperatura', 520.0000, 'ºC'),
	(242049, 118, '2014-03-15 00:44:56.000000', 'temperatura', 509.0000, 'ºC'),
	(242050, 118, '2014-03-15 00:44:57.000000', 'temperatura', 983.0000, 'ºC'),
	(242051, 118, '2014-03-15 00:44:58.000000', 'temperatura', 989.0000, 'ºC'),
	(242052, 118, '2014-03-15 00:44:59.000000', 'temperatura', 797.0000, 'ºC'),
	(242053, 118, '2014-03-15 00:45:00.000000', 'temperatura', 1020.0000, 'ºC'),
	(242054, 118, '2014-03-15 00:45:01.000000', 'temperatura', 308.0000, 'ºC'),
	(242055, 118, '2014-03-15 00:45:02.000000', 'temperatura', 882.0000, 'ºC'),
	(242056, 118, '2014-03-15 00:45:03.000000', 'temperatura', 1088.0000, 'ºC'),
	(242057, 118, '2014-03-15 00:45:04.000000', 'temperatura', 391.0000, 'ºC'),
	(242058, 118, '2014-03-15 00:45:05.000000', 'temperatura', 1093.0000, 'ºC'),
	(242059, 118, '2014-03-15 00:45:06.000000', 'temperatura', 692.0000, 'ºC'),
	(242060, 118, '2014-03-15 00:45:07.000000', 'temperatura', 183.0000, 'ºC'),
	(242061, 118, '2014-03-15 00:45:08.000000', 'temperatura', 38.0000, 'ºC'),
	(242062, 118, '2014-03-15 00:45:09.000000', 'temperatura', 843.0000, 'ºC'),
	(242063, 118, '2014-03-15 00:45:10.000000', 'temperatura', 502.0000, 'ºC'),
	(242064, 118, '2014-03-15 00:45:11.000000', 'temperatura', 1181.0000, 'ºC'),
	(242065, 118, '2014-03-15 00:45:12.000000', 'temperatura', 800.0000, 'ºC'),
	(242066, 118, '2014-03-15 00:45:13.000000', 'temperatura', 456.0000, 'ºC'),
	(242067, 118, '2014-03-15 00:45:14.000000', 'temperatura', 1080.0000, 'ºC'),
	(242068, 118, '2014-03-15 00:45:15.000000', 'temperatura', 435.0000, 'ºC'),
	(242069, 118, '2014-03-15 00:45:16.000000', 'temperatura', 135.0000, 'ºC'),
	(242070, 118, '2014-03-15 00:45:17.000000', 'temperatura', 570.0000, 'ºC'),
	(242071, 118, '2014-03-15 00:45:18.000000', 'temperatura', 46.0000, 'ºC'),
	(242072, 118, '2014-03-15 00:45:19.000000', 'temperatura', 918.0000, 'ºC'),
	(242073, 118, '2014-03-15 00:45:20.000000', 'temperatura', 856.0000, 'ºC'),
	(242074, 118, '2014-03-15 00:45:21.000000', 'temperatura', 324.0000, 'ºC'),
	(242075, 118, '2014-03-15 00:45:22.000000', 'temperatura', 254.0000, 'ºC'),
	(242076, 118, '2014-03-15 00:45:23.000000', 'temperatura', 298.0000, 'ºC'),
	(242077, 118, '2014-03-15 00:45:24.000000', 'temperatura', 727.0000, 'ºC'),
	(242078, 118, '2014-03-15 00:45:25.000000', 'temperatura', 344.0000, 'ºC'),
	(242079, 118, '2014-03-15 00:45:26.000000', 'temperatura', 740.0000, 'ºC'),
	(242080, 118, '2014-03-15 00:45:27.000000', 'temperatura', 267.0000, 'ºC'),
	(242081, 118, '2014-03-15 00:45:28.000000', 'temperatura', 315.0000, 'ºC'),
	(242082, 118, '2014-03-15 00:45:29.000000', 'temperatura', 777.0000, 'ºC'),
	(242083, 118, '2014-03-15 00:45:30.000000', 'temperatura', 538.0000, 'ºC'),
	(242084, 118, '2014-03-15 00:45:31.000000', 'temperatura', 362.0000, 'ºC'),
	(242085, 118, '2014-03-15 00:45:32.000000', 'temperatura', 195.0000, 'ºC'),
	(242086, 118, '2014-03-15 00:45:33.000000', 'temperatura', 1091.0000, 'ºC'),
	(242087, 118, '2014-03-15 00:45:34.000000', 'temperatura', 69.0000, 'ºC'),
	(242088, 118, '2014-03-15 00:45:35.000000', 'temperatura', 673.0000, 'ºC'),
	(242089, 118, '2014-03-15 00:45:36.000000', 'temperatura', 761.0000, 'ºC'),
	(242090, 118, '2014-03-15 00:45:37.000000', 'temperatura', 583.0000, 'ºC'),
	(242091, 118, '2014-03-15 00:45:38.000000', 'temperatura', 633.0000, 'ºC'),
	(242092, 118, '2014-03-15 00:45:39.000000', 'temperatura', 219.0000, 'ºC'),
	(242093, 118, '2014-03-15 00:45:40.000000', 'temperatura', 396.0000, 'ºC'),
	(242094, 118, '2014-03-15 00:45:41.000000', 'temperatura', 121.0000, 'ºC'),
	(242095, 118, '2014-03-15 00:45:42.000000', 'temperatura', 619.0000, 'ºC'),
	(242096, 118, '2014-03-15 00:45:43.000000', 'temperatura', 331.0000, 'ºC'),
	(242097, 118, '2014-03-15 00:45:44.000000', 'temperatura', 1000.0000, 'ºC'),
	(242098, 118, '2014-03-15 00:45:45.000000', 'temperatura', 408.0000, 'ºC'),
	(242099, 118, '2014-03-15 00:45:46.000000', 'temperatura', 240.0000, 'ºC'),
	(242100, 118, '2014-03-15 00:45:47.000000', 'temperatura', 1177.0000, 'ºC'),
	(242101, 118, '2014-03-15 00:45:48.000000', 'temperatura', 363.0000, 'ºC'),
	(242102, 118, '2014-03-15 00:45:49.000000', 'temperatura', 688.0000, 'ºC'),
	(242103, 118, '2014-03-15 00:45:50.000000', 'temperatura', 1149.0000, 'ºC'),
	(242104, 118, '2014-03-15 00:45:51.000000', 'temperatura', 82.0000, 'ºC'),
	(242105, 118, '2014-03-15 00:45:52.000000', 'temperatura', 563.0000, 'ºC'),
	(242106, 118, '2014-03-15 00:45:53.000000', 'temperatura', 169.0000, 'ºC'),
	(242107, 118, '2014-03-15 00:45:54.000000', 'temperatura', 356.0000, 'ºC'),
	(242108, 118, '2014-03-15 00:45:55.000000', 'temperatura', 76.0000, 'ºC'),
	(242109, 118, '2014-03-15 00:45:56.000000', 'temperatura', 511.0000, 'ºC'),
	(242110, 118, '2014-03-15 00:45:57.000000', 'temperatura', 1128.0000, 'ºC'),
	(242111, 118, '2014-03-15 00:45:58.000000', 'temperatura', 509.0000, 'ºC'),
	(242112, 118, '2014-03-15 00:45:59.000000', 'temperatura', 360.0000, 'ºC'),
	(242113, 118, '2014-03-15 00:46:00.000000', 'temperatura', 275.0000, 'ºC'),
	(242114, 118, '2014-03-15 00:46:01.000000', 'temperatura', 294.0000, 'ºC'),
	(242115, 118, '2014-03-15 00:46:02.000000', 'temperatura', 647.0000, 'ºC'),
	(242116, 118, '2014-03-15 00:46:03.000000', 'temperatura', 1155.0000, 'ºC'),
	(242117, 118, '2014-03-15 00:46:04.000000', 'temperatura', 232.0000, 'ºC'),
	(242118, 118, '2014-03-15 00:46:05.000000', 'temperatura', 97.0000, 'ºC'),
	(242119, 118, '2014-03-15 00:46:06.000000', 'temperatura', 990.0000, 'ºC'),
	(242120, 118, '2014-03-15 00:46:07.000000', 'temperatura', 1058.0000, 'ºC'),
	(242121, 118, '2014-03-15 00:46:08.000000', 'temperatura', 1119.0000, 'ºC'),
	(242122, 118, '2014-03-15 00:46:09.000000', 'temperatura', 24.0000, 'ºC'),
	(242123, 118, '2014-03-15 00:46:10.000000', 'temperatura', 362.0000, 'ºC'),
	(242124, 118, '2014-03-15 00:46:11.000000', 'temperatura', 540.0000, 'ºC'),
	(242125, 118, '2014-03-15 00:46:12.000000', 'temperatura', 413.0000, 'ºC'),
	(242126, 118, '2014-03-15 00:46:13.000000', 'temperatura', 446.0000, 'ºC'),
	(242127, 118, '2014-03-15 00:46:14.000000', 'temperatura', 990.0000, 'ºC'),
	(242128, 118, '2014-03-15 00:46:15.000000', 'temperatura', 15.0000, 'ºC'),
	(242129, 118, '2014-03-15 00:46:16.000000', 'temperatura', 706.0000, 'ºC'),
	(242130, 118, '2014-03-15 00:46:17.000000', 'temperatura', 1084.0000, 'ºC'),
	(242131, 118, '2014-03-15 00:46:18.000000', 'temperatura', 902.0000, 'ºC'),
	(242132, 118, '2014-03-15 00:46:19.000000', 'temperatura', 58.0000, 'ºC'),
	(242133, 118, '2014-03-15 00:46:20.000000', 'temperatura', 1185.0000, 'ºC'),
	(242134, 118, '2014-03-15 00:46:21.000000', 'temperatura', 951.0000, 'ºC'),
	(242135, 118, '2014-03-15 00:46:22.000000', 'temperatura', 3.0000, 'ºC'),
	(242136, 118, '2014-03-15 00:46:23.000000', 'temperatura', 761.0000, 'ºC'),
	(242137, 118, '2014-03-15 00:46:24.000000', 'temperatura', 198.0000, 'ºC'),
	(242138, 118, '2014-03-15 00:46:25.000000', 'temperatura', 1106.0000, 'ºC'),
	(242139, 118, '2014-03-15 00:46:26.000000', 'temperatura', 136.0000, 'ºC'),
	(242140, 118, '2014-03-15 00:46:27.000000', 'temperatura', 963.0000, 'ºC'),
	(242141, 118, '2014-03-15 00:46:28.000000', 'temperatura', 809.0000, 'ºC'),
	(242142, 118, '2014-03-15 00:46:29.000000', 'temperatura', 1157.0000, 'ºC'),
	(242143, 118, '2014-03-15 00:46:30.000000', 'temperatura', 957.0000, 'ºC'),
	(242144, 118, '2014-03-15 00:46:31.000000', 'temperatura', 116.0000, 'ºC'),
	(242145, 118, '2014-03-15 00:46:32.000000', 'temperatura', 108.0000, 'ºC'),
	(242146, 118, '2014-03-15 00:46:33.000000', 'temperatura', 191.0000, 'ºC'),
	(242147, 118, '2014-03-15 00:46:34.000000', 'temperatura', 633.0000, 'ºC'),
	(242148, 118, '2014-03-15 00:46:35.000000', 'temperatura', 194.0000, 'ºC'),
	(242149, 118, '2014-03-15 00:46:36.000000', 'temperatura', 269.0000, 'ºC'),
	(242150, 118, '2014-03-15 00:46:37.000000', 'temperatura', 764.0000, 'ºC'),
	(242151, 118, '2014-03-15 00:46:38.000000', 'temperatura', 612.0000, 'ºC'),
	(242152, 118, '2014-03-15 00:46:39.000000', 'temperatura', 769.0000, 'ºC'),
	(242153, 118, '2014-03-15 00:46:40.000000', 'temperatura', 810.0000, 'ºC'),
	(242154, 118, '2014-03-15 00:46:41.000000', 'temperatura', 544.0000, 'ºC'),
	(242155, 118, '2014-03-15 00:46:42.000000', 'temperatura', 288.0000, 'ºC'),
	(242156, 118, '2014-03-15 00:46:43.000000', 'temperatura', 1011.0000, 'ºC'),
	(242157, 118, '2014-03-15 00:46:44.000000', 'temperatura', 590.0000, 'ºC'),
	(242158, 118, '2014-03-15 00:46:45.000000', 'temperatura', 1118.0000, 'ºC'),
	(242159, 118, '2014-03-15 00:46:46.000000', 'temperatura', 219.0000, 'ºC'),
	(242160, 118, '2014-03-15 00:46:47.000000', 'temperatura', 144.0000, 'ºC'),
	(242161, 118, '2014-03-15 00:46:48.000000', 'temperatura', 63.0000, 'ºC'),
	(242162, 118, '2014-03-15 00:46:49.000000', 'temperatura', 1082.0000, 'ºC'),
	(242163, 118, '2014-03-15 00:46:50.000000', 'temperatura', 424.0000, 'ºC'),
	(242164, 118, '2014-03-15 00:46:51.000000', 'temperatura', 74.0000, 'ºC'),
	(242165, 118, '2014-03-15 00:46:52.000000', 'temperatura', 297.0000, 'ºC'),
	(242166, 118, '2014-03-15 00:46:53.000000', 'temperatura', 64.0000, 'ºC'),
	(242167, 118, '2014-03-15 00:46:54.000000', 'temperatura', 632.0000, 'ºC'),
	(242168, 118, '2014-03-15 00:46:55.000000', 'temperatura', 565.0000, 'ºC'),
	(242169, 118, '2014-03-15 00:46:56.000000', 'temperatura', 931.0000, 'ºC'),
	(242170, 118, '2014-03-15 00:46:57.000000', 'temperatura', 559.0000, 'ºC'),
	(242171, 118, '2014-03-15 00:46:58.000000', 'temperatura', 3.0000, 'ºC'),
	(242172, 118, '2014-03-15 00:46:59.000000', 'temperatura', 740.0000, 'ºC'),
	(242173, 118, '2014-03-15 00:47:00.000000', 'temperatura', 91.0000, 'ºC'),
	(242174, 118, '2014-03-15 00:47:01.000000', 'temperatura', 635.0000, 'ºC'),
	(242175, 118, '2014-03-15 00:47:02.000000', 'temperatura', 503.0000, 'ºC'),
	(242176, 118, '2014-03-15 00:47:03.000000', 'temperatura', 611.0000, 'ºC'),
	(242177, 118, '2014-03-15 00:47:04.000000', 'temperatura', 347.0000, 'ºC'),
	(242178, 118, '2014-03-15 00:47:05.000000', 'temperatura', 1100.0000, 'ºC'),
	(242179, 118, '2014-03-15 00:47:06.000000', 'temperatura', 862.0000, 'ºC'),
	(242180, 118, '2014-03-15 00:47:07.000000', 'temperatura', 1008.0000, 'ºC'),
	(242181, 118, '2014-03-15 00:47:08.000000', 'temperatura', 57.0000, 'ºC'),
	(242182, 118, '2014-03-15 00:47:09.000000', 'temperatura', 861.0000, 'ºC'),
	(242183, 118, '2014-03-15 00:47:10.000000', 'temperatura', 535.0000, 'ºC'),
	(242184, 118, '2014-03-15 00:47:11.000000', 'temperatura', 94.0000, 'ºC'),
	(242185, 118, '2014-03-15 00:47:12.000000', 'temperatura', 63.0000, 'ºC'),
	(242186, 118, '2014-03-15 00:47:13.000000', 'temperatura', 35.0000, 'ºC'),
	(242187, 118, '2014-03-15 00:47:14.000000', 'temperatura', 1185.0000, 'ºC'),
	(242188, 118, '2014-03-15 00:47:15.000000', 'temperatura', 1021.0000, 'ºC'),
	(242189, 118, '2014-03-15 00:47:16.000000', 'temperatura', 351.0000, 'ºC'),
	(242190, 118, '2014-03-15 00:47:17.000000', 'temperatura', 1093.0000, 'ºC'),
	(242191, 118, '2014-03-15 00:47:18.000000', 'temperatura', 814.0000, 'ºC'),
	(242192, 118, '2014-03-15 00:47:19.000000', 'temperatura', 789.0000, 'ºC'),
	(242193, 118, '2014-03-15 00:47:20.000000', 'temperatura', 304.0000, 'ºC'),
	(242194, 118, '2014-03-15 00:47:21.000000', 'temperatura', 352.0000, 'ºC'),
	(242195, 118, '2014-03-15 00:47:22.000000', 'temperatura', 850.0000, 'ºC'),
	(242196, 118, '2014-03-15 00:47:23.000000', 'temperatura', 792.0000, 'ºC'),
	(242197, 118, '2014-03-15 00:47:24.000000', 'temperatura', 214.0000, 'ºC'),
	(242198, 118, '2014-03-15 00:47:25.000000', 'temperatura', 1094.0000, 'ºC'),
	(242199, 118, '2014-03-15 00:47:26.000000', 'temperatura', 26.0000, 'ºC'),
	(242200, 118, '2014-03-15 00:47:27.000000', 'temperatura', 451.0000, 'ºC'),
	(242201, 118, '2014-03-15 00:47:28.000000', 'temperatura', 975.0000, 'ºC'),
	(242202, 118, '2014-03-15 00:47:29.000000', 'temperatura', 1124.0000, 'ºC'),
	(242203, 118, '2014-03-15 00:47:30.000000', 'temperatura', 296.0000, 'ºC'),
	(242204, 118, '2014-03-15 00:47:31.000000', 'temperatura', 508.0000, 'ºC'),
	(242205, 118, '2014-03-15 00:47:32.000000', 'temperatura', 451.0000, 'ºC'),
	(242206, 118, '2014-03-15 00:47:33.000000', 'temperatura', 733.0000, 'ºC'),
	(242207, 118, '2014-03-15 00:47:34.000000', 'temperatura', 1114.0000, 'ºC'),
	(242208, 118, '2014-03-15 00:47:35.000000', 'temperatura', 969.0000, 'ºC'),
	(242209, 118, '2014-03-15 00:47:36.000000', 'temperatura', 306.0000, 'ºC'),
	(242210, 118, '2014-03-15 00:47:37.000000', 'temperatura', 1020.0000, 'ºC'),
	(242211, 118, '2014-03-15 00:47:38.000000', 'temperatura', 585.0000, 'ºC'),
	(242212, 118, '2014-03-15 00:47:39.000000', 'temperatura', 1067.0000, 'ºC'),
	(242213, 118, '2014-03-15 00:47:40.000000', 'temperatura', 1177.0000, 'ºC'),
	(242214, 118, '2014-03-15 00:47:41.000000', 'temperatura', 287.0000, 'ºC'),
	(242215, 118, '2014-03-15 00:47:42.000000', 'temperatura', 304.0000, 'ºC'),
	(242216, 118, '2014-03-15 00:47:43.000000', 'temperatura', 660.0000, 'ºC'),
	(242217, 118, '2014-03-15 00:47:44.000000', 'temperatura', 1190.0000, 'ºC'),
	(242218, 118, '2014-03-15 00:47:45.000000', 'temperatura', 369.0000, 'ºC'),
	(242219, 118, '2014-03-15 00:47:46.000000', 'temperatura', 677.0000, 'ºC'),
	(242220, 118, '2014-03-15 00:47:47.000000', 'temperatura', 1079.0000, 'ºC'),
	(242221, 118, '2014-03-15 00:47:48.000000', 'temperatura', 962.0000, 'ºC'),
	(242222, 118, '2014-03-15 00:47:49.000000', 'temperatura', 374.0000, 'ºC'),
	(242223, 118, '2014-03-15 00:47:50.000000', 'temperatura', 184.0000, 'ºC'),
	(242224, 118, '2014-03-15 00:47:51.000000', 'temperatura', 1001.0000, 'ºC'),
	(242225, 118, '2014-03-15 00:47:52.000000', 'temperatura', 852.0000, 'ºC'),
	(242226, 118, '2014-03-15 00:47:53.000000', 'temperatura', 57.0000, 'ºC'),
	(242227, 118, '2014-03-15 00:47:54.000000', 'temperatura', 128.0000, 'ºC'),
	(242228, 118, '2014-03-15 00:47:55.000000', 'temperatura', 473.0000, 'ºC'),
	(242229, 118, '2014-03-15 00:47:56.000000', 'temperatura', 780.0000, 'ºC'),
	(242230, 118, '2014-03-15 00:47:57.000000', 'temperatura', 81.0000, 'ºC'),
	(242231, 118, '2014-03-15 00:47:58.000000', 'temperatura', 467.0000, 'ºC'),
	(242232, 118, '2014-03-15 00:47:59.000000', 'temperatura', 891.0000, 'ºC'),
	(242233, 118, '2014-03-15 00:48:00.000000', 'temperatura', 655.0000, 'ºC'),
	(242234, 118, '2014-03-15 00:48:01.000000', 'temperatura', 601.0000, 'ºC'),
	(242235, 118, '2014-03-15 00:48:02.000000', 'temperatura', 1041.0000, 'ºC'),
	(242236, 118, '2014-03-15 00:48:03.000000', 'temperatura', 1003.0000, 'ºC'),
	(242237, 118, '2014-03-15 00:48:04.000000', 'temperatura', 693.0000, 'ºC'),
	(242238, 118, '2014-03-15 00:48:05.000000', 'temperatura', 455.0000, 'ºC'),
	(242239, 118, '2014-03-15 00:48:06.000000', 'temperatura', 199.0000, 'ºC'),
	(242240, 118, '2014-03-15 00:48:07.000000', 'temperatura', 831.0000, 'ºC'),
	(242241, 118, '2014-03-15 00:48:08.000000', 'temperatura', 1156.0000, 'ºC'),
	(242242, 118, '2014-03-15 00:48:09.000000', 'temperatura', 889.0000, 'ºC'),
	(242243, 118, '2014-03-15 00:48:10.000000', 'temperatura', 977.0000, 'ºC'),
	(242244, 118, '2014-03-15 00:48:11.000000', 'temperatura', 1019.0000, 'ºC'),
	(242245, 118, '2014-03-15 00:48:12.000000', 'temperatura', 965.0000, 'ºC'),
	(242246, 118, '2014-03-15 00:48:13.000000', 'temperatura', 567.0000, 'ºC'),
	(242247, 118, '2014-03-15 00:48:14.000000', 'temperatura', 1143.0000, 'ºC'),
	(242248, 118, '2014-03-15 00:48:15.000000', 'temperatura', 412.0000, 'ºC'),
	(242249, 118, '2014-03-15 00:48:16.000000', 'temperatura', 1033.0000, 'ºC'),
	(242250, 118, '2014-03-15 00:48:17.000000', 'temperatura', 331.0000, 'ºC'),
	(242251, 118, '2014-03-15 00:48:18.000000', 'temperatura', 954.0000, 'ºC'),
	(242252, 118, '2014-03-15 00:48:19.000000', 'temperatura', 179.0000, 'ºC'),
	(242253, 118, '2014-03-15 00:48:20.000000', 'temperatura', 434.0000, 'ºC'),
	(242254, 118, '2014-03-15 00:48:21.000000', 'temperatura', 433.0000, 'ºC'),
	(242255, 118, '2014-03-15 00:48:22.000000', 'temperatura', 864.0000, 'ºC'),
	(242256, 118, '2014-03-15 00:48:23.000000', 'temperatura', 621.0000, 'ºC'),
	(242257, 118, '2014-03-15 00:48:24.000000', 'temperatura', 515.0000, 'ºC'),
	(242258, 118, '2014-03-15 00:48:25.000000', 'temperatura', 712.0000, 'ºC'),
	(242259, 118, '2014-03-15 00:48:26.000000', 'temperatura', 814.0000, 'ºC'),
	(242260, 118, '2014-03-15 00:48:27.000000', 'temperatura', 733.0000, 'ºC'),
	(242261, 118, '2014-03-15 00:48:28.000000', 'temperatura', 26.0000, 'ºC'),
	(242262, 118, '2014-03-15 00:48:29.000000', 'temperatura', 330.0000, 'ºC'),
	(242263, 118, '2014-03-15 00:48:30.000000', 'temperatura', 375.0000, 'ºC'),
	(242264, 118, '2014-03-15 00:48:31.000000', 'temperatura', 884.0000, 'ºC'),
	(242265, 118, '2014-03-15 00:48:32.000000', 'temperatura', 894.0000, 'ºC'),
	(242266, 118, '2014-03-15 00:48:33.000000', 'temperatura', 620.0000, 'ºC'),
	(242267, 118, '2014-03-15 00:48:34.000000', 'temperatura', 417.0000, 'ºC'),
	(242268, 118, '2014-03-15 00:48:35.000000', 'temperatura', 227.0000, 'ºC'),
	(242269, 118, '2014-03-15 00:48:36.000000', 'temperatura', 1086.0000, 'ºC'),
	(242270, 118, '2014-03-15 00:48:37.000000', 'temperatura', 1149.0000, 'ºC'),
	(242271, 118, '2014-03-15 00:48:38.000000', 'temperatura', 86.0000, 'ºC'),
	(242272, 118, '2014-03-15 00:48:39.000000', 'temperatura', 585.0000, 'ºC'),
	(242273, 118, '2014-03-15 00:48:40.000000', 'temperatura', 269.0000, 'ºC'),
	(242274, 118, '2014-03-15 00:48:41.000000', 'temperatura', 789.0000, 'ºC'),
	(242275, 118, '2014-03-15 00:48:42.000000', 'temperatura', 737.0000, 'ºC'),
	(242276, 118, '2014-03-15 00:48:43.000000', 'temperatura', 121.0000, 'ºC'),
	(242277, 118, '2014-03-15 00:48:44.000000', 'temperatura', 794.0000, 'ºC'),
	(242278, 118, '2014-03-15 00:48:45.000000', 'temperatura', 8.0000, 'ºC'),
	(242279, 118, '2014-03-15 00:48:46.000000', 'temperatura', 59.0000, 'ºC'),
	(242280, 118, '2014-03-15 00:48:47.000000', 'temperatura', 269.0000, 'ºC'),
	(242281, 118, '2014-03-15 00:48:48.000000', 'temperatura', 1169.0000, 'ºC'),
	(242282, 118, '2014-03-15 00:48:49.000000', 'temperatura', 240.0000, 'ºC'),
	(242283, 118, '2014-03-15 00:48:50.000000', 'temperatura', 91.0000, 'ºC'),
	(242284, 118, '2014-03-15 00:48:51.000000', 'temperatura', 937.0000, 'ºC'),
	(242285, 118, '2014-03-15 00:48:52.000000', 'temperatura', 811.0000, 'ºC'),
	(242286, 118, '2014-03-15 00:48:53.000000', 'temperatura', 47.0000, 'ºC'),
	(242287, 118, '2014-03-15 00:48:54.000000', 'temperatura', 201.0000, 'ºC'),
	(242288, 118, '2014-03-15 00:48:55.000000', 'temperatura', 865.0000, 'ºC'),
	(242289, 118, '2014-03-15 00:48:56.000000', 'temperatura', 121.0000, 'ºC'),
	(242290, 118, '2014-03-15 00:48:57.000000', 'temperatura', 413.0000, 'ºC'),
	(242291, 118, '2014-03-15 00:48:58.000000', 'temperatura', 503.0000, 'ºC'),
	(242292, 118, '2014-03-15 00:48:59.000000', 'temperatura', 74.0000, 'ºC'),
	(242293, 118, '2014-03-15 00:49:00.000000', 'temperatura', 61.0000, 'ºC'),
	(242294, 118, '2014-03-15 00:49:01.000000', 'temperatura', 85.0000, 'ºC'),
	(242295, 118, '2014-03-15 00:49:02.000000', 'temperatura', 243.0000, 'ºC'),
	(242296, 118, '2014-03-15 00:49:03.000000', 'temperatura', 961.0000, 'ºC'),
	(242297, 118, '2014-03-15 00:49:04.000000', 'temperatura', 477.0000, 'ºC'),
	(242298, 118, '2014-03-15 00:49:05.000000', 'temperatura', 703.0000, 'ºC'),
	(242299, 118, '2014-03-15 00:49:06.000000', 'temperatura', 884.0000, 'ºC'),
	(242300, 118, '2014-03-15 00:49:07.000000', 'temperatura', 1110.0000, 'ºC'),
	(242301, 118, '2014-03-15 00:49:08.000000', 'temperatura', 501.0000, 'ºC'),
	(242302, 118, '2014-03-15 00:49:09.000000', 'temperatura', 374.0000, 'ºC'),
	(242303, 118, '2014-03-15 00:49:10.000000', 'temperatura', 367.0000, 'ºC'),
	(242304, 118, '2014-03-15 00:49:11.000000', 'temperatura', 713.0000, 'ºC'),
	(242305, 118, '2014-03-15 00:49:12.000000', 'temperatura', 66.0000, 'ºC'),
	(242306, 118, '2014-03-15 00:49:13.000000', 'temperatura', 589.0000, 'ºC'),
	(242307, 118, '2014-03-15 00:49:14.000000', 'temperatura', 350.0000, 'ºC'),
	(242308, 118, '2014-03-15 00:49:15.000000', 'temperatura', 1182.0000, 'ºC'),
	(242309, 118, '2014-03-15 00:49:16.000000', 'temperatura', 59.0000, 'ºC'),
	(242310, 118, '2014-03-15 00:49:17.000000', 'temperatura', 350.0000, 'ºC'),
	(242311, 118, '2014-03-15 00:49:18.000000', 'temperatura', 376.0000, 'ºC'),
	(242312, 118, '2014-03-15 00:49:19.000000', 'temperatura', 827.0000, 'ºC'),
	(242313, 118, '2014-03-15 00:49:20.000000', 'temperatura', 611.0000, 'ºC'),
	(242314, 118, '2014-03-15 00:49:21.000000', 'temperatura', 571.0000, 'ºC'),
	(242315, 118, '2014-03-15 00:49:22.000000', 'temperatura', 1026.0000, 'ºC'),
	(242316, 118, '2014-03-15 00:49:23.000000', 'temperatura', 1014.0000, 'ºC'),
	(242317, 118, '2014-03-15 00:49:24.000000', 'temperatura', 796.0000, 'ºC'),
	(242318, 118, '2014-03-15 00:49:25.000000', 'temperatura', 937.0000, 'ºC'),
	(242319, 118, '2014-03-15 00:49:26.000000', 'temperatura', 1098.0000, 'ºC'),
	(242320, 118, '2014-03-15 00:49:27.000000', 'temperatura', 280.0000, 'ºC'),
	(242321, 118, '2014-03-15 00:49:28.000000', 'temperatura', 508.0000, 'ºC'),
	(242322, 118, '2014-03-15 00:49:29.000000', 'temperatura', 498.0000, 'ºC'),
	(242323, 118, '2014-03-15 00:49:30.000000', 'temperatura', 966.0000, 'ºC'),
	(242324, 118, '2014-03-15 00:49:31.000000', 'temperatura', 938.0000, 'ºC'),
	(242325, 118, '2014-03-15 00:49:32.000000', 'temperatura', 591.0000, 'ºC'),
	(242326, 118, '2014-03-15 00:49:33.000000', 'temperatura', 144.0000, 'ºC'),
	(242327, 118, '2014-03-15 00:49:34.000000', 'temperatura', 145.0000, 'ºC'),
	(242328, 118, '2014-03-15 00:49:35.000000', 'temperatura', 292.0000, 'ºC'),
	(242329, 118, '2014-03-15 00:49:36.000000', 'temperatura', 1028.0000, 'ºC'),
	(242330, 118, '2014-03-15 00:49:37.000000', 'temperatura', 665.0000, 'ºC'),
	(242331, 118, '2014-03-15 00:49:38.000000', 'temperatura', 242.0000, 'ºC'),
	(242332, 118, '2014-03-15 00:49:39.000000', 'temperatura', 415.0000, 'ºC'),
	(242333, 118, '2014-03-15 00:49:40.000000', 'temperatura', 149.0000, 'ºC'),
	(242334, 118, '2014-03-15 00:49:41.000000', 'temperatura', 699.0000, 'ºC'),
	(242335, 118, '2014-03-15 00:49:42.000000', 'temperatura', 651.0000, 'ºC'),
	(242336, 118, '2014-03-15 00:49:43.000000', 'temperatura', 1156.0000, 'ºC'),
	(242337, 118, '2014-03-15 00:49:44.000000', 'temperatura', 231.0000, 'ºC'),
	(242338, 118, '2014-03-15 00:49:45.000000', 'temperatura', 84.0000, 'ºC'),
	(242339, 118, '2014-03-15 00:49:46.000000', 'temperatura', 930.0000, 'ºC'),
	(242340, 118, '2014-03-15 00:49:47.000000', 'temperatura', 797.0000, 'ºC'),
	(242341, 118, '2014-03-15 00:49:48.000000', 'temperatura', 1197.0000, 'ºC'),
	(242342, 118, '2014-03-15 00:49:49.000000', 'temperatura', 1194.0000, 'ºC'),
	(242343, 118, '2014-03-15 00:49:50.000000', 'temperatura', 1181.0000, 'ºC'),
	(242344, 118, '2014-03-15 00:49:51.000000', 'temperatura', 1123.0000, 'ºC'),
	(242345, 118, '2014-03-15 00:49:52.000000', 'temperatura', 873.0000, 'ºC'),
	(242346, 118, '2014-03-15 00:49:53.000000', 'temperatura', 995.0000, 'ºC'),
	(242347, 118, '2014-03-15 00:49:54.000000', 'temperatura', 1156.0000, 'ºC'),
	(242348, 118, '2014-03-15 00:49:55.000000', 'temperatura', 397.0000, 'ºC'),
	(242349, 118, '2014-03-15 00:49:56.000000', 'temperatura', 917.0000, 'ºC'),
	(242350, 118, '2014-03-15 00:49:57.000000', 'temperatura', 996.0000, 'ºC'),
	(242351, 118, '2014-03-15 00:49:58.000000', 'temperatura', 1027.0000, 'ºC'),
	(242352, 118, '2014-03-15 00:49:59.000000', 'temperatura', 948.0000, 'ºC'),
	(242353, 118, '2014-03-15 00:50:00.000000', 'temperatura', 458.0000, 'ºC'),
	(242354, 118, '2014-03-15 00:50:01.000000', 'temperatura', 647.0000, 'ºC'),
	(242355, 118, '2014-03-15 00:50:02.000000', 'temperatura', 662.0000, 'ºC'),
	(242356, 118, '2014-03-15 00:50:03.000000', 'temperatura', 169.0000, 'ºC'),
	(242357, 118, '2014-03-15 00:50:04.000000', 'temperatura', 59.0000, 'ºC'),
	(242358, 118, '2014-03-15 00:50:05.000000', 'temperatura', 989.0000, 'ºC'),
	(242359, 118, '2014-03-15 00:50:06.000000', 'temperatura', 1167.0000, 'ºC'),
	(242360, 118, '2014-03-15 00:50:07.000000', 'temperatura', 469.0000, 'ºC'),
	(242361, 118, '2014-03-15 00:50:08.000000', 'temperatura', 46.0000, 'ºC'),
	(242362, 118, '2014-03-15 00:50:09.000000', 'temperatura', 23.0000, 'ºC'),
	(242363, 118, '2014-03-15 00:50:10.000000', 'temperatura', 1178.0000, 'ºC'),
	(242364, 118, '2014-03-15 00:50:11.000000', 'temperatura', 1022.0000, 'ºC'),
	(242365, 118, '2014-03-15 00:50:12.000000', 'temperatura', 377.0000, 'ºC'),
	(242366, 118, '2014-03-15 00:50:13.000000', 'temperatura', 20.0000, 'ºC'),
	(242367, 118, '2014-03-15 00:50:14.000000', 'temperatura', 167.0000, 'ºC'),
	(242368, 118, '2014-03-15 00:50:15.000000', 'temperatura', 776.0000, 'ºC'),
	(242369, 118, '2014-03-15 00:50:16.000000', 'temperatura', 978.0000, 'ºC'),
	(242370, 118, '2014-03-15 00:50:17.000000', 'temperatura', 165.0000, 'ºC'),
	(242371, 118, '2014-03-15 00:50:18.000000', 'temperatura', 292.0000, 'ºC'),
	(242372, 118, '2014-03-15 00:50:19.000000', 'temperatura', 964.0000, 'ºC'),
	(242373, 118, '2014-03-15 00:50:20.000000', 'temperatura', 344.0000, 'ºC'),
	(242374, 118, '2014-03-15 00:50:21.000000', 'temperatura', 27.0000, 'ºC'),
	(242375, 118, '2014-03-15 00:50:22.000000', 'temperatura', 305.0000, 'ºC'),
	(242376, 118, '2014-03-15 00:50:23.000000', 'temperatura', 246.0000, 'ºC'),
	(242377, 118, '2014-03-15 00:50:24.000000', 'temperatura', 313.0000, 'ºC'),
	(242378, 118, '2014-03-15 00:50:25.000000', 'temperatura', 829.0000, 'ºC'),
	(242379, 118, '2014-03-15 00:50:26.000000', 'temperatura', 807.0000, 'ºC'),
	(242380, 118, '2014-03-15 00:50:27.000000', 'temperatura', 347.0000, 'ºC'),
	(242381, 118, '2014-03-15 00:50:28.000000', 'temperatura', 517.0000, 'ºC'),
	(242382, 118, '2014-03-15 00:50:29.000000', 'temperatura', 341.0000, 'ºC'),
	(242383, 118, '2014-03-15 00:50:30.000000', 'temperatura', 158.0000, 'ºC'),
	(242384, 118, '2014-03-15 00:50:31.000000', 'temperatura', 966.0000, 'ºC'),
	(242385, 118, '2014-03-15 00:50:32.000000', 'temperatura', 758.0000, 'ºC'),
	(242386, 118, '2014-03-15 00:50:33.000000', 'temperatura', 894.0000, 'ºC'),
	(242387, 118, '2014-03-15 00:50:34.000000', 'temperatura', 993.0000, 'ºC'),
	(242388, 118, '2014-03-15 00:50:35.000000', 'temperatura', 1084.0000, 'ºC'),
	(242389, 118, '2014-03-15 00:50:36.000000', 'temperatura', 43.0000, 'ºC'),
	(242390, 118, '2014-03-15 00:50:37.000000', 'temperatura', 562.0000, 'ºC'),
	(242391, 118, '2014-03-15 00:50:38.000000', 'temperatura', 283.0000, 'ºC'),
	(242392, 118, '2014-03-15 00:50:39.000000', 'temperatura', 930.0000, 'ºC'),
	(242393, 118, '2014-03-15 00:50:40.000000', 'temperatura', 199.0000, 'ºC'),
	(242394, 118, '2014-03-15 00:50:41.000000', 'temperatura', 607.0000, 'ºC'),
	(242395, 118, '2014-03-15 00:50:42.000000', 'temperatura', 37.0000, 'ºC'),
	(242396, 118, '2014-03-15 00:50:43.000000', 'temperatura', 764.0000, 'ºC'),
	(242397, 118, '2014-03-15 00:50:44.000000', 'temperatura', 112.0000, 'ºC'),
	(242398, 118, '2014-03-15 00:50:45.000000', 'temperatura', 668.0000, 'ºC'),
	(242399, 118, '2014-03-15 00:50:46.000000', 'temperatura', 603.0000, 'ºC'),
	(242400, 118, '2014-03-15 00:50:47.000000', 'temperatura', 1011.0000, 'ºC'),
	(242401, 118, '2014-03-15 00:50:48.000000', 'temperatura', 847.0000, 'ºC'),
	(242402, 118, '2014-03-15 00:50:49.000000', 'temperatura', 4.0000, 'ºC'),
	(242403, 118, '2014-03-15 00:50:50.000000', 'temperatura', 1077.0000, 'ºC'),
	(242404, 118, '2014-03-15 00:50:51.000000', 'temperatura', 573.0000, 'ºC'),
	(242405, 118, '2014-03-15 00:50:52.000000', 'temperatura', 837.0000, 'ºC'),
	(242406, 118, '2014-03-15 00:50:53.000000', 'temperatura', 65.0000, 'ºC'),
	(242407, 118, '2014-03-15 00:50:54.000000', 'temperatura', 217.0000, 'ºC'),
	(242408, 118, '2014-03-15 00:50:55.000000', 'temperatura', 889.0000, 'ºC'),
	(242409, 118, '2014-03-15 00:50:56.000000', 'temperatura', 193.0000, 'ºC'),
	(242410, 118, '2014-03-15 00:50:57.000000', 'temperatura', 701.0000, 'ºC'),
	(242411, 118, '2014-03-15 00:50:58.000000', 'temperatura', 527.0000, 'ºC'),
	(242412, 118, '2014-03-15 00:50:59.000000', 'temperatura', 533.0000, 'ºC'),
	(242413, 118, '2014-03-15 00:51:00.000000', 'temperatura', 1082.0000, 'ºC'),
	(242414, 118, '2014-03-15 00:51:01.000000', 'temperatura', 211.0000, 'ºC'),
	(242415, 118, '2014-03-15 00:51:02.000000', 'temperatura', 212.0000, 'ºC'),
	(242416, 118, '2014-03-15 00:51:03.000000', 'temperatura', 427.0000, 'ºC'),
	(242417, 118, '2014-03-15 00:51:04.000000', 'temperatura', 300.0000, 'ºC'),
	(242418, 118, '2014-03-15 00:51:05.000000', 'temperatura', 219.0000, 'ºC'),
	(242419, 118, '2014-03-15 00:51:06.000000', 'temperatura', 193.0000, 'ºC'),
	(242420, 118, '2014-03-15 00:51:07.000000', 'temperatura', 311.0000, 'ºC'),
	(242421, 118, '2014-03-15 00:51:08.000000', 'temperatura', 978.0000, 'ºC'),
	(242422, 118, '2014-03-15 00:51:09.000000', 'temperatura', 356.0000, 'ºC'),
	(242423, 118, '2014-03-15 00:51:10.000000', 'temperatura', 45.0000, 'ºC'),
	(242424, 118, '2014-03-15 00:51:11.000000', 'temperatura', 358.0000, 'ºC'),
	(242425, 118, '2014-03-15 00:51:12.000000', 'temperatura', 456.0000, 'ºC'),
	(242426, 118, '2014-03-15 00:51:13.000000', 'temperatura', 7.0000, 'ºC'),
	(242427, 118, '2014-03-15 00:51:14.000000', 'temperatura', 1069.0000, 'ºC'),
	(242428, 118, '2014-03-15 00:51:15.000000', 'temperatura', 522.0000, 'ºC'),
	(242429, 118, '2014-03-15 00:51:16.000000', 'temperatura', 604.0000, 'ºC'),
	(242430, 118, '2014-03-15 00:51:17.000000', 'temperatura', 255.0000, 'ºC'),
	(242431, 118, '2014-03-15 00:51:18.000000', 'temperatura', 662.0000, 'ºC'),
	(242432, 118, '2014-03-15 00:51:19.000000', 'temperatura', 146.0000, 'ºC'),
	(242433, 118, '2014-03-15 00:51:20.000000', 'temperatura', 1143.0000, 'ºC'),
	(242434, 118, '2014-03-15 00:51:21.000000', 'temperatura', 479.0000, 'ºC'),
	(242435, 118, '2014-03-15 00:51:22.000000', 'temperatura', 165.0000, 'ºC'),
	(242436, 118, '2014-03-15 00:51:23.000000', 'temperatura', 591.0000, 'ºC'),
	(242437, 118, '2014-03-15 00:51:24.000000', 'temperatura', 59.0000, 'ºC'),
	(242438, 118, '2014-03-15 00:51:25.000000', 'temperatura', 925.0000, 'ºC'),
	(242439, 118, '2014-03-15 00:51:26.000000', 'temperatura', 846.0000, 'ºC'),
	(242440, 118, '2014-03-15 00:51:27.000000', 'temperatura', 256.0000, 'ºC'),
	(242441, 118, '2014-03-15 00:51:28.000000', 'temperatura', 1144.0000, 'ºC'),
	(242442, 118, '2014-03-15 00:51:29.000000', 'temperatura', 151.0000, 'ºC'),
	(242443, 118, '2014-03-15 00:51:30.000000', 'temperatura', 926.0000, 'ºC'),
	(242444, 118, '2014-03-15 00:51:31.000000', 'temperatura', 575.0000, 'ºC'),
	(242445, 118, '2014-03-15 00:51:32.000000', 'temperatura', 97.0000, 'ºC'),
	(242446, 118, '2014-03-15 00:51:33.000000', 'temperatura', 1163.0000, 'ºC'),
	(242447, 118, '2014-03-15 00:51:34.000000', 'temperatura', 724.0000, 'ºC'),
	(242448, 118, '2014-03-15 00:51:35.000000', 'temperatura', 131.0000, 'ºC'),
	(242449, 118, '2014-03-15 00:51:36.000000', 'temperatura', 883.0000, 'ºC'),
	(242450, 118, '2014-03-15 00:51:37.000000', 'temperatura', 423.0000, 'ºC'),
	(242451, 118, '2014-03-15 00:51:38.000000', 'temperatura', 667.0000, 'ºC'),
	(242452, 118, '2014-03-15 00:51:39.000000', 'temperatura', 865.0000, 'ºC'),
	(242453, 118, '2014-03-15 00:51:40.000000', 'temperatura', 1127.0000, 'ºC'),
	(242454, 118, '2014-03-15 00:51:41.000000', 'temperatura', 638.0000, 'ºC'),
	(242455, 118, '2014-03-15 00:51:42.000000', 'temperatura', 1008.0000, 'ºC'),
	(242456, 118, '2014-03-15 00:51:43.000000', 'temperatura', 730.0000, 'ºC'),
	(242457, 118, '2014-03-15 00:51:44.000000', 'temperatura', 624.0000, 'ºC'),
	(242458, 118, '2014-03-15 00:51:45.000000', 'temperatura', 931.0000, 'ºC'),
	(242459, 118, '2014-03-15 00:51:46.000000', 'temperatura', 385.0000, 'ºC'),
	(242460, 118, '2014-03-15 00:51:47.000000', 'temperatura', 331.0000, 'ºC'),
	(242461, 118, '2014-03-15 00:51:48.000000', 'temperatura', 501.0000, 'ºC'),
	(242462, 118, '2014-03-15 00:51:49.000000', 'temperatura', 311.0000, 'ºC'),
	(242463, 118, '2014-03-15 00:51:50.000000', 'temperatura', 55.0000, 'ºC'),
	(242464, 118, '2014-03-15 00:51:51.000000', 'temperatura', 543.0000, 'ºC'),
	(242465, 118, '2014-03-15 00:51:52.000000', 'temperatura', 148.0000, 'ºC'),
	(242466, 118, '2014-03-15 00:51:53.000000', 'temperatura', 314.0000, 'ºC'),
	(242467, 118, '2014-03-15 00:51:54.000000', 'temperatura', 1126.0000, 'ºC'),
	(242468, 118, '2014-03-15 00:51:55.000000', 'temperatura', 1089.0000, 'ºC'),
	(242469, 118, '2014-03-15 00:51:56.000000', 'temperatura', 868.0000, 'ºC'),
	(242470, 118, '2014-03-15 00:51:57.000000', 'temperatura', 1071.0000, 'ºC'),
	(242471, 118, '2014-03-15 00:51:58.000000', 'temperatura', 354.0000, 'ºC'),
	(242472, 118, '2014-03-15 00:51:59.000000', 'temperatura', 954.0000, 'ºC'),
	(242473, 118, '2014-03-15 00:52:00.000000', 'temperatura', 112.0000, 'ºC'),
	(242474, 118, '2014-03-15 00:52:01.000000', 'temperatura', 99.0000, 'ºC'),
	(242475, 118, '2014-03-15 00:52:02.000000', 'temperatura', 156.0000, 'ºC'),
	(242476, 118, '2014-03-15 00:52:03.000000', 'temperatura', 487.0000, 'ºC'),
	(242477, 118, '2014-03-15 00:52:04.000000', 'temperatura', 767.0000, 'ºC'),
	(242478, 118, '2014-03-15 00:52:05.000000', 'temperatura', 1172.0000, 'ºC'),
	(242479, 118, '2014-03-15 00:52:06.000000', 'temperatura', 1162.0000, 'ºC'),
	(242480, 118, '2014-03-15 00:52:07.000000', 'temperatura', 1092.0000, 'ºC'),
	(242481, 118, '2014-03-15 00:52:08.000000', 'temperatura', 776.0000, 'ºC'),
	(242482, 118, '2014-03-15 00:52:09.000000', 'temperatura', 606.0000, 'ºC'),
	(242483, 118, '2014-03-15 00:52:10.000000', 'temperatura', 702.0000, 'ºC'),
	(242484, 118, '2014-03-15 00:52:11.000000', 'temperatura', 490.0000, 'ºC'),
	(242485, 118, '2014-03-15 00:52:12.000000', 'temperatura', 347.0000, 'ºC'),
	(242486, 118, '2014-03-15 00:52:13.000000', 'temperatura', 263.0000, 'ºC'),
	(242487, 118, '2014-03-15 00:52:14.000000', 'temperatura', 277.0000, 'ºC'),
	(242488, 118, '2014-03-15 00:52:15.000000', 'temperatura', 594.0000, 'ºC'),
	(242489, 118, '2014-03-15 00:52:16.000000', 'temperatura', 940.0000, 'ºC'),
	(242490, 118, '2014-03-15 00:52:17.000000', 'temperatura', 519.0000, 'ºC'),
	(242491, 118, '2014-03-15 00:52:18.000000', 'temperatura', 976.0000, 'ºC'),
	(242492, 118, '2014-03-15 00:52:19.000000', 'temperatura', 921.0000, 'ºC'),
	(242493, 118, '2014-03-15 00:52:20.000000', 'temperatura', 479.0000, 'ºC'),
	(242494, 118, '2014-03-15 00:52:21.000000', 'temperatura', 832.0000, 'ºC'),
	(242495, 118, '2014-03-15 00:52:22.000000', 'temperatura', 323.0000, 'ºC'),
	(242496, 118, '2014-03-15 00:52:23.000000', 'temperatura', 319.0000, 'ºC'),
	(242497, 118, '2014-03-15 00:52:24.000000', 'temperatura', 628.0000, 'ºC'),
	(242498, 118, '2014-03-15 00:52:25.000000', 'temperatura', 983.0000, 'ºC'),
	(242499, 118, '2014-03-15 00:52:26.000000', 'temperatura', 631.0000, 'ºC'),
	(242500, 118, '2014-03-15 00:52:27.000000', 'temperatura', 209.0000, 'ºC'),
	(242501, 118, '2014-03-15 00:52:28.000000', 'temperatura', 350.0000, 'ºC'),
	(242502, 118, '2014-03-15 00:52:29.000000', 'temperatura', 1123.0000, 'ºC'),
	(242503, 118, '2014-03-15 00:52:30.000000', 'temperatura', 966.0000, 'ºC'),
	(242504, 118, '2014-03-15 00:52:31.000000', 'temperatura', 260.0000, 'ºC'),
	(242505, 118, '2014-03-15 00:52:32.000000', 'temperatura', 804.0000, 'ºC'),
	(242506, 118, '2014-03-15 00:52:33.000000', 'temperatura', 841.0000, 'ºC'),
	(242507, 118, '2014-03-15 00:52:34.000000', 'temperatura', 591.0000, 'ºC'),
	(242508, 118, '2014-03-15 00:52:35.000000', 'temperatura', 436.0000, 'ºC'),
	(242509, 118, '2014-03-15 00:52:36.000000', 'temperatura', 406.0000, 'ºC'),
	(242510, 118, '2014-03-15 00:52:37.000000', 'temperatura', 723.0000, 'ºC'),
	(242511, 118, '2014-03-15 00:52:38.000000', 'temperatura', 1195.0000, 'ºC'),
	(242512, 118, '2014-03-15 00:52:39.000000', 'temperatura', 208.0000, 'ºC'),
	(242513, 118, '2014-03-15 00:52:40.000000', 'temperatura', 1056.0000, 'ºC'),
	(242514, 118, '2014-03-15 00:52:41.000000', 'temperatura', 1057.0000, 'ºC'),
	(242515, 118, '2014-03-15 00:52:42.000000', 'temperatura', 915.0000, 'ºC'),
	(242516, 118, '2014-03-15 00:52:43.000000', 'temperatura', 207.0000, 'ºC'),
	(242517, 118, '2014-03-15 00:52:44.000000', 'temperatura', 688.0000, 'ºC'),
	(242518, 118, '2014-03-15 00:52:45.000000', 'temperatura', 422.0000, 'ºC'),
	(242519, 118, '2014-03-15 00:52:46.000000', 'temperatura', 45.0000, 'ºC'),
	(242520, 118, '2014-03-15 00:52:47.000000', 'temperatura', 159.0000, 'ºC'),
	(242521, 118, '2014-03-15 00:52:48.000000', 'temperatura', 660.0000, 'ºC'),
	(242522, 118, '2014-03-15 00:52:49.000000', 'temperatura', 426.0000, 'ºC'),
	(242523, 118, '2014-03-15 00:52:50.000000', 'temperatura', 150.0000, 'ºC'),
	(242524, 118, '2014-03-15 00:52:51.000000', 'temperatura', 672.0000, 'ºC'),
	(242525, 118, '2014-03-15 00:52:52.000000', 'temperatura', 510.0000, 'ºC'),
	(242526, 118, '2014-03-15 00:52:53.000000', 'temperatura', 536.0000, 'ºC'),
	(242527, 118, '2014-03-15 00:52:54.000000', 'temperatura', 1151.0000, 'ºC'),
	(242528, 118, '2014-03-15 00:52:55.000000', 'temperatura', 546.0000, 'ºC'),
	(242529, 118, '2014-03-15 00:52:56.000000', 'temperatura', 478.0000, 'ºC'),
	(242530, 118, '2014-03-15 00:52:57.000000', 'temperatura', 751.0000, 'ºC'),
	(242531, 118, '2014-03-15 00:52:58.000000', 'temperatura', 1122.0000, 'ºC'),
	(242532, 118, '2014-03-15 00:52:59.000000', 'temperatura', 958.0000, 'ºC'),
	(242533, 118, '2014-03-15 00:53:00.000000', 'temperatura', 226.0000, 'ºC'),
	(242534, 118, '2014-03-15 00:53:01.000000', 'temperatura', 656.0000, 'ºC'),
	(242535, 118, '2014-03-15 00:53:02.000000', 'temperatura', 204.0000, 'ºC'),
	(242536, 118, '2014-03-15 00:53:03.000000', 'temperatura', 251.0000, 'ºC'),
	(242537, 118, '2014-03-15 00:53:04.000000', 'temperatura', 645.0000, 'ºC'),
	(242538, 118, '2014-03-15 00:53:05.000000', 'temperatura', 71.0000, 'ºC'),
	(242539, 118, '2014-03-15 00:53:06.000000', 'temperatura', 823.0000, 'ºC'),
	(242540, 118, '2014-03-15 00:53:07.000000', 'temperatura', 300.0000, 'ºC'),
	(242541, 118, '2014-03-15 00:53:08.000000', 'temperatura', 231.0000, 'ºC'),
	(242542, 118, '2014-03-15 00:53:09.000000', 'temperatura', 257.0000, 'ºC'),
	(242543, 118, '2014-03-15 00:53:10.000000', 'temperatura', 590.0000, 'ºC'),
	(242544, 118, '2014-03-15 00:53:11.000000', 'temperatura', 982.0000, 'ºC'),
	(242545, 118, '2014-03-15 00:53:12.000000', 'temperatura', 739.0000, 'ºC'),
	(242546, 118, '2014-03-15 00:53:13.000000', 'temperatura', 750.0000, 'ºC'),
	(242547, 118, '2014-03-15 00:53:14.000000', 'temperatura', 336.0000, 'ºC'),
	(242548, 118, '2014-03-15 00:53:15.000000', 'temperatura', 627.0000, 'ºC'),
	(242549, 118, '2014-03-15 00:53:16.000000', 'temperatura', 927.0000, 'ºC'),
	(242550, 118, '2014-03-15 00:53:17.000000', 'temperatura', 357.0000, 'ºC'),
	(242551, 118, '2014-03-15 00:53:18.000000', 'temperatura', 203.0000, 'ºC'),
	(242552, 118, '2014-03-15 00:53:19.000000', 'temperatura', 1146.0000, 'ºC'),
	(242553, 118, '2014-03-15 00:53:20.000000', 'temperatura', 319.0000, 'ºC'),
	(242554, 118, '2014-03-15 00:53:21.000000', 'temperatura', 560.0000, 'ºC'),
	(242555, 118, '2014-03-15 00:53:22.000000', 'temperatura', 641.0000, 'ºC'),
	(242556, 118, '2014-03-15 00:53:23.000000', 'temperatura', 328.0000, 'ºC'),
	(242557, 118, '2014-03-15 00:53:24.000000', 'temperatura', 918.0000, 'ºC'),
	(242558, 118, '2014-03-15 00:53:25.000000', 'temperatura', 4.0000, 'ºC'),
	(242559, 118, '2014-03-15 00:53:26.000000', 'temperatura', 868.0000, 'ºC'),
	(242560, 118, '2014-03-15 00:53:27.000000', 'temperatura', 730.0000, 'ºC'),
	(242561, 118, '2014-03-15 00:53:28.000000', 'temperatura', 1046.0000, 'ºC'),
	(242562, 118, '2014-03-15 00:53:29.000000', 'temperatura', 639.0000, 'ºC'),
	(242563, 118, '2014-03-15 00:53:30.000000', 'temperatura', 60.0000, 'ºC'),
	(242564, 118, '2014-03-15 00:53:31.000000', 'temperatura', 781.0000, 'ºC'),
	(242565, 118, '2014-03-15 00:53:32.000000', 'temperatura', 128.0000, 'ºC'),
	(242566, 118, '2014-03-15 00:53:33.000000', 'temperatura', 696.0000, 'ºC'),
	(242567, 118, '2014-03-15 00:53:34.000000', 'temperatura', 697.0000, 'ºC'),
	(242568, 118, '2014-03-15 00:53:35.000000', 'temperatura', 199.0000, 'ºC'),
	(242569, 118, '2014-03-15 00:53:36.000000', 'temperatura', 104.0000, 'ºC'),
	(242570, 118, '2014-03-15 00:53:37.000000', 'temperatura', 1125.0000, 'ºC'),
	(242571, 118, '2014-03-15 00:53:38.000000', 'temperatura', 513.0000, 'ºC'),
	(242572, 118, '2014-03-15 00:53:39.000000', 'temperatura', 388.0000, 'ºC'),
	(242573, 118, '2014-03-15 00:53:40.000000', 'temperatura', 404.0000, 'ºC'),
	(242574, 118, '2014-03-15 00:53:41.000000', 'temperatura', 856.0000, 'ºC'),
	(242575, 118, '2014-03-15 00:53:42.000000', 'temperatura', 668.0000, 'ºC'),
	(242576, 118, '2014-03-15 00:53:43.000000', 'temperatura', 774.0000, 'ºC'),
	(242577, 118, '2014-03-15 00:53:44.000000', 'temperatura', 664.0000, 'ºC'),
	(242578, 118, '2014-03-15 00:53:45.000000', 'temperatura', 998.0000, 'ºC'),
	(242579, 118, '2014-03-15 00:53:46.000000', 'temperatura', 601.0000, 'ºC'),
	(242580, 118, '2014-03-15 00:53:47.000000', 'temperatura', 9.0000, 'ºC'),
	(242581, 118, '2014-03-15 00:53:48.000000', 'temperatura', 643.0000, 'ºC'),
	(242582, 118, '2014-03-15 00:53:49.000000', 'temperatura', 787.0000, 'ºC'),
	(242583, 118, '2014-03-15 00:53:50.000000', 'temperatura', 808.0000, 'ºC'),
	(242584, 118, '2014-03-15 00:53:51.000000', 'temperatura', 478.0000, 'ºC'),
	(242585, 118, '2014-03-15 00:53:52.000000', 'temperatura', 1168.0000, 'ºC'),
	(242586, 118, '2014-03-15 00:53:53.000000', 'temperatura', 805.0000, 'ºC'),
	(242587, 118, '2014-03-15 00:53:54.000000', 'temperatura', 521.0000, 'ºC'),
	(242588, 118, '2014-03-15 00:53:55.000000', 'temperatura', 192.0000, 'ºC'),
	(242589, 118, '2014-03-15 00:53:56.000000', 'temperatura', 596.0000, 'ºC'),
	(242590, 118, '2014-03-15 00:53:57.000000', 'temperatura', 5.0000, 'ºC'),
	(242591, 118, '2014-03-15 00:53:58.000000', 'temperatura', 637.0000, 'ºC'),
	(242592, 118, '2014-03-15 00:53:59.000000', 'temperatura', 772.0000, 'ºC'),
	(242593, 118, '2014-03-15 00:54:00.000000', 'temperatura', 749.0000, 'ºC'),
	(242594, 118, '2014-03-15 00:54:01.000000', 'temperatura', 229.0000, 'ºC'),
	(242595, 118, '2014-03-15 00:54:02.000000', 'temperatura', 98.0000, 'ºC'),
	(242596, 118, '2014-03-15 00:54:03.000000', 'temperatura', 1003.0000, 'ºC'),
	(242597, 118, '2014-03-15 00:54:04.000000', 'temperatura', 1122.0000, 'ºC'),
	(242598, 118, '2014-03-15 00:54:05.000000', 'temperatura', 201.0000, 'ºC'),
	(242599, 118, '2014-03-15 00:54:06.000000', 'temperatura', 41.0000, 'ºC'),
	(242600, 118, '2014-03-15 00:54:07.000000', 'temperatura', 803.0000, 'ºC'),
	(242601, 118, '2014-03-15 00:54:08.000000', 'temperatura', 291.0000, 'ºC'),
	(242602, 118, '2014-03-15 00:54:09.000000', 'temperatura', 245.0000, 'ºC'),
	(242603, 118, '2014-03-15 00:54:10.000000', 'temperatura', 354.0000, 'ºC'),
	(242604, 118, '2014-03-15 00:54:11.000000', 'temperatura', 1035.0000, 'ºC'),
	(242605, 118, '2014-03-15 00:54:12.000000', 'temperatura', 514.0000, 'ºC'),
	(242606, 118, '2014-03-15 00:54:13.000000', 'temperatura', 665.0000, 'ºC'),
	(242607, 118, '2014-03-15 00:54:14.000000', 'temperatura', 583.0000, 'ºC'),
	(242608, 118, '2014-03-15 00:54:15.000000', 'temperatura', 922.0000, 'ºC'),
	(242609, 118, '2014-03-15 00:54:16.000000', 'temperatura', 460.0000, 'ºC'),
	(242610, 118, '2014-03-15 00:54:17.000000', 'temperatura', 735.0000, 'ºC'),
	(242611, 118, '2014-03-15 00:54:18.000000', 'temperatura', 1097.0000, 'ºC'),
	(242612, 118, '2014-03-15 00:54:19.000000', 'temperatura', 881.0000, 'ºC'),
	(242613, 118, '2014-03-15 00:54:20.000000', 'temperatura', 1113.0000, 'ºC'),
	(242614, 118, '2014-03-15 00:54:21.000000', 'temperatura', 521.0000, 'ºC'),
	(242615, 118, '2014-03-15 00:54:22.000000', 'temperatura', 469.0000, 'ºC'),
	(242616, 118, '2014-03-15 00:54:23.000000', 'temperatura', 782.0000, 'ºC'),
	(242617, 118, '2014-03-15 00:54:24.000000', 'temperatura', 104.0000, 'ºC'),
	(242618, 118, '2014-03-15 00:54:25.000000', 'temperatura', 572.0000, 'ºC'),
	(242619, 118, '2014-03-15 00:54:26.000000', 'temperatura', 149.0000, 'ºC'),
	(242620, 118, '2014-03-15 00:54:27.000000', 'temperatura', 232.0000, 'ºC'),
	(242621, 118, '2014-03-15 00:54:28.000000', 'temperatura', 711.0000, 'ºC'),
	(242622, 118, '2014-03-15 00:54:29.000000', 'temperatura', 459.0000, 'ºC'),
	(242623, 118, '2014-03-15 00:54:30.000000', 'temperatura', 164.0000, 'ºC'),
	(242624, 118, '2014-03-15 00:54:31.000000', 'temperatura', 643.0000, 'ºC'),
	(242625, 118, '2014-03-15 00:54:32.000000', 'temperatura', 323.0000, 'ºC'),
	(242626, 118, '2014-03-15 00:54:33.000000', 'temperatura', 887.0000, 'ºC'),
	(242627, 118, '2014-03-15 00:54:34.000000', 'temperatura', 1065.0000, 'ºC'),
	(242628, 118, '2014-03-15 00:54:35.000000', 'temperatura', 264.0000, 'ºC'),
	(242629, 118, '2014-03-15 00:54:36.000000', 'temperatura', 525.0000, 'ºC'),
	(242630, 118, '2014-03-15 00:54:37.000000', 'temperatura', 634.0000, 'ºC'),
	(242631, 118, '2014-03-15 00:54:38.000000', 'temperatura', 394.0000, 'ºC'),
	(242632, 118, '2014-03-15 00:54:39.000000', 'temperatura', 69.0000, 'ºC'),
	(242633, 118, '2014-03-15 00:54:40.000000', 'temperatura', 363.0000, 'ºC'),
	(242634, 118, '2014-03-15 00:54:41.000000', 'temperatura', 411.0000, 'ºC'),
	(242635, 118, '2014-03-15 00:54:42.000000', 'temperatura', 964.0000, 'ºC'),
	(242636, 118, '2014-03-15 00:54:43.000000', 'temperatura', 1187.0000, 'ºC'),
	(242637, 118, '2014-03-15 00:54:44.000000', 'temperatura', 643.0000, 'ºC'),
	(242638, 118, '2014-03-15 00:54:45.000000', 'temperatura', 854.0000, 'ºC'),
	(242639, 118, '2014-03-15 00:54:46.000000', 'temperatura', 1143.0000, 'ºC'),
	(242640, 118, '2014-03-15 00:54:47.000000', 'temperatura', 751.0000, 'ºC'),
	(242641, 118, '2014-03-15 00:54:48.000000', 'temperatura', 329.0000, 'ºC'),
	(242642, 118, '2014-03-15 00:54:49.000000', 'temperatura', 593.0000, 'ºC'),
	(242643, 118, '2014-03-15 00:54:50.000000', 'temperatura', 780.0000, 'ºC'),
	(242644, 118, '2014-03-15 00:54:51.000000', 'temperatura', 919.0000, 'ºC'),
	(242645, 118, '2014-03-15 00:54:52.000000', 'temperatura', 1055.0000, 'ºC'),
	(242646, 118, '2014-03-15 00:54:53.000000', 'temperatura', 120.0000, 'ºC'),
	(242647, 118, '2014-03-15 00:54:54.000000', 'temperatura', 1033.0000, 'ºC'),
	(242648, 118, '2014-03-15 00:54:55.000000', 'temperatura', 8.0000, 'ºC'),
	(242649, 118, '2014-03-15 00:54:56.000000', 'temperatura', 542.0000, 'ºC'),
	(242650, 118, '2014-03-15 00:54:57.000000', 'temperatura', 286.0000, 'ºC'),
	(242651, 118, '2014-03-15 00:54:58.000000', 'temperatura', 1003.0000, 'ºC'),
	(242652, 118, '2014-03-15 00:54:59.000000', 'temperatura', 560.0000, 'ºC'),
	(242653, 118, '2014-03-15 00:55:00.000000', 'temperatura', 991.0000, 'ºC'),
	(242654, 118, '2014-03-15 00:55:01.000000', 'temperatura', 873.0000, 'ºC'),
	(242655, 118, '2014-03-15 00:55:02.000000', 'temperatura', 194.0000, 'ºC'),
	(242656, 118, '2014-03-15 00:55:03.000000', 'temperatura', 752.0000, 'ºC'),
	(242657, 118, '2014-03-15 00:55:04.000000', 'temperatura', 777.0000, 'ºC'),
	(242658, 118, '2014-03-15 00:55:05.000000', 'temperatura', 429.0000, 'ºC'),
	(242659, 118, '2014-03-15 00:55:06.000000', 'temperatura', 1014.0000, 'ºC'),
	(242660, 118, '2014-03-15 00:55:07.000000', 'temperatura', 186.0000, 'ºC'),
	(242661, 118, '2014-03-15 00:55:08.000000', 'temperatura', 289.0000, 'ºC'),
	(242662, 118, '2014-03-15 00:55:09.000000', 'temperatura', 885.0000, 'ºC'),
	(242663, 118, '2014-03-15 00:55:10.000000', 'temperatura', 1158.0000, 'ºC'),
	(242664, 118, '2014-03-15 00:55:11.000000', 'temperatura', 737.0000, 'ºC'),
	(242665, 118, '2014-03-15 00:55:12.000000', 'temperatura', 210.0000, 'ºC'),
	(242666, 118, '2014-03-15 00:55:13.000000', 'temperatura', 39.0000, 'ºC'),
	(242667, 118, '2014-03-15 00:55:14.000000', 'temperatura', 768.0000, 'ºC'),
	(242668, 118, '2014-03-15 00:55:15.000000', 'temperatura', 124.0000, 'ºC'),
	(242669, 118, '2014-03-15 00:55:16.000000', 'temperatura', 717.0000, 'ºC'),
	(242670, 118, '2014-03-15 00:55:17.000000', 'temperatura', 811.0000, 'ºC'),
	(242671, 118, '2014-03-15 00:55:18.000000', 'temperatura', 707.0000, 'ºC'),
	(242672, 118, '2014-03-15 00:55:19.000000', 'temperatura', 1104.0000, 'ºC'),
	(242673, 118, '2014-03-15 00:55:20.000000', 'temperatura', 996.0000, 'ºC'),
	(242674, 118, '2014-03-15 00:55:21.000000', 'temperatura', 469.0000, 'ºC'),
	(242675, 118, '2014-03-15 00:55:22.000000', 'temperatura', 558.0000, 'ºC'),
	(242676, 118, '2014-03-15 00:55:23.000000', 'temperatura', 183.0000, 'ºC'),
	(242677, 118, '2014-03-15 00:55:24.000000', 'temperatura', 441.0000, 'ºC'),
	(242678, 118, '2014-03-15 00:55:25.000000', 'temperatura', 458.0000, 'ºC'),
	(242679, 118, '2014-03-15 00:55:26.000000', 'temperatura', 967.0000, 'ºC'),
	(242680, 118, '2014-03-15 00:55:27.000000', 'temperatura', 1060.0000, 'ºC'),
	(242681, 118, '2014-03-15 00:55:28.000000', 'temperatura', 1.0000, 'ºC'),
	(242682, 118, '2014-03-15 00:55:29.000000', 'temperatura', 426.0000, 'ºC'),
	(242683, 118, '2014-03-15 00:55:30.000000', 'temperatura', 928.0000, 'ºC'),
	(242684, 118, '2014-03-15 00:55:31.000000', 'temperatura', 962.0000, 'ºC'),
	(242685, 118, '2014-03-15 00:55:32.000000', 'temperatura', 827.0000, 'ºC'),
	(242686, 118, '2014-03-15 00:55:33.000000', 'temperatura', 50.0000, 'ºC'),
	(242687, 118, '2014-03-15 00:55:34.000000', 'temperatura', 169.0000, 'ºC'),
	(242688, 118, '2014-03-15 00:55:35.000000', 'temperatura', 696.0000, 'ºC'),
	(242689, 118, '2014-03-15 00:55:36.000000', 'temperatura', 573.0000, 'ºC'),
	(242690, 118, '2014-03-15 00:55:37.000000', 'temperatura', 778.0000, 'ºC'),
	(242691, 118, '2014-03-15 00:55:38.000000', 'temperatura', 973.0000, 'ºC'),
	(242692, 118, '2014-03-15 00:55:39.000000', 'temperatura', 129.0000, 'ºC'),
	(242693, 118, '2014-03-15 00:55:40.000000', 'temperatura', 129.0000, 'ºC'),
	(242694, 118, '2014-03-15 00:55:41.000000', 'temperatura', 258.0000, 'ºC'),
	(242695, 118, '2014-03-15 00:55:42.000000', 'temperatura', 902.0000, 'ºC'),
	(242696, 118, '2014-03-15 00:55:43.000000', 'temperatura', 137.0000, 'ºC'),
	(242697, 118, '2014-03-15 00:55:44.000000', 'temperatura', 378.0000, 'ºC'),
	(242698, 118, '2014-03-15 00:55:45.000000', 'temperatura', 282.0000, 'ºC'),
	(242699, 118, '2014-03-15 00:55:46.000000', 'temperatura', 277.0000, 'ºC'),
	(242700, 118, '2014-03-15 00:55:47.000000', 'temperatura', 540.0000, 'ºC'),
	(242701, 118, '2014-03-15 00:55:48.000000', 'temperatura', 668.0000, 'ºC'),
	(242702, 118, '2014-03-15 00:55:49.000000', 'temperatura', 519.0000, 'ºC'),
	(242703, 118, '2014-03-15 00:55:50.000000', 'temperatura', 593.0000, 'ºC'),
	(242704, 118, '2014-03-15 00:55:51.000000', 'temperatura', 210.0000, 'ºC'),
	(242705, 118, '2014-03-15 00:55:52.000000', 'temperatura', 471.0000, 'ºC'),
	(242706, 118, '2014-03-15 00:55:53.000000', 'temperatura', 525.0000, 'ºC'),
	(242707, 118, '2014-03-15 00:55:54.000000', 'temperatura', 11.0000, 'ºC'),
	(242708, 118, '2014-03-15 00:55:55.000000', 'temperatura', 882.0000, 'ºC'),
	(242709, 118, '2014-03-15 00:55:56.000000', 'temperatura', 776.0000, 'ºC'),
	(242710, 118, '2014-03-15 00:55:57.000000', 'temperatura', 37.0000, 'ºC'),
	(242711, 118, '2014-03-15 00:55:58.000000', 'temperatura', 258.0000, 'ºC'),
	(242712, 118, '2014-03-15 00:55:59.000000', 'temperatura', 1179.0000, 'ºC'),
	(242713, 118, '2014-03-15 00:56:00.000000', 'temperatura', 321.0000, 'ºC'),
	(242714, 118, '2014-03-15 00:56:01.000000', 'temperatura', 466.0000, 'ºC'),
	(242715, 118, '2014-03-15 00:56:02.000000', 'temperatura', 171.0000, 'ºC'),
	(242716, 118, '2014-03-15 00:56:03.000000', 'temperatura', 657.0000, 'ºC'),
	(242717, 118, '2014-03-15 00:56:04.000000', 'temperatura', 370.0000, 'ºC'),
	(242718, 118, '2014-03-15 00:56:05.000000', 'temperatura', 1082.0000, 'ºC'),
	(242719, 118, '2014-03-15 00:56:06.000000', 'temperatura', 701.0000, 'ºC'),
	(242720, 118, '2014-03-15 00:56:07.000000', 'temperatura', 260.0000, 'ºC'),
	(242721, 118, '2014-03-15 00:56:08.000000', 'temperatura', 396.0000, 'ºC'),
	(242722, 118, '2014-03-15 00:56:09.000000', 'temperatura', 1199.0000, 'ºC'),
	(242723, 118, '2014-03-15 00:56:10.000000', 'temperatura', 8.0000, 'ºC'),
	(242724, 118, '2014-03-15 00:56:11.000000', 'temperatura', 46.0000, 'ºC'),
	(242725, 118, '2014-03-15 00:56:12.000000', 'temperatura', 204.0000, 'ºC'),
	(242726, 118, '2014-03-15 00:56:13.000000', 'temperatura', 884.0000, 'ºC'),
	(242727, 118, '2014-03-15 00:56:14.000000', 'temperatura', 210.0000, 'ºC'),
	(242728, 118, '2014-03-15 00:56:15.000000', 'temperatura', 798.0000, 'ºC'),
	(242729, 118, '2014-03-15 00:56:16.000000', 'temperatura', 959.0000, 'ºC'),
	(242730, 118, '2014-03-15 00:56:17.000000', 'temperatura', 1.0000, 'ºC'),
	(242731, 118, '2014-03-15 00:56:18.000000', 'temperatura', 728.0000, 'ºC'),
	(242732, 118, '2014-03-15 00:56:19.000000', 'temperatura', 39.0000, 'ºC'),
	(242733, 118, '2014-03-15 00:56:20.000000', 'temperatura', 411.0000, 'ºC'),
	(242734, 118, '2014-03-15 00:56:21.000000', 'temperatura', 739.0000, 'ºC'),
	(242735, 118, '2014-03-15 00:56:22.000000', 'temperatura', 63.0000, 'ºC'),
	(242736, 118, '2014-03-15 00:56:23.000000', 'temperatura', 496.0000, 'ºC'),
	(242737, 118, '2014-03-15 00:56:24.000000', 'temperatura', 1093.0000, 'ºC'),
	(242738, 118, '2014-03-15 00:56:25.000000', 'temperatura', 377.0000, 'ºC'),
	(242739, 118, '2014-03-15 00:56:26.000000', 'temperatura', 1007.0000, 'ºC'),
	(242740, 118, '2014-03-15 00:56:27.000000', 'temperatura', 303.0000, 'ºC'),
	(242741, 118, '2014-03-15 00:56:28.000000', 'temperatura', 896.0000, 'ºC'),
	(242742, 118, '2014-03-15 00:56:29.000000', 'temperatura', 1169.0000, 'ºC'),
	(242743, 118, '2014-03-15 00:56:30.000000', 'temperatura', 760.0000, 'ºC'),
	(242744, 118, '2014-03-15 00:56:31.000000', 'temperatura', 293.0000, 'ºC'),
	(242745, 118, '2014-03-15 00:56:32.000000', 'temperatura', 384.0000, 'ºC'),
	(242746, 118, '2014-03-15 00:56:33.000000', 'temperatura', 1043.0000, 'ºC'),
	(242747, 118, '2014-03-15 00:56:34.000000', 'temperatura', 462.0000, 'ºC'),
	(242748, 118, '2014-03-15 00:56:35.000000', 'temperatura', 381.0000, 'ºC'),
	(242749, 118, '2014-03-15 00:56:36.000000', 'temperatura', 522.0000, 'ºC'),
	(242750, 118, '2014-03-15 00:56:37.000000', 'temperatura', 267.0000, 'ºC'),
	(242751, 118, '2014-03-15 00:56:38.000000', 'temperatura', 970.0000, 'ºC'),
	(242752, 118, '2014-03-15 00:56:39.000000', 'temperatura', 447.0000, 'ºC'),
	(242753, 118, '2014-03-15 00:56:40.000000', 'temperatura', 529.0000, 'ºC'),
	(242754, 118, '2014-03-15 00:56:41.000000', 'temperatura', 102.0000, 'ºC'),
	(242755, 118, '2014-03-15 00:56:42.000000', 'temperatura', 123.0000, 'ºC'),
	(242756, 118, '2014-03-15 00:56:43.000000', 'temperatura', 311.0000, 'ºC'),
	(242757, 118, '2014-03-15 00:56:44.000000', 'temperatura', 1186.0000, 'ºC'),
	(242758, 118, '2014-03-15 00:56:45.000000', 'temperatura', 197.0000, 'ºC'),
	(242759, 118, '2014-03-15 00:56:46.000000', 'temperatura', 1028.0000, 'ºC'),
	(242760, 118, '2014-03-15 00:56:47.000000', 'temperatura', 950.0000, 'ºC'),
	(242761, 118, '2014-03-15 00:56:48.000000', 'temperatura', 467.0000, 'ºC'),
	(242762, 118, '2014-03-15 00:56:49.000000', 'temperatura', 684.0000, 'ºC'),
	(242763, 118, '2014-03-15 00:56:50.000000', 'temperatura', 819.0000, 'ºC'),
	(242764, 118, '2014-03-15 00:56:51.000000', 'temperatura', 843.0000, 'ºC'),
	(242765, 118, '2014-03-15 00:56:52.000000', 'temperatura', 558.0000, 'ºC'),
	(242766, 118, '2014-03-15 00:56:53.000000', 'temperatura', 264.0000, 'ºC'),
	(242767, 118, '2014-03-15 00:56:54.000000', 'temperatura', 844.0000, 'ºC'),
	(242768, 118, '2014-03-15 00:56:55.000000', 'temperatura', 1031.0000, 'ºC'),
	(242769, 118, '2014-03-15 00:56:56.000000', 'temperatura', 221.0000, 'ºC'),
	(242770, 118, '2014-03-15 00:56:57.000000', 'temperatura', 412.0000, 'ºC'),
	(242771, 118, '2014-03-15 00:56:58.000000', 'temperatura', 198.0000, 'ºC'),
	(242772, 118, '2014-03-15 00:56:59.000000', 'temperatura', 955.0000, 'ºC'),
	(242773, 118, '2014-03-15 00:57:00.000000', 'temperatura', 582.0000, 'ºC'),
	(242774, 118, '2014-03-15 00:57:01.000000', 'temperatura', 44.0000, 'ºC'),
	(242775, 118, '2014-03-15 00:57:02.000000', 'temperatura', 877.0000, 'ºC'),
	(242776, 118, '2014-03-15 00:57:03.000000', 'temperatura', 653.0000, 'ºC'),
	(242777, 118, '2014-03-15 00:57:04.000000', 'temperatura', 636.0000, 'ºC'),
	(242778, 118, '2014-03-15 00:57:05.000000', 'temperatura', 19.0000, 'ºC'),
	(242779, 118, '2014-03-15 00:57:06.000000', 'temperatura', 588.0000, 'ºC'),
	(242780, 118, '2014-03-15 00:57:07.000000', 'temperatura', 485.0000, 'ºC'),
	(242781, 118, '2014-03-15 00:57:08.000000', 'temperatura', 659.0000, 'ºC'),
	(242782, 118, '2014-03-15 00:57:09.000000', 'temperatura', 640.0000, 'ºC'),
	(242783, 118, '2014-03-15 00:57:10.000000', 'temperatura', 23.0000, 'ºC'),
	(242784, 118, '2014-03-15 00:57:11.000000', 'temperatura', 597.0000, 'ºC'),
	(242785, 118, '2014-03-15 00:57:12.000000', 'temperatura', 517.0000, 'ºC'),
	(242786, 118, '2014-03-15 00:57:13.000000', 'temperatura', 794.0000, 'ºC'),
	(242787, 118, '2014-03-15 00:57:14.000000', 'temperatura', 20.0000, 'ºC'),
	(242788, 118, '2014-03-15 00:57:15.000000', 'temperatura', 120.0000, 'ºC'),
	(242789, 118, '2014-03-15 00:57:16.000000', 'temperatura', 538.0000, 'ºC'),
	(242790, 118, '2014-03-15 00:57:17.000000', 'temperatura', 1130.0000, 'ºC'),
	(242791, 118, '2014-03-15 00:57:18.000000', 'temperatura', 438.0000, 'ºC'),
	(242792, 118, '2014-03-15 00:57:19.000000', 'temperatura', 0.0000, 'ºC'),
	(242793, 118, '2014-03-15 00:57:20.000000', 'temperatura', 1087.0000, 'ºC'),
	(242794, 118, '2014-03-15 00:57:21.000000', 'temperatura', 635.0000, 'ºC'),
	(242795, 118, '2014-03-15 00:57:22.000000', 'temperatura', 1116.0000, 'ºC'),
	(242796, 118, '2014-03-15 00:57:23.000000', 'temperatura', 74.0000, 'ºC'),
	(242797, 118, '2014-03-15 00:57:24.000000', 'temperatura', 623.0000, 'ºC'),
	(242798, 118, '2014-03-15 00:57:25.000000', 'temperatura', 495.0000, 'ºC'),
	(242799, 118, '2014-03-15 00:57:26.000000', 'temperatura', 604.0000, 'ºC'),
	(242800, 118, '2014-03-15 00:57:27.000000', 'temperatura', 338.0000, 'ºC'),
	(242801, 118, '2014-03-15 00:57:28.000000', 'temperatura', 1079.0000, 'ºC'),
	(242802, 118, '2014-03-15 00:57:29.000000', 'temperatura', 782.0000, 'ºC'),
	(242803, 118, '2014-03-15 00:57:30.000000', 'temperatura', 671.0000, 'ºC'),
	(242804, 118, '2014-03-15 00:57:31.000000', 'temperatura', 1010.0000, 'ºC'),
	(242805, 118, '2014-03-15 00:57:32.000000', 'temperatura', 639.0000, 'ºC'),
	(242806, 118, '2014-03-15 00:57:33.000000', 'temperatura', 163.0000, 'ºC'),
	(242807, 118, '2014-03-15 00:57:34.000000', 'temperatura', 101.0000, 'ºC'),
	(242808, 118, '2014-03-15 00:57:35.000000', 'temperatura', 16.0000, 'ºC'),
	(242809, 118, '2014-03-15 00:57:36.000000', 'temperatura', 979.0000, 'ºC'),
	(242810, 118, '2014-03-15 00:57:37.000000', 'temperatura', 45.0000, 'ºC'),
	(242811, 118, '2014-03-15 00:57:38.000000', 'temperatura', 888.0000, 'ºC'),
	(242812, 118, '2014-03-15 00:57:39.000000', 'temperatura', 706.0000, 'ºC'),
	(242813, 118, '2014-03-15 00:57:40.000000', 'temperatura', 865.0000, 'ºC'),
	(242814, 118, '2014-03-15 00:57:41.000000', 'temperatura', 1008.0000, 'ºC'),
	(242815, 118, '2014-03-15 00:57:42.000000', 'temperatura', 46.0000, 'ºC'),
	(242816, 118, '2014-03-15 00:57:43.000000', 'temperatura', 806.0000, 'ºC'),
	(242817, 118, '2014-03-15 00:57:44.000000', 'temperatura', 292.0000, 'ºC'),
	(242818, 118, '2014-03-15 00:57:45.000000', 'temperatura', 242.0000, 'ºC'),
	(242819, 118, '2014-03-15 00:57:46.000000', 'temperatura', 336.0000, 'ºC'),
	(242820, 118, '2014-03-15 00:57:47.000000', 'temperatura', 952.0000, 'ºC'),
	(242821, 118, '2014-03-15 00:57:48.000000', 'temperatura', 156.0000, 'ºC'),
	(242822, 118, '2014-03-15 00:57:49.000000', 'temperatura', 323.0000, 'ºC'),
	(242823, 118, '2014-03-15 00:57:50.000000', 'temperatura', 1148.0000, 'ºC'),
	(242824, 118, '2014-03-15 00:57:51.000000', 'temperatura', 1172.0000, 'ºC'),
	(242825, 118, '2014-03-15 00:57:52.000000', 'temperatura', 15.0000, 'ºC'),
	(242826, 118, '2014-03-15 00:57:53.000000', 'temperatura', 159.0000, 'ºC'),
	(242827, 118, '2014-03-15 00:57:54.000000', 'temperatura', 752.0000, 'ºC'),
	(242828, 118, '2014-03-15 00:57:55.000000', 'temperatura', 882.0000, 'ºC'),
	(242829, 118, '2014-03-15 00:57:56.000000', 'temperatura', 954.0000, 'ºC'),
	(242830, 118, '2014-03-15 00:57:57.000000', 'temperatura', 927.0000, 'ºC'),
	(242831, 118, '2014-03-15 00:57:58.000000', 'temperatura', 571.0000, 'ºC'),
	(242832, 118, '2014-03-15 00:57:59.000000', 'temperatura', 75.0000, 'ºC'),
	(242833, 118, '2014-03-15 00:58:00.000000', 'temperatura', 1063.0000, 'ºC'),
	(242834, 118, '2014-03-15 00:58:01.000000', 'temperatura', 290.0000, 'ºC'),
	(242835, 118, '2014-03-15 00:58:02.000000', 'temperatura', 662.0000, 'ºC'),
	(242836, 118, '2014-03-15 00:58:03.000000', 'temperatura', 42.0000, 'ºC'),
	(242837, 118, '2014-03-15 00:58:04.000000', 'temperatura', 622.0000, 'ºC'),
	(242838, 118, '2014-03-15 00:58:05.000000', 'temperatura', 584.0000, 'ºC'),
	(242839, 118, '2014-03-15 00:58:06.000000', 'temperatura', 1054.0000, 'ºC'),
	(242840, 118, '2014-03-15 00:58:07.000000', 'temperatura', 1121.0000, 'ºC'),
	(242841, 118, '2014-03-15 00:58:08.000000', 'temperatura', 42.0000, 'ºC'),
	(242842, 118, '2014-03-15 00:58:09.000000', 'temperatura', 448.0000, 'ºC'),
	(242843, 118, '2014-03-15 00:58:10.000000', 'temperatura', 913.0000, 'ºC'),
	(242844, 118, '2014-03-15 00:58:11.000000', 'temperatura', 822.0000, 'ºC'),
	(242845, 118, '2014-03-15 00:58:12.000000', 'temperatura', 173.0000, 'ºC'),
	(242846, 118, '2014-03-15 00:58:13.000000', 'temperatura', 799.0000, 'ºC'),
	(242847, 118, '2014-03-15 00:58:14.000000', 'temperatura', 1078.0000, 'ºC'),
	(242848, 118, '2014-03-15 00:58:15.000000', 'temperatura', 592.0000, 'ºC'),
	(242849, 118, '2014-03-15 00:58:16.000000', 'temperatura', 927.0000, 'ºC'),
	(242850, 118, '2014-03-15 00:58:17.000000', 'temperatura', 459.0000, 'ºC'),
	(242851, 118, '2014-03-15 00:58:18.000000', 'temperatura', 714.0000, 'ºC'),
	(242852, 118, '2014-03-15 00:58:19.000000', 'temperatura', 992.0000, 'ºC'),
	(242853, 118, '2014-03-15 00:58:20.000000', 'temperatura', 422.0000, 'ºC'),
	(242854, 118, '2014-03-15 00:58:21.000000', 'temperatura', 332.0000, 'ºC'),
	(242855, 118, '2014-03-15 00:58:22.000000', 'temperatura', 395.0000, 'ºC'),
	(242856, 118, '2014-03-15 00:58:23.000000', 'temperatura', 980.0000, 'ºC'),
	(242857, 118, '2014-03-15 00:58:24.000000', 'temperatura', 115.0000, 'ºC'),
	(242858, 118, '2014-03-15 00:58:25.000000', 'temperatura', 36.0000, 'ºC'),
	(242859, 118, '2014-03-15 00:58:26.000000', 'temperatura', 1036.0000, 'ºC'),
	(242860, 118, '2014-03-15 00:58:27.000000', 'temperatura', 274.0000, 'ºC'),
	(242861, 118, '2014-03-15 00:58:28.000000', 'temperatura', 662.0000, 'ºC'),
	(242862, 118, '2014-03-15 00:58:29.000000', 'temperatura', 86.0000, 'ºC'),
	(242863, 118, '2014-03-15 00:58:30.000000', 'temperatura', 848.0000, 'ºC'),
	(242864, 118, '2014-03-15 00:58:31.000000', 'temperatura', 379.0000, 'ºC'),
	(242865, 118, '2014-03-15 00:58:32.000000', 'temperatura', 555.0000, 'ºC'),
	(242866, 118, '2014-03-15 00:58:33.000000', 'temperatura', 436.0000, 'ºC'),
	(242867, 118, '2014-03-15 00:58:34.000000', 'temperatura', 518.0000, 'ºC'),
	(242868, 118, '2014-03-15 00:58:35.000000', 'temperatura', 83.0000, 'ºC'),
	(242869, 118, '2014-03-15 00:58:36.000000', 'temperatura', 58.0000, 'ºC'),
	(242870, 118, '2014-03-15 00:58:37.000000', 'temperatura', 44.0000, 'ºC'),
	(242871, 118, '2014-03-15 00:58:38.000000', 'temperatura', 45.0000, 'ºC'),
	(242872, 118, '2014-03-15 00:58:39.000000', 'temperatura', 92.0000, 'ºC'),
	(242873, 118, '2014-03-15 00:58:40.000000', 'temperatura', 328.0000, 'ºC'),
	(242874, 118, '2014-03-15 00:58:41.000000', 'temperatura', 165.0000, 'ºC'),
	(242875, 118, '2014-03-15 00:58:42.000000', 'temperatura', 1041.0000, 'ºC'),
	(242876, 118, '2014-03-15 00:58:43.000000', 'temperatura', 1111.0000, 'ºC'),
	(242877, 118, '2014-03-15 00:58:44.000000', 'temperatura', 32.0000, 'ºC'),
	(242878, 118, '2014-03-15 00:58:45.000000', 'temperatura', 427.0000, 'ºC'),
	(242879, 118, '2014-03-15 00:58:46.000000', 'temperatura', 841.0000, 'ºC'),
	(242880, 118, '2014-03-15 00:58:47.000000', 'temperatura', 523.0000, 'ºC'),
	(242881, 118, '2014-03-15 00:58:48.000000', 'temperatura', 91.0000, 'ºC'),
	(242882, 118, '2014-03-15 00:58:49.000000', 'temperatura', 89.0000, 'ºC'),
	(242883, 118, '2014-03-15 00:58:50.000000', 'temperatura', 174.0000, 'ºC'),
	(242884, 118, '2014-03-15 00:58:51.000000', 'temperatura', 600.0000, 'ºC'),
	(242885, 118, '2014-03-15 00:58:52.000000', 'temperatura', 80.0000, 'ºC'),
	(242886, 118, '2014-03-15 00:58:53.000000', 'temperatura', 1000.0000, 'ºC'),
	(242887, 118, '2014-03-15 00:58:54.000000', 'temperatura', 1162.0000, 'ºC'),
	(242888, 118, '2014-03-15 00:58:55.000000', 'temperatura', 410.0000, 'ºC'),
	(242889, 118, '2014-03-15 00:58:56.000000', 'temperatura', 965.0000, 'ºC'),
	(242890, 118, '2014-03-15 00:58:57.000000', 'temperatura', 1195.0000, 'ºC'),
	(242891, 118, '2014-03-15 00:58:58.000000', 'temperatura', 681.0000, 'ºC'),
	(242892, 118, '2014-03-15 00:58:59.000000', 'temperatura', 1020.0000, 'ºC'),
	(242893, 118, '2014-03-15 00:59:00.000000', 'temperatura', 659.0000, 'ºC'),
	(242894, 118, '2014-03-15 00:59:01.000000', 'temperatura', 233.0000, 'ºC'),
	(242895, 118, '2014-03-15 00:59:02.000000', 'temperatura', 388.0000, 'ºC'),
	(242896, 118, '2014-03-15 00:59:03.000000', 'temperatura', 41.0000, 'ºC'),
	(242897, 118, '2014-03-15 00:59:04.000000', 'temperatura', 242.0000, 'ºC'),
	(242898, 118, '2014-03-15 00:59:05.000000', 'temperatura', 1087.0000, 'ºC'),
	(242899, 118, '2014-03-15 00:59:06.000000', 'temperatura', 1110.0000, 'ºC'),
	(242900, 118, '2014-03-15 00:59:07.000000', 'temperatura', 1090.0000, 'ºC'),
	(242901, 118, '2014-03-15 00:59:08.000000', 'temperatura', 918.0000, 'ºC'),
	(242902, 118, '2014-03-15 00:59:09.000000', 'temperatura', 124.0000, 'ºC'),
	(242903, 118, '2014-03-15 00:59:10.000000', 'temperatura', 264.0000, 'ºC'),
	(242904, 118, '2014-03-15 00:59:11.000000', 'temperatura', 950.0000, 'ºC'),
	(242905, 118, '2014-03-15 00:59:12.000000', 'temperatura', 359.0000, 'ºC'),
	(242906, 118, '2014-03-15 00:59:13.000000', 'temperatura', 145.0000, 'ºC'),
	(242907, 118, '2014-03-15 00:59:14.000000', 'temperatura', 847.0000, 'ºC'),
	(242908, 118, '2014-03-15 00:59:15.000000', 'temperatura', 200.0000, 'ºC'),
	(242909, 118, '2014-03-15 00:59:16.000000', 'temperatura', 861.0000, 'ºC'),
	(242910, 118, '2014-03-15 00:59:17.000000', 'temperatura', 106.0000, 'ºC'),
	(242911, 118, '2014-03-15 00:59:18.000000', 'temperatura', 349.0000, 'ºC'),
	(242912, 118, '2014-03-15 00:59:19.000000', 'temperatura', 224.0000, 'ºC'),
	(242913, 118, '2014-03-15 00:59:20.000000', 'temperatura', 76.0000, 'ºC'),
	(242914, 118, '2014-03-15 00:59:21.000000', 'temperatura', 910.0000, 'ºC'),
	(242915, 118, '2014-03-15 00:59:22.000000', 'temperatura', 720.0000, 'ºC'),
	(242916, 118, '2014-03-15 00:59:23.000000', 'temperatura', 872.0000, 'ºC'),
	(242917, 118, '2014-03-15 00:59:24.000000', 'temperatura', 999.0000, 'ºC'),
	(242918, 118, '2014-03-15 00:59:25.000000', 'temperatura', 1181.0000, 'ºC'),
	(242919, 118, '2014-03-15 00:59:26.000000', 'temperatura', 506.0000, 'ºC'),
	(242920, 118, '2014-03-15 00:59:27.000000', 'temperatura', 189.0000, 'ºC'),
	(242921, 118, '2014-03-15 00:59:28.000000', 'temperatura', 626.0000, 'ºC'),
	(242922, 118, '2014-03-15 00:59:29.000000', 'temperatura', 163.0000, 'ºC'),
	(242923, 118, '2014-03-15 00:59:30.000000', 'temperatura', 138.0000, 'ºC'),
	(242924, 118, '2014-03-15 00:59:31.000000', 'temperatura', 200.0000, 'ºC'),
	(242925, 118, '2014-03-15 00:59:32.000000', 'temperatura', 589.0000, 'ºC'),
	(242926, 118, '2014-03-15 00:59:33.000000', 'temperatura', 1146.0000, 'ºC'),
	(242927, 118, '2014-03-15 00:59:34.000000', 'temperatura', 364.0000, 'ºC'),
	(242928, 118, '2014-03-15 00:59:35.000000', 'temperatura', 781.0000, 'ºC'),
	(242929, 118, '2014-03-15 00:59:36.000000', 'temperatura', 415.0000, 'ºC'),
	(242930, 118, '2014-03-15 00:59:37.000000', 'temperatura', 933.0000, 'ºC'),
	(242931, 118, '2014-03-15 00:59:38.000000', 'temperatura', 1020.0000, 'ºC'),
	(242932, 118, '2014-03-15 00:59:39.000000', 'temperatura', 1101.0000, 'ºC'),
	(242933, 118, '2014-03-15 00:59:40.000000', 'temperatura', 44.0000, 'ºC'),
	(242934, 118, '2014-03-15 00:59:41.000000', 'temperatura', 518.0000, 'ºC'),
	(242935, 118, '2014-03-15 00:59:42.000000', 'temperatura', 59.0000, 'ºC'),
	(242936, 118, '2014-03-15 00:59:43.000000', 'temperatura', 1142.0000, 'ºC'),
	(242937, 118, '2014-03-15 00:59:44.000000', 'temperatura', 733.0000, 'ºC'),
	(242938, 118, '2014-03-15 00:59:45.000000', 'temperatura', 241.0000, 'ºC'),
	(242939, 118, '2014-03-15 00:59:46.000000', 'temperatura', 206.0000, 'ºC'),
	(242940, 118, '2014-03-15 00:59:47.000000', 'temperatura', 305.0000, 'ºC'),
	(242941, 118, '2014-03-15 00:59:48.000000', 'temperatura', 910.0000, 'ºC'),
	(242942, 118, '2014-03-15 00:59:49.000000', 'temperatura', 34.0000, 'ºC'),
	(242943, 118, '2014-03-15 00:59:50.000000', 'temperatura', 1043.0000, 'ºC'),
	(242944, 118, '2014-03-15 00:59:51.000000', 'temperatura', 312.0000, 'ºC'),
	(242945, 118, '2014-03-15 00:59:52.000000', 'temperatura', 832.0000, 'ºC'),
	(242946, 118, '2014-03-15 00:59:53.000000', 'temperatura', 822.0000, 'ºC'),
	(242947, 118, '2014-03-15 00:59:54.000000', 'temperatura', 417.0000, 'ºC'),
	(242948, 118, '2014-03-15 00:59:55.000000', 'temperatura', 819.0000, 'ºC'),
	(242949, 118, '2014-03-15 00:59:56.000000', 'temperatura', 446.0000, 'ºC'),
	(242950, 118, '2014-03-15 00:59:57.000000', 'temperatura', 974.0000, 'ºC'),
	(242951, 118, '2014-03-15 00:59:58.000000', 'temperatura', 1133.0000, 'ºC'),
	(242952, 118, '2014-03-15 00:59:59.000000', 'temperatura', 343.0000, 'ºC'),
	(242953, 118, '2014-03-15 01:00:00.000000', 'temperatura', 717.0000, 'ºC'),
	(242954, 118, '2014-03-15 01:00:01.000000', 'temperatura', 156.0000, 'ºC'),
	(242955, 118, '2014-03-15 01:00:02.000000', 'temperatura', 1029.0000, 'ºC'),
	(242956, 118, '2014-03-15 01:00:03.000000', 'temperatura', 1078.0000, 'ºC'),
	(242957, 118, '2014-03-15 01:00:04.000000', 'temperatura', 1103.0000, 'ºC'),
	(242958, 118, '2014-03-15 01:00:05.000000', 'temperatura', 1081.0000, 'ºC'),
	(242959, 118, '2014-03-15 01:00:06.000000', 'temperatura', 895.0000, 'ºC'),
	(242960, 118, '2014-03-15 01:00:07.000000', 'temperatura', 35.0000, 'ºC'),
	(242961, 118, '2014-03-15 01:00:08.000000', 'temperatura', 1090.0000, 'ºC'),
	(242962, 118, '2014-03-15 01:00:09.000000', 'temperatura', 547.0000, 'ºC'),
	(242963, 118, '2014-03-15 01:00:10.000000', 'temperatura', 663.0000, 'ºC'),
	(242964, 118, '2014-03-15 01:00:11.000000', 'temperatura', 475.0000, 'ºC'),
	(242965, 118, '2014-03-15 01:00:12.000000', 'temperatura', 387.0000, 'ºC'),
	(242966, 118, '2014-03-15 01:00:13.000000', 'temperatura', 512.0000, 'ºC'),
	(242967, 118, '2014-03-15 01:00:14.000000', 'temperatura', 197.0000, 'ºC'),
	(242968, 118, '2014-03-15 01:00:15.000000', 'temperatura', 651.0000, 'ºC'),
	(242969, 118, '2014-03-15 01:00:16.000000', 'temperatura', 263.0000, 'ºC'),
	(242970, 118, '2014-03-15 01:00:17.000000', 'temperatura', 564.0000, 'ºC'),
	(242971, 118, '2014-03-15 01:00:18.000000', 'temperatura', 832.0000, 'ºC'),
	(242972, 118, '2014-03-15 01:00:19.000000', 'temperatura', 70.0000, 'ºC'),
	(242973, 118, '2014-03-15 01:00:20.000000', 'temperatura', 252.0000, 'ºC'),
	(242974, 118, '2014-03-15 01:00:21.000000', 'temperatura', 1049.0000, 'ºC'),
	(242975, 118, '2014-03-15 01:00:22.000000', 'temperatura', 892.0000, 'ºC'),
	(242976, 118, '2014-03-15 01:00:23.000000', 'temperatura', 112.0000, 'ºC'),
	(242977, 118, '2014-03-15 01:00:24.000000', 'temperatura', 286.0000, 'ºC'),
	(242978, 118, '2014-03-15 01:00:25.000000', 'temperatura', 1093.0000, 'ºC'),
	(242979, 118, '2014-03-15 01:00:26.000000', 'temperatura', 1006.0000, 'ºC'),
	(242980, 118, '2014-03-15 01:00:27.000000', 'temperatura', 555.0000, 'ºC'),
	(242981, 118, '2014-03-15 01:00:28.000000', 'temperatura', 955.0000, 'ºC'),
	(242982, 118, '2014-03-15 01:00:29.000000', 'temperatura', 710.0000, 'ºC'),
	(242983, 118, '2014-03-15 01:00:30.000000', 'temperatura', 686.0000, 'ºC'),
	(242984, 118, '2014-03-15 01:00:31.000000', 'temperatura', 101.0000, 'ºC'),
	(242985, 118, '2014-03-15 01:00:32.000000', 'temperatura', 848.0000, 'ºC'),
	(242986, 118, '2014-03-15 01:00:33.000000', 'temperatura', 338.0000, 'ºC'),
	(242987, 118, '2014-03-15 01:00:34.000000', 'temperatura', 346.0000, 'ºC'),
	(242988, 118, '2014-03-15 01:00:35.000000', 'temperatura', 715.0000, 'ºC'),
	(242989, 118, '2014-03-15 01:00:36.000000', 'temperatura', 138.0000, 'ºC'),
	(242990, 118, '2014-03-15 01:00:37.000000', 'temperatura', 948.0000, 'ºC'),
	(242991, 118, '2014-03-15 01:00:38.000000', 'temperatura', 724.0000, 'ºC'),
	(242992, 118, '2014-03-15 01:00:39.000000', 'temperatura', 776.0000, 'ºC'),
	(242993, 118, '2014-03-15 01:00:40.000000', 'temperatura', 508.0000, 'ºC'),
	(242994, 118, '2014-03-15 01:00:41.000000', 'temperatura', 212.0000, 'ºC'),
	(242995, 118, '2014-03-15 01:00:42.000000', 'temperatura', 735.0000, 'ºC'),
	(242996, 118, '2014-03-15 01:00:43.000000', 'temperatura', 643.0000, 'ºC'),
	(242997, 118, '2014-03-15 01:00:44.000000', 'temperatura', 1011.0000, 'ºC'),
	(242998, 118, '2014-03-15 01:00:45.000000', 'temperatura', 725.0000, 'ºC'),
	(242999, 118, '2014-03-15 01:00:46.000000', 'temperatura', 592.0000, 'ºC'),
	(243000, 118, '2014-03-15 01:00:47.000000', 'temperatura', 786.0000, 'ºC'),
	(243001, 118, '2014-03-15 01:00:48.000000', 'temperatura', 953.0000, 'ºC'),
	(243002, 118, '2014-03-15 01:00:49.000000', 'temperatura', 8.0000, 'ºC'),
	(243003, 118, '2014-03-15 01:00:50.000000', 'temperatura', 781.0000, 'ºC'),
	(243004, 118, '2014-03-15 01:00:51.000000', 'temperatura', 280.0000, 'ºC'),
	(243005, 118, '2014-03-15 01:00:52.000000', 'temperatura', 261.0000, 'ºC'),
	(243006, 118, '2014-03-15 01:00:53.000000', 'temperatura', 465.0000, 'ºC'),
	(243007, 118, '2014-03-15 01:00:54.000000', 'temperatura', 340.0000, 'ºC'),
	(243008, 118, '2014-03-15 01:00:55.000000', 'temperatura', 306.0000, 'ºC'),
	(243009, 118, '2014-03-15 01:00:56.000000', 'temperatura', 510.0000, 'ºC'),
	(243010, 118, '2014-03-15 01:00:57.000000', 'temperatura', 433.0000, 'ºC'),
	(243011, 118, '2014-03-15 01:00:58.000000', 'temperatura', 634.0000, 'ºC'),
	(243012, 118, '2014-03-15 01:00:59.000000', 'temperatura', 673.0000, 'ºC'),
	(243013, 118, '2014-03-15 01:01:00.000000', 'temperatura', 265.0000, 'ºC'),
	(243014, 118, '2014-03-15 01:01:01.000000', 'temperatura', 506.0000, 'ºC'),
	(243015, 118, '2014-03-15 01:01:02.000000', 'temperatura', 534.0000, 'ºC'),
	(243016, 118, '2014-03-15 01:01:03.000000', 'temperatura', 1153.0000, 'ºC'),
	(243017, 118, '2014-03-15 01:01:04.000000', 'temperatura', 564.0000, 'ºC'),
	(243018, 118, '2014-03-15 01:01:05.000000', 'temperatura', 563.0000, 'ºC'),
	(243019, 118, '2014-03-15 01:01:06.000000', 'temperatura', 1123.0000, 'ºC'),
	(243020, 118, '2014-03-15 01:01:07.000000', 'temperatura', 324.0000, 'ºC'),
	(243021, 118, '2014-03-15 01:01:08.000000', 'temperatura', 653.0000, 'ºC'),
	(243022, 118, '2014-03-15 01:01:09.000000', 'temperatura', 1092.0000, 'ºC'),
	(243023, 118, '2014-03-15 01:01:10.000000', 'temperatura', 1102.0000, 'ºC'),
	(243024, 118, '2014-03-15 01:01:11.000000', 'temperatura', 1033.0000, 'ºC'),
	(243025, 118, '2014-03-15 01:01:12.000000', 'temperatura', 661.0000, 'ºC'),
	(243026, 118, '2014-03-15 01:01:13.000000', 'temperatura', 205.0000, 'ºC'),
	(243027, 118, '2014-03-15 01:01:14.000000', 'temperatura', 245.0000, 'ºC'),
	(243028, 118, '2014-03-15 01:01:15.000000', 'temperatura', 611.0000, 'ºC'),
	(243029, 118, '2014-03-15 01:01:16.000000', 'temperatura', 1120.0000, 'ºC'),
	(243030, 118, '2014-03-15 01:01:17.000000', 'temperatura', 168.0000, 'ºC'),
	(243031, 118, '2014-03-15 01:01:18.000000', 'temperatura', 1080.0000, 'ºC'),
	(243032, 118, '2014-03-15 01:01:19.000000', 'temperatura', 95.0000, 'ºC'),
	(243033, 118, '2014-03-15 01:01:20.000000', 'temperatura', 839.0000, 'ºC'),
	(243034, 118, '2014-03-15 01:01:21.000000', 'temperatura', 307.0000, 'ºC'),
	(243035, 118, '2014-03-15 01:01:22.000000', 'temperatura', 218.0000, 'ºC'),
	(243036, 118, '2014-03-15 01:01:23.000000', 'temperatura', 172.0000, 'ºC'),
	(243037, 118, '2014-03-15 01:01:24.000000', 'temperatura', 204.0000, 'ºC'),
	(243038, 118, '2014-03-15 01:01:25.000000', 'temperatura', 506.0000, 'ºC'),
	(243039, 118, '2014-03-15 01:01:26.000000', 'temperatura', 716.0000, 'ºC'),
	(243040, 118, '2014-03-15 01:01:27.000000', 'temperatura', 866.0000, 'ºC'),
	(243041, 118, '2014-03-15 01:01:28.000000', 'temperatura', 980.0000, 'ºC'),
	(243042, 118, '2014-03-15 01:01:29.000000', 'temperatura', 1102.0000, 'ºC'),
	(243043, 118, '2014-03-15 01:01:30.000000', 'temperatura', 170.0000, 'ºC'),
	(243044, 118, '2014-03-15 01:01:31.000000', 'temperatura', 1145.0000, 'ºC'),
	(243045, 118, '2014-03-15 01:01:32.000000', 'temperatura', 417.0000, 'ºC'),
	(243046, 118, '2014-03-15 01:01:33.000000', 'temperatura', 1051.0000, 'ºC'),
	(243047, 118, '2014-03-15 01:01:34.000000', 'temperatura', 405.0000, 'ºC'),
	(243048, 118, '2014-03-15 01:01:35.000000', 'temperatura', 71.0000, 'ºC'),
	(243049, 118, '2014-03-15 01:01:36.000000', 'temperatura', 343.0000, 'ºC'),
	(243050, 118, '2014-03-15 01:01:37.000000', 'temperatura', 299.0000, 'ºC'),
	(243051, 118, '2014-03-15 01:01:38.000000', 'temperatura', 469.0000, 'ºC'),
	(243052, 118, '2014-03-15 01:01:39.000000', 'temperatura', 246.0000, 'ºC'),
	(243053, 118, '2014-03-15 01:01:40.000000', 'temperatura', 1023.0000, 'ºC'),
	(243054, 118, '2014-03-15 01:01:41.000000', 'temperatura', 778.0000, 'ºC'),
	(243055, 118, '2014-03-15 01:01:42.000000', 'temperatura', 824.0000, 'ºC'),
	(243056, 118, '2014-03-15 01:01:43.000000', 'temperatura', 585.0000, 'ºC'),
	(243057, 118, '2014-03-15 01:01:44.000000', 'temperatura', 452.0000, 'ºC'),
	(243058, 118, '2014-03-15 01:01:45.000000', 'temperatura', 508.0000, 'ºC'),
	(243059, 118, '2014-03-15 01:01:46.000000', 'temperatura', 1182.0000, 'ºC'),
	(243060, 118, '2014-03-15 01:01:47.000000', 'temperatura', 786.0000, 'ºC'),
	(243061, 118, '2014-03-15 01:01:48.000000', 'temperatura', 387.0000, 'ºC'),
	(243062, 118, '2014-03-15 01:01:49.000000', 'temperatura', 776.0000, 'ºC'),
	(243063, 118, '2014-03-15 01:01:50.000000', 'temperatura', 319.0000, 'ºC'),
	(243064, 118, '2014-03-15 01:01:51.000000', 'temperatura', 469.0000, 'ºC'),
	(243065, 118, '2014-03-15 01:01:52.000000', 'temperatura', 187.0000, 'ºC'),
	(243066, 118, '2014-03-15 01:01:53.000000', 'temperatura', 729.0000, 'ºC'),
	(243067, 118, '2014-03-15 01:01:54.000000', 'temperatura', 684.0000, 'ºC'),
	(243068, 118, '2014-03-15 01:01:55.000000', 'temperatura', 34.0000, 'ºC'),
	(243069, 118, '2014-03-15 01:01:56.000000', 'temperatura', 517.0000, 'ºC'),
	(243070, 118, '2014-03-15 01:01:57.000000', 'temperatura', 84.0000, 'ºC'),
	(243071, 118, '2014-03-15 01:01:58.000000', 'temperatura', 69.0000, 'ºC'),
	(243072, 118, '2014-03-15 01:01:59.000000', 'temperatura', 95.0000, 'ºC'),
	(243073, 118, '2014-03-15 01:02:00.000000', 'temperatura', 266.0000, 'ºC'),
	(243074, 118, '2014-03-15 01:02:01.000000', 'temperatura', 1046.0000, 'ºC'),
	(243075, 118, '2014-03-15 01:02:02.000000', 'temperatura', 831.0000, 'ºC'),
	(243076, 118, '2014-03-15 01:02:03.000000', 'temperatura', 1021.0000, 'ºC'),
	(243077, 118, '2014-03-15 01:02:04.000000', 'temperatura', 209.0000, 'ºC'),
	(243078, 118, '2014-03-15 01:02:05.000000', 'temperatura', 384.0000, 'ºC'),
	(243079, 118, '2014-03-15 01:02:06.000000', 'temperatura', 94.0000, 'ºC'),
	(243080, 118, '2014-03-15 01:02:07.000000', 'temperatura', 519.0000, 'ºC'),
	(243081, 118, '2014-03-15 01:02:08.000000', 'temperatura', 1111.0000, 'ºC'),
	(243082, 118, '2014-03-15 01:02:09.000000', 'temperatura', 399.0000, 'ºC'),
	(243083, 118, '2014-03-15 01:02:10.000000', 'temperatura', 1064.0000, 'ºC'),
	(243084, 118, '2014-03-15 01:02:11.000000', 'temperatura', 524.0000, 'ºC'),
	(243085, 118, '2014-03-15 01:02:12.000000', 'temperatura', 626.0000, 'ºC'),
	(243086, 118, '2014-03-15 01:02:13.000000', 'temperatura', 358.0000, 'ºC'),
	(243087, 118, '2014-03-15 01:02:14.000000', 'temperatura', 1116.0000, 'ºC'),
	(243088, 118, '2014-03-15 01:02:15.000000', 'temperatura', 903.0000, 'ºC'),
	(243089, 118, '2014-03-15 01:02:16.000000', 'temperatura', 1171.0000, 'ºC'),
	(243090, 118, '2014-03-15 01:02:17.000000', 'temperatura', 743.0000, 'ºC'),
	(243091, 118, '2014-03-15 01:02:18.000000', 'temperatura', 204.0000, 'ºC'),
	(243092, 118, '2014-03-15 01:02:19.000000', 'temperatura', 1192.0000, 'ºC'),
	(243093, 118, '2014-03-15 01:02:20.000000', 'temperatura', 548.0000, 'ºC'),
	(243094, 118, '2014-03-15 01:02:21.000000', 'temperatura', 364.0000, 'ºC'),
	(243095, 118, '2014-03-15 01:02:22.000000', 'temperatura', 177.0000, 'ºC'),
	(243096, 118, '2014-03-15 01:02:23.000000', 'temperatura', 995.0000, 'ºC'),
	(243097, 118, '2014-03-15 01:02:24.000000', 'temperatura', 845.0000, 'ºC'),
	(243098, 118, '2014-03-15 01:02:25.000000', 'temperatura', 37.0000, 'ºC'),
	(243099, 118, '2014-03-15 01:02:26.000000', 'temperatura', 54.0000, 'ºC'),
	(243100, 118, '2014-03-15 01:02:27.000000', 'temperatura', 159.0000, 'ºC'),
	(243101, 118, '2014-03-15 01:02:28.000000', 'temperatura', 632.0000, 'ºC'),
	(243102, 118, '2014-03-15 01:02:29.000000', 'temperatura', 286.0000, 'ºC'),
	(243103, 118, '2014-03-15 01:02:30.000000', 'temperatura', 734.0000, 'ºC'),
	(243104, 118, '2014-03-15 01:02:31.000000', 'temperatura', 413.0000, 'ºC'),
	(243105, 118, '2014-03-15 01:02:32.000000', 'temperatura', 1064.0000, 'ºC'),
	(243106, 118, '2014-03-15 01:02:33.000000', 'temperatura', 481.0000, 'ºC'),
	(243107, 118, '2014-03-15 01:02:34.000000', 'temperatura', 414.0000, 'ºC'),
	(243108, 118, '2014-03-15 01:02:35.000000', 'temperatura', 626.0000, 'ºC'),
	(243109, 118, '2014-03-15 01:02:36.000000', 'temperatura', 690.0000, 'ºC'),
	(243110, 118, '2014-03-15 01:02:37.000000', 'temperatura', 370.0000, 'ºC'),
	(243111, 118, '2014-03-15 01:02:38.000000', 'temperatura', 981.0000, 'ºC'),
	(243112, 118, '2014-03-15 01:02:39.000000', 'temperatura', 197.0000, 'ºC'),
	(243113, 118, '2014-03-15 01:02:40.000000', 'temperatura', 442.0000, 'ºC'),
	(243114, 118, '2014-03-15 01:02:41.000000', 'temperatura', 420.0000, 'ºC'),
	(243115, 118, '2014-03-15 01:02:42.000000', 'temperatura', 773.0000, 'ºC'),
	(243116, 118, '2014-03-15 01:02:43.000000', 'temperatura', 205.0000, 'ºC'),
	(243117, 118, '2014-03-15 01:02:44.000000', 'temperatura', 1107.0000, 'ºC'),
	(243118, 118, '2014-03-15 01:02:45.000000', 'temperatura', 121.0000, 'ºC'),
	(243119, 118, '2014-03-15 01:02:46.000000', 'temperatura', 883.0000, 'ºC'),
	(243120, 118, '2014-03-15 01:02:47.000000', 'temperatura', 451.0000, 'ºC'),
	(243121, 118, '2014-03-15 01:02:48.000000', 'temperatura', 809.0000, 'ºC'),
	(243122, 118, '2014-03-15 01:02:49.000000', 'temperatura', 294.0000, 'ºC'),
	(243123, 118, '2014-03-15 01:02:50.000000', 'temperatura', 242.0000, 'ºC'),
	(243124, 118, '2014-03-15 01:02:51.000000', 'temperatura', 328.0000, 'ºC'),
	(243125, 118, '2014-03-15 01:02:52.000000', 'temperatura', 913.0000, 'ºC'),
	(243126, 118, '2014-03-15 01:02:53.000000', 'temperatura', 1183.0000, 'ºC'),
	(243127, 118, '2014-03-15 01:02:54.000000', 'temperatura', 778.0000, 'ºC'),
	(243128, 118, '2014-03-15 01:02:55.000000', 'temperatura', 342.0000, 'ºC'),
	(243129, 118, '2014-03-15 01:02:56.000000', 'temperatura', 575.0000, 'ºC'),
	(243130, 118, '2014-03-15 01:02:57.000000', 'temperatura', 649.0000, 'ºC'),
	(243131, 118, '2014-03-15 01:02:58.000000', 'temperatura', 321.0000, 'ºC'),
	(243132, 118, '2014-03-15 01:02:59.000000', 'temperatura', 859.0000, 'ºC'),
	(243133, 118, '2014-03-15 01:03:00.000000', 'temperatura', 934.0000, 'ºC'),
	(243134, 118, '2014-03-15 01:03:01.000000', 'temperatura', 893.0000, 'ºC'),
	(243135, 118, '2014-03-15 01:03:02.000000', 'temperatura', 463.0000, 'ºC'),
	(243136, 118, '2014-03-15 01:03:03.000000', 'temperatura', 835.0000, 'ºC'),
	(243137, 118, '2014-03-15 01:03:04.000000', 'temperatura', 387.0000, 'ºC'),
	(243138, 118, '2014-03-15 01:03:05.000000', 'temperatura', 632.0000, 'ºC'),
	(243139, 118, '2014-03-15 01:03:06.000000', 'temperatura', 800.0000, 'ºC'),
	(243140, 118, '2014-03-15 01:03:07.000000', 'temperatura', 905.0000, 'ºC'),
	(243141, 118, '2014-03-15 01:03:08.000000', 'temperatura', 925.0000, 'ºC'),
	(243142, 118, '2014-03-15 01:03:09.000000', 'temperatura', 709.0000, 'ºC'),
	(243143, 118, '2014-03-15 01:03:10.000000', 'temperatura', 771.0000, 'ºC'),
	(243144, 118, '2014-03-15 01:03:11.000000', 'temperatura', 529.0000, 'ºC'),
	(243145, 118, '2014-03-15 01:03:12.000000', 'temperatura', 333.0000, 'ºC'),
	(243146, 118, '2014-03-15 01:03:13.000000', 'temperatura', 78.0000, 'ºC'),
	(243147, 118, '2014-03-15 01:03:14.000000', 'temperatura', 592.0000, 'ºC'),
	(243148, 118, '2014-03-15 01:03:15.000000', 'temperatura', 325.0000, 'ºC'),
	(243149, 118, '2014-03-15 01:03:16.000000', 'temperatura', 1051.0000, 'ºC'),
	(243150, 118, '2014-03-15 01:03:17.000000', 'temperatura', 681.0000, 'ºC'),
	(243151, 118, '2014-03-15 01:03:18.000000', 'temperatura', 251.0000, 'ºC'),
	(243152, 118, '2014-03-15 01:03:19.000000', 'temperatura', 411.0000, 'ºC'),
	(243153, 118, '2014-03-15 01:03:20.000000', 'temperatura', 105.0000, 'ºC'),
	(243154, 118, '2014-03-15 01:03:21.000000', 'temperatura', 492.0000, 'ºC'),
	(243155, 118, '2014-03-15 01:03:22.000000', 'temperatura', 945.0000, 'ºC'),
	(243156, 118, '2014-03-15 01:03:23.000000', 'temperatura', 851.0000, 'ºC'),
	(243157, 118, '2014-03-15 01:03:24.000000', 'temperatura', 218.0000, 'ºC'),
	(243158, 118, '2014-03-15 01:03:25.000000', 'temperatura', 941.0000, 'ºC'),
	(243159, 118, '2014-03-15 01:03:26.000000', 'temperatura', 449.0000, 'ºC'),
	(243160, 118, '2014-03-15 01:03:27.000000', 'temperatura', 622.0000, 'ºC'),
	(243161, 118, '2014-03-15 01:03:28.000000', 'temperatura', 565.0000, 'ºC'),
	(243162, 118, '2014-03-15 01:03:29.000000', 'temperatura', 960.0000, 'ºC'),
	(243163, 118, '2014-03-15 01:03:30.000000', 'temperatura', 703.0000, 'ºC'),
	(243164, 118, '2014-03-15 01:03:31.000000', 'temperatura', 636.0000, 'ºC'),
	(243165, 118, '2014-03-15 01:03:32.000000', 'temperatura', 1072.0000, 'ºC'),
	(243166, 118, '2014-03-15 01:03:33.000000', 'temperatura', 1054.0000, 'ºC'),
	(243167, 118, '2014-03-15 01:03:34.000000', 'temperatura', 851.0000, 'ºC'),
	(243168, 118, '2014-03-15 01:03:35.000000', 'temperatura', 1097.0000, 'ºC'),
	(243169, 118, '2014-03-15 01:03:36.000000', 'temperatura', 532.0000, 'ºC'),
	(243170, 118, '2014-03-15 01:03:37.000000', 'temperatura', 569.0000, 'ºC'),
	(243171, 118, '2014-03-15 01:03:38.000000', 'temperatura', 49.0000, 'ºC'),
	(243172, 118, '2014-03-15 01:03:39.000000', 'temperatura', 939.0000, 'ºC'),
	(243173, 118, '2014-03-15 01:03:40.000000', 'temperatura', 946.0000, 'ºC'),
	(243174, 118, '2014-03-15 01:03:41.000000', 'temperatura', 717.0000, 'ºC'),
	(243175, 118, '2014-03-15 01:03:42.000000', 'temperatura', 747.0000, 'ºC'),
	(243176, 118, '2014-03-15 01:03:43.000000', 'temperatura', 383.0000, 'ºC'),
	(243177, 118, '2014-03-15 01:03:44.000000', 'temperatura', 875.0000, 'ºC'),
	(243178, 118, '2014-03-15 01:03:45.000000', 'temperatura', 826.0000, 'ºC'),
	(243179, 118, '2014-03-15 01:03:46.000000', 'temperatura', 304.0000, 'ºC'),
	(243180, 118, '2014-03-15 01:03:47.000000', 'temperatura', 244.0000, 'ºC'),
	(243181, 118, '2014-03-15 01:03:48.000000', 'temperatura', 307.0000, 'ºC'),
	(243182, 118, '2014-03-15 01:03:49.000000', 'temperatura', 803.0000, 'ºC'),
	(243183, 118, '2014-03-15 01:03:50.000000', 'temperatura', 695.0000, 'ºC'),
	(243184, 118, '2014-03-15 01:03:51.000000', 'temperatura', 1066.0000, 'ºC'),
	(243185, 118, '2014-03-15 01:03:52.000000', 'temperatura', 847.0000, 'ºC'),
	(243186, 118, '2014-03-15 01:03:53.000000', 'temperatura', 1037.0000, 'ºC'),
	(243187, 118, '2014-03-15 01:03:54.000000', 'temperatura', 246.0000, 'ºC'),
	(243188, 118, '2014-03-15 01:03:55.000000', 'temperatura', 519.0000, 'ºC'),
	(243189, 118, '2014-03-15 01:03:56.000000', 'temperatura', 656.0000, 'ºC'),
	(243190, 118, '2014-03-15 01:03:57.000000', 'temperatura', 525.0000, 'ºC'),
	(243191, 118, '2014-03-15 01:03:58.000000', 'temperatura', 657.0000, 'ºC'),
	(243192, 118, '2014-03-15 01:03:59.000000', 'temperatura', 512.0000, 'ºC'),
	(243193, 118, '2014-03-15 01:04:00.000000', 'temperatura', 588.0000, 'ºC'),
	(243194, 118, '2014-03-15 01:04:01.000000', 'temperatura', 205.0000, 'ºC'),
	(243195, 118, '2014-03-15 01:04:02.000000', 'temperatura', 461.0000, 'ºC'),
	(243196, 118, '2014-03-15 01:04:03.000000', 'temperatura', 493.0000, 'ºC'),
	(243197, 118, '2014-03-15 01:04:04.000000', 'temperatura', 1080.0000, 'ºC'),
	(243198, 118, '2014-03-15 01:04:05.000000', 'temperatura', 322.0000, 'ºC'),
	(243199, 118, '2014-03-15 01:04:06.000000', 'temperatura', 772.0000, 'ºC'),
	(243200, 118, '2014-03-15 01:04:07.000000', 'temperatura', 493.0000, 'ºC'),
	(243201, 118, '2014-03-15 01:04:08.000000', 'temperatura', 149.0000, 'ºC'),
	(243202, 118, '2014-03-15 01:04:09.000000', 'temperatura', 465.0000, 'ºC'),
	(243203, 118, '2014-03-15 01:04:10.000000', 'temperatura', 682.0000, 'ºC'),
	(243204, 118, '2014-03-15 01:04:11.000000', 'temperatura', 812.0000, 'ºC'),
	(243205, 118, '2014-03-15 01:04:12.000000', 'temperatura', 817.0000, 'ºC'),
	(243206, 118, '2014-03-15 01:04:13.000000', 'temperatura', 448.0000, 'ºC'),
	(243207, 118, '2014-03-15 01:04:14.000000', 'temperatura', 990.0000, 'ºC'),
	(243208, 118, '2014-03-15 01:04:15.000000', 'temperatura', 5.0000, 'ºC'),
	(243209, 118, '2014-03-15 01:04:16.000000', 'temperatura', 658.0000, 'ºC'),
	(243210, 118, '2014-03-15 01:04:17.000000', 'temperatura', 876.0000, 'ºC'),
	(243211, 118, '2014-03-15 01:04:18.000000', 'temperatura', 5.0000, 'ºC'),
	(243212, 118, '2014-03-15 01:04:19.000000', 'temperatura', 999.0000, 'ºC'),
	(243213, 118, '2014-03-15 01:04:20.000000', 'temperatura', 178.0000, 'ºC'),
	(243214, 118, '2014-03-15 01:04:21.000000', 'temperatura', 295.0000, 'ºC'),
	(243215, 118, '2014-03-15 01:04:22.000000', 'temperatura', 942.0000, 'ºC'),
	(243216, 118, '2014-03-15 01:04:23.000000', 'temperatura', 223.0000, 'ºC'),
	(243217, 118, '2014-03-15 01:04:24.000000', 'temperatura', 693.0000, 'ºC'),
	(243218, 118, '2014-03-15 01:04:25.000000', 'temperatura', 394.0000, 'ºC'),
	(243219, 118, '2014-03-15 01:04:26.000000', 'temperatura', 1093.0000, 'ºC'),
	(243220, 118, '2014-03-15 01:04:27.000000', 'temperatura', 682.0000, 'ºC'),
	(243221, 118, '2014-03-15 01:04:28.000000', 'temperatura', 134.0000, 'ºC'),
	(243222, 118, '2014-03-15 01:04:29.000000', 'temperatura', 1021.0000, 'ºC'),
	(243223, 118, '2014-03-15 01:04:30.000000', 'temperatura', 1107.0000, 'ºC'),
	(243224, 118, '2014-03-15 01:04:31.000000', 'temperatura', 72.0000, 'ºC'),
	(243225, 118, '2014-03-15 01:04:32.000000', 'temperatura', 638.0000, 'ºC'),
	(243226, 118, '2014-03-15 01:04:33.000000', 'temperatura', 575.0000, 'ºC'),
	(243227, 118, '2014-03-15 01:04:34.000000', 'temperatura', 962.0000, 'ºC'),
	(243228, 118, '2014-03-15 01:04:35.000000', 'temperatura', 684.0000, 'ºC'),
	(243229, 118, '2014-03-15 01:04:36.000000', 'temperatura', 534.0000, 'ºC'),
	(243230, 118, '2014-03-15 01:04:37.000000', 'temperatura', 621.0000, 'ºC'),
	(243231, 118, '2014-03-15 01:04:38.000000', 'temperatura', 303.0000, 'ºC'),
	(243232, 118, '2014-03-15 01:04:39.000000', 'temperatura', 854.0000, 'ºC'),
	(243233, 118, '2014-03-15 01:04:40.000000', 'temperatura', 958.0000, 'ºC'),
	(243234, 118, '2014-03-15 01:04:41.000000', 'temperatura', 1030.0000, 'ºC'),
	(243235, 118, '2014-03-15 01:04:42.000000', 'temperatura', 1078.0000, 'ºC'),
	(243236, 118, '2014-03-15 01:04:43.000000', 'temperatura', 1098.0000, 'ºC'),
	(243237, 118, '2014-03-15 01:04:44.000000', 'temperatura', 1059.0000, 'ºC'),
	(243238, 118, '2014-03-15 01:04:45.000000', 'temperatura', 801.0000, 'ºC'),
	(243239, 118, '2014-03-15 01:04:46.000000', 'temperatura', 829.0000, 'ºC'),
	(243240, 118, '2014-03-15 01:04:47.000000', 'temperatura', 544.0000, 'ºC'),
	(243241, 118, '2014-03-15 01:04:48.000000', 'temperatura', 232.0000, 'ºC'),
	(243242, 118, '2014-03-15 01:04:49.000000', 'temperatura', 729.0000, 'ºC'),
	(243243, 118, '2014-03-15 01:04:50.000000', 'temperatura', 550.0000, 'ºC'),
	(243244, 118, '2014-03-15 01:04:51.000000', 'temperatura', 565.0000, 'ºC'),
	(243245, 118, '2014-03-15 01:04:52.000000', 'temperatura', 1173.0000, 'ºC'),
	(243246, 118, '2014-03-15 01:04:53.000000', 'temperatura', 572.0000, 'ºC'),
	(243247, 118, '2014-03-15 01:04:54.000000', 'temperatura', 543.0000, 'ºC'),
	(243248, 118, '2014-03-15 01:04:55.000000', 'temperatura', 998.0000, 'ºC'),
	(243249, 118, '2014-03-15 01:04:56.000000', 'temperatura', 959.0000, 'ºC'),
	(243250, 118, '2014-03-15 01:04:57.000000', 'temperatura', 605.0000, 'ºC'),
	(243251, 118, '2014-03-15 01:04:58.000000', 'temperatura', 148.0000, 'ºC'),
	(243252, 118, '2014-03-15 01:04:59.000000', 'temperatura', 125.0000, 'ºC'),
	(243253, 118, '2014-03-15 01:05:00.000000', 'temperatura', 183.0000, 'ºC'),
	(243254, 118, '2014-03-15 01:05:01.000000', 'temperatura', 540.0000, 'ºC'),
	(243255, 118, '2014-03-15 01:05:02.000000', 'temperatura', 952.0000, 'ºC'),
	(243256, 118, '2014-03-15 01:05:03.000000', 'temperatura', 741.0000, 'ºC'),
	(243257, 118, '2014-03-15 01:05:04.000000', 'temperatura', 849.0000, 'ºC'),
	(243258, 118, '2014-03-15 01:05:05.000000', 'temperatura', 823.0000, 'ºC'),
	(243259, 118, '2014-03-15 01:05:06.000000', 'temperatura', 367.0000, 'ºC'),
	(243260, 118, '2014-03-15 01:05:07.000000', 'temperatura', 566.0000, 'ºC'),
	(243261, 118, '2014-03-15 01:05:08.000000', 'temperatura', 530.0000, 'ºC'),
	(243262, 118, '2014-03-15 01:05:09.000000', 'temperatura', 955.0000, 'ºC'),
	(243263, 118, '2014-03-15 01:05:10.000000', 'temperatura', 783.0000, 'ºC'),
	(243264, 118, '2014-03-15 01:05:11.000000', 'temperatura', 1049.0000, 'ºC'),
	(243265, 118, '2014-03-15 01:05:12.000000', 'temperatura', 499.0000, 'ºC'),
	(243266, 118, '2014-03-15 01:05:13.000000', 'temperatura', 548.0000, 'ºC'),
	(243267, 118, '2014-03-15 01:05:14.000000', 'temperatura', 41.0000, 'ºC'),
	(243268, 118, '2014-03-15 01:05:15.000000', 'temperatura', 964.0000, 'ºC'),
	(243269, 118, '2014-03-15 01:05:16.000000', 'temperatura', 1099.0000, 'ºC'),
	(243270, 118, '2014-03-15 01:05:17.000000', 'temperatura', 201.0000, 'ºC'),
	(243271, 118, '2014-03-15 01:05:18.000000', 'temperatura', 110.0000, 'ºC'),
	(243272, 118, '2014-03-15 01:05:19.000000', 'temperatura', 1147.0000, 'ºC'),
	(243273, 118, '2014-03-15 01:05:20.000000', 'temperatura', 606.0000, 'ºC'),
	(243274, 118, '2014-03-15 01:05:21.000000', 'temperatura', 791.0000, 'ºC'),
	(243275, 118, '2014-03-15 01:05:22.000000', 'temperatura', 935.0000, 'ºC'),
	(243276, 118, '2014-03-15 01:05:23.000000', 'temperatura', 1105.0000, 'ºC'),
	(243277, 118, '2014-03-15 01:05:24.000000', 'temperatura', 320.0000, 'ºC'),
	(243278, 118, '2014-03-15 01:05:25.000000', 'temperatura', 687.0000, 'ºC'),
	(243279, 118, '2014-03-15 01:05:26.000000', 'temperatura', 74.0000, 'ºC'),
	(243280, 118, '2014-03-15 01:05:27.000000', 'temperatura', 710.0000, 'ºC'),
	(243281, 118, '2014-03-15 01:05:28.000000', 'temperatura', 927.0000, 'ºC'),
	(243282, 118, '2014-03-15 01:05:29.000000', 'temperatura', 105.0000, 'ºC'),
	(243283, 118, '2014-03-15 01:05:30.000000', 'temperatura', 143.0000, 'ºC'),
	(243284, 118, '2014-03-15 01:05:31.000000', 'temperatura', 404.0000, 'ºC'),
	(243285, 118, '2014-03-15 01:05:32.000000', 'temperatura', 391.0000, 'ºC'),
	(243286, 118, '2014-03-15 01:05:33.000000', 'temperatura', 743.0000, 'ºC'),
	(243287, 118, '2014-03-15 01:05:34.000000', 'temperatura', 142.0000, 'ºC'),
	(243288, 118, '2014-03-15 01:05:35.000000', 'temperatura', 884.0000, 'ºC'),
	(243289, 118, '2014-03-15 01:05:36.000000', 'temperatura', 393.0000, 'ºC'),
	(243290, 118, '2014-03-15 01:05:37.000000', 'temperatura', 513.0000, 'ºC'),
	(243291, 118, '2014-03-15 01:05:38.000000', 'temperatura', 185.0000, 'ºC'),
	(243292, 118, '2014-03-15 01:05:39.000000', 'temperatura', 587.0000, 'ºC'),
	(243293, 118, '2014-03-15 01:05:40.000000', 'temperatura', 1182.0000, 'ºC'),
	(243294, 118, '2014-03-15 01:05:41.000000', 'temperatura', 547.0000, 'ºC'),
	(243295, 118, '2014-03-15 01:05:42.000000', 'temperatura', 390.0000, 'ºC'),
	(243296, 118, '2014-03-15 01:05:43.000000', 'temperatura', 309.0000, 'ºC'),
	(243297, 118, '2014-03-15 01:05:44.000000', 'temperatura', 377.0000, 'ºC'),
	(243298, 118, '2014-03-15 01:05:45.000000', 'temperatura', 957.0000, 'ºC'),
	(243299, 118, '2014-03-15 01:05:46.000000', 'temperatura', 57.0000, 'ºC'),
	(243300, 118, '2014-03-15 01:05:47.000000', 'temperatura', 1012.0000, 'ºC'),
	(243301, 118, '2014-03-15 01:05:48.000000', 'temperatura', 88.0000, 'ºC'),
	(243302, 118, '2014-03-15 01:05:49.000000', 'temperatura', 1008.0000, 'ºC'),
	(243303, 118, '2014-03-15 01:05:50.000000', 'temperatura', 1174.0000, 'ºC'),
	(243304, 118, '2014-03-15 01:05:51.000000', 'temperatura', 447.0000, 'ºC'),
	(243305, 118, '2014-03-15 01:05:52.000000', 'temperatura', 1115.0000, 'ºC'),
	(243306, 118, '2014-03-15 01:05:53.000000', 'temperatura', 632.0000, 'ºC'),
	(243307, 118, '2014-03-15 01:05:54.000000', 'temperatura', 1015.0000, 'ºC'),
	(243308, 118, '2014-03-15 01:05:55.000000', 'temperatura', 782.0000, 'ºC'),
	(243309, 118, '2014-03-15 01:05:56.000000', 'temperatura', 865.0000, 'ºC'),
	(243310, 118, '2014-03-15 01:05:57.000000', 'temperatura', 780.0000, 'ºC'),
	(243311, 118, '2014-03-15 01:05:58.000000', 'temperatura', 105.0000, 'ºC'),
	(243312, 118, '2014-03-15 01:05:59.000000', 'temperatura', 585.0000, 'ºC'),
	(243313, 118, '2014-03-15 01:06:00.000000', 'temperatura', 210.0000, 'ºC'),
	(243314, 118, '2014-03-15 01:06:01.000000', 'temperatura', 498.0000, 'ºC'),
	(243315, 118, '2014-03-15 01:06:02.000000', 'temperatura', 657.0000, 'ºC'),
	(243316, 118, '2014-03-15 01:06:03.000000', 'temperatura', 594.0000, 'ºC'),
	(243317, 118, '2014-03-15 01:06:04.000000', 'temperatura', 998.0000, 'ºC'),
	(243318, 118, '2014-03-15 01:06:05.000000', 'temperatura', 807.0000, 'ºC'),
	(243319, 118, '2014-03-15 01:06:06.000000', 'temperatura', 1043.0000, 'ºC'),
	(243320, 118, '2014-03-15 01:06:07.000000', 'temperatura', 396.0000, 'ºC'),
	(243321, 118, '2014-03-15 01:06:08.000000', 'temperatura', 51.0000, 'ºC'),
	(243322, 118, '2014-03-15 01:06:09.000000', 'temperatura', 268.0000, 'ºC'),
	(243323, 118, '2014-03-15 01:06:10.000000', 'temperatura', 1186.0000, 'ºC'),
	(243324, 118, '2014-03-15 01:06:11.000000', 'temperatura', 326.0000, 'ºC'),
	(243325, 118, '2014-03-15 01:06:12.000000', 'temperatura', 475.0000, 'ºC'),
	(243326, 118, '2014-03-15 01:06:13.000000', 'temperatura', 197.0000, 'ºC'),
	(243327, 118, '2014-03-15 01:06:14.000000', 'temperatura', 758.0000, 'ºC'),
	(243328, 118, '2014-03-15 01:06:15.000000', 'temperatura', 802.0000, 'ºC'),
	(243329, 118, '2014-03-15 01:06:16.000000', 'temperatura', 536.0000, 'ºC'),
	(243330, 118, '2014-03-15 01:06:17.000000', 'temperatura', 276.0000, 'ºC'),
	(243331, 118, '2014-03-15 01:06:18.000000', 'temperatura', 970.0000, 'ºC'),
	(243332, 118, '2014-03-15 01:06:19.000000', 'temperatura', 424.0000, 'ºC'),
	(243333, 118, '2014-03-15 01:06:20.000000', 'temperatura', 408.0000, 'ºC'),
	(243334, 118, '2014-03-15 01:06:21.000000', 'temperatura', 770.0000, 'ºC'),
	(243335, 118, '2014-03-15 01:06:22.000000', 'temperatura', 227.0000, 'ºC'),
	(243336, 118, '2014-03-15 01:06:23.000000', 'temperatura', 25.0000, 'ºC'),
	(243337, 118, '2014-03-15 01:06:24.000000', 'temperatura', 644.0000, 'ºC'),
	(243338, 118, '2014-03-15 01:06:25.000000', 'temperatura', 744.0000, 'ºC'),
	(243339, 118, '2014-03-15 01:06:26.000000', 'temperatura', 590.0000, 'ºC'),
	(243340, 118, '2014-03-15 01:06:27.000000', 'temperatura', 720.0000, 'ºC'),
	(243341, 118, '2014-03-15 01:06:28.000000', 'temperatura', 631.0000, 'ºC'),
	(243342, 118, '2014-03-15 01:06:29.000000', 'temperatura', 995.0000, 'ºC'),
	(243343, 118, '2014-03-15 01:06:30.000000', 'temperatura', 682.0000, 'ºC'),
	(243344, 118, '2014-03-15 01:06:31.000000', 'temperatura', 428.0000, 'ºC'),
	(243345, 118, '2014-03-15 01:06:32.000000', 'temperatura', 91.0000, 'ºC'),
	(243346, 118, '2014-03-15 01:06:33.000000', 'temperatura', 373.0000, 'ºC'),
	(243347, 118, '2014-03-15 01:06:34.000000', 'temperatura', 393.0000, 'ºC'),
	(243348, 118, '2014-03-15 01:06:35.000000', 'temperatura', 844.0000, 'ºC'),
	(243349, 118, '2014-03-15 01:06:36.000000', 'temperatura', 642.0000, 'ºC'),
	(243350, 118, '2014-03-15 01:06:37.000000', 'temperatura', 681.0000, 'ºC'),
	(243351, 118, '2014-03-15 01:06:38.000000', 'temperatura', 279.0000, 'ºC'),
	(243352, 118, '2014-03-15 01:06:39.000000', 'temperatura', 550.0000, 'ºC'),
	(243353, 118, '2014-03-15 01:06:40.000000', 'temperatura', 715.0000, 'ºC'),
	(243354, 118, '2014-03-15 01:06:41.000000', 'temperatura', 724.0000, 'ºC'),
	(243355, 118, '2014-03-15 01:06:42.000000', 'temperatura', 278.0000, 'ºC'),
	(243356, 118, '2014-03-15 01:06:43.000000', 'temperatura', 415.0000, 'ºC'),
	(243357, 118, '2014-03-15 01:06:44.000000', 'temperatura', 45.0000, 'ºC'),
	(243358, 118, '2014-03-15 01:06:45.000000', 'temperatura', 179.0000, 'ºC'),
	(243359, 118, '2014-03-15 01:06:46.000000', 'temperatura', 760.0000, 'ºC'),
	(243360, 118, '2014-03-15 01:06:47.000000', 'temperatura', 864.0000, 'ºC'),
	(243361, 118, '2014-03-15 01:06:48.000000', 'temperatura', 839.0000, 'ºC'),
	(243362, 118, '2014-03-15 01:06:49.000000', 'temperatura', 403.0000, 'ºC'),
	(243363, 118, '2014-03-15 01:06:50.000000', 'temperatura', 698.0000, 'ºC'),
	(243364, 118, '2014-03-15 01:06:51.000000', 'temperatura', 1085.0000, 'ºC'),
	(243365, 118, '2014-03-15 01:06:52.000000', 'temperatura', 928.0000, 'ºC'),
	(243366, 118, '2014-03-15 01:06:53.000000', 'temperatura', 188.0000, 'ºC'),
	(243367, 118, '2014-03-15 01:06:54.000000', 'temperatura', 555.0000, 'ºC'),
	(243368, 118, '2014-03-15 01:06:55.000000', 'temperatura', 1011.0000, 'ºC'),
	(243369, 118, '2014-03-15 01:06:56.000000', 'temperatura', 991.0000, 'ºC'),
	(243370, 118, '2014-03-15 01:06:57.000000', 'temperatura', 724.0000, 'ºC'),
	(243371, 118, '2014-03-15 01:06:58.000000', 'temperatura', 647.0000, 'ºC'),
	(243372, 118, '2014-03-15 01:06:59.000000', 'temperatura', 1065.0000, 'ºC'),
	(243373, 118, '2014-03-15 01:07:00.000000', 'temperatura', 984.0000, 'ºC'),
	(243374, 118, '2014-03-15 01:07:01.000000', 'temperatura', 526.0000, 'ºC'),
	(243375, 118, '2014-03-15 01:07:02.000000', 'temperatura', 879.0000, 'ºC'),
	(243376, 118, '2014-03-15 01:07:03.000000', 'temperatura', 417.0000, 'ºC'),
	(243377, 118, '2014-03-15 01:07:04.000000', 'temperatura', 648.0000, 'ºC'),
	(243378, 118, '2014-03-15 01:07:05.000000', 'temperatura', 791.0000, 'ºC'),
	(243379, 118, '2014-03-15 01:07:06.000000', 'temperatura', 811.0000, 'ºC'),
	(243380, 118, '2014-03-15 01:07:07.000000', 'temperatura', 484.0000, 'ºC'),
	(243381, 118, '2014-03-15 01:07:08.000000', 'temperatura', 1186.0000, 'ºC'),
	(243382, 118, '2014-03-15 01:07:09.000000', 'temperatura', 879.0000, 'ºC'),
	(243383, 118, '2014-03-15 01:07:10.000000', 'temperatura', 837.0000, 'ºC'),
	(243384, 118, '2014-03-15 01:07:11.000000', 'temperatura', 350.0000, 'ºC'),
	(243385, 118, '2014-03-15 01:07:12.000000', 'temperatura', 439.0000, 'ºC'),
	(243386, 118, '2014-03-15 01:07:13.000000', 'temperatura', 1145.0000, 'ºC'),
	(243387, 118, '2014-03-15 01:07:14.000000', 'temperatura', 810.0000, 'ºC'),
	(243388, 118, '2014-03-15 01:07:15.000000', 'temperatura', 615.0000, 'ºC'),
	(243389, 118, '2014-03-15 01:07:16.000000', 'temperatura', 645.0000, 'ºC'),
	(243390, 118, '2014-03-15 01:07:17.000000', 'temperatura', 180.0000, 'ºC'),
	(243391, 118, '2014-03-15 01:07:18.000000', 'temperatura', 165.0000, 'ºC'),
	(243392, 118, '2014-03-15 01:07:19.000000', 'temperatura', 286.0000, 'ºC'),
	(243393, 118, '2014-03-15 01:07:20.000000', 'temperatura', 935.0000, 'ºC'),
	(243394, 118, '2014-03-15 01:07:21.000000', 'temperatura', 219.0000, 'ºC'),
	(243395, 118, '2014-03-15 01:07:22.000000', 'temperatura', 688.0000, 'ºC'),
	(243396, 118, '2014-03-15 01:07:23.000000', 'temperatura', 385.0000, 'ºC'),
	(243397, 118, '2014-03-15 01:07:24.000000', 'temperatura', 1062.0000, 'ºC'),
	(243398, 118, '2014-03-15 01:07:25.000000', 'temperatura', 555.0000, 'ºC'),
	(243399, 118, '2014-03-15 01:07:26.000000', 'temperatura', 788.0000, 'ºC'),
	(243400, 118, '2014-03-15 01:07:27.000000', 'temperatura', 1075.0000, 'ºC'),
	(243401, 118, '2014-03-15 01:07:28.000000', 'temperatura', 613.0000, 'ºC'),
	(243402, 118, '2014-03-15 01:07:29.000000', 'temperatura', 1039.0000, 'ºC'),
	(243403, 118, '2014-03-15 01:07:30.000000', 'temperatura', 957.0000, 'ºC'),
	(243404, 118, '2014-03-15 01:07:31.000000', 'temperatura', 469.0000, 'ºC'),
	(243405, 118, '2014-03-15 01:07:32.000000', 'temperatura', 674.0000, 'ºC'),
	(243406, 118, '2014-03-15 01:07:33.000000', 'temperatura', 763.0000, 'ºC'),
	(243407, 118, '2014-03-15 01:07:34.000000', 'temperatura', 592.0000, 'ºC'),
	(243408, 118, '2014-03-15 01:07:35.000000', 'temperatura', 674.0000, 'ºC'),
	(243409, 118, '2014-03-15 01:07:36.000000', 'temperatura', 392.0000, 'ºC'),
	(243410, 118, '2014-03-15 01:07:37.000000', 'temperatura', 1141.0000, 'ºC'),
	(243411, 118, '2014-03-15 01:07:38.000000', 'temperatura', 928.0000, 'ºC'),
	(243412, 118, '2014-03-15 01:07:39.000000', 'temperatura', 19.0000, 'ºC'),
	(243413, 118, '2014-03-15 01:07:40.000000', 'temperatura', 911.0000, 'ºC'),
	(243414, 118, '2014-03-15 01:07:41.000000', 'temperatura', 897.0000, 'ºC'),
	(243415, 118, '2014-03-15 01:07:42.000000', 'temperatura', 555.0000, 'ºC'),
	(243416, 118, '2014-03-15 01:07:43.000000', 'temperatura', 85.0000, 'ºC'),
	(243417, 118, '2014-03-15 01:07:44.000000', 'temperatura', 1159.0000, 'ºC'),
	(243418, 118, '2014-03-15 01:07:45.000000', 'temperatura', 741.0000, 'ºC'),
	(243419, 118, '2014-03-15 01:07:46.000000', 'temperatura', 228.0000, 'ºC'),
	(243420, 118, '2014-03-15 01:07:47.000000', 'temperatura', 118.0000, 'ºC'),
	(243421, 118, '2014-03-15 01:07:48.000000', 'temperatura', 1108.0000, 'ºC'),
	(243422, 118, '2014-03-15 01:07:49.000000', 'temperatura', 386.0000, 'ºC'),
	(243423, 118, '2014-03-15 01:07:50.000000', 'temperatura', 1006.0000, 'ºC'),
	(243424, 118, '2014-03-15 01:07:51.000000', 'temperatura', 273.0000, 'ºC'),
	(243425, 118, '2014-03-15 01:07:52.000000', 'temperatura', 748.0000, 'ºC'),
	(243426, 118, '2014-03-15 01:07:53.000000', 'temperatura', 523.0000, 'ºC'),
	(243427, 118, '2014-03-15 01:07:54.000000', 'temperatura', 370.0000, 'ºC'),
	(243428, 118, '2014-03-15 01:07:55.000000', 'temperatura', 281.0000, 'ºC'),
	(243429, 118, '2014-03-15 01:07:56.000000', 'temperatura', 297.0000, 'ºC'),
	(243430, 118, '2014-03-15 01:07:57.000000', 'temperatura', 640.0000, 'ºC'),
	(243431, 118, '2014-03-15 01:07:58.000000', 'temperatura', 1109.0000, 'ºC'),
	(243432, 118, '2014-03-15 01:07:59.000000', 'temperatura', 27.0000, 'ºC'),
	(243433, 118, '2014-03-15 01:08:00.000000', 'temperatura', 408.0000, 'ºC'),
	(243434, 118, '2014-03-15 01:08:01.000000', 'temperatura', 761.0000, 'ºC'),
	(243435, 118, '2014-03-15 01:08:02.000000', 'temperatura', 179.0000, 'ºC'),
	(243436, 118, '2014-03-15 01:08:03.000000', 'temperatura', 1014.0000, 'ºC'),
	(243437, 118, '2014-03-15 01:08:04.000000', 'temperatura', 934.0000, 'ºC'),
	(243438, 118, '2014-03-15 01:08:05.000000', 'temperatura', 429.0000, 'ºC'),
	(243439, 118, '2014-03-15 01:08:06.000000', 'temperatura', 543.0000, 'ºC'),
	(243440, 118, '2014-03-15 01:08:07.000000', 'temperatura', 228.0000, 'ºC'),
	(243441, 118, '2014-03-15 01:08:08.000000', 'temperatura', 711.0000, 'ºC'),
	(243442, 118, '2014-03-15 01:08:09.000000', 'temperatura', 474.0000, 'ºC'),
	(243443, 118, '2014-03-15 01:08:10.000000', 'temperatura', 236.0000, 'ºC'),
	(243444, 118, '2014-03-15 01:08:11.000000', 'temperatura', 960.0000, 'ºC'),
	(243445, 118, '2014-03-15 01:08:12.000000', 'temperatura', 491.0000, 'ºC'),
	(243446, 118, '2014-03-15 01:08:13.000000', 'temperatura', 774.0000, 'ºC'),
	(243447, 118, '2014-03-15 01:08:14.000000', 'temperatura', 1198.0000, 'ºC'),
	(243448, 118, '2014-03-15 01:08:15.000000', 'temperatura', 68.0000, 'ºC'),
	(243449, 118, '2014-03-15 01:08:16.000000', 'temperatura', 345.0000, 'ºC'),
	(243450, 118, '2014-03-15 01:08:17.000000', 'temperatura', 325.0000, 'ºC'),
	(243451, 118, '2014-03-15 01:08:18.000000', 'temperatura', 589.0000, 'ºC'),
	(243452, 118, '2014-03-15 01:08:19.000000', 'temperatura', 770.0000, 'ºC'),
	(243453, 118, '2014-03-15 01:08:20.000000', 'temperatura', 883.0000, 'ºC'),
	(243454, 118, '2014-03-15 01:08:21.000000', 'temperatura', 906.0000, 'ºC'),
	(243455, 118, '2014-03-15 01:08:22.000000', 'temperatura', 682.0000, 'ºC'),
	(243456, 118, '2014-03-15 01:08:23.000000', 'temperatura', 691.0000, 'ºC'),
	(243457, 118, '2014-03-15 01:08:24.000000', 'temperatura', 211.0000, 'ºC'),
	(243458, 118, '2014-03-15 01:08:25.000000', 'temperatura', 184.0000, 'ºC'),
	(243459, 118, '2014-03-15 01:08:26.000000', 'temperatura', 285.0000, 'ºC'),
	(243460, 118, '2014-03-15 01:08:27.000000', 'temperatura', 875.0000, 'ºC'),
	(243461, 118, '2014-03-15 01:08:28.000000', 'temperatura', 1118.0000, 'ºC'),
	(243462, 118, '2014-03-15 01:08:29.000000', 'temperatura', 567.0000, 'ºC'),
	(243463, 118, '2014-03-15 01:08:30.000000', 'temperatura', 680.0000, 'ºC'),
	(243464, 118, '2014-03-15 01:08:31.000000', 'temperatura', 499.0000, 'ºC'),
	(243465, 118, '2014-03-15 01:08:32.000000', 'temperatura', 457.0000, 'ºC'),
	(243466, 118, '2014-03-15 01:08:33.000000', 'temperatura', 788.0000, 'ºC'),
	(243467, 118, '2014-03-15 01:08:34.000000', 'temperatura', 168.0000, 'ºC'),
	(243468, 118, '2014-03-15 01:08:35.000000', 'temperatura', 877.0000, 'ºC'),
	(243469, 118, '2014-03-15 01:08:36.000000', 'temperatura', 282.0000, 'ºC'),
	(243470, 118, '2014-03-15 01:08:37.000000', 'temperatura', 1179.0000, 'ºC'),
	(243471, 118, '2014-03-15 01:08:38.000000', 'temperatura', 248.0000, 'ºC'),
	(243472, 118, '2014-03-15 01:08:39.000000', 'temperatura', 105.0000, 'ºC'),
	(243473, 118, '2014-03-15 01:08:40.000000', 'temperatura', 981.0000, 'ºC'),
	(243474, 118, '2014-03-15 01:08:41.000000', 'temperatura', 989.0000, 'ºC'),
	(243475, 118, '2014-03-15 01:08:42.000000', 'temperatura', 804.0000, 'ºC'),
	(243476, 118, '2014-03-15 01:08:43.000000', 'temperatura', 1052.0000, 'ºC'),
	(243477, 118, '2014-03-15 01:08:44.000000', 'temperatura', 449.0000, 'ºC'),
	(243478, 118, '2014-03-15 01:08:45.000000', 'temperatura', 289.0000, 'ºC'),
	(243479, 118, '2014-03-15 01:08:46.000000', 'temperatura', 101.0000, 'ºC'),
	(243480, 118, '2014-03-15 01:08:47.000000', 'temperatura', 837.0000, 'ºC'),
	(243481, 118, '2014-03-15 01:08:48.000000', 'temperatura', 281.0000, 'ºC'),
	(243482, 118, '2014-03-15 01:08:49.000000', 'temperatura', 94.0000, 'ºC'),
	(243483, 118, '2014-03-15 01:08:50.000000', 'temperatura', 829.0000, 'ºC'),
	(243484, 118, '2014-03-15 01:08:51.000000', 'temperatura', 262.0000, 'ºC'),
	(243485, 118, '2014-03-15 01:08:52.000000', 'temperatura', 26.0000, 'ºC'),
	(243486, 118, '2014-03-15 01:08:53.000000', 'temperatura', 543.0000, 'ºC'),
	(243487, 118, '2014-03-15 01:08:54.000000', 'temperatura', 238.0000, 'ºC'),
	(243488, 118, '2014-03-15 01:08:55.000000', 'temperatura', 760.0000, 'ºC'),
	(243489, 118, '2014-03-15 01:08:56.000000', 'temperatura', 690.0000, 'ºC'),
	(243490, 118, '2014-03-15 01:08:57.000000', 'temperatura', 1167.0000, 'ºC'),
	(243491, 118, '2014-03-15 01:08:58.000000', 'temperatura', 165.0000, 'ºC'),
	(243492, 118, '2014-03-15 01:08:59.000000', 'temperatura', 925.0000, 'ºC'),
	(243493, 118, '2014-03-15 01:09:00.000000', 'temperatura', 530.0000, 'ºC'),
	(243494, 118, '2014-03-15 01:09:01.000000', 'temperatura', 1077.0000, 'ºC'),
	(243495, 118, '2014-03-15 01:09:02.000000', 'temperatura', 193.0000, 'ºC'),
	(243496, 118, '2014-03-15 01:09:03.000000', 'temperatura', 136.0000, 'ºC'),
	(243497, 118, '2014-03-15 01:09:04.000000', 'temperatura', 100.0000, 'ºC'),
	(243498, 118, '2014-03-15 01:09:05.000000', 'temperatura', 94.0000, 'ºC'),
	(243499, 118, '2014-03-15 01:09:06.000000', 'temperatura', 171.0000, 'ºC'),
	(243500, 118, '2014-03-15 01:09:07.000000', 'temperatura', 572.0000, 'ºC'),
	(243501, 118, '2014-03-15 01:09:08.000000', 'temperatura', 1149.0000, 'ºC'),
	(243502, 118, '2014-03-15 01:09:09.000000', 'temperatura', 428.0000, 'ºC'),
	(243503, 118, '2014-03-15 01:09:10.000000', 'temperatura', 1095.0000, 'ºC'),
	(243504, 118, '2014-03-15 01:09:11.000000', 'temperatura', 590.0000, 'ºC'),
	(243505, 118, '2014-03-15 01:09:12.000000', 'temperatura', 865.0000, 'ºC'),
	(243506, 118, '2014-03-15 01:09:13.000000', 'temperatura', 157.0000, 'ºC'),
	(243507, 118, '2014-03-15 01:09:14.000000', 'temperatura', 590.0000, 'ºC'),
	(243508, 118, '2014-03-15 01:09:15.000000', 'temperatura', 80.0000, 'ºC'),
	(243509, 118, '2014-03-15 01:09:16.000000', 'temperatura', 1030.0000, 'ºC'),
	(243510, 118, '2014-03-15 01:09:17.000000', 'temperatura', 112.0000, 'ºC'),
	(243511, 118, '2014-03-15 01:09:18.000000', 'temperatura', 1070.0000, 'ºC'),
	(243512, 118, '2014-03-15 01:09:19.000000', 'temperatura', 214.0000, 'ºC'),
	(243513, 118, '2014-03-15 01:09:20.000000', 'temperatura', 261.0000, 'ºC'),
	(243514, 118, '2014-03-15 01:09:21.000000', 'temperatura', 662.0000, 'ºC'),
	(243515, 118, '2014-03-15 01:09:22.000000', 'temperatura', 130.0000, 'ºC'),
	(243516, 118, '2014-03-15 01:09:23.000000', 'temperatura', 1065.0000, 'ºC'),
	(243517, 118, '2014-03-15 01:09:24.000000', 'temperatura', 133.0000, 'ºC'),
	(243518, 118, '2014-03-15 01:09:25.000000', 'temperatura', 1071.0000, 'ºC'),
	(243519, 118, '2014-03-15 01:09:26.000000', 'temperatura', 156.0000, 'ºC'),
	(243520, 118, '2014-03-15 01:09:27.000000', 'temperatura', 1170.0000, 'ºC'),
	(243521, 118, '2014-03-15 01:09:28.000000', 'temperatura', 579.0000, 'ºC'),
	(243522, 118, '2014-03-15 01:09:29.000000', 'temperatura', 588.0000, 'ºC'),
	(243523, 118, '2014-03-15 01:09:30.000000', 'temperatura', 4.0000, 'ºC'),
	(243524, 118, '2014-03-15 01:09:31.000000', 'temperatura', 654.0000, 'ºC'),
	(243525, 118, '2014-03-15 01:09:32.000000', 'temperatura', 858.0000, 'ºC'),
	(243526, 118, '2014-03-15 01:09:33.000000', 'temperatura', 1130.0000, 'ºC'),
	(243527, 118, '2014-03-15 01:09:34.000000', 'temperatura', 675.0000, 'ºC'),
	(243528, 118, '2014-03-15 01:09:35.000000', 'temperatura', 1188.0000, 'ºC'),
	(243529, 118, '2014-03-15 01:09:36.000000', 'temperatura', 312.0000, 'ºC'),
	(243530, 118, '2014-03-15 01:09:37.000000', 'temperatura', 400.0000, 'ºC'),
	(243531, 118, '2014-03-15 01:09:38.000000', 'temperatura', 1062.0000, 'ºC'),
	(243532, 118, '2014-03-15 01:09:39.000000', 'temperatura', 511.0000, 'ºC'),
	(243533, 118, '2014-03-15 01:09:40.000000', 'temperatura', 568.0000, 'ºC'),
	(243534, 118, '2014-03-15 01:09:41.000000', 'temperatura', 110.0000, 'ºC'),
	(243535, 118, '2014-03-15 01:09:42.000000', 'temperatura', 44.0000, 'ºC'),
	(243536, 118, '2014-03-15 01:09:43.000000', 'temperatura', 1090.0000, 'ºC'),
	(243537, 118, '2014-03-15 01:09:44.000000', 'temperatura', 521.0000, 'ºC'),
	(243538, 118, '2014-03-15 01:09:45.000000', 'temperatura', 537.0000, 'ºC'),
	(243539, 118, '2014-03-15 01:09:46.000000', 'temperatura', 1119.0000, 'ºC'),
	(243540, 118, '2014-03-15 01:09:47.000000', 'temperatura', 386.0000, 'ºC'),
	(243541, 118, '2014-03-15 01:09:48.000000', 'temperatura', 972.0000, 'ºC'),
	(243542, 118, '2014-03-15 01:09:49.000000', 'temperatura', 102.0000, 'ºC'),
	(243543, 118, '2014-03-15 01:09:50.000000', 'temperatura', 1195.0000, 'ºC'),
	(243544, 118, '2014-03-15 01:09:51.000000', 'temperatura', 870.0000, 'ºC'),
	(243545, 118, '2014-03-15 01:09:52.000000', 'temperatura', 765.0000, 'ºC'),
	(243546, 118, '2014-03-15 01:09:53.000000', 'temperatura', 17.0000, 'ºC'),
	(243547, 118, '2014-03-15 01:09:54.000000', 'temperatura', 190.0000, 'ºC'),
	(243548, 118, '2014-03-15 01:09:55.000000', 'temperatura', 897.0000, 'ºC'),
	(243549, 118, '2014-03-15 01:09:56.000000', 'temperatura', 319.0000, 'ºC'),
	(243550, 118, '2014-03-15 01:09:57.000000', 'temperatura', 101.0000, 'ºC'),
	(243551, 118, '2014-03-15 01:09:58.000000', 'temperatura', 752.0000, 'ºC'),
	(243552, 118, '2014-03-15 01:09:59.000000', 'temperatura', 1057.0000, 'ºC'),
	(243553, 118, '2014-03-15 01:10:00.000000', 'temperatura', 627.0000, 'ºC'),
	(243554, 118, '2014-03-15 01:10:01.000000', 'temperatura', 1166.0000, 'ºC'),
	(243555, 118, '2014-03-15 01:10:02.000000', 'temperatura', 348.0000, 'ºC'),
	(243556, 118, '2014-03-15 01:10:03.000000', 'temperatura', 642.0000, 'ºC'),
	(243557, 118, '2014-03-15 01:10:04.000000', 'temperatura', 966.0000, 'ºC'),
	(243558, 118, '2014-03-15 01:10:05.000000', 'temperatura', 504.0000, 'ºC'),
	(243559, 118, '2014-03-15 01:10:06.000000', 'temperatura', 824.0000, 'ºC'),
	(243560, 118, '2014-03-15 01:10:07.000000', 'temperatura', 209.0000, 'ºC'),
	(243561, 118, '2014-03-15 01:10:08.000000', 'temperatura', 972.0000, 'ºC'),
	(243562, 118, '2014-03-15 01:10:09.000000', 'temperatura', 633.0000, 'ºC'),
	(243563, 118, '2014-03-15 01:10:10.000000', 'temperatura', 250.0000, 'ºC'),
	(243564, 118, '2014-03-15 01:10:11.000000', 'temperatura', 552.0000, 'ºC'),
	(243565, 118, '2014-03-15 01:10:12.000000', 'temperatura', 809.0000, 'ºC'),
	(243566, 118, '2014-03-15 01:10:13.000000', 'temperatura', 1191.0000, 'ºC'),
	(243567, 118, '2014-03-15 01:10:14.000000', 'temperatura', 1127.0000, 'ºC'),
	(243568, 118, '2014-03-15 01:10:15.000000', 'temperatura', 865.0000, 'ºC'),
	(243569, 118, '2014-03-15 01:10:16.000000', 'temperatura', 945.0000, 'ºC'),
	(243570, 118, '2014-03-15 01:10:17.000000', 'temperatura', 929.0000, 'ºC'),
	(243571, 118, '2014-03-15 01:10:18.000000', 'temperatura', 613.0000, 'ºC'),
	(243572, 118, '2014-03-15 01:10:19.000000', 'temperatura', 276.0000, 'ºC'),
	(243573, 118, '2014-03-15 01:10:20.000000', 'temperatura', 742.0000, 'ºC'),
	(243574, 118, '2014-03-15 01:10:21.000000', 'temperatura', 481.0000, 'ºC'),
	(243575, 118, '2014-03-15 01:10:22.000000', 'temperatura', 179.0000, 'ºC'),
	(243576, 118, '2014-03-15 01:10:23.000000', 'temperatura', 652.0000, 'ºC'),
	(243577, 118, '2014-03-15 01:10:24.000000', 'temperatura', 323.0000, 'ºC'),
	(243578, 118, '2014-03-15 01:10:25.000000', 'temperatura', 861.0000, 'ºC'),
	(243579, 118, '2014-03-15 01:10:26.000000', 'temperatura', 937.0000, 'ºC'),
	(243580, 118, '2014-03-15 01:10:27.000000', 'temperatura', 900.0000, 'ºC'),
	(243581, 118, '2014-03-15 01:10:28.000000', 'temperatura', 491.0000, 'ºC'),
	(243582, 118, '2014-03-15 01:10:29.000000', 'temperatura', 955.0000, 'ºC'),
	(243583, 118, '2014-03-15 01:10:30.000000', 'temperatura', 904.0000, 'ºC'),
	(243584, 118, '2014-03-15 01:10:31.000000', 'temperatura', 456.0000, 'ºC'),
	(243585, 118, '2014-03-15 01:10:32.000000', 'temperatura', 768.0000, 'ºC'),
	(243586, 118, '2014-03-15 01:10:33.000000', 'temperatura', 74.0000, 'ºC'),
	(243587, 118, '2014-03-15 01:10:34.000000', 'temperatura', 466.0000, 'ºC'),
	(243588, 118, '2014-03-15 01:10:35.000000', 'temperatura', 906.0000, 'ºC'),
	(243589, 118, '2014-03-15 01:10:36.000000', 'temperatura', 734.0000, 'ºC'),
	(243590, 118, '2014-03-15 01:10:37.000000', 'temperatura', 953.0000, 'ºC'),
	(243591, 118, '2014-03-15 01:10:38.000000', 'temperatura', 162.0000, 'ºC'),
	(243592, 118, '2014-03-15 01:10:39.000000', 'temperatura', 351.0000, 'ºC'),
	(243593, 118, '2014-03-15 01:10:40.000000', 'temperatura', 71.0000, 'ºC'),
	(243594, 118, '2014-03-15 01:10:41.000000', 'temperatura', 500.0000, 'ºC'),
	(243595, 118, '2014-03-15 01:10:42.000000', 'temperatura', 1090.0000, 'ºC'),
	(243596, 118, '2014-03-15 01:10:43.000000', 'temperatura', 351.0000, 'ºC'),
	(243597, 118, '2014-03-15 01:10:44.000000', 'temperatura', 886.0000, 'ºC'),
	(243598, 118, '2014-03-15 01:10:45.000000', 'temperatura', 975.0000, 'ºC'),
	(243599, 118, '2014-03-15 01:10:46.000000', 'temperatura', 1020.0000, 'ºC'),
	(243600, 118, '2014-03-15 01:10:47.000000', 'temperatura', 974.0000, 'ºC'),
	(243601, 118, '2014-03-15 01:10:48.000000', 'temperatura', 612.0000, 'ºC'),
	(243602, 118, '2014-03-15 01:10:49.000000', 'temperatura', 138.0000, 'ºC'),
	(243603, 118, '2014-03-15 01:10:50.000000', 'temperatura', 55.0000, 'ºC'),
	(243604, 118, '2014-03-15 01:10:51.000000', 'temperatura', 1060.0000, 'ºC'),
	(243605, 118, '2014-03-15 01:10:52.000000', 'temperatura', 335.0000, 'ºC'),
	(243606, 119, '2014-03-15 00:00:00.000000', 'temperatura', 1081.0000, 'ºC'),
	(243607, 119, '2014-03-15 00:00:01.000000', 'temperatura', 312.0000, 'ºC'),
	(243608, 119, '2014-03-15 00:00:02.000000', 'temperatura', 721.0000, 'ºC'),
	(243609, 119, '2014-03-15 00:00:03.000000', 'temperatura', 266.0000, 'ºC'),
	(243610, 119, '2014-03-15 00:00:04.000000', 'temperatura', 370.0000, 'ºC'),
	(243611, 119, '2014-03-15 00:00:05.000000', 'temperatura', 1053.0000, 'ºC'),
	(243612, 119, '2014-03-15 00:00:06.000000', 'temperatura', 554.0000, 'ºC'),
	(243613, 119, '2014-03-15 00:00:07.000000', 'temperatura', 814.0000, 'ºC'),
	(243614, 119, '2014-03-15 00:00:08.000000', 'temperatura', 7.0000, 'ºC'),
	(243615, 119, '2014-03-15 00:00:09.000000', 'temperatura', 1193.0000, 'ºC'),
	(243616, 119, '2014-03-15 00:00:10.000000', 'temperatura', 1145.0000, 'ºC'),
	(243617, 119, '2014-03-15 00:00:11.000000', 'temperatura', 948.0000, 'ºC'),
	(243618, 119, '2014-03-15 00:00:12.000000', 'temperatura', 102.0000, 'ºC'),
	(243619, 119, '2014-03-15 00:00:13.000000', 'temperatura', 70.0000, 'ºC'),
	(243620, 119, '2014-03-15 00:00:14.000000', 'temperatura', 43.0000, 'ºC'),
	(243621, 119, '2014-03-15 00:00:15.000000', 'temperatura', 5.0000, 'ºC'),
	(243622, 119, '2014-03-15 00:00:16.000000', 'temperatura', 1098.0000, 'ºC'),
	(243623, 119, '2014-03-15 00:00:17.000000', 'temperatura', 673.0000, 'ºC'),
	(243624, 119, '2014-03-15 00:00:18.000000', 'temperatura', 74.0000, 'ºC'),
	(243625, 119, '2014-03-15 00:00:19.000000', 'temperatura', 750.0000, 'ºC'),
	(243626, 119, '2014-03-15 00:00:20.000000', 'temperatura', 1130.0000, 'ºC'),
	(243627, 119, '2014-03-15 00:00:21.000000', 'temperatura', 1000.0000, 'ºC'),
	(243628, 119, '2014-03-15 00:00:22.000000', 'temperatura', 408.0000, 'ºC'),
	(243629, 119, '2014-03-15 00:00:23.000000', 'temperatura', 244.0000, 'ºC'),
	(243630, 119, '2014-03-15 00:00:24.000000', 'temperatura', 1195.0000, 'ºC'),
	(243631, 119, '2014-03-15 00:00:25.000000', 'temperatura', 443.0000, 'ºC'),
	(243632, 119, '2014-03-15 00:00:26.000000', 'temperatura', 1031.0000, 'ºC'),
	(243633, 119, '2014-03-15 00:00:27.000000', 'temperatura', 227.0000, 'ºC'),
	(243634, 119, '2014-03-15 00:00:28.000000', 'temperatura', 441.0000, 'ºC'),
	(243635, 119, '2014-03-15 00:00:29.000000', 'temperatura', 324.0000, 'ºC'),
	(243636, 119, '2014-03-15 00:00:30.000000', 'temperatura', 300.0000, 'ºC'),
	(243637, 119, '2014-03-15 00:00:31.000000', 'temperatura', 529.0000, 'ºC'),
	(243638, 119, '2014-03-15 00:00:32.000000', 'temperatura', 544.0000, 'ºC'),
	(243639, 119, '2014-03-15 00:00:33.000000', 'temperatura', 1135.0000, 'ºC'),
	(243640, 119, '2014-03-15 00:00:34.000000', 'temperatura', 441.0000, 'ºC'),
	(243641, 119, '2014-03-15 00:00:35.000000', 'temperatura', 2.0000, 'ºC'),
	(243642, 119, '2014-03-15 00:00:36.000000', 'temperatura', 1087.0000, 'ºC'),
	(243643, 119, '2014-03-15 00:00:37.000000', 'temperatura', 629.0000, 'ºC'),
	(243644, 119, '2014-03-15 00:00:38.000000', 'temperatura', 1086.0000, 'ºC'),
	(243645, 119, '2014-03-15 00:00:39.000000', 'temperatura', 1144.0000, 'ºC'),
	(243646, 119, '2014-03-15 00:00:40.000000', 'temperatura', 60.0000, 'ºC'),
	(243647, 119, '2014-03-15 00:00:41.000000', 'temperatura', 469.0000, 'ºC'),
	(243648, 119, '2014-03-15 00:00:42.000000', 'temperatura', 965.0000, 'ºC'),
	(243649, 119, '2014-03-15 00:00:43.000000', 'temperatura', 1021.0000, 'ºC'),
	(243650, 119, '2014-03-15 00:00:44.000000', 'temperatura', 1008.0000, 'ºC'),
	(243651, 119, '2014-03-15 00:00:45.000000', 'temperatura', 776.0000, 'ºC'),
	(243652, 119, '2014-03-15 00:00:46.000000', 'temperatura', 859.0000, 'ºC'),
	(243653, 119, '2014-03-15 00:00:47.000000', 'temperatura', 769.0000, 'ºC'),
	(243654, 119, '2014-03-15 00:00:48.000000', 'temperatura', 66.0000, 'ºC'),
	(243655, 119, '2014-03-15 00:00:49.000000', 'temperatura', 425.0000, 'ºC'),
	(243656, 119, '2014-03-15 00:00:50.000000', 'temperatura', 728.0000, 'ºC'),
	(243657, 119, '2014-03-15 00:00:51.000000', 'temperatura', 1163.0000, 'ºC'),
	(243658, 119, '2014-03-15 00:00:52.000000', 'temperatura', 33.0000, 'ºC'),
	(243659, 119, '2014-03-15 00:00:53.000000', 'temperatura', 278.0000, 'ºC'),
	(243660, 119, '2014-03-15 00:00:54.000000', 'temperatura', 89.0000, 'ºC'),
	(243661, 119, '2014-03-15 00:00:55.000000', 'temperatura', 811.0000, 'ºC'),
	(243662, 119, '2014-03-15 00:00:56.000000', 'temperatura', 188.0000, 'ºC'),
	(243663, 119, '2014-03-15 00:00:57.000000', 'temperatura', 910.0000, 'ºC'),
	(243664, 119, '2014-03-15 00:00:58.000000', 'temperatura', 386.0000, 'ºC'),
	(243665, 119, '2014-03-15 00:00:59.000000', 'temperatura', 401.0000, 'ºC'),
	(243666, 119, '2014-03-15 00:01:00.000000', 'temperatura', 849.0000, 'ºC'),
	(243667, 119, '2014-03-15 00:01:01.000000', 'temperatura', 640.0000, 'ºC'),
	(243668, 119, '2014-03-15 00:01:02.000000', 'temperatura', 655.0000, 'ºC'),
	(243669, 119, '2014-03-15 00:01:03.000000', 'temperatura', 156.0000, 'ºC'),
	(243670, 119, '2014-03-15 00:01:04.000000', 'temperatura', 14.0000, 'ºC'),
	(243671, 119, '2014-03-15 00:01:05.000000', 'temperatura', 804.0000, 'ºC'),
	(243672, 119, '2014-03-15 00:01:06.000000', 'temperatura', 378.0000, 'ºC'),
	(243673, 119, '2014-03-15 00:01:07.000000', 'temperatura', 679.0000, 'ºC'),
	(243674, 119, '2014-03-15 00:01:08.000000', 'temperatura', 1061.0000, 'ºC'),
	(243675, 119, '2014-03-15 00:01:09.000000', 'temperatura', 868.0000, 'ºC'),
	(243676, 119, '2014-03-15 00:01:10.000000', 'temperatura', 1158.0000, 'ºC'),
	(243677, 119, '2014-03-15 00:01:11.000000', 'temperatura', 784.0000, 'ºC'),
	(243678, 119, '2014-03-15 00:01:12.000000', 'temperatura', 450.0000, 'ºC'),
	(243679, 119, '2014-03-15 00:01:13.000000', 'temperatura', 1096.0000, 'ºC'),
	(243680, 119, '2014-03-15 00:01:14.000000', 'temperatura', 533.0000, 'ºC'),
	(243681, 119, '2014-03-15 00:01:15.000000', 'temperatura', 578.0000, 'ºC'),
	(243682, 119, '2014-03-15 00:01:16.000000', 'temperatura', 90.0000, 'ºC'),
	(243683, 119, '2014-03-15 00:01:17.000000', 'temperatura', 1116.0000, 'ºC'),
	(243684, 119, '2014-03-15 00:01:18.000000', 'temperatura', 512.0000, 'ºC'),
	(243685, 119, '2014-03-15 00:01:19.000000', 'temperatura', 411.0000, 'ºC'),
	(243686, 119, '2014-03-15 00:01:20.000000', 'temperatura', 519.0000, 'ºC'),
	(243687, 119, '2014-03-15 00:01:21.000000', 'temperatura', 164.0000, 'ºC'),
	(243688, 119, '2014-03-15 00:01:22.000000', 'temperatura', 463.0000, 'ºC'),
	(243689, 119, '2014-03-15 00:01:23.000000', 'temperatura', 624.0000, 'ºC'),
	(243690, 119, '2014-03-15 00:01:24.000000', 'temperatura', 532.0000, 'ºC'),
	(243691, 119, '2014-03-15 00:01:25.000000', 'temperatura', 789.0000, 'ºC'),
	(243692, 119, '2014-03-15 00:01:26.000000', 'temperatura', 1148.0000, 'ºC'),
	(243693, 119, '2014-03-15 00:01:27.000000', 'temperatura', 975.0000, 'ºC'),
	(243694, 119, '2014-03-15 00:01:28.000000', 'temperatura', 231.0000, 'ºC'),
	(243695, 119, '2014-03-15 00:01:29.000000', 'temperatura', 631.0000, 'ºC'),
	(243696, 119, '2014-03-15 00:01:30.000000', 'temperatura', 63.0000, 'ºC'),
	(243697, 119, '2014-03-15 00:01:31.000000', 'temperatura', 823.0000, 'ºC'),
	(243698, 119, '2014-03-15 00:01:32.000000', 'temperatura', 328.0000, 'ºC'),
	(243699, 119, '2014-03-15 00:01:33.000000', 'temperatura', 368.0000, 'ºC'),
	(243700, 119, '2014-03-15 00:01:34.000000', 'temperatura', 858.0000, 'ºC'),
	(243701, 119, '2014-03-15 00:01:35.000000', 'temperatura', 785.0000, 'ºC'),
	(243702, 119, '2014-03-15 00:01:36.000000', 'temperatura', 151.0000, 'ºC'),
	(243703, 119, '2014-03-15 00:01:37.000000', 'temperatura', 802.0000, 'ºC'),
	(243704, 119, '2014-03-15 00:01:38.000000', 'temperatura', 1157.0000, 'ºC'),
	(243705, 119, '2014-03-15 00:01:39.000000', 'temperatura', 978.0000, 'ºC'),
	(243706, 119, '2014-03-15 00:01:40.000000', 'temperatura', 222.0000, 'ºC'),
	(243707, 119, '2014-03-15 00:01:41.000000', 'temperatura', 573.0000, 'ºC'),
	(243708, 119, '2014-03-15 00:01:42.000000', 'temperatura', 1003.0000, 'ºC'),
	(243709, 119, '2014-03-15 00:01:43.000000', 'temperatura', 896.0000, 'ºC'),
	(243710, 119, '2014-03-15 00:01:44.000000', 'temperatura', 273.0000, 'ºC'),
	(243711, 119, '2014-03-15 00:01:45.000000', 'temperatura', 1076.0000, 'ºC'),
	(243712, 119, '2014-03-15 00:01:46.000000', 'temperatura', 963.0000, 'ºC'),
	(243713, 119, '2014-03-15 00:01:47.000000', 'temperatura', 385.0000, 'ºC'),
	(243714, 119, '2014-03-15 00:01:48.000000', 'temperatura', 236.0000, 'ºC'),
	(243715, 119, '2014-03-15 00:01:49.000000', 'temperatura', 25.0000, 'ºC'),
	(243716, 119, '2014-03-15 00:01:50.000000', 'temperatura', 618.0000, 'ºC'),
	(243717, 119, '2014-03-15 00:01:51.000000', 'temperatura', 615.0000, 'ºC'),
	(243718, 119, '2014-03-15 00:01:52.000000', 'temperatura', 22.0000, 'ºC'),
	(243719, 119, '2014-03-15 00:01:53.000000', 'temperatura', 665.0000, 'ºC'),
	(243720, 119, '2014-03-15 00:01:54.000000', 'temperatura', 859.0000, 'ºC'),
	(243721, 119, '2014-03-15 00:01:55.000000', 'temperatura', 1103.0000, 'ºC'),
	(243722, 119, '2014-03-15 00:01:56.000000', 'temperatura', 536.0000, 'ºC'),
	(243723, 119, '2014-03-15 00:01:57.000000', 'temperatura', 572.0000, 'ºC'),
	(243724, 119, '2014-03-15 00:01:58.000000', 'temperatura', 54.0000, 'ºC'),
	(243725, 119, '2014-03-15 00:01:59.000000', 'temperatura', 953.0000, 'ºC'),
	(243726, 119, '2014-03-15 00:02:00.000000', 'temperatura', 1006.0000, 'ºC'),
	(243727, 119, '2014-03-15 00:02:01.000000', 'temperatura', 969.0000, 'ºC'),
	(243728, 119, '2014-03-15 00:02:02.000000', 'temperatura', 629.0000, 'ºC'),
	(243729, 119, '2014-03-15 00:02:03.000000', 'temperatura', 239.0000, 'ºC'),
	(243730, 119, '2014-03-15 00:02:04.000000', 'temperatura', 508.0000, 'ºC'),
	(243731, 119, '2014-03-15 00:02:05.000000', 'temperatura', 622.0000, 'ºC'),
	(243732, 119, '2014-03-15 00:02:06.000000', 'temperatura', 387.0000, 'ºC'),
	(243733, 119, '2014-03-15 00:02:07.000000', 'temperatura', 69.0000, 'ºC'),
	(243734, 119, '2014-03-15 00:02:08.000000', 'temperatura', 383.0000, 'ºC'),
	(243735, 119, '2014-03-15 00:02:09.000000', 'temperatura', 510.0000, 'ºC'),
	(243736, 119, '2014-03-15 00:02:10.000000', 'temperatura', 203.0000, 'ºC'),
	(243737, 119, '2014-03-15 00:02:11.000000', 'temperatura', 685.0000, 'ºC'),
	(243738, 119, '2014-03-15 00:02:12.000000', 'temperatura', 415.0000, 'ºC'),
	(243739, 119, '2014-03-15 00:02:13.000000', 'temperatura', 23.0000, 'ºC'),
	(243740, 119, '2014-03-15 00:02:14.000000', 'temperatura', 68.0000, 'ºC'),
	(243741, 119, '2014-03-15 00:02:15.000000', 'temperatura', 274.0000, 'ºC'),
	(243742, 119, '2014-03-15 00:02:16.000000', 'temperatura', 1165.0000, 'ºC'),
	(243743, 119, '2014-03-15 00:02:17.000000', 'temperatura', 204.0000, 'ºC'),
	(243744, 119, '2014-03-15 00:02:18.000000', 'temperatura', 1125.0000, 'ºC'),
	(243745, 119, '2014-03-15 00:02:19.000000', 'temperatura', 215.0000, 'ºC'),
	(243746, 119, '2014-03-15 00:02:20.000000', 'temperatura', 100.0000, 'ºC'),
	(243747, 119, '2014-03-15 00:02:21.000000', 'temperatura', 1054.0000, 'ºC'),
	(243748, 119, '2014-03-15 00:02:22.000000', 'temperatura', 172.0000, 'ºC'),
	(243749, 119, '2014-03-15 00:02:23.000000', 'temperatura', 98.0000, 'ºC'),
	(243750, 119, '2014-03-15 00:02:24.000000', 'temperatura', 1176.0000, 'ºC'),
	(243751, 119, '2014-03-15 00:02:25.000000', 'temperatura', 785.0000, 'ºC'),
	(243752, 119, '2014-03-15 00:02:26.000000', 'temperatura', 398.0000, 'ºC'),
	(243753, 119, '2014-03-15 00:02:27.000000', 'temperatura', 835.0000, 'ºC'),
	(243754, 119, '2014-03-15 00:02:28.000000', 'temperatura', 583.0000, 'ºC'),
	(243755, 119, '2014-03-15 00:02:29.000000', 'temperatura', 410.0000, 'ºC'),
	(243756, 119, '2014-03-15 00:02:30.000000', 'temperatura', 302.0000, 'ºC'),
	(243757, 119, '2014-03-15 00:02:31.000000', 'temperatura', 279.0000, 'ºC'),
	(243758, 119, '2014-03-15 00:02:32.000000', 'temperatura', 489.0000, 'ºC'),
	(243759, 119, '2014-03-15 00:02:33.000000', 'temperatura', 410.0000, 'ºC'),
	(243760, 119, '2014-03-15 00:02:34.000000', 'temperatura', 582.0000, 'ºC'),
	(243761, 119, '2014-03-15 00:02:35.000000', 'temperatura', 480.0000, 'ºC'),
	(243762, 119, '2014-03-15 00:02:36.000000', 'temperatura', 657.0000, 'ºC'),
	(243763, 119, '2014-03-15 00:02:37.000000', 'temperatura', 644.0000, 'ºC'),
	(243764, 119, '2014-03-15 00:02:38.000000', 'temperatura', 48.0000, 'ºC'),
	(243765, 119, '2014-03-15 00:02:39.000000', 'temperatura', 711.0000, 'ºC'),
	(243766, 119, '2014-03-15 00:02:40.000000', 'temperatura', 1012.0000, 'ºC'),
	(243767, 119, '2014-03-15 00:02:41.000000', 'temperatura', 525.0000, 'ºC'),
	(243768, 119, '2014-03-15 00:02:42.000000', 'temperatura', 790.0000, 'ºC'),
	(243769, 119, '2014-03-15 00:02:43.000000', 'temperatura', 1177.0000, 'ºC'),
	(243770, 119, '2014-03-15 00:02:44.000000', 'temperatura', 1114.0000, 'ºC'),
	(243771, 119, '2014-03-15 00:02:45.000000', 'temperatura', 839.0000, 'ºC'),
	(243772, 119, '2014-03-15 00:02:46.000000', 'temperatura', 853.0000, 'ºC'),
	(243773, 119, '2014-03-15 00:02:47.000000', 'temperatura', 548.0000, 'ºC'),
	(243774, 119, '2014-03-15 00:02:48.000000', 'temperatura', 184.0000, 'ºC'),
	(243775, 119, '2014-03-15 00:02:49.000000', 'temperatura', 474.0000, 'ºC'),
	(243776, 119, '2014-03-15 00:02:50.000000', 'temperatura', 620.0000, 'ºC'),
	(243777, 119, '2014-03-15 00:02:51.000000', 'temperatura', 478.0000, 'ºC'),
	(243778, 119, '2014-03-15 00:02:52.000000', 'temperatura', 532.0000, 'ºC'),
	(243779, 119, '2014-03-15 00:02:53.000000', 'temperatura', 25.0000, 'ºC'),
	(243780, 119, '2014-03-15 00:02:54.000000', 'temperatura', 931.0000, 'ºC'),
	(243781, 119, '2014-03-15 00:02:55.000000', 'temperatura', 981.0000, 'ºC'),
	(243782, 119, '2014-03-15 00:02:56.000000', 'temperatura', 910.0000, 'ºC'),
	(243783, 119, '2014-03-15 00:02:57.000000', 'temperatura', 408.0000, 'ºC'),
	(243784, 119, '2014-03-15 00:02:58.000000', 'temperatura', 512.0000, 'ºC'),
	(243785, 119, '2014-03-15 00:02:59.000000', 'temperatura', 136.0000, 'ºC'),
	(243786, 119, '2014-03-15 00:03:00.000000', 'temperatura', 343.0000, 'ºC'),
	(243787, 119, '2014-03-15 00:03:01.000000', 'temperatura', 107.0000, 'ºC'),
	(243788, 119, '2014-03-15 00:03:02.000000', 'temperatura', 706.0000, 'ºC'),
	(243789, 119, '2014-03-15 00:03:03.000000', 'temperatura', 810.0000, 'ºC'),
	(243790, 119, '2014-03-15 00:03:04.000000', 'temperatura', 732.0000, 'ºC'),
	(243791, 119, '2014-03-15 00:03:05.000000', 'temperatura', 30.0000, 'ºC'),
	(243792, 119, '2014-03-15 00:03:06.000000', 'temperatura', 356.0000, 'ºC'),
	(243793, 119, '2014-03-15 00:03:07.000000', 'temperatura', 489.0000, 'ºC'),
	(243794, 119, '2014-03-15 00:03:08.000000', 'temperatura', 178.0000, 'ºC'),
	(243795, 119, '2014-03-15 00:03:09.000000', 'temperatura', 623.0000, 'ºC'),
	(243796, 119, '2014-03-15 00:03:10.000000', 'temperatura', 184.0000, 'ºC'),
	(243797, 119, '2014-03-15 00:03:11.000000', 'temperatura', 250.0000, 'ºC'),
	(243798, 119, '2014-03-15 00:03:12.000000', 'temperatura', 697.0000, 'ºC'),
	(243799, 119, '2014-03-15 00:03:13.000000', 'temperatura', 338.0000, 'ºC'),
	(243800, 119, '2014-03-15 00:03:14.000000', 'temperatura', 798.0000, 'ºC'),
	(243801, 119, '2014-03-15 00:03:15.000000', 'temperatura', 576.0000, 'ºC'),
	(243802, 119, '2014-03-15 00:03:16.000000', 'temperatura', 488.0000, 'ºC'),
	(243803, 119, '2014-03-15 00:03:17.000000', 'temperatura', 711.0000, 'ºC'),
	(243804, 119, '2014-03-15 00:03:18.000000', 'temperatura', 892.0000, 'ºC'),
	(243805, 119, '2014-03-15 00:03:19.000000', 'temperatura', 1129.0000, 'ºC'),
	(243806, 119, '2014-03-15 00:03:20.000000', 'temperatura', 569.0000, 'ºC'),
	(243807, 119, '2014-03-15 00:03:21.000000', 'temperatura', 656.0000, 'ºC'),
	(243808, 119, '2014-03-15 00:03:22.000000', 'temperatura', 376.0000, 'ºC'),
	(243809, 119, '2014-03-15 00:03:23.000000', 'temperatura', 1111.0000, 'ºC'),
	(243810, 119, '2014-03-15 00:03:24.000000', 'temperatura', 826.0000, 'ºC'),
	(243811, 119, '2014-03-15 00:03:25.000000', 'temperatura', 800.0000, 'ºC'),
	(243812, 119, '2014-03-15 00:03:26.000000', 'temperatura', 323.0000, 'ºC'),
	(243813, 119, '2014-03-15 00:03:27.000000', 'temperatura', 416.0000, 'ºC'),
	(243814, 119, '2014-03-15 00:03:28.000000', 'temperatura', 1112.0000, 'ºC'),
	(243815, 119, '2014-03-15 00:03:29.000000', 'temperatura', 713.0000, 'ºC'),
	(243816, 119, '2014-03-15 00:03:30.000000', 'temperatura', 227.0000, 'ºC'),
	(243817, 119, '2014-03-15 00:03:31.000000', 'temperatura', 200.0000, 'ºC'),
	(243818, 119, '2014-03-15 00:03:32.000000', 'temperatura', 316.0000, 'ºC'),
	(243819, 119, '2014-03-15 00:03:33.000000', 'temperatura', 981.0000, 'ºC'),
	(243820, 119, '2014-03-15 00:03:34.000000', 'temperatura', 359.0000, 'ºC'),
	(243821, 119, '2014-03-15 00:03:35.000000', 'temperatura', 54.0000, 'ºC'),
	(243822, 119, '2014-03-15 00:03:36.000000', 'temperatura', 392.0000, 'ºC'),
	(243823, 119, '2014-03-15 00:03:37.000000', 'temperatura', 596.0000, 'ºC'),
	(243824, 119, '2014-03-15 00:03:38.000000', 'temperatura', 608.0000, 'ºC'),
	(243825, 119, '2014-03-15 00:03:39.000000', 'temperatura', 52.0000, 'ºC'),
	(243826, 119, '2014-03-15 00:03:40.000000', 'temperatura', 835.0000, 'ºC'),
	(243827, 119, '2014-03-15 00:03:41.000000', 'temperatura', 419.0000, 'ºC'),
	(243828, 119, '2014-03-15 00:03:42.000000', 'temperatura', 792.0000, 'ºC'),
	(243829, 119, '2014-03-15 00:03:43.000000', 'temperatura', 303.0000, 'ºC'),
	(243830, 119, '2014-03-15 00:03:44.000000', 'temperatura', 338.0000, 'ºC'),
	(243831, 119, '2014-03-15 00:03:45.000000', 'temperatura', 782.0000, 'ºC'),
	(243832, 119, '2014-03-15 00:03:46.000000', 'temperatura', 499.0000, 'ºC'),
	(243833, 119, '2014-03-15 00:03:47.000000', 'temperatura', 147.0000, 'ºC'),
	(243834, 119, '2014-03-15 00:03:48.000000', 'temperatura', 441.0000, 'ºC'),
	(243835, 119, '2014-03-15 00:03:49.000000', 'temperatura', 563.0000, 'ºC'),
	(243836, 119, '2014-03-15 00:03:50.000000', 'temperatura', 291.0000, 'ºC'),
	(243837, 119, '2014-03-15 00:03:51.000000', 'temperatura', 967.0000, 'ºC'),
	(243838, 119, '2014-03-15 00:03:52.000000', 'temperatura', 365.0000, 'ºC'),
	(243839, 119, '2014-03-15 00:03:53.000000', 'temperatura', 123.0000, 'ºC'),
	(243840, 119, '2014-03-15 00:03:54.000000', 'temperatura', 718.0000, 'ºC'),
	(243841, 119, '2014-03-15 00:03:55.000000', 'temperatura', 825.0000, 'ºC'),
	(243842, 119, '2014-03-15 00:03:56.000000', 'temperatura', 771.0000, 'ºC'),
	(243843, 119, '2014-03-15 00:03:57.000000', 'temperatura', 181.0000, 'ºC'),
	(243844, 119, '2014-03-15 00:03:58.000000', 'temperatura', 993.0000, 'ºC'),
	(243845, 119, '2014-03-15 00:03:59.000000', 'temperatura', 824.0000, 'ºC'),
	(243846, 119, '2014-03-15 00:04:00.000000', 'temperatura', 1139.0000, 'ºC'),
	(243847, 119, '2014-03-15 00:04:01.000000', 'temperatura', 823.0000, 'ºC'),
	(243848, 119, '2014-03-15 00:04:02.000000', 'temperatura', 701.0000, 'ºC'),
	(243849, 119, '2014-03-15 00:04:03.000000', 'temperatura', 1034.0000, 'ºC'),
	(243850, 119, '2014-03-15 00:04:04.000000', 'temperatura', 667.0000, 'ºC'),
	(243851, 119, '2014-03-15 00:04:05.000000', 'temperatura', 233.0000, 'ºC'),
	(243852, 119, '2014-03-15 00:04:06.000000', 'temperatura', 363.0000, 'ºC'),
	(243853, 119, '2014-03-15 00:04:07.000000', 'temperatura', 1120.0000, 'ºC'),
	(243854, 119, '2014-03-15 00:04:08.000000', 'temperatura', 910.0000, 'ºC'),
	(243855, 119, '2014-03-15 00:04:09.000000', 'temperatura', 1191.0000, 'ºC'),
	(243856, 119, '2014-03-15 00:04:10.000000', 'temperatura', 827.0000, 'ºC'),
	(243857, 119, '2014-03-15 00:04:11.000000', 'temperatura', 560.0000, 'ºC'),
	(243858, 119, '2014-03-15 00:04:12.000000', 'temperatura', 320.0000, 'ºC'),
	(243859, 119, '2014-03-15 00:04:13.000000', 'temperatura', 1122.0000, 'ºC'),
	(243860, 119, '2014-03-15 00:04:14.000000', 'temperatura', 1049.0000, 'ºC'),
	(243861, 119, '2014-03-15 00:04:15.000000', 'temperatura', 681.0000, 'ºC'),
	(243862, 119, '2014-03-15 00:04:16.000000', 'temperatura', 259.0000, 'ºC'),
	(243863, 119, '2014-03-15 00:04:17.000000', 'temperatura', 451.0000, 'ºC'),
	(243864, 119, '2014-03-15 00:04:18.000000', 'temperatura', 279.0000, 'ºC'),
	(243865, 119, '2014-03-15 00:04:19.000000', 'temperatura', 43.0000, 'ºC'),
	(243866, 119, '2014-03-15 00:04:20.000000', 'temperatura', 579.0000, 'ºC'),
	(243867, 119, '2014-03-15 00:04:21.000000', 'temperatura', 364.0000, 'ºC'),
	(243868, 119, '2014-03-15 00:04:22.000000', 'temperatura', 85.0000, 'ºC'),
	(243869, 119, '2014-03-15 00:04:23.000000', 'temperatura', 533.0000, 'ºC'),
	(243870, 119, '2014-03-15 00:04:24.000000', 'temperatura', 12.0000, 'ºC'),
	(243871, 119, '2014-03-15 00:04:25.000000', 'temperatura', 862.0000, 'ºC'),
	(243872, 119, '2014-03-15 00:04:26.000000', 'temperatura', 674.0000, 'ºC'),
	(243873, 119, '2014-03-15 00:04:27.000000', 'temperatura', 786.0000, 'ºC'),
	(243874, 119, '2014-03-15 00:04:28.000000', 'temperatura', 706.0000, 'ºC'),
	(243875, 119, '2014-03-15 00:04:29.000000', 'temperatura', 1173.0000, 'ºC'),
	(243876, 119, '2014-03-15 00:04:30.000000', 'temperatura', 150.0000, 'ºC'),
	(243877, 119, '2014-03-15 00:04:31.000000', 'temperatura', 828.0000, 'ºC'),
	(243878, 119, '2014-03-15 00:04:32.000000', 'temperatura', 92.0000, 'ºC'),
	(243879, 119, '2014-03-15 00:04:33.000000', 'temperatura', 374.0000, 'ºC'),
	(243880, 119, '2014-03-15 00:04:34.000000', 'temperatura', 398.0000, 'ºC'),
	(243881, 119, '2014-03-15 00:04:35.000000', 'temperatura', 866.0000, 'ºC'),
	(243882, 119, '2014-03-15 00:04:36.000000', 'temperatura', 737.0000, 'ºC'),
	(243883, 119, '2014-03-15 00:04:37.000000', 'temperatura', 1086.0000, 'ºC'),
	(243884, 119, '2014-03-15 00:04:38.000000', 'temperatura', 820.0000, 'ºC'),
	(243885, 119, '2014-03-15 00:04:39.000000', 'temperatura', 842.0000, 'ºC'),
	(243886, 119, '2014-03-15 00:04:40.000000', 'temperatura', 549.0000, 'ºC'),
	(243887, 119, '2014-03-15 00:04:41.000000', 'temperatura', 222.0000, 'ºC'),
	(243888, 119, '2014-03-15 00:04:42.000000', 'temperatura', 662.0000, 'ºC'),
	(243889, 119, '2014-03-15 00:04:43.000000', 'temperatura', 244.0000, 'ºC'),
	(243890, 119, '2014-03-15 00:04:44.000000', 'temperatura', 436.0000, 'ºC'),
	(243891, 119, '2014-03-15 00:04:45.000000', 'temperatura', 248.0000, 'ºC'),
	(243892, 119, '2014-03-15 00:04:46.000000', 'temperatura', 1134.0000, 'ºC'),
	(243893, 119, '2014-03-15 00:04:47.000000', 'temperatura', 124.0000, 'ºC'),
	(243894, 119, '2014-03-15 00:04:48.000000', 'temperatura', 820.0000, 'ºC'),
	(243895, 119, '2014-03-15 00:04:49.000000', 'temperatura', 129.0000, 'ºC'),
	(243896, 119, '2014-03-15 00:04:50.000000', 'temperatura', 586.0000, 'ºC'),
	(243897, 119, '2014-03-15 00:04:51.000000', 'temperatura', 142.0000, 'ºC'),
	(243898, 119, '2014-03-15 00:04:52.000000', 'temperatura', 154.0000, 'ºC'),
	(243899, 119, '2014-03-15 00:04:53.000000', 'temperatura', 343.0000, 'ºC'),
	(243900, 119, '2014-03-15 00:04:54.000000', 'temperatura', 52.0000, 'ºC'),
	(243901, 119, '2014-03-15 00:04:55.000000', 'temperatura', 434.0000, 'ºC'),
	(243902, 119, '2014-03-15 00:04:56.000000', 'temperatura', 813.0000, 'ºC'),
	(243903, 119, '2014-03-15 00:04:57.000000', 'temperatura', 365.0000, 'ºC'),
	(243904, 119, '2014-03-15 00:04:58.000000', 'temperatura', 584.0000, 'ºC'),
	(243905, 119, '2014-03-15 00:04:59.000000', 'temperatura', 628.0000, 'ºC'),
	(243906, 119, '2014-03-15 00:05:00.000000', 'temperatura', 189.0000, 'ºC'),
	(243907, 119, '2014-03-15 00:05:01.000000', 'temperatura', 261.0000, 'ºC'),
	(243908, 119, '2014-03-15 00:05:02.000000', 'temperatura', 740.0000, 'ºC'),
	(243909, 119, '2014-03-15 00:05:03.000000', 'temperatura', 515.0000, 'ºC'),
	(243910, 119, '2014-03-15 00:05:04.000000', 'temperatura', 356.0000, 'ºC'),
	(243911, 119, '2014-03-15 00:05:05.000000', 'temperatura', 234.0000, 'ºC'),
	(243912, 119, '2014-03-15 00:05:06.000000', 'temperatura', 106.0000, 'ºC'),
	(243913, 119, '2014-03-15 00:05:07.000000', 'temperatura', 1025.0000, 'ºC'),
	(243914, 119, '2014-03-15 00:05:08.000000', 'temperatura', 8.0000, 'ºC'),
	(243915, 119, '2014-03-15 00:05:09.000000', 'temperatura', 566.0000, 'ºC'),
	(243916, 119, '2014-03-15 00:05:10.000000', 'temperatura', 405.0000, 'ºC'),
	(243917, 119, '2014-03-15 00:05:11.000000', 'temperatura', 328.0000, 'ºC'),
	(243918, 119, '2014-03-15 00:05:12.000000', 'temperatura', 425.0000, 'ºC'),
	(243919, 119, '2014-03-15 00:05:13.000000', 'temperatura', 1144.0000, 'ºC'),
	(243920, 119, '2014-03-15 00:05:14.000000', 'temperatura', 844.0000, 'ºC'),
	(243921, 119, '2014-03-15 00:05:15.000000', 'temperatura', 789.0000, 'ºC'),
	(243922, 119, '2014-03-15 00:05:16.000000', 'temperatura', 213.0000, 'ºC'),
	(243923, 119, '2014-03-15 00:05:17.000000', 'temperatura', 1099.0000, 'ºC'),
	(243924, 119, '2014-03-15 00:05:18.000000', 'temperatura', 57.0000, 'ºC'),
	(243925, 119, '2014-03-15 00:05:19.000000', 'temperatura', 590.0000, 'ºC'),
	(243926, 119, '2014-03-15 00:05:20.000000', 'temperatura', 379.0000, 'ºC'),
	(243927, 119, '2014-03-15 00:05:21.000000', 'temperatura', 124.0000, 'ºC'),
	(243928, 119, '2014-03-15 00:05:22.000000', 'temperatura', 683.0000, 'ºC'),
	(243929, 119, '2014-03-15 00:05:23.000000', 'temperatura', 642.0000, 'ºC'),
	(243930, 119, '2014-03-15 00:05:24.000000', 'temperatura', 1164.0000, 'ºC'),
	(243931, 119, '2014-03-15 00:05:25.000000', 'temperatura', 294.0000, 'ºC'),
	(243932, 119, '2014-03-15 00:05:26.000000', 'temperatura', 376.0000, 'ºC'),
	(243933, 119, '2014-03-15 00:05:27.000000', 'temperatura', 1002.0000, 'ºC'),
	(243934, 119, '2014-03-15 00:05:28.000000', 'temperatura', 282.0000, 'ºC'),
	(243935, 119, '2014-03-15 00:05:29.000000', 'temperatura', 805.0000, 'ºC'),
	(243936, 119, '2014-03-15 00:05:30.000000', 'temperatura', 780.0000, 'ºC'),
	(243937, 119, '2014-03-15 00:05:31.000000', 'temperatura', 286.0000, 'ºC'),
	(243938, 119, '2014-03-15 00:05:32.000000', 'temperatura', 290.0000, 'ºC'),
	(243939, 119, '2014-03-15 00:05:33.000000', 'temperatura', 593.0000, 'ºC'),
	(243940, 119, '2014-03-15 00:05:34.000000', 'temperatura', 894.0000, 'ºC'),
	(243941, 119, '2014-03-15 00:05:35.000000', 'temperatura', 294.0000, 'ºC'),
	(243942, 119, '2014-03-15 00:05:36.000000', 'temperatura', 1187.0000, 'ºC'),
	(243943, 119, '2014-03-15 00:05:37.000000', 'temperatura', 253.0000, 'ºC'),
	(243944, 119, '2014-03-15 00:05:38.000000', 'temperatura', 104.0000, 'ºC'),
	(243945, 119, '2014-03-15 00:05:39.000000', 'temperatura', 963.0000, 'ºC'),
	(243946, 119, '2014-03-15 00:05:40.000000', 'temperatura', 905.0000, 'ºC'),
	(243947, 119, '2014-03-15 00:05:41.000000', 'temperatura', 434.0000, 'ºC'),
	(243948, 119, '2014-03-15 00:05:42.000000', 'temperatura', 656.0000, 'ºC'),
	(243949, 119, '2014-03-15 00:05:43.000000', 'temperatura', 779.0000, 'ºC'),
	(243950, 119, '2014-03-15 00:05:44.000000', 'temperatura', 729.0000, 'ºC'),
	(243951, 119, '2014-03-15 00:05:45.000000', 'temperatura', 109.0000, 'ºC'),
	(243952, 119, '2014-03-15 00:05:46.000000', 'temperatura', 756.0000, 'ºC'),
	(243953, 119, '2014-03-15 00:05:47.000000', 'temperatura', 1054.0000, 'ºC'),
	(243954, 119, '2014-03-15 00:05:48.000000', 'temperatura', 602.0000, 'ºC'),
	(243955, 119, '2014-03-15 00:05:49.000000', 'temperatura', 1049.0000, 'ºC'),
	(243956, 119, '2014-03-15 00:05:50.000000', 'temperatura', 1040.0000, 'ºC'),
	(243957, 119, '2014-03-15 00:05:51.000000', 'temperatura', 854.0000, 'ºC'),
	(243958, 119, '2014-03-15 00:05:52.000000', 'temperatura', 1152.0000, 'ºC'),
	(243959, 119, '2014-03-15 00:05:53.000000', 'temperatura', 797.0000, 'ºC'),
	(243960, 119, '2014-03-15 00:05:54.000000', 'temperatura', 528.0000, 'ºC'),
	(243961, 119, '2014-03-15 00:05:55.000000', 'temperatura', 252.0000, 'ºC'),
	(243962, 119, '2014-03-15 00:05:56.000000', 'temperatura', 876.0000, 'ºC'),
	(243963, 119, '2014-03-15 00:05:57.000000', 'temperatura', 23.0000, 'ºC'),
	(243964, 119, '2014-03-15 00:05:58.000000', 'temperatura', 1090.0000, 'ºC'),
	(243965, 119, '2014-03-15 00:05:59.000000', 'temperatura', 580.0000, 'ºC'),
	(243966, 119, '2014-03-15 00:06:00.000000', 'temperatura', 831.0000, 'ºC'),
	(243967, 119, '2014-03-15 00:06:01.000000', 'temperatura', 15.0000, 'ºC'),
	(243968, 119, '2014-03-15 00:06:02.000000', 'temperatura', 1184.0000, 'ºC'),
	(243969, 119, '2014-03-15 00:06:03.000000', 'temperatura', 1075.0000, 'ºC'),
	(243970, 119, '2014-03-15 00:06:04.000000', 'temperatura', 622.0000, 'ºC'),
	(243971, 119, '2014-03-15 00:06:05.000000', 'temperatura', 1088.0000, 'ºC'),
	(243972, 119, '2014-03-15 00:06:06.000000', 'temperatura', 1171.0000, 'ºC'),
	(243973, 119, '2014-03-15 00:06:07.000000', 'temperatura', 194.0000, 'ºC'),
	(243974, 119, '2014-03-15 00:06:08.000000', 'temperatura', 1058.0000, 'ºC'),
	(243975, 119, '2014-03-15 00:06:09.000000', 'temperatura', 1108.0000, 'ºC'),
	(243976, 119, '2014-03-15 00:06:10.000000', 'temperatura', 1166.0000, 'ºC'),
	(243977, 119, '2014-03-15 00:06:11.000000', 'temperatura', 108.0000, 'ºC'),
	(243978, 119, '2014-03-15 00:06:12.000000', 'temperatura', 644.0000, 'ºC'),
	(243979, 119, '2014-03-15 00:06:13.000000', 'temperatura', 493.0000, 'ºC'),
	(243980, 119, '2014-03-15 00:06:14.000000', 'temperatura', 534.0000, 'ºC'),
	(243981, 119, '2014-03-15 00:06:15.000000', 'temperatura', 1191.0000, 'ºC'),
	(243982, 119, '2014-03-15 00:06:16.000000', 'temperatura', 753.0000, 'ºC'),
	(243983, 119, '2014-03-15 00:06:17.000000', 'temperatura', 192.0000, 'ºC'),
	(243984, 119, '2014-03-15 00:06:18.000000', 'temperatura', 1104.0000, 'ºC'),
	(243985, 119, '2014-03-15 00:06:19.000000', 'temperatura', 141.0000, 'ºC'),
	(243986, 119, '2014-03-15 00:06:20.000000', 'temperatura', 997.0000, 'ºC'),
	(243987, 119, '2014-03-15 00:06:21.000000', 'temperatura', 960.0000, 'ºC'),
	(243988, 119, '2014-03-15 00:06:22.000000', 'temperatura', 610.0000, 'ºC'),
	(243989, 119, '2014-03-15 00:06:23.000000', 'temperatura', 172.0000, 'ºC'),
	(243990, 119, '2014-03-15 00:06:24.000000', 'temperatura', 229.0000, 'ºC'),
	(243991, 119, '2014-03-15 00:06:25.000000', 'temperatura', 628.0000, 'ºC'),
	(243992, 119, '2014-03-15 00:06:26.000000', 'temperatura', 55.0000, 'ºC'),
	(243993, 119, '2014-03-15 00:06:27.000000', 'temperatura', 792.0000, 'ºC'),
	(243994, 119, '2014-03-15 00:06:28.000000', 'temperatura', 195.0000, 'ºC'),
	(243995, 119, '2014-03-15 00:06:29.000000', 'temperatura', 1000.0000, 'ºC'),
	(243996, 119, '2014-03-15 00:06:30.000000', 'temperatura', 816.0000, 'ºC'),
	(243997, 119, '2014-03-15 00:06:31.000000', 'temperatura', 1082.0000, 'ºC'),
	(243998, 119, '2014-03-15 00:06:32.000000', 'temperatura', 559.0000, 'ºC'),
	(243999, 119, '2014-03-15 00:06:33.000000', 'temperatura', 753.0000, 'ºC'),
	(244000, 119, '2014-03-15 00:06:34.000000', 'temperatura', 886.0000, 'ºC'),
	(244001, 119, '2014-03-15 00:06:35.000000', 'temperatura', 972.0000, 'ºC'),
	(244002, 119, '2014-03-15 00:06:36.000000', 'temperatura', 1004.0000, 'ºC'),
	(244003, 119, '2014-03-15 00:06:37.000000', 'temperatura', 903.0000, 'ºC'),
	(244004, 119, '2014-03-15 00:06:38.000000', 'temperatura', 304.0000, 'ºC'),
	(244005, 119, '2014-03-15 00:06:39.000000', 'temperatura', 12.0000, 'ºC'),
	(244006, 119, '2014-03-15 00:06:40.000000', 'temperatura', 348.0000, 'ºC'),
	(244007, 119, '2014-03-15 00:06:41.000000', 'temperatura', 507.0000, 'ºC'),
	(244008, 119, '2014-03-15 00:06:42.000000', 'temperatura', 288.0000, 'ºC'),
	(244009, 119, '2014-03-15 00:06:43.000000', 'temperatura', 1122.0000, 'ºC'),
	(244010, 119, '2014-03-15 00:06:44.000000', 'temperatura', 1145.0000, 'ºC'),
	(244011, 119, '2014-03-15 00:06:45.000000', 'temperatura', 1158.0000, 'ºC'),
	(244012, 119, '2014-03-15 00:06:46.000000', 'temperatura', 1158.0000, 'ºC'),
	(244013, 119, '2014-03-15 00:06:47.000000', 'temperatura', 1117.0000, 'ºC'),
	(244014, 119, '2014-03-15 00:06:48.000000', 'temperatura', 909.0000, 'ºC'),
	(244015, 119, '2014-03-15 00:06:49.000000', 'temperatura', 1197.0000, 'ºC'),
	(244016, 119, '2014-03-15 00:06:50.000000', 'temperatura', 858.0000, 'ºC'),
	(244017, 119, '2014-03-15 00:06:51.000000', 'temperatura', 700.0000, 'ºC'),
	(244018, 119, '2014-03-15 00:06:52.000000', 'temperatura', 925.0000, 'ºC'),
	(244019, 119, '2014-03-15 00:06:53.000000', 'temperatura', 125.0000, 'ºC'),
	(244020, 119, '2014-03-15 00:06:54.000000', 'temperatura', 251.0000, 'ºC'),
	(244021, 119, '2014-03-15 00:06:55.000000', 'temperatura', 882.0000, 'ºC'),
	(244022, 119, '2014-03-15 00:06:56.000000', 'temperatura', 57.0000, 'ºC'),
	(244023, 119, '2014-03-15 00:06:57.000000', 'temperatura', 40.0000, 'ºC'),
	(244024, 119, '2014-03-15 00:06:58.000000', 'temperatura', 30.0000, 'ºC'),
	(244025, 119, '2014-03-15 00:06:59.000000', 'temperatura', 30.0000, 'ºC'),
	(244026, 119, '2014-03-15 00:07:00.000000', 'temperatura', 61.0000, 'ºC'),
	(244027, 119, '2014-03-15 00:07:01.000000', 'temperatura', 217.0000, 'ºC'),
	(244028, 119, '2014-03-15 00:07:02.000000', 'temperatura', 901.0000, 'ºC'),
	(244029, 119, '2014-03-15 00:07:03.000000', 'temperatura', 255.0000, 'ºC'),
	(244030, 119, '2014-03-15 00:07:04.000000', 'temperatura', 972.0000, 'ºC'),
	(244031, 119, '2014-03-15 00:07:05.000000', 'temperatura', 496.0000, 'ºC'),
	(244032, 119, '2014-03-15 00:07:06.000000', 'temperatura', 764.0000, 'ºC'),
	(244033, 119, '2014-03-15 00:07:07.000000', 'temperatura', 1132.0000, 'ºC'),
	(244034, 119, '2014-03-15 00:07:08.000000', 'temperatura', 968.0000, 'ºC'),
	(244035, 119, '2014-03-15 00:07:09.000000', 'temperatura', 243.0000, 'ºC'),
	(244036, 119, '2014-03-15 00:07:10.000000', 'temperatura', 715.0000, 'ºC'),
	(244037, 119, '2014-03-15 00:07:11.000000', 'temperatura', 445.0000, 'ºC'),
	(244038, 119, '2014-03-15 00:07:12.000000', 'temperatura', 81.0000, 'ºC'),
	(244039, 119, '2014-03-15 00:07:13.000000', 'temperatura', 268.0000, 'ºC'),
	(244040, 119, '2014-03-15 00:07:14.000000', 'temperatura', 1100.0000, 'ºC'),
	(244041, 119, '2014-03-15 00:07:15.000000', 'temperatura', 1095.0000, 'ºC'),
	(244042, 119, '2014-03-15 00:07:16.000000', 'temperatura', 977.0000, 'ºC'),
	(244043, 119, '2014-03-15 00:07:17.000000', 'temperatura', 399.0000, 'ºC'),
	(244044, 119, '2014-03-15 00:07:18.000000', 'temperatura', 266.0000, 'ºC'),
	(244045, 119, '2014-03-15 00:07:19.000000', 'temperatura', 134.0000, 'ºC'),
	(244046, 119, '2014-03-15 00:07:20.000000', 'temperatura', 1072.0000, 'ºC'),
	(244047, 119, '2014-03-15 00:07:21.000000', 'temperatura', 156.0000, 'ºC'),
	(244048, 119, '2014-03-15 00:07:22.000000', 'temperatura', 1167.0000, 'ºC'),
	(244049, 119, '2014-03-15 00:07:23.000000', 'temperatura', 566.0000, 'ºC'),
	(244050, 119, '2014-03-15 00:07:24.000000', 'temperatura', 531.0000, 'ºC'),
	(244051, 119, '2014-03-15 00:07:25.000000', 'temperatura', 956.0000, 'ºC'),
	(244052, 119, '2014-03-15 00:07:26.000000', 'temperatura', 788.0000, 'ºC'),
	(244053, 119, '2014-03-15 00:07:27.000000', 'temperatura', 1073.0000, 'ºC'),
	(244054, 119, '2014-03-15 00:07:28.000000', 'temperatura', 601.0000, 'ºC'),
	(244055, 119, '2014-03-15 00:07:29.000000', 'temperatura', 987.0000, 'ºC'),
	(244056, 119, '2014-03-15 00:07:30.000000', 'temperatura', 730.0000, 'ºC'),
	(244057, 119, '2014-03-15 00:07:31.000000', 'temperatura', 692.0000, 'ºC'),
	(244058, 119, '2014-03-15 00:07:32.000000', 'temperatura', 70.0000, 'ºC'),
	(244059, 119, '2014-03-15 00:07:33.000000', 'temperatura', 674.0000, 'ºC'),
	(244060, 119, '2014-03-15 00:07:34.000000', 'temperatura', 762.0000, 'ºC'),
	(244061, 119, '2014-03-15 00:07:35.000000', 'temperatura', 586.0000, 'ºC'),
	(244062, 119, '2014-03-15 00:07:36.000000', 'temperatura', 646.0000, 'ºC'),
	(244063, 119, '2014-03-15 00:07:37.000000', 'temperatura', 272.0000, 'ºC'),
	(244064, 119, '2014-03-15 00:07:38.000000', 'temperatura', 622.0000, 'ºC'),
	(244065, 119, '2014-03-15 00:07:39.000000', 'temperatura', 1094.0000, 'ºC'),
	(244066, 119, '2014-03-15 00:07:40.000000', 'temperatura', 4.0000, 'ºC'),
	(244067, 119, '2014-03-15 00:07:41.000000', 'temperatura', 340.0000, 'ºC'),
	(244068, 119, '2014-03-15 00:07:42.000000', 'temperatura', 488.0000, 'ºC'),
	(244069, 119, '2014-03-15 00:07:43.000000', 'temperatura', 222.0000, 'ºC'),
	(244070, 119, '2014-03-15 00:07:44.000000', 'temperatura', 844.0000, 'ºC'),
	(244071, 119, '2014-03-15 00:07:45.000000', 'temperatura', 1156.0000, 'ºC'),
	(244072, 119, '2014-03-15 00:07:46.000000', 'temperatura', 849.0000, 'ºC'),
	(244073, 119, '2014-03-15 00:07:47.000000', 'temperatura', 777.0000, 'ºC'),
	(244074, 119, '2014-03-15 00:07:48.000000', 'temperatura', 138.0000, 'ºC'),
	(244075, 119, '2014-03-15 00:07:49.000000', 'temperatura', 758.0000, 'ºC'),
	(244076, 119, '2014-03-15 00:07:50.000000', 'temperatura', 977.0000, 'ºC'),
	(244077, 119, '2014-03-15 00:07:51.000000', 'temperatura', 211.0000, 'ºC'),
	(244078, 119, '2014-03-15 00:07:52.000000', 'temperatura', 525.0000, 'ºC'),
	(244079, 119, '2014-03-15 00:07:53.000000', 'temperatura', 791.0000, 'ºC'),
	(244080, 119, '2014-03-15 00:07:54.000000', 'temperatura', 1183.0000, 'ºC'),
	(244081, 119, '2014-03-15 00:07:55.000000', 'temperatura', 1140.0000, 'ºC'),
	(244082, 119, '2014-03-15 00:07:56.000000', 'temperatura', 953.0000, 'ºC'),
	(244083, 119, '2014-03-15 00:07:57.000000', 'temperatura', 147.0000, 'ºC'),
	(244084, 119, '2014-03-15 00:07:58.000000', 'temperatura', 277.0000, 'ºC'),
	(244085, 119, '2014-03-15 00:07:59.000000', 'temperatura', 941.0000, 'ºC'),
	(244086, 119, '2014-03-15 00:08:00.000000', 'temperatura', 277.0000, 'ºC'),
	(244087, 119, '2014-03-15 00:08:01.000000', 'temperatura', 960.0000, 'ºC'),
	(244088, 119, '2014-03-15 00:08:02.000000', 'temperatura', 373.0000, 'ºC'),
	(244089, 119, '2014-03-15 00:08:03.000000', 'temperatura', 184.0000, 'ºC'),
	(244090, 119, '2014-03-15 00:08:04.000000', 'temperatura', 1000.0000, 'ºC'),
	(244091, 119, '2014-03-15 00:08:05.000000', 'temperatura', 851.0000, 'ºC'),
	(244092, 119, '2014-03-15 00:08:06.000000', 'temperatura', 54.0000, 'ºC'),
	(244093, 119, '2014-03-15 00:08:07.000000', 'temperatura', 116.0000, 'ºC'),
	(244094, 119, '2014-03-15 00:08:08.000000', 'temperatura', 420.0000, 'ºC'),
	(244095, 119, '2014-03-15 00:08:09.000000', 'temperatura', 554.0000, 'ºC'),
	(244096, 119, '2014-03-15 00:08:10.000000', 'temperatura', 309.0000, 'ºC'),
	(244097, 119, '2014-03-15 00:08:11.000000', 'temperatura', 1084.0000, 'ºC'),
	(244098, 119, '2014-03-15 00:08:12.000000', 'temperatura', 893.0000, 'ºC'),
	(244099, 119, '2014-03-15 00:08:13.000000', 'temperatura', 15.0000, 'ºC'),
	(244100, 119, '2014-03-15 00:08:14.000000', 'temperatura', 995.0000, 'ºC'),
	(244101, 119, '2014-03-15 00:08:15.000000', 'temperatura', 132.0000, 'ºC'),
	(244102, 119, '2014-03-15 00:08:16.000000', 'temperatura', 74.0000, 'ºC'),
	(244103, 119, '2014-03-15 00:08:17.000000', 'temperatura', 1175.0000, 'ºC'),
	(244104, 119, '2014-03-15 00:08:18.000000', 'temperatura', 853.0000, 'ºC'),
	(244105, 119, '2014-03-15 00:08:19.000000', 'temperatura', 741.0000, 'ºC'),
	(244106, 119, '2014-03-15 00:08:20.000000', 'temperatura', 1148.0000, 'ºC'),
	(244107, 119, '2014-03-15 00:08:21.000000', 'temperatura', 1118.0000, 'ºC'),
	(244108, 119, '2014-03-15 00:08:22.000000', 'temperatura', 947.0000, 'ºC'),
	(244109, 119, '2014-03-15 00:08:23.000000', 'temperatura', 181.0000, 'ºC'),
	(244110, 119, '2014-03-15 00:08:24.000000', 'temperatura', 466.0000, 'ºC'),
	(244111, 119, '2014-03-15 00:08:25.000000', 'temperatura', 586.0000, 'ºC'),
	(244112, 119, '2014-03-15 00:08:26.000000', 'temperatura', 333.0000, 'ºC'),
	(244113, 119, '2014-03-15 00:08:27.000000', 'temperatura', 1105.0000, 'ºC'),
	(244114, 119, '2014-03-15 00:08:28.000000', 'temperatura', 930.0000, 'ºC'),
	(244115, 119, '2014-03-15 00:08:29.000000', 'temperatura', 134.0000, 'ºC'),
	(244116, 119, '2014-03-15 00:08:30.000000', 'temperatura', 280.0000, 'ºC'),
	(244117, 119, '2014-03-15 00:08:31.000000', 'temperatura', 997.0000, 'ºC'),
	(244118, 119, '2014-03-15 00:08:32.000000', 'temperatura', 549.0000, 'ºC'),
	(244119, 119, '2014-03-15 00:08:33.000000', 'temperatura', 951.0000, 'ºC'),
	(244120, 119, '2014-03-15 00:08:34.000000', 'temperatura', 710.0000, 'ºC'),
	(244121, 119, '2014-03-15 00:08:35.000000', 'temperatura', 696.0000, 'ºC'),
	(244122, 119, '2014-03-15 00:08:36.000000', 'temperatura', 152.0000, 'ºC'),
	(244123, 119, '2014-03-15 00:08:37.000000', 'temperatura', 1073.0000, 'ºC'),
	(244124, 119, '2014-03-15 00:08:38.000000', 'temperatura', 111.0000, 'ºC'),
	(244125, 119, '2014-03-15 00:08:39.000000', 'temperatura', 935.0000, 'ºC'),
	(244126, 119, '2014-03-15 00:08:40.000000', 'temperatura', 741.0000, 'ºC'),
	(244127, 119, '2014-03-15 00:08:41.000000', 'temperatura', 904.0000, 'ºC'),
	(244128, 119, '2014-03-15 00:08:42.000000', 'temperatura', 1094.0000, 'ºC'),
	(244129, 119, '2014-03-15 00:08:43.000000', 'temperatura', 362.0000, 'ºC'),
	(244130, 119, '2014-03-15 00:08:44.000000', 'temperatura', 925.0000, 'ºC'),
	(244131, 119, '2014-03-15 00:08:45.000000', 'temperatura', 1140.0000, 'ºC'),
	(244132, 119, '2014-03-15 00:08:46.000000', 'temperatura', 528.0000, 'ºC'),
	(244133, 119, '2014-03-15 00:08:47.000000', 'temperatura', 419.0000, 'ºC'),
	(244134, 119, '2014-03-15 00:08:48.000000', 'temperatura', 512.0000, 'ºC'),
	(244135, 119, '2014-03-15 00:08:49.000000', 'temperatura', 105.0000, 'ºC'),
	(244136, 119, '2014-03-15 00:08:50.000000', 'temperatura', 187.0000, 'ºC'),
	(244137, 119, '2014-03-15 00:08:51.000000', 'temperatura', 622.0000, 'ºC'),
	(244138, 119, '2014-03-15 00:08:52.000000', 'temperatura', 151.0000, 'ºC'),
	(244139, 119, '2014-03-15 00:08:53.000000', 'temperatura', 86.0000, 'ºC'),
	(244140, 119, '2014-03-15 00:08:54.000000', 'temperatura', 1180.0000, 'ºC'),
	(244141, 119, '2014-03-15 00:08:55.000000', 'temperatura', 843.0000, 'ºC'),
	(244142, 119, '2014-03-15 00:08:56.000000', 'temperatura', 675.0000, 'ºC'),
	(244143, 119, '2014-03-15 00:08:57.000000', 'temperatura', 848.0000, 'ºC'),
	(244144, 119, '2014-03-15 00:08:58.000000', 'temperatura', 1013.0000, 'ºC'),
	(244145, 119, '2014-03-15 00:08:59.000000', 'temperatura', 122.0000, 'ºC'),
	(244146, 119, '2014-03-15 00:09:00.000000', 'temperatura', 1174.0000, 'ºC'),
	(244147, 119, '2014-03-15 00:09:01.000000', 'temperatura', 703.0000, 'ºC'),
	(244148, 119, '2014-03-15 00:09:02.000000', 'temperatura', 1192.0000, 'ºC'),
	(244149, 119, '2014-03-15 00:09:03.000000', 'temperatura', 252.0000, 'ºC'),
	(244150, 119, '2014-03-15 00:09:04.000000', 'temperatura', 85.0000, 'ºC'),
	(244151, 119, '2014-03-15 00:09:05.000000', 'temperatura', 869.0000, 'ºC'),
	(244152, 119, '2014-03-15 00:09:06.000000', 'temperatura', 492.0000, 'ºC'),
	(244153, 119, '2014-03-15 00:09:07.000000', 'temperatura', 1053.0000, 'ºC'),
	(244154, 119, '2014-03-15 00:09:08.000000', 'temperatura', 190.0000, 'ºC'),
	(244155, 119, '2014-03-15 00:09:09.000000', 'temperatura', 190.0000, 'ºC'),
	(244156, 119, '2014-03-15 00:09:10.000000', 'temperatura', 381.0000, 'ºC'),
	(244157, 119, '2014-03-15 00:09:11.000000', 'temperatura', 138.0000, 'ºC'),
	(244158, 119, '2014-03-15 00:09:12.000000', 'temperatura', 744.0000, 'ºC'),
	(244159, 119, '2014-03-15 00:09:13.000000', 'temperatura', 907.0000, 'ºC'),
	(244160, 119, '2014-03-15 00:09:14.000000', 'temperatura', 1102.0000, 'ºC'),
	(244161, 119, '2014-03-15 00:09:15.000000', 'temperatura', 392.0000, 'ºC'),
	(244162, 119, '2014-03-15 00:09:16.000000', 'temperatura', 1053.0000, 'ºC'),
	(244163, 119, '2014-03-15 00:09:17.000000', 'temperatura', 491.0000, 'ºC'),
	(244164, 119, '2014-03-15 00:09:18.000000', 'temperatura', 494.0000, 'ºC'),
	(244165, 119, '2014-03-15 00:09:19.000000', 'temperatura', 999.0000, 'ºC'),
	(244166, 119, '2014-03-15 00:09:20.000000', 'temperatura', 1112.0000, 'ºC'),
	(244167, 119, '2014-03-15 00:09:21.000000', 'temperatura', 164.0000, 'ºC'),
	(244168, 119, '2014-03-15 00:09:22.000000', 'temperatura', 1086.0000, 'ºC'),
	(244169, 119, '2014-03-15 00:09:23.000000', 'temperatura', 136.0000, 'ºC'),
	(244170, 119, '2014-03-15 00:09:24.000000', 'temperatura', 1025.0000, 'ºC'),
	(244171, 119, '2014-03-15 00:09:25.000000', 'temperatura', 1118.0000, 'ºC'),
	(244172, 119, '2014-03-15 00:09:26.000000', 'temperatura', 112.0000, 'ºC'),
	(244173, 119, '2014-03-15 00:09:27.000000', 'temperatura', 810.0000, 'ºC'),
	(244174, 119, '2014-03-15 00:09:28.000000', 'temperatura', 112.0000, 'ºC'),
	(244175, 119, '2014-03-15 00:09:29.000000', 'temperatura', 533.0000, 'ºC'),
	(244176, 119, '2014-03-15 00:09:30.000000', 'temperatura', 1129.0000, 'ºC'),
	(244177, 119, '2014-03-15 00:09:31.000000', 'temperatura', 445.0000, 'ºC'),
	(244178, 119, '2014-03-15 00:09:32.000000', 'temperatura', 37.0000, 'ºC'),
	(244179, 119, '2014-03-15 00:09:33.000000', 'temperatura', 54.0000, 'ºC'),
	(244180, 119, '2014-03-15 00:09:34.000000', 'temperatura', 159.0000, 'ºC'),
	(244181, 119, '2014-03-15 00:09:35.000000', 'temperatura', 632.0000, 'ºC'),
	(244182, 119, '2014-03-15 00:09:36.000000', 'temperatura', 285.0000, 'ºC'),
	(244183, 119, '2014-03-15 00:09:37.000000', 'temperatura', 729.0000, 'ºC'),
	(244184, 119, '2014-03-15 00:09:38.000000', 'temperatura', 388.0000, 'ºC'),
	(244185, 119, '2014-03-15 00:09:39.000000', 'temperatura', 956.0000, 'ºC'),
	(244186, 119, '2014-03-15 00:09:40.000000', 'temperatura', 18.0000, 'ºC'),
	(244187, 119, '2014-03-15 00:09:41.000000', 'temperatura', 821.0000, 'ºC'),
	(244188, 119, '2014-03-15 00:09:42.000000', 'temperatura', 453.0000, 'ºC'),
	(244189, 119, '2014-03-15 00:09:43.000000', 'temperatura', 1003.0000, 'ºC'),
	(244190, 119, '2014-03-15 00:09:44.000000', 'temperatura', 56.0000, 'ºC'),
	(244191, 119, '2014-03-15 00:09:45.000000', 'temperatura', 871.0000, 'ºC'),
	(244192, 119, '2014-03-15 00:09:46.000000', 'temperatura', 588.0000, 'ºC'),
	(244193, 119, '2014-03-15 00:09:47.000000', 'temperatura', 327.0000, 'ºC'),
	(244194, 119, '2014-03-15 00:09:48.000000', 'temperatura', 1070.0000, 'ºC'),
	(244195, 119, '2014-03-15 00:09:49.000000', 'temperatura', 769.0000, 'ºC'),
	(244196, 119, '2014-03-15 00:09:50.000000', 'temperatura', 637.0000, 'ºC'),
	(244197, 119, '2014-03-15 00:09:51.000000', 'temperatura', 878.0000, 'ºC'),
	(244198, 119, '2014-03-15 00:09:52.000000', 'temperatura', 81.0000, 'ºC'),
	(244199, 119, '2014-03-15 00:09:53.000000', 'temperatura', 169.0000, 'ºC'),
	(244200, 119, '2014-03-15 00:09:54.000000', 'temperatura', 605.0000, 'ºC'),
	(244201, 119, '2014-03-15 00:09:55.000000', 'temperatura', 119.0000, 'ºC'),
	(244202, 119, '2014-03-15 00:09:56.000000', 'temperatura', 1179.0000, 'ºC'),
	(244203, 119, '2014-03-15 00:09:57.000000', 'temperatura', 738.0000, 'ºC'),
	(244204, 119, '2014-03-15 00:09:58.000000', 'temperatura', 154.0000, 'ºC'),
	(244205, 119, '2014-03-15 00:09:59.000000', 'temperatura', 955.0000, 'ºC'),
	(244206, 119, '2014-03-15 00:10:00.000000', 'temperatura', 715.0000, 'ºC'),
	(244207, 119, '2014-03-15 00:10:01.000000', 'temperatura', 710.0000, 'ºC'),
	(244208, 119, '2014-03-15 00:10:02.000000', 'temperatura', 207.0000, 'ºC'),
	(244209, 119, '2014-03-15 00:10:03.000000', 'temperatura', 104.0000, 'ºC'),
	(244210, 119, '2014-03-15 00:10:04.000000', 'temperatura', 1098.0000, 'ºC'),
	(244211, 119, '2014-03-15 00:10:05.000000', 'temperatura', 381.0000, 'ºC'),
	(244212, 119, '2014-03-15 00:10:06.000000', 'temperatura', 1009.0000, 'ºC'),
	(244213, 119, '2014-03-15 00:10:07.000000', 'temperatura', 305.0000, 'ºC'),
	(244214, 119, '2014-03-15 00:10:08.000000', 'temperatura', 897.0000, 'ºC'),
	(244215, 119, '2014-03-15 00:10:09.000000', 'temperatura', 1172.0000, 'ºC'),
	(244216, 119, '2014-03-15 00:10:10.000000', 'temperatura', 769.0000, 'ºC'),
	(244217, 119, '2014-03-15 00:10:11.000000', 'temperatura', 330.0000, 'ºC'),
	(244218, 119, '2014-03-15 00:10:12.000000', 'temperatura', 541.0000, 'ºC'),
	(244219, 119, '2014-03-15 00:10:13.000000', 'temperatura', 516.0000, 'ºC'),
	(244220, 119, '2014-03-15 00:10:14.000000', 'temperatura', 960.0000, 'ºC'),
	(244221, 119, '2014-03-15 00:10:15.000000', 'temperatura', 851.0000, 'ºC'),
	(244222, 119, '2014-03-15 00:10:16.000000', 'temperatura', 176.0000, 'ºC'),
	(244223, 119, '2014-03-15 00:10:17.000000', 'temperatura', 725.0000, 'ºC'),
	(244224, 119, '2014-03-15 00:10:18.000000', 'temperatura', 701.0000, 'ºC'),
	(244225, 119, '2014-03-15 00:10:19.000000', 'temperatura', 129.0000, 'ºC'),
	(244226, 119, '2014-03-15 00:10:20.000000', 'temperatura', 942.0000, 'ºC'),
	(244227, 119, '2014-03-15 00:10:21.000000', 'temperatura', 723.0000, 'ºC'),
	(244228, 119, '2014-03-15 00:10:22.000000', 'temperatura', 792.0000, 'ºC'),
	(244229, 119, '2014-03-15 00:10:23.000000', 'temperatura', 588.0000, 'ºC'),
	(244230, 119, '2014-03-15 00:10:24.000000', 'temperatura', 566.0000, 'ºC'),
	(244231, 119, '2014-03-15 00:10:25.000000', 'temperatura', 1069.0000, 'ºC'),
	(244232, 119, '2014-03-15 00:10:26.000000', 'temperatura', 44.0000, 'ºC'),
	(244233, 119, '2014-03-15 00:10:27.000000', 'temperatura', 614.0000, 'ºC'),
	(244234, 119, '2014-03-15 00:10:28.000000', 'temperatura', 540.0000, 'ºC'),
	(244235, 119, '2014-03-15 00:10:29.000000', 'temperatura', 858.0000, 'ºC'),
	(244236, 119, '2014-03-15 00:10:30.000000', 'temperatura', 270.0000, 'ºC'),
	(244237, 119, '2014-03-15 00:10:31.000000', 'temperatura', 1178.0000, 'ºC'),
	(244238, 119, '2014-03-15 00:10:32.000000', 'temperatura', 280.0000, 'ºC'),
	(244239, 119, '2014-03-15 00:10:33.000000', 'temperatura', 267.0000, 'ºC'),
	(244240, 119, '2014-03-15 00:10:34.000000', 'temperatura', 495.0000, 'ºC'),
	(244241, 119, '2014-03-15 00:10:35.000000', 'temperatura', 474.0000, 'ºC'),
	(244242, 119, '2014-03-15 00:10:36.000000', 'temperatura', 886.0000, 'ºC'),
	(244243, 119, '2014-03-15 00:10:37.000000', 'temperatura', 610.0000, 'ºC'),
	(244244, 119, '2014-03-15 00:10:38.000000', 'temperatura', 392.0000, 'ºC'),
	(244245, 119, '2014-03-15 00:10:39.000000', 'temperatura', 131.0000, 'ºC'),
	(244246, 119, '2014-03-15 00:10:40.000000', 'temperatura', 679.0000, 'ºC'),
	(244247, 119, '2014-03-15 00:10:41.000000', 'temperatura', 603.0000, 'ºC'),
	(244248, 119, '2014-03-15 00:10:42.000000', 'temperatura', 977.0000, 'ºC'),
	(244249, 119, '2014-03-15 00:10:43.000000', 'temperatura', 678.0000, 'ºC'),
	(244250, 119, '2014-03-15 00:10:44.000000', 'temperatura', 460.0000, 'ºC'),
	(244251, 119, '2014-03-15 00:10:45.000000', 'temperatura', 266.0000, 'ºC'),
	(244252, 119, '2014-03-15 00:10:46.000000', 'temperatura', 1150.0000, 'ºC'),
	(244253, 119, '2014-03-15 00:10:47.000000', 'temperatura', 153.0000, 'ºC'),
	(244254, 119, '2014-03-15 00:10:48.000000', 'temperatura', 916.0000, 'ºC'),
	(244255, 119, '2014-03-15 00:10:49.000000', 'temperatura', 521.0000, 'ºC'),
	(244256, 119, '2014-03-15 00:10:50.000000', 'temperatura', 1056.0000, 'ºC'),
	(244257, 119, '2014-03-15 00:10:51.000000', 'temperatura', 120.0000, 'ºC'),
	(244258, 119, '2014-03-15 00:10:52.000000', 'temperatura', 1031.0000, 'ºC'),
	(244259, 119, '2014-03-15 00:10:53.000000', 'temperatura', 1194.0000, 'ºC'),
	(244260, 119, '2014-03-15 00:10:54.000000', 'temperatura', 480.0000, 'ºC'),
	(244261, 119, '2014-03-15 00:10:55.000000', 'temperatura', 17.0000, 'ºC'),
	(244262, 119, '2014-03-15 00:10:56.000000', 'temperatura', 1048.0000, 'ºC'),
	(244263, 119, '2014-03-15 00:10:57.000000', 'temperatura', 388.0000, 'ºC'),
	(244264, 119, '2014-03-15 00:10:58.000000', 'temperatura', 1195.0000, 'ºC'),
	(244265, 119, '2014-03-15 00:10:59.000000', 'temperatura', 14.0000, 'ºC'),
	(244266, 119, '2014-03-15 00:11:00.000000', 'temperatura', 85.0000, 'ºC'),
	(244267, 119, '2014-03-15 00:11:01.000000', 'temperatura', 382.0000, 'ºC'),
	(244268, 119, '2014-03-15 00:11:02.000000', 'temperatura', 458.0000, 'ºC'),
	(244269, 119, '2014-03-15 00:11:03.000000', 'temperatura', 1142.0000, 'ºC'),
	(244270, 119, '2014-03-15 00:11:04.000000', 'temperatura', 738.0000, 'ºC'),
	(244271, 119, '2014-03-15 00:11:05.000000', 'temperatura', 262.0000, 'ºC'),
	(244272, 119, '2014-03-15 00:11:06.000000', 'temperatura', 300.0000, 'ºC'),
	(244273, 119, '2014-03-15 00:11:07.000000', 'temperatura', 712.0000, 'ºC'),
	(244274, 119, '2014-03-15 00:11:08.000000', 'temperatura', 260.0000, 'ºC'),
	(244275, 119, '2014-03-15 00:11:09.000000', 'temperatura', 365.0000, 'ºC'),
	(244276, 119, '2014-03-15 00:11:10.000000', 'temperatura', 1047.0000, 'ºC'),
	(244277, 119, '2014-03-15 00:11:11.000000', 'temperatura', 538.0000, 'ºC'),
	(244278, 119, '2014-03-15 00:11:12.000000', 'temperatura', 750.0000, 'ºC'),
	(244279, 119, '2014-03-15 00:11:13.000000', 'temperatura', 936.0000, 'ºC'),
	(244280, 119, '2014-03-15 00:11:14.000000', 'temperatura', 31.0000, 'ºC'),
	(244281, 119, '2014-03-15 00:11:15.000000', 'temperatura', 947.0000, 'ºC'),
	(244282, 119, '2014-03-15 00:11:16.000000', 'temperatura', 1044.0000, 'ºC'),
	(244283, 119, '2014-03-15 00:11:17.000000', 'temperatura', 1179.0000, 'ºC'),
	(244284, 119, '2014-03-15 00:11:18.000000', 'temperatura', 362.0000, 'ºC'),
	(244285, 119, '2014-03-15 00:11:19.000000', 'temperatura', 673.0000, 'ºC'),
	(244286, 119, '2014-03-15 00:11:20.000000', 'temperatura', 1081.0000, 'ºC'),
	(244287, 119, '2014-03-15 00:11:21.000000', 'temperatura', 986.0000, 'ºC'),
	(244288, 119, '2014-03-15 00:11:22.000000', 'temperatura', 489.0000, 'ºC'),
	(244289, 119, '2014-03-15 00:11:23.000000', 'temperatura', 688.0000, 'ºC'),
	(244290, 119, '2014-03-15 00:11:24.000000', 'temperatura', 775.0000, 'ºC'),
	(244291, 119, '2014-03-15 00:11:25.000000', 'temperatura', 608.0000, 'ºC'),
	(244292, 119, '2014-03-15 00:11:26.000000', 'temperatura', 716.0000, 'ºC'),
	(244293, 119, '2014-03-15 00:11:27.000000', 'temperatura', 558.0000, 'ºC'),
	(244294, 119, '2014-03-15 00:11:28.000000', 'temperatura', 640.0000, 'ºC'),
	(244295, 119, '2014-03-15 00:11:29.000000', 'temperatura', 326.0000, 'ºC'),
	(244296, 119, '2014-03-15 00:11:30.000000', 'temperatura', 913.0000, 'ºC'),
	(244297, 119, '2014-03-15 00:11:31.000000', 'temperatura', 1186.0000, 'ºC'),
	(244298, 119, '2014-03-15 00:11:32.000000', 'temperatura', 793.0000, 'ºC'),
	(244299, 119, '2014-03-15 00:11:33.000000', 'temperatura', 405.0000, 'ºC'),
	(244300, 119, '2014-03-15 00:11:34.000000', 'temperatura', 850.0000, 'ºC'),
	(244301, 119, '2014-03-15 00:11:35.000000', 'temperatura', 633.0000, 'ºC'),
	(244302, 119, '2014-03-15 00:11:36.000000', 'temperatura', 615.0000, 'ºC'),
	(244303, 119, '2014-03-15 00:11:37.000000', 'temperatura', 1177.0000, 'ºC'),
	(244304, 119, '2014-03-15 00:11:38.000000', 'temperatura', 441.0000, 'ºC'),
	(244305, 119, '2014-03-15 00:11:39.000000', 'temperatura', 1076.0000, 'ºC'),
	(244306, 119, '2014-03-15 00:11:40.000000', 'temperatura', 455.0000, 'ºC'),
	(244307, 119, '2014-03-15 00:11:41.000000', 'temperatura', 247.0000, 'ºC'),
	(244308, 119, '2014-03-15 00:11:42.000000', 'temperatura', 1074.0000, 'ºC'),
	(244309, 119, '2014-03-15 00:11:43.000000', 'temperatura', 1026.0000, 'ºC'),
	(244310, 119, '2014-03-15 00:11:44.000000', 'temperatura', 709.0000, 'ºC'),
	(244311, 119, '2014-03-15 00:11:45.000000', 'temperatura', 468.0000, 'ºC'),
	(244312, 119, '2014-03-15 00:11:46.000000', 'temperatura', 215.0000, 'ºC'),
	(244313, 119, '2014-03-15 00:11:47.000000', 'temperatura', 870.0000, 'ºC'),
	(244314, 119, '2014-03-15 00:11:48.000000', 'temperatura', 105.0000, 'ºC'),
	(244315, 119, '2014-03-15 00:11:49.000000', 'temperatura', 317.0000, 'ºC'),
	(244316, 119, '2014-03-15 00:11:50.000000', 'temperatura', 70.0000, 'ºC'),
	(244317, 119, '2014-03-15 00:11:51.000000', 'temperatura', 598.0000, 'ºC'),
	(244318, 119, '2014-03-15 00:11:52.000000', 'temperatura', 383.0000, 'ºC'),
	(244319, 119, '2014-03-15 00:11:53.000000', 'temperatura', 122.0000, 'ºC'),
	(244320, 119, '2014-03-15 00:11:54.000000', 'temperatura', 660.0000, 'ºC'),
	(244321, 119, '2014-03-15 00:11:55.000000', 'temperatura', 533.0000, 'ºC'),
	(244322, 119, '2014-03-15 00:11:56.000000', 'temperatura', 688.0000, 'ºC'),
	(244323, 119, '2014-03-15 00:11:57.000000', 'temperatura', 640.0000, 'ºC'),
	(244324, 119, '2014-03-15 00:11:58.000000', 'temperatura', 1137.0000, 'ºC'),
	(244325, 119, '2014-03-15 00:11:59.000000', 'temperatura', 166.0000, 'ºC'),
	(244326, 119, '2014-03-15 00:12:00.000000', 'temperatura', 1018.0000, 'ºC'),
	(244327, 119, '2014-03-15 00:12:01.000000', 'temperatura', 994.0000, 'ºC'),
	(244328, 119, '2014-03-15 00:12:02.000000', 'temperatura', 715.0000, 'ºC'),
	(244329, 119, '2014-03-15 00:12:03.000000', 'temperatura', 593.0000, 'ºC'),
	(244330, 119, '2014-03-15 00:12:04.000000', 'temperatura', 820.0000, 'ºC'),
	(244331, 119, '2014-03-15 00:12:05.000000', 'temperatura', 1124.0000, 'ºC'),
	(244332, 119, '2014-03-15 00:12:06.000000', 'temperatura', 759.0000, 'ºC'),
	(244333, 119, '2014-03-15 00:12:07.000000', 'temperatura', 424.0000, 'ºC'),
	(244334, 119, '2014-03-15 00:12:08.000000', 'temperatura', 1044.0000, 'ºC'),
	(244335, 119, '2014-03-15 00:12:09.000000', 'temperatura', 350.0000, 'ºC'),
	(244336, 119, '2014-03-15 00:12:10.000000', 'temperatura', 1016.0000, 'ºC'),
	(244337, 119, '2014-03-15 00:12:11.000000', 'temperatura', 431.0000, 'ºC'),
	(244338, 119, '2014-03-15 00:12:12.000000', 'temperatura', 308.0000, 'ºC'),
	(244339, 119, '2014-03-15 00:12:13.000000', 'temperatura', 248.0000, 'ºC'),
	(244340, 119, '2014-03-15 00:12:14.000000', 'temperatura', 316.0000, 'ºC'),
	(244341, 119, '2014-03-15 00:12:15.000000', 'temperatura', 836.0000, 'ºC'),
	(244342, 119, '2014-03-15 00:12:16.000000', 'temperatura', 831.0000, 'ºC'),
	(244343, 119, '2014-03-15 00:12:17.000000', 'temperatura', 450.0000, 'ºC'),
	(244344, 119, '2014-03-15 00:12:18.000000', 'temperatura', 956.0000, 'ºC'),
	(244345, 119, '2014-03-15 00:12:19.000000', 'temperatura', 1032.0000, 'ºC'),
	(244346, 119, '2014-03-15 00:12:20.000000', 'temperatura', 1090.0000, 'ºC'),
	(244347, 119, '2014-03-15 00:12:21.000000', 'temperatura', 1157.0000, 'ºC'),
	(244348, 119, '2014-03-15 00:12:22.000000', 'temperatura', 114.0000, 'ºC'),
	(244349, 119, '2014-03-15 00:12:23.000000', 'temperatura', 701.0000, 'ºC'),
	(244350, 119, '2014-03-15 00:12:24.000000', 'temperatura', 761.0000, 'ºC'),
	(244351, 119, '2014-03-15 00:12:25.000000', 'temperatura', 503.0000, 'ºC'),
	(244352, 119, '2014-03-15 00:12:26.000000', 'temperatura', 235.0000, 'ºC'),
	(244353, 119, '2014-03-15 00:12:27.000000', 'temperatura', 863.0000, 'ºC'),
	(244354, 119, '2014-03-15 00:12:28.000000', 'temperatura', 14.0000, 'ºC'),
	(244355, 119, '2014-03-15 00:12:29.000000', 'temperatura', 1078.0000, 'ºC'),
	(244356, 119, '2014-03-15 00:12:30.000000', 'temperatura', 552.0000, 'ºC'),
	(244357, 119, '2014-03-15 00:12:31.000000', 'temperatura', 724.0000, 'ºC'),
	(244358, 119, '2014-03-15 00:12:32.000000', 'temperatura', 764.0000, 'ºC'),
	(244359, 119, '2014-03-15 00:12:33.000000', 'temperatura', 449.0000, 'ºC'),
	(244360, 119, '2014-03-15 00:12:34.000000', 'temperatura', 1154.0000, 'ºC'),
	(244361, 119, '2014-03-15 00:12:35.000000', 'temperatura', 821.0000, 'ºC'),
	(244362, 119, '2014-03-15 00:12:36.000000', 'temperatura', 646.0000, 'ºC'),
	(244363, 119, '2014-03-15 00:12:37.000000', 'temperatura', 767.0000, 'ºC'),
	(244364, 119, '2014-03-15 00:12:38.000000', 'temperatura', 698.0000, 'ºC'),
	(244365, 119, '2014-03-15 00:12:39.000000', 'temperatura', 1188.0000, 'ºC'),
	(244366, 119, '2014-03-15 00:12:40.000000', 'temperatura', 246.0000, 'ºC'),
	(244367, 119, '2014-03-15 00:12:41.000000', 'temperatura', 67.0000, 'ºC'),
	(244368, 119, '2014-03-15 00:12:42.000000', 'temperatura', 797.0000, 'ºC'),
	(244369, 119, '2014-03-15 00:12:43.000000', 'temperatura', 187.0000, 'ºC'),
	(244370, 119, '2014-03-15 00:12:44.000000', 'temperatura', 943.0000, 'ºC'),
	(244371, 119, '2014-03-15 00:12:45.000000', 'temperatura', 555.0000, 'ºC'),
	(244372, 119, '2014-03-15 00:12:46.000000', 'temperatura', 1148.0000, 'ºC'),
	(244373, 119, '2014-03-15 00:12:47.000000', 'temperatura', 474.0000, 'ºC'),
	(244374, 119, '2014-03-15 00:12:48.000000', 'temperatura', 127.0000, 'ºC'),
	(244375, 119, '2014-03-15 00:12:49.000000', 'temperatura', 411.0000, 'ºC'),
	(244376, 119, '2014-03-15 00:12:50.000000', 'temperatura', 478.0000, 'ºC'),
	(244377, 119, '2014-03-15 00:12:51.000000', 'temperatura', 1156.0000, 'ºC'),
	(244378, 119, '2014-03-15 00:12:52.000000', 'temperatura', 747.0000, 'ºC'),
	(244379, 119, '2014-03-15 00:12:53.000000', 'temperatura', 269.0000, 'ºC'),
	(244380, 119, '2014-03-15 00:12:54.000000', 'temperatura', 302.0000, 'ºC'),
	(244381, 119, '2014-03-15 00:12:55.000000', 'temperatura', 706.0000, 'ºC'),
	(244382, 119, '2014-03-15 00:12:56.000000', 'temperatura', 222.0000, 'ºC'),
	(244383, 119, '2014-03-15 00:12:57.000000', 'temperatura', 193.0000, 'ºC'),
	(244384, 119, '2014-03-15 00:12:58.000000', 'temperatura', 301.0000, 'ºC'),
	(244385, 119, '2014-03-15 00:12:59.000000', 'temperatura', 925.0000, 'ºC'),
	(244386, 119, '2014-03-15 00:13:00.000000', 'temperatura', 123.0000, 'ºC'),
	(244387, 119, '2014-03-15 00:13:01.000000', 'temperatura', 239.0000, 'ºC'),
	(244388, 119, '2014-03-15 00:13:02.000000', 'temperatura', 828.0000, 'ºC'),
	(244389, 119, '2014-03-15 00:13:03.000000', 'temperatura', 1022.0000, 'ºC'),
	(244390, 119, '2014-03-15 00:13:04.000000', 'temperatura', 227.0000, 'ºC'),
	(244391, 119, '2014-03-15 00:13:05.000000', 'temperatura', 468.0000, 'ºC'),
	(244392, 119, '2014-03-15 00:13:06.000000', 'temperatura', 462.0000, 'ºC'),
	(244393, 119, '2014-03-15 00:13:07.000000', 'temperatura', 905.0000, 'ºC'),
	(244394, 119, '2014-03-15 00:13:08.000000', 'temperatura', 740.0000, 'ºC'),
	(244395, 119, '2014-03-15 00:13:09.000000', 'temperatura', 987.0000, 'ºC'),
	(244396, 119, '2014-03-15 00:13:10.000000', 'temperatura', 314.0000, 'ºC'),
	(244397, 119, '2014-03-15 00:13:11.000000', 'temperatura', 1011.0000, 'ºC'),
	(244398, 119, '2014-03-15 00:13:12.000000', 'temperatura', 514.0000, 'ºC'),
	(244399, 119, '2014-03-15 00:13:13.000000', 'temperatura', 737.0000, 'ºC'),
	(244400, 119, '2014-03-15 00:13:14.000000', 'temperatura', 942.0000, 'ºC'),
	(244401, 119, '2014-03-15 00:13:15.000000', 'temperatura', 101.0000, 'ºC'),
	(244402, 119, '2014-03-15 00:13:16.000000', 'temperatura', 79.0000, 'ºC'),
	(244403, 119, '2014-03-15 00:13:17.000000', 'temperatura', 94.0000, 'ºC'),
	(244404, 119, '2014-03-15 00:13:18.000000', 'temperatura', 233.0000, 'ºC'),
	(244405, 119, '2014-03-15 00:13:19.000000', 'temperatura', 883.0000, 'ºC'),
	(244406, 119, '2014-03-15 00:13:20.000000', 'temperatura', 119.0000, 'ºC'),
	(244407, 119, '2014-03-15 00:13:21.000000', 'temperatura', 343.0000, 'ºC'),
	(244408, 119, '2014-03-15 00:13:22.000000', 'temperatura', 161.0000, 'ºC'),
	(244409, 119, '2014-03-15 00:13:23.000000', 'temperatura', 977.0000, 'ºC'),
	(244410, 119, '2014-03-15 00:13:24.000000', 'temperatura', 803.0000, 'ºC'),
	(244411, 119, '2014-03-15 00:13:25.000000', 'temperatura', 1082.0000, 'ºC'),
	(244412, 119, '2014-03-15 00:13:26.000000', 'temperatura', 604.0000, 'ºC'),
	(244413, 119, '2014-03-15 00:13:27.000000', 'temperatura', 973.0000, 'ºC'),
	(244414, 119, '2014-03-15 00:13:28.000000', 'temperatura', 655.0000, 'ºC'),
	(244415, 119, '2014-03-15 00:13:29.000000', 'temperatura', 357.0000, 'ºC'),
	(244416, 119, '2014-03-15 00:13:30.000000', 'temperatura', 1019.0000, 'ºC'),
	(244417, 119, '2014-03-15 00:13:31.000000', 'temperatura', 426.0000, 'ºC'),
	(244418, 119, '2014-03-15 00:13:32.000000', 'temperatura', 274.0000, 'ºC'),
	(244419, 119, '2014-03-15 00:13:33.000000', 'temperatura', 92.0000, 'ºC'),
	(244420, 119, '2014-03-15 00:13:34.000000', 'temperatura', 838.0000, 'ºC'),
	(244421, 119, '2014-03-15 00:13:35.000000', 'temperatura', 315.0000, 'ºC'),
	(244422, 119, '2014-03-15 00:13:36.000000', 'temperatura', 261.0000, 'ºC'),
	(244423, 119, '2014-03-15 00:13:37.000000', 'temperatura', 362.0000, 'ºC'),
	(244424, 119, '2014-03-15 00:13:38.000000', 'temperatura', 1026.0000, 'ºC'),
	(244425, 119, '2014-03-15 00:13:39.000000', 'temperatura', 444.0000, 'ºC'),
	(244426, 119, '2014-03-15 00:13:40.000000', 'temperatura', 343.0000, 'ºC'),
	(244427, 119, '2014-03-15 00:13:41.000000', 'temperatura', 384.0000, 'ºC'),
	(244428, 119, '2014-03-15 00:13:42.000000', 'temperatura', 889.0000, 'ºC'),
	(244429, 119, '2014-03-15 00:13:43.000000', 'temperatura', 896.0000, 'ºC'),
	(244430, 119, '2014-03-15 00:13:44.000000', 'temperatura', 614.0000, 'ºC'),
	(244431, 119, '2014-03-15 00:13:45.000000', 'temperatura', 383.0000, 'ºC'),
	(244432, 119, '2014-03-15 00:13:46.000000', 'temperatura', 72.0000, 'ºC'),
	(244433, 119, '2014-03-15 00:13:47.000000', 'temperatura', 410.0000, 'ºC'),
	(244434, 119, '2014-03-15 00:13:48.000000', 'temperatura', 635.0000, 'ºC'),
	(244435, 119, '2014-03-15 00:13:49.000000', 'temperatura', 748.0000, 'ºC'),
	(244436, 119, '2014-03-15 00:13:50.000000', 'temperatura', 634.0000, 'ºC'),
	(244437, 119, '2014-03-15 00:13:51.000000', 'temperatura', 929.0000, 'ºC'),
	(244438, 119, '2014-03-15 00:13:52.000000', 'temperatura', 340.0000, 'ºC'),
	(244439, 119, '2014-03-15 00:13:53.000000', 'temperatura', 117.0000, 'ºC'),
	(244440, 119, '2014-03-15 00:13:54.000000', 'temperatura', 764.0000, 'ºC'),
	(244441, 119, '2014-03-15 00:13:55.000000', 'temperatura', 1068.0000, 'ºC'),
	(244442, 119, '2014-03-15 00:13:56.000000', 'temperatura', 648.0000, 'ºC'),
	(244443, 119, '2014-03-15 00:13:57.000000', 'temperatura', 40.0000, 'ºC'),
	(244444, 119, '2014-03-15 00:13:58.000000', 'temperatura', 653.0000, 'ºC'),
	(244445, 119, '2014-03-15 00:13:59.000000', 'temperatura', 746.0000, 'ºC'),
	(244446, 119, '2014-03-15 00:14:00.000000', 'temperatura', 573.0000, 'ºC'),
	(244447, 119, '2014-03-15 00:14:01.000000', 'temperatura', 628.0000, 'ºC'),
	(244448, 119, '2014-03-15 00:14:02.000000', 'temperatura', 221.0000, 'ºC'),
	(244449, 119, '2014-03-15 00:14:03.000000', 'temperatura', 423.0000, 'ºC'),
	(244450, 119, '2014-03-15 00:14:04.000000', 'temperatura', 249.0000, 'ºC'),
	(244451, 119, '2014-03-15 00:14:05.000000', 'temperatura', 1180.0000, 'ºC'),
	(244452, 119, '2014-03-15 00:14:06.000000', 'temperatura', 352.0000, 'ºC'),
	(244453, 119, '2014-03-15 00:14:07.000000', 'temperatura', 620.0000, 'ºC'),
	(244454, 119, '2014-03-15 00:14:08.000000', 'temperatura', 846.0000, 'ºC'),
	(244455, 119, '2014-03-15 00:14:09.000000', 'temperatura', 1170.0000, 'ºC'),
	(244456, 119, '2014-03-15 00:14:10.000000', 'temperatura', 912.0000, 'ºC'),
	(244457, 119, '2014-03-15 00:14:11.000000', 'temperatura', 1049.0000, 'ºC'),
	(244458, 119, '2014-03-15 00:14:12.000000', 'temperatura', 111.0000, 'ºC'),
	(244459, 119, '2014-03-15 00:14:13.000000', 'temperatura', 1009.0000, 'ºC'),
	(244460, 119, '2014-03-15 00:14:14.000000', 'temperatura', 1112.0000, 'ºC'),
	(244461, 119, '2014-03-15 00:14:15.000000', 'temperatura', 132.0000, 'ºC'),
	(244462, 119, '2014-03-15 00:14:16.000000', 'temperatura', 925.0000, 'ºC'),
	(244463, 119, '2014-03-15 00:14:17.000000', 'temperatura', 631.0000, 'ºC'),
	(244464, 119, '2014-03-15 00:14:18.000000', 'temperatura', 381.0000, 'ºC'),
	(244465, 119, '2014-03-15 00:14:19.000000', 'temperatura', 10.0000, 'ºC'),
	(244466, 119, '2014-03-15 00:14:20.000000', 'temperatura', 109.0000, 'ºC'),
	(244467, 119, '2014-03-15 00:14:21.000000', 'temperatura', 517.0000, 'ºC'),
	(244468, 119, '2014-03-15 00:14:22.000000', 'temperatura', 1058.0000, 'ºC'),
	(244469, 119, '2014-03-15 00:14:23.000000', 'temperatura', 138.0000, 'ºC'),
	(244470, 119, '2014-03-15 00:14:24.000000', 'temperatura', 1118.0000, 'ºC'),
	(244471, 119, '2014-03-15 00:14:25.000000', 'temperatura', 378.0000, 'ºC'),
	(244472, 119, '2014-03-15 00:14:26.000000', 'temperatura', 935.0000, 'ºC'),
	(244473, 119, '2014-03-15 00:14:27.000000', 'temperatura', 1141.0000, 'ºC'),
	(244474, 119, '2014-03-15 00:14:28.000000', 'temperatura', 501.0000, 'ºC'),
	(244475, 119, '2014-03-15 00:14:29.000000', 'temperatura', 282.0000, 'ºC'),
	(244476, 119, '2014-03-15 00:14:30.000000', 'temperatura', 1107.0000, 'ºC'),
	(244477, 119, '2014-03-15 00:14:31.000000', 'temperatura', 1092.0000, 'ºC'),
	(244478, 119, '2014-03-15 00:14:32.000000', 'temperatura', 937.0000, 'ºC'),
	(244479, 119, '2014-03-15 00:14:33.000000', 'temperatura', 211.0000, 'ºC'),
	(244480, 119, '2014-03-15 00:14:34.000000', 'temperatura', 645.0000, 'ºC'),
	(244481, 119, '2014-03-15 00:14:35.000000', 'temperatura', 190.0000, 'ºC'),
	(244482, 119, '2014-03-15 00:14:36.000000', 'temperatura', 218.0000, 'ºC'),
	(244483, 119, '2014-03-15 00:14:37.000000', 'temperatura', 518.0000, 'ºC'),
	(244484, 119, '2014-03-15 00:14:38.000000', 'temperatura', 737.0000, 'ºC'),
	(244485, 119, '2014-03-15 00:14:39.000000', 'temperatura', 932.0000, 'ºC'),
	(244486, 119, '2014-03-15 00:14:40.000000', 'temperatura', 51.0000, 'ºC'),
	(244487, 119, '2014-03-15 00:14:41.000000', 'temperatura', 1058.0000, 'ºC'),
	(244488, 119, '2014-03-15 00:14:42.000000', 'temperatura', 338.0000, 'ºC'),
	(244489, 119, '2014-03-15 00:14:43.000000', 'temperatura', 918.0000, 'ºC'),
	(244490, 119, '2014-03-15 00:14:44.000000', 'temperatura', 1176.0000, 'ºC'),
	(244491, 119, '2014-03-15 00:14:45.000000', 'temperatura', 727.0000, 'ºC'),
	(244492, 119, '2014-03-15 00:14:46.000000', 'temperatura', 107.0000, 'ºC'),
	(244493, 119, '2014-03-15 00:14:47.000000', 'temperatura', 755.0000, 'ºC'),
	(244494, 119, '2014-03-15 00:14:48.000000', 'temperatura', 1055.0000, 'ºC'),
	(244495, 119, '2014-03-15 00:14:49.000000', 'temperatura', 610.0000, 'ºC'),
	(244496, 119, '2014-03-15 00:14:50.000000', 'temperatura', 1087.0000, 'ºC'),
	(244497, 119, '2014-03-15 00:14:51.000000', 'temperatura', 3.0000, 'ºC'),
	(244498, 119, '2014-03-15 00:14:52.000000', 'temperatura', 357.0000, 'ºC'),
	(244499, 119, '2014-03-15 00:14:53.000000', 'temperatura', 576.0000, 'ºC'),
	(244500, 119, '2014-03-15 00:14:54.000000', 'temperatura', 609.0000, 'ºC'),
	(244501, 119, '2014-03-15 00:14:55.000000', 'temperatura', 116.0000, 'ºC'),
	(244502, 119, '2014-03-15 00:14:56.000000', 'temperatura', 1156.0000, 'ºC'),
	(244503, 119, '2014-03-15 00:14:57.000000', 'temperatura', 631.0000, 'ºC'),
	(244504, 119, '2014-03-15 00:14:58.000000', 'temperatura', 886.0000, 'ºC'),
	(244505, 119, '2014-03-15 00:14:59.000000', 'temperatura', 139.0000, 'ºC'),
	(244506, 119, '2014-03-15 00:15:00.000000', 'temperatura', 436.0000, 'ºC'),
	(244507, 119, '2014-03-15 00:15:01.000000', 'temperatura', 563.0000, 'ºC'),
	(244508, 119, '2014-03-15 00:15:02.000000', 'temperatura', 307.0000, 'ºC'),
	(244509, 119, '2014-03-15 00:15:03.000000', 'temperatura', 1048.0000, 'ºC'),
	(244510, 119, '2014-03-15 00:15:04.000000', 'temperatura', 717.0000, 'ºC'),
	(244511, 119, '2014-03-15 00:15:05.000000', 'temperatura', 444.0000, 'ºC'),
	(244512, 119, '2014-03-15 00:15:06.000000', 'temperatura', 67.0000, 'ºC'),
	(244513, 119, '2014-03-15 00:15:07.000000', 'temperatura', 204.0000, 'ºC'),
	(244514, 119, '2014-03-15 00:15:08.000000', 'temperatura', 821.0000, 'ºC'),
	(244515, 119, '2014-03-15 00:15:09.000000', 'temperatura', 1094.0000, 'ºC'),
	(244516, 119, '2014-03-15 00:15:10.000000', 'temperatura', 606.0000, 'ºC'),
	(244517, 119, '2014-03-15 00:15:11.000000', 'temperatura', 949.0000, 'ºC'),
	(244518, 119, '2014-03-15 00:15:12.000000', 'temperatura', 528.0000, 'ºC'),
	(244519, 119, '2014-03-15 00:15:13.000000', 'temperatura', 995.0000, 'ºC'),
	(244520, 119, '2014-03-15 00:15:14.000000', 'temperatura', 991.0000, 'ºC'),
	(244521, 119, '2014-03-15 00:15:15.000000', 'temperatura', 769.0000, 'ºC'),
	(244522, 119, '2014-03-15 00:15:16.000000', 'temperatura', 875.0000, 'ºC'),
	(244523, 119, '2014-03-15 00:15:17.000000', 'temperatura', 867.0000, 'ºC'),
	(244524, 119, '2014-03-15 00:15:18.000000', 'temperatura', 509.0000, 'ºC'),
	(244525, 119, '2014-03-15 00:15:19.000000', 'temperatura', 1146.0000, 'ºC'),
	(244526, 119, '2014-03-15 00:15:20.000000', 'temperatura', 602.0000, 'ºC'),
	(244527, 119, '2014-03-15 00:15:21.000000', 'temperatura', 775.0000, 'ºC'),
	(244528, 119, '2014-03-15 00:15:22.000000', 'temperatura', 870.0000, 'ºC'),
	(244529, 119, '2014-03-15 00:15:23.000000', 'temperatura', 826.0000, 'ºC'),
	(244530, 119, '2014-03-15 00:15:24.000000', 'temperatura', 321.0000, 'ºC'),
	(244531, 119, '2014-03-15 00:15:25.000000', 'temperatura', 328.0000, 'ºC'),
	(244532, 119, '2014-03-15 00:15:26.000000', 'temperatura', 677.0000, 'ºC'),
	(244533, 119, '2014-03-15 00:15:27.000000', 'temperatura', 0.0000, 'ºC'),
	(244534, 119, '2014-03-15 00:15:28.000000', 'temperatura', 371.0000, 'ºC'),
	(244535, 119, '2014-03-15 00:15:29.000000', 'temperatura', 654.0000, 'ºC'),
	(244536, 119, '2014-03-15 00:15:30.000000', 'temperatura', 960.0000, 'ºC'),
	(244537, 119, '2014-03-15 00:15:31.000000', 'temperatura', 436.0000, 'ºC'),
	(244538, 119, '2014-03-15 00:15:32.000000', 'temperatura', 499.0000, 'ºC'),
	(244539, 119, '2014-03-15 00:15:33.000000', 'temperatura', 1191.0000, 'ºC'),
	(244540, 119, '2014-03-15 00:15:34.000000', 'temperatura', 856.0000, 'ºC'),
	(244541, 119, '2014-03-15 00:15:35.000000', 'temperatura', 706.0000, 'ºC'),
	(244542, 119, '2014-03-15 00:15:36.000000', 'temperatura', 965.0000, 'ºC'),
	(244543, 119, '2014-03-15 00:15:37.000000', 'temperatura', 308.0000, 'ºC'),
	(244544, 119, '2014-03-15 00:15:38.000000', 'temperatura', 1045.0000, 'ºC'),
	(244545, 119, '2014-03-15 00:15:39.000000', 'temperatura', 703.0000, 'ºC'),
	(244546, 119, '2014-03-15 00:15:40.000000', 'temperatura', 380.0000, 'ºC'),
	(244547, 119, '2014-03-15 00:15:41.000000', 'temperatura', 991.0000, 'ºC'),
	(244548, 119, '2014-03-15 00:15:42.000000', 'temperatura', 216.0000, 'ºC'),
	(244549, 119, '2014-03-15 00:15:43.000000', 'temperatura', 506.0000, 'ºC'),
	(244550, 119, '2014-03-15 00:15:44.000000', 'temperatura', 684.0000, 'ºC'),
	(244551, 119, '2014-03-15 00:15:45.000000', 'temperatura', 703.0000, 'ºC'),
	(244552, 119, '2014-03-15 00:15:46.000000', 'temperatura', 262.0000, 'ºC'),
	(244553, 119, '2014-03-15 00:15:47.000000', 'temperatura', 404.0000, 'ºC'),
	(244554, 119, '2014-03-15 00:15:48.000000', 'temperatura', 32.0000, 'ºC'),
	(244555, 119, '2014-03-15 00:15:49.000000', 'temperatura', 151.0000, 'ºC'),
	(244556, 119, '2014-03-15 00:15:50.000000', 'temperatura', 657.0000, 'ºC'),
	(244557, 119, '2014-03-15 00:15:51.000000', 'temperatura', 434.0000, 'ºC'),
	(244558, 119, '2014-03-15 00:15:52.000000', 'temperatura', 201.0000, 'ºC'),
	(244559, 119, '2014-03-15 00:15:53.000000', 'temperatura', 903.0000, 'ºC'),
	(244560, 119, '2014-03-15 00:15:54.000000', 'temperatura', 310.0000, 'ºC'),
	(244561, 119, '2014-03-15 00:15:55.000000', 'temperatura', 43.0000, 'ºC'),
	(244562, 119, '2014-03-15 00:15:56.000000', 'temperatura', 486.0000, 'ºC'),
	(244563, 119, '2014-03-15 00:15:57.000000', 'temperatura', 1102.0000, 'ºC'),
	(244564, 119, '2014-03-15 00:15:58.000000', 'temperatura', 452.0000, 'ºC'),
	(244565, 119, '2014-03-15 00:15:59.000000', 'temperatura', 153.0000, 'ºC'),
	(244566, 119, '2014-03-15 00:16:00.000000', 'temperatura', 610.0000, 'ºC'),
	(244567, 119, '2014-03-15 00:16:01.000000', 'temperatura', 190.0000, 'ºC'),
	(244568, 119, '2014-03-15 00:16:02.000000', 'temperatura', 324.0000, 'ºC'),
	(244569, 119, '2014-03-15 00:16:03.000000', 'temperatura', 1048.0000, 'ºC'),
	(244570, 119, '2014-03-15 00:16:04.000000', 'temperatura', 671.0000, 'ºC'),
	(244571, 119, '2014-03-15 00:16:05.000000', 'temperatura', 210.0000, 'ºC'),
	(244572, 119, '2014-03-15 00:16:06.000000', 'temperatura', 237.0000, 'ºC'),
	(244573, 119, '2014-03-15 00:16:07.000000', 'temperatura', 556.0000, 'ºC'),
	(244574, 119, '2014-03-15 00:16:08.000000', 'temperatura', 869.0000, 'ºC'),
	(244575, 119, '2014-03-15 00:16:09.000000', 'temperatura', 277.0000, 'ºC'),
	(244576, 119, '2014-03-15 00:16:10.000000', 'temperatura', 1181.0000, 'ºC'),
	(244577, 119, '2014-03-15 00:16:11.000000', 'temperatura', 272.0000, 'ºC'),
	(244578, 119, '2014-03-15 00:16:12.000000', 'temperatura', 218.0000, 'ºC'),
	(244579, 119, '2014-03-15 00:16:13.000000', 'temperatura', 275.0000, 'ºC'),
	(244580, 119, '2014-03-15 00:16:14.000000', 'temperatura', 723.0000, 'ºC'),
	(244581, 119, '2014-03-15 00:16:15.000000', 'temperatura', 391.0000, 'ºC'),
	(244582, 119, '2014-03-15 00:16:16.000000', 'temperatura', 985.0000, 'ºC'),
	(244583, 119, '2014-03-15 00:16:17.000000', 'temperatura', 155.0000, 'ºC'),
	(244584, 119, '2014-03-15 00:16:18.000000', 'temperatura', 218.0000, 'ºC'),
	(244585, 119, '2014-03-15 00:16:19.000000', 'temperatura', 626.0000, 'ºC'),
	(244586, 119, '2014-03-15 00:16:20.000000', 'temperatura', 78.0000, 'ºC'),
	(244587, 119, '2014-03-15 00:16:21.000000', 'temperatura', 911.0000, 'ºC'),
	(244588, 119, '2014-03-15 00:16:22.000000', 'temperatura', 722.0000, 'ºC'),
	(244589, 119, '2014-03-15 00:16:23.000000', 'temperatura', 878.0000, 'ºC'),
	(244590, 119, '2014-03-15 00:16:24.000000', 'temperatura', 1026.0000, 'ºC'),
	(244591, 119, '2014-03-15 00:16:25.000000', 'temperatura', 93.0000, 'ºC'),
	(244592, 119, '2014-03-15 00:16:26.000000', 'temperatura', 990.0000, 'ºC'),
	(244593, 119, '2014-03-15 00:16:27.000000', 'temperatura', 1070.0000, 'ºC'),
	(244594, 119, '2014-03-15 00:16:28.000000', 'temperatura', 1183.0000, 'ºC'),
	(244595, 119, '2014-03-15 00:16:29.000000', 'temperatura', 305.0000, 'ºC'),
	(244596, 119, '2014-03-15 00:16:30.000000', 'temperatura', 376.0000, 'ºC'),
	(244597, 119, '2014-03-15 00:16:31.000000', 'temperatura', 965.0000, 'ºC'),
	(244598, 119, '2014-03-15 00:16:32.000000', 'temperatura', 97.0000, 'ºC'),
	(244599, 119, '2014-03-15 00:16:33.000000', 'temperatura', 1191.0000, 'ºC'),
	(244600, 119, '2014-03-15 00:16:34.000000', 'temperatura', 864.0000, 'ºC'),
	(244601, 119, '2014-03-15 00:16:35.000000', 'temperatura', 746.0000, 'ºC'),
	(244602, 119, '2014-03-15 00:16:36.000000', 'temperatura', 1141.0000, 'ºC'),
	(244603, 119, '2014-03-15 00:16:37.000000', 'temperatura', 1068.0000, 'ºC'),
	(244604, 119, '2014-03-15 00:16:38.000000', 'temperatura', 718.0000, 'ºC'),
	(244605, 119, '2014-03-15 00:16:39.000000', 'temperatura', 387.0000, 'ºC'),
	(244606, 119, '2014-03-15 00:16:40.000000', 'temperatura', 982.0000, 'ºC'),
	(244607, 119, '2014-03-15 00:16:41.000000', 'temperatura', 149.0000, 'ºC'),
	(244608, 119, '2014-03-15 00:16:42.000000', 'temperatura', 199.0000, 'ºC'),
	(244609, 119, '2014-03-15 00:16:43.000000', 'temperatura', 546.0000, 'ºC'),
	(244610, 119, '2014-03-15 00:16:44.000000', 'temperatura', 937.0000, 'ºC'),
	(244611, 119, '2014-03-15 00:16:45.000000', 'temperatura', 647.0000, 'ºC'),
	(244612, 119, '2014-03-15 00:16:46.000000', 'temperatura', 425.0000, 'ºC'),
	(244613, 119, '2014-03-15 00:16:47.000000', 'temperatura', 185.0000, 'ºC'),
	(244614, 119, '2014-03-15 00:16:48.000000', 'temperatura', 849.0000, 'ºC'),
	(244615, 119, '2014-03-15 00:16:49.000000', 'temperatura', 89.0000, 'ºC'),
	(244616, 119, '2014-03-15 00:16:50.000000', 'temperatura', 300.0000, 'ºC'),
	(244617, 119, '2014-03-15 00:16:51.000000', 'temperatura', 34.0000, 'ºC'),
	(244618, 119, '2014-03-15 00:16:52.000000', 'temperatura', 469.0000, 'ºC'),
	(244619, 119, '2014-03-15 00:16:53.000000', 'temperatura', 1045.0000, 'ºC'),
	(244620, 119, '2014-03-15 00:16:54.000000', 'temperatura', 218.0000, 'ºC'),
	(244621, 119, '2014-03-15 00:16:55.000000', 'temperatura', 356.0000, 'ºC'),
	(244622, 119, '2014-03-15 00:16:56.000000', 'temperatura', 1128.0000, 'ºC'),
	(244623, 119, '2014-03-15 00:16:57.000000', 'temperatura', 971.0000, 'ºC'),
	(244624, 119, '2014-03-15 00:16:58.000000', 'temperatura', 269.0000, 'ºC'),
	(244625, 119, '2014-03-15 00:16:59.000000', 'temperatura', 836.0000, 'ºC'),
	(244626, 119, '2014-03-15 00:17:00.000000', 'temperatura', 974.0000, 'ºC'),
	(244627, 119, '2014-03-15 00:17:01.000000', 'temperatura', 1163.0000, 'ºC'),
	(244628, 119, '2014-03-15 00:17:02.000000', 'temperatura', 494.0000, 'ºC'),
	(244629, 119, '2014-03-15 00:17:03.000000', 'temperatura', 179.0000, 'ºC'),
	(244630, 119, '2014-03-15 00:17:04.000000', 'temperatura', 613.0000, 'ºC'),
	(244631, 119, '2014-03-15 00:17:05.000000', 'temperatura', 129.0000, 'ºC'),
	(244632, 119, '2014-03-15 00:17:06.000000', 'temperatura', 9.0000, 'ºC'),
	(244633, 119, '2014-03-15 00:17:07.000000', 'temperatura', 855.0000, 'ºC'),
	(244634, 119, '2014-03-15 00:17:08.000000', 'temperatura', 652.0000, 'ºC'),
	(244635, 119, '2014-03-15 00:17:09.000000', 'temperatura', 693.0000, 'ºC'),
	(244636, 119, '2014-03-15 00:17:10.000000', 'temperatura', 309.0000, 'ºC'),
	(244637, 119, '2014-03-15 00:17:11.000000', 'temperatura', 667.0000, 'ºC'),
	(244638, 119, '2014-03-15 00:17:12.000000', 'temperatura', 9.0000, 'ºC'),
	(244639, 119, '2014-03-15 00:17:13.000000', 'temperatura', 444.0000, 'ºC'),
	(244640, 119, '2014-03-15 00:17:14.000000', 'temperatura', 992.0000, 'ºC'),
	(244641, 119, '2014-03-15 00:17:15.000000', 'temperatura', 31.0000, 'ºC'),
	(244642, 119, '2014-03-15 00:17:16.000000', 'temperatura', 777.0000, 'ºC'),
	(244643, 119, '2014-03-15 00:17:17.000000', 'temperatura', 196.0000, 'ºC'),
	(244644, 119, '2014-03-15 00:17:18.000000', 'temperatura', 1047.0000, 'ºC'),
	(244645, 119, '2014-03-15 00:17:19.000000', 'temperatura', 1046.0000, 'ºC'),
	(244646, 119, '2014-03-15 00:17:20.000000', 'temperatura', 892.0000, 'ºC'),
	(244647, 119, '2014-03-15 00:17:21.000000', 'temperatura', 123.0000, 'ºC'),
	(244648, 119, '2014-03-15 00:17:22.000000', 'temperatura', 339.0000, 'ºC'),
	(244649, 119, '2014-03-15 00:17:23.000000', 'temperatura', 127.0000, 'ºC'),
	(244650, 119, '2014-03-15 00:17:24.000000', 'temperatura', 817.0000, 'ºC'),
	(244651, 119, '2014-03-15 00:17:25.000000', 'temperatura', 105.0000, 'ºC'),
	(244652, 119, '2014-03-15 00:17:26.000000', 'temperatura', 476.0000, 'ºC'),
	(244653, 119, '2014-03-15 00:17:27.000000', 'temperatura', 866.0000, 'ºC'),
	(244654, 119, '2014-03-15 00:17:28.000000', 'temperatura', 501.0000, 'ºC'),
	(244655, 119, '2014-03-15 00:17:29.000000', 'temperatura', 1109.0000, 'ºC'),
	(244656, 119, '2014-03-15 00:17:30.000000', 'temperatura', 444.0000, 'ºC'),
	(244657, 119, '2014-03-15 00:17:31.000000', 'temperatura', 90.0000, 'ºC'),
	(244658, 119, '2014-03-15 00:17:32.000000', 'temperatura', 319.0000, 'ºC'),
	(244659, 119, '2014-03-15 00:17:33.000000', 'temperatura', 125.0000, 'ºC'),
	(244660, 119, '2014-03-15 00:17:34.000000', 'temperatura', 870.0000, 'ºC'),
	(244661, 119, '2014-03-15 00:17:35.000000', 'temperatura', 374.0000, 'ºC'),
	(244662, 119, '2014-03-15 00:17:36.000000', 'temperatura', 463.0000, 'ºC'),
	(244663, 119, '2014-03-15 00:17:37.000000', 'temperatura', 1192.0000, 'ºC'),
	(244664, 119, '2014-03-15 00:17:38.000000', 'temperatura', 974.0000, 'ºC'),
	(244665, 119, '2014-03-15 00:17:39.000000', 'temperatura', 92.0000, 'ºC'),
	(244666, 119, '2014-03-15 00:17:40.000000', 'temperatura', 1139.0000, 'ºC'),
	(244667, 119, '2014-03-15 00:17:41.000000', 'temperatura', 618.0000, 'ºC'),
	(244668, 119, '2014-03-15 00:17:42.000000', 'temperatura', 874.0000, 'ºC'),
	(244669, 119, '2014-03-15 00:17:43.000000', 'temperatura', 118.0000, 'ºC'),
	(244670, 119, '2014-03-15 00:17:44.000000', 'temperatura', 369.0000, 'ºC'),
	(244671, 119, '2014-03-15 00:17:45.000000', 'temperatura', 289.0000, 'ºC'),
	(244672, 119, '2014-03-15 00:17:46.000000', 'temperatura', 338.0000, 'ºC'),
	(244673, 119, '2014-03-15 00:17:47.000000', 'temperatura', 827.0000, 'ºC'),
	(244674, 119, '2014-03-15 00:17:48.000000', 'temperatura', 718.0000, 'ºC'),
	(244675, 119, '2014-03-15 00:17:49.000000', 'temperatura', 1111.0000, 'ºC'),
	(244676, 119, '2014-03-15 00:17:50.000000', 'temperatura', 1001.0000, 'ºC'),
	(244677, 119, '2014-03-15 00:17:51.000000', 'temperatura', 473.0000, 'ºC'),
	(244678, 119, '2014-03-15 00:17:52.000000', 'temperatura', 560.0000, 'ºC'),
	(244679, 119, '2014-03-15 00:17:53.000000', 'temperatura', 185.0000, 'ºC'),
	(244680, 119, '2014-03-15 00:17:54.000000', 'temperatura', 444.0000, 'ºC'),
	(244681, 119, '2014-03-15 00:17:55.000000', 'temperatura', 464.0000, 'ºC'),
	(244682, 119, '2014-03-15 00:17:56.000000', 'temperatura', 989.0000, 'ºC'),
	(244683, 119, '2014-03-15 00:17:57.000000', 'temperatura', 1153.0000, 'ºC'),
	(244684, 119, '2014-03-15 00:17:58.000000', 'temperatura', 400.0000, 'ºC'),
	(244685, 119, '2014-03-15 00:17:59.000000', 'temperatura', 941.0000, 'ºC'),
	(244686, 119, '2014-03-15 00:18:00.000000', 'temperatura', 1104.0000, 'ºC'),
	(244687, 119, '2014-03-15 00:18:01.000000', 'temperatura', 299.0000, 'ºC'),
	(244688, 119, '2014-03-15 00:18:02.000000', 'temperatura', 585.0000, 'ºC'),
	(244689, 119, '2014-03-15 00:18:03.000000', 'temperatura', 826.0000, 'ºC'),
	(244690, 119, '2014-03-15 00:18:04.000000', 'temperatura', 1175.0000, 'ºC'),
	(244691, 119, '2014-03-15 00:18:05.000000', 'temperatura', 1001.0000, 'ºC'),
	(244692, 119, '2014-03-15 00:18:06.000000', 'temperatura', 277.0000, 'ºC'),
	(244693, 119, '2014-03-15 00:18:07.000000', 'temperatura', 782.0000, 'ºC'),
	(244694, 119, '2014-03-15 00:18:08.000000', 'temperatura', 682.0000, 'ºC'),
	(244695, 119, '2014-03-15 00:18:09.000000', 'temperatura', 1063.0000, 'ºC'),
	(244696, 119, '2014-03-15 00:18:10.000000', 'temperatura', 871.0000, 'ºC'),
	(244697, 119, '2014-03-15 00:18:11.000000', 'temperatura', 1165.0000, 'ºC'),
	(244698, 119, '2014-03-15 00:18:12.000000', 'temperatura', 815.0000, 'ºC'),
	(244699, 119, '2014-03-15 00:18:13.000000', 'temperatura', 579.0000, 'ºC'),
	(244700, 119, '2014-03-15 00:18:14.000000', 'temperatura', 449.0000, 'ºC'),
	(244701, 119, '2014-03-15 00:18:15.000000', 'temperatura', 512.0000, 'ºC'),
	(244702, 119, '2014-03-15 00:18:16.000000', 'temperatura', 10.0000, 'ºC'),
	(244703, 119, '2014-03-15 00:18:17.000000', 'temperatura', 915.0000, 'ºC'),
	(244704, 119, '2014-03-15 00:18:18.000000', 'temperatura', 947.0000, 'ºC'),
	(244705, 119, '2014-03-15 00:18:19.000000', 'temperatura', 788.0000, 'ºC'),
	(244706, 119, '2014-03-15 00:18:20.000000', 'temperatura', 1102.0000, 'ºC'),
	(244707, 119, '2014-03-15 00:18:21.000000', 'temperatura', 746.0000, 'ºC'),
	(244708, 119, '2014-03-15 00:18:22.000000', 'temperatura', 426.0000, 'ºC'),
	(244709, 119, '2014-03-15 00:18:23.000000', 'temperatura', 1090.0000, 'ºC'),
	(244710, 119, '2014-03-15 00:18:24.000000', 'temperatura', 572.0000, 'ºC'),
	(244711, 119, '2014-03-15 00:18:25.000000', 'temperatura', 791.0000, 'ºC'),
	(244712, 119, '2014-03-15 00:18:26.000000', 'temperatura', 1040.0000, 'ºC'),
	(244713, 119, '2014-03-15 00:18:27.000000', 'temperatura', 427.0000, 'ºC'),
	(244714, 119, '2014-03-15 00:18:28.000000', 'temperatura', 217.0000, 'ºC'),
	(244715, 119, '2014-03-15 00:18:29.000000', 'temperatura', 1004.0000, 'ºC'),
	(244716, 119, '2014-03-15 00:18:30.000000', 'temperatura', 771.0000, 'ºC'),
	(244717, 119, '2014-03-15 00:18:31.000000', 'temperatura', 841.0000, 'ºC'),
	(244718, 119, '2014-03-15 00:18:32.000000', 'temperatura', 693.0000, 'ºC'),
	(244719, 119, '2014-03-15 00:18:33.000000', 'temperatura', 943.0000, 'ºC'),
	(244720, 119, '2014-03-15 00:18:34.000000', 'temperatura', 236.0000, 'ºC'),
	(244721, 119, '2014-03-15 00:18:35.000000', 'temperatura', 753.0000, 'ºC'),
	(244722, 119, '2014-03-15 00:18:36.000000', 'temperatura', 656.0000, 'ºC'),
	(244723, 119, '2014-03-15 00:18:37.000000', 'temperatura', 1022.0000, 'ºC'),
	(244724, 119, '2014-03-15 00:18:38.000000', 'temperatura', 742.0000, 'ºC'),
	(244725, 119, '2014-03-15 00:18:39.000000', 'temperatura', 644.0000, 'ºC'),
	(244726, 119, '2014-03-15 00:18:40.000000', 'temperatura', 995.0000, 'ºC'),
	(244727, 119, '2014-03-15 00:18:41.000000', 'temperatura', 642.0000, 'ºC'),
	(244728, 119, '2014-03-15 00:18:42.000000', 'temperatura', 226.0000, 'ºC'),
	(244729, 119, '2014-03-15 00:18:43.000000', 'temperatura', 404.0000, 'ºC'),
	(244730, 119, '2014-03-15 00:18:44.000000', 'temperatura', 145.0000, 'ºC'),
	(244731, 119, '2014-03-15 00:18:45.000000', 'temperatura', 712.0000, 'ºC'),
	(244732, 119, '2014-03-15 00:18:46.000000', 'temperatura', 726.0000, 'ºC'),
	(244733, 119, '2014-03-15 00:18:47.000000', 'temperatura', 296.0000, 'ºC'),
	(244734, 119, '2014-03-15 00:18:48.000000', 'temperatura', 500.0000, 'ºC'),
	(244735, 119, '2014-03-15 00:18:49.000000', 'temperatura', 412.0000, 'ºC'),
	(244736, 119, '2014-03-15 00:18:50.000000', 'temperatura', 563.0000, 'ºC'),
	(244737, 119, '2014-03-15 00:18:51.000000', 'temperatura', 378.0000, 'ºC'),
	(244738, 119, '2014-03-15 00:18:52.000000', 'temperatura', 204.0000, 'ºC'),
	(244739, 119, '2014-03-15 00:18:53.000000', 'temperatura', 1083.0000, 'ºC'),
	(244740, 119, '2014-03-15 00:18:54.000000', 'temperatura', 6.0000, 'ºC'),
	(244741, 119, '2014-03-15 00:18:55.000000', 'temperatura', 379.0000, 'ºC'),
	(244742, 119, '2014-03-15 00:18:56.000000', 'temperatura', 678.0000, 'ºC'),
	(244743, 119, '2014-03-15 00:18:57.000000', 'temperatura', 1052.0000, 'ºC'),
	(244744, 119, '2014-03-15 00:18:58.000000', 'temperatura', 827.0000, 'ºC'),
	(244745, 119, '2014-03-15 00:18:59.000000', 'temperatura', 981.0000, 'ºC'),
	(244746, 119, '2014-03-15 00:19:00.000000', 'temperatura', 25.0000, 'ºC'),
	(244747, 119, '2014-03-15 00:19:01.000000', 'temperatura', 781.0000, 'ºC'),
	(244748, 119, '2014-03-15 00:19:02.000000', 'temperatura', 229.0000, 'ºC'),
	(244749, 119, '2014-03-15 00:19:03.000000', 'temperatura', 4.0000, 'ºC'),
	(244750, 119, '2014-03-15 00:19:04.000000', 'temperatura', 532.0000, 'ºC'),
	(244751, 119, '2014-03-15 00:19:05.000000', 'temperatura', 249.0000, 'ºC'),
	(244752, 119, '2014-03-15 00:19:06.000000', 'temperatura', 851.0000, 'ºC'),
	(244753, 119, '2014-03-15 00:19:07.000000', 'temperatura', 1109.0000, 'ºC'),
	(244754, 119, '2014-03-15 00:19:08.000000', 'temperatura', 592.0000, 'ºC'),
	(244755, 119, '2014-03-15 00:19:09.000000', 'temperatura', 832.0000, 'ºC'),
	(244756, 119, '2014-03-15 00:19:10.000000', 'temperatura', 1183.0000, 'ºC'),
	(244757, 119, '2014-03-15 00:19:11.000000', 'temperatura', 1023.0000, 'ºC'),
	(244758, 119, '2014-03-15 00:19:12.000000', 'temperatura', 364.0000, 'ºC'),
	(244759, 119, '2014-03-15 00:19:13.000000', 'temperatura', 1154.0000, 'ºC'),
	(244760, 119, '2014-03-15 00:19:14.000000', 'temperatura', 1079.0000, 'ºC'),
	(244761, 119, '2014-03-15 00:19:15.000000', 'temperatura', 731.0000, 'ºC'),
	(244762, 119, '2014-03-15 00:19:16.000000', 'temperatura', 418.0000, 'ºC'),
	(244763, 119, '2014-03-15 00:19:17.000000', 'temperatura', 1100.0000, 'ºC'),
	(244764, 119, '2014-03-15 00:19:18.000000', 'temperatura', 645.0000, 'ºC'),
	(244765, 119, '2014-03-15 00:19:19.000000', 'temperatura', 1124.0000, 'ºC'),
	(244766, 119, '2014-03-15 00:19:20.000000', 'temperatura', 88.0000, 'ºC'),
	(244767, 119, '2014-03-15 00:19:21.000000', 'temperatura', 667.0000, 'ºC'),
	(244768, 119, '2014-03-15 00:19:22.000000', 'temperatura', 670.0000, 'ºC'),
	(244769, 119, '2014-03-15 00:19:23.000000', 'temperatura', 152.0000, 'ºC'),
	(244770, 119, '2014-03-15 00:19:24.000000', 'temperatura', 1148.0000, 'ºC'),
	(244771, 119, '2014-03-15 00:19:25.000000', 'temperatura', 485.0000, 'ºC'),
	(244772, 119, '2014-03-15 00:19:26.000000', 'temperatura', 183.0000, 'ºC'),
	(244773, 119, '2014-03-15 00:19:27.000000', 'temperatura', 659.0000, 'ºC'),
	(244774, 119, '2014-03-15 00:19:28.000000', 'temperatura', 349.0000, 'ºC'),
	(244775, 119, '2014-03-15 00:19:29.000000', 'temperatura', 966.0000, 'ºC'),
	(244776, 119, '2014-03-15 00:19:30.000000', 'temperatura', 185.0000, 'ºC'),
	(244777, 119, '2014-03-15 00:19:31.000000', 'temperatura', 428.0000, 'ºC'),
	(244778, 119, '2014-03-15 00:19:32.000000', 'temperatura', 385.0000, 'ºC'),
	(244779, 119, '2014-03-15 00:19:33.000000', 'temperatura', 640.0000, 'ºC'),
	(244780, 119, '2014-03-15 00:19:34.000000', 'temperatura', 846.0000, 'ºC'),
	(244781, 119, '2014-03-15 00:19:35.000000', 'temperatura', 1112.0000, 'ºC'),
	(244782, 119, '2014-03-15 00:19:36.000000', 'temperatura', 622.0000, 'ºC'),
	(244783, 119, '2014-03-15 00:19:37.000000', 'temperatura', 972.0000, 'ºC'),
	(244784, 119, '2014-03-15 00:19:38.000000', 'temperatura', 598.0000, 'ºC'),
	(244785, 119, '2014-03-15 00:19:39.000000', 'temperatura', 74.0000, 'ºC'),
	(244786, 119, '2014-03-15 00:19:40.000000', 'temperatura', 974.0000, 'ºC'),
	(244787, 119, '2014-03-15 00:19:41.000000', 'temperatura', 1050.0000, 'ºC'),
	(244788, 119, '2014-03-15 00:19:42.000000', 'temperatura', 1128.0000, 'ºC'),
	(244789, 119, '2014-03-15 00:19:43.000000', 'temperatura', 92.0000, 'ºC'),
	(244790, 119, '2014-03-15 00:19:44.000000', 'temperatura', 675.0000, 'ºC'),
	(244791, 119, '2014-03-15 00:19:45.000000', 'temperatura', 702.0000, 'ºC'),
	(244792, 119, '2014-03-15 00:19:46.000000', 'temperatura', 284.0000, 'ºC'),
	(244793, 119, '2014-03-15 00:19:47.000000', 'temperatura', 514.0000, 'ºC'),
	(244794, 119, '2014-03-15 00:19:48.000000', 'temperatura', 521.0000, 'ºC'),
	(244795, 119, '2014-03-15 00:19:49.000000', 'temperatura', 1060.0000, 'ºC'),
	(244796, 119, '2014-03-15 00:19:50.000000', 'temperatura', 141.0000, 'ºC'),
	(244797, 119, '2014-03-15 00:19:51.000000', 'temperatura', 1123.0000, 'ºC'),
	(244798, 119, '2014-03-15 00:19:52.000000', 'temperatura', 393.0000, 'ºC'),
	(244799, 119, '2014-03-15 00:19:53.000000', 'temperatura', 997.0000, 'ºC'),
	(244800, 119, '2014-03-15 00:19:54.000000', 'temperatura', 205.0000, 'ºC'),
	(244801, 119, '2014-03-15 00:19:55.000000', 'temperatura', 435.0000, 'ºC'),
	(244802, 119, '2014-03-15 00:19:56.000000', 'temperatura', 361.0000, 'ºC'),
	(244803, 119, '2014-03-15 00:19:57.000000', 'temperatura', 498.0000, 'ºC'),
	(244804, 119, '2014-03-15 00:19:58.000000', 'temperatura', 210.0000, 'ºC'),
	(244805, 119, '2014-03-15 00:19:59.000000', 'temperatura', 757.0000, 'ºC'),
	(244806, 119, '2014-03-15 00:20:00.000000', 'temperatura', 757.0000, 'ºC'),
	(244807, 119, '2014-03-15 00:20:01.000000', 'temperatura', 311.0000, 'ºC'),
	(244808, 119, '2014-03-15 00:20:02.000000', 'temperatura', 485.0000, 'ºC'),
	(244809, 119, '2014-03-15 00:20:03.000000', 'temperatura', 294.0000, 'ºC'),
	(244810, 119, '2014-03-15 00:20:04.000000', 'temperatura', 13.0000, 'ºC'),
	(244811, 119, '2014-03-15 00:20:05.000000', 'temperatura', 385.0000, 'ºC'),
	(244812, 119, '2014-03-15 00:20:06.000000', 'temperatura', 687.0000, 'ºC'),
	(244813, 119, '2014-03-15 00:20:07.000000', 'temperatura', 1078.0000, 'ºC'),
	(244814, 119, '2014-03-15 00:20:08.000000', 'temperatura', 932.0000, 'ºC'),
	(244815, 119, '2014-03-15 00:20:09.000000', 'temperatura', 228.0000, 'ºC'),
	(244816, 119, '2014-03-15 00:20:10.000000', 'temperatura', 742.0000, 'ºC'),
	(244817, 119, '2014-03-15 00:20:11.000000', 'temperatura', 627.0000, 'ºC'),
	(244818, 119, '2014-03-15 00:20:12.000000', 'temperatura', 911.0000, 'ºC'),
	(244819, 119, '2014-03-15 00:20:13.000000', 'temperatura', 273.0000, 'ºC'),
	(244820, 119, '2014-03-15 00:20:14.000000', 'temperatura', 1032.0000, 'ºC'),
	(244821, 119, '2014-03-15 00:20:15.000000', 'temperatura', 743.0000, 'ºC'),
	(244822, 119, '2014-03-15 00:20:16.000000', 'temperatura', 618.0000, 'ºC'),
	(244823, 119, '2014-03-15 00:20:17.000000', 'temperatura', 862.0000, 'ºC'),
	(244824, 119, '2014-03-15 00:20:18.000000', 'temperatura', 56.0000, 'ºC'),
	(244825, 119, '2014-03-15 00:20:19.000000', 'temperatura', 97.0000, 'ºC'),
	(244826, 119, '2014-03-15 00:20:20.000000', 'temperatura', 315.0000, 'ºC'),
	(244827, 119, '2014-03-15 00:20:21.000000', 'temperatura', 84.0000, 'ºC'),
	(244828, 119, '2014-03-15 00:20:22.000000', 'temperatura', 676.0000, 'ºC'),
	(244829, 119, '2014-03-15 00:20:23.000000', 'temperatura', 730.0000, 'ºC'),
	(244830, 119, '2014-03-15 00:20:24.000000', 'temperatura', 421.0000, 'ºC'),
	(244831, 119, '2014-03-15 00:20:25.000000', 'temperatura', 1115.0000, 'ºC'),
	(244832, 119, '2014-03-15 00:20:26.000000', 'temperatura', 714.0000, 'ºC'),
	(244833, 119, '2014-03-15 00:20:27.000000', 'temperatura', 225.0000, 'ºC'),
	(244834, 119, '2014-03-15 00:20:28.000000', 'temperatura', 183.0000, 'ºC'),
	(244835, 119, '2014-03-15 00:20:29.000000', 'temperatura', 241.0000, 'ºC'),
	(244836, 119, '2014-03-15 00:20:30.000000', 'temperatura', 655.0000, 'ºC'),
	(244837, 119, '2014-03-15 00:20:31.000000', 'temperatura', 152.0000, 'ºC'),
	(244838, 119, '2014-03-15 00:20:32.000000', 'temperatura', 1195.0000, 'ºC'),
	(244839, 119, '2014-03-15 00:20:33.000000', 'temperatura', 721.0000, 'ºC'),
	(244840, 119, '2014-03-15 00:20:34.000000', 'temperatura', 21.0000, 'ºC'),
	(244841, 119, '2014-03-15 00:20:35.000000', 'temperatura', 342.0000, 'ºC'),
	(244842, 119, '2014-03-15 00:20:36.000000', 'temperatura', 449.0000, 'ºC'),
	(244843, 119, '2014-03-15 00:20:37.000000', 'temperatura', 18.0000, 'ºC'),
	(244844, 119, '2014-03-15 00:20:38.000000', 'temperatura', 1142.0000, 'ºC'),
	(244845, 119, '2014-03-15 00:20:39.000000', 'temperatura', 858.0000, 'ºC'),
	(244846, 119, '2014-03-15 00:20:40.000000', 'temperatura', 866.0000, 'ºC'),
	(244847, 119, '2014-03-15 00:20:41.000000', 'temperatura', 553.0000, 'ºC'),
	(244848, 119, '2014-03-15 00:20:42.000000', 'temperatura', 171.0000, 'ºC'),
	(244849, 119, '2014-03-15 00:20:43.000000', 'temperatura', 395.0000, 'ºC'),
	(244850, 119, '2014-03-15 00:20:44.000000', 'temperatura', 264.0000, 'ºC'),
	(244851, 119, '2014-03-15 00:20:45.000000', 'temperatura', 136.0000, 'ºC'),
	(244852, 119, '2014-03-15 00:20:46.000000', 'temperatura', 1088.0000, 'ºC'),
	(244853, 119, '2014-03-15 00:20:47.000000', 'temperatura', 232.0000, 'ºC'),
	(244854, 119, '2014-03-15 00:20:48.000000', 'temperatura', 295.0000, 'ºC'),
	(244855, 119, '2014-03-15 00:20:49.000000', 'temperatura', 780.0000, 'ºC'),
	(244856, 119, '2014-03-15 00:20:50.000000', 'temperatura', 615.0000, 'ºC'),
	(244857, 119, '2014-03-15 00:20:51.000000', 'temperatura', 738.0000, 'ºC'),
	(244858, 119, '2014-03-15 00:20:52.000000', 'temperatura', 645.0000, 'ºC'),
	(244859, 119, '2014-03-15 00:20:53.000000', 'temperatura', 1011.0000, 'ºC'),
	(244860, 119, '2014-03-15 00:20:54.000000', 'temperatura', 719.0000, 'ºC'),
	(244861, 119, '2014-03-15 00:20:55.000000', 'temperatura', 562.0000, 'ºC'),
	(244862, 119, '2014-03-15 00:20:56.000000', 'temperatura', 654.0000, 'ºC'),
	(244863, 119, '2014-03-15 00:20:57.000000', 'temperatura', 386.0000, 'ºC'),
	(244864, 119, '2014-03-15 00:20:58.000000', 'temperatura', 1169.0000, 'ºC'),
	(244865, 119, '2014-03-15 00:20:59.000000', 'temperatura', 1087.0000, 'ºC'),
	(244866, 119, '2014-03-15 00:21:00.000000', 'temperatura', 726.0000, 'ºC'),
	(244867, 119, '2014-03-15 00:21:01.000000', 'temperatura', 373.0000, 'ºC'),
	(244868, 119, '2014-03-15 00:21:02.000000', 'temperatura', 885.0000, 'ºC'),
	(244869, 119, '2014-03-15 00:21:03.000000', 'temperatura', 907.0000, 'ºC'),
	(244870, 119, '2014-03-15 00:21:04.000000', 'temperatura', 681.0000, 'ºC'),
	(244871, 119, '2014-03-15 00:21:05.000000', 'temperatura', 685.0000, 'ºC'),
	(244872, 119, '2014-03-15 00:21:06.000000', 'temperatura', 182.0000, 'ºC'),
	(244873, 119, '2014-03-15 00:21:07.000000', 'temperatura', 55.0000, 'ºC'),
	(244874, 119, '2014-03-15 00:21:08.000000', 'temperatura', 930.0000, 'ºC'),
	(244875, 119, '2014-03-15 00:21:09.000000', 'temperatura', 884.0000, 'ºC'),
	(244876, 119, '2014-03-15 00:21:10.000000', 'temperatura', 433.0000, 'ºC'),
	(244877, 119, '2014-03-15 00:21:11.000000', 'temperatura', 713.0000, 'ºC'),
	(244878, 119, '2014-03-15 00:21:12.000000', 'temperatura', 1067.0000, 'ºC'),
	(244879, 119, '2014-03-15 00:21:13.000000', 'temperatura', 795.0000, 'ºC'),
	(244880, 119, '2014-03-15 00:21:14.000000', 'temperatura', 775.0000, 'ºC'),
	(244881, 119, '2014-03-15 00:21:15.000000', 'temperatura', 292.0000, 'ºC'),
	(244882, 119, '2014-03-15 00:21:16.000000', 'temperatura', 334.0000, 'ºC'),
	(244883, 119, '2014-03-15 00:21:17.000000', 'temperatura', 796.0000, 'ºC'),
	(244884, 119, '2014-03-15 00:21:18.000000', 'temperatura', 577.0000, 'ºC'),
	(244885, 119, '2014-03-15 00:21:19.000000', 'temperatura', 499.0000, 'ºC'),
	(244886, 119, '2014-03-15 00:21:20.000000', 'temperatura', 765.0000, 'ºC'),
	(244887, 119, '2014-03-15 00:21:21.000000', 'temperatura', 1127.0000, 'ºC'),
	(244888, 119, '2014-03-15 00:21:22.000000', 'temperatura', 943.0000, 'ºC'),
	(244889, 119, '2014-03-15 00:21:23.000000', 'temperatura', 132.0000, 'ºC'),
	(244890, 119, '2014-03-15 00:21:24.000000', 'temperatura', 233.0000, 'ºC'),
	(244891, 119, '2014-03-15 00:21:25.000000', 'temperatura', 770.0000, 'ºC'),
	(244892, 119, '2014-03-15 00:21:26.000000', 'temperatura', 750.0000, 'ºC'),
	(244893, 119, '2014-03-15 00:21:27.000000', 'temperatura', 241.0000, 'ºC'),
	(244894, 119, '2014-03-15 00:21:28.000000', 'temperatura', 154.0000, 'ºC'),
	(244895, 119, '2014-03-15 00:21:29.000000', 'temperatura', 50.0000, 'ºC'),
	(244896, 119, '2014-03-15 00:21:30.000000', 'temperatura', 987.0000, 'ºC'),
	(244897, 119, '2014-03-15 00:21:31.000000', 'temperatura', 1184.0000, 'ºC'),
	(244898, 119, '2014-03-15 00:21:32.000000', 'temperatura', 562.0000, 'ºC'),
	(244899, 119, '2014-03-15 00:21:33.000000', 'temperatura', 458.0000, 'ºC'),
	(244900, 119, '2014-03-15 00:21:34.000000', 'temperatura', 602.0000, 'ºC'),
	(244901, 119, '2014-03-15 00:21:35.000000', 'temperatura', 439.0000, 'ºC'),
	(244902, 119, '2014-03-15 00:21:36.000000', 'temperatura', 388.0000, 'ºC'),
	(244903, 119, '2014-03-15 00:21:37.000000', 'temperatura', 624.0000, 'ºC'),
	(244904, 119, '2014-03-15 00:21:38.000000', 'temperatura', 757.0000, 'ºC'),
	(244905, 119, '2014-03-15 00:21:39.000000', 'temperatura', 714.0000, 'ºC'),
	(244906, 119, '2014-03-15 00:21:40.000000', 'temperatura', 97.0000, 'ºC'),
	(244907, 119, '2014-03-15 00:21:41.000000', 'temperatura', 746.0000, 'ºC'),
	(244908, 119, '2014-03-15 00:21:42.000000', 'temperatura', 1041.0000, 'ºC'),
	(244909, 119, '2014-03-15 00:21:43.000000', 'temperatura', 565.0000, 'ºC'),
	(244910, 119, '2014-03-15 00:21:44.000000', 'temperatura', 902.0000, 'ºC'),
	(244911, 119, '2014-03-15 00:21:45.000000', 'temperatura', 415.0000, 'ºC'),
	(244912, 119, '2014-03-15 00:21:46.000000', 'temperatura', 572.0000, 'ºC'),
	(244913, 119, '2014-03-15 00:21:47.000000', 'temperatura', 415.0000, 'ºC'),
	(244914, 119, '2014-03-15 00:21:48.000000', 'temperatura', 361.0000, 'ºC'),
	(244915, 119, '2014-03-15 00:21:49.000000', 'temperatura', 559.0000, 'ºC'),
	(244916, 119, '2014-03-15 00:21:50.000000', 'temperatura', 511.0000, 'ºC'),
	(244917, 119, '2014-03-15 00:21:51.000000', 'temperatura', 880.0000, 'ºC'),
	(244918, 119, '2014-03-15 00:21:52.000000', 'temperatura', 467.0000, 'ºC'),
	(244919, 119, '2014-03-15 00:21:53.000000', 'temperatura', 897.0000, 'ºC'),
	(244920, 119, '2014-03-15 00:21:54.000000', 'temperatura', 683.0000, 'ºC'),
	(244921, 119, '2014-03-15 00:21:55.000000', 'temperatura', 725.0000, 'ºC'),
	(244922, 119, '2014-03-15 00:21:56.000000', 'temperatura', 376.0000, 'ºC'),
	(244923, 119, '2014-03-15 00:21:57.000000', 'temperatura', 905.0000, 'ºC'),
	(244924, 119, '2014-03-15 00:21:58.000000', 'temperatura', 998.0000, 'ºC'),
	(244925, 119, '2014-03-15 00:21:59.000000', 'temperatura', 1077.0000, 'ºC'),
	(244926, 119, '2014-03-15 00:22:00.000000', 'temperatura', 1191.0000, 'ºC'),
	(244927, 119, '2014-03-15 00:22:01.000000', 'temperatura', 322.0000, 'ºC'),
	(244928, 119, '2014-03-15 00:22:02.000000', 'temperatura', 441.0000, 'ºC'),
	(244929, 119, '2014-03-15 00:22:03.000000', 'temperatura', 38.0000, 'ºC'),
	(244930, 119, '2014-03-15 00:22:04.000000', 'temperatura', 67.0000, 'ºC'),
	(244931, 119, '2014-03-15 00:22:05.000000', 'temperatura', 223.0000, 'ºC'),
	(244932, 119, '2014-03-15 00:22:06.000000', 'temperatura', 913.0000, 'ºC'),
	(244933, 119, '2014-03-15 00:22:07.000000', 'temperatura', 298.0000, 'ºC'),
	(244934, 119, '2014-03-15 00:22:08.000000', 'temperatura', 1150.0000, 'ºC'),
	(244935, 119, '2014-03-15 00:22:09.000000', 'temperatura', 57.0000, 'ºC'),
	(244936, 119, '2014-03-15 00:22:10.000000', 'temperatura', 437.0000, 'ºC'),
	(244937, 119, '2014-03-15 00:22:11.000000', 'temperatura', 812.0000, 'ºC'),
	(244938, 119, '2014-03-15 00:22:12.000000', 'temperatura', 351.0000, 'ºC'),
	(244939, 119, '2014-03-15 00:22:13.000000', 'temperatura', 518.0000, 'ºC'),
	(244940, 119, '2014-03-15 00:22:14.000000', 'temperatura', 339.0000, 'ºC'),
	(244941, 119, '2014-03-15 00:22:15.000000', 'temperatura', 142.0000, 'ºC'),
	(244942, 119, '2014-03-15 00:22:16.000000', 'temperatura', 892.0000, 'ºC'),
	(244943, 119, '2014-03-15 00:22:17.000000', 'temperatura', 433.0000, 'ºC'),
	(244944, 119, '2014-03-15 00:22:18.000000', 'temperatura', 691.0000, 'ºC'),
	(244945, 119, '2014-03-15 00:22:19.000000', 'temperatura', 956.0000, 'ºC'),
	(244946, 119, '2014-03-15 00:22:20.000000', 'temperatura', 308.0000, 'ºC'),
	(244947, 119, '2014-03-15 00:22:21.000000', 'temperatura', 1072.0000, 'ºC'),
	(244948, 119, '2014-03-15 00:22:22.000000', 'temperatura', 838.0000, 'ºC'),
	(244949, 119, '2014-03-15 00:22:23.000000', 'temperatura', 972.0000, 'ºC'),
	(244950, 119, '2014-03-15 00:22:24.000000', 'temperatura', 1147.0000, 'ºC'),
	(244951, 119, '2014-03-15 00:22:25.000000', 'temperatura', 419.0000, 'ºC'),
	(244952, 119, '2014-03-15 00:22:26.000000', 'temperatura', 1056.0000, 'ºC'),
	(244953, 119, '2014-03-15 00:22:27.000000', 'temperatura', 422.0000, 'ºC'),
	(244954, 119, '2014-03-15 00:22:28.000000', 'temperatura', 145.0000, 'ºC'),
	(244955, 119, '2014-03-15 00:22:29.000000', 'temperatura', 657.0000, 'ºC'),
	(244956, 119, '2014-03-15 00:22:30.000000', 'temperatura', 450.0000, 'ºC'),
	(244957, 119, '2014-03-15 00:22:31.000000', 'temperatura', 281.0000, 'ºC'),
	(244958, 119, '2014-03-15 00:22:32.000000', 'temperatura', 54.0000, 'ºC'),
	(244959, 119, '2014-03-15 00:22:33.000000', 'temperatura', 629.0000, 'ºC'),
	(244960, 119, '2014-03-15 00:22:34.000000', 'temperatura', 584.0000, 'ºC'),
	(244961, 119, '2014-03-15 00:22:35.000000', 'temperatura', 1033.0000, 'ºC'),
	(244962, 119, '2014-03-15 00:22:36.000000', 'temperatura', 1012.0000, 'ºC'),
	(244963, 119, '2014-03-15 00:22:37.000000', 'temperatura', 763.0000, 'ºC'),
	(244964, 119, '2014-03-15 00:22:38.000000', 'temperatura', 777.0000, 'ºC'),
	(244965, 119, '2014-03-15 00:22:39.000000', 'temperatura', 398.0000, 'ºC'),
	(244966, 119, '2014-03-15 00:22:40.000000', 'temperatura', 861.0000, 'ºC'),
	(244967, 119, '2014-03-15 00:22:41.000000', 'temperatura', 712.0000, 'ºC'),
	(244968, 119, '2014-03-15 00:22:42.000000', 'temperatura', 977.0000, 'ºC'),
	(244969, 119, '2014-03-15 00:22:43.000000', 'temperatura', 349.0000, 'ºC'),
	(244970, 119, '2014-03-15 00:22:44.000000', 'temperatura', 12.0000, 'ºC'),
	(244971, 119, '2014-03-15 00:22:45.000000', 'temperatura', 217.0000, 'ºC'),
	(244972, 119, '2014-03-15 00:22:46.000000', 'temperatura', 1049.0000, 'ºC'),
	(244973, 119, '2014-03-15 00:22:47.000000', 'temperatura', 993.0000, 'ºC'),
	(244974, 119, '2014-03-15 00:22:48.000000', 'temperatura', 620.0000, 'ºC'),
	(244975, 119, '2014-03-15 00:22:49.000000', 'temperatura', 121.0000, 'ºC'),
	(244976, 119, '2014-03-15 00:22:50.000000', 'temperatura', 1143.0000, 'ºC'),
	(244977, 119, '2014-03-15 00:22:51.000000', 'temperatura', 556.0000, 'ºC'),
	(244978, 119, '2014-03-15 00:22:52.000000', 'temperatura', 550.0000, 'ºC'),
	(244979, 119, '2014-03-15 00:22:53.000000', 'temperatura', 1083.0000, 'ºC'),
	(244980, 119, '2014-03-15 00:22:54.000000', 'temperatura', 165.0000, 'ºC'),
	(244981, 119, '2014-03-15 00:22:55.000000', 'temperatura', 1178.0000, 'ºC'),
	(244982, 119, '2014-03-15 00:22:56.000000', 'temperatura', 594.0000, 'ºC'),
	(244983, 119, '2014-03-15 00:22:57.000000', 'temperatura', 636.0000, 'ºC'),
	(244984, 119, '2014-03-15 00:22:58.000000', 'temperatura', 200.0000, 'ºC'),
	(244985, 119, '2014-03-15 00:22:59.000000', 'temperatura', 291.0000, 'ºC'),
	(244986, 119, '2014-03-15 00:23:00.000000', 'temperatura', 856.0000, 'ºC'),
	(244987, 119, '2014-03-15 00:23:01.000000', 'temperatura', 1008.0000, 'ºC'),
	(244988, 119, '2014-03-15 00:23:02.000000', 'temperatura', 71.0000, 'ºC'),
	(244989, 119, '2014-03-15 00:23:03.000000', 'temperatura', 931.0000, 'ºC'),
	(244990, 119, '2014-03-15 00:23:04.000000', 'temperatura', 842.0000, 'ºC'),
	(244991, 119, '2014-03-15 00:23:05.000000', 'temperatura', 220.0000, 'ºC'),
	(244992, 119, '2014-03-15 00:23:06.000000', 'temperatura', 975.0000, 'ºC'),
	(244993, 119, '2014-03-15 00:23:07.000000', 'temperatura', 616.0000, 'ºC'),
	(244994, 119, '2014-03-15 00:23:08.000000', 'temperatura', 155.0000, 'ºC'),
	(244995, 119, '2014-03-15 00:23:09.000000', 'temperatura', 128.0000, 'ºC'),
	(244996, 119, '2014-03-15 00:23:10.000000', 'temperatura', 174.0000, 'ºC'),
	(244997, 119, '2014-03-15 00:23:11.000000', 'temperatura', 488.0000, 'ºC'),
	(244998, 119, '2014-03-15 00:23:12.000000', 'temperatura', 718.0000, 'ºC'),
	(244999, 119, '2014-03-15 00:23:13.000000', 'temperatura', 926.0000, 'ºC'),
	(245000, 119, '2014-03-15 00:23:14.000000', 'temperatura', 77.0000, 'ºC'),
	(245001, 119, '2014-03-15 00:23:15.000000', 'temperatura', 8.0000, 'ºC'),
	(245002, 119, '2014-03-15 00:23:16.000000', 'temperatura', 1009.0000, 'ºC'),
	(245003, 119, '2014-03-15 00:23:17.000000', 'temperatura', 222.0000, 'ºC'),
	(245004, 119, '2014-03-15 00:23:18.000000', 'temperatura', 484.0000, 'ºC'),
	(245005, 119, '2014-03-15 00:23:19.000000', 'temperatura', 554.0000, 'ºC'),
	(245006, 119, '2014-03-15 00:23:20.000000', 'temperatura', 119.0000, 'ºC'),
	(245007, 119, '2014-03-15 00:23:21.000000', 'temperatura', 132.0000, 'ºC'),
	(245008, 119, '2014-03-15 00:23:22.000000', 'temperatura', 306.0000, 'ºC'),
	(245009, 119, '2014-03-15 00:23:23.000000', 'temperatura', 1132.0000, 'ºC'),
	(245010, 119, '2014-03-15 00:23:24.000000', 'temperatura', 1145.0000, 'ºC'),
	(245011, 119, '2014-03-15 00:23:25.000000', 'temperatura', 1129.0000, 'ºC'),
	(245012, 119, '2014-03-15 00:23:26.000000', 'temperatura', 1011.0000, 'ºC'),
	(245013, 119, '2014-03-15 00:23:27.000000', 'temperatura', 467.0000, 'ºC'),
	(245014, 119, '2014-03-15 00:23:28.000000', 'temperatura', 505.0000, 'ºC'),
	(245015, 119, '2014-03-15 00:23:29.000000', 'temperatura', 1124.0000, 'ºC'),
	(245016, 119, '2014-03-15 00:23:30.000000', 'temperatura', 505.0000, 'ºC'),
	(245017, 119, '2014-03-15 00:23:31.000000', 'temperatura', 352.0000, 'ºC'),
	(245018, 119, '2014-03-15 00:23:32.000000', 'temperatura', 246.0000, 'ºC'),
	(245019, 119, '2014-03-15 00:23:33.000000', 'temperatura', 174.0000, 'ºC'),
	(245020, 119, '2014-03-15 00:23:34.000000', 'temperatura', 135.0000, 'ºC'),
	(245021, 119, '2014-03-15 00:23:35.000000', 'temperatura', 153.0000, 'ºC'),
	(245022, 119, '2014-03-15 00:23:36.000000', 'temperatura', 361.0000, 'ºC'),
	(245023, 119, '2014-03-15 00:23:37.000000', 'temperatura', 144.0000, 'ºC'),
	(245024, 119, '2014-03-15 00:23:38.000000', 'temperatura', 840.0000, 'ºC'),
	(245025, 119, '2014-03-15 00:23:39.000000', 'temperatura', 167.0000, 'ºC'),
	(245026, 119, '2014-03-15 00:23:40.000000', 'temperatura', 718.0000, 'ºC'),
	(245027, 119, '2014-03-15 00:23:41.000000', 'temperatura', 687.0000, 'ºC'),
	(245028, 119, '2014-03-15 00:23:42.000000', 'temperatura', 84.0000, 'ºC'),
	(245029, 119, '2014-03-15 00:23:43.000000', 'temperatura', 758.0000, 'ºC'),
	(245030, 119, '2014-03-15 00:23:44.000000', 'temperatura', 1137.0000, 'ºC'),
	(245031, 119, '2014-03-15 00:23:45.000000', 'temperatura', 1012.0000, 'ºC'),
	(245032, 119, '2014-03-15 00:23:46.000000', 'temperatura', 451.0000, 'ºC'),
	(245033, 119, '2014-03-15 00:23:47.000000', 'temperatura', 417.0000, 'ºC'),
	(245034, 119, '2014-03-15 00:23:48.000000', 'temperatura', 733.0000, 'ºC'),
	(245035, 119, '2014-03-15 00:23:49.000000', 'temperatura', 14.0000, 'ºC'),
	(245036, 119, '2014-03-15 00:23:50.000000', 'temperatura', 274.0000, 'ºC'),
	(245037, 119, '2014-03-15 00:23:51.000000', 'temperatura', 127.0000, 'ºC'),
	(245038, 119, '2014-03-15 00:23:52.000000', 'temperatura', 1013.0000, 'ºC'),
	(245039, 119, '2014-03-15 00:23:53.000000', 'temperatura', 1084.0000, 'ºC'),
	(245040, 119, '2014-03-15 00:23:54.000000', 'temperatura', 1180.0000, 'ºC'),
	(245041, 119, '2014-03-15 00:23:55.000000', 'temperatura', 252.0000, 'ºC'),
	(245042, 119, '2014-03-15 00:23:56.000000', 'temperatura', 119.0000, 'ºC'),
	(245043, 119, '2014-03-15 00:23:57.000000', 'temperatura', 1039.0000, 'ºC'),
	(245044, 119, '2014-03-15 00:23:58.000000', 'temperatura', 41.0000, 'ºC'),
	(245045, 119, '2014-03-15 00:23:59.000000', 'temperatura', 687.0000, 'ºC'),
	(245046, 119, '2014-03-15 00:24:00.000000', 'temperatura', 911.0000, 'ºC'),
	(245047, 119, '2014-03-15 00:24:01.000000', 'temperatura', 97.0000, 'ºC'),
	(245048, 119, '2014-03-15 00:24:02.000000', 'temperatura', 151.0000, 'ºC'),
	(245049, 119, '2014-03-15 00:24:03.000000', 'temperatura', 464.0000, 'ºC'),
	(245050, 119, '2014-03-15 00:24:04.000000', 'temperatura', 666.0000, 'ºC'),
	(245051, 119, '2014-03-15 00:24:05.000000', 'temperatura', 742.0000, 'ºC'),
	(245052, 119, '2014-03-15 00:24:06.000000', 'temperatura', 511.0000, 'ºC'),
	(245053, 119, '2014-03-15 00:24:07.000000', 'temperatura', 330.0000, 'ºC'),
	(245054, 119, '2014-03-15 00:24:08.000000', 'temperatura', 116.0000, 'ºC'),
	(245055, 119, '2014-03-15 00:24:09.000000', 'temperatura', 790.0000, 'ºC'),
	(245056, 119, '2014-03-15 00:24:10.000000', 'temperatura', 5.0000, 'ºC'),
	(245057, 119, '2014-03-15 00:24:11.000000', 'temperatura', 55.0000, 'ºC'),
	(245058, 119, '2014-03-15 00:24:12.000000', 'temperatura', 262.0000, 'ºC'),
	(245059, 119, '2014-03-15 00:24:13.000000', 'temperatura', 1144.0000, 'ºC'),
	(245060, 119, '2014-03-15 00:24:14.000000', 'temperatura', 137.0000, 'ºC'),
	(245061, 119, '2014-03-15 00:24:15.000000', 'temperatura', 851.0000, 'ºC'),
	(245062, 119, '2014-03-15 00:24:16.000000', 'temperatura', 243.0000, 'ºC'),
	(245063, 119, '2014-03-15 00:24:17.000000', 'temperatura', 1066.0000, 'ºC'),
	(245064, 119, '2014-03-15 00:24:18.000000', 'temperatura', 998.0000, 'ºC'),
	(245065, 119, '2014-03-15 00:24:19.000000', 'temperatura', 595.0000, 'ºC'),
	(245066, 119, '2014-03-15 00:24:20.000000', 'temperatura', 1183.0000, 'ºC'),
	(245067, 119, '2014-03-15 00:24:21.000000', 'temperatura', 528.0000, 'ºC'),
	(245068, 119, '2014-03-15 00:24:22.000000', 'temperatura', 291.0000, 'ºC'),
	(245069, 119, '2014-03-15 00:24:23.000000', 'temperatura', 1074.0000, 'ºC'),
	(245070, 119, '2014-03-15 00:24:24.000000', 'temperatura', 895.0000, 'ºC'),
	(245071, 119, '2014-03-15 00:24:25.000000', 'temperatura', 56.0000, 'ºC'),
	(245072, 119, '2014-03-15 00:24:26.000000', 'temperatura', 1195.0000, 'ºC'),
	(245073, 119, '2014-03-15 00:24:27.000000', 'temperatura', 1008.0000, 'ºC'),
	(245074, 119, '2014-03-15 00:24:28.000000', 'temperatura', 257.0000, 'ºC'),
	(245075, 119, '2014-03-15 00:24:29.000000', 'temperatura', 658.0000, 'ºC'),
	(245076, 119, '2014-03-15 00:24:30.000000', 'temperatura', 121.0000, 'ºC'),
	(245077, 119, '2014-03-15 00:24:31.000000', 'temperatura', 1031.0000, 'ºC'),
	(245078, 119, '2014-03-15 00:24:32.000000', 'temperatura', 1192.0000, 'ºC'),
	(245079, 119, '2014-03-15 00:24:33.000000', 'temperatura', 469.0000, 'ºC'),
	(245080, 119, '2014-03-15 00:24:34.000000', 'temperatura', 1170.0000, 'ºC'),
	(245081, 119, '2014-03-15 00:24:35.000000', 'temperatura', 845.0000, 'ºC'),
	(245082, 119, '2014-03-15 00:24:36.000000', 'temperatura', 713.0000, 'ºC'),
	(245083, 119, '2014-03-15 00:24:37.000000', 'temperatura', 1032.0000, 'ºC'),
	(245084, 119, '2014-03-15 00:24:38.000000', 'temperatura', 620.0000, 'ºC'),
	(245085, 119, '2014-03-15 00:24:39.000000', 'temperatura', 6.0000, 'ºC'),
	(245086, 119, '2014-03-15 00:24:40.000000', 'temperatura', 568.0000, 'ºC'),
	(245087, 119, '2014-03-15 00:24:41.000000', 'temperatura', 423.0000, 'ºC'),
	(245088, 119, '2014-03-15 00:24:42.000000', 'temperatura', 413.0000, 'ºC'),
	(245089, 119, '2014-03-15 00:24:43.000000', 'temperatura', 797.0000, 'ºC'),
	(245090, 119, '2014-03-15 00:24:44.000000', 'temperatura', 348.0000, 'ºC'),
	(245091, 119, '2014-03-15 00:24:45.000000', 'temperatura', 546.0000, 'ºC'),
	(245092, 119, '2014-03-15 00:24:46.000000', 'temperatura', 488.0000, 'ºC'),
	(245093, 119, '2014-03-15 00:24:47.000000', 'temperatura', 803.0000, 'ºC'),
	(245094, 119, '2014-03-15 00:24:48.000000', 'temperatura', 153.0000, 'ºC'),
	(245095, 119, '2014-03-15 00:24:49.000000', 'temperatura', 754.0000, 'ºC'),
	(245096, 119, '2014-03-15 00:24:50.000000', 'temperatura', 914.0000, 'ºC'),
	(245097, 119, '2014-03-15 00:24:51.000000', 'temperatura', 1109.0000, 'ºC'),
	(245098, 119, '2014-03-15 00:24:52.000000', 'temperatura', 401.0000, 'ºC'),
	(245099, 119, '2014-03-15 00:24:53.000000', 'temperatura', 1079.0000, 'ºC'),
	(245100, 119, '2014-03-15 00:24:54.000000', 'temperatura', 593.0000, 'ºC'),
	(245101, 119, '2014-03-15 00:24:55.000000', 'temperatura', 930.0000, 'ºC'),
	(245102, 119, '2014-03-15 00:24:56.000000', 'temperatura', 472.0000, 'ºC'),
	(245103, 119, '2014-03-15 00:24:57.000000', 'temperatura', 768.0000, 'ºC'),
	(245104, 119, '2014-03-15 00:24:58.000000', 'temperatura', 27.0000, 'ºC'),
	(245105, 119, '2014-03-15 00:24:59.000000', 'temperatura', 232.0000, 'ºC'),
	(245106, 119, '2014-03-15 00:25:00.000000', 'temperatura', 1077.0000, 'ºC'),
	(245107, 119, '2014-03-15 00:25:01.000000', 'temperatura', 1089.0000, 'ºC'),
	(245108, 119, '2014-03-15 00:25:02.000000', 'temperatura', 1017.0000, 'ºC'),
	(245109, 119, '2014-03-15 00:25:03.000000', 'temperatura', 619.0000, 'ºC'),
	(245110, 119, '2014-03-15 00:25:04.000000', 'temperatura', 45.0000, 'ºC'),
	(245111, 119, '2014-03-15 00:25:05.000000', 'temperatura', 767.0000, 'ºC'),
	(245112, 119, '2014-03-15 00:25:06.000000', 'temperatura', 101.0000, 'ºC'),
	(245113, 119, '2014-03-15 00:25:07.000000', 'temperatura', 604.0000, 'ºC'),
	(245114, 119, '2014-03-15 00:25:08.000000', 'temperatura', 316.0000, 'ºC'),
	(245115, 119, '2014-03-15 00:25:09.000000', 'temperatura', 968.0000, 'ºC'),
	(245116, 119, '2014-03-15 00:25:10.000000', 'temperatura', 296.0000, 'ºC'),
	(245117, 119, '2014-03-15 00:25:11.000000', 'temperatura', 974.0000, 'ºC'),
	(245118, 119, '2014-03-15 00:25:12.000000', 'temperatura', 383.0000, 'ºC'),
	(245119, 119, '2014-03-15 00:25:13.000000', 'temperatura', 192.0000, 'ºC'),
	(245120, 119, '2014-03-15 00:25:14.000000', 'temperatura', 1015.0000, 'ºC'),
	(245121, 119, '2014-03-15 00:25:15.000000', 'temperatura', 896.0000, 'ºC'),
	(245122, 119, '2014-03-15 00:25:16.000000', 'temperatura', 238.0000, 'ºC'),
	(245123, 119, '2014-03-15 00:25:17.000000', 'temperatura', 901.0000, 'ºC'),
	(245124, 119, '2014-03-15 00:25:18.000000', 'temperatura', 191.0000, 'ºC'),
	(245125, 119, '2014-03-15 00:25:19.000000', 'temperatura', 653.0000, 'ºC'),
	(245126, 119, '2014-03-15 00:25:20.000000', 'temperatura', 294.0000, 'ºC'),
	(245127, 119, '2014-03-15 00:25:21.000000', 'temperatura', 712.0000, 'ºC'),
	(245128, 119, '2014-03-15 00:25:22.000000', 'temperatura', 277.0000, 'ºC'),
	(245129, 119, '2014-03-15 00:25:23.000000', 'temperatura', 452.0000, 'ºC'),
	(245130, 119, '2014-03-15 00:25:24.000000', 'temperatura', 228.0000, 'ºC'),
	(245131, 119, '2014-03-15 00:25:25.000000', 'temperatura', 982.0000, 'ºC'),
	(245132, 119, '2014-03-15 00:25:26.000000', 'temperatura', 630.0000, 'ºC'),
	(245133, 119, '2014-03-15 00:25:27.000000', 'temperatura', 203.0000, 'ºC'),
	(245134, 119, '2014-03-15 00:25:28.000000', 'temperatura', 326.0000, 'ºC'),
	(245135, 119, '2014-03-15 00:25:29.000000', 'temperatura', 1023.0000, 'ºC'),
	(245136, 119, '2014-03-15 00:25:30.000000', 'temperatura', 536.0000, 'ºC'),
	(245137, 119, '2014-03-15 00:25:31.000000', 'temperatura', 810.0000, 'ºC'),
	(245138, 119, '2014-03-15 00:25:32.000000', 'temperatura', 43.0000, 'ºC'),
	(245139, 119, '2014-03-15 00:25:33.000000', 'temperatura', 186.0000, 'ºC'),
	(245140, 119, '2014-03-15 00:25:34.000000', 'temperatura', 800.0000, 'ºC'),
	(245141, 119, '2014-03-15 00:25:35.000000', 'temperatura', 1043.0000, 'ºC'),
	(245142, 119, '2014-03-15 00:25:36.000000', 'temperatura', 415.0000, 'ºC'),
	(245143, 119, '2014-03-15 00:25:37.000000', 'temperatura', 145.0000, 'ºC'),
	(245144, 119, '2014-03-15 00:25:38.000000', 'temperatura', 682.0000, 'ºC'),
	(245145, 119, '2014-03-15 00:25:39.000000', 'temperatura', 577.0000, 'ºC'),
	(245146, 119, '2014-03-15 00:25:40.000000', 'temperatura', 840.0000, 'ºC'),
	(245147, 119, '2014-03-15 00:25:41.000000', 'temperatura', 69.0000, 'ºC'),
	(245148, 119, '2014-03-15 00:25:42.000000', 'temperatura', 223.0000, 'ºC'),
	(245149, 119, '2014-03-15 00:25:43.000000', 'temperatura', 911.0000, 'ºC'),
	(245150, 119, '2014-03-15 00:25:44.000000', 'temperatura', 286.0000, 'ºC'),
	(245151, 119, '2014-03-15 00:25:45.000000', 'temperatura', 1097.0000, 'ºC'),
	(245152, 119, '2014-03-15 00:25:46.000000', 'temperatura', 1029.0000, 'ºC'),
	(245153, 119, '2014-03-15 00:25:47.000000', 'temperatura', 654.0000, 'ºC'),
	(245154, 119, '2014-03-15 00:25:48.000000', 'temperatura', 184.0000, 'ºC'),
	(245155, 119, '2014-03-15 00:25:49.000000', 'temperatura', 158.0000, 'ºC'),
	(245156, 119, '2014-03-15 00:25:50.000000', 'temperatura', 239.0000, 'ºC'),
	(245157, 119, '2014-03-15 00:25:51.000000', 'temperatura', 721.0000, 'ºC'),
	(245158, 119, '2014-03-15 00:25:52.000000', 'temperatura', 489.0000, 'ºC'),
	(245159, 119, '2014-03-15 00:25:53.000000', 'temperatura', 283.0000, 'ºC'),
	(245160, 119, '2014-03-15 00:25:54.000000', 'temperatura', 1147.0000, 'ºC'),
	(245161, 119, '2014-03-15 00:25:55.000000', 'temperatura', 88.0000, 'ºC'),
	(245162, 119, '2014-03-15 00:25:56.000000', 'temperatura', 600.0000, 'ºC'),
	(245163, 119, '2014-03-15 00:25:57.000000', 'temperatura', 337.0000, 'ºC'),
	(245164, 119, '2014-03-15 00:25:58.000000', 'temperatura', 1083.0000, 'ºC'),
	(245165, 119, '2014-03-15 00:25:59.000000', 'temperatura', 806.0000, 'ºC'),
	(245166, 119, '2014-03-15 00:26:00.000000', 'temperatura', 783.0000, 'ºC'),
	(245167, 119, '2014-03-15 00:26:01.000000', 'temperatura', 296.0000, 'ºC'),
	(245168, 119, '2014-03-15 00:26:02.000000', 'temperatura', 331.0000, 'ºC'),
	(245169, 119, '2014-03-15 00:26:03.000000', 'temperatura', 769.0000, 'ºC'),
	(245170, 119, '2014-03-15 00:26:04.000000', 'temperatura', 451.0000, 'ºC'),
	(245171, 119, '2014-03-15 00:26:05.000000', 'temperatura', 1151.0000, 'ºC'),
	(245172, 119, '2014-03-15 00:26:06.000000', 'temperatura', 801.0000, 'ºC'),
	(245173, 119, '2014-03-15 00:26:07.000000', 'temperatura', 554.0000, 'ºC'),
	(245174, 119, '2014-03-15 00:26:08.000000', 'temperatura', 368.0000, 'ºC'),
	(245175, 119, '2014-03-15 00:26:09.000000', 'temperatura', 177.0000, 'ºC'),
	(245176, 119, '2014-03-15 00:26:10.000000', 'temperatura', 981.0000, 'ºC'),
	(245177, 119, '2014-03-15 00:26:11.000000', 'temperatura', 777.0000, 'ºC'),
	(245178, 119, '2014-03-15 00:26:12.000000', 'temperatura', 942.0000, 'ºC'),
	(245179, 119, '2014-03-15 00:26:13.000000', 'temperatura', 1178.0000, 'ºC'),
	(245180, 119, '2014-03-15 00:26:14.000000', 'temperatura', 664.0000, 'ºC'),
	(245181, 119, '2014-03-15 00:26:15.000000', 'temperatura', 987.0000, 'ºC'),
	(245182, 119, '2014-03-15 00:26:16.000000', 'temperatura', 543.0000, 'ºC'),
	(245183, 119, '2014-03-15 00:26:17.000000', 'temperatura', 953.0000, 'ºC'),
	(245184, 119, '2014-03-15 00:26:18.000000', 'temperatura', 738.0000, 'ºC'),
	(245185, 119, '2014-03-15 00:26:19.000000', 'temperatura', 833.0000, 'ºC'),
	(245186, 119, '2014-03-15 00:26:20.000000', 'temperatura', 748.0000, 'ºC'),
	(245187, 119, '2014-03-15 00:26:21.000000', 'temperatura', 45.0000, 'ºC'),
	(245188, 119, '2014-03-15 00:26:22.000000', 'temperatura', 380.0000, 'ºC'),
	(245189, 119, '2014-03-15 00:26:23.000000', 'temperatura', 564.0000, 'ºC'),
	(245190, 119, '2014-03-15 00:26:24.000000', 'temperatura', 482.0000, 'ºC'),
	(245191, 119, '2014-03-15 00:26:25.000000', 'temperatura', 720.0000, 'ºC'),
	(245192, 119, '2014-03-15 00:26:26.000000', 'temperatura', 954.0000, 'ºC'),
	(245193, 119, '2014-03-15 00:26:27.000000', 'temperatura', 212.0000, 'ºC'),
	(245194, 119, '2014-03-15 00:26:28.000000', 'temperatura', 596.0000, 'ºC'),
	(245195, 119, '2014-03-15 00:26:29.000000', 'temperatura', 1145.0000, 'ºC'),
	(245196, 119, '2014-03-15 00:26:30.000000', 'temperatura', 339.0000, 'ºC'),
	(245197, 119, '2014-03-15 00:26:31.000000', 'temperatura', 661.0000, 'ºC'),
	(245198, 119, '2014-03-15 00:26:32.000000', 'temperatura', 1089.0000, 'ºC'),
	(245199, 119, '2014-03-15 00:26:33.000000', 'temperatura', 1062.0000, 'ºC'),
	(245200, 119, '2014-03-15 00:26:34.000000', 'temperatura', 843.0000, 'ºC'),
	(245201, 119, '2014-03-15 00:26:35.000000', 'temperatura', 1031.0000, 'ºC'),
	(245202, 119, '2014-03-15 00:26:36.000000', 'temperatura', 226.0000, 'ºC'),
	(245203, 119, '2014-03-15 00:26:37.000000', 'temperatura', 436.0000, 'ºC'),
	(245204, 119, '2014-03-15 00:26:38.000000', 'temperatura', 303.0000, 'ºC'),
	(245205, 119, '2014-03-15 00:26:39.000000', 'temperatura', 210.0000, 'ºC'),
	(245206, 119, '2014-03-15 00:26:40.000000', 'temperatura', 139.0000, 'ºC'),
	(245207, 119, '2014-03-15 00:26:41.000000', 'temperatura', 65.0000, 'ºC'),
	(245208, 119, '2014-03-15 00:26:42.000000', 'temperatura', 1110.0000, 'ºC'),
	(245209, 119, '2014-03-15 00:26:43.000000', 'temperatura', 555.0000, 'ºC'),
	(245210, 119, '2014-03-15 00:26:44.000000', 'temperatura', 644.0000, 'ºC'),
	(245211, 119, '2014-03-15 00:26:45.000000', 'temperatura', 356.0000, 'ºC'),
	(245212, 119, '2014-03-15 00:26:46.000000', 'temperatura', 1047.0000, 'ºC'),
	(245213, 119, '2014-03-15 00:26:47.000000', 'temperatura', 569.0000, 'ºC'),
	(245214, 119, '2014-03-15 00:26:48.000000', 'temperatura', 906.0000, 'ºC'),
	(245215, 119, '2014-03-15 00:26:49.000000', 'temperatura', 421.0000, 'ºC'),
	(245216, 119, '2014-03-15 00:26:50.000000', 'temperatura', 589.0000, 'ºC'),
	(245217, 119, '2014-03-15 00:26:51.000000', 'temperatura', 483.0000, 'ºC'),
	(245218, 119, '2014-03-15 00:26:52.000000', 'temperatura', 648.0000, 'ºC'),
	(245219, 119, '2014-03-15 00:26:53.000000', 'temperatura', 590.0000, 'ºC'),
	(245220, 119, '2014-03-15 00:26:54.000000', 'temperatura', 1006.0000, 'ºC'),
	(245221, 119, '2014-03-15 00:26:55.000000', 'temperatura', 864.0000, 'ºC'),
	(245222, 119, '2014-03-15 00:26:56.000000', 'temperatura', 99.0000, 'ºC'),
	(245223, 119, '2014-03-15 00:26:57.000000', 'temperatura', 307.0000, 'ºC'),
	(245224, 119, '2014-03-15 00:26:58.000000', 'temperatura', 35.0000, 'ºC'),
	(245225, 119, '2014-03-15 00:26:59.000000', 'temperatura', 455.0000, 'ºC'),
	(245226, 119, '2014-03-15 00:27:00.000000', 'temperatura', 972.0000, 'ºC'),
	(245227, 119, '2014-03-15 00:27:01.000000', 'temperatura', 1096.0000, 'ºC'),
	(245228, 119, '2014-03-15 00:27:02.000000', 'temperatura', 163.0000, 'ºC'),
	(245229, 119, '2014-03-15 00:27:03.000000', 'temperatura', 1127.0000, 'ºC'),
	(245230, 119, '2014-03-15 00:27:04.000000', 'temperatura', 345.0000, 'ºC'),
	(245231, 119, '2014-03-15 00:27:05.000000', 'temperatura', 746.0000, 'ºC'),
	(245232, 119, '2014-03-15 00:27:06.000000', 'temperatura', 297.0000, 'ºC'),
	(245233, 119, '2014-03-15 00:27:07.000000', 'temperatura', 447.0000, 'ºC'),
	(245234, 119, '2014-03-15 00:27:08.000000', 'temperatura', 144.0000, 'ºC'),
	(245235, 119, '2014-03-15 00:27:09.000000', 'temperatura', 581.0000, 'ºC'),
	(245236, 119, '2014-03-15 00:27:10.000000', 'temperatura', 73.0000, 'ºC'),
	(245237, 119, '2014-03-15 00:27:11.000000', 'temperatura', 1020.0000, 'ºC'),
	(245238, 119, '2014-03-15 00:27:12.000000', 'temperatura', 84.0000, 'ºC'),
	(245239, 119, '2014-03-15 00:27:13.000000', 'temperatura', 959.0000, 'ºC'),
	(245240, 119, '2014-03-15 00:27:14.000000', 'temperatura', 946.0000, 'ºC'),
	(245241, 119, '2014-03-15 00:27:15.000000', 'temperatura', 653.0000, 'ºC'),
	(245242, 119, '2014-03-15 00:27:16.000000', 'temperatura', 425.0000, 'ºC'),
	(245243, 119, '2014-03-15 00:27:17.000000', 'temperatura', 168.0000, 'ºC'),
	(245244, 119, '2014-03-15 00:27:18.000000', 'temperatura', 764.0000, 'ºC'),
	(245245, 119, '2014-03-15 00:27:19.000000', 'temperatura', 920.0000, 'ºC'),
	(245246, 119, '2014-03-15 00:27:20.000000', 'temperatura', 1105.0000, 'ºC'),
	(245247, 119, '2014-03-15 00:27:21.000000', 'temperatura', 365.0000, 'ºC'),
	(245248, 119, '2014-03-15 00:27:22.000000', 'temperatura', 912.0000, 'ºC'),
	(245249, 119, '2014-03-15 00:27:23.000000', 'temperatura', 1067.0000, 'ºC'),
	(245250, 119, '2014-03-15 00:27:24.000000', 'temperatura', 199.0000, 'ºC'),
	(245251, 119, '2014-03-15 00:27:25.000000', 'temperatura', 193.0000, 'ºC'),
	(245252, 119, '2014-03-15 00:27:26.000000', 'temperatura', 369.0000, 'ºC'),
	(245253, 119, '2014-03-15 00:27:27.000000', 'temperatura', 69.0000, 'ºC'),
	(245254, 119, '2014-03-15 00:27:28.000000', 'temperatura', 435.0000, 'ºC'),
	(245255, 119, '2014-03-15 00:27:29.000000', 'temperatura', 770.0000, 'ºC'),
	(245256, 119, '2014-03-15 00:27:30.000000', 'temperatura', 145.0000, 'ºC'),
	(245257, 119, '2014-03-15 00:27:31.000000', 'temperatura', 817.0000, 'ºC'),
	(245258, 119, '2014-03-15 00:27:32.000000', 'temperatura', 52.0000, 'ºC'),
	(245259, 119, '2014-03-15 00:27:33.000000', 'temperatura', 206.0000, 'ºC'),
	(245260, 119, '2014-03-15 00:27:34.000000', 'temperatura', 877.0000, 'ºC'),
	(245261, 119, '2014-03-15 00:27:35.000000', 'temperatura', 169.0000, 'ºC'),
	(245262, 119, '2014-03-15 00:27:36.000000', 'temperatura', 611.0000, 'ºC'),
	(245263, 119, '2014-03-15 00:27:37.000000', 'temperatura', 149.0000, 'ºC'),
	(245264, 119, '2014-03-15 00:27:38.000000', 'temperatura', 112.0000, 'ºC'),
	(245265, 119, '2014-03-15 00:27:39.000000', 'temperatura', 115.0000, 'ºC'),
	(245266, 119, '2014-03-15 00:27:40.000000', 'temperatura', 238.0000, 'ºC'),
	(245267, 119, '2014-03-15 00:27:41.000000', 'temperatura', 846.0000, 'ºC'),
	(245268, 119, '2014-03-15 00:27:42.000000', 'temperatura', 1117.0000, 'ºC'),
	(245269, 119, '2014-03-15 00:27:43.000000', 'temperatura', 649.0000, 'ºC'),
	(245270, 119, '2014-03-15 00:27:44.000000', 'temperatura', 1094.0000, 'ºC'),
	(245271, 119, '2014-03-15 00:27:45.000000', 'temperatura', 1125.0000, 'ºC'),
	(245272, 119, '2014-03-15 00:27:46.000000', 'temperatura', 1141.0000, 'ºC'),
	(245273, 119, '2014-03-15 00:27:47.000000', 'temperatura', 1132.0000, 'ºC'),
	(245274, 119, '2014-03-15 00:27:48.000000', 'temperatura', 1038.0000, 'ºC'),
	(245275, 119, '2014-03-15 00:27:49.000000', 'temperatura', 594.0000, 'ºC'),
	(245276, 119, '2014-03-15 00:27:50.000000', 'temperatura', 1057.0000, 'ºC'),
	(245277, 119, '2014-03-15 00:27:51.000000', 'temperatura', 1103.0000, 'ºC'),
	(245278, 119, '2014-03-15 00:27:52.000000', 'temperatura', 1146.0000, 'ºC'),
	(245279, 119, '2014-03-15 00:27:53.000000', 'temperatura', 21.0000, 'ºC'),
	(245280, 119, '2014-03-15 00:27:54.000000', 'temperatura', 269.0000, 'ºC'),
	(245281, 119, '2014-03-15 00:27:55.000000', 'temperatura', 80.0000, 'ºC'),
	(245282, 119, '2014-03-15 00:27:56.000000', 'temperatura', 796.0000, 'ºC'),
	(245283, 119, '2014-03-15 00:27:57.000000', 'temperatura', 140.0000, 'ºC'),
	(245284, 119, '2014-03-15 00:27:58.000000', 'temperatura', 714.0000, 'ºC'),
	(245285, 119, '2014-03-15 00:27:59.000000', 'temperatura', 749.0000, 'ºC'),
	(245286, 119, '2014-03-15 00:28:00.000000', 'temperatura', 406.0000, 'ºC'),
	(245287, 119, '2014-03-15 00:28:01.000000', 'temperatura', 980.0000, 'ºC'),
	(245288, 119, '2014-03-15 00:28:02.000000', 'temperatura', 85.0000, 'ºC'),
	(245289, 119, '2014-03-15 00:28:03.000000', 'temperatura', 1083.0000, 'ºC'),
	(245290, 119, '2014-03-15 00:28:04.000000', 'temperatura', 362.0000, 'ºC'),
	(245291, 119, '2014-03-15 00:28:05.000000', 'temperatura', 960.0000, 'ºC'),
	(245292, 119, '2014-03-15 00:28:06.000000', 'temperatura', 115.0000, 'ºC'),
	(245293, 119, '2014-03-15 00:28:07.000000', 'temperatura', 97.0000, 'ºC'),
	(245294, 119, '2014-03-15 00:28:08.000000', 'temperatura', 139.0000, 'ºC'),
	(245295, 119, '2014-03-15 00:28:09.000000', 'temperatura', 405.0000, 'ºC'),
	(245296, 119, '2014-03-15 00:28:10.000000', 'temperatura', 408.0000, 'ºC'),
	(245297, 119, '2014-03-15 00:28:11.000000', 'temperatura', 827.0000, 'ºC'),
	(245298, 119, '2014-03-15 00:28:12.000000', 'temperatura', 512.0000, 'ºC'),
	(245299, 119, '2014-03-15 00:28:13.000000', 'temperatura', 78.0000, 'ºC'),
	(245300, 119, '2014-03-15 00:28:14.000000', 'temperatura', 53.0000, 'ºC'),
	(245301, 119, '2014-03-15 00:28:15.000000', 'temperatura', 34.0000, 'ºC'),
	(245302, 119, '2014-03-15 00:28:16.000000', 'temperatura', 9.0000, 'ºC'),
	(245303, 119, '2014-03-15 00:28:17.000000', 'temperatura', 1147.0000, 'ºC'),
	(245304, 119, '2014-03-15 00:28:18.000000', 'temperatura', 906.0000, 'ºC'),
	(245305, 119, '2014-03-15 00:28:19.000000', 'temperatura', 1090.0000, 'ºC'),
	(245306, 119, '2014-03-15 00:28:20.000000', 'temperatura', 333.0000, 'ºC'),
	(245307, 119, '2014-03-15 00:28:21.000000', 'temperatura', 796.0000, 'ºC'),
	(245308, 119, '2014-03-15 00:28:22.000000', 'temperatura', 581.0000, 'ºC'),
	(245309, 119, '2014-03-15 00:28:23.000000', 'temperatura', 516.0000, 'ºC'),
	(245310, 119, '2014-03-15 00:28:24.000000', 'temperatura', 837.0000, 'ºC'),
	(245311, 119, '2014-03-15 00:28:25.000000', 'temperatura', 238.0000, 'ºC'),
	(245312, 119, '2014-03-15 00:28:26.000000', 'temperatura', 1081.0000, 'ºC'),
	(245313, 119, '2014-03-15 00:28:27.000000', 'temperatura', 1091.0000, 'ºC'),
	(245314, 119, '2014-03-15 00:28:28.000000', 'temperatura', 1011.0000, 'ºC'),
	(245315, 119, '2014-03-15 00:28:29.000000', 'temperatura', 585.0000, 'ºC'),
	(245316, 119, '2014-03-15 00:28:30.000000', 'temperatura', 1092.0000, 'ºC'),
	(245317, 119, '2014-03-15 00:28:31.000000', 'temperatura', 107.0000, 'ºC'),
	(245318, 119, '2014-03-15 00:28:32.000000', 'temperatura', 859.0000, 'ºC'),
	(245319, 119, '2014-03-15 00:28:33.000000', 'temperatura', 373.0000, 'ºC'),
	(245320, 119, '2014-03-15 00:28:34.000000', 'temperatura', 490.0000, 'ºC'),
	(245321, 119, '2014-03-15 00:28:35.000000', 'temperatura', 131.0000, 'ºC'),
	(245322, 119, '2014-03-15 00:28:36.000000', 'temperatura', 384.0000, 'ºC'),
	(245323, 119, '2014-03-15 00:28:37.000000', 'temperatura', 330.0000, 'ºC'),
	(245324, 119, '2014-03-15 00:28:38.000000', 'temperatura', 498.0000, 'ºC'),
	(245325, 119, '2014-03-15 00:28:39.000000', 'temperatura', 301.0000, 'ºC'),
	(245326, 119, '2014-03-15 00:28:40.000000', 'temperatura', 10.0000, 'ºC'),
	(245327, 119, '2014-03-15 00:28:41.000000', 'temperatura', 348.0000, 'ºC'),
	(245328, 119, '2014-03-15 00:28:42.000000', 'temperatura', 510.0000, 'ºC'),
	(245329, 119, '2014-03-15 00:28:43.000000', 'temperatura', 308.0000, 'ºC'),
	(245330, 119, '2014-03-15 00:28:44.000000', 'temperatura', 10.0000, 'ºC'),
	(245331, 119, '2014-03-15 00:28:45.000000', 'temperatura', 328.0000, 'ºC'),
	(245332, 119, '2014-03-15 00:28:46.000000', 'temperatura', 408.0000, 'ºC'),
	(245333, 119, '2014-03-15 00:28:47.000000', 'temperatura', 1059.0000, 'ºC'),
	(245334, 119, '2014-03-15 00:28:48.000000', 'temperatura', 470.0000, 'ºC'),
	(245335, 119, '2014-03-15 00:28:49.000000', 'temperatura', 373.0000, 'ºC'),
	(245336, 119, '2014-03-15 00:28:50.000000', 'temperatura', 456.0000, 'ºC'),
	(245337, 119, '2014-03-15 00:28:51.000000', 'temperatura', 1161.0000, 'ºC'),
	(245338, 119, '2014-03-15 00:28:52.000000', 'temperatura', 838.0000, 'ºC'),
	(245339, 119, '2014-03-15 00:28:53.000000', 'temperatura', 706.0000, 'ºC'),
	(245340, 119, '2014-03-15 00:28:54.000000', 'temperatura', 1017.0000, 'ºC'),
	(245341, 119, '2014-03-15 00:28:55.000000', 'temperatura', 569.0000, 'ºC'),
	(245342, 119, '2014-03-15 00:28:56.000000', 'temperatura', 992.0000, 'ºC'),
	(245343, 119, '2014-03-15 00:28:57.000000', 'temperatura', 856.0000, 'ºC'),
	(245344, 119, '2014-03-15 00:28:58.000000', 'temperatura', 103.0000, 'ºC'),
	(245345, 119, '2014-03-15 00:28:59.000000', 'temperatura', 348.0000, 'ºC'),
	(245346, 119, '2014-03-15 00:29:00.000000', 'temperatura', 233.0000, 'ºC'),
	(245347, 119, '2014-03-15 00:29:01.000000', 'temperatura', 119.0000, 'ºC'),
	(245348, 119, '2014-03-15 00:29:02.000000', 'temperatura', 1097.0000, 'ºC'),
	(245349, 119, '2014-03-15 00:29:03.000000', 'temperatura', 327.0000, 'ºC'),
	(245350, 119, '2014-03-15 00:29:04.000000', 'temperatura', 747.0000, 'ºC'),
	(245351, 119, '2014-03-15 00:29:05.000000', 'temperatura', 352.0000, 'ºC'),
	(245352, 119, '2014-03-15 00:29:06.000000', 'temperatura', 720.0000, 'ºC'),
	(245353, 119, '2014-03-15 00:29:07.000000', 'temperatura', 147.0000, 'ºC'),
	(245354, 119, '2014-03-15 00:29:08.000000', 'temperatura', 973.0000, 'ºC'),
	(245355, 119, '2014-03-15 00:29:09.000000', 'temperatura', 827.0000, 'ºC'),
	(245356, 119, '2014-03-15 00:29:10.000000', 'temperatura', 15.0000, 'ºC'),
	(245357, 119, '2014-03-15 00:29:11.000000', 'temperatura', 1197.0000, 'ºC'),
	(245358, 119, '2014-03-15 00:29:12.000000', 'temperatura', 1137.0000, 'ºC'),
	(245359, 119, '2014-03-15 00:29:13.000000', 'temperatura', 897.0000, 'ºC'),
	(245360, 119, '2014-03-15 00:29:14.000000', 'temperatura', 1072.0000, 'ºC'),
	(245361, 119, '2014-03-15 00:29:15.000000', 'temperatura', 270.0000, 'ºC'),
	(245362, 119, '2014-03-15 00:29:16.000000', 'temperatura', 536.0000, 'ºC'),
	(245363, 119, '2014-03-15 00:29:17.000000', 'temperatura', 671.0000, 'ºC'),
	(245364, 119, '2014-03-15 00:29:18.000000', 'temperatura', 548.0000, 'ºC'),
	(245365, 119, '2014-03-15 00:29:19.000000', 'temperatura', 725.0000, 'ºC'),
	(245366, 119, '2014-03-15 00:29:20.000000', 'temperatura', 784.0000, 'ºC'),
	(245367, 119, '2014-03-15 00:29:21.000000', 'temperatura', 545.0000, 'ºC'),
	(245368, 119, '2014-03-15 00:29:22.000000', 'temperatura', 373.0000, 'ºC'),
	(245369, 119, '2014-03-15 00:29:23.000000', 'temperatura', 232.0000, 'ºC'),
	(245370, 119, '2014-03-15 00:29:24.000000', 'temperatura', 42.0000, 'ºC'),
	(245371, 119, '2014-03-15 00:29:25.000000', 'temperatura', 712.0000, 'ºC'),
	(245372, 119, '2014-03-15 00:29:26.000000', 'temperatura', 1034.0000, 'ºC'),
	(245373, 119, '2014-03-15 00:29:27.000000', 'temperatura', 637.0000, 'ºC'),
	(245374, 119, '2014-03-15 00:29:28.000000', 'temperatura', 83.0000, 'ºC'),
	(245375, 119, '2014-03-15 00:29:29.000000', 'temperatura', 904.0000, 'ºC'),
	(245376, 119, '2014-03-15 00:29:30.000000', 'temperatura', 670.0000, 'ºC'),
	(245377, 119, '2014-03-15 00:29:31.000000', 'temperatura', 641.0000, 'ºC'),
	(245378, 119, '2014-03-15 00:29:32.000000', 'temperatura', 1192.0000, 'ºC'),
	(245379, 119, '2014-03-15 00:29:33.000000', 'temperatura', 441.0000, 'ºC'),
	(245380, 119, '2014-03-15 00:29:34.000000', 'temperatura', 1030.0000, 'ºC'),
	(245381, 119, '2014-03-15 00:29:35.000000', 'temperatura', 225.0000, 'ºC'),
	(245382, 119, '2014-03-15 00:29:36.000000', 'temperatura', 436.0000, 'ºC'),
	(245383, 119, '2014-03-15 00:29:37.000000', 'temperatura', 306.0000, 'ºC'),
	(245384, 119, '2014-03-15 00:29:38.000000', 'temperatura', 221.0000, 'ºC'),
	(245385, 119, '2014-03-15 00:29:39.000000', 'temperatura', 187.0000, 'ºC'),
	(245386, 119, '2014-03-15 00:29:40.000000', 'temperatura', 272.0000, 'ºC'),
	(245387, 119, '2014-03-15 00:29:41.000000', 'temperatura', 799.0000, 'ºC'),
	(245388, 119, '2014-03-15 00:29:42.000000', 'temperatura', 781.0000, 'ºC'),
	(245389, 119, '2014-03-15 00:29:43.000000', 'temperatura', 306.0000, 'ºC'),
	(245390, 119, '2014-03-15 00:29:44.000000', 'temperatura', 390.0000, 'ºC'),
	(245391, 119, '2014-03-15 00:29:45.000000', 'temperatura', 1030.0000, 'ºC'),
	(245392, 119, '2014-03-15 00:29:46.000000', 'temperatura', 381.0000, 'ºC'),
	(245393, 119, '2014-03-15 00:29:47.000000', 'temperatura', 15.0000, 'ºC'),
	(245394, 119, '2014-03-15 00:29:48.000000', 'temperatura', 134.0000, 'ºC'),
	(245395, 119, '2014-03-15 00:29:49.000000', 'temperatura', 627.0000, 'ºC'),
	(245396, 119, '2014-03-15 00:29:50.000000', 'temperatura', 331.0000, 'ºC'),
	(245397, 119, '2014-03-15 00:29:51.000000', 'temperatura', 975.0000, 'ºC'),
	(245398, 119, '2014-03-15 00:29:52.000000', 'temperatura', 284.0000, 'ºC'),
	(245399, 119, '2014-03-15 00:29:53.000000', 'temperatura', 896.0000, 'ºC'),
	(245400, 119, '2014-03-15 00:29:54.000000', 'temperatura', 28.0000, 'ºC'),
	(245401, 119, '2014-03-15 00:29:55.000000', 'temperatura', 1051.0000, 'ºC'),
	(245402, 119, '2014-03-15 00:29:56.000000', 'temperatura', 371.0000, 'ºC'),
	(245403, 119, '2014-03-15 00:29:57.000000', 'temperatura', 1105.0000, 'ºC'),
	(245404, 119, '2014-03-15 00:29:58.000000', 'temperatura', 809.0000, 'ºC'),
	(245405, 119, '2014-03-15 00:29:59.000000', 'temperatura', 733.0000, 'ºC'),
	(245406, 119, '2014-03-15 00:30:00.000000', 'temperatura', 39.0000, 'ºC'),
	(245407, 119, '2014-03-15 00:30:01.000000', 'temperatura', 397.0000, 'ºC'),
	(245408, 119, '2014-03-15 00:30:02.000000', 'temperatura', 667.0000, 'ºC'),
	(245409, 119, '2014-03-15 00:30:03.000000', 'temperatura', 944.0000, 'ºC'),
	(245410, 119, '2014-03-15 00:30:04.000000', 'temperatura', 321.0000, 'ºC'),
	(245411, 119, '2014-03-15 00:30:05.000000', 'temperatura', 1174.0000, 'ºC'),
	(245412, 119, '2014-03-15 00:30:06.000000', 'temperatura', 105.0000, 'ºC'),
	(245413, 119, '2014-03-15 00:30:07.000000', 'temperatura', 605.0000, 'ºC'),
	(245414, 119, '2014-03-15 00:30:08.000000', 'temperatura', 311.0000, 'ºC'),
	(245415, 119, '2014-03-15 00:30:09.000000', 'temperatura', 942.0000, 'ºC'),
	(245416, 119, '2014-03-15 00:30:10.000000', 'temperatura', 174.0000, 'ºC'),
	(245417, 119, '2014-03-15 00:30:11.000000', 'temperatura', 447.0000, 'ºC'),
	(245418, 119, '2014-03-15 00:30:12.000000', 'temperatura', 512.0000, 'ºC'),
	(245419, 119, '2014-03-15 00:30:13.000000', 'temperatura', 21.0000, 'ºC'),
	(245420, 119, '2014-03-15 00:30:14.000000', 'temperatura', 968.0000, 'ºC'),
	(245421, 119, '2014-03-15 00:30:15.000000', 'temperatura', 1177.0000, 'ºC'),
	(245422, 119, '2014-03-15 00:30:16.000000', 'temperatura', 584.0000, 'ºC'),
	(245423, 119, '2014-03-15 00:30:17.000000', 'temperatura', 589.0000, 'ºC'),
	(245424, 119, '2014-03-15 00:30:18.000000', 'temperatura', 1191.0000, 'ºC'),
	(245425, 119, '2014-03-15 00:30:19.000000', 'temperatura', 591.0000, 'ºC'),
	(245426, 119, '2014-03-15 00:30:20.000000', 'temperatura', 581.0000, 'ºC'),
	(245427, 119, '2014-03-15 00:30:21.000000', 'temperatura', 1131.0000, 'ºC'),
	(245428, 119, '2014-03-15 00:30:22.000000', 'temperatura', 315.0000, 'ºC'),
	(245429, 119, '2014-03-15 00:30:23.000000', 'temperatura', 580.0000, 'ºC'),
	(245430, 119, '2014-03-15 00:30:24.000000', 'temperatura', 757.0000, 'ºC'),
	(245431, 119, '2014-03-15 00:30:25.000000', 'temperatura', 845.0000, 'ºC'),
	(245432, 119, '2014-03-15 00:30:26.000000', 'temperatura', 756.0000, 'ºC'),
	(245433, 119, '2014-03-15 00:30:27.000000', 'temperatura', 44.0000, 'ºC'),
	(245434, 119, '2014-03-15 00:30:28.000000', 'temperatura', 351.0000, 'ºC'),
	(245435, 119, '2014-03-15 00:30:29.000000', 'temperatura', 426.0000, 'ºC'),
	(245436, 119, '2014-03-15 00:30:30.000000', 'temperatura', 1075.0000, 'ºC'),
	(245437, 119, '2014-03-15 00:30:31.000000', 'temperatura', 497.0000, 'ºC'),
	(245438, 119, '2014-03-15 00:30:32.000000', 'temperatura', 463.0000, 'ºC'),
	(245439, 119, '2014-03-15 00:30:33.000000', 'temperatura', 823.0000, 'ºC'),
	(245440, 119, '2014-03-15 00:30:34.000000', 'temperatura', 328.0000, 'ºC'),
	(245441, 119, '2014-03-15 00:30:35.000000', 'temperatura', 370.0000, 'ºC'),
	(245442, 119, '2014-03-15 00:30:36.000000', 'temperatura', 868.0000, 'ºC'),
	(245443, 119, '2014-03-15 00:30:37.000000', 'temperatura', 831.0000, 'ºC'),
	(245444, 119, '2014-03-15 00:30:38.000000', 'temperatura', 350.0000, 'ºC'),
	(245445, 119, '2014-03-15 00:30:39.000000', 'temperatura', 458.0000, 'ºC'),
	(245446, 119, '2014-03-15 00:30:40.000000', 'temperatura', 39.0000, 'ºC'),
	(245447, 119, '2014-03-15 00:30:41.000000', 'temperatura', 24.0000, 'ºC'),
	(245448, 119, '2014-03-15 00:30:42.000000', 'temperatura', 2.0000, 'ºC'),
	(245449, 119, '2014-03-15 00:30:43.000000', 'temperatura', 1139.0000, 'ºC'),
	(245450, 119, '2014-03-15 00:30:44.000000', 'temperatura', 888.0000, 'ºC'),
	(245451, 119, '2014-03-15 00:30:45.000000', 'temperatura', 1025.0000, 'ºC'),
	(245452, 119, '2014-03-15 00:30:46.000000', 'temperatura', 59.0000, 'ºC'),
	(245453, 119, '2014-03-15 00:30:47.000000', 'temperatura', 822.0000, 'ºC'),
	(245454, 119, '2014-03-15 00:30:48.000000', 'temperatura', 334.0000, 'ºC'),
	(245455, 119, '2014-03-15 00:30:49.000000', 'temperatura', 403.0000, 'ºC'),
	(245456, 119, '2014-03-15 00:30:50.000000', 'temperatura', 1012.0000, 'ºC'),
	(245457, 119, '2014-03-15 00:30:51.000000', 'temperatura', 255.0000, 'ºC'),
	(245458, 119, '2014-03-15 00:30:52.000000', 'temperatura', 638.0000, 'ºC'),
	(245459, 119, '2014-03-15 00:30:53.000000', 'temperatura', 26.0000, 'ºC'),
	(245460, 119, '2014-03-15 00:30:54.000000', 'temperatura', 616.0000, 'ºC'),
	(245461, 119, '2014-03-15 00:30:55.000000', 'temperatura', 602.0000, 'ºC'),
	(245462, 119, '2014-03-15 00:30:56.000000', 'temperatura', 1163.0000, 'ºC'),
	(245463, 119, '2014-03-15 00:30:57.000000', 'temperatura', 408.0000, 'ºC'),
	(245464, 119, '2014-03-15 00:30:58.000000', 'temperatura', 953.0000, 'ºC'),
	(245465, 119, '2014-03-15 00:30:59.000000', 'temperatura', 1140.0000, 'ºC'),
	(245466, 119, '2014-03-15 00:31:00.000000', 'temperatura', 442.0000, 'ºC'),
	(245467, 119, '2014-03-15 00:31:01.000000', 'temperatura', 1190.0000, 'ºC'),
	(245468, 119, '2014-03-15 00:31:02.000000', 'temperatura', 1023.0000, 'ºC'),
	(245469, 119, '2014-03-15 00:31:03.000000', 'temperatura', 347.0000, 'ºC'),
	(245470, 119, '2014-03-15 00:31:04.000000', 'temperatura', 1067.0000, 'ºC'),
	(245471, 119, '2014-03-15 00:31:05.000000', 'temperatura', 695.0000, 'ºC'),
	(245472, 119, '2014-03-15 00:31:06.000000', 'temperatura', 273.0000, 'ºC'),
	(245473, 119, '2014-03-15 00:31:07.000000', 'temperatura', 482.0000, 'ºC'),
	(245474, 119, '2014-03-15 00:31:08.000000', 'temperatura', 392.0000, 'ºC'),
	(245475, 119, '2014-03-15 00:31:09.000000', 'temperatura', 512.0000, 'ºC'),
	(245476, 119, '2014-03-15 00:31:10.000000', 'temperatura', 185.0000, 'ºC'),
	(245477, 119, '2014-03-15 00:31:11.000000', 'temperatura', 591.0000, 'ºC'),
	(245478, 119, '2014-03-15 00:31:12.000000', 'temperatura', 1198.0000, 'ºC'),
	(245479, 119, '2014-03-15 00:31:13.000000', 'temperatura', 620.0000, 'ºC'),
	(245480, 119, '2014-03-15 00:31:14.000000', 'temperatura', 706.0000, 'ºC'),
	(245481, 119, '2014-03-15 00:31:15.000000', 'temperatura', 469.0000, 'ºC'),
	(245482, 119, '2014-03-15 00:31:16.000000', 'temperatura', 230.0000, 'ºC'),
	(245483, 119, '2014-03-15 00:31:17.000000', 'temperatura', 941.0000, 'ºC'),
	(245484, 119, '2014-03-15 00:31:18.000000', 'temperatura', 418.0000, 'ºC'),
	(245485, 119, '2014-03-15 00:31:19.000000', 'temperatura', 468.0000, 'ºC'),
	(245486, 119, '2014-03-15 00:31:20.000000', 'temperatura', 1085.0000, 'ºC'),
	(245487, 119, '2014-03-15 00:31:21.000000', 'temperatura', 421.0000, 'ºC'),
	(245488, 119, '2014-03-15 00:31:22.000000', 'temperatura', 50.0000, 'ºC'),
	(245489, 119, '2014-03-15 00:31:23.000000', 'temperatura', 188.0000, 'ºC'),
	(245490, 119, '2014-03-15 00:31:24.000000', 'temperatura', 792.0000, 'ºC'),
	(245491, 119, '2014-03-15 00:31:25.000000', 'temperatura', 994.0000, 'ºC'),
	(245492, 119, '2014-03-15 00:31:26.000000', 'temperatura', 197.0000, 'ºC'),
	(245493, 119, '2014-03-15 00:31:27.000000', 'temperatura', 401.0000, 'ºC'),
	(245494, 119, '2014-03-15 00:31:28.000000', 'temperatura', 217.0000, 'ºC'),
	(245495, 119, '2014-03-15 00:31:29.000000', 'temperatura', 1080.0000, 'ºC'),
	(245496, 119, '2014-03-15 00:31:30.000000', 'temperatura', 1149.0000, 'ºC'),
	(245497, 119, '2014-03-15 00:31:31.000000', 'temperatura', 109.0000, 'ºC'),
	(245498, 119, '2014-03-15 00:31:32.000000', 'temperatura', 695.0000, 'ºC'),
	(245499, 119, '2014-03-15 00:31:33.000000', 'temperatura', 750.0000, 'ºC'),
	(245500, 119, '2014-03-15 00:31:34.000000', 'temperatura', 466.0000, 'ºC'),
	(245501, 119, '2014-03-15 00:31:35.000000', 'temperatura', 80.0000, 'ºC'),
	(245502, 119, '2014-03-15 00:31:36.000000', 'temperatura', 201.0000, 'ºC'),
	(245503, 119, '2014-03-15 00:31:37.000000', 'temperatura', 768.0000, 'ºC'),
	(245504, 119, '2014-03-15 00:31:38.000000', 'temperatura', 835.0000, 'ºC'),
	(245505, 119, '2014-03-15 00:31:39.000000', 'temperatura', 672.0000, 'ºC'),
	(245506, 119, '2014-03-15 00:31:40.000000', 'temperatura', 858.0000, 'ºC'),
	(245507, 119, '2014-03-15 00:31:41.000000', 'temperatura', 1073.0000, 'ºC'),
	(245508, 119, '2014-03-15 00:31:42.000000', 'temperatura', 392.0000, 'ºC'),
	(245509, 119, '2014-03-15 00:31:43.000000', 'temperatura', 1142.0000, 'ºC'),
	(245510, 119, '2014-03-15 00:31:44.000000', 'temperatura', 933.0000, 'ºC'),
	(245511, 119, '2014-03-15 00:31:45.000000', 'temperatura', 40.0000, 'ºC'),
	(245512, 119, '2014-03-15 00:31:46.000000', 'temperatura', 1003.0000, 'ºC'),
	(245513, 119, '2014-03-15 00:31:47.000000', 'temperatura', 96.0000, 'ºC'),
	(245514, 119, '2014-03-15 00:31:48.000000', 'temperatura', 1070.0000, 'ºC'),
	(245515, 119, '2014-03-15 00:31:49.000000', 'temperatura', 262.0000, 'ºC'),
	(245516, 119, '2014-03-15 00:31:50.000000', 'temperatura', 499.0000, 'ºC'),
	(245517, 119, '2014-03-15 00:31:51.000000', 'temperatura', 511.0000, 'ºC'),
	(245518, 119, '2014-03-15 00:31:52.000000', 'temperatura', 1059.0000, 'ºC'),
	(245519, 119, '2014-03-15 00:31:53.000000', 'temperatura', 163.0000, 'ºC'),
	(245520, 119, '2014-03-15 00:31:54.000000', 'temperatura', 36.0000, 'ºC'),
	(245521, 119, '2014-03-15 00:31:55.000000', 'temperatura', 893.0000, 'ºC'),
	(245522, 119, '2014-03-15 00:31:56.000000', 'temperatura', 759.0000, 'ºC'),
	(245523, 119, '2014-03-15 00:31:57.000000', 'temperatura', 1114.0000, 'ºC'),
	(245524, 119, '2014-03-15 00:31:58.000000', 'temperatura', 894.0000, 'ºC'),
	(245525, 119, '2014-03-15 00:31:59.000000', 'temperatura', 1131.0000, 'ºC'),
	(245526, 119, '2014-03-15 00:32:00.000000', 'temperatura', 571.0000, 'ºC'),
	(245527, 119, '2014-03-15 00:32:01.000000', 'temperatura', 663.0000, 'ºC'),
	(245528, 119, '2014-03-15 00:32:02.000000', 'temperatura', 404.0000, 'ºC'),
	(245529, 119, '2014-03-15 00:32:03.000000', 'temperatura', 31.0000, 'ºC'),
	(245530, 119, '2014-03-15 00:32:04.000000', 'temperatura', 142.0000, 'ºC'),
	(245531, 119, '2014-03-15 00:32:05.000000', 'temperatura', 616.0000, 'ºC'),
	(245532, 119, '2014-03-15 00:32:06.000000', 'temperatura', 257.0000, 'ºC'),
	(245533, 119, '2014-03-15 00:32:07.000000', 'temperatura', 637.0000, 'ºC'),
	(245534, 119, '2014-03-15 00:32:08.000000', 'temperatura', 15.0000, 'ºC'),
	(245535, 119, '2014-03-15 00:32:09.000000', 'temperatura', 565.0000, 'ºC'),
	(245536, 119, '2014-03-15 00:32:10.000000', 'temperatura', 382.0000, 'ºC'),
	(245537, 119, '2014-03-15 00:32:11.000000', 'temperatura', 214.0000, 'ºC'),
	(245538, 119, '2014-03-15 00:32:12.000000', 'temperatura', 1124.0000, 'ºC'),
	(245539, 119, '2014-03-15 00:32:13.000000', 'temperatura', 180.0000, 'ºC'),
	(245540, 119, '2014-03-15 00:32:14.000000', 'temperatura', 1129.0000, 'ºC'),
	(245541, 119, '2014-03-15 00:32:15.000000', 'temperatura', 306.0000, 'ºC'),
	(245542, 119, '2014-03-15 00:32:16.000000', 'temperatura', 543.0000, 'ºC'),
	(245543, 119, '2014-03-15 00:32:17.000000', 'temperatura', 599.0000, 'ºC'),
	(245544, 119, '2014-03-15 00:32:18.000000', 'temperatura', 163.0000, 'ºC'),
	(245545, 119, '2014-03-15 00:32:19.000000', 'temperatura', 222.0000, 'ºC'),
	(245546, 119, '2014-03-15 00:32:20.000000', 'temperatura', 619.0000, 'ºC'),
	(245547, 119, '2014-03-15 00:32:21.000000', 'temperatura', 32.0000, 'ºC'),
	(245548, 119, '2014-03-15 00:32:22.000000', 'temperatura', 704.0000, 'ºC'),
	(245549, 119, '2014-03-15 00:32:23.000000', 'temperatura', 1022.0000, 'ºC'),
	(245550, 119, '2014-03-15 00:32:24.000000', 'temperatura', 600.0000, 'ºC'),
	(245551, 119, '2014-03-15 00:32:25.000000', 'temperatura', 1133.0000, 'ºC'),
	(245552, 119, '2014-03-15 00:32:26.000000', 'temperatura', 265.0000, 'ºC'),
	(245553, 119, '2014-03-15 00:32:27.000000', 'temperatura', 327.0000, 'ºC'),
	(245554, 119, '2014-03-15 00:32:28.000000', 'temperatura', 841.0000, 'ºC'),
	(245555, 119, '2014-03-15 00:32:29.000000', 'temperatura', 824.0000, 'ºC'),
	(245556, 119, '2014-03-15 00:32:30.000000', 'temperatura', 399.0000, 'ºC'),
	(245557, 119, '2014-03-15 00:32:31.000000', 'temperatura', 723.0000, 'ºC'),
	(245558, 119, '2014-03-15 00:32:32.000000', 'temperatura', 17.0000, 'ºC'),
	(245559, 119, '2014-03-15 00:32:33.000000', 'temperatura', 319.0000, 'ºC'),
	(245560, 119, '2014-03-15 00:32:34.000000', 'temperatura', 344.0000, 'ºC'),
	(245561, 119, '2014-03-15 00:32:35.000000', 'temperatura', 763.0000, 'ºC'),
	(245562, 119, '2014-03-15 00:32:36.000000', 'temperatura', 385.0000, 'ºC'),
	(245563, 119, '2014-03-15 00:32:37.000000', 'temperatura', 836.0000, 'ºC'),
	(245564, 119, '2014-03-15 00:32:38.000000', 'temperatura', 623.0000, 'ºC'),
	(245565, 119, '2014-03-15 00:32:39.000000', 'temperatura', 611.0000, 'ºC'),
	(245566, 119, '2014-03-15 00:32:40.000000', 'temperatura', 1184.0000, 'ºC'),
	(245567, 119, '2014-03-15 00:32:41.000000', 'temperatura', 486.0000, 'ºC'),
	(245568, 119, '2014-03-15 00:32:42.000000', 'temperatura', 82.0000, 'ºC'),
	(245569, 119, '2014-03-15 00:32:43.000000', 'temperatura', 150.0000, 'ºC'),
	(245570, 119, '2014-03-15 00:32:44.000000', 'temperatura', 505.0000, 'ºC'),
	(245571, 119, '2014-03-15 00:32:45.000000', 'temperatura', 877.0000, 'ºC'),
	(245572, 119, '2014-03-15 00:32:46.000000', 'temperatura', 469.0000, 'ºC'),
	(245573, 119, '2014-03-15 00:32:47.000000', 'temperatura', 914.0000, 'ºC'),
	(245574, 119, '2014-03-15 00:32:48.000000', 'temperatura', 764.0000, 'ºC'),
	(245575, 119, '2014-03-15 00:32:49.000000', 'temperatura', 1078.0000, 'ºC'),
	(245576, 119, '2014-03-15 00:32:50.000000', 'temperatura', 698.0000, 'ºC'),
	(245577, 119, '2014-03-15 00:32:51.000000', 'temperatura', 256.0000, 'ºC'),
	(245578, 119, '2014-03-15 00:32:52.000000', 'temperatura', 389.0000, 'ºC'),
	(245579, 119, '2014-03-15 00:32:53.000000', 'temperatura', 1176.0000, 'ºC'),
	(245580, 119, '2014-03-15 00:32:54.000000', 'temperatura', 1114.0000, 'ºC'),
	(245581, 119, '2014-03-15 00:32:55.000000', 'temperatura', 841.0000, 'ºC'),
	(245582, 119, '2014-03-15 00:32:56.000000', 'temperatura', 863.0000, 'ºC'),
	(245583, 119, '2014-03-15 00:32:57.000000', 'temperatura', 592.0000, 'ºC'),
	(245584, 119, '2014-03-15 00:32:58.000000', 'temperatura', 374.0000, 'ºC'),
	(245585, 119, '2014-03-15 00:32:59.000000', 'temperatura', 93.0000, 'ºC'),
	(245586, 119, '2014-03-15 00:33:00.000000', 'temperatura', 543.0000, 'ºC'),
	(245587, 119, '2014-03-15 00:33:01.000000', 'temperatura', 39.0000, 'ºC'),
	(245588, 119, '2014-03-15 00:33:02.000000', 'temperatura', 965.0000, 'ºC'),
	(245589, 119, '2014-03-15 00:33:03.000000', 'temperatura', 1107.0000, 'ºC'),
	(245590, 119, '2014-03-15 00:33:04.000000', 'temperatura', 242.0000, 'ºC'),
	(245591, 119, '2014-03-15 00:33:05.000000', 'temperatura', 287.0000, 'ºC'),
	(245592, 119, '2014-03-15 00:33:06.000000', 'temperatura', 712.0000, 'ºC'),
	(245593, 119, '2014-03-15 00:33:07.000000', 'temperatura', 297.0000, 'ºC'),
	(245594, 119, '2014-03-15 00:33:08.000000', 'temperatura', 552.0000, 'ºC'),
	(245595, 119, '2014-03-15 00:33:09.000000', 'temperatura', 667.0000, 'ºC'),
	(245596, 119, '2014-03-15 00:33:10.000000', 'temperatura', 482.0000, 'ºC'),
	(245597, 119, '2014-03-15 00:33:11.000000', 'temperatura', 407.0000, 'ºC'),
	(245598, 119, '2014-03-15 00:33:12.000000', 'temperatura', 590.0000, 'ºC'),
	(245599, 119, '2014-03-15 00:33:13.000000', 'temperatura', 531.0000, 'ºC'),
	(245600, 119, '2014-03-15 00:33:14.000000', 'temperatura', 886.0000, 'ºC'),
	(245601, 119, '2014-03-15 00:33:15.000000', 'temperatura', 435.0000, 'ºC'),
	(245602, 119, '2014-03-15 00:33:16.000000', 'temperatura', 718.0000, 'ºC'),
	(245603, 119, '2014-03-15 00:33:17.000000', 'temperatura', 1084.0000, 'ºC'),
	(245604, 119, '2014-03-15 00:33:18.000000', 'temperatura', 869.0000, 'ºC'),
	(245605, 119, '2014-03-15 00:33:19.000000', 'temperatura', 1094.0000, 'ºC'),
	(245606, 119, '2014-03-15 00:33:20.000000', 'temperatura', 464.0000, 'ºC'),
	(245607, 119, '2014-03-15 00:33:21.000000', 'temperatura', 239.0000, 'ºC'),
	(245608, 119, '2014-03-15 00:33:22.000000', 'temperatura', 1004.0000, 'ºC'),
	(245609, 119, '2014-03-15 00:33:23.000000', 'temperatura', 704.0000, 'ºC'),
	(245610, 119, '2014-03-15 00:33:24.000000', 'temperatura', 507.0000, 'ºC'),
	(245611, 119, '2014-03-15 00:33:25.000000', 'temperatura', 424.0000, 'ºC'),
	(245612, 119, '2014-03-15 00:33:26.000000', 'temperatura', 599.0000, 'ºC'),
	(245613, 119, '2014-03-15 00:33:27.000000', 'temperatura', 525.0000, 'ºC'),
	(245614, 119, '2014-03-15 00:33:28.000000', 'temperatura', 827.0000, 'ºC'),
	(245615, 119, '2014-03-15 00:33:29.000000', 'temperatura', 159.0000, 'ºC'),
	(245616, 119, '2014-03-15 00:33:30.000000', 'temperatura', 716.0000, 'ºC'),
	(245617, 119, '2014-03-15 00:33:31.000000', 'temperatura', 704.0000, 'ºC'),
	(245618, 119, '2014-03-15 00:33:32.000000', 'temperatura', 174.0000, 'ºC'),
	(245619, 119, '2014-03-15 00:33:33.000000', 'temperatura', 1158.0000, 'ºC'),
	(245620, 119, '2014-03-15 00:33:34.000000', 'temperatura', 466.0000, 'ºC'),
	(245621, 119, '2014-03-15 00:33:35.000000', 'temperatura', 57.0000, 'ºC'),
	(245622, 119, '2014-03-15 00:33:36.000000', 'temperatura', 88.0000, 'ºC'),
	(245623, 119, '2014-03-15 00:33:37.000000', 'temperatura', 271.0000, 'ºC'),
	(245624, 119, '2014-03-15 00:33:38.000000', 'temperatura', 1093.0000, 'ºC'),
	(245625, 119, '2014-03-15 00:33:39.000000', 'temperatura', 1049.0000, 'ºC'),
	(245626, 119, '2014-03-15 00:33:40.000000', 'temperatura', 767.0000, 'ºC'),
	(245627, 119, '2014-03-15 00:33:41.000000', 'temperatura', 688.0000, 'ºC'),
	(245628, 119, '2014-03-15 00:33:42.000000', 'temperatura', 1141.0000, 'ºC'),
	(245629, 119, '2014-03-15 00:33:43.000000', 'temperatura', 43.0000, 'ºC'),
	(245630, 119, '2014-03-15 00:33:44.000000', 'temperatura', 391.0000, 'ºC'),
	(245631, 119, '2014-03-15 00:33:45.000000', 'temperatura', 628.0000, 'ºC'),
	(245632, 119, '2014-03-15 00:33:46.000000', 'temperatura', 767.0000, 'ºC'),
	(245633, 119, '2014-03-15 00:33:47.000000', 'temperatura', 749.0000, 'ºC'),
	(245634, 119, '2014-03-15 00:33:48.000000', 'temperatura', 247.0000, 'ºC'),
	(245635, 119, '2014-03-15 00:33:49.000000', 'temperatura', 190.0000, 'ºC'),
	(245636, 119, '2014-03-15 00:33:50.000000', 'temperatura', 207.0000, 'ºC'),
	(245637, 119, '2014-03-15 00:33:51.000000', 'temperatura', 465.0000, 'ºC'),
	(245638, 119, '2014-03-15 00:33:52.000000', 'temperatura', 506.0000, 'ºC'),
	(245639, 119, '2014-03-15 00:33:53.000000', 'temperatura', 1136.0000, 'ºC'),
	(245640, 119, '2014-03-15 00:33:54.000000', 'temperatura', 563.0000, 'ºC'),
	(245641, 119, '2014-03-15 00:33:55.000000', 'temperatura', 608.0000, 'ºC'),
	(245642, 119, '2014-03-15 00:33:56.000000', 'temperatura', 152.0000, 'ºC'),
	(245643, 119, '2014-03-15 00:33:57.000000', 'temperatura', 135.0000, 'ºC'),
	(245644, 119, '2014-03-15 00:33:58.000000', 'temperatura', 221.0000, 'ºC'),
	(245645, 119, '2014-03-15 00:33:59.000000', 'temperatura', 701.0000, 'ºC'),
	(245646, 119, '2014-03-15 00:34:00.000000', 'temperatura', 442.0000, 'ºC'),
	(245647, 119, '2014-03-15 00:34:01.000000', 'temperatura', 107.0000, 'ºC'),
	(245648, 119, '2014-03-15 00:34:02.000000', 'temperatura', 411.0000, 'ºC'),
	(245649, 119, '2014-03-15 00:34:03.000000', 'temperatura', 534.0000, 'ºC'),
	(245650, 119, '2014-03-15 00:34:04.000000', 'temperatura', 236.0000, 'ºC'),
	(245651, 119, '2014-03-15 00:34:05.000000', 'temperatura', 781.0000, 'ºC'),
	(245652, 119, '2014-03-15 00:34:06.000000', 'temperatura', 797.0000, 'ºC'),
	(245653, 119, '2014-03-15 00:34:07.000000', 'temperatura', 443.0000, 'ºC'),
	(245654, 119, '2014-03-15 00:34:08.000000', 'temperatura', 1025.0000, 'ºC'),
	(245655, 119, '2014-03-15 00:34:09.000000', 'temperatura', 198.0000, 'ºC'),
	(245656, 119, '2014-03-15 00:34:10.000000', 'temperatura', 312.0000, 'ºC'),
	(245657, 119, '2014-03-15 00:34:11.000000', 'temperatura', 968.0000, 'ºC'),
	(245658, 119, '2014-03-15 00:34:12.000000', 'temperatura', 306.0000, 'ºC'),
	(245659, 119, '2014-03-15 00:34:13.000000', 'temperatura', 1024.0000, 'ºC'),
	(245660, 119, '2014-03-15 00:34:14.000000', 'temperatura', 605.0000, 'ºC'),
	(245661, 119, '2014-03-15 00:34:15.000000', 'temperatura', 1153.0000, 'ºC'),
	(245662, 119, '2014-03-15 00:34:16.000000', 'temperatura', 350.0000, 'ºC'),
	(245663, 119, '2014-03-15 00:34:17.000000', 'temperatura', 693.0000, 'ºC'),
	(245664, 119, '2014-03-15 00:34:18.000000', 'temperatura', 15.0000, 'ºC'),
	(245665, 119, '2014-03-15 00:34:19.000000', 'temperatura', 397.0000, 'ºC'),
	(245666, 119, '2014-03-15 00:34:20.000000', 'temperatura', 741.0000, 'ºC'),
	(245667, 119, '2014-03-15 00:34:21.000000', 'temperatura', 114.0000, 'ºC'),
	(245668, 119, '2014-03-15 00:34:22.000000', 'temperatura', 749.0000, 'ºC'),
	(245669, 119, '2014-03-15 00:34:23.000000', 'temperatura', 1001.0000, 'ºC'),
	(245670, 119, '2014-03-15 00:34:24.000000', 'temperatura', 358.0000, 'ºC'),
	(245671, 119, '2014-03-15 00:34:25.000000', 'temperatura', 1189.0000, 'ºC'),
	(245672, 119, '2014-03-15 00:34:26.000000', 'temperatura', 69.0000, 'ºC'),
	(245673, 119, '2014-03-15 00:34:27.000000', 'temperatura', 382.0000, 'ºC'),
	(245674, 119, '2014-03-15 00:34:28.000000', 'temperatura', 502.0000, 'ºC'),
	(245675, 119, '2014-03-15 00:34:29.000000', 'temperatura', 163.0000, 'ºC'),
	(245676, 119, '2014-03-15 00:34:30.000000', 'temperatura', 511.0000, 'ºC'),
	(245677, 119, '2014-03-15 00:34:31.000000', 'temperatura', 867.0000, 'ºC'),
	(245678, 119, '2014-03-15 00:34:32.000000', 'temperatura', 403.0000, 'ºC'),
	(245679, 119, '2014-03-15 00:34:33.000000', 'temperatura', 614.0000, 'ºC'),
	(245680, 119, '2014-03-15 00:34:34.000000', 'temperatura', 662.0000, 'ºC'),
	(245681, 119, '2014-03-15 00:34:35.000000', 'temperatura', 266.0000, 'ºC'),
	(245682, 119, '2014-03-15 00:34:36.000000', 'temperatura', 547.0000, 'ºC'),
	(245683, 119, '2014-03-15 00:34:37.000000', 'temperatura', 736.0000, 'ºC'),
	(245684, 119, '2014-03-15 00:34:38.000000', 'temperatura', 842.0000, 'ºC'),
	(245685, 119, '2014-03-15 00:34:39.000000', 'temperatura', 801.0000, 'ºC'),
	(245686, 119, '2014-03-15 00:34:40.000000', 'temperatura', 279.0000, 'ºC'),
	(245687, 119, '2014-03-15 00:34:41.000000', 'temperatura', 194.0000, 'ºC'),
	(245688, 119, '2014-03-15 00:34:42.000000', 'temperatura', 132.0000, 'ºC'),
	(245689, 119, '2014-03-15 00:34:43.000000', 'temperatura', 78.0000, 'ºC'),
	(245690, 119, '2014-03-15 00:34:44.000000', 'temperatura', 1196.0000, 'ºC'),
	(245691, 119, '2014-03-15 00:34:45.000000', 'temperatura', 945.0000, 'ºC'),
	(245692, 119, '2014-03-15 00:34:46.000000', 'temperatura', 1139.0000, 'ºC'),
	(245693, 119, '2014-03-15 00:34:47.000000', 'temperatura', 462.0000, 'ºC'),
	(245694, 119, '2014-03-15 00:34:48.000000', 'temperatura', 91.0000, 'ºC'),
	(245695, 119, '2014-03-15 00:34:49.000000', 'temperatura', 268.0000, 'ºC'),
	(245696, 119, '2014-03-15 00:34:50.000000', 'temperatura', 1070.0000, 'ºC'),
	(245697, 119, '2014-03-15 00:34:51.000000', 'temperatura', 945.0000, 'ºC'),
	(245698, 119, '2014-03-15 00:34:52.000000', 'temperatura', 317.0000, 'ºC'),
	(245699, 119, '2014-03-15 00:34:53.000000', 'temperatura', 1148.0000, 'ºC'),
	(245700, 119, '2014-03-15 00:34:54.000000', 'temperatura', 1190.0000, 'ºC'),
	(245701, 119, '2014-03-15 00:34:55.000000', 'temperatura', 107.0000, 'ºC'),
	(245702, 119, '2014-03-15 00:34:56.000000', 'temperatura', 564.0000, 'ºC'),
	(245703, 119, '2014-03-15 00:34:57.000000', 'temperatura', 99.0000, 'ºC'),
	(245704, 119, '2014-03-15 00:34:58.000000', 'temperatura', 5.0000, 'ºC'),
	(245705, 119, '2014-03-15 00:34:59.000000', 'temperatura', 926.0000, 'ºC'),
	(245706, 119, '2014-03-15 00:35:00.000000', 'temperatura', 1017.0000, 'ºC'),
	(245707, 119, '2014-03-15 00:35:01.000000', 'temperatura', 1109.0000, 'ºC'),
	(245708, 119, '2014-03-15 00:35:02.000000', 'temperatura', 96.0000, 'ºC'),
	(245709, 119, '2014-03-15 00:35:03.000000', 'temperatura', 750.0000, 'ºC'),
	(245710, 119, '2014-03-15 00:35:04.000000', 'temperatura', 1062.0000, 'ºC'),
	(245711, 119, '2014-03-15 00:35:05.000000', 'temperatura', 662.0000, 'ºC'),
	(245712, 119, '2014-03-15 00:35:06.000000', 'temperatura', 123.0000, 'ºC'),
	(245713, 119, '2014-03-15 00:35:07.000000', 'temperatura', 1029.0000, 'ºC'),
	(245714, 119, '2014-03-15 00:35:08.000000', 'temperatura', 1179.0000, 'ºC'),
	(245715, 119, '2014-03-15 00:35:09.000000', 'temperatura', 409.0000, 'ºC'),
	(245716, 119, '2014-03-15 00:35:10.000000', 'temperatura', 905.0000, 'ºC'),
	(245717, 119, '2014-03-15 00:35:11.000000', 'temperatura', 902.0000, 'ºC'),
	(245718, 119, '2014-03-15 00:35:12.000000', 'temperatura', 595.0000, 'ºC'),
	(245719, 119, '2014-03-15 00:35:13.000000', 'temperatura', 271.0000, 'ºC'),
	(245720, 119, '2014-03-15 00:35:14.000000', 'temperatura', 768.0000, 'ºC'),
	(245721, 119, '2014-03-15 00:35:15.000000', 'temperatura', 629.0000, 'ºC'),
	(245722, 119, '2014-03-15 00:35:16.000000', 'temperatura', 841.0000, 'ºC'),
	(245723, 119, '2014-03-15 00:35:17.000000', 'temperatura', 1118.0000, 'ºC'),
	(245724, 119, '2014-03-15 00:35:18.000000', 'temperatura', 667.0000, 'ºC'),
	(245725, 119, '2014-03-15 00:35:19.000000', 'temperatura', 1180.0000, 'ºC'),
	(245726, 119, '2014-03-15 00:35:20.000000', 'temperatura', 301.0000, 'ºC'),
	(245727, 119, '2014-03-15 00:35:21.000000', 'temperatura', 366.0000, 'ºC'),
	(245728, 119, '2014-03-15 00:35:22.000000', 'temperatura', 928.0000, 'ºC'),
	(245729, 119, '2014-03-15 00:35:23.000000', 'temperatura', 1142.0000, 'ºC'),
	(245730, 119, '2014-03-15 00:35:24.000000', 'temperatura', 526.0000, 'ºC'),
	(245731, 119, '2014-03-15 00:35:25.000000', 'temperatura', 407.0000, 'ºC'),
	(245732, 119, '2014-03-15 00:35:26.000000', 'temperatura', 455.0000, 'ºC'),
	(245733, 119, '2014-03-15 00:35:27.000000', 'temperatura', 1053.0000, 'ºC'),
	(245734, 119, '2014-03-15 00:35:28.000000', 'temperatura', 304.0000, 'ºC'),
	(245735, 119, '2014-03-15 00:35:29.000000', 'temperatura', 760.0000, 'ºC'),
	(245736, 119, '2014-03-15 00:35:30.000000', 'temperatura', 487.0000, 'ºC'),
	(245737, 119, '2014-03-15 00:35:31.000000', 'temperatura', 159.0000, 'ºC'),
	(245738, 119, '2014-03-15 00:35:32.000000', 'temperatura', 531.0000, 'ºC'),
	(245739, 119, '2014-03-15 00:35:33.000000', 'temperatura', 979.0000, 'ºC'),
	(245740, 119, '2014-03-15 00:35:34.000000', 'temperatura', 903.0000, 'ºC'),
	(245741, 119, '2014-03-15 00:35:35.000000', 'temperatura', 380.0000, 'ºC'),
	(245742, 119, '2014-03-15 00:35:36.000000', 'temperatura', 392.0000, 'ºC'),
	(245743, 119, '2014-03-15 00:35:37.000000', 'temperatura', 818.0000, 'ºC'),
	(245744, 119, '2014-03-15 00:35:38.000000', 'temperatura', 517.0000, 'ºC'),
	(245745, 119, '2014-03-15 00:35:39.000000', 'temperatura', 132.0000, 'ºC'),
	(245746, 119, '2014-03-15 00:35:40.000000', 'temperatura', 308.0000, 'ºC'),
	(245747, 119, '2014-03-15 00:35:41.000000', 'temperatura', 1144.0000, 'ºC'),
	(245748, 119, '2014-03-15 00:35:42.000000', 'temperatura', 1197.0000, 'ºC'),
	(245749, 119, '2014-03-15 00:35:43.000000', 'temperatura', 153.0000, 'ºC'),
	(245750, 119, '2014-03-15 00:35:44.000000', 'temperatura', 774.0000, 'ºC'),
	(245751, 119, '2014-03-15 00:35:45.000000', 'temperatura', 1012.0000, 'ºC'),
	(245752, 119, '2014-03-15 00:35:46.000000', 'temperatura', 337.0000, 'ºC'),
	(245753, 119, '2014-03-15 00:35:47.000000', 'temperatura', 1052.0000, 'ºC'),
	(245754, 119, '2014-03-15 00:35:48.000000', 'temperatura', 649.0000, 'ºC'),
	(245755, 119, '2014-03-15 00:35:49.000000', 'temperatura', 90.0000, 'ºC'),
	(245756, 119, '2014-03-15 00:35:50.000000', 'temperatura', 903.0000, 'ºC'),
	(245757, 119, '2014-03-15 00:35:51.000000', 'temperatura', 647.0000, 'ºC'),
	(245758, 119, '2014-03-15 00:35:52.000000', 'temperatura', 527.0000, 'ºC'),
	(245759, 119, '2014-03-15 00:35:53.000000', 'temperatura', 693.0000, 'ºC'),
	(245760, 119, '2014-03-15 00:35:54.000000', 'temperatura', 685.0000, 'ºC'),
	(245761, 119, '2014-03-15 00:35:55.000000', 'temperatura', 147.0000, 'ºC'),
	(245762, 119, '2014-03-15 00:35:56.000000', 'temperatura', 1080.0000, 'ºC'),
	(245763, 119, '2014-03-15 00:35:57.000000', 'temperatura', 160.0000, 'ºC'),
	(245764, 119, '2014-03-15 00:35:58.000000', 'temperatura', 1159.0000, 'ºC'),
	(245765, 119, '2014-03-15 00:35:59.000000', 'temperatura', 517.0000, 'ºC'),
	(245766, 119, '2014-03-15 00:36:00.000000', 'temperatura', 307.0000, 'ºC'),
	(245767, 119, '2014-03-15 00:36:01.000000', 'temperatura', 1187.0000, 'ºC'),
	(245768, 119, '2014-03-15 00:36:02.000000', 'temperatura', 212.0000, 'ºC'),
	(245769, 119, '2014-03-15 00:36:03.000000', 'temperatura', 1101.0000, 'ºC'),
	(245770, 119, '2014-03-15 00:36:04.000000', 'temperatura', 68.0000, 'ºC'),
	(245771, 119, '2014-03-15 00:36:05.000000', 'temperatura', 640.0000, 'ºC'),
	(245772, 119, '2014-03-15 00:36:06.000000', 'temperatura', 595.0000, 'ºC'),
	(245773, 119, '2014-03-15 00:36:07.000000', 'temperatura', 1054.0000, 'ºC'),
	(245774, 119, '2014-03-15 00:36:08.000000', 'temperatura', 1088.0000, 'ºC'),
	(245775, 119, '2014-03-15 00:36:09.000000', 'temperatura', 1079.0000, 'ºC'),
	(245776, 119, '2014-03-15 00:36:10.000000', 'temperatura', 932.0000, 'ºC'),
	(245777, 119, '2014-03-15 00:36:11.000000', 'temperatura', 221.0000, 'ºC'),
	(245778, 119, '2014-03-15 00:36:12.000000', 'temperatura', 709.0000, 'ºC'),
	(245779, 119, '2014-03-15 00:36:13.000000', 'temperatura', 484.0000, 'ºC'),
	(245780, 119, '2014-03-15 00:36:14.000000', 'temperatura', 293.0000, 'ºC'),
	(245781, 119, '2014-03-15 00:36:15.000000', 'temperatura', 13.0000, 'ºC'),
	(245782, 119, '2014-03-15 00:36:16.000000', 'temperatura', 389.0000, 'ºC'),
	(245783, 119, '2014-03-15 00:36:17.000000', 'temperatura', 705.0000, 'ºC'),
	(245784, 119, '2014-03-15 00:36:18.000000', 'temperatura', 1160.0000, 'ºC'),
	(245785, 119, '2014-03-15 00:36:19.000000', 'temperatura', 83.0000, 'ºC'),
	(245786, 119, '2014-03-15 00:36:20.000000', 'temperatura', 534.0000, 'ºC'),
	(245787, 119, '2014-03-15 00:36:21.000000', 'temperatura', 25.0000, 'ºC'),
	(245788, 119, '2014-03-15 00:36:22.000000', 'temperatura', 922.0000, 'ºC'),
	(245789, 119, '2014-03-15 00:36:23.000000', 'temperatura', 936.0000, 'ºC'),
	(245790, 119, '2014-03-15 00:36:24.000000', 'temperatura', 715.0000, 'ºC'),
	(245791, 119, '2014-03-15 00:36:25.000000', 'temperatura', 769.0000, 'ºC'),
	(245792, 119, '2014-03-15 00:36:26.000000', 'temperatura', 497.0000, 'ºC'),
	(245793, 119, '2014-03-15 00:36:27.000000', 'temperatura', 180.0000, 'ºC'),
	(245794, 119, '2014-03-15 00:36:28.000000', 'temperatura', 609.0000, 'ºC'),
	(245795, 119, '2014-03-15 00:36:29.000000', 'temperatura', 105.0000, 'ºC'),
	(245796, 119, '2014-03-15 00:36:30.000000', 'temperatura', 1101.0000, 'ºC'),
	(245797, 119, '2014-03-15 00:36:31.000000', 'temperatura', 390.0000, 'ºC'),
	(245798, 119, '2014-03-15 00:36:32.000000', 'temperatura', 1047.0000, 'ºC'),
	(245799, 119, '2014-03-15 00:36:33.000000', 'temperatura', 464.0000, 'ºC'),
	(245800, 119, '2014-03-15 00:36:34.000000', 'temperatura', 381.0000, 'ºC'),
	(245801, 119, '2014-03-15 00:36:35.000000', 'temperatura', 514.0000, 'ºC'),
	(245802, 119, '2014-03-15 00:36:36.000000', 'temperatura', 227.0000, 'ºC'),
	(245803, 119, '2014-03-15 00:36:37.000000', 'temperatura', 795.0000, 'ºC'),
	(245804, 119, '2014-03-15 00:36:38.000000', 'temperatura', 895.0000, 'ºC'),
	(245805, 119, '2014-03-15 00:36:39.000000', 'temperatura', 889.0000, 'ºC'),
	(245806, 119, '2014-03-15 00:36:40.000000', 'temperatura', 562.0000, 'ºC'),
	(245807, 119, '2014-03-15 00:36:41.000000', 'temperatura', 143.0000, 'ºC'),
	(245808, 119, '2014-03-15 00:36:42.000000', 'temperatura', 228.0000, 'ºC'),
	(245809, 119, '2014-03-15 00:36:43.000000', 'temperatura', 710.0000, 'ºC'),
	(245810, 119, '2014-03-15 00:36:44.000000', 'temperatura', 470.0000, 'ºC'),
	(245811, 119, '2014-03-15 00:36:45.000000', 'temperatura', 219.0000, 'ºC'),
	(245812, 119, '2014-03-15 00:36:46.000000', 'temperatura', 884.0000, 'ºC'),
	(245813, 119, '2014-03-15 00:36:47.000000', 'temperatura', 166.0000, 'ºC'),
	(245814, 119, '2014-03-15 00:36:48.000000', 'temperatura', 577.0000, 'ºC'),
	(245815, 119, '2014-03-15 00:36:49.000000', 'temperatura', 1187.0000, 'ºC'),
	(245816, 119, '2014-03-15 00:36:50.000000', 'temperatura', 606.0000, 'ºC'),
	(245817, 119, '2014-03-15 00:36:51.000000', 'temperatura', 667.0000, 'ºC'),
	(245818, 119, '2014-03-15 00:36:52.000000', 'temperatura', 320.0000, 'ºC'),
	(245819, 119, '2014-03-15 00:36:53.000000', 'temperatura', 797.0000, 'ºC'),
	(245820, 119, '2014-03-15 00:36:54.000000', 'temperatura', 625.0000, 'ºC'),
	(245821, 119, '2014-03-15 00:36:55.000000', 'temperatura', 737.0000, 'ºC'),
	(245822, 119, '2014-03-15 00:36:56.000000', 'temperatura', 611.0000, 'ºC'),
	(245823, 119, '2014-03-15 00:36:57.000000', 'temperatura', 843.0000, 'ºC'),
	(245824, 119, '2014-03-15 00:36:58.000000', 'temperatura', 1183.0000, 'ºC'),
	(245825, 119, '2014-03-15 00:36:59.000000', 'temperatura', 987.0000, 'ºC'),
	(245826, 119, '2014-03-15 00:37:00.000000', 'temperatura', 184.0000, 'ºC'),
	(245827, 119, '2014-03-15 00:37:01.000000', 'temperatura', 362.0000, 'ºC'),
	(245828, 119, '2014-03-15 00:37:02.000000', 'temperatura', 56.0000, 'ºC'),
	(245829, 119, '2014-03-15 00:37:03.000000', 'temperatura', 395.0000, 'ºC'),
	(245830, 119, '2014-03-15 00:37:04.000000', 'temperatura', 609.0000, 'ºC'),
	(245831, 119, '2014-03-15 00:37:05.000000', 'temperatura', 659.0000, 'ºC'),
	(245832, 119, '2014-03-15 00:37:06.000000', 'temperatura', 269.0000, 'ºC'),
	(245833, 119, '2014-03-15 00:37:07.000000', 'temperatura', 567.0000, 'ºC'),
	(245834, 119, '2014-03-15 00:37:08.000000', 'temperatura', 831.0000, 'ºC'),
	(245835, 119, '2014-03-15 00:37:09.000000', 'temperatura', 54.0000, 'ºC'),
	(245836, 119, '2014-03-15 00:37:10.000000', 'temperatura', 175.0000, 'ºC'),
	(245837, 119, '2014-03-15 00:37:11.000000', 'temperatura', 717.0000, 'ºC'),
	(245838, 119, '2014-03-15 00:37:12.000000', 'temperatura', 657.0000, 'ºC'),
	(245839, 119, '2014-03-15 00:37:13.000000', 'temperatura', 1137.0000, 'ºC'),
	(245840, 119, '2014-03-15 00:37:14.000000', 'temperatura', 112.0000, 'ºC'),
	(245841, 119, '2014-03-15 00:37:15.000000', 'temperatura', 752.0000, 'ºC'),
	(245842, 119, '2014-03-15 00:37:16.000000', 'temperatura', 1025.0000, 'ºC'),
	(245843, 119, '2014-03-15 00:37:17.000000', 'temperatura', 469.0000, 'ºC'),
	(245844, 119, '2014-03-15 00:37:18.000000', 'temperatura', 472.0000, 'ºC'),
	(245845, 119, '2014-03-15 00:37:19.000000', 'temperatura', 950.0000, 'ºC'),
	(245846, 119, '2014-03-15 00:37:20.000000', 'temperatura', 937.0000, 'ºC'),
	(245847, 119, '2014-03-15 00:37:21.000000', 'temperatura', 633.0000, 'ºC'),
	(245848, 119, '2014-03-15 00:37:22.000000', 'temperatura', 357.0000, 'ºC'),
	(245849, 119, '2014-03-15 00:37:23.000000', 'temperatura', 1085.0000, 'ºC'),
	(245850, 119, '2014-03-15 00:37:24.000000', 'temperatura', 757.0000, 'ºC'),
	(245851, 119, '2014-03-15 00:37:25.000000', 'temperatura', 529.0000, 'ºC'),
	(245852, 119, '2014-03-15 00:37:26.000000', 'temperatura', 373.0000, 'ºC'),
	(245853, 119, '2014-03-15 00:37:27.000000', 'temperatura', 280.0000, 'ºC'),
	(245854, 119, '2014-03-15 00:37:28.000000', 'temperatura', 280.0000, 'ºC'),
	(245855, 119, '2014-03-15 00:37:29.000000', 'temperatura', 563.0000, 'ºC'),
	(245856, 119, '2014-03-15 00:37:30.000000', 'temperatura', 773.0000, 'ºC'),
	(245857, 119, '2014-03-15 00:37:31.000000', 'temperatura', 979.0000, 'ºC'),
	(245858, 119, '2014-03-15 00:37:32.000000', 'temperatura', 176.0000, 'ºC'),
	(245859, 119, '2014-03-15 00:37:33.000000', 'temperatura', 342.0000, 'ºC'),
	(245860, 119, '2014-03-15 00:37:34.000000', 'temperatura', 1184.0000, 'ºC'),
	(245861, 119, '2014-03-15 00:37:35.000000', 'temperatura', 95.0000, 'ºC'),
	(245862, 119, '2014-03-15 00:37:36.000000', 'temperatura', 524.0000, 'ºC'),
	(245863, 119, '2014-03-15 00:37:37.000000', 'temperatura', 1136.0000, 'ºC'),
	(245864, 119, '2014-03-15 00:37:38.000000', 'temperatura', 507.0000, 'ºC'),
	(245865, 119, '2014-03-15 00:37:39.000000', 'temperatura', 330.0000, 'ºC'),
	(245866, 119, '2014-03-15 00:37:40.000000', 'temperatura', 127.0000, 'ºC'),
	(245867, 119, '2014-03-15 00:37:41.000000', 'temperatura', 848.0000, 'ºC'),
	(245868, 119, '2014-03-15 00:37:42.000000', 'temperatura', 258.0000, 'ºC'),
	(245869, 119, '2014-03-15 00:37:43.000000', 'temperatura', 1146.0000, 'ºC'),
	(245870, 119, '2014-03-15 00:37:44.000000', 'temperatura', 155.0000, 'ºC'),
	(245871, 119, '2014-03-15 00:37:45.000000', 'temperatura', 941.0000, 'ºC'),
	(245872, 119, '2014-03-15 00:37:46.000000', 'temperatura', 638.0000, 'ºC'),
	(245873, 119, '2014-03-15 00:37:47.000000', 'temperatura', 367.0000, 'ºC'),
	(245874, 119, '2014-03-15 00:37:48.000000', 'temperatura', 1124.0000, 'ºC'),
	(245875, 119, '2014-03-15 00:37:49.000000', 'temperatura', 920.0000, 'ºC'),
	(245876, 119, '2014-03-15 00:37:50.000000', 'temperatura', 29.0000, 'ºC'),
	(245877, 119, '2014-03-15 00:37:51.000000', 'temperatura', 986.0000, 'ºC'),
	(245878, 119, '2014-03-15 00:37:52.000000', 'temperatura', 42.0000, 'ºC'),
	(245879, 119, '2014-03-15 00:37:53.000000', 'temperatura', 851.0000, 'ºC'),
	(245880, 119, '2014-03-15 00:37:54.000000', 'temperatura', 532.0000, 'ºC'),
	(245881, 119, '2014-03-15 00:37:55.000000', 'temperatura', 107.0000, 'ºC'),
	(245882, 119, '2014-03-15 00:37:56.000000', 'temperatura', 139.0000, 'ºC'),
	(245883, 119, '2014-03-15 00:37:57.000000', 'temperatura', 376.0000, 'ºC'),
	(245884, 119, '2014-03-15 00:37:58.000000', 'temperatura', 262.0000, 'ºC'),
	(245885, 119, '2014-03-15 00:37:59.000000', 'temperatura', 182.0000, 'ºC'),
	(245886, 119, '2014-03-15 00:38:00.000000', 'temperatura', 124.0000, 'ºC'),
	(245887, 119, '2014-03-15 00:38:01.000000', 'temperatura', 76.0000, 'ºC'),
	(245888, 119, '2014-03-15 00:38:02.000000', 'temperatura', 10.0000, 'ºC'),
	(245889, 119, '2014-03-15 00:38:03.000000', 'temperatura', 1021.0000, 'ºC'),
	(245890, 119, '2014-03-15 00:38:04.000000', 'temperatura', 274.0000, 'ºC'),
	(245891, 119, '2014-03-15 00:38:05.000000', 'temperatura', 707.0000, 'ºC'),
	(245892, 119, '2014-03-15 00:38:06.000000', 'temperatura', 316.0000, 'ºC'),
	(245893, 119, '2014-03-15 00:38:07.000000', 'temperatura', 659.0000, 'ºC'),
	(245894, 119, '2014-03-15 00:38:08.000000', 'temperatura', 1146.0000, 'ºC'),
	(245895, 119, '2014-03-15 00:38:09.000000', 'temperatura', 153.0000, 'ºC'),
	(245896, 119, '2014-03-15 00:38:10.000000', 'temperatura', 930.0000, 'ºC'),
	(245897, 119, '2014-03-15 00:38:11.000000', 'temperatura', 592.0000, 'ºC'),
	(245898, 119, '2014-03-15 00:38:12.000000', 'temperatura', 168.0000, 'ºC'),
	(245899, 119, '2014-03-15 00:38:13.000000', 'temperatura', 267.0000, 'ºC'),
	(245900, 119, '2014-03-15 00:38:14.000000', 'temperatura', 831.0000, 'ºC'),
	(245901, 119, '2014-03-15 00:38:15.000000', 'temperatura', 955.0000, 'ºC'),
	(245902, 119, '2014-03-15 00:38:16.000000', 'temperatura', 1082.0000, 'ºC'),
	(245903, 119, '2014-03-15 00:38:17.000000', 'temperatura', 144.0000, 'ºC'),
	(245904, 119, '2014-03-15 00:38:18.000000', 'temperatura', 1076.0000, 'ºC'),
	(245905, 119, '2014-03-15 00:38:19.000000', 'temperatura', 148.0000, 'ºC'),
	(245906, 119, '2014-03-15 00:38:20.000000', 'temperatura', 1111.0000, 'ºC'),
	(245907, 119, '2014-03-15 00:38:21.000000', 'temperatura', 311.0000, 'ºC'),
	(245908, 119, '2014-03-15 00:38:22.000000', 'temperatura', 624.0000, 'ºC'),
	(245909, 119, '2014-03-15 00:38:23.000000', 'temperatura', 988.0000, 'ºC'),
	(245910, 119, '2014-03-15 00:38:24.000000', 'temperatura', 668.0000, 'ºC'),
	(245911, 119, '2014-03-15 00:38:25.000000', 'temperatura', 375.0000, 'ºC'),
	(245912, 119, '2014-03-15 00:38:26.000000', 'temperatura', 1072.0000, 'ºC'),
	(245913, 119, '2014-03-15 00:38:27.000000', 'temperatura', 635.0000, 'ºC'),
	(245914, 119, '2014-03-15 00:38:28.000000', 'temperatura', 1161.0000, 'ºC'),
	(245915, 119, '2014-03-15 00:38:29.000000', 'temperatura', 301.0000, 'ºC'),
	(245916, 119, '2014-03-15 00:38:30.000000', 'temperatura', 421.0000, 'ºC'),
	(245917, 119, '2014-03-15 00:38:31.000000', 'temperatura', 5.0000, 'ºC'),
	(245918, 119, '2014-03-15 00:38:32.000000', 'temperatura', 1161.0000, 'ºC'),
	(245919, 119, '2014-03-15 00:38:33.000000', 'temperatura', 991.0000, 'ºC'),
	(245920, 119, '2014-03-15 00:38:34.000000', 'temperatura', 273.0000, 'ºC'),
	(245921, 119, '2014-03-15 00:38:35.000000', 'temperatura', 790.0000, 'ºC'),
	(245922, 119, '2014-03-15 00:38:36.000000', 'temperatura', 732.0000, 'ºC'),
	(245923, 119, '2014-03-15 00:38:37.000000', 'temperatura', 91.0000, 'ºC'),
	(245924, 119, '2014-03-15 00:38:38.000000', 'temperatura', 661.0000, 'ºC'),
	(245925, 119, '2014-03-15 00:38:39.000000', 'temperatura', 631.0000, 'ºC'),
	(245926, 119, '2014-03-15 00:38:40.000000', 'temperatura', 1173.0000, 'ºC'),
	(245927, 119, '2014-03-15 00:38:41.000000', 'temperatura', 373.0000, 'ºC'),
	(245928, 119, '2014-03-15 00:38:42.000000', 'temperatura', 748.0000, 'ºC'),
	(245929, 119, '2014-03-15 00:38:43.000000', 'temperatura', 220.0000, 'ºC'),
	(245930, 119, '2014-03-15 00:38:44.000000', 'temperatura', 56.0000, 'ºC'),
	(245931, 119, '2014-03-15 00:38:45.000000', 'temperatura', 821.0000, 'ºC'),
	(245932, 119, '2014-03-15 00:38:46.000000', 'temperatura', 339.0000, 'ºC'),
	(245933, 119, '2014-03-15 00:38:47.000000', 'temperatura', 433.0000, 'ºC'),
	(245934, 119, '2014-03-15 00:38:48.000000', 'temperatura', 1148.0000, 'ºC'),
	(245935, 119, '2014-03-15 00:38:49.000000', 'temperatura', 839.0000, 'ºC'),
	(245936, 119, '2014-03-15 00:38:50.000000', 'temperatura', 755.0000, 'ºC'),
	(245937, 119, '2014-03-15 00:38:51.000000', 'temperatura', 57.0000, 'ºC'),
	(245938, 119, '2014-03-15 00:38:52.000000', 'temperatura', 419.0000, 'ºC'),
	(245939, 119, '2014-03-15 00:38:53.000000', 'temperatura', 725.0000, 'ºC'),
	(245940, 119, '2014-03-15 00:38:54.000000', 'temperatura', 1168.0000, 'ºC'),
	(245941, 119, '2014-03-15 00:38:55.000000', 'temperatura', 64.0000, 'ºC'),
	(245942, 119, '2014-03-15 00:38:56.000000', 'temperatura', 419.0000, 'ºC'),
	(245943, 119, '2014-03-15 00:38:57.000000', 'temperatura', 702.0000, 'ºC'),
	(245944, 119, '2014-03-15 00:38:58.000000', 'temperatura', 1053.0000, 'ºC'),
	(245945, 119, '2014-03-15 00:38:59.000000', 'temperatura', 761.0000, 'ºC'),
	(245946, 119, '2014-03-15 00:39:00.000000', 'temperatura', 648.0000, 'ºC'),
	(245947, 119, '2014-03-15 00:39:01.000000', 'temperatura', 954.0000, 'ºC'),
	(245948, 119, '2014-03-15 00:39:02.000000', 'temperatura', 428.0000, 'ºC'),
	(245949, 119, '2014-03-15 00:39:03.000000', 'temperatura', 478.0000, 'ºC'),
	(245950, 119, '2014-03-15 00:39:04.000000', 'temperatura', 1108.0000, 'ºC'),
	(245951, 119, '2014-03-15 00:39:05.000000', 'temperatura', 504.0000, 'ºC'),
	(245952, 119, '2014-03-15 00:39:06.000000', 'temperatura', 399.0000, 'ºC'),
	(245953, 119, '2014-03-15 00:39:07.000000', 'temperatura', 483.0000, 'ºC'),
	(245954, 119, '2014-03-15 00:39:08.000000', 'temperatura', 17.0000, 'ºC'),
	(245955, 119, '2014-03-15 00:39:09.000000', 'temperatura', 1036.0000, 'ºC'),
	(245956, 119, '2014-03-15 00:39:10.000000', 'temperatura', 332.0000, 'ºC'),
	(245957, 119, '2014-03-15 00:39:11.000000', 'temperatura', 951.0000, 'ºC'),
	(245958, 119, '2014-03-15 00:39:12.000000', 'temperatura', 159.0000, 'ºC'),
	(245959, 119, '2014-03-15 00:39:13.000000', 'temperatura', 342.0000, 'ºC'),
	(245960, 119, '2014-03-15 00:39:14.000000', 'temperatura', 36.0000, 'ºC'),
	(245961, 119, '2014-03-15 00:39:15.000000', 'temperatura', 355.0000, 'ºC'),
	(245962, 119, '2014-03-15 00:39:16.000000', 'temperatura', 466.0000, 'ºC'),
	(245963, 119, '2014-03-15 00:39:17.000000', 'temperatura', 64.0000, 'ºC'),
	(245964, 119, '2014-03-15 00:39:18.000000', 'temperatura', 123.0000, 'ºC'),
	(245965, 119, '2014-03-15 00:39:19.000000', 'temperatura', 426.0000, 'ºC'),
	(245966, 119, '2014-03-15 00:39:20.000000', 'temperatura', 559.0000, 'ºC'),
	(245967, 119, '2014-03-15 00:39:21.000000', 'temperatura', 317.0000, 'ºC'),
	(245968, 119, '2014-03-15 00:39:22.000000', 'temperatura', 1110.0000, 'ºC'),
	(245969, 119, '2014-03-15 00:39:23.000000', 'temperatura', 999.0000, 'ºC'),
	(245970, 119, '2014-03-15 00:39:24.000000', 'temperatura', 466.0000, 'ºC'),
	(245971, 119, '2014-03-15 00:39:25.000000', 'temperatura', 535.0000, 'ºC'),
	(245972, 119, '2014-03-15 00:39:26.000000', 'temperatura', 75.0000, 'ºC'),
	(245973, 119, '2014-03-15 00:39:27.000000', 'temperatura', 1171.0000, 'ºC'),
	(245974, 119, '2014-03-15 00:39:28.000000', 'temperatura', 832.0000, 'ºC'),
	(245975, 119, '2014-03-15 00:39:29.000000', 'temperatura', 645.0000, 'ºC'),
	(245976, 119, '2014-03-15 00:39:30.000000', 'temperatura', 732.0000, 'ºC'),
	(245977, 119, '2014-03-15 00:39:31.000000', 'temperatura', 523.0000, 'ºC'),
	(245978, 119, '2014-03-15 00:39:32.000000', 'temperatura', 421.0000, 'ºC'),
	(245979, 119, '2014-03-15 00:39:33.000000', 'temperatura', 536.0000, 'ºC'),
	(245980, 119, '2014-03-15 00:39:34.000000', 'temperatura', 218.0000, 'ºC'),
	(245981, 119, '2014-03-15 00:39:35.000000', 'temperatura', 684.0000, 'ºC'),
	(245982, 119, '2014-03-15 00:39:36.000000', 'temperatura', 365.0000, 'ºC'),
	(245983, 119, '2014-03-15 00:39:37.000000', 'temperatura', 972.0000, 'ºC'),
	(245984, 119, '2014-03-15 00:39:38.000000', 'temperatura', 169.0000, 'ºC'),
	(245985, 119, '2014-03-15 00:39:39.000000', 'temperatura', 327.0000, 'ºC'),
	(245986, 119, '2014-03-15 00:39:40.000000', 'temperatura', 1129.0000, 'ºC'),
	(245987, 119, '2014-03-15 00:39:41.000000', 'temperatura', 1063.0000, 'ºC'),
	(245988, 119, '2014-03-15 00:39:42.000000', 'temperatura', 728.0000, 'ºC'),
	(245989, 119, '2014-03-15 00:39:43.000000', 'temperatura', 452.0000, 'ºC'),
	(245990, 119, '2014-03-15 00:39:44.000000', 'temperatura', 78.0000, 'ºC'),
	(245991, 119, '2014-03-15 00:39:45.000000', 'temperatura', 235.0000, 'ºC'),
	(245992, 119, '2014-03-15 00:39:46.000000', 'temperatura', 941.0000, 'ºC'),
	(245993, 119, '2014-03-15 00:39:47.000000', 'temperatura', 402.0000, 'ºC'),
	(245994, 119, '2014-03-15 00:39:48.000000', 'temperatura', 388.0000, 'ºC'),
	(245995, 119, '2014-03-15 00:39:49.000000', 'temperatura', 731.0000, 'ºC'),
	(245996, 119, '2014-03-15 00:39:50.000000', 'temperatura', 94.0000, 'ºC'),
	(245997, 119, '2014-03-15 00:39:51.000000', 'temperatura', 678.0000, 'ºC'),
	(245998, 119, '2014-03-15 00:39:52.000000', 'temperatura', 708.0000, 'ºC'),
	(245999, 119, '2014-03-15 00:39:53.000000', 'temperatura', 308.0000, 'ºC'),
	(246000, 119, '2014-03-15 00:39:54.000000', 'temperatura', 616.0000, 'ºC'),
	(246001, 119, '2014-03-15 00:39:55.000000', 'temperatura', 955.0000, 'ºC'),
	(246002, 119, '2014-03-15 00:39:56.000000', 'temperatura', 526.0000, 'ºC'),
	(246003, 119, '2014-03-15 00:39:57.000000', 'temperatura', 969.0000, 'ºC'),
	(246004, 119, '2014-03-15 00:39:58.000000', 'temperatura', 864.0000, 'ºC'),
	(246005, 119, '2014-03-15 00:39:59.000000', 'temperatura', 217.0000, 'ºC'),
	(246006, 119, '2014-03-15 00:40:00.000000', 'temperatura', 891.0000, 'ºC'),
	(246007, 119, '2014-03-15 00:40:01.000000', 'temperatura', 204.0000, 'ºC'),
	(246008, 119, '2014-03-15 00:40:02.000000', 'temperatura', 747.0000, 'ºC'),
	(246009, 119, '2014-03-15 00:40:03.000000', 'temperatura', 725.0000, 'ºC'),
	(246010, 119, '2014-03-15 00:40:04.000000', 'temperatura', 186.0000, 'ºC'),
	(246011, 119, '2014-03-15 00:40:05.000000', 'temperatura', 1154.0000, 'ºC'),
	(246012, 119, '2014-03-15 00:40:06.000000', 'temperatura', 412.0000, 'ºC'),
	(246013, 119, '2014-03-15 00:40:07.000000', 'temperatura', 1000.0000, 'ºC'),
	(246014, 119, '2014-03-15 00:40:08.000000', 'temperatura', 162.0000, 'ºC'),
	(246015, 119, '2014-03-15 00:40:09.000000', 'temperatura', 212.0000, 'ºC'),
	(246016, 119, '2014-03-15 00:40:10.000000', 'temperatura', 576.0000, 'ºC'),
	(246017, 119, '2014-03-15 00:40:11.000000', 'temperatura', 1043.0000, 'ºC'),
	(246018, 119, '2014-03-15 00:40:12.000000', 'temperatura', 1088.0000, 'ºC'),
	(246019, 119, '2014-03-15 00:40:13.000000', 'temperatura', 1112.0000, 'ºC'),
	(246020, 119, '2014-03-15 00:40:14.000000', 'temperatura', 1094.0000, 'ºC'),
	(246021, 119, '2014-03-15 00:40:15.000000', 'temperatura', 937.0000, 'ºC'),
	(246022, 119, '2014-03-15 00:40:16.000000', 'temperatura', 201.0000, 'ºC'),
	(246023, 119, '2014-03-15 00:40:17.000000', 'temperatura', 597.0000, 'ºC'),
	(246024, 119, '2014-03-15 00:40:18.000000', 'temperatura', 1181.0000, 'ºC'),
	(246025, 119, '2014-03-15 00:40:19.000000', 'temperatura', 513.0000, 'ºC'),
	(246026, 119, '2014-03-15 00:40:20.000000', 'temperatura', 225.0000, 'ºC'),
	(246027, 119, '2014-03-15 00:40:21.000000', 'temperatura', 787.0000, 'ºC'),
	(246028, 119, '2014-03-15 00:40:22.000000', 'temperatura', 858.0000, 'ºC'),
	(246029, 119, '2014-03-15 00:40:23.000000', 'temperatura', 731.0000, 'ºC'),
	(246030, 119, '2014-03-15 00:40:24.000000', 'temperatura', 1083.0000, 'ºC'),
	(246031, 119, '2014-03-15 00:40:25.000000', 'temperatura', 822.0000, 'ºC'),
	(246032, 119, '2014-03-15 00:40:26.000000', 'temperatura', 862.0000, 'ºC'),
	(246033, 119, '2014-03-15 00:40:27.000000', 'temperatura', 645.0000, 'ºC'),
	(246034, 119, '2014-03-15 00:40:28.000000', 'temperatura', 638.0000, 'ºC'),
	(246035, 119, '2014-03-15 00:40:29.000000', 'temperatura', 56.0000, 'ºC'),
	(246036, 119, '2014-03-15 00:40:30.000000', 'temperatura', 768.0000, 'ºC'),
	(246037, 119, '2014-03-15 00:40:31.000000', 'temperatura', 71.0000, 'ºC'),
	(246038, 119, '2014-03-15 00:40:32.000000', 'temperatura', 451.0000, 'ºC'),
	(246039, 119, '2014-03-15 00:40:33.000000', 'temperatura', 844.0000, 'ºC'),
	(246040, 119, '2014-03-15 00:40:34.000000', 'temperatura', 468.0000, 'ºC'),
	(246041, 119, '2014-03-15 00:40:35.000000', 'temperatura', 1008.0000, 'ºC'),
	(246042, 119, '2014-03-15 00:40:36.000000', 'temperatura', 38.0000, 'ºC'),
	(246043, 119, '2014-03-15 00:40:37.000000', 'temperatura', 767.0000, 'ºC'),
	(246044, 119, '2014-03-15 00:40:38.000000', 'temperatura', 119.0000, 'ºC'),
	(246045, 119, '2014-03-15 00:40:39.000000', 'temperatura', 697.0000, 'ºC'),
	(246046, 119, '2014-03-15 00:40:40.000000', 'temperatura', 726.0000, 'ºC'),
	(246047, 119, '2014-03-15 00:40:41.000000', 'temperatura', 338.0000, 'ºC'),
	(246048, 119, '2014-03-15 00:40:42.000000', 'temperatura', 716.0000, 'ºC'),
	(246049, 119, '2014-03-15 00:40:43.000000', 'temperatura', 166.0000, 'ºC'),
	(246050, 119, '2014-03-15 00:40:44.000000', 'temperatura', 1080.0000, 'ºC'),
	(246051, 119, '2014-03-15 00:40:45.000000', 'temperatura', 105.0000, 'ºC'),
	(246052, 119, '2014-03-15 00:40:46.000000', 'temperatura', 884.0000, 'ºC'),
	(246053, 119, '2014-03-15 00:40:47.000000', 'temperatura', 506.0000, 'ºC'),
	(246054, 119, '2014-03-15 00:40:48.000000', 'temperatura', 1079.0000, 'ºC'),
	(246055, 119, '2014-03-15 00:40:49.000000', 'temperatura', 276.0000, 'ºC'),
	(246056, 119, '2014-03-15 00:40:50.000000', 'temperatura', 543.0000, 'ºC'),
	(246057, 119, '2014-03-15 00:40:51.000000', 'temperatura', 688.0000, 'ºC'),
	(246058, 119, '2014-03-15 00:40:52.000000', 'temperatura', 612.0000, 'ºC'),
	(246059, 119, '2014-03-15 00:40:53.000000', 'temperatura', 997.0000, 'ºC'),
	(246060, 119, '2014-03-15 00:40:54.000000', 'temperatura', 747.0000, 'ºC'),
	(246061, 119, '2014-03-15 00:40:55.000000', 'temperatura', 747.0000, 'ºC'),
	(246062, 119, '2014-03-15 00:40:56.000000', 'temperatura', 292.0000, 'ºC'),
	(246063, 119, '2014-03-15 00:40:57.000000', 'temperatura', 422.0000, 'ºC'),
	(246064, 119, '2014-03-15 00:40:58.000000', 'temperatura', 32.0000, 'ºC'),
	(246065, 119, '2014-03-15 00:40:59.000000', 'temperatura', 95.0000, 'ºC'),
	(246066, 119, '2014-03-15 00:41:00.000000', 'temperatura', 378.0000, 'ºC'),
	(246067, 119, '2014-03-15 00:41:01.000000', 'temperatura', 406.0000, 'ºC'),
	(246068, 119, '2014-03-15 00:41:02.000000', 'temperatura', 899.0000, 'ºC'),
	(246069, 119, '2014-03-15 00:41:03.000000', 'temperatura', 876.0000, 'ºC'),
	(246070, 119, '2014-03-15 00:41:04.000000', 'temperatura', 483.0000, 'ºC'),
	(246071, 119, '2014-03-15 00:41:05.000000', 'temperatura', 990.0000, 'ºC'),
	(246072, 119, '2014-03-15 00:41:06.000000', 'temperatura', 1099.0000, 'ºC'),
	(246073, 119, '2014-03-15 00:41:07.000000', 'temperatura', 125.0000, 'ºC'),
	(246074, 119, '2014-03-15 00:41:08.000000', 'temperatura', 930.0000, 'ºC'),
	(246075, 119, '2014-03-15 00:41:09.000000', 'temperatura', 673.0000, 'ºC'),
	(246076, 119, '2014-03-15 00:41:10.000000', 'temperatura', 578.0000, 'ºC'),
	(246077, 119, '2014-03-15 00:41:11.000000', 'temperatura', 871.0000, 'ºC'),
	(246078, 119, '2014-03-15 00:41:12.000000', 'temperatura', 220.0000, 'ºC'),
	(246079, 119, '2014-03-15 00:41:13.000000', 'temperatura', 888.0000, 'ºC'),
	(246080, 119, '2014-03-15 00:41:14.000000', 'temperatura', 179.0000, 'ºC'),
	(246081, 119, '2014-03-15 00:41:15.000000', 'temperatura', 634.0000, 'ºC'),
	(246082, 119, '2014-03-15 00:41:16.000000', 'temperatura', 231.0000, 'ºC'),
	(246083, 119, '2014-03-15 00:41:17.000000', 'temperatura', 455.0000, 'ºC'),
	(246084, 119, '2014-03-15 00:41:18.000000', 'temperatura', 383.0000, 'ºC'),
	(246085, 119, '2014-03-15 00:41:19.000000', 'temperatura', 550.0000, 'ºC'),
	(246086, 119, '2014-03-15 00:41:20.000000', 'temperatura', 402.0000, 'ºC'),
	(246087, 119, '2014-03-15 00:41:21.000000', 'temperatura', 360.0000, 'ºC'),
	(246088, 119, '2014-03-15 00:41:22.000000', 'temperatura', 595.0000, 'ºC'),
	(246089, 119, '2014-03-15 00:41:23.000000', 'temperatura', 694.0000, 'ºC'),
	(246090, 119, '2014-03-15 00:41:24.000000', 'temperatura', 486.0000, 'ºC'),
	(246091, 119, '2014-03-15 00:41:25.000000', 'temperatura', 350.0000, 'ºC'),
	(246092, 119, '2014-03-15 00:41:26.000000', 'temperatura', 291.0000, 'ºC'),
	(246093, 119, '2014-03-15 00:41:27.000000', 'temperatura', 404.0000, 'ºC'),
	(246094, 119, '2014-03-15 00:41:28.000000', 'temperatura', 1150.0000, 'ºC'),
	(246095, 119, '2014-03-15 00:41:29.000000', 'temperatura', 937.0000, 'ºC'),
	(246096, 119, '2014-03-15 00:41:30.000000', 'temperatura', 36.0000, 'ºC'),
	(246097, 119, '2014-03-15 00:41:31.000000', 'temperatura', 970.0000, 'ºC'),
	(246098, 119, '2014-03-15 00:41:32.000000', 'temperatura', 1143.0000, 'ºC'),
	(246099, 119, '2014-03-15 00:41:33.000000', 'temperatura', 405.0000, 'ºC'),
	(246100, 119, '2014-03-15 00:41:34.000000', 'temperatura', 998.0000, 'ºC'),
	(246101, 119, '2014-03-15 00:41:35.000000', 'temperatura', 174.0000, 'ºC'),
	(246102, 119, '2014-03-15 00:41:36.000000', 'temperatura', 278.0000, 'ºC'),
	(246103, 119, '2014-03-15 00:41:37.000000', 'temperatura', 870.0000, 'ºC'),
	(246104, 119, '2014-03-15 00:41:38.000000', 'temperatura', 1114.0000, 'ºC'),
	(246105, 119, '2014-03-15 00:41:39.000000', 'temperatura', 561.0000, 'ºC'),
	(246106, 119, '2014-03-15 00:41:40.000000', 'temperatura', 664.0000, 'ºC'),
	(246107, 119, '2014-03-15 00:41:41.000000', 'temperatura', 438.0000, 'ºC'),
	(246108, 119, '2014-03-15 00:41:42.000000', 'temperatura', 196.0000, 'ºC'),
	(246109, 119, '2014-03-15 00:41:43.000000', 'temperatura', 867.0000, 'ºC'),
	(246110, 119, '2014-03-15 00:41:44.000000', 'temperatura', 150.0000, 'ºC'),
	(246111, 119, '2014-03-15 00:41:45.000000', 'temperatura', 547.0000, 'ºC'),
	(246112, 119, '2014-03-15 00:41:46.000000', 'temperatura', 1084.0000, 'ºC'),
	(246113, 119, '2014-03-15 00:41:47.000000', 'temperatura', 183.0000, 'ºC'),
	(246114, 119, '2014-03-15 00:41:48.000000', 'temperatura', 61.0000, 'ºC'),
	(246115, 119, '2014-03-15 00:41:49.000000', 'temperatura', 959.0000, 'ºC'),
	(246116, 119, '2014-03-15 00:41:50.000000', 'temperatura', 1013.0000, 'ºC'),
	(246117, 119, '2014-03-15 00:41:51.000000', 'temperatura', 988.0000, 'ºC'),
	(246118, 119, '2014-03-15 00:41:52.000000', 'temperatura', 703.0000, 'ºC'),
	(246119, 119, '2014-03-15 00:41:53.000000', 'temperatura', 551.0000, 'ºC'),
	(246120, 119, '2014-03-15 00:41:54.000000', 'temperatura', 645.0000, 'ºC'),
	(246121, 119, '2014-03-15 00:41:55.000000', 'temperatura', 374.0000, 'ºC'),
	(246122, 119, '2014-03-15 00:41:56.000000', 'temperatura', 1134.0000, 'ºC'),
	(246123, 119, '2014-03-15 00:41:57.000000', 'temperatura', 950.0000, 'ºC'),
	(246124, 119, '2014-03-15 00:41:58.000000', 'temperatura', 146.0000, 'ºC'),
	(246125, 119, '2014-03-15 00:41:59.000000', 'temperatura', 282.0000, 'ºC'),
	(246126, 119, '2014-03-15 00:42:00.000000', 'temperatura', 972.0000, 'ºC'),
	(246127, 119, '2014-03-15 00:42:01.000000', 'temperatura', 415.0000, 'ºC'),
	(246128, 119, '2014-03-15 00:42:02.000000', 'temperatura', 360.0000, 'ºC'),
	(246129, 119, '2014-03-15 00:42:03.000000', 'temperatura', 554.0000, 'ºC'),
	(246130, 119, '2014-03-15 00:42:04.000000', 'temperatura', 491.0000, 'ºC'),
	(246131, 119, '2014-03-15 00:42:05.000000', 'temperatura', 793.0000, 'ºC'),
	(246132, 119, '2014-03-15 00:42:06.000000', 'temperatura', 94.0000, 'ºC'),
	(246133, 119, '2014-03-15 00:42:07.000000', 'temperatura', 490.0000, 'ºC'),
	(246134, 119, '2014-03-15 00:42:08.000000', 'temperatura', 967.0000, 'ºC'),
	(246135, 119, '2014-03-15 00:42:09.000000', 'temperatura', 968.0000, 'ºC'),
	(246136, 119, '2014-03-15 00:42:10.000000', 'temperatura', 741.0000, 'ºC'),
	(246137, 119, '2014-03-15 00:42:11.000000', 'temperatura', 799.0000, 'ºC'),
	(246138, 119, '2014-03-15 00:42:12.000000', 'temperatura', 571.0000, 'ºC'),
	(246139, 119, '2014-03-15 00:42:13.000000', 'temperatura', 462.0000, 'ºC'),
	(246140, 119, '2014-03-15 00:42:14.000000', 'temperatura', 595.0000, 'ºC'),
	(246141, 119, '2014-03-15 00:42:15.000000', 'temperatura', 390.0000, 'ºC'),
	(246142, 119, '2014-03-15 00:42:16.000000', 'temperatura', 166.0000, 'ºC'),
	(246143, 119, '2014-03-15 00:42:17.000000', 'temperatura', 859.0000, 'ºC'),
	(246144, 119, '2014-03-15 00:42:18.000000', 'temperatura', 199.0000, 'ºC'),
	(246145, 119, '2014-03-15 00:42:19.000000', 'temperatura', 818.0000, 'ºC'),
	(246146, 119, '2014-03-15 00:42:20.000000', 'temperatura', 1094.0000, 'ºC'),
	(246147, 119, '2014-03-15 00:42:21.000000', 'temperatura', 615.0000, 'ºC'),
	(246148, 119, '2014-03-15 00:42:22.000000', 'temperatura', 994.0000, 'ºC'),
	(246149, 119, '2014-03-15 00:42:23.000000', 'temperatura', 725.0000, 'ºC'),
	(246150, 119, '2014-03-15 00:42:24.000000', 'temperatura', 643.0000, 'ºC'),
	(246151, 119, '2014-03-15 00:42:25.000000', 'temperatura', 1040.0000, 'ºC'),
	(246152, 119, '2014-03-15 00:42:26.000000', 'temperatura', 873.0000, 'ºC'),
	(246153, 119, '2014-03-15 00:42:27.000000', 'temperatura', 46.0000, 'ºC'),
	(246154, 119, '2014-03-15 00:42:28.000000', 'temperatura', 13.0000, 'ºC'),
	(246155, 119, '2014-03-15 00:42:29.000000', 'temperatura', 1125.0000, 'ºC'),
	(246156, 119, '2014-03-15 00:42:30.000000', 'temperatura', 787.0000, 'ºC'),
	(246157, 119, '2014-03-15 00:42:31.000000', 'temperatura', 560.0000, 'ºC'),
	(246158, 119, '2014-03-15 00:42:32.000000', 'temperatura', 440.0000, 'ºC'),
	(246159, 119, '2014-03-15 00:42:33.000000', 'temperatura', 520.0000, 'ºC'),
	(246160, 119, '2014-03-15 00:42:34.000000', 'temperatura', 81.0000, 'ºC'),
	(246161, 119, '2014-03-15 00:42:35.000000', 'temperatura', 44.0000, 'ºC'),
	(246162, 119, '2014-03-15 00:42:36.000000', 'temperatura', 1177.0000, 'ºC'),
	(246163, 119, '2014-03-15 00:42:37.000000', 'temperatura', 954.0000, 'ºC'),
	(246164, 119, '2014-03-15 00:42:38.000000', 'temperatura', 39.0000, 'ºC'),
	(246165, 119, '2014-03-15 00:42:39.000000', 'temperatura', 936.0000, 'ºC'),
	(246166, 119, '2014-03-15 00:42:40.000000', 'temperatura', 963.0000, 'ºC'),
	(246167, 119, '2014-03-15 00:42:41.000000', 'temperatura', 807.0000, 'ºC'),
	(246168, 119, '2014-03-15 00:42:42.000000', 'temperatura', 1147.0000, 'ºC'),
	(246169, 119, '2014-03-15 00:42:43.000000', 'temperatura', 914.0000, 'ºC'),
	(246170, 119, '2014-03-15 00:42:44.000000', 'temperatura', 1131.0000, 'ºC'),
	(246171, 119, '2014-03-15 00:42:45.000000', 'temperatura', 514.0000, 'ºC'),
	(246172, 119, '2014-03-15 00:42:46.000000', 'temperatura', 378.0000, 'ºC'),
	(246173, 119, '2014-03-15 00:42:47.000000', 'temperatura', 345.0000, 'ºC'),
	(246174, 119, '2014-03-15 00:42:48.000000', 'temperatura', 594.0000, 'ºC'),
	(246175, 119, '2014-03-15 00:42:49.000000', 'temperatura', 737.0000, 'ºC'),
	(246176, 119, '2014-03-15 00:42:50.000000', 'temperatura', 701.0000, 'ºC'),
	(246177, 119, '2014-03-15 00:42:51.000000', 'temperatura', 95.0000, 'ºC'),
	(246178, 119, '2014-03-15 00:42:52.000000', 'temperatura', 773.0000, 'ºC'),
	(246179, 119, '2014-03-15 00:42:53.000000', 'temperatura', 1181.0000, 'ºC'),
	(246180, 119, '2014-03-15 00:42:54.000000', 'temperatura', 1188.0000, 'ºC'),
	(246181, 119, '2014-03-15 00:42:55.000000', 'temperatura', 1196.0000, 'ºC'),
	(246182, 119, '2014-03-15 00:42:56.000000', 'temperatura', 18.0000, 'ºC'),
	(246183, 119, '2014-03-15 00:42:57.000000', 'temperatura', 100.0000, 'ºC'),
	(246184, 119, '2014-03-15 00:42:58.000000', 'temperatura', 446.0000, 'ºC'),
	(246185, 119, '2014-03-15 00:42:59.000000', 'temperatura', 731.0000, 'ºC'),
	(246186, 119, '2014-03-15 00:43:00.000000', 'temperatura', 1120.0000, 'ºC'),
	(246187, 119, '2014-03-15 00:43:01.000000', 'temperatura', 1006.0000, 'ºC'),
	(246188, 119, '2014-03-15 00:43:02.000000', 'temperatura', 469.0000, 'ºC'),
	(246189, 119, '2014-03-15 00:43:03.000000', 'temperatura', 527.0000, 'ºC'),
	(246190, 119, '2014-03-15 00:43:04.000000', 'temperatura', 29.0000, 'ºC'),
	(246191, 119, '2014-03-15 00:43:05.000000', 'temperatura', 965.0000, 'ºC'),
	(246192, 119, '2014-03-15 00:43:06.000000', 'temperatura', 1138.0000, 'ºC'),
	(246193, 119, '2014-03-15 00:43:07.000000', 'temperatura', 394.0000, 'ºC'),
	(246194, 119, '2014-03-15 00:43:08.000000', 'temperatura', 959.0000, 'ºC'),
	(246195, 119, '2014-03-15 00:43:09.000000', 'temperatura', 11.0000, 'ºC'),
	(246196, 119, '2014-03-15 00:43:10.000000', 'temperatura', 778.0000, 'ºC'),
	(246197, 119, '2014-03-15 00:43:11.000000', 'temperatura', 258.0000, 'ºC'),
	(246198, 119, '2014-03-15 00:43:12.000000', 'temperatura', 158.0000, 'ºC'),
	(246199, 119, '2014-03-15 00:43:13.000000', 'temperatura', 16.0000, 'ºC'),
	(246200, 119, '2014-03-15 00:43:14.000000', 'temperatura', 806.0000, 'ºC'),
	(246201, 119, '2014-03-15 00:43:15.000000', 'temperatura', 385.0000, 'ºC'),
	(246202, 119, '2014-03-15 00:43:16.000000', 'temperatura', 705.0000, 'ºC'),
	(246203, 119, '2014-03-15 00:43:17.000000', 'temperatura', 1171.0000, 'ºC'),
	(246204, 119, '2014-03-15 00:43:18.000000', 'temperatura', 143.0000, 'ºC'),
	(246205, 119, '2014-03-15 00:43:19.000000', 'temperatura', 800.0000, 'ºC'),
	(246206, 119, '2014-03-15 00:43:20.000000', 'temperatura', 1170.0000, 'ºC'),
	(246207, 119, '2014-03-15 00:43:21.000000', 'temperatura', 1053.0000, 'ºC'),
	(246208, 119, '2014-03-15 00:43:22.000000', 'temperatura', 556.0000, 'ºC'),
	(246209, 119, '2014-03-15 00:43:23.000000', 'temperatura', 820.0000, 'ºC'),
	(246210, 119, '2014-03-15 00:43:24.000000', 'temperatura', 35.0000, 'ºC'),
	(246211, 119, '2014-03-15 00:43:25.000000', 'temperatura', 112.0000, 'ºC'),
	(246212, 119, '2014-03-15 00:43:26.000000', 'temperatura', 457.0000, 'ºC'),
	(246213, 119, '2014-03-15 00:43:27.000000', 'temperatura', 750.0000, 'ºC'),
	(246214, 119, '2014-03-15 00:43:28.000000', 'temperatura', 1180.0000, 'ºC'),
	(246215, 119, '2014-03-15 00:43:29.000000', 'temperatura', 48.0000, 'ºC'),
	(246216, 119, '2014-03-15 00:43:30.000000', 'temperatura', 304.0000, 'ºC'),
	(246217, 119, '2014-03-15 00:43:31.000000', 'temperatura', 174.0000, 'ºC'),
	(246218, 119, '2014-03-15 00:43:32.000000', 'temperatura', 1160.0000, 'ºC'),
	(246219, 119, '2014-03-15 00:43:33.000000', 'temperatura', 478.0000, 'ºC'),
	(246220, 119, '2014-03-15 00:43:34.000000', 'temperatura', 109.0000, 'ºC'),
	(246221, 119, '2014-03-15 00:43:35.000000', 'temperatura', 311.0000, 'ºC'),
	(246222, 119, '2014-03-15 00:43:36.000000', 'temperatura', 30.0000, 'ºC'),
	(246223, 119, '2014-03-15 00:43:37.000000', 'temperatura', 418.0000, 'ºC'),
	(246224, 119, '2014-03-15 00:43:38.000000', 'temperatura', 800.0000, 'ºC'),
	(246225, 119, '2014-03-15 00:43:39.000000', 'temperatura', 347.0000, 'ºC'),
	(246226, 119, '2014-03-15 00:43:40.000000', 'temperatura', 535.0000, 'ºC'),
	(246227, 119, '2014-03-15 00:43:41.000000', 'temperatura', 435.0000, 'ºC'),
	(246228, 119, '2014-03-15 00:43:42.000000', 'temperatura', 572.0000, 'ºC'),
	(246229, 119, '2014-03-15 00:43:43.000000', 'temperatura', 354.0000, 'ºC'),
	(246230, 119, '2014-03-15 00:43:44.000000', 'temperatura', 55.0000, 'ºC'),
	(246231, 119, '2014-03-15 00:43:45.000000', 'temperatura', 411.0000, 'ºC'),
	(246232, 119, '2014-03-15 00:43:46.000000', 'temperatura', 694.0000, 'ºC'),
	(246233, 119, '2014-03-15 00:43:47.000000', 'temperatura', 1037.0000, 'ºC'),
	(246234, 119, '2014-03-15 00:43:48.000000', 'temperatura', 703.0000, 'ºC'),
	(246235, 119, '2014-03-15 00:43:49.000000', 'temperatura', 403.0000, 'ºC'),
	(246236, 119, '2014-03-15 00:43:50.000000', 'temperatura', 1107.0000, 'ºC'),
	(246237, 119, '2014-03-15 00:43:51.000000', 'temperatura', 728.0000, 'ºC'),
	(246238, 119, '2014-03-15 00:43:52.000000', 'temperatura', 320.0000, 'ºC'),
	(246239, 119, '2014-03-15 00:43:53.000000', 'temperatura', 615.0000, 'ºC'),
	(246240, 119, '2014-03-15 00:43:54.000000', 'temperatura', 916.0000, 'ºC'),
	(246241, 119, '2014-03-15 00:43:55.000000', 'temperatura', 335.0000, 'ºC'),
	(246242, 119, '2014-03-15 00:43:56.000000', 'temperatura', 130.0000, 'ºC'),
	(246243, 119, '2014-03-15 00:43:57.000000', 'temperatura', 842.0000, 'ºC'),
	(246244, 119, '2014-03-15 00:43:58.000000', 'temperatura', 222.0000, 'ºC'),
	(246245, 119, '2014-03-15 00:43:59.000000', 'temperatura', 983.0000, 'ºC'),
	(246246, 119, '2014-03-15 00:44:00.000000', 'temperatura', 650.0000, 'ºC'),
	(246247, 119, '2014-03-15 00:44:01.000000', 'temperatura', 302.0000, 'ºC'),
	(246248, 119, '2014-03-15 00:44:02.000000', 'temperatura', 762.0000, 'ºC'),
	(246249, 119, '2014-03-15 00:44:03.000000', 'temperatura', 502.0000, 'ºC'),
	(246250, 119, '2014-03-15 00:44:04.000000', 'temperatura', 225.0000, 'ºC'),
	(246251, 119, '2014-03-15 00:44:05.000000', 'temperatura', 822.0000, 'ºC'),
	(246252, 119, '2014-03-15 00:44:06.000000', 'temperatura', 1032.0000, 'ºC'),
	(246253, 119, '2014-03-15 00:44:07.000000', 'temperatura', 298.0000, 'ºC'),
	(246254, 119, '2014-03-15 00:44:08.000000', 'temperatura', 793.0000, 'ºC'),
	(246255, 119, '2014-03-15 00:44:09.000000', 'temperatura', 672.0000, 'ºC'),
	(246256, 119, '2014-03-15 00:44:10.000000', 'temperatura', 982.0000, 'ºC'),
	(246257, 119, '2014-03-15 00:44:11.000000', 'temperatura', 492.0000, 'ºC'),
	(246258, 119, '2014-03-15 00:44:12.000000', 'temperatura', 716.0000, 'ºC'),
	(246259, 119, '2014-03-15 00:44:13.000000', 'temperatura', 905.0000, 'ºC'),
	(246260, 119, '2014-03-15 00:44:14.000000', 'temperatura', 1178.0000, 'ºC'),
	(246261, 119, '2014-03-15 00:44:15.000000', 'temperatura', 776.0000, 'ºC'),
	(246262, 119, '2014-03-15 00:44:16.000000', 'temperatura', 347.0000, 'ºC'),
	(246263, 119, '2014-03-15 00:44:17.000000', 'temperatura', 607.0000, 'ºC'),
	(246264, 119, '2014-03-15 00:44:18.000000', 'temperatura', 796.0000, 'ºC'),
	(246265, 119, '2014-03-15 00:44:19.000000', 'temperatura', 959.0000, 'ºC'),
	(246266, 119, '2014-03-15 00:44:20.000000', 'temperatura', 9.0000, 'ºC'),
	(246267, 119, '2014-03-15 00:44:21.000000', 'temperatura', 767.0000, 'ºC'),
	(246268, 119, '2014-03-15 00:44:22.000000', 'temperatura', 210.0000, 'ºC'),
	(246269, 119, '2014-03-15 00:44:23.000000', 'temperatura', 1147.0000, 'ºC'),
	(246270, 119, '2014-03-15 00:44:24.000000', 'temperatura', 308.0000, 'ºC'),
	(246271, 119, '2014-03-15 00:44:25.000000', 'temperatura', 498.0000, 'ºC'),
	(246272, 119, '2014-03-15 00:44:26.000000', 'temperatura', 369.0000, 'ºC'),
	(246273, 119, '2014-03-15 00:44:27.000000', 'temperatura', 349.0000, 'ºC'),
	(246274, 119, '2014-03-15 00:44:28.000000', 'temperatura', 637.0000, 'ºC'),
	(246275, 119, '2014-03-15 00:44:29.000000', 'temperatura', 941.0000, 'ºC'),
	(246276, 119, '2014-03-15 00:44:30.000000', 'temperatura', 395.0000, 'ºC'),
	(246277, 119, '2014-03-15 00:44:31.000000', 'temperatura', 350.0000, 'ºC'),
	(246278, 119, '2014-03-15 00:44:32.000000', 'temperatura', 567.0000, 'ºC'),
	(246279, 119, '2014-03-15 00:44:33.000000', 'temperatura', 586.0000, 'ºC'),
	(246280, 119, '2014-03-15 00:44:34.000000', 'temperatura', 28.0000, 'ºC'),
	(246281, 119, '2014-03-15 00:44:35.000000', 'temperatura', 784.0000, 'ºC'),
	(246282, 119, '2014-03-15 00:44:36.000000', 'temperatura', 234.0000, 'ºC'),
	(246283, 119, '2014-03-15 00:44:37.000000', 'temperatura', 21.0000, 'ºC'),
	(246284, 119, '2014-03-15 00:44:38.000000', 'temperatura', 605.0000, 'ºC'),
	(246285, 119, '2014-03-15 00:44:39.000000', 'temperatura', 560.0000, 'ºC'),
	(246286, 119, '2014-03-15 00:44:40.000000', 'temperatura', 985.0000, 'ºC'),
	(246287, 119, '2014-03-15 00:44:41.000000', 'temperatura', 848.0000, 'ºC'),
	(246288, 119, '2014-03-15 00:44:42.000000', 'temperatura', 85.0000, 'ºC'),
	(246289, 119, '2014-03-15 00:44:43.000000', 'temperatura', 282.0000, 'ºC'),
	(246290, 119, '2014-03-15 00:44:44.000000', 'temperatura', 1154.0000, 'ºC'),
	(246291, 119, '2014-03-15 00:44:45.000000', 'temperatura', 127.0000, 'ºC'),
	(246292, 119, '2014-03-15 00:44:46.000000', 'temperatura', 771.0000, 'ºC'),
	(246293, 119, '2014-03-15 00:44:47.000000', 'temperatura', 1074.0000, 'ºC'),
	(246294, 119, '2014-03-15 00:44:48.000000', 'temperatura', 659.0000, 'ºC'),
	(246295, 119, '2014-03-15 00:44:49.000000', 'temperatura', 73.0000, 'ºC'),
	(246296, 119, '2014-03-15 00:44:50.000000', 'temperatura', 789.0000, 'ºC'),
	(246297, 119, '2014-03-15 00:44:51.000000', 'temperatura', 124.0000, 'ºC'),
	(246298, 119, '2014-03-15 00:44:52.000000', 'temperatura', 655.0000, 'ºC'),
	(246299, 119, '2014-03-15 00:44:53.000000', 'temperatura', 505.0000, 'ºC'),
	(246300, 119, '2014-03-15 00:44:54.000000', 'temperatura', 561.0000, 'ºC'),
	(246301, 119, '2014-03-15 00:44:55.000000', 'temperatura', 90.0000, 'ºC'),
	(246302, 119, '2014-03-15 00:44:56.000000', 'temperatura', 1165.0000, 'ºC'),
	(246303, 119, '2014-03-15 00:44:57.000000', 'temperatura', 757.0000, 'ºC'),
	(246304, 119, '2014-03-15 00:44:58.000000', 'temperatura', 291.0000, 'ºC'),
	(246305, 119, '2014-03-15 00:44:59.000000', 'temperatura', 385.0000, 'ºC'),
	(246306, 119, '2014-03-15 00:45:00.000000', 'temperatura', 1053.0000, 'ºC'),
	(246307, 119, '2014-03-15 00:45:01.000000', 'temperatura', 511.0000, 'ºC'),
	(246308, 119, '2014-03-15 00:45:02.000000', 'temperatura', 594.0000, 'ºC'),
	(246309, 119, '2014-03-15 00:45:03.000000', 'temperatura', 237.0000, 'ºC'),
	(246310, 119, '2014-03-15 00:45:04.000000', 'temperatura', 604.0000, 'ºC'),
	(246311, 119, '2014-03-15 00:45:05.000000', 'temperatura', 1111.0000, 'ºC'),
	(246312, 119, '2014-03-15 00:45:06.000000', 'temperatura', 143.0000, 'ºC'),
	(246313, 119, '2014-03-15 00:45:07.000000', 'temperatura', 984.0000, 'ºC'),
	(246314, 119, '2014-03-15 00:45:08.000000', 'temperatura', 890.0000, 'ºC'),
	(246315, 119, '2014-03-15 00:45:09.000000', 'temperatura', 300.0000, 'ºC'),
	(246316, 119, '2014-03-15 00:45:10.000000', 'temperatura', 28.0000, 'ºC'),
	(246317, 119, '2014-03-15 00:45:11.000000', 'temperatura', 443.0000, 'ºC'),
	(246318, 119, '2014-03-15 00:45:12.000000', 'temperatura', 931.0000, 'ºC'),
	(246319, 119, '2014-03-15 00:45:13.000000', 'temperatura', 926.0000, 'ºC'),
	(246320, 119, '2014-03-15 00:45:14.000000', 'temperatura', 636.0000, 'ºC'),
	(246321, 119, '2014-03-15 00:45:15.000000', 'temperatura', 404.0000, 'ºC'),
	(246322, 119, '2014-03-15 00:45:16.000000', 'temperatura', 110.0000, 'ºC'),
	(246323, 119, '2014-03-15 00:45:17.000000', 'temperatura', 542.0000, 'ºC'),
	(246324, 119, '2014-03-15 00:45:18.000000', 'temperatura', 1178.0000, 'ºC'),
	(246325, 119, '2014-03-15 00:45:19.000000', 'temperatura', 666.0000, 'ºC'),
	(246326, 119, '2014-03-15 00:45:20.000000', 'temperatura', 996.0000, 'ºC'),
	(246327, 119, '2014-03-15 00:45:21.000000', 'temperatura', 582.0000, 'ºC'),
	(246328, 119, '2014-03-15 00:45:22.000000', 'temperatura', 1122.0000, 'ºC'),
	(246329, 119, '2014-03-15 00:45:23.000000', 'temperatura', 265.0000, 'ºC'),
	(246330, 119, '2014-03-15 00:45:24.000000', 'temperatura', 361.0000, 'ºC'),
	(246331, 119, '2014-03-15 00:45:25.000000', 'temperatura', 1008.0000, 'ºC'),
	(246332, 119, '2014-03-15 00:45:26.000000', 'temperatura', 357.0000, 'ºC'),
	(246333, 119, '2014-03-15 00:45:27.000000', 'temperatura', 1163.0000, 'ºC'),
	(246334, 119, '2014-03-15 00:45:28.000000', 'temperatura', 1146.0000, 'ºC'),
	(246335, 119, '2014-03-15 00:45:29.000000', 'temperatura', 1041.0000, 'ºC'),
	(246336, 119, '2014-03-15 00:45:30.000000', 'temperatura', 566.0000, 'ºC'),
	(246337, 119, '2014-03-15 00:45:31.000000', 'temperatura', 907.0000, 'ºC'),
	(246338, 119, '2014-03-15 00:45:32.000000', 'temperatura', 439.0000, 'ºC'),
	(246339, 119, '2014-03-15 00:45:33.000000', 'temperatura', 675.0000, 'ºC'),
	(246340, 119, '2014-03-15 00:45:34.000000', 'temperatura', 856.0000, 'ºC'),
	(246341, 119, '2014-03-15 00:45:35.000000', 'temperatura', 1058.0000, 'ºC'),
	(246342, 119, '2014-03-15 00:45:36.000000', 'temperatura', 321.0000, 'ºC'),
	(246343, 119, '2014-03-15 00:45:37.000000', 'temperatura', 834.0000, 'ºC'),
	(246344, 119, '2014-03-15 00:45:38.000000', 'temperatura', 806.0000, 'ºC'),
	(246345, 119, '2014-03-15 00:45:39.000000', 'temperatura', 329.0000, 'ºC'),
	(246346, 119, '2014-03-15 00:45:40.000000', 'temperatura', 427.0000, 'ºC'),
	(246347, 119, '2014-03-15 00:45:41.000000', 'temperatura', 1147.0000, 'ºC'),
	(246348, 119, '2014-03-15 00:45:42.000000', 'temperatura', 856.0000, 'ºC'),
	(246349, 119, '2014-03-15 00:45:43.000000', 'temperatura', 837.0000, 'ºC'),
	(246350, 119, '2014-03-15 00:45:44.000000', 'temperatura', 420.0000, 'ºC'),
	(246351, 119, '2014-03-15 00:45:45.000000', 'temperatura', 788.0000, 'ºC'),
	(246352, 119, '2014-03-15 00:45:46.000000', 'temperatura', 281.0000, 'ºC'),
	(246353, 119, '2014-03-15 00:45:47.000000', 'temperatura', 242.0000, 'ºC'),
	(246354, 119, '2014-03-15 00:45:48.000000', 'temperatura', 366.0000, 'ºC'),
	(246355, 119, '2014-03-15 00:45:49.000000', 'temperatura', 1104.0000, 'ºC'),
	(246356, 119, '2014-03-15 00:45:50.000000', 'temperatura', 822.0000, 'ºC'),
	(246357, 119, '2014-03-15 00:45:51.000000', 'temperatura', 801.0000, 'ºC'),
	(246358, 119, '2014-03-15 00:45:52.000000', 'temperatura', 336.0000, 'ºC'),
	(246359, 119, '2014-03-15 00:45:53.000000', 'temperatura', 481.0000, 'ºC'),
	(246360, 119, '2014-03-15 00:45:54.000000', 'temperatura', 194.0000, 'ºC'),
	(246361, 119, '2014-03-15 00:45:55.000000', 'temperatura', 731.0000, 'ºC'),
	(246362, 119, '2014-03-15 00:45:56.000000', 'temperatura', 672.0000, 'ºC'),
	(246363, 119, '2014-03-15 00:45:57.000000', 'temperatura', 1170.0000, 'ºC'),
	(246364, 119, '2014-03-15 00:45:58.000000', 'temperatura', 231.0000, 'ºC'),
	(246365, 119, '2014-03-15 00:45:59.000000', 'temperatura', 48.0000, 'ºC'),
	(246366, 119, '2014-03-15 00:46:00.000000', 'temperatura', 747.0000, 'ºC'),
	(246367, 119, '2014-03-15 00:46:01.000000', 'temperatura', 1190.0000, 'ºC'),
	(246368, 119, '2014-03-15 00:46:02.000000', 'temperatura', 112.0000, 'ºC'),
	(246369, 119, '2014-03-15 00:46:03.000000', 'temperatura', 591.0000, 'ºC'),
	(246370, 119, '2014-03-15 00:46:04.000000', 'temperatura', 220.0000, 'ºC'),
	(246371, 119, '2014-03-15 00:46:05.000000', 'temperatura', 526.0000, 'ºC'),
	(246372, 119, '2014-03-15 00:46:06.000000', 'temperatura', 772.0000, 'ºC'),
	(246373, 119, '2014-03-15 00:46:07.000000', 'temperatura', 1080.0000, 'ºC'),
	(246374, 119, '2014-03-15 00:46:08.000000', 'temperatura', 687.0000, 'ºC'),
	(246375, 119, '2014-03-15 00:46:09.000000', 'temperatura', 194.0000, 'ºC'),
	(246376, 119, '2014-03-15 00:46:10.000000', 'temperatura', 110.0000, 'ºC'),
	(246377, 119, '2014-03-15 00:46:11.000000', 'temperatura', 1169.0000, 'ºC'),
	(246378, 119, '2014-03-15 00:46:12.000000', 'temperatura', 715.0000, 'ºC'),
	(246379, 119, '2014-03-15 00:46:13.000000', 'temperatura', 68.0000, 'ºC'),
	(246380, 119, '2014-03-15 00:46:14.000000', 'temperatura', 596.0000, 'ºC'),
	(246381, 119, '2014-03-15 00:46:15.000000', 'temperatura', 379.0000, 'ºC'),
	(246382, 119, '2014-03-15 00:46:16.000000', 'temperatura', 104.0000, 'ºC'),
	(246383, 119, '2014-03-15 00:46:17.000000', 'temperatura', 584.0000, 'ºC'),
	(246384, 119, '2014-03-15 00:46:18.000000', 'temperatura', 209.0000, 'ºC'),
	(246385, 119, '2014-03-15 00:46:19.000000', 'temperatura', 493.0000, 'ºC'),
	(246386, 119, '2014-03-15 00:46:20.000000', 'temperatura', 640.0000, 'ºC'),
	(246387, 119, '2014-03-15 00:46:21.000000', 'temperatura', 521.0000, 'ºC'),
	(246388, 119, '2014-03-15 00:46:22.000000', 'temperatura', 687.0000, 'ºC'),
	(246389, 119, '2014-03-15 00:46:23.000000', 'temperatura', 669.0000, 'ºC'),
	(246390, 119, '2014-03-15 00:46:24.000000', 'temperatura', 87.0000, 'ºC'),
	(246391, 119, '2014-03-15 00:46:25.000000', 'temperatura', 828.0000, 'ºC'),
	(246392, 119, '2014-03-15 00:46:26.000000', 'temperatura', 279.0000, 'ºC'),
	(246393, 119, '2014-03-15 00:46:27.000000', 'temperatura', 112.0000, 'ºC'),
	(246394, 119, '2014-03-15 00:46:28.000000', 'temperatura', 925.0000, 'ºC'),
	(246395, 119, '2014-03-15 00:46:29.000000', 'temperatura', 688.0000, 'ºC'),
	(246396, 119, '2014-03-15 00:46:30.000000', 'temperatura', 667.0000, 'ºC'),
	(246397, 119, '2014-03-15 00:46:31.000000', 'temperatura', 70.0000, 'ºC'),
	(246398, 119, '2014-03-15 00:46:32.000000', 'temperatura', 750.0000, 'ºC'),
	(246399, 119, '2014-03-15 00:46:33.000000', 'temperatura', 1142.0000, 'ºC'),
	(246400, 119, '2014-03-15 00:46:34.000000', 'temperatura', 1061.0000, 'ºC'),
	(246401, 119, '2014-03-15 00:46:35.000000', 'temperatura', 679.0000, 'ºC'),
	(246402, 119, '2014-03-15 00:46:36.000000', 'temperatura', 213.0000, 'ºC'),
	(246403, 119, '2014-03-15 00:46:37.000000', 'temperatura', 227.0000, 'ºC'),
	(246404, 119, '2014-03-15 00:46:38.000000', 'temperatura', 499.0000, 'ºC'),
	(246405, 119, '2014-03-15 00:46:39.000000', 'temperatura', 612.0000, 'ºC'),
	(246406, 119, '2014-03-15 00:46:40.000000', 'temperatura', 363.0000, 'ºC'),
	(246407, 119, '2014-03-15 00:46:41.000000', 'temperatura', 1181.0000, 'ºC'),
	(246408, 119, '2014-03-15 00:46:42.000000', 'temperatura', 14.0000, 'ºC'),
	(246409, 119, '2014-03-15 00:46:43.000000', 'temperatura', 130.0000, 'ºC'),
	(246410, 119, '2014-03-15 00:46:44.000000', 'temperatura', 606.0000, 'ºC'),
	(246411, 119, '2014-03-15 00:46:45.000000', 'temperatura', 241.0000, 'ºC'),
	(246412, 119, '2014-03-15 00:46:46.000000', 'temperatura', 589.0000, 'ºC'),
	(246413, 119, '2014-03-15 00:46:47.000000', 'temperatura', 1020.0000, 'ºC'),
	(246414, 119, '2014-03-15 00:46:48.000000', 'temperatura', 933.0000, 'ºC'),
	(246415, 119, '2014-03-15 00:46:49.000000', 'temperatura', 409.0000, 'ºC'),
	(246416, 119, '2014-03-15 00:46:50.000000', 'temperatura', 444.0000, 'ºC'),
	(246417, 119, '2014-03-15 00:46:51.000000', 'temperatura', 994.0000, 'ºC'),
	(246418, 119, '2014-03-15 00:46:52.000000', 'temperatura', 39.0000, 'ºC'),
	(246419, 119, '2014-03-15 00:46:53.000000', 'temperatura', 814.0000, 'ºC'),
	(246420, 119, '2014-03-15 00:46:54.000000', 'temperatura', 352.0000, 'ºC'),
	(246421, 119, '2014-03-15 00:46:55.000000', 'temperatura', 518.0000, 'ºC'),
	(246422, 119, '2014-03-15 00:46:56.000000', 'temperatura', 334.0000, 'ºC'),
	(246423, 119, '2014-03-15 00:46:57.000000', 'temperatura', 115.0000, 'ºC'),
	(246424, 119, '2014-03-15 00:46:58.000000', 'temperatura', 777.0000, 'ºC'),
	(246425, 119, '2014-03-15 00:46:59.000000', 'temperatura', 1139.0000, 'ºC'),
	(246426, 119, '2014-03-15 00:47:00.000000', 'temperatura', 965.0000, 'ºC'),
	(246427, 119, '2014-03-15 00:47:01.000000', 'temperatura', 209.0000, 'ºC'),
	(246428, 119, '2014-03-15 00:47:02.000000', 'temperatura', 550.0000, 'ºC'),
	(246429, 119, '2014-03-15 00:47:03.000000', 'temperatura', 924.0000, 'ºC'),
	(246430, 119, '2014-03-15 00:47:04.000000', 'temperatura', 569.0000, 'ºC'),
	(246431, 119, '2014-03-15 00:47:05.000000', 'temperatura', 75.0000, 'ºC'),
	(246432, 119, '2014-03-15 00:47:06.000000', 'temperatura', 1067.0000, 'ºC'),
	(246433, 119, '2014-03-15 00:47:07.000000', 'temperatura', 309.0000, 'ºC'),
	(246434, 119, '2014-03-15 00:47:08.000000', 'temperatura', 746.0000, 'ºC'),
	(246435, 119, '2014-03-15 00:47:09.000000', 'temperatura', 405.0000, 'ºC'),
	(246436, 119, '2014-03-15 00:47:10.000000', 'temperatura', 987.0000, 'ºC'),
	(246437, 119, '2014-03-15 00:47:11.000000', 'temperatura', 121.0000, 'ºC'),
	(246438, 119, '2014-03-15 00:47:12.000000', 'temperatura', 43.0000, 'ºC'),
	(246439, 119, '2014-03-15 00:47:13.000000', 'temperatura', 1051.0000, 'ºC'),
	(246440, 119, '2014-03-15 00:47:14.000000', 'temperatura', 330.0000, 'ºC'),
	(246441, 119, '2014-03-15 00:47:15.000000', 'temperatura', 895.0000, 'ºC'),
	(246442, 119, '2014-03-15 00:47:16.000000', 'temperatura', 1084.0000, 'ºC'),
	(246443, 119, '2014-03-15 00:47:17.000000', 'temperatura', 338.0000, 'ºC'),
	(246444, 119, '2014-03-15 00:47:18.000000', 'temperatura', 838.0000, 'ºC'),
	(246445, 119, '2014-03-15 00:47:19.000000', 'temperatura', 778.0000, 'ºC'),
	(246446, 119, '2014-03-15 00:47:20.000000', 'temperatura', 177.0000, 'ºC'),
	(246447, 119, '2014-03-15 00:47:21.000000', 'temperatura', 949.0000, 'ºC'),
	(246448, 119, '2014-03-15 00:47:22.000000', 'temperatura', 617.0000, 'ºC'),
	(246449, 119, '2014-03-15 00:47:23.000000', 'temperatura', 235.0000, 'ºC'),
	(246450, 119, '2014-03-15 00:47:24.000000', 'temperatura', 528.0000, 'ºC'),
	(246451, 119, '2014-03-15 00:47:25.000000', 'temperatura', 733.0000, 'ºC'),
	(246452, 119, '2014-03-15 00:47:26.000000', 'temperatura', 884.0000, 'ºC'),
	(246453, 119, '2014-03-15 00:47:27.000000', 'temperatura', 1019.0000, 'ºC'),
	(246454, 119, '2014-03-15 00:47:28.000000', 'temperatura', 46.0000, 'ºC'),
	(246455, 119, '2014-03-15 00:47:29.000000', 'temperatura', 773.0000, 'ºC'),
	(246456, 119, '2014-03-15 00:47:30.000000', 'temperatura', 126.0000, 'ºC'),
	(246457, 119, '2014-03-15 00:47:31.000000', 'temperatura', 713.0000, 'ºC'),
	(246458, 119, '2014-03-15 00:47:32.000000', 'temperatura', 786.0000, 'ºC'),
	(246459, 119, '2014-03-15 00:47:33.000000', 'temperatura', 591.0000, 'ºC'),
	(246460, 119, '2014-03-15 00:47:34.000000', 'temperatura', 599.0000, 'ºC'),
	(246461, 119, '2014-03-15 00:47:35.000000', 'temperatura', 23.0000, 'ºC'),
	(246462, 119, '2014-03-15 00:47:36.000000', 'temperatura', 717.0000, 'ºC'),
	(246463, 119, '2014-03-15 00:47:37.000000', 'temperatura', 1117.0000, 'ºC'),
	(246464, 119, '2014-03-15 00:47:38.000000', 'temperatura', 1033.0000, 'ºC'),
	(246465, 119, '2014-03-15 00:47:39.000000', 'temperatura', 613.0000, 'ºC'),
	(246466, 119, '2014-03-15 00:47:40.000000', 'temperatura', 1170.0000, 'ºC'),
	(246467, 119, '2014-03-15 00:47:41.000000', 'temperatura', 412.0000, 'ºC'),
	(246468, 119, '2014-03-15 00:47:42.000000', 'temperatura', 949.0000, 'ºC'),
	(246469, 119, '2014-03-15 00:47:43.000000', 'temperatura', 1111.0000, 'ºC'),
	(246470, 119, '2014-03-15 00:47:44.000000', 'temperatura', 307.0000, 'ºC'),
	(246471, 119, '2014-03-15 00:47:45.000000', 'temperatura', 602.0000, 'ºC'),
	(246472, 119, '2014-03-15 00:47:46.000000', 'temperatura', 892.0000, 'ºC'),
	(246473, 119, '2014-03-15 00:47:47.000000', 'temperatura', 253.0000, 'ºC'),
	(246474, 119, '2014-03-15 00:47:48.000000', 'temperatura', 988.0000, 'ºC'),
	(246475, 119, '2014-03-15 00:47:49.000000', 'temperatura', 584.0000, 'ºC'),
	(246476, 119, '2014-03-15 00:47:50.000000', 'temperatura', 1154.0000, 'ºC'),
	(246477, 119, '2014-03-15 00:47:51.000000', 'temperatura', 420.0000, 'ºC'),
	(246478, 119, '2014-03-15 00:47:52.000000', 'temperatura', 1038.0000, 'ºC'),
	(246479, 119, '2014-03-15 00:47:53.000000', 'temperatura', 331.0000, 'ºC'),
	(246480, 119, '2014-03-15 00:47:54.000000', 'temperatura', 941.0000, 'ºC'),
	(246481, 119, '2014-03-15 00:47:55.000000', 'temperatura', 111.0000, 'ºC'),
	(246482, 119, '2014-03-15 00:47:56.000000', 'temperatura', 135.0000, 'ºC'),
	(246483, 119, '2014-03-15 00:47:57.000000', 'temperatura', 341.0000, 'ºC'),
	(246484, 119, '2014-03-15 00:47:58.000000', 'temperatura', 103.0000, 'ºC'),
	(246485, 119, '2014-03-15 00:47:59.000000', 'temperatura', 691.0000, 'ºC'),
	(246486, 119, '2014-03-15 00:48:00.000000', 'temperatura', 744.0000, 'ºC'),
	(246487, 119, '2014-03-15 00:48:01.000000', 'temperatura', 451.0000, 'ºC'),
	(246488, 119, '2014-03-15 00:48:02.000000', 'temperatura', 22.0000, 'ºC'),
	(246489, 119, '2014-03-15 00:48:03.000000', 'temperatura', 1157.0000, 'ºC'),
	(246490, 119, '2014-03-15 00:48:04.000000', 'temperatura', 920.0000, 'ºC'),
	(246491, 119, '2014-03-15 00:48:05.000000', 'temperatura', 1128.0000, 'ºC'),
	(246492, 119, '2014-03-15 00:48:06.000000', 'temperatura', 480.0000, 'ºC'),
	(246493, 119, '2014-03-15 00:48:07.000000', 'temperatura', 218.0000, 'ºC'),
	(246494, 119, '2014-03-15 00:48:08.000000', 'temperatura', 850.0000, 'ºC'),
	(246495, 119, '2014-03-15 00:48:09.000000', 'temperatura', 1197.0000, 'ºC'),
	(246496, 119, '2014-03-15 00:48:10.000000', 'temperatura', 1036.0000, 'ºC'),
	(246497, 119, '2014-03-15 00:48:11.000000', 'temperatura', 391.0000, 'ºC'),
	(246498, 119, '2014-03-15 00:48:12.000000', 'temperatura', 45.0000, 'ºC'),
	(246499, 119, '2014-03-15 00:48:13.000000', 'temperatura', 253.0000, 'ºC'),
	(246500, 119, '2014-03-15 00:48:14.000000', 'temperatura', 1130.0000, 'ºC'),
	(246501, 119, '2014-03-15 00:48:15.000000', 'temperatura', 90.0000, 'ºC'),
	(246502, 119, '2014-03-15 00:48:16.000000', 'temperatura', 663.0000, 'ºC'),
	(246503, 119, '2014-03-15 00:48:17.000000', 'temperatura', 645.0000, 'ºC'),
	(246504, 119, '2014-03-15 00:48:18.000000', 'temperatura', 38.0000, 'ºC'),
	(246505, 119, '2014-03-15 00:48:19.000000', 'temperatura', 654.0000, 'ºC'),
	(246506, 119, '2014-03-15 00:48:20.000000', 'temperatura', 758.0000, 'ºC'),
	(246507, 119, '2014-03-15 00:48:21.000000', 'temperatura', 629.0000, 'ºC'),
	(246508, 119, '2014-03-15 00:48:22.000000', 'temperatura', 872.0000, 'ºC'),
	(246509, 119, '2014-03-15 00:48:23.000000', 'temperatura', 73.0000, 'ºC'),
	(246510, 119, '2014-03-15 00:48:24.000000', 'temperatura', 150.0000, 'ºC'),
	(246511, 119, '2014-03-15 00:48:25.000000', 'temperatura', 532.0000, 'ºC'),
	(246512, 119, '2014-03-15 00:48:26.000000', 'temperatura', 1008.0000, 'ºC'),
	(246513, 119, '2014-03-15 00:48:27.000000', 'temperatura', 1047.0000, 'ºC'),
	(246514, 119, '2014-03-15 00:48:28.000000', 'temperatura', 1009.0000, 'ºC'),
	(246515, 119, '2014-03-15 00:48:29.000000', 'temperatura', 704.0000, 'ºC'),
	(246516, 119, '2014-03-15 00:48:30.000000', 'temperatura', 496.0000, 'ºC'),
	(246517, 119, '2014-03-15 00:48:31.000000', 'temperatura', 367.0000, 'ºC'),
	(246518, 119, '2014-03-15 00:48:32.000000', 'temperatura', 349.0000, 'ºC'),
	(246519, 119, '2014-03-15 00:48:33.000000', 'temperatura', 645.0000, 'ºC'),
	(246520, 119, '2014-03-15 00:48:34.000000', 'temperatura', 976.0000, 'ºC'),
	(246521, 119, '2014-03-15 00:48:35.000000', 'temperatura', 546.0000, 'ºC'),
	(246522, 119, '2014-03-15 00:48:36.000000', 'temperatura', 1002.0000, 'ºC'),
	(246523, 119, '2014-03-15 00:48:37.000000', 'temperatura', 974.0000, 'ºC'),
	(246524, 119, '2014-03-15 00:48:38.000000', 'temperatura', 665.0000, 'ºC'),
	(246525, 119, '2014-03-15 00:48:39.000000', 'temperatura', 404.0000, 'ºC'),
	(246526, 119, '2014-03-15 00:48:40.000000', 'temperatura', 26.0000, 'ºC'),
	(246527, 119, '2014-03-15 00:48:41.000000', 'temperatura', 118.0000, 'ºC'),
	(246528, 119, '2014-03-15 00:48:42.000000', 'temperatura', 513.0000, 'ºC'),
	(246529, 119, '2014-03-15 00:48:43.000000', 'temperatura', 1011.0000, 'ºC'),
	(246530, 119, '2014-03-15 00:48:44.000000', 'temperatura', 1117.0000, 'ºC'),
	(246531, 119, '2014-03-15 00:48:45.000000', 'temperatura', 152.0000, 'ºC'),
	(246532, 119, '2014-03-15 00:48:46.000000', 'temperatura', 1012.0000, 'ºC'),
	(246533, 119, '2014-03-15 00:48:47.000000', 'temperatura', 1001.0000, 'ºC'),
	(246534, 119, '2014-03-15 00:48:48.000000', 'temperatura', 770.0000, 'ºC'),
	(246535, 119, '2014-03-15 00:48:49.000000', 'temperatura', 846.0000, 'ºC'),
	(246536, 119, '2014-03-15 00:48:50.000000', 'temperatura', 724.0000, 'ºC'),
	(246537, 119, '2014-03-15 00:48:51.000000', 'temperatura', 1081.0000, 'ºC'),
	(246538, 119, '2014-03-15 00:48:52.000000', 'temperatura', 832.0000, 'ºC'),
	(246539, 119, '2014-03-15 00:48:53.000000', 'temperatura', 920.0000, 'ºC'),
	(246540, 119, '2014-03-15 00:48:54.000000', 'temperatura', 902.0000, 'ºC'),
	(246541, 119, '2014-03-15 00:48:55.000000', 'temperatura', 553.0000, 'ºC'),
	(246542, 119, '2014-03-15 00:48:56.000000', 'temperatura', 60.0000, 'ºC'),
	(246543, 119, '2014-03-15 00:48:57.000000', 'temperatura', 1041.0000, 'ºC'),
	(246544, 119, '2014-03-15 00:48:58.000000', 'temperatura', 224.0000, 'ºC'),
	(246545, 119, '2014-03-15 00:48:59.000000', 'temperatura', 397.0000, 'ºC'),
	(246546, 119, '2014-03-15 00:49:00.000000', 'temperatura', 115.0000, 'ºC'),
	(246547, 119, '2014-03-15 00:49:01.000000', 'temperatura', 584.0000, 'ºC'),
	(246548, 119, '2014-03-15 00:49:02.000000', 'temperatura', 176.0000, 'ºC'),
	(246549, 119, '2014-03-15 00:49:03.000000', 'temperatura', 329.0000, 'ºC'),
	(246550, 119, '2014-03-15 00:49:04.000000', 'temperatura', 1119.0000, 'ºC'),
	(246551, 119, '2014-03-15 00:49:05.000000', 'temperatura', 1005.0000, 'ºC'),
	(246552, 119, '2014-03-15 00:49:06.000000', 'temperatura', 472.0000, 'ºC'),
	(246553, 119, '2014-03-15 00:49:07.000000', 'temperatura', 542.0000, 'ºC'),
	(246554, 119, '2014-03-15 00:49:08.000000', 'temperatura', 97.0000, 'ºC'),
	(246555, 119, '2014-03-15 00:49:09.000000', 'temperatura', 60.0000, 'ºC'),
	(246556, 119, '2014-03-15 00:49:10.000000', 'temperatura', 11.0000, 'ºC'),
	(246557, 119, '2014-03-15 00:49:11.000000', 'temperatura', 1072.0000, 'ºC'),
	(246558, 119, '2014-03-15 00:49:12.000000', 'temperatura', 528.0000, 'ºC'),
	(246559, 119, '2014-03-15 00:49:13.000000', 'temperatura', 626.0000, 'ºC'),
	(246560, 119, '2014-03-15 00:49:14.000000', 'temperatura', 346.0000, 'ºC'),
	(246561, 119, '2014-03-15 00:49:15.000000', 'temperatura', 1051.0000, 'ºC'),
	(246562, 119, '2014-03-15 00:49:16.000000', 'temperatura', 618.0000, 'ºC'),
	(246563, 119, '2014-03-15 00:49:17.000000', 'temperatura', 1138.0000, 'ºC'),
	(246564, 119, '2014-03-15 00:49:18.000000', 'temperatura', 236.0000, 'ºC'),
	(246565, 119, '2014-03-15 00:49:19.000000', 'temperatura', 165.0000, 'ºC'),
	(246566, 119, '2014-03-15 00:49:20.000000', 'temperatura', 118.0000, 'ºC'),
	(246567, 119, '2014-03-15 00:49:21.000000', 'temperatura', 95.0000, 'ºC'),
	(246568, 119, '2014-03-15 00:49:22.000000', 'temperatura', 122.0000, 'ºC'),
	(246569, 119, '2014-03-15 00:49:23.000000', 'temperatura', 326.0000, 'ºC'),
	(246570, 119, '2014-03-15 00:49:24.000000', 'temperatura', 62.0000, 'ºC'),
	(246571, 119, '2014-03-15 00:49:25.000000', 'temperatura', 536.0000, 'ºC'),
	(246572, 119, '2014-03-15 00:49:26.000000', 'temperatura', 93.0000, 'ºC'),
	(246573, 119, '2014-03-15 00:49:27.000000', 'temperatura', 58.0000, 'ºC'),
	(246574, 119, '2014-03-15 00:49:28.000000', 'temperatura', 10.0000, 'ºC'),
	(246575, 119, '2014-03-15 00:49:29.000000', 'temperatura', 1079.0000, 'ºC'),
	(246576, 119, '2014-03-15 00:49:30.000000', 'temperatura', 566.0000, 'ºC'),
	(246577, 119, '2014-03-15 00:49:31.000000', 'temperatura', 793.0000, 'ºC'),
	(246578, 119, '2014-03-15 00:49:32.000000', 'temperatura', 1066.0000, 'ºC'),
	(246579, 119, '2014-03-15 00:49:33.000000', 'temperatura', 554.0000, 'ºC'),
	(246580, 119, '2014-03-15 00:49:34.000000', 'temperatura', 772.0000, 'ºC'),
	(246581, 119, '2014-03-15 00:49:35.000000', 'temperatura', 1000.0000, 'ºC'),
	(246582, 119, '2014-03-15 00:49:36.000000', 'temperatura', 284.0000, 'ºC'),
	(246583, 119, '2014-03-15 00:49:37.000000', 'temperatura', 818.0000, 'ºC'),
	(246584, 119, '2014-03-15 00:49:38.000000', 'temperatura', 840.0000, 'ºC'),
	(246585, 119, '2014-03-15 00:49:39.000000', 'temperatura', 548.0000, 'ºC'),
	(246586, 119, '2014-03-15 00:49:40.000000', 'temperatura', 218.0000, 'ºC'),
	(246587, 119, '2014-03-15 00:49:41.000000', 'temperatura', 647.0000, 'ºC'),
	(246588, 119, '2014-03-15 00:49:42.000000', 'temperatura', 183.0000, 'ºC'),
	(246589, 119, '2014-03-15 00:49:43.000000', 'temperatura', 174.0000, 'ºC'),
	(246590, 119, '2014-03-15 00:49:44.000000', 'temperatura', 321.0000, 'ºC'),
	(246591, 119, '2014-03-15 00:49:45.000000', 'temperatura', 1085.0000, 'ºC'),
	(246592, 119, '2014-03-15 00:49:46.000000', 'temperatura', 860.0000, 'ºC'),
	(246593, 119, '2014-03-15 00:49:47.000000', 'temperatura', 1046.0000, 'ºC'),
	(246594, 119, '2014-03-15 00:49:48.000000', 'temperatura', 251.0000, 'ºC'),
	(246595, 119, '2014-03-15 00:49:49.000000', 'temperatura', 519.0000, 'ºC'),
	(246596, 119, '2014-03-15 00:49:50.000000', 'temperatura', 641.0000, 'ºC'),
	(246597, 119, '2014-03-15 00:49:51.000000', 'temperatura', 447.0000, 'ºC'),
	(246598, 119, '2014-03-15 00:49:52.000000', 'temperatura', 313.0000, 'ºC'),
	(246599, 119, '2014-03-15 00:49:53.000000', 'temperatura', 224.0000, 'ºC'),
	(246600, 119, '2014-03-15 00:49:54.000000', 'temperatura', 182.0000, 'ºC'),
	(246601, 119, '2014-03-15 00:49:55.000000', 'temperatura', 239.0000, 'ºC'),
	(246602, 119, '2014-03-15 00:49:56.000000', 'temperatura', 647.0000, 'ºC'),
	(246603, 119, '2014-03-15 00:49:57.000000', 'temperatura', 121.0000, 'ºC'),
	(246604, 119, '2014-03-15 00:49:58.000000', 'temperatura', 1064.0000, 'ºC'),
	(246605, 119, '2014-03-15 00:49:59.000000', 'temperatura', 159.0000, 'ºC'),
	(246606, 119, '2014-03-15 00:50:00.000000', 'temperatura', 3.0000, 'ºC'),
	(246607, 119, '2014-03-15 00:50:01.000000', 'temperatura', 738.0000, 'ºC'),
	(246608, 119, '2014-03-15 00:50:02.000000', 'temperatura', 82.0000, 'ºC'),
	(246609, 119, '2014-03-15 00:50:03.000000', 'temperatura', 595.0000, 'ºC'),
	(246610, 119, '2014-03-15 00:50:04.000000', 'temperatura', 331.0000, 'ºC'),
	(246611, 119, '2014-03-15 00:50:05.000000', 'temperatura', 1069.0000, 'ºC'),
	(246612, 119, '2014-03-15 00:50:06.000000', 'temperatura', 755.0000, 'ºC'),
	(246613, 119, '2014-03-15 00:50:07.000000', 'temperatura', 566.0000, 'ºC'),
	(246614, 119, '2014-03-15 00:50:08.000000', 'temperatura', 567.0000, 'ºC'),
	(246615, 119, '2014-03-15 00:50:09.000000', 'temperatura', 1139.0000, 'ºC'),
	(246616, 119, '2014-03-15 00:50:10.000000', 'temperatura', 394.0000, 'ºC'),
	(246617, 119, '2014-03-15 00:50:11.000000', 'temperatura', 951.0000, 'ºC'),
	(246618, 119, '2014-03-15 00:50:12.000000', 'temperatura', 1174.0000, 'ºC'),
	(246619, 119, '2014-03-15 00:50:13.000000', 'temperatura', 618.0000, 'ºC'),
	(246620, 119, '2014-03-15 00:50:14.000000', 'temperatura', 768.0000, 'ºC'),
	(246621, 119, '2014-03-15 00:50:15.000000', 'temperatura', 788.0000, 'ºC'),
	(246622, 119, '2014-03-15 00:50:16.000000', 'temperatura', 437.0000, 'ºC'),
	(246623, 119, '2014-03-15 00:50:17.000000', 'temperatura', 1020.0000, 'ºC'),
	(246624, 119, '2014-03-15 00:50:18.000000', 'temperatura', 189.0000, 'ºC'),
	(246625, 119, '2014-03-15 00:50:19.000000', 'temperatura', 284.0000, 'ºC'),
	(246626, 119, '2014-03-15 00:50:20.000000', 'temperatura', 856.0000, 'ºC'),
	(246627, 119, '2014-03-15 00:50:21.000000', 'temperatura', 1026.0000, 'ºC'),
	(246628, 119, '2014-03-15 00:50:22.000000', 'temperatura', 165.0000, 'ºC'),
	(246629, 119, '2014-03-15 00:50:23.000000', 'temperatura', 147.0000, 'ºC'),
	(246630, 119, '2014-03-15 00:50:24.000000', 'temperatura', 240.0000, 'ºC'),
	(246631, 119, '2014-03-15 00:50:25.000000', 'temperatura', 762.0000, 'ºC'),
	(246632, 119, '2014-03-15 00:50:26.000000', 'temperatura', 688.0000, 'ºC'),
	(246633, 119, '2014-03-15 00:50:27.000000', 'temperatura', 1154.0000, 'ºC'),
	(246634, 119, '2014-03-15 00:50:28.000000', 'temperatura', 106.0000, 'ºC'),
	(246635, 119, '2014-03-15 00:50:29.000000', 'temperatura', 670.0000, 'ºC'),
	(246636, 119, '2014-03-15 00:50:30.000000', 'temperatura', 631.0000, 'ºC'),
	(246637, 119, '2014-03-15 00:50:31.000000', 'temperatura', 1145.0000, 'ºC'),
	(246638, 119, '2014-03-15 00:50:32.000000', 'temperatura', 234.0000, 'ºC'),
	(246639, 119, '2014-03-15 00:50:33.000000', 'temperatura', 136.0000, 'ºC'),
	(246640, 119, '2014-03-15 00:50:34.000000', 'temperatura', 1179.0000, 'ºC'),
	(246641, 119, '2014-03-15 00:50:35.000000', 'temperatura', 687.0000, 'ºC'),
	(246642, 119, '2014-03-15 00:50:36.000000', 'temperatura', 1097.0000, 'ºC'),
	(246643, 119, '2014-03-15 00:50:37.000000', 'temperatura', 1027.0000, 'ºC'),
	(246644, 119, '2014-03-15 00:50:38.000000', 'temperatura', 645.0000, 'ºC'),
	(246645, 119, '2014-03-15 00:50:39.000000', 'temperatura', 141.0000, 'ºC'),
	(246646, 119, '2014-03-15 00:50:40.000000', 'temperatura', 1174.0000, 'ºC'),
	(246647, 119, '2014-03-15 00:50:41.000000', 'temperatura', 646.0000, 'ºC'),
	(246648, 119, '2014-03-15 00:50:42.000000', 'temperatura', 910.0000, 'ºC'),
	(246649, 119, '2014-03-15 00:50:43.000000', 'temperatura', 210.0000, 'ºC'),
	(246650, 119, '2014-03-15 00:50:44.000000', 'temperatura', 720.0000, 'ºC'),
	(246651, 119, '2014-03-15 00:50:45.000000', 'temperatura', 571.0000, 'ºC'),
	(246652, 119, '2014-03-15 00:50:46.000000', 'temperatura', 698.0000, 'ºC'),
	(246653, 119, '2014-03-15 00:50:47.000000', 'temperatura', 575.0000, 'ºC'),
	(246654, 119, '2014-03-15 00:50:48.000000', 'temperatura', 784.0000, 'ºC'),
	(246655, 119, '2014-03-15 00:50:49.000000', 'temperatura', 992.0000, 'ºC'),
	(246656, 119, '2014-03-15 00:50:50.000000', 'temperatura', 211.0000, 'ºC'),
	(246657, 119, '2014-03-15 00:50:51.000000', 'temperatura', 481.0000, 'ºC'),
	(246658, 119, '2014-03-15 00:50:52.000000', 'temperatura', 570.0000, 'ºC'),
	(246659, 119, '2014-03-15 00:50:53.000000', 'temperatura', 209.0000, 'ºC'),
	(246660, 119, '2014-03-15 00:50:54.000000', 'temperatura', 535.0000, 'ºC'),
	(246661, 119, '2014-03-15 00:50:55.000000', 'temperatura', 849.0000, 'ºC'),
	(246662, 119, '2014-03-15 00:50:56.000000', 'temperatura', 241.0000, 'ºC'),
	(246663, 119, '2014-03-15 00:50:57.000000', 'temperatura', 1058.0000, 'ºC'),
	(246664, 119, '2014-03-15 00:50:58.000000', 'temperatura', 969.0000, 'ºC'),
	(246665, 119, '2014-03-15 00:50:59.000000', 'temperatura', 471.0000, 'ºC'),
	(246666, 119, '2014-03-15 00:51:00.000000', 'temperatura', 647.0000, 'ºC'),
	(246667, 119, '2014-03-15 00:51:01.000000', 'temperatura', 623.0000, 'ºC'),
	(246668, 119, '2014-03-15 00:51:02.000000', 'temperatura', 1173.0000, 'ºC'),
	(246669, 119, '2014-03-15 00:51:03.000000', 'temperatura', 397.0000, 'ºC'),
	(246670, 119, '2014-03-15 00:51:04.000000', 'temperatura', 868.0000, 'ºC'),
	(246671, 119, '2014-03-15 00:51:05.000000', 'temperatura', 750.0000, 'ºC'),
	(246672, 119, '2014-03-15 00:51:06.000000', 'temperatura', 1144.0000, 'ºC'),
	(246673, 119, '2014-03-15 00:51:07.000000', 'temperatura', 1073.0000, 'ºC'),
	(246674, 119, '2014-03-15 00:51:08.000000', 'temperatura', 733.0000, 'ºC'),
	(246675, 119, '2014-03-15 00:51:09.000000', 'temperatura', 444.0000, 'ºC'),
	(246676, 119, '2014-03-15 00:51:10.000000', 'temperatura', 24.0000, 'ºC'),
	(246677, 119, '2014-03-15 00:51:11.000000', 'temperatura', 1186.0000, 'ºC'),
	(246678, 119, '2014-03-15 00:51:12.000000', 'temperatura', 1060.0000, 'ºC'),
	(246679, 119, '2014-03-15 00:51:13.000000', 'temperatura', 544.0000, 'ºC'),
	(246680, 119, '2014-03-15 00:51:14.000000', 'temperatura', 739.0000, 'ºC'),
	(246681, 119, '2014-03-15 00:51:15.000000', 'temperatura', 863.0000, 'ºC'),
	(246682, 119, '2014-03-15 00:51:16.000000', 'temperatura', 900.0000, 'ºC'),
	(246683, 119, '2014-03-15 00:51:17.000000', 'temperatura', 710.0000, 'ºC'),
	(246684, 119, '2014-03-15 00:51:18.000000', 'temperatura', 852.0000, 'ºC'),
	(246685, 119, '2014-03-15 00:51:19.000000', 'temperatura', 929.0000, 'ºC'),
	(246686, 119, '2014-03-15 00:51:20.000000', 'temperatura', 891.0000, 'ºC'),
	(246687, 119, '2014-03-15 00:51:21.000000', 'temperatura', 470.0000, 'ºC'),
	(246688, 119, '2014-03-15 00:51:22.000000', 'temperatura', 876.0000, 'ºC'),
	(246689, 119, '2014-03-15 00:51:23.000000', 'temperatura', 570.0000, 'ºC'),
	(246690, 119, '2014-03-15 00:51:24.000000', 'temperatura', 221.0000, 'ºC'),
	(246691, 119, '2014-03-15 00:51:25.000000', 'temperatura', 599.0000, 'ºC'),
	(246692, 119, '2014-03-15 00:51:26.000000', 'temperatura', 1130.0000, 'ºC'),
	(246693, 119, '2014-03-15 00:51:27.000000', 'temperatura', 253.0000, 'ºC'),
	(246694, 119, '2014-03-15 00:51:28.000000', 'temperatura', 278.0000, 'ºC'),
	(246695, 119, '2014-03-15 00:51:29.000000', 'temperatura', 629.0000, 'ºC'),
	(246696, 119, '2014-03-15 00:51:30.000000', 'temperatura', 1114.0000, 'ºC'),
	(246697, 119, '2014-03-15 00:51:31.000000', 'temperatura', 82.0000, 'ºC'),
	(246698, 119, '2014-03-15 00:51:32.000000', 'temperatura', 667.0000, 'ºC'),
	(246699, 119, '2014-03-15 00:51:33.000000', 'temperatura', 690.0000, 'ºC'),
	(246700, 119, '2014-03-15 00:51:34.000000', 'temperatura', 250.0000, 'ºC'),
	(246701, 119, '2014-03-15 00:51:35.000000', 'temperatura', 379.0000, 'ºC'),
	(246702, 119, '2014-03-15 00:51:36.000000', 'temperatura', 1145.0000, 'ºC'),
	(246703, 119, '2014-03-15 00:51:37.000000', 'temperatura', 990.0000, 'ºC'),
	(246704, 119, '2014-03-15 00:51:38.000000', 'temperatura', 316.0000, 'ºC'),
	(246705, 119, '2014-03-15 00:51:39.000000', 'temperatura', 1009.0000, 'ºC'),
	(246706, 119, '2014-03-15 00:51:40.000000', 'temperatura', 497.0000, 'ºC'),
	(246707, 119, '2014-03-15 00:51:41.000000', 'temperatura', 658.0000, 'ºC'),
	(246708, 119, '2014-03-15 00:51:42.000000', 'temperatura', 599.0000, 'ºC'),
	(246709, 119, '2014-03-15 00:51:43.000000', 'temperatura', 1024.0000, 'ºC'),
	(246710, 119, '2014-03-15 00:51:44.000000', 'temperatura', 921.0000, 'ºC'),
	(246711, 119, '2014-03-15 00:51:45.000000', 'temperatura', 335.0000, 'ºC'),
	(246712, 119, '2014-03-15 00:51:46.000000', 'temperatura', 113.0000, 'ºC'),
	(246713, 119, '2014-03-15 00:51:47.000000', 'temperatura', 762.0000, 'ºC'),
	(246714, 119, '2014-03-15 00:51:48.000000', 'temperatura', 1068.0000, 'ºC'),
	(246715, 119, '2014-03-15 00:51:49.000000', 'temperatura', 656.0000, 'ºC'),
	(246716, 119, '2014-03-15 00:51:50.000000', 'temperatura', 79.0000, 'ºC'),
	(246717, 119, '2014-03-15 00:51:51.000000', 'temperatura', 824.0000, 'ºC'),
	(246718, 119, '2014-03-15 00:51:52.000000', 'temperatura', 284.0000, 'ºC'),
	(246719, 119, '2014-03-15 00:51:53.000000', 'temperatura', 151.0000, 'ºC'),
	(246720, 119, '2014-03-15 00:51:54.000000', 'temperatura', 1102.0000, 'ºC'),
	(246721, 119, '2014-03-15 00:51:55.000000', 'temperatura', 255.0000, 'ºC'),
	(246722, 119, '2014-03-15 00:51:56.000000', 'temperatura', 373.0000, 'ºC'),
	(246723, 119, '2014-03-15 00:51:57.000000', 'temperatura', 1101.0000, 'ºC'),
	(246724, 119, '2014-03-15 00:51:58.000000', 'temperatura', 786.0000, 'ºC'),
	(246725, 119, '2014-03-15 00:51:59.000000', 'temperatura', 628.0000, 'ºC'),
	(246726, 119, '2014-03-15 00:52:00.000000', 'temperatura', 781.0000, 'ºC'),
	(246727, 119, '2014-03-15 00:52:01.000000', 'temperatura', 823.0000, 'ºC'),
	(246728, 119, '2014-03-15 00:52:02.000000', 'temperatura', 570.0000, 'ºC'),
	(246729, 119, '2014-03-15 00:52:03.000000', 'temperatura', 384.0000, 'ºC'),
	(246730, 119, '2014-03-15 00:52:04.000000', 'temperatura', 208.0000, 'ºC'),
	(246731, 119, '2014-03-15 00:52:05.000000', 'temperatura', 1089.0000, 'ºC'),
	(246732, 119, '2014-03-15 00:52:06.000000', 'temperatura', 21.0000, 'ºC'),
	(246733, 119, '2014-03-15 00:52:07.000000', 'temperatura', 439.0000, 'ºC'),
	(246734, 119, '2014-03-15 00:52:08.000000', 'temperatura', 934.0000, 'ºC'),
	(246735, 119, '2014-03-15 00:52:09.000000', 'temperatura', 954.0000, 'ºC'),
	(246736, 119, '2014-03-15 00:52:10.000000', 'temperatura', 766.0000, 'ºC'),
	(246737, 119, '2014-03-15 00:52:11.000000', 'temperatura', 969.0000, 'ºC'),
	(246738, 119, '2014-03-15 00:52:12.000000', 'temperatura', 146.0000, 'ºC'),
	(246739, 119, '2014-03-15 00:52:13.000000', 'temperatura', 227.0000, 'ºC'),
	(246740, 119, '2014-03-15 00:52:14.000000', 'temperatura', 695.0000, 'ºC'),
	(246741, 119, '2014-03-15 00:52:15.000000', 'temperatura', 395.0000, 'ºC'),
	(246742, 119, '2014-03-15 00:52:16.000000', 'temperatura', 1092.0000, 'ºC'),
	(246743, 119, '2014-03-15 00:52:17.000000', 'temperatura', 676.0000, 'ºC'),
	(246744, 119, '2014-03-15 00:52:18.000000', 'temperatura', 102.0000, 'ºC'),
	(246745, 119, '2014-03-15 00:52:19.000000', 'temperatura', 882.0000, 'ºC'),
	(246746, 119, '2014-03-15 00:52:20.000000', 'temperatura', 506.0000, 'ºC'),
	(246747, 119, '2014-03-15 00:52:21.000000', 'temperatura', 1085.0000, 'ºC'),
	(246748, 119, '2014-03-15 00:52:22.000000', 'temperatura', 306.0000, 'ºC'),
	(246749, 119, '2014-03-15 00:52:23.000000', 'temperatura', 674.0000, 'ºC'),
	(246750, 119, '2014-03-15 00:52:24.000000', 'temperatura', 55.0000, 'ºC'),
	(246751, 119, '2014-03-15 00:52:25.000000', 'temperatura', 652.0000, 'ºC'),
	(246752, 119, '2014-03-15 00:52:26.000000', 'temperatura', 698.0000, 'ºC'),
	(246753, 119, '2014-03-15 00:52:27.000000', 'temperatura', 332.0000, 'ºC'),
	(246754, 119, '2014-03-15 00:52:28.000000', 'temperatura', 768.0000, 'ºC'),
	(246755, 119, '2014-03-15 00:52:29.000000', 'temperatura', 444.0000, 'ºC'),
	(246756, 119, '2014-03-15 00:52:30.000000', 'temperatura', 1114.0000, 'ºC'),
	(246757, 119, '2014-03-15 00:52:31.000000', 'temperatura', 642.0000, 'ºC'),
	(246758, 119, '2014-03-15 00:52:32.000000', 'temperatura', 1067.0000, 'ºC'),
	(246759, 119, '2014-03-15 00:52:33.000000', 'temperatura', 1011.0000, 'ºC'),
	(246760, 119, '2014-03-15 00:52:34.000000', 'temperatura', 655.0000, 'ºC'),
	(246761, 119, '2014-03-15 00:52:35.000000', 'temperatura', 241.0000, 'ºC'),
	(246762, 119, '2014-03-15 00:52:36.000000', 'temperatura', 442.0000, 'ºC'),
	(246763, 119, '2014-03-15 00:52:37.000000', 'temperatura', 286.0000, 'ºC'),
	(246764, 119, '2014-03-15 00:52:38.000000', 'temperatura', 104.0000, 'ºC'),
	(246765, 119, '2014-03-15 00:52:39.000000', 'temperatura', 863.0000, 'ºC'),
	(246766, 119, '2014-03-15 00:52:40.000000', 'temperatura', 403.0000, 'ºC'),
	(246767, 119, '2014-03-15 00:52:41.000000', 'temperatura', 625.0000, 'ºC'),
	(246768, 119, '2014-03-15 00:52:42.000000', 'temperatura', 718.0000, 'ºC'),
	(246769, 119, '2014-03-15 00:52:43.000000', 'temperatura', 516.0000, 'ºC'),
	(246770, 119, '2014-03-15 00:52:44.000000', 'temperatura', 428.0000, 'ºC'),
	(246771, 119, '2014-03-15 00:52:45.000000', 'temperatura', 591.0000, 'ºC'),
	(246772, 119, '2014-03-15 00:52:46.000000', 'temperatura', 471.0000, 'ºC'),
	(246773, 119, '2014-03-15 00:52:47.000000', 'temperatura', 583.0000, 'ºC'),
	(246774, 119, '2014-03-15 00:52:48.000000', 'temperatura', 303.0000, 'ºC'),
	(246775, 119, '2014-03-15 00:52:49.000000', 'temperatura', 967.0000, 'ºC'),
	(246776, 119, '2014-03-15 00:52:50.000000', 'temperatura', 324.0000, 'ºC'),
	(246777, 119, '2014-03-15 00:52:51.000000', 'temperatura', 1122.0000, 'ºC'),
	(246778, 119, '2014-03-15 00:52:52.000000', 'temperatura', 1037.0000, 'ºC'),
	(246779, 119, '2014-03-15 00:52:53.000000', 'temperatura', 618.0000, 'ºC'),
	(246780, 119, '2014-03-15 00:52:54.000000', 'temperatura', 1181.0000, 'ºC'),
	(246781, 119, '2014-03-15 00:52:55.000000', 'temperatura', 450.0000, 'ºC'),
	(246782, 119, '2014-03-15 00:52:56.000000', 'temperatura', 1107.0000, 'ºC'),
	(246783, 119, '2014-03-15 00:52:57.000000', 'temperatura', 585.0000, 'ºC'),
	(246784, 119, '2014-03-15 00:52:58.000000', 'temperatura', 805.0000, 'ºC'),
	(246785, 119, '2014-03-15 00:52:59.000000', 'temperatura', 1069.0000, 'ºC'),
	(246786, 119, '2014-03-15 00:53:00.000000', 'temperatura', 531.0000, 'ºC'),
	(246787, 119, '2014-03-15 00:53:01.000000', 'temperatura', 649.0000, 'ºC'),
	(246788, 119, '2014-03-15 00:53:02.000000', 'temperatura', 451.0000, 'ºC'),
	(246789, 119, '2014-03-15 00:53:03.000000', 'temperatura', 308.0000, 'ºC'),
	(246790, 119, '2014-03-15 00:53:04.000000', 'temperatura', 189.0000, 'ºC'),
	(246791, 119, '2014-03-15 00:53:05.000000', 'temperatura', 23.0000, 'ºC'),
	(246792, 119, '2014-03-15 00:53:06.000000', 'temperatura', 748.0000, 'ºC'),
	(246793, 119, '2014-03-15 00:53:07.000000', 'temperatura', 71.0000, 'ºC'),
	(246794, 119, '2014-03-15 00:53:08.000000', 'temperatura', 510.0000, 'ºC'),
	(246795, 119, '2014-03-15 00:53:09.000000', 'temperatura', 1140.0000, 'ºC'),
	(246796, 119, '2014-03-15 00:53:10.000000', 'temperatura', 569.0000, 'ºC'),
	(246797, 119, '2014-03-15 00:53:11.000000', 'temperatura', 627.0000, 'ºC'),
	(246798, 119, '2014-03-15 00:53:12.000000', 'temperatura', 227.0000, 'ºC'),
	(246799, 119, '2014-03-15 00:53:13.000000', 'temperatura', 456.0000, 'ºC'),
	(246800, 119, '2014-03-15 00:53:14.000000', 'temperatura', 401.0000, 'ºC'),
	(246801, 119, '2014-03-15 00:53:15.000000', 'temperatura', 636.0000, 'ºC'),
	(246802, 119, '2014-03-15 00:53:16.000000', 'temperatura', 776.0000, 'ºC'),
	(246803, 119, '2014-03-15 00:53:17.000000', 'temperatura', 773.0000, 'ºC'),
	(246804, 119, '2014-03-15 00:53:18.000000', 'temperatura', 336.0000, 'ºC'),
	(246805, 119, '2014-03-15 00:53:19.000000', 'temperatura', 562.0000, 'ºC'),
	(246806, 119, '2014-03-15 00:53:20.000000', 'temperatura', 605.0000, 'ºC'),
	(246807, 119, '2014-03-15 00:53:21.000000', 'temperatura', 137.0000, 'ºC'),
	(246808, 119, '2014-03-15 00:53:22.000000', 'temperatura', 73.0000, 'ºC'),
	(246809, 119, '2014-03-15 00:53:23.000000', 'temperatura', 1154.0000, 'ºC'),
	(246810, 119, '2014-03-15 00:53:24.000000', 'temperatura', 749.0000, 'ºC'),
	(246811, 119, '2014-03-15 00:53:25.000000', 'temperatura', 286.0000, 'ºC'),
	(246812, 119, '2014-03-15 00:53:26.000000', 'temperatura', 385.0000, 'ºC'),
	(246813, 119, '2014-03-15 00:53:27.000000', 'temperatura', 1065.0000, 'ºC'),
	(246814, 119, '2014-03-15 00:53:28.000000', 'temperatura', 571.0000, 'ºC'),
	(246815, 119, '2014-03-15 00:53:29.000000', 'temperatura', 860.0000, 'ºC'),
	(246816, 119, '2014-03-15 00:53:30.000000', 'temperatura', 187.0000, 'ºC'),
	(246817, 119, '2014-03-15 00:53:31.000000', 'temperatura', 755.0000, 'ºC'),
	(246818, 119, '2014-03-15 00:53:32.000000', 'temperatura', 815.0000, 'ºC'),
	(246819, 119, '2014-03-15 00:53:33.000000', 'temperatura', 611.0000, 'ºC'),
	(246820, 119, '2014-03-15 00:53:34.000000', 'temperatura', 610.0000, 'ºC'),
	(246821, 119, '2014-03-15 00:53:35.000000', 'temperatura', 17.0000, 'ºC'),
	(246822, 119, '2014-03-15 00:53:36.000000', 'temperatura', 657.0000, 'ºC'),
	(246823, 119, '2014-03-15 00:53:37.000000', 'temperatura', 835.0000, 'ºC'),
	(246824, 119, '2014-03-15 00:53:38.000000', 'temperatura', 1002.0000, 'ºC'),
	(246825, 119, '2014-03-15 00:53:39.000000', 'temperatura', 105.0000, 'ºC'),
	(246826, 119, '2014-03-15 00:53:40.000000', 'temperatura', 1122.0000, 'ºC'),
	(246827, 119, '2014-03-15 00:53:41.000000', 'temperatura', 494.0000, 'ºC'),
	(246828, 119, '2014-03-15 00:53:42.000000', 'temperatura', 306.0000, 'ºC'),
	(246829, 119, '2014-03-15 00:53:43.000000', 'temperatura', 47.0000, 'ºC'),
	(246830, 119, '2014-03-15 00:53:44.000000', 'temperatura', 517.0000, 'ºC'),
	(246831, 119, '2014-03-15 00:53:45.000000', 'temperatura', 45.0000, 'ºC'),
	(246832, 119, '2014-03-15 00:53:46.000000', 'temperatura', 1076.0000, 'ºC'),
	(246833, 119, '2014-03-15 00:53:47.000000', 'temperatura', 443.0000, 'ºC'),
	(246834, 119, '2014-03-15 00:53:48.000000', 'temperatura', 189.0000, 'ºC'),
	(246835, 119, '2014-03-15 00:53:49.000000', 'temperatura', 815.0000, 'ºC'),
	(246836, 119, '2014-03-15 00:53:50.000000', 'temperatura', 1107.0000, 'ºC'),
	(246837, 119, '2014-03-15 00:53:51.000000', 'temperatura', 694.0000, 'ºC'),
	(246838, 119, '2014-03-15 00:53:52.000000', 'temperatura', 149.0000, 'ºC'),
	(246839, 119, '2014-03-15 00:53:53.000000', 'temperatura', 1061.0000, 'ºC'),
	(246840, 119, '2014-03-15 00:53:54.000000', 'temperatura', 60.0000, 'ºC'),
	(246841, 119, '2014-03-15 00:53:55.000000', 'temperatura', 718.0000, 'ºC'),
	(246842, 119, '2014-03-15 00:53:56.000000', 'temperatura', 1008.0000, 'ºC'),
	(246843, 119, '2014-03-15 00:53:57.000000', 'temperatura', 488.0000, 'ºC'),
	(246844, 119, '2014-03-15 00:53:58.000000', 'temperatura', 616.0000, 'ºC'),
	(246845, 119, '2014-03-15 00:53:59.000000', 'temperatura', 417.0000, 'ºC'),
	(246846, 119, '2014-03-15 00:54:00.000000', 'temperatura', 238.0000, 'ºC'),
	(246847, 119, '2014-03-15 00:54:01.000000', 'temperatura', 1139.0000, 'ºC'),
	(246848, 119, '2014-03-15 00:54:02.000000', 'temperatura', 181.0000, 'ºC'),
	(246849, 119, '2014-03-15 00:54:03.000000', 'temperatura', 1090.0000, 'ºC'),
	(246850, 119, '2014-03-15 00:54:04.000000', 'temperatura', 109.0000, 'ºC'),
	(246851, 119, '2014-03-15 00:54:05.000000', 'temperatura', 873.0000, 'ºC'),
	(246852, 119, '2014-03-15 00:54:06.000000', 'temperatura', 439.0000, 'ºC'),
	(246853, 119, '2014-03-15 00:54:07.000000', 'temperatura', 777.0000, 'ºC'),
	(246854, 119, '2014-03-15 00:54:08.000000', 'temperatura', 168.0000, 'ºC'),
	(246855, 119, '2014-03-15 00:54:09.000000', 'temperatura', 911.0000, 'ºC'),
	(246856, 119, '2014-03-15 00:54:10.000000', 'temperatura', 452.0000, 'ºC'),
	(246857, 119, '2014-03-15 00:54:11.000000', 'temperatura', 728.0000, 'ºC'),
	(246858, 119, '2014-03-15 00:54:12.000000', 'temperatura', 1083.0000, 'ºC'),
	(246859, 119, '2014-03-15 00:54:13.000000', 'temperatura', 832.0000, 'ºC'),
	(246860, 119, '2014-03-15 00:54:14.000000', 'temperatura', 909.0000, 'ºC'),
	(246861, 119, '2014-03-15 00:54:15.000000', 'temperatura', 852.0000, 'ºC'),
	(246862, 119, '2014-03-15 00:54:16.000000', 'temperatura', 334.0000, 'ºC'),
	(246863, 119, '2014-03-15 00:54:17.000000', 'temperatura', 315.0000, 'ºC'),
	(246864, 119, '2014-03-15 00:54:18.000000', 'temperatura', 574.0000, 'ºC'),
	(246865, 119, '2014-03-15 00:54:19.000000', 'temperatura', 726.0000, 'ºC'),
	(246866, 119, '2014-03-15 00:54:20.000000', 'temperatura', 707.0000, 'ºC'),
	(246867, 119, '2014-03-15 00:54:21.000000', 'temperatura', 158.0000, 'ºC'),
	(246868, 119, '2014-03-15 00:54:22.000000', 'temperatura', 1068.0000, 'ºC'),
	(246869, 119, '2014-03-15 00:54:23.000000', 'temperatura', 68.0000, 'ºC'),
	(246870, 119, '2014-03-15 00:54:24.000000', 'temperatura', 734.0000, 'ºC'),
	(246871, 119, '2014-03-15 00:54:25.000000', 'temperatura', 1068.0000, 'ºC'),
	(246872, 119, '2014-03-15 00:54:26.000000', 'temperatura', 740.0000, 'ºC'),
	(246873, 119, '2014-03-15 00:54:27.000000', 'temperatura', 497.0000, 'ºC'),
	(246874, 119, '2014-03-15 00:54:28.000000', 'temperatura', 263.0000, 'ºC'),
	(246875, 119, '2014-03-15 00:54:29.000000', 'temperatura', 1026.0000, 'ºC'),
	(246876, 119, '2014-03-15 00:54:30.000000', 'temperatura', 742.0000, 'ºC'),
	(246877, 119, '2014-03-15 00:54:31.000000', 'temperatura', 632.0000, 'ºC'),
	(246878, 119, '2014-03-15 00:54:32.000000', 'temperatura', 933.0000, 'ºC'),
	(246879, 119, '2014-03-15 00:54:33.000000', 'temperatura', 370.0000, 'ºC'),
	(246880, 119, '2014-03-15 00:54:34.000000', 'temperatura', 252.0000, 'ºC'),
	(246881, 119, '2014-03-15 00:54:35.000000', 'temperatura', 150.0000, 'ºC'),
	(246882, 119, '2014-03-15 00:54:36.000000', 'temperatura', 1194.0000, 'ºC'),
	(246883, 119, '2014-03-15 00:54:37.000000', 'temperatura', 720.0000, 'ºC'),
	(246884, 119, '2014-03-15 00:54:38.000000', 'temperatura', 20.0000, 'ºC'),
	(246885, 119, '2014-03-15 00:54:39.000000', 'temperatura', 341.0000, 'ºC'),
	(246886, 119, '2014-03-15 00:54:40.000000', 'temperatura', 446.0000, 'ºC'),
	(246887, 119, '2014-03-15 00:54:41.000000', 'temperatura', 7.0000, 'ºC'),
	(246888, 119, '2014-03-15 00:54:42.000000', 'temperatura', 1099.0000, 'ºC'),
	(246889, 119, '2014-03-15 00:54:43.000000', 'temperatura', 673.0000, 'ºC'),
	(246890, 119, '2014-03-15 00:54:44.000000', 'temperatura', 69.0000, 'ºC'),
	(246891, 119, '2014-03-15 00:54:45.000000', 'temperatura', 724.0000, 'ºC'),
	(246892, 119, '2014-03-15 00:54:46.000000', 'temperatura', 1016.0000, 'ºC'),
	(246893, 119, '2014-03-15 00:54:47.000000', 'temperatura', 509.0000, 'ºC'),
	(246894, 119, '2014-03-15 00:54:48.000000', 'temperatura', 698.0000, 'ºC'),
	(246895, 119, '2014-03-15 00:54:49.000000', 'temperatura', 761.0000, 'ºC'),
	(246896, 119, '2014-03-15 00:54:50.000000', 'temperatura', 514.0000, 'ºC'),
	(246897, 119, '2014-03-15 00:54:51.000000', 'temperatura', 287.0000, 'ºC'),
	(246898, 119, '2014-03-15 00:54:52.000000', 'temperatura', 1095.0000, 'ºC'),
	(246899, 119, '2014-03-15 00:54:53.000000', 'temperatura', 1014.0000, 'ºC'),
	(246900, 119, '2014-03-15 00:54:54.000000', 'temperatura', 587.0000, 'ºC'),
	(246901, 119, '2014-03-15 00:54:55.000000', 'temperatura', 1091.0000, 'ºC'),
	(246902, 119, '2014-03-15 00:54:56.000000', 'temperatura', 94.0000, 'ºC'),
	(246903, 119, '2014-03-15 00:54:57.000000', 'temperatura', 799.0000, 'ºC'),
	(246904, 119, '2014-03-15 00:54:58.000000', 'temperatura', 115.0000, 'ºC'),
	(246905, 119, '2014-03-15 00:54:59.000000', 'temperatura', 576.0000, 'ºC'),
	(246906, 119, '2014-03-15 00:55:00.000000', 'temperatura', 138.0000, 'ºC'),
	(246907, 119, '2014-03-15 00:55:01.000000', 'temperatura', 163.0000, 'ºC'),
	(246908, 119, '2014-03-15 00:55:02.000000', 'temperatura', 399.0000, 'ºC'),
	(246909, 119, '2014-03-15 00:55:03.000000', 'temperatura', 306.0000, 'ºC'),
	(246910, 119, '2014-03-15 00:55:04.000000', 'temperatura', 336.0000, 'ºC'),
	(246911, 119, '2014-03-15 00:55:05.000000', 'temperatura', 761.0000, 'ºC'),
	(246912, 119, '2014-03-15 00:55:06.000000', 'temperatura', 397.0000, 'ºC'),
	(246913, 119, '2014-03-15 00:55:07.000000', 'temperatura', 904.0000, 'ºC'),
	(246914, 119, '2014-03-15 00:55:08.000000', 'temperatura', 928.0000, 'ºC'),
	(246915, 119, '2014-03-15 00:55:09.000000', 'temperatura', 729.0000, 'ºC'),
	(246916, 119, '2014-03-15 00:55:10.000000', 'temperatura', 863.0000, 'ºC'),
	(246917, 119, '2014-03-15 00:55:11.000000', 'temperatura', 926.0000, 'ºC'),
	(246918, 119, '2014-03-15 00:55:12.000000', 'temperatura', 841.0000, 'ºC'),
	(246919, 119, '2014-03-15 00:55:13.000000', 'temperatura', 227.0000, 'ºC'),
	(246920, 119, '2014-03-15 00:55:14.000000', 'temperatura', 1015.0000, 'ºC'),
	(246921, 119, '2014-03-15 00:55:15.000000', 'temperatura', 795.0000, 'ºC'),
	(246922, 119, '2014-03-15 00:55:16.000000', 'temperatura', 931.0000, 'ºC'),
	(246923, 119, '2014-03-15 00:55:17.000000', 'temperatura', 1068.0000, 'ºC'),
	(246924, 119, '2014-03-15 00:55:18.000000', 'temperatura', 149.0000, 'ºC'),
	(246925, 119, '2014-03-15 00:55:19.000000', 'temperatura', 1141.0000, 'ºC'),
	(246926, 119, '2014-03-15 00:55:20.000000', 'temperatura', 459.0000, 'ºC'),
	(246927, 119, '2014-03-15 00:55:21.000000', 'temperatura', 73.0000, 'ºC'),
	(246928, 119, '2014-03-15 00:55:22.000000', 'temperatura', 186.0000, 'ºC'),
	(246929, 119, '2014-03-15 00:55:23.000000', 'temperatura', 713.0000, 'ºC'),
	(246930, 119, '2014-03-15 00:55:24.000000', 'temperatura', 609.0000, 'ºC'),
	(246931, 119, '2014-03-15 00:55:25.000000', 'temperatura', 905.0000, 'ºC'),
	(246932, 119, '2014-03-15 00:55:26.000000', 'temperatura', 298.0000, 'ºC'),
	(246933, 119, '2014-03-15 00:55:27.000000', 'temperatura', 1174.0000, 'ºC'),
	(246934, 119, '2014-03-15 00:55:28.000000', 'temperatura', 180.0000, 'ºC'),
	(246935, 119, '2014-03-15 00:55:29.000000', 'temperatura', 976.0000, 'ºC'),
	(246936, 119, '2014-03-15 00:55:30.000000', 'temperatura', 742.0000, 'ºC'),
	(246937, 119, '2014-03-15 00:55:31.000000', 'temperatura', 781.0000, 'ºC'),
	(246938, 119, '2014-03-15 00:55:32.000000', 'temperatura', 479.0000, 'ºC'),
	(246939, 119, '2014-03-15 00:55:33.000000', 'temperatura', 52.0000, 'ºC'),
	(246940, 119, '2014-03-15 00:55:34.000000', 'temperatura', 25.0000, 'ºC'),
	(246941, 119, '2014-03-15 00:55:35.000000', 'temperatura', 1170.0000, 'ºC'),
	(246942, 119, '2014-03-15 00:55:36.000000', 'temperatura', 974.0000, 'ºC'),
	(246943, 119, '2014-03-15 00:55:37.000000', 'temperatura', 160.0000, 'ºC'),
	(246944, 119, '2014-03-15 00:55:38.000000', 'temperatura', 280.0000, 'ºC'),
	(246945, 119, '2014-03-15 00:55:39.000000', 'temperatura', 918.0000, 'ºC'),
	(246946, 119, '2014-03-15 00:55:40.000000', 'temperatura', 152.0000, 'ºC'),
	(246947, 119, '2014-03-15 00:55:41.000000', 'temperatura', 406.0000, 'ºC'),
	(246948, 119, '2014-03-15 00:55:42.000000', 'temperatura', 376.0000, 'ºC'),
	(246949, 119, '2014-03-15 00:55:43.000000', 'temperatura', 662.0000, 'ºC'),
	(246950, 119, '2014-03-15 00:55:44.000000', 'temperatura', 982.0000, 'ºC'),
	(246951, 119, '2014-03-15 00:55:45.000000', 'temperatura', 526.0000, 'ºC'),
	(246952, 119, '2014-03-15 00:55:46.000000', 'temperatura', 883.0000, 'ºC'),
	(246953, 119, '2014-03-15 00:55:47.000000', 'temperatura', 436.0000, 'ºC'),
	(246954, 119, '2014-03-15 00:55:48.000000', 'temperatura', 734.0000, 'ºC'),
	(246955, 119, '2014-03-15 00:55:49.000000', 'temperatura', 1162.0000, 'ºC'),
	(246956, 119, '2014-03-15 00:55:50.000000', 'temperatura', 10.0000, 'ºC'),
	(246957, 119, '2014-03-15 00:55:51.000000', 'temperatura', 164.0000, 'ºC'),
	(246958, 119, '2014-03-15 00:55:52.000000', 'temperatura', 790.0000, 'ºC'),
	(246959, 119, '2014-03-15 00:55:53.000000', 'temperatura', 1057.0000, 'ºC'),
	(246960, 119, '2014-03-15 00:55:54.000000', 'temperatura', 518.0000, 'ºC'),
	(246961, 119, '2014-03-15 00:55:55.000000', 'temperatura', 619.0000, 'ºC'),
	(246962, 119, '2014-03-15 00:55:56.000000', 'temperatura', 341.0000, 'ºC'),
	(246963, 119, '2014-03-15 00:55:57.000000', 'temperatura', 1047.0000, 'ºC'),
	(246964, 119, '2014-03-15 00:55:58.000000', 'temperatura', 613.0000, 'ºC'),
	(246965, 119, '2014-03-15 00:55:59.000000', 'temperatura', 1126.0000, 'ºC'),
	(246966, 119, '2014-03-15 00:56:00.000000', 'temperatura', 189.0000, 'ºC'),
	(246967, 119, '2014-03-15 00:56:01.000000', 'temperatura', 1167.0000, 'ºC'),
	(246968, 119, '2014-03-15 00:56:02.000000', 'temperatura', 470.0000, 'ºC'),
	(246969, 119, '2014-03-15 00:56:03.000000', 'temperatura', 49.0000, 'ºC'),
	(246970, 119, '2014-03-15 00:56:04.000000', 'temperatura', 37.0000, 'ºC'),
	(246971, 119, '2014-03-15 00:56:05.000000', 'temperatura', 38.0000, 'ºC'),
	(246972, 119, '2014-03-15 00:56:06.000000', 'temperatura', 81.0000, 'ºC'),
	(246973, 119, '2014-03-15 00:56:07.000000', 'temperatura', 290.0000, 'ºC'),
	(246974, 119, '2014-03-15 00:56:08.000000', 'temperatura', 10.0000, 'ºC'),
	(246975, 119, '2014-03-15 00:56:09.000000', 'temperatura', 378.0000, 'ºC'),
	(246976, 119, '2014-03-15 00:56:10.000000', 'temperatura', 659.0000, 'ºC'),
	(246977, 119, '2014-03-15 00:56:11.000000', 'temperatura', 964.0000, 'ºC'),
	(246978, 119, '2014-03-15 00:56:12.000000', 'temperatura', 443.0000, 'ºC'),
	(246979, 119, '2014-03-15 00:56:13.000000', 'temperatura', 522.0000, 'ºC'),
	(246980, 119, '2014-03-15 00:56:14.000000', 'temperatura', 82.0000, 'ºC'),
	(246981, 119, '2014-03-15 00:56:15.000000', 'temperatura', 44.0000, 'ºC'),
	(246982, 119, '2014-03-15 00:56:16.000000', 'temperatura', 1174.0000, 'ºC'),
	(246983, 119, '2014-03-15 00:56:17.000000', 'temperatura', 937.0000, 'ºC'),
	(246984, 119, '2014-03-15 00:56:18.000000', 'temperatura', 1167.0000, 'ºC'),
	(246985, 119, '2014-03-15 00:56:19.000000', 'temperatura', 624.0000, 'ºC'),
	(246986, 119, '2014-03-15 00:56:20.000000', 'temperatura', 818.0000, 'ºC'),
	(246987, 119, '2014-03-15 00:56:21.000000', 'temperatura', 1020.0000, 'ºC'),
	(246988, 119, '2014-03-15 00:56:22.000000', 'temperatura', 246.0000, 'ºC'),
	(246989, 119, '2014-03-15 00:56:23.000000', 'temperatura', 570.0000, 'ºC'),
	(246990, 119, '2014-03-15 00:56:24.000000', 'temperatura', 914.0000, 'ºC'),
	(246991, 119, '2014-03-15 00:56:25.000000', 'temperatura', 462.0000, 'ºC'),
	(246992, 119, '2014-03-15 00:56:26.000000', 'temperatura', 766.0000, 'ºC'),
	(246993, 119, '2014-03-15 00:56:27.000000', 'temperatura', 44.0000, 'ºC'),
	(246994, 119, '2014-03-15 00:56:28.000000', 'temperatura', 322.0000, 'ºC'),
	(246995, 119, '2014-03-15 00:56:29.000000', 'temperatura', 280.0000, 'ºC'),
	(246996, 119, '2014-03-15 00:56:30.000000', 'temperatura', 435.0000, 'ºC'),
	(246997, 119, '2014-03-15 00:56:31.000000', 'temperatura', 135.0000, 'ºC'),
	(246998, 119, '2014-03-15 00:56:32.000000', 'temperatura', 571.0000, 'ºC'),
	(246999, 119, '2014-03-15 00:56:33.000000', 'temperatura', 51.0000, 'ºC'),
	(247000, 119, '2014-03-15 00:56:34.000000', 'temperatura', 943.0000, 'ºC'),
	(247001, 119, '2014-03-15 00:56:35.000000', 'temperatura', 961.0000, 'ºC'),
	(247002, 119, '2014-03-15 00:56:36.000000', 'temperatura', 776.0000, 'ºC'),
	(247003, 119, '2014-03-15 00:56:37.000000', 'temperatura', 999.0000, 'ºC'),
	(247004, 119, '2014-03-15 00:56:38.000000', 'temperatura', 267.0000, 'ºC'),
	(247005, 119, '2014-03-15 00:56:39.000000', 'temperatura', 740.0000, 'ºC'),
	(247006, 119, '2014-03-15 00:56:40.000000', 'temperatura', 498.0000, 'ºC'),
	(247007, 119, '2014-03-15 00:56:41.000000', 'temperatura', 270.0000, 'ºC'),
	(247008, 119, '2014-03-15 00:56:42.000000', 'temperatura', 1059.0000, 'ºC'),
	(247009, 119, '2014-03-15 00:56:43.000000', 'temperatura', 882.0000, 'ºC'),
	(247010, 119, '2014-03-15 00:56:44.000000', 'temperatura', 35.0000, 'ºC'),
	(247011, 119, '2014-03-15 00:56:45.000000', 'temperatura', 1131.0000, 'ºC'),
	(247012, 119, '2014-03-15 00:56:46.000000', 'temperatura', 748.0000, 'ºC'),
	(247013, 119, '2014-03-15 00:56:47.000000', 'temperatura', 350.0000, 'ºC'),
	(247014, 119, '2014-03-15 00:56:48.000000', 'temperatura', 707.0000, 'ºC'),
	(247015, 119, '2014-03-15 00:56:49.000000', 'temperatura', 86.0000, 'ºC'),
	(247016, 119, '2014-03-15 00:56:50.000000', 'temperatura', 710.0000, 'ºC'),
	(247017, 119, '2014-03-15 00:56:51.000000', 'temperatura', 890.0000, 'ºC'),
	(247018, 119, '2014-03-15 00:56:52.000000', 'temperatura', 1119.0000, 'ºC'),
	(247019, 119, '2014-03-15 00:56:53.000000', 'temperatura', 529.0000, 'ºC'),
	(247020, 119, '2014-03-15 00:56:54.000000', 'temperatura', 487.0000, 'ºC'),
	(247021, 119, '2014-03-15 00:56:55.000000', 'temperatura', 850.0000, 'ºC'),
	(247022, 119, '2014-03-15 00:56:56.000000', 'temperatura', 387.0000, 'ºC'),
	(247023, 119, '2014-03-15 00:56:57.000000', 'temperatura', 584.0000, 'ºC'),
	(247024, 119, '2014-03-15 00:56:58.000000', 'temperatura', 563.0000, 'ºC'),
	(247025, 119, '2014-03-15 00:56:59.000000', 'temperatura', 1064.0000, 'ºC'),
	(247026, 119, '2014-03-15 00:57:00.000000', 'temperatura', 29.0000, 'ºC'),
	(247027, 119, '2014-03-15 00:57:01.000000', 'temperatura', 556.0000, 'ºC'),
	(247028, 119, '2014-03-15 00:57:02.000000', 'temperatura', 291.0000, 'ºC'),
	(247029, 119, '2014-03-15 00:57:03.000000', 'temperatura', 987.0000, 'ºC'),
	(247030, 119, '2014-03-15 00:57:04.000000', 'temperatura', 462.0000, 'ºC'),
	(247031, 119, '2014-03-15 00:57:05.000000', 'temperatura', 551.0000, 'ºC'),
	(247032, 119, '2014-03-15 00:57:06.000000', 'temperatura', 170.0000, 'ºC'),
	(247033, 119, '2014-03-15 00:57:07.000000', 'temperatura', 398.0000, 'ºC'),
	(247034, 119, '2014-03-15 00:57:08.000000', 'temperatura', 281.0000, 'ºC'),
	(247035, 119, '2014-03-15 00:57:09.000000', 'temperatura', 211.0000, 'ºC'),
	(247036, 119, '2014-03-15 00:57:10.000000', 'temperatura', 211.0000, 'ºC'),
	(247037, 119, '2014-03-15 00:57:11.000000', 'temperatura', 426.0000, 'ºC'),
	(247038, 119, '2014-03-15 00:57:12.000000', 'temperatura', 294.0000, 'ºC'),
	(247039, 119, '2014-03-15 00:57:13.000000', 'temperatura', 192.0000, 'ºC'),
	(247040, 119, '2014-03-15 00:57:14.000000', 'temperatura', 79.0000, 'ºC'),
	(247041, 119, '2014-03-15 00:57:15.000000', 'temperatura', 1021.0000, 'ºC'),
	(247042, 119, '2014-03-15 00:57:16.000000', 'temperatura', 69.0000, 'ºC'),
	(247043, 119, '2014-03-15 00:57:17.000000', 'temperatura', 882.0000, 'ºC'),
	(247044, 119, '2014-03-15 00:57:18.000000', 'temperatura', 601.0000, 'ºC'),
	(247045, 119, '2014-03-15 00:57:19.000000', 'temperatura', 362.0000, 'ºC'),
	(247046, 119, '2014-03-15 00:57:20.000000', 'temperatura', 6.0000, 'ºC'),
	(247047, 119, '2014-03-15 00:57:21.000000', 'temperatura', 144.0000, 'ºC'),
	(247048, 119, '2014-03-15 00:57:22.000000', 'temperatura', 703.0000, 'ºC'),
	(247049, 119, '2014-03-15 00:57:23.000000', 'temperatura', 683.0000, 'ºC'),
	(247050, 119, '2014-03-15 00:57:24.000000', 'temperatura', 108.0000, 'ºC'),
	(247051, 119, '2014-03-15 00:57:25.000000', 'temperatura', 893.0000, 'ºC'),
	(247052, 119, '2014-03-15 00:57:26.000000', 'temperatura', 538.0000, 'ºC'),
	(247053, 119, '2014-03-15 00:57:27.000000', 'temperatura', 14.0000, 'ºC'),
	(247054, 119, '2014-03-15 00:57:28.000000', 'temperatura', 858.0000, 'ºC'),
	(247055, 119, '2014-03-15 00:57:29.000000', 'temperatura', 646.0000, 'ºC'),
	(247056, 119, '2014-03-15 00:57:30.000000', 'temperatura', 658.0000, 'ºC'),
	(247057, 119, '2014-03-15 00:57:31.000000', 'temperatura', 151.0000, 'ºC'),
	(247058, 119, '2014-03-15 00:57:32.000000', 'temperatura', 1182.0000, 'ºC'),
	(247059, 119, '2014-03-15 00:57:33.000000', 'temperatura', 656.0000, 'ºC'),
	(247060, 119, '2014-03-15 00:57:34.000000', 'temperatura', 936.0000, 'ºC'),
	(247061, 119, '2014-03-15 00:57:35.000000', 'temperatura', 311.0000, 'ºC'),
	(247062, 119, '2014-03-15 00:57:36.000000', 'temperatura', 1150.0000, 'ºC'),
	(247063, 119, '2014-03-15 00:57:37.000000', 'temperatura', 15.0000, 'ºC'),
	(247064, 119, '2014-03-15 00:57:38.000000', 'temperatura', 227.0000, 'ºC'),
	(247065, 119, '2014-03-15 00:57:39.000000', 'temperatura', 1092.0000, 'ºC'),
	(247066, 119, '2014-03-15 00:57:40.000000', 'temperatura', 1179.0000, 'ºC'),
	(247067, 119, '2014-03-15 00:57:41.000000', 'temperatura', 220.0000, 'ºC'),
	(247068, 119, '2014-03-15 00:57:42.000000', 'temperatura', 1161.0000, 'ºC'),
	(247069, 119, '2014-03-15 00:57:43.000000', 'temperatura', 346.0000, 'ºC'),
	(247070, 119, '2014-03-15 00:57:44.000000', 'temperatura', 647.0000, 'ºC'),
	(247071, 119, '2014-03-15 00:57:45.000000', 'temperatura', 999.0000, 'ºC'),
	(247072, 119, '2014-03-15 00:57:46.000000', 'temperatura', 654.0000, 'ºC'),
	(247073, 119, '2014-03-15 00:57:47.000000', 'temperatura', 272.0000, 'ºC'),
	(247074, 119, '2014-03-15 00:57:48.000000', 'temperatura', 598.0000, 'ºC'),
	(247075, 119, '2014-03-15 00:57:49.000000', 'temperatura', 974.0000, 'ºC'),
	(247076, 119, '2014-03-15 00:57:50.000000', 'temperatura', 677.0000, 'ºC'),
	(247077, 119, '2014-03-15 00:57:51.000000', 'temperatura', 463.0000, 'ºC'),
	(247078, 119, '2014-03-15 00:57:52.000000', 'temperatura', 285.0000, 'ºC'),
	(247079, 119, '2014-03-15 00:57:53.000000', 'temperatura', 35.0000, 'ºC'),
	(247080, 119, '2014-03-15 00:57:54.000000', 'temperatura', 520.0000, 'ºC'),
	(247081, 119, '2014-03-15 00:57:55.000000', 'temperatura', 96.0000, 'ºC'),
	(247082, 119, '2014-03-15 00:57:56.000000', 'temperatura', 122.0000, 'ºC'),
	(247083, 119, '2014-03-15 00:57:57.000000', 'temperatura', 323.0000, 'ºC'),
	(247084, 119, '2014-03-15 00:57:58.000000', 'temperatura', 49.0000, 'ºC'),
	(247085, 119, '2014-03-15 00:57:59.000000', 'temperatura', 476.0000, 'ºC'),
	(247086, 119, '2014-03-15 00:58:00.000000', 'temperatura', 1036.0000, 'ºC'),
	(247087, 119, '2014-03-15 00:58:01.000000', 'temperatura', 150.0000, 'ºC'),
	(247088, 119, '2014-03-15 00:58:02.000000', 'temperatura', 42.0000, 'ºC'),
	(247089, 119, '2014-03-15 00:58:03.000000', 'temperatura', 960.0000, 'ºC'),
	(247090, 119, '2014-03-15 00:58:04.000000', 'temperatura', 1077.0000, 'ºC'),
	(247091, 119, '2014-03-15 00:58:05.000000', 'temperatura', 106.0000, 'ºC'),
	(247092, 119, '2014-03-15 00:58:06.000000', 'temperatura', 899.0000, 'ºC'),
	(247093, 119, '2014-03-15 00:58:07.000000', 'temperatura', 577.0000, 'ºC'),
	(247094, 119, '2014-03-15 00:58:08.000000', 'temperatura', 188.0000, 'ºC'),
	(247095, 119, '2014-03-15 00:58:09.000000', 'temperatura', 409.0000, 'ºC'),
	(247096, 119, '2014-03-15 00:58:10.000000', 'temperatura', 283.0000, 'ºC'),
	(247097, 119, '2014-03-15 00:58:11.000000', 'temperatura', 187.0000, 'ºC'),
	(247098, 119, '2014-03-15 00:58:12.000000', 'temperatura', 85.0000, 'ºC'),
	(247099, 119, '2014-03-15 00:58:13.000000', 'temperatura', 1067.0000, 'ºC'),
	(247100, 119, '2014-03-15 00:58:14.000000', 'temperatura', 279.0000, 'ºC'),
	(247101, 119, '2014-03-15 00:58:15.000000', 'temperatura', 595.0000, 'ºC'),
	(247102, 119, '2014-03-15 00:58:16.000000', 'temperatura', 938.0000, 'ºC'),
	(247103, 119, '2014-03-15 00:58:17.000000', 'temperatura', 506.0000, 'ºC'),
	(247104, 119, '2014-03-15 00:58:18.000000', 'temperatura', 914.0000, 'ºC'),
	(247105, 119, '2014-03-15 00:58:19.000000', 'temperatura', 655.0000, 'ºC'),
	(247106, 119, '2014-03-15 00:58:20.000000', 'temperatura', 535.0000, 'ºC'),
	(247107, 119, '2014-03-15 00:58:21.000000', 'temperatura', 708.0000, 'ºC'),
	(247108, 119, '2014-03-15 00:58:22.000000', 'temperatura', 738.0000, 'ºC'),
	(247109, 119, '2014-03-15 00:58:23.000000', 'temperatura', 364.0000, 'ºC'),
	(247110, 119, '2014-03-15 00:58:24.000000', 'temperatura', 807.0000, 'ºC'),
	(247111, 119, '2014-03-15 00:58:25.000000', 'temperatura', 544.0000, 'ºC'),
	(247112, 119, '2014-03-15 00:58:26.000000', 'temperatura', 298.0000, 'ºC'),
	(247113, 119, '2014-03-15 00:58:27.000000', 'temperatura', 1059.0000, 'ºC'),
	(247114, 119, '2014-03-15 00:58:28.000000', 'temperatura', 800.0000, 'ºC'),
	(247115, 119, '2014-03-15 00:58:29.000000', 'temperatura', 827.0000, 'ºC'),
	(247116, 119, '2014-03-15 00:58:30.000000', 'temperatura', 533.0000, 'ºC'),
	(247117, 119, '2014-03-15 00:58:31.000000', 'temperatura', 187.0000, 'ºC'),
	(247118, 119, '2014-03-15 00:58:32.000000', 'temperatura', 534.0000, 'ºC'),
	(247119, 119, '2014-03-15 00:58:33.000000', 'temperatura', 912.0000, 'ºC'),
	(247120, 119, '2014-03-15 00:58:34.000000', 'temperatura', 558.0000, 'ºC'),
	(247121, 119, '2014-03-15 00:58:35.000000', 'temperatura', 53.0000, 'ºC'),
	(247122, 119, '2014-03-15 00:58:36.000000', 'temperatura', 992.0000, 'ºC'),
	(247123, 119, '2014-03-15 00:58:37.000000', 'temperatura', 0.0000, 'ºC'),
	(247124, 119, '2014-03-15 00:58:38.000000', 'temperatura', 627.0000, 'ºC'),
	(247125, 119, '2014-03-15 00:58:39.000000', 'temperatura', 734.0000, 'ºC'),
	(247126, 119, '2014-03-15 00:58:40.000000', 'temperatura', 589.0000, 'ºC'),
	(247127, 119, '2014-03-15 00:58:41.000000', 'temperatura', 744.0000, 'ºC'),
	(247128, 119, '2014-03-15 00:58:42.000000', 'temperatura', 755.0000, 'ºC'),
	(247129, 119, '2014-03-15 00:58:43.000000', 'temperatura', 344.0000, 'ºC'),
	(247130, 119, '2014-03-15 00:58:44.000000', 'temperatura', 653.0000, 'ºC'),
	(247131, 119, '2014-03-15 00:58:45.000000', 'temperatura', 1033.0000, 'ºC'),
	(247132, 119, '2014-03-15 00:58:46.000000', 'temperatura', 806.0000, 'ºC'),
	(247133, 119, '2014-03-15 00:58:47.000000', 'temperatura', 933.0000, 'ºC'),
	(247134, 119, '2014-03-15 00:58:48.000000', 'temperatura', 1046.0000, 'ºC'),
	(247135, 119, '2014-03-15 00:58:49.000000', 'temperatura', 33.0000, 'ºC'),
	(247136, 119, '2014-03-15 00:58:50.000000', 'temperatura', 628.0000, 'ºC'),
	(247137, 119, '2014-03-15 00:58:51.000000', 'temperatura', 641.0000, 'ºC'),
	(247138, 119, '2014-03-15 00:58:52.000000', 'temperatura', 120.0000, 'ºC'),
	(247139, 119, '2014-03-15 00:58:53.000000', 'temperatura', 1077.0000, 'ºC'),
	(247140, 119, '2014-03-15 00:58:54.000000', 'temperatura', 225.0000, 'ºC'),
	(247141, 119, '2014-03-15 00:58:55.000000', 'temperatura', 296.0000, 'ºC'),
	(247142, 119, '2014-03-15 00:58:56.000000', 'temperatura', 806.0000, 'ºC'),
	(247143, 119, '2014-03-15 00:58:57.000000', 'temperatura', 740.0000, 'ºC'),
	(247144, 119, '2014-03-15 00:58:58.000000', 'temperatura', 84.0000, 'ºC'),
	(247145, 119, '2014-03-15 00:58:59.000000', 'temperatura', 599.0000, 'ºC'),
	(247146, 119, '2014-03-15 00:59:00.000000', 'temperatura', 346.0000, 'ºC'),
	(247147, 119, '2014-03-15 00:59:01.000000', 'temperatura', 1133.0000, 'ºC'),
	(247148, 119, '2014-03-15 00:59:02.000000', 'temperatura', 1029.0000, 'ºC'),
	(247149, 119, '2014-03-15 00:59:03.000000', 'temperatura', 546.0000, 'ºC'),
	(247150, 119, '2014-03-15 00:59:04.000000', 'temperatura', 842.0000, 'ºC'),
	(247151, 119, '2014-03-15 00:59:05.000000', 'temperatura', 173.0000, 'ºC'),
	(247152, 119, '2014-03-15 00:59:06.000000', 'temperatura', 742.0000, 'ºC'),
	(247153, 119, '2014-03-15 00:59:07.000000', 'temperatura', 788.0000, 'ºC'),
	(247154, 119, '2014-03-15 00:59:08.000000', 'temperatura', 515.0000, 'ºC'),
	(247155, 119, '2014-03-15 00:59:09.000000', 'temperatura', 211.0000, 'ºC'),
	(247156, 119, '2014-03-15 00:59:10.000000', 'temperatura', 711.0000, 'ºC'),
	(247157, 119, '2014-03-15 00:59:11.000000', 'temperatura', 522.0000, 'ºC'),
	(247158, 119, '2014-03-15 00:59:12.000000', 'temperatura', 479.0000, 'ºC'),
	(247159, 119, '2014-03-15 00:59:13.000000', 'temperatura', 830.0000, 'ºC'),
	(247160, 119, '2014-03-15 00:59:14.000000', 'temperatura', 315.0000, 'ºC'),
	(247161, 119, '2014-03-15 00:59:15.000000', 'temperatura', 283.0000, 'ºC'),
	(247162, 119, '2014-03-15 00:59:16.000000', 'temperatura', 471.0000, 'ºC'),
	(247163, 119, '2014-03-15 00:59:17.000000', 'temperatura', 305.0000, 'ºC'),
	(247164, 119, '2014-03-15 00:59:18.000000', 'temperatura', 113.0000, 'ºC'),
	(247165, 119, '2014-03-15 00:59:19.000000', 'temperatura', 851.0000, 'ºC'),
	(247166, 119, '2014-03-15 00:59:20.000000', 'temperatura', 318.0000, 'ºC'),
	(247167, 119, '2014-03-15 00:59:21.000000', 'temperatura', 235.0000, 'ºC'),
	(247168, 119, '2014-03-15 00:59:22.000000', 'temperatura', 222.0000, 'ºC'),
	(247169, 119, '2014-03-15 00:59:23.000000', 'temperatura', 406.0000, 'ºC'),
	(247170, 119, '2014-03-15 00:59:24.000000', 'temperatura', 164.0000, 'ºC'),
	(247171, 119, '2014-03-15 00:59:25.000000', 'temperatura', 805.0000, 'ºC'),
	(247172, 119, '2014-03-15 00:59:26.000000', 'temperatura', 1131.0000, 'ºC'),
	(247173, 119, '2014-03-15 00:59:27.000000', 'temperatura', 841.0000, 'ºC'),
	(247174, 119, '2014-03-15 00:59:28.000000', 'temperatura', 814.0000, 'ºC'),
	(247175, 119, '2014-03-15 00:59:29.000000', 'temperatura', 345.0000, 'ºC'),
	(247176, 119, '2014-03-15 00:59:30.000000', 'temperatura', 485.0000, 'ºC'),
	(247177, 119, '2014-03-15 00:59:31.000000', 'temperatura', 189.0000, 'ºC'),
	(247178, 119, '2014-03-15 00:59:32.000000', 'temperatura', 690.0000, 'ºC'),
	(247179, 119, '2014-03-15 00:59:33.000000', 'temperatura', 486.0000, 'ºC'),
	(247180, 119, '2014-03-15 00:59:34.000000', 'temperatura', 361.0000, 'ºC'),
	(247181, 119, '2014-03-15 00:59:35.000000', 'temperatura', 346.0000, 'ºC'),
	(247182, 119, '2014-03-15 00:59:36.000000', 'temperatura', 648.0000, 'ºC'),
	(247183, 119, '2014-03-15 00:59:37.000000', 'temperatura', 1002.0000, 'ºC'),
	(247184, 119, '2014-03-15 00:59:38.000000', 'temperatura', 669.0000, 'ºC'),
	(247185, 119, '2014-03-15 00:59:39.000000', 'temperatura', 337.0000, 'ºC'),
	(247186, 119, '2014-03-15 00:59:40.000000', 'temperatura', 877.0000, 'ºC'),
	(247187, 119, '2014-03-15 00:59:41.000000', 'temperatura', 977.0000, 'ºC'),
	(247188, 119, '2014-03-15 00:59:42.000000', 'temperatura', 1053.0000, 'ºC'),
	(247189, 119, '2014-03-15 00:59:43.000000', 'temperatura', 1136.0000, 'ºC'),
	(247190, 119, '2014-03-15 00:59:44.000000', 'temperatura', 120.0000, 'ºC'),
	(247191, 119, '2014-03-15 00:59:45.000000', 'temperatura', 793.0000, 'ºC'),
	(247192, 119, '2014-03-15 00:59:46.000000', 'temperatura', 7.0000, 'ºC'),
	(247193, 119, '2014-03-15 00:59:47.000000', 'temperatura', 54.0000, 'ºC'),
	(247194, 119, '2014-03-15 00:59:48.000000', 'temperatura', 249.0000, 'ºC'),
	(247195, 119, '2014-03-15 00:59:49.000000', 'temperatura', 1084.0000, 'ºC'),
	(247196, 119, '2014-03-15 00:59:50.000000', 'temperatura', 1073.0000, 'ºC'),
	(247197, 119, '2014-03-15 00:59:51.000000', 'temperatura', 914.0000, 'ºC'),
	(247198, 119, '2014-03-15 00:59:52.000000', 'temperatura', 150.0000, 'ºC'),
	(247199, 119, '2014-03-15 00:59:53.000000', 'temperatura', 409.0000, 'ºC'),
	(247200, 119, '2014-03-15 00:59:54.000000', 'temperatura', 396.0000, 'ºC'),
	(247201, 119, '2014-03-15 00:59:55.000000', 'temperatura', 753.0000, 'ºC'),
	(247202, 119, '2014-03-15 00:59:56.000000', 'temperatura', 178.0000, 'ºC'),
	(247203, 119, '2014-03-15 00:59:57.000000', 'temperatura', 1031.0000, 'ºC'),
	(247204, 119, '2014-03-15 00:59:58.000000', 'temperatura', 1023.0000, 'ºC'),
	(247205, 119, '2014-03-15 00:59:59.000000', 'temperatura', 822.0000, 'ºC'),
	(247206, 119, '2014-03-15 01:00:00.000000', 'temperatura', 1039.0000, 'ºC'),
	(247207, 119, '2014-03-15 01:00:01.000000', 'temperatura', 332.0000, 'ºC'),
	(247208, 119, '2014-03-15 01:00:02.000000', 'temperatura', 944.0000, 'ºC'),
	(247209, 119, '2014-03-15 01:00:03.000000', 'temperatura', 125.0000, 'ºC'),
	(247210, 119, '2014-03-15 01:00:04.000000', 'temperatura', 192.0000, 'ºC'),
	(247211, 119, '2014-03-15 01:00:05.000000', 'temperatura', 588.0000, 'ºC'),
	(247212, 119, '2014-03-15 01:00:06.000000', 'temperatura', 1161.0000, 'ºC'),
	(247213, 119, '2014-03-15 01:00:07.000000', 'temperatura', 444.0000, 'ºC'),
	(247214, 119, '2014-03-15 01:00:08.000000', 'temperatura', 1137.0000, 'ºC'),
	(247215, 119, '2014-03-15 01:00:09.000000', 'temperatura', 755.0000, 'ºC'),
	(247216, 119, '2014-03-15 01:00:10.000000', 'temperatura', 363.0000, 'ºC'),
	(247217, 119, '2014-03-15 01:00:11.000000', 'temperatura', 751.0000, 'ºC'),
	(247218, 119, '2014-03-15 01:00:12.000000', 'temperatura', 267.0000, 'ºC'),
	(247219, 119, '2014-03-15 01:00:13.000000', 'temperatura', 284.0000, 'ºC'),
	(247220, 119, '2014-03-15 01:00:14.000000', 'temperatura', 618.0000, 'ºC'),
	(247221, 119, '2014-03-15 01:00:15.000000', 'temperatura', 1039.0000, 'ºC'),
	(247222, 119, '2014-03-15 01:00:16.000000', 'temperatura', 941.0000, 'ºC'),
	(247223, 119, '2014-03-15 01:00:17.000000', 'temperatura', 388.0000, 'ºC'),
	(247224, 119, '2014-03-15 01:00:18.000000', 'temperatura', 316.0000, 'ºC'),
	(247225, 119, '2014-03-15 01:00:19.000000', 'temperatura', 417.0000, 'ºC'),
	(247226, 119, '2014-03-15 01:00:20.000000', 'temperatura', 1139.0000, 'ºC'),
	(247227, 119, '2014-03-15 01:00:21.000000', 'temperatura', 843.0000, 'ºC'),
	(247228, 119, '2014-03-15 01:00:22.000000', 'temperatura', 799.0000, 'ºC'),
	(247229, 119, '2014-03-15 01:00:23.000000', 'temperatura', 267.0000, 'ºC'),
	(247230, 119, '2014-03-15 01:00:24.000000', 'temperatura', 136.0000, 'ºC'),
	(247231, 119, '2014-03-15 01:00:25.000000', 'temperatura', 1081.0000, 'ºC'),
	(247232, 119, '2014-03-15 01:00:26.000000', 'temperatura', 200.0000, 'ºC'),
	(247233, 119, '2014-03-15 01:00:27.000000', 'temperatura', 154.0000, 'ºC'),
	(247234, 119, '2014-03-15 01:00:28.000000', 'temperatura', 172.0000, 'ºC'),
	(247235, 119, '2014-03-15 01:00:29.000000', 'temperatura', 400.0000, 'ºC'),
	(247236, 119, '2014-03-15 01:00:30.000000', 'temperatura', 281.0000, 'ºC'),
	(247237, 119, '2014-03-15 01:00:31.000000', 'temperatura', 209.0000, 'ºC'),
	(247238, 119, '2014-03-15 01:00:32.000000', 'temperatura', 200.0000, 'ºC'),
	(247239, 119, '2014-03-15 01:00:33.000000', 'temperatura', 373.0000, 'ºC'),
	(247240, 119, '2014-03-15 01:00:34.000000', 'temperatura', 68.0000, 'ºC'),
	(247241, 119, '2014-03-15 01:00:35.000000', 'temperatura', 419.0000, 'ºC'),
	(247242, 119, '2014-03-15 01:00:36.000000', 'temperatura', 692.0000, 'ºC'),
	(247243, 119, '2014-03-15 01:00:37.000000', 'temperatura', 1006.0000, 'ºC'),
	(247244, 119, '2014-03-15 01:00:38.000000', 'temperatura', 552.0000, 'ºC'),
	(247245, 119, '2014-03-15 01:00:39.000000', 'temperatura', 941.0000, 'ºC'),
	(247246, 119, '2014-03-15 01:00:40.000000', 'temperatura', 652.0000, 'ºC'),
	(247247, 119, '2014-03-15 01:00:41.000000', 'temperatura', 436.0000, 'ºC'),
	(247248, 119, '2014-03-15 01:00:42.000000', 'temperatura', 223.0000, 'ºC'),
	(247249, 119, '2014-03-15 01:00:43.000000', 'temperatura', 1009.0000, 'ºC'),
	(247250, 119, '2014-03-15 01:00:44.000000', 'temperatura', 776.0000, 'ºC'),
	(247251, 119, '2014-03-15 01:00:45.000000', 'temperatura', 854.0000, 'ºC'),
	(247252, 119, '2014-03-15 01:00:46.000000', 'temperatura', 744.0000, 'ºC'),
	(247253, 119, '2014-03-15 01:00:47.000000', 'temperatura', 1156.0000, 'ºC'),
	(247254, 119, '2014-03-15 01:00:48.000000', 'temperatura', 1148.0000, 'ºC'),
	(247255, 119, '2014-03-15 01:00:49.000000', 'temperatura', 1075.0000, 'ºC'),
	(247256, 119, '2014-03-15 01:00:50.000000', 'temperatura', 730.0000, 'ºC'),
	(247257, 119, '2014-03-15 01:00:51.000000', 'temperatura', 427.0000, 'ºC'),
	(247258, 119, '2014-03-15 01:00:52.000000', 'temperatura', 1143.0000, 'ºC'),
	(247259, 119, '2014-03-15 01:00:53.000000', 'temperatura', 837.0000, 'ºC'),
	(247260, 119, '2014-03-15 01:00:54.000000', 'temperatura', 754.0000, 'ºC'),
	(247261, 119, '2014-03-15 01:00:55.000000', 'temperatura', 58.0000, 'ºC'),
	(247262, 119, '2014-03-15 01:00:56.000000', 'temperatura', 432.0000, 'ºC'),
	(247263, 119, '2014-03-15 01:00:57.000000', 'temperatura', 786.0000, 'ºC'),
	(247264, 119, '2014-03-15 01:00:58.000000', 'temperatura', 236.0000, 'ºC'),
	(247265, 119, '2014-03-15 01:00:59.000000', 'temperatura', 21.0000, 'ºC'),
	(247266, 119, '2014-03-15 01:01:00.000000', 'temperatura', 599.0000, 'ºC'),
	(247267, 119, '2014-03-15 01:01:01.000000', 'temperatura', 534.0000, 'ºC'),
	(247268, 119, '2014-03-15 01:01:02.000000', 'temperatura', 870.0000, 'ºC'),
	(247269, 119, '2014-03-15 01:01:03.000000', 'temperatura', 350.0000, 'ºC'),
	(247270, 119, '2014-03-15 01:01:04.000000', 'temperatura', 340.0000, 'ºC'),
	(247271, 119, '2014-03-15 01:01:05.000000', 'temperatura', 653.0000, 'ºC'),
	(247272, 119, '2014-03-15 01:01:06.000000', 'temperatura', 1042.0000, 'ºC'),
	(247273, 119, '2014-03-15 01:01:07.000000', 'temperatura', 852.0000, 'ºC'),
	(247274, 119, '2014-03-15 01:01:08.000000', 'temperatura', 1136.0000, 'ºC'),
	(247275, 119, '2014-03-15 01:01:09.000000', 'temperatura', 723.0000, 'ºC'),
	(247276, 119, '2014-03-15 01:01:10.000000', 'temperatura', 210.0000, 'ºC'),
	(247277, 119, '2014-03-15 01:01:11.000000', 'temperatura', 79.0000, 'ºC'),
	(247278, 119, '2014-03-15 01:01:12.000000', 'temperatura', 965.0000, 'ºC'),
	(247279, 119, '2014-03-15 01:01:13.000000', 'temperatura', 991.0000, 'ºC'),
	(247280, 119, '2014-03-15 01:01:14.000000', 'temperatura', 860.0000, 'ºC'),
	(247281, 119, '2014-03-15 01:01:15.000000', 'temperatura', 127.0000, 'ºC'),
	(247282, 119, '2014-03-15 01:01:16.000000', 'temperatura', 454.0000, 'ºC'),
	(247283, 119, '2014-03-15 01:01:17.000000', 'temperatura', 690.0000, 'ºC'),
	(247284, 119, '2014-03-15 01:01:18.000000', 'temperatura', 890.0000, 'ºC'),
	(247285, 119, '2014-03-15 01:01:19.000000', 'temperatura', 1181.0000, 'ºC'),
	(247286, 119, '2014-03-15 01:01:20.000000', 'temperatura', 836.0000, 'ºC'),
	(247287, 119, '2014-03-15 01:01:21.000000', 'temperatura', 636.0000, 'ºC'),
	(247288, 119, '2014-03-15 01:01:22.000000', 'temperatura', 671.0000, 'ºC'),
	(247289, 119, '2014-03-15 01:01:23.000000', 'temperatura', 248.0000, 'ºC'),
	(247290, 119, '2014-03-15 01:01:24.000000', 'temperatura', 430.0000, 'ºC'),
	(247291, 119, '2014-03-15 01:01:25.000000', 'temperatura', 204.0000, 'ºC'),
	(247292, 119, '2014-03-15 01:01:26.000000', 'temperatura', 931.0000, 'ºC'),
	(247293, 119, '2014-03-15 01:01:27.000000', 'temperatura', 442.0000, 'ºC'),
	(247294, 119, '2014-03-15 01:01:28.000000', 'temperatura', 621.0000, 'ºC'),
	(247295, 119, '2014-03-15 01:01:29.000000', 'temperatura', 576.0000, 'ºC'),
	(247296, 119, '2014-03-15 01:01:30.000000', 'temperatura', 1020.0000, 'ºC'),
	(247297, 119, '2014-03-15 01:01:31.000000', 'temperatura', 971.0000, 'ºC'),
	(247298, 119, '2014-03-15 01:01:32.000000', 'temperatura', 598.0000, 'ºC'),
	(247299, 119, '2014-03-15 01:01:33.000000', 'temperatura', 76.0000, 'ºC'),
	(247300, 119, '2014-03-15 01:01:34.000000', 'temperatura', 986.0000, 'ºC'),
	(247301, 119, '2014-03-15 01:01:35.000000', 'temperatura', 1104.0000, 'ºC'),
	(247302, 119, '2014-03-15 01:01:36.000000', 'temperatura', 161.0000, 'ºC'),
	(247303, 119, '2014-03-15 01:01:37.000000', 'temperatura', 1096.0000, 'ºC'),
	(247304, 119, '2014-03-15 01:01:38.000000', 'temperatura', 194.0000, 'ºC'),
	(247305, 119, '2014-03-15 01:01:39.000000', 'temperatura', 85.0000, 'ºC'),
	(247306, 119, '2014-03-15 01:01:40.000000', 'temperatura', 1042.0000, 'ºC'),
	(247307, 119, '2014-03-15 01:01:41.000000', 'temperatura', 156.0000, 'ºC'),
	(247308, 119, '2014-03-15 01:01:42.000000', 'temperatura', 56.0000, 'ºC'),
	(247309, 119, '2014-03-15 01:01:43.000000', 'temperatura', 1013.0000, 'ºC'),
	(247310, 119, '2014-03-15 01:01:44.000000', 'temperatura', 97.0000, 'ºC'),
	(247311, 119, '2014-03-15 01:01:45.000000', 'temperatura', 1045.0000, 'ºC'),
	(247312, 119, '2014-03-15 01:01:46.000000', 'temperatura', 136.0000, 'ºC'),
	(247313, 119, '2014-03-15 01:01:47.000000', 'temperatura', 1147.0000, 'ºC'),
	(247314, 119, '2014-03-15 01:01:48.000000', 'temperatura', 525.0000, 'ºC'),
	(247315, 119, '2014-03-15 01:01:49.000000', 'temperatura', 385.0000, 'ºC'),
	(247316, 119, '2014-03-15 01:01:50.000000', 'temperatura', 353.0000, 'ºC'),
	(247317, 119, '2014-03-15 01:01:51.000000', 'temperatura', 608.0000, 'ºC'),
	(247318, 119, '2014-03-15 01:01:52.000000', 'temperatura', 780.0000, 'ºC'),
	(247319, 119, '2014-03-15 01:01:53.000000', 'temperatura', 879.0000, 'ºC'),
	(247320, 119, '2014-03-15 01:01:54.000000', 'temperatura', 853.0000, 'ºC'),
	(247321, 119, '2014-03-15 01:01:55.000000', 'temperatura', 431.0000, 'ºC'),
	(247322, 119, '2014-03-15 01:01:56.000000', 'temperatura', 794.0000, 'ºC'),
	(247323, 119, '2014-03-15 01:01:57.000000', 'temperatura', 279.0000, 'ºC'),
	(247324, 119, '2014-03-15 01:01:58.000000', 'temperatura', 212.0000, 'ºC'),
	(247325, 119, '2014-03-15 01:01:59.000000', 'temperatura', 223.0000, 'ºC'),
	(247326, 119, '2014-03-15 01:02:00.000000', 'temperatura', 483.0000, 'ºC'),
	(247327, 119, '2014-03-15 01:02:01.000000', 'temperatura', 543.0000, 'ºC'),
	(247328, 119, '2014-03-15 01:02:02.000000', 'temperatura', 68.0000, 'ºC'),
	(247329, 119, '2014-03-15 01:02:03.000000', 'temperatura', 1110.0000, 'ºC'),
	(247330, 119, '2014-03-15 01:02:04.000000', 'temperatura', 548.0000, 'ºC'),
	(247331, 119, '2014-03-15 01:02:05.000000', 'temperatura', 611.0000, 'ºC'),
	(247332, 119, '2014-03-15 01:02:06.000000', 'temperatura', 209.0000, 'ºC'),
	(247333, 119, '2014-03-15 01:02:07.000000', 'temperatura', 413.0000, 'ºC'),
	(247334, 119, '2014-03-15 01:02:08.000000', 'temperatura', 238.0000, 'ºC'),
	(247335, 119, '2014-03-15 01:02:09.000000', 'temperatura', 1153.0000, 'ºC'),
	(247336, 119, '2014-03-15 01:02:10.000000', 'temperatura', 252.0000, 'ºC'),
	(247337, 119, '2014-03-15 01:02:11.000000', 'temperatura', 202.0000, 'ºC'),
	(247338, 119, '2014-03-15 01:02:12.000000', 'temperatura', 255.0000, 'ºC'),
	(247339, 119, '2014-03-15 01:02:13.000000', 'temperatura', 667.0000, 'ºC'),
	(247340, 119, '2014-03-15 01:02:14.000000', 'temperatura', 170.0000, 'ºC'),
	(247341, 119, '2014-03-15 01:02:15.000000', 'temperatura', 49.0000, 'ºC'),
	(247342, 119, '2014-03-15 01:02:16.000000', 'temperatura', 935.0000, 'ºC'),
	(247343, 119, '2014-03-15 01:02:17.000000', 'temperatura', 928.0000, 'ºC'),
	(247344, 119, '2014-03-15 01:02:18.000000', 'temperatura', 637.0000, 'ºC'),
	(247345, 119, '2014-03-15 01:02:19.000000', 'temperatura', 400.0000, 'ºC'),
	(247346, 119, '2014-03-15 01:02:20.000000', 'temperatura', 91.0000, 'ºC'),
	(247347, 119, '2014-03-15 01:02:21.000000', 'temperatura', 454.0000, 'ºC'),
	(247348, 119, '2014-03-15 01:02:22.000000', 'temperatura', 797.0000, 'ºC'),
	(247349, 119, '2014-03-15 01:02:23.000000', 'temperatura', 225.0000, 'ºC'),
	(247350, 119, '2014-03-15 01:02:24.000000', 'temperatura', 1132.0000, 'ºC'),
	(247351, 119, '2014-03-15 01:02:25.000000', 'temperatura', 188.0000, 'ºC'),
	(247352, 119, '2014-03-15 01:02:26.000000', 'temperatura', 1144.0000, 'ºC'),
	(247353, 119, '2014-03-15 01:02:27.000000', 'temperatura', 357.0000, 'ºC'),
	(247354, 119, '2014-03-15 01:02:28.000000', 'temperatura', 755.0000, 'ºC'),
	(247355, 119, '2014-03-15 01:02:29.000000', 'temperatura', 303.0000, 'ºC'),
	(247356, 119, '2014-03-15 01:02:30.000000', 'temperatura', 450.0000, 'ºC'),
	(247357, 119, '2014-03-15 01:02:31.000000', 'temperatura', 141.0000, 'ºC'),
	(247358, 119, '2014-03-15 01:02:32.000000', 'temperatura', 555.0000, 'ºC'),
	(247359, 119, '2014-03-15 01:02:33.000000', 'temperatura', 1153.0000, 'ºC'),
	(247360, 119, '2014-03-15 01:02:34.000000', 'temperatura', 500.0000, 'ºC'),
	(247361, 119, '2014-03-15 01:02:35.000000', 'temperatura', 241.0000, 'ºC'),
	(247362, 119, '2014-03-15 01:02:36.000000', 'temperatura', 904.0000, 'ºC'),
	(247363, 119, '2014-03-15 01:02:37.000000', 'temperatura', 199.0000, 'ºC'),
	(247364, 119, '2014-03-15 01:02:38.000000', 'temperatura', 686.0000, 'ºC'),
	(247365, 119, '2014-03-15 01:02:39.000000', 'temperatura', 430.0000, 'ºC'),
	(247366, 119, '2014-03-15 01:02:40.000000', 'temperatura', 94.0000, 'ºC'),
	(247367, 119, '2014-03-15 01:02:41.000000', 'temperatura', 381.0000, 'ºC'),
	(247368, 119, '2014-03-15 01:02:42.000000', 'temperatura', 425.0000, 'ºC'),
	(247369, 119, '2014-03-15 01:02:43.000000', 'temperatura', 980.0000, 'ºC'),
	(247370, 119, '2014-03-15 01:02:44.000000', 'temperatura', 25.0000, 'ºC'),
	(247371, 119, '2014-03-15 01:02:45.000000', 'temperatura', 784.0000, 'ºC'),
	(247372, 119, '2014-03-15 01:02:46.000000', 'temperatura', 249.0000, 'ºC'),
	(247373, 119, '2014-03-15 01:02:47.000000', 'temperatura', 93.0000, 'ºC'),
	(247374, 119, '2014-03-15 01:02:48.000000', 'temperatura', 916.0000, 'ºC'),
	(247375, 119, '2014-03-15 01:02:49.000000', 'temperatura', 702.0000, 'ºC'),
	(247376, 119, '2014-03-15 01:02:50.000000', 'temperatura', 765.0000, 'ºC'),
	(247377, 119, '2014-03-15 01:02:51.000000', 'temperatura', 516.0000, 'ºC'),
	(247378, 119, '2014-03-15 01:02:52.000000', 'temperatura', 289.0000, 'ºC'),
	(247379, 119, '2014-03-15 01:02:53.000000', 'temperatura', 1095.0000, 'ºC'),
	(247380, 119, '2014-03-15 01:02:54.000000', 'temperatura', 1010.0000, 'ºC'),
	(247381, 119, '2014-03-15 01:02:55.000000', 'temperatura', 565.0000, 'ºC'),
	(247382, 119, '2014-03-15 01:02:56.000000', 'temperatura', 996.0000, 'ºC'),
	(247383, 119, '2014-03-15 01:02:57.000000', 'temperatura', 886.0000, 'ºC'),
	(247384, 119, '2014-03-15 01:02:58.000000', 'temperatura', 241.0000, 'ºC'),
	(247385, 119, '2014-03-15 01:02:59.000000', 'temperatura', 947.0000, 'ºC'),
	(247386, 119, '2014-03-15 01:03:00.000000', 'temperatura', 415.0000, 'ºC'),
	(247387, 119, '2014-03-15 01:03:01.000000', 'temperatura', 433.0000, 'ºC'),
	(247388, 119, '2014-03-15 01:03:02.000000', 'temperatura', 921.0000, 'ºC'),
	(247389, 119, '2014-03-15 01:03:03.000000', 'temperatura', 905.0000, 'ºC'),
	(247390, 119, '2014-03-15 01:03:04.000000', 'temperatura', 565.0000, 'ºC'),
	(247391, 119, '2014-03-15 01:03:05.000000', 'temperatura', 111.0000, 'ºC'),
	(247392, 119, '2014-03-15 01:03:06.000000', 'temperatura', 61.0000, 'ºC'),
	(247393, 119, '2014-03-15 01:03:07.000000', 'temperatura', 1173.0000, 'ºC'),
	(247394, 119, '2014-03-15 01:03:08.000000', 'temperatura', 881.0000, 'ºC'),
	(247395, 119, '2014-03-15 01:03:09.000000', 'temperatura', 885.0000, 'ºC'),
	(247396, 119, '2014-03-15 01:03:10.000000', 'temperatura', 585.0000, 'ºC'),
	(247397, 119, '2014-03-15 01:03:11.000000', 'temperatura', 268.0000, 'ºC'),
	(247398, 119, '2014-03-15 01:03:12.000000', 'temperatura', 785.0000, 'ºC'),
	(247399, 119, '2014-03-15 01:03:13.000000', 'temperatura', 723.0000, 'ºC'),
	(247400, 119, '2014-03-15 01:03:14.000000', 'temperatura', 61.0000, 'ºC'),
	(247401, 119, '2014-03-15 01:03:15.000000', 'temperatura', 538.0000, 'ºC'),
	(247402, 119, '2014-03-15 01:03:16.000000', 'temperatura', 105.0000, 'ºC'),
	(247403, 119, '2014-03-15 01:03:17.000000', 'temperatura', 114.0000, 'ºC'),
	(247404, 119, '2014-03-15 01:03:18.000000', 'temperatura', 253.0000, 'ºC'),
	(247405, 119, '2014-03-15 01:03:19.000000', 'temperatura', 925.0000, 'ºC'),
	(247406, 119, '2014-03-15 01:03:20.000000', 'temperatura', 267.0000, 'ºC'),
	(247407, 119, '2014-03-15 01:03:21.000000', 'temperatura', 961.0000, 'ºC'),
	(247408, 119, '2014-03-15 01:03:22.000000', 'temperatura', 402.0000, 'ºC'),
	(247409, 119, '2014-03-15 01:03:23.000000', 'temperatura', 327.0000, 'ºC'),
	(247410, 119, '2014-03-15 01:03:24.000000', 'temperatura', 432.0000, 'ºC'),
	(247411, 119, '2014-03-15 01:03:25.000000', 'temperatura', 1179.0000, 'ºC'),
	(247412, 119, '2014-03-15 01:03:26.000000', 'temperatura', 1001.0000, 'ºC'),
	(247413, 119, '2014-03-15 01:03:27.000000', 'temperatura', 266.0000, 'ºC'),
	(247414, 119, '2014-03-15 01:03:28.000000', 'temperatura', 730.0000, 'ºC'),
	(247415, 119, '2014-03-15 01:03:29.000000', 'temperatura', 451.0000, 'ºC'),
	(247416, 119, '2014-03-15 01:03:30.000000', 'temperatura', 66.0000, 'ºC'),
	(247417, 119, '2014-03-15 01:03:31.000000', 'temperatura', 176.0000, 'ºC'),
	(247418, 119, '2014-03-15 01:03:32.000000', 'temperatura', 683.0000, 'ºC'),
	(247419, 119, '2014-03-15 01:03:33.000000', 'temperatura', 486.0000, 'ºC'),
	(247420, 119, '2014-03-15 01:03:34.000000', 'temperatura', 384.0000, 'ºC'),
	(247421, 119, '2014-03-15 01:03:35.000000', 'temperatura', 464.0000, 'ºC'),
	(247422, 119, '2014-03-15 01:03:36.000000', 'temperatura', 1165.0000, 'ºC'),
	(247423, 119, '2014-03-15 01:03:37.000000', 'temperatura', 836.0000, 'ºC'),
	(247424, 119, '2014-03-15 01:03:38.000000', 'temperatura', 683.0000, 'ºC'),
	(247425, 119, '2014-03-15 01:03:39.000000', 'temperatura', 907.0000, 'ºC'),
	(247426, 119, '2014-03-15 01:03:40.000000', 'temperatura', 87.0000, 'ºC'),
	(247427, 119, '2014-03-15 01:03:41.000000', 'temperatura', 117.0000, 'ºC'),
	(247428, 119, '2014-03-15 01:03:42.000000', 'temperatura', 322.0000, 'ºC'),
	(247429, 119, '2014-03-15 01:03:43.000000', 'temperatura', 61.0000, 'ºC'),
	(247430, 119, '2014-03-15 01:03:44.000000', 'temperatura', 541.0000, 'ºC'),
	(247431, 119, '2014-03-15 01:03:45.000000', 'temperatura', 121.0000, 'ºC'),
	(247432, 119, '2014-03-15 01:03:46.000000', 'temperatura', 182.0000, 'ºC'),
	(247433, 119, '2014-03-15 01:03:47.000000', 'temperatura', 549.0000, 'ºC'),
	(247434, 119, '2014-03-15 01:03:48.000000', 'temperatura', 1000.0000, 'ºC'),
	(247435, 119, '2014-03-15 01:03:49.000000', 'temperatura', 953.0000, 'ºC'),
	(247436, 119, '2014-03-15 01:03:50.000000', 'temperatura', 566.0000, 'ºC'),
	(247437, 119, '2014-03-15 01:03:51.000000', 'temperatura', 1172.0000, 'ºC'),
	(247438, 119, '2014-03-15 01:03:52.000000', 'temperatura', 561.0000, 'ºC'),
	(247439, 119, '2014-03-15 01:03:53.000000', 'temperatura', 492.0000, 'ºC'),
	(247440, 119, '2014-03-15 01:03:54.000000', 'temperatura', 776.0000, 'ºC'),
	(247441, 119, '2014-03-15 01:03:55.000000', 'temperatura', 6.0000, 'ºC'),
	(247442, 119, '2014-03-15 01:03:56.000000', 'temperatura', 103.0000, 'ºC'),
	(247443, 119, '2014-03-15 01:03:57.000000', 'temperatura', 497.0000, 'ºC'),
	(247444, 119, '2014-03-15 01:03:58.000000', 'temperatura', 975.0000, 'ºC'),
	(247445, 119, '2014-03-15 01:03:59.000000', 'temperatura', 986.0000, 'ºC'),
	(247446, 119, '2014-03-15 01:04:00.000000', 'temperatura', 803.0000, 'ºC'),
	(247447, 119, '2014-03-15 01:04:01.000000', 'temperatura', 1059.0000, 'ºC'),
	(247448, 119, '2014-03-15 01:04:02.000000', 'temperatura', 485.0000, 'ºC'),
	(247449, 119, '2014-03-15 01:04:03.000000', 'temperatura', 451.0000, 'ºC'),
	(247450, 119, '2014-03-15 01:04:04.000000', 'temperatura', 798.0000, 'ºC'),
	(247451, 119, '2014-03-15 01:04:05.000000', 'temperatura', 238.0000, 'ºC'),
	(247452, 119, '2014-03-15 01:04:06.000000', 'temperatura', 1196.0000, 'ºC'),
	(247453, 119, '2014-03-15 01:04:07.000000', 'temperatura', 468.0000, 'ºC'),
	(247454, 119, '2014-03-15 01:04:08.000000', 'temperatura', 1153.0000, 'ºC'),
	(247455, 119, '2014-03-15 01:04:09.000000', 'temperatura', 760.0000, 'ºC'),
	(247456, 119, '2014-03-15 01:04:10.000000', 'temperatura', 343.0000, 'ºC'),
	(247457, 119, '2014-03-15 01:04:11.000000', 'temperatura', 634.0000, 'ºC'),
	(247458, 119, '2014-03-15 01:04:12.000000', 'temperatura', 941.0000, 'ºC'),
	(247459, 119, '2014-03-15 01:04:13.000000', 'temperatura', 406.0000, 'ºC'),
	(247460, 119, '2014-03-15 01:04:14.000000', 'temperatura', 407.0000, 'ºC'),
	(247461, 119, '2014-03-15 01:04:15.000000', 'temperatura', 817.0000, 'ºC'),
	(247462, 119, '2014-03-15 01:04:16.000000', 'temperatura', 466.0000, 'ºC'),
	(247463, 119, '2014-03-15 01:04:17.000000', 'temperatura', 1080.0000, 'ºC'),
	(247464, 119, '2014-03-15 01:04:18.000000', 'temperatura', 402.0000, 'ºC'),
	(247465, 119, '2014-03-15 01:04:19.000000', 'temperatura', 1169.0000, 'ºC'),
	(247466, 119, '2014-03-15 01:04:20.000000', 'temperatura', 1041.0000, 'ºC'),
	(247467, 119, '2014-03-15 01:04:21.000000', 'temperatura', 498.0000, 'ºC'),
	(247468, 119, '2014-03-15 01:04:22.000000', 'temperatura', 566.0000, 'ºC'),
	(247469, 119, '2014-03-15 01:04:23.000000', 'temperatura', 136.0000, 'ºC'),
	(247470, 119, '2014-03-15 01:04:24.000000', 'temperatura', 184.0000, 'ºC'),
	(247471, 119, '2014-03-15 01:04:25.000000', 'temperatura', 511.0000, 'ºC'),
	(247472, 119, '2014-03-15 01:04:26.000000', 'temperatura', 806.0000, 'ºC'),
	(247473, 119, '2014-03-15 01:04:27.000000', 'temperatura', 94.0000, 'ºC'),
	(247474, 119, '2014-03-15 01:04:28.000000', 'temperatura', 456.0000, 'ºC'),
	(247475, 119, '2014-03-15 01:04:29.000000', 'temperatura', 798.0000, 'ºC'),
	(247476, 119, '2014-03-15 01:04:30.000000', 'temperatura', 220.0000, 'ºC'),
	(247477, 119, '2014-03-15 01:04:31.000000', 'temperatura', 1108.0000, 'ºC'),
	(247478, 119, '2014-03-15 01:04:32.000000', 'temperatura', 79.0000, 'ºC'),
	(247479, 119, '2014-03-15 01:04:33.000000', 'temperatura', 671.0000, 'ºC'),
	(247480, 119, '2014-03-15 01:04:34.000000', 'temperatura', 718.0000, 'ºC'),
	(247481, 119, '2014-03-15 01:04:35.000000', 'temperatura', 380.0000, 'ºC'),
	(247482, 119, '2014-03-15 01:04:36.000000', 'temperatura', 946.0000, 'ºC'),
	(247483, 119, '2014-03-15 01:04:37.000000', 'temperatura', 1191.0000, 'ºC'),
	(247484, 119, '2014-03-15 01:04:38.000000', 'temperatura', 717.0000, 'ºC'),
	(247485, 119, '2014-03-15 01:04:39.000000', 'temperatura', 12.0000, 'ºC'),
	(247486, 119, '2014-03-15 01:04:40.000000', 'temperatura', 308.0000, 'ºC'),
	(247487, 119, '2014-03-15 01:04:41.000000', 'temperatura', 306.0000, 'ºC'),
	(247488, 119, '2014-03-15 01:04:42.000000', 'temperatura', 606.0000, 'ºC'),
	(247489, 119, '2014-03-15 01:04:43.000000', 'temperatura', 913.0000, 'ºC'),
	(247490, 119, '2014-03-15 01:04:44.000000', 'temperatura', 349.0000, 'ºC'),
	(247491, 119, '2014-03-15 01:04:45.000000', 'temperatura', 204.0000, 'ºC'),
	(247492, 119, '2014-03-15 01:04:46.000000', 'temperatura', 1173.0000, 'ºC'),
	(247493, 119, '2014-03-15 01:04:47.000000', 'temperatura', 457.0000, 'ºC'),
	(247494, 119, '2014-03-15 01:04:48.000000', 'temperatura', 1163.0000, 'ºC'),
	(247495, 119, '2014-03-15 01:04:49.000000', 'temperatura', 845.0000, 'ºC'),
	(247496, 119, '2014-03-15 01:04:50.000000', 'temperatura', 738.0000, 'ºC'),
	(247497, 119, '2014-03-15 01:04:51.000000', 'temperatura', 1156.0000, 'ºC'),
	(247498, 119, '2014-03-15 01:04:52.000000', 'temperatura', 1167.0000, 'ºC'),
	(247499, 119, '2014-03-15 01:04:53.000000', 'temperatura', 1167.0000, 'ºC'),
	(247500, 119, '2014-03-15 01:04:54.000000', 'temperatura', 1133.0000, 'ºC'),
	(247501, 119, '2014-03-15 01:04:55.000000', 'temperatura', 963.0000, 'ºC'),
	(247502, 119, '2014-03-15 01:04:56.000000', 'temperatura', 219.0000, 'ºC'),
	(247503, 119, '2014-03-15 01:04:57.000000', 'temperatura', 608.0000, 'ºC'),
	(247504, 119, '2014-03-15 01:04:58.000000', 'temperatura', 1180.0000, 'ºC'),
	(247505, 119, '2014-03-15 01:04:59.000000', 'temperatura', 480.0000, 'ºC'),
	(247506, 119, '2014-03-15 01:05:00.000000', 'temperatura', 58.0000, 'ºC'),
	(247507, 119, '2014-03-15 01:05:01.000000', 'temperatura', 51.0000, 'ºC'),
	(247508, 119, '2014-03-15 01:05:02.000000', 'temperatura', 83.0000, 'ºC'),
	(247509, 119, '2014-03-15 01:05:03.000000', 'temperatura', 262.0000, 'ºC'),
	(247510, 119, '2014-03-15 01:05:04.000000', 'temperatura', 1061.0000, 'ºC'),
	(247511, 119, '2014-03-15 01:05:05.000000', 'temperatura', 920.0000, 'ºC'),
	(247512, 119, '2014-03-15 01:05:06.000000', 'temperatura', 219.0000, 'ºC'),
	(247513, 119, '2014-03-15 01:05:07.000000', 'temperatura', 734.0000, 'ºC'),
	(247514, 119, '2014-03-15 01:05:08.000000', 'temperatura', 616.0000, 'ºC'),
	(247515, 119, '2014-03-15 01:05:09.000000', 'temperatura', 876.0000, 'ºC'),
	(247516, 119, '2014-03-15 01:05:10.000000', 'temperatura', 133.0000, 'ºC'),
	(247517, 119, '2014-03-15 01:05:11.000000', 'temperatura', 436.0000, 'ºC'),
	(247518, 119, '2014-03-15 01:05:12.000000', 'temperatura', 585.0000, 'ºC'),
	(247519, 119, '2014-03-15 01:05:13.000000', 'temperatura', 415.0000, 'ºC'),
	(247520, 119, '2014-03-15 01:05:14.000000', 'temperatura', 319.0000, 'ºC'),
	(247521, 119, '2014-03-15 01:05:15.000000', 'temperatura', 353.0000, 'ºC'),
	(247522, 119, '2014-03-15 01:05:16.000000', 'temperatura', 806.0000, 'ºC'),
	(247523, 119, '2014-03-15 01:05:17.000000', 'temperatura', 574.0000, 'ºC'),
	(247524, 119, '2014-03-15 01:05:18.000000', 'temperatura', 453.0000, 'ºC'),
	(247525, 119, '2014-03-15 01:05:19.000000', 'temperatura', 545.0000, 'ºC'),
	(247526, 119, '2014-03-15 01:05:20.000000', 'temperatura', 163.0000, 'ºC'),
	(247527, 119, '2014-03-15 01:05:21.000000', 'temperatura', 381.0000, 'ºC'),
	(247528, 119, '2014-03-15 01:05:22.000000', 'temperatura', 217.0000, 'ºC'),
	(247529, 119, '2014-03-15 01:05:23.000000', 'temperatura', 1144.0000, 'ºC'),
	(247530, 119, '2014-03-15 01:05:24.000000', 'temperatura', 268.0000, 'ºC'),
	(247531, 119, '2014-03-15 01:05:25.000000', 'temperatura', 307.0000, 'ºC'),
	(247532, 119, '2014-03-15 01:05:26.000000', 'temperatura', 734.0000, 'ºC'),
	(247533, 119, '2014-03-15 01:05:27.000000', 'temperatura', 349.0000, 'ºC'),
	(247534, 119, '2014-03-15 01:05:28.000000', 'temperatura', 744.0000, 'ºC'),
	(247535, 119, '2014-03-15 01:05:29.000000', 'temperatura', 273.0000, 'ºC'),
	(247536, 119, '2014-03-15 01:05:30.000000', 'temperatura', 332.0000, 'ºC'),
	(247537, 119, '2014-03-15 01:05:31.000000', 'temperatura', 841.0000, 'ºC'),
	(247538, 119, '2014-03-15 01:05:32.000000', 'temperatura', 812.0000, 'ºC'),
	(247539, 119, '2014-03-15 01:05:33.000000', 'temperatura', 334.0000, 'ºC'),
	(247540, 119, '2014-03-15 01:05:34.000000', 'temperatura', 438.0000, 'ºC'),
	(247541, 119, '2014-03-15 01:05:35.000000', 'temperatura', 1188.0000, 'ºC'),
	(247542, 119, '2014-03-15 01:05:36.000000', 'temperatura', 1027.0000, 'ºC'),
	(247543, 119, '2014-03-15 01:05:37.000000', 'temperatura', 370.0000, 'ºC'),
	(247544, 119, '2014-03-15 01:05:38.000000', 'temperatura', 1171.0000, 'ºC'),
	(247545, 119, '2014-03-15 01:05:39.000000', 'temperatura', 1145.0000, 'ºC'),
	(247546, 119, '2014-03-15 01:05:40.000000', 'temperatura', 1012.0000, 'ºC'),
	(247547, 119, '2014-03-15 01:05:41.000000', 'temperatura', 427.0000, 'ºC'),
	(247548, 119, '2014-03-15 01:05:42.000000', 'temperatura', 299.0000, 'ºC'),
	(247549, 119, '2014-03-15 01:05:43.000000', 'temperatura', 212.0000, 'ºC'),
	(247550, 119, '2014-03-15 01:05:44.000000', 'temperatura', 167.0000, 'ºC'),
	(247551, 119, '2014-03-15 01:05:45.000000', 'temperatura', 198.0000, 'ºC'),
	(247552, 119, '2014-03-15 01:05:46.000000', 'temperatura', 490.0000, 'ºC'),
	(247553, 119, '2014-03-15 01:05:47.000000', 'temperatura', 658.0000, 'ºC'),
	(247554, 119, '2014-03-15 01:05:48.000000', 'temperatura', 617.0000, 'ºC'),
	(247555, 119, '2014-03-15 01:05:49.000000', 'temperatura', 1115.0000, 'ºC'),
	(247556, 119, '2014-03-15 01:05:50.000000', 'temperatura', 121.0000, 'ºC'),
	(247557, 119, '2014-03-15 01:05:51.000000', 'temperatura', 862.0000, 'ºC'),
	(247558, 119, '2014-03-15 01:05:52.000000', 'temperatura', 348.0000, 'ºC'),
	(247559, 119, '2014-03-15 01:05:53.000000', 'temperatura', 356.0000, 'ºC'),
	(247560, 119, '2014-03-15 01:05:54.000000', 'temperatura', 734.0000, 'ºC'),
	(247561, 119, '2014-03-15 01:05:55.000000', 'temperatura', 203.0000, 'ºC'),
	(247562, 119, '2014-03-15 01:05:56.000000', 'temperatura', 12.0000, 'ºC'),
	(247563, 119, '2014-03-15 01:05:57.000000', 'temperatura', 654.0000, 'ºC'),
	(247564, 119, '2014-03-15 01:05:58.000000', 'temperatura', 835.0000, 'ºC'),
	(247565, 119, '2014-03-15 01:05:59.000000', 'temperatura', 1014.0000, 'ºC'),
	(247566, 119, '2014-03-15 01:06:00.000000', 'temperatura', 166.0000, 'ºC'),
	(247567, 119, '2014-03-15 01:06:01.000000', 'temperatura', 186.0000, 'ºC'),
	(247568, 119, '2014-03-15 01:06:02.000000', 'temperatura', 433.0000, 'ºC'),
	(247569, 119, '2014-03-15 01:06:03.000000', 'temperatura', 409.0000, 'ºC'),
	(247570, 119, '2014-03-15 01:06:04.000000', 'temperatura', 747.0000, 'ºC'),
	(247571, 119, '2014-03-15 01:06:05.000000', 'temperatura', 106.0000, 'ºC'),
	(247572, 119, '2014-03-15 01:06:06.000000', 'temperatura', 691.0000, 'ºC'),
	(247573, 119, '2014-03-15 01:06:07.000000', 'temperatura', 736.0000, 'ºC'),
	(247574, 119, '2014-03-15 01:06:08.000000', 'temperatura', 408.0000, 'ºC'),
	(247575, 119, '2014-03-15 01:06:09.000000', 'temperatura', 1032.0000, 'ºC'),
	(247576, 119, '2014-03-15 01:06:10.000000', 'temperatura', 337.0000, 'ºC'),
	(247577, 119, '2014-03-15 01:06:11.000000', 'temperatura', 990.0000, 'ºC'),
	(247578, 119, '2014-03-15 01:06:12.000000', 'temperatura', 340.0000, 'ºC'),
	(247579, 119, '2014-03-15 01:06:13.000000', 'temperatura', 1128.0000, 'ºC'),
	(247580, 119, '2014-03-15 01:06:14.000000', 'temperatura', 1023.0000, 'ºC'),
	(247581, 119, '2014-03-15 01:06:15.000000', 'temperatura', 530.0000, 'ºC'),
	(247582, 119, '2014-03-15 01:06:16.000000', 'temperatura', 780.0000, 'ºC'),
	(247583, 119, '2014-03-15 01:06:17.000000', 'temperatura', 1112.0000, 'ºC'),
	(247584, 119, '2014-03-15 01:06:18.000000', 'temperatura', 822.0000, 'ºC'),
	(247585, 119, '2014-03-15 01:06:19.000000', 'temperatura', 775.0000, 'ºC'),
	(247586, 119, '2014-03-15 01:06:20.000000', 'temperatura', 210.0000, 'ºC'),
	(247587, 119, '2014-03-15 01:06:21.000000', 'temperatura', 1124.0000, 'ºC'),
	(247588, 119, '2014-03-15 01:06:22.000000', 'temperatura', 189.0000, 'ºC'),
	(247589, 119, '2014-03-15 01:06:23.000000', 'temperatura', 1174.0000, 'ºC'),
	(247590, 119, '2014-03-15 01:06:24.000000', 'temperatura', 504.0000, 'ºC'),
	(247591, 119, '2014-03-15 01:06:25.000000', 'temperatura', 198.0000, 'ºC'),
	(247592, 119, '2014-03-15 01:06:26.000000', 'temperatura', 677.0000, 'ºC'),
	(247593, 119, '2014-03-15 01:06:27.000000', 'temperatura', 393.0000, 'ºC'),
	(247594, 119, '2014-03-15 01:06:28.000000', 'temperatura', 1134.0000, 'ºC'),
	(247595, 119, '2014-03-15 01:06:29.000000', 'temperatura', 893.0000, 'ºC'),
	(247596, 119, '2014-03-15 01:06:30.000000', 'temperatura', 1061.0000, 'ºC'),
	(247597, 119, '2014-03-15 01:06:31.000000', 'temperatura', 228.0000, 'ºC'),
	(247598, 119, '2014-03-15 01:06:32.000000', 'temperatura', 359.0000, 'ºC'),
	(247599, 119, '2014-03-15 01:06:33.000000', 'temperatura', 1111.0000, 'ºC'),
	(247600, 119, '2014-03-15 01:06:34.000000', 'temperatura', 880.0000, 'ºC'),
	(247601, 119, '2014-03-15 01:06:35.000000', 'temperatura', 1066.0000, 'ºC'),
	(247602, 119, '2014-03-15 01:06:36.000000', 'temperatura', 290.0000, 'ºC'),
	(247603, 119, '2014-03-15 01:06:37.000000', 'temperatura', 653.0000, 'ºC'),
	(247604, 119, '2014-03-15 01:06:38.000000', 'temperatura', 1194.0000, 'ºC'),
	(247605, 119, '2014-03-15 01:06:39.000000', 'temperatura', 414.0000, 'ºC'),
	(247606, 119, '2014-03-15 01:06:40.000000', 'temperatura', 886.0000, 'ºC'),
	(247607, 119, '2014-03-15 01:06:41.000000', 'temperatura', 789.0000, 'ºC'),
	(247608, 119, '2014-03-15 01:06:42.000000', 'temperatura', 87.0000, 'ºC'),
	(247609, 119, '2014-03-15 01:06:43.000000', 'temperatura', 468.0000, 'ºC'),
	(247610, 119, '2014-03-15 01:06:44.000000', 'temperatura', 879.0000, 'ºC'),
	(247611, 119, '2014-03-15 01:06:45.000000', 'temperatura', 593.0000, 'ºC'),
	(247612, 119, '2014-03-15 01:06:46.000000', 'temperatura', 328.0000, 'ºC'),
	(247613, 119, '2014-03-15 01:06:47.000000', 'temperatura', 1064.0000, 'ºC'),
	(247614, 119, '2014-03-15 01:06:48.000000', 'temperatura', 733.0000, 'ºC'),
	(247615, 119, '2014-03-15 01:06:49.000000', 'temperatura', 476.0000, 'ºC'),
	(247616, 119, '2014-03-15 01:06:50.000000', 'temperatura', 182.0000, 'ºC'),
	(247617, 119, '2014-03-15 01:06:51.000000', 'temperatura', 684.0000, 'ºC'),
	(247618, 119, '2014-03-15 01:06:52.000000', 'temperatura', 471.0000, 'ºC'),
	(247619, 119, '2014-03-15 01:06:53.000000', 'temperatura', 307.0000, 'ºC'),
	(247620, 119, '2014-03-15 01:06:54.000000', 'temperatura', 120.0000, 'ºC'),
	(247621, 119, '2014-03-15 01:06:55.000000', 'temperatura', 878.0000, 'ºC'),
	(247622, 119, '2014-03-15 01:06:56.000000', 'temperatura', 433.0000, 'ºC'),
	(247623, 119, '2014-03-15 01:06:57.000000', 'temperatura', 729.0000, 'ºC'),
	(247624, 119, '2014-03-15 01:06:58.000000', 'temperatura', 1148.0000, 'ºC'),
	(247625, 119, '2014-03-15 01:06:59.000000', 'temperatura', 1153.0000, 'ºC'),
	(247626, 119, '2014-03-15 01:07:00.000000', 'temperatura', 1121.0000, 'ºC'),
	(247627, 119, '2014-03-15 01:07:01.000000', 'temperatura', 946.0000, 'ºC'),
	(247628, 119, '2014-03-15 01:07:02.000000', 'temperatura', 167.0000, 'ºC'),
	(247629, 119, '2014-03-15 01:07:03.000000', 'temperatura', 399.0000, 'ºC'),
	(247630, 119, '2014-03-15 01:07:04.000000', 'temperatura', 296.0000, 'ºC'),
	(247631, 119, '2014-03-15 01:07:05.000000', 'temperatura', 281.0000, 'ºC'),
	(247632, 119, '2014-03-15 01:07:06.000000', 'temperatura', 517.0000, 'ºC'),
	(247633, 119, '2014-03-15 01:07:07.000000', 'temperatura', 543.0000, 'ºC'),
	(247634, 119, '2014-03-15 01:07:08.000000', 'temperatura', 1166.0000, 'ºC'),
	(247635, 119, '2014-03-15 01:07:09.000000', 'temperatura', 601.0000, 'ºC'),
	(247636, 119, '2014-03-15 01:07:10.000000', 'temperatura', 707.0000, 'ºC'),
	(247637, 119, '2014-03-15 01:07:11.000000', 'temperatura', 534.0000, 'ºC'),
	(247638, 119, '2014-03-15 01:07:12.000000', 'temperatura', 547.0000, 'ºC'),
	(247639, 119, '2014-03-15 01:07:13.000000', 'temperatura', 1133.0000, 'ºC'),
	(247640, 119, '2014-03-15 01:07:14.000000', 'temperatura', 424.0000, 'ºC'),
	(247641, 119, '2014-03-15 01:07:15.000000', 'temperatura', 1121.0000, 'ºC'),
	(247642, 119, '2014-03-15 01:07:16.000000', 'temperatura', 734.0000, 'ºC'),
	(247643, 119, '2014-03-15 01:07:17.000000', 'temperatura', 306.0000, 'ºC'),
	(247644, 119, '2014-03-15 01:07:18.000000', 'temperatura', 529.0000, 'ºC'),
	(247645, 119, '2014-03-15 01:07:19.000000', 'temperatura', 529.0000, 'ºC'),
	(247646, 119, '2014-03-15 01:07:20.000000', 'temperatura', 1060.0000, 'ºC'),
	(247647, 119, '2014-03-15 01:07:21.000000', 'temperatura', 111.0000, 'ºC'),
	(247648, 119, '2014-03-15 01:07:22.000000', 'temperatura', 977.0000, 'ºC'),
	(247649, 119, '2014-03-15 01:07:23.000000', 'temperatura', 952.0000, 'ºC'),
	(247650, 119, '2014-03-15 01:07:24.000000', 'temperatura', 631.0000, 'ºC'),
	(247651, 119, '2014-03-15 01:07:25.000000', 'temperatura', 299.0000, 'ºC'),
	(247652, 119, '2014-03-15 01:07:26.000000', 'temperatura', 801.0000, 'ºC'),
	(247653, 119, '2014-03-15 01:07:27.000000', 'temperatura', 711.0000, 'ºC'),
	(247654, 119, '2014-03-15 01:07:28.000000', 'temperatura', 1151.0000, 'ºC'),
	(247655, 119, '2014-03-15 01:07:29.000000', 'temperatura', 23.0000, 'ºC'),
	(247656, 119, '2014-03-15 01:07:30.000000', 'temperatura', 261.0000, 'ºC'),
	(247657, 119, '2014-03-15 01:07:31.000000', 'temperatura', 36.0000, 'ºC'),
	(247658, 119, '2014-03-15 01:07:32.000000', 'temperatura', 597.0000, 'ºC'),
	(247659, 119, '2014-03-15 01:07:33.000000', 'temperatura', 480.0000, 'ºC'),
	(247660, 119, '2014-03-15 01:07:34.000000', 'temperatura', 608.0000, 'ºC'),
	(247661, 119, '2014-03-15 01:07:35.000000', 'temperatura', 401.0000, 'ºC'),
	(247662, 119, '2014-03-15 01:07:36.000000', 'temperatura', 183.0000, 'ºC'),
	(247663, 119, '2014-03-15 01:07:37.000000', 'temperatura', 909.0000, 'ºC'),
	(247664, 119, '2014-03-15 01:07:38.000000', 'temperatura', 399.0000, 'ºC'),
	(247665, 119, '2014-03-15 01:07:39.000000', 'temperatura', 468.0000, 'ºC'),
	(247666, 119, '2014-03-15 01:07:40.000000', 'temperatura', 1145.0000, 'ºC'),
	(247667, 119, '2014-03-15 01:07:41.000000', 'temperatura', 722.0000, 'ºC'),
	(247668, 119, '2014-03-15 01:07:42.000000', 'temperatura', 176.0000, 'ºC'),
	(247669, 119, '2014-03-15 01:07:43.000000', 'temperatura', 1112.0000, 'ºC'),
	(247670, 119, '2014-03-15 01:07:44.000000', 'temperatura', 231.0000, 'ºC'),
	(247671, 119, '2014-03-15 01:07:45.000000', 'temperatura', 223.0000, 'ºC'),
	(247672, 119, '2014-03-15 01:07:46.000000', 'temperatura', 422.0000, 'ºC'),
	(247673, 119, '2014-03-15 01:07:47.000000', 'temperatura', 240.0000, 'ºC'),
	(247674, 119, '2014-03-15 01:07:48.000000', 'temperatura', 1137.0000, 'ºC'),
	(247675, 119, '2014-03-15 01:07:49.000000', 'temperatura', 163.0000, 'ºC'),
	(247676, 119, '2014-03-15 01:07:50.000000', 'temperatura', 1004.0000, 'ºC'),
	(247677, 119, '2014-03-15 01:07:51.000000', 'temperatura', 934.0000, 'ºC'),
	(247678, 119, '2014-03-15 01:07:52.000000', 'temperatura', 456.0000, 'ºC'),
	(247679, 119, '2014-03-15 01:07:53.000000', 'temperatura', 679.0000, 'ºC'),
	(247680, 119, '2014-03-15 01:07:54.000000', 'temperatura', 829.0000, 'ºC'),
	(247681, 119, '2014-03-15 01:07:55.000000', 'temperatura', 908.0000, 'ºC'),
	(247682, 119, '2014-03-15 01:07:56.000000', 'temperatura', 855.0000, 'ºC'),
	(247683, 119, '2014-03-15 01:07:57.000000', 'temperatura', 350.0000, 'ºC'),
	(247684, 119, '2014-03-15 01:07:58.000000', 'temperatura', 386.0000, 'ºC'),
	(247685, 119, '2014-03-15 01:07:59.000000', 'temperatura', 878.0000, 'ºC'),
	(247686, 119, '2014-03-15 01:08:00.000000', 'temperatura', 835.0000, 'ºC'),
	(247687, 119, '2014-03-15 01:08:01.000000', 'temperatura', 342.0000, 'ºC'),
	(247688, 119, '2014-03-15 01:08:02.000000', 'temperatura', 403.0000, 'ºC'),
	(247689, 119, '2014-03-15 01:08:03.000000', 'temperatura', 993.0000, 'ºC'),
	(247690, 119, '2014-03-15 01:08:04.000000', 'temperatura', 154.0000, 'ºC'),
	(247691, 119, '2014-03-15 01:08:05.000000', 'temperatura', 190.0000, 'ºC'),
	(247692, 119, '2014-03-15 01:08:06.000000', 'temperatura', 490.0000, 'ºC'),
	(247693, 119, '2014-03-15 01:08:07.000000', 'temperatura', 681.0000, 'ºC'),
	(247694, 119, '2014-03-15 01:08:08.000000', 'temperatura', 735.0000, 'ºC'),
	(247695, 119, '2014-03-15 01:08:09.000000', 'temperatura', 433.0000, 'ºC'),
	(247696, 119, '2014-03-15 01:08:10.000000', 'temperatura', 1160.0000, 'ºC'),
	(247697, 119, '2014-03-15 01:08:11.000000', 'temperatura', 901.0000, 'ºC'),
	(247698, 119, '2014-03-15 01:08:12.000000', 'temperatura', 1025.0000, 'ºC'),
	(247699, 119, '2014-03-15 01:08:13.000000', 'temperatura', 23.0000, 'ºC'),
	(247700, 119, '2014-03-15 01:08:14.000000', 'temperatura', 639.0000, 'ºC'),
	(247701, 119, '2014-03-15 01:08:15.000000', 'temperatura', 728.0000, 'ºC'),
	(247702, 119, '2014-03-15 01:08:16.000000', 'temperatura', 524.0000, 'ºC'),
	(247703, 119, '2014-03-15 01:08:17.000000', 'temperatura', 438.0000, 'ºC'),
	(247704, 119, '2014-03-15 01:08:18.000000', 'temperatura', 617.0000, 'ºC'),
	(247705, 119, '2014-03-15 01:08:19.000000', 'temperatura', 572.0000, 'ºC'),
	(247706, 119, '2014-03-15 01:08:20.000000', 'temperatura', 1010.0000, 'ºC'),
	(247707, 119, '2014-03-15 01:08:21.000000', 'temperatura', 932.0000, 'ºC'),
	(247708, 119, '2014-03-15 01:08:22.000000', 'temperatura', 433.0000, 'ºC'),
	(247709, 119, '2014-03-15 01:08:23.000000', 'temperatura', 568.0000, 'ºC'),
	(247710, 119, '2014-03-15 01:08:24.000000', 'temperatura', 343.0000, 'ºC'),
	(247711, 119, '2014-03-15 01:08:25.000000', 'temperatura', 11.0000, 'ºC'),
	(247712, 119, '2014-03-15 01:08:26.000000', 'temperatura', 225.0000, 'ºC'),
	(247713, 119, '2014-03-15 01:08:27.000000', 'temperatura', 1095.0000, 'ºC'),
	(247714, 119, '2014-03-15 01:08:28.000000', 'temperatura', 1198.0000, 'ºC'),
	(247715, 119, '2014-03-15 01:08:29.000000', 'temperatura', 307.0000, 'ºC'),
	(247716, 119, '2014-03-15 01:08:30.000000', 'temperatura', 340.0000, 'ºC'),
	(247717, 119, '2014-03-15 01:08:31.000000', 'temperatura', 782.0000, 'ºC'),
	(247718, 119, '2014-03-15 01:08:32.000000', 'temperatura', 490.0000, 'ºC'),
	(247719, 119, '2014-03-15 01:08:33.000000', 'temperatura', 102.0000, 'ºC'),
	(247720, 119, '2014-03-15 01:08:34.000000', 'temperatura', 241.0000, 'ºC'),
	(247721, 119, '2014-03-15 01:08:35.000000', 'temperatura', 902.0000, 'ºC'),
	(247722, 119, '2014-03-15 01:08:36.000000', 'temperatura', 185.0000, 'ºC'),
	(247723, 119, '2014-03-15 01:08:37.000000', 'temperatura', 619.0000, 'ºC'),
	(247724, 119, '2014-03-15 01:08:38.000000', 'temperatura', 140.0000, 'ºC'),
	(247725, 119, '2014-03-15 01:08:39.000000', 'temperatura', 45.0000, 'ºC'),
	(247726, 119, '2014-03-15 01:08:40.000000', 'temperatura', 1004.0000, 'ºC'),
	(247727, 119, '2014-03-15 01:08:41.000000', 'temperatura', 86.0000, 'ºC'),
	(247728, 119, '2014-03-15 01:08:42.000000', 'temperatura', 1020.0000, 'ºC'),
	(247729, 119, '2014-03-15 01:08:43.000000', 'temperatura', 43.0000, 'ºC'),
	(247730, 119, '2014-03-15 01:08:44.000000', 'temperatura', 756.0000, 'ºC'),
	(247731, 119, '2014-03-15 01:08:45.000000', 'temperatura', 52.0000, 'ºC'),
	(247732, 119, '2014-03-15 01:08:46.000000', 'temperatura', 390.0000, 'ºC'),
	(247733, 119, '2014-03-15 01:08:47.000000', 'temperatura', 594.0000, 'ºC'),
	(247734, 119, '2014-03-15 01:08:48.000000', 'temperatura', 601.0000, 'ºC'),
	(247735, 119, '2014-03-15 01:08:49.000000', 'temperatura', 23.0000, 'ºC'),
	(247736, 119, '2014-03-15 01:08:50.000000', 'temperatura', 714.0000, 'ºC'),
	(247737, 119, '2014-03-15 01:08:51.000000', 'temperatura', 1102.0000, 'ºC'),
	(247738, 119, '2014-03-15 01:08:52.000000', 'temperatura', 966.0000, 'ºC'),
	(247739, 119, '2014-03-15 01:08:53.000000', 'temperatura', 326.0000, 'ºC'),
	(247740, 119, '2014-03-15 01:08:54.000000', 'temperatura', 1132.0000, 'ºC'),
	(247741, 119, '2014-03-15 01:08:55.000000', 'temperatura', 1083.0000, 'ºC'),
	(247742, 119, '2014-03-15 01:08:56.000000', 'temperatura', 820.0000, 'ºC'),
	(247743, 119, '2014-03-15 01:08:57.000000', 'temperatura', 850.0000, 'ºC'),
	(247744, 119, '2014-03-15 01:08:58.000000', 'temperatura', 591.0000, 'ºC'),
	(247745, 119, '2014-03-15 01:08:59.000000', 'temperatura', 407.0000, 'ºC'),
	(247746, 119, '2014-03-15 01:09:00.000000', 'temperatura', 262.0000, 'ºC'),
	(247747, 119, '2014-03-15 01:09:01.000000', 'temperatura', 88.0000, 'ºC'),
	(247748, 119, '2014-03-15 01:09:02.000000', 'temperatura', 857.0000, 'ºC'),
	(247749, 119, '2014-03-15 01:09:03.000000', 'temperatura', 422.0000, 'ºC'),
	(247750, 119, '2014-03-15 01:09:04.000000', 'temperatura', 738.0000, 'ºC'),
	(247751, 119, '2014-03-15 01:09:05.000000', 'temperatura', 27.0000, 'ºC'),
	(247752, 119, '2014-03-15 01:09:06.000000', 'temperatura', 318.0000, 'ºC'),
	(247753, 119, '2014-03-15 01:09:07.000000', 'temperatura', 312.0000, 'ºC'),
	(247754, 119, '2014-03-15 01:09:08.000000', 'temperatura', 608.0000, 'ºC'),
	(247755, 119, '2014-03-15 01:09:09.000000', 'temperatura', 901.0000, 'ºC'),
	(247756, 119, '2014-03-15 01:09:10.000000', 'temperatura', 282.0000, 'ºC'),
	(247757, 119, '2014-03-15 01:09:11.000000', 'temperatura', 1110.0000, 'ºC'),
	(247758, 119, '2014-03-15 01:09:12.000000', 'temperatura', 1103.0000, 'ºC'),
	(247759, 119, '2014-03-15 01:09:13.000000', 'temperatura', 986.0000, 'ºC'),
	(247760, 119, '2014-03-15 01:09:14.000000', 'temperatura', 419.0000, 'ºC'),
	(247761, 119, '2014-03-15 01:09:15.000000', 'temperatura', 340.0000, 'ºC'),
	(247762, 119, '2014-03-15 01:09:16.000000', 'temperatura', 445.0000, 'ºC'),
	(247763, 119, '2014-03-15 01:09:17.000000', 'temperatura', 4.0000, 'ºC'),
	(247764, 119, '2014-03-15 01:09:18.000000', 'temperatura', 1084.0000, 'ºC'),
	(247765, 119, '2014-03-15 01:09:19.000000', 'temperatura', 610.0000, 'ºC'),
	(247766, 119, '2014-03-15 01:09:20.000000', 'temperatura', 998.0000, 'ºC'),
	(247767, 119, '2014-03-15 01:09:21.000000', 'temperatura', 761.0000, 'ºC'),
	(247768, 119, '2014-03-15 01:09:22.000000', 'temperatura', 813.0000, 'ºC'),
	(247769, 119, '2014-03-15 01:09:23.000000', 'temperatura', 580.0000, 'ºC'),
	(247770, 119, '2014-03-15 01:09:24.000000', 'temperatura', 464.0000, 'ºC'),
	(247771, 119, '2014-03-15 01:09:25.000000', 'temperatura', 579.0000, 'ºC'),
	(247772, 119, '2014-03-15 01:09:26.000000', 'temperatura', 305.0000, 'ºC'),
	(247773, 119, '2014-03-15 01:09:27.000000', 'temperatura', 988.0000, 'ºC'),
	(247774, 119, '2014-03-15 01:09:28.000000', 'temperatura', 427.0000, 'ºC'),
	(247775, 119, '2014-03-15 01:09:29.000000', 'temperatura', 372.0000, 'ºC'),
	(247776, 119, '2014-03-15 01:09:30.000000', 'temperatura', 578.0000, 'ºC'),
	(247777, 119, '2014-03-15 01:09:31.000000', 'temperatura', 575.0000, 'ºC'),
	(247778, 119, '2014-03-15 01:09:32.000000', 'temperatura', 1142.0000, 'ºC'),
	(247779, 119, '2014-03-15 01:09:33.000000', 'temperatura', 384.0000, 'ºC'),
	(247780, 119, '2014-03-15 01:09:34.000000', 'temperatura', 896.0000, 'ºC'),
	(247781, 119, '2014-03-15 01:09:35.000000', 'temperatura', 926.0000, 'ºC'),
	(247782, 119, '2014-03-15 01:09:36.000000', 'temperatura', 745.0000, 'ºC'),
	(247783, 119, '2014-03-15 01:09:37.000000', 'temperatura', 947.0000, 'ºC'),
	(247784, 119, '2014-03-15 01:09:38.000000', 'temperatura', 99.0000, 'ºC'),
	(247785, 119, '2014-03-15 01:09:39.000000', 'temperatura', 53.0000, 'ºC'),
	(247786, 119, '2014-03-15 01:09:40.000000', 'temperatura', 1172.0000, 'ºC'),
	(247787, 119, '2014-03-15 01:09:41.000000', 'temperatura', 900.0000, 'ºC'),
	(247788, 119, '2014-03-15 01:09:42.000000', 'temperatura', 983.0000, 'ºC'),
	(247789, 119, '2014-03-15 01:09:43.000000', 'temperatura', 1015.0000, 'ºC'),
	(247790, 119, '2014-03-15 01:09:44.000000', 'temperatura', 926.0000, 'ºC'),
	(247791, 119, '2014-03-15 01:09:45.000000', 'temperatura', 386.0000, 'ºC'),
	(247792, 119, '2014-03-15 01:09:46.000000', 'temperatura', 354.0000, 'ºC'),
	(247793, 119, '2014-03-15 01:09:47.000000', 'temperatura', 614.0000, 'ºC'),
	(247794, 119, '2014-03-15 01:09:48.000000', 'temperatura', 806.0000, 'ºC'),
	(247795, 119, '2014-03-15 01:09:49.000000', 'temperatura', 990.0000, 'ºC'),
	(247796, 119, '2014-03-15 01:09:50.000000', 'temperatura', 133.0000, 'ºC'),
	(247797, 119, '2014-03-15 01:09:51.000000', 'temperatura', 93.0000, 'ºC'),
	(247798, 119, '2014-03-15 01:09:52.000000', 'temperatura', 66.0000, 'ºC'),
	(247799, 119, '2014-03-15 01:09:53.000000', 'temperatura', 54.0000, 'ºC'),
	(247800, 119, '2014-03-15 01:09:54.000000', 'temperatura', 70.0000, 'ºC'),
	(247801, 119, '2014-03-15 01:09:55.000000', 'temperatura', 191.0000, 'ºC'),
	(247802, 119, '2014-03-15 01:09:56.000000', 'temperatura', 743.0000, 'ºC'),
	(247803, 119, '2014-03-15 01:09:57.000000', 'temperatura', 745.0000, 'ºC'),
	(247804, 119, '2014-03-15 01:09:58.000000', 'temperatura', 294.0000, 'ºC'),
	(247805, 119, '2014-03-15 01:09:59.000000', 'temperatura', 438.0000, 'ºC'),
	(247806, 119, '2014-03-15 01:10:00.000000', 'temperatura', 106.0000, 'ºC'),
	(247807, 119, '2014-03-15 01:10:01.000000', 'temperatura', 417.0000, 'ºC'),
	(247808, 119, '2014-03-15 01:10:02.000000', 'temperatura', 569.0000, 'ºC'),
	(247809, 119, '2014-03-15 01:10:03.000000', 'temperatura', 395.0000, 'ºC'),
	(247810, 119, '2014-03-15 01:10:04.000000', 'temperatura', 267.0000, 'ºC'),
	(247811, 119, '2014-03-15 01:10:05.000000', 'temperatura', 149.0000, 'ºC'),
	(247812, 119, '2014-03-15 01:10:06.000000', 'temperatura', 1145.0000, 'ºC'),
	(247813, 119, '2014-03-15 01:10:07.000000', 'temperatura', 479.0000, 'ºC'),
	(247814, 119, '2014-03-15 01:10:08.000000', 'temperatura', 159.0000, 'ºC'),
	(247815, 119, '2014-03-15 01:10:09.000000', 'temperatura', 560.0000, 'ºC'),
	(247816, 119, '2014-03-15 01:10:10.000000', 'temperatura', 1123.0000, 'ºC'),
	(247817, 119, '2014-03-15 01:10:11.000000', 'temperatura', 336.0000, 'ºC'),
	(247818, 119, '2014-03-15 01:10:12.000000', 'temperatura', 713.0000, 'ºC'),
	(247819, 119, '2014-03-15 01:10:13.000000', 'temperatura', 155.0000, 'ºC'),
	(247820, 119, '2014-03-15 01:10:14.000000', 'temperatura', 1038.0000, 'ºC'),
	(247821, 119, '2014-03-15 01:10:15.000000', 'temperatura', 1123.0000, 'ºC'),
	(247822, 119, '2014-03-15 01:10:16.000000', 'temperatura', 103.0000, 'ºC'),
	(247823, 119, '2014-03-15 01:10:17.000000', 'temperatura', 748.0000, 'ºC'),
	(247824, 119, '2014-03-15 01:10:18.000000', 'temperatura', 1028.0000, 'ºC'),
	(247825, 119, '2014-03-15 01:10:19.000000', 'temperatura', 500.0000, 'ºC'),
	(247826, 119, '2014-03-15 01:10:20.000000', 'temperatura', 615.0000, 'ºC'),
	(247827, 119, '2014-03-15 01:10:21.000000', 'temperatura', 377.0000, 'ºC'),
	(247828, 119, '2014-03-15 01:10:22.000000', 'temperatura', 38.0000, 'ºC'),
	(247829, 119, '2014-03-15 01:10:23.000000', 'temperatura', 263.0000, 'ºC'),
	(247830, 119, '2014-03-15 01:10:24.000000', 'temperatura', 1198.0000, 'ºC'),
	(247831, 119, '2014-03-15 01:10:25.000000', 'temperatura', 402.0000, 'ºC'),
	(247832, 119, '2014-03-15 01:10:26.000000', 'temperatura', 819.0000, 'ºC'),
	(247833, 119, '2014-03-15 01:10:27.000000', 'temperatura', 487.0000, 'ºC'),
	(247834, 119, '2014-03-15 01:10:28.000000', 'temperatura', 1178.0000, 'ºC'),
	(247835, 119, '2014-03-15 01:10:29.000000', 'temperatura', 832.0000, 'ºC'),
	(247836, 119, '2014-03-15 01:10:30.000000', 'temperatura', 624.0000, 'ºC'),
	(247837, 119, '2014-03-15 01:10:31.000000', 'temperatura', 625.0000, 'ºC'),
	(247838, 119, '2014-03-15 01:10:32.000000', 'temperatura', 55.0000, 'ºC'),
	(247839, 119, '2014-03-15 01:10:33.000000', 'temperatura', 798.0000, 'ºC'),
	(247840, 119, '2014-03-15 01:10:34.000000', 'temperatura', 227.0000, 'ºC'),
	(247841, 119, '2014-03-15 01:10:35.000000', 'temperatura', 1140.0000, 'ºC'),
	(247842, 119, '2014-03-15 01:10:36.000000', 'temperatura', 219.0000, 'ºC'),
	(247843, 119, '2014-03-15 01:10:37.000000', 'temperatura', 76.0000, 'ºC'),
	(247844, 119, '2014-03-15 01:10:38.000000', 'temperatura', 924.0000, 'ºC'),
	(247845, 119, '2014-03-15 01:10:39.000000', 'temperatura', 791.0000, 'ºC'),
	(247846, 119, '2014-03-15 01:10:40.000000', 'temperatura', 1183.0000, 'ºC'),
	(247847, 119, '2014-03-15 01:10:41.000000', 'temperatura', 1143.0000, 'ºC'),
	(247848, 119, '2014-03-15 01:10:42.000000', 'temperatura', 965.0000, 'ºC'),
	(247849, 119, '2014-03-15 01:10:43.000000', 'temperatura', 197.0000, 'ºC'),
	(247850, 119, '2014-03-15 01:10:44.000000', 'temperatura', 492.0000, 'ºC'),
	(247851, 119, '2014-03-15 01:10:45.000000', 'temperatura', 670.0000, 'ºC'),
	(247852, 119, '2014-03-15 01:10:46.000000', 'temperatura', 675.0000, 'ºC'),
	(247853, 119, '2014-03-15 01:10:47.000000', 'temperatura', 163.0000, 'ºC'),
	(247854, 119, '2014-03-15 01:10:48.000000', 'temperatura', 1191.0000, 'ºC'),
	(247855, 119, '2014-03-15 01:10:49.000000', 'temperatura', 669.0000, 'ºC'),
	(247856, 119, '2014-03-15 01:10:50.000000', 'temperatura', 969.0000, 'ºC'),
	(247857, 119, '2014-03-15 01:10:51.000000', 'temperatura', 441.0000, 'ºC'),
	(247858, 119, '2014-03-15 01:10:52.000000', 'temperatura', 499.0000, 'ºC'),
	(247859, 119, '2014-03-15 01:10:53.000000', 'temperatura', 1173.0000, 'ºC'),
	(247860, 119, '2014-03-15 01:10:54.000000', 'temperatura', 769.0000, 'ºC'),
	(247861, 119, '2014-03-15 01:10:55.000000', 'temperatura', 327.0000, 'ºC'),
	(247862, 119, '2014-03-15 01:10:56.000000', 'temperatura', 527.0000, 'ºC'),
	(247863, 119, '2014-03-15 01:10:57.000000', 'temperatura', 455.0000, 'ºC'),
	(247864, 119, '2014-03-15 01:10:58.000000', 'temperatura', 695.0000, 'ºC'),
	(247865, 119, '2014-03-15 01:10:59.000000', 'temperatura', 910.0000, 'ºC'),
	(247866, 119, '2014-03-15 01:11:00.000000', 'temperatura', 66.0000, 'ºC'),
	(247867, 119, '2014-03-15 01:11:01.000000', 'temperatura', 1199.0000, 'ºC'),
	(247868, 119, '2014-03-15 01:11:02.000000', 'temperatura', 999.0000, 'ºC'),
	(247869, 119, '2014-03-15 01:11:03.000000', 'temperatura', 197.0000, 'ºC'),
	(247870, 119, '2014-03-15 01:11:04.000000', 'temperatura', 390.0000, 'ºC'),
	(247871, 119, '2014-03-15 01:11:05.000000', 'temperatura', 157.0000, 'ºC'),
	(247872, 119, '2014-03-15 01:11:06.000000', 'temperatura', 817.0000, 'ºC'),
	(247873, 119, '2014-03-15 01:11:07.000000', 'temperatura', 14.0000, 'ºC'),
	(247874, 119, '2014-03-15 01:11:08.000000', 'temperatura', 19.0000, 'ºC'),
	(247875, 119, '2014-03-15 01:11:09.000000', 'temperatura', 53.0000, 'ºC'),
	(247876, 119, '2014-03-15 01:11:10.000000', 'temperatura', 210.0000, 'ºC'),
	(247877, 119, '2014-03-15 01:11:11.000000', 'temperatura', 890.0000, 'ºC'),
	(247878, 119, '2014-03-15 01:11:12.000000', 'temperatura', 220.0000, 'ºC'),
	(247879, 119, '2014-03-15 01:11:13.000000', 'temperatura', 830.0000, 'ºC'),
	(247880, 119, '2014-03-15 01:11:14.000000', 'temperatura', 1092.0000, 'ºC'),
	(247881, 119, '2014-03-15 01:11:15.000000', 'temperatura', 569.0000, 'ºC'),
	(247882, 119, '2014-03-15 01:11:16.000000', 'temperatura', 770.0000, 'ºC'),
	(247883, 119, '2014-03-15 01:11:17.000000', 'temperatura', 944.0000, 'ºC'),
	(247884, 119, '2014-03-15 01:11:18.000000', 'temperatura', 10.0000, 'ºC'),
	(247885, 119, '2014-03-15 01:11:19.000000', 'temperatura', 818.0000, 'ºC'),
	(247886, 119, '2014-03-15 01:11:20.000000', 'temperatura', 460.0000, 'ºC'),
	(247887, 119, '2014-03-15 01:11:21.000000', 'temperatura', 1049.0000, 'ºC'),
	(247888, 119, '2014-03-15 01:11:22.000000', 'temperatura', 265.0000, 'ºC'),
	(247889, 119, '2014-03-15 01:11:23.000000', 'temperatura', 577.0000, 'ºC'),
	(247890, 119, '2014-03-15 01:11:24.000000', 'temperatura', 890.0000, 'ºC'),
	(247891, 119, '2014-03-15 01:11:25.000000', 'temperatura', 322.0000, 'ºC'),
	(247892, 119, '2014-03-15 01:11:26.000000', 'temperatura', 141.0000, 'ºC'),
	(247893, 119, '2014-03-15 01:11:27.000000', 'temperatura', 940.0000, 'ºC'),
	(247894, 119, '2014-03-15 01:11:28.000000', 'temperatura', 675.0000, 'ºC'),
	(247895, 119, '2014-03-15 01:11:29.000000', 'temperatura', 557.0000, 'ºC'),
	(247896, 119, '2014-03-15 01:11:30.000000', 'temperatura', 762.0000, 'ºC'),
	(247897, 119, '2014-03-15 01:11:31.000000', 'temperatura', 938.0000, 'ºC'),
	(247898, 119, '2014-03-15 01:11:32.000000', 'temperatura', 5.0000, 'ºC'),
	(247899, 119, '2014-03-15 01:11:33.000000', 'temperatura', 812.0000, 'ºC'),
	(247900, 119, '2014-03-15 01:11:34.000000', 'temperatura', 444.0000, 'ºC'),
	(247901, 119, '2014-03-15 01:11:35.000000', 'temperatura', 986.0000, 'ºC'),
	(247902, 119, '2014-03-15 01:11:36.000000', 'temperatura', 1196.0000, 'ºC'),
	(247903, 119, '2014-03-15 01:11:37.000000', 'temperatura', 624.0000, 'ºC'),
	(247904, 119, '2014-03-15 01:11:38.000000', 'temperatura', 731.0000, 'ºC'),
	(247905, 119, '2014-03-15 01:11:39.000000', 'temperatura', 585.0000, 'ºC'),
	(247906, 119, '2014-03-15 01:11:40.000000', 'temperatura', 730.0000, 'ºC'),
	(247907, 119, '2014-03-15 01:11:41.000000', 'temperatura', 697.0000, 'ºC'),
	(247908, 119, '2014-03-15 01:11:42.000000', 'temperatura', 96.0000, 'ºC'),
	(247909, 119, '2014-03-15 01:11:43.000000', 'temperatura', 788.0000, 'ºC'),
	(247910, 119, '2014-03-15 01:11:44.000000', 'temperatura', 53.0000, 'ºC'),
	(247911, 119, '2014-03-15 01:11:45.000000', 'temperatura', 300.0000, 'ºC'),
	(247912, 119, '2014-03-15 01:11:46.000000', 'temperatura', 144.0000, 'ºC'),
	(247913, 119, '2014-03-15 01:11:47.000000', 'temperatura', 1019.0000, 'ºC'),
	(247914, 119, '2014-03-15 01:11:48.000000', 'temperatura', 1065.0000, 'ºC'),
	(247915, 119, '2014-03-15 01:11:49.000000', 'temperatura', 1067.0000, 'ºC'),
	(247916, 119, '2014-03-15 01:11:50.000000', 'temperatura', 942.0000, 'ºC'),
	(247917, 119, '2014-03-15 01:11:51.000000', 'temperatura', 310.0000, 'ºC'),
	(247918, 119, '2014-03-15 01:11:52.000000', 'temperatura', 1125.0000, 'ºC'),
	(247919, 119, '2014-03-15 01:11:53.000000', 'temperatura', 1095.0000, 'ºC'),
	(247920, 119, '2014-03-15 01:11:54.000000', 'temperatura', 899.0000, 'ºC'),
	(247921, 119, '2014-03-15 01:11:55.000000', 'temperatura', 12.0000, 'ºC'),
	(247922, 119, '2014-03-15 01:11:56.000000', 'temperatura', 964.0000, 'ºC'),
	(247923, 119, '2014-03-15 01:11:57.000000', 'temperatura', 1182.0000, 'ºC'),
	(247924, 119, '2014-03-15 01:11:58.000000', 'temperatura', 621.0000, 'ºC'),
	(247925, 119, '2014-03-15 01:11:59.000000', 'temperatura', 758.0000, 'ºC'),
	(247926, 119, '2014-03-15 01:12:00.000000', 'temperatura', 730.0000, 'ºC'),
	(247927, 119, '2014-03-15 01:12:01.000000', 'temperatura', 175.0000, 'ºC'),
	(247928, 119, '2014-03-15 01:12:02.000000', 'temperatura', 1086.0000, 'ºC'),
	(247929, 119, '2014-03-15 01:12:03.000000', 'temperatura', 104.0000, 'ºC'),
	(247930, 119, '2014-03-15 01:12:04.000000', 'temperatura', 865.0000, 'ºC'),
	(247931, 119, '2014-03-15 01:12:05.000000', 'temperatura', 413.0000, 'ºC'),
	(247932, 119, '2014-03-15 01:12:06.000000', 'temperatura', 670.0000, 'ºC'),
	(247933, 119, '2014-03-15 01:12:07.000000', 'temperatura', 911.0000, 'ºC'),
	(247934, 119, '2014-03-15 01:12:08.000000', 'temperatura', 146.0000, 'ºC'),
	(247935, 119, '2014-03-15 01:12:09.000000', 'temperatura', 398.0000, 'ºC'),
	(247936, 119, '2014-03-15 01:12:10.000000', 'temperatura', 353.0000, 'ºC'),
	(247937, 119, '2014-03-15 01:12:11.000000', 'temperatura', 573.0000, 'ºC'),
	(247938, 119, '2014-03-15 01:12:12.000000', 'temperatura', 603.0000, 'ºC'),
	(247939, 119, '2014-03-15 01:12:13.000000', 'temperatura', 99.0000, 'ºC'),
	(247940, 119, '2014-03-15 01:12:14.000000', 'temperatura', 1086.0000, 'ºC'),
	(247941, 119, '2014-03-15 01:12:15.000000', 'temperatura', 333.0000, 'ºC'),
	(247942, 119, '2014-03-15 01:12:16.000000', 'temperatura', 809.0000, 'ºC'),
	(247943, 119, '2014-03-15 01:12:17.000000', 'temperatura', 645.0000, 'ºC'),
	(247944, 119, '2014-03-15 01:12:18.000000', 'temperatura', 798.0000, 'ºC'),
	(247945, 119, '2014-03-15 01:12:19.000000', 'temperatura', 857.0000, 'ºC'),
	(247946, 119, '2014-03-15 01:12:20.000000', 'temperatura', 692.0000, 'ºC'),
	(247947, 119, '2014-03-15 01:12:21.000000', 'temperatura', 887.0000, 'ºC'),
	(247948, 119, '2014-03-15 01:12:22.000000', 'temperatura', 1160.0000, 'ºC'),
	(247949, 119, '2014-03-15 01:12:23.000000', 'temperatura', 742.0000, 'ºC'),
	(247950, 119, '2014-03-15 01:12:24.000000', 'temperatura', 229.0000, 'ºC'),
	(247951, 119, '2014-03-15 01:12:25.000000', 'temperatura', 119.0000, 'ºC'),
	(247952, 119, '2014-03-15 01:12:26.000000', 'temperatura', 1108.0000, 'ºC'),
	(247953, 119, '2014-03-15 01:12:27.000000', 'temperatura', 385.0000, 'ºC'),
	(247954, 119, '2014-03-15 01:12:28.000000', 'temperatura', 1000.0000, 'ºC'),
	(247955, 119, '2014-03-15 01:12:29.000000', 'temperatura', 246.0000, 'ºC'),
	(247956, 119, '2014-03-15 01:12:30.000000', 'temperatura', 630.0000, 'ºC'),
	(247957, 119, '2014-03-15 01:12:31.000000', 'temperatura', 12.0000, 'ºC'),
	(247958, 119, '2014-03-15 01:12:32.000000', 'temperatura', 570.0000, 'ºC'),
	(247959, 119, '2014-03-15 01:12:33.000000', 'temperatura', 417.0000, 'ºC'),
	(247960, 119, '2014-03-15 01:12:34.000000', 'temperatura', 373.0000, 'ºC'),
	(247961, 119, '2014-03-15 01:12:35.000000', 'temperatura', 617.0000, 'ºC'),
	(247962, 119, '2014-03-15 01:12:36.000000', 'temperatura', 767.0000, 'ºC'),
	(247963, 119, '2014-03-15 01:12:37.000000', 'temperatura', 784.0000, 'ºC'),
	(247964, 119, '2014-03-15 01:12:38.000000', 'temperatura', 420.0000, 'ºC'),
	(247965, 119, '2014-03-15 01:12:39.000000', 'temperatura', 947.0000, 'ºC'),
	(247966, 119, '2014-03-15 01:12:40.000000', 'temperatura', 1075.0000, 'ºC'),
	(247967, 119, '2014-03-15 01:12:41.000000', 'temperatura', 137.0000, 'ºC'),
	(247968, 119, '2014-03-15 01:12:42.000000', 'temperatura', 1059.0000, 'ºC'),
	(247969, 119, '2014-03-15 01:12:43.000000', 'temperatura', 84.0000, 'ºC'),
	(247970, 119, '2014-03-15 01:12:44.000000', 'temperatura', 846.0000, 'ºC'),
	(247971, 119, '2014-03-15 01:12:45.000000', 'temperatura', 377.0000, 'ºC'),
	(247972, 119, '2014-03-15 01:12:46.000000', 'temperatura', 550.0000, 'ºC'),
	(247973, 119, '2014-03-15 01:12:47.000000', 'temperatura', 416.0000, 'ºC'),
	(247974, 119, '2014-03-15 01:12:48.000000', 'temperatura', 431.0000, 'ºC'),
	(247975, 119, '2014-03-15 01:12:49.000000', 'temperatura', 908.0000, 'ºC'),
	(247976, 119, '2014-03-15 01:12:50.000000', 'temperatura', 847.0000, 'ºC'),
	(247977, 119, '2014-03-15 01:12:51.000000', 'temperatura', 310.0000, 'ºC'),
	(247978, 119, '2014-03-15 01:12:52.000000', 'temperatura', 210.0000, 'ºC'),
	(247979, 119, '2014-03-15 01:12:53.000000', 'temperatura', 120.0000, 'ºC'),
	(247980, 119, '2014-03-15 01:12:54.000000', 'temperatura', 1173.0000, 'ºC'),
	(247981, 119, '2014-03-15 01:12:55.000000', 'temperatura', 702.0000, 'ºC'),
	(247982, 119, '2014-03-15 01:12:56.000000', 'temperatura', 1194.0000, 'ºC'),
	(247983, 119, '2014-03-15 01:12:57.000000', 'temperatura', 265.0000, 'ºC'),
	(247984, 119, '2014-03-15 01:12:58.000000', 'temperatura', 142.0000, 'ºC'),
	(247985, 119, '2014-03-15 01:12:59.000000', 'temperatura', 1117.0000, 'ºC'),
	(247986, 119, '2014-03-15 01:13:00.000000', 'temperatura', 360.0000, 'ºC'),
	(247987, 119, '2014-03-15 01:13:01.000000', 'temperatura', 849.0000, 'ºC'),
	(247988, 119, '2014-03-15 01:13:02.000000', 'temperatura', 767.0000, 'ºC'),
	(247989, 119, '2014-03-15 01:13:03.000000', 'temperatura', 86.0000, 'ºC'),
	(247990, 119, '2014-03-15 01:13:04.000000', 'temperatura', 532.0000, 'ºC'),
	(247991, 119, '2014-03-15 01:13:05.000000', 'temperatura', 1.0000, 'ºC'),
	(247992, 119, '2014-03-15 01:13:06.000000', 'temperatura', 809.0000, 'ºC'),
	(247993, 119, '2014-03-15 01:13:07.000000', 'temperatura', 442.0000, 'ºC'),
	(247994, 119, '2014-03-15 01:13:08.000000', 'temperatura', 985.0000, 'ºC'),
	(247995, 119, '2014-03-15 01:13:09.000000', 'temperatura', 0.0000, 'ºC'),
	(247996, 119, '2014-03-15 01:13:10.000000', 'temperatura', 645.0000, 'ºC'),
	(247997, 119, '2014-03-15 01:13:11.000000', 'temperatura', 824.0000, 'ºC'),
	(247998, 119, '2014-03-15 01:13:12.000000', 'temperatura', 984.0000, 'ºC'),
	(247999, 119, '2014-03-15 01:13:13.000000', 'temperatura', 52.0000, 'ºC'),
	(248000, 119, '2014-03-15 01:13:14.000000', 'temperatura', 906.0000, 'ºC'),
	(248001, 119, '2014-03-15 01:13:15.000000', 'temperatura', 776.0000, 'ºC'),
	(248002, 119, '2014-03-15 01:13:16.000000', 'temperatura', 1163.0000, 'ºC'),
	(248003, 119, '2014-03-15 01:13:17.000000', 'temperatura', 1085.0000, 'ºC'),
	(248004, 119, '2014-03-15 01:13:18.000000', 'temperatura', 740.0000, 'ºC'),
	(248005, 119, '2014-03-15 01:13:19.000000', 'temperatura', 443.0000, 'ºC'),
	(248006, 119, '2014-03-15 01:13:20.000000', 'temperatura', 1197.0000, 'ºC'),
	(248007, 119, '2014-03-15 01:13:21.000000', 'temperatura', 1055.0000, 'ºC'),
	(248008, 119, '2014-03-15 01:13:22.000000', 'temperatura', 484.0000, 'ºC'),
	(248009, 119, '2014-03-15 01:13:23.000000', 'temperatura', 456.0000, 'ºC'),
	(248010, 119, '2014-03-15 01:13:24.000000', 'temperatura', 830.0000, 'ºC'),
	(248011, 119, '2014-03-15 01:13:25.000000', 'temperatura', 380.0000, 'ºC'),
	(248012, 119, '2014-03-15 01:13:26.000000', 'temperatura', 611.0000, 'ºC'),
	(248013, 119, '2014-03-15 01:13:27.000000', 'temperatura', 718.0000, 'ºC'),
	(248014, 119, '2014-03-15 01:13:28.000000', 'temperatura', 554.0000, 'ºC'),
	(248015, 119, '2014-03-15 01:13:29.000000', 'temperatura', 618.0000, 'ºC'),
	(248016, 119, '2014-03-15 01:13:30.000000', 'temperatura', 227.0000, 'ºC'),
	(248017, 119, '2014-03-15 01:13:31.000000', 'temperatura', 481.0000, 'ºC'),
	(248018, 119, '2014-03-15 01:13:32.000000', 'temperatura', 525.0000, 'ºC'),
	(248019, 119, '2014-03-15 01:13:33.000000', 'temperatura', 1184.0000, 'ºC'),
	(248020, 119, '2014-03-15 01:13:34.000000', 'temperatura', 746.0000, 'ºC'),
	(248021, 119, '2014-03-15 01:13:35.000000', 'temperatura', 176.0000, 'ºC'),
	(248022, 119, '2014-03-15 01:13:36.000000', 'temperatura', 1043.0000, 'ºC'),
	(248023, 119, '2014-03-15 01:13:37.000000', 'temperatura', 1086.0000, 'ºC'),
	(248024, 119, '2014-03-15 01:13:38.000000', 'temperatura', 1102.0000, 'ºC'),
	(248025, 119, '2014-03-15 01:13:39.000000', 'temperatura', 1054.0000, 'ºC'),
	(248026, 119, '2014-03-15 01:13:40.000000', 'temperatura', 764.0000, 'ºC'),
	(248027, 119, '2014-03-15 01:13:41.000000', 'temperatura', 660.0000, 'ºC'),
	(248028, 119, '2014-03-15 01:13:42.000000', 'temperatura', 1008.0000, 'ºC'),
	(248029, 119, '2014-03-15 01:13:43.000000', 'temperatura', 659.0000, 'ºC'),
	(248030, 119, '2014-03-15 01:13:44.000000', 'temperatura', 271.0000, 'ºC'),
	(248031, 119, '2014-03-15 01:13:45.000000', 'temperatura', 577.0000, 'ºC'),
	(248032, 119, '2014-03-15 01:13:46.000000', 'temperatura', 875.0000, 'ºC'),
	(248033, 119, '2014-03-15 01:13:47.000000', 'temperatura', 245.0000, 'ºC'),
	(248034, 119, '2014-03-15 01:13:48.000000', 'temperatura', 1000.0000, 'ºC'),
	(248035, 119, '2014-03-15 01:13:49.000000', 'temperatura', 666.0000, 'ºC'),
	(248036, 119, '2014-03-15 01:13:50.000000', 'temperatura', 332.0000, 'ºC'),
	(248037, 119, '2014-03-15 01:13:51.000000', 'temperatura', 860.0000, 'ºC'),
	(248038, 119, '2014-03-15 01:13:52.000000', 'temperatura', 905.0000, 'ºC'),
	(248039, 119, '2014-03-15 01:13:53.000000', 'temperatura', 746.0000, 'ºC'),
	(248040, 119, '2014-03-15 01:13:54.000000', 'temperatura', 1013.0000, 'ºC'),
	(248041, 119, '2014-03-15 01:13:55.000000', 'temperatura', 430.0000, 'ºC'),
	(248042, 119, '2014-03-15 01:13:56.000000', 'temperatura', 311.0000, 'ºC'),
	(248043, 119, '2014-03-15 01:13:57.000000', 'temperatura', 266.0000, 'ºC'),
	(248044, 119, '2014-03-15 01:13:58.000000', 'temperatura', 396.0000, 'ºC'),
	(248045, 119, '2014-03-15 01:13:59.000000', 'temperatura', 1183.0000, 'ºC'),
	(248046, 119, '2014-03-15 01:14:00.000000', 'temperatura', 1126.0000, 'ºC'),
	(248047, 119, '2014-03-15 01:14:01.000000', 'temperatura', 884.0000, 'ºC'),
	(248048, 119, '2014-03-15 01:14:02.000000', 'temperatura', 1042.0000, 'ºC'),
	(248049, 119, '2014-03-15 01:14:03.000000', 'temperatura', 157.0000, 'ºC'),
	(248050, 119, '2014-03-15 01:14:04.000000', 'temperatura', 59.0000, 'ºC'),
	(248051, 119, '2014-03-15 01:14:05.000000', 'temperatura', 1025.0000, 'ºC'),
	(248052, 119, '2014-03-15 01:14:06.000000', 'temperatura', 151.0000, 'ºC'),
	(248053, 119, '2014-03-15 01:14:07.000000', 'temperatura', 79.0000, 'ºC'),
	(248054, 119, '2014-03-15 01:14:08.000000', 'temperatura', 1141.0000, 'ºC'),
	(248055, 119, '2014-03-15 01:14:09.000000', 'temperatura', 669.0000, 'ºC'),
	(248056, 119, '2014-03-15 01:14:10.000000', 'temperatura', 1122.0000, 'ºC'),
	(248057, 119, '2014-03-15 01:14:11.000000', 'temperatura', 5.0000, 'ºC'),
	(248058, 119, '2014-03-15 01:14:12.000000', 'temperatura', 260.0000, 'ºC'),
	(248059, 119, '2014-03-15 01:14:13.000000', 'temperatura', 86.0000, 'ºC'),
	(248060, 119, '2014-03-15 01:14:14.000000', 'temperatura', 852.0000, 'ºC'),
	(248061, 119, '2014-03-15 01:14:15.000000', 'temperatura', 400.0000, 'ºC'),
	(248062, 119, '2014-03-15 01:14:16.000000', 'temperatura', 643.0000, 'ºC'),
	(248063, 119, '2014-03-15 01:14:17.000000', 'temperatura', 819.0000, 'ºC'),
	(248064, 119, '2014-03-15 01:14:18.000000', 'temperatura', 964.0000, 'ºC'),
	(248065, 119, '2014-03-15 01:14:19.000000', 'temperatura', 1164.0000, 'ºC'),
	(248066, 119, '2014-03-15 01:14:20.000000', 'temperatura', 530.0000, 'ºC'),
	(248067, 119, '2014-03-15 01:14:21.000000', 'temperatura', 358.0000, 'ºC'),
	(248068, 119, '2014-03-15 01:14:22.000000', 'temperatura', 199.0000, 'ºC'),
	(248069, 119, '2014-03-15 01:14:23.000000', 'temperatura', 1122.0000, 'ºC'),
	(248070, 119, '2014-03-15 01:14:24.000000', 'temperatura', 214.0000, 'ºC'),
	(248071, 119, '2014-03-15 01:14:25.000000', 'temperatura', 105.0000, 'ºC'),
	(248072, 119, '2014-03-15 01:14:26.000000', 'temperatura', 1082.0000, 'ºC'),
	(248073, 119, '2014-03-15 01:14:27.000000', 'temperatura', 297.0000, 'ºC'),
	(248074, 119, '2014-03-15 01:14:28.000000', 'temperatura', 639.0000, 'ºC'),
	(248075, 119, '2014-03-15 01:14:29.000000', 'temperatura', 1106.0000, 'ºC'),
	(248076, 119, '2014-03-15 01:14:30.000000', 'temperatura', 13.0000, 'ºC'),
	(248077, 119, '2014-03-15 01:14:31.000000', 'temperatura', 347.0000, 'ºC'),
	(248078, 119, '2014-03-15 01:14:32.000000', 'temperatura', 498.0000, 'ºC'),
	(248079, 119, '2014-03-15 01:14:33.000000', 'temperatura', 249.0000, 'ºC'),
	(248080, 119, '2014-03-15 01:14:34.000000', 'temperatura', 951.0000, 'ºC'),
	(248081, 119, '2014-03-15 01:14:35.000000', 'temperatura', 410.0000, 'ºC'),
	(248082, 119, '2014-03-15 01:14:36.000000', 'temperatura', 398.0000, 'ºC'),
	(248083, 119, '2014-03-15 01:14:37.000000', 'temperatura', 758.0000, 'ºC'),
	(248084, 119, '2014-03-15 01:14:38.000000', 'temperatura', 196.0000, 'ºC'),
	(248085, 119, '2014-03-15 01:14:39.000000', 'temperatura', 1109.0000, 'ºC'),
	(248086, 119, '2014-03-15 01:14:40.000000', 'temperatura', 158.0000, 'ºC'),
	(248087, 119, '2014-03-15 01:14:41.000000', 'temperatura', 1060.0000, 'ºC'),
	(248088, 119, '2014-03-15 01:14:42.000000', 'temperatura', 30.0000, 'ºC'),
	(248089, 119, '2014-03-15 01:14:43.000000', 'temperatura', 569.0000, 'ºC'),
	(248090, 119, '2014-03-15 01:14:44.000000', 'temperatura', 355.0000, 'ºC'),
	(248091, 119, '2014-03-15 01:14:45.000000', 'temperatura', 69.0000, 'ºC'),
	(248092, 119, '2014-03-15 01:14:46.000000', 'temperatura', 480.0000, 'ºC'),
	(248093, 119, '2014-03-15 01:14:47.000000', 'temperatura', 993.0000, 'ºC'),
	(248094, 119, '2014-03-15 01:14:48.000000', 'temperatura', 1127.0000, 'ºC'),
	(248095, 119, '2014-03-15 01:14:49.000000', 'temperatura', 254.0000, 'ºC'),
	(248096, 119, '2014-03-15 01:14:50.000000', 'temperatura', 290.0000, 'ºC'),
	(248097, 119, '2014-03-15 01:14:51.000000', 'temperatura', 688.0000, 'ºC'),
	(248098, 119, '2014-03-15 01:14:52.000000', 'temperatura', 171.0000, 'ºC'),
	(248099, 119, '2014-03-15 01:14:53.000000', 'temperatura', 1192.0000, 'ºC'),
	(248100, 119, '2014-03-15 01:14:54.000000', 'temperatura', 648.0000, 'ºC'),
	(248101, 119, '2014-03-15 01:14:55.000000', 'temperatura', 865.0000, 'ºC'),
	(248102, 119, '2014-03-15 01:14:56.000000', 'temperatura', 1181.0000, 'ºC'),
	(248103, 119, '2014-03-15 01:14:57.000000', 'temperatura', 911.0000, 'ºC'),
	(248104, 119, '2014-03-15 01:14:58.000000', 'temperatura', 1013.0000, 'ºC'),
	(248105, 119, '2014-03-15 01:14:59.000000', 'temperatura', 1133.0000, 'ºC'),
	(248106, 119, '2014-03-15 01:15:00.000000', 'temperatura', 226.0000, 'ºC'),
	(248107, 119, '2014-03-15 01:15:01.000000', 'temperatura', 131.0000, 'ºC'),
	(248108, 119, '2014-03-15 01:15:02.000000', 'temperatura', 1178.0000, 'ºC'),
	(248109, 119, '2014-03-15 01:15:03.000000', 'temperatura', 698.0000, 'ºC'),
	(248110, 119, '2014-03-15 01:15:04.000000', 'temperatura', 1155.0000, 'ºC'),
	(248111, 119, '2014-03-15 01:15:05.000000', 'temperatura', 81.0000, 'ºC'),
	(248112, 119, '2014-03-15 01:15:06.000000', 'temperatura', 542.0000, 'ºC'),
	(248113, 119, '2014-03-15 01:15:07.000000', 'temperatura', 66.0000, 'ºC'),
	(248114, 119, '2014-03-15 01:15:08.000000', 'temperatura', 1104.0000, 'ºC'),
	(248115, 119, '2014-03-15 01:15:09.000000', 'temperatura', 523.0000, 'ºC'),
	(248116, 119, '2014-03-15 01:15:10.000000', 'temperatura', 505.0000, 'ºC'),
	(248117, 119, '2014-03-15 01:15:11.000000', 'temperatura', 955.0000, 'ºC'),
	(248118, 119, '2014-03-15 01:15:12.000000', 'temperatura', 860.0000, 'ºC'),
	(248119, 119, '2014-03-15 01:15:13.000000', 'temperatura', 234.0000, 'ºC'),
	(248120, 119, '2014-03-15 01:15:14.000000', 'temperatura', 994.0000, 'ºC'),
	(248121, 119, '2014-03-15 01:15:15.000000', 'temperatura', 667.0000, 'ºC'),
	(248122, 119, '2014-03-15 01:15:16.000000', 'temperatura', 354.0000, 'ºC'),
	(248123, 119, '2014-03-15 01:15:17.000000', 'temperatura', 971.0000, 'ºC'),
	(248124, 119, '2014-03-15 01:15:18.000000', 'temperatura', 191.0000, 'ºC'),
	(248125, 119, '2014-03-15 01:15:19.000000', 'temperatura', 442.0000, 'ºC'),
	(248126, 119, '2014-03-15 01:15:20.000000', 'temperatura', 438.0000, 'ºC'),
	(248127, 119, '2014-03-15 01:15:21.000000', 'temperatura', 865.0000, 'ºC'),
	(248128, 119, '2014-03-15 01:15:22.000000', 'temperatura', 611.0000, 'ºC'),
	(248129, 119, '2014-03-15 01:15:23.000000', 'temperatura', 461.0000, 'ºC'),
	(248130, 119, '2014-03-15 01:15:24.000000', 'temperatura', 474.0000, 'ºC'),
	(248131, 119, '2014-03-15 01:15:25.000000', 'temperatura', 985.0000, 'ºC'),
	(248132, 119, '2014-03-15 01:15:26.000000', 'temperatura', 1106.0000, 'ºC'),
	(248133, 119, '2014-03-15 01:15:27.000000', 'temperatura', 175.0000, 'ºC'),
	(248134, 119, '2014-03-15 01:15:28.000000', 'temperatura', 1156.0000, 'ºC'),
	(248135, 119, '2014-03-15 01:15:29.000000', 'temperatura', 456.0000, 'ºC'),
	(248136, 119, '2014-03-15 01:15:30.000000', 'temperatura', 12.0000, 'ºC'),
	(248137, 119, '2014-03-15 01:15:31.000000', 'temperatura', 1093.0000, 'ºC'),
	(248138, 119, '2014-03-15 01:15:32.000000', 'temperatura', 628.0000, 'ºC'),
	(248139, 119, '2014-03-15 01:15:33.000000', 'temperatura', 1063.0000, 'ºC'),
	(248140, 119, '2014-03-15 01:15:34.000000', 'temperatura', 1032.0000, 'ºC'),
	(248141, 119, '2014-03-15 01:15:35.000000', 'temperatura', 770.0000, 'ºC'),
	(248142, 119, '2014-03-15 01:15:36.000000', 'temperatura', 756.0000, 'ºC'),
	(248143, 119, '2014-03-15 01:15:37.000000', 'temperatura', 268.0000, 'ºC'),
	(248144, 119, '2014-03-15 01:15:38.000000', 'temperatura', 275.0000, 'ºC'),
	(248145, 119, '2014-03-15 01:15:39.000000', 'temperatura', 570.0000, 'ºC'),
	(248146, 119, '2014-03-15 01:15:40.000000', 'temperatura', 825.0000, 'ºC'),
	(248147, 119, '2014-03-15 01:15:41.000000', 'temperatura', 18.0000, 'ºC'),
	(248148, 119, '2014-03-15 01:15:42.000000', 'temperatura', 14.0000, 'ºC'),
	(248149, 119, '2014-03-15 01:15:43.000000', 'temperatura', 17.0000, 'ºC'),
	(248150, 119, '2014-03-15 01:15:44.000000', 'temperatura', 42.0000, 'ºC'),
	(248151, 119, '2014-03-15 01:15:45.000000', 'temperatura', 162.0000, 'ºC'),
	(248152, 119, '2014-03-15 01:15:46.000000', 'temperatura', 685.0000, 'ºC'),
	(248153, 119, '2014-03-15 01:15:47.000000', 'temperatura', 540.0000, 'ºC'),
	(248154, 119, '2014-03-15 01:15:48.000000', 'temperatura', 644.0000, 'ºC'),
	(248155, 119, '2014-03-15 01:15:49.000000', 'temperatura', 401.0000, 'ºC'),
	(248156, 119, '2014-03-15 01:15:50.000000', 'temperatura', 75.0000, 'ºC'),
	(248157, 119, '2014-03-15 01:15:51.000000', 'temperatura', 371.0000, 'ºC'),
	(248158, 119, '2014-03-15 01:15:52.000000', 'temperatura', 431.0000, 'ºC'),
	(248159, 119, '2014-03-15 01:15:53.000000', 'temperatura', 1042.0000, 'ºC'),
	(248160, 119, '2014-03-15 01:15:54.000000', 'temperatura', 319.0000, 'ºC'),
	(248161, 119, '2014-03-15 01:15:55.000000', 'temperatura', 869.0000, 'ºC'),
	(248162, 119, '2014-03-15 01:15:56.000000', 'temperatura', 989.0000, 'ºC'),
	(248163, 119, '2014-03-15 01:15:57.000000', 'temperatura', 1139.0000, 'ºC'),
	(248164, 119, '2014-03-15 01:15:58.000000', 'temperatura', 328.0000, 'ºC'),
	(248165, 119, '2014-03-15 01:15:59.000000', 'temperatura', 625.0000, 'ºC'),
	(248166, 119, '2014-03-15 01:16:00.000000', 'temperatura', 940.0000, 'ºC'),
	(248167, 119, '2014-03-15 01:16:01.000000', 'temperatura', 424.0000, 'ºC'),
	(248168, 119, '2014-03-15 01:16:02.000000', 'temperatura', 503.0000, 'ºC'),
	(248169, 119, '2014-03-15 01:16:03.000000', 'temperatura', 42.0000, 'ºC'),
	(248170, 119, '2014-03-15 01:16:04.000000', 'temperatura', 1102.0000, 'ºC'),
	(248171, 119, '2014-03-15 01:16:05.000000', 'temperatura', 584.0000, 'ºC'),
	(248172, 119, '2014-03-15 01:16:06.000000', 'temperatura', 815.0000, 'ºC'),
	(248173, 119, '2014-03-15 01:16:07.000000', 'temperatura', 1125.0000, 'ºC'),
	(248174, 119, '2014-03-15 01:16:08.000000', 'temperatura', 779.0000, 'ºC'),
	(248175, 119, '2014-03-15 01:16:09.000000', 'temperatura', 523.0000, 'ºC'),
	(248176, 119, '2014-03-15 01:16:10.000000', 'temperatura', 276.0000, 'ºC'),
	(248177, 119, '2014-03-15 01:16:11.000000', 'temperatura', 1010.0000, 'ºC'),
	(248178, 119, '2014-03-15 01:16:12.000000', 'temperatura', 626.0000, 'ºC'),
	(248179, 119, '2014-03-15 01:16:13.000000', 'temperatura', 97.0000, 'ºC'),
	(248180, 119, '2014-03-15 01:16:14.000000', 'temperatura', 1011.0000, 'ºC'),
	(248181, 119, '2014-03-15 01:16:15.000000', 'temperatura', 1162.0000, 'ºC'),
	(248182, 119, '2014-03-15 01:16:16.000000', 'temperatura', 376.0000, 'ºC'),
	(248183, 119, '2014-03-15 01:16:17.000000', 'temperatura', 797.0000, 'ºC'),
	(248184, 119, '2014-03-15 01:16:18.000000', 'temperatura', 459.0000, 'ºC'),
	(248185, 119, '2014-03-15 01:16:19.000000', 'temperatura', 1103.0000, 'ºC'),
	(248186, 119, '2014-03-15 01:16:20.000000', 'temperatura', 538.0000, 'ºC'),
	(248187, 119, '2014-03-15 01:16:21.000000', 'temperatura', 581.0000, 'ºC'),
	(248188, 119, '2014-03-15 01:16:22.000000', 'temperatura', 90.0000, 'ºC'),
	(248189, 119, '2014-03-15 01:16:23.000000', 'temperatura', 1110.0000, 'ºC'),
	(248190, 119, '2014-03-15 01:16:24.000000', 'temperatura', 478.0000, 'ºC'),
	(248191, 119, '2014-03-15 01:16:25.000000', 'temperatura', 263.0000, 'ºC'),
	(248192, 119, '2014-03-15 01:16:26.000000', 'temperatura', 1081.0000, 'ºC'),
	(248193, 119, '2014-03-15 01:16:27.000000', 'temperatura', 1018.0000, 'ºC'),
	(248194, 119, '2014-03-15 01:16:28.000000', 'temperatura', 644.0000, 'ºC'),
	(248195, 119, '2014-03-15 01:16:29.000000', 'temperatura', 169.0000, 'ºC'),
	(248196, 119, '2014-03-15 01:16:30.000000', 'temperatura', 115.0000, 'ºC'),
	(248197, 119, '2014-03-15 01:16:31.000000', 'temperatura', 65.0000, 'ºC'),
	(248198, 119, '2014-03-15 01:16:32.000000', 'temperatura', 1182.0000, 'ºC'),
	(248199, 119, '2014-03-15 01:16:33.000000', 'temperatura', 916.0000, 'ºC'),
	(248200, 119, '2014-03-15 01:16:34.000000', 'temperatura', 1033.0000, 'ºC'),
	(248201, 119, '2014-03-15 01:16:35.000000', 'temperatura', 20.0000, 'ºC'),
	(248202, 119, '2014-03-15 01:16:36.000000', 'temperatura', 599.0000, 'ºC'),
	(248203, 119, '2014-03-15 01:16:37.000000', 'temperatura', 537.0000, 'ºC'),
	(248204, 119, '2014-03-15 01:16:38.000000', 'temperatura', 889.0000, 'ºC'),
	(248205, 119, '2014-03-15 01:16:39.000000', 'temperatura', 433.0000, 'ºC'),
	(248206, 119, '2014-03-15 01:16:40.000000', 'temperatura', 697.0000, 'ºC'),
	(248207, 119, '2014-03-15 01:16:41.000000', 'temperatura', 990.0000, 'ºC'),
	(248208, 119, '2014-03-15 01:16:42.000000', 'temperatura', 458.0000, 'ºC'),
	(248209, 119, '2014-03-15 01:16:43.000000', 'temperatura', 520.0000, 'ºC'),
	(248210, 119, '2014-03-15 01:16:44.000000', 'temperatura', 26.0000, 'ºC'),
	(248211, 119, '2014-03-15 01:16:45.000000', 'temperatura', 970.0000, 'ºC'),
	(248212, 119, '2014-03-15 01:16:46.000000', 'temperatura', 1171.0000, 'ºC'),
	(248213, 119, '2014-03-15 01:16:47.000000', 'temperatura', 548.0000, 'ºC'),
	(248214, 119, '2014-03-15 01:16:48.000000', 'temperatura', 428.0000, 'ºC'),
	(248215, 119, '2014-03-15 01:16:49.000000', 'temperatura', 496.0000, 'ºC'),
	(248216, 119, '2014-03-15 01:16:50.000000', 'temperatura', 1195.0000, 'ºC'),
	(248217, 119, '2014-03-15 01:16:51.000000', 'temperatura', 887.0000, 'ºC'),
	(248218, 119, '2014-03-15 01:16:52.000000', 'temperatura', 853.0000, 'ºC'),
	(248219, 119, '2014-03-15 01:16:53.000000', 'temperatura', 405.0000, 'ºC'),
	(248220, 119, '2014-03-15 01:16:54.000000', 'temperatura', 664.0000, 'ºC'),
	(248221, 119, '2014-03-15 01:16:55.000000', 'temperatura', 905.0000, 'ºC'),
	(248222, 119, '2014-03-15 01:16:56.000000', 'temperatura', 133.0000, 'ºC'),
	(248223, 119, '2014-03-15 01:16:57.000000', 'temperatura', 351.0000, 'ºC'),
	(248224, 119, '2014-03-15 01:16:58.000000', 'temperatura', 157.0000, 'ºC'),
	(248225, 119, '2014-03-15 01:16:59.000000', 'temperatura', 931.0000, 'ºC'),
	(248226, 119, '2014-03-15 01:17:00.000000', 'temperatura', 584.0000, 'ºC'),
	(248227, 119, '2014-03-15 01:17:01.000000', 'temperatura', 128.0000, 'ºC'),
	(248228, 119, '2014-03-15 01:17:02.000000', 'temperatura', 89.0000, 'ºC'),
	(248229, 119, '2014-03-15 01:17:03.000000', 'temperatura', 59.0000, 'ºC'),
	(248230, 119, '2014-03-15 01:17:04.000000', 'temperatura', 32.0000, 'ºC'),
	(248231, 119, '2014-03-15 01:17:05.000000', 'temperatura', 1183.0000, 'ºC'),
	(248232, 119, '2014-03-15 01:17:06.000000', 'temperatura', 1019.0000, 'ºC'),
	(248233, 119, '2014-03-15 01:17:07.000000', 'temperatura', 347.0000, 'ºC'),
	(248234, 119, '2014-03-15 01:17:08.000000', 'temperatura', 1079.0000, 'ºC'),
	(248235, 119, '2014-03-15 01:17:09.000000', 'temperatura', 755.0000, 'ºC'),
	(248236, 119, '2014-03-15 01:17:10.000000', 'temperatura', 539.0000, 'ºC'),
	(248237, 119, '2014-03-15 01:17:11.000000', 'temperatura', 429.0000, 'ºC'),
	(248238, 119, '2014-03-15 01:17:12.000000', 'temperatura', 530.0000, 'ºC'),
	(248239, 119, '2014-03-15 01:17:13.000000', 'temperatura', 163.0000, 'ºC'),
	(248240, 119, '2014-03-15 01:17:14.000000', 'temperatura', 424.0000, 'ºC'),
	(248241, 119, '2014-03-15 01:17:15.000000', 'temperatura', 433.0000, 'ºC'),
	(248242, 119, '2014-03-15 01:17:16.000000', 'temperatura', 892.0000, 'ºC'),
	(248243, 119, '2014-03-15 01:17:17.000000', 'temperatura', 761.0000, 'ºC'),
	(248244, 119, '2014-03-15 01:17:18.000000', 'temperatura', 1130.0000, 'ºC'),
	(248245, 119, '2014-03-15 01:17:19.000000', 'temperatura', 967.0000, 'ºC'),
	(248246, 119, '2014-03-15 01:17:20.000000', 'temperatura', 246.0000, 'ºC'),
	(248247, 119, '2014-03-15 01:17:21.000000', 'temperatura', 732.0000, 'ºC'),
	(248248, 119, '2014-03-15 01:17:22.000000', 'temperatura', 519.0000, 'ºC'),
	(248249, 119, '2014-03-15 01:17:23.000000', 'temperatura', 401.0000, 'ºC'),
	(248250, 119, '2014-03-15 01:17:24.000000', 'temperatura', 450.0000, 'ºC'),
	(248251, 119, '2014-03-15 01:17:25.000000', 'temperatura', 1047.0000, 'ºC'),
	(248252, 119, '2014-03-15 01:17:26.000000', 'temperatura', 286.0000, 'ºC'),
	(248253, 119, '2014-03-15 01:17:27.000000', 'temperatura', 688.0000, 'ºC'),
	(248254, 119, '2014-03-15 01:17:28.000000', 'temperatura', 185.0000, 'ºC'),
	(248255, 119, '2014-03-15 01:17:29.000000', 'temperatura', 61.0000, 'ºC'),
	(248256, 119, '2014-03-15 01:17:30.000000', 'temperatura', 948.0000, 'ºC'),
	(248257, 119, '2014-03-15 01:17:31.000000', 'temperatura', 959.0000, 'ºC'),
	(248258, 119, '2014-03-15 01:17:32.000000', 'temperatura', 752.0000, 'ºC'),
	(248259, 119, '2014-03-15 01:17:33.000000', 'temperatura', 883.0000, 'ºC'),
	(248260, 119, '2014-03-15 01:17:34.000000', 'temperatura', 958.0000, 'ºC'),
	(248261, 119, '2014-03-15 01:17:35.000000', 'temperatura', 943.0000, 'ºC'),
	(248262, 119, '2014-03-15 01:17:36.000000', 'temperatura', 643.0000, 'ºC'),
	(248263, 119, '2014-03-15 01:17:37.000000', 'temperatura', 383.0000, 'ºC'),
	(248264, 119, '2014-03-15 01:17:38.000000', 'temperatura', 1190.0000, 'ºC'),
	(248265, 119, '2014-03-15 01:17:39.000000', 'temperatura', 0.0000, 'ºC'),
	(248266, 119, '2014-03-15 01:17:40.000000', 'temperatura', 29.0000, 'ºC'),
	(248267, 119, '2014-03-15 01:17:41.000000', 'temperatura', 147.0000, 'ºC'),
	(248268, 119, '2014-03-15 01:17:42.000000', 'temperatura', 649.0000, 'ºC'),
	(248269, 119, '2014-03-15 01:17:43.000000', 'temperatura', 403.0000, 'ºC'),
	(248270, 119, '2014-03-15 01:17:44.000000', 'temperatura', 70.0000, 'ºC'),
	(248271, 119, '2014-03-15 01:17:45.000000', 'temperatura', 341.0000, 'ºC'),
	(248272, 119, '2014-03-15 01:17:46.000000', 'temperatura', 296.0000, 'ºC'),
	(248273, 119, '2014-03-15 01:17:47.000000', 'temperatura', 458.0000, 'ºC'),
	(248274, 119, '2014-03-15 01:17:48.000000', 'temperatura', 202.0000, 'ºC'),
	(248275, 119, '2014-03-15 01:17:49.000000', 'temperatura', 835.0000, 'ºC'),
	(248276, 119, '2014-03-15 01:17:50.000000', 'temperatura', 1169.0000, 'ºC'),
	(248277, 119, '2014-03-15 01:17:51.000000', 'temperatura', 942.0000, 'ºC'),
	(248278, 119, '2014-03-15 01:17:52.000000', 'temperatura', 3.0000, 'ºC'),
	(248279, 119, '2014-03-15 01:17:53.000000', 'temperatura', 789.0000, 'ºC'),
	(248280, 119, '2014-03-15 01:17:54.000000', 'temperatura', 338.0000, 'ºC'),
	(248281, 119, '2014-03-15 01:17:55.000000', 'temperatura', 524.0000, 'ºC'),
	(248282, 119, '2014-03-15 01:17:56.000000', 'temperatura', 406.0000, 'ºC'),
	(248283, 119, '2014-03-15 01:17:57.000000', 'temperatura', 458.0000, 'ºC'),
	(248284, 119, '2014-03-15 01:17:58.000000', 'temperatura', 1072.0000, 'ºC'),
	(248285, 119, '2014-03-15 01:17:59.000000', 'temperatura', 388.0000, 'ºC'),
	(248286, 119, '2014-03-15 01:18:00.000000', 'temperatura', 1125.0000, 'ºC'),
	(248287, 119, '2014-03-15 01:18:01.000000', 'temperatura', 861.0000, 'ºC'),
	(248288, 119, '2014-03-15 01:18:02.000000', 'temperatura', 930.0000, 'ºC'),
	(248289, 119, '2014-03-15 01:18:03.000000', 'temperatura', 867.0000, 'ºC'),
	(248290, 119, '2014-03-15 01:18:04.000000', 'temperatura', 347.0000, 'ºC'),
	(248291, 119, '2014-03-15 01:18:05.000000', 'temperatura', 332.0000, 'ºC'),
	(248292, 119, '2014-03-15 01:18:06.000000', 'temperatura', 623.0000, 'ºC'),
	(248293, 119, '2014-03-15 01:18:07.000000', 'temperatura', 916.0000, 'ºC'),
	(248294, 119, '2014-03-15 01:18:08.000000', 'temperatura', 314.0000, 'ºC'),
	(248295, 119, '2014-03-15 01:18:09.000000', 'temperatura', 24.0000, 'ºC'),
	(248296, 119, '2014-03-15 01:18:10.000000', 'temperatura', 376.0000, 'ºC'),
	(248297, 119, '2014-03-15 01:18:11.000000', 'temperatura', 609.0000, 'ºC'),
	(248298, 119, '2014-03-15 01:18:12.000000', 'temperatura', 715.0000, 'ºC'),
	(248299, 119, '2014-03-15 01:18:13.000000', 'temperatura', 552.0000, 'ºC'),
	(248300, 119, '2014-03-15 01:18:14.000000', 'temperatura', 616.0000, 'ºC'),
	(248301, 119, '2014-03-15 01:18:15.000000', 'temperatura', 223.0000, 'ºC'),
	(248302, 119, '2014-03-15 01:18:16.000000', 'temperatura', 466.0000, 'ºC'),
	(248303, 119, '2014-03-15 01:18:17.000000', 'temperatura', 464.0000, 'ºC'),
	(248304, 119, '2014-03-15 01:18:18.000000', 'temperatura', 922.0000, 'ºC'),
	(248305, 119, '2014-03-15 01:18:19.000000', 'temperatura', 819.0000, 'ºC'),
	(248306, 119, '2014-03-15 01:18:20.000000', 'temperatura', 127.0000, 'ºC'),
	(248307, 119, '2014-03-15 01:18:21.000000', 'temperatura', 582.0000, 'ºC'),
	(248308, 119, '2014-03-15 01:18:22.000000', 'temperatura', 127.0000, 'ºC'),
	(248309, 119, '2014-03-15 01:18:23.000000', 'temperatura', 91.0000, 'ºC'),
	(248310, 119, '2014-03-15 01:18:24.000000', 'temperatura', 72.0000, 'ºC'),
	(248311, 119, '2014-03-15 01:18:25.000000', 'temperatura', 91.0000, 'ºC'),
	(248312, 119, '2014-03-15 01:18:26.000000', 'temperatura', 236.0000, 'ºC'),
	(248313, 119, '2014-03-15 01:18:27.000000', 'temperatura', 909.0000, 'ºC'),
	(248314, 119, '2014-03-15 01:18:28.000000', 'temperatura', 238.0000, 'ºC'),
	(248315, 119, '2014-03-15 01:18:29.000000', 'temperatura', 862.0000, 'ºC'),
	(248316, 119, '2014-03-15 01:18:30.000000', 'temperatura', 1197.0000, 'ºC'),
	(248317, 119, '2014-03-15 01:18:31.000000', 'temperatura', 1001.0000, 'ºC'),
	(248318, 119, '2014-03-15 01:18:32.000000', 'temperatura', 212.0000, 'ºC'),
	(248319, 119, '2014-03-15 01:18:33.000000', 'temperatura', 461.0000, 'ºC'),
	(248320, 119, '2014-03-15 01:18:34.000000', 'temperatura', 466.0000, 'ºC'),
	(248321, 119, '2014-03-15 01:18:35.000000', 'temperatura', 949.0000, 'ºC'),
	(248322, 119, '2014-03-15 01:18:36.000000', 'temperatura', 946.0000, 'ºC'),
	(248323, 119, '2014-03-15 01:18:37.000000', 'temperatura', 686.0000, 'ºC'),
	(248324, 119, '2014-03-15 01:18:38.000000', 'temperatura', 591.0000, 'ºC'),
	(248325, 119, '2014-03-15 01:18:39.000000', 'temperatura', 896.0000, 'ºC'),
	(248326, 119, '2014-03-15 01:18:40.000000', 'temperatura', 307.0000, 'ºC'),
	(248327, 119, '2014-03-15 01:18:41.000000', 'temperatura', 51.0000, 'ºC'),
	(248328, 119, '2014-03-15 01:18:42.000000', 'temperatura', 532.0000, 'ºC'),
	(248329, 119, '2014-03-15 01:18:43.000000', 'temperatura', 107.0000, 'ºC'),
	(248330, 119, '2014-03-15 01:18:44.000000', 'temperatura', 142.0000, 'ºC'),
	(248331, 119, '2014-03-15 01:18:45.000000', 'temperatura', 388.0000, 'ºC'),
	(248332, 119, '2014-03-15 01:18:46.000000', 'temperatura', 314.0000, 'ºC'),
	(248333, 119, '2014-03-15 01:18:47.000000', 'temperatura', 406.0000, 'ºC'),
	(248334, 119, '2014-03-15 01:18:48.000000', 'temperatura', 1090.0000, 'ºC'),
	(248335, 119, '2014-03-15 01:18:49.000000', 'temperatura', 631.0000, 'ºC'),
	(248336, 119, '2014-03-15 01:18:50.000000', 'temperatura', 1085.0000, 'ºC'),
	(248337, 119, '2014-03-15 01:18:51.000000', 'temperatura', 1134.0000, 'ºC'),
	(248338, 119, '2014-03-15 01:18:52.000000', 'temperatura', 15.0000, 'ºC'),
	(248339, 119, '2014-03-15 01:18:53.000000', 'temperatura', 275.0000, 'ºC'),
	(248340, 119, '2014-03-15 01:18:54.000000', 'temperatura', 131.0000, 'ºC'),
	(248341, 119, '2014-03-15 01:18:55.000000', 'temperatura', 1028.0000, 'ºC'),
	(248342, 119, '2014-03-15 01:18:56.000000', 'temperatura', 1149.0000, 'ºC'),
	(248343, 119, '2014-03-15 01:18:57.000000', 'temperatura', 262.0000, 'ºC'),
	(248344, 119, '2014-03-15 01:18:58.000000', 'temperatura', 261.0000, 'ºC'),
	(248345, 119, '2014-03-15 01:18:59.000000', 'temperatura', 521.0000, 'ºC'),
	(248346, 119, '2014-03-15 01:19:00.000000', 'temperatura', 624.0000, 'ºC'),
	(248347, 119, '2014-03-15 01:19:01.000000', 'temperatura', 355.0000, 'ºC'),
	(248348, 119, '2014-03-15 01:19:02.000000', 'temperatura', 1106.0000, 'ºC'),
	(248349, 119, '2014-03-15 01:19:03.000000', 'temperatura', 863.0000, 'ºC'),
	(248350, 119, '2014-03-15 01:19:04.000000', 'temperatura', 996.0000, 'ºC'),
	(248351, 119, '2014-03-15 01:19:05.000000', 'temperatura', 1195.0000, 'ºC'),
	(248352, 119, '2014-03-15 01:19:06.000000', 'temperatura', 587.0000, 'ºC'),
	(248353, 119, '2014-03-15 01:19:07.000000', 'temperatura', 552.0000, 'ºC'),
	(248354, 119, '2014-03-15 01:19:08.000000', 'temperatura', 996.0000, 'ºC'),
	(248355, 119, '2014-03-15 01:19:09.000000', 'temperatura', 926.0000, 'ºC'),
	(248356, 119, '2014-03-15 01:19:10.000000', 'temperatura', 443.0000, 'ºC'),
	(248357, 119, '2014-03-15 01:19:11.000000', 'temperatura', 638.0000, 'ºC'),
	(248358, 119, '2014-03-15 01:19:12.000000', 'temperatura', 661.0000, 'ºC'),
	(248359, 119, '2014-03-15 01:19:13.000000', 'temperatura', 193.0000, 'ºC'),
	(248360, 119, '2014-03-15 01:19:14.000000', 'temperatura', 182.0000, 'ºC'),
	(248361, 119, '2014-03-15 01:19:15.000000', 'temperatura', 332.0000, 'ºC'),
	(248362, 119, '2014-03-15 01:19:16.000000', 'temperatura', 1113.0000, 'ºC'),
	(248363, 119, '2014-03-15 01:19:17.000000', 'temperatura', 971.0000, 'ºC'),
	(248364, 119, '2014-03-15 01:19:18.000000', 'temperatura', 314.0000, 'ºC'),
	(248365, 119, '2014-03-15 01:19:19.000000', 'temperatura', 1061.0000, 'ºC'),
	(248366, 119, '2014-03-15 01:19:20.000000', 'temperatura', 760.0000, 'ºC'),
	(248367, 119, '2014-03-15 01:19:21.000000', 'temperatura', 618.0000, 'ºC'),
	(248368, 119, '2014-03-15 01:19:22.000000', 'temperatura', 813.0000, 'ºC'),
	(248369, 119, '2014-03-15 01:19:23.000000', 'temperatura', 1010.0000, 'ºC'),
	(248370, 119, '2014-03-15 01:19:24.000000', 'temperatura', 211.0000, 'ºC'),
	(248371, 119, '2014-03-15 01:19:25.000000', 'temperatura', 427.0000, 'ºC'),
	(248372, 119, '2014-03-15 01:19:26.000000', 'temperatura', 303.0000, 'ºC'),
	(248373, 119, '2014-03-15 01:19:27.000000', 'temperatura', 234.0000, 'ºC'),
	(248374, 119, '2014-03-15 01:19:28.000000', 'temperatura', 263.0000, 'ºC'),
	(248375, 119, '2014-03-15 01:19:29.000000', 'temperatura', 613.0000, 'ºC'),
	(248376, 119, '2014-03-15 01:19:30.000000', 'temperatura', 1074.0000, 'ºC'),
	(248377, 119, '2014-03-15 01:19:31.000000', 'temperatura', 1134.0000, 'ºC'),
	(248378, 119, '2014-03-15 01:19:32.000000', 'temperatura', 48.0000, 'ºC'),
	(248379, 119, '2014-03-15 01:19:33.000000', 'temperatura', 440.0000, 'ºC'),
	(248380, 119, '2014-03-15 01:19:34.000000', 'temperatura', 857.0000, 'ºC'),
	(248381, 119, '2014-03-15 01:19:35.000000', 'temperatura', 564.0000, 'ºC'),
	(248382, 119, '2014-03-15 01:19:36.000000', 'temperatura', 248.0000, 'ºC'),
	(248383, 119, '2014-03-15 01:19:37.000000', 'temperatura', 749.0000, 'ºC'),
	(248384, 119, '2014-03-15 01:19:38.000000', 'temperatura', 600.0000, 'ºC'),
	(248385, 119, '2014-03-15 01:19:39.000000', 'temperatura', 755.0000, 'ºC'),
	(248386, 119, '2014-03-15 01:19:40.000000', 'temperatura', 777.0000, 'ºC'),
	(248387, 119, '2014-03-15 01:19:41.000000', 'temperatura', 419.0000, 'ºC'),
	(248388, 119, '2014-03-15 01:19:42.000000', 'temperatura', 966.0000, 'ºC'),
	(248389, 119, '2014-03-15 01:19:43.000000', 'temperatura', 1171.0000, 'ºC'),
	(248390, 119, '2014-03-15 01:19:44.000000', 'temperatura', 558.0000, 'ºC'),
	(248391, 119, '2014-03-15 01:19:45.000000', 'temperatura', 478.0000, 'ºC'),
	(248392, 119, '2014-03-15 01:19:46.000000', 'temperatura', 717.0000, 'ºC'),
	(248393, 119, '2014-03-15 01:19:47.000000', 'temperatura', 949.0000, 'ºC'),
	(248394, 119, '2014-03-15 01:19:48.000000', 'temperatura', 196.0000, 'ºC'),
	(248395, 119, '2014-03-15 01:19:49.000000', 'temperatura', 534.0000, 'ºC'),
	(248396, 119, '2014-03-15 01:19:50.000000', 'temperatura', 882.0000, 'ºC'),
	(248397, 119, '2014-03-15 01:19:51.000000', 'temperatura', 410.0000, 'ºC'),
	(248398, 119, '2014-03-15 01:19:52.000000', 'temperatura', 603.0000, 'ºC'),
	(248399, 119, '2014-03-15 01:19:53.000000', 'temperatura', 585.0000, 'ºC'),
	(248400, 119, '2014-03-15 01:19:54.000000', 'temperatura', 1115.0000, 'ºC'),
	(248401, 119, '2014-03-15 01:19:55.000000', 'temperatura', 223.0000, 'ºC'),
	(248402, 119, '2014-03-15 01:19:56.000000', 'temperatura', 168.0000, 'ºC'),
	(248403, 119, '2014-03-15 01:19:57.000000', 'temperatura', 174.0000, 'ºC'),
	(248404, 119, '2014-03-15 01:19:58.000000', 'temperatura', 364.0000, 'ºC'),
	(248405, 119, '2014-03-15 01:19:59.000000', 'temperatura', 99.0000, 'ºC'),
	(248406, 119, '2014-03-15 01:20:00.000000', 'temperatura', 606.0000, 'ºC'),
	(248407, 119, '2014-03-15 01:20:01.000000', 'temperatura', 331.0000, 'ºC'),
	(248408, 119, '2014-03-15 01:20:02.000000', 'temperatura', 1038.0000, 'ºC'),
	(248409, 119, '2014-03-15 01:20:03.000000', 'temperatura', 598.0000, 'ºC'),
	(248410, 119, '2014-03-15 01:20:04.000000', 'temperatura', 1078.0000, 'ºC'),
	(248411, 119, '2014-03-15 01:20:05.000000', 'temperatura', 1197.0000, 'ºC'),
	(248412, 119, '2014-03-15 01:20:06.000000', 'temperatura', 351.0000, 'ºC'),
	(248413, 119, '2014-03-15 01:20:07.000000', 'temperatura', 563.0000, 'ºC'),
	(248414, 119, '2014-03-15 01:20:08.000000', 'temperatura', 563.0000, 'ºC'),
	(248415, 119, '2014-03-15 01:20:09.000000', 'temperatura', 1125.0000, 'ºC'),
	(248416, 119, '2014-03-15 01:20:10.000000', 'temperatura', 339.0000, 'ºC'),
	(248417, 119, '2014-03-15 01:20:11.000000', 'temperatura', 719.0000, 'ºC'),
	(248418, 119, '2014-03-15 01:20:12.000000', 'temperatura', 179.0000, 'ºC'),
	(248419, 119, '2014-03-15 01:20:13.000000', 'temperatura', 1140.0000, 'ºC'),
	(248420, 119, '2014-03-15 01:20:14.000000', 'temperatura', 361.0000, 'ºC'),
	(248421, 119, '2014-03-15 01:20:15.000000', 'temperatura', 786.0000, 'ºC'),
	(248422, 119, '2014-03-15 01:20:16.000000', 'temperatura', 448.0000, 'ºC'),
	(248423, 119, '2014-03-15 01:20:17.000000', 'temperatura', 1081.0000, 'ºC'),
	(248424, 119, '2014-03-15 01:20:18.000000', 'temperatura', 464.0000, 'ºC'),
	(248425, 119, '2014-03-15 01:20:19.000000', 'temperatura', 277.0000, 'ºC'),
	(248426, 119, '2014-03-15 01:20:20.000000', 'temperatura', 1194.0000, 'ºC'),
	(248427, 119, '2014-03-15 01:20:21.000000', 'temperatura', 341.0000, 'ºC'),
	(248428, 119, '2014-03-15 01:20:22.000000', 'temperatura', 521.0000, 'ºC'),
	(248429, 119, '2014-03-15 01:20:23.000000', 'temperatura', 382.0000, 'ºC'),
	(248430, 119, '2014-03-15 01:20:24.000000', 'temperatura', 346.0000, 'ºC'),
	(248431, 119, '2014-03-15 01:20:25.000000', 'temperatura', 588.0000, 'ºC'),
	(248432, 119, '2014-03-15 01:20:26.000000', 'temperatura', 700.0000, 'ºC'),
	(248433, 119, '2014-03-15 01:20:27.000000', 'temperatura', 538.0000, 'ºC'),
	(248434, 119, '2014-03-15 01:20:28.000000', 'temperatura', 590.0000, 'ºC'),
	(248435, 119, '2014-03-15 01:20:29.000000', 'temperatura', 135.0000, 'ºC'),
	(248436, 119, '2014-03-15 01:20:30.000000', 'temperatura', 108.0000, 'ºC'),
	(248437, 119, '2014-03-15 01:20:31.000000', 'temperatura', 134.0000, 'ºC'),
	(248438, 119, '2014-03-15 01:20:32.000000', 'temperatura', 346.0000, 'ºC'),
	(248439, 119, '2014-03-15 01:20:33.000000', 'temperatura', 127.0000, 'ºC'),
	(248440, 119, '2014-03-15 01:20:34.000000', 'temperatura', 800.0000, 'ºC'),
	(248441, 119, '2014-03-15 01:20:35.000000', 'temperatura', 17.0000, 'ºC'),
	(248442, 119, '2014-03-15 01:20:36.000000', 'temperatura', 88.0000, 'ºC'),
	(248443, 119, '2014-03-15 01:20:37.000000', 'temperatura', 389.0000, 'ºC'),
	(248444, 119, '2014-03-15 01:20:38.000000', 'temperatura', 483.0000, 'ºC'),
	(248445, 119, '2014-03-15 01:20:39.000000', 'temperatura', 47.0000, 'ºC'),
	(248446, 119, '2014-03-15 01:20:40.000000', 'temperatura', 1186.0000, 'ºC'),
	(248447, 119, '2014-03-15 01:20:41.000000', 'temperatura', 989.0000, 'ºC'),
	(248448, 119, '2014-03-15 01:20:42.000000', 'temperatura', 186.0000, 'ºC'),
	(248449, 119, '2014-03-15 01:20:43.000000', 'temperatura', 367.0000, 'ºC'),
	(248450, 119, '2014-03-15 01:20:44.000000', 'temperatura', 75.0000, 'ºC'),
	(248451, 119, '2014-03-15 01:20:45.000000', 'temperatura', 474.0000, 'ºC'),
	(248452, 119, '2014-03-15 01:20:46.000000', 'temperatura', 946.0000, 'ºC'),
	(248453, 119, '2014-03-15 01:20:47.000000', 'temperatura', 910.0000, 'ºC'),
	(248454, 119, '2014-03-15 01:20:48.000000', 'temperatura', 512.0000, 'ºC'),
	(248455, 119, '2014-03-15 01:20:49.000000', 'temperatura', 1031.0000, 'ºC'),
	(248456, 119, '2014-03-15 01:20:50.000000', 'temperatura', 17.0000, 'ºC'),
	(248457, 119, '2014-03-15 01:20:51.000000', 'temperatura', 596.0000, 'ºC'),
	(248458, 119, '2014-03-15 01:20:52.000000', 'temperatura', 527.0000, 'ºC'),
	(248459, 119, '2014-03-15 01:20:53.000000', 'temperatura', 847.0000, 'ºC'),
	(248460, 119, '2014-03-15 01:20:54.000000', 'temperatura', 257.0000, 'ºC'),
	(248461, 119, '2014-03-15 01:20:55.000000', 'temperatura', 1145.0000, 'ºC'),
	(248462, 119, '2014-03-15 01:20:56.000000', 'temperatura', 154.0000, 'ºC'),
	(248463, 119, '2014-03-15 01:20:57.000000', 'temperatura', 935.0000, 'ºC'),
	(248464, 119, '2014-03-15 01:20:58.000000', 'temperatura', 613.0000, 'ºC'),
	(248465, 119, '2014-03-15 01:20:59.000000', 'temperatura', 260.0000, 'ºC'),
	(248466, 119, '2014-03-15 01:21:00.000000', 'temperatura', 664.0000, 'ºC'),
	(248467, 119, '2014-03-15 01:21:01.000000', 'temperatura', 137.0000, 'ºC'),
	(248468, 119, '2014-03-15 01:21:02.000000', 'temperatura', 1097.0000, 'ºC'),
	(248469, 119, '2014-03-15 01:21:03.000000', 'temperatura', 272.0000, 'ºC'),
	(248470, 119, '2014-03-15 01:21:04.000000', 'temperatura', 469.0000, 'ºC'),
	(248471, 119, '2014-03-15 01:21:05.000000', 'temperatura', 330.0000, 'ºC'),
	(248472, 119, '2014-03-15 01:21:06.000000', 'temperatura', 245.0000, 'ºC'),
	(248473, 119, '2014-03-15 01:21:07.000000', 'temperatura', 234.0000, 'ºC'),
	(248474, 119, '2014-03-15 01:21:08.000000', 'temperatura', 438.0000, 'ºC'),
	(248475, 119, '2014-03-15 01:21:09.000000', 'temperatura', 286.0000, 'ºC'),
	(248476, 119, '2014-03-15 01:21:10.000000', 'temperatura', 119.0000, 'ºC'),
	(248477, 119, '2014-03-15 01:21:11.000000', 'temperatura', 938.0000, 'ºC'),
	(248478, 119, '2014-03-15 01:21:12.000000', 'temperatura', 731.0000, 'ºC'),
	(248479, 119, '2014-03-15 01:21:13.000000', 'temperatura', 844.0000, 'ºC'),
	(248480, 119, '2014-03-15 01:21:14.000000', 'temperatura', 826.0000, 'ºC'),
	(248481, 119, '2014-03-15 01:21:15.000000', 'temperatura', 397.0000, 'ºC'),
	(248482, 119, '2014-03-15 01:21:16.000000', 'temperatura', 709.0000, 'ºC'),
	(248483, 119, '2014-03-15 01:21:17.000000', 'temperatura', 1154.0000, 'ºC'),
	(248484, 119, '2014-03-15 01:21:18.000000', 'temperatura', 42.0000, 'ºC'),
	(248485, 119, '2014-03-15 01:21:19.000000', 'temperatura', 351.0000, 'ºC'),
	(248486, 119, '2014-03-15 01:21:20.000000', 'temperatura', 427.0000, 'ºC'),
	(248487, 119, '2014-03-15 01:21:21.000000', 'temperatura', 1084.0000, 'ºC'),
	(248488, 119, '2014-03-15 01:21:22.000000', 'temperatura', 537.0000, 'ºC'),
	(248489, 119, '2014-03-15 01:21:23.000000', 'temperatura', 637.0000, 'ºC'),
	(248490, 119, '2014-03-15 01:21:24.000000', 'temperatura', 372.0000, 'ºC'),
	(248491, 119, '2014-03-15 01:21:25.000000', 'temperatura', 1150.0000, 'ºC'),
	(248492, 119, '2014-03-15 01:21:26.000000', 'temperatura', 1036.0000, 'ºC'),
	(248493, 119, '2014-03-15 01:21:27.000000', 'temperatura', 531.0000, 'ºC'),
	(248494, 119, '2014-03-15 01:21:28.000000', 'temperatura', 746.0000, 'ºC'),
	(248495, 119, '2014-03-15 01:21:29.000000', 'temperatura', 938.0000, 'ºC'),
	(248496, 119, '2014-03-15 01:21:30.000000', 'temperatura', 52.0000, 'ºC'),
	(248497, 119, '2014-03-15 01:21:31.000000', 'temperatura', 1046.0000, 'ºC'),
	(248498, 119, '2014-03-15 01:21:32.000000', 'temperatura', 274.0000, 'ºC'),
	(248499, 119, '2014-03-15 01:21:33.000000', 'temperatura', 634.0000, 'ºC'),
	(248500, 119, '2014-03-15 01:21:34.000000', 'temperatura', 1148.0000, 'ºC'),
	(248501, 119, '2014-03-15 01:21:35.000000', 'temperatura', 240.0000, 'ºC'),
	(248502, 119, '2014-03-15 01:21:36.000000', 'temperatura', 155.0000, 'ºC'),
	(248503, 119, '2014-03-15 01:21:37.000000', 'temperatura', 58.0000, 'ºC'),
	(248504, 119, '2014-03-15 01:21:38.000000', 'temperatura', 1023.0000, 'ºC'),
	(248505, 119, '2014-03-15 01:21:39.000000', 'temperatura', 144.0000, 'ºC'),
	(248506, 119, '2014-03-15 01:21:40.000000', 'temperatura', 50.0000, 'ºC'),
	(248507, 119, '2014-03-15 01:21:41.000000', 'temperatura', 1018.0000, 'ºC'),
	(248508, 119, '2014-03-15 01:21:42.000000', 'temperatura', 139.0000, 'ºC'),
	(248509, 119, '2014-03-15 01:21:43.000000', 'temperatura', 44.0000, 'ºC'),
	(248510, 119, '2014-03-15 01:21:44.000000', 'temperatura', 1003.0000, 'ºC'),
	(248511, 119, '2014-03-15 01:21:45.000000', 'temperatura', 83.0000, 'ºC'),
	(248512, 119, '2014-03-15 01:21:46.000000', 'temperatura', 1008.0000, 'ºC'),
	(248513, 119, '2014-03-15 01:21:47.000000', 'temperatura', 1192.0000, 'ºC'),
	(248514, 119, '2014-03-15 01:21:48.000000', 'temperatura', 537.0000, 'ºC'),
	(248515, 119, '2014-03-15 01:21:49.000000', 'temperatura', 310.0000, 'ºC'),
	(248516, 119, '2014-03-15 01:21:50.000000', 'temperatura', 1138.0000, 'ºC'),
	(248517, 119, '2014-03-15 01:21:51.000000', 'temperatura', 1163.0000, 'ºC'),
	(248518, 119, '2014-03-15 01:21:52.000000', 'temperatura', 1199.0000, 'ºC'),
	(248519, 119, '2014-03-15 01:21:53.000000', 'temperatura', 109.0000, 'ºC'),
	(248520, 119, '2014-03-15 01:21:54.000000', 'temperatura', 546.0000, 'ºC'),
	(248521, 119, '2014-03-15 01:21:55.000000', 'temperatura', 6.0000, 'ºC'),
	(248522, 119, '2014-03-15 01:21:56.000000', 'temperatura', 793.0000, 'ºC'),
	(248523, 119, '2014-03-15 01:21:57.000000', 'temperatura', 345.0000, 'ºC'),
	(248524, 119, '2014-03-15 01:21:58.000000', 'temperatura', 548.0000, 'ºC'),
	(248525, 119, '2014-03-15 01:21:59.000000', 'temperatura', 505.0000, 'ºC'),
	(248526, 119, '2014-03-15 01:22:00.000000', 'temperatura', 882.0000, 'ºC'),
	(248527, 119, '2014-03-15 01:22:01.000000', 'temperatura', 497.0000, 'ºC'),
	(248528, 119, '2014-03-15 01:22:02.000000', 'temperatura', 1038.0000, 'ºC'),
	(248529, 119, '2014-03-15 01:22:03.000000', 'temperatura', 98.0000, 'ºC'),
	(248530, 119, '2014-03-15 01:22:04.000000', 'temperatura', 976.0000, 'ºC'),
	(248531, 119, '2014-03-15 01:22:05.000000', 'temperatura', 987.0000, 'ºC'),
	(248532, 119, '2014-03-15 01:22:06.000000', 'temperatura', 806.0000, 'ºC'),
	(248533, 119, '2014-03-15 01:22:07.000000', 'temperatura', 1072.0000, 'ºC'),
	(248534, 119, '2014-03-15 01:22:08.000000', 'temperatura', 541.0000, 'ºC'),
	(248535, 119, '2014-03-15 01:22:09.000000', 'temperatura', 691.0000, 'ºC'),
	(248536, 119, '2014-03-15 01:22:10.000000', 'temperatura', 633.0000, 'ºC'),
	(248537, 119, '2014-03-15 01:22:11.000000', 'temperatura', 1094.0000, 'ºC'),
	(248538, 119, '2014-03-15 01:22:12.000000', 'temperatura', 1168.0000, 'ºC'),
	(248539, 119, '2014-03-15 01:22:13.000000', 'temperatura', 161.0000, 'ºC'),
	(248540, 119, '2014-03-15 01:22:14.000000', 'temperatura', 901.0000, 'ºC'),
	(248541, 119, '2014-03-15 01:22:15.000000', 'temperatura', 421.0000, 'ºC'),
	(248542, 119, '2014-03-15 01:22:16.000000', 'temperatura', 603.0000, 'ºC'),
	(248543, 119, '2014-03-15 01:22:17.000000', 'temperatura', 552.0000, 'ºC'),
	(248544, 119, '2014-03-15 01:22:18.000000', 'temperatura', 953.0000, 'ºC'),
	(248545, 119, '2014-03-15 01:22:19.000000', 'temperatura', 709.0000, 'ºC'),
	(248546, 119, '2014-03-15 01:22:20.000000', 'temperatura', 687.0000, 'ºC'),
	(248547, 119, '2014-03-15 01:22:21.000000', 'temperatura', 109.0000, 'ºC'),
	(248548, 119, '2014-03-15 01:22:22.000000', 'temperatura', 883.0000, 'ºC'),
	(248549, 119, '2014-03-15 01:22:23.000000', 'temperatura', 490.0000, 'ºC'),
	(248550, 119, '2014-03-15 01:22:24.000000', 'temperatura', 1001.0000, 'ºC'),
	(248551, 119, '2014-03-15 01:22:25.000000', 'temperatura', 1135.0000, 'ºC'),
	(248552, 119, '2014-03-15 01:22:26.000000', 'temperatura', 272.0000, 'ºC'),
	(248553, 119, '2014-03-15 01:22:27.000000', 'temperatura', 357.0000, 'ºC'),
	(248554, 119, '2014-03-15 01:22:28.000000', 'temperatura', 967.0000, 'ºC'),
	(248555, 119, '2014-03-15 01:22:29.000000', 'temperatura', 166.0000, 'ºC'),
	(248556, 119, '2014-03-15 01:22:30.000000', 'temperatura', 330.0000, 'ºC'),
	(248557, 119, '2014-03-15 01:22:31.000000', 'temperatura', 1152.0000, 'ºC'),
	(248558, 119, '2014-03-15 01:22:32.000000', 'temperatura', 1171.0000, 'ºC'),
	(248559, 119, '2014-03-15 01:22:33.000000', 'temperatura', 1198.0000, 'ºC'),
	(248560, 119, '2014-03-15 01:22:34.000000', 'temperatura', 77.0000, 'ºC'),
	(248561, 119, '2014-03-15 01:22:35.000000', 'temperatura', 393.0000, 'ºC'),
	(248562, 119, '2014-03-15 01:22:36.000000', 'temperatura', 533.0000, 'ºC'),
	(248563, 119, '2014-03-15 01:22:37.000000', 'temperatura', 289.0000, 'ºC'),
	(248564, 119, '2014-03-15 01:22:38.000000', 'temperatura', 1047.0000, 'ºC'),
	(248565, 119, '2014-03-15 01:22:39.000000', 'temperatura', 766.0000, 'ºC'),
	(248566, 119, '2014-03-15 01:22:40.000000', 'temperatura', 692.0000, 'ºC'),
	(248567, 119, '2014-03-15 01:22:41.000000', 'temperatura', 1163.0000, 'ºC'),
	(248568, 119, '2014-03-15 01:22:42.000000', 'temperatura', 137.0000, 'ºC'),
	(248569, 119, '2014-03-15 01:22:43.000000', 'temperatura', 796.0000, 'ºC'),
	(248570, 119, '2014-03-15 01:22:44.000000', 'temperatura', 1170.0000, 'ºC'),
	(248571, 119, '2014-03-15 01:22:45.000000', 'temperatura', 1064.0000, 'ºC'),
	(248572, 119, '2014-03-15 01:22:46.000000', 'temperatura', 610.0000, 'ºC'),
	(248573, 119, '2014-03-15 01:22:47.000000', 'temperatura', 1060.0000, 'ºC'),
	(248574, 119, '2014-03-15 01:22:48.000000', 'temperatura', 1069.0000, 'ºC'),
	(248575, 119, '2014-03-15 01:22:49.000000', 'temperatura', 966.0000, 'ºC'),
	(248576, 119, '2014-03-15 01:22:50.000000', 'temperatura', 424.0000, 'ºC'),
	(248577, 119, '2014-03-15 01:22:51.000000', 'temperatura', 423.0000, 'ºC'),
	(248578, 119, '2014-03-15 01:22:52.000000', 'temperatura', 841.0000, 'ºC'),
	(248579, 119, '2014-03-15 01:22:53.000000', 'temperatura', 539.0000, 'ºC'),
	(248580, 119, '2014-03-15 01:22:54.000000', 'temperatura', 173.0000, 'ºC'),
	(248581, 119, '2014-03-15 01:22:55.000000', 'temperatura', 447.0000, 'ºC'),
	(248582, 119, '2014-03-15 01:22:56.000000', 'temperatura', 518.0000, 'ºC'),
	(248583, 119, '2014-03-15 01:22:57.000000', 'temperatura', 48.0000, 'ºC'),
	(248584, 119, '2014-03-15 01:22:58.000000', 'temperatura', 1089.0000, 'ºC'),
	(248585, 119, '2014-03-15 01:22:59.000000', 'temperatura', 500.0000, 'ºC'),
	(248586, 119, '2014-03-15 01:23:00.000000', 'temperatura', 434.0000, 'ºC'),
	(248587, 119, '2014-03-15 01:23:01.000000', 'temperatura', 670.0000, 'ºC'),
	(248588, 119, '2014-03-15 01:23:02.000000', 'temperatura', 850.0000, 'ºC'),
	(248589, 119, '2014-03-15 01:23:03.000000', 'temperatura', 1038.0000, 'ºC'),
	(248590, 119, '2014-03-15 01:23:04.000000', 'temperatura', 241.0000, 'ºC'),
	(248591, 119, '2014-03-15 01:23:05.000000', 'temperatura', 492.0000, 'ºC'),
	(248592, 119, '2014-03-15 01:23:06.000000', 'temperatura', 536.0000, 'ºC'),
	(248593, 119, '2014-03-15 01:23:07.000000', 'temperatura', 6.0000, 'ºC'),
	(248594, 119, '2014-03-15 01:23:08.000000', 'temperatura', 822.0000, 'ºC'),
	(248595, 119, '2014-03-15 01:23:09.000000', 'temperatura', 491.0000, 'ºC'),
	(248596, 119, '2014-03-15 01:23:10.000000', 'temperatura', 1191.0000, 'ºC'),
	(248597, 119, '2014-03-15 01:23:11.000000', 'temperatura', 882.0000, 'ºC'),
	(248598, 119, '2014-03-15 01:23:12.000000', 'temperatura', 837.0000, 'ºC'),
	(248599, 119, '2014-03-15 01:23:13.000000', 'temperatura', 342.0000, 'ºC'),
	(248600, 119, '2014-03-15 01:23:14.000000', 'temperatura', 397.0000, 'ºC'),
	(248601, 119, '2014-03-15 01:23:15.000000', 'temperatura', 960.0000, 'ºC'),
	(248602, 119, '2014-03-15 01:23:16.000000', 'temperatura', 10.0000, 'ºC'),
	(248603, 119, '2014-03-15 01:23:17.000000', 'temperatura', 768.0000, 'ºC'),
	(248604, 119, '2014-03-15 01:23:18.000000', 'temperatura', 214.0000, 'ºC'),
	(248605, 119, '2014-03-15 01:23:19.000000', 'temperatura', 1165.0000, 'ºC'),
	(248606, 119, '2014-03-15 01:23:20.000000', 'temperatura', 383.0000, 'ºC'),
	(248607, 119, '2014-03-15 01:23:21.000000', 'temperatura', 823.0000, 'ºC'),
	(248608, 119, '2014-03-15 01:23:22.000000', 'temperatura', 565.0000, 'ºC'),
	(248609, 119, '2014-03-15 01:23:23.000000', 'temperatura', 358.0000, 'ºC'),
	(248610, 119, '2014-03-15 01:23:24.000000', 'temperatura', 95.0000, 'ºC'),
	(248611, 119, '2014-03-15 01:23:25.000000', 'temperatura', 603.0000, 'ºC'),
	(248612, 119, '2014-03-15 01:23:26.000000', 'temperatura', 330.0000, 'ºC'),
	(248613, 119, '2014-03-15 01:23:27.000000', 'temperatura', 1039.0000, 'ºC'),
	(248614, 119, '2014-03-15 01:23:28.000000', 'temperatura', 607.0000, 'ºC'),
	(248615, 119, '2014-03-15 01:23:29.000000', 'temperatura', 1117.0000, 'ºC'),
	(248616, 119, '2014-03-15 01:23:30.000000', 'temperatura', 164.0000, 'ºC'),
	(248617, 119, '2014-03-15 01:23:31.000000', 'temperatura', 1071.0000, 'ºC'),
	(248618, 119, '2014-03-15 01:23:32.000000', 'temperatura', 61.0000, 'ºC'),
	(248619, 119, '2014-03-15 01:23:33.000000', 'temperatura', 695.0000, 'ºC'),
	(248620, 119, '2014-03-15 01:23:34.000000', 'temperatura', 890.0000, 'ºC'),
	(248621, 119, '2014-03-15 01:23:35.000000', 'temperatura', 1166.0000, 'ºC'),
	(248622, 119, '2014-03-15 01:23:36.000000', 'temperatura', 762.0000, 'ºC'),
	(248623, 119, '2014-03-15 01:23:37.000000', 'temperatura', 313.0000, 'ºC'),
	(248624, 119, '2014-03-15 01:23:38.000000', 'temperatura', 480.0000, 'ºC'),
	(248625, 119, '2014-03-15 01:23:39.000000', 'temperatura', 263.0000, 'ºC'),
	(248626, 119, '2014-03-15 01:23:40.000000', 'temperatura', 1072.0000, 'ºC'),
	(248627, 119, '2014-03-15 01:23:41.000000', 'temperatura', 973.0000, 'ºC'),
	(248628, 119, '2014-03-15 01:23:42.000000', 'temperatura', 451.0000, 'ºC'),
	(248629, 119, '2014-03-15 01:23:43.000000', 'temperatura', 534.0000, 'ºC'),
	(248630, 119, '2014-03-15 01:23:44.000000', 'temperatura', 120.0000, 'ºC'),
	(248631, 119, '2014-03-15 01:23:45.000000', 'temperatura', 199.0000, 'ºC'),
	(248632, 119, '2014-03-15 01:23:46.000000', 'temperatura', 632.0000, 'ºC'),
	(248633, 119, '2014-03-15 01:23:47.000000', 'temperatura', 167.0000, 'ºC'),
	(248634, 119, '2014-03-15 01:23:48.000000', 'temperatura', 137.0000, 'ºC'),
	(248635, 119, '2014-03-15 01:23:49.000000', 'temperatura', 186.0000, 'ºC'),
	(248636, 119, '2014-03-15 01:23:50.000000', 'temperatura', 517.0000, 'ºC'),
	(248637, 119, '2014-03-15 01:23:51.000000', 'temperatura', 830.0000, 'ºC'),
	(248638, 119, '2014-03-15 01:23:52.000000', 'temperatura', 201.0000, 'ºC'),
	(248639, 119, '2014-03-15 01:23:53.000000', 'temperatura', 913.0000, 'ºC'),
	(248640, 119, '2014-03-15 01:23:54.000000', 'temperatura', 361.0000, 'ºC'),
	(248641, 119, '2014-03-15 01:23:55.000000', 'temperatura', 268.0000, 'ºC'),
	(248642, 119, '2014-03-15 01:23:56.000000', 'temperatura', 258.0000, 'ºC'),
	(248643, 119, '2014-03-15 01:23:57.000000', 'temperatura', 486.0000, 'ºC'),
	(248644, 119, '2014-03-15 01:23:58.000000', 'temperatura', 458.0000, 'ºC'),
	(248645, 119, '2014-03-15 01:23:59.000000', 'temperatura', 832.0000, 'ºC'),
	(248646, 119, '2014-03-15 01:24:00.000000', 'temperatura', 388.0000, 'ºC'),
	(248647, 119, '2014-03-15 01:24:01.000000', 'temperatura', 644.0000, 'ºC'),
	(248648, 119, '2014-03-15 01:24:02.000000', 'temperatura', 858.0000, 'ºC'),
	(248649, 119, '2014-03-15 01:24:03.000000', 'temperatura', 1157.0000, 'ºC'),
	(248650, 119, '2014-03-15 01:24:04.000000', 'temperatura', 811.0000, 'ºC'),
	(248651, 119, '2014-03-15 01:24:05.000000', 'temperatura', 585.0000, 'ºC'),
	(248652, 119, '2014-03-15 01:24:06.000000', 'temperatura', 492.0000, 'ºC'),
	(248653, 119, '2014-03-15 01:24:07.000000', 'temperatura', 708.0000, 'ºC'),
	(248654, 119, '2014-03-15 01:24:08.000000', 'temperatura', 862.0000, 'ºC'),
	(248655, 119, '2014-03-15 01:24:09.000000', 'temperatura', 986.0000, 'ºC'),
	(248656, 119, '2014-03-15 01:24:10.000000', 'temperatura', 1145.0000, 'ºC'),
	(248657, 119, '2014-03-15 01:24:11.000000', 'temperatura', 366.0000, 'ºC'),
	(248658, 119, '2014-03-15 01:24:12.000000', 'temperatura', 798.0000, 'ºC'),
	(248659, 119, '2014-03-15 01:24:13.000000', 'temperatura', 493.0000, 'ºC'),
	(248660, 119, '2014-03-15 01:24:14.000000', 'temperatura', 71.0000, 'ºC'),
	(248661, 119, '2014-03-15 01:24:15.000000', 'temperatura', 75.0000, 'ºC'),
	(248662, 119, '2014-03-15 01:24:16.000000', 'temperatura', 161.0000, 'ºC'),
	(248663, 119, '2014-03-15 01:24:17.000000', 'temperatura', 583.0000, 'ºC'),
	(248664, 119, '2014-03-15 01:24:18.000000', 'temperatura', 33.0000, 'ºC'),
	(248665, 119, '2014-03-15 01:24:19.000000', 'temperatura', 814.0000, 'ºC'),
	(248666, 119, '2014-03-15 01:24:20.000000', 'temperatura', 371.0000, 'ºC'),
	(248667, 119, '2014-03-15 01:24:21.000000', 'temperatura', 614.0000, 'ºC'),
	(248668, 119, '2014-03-15 01:24:22.000000', 'temperatura', 759.0000, 'ºC'),
	(248669, 119, '2014-03-15 01:24:23.000000', 'temperatura', 752.0000, 'ºC'),
	(248670, 119, '2014-03-15 01:24:24.000000', 'temperatura', 286.0000, 'ºC'),
	(248671, 119, '2014-03-15 01:24:25.000000', 'temperatura', 372.0000, 'ºC'),
	(248672, 119, '2014-03-15 01:24:26.000000', 'temperatura', 1005.0000, 'ºC'),
	(248673, 119, '2014-03-15 01:24:27.000000', 'temperatura', 306.0000, 'ºC'),
	(248674, 119, '2014-03-15 01:24:28.000000', 'temperatura', 918.0000, 'ºC'),
	(248675, 119, '2014-03-15 01:24:29.000000', 'temperatura', 71.0000, 'ºC'),
	(248676, 119, '2014-03-15 01:24:30.000000', 'temperatura', 4.0000, 'ºC'),
	(248677, 119, '2014-03-15 01:24:31.000000', 'temperatura', 1006.0000, 'ºC'),
	(248678, 119, '2014-03-15 01:24:32.000000', 'temperatura', 218.0000, 'ºC'),
	(248679, 119, '2014-03-15 01:24:33.000000', 'temperatura', 473.0000, 'ºC'),
	(248680, 119, '2014-03-15 01:24:34.000000', 'temperatura', 510.0000, 'ºC'),
	(248681, 119, '2014-03-15 01:24:35.000000', 'temperatura', 1130.0000, 'ºC'),
	(248682, 119, '2014-03-15 01:24:36.000000', 'temperatura', 524.0000, 'ºC'),
	(248683, 119, '2014-03-15 01:24:37.000000', 'temperatura', 429.0000, 'ºC'),
	(248684, 119, '2014-03-15 01:24:38.000000', 'temperatura', 574.0000, 'ºC'),
	(248685, 119, '2014-03-15 01:24:39.000000', 'temperatura', 382.0000, 'ºC'),
	(248686, 119, '2014-03-15 01:24:40.000000', 'temperatura', 190.0000, 'ºC'),
	(248687, 119, '2014-03-15 01:24:41.000000', 'temperatura', 1004.0000, 'ºC'),
	(248688, 119, '2014-03-15 01:24:42.000000', 'temperatura', 851.0000, 'ºC'),
	(248689, 119, '2014-03-15 01:24:43.000000', 'temperatura', 42.0000, 'ºC'),
	(248690, 119, '2014-03-15 01:24:44.000000', 'temperatura', 59.0000, 'ºC'),
	(248691, 119, '2014-03-15 01:24:45.000000', 'temperatura', 170.0000, 'ºC'),
	(248692, 119, '2014-03-15 01:24:46.000000', 'temperatura', 672.0000, 'ºC'),
	(248693, 119, '2014-03-15 01:24:47.000000', 'temperatura', 453.0000, 'ºC'),
	(248694, 119, '2014-03-15 01:24:48.000000', 'temperatura', 247.0000, 'ºC'),
	(248695, 119, '2014-03-15 01:24:49.000000', 'temperatura', 1076.0000, 'ºC'),
	(248696, 119, '2014-03-15 01:24:50.000000', 'temperatura', 1041.0000, 'ºC'),
	(248697, 119, '2014-03-15 01:24:51.000000', 'temperatura', 776.0000, 'ºC'),
	(248698, 119, '2014-03-15 01:24:52.000000', 'temperatura', 760.0000, 'ºC'),
	(248699, 119, '2014-03-15 01:24:53.000000', 'temperatura', 269.0000, 'ºC'),
	(248700, 119, '2014-03-15 01:24:54.000000', 'temperatura', 268.0000, 'ºC'),
	(248701, 119, '2014-03-15 01:24:55.000000', 'temperatura', 532.0000, 'ºC'),
	(248702, 119, '2014-03-15 01:24:56.000000', 'temperatura', 658.0000, 'ºC'),
	(248703, 119, '2014-03-15 01:24:57.000000', 'temperatura', 493.0000, 'ºC'),
	(248704, 119, '2014-03-15 01:24:58.000000', 'temperatura', 493.0000, 'ºC'),
	(248705, 119, '2014-03-15 01:24:59.000000', 'temperatura', 987.0000, 'ºC'),
	(248706, 119, '2014-03-15 01:25:00.000000', 'temperatura', 1055.0000, 'ºC'),
	(248707, 119, '2014-03-15 01:25:01.000000', 'temperatura', 1114.0000, 'ºC'),
	(248708, 119, '2014-03-15 01:25:02.000000', 'temperatura', 5.0000, 'ºC'),
	(248709, 119, '2014-03-15 01:25:03.000000', 'temperatura', 285.0000, 'ºC'),
	(248710, 119, '2014-03-15 01:25:04.000000', 'temperatura', 211.0000, 'ºC'),
	(248711, 119, '2014-03-15 01:25:05.000000', 'temperatura', 198.0000, 'ºC'),
	(248712, 119, '2014-03-15 01:25:06.000000', 'temperatura', 361.0000, 'ºC'),
	(248713, 119, '2014-03-15 01:25:07.000000', 'temperatura', 8.0000, 'ºC'),
	(248714, 119, '2014-03-15 01:25:08.000000', 'temperatura', 160.0000, 'ºC'),
	(248715, 119, '2014-03-15 01:25:09.000000', 'temperatura', 775.0000, 'ºC'),
	(248716, 119, '2014-03-15 01:25:10.000000', 'temperatura', 997.0000, 'ºC'),
	(248717, 119, '2014-03-15 01:25:11.000000', 'temperatura', 258.0000, 'ºC'),
	(248718, 119, '2014-03-15 01:25:12.000000', 'temperatura', 700.0000, 'ºC'),
	(248719, 119, '2014-03-15 01:25:13.000000', 'temperatura', 327.0000, 'ºC'),
	(248720, 119, '2014-03-15 01:25:14.000000', 'temperatura', 736.0000, 'ºC'),
	(248721, 119, '2014-03-15 01:25:15.000000', 'temperatura', 299.0000, 'ºC'),
	(248722, 119, '2014-03-15 01:25:16.000000', 'temperatura', 488.0000, 'ºC'),
	(248723, 119, '2014-03-15 01:25:17.000000', 'temperatura', 344.0000, 'ºC'),
	(248724, 119, '2014-03-15 01:25:18.000000', 'temperatura', 255.0000, 'ºC'),
	(248725, 119, '2014-03-15 01:25:19.000000', 'temperatura', 244.0000, 'ºC'),
	(248726, 119, '2014-03-15 01:25:20.000000', 'temperatura', 454.0000, 'ºC'),
	(248727, 119, '2014-03-15 01:25:21.000000', 'temperatura', 338.0000, 'ºC'),
	(248728, 119, '2014-03-15 01:25:22.000000', 'temperatura', 330.0000, 'ºC'),
	(248729, 119, '2014-03-15 01:25:23.000000', 'temperatura', 638.0000, 'ºC'),
	(248730, 119, '2014-03-15 01:25:24.000000', 'temperatura', 1001.0000, 'ºC'),
	(248731, 119, '2014-03-15 01:25:25.000000', 'temperatura', 690.0000, 'ºC'),
	(248732, 119, '2014-03-15 01:25:26.000000', 'temperatura', 447.0000, 'ºC'),
	(248733, 119, '2014-03-15 01:25:27.000000', 'temperatura', 167.0000, 'ºC'),
	(248734, 119, '2014-03-15 01:25:28.000000', 'temperatura', 694.0000, 'ºC'),
	(248735, 119, '2014-03-15 01:25:29.000000', 'temperatura', 571.0000, 'ºC'),
	(248736, 119, '2014-03-15 01:25:30.000000', 'temperatura', 771.0000, 'ºC'),
	(248737, 119, '2014-03-15 01:25:31.000000', 'temperatura', 945.0000, 'ºC'),
	(248738, 119, '2014-03-15 01:25:32.000000', 'temperatura', 10.0000, 'ºC'),
	(248739, 119, '2014-03-15 01:25:33.000000', 'temperatura', 815.0000, 'ºC'),
	(248740, 119, '2014-03-15 01:25:34.000000', 'temperatura', 448.0000, 'ºC'),
	(248741, 119, '2014-03-15 01:25:35.000000', 'temperatura', 996.0000, 'ºC'),
	(248742, 119, '2014-03-15 01:25:36.000000', 'temperatura', 37.0000, 'ºC'),
	(248743, 119, '2014-03-15 01:25:37.000000', 'temperatura', 796.0000, 'ºC'),
	(248744, 119, '2014-03-15 01:25:38.000000', 'temperatura', 272.0000, 'ºC'),
	(248745, 119, '2014-03-15 01:25:39.000000', 'temperatura', 170.0000, 'ºC'),
	(248746, 119, '2014-03-15 01:25:40.000000', 'temperatura', 37.0000, 'ºC'),
	(248747, 119, '2014-03-15 01:25:41.000000', 'temperatura', 874.0000, 'ºC'),
	(248748, 119, '2014-03-15 01:25:42.000000', 'temperatura', 661.0000, 'ºC'),
	(248749, 119, '2014-03-15 01:25:43.000000', 'temperatura', 682.0000, 'ºC'),
	(248750, 119, '2014-03-15 01:25:44.000000', 'temperatura', 229.0000, 'ºC'),
	(248751, 119, '2014-03-15 01:25:45.000000', 'temperatura', 298.0000, 'ºC'),
	(248752, 119, '2014-03-15 01:25:46.000000', 'temperatura', 804.0000, 'ºC'),
	(248753, 119, '2014-03-15 01:25:47.000000', 'temperatura', 726.0000, 'ºC'),
	(248754, 119, '2014-03-15 01:25:48.000000', 'temperatura', 19.0000, 'ºC'),
	(248755, 119, '2014-03-15 01:25:49.000000', 'temperatura', 319.0000, 'ºC'),
	(248756, 119, '2014-03-15 01:25:50.000000', 'temperatura', 336.0000, 'ºC'),
	(248757, 119, '2014-03-15 01:25:51.000000', 'temperatura', 723.0000, 'ºC'),
	(248758, 119, '2014-03-15 01:25:52.000000', 'temperatura', 209.0000, 'ºC'),
	(248759, 119, '2014-03-15 01:25:53.000000', 'temperatura', 76.0000, 'ºC'),
	(248760, 119, '2014-03-15 01:25:54.000000', 'temperatura', 952.0000, 'ºC'),
	(248761, 119, '2014-03-15 01:25:55.000000', 'temperatura', 935.0000, 'ºC'),
	(248762, 119, '2014-03-15 01:25:56.000000', 'temperatura', 619.0000, 'ºC'),
	(248763, 119, '2014-03-15 01:25:57.000000', 'temperatura', 291.0000, 'ºC'),
	(248764, 119, '2014-03-15 01:25:58.000000', 'temperatura', 797.0000, 'ºC'),
	(248765, 119, '2014-03-15 01:25:59.000000', 'temperatura', 711.0000, 'ºC'),
	(248766, 119, '2014-03-15 01:26:00.000000', 'temperatura', 1166.0000, 'ºC'),
	(248767, 119, '2014-03-15 01:26:01.000000', 'temperatura', 99.0000, 'ºC'),
	(248768, 119, '2014-03-15 01:26:02.000000', 'temperatura', 598.0000, 'ºC'),
	(248769, 119, '2014-03-15 01:26:03.000000', 'temperatura', 294.0000, 'ºC'),
	(248770, 119, '2014-03-15 01:26:04.000000', 'temperatura', 877.0000, 'ºC'),
	(248771, 119, '2014-03-15 01:26:05.000000', 'temperatura', 1101.0000, 'ºC'),
	(248772, 119, '2014-03-15 01:26:06.000000', 'temperatura', 475.0000, 'ºC'),
	(248773, 119, '2014-03-15 01:26:07.000000', 'temperatura', 272.0000, 'ºC'),
	(248774, 119, '2014-03-15 01:26:08.000000', 'temperatura', 1137.0000, 'ºC'),
	(248775, 119, '2014-03-15 01:26:09.000000', 'temperatura', 70.0000, 'ºC'),
	(248776, 119, '2014-03-15 01:26:10.000000', 'temperatura', 541.0000, 'ºC'),
	(248777, 119, '2014-03-15 01:26:11.000000', 'temperatura', 92.0000, 'ºC'),
	(248778, 119, '2014-03-15 01:26:12.000000', 'temperatura', 40.0000, 'ºC'),
	(248779, 119, '2014-03-15 01:26:13.000000', 'temperatura', 1122.0000, 'ºC'),
	(248780, 119, '2014-03-15 01:26:14.000000', 'temperatura', 692.0000, 'ºC'),
	(248781, 119, '2014-03-15 01:26:15.000000', 'temperatura', 95.0000, 'ºC'),
	(248782, 119, '2014-03-15 01:26:16.000000', 'temperatura', 799.0000, 'ºC'),
	(248783, 119, '2014-03-15 01:26:17.000000', 'temperatura', 112.0000, 'ºC'),
	(248784, 119, '2014-03-15 01:26:18.000000', 'temperatura', 561.0000, 'ºC'),
	(248785, 119, '2014-03-15 01:26:19.000000', 'temperatura', 73.0000, 'ºC'),
	(248786, 119, '2014-03-15 01:26:20.000000', 'temperatura', 1079.0000, 'ºC'),
	(248787, 119, '2014-03-15 01:26:21.000000', 'temperatura', 376.0000, 'ºC'),
	(248788, 119, '2014-03-15 01:26:22.000000', 'temperatura', 1047.0000, 'ºC'),
	(248789, 119, '2014-03-15 01:26:23.000000', 'temperatura', 504.0000, 'ºC'),
	(248790, 119, '2014-03-15 01:26:24.000000', 'temperatura', 581.0000, 'ºC'),
	(248791, 119, '2014-03-15 01:26:25.000000', 'temperatura', 192.0000, 'ºC'),
	(248792, 119, '2014-03-15 01:26:26.000000', 'temperatura', 419.0000, 'ºC'),
	(248793, 119, '2014-03-15 01:26:27.000000', 'temperatura', 317.0000, 'ºC'),
	(248794, 119, '2014-03-15 01:26:28.000000', 'temperatura', 330.0000, 'ºC'),
	(248795, 119, '2014-03-15 01:26:29.000000', 'temperatura', 701.0000, 'ºC'),
	(248796, 119, '2014-03-15 01:26:30.000000', 'temperatura', 113.0000, 'ºC'),
	(248797, 119, '2014-03-15 01:26:31.000000', 'temperatura', 865.0000, 'ºC'),
	(248798, 119, '2014-03-15 01:26:32.000000', 'temperatura', 385.0000, 'ºC'),
	(248799, 119, '2014-03-15 01:26:33.000000', 'temperatura', 532.0000, 'ºC'),
	(248800, 119, '2014-03-15 01:26:34.000000', 'temperatura', 303.0000, 'ºC'),
	(248801, 119, '2014-03-15 01:26:35.000000', 'temperatura', 1121.0000, 'ºC'),
	(248802, 119, '2014-03-15 01:26:36.000000', 'temperatura', 1097.0000, 'ºC'),
	(248803, 119, '2014-03-15 01:26:37.000000', 'temperatura', 920.0000, 'ºC'),
	(248804, 119, '2014-03-15 01:26:38.000000', 'temperatura', 111.0000, 'ºC'),
	(248805, 119, '2014-03-15 01:26:39.000000', 'temperatura', 196.0000, 'ºC'),
	(248806, 119, '2014-03-15 01:26:40.000000', 'temperatura', 649.0000, 'ºC'),
	(248807, 119, '2014-03-15 01:26:41.000000', 'temperatura', 256.0000, 'ºC'),
	(248808, 119, '2014-03-15 01:26:42.000000', 'temperatura', 535.0000, 'ºC'),
	(248809, 119, '2014-03-15 01:26:43.000000', 'temperatura', 708.0000, 'ºC'),
	(248810, 119, '2014-03-15 01:26:44.000000', 'temperatura', 734.0000, 'ºC'),
	(248811, 119, '2014-03-15 01:26:45.000000', 'temperatura', 345.0000, 'ºC'),
	(248812, 119, '2014-03-15 01:26:46.000000', 'temperatura', 724.0000, 'ºC'),
	(248813, 119, '2014-03-15 01:26:47.000000', 'temperatura', 185.0000, 'ºC'),
	(248814, 119, '2014-03-15 01:26:48.000000', 'temperatura', 1153.0000, 'ºC'),
	(248815, 119, '2014-03-15 01:26:49.000000', 'temperatura', 412.0000, 'ºC'),
	(248816, 119, '2014-03-15 01:26:50.000000', 'temperatura', 999.0000, 'ºC'),
	(248817, 119, '2014-03-15 01:26:51.000000', 'temperatura', 162.0000, 'ºC'),
	(248818, 119, '2014-03-15 01:26:52.000000', 'temperatura', 211.0000, 'ºC'),
	(248819, 119, '2014-03-15 01:26:53.000000', 'temperatura', 571.0000, 'ºC'),
	(248820, 119, '2014-03-15 01:26:54.000000', 'temperatura', 1022.0000, 'ºC'),
	(248821, 119, '2014-03-15 01:26:55.000000', 'temperatura', 999.0000, 'ºC'),
	(248822, 119, '2014-03-15 01:26:56.000000', 'temperatura', 729.0000, 'ºC'),
	(248823, 119, '2014-03-15 01:26:57.000000', 'temperatura', 648.0000, 'ºC'),
	(248824, 119, '2014-03-15 01:26:58.000000', 'temperatura', 1053.0000, 'ºC'),
	(248825, 119, '2014-03-15 01:26:59.000000', 'temperatura', 923.0000, 'ºC'),
	(248826, 119, '2014-03-15 01:27:00.000000', 'temperatura', 255.0000, 'ºC'),
	(248827, 119, '2014-03-15 01:27:01.000000', 'temperatura', 906.0000, 'ºC'),
	(248828, 119, '2014-03-15 01:27:02.000000', 'temperatura', 167.0000, 'ºC'),
	(248829, 119, '2014-03-15 01:27:03.000000', 'temperatura', 517.0000, 'ºC'),
	(248830, 119, '2014-03-15 01:27:04.000000', 'temperatura', 884.0000, 'ºC'),
	(248831, 119, '2014-03-15 01:27:05.000000', 'temperatura', 468.0000, 'ºC'),
	(248832, 119, '2014-03-15 01:27:06.000000', 'temperatura', 889.0000, 'ºC'),
	(248833, 119, '2014-03-15 01:27:07.000000', 'temperatura', 642.0000, 'ºC'),
	(248834, 119, '2014-03-15 01:27:08.000000', 'temperatura', 544.0000, 'ºC'),
	(248835, 119, '2014-03-15 01:27:09.000000', 'temperatura', 793.0000, 'ºC'),
	(248836, 119, '2014-03-15 01:27:10.000000', 'temperatura', 1134.0000, 'ºC'),
	(248837, 119, '2014-03-15 01:27:11.000000', 'temperatura', 890.0000, 'ºC'),
	(248838, 119, '2014-03-15 01:27:12.000000', 'temperatura', 1051.0000, 'ºC'),
	(248839, 119, '2014-03-15 01:27:13.000000', 'temperatura', 186.0000, 'ºC'),
	(248840, 119, '2014-03-15 01:27:14.000000', 'temperatura', 177.0000, 'ºC'),
	(248841, 119, '2014-03-15 01:27:15.000000', 'temperatura', 326.0000, 'ºC'),
	(248842, 119, '2014-03-15 01:27:16.000000', 'temperatura', 1101.0000, 'ºC'),
	(248843, 119, '2014-03-15 01:27:17.000000', 'temperatura', 925.0000, 'ºC'),
	(248844, 119, '2014-03-15 01:27:18.000000', 'temperatura', 126.0000, 'ºC'),
	(248845, 119, '2014-03-15 01:27:19.000000', 'temperatura', 253.0000, 'ºC'),
	(248846, 119, '2014-03-15 01:27:20.000000', 'temperatura', 888.0000, 'ºC'),
	(248847, 119, '2014-03-15 01:27:21.000000', 'temperatura', 82.0000, 'ºC'),
	(248848, 119, '2014-03-15 01:27:22.000000', 'temperatura', 146.0000, 'ºC'),
	(248849, 119, '2014-03-15 01:27:23.000000', 'temperatura', 485.0000, 'ºC'),
	(248850, 120, '2014-03-15 00:00:00.000000', 'temperatura', 90.0000, 'ºC'),
	(248851, 120, '2014-03-15 00:00:01.000000', 'temperatura', 485.0000, 'ºC'),
	(248852, 120, '2014-03-15 00:00:02.000000', 'temperatura', 955.0000, 'ºC'),
	(248853, 120, '2014-03-15 00:00:03.000000', 'temperatura', 918.0000, 'ºC'),
	(248854, 120, '2014-03-15 00:00:04.000000', 'temperatura', 528.0000, 'ºC'),
	(248855, 120, '2014-03-15 00:00:05.000000', 'temperatura', 1084.0000, 'ºC'),
	(248856, 120, '2014-03-15 00:00:06.000000', 'temperatura', 237.0000, 'ºC'),
	(248857, 120, '2014-03-15 00:00:07.000000', 'temperatura', 335.0000, 'ºC'),
	(248858, 120, '2014-03-15 00:00:08.000000', 'temperatura', 966.0000, 'ºC'),
	(248859, 120, '2014-03-15 00:00:09.000000', 'temperatura', 222.0000, 'ºC'),
	(248860, 120, '2014-03-15 00:00:10.000000', 'temperatura', 615.0000, 'ºC'),
	(248861, 120, '2014-03-15 00:00:11.000000', 'temperatura', 8.0000, 'ºC'),
	(248862, 120, '2014-03-15 00:00:12.000000', 'temperatura', 595.0000, 'ºC'),
	(248863, 120, '2014-03-15 00:00:13.000000', 'temperatura', 553.0000, 'ºC'),
	(248864, 120, '2014-03-15 00:00:14.000000', 'temperatura', 981.0000, 'ºC'),
	(248865, 120, '2014-03-15 00:00:15.000000', 'temperatura', 844.0000, 'ºC'),
	(248866, 120, '2014-03-15 00:00:16.000000', 'temperatura', 80.0000, 'ºC'),
	(248867, 120, '2014-03-15 00:00:17.000000', 'temperatura', 269.0000, 'ºC'),
	(248868, 120, '2014-03-15 00:00:18.000000', 'temperatura', 1106.0000, 'ºC'),
	(248869, 120, '2014-03-15 00:00:19.000000', 'temperatura', 1124.0000, 'ºC'),
	(248870, 120, '2014-03-15 00:00:20.000000', 'temperatura', 1102.0000, 'ºC'),
	(248871, 120, '2014-03-15 00:00:21.000000', 'temperatura', 938.0000, 'ºC'),
	(248872, 120, '2014-03-15 00:00:22.000000', 'temperatura', 185.0000, 'ºC'),
	(248873, 120, '2014-03-15 00:00:23.000000', 'temperatura', 509.0000, 'ºC'),
	(248874, 120, '2014-03-15 00:00:24.000000', 'temperatura', 793.0000, 'ºC'),
	(248875, 120, '2014-03-15 00:00:25.000000', 'temperatura', 39.0000, 'ºC'),
	(248876, 120, '2014-03-15 00:00:26.000000', 'temperatura', 215.0000, 'ºC'),
	(248877, 120, '2014-03-15 00:00:27.000000', 'temperatura', 960.0000, 'ºC'),
	(248878, 120, '2014-03-15 00:00:28.000000', 'temperatura', 554.0000, 'ºC'),
	(248879, 120, '2014-03-15 00:00:29.000000', 'temperatura', 1091.0000, 'ºC'),
	(248880, 120, '2014-03-15 00:00:30.000000', 'temperatura', 193.0000, 'ºC'),
	(248881, 120, '2014-03-15 00:00:31.000000', 'temperatura', 95.0000, 'ºC'),
	(248882, 120, '2014-03-15 00:00:32.000000', 'temperatura', 1093.0000, 'ºC'),
	(248883, 120, '2014-03-15 00:00:33.000000', 'temperatura', 384.0000, 'ºC'),
	(248884, 120, '2014-03-15 00:00:34.000000', 'temperatura', 1039.0000, 'ºC'),
	(248885, 120, '2014-03-15 00:00:35.000000', 'temperatura', 443.0000, 'ºC'),
	(248886, 120, '2014-03-15 00:00:36.000000', 'temperatura', 300.0000, 'ºC'),
	(248887, 120, '2014-03-15 00:00:37.000000', 'temperatura', 172.0000, 'ºC'),
	(248888, 120, '2014-03-15 00:00:38.000000', 'temperatura', 1159.0000, 'ºC'),
	(248889, 120, '2014-03-15 00:00:39.000000', 'temperatura', 478.0000, 'ºC'),
	(248890, 120, '2014-03-15 00:00:40.000000', 'temperatura', 115.0000, 'ºC'),
	(248891, 120, '2014-03-15 00:00:41.000000', 'temperatura', 343.0000, 'ºC'),
	(248892, 120, '2014-03-15 00:00:42.000000', 'temperatura', 172.0000, 'ºC'),
	(248893, 120, '2014-03-15 00:00:43.000000', 'temperatura', 1028.0000, 'ºC'),
	(248894, 120, '2014-03-15 00:00:44.000000', 'temperatura', 1025.0000, 'ºC'),
	(248895, 120, '2014-03-15 00:00:45.000000', 'temperatura', 841.0000, 'ºC'),
	(248896, 120, '2014-03-15 00:00:46.000000', 'temperatura', 1130.0000, 'ºC'),
	(248897, 120, '2014-03-15 00:00:47.000000', 'temperatura', 730.0000, 'ºC'),
	(248898, 120, '2014-03-15 00:00:48.000000', 'temperatura', 259.0000, 'ºC'),
	(248899, 120, '2014-03-15 00:00:49.000000', 'temperatura', 306.0000, 'ºC'),
	(248900, 120, '2014-03-15 00:00:50.000000', 'temperatura', 754.0000, 'ºC'),
	(248901, 120, '2014-03-15 00:00:51.000000', 'temperatura', 450.0000, 'ºC'),
	(248902, 120, '2014-03-15 00:00:52.000000', 'temperatura', 1192.0000, 'ºC'),
	(248903, 120, '2014-03-15 00:00:53.000000', 'temperatura', 1008.0000, 'ºC'),
	(248904, 120, '2014-03-15 00:00:54.000000', 'temperatura', 266.0000, 'ºC'),
	(248905, 120, '2014-03-15 00:00:55.000000', 'temperatura', 705.0000, 'ºC'),
	(248906, 120, '2014-03-15 00:00:56.000000', 'temperatura', 330.0000, 'ºC'),
	(248907, 120, '2014-03-15 00:00:57.000000', 'temperatura', 733.0000, 'ºC'),
	(248908, 120, '2014-03-15 00:00:58.000000', 'temperatura', 277.0000, 'ºC'),
	(248909, 120, '2014-03-15 00:00:59.000000', 'temperatura', 385.0000, 'ºC'),
	(248910, 120, '2014-03-15 00:01:00.000000', 'temperatura', 1095.0000, 'ºC'),
	(248911, 120, '2014-03-15 00:01:01.000000', 'temperatura', 720.0000, 'ºC'),
	(248912, 120, '2014-03-15 00:01:02.000000', 'temperatura', 316.0000, 'ºC'),
	(248913, 120, '2014-03-15 00:01:03.000000', 'temperatura', 620.0000, 'ºC'),
	(248914, 120, '2014-03-15 00:01:04.000000', 'temperatura', 954.0000, 'ºC'),
	(248915, 120, '2014-03-15 00:01:05.000000', 'temperatura', 509.0000, 'ºC'),
	(248916, 120, '2014-03-15 00:01:06.000000', 'temperatura', 883.0000, 'ºC'),
	(248917, 120, '2014-03-15 00:01:07.000000', 'temperatura', 489.0000, 'ºC'),
	(248918, 120, '2014-03-15 00:01:08.000000', 'temperatura', 997.0000, 'ºC'),
	(248919, 120, '2014-03-15 00:01:09.000000', 'temperatura', 1117.0000, 'ºC'),
	(248920, 120, '2014-03-15 00:01:10.000000', 'temperatura', 196.0000, 'ºC'),
	(248921, 120, '2014-03-15 00:01:11.000000', 'temperatura', 31.0000, 'ºC'),
	(248922, 120, '2014-03-15 00:01:12.000000', 'temperatura', 765.0000, 'ºC'),
	(248923, 120, '2014-03-15 00:01:13.000000', 'temperatura', 135.0000, 'ºC'),
	(248924, 120, '2014-03-15 00:01:14.000000', 'temperatura', 781.0000, 'ºC'),
	(248925, 120, '2014-03-15 00:01:15.000000', 'temperatura', 1099.0000, 'ºC'),
	(248926, 120, '2014-03-15 00:01:16.000000', 'temperatura', 753.0000, 'ºC'),
	(248927, 120, '2014-03-15 00:01:17.000000', 'temperatura', 468.0000, 'ºC'),
	(248928, 120, '2014-03-15 00:01:18.000000', 'temperatura', 81.0000, 'ºC'),
	(248929, 120, '2014-03-15 00:01:19.000000', 'temperatura', 201.0000, 'ºC'),
	(248930, 120, '2014-03-15 00:01:20.000000', 'temperatura', 763.0000, 'ºC'),
	(248931, 120, '2014-03-15 00:01:21.000000', 'temperatura', 811.0000, 'ºC'),
	(248932, 120, '2014-03-15 00:01:22.000000', 'temperatura', 569.0000, 'ºC'),
	(248933, 120, '2014-03-15 00:01:23.000000', 'temperatura', 413.0000, 'ºC'),
	(248934, 120, '2014-03-15 00:01:24.000000', 'temperatura', 356.0000, 'ºC'),
	(248935, 120, '2014-03-15 00:01:25.000000', 'temperatura', 544.0000, 'ºC'),
	(248936, 120, '2014-03-15 00:01:26.000000', 'temperatura', 452.0000, 'ºC'),
	(248937, 120, '2014-03-15 00:01:27.000000', 'temperatura', 629.0000, 'ºC'),
	(248938, 120, '2014-03-15 00:01:28.000000', 'temperatura', 587.0000, 'ºC'),
	(248939, 120, '2014-03-15 00:01:29.000000', 'temperatura', 1050.0000, 'ºC'),
	(248940, 120, '2014-03-15 00:01:30.000000', 'temperatura', 1089.0000, 'ºC'),
	(248941, 120, '2014-03-15 00:01:31.000000', 'temperatura', 1097.0000, 'ºC'),
	(248942, 120, '2014-03-15 00:01:32.000000', 'temperatura', 1019.0000, 'ºC'),
	(248943, 120, '2014-03-15 00:01:33.000000', 'temperatura', 602.0000, 'ºC'),
	(248944, 120, '2014-03-15 00:01:34.000000', 'temperatura', 1156.0000, 'ºC'),
	(248945, 120, '2014-03-15 00:01:35.000000', 'temperatura', 372.0000, 'ºC'),
	(248946, 120, '2014-03-15 00:01:36.000000', 'temperatura', 794.0000, 'ºC'),
	(248947, 120, '2014-03-15 00:01:37.000000', 'temperatura', 453.0000, 'ºC'),
	(248948, 120, '2014-03-15 00:01:38.000000', 'temperatura', 1085.0000, 'ºC'),
	(248949, 120, '2014-03-15 00:01:39.000000', 'temperatura', 465.0000, 'ºC'),
	(248950, 120, '2014-03-15 00:01:40.000000', 'temperatura', 271.0000, 'ºC'),
	(248951, 120, '2014-03-15 00:01:41.000000', 'temperatura', 1161.0000, 'ºC'),
	(248952, 120, '2014-03-15 00:01:42.000000', 'temperatura', 194.0000, 'ºC'),
	(248953, 120, '2014-03-15 00:01:43.000000', 'temperatura', 1088.0000, 'ºC'),
	(248954, 120, '2014-03-15 00:01:44.000000', 'temperatura', 56.0000, 'ºC'),
	(248955, 120, '2014-03-15 00:01:45.000000', 'temperatura', 618.0000, 'ºC'),
	(248956, 120, '2014-03-15 00:01:46.000000', 'temperatura', 524.0000, 'ºC'),
	(248957, 120, '2014-03-15 00:01:47.000000', 'temperatura', 764.0000, 'ºC'),
	(248958, 120, '2014-03-15 00:01:48.000000', 'temperatura', 1051.0000, 'ºC'),
	(248959, 120, '2014-03-15 00:01:49.000000', 'temperatura', 564.0000, 'ºC'),
	(248960, 120, '2014-03-15 00:01:50.000000', 'temperatura', 865.0000, 'ºC'),
	(248961, 120, '2014-03-15 00:01:51.000000', 'temperatura', 233.0000, 'ºC'),
	(248962, 120, '2014-03-15 00:01:52.000000', 'temperatura', 972.0000, 'ºC'),
	(248963, 120, '2014-03-15 00:01:53.000000', 'temperatura', 561.0000, 'ºC'),
	(248964, 120, '2014-03-15 00:01:54.000000', 'temperatura', 1089.0000, 'ºC'),
	(248965, 120, '2014-03-15 00:01:55.000000', 'temperatura', 161.0000, 'ºC'),
	(248966, 120, '2014-03-15 00:01:56.000000', 'temperatura', 1139.0000, 'ºC'),
	(248967, 120, '2014-03-15 00:01:57.000000', 'temperatura', 414.0000, 'ºC'),
	(248968, 120, '2014-03-15 00:01:58.000000', 'temperatura', 1053.0000, 'ºC'),
	(248969, 120, '2014-03-15 00:01:59.000000', 'temperatura', 421.0000, 'ºC'),
	(248970, 120, '2014-03-15 00:02:00.000000', 'temperatura', 150.0000, 'ºC'),
	(248971, 120, '2014-03-15 00:02:01.000000', 'temperatura', 685.0000, 'ºC'),
	(248972, 120, '2014-03-15 00:02:02.000000', 'temperatura', 577.0000, 'ºC'),
	(248973, 120, '2014-03-15 00:02:03.000000', 'temperatura', 830.0000, 'ºC'),
	(248974, 120, '2014-03-15 00:02:04.000000', 'temperatura', 18.0000, 'ºC'),
	(248975, 120, '2014-03-15 00:02:05.000000', 'temperatura', 0.0000, 'ºC'),
	(248976, 120, '2014-03-15 00:02:06.000000', 'temperatura', 1146.0000, 'ºC'),
	(248977, 120, '2014-03-15 00:02:07.000000', 'temperatura', 933.0000, 'ºC'),
	(248978, 120, '2014-03-15 00:02:08.000000', 'temperatura', 26.0000, 'ºC'),
	(248979, 120, '2014-03-15 00:02:09.000000', 'temperatura', 933.0000, 'ºC'),
	(248980, 120, '2014-03-15 00:02:10.000000', 'temperatura', 986.0000, 'ºC'),
	(248981, 120, '2014-03-15 00:02:11.000000', 'temperatura', 933.0000, 'ºC'),
	(248982, 120, '2014-03-15 00:02:12.000000', 'temperatura', 507.0000, 'ºC'),
	(248983, 120, '2014-03-15 00:02:13.000000', 'temperatura', 934.0000, 'ºC'),
	(248984, 120, '2014-03-15 00:02:14.000000', 'temperatura', 753.0000, 'ºC'),
	(248985, 120, '2014-03-15 00:02:15.000000', 'temperatura', 961.0000, 'ºC'),
	(248986, 120, '2014-03-15 00:02:16.000000', 'temperatura', 149.0000, 'ºC'),
	(248987, 120, '2014-03-15 00:02:17.000000', 'temperatura', 263.0000, 'ºC'),
	(248988, 120, '2014-03-15 00:02:18.000000', 'temperatura', 867.0000, 'ºC'),
	(248989, 120, '2014-03-15 00:02:19.000000', 'temperatura', 1148.0000, 'ºC'),
	(248990, 120, '2014-03-15 00:02:20.000000', 'temperatura', 741.0000, 'ºC'),
	(248991, 120, '2014-03-15 00:02:21.000000', 'temperatura', 258.0000, 'ºC'),
	(248992, 120, '2014-03-15 00:02:22.000000', 'temperatura', 271.0000, 'ºC'),
	(248993, 120, '2014-03-15 00:02:23.000000', 'temperatura', 578.0000, 'ºC'),
	(248994, 120, '2014-03-15 00:02:24.000000', 'temperatura', 879.0000, 'ºC'),
	(248995, 120, '2014-03-15 00:02:25.000000', 'temperatura', 263.0000, 'ºC'),
	(248996, 120, '2014-03-15 00:02:26.000000', 'temperatura', 1076.0000, 'ºC'),
	(248997, 120, '2014-03-15 00:02:27.000000', 'temperatura', 991.0000, 'ºC'),
	(248998, 120, '2014-03-15 00:02:28.000000', 'temperatura', 531.0000, 'ºC'),
	(248999, 120, '2014-03-15 00:02:29.000000', 'temperatura', 879.0000, 'ºC'),
	(249000, 120, '2014-03-15 00:02:30.000000', 'temperatura', 402.0000, 'ºC'),
	(249001, 120, '2014-03-15 00:02:31.000000', 'temperatura', 577.0000, 'ºC'),
	(249002, 120, '2014-03-15 00:02:32.000000', 'temperatura', 476.0000, 'ºC'),
	(249003, 120, '2014-03-15 00:02:33.000000', 'temperatura', 651.0000, 'ºC'),
	(249004, 120, '2014-03-15 00:02:34.000000', 'temperatura', 629.0000, 'ºC'),
	(249005, 120, '2014-03-15 00:02:35.000000', 'temperatura', 1192.0000, 'ºC'),
	(249006, 120, '2014-03-15 00:02:36.000000', 'temperatura', 472.0000, 'ºC'),
	(249007, 120, '2014-03-15 00:02:37.000000', 'temperatura', 1185.0000, 'ºC'),
	(249008, 120, '2014-03-15 00:02:38.000000', 'temperatura', 908.0000, 'ºC'),
	(249009, 120, '2014-03-15 00:02:39.000000', 'temperatura', 985.0000, 'ºC'),
	(249010, 120, '2014-03-15 00:02:40.000000', 'temperatura', 1001.0000, 'ºC'),
	(249011, 120, '2014-03-15 00:02:41.000000', 'temperatura', 852.0000, 'ºC'),
	(249012, 120, '2014-03-15 00:02:42.000000', 'temperatura', 58.0000, 'ºC'),
	(249013, 120, '2014-03-15 00:02:43.000000', 'temperatura', 132.0000, 'ºC'),
	(249014, 120, '2014-03-15 00:02:44.000000', 'temperatura', 489.0000, 'ºC'),
	(249015, 120, '2014-03-15 00:02:45.000000', 'temperatura', 850.0000, 'ºC'),
	(249016, 120, '2014-03-15 00:02:46.000000', 'temperatura', 382.0000, 'ºC'),
	(249017, 120, '2014-03-15 00:02:47.000000', 'temperatura', 560.0000, 'ºC'),
	(249018, 120, '2014-03-15 00:02:48.000000', 'temperatura', 455.0000, 'ºC'),
	(249019, 120, '2014-03-15 00:02:49.000000', 'temperatura', 597.0000, 'ºC'),
	(249020, 120, '2014-03-15 00:02:50.000000', 'temperatura', 420.0000, 'ºC'),
	(249021, 120, '2014-03-15 00:02:51.000000', 'temperatura', 309.0000, 'ºC'),
	(249022, 120, '2014-03-15 00:02:52.000000', 'temperatura', 284.0000, 'ºC'),
	(249023, 120, '2014-03-15 00:02:53.000000', 'temperatura', 493.0000, 'ºC'),
	(249024, 120, '2014-03-15 00:02:54.000000', 'temperatura', 415.0000, 'ºC'),
	(249025, 120, '2014-03-15 00:02:55.000000', 'temperatura', 596.0000, 'ºC'),
	(249026, 120, '2014-03-15 00:02:56.000000', 'temperatura', 536.0000, 'ºC'),
	(249027, 120, '2014-03-15 00:02:57.000000', 'temperatura', 893.0000, 'ºC'),
	(249028, 120, '2014-03-15 00:02:58.000000', 'temperatura', 456.0000, 'ºC'),
	(249029, 120, '2014-03-15 00:02:59.000000', 'temperatura', 802.0000, 'ºC'),
	(249030, 120, '2014-03-15 00:03:00.000000', 'temperatura', 244.0000, 'ºC'),
	(249031, 120, '2014-03-15 00:03:01.000000', 'temperatura', 15.0000, 'ºC'),
	(249032, 120, '2014-03-15 00:03:02.000000', 'temperatura', 544.0000, 'ºC'),
	(249033, 120, '2014-03-15 00:03:03.000000', 'temperatura', 273.0000, 'ºC'),
	(249034, 120, '2014-03-15 00:03:04.000000', 'temperatura', 934.0000, 'ºC'),
	(249035, 120, '2014-03-15 00:03:05.000000', 'temperatura', 251.0000, 'ºC'),
	(249036, 120, '2014-03-15 00:03:06.000000', 'temperatura', 855.0000, 'ºC'),
	(249037, 120, '2014-03-15 00:03:07.000000', 'temperatura', 1120.0000, 'ºC'),
	(249038, 120, '2014-03-15 00:03:08.000000', 'temperatura', 639.0000, 'ºC'),
	(249039, 120, '2014-03-15 00:03:09.000000', 'temperatura', 1033.0000, 'ºC'),
	(249040, 120, '2014-03-15 00:03:10.000000', 'temperatura', 850.0000, 'ºC'),
	(249041, 120, '2014-03-15 00:03:11.000000', 'temperatura', 1151.0000, 'ºC'),
	(249042, 120, '2014-03-15 00:03:12.000000', 'temperatura', 804.0000, 'ºC'),
	(249043, 120, '2014-03-15 00:03:13.000000', 'temperatura', 569.0000, 'ºC'),
	(249044, 120, '2014-03-15 00:03:14.000000', 'temperatura', 435.0000, 'ºC'),
	(249045, 120, '2014-03-15 00:03:15.000000', 'temperatura', 467.0000, 'ºC'),
	(249046, 120, '2014-03-15 00:03:16.000000', 'temperatura', 1033.0000, 'ºC'),
	(249047, 120, '2014-03-15 00:03:17.000000', 'temperatura', 162.0000, 'ºC'),
	(249048, 120, '2014-03-15 00:03:18.000000', 'temperatura', 110.0000, 'ºC'),
	(249049, 120, '2014-03-15 00:03:19.000000', 'temperatura', 68.0000, 'ºC'),
	(249050, 120, '2014-03-15 00:03:20.000000', 'temperatura', 9.0000, 'ºC'),
	(249051, 120, '2014-03-15 00:03:21.000000', 'temperatura', 1040.0000, 'ºC'),
	(249052, 120, '2014-03-15 00:03:22.000000', 'temperatura', 376.0000, 'ºC'),
	(249053, 120, '2014-03-15 00:03:23.000000', 'temperatura', 1161.0000, 'ºC'),
	(249054, 120, '2014-03-15 00:03:24.000000', 'temperatura', 1075.0000, 'ºC'),
	(249055, 120, '2014-03-15 00:03:25.000000', 'temperatura', 695.0000, 'ºC'),
	(249056, 120, '2014-03-15 00:03:26.000000', 'temperatura', 248.0000, 'ºC'),
	(249057, 120, '2014-03-15 00:03:27.000000', 'temperatura', 357.0000, 'ºC'),
	(249058, 120, '2014-03-15 00:03:28.000000', 'temperatura', 1043.0000, 'ºC'),
	(249059, 120, '2014-03-15 00:03:29.000000', 'temperatura', 544.0000, 'ºC'),
	(249060, 120, '2014-03-15 00:03:30.000000', 'temperatura', 793.0000, 'ºC'),
	(249061, 120, '2014-03-15 00:03:31.000000', 'temperatura', 1131.0000, 'ºC'),
	(249062, 120, '2014-03-15 00:03:32.000000', 'temperatura', 877.0000, 'ºC'),
	(249063, 120, '2014-03-15 00:03:33.000000', 'temperatura', 994.0000, 'ºC'),
	(249064, 120, '2014-03-15 00:03:34.000000', 'temperatura', 1140.0000, 'ºC'),
	(249065, 120, '2014-03-15 00:03:35.000000', 'temperatura', 319.0000, 'ºC'),
	(249066, 120, '2014-03-15 00:03:36.000000', 'temperatura', 576.0000, 'ºC'),
	(249067, 120, '2014-03-15 00:03:37.000000', 'temperatura', 725.0000, 'ºC'),
	(249068, 120, '2014-03-15 00:03:38.000000', 'temperatura', 694.0000, 'ºC'),
	(249069, 120, '2014-03-15 00:03:39.000000', 'temperatura', 95.0000, 'ºC'),
	(249070, 120, '2014-03-15 00:03:40.000000', 'temperatura', 795.0000, 'ºC'),
	(249071, 120, '2014-03-15 00:03:41.000000', 'temperatura', 90.0000, 'ºC'),
	(249072, 120, '2014-03-15 00:03:42.000000', 'temperatura', 467.0000, 'ºC'),
	(249073, 120, '2014-03-15 00:03:43.000000', 'temperatura', 864.0000, 'ºC'),
	(249074, 120, '2014-03-15 00:03:44.000000', 'temperatura', 518.0000, 'ºC'),
	(249075, 120, '2014-03-15 00:03:45.000000', 'temperatura', 0.0000, 'ºC'),
	(249076, 120, '2014-03-15 00:03:46.000000', 'temperatura', 845.0000, 'ºC'),
	(249077, 120, '2014-03-15 00:03:47.000000', 'temperatura', 626.0000, 'ºC'),
	(249078, 120, '2014-03-15 00:03:48.000000', 'temperatura', 596.0000, 'ºC'),
	(249079, 120, '2014-03-15 00:03:49.000000', 'temperatura', 1102.0000, 'ºC'),
	(249080, 120, '2014-03-15 00:03:50.000000', 'temperatura', 123.0000, 'ºC'),
	(249081, 120, '2014-03-15 00:03:51.000000', 'temperatura', 909.0000, 'ºC'),
	(249082, 120, '2014-03-15 00:03:52.000000', 'temperatura', 578.0000, 'ºC'),
	(249083, 120, '2014-03-15 00:03:53.000000', 'temperatura', 164.0000, 'ºC'),
	(249084, 120, '2014-03-15 00:03:54.000000', 'temperatura', 286.0000, 'ºC'),
	(249085, 120, '2014-03-15 00:03:55.000000', 'temperatura', 938.0000, 'ºC'),
	(249086, 120, '2014-03-15 00:03:56.000000', 'temperatura', 233.0000, 'ºC'),
	(249087, 120, '2014-03-15 00:03:57.000000', 'temperatura', 752.0000, 'ºC'),
	(249088, 120, '2014-03-15 00:03:58.000000', 'temperatura', 660.0000, 'ºC'),
	(249089, 120, '2014-03-15 00:03:59.000000', 'temperatura', 1045.0000, 'ºC'),
	(249090, 120, '2014-03-15 00:04:00.000000', 'temperatura', 845.0000, 'ºC'),
	(249091, 120, '2014-03-15 00:04:01.000000', 'temperatura', 1090.0000, 'ºC'),
	(249092, 120, '2014-03-15 00:04:02.000000', 'temperatura', 517.0000, 'ºC'),
	(249093, 120, '2014-03-15 00:04:03.000000', 'temperatura', 513.0000, 'ºC'),
	(249094, 120, '2014-03-15 00:04:04.000000', 'temperatura', 1017.0000, 'ºC'),
	(249095, 120, '2014-03-15 00:04:05.000000', 'temperatura', 1145.0000, 'ºC'),
	(249096, 120, '2014-03-15 00:04:06.000000', 'temperatura', 276.0000, 'ºC'),
	(249097, 120, '2014-03-15 00:04:07.000000', 'temperatura', 345.0000, 'ºC'),
	(249098, 120, '2014-03-15 00:04:08.000000', 'temperatura', 896.0000, 'ºC'),
	(249099, 120, '2014-03-15 00:04:09.000000', 'temperatura', 1048.0000, 'ºC'),
	(249100, 120, '2014-03-15 00:04:10.000000', 'temperatura', 151.0000, 'ºC'),
	(249101, 120, '2014-03-15 00:04:11.000000', 'temperatura', 11.0000, 'ºC'),
	(249102, 120, '2014-03-15 00:04:12.000000', 'temperatura', 804.0000, 'ºC'),
	(249103, 120, '2014-03-15 00:04:13.000000', 'temperatura', 387.0000, 'ºC'),
	(249104, 120, '2014-03-15 00:04:14.000000', 'temperatura', 722.0000, 'ºC'),
	(249105, 120, '2014-03-15 00:04:15.000000', 'temperatura', 49.0000, 'ºC'),
	(249106, 120, '2014-03-15 00:04:16.000000', 'temperatura', 480.0000, 'ºC'),
	(249107, 120, '2014-03-15 00:04:17.000000', 'temperatura', 1056.0000, 'ºC'),
	(249108, 120, '2014-03-15 00:04:18.000000', 'temperatura', 238.0000, 'ºC'),
	(249109, 120, '2014-03-15 00:04:19.000000', 'temperatura', 423.0000, 'ºC'),
	(249110, 120, '2014-03-15 00:04:20.000000', 'temperatura', 203.0000, 'ºC'),
	(249111, 120, '2014-03-15 00:04:21.000000', 'temperatura', 945.0000, 'ºC'),
	(249112, 120, '2014-03-15 00:04:22.000000', 'temperatura', 516.0000, 'ºC'),
	(249113, 120, '2014-03-15 00:04:23.000000', 'temperatura', 944.0000, 'ºC'),
	(249114, 120, '2014-03-15 00:04:24.000000', 'temperatura', 775.0000, 'ºC'),
	(249115, 120, '2014-03-15 00:04:25.000000', 'temperatura', 1042.0000, 'ºC'),
	(249116, 120, '2014-03-15 00:04:26.000000', 'temperatura', 487.0000, 'ºC'),
	(249117, 120, '2014-03-15 00:04:27.000000', 'temperatura', 510.0000, 'ºC'),
	(249118, 120, '2014-03-15 00:04:28.000000', 'temperatura', 1089.0000, 'ºC'),
	(249119, 120, '2014-03-15 00:04:29.000000', 'temperatura', 316.0000, 'ºC'),
	(249120, 120, '2014-03-15 00:04:30.000000', 'temperatura', 711.0000, 'ºC'),
	(249121, 120, '2014-03-15 00:04:31.000000', 'temperatura', 210.0000, 'ºC'),
	(249122, 120, '2014-03-15 00:04:32.000000', 'temperatura', 119.0000, 'ºC'),
	(249123, 120, '2014-03-15 00:04:33.000000', 'temperatura', 1162.0000, 'ºC'),
	(249124, 120, '2014-03-15 00:04:34.000000', 'temperatura', 656.0000, 'ºC'),
	(249125, 120, '2014-03-15 00:04:35.000000', 'temperatura', 994.0000, 'ºC'),
	(249126, 120, '2014-03-15 00:04:36.000000', 'temperatura', 604.0000, 'ºC'),
	(249127, 120, '2014-03-15 00:04:37.000000', 'temperatura', 36.0000, 'ºC'),
	(249128, 120, '2014-03-15 00:04:38.000000', 'temperatura', 769.0000, 'ºC'),
	(249129, 120, '2014-03-15 00:04:39.000000', 'temperatura', 139.0000, 'ºC'),
	(249130, 120, '2014-03-15 00:04:40.000000', 'temperatura', 786.0000, 'ºC'),
	(249131, 120, '2014-03-15 00:04:41.000000', 'temperatura', 1116.0000, 'ºC'),
	(249132, 120, '2014-03-15 00:04:42.000000', 'temperatura', 823.0000, 'ºC'),
	(249133, 120, '2014-03-15 00:04:43.000000', 'temperatura', 766.0000, 'ºC'),
	(249134, 120, '2014-03-15 00:04:44.000000', 'temperatura', 162.0000, 'ºC'),
	(249135, 120, '2014-03-15 00:04:45.000000', 'temperatura', 914.0000, 'ºC'),
	(249136, 120, '2014-03-15 00:04:46.000000', 'temperatura', 484.0000, 'ºC'),
	(249137, 120, '2014-03-15 00:04:47.000000', 'temperatura', 876.0000, 'ºC'),
	(249138, 120, '2014-03-15 00:04:48.000000', 'temperatura', 530.0000, 'ºC'),
	(249139, 120, '2014-03-15 00:04:49.000000', 'temperatura', 24.0000, 'ºC'),
	(249140, 120, '2014-03-15 00:04:50.000000', 'temperatura', 929.0000, 'ºC'),
	(249141, 120, '2014-03-15 00:04:51.000000', 'temperatura', 973.0000, 'ºC'),
	(249142, 120, '2014-03-15 00:04:52.000000', 'temperatura', 878.0000, 'ºC'),
	(249143, 120, '2014-03-15 00:04:53.000000', 'temperatura', 272.0000, 'ºC'),
	(249144, 120, '2014-03-15 00:04:54.000000', 'temperatura', 1128.0000, 'ºC'),
	(249145, 120, '2014-03-15 00:04:55.000000', 'temperatura', 25.0000, 'ºC'),
	(249146, 120, '2014-03-15 00:04:56.000000', 'temperatura', 342.0000, 'ºC'),
	(249147, 120, '2014-03-15 00:04:57.000000', 'temperatura', 434.0000, 'ºC'),
	(249148, 120, '2014-03-15 00:04:58.000000', 'temperatura', 1145.0000, 'ºC'),
	(249149, 120, '2014-03-15 00:04:59.000000', 'temperatura', 821.0000, 'ºC'),
	(249150, 120, '2014-03-15 00:05:00.000000', 'temperatura', 673.0000, 'ºC'),
	(249151, 120, '2014-03-15 00:05:01.000000', 'temperatura', 903.0000, 'ºC'),
	(249152, 120, '2014-03-15 00:05:02.000000', 'temperatura', 94.0000, 'ºC'),
	(249153, 120, '2014-03-15 00:05:03.000000', 'temperatura', 161.0000, 'ºC'),
	(249154, 120, '2014-03-15 00:05:04.000000', 'temperatura', 525.0000, 'ºC'),
	(249155, 120, '2014-03-15 00:05:05.000000', 'temperatura', 943.0000, 'ºC'),
	(249156, 120, '2014-03-15 00:05:06.000000', 'temperatura', 739.0000, 'ºC'),
	(249157, 120, '2014-03-15 00:05:07.000000', 'temperatura', 867.0000, 'ºC'),
	(249158, 120, '2014-03-15 00:05:08.000000', 'temperatura', 919.0000, 'ºC'),
	(249159, 120, '2014-03-15 00:05:09.000000', 'temperatura', 795.0000, 'ºC'),
	(249160, 120, '2014-03-15 00:05:10.000000', 'temperatura', 17.0000, 'ºC'),
	(249161, 120, '2014-03-15 00:05:11.000000', 'temperatura', 102.0000, 'ºC'),
	(249162, 120, '2014-03-15 00:05:12.000000', 'temperatura', 460.0000, 'ºC'),
	(249163, 120, '2014-03-15 00:05:13.000000', 'temperatura', 795.0000, 'ºC'),
	(249164, 120, '2014-03-15 00:05:14.000000', 'temperatura', 196.0000, 'ºC'),
	(249165, 120, '2014-03-15 00:05:15.000000', 'temperatura', 993.0000, 'ºC'),
	(249166, 120, '2014-03-15 00:05:16.000000', 'temperatura', 777.0000, 'ºC'),
	(249167, 120, '2014-03-15 00:05:17.000000', 'temperatura', 909.0000, 'ºC'),
	(249168, 120, '2014-03-15 00:05:18.000000', 'temperatura', 1015.0000, 'ºC'),
	(249169, 120, '2014-03-15 00:05:19.000000', 'temperatura', 1146.0000, 'ºC'),
	(249170, 120, '2014-03-15 00:05:20.000000', 'temperatura', 285.0000, 'ºC'),
	(249171, 120, '2014-03-15 00:05:21.000000', 'temperatura', 389.0000, 'ºC'),
	(249172, 120, '2014-03-15 00:05:22.000000', 'temperatura', 1091.0000, 'ºC'),
	(249173, 120, '2014-03-15 00:05:23.000000', 'temperatura', 689.0000, 'ºC'),
	(249174, 120, '2014-03-15 00:05:24.000000', 'temperatura', 170.0000, 'ºC'),
	(249175, 120, '2014-03-15 00:05:25.000000', 'temperatura', 1185.0000, 'ºC'),
	(249176, 120, '2014-03-15 00:05:26.000000', 'temperatura', 615.0000, 'ºC'),
	(249177, 120, '2014-03-15 00:05:27.000000', 'temperatura', 722.0000, 'ºC'),
	(249178, 120, '2014-03-15 00:05:28.000000', 'temperatura', 563.0000, 'ºC'),
	(249179, 120, '2014-03-15 00:05:29.000000', 'temperatura', 650.0000, 'ºC'),
	(249180, 120, '2014-03-15 00:05:30.000000', 'temperatura', 360.0000, 'ºC'),
	(249181, 120, '2014-03-15 00:05:31.000000', 'temperatura', 1053.0000, 'ºC'),
	(249182, 120, '2014-03-15 00:05:32.000000', 'temperatura', 585.0000, 'ºC'),
	(249183, 120, '2014-03-15 00:05:33.000000', 'temperatura', 965.0000, 'ºC'),
	(249184, 120, '2014-03-15 00:05:34.000000', 'temperatura', 673.0000, 'ºC'),
	(249185, 120, '2014-03-15 00:05:35.000000', 'temperatura', 470.0000, 'ºC'),
	(249186, 120, '2014-03-15 00:05:36.000000', 'temperatura', 332.0000, 'ºC'),
	(249187, 120, '2014-03-15 00:05:37.000000', 'temperatura', 252.0000, 'ºC'),
	(249188, 120, '2014-03-15 00:05:38.000000', 'temperatura', 262.0000, 'ºC'),
	(249189, 120, '2014-03-15 00:05:39.000000', 'temperatura', 554.0000, 'ºC'),
	(249190, 120, '2014-03-15 00:05:40.000000', 'temperatura', 786.0000, 'ºC'),
	(249191, 120, '2014-03-15 00:05:41.000000', 'temperatura', 1069.0000, 'ºC'),
	(249192, 120, '2014-03-15 00:05:42.000000', 'temperatura', 586.0000, 'ºC'),
	(249193, 120, '2014-03-15 00:05:43.000000', 'temperatura', 924.0000, 'ºC'),
	(249194, 120, '2014-03-15 00:05:44.000000', 'temperatura', 463.0000, 'ºC'),
	(249195, 120, '2014-03-15 00:05:45.000000', 'temperatura', 744.0000, 'ºC'),
	(249196, 120, '2014-03-15 00:05:46.000000', 'temperatura', 1133.0000, 'ºC'),
	(249197, 120, '2014-03-15 00:05:47.000000', 'temperatura', 1032.0000, 'ºC'),
	(249198, 120, '2014-03-15 00:05:48.000000', 'temperatura', 562.0000, 'ºC'),
	(249199, 120, '2014-03-15 00:05:49.000000', 'temperatura', 913.0000, 'ºC'),
	(249200, 120, '2014-03-15 00:05:50.000000', 'temperatura', 482.0000, 'ºC'),
	(249201, 120, '2014-03-15 00:05:51.000000', 'temperatura', 872.0000, 'ºC'),
	(249202, 120, '2014-03-15 00:05:52.000000', 'temperatura', 512.0000, 'ºC'),
	(249203, 120, '2014-03-15 00:05:53.000000', 'temperatura', 1144.0000, 'ºC'),
	(249204, 120, '2014-03-15 00:05:54.000000', 'temperatura', 585.0000, 'ºC'),
	(249205, 120, '2014-03-15 00:05:55.000000', 'temperatura', 694.0000, 'ºC'),
	(249206, 120, '2014-03-15 00:05:56.000000', 'temperatura', 513.0000, 'ºC'),
	(249207, 120, '2014-03-15 00:05:57.000000', 'temperatura', 487.0000, 'ºC'),
	(249208, 120, '2014-03-15 00:05:58.000000', 'temperatura', 895.0000, 'ºC'),
	(249209, 120, '2014-03-15 00:05:59.000000', 'temperatura', 614.0000, 'ºC'),
	(249210, 120, '2014-03-15 00:06:00.000000', 'temperatura', 386.0000, 'ºC'),
	(249211, 120, '2014-03-15 00:06:01.000000', 'temperatura', 90.0000, 'ºC'),
	(249212, 120, '2014-03-15 00:06:02.000000', 'temperatura', 493.0000, 'ºC'),
	(249213, 120, '2014-03-15 00:06:03.000000', 'temperatura', 995.0000, 'ºC'),
	(249214, 120, '2014-03-15 00:06:04.000000', 'temperatura', 1097.0000, 'ºC'),
	(249215, 120, '2014-03-15 00:06:05.000000', 'temperatura', 101.0000, 'ºC'),
	(249216, 120, '2014-03-15 00:06:06.000000', 'temperatura', 815.0000, 'ºC'),
	(249217, 120, '2014-03-15 00:06:07.000000', 'temperatura', 170.0000, 'ºC'),
	(249218, 120, '2014-03-15 00:06:08.000000', 'temperatura', 805.0000, 'ºC'),
	(249219, 120, '2014-03-15 00:06:09.000000', 'temperatura', 1116.0000, 'ºC'),
	(249220, 120, '2014-03-15 00:06:10.000000', 'temperatura', 768.0000, 'ºC'),
	(249221, 120, '2014-03-15 00:06:11.000000', 'temperatura', 491.0000, 'ºC'),
	(249222, 120, '2014-03-15 00:06:12.000000', 'temperatura', 151.0000, 'ºC'),
	(249223, 120, '2014-03-15 00:06:13.000000', 'temperatura', 481.0000, 'ºC'),
	(249224, 120, '2014-03-15 00:06:14.000000', 'temperatura', 753.0000, 'ºC'),
	(249225, 120, '2014-03-15 00:06:15.000000', 'temperatura', 1124.0000, 'ºC'),
	(249226, 120, '2014-03-15 00:06:16.000000', 'temperatura', 962.0000, 'ºC'),
	(249227, 120, '2014-03-15 00:06:17.000000', 'temperatura', 236.0000, 'ºC'),
	(249228, 120, '2014-03-15 00:06:18.000000', 'temperatura', 694.0000, 'ºC'),
	(249229, 120, '2014-03-15 00:06:19.000000', 'temperatura', 363.0000, 'ºC'),
	(249230, 120, '2014-03-15 00:06:20.000000', 'temperatura', 932.0000, 'ºC'),
	(249231, 120, '2014-03-15 00:06:21.000000', 'temperatura', 1175.0000, 'ºC'),
	(249232, 120, '2014-03-15 00:06:22.000000', 'temperatura', 678.0000, 'ºC'),
	(249233, 120, '2014-03-15 00:06:23.000000', 'temperatura', 1066.0000, 'ºC'),
	(249234, 120, '2014-03-15 00:06:24.000000', 'temperatura', 894.0000, 'ºC'),
	(249235, 120, '2014-03-15 00:06:25.000000', 'temperatura', 74.0000, 'ºC'),
	(249236, 120, '2014-03-15 00:06:26.000000', 'temperatura', 90.0000, 'ºC'),
	(249237, 120, '2014-03-15 00:06:27.000000', 'temperatura', 227.0000, 'ºC'),
	(249238, 120, '2014-03-15 00:06:28.000000', 'temperatura', 866.0000, 'ºC'),
	(249239, 120, '2014-03-15 00:06:29.000000', 'temperatura', 50.0000, 'ºC'),
	(249240, 120, '2014-03-15 00:06:30.000000', 'temperatura', 50.0000, 'ºC'),
	(249241, 120, '2014-03-15 00:06:31.000000', 'temperatura', 103.0000, 'ºC'),
	(249242, 120, '2014-03-15 00:06:32.000000', 'temperatura', 366.0000, 'ºC'),
	(249243, 120, '2014-03-15 00:06:33.000000', 'temperatura', 321.0000, 'ºC'),
	(249244, 120, '2014-03-15 00:06:34.000000', 'temperatura', 508.0000, 'ºC'),
	(249245, 120, '2014-03-15 00:06:35.000000', 'temperatura', 375.0000, 'ºC'),
	(249246, 120, '2014-03-15 00:06:36.000000', 'temperatura', 354.0000, 'ºC'),
	(249247, 120, '2014-03-15 00:06:37.000000', 'temperatura', 646.0000, 'ºC'),
	(249248, 120, '2014-03-15 00:06:38.000000', 'temperatura', 969.0000, 'ºC'),
	(249249, 120, '2014-03-15 00:06:39.000000', 'temperatura', 508.0000, 'ºC'),
	(249250, 120, '2014-03-15 00:06:40.000000', 'temperatura', 833.0000, 'ºC'),
	(249251, 120, '2014-03-15 00:06:41.000000', 'temperatura', 239.0000, 'ºC'),
	(249252, 120, '2014-03-15 00:06:42.000000', 'temperatura', 1100.0000, 'ºC'),
	(249253, 120, '2014-03-15 00:06:43.000000', 'temperatura', 1181.0000, 'ºC'),
	(249254, 120, '2014-03-15 00:06:44.000000', 'temperatura', 206.0000, 'ºC'),
	(249255, 120, '2014-03-15 00:06:45.000000', 'temperatura', 1088.0000, 'ºC'),
	(249256, 120, '2014-03-15 00:06:46.000000', 'temperatura', 23.0000, 'ºC'),
	(249257, 120, '2014-03-15 00:06:47.000000', 'temperatura', 453.0000, 'ºC'),
	(249258, 120, '2014-03-15 00:06:48.000000', 'temperatura', 994.0000, 'ºC'),
	(249259, 120, '2014-03-15 00:06:49.000000', 'temperatura', 11.0000, 'ºC'),
	(249260, 120, '2014-03-15 00:06:50.000000', 'temperatura', 672.0000, 'ºC'),
	(249261, 120, '2014-03-15 00:06:51.000000', 'temperatura', 931.0000, 'ºC'),
	(249262, 120, '2014-03-15 00:06:52.000000', 'temperatura', 237.0000, 'ºC'),
	(249263, 120, '2014-03-15 00:06:53.000000', 'temperatura', 794.0000, 'ºC'),
	(249264, 120, '2014-03-15 00:06:54.000000', 'temperatura', 858.0000, 'ºC'),
	(249265, 120, '2014-03-15 00:06:55.000000', 'temperatura', 709.0000, 'ºC'),
	(249266, 120, '2014-03-15 00:06:56.000000', 'temperatura', 970.0000, 'ºC'),
	(249267, 120, '2014-03-15 00:06:57.000000', 'temperatura', 325.0000, 'ºC'),
	(249268, 120, '2014-03-15 00:06:58.000000', 'temperatura', 1114.0000, 'ºC'),
	(249269, 120, '2014-03-15 00:06:59.000000', 'temperatura', 995.0000, 'ºC'),
	(249270, 120, '2014-03-15 00:07:00.000000', 'temperatura', 434.0000, 'ºC'),
	(249271, 120, '2014-03-15 00:07:01.000000', 'temperatura', 385.0000, 'ºC'),
	(249272, 120, '2014-03-15 00:07:02.000000', 'temperatura', 624.0000, 'ºC'),
	(249273, 120, '2014-03-15 00:07:03.000000', 'temperatura', 765.0000, 'ºC'),
	(249274, 120, '2014-03-15 00:07:04.000000', 'temperatura', 755.0000, 'ºC'),
	(249275, 120, '2014-03-15 00:07:05.000000', 'temperatura', 280.0000, 'ºC'),
	(249276, 120, '2014-03-15 00:07:06.000000', 'temperatura', 337.0000, 'ºC'),
	(249277, 120, '2014-03-15 00:07:07.000000', 'temperatura', 844.0000, 'ºC'),
	(249278, 120, '2014-03-15 00:07:08.000000', 'temperatura', 810.0000, 'ºC'),
	(249279, 120, '2014-03-15 00:07:09.000000', 'temperatura', 320.0000, 'ºC'),
	(249280, 120, '2014-03-15 00:07:10.000000', 'temperatura', 368.0000, 'ºC'),
	(249281, 120, '2014-03-15 00:07:11.000000', 'temperatura', 881.0000, 'ºC'),
	(249282, 120, '2014-03-15 00:07:12.000000', 'temperatura', 901.0000, 'ºC'),
	(249283, 120, '2014-03-15 00:07:13.000000', 'temperatura', 663.0000, 'ºC'),
	(249284, 120, '2014-03-15 00:07:14.000000', 'temperatura', 613.0000, 'ºC'),
	(249285, 120, '2014-03-15 00:07:15.000000', 'temperatura', 1076.0000, 'ºC'),
	(249286, 120, '2014-03-15 00:07:16.000000', 'temperatura', 1141.0000, 'ºC'),
	(249287, 120, '2014-03-15 00:07:17.000000', 'temperatura', 80.0000, 'ºC'),
	(249288, 120, '2014-03-15 00:07:18.000000', 'temperatura', 575.0000, 'ºC'),
	(249289, 120, '2014-03-15 00:07:19.000000', 'temperatura', 237.0000, 'ºC'),
	(249290, 120, '2014-03-15 00:07:20.000000', 'temperatura', 661.0000, 'ºC'),
	(249291, 120, '2014-03-15 00:07:21.000000', 'temperatura', 192.0000, 'ºC'),
	(249292, 120, '2014-03-15 00:07:22.000000', 'temperatura', 179.0000, 'ºC'),
	(249293, 120, '2014-03-15 00:07:23.000000', 'temperatura', 320.0000, 'ºC'),
	(249294, 120, '2014-03-15 00:07:24.000000', 'temperatura', 1061.0000, 'ºC'),
	(249295, 120, '2014-03-15 00:07:25.000000', 'temperatura', 747.0000, 'ºC'),
	(249296, 120, '2014-03-15 00:07:26.000000', 'temperatura', 551.0000, 'ºC'),
	(249297, 120, '2014-03-15 00:07:27.000000', 'temperatura', 516.0000, 'ºC'),
	(249298, 120, '2014-03-15 00:07:28.000000', 'temperatura', 926.0000, 'ºC'),
	(249299, 120, '2014-03-15 00:07:29.000000', 'temperatura', 683.0000, 'ºC'),
	(249300, 120, '2014-03-15 00:07:30.000000', 'temperatura', 640.0000, 'ºC'),
	(249301, 120, '2014-03-15 00:07:31.000000', 'temperatura', 1148.0000, 'ºC'),
	(249302, 120, '2014-03-15 00:07:32.000000', 'temperatura', 223.0000, 'ºC'),
	(249303, 120, '2014-03-15 00:07:33.000000', 'temperatura', 69.0000, 'ºC'),
	(249304, 120, '2014-03-15 00:07:34.000000', 'temperatura', 878.0000, 'ºC'),
	(249305, 120, '2014-03-15 00:07:35.000000', 'temperatura', 584.0000, 'ºC'),
	(249306, 120, '2014-03-15 00:07:36.000000', 'temperatura', 288.0000, 'ºC'),
	(249307, 120, '2014-03-15 00:07:37.000000', 'temperatura', 886.0000, 'ºC'),
	(249308, 120, '2014-03-15 00:07:38.000000', 'temperatura', 1166.0000, 'ºC'),
	(249309, 120, '2014-03-15 00:07:39.000000', 'temperatura', 773.0000, 'ºC'),
	(249310, 120, '2014-03-15 00:07:40.000000', 'temperatura', 368.0000, 'ºC'),
	(249311, 120, '2014-03-15 00:07:41.000000', 'temperatura', 720.0000, 'ºC'),
	(249312, 120, '2014-03-15 00:07:42.000000', 'temperatura', 98.0000, 'ºC'),
	(249313, 120, '2014-03-15 00:07:43.000000', 'temperatura', 731.0000, 'ºC'),
	(249314, 120, '2014-03-15 00:07:44.000000', 'temperatura', 960.0000, 'ºC'),
	(249315, 120, '2014-03-15 00:07:45.000000', 'temperatura', 210.0000, 'ºC'),
	(249316, 120, '2014-03-15 00:07:46.000000', 'temperatura', 569.0000, 'ºC'),
	(249317, 120, '2014-03-15 00:07:47.000000', 'temperatura', 1014.0000, 'ºC'),
	(249318, 120, '2014-03-15 00:07:48.000000', 'temperatura', 966.0000, 'ºC'),
	(249319, 120, '2014-03-15 00:07:49.000000', 'temperatura', 587.0000, 'ºC'),
	(249320, 120, '2014-03-15 00:07:50.000000', 'temperatura', 36.0000, 'ºC'),
	(249321, 120, '2014-03-15 00:07:51.000000', 'temperatura', 823.0000, 'ºC'),
	(249322, 120, '2014-03-15 00:07:52.000000', 'temperatura', 404.0000, 'ºC'),
	(249323, 120, '2014-03-15 00:07:53.000000', 'temperatura', 753.0000, 'ºC'),
	(249324, 120, '2014-03-15 00:07:54.000000', 'temperatura', 151.0000, 'ºC'),
	(249325, 120, '2014-03-15 00:07:55.000000', 'temperatura', 900.0000, 'ºC'),
	(249326, 120, '2014-03-15 00:07:56.000000', 'temperatura', 446.0000, 'ºC'),
	(249327, 120, '2014-03-15 00:07:57.000000', 'temperatura', 733.0000, 'ºC'),
	(249328, 120, '2014-03-15 00:07:58.000000', 'temperatura', 1125.0000, 'ºC'),
	(249329, 120, '2014-03-15 00:07:59.000000', 'temperatura', 1027.0000, 'ºC'),
	(249330, 120, '2014-03-15 00:08:00.000000', 'temperatura', 561.0000, 'ºC'),
	(249331, 120, '2014-03-15 00:08:01.000000', 'temperatura', 925.0000, 'ºC'),
	(249332, 120, '2014-03-15 00:08:02.000000', 'temperatura', 541.0000, 'ºC'),
	(249333, 120, '2014-03-15 00:08:03.000000', 'temperatura', 1131.0000, 'ºC'),
	(249334, 120, '2014-03-15 00:08:04.000000', 'temperatura', 433.0000, 'ºC'),
	(249335, 120, '2014-03-15 00:08:05.000000', 'temperatura', 1173.0000, 'ºC'),
	(249336, 120, '2014-03-15 00:08:06.000000', 'temperatura', 967.0000, 'ºC'),
	(249337, 120, '2014-03-15 00:08:07.000000', 'temperatura', 118.0000, 'ºC'),
	(249338, 120, '2014-03-15 00:08:08.000000', 'temperatura', 86.0000, 'ºC'),
	(249339, 120, '2014-03-15 00:08:09.000000', 'temperatura', 77.0000, 'ºC'),
	(249340, 120, '2014-03-15 00:08:10.000000', 'temperatura', 130.0000, 'ºC'),
	(249341, 120, '2014-03-15 00:08:11.000000', 'temperatura', 418.0000, 'ºC'),
	(249342, 120, '2014-03-15 00:08:12.000000', 'temperatura', 501.0000, 'ºC'),
	(249343, 120, '2014-03-15 00:08:13.000000', 'temperatura', 49.0000, 'ºC'),
	(249344, 120, '2014-03-15 00:08:14.000000', 'temperatura', 1145.0000, 'ºC'),
	(249345, 120, '2014-03-15 00:08:15.000000', 'temperatura', 779.0000, 'ºC'),
	(249346, 120, '2014-03-15 00:08:16.000000', 'temperatura', 460.0000, 'ºC'),
	(249347, 120, '2014-03-15 00:08:17.000000', 'temperatura', 1165.0000, 'ºC'),
	(249348, 120, '2014-03-15 00:08:18.000000', 'temperatura', 846.0000, 'ºC'),
	(249349, 120, '2014-03-15 00:08:19.000000', 'temperatura', 734.0000, 'ºC'),
	(249350, 120, '2014-03-15 00:08:20.000000', 'temperatura', 1132.0000, 'ºC'),
	(249351, 120, '2014-03-15 00:08:21.000000', 'temperatura', 1057.0000, 'ºC'),
	(249352, 120, '2014-03-15 00:08:22.000000', 'temperatura', 692.0000, 'ºC'),
	(249353, 120, '2014-03-15 00:08:23.000000', 'temperatura', 288.0000, 'ºC'),
	(249354, 120, '2014-03-15 00:08:24.000000', 'temperatura', 566.0000, 'ºC'),
	(249355, 120, '2014-03-15 00:08:25.000000', 'temperatura', 765.0000, 'ºC'),
	(249356, 120, '2014-03-15 00:08:26.000000', 'temperatura', 927.0000, 'ºC'),
	(249357, 120, '2014-03-15 00:08:27.000000', 'temperatura', 1143.0000, 'ºC'),
	(249358, 120, '2014-03-15 00:08:28.000000', 'temperatura', 532.0000, 'ºC'),
	(249359, 120, '2014-03-15 00:08:29.000000', 'temperatura', 431.0000, 'ºC'),
	(249360, 120, '2014-03-15 00:08:30.000000', 'temperatura', 561.0000, 'ºC'),
	(249361, 120, '2014-03-15 00:08:31.000000', 'temperatura', 312.0000, 'ºC'),
	(249362, 120, '2014-03-15 00:08:32.000000', 'temperatura', 1077.0000, 'ºC'),
	(249363, 120, '2014-03-15 00:08:33.000000', 'temperatura', 851.0000, 'ºC'),
	(249364, 120, '2014-03-15 00:08:34.000000', 'temperatura', 1022.0000, 'ºC'),
	(249365, 120, '2014-03-15 00:08:35.000000', 'temperatura', 158.0000, 'ºC'),
	(249366, 120, '2014-03-15 00:08:36.000000', 'temperatura', 124.0000, 'ºC'),
	(249367, 120, '2014-03-15 00:08:37.000000', 'temperatura', 147.0000, 'ºC'),
	(249368, 120, '2014-03-15 00:08:38.000000', 'temperatura', 364.0000, 'ºC'),
	(249369, 120, '2014-03-15 00:08:39.000000', 'temperatura', 180.0000, 'ºC'),
	(249370, 120, '2014-03-15 00:08:40.000000', 'temperatura', 1007.0000, 'ºC'),
	(249371, 120, '2014-03-15 00:08:41.000000', 'temperatura', 898.0000, 'ºC'),
	(249372, 120, '2014-03-15 00:08:42.000000', 'temperatura', 269.0000, 'ºC'),
	(249373, 120, '2014-03-15 00:08:43.000000', 'temperatura', 1050.0000, 'ºC'),
	(249374, 120, '2014-03-15 00:08:44.000000', 'temperatura', 844.0000, 'ºC'),
	(249375, 120, '2014-03-15 00:08:45.000000', 'temperatura', 1069.0000, 'ºC'),
	(249376, 120, '2014-03-15 00:08:46.000000', 'temperatura', 413.0000, 'ºC'),
	(249377, 120, '2014-03-15 00:08:47.000000', 'temperatura', 60.0000, 'ºC'),
	(249378, 120, '2014-03-15 00:08:48.000000', 'temperatura', 262.0000, 'ºC'),
	(249379, 120, '2014-03-15 00:08:49.000000', 'temperatura', 1130.0000, 'ºC'),
	(249380, 120, '2014-03-15 00:08:50.000000', 'temperatura', 62.0000, 'ºC'),
	(249381, 120, '2014-03-15 00:08:51.000000', 'temperatura', 524.0000, 'ºC'),
	(249382, 120, '2014-03-15 00:08:52.000000', 'temperatura', 35.0000, 'ºC'),
	(249383, 120, '2014-03-15 00:08:53.000000', 'temperatura', 1002.0000, 'ºC'),
	(249384, 120, '2014-03-15 00:08:54.000000', 'temperatura', 104.0000, 'ºC'),
	(249385, 120, '2014-03-15 00:08:55.000000', 'temperatura', 1114.0000, 'ºC'),
	(249386, 120, '2014-03-15 00:08:56.000000', 'temperatura', 461.0000, 'ºC'),
	(249387, 120, '2014-03-15 00:08:57.000000', 'temperatura', 162.0000, 'ºC'),
	(249388, 120, '2014-03-15 00:08:58.000000', 'temperatura', 628.0000, 'ºC'),
	(249389, 120, '2014-03-15 00:08:59.000000', 'temperatura', 254.0000, 'ºC'),
	(249390, 120, '2014-03-15 00:09:00.000000', 'temperatura', 586.0000, 'ºC'),
	(249391, 120, '2014-03-15 00:09:01.000000', 'temperatura', 969.0000, 'ºC'),
	(249392, 120, '2014-03-15 00:09:02.000000', 'temperatura', 686.0000, 'ºC'),
	(249393, 120, '2014-03-15 00:09:03.000000', 'temperatura', 527.0000, 'ºC'),
	(249394, 120, '2014-03-15 00:09:04.000000', 'temperatura', 574.0000, 'ºC'),
	(249395, 120, '2014-03-15 00:09:05.000000', 'temperatura', 91.0000, 'ºC'),
	(249396, 120, '2014-03-15 00:09:06.000000', 'temperatura', 1133.0000, 'ºC'),
	(249397, 120, '2014-03-15 00:09:07.000000', 'temperatura', 594.0000, 'ºC'),
	(249398, 120, '2014-03-15 00:09:08.000000', 'temperatura', 772.0000, 'ºC'),
	(249399, 120, '2014-03-15 00:09:09.000000', 'temperatura', 877.0000, 'ºC'),
	(249400, 120, '2014-03-15 00:09:10.000000', 'temperatura', 871.0000, 'ºC'),
	(249401, 120, '2014-03-15 00:09:11.000000', 'temperatura', 525.0000, 'ºC'),
	(249402, 120, '2014-03-15 00:09:12.000000', 'temperatura', 12.0000, 'ºC'),
	(249403, 120, '2014-03-15 00:09:13.000000', 'temperatura', 885.0000, 'ºC'),
	(249404, 120, '2014-03-15 00:09:14.000000', 'temperatura', 789.0000, 'ºC'),
	(249405, 120, '2014-03-15 00:09:15.000000', 'temperatura', 91.0000, 'ºC'),
	(249406, 120, '2014-03-15 00:09:16.000000', 'temperatura', 488.0000, 'ºC'),
	(249407, 120, '2014-03-15 00:09:17.000000', 'temperatura', 968.0000, 'ºC'),
	(249408, 120, '2014-03-15 00:09:18.000000', 'temperatura', 975.0000, 'ºC'),
	(249409, 120, '2014-03-15 00:09:19.000000', 'temperatura', 773.0000, 'ºC'),
	(249410, 120, '2014-03-15 00:09:20.000000', 'temperatura', 938.0000, 'ºC'),
	(249411, 120, '2014-03-15 00:09:21.000000', 'temperatura', 1175.0000, 'ºC'),
	(249412, 120, '2014-03-15 00:09:22.000000', 'temperatura', 660.0000, 'ºC'),
	(249413, 120, '2014-03-15 00:09:23.000000', 'temperatura', 977.0000, 'ºC'),
	(249414, 120, '2014-03-15 00:09:24.000000', 'temperatura', 505.0000, 'ºC'),
	(249415, 120, '2014-03-15 00:09:25.000000', 'temperatura', 796.0000, 'ºC'),
	(249416, 120, '2014-03-15 00:09:26.000000', 'temperatura', 64.0000, 'ºC'),
	(249417, 120, '2014-03-15 00:09:27.000000', 'temperatura', 334.0000, 'ºC'),
	(249418, 120, '2014-03-15 00:09:28.000000', 'temperatura', 279.0000, 'ºC'),
	(249419, 120, '2014-03-15 00:09:29.000000', 'temperatura', 393.0000, 'ºC'),
	(249420, 120, '2014-03-15 00:09:30.000000', 'temperatura', 1129.0000, 'ºC'),
	(249421, 120, '2014-03-15 00:09:31.000000', 'temperatura', 866.0000, 'ºC'),
	(249422, 120, '2014-03-15 00:09:32.000000', 'temperatura', 942.0000, 'ºC'),
	(249423, 120, '2014-03-15 00:09:33.000000', 'temperatura', 915.0000, 'ºC'),
	(249424, 120, '2014-03-15 00:09:34.000000', 'temperatura', 547.0000, 'ºC'),
	(249425, 120, '2014-03-15 00:09:35.000000', 'temperatura', 1191.0000, 'ºC'),
	(249426, 120, '2014-03-15 00:09:36.000000', 'temperatura', 716.0000, 'ºC'),
	(249427, 120, '2014-03-15 00:09:37.000000', 'temperatura', 7.0000, 'ºC'),
	(249428, 120, '2014-03-15 00:09:38.000000', 'temperatura', 285.0000, 'ºC'),
	(249429, 120, '2014-03-15 00:09:39.000000', 'temperatura', 207.0000, 'ºC'),
	(249430, 120, '2014-03-15 00:09:40.000000', 'temperatura', 179.0000, 'ºC'),
	(249431, 120, '2014-03-15 00:09:41.000000', 'temperatura', 277.0000, 'ºC'),
	(249432, 120, '2014-03-15 00:09:42.000000', 'temperatura', 848.0000, 'ºC'),
	(249433, 120, '2014-03-15 00:09:43.000000', 'temperatura', 1010.0000, 'ºC'),
	(249434, 120, '2014-03-15 00:09:44.000000', 'temperatura', 106.0000, 'ºC'),
	(249435, 120, '2014-03-15 00:09:45.000000', 'temperatura', 1098.0000, 'ºC'),
	(249436, 120, '2014-03-15 00:09:46.000000', 'temperatura', 376.0000, 'ºC'),
	(249437, 120, '2014-03-15 00:09:47.000000', 'temperatura', 985.0000, 'ºC'),
	(249438, 120, '2014-03-15 00:09:48.000000', 'temperatura', 197.0000, 'ºC'),
	(249439, 120, '2014-03-15 00:09:49.000000', 'temperatura', 430.0000, 'ºC'),
	(249440, 120, '2014-03-15 00:09:50.000000', 'temperatura', 361.0000, 'ºC'),
	(249441, 120, '2014-03-15 00:09:51.000000', 'temperatura', 516.0000, 'ºC'),
	(249442, 120, '2014-03-15 00:09:52.000000', 'temperatura', 297.0000, 'ºC'),
	(249443, 120, '2014-03-15 00:09:53.000000', 'temperatura', 1138.0000, 'ºC'),
	(249444, 120, '2014-03-15 00:09:54.000000', 'temperatura', 1199.0000, 'ºC'),
	(249445, 120, '2014-03-15 00:09:55.000000', 'temperatura', 183.0000, 'ºC'),
	(249446, 120, '2014-03-15 00:09:56.000000', 'temperatura', 917.0000, 'ºC'),
	(249447, 120, '2014-03-15 00:09:57.000000', 'temperatura', 435.0000, 'ºC'),
	(249448, 120, '2014-03-15 00:09:58.000000', 'temperatura', 628.0000, 'ºC'),
	(249449, 120, '2014-03-15 00:09:59.000000', 'temperatura', 633.0000, 'ºC'),
	(249450, 120, '2014-03-15 00:10:00.000000', 'temperatura', 83.0000, 'ºC'),
	(249451, 120, '2014-03-15 00:10:01.000000', 'temperatura', 914.0000, 'ºC'),
	(249452, 120, '2014-03-15 00:10:02.000000', 'temperatura', 725.0000, 'ºC'),
	(249453, 120, '2014-03-15 00:10:03.000000', 'temperatura', 881.0000, 'ºC'),
	(249454, 120, '2014-03-15 00:10:04.000000', 'temperatura', 1031.0000, 'ºC'),
	(249455, 120, '2014-03-15 00:10:05.000000', 'temperatura', 114.0000, 'ºC'),
	(249456, 120, '2014-03-15 00:10:06.000000', 'temperatura', 1076.0000, 'ºC'),
	(249457, 120, '2014-03-15 00:10:07.000000', 'temperatura', 240.0000, 'ºC'),
	(249458, 120, '2014-03-15 00:10:08.000000', 'temperatura', 370.0000, 'ºC'),
	(249459, 120, '2014-03-15 00:10:09.000000', 'temperatura', 1130.0000, 'ºC'),
	(249460, 120, '2014-03-15 00:10:10.000000', 'temperatura', 944.0000, 'ºC'),
	(249461, 120, '2014-03-15 00:10:11.000000', 'temperatura', 127.0000, 'ºC'),
	(249462, 120, '2014-03-15 00:10:12.000000', 'temperatura', 204.0000, 'ºC'),
	(249463, 120, '2014-03-15 00:10:13.000000', 'temperatura', 639.0000, 'ºC'),
	(249464, 120, '2014-03-15 00:10:14.000000', 'temperatura', 183.0000, 'ºC'),
	(249465, 120, '2014-03-15 00:10:15.000000', 'temperatura', 201.0000, 'ºC'),
	(249466, 120, '2014-03-15 00:10:16.000000', 'temperatura', 453.0000, 'ºC'),
	(249467, 120, '2014-03-15 00:10:17.000000', 'temperatura', 465.0000, 'ºC'),
	(249468, 120, '2014-03-15 00:10:18.000000', 'temperatura', 967.0000, 'ºC'),
	(249469, 120, '2014-03-15 00:10:19.000000', 'temperatura', 1039.0000, 'ºC'),
	(249470, 120, '2014-03-15 00:10:20.000000', 'temperatura', 1096.0000, 'ºC'),
	(249471, 120, '2014-03-15 00:10:21.000000', 'temperatura', 1163.0000, 'ºC'),
	(249472, 120, '2014-03-15 00:10:22.000000', 'temperatura', 128.0000, 'ºC'),
	(249473, 120, '2014-03-15 00:10:23.000000', 'temperatura', 753.0000, 'ºC'),
	(249474, 120, '2014-03-15 00:10:24.000000', 'temperatura', 981.0000, 'ºC'),
	(249475, 120, '2014-03-15 00:10:25.000000', 'temperatura', 245.0000, 'ºC'),
	(249476, 120, '2014-03-15 00:10:26.000000', 'temperatura', 683.0000, 'ºC'),
	(249477, 120, '2014-03-15 00:10:27.000000', 'temperatura', 282.0000, 'ºC'),
	(249478, 120, '2014-03-15 00:10:28.000000', 'temperatura', 561.0000, 'ºC'),
	(249479, 120, '2014-03-15 00:10:29.000000', 'temperatura', 759.0000, 'ºC'),
	(249480, 120, '2014-03-15 00:10:30.000000', 'temperatura', 913.0000, 'ºC'),
	(249481, 120, '2014-03-15 00:10:31.000000', 'temperatura', 1090.0000, 'ºC'),
	(249482, 120, '2014-03-15 00:10:32.000000', 'temperatura', 311.0000, 'ºC'),
	(249483, 120, '2014-03-15 00:10:33.000000', 'temperatura', 687.0000, 'ºC'),
	(249484, 120, '2014-03-15 00:10:34.000000', 'temperatura', 102.0000, 'ºC'),
	(249485, 120, '2014-03-15 00:10:35.000000', 'temperatura', 847.0000, 'ºC'),
	(249486, 120, '2014-03-15 00:10:36.000000', 'temperatura', 332.0000, 'ºC'),
	(249487, 120, '2014-03-15 00:10:37.000000', 'temperatura', 320.0000, 'ºC'),
	(249488, 120, '2014-03-15 00:10:38.000000', 'temperatura', 601.0000, 'ºC'),
	(249489, 120, '2014-03-15 00:10:39.000000', 'temperatura', 849.0000, 'ºC'),
	(249490, 120, '2014-03-15 00:10:40.000000', 'temperatura', 43.0000, 'ºC'),
	(249491, 120, '2014-03-15 00:10:41.000000', 'temperatura', 67.0000, 'ºC'),
	(249492, 120, '2014-03-15 00:10:42.000000', 'temperatura', 206.0000, 'ºC'),
	(249493, 120, '2014-03-15 00:10:43.000000', 'temperatura', 831.0000, 'ºC'),
	(249494, 120, '2014-03-15 00:10:44.000000', 'temperatura', 1136.0000, 'ºC'),
	(249495, 120, '2014-03-15 00:10:45.000000', 'temperatura', 790.0000, 'ºC'),
	(249496, 120, '2014-03-15 00:10:46.000000', 'temperatura', 541.0000, 'ºC'),
	(249497, 120, '2014-03-15 00:10:47.000000', 'temperatura', 338.0000, 'ºC'),
	(249498, 120, '2014-03-15 00:10:48.000000', 'temperatura', 64.0000, 'ºC'),
	(249499, 120, '2014-03-15 00:10:49.000000', 'temperatura', 507.0000, 'ºC'),
	(249500, 120, '2014-03-15 00:10:50.000000', 'temperatura', 1143.0000, 'ºC'),
	(249501, 120, '2014-03-15 00:10:51.000000', 'temperatura', 593.0000, 'ºC'),
	(249502, 120, '2014-03-15 00:10:52.000000', 'temperatura', 740.0000, 'ºC'),
	(249503, 120, '2014-03-15 00:10:53.000000', 'temperatura', 721.0000, 'ºC'),
	(249504, 120, '2014-03-15 00:10:54.000000', 'temperatura', 184.0000, 'ºC'),
	(249505, 120, '2014-03-15 00:10:55.000000', 'temperatura', 1159.0000, 'ºC'),
	(249506, 120, '2014-03-15 00:10:56.000000', 'temperatura', 443.0000, 'ºC'),
	(249507, 120, '2014-03-15 00:10:57.000000', 'temperatura', 1140.0000, 'ºC'),
	(249508, 120, '2014-03-15 00:10:58.000000', 'temperatura', 770.0000, 'ºC'),
	(249509, 120, '2014-03-15 00:10:59.000000', 'temperatura', 431.0000, 'ºC'),
	(249510, 120, '2014-03-15 00:11:00.000000', 'temperatura', 1045.0000, 'ºC'),
	(249511, 120, '2014-03-15 00:11:01.000000', 'temperatura', 334.0000, 'ºC'),
	(249512, 120, '2014-03-15 00:11:02.000000', 'temperatura', 933.0000, 'ºC'),
	(249513, 120, '2014-03-15 00:11:03.000000', 'temperatura', 64.0000, 'ºC'),
	(249514, 120, '2014-03-15 00:11:04.000000', 'temperatura', 1122.0000, 'ºC'),
	(249515, 120, '2014-03-15 00:11:05.000000', 'temperatura', 619.0000, 'ºC'),
	(249516, 120, '2014-03-15 00:11:06.000000', 'temperatura', 928.0000, 'ºC'),
	(249517, 120, '2014-03-15 00:11:07.000000', 'temperatura', 385.0000, 'ºC'),
	(249518, 120, '2014-03-15 00:11:08.000000', 'temperatura', 341.0000, 'ºC'),
	(249519, 120, '2014-03-15 00:11:09.000000', 'temperatura', 551.0000, 'ºC'),
	(249520, 120, '2014-03-15 00:11:10.000000', 'temperatura', 531.0000, 'ºC'),
	(249521, 120, '2014-03-15 00:11:11.000000', 'temperatura', 1003.0000, 'ºC'),
	(249522, 120, '2014-03-15 00:11:12.000000', 'temperatura', 1022.0000, 'ºC'),
	(249523, 120, '2014-03-15 00:11:13.000000', 'temperatura', 902.0000, 'ºC'),
	(249524, 120, '2014-03-15 00:11:14.000000', 'temperatura', 243.0000, 'ºC'),
	(249525, 120, '2014-03-15 00:11:15.000000', 'temperatura', 910.0000, 'ºC'),
	(249526, 120, '2014-03-15 00:11:16.000000', 'temperatura', 223.0000, 'ºC'),
	(249527, 120, '2014-03-15 00:11:17.000000', 'temperatura', 785.0000, 'ºC'),
	(249528, 120, '2014-03-15 00:11:18.000000', 'temperatura', 857.0000, 'ºC'),
	(249529, 120, '2014-03-15 00:11:19.000000', 'temperatura', 730.0000, 'ºC'),
	(249530, 120, '2014-03-15 00:11:20.000000', 'temperatura', 1077.0000, 'ºC'),
	(249531, 120, '2014-03-15 00:11:21.000000', 'temperatura', 799.0000, 'ºC'),
	(249532, 120, '2014-03-15 00:11:22.000000', 'temperatura', 764.0000, 'ºC'),
	(249533, 120, '2014-03-15 00:11:23.000000', 'temperatura', 222.0000, 'ºC'),
	(249534, 120, '2014-03-15 00:11:24.000000', 'temperatura', 20.0000, 'ºC'),
	(249535, 120, '2014-03-15 00:11:25.000000', 'temperatura', 633.0000, 'ºC'),
	(249536, 120, '2014-03-15 00:11:26.000000', 'temperatura', 707.0000, 'ºC'),
	(249537, 120, '2014-03-15 00:11:27.000000', 'temperatura', 434.0000, 'ºC'),
	(249538, 120, '2014-03-15 00:11:28.000000', 'temperatura', 52.0000, 'ºC'),
	(249539, 120, '2014-03-15 00:11:29.000000', 'temperatura', 156.0000, 'ºC'),
	(249540, 120, '2014-03-15 00:11:30.000000', 'temperatura', 624.0000, 'ºC'),
	(249541, 120, '2014-03-15 00:11:31.000000', 'temperatura', 255.0000, 'ºC'),
	(249542, 120, '2014-03-15 00:11:32.000000', 'temperatura', 601.0000, 'ºC'),
	(249543, 120, '2014-03-15 00:11:33.000000', 'temperatura', 1043.0000, 'ºC'),
	(249544, 120, '2014-03-15 00:11:34.000000', 'temperatura', 1011.0000, 'ºC'),
	(249545, 120, '2014-03-15 00:11:35.000000', 'temperatura', 727.0000, 'ºC'),
	(249546, 120, '2014-03-15 00:11:36.000000', 'temperatura', 602.0000, 'ºC'),
	(249547, 120, '2014-03-15 00:11:37.000000', 'temperatura', 828.0000, 'ºC'),
	(249548, 120, '2014-03-15 00:11:38.000000', 'temperatura', 1137.0000, 'ºC'),
	(249549, 120, '2014-03-15 00:11:39.000000', 'temperatura', 799.0000, 'ºC'),
	(249550, 120, '2014-03-15 00:11:40.000000', 'temperatura', 584.0000, 'ºC'),
	(249551, 120, '2014-03-15 00:11:41.000000', 'temperatura', 526.0000, 'ºC'),
	(249552, 120, '2014-03-15 00:11:42.000000', 'temperatura', 878.0000, 'ºC'),
	(249553, 120, '2014-03-15 00:11:43.000000', 'temperatura', 414.0000, 'ºC'),
	(249554, 120, '2014-03-15 00:11:44.000000', 'temperatura', 635.0000, 'ºC'),
	(249555, 120, '2014-03-15 00:11:45.000000', 'temperatura', 733.0000, 'ºC'),
	(249556, 120, '2014-03-15 00:11:46.000000', 'temperatura', 560.0000, 'ºC'),
	(249557, 120, '2014-03-15 00:11:47.000000', 'temperatura', 602.0000, 'ºC'),
	(249558, 120, '2014-03-15 00:11:48.000000', 'temperatura', 131.0000, 'ºC'),
	(249559, 120, '2014-03-15 00:11:49.000000', 'temperatura', 47.0000, 'ºC'),
	(249560, 120, '2014-03-15 00:11:50.000000', 'temperatura', 1045.0000, 'ºC'),
	(249561, 120, '2014-03-15 00:11:51.000000', 'temperatura', 283.0000, 'ºC'),
	(249562, 120, '2014-03-15 00:11:52.000000', 'temperatura', 683.0000, 'ºC'),
	(249563, 120, '2014-03-15 00:11:53.000000', 'temperatura', 164.0000, 'ºC'),
	(249564, 120, '2014-03-15 00:11:54.000000', 'temperatura', 1174.0000, 'ºC'),
	(249565, 120, '2014-03-15 00:11:55.000000', 'temperatura', 575.0000, 'ºC'),
	(249566, 120, '2014-03-15 00:11:56.000000', 'temperatura', 556.0000, 'ºC'),
	(249567, 120, '2014-03-15 00:11:57.000000', 'temperatura', 1056.0000, 'ºC'),
	(249568, 120, '2014-03-15 00:11:58.000000', 'temperatura', 11.0000, 'ºC'),
	(249569, 120, '2014-03-15 00:11:59.000000', 'temperatura', 490.0000, 'ºC'),
	(249570, 120, '2014-03-15 00:12:00.000000', 'temperatura', 15.0000, 'ºC'),
	(249571, 120, '2014-03-15 00:12:01.000000', 'temperatura', 1005.0000, 'ºC'),
	(249572, 120, '2014-03-15 00:12:02.000000', 'temperatura', 182.0000, 'ºC'),
	(249573, 120, '2014-03-15 00:12:03.000000', 'temperatura', 295.0000, 'ºC'),
	(249574, 120, '2014-03-15 00:12:04.000000', 'temperatura', 929.0000, 'ºC'),
	(249575, 120, '2014-03-15 00:12:05.000000', 'temperatura', 159.0000, 'ºC'),
	(249576, 120, '2014-03-15 00:12:06.000000', 'temperatura', 411.0000, 'ºC'),
	(249577, 120, '2014-03-15 00:12:07.000000', 'temperatura', 379.0000, 'ºC'),
	(249578, 120, '2014-03-15 00:12:08.000000', 'temperatura', 661.0000, 'ºC'),
	(249579, 120, '2014-03-15 00:12:09.000000', 'temperatura', 969.0000, 'ºC'),
	(249580, 120, '2014-03-15 00:12:10.000000', 'temperatura', 464.0000, 'ºC'),
	(249581, 120, '2014-03-15 00:12:11.000000', 'temperatura', 611.0000, 'ºC'),
	(249582, 120, '2014-03-15 00:12:12.000000', 'temperatura', 463.0000, 'ºC'),
	(249583, 120, '2014-03-15 00:12:13.000000', 'temperatura', 483.0000, 'ºC'),
	(249584, 120, '2014-03-15 00:12:14.000000', 'temperatura', 1027.0000, 'ºC'),
	(249585, 120, '2014-03-15 00:12:15.000000', 'temperatura', 87.0000, 'ºC'),
	(249586, 120, '2014-03-15 00:12:16.000000', 'temperatura', 956.0000, 'ºC'),
	(249587, 120, '2014-03-15 00:12:17.000000', 'temperatura', 919.0000, 'ºC'),
	(249588, 120, '2014-03-15 00:12:18.000000', 'temperatura', 527.0000, 'ºC'),
	(249589, 120, '2014-03-15 00:12:19.000000', 'temperatura', 1080.0000, 'ºC'),
	(249590, 120, '2014-03-15 00:12:20.000000', 'temperatura', 219.0000, 'ºC'),
	(249591, 120, '2014-03-15 00:12:21.000000', 'temperatura', 255.0000, 'ºC'),
	(249592, 120, '2014-03-15 00:12:22.000000', 'temperatura', 618.0000, 'ºC'),
	(249593, 120, '2014-03-15 00:12:23.000000', 'temperatura', 1125.0000, 'ºC'),
	(249594, 120, '2014-03-15 00:12:24.000000', 'temperatura', 172.0000, 'ºC'),
	(249595, 120, '2014-03-15 00:12:25.000000', 'temperatura', 1086.0000, 'ºC'),
	(249596, 120, '2014-03-15 00:12:26.000000', 'temperatura', 114.0000, 'ºC'),
	(249597, 120, '2014-03-15 00:12:27.000000', 'temperatura', 911.0000, 'ºC'),
	(249598, 120, '2014-03-15 00:12:28.000000', 'temperatura', 615.0000, 'ºC'),
	(249599, 120, '2014-03-15 00:12:29.000000', 'temperatura', 342.0000, 'ºC'),
	(249600, 120, '2014-03-15 00:12:30.000000', 'temperatura', 1064.0000, 'ºC'),
	(249601, 120, '2014-03-15 00:12:31.000000', 'temperatura', 697.0000, 'ºC'),
	(249602, 120, '2014-03-15 00:12:32.000000', 'temperatura', 292.0000, 'ºC'),
	(249603, 120, '2014-03-15 00:12:33.000000', 'temperatura', 571.0000, 'ºC'),
	(249604, 120, '2014-03-15 00:12:34.000000', 'temperatura', 780.0000, 'ºC'),
	(249605, 120, '2014-03-15 00:12:35.000000', 'temperatura', 986.0000, 'ºC'),
	(249606, 120, '2014-03-15 00:12:36.000000', 'temperatura', 189.0000, 'ºC'),
	(249607, 120, '2014-03-15 00:12:37.000000', 'temperatura', 388.0000, 'ºC'),
	(249608, 120, '2014-03-15 00:12:38.000000', 'temperatura', 175.0000, 'ºC'),
	(249609, 120, '2014-03-15 00:12:39.000000', 'temperatura', 910.0000, 'ºC'),
	(249610, 120, '2014-03-15 00:12:40.000000', 'temperatura', 426.0000, 'ºC'),
	(249611, 120, '2014-03-15 00:12:41.000000', 'temperatura', 602.0000, 'ºC'),
	(249612, 120, '2014-03-15 00:12:42.000000', 'temperatura', 531.0000, 'ºC'),
	(249613, 120, '2014-03-15 00:12:43.000000', 'temperatura', 848.0000, 'ºC'),
	(249614, 120, '2014-03-15 00:12:44.000000', 'temperatura', 249.0000, 'ºC'),
	(249615, 120, '2014-03-15 00:12:45.000000', 'temperatura', 1100.0000, 'ºC'),
	(249616, 120, '2014-03-15 00:12:46.000000', 'temperatura', 1155.0000, 'ºC'),
	(249617, 120, '2014-03-15 00:12:47.000000', 'temperatura', 76.0000, 'ºC'),
	(249618, 120, '2014-03-15 00:12:48.000000', 'temperatura', 515.0000, 'ºC'),
	(249619, 120, '2014-03-15 00:12:49.000000', 'temperatura', 1146.0000, 'ºC'),
	(249620, 120, '2014-03-15 00:12:50.000000', 'temperatura', 588.0000, 'ºC'),
	(249621, 120, '2014-03-15 00:12:51.000000', 'temperatura', 701.0000, 'ºC'),
	(249622, 120, '2014-03-15 00:12:52.000000', 'temperatura', 543.0000, 'ºC'),
	(249623, 120, '2014-03-15 00:12:53.000000', 'temperatura', 613.0000, 'ºC'),
	(249624, 120, '2014-03-15 00:12:54.000000', 'temperatura', 236.0000, 'ºC'),
	(249625, 120, '2014-03-15 00:12:55.000000', 'temperatura', 540.0000, 'ºC'),
	(249626, 120, '2014-03-15 00:12:56.000000', 'temperatura', 792.0000, 'ºC'),
	(249627, 120, '2014-03-15 00:12:57.000000', 'temperatura', 1142.0000, 'ºC'),
	(249628, 120, '2014-03-15 00:12:58.000000', 'temperatura', 934.0000, 'ºC'),
	(249629, 120, '2014-03-15 00:12:59.000000', 'temperatura', 46.0000, 'ºC'),
	(249630, 120, '2014-03-15 00:13:00.000000', 'temperatura', 1029.0000, 'ºC'),
	(249631, 120, '2014-03-15 00:13:01.000000', 'temperatura', 207.0000, 'ºC'),
	(249632, 120, '2014-03-15 00:13:02.000000', 'temperatura', 349.0000, 'ºC'),
	(249633, 120, '2014-03-15 00:13:03.000000', 'temperatura', 1122.0000, 'ºC'),
	(249634, 120, '2014-03-15 00:13:04.000000', 'temperatura', 964.0000, 'ºC'),
	(249635, 120, '2014-03-15 00:13:05.000000', 'temperatura', 254.0000, 'ºC'),
	(249636, 120, '2014-03-15 00:13:06.000000', 'temperatura', 781.0000, 'ºC'),
	(249637, 120, '2014-03-15 00:13:07.000000', 'temperatura', 744.0000, 'ºC'),
	(249638, 120, '2014-03-15 00:13:08.000000', 'temperatura', 174.0000, 'ºC'),
	(249639, 120, '2014-03-15 00:13:09.000000', 'temperatura', 1042.0000, 'ºC'),
	(249640, 120, '2014-03-15 00:13:10.000000', 'temperatura', 1087.0000, 'ºC'),
	(249641, 120, '2014-03-15 00:13:11.000000', 'temperatura', 1109.0000, 'ºC'),
	(249642, 120, '2014-03-15 00:13:12.000000', 'temperatura', 1086.0000, 'ºC'),
	(249643, 120, '2014-03-15 00:13:13.000000', 'temperatura', 901.0000, 'ºC'),
	(249644, 120, '2014-03-15 00:13:14.000000', 'temperatura', 47.0000, 'ºC'),
	(249645, 120, '2014-03-15 00:13:15.000000', 'temperatura', 1135.0000, 'ºC'),
	(249646, 120, '2014-03-15 00:13:16.000000', 'temperatura', 733.0000, 'ºC'),
	(249647, 120, '2014-03-15 00:13:17.000000', 'temperatura', 262.0000, 'ºC'),
	(249648, 120, '2014-03-15 00:13:18.000000', 'temperatura', 311.0000, 'ºC'),
	(249649, 120, '2014-03-15 00:13:19.000000', 'temperatura', 768.0000, 'ºC'),
	(249650, 120, '2014-03-15 00:13:20.000000', 'temperatura', 509.0000, 'ºC'),
	(249651, 120, '2014-03-15 00:13:21.000000', 'temperatura', 241.0000, 'ºC'),
	(249652, 120, '2014-03-15 00:13:22.000000', 'temperatura', 878.0000, 'ºC'),
	(249653, 120, '2014-03-15 00:13:23.000000', 'temperatura', 66.0000, 'ºC'),
	(249654, 120, '2014-03-15 00:13:24.000000', 'temperatura', 99.0000, 'ºC'),
	(249655, 120, '2014-03-15 00:13:25.000000', 'temperatura', 297.0000, 'ºC'),
	(249656, 120, '2014-03-15 00:13:26.000000', 'temperatura', 1188.0000, 'ºC'),
	(249657, 120, '2014-03-15 00:13:27.000000', 'temperatura', 250.0000, 'ºC'),
	(249658, 120, '2014-03-15 00:13:28.000000', 'temperatura', 87.0000, 'ºC'),
	(249659, 120, '2014-03-15 00:13:29.000000', 'temperatura', 886.0000, 'ºC'),
	(249660, 120, '2014-03-15 00:13:30.000000', 'temperatura', 567.0000, 'ºC'),
	(249661, 120, '2014-03-15 00:13:31.000000', 'temperatura', 181.0000, 'ºC'),
	(249662, 120, '2014-03-15 00:13:32.000000', 'temperatura', 402.0000, 'ºC'),
	(249663, 120, '2014-03-15 00:13:33.000000', 'temperatura', 268.0000, 'ºC'),
	(249664, 120, '2014-03-15 00:13:34.000000', 'temperatura', 134.0000, 'ºC'),
	(249665, 120, '2014-03-15 00:13:35.000000', 'temperatura', 1068.0000, 'ºC'),
	(249666, 120, '2014-03-15 00:13:36.000000', 'temperatura', 139.0000, 'ºC'),
	(249667, 120, '2014-03-15 00:13:37.000000', 'temperatura', 1089.0000, 'ºC'),
	(249668, 120, '2014-03-15 00:13:38.000000', 'temperatura', 230.0000, 'ºC'),
	(249669, 120, '2014-03-15 00:13:39.000000', 'temperatura', 283.0000, 'ºC'),
	(249670, 120, '2014-03-15 00:13:40.000000', 'temperatura', 724.0000, 'ºC'),
	(249671, 120, '2014-03-15 00:13:41.000000', 'temperatura', 375.0000, 'ºC'),
	(249672, 120, '2014-03-15 00:13:42.000000', 'temperatura', 901.0000, 'ºC'),
	(249673, 120, '2014-03-15 00:13:43.000000', 'temperatura', 981.0000, 'ºC'),
	(249674, 120, '2014-03-15 00:13:44.000000', 'temperatura', 1001.0000, 'ºC'),
	(249675, 120, '2014-03-15 00:13:45.000000', 'temperatura', 862.0000, 'ºC'),
	(249676, 120, '2014-03-15 00:13:46.000000', 'temperatura', 108.0000, 'ºC'),
	(249677, 120, '2014-03-15 00:13:47.000000', 'temperatura', 357.0000, 'ºC'),
	(249678, 120, '2014-03-15 00:13:48.000000', 'temperatura', 260.0000, 'ºC'),
	(249679, 120, '2014-03-15 00:13:49.000000', 'temperatura', 231.0000, 'ºC'),
	(249680, 120, '2014-03-15 00:13:50.000000', 'temperatura', 373.0000, 'ºC'),
	(249681, 120, '2014-03-15 00:13:51.000000', 'temperatura', 1174.0000, 'ºC'),
	(249682, 120, '2014-03-15 00:13:52.000000', 'temperatura', 1152.0000, 'ºC'),
	(249683, 120, '2014-03-15 00:13:53.000000', 'temperatura', 1039.0000, 'ºC'),
	(249684, 120, '2014-03-15 00:13:54.000000', 'temperatura', 537.0000, 'ºC'),
	(249685, 120, '2014-03-15 00:13:55.000000', 'temperatura', 770.0000, 'ºC'),
	(249686, 120, '2014-03-15 00:13:56.000000', 'temperatura', 1037.0000, 'ºC'),
	(249687, 120, '2014-03-15 00:13:57.000000', 'temperatura', 479.0000, 'ºC'),
	(249688, 120, '2014-03-15 00:13:58.000000', 'temperatura', 482.0000, 'ºC'),
	(249689, 120, '2014-03-15 00:13:59.000000', 'temperatura', 976.0000, 'ºC'),
	(249690, 120, '2014-03-15 00:14:00.000000', 'temperatura', 1032.0000, 'ºC'),
	(249691, 120, '2014-03-15 00:14:01.000000', 'temperatura', 1034.0000, 'ºC'),
	(249692, 120, '2014-03-15 00:14:02.000000', 'temperatura', 872.0000, 'ºC'),
	(249693, 120, '2014-03-15 00:14:03.000000', 'temperatura', 61.0000, 'ºC'),
	(249694, 120, '2014-03-15 00:14:04.000000', 'temperatura', 87.0000, 'ºC'),
	(249695, 120, '2014-03-15 00:14:05.000000', 'temperatura', 252.0000, 'ºC'),
	(249696, 120, '2014-03-15 00:14:06.000000', 'temperatura', 1002.0000, 'ºC'),
	(249697, 120, '2014-03-15 00:14:07.000000', 'temperatura', 653.0000, 'ºC'),
	(249698, 120, '2014-03-15 00:14:08.000000', 'temperatura', 258.0000, 'ºC'),
	(249699, 120, '2014-03-15 00:14:09.000000', 'temperatura', 533.0000, 'ºC'),
	(249700, 120, '2014-03-15 00:14:10.000000', 'temperatura', 691.0000, 'ºC'),
	(249701, 120, '2014-03-15 00:14:11.000000', 'temperatura', 655.0000, 'ºC'),
	(249702, 120, '2014-03-15 00:14:12.000000', 'temperatura', 5.0000, 'ºC'),
	(249703, 120, '2014-03-15 00:14:13.000000', 'temperatura', 460.0000, 'ºC'),
	(249704, 120, '2014-03-15 00:14:14.000000', 'temperatura', 1084.0000, 'ºC'),
	(249705, 120, '2014-03-15 00:14:15.000000', 'temperatura', 442.0000, 'ºC'),
	(249706, 120, '2014-03-15 00:14:16.000000', 'temperatura', 156.0000, 'ºC'),
	(249707, 120, '2014-03-15 00:14:17.000000', 'temperatura', 657.0000, 'ºC'),
	(249708, 120, '2014-03-15 00:14:18.000000', 'temperatura', 416.0000, 'ºC'),
	(249709, 120, '2014-03-15 00:14:19.000000', 'temperatura', 110.0000, 'ºC'),
	(249710, 120, '2014-03-15 00:14:20.000000', 'temperatura', 502.0000, 'ºC'),
	(249711, 120, '2014-03-15 00:14:21.000000', 'temperatura', 980.0000, 'ºC'),
	(249712, 120, '2014-03-15 00:14:22.000000', 'temperatura', 995.0000, 'ºC'),
	(249713, 120, '2014-03-15 00:14:23.000000', 'temperatura', 837.0000, 'ºC'),
	(249714, 120, '2014-03-15 00:14:24.000000', 'temperatura', 0.0000, 'ºC'),
	(249715, 120, '2014-03-15 00:14:25.000000', 'temperatura', 1089.0000, 'ºC'),
	(249716, 120, '2014-03-15 00:14:26.000000', 'temperatura', 647.0000, 'ºC'),
	(249717, 120, '2014-03-15 00:14:27.000000', 'temperatura', 1168.0000, 'ºC'),
	(249718, 120, '2014-03-15 00:14:28.000000', 'temperatura', 301.0000, 'ºC'),
	(249719, 120, '2014-03-15 00:14:29.000000', 'temperatura', 401.0000, 'ºC'),
	(249720, 120, '2014-03-15 00:14:30.000000', 'temperatura', 1102.0000, 'ºC'),
	(249721, 120, '2014-03-15 00:14:31.000000', 'temperatura', 707.0000, 'ºC'),
	(249722, 120, '2014-03-15 00:14:32.000000', 'temperatura', 230.0000, 'ºC'),
	(249723, 120, '2014-03-15 00:14:33.000000', 'temperatura', 228.0000, 'ºC'),
	(249724, 120, '2014-03-15 00:14:34.000000', 'temperatura', 449.0000, 'ºC'),
	(249725, 120, '2014-03-15 00:14:35.000000', 'temperatura', 365.0000, 'ºC'),
	(249726, 120, '2014-03-15 00:14:36.000000', 'temperatura', 478.0000, 'ºC'),
	(249727, 120, '2014-03-15 00:14:37.000000', 'temperatura', 95.0000, 'ºC'),
	(249728, 120, '2014-03-15 00:14:38.000000', 'temperatura', 242.0000, 'ºC'),
	(249729, 120, '2014-03-15 00:14:39.000000', 'temperatura', 924.0000, 'ºC'),
	(249730, 120, '2014-03-15 00:14:40.000000', 'temperatura', 294.0000, 'ºC'),
	(249731, 120, '2014-03-15 00:14:41.000000', 'temperatura', 1097.0000, 'ºC'),
	(249732, 120, '2014-03-15 00:14:42.000000', 'temperatura', 1006.0000, 'ºC'),
	(249733, 120, '2014-03-15 00:14:43.000000', 'temperatura', 541.0000, 'ºC'),
	(249734, 120, '2014-03-15 00:14:44.000000', 'temperatura', 885.0000, 'ºC'),
	(249735, 120, '2014-03-15 00:14:45.000000', 'temperatura', 403.0000, 'ºC'),
	(249736, 120, '2014-03-15 00:14:46.000000', 'temperatura', 563.0000, 'ºC'),
	(249737, 120, '2014-03-15 00:14:47.000000', 'temperatura', 403.0000, 'ºC'),
	(249738, 120, '2014-03-15 00:14:48.000000', 'temperatura', 328.0000, 'ºC'),
	(249739, 120, '2014-03-15 00:14:49.000000', 'temperatura', 429.0000, 'ºC'),
	(249740, 120, '2014-03-15 00:14:50.000000', 'temperatura', 1165.0000, 'ºC'),
	(249741, 120, '2014-03-15 00:14:51.000000', 'temperatura', 938.0000, 'ºC'),
	(249742, 120, '2014-03-15 00:14:52.000000', 'temperatura', 1195.0000, 'ºC'),
	(249743, 120, '2014-03-15 00:14:53.000000', 'temperatura', 763.0000, 'ºC'),
	(249744, 120, '2014-03-15 00:14:54.000000', 'temperatura', 229.0000, 'ºC'),
	(249745, 120, '2014-03-15 00:14:55.000000', 'temperatura', 58.0000, 'ºC'),
	(249746, 120, '2014-03-15 00:14:56.000000', 'temperatura', 803.0000, 'ºC'),
	(249747, 120, '2014-03-15 00:14:57.000000', 'temperatura', 243.0000, 'ºC'),
	(249748, 120, '2014-03-15 00:14:58.000000', 'temperatura', 7.0000, 'ºC'),
	(249749, 120, '2014-03-15 00:14:59.000000', 'temperatura', 504.0000, 'ºC'),
	(249750, 120, '2014-03-15 00:15:00.000000', 'temperatura', 100.0000, 'ºC'),
	(249751, 120, '2014-03-15 00:15:01.000000', 'temperatura', 190.0000, 'ºC'),
	(249752, 120, '2014-03-15 00:15:02.000000', 'temperatura', 650.0000, 'ºC'),
	(249753, 120, '2014-03-15 00:15:03.000000', 'temperatura', 280.0000, 'ºC'),
	(249754, 120, '2014-03-15 00:15:04.000000', 'temperatura', 651.0000, 'ºC'),
	(249755, 120, '2014-03-15 00:15:05.000000', 'temperatura', 17.0000, 'ºC'),
	(249756, 120, '2014-03-15 00:15:06.000000', 'temperatura', 533.0000, 'ºC'),
	(249757, 120, '2014-03-15 00:15:07.000000', 'temperatura', 212.0000, 'ºC'),
	(249758, 120, '2014-03-15 00:15:08.000000', 'temperatura', 662.0000, 'ºC'),
	(249759, 120, '2014-03-15 00:15:09.000000', 'temperatura', 275.0000, 'ºC'),
	(249760, 120, '2014-03-15 00:15:10.000000', 'temperatura', 589.0000, 'ºC'),
	(249761, 120, '2014-03-15 00:15:11.000000', 'temperatura', 922.0000, 'ºC'),
	(249762, 120, '2014-03-15 00:15:12.000000', 'temperatura', 444.0000, 'ºC'),
	(249763, 120, '2014-03-15 00:15:13.000000', 'temperatura', 653.0000, 'ºC'),
	(249764, 120, '2014-03-15 00:15:14.000000', 'temperatura', 735.0000, 'ºC'),
	(249765, 120, '2014-03-15 00:15:15.000000', 'temperatura', 514.0000, 'ºC'),
	(249766, 120, '2014-03-15 00:15:16.000000', 'temperatura', 365.0000, 'ºC'),
	(249767, 120, '2014-03-15 00:15:17.000000', 'temperatura', 286.0000, 'ºC'),
	(249768, 120, '2014-03-15 00:15:18.000000', 'temperatura', 333.0000, 'ºC'),
	(249769, 120, '2014-03-15 00:15:19.000000', 'temperatura', 811.0000, 'ºC'),
	(249770, 120, '2014-03-15 00:15:20.000000', 'temperatura', 653.0000, 'ºC'),
	(249771, 120, '2014-03-15 00:15:21.000000', 'temperatura', 833.0000, 'ºC'),
	(249772, 120, '2014-03-15 00:15:22.000000', 'temperatura', 1007.0000, 'ºC'),
	(249773, 120, '2014-03-15 00:15:23.000000', 'temperatura', 138.0000, 'ºC'),
	(249774, 120, '2014-03-15 00:15:24.000000', 'temperatura', 67.0000, 'ºC'),
	(249775, 120, '2014-03-15 00:15:25.000000', 'temperatura', 1124.0000, 'ºC'),
	(249776, 120, '2014-03-15 00:15:26.000000', 'temperatura', 618.0000, 'ºC'),
	(249777, 120, '2014-03-15 00:15:27.000000', 'temperatura', 917.0000, 'ºC'),
	(249778, 120, '2014-03-15 00:15:28.000000', 'temperatura', 333.0000, 'ºC'),
	(249779, 120, '2014-03-15 00:15:29.000000', 'temperatura', 113.0000, 'ºC'),
	(249780, 120, '2014-03-15 00:15:30.000000', 'temperatura', 766.0000, 'ºC'),
	(249781, 120, '2014-03-15 00:15:31.000000', 'temperatura', 1091.0000, 'ºC'),
	(249782, 120, '2014-03-15 00:15:32.000000', 'temperatura', 759.0000, 'ºC'),
	(249783, 120, '2014-03-15 00:15:33.000000', 'temperatura', 521.0000, 'ºC'),
	(249784, 120, '2014-03-15 00:15:34.000000', 'temperatura', 328.0000, 'ºC'),
	(249785, 120, '2014-03-15 00:15:35.000000', 'temperatura', 80.0000, 'ºC'),
	(249786, 120, '2014-03-15 00:15:36.000000', 'temperatura', 614.0000, 'ºC'),
	(249787, 120, '2014-03-15 00:15:37.000000', 'temperatura', 433.0000, 'ºC'),
	(249788, 120, '2014-03-15 00:15:38.000000', 'temperatura', 322.0000, 'ºC'),
	(249789, 120, '2014-03-15 00:15:39.000000', 'temperatura', 311.0000, 'ºC'),
	(249790, 120, '2014-03-15 00:15:40.000000', 'temperatura', 589.0000, 'ºC'),
	(249791, 120, '2014-03-15 00:15:41.000000', 'temperatura', 811.0000, 'ºC'),
	(249792, 120, '2014-03-15 00:15:42.000000', 'temperatura', 1092.0000, 'ºC'),
	(249793, 120, '2014-03-15 00:15:43.000000', 'temperatura', 624.0000, 'ºC'),
	(249794, 120, '2014-03-15 00:15:44.000000', 'temperatura', 1048.0000, 'ºC'),
	(249795, 120, '2014-03-15 00:15:45.000000', 'temperatura', 965.0000, 'ºC'),
	(249796, 120, '2014-03-15 00:15:46.000000', 'temperatura', 484.0000, 'ºC'),
	(249797, 120, '2014-03-15 00:15:47.000000', 'temperatura', 725.0000, 'ºC'),
	(249798, 120, '2014-03-15 00:15:48.000000', 'temperatura', 972.0000, 'ºC'),
	(249799, 120, '2014-03-15 00:15:49.000000', 'temperatura', 288.0000, 'ºC'),
	(249800, 120, '2014-03-15 00:15:50.000000', 'temperatura', 925.0000, 'ºC'),
	(249801, 120, '2014-03-15 00:15:51.000000', 'temperatura', 160.0000, 'ºC'),
	(249802, 120, '2014-03-15 00:15:52.000000', 'temperatura', 427.0000, 'ºC'),
	(249803, 120, '2014-03-15 00:15:53.000000', 'temperatura', 455.0000, 'ºC'),
	(249804, 120, '2014-03-15 00:15:54.000000', 'temperatura', 995.0000, 'ºC'),
	(249805, 120, '2014-03-15 00:15:55.000000', 'temperatura', 10.0000, 'ºC'),
	(249806, 120, '2014-03-15 00:15:56.000000', 'temperatura', 664.0000, 'ºC'),
	(249807, 120, '2014-03-15 00:15:57.000000', 'temperatura', 891.0000, 'ºC'),
	(249808, 120, '2014-03-15 00:15:58.000000', 'temperatura', 64.0000, 'ºC'),
	(249809, 120, '2014-03-15 00:15:59.000000', 'temperatura', 48.0000, 'ºC'),
	(249810, 120, '2014-03-15 00:16:00.000000', 'temperatura', 48.0000, 'ºC'),
	(249811, 120, '2014-03-15 00:16:01.000000', 'temperatura', 98.0000, 'ºC'),
	(249812, 120, '2014-03-15 00:16:02.000000', 'temperatura', 346.0000, 'ºC'),
	(249813, 120, '2014-03-15 00:16:03.000000', 'temperatura', 237.0000, 'ºC'),
	(249814, 120, '2014-03-15 00:16:04.000000', 'temperatura', 149.0000, 'ºC'),
	(249815, 120, '2014-03-15 00:16:05.000000', 'temperatura', 31.0000, 'ºC'),
	(249816, 120, '2014-03-15 00:16:06.000000', 'temperatura', 910.0000, 'ºC'),
	(249817, 120, '2014-03-15 00:16:07.000000', 'temperatura', 858.0000, 'ºC'),
	(249818, 120, '2014-03-15 00:16:08.000000', 'temperatura', 360.0000, 'ºC'),
	(249819, 120, '2014-03-15 00:16:09.000000', 'temperatura', 429.0000, 'ºC'),
	(249820, 120, '2014-03-15 00:16:10.000000', 'temperatura', 1062.0000, 'ºC'),
	(249821, 120, '2014-03-15 00:16:11.000000', 'temperatura', 423.0000, 'ºC'),
	(249822, 120, '2014-03-15 00:16:12.000000', 'temperatura', 132.0000, 'ºC'),
	(249823, 120, '2014-03-15 00:16:13.000000', 'temperatura', 592.0000, 'ºC'),
	(249824, 120, '2014-03-15 00:16:14.000000', 'temperatura', 164.0000, 'ºC'),
	(249825, 120, '2014-03-15 00:16:15.000000', 'temperatura', 243.0000, 'ºC'),
	(249826, 120, '2014-03-15 00:16:16.000000', 'temperatura', 724.0000, 'ºC'),
	(249827, 120, '2014-03-15 00:16:17.000000', 'temperatura', 493.0000, 'ºC'),
	(249828, 120, '2014-03-15 00:16:18.000000', 'temperatura', 292.0000, 'ºC'),
	(249829, 120, '2014-03-15 00:16:19.000000', 'temperatura', 1183.0000, 'ºC'),
	(249830, 120, '2014-03-15 00:16:20.000000', 'temperatura', 238.0000, 'ºC'),
	(249831, 120, '2014-03-15 00:16:21.000000', 'temperatura', 42.0000, 'ºC'),
	(249832, 120, '2014-03-15 00:16:22.000000', 'temperatura', 697.0000, 'ºC'),
	(249833, 120, '2014-03-15 00:16:23.000000', 'temperatura', 958.0000, 'ºC'),
	(249834, 120, '2014-03-15 00:16:24.000000', 'temperatura', 300.0000, 'ºC'),
	(249835, 120, '2014-03-15 00:16:25.000000', 'temperatura', 1027.0000, 'ºC'),
	(249836, 120, '2014-03-15 00:16:26.000000', 'temperatura', 635.0000, 'ºC'),
	(249837, 120, '2014-03-15 00:16:27.000000', 'temperatura', 95.0000, 'ºC'),
	(249838, 120, '2014-03-15 00:16:28.000000', 'temperatura', 969.0000, 'ºC'),
	(249839, 120, '2014-03-15 00:16:29.000000', 'temperatura', 963.0000, 'ºC'),
	(249840, 120, '2014-03-15 00:16:30.000000', 'temperatura', 708.0000, 'ºC'),
	(249841, 120, '2014-03-15 00:16:31.000000', 'temperatura', 650.0000, 'ºC'),
	(249842, 120, '2014-03-15 00:16:32.000000', 'temperatura', 1126.0000, 'ºC'),
	(249843, 120, '2014-03-15 00:16:33.000000', 'temperatura', 83.0000, 'ºC'),
	(249844, 120, '2014-03-15 00:16:34.000000', 'temperatura', 638.0000, 'ºC'),
	(249845, 120, '2014-03-15 00:16:35.000000', 'temperatura', 539.0000, 'ºC'),
	(249846, 120, '2014-03-15 00:16:36.000000', 'temperatura', 784.0000, 'ºC'),
	(249847, 120, '2014-03-15 00:16:37.000000', 'temperatura', 1102.0000, 'ºC'),
	(249848, 120, '2014-03-15 00:16:38.000000', 'temperatura', 757.0000, 'ºC'),
	(249849, 120, '2014-03-15 00:16:39.000000', 'temperatura', 481.0000, 'ºC'),
	(249850, 120, '2014-03-15 00:16:40.000000', 'temperatura', 136.0000, 'ºC'),
	(249851, 120, '2014-03-15 00:16:41.000000', 'temperatura', 437.0000, 'ºC'),
	(249852, 120, '2014-03-15 00:16:42.000000', 'temperatura', 578.0000, 'ºC'),
	(249853, 120, '2014-03-15 00:16:43.000000', 'temperatura', 377.0000, 'ºC'),
	(249854, 120, '2014-03-15 00:16:44.000000', 'temperatura', 155.0000, 'ºC'),
	(249855, 120, '2014-03-15 00:16:45.000000', 'temperatura', 842.0000, 'ºC'),
	(249856, 120, '2014-03-15 00:16:46.000000', 'temperatura', 148.0000, 'ºC'),
	(249857, 120, '2014-03-15 00:16:47.000000', 'temperatura', 613.0000, 'ºC'),
	(249858, 120, '2014-03-15 00:16:48.000000', 'temperatura', 222.0000, 'ºC'),
	(249859, 120, '2014-03-15 00:16:49.000000', 'temperatura', 471.0000, 'ºC'),
	(249860, 120, '2014-03-15 00:16:50.000000', 'temperatura', 491.0000, 'ºC'),
	(249861, 120, '2014-03-15 00:16:51.000000', 'temperatura', 1043.0000, 'ºC'),
	(249862, 120, '2014-03-15 00:16:52.000000', 'temperatura', 143.0000, 'ºC'),
	(249863, 120, '2014-03-15 00:16:53.000000', 'temperatura', 1185.0000, 'ºC'),
	(249864, 120, '2014-03-15 00:16:54.000000', 'temperatura', 697.0000, 'ºC'),
	(249865, 120, '2014-03-15 00:16:55.000000', 'temperatura', 1129.0000, 'ºC'),
	(249866, 120, '2014-03-15 00:16:56.000000', 'temperatura', 1154.0000, 'ºC'),
	(249867, 120, '2014-03-15 00:16:57.000000', 'temperatura', 1185.0000, 'ºC'),
	(249868, 120, '2014-03-15 00:16:58.000000', 'temperatura', 64.0000, 'ºC'),
	(249869, 120, '2014-03-15 00:16:59.000000', 'temperatura', 363.0000, 'ºC'),
	(249870, 120, '2014-03-15 00:17:00.000000', 'temperatura', 426.0000, 'ºC'),
	(249871, 120, '2014-03-15 00:17:01.000000', 'temperatura', 1042.0000, 'ºC'),
	(249872, 120, '2014-03-15 00:17:02.000000', 'temperatura', 330.0000, 'ºC'),
	(249873, 120, '2014-03-15 00:17:03.000000', 'temperatura', 927.0000, 'ºC'),
	(249874, 120, '2014-03-15 00:17:04.000000', 'temperatura', 45.0000, 'ºC'),
	(249875, 120, '2014-03-15 00:17:05.000000', 'temperatura', 1046.0000, 'ºC'),
	(249876, 120, '2014-03-15 00:17:06.000000', 'temperatura', 294.0000, 'ºC'),
	(249877, 120, '2014-03-15 00:17:07.000000', 'temperatura', 732.0000, 'ºC'),
	(249878, 120, '2014-03-15 00:17:08.000000', 'temperatura', 378.0000, 'ºC'),
	(249879, 120, '2014-03-15 00:17:09.000000', 'temperatura', 894.0000, 'ºC'),
	(249880, 120, '2014-03-15 00:17:10.000000', 'temperatura', 938.0000, 'ºC'),
	(249881, 120, '2014-03-15 00:17:11.000000', 'temperatura', 806.0000, 'ºC'),
	(249882, 120, '2014-03-15 00:17:12.000000', 'temperatura', 18.0000, 'ºC'),
	(249883, 120, '2014-03-15 00:17:13.000000', 'temperatura', 74.0000, 'ºC'),
	(249884, 120, '2014-03-15 00:17:14.000000', 'temperatura', 315.0000, 'ºC'),
	(249885, 120, '2014-03-15 00:17:15.000000', 'temperatura', 154.0000, 'ºC'),
	(249886, 120, '2014-03-15 00:17:16.000000', 'temperatura', 1025.0000, 'ºC'),
	(249887, 120, '2014-03-15 00:17:17.000000', 'temperatura', 1064.0000, 'ºC'),
	(249888, 120, '2014-03-15 00:17:18.000000', 'temperatura', 1046.0000, 'ºC'),
	(249889, 120, '2014-03-15 00:17:19.000000', 'temperatura', 838.0000, 'ºC'),
	(249890, 120, '2014-03-15 00:17:20.000000', 'temperatura', 1051.0000, 'ºC'),
	(249891, 120, '2014-03-15 00:17:21.000000', 'temperatura', 342.0000, 'ºC'),
	(249892, 120, '2014-03-15 00:17:22.000000', 'temperatura', 959.0000, 'ºC'),
	(249893, 120, '2014-03-15 00:17:23.000000', 'temperatura', 169.0000, 'ºC'),
	(249894, 120, '2014-03-15 00:17:24.000000', 'temperatura', 370.0000, 'ºC'),
	(249895, 120, '2014-03-15 00:17:25.000000', 'temperatura', 141.0000, 'ºC'),
	(249896, 120, '2014-03-15 00:17:26.000000', 'temperatura', 796.0000, 'ºC'),
	(249897, 120, '2014-03-15 00:17:27.000000', 'temperatura', 1156.0000, 'ºC'),
	(249898, 120, '2014-03-15 00:17:28.000000', 'temperatura', 994.0000, 'ºC'),
	(249899, 120, '2014-03-15 00:17:29.000000', 'temperatura', 304.0000, 'ºC'),
	(249900, 120, '2014-03-15 00:17:30.000000', 'temperatura', 939.0000, 'ºC'),
	(249901, 120, '2014-03-15 00:17:31.000000', 'temperatura', 182.0000, 'ºC'),
	(249902, 120, '2014-03-15 00:17:32.000000', 'temperatura', 493.0000, 'ºC'),
	(249903, 120, '2014-03-15 00:17:33.000000', 'temperatura', 722.0000, 'ºC'),
	(249904, 120, '2014-03-15 00:17:34.000000', 'temperatura', 929.0000, 'ºC'),
	(249905, 120, '2014-03-15 00:17:35.000000', 'temperatura', 80.0000, 'ºC'),
	(249906, 120, '2014-03-15 00:17:36.000000', 'temperatura', 15.0000, 'ºC'),
	(249907, 120, '2014-03-15 00:17:37.000000', 'temperatura', 1035.0000, 'ºC'),
	(249908, 120, '2014-03-15 00:17:38.000000', 'temperatura', 331.0000, 'ºC'),
	(249909, 120, '2014-03-15 00:17:39.000000', 'temperatura', 949.0000, 'ºC'),
	(249910, 120, '2014-03-15 00:17:40.000000', 'temperatura', 155.0000, 'ºC'),
	(249911, 120, '2014-03-15 00:17:41.000000', 'temperatura', 327.0000, 'ºC'),
	(249912, 120, '2014-03-15 00:17:42.000000', 'temperatura', 1170.0000, 'ºC'),
	(249913, 120, '2014-03-15 00:17:43.000000', 'temperatura', 68.0000, 'ºC'),
	(249914, 120, '2014-03-15 00:17:44.000000', 'temperatura', 433.0000, 'ºC'),
	(249915, 120, '2014-03-15 00:17:45.000000', 'temperatura', 761.0000, 'ºC'),
	(249916, 120, '2014-03-15 00:17:46.000000', 'temperatura', 108.0000, 'ºC'),
	(249917, 120, '2014-03-15 00:17:47.000000', 'temperatura', 656.0000, 'ºC'),
	(249918, 120, '2014-03-15 00:17:48.000000', 'temperatura', 555.0000, 'ºC'),
	(249919, 120, '2014-03-15 00:17:49.000000', 'temperatura', 808.0000, 'ºC'),
	(249920, 120, '2014-03-15 00:17:50.000000', 'temperatura', 1177.0000, 'ºC'),
	(249921, 120, '2014-03-15 00:17:51.000000', 'temperatura', 1062.0000, 'ºC'),
	(249922, 120, '2014-03-15 00:17:52.000000', 'temperatura', 580.0000, 'ºC'),
	(249923, 120, '2014-03-15 00:17:53.000000', 'temperatura', 914.0000, 'ºC'),
	(249924, 120, '2014-03-15 00:17:54.000000', 'temperatura', 431.0000, 'ºC'),
	(249925, 120, '2014-03-15 00:17:55.000000', 'temperatura', 613.0000, 'ºC'),
	(249926, 120, '2014-03-15 00:17:56.000000', 'temperatura', 574.0000, 'ºC'),
	(249927, 120, '2014-03-15 00:17:57.000000', 'temperatura', 1031.0000, 'ºC'),
	(249928, 120, '2014-03-15 00:17:58.000000', 'temperatura', 1032.0000, 'ºC'),
	(249929, 120, '2014-03-15 00:17:59.000000', 'temperatura', 868.0000, 'ºC'),
	(249930, 120, '2014-03-15 00:18:00.000000', 'temperatura', 44.0000, 'ºC'),
	(249931, 120, '2014-03-15 00:18:01.000000', 'temperatura', 15.0000, 'ºC'),
	(249932, 120, '2014-03-15 00:18:02.000000', 'temperatura', 1146.0000, 'ºC'),
	(249933, 120, '2014-03-15 00:18:03.000000', 'temperatura', 883.0000, 'ºC'),
	(249934, 120, '2014-03-15 00:18:04.000000', 'temperatura', 977.0000, 'ºC'),
	(249935, 120, '2014-03-15 00:18:05.000000', 'temperatura', 1038.0000, 'ºC'),
	(249936, 120, '2014-03-15 00:18:06.000000', 'temperatura', 1060.0000, 'ºC'),
	(249937, 120, '2014-03-15 00:18:07.000000', 'temperatura', 984.0000, 'ºC'),
	(249938, 120, '2014-03-15 00:18:08.000000', 'temperatura', 543.0000, 'ºC'),
	(249939, 120, '2014-03-15 00:18:09.000000', 'temperatura', 962.0000, 'ºC'),
	(249940, 120, '2014-03-15 00:18:10.000000', 'temperatura', 782.0000, 'ºC'),
	(249941, 120, '2014-03-15 00:18:11.000000', 'temperatura', 1023.0000, 'ºC'),
	(249942, 120, '2014-03-15 00:18:12.000000', 'temperatura', 372.0000, 'ºC'),
	(249943, 120, '2014-03-15 00:18:13.000000', 'temperatura', 1191.0000, 'ºC'),
	(249944, 120, '2014-03-15 00:18:14.000000', 'temperatura', 39.0000, 'ºC'),
	(249945, 120, '2014-03-15 00:18:15.000000', 'temperatura', 221.0000, 'ºC'),
	(249946, 120, '2014-03-15 00:18:16.000000', 'temperatura', 990.0000, 'ºC'),
	(249947, 120, '2014-03-15 00:18:17.000000', 'temperatura', 686.0000, 'ºC'),
	(249948, 120, '2014-03-15 00:18:18.000000', 'temperatura', 460.0000, 'ºC'),
	(249949, 120, '2014-03-15 00:18:19.000000', 'temperatura', 245.0000, 'ºC'),
	(249950, 120, '2014-03-15 00:18:20.000000', 'temperatura', 1044.0000, 'ºC'),
	(249951, 120, '2014-03-15 00:18:21.000000', 'temperatura', 887.0000, 'ºC'),
	(249952, 120, '2014-03-15 00:18:22.000000', 'temperatura', 102.0000, 'ºC'),
	(249953, 120, '2014-03-15 00:18:23.000000', 'temperatura', 251.0000, 'ºC'),
	(249954, 120, '2014-03-15 00:18:24.000000', 'temperatura', 951.0000, 'ºC'),
	(249955, 120, '2014-03-15 00:18:25.000000', 'temperatura', 399.0000, 'ºC'),
	(249956, 120, '2014-03-15 00:18:26.000000', 'temperatura', 343.0000, 'ºC'),
	(249957, 120, '2014-03-15 00:18:27.000000', 'temperatura', 520.0000, 'ºC'),
	(249958, 120, '2014-03-15 00:18:28.000000', 'temperatura', 373.0000, 'ºC'),
	(249959, 120, '2014-03-15 00:18:29.000000', 'temperatura', 304.0000, 'ºC'),
	(249960, 120, '2014-03-15 00:18:30.000000', 'temperatura', 400.0000, 'ºC'),
	(249961, 120, '2014-03-15 00:18:31.000000', 'temperatura', 1090.0000, 'ºC'),
	(249962, 120, '2014-03-15 00:18:32.000000', 'temperatura', 651.0000, 'ºC'),
	(249963, 120, '2014-03-15 00:18:33.000000', 'temperatura', 1184.0000, 'ºC'),
	(249964, 120, '2014-03-15 00:18:34.000000', 'temperatura', 367.0000, 'ºC'),
	(249965, 120, '2014-03-15 00:18:35.000000', 'temperatura', 683.0000, 'ºC'),
	(249966, 120, '2014-03-15 00:18:36.000000', 'temperatura', 1115.0000, 'ºC'),
	(249967, 120, '2014-03-15 00:18:37.000000', 'temperatura', 1126.0000, 'ºC'),
	(249968, 120, '2014-03-15 00:18:38.000000', 'temperatura', 1084.0000, 'ºC'),
	(249969, 120, '2014-03-15 00:18:39.000000', 'temperatura', 845.0000, 'ºC'),
	(249970, 120, '2014-03-15 00:18:40.000000', 'temperatura', 973.0000, 'ºC'),
	(249971, 120, '2014-03-15 00:18:41.000000', 'temperatura', 1130.0000, 'ºC'),
	(249972, 120, '2014-03-15 00:18:42.000000', 'temperatura', 332.0000, 'ºC'),
	(249973, 120, '2014-03-15 00:18:43.000000', 'temperatura', 672.0000, 'ºC'),
	(249974, 120, '2014-03-15 00:18:44.000000', 'temperatura', 1163.0000, 'ºC'),
	(249975, 120, '2014-03-15 00:18:45.000000', 'temperatura', 201.0000, 'ºC'),
	(249976, 120, '2014-03-15 00:18:46.000000', 'temperatura', 1118.0000, 'ºC'),
	(249977, 120, '2014-03-15 00:18:47.000000', 'temperatura', 184.0000, 'ºC'),
	(249978, 120, '2014-03-15 00:18:48.000000', 'temperatura', 1169.0000, 'ºC'),
	(249979, 120, '2014-03-15 00:18:49.000000', 'temperatura', 492.0000, 'ºC'),
	(249980, 120, '2014-03-15 00:18:50.000000', 'temperatura', 153.0000, 'ºC'),
	(249981, 120, '2014-03-15 00:18:51.000000', 'temperatura', 488.0000, 'ºC'),
	(249982, 120, '2014-03-15 00:18:52.000000', 'temperatura', 784.0000, 'ºC'),
	(249983, 120, '2014-03-15 00:18:53.000000', 'temperatura', 57.0000, 'ºC'),
	(249984, 120, '2014-03-15 00:18:54.000000', 'temperatura', 331.0000, 'ºC'),
	(249985, 120, '2014-03-15 00:18:55.000000', 'temperatura', 285.0000, 'ºC'),
	(249986, 120, '2014-03-15 00:18:56.000000', 'temperatura', 434.0000, 'ºC'),
	(249987, 120, '2014-03-15 00:18:57.000000', 'temperatura', 116.0000, 'ºC'),
	(249988, 120, '2014-03-15 00:18:58.000000', 'temperatura', 476.0000, 'ºC'),
	(249989, 120, '2014-03-15 00:18:59.000000', 'temperatura', 832.0000, 'ºC'),
	(249990, 120, '2014-03-15 00:19:00.000000', 'temperatura', 334.0000, 'ºC'),
	(249991, 120, '2014-03-15 00:19:01.000000', 'temperatura', 375.0000, 'ºC'),
	(249992, 120, '2014-03-15 00:19:02.000000', 'temperatura', 872.0000, 'ºC'),
	(249993, 120, '2014-03-15 00:19:03.000000', 'temperatura', 836.0000, 'ºC'),
	(249994, 120, '2014-03-15 00:19:04.000000', 'temperatura', 366.0000, 'ºC'),
	(249995, 120, '2014-03-15 00:19:05.000000', 'temperatura', 521.0000, 'ºC'),
	(249996, 120, '2014-03-15 00:19:06.000000', 'temperatura', 308.0000, 'ºC'),
	(249997, 120, '2014-03-15 00:19:07.000000', 'temperatura', 1177.0000, 'ºC'),
	(249998, 120, '2014-03-15 00:19:08.000000', 'temperatura', 161.0000, 'ºC'),
	(249999, 120, '2014-03-15 00:19:09.000000', 'temperatura', 876.0000, 'ºC'),
	(250000, 120, '2014-03-15 00:19:10.000000', 'temperatura', 295.0000, 'ºC'),
	(250001, 120, '2014-03-15 00:19:11.000000', 'temperatura', 48.0000, 'ºC'),
	(250002, 120, '2014-03-15 00:19:12.000000', 'temperatura', 555.0000, 'ºC'),
	(250003, 120, '2014-03-15 00:19:13.000000', 'temperatura', 230.0000, 'ºC'),
	(250004, 120, '2014-03-15 00:19:14.000000', 'temperatura', 689.0000, 'ºC'),
	(250005, 120, '2014-03-15 00:19:15.000000', 'temperatura', 355.0000, 'ºC'),
	(250006, 120, '2014-03-15 00:19:16.000000', 'temperatura', 907.0000, 'ºC'),
	(250007, 120, '2014-03-15 00:19:17.000000', 'temperatura', 1069.0000, 'ºC'),
	(250008, 120, '2014-03-15 00:19:18.000000', 'temperatura', 227.0000, 'ºC'),
	(250009, 120, '2014-03-15 00:19:19.000000', 'temperatura', 326.0000, 'ºC'),
	(250010, 120, '2014-03-15 00:19:20.000000', 'temperatura', 953.0000, 'ºC'),
	(250011, 120, '2014-03-15 00:19:21.000000', 'temperatura', 184.0000, 'ºC'),
	(250012, 120, '2014-03-15 00:19:22.000000', 'temperatura', 463.0000, 'ºC'),
	(250013, 120, '2014-03-15 00:19:23.000000', 'temperatura', 565.0000, 'ºC'),
	(250014, 120, '2014-03-15 00:19:24.000000', 'temperatura', 234.0000, 'ºC'),
	(250015, 120, '2014-03-15 00:19:25.000000', 'temperatura', 678.0000, 'ºC'),
	(250016, 120, '2014-03-15 00:19:26.000000', 'temperatura', 286.0000, 'ºC'),
	(250017, 120, '2014-03-15 00:19:27.000000', 'temperatura', 598.0000, 'ºC'),
	(250018, 120, '2014-03-15 00:19:28.000000', 'temperatura', 932.0000, 'ºC'),
	(250019, 120, '2014-03-15 00:19:29.000000', 'temperatura', 465.0000, 'ºC'),
	(250020, 120, '2014-03-15 00:19:30.000000', 'temperatura', 730.0000, 'ºC'),
	(250021, 120, '2014-03-15 00:19:31.000000', 'temperatura', 1055.0000, 'ºC'),
	(250022, 120, '2014-03-15 00:19:32.000000', 'temperatura', 688.0000, 'ºC'),
	(250023, 120, '2014-03-15 00:19:33.000000', 'temperatura', 274.0000, 'ºC'),
	(250024, 120, '2014-03-15 00:19:34.000000', 'temperatura', 506.0000, 'ºC'),
	(250025, 120, '2014-03-15 00:19:35.000000', 'temperatura', 508.0000, 'ºC'),
	(250026, 120, '2014-03-15 00:19:36.000000', 'temperatura', 1024.0000, 'ºC'),
	(250027, 120, '2014-03-15 00:19:37.000000', 'temperatura', 1194.0000, 'ºC'),
	(250028, 120, '2014-03-15 00:19:38.000000', 'temperatura', 499.0000, 'ºC'),
	(250029, 120, '2014-03-15 00:19:39.000000', 'temperatura', 116.0000, 'ºC'),
	(250030, 120, '2014-03-15 00:19:40.000000', 'temperatura', 283.0000, 'ºC'),
	(250031, 120, '2014-03-15 00:19:41.000000', 'temperatura', 1067.0000, 'ºC'),
	(250032, 120, '2014-03-15 00:19:42.000000', 'temperatura', 885.0000, 'ºC'),
	(250033, 120, '2014-03-15 00:19:43.000000', 'temperatura', 24.0000, 'ºC'),
	(250034, 120, '2014-03-15 00:19:44.000000', 'temperatura', 1068.0000, 'ºC'),
	(250035, 120, '2014-03-15 00:19:45.000000', 'temperatura', 468.0000, 'ºC'),
	(250036, 120, '2014-03-15 00:19:46.000000', 'temperatura', 335.0000, 'ºC'),
	(250037, 120, '2014-03-15 00:19:47.000000', 'temperatura', 274.0000, 'ºC'),
	(250038, 120, '2014-03-15 00:19:48.000000', 'temperatura', 365.0000, 'ºC'),
	(250039, 120, '2014-03-15 00:19:49.000000', 'temperatura', 1002.0000, 'ºC'),
	(250040, 120, '2014-03-15 00:19:50.000000', 'temperatura', 318.0000, 'ºC'),
	(250041, 120, '2014-03-15 00:19:51.000000', 'temperatura', 982.0000, 'ºC'),
	(250042, 120, '2014-03-15 00:19:52.000000', 'temperatura', 355.0000, 'ºC'),
	(250043, 120, '2014-03-15 00:19:53.000000', 'temperatura', 33.0000, 'ºC'),
	(250044, 120, '2014-03-15 00:19:54.000000', 'temperatura', 299.0000, 'ºC'),
	(250045, 120, '2014-03-15 00:19:55.000000', 'temperatura', 197.0000, 'ºC'),
	(250046, 120, '2014-03-15 00:19:56.000000', 'temperatura', 88.0000, 'ºC'),
	(250047, 120, '2014-03-15 00:19:57.000000', 'temperatura', 1050.0000, 'ºC'),
	(250048, 120, '2014-03-15 00:19:58.000000', 'temperatura', 186.0000, 'ºC'),
	(250049, 120, '2014-03-15 00:19:59.000000', 'temperatura', 180.0000, 'ºC'),
	(250050, 120, '2014-03-15 00:20:00.000000', 'temperatura', 345.0000, 'ºC'),
	(250051, 120, '2014-03-15 00:20:01.000000', 'temperatura', 1184.0000, 'ºC'),
	(250052, 120, '2014-03-15 00:20:02.000000', 'temperatura', 87.0000, 'ºC'),
	(250053, 120, '2014-03-15 00:20:03.000000', 'temperatura', 483.0000, 'ºC'),
	(250054, 120, '2014-03-15 00:20:04.000000', 'temperatura', 953.0000, 'ºC'),
	(250055, 120, '2014-03-15 00:20:05.000000', 'temperatura', 916.0000, 'ºC'),
	(250056, 120, '2014-03-15 00:20:06.000000', 'temperatura', 524.0000, 'ºC'),
	(250057, 120, '2014-03-15 00:20:07.000000', 'temperatura', 1072.0000, 'ºC'),
	(250058, 120, '2014-03-15 00:20:08.000000', 'temperatura', 188.0000, 'ºC'),
	(250059, 120, '2014-03-15 00:20:09.000000', 'temperatura', 126.0000, 'ºC'),
	(250060, 120, '2014-03-15 00:20:10.000000', 'temperatura', 64.0000, 'ºC'),
	(250061, 120, '2014-03-15 00:20:11.000000', 'temperatura', 1145.0000, 'ºC'),
	(250062, 120, '2014-03-15 00:20:12.000000', 'temperatura', 734.0000, 'ºC'),
	(250063, 120, '2014-03-15 00:20:13.000000', 'temperatura', 235.0000, 'ºC'),
	(250064, 120, '2014-03-15 00:20:14.000000', 'temperatura', 174.0000, 'ºC'),
	(250065, 120, '2014-03-15 00:20:15.000000', 'temperatura', 166.0000, 'ºC'),
	(250066, 120, '2014-03-15 00:20:16.000000', 'temperatura', 310.0000, 'ºC'),
	(250067, 120, '2014-03-15 00:20:17.000000', 'temperatura', 1050.0000, 'ºC'),
	(250068, 120, '2014-03-15 00:20:18.000000', 'temperatura', 719.0000, 'ºC'),
	(250069, 120, '2014-03-15 00:20:19.000000', 'temperatura', 448.0000, 'ºC'),
	(250070, 120, '2014-03-15 00:20:20.000000', 'temperatura', 84.0000, 'ºC'),
	(250071, 120, '2014-03-15 00:20:21.000000', 'temperatura', 276.0000, 'ºC'),
	(250072, 120, '2014-03-15 00:20:22.000000', 'temperatura', 1127.0000, 'ºC'),
	(250073, 120, '2014-03-15 00:20:23.000000', 'temperatura', 10.0000, 'ºC'),
	(250074, 120, '2014-03-15 00:20:24.000000', 'temperatura', 267.0000, 'ºC'),
	(250075, 120, '2014-03-15 00:20:25.000000', 'temperatura', 105.0000, 'ºC'),
	(250076, 120, '2014-03-15 00:20:26.000000', 'temperatura', 926.0000, 'ºC'),
	(250077, 120, '2014-03-15 00:20:27.000000', 'temperatura', 715.0000, 'ºC'),
	(250078, 120, '2014-03-15 00:20:28.000000', 'temperatura', 797.0000, 'ºC'),
	(250079, 120, '2014-03-15 00:20:29.000000', 'temperatura', 640.0000, 'ºC'),
	(250080, 120, '2014-03-15 00:20:30.000000', 'temperatura', 809.0000, 'ºC'),
	(250081, 120, '2014-03-15 00:20:31.000000', 'temperatura', 926.0000, 'ºC'),
	(250082, 120, '2014-03-15 00:20:32.000000', 'temperatura', 1004.0000, 'ºC'),
	(250083, 120, '2014-03-15 00:20:33.000000', 'temperatura', 1041.0000, 'ºC'),
	(250084, 120, '2014-03-15 00:20:34.000000', 'temperatura', 995.0000, 'ºC'),
	(250085, 120, '2014-03-15 00:20:35.000000', 'temperatura', 653.0000, 'ºC'),
	(250086, 120, '2014-03-15 00:20:36.000000', 'temperatura', 281.0000, 'ºC'),
	(250087, 120, '2014-03-15 00:20:37.000000', 'temperatura', 646.0000, 'ºC'),
	(250088, 120, '2014-03-15 00:20:38.000000', 'temperatura', 1187.0000, 'ºC'),
	(250089, 120, '2014-03-15 00:20:39.000000', 'temperatura', 398.0000, 'ºC'),
	(250090, 120, '2014-03-15 00:20:40.000000', 'temperatura', 828.0000, 'ºC'),
	(250091, 120, '2014-03-15 00:20:41.000000', 'temperatura', 547.0000, 'ºC'),
	(250092, 120, '2014-03-15 00:20:42.000000', 'temperatura', 253.0000, 'ºC'),
	(250093, 120, '2014-03-15 00:20:43.000000', 'temperatura', 823.0000, 'ºC'),
	(250094, 120, '2014-03-15 00:20:44.000000', 'temperatura', 959.0000, 'ºC'),
	(250095, 120, '2014-03-15 00:20:45.000000', 'temperatura', 1125.0000, 'ºC'),
	(250096, 120, '2014-03-15 00:20:46.000000', 'temperatura', 349.0000, 'ºC'),
	(250097, 120, '2014-03-15 00:20:47.000000', 'temperatura', 772.0000, 'ºC'),
	(250098, 120, '2014-03-15 00:20:48.000000', 'temperatura', 412.0000, 'ºC'),
	(250099, 120, '2014-03-15 00:20:49.000000', 'temperatura', 944.0000, 'ºC'),
	(250100, 120, '2014-03-15 00:20:50.000000', 'temperatura', 1085.0000, 'ºC'),
	(250101, 120, '2014-03-15 00:20:51.000000', 'temperatura', 195.0000, 'ºC'),
	(250102, 120, '2014-03-15 00:20:52.000000', 'temperatura', 118.0000, 'ºC'),
	(250103, 120, '2014-03-15 00:20:53.000000', 'temperatura', 4.0000, 'ºC'),
	(250104, 120, '2014-03-15 00:20:54.000000', 'temperatura', 870.0000, 'ºC'),
	(250105, 120, '2014-03-15 00:20:55.000000', 'temperatura', 738.0000, 'ºC'),
	(250106, 120, '2014-03-15 00:20:56.000000', 'temperatura', 1081.0000, 'ºC'),
	(250107, 120, '2014-03-15 00:20:57.000000', 'temperatura', 792.0000, 'ºC'),
	(250108, 120, '2014-03-15 00:20:58.000000', 'temperatura', 716.0000, 'ºC'),
	(250109, 120, '2014-03-15 00:20:59.000000', 'temperatura', 6.0000, 'ºC'),
	(250110, 120, '2014-03-15 00:21:00.000000', 'temperatura', 284.0000, 'ºC'),
	(250111, 120, '2014-03-15 00:21:01.000000', 'temperatura', 200.0000, 'ºC'),
	(250112, 120, '2014-03-15 00:21:02.000000', 'temperatura', 148.0000, 'ºC'),
	(250113, 120, '2014-03-15 00:21:03.000000', 'temperatura', 143.0000, 'ºC'),
	(250114, 120, '2014-03-15 00:21:04.000000', 'temperatura', 269.0000, 'ºC'),
	(250115, 120, '2014-03-15 00:21:05.000000', 'temperatura', 919.0000, 'ºC'),
	(250116, 120, '2014-03-15 00:21:06.000000', 'temperatura', 187.0000, 'ºC'),
	(250117, 120, '2014-03-15 00:21:07.000000', 'temperatura', 580.0000, 'ºC'),
	(250118, 120, '2014-03-15 00:21:08.000000', 'temperatura', 1140.0000, 'ºC'),
	(250119, 120, '2014-03-15 00:21:09.000000', 'temperatura', 361.0000, 'ºC'),
	(250120, 120, '2014-03-15 00:21:10.000000', 'temperatura', 783.0000, 'ºC'),
	(250121, 120, '2014-03-15 00:21:11.000000', 'temperatura', 434.0000, 'ºC'),
	(250122, 120, '2014-03-15 00:21:12.000000', 'temperatura', 1021.0000, 'ºC'),
	(250123, 120, '2014-03-15 00:21:13.000000', 'temperatura', 205.0000, 'ºC'),
	(250124, 120, '2014-03-15 00:21:14.000000', 'temperatura', 360.0000, 'ºC'),
	(250125, 120, '2014-03-15 00:21:15.000000', 'temperatura', 1187.0000, 'ºC'),
	(250126, 120, '2014-03-15 00:21:16.000000', 'temperatura', 55.0000, 'ºC'),
	(250127, 120, '2014-03-15 00:21:17.000000', 'temperatura', 316.0000, 'ºC'),
	(250128, 120, '2014-03-15 00:21:18.000000', 'temperatura', 217.0000, 'ºC'),
	(250129, 120, '2014-03-15 00:21:19.000000', 'temperatura', 134.0000, 'ºC'),
	(250130, 120, '2014-03-15 00:21:20.000000', 'temperatura', 22.0000, 'ºC'),
	(250131, 120, '2014-03-15 00:21:21.000000', 'temperatura', 907.0000, 'ºC'),
	(250132, 120, '2014-03-15 00:21:22.000000', 'temperatura', 869.0000, 'ºC'),
	(250133, 120, '2014-03-15 00:21:23.000000', 'temperatura', 427.0000, 'ºC'),
	(250134, 120, '2014-03-15 00:21:24.000000', 'temperatura', 725.0000, 'ºC'),
	(250135, 120, '2014-03-15 00:21:25.000000', 'temperatura', 1148.0000, 'ºC'),
	(250136, 120, '2014-03-15 00:21:26.000000', 'temperatura', 1164.0000, 'ºC'),
	(250137, 120, '2014-03-15 00:21:27.000000', 'temperatura', 1178.0000, 'ºC'),
	(250138, 120, '2014-03-15 00:21:28.000000', 'temperatura', 1196.0000, 'ºC'),
	(250139, 120, '2014-03-15 00:21:29.000000', 'temperatura', 47.0000, 'ºC'),
	(250140, 120, '2014-03-15 00:21:30.000000', 'temperatura', 249.0000, 'ºC'),
	(250141, 120, '2014-03-15 00:21:31.000000', 'temperatura', 1102.0000, 'ºC'),
	(250142, 120, '2014-03-15 00:21:32.000000', 'temperatura', 1166.0000, 'ºC'),
	(250143, 120, '2014-03-15 00:21:33.000000', 'temperatura', 123.0000, 'ºC'),
	(250144, 120, '2014-03-15 00:21:34.000000', 'temperatura', 716.0000, 'ºC'),
	(250145, 120, '2014-03-15 00:21:35.000000', 'temperatura', 812.0000, 'ºC'),
	(250146, 120, '2014-03-15 00:21:36.000000', 'temperatura', 713.0000, 'ºC'),
	(250147, 120, '2014-03-15 00:21:37.000000', 'temperatura', 1130.0000, 'ºC'),
	(250148, 120, '2014-03-15 00:21:38.000000', 'temperatura', 1112.0000, 'ºC'),
	(250149, 120, '2014-03-15 00:21:39.000000', 'temperatura', 970.0000, 'ºC'),
	(250150, 120, '2014-03-15 00:21:40.000000', 'temperatura', 314.0000, 'ºC'),
	(250151, 120, '2014-03-15 00:21:41.000000', 'temperatura', 1060.0000, 'ºC'),
	(250152, 120, '2014-03-15 00:21:42.000000', 'temperatura', 758.0000, 'ºC'),
	(250153, 120, '2014-03-15 00:21:43.000000', 'temperatura', 613.0000, 'ºC'),
	(250154, 120, '2014-03-15 00:21:44.000000', 'temperatura', 791.0000, 'ºC'),
	(250155, 120, '2014-03-15 00:21:45.000000', 'temperatura', 917.0000, 'ºC'),
	(250156, 120, '2014-03-15 00:21:46.000000', 'temperatura', 1011.0000, 'ºC'),
	(250157, 120, '2014-03-15 00:21:47.000000', 'temperatura', 1103.0000, 'ºC'),
	(250158, 120, '2014-03-15 00:21:48.000000', 'temperatura', 85.0000, 'ºC'),
	(250159, 120, '2014-03-15 00:21:49.000000', 'temperatura', 718.0000, 'ºC'),
	(250160, 120, '2014-03-15 00:21:50.000000', 'temperatura', 932.0000, 'ºC'),
	(250161, 120, '2014-03-15 00:21:51.000000', 'temperatura', 110.0000, 'ºC'),
	(250162, 120, '2014-03-15 00:21:52.000000', 'temperatura', 153.0000, 'ºC'),
	(250163, 120, '2014-03-15 00:21:53.000000', 'temperatura', 435.0000, 'ºC'),
	(250164, 120, '2014-03-15 00:21:54.000000', 'temperatura', 516.0000, 'ºC'),
	(250165, 120, '2014-03-15 00:21:55.000000', 'temperatura', 77.0000, 'ºC'),
	(250166, 120, '2014-03-15 00:21:56.000000', 'temperatura', 35.0000, 'ºC'),
	(250167, 120, '2014-03-15 00:21:57.000000', 'temperatura', 1146.0000, 'ºC'),
	(250168, 120, '2014-03-15 00:21:58.000000', 'temperatura', 827.0000, 'ºC'),
	(250169, 120, '2014-03-15 00:21:59.000000', 'temperatura', 697.0000, 'ºC'),
	(250170, 120, '2014-03-15 00:22:00.000000', 'temperatura', 1005.0000, 'ºC'),
	(250171, 120, '2014-03-15 00:22:01.000000', 'temperatura', 533.0000, 'ºC'),
	(250172, 120, '2014-03-15 00:22:02.000000', 'temperatura', 852.0000, 'ºC'),
	(250173, 120, '2014-03-15 00:22:03.000000', 'temperatura', 261.0000, 'ºC'),
	(250174, 120, '2014-03-15 00:22:04.000000', 'temperatura', 1149.0000, 'ºC'),
	(250175, 120, '2014-03-15 00:22:05.000000', 'temperatura', 162.0000, 'ºC'),
	(250176, 120, '2014-03-15 00:22:06.000000', 'temperatura', 963.0000, 'ºC'),
	(250177, 120, '2014-03-15 00:22:07.000000', 'temperatura', 728.0000, 'ºC'),
	(250178, 120, '2014-03-15 00:22:08.000000', 'temperatura', 754.0000, 'ºC'),
	(250179, 120, '2014-03-15 00:22:09.000000', 'temperatura', 386.0000, 'ºC'),
	(250180, 120, '2014-03-15 00:22:10.000000', 'temperatura', 867.0000, 'ºC'),
	(250181, 120, '2014-03-15 00:22:11.000000', 'temperatura', 779.0000, 'ºC'),
	(250182, 120, '2014-03-15 00:22:12.000000', 'temperatura', 93.0000, 'ºC'),
	(250183, 120, '2014-03-15 00:22:13.000000', 'temperatura', 531.0000, 'ºC'),
	(250184, 120, '2014-03-15 00:22:14.000000', 'temperatura', 1177.0000, 'ºC'),
	(250185, 120, '2014-03-15 00:22:15.000000', 'temperatura', 691.0000, 'ºC'),
	(250186, 120, '2014-03-15 00:22:16.000000', 'temperatura', 1125.0000, 'ºC'),
	(250187, 120, '2014-03-15 00:22:17.000000', 'temperatura', 1154.0000, 'ºC'),
	(250188, 120, '2014-03-15 00:22:18.000000', 'temperatura', 1196.0000, 'ºC'),
	(250189, 120, '2014-03-15 00:22:19.000000', 'temperatura', 115.0000, 'ºC'),
	(250190, 120, '2014-03-15 00:22:20.000000', 'temperatura', 591.0000, 'ºC'),
	(250191, 120, '2014-03-15 00:22:21.000000', 'temperatura', 209.0000, 'ºC'),
	(250192, 120, '2014-03-15 00:22:22.000000', 'temperatura', 471.0000, 'ºC'),
	(250193, 120, '2014-03-15 00:22:23.000000', 'temperatura', 532.0000, 'ºC'),
	(250194, 120, '2014-03-15 00:22:24.000000', 'temperatura', 44.0000, 'ºC'),
	(250195, 120, '2014-03-15 00:22:25.000000', 'temperatura', 1026.0000, 'ºC'),
	(250196, 120, '2014-03-15 00:22:26.000000', 'temperatura', 198.0000, 'ºC'),
	(250197, 120, '2014-03-15 00:22:27.000000', 'temperatura', 313.0000, 'ºC'),
	(250198, 120, '2014-03-15 00:22:28.000000', 'temperatura', 971.0000, 'ºC'),
	(250199, 120, '2014-03-15 00:22:29.000000', 'temperatura', 317.0000, 'ºC'),
	(250200, 120, '2014-03-15 00:22:30.000000', 'temperatura', 1072.0000, 'ºC'),
	(250201, 120, '2014-03-15 00:22:31.000000', 'temperatura', 809.0000, 'ºC'),
	(250202, 120, '2014-03-15 00:22:32.000000', 'temperatura', 832.0000, 'ºC'),
	(250203, 120, '2014-03-15 00:22:33.000000', 'temperatura', 531.0000, 'ºC'),
	(250204, 120, '2014-03-15 00:22:34.000000', 'temperatura', 162.0000, 'ºC'),
	(250205, 120, '2014-03-15 00:22:35.000000', 'temperatura', 414.0000, 'ºC'),
	(250206, 120, '2014-03-15 00:22:36.000000', 'temperatura', 387.0000, 'ºC'),
	(250207, 120, '2014-03-15 00:22:37.000000', 'temperatura', 692.0000, 'ºC'),
	(250208, 120, '2014-03-15 00:22:38.000000', 'temperatura', 1101.0000, 'ºC'),
	(250209, 120, '2014-03-15 00:22:39.000000', 'temperatura', 1029.0000, 'ºC'),
	(250210, 120, '2014-03-15 00:22:40.000000', 'temperatura', 644.0000, 'ºC'),
	(250211, 120, '2014-03-15 00:22:41.000000', 'temperatura', 134.0000, 'ºC'),
	(250212, 120, '2014-03-15 00:22:42.000000', 'temperatura', 1138.0000, 'ºC'),
	(250213, 120, '2014-03-15 00:22:43.000000', 'temperatura', 487.0000, 'ºC'),
	(250214, 120, '2014-03-15 00:22:44.000000', 'temperatura', 222.0000, 'ºC'),
	(250215, 120, '2014-03-15 00:22:45.000000', 'temperatura', 848.0000, 'ºC'),
	(250216, 120, '2014-03-15 00:22:46.000000', 'temperatura', 1177.0000, 'ºC'),
	(250217, 120, '2014-03-15 00:22:47.000000', 'temperatura', 939.0000, 'ºC'),
	(250218, 120, '2014-03-15 00:22:48.000000', 'temperatura', 1167.0000, 'ºC'),
	(250219, 120, '2014-03-15 00:22:49.000000', 'temperatura', 616.0000, 'ºC'),
	(250220, 120, '2014-03-15 00:22:50.000000', 'temperatura', 778.0000, 'ºC'),
	(250221, 120, '2014-03-15 00:22:51.000000', 'temperatura', 846.0000, 'ºC'),
	(250222, 120, '2014-03-15 00:22:52.000000', 'temperatura', 696.0000, 'ºC'),
	(250223, 120, '2014-03-15 00:22:53.000000', 'temperatura', 944.0000, 'ºC'),
	(250224, 120, '2014-03-15 00:22:54.000000', 'temperatura', 231.0000, 'ºC'),
	(250225, 120, '2014-03-15 00:22:55.000000', 'temperatura', 725.0000, 'ºC'),
	(250226, 120, '2014-03-15 00:22:56.000000', 'temperatura', 533.0000, 'ºC'),
	(250227, 120, '2014-03-15 00:22:57.000000', 'temperatura', 489.0000, 'ºC'),
	(250228, 120, '2014-03-15 00:22:58.000000', 'temperatura', 849.0000, 'ºC'),
	(250229, 120, '2014-03-15 00:22:59.000000', 'temperatura', 376.0000, 'ºC'),
	(250230, 120, '2014-03-15 00:23:00.000000', 'temperatura', 536.0000, 'ºC'),
	(250231, 120, '2014-03-15 00:23:01.000000', 'temperatura', 349.0000, 'ºC'),
	(250232, 120, '2014-03-15 00:23:02.000000', 'temperatura', 141.0000, 'ºC'),
	(250233, 120, '2014-03-15 00:23:03.000000', 'temperatura', 856.0000, 'ºC'),
	(250234, 120, '2014-03-15 00:23:04.000000', 'temperatura', 260.0000, 'ºC'),
	(250235, 120, '2014-03-15 00:23:05.000000', 'temperatura', 1132.0000, 'ºC'),
	(250236, 120, '2014-03-15 00:23:06.000000', 'temperatura', 78.0000, 'ºC'),
	(250237, 120, '2014-03-15 00:23:07.000000', 'temperatura', 597.0000, 'ºC'),
	(250238, 120, '2014-03-15 00:23:08.000000', 'temperatura', 350.0000, 'ºC'),
	(250239, 120, '2014-03-15 00:23:09.000000', 'temperatura', 1160.0000, 'ºC'),
	(250240, 120, '2014-03-15 00:23:10.000000', 'temperatura', 1150.0000, 'ºC'),
	(250241, 120, '2014-03-15 00:23:11.000000', 'temperatura', 1070.0000, 'ºC'),
	(250242, 120, '2014-03-15 00:23:12.000000', 'temperatura', 703.0000, 'ºC'),
	(250243, 120, '2014-03-15 00:23:13.000000', 'temperatura', 305.0000, 'ºC'),
	(250244, 120, '2014-03-15 00:23:14.000000', 'temperatura', 614.0000, 'ºC'),
	(250245, 120, '2014-03-15 00:23:15.000000', 'temperatura', 958.0000, 'ºC'),
	(250246, 120, '2014-03-15 00:23:16.000000', 'temperatura', 548.0000, 'ºC'),
	(250247, 120, '2014-03-15 00:23:17.000000', 'temperatura', 1065.0000, 'ºC'),
	(250248, 120, '2014-03-15 00:23:18.000000', 'temperatura', 82.0000, 'ºC'),
	(250249, 120, '2014-03-15 00:23:19.000000', 'temperatura', 816.0000, 'ºC'),
	(250250, 120, '2014-03-15 00:23:20.000000', 'temperatura', 236.0000, 'ºC'),
	(250251, 120, '2014-03-15 00:23:21.000000', 'temperatura', 1133.0000, 'ºC'),
	(250252, 120, '2014-03-15 00:23:22.000000', 'temperatura', 155.0000, 'ºC'),
	(250253, 120, '2014-03-15 00:23:23.000000', 'temperatura', 979.0000, 'ºC'),
	(250254, 120, '2014-03-15 00:23:24.000000', 'temperatura', 831.0000, 'ºC'),
	(250255, 120, '2014-03-15 00:23:25.000000', 'temperatura', 19.0000, 'ºC'),
	(250256, 120, '2014-03-15 00:23:26.000000', 'temperatura', 1.0000, 'ºC'),
	(250257, 120, '2014-03-15 00:23:27.000000', 'temperatura', 1150.0000, 'ºC'),
	(250258, 120, '2014-03-15 00:23:28.000000', 'temperatura', 947.0000, 'ºC'),
	(250259, 120, '2014-03-15 00:23:29.000000', 'temperatura', 86.0000, 'ºC'),
	(250260, 120, '2014-03-15 00:23:30.000000', 'temperatura', 1190.0000, 'ºC'),
	(250261, 120, '2014-03-15 00:23:31.000000', 'temperatura', 890.0000, 'ºC'),
	(250262, 120, '2014-03-15 00:23:32.000000', 'temperatura', 882.0000, 'ºC'),
	(250263, 120, '2014-03-15 00:23:33.000000', 'temperatura', 539.0000, 'ºC'),
	(250264, 120, '2014-03-15 00:23:34.000000', 'temperatura', 49.0000, 'ºC'),
	(250265, 120, '2014-03-15 00:23:35.000000', 'temperatura', 1030.0000, 'ºC'),
	(250266, 120, '2014-03-15 00:23:36.000000', 'temperatura', 202.0000, 'ºC'),
	(250267, 120, '2014-03-15 00:23:37.000000', 'temperatura', 321.0000, 'ºC'),
	(250268, 120, '2014-03-15 00:23:38.000000', 'temperatura', 1001.0000, 'ºC'),
	(250269, 120, '2014-03-15 00:23:39.000000', 'temperatura', 442.0000, 'ºC'),
	(250270, 120, '2014-03-15 00:23:40.000000', 'temperatura', 408.0000, 'ºC'),
	(250271, 120, '2014-03-15 00:23:41.000000', 'temperatura', 712.0000, 'ºC'),
	(250272, 120, '2014-03-15 00:23:42.000000', 'temperatura', 1138.0000, 'ºC'),
	(250273, 120, '2014-03-15 00:23:43.000000', 'temperatura', 1153.0000, 'ºC'),
	(250274, 120, '2014-03-15 00:23:44.000000', 'temperatura', 1153.0000, 'ºC'),
	(250275, 120, '2014-03-15 00:23:45.000000', 'temperatura', 1107.0000, 'ºC'),
	(250276, 120, '2014-03-15 00:23:46.000000', 'temperatura', 874.0000, 'ºC'),
	(250277, 120, '2014-03-15 00:23:47.000000', 'temperatura', 1050.0000, 'ºC'),
	(250278, 120, '2014-03-15 00:23:48.000000', 'temperatura', 228.0000, 'ºC'),
	(250279, 120, '2014-03-15 00:23:49.000000', 'temperatura', 393.0000, 'ºC'),
	(250280, 120, '2014-03-15 00:23:50.000000', 'temperatura', 79.0000, 'ºC'),
	(250281, 120, '2014-03-15 00:23:51.000000', 'temperatura', 417.0000, 'ºC'),
	(250282, 120, '2014-03-15 00:23:52.000000', 'temperatura', 647.0000, 'ºC'),
	(250283, 120, '2014-03-15 00:23:53.000000', 'temperatura', 786.0000, 'ºC'),
	(250284, 120, '2014-03-15 00:23:54.000000', 'temperatura', 791.0000, 'ºC'),
	(250285, 120, '2014-03-15 00:23:55.000000', 'temperatura', 397.0000, 'ºC'),
	(250286, 120, '2014-03-15 00:23:56.000000', 'temperatura', 811.0000, 'ºC'),
	(250287, 120, '2014-03-15 00:23:57.000000', 'temperatura', 466.0000, 'ºC'),
	(250288, 120, '2014-03-15 00:23:58.000000', 'temperatura', 1097.0000, 'ºC'),
	(250289, 120, '2014-03-15 00:23:59.000000', 'temperatura', 488.0000, 'ºC'),
	(250290, 120, '2014-03-15 00:24:00.000000', 'temperatura', 351.0000, 'ºC'),
	(250291, 120, '2014-03-15 00:24:01.000000', 'temperatura', 288.0000, 'ºC'),
	(250292, 120, '2014-03-15 00:24:02.000000', 'temperatura', 391.0000, 'ºC'),
	(250293, 120, '2014-03-15 00:24:03.000000', 'temperatura', 1090.0000, 'ºC'),
	(250294, 120, '2014-03-15 00:24:04.000000', 'temperatura', 679.0000, 'ºC'),
	(250295, 120, '2014-03-15 00:24:05.000000', 'temperatura', 124.0000, 'ºC'),
	(250296, 120, '2014-03-15 00:24:06.000000', 'temperatura', 983.0000, 'ºC'),
	(250297, 120, '2014-03-15 00:24:07.000000', 'temperatura', 943.0000, 'ºC'),
	(250298, 120, '2014-03-15 00:24:08.000000', 'temperatura', 568.0000, 'ºC'),
	(250299, 120, '2014-03-15 00:24:09.000000', 'temperatura', 12.0000, 'ºC'),
	(250300, 120, '2014-03-15 00:24:10.000000', 'temperatura', 756.0000, 'ºC'),
	(250301, 120, '2014-03-15 00:24:11.000000', 'temperatura', 142.0000, 'ºC'),
	(250302, 120, '2014-03-15 00:24:12.000000', 'temperatura', 845.0000, 'ºC'),
	(250303, 120, '2014-03-15 00:24:13.000000', 'temperatura', 200.0000, 'ºC'),
	(250304, 120, '2014-03-15 00:24:14.000000', 'temperatura', 865.0000, 'ºC'),
	(250305, 120, '2014-03-15 00:24:15.000000', 'temperatura', 125.0000, 'ºC'),
	(250306, 120, '2014-03-15 00:24:16.000000', 'temperatura', 433.0000, 'ºC'),
	(250307, 120, '2014-03-15 00:24:17.000000', 'temperatura', 587.0000, 'ºC'),
	(250308, 120, '2014-03-15 00:24:18.000000', 'temperatura', 439.0000, 'ºC'),
	(250309, 120, '2014-03-15 00:24:19.000000', 'temperatura', 433.0000, 'ºC'),
	(250310, 120, '2014-03-15 00:24:20.000000', 'temperatura', 848.0000, 'ºC'),
	(250311, 120, '2014-03-15 00:24:21.000000', 'temperatura', 542.0000, 'ºC'),
	(250312, 120, '2014-03-15 00:24:22.000000', 'temperatura', 168.0000, 'ºC'),
	(250313, 120, '2014-03-15 00:24:23.000000', 'temperatura', 414.0000, 'ºC'),
	(250314, 120, '2014-03-15 00:24:24.000000', 'temperatura', 367.0000, 'ºC'),
	(250315, 120, '2014-03-15 00:24:25.000000', 'temperatura', 592.0000, 'ºC'),
	(250316, 120, '2014-03-15 00:24:26.000000', 'temperatura', 659.0000, 'ºC'),
	(250317, 120, '2014-03-15 00:24:27.000000', 'temperatura', 321.0000, 'ºC'),
	(250318, 120, '2014-03-15 00:24:28.000000', 'temperatura', 830.0000, 'ºC'),
	(250319, 120, '2014-03-15 00:24:29.000000', 'temperatura', 785.0000, 'ºC'),
	(250320, 120, '2014-03-15 00:24:30.000000', 'temperatura', 238.0000, 'ºC'),
	(250321, 120, '2014-03-15 00:24:31.000000', 'temperatura', 35.0000, 'ºC'),
	(250322, 120, '2014-03-15 00:24:32.000000', 'temperatura', 663.0000, 'ºC'),
	(250323, 120, '2014-03-15 00:24:33.000000', 'temperatura', 809.0000, 'ºC'),
	(250324, 120, '2014-03-15 00:24:34.000000', 'temperatura', 855.0000, 'ºC'),
	(250325, 120, '2014-03-15 00:24:35.000000', 'temperatura', 648.0000, 'ºC'),
	(250326, 120, '2014-03-15 00:24:36.000000', 'temperatura', 677.0000, 'ºC'),
	(250327, 120, '2014-03-15 00:24:37.000000', 'temperatura', 241.0000, 'ºC'),
	(250328, 120, '2014-03-15 00:24:38.000000', 'temperatura', 377.0000, 'ºC'),
	(250329, 120, '2014-03-15 00:24:39.000000', 'temperatura', 1160.0000, 'ºC'),
	(250330, 120, '2014-03-15 00:24:40.000000', 'temperatura', 1068.0000, 'ºC'),
	(250331, 120, '2014-03-15 00:24:41.000000', 'temperatura', 664.0000, 'ºC'),
	(250332, 120, '2014-03-15 00:24:42.000000', 'temperatura', 113.0000, 'ºC'),
	(250333, 120, '2014-03-15 00:24:43.000000', 'temperatura', 975.0000, 'ºC'),
	(250334, 120, '2014-03-15 00:24:44.000000', 'temperatura', 937.0000, 'ºC'),
	(250335, 120, '2014-03-15 00:24:45.000000', 'temperatura', 560.0000, 'ºC'),
	(250336, 120, '2014-03-15 00:24:46.000000', 'temperatura', 1191.0000, 'ºC'),
	(250337, 120, '2014-03-15 00:24:47.000000', 'temperatura', 675.0000, 'ºC'),
	(250338, 120, '2014-03-15 00:24:48.000000', 'temperatura', 1004.0000, 'ºC'),
	(250339, 120, '2014-03-15 00:24:49.000000', 'temperatura', 594.0000, 'ºC'),
	(250340, 120, '2014-03-15 00:24:50.000000', 'temperatura', 1158.0000, 'ºC'),
	(250341, 120, '2014-03-15 00:24:51.000000', 'temperatura', 410.0000, 'ºC'),
	(250342, 120, '2014-03-15 00:24:52.000000', 'temperatura', 975.0000, 'ºC'),
	(250343, 120, '2014-03-15 00:24:53.000000', 'temperatura', 46.0000, 'ºC'),
	(250344, 120, '2014-03-15 00:24:54.000000', 'temperatura', 905.0000, 'ºC'),
	(250345, 120, '2014-03-15 00:24:55.000000', 'temperatura', 789.0000, 'ºC'),
	(250346, 120, '2014-03-15 00:24:56.000000', 'temperatura', 28.0000, 'ºC'),
	(250347, 120, '2014-03-15 00:24:57.000000', 'temperatura', 174.0000, 'ºC'),
	(250348, 120, '2014-03-15 00:24:58.000000', 'temperatura', 789.0000, 'ºC'),
	(250349, 120, '2014-03-15 00:24:59.000000', 'temperatura', 1023.0000, 'ºC'),
	(250350, 120, '2014-03-15 00:25:00.000000', 'temperatura', 346.0000, 'ºC'),
	(250351, 120, '2014-03-15 00:25:01.000000', 'temperatura', 1064.0000, 'ºC'),
	(250352, 120, '2014-03-15 00:25:02.000000', 'temperatura', 681.0000, 'ºC'),
	(250353, 120, '2014-03-15 00:25:03.000000', 'temperatura', 212.0000, 'ºC'),
	(250354, 120, '2014-03-15 00:25:04.000000', 'temperatura', 220.0000, 'ºC'),
	(250355, 120, '2014-03-15 00:25:05.000000', 'temperatura', 464.0000, 'ºC'),
	(250356, 120, '2014-03-15 00:25:06.000000', 'temperatura', 461.0000, 'ºC'),
	(250357, 120, '2014-03-15 00:25:07.000000', 'temperatura', 914.0000, 'ºC'),
	(250358, 120, '2014-03-15 00:25:08.000000', 'temperatura', 786.0000, 'ºC'),
	(250359, 120, '2014-03-15 00:25:09.000000', 'temperatura', 1189.0000, 'ºC'),
	(250360, 120, '2014-03-15 00:25:10.000000', 'temperatura', 1187.0000, 'ºC'),
	(250361, 120, '2014-03-15 00:25:11.000000', 'temperatura', 1169.0000, 'ºC'),
	(250362, 120, '2014-03-15 00:25:12.000000', 'temperatura', 1082.0000, 'ºC'),
	(250363, 120, '2014-03-15 00:25:13.000000', 'temperatura', 707.0000, 'ºC'),
	(250364, 120, '2014-03-15 00:25:14.000000', 'temperatura', 287.0000, 'ºC'),
	(250365, 120, '2014-03-15 00:25:15.000000', 'temperatura', 514.0000, 'ºC'),
	(250366, 120, '2014-03-15 00:25:16.000000', 'temperatura', 509.0000, 'ºC'),
	(250367, 120, '2014-03-15 00:25:17.000000', 'temperatura', 1005.0000, 'ºC'),
	(250368, 120, '2014-03-15 00:25:18.000000', 'temperatura', 1100.0000, 'ºC'),
	(250369, 120, '2014-03-15 00:25:19.000000', 'temperatura', 82.0000, 'ºC'),
	(250370, 120, '2014-03-15 00:25:20.000000', 'temperatura', 714.0000, 'ºC'),
	(250371, 120, '2014-03-15 00:25:21.000000', 'temperatura', 924.0000, 'ºC'),
	(250372, 120, '2014-03-15 00:25:22.000000', 'temperatura', 76.0000, 'ºC'),
	(250373, 120, '2014-03-15 00:25:23.000000', 'temperatura', 10.0000, 'ºC'),
	(250374, 120, '2014-03-15 00:25:24.000000', 'temperatura', 1021.0000, 'ºC'),
	(250375, 120, '2014-03-15 00:25:25.000000', 'temperatura', 275.0000, 'ºC'),
	(250376, 120, '2014-03-15 00:25:26.000000', 'temperatura', 716.0000, 'ºC'),
	(250377, 120, '2014-03-15 00:25:27.000000', 'temperatura', 352.0000, 'ºC'),
	(250378, 120, '2014-03-15 00:25:28.000000', 'temperatura', 814.0000, 'ºC'),
	(250379, 120, '2014-03-15 00:25:29.000000', 'temperatura', 612.0000, 'ºC'),
	(250380, 120, '2014-03-15 00:25:30.000000', 'temperatura', 621.0000, 'ºC'),
	(250381, 120, '2014-03-15 00:25:31.000000', 'temperatura', 69.0000, 'ºC'),
	(250382, 120, '2014-03-15 00:25:32.000000', 'temperatura', 881.0000, 'ºC'),
	(250383, 120, '2014-03-15 00:25:33.000000', 'temperatura', 601.0000, 'ºC'),
	(250384, 120, '2014-03-15 00:25:34.000000', 'temperatura', 363.0000, 'ºC'),
	(250385, 120, '2014-03-15 00:25:35.000000', 'temperatura', 11.0000, 'ºC'),
	(250386, 120, '2014-03-15 00:25:36.000000', 'temperatura', 166.0000, 'ºC'),
	(250387, 120, '2014-03-15 00:25:37.000000', 'temperatura', 798.0000, 'ºC'),
	(250388, 120, '2014-03-15 00:25:38.000000', 'temperatura', 1093.0000, 'ºC'),
	(250389, 120, '2014-03-15 00:25:39.000000', 'temperatura', 672.0000, 'ºC'),
	(250390, 120, '2014-03-15 00:25:40.000000', 'temperatura', 82.0000, 'ºC'),
	(250391, 120, '2014-03-15 00:25:41.000000', 'temperatura', 793.0000, 'ºC'),
	(250392, 120, '2014-03-15 00:25:42.000000', 'temperatura', 120.0000, 'ºC'),
	(250393, 120, '2014-03-15 00:25:43.000000', 'temperatura', 622.0000, 'ºC'),
	(250394, 120, '2014-03-15 00:25:44.000000', 'temperatura', 349.0000, 'ºC'),
	(250395, 120, '2014-03-15 00:25:45.000000', 'temperatura', 1082.0000, 'ºC'),
	(250396, 120, '2014-03-15 00:25:46.000000', 'temperatura', 761.0000, 'ºC'),
	(250397, 120, '2014-03-15 00:25:47.000000', 'temperatura', 558.0000, 'ºC'),
	(250398, 120, '2014-03-15 00:25:48.000000', 'temperatura', 511.0000, 'ºC'),
	(250399, 120, '2014-03-15 00:25:49.000000', 'temperatura', 881.0000, 'ºC'),
	(250400, 120, '2014-03-15 00:25:50.000000', 'temperatura', 470.0000, 'ºC'),
	(250401, 120, '2014-03-15 00:25:51.000000', 'temperatura', 909.0000, 'ºC'),
	(250402, 120, '2014-03-15 00:25:52.000000', 'temperatura', 736.0000, 'ºC'),
	(250403, 120, '2014-03-15 00:25:53.000000', 'temperatura', 951.0000, 'ºC'),
	(250404, 120, '2014-03-15 00:25:54.000000', 'temperatura', 150.0000, 'ºC'),
	(250405, 120, '2014-03-15 00:25:55.000000', 'temperatura', 296.0000, 'ºC'),
	(250406, 120, '2014-03-15 00:25:56.000000', 'temperatura', 1029.0000, 'ºC'),
	(250407, 120, '2014-03-15 00:25:57.000000', 'temperatura', 660.0000, 'ºC'),
	(250408, 120, '2014-03-15 00:25:58.000000', 'temperatura', 211.0000, 'ºC'),
	(250409, 120, '2014-03-15 00:25:59.000000', 'temperatura', 278.0000, 'ºC'),
	(250410, 120, '2014-03-15 00:26:00.000000', 'temperatura', 755.0000, 'ºC'),
	(250411, 120, '2014-03-15 00:26:01.000000', 'temperatura', 544.0000, 'ºC'),
	(250412, 120, '2014-03-15 00:26:02.000000', 'temperatura', 453.0000, 'ºC'),
	(250413, 120, '2014-03-15 00:26:03.000000', 'temperatura', 636.0000, 'ºC'),
	(250414, 120, '2014-03-15 00:26:04.000000', 'temperatura', 619.0000, 'ºC'),
	(250415, 120, '2014-03-15 00:26:05.000000', 'temperatura', 1189.0000, 'ºC'),
	(250416, 120, '2014-03-15 00:26:06.000000', 'temperatura', 488.0000, 'ºC'),
	(250417, 120, '2014-03-15 00:26:07.000000', 'temperatura', 75.0000, 'ºC'),
	(250418, 120, '2014-03-15 00:26:08.000000', 'temperatura', 109.0000, 'ºC'),
	(250419, 120, '2014-03-15 00:26:09.000000', 'temperatura', 322.0000, 'ºC'),
	(250420, 120, '2014-03-15 00:26:10.000000', 'temperatura', 83.0000, 'ºC'),
	(250421, 120, '2014-03-15 00:26:11.000000', 'temperatura', 649.0000, 'ºC'),
	(250422, 120, '2014-03-15 00:26:12.000000', 'temperatura', 599.0000, 'ºC'),
	(250423, 120, '2014-03-15 00:26:13.000000', 'temperatura', 1046.0000, 'ºC'),
	(250424, 120, '2014-03-15 00:26:14.000000', 'temperatura', 1032.0000, 'ºC'),
	(250425, 120, '2014-03-15 00:26:15.000000', 'temperatura', 826.0000, 'ºC'),
	(250426, 120, '2014-03-15 00:26:16.000000', 'temperatura', 1031.0000, 'ºC'),
	(250427, 120, '2014-03-15 00:26:17.000000', 'temperatura', 280.0000, 'ºC'),
	(250428, 120, '2014-03-15 00:26:18.000000', 'temperatura', 708.0000, 'ºC'),
	(250429, 120, '2014-03-15 00:26:19.000000', 'temperatura', 298.0000, 'ºC'),
	(250430, 120, '2014-03-15 00:26:20.000000', 'temperatura', 566.0000, 'ºC'),
	(250431, 120, '2014-03-15 00:26:21.000000', 'temperatura', 737.0000, 'ºC'),
	(250432, 120, '2014-03-15 00:26:22.000000', 'temperatura', 789.0000, 'ºC'),
	(250433, 120, '2014-03-15 00:26:23.000000', 'temperatura', 532.0000, 'ºC'),
	(250434, 120, '2014-03-15 00:26:24.000000', 'temperatura', 297.0000, 'ºC'),
	(250435, 120, '2014-03-15 00:26:25.000000', 'temperatura', 1086.0000, 'ºC'),
	(250436, 120, '2014-03-15 00:26:26.000000', 'temperatura', 942.0000, 'ºC'),
	(250437, 120, '2014-03-15 00:26:27.000000', 'temperatura', 252.0000, 'ºC'),
	(250438, 120, '2014-03-15 00:26:28.000000', 'temperatura', 832.0000, 'ºC'),
	(250439, 120, '2014-03-15 00:26:29.000000', 'temperatura', 1007.0000, 'ºC'),
	(250440, 120, '2014-03-15 00:26:30.000000', 'temperatura', 138.0000, 'ºC'),
	(250441, 120, '2014-03-15 00:26:31.000000', 'temperatura', 68.0000, 'ºC'),
	(250442, 120, '2014-03-15 00:26:32.000000', 'temperatura', 1130.0000, 'ºC'),
	(250443, 120, '2014-03-15 00:26:33.000000', 'temperatura', 645.0000, 'ºC'),
	(250444, 120, '2014-03-15 00:26:34.000000', 'temperatura', 1037.0000, 'ºC'),
	(250445, 120, '2014-03-15 00:26:35.000000', 'temperatura', 848.0000, 'ºC'),
	(250446, 120, '2014-03-15 00:26:36.000000', 'temperatura', 1131.0000, 'ºC'),
	(250447, 120, '2014-03-15 00:26:37.000000', 'temperatura', 709.0000, 'ºC'),
	(250448, 120, '2014-03-15 00:26:38.000000', 'temperatura', 155.0000, 'ºC'),
	(250449, 120, '2014-03-15 00:26:39.000000', 'temperatura', 1046.0000, 'ºC'),
	(250450, 120, '2014-03-15 00:26:40.000000', 'temperatura', 1167.0000, 'ºC'),
	(250451, 120, '2014-03-15 00:26:41.000000', 'temperatura', 298.0000, 'ºC'),
	(250452, 120, '2014-03-15 00:26:42.000000', 'temperatura', 390.0000, 'ºC'),
	(250453, 120, '2014-03-15 00:26:43.000000', 'temperatura', 1055.0000, 'ºC'),
	(250454, 120, '2014-03-15 00:26:44.000000', 'temperatura', 507.0000, 'ºC'),
	(250455, 120, '2014-03-15 00:26:45.000000', 'temperatura', 568.0000, 'ºC'),
	(250456, 120, '2014-03-15 00:26:46.000000', 'temperatura', 121.0000, 'ºC'),
	(250457, 120, '2014-03-15 00:26:47.000000', 'temperatura', 102.0000, 'ºC'),
	(250458, 120, '2014-03-15 00:26:48.000000', 'temperatura', 147.0000, 'ºC'),
	(250459, 120, '2014-03-15 00:26:49.000000', 'temperatura', 429.0000, 'ºC'),
	(250460, 120, '2014-03-15 00:26:50.000000', 'temperatura', 505.0000, 'ºC'),
	(250461, 120, '2014-03-15 00:26:51.000000', 'temperatura', 39.0000, 'ºC'),
	(250462, 120, '2014-03-15 00:26:52.000000', 'temperatura', 1079.0000, 'ºC'),
	(250463, 120, '2014-03-15 00:26:53.000000', 'temperatura', 478.0000, 'ºC'),
	(250464, 120, '2014-03-15 00:26:54.000000', 'temperatura', 353.0000, 'ºC'),
	(250465, 120, '2014-03-15 00:26:55.000000', 'temperatura', 333.0000, 'ºC'),
	(250466, 120, '2014-03-15 00:26:56.000000', 'temperatura', 608.0000, 'ºC'),
	(250467, 120, '2014-03-15 00:26:57.000000', 'temperatura', 838.0000, 'ºC'),
	(250468, 120, '2014-03-15 00:26:58.000000', 'temperatura', 1169.0000, 'ºC'),
	(250469, 120, '2014-03-15 00:26:59.000000', 'temperatura', 933.0000, 'ºC'),
	(250470, 120, '2014-03-15 00:27:00.000000', 'temperatura', 1157.0000, 'ºC'),
	(250471, 120, '2014-03-15 00:27:01.000000', 'temperatura', 585.0000, 'ºC'),
	(250472, 120, '2014-03-15 00:27:02.000000', 'temperatura', 654.0000, 'ºC'),
	(250473, 120, '2014-03-15 00:27:03.000000', 'temperatura', 315.0000, 'ºC'),
	(250474, 120, '2014-03-15 00:27:04.000000', 'temperatura', 815.0000, 'ºC'),
	(250475, 120, '2014-03-15 00:27:05.000000', 'temperatura', 728.0000, 'ºC'),
	(250476, 120, '2014-03-15 00:27:06.000000', 'temperatura', 1199.0000, 'ºC'),
	(250477, 120, '2014-03-15 00:27:07.000000', 'temperatura', 210.0000, 'ºC'),
	(250478, 120, '2014-03-15 00:27:08.000000', 'temperatura', 1054.0000, 'ºC'),
	(250479, 120, '2014-03-15 00:27:09.000000', 'temperatura', 1040.0000, 'ºC'),
	(250480, 120, '2014-03-15 00:27:10.000000', 'temperatura', 840.0000, 'ºC'),
	(250481, 120, '2014-03-15 00:27:11.000000', 'temperatura', 1082.0000, 'ºC'),
	(250482, 120, '2014-03-15 00:27:12.000000', 'temperatura', 487.0000, 'ºC'),
	(250483, 120, '2014-03-15 00:27:13.000000', 'temperatura', 390.0000, 'ºC'),
	(250484, 120, '2014-03-15 00:27:14.000000', 'temperatura', 490.0000, 'ºC'),
	(250485, 120, '2014-03-15 00:27:15.000000', 'temperatura', 81.0000, 'ºC'),
	(250486, 120, '2014-03-15 00:27:16.000000', 'temperatura', 134.0000, 'ºC'),
	(250487, 120, '2014-03-15 00:27:17.000000', 'temperatura', 428.0000, 'ºC'),
	(250488, 120, '2014-03-15 00:27:18.000000', 'temperatura', 537.0000, 'ºC'),
	(250489, 120, '2014-03-15 00:27:19.000000', 'temperatura', 204.0000, 'ºC'),
	(250490, 120, '2014-03-15 00:27:20.000000', 'temperatura', 610.0000, 'ºC'),
	(250491, 120, '2014-03-15 00:27:21.000000', 'temperatura', 37.0000, 'ºC'),
	(250492, 120, '2014-03-15 00:27:22.000000', 'temperatura', 755.0000, 'ºC'),
	(250493, 120, '2014-03-15 00:27:23.000000', 'temperatura', 67.0000, 'ºC'),
	(250494, 120, '2014-03-15 00:27:24.000000', 'temperatura', 469.0000, 'ºC'),
	(250495, 120, '2014-03-15 00:27:25.000000', 'temperatura', 946.0000, 'ºC'),
	(250496, 120, '2014-03-15 00:27:26.000000', 'temperatura', 921.0000, 'ºC'),
	(250497, 120, '2014-03-15 00:27:27.000000', 'temperatura', 570.0000, 'ºC'),
	(250498, 120, '2014-03-15 00:27:28.000000', 'temperatura', 87.0000, 'ºC'),
	(250499, 120, '2014-03-15 00:27:29.000000', 'temperatura', 1125.0000, 'ºC'),
	(250500, 120, '2014-03-15 00:27:30.000000', 'temperatura', 564.0000, 'ºC'),
	(250501, 120, '2014-03-15 00:27:31.000000', 'temperatura', 647.0000, 'ºC'),
	(250502, 120, '2014-03-15 00:27:32.000000', 'temperatura', 343.0000, 'ºC'),
	(250503, 120, '2014-03-15 00:27:33.000000', 'temperatura', 973.0000, 'ºC'),
	(250504, 120, '2014-03-15 00:27:34.000000', 'temperatura', 236.0000, 'ºC'),
	(250505, 120, '2014-03-15 00:27:35.000000', 'temperatura', 661.0000, 'ºC'),
	(250506, 120, '2014-03-15 00:27:36.000000', 'temperatura', 200.0000, 'ºC'),
	(250507, 120, '2014-03-15 00:27:37.000000', 'temperatura', 215.0000, 'ºC'),
	(250508, 120, '2014-03-15 00:27:38.000000', 'temperatura', 476.0000, 'ºC'),
	(250509, 120, '2014-03-15 00:27:39.000000', 'temperatura', 535.0000, 'ºC'),
	(250510, 120, '2014-03-15 00:27:40.000000', 'temperatura', 50.0000, 'ºC'),
	(250511, 120, '2014-03-15 00:27:41.000000', 'temperatura', 1044.0000, 'ºC'),
	(250512, 120, '2014-03-15 00:27:42.000000', 'temperatura', 270.0000, 'ºC'),
	(250513, 120, '2014-03-15 00:27:43.000000', 'temperatura', 619.0000, 'ºC'),
	(250514, 120, '2014-03-15 00:27:44.000000', 'temperatura', 1084.0000, 'ºC'),
	(250515, 120, '2014-03-15 00:27:45.000000', 'temperatura', 1162.0000, 'ºC'),
	(250516, 120, '2014-03-15 00:27:46.000000', 'temperatura', 162.0000, 'ºC'),
	(250517, 120, '2014-03-15 00:27:47.000000', 'temperatura', 924.0000, 'ºC'),
	(250518, 120, '2014-03-15 00:27:48.000000', 'temperatura', 535.0000, 'ºC'),
	(250519, 120, '2014-03-15 00:27:49.000000', 'temperatura', 1103.0000, 'ºC'),
	(250520, 120, '2014-03-15 00:27:50.000000', 'temperatura', 309.0000, 'ºC'),
	(250521, 120, '2014-03-15 00:27:51.000000', 'temperatura', 638.0000, 'ºC'),
	(250522, 120, '2014-03-15 00:27:52.000000', 'temperatura', 1065.0000, 'ºC'),
	(250523, 120, '2014-03-15 00:27:53.000000', 'temperatura', 1009.0000, 'ºC'),
	(250524, 120, '2014-03-15 00:27:54.000000', 'temperatura', 649.0000, 'ºC'),
	(250525, 120, '2014-03-15 00:27:55.000000', 'temperatura', 221.0000, 'ºC'),
	(250526, 120, '2014-03-15 00:27:56.000000', 'temperatura', 358.0000, 'ºC'),
	(250527, 120, '2014-03-15 00:27:57.000000', 'temperatura', 1129.0000, 'ºC'),
	(250528, 120, '2014-03-15 00:27:58.000000', 'temperatura', 972.0000, 'ºC'),
	(250529, 120, '2014-03-15 00:27:59.000000', 'temperatura', 271.0000, 'ºC'),
	(250530, 120, '2014-03-15 00:28:00.000000', 'temperatura', 838.0000, 'ºC'),
	(250531, 120, '2014-03-15 00:28:01.000000', 'temperatura', 981.0000, 'ºC'),
	(250532, 120, '2014-03-15 00:28:02.000000', 'temperatura', 1188.0000, 'ºC'),
	(250533, 120, '2014-03-15 00:28:03.000000', 'temperatura', 601.0000, 'ºC'),
	(250534, 120, '2014-03-15 00:28:04.000000', 'temperatura', 641.0000, 'ºC'),
	(250535, 120, '2014-03-15 00:28:05.000000', 'temperatura', 202.0000, 'ºC'),
	(250536, 120, '2014-03-15 00:28:06.000000', 'temperatura', 287.0000, 'ºC'),
	(250537, 120, '2014-03-15 00:28:07.000000', 'temperatura', 829.0000, 'ºC'),
	(250538, 120, '2014-03-15 00:28:08.000000', 'temperatura', 886.0000, 'ºC'),
	(250539, 120, '2014-03-15 00:28:09.000000', 'temperatura', 741.0000, 'ºC'),
	(250540, 120, '2014-03-15 00:28:10.000000', 'temperatura', 1050.0000, 'ºC'),
	(250541, 120, '2014-03-15 00:28:11.000000', 'temperatura', 625.0000, 'ºC'),
	(250542, 120, '2014-03-15 00:28:12.000000', 'temperatura', 1178.0000, 'ºC'),
	(250543, 120, '2014-03-15 00:28:13.000000', 'temperatura', 413.0000, 'ºC'),
	(250544, 120, '2014-03-15 00:28:14.000000', 'temperatura', 935.0000, 'ºC'),
	(250545, 120, '2014-03-15 00:28:15.000000', 'temperatura', 1033.0000, 'ºC'),
	(250546, 120, '2014-03-15 00:28:16.000000', 'temperatura', 1162.0000, 'ºC'),
	(250547, 120, '2014-03-15 00:28:17.000000', 'temperatura', 310.0000, 'ºC'),
	(250548, 120, '2014-03-15 00:28:18.000000', 'temperatura', 467.0000, 'ºC'),
	(250549, 120, '2014-03-15 00:28:19.000000', 'temperatura', 203.0000, 'ºC'),
	(250550, 120, '2014-03-15 00:28:20.000000', 'temperatura', 817.0000, 'ºC'),
	(250551, 120, '2014-03-15 00:28:21.000000', 'temperatura', 1076.0000, 'ºC'),
	(250552, 120, '2014-03-15 00:28:22.000000', 'temperatura', 531.0000, 'ºC'),
	(250553, 120, '2014-03-15 00:28:23.000000', 'temperatura', 625.0000, 'ºC'),
	(250554, 120, '2014-03-15 00:28:24.000000', 'temperatura', 334.0000, 'ºC'),
	(250555, 120, '2014-03-15 00:28:25.000000', 'temperatura', 997.0000, 'ºC'),
	(250556, 120, '2014-03-15 00:28:26.000000', 'temperatura', 380.0000, 'ºC'),
	(250557, 120, '2014-03-15 00:28:27.000000', 'temperatura', 111.0000, 'ºC'),
	(250558, 120, '2014-03-15 00:28:28.000000', 'temperatura', 615.0000, 'ºC'),
	(250559, 120, '2014-03-15 00:28:29.000000', 'temperatura', 344.0000, 'ºC'),
	(250560, 120, '2014-03-15 00:28:30.000000', 'temperatura', 1073.0000, 'ºC'),
	(250561, 120, '2014-03-15 00:28:31.000000', 'temperatura', 733.0000, 'ºC'),
	(250562, 120, '2014-03-15 00:28:32.000000', 'temperatura', 447.0000, 'ºC'),
	(250563, 120, '2014-03-15 00:28:33.000000', 'temperatura', 35.0000, 'ºC'),
	(250564, 120, '2014-03-15 00:28:34.000000', 'temperatura', 38.0000, 'ºC'),
	(250565, 120, '2014-03-15 00:28:35.000000', 'temperatura', 83.0000, 'ºC'),
	(250566, 120, '2014-03-15 00:28:36.000000', 'temperatura', 301.0000, 'ºC'),
	(250567, 120, '2014-03-15 00:28:37.000000', 'temperatura', 57.0000, 'ºC'),
	(250568, 120, '2014-03-15 00:28:38.000000', 'temperatura', 583.0000, 'ºC'),
	(250569, 120, '2014-03-15 00:28:39.000000', 'temperatura', 343.0000, 'ºC'),
	(250570, 120, '2014-03-15 00:28:40.000000', 'temperatura', 1167.0000, 'ºC'),
	(250571, 120, '2014-03-15 00:28:41.000000', 'temperatura', 7.0000, 'ºC'),
	(250572, 120, '2014-03-15 00:28:42.000000', 'temperatura', 135.0000, 'ºC'),
	(250573, 120, '2014-03-15 00:28:43.000000', 'temperatura', 654.0000, 'ºC'),
	(250574, 120, '2014-03-15 00:28:44.000000', 'temperatura', 466.0000, 'ºC'),
	(250575, 120, '2014-03-15 00:28:45.000000', 'temperatura', 366.0000, 'ºC'),
	(250576, 120, '2014-03-15 00:28:46.000000', 'temperatura', 436.0000, 'ºC'),
	(250577, 120, '2014-03-15 00:28:47.000000', 'temperatura', 1081.0000, 'ºC'),
	(250578, 120, '2014-03-15 00:28:48.000000', 'temperatura', 498.0000, 'ºC'),
	(250579, 120, '2014-03-15 00:28:49.000000', 'temperatura', 446.0000, 'ºC'),
	(250580, 120, '2014-03-15 00:28:50.000000', 'temperatura', 738.0000, 'ºC'),
	(250581, 120, '2014-03-15 00:28:51.000000', 'temperatura', 1152.0000, 'ºC'),
	(250582, 120, '2014-03-15 00:28:52.000000', 'temperatura', 1146.0000, 'ºC'),
	(250583, 120, '2014-03-15 00:28:53.000000', 'temperatura', 1075.0000, 'ºC'),
	(250584, 120, '2014-03-15 00:28:54.000000', 'temperatura', 737.0000, 'ºC'),
	(250585, 120, '2014-03-15 00:28:55.000000', 'temperatura', 461.0000, 'ºC'),
	(250586, 120, '2014-03-15 00:28:56.000000', 'temperatura', 95.0000, 'ºC'),
	(250587, 120, '2014-03-15 00:28:57.000000', 'temperatura', 294.0000, 'ºC'),
	(250588, 120, '2014-03-15 00:28:58.000000', 'temperatura', 1185.0000, 'ºC'),
	(250589, 120, '2014-03-15 00:28:59.000000', 'temperatura', 241.0000, 'ºC'),
	(250590, 120, '2014-03-15 00:29:00.000000', 'temperatura', 52.0000, 'ºC'),
	(250591, 120, '2014-03-15 00:29:01.000000', 'temperatura', 736.0000, 'ºC'),
	(250592, 120, '2014-03-15 00:29:02.000000', 'temperatura', 1124.0000, 'ºC'),
	(250593, 120, '2014-03-15 00:29:03.000000', 'temperatura', 1015.0000, 'ºC'),
	(250594, 120, '2014-03-15 00:29:04.000000', 'temperatura', 501.0000, 'ºC'),
	(250595, 120, '2014-03-15 00:29:05.000000', 'temperatura', 662.0000, 'ºC'),
	(250596, 120, '2014-03-15 00:29:06.000000', 'temperatura', 606.0000, 'ºC'),
	(250597, 120, '2014-03-15 00:29:07.000000', 'temperatura', 1046.0000, 'ºC'),
	(250598, 120, '2014-03-15 00:29:08.000000', 'temperatura', 1014.0000, 'ºC'),
	(250599, 120, '2014-03-15 00:29:09.000000', 'temperatura', 732.0000, 'ºC'),
	(250600, 120, '2014-03-15 00:29:10.000000', 'temperatura', 616.0000, 'ºC'),
	(250601, 120, '2014-03-15 00:29:11.000000', 'temperatura', 887.0000, 'ºC'),
	(250602, 120, '2014-03-15 00:29:12.000000', 'temperatura', 188.0000, 'ºC'),
	(250603, 120, '2014-03-15 00:29:13.000000', 'temperatura', 677.0000, 'ºC'),
	(250604, 120, '2014-03-15 00:29:14.000000', 'temperatura', 424.0000, 'ºC'),
	(250605, 120, '2014-03-15 00:29:15.000000', 'temperatura', 89.0000, 'ºC'),
	(250606, 120, '2014-03-15 00:29:16.000000', 'temperatura', 374.0000, 'ºC'),
	(250607, 120, '2014-03-15 00:29:17.000000', 'temperatura', 401.0000, 'ºC'),
	(250608, 120, '2014-03-15 00:29:18.000000', 'temperatura', 884.0000, 'ºC'),
	(250609, 120, '2014-03-15 00:29:19.000000', 'temperatura', 819.0000, 'ºC'),
	(250610, 120, '2014-03-15 00:29:20.000000', 'temperatura', 244.0000, 'ºC'),
	(250611, 120, '2014-03-15 00:29:21.000000', 'temperatura', 1161.0000, 'ºC'),
	(250612, 120, '2014-03-15 00:29:22.000000', 'temperatura', 274.0000, 'ºC'),
	(250613, 120, '2014-03-15 00:29:23.000000', 'temperatura', 287.0000, 'ºC'),
	(250614, 120, '2014-03-15 00:29:24.000000', 'temperatura', 614.0000, 'ºC'),
	(250615, 120, '2014-03-15 00:29:25.000000', 'temperatura', 1011.0000, 'ºC'),
	(250616, 120, '2014-03-15 00:29:26.000000', 'temperatura', 810.0000, 'ºC'),
	(250617, 120, '2014-03-15 00:29:27.000000', 'temperatura', 1021.0000, 'ºC'),
	(250618, 120, '2014-03-15 00:29:28.000000', 'temperatura', 275.0000, 'ºC'),
	(250619, 120, '2014-03-15 00:29:29.000000', 'temperatura', 713.0000, 'ºC'),
	(250620, 120, '2014-03-15 00:29:30.000000', 'temperatura', 341.0000, 'ºC'),
	(250621, 120, '2014-03-15 00:29:31.000000', 'temperatura', 766.0000, 'ºC'),
	(250622, 120, '2014-03-15 00:29:32.000000', 'temperatura', 406.0000, 'ºC'),
	(250623, 120, '2014-03-15 00:29:33.000000', 'temperatura', 934.0000, 'ºC'),
	(250624, 120, '2014-03-15 00:29:34.000000', 'temperatura', 1051.0000, 'ºC'),
	(250625, 120, '2014-03-15 00:29:35.000000', 'temperatura', 56.0000, 'ºC'),
	(250626, 120, '2014-03-15 00:29:36.000000', 'temperatura', 724.0000, 'ºC'),
	(250627, 120, '2014-03-15 00:29:37.000000', 'temperatura', 1056.0000, 'ºC'),
	(250628, 120, '2014-03-15 00:29:38.000000', 'temperatura', 705.0000, 'ºC'),
	(250629, 120, '2014-03-15 00:29:39.000000', 'temperatura', 360.0000, 'ºC'),
	(250630, 120, '2014-03-15 00:29:40.000000', 'temperatura', 884.0000, 'ºC'),
	(250631, 120, '2014-03-15 00:29:41.000000', 'temperatura', 941.0000, 'ºC'),
	(250632, 120, '2014-03-15 00:29:42.000000', 'temperatura', 854.0000, 'ºC'),
	(250633, 120, '2014-03-15 00:29:43.000000', 'temperatura', 249.0000, 'ºC'),
	(250634, 120, '2014-03-15 00:29:44.000000', 'temperatura', 1081.0000, 'ºC'),
	(250635, 120, '2014-03-15 00:29:45.000000', 'temperatura', 1060.0000, 'ºC'),
	(250636, 120, '2014-03-15 00:29:46.000000', 'temperatura', 857.0000, 'ºC'),
	(250637, 120, '2014-03-15 00:29:47.000000', 'temperatura', 1106.0000, 'ºC'),
	(250638, 120, '2014-03-15 00:29:48.000000', 'temperatura', 558.0000, 'ºC'),
	(250639, 120, '2014-03-15 00:29:49.000000', 'temperatura', 674.0000, 'ºC'),
	(250640, 120, '2014-03-15 00:29:50.000000', 'temperatura', 495.0000, 'ºC'),
	(250641, 120, '2014-03-15 00:29:51.000000', 'temperatura', 454.0000, 'ºC'),
	(250642, 120, '2014-03-15 00:29:52.000000', 'temperatura', 786.0000, 'ºC'),
	(250643, 120, '2014-03-15 00:29:53.000000', 'temperatura', 169.0000, 'ºC'),
	(250644, 120, '2014-03-15 00:29:54.000000', 'temperatura', 889.0000, 'ºC'),
	(250645, 120, '2014-03-15 00:29:55.000000', 'temperatura', 337.0000, 'ºC'),
	(250646, 120, '2014-03-15 00:29:56.000000', 'temperatura', 218.0000, 'ºC'),
	(250647, 120, '2014-03-15 00:29:57.000000', 'temperatura', 79.0000, 'ºC'),
	(250648, 120, '2014-03-15 00:29:58.000000', 'temperatura', 942.0000, 'ºC'),
	(250649, 120, '2014-03-15 00:29:59.000000', 'temperatura', 872.0000, 'ºC'),
	(250650, 120, '2014-03-15 00:30:00.000000', 'temperatura', 337.0000, 'ºC'),
	(250651, 120, '2014-03-15 00:30:01.000000', 'temperatura', 269.0000, 'ºC'),
	(250652, 120, '2014-03-15 00:30:02.000000', 'temperatura', 333.0000, 'ºC'),
	(250653, 120, '2014-03-15 00:30:03.000000', 'temperatura', 860.0000, 'ºC'),
	(250654, 120, '2014-03-15 00:30:04.000000', 'temperatura', 902.0000, 'ºC'),
	(250655, 120, '2014-03-15 00:30:05.000000', 'temperatura', 730.0000, 'ºC'),
	(250656, 120, '2014-03-15 00:30:06.000000', 'temperatura', 945.0000, 'ºC'),
	(250657, 120, '2014-03-15 00:30:07.000000', 'temperatura', 137.0000, 'ºC'),
	(250658, 120, '2014-03-15 00:30:08.000000', 'temperatura', 248.0000, 'ºC'),
	(250659, 120, '2014-03-15 00:30:09.000000', 'temperatura', 832.0000, 'ºC'),
	(250660, 120, '2014-03-15 00:30:10.000000', 'temperatura', 1014.0000, 'ºC'),
	(250661, 120, '2014-03-15 00:30:11.000000', 'temperatura', 177.0000, 'ºC'),
	(250662, 120, '2014-03-15 00:30:12.000000', 'temperatura', 243.0000, 'ºC'),
	(250663, 120, '2014-03-15 00:30:13.000000', 'temperatura', 686.0000, 'ºC'),
	(250664, 120, '2014-03-15 00:30:14.000000', 'temperatura', 299.0000, 'ºC'),
	(250665, 120, '2014-03-15 00:30:15.000000', 'temperatura', 639.0000, 'ºC'),
	(250666, 120, '2014-03-15 00:30:16.000000', 'temperatura', 1096.0000, 'ºC'),
	(250667, 120, '2014-03-15 00:30:17.000000', 'temperatura', 1166.0000, 'ºC'),
	(250668, 120, '2014-03-15 00:30:18.000000', 'temperatura', 144.0000, 'ºC'),
	(250669, 120, '2014-03-15 00:30:19.000000', 'temperatura', 819.0000, 'ºC'),
	(250670, 120, '2014-03-15 00:30:20.000000', 'temperatura', 66.0000, 'ºC'),
	(250671, 120, '2014-03-15 00:30:21.000000', 'temperatura', 271.0000, 'ºC'),
	(250672, 120, '2014-03-15 00:30:22.000000', 'temperatura', 1159.0000, 'ºC'),
	(250673, 120, '2014-03-15 00:30:23.000000', 'temperatura', 184.0000, 'ºC'),
	(250674, 120, '2014-03-15 00:30:24.000000', 'temperatura', 1040.0000, 'ºC'),
	(250675, 120, '2014-03-15 00:30:25.000000', 'temperatura', 1052.0000, 'ºC'),
	(250676, 120, '2014-03-15 00:30:26.000000', 'temperatura', 938.0000, 'ºC'),
	(250677, 120, '2014-03-15 00:30:27.000000', 'temperatura', 334.0000, 'ºC'),
	(250678, 120, '2014-03-15 00:30:28.000000', 'temperatura', 59.0000, 'ºC'),
	(250679, 120, '2014-03-15 00:30:29.000000', 'temperatura', 494.0000, 'ºC'),
	(250680, 120, '2014-03-15 00:30:30.000000', 'temperatura', 1093.0000, 'ºC'),
	(250681, 120, '2014-03-15 00:30:31.000000', 'temperatura', 383.0000, 'ºC'),
	(250682, 120, '2014-03-15 00:30:32.000000', 'temperatura', 1036.0000, 'ºC'),
	(250683, 120, '2014-03-15 00:30:33.000000', 'temperatura', 433.0000, 'ºC'),
	(250684, 120, '2014-03-15 00:30:34.000000', 'temperatura', 257.0000, 'ºC'),
	(250685, 120, '2014-03-15 00:30:35.000000', 'temperatura', 1187.0000, 'ºC'),
	(250686, 120, '2014-03-15 00:30:36.000000', 'temperatura', 362.0000, 'ºC'),
	(250687, 120, '2014-03-15 00:30:37.000000', 'temperatura', 650.0000, 'ºC'),
	(250688, 120, '2014-03-15 00:30:38.000000', 'temperatura', 967.0000, 'ºC'),
	(250689, 120, '2014-03-15 00:30:39.000000', 'temperatura', 483.0000, 'ºC'),
	(250690, 120, '2014-03-15 00:30:40.000000', 'temperatura', 717.0000, 'ºC'),
	(250691, 120, '2014-03-15 00:30:41.000000', 'temperatura', 935.0000, 'ºC'),
	(250692, 120, '2014-03-15 00:30:42.000000', 'temperatura', 125.0000, 'ºC'),
	(250693, 120, '2014-03-15 00:30:43.000000', 'temperatura', 222.0000, 'ºC'),
	(250694, 120, '2014-03-15 00:30:44.000000', 'temperatura', 735.0000, 'ºC'),
	(250695, 120, '2014-03-15 00:30:45.000000', 'temperatura', 608.0000, 'ºC'),
	(250696, 120, '2014-03-15 00:30:46.000000', 'temperatura', 836.0000, 'ºC'),
	(250697, 120, '2014-03-15 00:30:47.000000', 'temperatura', 1155.0000, 'ºC'),
	(250698, 120, '2014-03-15 00:30:48.000000', 'temperatura', 868.0000, 'ºC'),
	(250699, 120, '2014-03-15 00:30:49.000000', 'temperatura', 876.0000, 'ºC'),
	(250700, 120, '2014-03-15 00:30:50.000000', 'temperatura', 577.0000, 'ºC'),
	(250701, 120, '2014-03-15 00:30:51.000000', 'temperatura', 258.0000, 'ºC'),
	(250702, 120, '2014-03-15 00:30:52.000000', 'temperatura', 761.0000, 'ºC'),
	(250703, 120, '2014-03-15 00:30:53.000000', 'temperatura', 628.0000, 'ºC'),
	(250704, 120, '2014-03-15 00:30:54.000000', 'temperatura', 860.0000, 'ºC'),
	(250705, 120, '2014-03-15 00:30:55.000000', 'temperatura', 16.0000, 'ºC'),
	(250706, 120, '2014-03-15 00:30:56.000000', 'temperatura', 1102.0000, 'ºC'),
	(250707, 120, '2014-03-15 00:30:57.000000', 'temperatura', 660.0000, 'ºC'),
	(250708, 120, '2014-03-15 00:30:58.000000', 'temperatura', 1197.0000, 'ºC'),
	(250709, 120, '2014-03-15 00:30:59.000000', 'temperatura', 406.0000, 'ºC'),
	(250710, 120, '2014-03-15 00:31:00.000000', 'temperatura', 837.0000, 'ºC'),
	(250711, 120, '2014-03-15 00:31:01.000000', 'temperatura', 569.0000, 'ºC'),
	(250712, 120, '2014-03-15 00:31:02.000000', 'temperatura', 334.0000, 'ºC'),
	(250713, 120, '2014-03-15 00:31:03.000000', 'temperatura', 1163.0000, 'ºC'),
	(250714, 120, '2014-03-15 00:31:04.000000', 'temperatura', 16.0000, 'ºC'),
	(250715, 120, '2014-03-15 00:31:05.000000', 'temperatura', 190.0000, 'ºC'),
	(250716, 120, '2014-03-15 00:31:06.000000', 'temperatura', 902.0000, 'ºC'),
	(250717, 120, '2014-03-15 00:31:07.000000', 'temperatura', 342.0000, 'ºC'),
	(250718, 120, '2014-03-15 00:31:08.000000', 'temperatura', 204.0000, 'ºC'),
	(250719, 120, '2014-03-15 00:31:09.000000', 'temperatura', 1196.0000, 'ºC'),
	(250720, 120, '2014-03-15 00:31:10.000000', 'temperatura', 566.0000, 'ºC'),
	(250721, 120, '2014-03-15 00:31:11.000000', 'temperatura', 443.0000, 'ºC'),
	(250722, 120, '2014-03-15 00:31:12.000000', 'temperatura', 516.0000, 'ºC'),
	(250723, 120, '2014-03-15 00:31:13.000000', 'temperatura', 55.0000, 'ºC'),
	(250724, 120, '2014-03-15 00:31:14.000000', 'temperatura', 1125.0000, 'ºC'),
	(250725, 120, '2014-03-15 00:31:15.000000', 'temperatura', 660.0000, 'ºC'),
	(250726, 120, '2014-03-15 00:31:16.000000', 'temperatura', 1128.0000, 'ºC'),
	(250727, 120, '2014-03-15 00:31:17.000000', 'temperatura', 60.0000, 'ºC'),
	(250728, 120, '2014-03-15 00:31:18.000000', 'temperatura', 518.0000, 'ºC'),
	(250729, 120, '2014-03-15 00:31:19.000000', 'temperatura', 8.0000, 'ºC'),
	(250730, 120, '2014-03-15 00:31:20.000000', 'temperatura', 888.0000, 'ºC'),
	(250731, 120, '2014-03-15 00:31:21.000000', 'temperatura', 817.0000, 'ºC'),
	(250732, 120, '2014-03-15 00:31:22.000000', 'temperatura', 221.0000, 'ºC'),
	(250733, 120, '2014-03-15 00:31:23.000000', 'temperatura', 1054.0000, 'ºC'),
	(250734, 120, '2014-03-15 00:31:24.000000', 'temperatura', 1009.0000, 'ºC'),
	(250735, 120, '2014-03-15 00:31:25.000000', 'temperatura', 682.0000, 'ºC'),
	(250736, 120, '2014-03-15 00:31:26.000000', 'temperatura', 385.0000, 'ºC'),
	(250737, 120, '2014-03-15 00:31:27.000000', 'temperatura', 1080.0000, 'ºC'),
	(250738, 120, '2014-03-15 00:31:28.000000', 'temperatura', 646.0000, 'ºC'),
	(250739, 120, '2014-03-15 00:31:29.000000', 'temperatura', 1190.0000, 'ºC'),
	(250740, 120, '2014-03-15 00:31:30.000000', 'temperatura', 414.0000, 'ºC'),
	(250741, 120, '2014-03-15 00:31:31.000000', 'temperatura', 899.0000, 'ºC'),
	(250742, 120, '2014-03-15 00:31:32.000000', 'temperatura', 853.0000, 'ºC'),
	(250743, 120, '2014-03-15 00:31:33.000000', 'temperatura', 370.0000, 'ºC'),
	(250744, 120, '2014-03-15 00:31:34.000000', 'temperatura', 491.0000, 'ºC'),
	(250745, 120, '2014-03-15 00:31:35.000000', 'temperatura', 146.0000, 'ºC'),
	(250746, 120, '2014-03-15 00:31:36.000000', 'temperatura', 459.0000, 'ºC'),
	(250747, 120, '2014-03-15 00:31:37.000000', 'temperatura', 654.0000, 'ºC'),
	(250748, 120, '2014-03-15 00:31:38.000000', 'temperatura', 696.0000, 'ºC'),
	(250749, 120, '2014-03-15 00:31:39.000000', 'temperatura', 317.0000, 'ºC'),
	(250750, 120, '2014-03-15 00:31:40.000000', 'temperatura', 697.0000, 'ºC'),
	(250751, 120, '2014-03-15 00:31:41.000000', 'temperatura', 134.0000, 'ºC'),
	(250752, 120, '2014-03-15 00:31:42.000000', 'temperatura', 981.0000, 'ºC'),
	(250753, 120, '2014-03-15 00:31:43.000000', 'temperatura', 905.0000, 'ºC'),
	(250754, 120, '2014-03-15 00:31:44.000000', 'temperatura', 381.0000, 'ºC'),
	(250755, 120, '2014-03-15 00:31:45.000000', 'temperatura', 390.0000, 'ºC'),
	(250756, 120, '2014-03-15 00:31:46.000000', 'temperatura', 806.0000, 'ºC'),
	(250757, 120, '2014-03-15 00:31:47.000000', 'temperatura', 462.0000, 'ºC'),
	(250758, 120, '2014-03-15 00:31:48.000000', 'temperatura', 1093.0000, 'ºC'),
	(250759, 120, '2014-03-15 00:31:49.000000', 'temperatura', 480.0000, 'ºC'),
	(250760, 120, '2014-03-15 00:31:50.000000', 'temperatura', 322.0000, 'ºC'),
	(250761, 120, '2014-03-15 00:31:51.000000', 'temperatura', 168.0000, 'ºC'),
	(250762, 120, '2014-03-15 00:31:52.000000', 'temperatura', 1078.0000, 'ºC'),
	(250763, 120, '2014-03-15 00:31:53.000000', 'temperatura', 83.0000, 'ºC'),
	(250764, 120, '2014-03-15 00:31:54.000000', 'temperatura', 782.0000, 'ºC'),
	(250765, 120, '2014-03-15 00:31:55.000000', 'temperatura', 63.0000, 'ºC'),
	(250766, 120, '2014-03-15 00:31:56.000000', 'temperatura', 368.0000, 'ºC'),
	(250767, 120, '2014-03-15 00:31:57.000000', 'temperatura', 450.0000, 'ºC'),
	(250768, 120, '2014-03-15 00:31:58.000000', 'temperatura', 1150.0000, 'ºC'),
	(250769, 120, '2014-03-15 00:31:59.000000', 'temperatura', 799.0000, 'ºC'),
	(250770, 120, '2014-03-15 00:32:00.000000', 'temperatura', 544.0000, 'ºC'),
	(250771, 120, '2014-03-15 00:32:01.000000', 'temperatura', 324.0000, 'ºC'),
	(250772, 120, '2014-03-15 00:32:02.000000', 'temperatura', 1190.0000, 'ºC'),
	(250773, 120, '2014-03-15 00:32:03.000000', 'temperatura', 176.0000, 'ºC'),
	(250774, 120, '2014-03-15 00:32:04.000000', 'temperatura', 911.0000, 'ºC'),
	(250775, 120, '2014-03-15 00:32:05.000000', 'temperatura', 430.0000, 'ºC'),
	(250776, 120, '2014-03-15 00:32:06.000000', 'temperatura', 616.0000, 'ºC'),
	(250777, 120, '2014-03-15 00:32:07.000000', 'temperatura', 590.0000, 'ºC'),
	(250778, 120, '2014-03-15 00:32:08.000000', 'temperatura', 1102.0000, 'ºC'),
	(250779, 120, '2014-03-15 00:32:09.000000', 'temperatura', 143.0000, 'ºC'),
	(250780, 120, '2014-03-15 00:32:10.000000', 'temperatura', 1008.0000, 'ºC'),
	(250781, 120, '2014-03-15 00:32:11.000000', 'temperatura', 1014.0000, 'ºC'),
	(250782, 120, '2014-03-15 00:32:12.000000', 'temperatura', 843.0000, 'ºC'),
	(250783, 120, '2014-03-15 00:32:13.000000', 'temperatura', 1175.0000, 'ºC'),
	(250784, 120, '2014-03-15 00:32:14.000000', 'temperatura', 945.0000, 'ºC'),
	(250785, 120, '2014-03-15 00:32:15.000000', 'temperatura', 2.0000, 'ºC'),
	(250786, 120, '2014-03-15 00:32:16.000000', 'temperatura', 774.0000, 'ºC'),
	(250787, 120, '2014-03-15 00:32:17.000000', 'temperatura', 264.0000, 'ºC'),
	(250788, 120, '2014-03-15 00:32:18.000000', 'temperatura', 200.0000, 'ºC'),
	(250789, 120, '2014-03-15 00:32:19.000000', 'temperatura', 206.0000, 'ºC'),
	(250790, 120, '2014-03-15 00:32:20.000000', 'temperatura', 432.0000, 'ºC'),
	(250791, 120, '2014-03-15 00:32:21.000000', 'temperatura', 342.0000, 'ºC'),
	(250792, 120, '2014-03-15 00:32:22.000000', 'temperatura', 413.0000, 'ºC'),
	(250793, 120, '2014-03-15 00:32:23.000000', 'temperatura', 1042.0000, 'ºC'),
	(250794, 120, '2014-03-15 00:32:24.000000', 'temperatura', 370.0000, 'ºC'),
	(250795, 120, '2014-03-15 00:32:25.000000', 'temperatura', 1124.0000, 'ºC'),
	(250796, 120, '2014-03-15 00:32:26.000000', 'temperatura', 911.0000, 'ºC'),
	(250797, 120, '2014-03-15 00:32:27.000000', 'temperatura', 1186.0000, 'ºC'),
	(250798, 120, '2014-03-15 00:32:28.000000', 'temperatura', 795.0000, 'ºC'),
	(250799, 120, '2014-03-15 00:32:29.000000', 'temperatura', 416.0000, 'ºC'),
	(250800, 120, '2014-03-15 00:32:30.000000', 'temperatura', 897.0000, 'ºC'),
	(250801, 120, '2014-03-15 00:32:31.000000', 'temperatura', 836.0000, 'ºC'),
	(250802, 120, '2014-03-15 00:32:32.000000', 'temperatura', 292.0000, 'ºC'),
	(250803, 120, '2014-03-15 00:32:33.000000', 'temperatura', 153.0000, 'ºC'),
	(250804, 120, '2014-03-15 00:32:34.000000', 'temperatura', 1087.0000, 'ºC'),
	(250805, 120, '2014-03-15 00:32:35.000000', 'temperatura', 180.0000, 'ºC'),
	(250806, 120, '2014-03-15 00:32:36.000000', 'temperatura', 36.0000, 'ºC'),
	(250807, 120, '2014-03-15 00:32:37.000000', 'temperatura', 843.0000, 'ºC'),
	(250808, 120, '2014-03-15 00:32:38.000000', 'temperatura', 505.0000, 'ºC'),
	(250809, 120, '2014-03-15 00:32:39.000000', 'temperatura', 1196.0000, 'ºC'),
	(250810, 120, '2014-03-15 00:32:40.000000', 'temperatura', 869.0000, 'ºC'),
	(250811, 120, '2014-03-15 00:32:41.000000', 'temperatura', 754.0000, 'ºC'),
	(250812, 120, '2014-03-15 00:32:42.000000', 'temperatura', 1165.0000, 'ºC'),
	(250813, 120, '2014-03-15 00:32:43.000000', 'temperatura', 1162.0000, 'ºC'),
	(250814, 120, '2014-03-15 00:32:44.000000', 'temperatura', 1116.0000, 'ºC'),
	(250815, 120, '2014-03-15 00:32:45.000000', 'temperatura', 897.0000, 'ºC'),
	(250816, 120, '2014-03-15 00:32:46.000000', 'temperatura', 1136.0000, 'ºC'),
	(250817, 120, '2014-03-15 00:32:47.000000', 'temperatura', 588.0000, 'ºC'),
	(250818, 120, '2014-03-15 00:32:48.000000', 'temperatura', 733.0000, 'ºC'),
	(250819, 120, '2014-03-15 00:32:49.000000', 'temperatura', 702.0000, 'ºC'),
	(250820, 120, '2014-03-15 00:32:50.000000', 'temperatura', 113.0000, 'ºC'),
	(250821, 120, '2014-03-15 00:32:51.000000', 'temperatura', 858.0000, 'ºC'),
	(250822, 120, '2014-03-15 00:32:52.000000', 'temperatura', 353.0000, 'ºC'),
	(250823, 120, '2014-03-15 00:32:53.000000', 'temperatura', 392.0000, 'ºC'),
	(250824, 120, '2014-03-15 00:32:54.000000', 'temperatura', 902.0000, 'ºC'),
	(250825, 120, '2014-03-15 00:32:55.000000', 'temperatura', 934.0000, 'ºC'),
	(250826, 120, '2014-03-15 00:32:56.000000', 'temperatura', 762.0000, 'ºC'),
	(250827, 120, '2014-03-15 00:32:57.000000', 'temperatura', 1010.0000, 'ºC'),
	(250828, 120, '2014-03-15 00:32:58.000000', 'temperatura', 366.0000, 'ºC'),
	(250829, 120, '2014-03-15 00:32:59.000000', 'temperatura', 0.0000, 'ºC'),
	(250830, 120, '2014-03-15 00:33:00.000000', 'temperatura', 103.0000, 'ºC'),
	(250831, 120, '2014-03-15 00:33:01.000000', 'temperatura', 516.0000, 'ºC'),
	(250832, 120, '2014-03-15 00:33:02.000000', 'temperatura', 1072.0000, 'ºC'),
	(250833, 120, '2014-03-15 00:33:03.000000', 'temperatura', 213.0000, 'ºC'),
	(250834, 120, '2014-03-15 00:33:04.000000', 'temperatura', 247.0000, 'ºC'),
	(250835, 120, '2014-03-15 00:33:05.000000', 'temperatura', 597.0000, 'ºC'),
	(250836, 120, '2014-03-15 00:33:06.000000', 'temperatura', 1043.0000, 'ºC'),
	(250837, 120, '2014-03-15 00:33:07.000000', 'temperatura', 1028.0000, 'ºC'),
	(250838, 120, '2014-03-15 00:33:08.000000', 'temperatura', 809.0000, 'ºC'),
	(250839, 120, '2014-03-15 00:33:09.000000', 'temperatura', 961.0000, 'ºC'),
	(250840, 120, '2014-03-15 00:33:10.000000', 'temperatura', 1181.0000, 'ºC'),
	(250841, 120, '2014-03-15 00:33:11.000000', 'temperatura', 620.0000, 'ºC'),
	(250842, 120, '2014-03-15 00:33:12.000000', 'temperatura', 759.0000, 'ºC'),
	(250843, 120, '2014-03-15 00:33:13.000000', 'temperatura', 737.0000, 'ºC'),
	(250844, 120, '2014-03-15 00:33:14.000000', 'temperatura', 206.0000, 'ºC'),
	(250845, 120, '2014-03-15 00:33:15.000000', 'temperatura', 21.0000, 'ºC'),
	(250846, 120, '2014-03-15 00:33:16.000000', 'temperatura', 687.0000, 'ºC'),
	(250847, 120, '2014-03-15 00:33:17.000000', 'temperatura', 970.0000, 'ºC'),
	(250848, 120, '2014-03-15 00:33:18.000000', 'temperatura', 393.0000, 'ºC'),
	(250849, 120, '2014-03-15 00:33:19.000000', 'temperatura', 255.0000, 'ºC'),
	(250850, 120, '2014-03-15 00:33:20.000000', 'temperatura', 95.0000, 'ºC'),
	(250851, 120, '2014-03-15 00:33:21.000000', 'temperatura', 910.0000, 'ºC'),
	(250852, 120, '2014-03-15 00:33:22.000000', 'temperatura', 667.0000, 'ºC'),
	(250853, 120, '2014-03-15 00:33:23.000000', 'temperatura', 606.0000, 'ºC'),
	(250854, 120, '2014-03-15 00:33:24.000000', 'temperatura', 1030.0000, 'ºC'),
	(250855, 120, '2014-03-15 00:33:25.000000', 'temperatura', 933.0000, 'ºC'),
	(250856, 120, '2014-03-15 00:33:26.000000', 'temperatura', 375.0000, 'ºC'),
	(250857, 120, '2014-03-15 00:33:27.000000', 'temperatura', 277.0000, 'ºC'),
	(250858, 120, '2014-03-15 00:33:28.000000', 'temperatura', 258.0000, 'ºC'),
	(250859, 120, '2014-03-15 00:33:29.000000', 'temperatura', 461.0000, 'ºC'),
	(250860, 120, '2014-03-15 00:33:30.000000', 'temperatura', 331.0000, 'ºC'),
	(250861, 120, '2014-03-15 00:33:31.000000', 'temperatura', 271.0000, 'ºC'),
	(250862, 120, '2014-03-15 00:33:32.000000', 'temperatura', 365.0000, 'ºC'),
	(250863, 120, '2014-03-15 00:33:33.000000', 'temperatura', 1014.0000, 'ºC'),
	(250864, 120, '2014-03-15 00:33:34.000000', 'temperatura', 373.0000, 'ºC'),
	(250865, 120, '2014-03-15 00:33:35.000000', 'temperatura', 22.0000, 'ºC'),
	(250866, 120, '2014-03-15 00:33:36.000000', 'temperatura', 193.0000, 'ºC'),
	(250867, 120, '2014-03-15 00:33:37.000000', 'temperatura', 900.0000, 'ºC'),
	(250868, 120, '2014-03-15 00:33:38.000000', 'temperatura', 323.0000, 'ºC'),
	(250869, 120, '2014-03-15 00:33:39.000000', 'temperatura', 115.0000, 'ºC'),
	(250870, 120, '2014-03-15 00:33:40.000000', 'temperatura', 805.0000, 'ºC'),
	(250871, 120, '2014-03-15 00:33:41.000000', 'temperatura', 80.0000, 'ºC'),
	(250872, 120, '2014-03-15 00:33:42.000000', 'temperatura', 385.0000, 'ºC'),
	(250873, 120, '2014-03-15 00:33:43.000000', 'temperatura', 486.0000, 'ºC'),
	(250874, 120, '2014-03-15 00:33:44.000000', 'temperatura', 74.0000, 'ºC'),
	(250875, 120, '2014-03-15 00:33:45.000000', 'temperatura', 115.0000, 'ºC'),
	(250876, 120, '2014-03-15 00:33:46.000000', 'temperatura', 354.0000, 'ºC'),
	(250877, 120, '2014-03-15 00:33:47.000000', 'temperatura', 226.0000, 'ºC'),
	(250878, 120, '2014-03-15 00:33:48.000000', 'temperatura', 67.0000, 'ºC'),
	(250879, 120, '2014-03-15 00:33:49.000000', 'temperatura', 857.0000, 'ºC'),
	(250880, 120, '2014-03-15 00:33:50.000000', 'temperatura', 487.0000, 'ºC'),
	(250881, 120, '2014-03-15 00:33:51.000000', 'temperatura', 1063.0000, 'ºC'),
	(250882, 120, '2014-03-15 00:33:52.000000', 'temperatura', 253.0000, 'ºC'),
	(250883, 120, '2014-03-15 00:33:53.000000', 'temperatura', 478.0000, 'ºC'),
	(250884, 120, '2014-03-15 00:33:54.000000', 'temperatura', 432.0000, 'ºC'),
	(250885, 120, '2014-03-15 00:33:55.000000', 'temperatura', 727.0000, 'ºC'),
	(250886, 120, '2014-03-15 00:33:56.000000', 'temperatura', 1140.0000, 'ºC'),
	(250887, 120, '2014-03-15 00:33:57.000000', 'temperatura', 1120.0000, 'ºC'),
	(250888, 120, '2014-03-15 00:33:58.000000', 'temperatura', 981.0000, 'ºC'),
	(250889, 120, '2014-03-15 00:33:59.000000', 'temperatura', 343.0000, 'ºC'),
	(250890, 120, '2014-03-15 00:34:00.000000', 'temperatura', 1173.0000, 'ºC'),
	(250891, 120, '2014-03-15 00:34:01.000000', 'temperatura', 37.0000, 'ºC'),
	(250892, 120, '2014-03-15 00:34:02.000000', 'temperatura', 264.0000, 'ºC'),
	(250893, 120, '2014-03-15 00:34:03.000000', 'temperatura', 13.0000, 'ºC'),
	(250894, 120, '2014-03-15 00:34:04.000000', 'temperatura', 471.0000, 'ºC'),
	(250895, 120, '2014-03-15 00:34:05.000000', 'temperatura', 1115.0000, 'ºC'),
	(250896, 120, '2014-03-15 00:34:06.000000', 'temperatura', 566.0000, 'ºC'),
	(250897, 120, '2014-03-15 00:34:07.000000', 'temperatura', 684.0000, 'ºC'),
	(250898, 120, '2014-03-15 00:34:08.000000', 'temperatura', 521.0000, 'ºC'),
	(250899, 120, '2014-03-15 00:34:09.000000', 'temperatura', 556.0000, 'ºC'),
	(250900, 120, '2014-03-15 00:34:10.000000', 'temperatura', 19.0000, 'ºC'),
	(250901, 120, '2014-03-15 00:34:11.000000', 'temperatura', 824.0000, 'ºC'),
	(250902, 120, '2014-03-15 00:34:12.000000', 'temperatura', 465.0000, 'ºC'),
	(250903, 120, '2014-03-15 00:34:13.000000', 'temperatura', 1052.0000, 'ºC'),
	(250904, 120, '2014-03-15 00:34:14.000000', 'temperatura', 266.0000, 'ºC'),
	(250905, 120, '2014-03-15 00:34:15.000000', 'temperatura', 577.0000, 'ºC'),
	(250906, 120, '2014-03-15 00:34:16.000000', 'temperatura', 885.0000, 'ºC'),
	(250907, 120, '2014-03-15 00:34:17.000000', 'temperatura', 297.0000, 'ºC'),
	(250908, 120, '2014-03-15 00:34:18.000000', 'temperatura', 27.0000, 'ºC'),
	(250909, 120, '2014-03-15 00:34:19.000000', 'temperatura', 447.0000, 'ºC'),
	(250910, 120, '2014-03-15 00:34:20.000000', 'temperatura', 954.0000, 'ºC'),
	(250911, 120, '2014-03-15 00:34:21.000000', 'temperatura', 1027.0000, 'ºC'),
	(250912, 120, '2014-03-15 00:34:22.000000', 'temperatura', 1077.0000, 'ºC'),
	(250913, 120, '2014-03-15 00:34:23.000000', 'temperatura', 1102.0000, 'ºC'),
	(250914, 120, '2014-03-15 00:34:24.000000', 'temperatura', 1082.0000, 'ºC'),
	(250915, 120, '2014-03-15 00:34:25.000000', 'temperatura', 902.0000, 'ºC'),
	(250916, 120, '2014-03-15 00:34:26.000000', 'temperatura', 68.0000, 'ºC'),
	(250917, 120, '2014-03-15 00:34:27.000000', 'temperatura', 31.0000, 'ºC'),
	(250918, 120, '2014-03-15 00:34:28.000000', 'temperatura', 1152.0000, 'ºC'),
	(250919, 120, '2014-03-15 00:34:29.000000', 'temperatura', 867.0000, 'ºC'),
	(250920, 120, '2014-03-15 00:34:30.000000', 'temperatura', 880.0000, 'ºC'),
	(250921, 120, '2014-03-15 00:34:31.000000', 'temperatura', 601.0000, 'ºC'),
	(250922, 120, '2014-03-15 00:34:32.000000', 'temperatura', 364.0000, 'ºC'),
	(250923, 120, '2014-03-15 00:34:33.000000', 'temperatura', 20.0000, 'ºC'),
	(250924, 120, '2014-03-15 00:34:34.000000', 'temperatura', 207.0000, 'ºC'),
	(250925, 120, '2014-03-15 00:34:35.000000', 'temperatura', 973.0000, 'ºC'),
	(250926, 120, '2014-03-15 00:34:36.000000', 'temperatura', 648.0000, 'ºC'),
	(250927, 120, '2014-03-15 00:34:37.000000', 'temperatura', 321.0000, 'ºC'),
	(250928, 120, '2014-03-15 00:34:38.000000', 'temperatura', 861.0000, 'ºC'),
	(250929, 120, '2014-03-15 00:34:39.000000', 'temperatura', 943.0000, 'ºC'),
	(250930, 120, '2014-03-15 00:34:40.000000', 'temperatura', 933.0000, 'ºC'),
	(250931, 120, '2014-03-15 00:34:41.000000', 'temperatura', 636.0000, 'ºC'),
	(250932, 120, '2014-03-15 00:34:42.000000', 'temperatura', 383.0000, 'ºC'),
	(250933, 120, '2014-03-15 00:34:43.000000', 'temperatura', 6.0000, 'ºC'),
	(250934, 120, '2014-03-15 00:34:44.000000', 'temperatura', 83.0000, 'ºC'),
	(250935, 120, '2014-03-15 00:34:45.000000', 'temperatura', 398.0000, 'ºC'),
	(250936, 120, '2014-03-15 00:34:46.000000', 'temperatura', 540.0000, 'ºC'),
	(250937, 120, '2014-03-15 00:34:47.000000', 'temperatura', 305.0000, 'ºC'),
	(250938, 120, '2014-03-15 00:34:48.000000', 'temperatura', 1107.0000, 'ºC'),
	(250939, 120, '2014-03-15 00:34:49.000000', 'temperatura', 1020.0000, 'ºC'),
	(250940, 120, '2014-03-15 00:34:50.000000', 'temperatura', 578.0000, 'ºC'),
	(250941, 120, '2014-03-15 00:34:51.000000', 'temperatura', 1031.0000, 'ºC'),
	(250942, 120, '2014-03-15 00:34:52.000000', 'temperatura', 1021.0000, 'ºC'),
	(250943, 120, '2014-03-15 00:34:53.000000', 'temperatura', 814.0000, 'ºC'),
	(250944, 120, '2014-03-15 00:34:54.000000', 'temperatura', 1007.0000, 'ºC'),
	(250945, 120, '2014-03-15 00:34:55.000000', 'temperatura', 192.0000, 'ºC'),
	(250946, 120, '2014-03-15 00:34:56.000000', 'temperatura', 343.0000, 'ºC'),
	(250947, 120, '2014-03-15 00:34:57.000000', 'temperatura', 1136.0000, 'ºC'),
	(250948, 120, '2014-03-15 00:34:58.000000', 'temperatura', 1051.0000, 'ºC'),
	(250949, 120, '2014-03-15 00:34:59.000000', 'temperatura', 650.0000, 'ºC'),
	(250950, 120, '2014-03-15 00:35:00.000000', 'temperatura', 96.0000, 'ºC'),
	(250951, 120, '2014-03-15 00:35:01.000000', 'temperatura', 930.0000, 'ºC'),
	(250952, 120, '2014-03-15 00:35:02.000000', 'temperatura', 765.0000, 'ºC'),
	(250953, 120, '2014-03-15 00:35:03.000000', 'temperatura', 1034.0000, 'ºC'),
	(250954, 120, '2014-03-15 00:35:04.000000', 'temperatura', 474.0000, 'ºC'),
	(250955, 120, '2014-03-15 00:35:05.000000', 'temperatura', 468.0000, 'ºC'),
	(250956, 120, '2014-03-15 00:35:06.000000', 'temperatura', 921.0000, 'ºC'),
	(250957, 120, '2014-03-15 00:35:07.000000', 'temperatura', 801.0000, 'ºC'),
	(250958, 120, '2014-03-15 00:35:08.000000', 'temperatura', 43.0000, 'ºC'),
	(250959, 120, '2014-03-15 00:35:09.000000', 'temperatura', 211.0000, 'ºC'),
	(250960, 120, '2014-03-15 00:35:10.000000', 'temperatura', 926.0000, 'ºC'),
	(250961, 120, '2014-03-15 00:35:11.000000', 'temperatura', 398.0000, 'ºC'),
	(250962, 120, '2014-03-15 00:35:12.000000', 'temperatura', 413.0000, 'ºC'),
	(250963, 120, '2014-03-15 00:35:13.000000', 'temperatura', 873.0000, 'ºC'),
	(250964, 120, '2014-03-15 00:35:14.000000', 'temperatura', 724.0000, 'ºC'),
	(250965, 120, '2014-03-15 00:35:15.000000', 'temperatura', 1004.0000, 'ºC'),
	(250966, 120, '2014-03-15 00:35:16.000000', 'temperatura', 449.0000, 'ºC'),
	(250967, 120, '2014-03-15 00:35:17.000000', 'temperatura', 431.0000, 'ºC'),
	(250968, 120, '2014-03-15 00:35:18.000000', 'temperatura', 811.0000, 'ºC'),
	(250969, 120, '2014-03-15 00:35:19.000000', 'temperatura', 363.0000, 'ºC'),
	(250970, 120, '2014-03-15 00:35:20.000000', 'temperatura', 582.0000, 'ºC'),
	(250971, 120, '2014-03-15 00:35:21.000000', 'temperatura', 623.0000, 'ºC'),
	(250972, 120, '2014-03-15 00:35:22.000000', 'temperatura', 169.0000, 'ºC'),
	(250973, 120, '2014-03-15 00:35:23.000000', 'temperatura', 177.0000, 'ºC'),
	(250974, 120, '2014-03-15 00:35:24.000000', 'temperatura', 376.0000, 'ºC'),
	(250975, 120, '2014-03-15 00:35:25.000000', 'temperatura', 152.0000, 'ºC'),
	(250976, 120, '2014-03-15 00:35:26.000000', 'temperatura', 833.0000, 'ºC'),
	(250977, 120, '2014-03-15 00:35:27.000000', 'temperatura', 110.0000, 'ºC'),
	(250978, 120, '2014-03-15 00:35:28.000000', 'temperatura', 452.0000, 'ºC'),
	(250979, 120, '2014-03-15 00:35:29.000000', 'temperatura', 727.0000, 'ºC'),
	(250980, 120, '2014-03-15 00:35:30.000000', 'temperatura', 1083.0000, 'ºC'),
	(250981, 120, '2014-03-15 00:35:31.000000', 'temperatura', 833.0000, 'ºC'),
	(250982, 120, '2014-03-15 00:35:32.000000', 'temperatura', 916.0000, 'ºC'),
	(250983, 120, '2014-03-15 00:35:33.000000', 'temperatura', 880.0000, 'ºC'),
	(250984, 120, '2014-03-15 00:35:34.000000', 'temperatura', 455.0000, 'ºC'),
	(250985, 120, '2014-03-15 00:35:35.000000', 'temperatura', 833.0000, 'ºC'),
	(250986, 120, '2014-03-15 00:35:36.000000', 'temperatura', 402.0000, 'ºC'),
	(250987, 120, '2014-03-15 00:35:37.000000', 'temperatura', 713.0000, 'ºC'),
	(250988, 120, '2014-03-15 00:35:38.000000', 'temperatura', 1157.0000, 'ºC'),
	(250989, 120, '2014-03-15 00:35:39.000000', 'temperatura', 47.0000, 'ºC'),
	(250990, 120, '2014-03-15 00:35:40.000000', 'temperatura', 365.0000, 'ºC'),
	(250991, 120, '2014-03-15 00:35:41.000000', 'temperatura', 485.0000, 'ºC'),
	(250992, 120, '2014-03-15 00:35:42.000000', 'temperatura', 132.0000, 'ºC'),
	(250993, 120, '2014-03-15 00:35:43.000000', 'temperatura', 402.0000, 'ºC'),
	(250994, 120, '2014-03-15 00:35:44.000000', 'temperatura', 416.0000, 'ºC'),
	(250995, 120, '2014-03-15 00:35:45.000000', 'temperatura', 876.0000, 'ºC'),
	(250996, 120, '2014-03-15 00:35:46.000000', 'temperatura', 730.0000, 'ºC'),
	(250997, 120, '2014-03-15 00:35:47.000000', 'temperatura', 1024.0000, 'ºC'),
	(250998, 120, '2014-03-15 00:35:48.000000', 'temperatura', 531.0000, 'ºC'),
	(250999, 120, '2014-03-15 00:35:49.000000', 'temperatura', 783.0000, 'ºC'),
	(251000, 120, '2014-03-15 00:35:50.000000', 'temperatura', 1122.0000, 'ºC'),
	(251001, 120, '2014-03-15 00:35:51.000000', 'temperatura', 861.0000, 'ºC'),
	(251002, 120, '2014-03-15 00:35:52.000000', 'temperatura', 938.0000, 'ºC'),
	(251003, 120, '2014-03-15 00:35:53.000000', 'temperatura', 910.0000, 'ºC'),
	(251004, 120, '2014-03-15 00:35:54.000000', 'temperatura', 537.0000, 'ºC'),
	(251005, 120, '2014-03-15 00:35:55.000000', 'temperatura', 1153.0000, 'ºC'),
	(251006, 120, '2014-03-15 00:35:56.000000', 'temperatura', 555.0000, 'ºC'),
	(251007, 120, '2014-03-15 00:35:57.000000', 'temperatura', 516.0000, 'ºC'),
	(251008, 120, '2014-03-15 00:35:58.000000', 'temperatura', 915.0000, 'ºC'),
	(251009, 120, '2014-03-15 00:35:59.000000', 'temperatura', 627.0000, 'ºC'),
	(251010, 120, '2014-03-15 00:36:00.000000', 'temperatura', 391.0000, 'ºC'),
	(251011, 120, '2014-03-15 00:36:01.000000', 'temperatura', 73.0000, 'ºC'),
	(251012, 120, '2014-03-15 00:36:02.000000', 'temperatura', 394.0000, 'ºC'),
	(251013, 120, '2014-03-15 00:36:03.000000', 'temperatura', 552.0000, 'ºC'),
	(251014, 120, '2014-03-15 00:36:04.000000', 'temperatura', 377.0000, 'ºC'),
	(251015, 120, '2014-03-15 00:36:05.000000', 'temperatura', 230.0000, 'ºC'),
	(251016, 120, '2014-03-15 00:36:06.000000', 'temperatura', 18.0000, 'ºC'),
	(251017, 120, '2014-03-15 00:36:07.000000', 'temperatura', 604.0000, 'ºC'),
	(251018, 120, '2014-03-15 00:36:08.000000', 'temperatura', 563.0000, 'ºC'),
	(251019, 120, '2014-03-15 00:36:09.000000', 'temperatura', 1005.0000, 'ºC'),
	(251020, 120, '2014-03-15 00:36:10.000000', 'temperatura', 937.0000, 'ºC'),
	(251021, 120, '2014-03-15 00:36:11.000000', 'temperatura', 468.0000, 'ºC'),
	(251022, 120, '2014-03-15 00:36:12.000000', 'temperatura', 733.0000, 'ºC'),
	(251023, 120, '2014-03-15 00:36:13.000000', 'temperatura', 1060.0000, 'ºC'),
	(251024, 120, '2014-03-15 00:36:14.000000', 'temperatura', 702.0000, 'ºC'),
	(251025, 120, '2014-03-15 00:36:15.000000', 'temperatura', 331.0000, 'ºC'),
	(251026, 120, '2014-03-15 00:36:16.000000', 'temperatura', 749.0000, 'ºC'),
	(251027, 120, '2014-03-15 00:36:17.000000', 'temperatura', 352.0000, 'ºC'),
	(251028, 120, '2014-03-15 00:36:18.000000', 'temperatura', 712.0000, 'ºC'),
	(251029, 120, '2014-03-15 00:36:19.000000', 'temperatura', 105.0000, 'ºC'),
	(251030, 120, '2014-03-15 00:36:20.000000', 'temperatura', 792.0000, 'ºC'),
	(251031, 120, '2014-03-15 00:36:21.000000', 'temperatura', 42.0000, 'ºC'),
	(251032, 120, '2014-03-15 00:36:22.000000', 'temperatura', 238.0000, 'ºC'),
	(251033, 120, '2014-03-15 00:36:23.000000', 'temperatura', 1062.0000, 'ºC'),
	(251034, 120, '2014-03-15 00:36:24.000000', 'temperatura', 997.0000, 'ºC'),
	(251035, 120, '2014-03-15 00:36:25.000000', 'temperatura', 599.0000, 'ºC'),
	(251036, 120, '2014-03-15 00:36:26.000000', 'temperatura', 5.0000, 'ºC'),
	(251037, 120, '2014-03-15 00:36:27.000000', 'temperatura', 629.0000, 'ºC'),
	(251038, 120, '2014-03-15 00:36:28.000000', 'temperatura', 730.0000, 'ºC'),
	(251039, 120, '2014-03-15 00:36:29.000000', 'temperatura', 564.0000, 'ºC'),
	(251040, 120, '2014-03-15 00:36:30.000000', 'temperatura', 630.0000, 'ºC'),
	(251041, 120, '2014-03-15 00:36:31.000000', 'temperatura', 258.0000, 'ºC'),
	(251042, 120, '2014-03-15 00:36:32.000000', 'temperatura', 600.0000, 'ºC'),
	(251043, 120, '2014-03-15 00:36:33.000000', 'temperatura', 1026.0000, 'ºC'),
	(251044, 120, '2014-03-15 00:36:34.000000', 'temperatura', 929.0000, 'ºC'),
	(251045, 120, '2014-03-15 00:36:35.000000', 'temperatura', 371.0000, 'ºC'),
	(251046, 120, '2014-03-15 00:36:36.000000', 'temperatura', 266.0000, 'ºC'),
	(251047, 120, '2014-03-15 00:36:37.000000', 'temperatura', 218.0000, 'ºC'),
	(251048, 120, '2014-03-15 00:36:38.000000', 'temperatura', 293.0000, 'ºC'),
	(251049, 120, '2014-03-15 00:36:39.000000', 'temperatura', 812.0000, 'ºC'),
	(251050, 120, '2014-03-15 00:36:40.000000', 'temperatura', 782.0000, 'ºC'),
	(251051, 120, '2014-03-15 00:36:41.000000', 'temperatura', 273.0000, 'ºC'),
	(251052, 120, '2014-03-15 00:36:42.000000', 'temperatura', 222.0000, 'ºC'),
	(251053, 120, '2014-03-15 00:36:43.000000', 'temperatura', 291.0000, 'ºC'),
	(251054, 120, '2014-03-15 00:36:44.000000', 'temperatura', 787.0000, 'ºC'),
	(251055, 120, '2014-03-15 00:36:45.000000', 'temperatura', 665.0000, 'ºC'),
	(251056, 120, '2014-03-15 00:36:46.000000', 'temperatura', 964.0000, 'ºC'),
	(251057, 120, '2014-03-15 00:36:47.000000', 'temperatura', 426.0000, 'ºC'),
	(251058, 120, '2014-03-15 00:36:48.000000', 'temperatura', 436.0000, 'ºC'),
	(251059, 120, '2014-03-15 00:36:49.000000', 'temperatura', 904.0000, 'ºC'),
	(251060, 120, '2014-03-15 00:36:50.000000', 'temperatura', 812.0000, 'ºC'),
	(251061, 120, '2014-03-15 00:36:51.000000', 'temperatura', 148.0000, 'ºC'),
	(251062, 120, '2014-03-15 00:36:52.000000', 'temperatura', 705.0000, 'ºC'),
	(251063, 120, '2014-03-15 00:36:53.000000', 'temperatura', 680.0000, 'ºC'),
	(251064, 120, '2014-03-15 00:36:54.000000', 'temperatura', 85.0000, 'ºC'),
	(251065, 120, '2014-03-15 00:36:55.000000', 'temperatura', 786.0000, 'ºC'),
	(251066, 120, '2014-03-15 00:36:56.000000', 'temperatura', 76.0000, 'ºC'),
	(251067, 120, '2014-03-15 00:36:57.000000', 'temperatura', 421.0000, 'ºC'),
	(251068, 120, '2014-03-15 00:36:58.000000', 'temperatura', 679.0000, 'ºC'),
	(251069, 120, '2014-03-15 00:36:59.000000', 'temperatura', 934.0000, 'ºC'),
	(251070, 120, '2014-03-15 00:37:00.000000', 'temperatura', 231.0000, 'ºC'),
	(251071, 120, '2014-03-15 00:37:01.000000', 'temperatura', 755.0000, 'ºC'),
	(251072, 120, '2014-03-15 00:37:02.000000', 'temperatura', 683.0000, 'ºC'),
	(251073, 120, '2014-03-15 00:37:03.000000', 'temperatura', 1148.0000, 'ºC'),
	(251074, 120, '2014-03-15 00:37:04.000000', 'temperatura', 92.0000, 'ºC'),
	(251075, 120, '2014-03-15 00:37:05.000000', 'temperatura', 618.0000, 'ºC'),
	(251076, 120, '2014-03-15 00:37:06.000000', 'temperatura', 414.0000, 'ºC'),
	(251077, 120, '2014-03-15 00:37:07.000000', 'temperatura', 216.0000, 'ºC'),
	(251078, 120, '2014-03-15 00:37:08.000000', 'temperatura', 1039.0000, 'ºC'),
	(251079, 120, '2014-03-15 00:37:09.000000', 'temperatura', 945.0000, 'ºC'),
	(251080, 120, '2014-03-15 00:37:10.000000', 'temperatura', 411.0000, 'ºC'),
	(251081, 120, '2014-03-15 00:37:11.000000', 'temperatura', 420.0000, 'ºC'),
	(251082, 120, '2014-03-15 00:37:12.000000', 'temperatura', 869.0000, 'ºC'),
	(251083, 120, '2014-03-15 00:37:13.000000', 'temperatura', 685.0000, 'ºC'),
	(251084, 120, '2014-03-15 00:37:14.000000', 'temperatura', 816.0000, 'ºC'),
	(251085, 120, '2014-03-15 00:37:15.000000', 'temperatura', 829.0000, 'ºC'),
	(251086, 120, '2014-03-15 00:37:16.000000', 'temperatura', 495.0000, 'ºC'),
	(251087, 120, '2014-03-15 00:37:17.000000', 'temperatura', 1188.0000, 'ºC'),
	(251088, 120, '2014-03-15 00:37:18.000000', 'temperatura', 857.0000, 'ºC'),
	(251089, 120, '2014-03-15 00:37:19.000000', 'temperatura', 721.0000, 'ºC'),
	(251090, 120, '2014-03-15 00:37:20.000000', 'temperatura', 1036.0000, 'ºC'),
	(251091, 120, '2014-03-15 00:37:21.000000', 'temperatura', 616.0000, 'ºC'),
	(251092, 120, '2014-03-15 00:37:22.000000', 'temperatura', 1173.0000, 'ºC'),
	(251093, 120, '2014-03-15 00:37:23.000000', 'temperatura', 419.0000, 'ºC'),
	(251094, 120, '2014-03-15 00:37:24.000000', 'temperatura', 976.0000, 'ºC'),
	(251095, 120, '2014-03-15 00:37:25.000000', 'temperatura', 23.0000, 'ºC'),
	(251096, 120, '2014-03-15 00:37:26.000000', 'temperatura', 788.0000, 'ºC'),
	(251097, 120, '2014-03-15 00:37:27.000000', 'temperatura', 272.0000, 'ºC'),
	(251098, 120, '2014-03-15 00:37:28.000000', 'temperatura', 196.0000, 'ºC'),
	(251099, 120, '2014-03-15 00:37:29.000000', 'temperatura', 164.0000, 'ºC'),
	(251100, 120, '2014-03-15 00:37:30.000000', 'temperatura', 232.0000, 'ºC'),
	(251101, 120, '2014-03-15 00:37:31.000000', 'temperatura', 668.0000, 'ºC'),
	(251102, 120, '2014-03-15 00:37:32.000000', 'temperatura', 244.0000, 'ºC'),
	(251103, 120, '2014-03-15 00:37:33.000000', 'temperatura', 419.0000, 'ºC'),
	(251104, 120, '2014-03-15 00:37:34.000000', 'temperatura', 162.0000, 'ºC'),
	(251105, 120, '2014-03-15 00:37:35.000000', 'temperatura', 755.0000, 'ºC'),
	(251106, 120, '2014-03-15 00:37:36.000000', 'temperatura', 888.0000, 'ºC'),
	(251107, 120, '2014-03-15 00:37:37.000000', 'temperatura', 976.0000, 'ºC'),
	(251108, 120, '2014-03-15 00:37:38.000000', 'temperatura', 1016.0000, 'ºC'),
	(251109, 120, '2014-03-15 00:37:39.000000', 'temperatura', 952.0000, 'ºC'),
	(251110, 120, '2014-03-15 00:37:40.000000', 'temperatura', 513.0000, 'ºC'),
	(251111, 120, '2014-03-15 00:37:41.000000', 'temperatura', 911.0000, 'ºC'),
	(251112, 120, '2014-03-15 00:37:42.000000', 'temperatura', 615.0000, 'ºC'),
	(251113, 120, '2014-03-15 00:37:43.000000', 'temperatura', 341.0000, 'ºC'),
	(251114, 120, '2014-03-15 00:37:44.000000', 'temperatura', 1064.0000, 'ºC'),
	(251115, 120, '2014-03-15 00:37:45.000000', 'temperatura', 694.0000, 'ºC'),
	(251116, 120, '2014-03-15 00:37:46.000000', 'temperatura', 279.0000, 'ºC'),
	(251117, 120, '2014-03-15 00:37:47.000000', 'temperatura', 515.0000, 'ºC'),
	(251118, 120, '2014-03-15 00:37:48.000000', 'temperatura', 536.0000, 'ºC'),
	(251119, 120, '2014-03-15 00:37:49.000000', 'temperatura', 1136.0000, 'ºC'),
	(251120, 120, '2014-03-15 00:37:50.000000', 'temperatura', 472.0000, 'ºC'),
	(251121, 120, '2014-03-15 00:37:51.000000', 'temperatura', 152.0000, 'ºC'),
	(251122, 120, '2014-03-15 00:37:52.000000', 'temperatura', 544.0000, 'ºC'),
	(251123, 120, '2014-03-15 00:37:53.000000', 'temperatura', 1063.0000, 'ºC'),
	(251124, 120, '2014-03-15 00:37:54.000000', 'temperatura', 87.0000, 'ºC'),
	(251125, 120, '2014-03-15 00:37:55.000000', 'temperatura', 845.0000, 'ºC'),
	(251126, 120, '2014-03-15 00:37:56.000000', 'temperatura', 364.0000, 'ºC'),
	(251127, 120, '2014-03-15 00:37:57.000000', 'temperatura', 484.0000, 'ºC'),
	(251128, 120, '2014-03-15 00:37:58.000000', 'temperatura', 131.0000, 'ºC'),
	(251129, 120, '2014-03-15 00:37:59.000000', 'temperatura', 402.0000, 'ºC'),
	(251130, 120, '2014-03-15 00:38:00.000000', 'temperatura', 417.0000, 'ºC'),
	(251131, 120, '2014-03-15 00:38:01.000000', 'temperatura', 879.0000, 'ºC'),
	(251132, 120, '2014-03-15 00:38:02.000000', 'temperatura', 744.0000, 'ºC'),
	(251133, 120, '2014-03-15 00:38:03.000000', 'temperatura', 1083.0000, 'ºC'),
	(251134, 120, '2014-03-15 00:38:04.000000', 'temperatura', 784.0000, 'ºC'),
	(251135, 120, '2014-03-15 00:38:05.000000', 'temperatura', 672.0000, 'ºC'),
	(251136, 120, '2014-03-15 00:38:06.000000', 'temperatura', 1008.0000, 'ºC'),
	(251137, 120, '2014-03-15 00:38:07.000000', 'temperatura', 627.0000, 'ºC'),
	(251138, 120, '2014-03-15 00:38:08.000000', 'temperatura', 108.0000, 'ºC'),
	(251139, 120, '2014-03-15 00:38:09.000000', 'temperatura', 1063.0000, 'ºC'),
	(251140, 120, '2014-03-15 00:38:10.000000', 'temperatura', 189.0000, 'ºC'),
	(251141, 120, '2014-03-15 00:38:11.000000', 'temperatura', 158.0000, 'ºC'),
	(251142, 120, '2014-03-15 00:38:12.000000', 'temperatura', 224.0000, 'ºC'),
	(251143, 120, '2014-03-15 00:38:13.000000', 'temperatura', 647.0000, 'ºC'),
	(251144, 120, '2014-03-15 00:38:14.000000', 'temperatura', 164.0000, 'ºC'),
	(251145, 120, '2014-03-15 00:38:15.000000', 'temperatura', 80.0000, 'ºC'),
	(251146, 120, '2014-03-15 00:38:16.000000', 'temperatura', 1110.0000, 'ºC'),
	(251147, 120, '2014-03-15 00:38:17.000000', 'temperatura', 507.0000, 'ºC'),
	(251148, 120, '2014-03-15 00:38:18.000000', 'temperatura', 408.0000, 'ºC'),
	(251149, 120, '2014-03-15 00:38:19.000000', 'temperatura', 517.0000, 'ºC'),
	(251150, 120, '2014-03-15 00:38:20.000000', 'temperatura', 161.0000, 'ºC'),
	(251151, 120, '2014-03-15 00:38:21.000000', 'temperatura', 457.0000, 'ºC'),
	(251152, 120, '2014-03-15 00:38:22.000000', 'temperatura', 600.0000, 'ºC'),
	(251153, 120, '2014-03-15 00:38:23.000000', 'temperatura', 430.0000, 'ºC'),
	(251154, 120, '2014-03-15 00:38:24.000000', 'temperatura', 350.0000, 'ºC'),
	(251155, 120, '2014-03-15 00:38:25.000000', 'temperatura', 460.0000, 'ºC'),
	(251156, 120, '2014-03-15 00:38:26.000000', 'temperatura', 51.0000, 'ºC'),
	(251157, 120, '2014-03-15 00:38:27.000000', 'temperatura', 77.0000, 'ºC'),
	(251158, 120, '2014-03-15 00:38:28.000000', 'temperatura', 232.0000, 'ºC'),
	(251159, 120, '2014-03-15 00:38:29.000000', 'temperatura', 929.0000, 'ºC'),
	(251160, 120, '2014-03-15 00:38:30.000000', 'temperatura', 350.0000, 'ºC'),
	(251161, 120, '2014-03-15 00:38:31.000000', 'temperatura', 165.0000, 'ºC'),
	(251162, 120, '2014-03-15 00:38:32.000000', 'temperatura', 976.0000, 'ºC'),
	(251163, 120, '2014-03-15 00:38:33.000000', 'temperatura', 783.0000, 'ºC'),
	(251164, 120, '2014-03-15 00:38:34.000000', 'temperatura', 988.0000, 'ºC'),
	(251165, 120, '2014-03-15 00:38:35.000000', 'temperatura', 194.0000, 'ºC'),
	(251166, 120, '2014-03-15 00:38:36.000000', 'temperatura', 403.0000, 'ºC'),
	(251167, 120, '2014-03-15 00:38:37.000000', 'temperatura', 235.0000, 'ºC'),
	(251168, 120, '2014-03-15 00:38:38.000000', 'temperatura', 1165.0000, 'ºC'),
	(251169, 120, '2014-03-15 00:38:39.000000', 'temperatura', 320.0000, 'ºC'),
	(251170, 120, '2014-03-15 00:38:40.000000', 'temperatura', 507.0000, 'ºC'),
	(251171, 120, '2014-03-15 00:38:41.000000', 'temperatura', 376.0000, 'ºC'),
	(251172, 120, '2014-03-15 00:38:42.000000', 'temperatura', 357.0000, 'ºC'),
	(251173, 120, '2014-03-15 00:38:43.000000', 'temperatura', 660.0000, 'ºC'),
	(251174, 120, '2014-03-15 00:38:44.000000', 'temperatura', 1030.0000, 'ºC'),
	(251175, 120, '2014-03-15 00:38:45.000000', 'temperatura', 771.0000, 'ºC'),
	(251176, 120, '2014-03-15 00:38:46.000000', 'temperatura', 763.0000, 'ºC'),
	(251177, 120, '2014-03-15 00:38:47.000000', 'temperatura', 302.0000, 'ºC'),
	(251178, 120, '2014-03-15 00:38:48.000000', 'temperatura', 421.0000, 'ºC'),
	(251179, 120, '2014-03-15 00:38:49.000000', 'temperatura', 1.0000, 'ºC'),
	(251180, 120, '2014-03-15 00:38:50.000000', 'temperatura', 1141.0000, 'ºC'),
	(251181, 120, '2014-03-15 00:38:51.000000', 'temperatura', 901.0000, 'ºC'),
	(251182, 120, '2014-03-15 00:38:52.000000', 'temperatura', 1086.0000, 'ºC'),
	(251183, 120, '2014-03-15 00:38:53.000000', 'temperatura', 327.0000, 'ºC'),
	(251184, 120, '2014-03-15 00:38:54.000000', 'temperatura', 778.0000, 'ºC'),
	(251185, 120, '2014-03-15 00:38:55.000000', 'temperatura', 511.0000, 'ºC'),
	(251186, 120, '2014-03-15 00:38:56.000000', 'temperatura', 218.0000, 'ºC'),
	(251187, 120, '2014-03-15 00:38:57.000000', 'temperatura', 760.0000, 'ºC'),
	(251188, 120, '2014-03-15 00:38:58.000000', 'temperatura', 747.0000, 'ºC'),
	(251189, 120, '2014-03-15 00:38:59.000000', 'temperatura', 257.0000, 'ºC'),
	(251190, 120, '2014-03-15 00:39:00.000000', 'temperatura', 241.0000, 'ºC'),
	(251191, 120, '2014-03-15 00:39:01.000000', 'temperatura', 437.0000, 'ºC'),
	(251192, 120, '2014-03-15 00:39:02.000000', 'temperatura', 263.0000, 'ºC'),
	(251193, 120, '2014-03-15 00:39:03.000000', 'temperatura', 4.0000, 'ºC'),
	(251194, 120, '2014-03-15 00:39:04.000000', 'temperatura', 433.0000, 'ºC'),
	(251195, 120, '2014-03-15 00:39:05.000000', 'temperatura', 950.0000, 'ºC'),
	(251196, 120, '2014-03-15 00:39:06.000000', 'temperatura', 1055.0000, 'ºC'),
	(251197, 120, '2014-03-15 00:39:07.000000', 'temperatura', 25.0000, 'ºC'),
	(251198, 120, '2014-03-15 00:39:08.000000', 'temperatura', 558.0000, 'ºC'),
	(251199, 120, '2014-03-15 00:39:09.000000', 'temperatura', 319.0000, 'ºC'),
	(251200, 120, '2014-03-15 00:39:10.000000', 'temperatura', 1119.0000, 'ºC'),
	(251201, 120, '2014-03-15 00:39:11.000000', 'temperatura', 1038.0000, 'ºC'),
	(251202, 120, '2014-03-15 00:39:12.000000', 'temperatura', 634.0000, 'ºC'),
	(251203, 120, '2014-03-15 00:39:13.000000', 'temperatura', 56.0000, 'ºC'),
	(251204, 120, '2014-03-15 00:39:14.000000', 'temperatura', 779.0000, 'ºC'),
	(251205, 120, '2014-03-15 00:39:15.000000', 'temperatura', 128.0000, 'ºC'),
	(251206, 120, '2014-03-15 00:39:16.000000', 'temperatura', 703.0000, 'ºC'),
	(251207, 120, '2014-03-15 00:39:17.000000', 'temperatura', 732.0000, 'ºC'),
	(251208, 120, '2014-03-15 00:39:18.000000', 'temperatura', 353.0000, 'ºC'),
	(251209, 120, '2014-03-15 00:39:19.000000', 'temperatura', 767.0000, 'ºC'),
	(251210, 120, '2014-03-15 00:39:20.000000', 'temperatura', 378.0000, 'ºC'),
	(251211, 120, '2014-03-15 00:39:21.000000', 'temperatura', 787.0000, 'ºC'),
	(251212, 120, '2014-03-15 00:39:22.000000', 'temperatura', 405.0000, 'ºC'),
	(251213, 120, '2014-03-15 00:39:23.000000', 'temperatura', 861.0000, 'ºC'),
	(251214, 120, '2014-03-15 00:39:24.000000', 'temperatura', 693.0000, 'ºC'),
	(251215, 120, '2014-03-15 00:39:25.000000', 'temperatura', 881.0000, 'ºC'),
	(251216, 120, '2014-03-15 00:39:26.000000', 'temperatura', 1126.0000, 'ºC'),
	(251217, 120, '2014-03-15 00:39:27.000000', 'temperatura', 586.0000, 'ºC'),
	(251218, 120, '2014-03-15 00:39:28.000000', 'temperatura', 755.0000, 'ºC'),
	(251219, 120, '2014-03-15 00:39:29.000000', 'temperatura', 816.0000, 'ºC'),
	(251220, 120, '2014-03-15 00:39:30.000000', 'temperatura', 615.0000, 'ºC'),
	(251221, 120, '2014-03-15 00:39:31.000000', 'temperatura', 627.0000, 'ºC'),
	(251222, 120, '2014-03-15 00:39:32.000000', 'temperatura', 90.0000, 'ºC'),
	(251223, 120, '2014-03-15 00:39:33.000000', 'temperatura', 968.0000, 'ºC'),
	(251224, 120, '2014-03-15 00:39:34.000000', 'temperatura', 974.0000, 'ºC'),
	(251225, 120, '2014-03-15 00:39:35.000000', 'temperatura', 764.0000, 'ºC'),
	(251226, 120, '2014-03-15 00:39:36.000000', 'temperatura', 900.0000, 'ºC'),
	(251227, 120, '2014-03-15 00:39:37.000000', 'temperatura', 1006.0000, 'ºC'),
	(251228, 120, '2014-03-15 00:39:38.000000', 'temperatura', 1133.0000, 'ºC'),
	(251229, 120, '2014-03-15 00:39:39.000000', 'temperatura', 248.0000, 'ºC'),
	(251230, 120, '2014-03-15 00:39:40.000000', 'temperatura', 240.0000, 'ºC'),
	(251231, 120, '2014-03-15 00:39:41.000000', 'temperatura', 457.0000, 'ºC'),
	(251232, 120, '2014-03-15 00:39:42.000000', 'temperatura', 366.0000, 'ºC'),
	(251233, 120, '2014-03-15 00:39:43.000000', 'temperatura', 460.0000, 'ºC'),
	(251234, 120, '2014-03-15 00:39:44.000000', 'temperatura', 0.0000, 'ºC'),
	(251235, 120, '2014-03-15 00:39:45.000000', 'temperatura', 1024.0000, 'ºC'),
	(251236, 120, '2014-03-15 00:39:46.000000', 'temperatura', 318.0000, 'ºC'),
	(251237, 120, '2014-03-15 00:39:47.000000', 'temperatura', 917.0000, 'ºC'),
	(251238, 120, '2014-03-15 00:39:48.000000', 'temperatura', 35.0000, 'ºC'),
	(251239, 120, '2014-03-15 00:39:49.000000', 'temperatura', 1021.0000, 'ºC'),
	(251240, 120, '2014-03-15 00:39:50.000000', 'temperatura', 202.0000, 'ºC'),
	(251241, 120, '2014-03-15 00:39:51.000000', 'temperatura', 347.0000, 'ºC'),
	(251242, 120, '2014-03-15 00:39:52.000000', 'temperatura', 1130.0000, 'ºC'),
	(251243, 120, '2014-03-15 00:39:53.000000', 'temperatura', 1009.0000, 'ºC'),
	(251244, 120, '2014-03-15 00:39:54.000000', 'temperatura', 456.0000, 'ºC'),
	(251245, 120, '2014-03-15 00:39:55.000000', 'temperatura', 454.0000, 'ºC'),
	(251246, 120, '2014-03-15 00:39:56.000000', 'temperatura', 903.0000, 'ºC'),
	(251247, 120, '2014-03-15 00:39:57.000000', 'temperatura', 753.0000, 'ºC'),
	(251248, 120, '2014-03-15 00:39:58.000000', 'temperatura', 1057.0000, 'ºC'),
	(251249, 120, '2014-03-15 00:39:59.000000', 'temperatura', 625.0000, 'ºC'),
	(251250, 120, '2014-03-15 00:40:00.000000', 'temperatura', 1153.0000, 'ºC'),
	(251251, 120, '2014-03-15 00:40:01.000000', 'temperatura', 294.0000, 'ºC'),
	(251252, 120, '2014-03-15 00:40:02.000000', 'temperatura', 409.0000, 'ºC'),
	(251253, 120, '2014-03-15 00:40:03.000000', 'temperatura', 1165.0000, 'ºC'),
	(251254, 120, '2014-03-15 00:40:04.000000', 'temperatura', 996.0000, 'ºC'),
	(251255, 120, '2014-03-15 00:40:05.000000', 'temperatura', 288.0000, 'ºC'),
	(251256, 120, '2014-03-15 00:40:06.000000', 'temperatura', 852.0000, 'ºC'),
	(251257, 120, '2014-03-15 00:40:07.000000', 'temperatura', 996.0000, 'ºC'),
	(251258, 120, '2014-03-15 00:40:08.000000', 'temperatura', 27.0000, 'ºC'),
	(251259, 120, '2014-03-15 00:40:09.000000', 'temperatura', 745.0000, 'ºC'),
	(251260, 120, '2014-03-15 00:40:10.000000', 'temperatura', 46.0000, 'ºC'),
	(251261, 120, '2014-03-15 00:40:11.000000', 'temperatura', 397.0000, 'ºC'),
	(251262, 120, '2014-03-15 00:40:12.000000', 'temperatura', 646.0000, 'ºC'),
	(251263, 120, '2014-03-15 00:40:13.000000', 'temperatura', 841.0000, 'ºC'),
	(251264, 120, '2014-03-15 00:40:14.000000', 'temperatura', 1064.0000, 'ºC'),
	(251265, 120, '2014-03-15 00:40:15.000000', 'temperatura', 401.0000, 'ºC'),
	(251266, 120, '2014-03-15 00:40:16.000000', 'temperatura', 13.0000, 'ºC'),
	(251267, 120, '2014-03-15 00:40:17.000000', 'temperatura', 64.0000, 'ºC'),
	(251268, 120, '2014-03-15 00:40:18.000000', 'temperatura', 278.0000, 'ºC'),
	(251269, 120, '2014-03-15 00:40:19.000000', 'temperatura', 0.0000, 'ºC'),
	(251270, 120, '2014-03-15 00:40:20.000000', 'temperatura', 368.0000, 'ºC'),
	(251271, 120, '2014-03-15 00:40:21.000000', 'temperatura', 640.0000, 'ºC'),
	(251272, 120, '2014-03-15 00:40:22.000000', 'temperatura', 895.0000, 'ºC'),
	(251273, 120, '2014-03-15 00:40:23.000000', 'temperatura', 158.0000, 'ºC'),
	(251274, 120, '2014-03-15 00:40:24.000000', 'temperatura', 506.0000, 'ºC'),
	(251275, 120, '2014-03-15 00:40:25.000000', 'temperatura', 853.0000, 'ºC'),
	(251276, 120, '2014-03-15 00:40:26.000000', 'temperatura', 350.0000, 'ºC'),
	(251277, 120, '2014-03-15 00:40:27.000000', 'temperatura', 393.0000, 'ºC'),
	(251278, 120, '2014-03-15 00:40:28.000000', 'temperatura', 912.0000, 'ºC'),
	(251279, 120, '2014-03-15 00:40:29.000000', 'temperatura', 985.0000, 'ºC'),
	(251280, 120, '2014-03-15 00:40:30.000000', 'temperatura', 988.0000, 'ºC'),
	(251281, 120, '2014-03-15 00:40:31.000000', 'temperatura', 784.0000, 'ºC'),
	(251282, 120, '2014-03-15 00:40:32.000000', 'temperatura', 957.0000, 'ºC'),
	(251283, 120, '2014-03-15 00:40:33.000000', 'temperatura', 36.0000, 'ºC'),
	(251284, 120, '2014-03-15 00:40:34.000000', 'temperatura', 907.0000, 'ºC'),
	(251285, 120, '2014-03-15 00:40:35.000000', 'temperatura', 827.0000, 'ºC'),
	(251286, 120, '2014-03-15 00:40:36.000000', 'temperatura', 214.0000, 'ºC'),
	(251287, 120, '2014-03-15 00:40:37.000000', 'temperatura', 989.0000, 'ºC'),
	(251288, 120, '2014-03-15 00:40:38.000000', 'temperatura', 707.0000, 'ºC'),
	(251289, 120, '2014-03-15 00:40:39.000000', 'temperatura', 565.0000, 'ºC'),
	(251290, 120, '2014-03-15 00:40:40.000000', 'temperatura', 705.0000, 'ºC'),
	(251291, 120, '2014-03-15 00:40:41.000000', 'temperatura', 632.0000, 'ºC'),
	(251292, 120, '2014-03-15 00:40:42.000000', 'temperatura', 1045.0000, 'ºC'),
	(251293, 120, '2014-03-15 00:40:43.000000', 'temperatura', 930.0000, 'ºC'),
	(251294, 120, '2014-03-15 00:40:44.000000', 'temperatura', 315.0000, 'ºC'),
	(251295, 120, '2014-03-15 00:40:45.000000', 'temperatura', 1184.0000, 'ºC'),
	(251296, 120, '2014-03-15 00:40:46.000000', 'temperatura', 177.0000, 'ºC'),
	(251297, 120, '2014-03-15 00:40:47.000000', 'temperatura', 932.0000, 'ºC'),
	(251298, 120, '2014-03-15 00:40:48.000000', 'temperatura', 529.0000, 'ºC'),
	(251299, 120, '2014-03-15 00:40:49.000000', 'temperatura', 1049.0000, 'ºC'),
	(251300, 120, '2014-03-15 00:40:50.000000', 'temperatura', 59.0000, 'ºC'),
	(251301, 120, '2014-03-15 00:40:51.000000', 'temperatura', 751.0000, 'ºC'),
	(251302, 120, '2014-03-15 00:40:52.000000', 'temperatura', 1176.0000, 'ºC'),
	(251303, 120, '2014-03-15 00:40:53.000000', 'temperatura', 28.0000, 'ºC'),
	(251304, 120, '2014-03-15 00:40:54.000000', 'temperatura', 213.0000, 'ºC'),
	(251305, 120, '2014-03-15 00:40:55.000000', 'temperatura', 983.0000, 'ºC'),
	(251306, 120, '2014-03-15 00:40:56.000000', 'temperatura', 677.0000, 'ºC'),
	(251307, 120, '2014-03-15 00:40:57.000000', 'temperatura', 434.0000, 'ºC'),
	(251308, 120, '2014-03-15 00:40:58.000000', 'temperatura', 142.0000, 'ºC'),
	(251309, 120, '2014-03-15 00:40:59.000000', 'temperatura', 609.0000, 'ºC'),
	(251310, 120, '2014-03-15 00:41:00.000000', 'temperatura', 217.0000, 'ºC'),
	(251311, 120, '2014-03-15 00:41:01.000000', 'temperatura', 461.0000, 'ºC'),
	(251312, 120, '2014-03-15 00:41:02.000000', 'temperatura', 452.0000, 'ºC'),
	(251313, 120, '2014-03-15 00:41:03.000000', 'temperatura', 879.0000, 'ºC'),
	(251314, 120, '2014-03-15 00:41:04.000000', 'temperatura', 641.0000, 'ºC'),
	(251315, 120, '2014-03-15 00:41:05.000000', 'temperatura', 567.0000, 'ºC'),
	(251316, 120, '2014-03-15 00:41:06.000000', 'temperatura', 912.0000, 'ºC'),
	(251317, 120, '2014-03-15 00:41:07.000000', 'temperatura', 459.0000, 'ºC'),
	(251318, 120, '2014-03-15 00:41:08.000000', 'temperatura', 758.0000, 'ºC'),
	(251319, 120, '2014-03-15 00:41:09.000000', 'temperatura', 15.0000, 'ºC'),
	(251320, 120, '2014-03-15 00:41:10.000000', 'temperatura', 203.0000, 'ºC'),
	(251321, 120, '2014-03-15 00:41:11.000000', 'temperatura', 969.0000, 'ºC'),
	(251322, 120, '2014-03-15 00:41:12.000000', 'temperatura', 638.0000, 'ºC'),
	(251323, 120, '2014-03-15 00:41:13.000000', 'temperatura', 282.0000, 'ºC'),
	(251324, 120, '2014-03-15 00:41:14.000000', 'temperatura', 697.0000, 'ºC'),
	(251325, 120, '2014-03-15 00:41:15.000000', 'temperatura', 240.0000, 'ºC'),
	(251326, 120, '2014-03-15 00:41:16.000000', 'temperatura', 310.0000, 'ºC'),
	(251327, 120, '2014-03-15 00:41:17.000000', 'temperatura', 830.0000, 'ºC'),
	(251328, 120, '2014-03-15 00:41:18.000000', 'temperatura', 822.0000, 'ºC'),
	(251329, 120, '2014-03-15 00:41:19.000000', 'temperatura', 417.0000, 'ºC'),
	(251330, 120, '2014-03-15 00:41:20.000000', 'temperatura', 823.0000, 'ºC'),
	(251331, 120, '2014-03-15 00:41:21.000000', 'temperatura', 464.0000, 'ºC'),
	(251332, 120, '2014-03-15 00:41:22.000000', 'temperatura', 1050.0000, 'ºC'),
	(251333, 120, '2014-03-15 00:41:23.000000', 'temperatura', 259.0000, 'ºC'),
	(251334, 120, '2014-03-15 00:41:24.000000', 'temperatura', 544.0000, 'ºC'),
	(251335, 120, '2014-03-15 00:41:25.000000', 'temperatura', 746.0000, 'ºC'),
	(251336, 120, '2014-03-15 00:41:26.000000', 'temperatura', 896.0000, 'ºC'),
	(251337, 120, '2014-03-15 00:41:27.000000', 'temperatura', 1042.0000, 'ºC'),
	(251338, 120, '2014-03-15 00:41:28.000000', 'temperatura', 123.0000, 'ºC'),
	(251339, 120, '2014-03-15 00:41:29.000000', 'temperatura', 1091.0000, 'ºC'),
	(251340, 120, '2014-03-15 00:41:30.000000', 'temperatura', 288.0000, 'ºC'),
	(251341, 120, '2014-03-15 00:41:31.000000', 'temperatura', 565.0000, 'ºC'),
	(251342, 120, '2014-03-15 00:41:32.000000', 'temperatura', 764.0000, 'ºC'),
	(251343, 120, '2014-03-15 00:41:33.000000', 'temperatura', 923.0000, 'ºC'),
	(251344, 120, '2014-03-15 00:41:34.000000', 'temperatura', 1125.0000, 'ºC'),
	(251345, 120, '2014-03-15 00:41:35.000000', 'temperatura', 456.0000, 'ºC'),
	(251346, 120, '2014-03-15 00:41:36.000000', 'temperatura', 107.0000, 'ºC'),
	(251347, 120, '2014-03-15 00:41:37.000000', 'temperatura', 367.0000, 'ºC'),
	(251348, 120, '2014-03-15 00:41:38.000000', 'temperatura', 315.0000, 'ºC'),
	(251349, 120, '2014-03-15 00:41:39.000000', 'temperatura', 475.0000, 'ºC'),
	(251350, 120, '2014-03-15 00:41:40.000000', 'temperatura', 229.0000, 'ºC'),
	(251351, 120, '2014-03-15 00:41:41.000000', 'temperatura', 920.0000, 'ºC'),
	(251352, 120, '2014-03-15 00:41:42.000000', 'temperatura', 313.0000, 'ºC'),
	(251353, 120, '2014-03-15 00:41:43.000000', 'temperatura', 6.0000, 'ºC'),
	(251354, 120, '2014-03-15 00:41:44.000000', 'temperatura', 290.0000, 'ºC'),
	(251355, 120, '2014-03-15 00:41:45.000000', 'temperatura', 234.0000, 'ºC'),
	(251356, 120, '2014-03-15 00:41:46.000000', 'temperatura', 302.0000, 'ºC'),
	(251357, 120, '2014-03-15 00:41:47.000000', 'temperatura', 806.0000, 'ºC'),
	(251358, 120, '2014-03-15 00:41:48.000000', 'temperatura', 724.0000, 'ºC'),
	(251359, 120, '2014-03-15 00:41:49.000000', 'temperatura', 2.0000, 'ºC'),
	(251360, 120, '2014-03-15 00:41:50.000000', 'temperatura', 241.0000, 'ºC'),
	(251361, 120, '2014-03-15 00:41:51.000000', 'temperatura', 1199.0000, 'ºC'),
	(251362, 120, '2014-03-15 00:41:52.000000', 'temperatura', 474.0000, 'ºC'),
	(251363, 120, '2014-03-15 00:41:53.000000', 'temperatura', 1173.0000, 'ºC'),
	(251364, 120, '2014-03-15 00:41:54.000000', 'temperatura', 843.0000, 'ºC'),
	(251365, 120, '2014-03-15 00:41:55.000000', 'temperatura', 695.0000, 'ºC'),
	(251366, 120, '2014-03-15 00:41:56.000000', 'temperatura', 947.0000, 'ºC'),
	(251367, 120, '2014-03-15 00:41:57.000000', 'temperatura', 250.0000, 'ºC'),
	(251368, 120, '2014-03-15 00:41:58.000000', 'temperatura', 810.0000, 'ºC'),
	(251369, 120, '2014-03-15 00:41:59.000000', 'temperatura', 902.0000, 'ºC'),
	(251370, 120, '2014-03-15 00:42:00.000000', 'temperatura', 881.0000, 'ºC'),
	(251371, 120, '2014-03-15 00:42:01.000000', 'temperatura', 499.0000, 'ºC'),
	(251372, 120, '2014-03-15 00:42:02.000000', 'temperatura', 1052.0000, 'ºC'),
	(251373, 120, '2014-03-15 00:42:03.000000', 'temperatura', 164.0000, 'ºC'),
	(251374, 120, '2014-03-15 00:42:04.000000', 'temperatura', 66.0000, 'ºC'),
	(251375, 120, '2014-03-15 00:42:05.000000', 'temperatura', 1039.0000, 'ºC'),
	(251376, 120, '2014-03-15 00:42:06.000000', 'temperatura', 195.0000, 'ºC'),
	(251377, 120, '2014-03-15 00:42:07.000000', 'temperatura', 260.0000, 'ºC'),
	(251378, 120, '2014-03-15 00:42:08.000000', 'temperatura', 715.0000, 'ºC'),
	(251379, 120, '2014-03-15 00:42:09.000000', 'temperatura', 397.0000, 'ºC'),
	(251380, 120, '2014-03-15 00:42:10.000000', 'temperatura', 1041.0000, 'ºC'),
	(251381, 120, '2014-03-15 00:42:11.000000', 'temperatura', 415.0000, 'ºC'),
	(251382, 120, '2014-03-15 00:42:12.000000', 'temperatura', 151.0000, 'ºC'),
	(251383, 120, '2014-03-15 00:42:13.000000', 'temperatura', 709.0000, 'ºC'),
	(251384, 120, '2014-03-15 00:42:14.000000', 'temperatura', 693.0000, 'ºC'),
	(251385, 120, '2014-03-15 00:42:15.000000', 'temperatura', 141.0000, 'ºC'),
	(251386, 120, '2014-03-15 00:42:16.000000', 'temperatura', 1025.0000, 'ºC'),
	(251387, 120, '2014-03-15 00:42:17.000000', 'temperatura', 1101.0000, 'ºC'),
	(251388, 120, '2014-03-15 00:42:18.000000', 'temperatura', 32.0000, 'ºC'),
	(251389, 120, '2014-03-15 00:42:19.000000', 'temperatura', 458.0000, 'ºC'),
	(251390, 120, '2014-03-15 00:42:20.000000', 'temperatura', 996.0000, 'ºC'),
	(251391, 120, '2014-03-15 00:42:21.000000', 'temperatura', 5.0000, 'ºC'),
	(251392, 120, '2014-03-15 00:42:22.000000', 'temperatura', 636.0000, 'ºC'),
	(251393, 120, '2014-03-15 00:42:23.000000', 'temperatura', 766.0000, 'ºC'),
	(251394, 120, '2014-03-15 00:42:24.000000', 'temperatura', 723.0000, 'ºC'),
	(251395, 120, '2014-03-15 00:42:25.000000', 'temperatura', 116.0000, 'ºC'),
	(251396, 120, '2014-03-15 00:42:26.000000', 'temperatura', 811.0000, 'ºC'),
	(251397, 120, '2014-03-15 00:42:27.000000', 'temperatura', 108.0000, 'ºC'),
	(251398, 120, '2014-03-15 00:42:28.000000', 'temperatura', 510.0000, 'ºC'),
	(251399, 120, '2014-03-15 00:42:29.000000', 'temperatura', 1023.0000, 'ºC'),
	(251400, 120, '2014-03-15 00:42:30.000000', 'temperatura', 1187.0000, 'ºC'),
	(251401, 120, '2014-03-15 00:42:31.000000', 'temperatura', 466.0000, 'ºC'),
	(251402, 120, '2014-03-15 00:42:32.000000', 'temperatura', 1171.0000, 'ºC'),
	(251403, 120, '2014-03-15 00:42:33.000000', 'temperatura', 857.0000, 'ºC'),
	(251404, 120, '2014-03-15 00:42:34.000000', 'temperatura', 772.0000, 'ºC'),
	(251405, 120, '2014-03-15 00:42:35.000000', 'temperatura', 88.0000, 'ºC'),
	(251406, 120, '2014-03-15 00:42:36.000000', 'temperatura', 528.0000, 'ºC'),
	(251407, 120, '2014-03-15 00:42:37.000000', 'temperatura', 1173.0000, 'ºC'),
	(251408, 120, '2014-03-15 00:42:38.000000', 'temperatura', 683.0000, 'ºC'),
	(251409, 120, '2014-03-15 00:42:39.000000', 'temperatura', 1097.0000, 'ºC'),
	(251410, 120, '2014-03-15 00:42:40.000000', 'temperatura', 1037.0000, 'ºC'),
	(251411, 120, '2014-03-15 00:42:41.000000', 'temperatura', 693.0000, 'ºC'),
	(251412, 120, '2014-03-15 00:42:42.000000', 'temperatura', 355.0000, 'ºC'),
	(251413, 120, '2014-03-15 00:42:43.000000', 'temperatura', 895.0000, 'ºC'),
	(251414, 120, '2014-03-15 00:42:44.000000', 'temperatura', 1012.0000, 'ºC'),
	(251415, 120, '2014-03-15 00:42:45.000000', 'temperatura', 1173.0000, 'ºC'),
	(251416, 120, '2014-03-15 00:42:46.000000', 'temperatura', 433.0000, 'ºC'),
	(251417, 120, '2014-03-15 00:42:47.000000', 'temperatura', 1045.0000, 'ºC'),
	(251418, 120, '2014-03-15 00:42:48.000000', 'temperatura', 328.0000, 'ºC'),
	(251419, 120, '2014-03-15 00:42:49.000000', 'temperatura', 906.0000, 'ºC'),
	(251420, 120, '2014-03-15 00:42:50.000000', 'temperatura', 1147.0000, 'ºC'),
	(251421, 120, '2014-03-15 00:42:51.000000', 'temperatura', 616.0000, 'ºC'),
	(251422, 120, '2014-03-15 00:42:52.000000', 'temperatura', 839.0000, 'ºC'),
	(251423, 120, '2014-03-15 00:42:53.000000', 'temperatura', 1147.0000, 'ºC'),
	(251424, 120, '2014-03-15 00:42:54.000000', 'temperatura', 820.0000, 'ºC'),
	(251425, 120, '2014-03-15 00:42:55.000000', 'temperatura', 661.0000, 'ºC'),
	(251426, 120, '2014-03-15 00:42:56.000000', 'temperatura', 843.0000, 'ºC'),
	(251427, 120, '2014-03-15 00:42:57.000000', 'temperatura', 1032.0000, 'ºC'),
	(251428, 120, '2014-03-15 00:42:58.000000', 'temperatura', 232.0000, 'ºC'),
	(251429, 120, '2014-03-15 00:42:59.000000', 'temperatura', 465.0000, 'ºC'),
	(251430, 120, '2014-03-15 00:43:00.000000', 'temperatura', 429.0000, 'ºC'),
	(251431, 120, '2014-03-15 00:43:01.000000', 'temperatura', 751.0000, 'ºC'),
	(251432, 120, '2014-03-15 00:43:02.000000', 'temperatura', 70.0000, 'ºC'),
	(251433, 120, '2014-03-15 00:43:03.000000', 'temperatura', 498.0000, 'ºC'),
	(251434, 120, '2014-03-15 00:43:04.000000', 'temperatura', 1078.0000, 'ºC'),
	(251435, 120, '2014-03-15 00:43:05.000000', 'temperatura', 299.0000, 'ºC'),
	(251436, 120, '2014-03-15 00:43:06.000000', 'temperatura', 659.0000, 'ºC'),
	(251437, 120, '2014-03-15 00:43:07.000000', 'temperatura', 1199.0000, 'ºC'),
	(251438, 120, '2014-03-15 00:43:08.000000', 'temperatura', 418.0000, 'ºC'),
	(251439, 120, '2014-03-15 00:43:09.000000', 'temperatura', 895.0000, 'ºC'),
	(251440, 120, '2014-03-15 00:43:10.000000', 'temperatura', 822.0000, 'ºC'),
	(251441, 120, '2014-03-15 00:43:11.000000', 'temperatura', 226.0000, 'ºC'),
	(251442, 120, '2014-03-15 00:43:12.000000', 'temperatura', 1062.0000, 'ºC'),
	(251443, 120, '2014-03-15 00:43:13.000000', 'temperatura', 1032.0000, 'ºC'),
	(251444, 120, '2014-03-15 00:43:14.000000', 'temperatura', 774.0000, 'ºC'),
	(251445, 120, '2014-03-15 00:43:15.000000', 'temperatura', 775.0000, 'ºC'),
	(251446, 120, '2014-03-15 00:43:16.000000', 'temperatura', 355.0000, 'ºC'),
	(251447, 120, '2014-03-15 00:43:17.000000', 'temperatura', 649.0000, 'ºC'),
	(251448, 120, '2014-03-15 00:43:18.000000', 'temperatura', 981.0000, 'ºC'),
	(251449, 120, '2014-03-15 00:43:19.000000', 'temperatura', 560.0000, 'ºC'),
	(251450, 120, '2014-03-15 00:43:20.000000', 'temperatura', 1055.0000, 'ºC'),
	(251451, 120, '2014-03-15 00:43:21.000000', 'temperatura', 1196.0000, 'ºC'),
	(251452, 120, '2014-03-15 00:43:22.000000', 'temperatura', 414.0000, 'ºC'),
	(251453, 120, '2014-03-15 00:43:23.000000', 'temperatura', 883.0000, 'ºC'),
	(251454, 120, '2014-03-15 00:43:24.000000', 'temperatura', 775.0000, 'ºC'),
	(251455, 120, '2014-03-15 00:43:25.000000', 'temperatura', 26.0000, 'ºC'),
	(251456, 120, '2014-03-15 00:43:26.000000', 'temperatura', 206.0000, 'ºC'),
	(251457, 120, '2014-03-15 00:43:27.000000', 'temperatura', 951.0000, 'ºC'),
	(251458, 120, '2014-03-15 00:43:28.000000', 'temperatura', 540.0000, 'ºC'),
	(251459, 120, '2014-03-15 00:43:29.000000', 'temperatura', 1046.0000, 'ºC'),
	(251460, 120, '2014-03-15 00:43:30.000000', 'temperatura', 9.0000, 'ºC'),
	(251461, 120, '2014-03-15 00:43:31.000000', 'temperatura', 507.0000, 'ºC'),
	(251462, 120, '2014-03-15 00:43:32.000000', 'temperatura', 112.0000, 'ºC'),
	(251463, 120, '2014-03-15 00:43:33.000000', 'temperatura', 237.0000, 'ºC'),
	(251464, 120, '2014-03-15 00:43:34.000000', 'temperatura', 848.0000, 'ºC'),
	(251465, 120, '2014-03-15 00:43:35.000000', 'temperatura', 1133.0000, 'ºC'),
	(251466, 120, '2014-03-15 00:43:36.000000', 'temperatura', 719.0000, 'ºC'),
	(251467, 120, '2014-03-15 00:43:37.000000', 'temperatura', 196.0000, 'ºC'),
	(251468, 120, '2014-03-15 00:43:38.000000', 'temperatura', 26.0000, 'ºC'),
	(251469, 120, '2014-03-15 00:43:39.000000', 'temperatura', 739.0000, 'ºC'),
	(251470, 120, '2014-03-15 00:43:40.000000', 'temperatura', 21.0000, 'ºC'),
	(251471, 120, '2014-03-15 00:43:41.000000', 'temperatura', 286.0000, 'ºC'),
	(251472, 120, '2014-03-15 00:43:42.000000', 'temperatura', 168.0000, 'ºC'),
	(251473, 120, '2014-03-15 00:43:43.000000', 'temperatura', 1181.0000, 'ºC'),
	(251474, 120, '2014-03-15 00:43:44.000000', 'temperatura', 602.0000, 'ºC'),
	(251475, 120, '2014-03-15 00:43:45.000000', 'temperatura', 668.0000, 'ºC'),
	(251476, 120, '2014-03-15 00:43:46.000000', 'temperatura', 335.0000, 'ºC'),
	(251477, 120, '2014-03-15 00:43:47.000000', 'temperatura', 872.0000, 'ºC'),
	(251478, 120, '2014-03-15 00:43:48.000000', 'temperatura', 956.0000, 'ºC'),
	(251479, 120, '2014-03-15 00:43:49.000000', 'temperatura', 965.0000, 'ºC'),
	(251480, 120, '2014-03-15 00:43:50.000000', 'temperatura', 758.0000, 'ºC'),
	(251481, 120, '2014-03-15 00:43:51.000000', 'temperatura', 896.0000, 'ºC'),
	(251482, 120, '2014-03-15 00:43:52.000000', 'temperatura', 1007.0000, 'ºC'),
	(251483, 120, '2014-03-15 00:43:53.000000', 'temperatura', 1148.0000, 'ºC'),
	(251484, 120, '2014-03-15 00:43:54.000000', 'temperatura', 319.0000, 'ºC'),
	(251485, 120, '2014-03-15 00:43:55.000000', 'temperatura', 551.0000, 'ºC'),
	(251486, 120, '2014-03-15 00:43:56.000000', 'temperatura', 600.0000, 'ºC'),
	(251487, 120, '2014-03-15 00:43:57.000000', 'temperatura', 147.0000, 'ºC'),
	(251488, 120, '2014-03-15 00:43:58.000000', 'temperatura', 134.0000, 'ºC'),
	(251489, 120, '2014-03-15 00:43:59.000000', 'temperatura', 231.0000, 'ºC'),
	(251490, 120, '2014-03-15 00:44:00.000000', 'temperatura', 751.0000, 'ºC'),
	(251491, 120, '2014-03-15 00:44:01.000000', 'temperatura', 664.0000, 'ºC'),
	(251492, 120, '2014-03-15 00:44:02.000000', 'temperatura', 1067.0000, 'ºC'),
	(251493, 120, '2014-03-15 00:44:03.000000', 'temperatura', 942.0000, 'ºC'),
	(251494, 120, '2014-03-15 00:44:04.000000', 'temperatura', 310.0000, 'ºC'),
	(251495, 120, '2014-03-15 00:44:05.000000', 'temperatura', 1124.0000, 'ºC'),
	(251496, 120, '2014-03-15 00:44:06.000000', 'temperatura', 1091.0000, 'ºC'),
	(251497, 120, '2014-03-15 00:44:07.000000', 'temperatura', 882.0000, 'ºC'),
	(251498, 120, '2014-03-15 00:44:08.000000', 'temperatura', 1140.0000, 'ºC'),
	(251499, 120, '2014-03-15 00:44:09.000000', 'temperatura', 656.0000, 'ºC'),
	(251500, 120, '2014-03-15 00:44:10.000000', 'temperatura', 1058.0000, 'ºC'),
	(251501, 120, '2014-03-15 00:44:11.000000', 'temperatura', 921.0000, 'ºC'),
	(251502, 120, '2014-03-15 00:44:12.000000', 'temperatura', 233.0000, 'ºC'),
	(251503, 120, '2014-03-15 00:44:13.000000', 'temperatura', 804.0000, 'ºC'),
	(251504, 120, '2014-03-15 00:44:14.000000', 'temperatura', 922.0000, 'ºC'),
	(251505, 120, '2014-03-15 00:44:15.000000', 'temperatura', 997.0000, 'ºC'),
	(251506, 120, '2014-03-15 00:44:16.000000', 'temperatura', 1021.0000, 'ºC'),
	(251507, 120, '2014-03-15 00:44:17.000000', 'temperatura', 912.0000, 'ºC'),
	(251508, 120, '2014-03-15 00:44:18.000000', 'temperatura', 297.0000, 'ºC'),
	(251509, 120, '2014-03-15 00:44:19.000000', 'temperatura', 1152.0000, 'ºC'),
	(251510, 120, '2014-03-15 00:44:20.000000', 'temperatura', 67.0000, 'ºC'),
	(251511, 120, '2014-03-15 00:44:21.000000', 'temperatura', 479.0000, 'ºC'),
	(251512, 120, '2014-03-15 00:44:22.000000', 'temperatura', 997.0000, 'ºC'),
	(251513, 120, '2014-03-15 00:44:23.000000', 'temperatura', 1149.0000, 'ºC'),
	(251514, 120, '2014-03-15 00:44:24.000000', 'temperatura', 351.0000, 'ºC'),
	(251515, 120, '2014-03-15 00:44:25.000000', 'temperatura', 712.0000, 'ºC'),
	(251516, 120, '2014-03-15 00:44:26.000000', 'temperatura', 106.0000, 'ºC'),
	(251517, 120, '2014-03-15 00:44:27.000000', 'temperatura', 794.0000, 'ºC'),
	(251518, 120, '2014-03-15 00:44:28.000000', 'temperatura', 53.0000, 'ºC'),
	(251519, 120, '2014-03-15 00:44:29.000000', 'temperatura', 282.0000, 'ºC'),
	(251520, 120, '2014-03-15 00:44:30.000000', 'temperatura', 53.0000, 'ºC'),
	(251521, 120, '2014-03-15 00:44:31.000000', 'temperatura', 620.0000, 'ºC'),
	(251522, 120, '2014-03-15 00:44:32.000000', 'temperatura', 542.0000, 'ºC'),
	(251523, 120, '2014-03-15 00:44:33.000000', 'temperatura', 848.0000, 'ºC'),
	(251524, 120, '2014-03-15 00:44:34.000000', 'temperatura', 214.0000, 'ºC'),
	(251525, 120, '2014-03-15 00:44:35.000000', 'temperatura', 928.0000, 'ºC'),
	(251526, 120, '2014-03-15 00:44:36.000000', 'temperatura', 397.0000, 'ºC'),
	(251527, 120, '2014-03-15 00:44:37.000000', 'temperatura', 404.0000, 'ºC'),
	(251528, 120, '2014-03-15 00:44:38.000000', 'temperatura', 827.0000, 'ºC'),
	(251529, 120, '2014-03-15 00:44:39.000000', 'temperatura', 526.0000, 'ºC'),
	(251530, 120, '2014-03-15 00:44:40.000000', 'temperatura', 147.0000, 'ºC'),
	(251531, 120, '2014-03-15 00:44:41.000000', 'temperatura', 360.0000, 'ºC'),
	(251532, 120, '2014-03-15 00:44:42.000000', 'temperatura', 161.0000, 'ºC'),
	(251533, 120, '2014-03-15 00:44:43.000000', 'temperatura', 922.0000, 'ºC'),
	(251534, 120, '2014-03-15 00:44:44.000000', 'temperatura', 528.0000, 'ºC'),
	(251535, 120, '2014-03-15 00:44:45.000000', 'temperatura', 1075.0000, 'ºC'),
	(251536, 120, '2014-03-15 00:44:46.000000', 'temperatura', 191.0000, 'ºC'),
	(251537, 120, '2014-03-15 00:44:47.000000', 'temperatura', 133.0000, 'ºC'),
	(251538, 120, '2014-03-15 00:44:48.000000', 'temperatura', 90.0000, 'ºC'),
	(251539, 120, '2014-03-15 00:44:49.000000', 'temperatura', 52.0000, 'ºC'),
	(251540, 120, '2014-03-15 00:44:50.000000', 'temperatura', 1192.0000, 'ºC'),
	(251541, 120, '2014-03-15 00:44:51.000000', 'temperatura', 1004.0000, 'ºC'),
	(251542, 120, '2014-03-15 00:44:52.000000', 'temperatura', 243.0000, 'ºC'),
	(251543, 120, '2014-03-15 00:44:53.000000', 'temperatura', 603.0000, 'ºC'),
	(251544, 120, '2014-03-15 00:44:54.000000', 'temperatura', 1087.0000, 'ºC'),
	(251545, 120, '2014-03-15 00:44:55.000000', 'temperatura', 27.0000, 'ºC'),
	(251546, 120, '2014-03-15 00:44:56.000000', 'temperatura', 474.0000, 'ºC'),
	(251547, 120, '2014-03-15 00:44:57.000000', 'temperatura', 1091.0000, 'ºC'),
	(251548, 120, '2014-03-15 00:44:58.000000', 'temperatura', 433.0000, 'ºC'),
	(251549, 120, '2014-03-15 00:44:59.000000', 'temperatura', 91.0000, 'ºC'),
	(251550, 120, '2014-03-15 00:45:00.000000', 'temperatura', 356.0000, 'ºC'),
	(251551, 120, '2014-03-15 00:45:01.000000', 'temperatura', 310.0000, 'ºC'),
	(251552, 120, '2014-03-15 00:45:02.000000', 'temperatura', 480.0000, 'ºC'),
	(251553, 120, '2014-03-15 00:45:03.000000', 'temperatura', 272.0000, 'ºC'),
	(251554, 120, '2014-03-15 00:45:04.000000', 'temperatura', 1121.0000, 'ºC'),
	(251555, 120, '2014-03-15 00:45:05.000000', 'temperatura', 1188.0000, 'ºC'),
	(251556, 120, '2014-03-15 00:45:06.000000', 'temperatura', 178.0000, 'ºC'),
	(251557, 120, '2014-03-15 00:45:07.000000', 'temperatura', 925.0000, 'ºC'),
	(251558, 120, '2014-03-15 00:45:08.000000', 'temperatura', 492.0000, 'ºC'),
	(251559, 120, '2014-03-15 00:45:09.000000', 'temperatura', 887.0000, 'ºC'),
	(251560, 120, '2014-03-15 00:45:10.000000', 'temperatura', 560.0000, 'ºC'),
	(251561, 120, '2014-03-15 00:45:11.000000', 'temperatura', 138.0000, 'ºC'),
	(251562, 120, '2014-03-15 00:45:12.000000', 'temperatura', 210.0000, 'ºC'),
	(251563, 120, '2014-03-15 00:45:13.000000', 'temperatura', 636.0000, 'ºC'),
	(251564, 120, '2014-03-15 00:45:14.000000', 'temperatura', 152.0000, 'ºC'),
	(251565, 120, '2014-03-15 00:45:15.000000', 'temperatura', 51.0000, 'ºC'),
	(251566, 120, '2014-03-15 00:45:16.000000', 'temperatura', 1000.0000, 'ºC'),
	(251567, 120, '2014-03-15 00:45:17.000000', 'temperatura', 49.0000, 'ºC'),
	(251568, 120, '2014-03-15 00:45:18.000000', 'temperatura', 845.0000, 'ºC'),
	(251569, 120, '2014-03-15 00:45:19.000000', 'temperatura', 477.0000, 'ºC'),
	(251570, 120, '2014-03-15 00:45:20.000000', 'temperatura', 1053.0000, 'ºC'),
	(251571, 120, '2014-03-15 00:45:21.000000', 'temperatura', 232.0000, 'ºC'),
	(251572, 120, '2014-03-15 00:45:22.000000', 'temperatura', 405.0000, 'ºC'),
	(251573, 120, '2014-03-15 00:45:23.000000', 'temperatura', 126.0000, 'ºC'),
	(251574, 120, '2014-03-15 00:45:24.000000', 'temperatura', 616.0000, 'ºC'),
	(251575, 120, '2014-03-15 00:45:25.000000', 'temperatura', 304.0000, 'ºC'),
	(251576, 120, '2014-03-15 00:45:26.000000', 'temperatura', 871.0000, 'ºC'),
	(251577, 120, '2014-03-15 00:45:27.000000', 'temperatura', 1043.0000, 'ºC'),
	(251578, 120, '2014-03-15 00:45:28.000000', 'temperatura', 201.0000, 'ºC'),
	(251579, 120, '2014-03-15 00:45:29.000000', 'temperatura', 279.0000, 'ºC'),
	(251580, 120, '2014-03-15 00:45:30.000000', 'temperatura', 792.0000, 'ºC'),
	(251581, 120, '2014-03-15 00:45:31.000000', 'temperatura', 721.0000, 'ºC'),
	(251582, 120, '2014-03-15 00:45:32.000000', 'temperatura', 33.0000, 'ºC'),
	(251583, 120, '2014-03-15 00:45:33.000000', 'temperatura', 401.0000, 'ºC'),
	(251584, 120, '2014-03-15 00:45:34.000000', 'temperatura', 708.0000, 'ºC'),
	(251585, 120, '2014-03-15 00:45:35.000000', 'temperatura', 1137.0000, 'ºC'),
	(251586, 120, '2014-03-15 00:45:36.000000', 'temperatura', 1160.0000, 'ºC'),
	(251587, 120, '2014-03-15 00:45:37.000000', 'temperatura', 1191.0000, 'ºC'),
	(251588, 120, '2014-03-15 00:45:38.000000', 'temperatura', 75.0000, 'ºC'),
	(251589, 120, '2014-03-15 00:45:39.000000', 'temperatura', 400.0000, 'ºC'),
	(251590, 120, '2014-03-15 00:45:40.000000', 'temperatura', 579.0000, 'ºC'),
	(251591, 120, '2014-03-15 00:45:41.000000', 'temperatura', 495.0000, 'ºC'),
	(251592, 120, '2014-03-15 00:45:42.000000', 'temperatura', 738.0000, 'ºC'),
	(251593, 120, '2014-03-15 00:45:43.000000', 'temperatura', 1005.0000, 'ºC'),
	(251594, 120, '2014-03-15 00:45:44.000000', 'temperatura', 413.0000, 'ºC'),
	(251595, 120, '2014-03-15 00:45:45.000000', 'temperatura', 248.0000, 'ºC'),
	(251596, 120, '2014-03-15 00:45:46.000000', 'temperatura', 1.0000, 'ºC'),
	(251597, 120, '2014-03-15 00:45:47.000000', 'temperatura', 463.0000, 'ºC'),
	(251598, 120, '2014-03-15 00:45:48.000000', 'temperatura', 1112.0000, 'ºC'),
	(251599, 120, '2014-03-15 00:45:49.000000', 'temperatura', 573.0000, 'ºC'),
	(251600, 120, '2014-03-15 00:45:50.000000', 'temperatura', 728.0000, 'ºC'),
	(251601, 120, '2014-03-15 00:45:51.000000', 'temperatura', 722.0000, 'ºC'),
	(251602, 120, '2014-03-15 00:45:52.000000', 'temperatura', 229.0000, 'ºC'),
	(251603, 120, '2014-03-15 00:45:53.000000', 'temperatura', 176.0000, 'ºC'),
	(251604, 120, '2014-03-15 00:45:54.000000', 'temperatura', 194.0000, 'ºC'),
	(251605, 120, '2014-03-15 00:45:55.000000', 'temperatura', 443.0000, 'ºC'),
	(251606, 120, '2014-03-15 00:45:56.000000', 'temperatura', 435.0000, 'ºC'),
	(251607, 120, '2014-03-15 00:45:57.000000', 'temperatura', 848.0000, 'ºC'),
	(251608, 120, '2014-03-15 00:45:58.000000', 'temperatura', 532.0000, 'ºC'),
	(251609, 120, '2014-03-15 00:45:59.000000', 'temperatura', 116.0000, 'ºC'),
	(251610, 120, '2014-03-15 00:46:00.000000', 'temperatura', 188.0000, 'ºC'),
	(251611, 120, '2014-03-15 00:46:01.000000', 'temperatura', 589.0000, 'ºC'),
	(251612, 120, '2014-03-15 00:46:02.000000', 'temperatura', 1183.0000, 'ºC'),
	(251613, 120, '2014-03-15 00:46:03.000000', 'temperatura', 547.0000, 'ºC'),
	(251614, 120, '2014-03-15 00:46:04.000000', 'temperatura', 387.0000, 'ºC'),
	(251615, 120, '2014-03-15 00:46:05.000000', 'temperatura', 295.0000, 'ºC'),
	(251616, 120, '2014-03-15 00:46:06.000000', 'temperatura', 315.0000, 'ºC'),
	(251617, 120, '2014-03-15 00:46:07.000000', 'temperatura', 688.0000, 'ºC'),
	(251618, 120, '2014-03-15 00:46:08.000000', 'temperatura', 98.0000, 'ºC'),
	(251619, 120, '2014-03-15 00:46:09.000000', 'temperatura', 827.0000, 'ºC'),
	(251620, 120, '2014-03-15 00:46:10.000000', 'temperatura', 240.0000, 'ºC'),
	(251621, 120, '2014-03-15 00:46:11.000000', 'temperatura', 1119.0000, 'ºC'),
	(251622, 120, '2014-03-15 00:46:12.000000', 'temperatura', 76.0000, 'ºC'),
	(251623, 120, '2014-03-15 00:46:13.000000', 'temperatura', 623.0000, 'ºC'),
	(251624, 120, '2014-03-15 00:46:14.000000', 'temperatura', 489.0000, 'ºC'),
	(251625, 120, '2014-03-15 00:46:15.000000', 'temperatura', 574.0000, 'ºC'),
	(251626, 120, '2014-03-15 00:46:16.000000', 'temperatura', 207.0000, 'ºC'),
	(251627, 120, '2014-03-15 00:46:17.000000', 'temperatura', 510.0000, 'ºC'),
	(251628, 120, '2014-03-15 00:46:18.000000', 'temperatura', 732.0000, 'ºC'),
	(251629, 120, '2014-03-15 00:46:19.000000', 'temperatura', 928.0000, 'ºC'),
	(251630, 120, '2014-03-15 00:46:20.000000', 'temperatura', 46.0000, 'ºC'),
	(251631, 120, '2014-03-15 00:46:21.000000', 'temperatura', 1048.0000, 'ºC'),
	(251632, 120, '2014-03-15 00:46:22.000000', 'temperatura', 303.0000, 'ºC'),
	(251633, 120, '2014-03-15 00:46:23.000000', 'temperatura', 769.0000, 'ºC'),
	(251634, 120, '2014-03-15 00:46:24.000000', 'temperatura', 539.0000, 'ºC'),
	(251635, 120, '2014-03-15 00:46:25.000000', 'temperatura', 387.0000, 'ºC'),
	(251636, 120, '2014-03-15 00:46:26.000000', 'temperatura', 317.0000, 'ºC'),
	(251637, 120, '2014-03-15 00:46:27.000000', 'temperatura', 426.0000, 'ºC'),
	(251638, 120, '2014-03-15 00:46:28.000000', 'temperatura', 1179.0000, 'ºC'),
	(251639, 120, '2014-03-15 00:46:29.000000', 'temperatura', 1020.0000, 'ºC'),
	(251640, 120, '2014-03-15 00:46:30.000000', 'temperatura', 360.0000, 'ºC'),
	(251641, 120, '2014-03-15 00:46:31.000000', 'temperatura', 1144.0000, 'ºC'),
	(251642, 120, '2014-03-15 00:46:32.000000', 'temperatura', 1039.0000, 'ºC'),
	(251643, 120, '2014-03-15 00:46:33.000000', 'temperatura', 563.0000, 'ºC'),
	(251644, 120, '2014-03-15 00:46:34.000000', 'temperatura', 899.0000, 'ºC'),
	(251645, 120, '2014-03-15 00:46:35.000000', 'temperatura', 406.0000, 'ºC'),
	(251646, 120, '2014-03-15 00:46:36.000000', 'temperatura', 535.0000, 'ºC'),
	(251647, 120, '2014-03-15 00:46:37.000000', 'temperatura', 259.0000, 'ºC'),
	(251648, 120, '2014-03-15 00:46:38.000000', 'temperatura', 888.0000, 'ºC'),
	(251649, 120, '2014-03-15 00:46:39.000000', 'temperatura', 63.0000, 'ºC'),
	(251650, 120, '2014-03-15 00:46:40.000000', 'temperatura', 53.0000, 'ºC'),
	(251651, 120, '2014-03-15 00:46:41.000000', 'temperatura', 77.0000, 'ºC'),
	(251652, 120, '2014-03-15 00:46:42.000000', 'temperatura', 225.0000, 'ºC'),
	(251653, 120, '2014-03-15 00:46:43.000000', 'temperatura', 896.0000, 'ºC'),
	(251654, 120, '2014-03-15 00:46:44.000000', 'temperatura', 204.0000, 'ºC'),
	(251655, 120, '2014-03-15 00:46:45.000000', 'temperatura', 733.0000, 'ºC'),
	(251656, 120, '2014-03-15 00:46:46.000000', 'temperatura', 653.0000, 'ºC'),
	(251657, 120, '2014-03-15 00:46:47.000000', 'temperatura', 1066.0000, 'ºC'),
	(251658, 120, '2014-03-15 00:46:48.000000', 'temperatura', 970.0000, 'ºC'),
	(251659, 120, '2014-03-15 00:46:49.000000', 'temperatura', 454.0000, 'ºC'),
	(251660, 120, '2014-03-15 00:46:50.000000', 'temperatura', 562.0000, 'ºC'),
	(251661, 120, '2014-03-15 00:46:51.000000', 'temperatura', 246.0000, 'ºC'),
	(251662, 120, '2014-03-15 00:46:52.000000', 'temperatura', 746.0000, 'ºC'),
	(251663, 120, '2014-03-15 00:46:53.000000', 'temperatura', 592.0000, 'ºC'),
	(251664, 120, '2014-03-15 00:46:54.000000', 'temperatura', 722.0000, 'ºC'),
	(251665, 120, '2014-03-15 00:46:55.000000', 'temperatura', 636.0000, 'ºC'),
	(251666, 120, '2014-03-15 00:46:56.000000', 'temperatura', 1015.0000, 'ºC'),
	(251667, 120, '2014-03-15 00:46:57.000000', 'temperatura', 767.0000, 'ºC'),
	(251668, 120, '2014-03-15 00:46:58.000000', 'temperatura', 792.0000, 'ºC'),
	(251669, 120, '2014-03-15 00:46:59.000000', 'temperatura', 457.0000, 'ºC'),
	(251670, 120, '2014-03-15 00:47:00.000000', 'temperatura', 1111.0000, 'ºC'),
	(251671, 120, '2014-03-15 00:47:01.000000', 'temperatura', 584.0000, 'ºC'),
	(251672, 120, '2014-03-15 00:47:02.000000', 'temperatura', 789.0000, 'ºC'),
	(251673, 120, '2014-03-15 00:47:03.000000', 'temperatura', 992.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(251674, 120, '2014-03-15 00:47:04.000000', 'temperatura', 195.0000, 'ºC'),
	(251675, 120, '2014-03-15 00:47:05.000000', 'temperatura', 401.0000, 'ºC'),
	(251676, 120, '2014-03-15 00:47:06.000000', 'temperatura', 217.0000, 'ºC'),
	(251677, 120, '2014-03-15 00:47:07.000000', 'temperatura', 1083.0000, 'ºC'),
	(251678, 120, '2014-03-15 00:47:08.000000', 'temperatura', 1164.0000, 'ºC'),
	(251679, 120, '2014-03-15 00:47:09.000000', 'temperatura', 173.0000, 'ºC'),
	(251680, 120, '2014-03-15 00:47:10.000000', 'temperatura', 973.0000, 'ºC'),
	(251681, 120, '2014-03-15 00:47:11.000000', 'temperatura', 748.0000, 'ºC'),
	(251682, 120, '2014-03-15 00:47:12.000000', 'temperatura', 822.0000, 'ºC'),
	(251683, 120, '2014-03-15 00:47:13.000000', 'temperatura', 665.0000, 'ºC'),
	(251684, 120, '2014-03-15 00:47:14.000000', 'temperatura', 861.0000, 'ºC'),
	(251685, 120, '2014-03-15 00:47:15.000000', 'temperatura', 1109.0000, 'ºC'),
	(251686, 120, '2014-03-15 00:47:16.000000', 'temperatura', 561.0000, 'ºC'),
	(251687, 120, '2014-03-15 00:47:17.000000', 'temperatura', 681.0000, 'ºC'),
	(251688, 120, '2014-03-15 00:47:18.000000', 'temperatura', 524.0000, 'ºC'),
	(251689, 120, '2014-03-15 00:47:19.000000', 'temperatura', 575.0000, 'ºC'),
	(251690, 120, '2014-03-15 00:47:20.000000', 'temperatura', 104.0000, 'ºC'),
	(251691, 120, '2014-03-15 00:47:21.000000', 'temperatura', 1194.0000, 'ºC'),
	(251692, 120, '2014-03-15 00:47:22.000000', 'temperatura', 862.0000, 'ºC'),
	(251693, 120, '2014-03-15 00:47:23.000000', 'temperatura', 726.0000, 'ºC'),
	(251694, 120, '2014-03-15 00:47:24.000000', 'temperatura', 1043.0000, 'ºC'),
	(251695, 120, '2014-03-15 00:47:25.000000', 'temperatura', 640.0000, 'ºC'),
	(251696, 120, '2014-03-15 00:47:26.000000', 'temperatura', 72.0000, 'ºC'),
	(251697, 120, '2014-03-15 00:47:27.000000', 'temperatura', 840.0000, 'ºC'),
	(251698, 120, '2014-03-15 00:47:28.000000', 'temperatura', 383.0000, 'ºC'),
	(251699, 120, '2014-03-15 00:47:29.000000', 'temperatura', 597.0000, 'ºC'),
	(251700, 120, '2014-03-15 00:47:30.000000', 'temperatura', 638.0000, 'ºC'),
	(251701, 120, '2014-03-15 00:47:31.000000', 'temperatura', 198.0000, 'ºC'),
	(251702, 120, '2014-03-15 00:47:32.000000', 'temperatura', 277.0000, 'ºC'),
	(251703, 120, '2014-03-15 00:47:33.000000', 'temperatura', 792.0000, 'ºC'),
	(251704, 120, '2014-03-15 00:47:34.000000', 'temperatura', 730.0000, 'ºC'),
	(251705, 120, '2014-03-15 00:47:35.000000', 'temperatura', 76.0000, 'ºC'),
	(251706, 120, '2014-03-15 00:47:36.000000', 'temperatura', 588.0000, 'ºC'),
	(251707, 120, '2014-03-15 00:47:37.000000', 'temperatura', 315.0000, 'ºC'),
	(251708, 120, '2014-03-15 00:47:38.000000', 'temperatura', 1009.0000, 'ºC'),
	(251709, 120, '2014-03-15 00:47:39.000000', 'temperatura', 499.0000, 'ºC'),
	(251710, 120, '2014-03-15 00:47:40.000000', 'temperatura', 672.0000, 'ºC'),
	(251711, 120, '2014-03-15 00:47:41.000000', 'temperatura', 663.0000, 'ºC'),
	(251712, 120, '2014-03-15 00:47:42.000000', 'temperatura', 98.0000, 'ºC'),
	(251713, 120, '2014-03-15 00:47:43.000000', 'temperatura', 900.0000, 'ºC'),
	(251714, 120, '2014-03-15 00:47:44.000000', 'temperatura', 610.0000, 'ºC'),
	(251715, 120, '2014-03-15 00:47:45.000000', 'temperatura', 349.0000, 'ºC'),
	(251716, 120, '2014-03-15 00:47:46.000000', 'temperatura', 1116.0000, 'ºC'),
	(251717, 120, '2014-03-15 00:47:47.000000', 'temperatura', 935.0000, 'ºC'),
	(251718, 120, '2014-03-15 00:47:48.000000', 'temperatura', 128.0000, 'ºC'),
	(251719, 120, '2014-03-15 00:47:49.000000', 'temperatura', 233.0000, 'ºC'),
	(251720, 120, '2014-03-15 00:47:50.000000', 'temperatura', 783.0000, 'ºC'),
	(251721, 120, '2014-03-15 00:47:51.000000', 'temperatura', 818.0000, 'ºC'),
	(251722, 120, '2014-03-15 00:47:52.000000', 'temperatura', 540.0000, 'ºC'),
	(251723, 120, '2014-03-15 00:47:53.000000', 'temperatura', 245.0000, 'ºC'),
	(251724, 120, '2014-03-15 00:47:54.000000', 'temperatura', 808.0000, 'ºC'),
	(251725, 120, '2014-03-15 00:47:55.000000', 'temperatura', 906.0000, 'ºC'),
	(251726, 120, '2014-03-15 00:47:56.000000', 'temperatura', 906.0000, 'ºC'),
	(251727, 120, '2014-03-15 00:47:57.000000', 'temperatura', 614.0000, 'ºC'),
	(251728, 120, '2014-03-15 00:47:58.000000', 'temperatura', 352.0000, 'ºC'),
	(251729, 120, '2014-03-15 00:47:59.000000', 'temperatura', 1116.0000, 'ºC'),
	(251730, 120, '2014-03-15 00:48:00.000000', 'temperatura', 927.0000, 'ºC'),
	(251731, 120, '2014-03-15 00:48:01.000000', 'temperatura', 87.0000, 'ºC'),
	(251732, 120, '2014-03-15 00:48:02.000000', 'temperatura', 54.0000, 'ºC'),
	(251733, 120, '2014-03-15 00:48:03.000000', 'temperatura', 10.0000, 'ºC'),
	(251734, 120, '2014-03-15 00:48:04.000000', 'temperatura', 1090.0000, 'ºC'),
	(251735, 120, '2014-03-15 00:48:05.000000', 'temperatura', 620.0000, 'ºC'),
	(251736, 120, '2014-03-15 00:48:06.000000', 'temperatura', 1029.0000, 'ºC'),
	(251737, 120, '2014-03-15 00:48:07.000000', 'temperatura', 886.0000, 'ºC'),
	(251738, 120, '2014-03-15 00:48:08.000000', 'temperatura', 144.0000, 'ºC'),
	(251739, 120, '2014-03-15 00:48:09.000000', 'temperatura', 462.0000, 'ºC'),
	(251740, 120, '2014-03-15 00:48:10.000000', 'temperatura', 679.0000, 'ºC'),
	(251741, 120, '2014-03-15 00:48:11.000000', 'temperatura', 809.0000, 'ºC'),
	(251742, 120, '2014-03-15 00:48:12.000000', 'temperatura', 809.0000, 'ºC'),
	(251743, 120, '2014-03-15 00:48:13.000000', 'temperatura', 420.0000, 'ºC'),
	(251744, 120, '2014-03-15 00:48:14.000000', 'temperatura', 871.0000, 'ºC'),
	(251745, 120, '2014-03-15 00:48:15.000000', 'temperatura', 697.0000, 'ºC'),
	(251746, 120, '2014-03-15 00:48:16.000000', 'temperatura', 874.0000, 'ºC'),
	(251747, 120, '2014-03-15 00:48:17.000000', 'temperatura', 1079.0000, 'ºC'),
	(251748, 120, '2014-03-15 00:48:18.000000', 'temperatura', 372.0000, 'ºC'),
	(251749, 120, '2014-03-15 00:48:19.000000', 'temperatura', 1026.0000, 'ºC'),
	(251750, 120, '2014-03-15 00:48:20.000000', 'temperatura', 412.0000, 'ºC'),
	(251751, 120, '2014-03-15 00:48:21.000000', 'temperatura', 184.0000, 'ºC'),
	(251752, 120, '2014-03-15 00:48:22.000000', 'temperatura', 884.0000, 'ºC'),
	(251753, 120, '2014-03-15 00:48:23.000000', 'temperatura', 270.0000, 'ºC'),
	(251754, 120, '2014-03-15 00:48:24.000000', 'temperatura', 1097.0000, 'ºC'),
	(251755, 120, '2014-03-15 00:48:25.000000', 'temperatura', 1074.0000, 'ºC'),
	(251756, 120, '2014-03-15 00:48:26.000000', 'temperatura', 883.0000, 'ºC'),
	(251757, 120, '2014-03-15 00:48:27.000000', 'temperatura', 1190.0000, 'ºC'),
	(251758, 120, '2014-03-15 00:48:28.000000', 'temperatura', 904.0000, 'ºC'),
	(251759, 120, '2014-03-15 00:48:29.000000', 'temperatura', 949.0000, 'ºC'),
	(251760, 120, '2014-03-15 00:48:30.000000', 'temperatura', 834.0000, 'ºC'),
	(251761, 120, '2014-03-15 00:48:31.000000', 'temperatura', 124.0000, 'ºC'),
	(251762, 120, '2014-03-15 00:48:32.000000', 'temperatura', 518.0000, 'ºC'),
	(251763, 120, '2014-03-15 00:48:33.000000', 'temperatura', 1019.0000, 'ºC'),
	(251764, 120, '2014-03-15 00:48:34.000000', 'temperatura', 1142.0000, 'ºC'),
	(251765, 120, '2014-03-15 00:48:35.000000', 'temperatura', 251.0000, 'ºC'),
	(251766, 120, '2014-03-15 00:48:36.000000', 'temperatura', 231.0000, 'ºC'),
	(251767, 120, '2014-03-15 00:48:37.000000', 'temperatura', 403.0000, 'ºC'),
	(251768, 120, '2014-03-15 00:48:38.000000', 'temperatura', 124.0000, 'ºC'),
	(251769, 120, '2014-03-15 00:48:39.000000', 'temperatura', 610.0000, 'ºC'),
	(251770, 120, '2014-03-15 00:48:40.000000', 'temperatura', 280.0000, 'ºC'),
	(251771, 120, '2014-03-15 00:48:41.000000', 'temperatura', 772.0000, 'ºC'),
	(251772, 120, '2014-03-15 00:48:42.000000', 'temperatura', 617.0000, 'ºC'),
	(251773, 120, '2014-03-15 00:48:43.000000', 'temperatura', 771.0000, 'ºC'),
	(251774, 120, '2014-03-15 00:48:44.000000', 'temperatura', 806.0000, 'ºC'),
	(251775, 120, '2014-03-15 00:48:45.000000', 'temperatura', 517.0000, 'ºC'),
	(251776, 120, '2014-03-15 00:48:46.000000', 'temperatura', 167.0000, 'ºC'),
	(251777, 120, '2014-03-15 00:48:47.000000', 'temperatura', 486.0000, 'ºC'),
	(251778, 120, '2014-03-15 00:48:48.000000', 'temperatura', 729.0000, 'ºC'),
	(251779, 120, '2014-03-15 00:48:49.000000', 'temperatura', 985.0000, 'ºC'),
	(251780, 120, '2014-03-15 00:48:50.000000', 'temperatura', 340.0000, 'ºC'),
	(251781, 120, '2014-03-15 00:48:51.000000', 'temperatura', 1146.0000, 'ºC'),
	(251782, 120, '2014-03-15 00:48:52.000000', 'temperatura', 1108.0000, 'ºC'),
	(251783, 120, '2014-03-15 00:48:53.000000', 'temperatura', 904.0000, 'ºC'),
	(251784, 120, '2014-03-15 00:48:54.000000', 'temperatura', 1196.0000, 'ºC'),
	(251785, 120, '2014-03-15 00:48:55.000000', 'temperatura', 871.0000, 'ºC'),
	(251786, 120, '2014-03-15 00:48:56.000000', 'temperatura', 766.0000, 'ºC'),
	(251787, 120, '2014-03-15 00:48:57.000000', 'temperatura', 16.0000, 'ºC'),
	(251788, 120, '2014-03-15 00:48:58.000000', 'temperatura', 183.0000, 'ºC'),
	(251789, 120, '2014-03-15 00:48:59.000000', 'temperatura', 866.0000, 'ºC'),
	(251790, 120, '2014-03-15 00:49:00.000000', 'temperatura', 183.0000, 'ºC'),
	(251791, 120, '2014-03-15 00:49:01.000000', 'temperatura', 715.0000, 'ºC'),
	(251792, 120, '2014-03-15 00:49:02.000000', 'temperatura', 630.0000, 'ºC'),
	(251793, 120, '2014-03-15 00:49:03.000000', 'temperatura', 1002.0000, 'ºC'),
	(251794, 120, '2014-03-15 00:49:04.000000', 'temperatura', 722.0000, 'ºC'),
	(251795, 120, '2014-03-15 00:49:05.000000', 'temperatura', 606.0000, 'ºC'),
	(251796, 120, '2014-03-15 00:49:06.000000', 'temperatura', 863.0000, 'ºC'),
	(251797, 120, '2014-03-15 00:49:07.000000', 'temperatura', 98.0000, 'ºC'),
	(251798, 120, '2014-03-15 00:49:08.000000', 'temperatura', 300.0000, 'ºC'),
	(251799, 120, '2014-03-15 00:49:09.000000', 'temperatura', 8.0000, 'ºC'),
	(251800, 120, '2014-03-15 00:49:10.000000', 'temperatura', 338.0000, 'ºC'),
	(251801, 120, '2014-03-15 00:49:11.000000', 'temperatura', 469.0000, 'ºC'),
	(251802, 120, '2014-03-15 00:49:12.000000', 'temperatura', 131.0000, 'ºC'),
	(251803, 120, '2014-03-15 00:49:13.000000', 'temperatura', 449.0000, 'ºC'),
	(251804, 120, '2014-03-15 00:49:14.000000', 'temperatura', 654.0000, 'ºC'),
	(251805, 120, '2014-03-15 00:49:15.000000', 'temperatura', 722.0000, 'ºC'),
	(251806, 120, '2014-03-15 00:49:16.000000', 'temperatura', 450.0000, 'ºC'),
	(251807, 120, '2014-03-15 00:49:17.000000', 'temperatura', 84.0000, 'ºC'),
	(251808, 120, '2014-03-15 00:49:18.000000', 'temperatura', 269.0000, 'ºC'),
	(251809, 120, '2014-03-15 00:49:19.000000', 'temperatura', 1092.0000, 'ºC'),
	(251810, 120, '2014-03-15 00:49:20.000000', 'temperatura', 1057.0000, 'ºC'),
	(251811, 120, '2014-03-15 00:49:21.000000', 'temperatura', 808.0000, 'ºC'),
	(251812, 120, '2014-03-15 00:49:22.000000', 'temperatura', 871.0000, 'ºC'),
	(251813, 120, '2014-03-15 00:49:23.000000', 'temperatura', 729.0000, 'ºC'),
	(251814, 120, '2014-03-15 00:49:24.000000', 'temperatura', 1034.0000, 'ºC'),
	(251815, 120, '2014-03-15 00:49:25.000000', 'temperatura', 581.0000, 'ºC'),
	(251816, 120, '2014-03-15 00:49:26.000000', 'temperatura', 1006.0000, 'ºC'),
	(251817, 120, '2014-03-15 00:49:27.000000', 'temperatura', 886.0000, 'ºC'),
	(251818, 120, '2014-03-15 00:49:28.000000', 'temperatura', 212.0000, 'ºC'),
	(251819, 120, '2014-03-15 00:49:29.000000', 'temperatura', 803.0000, 'ºC'),
	(251820, 120, '2014-03-15 00:49:30.000000', 'temperatura', 981.0000, 'ºC'),
	(251821, 120, '2014-03-15 00:49:31.000000', 'temperatura', 96.0000, 'ºC'),
	(251822, 120, '2014-03-15 00:49:32.000000', 'temperatura', 1137.0000, 'ºC'),
	(251823, 120, '2014-03-15 00:49:33.000000', 'temperatura', 596.0000, 'ºC'),
	(251824, 120, '2014-03-15 00:49:34.000000', 'temperatura', 770.0000, 'ºC'),
	(251825, 120, '2014-03-15 00:49:35.000000', 'temperatura', 861.0000, 'ºC'),
	(251826, 120, '2014-03-15 00:49:36.000000', 'temperatura', 797.0000, 'ºC'),
	(251827, 120, '2014-03-15 00:49:37.000000', 'temperatura', 202.0000, 'ºC'),
	(251828, 120, '2014-03-15 00:49:38.000000', 'temperatura', 1018.0000, 'ºC'),
	(251829, 120, '2014-03-15 00:49:39.000000', 'temperatura', 887.0000, 'ºC'),
	(251830, 120, '2014-03-15 00:49:40.000000', 'temperatura', 179.0000, 'ºC'),
	(251831, 120, '2014-03-15 00:49:41.000000', 'temperatura', 634.0000, 'ºC'),
	(251832, 120, '2014-03-15 00:49:42.000000', 'temperatura', 234.0000, 'ºC'),
	(251833, 120, '2014-03-15 00:49:43.000000', 'temperatura', 467.0000, 'ºC'),
	(251834, 120, '2014-03-15 00:49:44.000000', 'temperatura', 436.0000, 'ºC'),
	(251835, 120, '2014-03-15 00:49:45.000000', 'temperatura', 779.0000, 'ºC'),
	(251836, 120, '2014-03-15 00:49:46.000000', 'temperatura', 189.0000, 'ºC'),
	(251837, 120, '2014-03-15 00:49:47.000000', 'temperatura', 1008.0000, 'ºC'),
	(251838, 120, '2014-03-15 00:49:48.000000', 'temperatura', 875.0000, 'ºC'),
	(251839, 120, '2014-03-15 00:49:49.000000', 'temperatura', 150.0000, 'ºC'),
	(251840, 120, '2014-03-15 00:49:50.000000', 'temperatura', 527.0000, 'ºC'),
	(251841, 120, '2014-03-15 00:49:51.000000', 'temperatura', 983.0000, 'ºC'),
	(251842, 120, '2014-03-15 00:49:52.000000', 'temperatura', 934.0000, 'ºC'),
	(251843, 120, '2014-03-15 00:49:53.000000', 'temperatura', 523.0000, 'ºC'),
	(251844, 120, '2014-03-15 00:49:54.000000', 'temperatura', 1013.0000, 'ºC'),
	(251845, 120, '2014-03-15 00:49:55.000000', 'temperatura', 1097.0000, 'ºC'),
	(251846, 120, '2014-03-15 00:49:56.000000', 'temperatura', 47.0000, 'ºC'),
	(251847, 120, '2014-03-15 00:49:57.000000', 'temperatura', 545.0000, 'ºC'),
	(251848, 120, '2014-03-15 00:49:58.000000', 'temperatura', 182.0000, 'ºC'),
	(251849, 120, '2014-03-15 00:49:59.000000', 'temperatura', 477.0000, 'ºC'),
	(251850, 120, '2014-03-15 00:50:00.000000', 'temperatura', 638.0000, 'ºC'),
	(251851, 120, '2014-03-15 00:50:01.000000', 'temperatura', 560.0000, 'ºC'),
	(251852, 120, '2014-03-15 00:50:02.000000', 'temperatura', 886.0000, 'ºC'),
	(251853, 120, '2014-03-15 00:50:03.000000', 'temperatura', 350.0000, 'ºC'),
	(251854, 120, '2014-03-15 00:50:04.000000', 'temperatura', 294.0000, 'ºC'),
	(251855, 120, '2014-03-15 00:50:05.000000', 'temperatura', 421.0000, 'ºC'),
	(251856, 120, '2014-03-15 00:50:06.000000', 'temperatura', 22.0000, 'ºC'),
	(251857, 120, '2014-03-15 00:50:07.000000', 'temperatura', 48.0000, 'ºC'),
	(251858, 120, '2014-03-15 00:50:08.000000', 'temperatura', 175.0000, 'ºC'),
	(251859, 120, '2014-03-15 00:50:09.000000', 'temperatura', 731.0000, 'ºC'),
	(251860, 120, '2014-03-15 00:50:10.000000', 'temperatura', 729.0000, 'ºC'),
	(251861, 120, '2014-03-15 00:50:11.000000', 'temperatura', 252.0000, 'ºC'),
	(251862, 120, '2014-03-15 00:50:12.000000', 'temperatura', 275.0000, 'ºC'),
	(251863, 120, '2014-03-15 00:50:13.000000', 'temperatura', 618.0000, 'ºC'),
	(251864, 120, '2014-03-15 00:50:14.000000', 'temperatura', 1066.0000, 'ºC'),
	(251865, 120, '2014-03-15 00:50:15.000000', 'temperatura', 1078.0000, 'ºC'),
	(251866, 120, '2014-03-15 00:50:16.000000', 'temperatura', 993.0000, 'ºC'),
	(251867, 120, '2014-03-15 00:50:17.000000', 'temperatura', 531.0000, 'ºC'),
	(251868, 120, '2014-03-15 00:50:18.000000', 'temperatura', 875.0000, 'ºC'),
	(251869, 120, '2014-03-15 00:50:19.000000', 'temperatura', 384.0000, 'ºC'),
	(251870, 120, '2014-03-15 00:50:20.000000', 'temperatura', 493.0000, 'ºC'),
	(251871, 120, '2014-03-15 00:50:21.000000', 'temperatura', 116.0000, 'ºC'),
	(251872, 120, '2014-03-15 00:50:22.000000', 'temperatura', 301.0000, 'ºC'),
	(251873, 120, '2014-03-15 00:50:23.000000', 'temperatura', 1158.0000, 'ºC'),
	(251874, 120, '2014-03-15 00:50:24.000000', 'temperatura', 88.0000, 'ºC'),
	(251875, 120, '2014-03-15 00:50:25.000000', 'temperatura', 567.0000, 'ºC'),
	(251876, 120, '2014-03-15 00:50:26.000000', 'temperatura', 172.0000, 'ºC'),
	(251877, 120, '2014-03-15 00:50:27.000000', 'temperatura', 357.0000, 'ºC'),
	(251878, 120, '2014-03-15 00:50:28.000000', 'temperatura', 71.0000, 'ºC'),
	(251879, 120, '2014-03-15 00:50:29.000000', 'temperatura', 484.0000, 'ºC'),
	(251880, 120, '2014-03-15 00:50:30.000000', 'temperatura', 1009.0000, 'ºC'),
	(251881, 120, '2014-03-15 00:50:31.000000', 'temperatura', 1191.0000, 'ºC'),
	(251882, 120, '2014-03-15 00:50:32.000000', 'temperatura', 531.0000, 'ºC'),
	(251883, 120, '2014-03-15 00:50:33.000000', 'temperatura', 284.0000, 'ºC'),
	(251884, 120, '2014-03-15 00:50:34.000000', 'temperatura', 1024.0000, 'ºC'),
	(251885, 120, '2014-03-15 00:50:35.000000', 'temperatura', 669.0000, 'ºC'),
	(251886, 120, '2014-03-15 00:50:36.000000', 'temperatura', 274.0000, 'ºC'),
	(251887, 120, '2014-03-15 00:50:37.000000', 'temperatura', 564.0000, 'ºC'),
	(251888, 120, '2014-03-15 00:50:38.000000', 'temperatura', 799.0000, 'ºC'),
	(251889, 120, '2014-03-15 00:50:39.000000', 'temperatura', 1103.0000, 'ºC'),
	(251890, 120, '2014-03-15 00:50:40.000000', 'temperatura', 719.0000, 'ºC'),
	(251891, 120, '2014-03-15 00:50:41.000000', 'temperatura', 285.0000, 'ºC'),
	(251892, 120, '2014-03-15 00:50:42.000000', 'temperatura', 468.0000, 'ºC'),
	(251893, 120, '2014-03-15 00:50:43.000000', 'temperatura', 285.0000, 'ºC'),
	(251894, 120, '2014-03-15 00:50:44.000000', 'temperatura', 22.0000, 'ºC'),
	(251895, 120, '2014-03-15 00:50:45.000000', 'temperatura', 457.0000, 'ºC'),
	(251896, 120, '2014-03-15 00:50:46.000000', 'temperatura', 1018.0000, 'ºC'),
	(251897, 120, '2014-03-15 00:50:47.000000', 'temperatura', 119.0000, 'ºC'),
	(251898, 120, '2014-03-15 00:50:48.000000', 'temperatura', 1144.0000, 'ºC'),
	(251899, 120, '2014-03-15 00:50:49.000000', 'temperatura', 560.0000, 'ºC'),
	(251900, 120, '2014-03-15 00:50:50.000000', 'temperatura', 571.0000, 'ºC'),
	(251901, 120, '2014-03-15 00:50:51.000000', 'temperatura', 1174.0000, 'ºC'),
	(251902, 120, '2014-03-15 00:50:52.000000', 'temperatura', 556.0000, 'ºC'),
	(251903, 120, '2014-03-15 00:50:53.000000', 'temperatura', 461.0000, 'ºC'),
	(251904, 120, '2014-03-15 00:50:54.000000', 'temperatura', 636.0000, 'ºC'),
	(251905, 120, '2014-03-15 00:50:55.000000', 'temperatura', 599.0000, 'ºC'),
	(251906, 120, '2014-03-15 00:50:56.000000', 'temperatura', 1087.0000, 'ºC'),
	(251907, 120, '2014-03-15 00:50:57.000000', 'temperatura', 40.0000, 'ºC'),
	(251908, 120, '2014-03-15 00:50:58.000000', 'temperatura', 540.0000, 'ºC'),
	(251909, 120, '2014-03-15 00:50:59.000000', 'temperatura', 181.0000, 'ºC'),
	(251910, 120, '2014-03-15 00:51:00.000000', 'temperatura', 486.0000, 'ºC'),
	(251911, 120, '2014-03-15 00:51:01.000000', 'temperatura', 684.0000, 'ºC'),
	(251912, 120, '2014-03-15 00:51:02.000000', 'temperatura', 765.0000, 'ºC'),
	(251913, 120, '2014-03-15 00:51:03.000000', 'temperatura', 575.0000, 'ºC'),
	(251914, 120, '2014-03-15 00:51:04.000000', 'temperatura', 578.0000, 'ºC'),
	(251915, 120, '2014-03-15 00:51:05.000000', 'temperatura', 1168.0000, 'ºC'),
	(251916, 120, '2014-03-15 00:51:06.000000', 'temperatura', 503.0000, 'ºC'),
	(251917, 120, '2014-03-15 00:51:07.000000', 'temperatura', 214.0000, 'ºC'),
	(251918, 120, '2014-03-15 00:51:08.000000', 'temperatura', 762.0000, 'ºC'),
	(251919, 120, '2014-03-15 00:51:09.000000', 'temperatura', 768.0000, 'ºC'),
	(251920, 120, '2014-03-15 00:51:10.000000', 'temperatura', 353.0000, 'ºC'),
	(251921, 120, '2014-03-15 00:51:11.000000', 'temperatura', 663.0000, 'ºC'),
	(251922, 120, '2014-03-15 00:51:12.000000', 'temperatura', 1056.0000, 'ºC'),
	(251923, 120, '2014-03-15 00:51:13.000000', 'temperatura', 893.0000, 'ºC'),
	(251924, 120, '2014-03-15 00:51:14.000000', 'temperatura', 97.0000, 'ºC'),
	(251925, 120, '2014-03-15 00:51:15.000000', 'temperatura', 206.0000, 'ºC'),
	(251926, 120, '2014-03-15 00:51:16.000000', 'temperatura', 740.0000, 'ºC'),
	(251927, 120, '2014-03-15 00:51:17.000000', 'temperatura', 680.0000, 'ºC'),
	(251928, 120, '2014-03-15 00:51:18.000000', 'temperatura', 1184.0000, 'ºC'),
	(251929, 120, '2014-03-15 00:51:19.000000', 'temperatura', 279.0000, 'ºC'),
	(251930, 120, '2014-03-15 00:51:20.000000', 'temperatura', 242.0000, 'ºC'),
	(251931, 120, '2014-03-15 00:51:21.000000', 'temperatura', 376.0000, 'ºC'),
	(251932, 120, '2014-03-15 00:51:22.000000', 'temperatura', 1155.0000, 'ºC'),
	(251933, 120, '2014-03-15 00:51:23.000000', 'temperatura', 1045.0000, 'ºC'),
	(251934, 120, '2014-03-15 00:51:24.000000', 'temperatura', 563.0000, 'ºC'),
	(251935, 120, '2014-03-15 00:51:25.000000', 'temperatura', 879.0000, 'ºC'),
	(251936, 120, '2014-03-15 00:51:26.000000', 'temperatura', 307.0000, 'ºC'),
	(251937, 120, '2014-03-15 00:51:27.000000', 'temperatura', 96.0000, 'ºC'),
	(251938, 120, '2014-03-15 00:51:28.000000', 'temperatura', 763.0000, 'ºC'),
	(251939, 120, '2014-03-15 00:51:29.000000', 'temperatura', 1126.0000, 'ºC'),
	(251940, 120, '2014-03-15 00:51:30.000000', 'temperatura', 942.0000, 'ºC'),
	(251941, 120, '2014-03-15 00:51:31.000000', 'temperatura', 131.0000, 'ºC'),
	(251942, 120, '2014-03-15 00:51:32.000000', 'temperatura', 229.0000, 'ºC'),
	(251943, 120, '2014-03-15 00:51:33.000000', 'temperatura', 752.0000, 'ºC'),
	(251944, 120, '2014-03-15 00:51:34.000000', 'temperatura', 674.0000, 'ºC'),
	(251945, 120, '2014-03-15 00:51:35.000000', 'temperatura', 1117.0000, 'ºC'),
	(251946, 120, '2014-03-15 00:51:36.000000', 'temperatura', 1162.0000, 'ºC'),
	(251947, 120, '2014-03-15 00:51:37.000000', 'temperatura', 59.0000, 'ºC'),
	(251948, 120, '2014-03-15 00:51:38.000000', 'temperatura', 409.0000, 'ºC'),
	(251949, 120, '2014-03-15 00:51:39.000000', 'temperatura', 668.0000, 'ºC'),
	(251950, 120, '2014-03-15 00:51:40.000000', 'temperatura', 916.0000, 'ºC'),
	(251951, 120, '2014-03-15 00:51:41.000000', 'temperatura', 176.0000, 'ºC'),
	(251952, 120, '2014-03-15 00:51:42.000000', 'temperatura', 533.0000, 'ºC'),
	(251953, 120, '2014-03-15 00:51:43.000000', 'temperatura', 938.0000, 'ºC'),
	(251954, 120, '2014-03-15 00:51:44.000000', 'temperatura', 693.0000, 'ºC'),
	(251955, 120, '2014-03-15 00:51:45.000000', 'temperatura', 648.0000, 'ºC'),
	(251956, 120, '2014-03-15 00:51:46.000000', 'temperatura', 1164.0000, 'ºC'),
	(251957, 120, '2014-03-15 00:51:47.000000', 'temperatura', 275.0000, 'ºC'),
	(251958, 120, '2014-03-15 00:51:48.000000', 'temperatura', 286.0000, 'ºC'),
	(251959, 120, '2014-03-15 00:51:49.000000', 'temperatura', 602.0000, 'ºC'),
	(251960, 120, '2014-03-15 00:51:50.000000', 'temperatura', 955.0000, 'ºC'),
	(251961, 120, '2014-03-15 00:51:51.000000', 'temperatura', 568.0000, 'ºC'),
	(251962, 120, '2014-03-15 00:51:52.000000', 'temperatura', 1175.0000, 'ºC'),
	(251963, 120, '2014-03-15 00:51:53.000000', 'temperatura', 572.0000, 'ºC'),
	(251964, 120, '2014-03-15 00:51:54.000000', 'temperatura', 534.0000, 'ºC'),
	(251965, 120, '2014-03-15 00:51:55.000000', 'temperatura', 955.0000, 'ºC'),
	(251966, 120, '2014-03-15 00:51:56.000000', 'temperatura', 775.0000, 'ºC'),
	(251967, 120, '2014-03-15 00:51:57.000000', 'temperatura', 1008.0000, 'ºC'),
	(251968, 120, '2014-03-15 00:51:58.000000', 'temperatura', 316.0000, 'ºC'),
	(251969, 120, '2014-03-15 00:51:59.000000', 'temperatura', 957.0000, 'ºC'),
	(251970, 120, '2014-03-15 00:52:00.000000', 'temperatura', 238.0000, 'ºC'),
	(251971, 120, '2014-03-15 00:52:01.000000', 'temperatura', 720.0000, 'ºC'),
	(251972, 120, '2014-03-15 00:52:02.000000', 'temperatura', 485.0000, 'ºC'),
	(251973, 120, '2014-03-15 00:52:03.000000', 'temperatura', 268.0000, 'ºC'),
	(251974, 120, '2014-03-15 00:52:04.000000', 'temperatura', 1084.0000, 'ºC'),
	(251975, 120, '2014-03-15 00:52:05.000000', 'temperatura', 1017.0000, 'ºC'),
	(251976, 120, '2014-03-15 00:52:06.000000', 'temperatura', 633.0000, 'ºC'),
	(251977, 120, '2014-03-15 00:52:07.000000', 'temperatura', 115.0000, 'ºC'),
	(251978, 120, '2014-03-15 00:52:08.000000', 'temperatura', 1076.0000, 'ºC'),
	(251979, 120, '2014-03-15 00:52:09.000000', 'temperatura', 235.0000, 'ºC'),
	(251980, 120, '2014-03-15 00:52:10.000000', 'temperatura', 350.0000, 'ºC'),
	(251981, 120, '2014-03-15 00:52:11.000000', 'temperatura', 1044.0000, 'ºC'),
	(251982, 120, '2014-03-15 00:52:12.000000', 'temperatura', 570.0000, 'ºC'),
	(251983, 120, '2014-03-15 00:52:13.000000', 'temperatura', 917.0000, 'ºC'),
	(251984, 120, '2014-03-15 00:52:14.000000', 'temperatura', 477.0000, 'ºC'),
	(251985, 120, '2014-03-15 00:52:15.000000', 'temperatura', 834.0000, 'ºC'),
	(251986, 120, '2014-03-15 00:52:16.000000', 'temperatura', 341.0000, 'ºC'),
	(251987, 120, '2014-03-15 00:52:17.000000', 'temperatura', 401.0000, 'ºC'),
	(251988, 120, '2014-03-15 00:52:18.000000', 'temperatura', 982.0000, 'ºC'),
	(251989, 120, '2014-03-15 00:52:19.000000', 'temperatura', 108.0000, 'ºC'),
	(251990, 120, '2014-03-15 00:52:20.000000', 'temperatura', 1193.0000, 'ºC'),
	(251991, 120, '2014-03-15 00:52:21.000000', 'temperatura', 843.0000, 'ºC'),
	(251992, 120, '2014-03-15 00:52:22.000000', 'temperatura', 636.0000, 'ºC'),
	(251993, 120, '2014-03-15 00:52:23.000000', 'temperatura', 652.0000, 'ºC'),
	(251994, 120, '2014-03-15 00:52:24.000000', 'temperatura', 150.0000, 'ºC'),
	(251995, 120, '2014-03-15 00:52:25.000000', 'temperatura', 1197.0000, 'ºC'),
	(251996, 120, '2014-03-15 00:52:26.000000', 'temperatura', 736.0000, 'ºC'),
	(251997, 120, '2014-03-15 00:52:27.000000', 'temperatura', 89.0000, 'ºC'),
	(251998, 120, '2014-03-15 00:52:28.000000', 'temperatura', 637.0000, 'ºC'),
	(251999, 120, '2014-03-15 00:52:29.000000', 'temperatura', 519.0000, 'ºC'),
	(252000, 120, '2014-03-15 00:52:30.000000', 'temperatura', 685.0000, 'ºC'),
	(252001, 120, '2014-03-15 00:52:31.000000', 'temperatura', 666.0000, 'ºC'),
	(252002, 120, '2014-03-15 00:52:32.000000', 'temperatura', 78.0000, 'ºC'),
	(252003, 120, '2014-03-15 00:52:33.000000', 'temperatura', 794.0000, 'ºC'),
	(252004, 120, '2014-03-15 00:52:34.000000', 'temperatura', 133.0000, 'ºC'),
	(252005, 120, '2014-03-15 00:52:35.000000', 'temperatura', 684.0000, 'ºC'),
	(252006, 120, '2014-03-15 00:52:36.000000', 'temperatura', 622.0000, 'ºC'),
	(252007, 120, '2014-03-15 00:52:37.000000', 'temperatura', 1056.0000, 'ºC'),
	(252008, 120, '2014-03-15 00:52:38.000000', 'temperatura', 1018.0000, 'ºC'),
	(252009, 120, '2014-03-15 00:52:39.000000', 'temperatura', 722.0000, 'ºC'),
	(252010, 120, '2014-03-15 00:52:40.000000', 'temperatura', 554.0000, 'ºC'),
	(252011, 120, '2014-03-15 00:52:41.000000', 'temperatura', 607.0000, 'ºC'),
	(252012, 120, '2014-03-15 00:52:42.000000', 'temperatura', 173.0000, 'ºC'),
	(252013, 120, '2014-03-15 00:52:43.000000', 'temperatura', 246.0000, 'ºC'),
	(252014, 120, '2014-03-15 00:52:44.000000', 'temperatura', 710.0000, 'ºC'),
	(252015, 120, '2014-03-15 00:52:45.000000', 'temperatura', 414.0000, 'ºC'),
	(252016, 120, '2014-03-15 00:52:46.000000', 'temperatura', 1141.0000, 'ºC'),
	(252017, 120, '2014-03-15 00:52:47.000000', 'temperatura', 864.0000, 'ºC'),
	(252018, 120, '2014-03-15 00:52:48.000000', 'temperatura', 897.0000, 'ºC'),
	(252019, 120, '2014-03-15 00:52:49.000000', 'temperatura', 693.0000, 'ºC'),
	(252020, 120, '2014-03-15 00:52:50.000000', 'temperatura', 774.0000, 'ºC'),
	(252021, 120, '2014-03-15 00:52:51.000000', 'temperatura', 592.0000, 'ºC'),
	(252022, 120, '2014-03-15 00:52:52.000000', 'temperatura', 640.0000, 'ºC'),
	(252023, 120, '2014-03-15 00:52:53.000000', 'temperatura', 223.0000, 'ºC'),
	(252024, 120, '2014-03-15 00:52:54.000000', 'temperatura', 394.0000, 'ºC'),
	(252025, 120, '2014-03-15 00:52:55.000000', 'temperatura', 102.0000, 'ºC'),
	(252026, 120, '2014-03-15 00:52:56.000000', 'temperatura', 529.0000, 'ºC'),
	(252027, 120, '2014-03-15 00:52:57.000000', 'temperatura', 1137.0000, 'ºC'),
	(252028, 120, '2014-03-15 00:52:58.000000', 'temperatura', 502.0000, 'ºC'),
	(252029, 120, '2014-03-15 00:52:59.000000', 'temperatura', 299.0000, 'ºC'),
	(252030, 120, '2014-03-15 00:53:00.000000', 'temperatura', 1191.0000, 'ºC'),
	(252031, 120, '2014-03-15 00:53:01.000000', 'temperatura', 256.0000, 'ºC'),
	(252032, 120, '2014-03-15 00:53:02.000000', 'temperatura', 107.0000, 'ºC'),
	(252033, 120, '2014-03-15 00:53:03.000000', 'temperatura', 969.0000, 'ºC'),
	(252034, 120, '2014-03-15 00:53:04.000000', 'temperatura', 923.0000, 'ºC'),
	(252035, 120, '2014-03-15 00:53:05.000000', 'temperatura', 510.0000, 'ºC'),
	(252036, 120, '2014-03-15 00:53:06.000000', 'temperatura', 981.0000, 'ºC'),
	(252037, 120, '2014-03-15 00:53:07.000000', 'temperatura', 974.0000, 'ºC'),
	(252038, 120, '2014-03-15 00:53:08.000000', 'temperatura', 729.0000, 'ºC'),
	(252039, 120, '2014-03-15 00:53:09.000000', 'temperatura', 721.0000, 'ºC'),
	(252040, 120, '2014-03-15 00:53:10.000000', 'temperatura', 221.0000, 'ºC'),
	(252041, 120, '2014-03-15 00:53:11.000000', 'temperatura', 142.0000, 'ºC'),
	(252042, 120, '2014-03-15 00:53:12.000000', 'temperatura', 48.0000, 'ºC'),
	(252043, 120, '2014-03-15 00:53:13.000000', 'temperatura', 1014.0000, 'ºC'),
	(252044, 120, '2014-03-15 00:53:14.000000', 'temperatura', 128.0000, 'ºC'),
	(252045, 120, '2014-03-15 00:53:15.000000', 'temperatura', 1197.0000, 'ºC'),
	(252046, 120, '2014-03-15 00:53:16.000000', 'temperatura', 801.0000, 'ºC'),
	(252047, 120, '2014-03-15 00:53:17.000000', 'temperatura', 415.0000, 'ºC'),
	(252048, 120, '2014-03-15 00:53:18.000000', 'temperatura', 874.0000, 'ºC'),
	(252049, 120, '2014-03-15 00:53:19.000000', 'temperatura', 726.0000, 'ºC'),
	(252050, 120, '2014-03-15 00:53:20.000000', 'temperatura', 1008.0000, 'ºC'),
	(252051, 120, '2014-03-15 00:53:21.000000', 'temperatura', 463.0000, 'ºC'),
	(252052, 120, '2014-03-15 00:53:22.000000', 'temperatura', 492.0000, 'ºC'),
	(252053, 120, '2014-03-15 00:53:23.000000', 'temperatura', 1072.0000, 'ºC'),
	(252054, 120, '2014-03-15 00:53:24.000000', 'temperatura', 284.0000, 'ºC'),
	(252055, 120, '2014-03-15 00:53:25.000000', 'temperatura', 606.0000, 'ºC'),
	(252056, 120, '2014-03-15 00:53:26.000000', 'temperatura', 978.0000, 'ºC'),
	(252057, 120, '2014-03-15 00:53:27.000000', 'temperatura', 673.0000, 'ºC'),
	(252058, 120, '2014-03-15 00:53:28.000000', 'temperatura', 430.0000, 'ºC'),
	(252059, 120, '2014-03-15 00:53:29.000000', 'temperatura', 130.0000, 'ºC'),
	(252060, 120, '2014-03-15 00:53:30.000000', 'temperatura', 563.0000, 'ºC'),
	(252061, 120, '2014-03-15 00:53:31.000000', 'temperatura', 23.0000, 'ºC'),
	(252062, 120, '2014-03-15 00:53:32.000000', 'temperatura', 830.0000, 'ºC'),
	(252063, 120, '2014-03-15 00:53:33.000000', 'temperatura', 478.0000, 'ºC'),
	(252064, 120, '2014-03-15 00:53:34.000000', 'temperatura', 1103.0000, 'ºC'),
	(252065, 120, '2014-03-15 00:53:35.000000', 'temperatura', 481.0000, 'ºC'),
	(252066, 120, '2014-03-15 00:53:36.000000', 'temperatura', 295.0000, 'ºC'),
	(252067, 120, '2014-03-15 00:53:37.000000', 'temperatura', 35.0000, 'ºC'),
	(252068, 120, '2014-03-15 00:53:38.000000', 'temperatura', 491.0000, 'ºC'),
	(252069, 120, '2014-03-15 00:53:39.000000', 'temperatura', 1149.0000, 'ºC'),
	(252070, 120, '2014-03-15 00:53:40.000000', 'temperatura', 674.0000, 'ºC'),
	(252071, 120, '2014-03-15 00:53:41.000000', 'temperatura', 1121.0000, 'ºC'),
	(252072, 120, '2014-03-15 00:53:42.000000', 'temperatura', 1184.0000, 'ºC'),
	(252073, 120, '2014-03-15 00:53:43.000000', 'temperatura', 157.0000, 'ºC'),
	(252074, 120, '2014-03-15 00:53:44.000000', 'temperatura', 835.0000, 'ºC'),
	(252075, 120, '2014-03-15 00:53:45.000000', 'temperatura', 106.0000, 'ºC'),
	(252076, 120, '2014-03-15 00:53:46.000000', 'temperatura', 423.0000, 'ºC'),
	(252077, 120, '2014-03-15 00:53:47.000000', 'temperatura', 599.0000, 'ºC'),
	(252078, 120, '2014-03-15 00:53:48.000000', 'temperatura', 527.0000, 'ºC'),
	(252079, 120, '2014-03-15 00:53:49.000000', 'temperatura', 838.0000, 'ºC'),
	(252080, 120, '2014-03-15 00:53:50.000000', 'temperatura', 211.0000, 'ºC'),
	(252081, 120, '2014-03-15 00:53:51.000000', 'temperatura', 942.0000, 'ºC'),
	(252082, 120, '2014-03-15 00:53:52.000000', 'temperatura', 477.0000, 'ºC'),
	(252083, 120, '2014-03-15 00:53:53.000000', 'temperatura', 758.0000, 'ºC'),
	(252084, 120, '2014-03-15 00:53:54.000000', 'temperatura', 1158.0000, 'ºC'),
	(252085, 120, '2014-03-15 00:53:55.000000', 'temperatura', 1120.0000, 'ºC'),
	(252086, 120, '2014-03-15 00:53:56.000000', 'temperatura', 923.0000, 'ºC'),
	(252087, 120, '2014-03-15 00:53:57.000000', 'temperatura', 57.0000, 'ºC'),
	(252088, 120, '2014-03-15 00:53:58.000000', 'temperatura', 1117.0000, 'ºC'),
	(252089, 120, '2014-03-15 00:53:59.000000', 'temperatura', 614.0000, 'ºC'),
	(252090, 120, '2014-03-15 00:54:00.000000', 'temperatura', 919.0000, 'ºC'),
	(252091, 120, '2014-03-15 00:54:01.000000', 'temperatura', 356.0000, 'ºC'),
	(252092, 120, '2014-03-15 00:54:02.000000', 'temperatura', 222.0000, 'ºC'),
	(252093, 120, '2014-03-15 00:54:03.000000', 'temperatura', 42.0000, 'ºC'),
	(252094, 120, '2014-03-15 00:54:04.000000', 'temperatura', 746.0000, 'ºC'),
	(252095, 120, '2014-03-15 00:54:05.000000', 'temperatura', 5.0000, 'ºC'),
	(252096, 120, '2014-03-15 00:54:06.000000', 'temperatura', 185.0000, 'ºC'),
	(252097, 120, '2014-03-15 00:54:07.000000', 'temperatura', 913.0000, 'ºC'),
	(252098, 120, '2014-03-15 00:54:08.000000', 'temperatura', 408.0000, 'ºC'),
	(252099, 120, '2014-03-15 00:54:09.000000', 'temperatura', 500.0000, 'ºC'),
	(252100, 120, '2014-03-15 00:54:10.000000', 'temperatura', 80.0000, 'ºC'),
	(252101, 120, '2014-03-15 00:54:11.000000', 'temperatura', 101.0000, 'ºC'),
	(252102, 120, '2014-03-15 00:54:12.000000', 'temperatura', 264.0000, 'ºC'),
	(252103, 120, '2014-03-15 00:54:13.000000', 'temperatura', 1018.0000, 'ºC'),
	(252104, 120, '2014-03-15 00:54:14.000000', 'temperatura', 699.0000, 'ºC'),
	(252105, 120, '2014-03-15 00:54:15.000000', 'temperatura', 443.0000, 'ºC'),
	(252106, 120, '2014-03-15 00:54:16.000000', 'temperatura', 115.0000, 'ºC'),
	(252107, 120, '2014-03-15 00:54:17.000000', 'temperatura', 448.0000, 'ºC'),
	(252108, 120, '2014-03-15 00:54:18.000000', 'temperatura', 697.0000, 'ºC'),
	(252109, 120, '2014-03-15 00:54:19.000000', 'temperatura', 942.0000, 'ºC'),
	(252110, 120, '2014-03-15 00:54:20.000000', 'temperatura', 219.0000, 'ºC'),
	(252111, 120, '2014-03-15 00:54:21.000000', 'temperatura', 669.0000, 'ºC'),
	(252112, 120, '2014-03-15 00:54:22.000000', 'temperatura', 287.0000, 'ºC'),
	(252113, 120, '2014-03-15 00:54:23.000000', 'temperatura', 632.0000, 'ºC'),
	(252114, 120, '2014-03-15 00:54:24.000000', 'temperatura', 1096.0000, 'ºC'),
	(252115, 120, '2014-03-15 00:54:25.000000', 'temperatura', 1184.0000, 'ºC'),
	(252116, 120, '2014-03-15 00:54:26.000000', 'temperatura', 235.0000, 'ºC'),
	(252117, 120, '2014-03-15 00:54:27.000000', 'temperatura', 24.0000, 'ºC'),
	(252118, 120, '2014-03-15 00:54:28.000000', 'temperatura', 616.0000, 'ºC'),
	(252119, 120, '2014-03-15 00:54:29.000000', 'temperatura', 608.0000, 'ºC'),
	(252120, 120, '2014-03-15 00:54:30.000000', 'temperatura', 1190.0000, 'ºC'),
	(252121, 120, '2014-03-15 00:54:31.000000', 'temperatura', 529.0000, 'ºC'),
	(252122, 120, '2014-03-15 00:54:32.000000', 'temperatura', 275.0000, 'ºC'),
	(252123, 120, '2014-03-15 00:54:33.000000', 'temperatura', 990.0000, 'ºC'),
	(252124, 120, '2014-03-15 00:54:34.000000', 'temperatura', 526.0000, 'ºC'),
	(252125, 120, '2014-03-15 00:54:35.000000', 'temperatura', 861.0000, 'ºC'),
	(252126, 120, '2014-03-15 00:54:36.000000', 'temperatura', 328.0000, 'ºC'),
	(252127, 120, '2014-03-15 00:54:37.000000', 'temperatura', 254.0000, 'ºC'),
	(252128, 120, '2014-03-15 00:54:38.000000', 'temperatura', 289.0000, 'ºC'),
	(252129, 120, '2014-03-15 00:54:39.000000', 'temperatura', 685.0000, 'ºC'),
	(252130, 120, '2014-03-15 00:54:40.000000', 'temperatura', 157.0000, 'ºC'),
	(252131, 120, '2014-03-15 00:54:41.000000', 'temperatura', 1130.0000, 'ºC'),
	(252132, 120, '2014-03-15 00:54:42.000000', 'temperatura', 381.0000, 'ºC'),
	(252133, 120, '2014-03-15 00:54:43.000000', 'temperatura', 914.0000, 'ºC'),
	(252134, 120, '2014-03-15 00:54:44.000000', 'temperatura', 1029.0000, 'ºC'),
	(252135, 120, '2014-03-15 00:54:45.000000', 'temperatura', 4.0000, 'ºC'),
	(252136, 120, '2014-03-15 00:54:46.000000', 'temperatura', 533.0000, 'ºC'),
	(252137, 120, '2014-03-15 00:54:47.000000', 'temperatura', 252.0000, 'ºC'),
	(252138, 120, '2014-03-15 00:54:48.000000', 'temperatura', 864.0000, 'ºC'),
	(252139, 120, '2014-03-15 00:54:49.000000', 'temperatura', 1163.0000, 'ºC'),
	(252140, 120, '2014-03-15 00:54:50.000000', 'temperatura', 823.0000, 'ºC'),
	(252141, 120, '2014-03-15 00:54:51.000000', 'temperatura', 625.0000, 'ºC'),
	(252142, 120, '2014-03-15 00:54:52.000000', 'temperatura', 659.0000, 'ºC'),
	(252143, 120, '2014-03-15 00:54:53.000000', 'temperatura', 220.0000, 'ºC'),
	(252144, 120, '2014-03-15 00:54:54.000000', 'temperatura', 324.0000, 'ºC'),
	(252145, 120, '2014-03-15 00:54:55.000000', 'temperatura', 958.0000, 'ºC'),
	(252146, 120, '2014-03-15 00:54:56.000000', 'temperatura', 220.0000, 'ºC'),
	(252147, 120, '2014-03-15 00:54:57.000000', 'temperatura', 626.0000, 'ºC'),
	(252148, 120, '2014-03-15 00:54:58.000000', 'temperatura', 73.0000, 'ºC'),
	(252149, 120, '2014-03-15 00:54:59.000000', 'temperatura', 884.0000, 'ºC'),
	(252150, 120, '2014-03-15 00:55:00.000000', 'temperatura', 604.0000, 'ºC'),
	(252151, 120, '2014-03-15 00:55:01.000000', 'temperatura', 368.0000, 'ºC'),
	(252152, 120, '2014-03-15 00:55:02.000000', 'temperatura', 29.0000, 'ºC'),
	(252153, 120, '2014-03-15 00:55:03.000000', 'temperatura', 241.0000, 'ºC'),
	(252154, 120, '2014-03-15 00:55:04.000000', 'temperatura', 1117.0000, 'ºC'),
	(252155, 120, '2014-03-15 00:55:05.000000', 'temperatura', 62.0000, 'ºC'),
	(252156, 120, '2014-03-15 00:55:06.000000', 'temperatura', 561.0000, 'ºC'),
	(252157, 120, '2014-03-15 00:55:07.000000', 'temperatura', 221.0000, 'ºC'),
	(252158, 120, '2014-03-15 00:55:08.000000', 'temperatura', 621.0000, 'ºC'),
	(252159, 120, '2014-03-15 00:55:09.000000', 'temperatura', 42.0000, 'ºC'),
	(252160, 120, '2014-03-15 00:55:10.000000', 'temperatura', 748.0000, 'ºC'),
	(252161, 120, '2014-03-15 00:55:11.000000', 'temperatura', 16.0000, 'ºC'),
	(252162, 120, '2014-03-15 00:55:12.000000', 'temperatura', 234.0000, 'ºC'),
	(252163, 120, '2014-03-15 00:55:13.000000', 'temperatura', 1122.0000, 'ºC'),
	(252164, 120, '2014-03-15 00:55:14.000000', 'temperatura', 111.0000, 'ºC'),
	(252165, 120, '2014-03-15 00:55:15.000000', 'temperatura', 788.0000, 'ºC'),
	(252166, 120, '2014-03-15 00:55:16.000000', 'temperatura', 8.0000, 'ºC'),
	(252167, 120, '2014-03-15 00:55:17.000000', 'temperatura', 78.0000, 'ºC'),
	(252168, 120, '2014-03-15 00:55:18.000000', 'temperatura', 366.0000, 'ºC'),
	(252169, 120, '2014-03-15 00:55:19.000000', 'temperatura', 397.0000, 'ºC'),
	(252170, 120, '2014-03-15 00:55:20.000000', 'temperatura', 887.0000, 'ºC'),
	(252171, 120, '2014-03-15 00:55:21.000000', 'temperatura', 843.0000, 'ºC'),
	(252172, 120, '2014-03-15 00:55:22.000000', 'temperatura', 357.0000, 'ºC'),
	(252173, 120, '2014-03-15 00:55:23.000000', 'temperatura', 454.0000, 'ºC'),
	(252174, 120, '2014-03-15 00:55:24.000000', 'temperatura', 2.0000, 'ºC'),
	(252175, 120, '2014-03-15 00:55:25.000000', 'temperatura', 1047.0000, 'ºC'),
	(252176, 120, '2014-03-15 00:55:26.000000', 'temperatura', 428.0000, 'ºC'),
	(252177, 120, '2014-03-15 00:55:27.000000', 'temperatura', 202.0000, 'ºC'),
	(252178, 120, '2014-03-15 00:55:28.000000', 'temperatura', 924.0000, 'ºC'),
	(252179, 120, '2014-03-15 00:55:29.000000', 'temperatura', 416.0000, 'ºC'),
	(252180, 120, '2014-03-15 00:55:30.000000', 'temperatura', 507.0000, 'ºC'),
	(252181, 120, '2014-03-15 00:55:31.000000', 'temperatura', 90.0000, 'ºC'),
	(252182, 120, '2014-03-15 00:55:32.000000', 'temperatura', 129.0000, 'ºC'),
	(252183, 120, '2014-03-15 00:55:33.000000', 'temperatura', 377.0000, 'ºC'),
	(252184, 120, '2014-03-15 00:55:34.000000', 'temperatura', 295.0000, 'ºC'),
	(252185, 120, '2014-03-15 00:55:35.000000', 'temperatura', 346.0000, 'ºC'),
	(252186, 120, '2014-03-15 00:55:36.000000', 'temperatura', 847.0000, 'ºC'),
	(252187, 120, '2014-03-15 00:55:37.000000', 'temperatura', 798.0000, 'ºC'),
	(252188, 120, '2014-03-15 00:55:38.000000', 'temperatura', 249.0000, 'ºC'),
	(252189, 120, '2014-03-15 00:55:39.000000', 'temperatura', 50.0000, 'ºC'),
	(252190, 120, '2014-03-15 00:55:40.000000', 'temperatura', 702.0000, 'ºC'),
	(252191, 120, '2014-03-15 00:55:41.000000', 'temperatura', 963.0000, 'ºC'),
	(252192, 120, '2014-03-15 00:55:42.000000', 'temperatura', 311.0000, 'ºC'),
	(252193, 120, '2014-03-15 00:55:43.000000', 'temperatura', 1064.0000, 'ºC'),
	(252194, 120, '2014-03-15 00:55:44.000000', 'temperatura', 789.0000, 'ºC'),
	(252195, 120, '2014-03-15 00:55:45.000000', 'temperatura', 755.0000, 'ºC'),
	(252196, 120, '2014-03-15 00:55:46.000000', 'temperatura', 206.0000, 'ºC'),
	(252197, 120, '2014-03-15 00:55:47.000000', 'temperatura', 1166.0000, 'ºC'),
	(252198, 120, '2014-03-15 00:55:48.000000', 'temperatura', 413.0000, 'ºC'),
	(252199, 120, '2014-03-15 00:55:49.000000', 'temperatura', 969.0000, 'ºC'),
	(252200, 120, '2014-03-15 00:55:50.000000', 'temperatura', 4.0000, 'ºC'),
	(252201, 120, '2014-03-15 00:55:51.000000', 'temperatura', 713.0000, 'ºC'),
	(252202, 120, '2014-03-15 00:55:52.000000', 'temperatura', 1156.0000, 'ºC'),
	(252203, 120, '2014-03-15 00:55:53.000000', 'temperatura', 40.0000, 'ºC'),
	(252204, 120, '2014-03-15 00:55:54.000000', 'temperatura', 331.0000, 'ºC'),
	(252205, 120, '2014-03-15 00:55:55.000000', 'temperatura', 336.0000, 'ºC'),
	(252206, 120, '2014-03-15 00:55:56.000000', 'temperatura', 688.0000, 'ºC'),
	(252207, 120, '2014-03-15 00:55:57.000000', 'temperatura', 33.0000, 'ºC'),
	(252208, 120, '2014-03-15 00:55:58.000000', 'temperatura', 503.0000, 'ºC'),
	(252209, 120, '2014-03-15 00:55:59.000000', 'temperatura', 14.0000, 'ºC'),
	(252210, 120, '2014-03-15 00:56:00.000000', 'temperatura', 963.0000, 'ºC'),
	(252211, 120, '2014-03-15 00:56:01.000000', 'temperatura', 1172.0000, 'ºC'),
	(252212, 120, '2014-03-15 00:56:02.000000', 'temperatura', 572.0000, 'ºC'),
	(252213, 120, '2014-03-15 00:56:03.000000', 'temperatura', 544.0000, 'ºC'),
	(252214, 120, '2014-03-15 00:56:04.000000', 'temperatura', 1005.0000, 'ºC'),
	(252215, 120, '2014-03-15 00:56:05.000000', 'temperatura', 992.0000, 'ºC'),
	(252216, 120, '2014-03-15 00:56:06.000000', 'temperatura', 745.0000, 'ºC'),
	(252217, 120, '2014-03-15 00:56:07.000000', 'temperatura', 751.0000, 'ºC'),
	(252218, 120, '2014-03-15 00:56:08.000000', 'temperatura', 319.0000, 'ºC'),
	(252219, 120, '2014-03-15 00:56:09.000000', 'temperatura', 545.0000, 'ºC'),
	(252220, 120, '2014-03-15 00:56:10.000000', 'temperatura', 567.0000, 'ºC'),
	(252221, 120, '2014-03-15 00:56:11.000000', 'temperatura', 2.0000, 'ºC'),
	(252222, 120, '2014-03-15 00:56:12.000000', 'temperatura', 710.0000, 'ºC'),
	(252223, 120, '2014-03-15 00:56:13.000000', 'temperatura', 1144.0000, 'ºC'),
	(252224, 120, '2014-03-15 00:56:14.000000', 'temperatura', 1191.0000, 'ºC'),
	(252225, 120, '2014-03-15 00:56:15.000000', 'temperatura', 124.0000, 'ºC'),
	(252226, 120, '2014-03-15 00:56:16.000000', 'temperatura', 649.0000, 'ºC'),
	(252227, 120, '2014-03-15 00:56:17.000000', 'temperatura', 471.0000, 'ºC'),
	(252228, 120, '2014-03-15 00:56:18.000000', 'temperatura', 410.0000, 'ºC'),
	(252229, 120, '2014-03-15 00:56:19.000000', 'temperatura', 635.0000, 'ºC'),
	(252230, 120, '2014-03-15 00:56:20.000000', 'temperatura', 748.0000, 'ºC'),
	(252231, 120, '2014-03-15 00:56:21.000000', 'temperatura', 637.0000, 'ºC'),
	(252232, 120, '2014-03-15 00:56:22.000000', 'temperatura', 938.0000, 'ºC'),
	(252233, 120, '2014-03-15 00:56:23.000000', 'temperatura', 380.0000, 'ºC'),
	(252234, 120, '2014-03-15 00:56:24.000000', 'temperatura', 287.0000, 'ºC'),
	(252235, 120, '2014-03-15 00:56:25.000000', 'temperatura', 295.0000, 'ºC'),
	(252236, 120, '2014-03-15 00:56:26.000000', 'temperatura', 614.0000, 'ºC'),
	(252237, 120, '2014-03-15 00:56:27.000000', 'temperatura', 985.0000, 'ºC'),
	(252238, 120, '2014-03-15 00:56:28.000000', 'temperatura', 684.0000, 'ºC'),
	(252239, 120, '2014-03-15 00:56:29.000000', 'temperatura', 465.0000, 'ºC'),
	(252240, 120, '2014-03-15 00:56:30.000000', 'temperatura', 274.0000, 'ºC'),
	(252241, 120, '2014-03-15 00:56:31.000000', 'temperatura', 1174.0000, 'ºC'),
	(252242, 120, '2014-03-15 00:56:32.000000', 'temperatura', 251.0000, 'ºC'),
	(252243, 120, '2014-03-15 00:56:33.000000', 'temperatura', 132.0000, 'ºC'),
	(252244, 120, '2014-03-15 00:56:34.000000', 'temperatura', 1107.0000, 'ºC'),
	(252245, 120, '2014-03-15 00:56:35.000000', 'temperatura', 341.0000, 'ºC'),
	(252246, 120, '2014-03-15 00:56:36.000000', 'temperatura', 782.0000, 'ºC'),
	(252247, 120, '2014-03-15 00:56:37.000000', 'temperatura', 488.0000, 'ºC'),
	(252248, 120, '2014-03-15 00:56:38.000000', 'temperatura', 97.0000, 'ºC'),
	(252249, 120, '2014-03-15 00:56:39.000000', 'temperatura', 219.0000, 'ºC'),
	(252250, 120, '2014-03-15 00:56:40.000000', 'temperatura', 805.0000, 'ºC'),
	(252251, 120, '2014-03-15 00:56:41.000000', 'temperatura', 968.0000, 'ºC'),
	(252252, 120, '2014-03-15 00:56:42.000000', 'temperatura', 26.0000, 'ºC'),
	(252253, 120, '2014-03-15 00:56:43.000000', 'temperatura', 827.0000, 'ºC'),
	(252254, 120, '2014-03-15 00:56:44.000000', 'temperatura', 456.0000, 'ºC'),
	(252255, 120, '2014-03-15 00:56:45.000000', 'temperatura', 999.0000, 'ºC'),
	(252256, 120, '2014-03-15 00:56:46.000000', 'temperatura', 27.0000, 'ºC'),
	(252257, 120, '2014-03-15 00:56:47.000000', 'temperatura', 738.0000, 'ºC'),
	(252258, 120, '2014-03-15 00:56:48.000000', 'temperatura', 10.0000, 'ºC'),
	(252259, 120, '2014-03-15 00:56:49.000000', 'temperatura', 238.0000, 'ºC'),
	(252260, 120, '2014-03-15 00:56:50.000000', 'temperatura', 1161.0000, 'ºC'),
	(252261, 120, '2014-03-15 00:56:51.000000', 'temperatura', 291.0000, 'ºC'),
	(252262, 120, '2014-03-15 00:56:52.000000', 'temperatura', 370.0000, 'ºC'),
	(252263, 120, '2014-03-15 00:56:53.000000', 'temperatura', 980.0000, 'ºC'),
	(252264, 120, '2014-03-15 00:56:54.000000', 'temperatura', 190.0000, 'ºC'),
	(252265, 120, '2014-03-15 00:56:55.000000', 'temperatura', 410.0000, 'ºC'),
	(252266, 120, '2014-03-15 00:56:56.000000', 'temperatura', 283.0000, 'ºC'),
	(252267, 120, '2014-03-15 00:56:57.000000', 'temperatura', 182.0000, 'ºC'),
	(252268, 120, '2014-03-15 00:56:58.000000', 'temperatura', 64.0000, 'ºC'),
	(252269, 120, '2014-03-15 00:56:59.000000', 'temperatura', 973.0000, 'ºC'),
	(252270, 120, '2014-03-15 00:57:00.000000', 'temperatura', 1072.0000, 'ºC'),
	(252271, 120, '2014-03-15 00:57:01.000000', 'temperatura', 43.0000, 'ºC'),
	(252272, 120, '2014-03-15 00:57:02.000000', 'temperatura', 601.0000, 'ºC'),
	(252273, 120, '2014-03-15 00:57:03.000000', 'temperatura', 474.0000, 'ºC'),
	(252274, 120, '2014-03-15 00:57:04.000000', 'temperatura', 567.0000, 'ºC'),
	(252275, 120, '2014-03-15 00:57:05.000000', 'temperatura', 214.0000, 'ºC'),
	(252276, 120, '2014-03-15 00:57:06.000000', 'temperatura', 570.0000, 'ºC'),
	(252277, 120, '2014-03-15 00:57:07.000000', 'temperatura', 1008.0000, 'ºC'),
	(252278, 120, '2014-03-15 00:57:08.000000', 'temperatura', 931.0000, 'ºC'),
	(252279, 120, '2014-03-15 00:57:09.000000', 'temperatura', 430.0000, 'ºC'),
	(252280, 120, '2014-03-15 00:57:10.000000', 'temperatura', 557.0000, 'ºC'),
	(252281, 120, '2014-03-15 00:57:11.000000', 'temperatura', 298.0000, 'ºC'),
	(252282, 120, '2014-03-15 00:57:12.000000', 'temperatura', 1019.0000, 'ºC'),
	(252283, 120, '2014-03-15 00:57:13.000000', 'temperatura', 603.0000, 'ºC'),
	(252284, 120, '2014-03-15 00:57:14.000000', 'temperatura', 1156.0000, 'ºC'),
	(252285, 120, '2014-03-15 00:57:15.000000', 'temperatura', 371.0000, 'ºC'),
	(252286, 120, '2014-03-15 00:57:16.000000', 'temperatura', 789.0000, 'ºC'),
	(252287, 120, '2014-03-15 00:57:17.000000', 'temperatura', 434.0000, 'ºC'),
	(252288, 120, '2014-03-15 00:57:18.000000', 'temperatura', 1002.0000, 'ºC'),
	(252289, 120, '2014-03-15 00:57:19.000000', 'temperatura', 110.0000, 'ºC'),
	(252290, 120, '2014-03-15 00:57:20.000000', 'temperatura', 1144.0000, 'ºC'),
	(252291, 120, '2014-03-15 00:57:21.000000', 'temperatura', 589.0000, 'ºC'),
	(252292, 120, '2014-03-15 00:57:22.000000', 'temperatura', 716.0000, 'ºC'),
	(252293, 120, '2014-03-15 00:57:23.000000', 'temperatura', 612.0000, 'ºC'),
	(252294, 120, '2014-03-15 00:57:24.000000', 'temperatura', 912.0000, 'ºC'),
	(252295, 120, '2014-03-15 00:57:25.000000', 'temperatura', 326.0000, 'ºC'),
	(252296, 120, '2014-03-15 00:57:26.000000', 'temperatura', 93.0000, 'ºC'),
	(252297, 120, '2014-03-15 00:57:27.000000', 'temperatura', 687.0000, 'ºC'),
	(252298, 120, '2014-03-15 00:57:28.000000', 'temperatura', 759.0000, 'ºC'),
	(252299, 120, '2014-03-15 00:57:29.000000', 'temperatura', 534.0000, 'ºC'),
	(252300, 120, '2014-03-15 00:57:30.000000', 'temperatura', 391.0000, 'ºC'),
	(252301, 120, '2014-03-15 00:57:31.000000', 'temperatura', 356.0000, 'ºC'),
	(252302, 120, '2014-03-15 00:57:32.000000', 'temperatura', 608.0000, 'ºC'),
	(252303, 120, '2014-03-15 00:57:33.000000', 'temperatura', 774.0000, 'ºC'),
	(252304, 120, '2014-03-15 00:57:34.000000', 'temperatura', 843.0000, 'ºC'),
	(252305, 120, '2014-03-15 00:57:35.000000', 'temperatura', 694.0000, 'ºC'),
	(252306, 120, '2014-03-15 00:57:36.000000', 'temperatura', 941.0000, 'ºC'),
	(252307, 120, '2014-03-15 00:57:37.000000', 'temperatura', 226.0000, 'ºC'),
	(252308, 120, '2014-03-15 00:57:38.000000', 'temperatura', 705.0000, 'ºC'),
	(252309, 120, '2014-03-15 00:57:39.000000', 'temperatura', 447.0000, 'ºC'),
	(252310, 120, '2014-03-15 00:57:40.000000', 'temperatura', 122.0000, 'ºC'),
	(252311, 120, '2014-03-15 00:57:41.000000', 'temperatura', 470.0000, 'ºC'),
	(252312, 120, '2014-03-15 00:57:42.000000', 'temperatura', 786.0000, 'ºC'),
	(252313, 120, '2014-03-15 00:57:43.000000', 'temperatura', 118.0000, 'ºC'),
	(252314, 120, '2014-03-15 00:57:44.000000', 'temperatura', 634.0000, 'ºC'),
	(252315, 120, '2014-03-15 00:57:45.000000', 'temperatura', 417.0000, 'ºC'),
	(252316, 120, '2014-03-15 00:57:46.000000', 'temperatura', 182.0000, 'ºC'),
	(252317, 120, '2014-03-15 00:57:47.000000', 'temperatura', 861.0000, 'ºC'),
	(252318, 120, '2014-03-15 00:57:48.000000', 'temperatura', 159.0000, 'ºC'),
	(252319, 120, '2014-03-15 00:57:49.000000', 'temperatura', 610.0000, 'ºC'),
	(252320, 120, '2014-03-15 00:57:50.000000', 'temperatura', 177.0000, 'ºC'),
	(252321, 120, '2014-03-15 00:57:51.000000', 'temperatura', 252.0000, 'ºC'),
	(252322, 120, '2014-03-15 00:57:52.000000', 'temperatura', 733.0000, 'ºC'),
	(252323, 120, '2014-03-15 00:57:53.000000', 'temperatura', 507.0000, 'ºC'),
	(252324, 120, '2014-03-15 00:57:54.000000', 'temperatura', 337.0000, 'ºC'),
	(252325, 120, '2014-03-15 00:57:55.000000', 'temperatura', 163.0000, 'ºC'),
	(252326, 120, '2014-03-15 00:57:56.000000', 'temperatura', 1006.0000, 'ºC'),
	(252327, 120, '2014-03-15 00:57:57.000000', 'temperatura', 940.0000, 'ºC'),
	(252328, 120, '2014-03-15 00:57:58.000000', 'temperatura', 484.0000, 'ºC'),
	(252329, 120, '2014-03-15 00:57:59.000000', 'temperatura', 800.0000, 'ºC'),
	(252330, 120, '2014-03-15 00:58:00.000000', 'temperatura', 149.0000, 'ºC'),
	(252331, 120, '2014-03-15 00:58:01.000000', 'temperatura', 746.0000, 'ºC'),
	(252332, 120, '2014-03-15 00:58:02.000000', 'temperatura', 883.0000, 'ºC'),
	(252333, 120, '2014-03-15 00:58:03.000000', 'temperatura', 977.0000, 'ºC'),
	(252334, 120, '2014-03-15 00:58:04.000000', 'temperatura', 1038.0000, 'ºC'),
	(252335, 120, '2014-03-15 00:58:05.000000', 'temperatura', 1058.0000, 'ºC'),
	(252336, 120, '2014-03-15 00:58:06.000000', 'temperatura', 976.0000, 'ºC'),
	(252337, 120, '2014-03-15 00:58:07.000000', 'temperatura', 508.0000, 'ºC'),
	(252338, 120, '2014-03-15 00:58:08.000000', 'temperatura', 813.0000, 'ºC'),
	(252339, 120, '2014-03-15 00:58:09.000000', 'temperatura', 139.0000, 'ºC'),
	(252340, 120, '2014-03-15 00:58:10.000000', 'temperatura', 657.0000, 'ºC'),
	(252341, 120, '2014-03-15 00:58:11.000000', 'temperatura', 469.0000, 'ºC'),
	(252342, 120, '2014-03-15 00:58:12.000000', 'temperatura', 374.0000, 'ºC'),
	(252343, 120, '2014-03-15 00:58:13.000000', 'temperatura', 462.0000, 'ºC'),
	(252344, 120, '2014-03-15 00:58:14.000000', 'temperatura', 1191.0000, 'ºC'),
	(252345, 120, '2014-03-15 00:58:15.000000', 'temperatura', 969.0000, 'ºC'),
	(252346, 120, '2014-03-15 00:58:16.000000', 'temperatura', 71.0000, 'ºC'),
	(252347, 120, '2014-03-15 00:58:17.000000', 'temperatura', 1048.0000, 'ºC'),
	(252348, 120, '2014-03-15 00:58:18.000000', 'temperatura', 230.0000, 'ºC'),
	(252349, 120, '2014-03-15 00:58:19.000000', 'temperatura', 407.0000, 'ºC'),
	(252350, 120, '2014-03-15 00:58:20.000000', 'temperatura', 146.0000, 'ºC'),
	(252351, 120, '2014-03-15 00:58:21.000000', 'temperatura', 707.0000, 'ºC'),
	(252352, 120, '2014-03-15 00:58:22.000000', 'temperatura', 698.0000, 'ºC'),
	(252353, 120, '2014-03-15 00:58:23.000000', 'temperatura', 168.0000, 'ºC'),
	(252354, 120, '2014-03-15 00:58:24.000000', 'temperatura', 1148.0000, 'ºC'),
	(252355, 120, '2014-03-15 00:58:25.000000', 'temperatura', 437.0000, 'ºC'),
	(252356, 120, '2014-03-15 00:58:26.000000', 'temperatura', 1142.0000, 'ºC'),
	(252357, 120, '2014-03-15 00:58:27.000000', 'temperatura', 798.0000, 'ºC'),
	(252358, 120, '2014-03-15 00:58:28.000000', 'temperatura', 565.0000, 'ºC'),
	(252359, 120, '2014-03-15 00:58:29.000000', 'temperatura', 430.0000, 'ºC'),
	(252360, 120, '2014-03-15 00:58:30.000000', 'temperatura', 457.0000, 'ºC'),
	(252361, 120, '2014-03-15 00:58:31.000000', 'temperatura', 995.0000, 'ºC'),
	(252362, 120, '2014-03-15 00:58:32.000000', 'temperatura', 5.0000, 'ºC'),
	(252363, 120, '2014-03-15 00:58:33.000000', 'temperatura', 638.0000, 'ºC'),
	(252364, 120, '2014-03-15 00:58:34.000000', 'temperatura', 778.0000, 'ºC'),
	(252365, 120, '2014-03-15 00:58:35.000000', 'temperatura', 775.0000, 'ºC'),
	(252366, 120, '2014-03-15 00:58:36.000000', 'temperatura', 342.0000, 'ºC'),
	(252367, 120, '2014-03-15 00:58:37.000000', 'temperatura', 587.0000, 'ºC'),
	(252368, 120, '2014-03-15 00:58:38.000000', 'temperatura', 707.0000, 'ºC'),
	(252369, 120, '2014-03-15 00:58:39.000000', 'temperatura', 574.0000, 'ºC'),
	(252370, 120, '2014-03-15 00:58:40.000000', 'temperatura', 751.0000, 'ºC'),
	(252371, 120, '2014-03-15 00:58:41.000000', 'temperatura', 832.0000, 'ºC'),
	(252372, 120, '2014-03-15 00:58:42.000000', 'temperatura', 706.0000, 'ºC'),
	(252373, 120, '2014-03-15 00:58:43.000000', 'temperatura', 1038.0000, 'ºC'),
	(252374, 120, '2014-03-15 00:58:44.000000', 'temperatura', 670.0000, 'ºC'),
	(252375, 120, '2014-03-15 00:58:45.000000', 'temperatura', 239.0000, 'ºC'),
	(252376, 120, '2014-03-15 00:58:46.000000', 'temperatura', 386.0000, 'ºC'),
	(252377, 120, '2014-03-15 00:58:47.000000', 'temperatura', 12.0000, 'ºC'),
	(252378, 120, '2014-03-15 00:58:48.000000', 'temperatura', 103.0000, 'ºC'),
	(252379, 120, '2014-03-15 00:58:49.000000', 'temperatura', 480.0000, 'ºC'),
	(252380, 120, '2014-03-15 00:58:50.000000', 'temperatura', 889.0000, 'ºC'),
	(252381, 120, '2014-03-15 00:58:51.000000', 'temperatura', 607.0000, 'ºC'),
	(252382, 120, '2014-03-15 00:58:52.000000', 'temperatura', 367.0000, 'ºC'),
	(252383, 120, '2014-03-15 00:58:53.000000', 'temperatura', 13.0000, 'ºC'),
	(252384, 120, '2014-03-15 00:58:54.000000', 'temperatura', 168.0000, 'ºC'),
	(252385, 120, '2014-03-15 00:58:55.000000', 'temperatura', 800.0000, 'ºC'),
	(252386, 120, '2014-03-15 00:58:56.000000', 'temperatura', 1096.0000, 'ºC'),
	(252387, 120, '2014-03-15 00:58:57.000000', 'temperatura', 683.0000, 'ºC'),
	(252388, 120, '2014-03-15 00:58:58.000000', 'temperatura', 127.0000, 'ºC'),
	(252389, 120, '2014-03-15 00:58:59.000000', 'temperatura', 984.0000, 'ºC'),
	(252390, 120, '2014-03-15 00:59:00.000000', 'temperatura', 940.0000, 'ºC'),
	(252391, 120, '2014-03-15 00:59:01.000000', 'temperatura', 547.0000, 'ºC'),
	(252392, 120, '2014-03-15 00:59:02.000000', 'temperatura', 1119.0000, 'ºC'),
	(252393, 120, '2014-03-15 00:59:03.000000', 'temperatura', 353.0000, 'ºC'),
	(252394, 120, '2014-03-15 00:59:04.000000', 'temperatura', 808.0000, 'ºC'),
	(252395, 120, '2014-03-15 00:59:05.000000', 'temperatura', 580.0000, 'ºC'),
	(252396, 120, '2014-03-15 00:59:06.000000', 'temperatura', 477.0000, 'ºC'),
	(252397, 120, '2014-03-15 00:59:07.000000', 'temperatura', 647.0000, 'ºC'),
	(252398, 120, '2014-03-15 00:59:08.000000', 'temperatura', 604.0000, 'ºC'),
	(252399, 120, '2014-03-15 00:59:09.000000', 'temperatura', 1078.0000, 'ºC'),
	(252400, 120, '2014-03-15 00:59:10.000000', 'temperatura', 1179.0000, 'ºC'),
	(252401, 120, '2014-03-15 00:59:11.000000', 'temperatura', 261.0000, 'ºC'),
	(252402, 120, '2014-03-15 00:59:12.000000', 'temperatura', 168.0000, 'ºC'),
	(252403, 120, '2014-03-15 00:59:13.000000', 'temperatura', 56.0000, 'ºC'),
	(252404, 120, '2014-03-15 00:59:14.000000', 'temperatura', 979.0000, 'ºC'),
	(252405, 120, '2014-03-15 00:59:15.000000', 'temperatura', 1129.0000, 'ºC'),
	(252406, 120, '2014-03-15 00:59:16.000000', 'temperatura', 306.0000, 'ºC'),
	(252407, 120, '2014-03-15 00:59:17.000000', 'temperatura', 546.0000, 'ºC'),
	(252408, 120, '2014-03-15 00:59:18.000000', 'temperatura', 611.0000, 'ºC'),
	(252409, 120, '2014-03-15 00:59:19.000000', 'temperatura', 218.0000, 'ºC'),
	(252410, 120, '2014-03-15 00:59:20.000000', 'temperatura', 457.0000, 'ºC'),
	(252411, 120, '2014-03-15 00:59:21.000000', 'temperatura', 431.0000, 'ºC'),
	(252412, 120, '2014-03-15 00:59:22.000000', 'temperatura', 786.0000, 'ºC'),
	(252413, 120, '2014-03-15 00:59:23.000000', 'temperatura', 235.0000, 'ºC'),
	(252414, 120, '2014-03-15 00:59:24.000000', 'temperatura', 18.0000, 'ºC'),
	(252415, 120, '2014-03-15 00:59:25.000000', 'temperatura', 587.0000, 'ºC'),
	(252416, 120, '2014-03-15 00:59:26.000000', 'temperatura', 480.0000, 'ºC'),
	(252417, 120, '2014-03-15 00:59:27.000000', 'temperatura', 639.0000, 'ºC'),
	(252418, 120, '2014-03-15 00:59:28.000000', 'temperatura', 557.0000, 'ºC'),
	(252419, 120, '2014-03-15 00:59:29.000000', 'temperatura', 869.0000, 'ºC'),
	(252420, 120, '2014-03-15 00:59:30.000000', 'temperatura', 273.0000, 'ºC'),
	(252421, 120, '2014-03-15 00:59:31.000000', 'temperatura', 1160.0000, 'ºC'),
	(252422, 120, '2014-03-15 00:59:32.000000', 'temperatura', 182.0000, 'ºC'),
	(252423, 120, '2014-03-15 00:59:33.000000', 'temperatura', 1029.0000, 'ºC'),
	(252424, 120, '2014-03-15 00:59:34.000000', 'temperatura', 1000.0000, 'ºC'),
	(252425, 120, '2014-03-15 00:59:35.000000', 'temperatura', 713.0000, 'ºC'),
	(252426, 120, '2014-03-15 00:59:36.000000', 'temperatura', 566.0000, 'ºC'),
	(252427, 120, '2014-03-15 00:59:37.000000', 'temperatura', 690.0000, 'ºC'),
	(252428, 120, '2014-03-15 00:59:38.000000', 'temperatura', 552.0000, 'ºC'),
	(252429, 120, '2014-03-15 00:59:39.000000', 'temperatura', 691.0000, 'ºC'),
	(252430, 120, '2014-03-15 00:59:40.000000', 'temperatura', 600.0000, 'ºC'),
	(252431, 120, '2014-03-15 00:59:41.000000', 'temperatura', 927.0000, 'ºC'),
	(252432, 120, '2014-03-15 00:59:42.000000', 'temperatura', 437.0000, 'ºC'),
	(252433, 120, '2014-03-15 00:59:43.000000', 'temperatura', 603.0000, 'ºC'),
	(252434, 120, '2014-03-15 00:59:44.000000', 'temperatura', 507.0000, 'ºC'),
	(252435, 120, '2014-03-15 00:59:45.000000', 'temperatura', 724.0000, 'ºC'),
	(252436, 120, '2014-03-15 00:59:46.000000', 'temperatura', 899.0000, 'ºC'),
	(252437, 120, '2014-03-15 00:59:47.000000', 'temperatura', 1124.0000, 'ºC'),
	(252438, 120, '2014-03-15 00:59:48.000000', 'temperatura', 524.0000, 'ºC'),
	(252439, 120, '2014-03-15 00:59:49.000000', 'temperatura', 447.0000, 'ºC'),
	(252440, 120, '2014-03-15 00:59:50.000000', 'temperatura', 666.0000, 'ºC'),
	(252441, 120, '2014-03-15 00:59:51.000000', 'temperatura', 790.0000, 'ºC'),
	(252442, 120, '2014-03-15 00:59:52.000000', 'temperatura', 751.0000, 'ºC'),
	(252443, 120, '2014-03-15 00:59:53.000000', 'temperatura', 187.0000, 'ºC'),
	(252444, 120, '2014-03-15 00:59:54.000000', 'temperatura', 1083.0000, 'ºC'),
	(252445, 120, '2014-03-15 00:59:55.000000', 'temperatura', 52.0000, 'ºC'),
	(252446, 120, '2014-03-15 00:59:56.000000', 'temperatura', 613.0000, 'ºC'),
	(252447, 120, '2014-03-15 00:59:57.000000', 'temperatura', 508.0000, 'ºC'),
	(252448, 120, '2014-03-15 00:59:58.000000', 'temperatura', 702.0000, 'ºC'),
	(252449, 120, '2014-03-15 00:59:59.000000', 'temperatura', 788.0000, 'ºC'),
	(252450, 120, '2014-03-15 01:00:00.000000', 'temperatura', 632.0000, 'ºC'),
	(252451, 120, '2014-03-15 01:00:01.000000', 'temperatura', 796.0000, 'ºC'),
	(252452, 120, '2014-03-15 01:00:02.000000', 'temperatura', 884.0000, 'ºC'),
	(252453, 120, '2014-03-15 01:00:03.000000', 'temperatura', 833.0000, 'ºC'),
	(252454, 120, '2014-03-15 01:00:04.000000', 'temperatura', 315.0000, 'ºC'),
	(252455, 120, '2014-03-15 01:00:05.000000', 'temperatura', 276.0000, 'ºC'),
	(252456, 120, '2014-03-15 01:00:06.000000', 'temperatura', 436.0000, 'ºC'),
	(252457, 120, '2014-03-15 01:00:07.000000', 'temperatura', 152.0000, 'ºC'),
	(252458, 120, '2014-03-15 01:00:08.000000', 'temperatura', 652.0000, 'ºC'),
	(252459, 120, '2014-03-15 01:00:09.000000', 'temperatura', 405.0000, 'ºC'),
	(252460, 120, '2014-03-15 01:00:10.000000', 'temperatura', 69.0000, 'ºC'),
	(252461, 120, '2014-03-15 01:00:11.000000', 'temperatura', 331.0000, 'ºC'),
	(252462, 120, '2014-03-15 01:00:12.000000', 'temperatura', 248.0000, 'ºC'),
	(252463, 120, '2014-03-15 01:00:13.000000', 'temperatura', 247.0000, 'ºC'),
	(252464, 120, '2014-03-15 01:00:14.000000', 'temperatura', 492.0000, 'ºC'),
	(252465, 120, '2014-03-15 01:00:15.000000', 'temperatura', 519.0000, 'ºC'),
	(252466, 120, '2014-03-15 01:00:16.000000', 'temperatura', 1121.0000, 'ºC'),
	(252467, 120, '2014-03-15 01:00:17.000000', 'temperatura', 448.0000, 'ºC'),
	(252468, 120, '2014-03-15 01:00:18.000000', 'temperatura', 77.0000, 'ºC'),
	(252469, 120, '2014-03-15 01:00:19.000000', 'temperatura', 241.0000, 'ºC'),
	(252470, 120, '2014-03-15 01:00:20.000000', 'temperatura', 974.0000, 'ºC'),
	(252471, 120, '2014-03-15 01:00:21.000000', 'temperatura', 548.0000, 'ºC'),
	(252472, 120, '2014-03-15 01:00:22.000000', 'temperatura', 1021.0000, 'ºC'),
	(252473, 120, '2014-03-15 01:00:23.000000', 'temperatura', 1059.0000, 'ºC'),
	(252474, 120, '2014-03-15 01:00:24.000000', 'temperatura', 1033.0000, 'ºC'),
	(252475, 120, '2014-03-15 01:00:25.000000', 'temperatura', 787.0000, 'ºC'),
	(252476, 120, '2014-03-15 01:00:26.000000', 'temperatura', 839.0000, 'ºC'),
	(252477, 120, '2014-03-15 01:00:27.000000', 'temperatura', 634.0000, 'ºC'),
	(252478, 120, '2014-03-15 01:00:28.000000', 'temperatura', 654.0000, 'ºC'),
	(252479, 120, '2014-03-15 01:00:29.000000', 'temperatura', 166.0000, 'ºC'),
	(252480, 120, '2014-03-15 01:00:30.000000', 'temperatura', 71.0000, 'ºC'),
	(252481, 120, '2014-03-15 01:00:31.000000', 'temperatura', 1057.0000, 'ºC'),
	(252482, 120, '2014-03-15 01:00:32.000000', 'temperatura', 271.0000, 'ºC'),
	(252483, 120, '2014-03-15 01:00:33.000000', 'temperatura', 584.0000, 'ºC'),
	(252484, 120, '2014-03-15 01:00:34.000000', 'temperatura', 910.0000, 'ºC'),
	(252485, 120, '2014-03-15 01:00:35.000000', 'temperatura', 397.0000, 'ºC'),
	(252486, 120, '2014-03-15 01:00:36.000000', 'temperatura', 455.0000, 'ºC'),
	(252487, 120, '2014-03-15 01:00:37.000000', 'temperatura', 1085.0000, 'ºC'),
	(252488, 120, '2014-03-15 01:00:38.000000', 'temperatura', 459.0000, 'ºC'),
	(252489, 120, '2014-03-15 01:00:39.000000', 'temperatura', 240.0000, 'ºC'),
	(252490, 120, '2014-03-15 01:00:40.000000', 'temperatura', 1026.0000, 'ºC'),
	(252491, 120, '2014-03-15 01:00:41.000000', 'temperatura', 810.0000, 'ºC'),
	(252492, 120, '2014-03-15 01:00:42.000000', 'temperatura', 972.0000, 'ºC'),
	(252493, 120, '2014-03-15 01:00:43.000000', 'temperatura', 32.0000, 'ºC'),
	(252494, 120, '2014-03-15 01:00:44.000000', 'temperatura', 846.0000, 'ºC'),
	(252495, 120, '2014-03-15 01:00:45.000000', 'temperatura', 531.0000, 'ºC'),
	(252496, 120, '2014-03-15 01:00:46.000000', 'temperatura', 118.0000, 'ºC'),
	(252497, 120, '2014-03-15 01:00:47.000000', 'temperatura', 198.0000, 'ºC'),
	(252498, 120, '2014-03-15 01:00:48.000000', 'temperatura', 636.0000, 'ºC'),
	(252499, 120, '2014-03-15 01:00:49.000000', 'temperatura', 188.0000, 'ºC'),
	(252500, 120, '2014-03-15 01:00:50.000000', 'temperatura', 231.0000, 'ºC'),
	(252501, 120, '2014-03-15 01:00:51.000000', 'temperatura', 593.0000, 'ºC'),
	(252502, 120, '2014-03-15 01:00:52.000000', 'temperatura', 1071.0000, 'ºC'),
	(252503, 120, '2014-03-15 01:00:53.000000', 'temperatura', 1176.0000, 'ºC'),
	(252504, 120, '2014-03-15 01:00:54.000000', 'temperatura', 268.0000, 'ºC'),
	(252505, 120, '2014-03-15 01:00:55.000000', 'temperatura', 213.0000, 'ºC'),
	(252506, 120, '2014-03-15 01:00:56.000000', 'temperatura', 261.0000, 'ºC'),
	(252507, 120, '2014-03-15 01:00:57.000000', 'temperatura', 667.0000, 'ºC'),
	(252508, 120, '2014-03-15 01:00:58.000000', 'temperatura', 153.0000, 'ºC'),
	(252509, 120, '2014-03-15 01:00:59.000000', 'temperatura', 1162.0000, 'ºC'),
	(252510, 120, '2014-03-15 01:01:00.000000', 'temperatura', 554.0000, 'ºC'),
	(252511, 120, '2014-03-15 01:01:01.000000', 'temperatura', 485.0000, 'ºC'),
	(252512, 120, '2014-03-15 01:01:02.000000', 'temperatura', 763.0000, 'ºC'),
	(252513, 120, '2014-03-15 01:01:03.000000', 'temperatura', 1158.0000, 'ºC'),
	(252514, 120, '2014-03-15 01:01:04.000000', 'temperatura', 1105.0000, 'ºC'),
	(252515, 120, '2014-03-15 01:01:05.000000', 'temperatura', 851.0000, 'ºC'),
	(252516, 120, '2014-03-15 01:01:06.000000', 'temperatura', 939.0000, 'ºC'),
	(252517, 120, '2014-03-15 01:01:07.000000', 'temperatura', 944.0000, 'ºC'),
	(252518, 120, '2014-03-15 01:01:08.000000', 'temperatura', 701.0000, 'ºC'),
	(252519, 120, '2014-03-15 01:01:09.000000', 'temperatura', 676.0000, 'ºC'),
	(252520, 120, '2014-03-15 01:01:10.000000', 'temperatura', 75.0000, 'ºC'),
	(252521, 120, '2014-03-15 01:01:11.000000', 'temperatura', 751.0000, 'ºC'),
	(252522, 120, '2014-03-15 01:01:12.000000', 'temperatura', 1128.0000, 'ºC'),
	(252523, 120, '2014-03-15 01:01:13.000000', 'temperatura', 987.0000, 'ºC'),
	(252524, 120, '2014-03-15 01:01:14.000000', 'temperatura', 351.0000, 'ºC'),
	(252525, 120, '2014-03-15 01:01:15.000000', 'temperatura', 1197.0000, 'ºC'),
	(252526, 120, '2014-03-15 01:01:16.000000', 'temperatura', 133.0000, 'ºC'),
	(252527, 120, '2014-03-15 01:01:17.000000', 'temperatura', 673.0000, 'ºC'),
	(252528, 120, '2014-03-15 01:01:18.000000', 'temperatura', 566.0000, 'ºC'),
	(252529, 120, '2014-03-15 01:01:19.000000', 'temperatura', 811.0000, 'ºC'),
	(252530, 120, '2014-03-15 01:01:20.000000', 'temperatura', 1156.0000, 'ºC'),
	(252531, 120, '2014-03-15 01:01:21.000000', 'temperatura', 950.0000, 'ºC'),
	(252532, 120, '2014-03-15 01:01:22.000000', 'temperatura', 80.0000, 'ºC'),
	(252533, 120, '2014-03-15 01:01:23.000000', 'temperatura', 1153.0000, 'ºC'),
	(252534, 120, '2014-03-15 01:01:24.000000', 'temperatura', 726.0000, 'ºC'),
	(252535, 120, '2014-03-15 01:01:25.000000', 'temperatura', 169.0000, 'ºC'),
	(252536, 120, '2014-03-15 01:01:26.000000', 'temperatura', 1067.0000, 'ºC'),
	(252537, 120, '2014-03-15 01:01:27.000000', 'temperatura', 28.0000, 'ºC'),
	(252538, 120, '2014-03-15 01:01:28.000000', 'temperatura', 542.0000, 'ºC'),
	(252539, 120, '2014-03-15 01:01:29.000000', 'temperatura', 226.0000, 'ºC'),
	(252540, 120, '2014-03-15 01:01:30.000000', 'temperatura', 703.0000, 'ºC'),
	(252541, 120, '2014-03-15 01:01:31.000000', 'temperatura', 440.0000, 'ºC'),
	(252542, 120, '2014-03-15 01:01:32.000000', 'temperatura', 89.0000, 'ºC'),
	(252543, 120, '2014-03-15 01:01:33.000000', 'temperatura', 326.0000, 'ºC'),
	(252544, 120, '2014-03-15 01:01:34.000000', 'temperatura', 163.0000, 'ºC'),
	(252545, 120, '2014-03-15 01:01:35.000000', 'temperatura', 1039.0000, 'ºC'),
	(252546, 120, '2014-03-15 01:01:36.000000', 'temperatura', 1106.0000, 'ºC'),
	(252547, 120, '2014-03-15 01:01:37.000000', 'temperatura', 12.0000, 'ºC'),
	(252548, 120, '2014-03-15 01:01:38.000000', 'temperatura', 342.0000, 'ºC'),
	(252549, 120, '2014-03-15 01:01:39.000000', 'temperatura', 474.0000, 'ºC'),
	(252550, 120, '2014-03-15 01:01:40.000000', 'temperatura', 145.0000, 'ºC'),
	(252551, 120, '2014-03-15 01:01:41.000000', 'temperatura', 506.0000, 'ºC'),
	(252552, 120, '2014-03-15 01:01:42.000000', 'temperatura', 894.0000, 'ºC'),
	(252553, 120, '2014-03-15 01:01:43.000000', 'temperatura', 552.0000, 'ºC'),
	(252554, 120, '2014-03-15 01:01:44.000000', 'temperatura', 80.0000, 'ºC'),
	(252555, 120, '2014-03-15 01:01:45.000000', 'temperatura', 1143.0000, 'ºC'),
	(252556, 120, '2014-03-15 01:01:46.000000', 'temperatura', 676.0000, 'ºC'),
	(252557, 120, '2014-03-15 01:01:47.000000', 'temperatura', 1151.0000, 'ºC'),
	(252558, 120, '2014-03-15 01:01:48.000000', 'temperatura', 126.0000, 'ºC'),
	(252559, 120, '2014-03-15 01:01:49.000000', 'temperatura', 778.0000, 'ºC'),
	(252560, 120, '2014-03-15 01:01:50.000000', 'temperatura', 1115.0000, 'ºC'),
	(252561, 120, '2014-03-15 01:01:51.000000', 'temperatura', 839.0000, 'ºC'),
	(252562, 120, '2014-03-15 01:01:52.000000', 'temperatura', 853.0000, 'ºC'),
	(252563, 120, '2014-03-15 01:01:53.000000', 'temperatura', 547.0000, 'ºC'),
	(252564, 120, '2014-03-15 01:01:54.000000', 'temperatura', 178.0000, 'ºC'),
	(252565, 120, '2014-03-15 01:01:55.000000', 'temperatura', 449.0000, 'ºC'),
	(252566, 120, '2014-03-15 01:01:56.000000', 'temperatura', 510.0000, 'ºC'),
	(252567, 120, '2014-03-15 01:01:57.000000', 'temperatura', 6.0000, 'ºC'),
	(252568, 120, '2014-03-15 01:01:58.000000', 'temperatura', 900.0000, 'ºC'),
	(252569, 120, '2014-03-15 01:01:59.000000', 'temperatura', 884.0000, 'ºC'),
	(252570, 120, '2014-03-15 01:02:00.000000', 'temperatura', 519.0000, 'ºC'),
	(252571, 120, '2014-03-15 01:02:01.000000', 'temperatura', 1143.0000, 'ºC'),
	(252572, 120, '2014-03-15 01:02:02.000000', 'temperatura', 559.0000, 'ºC'),
	(252573, 120, '2014-03-15 01:02:03.000000', 'temperatura', 566.0000, 'ºC'),
	(252574, 120, '2014-03-15 01:02:04.000000', 'temperatura', 1152.0000, 'ºC'),
	(252575, 120, '2014-03-15 01:02:05.000000', 'temperatura', 464.0000, 'ºC'),
	(252576, 120, '2014-03-15 01:02:06.000000', 'temperatura', 66.0000, 'ºC'),
	(252577, 120, '2014-03-15 01:02:07.000000', 'temperatura', 136.0000, 'ºC'),
	(252578, 120, '2014-03-15 01:02:08.000000', 'temperatura', 483.0000, 'ºC'),
	(252579, 120, '2014-03-15 01:02:09.000000', 'temperatura', 810.0000, 'ºC'),
	(252580, 120, '2014-03-15 01:02:10.000000', 'temperatura', 198.0000, 'ºC'),
	(252581, 120, '2014-03-15 01:02:11.000000', 'temperatura', 963.0000, 'ºC'),
	(252582, 120, '2014-03-15 01:02:12.000000', 'temperatura', 621.0000, 'ºC'),
	(252583, 120, '2014-03-15 01:02:13.000000', 'temperatura', 216.0000, 'ºC'),
	(252584, 120, '2014-03-15 01:02:14.000000', 'temperatura', 420.0000, 'ºC'),
	(252585, 120, '2014-03-15 01:02:15.000000', 'temperatura', 249.0000, 'ºC'),
	(252586, 120, '2014-03-15 01:02:16.000000', 'temperatura', 1186.0000, 'ºC'),
	(252587, 120, '2014-03-15 01:02:17.000000', 'temperatura', 383.0000, 'ºC'),
	(252588, 120, '2014-03-15 01:02:18.000000', 'temperatura', 759.0000, 'ºC'),
	(252589, 120, '2014-03-15 01:02:19.000000', 'temperatura', 244.0000, 'ºC'),
	(252590, 120, '2014-03-15 01:02:20.000000', 'temperatura', 144.0000, 'ºC'),
	(252591, 120, '2014-03-15 01:02:21.000000', 'temperatura', 1191.0000, 'ºC'),
	(252592, 120, '2014-03-15 01:02:22.000000', 'temperatura', 723.0000, 'ºC'),
	(252593, 120, '2014-03-15 01:02:23.000000', 'temperatura', 40.0000, 'ºC'),
	(252594, 120, '2014-03-15 01:02:24.000000', 'temperatura', 434.0000, 'ºC'),
	(252595, 120, '2014-03-15 01:02:25.000000', 'temperatura', 850.0000, 'ºC'),
	(252596, 120, '2014-03-15 01:02:26.000000', 'temperatura', 549.0000, 'ºC'),
	(252597, 120, '2014-03-15 01:02:27.000000', 'temperatura', 193.0000, 'ºC'),
	(252598, 120, '2014-03-15 01:02:28.000000', 'temperatura', 521.0000, 'ºC'),
	(252599, 120, '2014-03-15 01:02:29.000000', 'temperatura', 827.0000, 'ºC'),
	(252600, 120, '2014-03-15 01:02:30.000000', 'temperatura', 172.0000, 'ºC'),
	(252601, 120, '2014-03-15 01:02:31.000000', 'temperatura', 781.0000, 'ºC'),
	(252602, 120, '2014-03-15 01:02:32.000000', 'temperatura', 989.0000, 'ºC'),
	(252603, 120, '2014-03-15 01:02:33.000000', 'temperatura', 201.0000, 'ºC'),
	(252604, 120, '2014-03-15 01:02:34.000000', 'temperatura', 438.0000, 'ºC'),
	(252605, 120, '2014-03-15 01:02:35.000000', 'temperatura', 389.0000, 'ºC'),
	(252606, 120, '2014-03-15 01:02:36.000000', 'temperatura', 631.0000, 'ºC'),
	(252607, 120, '2014-03-15 01:02:37.000000', 'temperatura', 790.0000, 'ºC'),
	(252608, 120, '2014-03-15 01:02:38.000000', 'temperatura', 856.0000, 'ºC'),
	(252609, 120, '2014-03-15 01:02:39.000000', 'temperatura', 710.0000, 'ºC'),
	(252610, 120, '2014-03-15 01:02:40.000000', 'temperatura', 984.0000, 'ºC'),
	(252611, 120, '2014-03-15 01:02:41.000000', 'temperatura', 390.0000, 'ºC'),
	(252612, 120, '2014-03-15 01:02:42.000000', 'temperatura', 200.0000, 'ºC'),
	(252613, 120, '2014-03-15 01:02:43.000000', 'temperatura', 1028.0000, 'ºC'),
	(252614, 120, '2014-03-15 01:02:44.000000', 'temperatura', 943.0000, 'ºC'),
	(252615, 120, '2014-03-15 01:02:45.000000', 'temperatura', 431.0000, 'ºC'),
	(252616, 120, '2014-03-15 01:02:46.000000', 'temperatura', 526.0000, 'ºC'),
	(252617, 120, '2014-03-15 01:02:47.000000', 'temperatura', 139.0000, 'ºC'),
	(252618, 120, '2014-03-15 01:02:48.000000', 'temperatura', 318.0000, 'ºC'),
	(252619, 120, '2014-03-15 01:02:49.000000', 'temperatura', 1173.0000, 'ºC'),
	(252620, 120, '2014-03-15 01:02:50.000000', 'temperatura', 111.0000, 'ºC'),
	(252621, 120, '2014-03-15 01:02:51.000000', 'temperatura', 635.0000, 'ºC'),
	(252622, 120, '2014-03-15 01:02:52.000000', 'temperatura', 444.0000, 'ºC'),
	(252623, 120, '2014-03-15 01:02:53.000000', 'temperatura', 317.0000, 'ºC'),
	(252624, 120, '2014-03-15 01:02:54.000000', 'temperatura', 253.0000, 'ºC'),
	(252625, 120, '2014-03-15 01:02:55.000000', 'temperatura', 313.0000, 'ºC'),
	(252626, 120, '2014-03-15 01:02:56.000000', 'temperatura', 808.0000, 'ºC'),
	(252627, 120, '2014-03-15 01:02:57.000000', 'temperatura', 700.0000, 'ºC'),
	(252628, 120, '2014-03-15 01:02:58.000000', 'temperatura', 1077.0000, 'ºC'),
	(252629, 120, '2014-03-15 01:02:59.000000', 'temperatura', 888.0000, 'ºC'),
	(252630, 120, '2014-03-15 01:03:00.000000', 'temperatura', 6.0000, 'ºC'),
	(252631, 120, '2014-03-15 01:03:01.000000', 'temperatura', 969.0000, 'ºC'),
	(252632, 120, '2014-03-15 01:03:02.000000', 'temperatura', 27.0000, 'ºC'),
	(252633, 120, '2014-03-15 01:03:03.000000', 'temperatura', 826.0000, 'ºC'),
	(252634, 120, '2014-03-15 01:03:04.000000', 'temperatura', 453.0000, 'ºC'),
	(252635, 120, '2014-03-15 01:03:05.000000', 'temperatura', 985.0000, 'ºC'),
	(252636, 120, '2014-03-15 01:03:06.000000', 'temperatura', 1166.0000, 'ºC'),
	(252637, 120, '2014-03-15 01:03:07.000000', 'temperatura', 476.0000, 'ºC'),
	(252638, 120, '2014-03-15 01:03:08.000000', 'temperatura', 83.0000, 'ºC'),
	(252639, 120, '2014-03-15 01:03:09.000000', 'temperatura', 185.0000, 'ºC'),
	(252640, 120, '2014-03-15 01:03:10.000000', 'temperatura', 680.0000, 'ºC'),
	(252641, 120, '2014-03-15 01:03:11.000000', 'temperatura', 443.0000, 'ºC'),
	(252642, 120, '2014-03-15 01:03:12.000000', 'temperatura', 177.0000, 'ºC'),
	(252643, 120, '2014-03-15 01:03:13.000000', 'temperatura', 756.0000, 'ºC'),
	(252644, 120, '2014-03-15 01:03:14.000000', 'temperatura', 849.0000, 'ºC'),
	(252645, 120, '2014-03-15 01:03:15.000000', 'temperatura', 779.0000, 'ºC'),
	(252646, 120, '2014-03-15 01:03:16.000000', 'temperatura', 147.0000, 'ºC'),
	(252647, 120, '2014-03-15 01:03:17.000000', 'temperatura', 800.0000, 'ºC'),
	(252648, 120, '2014-03-15 01:03:18.000000', 'temperatura', 1159.0000, 'ºC'),
	(252649, 120, '2014-03-15 01:03:19.000000', 'temperatura', 995.0000, 'ºC'),
	(252650, 120, '2014-03-15 01:03:20.000000', 'temperatura', 299.0000, 'ºC'),
	(252651, 120, '2014-03-15 01:03:21.000000', 'temperatura', 912.0000, 'ºC'),
	(252652, 120, '2014-03-15 01:03:22.000000', 'temperatura', 64.0000, 'ºC'),
	(252653, 120, '2014-03-15 01:03:23.000000', 'temperatura', 1182.0000, 'ºC'),
	(252654, 120, '2014-03-15 01:03:24.000000', 'temperatura', 921.0000, 'ºC'),
	(252655, 120, '2014-03-15 01:03:25.000000', 'temperatura', 1058.0000, 'ºC'),
	(252656, 120, '2014-03-15 01:03:26.000000', 'temperatura', 127.0000, 'ºC'),
	(252657, 120, '2014-03-15 01:03:27.000000', 'temperatura', 1064.0000, 'ºC'),
	(252658, 120, '2014-03-15 01:03:28.000000', 'temperatura', 139.0000, 'ºC'),
	(252659, 120, '2014-03-15 01:03:29.000000', 'temperatura', 1102.0000, 'ºC'),
	(252660, 120, '2014-03-15 01:03:30.000000', 'temperatura', 295.0000, 'ºC'),
	(252661, 120, '2014-03-15 01:03:31.000000', 'temperatura', 567.0000, 'ºC'),
	(252662, 120, '2014-03-15 01:03:32.000000', 'temperatura', 752.0000, 'ºC'),
	(252663, 120, '2014-03-15 01:03:33.000000', 'temperatura', 858.0000, 'ºC'),
	(252664, 120, '2014-03-15 01:03:34.000000', 'temperatura', 835.0000, 'ºC'),
	(252665, 120, '2014-03-15 01:03:35.000000', 'temperatura', 400.0000, 'ºC'),
	(252666, 120, '2014-03-15 01:03:36.000000', 'temperatura', 697.0000, 'ºC'),
	(252667, 120, '2014-03-15 01:03:37.000000', 'temperatura', 1087.0000, 'ºC'),
	(252668, 120, '2014-03-15 01:03:38.000000', 'temperatura', 944.0000, 'ºC'),
	(252669, 120, '2014-03-15 01:03:39.000000', 'temperatura', 258.0000, 'ºC'),
	(252670, 120, '2014-03-15 01:03:40.000000', 'temperatura', 860.0000, 'ºC'),
	(252671, 120, '2014-03-15 01:03:41.000000', 'temperatura', 1127.0000, 'ºC'),
	(252672, 120, '2014-03-15 01:03:42.000000', 'temperatura', 653.0000, 'ºC'),
	(252673, 120, '2014-03-15 01:03:43.000000', 'temperatura', 1086.0000, 'ºC'),
	(252674, 120, '2014-03-15 01:03:44.000000', 'temperatura', 1073.0000, 'ºC'),
	(252675, 120, '2014-03-15 01:03:45.000000', 'temperatura', 905.0000, 'ºC'),
	(252676, 120, '2014-03-15 01:03:46.000000', 'temperatura', 106.0000, 'ºC'),
	(252677, 120, '2014-03-15 01:03:47.000000', 'temperatura', 216.0000, 'ºC'),
	(252678, 120, '2014-03-15 01:03:48.000000', 'temperatura', 763.0000, 'ºC'),
	(252679, 120, '2014-03-15 01:03:49.000000', 'temperatura', 767.0000, 'ºC'),
	(252680, 120, '2014-03-15 01:03:50.000000', 'temperatura', 345.0000, 'ºC'),
	(252681, 120, '2014-03-15 01:03:51.000000', 'temperatura', 625.0000, 'ºC'),
	(252682, 120, '2014-03-15 01:03:52.000000', 'temperatura', 890.0000, 'ºC'),
	(252683, 120, '2014-03-15 01:03:53.000000', 'temperatura', 175.0000, 'ºC'),
	(252684, 120, '2014-03-15 01:03:54.000000', 'temperatura', 604.0000, 'ºC'),
	(252685, 120, '2014-03-15 01:03:55.000000', 'temperatura', 98.0000, 'ºC'),
	(252686, 120, '2014-03-15 01:03:56.000000', 'temperatura', 1079.0000, 'ºC'),
	(252687, 120, '2014-03-15 01:03:57.000000', 'temperatura', 299.0000, 'ºC'),
	(252688, 120, '2014-03-15 01:03:58.000000', 'temperatura', 661.0000, 'ºC'),
	(252689, 120, '2014-03-15 01:03:59.000000', 'temperatura', 6.0000, 'ºC'),
	(252690, 120, '2014-03-15 01:04:00.000000', 'temperatura', 449.0000, 'ºC'),
	(252691, 120, '2014-03-15 01:04:01.000000', 'temperatura', 1026.0000, 'ºC'),
	(252692, 120, '2014-03-15 01:04:02.000000', 'temperatura', 185.0000, 'ºC'),
	(252693, 120, '2014-03-15 01:04:03.000000', 'temperatura', 245.0000, 'ºC'),
	(252694, 120, '2014-03-15 01:04:04.000000', 'temperatura', 674.0000, 'ºC'),
	(252695, 120, '2014-03-15 01:04:05.000000', 'temperatura', 234.0000, 'ºC'),
	(252696, 120, '2014-03-15 01:04:06.000000', 'temperatura', 348.0000, 'ºC'),
	(252697, 120, '2014-03-15 01:04:07.000000', 'temperatura', 1039.0000, 'ºC'),
	(252698, 120, '2014-03-15 01:04:08.000000', 'temperatura', 549.0000, 'ºC'),
	(252699, 120, '2014-03-15 01:04:09.000000', 'temperatura', 832.0000, 'ºC'),
	(252700, 120, '2014-03-15 01:04:10.000000', 'temperatura', 114.0000, 'ºC'),
	(252701, 120, '2014-03-15 01:04:11.000000', 'temperatura', 471.0000, 'ºC'),
	(252702, 120, '2014-03-15 01:04:12.000000', 'temperatura', 817.0000, 'ºC'),
	(252703, 120, '2014-03-15 01:04:13.000000', 'temperatura', 271.0000, 'ºC'),
	(252704, 120, '2014-03-15 01:04:14.000000', 'temperatura', 107.0000, 'ºC'),
	(252705, 120, '2014-03-15 01:04:15.000000', 'temperatura', 919.0000, 'ºC'),
	(252706, 120, '2014-03-15 01:04:16.000000', 'temperatura', 677.0000, 'ºC'),
	(252707, 120, '2014-03-15 01:04:17.000000', 'temperatura', 629.0000, 'ºC'),
	(252708, 120, '2014-03-15 01:04:18.000000', 'temperatura', 1113.0000, 'ºC'),
	(252709, 120, '2014-03-15 01:04:19.000000', 'temperatura', 79.0000, 'ºC'),
	(252710, 120, '2014-03-15 01:04:20.000000', 'temperatura', 658.0000, 'ºC'),
	(252711, 120, '2014-03-15 01:04:21.000000', 'temperatura', 652.0000, 'ºC'),
	(252712, 120, '2014-03-15 01:04:22.000000', 'temperatura', 87.0000, 'ºC'),
	(252713, 120, '2014-03-15 01:04:23.000000', 'temperatura', 878.0000, 'ºC'),
	(252714, 120, '2014-03-15 01:04:24.000000', 'temperatura', 530.0000, 'ºC'),
	(252715, 120, '2014-03-15 01:04:25.000000', 'temperatura', 17.0000, 'ºC'),
	(252716, 120, '2014-03-15 01:04:26.000000', 'temperatura', 896.0000, 'ºC'),
	(252717, 120, '2014-03-15 01:04:27.000000', 'temperatura', 829.0000, 'ºC'),
	(252718, 120, '2014-03-15 01:04:28.000000', 'temperatura', 259.0000, 'ºC'),
	(252719, 120, '2014-03-15 01:04:29.000000', 'temperatura', 6.0000, 'ºC'),
	(252720, 120, '2014-03-15 01:04:30.000000', 'temperatura', 454.0000, 'ºC'),
	(252721, 120, '2014-03-15 01:04:31.000000', 'temperatura', 1052.0000, 'ºC'),
	(252722, 120, '2014-03-15 01:04:32.000000', 'temperatura', 301.0000, 'ºC'),
	(252723, 120, '2014-03-15 01:04:33.000000', 'temperatura', 749.0000, 'ºC'),
	(252724, 120, '2014-03-15 01:04:34.000000', 'temperatura', 441.0000, 'ºC'),
	(252725, 120, '2014-03-15 01:04:35.000000', 'temperatura', 1159.0000, 'ºC'),
	(252726, 120, '2014-03-15 01:04:36.000000', 'temperatura', 873.0000, 'ºC'),
	(252727, 120, '2014-03-15 01:04:37.000000', 'temperatura', 890.0000, 'ºC'),
	(252728, 120, '2014-03-15 01:04:38.000000', 'temperatura', 628.0000, 'ºC'),
	(252729, 120, '2014-03-15 01:04:39.000000', 'temperatura', 473.0000, 'ºC'),
	(252730, 120, '2014-03-15 01:04:40.000000', 'temperatura', 479.0000, 'ºC'),
	(252731, 120, '2014-03-15 01:04:41.000000', 'temperatura', 977.0000, 'ºC'),
	(252732, 120, '2014-03-15 01:04:42.000000', 'temperatura', 1051.0000, 'ºC'),
	(252733, 120, '2014-03-15 01:04:43.000000', 'temperatura', 1123.0000, 'ºC'),
	(252734, 120, '2014-03-15 01:04:44.000000', 'temperatura', 63.0000, 'ºC'),
	(252735, 120, '2014-03-15 01:04:45.000000', 'temperatura', 548.0000, 'ºC'),
	(252736, 120, '2014-03-15 01:04:46.000000', 'temperatura', 148.0000, 'ºC'),
	(252737, 120, '2014-03-15 01:04:47.000000', 'temperatura', 299.0000, 'ºC'),
	(252738, 120, '2014-03-15 01:04:48.000000', 'temperatura', 1052.0000, 'ºC'),
	(252739, 120, '2014-03-15 01:04:49.000000', 'temperatura', 763.0000, 'ºC'),
	(252740, 120, '2014-03-15 01:04:50.000000', 'temperatura', 660.0000, 'ºC'),
	(252741, 120, '2014-03-15 01:04:51.000000', 'temperatura', 1010.0000, 'ºC'),
	(252742, 120, '2014-03-15 01:04:52.000000', 'temperatura', 673.0000, 'ºC'),
	(252743, 120, '2014-03-15 01:04:53.000000', 'temperatura', 335.0000, 'ºC'),
	(252744, 120, '2014-03-15 01:04:54.000000', 'temperatura', 857.0000, 'ºC'),
	(252745, 120, '2014-03-15 01:04:55.000000', 'temperatura', 881.0000, 'ºC'),
	(252746, 120, '2014-03-15 01:04:56.000000', 'temperatura', 633.0000, 'ºC'),
	(252747, 120, '2014-03-15 01:04:57.000000', 'temperatura', 522.0000, 'ºC'),
	(252748, 120, '2014-03-15 01:04:58.000000', 'temperatura', 710.0000, 'ºC'),
	(252749, 120, '2014-03-15 01:04:59.000000', 'temperatura', 788.0000, 'ºC'),
	(252750, 120, '2014-03-15 01:05:00.000000', 'temperatura', 608.0000, 'ºC'),
	(252751, 120, '2014-03-15 01:05:01.000000', 'temperatura', 678.0000, 'ºC'),
	(252752, 120, '2014-03-15 01:05:02.000000', 'temperatura', 366.0000, 'ºC'),
	(252753, 120, '2014-03-15 01:05:03.000000', 'temperatura', 997.0000, 'ºC'),
	(252754, 120, '2014-03-15 01:05:04.000000', 'temperatura', 289.0000, 'ºC'),
	(252755, 120, '2014-03-15 01:05:05.000000', 'temperatura', 853.0000, 'ºC'),
	(252756, 120, '2014-03-15 01:05:06.000000', 'temperatura', 1000.0000, 'ºC'),
	(252757, 120, '2014-03-15 01:05:07.000000', 'temperatura', 38.0000, 'ºC'),
	(252758, 120, '2014-03-15 01:05:08.000000', 'temperatura', 794.0000, 'ºC'),
	(252759, 120, '2014-03-15 01:05:09.000000', 'temperatura', 256.0000, 'ºC'),
	(252760, 120, '2014-03-15 01:05:10.000000', 'temperatura', 97.0000, 'ºC'),
	(252761, 120, '2014-03-15 01:05:11.000000', 'temperatura', 920.0000, 'ºC'),
	(252762, 120, '2014-03-15 01:05:12.000000', 'temperatura', 709.0000, 'ºC'),
	(252763, 120, '2014-03-15 01:05:13.000000', 'temperatura', 784.0000, 'ºC'),
	(252764, 120, '2014-03-15 01:05:14.000000', 'temperatura', 596.0000, 'ºC'),
	(252765, 120, '2014-03-15 01:05:15.000000', 'temperatura', 627.0000, 'ºC'),
	(252766, 120, '2014-03-15 01:05:16.000000', 'temperatura', 148.0000, 'ºC'),
	(252767, 120, '2014-03-15 01:05:17.000000', 'temperatura', 59.0000, 'ºC'),
	(252768, 120, '2014-03-15 01:05:18.000000', 'temperatura', 1054.0000, 'ºC'),
	(252769, 120, '2014-03-15 01:05:19.000000', 'temperatura', 290.0000, 'ºC'),
	(252770, 120, '2014-03-15 01:05:20.000000', 'temperatura', 689.0000, 'ºC'),
	(252771, 120, '2014-03-15 01:05:21.000000', 'temperatura', 176.0000, 'ºC'),
	(252772, 120, '2014-03-15 01:05:22.000000', 'temperatura', 14.0000, 'ºC'),
	(252773, 120, '2014-03-15 01:05:23.000000', 'temperatura', 743.0000, 'ºC'),
	(252774, 120, '2014-03-15 01:05:24.000000', 'temperatura', 75.0000, 'ºC'),
	(252775, 120, '2014-03-15 01:05:25.000000', 'temperatura', 543.0000, 'ºC'),
	(252776, 120, '2014-03-15 01:05:26.000000', 'temperatura', 94.0000, 'ºC'),
	(252777, 120, '2014-03-15 01:05:27.000000', 'temperatura', 39.0000, 'ºC'),
	(252778, 120, '2014-03-15 01:05:28.000000', 'temperatura', 1116.0000, 'ºC'),
	(252779, 120, '2014-03-15 01:05:29.000000', 'temperatura', 663.0000, 'ºC'),
	(252780, 120, '2014-03-15 01:05:30.000000', 'temperatura', 1168.0000, 'ºC'),
	(252781, 120, '2014-03-15 01:05:31.000000', 'temperatura', 249.0000, 'ºC'),
	(252782, 120, '2014-03-15 01:05:32.000000', 'temperatura', 142.0000, 'ºC'),
	(252783, 120, '2014-03-15 01:05:33.000000', 'temperatura', 1166.0000, 'ºC'),
	(252784, 120, '2014-03-15 01:05:34.000000', 'temperatura', 603.0000, 'ºC'),
	(252785, 120, '2014-03-15 01:05:35.000000', 'temperatura', 718.0000, 'ºC'),
	(252786, 120, '2014-03-15 01:05:36.000000', 'temperatura', 582.0000, 'ºC'),
	(252787, 120, '2014-03-15 01:05:37.000000', 'temperatura', 758.0000, 'ºC'),
	(252788, 120, '2014-03-15 01:05:38.000000', 'temperatura', 842.0000, 'ºC'),
	(252789, 120, '2014-03-15 01:05:39.000000', 'temperatura', 737.0000, 'ºC'),
	(252790, 120, '2014-03-15 01:05:40.000000', 'temperatura', 1161.0000, 'ºC'),
	(252791, 120, '2014-03-15 01:05:41.000000', 'temperatura', 1193.0000, 'ºC'),
	(252792, 120, '2014-03-15 01:05:42.000000', 'temperatura', 81.0000, 'ºC'),
	(252793, 120, '2014-03-15 01:05:43.000000', 'temperatura', 429.0000, 'ºC'),
	(252794, 120, '2014-03-15 01:05:44.000000', 'temperatura', 702.0000, 'ºC'),
	(252795, 120, '2014-03-15 01:05:45.000000', 'temperatura', 1023.0000, 'ºC'),
	(252796, 120, '2014-03-15 01:05:46.000000', 'temperatura', 608.0000, 'ºC'),
	(252797, 120, '2014-03-15 01:05:47.000000', 'temperatura', 1172.0000, 'ºC'),
	(252798, 120, '2014-03-15 01:05:48.000000', 'temperatura', 437.0000, 'ºC'),
	(252799, 120, '2014-03-15 01:05:49.000000', 'temperatura', 1071.0000, 'ºC'),
	(252800, 120, '2014-03-15 01:05:50.000000', 'temperatura', 445.0000, 'ºC'),
	(252801, 120, '2014-03-15 01:05:51.000000', 'temperatura', 213.0000, 'ºC'),
	(252802, 120, '2014-03-15 01:05:52.000000', 'temperatura', 930.0000, 'ºC'),
	(252803, 120, '2014-03-15 01:05:53.000000', 'temperatura', 412.0000, 'ºC'),
	(252804, 120, '2014-03-15 01:05:54.000000', 'temperatura', 472.0000, 'ºC'),
	(252805, 120, '2014-03-15 01:05:55.000000', 'temperatura', 1122.0000, 'ºC'),
	(252806, 120, '2014-03-15 01:05:56.000000', 'temperatura', 597.0000, 'ºC'),
	(252807, 120, '2014-03-15 01:05:57.000000', 'temperatura', 819.0000, 'ºC'),
	(252808, 120, '2014-03-15 01:05:58.000000', 'temperatura', 1102.0000, 'ºC'),
	(252809, 120, '2014-03-15 01:05:59.000000', 'temperatura', 657.0000, 'ºC'),
	(252810, 120, '2014-03-15 01:06:00.000000', 'temperatura', 1177.0000, 'ºC'),
	(252811, 120, '2014-03-15 01:06:01.000000', 'temperatura', 315.0000, 'ºC'),
	(252812, 120, '2014-03-15 01:06:02.000000', 'temperatura', 446.0000, 'ºC'),
	(252813, 120, '2014-03-15 01:06:03.000000', 'temperatura', 86.0000, 'ºC'),
	(252814, 120, '2014-03-15 01:06:04.000000', 'temperatura', 293.0000, 'ºC'),
	(252815, 120, '2014-03-15 01:06:05.000000', 'temperatura', 4.0000, 'ºC'),
	(252816, 120, '2014-03-15 01:06:06.000000', 'temperatura', 345.0000, 'ºC'),
	(252817, 120, '2014-03-15 01:06:07.000000', 'temperatura', 513.0000, 'ºC'),
	(252818, 120, '2014-03-15 01:06:08.000000', 'temperatura', 332.0000, 'ºC'),
	(252819, 120, '2014-03-15 01:06:09.000000', 'temperatura', 119.0000, 'ºC'),
	(252820, 120, '2014-03-15 01:06:10.000000', 'temperatura', 799.0000, 'ºC'),
	(252821, 120, '2014-03-15 01:06:11.000000', 'temperatura', 39.0000, 'ºC'),
	(252822, 120, '2014-03-15 01:06:12.000000', 'temperatura', 201.0000, 'ºC'),
	(252823, 120, '2014-03-15 01:06:13.000000', 'temperatura', 886.0000, 'ºC'),
	(252824, 120, '2014-03-15 01:06:14.000000', 'temperatura', 228.0000, 'ºC'),
	(252825, 120, '2014-03-15 01:06:15.000000', 'temperatura', 882.0000, 'ºC'),
	(252826, 120, '2014-03-15 01:06:16.000000', 'temperatura', 126.0000, 'ºC'),
	(252827, 120, '2014-03-15 01:06:17.000000', 'temperatura', 384.0000, 'ºC'),
	(252828, 120, '2014-03-15 01:06:18.000000', 'temperatura', 345.0000, 'ºC'),
	(252829, 120, '2014-03-15 01:06:19.000000', 'temperatura', 571.0000, 'ºC'),
	(252830, 120, '2014-03-15 01:06:20.000000', 'temperatura', 622.0000, 'ºC'),
	(252831, 120, '2014-03-15 01:06:21.000000', 'temperatura', 197.0000, 'ºC'),
	(252832, 120, '2014-03-15 01:06:22.000000', 'temperatura', 319.0000, 'ºC'),
	(252833, 120, '2014-03-15 01:06:23.000000', 'temperatura', 1006.0000, 'ºC'),
	(252834, 120, '2014-03-15 01:06:24.000000', 'temperatura', 475.0000, 'ºC'),
	(252835, 120, '2014-03-15 01:06:25.000000', 'temperatura', 554.0000, 'ºC'),
	(252836, 120, '2014-03-15 01:06:26.000000', 'temperatura', 147.0000, 'ºC'),
	(252837, 120, '2014-03-15 01:06:27.000000', 'temperatura', 271.0000, 'ºC'),
	(252838, 120, '2014-03-15 01:06:28.000000', 'temperatura', 917.0000, 'ºC'),
	(252839, 120, '2014-03-15 01:06:29.000000', 'temperatura', 174.0000, 'ºC'),
	(252840, 120, '2014-03-15 01:06:30.000000', 'temperatura', 518.0000, 'ºC'),
	(252841, 120, '2014-03-15 01:06:31.000000', 'temperatura', 870.0000, 'ºC'),
	(252842, 120, '2014-03-15 01:06:32.000000', 'temperatura', 394.0000, 'ºC'),
	(252843, 120, '2014-03-15 01:06:33.000000', 'temperatura', 563.0000, 'ºC'),
	(252844, 120, '2014-03-15 01:06:34.000000', 'temperatura', 433.0000, 'ºC'),
	(252845, 120, '2014-03-15 01:06:35.000000', 'temperatura', 475.0000, 'ºC'),
	(252846, 120, '2014-03-15 01:06:36.000000', 'temperatura', 1078.0000, 'ºC'),
	(252847, 120, '2014-03-15 01:06:37.000000', 'temperatura', 364.0000, 'ºC'),
	(252848, 120, '2014-03-15 01:06:38.000000', 'temperatura', 986.0000, 'ºC'),
	(252849, 120, '2014-03-15 01:06:39.000000', 'temperatura', 237.0000, 'ºC'),
	(252850, 120, '2014-03-15 01:06:40.000000', 'temperatura', 630.0000, 'ºC'),
	(252851, 120, '2014-03-15 01:06:41.000000', 'temperatura', 39.0000, 'ºC'),
	(252852, 120, '2014-03-15 01:06:42.000000', 'temperatura', 707.0000, 'ºC'),
	(252853, 120, '2014-03-15 01:06:43.000000', 'temperatura', 1019.0000, 'ºC'),
	(252854, 120, '2014-03-15 01:06:44.000000', 'temperatura', 575.0000, 'ºC'),
	(252855, 120, '2014-03-15 01:06:45.000000', 'temperatura', 1016.0000, 'ºC'),
	(252856, 120, '2014-03-15 01:06:46.000000', 'temperatura', 957.0000, 'ºC'),
	(252857, 120, '2014-03-15 01:06:47.000000', 'temperatura', 538.0000, 'ºC'),
	(252858, 120, '2014-03-15 01:06:48.000000', 'temperatura', 1021.0000, 'ºC'),
	(252859, 120, '2014-03-15 01:06:49.000000', 'temperatura', 1088.0000, 'ºC'),
	(252860, 120, '2014-03-15 01:06:50.000000', 'temperatura', 1180.0000, 'ºC'),
	(252861, 120, '2014-03-15 01:06:51.000000', 'temperatura', 234.0000, 'ºC'),
	(252862, 120, '2014-03-15 01:06:52.000000', 'temperatura', 32.0000, 'ºC'),
	(252863, 120, '2014-03-15 01:06:53.000000', 'temperatura', 657.0000, 'ºC'),
	(252864, 120, '2014-03-15 01:06:54.000000', 'temperatura', 792.0000, 'ºC'),
	(252865, 120, '2014-03-15 01:06:55.000000', 'temperatura', 788.0000, 'ºC'),
	(252866, 120, '2014-03-15 01:06:56.000000', 'temperatura', 367.0000, 'ºC'),
	(252867, 120, '2014-03-15 01:06:57.000000', 'temperatura', 668.0000, 'ºC'),
	(252868, 120, '2014-03-15 01:06:58.000000', 'temperatura', 1041.0000, 'ºC'),
	(252869, 120, '2014-03-15 01:06:59.000000', 'temperatura', 802.0000, 'ºC'),
	(252870, 120, '2014-03-15 01:07:00.000000', 'temperatura', 888.0000, 'ºC'),
	(252871, 120, '2014-03-15 01:07:01.000000', 'temperatura', 835.0000, 'ºC'),
	(252872, 120, '2014-03-15 01:07:02.000000', 'temperatura', 310.0000, 'ºC'),
	(252873, 120, '2014-03-15 01:07:03.000000', 'temperatura', 246.0000, 'ºC'),
	(252874, 120, '2014-03-15 01:07:04.000000', 'temperatura', 301.0000, 'ºC'),
	(252875, 120, '2014-03-15 01:07:05.000000', 'temperatura', 766.0000, 'ºC'),
	(252876, 120, '2014-03-15 01:07:06.000000', 'temperatura', 530.0000, 'ºC'),
	(252877, 120, '2014-03-15 01:07:07.000000', 'temperatura', 350.0000, 'ºC'),
	(252878, 120, '2014-03-15 01:07:08.000000', 'temperatura', 161.0000, 'ºC'),
	(252879, 120, '2014-03-15 01:07:09.000000', 'temperatura', 957.0000, 'ºC'),
	(252880, 120, '2014-03-15 01:07:10.000000', 'temperatura', 702.0000, 'ºC'),
	(252881, 120, '2014-03-15 01:07:11.000000', 'temperatura', 637.0000, 'ºC'),
	(252882, 120, '2014-03-15 01:07:12.000000', 'temperatura', 1082.0000, 'ºC'),
	(252883, 120, '2014-03-15 01:07:13.000000', 'temperatura', 1101.0000, 'ºC'),
	(252884, 120, '2014-03-15 01:07:14.000000', 'temperatura', 1058.0000, 'ºC'),
	(252885, 120, '2014-03-15 01:07:15.000000', 'temperatura', 786.0000, 'ºC'),
	(252886, 120, '2014-03-15 01:07:16.000000', 'temperatura', 759.0000, 'ºC'),
	(252887, 120, '2014-03-15 01:07:17.000000', 'temperatura', 235.0000, 'ºC'),
	(252888, 120, '2014-03-15 01:07:18.000000', 'temperatura', 101.0000, 'ºC'),
	(252889, 120, '2014-03-15 01:07:19.000000', 'temperatura', 998.0000, 'ºC'),
	(252890, 120, '2014-03-15 01:07:20.000000', 'temperatura', 1090.0000, 'ºC'),
	(252891, 120, '2014-03-15 01:07:21.000000', 'temperatura', 55.0000, 'ºC'),
	(252892, 120, '2014-03-15 01:07:22.000000', 'temperatura', 606.0000, 'ºC'),
	(252893, 120, '2014-03-15 01:07:23.000000', 'temperatura', 466.0000, 'ºC'),
	(252894, 120, '2014-03-15 01:07:24.000000', 'temperatura', 513.0000, 'ºC'),
	(252895, 120, '2014-03-15 01:07:25.000000', 'temperatura', 1167.0000, 'ºC'),
	(252896, 120, '2014-03-15 01:07:26.000000', 'temperatura', 695.0000, 'ºC'),
	(252897, 120, '2014-03-15 01:07:27.000000', 'temperatura', 1177.0000, 'ºC'),
	(252898, 120, '2014-03-15 01:07:28.000000', 'temperatura', 201.0000, 'ºC'),
	(252899, 120, '2014-03-15 01:07:29.000000', 'temperatura', 1074.0000, 'ºC'),
	(252900, 120, '2014-03-15 01:07:30.000000', 'temperatura', 1166.0000, 'ºC'),
	(252901, 120, '2014-03-15 01:07:31.000000', 'temperatura', 208.0000, 'ºC'),
	(252902, 120, '2014-03-15 01:07:32.000000', 'temperatura', 1143.0000, 'ºC'),
	(252903, 120, '2014-03-15 01:07:33.000000', 'temperatura', 292.0000, 'ºC'),
	(252904, 120, '2014-03-15 01:07:34.000000', 'temperatura', 432.0000, 'ºC'),
	(252905, 120, '2014-03-15 01:07:35.000000', 'temperatura', 84.0000, 'ºC'),
	(252906, 120, '2014-03-15 01:07:36.000000', 'temperatura', 326.0000, 'ºC'),
	(252907, 120, '2014-03-15 01:07:37.000000', 'temperatura', 177.0000, 'ºC'),
	(252908, 120, '2014-03-15 01:07:38.000000', 'temperatura', 1109.0000, 'ºC'),
	(252909, 120, '2014-03-15 01:07:39.000000', 'temperatura', 212.0000, 'ºC'),
	(252910, 120, '2014-03-15 01:07:40.000000', 'temperatura', 133.0000, 'ºC'),
	(252911, 120, '2014-03-15 01:07:41.000000', 'temperatura', 29.0000, 'ºC'),
	(252912, 120, '2014-03-15 01:07:42.000000', 'temperatura', 949.0000, 'ºC'),
	(252913, 120, '2014-03-15 01:07:43.000000', 'temperatura', 1059.0000, 'ºC'),
	(252914, 120, '2014-03-15 01:07:44.000000', 'temperatura', 47.0000, 'ºC'),
	(252915, 120, '2014-03-15 01:07:45.000000', 'temperatura', 660.0000, 'ºC'),
	(252916, 120, '2014-03-15 01:07:46.000000', 'temperatura', 758.0000, 'ºC'),
	(252917, 120, '2014-03-15 01:07:47.000000', 'temperatura', 610.0000, 'ºC'),
	(252918, 120, '2014-03-15 01:07:48.000000', 'temperatura', 775.0000, 'ºC'),
	(252919, 120, '2014-03-15 01:07:49.000000', 'temperatura', 849.0000, 'ºC'),
	(252920, 120, '2014-03-15 01:07:50.000000', 'temperatura', 717.0000, 'ºC'),
	(252921, 120, '2014-03-15 01:07:51.000000', 'temperatura', 1042.0000, 'ºC'),
	(252922, 120, '2014-03-15 01:07:52.000000', 'temperatura', 658.0000, 'ºC'),
	(252923, 120, '2014-03-15 01:07:53.000000', 'temperatura', 165.0000, 'ºC'),
	(252924, 120, '2014-03-15 01:07:54.000000', 'temperatura', 53.0000, 'ºC'),
	(252925, 120, '2014-03-15 01:07:55.000000', 'temperatura', 969.0000, 'ºC'),
	(252926, 120, '2014-03-15 01:07:56.000000', 'temperatura', 1088.0000, 'ºC'),
	(252927, 120, '2014-03-15 01:07:57.000000', 'temperatura', 133.0000, 'ºC'),
	(252928, 120, '2014-03-15 01:07:58.000000', 'temperatura', 1003.0000, 'ºC'),
	(252929, 120, '2014-03-15 01:07:59.000000', 'temperatura', 1014.0000, 'ºC'),
	(252930, 120, '2014-03-15 01:08:00.000000', 'temperatura', 863.0000, 'ºC'),
	(252931, 120, '2014-03-15 01:08:01.000000', 'temperatura', 71.0000, 'ºC'),
	(252932, 120, '2014-03-15 01:08:02.000000', 'temperatura', 168.0000, 'ºC'),
	(252933, 120, '2014-03-15 01:08:03.000000', 'temperatura', 626.0000, 'ºC'),
	(252934, 120, '2014-03-15 01:08:04.000000', 'temperatura', 226.0000, 'ºC'),
	(252935, 120, '2014-03-15 01:08:05.000000', 'temperatura', 455.0000, 'ºC'),
	(252936, 120, '2014-03-15 01:08:06.000000', 'temperatura', 395.0000, 'ºC'),
	(252937, 120, '2014-03-15 01:08:07.000000', 'temperatura', 611.0000, 'ºC'),
	(252938, 120, '2014-03-15 01:08:08.000000', 'temperatura', 672.0000, 'ºC'),
	(252939, 120, '2014-03-15 01:08:09.000000', 'temperatura', 327.0000, 'ºC'),
	(252940, 120, '2014-03-15 01:08:10.000000', 'temperatura', 818.0000, 'ºC'),
	(252941, 120, '2014-03-15 01:08:11.000000', 'temperatura', 712.0000, 'ºC'),
	(252942, 120, '2014-03-15 01:08:12.000000', 'temperatura', 1105.0000, 'ºC'),
	(252943, 120, '2014-03-15 01:08:13.000000', 'temperatura', 991.0000, 'ºC'),
	(252944, 120, '2014-03-15 01:08:14.000000', 'temperatura', 440.0000, 'ºC'),
	(252945, 120, '2014-03-15 01:08:15.000000', 'temperatura', 429.0000, 'ºC'),
	(252946, 120, '2014-03-15 01:08:16.000000', 'temperatura', 826.0000, 'ºC'),
	(252947, 120, '2014-03-15 01:08:17.000000', 'temperatura', 441.0000, 'ºC'),
	(252948, 120, '2014-03-15 01:08:18.000000', 'temperatura', 929.0000, 'ºC'),
	(252949, 120, '2014-03-15 01:08:19.000000', 'temperatura', 921.0000, 'ºC'),
	(252950, 120, '2014-03-15 01:08:20.000000', 'temperatura', 620.0000, 'ºC'),
	(252951, 120, '2014-03-15 01:08:21.000000', 'temperatura', 336.0000, 'ºC'),
	(252952, 120, '2014-03-15 01:08:22.000000', 'temperatura', 1023.0000, 'ºC'),
	(252953, 120, '2014-03-15 01:08:23.000000', 'temperatura', 508.0000, 'ºC'),
	(252954, 120, '2014-03-15 01:08:24.000000', 'temperatura', 668.0000, 'ºC'),
	(252955, 120, '2014-03-15 01:08:25.000000', 'temperatura', 619.0000, 'ºC'),
	(252956, 120, '2014-03-15 01:08:26.000000', 'temperatura', 1092.0000, 'ºC'),
	(252957, 120, '2014-03-15 01:08:27.000000', 'temperatura', 2.0000, 'ºC'),
	(252958, 120, '2014-03-15 01:08:28.000000', 'temperatura', 333.0000, 'ºC'),
	(252959, 120, '2014-03-15 01:08:29.000000', 'temperatura', 460.0000, 'ºC'),
	(252960, 120, '2014-03-15 01:08:30.000000', 'temperatura', 103.0000, 'ºC'),
	(252961, 120, '2014-03-15 01:08:31.000000', 'temperatura', 337.0000, 'ºC'),
	(252962, 120, '2014-03-15 01:08:32.000000', 'temperatura', 173.0000, 'ºC'),
	(252963, 120, '2014-03-15 01:08:33.000000', 'temperatura', 1057.0000, 'ºC'),
	(252964, 120, '2014-03-15 01:08:34.000000', 'temperatura', 1167.0000, 'ºC'),
	(252965, 120, '2014-03-15 01:08:35.000000', 'temperatura', 265.0000, 'ºC'),
	(252966, 120, '2014-03-15 01:08:36.000000', 'temperatura', 225.0000, 'ºC'),
	(252967, 120, '2014-03-15 01:08:37.000000', 'temperatura', 329.0000, 'ºC'),
	(252968, 120, '2014-03-15 01:08:38.000000', 'temperatura', 973.0000, 'ºC'),
	(252969, 120, '2014-03-15 01:08:39.000000', 'temperatura', 276.0000, 'ºC'),
	(252970, 120, '2014-03-15 01:08:40.000000', 'temperatura', 862.0000, 'ºC'),
	(252971, 120, '2014-03-15 01:08:41.000000', 'temperatura', 1081.0000, 'ºC'),
	(252972, 120, '2014-03-15 01:08:42.000000', 'temperatura', 421.0000, 'ºC'),
	(252973, 120, '2014-03-15 01:08:43.000000', 'temperatura', 62.0000, 'ºC'),
	(252974, 120, '2014-03-15 01:08:44.000000', 'temperatura', 246.0000, 'ºC'),
	(252975, 120, '2014-03-15 01:08:45.000000', 'temperatura', 1044.0000, 'ºC'),
	(252976, 120, '2014-03-15 01:08:46.000000', 'temperatura', 884.0000, 'ºC'),
	(252977, 120, '2014-03-15 01:08:47.000000', 'temperatura', 89.0000, 'ºC'),
	(252978, 120, '2014-03-15 01:08:48.000000', 'temperatura', 195.0000, 'ºC'),
	(252979, 120, '2014-03-15 01:08:49.000000', 'temperatura', 707.0000, 'ºC'),
	(252980, 120, '2014-03-15 01:08:50.000000', 'temperatura', 550.0000, 'ºC'),
	(252981, 120, '2014-03-15 01:08:51.000000', 'temperatura', 629.0000, 'ºC'),
	(252982, 120, '2014-03-15 01:08:52.000000', 'temperatura', 297.0000, 'ºC'),
	(252983, 120, '2014-03-15 01:08:53.000000', 'temperatura', 799.0000, 'ºC'),
	(252984, 120, '2014-03-15 01:08:54.000000', 'temperatura', 702.0000, 'ºC'),
	(252985, 120, '2014-03-15 01:08:55.000000', 'temperatura', 1115.0000, 'ºC'),
	(252986, 120, '2014-03-15 01:08:56.000000', 'temperatura', 1067.0000, 'ºC'),
	(252987, 120, '2014-03-15 01:08:57.000000', 'temperatura', 793.0000, 'ºC'),
	(252988, 120, '2014-03-15 01:08:58.000000', 'temperatura', 764.0000, 'ºC'),
	(252989, 120, '2014-03-15 01:08:59.000000', 'temperatura', 241.0000, 'ºC'),
	(252990, 120, '2014-03-15 01:09:00.000000', 'temperatura', 116.0000, 'ºC'),
	(252991, 120, '2014-03-15 01:09:01.000000', 'temperatura', 1054.0000, 'ºC'),
	(252992, 120, '2014-03-15 01:09:02.000000', 'temperatura', 126.0000, 'ºC'),
	(252993, 120, '2014-03-15 01:09:03.000000', 'temperatura', 1066.0000, 'ºC'),
	(252994, 120, '2014-03-15 01:09:04.000000', 'temperatura', 153.0000, 'ºC'),
	(252995, 120, '2014-03-15 01:09:05.000000', 'temperatura', 1167.0000, 'ºC'),
	(252996, 120, '2014-03-15 01:09:06.000000', 'temperatura', 578.0000, 'ºC'),
	(252997, 120, '2014-03-15 01:09:07.000000', 'temperatura', 588.0000, 'ºC'),
	(252998, 120, '2014-03-15 01:09:08.000000', 'temperatura', 7.0000, 'ºC'),
	(252999, 120, '2014-03-15 01:09:09.000000', 'temperatura', 671.0000, 'ºC'),
	(253000, 120, '2014-03-15 01:09:10.000000', 'temperatura', 933.0000, 'ºC'),
	(253001, 120, '2014-03-15 01:09:11.000000', 'temperatura', 253.0000, 'ºC'),
	(253002, 120, '2014-03-15 01:09:12.000000', 'temperatura', 866.0000, 'ºC'),
	(253003, 120, '2014-03-15 01:09:13.000000', 'temperatura', 1174.0000, 'ºC'),
	(253004, 120, '2014-03-15 01:09:14.000000', 'temperatura', 873.0000, 'ºC'),
	(253005, 120, '2014-03-15 01:09:15.000000', 'temperatura', 840.0000, 'ºC'),
	(253006, 120, '2014-03-15 01:09:16.000000', 'temperatura', 385.0000, 'ºC'),
	(253007, 120, '2014-03-15 01:09:17.000000', 'temperatura', 604.0000, 'ºC'),
	(253008, 120, '2014-03-15 01:09:18.000000', 'temperatura', 664.0000, 'ºC'),
	(253009, 120, '2014-03-15 01:09:19.000000', 'temperatura', 309.0000, 'ºC'),
	(253010, 120, '2014-03-15 01:09:20.000000', 'temperatura', 752.0000, 'ºC'),
	(253011, 120, '2014-03-15 01:09:21.000000', 'temperatura', 434.0000, 'ºC'),
	(253012, 120, '2014-03-15 01:09:22.000000', 'temperatura', 1115.0000, 'ºC'),
	(253013, 120, '2014-03-15 01:09:23.000000', 'temperatura', 675.0000, 'ºC'),
	(253014, 120, '2014-03-15 01:09:24.000000', 'temperatura', 31.0000, 'ºC'),
	(253015, 120, '2014-03-15 01:09:25.000000', 'temperatura', 529.0000, 'ºC'),
	(253016, 120, '2014-03-15 01:09:26.000000', 'temperatura', 151.0000, 'ºC'),
	(253017, 120, '2014-03-15 01:09:27.000000', 'temperatura', 370.0000, 'ºC'),
	(253018, 120, '2014-03-15 01:09:28.000000', 'temperatura', 199.0000, 'ºC'),
	(253019, 120, '2014-03-15 01:09:29.000000', 'temperatura', 1085.0000, 'ºC'),
	(253020, 120, '2014-03-15 01:09:30.000000', 'temperatura', 28.0000, 'ºC'),
	(253021, 120, '2014-03-15 01:09:31.000000', 'temperatura', 483.0000, 'ºC'),
	(253022, 120, '2014-03-15 01:09:32.000000', 'temperatura', 1135.0000, 'ºC'),
	(253023, 120, '2014-03-15 01:09:33.000000', 'temperatura', 625.0000, 'ºC'),
	(253024, 120, '2014-03-15 01:09:34.000000', 'temperatura', 922.0000, 'ºC'),
	(253025, 120, '2014-03-15 01:09:35.000000', 'temperatura', 336.0000, 'ºC'),
	(253026, 120, '2014-03-15 01:09:36.000000', 'temperatura', 112.0000, 'ºC'),
	(253027, 120, '2014-03-15 01:09:37.000000', 'temperatura', 753.0000, 'ºC'),
	(253028, 120, '2014-03-15 01:09:38.000000', 'temperatura', 1031.0000, 'ºC'),
	(253029, 120, '2014-03-15 01:09:39.000000', 'temperatura', 494.0000, 'ºC'),
	(253030, 120, '2014-03-15 01:09:40.000000', 'temperatura', 579.0000, 'ºC'),
	(253031, 120, '2014-03-15 01:09:41.000000', 'temperatura', 213.0000, 'ºC'),
	(253032, 120, '2014-03-15 01:09:42.000000', 'temperatura', 529.0000, 'ºC'),
	(253033, 120, '2014-03-15 01:09:43.000000', 'temperatura', 805.0000, 'ºC'),
	(253034, 120, '2014-03-15 01:09:44.000000', 'temperatura', 40.0000, 'ºC'),
	(253035, 120, '2014-03-15 01:09:45.000000', 'temperatura', 185.0000, 'ºC'),
	(253036, 120, '2014-03-15 01:09:46.000000', 'temperatura', 808.0000, 'ºC'),
	(253037, 120, '2014-03-15 01:09:47.000000', 'temperatura', 1082.0000, 'ºC'),
	(253038, 120, '2014-03-15 01:09:48.000000', 'temperatura', 588.0000, 'ºC'),
	(253039, 120, '2014-03-15 01:09:49.000000', 'temperatura', 895.0000, 'ºC'),
	(253040, 120, '2014-03-15 01:09:50.000000', 'temperatura', 312.0000, 'ºC'),
	(253041, 120, '2014-03-15 01:09:51.000000', 'temperatura', 74.0000, 'ºC'),
	(253042, 120, '2014-03-15 01:09:52.000000', 'temperatura', 634.0000, 'ºC'),
	(253043, 120, '2014-03-15 01:09:53.000000', 'temperatura', 548.0000, 'ºC'),
	(253044, 120, '2014-03-15 01:09:54.000000', 'temperatura', 840.0000, 'ºC'),
	(253045, 120, '2014-03-15 01:09:55.000000', 'temperatura', 154.0000, 'ºC'),
	(253046, 120, '2014-03-15 01:09:56.000000', 'temperatura', 654.0000, 'ºC'),
	(253047, 120, '2014-03-15 01:09:57.000000', 'temperatura', 406.0000, 'ºC'),
	(253048, 120, '2014-03-15 01:09:58.000000', 'temperatura', 69.0000, 'ºC'),
	(253049, 120, '2014-03-15 01:09:59.000000', 'temperatura', 326.0000, 'ºC'),
	(253050, 120, '2014-03-15 01:10:00.000000', 'temperatura', 224.0000, 'ºC'),
	(253051, 120, '2014-03-15 01:10:01.000000', 'temperatura', 141.0000, 'ºC'),
	(253052, 120, '2014-03-15 01:10:02.000000', 'temperatura', 35.0000, 'ºC'),
	(253053, 120, '2014-03-15 01:10:03.000000', 'temperatura', 952.0000, 'ºC'),
	(253054, 120, '2014-03-15 01:10:04.000000', 'temperatura', 1057.0000, 'ºC'),
	(253055, 120, '2014-03-15 01:10:05.000000', 'temperatura', 28.0000, 'ºC'),
	(253056, 120, '2014-03-15 01:10:06.000000', 'temperatura', 571.0000, 'ºC'),
	(253057, 120, '2014-03-15 01:10:07.000000', 'temperatura', 371.0000, 'ºC'),
	(253058, 120, '2014-03-15 01:10:08.000000', 'temperatura', 140.0000, 'ºC'),
	(253059, 120, '2014-03-15 01:10:09.000000', 'temperatura', 790.0000, 'ºC'),
	(253060, 120, '2014-03-15 01:10:10.000000', 'temperatura', 1132.0000, 'ºC'),
	(253061, 120, '2014-03-15 01:10:11.000000', 'temperatura', 887.0000, 'ºC'),
	(253062, 120, '2014-03-15 01:10:12.000000', 'temperatura', 1042.0000, 'ºC'),
	(253063, 120, '2014-03-15 01:10:13.000000', 'temperatura', 150.0000, 'ºC'),
	(253064, 120, '2014-03-15 01:10:14.000000', 'temperatura', 22.0000, 'ºC'),
	(253065, 120, '2014-03-15 01:10:15.000000', 'temperatura', 862.0000, 'ºC'),
	(253066, 120, '2014-03-15 01:10:16.000000', 'temperatura', 644.0000, 'ºC'),
	(253067, 120, '2014-03-15 01:10:17.000000', 'temperatura', 635.0000, 'ºC'),
	(253068, 120, '2014-03-15 01:10:18.000000', 'temperatura', 44.0000, 'ºC'),
	(253069, 120, '2014-03-15 01:10:19.000000', 'temperatura', 716.0000, 'ºC'),
	(253070, 120, '2014-03-15 01:10:20.000000', 'temperatura', 1047.0000, 'ºC'),
	(253071, 120, '2014-03-15 01:10:21.000000', 'temperatura', 687.0000, 'ºC'),
	(253072, 120, '2014-03-15 01:10:22.000000', 'temperatura', 293.0000, 'ºC'),
	(253073, 120, '2014-03-15 01:10:23.000000', 'temperatura', 608.0000, 'ºC'),
	(253074, 120, '2014-03-15 01:10:24.000000', 'temperatura', 960.0000, 'ºC'),
	(253075, 120, '2014-03-15 01:10:25.000000', 'temperatura', 575.0000, 'ºC'),
	(253076, 120, '2014-03-15 01:10:26.000000', 'temperatura', 1196.0000, 'ºC'),
	(253077, 120, '2014-03-15 01:10:27.000000', 'temperatura', 658.0000, 'ºC'),
	(253078, 120, '2014-03-15 01:10:28.000000', 'temperatura', 901.0000, 'ºC'),
	(253079, 120, '2014-03-15 01:10:29.000000', 'temperatura', 130.0000, 'ºC'),
	(253080, 120, '2014-03-15 01:10:30.000000', 'temperatura', 350.0000, 'ºC'),
	(253081, 120, '2014-03-15 01:10:31.000000', 'temperatura', 160.0000, 'ºC'),
	(253082, 120, '2014-03-15 01:10:32.000000', 'temperatura', 948.0000, 'ºC'),
	(253083, 120, '2014-03-15 01:10:33.000000', 'temperatura', 664.0000, 'ºC'),
	(253084, 120, '2014-03-15 01:10:34.000000', 'temperatura', 476.0000, 'ºC'),
	(253085, 120, '2014-03-15 01:10:35.000000', 'temperatura', 386.0000, 'ºC'),
	(253086, 120, '2014-03-15 01:10:36.000000', 'temperatura', 506.0000, 'ºC'),
	(253087, 120, '2014-03-15 01:10:37.000000', 'temperatura', 170.0000, 'ºC'),
	(253088, 120, '2014-03-15 01:10:38.000000', 'temperatura', 532.0000, 'ºC'),
	(253089, 120, '2014-03-15 01:10:39.000000', 'temperatura', 952.0000, 'ºC'),
	(253090, 120, '2014-03-15 01:10:40.000000', 'temperatura', 765.0000, 'ºC'),
	(253091, 120, '2014-03-15 01:10:41.000000', 'temperatura', 969.0000, 'ºC'),
	(253092, 120, '2014-03-15 01:10:42.000000', 'temperatura', 151.0000, 'ºC'),
	(253093, 120, '2014-03-15 01:10:43.000000', 'temperatura', 249.0000, 'ºC'),
	(253094, 120, '2014-03-15 01:10:44.000000', 'temperatura', 791.0000, 'ºC'),
	(253095, 120, '2014-03-15 01:10:45.000000', 'temperatura', 810.0000, 'ºC'),
	(253096, 120, '2014-03-15 01:10:46.000000', 'temperatura', 478.0000, 'ºC'),
	(253097, 120, '2014-03-15 01:10:47.000000', 'temperatura', 1159.0000, 'ºC'),
	(253098, 120, '2014-03-15 01:10:48.000000', 'temperatura', 761.0000, 'ºC'),
	(253099, 120, '2014-03-15 01:10:49.000000', 'temperatura', 327.0000, 'ºC'),
	(253100, 120, '2014-03-15 01:10:50.000000', 'temperatura', 555.0000, 'ºC'),
	(253101, 120, '2014-03-15 01:10:51.000000', 'temperatura', 594.0000, 'ºC'),
	(253102, 120, '2014-03-15 01:10:52.000000', 'temperatura', 103.0000, 'ºC'),
	(253103, 120, '2014-03-15 01:10:53.000000', 'temperatura', 1137.0000, 'ºC'),
	(253104, 120, '2014-03-15 01:10:54.000000', 'temperatura', 576.0000, 'ºC'),
	(253105, 120, '2014-03-15 01:10:55.000000', 'temperatura', 667.0000, 'ºC'),
	(253106, 120, '2014-03-15 01:10:56.000000', 'temperatura', 411.0000, 'ºC'),
	(253107, 120, '2014-03-15 01:10:57.000000', 'temperatura', 52.0000, 'ºC'),
	(253108, 120, '2014-03-15 01:10:58.000000', 'temperatura', 230.0000, 'ºC'),
	(253109, 120, '2014-03-15 01:10:59.000000', 'temperatura', 992.0000, 'ºC'),
	(253110, 120, '2014-03-15 01:11:00.000000', 'temperatura', 670.0000, 'ºC'),
	(253111, 120, '2014-03-15 01:11:01.000000', 'temperatura', 377.0000, 'ºC'),
	(253112, 120, '2014-03-15 01:11:02.000000', 'temperatura', 1073.0000, 'ºC'),
	(253113, 120, '2014-03-15 01:11:03.000000', 'temperatura', 636.0000, 'ºC'),
	(253114, 120, '2014-03-15 01:11:04.000000', 'temperatura', 1162.0000, 'ºC'),
	(253115, 120, '2014-03-15 01:11:05.000000', 'temperatura', 303.0000, 'ºC'),
	(253116, 120, '2014-03-15 01:11:06.000000', 'temperatura', 428.0000, 'ºC'),
	(253117, 120, '2014-03-15 01:11:07.000000', 'temperatura', 31.0000, 'ºC'),
	(253118, 120, '2014-03-15 01:11:08.000000', 'temperatura', 73.0000, 'ºC'),
	(253119, 120, '2014-03-15 01:11:09.000000', 'temperatura', 272.0000, 'ºC'),
	(253120, 120, '2014-03-15 01:11:10.000000', 'temperatura', 1142.0000, 'ºC'),
	(253121, 120, '2014-03-15 01:11:11.000000', 'temperatura', 92.0000, 'ºC'),
	(253122, 120, '2014-03-15 01:11:12.000000', 'temperatura', 637.0000, 'ºC'),
	(253123, 120, '2014-03-15 01:11:13.000000', 'temperatura', 510.0000, 'ºC'),
	(253124, 120, '2014-03-15 01:11:14.000000', 'temperatura', 639.0000, 'ºC'),
	(253125, 120, '2014-03-15 01:11:15.000000', 'temperatura', 467.0000, 'ºC'),
	(253126, 120, '2014-03-15 01:11:16.000000', 'temperatura', 416.0000, 'ºC'),
	(253127, 120, '2014-03-15 01:11:17.000000', 'temperatura', 680.0000, 'ºC'),
	(253128, 120, '2014-03-15 01:11:18.000000', 'temperatura', 954.0000, 'ºC'),
	(253129, 120, '2014-03-15 01:11:19.000000', 'temperatura', 332.0000, 'ºC'),
	(253130, 120, '2014-03-15 01:11:20.000000', 'temperatura', 1195.0000, 'ºC'),
	(253131, 120, '2014-03-15 01:11:21.000000', 'temperatura', 182.0000, 'ºC'),
	(253132, 120, '2014-03-15 01:11:22.000000', 'temperatura', 924.0000, 'ºC'),
	(253133, 120, '2014-03-15 01:11:23.000000', 'temperatura', 474.0000, 'ºC'),
	(253134, 120, '2014-03-15 01:11:24.000000', 'temperatura', 801.0000, 'ºC'),
	(253135, 120, '2014-03-15 01:11:25.000000', 'temperatura', 183.0000, 'ºC'),
	(253136, 120, '2014-03-15 01:11:26.000000', 'temperatura', 910.0000, 'ºC'),
	(253137, 120, '2014-03-15 01:11:27.000000', 'temperatura', 404.0000, 'ºC'),
	(253138, 120, '2014-03-15 01:11:28.000000', 'temperatura', 492.0000, 'ºC'),
	(253139, 120, '2014-03-15 01:11:29.000000', 'temperatura', 46.0000, 'ºC'),
	(253140, 120, '2014-03-15 01:11:30.000000', 'temperatura', 1155.0000, 'ºC'),
	(253141, 120, '2014-03-15 01:11:31.000000', 'temperatura', 837.0000, 'ºC'),
	(253142, 120, '2014-03-15 01:11:32.000000', 'temperatura', 722.0000, 'ºC'),
	(253143, 120, '2014-03-15 01:11:33.000000', 'temperatura', 1098.0000, 'ºC'),
	(253144, 120, '2014-03-15 01:11:34.000000', 'temperatura', 924.0000, 'ºC'),
	(253145, 120, '2014-03-15 01:11:35.000000', 'temperatura', 127.0000, 'ºC'),
	(253146, 120, '2014-03-15 01:11:36.000000', 'temperatura', 262.0000, 'ºC'),
	(253147, 120, '2014-03-15 01:11:37.000000', 'temperatura', 932.0000, 'ºC'),
	(253148, 120, '2014-03-15 01:11:38.000000', 'temperatura', 273.0000, 'ºC'),
	(253149, 120, '2014-03-15 01:11:39.000000', 'temperatura', 969.0000, 'ºC'),
	(253150, 120, '2014-03-15 01:11:40.000000', 'temperatura', 426.0000, 'ºC'),
	(253151, 120, '2014-03-15 01:11:41.000000', 'temperatura', 423.0000, 'ºC'),
	(253152, 120, '2014-03-15 01:11:42.000000', 'temperatura', 840.0000, 'ºC'),
	(253153, 120, '2014-03-15 01:11:43.000000', 'temperatura', 530.0000, 'ºC'),
	(253154, 120, '2014-03-15 01:11:44.000000', 'temperatura', 130.0000, 'ºC'),
	(253155, 120, '2014-03-15 01:11:45.000000', 'temperatura', 263.0000, 'ºC'),
	(253156, 120, '2014-03-15 01:11:46.000000', 'temperatura', 925.0000, 'ºC'),
	(253157, 120, '2014-03-15 01:11:47.000000', 'temperatura', 235.0000, 'ºC'),
	(253158, 120, '2014-03-15 01:11:48.000000', 'temperatura', 800.0000, 'ºC'),
	(253159, 120, '2014-03-15 01:11:49.000000', 'temperatura', 895.0000, 'ºC'),
	(253160, 120, '2014-03-15 01:11:50.000000', 'temperatura', 876.0000, 'ºC'),
	(253161, 120, '2014-03-15 01:11:51.000000', 'temperatura', 497.0000, 'ºC'),
	(253162, 120, '2014-03-15 01:11:52.000000', 'temperatura', 1057.0000, 'ºC'),
	(253163, 120, '2014-03-15 01:11:53.000000', 'temperatura', 195.0000, 'ºC'),
	(253164, 120, '2014-03-15 01:11:54.000000', 'temperatura', 202.0000, 'ºC'),
	(253165, 120, '2014-03-15 01:11:55.000000', 'temperatura', 429.0000, 'ºC'),
	(253166, 120, '2014-03-15 01:11:56.000000', 'temperatura', 337.0000, 'ºC'),
	(253167, 120, '2014-03-15 01:11:57.000000', 'temperatura', 399.0000, 'ºC'),
	(253168, 120, '2014-03-15 01:11:58.000000', 'temperatura', 984.0000, 'ºC'),
	(253169, 120, '2014-03-15 01:11:59.000000', 'temperatura', 122.0000, 'ºC'),
	(253170, 120, '2014-03-15 01:12:00.000000', 'temperatura', 61.0000, 'ºC'),
	(253171, 120, '2014-03-15 01:12:01.000000', 'temperatura', 1139.0000, 'ºC'),
	(253172, 120, '2014-03-15 01:12:02.000000', 'temperatura', 714.0000, 'ºC'),
	(253173, 120, '2014-03-15 01:12:03.000000', 'temperatura', 151.0000, 'ºC'),
	(253174, 120, '2014-03-15 01:12:04.000000', 'temperatura', 1014.0000, 'ºC'),
	(253175, 120, '2014-03-15 01:12:05.000000', 'temperatura', 1020.0000, 'ºC'),
	(253176, 120, '2014-03-15 01:12:06.000000', 'temperatura', 855.0000, 'ºC'),
	(253177, 120, '2014-03-15 01:12:07.000000', 'temperatura', 18.0000, 'ºC'),
	(253178, 120, '2014-03-15 01:12:08.000000', 'temperatura', 1125.0000, 'ºC'),
	(253179, 120, '2014-03-15 01:12:09.000000', 'temperatura', 770.0000, 'ºC'),
	(253180, 120, '2014-03-15 01:12:10.000000', 'temperatura', 475.0000, 'ºC'),
	(253181, 120, '2014-03-15 01:12:11.000000', 'temperatura', 67.0000, 'ºC'),
	(253182, 120, '2014-03-15 01:12:12.000000', 'temperatura', 111.0000, 'ºC'),
	(253183, 120, '2014-03-15 01:12:13.000000', 'temperatura', 353.0000, 'ºC'),
	(253184, 120, '2014-03-15 01:12:14.000000', 'temperatura', 234.0000, 'ºC'),
	(253185, 120, '2014-03-15 01:12:15.000000', 'temperatura', 110.0000, 'ºC'),
	(253186, 120, '2014-03-15 01:12:16.000000', 'temperatura', 1051.0000, 'ºC'),
	(253187, 120, '2014-03-15 01:12:17.000000', 'temperatura', 123.0000, 'ºC'),
	(253188, 120, '2014-03-15 01:12:18.000000', 'temperatura', 1062.0000, 'ºC'),
	(253189, 120, '2014-03-15 01:12:19.000000', 'temperatura', 144.0000, 'ºC'),
	(253190, 120, '2014-03-15 01:12:20.000000', 'temperatura', 1135.0000, 'ºC'),
	(253191, 120, '2014-03-15 01:12:21.000000', 'temperatura', 440.0000, 'ºC'),
	(253192, 120, '2014-03-15 01:12:22.000000', 'temperatura', 1199.0000, 'ºC'),
	(253193, 120, '2014-03-15 01:12:23.000000', 'temperatura', 1074.0000, 'ºC'),
	(253194, 120, '2014-03-15 01:12:24.000000', 'temperatura', 573.0000, 'ºC'),
	(253195, 120, '2014-03-15 01:12:25.000000', 'temperatura', 844.0000, 'ºC'),
	(253196, 120, '2014-03-15 01:12:26.000000', 'temperatura', 103.0000, 'ºC'),
	(253197, 120, '2014-03-15 01:12:27.000000', 'temperatura', 384.0000, 'ºC'),
	(253198, 120, '2014-03-15 01:12:28.000000', 'temperatura', 412.0000, 'ºC'),
	(253199, 120, '2014-03-15 01:12:29.000000', 'temperatura', 909.0000, 'ºC'),
	(253200, 120, '2014-03-15 01:12:30.000000', 'temperatura', 910.0000, 'ºC'),
	(253201, 120, '2014-03-15 01:12:31.000000', 'temperatura', 621.0000, 'ºC'),
	(253202, 120, '2014-03-15 01:12:32.000000', 'temperatura', 378.0000, 'ºC'),
	(253203, 120, '2014-03-15 01:12:33.000000', 'temperatura', 27.0000, 'ºC'),
	(253204, 120, '2014-03-15 01:12:34.000000', 'temperatura', 202.0000, 'ºC'),
	(253205, 120, '2014-03-15 01:12:35.000000', 'temperatura', 928.0000, 'ºC'),
	(253206, 120, '2014-03-15 01:12:36.000000', 'temperatura', 434.0000, 'ºC'),
	(253207, 120, '2014-03-15 01:12:37.000000', 'temperatura', 588.0000, 'ºC'),
	(253208, 120, '2014-03-15 01:12:38.000000', 'temperatura', 438.0000, 'ºC'),
	(253209, 120, '2014-03-15 01:12:39.000000', 'temperatura', 427.0000, 'ºC'),
	(253210, 120, '2014-03-15 01:12:40.000000', 'temperatura', 823.0000, 'ºC'),
	(253211, 120, '2014-03-15 01:12:41.000000', 'temperatura', 431.0000, 'ºC'),
	(253212, 120, '2014-03-15 01:12:42.000000', 'temperatura', 888.0000, 'ºC'),
	(253213, 120, '2014-03-15 01:12:43.000000', 'temperatura', 749.0000, 'ºC'),
	(253214, 120, '2014-03-15 01:12:44.000000', 'temperatura', 1082.0000, 'ºC'),
	(253215, 120, '2014-03-15 01:12:45.000000', 'temperatura', 764.0000, 'ºC'),
	(253216, 120, '2014-03-15 01:12:46.000000', 'temperatura', 572.0000, 'ºC'),
	(253217, 120, '2014-03-15 01:12:47.000000', 'temperatura', 571.0000, 'ºC'),
	(253218, 120, '2014-03-15 01:12:48.000000', 'temperatura', 1141.0000, 'ºC'),
	(253219, 120, '2014-03-15 01:12:49.000000', 'temperatura', 389.0000, 'ºC'),
	(253220, 120, '2014-03-15 01:12:50.000000', 'temperatura', 923.0000, 'ºC'),
	(253221, 120, '2014-03-15 01:12:51.000000', 'temperatura', 1051.0000, 'ºC'),
	(253222, 120, '2014-03-15 01:12:52.000000', 'temperatura', 84.0000, 'ºC'),
	(253223, 120, '2014-03-15 01:12:53.000000', 'temperatura', 867.0000, 'ºC'),
	(253224, 120, '2014-03-15 01:12:54.000000', 'temperatura', 483.0000, 'ºC'),
	(253225, 120, '2014-03-15 01:12:55.000000', 'temperatura', 1017.0000, 'ºC'),
	(253226, 120, '2014-03-15 01:12:56.000000', 'temperatura', 38.0000, 'ºC'),
	(253227, 120, '2014-03-15 01:12:57.000000', 'temperatura', 736.0000, 'ºC'),
	(253228, 120, '2014-03-15 01:12:58.000000', 'temperatura', 1167.0000, 'ºC'),
	(253229, 120, '2014-03-15 01:12:59.000000', 'temperatura', 27.0000, 'ºC'),
	(253230, 120, '2014-03-15 01:13:00.000000', 'temperatura', 237.0000, 'ºC'),
	(253231, 120, '2014-03-15 01:13:01.000000', 'temperatura', 1102.0000, 'ºC'),
	(253232, 120, '2014-03-15 01:13:02.000000', 'temperatura', 1.0000, 'ºC'),
	(253233, 120, '2014-03-15 01:13:03.000000', 'temperatura', 300.0000, 'ºC'),
	(253234, 120, '2014-03-15 01:13:04.000000', 'temperatura', 298.0000, 'ºC'),
	(253235, 120, '2014-03-15 01:13:05.000000', 'temperatura', 591.0000, 'ºC'),
	(253236, 120, '2014-03-15 01:13:06.000000', 'temperatura', 860.0000, 'ºC'),
	(253237, 120, '2014-03-15 01:13:07.000000', 'temperatura', 127.0000, 'ºC'),
	(253238, 120, '2014-03-15 01:13:08.000000', 'temperatura', 457.0000, 'ºC'),
	(253239, 120, '2014-03-15 01:13:09.000000', 'temperatura', 705.0000, 'ºC'),
	(253240, 120, '2014-03-15 01:13:10.000000', 'temperatura', 956.0000, 'ºC'),
	(253241, 120, '2014-03-15 01:13:11.000000', 'temperatura', 263.0000, 'ºC'),
	(253242, 120, '2014-03-15 01:13:12.000000', 'temperatura', 846.0000, 'ºC'),
	(253243, 120, '2014-03-15 01:13:13.000000', 'temperatura', 1044.0000, 'ºC'),
	(253244, 120, '2014-03-15 01:13:14.000000', 'temperatura', 282.0000, 'ºC'),
	(253245, 120, '2014-03-15 01:13:15.000000', 'temperatura', 677.0000, 'ºC'),
	(253246, 120, '2014-03-15 01:13:16.000000', 'temperatura', 141.0000, 'ºC'),
	(253247, 120, '2014-03-15 01:13:17.000000', 'temperatura', 1073.0000, 'ºC'),
	(253248, 120, '2014-03-15 01:13:18.000000', 'temperatura', 141.0000, 'ºC'),
	(253249, 120, '2014-03-15 01:13:19.000000', 'temperatura', 1089.0000, 'ºC'),
	(253250, 120, '2014-03-15 01:13:20.000000', 'temperatura', 221.0000, 'ºC'),
	(253251, 120, '2014-03-15 01:13:21.000000', 'temperatura', 240.0000, 'ºC'),
	(253252, 120, '2014-03-15 01:13:22.000000', 'temperatura', 536.0000, 'ºC'),
	(253253, 120, '2014-03-15 01:13:23.000000', 'temperatura', 763.0000, 'ºC'),
	(253254, 120, '2014-03-15 01:13:24.000000', 'temperatura', 1007.0000, 'ºC'),
	(253255, 120, '2014-03-15 01:13:25.000000', 'temperatura', 347.0000, 'ºC'),
	(253256, 120, '2014-03-15 01:13:26.000000', 'temperatura', 1114.0000, 'ºC'),
	(253257, 120, '2014-03-15 01:13:27.000000', 'temperatura', 929.0000, 'ºC'),
	(253258, 120, '2014-03-15 01:13:28.000000', 'temperatura', 103.0000, 'ºC'),
	(253259, 120, '2014-03-15 01:13:29.000000', 'temperatura', 127.0000, 'ºC'),
	(253260, 120, '2014-03-15 01:13:30.000000', 'temperatura', 330.0000, 'ºC'),
	(253261, 120, '2014-03-15 01:13:31.000000', 'temperatura', 66.0000, 'ºC'),
	(253262, 120, '2014-03-15 01:13:32.000000', 'temperatura', 542.0000, 'ºC'),
	(253263, 120, '2014-03-15 01:13:33.000000', 'temperatura', 114.0000, 'ºC'),
	(253264, 120, '2014-03-15 01:13:34.000000', 'temperatura', 144.0000, 'ºC'),
	(253265, 120, '2014-03-15 01:13:35.000000', 'temperatura', 376.0000, 'ºC'),
	(253266, 120, '2014-03-15 01:13:36.000000', 'temperatura', 251.0000, 'ºC'),
	(253267, 120, '2014-03-15 01:13:37.000000', 'temperatura', 128.0000, 'ºC'),
	(253268, 120, '2014-03-15 01:13:38.000000', 'temperatura', 1087.0000, 'ºC'),
	(253269, 120, '2014-03-15 01:13:39.000000', 'temperatura', 251.0000, 'ºC'),
	(253270, 120, '2014-03-15 01:13:40.000000', 'temperatura', 397.0000, 'ºC'),
	(253271, 120, '2014-03-15 01:13:41.000000', 'temperatura', 29.0000, 'ºC'),
	(253272, 120, '2014-03-15 01:13:42.000000', 'temperatura', 157.0000, 'ºC'),
	(253273, 120, '2014-03-15 01:13:43.000000', 'temperatura', 696.0000, 'ºC'),
	(253274, 120, '2014-03-15 01:13:44.000000', 'temperatura', 612.0000, 'ºC'),
	(253275, 120, '2014-03-15 01:13:45.000000', 'temperatura', 973.0000, 'ºC'),
	(253276, 120, '2014-03-15 01:13:46.000000', 'temperatura', 629.0000, 'ºC'),
	(253277, 120, '2014-03-15 01:13:47.000000', 'temperatura', 227.0000, 'ºC'),
	(253278, 120, '2014-03-15 01:13:48.000000', 'temperatura', 446.0000, 'ºC'),
	(253279, 120, '2014-03-15 01:13:49.000000', 'temperatura', 350.0000, 'ºC'),
	(253280, 120, '2014-03-15 01:13:50.000000', 'temperatura', 415.0000, 'ºC'),
	(253281, 120, '2014-03-15 01:13:51.000000', 'temperatura', 1024.0000, 'ºC'),
	(253282, 120, '2014-03-15 01:13:52.000000', 'temperatura', 277.0000, 'ºC'),
	(253283, 120, '2014-03-15 01:13:53.000000', 'temperatura', 712.0000, 'ºC'),
	(253284, 120, '2014-03-15 01:13:54.000000', 'temperatura', 330.0000, 'ºC'),
	(253285, 120, '2014-03-15 01:13:55.000000', 'temperatura', 716.0000, 'ºC'),
	(253286, 120, '2014-03-15 01:13:56.000000', 'temperatura', 192.0000, 'ºC'),
	(253287, 120, '2014-03-15 01:13:57.000000', 'temperatura', 9.0000, 'ºC'),
	(253288, 120, '2014-03-15 01:13:58.000000', 'temperatura', 669.0000, 'ºC'),
	(253289, 120, '2014-03-15 01:13:59.000000', 'temperatura', 919.0000, 'ºC'),
	(253290, 120, '2014-03-15 01:14:00.000000', 'temperatura', 190.0000, 'ºC'),
	(253291, 120, '2014-03-15 01:14:01.000000', 'temperatura', 594.0000, 'ºC'),
	(253292, 120, '2014-03-15 01:14:02.000000', 'temperatura', 1198.0000, 'ºC'),
	(253293, 120, '2014-03-15 01:14:03.000000', 'temperatura', 608.0000, 'ºC'),
	(253294, 120, '2014-03-15 01:14:04.000000', 'temperatura', 647.0000, 'ºC'),
	(253295, 120, '2014-03-15 01:14:05.000000', 'temperatura', 212.0000, 'ºC'),
	(253296, 120, '2014-03-15 01:14:06.000000', 'temperatura', 321.0000, 'ºC'),
	(253297, 120, '2014-03-15 01:14:07.000000', 'temperatura', 969.0000, 'ºC'),
	(253298, 120, '2014-03-15 01:14:08.000000', 'temperatura', 283.0000, 'ºC'),
	(253299, 120, '2014-03-15 01:14:09.000000', 'temperatura', 906.0000, 'ºC'),
	(253300, 120, '2014-03-15 01:14:10.000000', 'temperatura', 84.0000, 'ºC'),
	(253301, 120, '2014-03-15 01:14:11.000000', 'temperatura', 101.0000, 'ºC'),
	(253302, 120, '2014-03-15 01:14:12.000000', 'temperatura', 255.0000, 'ºC'),
	(253303, 120, '2014-03-15 01:14:13.000000', 'temperatura', 970.0000, 'ºC'),
	(253304, 120, '2014-03-15 01:14:14.000000', 'temperatura', 487.0000, 'ºC'),
	(253305, 120, '2014-03-15 01:14:15.000000', 'temperatura', 725.0000, 'ºC'),
	(253306, 120, '2014-03-15 01:14:16.000000', 'temperatura', 965.0000, 'ºC'),
	(253307, 120, '2014-03-15 01:14:17.000000', 'temperatura', 252.0000, 'ºC'),
	(253308, 120, '2014-03-15 01:14:18.000000', 'temperatura', 762.0000, 'ºC'),
	(253309, 120, '2014-03-15 01:14:19.000000', 'temperatura', 658.0000, 'ºC'),
	(253310, 120, '2014-03-15 01:14:20.000000', 'temperatura', 1004.0000, 'ºC'),
	(253311, 120, '2014-03-15 01:14:21.000000', 'temperatura', 645.0000, 'ºC'),
	(253312, 120, '2014-03-15 01:14:22.000000', 'temperatura', 216.0000, 'ºC'),
	(253313, 120, '2014-03-15 01:14:23.000000', 'temperatura', 342.0000, 'ºC'),
	(253314, 120, '2014-03-15 01:14:24.000000', 'temperatura', 1066.0000, 'ºC'),
	(253315, 120, '2014-03-15 01:14:25.000000', 'temperatura', 703.0000, 'ºC'),
	(253316, 120, '2014-03-15 01:14:26.000000', 'temperatura', 318.0000, 'ºC'),
	(253317, 120, '2014-03-15 01:14:27.000000', 'temperatura', 681.0000, 'ºC'),
	(253318, 120, '2014-03-15 01:14:28.000000', 'temperatura', 51.0000, 'ºC'),
	(253319, 120, '2014-03-15 01:14:29.000000', 'temperatura', 613.0000, 'ºC'),
	(253320, 120, '2014-03-15 01:14:30.000000', 'temperatura', 511.0000, 'ºC'),
	(253321, 120, '2014-03-15 01:14:31.000000', 'temperatura', 718.0000, 'ºC'),
	(253322, 120, '2014-03-15 01:14:32.000000', 'temperatura', 856.0000, 'ºC'),
	(253323, 120, '2014-03-15 01:14:33.000000', 'temperatura', 928.0000, 'ºC'),
	(253324, 120, '2014-03-15 01:14:34.000000', 'temperatura', 874.0000, 'ºC'),
	(253325, 120, '2014-03-15 01:14:35.000000', 'temperatura', 383.0000, 'ºC'),
	(253326, 120, '2014-03-15 01:14:36.000000', 'temperatura', 495.0000, 'ºC'),
	(253327, 120, '2014-03-15 01:14:37.000000', 'temperatura', 127.0000, 'ºC'),
	(253328, 120, '2014-03-15 01:14:38.000000', 'temperatura', 348.0000, 'ºC'),
	(253329, 120, '2014-03-15 01:14:39.000000', 'temperatura', 163.0000, 'ºC'),
	(253330, 120, '2014-03-15 01:14:40.000000', 'temperatura', 969.0000, 'ºC'),
	(253331, 120, '2014-03-15 01:14:41.000000', 'temperatura', 759.0000, 'ºC'),
	(253332, 120, '2014-03-15 01:14:42.000000', 'temperatura', 887.0000, 'ºC'),
	(253333, 120, '2014-03-15 01:14:43.000000', 'temperatura', 957.0000, 'ºC'),
	(253334, 120, '2014-03-15 01:14:44.000000', 'temperatura', 924.0000, 'ºC'),
	(253335, 120, '2014-03-15 01:14:45.000000', 'temperatura', 552.0000, 'ºC'),
	(253336, 120, '2014-03-15 01:14:46.000000', 'temperatura', 1190.0000, 'ºC'),
	(253337, 120, '2014-03-15 01:14:47.000000', 'temperatura', 691.0000, 'ºC'),
	(253338, 120, '2014-03-15 01:14:48.000000', 'temperatura', 1087.0000, 'ºC'),
	(253339, 120, '2014-03-15 01:14:49.000000', 'temperatura', 964.0000, 'ºC'),
	(253340, 120, '2014-03-15 01:14:50.000000', 'temperatura', 360.0000, 'ºC'),
	(253341, 120, '2014-03-15 01:14:51.000000', 'temperatura', 108.0000, 'ºC'),
	(253342, 120, '2014-03-15 01:14:52.000000', 'temperatura', 662.0000, 'ºC'),
	(253343, 120, '2014-03-15 01:14:53.000000', 'temperatura', 585.0000, 'ºC'),
	(253344, 120, '2014-03-15 01:14:54.000000', 'temperatura', 940.0000, 'ºC'),
	(253345, 120, '2014-03-15 01:14:55.000000', 'temperatura', 547.0000, 'ºC'),
	(253346, 120, '2014-03-15 01:14:56.000000', 'temperatura', 1114.0000, 'ºC'),
	(253347, 120, '2014-03-15 01:14:57.000000', 'temperatura', 331.0000, 'ºC'),
	(253348, 120, '2014-03-15 01:14:58.000000', 'temperatura', 713.0000, 'ºC'),
	(253349, 120, '2014-03-15 01:14:59.000000', 'temperatura', 172.0000, 'ºC'),
	(253350, 120, '2014-03-15 01:15:00.000000', 'temperatura', 1122.0000, 'ºC'),
	(253351, 120, '2014-03-15 01:15:01.000000', 'temperatura', 296.0000, 'ºC'),
	(253352, 120, '2014-03-15 01:15:02.000000', 'temperatura', 515.0000, 'ºC'),
	(253353, 120, '2014-03-15 01:15:03.000000', 'temperatura', 485.0000, 'ºC'),
	(253354, 120, '2014-03-15 01:15:04.000000', 'temperatura', 881.0000, 'ºC'),
	(253355, 120, '2014-03-15 01:15:05.000000', 'temperatura', 552.0000, 'ºC'),
	(253356, 120, '2014-03-15 01:15:06.000000', 'temperatura', 118.0000, 'ºC'),
	(253357, 120, '2014-03-15 01:15:07.000000', 'temperatura', 132.0000, 'ºC'),
	(253358, 120, '2014-03-15 01:15:08.000000', 'temperatura', 307.0000, 'ºC'),
	(253359, 120, '2014-03-15 01:15:09.000000', 'temperatura', 1141.0000, 'ºC'),
	(253360, 120, '2014-03-15 01:15:10.000000', 'temperatura', 1184.0000, 'ºC'),
	(253361, 120, '2014-03-15 01:15:11.000000', 'temperatura', 99.0000, 'ºC'),
	(253362, 120, '2014-03-15 01:15:12.000000', 'temperatura', 543.0000, 'ºC'),
	(253363, 120, '2014-03-15 01:15:13.000000', 'temperatura', 19.0000, 'ºC'),
	(253364, 120, '2014-03-15 01:15:14.000000', 'temperatura', 866.0000, 'ºC'),
	(253365, 120, '2014-03-15 01:15:15.000000', 'temperatura', 672.0000, 'ºC'),
	(253366, 120, '2014-03-15 01:15:16.000000', 'temperatura', 765.0000, 'ºC'),
	(253367, 120, '2014-03-15 01:15:17.000000', 'temperatura', 610.0000, 'ºC'),
	(253368, 120, '2014-03-15 01:15:18.000000', 'temperatura', 755.0000, 'ºC'),
	(253369, 120, '2014-03-15 01:15:19.000000', 'temperatura', 745.0000, 'ºC'),
	(253370, 120, '2014-03-15 01:15:20.000000', 'temperatura', 259.0000, 'ºC'),
	(253371, 120, '2014-03-15 01:15:21.000000', 'temperatura', 259.0000, 'ºC'),
	(253372, 120, '2014-03-15 01:15:22.000000', 'temperatura', 522.0000, 'ºC'),
	(253373, 120, '2014-03-15 01:15:23.000000', 'temperatura', 634.0000, 'ºC'),
	(253374, 120, '2014-03-15 01:15:24.000000', 'temperatura', 402.0000, 'ºC'),
	(253375, 120, '2014-03-15 01:15:25.000000', 'temperatura', 109.0000, 'ºC'),
	(253376, 120, '2014-03-15 01:15:26.000000', 'temperatura', 541.0000, 'ºC'),
	(253377, 120, '2014-03-15 01:15:27.000000', 'temperatura', 1177.0000, 'ºC'),
	(253378, 120, '2014-03-15 01:15:28.000000', 'temperatura', 663.0000, 'ºC'),
	(253379, 120, '2014-03-15 01:15:29.000000', 'temperatura', 985.0000, 'ºC'),
	(253380, 120, '2014-03-15 01:15:30.000000', 'temperatura', 537.0000, 'ºC'),
	(253381, 120, '2014-03-15 01:15:31.000000', 'temperatura', 931.0000, 'ºC'),
	(253382, 120, '2014-03-15 01:15:32.000000', 'temperatura', 645.0000, 'ºC'),
	(253383, 120, '2014-03-15 01:15:33.000000', 'temperatura', 432.0000, 'ºC'),
	(253384, 120, '2014-03-15 01:15:34.000000', 'temperatura', 224.0000, 'ºC'),
	(253385, 120, '2014-03-15 01:15:35.000000', 'temperatura', 1027.0000, 'ºC'),
	(253386, 120, '2014-03-15 01:15:36.000000', 'temperatura', 862.0000, 'ºC'),
	(253387, 120, '2014-03-15 01:15:37.000000', 'temperatura', 29.0000, 'ºC'),
	(253388, 120, '2014-03-15 01:15:38.000000', 'temperatura', 1161.0000, 'ºC'),
	(253389, 120, '2014-03-15 01:15:39.000000', 'temperatura', 917.0000, 'ºC'),
	(253390, 120, '2014-03-15 01:15:40.000000', 'temperatura', 1102.0000, 'ºC'),
	(253391, 120, '2014-03-15 01:15:41.000000', 'temperatura', 359.0000, 'ºC'),
	(253392, 120, '2014-03-15 01:15:42.000000', 'temperatura', 889.0000, 'ºC'),
	(253393, 120, '2014-03-15 01:15:43.000000', 'temperatura', 968.0000, 'ºC'),
	(253394, 120, '2014-03-15 01:15:44.000000', 'temperatura', 973.0000, 'ºC'),
	(253395, 120, '2014-03-15 01:15:45.000000', 'temperatura', 764.0000, 'ºC'),
	(253396, 120, '2014-03-15 01:15:46.000000', 'temperatura', 902.0000, 'ºC'),
	(253397, 120, '2014-03-15 01:15:47.000000', 'temperatura', 1015.0000, 'ºC'),
	(253398, 120, '2014-03-15 01:15:48.000000', 'temperatura', 1173.0000, 'ºC'),
	(253399, 120, '2014-03-15 01:15:49.000000', 'temperatura', 420.0000, 'ºC'),
	(253400, 120, '2014-03-15 01:15:50.000000', 'temperatura', 980.0000, 'ºC'),
	(253401, 120, '2014-03-15 01:15:51.000000', 'temperatura', 39.0000, 'ºC'),
	(253402, 120, '2014-03-15 01:15:52.000000', 'temperatura', 858.0000, 'ºC'),
	(253403, 120, '2014-03-15 01:15:53.000000', 'temperatura', 575.0000, 'ºC'),
	(253404, 120, '2014-03-15 01:15:54.000000', 'temperatura', 298.0000, 'ºC'),
	(253405, 120, '2014-03-15 01:15:55.000000', 'temperatura', 967.0000, 'ºC'),
	(253406, 120, '2014-03-15 01:15:56.000000', 'temperatura', 340.0000, 'ºC'),
	(253407, 120, '2014-03-15 01:15:57.000000', 'temperatura', 1199.0000, 'ºC'),
	(253408, 120, '2014-03-15 01:15:58.000000', 'temperatura', 176.0000, 'ºC'),
	(253409, 120, '2014-03-15 01:15:59.000000', 'temperatura', 884.0000, 'ºC'),
	(253410, 120, '2014-03-15 01:16:00.000000', 'temperatura', 294.0000, 'ºC'),
	(253411, 120, '2014-03-15 01:16:01.000000', 'temperatura', 16.0000, 'ºC'),
	(253412, 120, '2014-03-15 01:16:02.000000', 'temperatura', 398.0000, 'ºC'),
	(253413, 120, '2014-03-15 01:16:03.000000', 'temperatura', 742.0000, 'ºC'),
	(253414, 120, '2014-03-15 01:16:04.000000', 'temperatura', 117.0000, 'ºC'),
	(253415, 120, '2014-03-15 01:16:05.000000', 'temperatura', 759.0000, 'ºC'),
	(253416, 120, '2014-03-15 01:16:06.000000', 'temperatura', 1047.0000, 'ºC'),
	(253417, 120, '2014-03-15 01:16:07.000000', 'temperatura', 555.0000, 'ºC'),
	(253418, 120, '2014-03-15 01:16:08.000000', 'temperatura', 837.0000, 'ºC'),
	(253419, 120, '2014-03-15 01:16:09.000000', 'temperatura', 120.0000, 'ºC'),
	(253420, 120, '2014-03-15 01:16:10.000000', 'temperatura', 487.0000, 'ºC'),
	(253421, 120, '2014-03-15 01:16:11.000000', 'temperatura', 878.0000, 'ºC'),
	(253422, 120, '2014-03-15 01:16:12.000000', 'temperatura', 531.0000, 'ºC'),
	(253423, 120, '2014-03-15 01:16:13.000000', 'temperatura', 18.0000, 'ºC'),
	(253424, 120, '2014-03-15 01:16:14.000000', 'temperatura', 899.0000, 'ºC'),
	(253425, 120, '2014-03-15 01:16:15.000000', 'temperatura', 843.0000, 'ºC'),
	(253426, 120, '2014-03-15 01:16:16.000000', 'temperatura', 320.0000, 'ºC'),
	(253427, 120, '2014-03-15 01:16:17.000000', 'temperatura', 268.0000, 'ºC'),
	(253428, 120, '2014-03-15 01:16:18.000000', 'temperatura', 381.0000, 'ºC'),
	(253429, 120, '2014-03-15 01:16:19.000000', 'temperatura', 1100.0000, 'ºC'),
	(253430, 120, '2014-03-15 01:16:20.000000', 'temperatura', 760.0000, 'ºC'),
	(253431, 120, '2014-03-15 01:16:21.000000', 'temperatura', 498.0000, 'ºC'),
	(253432, 120, '2014-03-15 01:16:22.000000', 'temperatura', 210.0000, 'ºC'),
	(253433, 120, '2014-03-15 01:16:23.000000', 'temperatura', 757.0000, 'ºC'),
	(253434, 120, '2014-03-15 01:16:24.000000', 'temperatura', 757.0000, 'ºC'),
	(253435, 120, '2014-03-15 01:16:25.000000', 'temperatura', 312.0000, 'ºC'),
	(253436, 120, '2014-03-15 01:16:26.000000', 'temperatura', 491.0000, 'ºC'),
	(253437, 120, '2014-03-15 01:16:27.000000', 'temperatura', 319.0000, 'ºC'),
	(253438, 120, '2014-03-15 01:16:28.000000', 'temperatura', 122.0000, 'ºC'),
	(253439, 120, '2014-03-15 01:16:29.000000', 'temperatura', 852.0000, 'ºC'),
	(253440, 120, '2014-03-15 01:16:30.000000', 'temperatura', 296.0000, 'ºC'),
	(253441, 120, '2014-03-15 01:16:31.000000', 'temperatura', 123.0000, 'ºC'),
	(253442, 120, '2014-03-15 01:16:32.000000', 'temperatura', 930.0000, 'ºC'),
	(253443, 120, '2014-03-15 01:16:33.000000', 'temperatura', 682.0000, 'ºC'),
	(253444, 120, '2014-03-15 01:16:34.000000', 'temperatura', 618.0000, 'ºC'),
	(253445, 120, '2014-03-15 01:16:35.000000', 'temperatura', 1043.0000, 'ºC'),
	(253446, 120, '2014-03-15 01:16:36.000000', 'temperatura', 965.0000, 'ºC'),
	(253447, 120, '2014-03-15 01:16:37.000000', 'temperatura', 495.0000, 'ºC'),
	(253448, 120, '2014-03-15 01:16:38.000000', 'temperatura', 781.0000, 'ºC'),
	(253449, 120, '2014-03-15 01:16:39.000000', 'temperatura', 21.0000, 'ºC'),
	(253450, 120, '2014-03-15 01:16:40.000000', 'temperatura', 161.0000, 'ºC'),
	(253451, 120, '2014-03-15 01:16:41.000000', 'temperatura', 745.0000, 'ºC'),
	(253452, 120, '2014-03-15 01:16:42.000000', 'temperatura', 841.0000, 'ºC'),
	(253453, 120, '2014-03-15 01:16:43.000000', 'temperatura', 771.0000, 'ºC'),
	(253454, 120, '2014-03-15 01:16:44.000000', 'temperatura', 133.0000, 'ºC'),
	(253455, 120, '2014-03-15 01:16:45.000000', 'temperatura', 753.0000, 'ºC'),
	(253456, 120, '2014-03-15 01:16:46.000000', 'temperatura', 964.0000, 'ºC'),
	(253457, 120, '2014-03-15 01:16:47.000000', 'temperatura', 163.0000, 'ºC'),
	(253458, 120, '2014-03-15 01:16:48.000000', 'temperatura', 325.0000, 'ºC'),
	(253459, 120, '2014-03-15 01:16:49.000000', 'temperatura', 1136.0000, 'ºC'),
	(253460, 120, '2014-03-15 01:16:50.000000', 'temperatura', 1106.0000, 'ºC'),
	(253461, 120, '2014-03-15 01:16:51.000000', 'temperatura', 921.0000, 'ºC'),
	(253462, 120, '2014-03-15 01:16:52.000000', 'temperatura', 89.0000, 'ºC'),
	(253463, 120, '2014-03-15 01:16:53.000000', 'temperatura', 82.0000, 'ºC'),
	(253464, 120, '2014-03-15 01:16:54.000000', 'temperatura', 142.0000, 'ºC'),
	(253465, 120, '2014-03-15 01:16:55.000000', 'temperatura', 464.0000, 'ºC'),
	(253466, 120, '2014-03-15 01:16:56.000000', 'temperatura', 696.0000, 'ºC'),
	(253467, 120, '2014-03-15 01:16:57.000000', 'temperatura', 888.0000, 'ºC'),
	(253468, 120, '2014-03-15 01:16:58.000000', 'temperatura', 1154.0000, 'ºC'),
	(253469, 120, '2014-03-15 01:16:59.000000', 'temperatura', 706.0000, 'ºC'),
	(253470, 120, '2014-03-15 01:17:00.000000', 'temperatura', 68.0000, 'ºC'),
	(253471, 120, '2014-03-15 01:17:01.000000', 'temperatura', 623.0000, 'ºC'),
	(253472, 120, '2014-03-15 01:17:02.000000', 'temperatura', 512.0000, 'ºC'),
	(253473, 120, '2014-03-15 01:17:03.000000', 'temperatura', 689.0000, 'ºC'),
	(253474, 120, '2014-03-15 01:17:04.000000', 'temperatura', 713.0000, 'ºC'),
	(253475, 120, '2014-03-15 01:17:05.000000', 'temperatura', 297.0000, 'ºC'),
	(253476, 120, '2014-03-15 01:17:06.000000', 'temperatura', 545.0000, 'ºC'),
	(253477, 120, '2014-03-15 01:17:07.000000', 'temperatura', 634.0000, 'ºC'),
	(253478, 120, '2014-03-15 01:17:08.000000', 'temperatura', 337.0000, 'ºC'),
	(253479, 120, '2014-03-15 01:17:09.000000', 'temperatura', 982.0000, 'ºC'),
	(253480, 120, '2014-03-15 01:17:10.000000', 'temperatura', 299.0000, 'ºC'),
	(253481, 120, '2014-03-15 01:17:11.000000', 'temperatura', 949.0000, 'ºC'),
	(253482, 120, '2014-03-15 01:17:12.000000', 'temperatura', 250.0000, 'ºC'),
	(253483, 120, '2014-03-15 01:17:13.000000', 'temperatura', 805.0000, 'ºC'),
	(253484, 120, '2014-03-15 01:17:14.000000', 'temperatura', 874.0000, 'ºC'),
	(253485, 120, '2014-03-15 01:17:15.000000', 'temperatura', 755.0000, 'ºC'),
	(253486, 120, '2014-03-15 01:17:16.000000', 'temperatura', 1152.0000, 'ºC'),
	(253487, 120, '2014-03-15 01:17:17.000000', 'temperatura', 1097.0000, 'ºC'),
	(253488, 120, '2014-03-15 01:17:18.000000', 'temperatura', 830.0000, 'ºC'),
	(253489, 120, '2014-03-15 01:17:19.000000', 'temperatura', 861.0000, 'ºC'),
	(253490, 120, '2014-03-15 01:17:20.000000', 'temperatura', 615.0000, 'ºC'),
	(253491, 120, '2014-03-15 01:17:21.000000', 'temperatura', 490.0000, 'ºC'),
	(253492, 120, '2014-03-15 01:17:22.000000', 'temperatura', 608.0000, 'ºC'),
	(253493, 120, '2014-03-15 01:17:23.000000', 'temperatura', 370.0000, 'ºC'),
	(253494, 120, '2014-03-15 01:17:24.000000', 'temperatura', 24.0000, 'ºC'),
	(253495, 120, '2014-03-15 01:17:25.000000', 'temperatura', 213.0000, 'ºC'),
	(253496, 120, '2014-03-15 01:17:26.000000', 'temperatura', 991.0000, 'ºC'),
	(253497, 120, '2014-03-15 01:17:27.000000', 'temperatura', 720.0000, 'ºC'),
	(253498, 120, '2014-03-15 01:17:28.000000', 'temperatura', 625.0000, 'ºC'),
	(253499, 120, '2014-03-15 01:17:29.000000', 'temperatura', 964.0000, 'ºC'),
	(253500, 120, '2014-03-15 01:17:30.000000', 'temperatura', 549.0000, 'ºC'),
	(253501, 120, '2014-03-15 01:17:31.000000', 'temperatura', 1050.0000, 'ºC'),
	(253502, 120, '2014-03-15 01:17:32.000000', 'temperatura', 7.0000, 'ºC'),
	(253503, 120, '2014-03-15 01:17:33.000000', 'temperatura', 482.0000, 'ºC'),
	(253504, 120, '2014-03-15 01:17:34.000000', 'temperatura', 1193.0000, 'ºC'),
	(253505, 120, '2014-03-15 01:17:35.000000', 'temperatura', 917.0000, 'ºC'),
	(253506, 120, '2014-03-15 01:17:36.000000', 'temperatura', 1008.0000, 'ºC'),
	(253507, 120, '2014-03-15 01:17:37.000000', 'temperatura', 1089.0000, 'ºC'),
	(253508, 120, '2014-03-15 01:17:38.000000', 'temperatura', 21.0000, 'ºC'),
	(253509, 120, '2014-03-15 01:17:39.000000', 'temperatura', 437.0000, 'ºC'),
	(253510, 120, '2014-03-15 01:17:40.000000', 'temperatura', 924.0000, 'ºC'),
	(253511, 120, '2014-03-15 01:17:41.000000', 'temperatura', 910.0000, 'ºC'),
	(253512, 120, '2014-03-15 01:17:42.000000', 'temperatura', 578.0000, 'ºC'),
	(253513, 120, '2014-03-15 01:17:43.000000', 'temperatura', 159.0000, 'ºC'),
	(253514, 120, '2014-03-15 01:17:44.000000', 'temperatura', 261.0000, 'ºC'),
	(253515, 120, '2014-03-15 01:17:45.000000', 'temperatura', 828.0000, 'ºC'),
	(253516, 120, '2014-03-15 01:17:46.000000', 'temperatura', 958.0000, 'ºC'),
	(253517, 120, '2014-03-15 01:17:47.000000', 'temperatura', 1108.0000, 'ºC'),
	(253518, 120, '2014-03-15 01:17:48.000000', 'temperatura', 267.0000, 'ºC'),
	(253519, 120, '2014-03-15 01:17:49.000000', 'temperatura', 409.0000, 'ºC'),
	(253520, 120, '2014-03-15 01:17:50.000000', 'temperatura', 45.0000, 'ºC'),
	(253521, 120, '2014-03-15 01:17:51.000000', 'temperatura', 201.0000, 'ºC'),
	(253522, 120, '2014-03-15 01:17:52.000000', 'temperatura', 867.0000, 'ºC'),
	(253523, 120, '2014-03-15 01:17:53.000000', 'temperatura', 134.0000, 'ºC'),
	(253524, 120, '2014-03-15 01:17:54.000000', 'temperatura', 469.0000, 'ºC'),
	(253525, 120, '2014-03-15 01:17:55.000000', 'temperatura', 743.0000, 'ºC'),
	(253526, 120, '2014-03-15 01:17:56.000000', 'temperatura', 1107.0000, 'ºC'),
	(253527, 120, '2014-03-15 01:17:57.000000', 'temperatura', 908.0000, 'ºC'),
	(253528, 120, '2014-03-15 01:17:58.000000', 'temperatura', 21.0000, 'ºC'),
	(253529, 120, '2014-03-15 01:17:59.000000', 'temperatura', 982.0000, 'ºC'),
	(253530, 120, '2014-03-15 01:18:00.000000', 'temperatura', 46.0000, 'ºC'),
	(253531, 120, '2014-03-15 01:18:01.000000', 'temperatura', 887.0000, 'ºC'),
	(253532, 120, '2014-03-15 01:18:02.000000', 'temperatura', 695.0000, 'ºC'),
	(253533, 120, '2014-03-15 01:18:03.000000', 'temperatura', 814.0000, 'ºC'),
	(253534, 120, '2014-03-15 01:18:04.000000', 'temperatura', 787.0000, 'ºC'),
	(253535, 120, '2014-03-15 01:18:05.000000', 'temperatura', 293.0000, 'ºC'),
	(253536, 120, '2014-03-15 01:18:06.000000', 'temperatura', 306.0000, 'ºC'),
	(253537, 120, '2014-03-15 01:18:07.000000', 'temperatura', 650.0000, 'ºC'),
	(253538, 120, '2014-03-15 01:18:08.000000', 'temperatura', 1133.0000, 'ºC'),
	(253539, 120, '2014-03-15 01:18:09.000000', 'temperatura', 115.0000, 'ºC'),
	(253540, 120, '2014-03-15 01:18:10.000000', 'temperatura', 778.0000, 'ºC'),
	(253541, 120, '2014-03-15 01:18:11.000000', 'temperatura', 1143.0000, 'ºC'),
	(253542, 120, '2014-03-15 01:18:12.000000', 'temperatura', 984.0000, 'ºC'),
	(253543, 120, '2014-03-15 01:18:13.000000', 'temperatura', 290.0000, 'ºC'),
	(253544, 120, '2014-03-15 01:18:14.000000', 'temperatura', 901.0000, 'ºC'),
	(253545, 120, '2014-03-15 01:18:15.000000', 'temperatura', 33.0000, 'ºC'),
	(253546, 120, '2014-03-15 01:18:16.000000', 'temperatura', 1063.0000, 'ºC'),
	(253547, 120, '2014-03-15 01:18:17.000000', 'temperatura', 418.0000, 'ºC'),
	(253548, 120, '2014-03-15 01:18:18.000000', 'temperatura', 99.0000, 'ºC'),
	(253549, 120, '2014-03-15 01:18:19.000000', 'temperatura', 444.0000, 'ºC'),
	(253550, 120, '2014-03-15 01:18:20.000000', 'temperatura', 722.0000, 'ºC'),
	(253551, 120, '2014-03-15 01:18:21.000000', 'temperatura', 1079.0000, 'ºC'),
	(253552, 120, '2014-03-15 01:18:22.000000', 'temperatura', 828.0000, 'ºC'),
	(253553, 120, '2014-03-15 01:18:23.000000', 'temperatura', 906.0000, 'ºC'),
	(253554, 120, '2014-03-15 01:18:24.000000', 'temperatura', 846.0000, 'ºC'),
	(253555, 120, '2014-03-15 01:18:25.000000', 'temperatura', 312.0000, 'ºC'),
	(253556, 120, '2014-03-15 01:18:26.000000', 'temperatura', 221.0000, 'ºC'),
	(253557, 120, '2014-03-15 01:18:27.000000', 'temperatura', 171.0000, 'ºC'),
	(253558, 120, '2014-03-15 01:18:28.000000', 'temperatura', 192.0000, 'ºC'),
	(253559, 120, '2014-03-15 01:18:29.000000', 'temperatura', 446.0000, 'ºC'),
	(253560, 120, '2014-03-15 01:18:30.000000', 'temperatura', 454.0000, 'ºC'),
	(253561, 120, '2014-03-15 01:18:31.000000', 'temperatura', 934.0000, 'ºC'),
	(253562, 120, '2014-03-15 01:18:32.000000', 'temperatura', 907.0000, 'ºC'),
	(253563, 120, '2014-03-15 01:18:33.000000', 'temperatura', 533.0000, 'ºC'),
	(253564, 120, '2014-03-15 01:18:34.000000', 'temperatura', 1144.0000, 'ºC'),
	(253565, 120, '2014-03-15 01:18:35.000000', 'temperatura', 521.0000, 'ºC'),
	(253566, 120, '2014-03-15 01:18:36.000000', 'temperatura', 374.0000, 'ºC'),
	(253567, 120, '2014-03-15 01:18:37.000000', 'temperatura', 307.0000, 'ºC'),
	(253568, 120, '2014-03-15 01:18:38.000000', 'temperatura', 414.0000, 'ºC'),
	(253569, 120, '2014-03-15 01:18:39.000000', 'temperatura', 1152.0000, 'ºC'),
	(253570, 120, '2014-03-15 01:18:40.000000', 'temperatura', 915.0000, 'ºC'),
	(253571, 120, '2014-03-15 01:18:41.000000', 'temperatura', 1122.0000, 'ºC'),
	(253572, 120, '2014-03-15 01:18:42.000000', 'temperatura', 465.0000, 'ºC'),
	(253573, 120, '2014-03-15 01:18:43.000000', 'temperatura', 159.0000, 'ºC'),
	(253574, 120, '2014-03-15 01:18:44.000000', 'temperatura', 599.0000, 'ºC'),
	(253575, 120, '2014-03-15 01:18:45.000000', 'temperatura', 118.0000, 'ºC'),
	(253576, 120, '2014-03-15 01:18:46.000000', 'temperatura', 1194.0000, 'ºC'),
	(253577, 120, '2014-03-15 01:18:47.000000', 'temperatura', 818.0000, 'ºC'),
	(253578, 120, '2014-03-15 01:18:48.000000', 'temperatura', 509.0000, 'ºC'),
	(253579, 120, '2014-03-15 01:18:49.000000', 'temperatura', 92.0000, 'ºC'),
	(253580, 120, '2014-03-15 01:18:50.000000', 'temperatura', 134.0000, 'ºC'),
	(253581, 120, '2014-03-15 01:18:51.000000', 'temperatura', 393.0000, 'ºC'),
	(253582, 120, '2014-03-15 01:18:52.000000', 'temperatura', 363.0000, 'ºC'),
	(253583, 120, '2014-03-15 01:18:53.000000', 'temperatura', 636.0000, 'ºC'),
	(253584, 120, '2014-03-15 01:18:54.000000', 'temperatura', 891.0000, 'ºC'),
	(253585, 120, '2014-03-15 01:18:55.000000', 'temperatura', 147.0000, 'ºC'),
	(253586, 120, '2014-03-15 01:18:56.000000', 'temperatura', 465.0000, 'ºC'),
	(253587, 120, '2014-03-15 01:18:57.000000', 'temperatura', 684.0000, 'ºC'),
	(253588, 120, '2014-03-15 01:18:58.000000', 'temperatura', 827.0000, 'ºC'),
	(253589, 120, '2014-03-15 01:18:59.000000', 'temperatura', 880.0000, 'ºC'),
	(253590, 120, '2014-03-15 01:19:00.000000', 'temperatura', 723.0000, 'ºC'),
	(253591, 120, '2014-03-15 01:19:01.000000', 'temperatura', 974.0000, 'ºC'),
	(253592, 120, '2014-03-15 01:19:02.000000', 'temperatura', 302.0000, 'ºC'),
	(253593, 120, '2014-03-15 01:19:03.000000', 'temperatura', 989.0000, 'ºC'),
	(253594, 120, '2014-03-15 01:19:04.000000', 'temperatura', 437.0000, 'ºC'),
	(253595, 120, '2014-03-15 01:19:05.000000', 'temperatura', 421.0000, 'ºC'),
	(253596, 120, '2014-03-15 01:19:06.000000', 'temperatura', 793.0000, 'ºC'),
	(253597, 120, '2014-03-15 01:19:07.000000', 'temperatura', 302.0000, 'ºC'),
	(253598, 120, '2014-03-15 01:19:08.000000', 'temperatura', 333.0000, 'ºC'),
	(253599, 120, '2014-03-15 01:19:09.000000', 'temperatura', 759.0000, 'ºC'),
	(253600, 120, '2014-03-15 01:19:10.000000', 'temperatura', 396.0000, 'ºC'),
	(253601, 120, '2014-03-15 01:19:11.000000', 'temperatura', 905.0000, 'ºC'),
	(253602, 120, '2014-03-15 01:19:12.000000', 'temperatura', 936.0000, 'ºC'),
	(253603, 120, '2014-03-15 01:19:13.000000', 'temperatura', 767.0000, 'ºC'),
	(253604, 120, '2014-03-15 01:19:14.000000', 'temperatura', 1028.0000, 'ºC'),
	(253605, 120, '2014-03-15 01:19:15.000000', 'temperatura', 439.0000, 'ºC'),
	(253606, 120, '2014-03-15 01:19:16.000000', 'temperatura', 312.0000, 'ºC'),
	(253607, 120, '2014-03-15 01:19:17.000000', 'temperatura', 244.0000, 'ºC'),
	(253608, 120, '2014-03-15 01:19:18.000000', 'temperatura', 282.0000, 'ºC'),
	(253609, 120, '2014-03-15 01:19:19.000000', 'temperatura', 681.0000, 'ºC'),
	(253610, 120, '2014-03-15 01:19:20.000000', 'temperatura', 160.0000, 'ºC'),
	(253611, 120, '2014-03-15 01:19:21.000000', 'temperatura', 1158.0000, 'ºC'),
	(253612, 120, '2014-03-15 01:19:22.000000', 'temperatura', 509.0000, 'ºC'),
	(253613, 120, '2014-03-15 01:19:23.000000', 'temperatura', 272.0000, 'ºC'),
	(253614, 120, '2014-03-15 01:19:24.000000', 'temperatura', 1032.0000, 'ºC'),
	(253615, 120, '2014-03-15 01:19:25.000000', 'temperatura', 744.0000, 'ºC'),
	(253616, 120, '2014-03-15 01:19:26.000000', 'temperatura', 626.0000, 'ºC'),
	(253617, 120, '2014-03-15 01:19:27.000000', 'temperatura', 897.0000, 'ºC'),
	(253618, 120, '2014-03-15 01:19:28.000000', 'temperatura', 207.0000, 'ºC'),
	(253619, 120, '2014-03-15 01:19:29.000000', 'temperatura', 747.0000, 'ºC'),
	(253620, 120, '2014-03-15 01:19:30.000000', 'temperatura', 714.0000, 'ºC'),
	(253621, 120, '2014-03-15 01:19:31.000000', 'temperatura', 130.0000, 'ºC'),
	(253622, 120, '2014-03-15 01:19:32.000000', 'temperatura', 906.0000, 'ºC'),
	(253623, 120, '2014-03-15 01:19:33.000000', 'temperatura', 543.0000, 'ºC'),
	(253624, 120, '2014-03-15 01:19:34.000000', 'temperatura', 1198.0000, 'ºC'),
	(253625, 120, '2014-03-15 01:19:35.000000', 'temperatura', 762.0000, 'ºC'),
	(253626, 120, '2014-03-15 01:19:36.000000', 'temperatura', 217.0000, 'ºC'),
	(253627, 120, '2014-03-15 01:19:37.000000', 'temperatura', 1197.0000, 'ºC'),
	(253628, 120, '2014-03-15 01:19:38.000000', 'temperatura', 536.0000, 'ºC'),
	(253629, 120, '2014-03-15 01:19:39.000000', 'temperatura', 290.0000, 'ºC'),
	(253630, 120, '2014-03-15 01:19:40.000000', 'temperatura', 1043.0000, 'ºC'),
	(253631, 120, '2014-03-15 01:19:41.000000', 'temperatura', 743.0000, 'ºC'),
	(253632, 120, '2014-03-15 01:19:42.000000', 'temperatura', 587.0000, 'ºC'),
	(253633, 120, '2014-03-15 01:19:43.000000', 'temperatura', 707.0000, 'ºC'),
	(253634, 120, '2014-03-15 01:19:44.000000', 'temperatura', 572.0000, 'ºC'),
	(253635, 120, '2014-03-15 01:19:45.000000', 'temperatura', 743.0000, 'ºC'),
	(253636, 120, '2014-03-15 01:19:46.000000', 'temperatura', 799.0000, 'ºC'),
	(253637, 120, '2014-03-15 01:19:47.000000', 'temperatura', 566.0000, 'ºC'),
	(253638, 120, '2014-03-15 01:19:48.000000', 'temperatura', 434.0000, 'ºC'),
	(253639, 120, '2014-03-15 01:19:49.000000', 'temperatura', 474.0000, 'ºC'),
	(253640, 120, '2014-03-15 01:19:50.000000', 'temperatura', 1067.0000, 'ºC'),
	(253641, 120, '2014-03-15 01:19:51.000000', 'temperatura', 312.0000, 'ºC'),
	(253642, 120, '2014-03-15 01:19:52.000000', 'temperatura', 762.0000, 'ºC'),
	(253643, 120, '2014-03-15 01:19:53.000000', 'temperatura', 475.0000, 'ºC'),
	(253644, 120, '2014-03-15 01:19:54.000000', 'temperatura', 88.0000, 'ºC'),
	(253645, 120, '2014-03-15 01:19:55.000000', 'temperatura', 216.0000, 'ºC'),
	(253646, 120, '2014-03-15 01:19:56.000000', 'temperatura', 816.0000, 'ºC'),
	(253647, 120, '2014-03-15 01:19:57.000000', 'temperatura', 1033.0000, 'ºC'),
	(253648, 120, '2014-03-15 01:19:58.000000', 'temperatura', 319.0000, 'ºC'),
	(253649, 120, '2014-03-15 01:19:59.000000', 'temperatura', 895.0000, 'ºC'),
	(253650, 120, '2014-03-15 01:20:00.000000', 'temperatura', 1117.0000, 'ºC'),
	(253651, 120, '2014-03-15 01:20:01.000000', 'temperatura', 501.0000, 'ºC'),
	(253652, 120, '2014-03-15 01:20:02.000000', 'temperatura', 355.0000, 'ºC'),
	(253653, 120, '2014-03-15 01:20:03.000000', 'temperatura', 272.0000, 'ºC'),
	(253654, 120, '2014-03-15 01:20:04.000000', 'temperatura', 297.0000, 'ºC'),
	(253655, 120, '2014-03-15 01:20:05.000000', 'temperatura', 667.0000, 'ºC'),
	(253656, 120, '2014-03-15 01:20:06.000000', 'temperatura', 47.0000, 'ºC'),
	(253657, 120, '2014-03-15 01:20:07.000000', 'temperatura', 633.0000, 'ºC'),
	(253658, 120, '2014-03-15 01:20:08.000000', 'temperatura', 626.0000, 'ºC'),
	(253659, 120, '2014-03-15 01:20:09.000000', 'temperatura', 33.0000, 'ºC'),
	(253660, 120, '2014-03-15 01:20:10.000000', 'temperatura', 684.0000, 'ºC'),
	(253661, 120, '2014-03-15 01:20:11.000000', 'temperatura', 923.0000, 'ºC'),
	(253662, 120, '2014-03-15 01:20:12.000000', 'temperatura', 162.0000, 'ºC'),
	(253663, 120, '2014-03-15 01:20:13.000000', 'temperatura', 443.0000, 'ºC'),
	(253664, 120, '2014-03-15 01:20:14.000000', 'temperatura', 528.0000, 'ºC'),
	(253665, 120, '2014-03-15 01:20:15.000000', 'temperatura', 112.0000, 'ºC'),
	(253666, 120, '2014-03-15 01:20:16.000000', 'temperatura', 176.0000, 'ºC'),
	(253667, 120, '2014-03-15 01:20:17.000000', 'temperatura', 543.0000, 'ºC'),
	(253668, 120, '2014-03-15 01:20:18.000000', 'temperatura', 989.0000, 'ºC'),
	(253669, 120, '2014-03-15 01:20:19.000000', 'temperatura', 917.0000, 'ºC'),
	(253670, 120, '2014-03-15 01:20:20.000000', 'temperatura', 417.0000, 'ºC'),
	(253671, 120, '2014-03-15 01:20:21.000000', 'temperatura', 533.0000, 'ºC'),
	(253672, 120, '2014-03-15 01:20:22.000000', 'temperatura', 217.0000, 'ºC'),
	(253673, 120, '2014-03-15 01:20:23.000000', 'temperatura', 687.0000, 'ºC'),
	(253674, 120, '2014-03-15 01:20:24.000000', 'temperatura', 383.0000, 'ºC'),
	(253675, 120, '2014-03-15 01:20:25.000000', 'temperatura', 1057.0000, 'ºC'),
	(253676, 120, '2014-03-15 01:20:26.000000', 'temperatura', 535.0000, 'ºC'),
	(253677, 120, '2014-03-15 01:20:27.000000', 'temperatura', 706.0000, 'ºC'),
	(253678, 120, '2014-03-15 01:20:28.000000', 'temperatura', 725.0000, 'ºC'),
	(253679, 120, '2014-03-15 01:20:29.000000', 'temperatura', 309.0000, 'ºC'),
	(253680, 120, '2014-03-15 01:20:30.000000', 'temperatura', 568.0000, 'ºC'),
	(253681, 120, '2014-03-15 01:20:31.000000', 'temperatura', 716.0000, 'ºC'),
	(253682, 120, '2014-03-15 01:20:32.000000', 'temperatura', 675.0000, 'ºC'),
	(253683, 120, '2014-03-15 01:20:33.000000', 'temperatura', 27.0000, 'ºC'),
	(253684, 120, '2014-03-15 01:20:34.000000', 'temperatura', 512.0000, 'ºC'),
	(253685, 120, '2014-03-15 01:20:35.000000', 'temperatura', 78.0000, 'ºC'),
	(253686, 120, '2014-03-15 01:20:36.000000', 'temperatura', 54.0000, 'ºC'),
	(253687, 120, '2014-03-15 01:20:37.000000', 'temperatura', 36.0000, 'ºC'),
	(253688, 120, '2014-03-15 01:20:38.000000', 'temperatura', 18.0000, 'ºC'),
	(253689, 120, '2014-03-15 01:20:39.000000', 'temperatura', 1184.0000, 'ºC'),
	(253690, 120, '2014-03-15 01:20:40.000000', 'temperatura', 1068.0000, 'ºC'),
	(253691, 120, '2014-03-15 01:20:41.000000', 'temperatura', 587.0000, 'ºC'),
	(253692, 120, '2014-03-15 01:20:42.000000', 'temperatura', 933.0000, 'ºC'),
	(253693, 120, '2014-03-15 01:20:43.000000', 'temperatura', 504.0000, 'ºC'),
	(253694, 120, '2014-03-15 01:20:44.000000', 'temperatura', 920.0000, 'ºC'),
	(253695, 120, '2014-03-15 01:20:45.000000', 'temperatura', 690.0000, 'ºC'),
	(253696, 120, '2014-03-15 01:20:46.000000', 'temperatura', 689.0000, 'ºC'),
	(253697, 120, '2014-03-15 01:20:47.000000', 'temperatura', 178.0000, 'ºC'),
	(253698, 120, '2014-03-15 01:20:48.000000', 'temperatura', 21.0000, 'ºC'),
	(253699, 120, '2014-03-15 01:20:49.000000', 'temperatura', 773.0000, 'ºC'),
	(253700, 120, '2014-03-15 01:20:50.000000', 'temperatura', 201.0000, 'ºC'),
	(253701, 120, '2014-03-15 01:20:51.000000', 'temperatura', 1088.0000, 'ºC'),
	(253702, 120, '2014-03-15 01:20:52.000000', 'temperatura', 38.0000, 'ºC'),
	(253703, 120, '2014-03-15 01:20:53.000000', 'temperatura', 528.0000, 'ºC'),
	(253704, 120, '2014-03-15 01:20:54.000000', 'temperatura', 123.0000, 'ºC'),
	(253705, 120, '2014-03-15 01:20:55.000000', 'temperatura', 234.0000, 'ºC'),
	(253706, 120, '2014-03-15 01:20:56.000000', 'temperatura', 799.0000, 'ºC'),
	(253707, 120, '2014-03-15 01:20:57.000000', 'temperatura', 893.0000, 'ºC'),
	(253708, 120, '2014-03-15 01:20:58.000000', 'temperatura', 870.0000, 'ºC'),
	(253709, 120, '2014-03-15 01:20:59.000000', 'temperatura', 470.0000, 'ºC'),
	(253710, 120, '2014-03-15 01:21:00.000000', 'temperatura', 942.0000, 'ºC'),
	(253711, 120, '2014-03-15 01:21:01.000000', 'temperatura', 900.0000, 'ºC'),
	(253712, 120, '2014-03-15 01:21:02.000000', 'temperatura', 475.0000, 'ºC'),
	(253713, 120, '2014-03-15 01:21:03.000000', 'temperatura', 875.0000, 'ºC'),
	(253714, 120, '2014-03-15 01:21:04.000000', 'temperatura', 550.0000, 'ºC'),
	(253715, 120, '2014-03-15 01:21:05.000000', 'temperatura', 127.0000, 'ºC'),
	(253716, 120, '2014-03-15 01:21:06.000000', 'temperatura', 183.0000, 'ºC'),
	(253717, 120, '2014-03-15 01:21:07.000000', 'temperatura', 535.0000, 'ºC'),
	(253718, 120, '2014-03-15 01:21:08.000000', 'temperatura', 928.0000, 'ºC'),
	(253719, 120, '2014-03-15 01:21:09.000000', 'temperatura', 635.0000, 'ºC'),
	(253720, 120, '2014-03-15 01:21:10.000000', 'temperatura', 390.0000, 'ºC'),
	(253721, 120, '2014-03-15 01:21:11.000000', 'temperatura', 47.0000, 'ºC'),
	(253722, 120, '2014-03-15 01:21:12.000000', 'temperatura', 267.0000, 'ºC'),
	(253723, 120, '2014-03-15 01:21:13.000000', 'temperatura', 1192.0000, 'ºC'),
	(253724, 120, '2014-03-15 01:21:14.000000', 'temperatura', 362.0000, 'ºC'),
	(253725, 120, '2014-03-15 01:21:15.000000', 'temperatura', 631.0000, 'ºC'),
	(253726, 120, '2014-03-15 01:21:16.000000', 'temperatura', 873.0000, 'ºC'),
	(253727, 120, '2014-03-15 01:21:17.000000', 'temperatura', 70.0000, 'ºC'),
	(253728, 120, '2014-03-15 01:21:18.000000', 'temperatura', 132.0000, 'ºC'),
	(253729, 120, '2014-03-15 01:21:19.000000', 'temperatura', 449.0000, 'ºC'),
	(253730, 120, '2014-03-15 01:21:20.000000', 'temperatura', 650.0000, 'ºC'),
	(253731, 120, '2014-03-15 01:21:21.000000', 'temperatura', 705.0000, 'ºC'),
	(253732, 120, '2014-03-15 01:21:22.000000', 'temperatura', 374.0000, 'ºC'),
	(253733, 120, '2014-03-15 01:21:23.000000', 'temperatura', 955.0000, 'ºC'),
	(253734, 120, '2014-03-15 01:21:24.000000', 'temperatura', 54.0000, 'ºC'),
	(253735, 120, '2014-03-15 01:21:25.000000', 'temperatura', 1006.0000, 'ºC'),
	(253736, 120, '2014-03-15 01:21:26.000000', 'temperatura', 68.0000, 'ºC'),
	(253737, 120, '2014-03-15 01:21:27.000000', 'temperatura', 924.0000, 'ºC'),
	(253738, 120, '2014-03-15 01:21:28.000000', 'temperatura', 814.0000, 'ºC'),
	(253739, 120, '2014-03-15 01:21:29.000000', 'temperatura', 98.0000, 'ºC'),
	(253740, 120, '2014-03-15 01:21:30.000000', 'temperatura', 448.0000, 'ºC'),
	(253741, 120, '2014-03-15 01:21:31.000000', 'temperatura', 746.0000, 'ºC'),
	(253742, 120, '2014-03-15 01:21:32.000000', 'temperatura', 1187.0000, 'ºC'),
	(253743, 120, '2014-03-15 01:21:33.000000', 'temperatura', 97.0000, 'ºC'),
	(253744, 120, '2014-03-15 01:21:34.000000', 'temperatura', 527.0000, 'ºC'),
	(253745, 120, '2014-03-15 01:21:35.000000', 'temperatura', 1143.0000, 'ºC'),
	(253746, 120, '2014-03-15 01:21:36.000000', 'temperatura', 536.0000, 'ºC'),
	(253747, 120, '2014-03-15 01:21:37.000000', 'temperatura', 451.0000, 'ºC'),
	(253748, 120, '2014-03-15 01:21:38.000000', 'temperatura', 647.0000, 'ºC'),
	(253749, 120, '2014-03-15 01:21:39.000000', 'temperatura', 684.0000, 'ºC'),
	(253750, 120, '2014-03-15 01:21:40.000000', 'temperatura', 277.0000, 'ºC'),
	(253751, 120, '2014-03-15 01:21:41.000000', 'temperatura', 535.0000, 'ºC'),
	(253752, 120, '2014-03-15 01:21:42.000000', 'temperatura', 645.0000, 'ºC'),
	(253753, 120, '2014-03-15 01:21:43.000000', 'temperatura', 419.0000, 'ºC'),
	(253754, 120, '2014-03-15 01:21:44.000000', 'temperatura', 159.0000, 'ºC'),
	(253755, 120, '2014-03-15 01:21:45.000000', 'temperatura', 741.0000, 'ºC'),
	(253756, 120, '2014-03-15 01:21:46.000000', 'temperatura', 829.0000, 'ºC'),
	(253757, 120, '2014-03-15 01:21:47.000000', 'temperatura', 722.0000, 'ºC'),
	(253758, 120, '2014-03-15 01:21:48.000000', 'temperatura', 1124.0000, 'ºC'),
	(253759, 120, '2014-03-15 01:21:49.000000', 'temperatura', 1056.0000, 'ºC'),
	(253760, 120, '2014-03-15 01:21:50.000000', 'temperatura', 705.0000, 'ºC'),
	(253761, 120, '2014-03-15 01:21:51.000000', 'temperatura', 360.0000, 'ºC'),
	(253762, 120, '2014-03-15 01:21:52.000000', 'temperatura', 883.0000, 'ºC'),
	(253763, 120, '2014-03-15 01:21:53.000000', 'temperatura', 935.0000, 'ºC'),
	(253764, 120, '2014-03-15 01:21:54.000000', 'temperatura', 829.0000, 'ºC'),
	(253765, 120, '2014-03-15 01:21:55.000000', 'temperatura', 138.0000, 'ºC'),
	(253766, 120, '2014-03-15 01:21:56.000000', 'temperatura', 603.0000, 'ºC'),
	(253767, 120, '2014-03-15 01:21:57.000000', 'temperatura', 203.0000, 'ºC'),
	(253768, 120, '2014-03-15 01:21:58.000000', 'temperatura', 407.0000, 'ºC'),
	(253769, 120, '2014-03-15 01:21:59.000000', 'temperatura', 227.0000, 'ºC'),
	(253770, 120, '2014-03-15 01:22:00.000000', 'temperatura', 1115.0000, 'ºC'),
	(253771, 120, '2014-03-15 01:22:01.000000', 'temperatura', 92.0000, 'ºC'),
	(253772, 120, '2014-03-15 01:22:02.000000', 'temperatura', 715.0000, 'ºC'),
	(253773, 120, '2014-03-15 01:22:03.000000', 'temperatura', 902.0000, 'ºC'),
	(253774, 120, '2014-03-15 01:22:04.000000', 'temperatura', 1166.0000, 'ºC'),
	(253775, 120, '2014-03-15 01:22:05.000000', 'temperatura', 725.0000, 'ºC'),
	(253776, 120, '2014-03-15 01:22:06.000000', 'temperatura', 128.0000, 'ºC'),
	(253777, 120, '2014-03-15 01:22:07.000000', 'temperatura', 864.0000, 'ºC'),
	(253778, 120, '2014-03-15 01:22:08.000000', 'temperatura', 336.0000, 'ºC'),
	(253779, 120, '2014-03-15 01:22:09.000000', 'temperatura', 289.0000, 'ºC'),
	(253780, 120, '2014-03-15 01:22:10.000000', 'temperatura', 439.0000, 'ºC'),
	(253781, 120, '2014-03-15 01:22:11.000000', 'temperatura', 128.0000, 'ºC'),
	(253782, 120, '2014-03-15 01:22:12.000000', 'temperatura', 523.0000, 'ºC'),
	(253783, 120, '2014-03-15 01:22:13.000000', 'temperatura', 1032.0000, 'ºC'),
	(253784, 120, '2014-03-15 01:22:14.000000', 'temperatura', 1193.0000, 'ºC'),
	(253785, 120, '2014-03-15 01:22:15.000000', 'temperatura', 467.0000, 'ºC'),
	(253786, 120, '2014-03-15 01:22:16.000000', 'temperatura', 1159.0000, 'ºC'),
	(253787, 120, '2014-03-15 01:22:17.000000', 'temperatura', 795.0000, 'ºC'),
	(253788, 120, '2014-03-15 01:22:18.000000', 'temperatura', 499.0000, 'ºC'),
	(253789, 120, '2014-03-15 01:22:19.000000', 'temperatura', 110.0000, 'ºC'),
	(253790, 120, '2014-03-15 01:22:20.000000', 'temperatura', 253.0000, 'ºC'),
	(253791, 120, '2014-03-15 01:22:21.000000', 'temperatura', 936.0000, 'ºC'),
	(253792, 120, '2014-03-15 01:22:22.000000', 'temperatura', 321.0000, 'ºC'),
	(253793, 120, '2014-03-15 01:22:23.000000', 'temperatura', 1197.0000, 'ºC'),
	(253794, 120, '2014-03-15 01:22:24.000000', 'temperatura', 223.0000, 'ºC'),
	(253795, 120, '2014-03-15 01:22:25.000000', 'temperatura', 1125.0000, 'ºC'),
	(253796, 120, '2014-03-15 01:22:26.000000', 'temperatura', 157.0000, 'ºC'),
	(253797, 120, '2014-03-15 01:22:27.000000', 'temperatura', 1009.0000, 'ºC'),
	(253798, 120, '2014-03-15 01:22:28.000000', 'temperatura', 975.0000, 'ºC'),
	(253799, 120, '2014-03-15 01:22:29.000000', 'temperatura', 647.0000, 'ºC'),
	(253800, 120, '2014-03-15 01:22:30.000000', 'temperatura', 312.0000, 'ºC'),
	(253801, 120, '2014-03-15 01:22:31.000000', 'temperatura', 820.0000, 'ºC'),
	(253802, 120, '2014-03-15 01:22:32.000000', 'temperatura', 764.0000, 'ºC'),
	(253803, 120, '2014-03-15 01:22:33.000000', 'temperatura', 159.0000, 'ºC'),
	(253804, 120, '2014-03-15 01:22:34.000000', 'temperatura', 904.0000, 'ºC'),
	(253805, 120, '2014-03-15 01:22:35.000000', 'temperatura', 443.0000, 'ºC'),
	(253806, 120, '2014-03-15 01:22:36.000000', 'temperatura', 704.0000, 'ºC'),
	(253807, 120, '2014-03-15 01:22:37.000000', 'temperatura', 990.0000, 'ºC'),
	(253808, 120, '2014-03-15 01:22:38.000000', 'temperatura', 438.0000, 'ºC'),
	(253809, 120, '2014-03-15 01:22:39.000000', 'temperatura', 421.0000, 'ºC'),
	(253810, 120, '2014-03-15 01:22:40.000000', 'temperatura', 792.0000, 'ºC'),
	(253811, 120, '2014-03-15 01:22:41.000000', 'temperatura', 298.0000, 'ºC'),
	(253812, 120, '2014-03-15 01:22:42.000000', 'temperatura', 312.0000, 'ºC'),
	(253813, 120, '2014-03-15 01:22:43.000000', 'temperatura', 669.0000, 'ºC'),
	(253814, 120, '2014-03-15 01:22:44.000000', 'temperatura', 9.0000, 'ºC'),
	(253815, 120, '2014-03-15 01:22:45.000000', 'temperatura', 439.0000, 'ºC'),
	(253816, 120, '2014-03-15 01:22:46.000000', 'temperatura', 967.0000, 'ºC'),
	(253817, 120, '2014-03-15 01:22:47.000000', 'temperatura', 1117.0000, 'ºC'),
	(253818, 120, '2014-03-15 01:22:48.000000', 'temperatura', 288.0000, 'ºC'),
	(253819, 120, '2014-03-15 01:22:49.000000', 'temperatura', 486.0000, 'ºC'),
	(253820, 120, '2014-03-15 01:22:50.000000', 'temperatura', 369.0000, 'ºC'),
	(253821, 120, '2014-03-15 01:22:51.000000', 'temperatura', 386.0000, 'ºC'),
	(253822, 120, '2014-03-15 01:22:52.000000', 'temperatura', 823.0000, 'ºC'),
	(253823, 120, '2014-03-15 01:22:53.000000', 'temperatura', 559.0000, 'ºC'),
	(253824, 121, '2014-03-15 00:00:00.000000', 'temperatura', 1147.0000, 'ºC'),
	(253825, 121, '2014-03-15 00:00:01.000000', 'temperatura', 1163.0000, 'ºC'),
	(253826, 121, '2014-03-15 00:00:02.000000', 'temperatura', 1174.0000, 'ºC'),
	(253827, 121, '2014-03-15 00:00:03.000000', 'temperatura', 1181.0000, 'ºC'),
	(253828, 121, '2014-03-15 00:00:04.000000', 'temperatura', 1184.0000, 'ºC'),
	(253829, 121, '2014-03-15 00:00:05.000000', 'temperatura', 1176.0000, 'ºC'),
	(253830, 121, '2014-03-15 00:00:06.000000', 'temperatura', 1127.0000, 'ºC'),
	(253831, 121, '2014-03-15 00:00:07.000000', 'temperatura', 911.0000, 'ºC'),
	(253832, 121, '2014-03-15 00:00:08.000000', 'temperatura', 1172.0000, 'ºC'),
	(253833, 121, '2014-03-15 00:00:09.000000', 'temperatura', 730.0000, 'ºC'),
	(253834, 121, '2014-03-15 00:00:10.000000', 'temperatura', 131.0000, 'ºC'),
	(253835, 121, '2014-03-15 00:00:11.000000', 'temperatura', 869.0000, 'ºC'),
	(253836, 121, '2014-03-15 00:00:12.000000', 'temperatura', 350.0000, 'ºC'),
	(253837, 121, '2014-03-15 00:00:13.000000', 'temperatura', 345.0000, 'ºC'),
	(253838, 121, '2014-03-15 00:00:14.000000', 'temperatura', 676.0000, 'ºC'),
	(253839, 121, '2014-03-15 00:00:15.000000', 'temperatura', 1145.0000, 'ºC'),
	(253840, 121, '2014-03-15 00:00:16.000000', 'temperatura', 97.0000, 'ºC'),
	(253841, 121, '2014-03-15 00:00:17.000000', 'temperatura', 653.0000, 'ºC'),
	(253842, 121, '2014-03-15 00:00:18.000000', 'temperatura', 572.0000, 'ºC'),
	(253843, 121, '2014-03-15 00:00:19.000000', 'temperatura', 903.0000, 'ºC'),
	(253844, 121, '2014-03-15 00:00:20.000000', 'temperatura', 400.0000, 'ºC'),
	(253845, 121, '2014-03-15 00:00:21.000000', 'temperatura', 490.0000, 'ºC'),
	(253846, 121, '2014-03-15 00:00:22.000000', 'temperatura', 53.0000, 'ºC'),
	(253847, 121, '2014-03-15 00:00:23.000000', 'temperatura', 1195.0000, 'ºC'),
	(253848, 121, '2014-03-15 00:00:24.000000', 'temperatura', 1014.0000, 'ºC'),
	(253849, 121, '2014-03-15 00:00:25.000000', 'temperatura', 288.0000, 'ºC'),
	(253850, 121, '2014-03-15 00:00:26.000000', 'temperatura', 798.0000, 'ºC'),
	(253851, 121, '2014-03-15 00:00:27.000000', 'temperatura', 728.0000, 'ºC'),
	(253852, 121, '2014-03-15 00:00:28.000000', 'temperatura', 44.0000, 'ºC'),
	(253853, 121, '2014-03-15 00:00:29.000000', 'temperatura', 436.0000, 'ºC'),
	(253854, 121, '2014-03-15 00:00:30.000000', 'temperatura', 848.0000, 'ºC'),
	(253855, 121, '2014-03-15 00:00:31.000000', 'temperatura', 534.0000, 'ºC'),
	(253856, 121, '2014-03-15 00:00:32.000000', 'temperatura', 127.0000, 'ºC'),
	(253857, 121, '2014-03-15 00:00:33.000000', 'temperatura', 235.0000, 'ºC'),
	(253858, 121, '2014-03-15 00:00:34.000000', 'temperatura', 792.0000, 'ºC'),
	(253859, 121, '2014-03-15 00:00:35.000000', 'temperatura', 857.0000, 'ºC'),
	(253860, 121, '2014-03-15 00:00:36.000000', 'temperatura', 709.0000, 'ºC'),
	(253861, 121, '2014-03-15 00:00:37.000000', 'temperatura', 974.0000, 'ºC'),
	(253862, 121, '2014-03-15 00:00:38.000000', 'temperatura', 342.0000, 'ºC'),
	(253863, 121, '2014-03-15 00:00:39.000000', 'temperatura', 1190.0000, 'ºC'),
	(253864, 121, '2014-03-15 00:00:40.000000', 'temperatura', 123.0000, 'ºC'),
	(253865, 121, '2014-03-15 00:00:41.000000', 'temperatura', 645.0000, 'ºC'),
	(253866, 121, '2014-03-15 00:00:42.000000', 'temperatura', 459.0000, 'ºC'),
	(253867, 121, '2014-03-15 00:00:43.000000', 'temperatura', 359.0000, 'ºC'),
	(253868, 121, '2014-03-15 00:00:44.000000', 'temperatura', 419.0000, 'ºC'),
	(253869, 121, '2014-03-15 00:00:45.000000', 'temperatura', 1016.0000, 'ºC'),
	(253870, 121, '2014-03-15 00:00:46.000000', 'temperatura', 227.0000, 'ºC'),
	(253871, 121, '2014-03-15 00:00:47.000000', 'temperatura', 486.0000, 'ºC'),
	(253872, 121, '2014-03-15 00:00:48.000000', 'temperatura', 551.0000, 'ºC'),
	(253873, 121, '2014-03-15 00:00:49.000000', 'temperatura', 95.0000, 'ºC'),
	(253874, 121, '2014-03-15 00:00:50.000000', 'temperatura', 24.0000, 'ºC'),
	(253875, 121, '2014-03-15 00:00:51.000000', 'temperatura', 1033.0000, 'ºC'),
	(253876, 121, '2014-03-15 00:00:52.000000', 'temperatura', 296.0000, 'ºC'),
	(253877, 121, '2014-03-15 00:00:53.000000', 'temperatura', 781.0000, 'ºC'),
	(253878, 121, '2014-03-15 00:00:54.000000', 'temperatura', 619.0000, 'ºC'),
	(253879, 121, '2014-03-15 00:00:55.000000', 'temperatura', 750.0000, 'ºC'),
	(253880, 121, '2014-03-15 00:00:56.000000', 'temperatura', 696.0000, 'ºC'),
	(253881, 121, '2014-03-15 00:00:57.000000', 'temperatura', 30.0000, 'ºC'),
	(253882, 121, '2014-03-15 00:00:58.000000', 'temperatura', 464.0000, 'ºC'),
	(253883, 121, '2014-03-15 00:00:59.000000', 'temperatura', 1030.0000, 'ºC'),
	(253884, 121, '2014-03-15 00:01:00.000000', 'temperatura', 158.0000, 'ºC'),
	(253885, 121, '2014-03-15 00:01:01.000000', 'temperatura', 98.0000, 'ºC'),
	(253886, 121, '2014-03-15 00:01:02.000000', 'temperatura', 20.0000, 'ºC'),
	(253887, 121, '2014-03-15 00:01:03.000000', 'temperatura', 1005.0000, 'ºC'),
	(253888, 121, '2014-03-15 00:01:04.000000', 'temperatura', 168.0000, 'ºC'),
	(253889, 121, '2014-03-15 00:01:05.000000', 'temperatura', 223.0000, 'ºC'),
	(253890, 121, '2014-03-15 00:01:06.000000', 'temperatura', 611.0000, 'ºC'),
	(253891, 121, '2014-03-15 00:01:07.000000', 'temperatura', 1187.0000, 'ºC'),
	(253892, 121, '2014-03-15 00:01:08.000000', 'temperatura', 503.0000, 'ºC'),
	(253893, 121, '2014-03-15 00:01:09.000000', 'temperatura', 155.0000, 'ºC'),
	(253894, 121, '2014-03-15 00:01:10.000000', 'temperatura', 465.0000, 'ºC'),
	(253895, 121, '2014-03-15 00:01:11.000000', 'temperatura', 660.0000, 'ºC'),
	(253896, 121, '2014-03-15 00:01:12.000000', 'temperatura', 705.0000, 'ºC'),
	(253897, 121, '2014-03-15 00:01:13.000000', 'temperatura', 345.0000, 'ºC'),
	(253898, 121, '2014-03-15 00:01:14.000000', 'temperatura', 810.0000, 'ºC'),
	(253899, 121, '2014-03-15 00:01:15.000000', 'temperatura', 615.0000, 'ºC'),
	(253900, 121, '2014-03-15 00:01:16.000000', 'temperatura', 645.0000, 'ºC'),
	(253901, 121, '2014-03-15 00:01:17.000000', 'temperatura', 184.0000, 'ºC'),
	(253902, 121, '2014-03-15 00:01:18.000000', 'temperatura', 182.0000, 'ºC'),
	(253903, 121, '2014-03-15 00:01:19.000000', 'temperatura', 361.0000, 'ºC'),
	(253904, 121, '2014-03-15 00:01:20.000000', 'temperatura', 61.0000, 'ºC'),
	(253905, 121, '2014-03-15 00:01:21.000000', 'temperatura', 420.0000, 'ºC'),
	(253906, 121, '2014-03-15 00:01:22.000000', 'temperatura', 718.0000, 'ºC'),
	(253907, 121, '2014-03-15 00:01:23.000000', 'temperatura', 1129.0000, 'ºC'),
	(253908, 121, '2014-03-15 00:01:24.000000', 'temperatura', 1091.0000, 'ºC'),
	(253909, 121, '2014-03-15 00:01:25.000000', 'temperatura', 868.0000, 'ºC'),
	(253910, 121, '2014-03-15 00:01:26.000000', 'temperatura', 1068.0000, 'ºC'),
	(253911, 121, '2014-03-15 00:01:27.000000', 'temperatura', 338.0000, 'ºC'),
	(253912, 121, '2014-03-15 00:01:28.000000', 'temperatura', 885.0000, 'ºC'),
	(253913, 121, '2014-03-15 00:01:29.000000', 'temperatura', 1011.0000, 'ºC'),
	(253914, 121, '2014-03-15 00:01:30.000000', 'temperatura', 1.0000, 'ºC'),
	(253915, 121, '2014-03-15 00:01:31.000000', 'temperatura', 574.0000, 'ºC'),
	(253916, 121, '2014-03-15 00:01:32.000000', 'temperatura', 466.0000, 'ºC'),
	(253917, 121, '2014-03-15 00:01:33.000000', 'temperatura', 608.0000, 'ºC'),
	(253918, 121, '2014-03-15 00:01:34.000000', 'temperatura', 445.0000, 'ºC'),
	(253919, 121, '2014-03-15 00:01:35.000000', 'temperatura', 400.0000, 'ºC'),
	(253920, 121, '2014-03-15 00:01:36.000000', 'temperatura', 665.0000, 'ºC'),
	(253921, 121, '2014-03-15 00:01:37.000000', 'temperatura', 925.0000, 'ºC'),
	(253922, 121, '2014-03-15 00:01:38.000000', 'temperatura', 230.0000, 'ºC'),
	(253923, 121, '2014-03-15 00:01:39.000000', 'temperatura', 778.0000, 'ºC'),
	(253924, 121, '2014-03-15 00:01:40.000000', 'temperatura', 800.0000, 'ºC'),
	(253925, 121, '2014-03-15 00:01:41.000000', 'temperatura', 465.0000, 'ºC'),
	(253926, 121, '2014-03-15 00:01:42.000000', 'temperatura', 1125.0000, 'ºC'),
	(253927, 121, '2014-03-15 00:01:43.000000', 'temperatura', 632.0000, 'ºC'),
	(253928, 121, '2014-03-15 00:01:44.000000', 'temperatura', 986.0000, 'ºC'),
	(253929, 121, '2014-03-15 00:01:45.000000', 'temperatura', 636.0000, 'ºC'),
	(253930, 121, '2014-03-15 00:01:46.000000', 'temperatura', 219.0000, 'ºC'),
	(253931, 121, '2014-03-15 00:01:47.000000', 'temperatura', 389.0000, 'ºC'),
	(253932, 121, '2014-03-15 00:01:48.000000', 'temperatura', 88.0000, 'ºC'),
	(253933, 121, '2014-03-15 00:01:49.000000', 'temperatura', 473.0000, 'ºC'),
	(253934, 121, '2014-03-15 00:01:50.000000', 'temperatura', 903.0000, 'ºC'),
	(253935, 121, '2014-03-15 00:01:51.000000', 'temperatura', 698.0000, 'ºC'),
	(253936, 121, '2014-03-15 00:01:52.000000', 'temperatura', 779.0000, 'ºC'),
	(253937, 121, '2014-03-15 00:01:53.000000', 'temperatura', 602.0000, 'ºC'),
	(253938, 121, '2014-03-15 00:01:54.000000', 'temperatura', 675.0000, 'ºC'),
	(253939, 121, '2014-03-15 00:01:55.000000', 'temperatura', 368.0000, 'ºC'),
	(253940, 121, '2014-03-15 00:01:56.000000', 'temperatura', 1015.0000, 'ºC'),
	(253941, 121, '2014-03-15 00:01:57.000000', 'temperatura', 372.0000, 'ºC'),
	(253942, 121, '2014-03-15 00:01:58.000000', 'temperatura', 17.0000, 'ºC'),
	(253943, 121, '2014-03-15 00:01:59.000000', 'temperatura', 170.0000, 'ºC'),
	(253944, 121, '2014-03-15 00:02:00.000000', 'temperatura', 798.0000, 'ºC'),
	(253945, 121, '2014-03-15 00:02:01.000000', 'temperatura', 1082.0000, 'ºC'),
	(253946, 121, '2014-03-15 00:02:02.000000', 'temperatura', 614.0000, 'ºC'),
	(253947, 121, '2014-03-15 00:02:03.000000', 'temperatura', 1027.0000, 'ºC'),
	(253948, 121, '2014-03-15 00:02:04.000000', 'temperatura', 892.0000, 'ºC'),
	(253949, 121, '2014-03-15 00:02:05.000000', 'temperatura', 178.0000, 'ºC'),
	(253950, 121, '2014-03-15 00:02:06.000000', 'temperatura', 617.0000, 'ºC'),
	(253951, 121, '2014-03-15 00:02:07.000000', 'temperatura', 153.0000, 'ºC'),
	(253952, 121, '2014-03-15 00:02:08.000000', 'temperatura', 112.0000, 'ºC'),
	(253953, 121, '2014-03-15 00:02:09.000000', 'temperatura', 101.0000, 'ºC'),
	(253954, 121, '2014-03-15 00:02:10.000000', 'temperatura', 168.0000, 'ºC'),
	(253955, 121, '2014-03-15 00:02:11.000000', 'temperatura', 541.0000, 'ºC'),
	(253956, 121, '2014-03-15 00:02:12.000000', 'temperatura', 999.0000, 'ºC'),
	(253957, 121, '2014-03-15 00:02:13.000000', 'temperatura', 973.0000, 'ºC'),
	(253958, 121, '2014-03-15 00:02:14.000000', 'temperatura', 667.0000, 'ºC'),
	(253959, 121, '2014-03-15 00:02:15.000000', 'temperatura', 417.0000, 'ºC'),
	(253960, 121, '2014-03-15 00:02:16.000000', 'temperatura', 86.0000, 'ºC'),
	(253961, 121, '2014-03-15 00:02:17.000000', 'temperatura', 381.0000, 'ºC'),
	(253962, 121, '2014-03-15 00:02:18.000000', 'temperatura', 444.0000, 'ºC'),
	(253963, 121, '2014-03-15 00:02:19.000000', 'temperatura', 1079.0000, 'ºC'),
	(253964, 121, '2014-03-15 00:02:20.000000', 'temperatura', 464.0000, 'ºC'),
	(253965, 121, '2014-03-15 00:02:21.000000', 'temperatura', 283.0000, 'ºC'),
	(253966, 121, '2014-03-15 00:02:22.000000', 'temperatura', 24.0000, 'ºC'),
	(253967, 121, '2014-03-15 00:02:23.000000', 'temperatura', 470.0000, 'ºC'),
	(253968, 121, '2014-03-15 00:02:24.000000', 'temperatura', 1081.0000, 'ºC'),
	(253969, 121, '2014-03-15 00:02:25.000000', 'temperatura', 394.0000, 'ºC'),
	(253970, 121, '2014-03-15 00:02:26.000000', 'temperatura', 1130.0000, 'ºC'),
	(253971, 121, '2014-03-15 00:02:27.000000', 'temperatura', 865.0000, 'ºC'),
	(253972, 121, '2014-03-15 00:02:28.000000', 'temperatura', 938.0000, 'ºC'),
	(253973, 121, '2014-03-15 00:02:29.000000', 'temperatura', 897.0000, 'ºC'),
	(253974, 121, '2014-03-15 00:02:30.000000', 'temperatura', 468.0000, 'ºC'),
	(253975, 121, '2014-03-15 00:02:31.000000', 'temperatura', 851.0000, 'ºC'),
	(253976, 121, '2014-03-15 00:02:32.000000', 'temperatura', 454.0000, 'ºC'),
	(253977, 121, '2014-03-15 00:02:33.000000', 'temperatura', 914.0000, 'ºC'),
	(253978, 121, '2014-03-15 00:02:34.000000', 'temperatura', 808.0000, 'ºC'),
	(253979, 121, '2014-03-15 00:02:35.000000', 'temperatura', 99.0000, 'ºC'),
	(253980, 121, '2014-03-15 00:02:36.000000', 'temperatura', 471.0000, 'ºC'),
	(253981, 121, '2014-03-15 00:02:37.000000', 'temperatura', 859.0000, 'ºC'),
	(253982, 121, '2014-03-15 00:02:38.000000', 'temperatura', 481.0000, 'ºC'),
	(253983, 121, '2014-03-15 00:02:39.000000', 'temperatura', 1028.0000, 'ºC'),
	(253984, 121, '2014-03-15 00:02:40.000000', 'temperatura', 98.0000, 'ºC'),
	(253985, 121, '2014-03-15 00:02:41.000000', 'temperatura', 1007.0000, 'ºC'),
	(253986, 121, '2014-03-15 00:02:42.000000', 'temperatura', 1140.0000, 'ºC'),
	(253987, 121, '2014-03-15 00:02:43.000000', 'temperatura', 279.0000, 'ºC'),
	(253988, 121, '2014-03-15 00:02:44.000000', 'temperatura', 375.0000, 'ºC'),
	(253989, 121, '2014-03-15 00:02:45.000000', 'temperatura', 1040.0000, 'ºC'),
	(253990, 121, '2014-03-15 00:02:46.000000', 'temperatura', 476.0000, 'ºC'),
	(253991, 121, '2014-03-15 00:02:47.000000', 'temperatura', 460.0000, 'ºC'),
	(253992, 121, '2014-03-15 00:02:48.000000', 'temperatura', 871.0000, 'ºC'),
	(253993, 121, '2014-03-15 00:02:49.000000', 'temperatura', 578.0000, 'ºC'),
	(253994, 121, '2014-03-15 00:02:50.000000', 'temperatura', 278.0000, 'ºC'),
	(253995, 121, '2014-03-15 00:02:51.000000', 'temperatura', 855.0000, 'ºC'),
	(253996, 121, '2014-03-15 00:02:52.000000', 'temperatura', 1043.0000, 'ºC'),
	(253997, 121, '2014-03-15 00:02:53.000000', 'temperatura', 251.0000, 'ºC'),
	(253998, 121, '2014-03-15 00:02:54.000000', 'temperatura', 526.0000, 'ºC'),
	(253999, 121, '2014-03-15 00:02:55.000000', 'temperatura', 679.0000, 'ºC'),
	(254000, 121, '2014-03-15 00:02:56.000000', 'temperatura', 615.0000, 'ºC'),
	(254001, 121, '2014-03-15 00:02:57.000000', 'temperatura', 1038.0000, 'ºC'),
	(254002, 121, '2014-03-15 00:02:58.000000', 'temperatura', 947.0000, 'ºC'),
	(254003, 121, '2014-03-15 00:02:59.000000', 'temperatura', 421.0000, 'ºC'),
	(254004, 121, '2014-03-15 00:03:00.000000', 'temperatura', 464.0000, 'ºC'),
	(254005, 121, '2014-03-15 00:03:01.000000', 'temperatura', 1056.0000, 'ºC'),
	(254006, 121, '2014-03-15 00:03:02.000000', 'temperatura', 291.0000, 'ºC'),
	(254007, 121, '2014-03-15 00:03:03.000000', 'temperatura', 687.0000, 'ºC'),
	(254008, 121, '2014-03-15 00:03:04.000000', 'temperatura', 163.0000, 'ºC'),
	(254009, 121, '2014-03-15 00:03:05.000000', 'temperatura', 1155.0000, 'ºC'),
	(254010, 121, '2014-03-15 00:03:06.000000', 'temperatura', 486.0000, 'ºC'),
	(254011, 121, '2014-03-15 00:03:07.000000', 'temperatura', 164.0000, 'ºC'),
	(254012, 121, '2014-03-15 00:03:08.000000', 'temperatura', 562.0000, 'ºC'),
	(254013, 121, '2014-03-15 00:03:09.000000', 'temperatura', 1121.0000, 'ºC'),
	(254014, 121, '2014-03-15 00:03:10.000000', 'temperatura', 319.0000, 'ºC'),
	(254015, 121, '2014-03-15 00:03:11.000000', 'temperatura', 632.0000, 'ºC'),
	(254016, 121, '2014-03-15 00:03:12.000000', 'temperatura', 1004.0000, 'ºC'),
	(254017, 121, '2014-03-15 00:03:13.000000', 'temperatura', 725.0000, 'ºC'),
	(254018, 121, '2014-03-15 00:03:14.000000', 'temperatura', 613.0000, 'ºC'),
	(254019, 121, '2014-03-15 00:03:15.000000', 'temperatura', 891.0000, 'ºC'),
	(254020, 121, '2014-03-15 00:03:16.000000', 'temperatura', 218.0000, 'ºC'),
	(254021, 121, '2014-03-15 00:03:17.000000', 'temperatura', 815.0000, 'ºC'),
	(254022, 121, '2014-03-15 00:03:18.000000', 'temperatura', 1022.0000, 'ºC'),
	(254023, 121, '2014-03-15 00:03:19.000000', 'temperatura', 264.0000, 'ºC'),
	(254024, 121, '2014-03-15 00:03:20.000000', 'temperatura', 657.0000, 'ºC'),
	(254025, 121, '2014-03-15 00:03:21.000000', 'temperatura', 91.0000, 'ºC'),
	(254026, 121, '2014-03-15 00:03:22.000000', 'temperatura', 887.0000, 'ºC'),
	(254027, 121, '2014-03-15 00:03:23.000000', 'temperatura', 563.0000, 'ºC'),
	(254028, 121, '2014-03-15 00:03:24.000000', 'temperatura', 152.0000, 'ºC'),
	(254029, 121, '2014-03-15 00:03:25.000000', 'temperatura', 274.0000, 'ºC'),
	(254030, 121, '2014-03-15 00:03:26.000000', 'temperatura', 914.0000, 'ºC'),
	(254031, 121, '2014-03-15 00:03:27.000000', 'temperatura', 149.0000, 'ºC'),
	(254032, 121, '2014-03-15 00:03:28.000000', 'temperatura', 404.0000, 'ºC'),
	(254033, 121, '2014-03-15 00:03:29.000000', 'temperatura', 374.0000, 'ºC'),
	(254034, 121, '2014-03-15 00:03:30.000000', 'temperatura', 659.0000, 'ºC'),
	(254035, 121, '2014-03-15 00:03:31.000000', 'temperatura', 973.0000, 'ºC'),
	(254036, 121, '2014-03-15 00:03:32.000000', 'temperatura', 488.0000, 'ºC'),
	(254037, 121, '2014-03-15 00:03:33.000000', 'temperatura', 723.0000, 'ºC'),
	(254038, 121, '2014-03-15 00:03:34.000000', 'temperatura', 951.0000, 'ºC'),
	(254039, 121, '2014-03-15 00:03:35.000000', 'temperatura', 184.0000, 'ºC'),
	(254040, 121, '2014-03-15 00:03:36.000000', 'temperatura', 470.0000, 'ºC'),
	(254041, 121, '2014-03-15 00:03:37.000000', 'temperatura', 599.0000, 'ºC'),
	(254042, 121, '2014-03-15 00:03:38.000000', 'temperatura', 385.0000, 'ºC'),
	(254043, 121, '2014-03-15 00:03:39.000000', 'temperatura', 126.0000, 'ºC'),
	(254044, 121, '2014-03-15 00:03:40.000000', 'temperatura', 678.0000, 'ºC'),
	(254045, 121, '2014-03-15 00:03:41.000000', 'temperatura', 614.0000, 'ºC'),
	(254046, 121, '2014-03-15 00:03:42.000000', 'temperatura', 1034.0000, 'ºC'),
	(254047, 121, '2014-03-15 00:03:43.000000', 'temperatura', 927.0000, 'ºC'),
	(254048, 121, '2014-03-15 00:03:44.000000', 'temperatura', 337.0000, 'ºC'),
	(254049, 121, '2014-03-15 00:03:45.000000', 'temperatura', 102.0000, 'ºC'),
	(254050, 121, '2014-03-15 00:03:46.000000', 'temperatura', 699.0000, 'ºC'),
	(254051, 121, '2014-03-15 00:03:47.000000', 'temperatura', 791.0000, 'ºC'),
	(254052, 121, '2014-03-15 00:03:48.000000', 'temperatura', 658.0000, 'ºC'),
	(254053, 121, '2014-03-15 00:03:49.000000', 'temperatura', 919.0000, 'ºC'),
	(254054, 121, '2014-03-15 00:03:50.000000', 'temperatura', 222.0000, 'ºC'),
	(254055, 121, '2014-03-15 00:03:51.000000', 'temperatura', 752.0000, 'ºC'),
	(254056, 121, '2014-03-15 00:03:52.000000', 'temperatura', 695.0000, 'ºC'),
	(254057, 121, '2014-03-15 00:03:53.000000', 'temperatura', 18.0000, 'ºC'),
	(254058, 121, '2014-03-15 00:03:54.000000', 'temperatura', 406.0000, 'ºC'),
	(254059, 121, '2014-03-15 00:03:55.000000', 'temperatura', 777.0000, 'ºC'),
	(254060, 121, '2014-03-15 00:03:56.000000', 'temperatura', 268.0000, 'ºC'),
	(254061, 121, '2014-03-15 00:03:57.000000', 'temperatura', 209.0000, 'ºC'),
	(254062, 121, '2014-03-15 00:03:58.000000', 'temperatura', 243.0000, 'ºC'),
	(254063, 121, '2014-03-15 00:03:59.000000', 'temperatura', 589.0000, 'ºC'),
	(254064, 121, '2014-03-15 00:04:00.000000', 'temperatura', 1016.0000, 'ºC'),
	(254065, 121, '2014-03-15 00:04:01.000000', 'temperatura', 913.0000, 'ºC'),
	(254066, 121, '2014-03-15 00:04:02.000000', 'temperatura', 319.0000, 'ºC'),
	(254067, 121, '2014-03-15 00:04:03.000000', 'temperatura', 57.0000, 'ºC'),
	(254068, 121, '2014-03-15 00:04:04.000000', 'temperatura', 529.0000, 'ºC'),
	(254069, 121, '2014-03-15 00:04:05.000000', 'temperatura', 72.0000, 'ºC'),
	(254070, 121, '2014-03-15 00:04:06.000000', 'temperatura', 1175.0000, 'ºC'),
	(254071, 121, '2014-03-15 00:04:07.000000', 'temperatura', 860.0000, 'ºC'),
	(254072, 121, '2014-03-15 00:04:08.000000', 'temperatura', 776.0000, 'ºC'),
	(254073, 121, '2014-03-15 00:04:09.000000', 'temperatura', 99.0000, 'ºC'),
	(254074, 121, '2014-03-15 00:04:10.000000', 'temperatura', 570.0000, 'ºC'),
	(254075, 121, '2014-03-15 00:04:11.000000', 'temperatura', 152.0000, 'ºC'),
	(254076, 121, '2014-03-15 00:04:12.000000', 'temperatura', 249.0000, 'ºC'),
	(254077, 121, '2014-03-15 00:04:13.000000', 'temperatura', 792.0000, 'ºC'),
	(254078, 121, '2014-03-15 00:04:14.000000', 'temperatura', 814.0000, 'ºC'),
	(254079, 121, '2014-03-15 00:04:15.000000', 'temperatura', 494.0000, 'ºC'),
	(254080, 121, '2014-03-15 00:04:16.000000', 'temperatura', 27.0000, 'ºC'),
	(254081, 121, '2014-03-15 00:04:17.000000', 'temperatura', 1054.0000, 'ºC'),
	(254082, 121, '2014-03-15 00:04:18.000000', 'temperatura', 389.0000, 'ºC'),
	(254083, 121, '2014-03-15 00:04:19.000000', 'temperatura', 1185.0000, 'ºC'),
	(254084, 121, '2014-03-15 00:04:20.000000', 'temperatura', 1158.0000, 'ºC'),
	(254085, 121, '2014-03-15 00:04:21.000000', 'temperatura', 1037.0000, 'ºC'),
	(254086, 121, '2014-03-15 00:04:22.000000', 'temperatura', 512.0000, 'ºC'),
	(254087, 121, '2014-03-15 00:04:23.000000', 'temperatura', 649.0000, 'ºC'),
	(254088, 121, '2014-03-15 00:04:24.000000', 'temperatura', 508.0000, 'ºC'),
	(254089, 121, '2014-03-15 00:04:25.000000', 'temperatura', 594.0000, 'ºC'),
	(254090, 121, '2014-03-15 00:04:26.000000', 'temperatura', 245.0000, 'ºC'),
	(254091, 121, '2014-03-15 00:04:27.000000', 'temperatura', 646.0000, 'ºC'),
	(254092, 121, '2014-03-15 00:04:28.000000', 'temperatura', 95.0000, 'ºC'),
	(254093, 121, '2014-03-15 00:04:29.000000', 'temperatura', 936.0000, 'ºC'),
	(254094, 121, '2014-03-15 00:04:30.000000', 'temperatura', 797.0000, 'ºC'),
	(254095, 121, '2014-03-15 00:04:31.000000', 'temperatura', 1178.0000, 'ºC'),
	(254096, 121, '2014-03-15 00:04:32.000000', 'temperatura', 1098.0000, 'ºC'),
	(254097, 121, '2014-03-15 00:04:33.000000', 'temperatura', 756.0000, 'ºC'),
	(254098, 121, '2014-03-15 00:04:34.000000', 'temperatura', 488.0000, 'ºC'),
	(254099, 121, '2014-03-15 00:04:35.000000', 'temperatura', 174.0000, 'ºC'),
	(254100, 121, '2014-03-15 00:04:36.000000', 'temperatura', 605.0000, 'ºC'),
	(254101, 121, '2014-03-15 00:04:37.000000', 'temperatura', 105.0000, 'ºC'),
	(254102, 121, '2014-03-15 00:04:38.000000', 'temperatura', 1110.0000, 'ºC'),
	(254103, 121, '2014-03-15 00:04:39.000000', 'temperatura', 436.0000, 'ºC'),
	(254104, 121, '2014-03-15 00:04:40.000000', 'temperatura', 48.0000, 'ºC'),
	(254105, 121, '2014-03-15 00:04:41.000000', 'temperatura', 134.0000, 'ºC'),
	(254106, 121, '2014-03-15 00:04:42.000000', 'temperatura', 527.0000, 'ºC'),
	(254107, 121, '2014-03-15 00:04:43.000000', 'temperatura', 1035.0000, 'ºC'),
	(254108, 121, '2014-03-15 00:04:44.000000', 'temperatura', 1194.0000, 'ºC'),
	(254109, 121, '2014-03-15 00:04:45.000000', 'temperatura', 463.0000, 'ºC'),
	(254110, 121, '2014-03-15 00:04:46.000000', 'temperatura', 1134.0000, 'ºC'),
	(254111, 121, '2014-03-15 00:04:47.000000', 'temperatura', 682.0000, 'ºC'),
	(254112, 121, '2014-03-15 00:04:48.000000', 'temperatura', 9.0000, 'ºC'),
	(254113, 121, '2014-03-15 00:04:49.000000', 'temperatura', 398.0000, 'ºC'),
	(254114, 121, '2014-03-15 00:04:50.000000', 'temperatura', 766.0000, 'ºC'),
	(254115, 121, '2014-03-15 00:04:51.000000', 'temperatura', 236.0000, 'ºC'),
	(254116, 121, '2014-03-15 00:04:52.000000', 'temperatura', 81.0000, 'ºC'),
	(254117, 121, '2014-03-15 00:04:53.000000', 'temperatura', 897.0000, 'ºC'),
	(254118, 121, '2014-03-15 00:04:54.000000', 'temperatura', 642.0000, 'ºC'),
	(254119, 121, '2014-03-15 00:04:55.000000', 'temperatura', 521.0000, 'ºC'),
	(254120, 121, '2014-03-15 00:04:56.000000', 'temperatura', 679.0000, 'ºC'),
	(254121, 121, '2014-03-15 00:04:57.000000', 'temperatura', 634.0000, 'ºC'),
	(254122, 121, '2014-03-15 00:04:58.000000', 'temperatura', 1132.0000, 'ºC'),
	(254123, 121, '2014-03-15 00:04:59.000000', 'temperatura', 159.0000, 'ºC'),
	(254124, 121, '2014-03-15 00:05:00.000000', 'temperatura', 1001.0000, 'ºC'),
	(254125, 121, '2014-03-15 00:05:01.000000', 'temperatura', 926.0000, 'ºC'),
	(254126, 121, '2014-03-15 00:05:02.000000', 'temperatura', 428.0000, 'ºC'),
	(254127, 121, '2014-03-15 00:05:03.000000', 'temperatura', 561.0000, 'ºC'),
	(254128, 121, '2014-03-15 00:05:04.000000', 'temperatura', 324.0000, 'ºC'),
	(254129, 121, '2014-03-15 00:05:05.000000', 'temperatura', 1139.0000, 'ºC'),
	(254130, 121, '2014-03-15 00:05:06.000000', 'temperatura', 1120.0000, 'ºC'),
	(254131, 121, '2014-03-15 00:05:07.000000', 'temperatura', 985.0000, 'ºC'),
	(254132, 121, '2014-03-15 00:05:08.000000', 'temperatura', 367.0000, 'ºC'),
	(254133, 121, '2014-03-15 00:05:09.000000', 'temperatura', 80.0000, 'ºC'),
	(254134, 121, '2014-03-15 00:05:10.000000', 'temperatura', 498.0000, 'ºC'),
	(254135, 121, '2014-03-15 00:05:11.000000', 'temperatura', 1052.0000, 'ºC'),
	(254136, 121, '2014-03-15 00:05:12.000000', 'temperatura', 168.0000, 'ºC'),
	(254137, 121, '2014-03-15 00:05:13.000000', 'temperatura', 82.0000, 'ºC'),
	(254138, 121, '2014-03-15 00:05:14.000000', 'temperatura', 1106.0000, 'ºC'),
	(254139, 121, '2014-03-15 00:05:15.000000', 'temperatura', 485.0000, 'ºC'),
	(254140, 121, '2014-03-15 00:05:16.000000', 'temperatura', 309.0000, 'ºC'),
	(254141, 121, '2014-03-15 00:05:17.000000', 'temperatura', 88.0000, 'ºC'),
	(254142, 121, '2014-03-15 00:05:18.000000', 'temperatura', 714.0000, 'ºC'),
	(254143, 121, '2014-03-15 00:05:19.000000', 'temperatura', 908.0000, 'ºC'),
	(254144, 121, '2014-03-15 00:05:20.000000', 'temperatura', 1197.0000, 'ºC'),
	(254145, 121, '2014-03-15 00:05:21.000000', 'temperatura', 864.0000, 'ºC'),
	(254146, 121, '2014-03-15 00:05:22.000000', 'temperatura', 727.0000, 'ºC'),
	(254147, 121, '2014-03-15 00:05:23.000000', 'temperatura', 1043.0000, 'ºC'),
	(254148, 121, '2014-03-15 00:05:24.000000', 'temperatura', 633.0000, 'ºC'),
	(254149, 121, '2014-03-15 00:05:25.000000', 'temperatura', 40.0000, 'ºC'),
	(254150, 121, '2014-03-15 00:05:26.000000', 'temperatura', 701.0000, 'ºC'),
	(254151, 121, '2014-03-15 00:05:27.000000', 'temperatura', 984.0000, 'ºC'),
	(254152, 121, '2014-03-15 00:05:28.000000', 'temperatura', 417.0000, 'ºC'),
	(254153, 121, '2014-03-15 00:05:29.000000', 'temperatura', 332.0000, 'ºC'),
	(254154, 121, '2014-03-15 00:05:30.000000', 'temperatura', 413.0000, 'ºC'),
	(254155, 121, '2014-03-15 00:05:31.000000', 'temperatura', 1069.0000, 'ºC'),
	(254156, 121, '2014-03-15 00:05:32.000000', 'temperatura', 507.0000, 'ºC'),
	(254157, 121, '2014-03-15 00:05:33.000000', 'temperatura', 529.0000, 'ºC'),
	(254158, 121, '2014-03-15 00:05:34.000000', 'temperatura', 1123.0000, 'ºC'),
	(254159, 121, '2014-03-15 00:05:35.000000', 'temperatura', 431.0000, 'ºC'),
	(254160, 121, '2014-03-15 00:05:36.000000', 'temperatura', 1185.0000, 'ºC'),
	(254161, 121, '2014-03-15 00:05:37.000000', 'temperatura', 1033.0000, 'ºC'),
	(254162, 121, '2014-03-15 00:05:38.000000', 'temperatura', 412.0000, 'ºC'),
	(254163, 121, '2014-03-15 00:05:39.000000', 'temperatura', 160.0000, 'ºC'),
	(254164, 121, '2014-03-15 00:05:40.000000', 'temperatura', 766.0000, 'ºC'),
	(254165, 121, '2014-03-15 00:05:41.000000', 'temperatura', 950.0000, 'ºC'),
	(254166, 121, '2014-03-15 00:05:42.000000', 'temperatura', 50.0000, 'ºC'),
	(254167, 121, '2014-03-15 00:05:43.000000', 'temperatura', 1002.0000, 'ºC'),
	(254168, 121, '2014-03-15 00:05:44.000000', 'temperatura', 62.0000, 'ºC'),
	(254169, 121, '2014-03-15 00:05:45.000000', 'temperatura', 906.0000, 'ºC'),
	(254170, 121, '2014-03-15 00:05:46.000000', 'temperatura', 741.0000, 'ºC'),
	(254171, 121, '2014-03-15 00:05:47.000000', 'temperatura', 987.0000, 'ºC'),
	(254172, 121, '2014-03-15 00:05:48.000000', 'temperatura', 314.0000, 'ºC'),
	(254173, 121, '2014-03-15 00:05:49.000000', 'temperatura', 1009.0000, 'ºC'),
	(254174, 121, '2014-03-15 00:05:50.000000', 'temperatura', 505.0000, 'ºC'),
	(254175, 121, '2014-03-15 00:05:51.000000', 'temperatura', 697.0000, 'ºC'),
	(254176, 121, '2014-03-15 00:05:52.000000', 'temperatura', 771.0000, 'ºC'),
	(254177, 121, '2014-03-15 00:05:53.000000', 'temperatura', 566.0000, 'ºC'),
	(254178, 121, '2014-03-15 00:05:54.000000', 'temperatura', 518.0000, 'ºC'),
	(254179, 121, '2014-03-15 00:05:55.000000', 'temperatura', 891.0000, 'ºC'),
	(254180, 121, '2014-03-15 00:05:56.000000', 'temperatura', 503.0000, 'ºC'),
	(254181, 121, '2014-03-15 00:05:57.000000', 'temperatura', 1040.0000, 'ºC'),
	(254182, 121, '2014-03-15 00:05:58.000000', 'temperatura', 92.0000, 'ºC'),
	(254183, 121, '2014-03-15 00:05:59.000000', 'temperatura', 943.0000, 'ºC'),
	(254184, 121, '2014-03-15 00:06:00.000000', 'temperatura', 838.0000, 'ºC'),
	(254185, 121, '2014-03-15 00:06:01.000000', 'temperatura', 163.0000, 'ºC'),
	(254186, 121, '2014-03-15 00:06:02.000000', 'temperatura', 702.0000, 'ºC'),
	(254187, 121, '2014-03-15 00:06:03.000000', 'temperatura', 620.0000, 'ºC'),
	(254188, 121, '2014-03-15 00:06:04.000000', 'temperatura', 994.0000, 'ºC'),
	(254189, 121, '2014-03-15 00:06:05.000000', 'temperatura', 711.0000, 'ºC'),
	(254190, 121, '2014-03-15 00:06:06.000000', 'temperatura', 576.0000, 'ºC'),
	(254191, 121, '2014-03-15 00:06:07.000000', 'temperatura', 744.0000, 'ºC'),
	(254192, 121, '2014-03-15 00:06:08.000000', 'temperatura', 794.0000, 'ºC'),
	(254193, 121, '2014-03-15 00:06:09.000000', 'temperatura', 537.0000, 'ºC'),
	(254194, 121, '2014-03-15 00:06:10.000000', 'temperatura', 303.0000, 'ºC'),
	(254195, 121, '2014-03-15 00:06:11.000000', 'temperatura', 1106.0000, 'ºC'),
	(254196, 121, '2014-03-15 00:06:12.000000', 'temperatura', 1021.0000, 'ºC'),
	(254197, 121, '2014-03-15 00:06:13.000000', 'temperatura', 589.0000, 'ºC'),
	(254198, 121, '2014-03-15 00:06:14.000000', 'temperatura', 1082.0000, 'ºC'),
	(254199, 121, '2014-03-15 00:06:15.000000', 'temperatura', 42.0000, 'ºC'),
	(254200, 121, '2014-03-15 00:06:16.000000', 'temperatura', 566.0000, 'ºC'),
	(254201, 121, '2014-03-15 00:06:17.000000', 'temperatura', 303.0000, 'ºC'),
	(254202, 121, '2014-03-15 00:06:18.000000', 'temperatura', 1017.0000, 'ºC'),
	(254203, 121, '2014-03-15 00:06:19.000000', 'temperatura', 577.0000, 'ºC'),
	(254204, 121, '2014-03-15 00:06:20.000000', 'temperatura', 1036.0000, 'ºC'),
	(254205, 121, '2014-03-15 00:06:21.000000', 'temperatura', 1047.0000, 'ºC'),
	(254206, 121, '2014-03-15 00:06:22.000000', 'temperatura', 928.0000, 'ºC'),
	(254207, 121, '2014-03-15 00:06:23.000000', 'temperatura', 300.0000, 'ºC'),
	(254208, 121, '2014-03-15 00:06:24.000000', 'temperatura', 1118.0000, 'ºC'),
	(254209, 121, '2014-03-15 00:06:25.000000', 'temperatura', 1089.0000, 'ºC'),
	(254210, 121, '2014-03-15 00:06:26.000000', 'temperatura', 893.0000, 'ºC'),
	(254211, 121, '2014-03-15 00:06:27.000000', 'temperatura', 0.0000, 'ºC'),
	(254212, 121, '2014-03-15 00:06:28.000000', 'temperatura', 918.0000, 'ºC'),
	(254213, 121, '2014-03-15 00:06:29.000000', 'temperatura', 992.0000, 'ºC'),
	(254214, 121, '2014-03-15 00:06:30.000000', 'temperatura', 1005.0000, 'ºC'),
	(254215, 121, '2014-03-15 00:06:31.000000', 'temperatura', 850.0000, 'ºC'),
	(254216, 121, '2014-03-15 00:06:32.000000', 'temperatura', 35.0000, 'ºC'),
	(254217, 121, '2014-03-15 00:06:33.000000', 'temperatura', 26.0000, 'ºC'),
	(254218, 121, '2014-03-15 00:06:34.000000', 'temperatura', 26.0000, 'ºC'),
	(254219, 121, '2014-03-15 00:06:35.000000', 'temperatura', 52.0000, 'ºC'),
	(254220, 121, '2014-03-15 00:06:36.000000', 'temperatura', 182.0000, 'ºC'),
	(254221, 121, '2014-03-15 00:06:37.000000', 'temperatura', 753.0000, 'ºC'),
	(254222, 121, '2014-03-15 00:06:38.000000', 'temperatura', 820.0000, 'ºC'),
	(254223, 121, '2014-03-15 00:06:39.000000', 'temperatura', 643.0000, 'ºC'),
	(254224, 121, '2014-03-15 00:06:40.000000', 'temperatura', 755.0000, 'ºC'),
	(254225, 121, '2014-03-15 00:06:41.000000', 'temperatura', 649.0000, 'ºC'),
	(254226, 121, '2014-03-15 00:06:42.000000', 'temperatura', 977.0000, 'ºC'),
	(254227, 121, '2014-03-15 00:06:43.000000', 'temperatura', 538.0000, 'ºC'),
	(254228, 121, '2014-03-15 00:06:44.000000', 'temperatura', 960.0000, 'ºC'),
	(254229, 121, '2014-03-15 00:06:45.000000', 'temperatura', 789.0000, 'ºC'),
	(254230, 121, '2014-03-15 00:06:46.000000', 'temperatura', 1064.0000, 'ºC'),
	(254231, 121, '2014-03-15 00:06:47.000000', 'temperatura', 555.0000, 'ºC'),
	(254232, 121, '2014-03-15 00:06:48.000000', 'temperatura', 783.0000, 'ºC'),
	(254233, 121, '2014-03-15 00:06:49.000000', 'temperatura', 1050.0000, 'ºC'),
	(254234, 121, '2014-03-15 00:06:50.000000', 'temperatura', 502.0000, 'ºC'),
	(254235, 121, '2014-03-15 00:06:51.000000', 'temperatura', 559.0000, 'ºC'),
	(254236, 121, '2014-03-15 00:06:52.000000', 'temperatura', 90.0000, 'ºC'),
	(254237, 121, '2014-03-15 00:06:53.000000', 'temperatura', 1175.0000, 'ºC'),
	(254238, 121, '2014-03-15 00:06:54.000000', 'temperatura', 806.0000, 'ºC'),
	(254239, 121, '2014-03-15 00:06:55.000000', 'temperatura', 506.0000, 'ºC'),
	(254240, 121, '2014-03-15 00:06:56.000000', 'temperatura', 110.0000, 'ºC'),
	(254241, 121, '2014-03-15 00:06:57.000000', 'temperatura', 234.0000, 'ºC'),
	(254242, 121, '2014-03-15 00:06:58.000000', 'temperatura', 841.0000, 'ºC'),
	(254243, 121, '2014-03-15 00:06:59.000000', 'temperatura', 1103.0000, 'ºC'),
	(254244, 121, '2014-03-15 00:07:00.000000', 'temperatura', 593.0000, 'ºC'),
	(254245, 121, '2014-03-15 00:07:01.000000', 'temperatura', 854.0000, 'ºC'),
	(254246, 121, '2014-03-15 00:07:02.000000', 'temperatura', 94.0000, 'ºC'),
	(254247, 121, '2014-03-15 00:07:03.000000', 'temperatura', 307.0000, 'ºC'),
	(254248, 121, '2014-03-15 00:07:04.000000', 'temperatura', 55.0000, 'ºC'),
	(254249, 121, '2014-03-15 00:07:05.000000', 'temperatura', 556.0000, 'ºC'),
	(254250, 121, '2014-03-15 00:07:06.000000', 'temperatura', 214.0000, 'ºC'),
	(254251, 121, '2014-03-15 00:07:07.000000', 'temperatura', 601.0000, 'ºC'),
	(254252, 121, '2014-03-15 00:07:08.000000', 'temperatura', 1163.0000, 'ºC'),
	(254253, 121, '2014-03-15 00:07:09.000000', 'temperatura', 414.0000, 'ºC'),
	(254254, 121, '2014-03-15 00:07:10.000000', 'temperatura', 982.0000, 'ºC'),
	(254255, 121, '2014-03-15 00:07:11.000000', 'temperatura', 67.0000, 'ºC'),
	(254256, 121, '2014-03-15 00:07:12.000000', 'temperatura', 991.0000, 'ºC'),
	(254257, 121, '2014-03-15 00:07:13.000000', 'temperatura', 1153.0000, 'ºC'),
	(254258, 121, '2014-03-15 00:07:14.000000', 'temperatura', 393.0000, 'ºC'),
	(254259, 121, '2014-03-15 00:07:15.000000', 'temperatura', 906.0000, 'ºC'),
	(254260, 121, '2014-03-15 00:07:16.000000', 'temperatura', 953.0000, 'ºC'),
	(254261, 121, '2014-03-15 00:07:17.000000', 'temperatura', 848.0000, 'ºC'),
	(254262, 121, '2014-03-15 00:07:18.000000', 'temperatura', 180.0000, 'ºC'),
	(254263, 121, '2014-03-15 00:07:19.000000', 'temperatura', 757.0000, 'ºC'),
	(254264, 121, '2014-03-15 00:07:20.000000', 'temperatura', 844.0000, 'ºC'),
	(254265, 121, '2014-03-15 00:07:21.000000', 'temperatura', 750.0000, 'ºC'),
	(254266, 121, '2014-03-15 00:07:22.000000', 'temperatura', 20.0000, 'ºC'),
	(254267, 121, '2014-03-15 00:07:23.000000', 'temperatura', 251.0000, 'ºC'),
	(254268, 121, '2014-03-15 00:07:24.000000', 'temperatura', 1193.0000, 'ºC'),
	(254269, 121, '2014-03-15 00:07:25.000000', 'temperatura', 414.0000, 'ºC'),
	(254270, 121, '2014-03-15 00:07:26.000000', 'temperatura', 891.0000, 'ºC'),
	(254271, 121, '2014-03-15 00:07:27.000000', 'temperatura', 814.0000, 'ºC'),
	(254272, 121, '2014-03-15 00:07:28.000000', 'temperatura', 197.0000, 'ºC'),
	(254273, 121, '2014-03-15 00:07:29.000000', 'temperatura', 942.0000, 'ºC'),
	(254274, 121, '2014-03-15 00:07:30.000000', 'temperatura', 521.0000, 'ºC'),
	(254275, 121, '2014-03-15 00:07:31.000000', 'temperatura', 979.0000, 'ºC'),
	(254276, 121, '2014-03-15 00:07:32.000000', 'temperatura', 932.0000, 'ºC'),
	(254277, 121, '2014-03-15 00:07:33.000000', 'temperatura', 523.0000, 'ºC'),
	(254278, 121, '2014-03-15 00:07:34.000000', 'temperatura', 1022.0000, 'ºC'),
	(254279, 121, '2014-03-15 00:07:35.000000', 'temperatura', 1140.0000, 'ºC'),
	(254280, 121, '2014-03-15 00:07:36.000000', 'temperatura', 237.0000, 'ºC'),
	(254281, 121, '2014-03-15 00:07:37.000000', 'temperatura', 162.0000, 'ºC'),
	(254282, 121, '2014-03-15 00:07:38.000000', 'temperatura', 102.0000, 'ºC'),
	(254283, 121, '2014-03-15 00:07:39.000000', 'temperatura', 25.0000, 'ºC'),
	(254284, 121, '2014-03-15 00:07:40.000000', 'temperatura', 1017.0000, 'ºC'),
	(254285, 121, '2014-03-15 00:07:41.000000', 'temperatura', 211.0000, 'ºC'),
	(254286, 121, '2014-03-15 00:07:42.000000', 'temperatura', 404.0000, 'ºC'),
	(254287, 121, '2014-03-15 00:07:43.000000', 'temperatura', 189.0000, 'ºC'),
	(254288, 121, '2014-03-15 00:07:44.000000', 'temperatura', 935.0000, 'ºC'),
	(254289, 121, '2014-03-15 00:07:45.000000', 'temperatura', 505.0000, 'ºC'),
	(254290, 121, '2014-03-15 00:07:46.000000', 'temperatura', 923.0000, 'ºC'),
	(254291, 121, '2014-03-15 00:07:47.000000', 'temperatura', 699.0000, 'ºC'),
	(254292, 121, '2014-03-15 00:07:48.000000', 'temperatura', 728.0000, 'ºC'),
	(254293, 121, '2014-03-15 00:07:49.000000', 'temperatura', 341.0000, 'ºC'),
	(254294, 121, '2014-03-15 00:07:50.000000', 'temperatura', 722.0000, 'ºC'),
	(254295, 121, '2014-03-15 00:07:51.000000', 'temperatura', 188.0000, 'ºC'),
	(254296, 121, '2014-03-15 00:07:52.000000', 'temperatura', 1175.0000, 'ºC'),
	(254297, 121, '2014-03-15 00:07:53.000000', 'temperatura', 512.0000, 'ºC'),
	(254298, 121, '2014-03-15 00:07:54.000000', 'temperatura', 234.0000, 'ºC'),
	(254299, 121, '2014-03-15 00:07:55.000000', 'temperatura', 837.0000, 'ºC'),
	(254300, 121, '2014-03-15 00:07:56.000000', 'temperatura', 1083.0000, 'ºC'),
	(254301, 121, '2014-03-15 00:07:57.000000', 'temperatura', 504.0000, 'ºC'),
	(254302, 121, '2014-03-15 00:07:58.000000', 'temperatura', 471.0000, 'ºC'),
	(254303, 121, '2014-03-15 00:07:59.000000', 'temperatura', 842.0000, 'ºC'),
	(254304, 121, '2014-03-15 00:08:00.000000', 'temperatura', 399.0000, 'ºC'),
	(254305, 121, '2014-03-15 00:08:01.000000', 'temperatura', 668.0000, 'ºC'),
	(254306, 121, '2014-03-15 00:08:02.000000', 'temperatura', 944.0000, 'ºC'),
	(254307, 121, '2014-03-15 00:08:03.000000', 'temperatura', 319.0000, 'ºC'),
	(254308, 121, '2014-03-15 00:08:04.000000', 'temperatura', 1161.0000, 'ºC'),
	(254309, 121, '2014-03-15 00:08:05.000000', 'temperatura', 47.0000, 'ºC'),
	(254310, 121, '2014-03-15 00:08:06.000000', 'temperatura', 355.0000, 'ºC'),
	(254311, 121, '2014-03-15 00:08:07.000000', 'temperatura', 434.0000, 'ºC'),
	(254312, 121, '2014-03-15 00:08:08.000000', 'temperatura', 1107.0000, 'ºC'),
	(254313, 121, '2014-03-15 00:08:09.000000', 'temperatura', 632.0000, 'ºC'),
	(254314, 121, '2014-03-15 00:08:10.000000', 'temperatura', 1040.0000, 'ºC'),
	(254315, 121, '2014-03-15 00:08:11.000000', 'temperatura', 903.0000, 'ºC'),
	(254316, 121, '2014-03-15 00:08:12.000000', 'temperatura', 198.0000, 'ºC'),
	(254317, 121, '2014-03-15 00:08:13.000000', 'temperatura', 679.0000, 'ºC'),
	(254318, 121, '2014-03-15 00:08:14.000000', 'temperatura', 401.0000, 'ºC'),
	(254319, 121, '2014-03-15 00:08:15.000000', 'temperatura', 1170.0000, 'ºC'),
	(254320, 121, '2014-03-15 00:08:16.000000', 'temperatura', 1046.0000, 'ºC'),
	(254321, 121, '2014-03-15 00:08:17.000000', 'temperatura', 520.0000, 'ºC'),
	(254322, 121, '2014-03-15 00:08:18.000000', 'temperatura', 665.0000, 'ºC'),
	(254323, 121, '2014-03-15 00:08:19.000000', 'temperatura', 563.0000, 'ºC'),
	(254324, 121, '2014-03-15 00:08:20.000000', 'temperatura', 824.0000, 'ºC'),
	(254325, 121, '2014-03-15 00:08:21.000000', 'temperatura', 28.0000, 'ºC'),
	(254326, 121, '2014-03-15 00:08:22.000000', 'temperatura', 69.0000, 'ºC'),
	(254327, 121, '2014-03-15 00:08:23.000000', 'temperatura', 262.0000, 'ºC'),
	(254328, 121, '2014-03-15 00:08:24.000000', 'temperatura', 1105.0000, 'ºC'),
	(254329, 121, '2014-03-15 00:08:25.000000', 'temperatura', 1139.0000, 'ºC'),
	(254330, 121, '2014-03-15 00:08:26.000000', 'temperatura', 1179.0000, 'ºC'),
	(254331, 121, '2014-03-15 00:08:27.000000', 'temperatura', 81.0000, 'ºC'),
	(254332, 121, '2014-03-15 00:08:28.000000', 'temperatura', 469.0000, 'ºC'),
	(254333, 121, '2014-03-15 00:08:29.000000', 'temperatura', 900.0000, 'ºC'),
	(254334, 121, '2014-03-15 00:08:30.000000', 'temperatura', 694.0000, 'ºC'),
	(254335, 121, '2014-03-15 00:08:31.000000', 'temperatura', 770.0000, 'ºC'),
	(254336, 121, '2014-03-15 00:08:32.000000', 'temperatura', 571.0000, 'ºC'),
	(254337, 121, '2014-03-15 00:08:33.000000', 'temperatura', 544.0000, 'ºC'),
	(254338, 121, '2014-03-15 00:08:34.000000', 'temperatura', 1007.0000, 'ºC'),
	(254339, 121, '2014-03-15 00:08:35.000000', 'temperatura', 1003.0000, 'ºC'),
	(254340, 121, '2014-03-15 00:08:36.000000', 'temperatura', 793.0000, 'ºC'),
	(254341, 121, '2014-03-15 00:08:37.000000', 'temperatura', 960.0000, 'ºC'),
	(254342, 121, '2014-03-15 00:08:38.000000', 'temperatura', 19.0000, 'ºC'),
	(254343, 121, '2014-03-15 00:08:39.000000', 'temperatura', 817.0000, 'ºC'),
	(254344, 121, '2014-03-15 00:08:40.000000', 'temperatura', 429.0000, 'ºC'),
	(254345, 121, '2014-03-15 00:08:41.000000', 'temperatura', 896.0000, 'ºC'),
	(254346, 121, '2014-03-15 00:08:42.000000', 'temperatura', 790.0000, 'ºC'),
	(254347, 121, '2014-03-15 00:08:43.000000', 'temperatura', 65.0000, 'ºC'),
	(254348, 121, '2014-03-15 00:08:44.000000', 'temperatura', 354.0000, 'ºC'),
	(254349, 121, '2014-03-15 00:08:45.000000', 'temperatura', 376.0000, 'ºC'),
	(254350, 121, '2014-03-15 00:08:46.000000', 'temperatura', 820.0000, 'ºC'),
	(254351, 121, '2014-03-15 00:08:47.000000', 'temperatura', 573.0000, 'ºC'),
	(254352, 121, '2014-03-15 00:08:48.000000', 'temperatura', 405.0000, 'ºC'),
	(254353, 121, '2014-03-15 00:08:49.000000', 'temperatura', 307.0000, 'ºC'),
	(254354, 121, '2014-03-15 00:08:50.000000', 'temperatura', 321.0000, 'ºC'),
	(254355, 121, '2014-03-15 00:08:51.000000', 'temperatura', 682.0000, 'ºC'),
	(254356, 121, '2014-03-15 00:08:52.000000', 'temperatura', 50.0000, 'ºC'),
	(254357, 121, '2014-03-15 00:08:53.000000', 'temperatura', 604.0000, 'ºC'),
	(254358, 121, '2014-03-15 00:08:54.000000', 'temperatura', 469.0000, 'ºC'),
	(254359, 121, '2014-03-15 00:08:55.000000', 'temperatura', 533.0000, 'ºC'),
	(254360, 121, '2014-03-15 00:08:56.000000', 'temperatura', 58.0000, 'ºC'),
	(254361, 121, '2014-03-15 00:08:57.000000', 'temperatura', 1092.0000, 'ºC'),
	(254362, 121, '2014-03-15 00:08:58.000000', 'temperatura', 487.0000, 'ºC'),
	(254363, 121, '2014-03-15 00:08:59.000000', 'temperatura', 358.0000, 'ºC'),
	(254364, 121, '2014-03-15 00:09:00.000000', 'temperatura', 332.0000, 'ºC'),
	(254365, 121, '2014-03-15 00:09:01.000000', 'temperatura', 586.0000, 'ºC'),
	(254366, 121, '2014-03-15 00:09:02.000000', 'temperatura', 736.0000, 'ºC'),
	(254367, 121, '2014-03-15 00:09:03.000000', 'temperatura', 722.0000, 'ºC'),
	(254368, 121, '2014-03-15 00:09:04.000000', 'temperatura', 201.0000, 'ºC'),
	(254369, 121, '2014-03-15 00:09:05.000000', 'temperatura', 39.0000, 'ºC'),
	(254370, 121, '2014-03-15 00:09:06.000000', 'temperatura', 791.0000, 'ºC'),
	(254371, 121, '2014-03-15 00:09:07.000000', 'temperatura', 242.0000, 'ºC'),
	(254372, 121, '2014-03-15 00:09:08.000000', 'temperatura', 37.0000, 'ºC'),
	(254373, 121, '2014-03-15 00:09:09.000000', 'temperatura', 658.0000, 'ºC'),
	(254374, 121, '2014-03-15 00:09:10.000000', 'temperatura', 779.0000, 'ºC'),
	(254375, 121, '2014-03-15 00:09:11.000000', 'temperatura', 722.0000, 'ºC'),
	(254376, 121, '2014-03-15 00:09:12.000000', 'temperatura', 72.0000, 'ºC'),
	(254377, 121, '2014-03-15 00:09:13.000000', 'temperatura', 597.0000, 'ºC'),
	(254378, 121, '2014-03-15 00:09:14.000000', 'temperatura', 367.0000, 'ºC'),
	(254379, 121, '2014-03-15 00:09:15.000000', 'temperatura', 44.0000, 'ºC'),
	(254380, 121, '2014-03-15 00:09:16.000000', 'temperatura', 319.0000, 'ºC'),
	(254381, 121, '2014-03-15 00:09:17.000000', 'temperatura', 265.0000, 'ºC'),
	(254382, 121, '2014-03-15 00:09:18.000000', 'temperatura', 368.0000, 'ºC'),
	(254383, 121, '2014-03-15 00:09:19.000000', 'temperatura', 1047.0000, 'ºC'),
	(254384, 121, '2014-03-15 00:09:20.000000', 'temperatura', 530.0000, 'ºC'),
	(254385, 121, '2014-03-15 00:09:21.000000', 'temperatura', 712.0000, 'ºC'),
	(254386, 121, '2014-03-15 00:09:22.000000', 'temperatura', 768.0000, 'ºC'),
	(254387, 121, '2014-03-15 00:09:23.000000', 'temperatura', 504.0000, 'ºC'),
	(254388, 121, '2014-03-15 00:09:24.000000', 'temperatura', 217.0000, 'ºC'),
	(254389, 121, '2014-03-15 00:09:25.000000', 'temperatura', 773.0000, 'ºC'),
	(254390, 121, '2014-03-15 00:09:26.000000', 'temperatura', 814.0000, 'ºC'),
	(254391, 121, '2014-03-15 00:09:27.000000', 'temperatura', 551.0000, 'ºC'),
	(254392, 121, '2014-03-15 00:09:28.000000', 'temperatura', 313.0000, 'ºC'),
	(254393, 121, '2014-03-15 00:09:29.000000', 'temperatura', 1114.0000, 'ºC'),
	(254394, 121, '2014-03-15 00:09:30.000000', 'temperatura', 1032.0000, 'ºC'),
	(254395, 121, '2014-03-15 00:09:31.000000', 'temperatura', 619.0000, 'ºC'),
	(254396, 121, '2014-03-15 00:09:32.000000', 'temperatura', 1198.0000, 'ºC'),
	(254397, 121, '2014-03-15 00:09:33.000000', 'temperatura', 533.0000, 'ºC'),
	(254398, 121, '2014-03-15 00:09:34.000000', 'temperatura', 270.0000, 'ºC'),
	(254399, 121, '2014-03-15 00:09:35.000000', 'temperatura', 955.0000, 'ºC'),
	(254400, 121, '2014-03-15 00:09:36.000000', 'temperatura', 363.0000, 'ºC'),
	(254401, 121, '2014-03-15 00:09:37.000000', 'temperatura', 153.0000, 'ºC'),
	(254402, 121, '2014-03-15 00:09:38.000000', 'temperatura', 876.0000, 'ºC'),
	(254403, 121, '2014-03-15 00:09:39.000000', 'temperatura', 320.0000, 'ºC'),
	(254404, 121, '2014-03-15 00:09:40.000000', 'temperatura', 175.0000, 'ºC'),
	(254405, 121, '2014-03-15 00:09:41.000000', 'temperatura', 1114.0000, 'ºC'),
	(254406, 121, '2014-03-15 00:09:42.000000', 'temperatura', 247.0000, 'ºC'),
	(254407, 121, '2014-03-15 00:09:43.000000', 'temperatura', 295.0000, 'ºC'),
	(254408, 121, '2014-03-15 00:09:44.000000', 'temperatura', 731.0000, 'ºC'),
	(254409, 121, '2014-03-15 00:09:45.000000', 'temperatura', 372.0000, 'ºC'),
	(254410, 121, '2014-03-15 00:09:46.000000', 'temperatura', 869.0000, 'ºC'),
	(254411, 121, '2014-03-15 00:09:47.000000', 'temperatura', 829.0000, 'ºC'),
	(254412, 121, '2014-03-15 00:09:48.000000', 'temperatura', 337.0000, 'ºC'),
	(254413, 121, '2014-03-15 00:09:49.000000', 'temperatura', 397.0000, 'ºC'),
	(254414, 121, '2014-03-15 00:09:50.000000', 'temperatura', 978.0000, 'ºC'),
	(254415, 121, '2014-03-15 00:09:51.000000', 'temperatura', 98.0000, 'ºC'),
	(254416, 121, '2014-03-15 00:09:52.000000', 'temperatura', 1158.0000, 'ºC'),
	(254417, 121, '2014-03-15 00:09:53.000000', 'temperatura', 695.0000, 'ºC'),
	(254418, 121, '2014-03-15 00:09:54.000000', 'temperatura', 3.0000, 'ºC'),
	(254419, 121, '2014-03-15 00:09:55.000000', 'temperatura', 332.0000, 'ºC'),
	(254420, 121, '2014-03-15 00:09:56.000000', 'temperatura', 449.0000, 'ºC'),
	(254421, 121, '2014-03-15 00:09:57.000000', 'temperatura', 49.0000, 'ºC'),
	(254422, 121, '2014-03-15 00:09:58.000000', 'temperatura', 97.0000, 'ºC'),
	(254423, 121, '2014-03-15 00:09:59.000000', 'temperatura', 341.0000, 'ºC'),
	(254424, 121, '2014-03-15 00:10:00.000000', 'temperatura', 215.0000, 'ºC'),
	(254425, 121, '2014-03-15 00:10:01.000000', 'temperatura', 52.0000, 'ºC'),
	(254426, 121, '2014-03-15 00:10:02.000000', 'temperatura', 817.0000, 'ºC'),
	(254427, 121, '2014-03-15 00:10:03.000000', 'temperatura', 327.0000, 'ºC'),
	(254428, 121, '2014-03-15 00:10:04.000000', 'temperatura', 386.0000, 'ºC'),
	(254429, 121, '2014-03-15 00:10:05.000000', 'temperatura', 949.0000, 'ºC'),
	(254430, 121, '2014-03-15 00:10:06.000000', 'temperatura', 1188.0000, 'ºC'),
	(254431, 121, '2014-03-15 00:10:07.000000', 'temperatura', 692.0000, 'ºC'),
	(254432, 121, '2014-03-15 00:10:08.000000', 'temperatura', 1099.0000, 'ºC'),
	(254433, 121, '2014-03-15 00:10:09.000000', 'temperatura', 1017.0000, 'ºC'),
	(254434, 121, '2014-03-15 00:10:10.000000', 'temperatura', 588.0000, 'ºC'),
	(254435, 121, '2014-03-15 00:10:11.000000', 'temperatura', 1090.0000, 'ºC'),
	(254436, 121, '2014-03-15 00:10:12.000000', 'temperatura', 88.0000, 'ºC'),
	(254437, 121, '2014-03-15 00:10:13.000000', 'temperatura', 771.0000, 'ºC'),
	(254438, 121, '2014-03-15 00:10:14.000000', 'temperatura', 1191.0000, 'ºC'),
	(254439, 121, '2014-03-15 00:10:15.000000', 'temperatura', 43.0000, 'ºC'),
	(254440, 121, '2014-03-15 00:10:16.000000', 'temperatura', 241.0000, 'ºC'),
	(254441, 121, '2014-03-15 00:10:17.000000', 'temperatura', 1077.0000, 'ºC'),
	(254442, 121, '2014-03-15 00:10:18.000000', 'temperatura', 1061.0000, 'ºC'),
	(254443, 121, '2014-03-15 00:10:19.000000', 'temperatura', 877.0000, 'ºC'),
	(254444, 121, '2014-03-15 00:10:20.000000', 'temperatura', 2.0000, 'ºC'),
	(254445, 121, '2014-03-15 00:10:21.000000', 'temperatura', 978.0000, 'ºC'),
	(254446, 121, '2014-03-15 00:10:22.000000', 'temperatura', 87.0000, 'ºC'),
	(254447, 121, '2014-03-15 00:10:23.000000', 'temperatura', 1100.0000, 'ºC'),
	(254448, 121, '2014-03-15 00:10:24.000000', 'temperatura', 439.0000, 'ºC'),
	(254449, 121, '2014-03-15 00:10:25.000000', 'temperatura', 95.0000, 'ºC'),
	(254450, 121, '2014-03-15 00:10:26.000000', 'temperatura', 360.0000, 'ºC'),
	(254451, 121, '2014-03-15 00:10:27.000000', 'temperatura', 313.0000, 'ºC'),
	(254452, 121, '2014-03-15 00:10:28.000000', 'temperatura', 487.0000, 'ºC'),
	(254453, 121, '2014-03-15 00:10:29.000000', 'temperatura', 296.0000, 'ºC'),
	(254454, 121, '2014-03-15 00:10:30.000000', 'temperatura', 21.0000, 'ºC'),
	(254455, 121, '2014-03-15 00:10:31.000000', 'temperatura', 417.0000, 'ºC'),
	(254456, 121, '2014-03-15 00:10:32.000000', 'temperatura', 822.0000, 'ºC'),
	(254457, 121, '2014-03-15 00:10:33.000000', 'temperatura', 460.0000, 'ºC'),
	(254458, 121, '2014-03-15 00:10:34.000000', 'temperatura', 1035.0000, 'ºC'),
	(254459, 121, '2014-03-15 00:10:35.000000', 'temperatura', 196.0000, 'ºC'),
	(254460, 121, '2014-03-15 00:10:36.000000', 'temperatura', 274.0000, 'ºC'),
	(254461, 121, '2014-03-15 00:10:37.000000', 'temperatura', 783.0000, 'ºC'),
	(254462, 121, '2014-03-15 00:10:38.000000', 'temperatura', 695.0000, 'ºC'),
	(254463, 121, '2014-03-15 00:10:39.000000', 'temperatura', 1126.0000, 'ºC'),
	(254464, 121, '2014-03-15 00:10:40.000000', 'temperatura', 1144.0000, 'ºC'),
	(254465, 121, '2014-03-15 00:10:41.000000', 'temperatura', 1145.0000, 'ºC'),
	(254466, 121, '2014-03-15 00:10:42.000000', 'temperatura', 1090.0000, 'ºC'),
	(254467, 121, '2014-03-15 00:10:43.000000', 'temperatura', 819.0000, 'ºC'),
	(254468, 121, '2014-03-15 00:10:44.000000', 'temperatura', 823.0000, 'ºC'),
	(254469, 121, '2014-03-15 00:10:45.000000', 'temperatura', 458.0000, 'ºC'),
	(254470, 121, '2014-03-15 00:10:46.000000', 'temperatura', 1021.0000, 'ºC'),
	(254471, 121, '2014-03-15 00:10:47.000000', 'temperatura', 131.0000, 'ºC'),
	(254472, 121, '2014-03-15 00:10:48.000000', 'temperatura', 1193.0000, 'ºC'),
	(254473, 121, '2014-03-15 00:10:49.000000', 'temperatura', 772.0000, 'ºC'),
	(254474, 121, '2014-03-15 00:10:50.000000', 'temperatura', 282.0000, 'ºC'),
	(254475, 121, '2014-03-15 00:10:51.000000', 'temperatura', 294.0000, 'ºC'),
	(254476, 121, '2014-03-15 00:10:52.000000', 'temperatura', 626.0000, 'ºC'),
	(254477, 121, '2014-03-15 00:10:53.000000', 'temperatura', 1049.0000, 'ºC'),
	(254478, 121, '2014-03-15 00:10:54.000000', 'temperatura', 965.0000, 'ºC'),
	(254479, 121, '2014-03-15 00:10:55.000000', 'temperatura', 478.0000, 'ºC'),
	(254480, 121, '2014-03-15 00:10:56.000000', 'temperatura', 699.0000, 'ºC'),
	(254481, 121, '2014-03-15 00:10:57.000000', 'temperatura', 858.0000, 'ºC'),
	(254482, 121, '2014-03-15 00:10:58.000000', 'temperatura', 994.0000, 'ºC'),
	(254483, 121, '2014-03-15 00:10:59.000000', 'temperatura', 1198.0000, 'ºC'),
	(254484, 121, '2014-03-15 00:11:00.000000', 'temperatura', 606.0000, 'ºC'),
	(254485, 121, '2014-03-15 00:11:01.000000', 'temperatura', 640.0000, 'ºC'),
	(254486, 121, '2014-03-15 00:11:02.000000', 'temperatura', 179.0000, 'ºC'),
	(254487, 121, '2014-03-15 00:11:03.000000', 'temperatura', 177.0000, 'ºC'),
	(254488, 121, '2014-03-15 00:11:04.000000', 'temperatura', 349.0000, 'ºC'),
	(254489, 121, '2014-03-15 00:11:05.000000', 'temperatura', 15.0000, 'ºC'),
	(254490, 121, '2014-03-15 00:11:06.000000', 'temperatura', 226.0000, 'ºC'),
	(254491, 121, '2014-03-15 00:11:07.000000', 'temperatura', 1086.0000, 'ºC'),
	(254492, 121, '2014-03-15 00:11:08.000000', 'temperatura', 1155.0000, 'ºC'),
	(254493, 121, '2014-03-15 00:11:09.000000', 'temperatura', 114.0000, 'ºC'),
	(254494, 121, '2014-03-15 00:11:10.000000', 'temperatura', 709.0000, 'ºC'),
	(254495, 121, '2014-03-15 00:11:11.000000', 'temperatura', 801.0000, 'ºC'),
	(254496, 121, '2014-03-15 00:11:12.000000', 'temperatura', 681.0000, 'ºC'),
	(254497, 121, '2014-03-15 00:11:13.000000', 'temperatura', 1002.0000, 'ºC'),
	(254498, 121, '2014-03-15 00:11:14.000000', 'temperatura', 568.0000, 'ºC'),
	(254499, 121, '2014-03-15 00:11:15.000000', 'temperatura', 1032.0000, 'ºC'),
	(254500, 121, '2014-03-15 00:11:16.000000', 'temperatura', 1058.0000, 'ºC'),
	(254501, 121, '2014-03-15 00:11:17.000000', 'temperatura', 995.0000, 'ºC'),
	(254502, 121, '2014-03-15 00:11:18.000000', 'temperatura', 599.0000, 'ºC'),
	(254503, 121, '2014-03-15 00:11:19.000000', 'temperatura', 13.0000, 'ºC'),
	(254504, 121, '2014-03-15 00:11:20.000000', 'temperatura', 666.0000, 'ºC'),
	(254505, 121, '2014-03-15 00:11:21.000000', 'temperatura', 892.0000, 'ºC'),
	(254506, 121, '2014-03-15 00:11:22.000000', 'temperatura', 62.0000, 'ºC'),
	(254507, 121, '2014-03-15 00:11:23.000000', 'temperatura', 36.0000, 'ºC'),
	(254508, 121, '2014-03-15 00:11:24.000000', 'temperatura', 1195.0000, 'ºC'),
	(254509, 121, '2014-03-15 00:11:25.000000', 'temperatura', 1066.0000, 'ºC'),
	(254510, 121, '2014-03-15 00:11:26.000000', 'temperatura', 544.0000, 'ºC'),
	(254511, 121, '2014-03-15 00:11:27.000000', 'temperatura', 724.0000, 'ºC'),
	(254512, 121, '2014-03-15 00:11:28.000000', 'temperatura', 788.0000, 'ºC'),
	(254513, 121, '2014-03-15 00:11:29.000000', 'temperatura', 568.0000, 'ºC'),
	(254514, 121, '2014-03-15 00:11:30.000000', 'temperatura', 476.0000, 'ºC'),
	(254515, 121, '2014-03-15 00:11:31.000000', 'temperatura', 678.0000, 'ºC'),
	(254516, 121, '2014-03-15 00:11:32.000000', 'temperatura', 762.0000, 'ºC'),
	(254517, 121, '2014-03-15 00:11:33.000000', 'temperatura', 577.0000, 'ºC'),
	(254518, 121, '2014-03-15 00:11:34.000000', 'temperatura', 598.0000, 'ºC'),
	(254519, 121, '2014-03-15 00:11:35.000000', 'temperatura', 61.0000, 'ºC'),
	(254520, 121, '2014-03-15 00:11:36.000000', 'temperatura', 909.0000, 'ºC'),
	(254521, 121, '2014-03-15 00:11:37.000000', 'temperatura', 765.0000, 'ºC'),
	(254522, 121, '2014-03-15 00:11:38.000000', 'temperatura', 1098.0000, 'ºC'),
	(254523, 121, '2014-03-15 00:11:39.000000', 'temperatura', 797.0000, 'ºC'),
	(254524, 121, '2014-03-15 00:11:40.000000', 'temperatura', 689.0000, 'ºC'),
	(254525, 121, '2014-03-15 00:11:41.000000', 'temperatura', 1057.0000, 'ºC'),
	(254526, 121, '2014-03-15 00:11:42.000000', 'temperatura', 819.0000, 'ºC'),
	(254527, 121, '2014-03-15 00:11:43.000000', 'temperatura', 923.0000, 'ºC'),
	(254528, 121, '2014-03-15 00:11:44.000000', 'temperatura', 957.0000, 'ºC'),
	(254529, 121, '2014-03-15 00:11:45.000000', 'temperatura', 818.0000, 'ºC'),
	(254530, 121, '2014-03-15 00:11:46.000000', 'temperatura', 18.0000, 'ºC'),
	(254531, 121, '2014-03-15 00:11:47.000000', 'temperatura', 37.0000, 'ºC'),
	(254532, 121, '2014-03-15 00:11:48.000000', 'temperatura', 130.0000, 'ºC'),
	(254533, 121, '2014-03-15 00:11:49.000000', 'temperatura', 542.0000, 'ºC'),
	(254534, 121, '2014-03-15 00:11:50.000000', 'temperatura', 1118.0000, 'ºC'),
	(254535, 121, '2014-03-15 00:11:51.000000', 'temperatura', 364.0000, 'ºC'),
	(254536, 121, '2014-03-15 00:11:52.000000', 'temperatura', 869.0000, 'ºC'),
	(254537, 121, '2014-03-15 00:11:53.000000', 'temperatura', 852.0000, 'ºC'),
	(254538, 121, '2014-03-15 00:11:54.000000', 'temperatura', 454.0000, 'ºC'),
	(254539, 121, '2014-03-15 00:11:55.000000', 'temperatura', 913.0000, 'ºC'),
	(254540, 121, '2014-03-15 00:11:56.000000', 'temperatura', 806.0000, 'ºC'),
	(254541, 121, '2014-03-15 00:11:57.000000', 'temperatura', 90.0000, 'ºC'),
	(254542, 121, '2014-03-15 00:11:58.000000', 'temperatura', 435.0000, 'ºC'),
	(254543, 121, '2014-03-15 00:11:59.000000', 'temperatura', 702.0000, 'ºC'),
	(254544, 121, '2014-03-15 00:12:00.000000', 'temperatura', 1009.0000, 'ºC'),
	(254545, 121, '2014-03-15 00:12:01.000000', 'temperatura', 538.0000, 'ºC'),
	(254546, 121, '2014-03-15 00:12:02.000000', 'temperatura', 862.0000, 'ºC'),
	(254547, 121, '2014-03-15 00:12:03.000000', 'temperatura', 297.0000, 'ºC'),
	(254548, 121, '2014-03-15 00:12:04.000000', 'temperatura', 99.0000, 'ºC'),
	(254549, 121, '2014-03-15 00:12:05.000000', 'temperatura', 803.0000, 'ºC'),
	(254550, 121, '2014-03-15 00:12:06.000000', 'temperatura', 121.0000, 'ºC'),
	(254551, 121, '2014-03-15 00:12:07.000000', 'temperatura', 597.0000, 'ºC'),
	(254552, 121, '2014-03-15 00:12:08.000000', 'temperatura', 222.0000, 'ºC'),
	(254553, 121, '2014-03-15 00:12:09.000000', 'temperatura', 520.0000, 'ºC'),
	(254554, 121, '2014-03-15 00:12:10.000000', 'temperatura', 735.0000, 'ºC'),
	(254555, 121, '2014-03-15 00:12:11.000000', 'temperatura', 917.0000, 'ºC'),
	(254556, 121, '2014-03-15 00:12:12.000000', 'temperatura', 1177.0000, 'ºC'),
	(254557, 121, '2014-03-15 00:12:13.000000', 'temperatura', 738.0000, 'ºC'),
	(254558, 121, '2014-03-15 00:12:14.000000', 'temperatura', 157.0000, 'ºC'),
	(254559, 121, '2014-03-15 00:12:15.000000', 'temperatura', 974.0000, 'ºC'),
	(254560, 121, '2014-03-15 00:12:16.000000', 'temperatura', 799.0000, 'ºC'),
	(254561, 121, '2014-03-15 00:12:17.000000', 'temperatura', 1073.0000, 'ºC'),
	(254562, 121, '2014-03-15 00:12:18.000000', 'temperatura', 567.0000, 'ºC'),
	(254563, 121, '2014-03-15 00:12:19.000000', 'temperatura', 817.0000, 'ºC'),
	(254564, 121, '2014-03-15 00:12:20.000000', 'temperatura', 1184.0000, 'ºC'),
	(254565, 121, '2014-03-15 00:12:21.000000', 'temperatura', 1069.0000, 'ºC'),
	(254566, 121, '2014-03-15 00:12:22.000000', 'temperatura', 594.0000, 'ºC'),
	(254567, 121, '2014-03-15 00:12:23.000000', 'temperatura', 962.0000, 'ºC'),
	(254568, 121, '2014-03-15 00:12:24.000000', 'temperatura', 631.0000, 'ºC'),
	(254569, 121, '2014-03-15 00:12:25.000000', 'temperatura', 267.0000, 'ºC'),
	(254570, 121, '2014-03-15 00:12:26.000000', 'temperatura', 642.0000, 'ºC'),
	(254571, 121, '2014-03-15 00:12:27.000000', 'temperatura', 10.0000, 'ºC'),
	(254572, 121, '2014-03-15 00:12:28.000000', 'temperatura', 525.0000, 'ºC'),
	(254573, 121, '2014-03-15 00:12:29.000000', 'temperatura', 196.0000, 'ºC'),
	(254574, 121, '2014-03-15 00:12:30.000000', 'temperatura', 606.0000, 'ºC'),
	(254575, 121, '2014-03-15 00:12:31.000000', 'temperatura', 43.0000, 'ºC'),
	(254576, 121, '2014-03-15 00:12:32.000000', 'temperatura', 795.0000, 'ºC'),
	(254577, 121, '2014-03-15 00:12:33.000000', 'temperatura', 248.0000, 'ºC'),
	(254578, 121, '2014-03-15 00:12:34.000000', 'temperatura', 57.0000, 'ºC'),
	(254579, 121, '2014-03-15 00:12:35.000000', 'temperatura', 742.0000, 'ºC'),
	(254580, 121, '2014-03-15 00:12:36.000000', 'temperatura', 1138.0000, 'ºC'),
	(254581, 121, '2014-03-15 00:12:37.000000', 'temperatura', 1066.0000, 'ºC'),
	(254582, 121, '2014-03-15 00:12:38.000000', 'temperatura', 715.0000, 'ºC'),
	(254583, 121, '2014-03-15 00:12:39.000000', 'temperatura', 377.0000, 'ºC'),
	(254584, 121, '2014-03-15 00:12:40.000000', 'temperatura', 942.0000, 'ºC'),
	(254585, 121, '2014-03-15 00:12:41.000000', 'temperatura', 1179.0000, 'ºC'),
	(254586, 121, '2014-03-15 00:12:42.000000', 'temperatura', 668.0000, 'ºC'),
	(254587, 121, '2014-03-15 00:12:43.000000', 'temperatura', 1006.0000, 'ºC'),
	(254588, 121, '2014-03-15 00:12:44.000000', 'temperatura', 625.0000, 'ºC'),
	(254589, 121, '2014-03-15 00:12:45.000000', 'temperatura', 109.0000, 'ºC'),
	(254590, 121, '2014-03-15 00:12:46.000000', 'temperatura', 1070.0000, 'ºC'),
	(254591, 121, '2014-03-15 00:12:47.000000', 'temperatura', 225.0000, 'ºC'),
	(254592, 121, '2014-03-15 00:12:48.000000', 'temperatura', 315.0000, 'ºC'),
	(254593, 121, '2014-03-15 00:12:49.000000', 'temperatura', 898.0000, 'ºC'),
	(254594, 121, '2014-03-15 00:12:50.000000', 'temperatura', 1146.0000, 'ºC'),
	(254595, 121, '2014-03-15 00:12:51.000000', 'temperatura', 639.0000, 'ºC'),
	(254596, 121, '2014-03-15 00:12:52.000000', 'temperatura', 954.0000, 'ºC'),
	(254597, 121, '2014-03-15 00:12:53.000000', 'temperatura', 457.0000, 'ºC'),
	(254598, 121, '2014-03-15 00:12:54.000000', 'temperatura', 622.0000, 'ºC'),
	(254599, 121, '2014-03-15 00:12:55.000000', 'temperatura', 540.0000, 'ºC'),
	(254600, 121, '2014-03-15 00:12:56.000000', 'temperatura', 836.0000, 'ºC'),
	(254601, 121, '2014-03-15 00:12:57.000000', 'temperatura', 161.0000, 'ºC'),
	(254602, 121, '2014-03-15 00:12:58.000000', 'temperatura', 695.0000, 'ºC'),
	(254603, 121, '2014-03-15 00:12:59.000000', 'temperatura', 595.0000, 'ºC'),
	(254604, 121, '2014-03-15 00:13:00.000000', 'temperatura', 891.0000, 'ºC'),
	(254605, 121, '2014-03-15 00:13:01.000000', 'temperatura', 269.0000, 'ºC'),
	(254606, 121, '2014-03-15 00:13:02.000000', 'temperatura', 1075.0000, 'ºC'),
	(254607, 121, '2014-03-15 00:13:03.000000', 'temperatura', 966.0000, 'ºC'),
	(254608, 121, '2014-03-15 00:13:04.000000', 'temperatura', 408.0000, 'ºC'),
	(254609, 121, '2014-03-15 00:13:05.000000', 'temperatura', 341.0000, 'ºC'),
	(254610, 121, '2014-03-15 00:13:06.000000', 'temperatura', 481.0000, 'ºC'),
	(254611, 121, '2014-03-15 00:13:07.000000', 'temperatura', 185.0000, 'ºC'),
	(254612, 121, '2014-03-15 00:13:08.000000', 'temperatura', 680.0000, 'ºC'),
	(254613, 121, '2014-03-15 00:13:09.000000', 'temperatura', 448.0000, 'ºC'),
	(254614, 121, '2014-03-15 00:13:10.000000', 'temperatura', 199.0000, 'ºC'),
	(254615, 121, '2014-03-15 00:13:11.000000', 'temperatura', 854.0000, 'ºC'),
	(254616, 121, '2014-03-15 00:13:12.000000', 'temperatura', 71.0000, 'ºC'),
	(254617, 121, '2014-03-15 00:13:13.000000', 'temperatura', 195.0000, 'ºC'),
	(254618, 121, '2014-03-15 00:13:14.000000', 'temperatura', 762.0000, 'ºC'),
	(254619, 121, '2014-03-15 00:13:15.000000', 'temperatura', 827.0000, 'ºC'),
	(254620, 121, '2014-03-15 00:13:16.000000', 'temperatura', 647.0000, 'ºC'),
	(254621, 121, '2014-03-15 00:13:17.000000', 'temperatura', 756.0000, 'ºC'),
	(254622, 121, '2014-03-15 00:13:18.000000', 'temperatura', 641.0000, 'ºC'),
	(254623, 121, '2014-03-15 00:13:19.000000', 'temperatura', 935.0000, 'ºC'),
	(254624, 121, '2014-03-15 00:13:20.000000', 'temperatura', 354.0000, 'ºC'),
	(254625, 121, '2014-03-15 00:13:21.000000', 'temperatura', 165.0000, 'ºC'),
	(254626, 121, '2014-03-15 00:13:22.000000', 'temperatura', 964.0000, 'ºC'),
	(254627, 121, '2014-03-15 00:13:23.000000', 'temperatura', 726.0000, 'ºC'),
	(254628, 121, '2014-03-15 00:13:24.000000', 'temperatura', 739.0000, 'ºC'),
	(254629, 121, '2014-03-15 00:13:25.000000', 'temperatura', 319.0000, 'ºC'),
	(254630, 121, '2014-03-15 00:13:26.000000', 'temperatura', 576.0000, 'ºC'),
	(254631, 121, '2014-03-15 00:13:27.000000', 'temperatura', 726.0000, 'ºC'),
	(254632, 121, '2014-03-15 00:13:28.000000', 'temperatura', 702.0000, 'ºC'),
	(254633, 121, '2014-03-15 00:13:29.000000', 'temperatura', 131.0000, 'ºC'),
	(254634, 121, '2014-03-15 00:13:30.000000', 'temperatura', 952.0000, 'ºC'),
	(254635, 121, '2014-03-15 00:13:31.000000', 'temperatura', 765.0000, 'ºC'),
	(254636, 121, '2014-03-15 00:13:32.000000', 'temperatura', 969.0000, 'ºC'),
	(254637, 121, '2014-03-15 00:13:33.000000', 'temperatura', 149.0000, 'ºC'),
	(254638, 121, '2014-03-15 00:13:34.000000', 'temperatura', 242.0000, 'ºC'),
	(254639, 121, '2014-03-15 00:13:35.000000', 'temperatura', 760.0000, 'ºC'),
	(254640, 121, '2014-03-15 00:13:36.000000', 'temperatura', 677.0000, 'ºC'),
	(254641, 121, '2014-03-15 00:13:37.000000', 'temperatura', 1105.0000, 'ºC'),
	(254642, 121, '2014-03-15 00:13:38.000000', 'temperatura', 1094.0000, 'ºC'),
	(254643, 121, '2014-03-15 00:13:39.000000', 'temperatura', 954.0000, 'ºC'),
	(254644, 121, '2014-03-15 00:13:40.000000', 'temperatura', 290.0000, 'ºC'),
	(254645, 121, '2014-03-15 00:13:41.000000', 'temperatura', 990.0000, 'ºC'),
	(254646, 121, '2014-03-15 00:13:42.000000', 'temperatura', 481.0000, 'ºC'),
	(254647, 121, '2014-03-15 00:13:43.000000', 'temperatura', 635.0000, 'ºC'),
	(254648, 121, '2014-03-15 00:13:44.000000', 'temperatura', 531.0000, 'ºC'),
	(254649, 121, '2014-03-15 00:13:45.000000', 'temperatura', 752.0000, 'ºC'),
	(254650, 121, '2014-03-15 00:13:46.000000', 'temperatura', 966.0000, 'ºC'),
	(254651, 121, '2014-03-15 00:13:47.000000', 'temperatura', 174.0000, 'ºC'),
	(254652, 121, '2014-03-15 00:13:48.000000', 'temperatura', 371.0000, 'ºC'),
	(254653, 121, '2014-03-15 00:13:49.000000', 'temperatura', 136.0000, 'ºC'),
	(254654, 121, '2014-03-15 00:13:50.000000', 'temperatura', 768.0000, 'ºC'),
	(254655, 121, '2014-03-15 00:13:51.000000', 'temperatura', 1030.0000, 'ºC'),
	(254656, 121, '2014-03-15 00:13:52.000000', 'temperatura', 448.0000, 'ºC'),
	(254657, 121, '2014-03-15 00:13:53.000000', 'temperatura', 352.0000, 'ºC'),
	(254658, 121, '2014-03-15 00:13:54.000000', 'temperatura', 413.0000, 'ºC'),
	(254659, 121, '2014-03-15 00:13:55.000000', 'temperatura', 1012.0000, 'ºC'),
	(254660, 121, '2014-03-15 00:13:56.000000', 'temperatura', 223.0000, 'ºC'),
	(254661, 121, '2014-03-15 00:13:57.000000', 'temperatura', 478.0000, 'ºC'),
	(254662, 121, '2014-03-15 00:13:58.000000', 'temperatura', 522.0000, 'ºC'),
	(254663, 121, '2014-03-15 00:13:59.000000', 'temperatura', 1176.0000, 'ºC'),
	(254664, 121, '2014-03-15 00:14:00.000000', 'temperatura', 716.0000, 'ºC'),
	(254665, 121, '2014-03-15 00:14:01.000000', 'temperatura', 51.0000, 'ºC'),
	(254666, 121, '2014-03-15 00:14:02.000000', 'temperatura', 509.0000, 'ºC'),
	(254667, 121, '2014-03-15 00:14:03.000000', 'temperatura', 1193.0000, 'ºC'),
	(254668, 121, '2014-03-15 00:14:04.000000', 'temperatura', 837.0000, 'ºC'),
	(254669, 121, '2014-03-15 00:14:05.000000', 'temperatura', 608.0000, 'ºC'),
	(254670, 121, '2014-03-15 00:14:06.000000', 'temperatura', 527.0000, 'ºC'),
	(254671, 121, '2014-03-15 00:14:07.000000', 'temperatura', 814.0000, 'ºC'),
	(254672, 121, '2014-03-15 00:14:08.000000', 'temperatura', 88.0000, 'ºC'),
	(254673, 121, '2014-03-15 00:14:09.000000', 'temperatura', 398.0000, 'ºC'),
	(254674, 121, '2014-03-15 00:14:10.000000', 'temperatura', 526.0000, 'ºC'),
	(254675, 121, '2014-03-15 00:14:11.000000', 'temperatura', 237.0000, 'ºC'),
	(254676, 121, '2014-03-15 00:14:12.000000', 'temperatura', 809.0000, 'ºC'),
	(254677, 121, '2014-03-15 00:14:13.000000', 'temperatura', 934.0000, 'ºC'),
	(254678, 121, '2014-03-15 00:14:14.000000', 'temperatura', 1042.0000, 'ºC'),
	(254679, 121, '2014-03-15 00:14:15.000000', 'temperatura', 11.0000, 'ºC'),
	(254680, 121, '2014-03-15 00:14:16.000000', 'temperatura', 529.0000, 'ºC'),
	(254681, 121, '2014-03-15 00:14:17.000000', 'temperatura', 213.0000, 'ºC'),
	(254682, 121, '2014-03-15 00:14:18.000000', 'temperatura', 678.0000, 'ºC'),
	(254683, 121, '2014-03-15 00:14:19.000000', 'temperatura', 353.0000, 'ºC'),
	(254684, 121, '2014-03-15 00:14:20.000000', 'temperatura', 931.0000, 'ºC'),
	(254685, 121, '2014-03-15 00:14:21.000000', 'temperatura', 1195.0000, 'ºC'),
	(254686, 121, '2014-03-15 00:14:22.000000', 'temperatura', 782.0000, 'ºC'),
	(254687, 121, '2014-03-15 00:14:23.000000', 'temperatura', 324.0000, 'ºC'),
	(254688, 121, '2014-03-15 00:14:24.000000', 'temperatura', 477.0000, 'ºC'),
	(254689, 121, '2014-03-15 00:14:25.000000', 'temperatura', 213.0000, 'ºC'),
	(254690, 121, '2014-03-15 00:14:26.000000', 'temperatura', 836.0000, 'ºC'),
	(254691, 121, '2014-03-15 00:14:27.000000', 'temperatura', 1139.0000, 'ºC'),
	(254692, 121, '2014-03-15 00:14:28.000000', 'temperatura', 788.0000, 'ºC'),
	(254693, 121, '2014-03-15 00:14:29.000000', 'temperatura', 524.0000, 'ºC'),
	(254694, 121, '2014-03-15 00:14:30.000000', 'temperatura', 258.0000, 'ºC'),
	(254695, 121, '2014-03-15 00:14:31.000000', 'temperatura', 917.0000, 'ºC'),
	(254696, 121, '2014-03-15 00:14:32.000000', 'temperatura', 213.0000, 'ºC'),
	(254697, 121, '2014-03-15 00:14:33.000000', 'temperatura', 712.0000, 'ºC'),
	(254698, 121, '2014-03-15 00:14:34.000000', 'temperatura', 521.0000, 'ºC'),
	(254699, 121, '2014-03-15 00:14:35.000000', 'temperatura', 471.0000, 'ºC'),
	(254700, 121, '2014-03-15 00:14:36.000000', 'temperatura', 793.0000, 'ºC'),
	(254701, 121, '2014-03-15 00:14:37.000000', 'temperatura', 152.0000, 'ºC'),
	(254702, 121, '2014-03-15 00:14:38.000000', 'temperatura', 780.0000, 'ºC'),
	(254703, 121, '2014-03-15 00:14:39.000000', 'temperatura', 1046.0000, 'ºC'),
	(254704, 121, '2014-03-15 00:14:40.000000', 'temperatura', 490.0000, 'ºC'),
	(254705, 121, '2014-03-15 00:14:41.000000', 'temperatura', 514.0000, 'ºC'),
	(254706, 121, '2014-03-15 00:14:42.000000', 'temperatura', 1098.0000, 'ºC'),
	(254707, 121, '2014-03-15 00:14:43.000000', 'temperatura', 348.0000, 'ºC'),
	(254708, 121, '2014-03-15 00:14:44.000000', 'temperatura', 848.0000, 'ºC'),
	(254709, 121, '2014-03-15 00:14:45.000000', 'temperatura', 796.0000, 'ºC'),
	(254710, 121, '2014-03-15 00:14:46.000000', 'temperatura', 235.0000, 'ºC'),
	(254711, 121, '2014-03-15 00:14:47.000000', 'temperatura', 1189.0000, 'ºC'),
	(254712, 121, '2014-03-15 00:14:48.000000', 'temperatura', 441.0000, 'ºC'),
	(254713, 121, '2014-03-15 00:14:49.000000', 'temperatura', 1040.0000, 'ºC'),
	(254714, 121, '2014-03-15 00:14:50.000000', 'temperatura', 274.0000, 'ºC'),
	(254715, 121, '2014-03-15 00:14:51.000000', 'temperatura', 652.0000, 'ºC'),
	(254716, 121, '2014-03-15 00:14:52.000000', 'temperatura', 37.0000, 'ºC'),
	(254717, 121, '2014-03-15 00:14:53.000000', 'temperatura', 632.0000, 'ºC'),
	(254718, 121, '2014-03-15 00:14:54.000000', 'temperatura', 648.0000, 'ºC'),
	(254719, 121, '2014-03-15 00:14:55.000000', 'temperatura', 145.0000, 'ºC'),
	(254720, 121, '2014-03-15 00:14:56.000000', 'temperatura', 1182.0000, 'ºC'),
	(254721, 121, '2014-03-15 00:14:57.000000', 'temperatura', 676.0000, 'ºC'),
	(254722, 121, '2014-03-15 00:14:58.000000', 'temperatura', 1033.0000, 'ºC'),
	(254723, 121, '2014-03-15 00:14:59.000000', 'temperatura', 739.0000, 'ºC'),
	(254724, 121, '2014-03-15 00:15:00.000000', 'temperatura', 594.0000, 'ºC'),
	(254725, 121, '2014-03-15 00:15:01.000000', 'temperatura', 754.0000, 'ºC'),
	(254726, 121, '2014-03-15 00:15:02.000000', 'temperatura', 790.0000, 'ºC'),
	(254727, 121, '2014-03-15 00:15:03.000000', 'temperatura', 489.0000, 'ºC'),
	(254728, 121, '2014-03-15 00:15:04.000000', 'temperatura', 75.0000, 'ºC'),
	(254729, 121, '2014-03-15 00:15:05.000000', 'temperatura', 107.0000, 'ºC'),
	(254730, 121, '2014-03-15 00:15:06.000000', 'temperatura', 310.0000, 'ºC'),
	(254731, 121, '2014-03-15 00:15:07.000000', 'temperatura', 30.0000, 'ºC'),
	(254732, 121, '2014-03-15 00:15:08.000000', 'temperatura', 422.0000, 'ºC'),
	(254733, 121, '2014-03-15 00:15:09.000000', 'temperatura', 822.0000, 'ºC'),
	(254734, 121, '2014-03-15 00:15:10.000000', 'temperatura', 442.0000, 'ºC'),
	(254735, 121, '2014-03-15 00:15:11.000000', 'temperatura', 945.0000, 'ºC'),
	(254736, 121, '2014-03-15 00:15:12.000000', 'temperatura', 1000.0000, 'ºC'),
	(254737, 121, '2014-03-15 00:15:13.000000', 'temperatura', 967.0000, 'ºC'),
	(254738, 121, '2014-03-15 00:15:14.000000', 'temperatura', 635.0000, 'ºC'),
	(254739, 121, '2014-03-15 00:15:15.000000', 'temperatura', 275.0000, 'ºC'),
	(254740, 121, '2014-03-15 00:15:16.000000', 'temperatura', 669.0000, 'ºC'),
	(254741, 121, '2014-03-15 00:15:17.000000', 'temperatura', 123.0000, 'ºC'),
	(254742, 121, '2014-03-15 00:15:18.000000', 'temperatura', 1007.0000, 'ºC'),
	(254743, 121, '2014-03-15 00:15:19.000000', 'temperatura', 1068.0000, 'ºC'),
	(254744, 121, '2014-03-15 00:15:20.000000', 'temperatura', 1119.0000, 'ºC'),
	(254745, 121, '2014-03-15 00:15:21.000000', 'temperatura', 1190.0000, 'ºC'),
	(254746, 121, '2014-03-15 00:15:22.000000', 'temperatura', 192.0000, 'ºC'),
	(254747, 121, '2014-03-15 00:15:23.000000', 'temperatura', 993.0000, 'ºC'),
	(254748, 121, '2014-03-15 00:15:24.000000', 'temperatura', 789.0000, 'ºC'),
	(254749, 121, '2014-03-15 00:15:25.000000', 'temperatura', 966.0000, 'ºC'),
	(254750, 121, '2014-03-15 00:15:26.000000', 'temperatura', 65.0000, 'ºC'),
	(254751, 121, '2014-03-15 00:15:27.000000', 'temperatura', 1026.0000, 'ºC'),
	(254752, 121, '2014-03-15 00:15:28.000000', 'temperatura', 137.0000, 'ºC'),
	(254753, 121, '2014-03-15 00:15:29.000000', 'temperatura', 7.0000, 'ºC'),
	(254754, 121, '2014-03-15 00:15:30.000000', 'temperatura', 823.0000, 'ºC'),
	(254755, 121, '2014-03-15 00:15:31.000000', 'temperatura', 493.0000, 'ºC'),
	(254756, 121, '2014-03-15 00:15:32.000000', 'temperatura', 0.0000, 'ºC'),
	(254757, 121, '2014-03-15 00:15:33.000000', 'temperatura', 919.0000, 'ºC'),
	(254758, 121, '2014-03-15 00:15:34.000000', 'temperatura', 997.0000, 'ºC'),
	(254759, 121, '2014-03-15 00:15:35.000000', 'temperatura', 1026.0000, 'ºC'),
	(254760, 121, '2014-03-15 00:15:36.000000', 'temperatura', 941.0000, 'ºC'),
	(254761, 121, '2014-03-15 00:15:37.000000', 'temperatura', 426.0000, 'ºC'),
	(254762, 121, '2014-03-15 00:15:38.000000', 'temperatura', 510.0000, 'ºC'),
	(254763, 121, '2014-03-15 00:15:39.000000', 'temperatura', 71.0000, 'ºC'),
	(254764, 121, '2014-03-15 00:15:40.000000', 'temperatura', 25.0000, 'ºC'),
	(254765, 121, '2014-03-15 00:15:41.000000', 'temperatura', 1114.0000, 'ºC'),
	(254766, 121, '2014-03-15 00:15:42.000000', 'temperatura', 696.0000, 'ºC'),
	(254767, 121, '2014-03-15 00:15:43.000000', 'temperatura', 136.0000, 'ºC'),
	(254768, 121, '2014-03-15 00:15:44.000000', 'temperatura', 993.0000, 'ºC'),
	(254769, 121, '2014-03-15 00:15:45.000000', 'temperatura', 959.0000, 'ºC'),
	(254770, 121, '2014-03-15 00:15:46.000000', 'temperatura', 616.0000, 'ºC'),
	(254771, 121, '2014-03-15 00:15:47.000000', 'temperatura', 204.0000, 'ºC'),
	(254772, 121, '2014-03-15 00:15:48.000000', 'temperatura', 372.0000, 'ºC'),
	(254773, 121, '2014-03-15 00:15:49.000000', 'temperatura', 48.0000, 'ºC'),
	(254774, 121, '2014-03-15 00:15:50.000000', 'temperatura', 326.0000, 'ºC'),
	(254775, 121, '2014-03-15 00:15:51.000000', 'temperatura', 285.0000, 'ºC'),
	(254776, 121, '2014-03-15 00:15:52.000000', 'temperatura', 448.0000, 'ºC'),
	(254777, 121, '2014-03-15 00:15:53.000000', 'temperatura', 188.0000, 'ºC'),
	(254778, 121, '2014-03-15 00:15:54.000000', 'temperatura', 793.0000, 'ºC'),
	(254779, 121, '2014-03-15 00:15:55.000000', 'temperatura', 1002.0000, 'ºC'),
	(254780, 121, '2014-03-15 00:15:56.000000', 'temperatura', 231.0000, 'ºC'),
	(254781, 121, '2014-03-15 00:15:57.000000', 'temperatura', 552.0000, 'ºC'),
	(254782, 121, '2014-03-15 00:15:58.000000', 'temperatura', 866.0000, 'ºC'),
	(254783, 121, '2014-03-15 00:15:59.000000', 'temperatura', 274.0000, 'ºC'),
	(254784, 121, '2014-03-15 00:16:00.000000', 'temperatura', 1174.0000, 'ºC'),
	(254785, 121, '2014-03-15 00:16:01.000000', 'temperatura', 247.0000, 'ºC'),
	(254786, 121, '2014-03-15 00:16:02.000000', 'temperatura', 114.0000, 'ºC'),
	(254787, 121, '2014-03-15 00:16:03.000000', 'temperatura', 1031.0000, 'ºC'),
	(254788, 121, '2014-03-15 00:16:04.000000', 'temperatura', 13.0000, 'ºC'),
	(254789, 121, '2014-03-15 00:16:05.000000', 'temperatura', 571.0000, 'ºC'),
	(254790, 121, '2014-03-15 00:16:06.000000', 'temperatura', 418.0000, 'ºC'),
	(254791, 121, '2014-03-15 00:16:07.000000', 'temperatura', 377.0000, 'ºC'),
	(254792, 121, '2014-03-15 00:16:08.000000', 'temperatura', 631.0000, 'ºC'),
	(254793, 121, '2014-03-15 00:16:09.000000', 'temperatura', 827.0000, 'ºC'),
	(254794, 121, '2014-03-15 00:16:10.000000', 'temperatura', 1040.0000, 'ºC'),
	(254795, 121, '2014-03-15 00:16:11.000000', 'temperatura', 318.0000, 'ºC'),
	(254796, 121, '2014-03-15 00:16:12.000000', 'temperatura', 873.0000, 'ºC'),
	(254797, 121, '2014-03-15 00:16:13.000000', 'temperatura', 1009.0000, 'ºC'),
	(254798, 121, '2014-03-15 00:16:14.000000', 'temperatura', 29.0000, 'ºC'),
	(254799, 121, '2014-03-15 00:16:15.000000', 'temperatura', 718.0000, 'ºC'),
	(254800, 121, '2014-03-15 00:16:16.000000', 'temperatura', 1103.0000, 'ºC'),
	(254801, 121, '2014-03-15 00:16:17.000000', 'temperatura', 962.0000, 'ºC'),
	(254802, 121, '2014-03-15 00:16:18.000000', 'temperatura', 300.0000, 'ºC'),
	(254803, 121, '2014-03-15 00:16:19.000000', 'temperatura', 1017.0000, 'ºC'),
	(254804, 121, '2014-03-15 00:16:20.000000', 'temperatura', 586.0000, 'ºC'),
	(254805, 121, '2014-03-15 00:16:21.000000', 'temperatura', 1079.0000, 'ºC'),
	(254806, 121, '2014-03-15 00:16:22.000000', 'temperatura', 36.0000, 'ºC'),
	(254807, 121, '2014-03-15 00:16:23.000000', 'temperatura', 546.0000, 'ºC'),
	(254808, 121, '2014-03-15 00:16:24.000000', 'temperatura', 220.0000, 'ºC'),
	(254809, 121, '2014-03-15 00:16:25.000000', 'temperatura', 663.0000, 'ºC'),
	(254810, 121, '2014-03-15 00:16:26.000000', 'temperatura', 256.0000, 'ºC'),
	(254811, 121, '2014-03-15 00:16:27.000000', 'temperatura', 493.0000, 'ºC'),
	(254812, 121, '2014-03-15 00:16:28.000000', 'temperatura', 497.0000, 'ºC'),
	(254813, 121, '2014-03-15 00:16:29.000000', 'temperatura', 1004.0000, 'ºC'),
	(254814, 121, '2014-03-15 00:16:30.000000', 'temperatura', 1132.0000, 'ºC'),
	(254815, 121, '2014-03-15 00:16:31.000000', 'temperatura', 250.0000, 'ºC'),
	(254816, 121, '2014-03-15 00:16:32.000000', 'temperatura', 251.0000, 'ºC'),
	(254817, 121, '2014-03-15 00:16:33.000000', 'temperatura', 509.0000, 'ºC'),
	(254818, 121, '2014-03-15 00:16:34.000000', 'temperatura', 591.0000, 'ºC'),
	(254819, 121, '2014-03-15 00:16:35.000000', 'temperatura', 228.0000, 'ºC'),
	(254820, 121, '2014-03-15 00:16:36.000000', 'temperatura', 566.0000, 'ºC'),
	(254821, 121, '2014-03-15 00:16:37.000000', 'temperatura', 949.0000, 'ºC'),
	(254822, 121, '2014-03-15 00:16:38.000000', 'temperatura', 648.0000, 'ºC'),
	(254823, 121, '2014-03-15 00:16:39.000000', 'temperatura', 394.0000, 'ºC'),
	(254824, 121, '2014-03-15 00:16:40.000000', 'temperatura', 23.0000, 'ºC'),
	(254825, 121, '2014-03-15 00:16:41.000000', 'temperatura', 137.0000, 'ºC'),
	(254826, 121, '2014-03-15 00:16:42.000000', 'temperatura', 617.0000, 'ºC'),
	(254827, 121, '2014-03-15 00:16:43.000000', 'temperatura', 272.0000, 'ºC'),
	(254828, 121, '2014-03-15 00:16:44.000000', 'temperatura', 711.0000, 'ºC'),
	(254829, 121, '2014-03-15 00:16:45.000000', 'temperatura', 338.0000, 'ºC'),
	(254830, 121, '2014-03-15 00:16:46.000000', 'temperatura', 758.0000, 'ºC'),
	(254831, 121, '2014-03-15 00:16:47.000000', 'temperatura', 375.0000, 'ºC'),
	(254832, 121, '2014-03-15 00:16:48.000000', 'temperatura', 803.0000, 'ºC'),
	(254833, 121, '2014-03-15 00:16:49.000000', 'temperatura', 492.0000, 'ºC'),
	(254834, 121, '2014-03-15 00:16:50.000000', 'temperatura', 52.0000, 'ºC'),
	(254835, 121, '2014-03-15 00:16:51.000000', 'temperatura', 1182.0000, 'ºC'),
	(254836, 121, '2014-03-15 00:16:52.000000', 'temperatura', 955.0000, 'ºC'),
	(254837, 121, '2014-03-15 00:16:53.000000', 'temperatura', 29.0000, 'ºC'),
	(254838, 121, '2014-03-15 00:16:54.000000', 'temperatura', 879.0000, 'ºC'),
	(254839, 121, '2014-03-15 00:16:55.000000', 'temperatura', 712.0000, 'ºC'),
	(254840, 121, '2014-03-15 00:16:56.000000', 'temperatura', 922.0000, 'ºC'),
	(254841, 121, '2014-03-15 00:16:57.000000', 'temperatura', 76.0000, 'ºC'),
	(254842, 121, '2014-03-15 00:16:58.000000', 'temperatura', 12.0000, 'ºC'),
	(254843, 121, '2014-03-15 00:16:59.000000', 'temperatura', 1034.0000, 'ºC'),
	(254844, 121, '2014-03-15 00:17:00.000000', 'temperatura', 335.0000, 'ºC'),
	(254845, 121, '2014-03-15 00:17:01.000000', 'temperatura', 973.0000, 'ºC'),
	(254846, 121, '2014-03-15 00:17:02.000000', 'temperatura', 259.0000, 'ºC'),
	(254847, 121, '2014-03-15 00:17:03.000000', 'temperatura', 779.0000, 'ºC'),
	(254848, 121, '2014-03-15 00:17:04.000000', 'temperatura', 718.0000, 'ºC'),
	(254849, 121, '2014-03-15 00:17:05.000000', 'temperatura', 51.0000, 'ºC'),
	(254850, 121, '2014-03-15 00:17:06.000000', 'temperatura', 504.0000, 'ºC'),
	(254851, 121, '2014-03-15 00:17:07.000000', 'temperatura', 1167.0000, 'ºC'),
	(254852, 121, '2014-03-15 00:17:08.000000', 'temperatura', 724.0000, 'ºC'),
	(254853, 121, '2014-03-15 00:17:09.000000', 'temperatura', 120.0000, 'ºC'),
	(254854, 121, '2014-03-15 00:17:10.000000', 'temperatura', 827.0000, 'ºC'),
	(254855, 121, '2014-03-15 00:17:11.000000', 'temperatura', 175.0000, 'ºC'),
	(254856, 121, '2014-03-15 00:17:12.000000', 'temperatura', 797.0000, 'ºC'),
	(254857, 121, '2014-03-15 00:17:13.000000', 'temperatura', 1060.0000, 'ºC'),
	(254858, 121, '2014-03-15 00:17:14.000000', 'temperatura', 509.0000, 'ºC'),
	(254859, 121, '2014-03-15 00:17:15.000000', 'temperatura', 566.0000, 'ºC'),
	(254860, 121, '2014-03-15 00:17:16.000000', 'temperatura', 101.0000, 'ºC'),
	(254861, 121, '2014-03-15 00:17:17.000000', 'temperatura', 10.0000, 'ºC'),
	(254862, 121, '2014-03-15 00:17:18.000000', 'temperatura', 947.0000, 'ºC'),
	(254863, 121, '2014-03-15 00:17:19.000000', 'temperatura', 1103.0000, 'ºC'),
	(254864, 121, '2014-03-15 00:17:20.000000', 'temperatura', 278.0000, 'ºC'),
	(254865, 121, '2014-03-15 00:17:21.000000', 'temperatura', 479.0000, 'ºC'),
	(254866, 121, '2014-03-15 00:17:22.000000', 'temperatura', 363.0000, 'ºC'),
	(254867, 121, '2014-03-15 00:17:23.000000', 'temperatura', 379.0000, 'ºC'),
	(254868, 121, '2014-03-15 00:17:24.000000', 'temperatura', 805.0000, 'ºC'),
	(254869, 121, '2014-03-15 00:17:25.000000', 'temperatura', 489.0000, 'ºC'),
	(254870, 121, '2014-03-15 00:17:26.000000', 'temperatura', 31.0000, 'ºC'),
	(254871, 121, '2014-03-15 00:17:27.000000', 'temperatura', 1087.0000, 'ºC'),
	(254872, 121, '2014-03-15 00:17:28.000000', 'temperatura', 543.0000, 'ºC'),
	(254873, 121, '2014-03-15 00:17:29.000000', 'temperatura', 655.0000, 'ºC'),
	(254874, 121, '2014-03-15 00:17:30.000000', 'temperatura', 447.0000, 'ºC'),
	(254875, 121, '2014-03-15 00:17:31.000000', 'temperatura', 271.0000, 'ºC'),
	(254876, 121, '2014-03-15 00:17:32.000000', 'temperatura', 15.0000, 'ºC'),
	(254877, 121, '2014-03-15 00:17:33.000000', 'temperatura', 460.0000, 'ºC'),
	(254878, 121, '2014-03-15 00:17:34.000000', 'temperatura', 1057.0000, 'ºC'),
	(254879, 121, '2014-03-15 00:17:35.000000', 'temperatura', 304.0000, 'ºC'),
	(254880, 121, '2014-03-15 00:17:36.000000', 'temperatura', 751.0000, 'ºC'),
	(254881, 121, '2014-03-15 00:17:37.000000', 'temperatura', 443.0000, 'ºC'),
	(254882, 121, '2014-03-15 00:17:38.000000', 'temperatura', 1161.0000, 'ºC'),
	(254883, 121, '2014-03-15 00:17:39.000000', 'temperatura', 876.0000, 'ºC'),
	(254884, 121, '2014-03-15 00:17:40.000000', 'temperatura', 901.0000, 'ºC'),
	(254885, 121, '2014-03-15 00:17:41.000000', 'temperatura', 674.0000, 'ºC'),
	(254886, 121, '2014-03-15 00:17:42.000000', 'temperatura', 670.0000, 'ºC'),
	(254887, 121, '2014-03-15 00:17:43.000000', 'temperatura', 130.0000, 'ºC'),
	(254888, 121, '2014-03-15 00:17:44.000000', 'temperatura', 1037.0000, 'ºC'),
	(254889, 121, '2014-03-15 00:17:45.000000', 'temperatura', 1198.0000, 'ºC'),
	(254890, 121, '2014-03-15 00:17:46.000000', 'temperatura', 481.0000, 'ºC'),
	(254891, 121, '2014-03-15 00:17:47.000000', 'temperatura', 9.0000, 'ºC'),
	(254892, 121, '2014-03-15 00:17:48.000000', 'temperatura', 1002.0000, 'ºC'),
	(254893, 121, '2014-03-15 00:17:49.000000', 'temperatura', 183.0000, 'ºC'),
	(254894, 121, '2014-03-15 00:17:50.000000', 'temperatura', 310.0000, 'ºC'),
	(254895, 121, '2014-03-15 00:17:51.000000', 'temperatura', 1001.0000, 'ºC'),
	(254896, 121, '2014-03-15 00:17:52.000000', 'temperatura', 477.0000, 'ºC'),
	(254897, 121, '2014-03-15 00:17:53.000000', 'temperatura', 584.0000, 'ºC'),
	(254898, 121, '2014-03-15 00:17:54.000000', 'temperatura', 286.0000, 'ºC'),
	(254899, 121, '2014-03-15 00:17:55.000000', 'temperatura', 881.0000, 'ºC'),
	(254900, 121, '2014-03-15 00:17:56.000000', 'temperatura', 1149.0000, 'ºC'),
	(254901, 121, '2014-03-15 00:17:57.000000', 'temperatura', 699.0000, 'ºC'),
	(254902, 121, '2014-03-15 00:17:58.000000', 'temperatura', 51.0000, 'ºC'),
	(254903, 121, '2014-03-15 00:17:59.000000', 'temperatura', 557.0000, 'ºC'),
	(254904, 121, '2014-03-15 00:18:00.000000', 'temperatura', 232.0000, 'ºC'),
	(254905, 121, '2014-03-15 00:18:01.000000', 'temperatura', 689.0000, 'ºC'),
	(254906, 121, '2014-03-15 00:18:02.000000', 'temperatura', 352.0000, 'ºC'),
	(254907, 121, '2014-03-15 00:18:03.000000', 'temperatura', 891.0000, 'ºC'),
	(254908, 121, '2014-03-15 00:18:04.000000', 'temperatura', 1000.0000, 'ºC'),
	(254909, 121, '2014-03-15 00:18:05.000000', 'temperatura', 1128.0000, 'ºC'),
	(254910, 121, '2014-03-15 00:18:06.000000', 'temperatura', 241.0000, 'ºC'),
	(254911, 121, '2014-03-15 00:18:07.000000', 'temperatura', 220.0000, 'ºC'),
	(254912, 121, '2014-03-15 00:18:08.000000', 'temperatura', 380.0000, 'ºC'),
	(254913, 121, '2014-03-15 00:18:09.000000', 'temperatura', 38.0000, 'ºC'),
	(254914, 121, '2014-03-15 00:18:10.000000', 'temperatura', 254.0000, 'ºC'),
	(254915, 121, '2014-03-15 00:18:11.000000', 'temperatura', 1153.0000, 'ºC'),
	(254916, 121, '2014-03-15 00:18:12.000000', 'temperatura', 203.0000, 'ºC'),
	(254917, 121, '2014-03-15 00:18:13.000000', 'temperatura', 1157.0000, 'ºC'),
	(254918, 121, '2014-03-15 00:18:14.000000', 'temperatura', 376.0000, 'ºC'),
	(254919, 121, '2014-03-15 00:18:15.000000', 'temperatura', 809.0000, 'ºC'),
	(254920, 121, '2014-03-15 00:18:16.000000', 'temperatura', 520.0000, 'ºC'),
	(254921, 121, '2014-03-15 00:18:17.000000', 'temperatura', 171.0000, 'ºC'),
	(254922, 121, '2014-03-15 00:18:18.000000', 'temperatura', 497.0000, 'ºC'),
	(254923, 121, '2014-03-15 00:18:19.000000', 'temperatura', 772.0000, 'ºC'),
	(254924, 121, '2014-03-15 00:18:20.000000', 'temperatura', 1171.0000, 'ºC'),
	(254925, 121, '2014-03-15 00:18:21.000000', 'temperatura', 1140.0000, 'ºC'),
	(254926, 121, '2014-03-15 00:18:22.000000', 'temperatura', 987.0000, 'ºC'),
	(254927, 121, '2014-03-15 00:18:23.000000', 'temperatura', 315.0000, 'ºC'),
	(254928, 121, '2014-03-15 00:18:24.000000', 'temperatura', 1014.0000, 'ºC'),
	(254929, 121, '2014-03-15 00:18:25.000000', 'temperatura', 526.0000, 'ºC'),
	(254930, 121, '2014-03-15 00:18:26.000000', 'temperatura', 788.0000, 'ºC'),
	(254931, 121, '2014-03-15 00:18:27.000000', 'temperatura', 1162.0000, 'ºC'),
	(254932, 121, '2014-03-15 00:18:28.000000', 'temperatura', 1048.0000, 'ºC'),
	(254933, 121, '2014-03-15 00:18:29.000000', 'temperatura', 554.0000, 'ºC'),
	(254934, 121, '2014-03-15 00:18:30.000000', 'temperatura', 828.0000, 'ºC'),
	(254935, 121, '2014-03-15 00:18:31.000000', 'temperatura', 77.0000, 'ºC'),
	(254936, 121, '2014-03-15 00:18:32.000000', 'temperatura', 301.0000, 'ºC'),
	(254937, 121, '2014-03-15 00:18:33.000000', 'temperatura', 76.0000, 'ºC'),
	(254938, 121, '2014-03-15 00:18:34.000000', 'temperatura', 678.0000, 'ºC'),
	(254939, 121, '2014-03-15 00:18:35.000000', 'temperatura', 762.0000, 'ºC'),
	(254940, 121, '2014-03-15 00:18:36.000000', 'temperatura', 577.0000, 'ºC'),
	(254941, 121, '2014-03-15 00:18:37.000000', 'temperatura', 597.0000, 'ºC'),
	(254942, 121, '2014-03-15 00:18:38.000000', 'temperatura', 56.0000, 'ºC'),
	(254943, 121, '2014-03-15 00:18:39.000000', 'temperatura', 891.0000, 'ºC'),
	(254944, 121, '2014-03-15 00:18:40.000000', 'temperatura', 687.0000, 'ºC'),
	(254945, 121, '2014-03-15 00:18:41.000000', 'temperatura', 761.0000, 'ºC'),
	(254946, 121, '2014-03-15 00:18:42.000000', 'temperatura', 547.0000, 'ºC'),
	(254947, 121, '2014-03-15 00:18:43.000000', 'temperatura', 450.0000, 'ºC'),
	(254948, 121, '2014-03-15 00:18:44.000000', 'temperatura', 612.0000, 'ºC'),
	(254949, 121, '2014-03-15 00:18:45.000000', 'temperatura', 509.0000, 'ºC'),
	(254950, 121, '2014-03-15 00:18:46.000000', 'temperatura', 710.0000, 'ºC'),
	(254951, 121, '2014-03-15 00:18:47.000000', 'temperatura', 824.0000, 'ºC'),
	(254952, 121, '2014-03-15 00:18:48.000000', 'temperatura', 792.0000, 'ºC'),
	(254953, 121, '2014-03-15 00:18:49.000000', 'temperatura', 287.0000, 'ºC'),
	(254954, 121, '2014-03-15 00:18:50.000000', 'temperatura', 260.0000, 'ºC'),
	(254955, 121, '2014-03-15 00:18:51.000000', 'temperatura', 440.0000, 'ºC'),
	(254956, 121, '2014-03-15 00:18:52.000000', 'temperatura', 221.0000, 'ºC'),
	(254957, 121, '2014-03-15 00:18:53.000000', 'temperatura', 983.0000, 'ºC'),
	(254958, 121, '2014-03-15 00:18:54.000000', 'temperatura', 654.0000, 'ºC'),
	(254959, 121, '2014-03-15 00:18:55.000000', 'temperatura', 320.0000, 'ºC'),
	(254960, 121, '2014-03-15 00:18:56.000000', 'temperatura', 838.0000, 'ºC'),
	(254961, 121, '2014-03-15 00:18:57.000000', 'temperatura', 833.0000, 'ºC'),
	(254962, 121, '2014-03-15 00:18:58.000000', 'temperatura', 449.0000, 'ºC'),
	(254963, 121, '2014-03-15 00:18:59.000000', 'temperatura', 946.0000, 'ºC'),
	(254964, 121, '2014-03-15 00:19:00.000000', 'temperatura', 985.0000, 'ºC'),
	(254965, 121, '2014-03-15 00:19:01.000000', 'temperatura', 888.0000, 'ºC'),
	(254966, 121, '2014-03-15 00:19:02.000000', 'temperatura', 285.0000, 'ºC'),
	(254967, 121, '2014-03-15 00:19:03.000000', 'temperatura', 1160.0000, 'ºC'),
	(254968, 121, '2014-03-15 00:19:04.000000', 'temperatura', 147.0000, 'ºC'),
	(254969, 121, '2014-03-15 00:19:05.000000', 'temperatura', 857.0000, 'ºC'),
	(254970, 121, '2014-03-15 00:19:06.000000', 'temperatura', 244.0000, 'ºC'),
	(254971, 121, '2014-03-15 00:19:07.000000', 'temperatura', 1049.0000, 'ºC'),
	(254972, 121, '2014-03-15 00:19:08.000000', 'temperatura', 915.0000, 'ºC'),
	(254973, 121, '2014-03-15 00:19:09.000000', 'temperatura', 226.0000, 'ºC'),
	(254974, 121, '2014-03-15 00:19:10.000000', 'temperatura', 785.0000, 'ºC'),
	(254975, 121, '2014-03-15 00:19:11.000000', 'temperatura', 847.0000, 'ºC'),
	(254976, 121, '2014-03-15 00:19:12.000000', 'temperatura', 681.0000, 'ºC'),
	(254977, 121, '2014-03-15 00:19:13.000000', 'temperatura', 865.0000, 'ºC'),
	(254978, 121, '2014-03-15 00:19:14.000000', 'temperatura', 1083.0000, 'ºC'),
	(254979, 121, '2014-03-15 00:19:15.000000', 'temperatura', 420.0000, 'ºC'),
	(254980, 121, '2014-03-15 00:19:16.000000', 'temperatura', 54.0000, 'ºC'),
	(254981, 121, '2014-03-15 00:19:17.000000', 'temperatura', 208.0000, 'ºC'),
	(254982, 121, '2014-03-15 00:19:18.000000', 'temperatura', 877.0000, 'ºC'),
	(254983, 121, '2014-03-15 00:19:19.000000', 'temperatura', 163.0000, 'ºC'),
	(254984, 121, '2014-03-15 00:19:20.000000', 'temperatura', 585.0000, 'ºC'),
	(254985, 121, '2014-03-15 00:19:21.000000', 'temperatura', 36.0000, 'ºC'),
	(254986, 121, '2014-03-15 00:19:22.000000', 'temperatura', 827.0000, 'ºC'),
	(254987, 121, '2014-03-15 00:19:23.000000', 'temperatura', 425.0000, 'ºC'),
	(254988, 121, '2014-03-15 00:19:24.000000', 'temperatura', 845.0000, 'ºC'),
	(254989, 121, '2014-03-15 00:19:25.000000', 'temperatura', 550.0000, 'ºC'),
	(254990, 121, '2014-03-15 00:19:26.000000', 'temperatura', 217.0000, 'ºC'),
	(254991, 121, '2014-03-15 00:19:27.000000', 'temperatura', 636.0000, 'ºC'),
	(254992, 121, '2014-03-15 00:19:28.000000', 'temperatura', 129.0000, 'ºC'),
	(254993, 121, '2014-03-15 00:19:29.000000', 'temperatura', 1137.0000, 'ºC'),
	(254994, 121, '2014-03-15 00:19:30.000000', 'temperatura', 499.0000, 'ºC'),
	(254995, 121, '2014-03-15 00:19:31.000000', 'temperatura', 286.0000, 'ºC'),
	(254996, 121, '2014-03-15 00:19:32.000000', 'temperatura', 1133.0000, 'ºC'),
	(254997, 121, '2014-03-15 00:19:33.000000', 'temperatura', 7.0000, 'ºC'),
	(254998, 121, '2014-03-15 00:19:34.000000', 'temperatura', 236.0000, 'ºC'),
	(254999, 121, '2014-03-15 00:19:35.000000', 'temperatura', 1162.0000, 'ºC'),
	(255000, 121, '2014-03-15 00:19:36.000000', 'temperatura', 300.0000, 'ºC'),
	(255001, 121, '2014-03-15 00:19:37.000000', 'temperatura', 414.0000, 'ºC'),
	(255002, 121, '2014-03-15 00:19:38.000000', 'temperatura', 1173.0000, 'ºC'),
	(255003, 121, '2014-03-15 00:19:39.000000', 'temperatura', 1024.0000, 'ºC'),
	(255004, 121, '2014-03-15 00:19:40.000000', 'temperatura', 399.0000, 'ºC'),
	(255005, 121, '2014-03-15 00:19:41.000000', 'temperatura', 125.0000, 'ºC'),
	(255006, 121, '2014-03-15 00:19:42.000000', 'temperatura', 627.0000, 'ºC'),
	(255007, 121, '2014-03-15 00:19:43.000000', 'temperatura', 360.0000, 'ºC'),
	(255008, 121, '2014-03-15 00:19:44.000000', 'temperatura', 1118.0000, 'ºC'),
	(255009, 121, '2014-03-15 00:19:45.000000', 'temperatura', 914.0000, 'ºC'),
	(255010, 121, '2014-03-15 00:19:46.000000', 'temperatura', 15.0000, 'ºC'),
	(255011, 121, '2014-03-15 00:19:47.000000', 'temperatura', 934.0000, 'ºC'),
	(255012, 121, '2014-03-15 00:19:48.000000', 'temperatura', 1023.0000, 'ºC'),
	(255013, 121, '2014-03-15 00:19:49.000000', 'temperatura', 1116.0000, 'ºC'),
	(255014, 121, '2014-03-15 00:19:50.000000', 'temperatura', 111.0000, 'ºC'),
	(255015, 121, '2014-03-15 00:19:51.000000', 'temperatura', 806.0000, 'ºC'),
	(255016, 121, '2014-03-15 00:19:52.000000', 'temperatura', 99.0000, 'ºC'),
	(255017, 121, '2014-03-15 00:19:53.000000', 'temperatura', 475.0000, 'ºC'),
	(255018, 121, '2014-03-15 00:19:54.000000', 'temperatura', 880.0000, 'ºC'),
	(255019, 121, '2014-03-15 00:19:55.000000', 'temperatura', 576.0000, 'ºC'),
	(255020, 121, '2014-03-15 00:19:56.000000', 'temperatura', 241.0000, 'ºC'),
	(255021, 121, '2014-03-15 00:19:57.000000', 'temperatura', 679.0000, 'ºC'),
	(255022, 121, '2014-03-15 00:19:58.000000', 'temperatura', 271.0000, 'ºC'),
	(255023, 121, '2014-03-15 00:19:59.000000', 'temperatura', 516.0000, 'ºC'),
	(255024, 121, '2014-03-15 00:20:00.000000', 'temperatura', 571.0000, 'ºC'),
	(255025, 121, '2014-03-15 00:20:01.000000', 'temperatura', 107.0000, 'ºC'),
	(255026, 121, '2014-03-15 00:20:02.000000', 'temperatura', 22.0000, 'ºC'),
	(255027, 121, '2014-03-15 00:20:03.000000', 'temperatura', 991.0000, 'ºC'),
	(255028, 121, '2014-03-15 00:20:04.000000', 'temperatura', 88.0000, 'ºC'),
	(255029, 121, '2014-03-15 00:20:05.000000', 'temperatura', 1070.0000, 'ºC'),
	(255030, 121, '2014-03-15 00:20:06.000000', 'temperatura', 284.0000, 'ºC'),
	(255031, 121, '2014-03-15 00:20:07.000000', 'temperatura', 613.0000, 'ºC'),
	(255032, 121, '2014-03-15 00:20:08.000000', 'temperatura', 1013.0000, 'ºC'),
	(255033, 121, '2014-03-15 00:20:09.000000', 'temperatura', 824.0000, 'ºC'),
	(255034, 121, '2014-03-15 00:20:10.000000', 'temperatura', 1084.0000, 'ºC'),
	(255035, 121, '2014-03-15 00:20:11.000000', 'temperatura', 548.0000, 'ºC'),
	(255036, 121, '2014-03-15 00:20:12.000000', 'temperatura', 690.0000, 'ºC'),
	(255037, 121, '2014-03-15 00:20:13.000000', 'temperatura', 606.0000, 'ºC'),
	(255038, 121, '2014-03-15 00:20:14.000000', 'temperatura', 958.0000, 'ºC'),
	(255039, 121, '2014-03-15 00:20:15.000000', 'temperatura', 574.0000, 'ºC'),
	(255040, 121, '2014-03-15 00:20:16.000000', 'temperatura', 1195.0000, 'ºC'),
	(255041, 121, '2014-03-15 00:20:17.000000', 'temperatura', 655.0000, 'ºC'),
	(255042, 121, '2014-03-15 00:20:18.000000', 'temperatura', 888.0000, 'ºC'),
	(255043, 121, '2014-03-15 00:20:19.000000', 'temperatura', 77.0000, 'ºC'),
	(255044, 121, '2014-03-15 00:20:20.000000', 'temperatura', 122.0000, 'ºC'),
	(255045, 121, '2014-03-15 00:20:21.000000', 'temperatura', 380.0000, 'ºC'),
	(255046, 121, '2014-03-15 00:20:22.000000', 'temperatura', 334.0000, 'ºC'),
	(255047, 121, '2014-03-15 00:20:23.000000', 'temperatura', 530.0000, 'ºC'),
	(255048, 121, '2014-03-15 00:20:24.000000', 'temperatura', 448.0000, 'ºC'),
	(255049, 121, '2014-03-15 00:20:25.000000', 'temperatura', 650.0000, 'ºC'),
	(255050, 121, '2014-03-15 00:20:26.000000', 'temperatura', 708.0000, 'ºC'),
	(255051, 121, '2014-03-15 00:20:27.000000', 'temperatura', 389.0000, 'ºC'),
	(255052, 121, '2014-03-15 00:20:28.000000', 'temperatura', 1021.0000, 'ºC'),
	(255053, 121, '2014-03-15 00:20:29.000000', 'temperatura', 340.0000, 'ºC'),
	(255054, 121, '2014-03-15 00:20:30.000000', 'temperatura', 1035.0000, 'ºC'),
	(255055, 121, '2014-03-15 00:20:31.000000', 'temperatura', 558.0000, 'ºC'),
	(255056, 121, '2014-03-15 00:20:32.000000', 'temperatura', 885.0000, 'ºC'),
	(255057, 121, '2014-03-15 00:20:33.000000', 'temperatura', 351.0000, 'ºC'),
	(255058, 121, '2014-03-15 00:20:34.000000', 'temperatura', 303.0000, 'ºC'),
	(255059, 121, '2014-03-15 00:20:35.000000', 'temperatura', 459.0000, 'ºC'),
	(255060, 121, '2014-03-15 00:20:36.000000', 'temperatura', 187.0000, 'ºC'),
	(255061, 121, '2014-03-15 00:20:37.000000', 'temperatura', 761.0000, 'ºC'),
	(255062, 121, '2014-03-15 00:20:38.000000', 'temperatura', 843.0000, 'ºC'),
	(255063, 121, '2014-03-15 00:20:39.000000', 'temperatura', 733.0000, 'ºC'),
	(255064, 121, '2014-03-15 00:20:40.000000', 'temperatura', 1135.0000, 'ºC'),
	(255065, 121, '2014-03-15 00:20:41.000000', 'temperatura', 1079.0000, 'ºC'),
	(255066, 121, '2014-03-15 00:20:42.000000', 'temperatura', 790.0000, 'ºC'),
	(255067, 121, '2014-03-15 00:20:43.000000', 'temperatura', 714.0000, 'ºC'),
	(255068, 121, '2014-03-15 00:20:44.000000', 'temperatura', 1198.0000, 'ºC'),
	(255069, 121, '2014-03-15 00:20:45.000000', 'temperatura', 250.0000, 'ºC'),
	(255070, 121, '2014-03-15 00:20:46.000000', 'temperatura', 58.0000, 'ºC'),
	(255071, 121, '2014-03-15 00:20:47.000000', 'temperatura', 738.0000, 'ºC'),
	(255072, 121, '2014-03-15 00:20:48.000000', 'temperatura', 1117.0000, 'ºC'),
	(255073, 121, '2014-03-15 00:20:49.000000', 'temperatura', 970.0000, 'ºC'),
	(255074, 121, '2014-03-15 00:20:50.000000', 'temperatura', 302.0000, 'ºC'),
	(255075, 121, '2014-03-15 00:20:51.000000', 'temperatura', 998.0000, 'ºC'),
	(255076, 121, '2014-03-15 00:20:52.000000', 'temperatura', 484.0000, 'ºC'),
	(255077, 121, '2014-03-15 00:20:53.000000', 'temperatura', 629.0000, 'ºC'),
	(255078, 121, '2014-03-15 00:20:54.000000', 'temperatura', 493.0000, 'ºC'),
	(255079, 121, '2014-03-15 00:20:55.000000', 'temperatura', 580.0000, 'ºC'),
	(255080, 121, '2014-03-15 00:20:56.000000', 'temperatura', 221.0000, 'ºC'),
	(255081, 121, '2014-03-15 00:20:57.000000', 'temperatura', 564.0000, 'ºC'),
	(255082, 121, '2014-03-15 00:20:58.000000', 'temperatura', 959.0000, 'ºC'),
	(255083, 121, '2014-03-15 00:20:59.000000', 'temperatura', 702.0000, 'ºC'),
	(255084, 121, '2014-03-15 00:21:00.000000', 'temperatura', 634.0000, 'ºC'),
	(255085, 121, '2014-03-15 00:21:01.000000', 'temperatura', 1063.0000, 'ºC'),
	(255086, 121, '2014-03-15 00:21:02.000000', 'temperatura', 1014.0000, 'ºC'),
	(255087, 121, '2014-03-15 00:21:03.000000', 'temperatura', 681.0000, 'ºC'),
	(255088, 121, '2014-03-15 00:21:04.000000', 'temperatura', 364.0000, 'ºC'),
	(255089, 121, '2014-03-15 00:21:05.000000', 'temperatura', 980.0000, 'ºC'),
	(255090, 121, '2014-03-15 00:21:06.000000', 'temperatura', 205.0000, 'ºC'),
	(255091, 121, '2014-03-15 00:21:07.000000', 'temperatura', 488.0000, 'ºC'),
	(255092, 121, '2014-03-15 00:21:08.000000', 'temperatura', 626.0000, 'ºC'),
	(255093, 121, '2014-03-15 00:21:09.000000', 'temperatura', 467.0000, 'ºC'),
	(255094, 121, '2014-03-15 00:21:10.000000', 'temperatura', 455.0000, 'ºC'),
	(255095, 121, '2014-03-15 00:21:11.000000', 'temperatura', 874.0000, 'ºC'),
	(255096, 121, '2014-03-15 00:21:12.000000', 'temperatura', 608.0000, 'ºC'),
	(255097, 121, '2014-03-15 00:21:13.000000', 'temperatura', 416.0000, 'ºC'),
	(255098, 121, '2014-03-15 00:21:14.000000', 'temperatura', 256.0000, 'ºC'),
	(255099, 121, '2014-03-15 00:21:15.000000', 'temperatura', 32.0000, 'ºC'),
	(255100, 121, '2014-03-15 00:21:16.000000', 'temperatura', 595.0000, 'ºC'),
	(255101, 121, '2014-03-15 00:21:17.000000', 'temperatura', 478.0000, 'ºC'),
	(255102, 121, '2014-03-15 00:21:18.000000', 'temperatura', 605.0000, 'ºC'),
	(255103, 121, '2014-03-15 00:21:19.000000', 'temperatura', 392.0000, 'ºC'),
	(255104, 121, '2014-03-15 00:21:20.000000', 'temperatura', 147.0000, 'ºC'),
	(255105, 121, '2014-03-15 00:21:21.000000', 'temperatura', 759.0000, 'ºC'),
	(255106, 121, '2014-03-15 00:21:22.000000', 'temperatura', 952.0000, 'ºC'),
	(255107, 121, '2014-03-15 00:21:23.000000', 'temperatura', 87.0000, 'ºC'),
	(255108, 121, '2014-03-15 00:21:24.000000', 'temperatura', 1178.0000, 'ºC'),
	(255109, 121, '2014-03-15 00:21:25.000000', 'temperatura', 829.0000, 'ºC'),
	(255110, 121, '2014-03-15 00:21:26.000000', 'temperatura', 611.0000, 'ºC'),
	(255111, 121, '2014-03-15 00:21:27.000000', 'temperatura', 570.0000, 'ºC'),
	(255112, 121, '2014-03-15 00:21:28.000000', 'temperatura', 1018.0000, 'ºC'),
	(255113, 121, '2014-03-15 00:21:29.000000', 'temperatura', 981.0000, 'ºC'),
	(255114, 121, '2014-03-15 00:21:30.000000', 'temperatura', 651.0000, 'ºC'),
	(255115, 121, '2014-03-15 00:21:31.000000', 'temperatura', 314.0000, 'ºC'),
	(255116, 121, '2014-03-15 00:21:32.000000', 'temperatura', 818.0000, 'ºC'),
	(255117, 121, '2014-03-15 00:21:33.000000', 'temperatura', 745.0000, 'ºC'),
	(255118, 121, '2014-03-15 00:21:34.000000', 'temperatura', 75.0000, 'ºC'),
	(255119, 121, '2014-03-15 00:21:35.000000', 'temperatura', 538.0000, 'ºC'),
	(255120, 121, '2014-03-15 00:21:36.000000', 'temperatura', 65.0000, 'ºC'),
	(255121, 121, '2014-03-15 00:21:37.000000', 'temperatura', 1112.0000, 'ºC'),
	(255122, 121, '2014-03-15 00:21:38.000000', 'temperatura', 565.0000, 'ºC'),
	(255123, 121, '2014-03-15 00:21:39.000000', 'temperatura', 689.0000, 'ºC'),
	(255124, 121, '2014-03-15 00:21:40.000000', 'temperatura', 550.0000, 'ºC'),
	(255125, 121, '2014-03-15 00:21:41.000000', 'temperatura', 685.0000, 'ºC'),
	(255126, 121, '2014-03-15 00:21:42.000000', 'temperatura', 573.0000, 'ºC'),
	(255127, 121, '2014-03-15 00:21:43.000000', 'temperatura', 813.0000, 'ºC'),
	(255128, 121, '2014-03-15 00:21:44.000000', 'temperatura', 1145.0000, 'ºC'),
	(255129, 121, '2014-03-15 00:21:45.000000', 'temperatura', 887.0000, 'ºC'),
	(255130, 121, '2014-03-15 00:21:46.000000', 'temperatura', 1001.0000, 'ºC'),
	(255131, 121, '2014-03-15 00:21:47.000000', 'temperatura', 1144.0000, 'ºC'),
	(255132, 121, '2014-03-15 00:21:48.000000', 'temperatura', 319.0000, 'ºC'),
	(255133, 121, '2014-03-15 00:21:49.000000', 'temperatura', 561.0000, 'ºC'),
	(255134, 121, '2014-03-15 00:21:50.000000', 'temperatura', 651.0000, 'ºC'),
	(255135, 121, '2014-03-15 00:21:51.000000', 'temperatura', 372.0000, 'ºC'),
	(255136, 121, '2014-03-15 00:21:52.000000', 'temperatura', 1107.0000, 'ºC'),
	(255137, 121, '2014-03-15 00:21:53.000000', 'temperatura', 821.0000, 'ºC'),
	(255138, 121, '2014-03-15 00:21:54.000000', 'temperatura', 785.0000, 'ºC'),
	(255139, 121, '2014-03-15 00:21:55.000000', 'temperatura', 264.0000, 'ºC'),
	(255140, 121, '2014-03-15 00:21:56.000000', 'temperatura', 162.0000, 'ºC'),
	(255141, 121, '2014-03-15 00:21:57.000000', 'temperatura', 19.0000, 'ºC'),
	(255142, 121, '2014-03-15 00:21:58.000000', 'temperatura', 811.0000, 'ºC'),
	(255143, 121, '2014-03-15 00:21:59.000000', 'temperatura', 398.0000, 'ºC'),
	(255144, 121, '2014-03-15 00:22:00.000000', 'temperatura', 759.0000, 'ºC'),
	(255145, 121, '2014-03-15 00:22:01.000000', 'temperatura', 200.0000, 'ºC'),
	(255146, 121, '2014-03-15 00:22:02.000000', 'temperatura', 1126.0000, 'ºC'),
	(255147, 121, '2014-03-15 00:22:03.000000', 'temperatura', 227.0000, 'ºC'),
	(255148, 121, '2014-03-15 00:22:04.000000', 'temperatura', 158.0000, 'ºC'),
	(255149, 121, '2014-03-15 00:22:05.000000', 'temperatura', 111.0000, 'ºC'),
	(255150, 121, '2014-03-15 00:22:06.000000', 'temperatura', 83.0000, 'ºC'),
	(255151, 121, '2014-03-15 00:22:07.000000', 'temperatura', 80.0000, 'ºC'),
	(255152, 121, '2014-03-15 00:22:08.000000', 'temperatura', 152.0000, 'ºC'),
	(255153, 121, '2014-03-15 00:22:09.000000', 'temperatura', 520.0000, 'ºC'),
	(255154, 121, '2014-03-15 00:22:10.000000', 'temperatura', 944.0000, 'ºC'),
	(255155, 121, '2014-03-15 00:22:11.000000', 'temperatura', 760.0000, 'ºC'),
	(255156, 121, '2014-03-15 00:22:12.000000', 'temperatura', 970.0000, 'ºC'),
	(255157, 121, '2014-03-15 00:22:13.000000', 'temperatura', 170.0000, 'ºC'),
	(255158, 121, '2014-03-15 00:22:14.000000', 'temperatura', 339.0000, 'ºC'),
	(255159, 121, '2014-03-15 00:22:15.000000', 'temperatura', 1188.0000, 'ºC'),
	(255160, 121, '2014-03-15 00:22:16.000000', 'temperatura', 123.0000, 'ºC'),
	(255161, 121, '2014-03-15 00:22:17.000000', 'temperatura', 651.0000, 'ºC'),
	(255162, 121, '2014-03-15 00:22:18.000000', 'temperatura', 487.0000, 'ºC'),
	(255163, 121, '2014-03-15 00:22:19.000000', 'temperatura', 482.0000, 'ºC'),
	(255164, 121, '2014-03-15 00:22:20.000000', 'temperatura', 952.0000, 'ºC'),
	(255165, 121, '2014-03-15 00:22:21.000000', 'temperatura', 912.0000, 'ºC'),
	(255166, 121, '2014-03-15 00:22:22.000000', 'temperatura', 504.0000, 'ºC'),
	(255167, 121, '2014-03-15 00:22:23.000000', 'temperatura', 985.0000, 'ºC'),
	(255168, 121, '2014-03-15 00:22:24.000000', 'temperatura', 1012.0000, 'ºC'),
	(255169, 121, '2014-03-15 00:22:25.000000', 'temperatura', 905.0000, 'ºC'),
	(255170, 121, '2014-03-15 00:22:26.000000', 'temperatura', 293.0000, 'ºC'),
	(255171, 121, '2014-03-15 00:22:27.000000', 'temperatura', 1148.0000, 'ºC'),
	(255172, 121, '2014-03-15 00:22:28.000000', 'temperatura', 62.0000, 'ºC'),
	(255173, 121, '2014-03-15 00:22:29.000000', 'temperatura', 468.0000, 'ºC'),
	(255174, 121, '2014-03-15 00:22:30.000000', 'temperatura', 952.0000, 'ºC'),
	(255175, 121, '2014-03-15 00:22:31.000000', 'temperatura', 958.0000, 'ºC'),
	(255176, 121, '2014-03-15 00:22:32.000000', 'temperatura', 734.0000, 'ºC'),
	(255177, 121, '2014-03-15 00:22:33.000000', 'temperatura', 797.0000, 'ºC'),
	(255178, 121, '2014-03-15 00:22:34.000000', 'temperatura', 585.0000, 'ºC'),
	(255179, 121, '2014-03-15 00:22:35.000000', 'temperatura', 533.0000, 'ºC'),
	(255180, 121, '2014-03-15 00:22:36.000000', 'temperatura', 909.0000, 'ºC'),
	(255181, 121, '2014-03-15 00:22:37.000000', 'temperatura', 548.0000, 'ºC'),
	(255182, 121, '2014-03-15 00:22:38.000000', 'temperatura', 15.0000, 'ºC'),
	(255183, 121, '2014-03-15 00:22:39.000000', 'temperatura', 830.0000, 'ºC'),
	(255184, 121, '2014-03-15 00:22:40.000000', 'temperatura', 505.0000, 'ºC'),
	(255185, 121, '2014-03-15 00:22:41.000000', 'temperatura', 35.0000, 'ºC'),
	(255186, 121, '2014-03-15 00:22:42.000000', 'temperatura', 1062.0000, 'ºC'),
	(255187, 121, '2014-03-15 00:22:43.000000', 'temperatura', 405.0000, 'ºC'),
	(255188, 121, '2014-03-15 00:22:44.000000', 'temperatura', 38.0000, 'ºC'),
	(255189, 121, '2014-03-15 00:22:45.000000', 'temperatura', 178.0000, 'ºC'),
	(255190, 121, '2014-03-15 00:22:46.000000', 'temperatura', 775.0000, 'ºC'),
	(255191, 121, '2014-03-15 00:22:47.000000', 'temperatura', 940.0000, 'ºC'),
	(255192, 121, '2014-03-15 00:22:48.000000', 'temperatura', 1177.0000, 'ºC'),
	(255193, 121, '2014-03-15 00:22:49.000000', 'temperatura', 664.0000, 'ºC'),
	(255194, 121, '2014-03-15 00:22:50.000000', 'temperatura', 990.0000, 'ºC'),
	(255195, 121, '2014-03-15 00:22:51.000000', 'temperatura', 559.0000, 'ºC'),
	(255196, 121, '2014-03-15 00:22:52.000000', 'temperatura', 1027.0000, 'ºC'),
	(255197, 121, '2014-03-15 00:22:53.000000', 'temperatura', 1059.0000, 'ºC'),
	(255198, 121, '2014-03-15 00:22:54.000000', 'temperatura', 1015.0000, 'ºC'),
	(255199, 121, '2014-03-15 00:22:55.000000', 'temperatura', 696.0000, 'ºC'),
	(255200, 121, '2014-03-15 00:22:56.000000', 'temperatura', 437.0000, 'ºC'),
	(255201, 121, '2014-03-15 00:22:57.000000', 'temperatura', 99.0000, 'ºC'),
	(255202, 121, '2014-03-15 00:22:58.000000', 'temperatura', 383.0000, 'ºC'),
	(255203, 121, '2014-03-15 00:22:59.000000', 'temperatura', 418.0000, 'ºC'),
	(255204, 121, '2014-03-15 00:23:00.000000', 'temperatura', 942.0000, 'ºC'),
	(255205, 121, '2014-03-15 00:23:01.000000', 'temperatura', 1058.0000, 'ºC'),
	(255206, 121, '2014-03-15 00:23:02.000000', 'temperatura', 65.0000, 'ºC'),
	(255207, 121, '2014-03-15 00:23:03.000000', 'temperatura', 750.0000, 'ºC'),
	(255208, 121, '2014-03-15 00:23:04.000000', 'temperatura', 1157.0000, 'ºC'),
	(255209, 121, '2014-03-15 00:23:05.000000', 'temperatura', 1136.0000, 'ºC'),
	(255210, 121, '2014-03-15 00:23:06.000000', 'temperatura', 1008.0000, 'ºC'),
	(255211, 121, '2014-03-15 00:23:07.000000', 'temperatura', 433.0000, 'ºC'),
	(255212, 121, '2014-03-15 00:23:08.000000', 'temperatura', 341.0000, 'ºC'),
	(255213, 121, '2014-03-15 00:23:09.000000', 'temperatura', 406.0000, 'ºC'),
	(255214, 121, '2014-03-15 00:23:10.000000', 'temperatura', 1007.0000, 'ºC'),
	(255215, 121, '2014-03-15 00:23:11.000000', 'temperatura', 219.0000, 'ºC'),
	(255216, 121, '2014-03-15 00:23:12.000000', 'temperatura', 475.0000, 'ºC'),
	(255217, 121, '2014-03-15 00:23:13.000000', 'temperatura', 518.0000, 'ºC'),
	(255218, 121, '2014-03-15 00:23:14.000000', 'temperatura', 1166.0000, 'ºC'),
	(255219, 121, '2014-03-15 00:23:15.000000', 'temperatura', 678.0000, 'ºC'),
	(255220, 121, '2014-03-15 00:23:16.000000', 'temperatura', 1090.0000, 'ºC'),
	(255221, 121, '2014-03-15 00:23:17.000000', 'temperatura', 1019.0000, 'ºC'),
	(255222, 121, '2014-03-15 00:23:18.000000', 'temperatura', 623.0000, 'ºC'),
	(255223, 121, '2014-03-15 00:23:19.000000', 'temperatura', 61.0000, 'ºC'),
	(255224, 121, '2014-03-15 00:23:20.000000', 'temperatura', 836.0000, 'ºC'),
	(255225, 121, '2014-03-15 00:23:21.000000', 'temperatura', 396.0000, 'ºC'),
	(255226, 121, '2014-03-15 00:23:22.000000', 'temperatura', 671.0000, 'ºC'),
	(255227, 121, '2014-03-15 00:23:23.000000', 'temperatura', 971.0000, 'ºC'),
	(255228, 121, '2014-03-15 00:23:24.000000', 'temperatura', 439.0000, 'ºC'),
	(255229, 121, '2014-03-15 00:23:25.000000', 'temperatura', 485.0000, 'ºC'),
	(255230, 121, '2014-03-15 00:23:26.000000', 'temperatura', 1108.0000, 'ºC'),
	(255231, 121, '2014-03-15 00:23:27.000000', 'temperatura', 487.0000, 'ºC'),
	(255232, 121, '2014-03-15 00:23:28.000000', 'temperatura', 311.0000, 'ºC'),
	(255233, 121, '2014-03-15 00:23:29.000000', 'temperatura', 95.0000, 'ºC'),
	(255234, 121, '2014-03-15 00:23:30.000000', 'temperatura', 740.0000, 'ºC'),
	(255235, 121, '2014-03-15 00:23:31.000000', 'temperatura', 1019.0000, 'ºC'),
	(255236, 121, '2014-03-15 00:23:32.000000', 'temperatura', 472.0000, 'ºC'),
	(255237, 121, '2014-03-15 00:23:33.000000', 'temperatura', 507.0000, 'ºC'),
	(255238, 121, '2014-03-15 00:23:34.000000', 'temperatura', 1116.0000, 'ºC'),
	(255239, 121, '2014-03-15 00:23:35.000000', 'temperatura', 463.0000, 'ºC'),
	(255240, 121, '2014-03-15 00:23:36.000000', 'temperatura', 165.0000, 'ºC'),
	(255241, 121, '2014-03-15 00:23:37.000000', 'temperatura', 635.0000, 'ºC'),
	(255242, 121, '2014-03-15 00:23:38.000000', 'temperatura', 284.0000, 'ºC'),
	(255243, 121, '2014-03-15 00:23:39.000000', 'temperatura', 712.0000, 'ºC'),
	(255244, 121, '2014-03-15 00:23:40.000000', 'temperatura', 311.0000, 'ºC'),
	(255245, 121, '2014-03-15 00:23:41.000000', 'temperatura', 621.0000, 'ºC'),
	(255246, 121, '2014-03-15 00:23:42.000000', 'temperatura', 970.0000, 'ºC'),
	(255247, 121, '2014-03-15 00:23:43.000000', 'temperatura', 587.0000, 'ºC'),
	(255248, 121, '2014-03-15 00:23:44.000000', 'temperatura', 25.0000, 'ºC'),
	(255249, 121, '2014-03-15 00:23:45.000000', 'temperatura', 764.0000, 'ºC'),
	(255250, 121, '2014-03-15 00:23:46.000000', 'temperatura', 145.0000, 'ºC'),
	(255251, 121, '2014-03-15 00:23:47.000000', 'temperatura', 834.0000, 'ºC'),
	(255252, 121, '2014-03-15 00:23:48.000000', 'temperatura', 136.0000, 'ºC'),
	(255253, 121, '2014-03-15 00:23:49.000000', 'temperatura', 579.0000, 'ºC'),
	(255254, 121, '2014-03-15 00:23:50.000000', 'temperatura', 86.0000, 'ºC'),
	(255255, 121, '2014-03-15 00:23:51.000000', 'temperatura', 1096.0000, 'ºC'),
	(255256, 121, '2014-03-15 00:23:52.000000', 'temperatura', 420.0000, 'ºC'),
	(255257, 121, '2014-03-15 00:23:53.000000', 'temperatura', 16.0000, 'ºC'),
	(255258, 121, '2014-03-15 00:23:54.000000', 'temperatura', 17.0000, 'ºC'),
	(255259, 121, '2014-03-15 00:23:55.000000', 'temperatura', 37.0000, 'ºC'),
	(255260, 121, '2014-03-15 00:23:56.000000', 'temperatura', 135.0000, 'ºC'),
	(255261, 121, '2014-03-15 00:23:57.000000', 'temperatura', 564.0000, 'ºC'),
	(255262, 121, '2014-03-15 00:23:58.000000', 'temperatura', 17.0000, 'ºC'),
	(255263, 121, '2014-03-15 00:23:59.000000', 'temperatura', 795.0000, 'ºC'),
	(255264, 121, '2014-03-15 00:24:00.000000', 'temperatura', 322.0000, 'ºC'),
	(255265, 121, '2014-03-15 00:24:01.000000', 'temperatura', 428.0000, 'ºC'),
	(255266, 121, '2014-03-15 00:24:02.000000', 'temperatura', 1173.0000, 'ºC'),
	(255267, 121, '2014-03-15 00:24:03.000000', 'temperatura', 983.0000, 'ºC'),
	(255268, 121, '2014-03-15 00:24:04.000000', 'temperatura', 195.0000, 'ºC'),
	(255269, 121, '2014-03-15 00:24:05.000000', 'temperatura', 428.0000, 'ºC'),
	(255270, 121, '2014-03-15 00:24:06.000000', 'temperatura', 355.0000, 'ºC'),
	(255271, 121, '2014-03-15 00:24:07.000000', 'temperatura', 493.0000, 'ºC'),
	(255272, 121, '2014-03-15 00:24:08.000000', 'temperatura', 200.0000, 'ºC'),
	(255273, 121, '2014-03-15 00:24:09.000000', 'temperatura', 722.0000, 'ºC'),
	(255274, 121, '2014-03-15 00:24:10.000000', 'temperatura', 610.0000, 'ºC'),
	(255275, 121, '2014-03-15 00:24:11.000000', 'temperatura', 882.0000, 'ºC'),
	(255276, 121, '2014-03-15 00:24:12.000000', 'temperatura', 184.0000, 'ºC'),
	(255277, 121, '2014-03-15 00:24:13.000000', 'temperatura', 674.0000, 'ºC'),
	(255278, 121, '2014-03-15 00:24:14.000000', 'temperatura', 419.0000, 'ºC'),
	(255279, 121, '2014-03-15 00:24:15.000000', 'temperatura', 71.0000, 'ºC'),
	(255280, 121, '2014-03-15 00:24:16.000000', 'temperatura', 302.0000, 'ºC'),
	(255281, 121, '2014-03-15 00:24:17.000000', 'temperatura', 95.0000, 'ºC'),
	(255282, 121, '2014-03-15 00:24:18.000000', 'temperatura', 772.0000, 'ºC'),
	(255283, 121, '2014-03-15 00:24:19.000000', 'temperatura', 1173.0000, 'ºC'),
	(255284, 121, '2014-03-15 00:24:20.000000', 'temperatura', 1150.0000, 'ºC'),
	(255285, 121, '2014-03-15 00:24:21.000000', 'temperatura', 1030.0000, 'ºC'),
	(255286, 121, '2014-03-15 00:24:22.000000', 'temperatura', 501.0000, 'ºC'),
	(255287, 121, '2014-03-15 00:24:23.000000', 'temperatura', 614.0000, 'ºC'),
	(255288, 121, '2014-03-15 00:24:24.000000', 'temperatura', 369.0000, 'ºC'),
	(255289, 121, '2014-03-15 00:24:25.000000', 'temperatura', 4.0000, 'ºC'),
	(255290, 121, '2014-03-15 00:24:26.000000', 'temperatura', 115.0000, 'ºC'),
	(255291, 121, '2014-03-15 00:24:27.000000', 'temperatura', 562.0000, 'ºC'),
	(255292, 121, '2014-03-15 00:24:28.000000', 'temperatura', 66.0000, 'ºC'),
	(255293, 121, '2014-03-15 00:24:29.000000', 'temperatura', 1046.0000, 'ºC'),
	(255294, 121, '2014-03-15 00:24:30.000000', 'temperatura', 232.0000, 'ºC'),
	(255295, 121, '2014-03-15 00:24:31.000000', 'temperatura', 423.0000, 'ºC'),
	(255296, 121, '2014-03-15 00:24:32.000000', 'temperatura', 220.0000, 'ºC'),
	(255297, 121, '2014-03-15 00:24:33.000000', 'temperatura', 1032.0000, 'ºC'),
	(255298, 121, '2014-03-15 00:24:34.000000', 'temperatura', 900.0000, 'ºC'),
	(255299, 121, '2014-03-15 00:24:35.000000', 'temperatura', 204.0000, 'ºC'),
	(255300, 121, '2014-03-15 00:24:36.000000', 'temperatura', 722.0000, 'ºC'),
	(255301, 121, '2014-03-15 00:24:37.000000', 'temperatura', 599.0000, 'ºC'),
	(255302, 121, '2014-03-15 00:24:38.000000', 'temperatura', 828.0000, 'ºC'),
	(255303, 121, '2014-03-15 00:24:39.000000', 'temperatura', 1145.0000, 'ºC'),
	(255304, 121, '2014-03-15 00:24:40.000000', 'temperatura', 842.0000, 'ºC'),
	(255305, 121, '2014-03-15 00:24:41.000000', 'temperatura', 776.0000, 'ºC'),
	(255306, 121, '2014-03-15 00:24:42.000000', 'temperatura', 153.0000, 'ºC'),
	(255307, 121, '2014-03-15 00:24:43.000000', 'temperatura', 836.0000, 'ºC'),
	(255308, 121, '2014-03-15 00:24:44.000000', 'temperatura', 124.0000, 'ºC'),
	(255309, 121, '2014-03-15 00:24:45.000000', 'temperatura', 511.0000, 'ºC'),
	(255310, 121, '2014-03-15 00:24:46.000000', 'temperatura', 982.0000, 'ºC'),
	(255311, 121, '2014-03-15 00:24:47.000000', 'temperatura', 980.0000, 'ºC'),
	(255312, 121, '2014-03-15 00:24:48.000000', 'temperatura', 756.0000, 'ºC'),
	(255313, 121, '2014-03-15 00:24:49.000000', 'temperatura', 838.0000, 'ºC'),
	(255314, 121, '2014-03-15 00:24:50.000000', 'temperatura', 721.0000, 'ºC'),
	(255315, 121, '2014-03-15 00:24:51.000000', 'temperatura', 1094.0000, 'ºC'),
	(255316, 121, '2014-03-15 00:24:52.000000', 'temperatura', 908.0000, 'ºC'),
	(255317, 121, '2014-03-15 00:24:53.000000', 'temperatura', 57.0000, 'ºC'),
	(255318, 121, '2014-03-15 00:24:54.000000', 'temperatura', 1161.0000, 'ºC'),
	(255319, 121, '2014-03-15 00:24:55.000000', 'temperatura', 834.0000, 'ºC'),
	(255320, 121, '2014-03-15 00:24:56.000000', 'temperatura', 689.0000, 'ºC'),
	(255321, 121, '2014-03-15 00:24:57.000000', 'temperatura', 943.0000, 'ºC'),
	(255322, 121, '2014-03-15 00:24:58.000000', 'temperatura', 247.0000, 'ºC'),
	(255323, 121, '2014-03-15 00:24:59.000000', 'temperatura', 809.0000, 'ºC'),
	(255324, 121, '2014-03-15 00:25:00.000000', 'temperatura', 905.0000, 'ºC'),
	(255325, 121, '2014-03-15 00:25:01.000000', 'temperatura', 896.0000, 'ºC'),
	(255326, 121, '2014-03-15 00:25:02.000000', 'temperatura', 567.0000, 'ºC'),
	(255327, 121, '2014-03-15 00:25:03.000000', 'temperatura', 147.0000, 'ºC'),
	(255328, 121, '2014-03-15 00:25:04.000000', 'temperatura', 235.0000, 'ºC'),
	(255329, 121, '2014-03-15 00:25:05.000000', 'temperatura', 736.0000, 'ºC'),
	(255330, 121, '2014-03-15 00:25:06.000000', 'temperatura', 572.0000, 'ºC'),
	(255331, 121, '2014-03-15 00:25:07.000000', 'temperatura', 655.0000, 'ºC'),
	(255332, 121, '2014-03-15 00:25:08.000000', 'temperatura', 360.0000, 'ºC'),
	(255333, 121, '2014-03-15 00:25:09.000000', 'temperatura', 1034.0000, 'ºC'),
	(255334, 121, '2014-03-15 00:25:10.000000', 'temperatura', 491.0000, 'ºC'),
	(255335, 121, '2014-03-15 00:25:11.000000', 'temperatura', 553.0000, 'ºC'),
	(255336, 121, '2014-03-15 00:25:12.000000', 'temperatura', 92.0000, 'ºC'),
	(255337, 121, '2014-03-15 00:25:13.000000', 'temperatura', 4.0000, 'ºC'),
	(255338, 121, '2014-03-15 00:25:14.000000', 'temperatura', 942.0000, 'ºC'),
	(255339, 121, '2014-03-15 00:25:15.000000', 'temperatura', 1098.0000, 'ºC'),
	(255340, 121, '2014-03-15 00:25:16.000000', 'temperatura', 264.0000, 'ºC'),
	(255341, 121, '2014-03-15 00:25:17.000000', 'temperatura', 429.0000, 'ºC'),
	(255342, 121, '2014-03-15 00:25:18.000000', 'temperatura', 151.0000, 'ºC'),
	(255343, 121, '2014-03-15 00:25:19.000000', 'temperatura', 672.0000, 'ºC'),
	(255344, 121, '2014-03-15 00:25:20.000000', 'temperatura', 504.0000, 'ºC'),
	(255345, 121, '2014-03-15 00:25:21.000000', 'temperatura', 507.0000, 'ºC'),
	(255346, 121, '2014-03-15 00:25:22.000000', 'temperatura', 1022.0000, 'ºC'),
	(255347, 121, '2014-03-15 00:25:23.000000', 'temperatura', 1190.0000, 'ºC'),
	(255348, 121, '2014-03-15 00:25:24.000000', 'temperatura', 487.0000, 'ºC'),
	(255349, 121, '2014-03-15 00:25:25.000000', 'temperatura', 62.0000, 'ºC'),
	(255350, 121, '2014-03-15 00:25:26.000000', 'temperatura', 51.0000, 'ºC'),
	(255351, 121, '2014-03-15 00:25:27.000000', 'temperatura', 67.0000, 'ºC'),
	(255352, 121, '2014-03-15 00:25:28.000000', 'temperatura', 186.0000, 'ºC'),
	(255353, 121, '2014-03-15 00:25:29.000000', 'temperatura', 727.0000, 'ºC'),
	(255354, 121, '2014-03-15 00:25:30.000000', 'temperatura', 677.0000, 'ºC'),
	(255355, 121, '2014-03-15 00:25:31.000000', 'temperatura', 3.0000, 'ºC'),
	(255356, 121, '2014-03-15 00:25:32.000000', 'temperatura', 388.0000, 'ºC'),
	(255357, 121, '2014-03-15 00:25:33.000000', 'temperatura', 728.0000, 'ºC'),
	(255358, 121, '2014-03-15 00:25:34.000000', 'temperatura', 79.0000, 'ºC'),
	(255359, 121, '2014-03-15 00:25:35.000000', 'temperatura', 609.0000, 'ºC'),
	(255360, 121, '2014-03-15 00:25:36.000000', 'temperatura', 410.0000, 'ºC'),
	(255361, 121, '2014-03-15 00:25:37.000000', 'temperatura', 222.0000, 'ºC'),
	(255362, 121, '2014-03-15 00:25:38.000000', 'temperatura', 1080.0000, 'ºC'),
	(255363, 121, '2014-03-15 00:25:39.000000', 'temperatura', 1137.0000, 'ºC'),
	(255364, 121, '2014-03-15 00:25:40.000000', 'temperatura', 43.0000, 'ºC'),
	(255365, 121, '2014-03-15 00:25:41.000000', 'temperatura', 404.0000, 'ºC'),
	(255366, 121, '2014-03-15 00:25:42.000000', 'temperatura', 694.0000, 'ºC'),
	(255367, 121, '2014-03-15 00:25:43.000000', 'temperatura', 1056.0000, 'ºC'),
	(255368, 121, '2014-03-15 00:25:44.000000', 'temperatura', 797.0000, 'ºC'),
	(255369, 121, '2014-03-15 00:25:45.000000', 'temperatura', 821.0000, 'ºC'),
	(255370, 121, '2014-03-15 00:25:46.000000', 'temperatura', 514.0000, 'ºC'),
	(255371, 121, '2014-03-15 00:25:47.000000', 'temperatura', 107.0000, 'ºC'),
	(255372, 121, '2014-03-15 00:25:48.000000', 'temperatura', 193.0000, 'ºC'),
	(255373, 121, '2014-03-15 00:25:49.000000', 'temperatura', 646.0000, 'ºC'),
	(255374, 121, '2014-03-15 00:25:50.000000', 'temperatura', 249.0000, 'ºC'),
	(255375, 121, '2014-03-15 00:25:51.000000', 'temperatura', 509.0000, 'ºC'),
	(255376, 121, '2014-03-15 00:25:52.000000', 'temperatura', 600.0000, 'ºC'),
	(255377, 121, '2014-03-15 00:25:53.000000', 'temperatura', 273.0000, 'ºC'),
	(255378, 121, '2014-03-15 00:25:54.000000', 'temperatura', 764.0000, 'ºC'),
	(255379, 121, '2014-03-15 00:25:55.000000', 'temperatura', 603.0000, 'ºC'),
	(255380, 121, '2014-03-15 00:25:56.000000', 'temperatura', 721.0000, 'ºC'),
	(255381, 121, '2014-03-15 00:25:57.000000', 'temperatura', 599.0000, 'ºC'),
	(255382, 121, '2014-03-15 00:25:58.000000', 'temperatura', 833.0000, 'ºC'),
	(255383, 121, '2014-03-15 00:25:59.000000', 'temperatura', 1167.0000, 'ºC'),
	(255384, 121, '2014-03-15 00:26:00.000000', 'temperatura', 936.0000, 'ºC'),
	(255385, 121, '2014-03-15 00:26:01.000000', 'temperatura', 1179.0000, 'ºC'),
	(255386, 121, '2014-03-15 00:26:02.000000', 'temperatura', 689.0000, 'ºC'),
	(255387, 121, '2014-03-15 00:26:03.000000', 'temperatura', 1106.0000, 'ºC'),
	(255388, 121, '2014-03-15 00:26:04.000000', 'temperatura', 1067.0000, 'ºC'),
	(255389, 121, '2014-03-15 00:26:05.000000', 'temperatura', 815.0000, 'ºC'),
	(255390, 121, '2014-03-15 00:26:06.000000', 'temperatura', 876.0000, 'ºC'),
	(255391, 121, '2014-03-15 00:26:07.000000', 'temperatura', 736.0000, 'ºC'),
	(255392, 121, '2014-03-15 00:26:08.000000', 'temperatura', 1053.0000, 'ºC'),
	(255393, 121, '2014-03-15 00:26:09.000000', 'temperatura', 656.0000, 'ºC'),
	(255394, 121, '2014-03-15 00:26:10.000000', 'temperatura', 121.0000, 'ºC'),
	(255395, 121, '2014-03-15 00:26:11.000000', 'temperatura', 1036.0000, 'ºC'),
	(255396, 121, '2014-03-15 00:26:12.000000', 'temperatura', 21.0000, 'ºC'),
	(255397, 121, '2014-03-15 00:26:13.000000', 'temperatura', 594.0000, 'ºC'),
	(255398, 121, '2014-03-15 00:26:14.000000', 'temperatura', 509.0000, 'ºC'),
	(255399, 121, '2014-03-15 00:26:15.000000', 'temperatura', 763.0000, 'ºC'),
	(255400, 121, '2014-03-15 00:26:16.000000', 'temperatura', 1089.0000, 'ºC'),
	(255401, 121, '2014-03-15 00:26:17.000000', 'temperatura', 757.0000, 'ºC'),
	(255402, 121, '2014-03-15 00:26:18.000000', 'temperatura', 518.0000, 'ºC'),
	(255403, 121, '2014-03-15 00:26:19.000000', 'temperatura', 321.0000, 'ºC'),
	(255404, 121, '2014-03-15 00:26:20.000000', 'temperatura', 51.0000, 'ºC'),
	(255405, 121, '2014-03-15 00:26:21.000000', 'temperatura', 492.0000, 'ºC'),
	(255406, 121, '2014-03-15 00:26:22.000000', 'temperatura', 1109.0000, 'ºC'),
	(255407, 121, '2014-03-15 00:26:23.000000', 'temperatura', 469.0000, 'ºC'),
	(255408, 121, '2014-03-15 00:26:24.000000', 'temperatura', 219.0000, 'ºC'),
	(255409, 121, '2014-03-15 00:26:25.000000', 'temperatura', 890.0000, 'ºC'),
	(255410, 121, '2014-03-15 00:26:26.000000', 'temperatura', 192.0000, 'ºC'),
	(255411, 121, '2014-03-15 00:26:27.000000', 'temperatura', 689.0000, 'ºC'),
	(255412, 121, '2014-03-15 00:26:28.000000', 'temperatura', 470.0000, 'ºC'),
	(255413, 121, '2014-03-15 00:26:29.000000', 'temperatura', 286.0000, 'ºC'),
	(255414, 121, '2014-03-15 00:26:30.000000', 'temperatura', 18.0000, 'ºC'),
	(255415, 121, '2014-03-15 00:26:31.000000', 'temperatura', 431.0000, 'ºC'),
	(255416, 121, '2014-03-15 00:26:32.000000', 'temperatura', 905.0000, 'ºC'),
	(255417, 121, '2014-03-15 00:26:33.000000', 'temperatura', 831.0000, 'ºC'),
	(255418, 121, '2014-03-15 00:26:34.000000', 'temperatura', 243.0000, 'ºC'),
	(255419, 121, '2014-03-15 00:26:35.000000', 'temperatura', 1119.0000, 'ºC'),
	(255420, 121, '2014-03-15 00:26:36.000000', 'temperatura', 68.0000, 'ºC'),
	(255421, 121, '2014-03-15 00:26:37.000000', 'temperatura', 585.0000, 'ºC'),
	(255422, 121, '2014-03-15 00:26:38.000000', 'temperatura', 319.0000, 'ºC'),
	(255423, 121, '2014-03-15 00:26:39.000000', 'temperatura', 1041.0000, 'ºC'),
	(255424, 121, '2014-03-15 00:26:40.000000', 'temperatura', 650.0000, 'ºC'),
	(255425, 121, '2014-03-15 00:26:41.000000', 'temperatura', 127.0000, 'ºC'),
	(255426, 121, '2014-03-15 00:26:42.000000', 'temperatura', 1087.0000, 'ºC'),
	(255427, 121, '2014-03-15 00:26:43.000000', 'temperatura', 252.0000, 'ºC'),
	(255428, 121, '2014-03-15 00:26:44.000000', 'temperatura', 402.0000, 'ºC'),
	(255429, 121, '2014-03-15 00:26:45.000000', 'temperatura', 53.0000, 'ºC'),
	(255430, 121, '2014-03-15 00:26:46.000000', 'temperatura', 258.0000, 'ºC'),
	(255431, 121, '2014-03-15 00:26:47.000000', 'temperatura', 1132.0000, 'ºC'),
	(255432, 121, '2014-03-15 00:26:48.000000', 'temperatura', 89.0000, 'ºC'),
	(255433, 121, '2014-03-15 00:26:49.000000', 'temperatura', 646.0000, 'ºC'),
	(255434, 121, '2014-03-15 00:26:50.000000', 'temperatura', 566.0000, 'ºC'),
	(255435, 121, '2014-03-15 00:26:51.000000', 'temperatura', 893.0000, 'ºC'),
	(255436, 121, '2014-03-15 00:26:52.000000', 'temperatura', 368.0000, 'ºC'),
	(255437, 121, '2014-03-15 00:26:53.000000', 'temperatura', 360.0000, 'ºC'),
	(255438, 121, '2014-03-15 00:26:54.000000', 'temperatura', 697.0000, 'ºC'),
	(255439, 121, '2014-03-15 00:26:55.000000', 'temperatura', 4.0000, 'ºC'),
	(255440, 121, '2014-03-15 00:26:56.000000', 'temperatura', 329.0000, 'ºC'),
	(255441, 121, '2014-03-15 00:26:57.000000', 'temperatura', 435.0000, 'ºC'),
	(255442, 121, '2014-03-15 00:26:58.000000', 'temperatura', 1187.0000, 'ºC'),
	(255443, 121, '2014-03-15 00:26:59.000000', 'temperatura', 1031.0000, 'ºC'),
	(255444, 121, '2014-03-15 00:27:00.000000', 'temperatura', 393.0000, 'ºC'),
	(255445, 121, '2014-03-15 00:27:01.000000', 'temperatura', 74.0000, 'ºC'),
	(255446, 121, '2014-03-15 00:27:02.000000', 'temperatura', 393.0000, 'ºC'),
	(255447, 121, '2014-03-15 00:27:03.000000', 'temperatura', 543.0000, 'ºC'),
	(255448, 121, '2014-03-15 00:27:04.000000', 'temperatura', 334.0000, 'ºC'),
	(255449, 121, '2014-03-15 00:27:05.000000', 'temperatura', 44.0000, 'ºC'),
	(255450, 121, '2014-03-15 00:27:06.000000', 'temperatura', 417.0000, 'ºC'),
	(255451, 121, '2014-03-15 00:27:07.000000', 'temperatura', 755.0000, 'ºC'),
	(255452, 121, '2014-03-15 00:27:08.000000', 'temperatura', 122.0000, 'ºC'),
	(255453, 121, '2014-03-15 00:27:09.000000', 'temperatura', 747.0000, 'ºC'),
	(255454, 121, '2014-03-15 00:27:10.000000', 'temperatura', 968.0000, 'ºC'),
	(255455, 121, '2014-03-15 00:27:11.000000', 'temperatura', 201.0000, 'ºC'),
	(255456, 121, '2014-03-15 00:27:12.000000', 'temperatura', 502.0000, 'ºC'),
	(255457, 121, '2014-03-15 00:27:13.000000', 'temperatura', 708.0000, 'ºC'),
	(255458, 121, '2014-03-15 00:27:14.000000', 'temperatura', 834.0000, 'ºC'),
	(255459, 121, '2014-03-15 00:27:15.000000', 'temperatura', 845.0000, 'ºC'),
	(255460, 121, '2014-03-15 00:27:16.000000', 'temperatura', 523.0000, 'ºC'),
	(255461, 121, '2014-03-15 00:27:17.000000', 'temperatura', 81.0000, 'ºC'),
	(255462, 121, '2014-03-15 00:27:18.000000', 'temperatura', 37.0000, 'ºC'),
	(255463, 121, '2014-03-15 00:27:19.000000', 'temperatura', 1144.0000, 'ºC'),
	(255464, 121, '2014-03-15 00:27:20.000000', 'temperatura', 807.0000, 'ºC'),
	(255465, 121, '2014-03-15 00:27:21.000000', 'temperatura', 605.0000, 'ºC'),
	(255466, 121, '2014-03-15 00:27:22.000000', 'temperatura', 604.0000, 'ºC'),
	(255467, 121, '2014-03-15 00:27:23.000000', 'temperatura', 7.0000, 'ºC'),
	(255468, 121, '2014-03-15 00:27:24.000000', 'temperatura', 621.0000, 'ºC'),
	(255469, 121, '2014-03-15 00:27:25.000000', 'temperatura', 686.0000, 'ºC'),
	(255470, 121, '2014-03-15 00:27:26.000000', 'temperatura', 369.0000, 'ºC'),
	(255471, 121, '2014-03-15 00:27:27.000000', 'temperatura', 987.0000, 'ºC'),
	(255472, 121, '2014-03-15 00:27:28.000000', 'temperatura', 227.0000, 'ºC'),
	(255473, 121, '2014-03-15 00:27:29.000000', 'temperatura', 573.0000, 'ºC'),
	(255474, 121, '2014-03-15 00:27:30.000000', 'temperatura', 987.0000, 'ºC'),
	(255475, 121, '2014-03-15 00:27:31.000000', 'temperatura', 816.0000, 'ºC'),
	(255476, 121, '2014-03-15 00:27:32.000000', 'temperatura', 1120.0000, 'ºC'),
	(255477, 121, '2014-03-15 00:27:33.000000', 'temperatura', 752.0000, 'ºC'),
	(255478, 121, '2014-03-15 00:27:34.000000', 'temperatura', 399.0000, 'ºC'),
	(255479, 121, '2014-03-15 00:27:35.000000', 'temperatura', 940.0000, 'ºC'),
	(255480, 121, '2014-03-15 00:27:36.000000', 'temperatura', 1104.0000, 'ºC'),
	(255481, 121, '2014-03-15 00:27:37.000000', 'temperatura', 300.0000, 'ºC'),
	(255482, 121, '2014-03-15 00:27:38.000000', 'temperatura', 589.0000, 'ºC'),
	(255483, 121, '2014-03-15 00:27:39.000000', 'temperatura', 847.0000, 'ºC'),
	(255484, 121, '2014-03-15 00:27:40.000000', 'temperatura', 67.0000, 'ºC'),
	(255485, 121, '2014-03-15 00:27:41.000000', 'temperatura', 196.0000, 'ºC'),
	(255486, 121, '2014-03-15 00:27:42.000000', 'temperatura', 778.0000, 'ºC'),
	(255487, 121, '2014-03-15 00:27:43.000000', 'temperatura', 902.0000, 'ºC'),
	(255488, 121, '2014-03-15 00:27:44.000000', 'temperatura', 978.0000, 'ºC'),
	(255489, 121, '2014-03-15 00:27:45.000000', 'temperatura', 982.0000, 'ºC'),
	(255490, 121, '2014-03-15 00:27:46.000000', 'temperatura', 779.0000, 'ºC'),
	(255491, 121, '2014-03-15 00:27:47.000000', 'temperatura', 948.0000, 'ºC'),
	(255492, 121, '2014-03-15 00:27:48.000000', 'temperatura', 2.0000, 'ºC'),
	(255493, 121, '2014-03-15 00:27:49.000000', 'temperatura', 768.0000, 'ºC'),
	(255494, 121, '2014-03-15 00:27:50.000000', 'temperatura', 235.0000, 'ºC'),
	(255495, 121, '2014-03-15 00:27:51.000000', 'temperatura', 72.0000, 'ºC'),
	(255496, 121, '2014-03-15 00:27:52.000000', 'temperatura', 856.0000, 'ºC'),
	(255497, 121, '2014-03-15 00:27:53.000000', 'temperatura', 462.0000, 'ºC'),
	(255498, 121, '2014-03-15 00:27:54.000000', 'temperatura', 945.0000, 'ºC'),
	(255499, 121, '2014-03-15 00:27:55.000000', 'temperatura', 939.0000, 'ºC'),
	(255500, 121, '2014-03-15 00:27:56.000000', 'temperatura', 662.0000, 'ºC'),
	(255501, 121, '2014-03-15 00:27:57.000000', 'temperatura', 492.0000, 'ºC'),
	(255502, 121, '2014-03-15 00:27:58.000000', 'temperatura', 476.0000, 'ºC'),
	(255503, 121, '2014-03-15 00:27:59.000000', 'temperatura', 906.0000, 'ºC'),
	(255504, 121, '2014-03-15 00:28:00.000000', 'temperatura', 699.0000, 'ºC'),
	(255505, 121, '2014-03-15 00:28:01.000000', 'temperatura', 778.0000, 'ºC'),
	(255506, 121, '2014-03-15 00:28:02.000000', 'temperatura', 592.0000, 'ºC'),
	(255507, 121, '2014-03-15 00:28:03.000000', 'temperatura', 629.0000, 'ºC'),
	(255508, 121, '2014-03-15 00:28:04.000000', 'temperatura', 170.0000, 'ºC'),
	(255509, 121, '2014-03-15 00:28:05.000000', 'temperatura', 161.0000, 'ºC'),
	(255510, 121, '2014-03-15 00:28:06.000000', 'temperatura', 296.0000, 'ºC'),
	(255511, 121, '2014-03-15 00:28:07.000000', 'temperatura', 999.0000, 'ºC'),
	(255512, 121, '2014-03-15 00:28:08.000000', 'temperatura', 506.0000, 'ºC'),
	(255513, 121, '2014-03-15 00:28:09.000000', 'temperatura', 733.0000, 'ºC'),
	(255514, 121, '2014-03-15 00:28:10.000000', 'temperatura', 950.0000, 'ºC'),
	(255515, 121, '2014-03-15 00:28:11.000000', 'temperatura', 149.0000, 'ºC'),
	(255516, 121, '2014-03-15 00:28:12.000000', 'temperatura', 298.0000, 'ºC'),
	(255517, 121, '2014-03-15 00:28:13.000000', 'temperatura', 1044.0000, 'ºC'),
	(255518, 121, '2014-03-15 00:28:14.000000', 'temperatura', 723.0000, 'ºC'),
	(255519, 121, '2014-03-15 00:28:15.000000', 'temperatura', 487.0000, 'ºC'),
	(255520, 121, '2014-03-15 00:28:16.000000', 'temperatura', 265.0000, 'ºC'),
	(255521, 121, '2014-03-15 00:28:17.000000', 'temperatura', 1067.0000, 'ºC'),
	(255522, 121, '2014-03-15 00:28:18.000000', 'temperatura', 937.0000, 'ºC'),
	(255523, 121, '2014-03-15 00:28:19.000000', 'temperatura', 287.0000, 'ºC'),
	(255524, 121, '2014-03-15 00:28:20.000000', 'temperatura', 1022.0000, 'ºC'),
	(255525, 121, '2014-03-15 00:28:21.000000', 'temperatura', 650.0000, 'ºC'),
	(255526, 121, '2014-03-15 00:28:22.000000', 'temperatura', 183.0000, 'ºC'),
	(255527, 121, '2014-03-15 00:28:23.000000', 'temperatura', 169.0000, 'ºC'),
	(255528, 121, '2014-03-15 00:28:24.000000', 'temperatura', 295.0000, 'ºC'),
	(255529, 121, '2014-03-15 00:28:25.000000', 'temperatura', 967.0000, 'ºC'),
	(255530, 121, '2014-03-15 00:28:26.000000', 'temperatura', 353.0000, 'ºC'),
	(255531, 121, '2014-03-15 00:28:27.000000', 'temperatura', 65.0000, 'ºC'),
	(255532, 121, '2014-03-15 00:28:28.000000', 'temperatura', 466.0000, 'ºC'),
	(255533, 121, '2014-03-15 00:28:29.000000', 'temperatura', 935.0000, 'ºC'),
	(255534, 121, '2014-03-15 00:28:30.000000', 'temperatura', 877.0000, 'ºC'),
	(255535, 121, '2014-03-15 00:28:31.000000', 'temperatura', 380.0000, 'ºC'),
	(255536, 121, '2014-03-15 00:28:32.000000', 'temperatura', 470.0000, 'ºC'),
	(255537, 121, '2014-03-15 00:28:33.000000', 'temperatura', 11.0000, 'ºC'),
	(255538, 121, '2014-03-15 00:28:34.000000', 'temperatura', 1044.0000, 'ºC'),
	(255539, 121, '2014-03-15 00:28:35.000000', 'temperatura', 386.0000, 'ºC'),
	(255540, 121, '2014-03-15 00:28:36.000000', 'temperatura', 1.0000, 'ºC'),
	(255541, 121, '2014-03-15 00:28:37.000000', 'temperatura', 48.0000, 'ºC'),
	(255542, 121, '2014-03-15 00:28:38.000000', 'temperatura', 237.0000, 'ºC'),
	(255543, 121, '2014-03-15 00:28:39.000000', 'temperatura', 1042.0000, 'ºC'),
	(255544, 121, '2014-03-15 00:28:40.000000', 'temperatura', 899.0000, 'ºC'),
	(255545, 121, '2014-03-15 00:28:41.000000', 'temperatura', 168.0000, 'ºC'),
	(255546, 121, '2014-03-15 00:28:42.000000', 'temperatura', 546.0000, 'ºC'),
	(255547, 121, '2014-03-15 00:28:43.000000', 'temperatura', 1025.0000, 'ºC'),
	(255548, 121, '2014-03-15 00:28:44.000000', 'temperatura', 1089.0000, 'ºC'),
	(255549, 121, '2014-03-15 00:28:45.000000', 'temperatura', 1169.0000, 'ºC'),
	(255550, 121, '2014-03-15 00:28:46.000000', 'temperatura', 180.0000, 'ºC'),
	(255551, 121, '2014-03-15 00:28:47.000000', 'temperatura', 994.0000, 'ºC'),
	(255552, 121, '2014-03-15 00:28:48.000000', 'temperatura', 829.0000, 'ºC'),
	(255553, 121, '2014-03-15 00:28:49.000000', 'temperatura', 1164.0000, 'ºC'),
	(255554, 121, '2014-03-15 00:28:50.000000', 'temperatura', 935.0000, 'ºC'),
	(255555, 121, '2014-03-15 00:28:51.000000', 'temperatura', 1182.0000, 'ºC'),
	(255556, 121, '2014-03-15 00:28:52.000000', 'temperatura', 707.0000, 'ºC'),
	(255557, 121, '2014-03-15 00:28:53.000000', 'temperatura', 1189.0000, 'ºC'),
	(255558, 121, '2014-03-15 00:28:54.000000', 'temperatura', 223.0000, 'ºC'),
	(255559, 121, '2014-03-15 00:28:55.000000', 'temperatura', 1151.0000, 'ºC'),
	(255560, 121, '2014-03-15 00:28:56.000000', 'temperatura', 284.0000, 'ºC'),
	(255561, 121, '2014-03-15 00:28:57.000000', 'temperatura', 366.0000, 'ºC'),
	(255562, 121, '2014-03-15 00:28:58.000000', 'temperatura', 982.0000, 'ºC'),
	(255563, 121, '2014-03-15 00:28:59.000000', 'temperatura', 211.0000, 'ºC'),
	(255564, 121, '2014-03-15 00:29:00.000000', 'temperatura', 511.0000, 'ºC'),
	(255565, 121, '2014-03-15 00:29:01.000000', 'temperatura', 723.0000, 'ºC'),
	(255566, 121, '2014-03-15 00:29:02.000000', 'temperatura', 883.0000, 'ºC'),
	(255567, 121, '2014-03-15 00:29:03.000000', 'temperatura', 1046.0000, 'ºC'),
	(255568, 121, '2014-03-15 00:29:04.000000', 'temperatura', 182.0000, 'ºC'),
	(255569, 121, '2014-03-15 00:29:05.000000', 'temperatura', 171.0000, 'ºC'),
	(255570, 121, '2014-03-15 00:29:06.000000', 'temperatura', 312.0000, 'ºC'),
	(255571, 121, '2014-03-15 00:29:07.000000', 'temperatura', 1044.0000, 'ºC'),
	(255572, 121, '2014-03-15 00:29:08.000000', 'temperatura', 687.0000, 'ºC'),
	(255573, 121, '2014-03-15 00:29:09.000000', 'temperatura', 302.0000, 'ºC'),
	(255574, 121, '2014-03-15 00:29:10.000000', 'temperatura', 648.0000, 'ºC'),
	(255575, 121, '2014-03-15 00:29:11.000000', 'temperatura', 1137.0000, 'ºC'),
	(255576, 121, '2014-03-15 00:29:12.000000', 'temperatura', 140.0000, 'ºC'),
	(255577, 121, '2014-03-15 00:29:13.000000', 'temperatura', 892.0000, 'ºC'),
	(255578, 121, '2014-03-15 00:29:14.000000', 'temperatura', 440.0000, 'ºC'),
	(255579, 121, '2014-03-15 00:29:15.000000', 'temperatura', 723.0000, 'ºC'),
	(255580, 121, '2014-03-15 00:29:16.000000', 'temperatura', 1096.0000, 'ºC'),
	(255581, 121, '2014-03-15 00:29:17.000000', 'temperatura', 912.0000, 'ºC'),
	(255582, 121, '2014-03-15 00:29:18.000000', 'temperatura', 71.0000, 'ºC'),
	(255583, 121, '2014-03-15 00:29:19.000000', 'temperatura', 21.0000, 'ºC'),
	(255584, 121, '2014-03-15 00:29:20.000000', 'temperatura', 1091.0000, 'ºC'),
	(255585, 121, '2014-03-15 00:29:21.000000', 'temperatura', 593.0000, 'ºC'),
	(255586, 121, '2014-03-15 00:29:22.000000', 'temperatura', 893.0000, 'ºC'),
	(255587, 121, '2014-03-15 00:29:23.000000', 'temperatura', 286.0000, 'ºC'),
	(255588, 121, '2014-03-15 00:29:24.000000', 'temperatura', 1154.0000, 'ºC'),
	(255589, 121, '2014-03-15 00:29:25.000000', 'temperatura', 109.0000, 'ºC'),
	(255590, 121, '2014-03-15 00:29:26.000000', 'temperatura', 686.0000, 'ºC'),
	(255591, 121, '2014-03-15 00:29:27.000000', 'temperatura', 701.0000, 'ºC'),
	(255592, 121, '2014-03-15 00:29:28.000000', 'temperatura', 250.0000, 'ºC'),
	(255593, 121, '2014-03-15 00:29:29.000000', 'temperatura', 345.0000, 'ºC'),
	(255594, 121, '2014-03-15 00:29:30.000000', 'temperatura', 975.0000, 'ºC'),
	(255595, 121, '2014-03-15 00:29:31.000000', 'temperatura', 242.0000, 'ºC'),
	(255596, 121, '2014-03-15 00:29:32.000000', 'temperatura', 684.0000, 'ºC'),
	(255597, 121, '2014-03-15 00:29:33.000000', 'temperatura', 296.0000, 'ºC'),
	(255598, 121, '2014-03-15 00:29:34.000000', 'temperatura', 626.0000, 'ºC'),
	(255599, 121, '2014-03-15 00:29:35.000000', 'temperatura', 1044.0000, 'ºC'),
	(255600, 121, '2014-03-15 00:29:36.000000', 'temperatura', 944.0000, 'ºC'),
	(255601, 121, '2014-03-15 00:29:37.000000', 'temperatura', 388.0000, 'ºC'),
	(255602, 121, '2014-03-15 00:29:38.000000', 'temperatura', 308.0000, 'ºC'),
	(255603, 121, '2014-03-15 00:29:39.000000', 'temperatura', 376.0000, 'ºC'),
	(255604, 121, '2014-03-15 00:29:40.000000', 'temperatura', 956.0000, 'ºC'),
	(255605, 121, '2014-03-15 00:29:41.000000', 'temperatura', 52.0000, 'ºC'),
	(255606, 121, '2014-03-15 00:29:42.000000', 'temperatura', 994.0000, 'ºC'),
	(255607, 121, '2014-03-15 00:29:43.000000', 'temperatura', 16.0000, 'ºC'),
	(255608, 121, '2014-03-15 00:29:44.000000', 'temperatura', 698.0000, 'ºC'),
	(255609, 121, '2014-03-15 00:29:45.000000', 'temperatura', 1040.0000, 'ºC'),
	(255610, 121, '2014-03-15 00:29:46.000000', 'temperatura', 709.0000, 'ºC'),
	(255611, 121, '2014-03-15 00:29:47.000000', 'temperatura', 423.0000, 'ºC'),
	(255612, 121, '2014-03-15 00:29:48.000000', 'temperatura', 1191.0000, 'ºC'),
	(255613, 121, '2014-03-15 00:29:49.000000', 'temperatura', 1086.0000, 'ºC'),
	(255614, 121, '2014-03-15 00:29:50.000000', 'temperatura', 659.0000, 'ºC'),
	(255615, 121, '2014-03-15 00:29:51.000000', 'temperatura', 37.0000, 'ºC'),
	(255616, 121, '2014-03-15 00:29:52.000000', 'temperatura', 608.0000, 'ºC'),
	(255617, 121, '2014-03-15 00:29:53.000000', 'temperatura', 528.0000, 'ºC'),
	(255618, 121, '2014-03-15 00:29:54.000000', 'temperatura', 818.0000, 'ºC'),
	(255619, 121, '2014-03-15 00:29:55.000000', 'temperatura', 105.0000, 'ºC'),
	(255620, 121, '2014-03-15 00:29:56.000000', 'temperatura', 471.0000, 'ºC'),
	(255621, 121, '2014-03-15 00:29:57.000000', 'temperatura', 842.0000, 'ºC'),
	(255622, 121, '2014-03-15 00:29:58.000000', 'temperatura', 396.0000, 'ºC'),
	(255623, 121, '2014-03-15 00:29:59.000000', 'temperatura', 656.0000, 'ºC'),
	(255624, 121, '2014-03-15 00:30:00.000000', 'temperatura', 892.0000, 'ºC'),
	(255625, 121, '2014-03-15 00:30:01.000000', 'temperatura', 93.0000, 'ºC'),
	(255626, 121, '2014-03-15 00:30:02.000000', 'temperatura', 189.0000, 'ºC'),
	(255627, 121, '2014-03-15 00:30:03.000000', 'temperatura', 668.0000, 'ºC'),
	(255628, 121, '2014-03-15 00:30:04.000000', 'temperatura', 374.0000, 'ºC'),
	(255629, 121, '2014-03-15 00:30:05.000000', 'temperatura', 1063.0000, 'ºC'),
	(255630, 121, '2014-03-15 00:30:06.000000', 'temperatura', 597.0000, 'ºC'),
	(255631, 121, '2014-03-15 00:30:07.000000', 'temperatura', 994.0000, 'ºC'),
	(255632, 121, '2014-03-15 00:30:08.000000', 'temperatura', 780.0000, 'ºC'),
	(255633, 121, '2014-03-15 00:30:09.000000', 'temperatura', 921.0000, 'ºC'),
	(255634, 121, '2014-03-15 00:30:10.000000', 'temperatura', 1062.0000, 'ºC'),
	(255635, 121, '2014-03-15 00:30:11.000000', 'temperatura', 149.0000, 'ºC'),
	(255636, 121, '2014-03-15 00:30:12.000000', 'temperatura', 1158.0000, 'ºC'),
	(255637, 121, '2014-03-15 00:30:13.000000', 'temperatura', 543.0000, 'ºC'),
	(255638, 121, '2014-03-15 00:30:14.000000', 'temperatura', 441.0000, 'ºC'),
	(255639, 121, '2014-03-15 00:30:15.000000', 'temperatura', 577.0000, 'ºC'),
	(255640, 121, '2014-03-15 00:30:16.000000', 'temperatura', 363.0000, 'ºC'),
	(255641, 121, '2014-03-15 00:30:17.000000', 'temperatura', 83.0000, 'ºC'),
	(255642, 121, '2014-03-15 00:30:18.000000', 'temperatura', 529.0000, 'ºC'),
	(255643, 121, '2014-03-15 00:30:19.000000', 'temperatura', 1193.0000, 'ºC'),
	(255644, 121, '2014-03-15 00:30:20.000000', 'temperatura', 782.0000, 'ºC'),
	(255645, 121, '2014-03-15 00:30:21.000000', 'temperatura', 330.0000, 'ºC'),
	(255646, 121, '2014-03-15 00:30:22.000000', 'temperatura', 505.0000, 'ºC'),
	(255647, 121, '2014-03-15 00:30:23.000000', 'temperatura', 336.0000, 'ºC'),
	(255648, 121, '2014-03-15 00:30:24.000000', 'temperatura', 166.0000, 'ºC'),
	(255649, 121, '2014-03-15 00:30:25.000000', 'temperatura', 1020.0000, 'ºC'),
	(255650, 121, '2014-03-15 00:30:26.000000', 'temperatura', 1005.0000, 'ºC'),
	(255651, 121, '2014-03-15 00:30:27.000000', 'temperatura', 764.0000, 'ºC'),
	(255652, 121, '2014-03-15 00:30:28.000000', 'temperatura', 806.0000, 'ºC'),
	(255653, 121, '2014-03-15 00:30:29.000000', 'temperatura', 538.0000, 'ºC'),
	(255654, 121, '2014-03-15 00:30:30.000000', 'temperatura', 271.0000, 'ºC'),
	(255655, 121, '2014-03-15 00:30:31.000000', 'temperatura', 943.0000, 'ºC'),
	(255656, 121, '2014-03-15 00:30:32.000000', 'temperatura', 301.0000, 'ºC'),
	(255657, 121, '2014-03-15 00:30:33.000000', 'temperatura', 1076.0000, 'ºC'),
	(255658, 121, '2014-03-15 00:30:34.000000', 'temperatura', 880.0000, 'ºC'),
	(255659, 121, '2014-03-15 00:30:35.000000', 'temperatura', 1171.0000, 'ºC'),
	(255660, 121, '2014-03-15 00:30:36.000000', 'temperatura', 817.0000, 'ºC'),
	(255661, 121, '2014-03-15 00:30:37.000000', 'temperatura', 574.0000, 'ºC'),
	(255662, 121, '2014-03-15 00:30:38.000000', 'temperatura', 417.0000, 'ºC'),
	(255663, 121, '2014-03-15 00:30:39.000000', 'temperatura', 362.0000, 'ºC'),
	(255664, 121, '2014-03-15 00:30:40.000000', 'temperatura', 562.0000, 'ºC'),
	(255665, 121, '2014-03-15 00:30:41.000000', 'temperatura', 522.0000, 'ºC'),
	(255666, 121, '2014-03-15 00:30:42.000000', 'temperatura', 925.0000, 'ºC'),
	(255667, 121, '2014-03-15 00:30:43.000000', 'temperatura', 660.0000, 'ºC'),
	(255668, 121, '2014-03-15 00:30:44.000000', 'temperatura', 527.0000, 'ºC'),
	(255669, 121, '2014-03-15 00:30:45.000000', 'temperatura', 654.0000, 'ºC'),
	(255670, 121, '2014-03-15 00:30:46.000000', 'temperatura', 490.0000, 'ºC'),
	(255671, 121, '2014-03-15 00:30:47.000000', 'temperatura', 489.0000, 'ºC'),
	(255672, 121, '2014-03-15 00:30:48.000000', 'temperatura', 976.0000, 'ºC'),
	(255673, 121, '2014-03-15 00:30:49.000000', 'temperatura', 1014.0000, 'ºC'),
	(255674, 121, '2014-03-15 00:30:50.000000', 'temperatura', 943.0000, 'ºC'),
	(255675, 121, '2014-03-15 00:30:51.000000', 'temperatura', 471.0000, 'ºC'),
	(255676, 121, '2014-03-15 00:30:52.000000', 'temperatura', 730.0000, 'ºC'),
	(255677, 121, '2014-03-15 00:30:53.000000', 'temperatura', 1035.0000, 'ºC'),
	(255678, 121, '2014-03-15 00:30:54.000000', 'temperatura', 585.0000, 'ºC'),
	(255679, 121, '2014-03-15 00:30:55.000000', 'temperatura', 1021.0000, 'ºC'),
	(255680, 121, '2014-03-15 00:30:56.000000', 'temperatura', 951.0000, 'ºC'),
	(255681, 121, '2014-03-15 00:30:57.000000', 'temperatura', 491.0000, 'ºC'),
	(255682, 121, '2014-03-15 00:30:58.000000', 'temperatura', 802.0000, 'ºC'),
	(255683, 121, '2014-03-15 00:30:59.000000', 'temperatura', 139.0000, 'ºC'),
	(255684, 121, '2014-03-15 00:31:00.000000', 'temperatura', 688.0000, 'ºC'),
	(255685, 121, '2014-03-15 00:31:01.000000', 'temperatura', 624.0000, 'ºC'),
	(255686, 121, '2014-03-15 00:31:02.000000', 'temperatura', 1058.0000, 'ºC'),
	(255687, 121, '2014-03-15 00:31:03.000000', 'temperatura', 1019.0000, 'ºC'),
	(255688, 121, '2014-03-15 00:31:04.000000', 'temperatura', 720.0000, 'ºC'),
	(255689, 121, '2014-03-15 00:31:05.000000', 'temperatura', 542.0000, 'ºC'),
	(255690, 121, '2014-03-15 00:31:06.000000', 'temperatura', 553.0000, 'ºC'),
	(255691, 121, '2014-03-15 00:31:07.000000', 'temperatura', 1138.0000, 'ºC'),
	(255692, 121, '2014-03-15 00:31:08.000000', 'temperatura', 434.0000, 'ºC'),
	(255693, 121, '2014-03-15 00:31:09.000000', 'temperatura', 1155.0000, 'ºC'),
	(255694, 121, '2014-03-15 00:31:10.000000', 'temperatura', 872.0000, 'ºC'),
	(255695, 121, '2014-03-15 00:31:11.000000', 'temperatura', 898.0000, 'ºC'),
	(255696, 121, '2014-03-15 00:31:12.000000', 'temperatura', 675.0000, 'ºC'),
	(255697, 121, '2014-03-15 00:31:13.000000', 'temperatura', 680.0000, 'ºC'),
	(255698, 121, '2014-03-15 00:31:14.000000', 'temperatura', 177.0000, 'ºC'),
	(255699, 121, '2014-03-15 00:31:15.000000', 'temperatura', 46.0000, 'ºC'),
	(255700, 121, '2014-03-15 00:31:16.000000', 'temperatura', 900.0000, 'ºC'),
	(255701, 121, '2014-03-15 00:31:17.000000', 'temperatura', 762.0000, 'ºC'),
	(255702, 121, '2014-03-15 00:31:18.000000', 'temperatura', 1110.0000, 'ºC'),
	(255703, 121, '2014-03-15 00:31:19.000000', 'temperatura', 866.0000, 'ºC'),
	(255704, 121, '2014-03-15 00:31:20.000000', 'temperatura', 998.0000, 'ºC'),
	(255705, 121, '2014-03-15 00:31:21.000000', 'temperatura', 1195.0000, 'ºC'),
	(255706, 121, '2014-03-15 00:31:22.000000', 'temperatura', 580.0000, 'ºC'),
	(255707, 121, '2014-03-15 00:31:23.000000', 'temperatura', 518.0000, 'ºC'),
	(255708, 121, '2014-03-15 00:31:24.000000', 'temperatura', 848.0000, 'ºC'),
	(255709, 121, '2014-03-15 00:31:25.000000', 'temperatura', 287.0000, 'ºC'),
	(255710, 121, '2014-03-15 00:31:26.000000', 'temperatura', 90.0000, 'ºC'),
	(255711, 121, '2014-03-15 00:31:27.000000', 'temperatura', 790.0000, 'ºC'),
	(255712, 121, '2014-03-15 00:31:28.000000', 'temperatura', 81.0000, 'ºC'),
	(255713, 121, '2014-03-15 00:31:29.000000', 'temperatura', 435.0000, 'ºC'),
	(255714, 121, '2014-03-15 00:31:30.000000', 'temperatura', 732.0000, 'ºC'),
	(255715, 121, '2014-03-15 00:31:31.000000', 'temperatura', 1158.0000, 'ºC'),
	(255716, 121, '2014-03-15 00:31:32.000000', 'temperatura', 1192.0000, 'ºC'),
	(255717, 121, '2014-03-15 00:31:33.000000', 'temperatura', 87.0000, 'ºC'),
	(255718, 121, '2014-03-15 00:31:34.000000', 'temperatura', 461.0000, 'ºC'),
	(255719, 121, '2014-03-15 00:31:35.000000', 'temperatura', 845.0000, 'ºC'),
	(255720, 121, '2014-03-15 00:31:36.000000', 'temperatura', 440.0000, 'ºC'),
	(255721, 121, '2014-03-15 00:31:37.000000', 'temperatura', 867.0000, 'ºC'),
	(255722, 121, '2014-03-15 00:31:38.000000', 'temperatura', 616.0000, 'ºC'),
	(255723, 121, '2014-03-15 00:31:39.000000', 'temperatura', 481.0000, 'ºC'),
	(255724, 121, '2014-03-15 00:31:40.000000', 'temperatura', 555.0000, 'ºC'),
	(255725, 121, '2014-03-15 00:31:41.000000', 'temperatura', 135.0000, 'ºC'),
	(255726, 121, '2014-03-15 00:31:42.000000', 'temperatura', 207.0000, 'ºC'),
	(255727, 121, '2014-03-15 00:31:43.000000', 'temperatura', 634.0000, 'ºC'),
	(255728, 121, '2014-03-15 00:31:44.000000', 'temperatura', 146.0000, 'ºC'),
	(255729, 121, '2014-03-15 00:31:45.000000', 'temperatura', 30.0000, 'ºC'),
	(255730, 121, '2014-03-15 00:31:46.000000', 'temperatura', 914.0000, 'ºC'),
	(255731, 121, '2014-03-15 00:31:47.000000', 'temperatura', 879.0000, 'ºC'),
	(255732, 121, '2014-03-15 00:31:48.000000', 'temperatura', 453.0000, 'ºC'),
	(255733, 121, '2014-03-15 00:31:49.000000', 'temperatura', 830.0000, 'ºC'),
	(255734, 121, '2014-03-15 00:31:50.000000', 'temperatura', 390.0000, 'ºC'),
	(255735, 121, '2014-03-15 00:31:51.000000', 'temperatura', 660.0000, 'ºC'),
	(255736, 121, '2014-03-15 00:31:52.000000', 'temperatura', 930.0000, 'ºC'),
	(255737, 121, '2014-03-15 00:31:53.000000', 'temperatura', 271.0000, 'ºC'),
	(255738, 121, '2014-03-15 00:31:54.000000', 'temperatura', 967.0000, 'ºC'),
	(255739, 121, '2014-03-15 00:31:55.000000', 'temperatura', 422.0000, 'ºC'),
	(255740, 121, '2014-03-15 00:31:56.000000', 'temperatura', 408.0000, 'ºC'),
	(255741, 121, '2014-03-15 00:31:57.000000', 'temperatura', 775.0000, 'ºC'),
	(255742, 121, '2014-03-15 00:31:58.000000', 'temperatura', 251.0000, 'ºC'),
	(255743, 121, '2014-03-15 00:31:59.000000', 'temperatura', 130.0000, 'ºC'),
	(255744, 121, '2014-03-15 00:32:00.000000', 'temperatura', 1100.0000, 'ºC'),
	(255745, 121, '2014-03-15 00:32:01.000000', 'temperatura', 311.0000, 'ºC'),
	(255746, 121, '2014-03-15 00:32:02.000000', 'temperatura', 652.0000, 'ºC'),
	(255747, 121, '2014-03-15 00:32:03.000000', 'temperatura', 1130.0000, 'ºC'),
	(255748, 121, '2014-03-15 00:32:04.000000', 'temperatura', 95.0000, 'ºC'),
	(255749, 121, '2014-03-15 00:32:05.000000', 'temperatura', 684.0000, 'ºC'),
	(255750, 121, '2014-03-15 00:32:06.000000', 'temperatura', 734.0000, 'ºC'),
	(255751, 121, '2014-03-15 00:32:07.000000', 'temperatura', 421.0000, 'ºC'),
	(255752, 121, '2014-03-15 00:32:08.000000', 'temperatura', 1103.0000, 'ºC'),
	(255753, 121, '2014-03-15 00:32:09.000000', 'temperatura', 652.0000, 'ºC'),
	(255754, 121, '2014-03-15 00:32:10.000000', 'temperatura', 1151.0000, 'ºC'),
	(255755, 121, '2014-03-15 00:32:11.000000', 'temperatura', 200.0000, 'ºC'),
	(255756, 121, '2014-03-15 00:32:12.000000', 'temperatura', 1147.0000, 'ºC'),
	(255757, 121, '2014-03-15 00:32:13.000000', 'temperatura', 334.0000, 'ºC'),
	(255758, 121, '2014-03-15 00:32:14.000000', 'temperatura', 630.0000, 'ºC'),
	(255759, 121, '2014-03-15 00:32:15.000000', 'temperatura', 950.0000, 'ºC'),
	(255760, 121, '2014-03-15 00:32:16.000000', 'temperatura', 461.0000, 'ºC'),
	(255761, 121, '2014-03-15 00:32:17.000000', 'temperatura', 653.0000, 'ºC'),
	(255762, 121, '2014-03-15 00:32:18.000000', 'temperatura', 683.0000, 'ºC'),
	(255763, 121, '2014-03-15 00:32:19.000000', 'temperatura', 255.0000, 'ºC'),
	(255764, 121, '2014-03-15 00:32:20.000000', 'temperatura', 428.0000, 'ºC'),
	(255765, 121, '2014-03-15 00:32:21.000000', 'temperatura', 177.0000, 'ºC'),
	(255766, 121, '2014-03-15 00:32:22.000000', 'temperatura', 802.0000, 'ºC'),
	(255767, 121, '2014-03-15 00:32:23.000000', 'temperatura', 1079.0000, 'ºC'),
	(255768, 121, '2014-03-15 00:32:24.000000', 'temperatura', 589.0000, 'ºC'),
	(255769, 121, '2014-03-15 00:32:25.000000', 'temperatura', 910.0000, 'ºC'),
	(255770, 121, '2014-03-15 00:32:26.000000', 'temperatura', 382.0000, 'ºC'),
	(255771, 121, '2014-03-15 00:32:27.000000', 'temperatura', 380.0000, 'ºC'),
	(255772, 121, '2014-03-15 00:32:28.000000', 'temperatura', 755.0000, 'ºC'),
	(255773, 121, '2014-03-15 00:32:29.000000', 'temperatura', 236.0000, 'ºC'),
	(255774, 121, '2014-03-15 00:32:30.000000', 'temperatura', 113.0000, 'ºC'),
	(255775, 121, '2014-03-15 00:32:31.000000', 'temperatura', 1060.0000, 'ºC'),
	(255776, 121, '2014-03-15 00:32:32.000000', 'temperatura', 160.0000, 'ºC'),
	(255777, 121, '2014-03-15 00:32:33.000000', 'temperatura', 21.0000, 'ºC'),
	(255778, 121, '2014-03-15 00:32:34.000000', 'temperatura', 827.0000, 'ºC'),
	(255779, 121, '2014-03-15 00:32:35.000000', 'temperatura', 474.0000, 'ºC'),
	(255780, 121, '2014-03-15 00:32:36.000000', 'temperatura', 1086.0000, 'ºC'),
	(255781, 121, '2014-03-15 00:32:37.000000', 'temperatura', 409.0000, 'ºC'),
	(255782, 121, '2014-03-15 00:32:38.000000', 'temperatura', 1190.0000, 'ºC'),
	(255783, 121, '2014-03-15 00:32:39.000000', 'temperatura', 1123.0000, 'ºC'),
	(255784, 121, '2014-03-15 00:32:40.000000', 'temperatura', 844.0000, 'ºC'),
	(255785, 121, '2014-03-15 00:32:41.000000', 'temperatura', 850.0000, 'ºC'),
	(255786, 121, '2014-03-15 00:32:42.000000', 'temperatura', 521.0000, 'ºC'),
	(255787, 121, '2014-03-15 00:32:43.000000', 'temperatura', 53.0000, 'ºC'),
	(255788, 121, '2014-03-15 00:32:44.000000', 'temperatura', 1104.0000, 'ºC'),
	(255789, 121, '2014-03-15 00:32:45.000000', 'temperatura', 560.0000, 'ºC'),
	(255790, 121, '2014-03-15 00:32:46.000000', 'temperatura', 689.0000, 'ºC'),
	(255791, 121, '2014-03-15 00:32:47.000000', 'temperatura', 568.0000, 'ºC'),
	(255792, 121, '2014-03-15 00:32:48.000000', 'temperatura', 772.0000, 'ºC'),
	(255793, 121, '2014-03-15 00:32:49.000000', 'temperatura', 955.0000, 'ºC'),
	(255794, 121, '2014-03-15 00:32:50.000000', 'temperatura', 59.0000, 'ºC'),
	(255795, 121, '2014-03-15 00:32:51.000000', 'temperatura', 1031.0000, 'ºC'),
	(255796, 121, '2014-03-15 00:32:52.000000', 'temperatura', 179.0000, 'ºC'),
	(255797, 121, '2014-03-15 00:32:53.000000', 'temperatura', 201.0000, 'ºC'),
	(255798, 121, '2014-03-15 00:32:54.000000', 'temperatura', 471.0000, 'ºC'),
	(255799, 121, '2014-03-15 00:32:55.000000', 'temperatura', 552.0000, 'ºC'),
	(255800, 121, '2014-03-15 00:32:56.000000', 'temperatura', 147.0000, 'ºC'),
	(255801, 121, '2014-03-15 00:32:57.000000', 'temperatura', 281.0000, 'ºC'),
	(255802, 121, '2014-03-15 00:32:58.000000', 'temperatura', 966.0000, 'ºC'),
	(255803, 121, '2014-03-15 00:32:59.000000', 'temperatura', 384.0000, 'ºC'),
	(255804, 121, '2014-03-15 00:33:00.000000', 'temperatura', 225.0000, 'ºC'),
	(255805, 121, '2014-03-15 00:33:01.000000', 'temperatura', 1172.0000, 'ºC'),
	(255806, 121, '2014-03-15 00:33:02.000000', 'temperatura', 385.0000, 'ºC'),
	(255807, 121, '2014-03-15 00:33:03.000000', 'temperatura', 812.0000, 'ºC'),
	(255808, 121, '2014-03-15 00:33:04.000000', 'temperatura', 504.0000, 'ºC'),
	(255809, 121, '2014-03-15 00:33:05.000000', 'temperatura', 83.0000, 'ºC'),
	(255810, 121, '2014-03-15 00:33:06.000000', 'temperatura', 105.0000, 'ºC'),
	(255811, 121, '2014-03-15 00:33:07.000000', 'temperatura', 277.0000, 'ºC'),
	(255812, 121, '2014-03-15 00:33:08.000000', 'temperatura', 1070.0000, 'ºC'),
	(255813, 121, '2014-03-15 00:33:09.000000', 'temperatura', 918.0000, 'ºC'),
	(255814, 121, '2014-03-15 00:33:10.000000', 'temperatura', 182.0000, 'ºC'),
	(255815, 121, '2014-03-15 00:33:11.000000', 'temperatura', 556.0000, 'ºC'),
	(255816, 121, '2014-03-15 00:33:12.000000', 'temperatura', 1037.0000, 'ºC'),
	(255817, 121, '2014-03-15 00:33:13.000000', 'temperatura', 1114.0000, 'ºC'),
	(255818, 121, '2014-03-15 00:33:14.000000', 'temperatura', 60.0000, 'ºC'),
	(255819, 121, '2014-03-15 00:33:15.000000', 'temperatura', 560.0000, 'ºC'),
	(255820, 121, '2014-03-15 00:33:16.000000', 'temperatura', 219.0000, 'ºC'),
	(255821, 121, '2014-03-15 00:33:17.000000', 'temperatura', 615.0000, 'ºC'),
	(255822, 121, '2014-03-15 00:33:18.000000', 'temperatura', 19.0000, 'ºC'),
	(255823, 121, '2014-03-15 00:33:19.000000', 'temperatura', 649.0000, 'ºC'),
	(255824, 121, '2014-03-15 00:33:20.000000', 'temperatura', 791.0000, 'ºC'),
	(255825, 121, '2014-03-15 00:33:21.000000', 'temperatura', 809.0000, 'ºC'),
	(255826, 121, '2014-03-15 00:33:22.000000', 'temperatura', 473.0000, 'ºC'),
	(255827, 121, '2014-03-15 00:33:23.000000', 'temperatura', 1140.0000, 'ºC'),
	(255828, 121, '2014-03-15 00:33:24.000000', 'temperatura', 678.0000, 'ºC'),
	(255829, 121, '2014-03-15 00:33:25.000000', 'temperatura', 1172.0000, 'ºC'),
	(255830, 121, '2014-03-15 00:33:26.000000', 'temperatura', 226.0000, 'ºC'),
	(255831, 121, '2014-03-15 00:33:27.000000', 'temperatura', 13.0000, 'ºC'),
	(255832, 121, '2014-03-15 00:33:28.000000', 'temperatura', 588.0000, 'ºC'),
	(255833, 121, '2014-03-15 00:33:29.000000', 'temperatura', 502.0000, 'ºC'),
	(255834, 121, '2014-03-15 00:33:30.000000', 'temperatura', 748.0000, 'ºC'),
	(255835, 121, '2014-03-15 00:33:31.000000', 'temperatura', 1031.0000, 'ºC'),
	(255836, 121, '2014-03-15 00:33:32.000000', 'temperatura', 515.0000, 'ºC'),
	(255837, 121, '2014-03-15 00:33:33.000000', 'temperatura', 679.0000, 'ºC'),
	(255838, 121, '2014-03-15 00:33:34.000000', 'temperatura', 654.0000, 'ºC'),
	(255839, 121, '2014-03-15 00:33:35.000000', 'temperatura', 30.0000, 'ºC'),
	(255840, 121, '2014-03-15 00:33:36.000000', 'temperatura', 590.0000, 'ºC'),
	(255841, 121, '2014-03-15 00:33:37.000000', 'temperatura', 462.0000, 'ºC'),
	(255842, 121, '2014-03-15 00:33:38.000000', 'temperatura', 541.0000, 'ºC'),
	(255843, 121, '2014-03-15 00:33:39.000000', 'temperatura', 119.0000, 'ºC'),
	(255844, 121, '2014-03-15 00:33:40.000000', 'temperatura', 170.0000, 'ºC'),
	(255845, 121, '2014-03-15 00:33:41.000000', 'temperatura', 495.0000, 'ºC'),
	(255846, 121, '2014-03-15 00:33:42.000000', 'temperatura', 765.0000, 'ºC'),
	(255847, 121, '2014-03-15 00:33:43.000000', 'temperatura', 1142.0000, 'ºC'),
	(255848, 121, '2014-03-15 00:33:44.000000', 'temperatura', 1014.0000, 'ºC'),
	(255849, 121, '2014-03-15 00:33:45.000000', 'temperatura', 447.0000, 'ºC'),
	(255850, 121, '2014-03-15 00:33:46.000000', 'temperatura', 391.0000, 'ºC'),
	(255851, 121, '2014-03-15 00:33:47.000000', 'temperatura', 614.0000, 'ºC'),
	(255852, 121, '2014-03-15 00:33:48.000000', 'temperatura', 697.0000, 'ºC'),
	(255853, 121, '2014-03-15 00:33:49.000000', 'temperatura', 443.0000, 'ºC'),
	(255854, 121, '2014-03-15 00:33:50.000000', 'temperatura', 126.0000, 'ºC'),
	(255855, 121, '2014-03-15 00:33:51.000000', 'temperatura', 500.0000, 'ºC'),
	(255856, 121, '2014-03-15 00:33:52.000000', 'temperatura', 921.0000, 'ºC'),
	(255857, 121, '2014-03-15 00:33:53.000000', 'temperatura', 709.0000, 'ºC'),
	(255858, 121, '2014-03-15 00:33:54.000000', 'temperatura', 780.0000, 'ºC'),
	(255859, 121, '2014-03-15 00:33:55.000000', 'temperatura', 576.0000, 'ºC'),
	(255860, 121, '2014-03-15 00:33:56.000000', 'temperatura', 539.0000, 'ºC'),
	(255861, 121, '2014-03-15 00:33:57.000000', 'temperatura', 966.0000, 'ºC'),
	(255862, 121, '2014-03-15 00:33:58.000000', 'temperatura', 814.0000, 'ºC'),
	(255863, 121, '2014-03-15 00:33:59.000000', 'temperatura', 1175.0000, 'ºC'),
	(255864, 121, '2014-03-15 00:34:00.000000', 'temperatura', 1032.0000, 'ºC'),
	(255865, 121, '2014-03-15 00:34:01.000000', 'temperatura', 433.0000, 'ºC'),
	(255866, 121, '2014-03-15 00:34:02.000000', 'temperatura', 273.0000, 'ºC'),
	(255867, 121, '2014-03-15 00:34:03.000000', 'temperatura', 67.0000, 'ºC'),
	(255868, 121, '2014-03-15 00:34:04.000000', 'temperatura', 716.0000, 'ºC'),
	(255869, 121, '2014-03-15 00:34:05.000000', 'temperatura', 979.0000, 'ºC'),
	(255870, 121, '2014-03-15 00:34:06.000000', 'temperatura', 346.0000, 'ºC'),
	(255871, 121, '2014-03-15 00:34:07.000000', 'temperatura', 1196.0000, 'ºC'),
	(255872, 121, '2014-03-15 00:34:08.000000', 'temperatura', 140.0000, 'ºC'),
	(255873, 121, '2014-03-15 00:34:09.000000', 'temperatura', 712.0000, 'ºC'),
	(255874, 121, '2014-03-15 00:34:10.000000', 'temperatura', 744.0000, 'ºC'),
	(255875, 121, '2014-03-15 00:34:11.000000', 'temperatura', 381.0000, 'ºC'),
	(255876, 121, '2014-03-15 00:34:12.000000', 'temperatura', 876.0000, 'ºC'),
	(255877, 121, '2014-03-15 00:34:13.000000', 'temperatura', 835.0000, 'ºC'),
	(255878, 121, '2014-03-15 00:34:14.000000', 'temperatura', 350.0000, 'ºC'),
	(255879, 121, '2014-03-15 00:34:15.000000', 'temperatura', 446.0000, 'ºC'),
	(255880, 121, '2014-03-15 00:34:16.000000', 'temperatura', 1179.0000, 'ºC'),
	(255881, 121, '2014-03-15 00:34:17.000000', 'temperatura', 959.0000, 'ºC'),
	(255882, 121, '2014-03-15 00:34:18.000000', 'temperatura', 60.0000, 'ºC'),
	(255883, 121, '2014-03-15 00:34:19.000000', 'temperatura', 1021.0000, 'ºC'),
	(255884, 121, '2014-03-15 00:34:20.000000', 'temperatura', 124.0000, 'ºC'),
	(255885, 121, '2014-03-15 00:34:21.000000', 'temperatura', 1161.0000, 'ºC'),
	(255886, 121, '2014-03-15 00:34:22.000000', 'temperatura', 631.0000, 'ºC'),
	(255887, 121, '2014-03-15 00:34:23.000000', 'temperatura', 873.0000, 'ºC'),
	(255888, 121, '2014-03-15 00:34:24.000000', 'temperatura', 73.0000, 'ºC'),
	(255889, 121, '2014-03-15 00:34:25.000000', 'temperatura', 146.0000, 'ºC'),
	(255890, 121, '2014-03-15 00:34:26.000000', 'temperatura', 513.0000, 'ºC'),
	(255891, 121, '2014-03-15 00:34:27.000000', 'temperatura', 926.0000, 'ºC'),
	(255892, 121, '2014-03-15 00:34:28.000000', 'temperatura', 693.0000, 'ºC'),
	(255893, 121, '2014-03-15 00:34:29.000000', 'temperatura', 686.0000, 'ºC'),
	(255894, 121, '2014-03-15 00:34:30.000000', 'temperatura', 154.0000, 'ºC'),
	(255895, 121, '2014-03-15 00:34:31.000000', 'temperatura', 1110.0000, 'ºC'),
	(255896, 121, '2014-03-15 00:34:32.000000', 'temperatura', 291.0000, 'ºC'),
	(255897, 121, '2014-03-15 00:34:33.000000', 'temperatura', 524.0000, 'ºC'),
	(255898, 121, '2014-03-15 00:34:34.000000', 'temperatura', 548.0000, 'ºC'),
	(255899, 121, '2014-03-15 00:34:35.000000', 'temperatura', 1168.0000, 'ºC'),
	(255900, 121, '2014-03-15 00:34:36.000000', 'temperatura', 598.0000, 'ºC'),
	(255901, 121, '2014-03-15 00:34:37.000000', 'temperatura', 684.0000, 'ºC'),
	(255902, 121, '2014-03-15 00:34:38.000000', 'temperatura', 429.0000, 'ºC'),
	(255903, 121, '2014-03-15 00:34:39.000000', 'temperatura', 92.0000, 'ºC'),
	(255904, 121, '2014-03-15 00:34:40.000000', 'temperatura', 372.0000, 'ºC'),
	(255905, 121, '2014-03-15 00:34:41.000000', 'temperatura', 385.0000, 'ºC'),
	(255906, 121, '2014-03-15 00:34:42.000000', 'temperatura', 812.0000, 'ºC'),
	(255907, 121, '2014-03-15 00:34:43.000000', 'temperatura', 505.0000, 'ºC'),
	(255908, 121, '2014-03-15 00:34:44.000000', 'temperatura', 89.0000, 'ºC'),
	(255909, 121, '2014-03-15 00:34:45.000000', 'temperatura', 129.0000, 'ºC'),
	(255910, 121, '2014-03-15 00:34:46.000000', 'temperatura', 378.0000, 'ºC'),
	(255911, 121, '2014-03-15 00:34:47.000000', 'temperatura', 307.0000, 'ºC'),
	(255912, 121, '2014-03-15 00:34:48.000000', 'temperatura', 398.0000, 'ºC'),
	(255913, 121, '2014-03-15 00:34:49.000000', 'temperatura', 1071.0000, 'ºC'),
	(255914, 121, '2014-03-15 00:34:50.000000', 'temperatura', 562.0000, 'ºC'),
	(255915, 121, '2014-03-15 00:34:51.000000', 'temperatura', 796.0000, 'ºC'),
	(255916, 121, '2014-03-15 00:34:52.000000', 'temperatura', 1096.0000, 'ºC'),
	(255917, 121, '2014-03-15 00:34:53.000000', 'temperatura', 693.0000, 'ºC'),
	(255918, 121, '2014-03-15 00:34:54.000000', 'temperatura', 178.0000, 'ºC'),
	(255919, 121, '2014-03-15 00:34:55.000000', 'temperatura', 9.0000, 'ºC'),
	(255920, 121, '2014-03-15 00:34:56.000000', 'temperatura', 714.0000, 'ºC'),
	(255921, 121, '2014-03-15 00:34:57.000000', 'temperatura', 1141.0000, 'ºC'),
	(255922, 121, '2014-03-15 00:34:58.000000', 'temperatura', 1166.0000, 'ºC'),
	(255923, 121, '2014-03-15 00:34:59.000000', 'temperatura', 5.0000, 'ºC'),
	(255924, 121, '2014-03-15 00:35:00.000000', 'temperatura', 129.0000, 'ºC'),
	(255925, 121, '2014-03-15 00:35:01.000000', 'temperatura', 630.0000, 'ºC'),
	(255926, 121, '2014-03-15 00:35:02.000000', 'temperatura', 363.0000, 'ºC'),
	(255927, 121, '2014-03-15 00:35:03.000000', 'temperatura', 1125.0000, 'ºC'),
	(255928, 121, '2014-03-15 00:35:04.000000', 'temperatura', 939.0000, 'ºC'),
	(255929, 121, '2014-03-15 00:35:05.000000', 'temperatura', 120.0000, 'ºC'),
	(255930, 121, '2014-03-15 00:35:06.000000', 'temperatura', 182.0000, 'ºC'),
	(255931, 121, '2014-03-15 00:35:07.000000', 'temperatura', 551.0000, 'ºC'),
	(255932, 121, '2014-03-15 00:35:08.000000', 'temperatura', 1009.0000, 'ºC'),
	(255933, 121, '2014-03-15 00:35:09.000000', 'temperatura', 991.0000, 'ºC'),
	(255934, 121, '2014-03-15 00:35:10.000000', 'temperatura', 732.0000, 'ºC'),
	(255935, 121, '2014-03-15 00:35:11.000000', 'temperatura', 685.0000, 'ºC'),
	(255936, 121, '2014-03-15 00:35:12.000000', 'temperatura', 31.0000, 'ºC'),
	(255937, 121, '2014-03-15 00:35:13.000000', 'temperatura', 498.0000, 'ºC'),
	(255938, 121, '2014-03-15 00:35:14.000000', 'temperatura', 1.0000, 'ºC'),
	(255939, 121, '2014-03-15 00:35:15.000000', 'temperatura', 909.0000, 'ºC'),
	(255940, 121, '2014-03-15 00:35:16.000000', 'temperatura', 943.0000, 'ºC'),
	(255941, 121, '2014-03-15 00:35:17.000000', 'temperatura', 787.0000, 'ºC'),
	(255942, 121, '2014-03-15 00:35:18.000000', 'temperatura', 1108.0000, 'ºC'),
	(255943, 121, '2014-03-15 00:35:19.000000', 'temperatura', 778.0000, 'ºC'),
	(255944, 121, '2014-03-15 00:35:20.000000', 'temperatura', 565.0000, 'ºC'),
	(255945, 121, '2014-03-15 00:35:21.000000', 'temperatura', 495.0000, 'ºC'),
	(255946, 121, '2014-03-15 00:35:22.000000', 'temperatura', 779.0000, 'ºC'),
	(255947, 121, '2014-03-15 00:35:23.000000', 'temperatura', 12.0000, 'ºC'),
	(255948, 121, '2014-03-15 00:35:24.000000', 'temperatura', 123.0000, 'ºC'),
	(255949, 121, '2014-03-15 00:35:25.000000', 'temperatura', 579.0000, 'ºC'),
	(255950, 121, '2014-03-15 00:35:26.000000', 'temperatura', 127.0000, 'ºC'),
	(255951, 121, '2014-03-15 00:35:27.000000', 'temperatura', 98.0000, 'ºC'),
	(255952, 121, '2014-03-15 00:35:28.000000', 'temperatura', 110.0000, 'ºC'),
	(255953, 121, '2014-03-15 00:35:29.000000', 'temperatura', 257.0000, 'ºC'),
	(255954, 121, '2014-03-15 00:35:30.000000', 'temperatura', 956.0000, 'ºC'),
	(255955, 121, '2014-03-15 00:35:31.000000', 'temperatura', 410.0000, 'ºC'),
	(255956, 121, '2014-03-15 00:35:32.000000', 'temperatura', 382.0000, 'ºC'),
	(255957, 121, '2014-03-15 00:35:33.000000', 'temperatura', 681.0000, 'ºC'),
	(255958, 121, '2014-03-15 00:35:34.000000', 'temperatura', 1057.0000, 'ºC'),
	(255959, 121, '2014-03-15 00:35:35.000000', 'temperatura', 843.0000, 'ºC'),
	(255960, 121, '2014-03-15 00:35:36.000000', 'temperatura', 1047.0000, 'ºC'),
	(255961, 121, '2014-03-15 00:35:37.000000', 'temperatura', 303.0000, 'ºC'),
	(255962, 121, '2014-03-15 00:35:38.000000', 'temperatura', 778.0000, 'ºC'),
	(255963, 121, '2014-03-15 00:35:39.000000', 'temperatura', 579.0000, 'ºC'),
	(255964, 121, '2014-03-15 00:35:40.000000', 'temperatura', 562.0000, 'ºC'),
	(255965, 121, '2014-03-15 00:35:41.000000', 'temperatura', 1073.0000, 'ºC'),
	(255966, 121, '2014-03-15 00:35:42.000000', 'temperatura', 81.0000, 'ºC'),
	(255967, 121, '2014-03-15 00:35:43.000000', 'temperatura', 785.0000, 'ºC'),
	(255968, 121, '2014-03-15 00:35:44.000000', 'temperatura', 82.0000, 'ºC'),
	(255969, 121, '2014-03-15 00:35:45.000000', 'temperatura', 456.0000, 'ºC'),
	(255970, 121, '2014-03-15 00:35:46.000000', 'temperatura', 833.0000, 'ºC'),
	(255971, 121, '2014-03-15 00:35:47.000000', 'temperatura', 398.0000, 'ºC'),
	(255972, 121, '2014-03-15 00:35:48.000000', 'temperatura', 691.0000, 'ºC'),
	(255973, 121, '2014-03-15 00:35:49.000000', 'temperatura', 1060.0000, 'ºC'),
	(255974, 121, '2014-03-15 00:35:50.000000', 'temperatura', 829.0000, 'ºC'),
	(255975, 121, '2014-03-15 00:35:51.000000', 'temperatura', 967.0000, 'ºC'),
	(255976, 121, '2014-03-15 00:35:52.000000', 'temperatura', 1146.0000, 'ºC'),
	(255977, 121, '2014-03-15 00:35:53.000000', 'temperatura', 433.0000, 'ºC'),
	(255978, 121, '2014-03-15 00:35:54.000000', 'temperatura', 1124.0000, 'ºC'),
	(255979, 121, '2014-03-15 00:35:55.000000', 'temperatura', 723.0000, 'ºC'),
	(255980, 121, '2014-03-15 00:35:56.000000', 'temperatura', 245.0000, 'ºC'),
	(255981, 121, '2014-03-15 00:35:57.000000', 'temperatura', 255.0000, 'ºC'),
	(255982, 121, '2014-03-15 00:35:58.000000', 'temperatura', 540.0000, 'ºC'),
	(255983, 121, '2014-03-15 00:35:59.000000', 'temperatura', 735.0000, 'ºC'),
	(255984, 121, '2014-03-15 00:36:00.000000', 'temperatura', 855.0000, 'ºC'),
	(255985, 121, '2014-03-15 00:36:01.000000', 'temperatura', 870.0000, 'ºC'),
	(255986, 121, '2014-03-15 00:36:02.000000', 'temperatura', 586.0000, 'ºC'),
	(255987, 121, '2014-03-15 00:36:03.000000', 'temperatura', 320.0000, 'ºC'),
	(255988, 121, '2014-03-15 00:36:04.000000', 'temperatura', 1044.0000, 'ºC'),
	(255989, 121, '2014-03-15 00:36:05.000000', 'temperatura', 662.0000, 'ºC'),
	(255990, 121, '2014-03-15 00:36:06.000000', 'temperatura', 177.0000, 'ºC'),
	(255991, 121, '2014-03-15 00:36:07.000000', 'temperatura', 99.0000, 'ºC'),
	(255992, 121, '2014-03-15 00:36:08.000000', 'temperatura', 1166.0000, 'ºC'),
	(255993, 121, '2014-03-15 00:36:09.000000', 'temperatura', 731.0000, 'ºC'),
	(255994, 121, '2014-03-15 00:36:10.000000', 'temperatura', 160.0000, 'ºC'),
	(255995, 121, '2014-03-15 00:36:11.000000', 'temperatura', 1008.0000, 'ºC'),
	(255996, 121, '2014-03-15 00:36:12.000000', 'temperatura', 960.0000, 'ºC'),
	(255997, 121, '2014-03-15 00:36:13.000000', 'temperatura', 575.0000, 'ºC'),
	(255998, 121, '2014-03-15 00:36:14.000000', 'temperatura', 1195.0000, 'ºC'),
	(255999, 121, '2014-03-15 00:36:15.000000', 'temperatura', 652.0000, 'ºC'),
	(256000, 121, '2014-03-15 00:36:16.000000', 'temperatura', 876.0000, 'ºC'),
	(256001, 121, '2014-03-15 00:36:17.000000', 'temperatura', 23.0000, 'ºC'),
	(256002, 121, '2014-03-15 00:36:18.000000', 'temperatura', 1089.0000, 'ºC'),
	(256003, 121, '2014-03-15 00:36:19.000000', 'temperatura', 576.0000, 'ºC'),
	(256004, 121, '2014-03-15 00:36:20.000000', 'temperatura', 813.0000, 'ºC'),
	(256005, 121, '2014-03-15 00:36:21.000000', 'temperatura', 1139.0000, 'ºC'),
	(256006, 121, '2014-03-15 00:36:22.000000', 'temperatura', 854.0000, 'ºC'),
	(256007, 121, '2014-03-15 00:36:23.000000', 'temperatura', 855.0000, 'ºC'),
	(256008, 121, '2014-03-15 00:36:24.000000', 'temperatura', 514.0000, 'ºC'),
	(256009, 121, '2014-03-15 00:36:25.000000', 'temperatura', 7.0000, 'ºC'),
	(256010, 121, '2014-03-15 00:36:26.000000', 'temperatura', 892.0000, 'ºC'),
	(256011, 121, '2014-03-15 00:36:27.000000', 'temperatura', 839.0000, 'ºC'),
	(256012, 121, '2014-03-15 00:36:28.000000', 'temperatura', 318.0000, 'ºC'),
	(256013, 121, '2014-03-15 00:36:29.000000', 'temperatura', 277.0000, 'ºC'),
	(256014, 121, '2014-03-15 00:36:30.000000', 'temperatura', 430.0000, 'ºC'),
	(256015, 121, '2014-03-15 00:36:31.000000', 'temperatura', 118.0000, 'ºC'),
	(256016, 121, '2014-03-15 00:36:32.000000', 'temperatura', 500.0000, 'ºC'),
	(256017, 121, '2014-03-15 00:36:33.000000', 'temperatura', 947.0000, 'ºC'),
	(256018, 121, '2014-03-15 00:36:34.000000', 'temperatura', 836.0000, 'ºC'),
	(256019, 121, '2014-03-15 00:36:35.000000', 'temperatura', 141.0000, 'ºC'),
	(256020, 121, '2014-03-15 00:36:36.000000', 'temperatura', 597.0000, 'ºC'),
	(256021, 121, '2014-03-15 00:36:37.000000', 'temperatura', 160.0000, 'ºC'),
	(256022, 121, '2014-03-15 00:36:38.000000', 'temperatura', 213.0000, 'ºC'),
	(256023, 121, '2014-03-15 00:36:39.000000', 'temperatura', 584.0000, 'ºC'),
	(256024, 121, '2014-03-15 00:36:40.000000', 'temperatura', 1082.0000, 'ºC'),
	(256025, 121, '2014-03-15 00:36:41.000000', 'temperatura', 59.0000, 'ºC'),
	(256026, 121, '2014-03-15 00:36:42.000000', 'temperatura', 651.0000, 'ºC'),
	(256027, 121, '2014-03-15 00:36:43.000000', 'temperatura', 676.0000, 'ºC'),
	(256028, 121, '2014-03-15 00:36:44.000000', 'temperatura', 230.0000, 'ºC'),
	(256029, 121, '2014-03-15 00:36:45.000000', 'temperatura', 320.0000, 'ºC'),
	(256030, 121, '2014-03-15 00:36:46.000000', 'temperatura', 909.0000, 'ºC'),
	(256031, 121, '2014-03-15 00:36:47.000000', 'temperatura', 1189.0000, 'ºC'),
	(256032, 121, '2014-03-15 00:36:48.000000', 'temperatura', 815.0000, 'ºC'),
	(256033, 121, '2014-03-15 00:36:49.000000', 'temperatura', 511.0000, 'ºC'),
	(256034, 121, '2014-03-15 00:36:50.000000', 'temperatura', 110.0000, 'ºC'),
	(256035, 121, '2014-03-15 00:36:51.000000', 'temperatura', 216.0000, 'ºC'),
	(256036, 121, '2014-03-15 00:36:52.000000', 'temperatura', 751.0000, 'ºC'),
	(256037, 121, '2014-03-15 00:36:53.000000', 'temperatura', 709.0000, 'ºC'),
	(256038, 121, '2014-03-15 00:36:54.000000', 'temperatura', 93.0000, 'ºC'),
	(256039, 121, '2014-03-15 00:36:55.000000', 'temperatura', 736.0000, 'ºC'),
	(256040, 121, '2014-03-15 00:36:56.000000', 'temperatura', 1001.0000, 'ºC'),
	(256041, 121, '2014-03-15 00:36:57.000000', 'temperatura', 401.0000, 'ºC'),
	(256042, 121, '2014-03-15 00:36:58.000000', 'temperatura', 199.0000, 'ºC'),
	(256043, 121, '2014-03-15 00:36:59.000000', 'temperatura', 994.0000, 'ºC'),
	(256044, 121, '2014-03-15 00:37:00.000000', 'temperatura', 775.0000, 'ºC'),
	(256045, 121, '2014-03-15 00:37:01.000000', 'temperatura', 893.0000, 'ºC'),
	(256046, 121, '2014-03-15 00:37:02.000000', 'temperatura', 942.0000, 'ºC'),
	(256047, 121, '2014-03-15 00:37:03.000000', 'temperatura', 831.0000, 'ºC'),
	(256048, 121, '2014-03-15 00:37:04.000000', 'temperatura', 127.0000, 'ºC'),
	(256049, 121, '2014-03-15 00:37:05.000000', 'temperatura', 543.0000, 'ºC'),
	(256050, 121, '2014-03-15 00:37:06.000000', 'temperatura', 1135.0000, 'ºC'),
	(256051, 121, '2014-03-15 00:37:07.000000', 'temperatura', 445.0000, 'ºC'),
	(256052, 121, '2014-03-15 00:37:08.000000', 'temperatura', 23.0000, 'ºC'),
	(256053, 121, '2014-03-15 00:37:09.000000', 'temperatura', 1178.0000, 'ºC'),
	(256054, 121, '2014-03-15 00:37:10.000000', 'temperatura', 1021.0000, 'ºC'),
	(256055, 121, '2014-03-15 00:37:11.000000', 'temperatura', 372.0000, 'ºC'),
	(256056, 121, '2014-03-15 00:37:12.000000', 'temperatura', 1196.0000, 'ºC'),
	(256057, 121, '2014-03-15 00:37:13.000000', 'temperatura', 67.0000, 'ºC'),
	(256058, 121, '2014-03-15 00:37:14.000000', 'temperatura', 349.0000, 'ºC'),
	(256059, 121, '2014-03-15 00:37:15.000000', 'temperatura', 341.0000, 'ºC'),
	(256060, 121, '2014-03-15 00:37:16.000000', 'temperatura', 660.0000, 'ºC'),
	(256061, 121, '2014-03-15 00:37:17.000000', 'temperatura', 1077.0000, 'ºC'),
	(256062, 121, '2014-03-15 00:37:18.000000', 'temperatura', 1005.0000, 'ºC'),
	(256063, 121, '2014-03-15 00:37:19.000000', 'temperatura', 597.0000, 'ºC'),
	(256064, 121, '2014-03-15 00:37:20.000000', 'temperatura', 1169.0000, 'ºC'),
	(256065, 121, '2014-03-15 00:37:21.000000', 'temperatura', 457.0000, 'ºC'),
	(256066, 121, '2014-03-15 00:37:22.000000', 'temperatura', 1176.0000, 'ºC'),
	(256067, 121, '2014-03-15 00:37:23.000000', 'temperatura', 909.0000, 'ºC'),
	(256068, 121, '2014-03-15 00:37:24.000000', 'temperatura', 1017.0000, 'ºC'),
	(256069, 121, '2014-03-15 00:37:25.000000', 'temperatura', 1160.0000, 'ºC'),
	(256070, 121, '2014-03-15 00:37:26.000000', 'temperatura', 347.0000, 'ºC'),
	(256071, 121, '2014-03-15 00:37:27.000000', 'temperatura', 658.0000, 'ºC'),
	(256072, 121, '2014-03-15 00:37:28.000000', 'temperatura', 1047.0000, 'ºC'),
	(256073, 121, '2014-03-15 00:37:29.000000', 'temperatura', 863.0000, 'ºC'),
	(256074, 121, '2014-03-15 00:37:30.000000', 'temperatura', 1175.0000, 'ºC'),
	(256075, 121, '2014-03-15 00:37:31.000000', 'temperatura', 884.0000, 'ºC'),
	(256076, 121, '2014-03-15 00:37:32.000000', 'temperatura', 899.0000, 'ºC'),
	(256077, 121, '2014-03-15 00:37:33.000000', 'temperatura', 642.0000, 'ºC'),
	(256078, 121, '2014-03-15 00:37:34.000000', 'temperatura', 512.0000, 'ºC'),
	(256079, 121, '2014-03-15 00:37:35.000000', 'temperatura', 636.0000, 'ºC'),
	(256080, 121, '2014-03-15 00:37:36.000000', 'temperatura', 446.0000, 'ºC'),
	(256081, 121, '2014-03-15 00:37:37.000000', 'temperatura', 321.0000, 'ºC'),
	(256082, 121, '2014-03-15 00:37:38.000000', 'temperatura', 266.0000, 'ºC'),
	(256083, 121, '2014-03-15 00:37:39.000000', 'temperatura', 368.0000, 'ºC'),
	(256084, 121, '2014-03-15 00:37:40.000000', 'temperatura', 1043.0000, 'ºC'),
	(256085, 121, '2014-03-15 00:37:41.000000', 'temperatura', 510.0000, 'ºC'),
	(256086, 121, '2014-03-15 00:37:42.000000', 'temperatura', 621.0000, 'ºC'),
	(256087, 121, '2014-03-15 00:37:43.000000', 'temperatura', 378.0000, 'ºC'),
	(256088, 121, '2014-03-15 00:37:44.000000', 'temperatura', 28.0000, 'ºC'),
	(256089, 121, '2014-03-15 00:37:45.000000', 'temperatura', 204.0000, 'ºC'),
	(256090, 121, '2014-03-15 00:37:46.000000', 'temperatura', 937.0000, 'ºC'),
	(256091, 121, '2014-03-15 00:37:47.000000', 'temperatura', 474.0000, 'ºC'),
	(256092, 121, '2014-03-15 00:37:48.000000', 'temperatura', 759.0000, 'ºC'),
	(256093, 121, '2014-03-15 00:37:49.000000', 'temperatura', 1176.0000, 'ºC'),
	(256094, 121, '2014-03-15 00:37:50.000000', 'temperatura', 1.0000, 'ºC'),
	(256095, 121, '2014-03-15 00:37:51.000000', 'temperatura', 80.0000, 'ºC'),
	(256096, 121, '2014-03-15 00:37:52.000000', 'temperatura', 396.0000, 'ºC'),
	(256097, 121, '2014-03-15 00:37:53.000000', 'temperatura', 541.0000, 'ºC'),
	(256098, 121, '2014-03-15 00:37:54.000000', 'temperatura', 317.0000, 'ºC'),
	(256099, 121, '2014-03-15 00:37:55.000000', 'temperatura', 1164.0000, 'ºC'),
	(256100, 121, '2014-03-15 00:37:56.000000', 'temperatura', 70.0000, 'ºC'),
	(256101, 121, '2014-03-15 00:37:57.000000', 'temperatura', 457.0000, 'ºC'),
	(256102, 121, '2014-03-15 00:37:58.000000', 'temperatura', 877.0000, 'ºC'),
	(256103, 121, '2014-03-15 00:37:59.000000', 'temperatura', 615.0000, 'ºC'),
	(256104, 121, '2014-03-15 00:38:00.000000', 'temperatura', 445.0000, 'ºC'),
	(256105, 121, '2014-03-15 00:38:01.000000', 'temperatura', 381.0000, 'ºC'),
	(256106, 121, '2014-03-15 00:38:02.000000', 'temperatura', 571.0000, 'ºC'),
	(256107, 121, '2014-03-15 00:38:03.000000', 'temperatura', 512.0000, 'ºC'),
	(256108, 121, '2014-03-15 00:38:04.000000', 'temperatura', 846.0000, 'ºC'),
	(256109, 121, '2014-03-15 00:38:05.000000', 'temperatura', 294.0000, 'ºC'),
	(256110, 121, '2014-03-15 00:38:06.000000', 'temperatura', 133.0000, 'ºC'),
	(256111, 121, '2014-03-15 00:38:07.000000', 'temperatura', 985.0000, 'ºC'),
	(256112, 121, '2014-03-15 00:38:08.000000', 'temperatura', 924.0000, 'ºC'),
	(256113, 121, '2014-03-15 00:38:09.000000', 'temperatura', 466.0000, 'ºC'),
	(256114, 121, '2014-03-15 00:38:10.000000', 'temperatura', 758.0000, 'ºC'),
	(256115, 121, '2014-03-15 00:38:11.000000', 'temperatura', 1191.0000, 'ºC'),
	(256116, 121, '2014-03-15 00:38:12.000000', 'temperatura', 84.0000, 'ºC'),
	(256117, 121, '2014-03-15 00:38:13.000000', 'temperatura', 449.0000, 'ºC'),
	(256118, 121, '2014-03-15 00:38:14.000000', 'temperatura', 790.0000, 'ºC'),
	(256119, 121, '2014-03-15 00:38:15.000000', 'temperatura', 205.0000, 'ºC'),
	(256120, 121, '2014-03-15 00:38:16.000000', 'temperatura', 1056.0000, 'ºC'),
	(256121, 121, '2014-03-15 00:38:17.000000', 'temperatura', 1063.0000, 'ºC'),
	(256122, 121, '2014-03-15 00:38:18.000000', 'temperatura', 950.0000, 'ºC'),
	(256123, 121, '2014-03-15 00:38:19.000000', 'temperatura', 361.0000, 'ºC'),
	(256124, 121, '2014-03-15 00:38:20.000000', 'temperatura', 157.0000, 'ºC'),
	(256125, 121, '2014-03-15 00:38:21.000000', 'temperatura', 900.0000, 'ºC'),
	(256126, 121, '2014-03-15 00:38:22.000000', 'temperatura', 430.0000, 'ºC'),
	(256127, 121, '2014-03-15 00:38:23.000000', 'temperatura', 651.0000, 'ºC'),
	(256128, 121, '2014-03-15 00:38:24.000000', 'temperatura', 766.0000, 'ºC'),
	(256129, 121, '2014-03-15 00:38:25.000000', 'temperatura', 677.0000, 'ºC'),
	(256130, 121, '2014-03-15 00:38:26.000000', 'temperatura', 1086.0000, 'ºC'),
	(256131, 121, '2014-03-15 00:38:27.000000', 'temperatura', 1002.0000, 'ºC'),
	(256132, 121, '2014-03-15 00:38:28.000000', 'temperatura', 551.0000, 'ºC'),
	(256133, 121, '2014-03-15 00:38:29.000000', 'temperatura', 950.0000, 'ºC'),
	(256134, 121, '2014-03-15 00:38:30.000000', 'temperatura', 697.0000, 'ºC'),
	(256135, 121, '2014-03-15 00:38:31.000000', 'temperatura', 637.0000, 'ºC'),
	(256136, 121, '2014-03-15 00:38:32.000000', 'temperatura', 1095.0000, 'ºC'),
	(256137, 121, '2014-03-15 00:38:33.000000', 'temperatura', 1164.0000, 'ºC'),
	(256138, 121, '2014-03-15 00:38:34.000000', 'temperatura', 137.0000, 'ºC'),
	(256139, 121, '2014-03-15 00:38:35.000000', 'temperatura', 790.0000, 'ºC'),
	(256140, 121, '2014-03-15 00:38:36.000000', 'temperatura', 1142.0000, 'ºC'),
	(256141, 121, '2014-03-15 00:38:37.000000', 'temperatura', 938.0000, 'ºC'),
	(256142, 121, '2014-03-15 00:38:38.000000', 'temperatura', 66.0000, 'ºC'),
	(256143, 121, '2014-03-15 00:38:39.000000', 'temperatura', 1115.0000, 'ºC'),
	(256144, 121, '2014-03-15 00:38:40.000000', 'temperatura', 580.0000, 'ºC'),
	(256145, 121, '2014-03-15 00:38:41.000000', 'temperatura', 753.0000, 'ºC'),
	(256146, 121, '2014-03-15 00:38:42.000000', 'temperatura', 828.0000, 'ºC'),
	(256147, 121, '2014-03-15 00:38:43.000000', 'temperatura', 682.0000, 'ºC'),
	(256148, 121, '2014-03-15 00:38:44.000000', 'temperatura', 923.0000, 'ºC'),
	(256149, 121, '2014-03-15 00:38:45.000000', 'temperatura', 172.0000, 'ºC'),
	(256150, 121, '2014-03-15 00:38:46.000000', 'temperatura', 493.0000, 'ºC'),
	(256151, 121, '2014-03-15 00:38:47.000000', 'temperatura', 748.0000, 'ºC'),
	(256152, 121, '2014-03-15 00:38:48.000000', 'temperatura', 1060.0000, 'ºC'),
	(256153, 121, '2014-03-15 00:38:49.000000', 'temperatura', 659.0000, 'ºC'),
	(256154, 121, '2014-03-15 00:38:50.000000', 'temperatura', 114.0000, 'ºC'),
	(256155, 121, '2014-03-15 00:38:51.000000', 'temperatura', 994.0000, 'ºC'),
	(256156, 121, '2014-03-15 00:38:52.000000', 'temperatura', 1027.0000, 'ºC'),
	(256157, 121, '2014-03-15 00:38:53.000000', 'temperatura', 953.0000, 'ºC'),
	(256158, 121, '2014-03-15 00:38:54.000000', 'temperatura', 487.0000, 'ºC'),
	(256159, 121, '2014-03-15 00:38:55.000000', 'temperatura', 777.0000, 'ºC'),
	(256160, 121, '2014-03-15 00:38:56.000000', 'temperatura', 25.0000, 'ºC'),
	(256161, 121, '2014-03-15 00:38:57.000000', 'temperatura', 192.0000, 'ºC'),
	(256162, 121, '2014-03-15 00:38:58.000000', 'temperatura', 888.0000, 'ºC'),
	(256163, 121, '2014-03-15 00:38:59.000000', 'temperatura', 263.0000, 'ºC'),
	(256164, 121, '2014-03-15 00:39:00.000000', 'temperatura', 1053.0000, 'ºC'),
	(256165, 121, '2014-03-15 00:39:01.000000', 'temperatura', 878.0000, 'ºC'),
	(256166, 121, '2014-03-15 00:39:02.000000', 'temperatura', 28.0000, 'ºC'),
	(256167, 121, '2014-03-15 00:39:03.000000', 'temperatura', 1108.0000, 'ºC'),
	(256168, 121, '2014-03-15 00:39:04.000000', 'temperatura', 654.0000, 'ºC'),
	(256169, 121, '2014-03-15 00:39:05.000000', 'temperatura', 1150.0000, 'ºC'),
	(256170, 121, '2014-03-15 00:39:06.000000', 'temperatura', 188.0000, 'ºC'),
	(256171, 121, '2014-03-15 00:39:07.000000', 'temperatura', 1089.0000, 'ºC'),
	(256172, 121, '2014-03-15 00:39:08.000000', 'temperatura', 82.0000, 'ºC'),
	(256173, 121, '2014-03-15 00:39:09.000000', 'temperatura', 743.0000, 'ºC'),
	(256174, 121, '2014-03-15 00:39:10.000000', 'temperatura', 1071.0000, 'ºC'),
	(256175, 121, '2014-03-15 00:39:11.000000', 'temperatura', 727.0000, 'ºC'),
	(256176, 121, '2014-03-15 00:39:12.000000', 'temperatura', 421.0000, 'ºC'),
	(256177, 121, '2014-03-15 00:39:13.000000', 'temperatura', 1124.0000, 'ºC'),
	(256178, 121, '2014-03-15 00:39:14.000000', 'temperatura', 759.0000, 'ºC'),
	(256179, 121, '2014-03-15 00:39:15.000000', 'temperatura', 425.0000, 'ºC'),
	(256180, 121, '2014-03-15 00:39:16.000000', 'temperatura', 1045.0000, 'ºC'),
	(256181, 121, '2014-03-15 00:39:17.000000', 'temperatura', 353.0000, 'ºC'),
	(256182, 121, '2014-03-15 00:39:18.000000', 'temperatura', 1029.0000, 'ºC'),
	(256183, 121, '2014-03-15 00:39:19.000000', 'temperatura', 485.0000, 'ºC'),
	(256184, 121, '2014-03-15 00:39:20.000000', 'temperatura', 540.0000, 'ºC'),
	(256185, 121, '2014-03-15 00:39:21.000000', 'temperatura', 47.0000, 'ºC'),
	(256186, 121, '2014-03-15 00:39:22.000000', 'temperatura', 1017.0000, 'ºC'),
	(256187, 121, '2014-03-15 00:39:23.000000', 'temperatura', 141.0000, 'ºC'),
	(256188, 121, '2014-03-15 00:39:24.000000', 'temperatura', 55.0000, 'ºC'),
	(256189, 121, '2014-03-15 00:39:25.000000', 'temperatura', 1051.0000, 'ºC'),
	(256190, 121, '2014-03-15 00:39:26.000000', 'temperatura', 294.0000, 'ºC'),
	(256191, 121, '2014-03-15 00:39:27.000000', 'temperatura', 715.0000, 'ºC'),
	(256192, 121, '2014-03-15 00:39:28.000000', 'temperatura', 293.0000, 'ºC'),
	(256193, 121, '2014-03-15 00:39:29.000000', 'temperatura', 521.0000, 'ºC'),
	(256194, 121, '2014-03-15 00:39:30.000000', 'temperatura', 528.0000, 'ºC'),
	(256195, 121, '2014-03-15 00:39:31.000000', 'temperatura', 1077.0000, 'ºC'),
	(256196, 121, '2014-03-15 00:39:32.000000', 'temperatura', 201.0000, 'ºC'),
	(256197, 121, '2014-03-15 00:39:33.000000', 'temperatura', 176.0000, 'ºC'),
	(256198, 121, '2014-03-15 00:39:34.000000', 'temperatura', 278.0000, 'ºC'),
	(256199, 121, '2014-03-15 00:39:35.000000', 'temperatura', 860.0000, 'ºC'),
	(256200, 121, '2014-03-15 00:39:36.000000', 'temperatura', 1068.0000, 'ºC'),
	(256201, 121, '2014-03-15 00:39:37.000000', 'temperatura', 362.0000, 'ºC'),
	(256202, 121, '2014-03-15 00:39:38.000000', 'temperatura', 1005.0000, 'ºC'),
	(256203, 121, '2014-03-15 00:39:39.000000', 'temperatura', 340.0000, 'ºC'),
	(256204, 121, '2014-03-15 00:39:40.000000', 'temperatura', 1085.0000, 'ºC'),
	(256205, 121, '2014-03-15 00:39:41.000000', 'temperatura', 807.0000, 'ºC'),
	(256206, 121, '2014-03-15 00:39:42.000000', 'temperatura', 779.0000, 'ºC'),
	(256207, 121, '2014-03-15 00:39:43.000000', 'temperatura', 275.0000, 'ºC'),
	(256208, 121, '2014-03-15 00:39:44.000000', 'temperatura', 239.0000, 'ºC'),
	(256209, 121, '2014-03-15 00:39:45.000000', 'temperatura', 372.0000, 'ºC'),
	(256210, 121, '2014-03-15 00:39:46.000000', 'temperatura', 1141.0000, 'ºC'),
	(256211, 121, '2014-03-15 00:39:47.000000', 'temperatura', 992.0000, 'ºC'),
	(256212, 121, '2014-03-15 00:39:48.000000', 'temperatura', 335.0000, 'ºC'),
	(256213, 121, '2014-03-15 00:39:49.000000', 'temperatura', 1100.0000, 'ºC'),
	(256214, 121, '2014-03-15 00:39:50.000000', 'temperatura', 896.0000, 'ºC'),
	(256215, 121, '2014-03-15 00:39:51.000000', 'temperatura', 1181.0000, 'ºC'),
	(256216, 121, '2014-03-15 00:39:52.000000', 'temperatura', 816.0000, 'ºC'),
	(256217, 121, '2014-03-15 00:39:53.000000', 'temperatura', 538.0000, 'ºC'),
	(256218, 121, '2014-03-15 00:39:54.000000', 'temperatura', 244.0000, 'ºC'),
	(256219, 121, '2014-03-15 00:39:55.000000', 'temperatura', 805.0000, 'ºC'),
	(256220, 121, '2014-03-15 00:39:56.000000', 'temperatura', 896.0000, 'ºC'),
	(256221, 121, '2014-03-15 00:39:57.000000', 'temperatura', 864.0000, 'ºC'),
	(256222, 121, '2014-03-15 00:39:58.000000', 'temperatura', 432.0000, 'ºC'),
	(256223, 121, '2014-03-15 00:39:59.000000', 'temperatura', 770.0000, 'ºC'),
	(256224, 121, '2014-03-15 00:40:00.000000', 'temperatura', 155.0000, 'ºC'),
	(256225, 121, '2014-03-15 00:40:01.000000', 'temperatura', 864.0000, 'ºC'),
	(256226, 121, '2014-03-15 00:40:02.000000', 'temperatura', 256.0000, 'ºC'),
	(256227, 121, '2014-03-15 00:40:03.000000', 'temperatura', 1087.0000, 'ºC'),
	(256228, 121, '2014-03-15 00:40:04.000000', 'temperatura', 1070.0000, 'ºC'),
	(256229, 121, '2014-03-15 00:40:05.000000', 'temperatura', 889.0000, 'ºC'),
	(256230, 121, '2014-03-15 00:40:06.000000', 'temperatura', 37.0000, 'ºC'),
	(256231, 121, '2014-03-15 00:40:07.000000', 'temperatura', 1116.0000, 'ºC'),
	(256232, 121, '2014-03-15 00:40:08.000000', 'temperatura', 669.0000, 'ºC'),
	(256233, 121, '2014-03-15 00:40:09.000000', 'temperatura', 1198.0000, 'ºC'),
	(256234, 121, '2014-03-15 00:40:10.000000', 'temperatura', 384.0000, 'ºC'),
	(256235, 121, '2014-03-15 00:40:11.000000', 'temperatura', 725.0000, 'ºC'),
	(256236, 121, '2014-03-15 00:40:12.000000', 'temperatura', 74.0000, 'ºC'),
	(256237, 121, '2014-03-15 00:40:13.000000', 'temperatura', 596.0000, 'ºC'),
	(256238, 121, '2014-03-15 00:40:14.000000', 'temperatura', 357.0000, 'ºC'),
	(256239, 121, '2014-03-15 00:40:15.000000', 'temperatura', 1197.0000, 'ºC'),
	(256240, 121, '2014-03-15 00:40:16.000000', 'temperatura', 115.0000, 'ºC'),
	(256241, 121, '2014-03-15 00:40:17.000000', 'temperatura', 583.0000, 'ºC'),
	(256242, 121, '2014-03-15 00:40:18.000000', 'temperatura', 174.0000, 'ºC'),
	(256243, 121, '2014-03-15 00:40:19.000000', 'temperatura', 319.0000, 'ºC'),
	(256244, 121, '2014-03-15 00:40:20.000000', 'temperatura', 1072.0000, 'ºC'),
	(256245, 121, '2014-03-15 00:40:21.000000', 'temperatura', 807.0000, 'ºC'),
	(256246, 121, '2014-03-15 00:40:22.000000', 'temperatura', 817.0000, 'ºC'),
	(256247, 121, '2014-03-15 00:40:23.000000', 'temperatura', 466.0000, 'ºC'),
	(256248, 121, '2014-03-15 00:40:24.000000', 'temperatura', 1081.0000, 'ºC'),
	(256249, 121, '2014-03-15 00:40:25.000000', 'temperatura', 407.0000, 'ºC'),
	(256250, 121, '2014-03-15 00:40:26.000000', 'temperatura', 1190.0000, 'ºC'),
	(256251, 121, '2014-03-15 00:40:27.000000', 'temperatura', 1133.0000, 'ºC'),
	(256252, 121, '2014-03-15 00:40:28.000000', 'temperatura', 893.0000, 'ºC'),
	(256253, 121, '2014-03-15 00:40:29.000000', 'temperatura', 1066.0000, 'ºC'),
	(256254, 121, '2014-03-15 00:40:30.000000', 'temperatura', 253.0000, 'ºC'),
	(256255, 121, '2014-03-15 00:40:31.000000', 'temperatura', 469.0000, 'ºC'),
	(256256, 121, '2014-03-15 00:40:32.000000', 'temperatura', 385.0000, 'ºC'),
	(256257, 121, '2014-03-15 00:40:33.000000', 'temperatura', 520.0000, 'ºC'),
	(256258, 121, '2014-03-15 00:40:34.000000', 'temperatura', 245.0000, 'ºC'),
	(256259, 121, '2014-03-15 00:40:35.000000', 'temperatura', 863.0000, 'ºC'),
	(256260, 121, '2014-03-15 00:40:36.000000', 'temperatura', 1182.0000, 'ºC'),
	(256261, 121, '2014-03-15 00:40:37.000000', 'temperatura', 922.0000, 'ºC'),
	(256262, 121, '2014-03-15 00:40:38.000000', 'temperatura', 1063.0000, 'ºC'),
	(256263, 121, '2014-03-15 00:40:39.000000', 'temperatura', 151.0000, 'ºC'),
	(256264, 121, '2014-03-15 00:40:40.000000', 'temperatura', 1164.0000, 'ºC'),
	(256265, 121, '2014-03-15 00:40:41.000000', 'temperatura', 570.0000, 'ºC'),
	(256266, 121, '2014-03-15 00:40:42.000000', 'temperatura', 558.0000, 'ºC'),
	(256267, 121, '2014-03-15 00:40:43.000000', 'temperatura', 1082.0000, 'ºC'),
	(256268, 121, '2014-03-15 00:40:44.000000', 'temperatura', 135.0000, 'ºC'),
	(256269, 121, '2014-03-15 00:40:45.000000', 'temperatura', 1032.0000, 'ºC'),
	(256270, 121, '2014-03-15 00:40:46.000000', 'temperatura', 1153.0000, 'ºC'),
	(256271, 121, '2014-03-15 00:40:47.000000', 'temperatura', 268.0000, 'ºC'),
	(256272, 121, '2014-03-15 00:40:48.000000', 'temperatura', 283.0000, 'ºC'),
	(256273, 121, '2014-03-15 00:40:49.000000', 'temperatura', 613.0000, 'ºC'),
	(256274, 121, '2014-03-15 00:40:50.000000', 'temperatura', 1016.0000, 'ºC'),
	(256275, 121, '2014-03-15 00:40:51.000000', 'temperatura', 839.0000, 'ºC'),
	(256276, 121, '2014-03-15 00:40:52.000000', 'temperatura', 1151.0000, 'ºC'),
	(256277, 121, '2014-03-15 00:40:53.000000', 'temperatura', 837.0000, 'ºC'),
	(256278, 121, '2014-03-15 00:40:54.000000', 'temperatura', 733.0000, 'ºC'),
	(256279, 121, '2014-03-15 00:40:55.000000', 'temperatura', 1154.0000, 'ºC'),
	(256280, 121, '2014-03-15 00:40:56.000000', 'temperatura', 1170.0000, 'ºC'),
	(256281, 121, '2014-03-15 00:40:57.000000', 'temperatura', 1188.0000, 'ºC'),
	(256282, 121, '2014-03-15 00:40:58.000000', 'temperatura', 32.0000, 'ºC'),
	(256283, 121, '2014-03-15 00:40:59.000000', 'temperatura', 197.0000, 'ºC'),
	(256284, 121, '2014-03-15 00:41:00.000000', 'temperatura', 888.0000, 'ºC'),
	(256285, 121, '2014-03-15 00:41:01.000000', 'temperatura', 251.0000, 'ºC'),
	(256286, 121, '2014-03-15 00:41:02.000000', 'temperatura', 992.0000, 'ºC'),
	(256287, 121, '2014-03-15 00:41:03.000000', 'temperatura', 606.0000, 'ºC'),
	(256288, 121, '2014-03-15 00:41:04.000000', 'temperatura', 57.0000, 'ºC'),
	(256289, 121, '2014-03-15 00:41:05.000000', 'temperatura', 865.0000, 'ºC'),
	(256290, 121, '2014-03-15 00:41:06.000000', 'temperatura', 554.0000, 'ºC'),
	(256291, 121, '2014-03-15 00:41:07.000000', 'temperatura', 177.0000, 'ºC'),
	(256292, 121, '2014-03-15 00:41:08.000000', 'temperatura', 423.0000, 'ºC'),
	(256293, 121, '2014-03-15 00:41:09.000000', 'temperatura', 383.0000, 'ºC'),
	(256294, 121, '2014-03-15 00:41:10.000000', 'temperatura', 647.0000, 'ºC'),
	(256295, 121, '2014-03-15 00:41:11.000000', 'temperatura', 887.0000, 'ºC'),
	(256296, 121, '2014-03-15 00:41:12.000000', 'temperatura', 96.0000, 'ºC'),
	(256297, 121, '2014-03-15 00:41:13.000000', 'temperatura', 219.0000, 'ºC'),
	(256298, 121, '2014-03-15 00:41:14.000000', 'temperatura', 806.0000, 'ºC'),
	(256299, 121, '2014-03-15 00:41:15.000000', 'temperatura', 975.0000, 'ºC'),
	(256300, 121, '2014-03-15 00:41:16.000000', 'temperatura', 55.0000, 'ºC'),
	(256301, 121, '2014-03-15 00:41:17.000000', 'temperatura', 953.0000, 'ºC'),
	(256302, 121, '2014-03-15 00:41:18.000000', 'temperatura', 1000.0000, 'ºC'),
	(256303, 121, '2014-03-15 00:41:19.000000', 'temperatura', 940.0000, 'ºC'),
	(256304, 121, '2014-03-15 00:41:20.000000', 'temperatura', 500.0000, 'ºC'),
	(256305, 121, '2014-03-15 00:41:21.000000', 'temperatura', 880.0000, 'ºC'),
	(256306, 121, '2014-03-15 00:41:22.000000', 'temperatura', 500.0000, 'ºC'),
	(256307, 121, '2014-03-15 00:41:23.000000', 'temperatura', 1061.0000, 'ºC'),
	(256308, 121, '2014-03-15 00:41:24.000000', 'temperatura', 205.0000, 'ºC'),
	(256309, 121, '2014-03-15 00:41:25.000000', 'temperatura', 245.0000, 'ºC'),
	(256310, 121, '2014-03-15 00:41:26.000000', 'temperatura', 608.0000, 'ºC'),
	(256311, 121, '2014-03-15 00:41:27.000000', 'temperatura', 1105.0000, 'ºC'),
	(256312, 121, '2014-03-15 00:41:28.000000', 'temperatura', 100.0000, 'ºC'),
	(256313, 121, '2014-03-15 00:41:29.000000', 'temperatura', 789.0000, 'ºC'),
	(256314, 121, '2014-03-15 00:41:30.000000', 'temperatura', 46.0000, 'ºC'),
	(256315, 121, '2014-03-15 00:41:31.000000', 'temperatura', 261.0000, 'ºC'),
	(256316, 121, '2014-03-15 00:41:32.000000', 'temperatura', 1166.0000, 'ºC'),
	(256317, 121, '2014-03-15 00:41:33.000000', 'temperatura', 251.0000, 'ºC'),
	(256318, 121, '2014-03-15 00:41:34.000000', 'temperatura', 156.0000, 'ºC'),
	(256319, 121, '2014-03-15 00:41:35.000000', 'temperatura', 27.0000, 'ºC'),
	(256320, 121, '2014-03-15 00:41:36.000000', 'temperatura', 870.0000, 'ºC'),
	(256321, 121, '2014-03-15 00:41:37.000000', 'temperatura', 667.0000, 'ºC'),
	(256322, 121, '2014-03-15 00:41:38.000000', 'temperatura', 726.0000, 'ºC'),
	(256323, 121, '2014-03-15 00:41:39.000000', 'temperatura', 429.0000, 'ºC'),
	(256324, 121, '2014-03-15 00:41:40.000000', 'temperatura', 1169.0000, 'ºC'),
	(256325, 121, '2014-03-15 00:41:41.000000', 'temperatura', 960.0000, 'ºC'),
	(256326, 121, '2014-03-15 00:41:42.000000', 'temperatura', 92.0000, 'ºC'),
	(256327, 121, '2014-03-15 00:41:43.000000', 'temperatura', 1179.0000, 'ºC'),
	(256328, 121, '2014-03-15 00:41:44.000000', 'temperatura', 820.0000, 'ºC'),
	(256329, 121, '2014-03-15 00:41:45.000000', 'temperatura', 562.0000, 'ºC'),
	(256330, 121, '2014-03-15 00:41:46.000000', 'temperatura', 352.0000, 'ºC'),
	(256331, 121, '2014-03-15 00:41:47.000000', 'temperatura', 72.0000, 'ºC'),
	(256332, 121, '2014-03-15 00:41:48.000000', 'temperatura', 507.0000, 'ºC'),
	(256333, 121, '2014-03-15 00:41:49.000000', 'temperatura', 1120.0000, 'ºC'),
	(256334, 121, '2014-03-15 00:41:50.000000', 'temperatura', 479.0000, 'ºC'),
	(256335, 121, '2014-03-15 00:41:51.000000', 'temperatura', 234.0000, 'ºC'),
	(256336, 121, '2014-03-15 00:41:52.000000', 'temperatura', 933.0000, 'ºC'),
	(256337, 121, '2014-03-15 00:41:53.000000', 'temperatura', 363.0000, 'ºC'),
	(256338, 121, '2014-03-15 00:41:54.000000', 'temperatura', 219.0000, 'ºC'),
	(256339, 121, '2014-03-15 00:41:55.000000', 'temperatura', 6.0000, 'ºC'),
	(256340, 121, '2014-03-15 00:41:56.000000', 'temperatura', 572.0000, 'ºC'),
	(256341, 121, '2014-03-15 00:41:57.000000', 'temperatura', 442.0000, 'ºC'),
	(256342, 121, '2014-03-15 00:41:58.000000', 'temperatura', 495.0000, 'ºC'),
	(256343, 121, '2014-03-15 00:41:59.000000', 'temperatura', 1150.0000, 'ºC'),
	(256344, 121, '2014-03-15 00:42:00.000000', 'temperatura', 664.0000, 'ºC'),
	(256345, 121, '2014-03-15 00:42:01.000000', 'temperatura', 1070.0000, 'ºC'),
	(256346, 121, '2014-03-15 00:42:02.000000', 'temperatura', 962.0000, 'ºC'),
	(256347, 121, '2014-03-15 00:42:03.000000', 'temperatura', 397.0000, 'ºC'),
	(256348, 121, '2014-03-15 00:42:04.000000', 'temperatura', 301.0000, 'ºC'),
	(256349, 121, '2014-03-15 00:42:05.000000', 'temperatura', 314.0000, 'ºC'),
	(256350, 121, '2014-03-15 00:42:06.000000', 'temperatura', 666.0000, 'ºC'),
	(256351, 121, '2014-03-15 00:42:07.000000', 'temperatura', 1189.0000, 'ºC'),
	(256352, 121, '2014-03-15 00:42:08.000000', 'temperatura', 349.0000, 'ºC'),
	(256353, 121, '2014-03-15 00:42:09.000000', 'temperatura', 579.0000, 'ºC'),
	(256354, 121, '2014-03-15 00:42:10.000000', 'temperatura', 646.0000, 'ºC'),
	(256355, 121, '2014-03-15 00:42:11.000000', 'temperatura', 296.0000, 'ºC'),
	(256356, 121, '2014-03-15 00:42:12.000000', 'temperatura', 743.0000, 'ºC'),
	(256357, 121, '2014-03-15 00:42:13.000000', 'temperatura', 427.0000, 'ºC'),
	(256358, 121, '2014-03-15 00:42:14.000000', 'temperatura', 1108.0000, 'ºC'),
	(256359, 121, '2014-03-15 00:42:15.000000', 'temperatura', 659.0000, 'ºC'),
	(256360, 121, '2014-03-15 00:42:16.000000', 'temperatura', 1172.0000, 'ºC'),
	(256361, 121, '2014-03-15 00:42:17.000000', 'temperatura', 281.0000, 'ºC'),
	(256362, 121, '2014-03-15 00:42:18.000000', 'temperatura', 292.0000, 'ºC'),
	(256363, 121, '2014-03-15 00:42:19.000000', 'temperatura', 616.0000, 'ºC'),
	(256364, 121, '2014-03-15 00:42:20.000000', 'temperatura', 1006.0000, 'ºC'),
	(256365, 121, '2014-03-15 00:42:21.000000', 'temperatura', 784.0000, 'ºC'),
	(256366, 121, '2014-03-15 00:42:22.000000', 'temperatura', 899.0000, 'ºC'),
	(256367, 121, '2014-03-15 00:42:23.000000', 'temperatura', 945.0000, 'ºC'),
	(256368, 121, '2014-03-15 00:42:24.000000', 'temperatura', 830.0000, 'ºC'),
	(256369, 121, '2014-03-15 00:42:25.000000', 'temperatura', 113.0000, 'ºC'),
	(256370, 121, '2014-03-15 00:42:26.000000', 'temperatura', 475.0000, 'ºC'),
	(256371, 121, '2014-03-15 00:42:27.000000', 'temperatura', 838.0000, 'ºC'),
	(256372, 121, '2014-03-15 00:42:28.000000', 'temperatura', 365.0000, 'ºC'),
	(256373, 121, '2014-03-15 00:42:29.000000', 'temperatura', 510.0000, 'ºC'),
	(256374, 121, '2014-03-15 00:42:30.000000', 'temperatura', 258.0000, 'ºC'),
	(256375, 121, '2014-03-15 00:42:31.000000', 'temperatura', 960.0000, 'ºC'),
	(256376, 121, '2014-03-15 00:42:32.000000', 'temperatura', 424.0000, 'ºC'),
	(256377, 121, '2014-03-15 00:42:33.000000', 'temperatura', 443.0000, 'ºC'),
	(256378, 121, '2014-03-15 00:42:34.000000', 'temperatura', 941.0000, 'ºC'),
	(256379, 121, '2014-03-15 00:42:35.000000', 'temperatura', 979.0000, 'ºC'),
	(256380, 121, '2014-03-15 00:42:36.000000', 'temperatura', 873.0000, 'ºC'),
	(256381, 121, '2014-03-15 00:42:37.000000', 'temperatura', 228.0000, 'ºC'),
	(256382, 121, '2014-03-15 00:42:38.000000', 'temperatura', 922.0000, 'ºC'),
	(256383, 121, '2014-03-15 00:42:39.000000', 'temperatura', 324.0000, 'ºC'),
	(256384, 121, '2014-03-15 00:42:40.000000', 'temperatura', 55.0000, 'ºC'),
	(256385, 121, '2014-03-15 00:42:41.000000', 'temperatura', 504.0000, 'ºC'),
	(256386, 121, '2014-03-15 00:42:42.000000', 'temperatura', 1156.0000, 'ºC'),
	(256387, 121, '2014-03-15 00:42:43.000000', 'temperatura', 668.0000, 'ºC'),
	(256388, 121, '2014-03-15 00:42:44.000000', 'temperatura', 1072.0000, 'ºC'),
	(256389, 121, '2014-03-15 00:42:45.000000', 'temperatura', 955.0000, 'ºC'),
	(256390, 121, '2014-03-15 00:42:46.000000', 'temperatura', 362.0000, 'ºC'),
	(256391, 121, '2014-03-15 00:42:47.000000', 'temperatura', 143.0000, 'ºC'),
	(256392, 121, '2014-03-15 00:42:48.000000', 'temperatura', 832.0000, 'ºC'),
	(256393, 121, '2014-03-15 00:42:49.000000', 'temperatura', 131.0000, 'ºC'),
	(256394, 121, '2014-03-15 00:42:50.000000', 'temperatura', 560.0000, 'ºC'),
	(256395, 121, '2014-03-15 00:42:51.000000', 'temperatura', 6.0000, 'ºC'),
	(256396, 121, '2014-03-15 00:42:52.000000', 'temperatura', 749.0000, 'ºC'),
	(256397, 121, '2014-03-15 00:42:53.000000', 'temperatura', 130.0000, 'ºC'),
	(256398, 121, '2014-03-15 00:42:54.000000', 'temperatura', 802.0000, 'ºC'),
	(256399, 121, '2014-03-15 00:42:55.000000', 'temperatura', 21.0000, 'ºC'),
	(256400, 121, '2014-03-15 00:42:56.000000', 'temperatura', 101.0000, 'ºC'),
	(256401, 121, '2014-03-15 00:42:57.000000', 'temperatura', 441.0000, 'ºC'),
	(256402, 121, '2014-03-15 00:42:58.000000', 'temperatura', 704.0000, 'ºC'),
	(256403, 121, '2014-03-15 00:42:59.000000', 'temperatura', 998.0000, 'ºC'),
	(256404, 121, '2014-03-15 00:43:00.000000', 'temperatura', 479.0000, 'ºC'),
	(256405, 121, '2014-03-15 00:43:01.000000', 'temperatura', 602.0000, 'ºC'),
	(256406, 121, '2014-03-15 00:43:02.000000', 'temperatura', 373.0000, 'ºC'),
	(256407, 121, '2014-03-15 00:43:03.000000', 'temperatura', 60.0000, 'ºC'),
	(256408, 121, '2014-03-15 00:43:04.000000', 'temperatura', 380.0000, 'ºC'),
	(256409, 121, '2014-03-15 00:43:05.000000', 'temperatura', 520.0000, 'ºC'),
	(256410, 121, '2014-03-15 00:43:06.000000', 'temperatura', 260.0000, 'ºC'),
	(256411, 121, '2014-03-15 00:43:07.000000', 'temperatura', 939.0000, 'ºC'),
	(256412, 121, '2014-03-15 00:43:08.000000', 'temperatura', 319.0000, 'ºC'),
	(256413, 121, '2014-03-15 00:43:09.000000', 'temperatura', 1179.0000, 'ºC'),
	(256414, 121, '2014-03-15 00:43:10.000000', 'temperatura', 135.0000, 'ºC'),
	(256415, 121, '2014-03-15 00:43:11.000000', 'temperatura', 741.0000, 'ºC'),
	(256416, 121, '2014-03-15 00:43:12.000000', 'temperatura', 899.0000, 'ºC'),
	(256417, 121, '2014-03-15 00:43:13.000000', 'temperatura', 1074.0000, 'ºC'),
	(256418, 121, '2014-03-15 00:43:14.000000', 'temperatura', 271.0000, 'ºC'),
	(256419, 121, '2014-03-15 00:43:15.000000', 'temperatura', 534.0000, 'ºC'),
	(256420, 121, '2014-03-15 00:43:16.000000', 'temperatura', 660.0000, 'ºC'),
	(256421, 121, '2014-03-15 00:43:17.000000', 'temperatura', 495.0000, 'ºC'),
	(256422, 121, '2014-03-15 00:43:18.000000', 'temperatura', 497.0000, 'ºC'),
	(256423, 121, '2014-03-15 00:43:19.000000', 'temperatura', 1001.0000, 'ºC'),
	(256424, 121, '2014-03-15 00:43:20.000000', 'temperatura', 1112.0000, 'ºC'),
	(256425, 121, '2014-03-15 00:43:21.000000', 'temperatura', 160.0000, 'ºC'),
	(256426, 121, '2014-03-15 00:43:22.000000', 'temperatura', 1063.0000, 'ºC'),
	(256427, 121, '2014-03-15 00:43:23.000000', 'temperatura', 36.0000, 'ºC'),
	(256428, 121, '2014-03-15 00:43:24.000000', 'temperatura', 593.0000, 'ºC'),
	(256429, 121, '2014-03-15 00:43:25.000000', 'temperatura', 457.0000, 'ºC'),
	(256430, 121, '2014-03-15 00:43:26.000000', 'temperatura', 507.0000, 'ºC'),
	(256431, 121, '2014-03-15 00:43:27.000000', 'temperatura', 1162.0000, 'ºC'),
	(256432, 121, '2014-03-15 00:43:28.000000', 'temperatura', 690.0000, 'ºC'),
	(256433, 121, '2014-03-15 00:43:29.000000', 'temperatura', 1164.0000, 'ºC'),
	(256434, 121, '2014-03-15 00:43:30.000000', 'temperatura', 153.0000, 'ºC'),
	(256435, 121, '2014-03-15 00:43:31.000000', 'temperatura', 871.0000, 'ºC'),
	(256436, 121, '2014-03-15 00:43:32.000000', 'temperatura', 298.0000, 'ºC'),
	(256437, 121, '2014-03-15 00:43:33.000000', 'temperatura', 79.0000, 'ºC'),
	(256438, 121, '2014-03-15 00:43:34.000000', 'temperatura', 698.0000, 'ºC'),
	(256439, 121, '2014-03-15 00:43:35.000000', 'temperatura', 857.0000, 'ºC'),
	(256440, 121, '2014-03-15 00:43:36.000000', 'temperatura', 989.0000, 'ºC'),
	(256441, 121, '2014-03-15 00:43:37.000000', 'temperatura', 1174.0000, 'ºC'),
	(256442, 121, '2014-03-15 00:43:38.000000', 'temperatura', 502.0000, 'ºC'),
	(256443, 121, '2014-03-15 00:43:39.000000', 'temperatura', 191.0000, 'ºC'),
	(256444, 121, '2014-03-15 00:43:40.000000', 'temperatura', 651.0000, 'ºC'),
	(256445, 121, '2014-03-15 00:43:41.000000', 'temperatura', 280.0000, 'ºC'),
	(256446, 121, '2014-03-15 00:43:42.000000', 'temperatura', 648.0000, 'ºC'),
	(256447, 121, '2014-03-15 00:43:43.000000', 'temperatura', 2.0000, 'ºC'),
	(256448, 121, '2014-03-15 00:43:44.000000', 'temperatura', 467.0000, 'ºC'),
	(256449, 121, '2014-03-15 00:43:45.000000', 'temperatura', 1127.0000, 'ºC'),
	(256450, 121, '2014-03-15 00:43:46.000000', 'temperatura', 637.0000, 'ºC'),
	(256451, 121, '2014-03-15 00:43:47.000000', 'temperatura', 1002.0000, 'ºC'),
	(256452, 121, '2014-03-15 00:43:48.000000', 'temperatura', 702.0000, 'ºC'),
	(256453, 121, '2014-03-15 00:43:49.000000', 'temperatura', 503.0000, 'ºC'),
	(256454, 121, '2014-03-15 00:43:50.000000', 'temperatura', 409.0000, 'ºC'),
	(256455, 121, '2014-03-15 00:43:51.000000', 'temperatura', 535.0000, 'ºC'),
	(256456, 121, '2014-03-15 00:43:52.000000', 'temperatura', 251.0000, 'ºC'),
	(256457, 121, '2014-03-15 00:43:53.000000', 'temperatura', 848.0000, 'ºC'),
	(256458, 121, '2014-03-15 00:43:54.000000', 'temperatura', 1089.0000, 'ºC'),
	(256459, 121, '2014-03-15 00:43:55.000000', 'temperatura', 503.0000, 'ºC'),
	(256460, 121, '2014-03-15 00:43:56.000000', 'temperatura', 449.0000, 'ºC'),
	(256461, 121, '2014-03-15 00:43:57.000000', 'temperatura', 736.0000, 'ºC'),
	(256462, 121, '2014-03-15 00:43:58.000000', 'temperatura', 1132.0000, 'ºC'),
	(256463, 121, '2014-03-15 00:43:59.000000', 'temperatura', 1055.0000, 'ºC'),
	(256464, 121, '2014-03-15 00:44:00.000000', 'temperatura', 679.0000, 'ºC'),
	(256465, 121, '2014-03-15 00:44:01.000000', 'temperatura', 230.0000, 'ºC'),
	(256466, 121, '2014-03-15 00:44:02.000000', 'temperatura', 313.0000, 'ºC'),
	(256467, 121, '2014-03-15 00:44:03.000000', 'temperatura', 875.0000, 'ºC'),
	(256468, 121, '2014-03-15 00:44:04.000000', 'temperatura', 1038.0000, 'ºC'),
	(256469, 121, '2014-03-15 00:44:05.000000', 'temperatura', 165.0000, 'ºC'),
	(256470, 121, '2014-03-15 00:44:06.000000', 'temperatura', 111.0000, 'ºC'),
	(256471, 121, '2014-03-15 00:44:07.000000', 'temperatura', 63.0000, 'ºC'),
	(256472, 121, '2014-03-15 00:44:08.000000', 'temperatura', 1179.0000, 'ºC'),
	(256473, 121, '2014-03-15 00:44:09.000000', 'temperatura', 909.0000, 'ºC'),
	(256474, 121, '2014-03-15 00:44:10.000000', 'temperatura', 1007.0000, 'ºC'),
	(256475, 121, '2014-03-15 00:44:11.000000', 'temperatura', 1109.0000, 'ºC'),
	(256476, 121, '2014-03-15 00:44:12.000000', 'temperatura', 126.0000, 'ºC'),
	(256477, 121, '2014-03-15 00:44:13.000000', 'temperatura', 902.0000, 'ºC'),
	(256478, 121, '2014-03-15 00:44:14.000000', 'temperatura', 531.0000, 'ºC'),
	(256479, 121, '2014-03-15 00:44:15.000000', 'temperatura', 1151.0000, 'ºC'),
	(256480, 121, '2014-03-15 00:44:16.000000', 'temperatura', 560.0000, 'ºC'),
	(256481, 121, '2014-03-15 00:44:17.000000', 'temperatura', 550.0000, 'ºC'),
	(256482, 121, '2014-03-15 00:44:18.000000', 'temperatura', 1070.0000, 'ºC'),
	(256483, 121, '2014-03-15 00:44:19.000000', 'temperatura', 99.0000, 'ºC'),
	(256484, 121, '2014-03-15 00:44:20.000000', 'temperatura', 887.0000, 'ºC'),
	(256485, 121, '2014-03-15 00:44:21.000000', 'temperatura', 539.0000, 'ºC'),
	(256486, 121, '2014-03-15 00:44:22.000000', 'temperatura', 34.0000, 'ºC'),
	(256487, 121, '2014-03-15 00:44:23.000000', 'temperatura', 955.0000, 'ºC'),
	(256488, 121, '2014-03-15 00:44:24.000000', 'temperatura', 1071.0000, 'ºC'),
	(256489, 121, '2014-03-15 00:44:25.000000', 'temperatura', 93.0000, 'ºC'),
	(256490, 121, '2014-03-15 00:44:26.000000', 'temperatura', 854.0000, 'ºC'),
	(256491, 121, '2014-03-15 00:44:27.000000', 'temperatura', 388.0000, 'ºC'),
	(256492, 121, '2014-03-15 00:44:28.000000', 'temperatura', 579.0000, 'ºC'),
	(256493, 121, '2014-03-15 00:44:29.000000', 'temperatura', 532.0000, 'ºC'),
	(256494, 121, '2014-03-15 00:44:30.000000', 'temperatura', 922.0000, 'ºC'),
	(256495, 121, '2014-03-15 00:44:31.000000', 'temperatura', 615.0000, 'ºC'),
	(256496, 121, '2014-03-15 00:44:32.000000', 'temperatura', 310.0000, 'ºC'),
	(256497, 121, '2014-03-15 00:44:33.000000', 'temperatura', 907.0000, 'ºC'),
	(256498, 121, '2014-03-15 00:44:34.000000', 'temperatura', 3.0000, 'ºC'),
	(256499, 121, '2014-03-15 00:44:35.000000', 'temperatura', 894.0000, 'ºC'),
	(256500, 121, '2014-03-15 00:44:36.000000', 'temperatura', 861.0000, 'ºC'),
	(256501, 121, '2014-03-15 00:44:37.000000', 'temperatura', 425.0000, 'ºC'),
	(256502, 121, '2014-03-15 00:44:38.000000', 'temperatura', 741.0000, 'ºC'),
	(256503, 121, '2014-03-15 00:44:39.000000', 'temperatura', 30.0000, 'ºC'),
	(256504, 121, '2014-03-15 00:44:40.000000', 'temperatura', 329.0000, 'ºC'),
	(256505, 121, '2014-03-15 00:44:41.000000', 'temperatura', 354.0000, 'ºC'),
	(256506, 121, '2014-03-15 00:44:42.000000', 'temperatura', 786.0000, 'ºC'),
	(256507, 121, '2014-03-15 00:44:43.000000', 'temperatura', 466.0000, 'ºC'),
	(256508, 121, '2014-03-15 00:44:44.000000', 'temperatura', 1172.0000, 'ºC'),
	(256509, 121, '2014-03-15 00:44:45.000000', 'temperatura', 866.0000, 'ºC'),
	(256510, 121, '2014-03-15 00:44:46.000000', 'temperatura', 811.0000, 'ºC'),
	(256511, 121, '2014-03-15 00:44:47.000000', 'temperatura', 258.0000, 'ºC'),
	(256512, 121, '2014-03-15 00:44:48.000000', 'temperatura', 58.0000, 'ºC'),
	(256513, 121, '2014-03-15 00:44:49.000000', 'temperatura', 716.0000, 'ºC'),
	(256514, 121, '2014-03-15 00:44:50.000000', 'temperatura', 1006.0000, 'ºC'),
	(256515, 121, '2014-03-15 00:44:51.000000', 'temperatura', 484.0000, 'ºC'),
	(256516, 121, '2014-03-15 00:44:52.000000', 'temperatura', 600.0000, 'ºC'),
	(256517, 121, '2014-03-15 00:44:53.000000', 'temperatura', 351.0000, 'ºC'),
	(256518, 121, '2014-03-15 00:44:54.000000', 'temperatura', 1156.0000, 'ºC'),
	(256519, 121, '2014-03-15 00:44:55.000000', 'temperatura', 1125.0000, 'ºC'),
	(256520, 121, '2014-03-15 00:44:56.000000', 'temperatura', 957.0000, 'ºC'),
	(256521, 121, '2014-03-15 00:44:57.000000', 'temperatura', 214.0000, 'ºC'),
	(256522, 121, '2014-03-15 00:44:58.000000', 'temperatura', 596.0000, 'ºC'),
	(256523, 121, '2014-03-15 00:44:59.000000', 'temperatura', 1140.0000, 'ºC'),
	(256524, 121, '2014-03-15 00:45:00.000000', 'temperatura', 314.0000, 'ºC'),
	(256525, 121, '2014-03-15 00:45:01.000000', 'temperatura', 549.0000, 'ºC'),
	(256526, 121, '2014-03-15 00:45:02.000000', 'temperatura', 604.0000, 'ºC'),
	(256527, 121, '2014-03-15 00:45:03.000000', 'temperatura', 172.0000, 'ºC'),
	(256528, 121, '2014-03-15 00:45:04.000000', 'temperatura', 251.0000, 'ºC'),
	(256529, 121, '2014-03-15 00:45:05.000000', 'temperatura', 738.0000, 'ºC'),
	(256530, 121, '2014-03-15 00:45:06.000000', 'temperatura', 537.0000, 'ºC'),
	(256531, 121, '2014-03-15 00:45:07.000000', 'temperatura', 473.0000, 'ºC'),
	(256532, 121, '2014-03-15 00:45:08.000000', 'temperatura', 752.0000, 'ºC'),
	(256533, 121, '2014-03-15 00:45:09.000000', 'temperatura', 1142.0000, 'ºC'),
	(256534, 121, '2014-03-15 00:45:10.000000', 'temperatura', 1056.0000, 'ºC'),
	(256535, 121, '2014-03-15 00:45:11.000000', 'temperatura', 656.0000, 'ºC'),
	(256536, 121, '2014-03-15 00:45:12.000000', 'temperatura', 110.0000, 'ºC'),
	(256537, 121, '2014-03-15 00:45:13.000000', 'temperatura', 982.0000, 'ºC'),
	(256538, 121, '2014-03-15 00:45:14.000000', 'temperatura', 981.0000, 'ºC'),
	(256539, 121, '2014-03-15 00:45:15.000000', 'temperatura', 758.0000, 'ºC'),
	(256540, 121, '2014-03-15 00:45:16.000000', 'temperatura', 850.0000, 'ºC'),
	(256541, 121, '2014-03-15 00:45:17.000000', 'temperatura', 777.0000, 'ºC'),
	(256542, 121, '2014-03-15 00:45:18.000000', 'temperatura', 136.0000, 'ºC'),
	(256543, 121, '2014-03-15 00:45:19.000000', 'temperatura', 748.0000, 'ºC'),
	(256544, 121, '2014-03-15 00:45:20.000000', 'temperatura', 932.0000, 'ºC'),
	(256545, 121, '2014-03-15 00:45:21.000000', 'temperatura', 19.0000, 'ºC'),
	(256546, 121, '2014-03-15 00:45:22.000000', 'temperatura', 898.0000, 'ºC'),
	(256547, 121, '2014-03-15 00:45:23.000000', 'temperatura', 835.0000, 'ºC'),
	(256548, 121, '2014-03-15 00:45:24.000000', 'temperatura', 282.0000, 'ºC'),
	(256549, 121, '2014-03-15 00:45:25.000000', 'temperatura', 104.0000, 'ºC'),
	(256550, 121, '2014-03-15 00:45:26.000000', 'temperatura', 875.0000, 'ºC'),
	(256551, 121, '2014-03-15 00:45:27.000000', 'temperatura', 464.0000, 'ºC'),
	(256552, 121, '2014-03-15 00:45:28.000000', 'temperatura', 896.0000, 'ºC'),
	(256553, 121, '2014-03-15 00:45:29.000000', 'temperatura', 687.0000, 'ºC'),
	(256554, 121, '2014-03-15 00:45:30.000000', 'temperatura', 749.0000, 'ºC'),
	(256555, 121, '2014-03-15 00:45:31.000000', 'temperatura', 486.0000, 'ºC'),
	(256556, 121, '2014-03-15 00:45:32.000000', 'temperatura', 181.0000, 'ºC'),
	(256557, 121, '2014-03-15 00:45:33.000000', 'temperatura', 650.0000, 'ºC'),
	(256558, 121, '2014-03-15 00:45:34.000000', 'temperatura', 305.0000, 'ºC'),
	(256559, 121, '2014-03-15 00:45:35.000000', 'temperatura', 778.0000, 'ºC'),
	(256560, 121, '2014-03-15 00:45:36.000000', 'temperatura', 573.0000, 'ºC'),
	(256561, 121, '2014-03-15 00:45:37.000000', 'temperatura', 532.0000, 'ºC'),
	(256562, 121, '2014-03-15 00:45:38.000000', 'temperatura', 941.0000, 'ºC'),
	(256563, 121, '2014-03-15 00:45:39.000000', 'temperatura', 709.0000, 'ºC'),
	(256564, 121, '2014-03-15 00:45:40.000000', 'temperatura', 725.0000, 'ºC'),
	(256565, 121, '2014-03-15 00:45:41.000000', 'temperatura', 296.0000, 'ºC'),
	(256566, 121, '2014-03-15 00:45:42.000000', 'temperatura', 508.0000, 'ºC'),
	(256567, 121, '2014-03-15 00:45:43.000000', 'temperatura', 449.0000, 'ºC'),
	(256568, 121, '2014-03-15 00:45:44.000000', 'temperatura', 724.0000, 'ºC'),
	(256569, 121, '2014-03-15 00:45:45.000000', 'temperatura', 1075.0000, 'ºC'),
	(256570, 121, '2014-03-15 00:45:46.000000', 'temperatura', 801.0000, 'ºC'),
	(256571, 121, '2014-03-15 00:45:47.000000', 'temperatura', 779.0000, 'ºC'),
	(256572, 121, '2014-03-15 00:45:48.000000', 'temperatura', 296.0000, 'ºC'),
	(256573, 121, '2014-03-15 00:45:49.000000', 'temperatura', 341.0000, 'ºC'),
	(256574, 121, '2014-03-15 00:45:50.000000', 'temperatura', 820.0000, 'ºC'),
	(256575, 121, '2014-03-15 00:45:51.000000', 'temperatura', 677.0000, 'ºC'),
	(256576, 121, '2014-03-15 00:45:52.000000', 'temperatura', 925.0000, 'ºC'),
	(256577, 121, '2014-03-15 00:45:53.000000', 'temperatura', 193.0000, 'ºC'),
	(256578, 121, '2014-03-15 00:45:54.000000', 'temperatura', 592.0000, 'ºC'),
	(256579, 121, '2014-03-15 00:45:55.000000', 'temperatura', 1180.0000, 'ºC'),
	(256580, 121, '2014-03-15 00:45:56.000000', 'temperatura', 525.0000, 'ºC'),
	(256581, 121, '2014-03-15 00:45:57.000000', 'temperatura', 284.0000, 'ºC'),
	(256582, 121, '2014-03-15 00:45:58.000000', 'temperatura', 1048.0000, 'ºC'),
	(256583, 121, '2014-03-15 00:45:59.000000', 'temperatura', 786.0000, 'ºC'),
	(256584, 121, '2014-03-15 00:46:00.000000', 'temperatura', 788.0000, 'ºC'),
	(256585, 121, '2014-03-15 00:46:01.000000', 'temperatura', 384.0000, 'ºC'),
	(256586, 121, '2014-03-15 00:46:02.000000', 'temperatura', 753.0000, 'ºC'),
	(256587, 121, '2014-03-15 00:46:03.000000', 'temperatura', 217.0000, 'ºC'),
	(256588, 121, '2014-03-15 00:46:04.000000', 'temperatura', 26.0000, 'ºC'),
	(256589, 121, '2014-03-15 00:46:05.000000', 'temperatura', 679.0000, 'ºC'),
	(256590, 121, '2014-03-15 00:46:06.000000', 'temperatura', 919.0000, 'ºC'),
	(256591, 121, '2014-03-15 00:46:07.000000', 'temperatura', 157.0000, 'ºC'),
	(256592, 121, '2014-03-15 00:46:08.000000', 'temperatura', 427.0000, 'ºC'),
	(256593, 121, '2014-03-15 00:46:09.000000', 'temperatura', 466.0000, 'ºC'),
	(256594, 121, '2014-03-15 00:46:10.000000', 'temperatura', 1051.0000, 'ºC'),
	(256595, 121, '2014-03-15 00:46:11.000000', 'temperatura', 256.0000, 'ºC'),
	(256596, 121, '2014-03-15 00:46:12.000000', 'temperatura', 526.0000, 'ºC'),
	(256597, 121, '2014-03-15 00:46:13.000000', 'temperatura', 665.0000, 'ºC'),
	(256598, 121, '2014-03-15 00:46:14.000000', 'temperatura', 546.0000, 'ºC'),
	(256599, 121, '2014-03-15 00:46:15.000000', 'temperatura', 734.0000, 'ºC'),
	(256600, 121, '2014-03-15 00:46:16.000000', 'temperatura', 835.0000, 'ºC'),
	(256601, 121, '2014-03-15 00:46:17.000000', 'temperatura', 772.0000, 'ºC'),
	(256602, 121, '2014-03-15 00:46:18.000000', 'temperatura', 157.0000, 'ºC'),
	(256603, 121, '2014-03-15 00:46:19.000000', 'temperatura', 868.0000, 'ºC'),
	(256604, 121, '2014-03-15 00:46:20.000000', 'temperatura', 271.0000, 'ºC'),
	(256605, 121, '2014-03-15 00:46:21.000000', 'temperatura', 1151.0000, 'ºC'),
	(256606, 121, '2014-03-15 00:46:22.000000', 'temperatura', 141.0000, 'ºC'),
	(256607, 121, '2014-03-15 00:46:23.000000', 'temperatura', 851.0000, 'ºC'),
	(256608, 121, '2014-03-15 00:46:24.000000', 'temperatura', 236.0000, 'ºC'),
	(256609, 121, '2014-03-15 00:46:25.000000', 'temperatura', 1025.0000, 'ºC'),
	(256610, 121, '2014-03-15 00:46:26.000000', 'temperatura', 818.0000, 'ºC'),
	(256611, 121, '2014-03-15 00:46:27.000000', 'temperatura', 1015.0000, 'ºC'),
	(256612, 121, '2014-03-15 00:46:28.000000', 'temperatura', 221.0000, 'ºC'),
	(256613, 121, '2014-03-15 00:46:29.000000', 'temperatura', 463.0000, 'ºC'),
	(256614, 121, '2014-03-15 00:46:30.000000', 'temperatura', 452.0000, 'ºC'),
	(256615, 121, '2014-03-15 00:46:31.000000', 'temperatura', 870.0000, 'ºC'),
	(256616, 121, '2014-03-15 00:46:32.000000', 'temperatura', 593.0000, 'ºC'),
	(256617, 121, '2014-03-15 00:46:33.000000', 'temperatura', 358.0000, 'ºC'),
	(256618, 121, '2014-03-15 00:46:34.000000', 'temperatura', 9.0000, 'ºC'),
	(256619, 121, '2014-03-15 00:46:35.000000', 'temperatura', 173.0000, 'ºC'),
	(256620, 121, '2014-03-15 00:46:36.000000', 'temperatura', 838.0000, 'ºC'),
	(256621, 121, '2014-03-15 00:46:37.000000', 'temperatura', 71.0000, 'ºC'),
	(256622, 121, '2014-03-15 00:46:38.000000', 'temperatura', 243.0000, 'ºC'),
	(256623, 121, '2014-03-15 00:46:39.000000', 'temperatura', 1001.0000, 'ºC'),
	(256624, 121, '2014-03-15 00:46:40.000000', 'temperatura', 678.0000, 'ºC'),
	(256625, 121, '2014-03-15 00:46:41.000000', 'temperatura', 388.0000, 'ºC'),
	(256626, 121, '2014-03-15 00:46:42.000000', 'temperatura', 1108.0000, 'ºC'),
	(256627, 121, '2014-03-15 00:46:43.000000', 'temperatura', 774.0000, 'ºC'),
	(256628, 121, '2014-03-15 00:46:44.000000', 'temperatura', 546.0000, 'ºC'),
	(256629, 121, '2014-03-15 00:46:45.000000', 'temperatura', 409.0000, 'ºC'),
	(256630, 121, '2014-03-15 00:46:46.000000', 'temperatura', 409.0000, 'ºC'),
	(256631, 121, '2014-03-15 00:46:47.000000', 'temperatura', 819.0000, 'ºC'),
	(256632, 121, '2014-03-15 00:46:48.000000', 'temperatura', 468.0000, 'ºC'),
	(256633, 121, '2014-03-15 00:46:49.000000', 'temperatura', 1085.0000, 'ºC'),
	(256634, 121, '2014-03-15 00:46:50.000000', 'temperatura', 419.0000, 'ºC'),
	(256635, 121, '2014-03-15 00:46:51.000000', 'temperatura', 43.0000, 'ºC'),
	(256636, 121, '2014-03-15 00:46:52.000000', 'temperatura', 159.0000, 'ºC'),
	(256637, 121, '2014-03-15 00:46:53.000000', 'temperatura', 667.0000, 'ºC'),
	(256638, 121, '2014-03-15 00:46:54.000000', 'temperatura', 456.0000, 'ºC'),
	(256639, 121, '2014-03-15 00:46:55.000000', 'temperatura', 282.0000, 'ºC'),
	(256640, 121, '2014-03-15 00:46:56.000000', 'temperatura', 43.0000, 'ºC'),
	(256641, 121, '2014-03-15 00:46:57.000000', 'temperatura', 570.0000, 'ºC'),
	(256642, 121, '2014-03-15 00:46:58.000000', 'temperatura', 320.0000, 'ºC'),
	(256643, 121, '2014-03-15 00:46:59.000000', 'temperatura', 1089.0000, 'ºC'),
	(256644, 121, '2014-03-15 00:47:00.000000', 'temperatura', 886.0000, 'ºC'),
	(256645, 121, '2014-03-15 00:47:01.000000', 'temperatura', 1162.0000, 'ºC'),
	(256646, 121, '2014-03-15 00:47:02.000000', 'temperatura', 755.0000, 'ºC'),
	(256647, 121, '2014-03-15 00:47:03.000000', 'temperatura', 289.0000, 'ºC'),
	(256648, 121, '2014-03-15 00:47:04.000000', 'temperatura', 378.0000, 'ºC'),
	(256649, 121, '2014-03-15 00:47:05.000000', 'temperatura', 1026.0000, 'ºC'),
	(256650, 121, '2014-03-15 00:47:06.000000', 'temperatura', 396.0000, 'ºC'),
	(256651, 121, '2014-03-15 00:47:07.000000', 'temperatura', 101.0000, 'ºC'),
	(256652, 121, '2014-03-15 00:47:08.000000', 'temperatura', 519.0000, 'ºC'),
	(256653, 121, '2014-03-15 00:47:09.000000', 'temperatura', 1092.0000, 'ºC'),
	(256654, 121, '2014-03-15 00:47:10.000000', 'temperatura', 302.0000, 'ºC'),
	(256655, 121, '2014-03-15 00:47:11.000000', 'temperatura', 636.0000, 'ºC'),
	(256656, 121, '2014-03-15 00:47:12.000000', 'temperatura', 1075.0000, 'ºC'),
	(256657, 121, '2014-03-15 00:47:13.000000', 'temperatura', 1068.0000, 'ºC'),
	(256658, 121, '2014-03-15 00:47:14.000000', 'temperatura', 915.0000, 'ºC'),
	(256659, 121, '2014-03-15 00:47:15.000000', 'temperatura', 170.0000, 'ºC'),
	(256660, 121, '2014-03-15 00:47:16.000000', 'temperatura', 506.0000, 'ºC'),
	(256661, 121, '2014-03-15 00:47:17.000000', 'temperatura', 819.0000, 'ºC'),
	(256662, 121, '2014-03-15 00:47:18.000000', 'temperatura', 178.0000, 'ºC'),
	(256663, 121, '2014-03-15 00:47:19.000000', 'temperatura', 833.0000, 'ºC'),
	(256664, 121, '2014-03-15 00:47:20.000000', 'temperatura', 33.0000, 'ºC'),
	(256665, 121, '2014-03-15 00:47:21.000000', 'temperatura', 67.0000, 'ºC'),
	(256666, 121, '2014-03-15 00:47:22.000000', 'temperatura', 236.0000, 'ºC'),
	(256667, 121, '2014-03-15 00:47:23.000000', 'temperatura', 978.0000, 'ºC'),
	(256668, 121, '2014-03-15 00:47:24.000000', 'temperatura', 582.0000, 'ºC'),
	(256669, 121, '2014-03-15 00:47:25.000000', 'temperatura', 1178.0000, 'ºC'),
	(256670, 121, '2014-03-15 00:47:26.000000', 'temperatura', 545.0000, 'ºC'),
	(256671, 121, '2014-03-15 00:47:27.000000', 'temperatura', 390.0000, 'ºC'),
	(256672, 121, '2014-03-15 00:47:28.000000', 'temperatura', 315.0000, 'ºC'),
	(256673, 121, '2014-03-15 00:47:29.000000', 'temperatura', 408.0000, 'ºC'),
	(256674, 121, '2014-03-15 00:47:30.000000', 'temperatura', 1094.0000, 'ºC'),
	(256675, 121, '2014-03-15 00:47:31.000000', 'temperatura', 646.0000, 'ºC'),
	(256676, 121, '2014-03-15 00:47:32.000000', 'temperatura', 1147.0000, 'ºC'),
	(256677, 121, '2014-03-15 00:47:33.000000', 'temperatura', 199.0000, 'ºC'),
	(256678, 121, '2014-03-15 00:47:34.000000', 'temperatura', 1153.0000, 'ºC'),
	(256679, 121, '2014-03-15 00:47:35.000000', 'temperatura', 369.0000, 'ºC'),
	(256680, 121, '2014-03-15 00:47:36.000000', 'temperatura', 789.0000, 'ºC'),
	(256681, 121, '2014-03-15 00:47:37.000000', 'temperatura', 435.0000, 'ºC'),
	(256682, 121, '2014-03-15 00:47:38.000000', 'temperatura', 1010.0000, 'ºC'),
	(256683, 121, '2014-03-15 00:47:39.000000', 'temperatura', 147.0000, 'ºC'),
	(256684, 121, '2014-03-15 00:47:40.000000', 'temperatura', 106.0000, 'ºC'),
	(256685, 121, '2014-03-15 00:47:41.000000', 'temperatura', 86.0000, 'ºC'),
	(256686, 121, '2014-03-15 00:47:42.000000', 'temperatura', 116.0000, 'ºC'),
	(256687, 121, '2014-03-15 00:47:43.000000', 'temperatura', 321.0000, 'ºC'),
	(256688, 121, '2014-03-15 00:47:44.000000', 'temperatura', 57.0000, 'ºC'),
	(256689, 121, '2014-03-15 00:47:45.000000', 'temperatura', 524.0000, 'ºC'),
	(256690, 121, '2014-03-15 00:47:46.000000', 'temperatura', 50.0000, 'ºC'),
	(256691, 121, '2014-03-15 00:47:47.000000', 'temperatura', 1076.0000, 'ºC'),
	(256692, 121, '2014-03-15 00:47:48.000000', 'temperatura', 430.0000, 'ºC'),
	(256693, 121, '2014-03-15 00:47:49.000000', 'temperatura', 126.0000, 'ºC'),
	(256694, 121, '2014-03-15 00:47:50.000000', 'temperatura', 537.0000, 'ºC'),
	(256695, 121, '2014-03-15 00:47:51.000000', 'temperatura', 1108.0000, 'ºC'),
	(256696, 121, '2014-03-15 00:47:52.000000', 'temperatura', 331.0000, 'ºC'),
	(256697, 121, '2014-03-15 00:47:53.000000', 'temperatura', 732.0000, 'ºC'),
	(256698, 121, '2014-03-15 00:47:54.000000', 'temperatura', 265.0000, 'ºC'),
	(256699, 121, '2014-03-15 00:47:55.000000', 'temperatura', 332.0000, 'ºC'),
	(256700, 121, '2014-03-15 00:47:56.000000', 'temperatura', 863.0000, 'ºC'),
	(256701, 121, '2014-03-15 00:47:57.000000', 'temperatura', 923.0000, 'ºC'),
	(256702, 121, '2014-03-15 00:47:58.000000', 'temperatura', 823.0000, 'ºC'),
	(256703, 121, '2014-03-15 00:47:59.000000', 'temperatura', 148.0000, 'ºC'),
	(256704, 121, '2014-03-15 00:48:00.000000', 'temperatura', 672.0000, 'ºC'),
	(256705, 121, '2014-03-15 00:48:01.000000', 'temperatura', 516.0000, 'ºC'),
	(256706, 121, '2014-03-15 00:48:02.000000', 'temperatura', 563.0000, 'ºC'),
	(256707, 121, '2014-03-15 00:48:03.000000', 'temperatura', 68.0000, 'ºC'),
	(256708, 121, '2014-03-15 00:48:04.000000', 'temperatura', 1052.0000, 'ºC'),
	(256709, 121, '2014-03-15 00:48:05.000000', 'temperatura', 256.0000, 'ºC'),
	(256710, 121, '2014-03-15 00:48:06.000000', 'temperatura', 526.0000, 'ºC'),
	(256711, 121, '2014-03-15 00:48:07.000000', 'temperatura', 661.0000, 'ºC'),
	(256712, 121, '2014-03-15 00:48:08.000000', 'temperatura', 529.0000, 'ºC'),
	(256713, 121, '2014-03-15 00:48:09.000000', 'temperatura', 663.0000, 'ºC'),
	(256714, 121, '2014-03-15 00:48:10.000000', 'temperatura', 527.0000, 'ºC'),
	(256715, 121, '2014-03-15 00:48:11.000000', 'temperatura', 646.0000, 'ºC'),
	(256716, 121, '2014-03-15 00:48:12.000000', 'temperatura', 450.0000, 'ºC'),
	(256717, 121, '2014-03-15 00:48:13.000000', 'temperatura', 312.0000, 'ºC'),
	(256718, 121, '2014-03-15 00:48:14.000000', 'temperatura', 210.0000, 'ºC'),
	(256719, 121, '2014-03-15 00:48:15.000000', 'temperatura', 114.0000, 'ºC'),
	(256720, 121, '2014-03-15 00:48:16.000000', 'temperatura', 1143.0000, 'ºC'),
	(256721, 121, '2014-03-15 00:48:17.000000', 'temperatura', 571.0000, 'ºC'),
	(256722, 121, '2014-03-15 00:48:18.000000', 'temperatura', 628.0000, 'ºC'),
	(256723, 121, '2014-03-15 00:48:19.000000', 'temperatura', 228.0000, 'ºC'),
	(256724, 121, '2014-03-15 00:48:20.000000', 'temperatura', 458.0000, 'ºC'),
	(256725, 121, '2014-03-15 00:48:21.000000', 'temperatura', 404.0000, 'ºC'),
	(256726, 121, '2014-03-15 00:48:22.000000', 'temperatura', 647.0000, 'ºC'),
	(256727, 121, '2014-03-15 00:48:23.000000', 'temperatura', 824.0000, 'ºC'),
	(256728, 121, '2014-03-15 00:48:24.000000', 'temperatura', 978.0000, 'ºC'),
	(256729, 121, '2014-03-15 00:48:25.000000', 'temperatura', 21.0000, 'ºC'),
	(256730, 121, '2014-03-15 00:48:26.000000', 'temperatura', 770.0000, 'ºC'),
	(256731, 121, '2014-03-15 00:48:27.000000', 'temperatura', 187.0000, 'ºC'),
	(256732, 121, '2014-03-15 00:48:28.000000', 'temperatura', 1024.0000, 'ºC'),
	(256733, 121, '2014-03-15 00:48:29.000000', 'temperatura', 963.0000, 'ºC'),
	(256734, 121, '2014-03-15 00:48:30.000000', 'temperatura', 541.0000, 'ºC'),
	(256735, 121, '2014-03-15 00:48:31.000000', 'temperatura', 1019.0000, 'ºC'),
	(256736, 121, '2014-03-15 00:48:32.000000', 'temperatura', 1070.0000, 'ºC'),
	(256737, 121, '2014-03-15 00:48:33.000000', 'temperatura', 1096.0000, 'ºC'),
	(256738, 121, '2014-03-15 00:48:34.000000', 'temperatura', 1070.0000, 'ºC'),
	(256739, 121, '2014-03-15 00:48:35.000000', 'temperatura', 861.0000, 'ºC'),
	(256740, 121, '2014-03-15 00:48:36.000000', 'temperatura', 1095.0000, 'ºC'),
	(256741, 121, '2014-03-15 00:48:37.000000', 'temperatura', 494.0000, 'ºC'),
	(256742, 121, '2014-03-15 00:48:38.000000', 'temperatura', 384.0000, 'ºC'),
	(256743, 121, '2014-03-15 00:48:39.000000', 'temperatura', 438.0000, 'ºC'),
	(256744, 121, '2014-03-15 00:48:40.000000', 'temperatura', 1038.0000, 'ºC'),
	(256745, 121, '2014-03-15 00:48:41.000000', 'temperatura', 278.0000, 'ºC'),
	(256746, 121, '2014-03-15 00:48:42.000000', 'temperatura', 676.0000, 'ºC'),
	(256747, 121, '2014-03-15 00:48:43.000000', 'temperatura', 146.0000, 'ºC'),
	(256748, 121, '2014-03-15 00:48:44.000000', 'temperatura', 1102.0000, 'ºC'),
	(256749, 121, '2014-03-15 00:48:45.000000', 'temperatura', 274.0000, 'ºC'),
	(256750, 121, '2014-03-15 00:48:46.000000', 'temperatura', 464.0000, 'ºC'),
	(256751, 121, '2014-03-15 00:48:47.000000', 'temperatura', 297.0000, 'ºC'),
	(256752, 121, '2014-03-15 00:48:48.000000', 'temperatura', 93.0000, 'ºC'),
	(256753, 121, '2014-03-15 00:48:49.000000', 'temperatura', 774.0000, 'ºC'),
	(256754, 121, '2014-03-15 00:48:50.000000', 'temperatura', 1192.0000, 'ºC'),
	(256755, 121, '2014-03-15 00:48:51.000000', 'temperatura', 37.0000, 'ºC'),
	(256756, 121, '2014-03-15 00:48:52.000000', 'temperatura', 212.0000, 'ºC'),
	(256757, 121, '2014-03-15 00:48:53.000000', 'temperatura', 948.0000, 'ºC'),
	(256758, 121, '2014-03-15 00:48:54.000000', 'temperatura', 505.0000, 'ºC'),
	(256759, 121, '2014-03-15 00:48:55.000000', 'temperatura', 880.0000, 'ºC'),
	(256760, 121, '2014-03-15 00:48:56.000000', 'temperatura', 484.0000, 'ºC'),
	(256761, 121, '2014-03-15 00:48:57.000000', 'temperatura', 984.0000, 'ºC'),
	(256762, 121, '2014-03-15 00:48:58.000000', 'temperatura', 1068.0000, 'ºC'),
	(256763, 121, '2014-03-15 00:48:59.000000', 'temperatura', 1188.0000, 'ºC'),
	(256764, 121, '2014-03-15 00:49:00.000000', 'temperatura', 335.0000, 'ºC'),
	(256765, 121, '2014-03-15 00:49:01.000000', 'temperatura', 513.0000, 'ºC'),
	(256766, 121, '2014-03-15 00:49:02.000000', 'temperatura', 362.0000, 'ºC'),
	(256767, 121, '2014-03-15 00:49:03.000000', 'temperatura', 270.0000, 'ºC'),
	(256768, 121, '2014-03-15 00:49:04.000000', 'temperatura', 264.0000, 'ºC'),
	(256769, 121, '2014-03-15 00:49:05.000000', 'temperatura', 512.0000, 'ºC'),
	(256770, 121, '2014-03-15 00:49:06.000000', 'temperatura', 567.0000, 'ºC'),
	(256771, 121, '2014-03-15 00:49:07.000000', 'temperatura', 98.0000, 'ºC'),
	(256772, 121, '2014-03-15 00:49:08.000000', 'temperatura', 1193.0000, 'ºC'),
	(256773, 121, '2014-03-15 00:49:09.000000', 'temperatura', 868.0000, 'ºC'),
	(256774, 121, '2014-03-15 00:49:10.000000', 'temperatura', 763.0000, 'ºC'),
	(256775, 121, '2014-03-15 00:49:11.000000', 'temperatura', 12.0000, 'ºC'),
	(256776, 121, '2014-03-15 00:49:12.000000', 'temperatura', 173.0000, 'ºC'),
	(256777, 121, '2014-03-15 00:49:13.000000', 'temperatura', 826.0000, 'ºC'),
	(256778, 121, '2014-03-15 00:49:14.000000', 'temperatura', 14.0000, 'ºC'),
	(256779, 121, '2014-03-15 00:49:15.000000', 'temperatura', 1190.0000, 'ºC'),
	(256780, 121, '2014-03-15 00:49:16.000000', 'temperatura', 1110.0000, 'ºC'),
	(256781, 121, '2014-03-15 00:49:17.000000', 'temperatura', 780.0000, 'ºC'),
	(256782, 121, '2014-03-15 00:49:18.000000', 'temperatura', 570.0000, 'ºC'),
	(256783, 121, '2014-03-15 00:49:19.000000', 'temperatura', 512.0000, 'ºC'),
	(256784, 121, '2014-03-15 00:49:20.000000', 'temperatura', 848.0000, 'ºC'),
	(256785, 121, '2014-03-15 00:49:21.000000', 'temperatura', 307.0000, 'ºC'),
	(256786, 121, '2014-03-15 00:49:22.000000', 'temperatura', 191.0000, 'ºC'),
	(256787, 121, '2014-03-15 00:49:23.000000', 'temperatura', 33.0000, 'ºC'),
	(256788, 121, '2014-03-15 00:49:24.000000', 'temperatura', 794.0000, 'ºC'),
	(256789, 121, '2014-03-15 00:49:25.000000', 'temperatura', 271.0000, 'ºC'),
	(256790, 121, '2014-03-15 00:49:26.000000', 'temperatura', 174.0000, 'ºC'),
	(256791, 121, '2014-03-15 00:49:27.000000', 'temperatura', 56.0000, 'ºC'),
	(256792, 121, '2014-03-15 00:49:28.000000', 'temperatura', 959.0000, 'ºC'),
	(256793, 121, '2014-03-15 00:49:29.000000', 'temperatura', 1026.0000, 'ºC'),
	(256794, 121, '2014-03-15 00:49:30.000000', 'temperatura', 1055.0000, 'ºC'),
	(256795, 121, '2014-03-15 00:49:31.000000', 'temperatura', 995.0000, 'ºC'),
	(256796, 121, '2014-03-15 00:49:32.000000', 'temperatura', 614.0000, 'ºC'),
	(256797, 121, '2014-03-15 00:49:33.000000', 'temperatura', 85.0000, 'ºC'),
	(256798, 121, '2014-03-15 00:49:34.000000', 'temperatura', 983.0000, 'ºC'),
	(256799, 121, '2014-03-15 00:49:35.000000', 'temperatura', 1062.0000, 'ºC'),
	(256800, 121, '2014-03-15 00:49:36.000000', 'temperatura', 1161.0000, 'ºC'),
	(256801, 121, '2014-03-15 00:49:37.000000', 'temperatura', 220.0000, 'ºC'),
	(256802, 121, '2014-03-15 00:49:38.000000', 'temperatura', 18.0000, 'ºC'),
	(256803, 121, '2014-03-15 00:49:39.000000', 'temperatura', 632.0000, 'ºC'),
	(256804, 121, '2014-03-15 00:49:40.000000', 'temperatura', 704.0000, 'ºC'),
	(256805, 121, '2014-03-15 00:49:41.000000', 'temperatura', 425.0000, 'ºC'),
	(256806, 121, '2014-03-15 00:49:42.000000', 'temperatura', 15.0000, 'ºC'),
	(256807, 121, '2014-03-15 00:49:43.000000', 'temperatura', 0.0000, 'ºC'),
	(256808, 121, '2014-03-15 00:49:44.000000', 'temperatura', 1157.0000, 'ºC'),
	(256809, 121, '2014-03-15 00:49:45.000000', 'temperatura', 982.0000, 'ºC'),
	(256810, 121, '2014-03-15 00:49:46.000000', 'temperatura', 242.0000, 'ºC'),
	(256811, 121, '2014-03-15 00:49:47.000000', 'temperatura', 665.0000, 'ºC'),
	(256812, 121, '2014-03-15 00:49:48.000000', 'temperatura', 198.0000, 'ºC'),
	(256813, 121, '2014-03-15 00:49:49.000000', 'temperatura', 196.0000, 'ºC'),
	(256814, 121, '2014-03-15 00:49:50.000000', 'temperatura', 388.0000, 'ºC'),
	(256815, 121, '2014-03-15 00:49:51.000000', 'temperatura', 152.0000, 'ºC'),
	(256816, 121, '2014-03-15 00:49:52.000000', 'temperatura', 796.0000, 'ºC'),
	(256817, 121, '2014-03-15 00:49:53.000000', 'temperatura', 1124.0000, 'ºC'),
	(256818, 121, '2014-03-15 00:49:54.000000', 'temperatura', 834.0000, 'ºC'),
	(256819, 121, '2014-03-15 00:49:55.000000', 'temperatura', 796.0000, 'ºC'),
	(256820, 121, '2014-03-15 00:49:56.000000', 'temperatura', 278.0000, 'ºC'),
	(256821, 121, '2014-03-15 00:49:57.000000', 'temperatura', 204.0000, 'ºC'),
	(256822, 121, '2014-03-15 00:49:58.000000', 'temperatura', 185.0000, 'ºC'),
	(256823, 121, '2014-03-15 00:49:59.000000', 'temperatura', 315.0000, 'ºC'),
	(256824, 121, '2014-03-15 00:50:00.000000', 'temperatura', 1021.0000, 'ºC'),
	(256825, 121, '2014-03-15 00:50:01.000000', 'temperatura', 559.0000, 'ºC'),
	(256826, 121, '2014-03-15 00:50:02.000000', 'temperatura', 933.0000, 'ºC'),
	(256827, 121, '2014-03-15 00:50:03.000000', 'temperatura', 590.0000, 'ºC'),
	(256828, 121, '2014-03-15 00:50:04.000000', 'temperatura', 149.0000, 'ºC'),
	(256829, 121, '2014-03-15 00:50:05.000000', 'temperatura', 178.0000, 'ºC'),
	(256830, 121, '2014-03-15 00:50:06.000000', 'temperatura', 442.0000, 'ºC'),
	(256831, 121, '2014-03-15 00:50:07.000000', 'temperatura', 477.0000, 'ºC'),
	(256832, 121, '2014-03-15 00:50:08.000000', 'temperatura', 1058.0000, 'ºC'),
	(256833, 121, '2014-03-15 00:50:09.000000', 'temperatura', 261.0000, 'ºC'),
	(256834, 121, '2014-03-15 00:50:10.000000', 'temperatura', 530.0000, 'ºC'),
	(256835, 121, '2014-03-15 00:50:11.000000', 'temperatura', 668.0000, 'ºC'),
	(256836, 121, '2014-03-15 00:50:12.000000', 'temperatura', 549.0000, 'ºC'),
	(256837, 121, '2014-03-15 00:50:13.000000', 'temperatura', 742.0000, 'ºC'),
	(256838, 121, '2014-03-15 00:50:14.000000', 'temperatura', 863.0000, 'ºC'),
	(256839, 121, '2014-03-15 00:50:15.000000', 'temperatura', 889.0000, 'ºC'),
	(256840, 121, '2014-03-15 00:50:16.000000', 'temperatura', 659.0000, 'ºC'),
	(256841, 121, '2014-03-15 00:50:17.000000', 'temperatura', 628.0000, 'ºC'),
	(256842, 121, '2014-03-15 00:50:18.000000', 'temperatura', 1165.0000, 'ºC'),
	(256843, 121, '2014-03-15 00:50:19.000000', 'temperatura', 339.0000, 'ºC'),
	(256844, 121, '2014-03-15 00:50:20.000000', 'temperatura', 600.0000, 'ºC'),
	(256845, 121, '2014-03-15 00:50:21.000000', 'temperatura', 785.0000, 'ºC'),
	(256846, 121, '2014-03-15 00:50:22.000000', 'temperatura', 924.0000, 'ºC'),
	(256847, 121, '2014-03-15 00:50:23.000000', 'temperatura', 1066.0000, 'ºC'),
	(256848, 121, '2014-03-15 00:50:24.000000', 'temperatura', 158.0000, 'ºC'),
	(256849, 121, '2014-03-15 00:50:25.000000', 'temperatura', 1194.0000, 'ºC'),
	(256850, 121, '2014-03-15 00:50:26.000000', 'temperatura', 695.0000, 'ºC'),
	(256851, 121, '2014-03-15 00:50:27.000000', 'temperatura', 1095.0000, 'ºC'),
	(256852, 121, '2014-03-15 00:50:28.000000', 'temperatura', 990.0000, 'ºC'),
	(256853, 121, '2014-03-15 00:50:29.000000', 'temperatura', 466.0000, 'ºC'),
	(256854, 121, '2014-03-15 00:50:30.000000', 'temperatura', 562.0000, 'ºC'),
	(256855, 121, '2014-03-15 00:50:31.000000', 'temperatura', 210.0000, 'ºC'),
	(256856, 121, '2014-03-15 00:50:32.000000', 'temperatura', 565.0000, 'ºC'),
	(256857, 121, '2014-03-15 00:50:33.000000', 'temperatura', 994.0000, 'ºC'),
	(256858, 121, '2014-03-15 00:50:34.000000', 'temperatura', 878.0000, 'ºC'),
	(256859, 121, '2014-03-15 00:50:35.000000', 'temperatura', 208.0000, 'ºC'),
	(256860, 121, '2014-03-15 00:50:36.000000', 'temperatura', 805.0000, 'ºC'),
	(256861, 121, '2014-03-15 00:50:37.000000', 'temperatura', 1001.0000, 'ºC'),
	(256862, 121, '2014-03-15 00:50:38.000000', 'temperatura', 192.0000, 'ºC'),
	(256863, 121, '2014-03-15 00:50:39.000000', 'temperatura', 356.0000, 'ºC'),
	(256864, 121, '2014-03-15 00:50:40.000000', 'temperatura', 3.0000, 'ºC'),
	(256865, 121, '2014-03-15 00:50:41.000000', 'temperatura', 150.0000, 'ºC'),
	(256866, 121, '2014-03-15 00:50:42.000000', 'temperatura', 741.0000, 'ºC'),
	(256867, 121, '2014-03-15 00:50:43.000000', 'temperatura', 857.0000, 'ºC'),
	(256868, 121, '2014-03-15 00:50:44.000000', 'temperatura', 862.0000, 'ºC'),
	(256869, 121, '2014-03-15 00:50:45.000000', 'temperatura', 541.0000, 'ºC'),
	(256870, 121, '2014-03-15 00:50:46.000000', 'temperatura', 118.0000, 'ºC'),
	(256871, 121, '2014-03-15 00:50:47.000000', 'temperatura', 166.0000, 'ºC'),
	(256872, 121, '2014-03-15 00:50:48.000000', 'temperatura', 480.0000, 'ºC'),
	(256873, 121, '2014-03-15 00:50:49.000000', 'temperatura', 700.0000, 'ºC'),
	(256874, 121, '2014-03-15 00:50:50.000000', 'temperatura', 859.0000, 'ºC'),
	(256875, 121, '2014-03-15 00:50:51.000000', 'temperatura', 999.0000, 'ºC'),
	(256876, 121, '2014-03-15 00:50:52.000000', 'temperatura', 17.0000, 'ºC'),
	(256877, 121, '2014-03-15 00:50:53.000000', 'temperatura', 688.0000, 'ºC'),
	(256878, 121, '2014-03-15 00:50:54.000000', 'temperatura', 988.0000, 'ºC'),
	(256879, 121, '2014-03-15 00:50:55.000000', 'temperatura', 480.0000, 'ºC'),
	(256880, 121, '2014-03-15 00:50:56.000000', 'temperatura', 634.0000, 'ºC'),
	(256881, 121, '2014-03-15 00:50:57.000000', 'temperatura', 530.0000, 'ºC'),
	(256882, 121, '2014-03-15 00:50:58.000000', 'temperatura', 749.0000, 'ºC'),
	(256883, 121, '2014-03-15 00:50:59.000000', 'temperatura', 955.0000, 'ºC'),
	(256884, 121, '2014-03-15 00:51:00.000000', 'temperatura', 129.0000, 'ºC'),
	(256885, 121, '2014-03-15 00:51:01.000000', 'temperatura', 180.0000, 'ºC'),
	(256886, 121, '2014-03-15 00:51:02.000000', 'temperatura', 513.0000, 'ºC'),
	(256887, 121, '2014-03-15 00:51:03.000000', 'temperatura', 825.0000, 'ºC'),
	(256888, 121, '2014-03-15 00:51:04.000000', 'temperatura', 186.0000, 'ºC'),
	(256889, 121, '2014-03-15 00:51:05.000000', 'temperatura', 857.0000, 'ºC'),
	(256890, 121, '2014-03-15 00:51:06.000000', 'temperatura', 125.0000, 'ºC'),
	(256891, 121, '2014-03-15 00:51:07.000000', 'temperatura', 458.0000, 'ºC'),
	(256892, 121, '2014-03-15 00:51:08.000000', 'temperatura', 713.0000, 'ºC'),
	(256893, 121, '2014-03-15 00:51:09.000000', 'temperatura', 994.0000, 'ºC'),
	(256894, 121, '2014-03-15 00:51:10.000000', 'temperatura', 430.0000, 'ºC'),
	(256895, 121, '2014-03-15 00:51:11.000000', 'temperatura', 367.0000, 'ºC'),
	(256896, 121, '2014-03-15 00:51:12.000000', 'temperatura', 545.0000, 'ºC'),
	(256897, 121, '2014-03-15 00:51:13.000000', 'temperatura', 428.0000, 'ºC'),
	(256898, 121, '2014-03-15 00:51:14.000000', 'temperatura', 503.0000, 'ºC'),
	(256899, 121, '2014-03-15 00:51:15.000000', 'temperatura', 31.0000, 'ºC'),
	(256900, 121, '2014-03-15 00:51:16.000000', 'temperatura', 1047.0000, 'ºC'),
	(256901, 121, '2014-03-15 00:51:17.000000', 'temperatura', 342.0000, 'ºC'),
	(256902, 121, '2014-03-15 00:51:18.000000', 'temperatura', 970.0000, 'ºC'),
	(256903, 121, '2014-03-15 00:51:19.000000', 'temperatura', 225.0000, 'ºC'),
	(256904, 121, '2014-03-15 00:51:20.000000', 'temperatura', 613.0000, 'ºC'),
	(256905, 121, '2014-03-15 00:51:21.000000', 'temperatura', 1192.0000, 'ºC'),
	(256906, 121, '2014-03-15 00:51:22.000000', 'temperatura', 523.0000, 'ºC'),
	(256907, 121, '2014-03-15 00:51:23.000000', 'temperatura', 239.0000, 'ºC'),
	(256908, 121, '2014-03-15 00:51:24.000000', 'temperatura', 828.0000, 'ºC'),
	(256909, 121, '2014-03-15 00:51:25.000000', 'temperatura', 1020.0000, 'ºC'),
	(256910, 121, '2014-03-15 00:51:26.000000', 'temperatura', 220.0000, 'ºC'),
	(256911, 121, '2014-03-15 00:51:27.000000', 'temperatura', 439.0000, 'ºC'),
	(256912, 121, '2014-03-15 00:51:28.000000', 'temperatura', 335.0000, 'ºC'),
	(256913, 121, '2014-03-15 00:51:29.000000', 'temperatura', 357.0000, 'ºC'),
	(256914, 121, '2014-03-15 00:51:30.000000', 'temperatura', 781.0000, 'ºC'),
	(256915, 121, '2014-03-15 00:51:31.000000', 'temperatura', 435.0000, 'ºC'),
	(256916, 121, '2014-03-15 00:51:32.000000', 'temperatura', 1032.0000, 'ºC'),
	(256917, 121, '2014-03-15 00:51:33.000000', 'temperatura', 257.0000, 'ºC'),
	(256918, 121, '2014-03-15 00:51:34.000000', 'temperatura', 588.0000, 'ºC'),
	(256919, 121, '2014-03-15 00:51:35.000000', 'temperatura', 968.0000, 'ºC'),
	(256920, 121, '2014-03-15 00:51:36.000000', 'temperatura', 680.0000, 'ºC'),
	(256921, 121, '2014-03-15 00:51:37.000000', 'temperatura', 494.0000, 'ºC'),
	(256922, 121, '2014-03-15 00:51:38.000000', 'temperatura', 433.0000, 'ºC'),
	(256923, 121, '2014-03-15 00:51:39.000000', 'temperatura', 681.0000, 'ºC'),
	(256924, 121, '2014-03-15 00:51:40.000000', 'temperatura', 909.0000, 'ºC'),
	(256925, 121, '2014-03-15 00:51:41.000000', 'temperatura', 100.0000, 'ºC'),
	(256926, 121, '2014-03-15 00:51:42.000000', 'temperatura', 175.0000, 'ºC'),
	(256927, 121, '2014-03-15 00:51:43.000000', 'temperatura', 574.0000, 'ºC'),
	(256928, 121, '2014-03-15 00:51:44.000000', 'temperatura', 1144.0000, 'ºC'),
	(256929, 121, '2014-03-15 00:51:45.000000', 'temperatura', 401.0000, 'ºC'),
	(256930, 121, '2014-03-15 00:51:46.000000', 'temperatura', 972.0000, 'ºC'),
	(256931, 121, '2014-03-15 00:51:47.000000', 'temperatura', 59.0000, 'ºC'),
	(256932, 121, '2014-03-15 00:51:48.000000', 'temperatura', 979.0000, 'ºC'),
	(256933, 121, '2014-03-15 00:51:49.000000', 'temperatura', 1116.0000, 'ºC'),
	(256934, 121, '2014-03-15 00:51:50.000000', 'temperatura', 247.0000, 'ºC'),
	(256935, 121, '2014-03-15 00:51:51.000000', 'temperatura', 285.0000, 'ºC'),
	(256936, 121, '2014-03-15 00:51:52.000000', 'temperatura', 686.0000, 'ºC'),
	(256937, 121, '2014-03-15 00:51:53.000000', 'temperatura', 176.0000, 'ºC'),
	(256938, 121, '2014-03-15 00:51:54.000000', 'temperatura', 22.0000, 'ºC'),
	(256939, 121, '2014-03-15 00:51:55.000000', 'temperatura', 783.0000, 'ºC'),
	(256940, 121, '2014-03-15 00:51:56.000000', 'temperatura', 248.0000, 'ºC'),
	(256941, 121, '2014-03-15 00:51:57.000000', 'temperatura', 94.0000, 'ºC'),
	(256942, 121, '2014-03-15 00:51:58.000000', 'temperatura', 924.0000, 'ºC'),
	(256943, 121, '2014-03-15 00:51:59.000000', 'temperatura', 740.0000, 'ºC'),
	(256944, 121, '2014-03-15 00:52:00.000000', 'temperatura', 929.0000, 'ºC'),
	(256945, 121, '2014-03-15 00:52:01.000000', 'temperatura', 27.0000, 'ºC'),
	(256946, 121, '2014-03-15 00:52:02.000000', 'temperatura', 945.0000, 'ºC'),
	(256947, 121, '2014-03-15 00:52:03.000000', 'temperatura', 1047.0000, 'ºC'),
	(256948, 121, '2014-03-15 00:52:04.000000', 'temperatura', 1198.0000, 'ºC'),
	(256949, 121, '2014-03-15 00:52:05.000000', 'temperatura', 453.0000, 'ºC'),
	(256950, 121, '2014-03-15 00:52:06.000000', 'temperatura', 1069.0000, 'ºC'),
	(256951, 121, '2014-03-15 00:52:07.000000', 'temperatura', 386.0000, 'ºC'),
	(256952, 121, '2014-03-15 00:52:08.000000', 'temperatura', 1124.0000, 'ºC'),
	(256953, 121, '2014-03-15 00:52:09.000000', 'temperatura', 861.0000, 'ºC'),
	(256954, 121, '2014-03-15 00:52:10.000000', 'temperatura', 935.0000, 'ºC'),
	(256955, 121, '2014-03-15 00:52:11.000000', 'temperatura', 891.0000, 'ºC'),
	(256956, 121, '2014-03-15 00:52:12.000000', 'temperatura', 452.0000, 'ºC'),
	(256957, 121, '2014-03-15 00:52:13.000000', 'temperatura', 787.0000, 'ºC'),
	(256958, 121, '2014-03-15 00:52:14.000000', 'temperatura', 178.0000, 'ºC'),
	(256959, 121, '2014-03-15 00:52:15.000000', 'temperatura', 929.0000, 'ºC'),
	(256960, 121, '2014-03-15 00:52:16.000000', 'temperatura', 512.0000, 'ºC'),
	(256961, 121, '2014-03-15 00:52:17.000000', 'temperatura', 974.0000, 'ºC'),
	(256962, 121, '2014-03-15 00:52:18.000000', 'temperatura', 934.0000, 'ºC'),
	(256963, 121, '2014-03-15 00:52:19.000000', 'temperatura', 548.0000, 'ºC'),
	(256964, 121, '2014-03-15 00:52:20.000000', 'temperatura', 1141.0000, 'ºC'),
	(256965, 121, '2014-03-15 00:52:21.000000', 'temperatura', 460.0000, 'ºC'),
	(256966, 121, '2014-03-15 00:52:22.000000', 'temperatura', 79.0000, 'ºC'),
	(256967, 121, '2014-03-15 00:52:23.000000', 'temperatura', 215.0000, 'ºC'),
	(256968, 121, '2014-03-15 00:52:24.000000', 'temperatura', 838.0000, 'ºC'),
	(256969, 121, '2014-03-15 00:52:25.000000', 'temperatura', 1144.0000, 'ºC'),
	(256970, 121, '2014-03-15 00:52:26.000000', 'temperatura', 808.0000, 'ºC'),
	(256971, 121, '2014-03-15 00:52:27.000000', 'temperatura', 610.0000, 'ºC'),
	(256972, 121, '2014-03-15 00:52:28.000000', 'temperatura', 624.0000, 'ºC'),
	(256973, 121, '2014-03-15 00:52:29.000000', 'temperatura', 93.0000, 'ºC'),
	(256974, 121, '2014-03-15 00:52:30.000000', 'temperatura', 993.0000, 'ºC'),
	(256975, 121, '2014-03-15 00:52:31.000000', 'temperatura', 1084.0000, 'ºC'),
	(256976, 121, '2014-03-15 00:52:32.000000', 'temperatura', 44.0000, 'ºC'),
	(256977, 121, '2014-03-15 00:52:33.000000', 'temperatura', 566.0000, 'ºC'),
	(256978, 121, '2014-03-15 00:52:34.000000', 'temperatura', 300.0000, 'ºC'),
	(256979, 121, '2014-03-15 00:52:35.000000', 'temperatura', 1002.0000, 'ºC'),
	(256980, 121, '2014-03-15 00:52:36.000000', 'temperatura', 510.0000, 'ºC'),
	(256981, 121, '2014-03-15 00:52:37.000000', 'temperatura', 745.0000, 'ºC'),
	(256982, 121, '2014-03-15 00:52:38.000000', 'temperatura', 997.0000, 'ºC'),
	(256983, 121, '2014-03-15 00:52:39.000000', 'temperatura', 349.0000, 'ºC'),
	(256984, 121, '2014-03-15 00:52:40.000000', 'temperatura', 1154.0000, 'ºC'),
	(256985, 121, '2014-03-15 00:52:41.000000', 'temperatura', 1126.0000, 'ºC'),
	(256986, 121, '2014-03-15 00:52:42.000000', 'temperatura', 967.0000, 'ºC'),
	(256987, 121, '2014-03-15 00:52:43.000000', 'temperatura', 256.0000, 'ºC'),
	(256988, 121, '2014-03-15 00:52:44.000000', 'temperatura', 779.0000, 'ºC'),
	(256989, 121, '2014-03-15 00:52:45.000000', 'temperatura', 727.0000, 'ºC'),
	(256990, 121, '2014-03-15 00:52:46.000000', 'temperatura', 101.0000, 'ºC'),
	(256991, 121, '2014-03-15 00:52:47.000000', 'temperatura', 724.0000, 'ºC'),
	(256992, 121, '2014-03-15 00:52:48.000000', 'temperatura', 919.0000, 'ºC'),
	(256993, 121, '2014-03-15 00:52:49.000000', 'temperatura', 22.0000, 'ºC'),
	(256994, 121, '2014-03-15 00:52:50.000000', 'temperatura', 952.0000, 'ºC'),
	(256995, 121, '2014-03-15 00:52:51.000000', 'temperatura', 1096.0000, 'ºC'),
	(256996, 121, '2014-03-15 00:52:52.000000', 'temperatura', 224.0000, 'ºC'),
	(256997, 121, '2014-03-15 00:52:53.000000', 'temperatura', 234.0000, 'ºC'),
	(256998, 121, '2014-03-15 00:52:54.000000', 'temperatura', 497.0000, 'ºC'),
	(256999, 121, '2014-03-15 00:52:55.000000', 'temperatura', 582.0000, 'ºC'),
	(257000, 121, '2014-03-15 00:52:56.000000', 'temperatura', 220.0000, 'ºC'),
	(257001, 121, '2014-03-15 00:52:57.000000', 'temperatura', 556.0000, 'ºC'),
	(257002, 121, '2014-03-15 00:52:58.000000', 'temperatura', 920.0000, 'ºC'),
	(257003, 121, '2014-03-15 00:52:59.000000', 'temperatura', 533.0000, 'ºC'),
	(257004, 121, '2014-03-15 00:53:00.000000', 'temperatura', 1105.0000, 'ºC'),
	(257005, 121, '2014-03-15 00:53:01.000000', 'temperatura', 328.0000, 'ºC'),
	(257006, 121, '2014-03-15 00:53:02.000000', 'temperatura', 723.0000, 'ºC'),
	(257007, 121, '2014-03-15 00:53:03.000000', 'temperatura', 232.0000, 'ºC'),
	(257008, 121, '2014-03-15 00:53:04.000000', 'temperatura', 190.0000, 'ºC'),
	(257009, 121, '2014-03-15 00:53:05.000000', 'temperatura', 257.0000, 'ºC'),
	(257010, 121, '2014-03-15 00:53:06.000000', 'temperatura', 715.0000, 'ºC'),
	(257011, 121, '2014-03-15 00:53:07.000000', 'temperatura', 402.0000, 'ºC'),
	(257012, 121, '2014-03-15 00:53:08.000000', 'temperatura', 1068.0000, 'ºC'),
	(257013, 121, '2014-03-15 00:53:09.000000', 'temperatura', 533.0000, 'ºC'),
	(257014, 121, '2014-03-15 00:53:10.000000', 'temperatura', 661.0000, 'ºC'),
	(257015, 121, '2014-03-15 00:53:11.000000', 'temperatura', 507.0000, 'ºC'),
	(257016, 121, '2014-03-15 00:53:12.000000', 'temperatura', 554.0000, 'ºC'),
	(257017, 121, '2014-03-15 00:53:13.000000', 'temperatura', 50.0000, 'ºC'),
	(257018, 121, '2014-03-15 00:53:14.000000', 'temperatura', 988.0000, 'ºC'),
	(257019, 121, '2014-03-15 00:53:15.000000', 'temperatura', 1191.0000, 'ºC'),
	(257020, 121, '2014-03-15 00:53:16.000000', 'temperatura', 592.0000, 'ºC'),
	(257021, 121, '2014-03-15 00:53:17.000000', 'temperatura', 588.0000, 'ºC'),
	(257022, 121, '2014-03-15 00:53:18.000000', 'temperatura', 1162.0000, 'ºC'),
	(257023, 121, '2014-03-15 00:53:19.000000', 'temperatura', 449.0000, 'ºC'),
	(257024, 121, '2014-03-15 00:53:20.000000', 'temperatura', 1157.0000, 'ºC'),
	(257025, 121, '2014-03-15 00:53:21.000000', 'temperatura', 840.0000, 'ºC'),
	(257026, 121, '2014-03-15 00:53:22.000000', 'temperatura', 727.0000, 'ºC'),
	(257027, 121, '2014-03-15 00:53:23.000000', 'temperatura', 1118.0000, 'ºC'),
	(257028, 121, '2014-03-15 00:53:24.000000', 'temperatura', 1009.0000, 'ºC'),
	(257029, 121, '2014-03-15 00:53:25.000000', 'temperatura', 490.0000, 'ºC'),
	(257030, 121, '2014-03-15 00:53:26.000000', 'temperatura', 626.0000, 'ºC'),
	(257031, 121, '2014-03-15 00:53:27.000000', 'temperatura', 459.0000, 'ºC'),
	(257032, 121, '2014-03-15 00:53:28.000000', 'temperatura', 419.0000, 'ºC'),
	(257033, 121, '2014-03-15 00:53:29.000000', 'temperatura', 718.0000, 'ºC'),
	(257034, 121, '2014-03-15 00:53:30.000000', 'temperatura', 1135.0000, 'ºC'),
	(257035, 121, '2014-03-15 00:53:31.000000', 'temperatura', 1120.0000, 'ºC'),
	(257036, 121, '2014-03-15 00:53:32.000000', 'temperatura', 997.0000, 'ºC'),
	(257037, 121, '2014-03-15 00:53:33.000000', 'temperatura', 423.0000, 'ºC'),
	(257038, 121, '2014-03-15 00:53:34.000000', 'temperatura', 324.0000, 'ºC'),
	(257039, 121, '2014-03-15 00:53:35.000000', 'temperatura', 350.0000, 'ºC'),
	(257040, 121, '2014-03-15 00:53:36.000000', 'temperatura', 782.0000, 'ºC'),
	(257041, 121, '2014-03-15 00:53:37.000000', 'temperatura', 461.0000, 'ºC'),
	(257042, 121, '2014-03-15 00:53:38.000000', 'temperatura', 1159.0000, 'ºC'),
	(257043, 121, '2014-03-15 00:53:39.000000', 'temperatura', 811.0000, 'ºC'),
	(257044, 121, '2014-03-15 00:53:40.000000', 'temperatura', 577.0000, 'ºC'),
	(257045, 121, '2014-03-15 00:53:41.000000', 'temperatura', 455.0000, 'ºC'),
	(257046, 121, '2014-03-15 00:53:42.000000', 'temperatura', 545.0000, 'ºC'),
	(257047, 121, '2014-03-15 00:53:43.000000', 'temperatura', 159.0000, 'ºC'),
	(257048, 121, '2014-03-15 00:53:44.000000', 'temperatura', 361.0000, 'ºC'),
	(257049, 121, '2014-03-15 00:53:45.000000', 'temperatura', 130.0000, 'ºC'),
	(257050, 121, '2014-03-15 00:53:46.000000', 'temperatura', 764.0000, 'ºC'),
	(257051, 121, '2014-03-15 00:53:47.000000', 'temperatura', 1034.0000, 'ºC'),
	(257052, 121, '2014-03-15 00:53:48.000000', 'temperatura', 478.0000, 'ºC'),
	(257053, 121, '2014-03-15 00:53:49.000000', 'temperatura', 486.0000, 'ºC'),
	(257054, 121, '2014-03-15 00:53:50.000000', 'temperatura', 999.0000, 'ºC'),
	(257055, 121, '2014-03-15 00:53:51.000000', 'temperatura', 1136.0000, 'ºC'),
	(257056, 121, '2014-03-15 00:53:52.000000', 'temperatura', 285.0000, 'ºC'),
	(257057, 121, '2014-03-15 00:53:53.000000', 'temperatura', 418.0000, 'ºC'),
	(257058, 121, '2014-03-15 00:53:54.000000', 'temperatura', 35.0000, 'ºC'),
	(257059, 121, '2014-03-15 00:53:55.000000', 'temperatura', 120.0000, 'ºC'),
	(257060, 121, '2014-03-15 00:53:56.000000', 'temperatura', 498.0000, 'ºC'),
	(257061, 121, '2014-03-15 00:53:57.000000', 'temperatura', 929.0000, 'ºC'),
	(257062, 121, '2014-03-15 00:53:58.000000', 'temperatura', 754.0000, 'ºC'),
	(257063, 121, '2014-03-15 00:53:59.000000', 'temperatura', 981.0000, 'ºC'),
	(257064, 121, '2014-03-15 00:54:00.000000', 'temperatura', 245.0000, 'ºC'),
	(257065, 121, '2014-03-15 00:54:01.000000', 'temperatura', 680.0000, 'ºC'),
	(257066, 121, '2014-03-15 00:54:02.000000', 'temperatura', 266.0000, 'ºC'),
	(257067, 121, '2014-03-15 00:54:03.000000', 'temperatura', 492.0000, 'ºC'),
	(257068, 121, '2014-03-15 00:54:04.000000', 'temperatura', 461.0000, 'ºC'),
	(257069, 121, '2014-03-15 00:54:05.000000', 'temperatura', 832.0000, 'ºC'),
	(257070, 121, '2014-03-15 00:54:06.000000', 'temperatura', 375.0000, 'ºC'),
	(257071, 121, '2014-03-15 00:54:07.000000', 'temperatura', 580.0000, 'ºC'),
	(257072, 121, '2014-03-15 00:54:08.000000', 'temperatura', 578.0000, 'ºC'),
	(257073, 121, '2014-03-15 00:54:09.000000', 'temperatura', 1147.0000, 'ºC'),
	(257074, 121, '2014-03-15 00:54:10.000000', 'temperatura', 404.0000, 'ºC'),
	(257075, 121, '2014-03-15 00:54:11.000000', 'temperatura', 980.0000, 'ºC'),
	(257076, 121, '2014-03-15 00:54:12.000000', 'temperatura', 88.0000, 'ºC'),
	(257077, 121, '2014-03-15 00:54:13.000000', 'temperatura', 1100.0000, 'ºC'),
	(257078, 121, '2014-03-15 00:54:14.000000', 'temperatura', 437.0000, 'ºC'),
	(257079, 121, '2014-03-15 00:54:15.000000', 'temperatura', 86.0000, 'ºC'),
	(257080, 121, '2014-03-15 00:54:16.000000', 'temperatura', 320.0000, 'ºC'),
	(257081, 121, '2014-03-15 00:54:17.000000', 'temperatura', 141.0000, 'ºC'),
	(257082, 121, '2014-03-15 00:54:18.000000', 'temperatura', 948.0000, 'ºC'),
	(257083, 121, '2014-03-15 00:54:19.000000', 'temperatura', 715.0000, 'ºC'),
	(257084, 121, '2014-03-15 00:54:20.000000', 'temperatura', 734.0000, 'ºC'),
	(257085, 121, '2014-03-15 00:54:21.000000', 'temperatura', 326.0000, 'ºC'),
	(257086, 121, '2014-03-15 00:54:22.000000', 'temperatura', 626.0000, 'ºC'),
	(257087, 121, '2014-03-15 00:54:23.000000', 'temperatura', 952.0000, 'ºC'),
	(257088, 121, '2014-03-15 00:54:24.000000', 'temperatura', 484.0000, 'ºC'),
	(257089, 121, '2014-03-15 00:54:25.000000', 'temperatura', 763.0000, 'ºC'),
	(257090, 121, '2014-03-15 00:54:26.000000', 'temperatura', 1163.0000, 'ºC'),
	(257091, 121, '2014-03-15 00:54:27.000000', 'temperatura', 1126.0000, 'ºC'),
	(257092, 121, '2014-03-15 00:54:28.000000', 'temperatura', 942.0000, 'ºC'),
	(257093, 121, '2014-03-15 00:54:29.000000', 'temperatura', 133.0000, 'ºC'),
	(257094, 121, '2014-03-15 00:54:30.000000', 'temperatura', 241.0000, 'ºC'),
	(257095, 121, '2014-03-15 00:54:31.000000', 'temperatura', 807.0000, 'ºC'),
	(257096, 121, '2014-03-15 00:54:32.000000', 'temperatura', 910.0000, 'ºC'),
	(257097, 121, '2014-03-15 00:54:33.000000', 'temperatura', 929.0000, 'ºC'),
	(257098, 121, '2014-03-15 00:54:34.000000', 'temperatura', 718.0000, 'ºC'),
	(257099, 121, '2014-03-15 00:54:35.000000', 'temperatura', 801.0000, 'ºC'),
	(257100, 121, '2014-03-15 00:54:36.000000', 'temperatura', 654.0000, 'ºC'),
	(257101, 121, '2014-03-15 00:54:37.000000', 'temperatura', 865.0000, 'ºC'),
	(257102, 121, '2014-03-15 00:54:38.000000', 'temperatura', 1164.0000, 'ºC'),
	(257103, 121, '2014-03-15 00:54:39.000000', 'temperatura', 826.0000, 'ºC'),
	(257104, 121, '2014-03-15 00:54:40.000000', 'temperatura', 638.0000, 'ºC'),
	(257105, 121, '2014-03-15 00:54:41.000000', 'temperatura', 714.0000, 'ºC'),
	(257106, 121, '2014-03-15 00:54:42.000000', 'temperatura', 458.0000, 'ºC'),
	(257107, 121, '2014-03-15 00:54:43.000000', 'temperatura', 146.0000, 'ºC'),
	(257108, 121, '2014-03-15 00:54:44.000000', 'temperatura', 556.0000, 'ºC'),
	(257109, 121, '2014-03-15 00:54:45.000000', 'temperatura', 1145.0000, 'ºC'),
	(257110, 121, '2014-03-15 00:54:46.000000', 'temperatura', 456.0000, 'ºC'),
	(257111, 121, '2014-03-15 00:54:47.000000', 'temperatura', 48.0000, 'ºC'),
	(257112, 121, '2014-03-15 00:54:48.000000', 'temperatura', 70.0000, 'ºC'),
	(257113, 121, '2014-03-15 00:54:49.000000', 'temperatura', 208.0000, 'ºC'),
	(257114, 121, '2014-03-15 00:54:50.000000', 'temperatura', 831.0000, 'ºC'),
	(257115, 121, '2014-03-15 00:54:51.000000', 'temperatura', 1129.0000, 'ºC'),
	(257116, 121, '2014-03-15 00:54:52.000000', 'temperatura', 752.0000, 'ºC'),
	(257117, 121, '2014-03-15 00:54:53.000000', 'temperatura', 376.0000, 'ºC'),
	(257118, 121, '2014-03-15 00:54:54.000000', 'temperatura', 823.0000, 'ºC'),
	(257119, 121, '2014-03-15 00:54:55.000000', 'temperatura', 589.0000, 'ºC'),
	(257120, 121, '2014-03-15 00:54:56.000000', 'temperatura', 476.0000, 'ºC'),
	(257121, 121, '2014-03-15 00:54:57.000000', 'temperatura', 613.0000, 'ºC'),
	(257122, 121, '2014-03-15 00:54:58.000000', 'temperatura', 438.0000, 'ºC'),
	(257123, 121, '2014-03-15 00:54:59.000000', 'temperatura', 353.0000, 'ºC'),
	(257124, 121, '2014-03-15 00:55:00.000000', 'temperatura', 448.0000, 'ºC'),
	(257125, 121, '2014-03-15 00:55:01.000000', 'temperatura', 1185.0000, 'ºC'),
	(257126, 121, '2014-03-15 00:55:02.000000', 'temperatura', 981.0000, 'ºC'),
	(257127, 121, '2014-03-15 00:55:03.000000', 'temperatura', 150.0000, 'ºC'),
	(257128, 121, '2014-03-15 00:55:04.000000', 'temperatura', 206.0000, 'ºC'),
	(257129, 121, '2014-03-15 00:55:05.000000', 'temperatura', 583.0000, 'ºC'),
	(257130, 121, '2014-03-15 00:55:06.000000', 'temperatura', 1098.0000, 'ºC'),
	(257131, 121, '2014-03-15 00:55:07.000000', 'temperatura', 140.0000, 'ºC'),
	(257132, 121, '2014-03-15 00:55:08.000000', 'temperatura', 1008.0000, 'ºC'),
	(257133, 121, '2014-03-15 00:55:09.000000', 'temperatura', 1019.0000, 'ºC'),
	(257134, 121, '2014-03-15 00:55:10.000000', 'temperatura', 871.0000, 'ºC'),
	(257135, 121, '2014-03-15 00:55:11.000000', 'temperatura', 97.0000, 'ºC'),
	(257136, 121, '2014-03-15 00:55:12.000000', 'temperatura', 275.0000, 'ºC'),
	(257137, 121, '2014-03-15 00:55:13.000000', 'temperatura', 1082.0000, 'ºC'),
	(257138, 121, '2014-03-15 00:55:14.000000', 'temperatura', 989.0000, 'ºC'),
	(257139, 121, '2014-03-15 00:55:15.000000', 'temperatura', 496.0000, 'ºC'),
	(257140, 121, '2014-03-15 00:55:16.000000', 'temperatura', 717.0000, 'ºC'),
	(257141, 121, '2014-03-15 00:55:17.000000', 'temperatura', 895.0000, 'ºC'),
	(257142, 121, '2014-03-15 00:55:18.000000', 'temperatura', 1124.0000, 'ºC'),
	(257143, 121, '2014-03-15 00:55:19.000000', 'temperatura', 536.0000, 'ºC'),
	(257144, 121, '2014-03-15 00:55:20.000000', 'temperatura', 507.0000, 'ºC'),
	(257145, 121, '2014-03-15 00:55:21.000000', 'temperatura', 929.0000, 'ºC'),
	(257146, 121, '2014-03-15 00:55:22.000000', 'temperatura', 723.0000, 'ºC'),
	(257147, 121, '2014-03-15 00:55:23.000000', 'temperatura', 830.0000, 'ºC'),
	(257148, 121, '2014-03-15 00:55:24.000000', 'temperatura', 783.0000, 'ºC'),
	(257149, 121, '2014-03-15 00:55:25.000000', 'temperatura', 223.0000, 'ºC'),
	(257150, 121, '2014-03-15 00:55:26.000000', 'temperatura', 1168.0000, 'ºC'),
	(257151, 121, '2014-03-15 00:55:27.000000', 'temperatura', 373.0000, 'ºC'),
	(257152, 121, '2014-03-15 00:55:28.000000', 'temperatura', 759.0000, 'ºC'),
	(257153, 121, '2014-03-15 00:55:29.000000', 'temperatura', 277.0000, 'ºC'),
	(257154, 121, '2014-03-15 00:55:30.000000', 'temperatura', 309.0000, 'ºC'),
	(257155, 121, '2014-03-15 00:55:31.000000', 'temperatura', 715.0000, 'ºC'),
	(257156, 121, '2014-03-15 00:55:32.000000', 'temperatura', 249.0000, 'ºC'),
	(257157, 121, '2014-03-15 00:55:33.000000', 'temperatura', 299.0000, 'ºC'),
	(257158, 121, '2014-03-15 00:55:34.000000', 'temperatura', 747.0000, 'ºC'),
	(257159, 121, '2014-03-15 00:55:35.000000', 'temperatura', 441.0000, 'ºC'),
	(257160, 121, '2014-03-15 00:55:36.000000', 'temperatura', 1165.0000, 'ºC'),
	(257161, 121, '2014-03-15 00:55:37.000000', 'temperatura', 900.0000, 'ºC'),
	(257162, 121, '2014-03-15 00:55:38.000000', 'temperatura', 1006.0000, 'ºC'),
	(257163, 121, '2014-03-15 00:55:39.000000', 'temperatura', 1132.0000, 'ºC'),
	(257164, 121, '2014-03-15 00:55:40.000000', 'temperatura', 240.0000, 'ºC'),
	(257165, 121, '2014-03-15 00:55:41.000000', 'temperatura', 207.0000, 'ºC'),
	(257166, 121, '2014-03-15 00:55:42.000000', 'temperatura', 313.0000, 'ºC'),
	(257167, 121, '2014-03-15 00:55:43.000000', 'temperatura', 943.0000, 'ºC'),
	(257168, 121, '2014-03-15 00:55:44.000000', 'temperatura', 180.0000, 'ºC'),
	(257169, 121, '2014-03-15 00:55:45.000000', 'temperatura', 472.0000, 'ºC'),
	(257170, 121, '2014-03-15 00:55:46.000000', 'temperatura', 621.0000, 'ºC'),
	(257171, 121, '2014-03-15 00:55:47.000000', 'temperatura', 486.0000, 'ºC'),
	(257172, 121, '2014-03-15 00:55:48.000000', 'temperatura', 571.0000, 'ºC'),
	(257173, 121, '2014-03-15 00:55:49.000000', 'temperatura', 194.0000, 'ºC'),
	(257174, 121, '2014-03-15 00:55:50.000000', 'temperatura', 460.0000, 'ºC'),
	(257175, 121, '2014-03-15 00:55:51.000000', 'temperatura', 518.0000, 'ºC'),
	(257176, 121, '2014-03-15 00:55:52.000000', 'temperatura', 10.0000, 'ºC'),
	(257177, 121, '2014-03-15 00:55:53.000000', 'temperatura', 896.0000, 'ºC'),
	(257178, 121, '2014-03-15 00:55:54.000000', 'temperatura', 853.0000, 'ºC'),
	(257179, 121, '2014-03-15 00:55:55.000000', 'temperatura', 375.0000, 'ºC'),
	(257180, 121, '2014-03-15 00:55:56.000000', 'temperatura', 516.0000, 'ºC'),
	(257181, 121, '2014-03-15 00:55:57.000000', 'temperatura', 256.0000, 'ºC'),
	(257182, 121, '2014-03-15 00:55:58.000000', 'temperatura', 932.0000, 'ºC'),
	(257183, 121, '2014-03-15 00:55:59.000000', 'temperatura', 291.0000, 'ºC'),
	(257184, 121, '2014-03-15 00:56:00.000000', 'temperatura', 1063.0000, 'ºC'),
	(257185, 121, '2014-03-15 00:56:01.000000', 'temperatura', 840.0000, 'ºC'),
	(257186, 121, '2014-03-15 00:56:02.000000', 'temperatura', 1010.0000, 'ºC'),
	(257187, 121, '2014-03-15 00:56:03.000000', 'temperatura', 134.0000, 'ºC'),
	(257188, 121, '2014-03-15 00:56:04.000000', 'temperatura', 40.0000, 'ºC'),
	(257189, 121, '2014-03-15 00:56:05.000000', 'temperatura', 997.0000, 'ºC'),
	(257190, 121, '2014-03-15 00:56:06.000000', 'temperatura', 65.0000, 'ºC'),
	(257191, 121, '2014-03-15 00:56:07.000000', 'temperatura', 936.0000, 'ºC'),
	(257192, 121, '2014-03-15 00:56:08.000000', 'temperatura', 885.0000, 'ºC'),
	(257193, 121, '2014-03-15 00:56:09.000000', 'temperatura', 416.0000, 'ºC'),
	(257194, 121, '2014-03-15 00:56:10.000000', 'temperatura', 626.0000, 'ºC'),
	(257195, 121, '2014-03-15 00:56:11.000000', 'temperatura', 682.0000, 'ºC'),
	(257196, 121, '2014-03-15 00:56:12.000000', 'temperatura', 335.0000, 'ºC'),
	(257197, 121, '2014-03-15 00:56:13.000000', 'temperatura', 827.0000, 'ºC'),
	(257198, 121, '2014-03-15 00:56:14.000000', 'temperatura', 732.0000, 'ºC'),
	(257199, 121, '2014-03-15 00:56:15.000000', 'temperatura', 1181.0000, 'ºC'),
	(257200, 121, '2014-03-15 00:56:16.000000', 'temperatura', 108.0000, 'ºC'),
	(257201, 121, '2014-03-15 00:56:17.000000', 'temperatura', 596.0000, 'ºC'),
	(257202, 121, '2014-03-15 00:56:18.000000', 'temperatura', 258.0000, 'ºC'),
	(257203, 121, '2014-03-15 00:56:19.000000', 'temperatura', 701.0000, 'ºC'),
	(257204, 121, '2014-03-15 00:56:20.000000', 'temperatura', 332.0000, 'ºC'),
	(257205, 121, '2014-03-15 00:56:21.000000', 'temperatura', 757.0000, 'ºC'),
	(257206, 121, '2014-03-15 00:56:22.000000', 'temperatura', 391.0000, 'ºC'),
	(257207, 121, '2014-03-15 00:56:23.000000', 'temperatura', 884.0000, 'ºC'),
	(257208, 121, '2014-03-15 00:56:24.000000', 'temperatura', 847.0000, 'ºC'),
	(257209, 121, '2014-03-15 00:56:25.000000', 'temperatura', 382.0000, 'ºC'),
	(257210, 121, '2014-03-15 00:56:26.000000', 'temperatura', 571.0000, 'ºC'),
	(257211, 121, '2014-03-15 00:56:27.000000', 'temperatura', 510.0000, 'ºC'),
	(257212, 121, '2014-03-15 00:56:28.000000', 'temperatura', 836.0000, 'ºC'),
	(257213, 121, '2014-03-15 00:56:29.000000', 'temperatura', 249.0000, 'ºC'),
	(257214, 121, '2014-03-15 00:56:30.000000', 'temperatura', 1141.0000, 'ºC'),
	(257215, 121, '2014-03-15 00:56:31.000000', 'temperatura', 156.0000, 'ºC'),
	(257216, 121, '2014-03-15 00:56:32.000000', 'temperatura', 957.0000, 'ºC'),
	(257217, 121, '2014-03-15 00:56:33.000000', 'temperatura', 719.0000, 'ºC'),
	(257218, 121, '2014-03-15 00:56:34.000000', 'temperatura', 726.0000, 'ºC'),
	(257219, 121, '2014-03-15 00:56:35.000000', 'temperatura', 271.0000, 'ºC'),
	(257220, 121, '2014-03-15 00:56:36.000000', 'temperatura', 377.0000, 'ºC'),
	(257221, 121, '2014-03-15 00:56:37.000000', 'temperatura', 1074.0000, 'ºC'),
	(257222, 121, '2014-03-15 00:56:38.000000', 'temperatura', 639.0000, 'ºC'),
	(257223, 121, '2014-03-15 00:56:39.000000', 'temperatura', 1175.0000, 'ºC'),
	(257224, 121, '2014-03-15 00:56:40.000000', 'temperatura', 358.0000, 'ºC'),
	(257225, 121, '2014-03-15 00:56:41.000000', 'temperatura', 665.0000, 'ºC'),
	(257226, 121, '2014-03-15 00:56:42.000000', 'temperatura', 1050.0000, 'ºC'),
	(257227, 121, '2014-03-15 00:56:43.000000', 'temperatura', 858.0000, 'ºC'),
	(257228, 121, '2014-03-15 00:56:44.000000', 'temperatura', 1140.0000, 'ºC'),
	(257229, 121, '2014-03-15 00:56:45.000000', 'temperatura', 724.0000, 'ºC'),
	(257230, 121, '2014-03-15 00:56:46.000000', 'temperatura', 203.0000, 'ºC'),
	(257231, 121, '2014-03-15 00:56:47.000000', 'temperatura', 42.0000, 'ºC'),
	(257232, 121, '2014-03-15 00:56:48.000000', 'temperatura', 803.0000, 'ºC'),
	(257233, 121, '2014-03-15 00:56:49.000000', 'temperatura', 287.0000, 'ºC'),
	(257234, 121, '2014-03-15 00:56:50.000000', 'temperatura', 229.0000, 'ºC'),
	(257235, 121, '2014-03-15 00:56:51.000000', 'temperatura', 285.0000, 'ºC'),
	(257236, 121, '2014-03-15 00:56:52.000000', 'temperatura', 738.0000, 'ºC'),
	(257237, 121, '2014-03-15 00:56:53.000000', 'temperatura', 434.0000, 'ºC'),
	(257238, 121, '2014-03-15 00:56:54.000000', 'temperatura', 1157.0000, 'ºC'),
	(257239, 121, '2014-03-15 00:56:55.000000', 'temperatura', 882.0000, 'ºC'),
	(257240, 121, '2014-03-15 00:56:56.000000', 'temperatura', 939.0000, 'ºC'),
	(257241, 121, '2014-03-15 00:56:57.000000', 'temperatura', 851.0000, 'ºC'),
	(257242, 121, '2014-03-15 00:56:58.000000', 'temperatura', 239.0000, 'ºC'),
	(257243, 121, '2014-03-15 00:56:59.000000', 'temperatura', 1044.0000, 'ºC'),
	(257244, 121, '2014-03-15 00:57:00.000000', 'temperatura', 901.0000, 'ºC'),
	(257245, 121, '2014-03-15 00:57:01.000000', 'temperatura', 176.0000, 'ºC'),
	(257246, 121, '2014-03-15 00:57:02.000000', 'temperatura', 577.0000, 'ºC'),
	(257247, 121, '2014-03-15 00:57:03.000000', 'temperatura', 1158.0000, 'ºC'),
	(257248, 121, '2014-03-15 00:57:04.000000', 'temperatura', 457.0000, 'ºC'),
	(257249, 121, '2014-03-15 00:57:05.000000', 'temperatura', 15.0000, 'ºC'),
	(257250, 121, '2014-03-15 00:57:06.000000', 'temperatura', 1101.0000, 'ºC'),
	(257251, 121, '2014-03-15 00:57:07.000000', 'temperatura', 663.0000, 'ºC'),
	(257252, 121, '2014-03-15 00:57:08.000000', 'temperatura', 14.0000, 'ºC'),
	(257253, 121, '2014-03-15 00:57:09.000000', 'temperatura', 479.0000, 'ºC'),
	(257254, 121, '2014-03-15 00:57:10.000000', 'temperatura', 1154.0000, 'ºC'),
	(257255, 121, '2014-03-15 00:57:11.000000', 'temperatura', 734.0000, 'ºC'),
	(257256, 121, '2014-03-15 00:57:12.000000', 'temperatura', 207.0000, 'ºC'),
	(257257, 121, '2014-03-15 00:57:13.000000', 'temperatura', 33.0000, 'ºC'),
	(257258, 121, '2014-03-15 00:57:14.000000', 'temperatura', 746.0000, 'ºC'),
	(257259, 121, '2014-03-15 00:57:15.000000', 'temperatura', 31.0000, 'ºC'),
	(257260, 121, '2014-03-15 00:57:16.000000', 'temperatura', 318.0000, 'ºC'),
	(257261, 121, '2014-03-15 00:57:17.000000', 'temperatura', 296.0000, 'ºC'),
	(257262, 121, '2014-03-15 00:57:18.000000', 'temperatura', 528.0000, 'ºC'),
	(257263, 121, '2014-03-15 00:57:19.000000', 'temperatura', 551.0000, 'ºC'),
	(257264, 121, '2014-03-15 00:57:20.000000', 'temperatura', 1173.0000, 'ºC'),
	(257265, 121, '2014-03-15 00:57:21.000000', 'temperatura', 611.0000, 'ºC'),
	(257266, 121, '2014-03-15 00:57:22.000000', 'temperatura', 739.0000, 'ºC'),
	(257267, 121, '2014-03-15 00:57:23.000000', 'temperatura', 661.0000, 'ºC'),
	(257268, 121, '2014-03-15 00:57:24.000000', 'temperatura', 1089.0000, 'ºC'),
	(257269, 121, '2014-03-15 00:57:25.000000', 'temperatura', 1064.0000, 'ºC'),
	(257270, 121, '2014-03-15 00:57:26.000000', 'temperatura', 854.0000, 'ºC'),
	(257271, 121, '2014-03-15 00:57:27.000000', 'temperatura', 1076.0000, 'ºC'),
	(257272, 121, '2014-03-15 00:57:28.000000', 'temperatura', 421.0000, 'ºC'),
	(257273, 121, '2014-03-15 00:57:29.000000', 'temperatura', 76.0000, 'ºC'),
	(257274, 121, '2014-03-15 00:57:30.000000', 'temperatura', 317.0000, 'ºC'),
	(257275, 121, '2014-03-15 00:57:31.000000', 'temperatura', 158.0000, 'ºC'),
	(257276, 121, '2014-03-15 00:57:32.000000', 'temperatura', 1041.0000, 'ºC'),
	(257277, 121, '2014-03-15 00:57:33.000000', 'temperatura', 1130.0000, 'ºC'),
	(257278, 121, '2014-03-15 00:57:34.000000', 'temperatura', 129.0000, 'ºC'),
	(257279, 121, '2014-03-15 00:57:35.000000', 'temperatura', 856.0000, 'ºC'),
	(257280, 121, '2014-03-15 00:57:36.000000', 'temperatura', 291.0000, 'ºC'),
	(257281, 121, '2014-03-15 00:57:37.000000', 'temperatura', 87.0000, 'ºC'),
	(257282, 121, '2014-03-15 00:57:38.000000', 'temperatura', 763.0000, 'ºC'),
	(257283, 121, '2014-03-15 00:57:39.000000', 'temperatura', 1154.0000, 'ºC'),
	(257284, 121, '2014-03-15 00:57:40.000000', 'temperatura', 1083.0000, 'ºC'),
	(257285, 121, '2014-03-15 00:57:41.000000', 'temperatura', 753.0000, 'ºC'),
	(257286, 121, '2014-03-15 00:57:42.000000', 'temperatura', 515.0000, 'ºC'),
	(257287, 121, '2014-03-15 00:57:43.000000', 'temperatura', 319.0000, 'ºC'),
	(257288, 121, '2014-03-15 00:57:44.000000', 'temperatura', 51.0000, 'ºC'),
	(257289, 121, '2014-03-15 00:57:45.000000', 'temperatura', 498.0000, 'ºC'),
	(257290, 121, '2014-03-15 00:57:46.000000', 'temperatura', 1137.0000, 'ºC'),
	(257291, 121, '2014-03-15 00:57:47.000000', 'temperatura', 592.0000, 'ºC'),
	(257292, 121, '2014-03-15 00:57:48.000000', 'temperatura', 751.0000, 'ºC'),
	(257293, 121, '2014-03-15 00:57:49.000000', 'temperatura', 777.0000, 'ºC'),
	(257294, 121, '2014-03-15 00:57:50.000000', 'temperatura', 434.0000, 'ºC'),
	(257295, 121, '2014-03-15 00:57:51.000000', 'temperatura', 1041.0000, 'ºC'),
	(257296, 121, '2014-03-15 00:57:52.000000', 'temperatura', 303.0000, 'ºC'),
	(257297, 121, '2014-03-15 00:57:53.000000', 'temperatura', 792.0000, 'ºC'),
	(257298, 121, '2014-03-15 00:57:54.000000', 'temperatura', 651.0000, 'ºC'),
	(257299, 121, '2014-03-15 00:57:55.000000', 'temperatura', 882.0000, 'ºC'),
	(257300, 121, '2014-03-15 00:57:56.000000', 'temperatura', 55.0000, 'ºC'),
	(257301, 121, '2014-03-15 00:57:57.000000', 'temperatura', 31.0000, 'ºC'),
	(257302, 121, '2014-03-15 00:57:58.000000', 'temperatura', 1190.0000, 'ºC'),
	(257303, 121, '2014-03-15 00:57:59.000000', 'temperatura', 1059.0000, 'ºC'),
	(257304, 121, '2014-03-15 00:58:00.000000', 'temperatura', 525.0000, 'ºC'),
	(257305, 121, '2014-03-15 00:58:01.000000', 'temperatura', 646.0000, 'ºC'),
	(257306, 121, '2014-03-15 00:58:02.000000', 'temperatura', 457.0000, 'ºC'),
	(257307, 121, '2014-03-15 00:58:03.000000', 'temperatura', 348.0000, 'ºC'),
	(257308, 121, '2014-03-15 00:58:04.000000', 'temperatura', 370.0000, 'ºC'),
	(257309, 121, '2014-03-15 00:58:05.000000', 'temperatura', 807.0000, 'ºC'),
	(257310, 121, '2014-03-15 00:58:06.000000', 'temperatura', 527.0000, 'ºC'),
	(257311, 121, '2014-03-15 00:58:07.000000', 'temperatura', 211.0000, 'ºC'),
	(257312, 121, '2014-03-15 00:58:08.000000', 'temperatura', 678.0000, 'ºC'),
	(257313, 121, '2014-03-15 00:58:09.000000', 'temperatura', 354.0000, 'ºC'),
	(257314, 121, '2014-03-15 00:58:10.000000', 'temperatura', 940.0000, 'ºC'),
	(257315, 121, '2014-03-15 00:58:11.000000', 'temperatura', 36.0000, 'ºC'),
	(257316, 121, '2014-03-15 00:58:12.000000', 'temperatura', 960.0000, 'ºC'),
	(257317, 121, '2014-03-15 00:58:13.000000', 'temperatura', 1092.0000, 'ºC'),
	(257318, 121, '2014-03-15 00:58:14.000000', 'temperatura', 180.0000, 'ºC'),
	(257319, 121, '2014-03-15 00:58:15.000000', 'temperatura', 25.0000, 'ºC'),
	(257320, 121, '2014-03-15 00:58:16.000000', 'temperatura', 785.0000, 'ºC'),
	(257321, 121, '2014-03-15 00:58:17.000000', 'temperatura', 249.0000, 'ºC'),
	(257322, 121, '2014-03-15 00:58:18.000000', 'temperatura', 93.0000, 'ºC'),
	(257323, 121, '2014-03-15 00:58:19.000000', 'temperatura', 917.0000, 'ºC'),
	(257324, 121, '2014-03-15 00:58:20.000000', 'temperatura', 705.0000, 'ºC'),
	(257325, 121, '2014-03-15 00:58:21.000000', 'temperatura', 778.0000, 'ºC'),
	(257326, 121, '2014-03-15 00:58:22.000000', 'temperatura', 573.0000, 'ºC'),
	(257327, 121, '2014-03-15 00:58:23.000000', 'temperatura', 534.0000, 'ºC'),
	(257328, 121, '2014-03-15 00:58:24.000000', 'temperatura', 949.0000, 'ºC'),
	(257329, 121, '2014-03-15 00:58:25.000000', 'temperatura', 745.0000, 'ºC'),
	(257330, 121, '2014-03-15 00:58:26.000000', 'temperatura', 876.0000, 'ºC'),
	(257331, 121, '2014-03-15 00:58:27.000000', 'temperatura', 948.0000, 'ºC'),
	(257332, 121, '2014-03-15 00:58:28.000000', 'temperatura', 914.0000, 'ºC'),
	(257333, 121, '2014-03-15 00:58:29.000000', 'temperatura', 524.0000, 'ºC'),
	(257334, 121, '2014-03-15 00:58:30.000000', 'temperatura', 1078.0000, 'ºC'),
	(257335, 121, '2014-03-15 00:58:31.000000', 'temperatura', 219.0000, 'ºC'),
	(257336, 121, '2014-03-15 00:58:32.000000', 'temperatura', 262.0000, 'ºC'),
	(257337, 121, '2014-03-15 00:58:33.000000', 'temperatura', 652.0000, 'ºC'),
	(257338, 121, '2014-03-15 00:58:34.000000', 'temperatura', 77.0000, 'ºC'),
	(257339, 121, '2014-03-15 00:58:35.000000', 'temperatura', 828.0000, 'ºC'),
	(257340, 121, '2014-03-15 00:58:36.000000', 'temperatura', 309.0000, 'ºC'),
	(257341, 121, '2014-03-15 00:58:37.000000', 'temperatura', 260.0000, 'ºC'),
	(257342, 121, '2014-03-15 00:58:38.000000', 'temperatura', 376.0000, 'ºC'),
	(257343, 121, '2014-03-15 00:58:39.000000', 'temperatura', 1101.0000, 'ºC'),
	(257344, 121, '2014-03-15 00:58:40.000000', 'temperatura', 775.0000, 'ºC'),
	(257345, 121, '2014-03-15 00:58:41.000000', 'temperatura', 572.0000, 'ºC'),
	(257346, 121, '2014-03-15 00:58:42.000000', 'temperatura', 538.0000, 'ºC'),
	(257347, 121, '2014-03-15 00:58:43.000000', 'temperatura', 972.0000, 'ºC'),
	(257348, 121, '2014-03-15 00:58:44.000000', 'temperatura', 846.0000, 'ºC'),
	(257349, 121, '2014-03-15 00:58:45.000000', 'temperatura', 117.0000, 'ºC'),
	(257350, 121, '2014-03-15 00:58:46.000000', 'temperatura', 445.0000, 'ºC'),
	(257351, 121, '2014-03-15 00:58:47.000000', 'temperatura', 676.0000, 'ºC'),
	(257352, 121, '2014-03-15 00:58:48.000000', 'temperatura', 844.0000, 'ºC'),
	(257353, 121, '2014-03-15 00:58:49.000000', 'temperatura', 992.0000, 'ºC'),
	(257354, 121, '2014-03-15 00:58:50.000000', 'temperatura', 29.0000, 'ºC'),
	(257355, 121, '2014-03-15 00:58:51.000000', 'temperatura', 768.0000, 'ºC'),
	(257356, 121, '2014-03-15 00:58:52.000000', 'temperatura', 155.0000, 'ºC'),
	(257357, 121, '2014-03-15 00:58:53.000000', 'temperatura', 873.0000, 'ºC'),
	(257358, 121, '2014-03-15 00:58:54.000000', 'temperatura', 299.0000, 'ºC'),
	(257359, 121, '2014-03-15 00:58:55.000000', 'temperatura', 77.0000, 'ºC'),
	(257360, 121, '2014-03-15 00:58:56.000000', 'temperatura', 688.0000, 'ºC'),
	(257361, 121, '2014-03-15 00:58:57.000000', 'temperatura', 810.0000, 'ºC'),
	(257362, 121, '2014-03-15 00:58:58.000000', 'temperatura', 786.0000, 'ºC'),
	(257363, 121, '2014-03-15 00:58:59.000000', 'temperatura', 300.0000, 'ºC'),
	(257364, 121, '2014-03-15 00:59:00.000000', 'temperatura', 344.0000, 'ºC'),
	(257365, 121, '2014-03-15 00:59:01.000000', 'temperatura', 820.0000, 'ºC'),
	(257366, 121, '2014-03-15 00:59:02.000000', 'temperatura', 667.0000, 'ºC'),
	(257367, 121, '2014-03-15 00:59:03.000000', 'temperatura', 878.0000, 'ºC'),
	(257368, 121, '2014-03-15 00:59:04.000000', 'temperatura', 1189.0000, 'ºC'),
	(257369, 121, '2014-03-15 00:59:05.000000', 'temperatura', 911.0000, 'ºC'),
	(257370, 121, '2014-03-15 00:59:06.000000', 'temperatura', 989.0000, 'ºC'),
	(257371, 121, '2014-03-15 00:59:07.000000', 'temperatura', 1012.0000, 'ºC'),
	(257372, 121, '2014-03-15 00:59:08.000000', 'temperatura', 892.0000, 'ºC'),
	(257373, 121, '2014-03-15 00:59:09.000000', 'temperatura', 225.0000, 'ºC'),
	(257374, 121, '2014-03-15 00:59:10.000000', 'temperatura', 851.0000, 'ºC'),
	(257375, 121, '2014-03-15 00:59:11.000000', 'temperatura', 1179.0000, 'ºC'),
	(257376, 121, '2014-03-15 00:59:12.000000', 'temperatura', 942.0000, 'ºC'),
	(257377, 121, '2014-03-15 00:59:13.000000', 'temperatura', 1172.0000, 'ºC'),
	(257378, 121, '2014-03-15 00:59:14.000000', 'temperatura', 637.0000, 'ºC'),
	(257379, 121, '2014-03-15 00:59:15.000000', 'temperatura', 870.0000, 'ºC'),
	(257380, 121, '2014-03-15 00:59:16.000000', 'temperatura', 39.0000, 'ºC'),
	(257381, 121, '2014-03-15 00:59:17.000000', 'temperatura', 1186.0000, 'ºC'),
	(257382, 121, '2014-03-15 00:59:18.000000', 'temperatura', 1012.0000, 'ºC'),
	(257383, 121, '2014-03-15 00:59:19.000000', 'temperatura', 305.0000, 'ºC'),
	(257384, 121, '2014-03-15 00:59:20.000000', 'temperatura', 886.0000, 'ºC'),
	(257385, 121, '2014-03-15 00:59:21.000000', 'temperatura', 1119.0000, 'ºC'),
	(257386, 121, '2014-03-15 00:59:22.000000', 'temperatura', 535.0000, 'ºC'),
	(257387, 121, '2014-03-15 00:59:23.000000', 'temperatura', 519.0000, 'ºC'),
	(257388, 121, '2014-03-15 00:59:24.000000', 'temperatura', 992.0000, 'ºC'),
	(257389, 121, '2014-03-15 00:59:25.000000', 'temperatura', 1002.0000, 'ºC'),
	(257390, 121, '2014-03-15 00:59:26.000000', 'temperatura', 835.0000, 'ºC'),
	(257391, 121, '2014-03-15 00:59:27.000000', 'temperatura', 1169.0000, 'ºC'),
	(257392, 121, '2014-03-15 00:59:28.000000', 'temperatura', 941.0000, 'ºC'),
	(257393, 121, '2014-03-15 00:59:29.000000', 'temperatura', 1198.0000, 'ºC'),
	(257394, 121, '2014-03-15 00:59:30.000000', 'temperatura', 767.0000, 'ºC'),
	(257395, 121, '2014-03-15 00:59:31.000000', 'temperatura', 244.0000, 'ºC'),
	(257396, 121, '2014-03-15 00:59:32.000000', 'temperatura', 117.0000, 'ºC'),
	(257397, 121, '2014-03-15 00:59:33.000000', 'temperatura', 1054.0000, 'ºC'),
	(257398, 121, '2014-03-15 00:59:34.000000', 'temperatura', 118.0000, 'ºC'),
	(257399, 121, '2014-03-15 00:59:35.000000', 'temperatura', 1028.0000, 'ºC'),
	(257400, 121, '2014-03-15 00:59:36.000000', 'temperatura', 1187.0000, 'ºC'),
	(257401, 121, '2014-03-15 00:59:37.000000', 'temperatura', 450.0000, 'ºC'),
	(257402, 121, '2014-03-15 00:59:38.000000', 'temperatura', 1093.0000, 'ºC'),
	(257403, 121, '2014-03-15 00:59:39.000000', 'temperatura', 513.0000, 'ºC'),
	(257404, 121, '2014-03-15 00:59:40.000000', 'temperatura', 487.0000, 'ºC'),
	(257405, 121, '2014-03-15 00:59:41.000000', 'temperatura', 895.0000, 'ºC'),
	(257406, 121, '2014-03-15 00:59:42.000000', 'temperatura', 614.0000, 'ºC'),
	(257407, 121, '2014-03-15 00:59:43.000000', 'temperatura', 386.0000, 'ºC'),
	(257408, 121, '2014-03-15 00:59:44.000000', 'temperatura', 88.0000, 'ºC'),
	(257409, 121, '2014-03-15 00:59:45.000000', 'temperatura', 483.0000, 'ºC'),
	(257410, 121, '2014-03-15 00:59:46.000000', 'temperatura', 953.0000, 'ºC'),
	(257411, 121, '2014-03-15 00:59:47.000000', 'temperatura', 916.0000, 'ºC'),
	(257412, 121, '2014-03-15 00:59:48.000000', 'temperatura', 521.0000, 'ºC'),
	(257413, 121, '2014-03-15 00:59:49.000000', 'temperatura', 1059.0000, 'ºC'),
	(257414, 121, '2014-03-15 00:59:50.000000', 'temperatura', 132.0000, 'ºC'),
	(257415, 121, '2014-03-15 00:59:51.000000', 'temperatura', 1081.0000, 'ºC'),
	(257416, 121, '2014-03-15 00:59:52.000000', 'temperatura', 211.0000, 'ºC'),
	(257417, 121, '2014-03-15 00:59:53.000000', 'temperatura', 214.0000, 'ºC'),
	(257418, 121, '2014-03-15 00:59:54.000000', 'temperatura', 437.0000, 'ºC'),
	(257419, 121, '2014-03-15 00:59:55.000000', 'temperatura', 341.0000, 'ºC'),
	(257420, 121, '2014-03-15 00:59:56.000000', 'temperatura', 397.0000, 'ºC'),
	(257421, 121, '2014-03-15 00:59:57.000000', 'temperatura', 962.0000, 'ºC'),
	(257422, 121, '2014-03-15 00:59:58.000000', 'temperatura', 18.0000, 'ºC'),
	(257423, 121, '2014-03-15 00:59:59.000000', 'temperatura', 807.0000, 'ºC'),
	(257424, 121, '2014-03-15 01:00:00.000000', 'temperatura', 382.0000, 'ºC'),
	(257425, 121, '2014-03-15 01:00:01.000000', 'temperatura', 689.0000, 'ºC'),
	(257426, 121, '2014-03-15 01:00:02.000000', 'temperatura', 1098.0000, 'ºC'),
	(257427, 121, '2014-03-15 01:00:03.000000', 'temperatura', 1025.0000, 'ºC'),
	(257428, 121, '2014-03-15 01:00:04.000000', 'temperatura', 633.0000, 'ºC'),
	(257429, 121, '2014-03-15 01:00:05.000000', 'temperatura', 88.0000, 'ºC'),
	(257430, 121, '2014-03-15 01:00:06.000000', 'temperatura', 941.0000, 'ºC'),
	(257431, 121, '2014-03-15 01:00:07.000000', 'temperatura', 843.0000, 'ºC'),
	(257432, 121, '2014-03-15 01:00:08.000000', 'temperatura', 192.0000, 'ºC'),
	(257433, 121, '2014-03-15 01:00:09.000000', 'temperatura', 833.0000, 'ºC'),
	(257434, 121, '2014-03-15 01:00:10.000000', 'temperatura', 1187.0000, 'ºC'),
	(257435, 121, '2014-03-15 01:00:11.000000', 'temperatura', 1036.0000, 'ºC'),
	(257436, 121, '2014-03-15 01:00:12.000000', 'temperatura', 421.0000, 'ºC'),
	(257437, 121, '2014-03-15 01:00:13.000000', 'temperatura', 197.0000, 'ºC'),
	(257438, 121, '2014-03-15 01:00:14.000000', 'temperatura', 921.0000, 'ºC'),
	(257439, 121, '2014-03-15 01:00:15.000000', 'temperatura', 418.0000, 'ºC'),
	(257440, 121, '2014-03-15 01:00:16.000000', 'temperatura', 524.0000, 'ºC'),
	(257441, 121, '2014-03-15 01:00:17.000000', 'temperatura', 170.0000, 'ºC'),
	(257442, 121, '2014-03-15 01:00:18.000000', 'temperatura', 476.0000, 'ºC'),
	(257443, 121, '2014-03-15 01:00:19.000000', 'temperatura', 670.0000, 'ºC'),
	(257444, 121, '2014-03-15 01:00:20.000000', 'temperatura', 722.0000, 'ºC'),
	(257445, 121, '2014-03-15 01:00:21.000000', 'temperatura', 403.0000, 'ºC'),
	(257446, 121, '2014-03-15 01:00:22.000000', 'temperatura', 1048.0000, 'ºC'),
	(257447, 121, '2014-03-15 01:00:23.000000', 'temperatura', 430.0000, 'ºC'),
	(257448, 121, '2014-03-15 01:00:24.000000', 'temperatura', 208.0000, 'ºC'),
	(257449, 121, '2014-03-15 01:00:25.000000', 'temperatura', 952.0000, 'ºC'),
	(257450, 121, '2014-03-15 01:00:26.000000', 'temperatura', 534.0000, 'ºC'),
	(257451, 121, '2014-03-15 01:00:27.000000', 'temperatura', 1015.0000, 'ºC'),
	(257452, 121, '2014-03-15 01:00:28.000000', 'temperatura', 1074.0000, 'ºC'),
	(257453, 121, '2014-03-15 01:00:29.000000', 'temperatura', 1126.0000, 'ºC'),
	(257454, 121, '2014-03-15 01:00:30.000000', 'temperatura', 10.0000, 'ºC'),
	(257455, 121, '2014-03-15 01:00:31.000000', 'temperatura', 271.0000, 'ºC'),
	(257456, 121, '2014-03-15 01:00:32.000000', 'temperatura', 125.0000, 'ºC'),
	(257457, 121, '2014-03-15 01:00:33.000000', 'temperatura', 1011.0000, 'ºC'),
	(257458, 121, '2014-03-15 01:00:34.000000', 'temperatura', 1081.0000, 'ºC'),
	(257459, 121, '2014-03-15 01:00:35.000000', 'temperatura', 1175.0000, 'ºC'),
	(257460, 121, '2014-03-15 01:00:36.000000', 'temperatura', 232.0000, 'ºC'),
	(257461, 121, '2014-03-15 01:00:37.000000', 'temperatura', 36.0000, 'ºC'),
	(257462, 121, '2014-03-15 01:00:38.000000', 'temperatura', 682.0000, 'ºC'),
	(257463, 121, '2014-03-15 01:00:39.000000', 'temperatura', 903.0000, 'ºC'),
	(257464, 121, '2014-03-15 01:00:40.000000', 'temperatura', 71.0000, 'ºC'),
	(257465, 121, '2014-03-15 01:00:41.000000', 'temperatura', 44.0000, 'ºC'),
	(257466, 121, '2014-03-15 01:00:42.000000', 'temperatura', 9.0000, 'ºC'),
	(257467, 121, '2014-03-15 01:00:43.000000', 'temperatura', 1112.0000, 'ºC'),
	(257468, 121, '2014-03-15 01:00:44.000000', 'temperatura', 734.0000, 'ºC'),
	(257469, 121, '2014-03-15 01:00:45.000000', 'temperatura', 335.0000, 'ºC'),
	(257470, 121, '2014-03-15 01:00:46.000000', 'temperatura', 672.0000, 'ºC'),
	(257471, 121, '2014-03-15 01:00:47.000000', 'temperatura', 1157.0000, 'ºC'),
	(257472, 121, '2014-03-15 01:00:48.000000', 'temperatura', 169.0000, 'ºC'),
	(257473, 121, '2014-03-15 01:00:49.000000', 'temperatura', 975.0000, 'ºC'),
	(257474, 121, '2014-03-15 01:00:50.000000', 'temperatura', 767.0000, 'ºC'),
	(257475, 121, '2014-03-15 01:00:51.000000', 'temperatura', 913.0000, 'ºC'),
	(257476, 121, '2014-03-15 01:00:52.000000', 'temperatura', 1064.0000, 'ºC'),
	(257477, 121, '2014-03-15 01:00:53.000000', 'temperatura', 182.0000, 'ºC'),
	(257478, 121, '2014-03-15 01:00:54.000000', 'temperatura', 117.0000, 'ºC'),
	(257479, 121, '2014-03-15 01:00:55.000000', 'temperatura', 39.0000, 'ºC'),
	(257480, 121, '2014-03-15 01:00:56.000000', 'temperatura', 1044.0000, 'ºC'),
	(257481, 121, '2014-03-15 01:00:57.000000', 'temperatura', 304.0000, 'ºC'),
	(257482, 121, '2014-03-15 01:00:58.000000', 'temperatura', 788.0000, 'ºC'),
	(257483, 121, '2014-03-15 01:00:59.000000', 'temperatura', 631.0000, 'ºC'),
	(257484, 121, '2014-03-15 01:01:00.000000', 'temperatura', 790.0000, 'ºC'),
	(257485, 121, '2014-03-15 01:01:01.000000', 'temperatura', 857.0000, 'ºC'),
	(257486, 121, '2014-03-15 01:01:02.000000', 'temperatura', 718.0000, 'ºC'),
	(257487, 121, '2014-03-15 01:01:03.000000', 'temperatura', 1018.0000, 'ºC'),
	(257488, 121, '2014-03-15 01:01:04.000000', 'temperatura', 536.0000, 'ºC'),
	(257489, 121, '2014-03-15 01:01:05.000000', 'temperatura', 827.0000, 'ºC'),
	(257490, 121, '2014-03-15 01:01:06.000000', 'temperatura', 126.0000, 'ºC'),
	(257491, 121, '2014-03-15 01:01:07.000000', 'temperatura', 551.0000, 'ºC'),
	(257492, 121, '2014-03-15 01:01:08.000000', 'temperatura', 1176.0000, 'ºC'),
	(257493, 121, '2014-03-15 01:01:09.000000', 'temperatura', 626.0000, 'ºC'),
	(257494, 121, '2014-03-15 01:01:10.000000', 'temperatura', 805.0000, 'ºC'),
	(257495, 121, '2014-03-15 01:01:11.000000', 'temperatura', 948.0000, 'ºC'),
	(257496, 121, '2014-03-15 01:01:12.000000', 'temperatura', 1127.0000, 'ºC'),
	(257497, 121, '2014-03-15 01:01:13.000000', 'temperatura', 389.0000, 'ºC'),
	(257498, 121, '2014-03-15 01:01:14.000000', 'temperatura', 964.0000, 'ºC'),
	(257499, 121, '2014-03-15 01:01:15.000000', 'temperatura', 53.0000, 'ºC'),
	(257500, 121, '2014-03-15 01:01:16.000000', 'temperatura', 976.0000, 'ºC'),
	(257501, 121, '2014-03-15 01:01:17.000000', 'temperatura', 1118.0000, 'ºC'),
	(257502, 121, '2014-03-15 01:01:18.000000', 'temperatura', 266.0000, 'ºC'),
	(257503, 121, '2014-03-15 01:01:19.000000', 'temperatura', 376.0000, 'ºC'),
	(257504, 121, '2014-03-15 01:01:20.000000', 'temperatura', 1083.0000, 'ºC'),
	(257505, 121, '2014-03-15 01:01:21.000000', 'temperatura', 687.0000, 'ºC'),
	(257506, 121, '2014-03-15 01:01:22.000000', 'temperatura', 186.0000, 'ºC'),
	(257507, 121, '2014-03-15 01:01:23.000000', 'temperatura', 71.0000, 'ºC'),
	(257508, 121, '2014-03-15 01:01:24.000000', 'temperatura', 995.0000, 'ºC'),
	(257509, 121, '2014-03-15 01:01:25.000000', 'temperatura', 1162.0000, 'ºC'),
	(257510, 121, '2014-03-15 01:01:26.000000', 'temperatura', 428.0000, 'ºC'),
	(257511, 121, '2014-03-15 01:01:27.000000', 'temperatura', 1055.0000, 'ºC'),
	(257512, 121, '2014-03-15 01:01:28.000000', 'temperatura', 391.0000, 'ºC'),
	(257513, 121, '2014-03-15 01:01:29.000000', 'temperatura', 1191.0000, 'ºC'),
	(257514, 121, '2014-03-15 01:01:30.000000', 'temperatura', 1182.0000, 'ºC'),
	(257515, 121, '2014-03-15 01:01:31.000000', 'temperatura', 1139.0000, 'ºC'),
	(257516, 121, '2014-03-15 01:01:32.000000', 'temperatura', 950.0000, 'ºC'),
	(257517, 121, '2014-03-15 01:01:33.000000', 'temperatura', 132.0000, 'ºC'),
	(257518, 121, '2014-03-15 01:01:34.000000', 'temperatura', 209.0000, 'ºC'),
	(257519, 121, '2014-03-15 01:01:35.000000', 'temperatura', 652.0000, 'ºC'),
	(257520, 121, '2014-03-15 01:01:36.000000', 'temperatura', 231.0000, 'ºC'),
	(257521, 121, '2014-03-15 01:01:37.000000', 'temperatura', 401.0000, 'ºC'),
	(257522, 121, '2014-03-15 01:01:38.000000', 'temperatura', 112.0000, 'ºC'),
	(257523, 121, '2014-03-15 01:01:39.000000', 'temperatura', 559.0000, 'ºC'),
	(257524, 121, '2014-03-15 01:01:40.000000', 'temperatura', 61.0000, 'ºC'),
	(257525, 121, '2014-03-15 01:01:41.000000', 'temperatura', 1025.0000, 'ºC'),
	(257526, 121, '2014-03-15 01:01:42.000000', 'temperatura', 145.0000, 'ºC'),
	(257527, 121, '2014-03-15 01:01:43.000000', 'temperatura', 52.0000, 'ºC'),
	(257528, 121, '2014-03-15 01:01:44.000000', 'temperatura', 1022.0000, 'ºC'),
	(257529, 121, '2014-03-15 01:01:45.000000', 'temperatura', 156.0000, 'ºC'),
	(257530, 121, '2014-03-15 01:01:46.000000', 'temperatura', 116.0000, 'ºC'),
	(257531, 121, '2014-03-15 01:01:47.000000', 'temperatura', 112.0000, 'ºC'),
	(257532, 121, '2014-03-15 01:01:48.000000', 'temperatura', 211.0000, 'ºC'),
	(257533, 121, '2014-03-15 01:01:49.000000', 'temperatura', 721.0000, 'ºC'),
	(257534, 121, '2014-03-15 01:01:50.000000', 'temperatura', 572.0000, 'ºC'),
	(257535, 121, '2014-03-15 01:01:51.000000', 'temperatura', 695.0000, 'ºC'),
	(257536, 121, '2014-03-15 01:01:52.000000', 'temperatura', 563.0000, 'ºC'),
	(257537, 121, '2014-03-15 01:01:53.000000', 'temperatura', 728.0000, 'ºC'),
	(257538, 121, '2014-03-15 01:01:54.000000', 'temperatura', 751.0000, 'ºC'),
	(257539, 121, '2014-03-15 01:01:55.000000', 'temperatura', 374.0000, 'ºC'),
	(257540, 121, '2014-03-15 01:01:56.000000', 'temperatura', 814.0000, 'ºC'),
	(257541, 121, '2014-03-15 01:01:57.000000', 'temperatura', 552.0000, 'ºC'),
	(257542, 121, '2014-03-15 01:01:58.000000', 'temperatura', 318.0000, 'ºC'),
	(257543, 121, '2014-03-15 01:01:59.000000', 'temperatura', 1134.0000, 'ºC'),
	(257544, 121, '2014-03-15 01:02:00.000000', 'temperatura', 1117.0000, 'ºC'),
	(257545, 121, '2014-03-15 01:02:01.000000', 'temperatura', 985.0000, 'ºC'),
	(257546, 121, '2014-03-15 01:02:02.000000', 'temperatura', 371.0000, 'ºC'),
	(257547, 121, '2014-03-15 01:02:03.000000', 'temperatura', 104.0000, 'ºC'),
	(257548, 121, '2014-03-15 01:02:04.000000', 'temperatura', 605.0000, 'ºC'),
	(257549, 121, '2014-03-15 01:02:05.000000', 'temperatura', 316.0000, 'ºC'),
	(257550, 121, '2014-03-15 01:02:06.000000', 'temperatura', 964.0000, 'ºC'),
	(257551, 121, '2014-03-15 01:02:07.000000', 'temperatura', 271.0000, 'ºC'),
	(257552, 121, '2014-03-15 01:02:08.000000', 'temperatura', 865.0000, 'ºC'),
	(257553, 121, '2014-03-15 01:02:09.000000', 'temperatura', 1114.0000, 'ºC'),
	(257554, 121, '2014-03-15 01:02:10.000000', 'temperatura', 574.0000, 'ºC'),
	(257555, 121, '2014-03-15 01:02:11.000000', 'temperatura', 730.0000, 'ºC'),
	(257556, 121, '2014-03-15 01:02:12.000000', 'temperatura', 730.0000, 'ºC'),
	(257557, 121, '2014-03-15 01:02:13.000000', 'temperatura', 257.0000, 'ºC'),
	(257558, 121, '2014-03-15 01:02:14.000000', 'temperatura', 297.0000, 'ºC'),
	(257559, 121, '2014-03-15 01:02:15.000000', 'temperatura', 714.0000, 'ºC'),
	(257560, 121, '2014-03-15 01:02:16.000000', 'temperatura', 279.0000, 'ºC'),
	(257561, 121, '2014-03-15 01:02:17.000000', 'temperatura', 454.0000, 'ºC'),
	(257562, 121, '2014-03-15 01:02:18.000000', 'temperatura', 232.0000, 'ºC'),
	(257563, 121, '2014-03-15 01:02:19.000000', 'temperatura', 1001.0000, 'ºC'),
	(257564, 121, '2014-03-15 01:02:20.000000', 'temperatura', 708.0000, 'ºC'),
	(257565, 121, '2014-03-15 01:02:21.000000', 'temperatura', 539.0000, 'ºC'),
	(257566, 121, '2014-03-15 01:02:22.000000', 'temperatura', 571.0000, 'ºC'),
	(257567, 121, '2014-03-15 01:02:23.000000', 'temperatura', 38.0000, 'ºC'),
	(257568, 121, '2014-03-15 01:02:24.000000', 'temperatura', 879.0000, 'ºC'),
	(257569, 121, '2014-03-15 01:02:25.000000', 'temperatura', 681.0000, 'ºC'),
	(257570, 121, '2014-03-15 01:02:26.000000', 'temperatura', 770.0000, 'ºC'),
	(257571, 121, '2014-03-15 01:02:27.000000', 'temperatura', 604.0000, 'ºC'),
	(257572, 121, '2014-03-15 01:02:28.000000', 'temperatura', 714.0000, 'ºC'),
	(257573, 121, '2014-03-15 01:02:29.000000', 'temperatura', 557.0000, 'ºC'),
	(257574, 121, '2014-03-15 01:02:30.000000', 'temperatura', 644.0000, 'ºC'),
	(257575, 121, '2014-03-15 01:02:31.000000', 'temperatura', 351.0000, 'ºC'),
	(257576, 121, '2014-03-15 01:02:32.000000', 'temperatura', 1022.0000, 'ºC'),
	(257577, 121, '2014-03-15 01:02:33.000000', 'temperatura', 458.0000, 'ºC'),
	(257578, 121, '2014-03-15 01:02:34.000000', 'temperatura', 426.0000, 'ºC'),
	(257579, 121, '2014-03-15 01:02:35.000000', 'temperatura', 754.0000, 'ºC'),
	(257580, 121, '2014-03-15 01:02:36.000000', 'temperatura', 93.0000, 'ºC'),
	(257581, 121, '2014-03-15 01:02:37.000000', 'temperatura', 604.0000, 'ºC'),
	(257582, 121, '2014-03-15 01:02:38.000000', 'temperatura', 343.0000, 'ºC'),
	(257583, 121, '2014-03-15 01:02:39.000000', 'temperatura', 1102.0000, 'ºC'),
	(257584, 121, '2014-03-15 01:02:40.000000', 'temperatura', 882.0000, 'ºC'),
	(257585, 121, '2014-03-15 01:02:41.000000', 'temperatura', 1106.0000, 'ºC'),
	(257586, 121, '2014-03-15 01:02:42.000000', 'temperatura', 483.0000, 'ºC'),
	(257587, 121, '2014-03-15 01:02:43.000000', 'temperatura', 297.0000, 'ºC'),
	(257588, 121, '2014-03-15 01:02:44.000000', 'temperatura', 36.0000, 'ºC'),
	(257589, 121, '2014-03-15 01:02:45.000000', 'temperatura', 488.0000, 'ºC'),
	(257590, 121, '2014-03-15 01:02:46.000000', 'temperatura', 1135.0000, 'ºC'),
	(257591, 121, '2014-03-15 01:02:47.000000', 'temperatura', 611.0000, 'ºC'),
	(257592, 121, '2014-03-15 01:02:48.000000', 'temperatura', 851.0000, 'ºC'),
	(257593, 121, '2014-03-15 01:02:49.000000', 'temperatura', 20.0000, 'ºC'),
	(257594, 121, '2014-03-15 01:02:50.000000', 'temperatura', 1150.0000, 'ºC'),
	(257595, 121, '2014-03-15 01:02:51.000000', 'temperatura', 889.0000, 'ºC'),
	(257596, 121, '2014-03-15 01:02:52.000000', 'temperatura', 995.0000, 'ºC'),
	(257597, 121, '2014-03-15 01:02:53.000000', 'temperatura', 1110.0000, 'ºC'),
	(257598, 121, '2014-03-15 01:02:54.000000', 'temperatura', 165.0000, 'ºC'),
	(257599, 121, '2014-03-15 01:02:55.000000', 'temperatura', 1094.0000, 'ºC'),
	(257600, 121, '2014-03-15 01:02:56.000000', 'temperatura', 177.0000, 'ºC'),
	(257601, 121, '2014-03-15 01:02:57.000000', 'temperatura', 1.0000, 'ºC'),
	(257602, 121, '2014-03-15 01:02:58.000000', 'temperatura', 677.0000, 'ºC'),
	(257603, 121, '2014-03-15 01:02:59.000000', 'temperatura', 980.0000, 'ºC'),
	(257604, 121, '2014-03-15 01:03:00.000000', 'temperatura', 472.0000, 'ºC'),
	(257605, 121, '2014-03-15 01:03:01.000000', 'temperatura', 619.0000, 'ºC'),
	(257606, 121, '2014-03-15 01:03:02.000000', 'temperatura', 481.0000, 'ºC'),
	(257607, 121, '2014-03-15 01:03:03.000000', 'temperatura', 546.0000, 'ºC'),
	(257608, 121, '2014-03-15 01:03:04.000000', 'temperatura', 89.0000, 'ºC'),
	(257609, 121, '2014-03-15 01:03:05.000000', 'temperatura', 8.0000, 'ºC'),
	(257610, 121, '2014-03-15 01:03:06.000000', 'temperatura', 975.0000, 'ºC'),
	(257611, 121, '2014-03-15 01:03:07.000000', 'temperatura', 50.0000, 'ºC'),
	(257612, 121, '2014-03-15 01:03:08.000000', 'temperatura', 927.0000, 'ºC'),
	(257613, 121, '2014-03-15 01:03:09.000000', 'temperatura', 885.0000, 'ºC'),
	(257614, 121, '2014-03-15 01:03:10.000000', 'temperatura', 445.0000, 'ºC'),
	(257615, 121, '2014-03-15 01:03:11.000000', 'temperatura', 768.0000, 'ºC'),
	(257616, 121, '2014-03-15 01:03:12.000000', 'temperatura', 108.0000, 'ºC'),
	(257617, 121, '2014-03-15 01:03:13.000000', 'temperatura', 637.0000, 'ºC'),
	(257618, 121, '2014-03-15 01:03:14.000000', 'temperatura', 462.0000, 'ºC'),
	(257619, 121, '2014-03-15 01:03:15.000000', 'temperatura', 397.0000, 'ºC'),
	(257620, 121, '2014-03-15 01:03:16.000000', 'temperatura', 600.0000, 'ºC'),
	(257621, 121, '2014-03-15 01:03:17.000000', 'temperatura', 611.0000, 'ºC'),
	(257622, 121, '2014-03-15 01:03:18.000000', 'temperatura', 55.0000, 'ºC'),
	(257623, 121, '2014-03-15 01:03:19.000000', 'temperatura', 844.0000, 'ºC'),
	(257624, 121, '2014-03-15 01:03:20.000000', 'temperatura', 454.0000, 'ºC'),
	(257625, 121, '2014-03-15 01:03:21.000000', 'temperatura', 938.0000, 'ºC'),
	(257626, 121, '2014-03-15 01:03:22.000000', 'temperatura', 930.0000, 'ºC'),
	(257627, 121, '2014-03-15 01:03:23.000000', 'temperatura', 635.0000, 'ºC'),
	(257628, 121, '2014-03-15 01:03:24.000000', 'temperatura', 386.0000, 'ºC'),
	(257629, 121, '2014-03-15 01:03:25.000000', 'temperatura', 24.0000, 'ºC'),
	(257630, 121, '2014-03-15 01:03:26.000000', 'temperatura', 165.0000, 'ºC'),
	(257631, 121, '2014-03-15 01:03:27.000000', 'temperatura', 753.0000, 'ºC'),
	(257632, 121, '2014-03-15 01:03:28.000000', 'temperatura', 872.0000, 'ºC'),
	(257633, 121, '2014-03-15 01:03:29.000000', 'temperatura', 900.0000, 'ºC'),
	(257634, 121, '2014-03-15 01:03:30.000000', 'temperatura', 685.0000, 'ºC'),
	(257635, 121, '2014-03-15 01:03:31.000000', 'temperatura', 723.0000, 'ºC'),
	(257636, 122, '2014-03-15 00:00:00.000000', 'temperatura', 849.0000, 'ºC'),
	(257637, 122, '2014-03-15 00:00:01.000000', 'temperatura', 752.0000, 'ºC'),
	(257638, 122, '2014-03-15 00:00:02.000000', 'temperatura', 17.0000, 'ºC'),
	(257639, 122, '2014-03-15 00:00:03.000000', 'temperatura', 226.0000, 'ºC'),
	(257640, 122, '2014-03-15 00:00:04.000000', 'temperatura', 1082.0000, 'ºC'),
	(257641, 122, '2014-03-15 00:00:05.000000', 'temperatura', 1133.0000, 'ºC'),
	(257642, 122, '2014-03-15 00:00:06.000000', 'temperatura', 19.0000, 'ºC'),
	(257643, 122, '2014-03-15 00:00:07.000000', 'temperatura', 296.0000, 'ºC'),
	(257644, 122, '2014-03-15 00:00:08.000000', 'temperatura', 224.0000, 'ºC'),
	(257645, 122, '2014-03-15 00:00:09.000000', 'temperatura', 233.0000, 'ºC'),
	(257646, 122, '2014-03-15 00:00:10.000000', 'temperatura', 492.0000, 'ºC'),
	(257647, 122, '2014-03-15 00:00:11.000000', 'temperatura', 563.0000, 'ºC'),
	(257648, 122, '2014-03-15 00:00:12.000000', 'temperatura', 140.0000, 'ºC'),
	(257649, 122, '2014-03-15 00:00:13.000000', 'temperatura', 213.0000, 'ºC'),
	(257650, 122, '2014-03-15 00:00:14.000000', 'temperatura', 643.0000, 'ºC'),
	(257651, 122, '2014-03-15 00:00:15.000000', 'temperatura', 175.0000, 'ºC'),
	(257652, 122, '2014-03-15 00:00:16.000000', 'temperatura', 148.0000, 'ºC'),
	(257653, 122, '2014-03-15 00:00:17.000000', 'temperatura', 217.0000, 'ºC'),
	(257654, 122, '2014-03-15 00:00:18.000000', 'temperatura', 642.0000, 'ºC'),
	(257655, 122, '2014-03-15 00:00:19.000000', 'temperatura', 159.0000, 'ºC'),
	(257656, 122, '2014-03-15 00:00:20.000000', 'temperatura', 71.0000, 'ºC'),
	(257657, 122, '2014-03-15 00:00:21.000000', 'temperatura', 1076.0000, 'ºC'),
	(257658, 122, '2014-03-15 00:00:22.000000', 'temperatura', 369.0000, 'ºC'),
	(257659, 122, '2014-03-15 00:00:23.000000', 'temperatura', 1015.0000, 'ºC'),
	(257660, 122, '2014-03-15 00:00:24.000000', 'temperatura', 371.0000, 'ºC'),
	(257661, 122, '2014-03-15 00:00:25.000000', 'temperatura', 8.0000, 'ºC'),
	(257662, 122, '2014-03-15 00:00:26.000000', 'temperatura', 130.0000, 'ºC'),
	(257663, 122, '2014-03-15 00:00:27.000000', 'temperatura', 626.0000, 'ºC'),
	(257664, 122, '2014-03-15 00:00:28.000000', 'temperatura', 341.0000, 'ºC'),
	(257665, 122, '2014-03-15 00:00:29.000000', 'temperatura', 1028.0000, 'ºC'),
	(257666, 122, '2014-03-15 00:00:30.000000', 'temperatura', 517.0000, 'ºC'),
	(257667, 122, '2014-03-15 00:00:31.000000', 'temperatura', 700.0000, 'ºC'),
	(257668, 122, '2014-03-15 00:00:32.000000', 'temperatura', 750.0000, 'ºC'),
	(257669, 122, '2014-03-15 00:00:33.000000', 'temperatura', 452.0000, 'ºC'),
	(257670, 122, '2014-03-15 00:00:34.000000', 'temperatura', 8.0000, 'ºC'),
	(257671, 122, '2014-03-15 00:00:35.000000', 'temperatura', 1085.0000, 'ºC'),
	(257672, 122, '2014-03-15 00:00:36.000000', 'temperatura', 601.0000, 'ºC'),
	(257673, 122, '2014-03-15 00:00:37.000000', 'temperatura', 949.0000, 'ºC'),
	(257674, 122, '2014-03-15 00:00:38.000000', 'temperatura', 544.0000, 'ºC'),
	(257675, 122, '2014-03-15 00:00:39.000000', 'temperatura', 1075.0000, 'ºC'),
	(257676, 122, '2014-03-15 00:00:40.000000', 'temperatura', 143.0000, 'ºC'),
	(257677, 122, '2014-03-15 00:00:41.000000', 'temperatura', 1089.0000, 'ºC'),
	(257678, 122, '2014-03-15 00:00:42.000000', 'temperatura', 216.0000, 'ºC'),
	(257679, 122, '2014-03-15 00:00:43.000000', 'temperatura', 212.0000, 'ºC'),
	(257680, 122, '2014-03-15 00:00:44.000000', 'temperatura', 416.0000, 'ºC'),
	(257681, 122, '2014-03-15 00:00:45.000000', 'temperatura', 243.0000, 'ºC'),
	(257682, 122, '2014-03-15 00:00:46.000000', 'temperatura', 1166.0000, 'ºC'),
	(257683, 122, '2014-03-15 00:00:47.000000', 'temperatura', 302.0000, 'ºC'),
	(257684, 122, '2014-03-15 00:00:48.000000', 'temperatura', 411.0000, 'ºC'),
	(257685, 122, '2014-03-15 00:00:49.000000', 'temperatura', 1152.0000, 'ºC'),
	(257686, 122, '2014-03-15 00:00:50.000000', 'temperatura', 926.0000, 'ºC'),
	(257687, 122, '2014-03-15 00:00:51.000000', 'temperatura', 1176.0000, 'ºC'),
	(257688, 122, '2014-03-15 00:00:52.000000', 'temperatura', 701.0000, 'ºC'),
	(257689, 122, '2014-03-15 00:00:53.000000', 'temperatura', 1176.0000, 'ºC'),
	(257690, 122, '2014-03-15 00:00:54.000000', 'temperatura', 179.0000, 'ºC'),
	(257691, 122, '2014-03-15 00:00:55.000000', 'temperatura', 966.0000, 'ºC'),
	(257692, 122, '2014-03-15 00:00:56.000000', 'temperatura', 694.0000, 'ºC'),
	(257693, 122, '2014-03-15 00:00:57.000000', 'temperatura', 571.0000, 'ºC'),
	(257694, 122, '2014-03-15 00:00:58.000000', 'temperatura', 776.0000, 'ºC'),
	(257695, 122, '2014-03-15 00:00:59.000000', 'temperatura', 966.0000, 'ºC'),
	(257696, 122, '2014-03-15 00:01:00.000000', 'temperatura', 104.0000, 'ºC'),
	(257697, 122, '2014-03-15 00:01:01.000000', 'temperatura', 21.0000, 'ºC'),
	(257698, 122, '2014-03-15 00:01:02.000000', 'temperatura', 995.0000, 'ºC'),
	(257699, 122, '2014-03-15 00:01:03.000000', 'temperatura', 114.0000, 'ºC'),
	(257700, 122, '2014-03-15 00:01:04.000000', 'temperatura', 1183.0000, 'ºC'),
	(257701, 122, '2014-03-15 00:01:05.000000', 'temperatura', 776.0000, 'ºC'),
	(257702, 122, '2014-03-15 00:01:06.000000', 'temperatura', 328.0000, 'ºC'),
	(257703, 122, '2014-03-15 00:01:07.000000', 'temperatura', 515.0000, 'ºC'),
	(257704, 122, '2014-03-15 00:01:08.000000', 'temperatura', 390.0000, 'ºC'),
	(257705, 122, '2014-03-15 00:01:09.000000', 'temperatura', 407.0000, 'ºC'),
	(257706, 122, '2014-03-15 00:01:10.000000', 'temperatura', 863.0000, 'ºC'),
	(257707, 122, '2014-03-15 00:01:11.000000', 'temperatura', 697.0000, 'ºC'),
	(257708, 122, '2014-03-15 00:01:12.000000', 'temperatura', 896.0000, 'ºC'),
	(257709, 122, '2014-03-15 00:01:13.000000', 'temperatura', 1189.0000, 'ºC'),
	(257710, 122, '2014-03-15 00:01:14.000000', 'temperatura', 859.0000, 'ºC'),
	(257711, 122, '2014-03-15 00:01:15.000000', 'temperatura', 727.0000, 'ºC'),
	(257712, 122, '2014-03-15 00:01:16.000000', 'temperatura', 1058.0000, 'ºC'),
	(257713, 122, '2014-03-15 00:01:17.000000', 'temperatura', 711.0000, 'ºC'),
	(257714, 122, '2014-03-15 00:01:18.000000', 'temperatura', 381.0000, 'ºC'),
	(257715, 122, '2014-03-15 00:01:19.000000', 'temperatura', 973.0000, 'ºC'),
	(257716, 122, '2014-03-15 00:01:20.000000', 'temperatura', 121.0000, 'ºC'),
	(257717, 122, '2014-03-15 00:01:21.000000', 'temperatura', 89.0000, 'ºC'),
	(257718, 122, '2014-03-15 00:01:22.000000', 'temperatura', 79.0000, 'ºC'),
	(257719, 122, '2014-03-15 00:01:23.000000', 'temperatura', 131.0000, 'ºC'),
	(257720, 122, '2014-03-15 00:01:24.000000', 'temperatura', 418.0000, 'ºC'),
	(257721, 122, '2014-03-15 00:01:25.000000', 'temperatura', 496.0000, 'ºC'),
	(257722, 122, '2014-03-15 00:01:26.000000', 'temperatura', 25.0000, 'ºC'),
	(257723, 122, '2014-03-15 00:01:27.000000', 'temperatura', 1041.0000, 'ºC'),
	(257724, 122, '2014-03-15 00:01:28.000000', 'temperatura', 328.0000, 'ºC'),
	(257725, 122, '2014-03-15 00:01:29.000000', 'temperatura', 918.0000, 'ºC'),
	(257726, 122, '2014-03-15 00:01:30.000000', 'temperatura', 8.0000, 'ºC'),
	(257727, 122, '2014-03-15 00:01:31.000000', 'temperatura', 888.0000, 'ºC'),
	(257728, 122, '2014-03-15 00:01:32.000000', 'temperatura', 814.0000, 'ºC'),
	(257729, 122, '2014-03-15 00:01:33.000000', 'temperatura', 207.0000, 'ºC'),
	(257730, 122, '2014-03-15 00:01:34.000000', 'temperatura', 993.0000, 'ºC'),
	(257731, 122, '2014-03-15 00:01:35.000000', 'temperatura', 746.0000, 'ºC'),
	(257732, 122, '2014-03-15 00:01:36.000000', 'temperatura', 749.0000, 'ºC'),
	(257733, 122, '2014-03-15 00:01:37.000000', 'temperatura', 309.0000, 'ºC'),
	(257734, 122, '2014-03-15 00:01:38.000000', 'temperatura', 500.0000, 'ºC'),
	(257735, 122, '2014-03-15 00:01:39.000000', 'temperatura', 371.0000, 'ºC'),
	(257736, 122, '2014-03-15 00:01:40.000000', 'temperatura', 357.0000, 'ºC'),
	(257737, 122, '2014-03-15 00:01:41.000000', 'temperatura', 673.0000, 'ºC'),
	(257738, 122, '2014-03-15 00:01:42.000000', 'temperatura', 1093.0000, 'ºC'),
	(257739, 122, '2014-03-15 00:01:43.000000', 'temperatura', 1047.0000, 'ºC'),
	(257740, 122, '2014-03-15 00:01:44.000000', 'temperatura', 755.0000, 'ºC'),
	(257741, 122, '2014-03-15 00:01:45.000000', 'temperatura', 637.0000, 'ºC'),
	(257742, 122, '2014-03-15 00:01:46.000000', 'temperatura', 920.0000, 'ºC'),
	(257743, 122, '2014-03-15 00:01:47.000000', 'temperatura', 291.0000, 'ºC'),
	(257744, 122, '2014-03-15 00:01:48.000000', 'temperatura', 1094.0000, 'ºC'),
	(257745, 122, '2014-03-15 00:01:49.000000', 'temperatura', 997.0000, 'ºC'),
	(257746, 122, '2014-03-15 00:01:50.000000', 'temperatura', 503.0000, 'ºC'),
	(257747, 122, '2014-03-15 00:01:51.000000', 'temperatura', 724.0000, 'ºC'),
	(257748, 122, '2014-03-15 00:01:52.000000', 'temperatura', 912.0000, 'ºC'),
	(257749, 122, '2014-03-15 00:01:53.000000', 'temperatura', 1187.0000, 'ºC'),
	(257750, 122, '2014-03-15 00:01:54.000000', 'temperatura', 801.0000, 'ºC'),
	(257751, 122, '2014-03-15 00:01:55.000000', 'temperatura', 445.0000, 'ºC'),
	(257752, 122, '2014-03-15 00:01:56.000000', 'temperatura', 1020.0000, 'ºC'),
	(257753, 122, '2014-03-15 00:01:57.000000', 'temperatura', 168.0000, 'ºC'),
	(257754, 122, '2014-03-15 00:01:58.000000', 'temperatura', 181.0000, 'ºC'),
	(257755, 122, '2014-03-15 00:01:59.000000', 'temperatura', 399.0000, 'ºC'),
	(257756, 122, '2014-03-15 00:02:00.000000', 'temperatura', 254.0000, 'ºC'),
	(257757, 122, '2014-03-15 00:02:01.000000', 'temperatura', 73.0000, 'ºC'),
	(257758, 122, '2014-03-15 00:02:02.000000', 'temperatura', 805.0000, 'ºC'),
	(257759, 122, '2014-03-15 00:02:03.000000', 'temperatura', 208.0000, 'ºC'),
	(257760, 122, '2014-03-15 00:02:04.000000', 'temperatura', 1022.0000, 'ºC'),
	(257761, 122, '2014-03-15 00:02:05.000000', 'temperatura', 886.0000, 'ºC'),
	(257762, 122, '2014-03-15 00:02:06.000000', 'temperatura', 168.0000, 'ºC'),
	(257763, 122, '2014-03-15 00:02:07.000000', 'temperatura', 580.0000, 'ºC'),
	(257764, 122, '2014-03-15 00:02:08.000000', 'temperatura', 1198.0000, 'ºC'),
	(257765, 122, '2014-03-15 00:02:09.000000', 'temperatura', 649.0000, 'ºC'),
	(257766, 122, '2014-03-15 00:02:10.000000', 'temperatura', 853.0000, 'ºC'),
	(257767, 122, '2014-03-15 00:02:11.000000', 'temperatura', 1120.0000, 'ºC'),
	(257768, 122, '2014-03-15 00:02:12.000000', 'temperatura', 640.0000, 'ºC'),
	(257769, 122, '2014-03-15 00:02:13.000000', 'temperatura', 1040.0000, 'ºC'),
	(257770, 122, '2014-03-15 00:02:14.000000', 'temperatura', 882.0000, 'ºC'),
	(257771, 122, '2014-03-15 00:02:15.000000', 'temperatura', 91.0000, 'ºC'),
	(257772, 122, '2014-03-15 00:02:16.000000', 'temperatura', 208.0000, 'ºC'),
	(257773, 122, '2014-03-15 00:02:17.000000', 'temperatura', 768.0000, 'ºC'),
	(257774, 122, '2014-03-15 00:02:18.000000', 'temperatura', 815.0000, 'ºC'),
	(257775, 122, '2014-03-15 00:02:19.000000', 'temperatura', 571.0000, 'ºC'),
	(257776, 122, '2014-03-15 00:02:20.000000', 'temperatura', 413.0000, 'ºC'),
	(257777, 122, '2014-03-15 00:02:21.000000', 'temperatura', 353.0000, 'ºC'),
	(257778, 122, '2014-03-15 00:02:22.000000', 'temperatura', 525.0000, 'ºC'),
	(257779, 122, '2014-03-15 00:02:23.000000', 'temperatura', 367.0000, 'ºC'),
	(257780, 122, '2014-03-15 00:02:24.000000', 'temperatura', 259.0000, 'ºC'),
	(257781, 122, '2014-03-15 00:02:25.000000', 'temperatura', 196.0000, 'ºC'),
	(257782, 122, '2014-03-15 00:02:26.000000', 'temperatura', 202.0000, 'ºC'),
	(257783, 122, '2014-03-15 00:02:27.000000', 'temperatura', 425.0000, 'ºC'),
	(257784, 122, '2014-03-15 00:02:28.000000', 'temperatura', 317.0000, 'ºC'),
	(257785, 122, '2014-03-15 00:02:29.000000', 'temperatura', 311.0000, 'ºC'),
	(257786, 122, '2014-03-15 00:02:30.000000', 'temperatura', 606.0000, 'ºC'),
	(257787, 122, '2014-03-15 00:02:31.000000', 'temperatura', 895.0000, 'ºC'),
	(257788, 122, '2014-03-15 00:02:32.000000', 'temperatura', 260.0000, 'ºC'),
	(257789, 122, '2014-03-15 00:02:33.000000', 'temperatura', 1016.0000, 'ºC'),
	(257790, 122, '2014-03-15 00:02:34.000000', 'temperatura', 702.0000, 'ºC'),
	(257791, 122, '2014-03-15 00:02:35.000000', 'temperatura', 459.0000, 'ºC'),
	(257792, 122, '2014-03-15 00:02:36.000000', 'temperatura', 190.0000, 'ºC'),
	(257793, 122, '2014-03-15 00:02:37.000000', 'temperatura', 774.0000, 'ºC'),
	(257794, 122, '2014-03-15 00:02:38.000000', 'temperatura', 903.0000, 'ºC'),
	(257795, 122, '2014-03-15 00:02:39.000000', 'temperatura', 990.0000, 'ºC'),
	(257796, 122, '2014-03-15 00:02:40.000000', 'temperatura', 1042.0000, 'ºC'),
	(257797, 122, '2014-03-15 00:02:41.000000', 'temperatura', 1043.0000, 'ºC'),
	(257798, 122, '2014-03-15 00:02:42.000000', 'temperatura', 889.0000, 'ºC'),
	(257799, 122, '2014-03-15 00:02:43.000000', 'temperatura', 115.0000, 'ºC'),
	(257800, 122, '2014-03-15 00:02:44.000000', 'temperatura', 307.0000, 'ºC'),
	(257801, 122, '2014-03-15 00:02:45.000000', 'temperatura', 1194.0000, 'ºC'),
	(257802, 122, '2014-03-15 00:02:46.000000', 'temperatura', 246.0000, 'ºC'),
	(257803, 122, '2014-03-15 00:02:47.000000', 'temperatura', 52.0000, 'ºC'),
	(257804, 122, '2014-03-15 00:02:48.000000', 'temperatura', 719.0000, 'ºC'),
	(257805, 122, '2014-03-15 00:02:49.000000', 'temperatura', 1042.0000, 'ºC'),
	(257806, 122, '2014-03-15 00:02:50.000000', 'temperatura', 654.0000, 'ºC'),
	(257807, 122, '2014-03-15 00:02:51.000000', 'temperatura', 143.0000, 'ºC'),
	(257808, 122, '2014-03-15 00:02:52.000000', 'temperatura', 1154.0000, 'ºC'),
	(257809, 122, '2014-03-15 00:02:53.000000', 'temperatura', 543.0000, 'ºC'),
	(257810, 122, '2014-03-15 00:02:54.000000', 'temperatura', 452.0000, 'ºC'),
	(257811, 122, '2014-03-15 00:02:55.000000', 'temperatura', 630.0000, 'ºC'),
	(257812, 122, '2014-03-15 00:02:56.000000', 'temperatura', 594.0000, 'ºC'),
	(257813, 122, '2014-03-15 00:02:57.000000', 'temperatura', 1083.0000, 'ºC'),
	(257814, 122, '2014-03-15 00:02:58.000000', 'temperatura', 33.0000, 'ºC'),
	(257815, 122, '2014-03-15 00:02:59.000000', 'temperatura', 515.0000, 'ºC'),
	(257816, 122, '2014-03-15 00:03:00.000000', 'temperatura', 76.0000, 'ºC'),
	(257817, 122, '2014-03-15 00:03:01.000000', 'temperatura', 36.0000, 'ºC'),
	(257818, 122, '2014-03-15 00:03:02.000000', 'temperatura', 1155.0000, 'ºC'),
	(257819, 122, '2014-03-15 00:03:03.000000', 'temperatura', 865.0000, 'ºC'),
	(257820, 122, '2014-03-15 00:03:04.000000', 'temperatura', 862.0000, 'ºC'),
	(257821, 122, '2014-03-15 00:03:05.000000', 'temperatura', 516.0000, 'ºC'),
	(257822, 122, '2014-03-15 00:03:06.000000', 'temperatura', 1194.0000, 'ºC'),
	(257823, 122, '2014-03-15 00:03:07.000000', 'temperatura', 821.0000, 'ºC'),
	(257824, 122, '2014-03-15 00:03:08.000000', 'temperatura', 525.0000, 'ºC'),
	(257825, 122, '2014-03-15 00:03:09.000000', 'temperatura', 163.0000, 'ºC'),
	(257826, 122, '2014-03-15 00:03:10.000000', 'temperatura', 440.0000, 'ºC'),
	(257827, 122, '2014-03-15 00:03:11.000000', 'temperatura', 512.0000, 'ºC'),
	(257828, 122, '2014-03-15 00:03:12.000000', 'temperatura', 41.0000, 'ºC'),
	(257829, 122, '2014-03-15 00:03:13.000000', 'temperatura', 1068.0000, 'ºC'),
	(257830, 122, '2014-03-15 00:03:14.000000', 'temperatura', 419.0000, 'ºC'),
	(257831, 122, '2014-03-15 00:03:15.000000', 'temperatura', 92.0000, 'ºC'),
	(257832, 122, '2014-03-15 00:03:16.000000', 'temperatura', 404.0000, 'ºC'),
	(257833, 122, '2014-03-15 00:03:17.000000', 'temperatura', 543.0000, 'ºC'),
	(257834, 122, '2014-03-15 00:03:18.000000', 'temperatura', 305.0000, 'ºC'),
	(257835, 122, '2014-03-15 00:03:19.000000', 'temperatura', 1096.0000, 'ºC'),
	(257836, 122, '2014-03-15 00:03:20.000000', 'temperatura', 967.0000, 'ºC'),
	(257837, 122, '2014-03-15 00:03:21.000000', 'temperatura', 346.0000, 'ºC'),
	(257838, 122, '2014-03-15 00:03:22.000000', 'temperatura', 29.0000, 'ºC'),
	(257839, 122, '2014-03-15 00:03:23.000000', 'temperatura', 309.0000, 'ºC'),
	(257840, 122, '2014-03-15 00:03:24.000000', 'temperatura', 256.0000, 'ºC'),
	(257841, 122, '2014-03-15 00:03:25.000000', 'temperatura', 354.0000, 'ºC'),
	(257842, 122, '2014-03-15 00:03:26.000000', 'temperatura', 1003.0000, 'ºC'),
	(257843, 122, '2014-03-15 00:03:27.000000', 'temperatura', 355.0000, 'ºC'),
	(257844, 122, '2014-03-15 00:03:28.000000', 'temperatura', 1167.0000, 'ºC'),
	(257845, 122, '2014-03-15 00:03:29.000000', 'temperatura', 1168.0000, 'ºC'),
	(257846, 122, '2014-03-15 00:03:30.000000', 'temperatura', 1140.0000, 'ºC'),
	(257847, 122, '2014-03-15 00:03:31.000000', 'temperatura', 997.0000, 'ºC'),
	(257848, 122, '2014-03-15 00:03:32.000000', 'temperatura', 367.0000, 'ºC'),
	(257849, 122, '2014-03-15 00:03:33.000000', 'temperatura', 44.0000, 'ºC'),
	(257850, 122, '2014-03-15 00:03:34.000000', 'temperatura', 318.0000, 'ºC'),
	(257851, 122, '2014-03-15 00:03:35.000000', 'temperatura', 260.0000, 'ºC'),
	(257852, 122, '2014-03-15 00:03:36.000000', 'temperatura', 347.0000, 'ºC'),
	(257853, 122, '2014-03-15 00:03:37.000000', 'temperatura', 956.0000, 'ºC'),
	(257854, 122, '2014-03-15 00:03:38.000000', 'temperatura', 140.0000, 'ºC'),
	(257855, 122, '2014-03-15 00:03:39.000000', 'temperatura', 230.0000, 'ºC'),
	(257856, 122, '2014-03-15 00:03:40.000000', 'temperatura', 732.0000, 'ºC'),
	(257857, 122, '2014-03-15 00:03:41.000000', 'temperatura', 569.0000, 'ºC'),
	(257858, 122, '2014-03-15 00:03:42.000000', 'temperatura', 650.0000, 'ºC'),
	(257859, 122, '2014-03-15 00:03:43.000000', 'temperatura', 343.0000, 'ºC'),
	(257860, 122, '2014-03-15 00:03:44.000000', 'temperatura', 965.0000, 'ºC'),
	(257861, 122, '2014-03-15 00:03:45.000000', 'temperatura', 196.0000, 'ºC'),
	(257862, 122, '2014-03-15 00:03:46.000000', 'temperatura', 487.0000, 'ºC'),
	(257863, 122, '2014-03-15 00:03:47.000000', 'temperatura', 645.0000, 'ºC'),
	(257864, 122, '2014-03-15 00:03:48.000000', 'temperatura', 567.0000, 'ºC'),
	(257865, 122, '2014-03-15 00:03:49.000000', 'temperatura', 898.0000, 'ºC'),
	(257866, 122, '2014-03-15 00:03:50.000000', 'temperatura', 390.0000, 'ºC'),
	(257867, 122, '2014-03-15 00:03:51.000000', 'temperatura', 457.0000, 'ºC'),
	(257868, 122, '2014-03-15 00:03:52.000000', 'temperatura', 1115.0000, 'ºC'),
	(257869, 122, '2014-03-15 00:03:53.000000', 'temperatura', 603.0000, 'ºC'),
	(257870, 122, '2014-03-15 00:03:54.000000', 'temperatura', 873.0000, 'ºC'),
	(257871, 122, '2014-03-15 00:03:55.000000', 'temperatura', 155.0000, 'ºC'),
	(257872, 122, '2014-03-15 00:03:56.000000', 'temperatura', 557.0000, 'ºC'),
	(257873, 122, '2014-03-15 00:03:57.000000', 'temperatura', 1119.0000, 'ºC'),
	(257874, 122, '2014-03-15 00:03:58.000000', 'temperatura', 327.0000, 'ºC'),
	(257875, 122, '2014-03-15 00:03:59.000000', 'temperatura', 676.0000, 'ºC'),
	(257876, 122, '2014-03-15 00:04:00.000000', 'temperatura', 1.0000, 'ºC'),
	(257877, 122, '2014-03-15 00:04:01.000000', 'temperatura', 379.0000, 'ºC'),
	(257878, 122, '2014-03-15 00:04:02.000000', 'temperatura', 692.0000, 'ºC'),
	(257879, 122, '2014-03-15 00:04:03.000000', 'temperatura', 1122.0000, 'ºC'),
	(257880, 122, '2014-03-15 00:04:04.000000', 'temperatura', 1136.0000, 'ºC'),
	(257881, 122, '2014-03-15 00:04:05.000000', 'temperatura', 1116.0000, 'ºC'),
	(257882, 122, '2014-03-15 00:04:06.000000', 'temperatura', 969.0000, 'ºC'),
	(257883, 122, '2014-03-15 00:04:07.000000', 'temperatura', 300.0000, 'ºC'),
	(257884, 122, '2014-03-15 00:04:08.000000', 'temperatura', 994.0000, 'ºC'),
	(257885, 122, '2014-03-15 00:04:09.000000', 'temperatura', 470.0000, 'ºC'),
	(257886, 122, '2014-03-15 00:04:10.000000', 'temperatura', 567.0000, 'ºC'),
	(257887, 122, '2014-03-15 00:04:11.000000', 'temperatura', 228.0000, 'ºC'),
	(257888, 122, '2014-03-15 00:04:12.000000', 'temperatura', 640.0000, 'ºC'),
	(257889, 122, '2014-03-15 00:04:13.000000', 'temperatura', 115.0000, 'ºC'),
	(257890, 122, '2014-03-15 00:04:14.000000', 'temperatura', 1055.0000, 'ºC'),
	(257891, 122, '2014-03-15 00:04:15.000000', 'temperatura', 129.0000, 'ºC'),
	(257892, 122, '2014-03-15 00:04:16.000000', 'temperatura', 1083.0000, 'ºC'),
	(257893, 122, '2014-03-15 00:04:17.000000', 'temperatura', 227.0000, 'ºC'),
	(257894, 122, '2014-03-15 00:04:18.000000', 'temperatura', 286.0000, 'ºC'),
	(257895, 122, '2014-03-15 00:04:19.000000', 'temperatura', 751.0000, 'ºC'),
	(257896, 122, '2014-03-15 00:04:20.000000', 'temperatura', 495.0000, 'ºC'),
	(257897, 122, '2014-03-15 00:04:21.000000', 'temperatura', 225.0000, 'ºC'),
	(257898, 122, '2014-03-15 00:04:22.000000', 'temperatura', 839.0000, 'ºC'),
	(257899, 122, '2014-03-15 00:04:23.000000', 'temperatura', 1122.0000, 'ºC'),
	(257900, 122, '2014-03-15 00:04:24.000000', 'temperatura', 692.0000, 'ºC'),
	(257901, 122, '2014-03-15 00:04:25.000000', 'temperatura', 96.0000, 'ºC'),
	(257902, 122, '2014-03-15 00:04:26.000000', 'temperatura', 804.0000, 'ºC'),
	(257903, 122, '2014-03-15 00:04:27.000000', 'temperatura', 134.0000, 'ºC'),
	(257904, 122, '2014-03-15 00:04:28.000000', 'temperatura', 659.0000, 'ºC'),
	(257905, 122, '2014-03-15 00:04:29.000000', 'temperatura', 490.0000, 'ºC'),
	(257906, 122, '2014-03-15 00:04:30.000000', 'temperatura', 476.0000, 'ºC'),
	(257907, 122, '2014-03-15 00:04:31.000000', 'temperatura', 912.0000, 'ºC'),
	(257908, 122, '2014-03-15 00:04:32.000000', 'temperatura', 731.0000, 'ºC'),
	(257909, 122, '2014-03-15 00:04:33.000000', 'temperatura', 920.0000, 'ºC'),
	(257910, 122, '2014-03-15 00:04:34.000000', 'temperatura', 7.0000, 'ºC'),
	(257911, 122, '2014-03-15 00:04:35.000000', 'temperatura', 876.0000, 'ºC'),
	(257912, 122, '2014-03-15 00:04:36.000000', 'temperatura', 760.0000, 'ºC'),
	(257913, 122, '2014-03-15 00:04:37.000000', 'temperatura', 1171.0000, 'ºC'),
	(257914, 122, '2014-03-15 00:04:38.000000', 'temperatura', 1178.0000, 'ºC'),
	(257915, 122, '2014-03-15 00:04:39.000000', 'temperatura', 1175.0000, 'ºC'),
	(257916, 122, '2014-03-15 00:04:40.000000', 'temperatura', 1143.0000, 'ºC'),
	(257917, 122, '2014-03-15 00:04:41.000000', 'temperatura', 989.0000, 'ºC'),
	(257918, 122, '2014-03-15 00:04:42.000000', 'temperatura', 316.0000, 'ºC'),
	(257919, 122, '2014-03-15 00:04:43.000000', 'temperatura', 1015.0000, 'ºC'),
	(257920, 122, '2014-03-15 00:04:44.000000', 'temperatura', 527.0000, 'ºC'),
	(257921, 122, '2014-03-15 00:04:45.000000', 'temperatura', 790.0000, 'ºC'),
	(257922, 122, '2014-03-15 00:04:46.000000', 'temperatura', 1172.0000, 'ºC'),
	(257923, 122, '2014-03-15 00:04:47.000000', 'temperatura', 1088.0000, 'ºC'),
	(257924, 122, '2014-03-15 00:04:48.000000', 'temperatura', 723.0000, 'ºC'),
	(257925, 122, '2014-03-15 00:04:49.000000', 'temperatura', 355.0000, 'ºC'),
	(257926, 122, '2014-03-15 00:04:50.000000', 'temperatura', 804.0000, 'ºC'),
	(257927, 122, '2014-03-15 00:04:51.000000', 'temperatura', 556.0000, 'ºC'),
	(257928, 122, '2014-03-15 00:04:52.000000', 'temperatura', 368.0000, 'ºC'),
	(257929, 122, '2014-03-15 00:04:53.000000', 'temperatura', 171.0000, 'ºC'),
	(257930, 122, '2014-03-15 00:04:54.000000', 'temperatura', 954.0000, 'ºC'),
	(257931, 122, '2014-03-15 00:04:55.000000', 'temperatura', 658.0000, 'ºC'),
	(257932, 122, '2014-03-15 00:04:56.000000', 'temperatura', 429.0000, 'ºC'),
	(257933, 122, '2014-03-15 00:04:57.000000', 'temperatura', 173.0000, 'ºC'),
	(257934, 122, '2014-03-15 00:04:58.000000', 'temperatura', 775.0000, 'ºC'),
	(257935, 122, '2014-03-15 00:04:59.000000', 'temperatura', 956.0000, 'ºC'),
	(257936, 122, '2014-03-15 00:05:00.000000', 'temperatura', 57.0000, 'ºC'),
	(257937, 122, '2014-03-15 00:05:01.000000', 'temperatura', 1019.0000, 'ºC'),
	(257938, 122, '2014-03-15 00:05:02.000000', 'temperatura', 122.0000, 'ºC'),
	(257939, 122, '2014-03-15 00:05:03.000000', 'temperatura', 1153.0000, 'ºC'),
	(257940, 122, '2014-03-15 00:05:04.000000', 'temperatura', 601.0000, 'ºC'),
	(257941, 122, '2014-03-15 00:05:05.000000', 'temperatura', 748.0000, 'ºC'),
	(257942, 122, '2014-03-15 00:05:06.000000', 'temperatura', 737.0000, 'ºC'),
	(257943, 122, '2014-03-15 00:05:07.000000', 'temperatura', 241.0000, 'ºC'),
	(257944, 122, '2014-03-15 00:05:08.000000', 'temperatura', 196.0000, 'ºC'),
	(257945, 122, '2014-03-15 00:05:09.000000', 'temperatura', 258.0000, 'ºC'),
	(257946, 122, '2014-03-15 00:05:10.000000', 'temperatura', 700.0000, 'ºC'),
	(257947, 122, '2014-03-15 00:05:11.000000', 'temperatura', 326.0000, 'ºC'),
	(257948, 122, '2014-03-15 00:05:12.000000', 'temperatura', 731.0000, 'ºC'),
	(257949, 122, '2014-03-15 00:05:13.000000', 'temperatura', 276.0000, 'ºC'),
	(257950, 122, '2014-03-15 00:05:14.000000', 'temperatura', 389.0000, 'ºC'),
	(257951, 122, '2014-03-15 00:05:15.000000', 'temperatura', 1116.0000, 'ºC'),
	(257952, 122, '2014-03-15 00:05:16.000000', 'temperatura', 813.0000, 'ºC'),
	(257953, 122, '2014-03-15 00:05:17.000000', 'temperatura', 720.0000, 'ºC'),
	(257954, 122, '2014-03-15 00:05:18.000000', 'temperatura', 1160.0000, 'ºC'),
	(257955, 122, '2014-03-15 00:05:19.000000', 'temperatura', 40.0000, 'ºC'),
	(257956, 122, '2014-03-15 00:05:20.000000', 'temperatura', 320.0000, 'ºC'),
	(257957, 122, '2014-03-15 00:05:21.000000', 'temperatura', 282.0000, 'ºC'),
	(257958, 122, '2014-03-15 00:05:22.000000', 'temperatura', 452.0000, 'ºC'),
	(257959, 122, '2014-03-15 00:05:23.000000', 'temperatura', 211.0000, 'ºC'),
	(257960, 122, '2014-03-15 00:05:24.000000', 'temperatura', 901.0000, 'ºC'),
	(257961, 122, '2014-03-15 00:05:25.000000', 'temperatura', 274.0000, 'ºC'),
	(257962, 122, '2014-03-15 00:05:26.000000', 'temperatura', 1068.0000, 'ºC'),
	(257963, 122, '2014-03-15 00:05:27.000000', 'temperatura', 915.0000, 'ºC'),
	(257964, 122, '2014-03-15 00:05:28.000000', 'temperatura', 175.0000, 'ºC'),
	(257965, 122, '2014-03-15 00:05:29.000000', 'temperatura', 528.0000, 'ºC'),
	(257966, 122, '2014-03-15 00:05:30.000000', 'temperatura', 918.0000, 'ºC'),
	(257967, 122, '2014-03-15 00:05:31.000000', 'temperatura', 606.0000, 'ºC'),
	(257968, 122, '2014-03-15 00:05:32.000000', 'temperatura', 275.0000, 'ºC'),
	(257969, 122, '2014-03-15 00:05:33.000000', 'temperatura', 760.0000, 'ºC'),
	(257970, 122, '2014-03-15 00:05:34.000000', 'temperatura', 575.0000, 'ºC'),
	(257971, 122, '2014-03-15 00:05:35.000000', 'temperatura', 597.0000, 'ºC'),
	(257972, 122, '2014-03-15 00:05:36.000000', 'temperatura', 58.0000, 'ºC'),
	(257973, 122, '2014-03-15 00:05:37.000000', 'temperatura', 902.0000, 'ºC'),
	(257974, 122, '2014-03-15 00:05:38.000000', 'temperatura', 734.0000, 'ºC'),
	(257975, 122, '2014-03-15 00:05:39.000000', 'temperatura', 967.0000, 'ºC'),
	(257976, 122, '2014-03-15 00:05:40.000000', 'temperatura', 233.0000, 'ºC'),
	(257977, 122, '2014-03-15 00:05:41.000000', 'temperatura', 663.0000, 'ºC'),
	(257978, 122, '2014-03-15 00:05:42.000000', 'temperatura', 219.0000, 'ºC'),
	(257979, 122, '2014-03-15 00:05:43.000000', 'temperatura', 306.0000, 'ºC'),
	(257980, 122, '2014-03-15 00:05:44.000000', 'temperatura', 875.0000, 'ºC'),
	(257981, 122, '2014-03-15 00:05:45.000000', 'temperatura', 1056.0000, 'ºC'),
	(257982, 122, '2014-03-15 00:05:46.000000', 'temperatura', 254.0000, 'ºC'),
	(257983, 122, '2014-03-15 00:05:47.000000', 'temperatura', 502.0000, 'ºC'),
	(257984, 122, '2014-03-15 00:05:48.000000', 'temperatura', 551.0000, 'ºC'),
	(257985, 122, '2014-03-15 00:05:49.000000', 'temperatura', 47.0000, 'ºC'),
	(257986, 122, '2014-03-15 00:05:50.000000', 'temperatura', 983.0000, 'ºC'),
	(257987, 122, '2014-03-15 00:05:51.000000', 'temperatura', 1177.0000, 'ºC'),
	(257988, 122, '2014-03-15 00:05:52.000000', 'temperatura', 534.0000, 'ºC'),
	(257989, 122, '2014-03-15 00:05:53.000000', 'temperatura', 341.0000, 'ºC'),
	(257990, 122, '2014-03-15 00:05:54.000000', 'temperatura', 101.0000, 'ºC'),
	(257991, 122, '2014-03-15 00:05:55.000000', 'temperatura', 684.0000, 'ºC'),
	(257992, 122, '2014-03-15 00:05:56.000000', 'temperatura', 716.0000, 'ºC'),
	(257993, 122, '2014-03-15 00:05:57.000000', 'temperatura', 328.0000, 'ºC'),
	(257994, 122, '2014-03-15 00:05:58.000000', 'temperatura', 693.0000, 'ºC'),
	(257995, 122, '2014-03-15 00:05:59.000000', 'temperatura', 81.0000, 'ºC'),
	(257996, 122, '2014-03-15 00:06:00.000000', 'temperatura', 726.0000, 'ºC'),
	(257997, 122, '2014-03-15 00:06:01.000000', 'temperatura', 988.0000, 'ºC'),
	(257998, 122, '2014-03-15 00:06:02.000000', 'temperatura', 361.0000, 'ºC'),
	(257999, 122, '2014-03-15 00:06:03.000000', 'temperatura', 44.0000, 'ºC'),
	(258000, 122, '2014-03-15 00:06:04.000000', 'temperatura', 338.0000, 'ºC'),
	(258001, 122, '2014-03-15 00:06:05.000000', 'temperatura', 355.0000, 'ºC'),
	(258002, 122, '2014-03-15 00:06:06.000000', 'temperatura', 765.0000, 'ºC'),
	(258003, 122, '2014-03-15 00:06:07.000000', 'temperatura', 360.0000, 'ºC'),
	(258004, 122, '2014-03-15 00:06:08.000000', 'temperatura', 705.0000, 'ºC'),
	(258005, 122, '2014-03-15 00:06:09.000000', 'temperatura', 48.0000, 'ºC'),
	(258006, 122, '2014-03-15 00:06:10.000000', 'temperatura', 522.0000, 'ºC'),
	(258007, 122, '2014-03-15 00:06:11.000000', 'temperatura', 67.0000, 'ºC'),
	(258008, 122, '2014-03-15 00:06:12.000000', 'temperatura', 1172.0000, 'ºC'),
	(258009, 122, '2014-03-15 00:06:13.000000', 'temperatura', 858.0000, 'ºC'),
	(258010, 122, '2014-03-15 00:06:14.000000', 'temperatura', 773.0000, 'ºC'),
	(258011, 122, '2014-03-15 00:06:15.000000', 'temperatura', 94.0000, 'ºC'),
	(258012, 122, '2014-03-15 00:06:16.000000', 'temperatura', 553.0000, 'ºC'),
	(258013, 122, '2014-03-15 00:06:17.000000', 'temperatura', 80.0000, 'ºC'),
	(258014, 122, '2014-03-15 00:06:18.000000', 'temperatura', 1143.0000, 'ºC'),
	(258015, 122, '2014-03-15 00:06:19.000000', 'temperatura', 675.0000, 'ºC'),
	(258016, 122, '2014-03-15 00:06:20.000000', 'temperatura', 1147.0000, 'ºC'),
	(258017, 122, '2014-03-15 00:06:21.000000', 'temperatura', 111.0000, 'ºC'),
	(258018, 122, '2014-03-15 00:06:22.000000', 'temperatura', 714.0000, 'ºC'),
	(258019, 122, '2014-03-15 00:06:23.000000', 'temperatura', 836.0000, 'ºC'),
	(258020, 122, '2014-03-15 00:06:24.000000', 'temperatura', 839.0000, 'ºC'),
	(258021, 122, '2014-03-15 00:06:25.000000', 'temperatura', 486.0000, 'ºC'),
	(258022, 122, '2014-03-15 00:06:26.000000', 'temperatura', 1116.0000, 'ºC'),
	(258023, 122, '2014-03-15 00:06:27.000000', 'temperatura', 522.0000, 'ºC'),
	(258024, 122, '2014-03-15 00:06:28.000000', 'temperatura', 460.0000, 'ºC'),
	(258025, 122, '2014-03-15 00:06:29.000000', 'temperatura', 737.0000, 'ºC'),
	(258026, 122, '2014-03-15 00:06:30.000000', 'temperatura', 1106.0000, 'ºC'),
	(258027, 122, '2014-03-15 00:06:31.000000', 'temperatura', 920.0000, 'ºC'),
	(258028, 122, '2014-03-15 00:06:32.000000', 'temperatura', 80.0000, 'ºC'),
	(258029, 122, '2014-03-15 00:06:33.000000', 'temperatura', 43.0000, 'ºC'),
	(258030, 122, '2014-03-15 00:06:34.000000', 'temperatura', 1175.0000, 'ºC'),
	(258031, 122, '2014-03-15 00:06:35.000000', 'temperatura', 948.0000, 'ºC'),
	(258032, 122, '2014-03-15 00:06:36.000000', 'temperatura', 14.0000, 'ºC'),
	(258033, 122, '2014-03-15 00:06:37.000000', 'temperatura', 825.0000, 'ºC'),
	(258034, 122, '2014-03-15 00:06:38.000000', 'temperatura', 485.0000, 'ºC'),
	(258035, 122, '2014-03-15 00:06:39.000000', 'temperatura', 1149.0000, 'ºC'),
	(258036, 122, '2014-03-15 00:06:40.000000', 'temperatura', 690.0000, 'ºC'),
	(258037, 122, '2014-03-15 00:06:41.000000', 'temperatura', 3.0000, 'ºC'),
	(258038, 122, '2014-03-15 00:06:42.000000', 'temperatura', 347.0000, 'ºC'),
	(258039, 122, '2014-03-15 00:06:43.000000', 'temperatura', 527.0000, 'ºC'),
	(258040, 122, '2014-03-15 00:06:44.000000', 'temperatura', 394.0000, 'ºC'),
	(258041, 122, '2014-03-15 00:06:45.000000', 'temperatura', 391.0000, 'ºC'),
	(258042, 122, '2014-03-15 00:06:46.000000', 'temperatura', 773.0000, 'ºC'),
	(258043, 122, '2014-03-15 00:06:47.000000', 'temperatura', 293.0000, 'ºC'),
	(258044, 122, '2014-03-15 00:06:48.000000', 'temperatura', 344.0000, 'ºC'),
	(258045, 122, '2014-03-15 00:06:49.000000', 'temperatura', 845.0000, 'ºC'),
	(258046, 122, '2014-03-15 00:06:50.000000', 'temperatura', 792.0000, 'ºC'),
	(258047, 122, '2014-03-15 00:06:51.000000', 'temperatura', 224.0000, 'ºC'),
	(258048, 122, '2014-03-15 00:06:52.000000', 'temperatura', 1144.0000, 'ºC'),
	(258049, 122, '2014-03-15 00:06:53.000000', 'temperatura', 248.0000, 'ºC'),
	(258050, 122, '2014-03-15 00:06:54.000000', 'temperatura', 211.0000, 'ºC'),
	(258051, 122, '2014-03-15 00:06:55.000000', 'temperatura', 311.0000, 'ºC'),
	(258052, 122, '2014-03-15 00:06:56.000000', 'temperatura', 921.0000, 'ºC'),
	(258053, 122, '2014-03-15 00:06:57.000000', 'temperatura', 74.0000, 'ºC'),
	(258054, 122, '2014-03-15 00:06:58.000000', 'temperatura', 6.0000, 'ºC'),
	(258055, 122, '2014-03-15 00:06:59.000000', 'temperatura', 1008.0000, 'ºC'),
	(258056, 122, '2014-03-15 00:07:00.000000', 'temperatura', 222.0000, 'ºC'),
	(258057, 122, '2014-03-15 00:07:01.000000', 'temperatura', 488.0000, 'ºC'),
	(258058, 122, '2014-03-15 00:07:02.000000', 'temperatura', 573.0000, 'ºC'),
	(258059, 122, '2014-03-15 00:07:03.000000', 'temperatura', 204.0000, 'ºC'),
	(258060, 122, '2014-03-15 00:07:04.000000', 'temperatura', 500.0000, 'ºC'),
	(258061, 122, '2014-03-15 00:07:05.000000', 'temperatura', 689.0000, 'ºC'),
	(258062, 122, '2014-03-15 00:07:06.000000', 'temperatura', 745.0000, 'ºC'),
	(258063, 122, '2014-03-15 00:07:07.000000', 'temperatura', 458.0000, 'ºC'),
	(258064, 122, '2014-03-15 00:07:08.000000', 'temperatura', 56.0000, 'ºC'),
	(258065, 122, '2014-03-15 00:07:09.000000', 'temperatura', 105.0000, 'ºC'),
	(258066, 122, '2014-03-15 00:07:10.000000', 'temperatura', 360.0000, 'ºC'),
	(258067, 122, '2014-03-15 00:07:11.000000', 'temperatura', 286.0000, 'ºC'),
	(258068, 122, '2014-03-15 00:07:12.000000', 'temperatura', 350.0000, 'ºC'),
	(258069, 122, '2014-03-15 00:07:13.000000', 'temperatura', 892.0000, 'ºC'),
	(258070, 122, '2014-03-15 00:07:14.000000', 'temperatura', 1012.0000, 'ºC'),
	(258071, 122, '2014-03-15 00:07:15.000000', 'temperatura', 1184.0000, 'ºC'),
	(258072, 122, '2014-03-15 00:07:16.000000', 'temperatura', 484.0000, 'ºC'),
	(258073, 122, '2014-03-15 00:07:17.000000', 'temperatura', 70.0000, 'ºC'),
	(258074, 122, '2014-03-15 00:07:18.000000', 'temperatura', 98.0000, 'ºC'),
	(258075, 122, '2014-03-15 00:07:19.000000', 'temperatura', 280.0000, 'ºC'),
	(258076, 122, '2014-03-15 00:07:20.000000', 'temperatura', 1107.0000, 'ºC'),
	(258077, 122, '2014-03-15 00:07:21.000000', 'temperatura', 1095.0000, 'ºC'),
	(258078, 122, '2014-03-15 00:07:22.000000', 'temperatura', 957.0000, 'ºC'),
	(258079, 122, '2014-03-15 00:07:23.000000', 'temperatura', 297.0000, 'ºC'),
	(258080, 122, '2014-03-15 00:07:24.000000', 'temperatura', 1017.0000, 'ºC'),
	(258081, 122, '2014-03-15 00:07:25.000000', 'temperatura', 594.0000, 'ºC'),
	(258082, 122, '2014-03-15 00:07:26.000000', 'temperatura', 1118.0000, 'ºC'),
	(258083, 122, '2014-03-15 00:07:27.000000', 'temperatura', 210.0000, 'ºC'),
	(258084, 122, '2014-03-15 00:07:28.000000', 'temperatura', 95.0000, 'ºC'),
	(258085, 122, '2014-03-15 00:07:29.000000', 'temperatura', 1048.0000, 'ºC'),
	(258086, 122, '2014-03-15 00:07:30.000000', 'temperatura', 153.0000, 'ºC'),
	(258087, 122, '2014-03-15 00:07:31.000000', 'temperatura', 22.0000, 'ºC'),
	(258088, 122, '2014-03-15 00:07:32.000000', 'temperatura', 852.0000, 'ºC'),
	(258089, 122, '2014-03-15 00:07:33.000000', 'temperatura', 593.0000, 'ºC'),
	(258090, 122, '2014-03-15 00:07:34.000000', 'temperatura', 411.0000, 'ºC'),
	(258091, 122, '2014-03-15 00:07:35.000000', 'temperatura', 276.0000, 'ºC'),
	(258092, 122, '2014-03-15 00:07:36.000000', 'temperatura', 148.0000, 'ºC'),
	(258093, 122, '2014-03-15 00:07:37.000000', 'temperatura', 1114.0000, 'ºC'),
	(258094, 122, '2014-03-15 00:07:38.000000', 'temperatura', 326.0000, 'ºC'),
	(258095, 122, '2014-03-15 00:07:39.000000', 'temperatura', 690.0000, 'ºC'),
	(258096, 122, '2014-03-15 00:07:40.000000', 'temperatura', 70.0000, 'ºC'),
	(258097, 122, '2014-03-15 00:07:41.000000', 'temperatura', 682.0000, 'ºC'),
	(258098, 122, '2014-03-15 00:07:42.000000', 'temperatura', 799.0000, 'ºC'),
	(258099, 122, '2014-03-15 00:07:43.000000', 'temperatura', 750.0000, 'ºC'),
	(258100, 122, '2014-03-15 00:07:44.000000', 'temperatura', 154.0000, 'ºC'),
	(258101, 122, '2014-03-15 00:07:45.000000', 'temperatura', 919.0000, 'ºC'),
	(258102, 122, '2014-03-15 00:07:46.000000', 'temperatura', 536.0000, 'ºC'),
	(258103, 122, '2014-03-15 00:07:47.000000', 'temperatura', 1123.0000, 'ºC'),
	(258104, 122, '2014-03-15 00:07:48.000000', 'temperatura', 407.0000, 'ºC'),
	(258105, 122, '2014-03-15 00:07:49.000000', 'temperatura', 1067.0000, 'ºC'),
	(258106, 122, '2014-03-15 00:07:50.000000', 'temperatura', 514.0000, 'ºC'),
	(258107, 122, '2014-03-15 00:07:51.000000', 'temperatura', 570.0000, 'ºC'),
	(258108, 122, '2014-03-15 00:07:52.000000', 'temperatura', 109.0000, 'ºC'),
	(258109, 122, '2014-03-15 00:07:53.000000', 'temperatura', 36.0000, 'ºC'),
	(258110, 122, '2014-03-15 00:07:54.000000', 'temperatura', 1055.0000, 'ºC'),
	(258111, 122, '2014-03-15 00:07:55.000000', 'temperatura', 365.0000, 'ºC'),
	(258112, 122, '2014-03-15 00:07:56.000000', 'temperatura', 1063.0000, 'ºC'),
	(258113, 122, '2014-03-15 00:07:57.000000', 'temperatura', 619.0000, 'ºC'),
	(258114, 122, '2014-03-15 00:07:58.000000', 'temperatura', 1108.0000, 'ºC'),
	(258115, 122, '2014-03-15 00:07:59.000000', 'temperatura', 82.0000, 'ºC'),
	(258116, 122, '2014-03-15 00:08:00.000000', 'temperatura', 685.0000, 'ºC'),
	(258117, 122, '2014-03-15 00:08:01.000000', 'temperatura', 780.0000, 'ºC'),
	(258118, 122, '2014-03-15 00:08:02.000000', 'temperatura', 648.0000, 'ºC'),
	(258119, 122, '2014-03-15 00:08:03.000000', 'temperatura', 900.0000, 'ºC'),
	(258120, 122, '2014-03-15 00:08:04.000000', 'temperatura', 154.0000, 'ºC'),
	(258121, 122, '2014-03-15 00:08:05.000000', 'temperatura', 473.0000, 'ºC'),
	(258122, 122, '2014-03-15 00:08:06.000000', 'temperatura', 702.0000, 'ºC'),
	(258123, 122, '2014-03-15 00:08:07.000000', 'temperatura', 890.0000, 'ºC'),
	(258124, 122, '2014-03-15 00:08:08.000000', 'temperatura', 1147.0000, 'ºC'),
	(258125, 122, '2014-03-15 00:08:09.000000', 'temperatura', 665.0000, 'ºC'),
	(258126, 122, '2014-03-15 00:08:10.000000', 'temperatura', 1084.0000, 'ºC'),
	(258127, 122, '2014-03-15 00:08:11.000000', 'temperatura', 1027.0000, 'ºC'),
	(258128, 122, '2014-03-15 00:08:12.000000', 'temperatura', 683.0000, 'ºC'),
	(258129, 122, '2014-03-15 00:08:13.000000', 'temperatura', 335.0000, 'ºC'),
	(258130, 122, '2014-03-15 00:08:14.000000', 'temperatura', 826.0000, 'ºC'),
	(258131, 122, '2014-03-15 00:08:15.000000', 'temperatura', 725.0000, 'ºC'),
	(258132, 122, '2014-03-15 00:08:16.000000', 'temperatura', 1146.0000, 'ºC'),
	(258133, 122, '2014-03-15 00:08:17.000000', 'temperatura', 1159.0000, 'ºC'),
	(258134, 122, '2014-03-15 00:08:18.000000', 'temperatura', 1155.0000, 'ºC'),
	(258135, 122, '2014-03-15 00:08:19.000000', 'temperatura', 1098.0000, 'ºC'),
	(258136, 122, '2014-03-15 00:08:20.000000', 'temperatura', 827.0000, 'ºC'),
	(258137, 122, '2014-03-15 00:08:21.000000', 'temperatura', 842.0000, 'ºC'),
	(258138, 122, '2014-03-15 00:08:22.000000', 'temperatura', 529.0000, 'ºC'),
	(258139, 122, '2014-03-15 00:08:23.000000', 'temperatura', 121.0000, 'ºC'),
	(258140, 122, '2014-03-15 00:08:24.000000', 'temperatura', 217.0000, 'ºC'),
	(258141, 122, '2014-03-15 00:08:25.000000', 'temperatura', 721.0000, 'ºC'),
	(258142, 122, '2014-03-15 00:08:26.000000', 'temperatura', 554.0000, 'ºC'),
	(258143, 122, '2014-03-15 00:08:27.000000', 'temperatura', 609.0000, 'ºC'),
	(258144, 122, '2014-03-15 00:08:28.000000', 'temperatura', 182.0000, 'ºC'),
	(258145, 122, '2014-03-15 00:08:29.000000', 'temperatura', 286.0000, 'ºC'),
	(258146, 122, '2014-03-15 00:08:30.000000', 'temperatura', 882.0000, 'ºC'),
	(258147, 122, '2014-03-15 00:08:31.000000', 'temperatura', 1153.0000, 'ºC'),
	(258148, 122, '2014-03-15 00:08:32.000000', 'temperatura', 721.0000, 'ºC'),
	(258149, 122, '2014-03-15 00:08:33.000000', 'temperatura', 147.0000, 'ºC'),
	(258150, 122, '2014-03-15 00:08:34.000000', 'temperatura', 972.0000, 'ºC'),
	(258151, 122, '2014-03-15 00:08:35.000000', 'temperatura', 820.0000, 'ºC'),
	(258152, 122, '2014-03-15 00:08:36.000000', 'temperatura', 1184.0000, 'ºC'),
	(258153, 122, '2014-03-15 00:08:37.000000', 'temperatura', 1059.0000, 'ºC'),
	(258154, 122, '2014-03-15 00:08:38.000000', 'temperatura', 543.0000, 'ºC'),
	(258155, 122, '2014-03-15 00:08:39.000000', 'temperatura', 738.0000, 'ºC'),
	(258156, 122, '2014-03-15 00:08:40.000000', 'temperatura', 864.0000, 'ºC'),
	(258157, 122, '2014-03-15 00:08:41.000000', 'temperatura', 905.0000, 'ºC'),
	(258158, 122, '2014-03-15 00:08:42.000000', 'temperatura', 732.0000, 'ºC'),
	(258159, 122, '2014-03-15 00:08:43.000000', 'temperatura', 948.0000, 'ºC'),
	(258160, 122, '2014-03-15 00:08:44.000000', 'temperatura', 145.0000, 'ºC'),
	(258161, 122, '2014-03-15 00:08:45.000000', 'temperatura', 280.0000, 'ºC'),
	(258162, 122, '2014-03-15 00:08:46.000000', 'temperatura', 967.0000, 'ºC'),
	(258163, 122, '2014-03-15 00:08:47.000000', 'temperatura', 393.0000, 'ºC'),
	(258164, 122, '2014-03-15 00:08:48.000000', 'temperatura', 267.0000, 'ºC'),
	(258165, 122, '2014-03-15 00:08:49.000000', 'temperatura', 158.0000, 'ºC'),
	(258166, 122, '2014-03-15 00:08:50.000000', 'temperatura', 1187.0000, 'ºC'),
	(258167, 122, '2014-03-15 00:08:51.000000', 'temperatura', 660.0000, 'ºC'),
	(258168, 122, '2014-03-15 00:08:52.000000', 'temperatura', 942.0000, 'ºC'),
	(258169, 122, '2014-03-15 00:08:53.000000', 'temperatura', 328.0000, 'ºC'),
	(258170, 122, '2014-03-15 00:08:54.000000', 'temperatura', 16.0000, 'ºC'),
	(258171, 122, '2014-03-15 00:08:55.000000', 'temperatura', 297.0000, 'ºC'),
	(258172, 122, '2014-03-15 00:08:56.000000', 'temperatura', 238.0000, 'ºC'),
	(258173, 122, '2014-03-15 00:08:57.000000', 'temperatura', 298.0000, 'ºC'),
	(258174, 122, '2014-03-15 00:08:58.000000', 'temperatura', 778.0000, 'ºC'),
	(258175, 122, '2014-03-15 00:08:59.000000', 'temperatura', 596.0000, 'ºC'),
	(258176, 122, '2014-03-15 00:09:00.000000', 'temperatura', 644.0000, 'ºC'),
	(258177, 122, '2014-03-15 00:09:01.000000', 'temperatura', 236.0000, 'ºC'),
	(258178, 122, '2014-03-15 00:09:02.000000', 'temperatura', 446.0000, 'ºC'),
	(258179, 122, '2014-03-15 00:09:03.000000', 'temperatura', 324.0000, 'ºC'),
	(258180, 122, '2014-03-15 00:09:04.000000', 'temperatura', 281.0000, 'ºC'),
	(258181, 122, '2014-03-15 00:09:05.000000', 'temperatura', 434.0000, 'ºC'),
	(258182, 122, '2014-03-15 00:09:06.000000', 'temperatura', 129.0000, 'ºC'),
	(258183, 122, '2014-03-15 00:09:07.000000', 'temperatura', 540.0000, 'ºC'),
	(258184, 122, '2014-03-15 00:09:08.000000', 'temperatura', 1117.0000, 'ºC'),
	(258185, 122, '2014-03-15 00:09:09.000000', 'temperatura', 365.0000, 'ºC'),
	(258186, 122, '2014-03-15 00:09:10.000000', 'temperatura', 876.0000, 'ºC'),
	(258187, 122, '2014-03-15 00:09:11.000000', 'temperatura', 885.0000, 'ºC'),
	(258188, 122, '2014-03-15 00:09:12.000000', 'temperatura', 595.0000, 'ºC'),
	(258189, 122, '2014-03-15 00:09:13.000000', 'temperatura', 322.0000, 'ºC'),
	(258190, 122, '2014-03-15 00:09:14.000000', 'temperatura', 1025.0000, 'ºC'),
	(258191, 122, '2014-03-15 00:09:15.000000', 'temperatura', 558.0000, 'ºC'),
	(258192, 122, '2014-03-15 00:09:16.000000', 'temperatura', 916.0000, 'ºC'),
	(258193, 122, '2014-03-15 00:09:17.000000', 'temperatura', 506.0000, 'ºC'),
	(258194, 122, '2014-03-15 00:09:18.000000', 'temperatura', 984.0000, 'ºC'),
	(258195, 122, '2014-03-15 00:09:19.000000', 'temperatura', 1001.0000, 'ºC'),
	(258196, 122, '2014-03-15 00:09:20.000000', 'temperatura', 853.0000, 'ºC'),
	(258197, 122, '2014-03-15 00:09:21.000000', 'temperatura', 63.0000, 'ºC'),
	(258198, 122, '2014-03-15 00:09:22.000000', 'temperatura', 157.0000, 'ºC'),
	(258199, 122, '2014-03-15 00:09:23.000000', 'temperatura', 598.0000, 'ºC'),
	(258200, 122, '2014-03-15 00:09:24.000000', 'temperatura', 117.0000, 'ºC'),
	(258201, 122, '2014-03-15 00:09:25.000000', 'temperatura', 1191.0000, 'ºC'),
	(258202, 122, '2014-03-15 00:09:26.000000', 'temperatura', 804.0000, 'ºC'),
	(258203, 122, '2014-03-15 00:09:27.000000', 'temperatura', 450.0000, 'ºC'),
	(258204, 122, '2014-03-15 00:09:28.000000', 'temperatura', 1038.0000, 'ºC'),
	(258205, 122, '2014-03-15 00:09:29.000000', 'temperatura', 241.0000, 'ºC'),
	(258206, 122, '2014-03-15 00:09:30.000000', 'temperatura', 491.0000, 'ºC'),
	(258207, 122, '2014-03-15 00:09:31.000000', 'temperatura', 534.0000, 'ºC'),
	(258208, 122, '2014-03-15 00:09:32.000000', 'temperatura', 1196.0000, 'ºC'),
	(258209, 122, '2014-03-15 00:09:33.000000', 'temperatura', 778.0000, 'ºC'),
	(258210, 122, '2014-03-15 00:09:34.000000', 'temperatura', 303.0000, 'ºC'),
	(258211, 122, '2014-03-15 00:09:35.000000', 'temperatura', 380.0000, 'ºC'),
	(258212, 122, '2014-03-15 00:09:36.000000', 'temperatura', 990.0000, 'ºC'),
	(258213, 122, '2014-03-15 00:09:37.000000', 'temperatura', 214.0000, 'ºC'),
	(258214, 122, '2014-03-15 00:09:38.000000', 'temperatura', 501.0000, 'ºC'),
	(258215, 122, '2014-03-15 00:09:39.000000', 'temperatura', 662.0000, 'ºC'),
	(258216, 122, '2014-03-15 00:09:40.000000', 'temperatura', 609.0000, 'ºC'),
	(258217, 122, '2014-03-15 00:09:41.000000', 'temperatura', 1059.0000, 'ºC'),
	(258218, 122, '2014-03-15 00:09:42.000000', 'temperatura', 1070.0000, 'ºC'),
	(258219, 122, '2014-03-15 00:09:43.000000', 'temperatura', 972.0000, 'ºC'),
	(258220, 122, '2014-03-15 00:09:44.000000', 'temperatura', 449.0000, 'ºC'),
	(258221, 122, '2014-03-15 00:09:45.000000', 'temperatura', 530.0000, 'ºC'),
	(258222, 122, '2014-03-15 00:09:46.000000', 'temperatura', 105.0000, 'ºC'),
	(258223, 122, '2014-03-15 00:09:47.000000', 'temperatura', 135.0000, 'ºC'),
	(258224, 122, '2014-03-15 00:09:48.000000', 'temperatura', 360.0000, 'ºC'),
	(258225, 122, '2014-03-15 00:09:49.000000', 'temperatura', 194.0000, 'ºC'),
	(258226, 122, '2014-03-15 00:09:50.000000', 'temperatura', 1093.0000, 'ºC'),
	(258227, 122, '2014-03-15 00:09:51.000000', 'temperatura', 83.0000, 'ºC'),
	(258228, 122, '2014-03-15 00:09:52.000000', 'temperatura', 734.0000, 'ºC'),
	(258229, 122, '2014-03-15 00:09:53.000000', 'temperatura', 1025.0000, 'ºC'),
	(258230, 122, '2014-03-15 00:09:54.000000', 'temperatura', 522.0000, 'ºC'),
	(258231, 122, '2014-03-15 00:09:55.000000', 'temperatura', 737.0000, 'ºC'),
	(258232, 122, '2014-03-15 00:09:56.000000', 'temperatura', 918.0000, 'ºC'),
	(258233, 122, '2014-03-15 00:09:57.000000', 'temperatura', 1179.0000, 'ºC'),
	(258234, 122, '2014-03-15 00:09:58.000000', 'temperatura', 740.0000, 'ºC'),
	(258235, 122, '2014-03-15 00:09:59.000000', 'temperatura', 165.0000, 'ºC'),
	(258236, 122, '2014-03-15 00:10:00.000000', 'temperatura', 1008.0000, 'ºC'),
	(258237, 122, '2014-03-15 00:10:01.000000', 'temperatura', 942.0000, 'ºC'),
	(258238, 122, '2014-03-15 00:10:02.000000', 'temperatura', 488.0000, 'ºC'),
	(258239, 122, '2014-03-15 00:10:03.000000', 'temperatura', 814.0000, 'ºC'),
	(258240, 122, '2014-03-15 00:10:04.000000', 'temperatura', 207.0000, 'ºC'),
	(258241, 122, '2014-03-15 00:10:05.000000', 'temperatura', 992.0000, 'ºC'),
	(258242, 122, '2014-03-15 00:10:06.000000', 'temperatura', 741.0000, 'ºC'),
	(258243, 122, '2014-03-15 00:10:07.000000', 'temperatura', 730.0000, 'ºC'),
	(258244, 122, '2014-03-15 00:10:08.000000', 'temperatura', 227.0000, 'ºC'),
	(258245, 122, '2014-03-15 00:10:09.000000', 'temperatura', 145.0000, 'ºC'),
	(258246, 122, '2014-03-15 00:10:10.000000', 'temperatura', 43.0000, 'ºC'),
	(258247, 122, '2014-03-15 00:10:11.000000', 'temperatura', 981.0000, 'ºC'),
	(258248, 122, '2014-03-15 00:10:12.000000', 'temperatura', 1177.0000, 'ºC'),
	(258249, 122, '2014-03-15 00:10:13.000000', 'temperatura', 543.0000, 'ºC'),
	(258250, 122, '2014-03-15 00:10:14.000000', 'temperatura', 383.0000, 'ºC'),
	(258251, 122, '2014-03-15 00:10:15.000000', 'temperatura', 289.0000, 'ºC'),
	(258252, 122, '2014-03-15 00:10:16.000000', 'temperatura', 295.0000, 'ºC'),
	(258253, 122, '2014-03-15 00:10:17.000000', 'temperatura', 608.0000, 'ºC'),
	(258254, 122, '2014-03-15 00:10:18.000000', 'temperatura', 956.0000, 'ºC'),
	(258255, 122, '2014-03-15 00:10:19.000000', 'temperatura', 556.0000, 'ºC'),
	(258256, 122, '2014-03-15 00:10:20.000000', 'temperatura', 1112.0000, 'ºC'),
	(258257, 122, '2014-03-15 00:10:21.000000', 'temperatura', 294.0000, 'ºC'),
	(258258, 122, '2014-03-15 00:10:22.000000', 'temperatura', 535.0000, 'ºC'),
	(258259, 122, '2014-03-15 00:10:23.000000', 'temperatura', 592.0000, 'ºC'),
	(258260, 122, '2014-03-15 00:10:24.000000', 'temperatura', 157.0000, 'ºC'),
	(258261, 122, '2014-03-15 00:10:25.000000', 'temperatura', 209.0000, 'ºC'),
	(258262, 122, '2014-03-15 00:10:26.000000', 'temperatura', 575.0000, 'ºC'),
	(258263, 122, '2014-03-15 00:10:27.000000', 'temperatura', 1048.0000, 'ºC'),
	(258264, 122, '2014-03-15 00:10:28.000000', 'temperatura', 1115.0000, 'ºC'),
	(258265, 122, '2014-03-15 00:10:29.000000', 'temperatura', 31.0000, 'ºC'),
	(258266, 122, '2014-03-15 00:10:30.000000', 'temperatura', 413.0000, 'ºC'),
	(258267, 122, '2014-03-15 00:10:31.000000', 'temperatura', 772.0000, 'ºC'),
	(258268, 122, '2014-03-15 00:10:32.000000', 'temperatura', 219.0000, 'ºC'),
	(258269, 122, '2014-03-15 00:10:33.000000', 'temperatura', 1181.0000, 'ºC'),
	(258270, 122, '2014-03-15 00:10:34.000000', 'temperatura', 448.0000, 'ºC'),
	(258271, 122, '2014-03-15 00:10:35.000000', 'temperatura', 1097.0000, 'ºC'),
	(258272, 122, '2014-03-15 00:10:36.000000', 'temperatura', 543.0000, 'ºC'),
	(258273, 122, '2014-03-15 00:10:37.000000', 'temperatura', 623.0000, 'ºC'),
	(258274, 122, '2014-03-15 00:10:38.000000', 'temperatura', 286.0000, 'ºC'),
	(258275, 122, '2014-03-15 00:10:39.000000', 'temperatura', 764.0000, 'ºC'),
	(258276, 122, '2014-03-15 00:10:40.000000', 'temperatura', 560.0000, 'ºC'),
	(258277, 122, '2014-03-15 00:10:41.000000', 'temperatura', 509.0000, 'ºC'),
	(258278, 122, '2014-03-15 00:10:42.000000', 'temperatura', 864.0000, 'ºC'),
	(258279, 122, '2014-03-15 00:10:43.000000', 'temperatura', 395.0000, 'ºC'),
	(258280, 122, '2014-03-15 00:10:44.000000', 'temperatura', 585.0000, 'ºC'),
	(258281, 122, '2014-03-15 00:10:45.000000', 'temperatura', 538.0000, 'ºC'),
	(258282, 122, '2014-03-15 00:10:46.000000', 'temperatura', 934.0000, 'ºC'),
	(258283, 122, '2014-03-15 00:10:47.000000', 'temperatura', 660.0000, 'ºC'),
	(258284, 122, '2014-03-15 00:10:48.000000', 'temperatura', 499.0000, 'ºC'),
	(258285, 122, '2014-03-15 00:10:49.000000', 'temperatura', 512.0000, 'ºC'),
	(258286, 122, '2014-03-15 00:10:50.000000', 'temperatura', 1067.0000, 'ºC'),
	(258287, 122, '2014-03-15 00:10:51.000000', 'temperatura', 197.0000, 'ºC'),
	(258288, 122, '2014-03-15 00:10:52.000000', 'temperatura', 186.0000, 'ºC'),
	(258289, 122, '2014-03-15 00:10:53.000000', 'temperatura', 337.0000, 'ºC'),
	(258290, 122, '2014-03-15 00:10:54.000000', 'temperatura', 1130.0000, 'ºC'),
	(258291, 122, '2014-03-15 00:10:55.000000', 'temperatura', 1037.0000, 'ºC'),
	(258292, 122, '2014-03-15 00:10:56.000000', 'temperatura', 598.0000, 'ºC'),
	(258293, 122, '2014-03-15 00:10:57.000000', 'temperatura', 1079.0000, 'ºC'),
	(258294, 122, '2014-03-15 00:10:58.000000', 'temperatura', 3.0000, 'ºC'),
	(258295, 122, '2014-03-15 00:10:59.000000', 'temperatura', 376.0000, 'ºC'),
	(258296, 122, '2014-03-15 00:11:00.000000', 'temperatura', 671.0000, 'ºC'),
	(258297, 122, '2014-03-15 00:11:01.000000', 'temperatura', 1027.0000, 'ºC'),
	(258298, 122, '2014-03-15 00:11:02.000000', 'temperatura', 726.0000, 'ºC'),
	(258299, 122, '2014-03-15 00:11:03.000000', 'temperatura', 546.0000, 'ºC'),
	(258300, 122, '2014-03-15 00:11:04.000000', 'temperatura', 554.0000, 'ºC'),
	(258301, 122, '2014-03-15 00:11:05.000000', 'temperatura', 1133.0000, 'ºC'),
	(258302, 122, '2014-03-15 00:11:06.000000', 'temperatura', 404.0000, 'ºC'),
	(258303, 122, '2014-03-15 00:11:07.000000', 'temperatura', 1023.0000, 'ºC'),
	(258304, 122, '2014-03-15 00:11:08.000000', 'temperatura', 301.0000, 'ºC'),
	(258305, 122, '2014-03-15 00:11:09.000000', 'temperatura', 839.0000, 'ºC'),
	(258306, 122, '2014-03-15 00:11:10.000000', 'temperatura', 890.0000, 'ºC'),
	(258307, 122, '2014-03-15 00:11:11.000000', 'temperatura', 733.0000, 'ºC'),
	(258308, 122, '2014-03-15 00:11:12.000000', 'temperatura', 998.0000, 'ºC'),
	(258309, 122, '2014-03-15 00:11:13.000000', 'temperatura', 392.0000, 'ºC'),
	(258310, 122, '2014-03-15 00:11:14.000000', 'temperatura', 167.0000, 'ºC'),
	(258311, 122, '2014-03-15 00:11:15.000000', 'temperatura', 860.0000, 'ºC'),
	(258312, 122, '2014-03-15 00:11:16.000000', 'temperatura', 200.0000, 'ºC'),
	(258313, 122, '2014-03-15 00:11:17.000000', 'temperatura', 821.0000, 'ºC'),
	(258314, 122, '2014-03-15 00:11:18.000000', 'temperatura', 1105.0000, 'ºC'),
	(258315, 122, '2014-03-15 00:11:19.000000', 'temperatura', 663.0000, 'ºC'),
	(258316, 122, '2014-03-15 00:11:20.000000', 'temperatura', 1198.0000, 'ºC'),
	(258317, 122, '2014-03-15 00:11:21.000000', 'temperatura', 404.0000, 'ºC'),
	(258318, 122, '2014-03-15 00:11:22.000000', 'temperatura', 826.0000, 'ºC'),
	(258319, 122, '2014-03-15 00:11:23.000000', 'temperatura', 517.0000, 'ºC'),
	(258320, 122, '2014-03-15 00:11:24.000000', 'temperatura', 107.0000, 'ºC'),
	(258321, 122, '2014-03-15 00:11:25.000000', 'temperatura', 184.0000, 'ºC'),
	(258322, 122, '2014-03-15 00:11:26.000000', 'temperatura', 600.0000, 'ºC'),
	(258323, 122, '2014-03-15 00:11:27.000000', 'temperatura', 48.0000, 'ºC'),
	(258324, 122, '2014-03-15 00:11:28.000000', 'temperatura', 843.0000, 'ºC'),
	(258325, 122, '2014-03-15 00:11:29.000000', 'temperatura', 471.0000, 'ºC'),
	(258326, 122, '2014-03-15 00:11:30.000000', 'temperatura', 1026.0000, 'ºC'),
	(258327, 122, '2014-03-15 00:11:31.000000', 'temperatura', 118.0000, 'ºC'),
	(258328, 122, '2014-03-15 00:11:32.000000', 'temperatura', 1114.0000, 'ºC'),
	(258329, 122, '2014-03-15 00:11:33.000000', 'temperatura', 415.0000, 'ºC'),
	(258330, 122, '2014-03-15 00:11:34.000000', 'temperatura', 1132.0000, 'ºC'),
	(258331, 122, '2014-03-15 00:11:35.000000', 'temperatura', 815.0000, 'ºC'),
	(258332, 122, '2014-03-15 00:11:36.000000', 'temperatura', 681.0000, 'ºC'),
	(258333, 122, '2014-03-15 00:11:37.000000', 'temperatura', 960.0000, 'ºC'),
	(258334, 122, '2014-03-15 00:11:38.000000', 'temperatura', 359.0000, 'ºC'),
	(258335, 122, '2014-03-15 00:11:39.000000', 'temperatura', 115.0000, 'ºC'),
	(258336, 122, '2014-03-15 00:11:40.000000', 'temperatura', 699.0000, 'ºC'),
	(258337, 122, '2014-03-15 00:11:41.000000', 'temperatura', 751.0000, 'ºC'),
	(258338, 122, '2014-03-15 00:11:42.000000', 'temperatura', 457.0000, 'ºC'),
	(258339, 122, '2014-03-15 00:11:43.000000', 'temperatura', 32.0000, 'ºC'),
	(258340, 122, '2014-03-15 00:11:44.000000', 'temperatura', 1190.0000, 'ºC'),
	(258341, 122, '2014-03-15 00:11:45.000000', 'temperatura', 1054.0000, 'ºC'),
	(258342, 122, '2014-03-15 00:11:46.000000', 'temperatura', 500.0000, 'ºC'),
	(258343, 122, '2014-03-15 00:11:47.000000', 'temperatura', 540.0000, 'ºC'),
	(258344, 122, '2014-03-15 00:11:48.000000', 'temperatura', 1199.0000, 'ºC'),
	(258345, 122, '2014-03-15 00:11:49.000000', 'temperatura', 774.0000, 'ºC'),
	(258346, 122, '2014-03-15 00:11:50.000000', 'temperatura', 277.0000, 'ºC'),
	(258347, 122, '2014-03-15 00:11:51.000000', 'temperatura', 262.0000, 'ºC'),
	(258348, 122, '2014-03-15 00:11:52.000000', 'temperatura', 479.0000, 'ºC'),
	(258349, 122, '2014-03-15 00:11:53.000000', 'temperatura', 412.0000, 'ºC'),
	(258350, 122, '2014-03-15 00:11:54.000000', 'temperatura', 620.0000, 'ºC'),
	(258351, 122, '2014-03-15 00:11:55.000000', 'temperatura', 667.0000, 'ºC'),
	(258352, 122, '2014-03-15 00:11:56.000000', 'temperatura', 274.0000, 'ºC'),
	(258353, 122, '2014-03-15 00:11:57.000000', 'temperatura', 569.0000, 'ºC'),
	(258354, 122, '2014-03-15 00:11:58.000000', 'temperatura', 823.0000, 'ºC'),
	(258355, 122, '2014-03-15 00:11:59.000000', 'temperatura', 10.0000, 'ºC'),
	(258356, 122, '2014-03-15 00:12:00.000000', 'temperatura', 1182.0000, 'ºC'),
	(258357, 122, '2014-03-15 00:12:01.000000', 'temperatura', 1078.0000, 'ºC'),
	(258358, 122, '2014-03-15 00:12:02.000000', 'temperatura', 646.0000, 'ºC'),
	(258359, 122, '2014-03-15 00:12:03.000000', 'temperatura', 1195.0000, 'ºC'),
	(258360, 122, '2014-03-15 00:12:04.000000', 'temperatura', 437.0000, 'ºC'),
	(258361, 122, '2014-03-15 00:12:05.000000', 'temperatura', 1003.0000, 'ºC'),
	(258362, 122, '2014-03-15 00:12:06.000000', 'temperatura', 104.0000, 'ºC'),
	(258363, 122, '2014-03-15 00:12:07.000000', 'temperatura', 1112.0000, 'ºC'),
	(258364, 122, '2014-03-15 00:12:08.000000', 'temperatura', 450.0000, 'ºC'),
	(258365, 122, '2014-03-15 00:12:09.000000', 'temperatura', 112.0000, 'ºC'),
	(258366, 122, '2014-03-15 00:12:10.000000', 'temperatura', 409.0000, 'ºC'),
	(258367, 122, '2014-03-15 00:12:11.000000', 'temperatura', 512.0000, 'ºC'),
	(258368, 122, '2014-03-15 00:12:12.000000', 'temperatura', 134.0000, 'ºC'),
	(258369, 122, '2014-03-15 00:12:13.000000', 'temperatura', 334.0000, 'ºC'),
	(258370, 122, '2014-03-15 00:12:14.000000', 'temperatura', 70.0000, 'ºC'),
	(258371, 122, '2014-03-15 00:12:15.000000', 'temperatura', 547.0000, 'ºC'),
	(258372, 122, '2014-03-15 00:12:16.000000', 'temperatura', 125.0000, 'ºC'),
	(258373, 122, '2014-03-15 00:12:17.000000', 'temperatura', 186.0000, 'ºC'),
	(258374, 122, '2014-03-15 00:12:18.000000', 'temperatura', 555.0000, 'ºC'),
	(258375, 122, '2014-03-15 00:12:19.000000', 'temperatura', 1016.0000, 'ºC'),
	(258376, 122, '2014-03-15 00:12:20.000000', 'temperatura', 1018.0000, 'ºC'),
	(258377, 122, '2014-03-15 00:12:21.000000', 'temperatura', 840.0000, 'ºC'),
	(258378, 122, '2014-03-15 00:12:22.000000', 'temperatura', 1147.0000, 'ºC'),
	(258379, 122, '2014-03-15 00:12:23.000000', 'temperatura', 817.0000, 'ºC'),
	(258380, 122, '2014-03-15 00:12:24.000000', 'temperatura', 643.0000, 'ºC'),
	(258381, 122, '2014-03-15 00:12:25.000000', 'temperatura', 764.0000, 'ºC'),
	(258382, 122, '2014-03-15 00:12:26.000000', 'temperatura', 693.0000, 'ºC'),
	(258383, 122, '2014-03-15 00:12:27.000000', 'temperatura', 1174.0000, 'ºC'),
	(258384, 122, '2014-03-15 00:12:28.000000', 'temperatura', 191.0000, 'ºC'),
	(258385, 122, '2014-03-15 00:12:29.000000', 'temperatura', 1033.0000, 'ºC'),
	(258386, 122, '2014-03-15 00:12:30.000000', 'temperatura', 991.0000, 'ºC'),
	(258387, 122, '2014-03-15 00:12:31.000000', 'temperatura', 656.0000, 'ºC'),
	(258388, 122, '2014-03-15 00:12:32.000000', 'temperatura', 311.0000, 'ºC'),
	(258389, 122, '2014-03-15 00:12:33.000000', 'temperatura', 784.0000, 'ºC'),
	(258390, 122, '2014-03-15 00:12:34.000000', 'temperatura', 589.0000, 'ºC'),
	(258391, 122, '2014-03-15 00:12:35.000000', 'temperatura', 592.0000, 'ºC'),
	(258392, 122, '2014-03-15 00:12:36.000000', 'temperatura', 1192.0000, 'ºC'),
	(258393, 122, '2014-03-15 00:12:37.000000', 'temperatura', 588.0000, 'ºC'),
	(258394, 122, '2014-03-15 00:12:38.000000', 'temperatura', 562.0000, 'ºC'),
	(258395, 122, '2014-03-15 00:12:39.000000', 'temperatura', 1048.0000, 'ºC'),
	(258396, 122, '2014-03-15 00:12:40.000000', 'temperatura', 1153.0000, 'ºC'),
	(258397, 122, '2014-03-15 00:12:41.000000', 'temperatura', 222.0000, 'ºC'),
	(258398, 122, '2014-03-15 00:12:42.000000', 'temperatura', 52.0000, 'ºC'),
	(258399, 122, '2014-03-15 00:12:43.000000', 'temperatura', 794.0000, 'ºC'),
	(258400, 122, '2014-03-15 00:12:44.000000', 'temperatura', 217.0000, 'ºC'),
	(258401, 122, '2014-03-15 00:12:45.000000', 'temperatura', 1100.0000, 'ºC'),
	(258402, 122, '2014-03-15 00:12:46.000000', 'temperatura', 50.0000, 'ºC'),
	(258403, 122, '2014-03-15 00:12:47.000000', 'temperatura', 551.0000, 'ºC'),
	(258404, 122, '2014-03-15 00:12:48.000000', 'temperatura', 206.0000, 'ºC'),
	(258405, 122, '2014-03-15 00:12:49.000000', 'temperatura', 578.0000, 'ºC'),
	(258406, 122, '2014-03-15 00:12:50.000000', 'temperatura', 1073.0000, 'ºC'),
	(258407, 122, '2014-03-15 00:12:51.000000', 'temperatura', 31.0000, 'ºC'),
	(258408, 122, '2014-03-15 00:12:52.000000', 'temperatura', 538.0000, 'ºC'),
	(258409, 122, '2014-03-15 00:12:53.000000', 'temperatura', 198.0000, 'ºC'),
	(258410, 122, '2014-03-15 00:12:54.000000', 'temperatura', 576.0000, 'ºC'),
	(258411, 122, '2014-03-15 00:12:55.000000', 'temperatura', 1087.0000, 'ºC'),
	(258412, 122, '2014-03-15 00:12:56.000000', 'temperatura', 105.0000, 'ºC'),
	(258413, 122, '2014-03-15 00:12:57.000000', 'temperatura', 866.0000, 'ºC'),
	(258414, 122, '2014-03-15 00:12:58.000000', 'temperatura', 414.0000, 'ºC'),
	(258415, 122, '2014-03-15 00:12:59.000000', 'temperatura', 672.0000, 'ºC'),
	(258416, 122, '2014-03-15 00:13:00.000000', 'temperatura', 920.0000, 'ºC'),
	(258417, 122, '2014-03-15 00:13:01.000000', 'temperatura', 185.0000, 'ºC'),
	(258418, 122, '2014-03-15 00:13:02.000000', 'temperatura', 565.0000, 'ºC'),
	(258419, 122, '2014-03-15 00:13:03.000000', 'temperatura', 1070.0000, 'ºC'),
	(258420, 122, '2014-03-15 00:13:04.000000', 'temperatura', 54.0000, 'ºC'),
	(258421, 122, '2014-03-15 00:13:05.000000', 'temperatura', 661.0000, 'ºC'),
	(258422, 122, '2014-03-15 00:13:06.000000', 'temperatura', 746.0000, 'ºC'),
	(258423, 122, '2014-03-15 00:13:07.000000', 'temperatura', 546.0000, 'ºC'),
	(258424, 122, '2014-03-15 00:13:08.000000', 'temperatura', 493.0000, 'ºC'),
	(258425, 122, '2014-03-15 00:13:09.000000', 'temperatura', 827.0000, 'ºC'),
	(258426, 122, '2014-03-15 00:13:10.000000', 'temperatura', 258.0000, 'ºC'),
	(258427, 122, '2014-03-15 00:13:11.000000', 'temperatura', 8.0000, 'ºC'),
	(258428, 122, '2014-03-15 00:13:12.000000', 'temperatura', 469.0000, 'ºC'),
	(258429, 122, '2014-03-15 00:13:13.000000', 'temperatura', 1118.0000, 'ºC'),
	(258430, 122, '2014-03-15 00:13:14.000000', 'temperatura', 586.0000, 'ºC'),
	(258431, 122, '2014-03-15 00:13:15.000000', 'temperatura', 778.0000, 'ºC'),
	(258432, 122, '2014-03-15 00:13:16.000000', 'temperatura', 930.0000, 'ºC'),
	(258433, 122, '2014-03-15 00:13:17.000000', 'temperatura', 1116.0000, 'ºC'),
	(258434, 122, '2014-03-15 00:13:18.000000', 'temperatura', 390.0000, 'ºC'),
	(258435, 122, '2014-03-15 00:13:19.000000', 'temperatura', 1005.0000, 'ºC'),
	(258436, 122, '2014-03-15 00:13:20.000000', 'temperatura', 254.0000, 'ºC'),
	(258437, 122, '2014-03-15 00:13:21.000000', 'temperatura', 655.0000, 'ºC'),
	(258438, 122, '2014-03-15 00:13:22.000000', 'temperatura', 115.0000, 'ºC'),
	(258439, 122, '2014-03-15 00:13:23.000000', 'temperatura', 1010.0000, 'ºC'),
	(258440, 122, '2014-03-15 00:13:24.000000', 'temperatura', 1107.0000, 'ºC'),
	(258441, 122, '2014-03-15 00:13:25.000000', 'temperatura', 103.0000, 'ºC'),
	(258442, 122, '2014-03-15 00:13:26.000000', 'temperatura', 794.0000, 'ºC'),
	(258443, 122, '2014-03-15 00:13:27.000000', 'temperatura', 62.0000, 'ºC'),
	(258444, 122, '2014-03-15 00:13:28.000000', 'temperatura', 330.0000, 'ºC'),
	(258445, 122, '2014-03-15 00:13:29.000000', 'temperatura', 265.0000, 'ºC'),
	(258446, 122, '2014-03-15 00:13:30.000000', 'temperatura', 336.0000, 'ºC'),
	(258447, 122, '2014-03-15 00:13:31.000000', 'temperatura', 885.0000, 'ºC'),
	(258448, 122, '2014-03-15 00:13:32.000000', 'temperatura', 1016.0000, 'ºC'),
	(258449, 122, '2014-03-15 00:13:33.000000', 'temperatura', 27.0000, 'ºC'),
	(258450, 122, '2014-03-15 00:13:34.000000', 'temperatura', 687.0000, 'ºC'),
	(258451, 122, '2014-03-15 00:13:35.000000', 'temperatura', 953.0000, 'ºC'),
	(258452, 122, '2014-03-15 00:13:36.000000', 'temperatura', 305.0000, 'ºC'),
	(258453, 122, '2014-03-15 00:13:37.000000', 'temperatura', 1065.0000, 'ºC'),
	(258454, 122, '2014-03-15 00:13:38.000000', 'temperatura', 811.0000, 'ºC'),
	(258455, 122, '2014-03-15 00:13:39.000000', 'temperatura', 860.0000, 'ºC'),
	(258456, 122, '2014-03-15 00:13:40.000000', 'temperatura', 667.0000, 'ºC'),
	(258457, 122, '2014-03-15 00:13:41.000000', 'temperatura', 758.0000, 'ºC'),
	(258458, 122, '2014-03-15 00:13:42.000000', 'temperatura', 587.0000, 'ºC'),
	(258459, 122, '2014-03-15 00:13:43.000000', 'temperatura', 663.0000, 'ºC'),
	(258460, 122, '2014-03-15 00:13:44.000000', 'temperatura', 352.0000, 'ºC'),
	(258461, 122, '2014-03-15 00:13:45.000000', 'temperatura', 975.0000, 'ºC'),
	(258462, 122, '2014-03-15 00:13:46.000000', 'temperatura', 219.0000, 'ºC'),
	(258463, 122, '2014-03-15 00:13:47.000000', 'temperatura', 568.0000, 'ºC'),
	(258464, 122, '2014-03-15 00:13:48.000000', 'temperatura', 985.0000, 'ºC'),
	(258465, 122, '2014-03-15 00:13:49.000000', 'temperatura', 820.0000, 'ºC'),
	(258466, 122, '2014-03-15 00:13:50.000000', 'temperatura', 1147.0000, 'ºC'),
	(258467, 122, '2014-03-15 00:13:51.000000', 'temperatura', 874.0000, 'ºC'),
	(258468, 122, '2014-03-15 00:13:52.000000', 'temperatura', 931.0000, 'ºC'),
	(258469, 122, '2014-03-15 00:13:53.000000', 'temperatura', 834.0000, 'ºC'),
	(258470, 122, '2014-03-15 00:13:54.000000', 'temperatura', 176.0000, 'ºC'),
	(258471, 122, '2014-03-15 00:13:55.000000', 'temperatura', 780.0000, 'ºC'),
	(258472, 122, '2014-03-15 00:13:56.000000', 'temperatura', 970.0000, 'ºC'),
	(258473, 122, '2014-03-15 00:13:57.000000', 'temperatura', 112.0000, 'ºC'),
	(258474, 122, '2014-03-15 00:13:58.000000', 'temperatura', 52.0000, 'ºC'),
	(258475, 122, '2014-03-15 00:13:59.000000', 'temperatura', 1122.0000, 'ºC'),
	(258476, 122, '2014-03-15 00:14:00.000000', 'temperatura', 655.0000, 'ºC'),
	(258477, 122, '2014-03-15 00:14:01.000000', 'temperatura', 1110.0000, 'ºC'),
	(258478, 122, '2014-03-15 00:14:02.000000', 'temperatura', 1187.0000, 'ºC'),
	(258479, 122, '2014-03-15 00:14:03.000000', 'temperatura', 202.0000, 'ºC'),
	(258480, 122, '2014-03-15 00:14:04.000000', 'temperatura', 1053.0000, 'ºC'),
	(258481, 122, '2014-03-15 00:14:05.000000', 'temperatura', 1058.0000, 'ºC'),
	(258482, 122, '2014-03-15 00:14:06.000000', 'temperatura', 931.0000, 'ºC'),
	(258483, 122, '2014-03-15 00:14:07.000000', 'temperatura', 280.0000, 'ºC'),
	(258484, 122, '2014-03-15 00:14:08.000000', 'temperatura', 1008.0000, 'ºC'),
	(258485, 122, '2014-03-15 00:14:09.000000', 'temperatura', 601.0000, 'ºC'),
	(258486, 122, '2014-03-15 00:14:10.000000', 'temperatura', 1182.0000, 'ºC'),
	(258487, 122, '2014-03-15 00:14:11.000000', 'temperatura', 508.0000, 'ºC'),
	(258488, 122, '2014-03-15 00:14:12.000000', 'temperatura', 195.0000, 'ºC'),
	(258489, 122, '2014-03-15 00:14:13.000000', 'temperatura', 649.0000, 'ºC'),
	(258490, 122, '2014-03-15 00:14:14.000000', 'temperatura', 260.0000, 'ºC'),
	(258491, 122, '2014-03-15 00:14:15.000000', 'temperatura', 556.0000, 'ºC'),
	(258492, 122, '2014-03-15 00:14:16.000000', 'temperatura', 798.0000, 'ºC'),
	(258493, 122, '2014-03-15 00:14:17.000000', 'temperatura', 1124.0000, 'ºC'),
	(258494, 122, '2014-03-15 00:14:18.000000', 'temperatura', 825.0000, 'ºC'),
	(258495, 122, '2014-03-15 00:14:19.000000', 'temperatura', 755.0000, 'ºC'),
	(258496, 122, '2014-03-15 00:14:20.000000', 'temperatura', 101.0000, 'ºC'),
	(258497, 122, '2014-03-15 00:14:21.000000', 'temperatura', 639.0000, 'ºC'),
	(258498, 122, '2014-03-15 00:14:22.000000', 'temperatura', 495.0000, 'ºC'),
	(258499, 122, '2014-03-15 00:14:23.000000', 'temperatura', 557.0000, 'ºC'),
	(258500, 122, '2014-03-15 00:14:24.000000', 'temperatura', 101.0000, 'ºC'),
	(258501, 122, '2014-03-15 00:14:25.000000', 'temperatura', 34.0000, 'ºC'),
	(258502, 122, '2014-03-15 00:14:26.000000', 'temperatura', 1068.0000, 'ºC'),
	(258503, 122, '2014-03-15 00:14:27.000000', 'temperatura', 440.0000, 'ºC'),
	(258504, 122, '2014-03-15 00:14:28.000000', 'temperatura', 195.0000, 'ºC'),
	(258505, 122, '2014-03-15 00:14:29.000000', 'temperatura', 856.0000, 'ºC'),
	(258506, 122, '2014-03-15 00:14:30.000000', 'temperatura', 95.0000, 'ºC'),
	(258507, 122, '2014-03-15 00:14:31.000000', 'temperatura', 307.0000, 'ºC'),
	(258508, 122, '2014-03-15 00:14:32.000000', 'temperatura', 51.0000, 'ºC'),
	(258509, 122, '2014-03-15 00:14:33.000000', 'temperatura', 535.0000, 'ºC'),
	(258510, 122, '2014-03-15 00:14:34.000000', 'temperatura', 122.0000, 'ºC'),
	(258511, 122, '2014-03-15 00:14:35.000000', 'temperatura', 205.0000, 'ºC'),
	(258512, 122, '2014-03-15 00:14:36.000000', 'temperatura', 658.0000, 'ºC'),
	(258513, 122, '2014-03-15 00:14:37.000000', 'temperatura', 277.0000, 'ºC'),
	(258514, 122, '2014-03-15 00:14:38.000000', 'temperatura', 611.0000, 'ºC'),
	(258515, 122, '2014-03-15 00:14:39.000000', 'temperatura', 1023.0000, 'ºC'),
	(258516, 122, '2014-03-15 00:14:40.000000', 'temperatura', 884.0000, 'ºC'),
	(258517, 122, '2014-03-15 00:14:41.000000', 'temperatura', 150.0000, 'ºC'),
	(258518, 122, '2014-03-15 00:14:42.000000', 'temperatura', 498.0000, 'ºC'),
	(258519, 122, '2014-03-15 00:14:43.000000', 'temperatura', 841.0000, 'ºC'),
	(258520, 122, '2014-03-15 00:14:44.000000', 'temperatura', 313.0000, 'ºC'),
	(258521, 122, '2014-03-15 00:14:45.000000', 'temperatura', 240.0000, 'ºC'),
	(258522, 122, '2014-03-15 00:14:46.000000', 'temperatura', 261.0000, 'ºC'),
	(258523, 122, '2014-03-15 00:14:47.000000', 'temperatura', 586.0000, 'ºC'),
	(258524, 122, '2014-03-15 00:14:48.000000', 'temperatura', 946.0000, 'ºC'),
	(258525, 122, '2014-03-15 00:14:49.000000', 'temperatura', 575.0000, 'ºC'),
	(258526, 122, '2014-03-15 00:14:50.000000', 'temperatura', 36.0000, 'ºC'),
	(258527, 122, '2014-03-15 00:14:51.000000', 'temperatura', 858.0000, 'ºC'),
	(258528, 122, '2014-03-15 00:14:52.000000', 'temperatura', 580.0000, 'ºC'),
	(258529, 122, '2014-03-15 00:14:53.000000', 'temperatura', 327.0000, 'ºC'),
	(258530, 122, '2014-03-15 00:14:54.000000', 'temperatura', 1094.0000, 'ºC'),
	(258531, 122, '2014-03-15 00:14:55.000000', 'temperatura', 889.0000, 'ºC'),
	(258532, 122, '2014-03-15 00:14:56.000000', 'temperatura', 1166.0000, 'ºC'),
	(258533, 122, '2014-03-15 00:14:57.000000', 'temperatura', 765.0000, 'ºC'),
	(258534, 122, '2014-03-15 00:14:58.000000', 'temperatura', 324.0000, 'ºC'),
	(258535, 122, '2014-03-15 00:14:59.000000', 'temperatura', 527.0000, 'ºC'),
	(258536, 122, '2014-03-15 00:15:00.000000', 'temperatura', 462.0000, 'ºC'),
	(258537, 122, '2014-03-15 00:15:01.000000', 'temperatura', 729.0000, 'ºC'),
	(258538, 122, '2014-03-15 00:15:02.000000', 'temperatura', 1060.0000, 'ºC'),
	(258539, 122, '2014-03-15 00:15:03.000000', 'temperatura', 712.0000, 'ºC'),
	(258540, 122, '2014-03-15 00:15:04.000000', 'temperatura', 381.0000, 'ºC'),
	(258541, 122, '2014-03-15 00:15:05.000000', 'temperatura', 970.0000, 'ºC'),
	(258542, 122, '2014-03-15 00:15:06.000000', 'temperatura', 107.0000, 'ºC'),
	(258543, 122, '2014-03-15 00:15:07.000000', 'temperatura', 25.0000, 'ºC'),
	(258544, 122, '2014-03-15 00:15:08.000000', 'temperatura', 1003.0000, 'ºC'),
	(258545, 122, '2014-03-15 00:15:09.000000', 'temperatura', 143.0000, 'ºC'),
	(258546, 122, '2014-03-15 00:15:10.000000', 'temperatura', 107.0000, 'ºC'),
	(258547, 122, '2014-03-15 00:15:11.000000', 'temperatura', 107.0000, 'ºC'),
	(258548, 122, '2014-03-15 00:15:12.000000', 'temperatura', 214.0000, 'ºC'),
	(258549, 122, '2014-03-15 00:15:13.000000', 'temperatura', 748.0000, 'ºC'),
	(258550, 122, '2014-03-15 00:15:14.000000', 'temperatura', 700.0000, 'ºC'),
	(258551, 122, '2014-03-15 00:15:15.000000', 'temperatura', 54.0000, 'ºC'),
	(258552, 122, '2014-03-15 00:15:16.000000', 'temperatura', 574.0000, 'ºC'),
	(258553, 122, '2014-03-15 00:15:17.000000', 'temperatura', 307.0000, 'ºC'),
	(258554, 122, '2014-03-15 00:15:18.000000', 'temperatura', 1013.0000, 'ºC'),
	(258555, 122, '2014-03-15 00:15:19.000000', 'temperatura', 543.0000, 'ºC'),
	(258556, 122, '2014-03-15 00:15:20.000000', 'temperatura', 879.0000, 'ºC'),
	(258557, 122, '2014-03-15 00:15:21.000000', 'temperatura', 366.0000, 'ºC'),
	(258558, 122, '2014-03-15 00:15:22.000000', 'temperatura', 395.0000, 'ºC'),
	(258559, 122, '2014-03-15 00:15:23.000000', 'temperatura', 875.0000, 'ºC'),
	(258560, 122, '2014-03-15 00:15:24.000000', 'temperatura', 792.0000, 'ºC'),
	(258561, 122, '2014-03-15 00:15:25.000000', 'temperatura', 133.0000, 'ºC'),
	(258562, 122, '2014-03-15 00:15:26.000000', 'temperatura', 693.0000, 'ºC'),
	(258563, 122, '2014-03-15 00:15:27.000000', 'temperatura', 665.0000, 'ºC'),
	(258564, 122, '2014-03-15 00:15:28.000000', 'temperatura', 45.0000, 'ºC'),
	(258565, 122, '2014-03-15 00:15:29.000000', 'temperatura', 633.0000, 'ºC'),
	(258566, 122, '2014-03-15 00:15:30.000000', 'temperatura', 631.0000, 'ºC'),
	(258567, 122, '2014-03-15 00:15:31.000000', 'temperatura', 54.0000, 'ºC'),
	(258568, 122, '2014-03-15 00:15:32.000000', 'temperatura', 777.0000, 'ºC'),
	(258569, 122, '2014-03-15 00:15:33.000000', 'temperatura', 124.0000, 'ºC'),
	(258570, 122, '2014-03-15 00:15:34.000000', 'temperatura', 688.0000, 'ºC'),
	(258571, 122, '2014-03-15 00:15:35.000000', 'temperatura', 670.0000, 'ºC'),
	(258572, 122, '2014-03-15 00:15:36.000000', 'temperatura', 85.0000, 'ºC'),
	(258573, 122, '2014-03-15 00:15:37.000000', 'temperatura', 815.0000, 'ºC'),
	(258574, 122, '2014-03-15 00:15:38.000000', 'temperatura', 221.0000, 'ºC'),
	(258575, 122, '2014-03-15 00:15:39.000000', 'temperatura', 1060.0000, 'ºC'),
	(258576, 122, '2014-03-15 00:15:40.000000', 'temperatura', 1038.0000, 'ºC'),
	(258577, 122, '2014-03-15 00:15:41.000000', 'temperatura', 811.0000, 'ºC'),
	(258578, 122, '2014-03-15 00:15:42.000000', 'temperatura', 942.0000, 'ºC'),
	(258579, 122, '2014-03-15 00:15:43.000000', 'temperatura', 1077.0000, 'ºC'),
	(258580, 122, '2014-03-15 00:15:44.000000', 'temperatura', 161.0000, 'ºC'),
	(258581, 122, '2014-03-15 00:15:45.000000', 'temperatura', 1173.0000, 'ºC'),
	(258582, 122, '2014-03-15 00:15:46.000000', 'temperatura', 582.0000, 'ºC'),
	(258583, 122, '2014-03-15 00:15:47.000000', 'temperatura', 594.0000, 'ºC'),
	(258584, 122, '2014-03-15 00:15:48.000000', 'temperatura', 23.0000, 'ºC'),
	(258585, 122, '2014-03-15 00:15:49.000000', 'temperatura', 735.0000, 'ºC'),
	(258586, 122, '2014-03-15 00:15:50.000000', 'temperatura', 5.0000, 'ºC'),
	(258587, 122, '2014-03-15 00:15:51.000000', 'temperatura', 222.0000, 'ºC'),
	(258588, 122, '2014-03-15 00:15:52.000000', 'temperatura', 1096.0000, 'ºC'),
	(258589, 122, '2014-03-15 00:15:53.000000', 'temperatura', 15.0000, 'ºC'),
	(258590, 122, '2014-03-15 00:15:54.000000', 'temperatura', 388.0000, 'ºC'),
	(258591, 122, '2014-03-15 00:15:55.000000', 'temperatura', 695.0000, 'ºC'),
	(258592, 122, '2014-03-15 00:15:56.000000', 'temperatura', 1111.0000, 'ºC'),
	(258593, 122, '2014-03-15 00:15:57.000000', 'temperatura', 1071.0000, 'ºC'),
	(258594, 122, '2014-03-15 00:15:58.000000', 'temperatura', 821.0000, 'ºC'),
	(258595, 122, '2014-03-15 00:15:59.000000', 'temperatura', 893.0000, 'ºC'),
	(258596, 122, '2014-03-15 00:16:00.000000', 'temperatura', 801.0000, 'ºC'),
	(258597, 122, '2014-03-15 00:16:01.000000', 'temperatura', 127.0000, 'ºC'),
	(258598, 122, '2014-03-15 00:16:02.000000', 'temperatura', 632.0000, 'ºC'),
	(258599, 122, '2014-03-15 00:16:03.000000', 'temperatura', 381.0000, 'ºC'),
	(258600, 122, '2014-03-15 00:16:04.000000', 'temperatura', 8.0000, 'ºC'),
	(258601, 122, '2014-03-15 00:16:05.000000', 'temperatura', 100.0000, 'ºC'),
	(258602, 122, '2014-03-15 00:16:06.000000', 'temperatura', 474.0000, 'ºC'),
	(258603, 122, '2014-03-15 00:16:07.000000', 'temperatura', 871.0000, 'ºC'),
	(258604, 122, '2014-03-15 00:16:08.000000', 'temperatura', 535.0000, 'ºC'),
	(258605, 122, '2014-03-15 00:16:09.000000', 'temperatura', 61.0000, 'ºC'),
	(258606, 122, '2014-03-15 00:16:10.000000', 'temperatura', 1101.0000, 'ºC'),
	(258607, 122, '2014-03-15 00:16:11.000000', 'temperatura', 524.0000, 'ºC'),
	(258608, 122, '2014-03-15 00:16:12.000000', 'temperatura', 516.0000, 'ºC'),
	(258609, 122, '2014-03-15 00:16:13.000000', 'temperatura', 1008.0000, 'ºC'),
	(258610, 122, '2014-03-15 00:16:14.000000', 'temperatura', 1095.0000, 'ºC'),
	(258611, 122, '2014-03-15 00:16:15.000000', 'temperatura', 48.0000, 'ºC'),
	(258612, 122, '2014-03-15 00:16:16.000000', 'temperatura', 559.0000, 'ºC'),
	(258613, 122, '2014-03-15 00:16:17.000000', 'temperatura', 249.0000, 'ºC'),
	(258614, 122, '2014-03-15 00:16:18.000000', 'temperatura', 767.0000, 'ºC'),
	(258615, 122, '2014-03-15 00:16:19.000000', 'temperatura', 692.0000, 'ºC'),
	(258616, 122, '2014-03-15 00:16:20.000000', 'temperatura', 1156.0000, 'ºC'),
	(258617, 122, '2014-03-15 00:16:21.000000', 'temperatura', 106.0000, 'ºC'),
	(258618, 122, '2014-03-15 00:16:22.000000', 'temperatura', 664.0000, 'ºC'),
	(258619, 122, '2014-03-15 00:16:23.000000', 'temperatura', 603.0000, 'ºC'),
	(258620, 122, '2014-03-15 00:16:24.000000', 'temperatura', 1022.0000, 'ºC'),
	(258621, 122, '2014-03-15 00:16:25.000000', 'temperatura', 902.0000, 'ºC'),
	(258622, 122, '2014-03-15 00:16:26.000000', 'temperatura', 245.0000, 'ºC'),
	(258623, 122, '2014-03-15 00:16:27.000000', 'temperatura', 918.0000, 'ºC'),
	(258624, 122, '2014-03-15 00:16:28.000000', 'temperatura', 255.0000, 'ºC'),
	(258625, 122, '2014-03-15 00:16:29.000000', 'temperatura', 921.0000, 'ºC'),
	(258626, 122, '2014-03-15 00:16:30.000000', 'temperatura', 241.0000, 'ºC'),
	(258627, 122, '2014-03-15 00:16:31.000000', 'temperatura', 843.0000, 'ºC'),
	(258628, 122, '2014-03-15 00:16:32.000000', 'temperatura', 1092.0000, 'ºC'),
	(258629, 122, '2014-03-15 00:16:33.000000', 'temperatura', 530.0000, 'ºC'),
	(258630, 122, '2014-03-15 00:16:34.000000', 'temperatura', 576.0000, 'ºC'),
	(258631, 122, '2014-03-15 00:16:35.000000', 'temperatura', 89.0000, 'ºC'),
	(258632, 122, '2014-03-15 00:16:36.000000', 'temperatura', 1117.0000, 'ºC'),
	(258633, 122, '2014-03-15 00:16:37.000000', 'temperatura', 519.0000, 'ºC'),
	(258634, 122, '2014-03-15 00:16:38.000000', 'temperatura', 443.0000, 'ºC'),
	(258635, 122, '2014-03-15 00:16:39.000000', 'temperatura', 659.0000, 'ºC'),
	(258636, 122, '2014-03-15 00:16:40.000000', 'temperatura', 768.0000, 'ºC'),
	(258637, 122, '2014-03-15 00:16:41.000000', 'temperatura', 665.0000, 'ºC'),
	(258638, 122, '2014-03-15 00:16:42.000000', 'temperatura', 1019.0000, 'ºC'),
	(258639, 122, '2014-03-15 00:16:43.000000', 'temperatura', 701.0000, 'ºC'),
	(258640, 122, '2014-03-15 00:16:44.000000', 'temperatura', 447.0000, 'ºC'),
	(258641, 122, '2014-03-15 00:16:45.000000', 'temperatura', 133.0000, 'ºC'),
	(258642, 122, '2014-03-15 00:16:46.000000', 'temperatura', 523.0000, 'ºC'),
	(258643, 122, '2014-03-15 00:16:47.000000', 'temperatura', 1020.0000, 'ºC'),
	(258644, 122, '2014-03-15 00:16:48.000000', 'temperatura', 1128.0000, 'ºC'),
	(258645, 122, '2014-03-15 00:16:49.000000', 'temperatura', 184.0000, 'ºC'),
	(258646, 122, '2014-03-15 00:16:50.000000', 'temperatura', 1134.0000, 'ºC'),
	(258647, 122, '2014-03-15 00:16:51.000000', 'temperatura', 321.0000, 'ºC'),
	(258648, 122, '2014-03-15 00:16:52.000000', 'temperatura', 604.0000, 'ºC'),
	(258649, 122, '2014-03-15 00:16:53.000000', 'temperatura', 855.0000, 'ºC'),
	(258650, 122, '2014-03-15 00:16:54.000000', 'temperatura', 64.0000, 'ºC'),
	(258651, 122, '2014-03-15 00:16:55.000000', 'temperatura', 157.0000, 'ºC'),
	(258652, 122, '2014-03-15 00:16:56.000000', 'temperatura', 594.0000, 'ºC'),
	(258653, 122, '2014-03-15 00:16:57.000000', 'temperatura', 100.0000, 'ºC'),
	(258654, 122, '2014-03-15 00:16:58.000000', 'temperatura', 1119.0000, 'ºC'),
	(258655, 122, '2014-03-15 00:16:59.000000', 'temperatura', 493.0000, 'ºC'),
	(258656, 122, '2014-03-15 00:17:00.000000', 'temperatura', 309.0000, 'ºC'),
	(258657, 122, '2014-03-15 00:17:01.000000', 'temperatura', 68.0000, 'ºC'),
	(258658, 122, '2014-03-15 00:17:02.000000', 'temperatura', 613.0000, 'ºC'),
	(258659, 122, '2014-03-15 00:17:03.000000', 'temperatura', 462.0000, 'ºC'),
	(258660, 122, '2014-03-15 00:17:04.000000', 'temperatura', 472.0000, 'ºC'),
	(258661, 122, '2014-03-15 00:17:05.000000', 'temperatura', 976.0000, 'ºC'),
	(258662, 122, '2014-03-15 00:17:06.000000', 'temperatura', 1062.0000, 'ºC'),
	(258663, 122, '2014-03-15 00:17:07.000000', 'temperatura', 1182.0000, 'ºC'),
	(258664, 122, '2014-03-15 00:17:08.000000', 'temperatura', 327.0000, 'ºC'),
	(258665, 122, '2014-03-15 00:17:09.000000', 'temperatura', 489.0000, 'ºC'),
	(258666, 122, '2014-03-15 00:17:10.000000', 'temperatura', 264.0000, 'ºC'),
	(258667, 122, '2014-03-15 00:17:11.000000', 'temperatura', 1055.0000, 'ºC'),
	(258668, 122, '2014-03-15 00:17:12.000000', 'temperatura', 883.0000, 'ºC'),
	(258669, 122, '2014-03-15 00:17:13.000000', 'temperatura', 52.0000, 'ºC'),
	(258670, 122, '2014-03-15 00:17:14.000000', 'temperatura', 8.0000, 'ºC'),
	(258671, 122, '2014-03-15 00:17:15.000000', 'temperatura', 1087.0000, 'ºC'),
	(258672, 122, '2014-03-15 00:17:16.000000', 'temperatura', 609.0000, 'ºC'),
	(258673, 122, '2014-03-15 00:17:17.000000', 'temperatura', 987.0000, 'ºC'),
	(258674, 122, '2014-03-15 00:17:18.000000', 'temperatura', 706.0000, 'ºC'),
	(258675, 122, '2014-03-15 00:17:19.000000', 'temperatura', 568.0000, 'ºC'),
	(258676, 122, '2014-03-15 00:17:20.000000', 'temperatura', 726.0000, 'ºC'),
	(258677, 122, '2014-03-15 00:17:21.000000', 'temperatura', 727.0000, 'ºC'),
	(258678, 122, '2014-03-15 00:17:22.000000', 'temperatura', 258.0000, 'ºC'),
	(258679, 122, '2014-03-15 00:17:23.000000', 'temperatura', 309.0000, 'ºC'),
	(258680, 122, '2014-03-15 00:17:24.000000', 'temperatura', 773.0000, 'ºC'),
	(258681, 122, '2014-03-15 00:17:25.000000', 'temperatura', 537.0000, 'ºC'),
	(258682, 122, '2014-03-15 00:17:26.000000', 'temperatura', 366.0000, 'ºC'),
	(258683, 122, '2014-03-15 00:17:27.000000', 'temperatura', 218.0000, 'ºC'),
	(258684, 122, '2014-03-15 00:17:28.000000', 'temperatura', 1195.0000, 'ºC'),
	(258685, 122, '2014-03-15 00:17:29.000000', 'temperatura', 521.0000, 'ºC'),
	(258686, 122, '2014-03-15 00:17:30.000000', 'temperatura', 221.0000, 'ºC'),
	(258687, 122, '2014-03-15 00:17:31.000000', 'temperatura', 743.0000, 'ºC'),
	(258688, 122, '2014-03-15 00:17:32.000000', 'temperatura', 650.0000, 'ºC'),
	(258689, 122, '2014-03-15 00:17:33.000000', 'temperatura', 1022.0000, 'ºC'),
	(258690, 122, '2014-03-15 00:17:34.000000', 'temperatura', 761.0000, 'ºC'),
	(258691, 122, '2014-03-15 00:17:35.000000', 'temperatura', 738.0000, 'ºC'),
	(258692, 122, '2014-03-15 00:17:36.000000', 'temperatura', 209.0000, 'ºC'),
	(258693, 122, '2014-03-15 00:17:37.000000', 'temperatura', 33.0000, 'ºC'),
	(258694, 122, '2014-03-15 00:17:38.000000', 'temperatura', 736.0000, 'ºC'),
	(258695, 122, '2014-03-15 00:17:39.000000', 'temperatura', 1184.0000, 'ºC'),
	(258696, 122, '2014-03-15 00:17:40.000000', 'temperatura', 111.0000, 'ºC'),
	(258697, 122, '2014-03-15 00:17:41.000000', 'temperatura', 604.0000, 'ºC'),
	(258698, 122, '2014-03-15 00:17:42.000000', 'temperatura', 289.0000, 'ºC'),
	(258699, 122, '2014-03-15 00:17:43.000000', 'temperatura', 833.0000, 'ºC'),
	(258700, 122, '2014-03-15 00:17:44.000000', 'temperatura', 900.0000, 'ºC'),
	(258701, 122, '2014-03-15 00:17:45.000000', 'temperatura', 800.0000, 'ºC'),
	(258702, 122, '2014-03-15 00:17:46.000000', 'temperatura', 99.0000, 'ºC'),
	(258703, 122, '2014-03-15 00:17:47.000000', 'temperatura', 495.0000, 'ºC'),
	(258704, 122, '2014-03-15 00:17:48.000000', 'temperatura', 979.0000, 'ºC'),
	(258705, 122, '2014-03-15 00:17:49.000000', 'temperatura', 1009.0000, 'ºC'),
	(258706, 122, '2014-03-15 00:17:50.000000', 'temperatura', 910.0000, 'ºC'),
	(258707, 122, '2014-03-15 00:17:51.000000', 'temperatura', 325.0000, 'ºC'),
	(258708, 122, '2014-03-15 00:17:52.000000', 'temperatura', 96.0000, 'ºC'),
	(258709, 122, '2014-03-15 00:17:53.000000', 'temperatura', 705.0000, 'ºC'),
	(258710, 122, '2014-03-15 00:17:54.000000', 'temperatura', 835.0000, 'ºC'),
	(258711, 122, '2014-03-15 00:17:55.000000', 'temperatura', 862.0000, 'ºC'),
	(258712, 122, '2014-03-15 00:17:56.000000', 'temperatura', 604.0000, 'ºC'),
	(258713, 122, '2014-03-15 00:17:57.000000', 'temperatura', 435.0000, 'ºC'),
	(258714, 122, '2014-03-15 00:17:58.000000', 'temperatura', 363.0000, 'ºC'),
	(258715, 122, '2014-03-15 00:17:59.000000', 'temperatura', 510.0000, 'ºC'),
	(258716, 122, '2014-03-15 00:18:00.000000', 'temperatura', 262.0000, 'ºC'),
	(258717, 122, '2014-03-15 00:18:01.000000', 'temperatura', 981.0000, 'ºC'),
	(258718, 122, '2014-03-15 00:18:02.000000', 'temperatura', 519.0000, 'ºC'),
	(258719, 122, '2014-03-15 00:18:03.000000', 'temperatura', 851.0000, 'ºC'),
	(258720, 122, '2014-03-15 00:18:04.000000', 'temperatura', 299.0000, 'ºC'),
	(258721, 122, '2014-03-15 00:18:05.000000', 'temperatura', 145.0000, 'ºC'),
	(258722, 122, '2014-03-15 00:18:06.000000', 'temperatura', 1026.0000, 'ºC'),
	(258723, 122, '2014-03-15 00:18:07.000000', 'temperatura', 1095.0000, 'ºC'),
	(258724, 122, '2014-03-15 00:18:08.000000', 'temperatura', 1196.0000, 'ºC'),
	(258725, 122, '2014-03-15 00:18:09.000000', 'temperatura', 299.0000, 'ºC'),
	(258726, 122, '2014-03-15 00:18:10.000000', 'temperatura', 306.0000, 'ºC'),
	(258727, 122, '2014-03-15 00:18:11.000000', 'temperatura', 632.0000, 'ºC'),
	(258728, 122, '2014-03-15 00:18:12.000000', 'temperatura', 1045.0000, 'ºC'),
	(258729, 122, '2014-03-15 00:18:13.000000', 'temperatura', 929.0000, 'ºC'),
	(258730, 122, '2014-03-15 00:18:14.000000', 'temperatura', 310.0000, 'ºC'),
	(258731, 122, '2014-03-15 00:18:15.000000', 'temperatura', 1163.0000, 'ºC'),
	(258732, 122, '2014-03-15 00:18:16.000000', 'temperatura', 86.0000, 'ºC'),
	(258733, 122, '2014-03-15 00:18:17.000000', 'temperatura', 542.0000, 'ºC'),
	(258734, 122, '2014-03-15 00:18:18.000000', 'temperatura', 52.0000, 'ºC'),
	(258735, 122, '2014-03-15 00:18:19.000000', 'temperatura', 1035.0000, 'ºC'),
	(258736, 122, '2014-03-15 00:18:20.000000', 'temperatura', 221.0000, 'ºC'),
	(258737, 122, '2014-03-15 00:18:21.000000', 'temperatura', 399.0000, 'ºC'),
	(258738, 122, '2014-03-15 00:18:22.000000', 'temperatura', 134.0000, 'ºC'),
	(258739, 122, '2014-03-15 00:18:23.000000', 'temperatura', 671.0000, 'ºC'),
	(258740, 122, '2014-03-15 00:18:24.000000', 'temperatura', 553.0000, 'ºC'),
	(258741, 122, '2014-03-15 00:18:25.000000', 'temperatura', 754.0000, 'ºC'),
	(258742, 122, '2014-03-15 00:18:26.000000', 'temperatura', 912.0000, 'ºC'),
	(258743, 122, '2014-03-15 00:18:27.000000', 'temperatura', 1097.0000, 'ºC'),
	(258744, 122, '2014-03-15 00:18:28.000000', 'temperatura', 352.0000, 'ºC'),
	(258745, 122, '2014-03-15 00:18:29.000000', 'temperatura', 868.0000, 'ºC'),
	(258746, 122, '2014-03-15 00:18:30.000000', 'temperatura', 884.0000, 'ºC'),
	(258747, 122, '2014-03-15 00:18:31.000000', 'temperatura', 615.0000, 'ºC'),
	(258748, 122, '2014-03-15 00:18:32.000000', 'temperatura', 425.0000, 'ºC'),
	(258749, 122, '2014-03-15 00:18:33.000000', 'temperatura', 282.0000, 'ºC'),
	(258750, 122, '2014-03-15 00:18:34.000000', 'temperatura', 134.0000, 'ºC'),
	(258751, 122, '2014-03-15 00:18:35.000000', 'temperatura', 1024.0000, 'ºC'),
	(258752, 122, '2014-03-15 00:18:36.000000', 'temperatura', 1119.0000, 'ºC'),
	(258753, 122, '2014-03-15 00:18:37.000000', 'temperatura', 125.0000, 'ºC'),
	(258754, 122, '2014-03-15 00:18:38.000000', 'temperatura', 868.0000, 'ºC'),
	(258755, 122, '2014-03-15 00:18:39.000000', 'temperatura', 366.0000, 'ºC'),
	(258756, 122, '2014-03-15 00:18:40.000000', 'temperatura', 427.0000, 'ºC'),
	(258757, 122, '2014-03-15 00:18:41.000000', 'temperatura', 1035.0000, 'ºC'),
	(258758, 122, '2014-03-15 00:18:42.000000', 'temperatura', 298.0000, 'ºC'),
	(258759, 122, '2014-03-15 00:18:43.000000', 'temperatura', 783.0000, 'ºC'),
	(258760, 122, '2014-03-15 00:18:44.000000', 'temperatura', 622.0000, 'ºC'),
	(258761, 122, '2014-03-15 00:18:45.000000', 'temperatura', 760.0000, 'ºC'),
	(258762, 122, '2014-03-15 00:18:46.000000', 'temperatura', 736.0000, 'ºC'),
	(258763, 122, '2014-03-15 00:18:47.000000', 'temperatura', 201.0000, 'ºC'),
	(258764, 122, '2014-03-15 00:18:48.000000', 'temperatura', 1196.0000, 'ºC'),
	(258765, 122, '2014-03-15 00:18:49.000000', 'temperatura', 577.0000, 'ºC'),
	(258766, 122, '2014-03-15 00:18:50.000000', 'temperatura', 500.0000, 'ºC'),
	(258767, 122, '2014-03-15 00:18:51.000000', 'temperatura', 768.0000, 'ºC'),
	(258768, 122, '2014-03-15 00:18:52.000000', 'temperatura', 1140.0000, 'ºC'),
	(258769, 122, '2014-03-15 00:18:53.000000', 'temperatura', 998.0000, 'ºC'),
	(258770, 122, '2014-03-15 00:18:54.000000', 'temperatura', 371.0000, 'ºC'),
	(258771, 122, '2014-03-15 00:18:55.000000', 'temperatura', 60.0000, 'ºC'),
	(258772, 122, '2014-03-15 00:18:56.000000', 'temperatura', 388.0000, 'ºC'),
	(258773, 122, '2014-03-15 00:18:57.000000', 'temperatura', 559.0000, 'ºC'),
	(258774, 122, '2014-03-15 00:18:58.000000', 'temperatura', 434.0000, 'ºC'),
	(258775, 122, '2014-03-15 00:18:59.000000', 'temperatura', 493.0000, 'ºC'),
	(258776, 122, '2014-03-15 00:19:00.000000', 'temperatura', 1165.0000, 'ºC'),
	(258777, 122, '2014-03-15 00:19:01.000000', 'temperatura', 745.0000, 'ºC'),
	(258778, 122, '2014-03-15 00:19:02.000000', 'temperatura', 230.0000, 'ºC'),
	(258779, 122, '2014-03-15 00:19:03.000000', 'temperatura', 116.0000, 'ºC'),
	(258780, 122, '2014-03-15 00:19:04.000000', 'temperatura', 1089.0000, 'ºC'),
	(258781, 122, '2014-03-15 00:19:05.000000', 'temperatura', 298.0000, 'ºC'),
	(258782, 122, '2014-03-15 00:19:06.000000', 'temperatura', 624.0000, 'ºC'),
	(258783, 122, '2014-03-15 00:19:07.000000', 'temperatura', 1027.0000, 'ºC'),
	(258784, 122, '2014-03-15 00:19:08.000000', 'temperatura', 863.0000, 'ºC'),
	(258785, 122, '2014-03-15 00:19:09.000000', 'temperatura', 35.0000, 'ºC'),
	(258786, 122, '2014-03-15 00:19:10.000000', 'temperatura', 1187.0000, 'ºC'),
	(258787, 122, '2014-03-15 00:19:11.000000', 'temperatura', 1031.0000, 'ºC'),
	(258788, 122, '2014-03-15 00:19:12.000000', 'temperatura', 392.0000, 'ºC'),
	(258789, 122, '2014-03-15 00:19:13.000000', 'temperatura', 69.0000, 'ºC'),
	(258790, 122, '2014-03-15 00:19:14.000000', 'temperatura', 368.0000, 'ºC'),
	(258791, 122, '2014-03-15 00:19:15.000000', 'temperatura', 433.0000, 'ºC'),
	(258792, 122, '2014-03-15 00:19:16.000000', 'temperatura', 1062.0000, 'ºC'),
	(258793, 122, '2014-03-15 00:19:17.000000', 'temperatura', 413.0000, 'ºC'),
	(258794, 122, '2014-03-15 00:19:18.000000', 'temperatura', 78.0000, 'ºC'),
	(258795, 122, '2014-03-15 00:19:19.000000', 'temperatura', 354.0000, 'ºC'),
	(258796, 122, '2014-03-15 00:19:20.000000', 'temperatura', 334.0000, 'ºC'),
	(258797, 122, '2014-03-15 00:19:21.000000', 'temperatura', 610.0000, 'ºC'),
	(258798, 122, '2014-03-15 00:19:22.000000', 'temperatura', 850.0000, 'ºC'),
	(258799, 122, '2014-03-15 00:19:23.000000', 'temperatura', 19.0000, 'ºC'),
	(258800, 122, '2014-03-15 00:19:24.000000', 'temperatura', 1144.0000, 'ºC'),
	(258801, 122, '2014-03-15 00:19:25.000000', 'temperatura', 863.0000, 'ºC'),
	(258802, 122, '2014-03-15 00:19:26.000000', 'temperatura', 885.0000, 'ºC'),
	(258803, 122, '2014-03-15 00:19:27.000000', 'temperatura', 638.0000, 'ºC'),
	(258804, 122, '2014-03-15 00:19:28.000000', 'temperatura', 535.0000, 'ºC'),
	(258805, 122, '2014-03-15 00:19:29.000000', 'temperatura', 763.0000, 'ºC'),
	(258806, 122, '2014-03-15 00:19:30.000000', 'temperatura', 1008.0000, 'ºC'),
	(258807, 122, '2014-03-15 00:19:31.000000', 'temperatura', 353.0000, 'ºC'),
	(258808, 122, '2014-03-15 00:19:32.000000', 'temperatura', 1143.0000, 'ºC'),
	(258809, 122, '2014-03-15 00:19:33.000000', 'temperatura', 1054.0000, 'ºC'),
	(258810, 122, '2014-03-15 00:19:34.000000', 'temperatura', 643.0000, 'ºC'),
	(258811, 122, '2014-03-15 00:19:35.000000', 'temperatura', 55.0000, 'ºC'),
	(258812, 122, '2014-03-15 00:19:36.000000', 'temperatura', 745.0000, 'ºC'),
	(258813, 122, '2014-03-15 00:19:37.000000', 'temperatura', 1162.0000, 'ºC'),
	(258814, 122, '2014-03-15 00:19:38.000000', 'temperatura', 1173.0000, 'ºC'),
	(258815, 122, '2014-03-15 00:19:39.000000', 'temperatura', 1181.0000, 'ºC'),
	(258816, 122, '2014-03-15 00:19:40.000000', 'temperatura', 1188.0000, 'ºC'),
	(258817, 122, '2014-03-15 00:19:41.000000', 'temperatura', 1197.0000, 'ºC'),
	(258818, 122, '2014-03-15 00:19:42.000000', 'temperatura', 20.0000, 'ºC'),
	(258819, 122, '2014-03-15 00:19:43.000000', 'temperatura', 112.0000, 'ºC'),
	(258820, 122, '2014-03-15 00:19:44.000000', 'temperatura', 499.0000, 'ºC'),
	(258821, 122, '2014-03-15 00:19:45.000000', 'temperatura', 959.0000, 'ºC'),
	(258822, 122, '2014-03-15 00:19:46.000000', 'temperatura', 900.0000, 'ºC'),
	(258823, 122, '2014-03-15 00:19:47.000000', 'temperatura', 423.0000, 'ºC'),
	(258824, 122, '2014-03-15 00:19:48.000000', 'temperatura', 615.0000, 'ºC'),
	(258825, 122, '2014-03-15 00:19:49.000000', 'temperatura', 608.0000, 'ºC'),
	(258826, 122, '2014-03-15 00:19:50.000000', 'temperatura', 1193.0000, 'ºC'),
	(258827, 122, '2014-03-15 00:19:51.000000', 'temperatura', 542.0000, 'ºC'),
	(258828, 122, '2014-03-15 00:19:52.000000', 'temperatura', 331.0000, 'ºC'),
	(258829, 122, '2014-03-15 00:19:53.000000', 'temperatura', 29.0000, 'ºC'),
	(258830, 122, '2014-03-15 00:19:54.000000', 'temperatura', 355.0000, 'ºC'),
	(258831, 122, '2014-03-15 00:19:55.000000', 'temperatura', 487.0000, 'ºC'),
	(258832, 122, '2014-03-15 00:19:56.000000', 'temperatura', 173.0000, 'ºC'),
	(258833, 122, '2014-03-15 00:19:57.000000', 'temperatura', 601.0000, 'ºC'),
	(258834, 122, '2014-03-15 00:19:58.000000', 'temperatura', 90.0000, 'ºC'),
	(258835, 122, '2014-03-15 00:19:59.000000', 'temperatura', 1044.0000, 'ºC'),
	(258836, 122, '2014-03-15 00:20:00.000000', 'temperatura', 152.0000, 'ºC'),
	(258837, 122, '2014-03-15 00:20:01.000000', 'temperatura', 29.0000, 'ºC'),
	(258838, 122, '2014-03-15 00:20:02.000000', 'temperatura', 887.0000, 'ºC'),
	(258839, 122, '2014-03-15 00:20:03.000000', 'temperatura', 752.0000, 'ºC'),
	(258840, 122, '2014-03-15 00:20:04.000000', 'temperatura', 1097.0000, 'ºC'),
	(258841, 122, '2014-03-15 00:20:05.000000', 'temperatura', 831.0000, 'ºC'),
	(258842, 122, '2014-03-15 00:20:06.000000', 'temperatura', 863.0000, 'ºC'),
	(258843, 122, '2014-03-15 00:20:07.000000', 'temperatura', 622.0000, 'ºC'),
	(258844, 122, '2014-03-15 00:20:08.000000', 'temperatura', 524.0000, 'ºC'),
	(258845, 122, '2014-03-15 00:20:09.000000', 'temperatura', 753.0000, 'ºC'),
	(258846, 122, '2014-03-15 00:20:10.000000', 'temperatura', 995.0000, 'ºC'),
	(258847, 122, '2014-03-15 00:20:11.000000', 'temperatura', 314.0000, 'ºC'),
	(258848, 122, '2014-03-15 00:20:12.000000', 'temperatura', 986.0000, 'ºC'),
	(258849, 122, '2014-03-15 00:20:13.000000', 'temperatura', 388.0000, 'ºC'),
	(258850, 122, '2014-03-15 00:20:14.000000', 'temperatura', 184.0000, 'ºC'),
	(258851, 122, '2014-03-15 00:20:15.000000', 'temperatura', 958.0000, 'ºC'),
	(258852, 122, '2014-03-15 00:20:16.000000', 'temperatura', 635.0000, 'ºC'),
	(258853, 122, '2014-03-15 00:20:17.000000', 'temperatura', 304.0000, 'ºC'),
	(258854, 122, '2014-03-15 00:20:18.000000', 'temperatura', 815.0000, 'ºC'),
	(258855, 122, '2014-03-15 00:20:19.000000', 'temperatura', 764.0000, 'ºC'),
	(258856, 122, '2014-03-15 00:20:20.000000', 'temperatura', 175.0000, 'ºC'),
	(258857, 122, '2014-03-15 00:20:21.000000', 'temperatura', 984.0000, 'ºC'),
	(258858, 122, '2014-03-15 00:20:22.000000', 'temperatura', 794.0000, 'ºC'),
	(258859, 122, '2014-03-15 00:20:23.000000', 'temperatura', 1018.0000, 'ºC'),
	(258860, 122, '2014-03-15 00:20:24.000000', 'temperatura', 308.0000, 'ºC'),
	(258861, 122, '2014-03-15 00:20:25.000000', 'temperatura', 889.0000, 'ºC'),
	(258862, 122, '2014-03-15 00:20:26.000000', 'temperatura', 1120.0000, 'ºC'),
	(258863, 122, '2014-03-15 00:20:27.000000', 'temperatura', 533.0000, 'ºC'),
	(258864, 122, '2014-03-15 00:20:28.000000', 'temperatura', 508.0000, 'ºC'),
	(258865, 122, '2014-03-15 00:20:29.000000', 'temperatura', 938.0000, 'ºC'),
	(258866, 122, '2014-03-15 00:20:30.000000', 'temperatura', 769.0000, 'ºC'),
	(258867, 122, '2014-03-15 00:20:31.000000', 'temperatura', 1031.0000, 'ºC'),
	(258868, 122, '2014-03-15 00:20:32.000000', 'temperatura', 447.0000, 'ºC'),
	(258869, 122, '2014-03-15 00:20:33.000000', 'temperatura', 343.0000, 'ºC'),
	(258870, 122, '2014-03-15 00:20:34.000000', 'temperatura', 376.0000, 'ºC'),
	(258871, 122, '2014-03-15 00:20:35.000000', 'temperatura', 849.0000, 'ºC'),
	(258872, 122, '2014-03-15 00:20:36.000000', 'temperatura', 717.0000, 'ºC'),
	(258873, 122, '2014-03-15 00:20:37.000000', 'temperatura', 1041.0000, 'ºC'),
	(258874, 122, '2014-03-15 00:20:38.000000', 'temperatura', 655.0000, 'ºC'),
	(258875, 122, '2014-03-15 00:20:39.000000', 'temperatura', 151.0000, 'ºC'),
	(258876, 122, '2014-03-15 00:20:40.000000', 'temperatura', 1193.0000, 'ºC'),
	(258877, 122, '2014-03-15 00:20:41.000000', 'temperatura', 710.0000, 'ºC'),
	(258878, 122, '2014-03-15 00:20:42.000000', 'temperatura', 1171.0000, 'ºC'),
	(258879, 122, '2014-03-15 00:20:43.000000', 'temperatura', 125.0000, 'ºC'),
	(258880, 122, '2014-03-15 00:20:44.000000', 'temperatura', 713.0000, 'ºC'),
	(258881, 122, '2014-03-15 00:20:45.000000', 'temperatura', 790.0000, 'ºC'),
	(258882, 122, '2014-03-15 00:20:46.000000', 'temperatura', 611.0000, 'ºC'),
	(258883, 122, '2014-03-15 00:20:47.000000', 'temperatura', 686.0000, 'ºC'),
	(258884, 122, '2014-03-15 00:20:48.000000', 'temperatura', 398.0000, 'ºC'),
	(258885, 122, '2014-03-15 00:20:49.000000', 'temperatura', 1132.0000, 'ºC'),
	(258886, 122, '2014-03-15 00:20:50.000000', 'temperatura', 865.0000, 'ºC'),
	(258887, 122, '2014-03-15 00:20:51.000000', 'temperatura', 933.0000, 'ºC'),
	(258888, 122, '2014-03-15 00:20:52.000000', 'temperatura', 867.0000, 'ºC'),
	(258889, 122, '2014-03-15 00:20:53.000000', 'temperatura', 339.0000, 'ºC'),
	(258890, 122, '2014-03-15 00:20:54.000000', 'temperatura', 295.0000, 'ºC'),
	(258891, 122, '2014-03-15 00:20:55.000000', 'temperatura', 457.0000, 'ºC'),
	(258892, 122, '2014-03-15 00:20:56.000000', 'temperatura', 202.0000, 'ºC'),
	(258893, 122, '2014-03-15 00:20:57.000000', 'temperatura', 840.0000, 'ºC'),
	(258894, 122, '2014-03-15 00:20:58.000000', 'temperatura', 1192.0000, 'ºC'),
	(258895, 122, '2014-03-15 00:20:59.000000', 'temperatura', 1042.0000, 'ºC'),
	(258896, 122, '2014-03-15 00:21:00.000000', 'temperatura', 434.0000, 'ºC'),
	(258897, 122, '2014-03-15 00:21:01.000000', 'temperatura', 245.0000, 'ºC'),
	(258898, 122, '2014-03-15 00:21:02.000000', 'temperatura', 1122.0000, 'ºC'),
	(258899, 122, '2014-03-15 00:21:03.000000', 'temperatura', 77.0000, 'ºC'),
	(258900, 122, '2014-03-15 00:21:04.000000', 'temperatura', 618.0000, 'ºC'),
	(258901, 122, '2014-03-15 00:21:05.000000', 'temperatura', 459.0000, 'ºC'),
	(258902, 122, '2014-03-15 00:21:06.000000', 'temperatura', 441.0000, 'ºC'),
	(258903, 122, '2014-03-15 00:21:07.000000', 'temperatura', 828.0000, 'ºC'),
	(258904, 122, '2014-03-15 00:21:08.000000', 'temperatura', 417.0000, 'ºC'),
	(258905, 122, '2014-03-15 00:21:09.000000', 'temperatura', 804.0000, 'ºC'),
	(258906, 122, '2014-03-15 00:21:10.000000', 'temperatura', 368.0000, 'ºC'),
	(258907, 122, '2014-03-15 00:21:11.000000', 'temperatura', 630.0000, 'ºC'),
	(258908, 122, '2014-03-15 00:21:12.000000', 'temperatura', 845.0000, 'ºC'),
	(258909, 122, '2014-03-15 00:21:13.000000', 'temperatura', 1134.0000, 'ºC'),
	(258910, 122, '2014-03-15 00:21:14.000000', 'temperatura', 737.0000, 'ºC'),
	(258911, 122, '2014-03-15 00:21:15.000000', 'temperatura', 282.0000, 'ºC'),
	(258912, 122, '2014-03-15 00:21:16.000000', 'temperatura', 400.0000, 'ºC'),
	(258913, 122, '2014-03-15 00:21:17.000000', 'temperatura', 1156.0000, 'ºC'),
	(258914, 122, '2014-03-15 00:21:18.000000', 'temperatura', 979.0000, 'ºC'),
	(258915, 122, '2014-03-15 00:21:19.000000', 'temperatura', 230.0000, 'ºC'),
	(258916, 122, '2014-03-15 00:21:20.000000', 'temperatura', 611.0000, 'ºC'),
	(258917, 122, '2014-03-15 00:21:21.000000', 'temperatura', 1168.0000, 'ºC'),
	(258918, 122, '2014-03-15 00:21:22.000000', 'temperatura', 407.0000, 'ºC'),
	(258919, 122, '2014-03-15 00:21:23.000000', 'temperatura', 929.0000, 'ºC'),
	(258920, 122, '2014-03-15 00:21:24.000000', 'temperatura', 1026.0000, 'ºC'),
	(258921, 122, '2014-03-15 00:21:25.000000', 'temperatura', 1144.0000, 'ºC'),
	(258922, 122, '2014-03-15 00:21:26.000000', 'temperatura', 242.0000, 'ºC'),
	(258923, 122, '2014-03-15 00:21:27.000000', 'temperatura', 178.0000, 'ºC'),
	(258924, 122, '2014-03-15 00:21:28.000000', 'temperatura', 164.0000, 'ºC'),
	(258925, 122, '2014-03-15 00:21:29.000000', 'temperatura', 288.0000, 'ºC'),
	(258926, 122, '2014-03-15 00:21:30.000000', 'temperatura', 948.0000, 'ºC'),
	(258927, 122, '2014-03-15 00:21:31.000000', 'temperatura', 277.0000, 'ºC'),
	(258928, 122, '2014-03-15 00:21:32.000000', 'temperatura', 943.0000, 'ºC'),
	(258929, 122, '2014-03-15 00:21:33.000000', 'temperatura', 282.0000, 'ºC'),
	(258930, 122, '2014-03-15 00:21:34.000000', 'temperatura', 984.0000, 'ºC'),
	(258931, 122, '2014-03-15 00:21:35.000000', 'temperatura', 472.0000, 'ºC'),
	(258932, 122, '2014-03-15 00:21:36.000000', 'temperatura', 611.0000, 'ºC'),
	(258933, 122, '2014-03-15 00:21:37.000000', 'temperatura', 440.0000, 'ºC'),
	(258934, 122, '2014-03-15 00:21:38.000000', 'temperatura', 367.0000, 'ºC'),
	(258935, 122, '2014-03-15 00:21:39.000000', 'temperatura', 515.0000, 'ºC'),
	(258936, 122, '2014-03-15 00:21:40.000000', 'temperatura', 275.0000, 'ºC'),
	(258937, 122, '2014-03-15 00:21:41.000000', 'temperatura', 1030.0000, 'ºC'),
	(258938, 122, '2014-03-15 00:21:42.000000', 'temperatura', 727.0000, 'ºC'),
	(258939, 122, '2014-03-15 00:21:43.000000', 'temperatura', 546.0000, 'ºC'),
	(258940, 122, '2014-03-15 00:21:44.000000', 'temperatura', 547.0000, 'ºC'),
	(258941, 122, '2014-03-15 00:21:45.000000', 'temperatura', 1098.0000, 'ºC'),
	(258942, 122, '2014-03-15 00:21:46.000000', 'temperatura', 251.0000, 'ºC'),
	(258943, 122, '2014-03-15 00:21:47.000000', 'temperatura', 360.0000, 'ºC'),
	(258944, 122, '2014-03-15 00:21:48.000000', 'temperatura', 1050.0000, 'ºC'),
	(258945, 122, '2014-03-15 00:21:49.000000', 'temperatura', 570.0000, 'ºC'),
	(258946, 122, '2014-03-15 00:21:50.000000', 'temperatura', 898.0000, 'ºC'),
	(258947, 122, '2014-03-15 00:21:51.000000', 'temperatura', 381.0000, 'ºC'),
	(258948, 122, '2014-03-15 00:21:52.000000', 'temperatura', 413.0000, 'ºC'),
	(258949, 122, '2014-03-15 00:21:53.000000', 'temperatura', 920.0000, 'ºC'),
	(258950, 122, '2014-03-15 00:21:54.000000', 'temperatura', 964.0000, 'ºC'),
	(258951, 122, '2014-03-15 00:21:55.000000', 'temperatura', 861.0000, 'ºC'),
	(258952, 122, '2014-03-15 00:21:56.000000', 'temperatura', 214.0000, 'ºC'),
	(258953, 122, '2014-03-15 00:21:57.000000', 'temperatura', 887.0000, 'ºC'),
	(258954, 122, '2014-03-15 00:21:58.000000', 'temperatura', 194.0000, 'ºC'),
	(258955, 122, '2014-03-15 00:21:59.000000', 'temperatura', 709.0000, 'ºC'),
	(258956, 122, '2014-03-15 00:22:00.000000', 'temperatura', 561.0000, 'ºC'),
	(258957, 122, '2014-03-15 00:22:01.000000', 'temperatura', 682.0000, 'ºC'),
	(258958, 122, '2014-03-15 00:22:02.000000', 'temperatura', 528.0000, 'ºC'),
	(258959, 122, '2014-03-15 00:22:03.000000', 'temperatura', 592.0000, 'ºC'),
	(258960, 122, '2014-03-15 00:22:04.000000', 'temperatura', 178.0000, 'ºC'),
	(258961, 122, '2014-03-15 00:22:05.000000', 'temperatura', 313.0000, 'ºC'),
	(258962, 122, '2014-03-15 00:22:06.000000', 'temperatura', 1030.0000, 'ºC'),
	(258963, 122, '2014-03-15 00:22:07.000000', 'temperatura', 614.0000, 'ºC'),
	(258964, 122, '2014-03-15 00:22:08.000000', 'temperatura', 1181.0000, 'ºC'),
	(258965, 122, '2014-03-15 00:22:09.000000', 'temperatura', 465.0000, 'ºC'),
	(258966, 122, '2014-03-15 00:22:10.000000', 'temperatura', 1179.0000, 'ºC'),
	(258967, 122, '2014-03-15 00:22:11.000000', 'temperatura', 902.0000, 'ºC'),
	(258968, 122, '2014-03-15 00:22:12.000000', 'temperatura', 975.0000, 'ºC'),
	(258969, 122, '2014-03-15 00:22:13.000000', 'temperatura', 969.0000, 'ºC'),
	(258970, 122, '2014-03-15 00:22:14.000000', 'temperatura', 720.0000, 'ºC'),
	(258971, 122, '2014-03-15 00:22:15.000000', 'temperatura', 693.0000, 'ºC'),
	(258972, 122, '2014-03-15 00:22:16.000000', 'temperatura', 105.0000, 'ºC'),
	(258973, 122, '2014-03-15 00:22:17.000000', 'temperatura', 847.0000, 'ºC'),
	(258974, 122, '2014-03-15 00:22:18.000000', 'temperatura', 321.0000, 'ºC'),
	(258975, 122, '2014-03-15 00:22:19.000000', 'temperatura', 262.0000, 'ºC'),
	(258976, 122, '2014-03-15 00:22:20.000000', 'temperatura', 350.0000, 'ºC'),
	(258977, 122, '2014-03-15 00:22:21.000000', 'temperatura', 966.0000, 'ºC'),
	(258978, 122, '2014-03-15 00:22:22.000000', 'temperatura', 178.0000, 'ºC'),
	(258979, 122, '2014-03-15 00:22:23.000000', 'temperatura', 395.0000, 'ºC'),
	(258980, 122, '2014-03-15 00:22:24.000000', 'temperatura', 238.0000, 'ºC'),
	(258981, 122, '2014-03-15 00:22:25.000000', 'temperatura', 8.0000, 'ºC'),
	(258982, 122, '2014-03-15 00:22:26.000000', 'temperatura', 527.0000, 'ºC'),
	(258983, 122, '2014-03-15 00:22:27.000000', 'temperatura', 210.0000, 'ºC'),
	(258984, 122, '2014-03-15 00:22:28.000000', 'temperatura', 671.0000, 'ºC'),
	(258985, 122, '2014-03-15 00:22:29.000000', 'temperatura', 326.0000, 'ºC'),
	(258986, 122, '2014-03-15 00:22:30.000000', 'temperatura', 815.0000, 'ºC'),
	(258987, 122, '2014-03-15 00:22:31.000000', 'temperatura', 700.0000, 'ºC'),
	(258988, 122, '2014-03-15 00:22:32.000000', 'temperatura', 1054.0000, 'ºC'),
	(258989, 122, '2014-03-15 00:22:33.000000', 'temperatura', 772.0000, 'ºC'),
	(258990, 122, '2014-03-15 00:22:34.000000', 'temperatura', 696.0000, 'ºC'),
	(258991, 122, '2014-03-15 00:22:35.000000', 'temperatura', 1167.0000, 'ºC'),
	(258992, 122, '2014-03-15 00:22:36.000000', 'temperatura', 146.0000, 'ºC'),
	(258993, 122, '2014-03-15 00:22:37.000000', 'temperatura', 830.0000, 'ºC'),
	(258994, 122, '2014-03-15 00:22:38.000000', 'temperatura', 111.0000, 'ºC'),
	(258995, 122, '2014-03-15 00:22:39.000000', 'temperatura', 465.0000, 'ºC'),
	(258996, 122, '2014-03-15 00:22:40.000000', 'temperatura', 795.0000, 'ºC'),
	(258997, 122, '2014-03-15 00:22:41.000000', 'temperatura', 179.0000, 'ºC'),
	(258998, 122, '2014-03-15 00:22:42.000000', 'temperatura', 911.0000, 'ºC'),
	(258999, 122, '2014-03-15 00:22:43.000000', 'temperatura', 417.0000, 'ºC'),
	(259000, 122, '2014-03-15 00:22:44.000000', 'temperatura', 555.0000, 'ºC'),
	(259001, 122, '2014-03-15 00:22:45.000000', 'temperatura', 324.0000, 'ºC'),
	(259002, 122, '2014-03-15 00:22:46.000000', 'temperatura', 1154.0000, 'ºC'),
	(259003, 122, '2014-03-15 00:22:47.000000', 'temperatura', 1197.0000, 'ºC'),
	(259004, 122, '2014-03-15 00:22:48.000000', 'temperatura', 126.0000, 'ºC'),
	(259005, 122, '2014-03-15 00:22:49.000000', 'temperatura', 638.0000, 'ºC'),
	(259006, 122, '2014-03-15 00:22:50.000000', 'temperatura', 414.0000, 'ºC'),
	(259007, 122, '2014-03-15 00:22:51.000000', 'temperatura', 155.0000, 'ºC'),
	(259008, 122, '2014-03-15 00:22:52.000000', 'temperatura', 734.0000, 'ºC'),
	(259009, 122, '2014-03-15 00:22:53.000000', 'temperatura', 806.0000, 'ºC'),
	(259010, 122, '2014-03-15 00:22:54.000000', 'temperatura', 629.0000, 'ºC'),
	(259011, 122, '2014-03-15 00:22:55.000000', 'temperatura', 727.0000, 'ºC'),
	(259012, 122, '2014-03-15 00:22:56.000000', 'temperatura', 549.0000, 'ºC'),
	(259013, 122, '2014-03-15 00:22:57.000000', 'temperatura', 563.0000, 'ºC'),
	(259014, 122, '2014-03-15 00:22:58.000000', 'temperatura', 1170.0000, 'ºC'),
	(259015, 122, '2014-03-15 00:22:59.000000', 'temperatura', 559.0000, 'ºC'),
	(259016, 122, '2014-03-15 00:23:00.000000', 'temperatura', 487.0000, 'ºC'),
	(259017, 122, '2014-03-15 00:23:01.000000', 'temperatura', 758.0000, 'ºC'),
	(259018, 122, '2014-03-15 00:23:02.000000', 'temperatura', 1132.0000, 'ºC'),
	(259019, 122, '2014-03-15 00:23:03.000000', 'temperatura', 984.0000, 'ºC'),
	(259020, 122, '2014-03-15 00:23:04.000000', 'temperatura', 325.0000, 'ºC'),
	(259021, 122, '2014-03-15 00:23:05.000000', 'temperatura', 1076.0000, 'ºC'),
	(259022, 122, '2014-03-15 00:23:06.000000', 'temperatura', 802.0000, 'ºC'),
	(259023, 122, '2014-03-15 00:23:07.000000', 'temperatura', 785.0000, 'ºC'),
	(259024, 122, '2014-03-15 00:23:08.000000', 'temperatura', 320.0000, 'ºC'),
	(259025, 122, '2014-03-15 00:23:09.000000', 'temperatura', 444.0000, 'ºC'),
	(259026, 122, '2014-03-15 00:23:10.000000', 'temperatura', 61.0000, 'ºC'),
	(259027, 122, '2014-03-15 00:23:11.000000', 'temperatura', 173.0000, 'ºC'),
	(259028, 122, '2014-03-15 00:23:12.000000', 'temperatura', 685.0000, 'ºC'),
	(259029, 122, '2014-03-15 00:23:13.000000', 'temperatura', 505.0000, 'ºC'),
	(259030, 122, '2014-03-15 00:23:14.000000', 'temperatura', 469.0000, 'ºC'),
	(259031, 122, '2014-03-15 00:23:15.000000', 'temperatura', 830.0000, 'ºC'),
	(259032, 122, '2014-03-15 00:23:16.000000', 'temperatura', 346.0000, 'ºC'),
	(259033, 122, '2014-03-15 00:23:17.000000', 'temperatura', 438.0000, 'ºC'),
	(259034, 122, '2014-03-15 00:23:18.000000', 'temperatura', 1153.0000, 'ºC'),
	(259035, 122, '2014-03-15 00:23:19.000000', 'temperatura', 852.0000, 'ºC'),
	(259036, 122, '2014-03-15 00:23:20.000000', 'temperatura', 801.0000, 'ºC'),
	(259037, 122, '2014-03-15 00:23:21.000000', 'temperatura', 251.0000, 'ºC'),
	(259038, 122, '2014-03-15 00:23:22.000000', 'temperatura', 50.0000, 'ºC'),
	(259039, 122, '2014-03-15 00:23:23.000000', 'temperatura', 699.0000, 'ºC'),
	(259040, 122, '2014-03-15 00:23:24.000000', 'temperatura', 946.0000, 'ºC'),
	(259041, 122, '2014-03-15 00:23:25.000000', 'temperatura', 235.0000, 'ºC'),
	(259042, 122, '2014-03-15 00:23:26.000000', 'temperatura', 735.0000, 'ºC'),
	(259043, 122, '2014-03-15 00:23:27.000000', 'temperatura', 571.0000, 'ºC'),
	(259044, 122, '2014-03-15 00:23:28.000000', 'temperatura', 650.0000, 'ºC'),
	(259045, 122, '2014-03-15 00:23:29.000000', 'temperatura', 337.0000, 'ºC'),
	(259046, 122, '2014-03-15 00:23:30.000000', 'temperatura', 938.0000, 'ºC'),
	(259047, 122, '2014-03-15 00:23:31.000000', 'temperatura', 76.0000, 'ºC'),
	(259048, 122, '2014-03-15 00:23:32.000000', 'temperatura', 1170.0000, 'ºC'),
	(259049, 122, '2014-03-15 00:23:33.000000', 'temperatura', 820.0000, 'ºC'),
	(259050, 122, '2014-03-15 00:23:34.000000', 'temperatura', 592.0000, 'ºC'),
	(259051, 122, '2014-03-15 00:23:35.000000', 'temperatura', 498.0000, 'ºC'),
	(259052, 122, '2014-03-15 00:23:36.000000', 'temperatura', 715.0000, 'ºC'),
	(259053, 122, '2014-03-15 00:23:37.000000', 'temperatura', 883.0000, 'ºC'),
	(259054, 122, '2014-03-15 00:23:38.000000', 'temperatura', 1072.0000, 'ºC'),
	(259055, 122, '2014-03-15 00:23:39.000000', 'temperatura', 310.0000, 'ºC'),
	(259056, 122, '2014-03-15 00:23:40.000000', 'temperatura', 733.0000, 'ºC'),
	(259057, 122, '2014-03-15 00:23:41.000000', 'temperatura', 338.0000, 'ºC'),
	(259058, 122, '2014-03-15 00:23:42.000000', 'temperatura', 689.0000, 'ºC'),
	(259059, 122, '2014-03-15 00:23:43.000000', 'temperatura', 34.0000, 'ºC'),
	(259060, 122, '2014-03-15 00:23:44.000000', 'temperatura', 503.0000, 'ºC'),
	(259061, 122, '2014-03-15 00:23:45.000000', 'temperatura', 13.0000, 'ºC'),
	(259062, 122, '2014-03-15 00:23:46.000000', 'temperatura', 957.0000, 'ºC'),
	(259063, 122, '2014-03-15 00:23:47.000000', 'temperatura', 1145.0000, 'ºC'),
	(259064, 122, '2014-03-15 00:23:48.000000', 'temperatura', 455.0000, 'ºC'),
	(259065, 122, '2014-03-15 00:23:49.000000', 'temperatura', 41.0000, 'ºC'),
	(259066, 122, '2014-03-15 00:23:50.000000', 'temperatura', 38.0000, 'ºC'),
	(259067, 122, '2014-03-15 00:23:51.000000', 'temperatura', 71.0000, 'ºC'),
	(259068, 122, '2014-03-15 00:23:52.000000', 'temperatura', 240.0000, 'ºC'),
	(259069, 122, '2014-03-15 00:23:53.000000', 'temperatura', 986.0000, 'ºC'),
	(259070, 122, '2014-03-15 00:23:54.000000', 'temperatura', 612.0000, 'ºC'),
	(259071, 122, '2014-03-15 00:23:55.000000', 'temperatura', 101.0000, 'ºC'),
	(259072, 122, '2014-03-15 00:23:56.000000', 'temperatura', 1071.0000, 'ºC'),
	(259073, 122, '2014-03-15 00:23:57.000000', 'temperatura', 252.0000, 'ºC'),
	(259074, 122, '2014-03-15 00:23:58.000000', 'temperatura', 447.0000, 'ºC'),
	(259075, 122, '2014-03-15 00:23:59.000000', 'temperatura', 280.0000, 'ºC'),
	(259076, 122, '2014-03-15 00:24:00.000000', 'temperatura', 59.0000, 'ºC'),
	(259077, 122, '2014-03-15 00:24:01.000000', 'temperatura', 654.0000, 'ºC'),
	(259078, 122, '2014-03-15 00:24:02.000000', 'temperatura', 695.0000, 'ºC'),
	(259079, 122, '2014-03-15 00:24:03.000000', 'temperatura', 313.0000, 'ºC'),
	(259080, 122, '2014-03-15 00:24:04.000000', 'temperatura', 681.0000, 'ºC'),
	(259081, 122, '2014-03-15 00:24:05.000000', 'temperatura', 65.0000, 'ºC'),
	(259082, 122, '2014-03-15 00:24:06.000000', 'temperatura', 683.0000, 'ºC'),
	(259083, 122, '2014-03-15 00:24:07.000000', 'temperatura', 822.0000, 'ºC'),
	(259084, 122, '2014-03-15 00:24:08.000000', 'temperatura', 859.0000, 'ºC'),
	(259085, 122, '2014-03-15 00:24:09.000000', 'temperatura', 632.0000, 'ºC'),
	(259086, 122, '2014-03-15 00:24:10.000000', 'temperatura', 584.0000, 'ºC'),
	(259087, 122, '2014-03-15 00:24:11.000000', 'temperatura', 1023.0000, 'ºC'),
	(259088, 122, '2014-03-15 00:24:12.000000', 'temperatura', 966.0000, 'ºC'),
	(259089, 122, '2014-03-15 00:24:13.000000', 'temperatura', 558.0000, 'ºC'),
	(259090, 122, '2014-03-15 00:24:14.000000', 'temperatura', 1095.0000, 'ºC'),
	(259091, 122, '2014-03-15 00:24:15.000000', 'temperatura', 202.0000, 'ºC'),
	(259092, 122, '2014-03-15 00:24:16.000000', 'temperatura', 126.0000, 'ºC'),
	(259093, 122, '2014-03-15 00:24:17.000000', 'temperatura', 25.0000, 'ºC'),
	(259094, 122, '2014-03-15 00:24:18.000000', 'temperatura', 947.0000, 'ºC'),
	(259095, 122, '2014-03-15 00:24:19.000000', 'temperatura', 1061.0000, 'ºC'),
	(259096, 122, '2014-03-15 00:24:20.000000', 'temperatura', 63.0000, 'ºC'),
	(259097, 122, '2014-03-15 00:24:21.000000', 'temperatura', 735.0000, 'ºC'),
	(259098, 122, '2014-03-15 00:24:22.000000', 'temperatura', 1085.0000, 'ºC'),
	(259099, 122, '2014-03-15 00:24:23.000000', 'temperatura', 819.0000, 'ºC'),
	(259100, 122, '2014-03-15 00:24:24.000000', 'temperatura', 842.0000, 'ºC'),
	(259101, 122, '2014-03-15 00:24:25.000000', 'temperatura', 553.0000, 'ºC'),
	(259102, 122, '2014-03-15 00:24:26.000000', 'temperatura', 240.0000, 'ºC'),
	(259103, 122, '2014-03-15 00:24:27.000000', 'temperatura', 743.0000, 'ºC'),
	(259104, 122, '2014-03-15 00:24:28.000000', 'temperatura', 596.0000, 'ºC'),
	(259105, 122, '2014-03-15 00:24:29.000000', 'temperatura', 749.0000, 'ºC'),
	(259106, 122, '2014-03-15 00:24:30.000000', 'temperatura', 760.0000, 'ºC'),
	(259107, 122, '2014-03-15 00:24:31.000000', 'temperatura', 350.0000, 'ºC'),
	(259108, 122, '2014-03-15 00:24:32.000000', 'temperatura', 674.0000, 'ºC'),
	(259109, 122, '2014-03-15 00:24:33.000000', 'temperatura', 1120.0000, 'ºC'),
	(259110, 122, '2014-03-15 00:24:34.000000', 'temperatura', 1178.0000, 'ºC'),
	(259111, 122, '2014-03-15 00:24:35.000000', 'temperatura', 129.0000, 'ºC'),
	(259112, 122, '2014-03-15 00:24:36.000000', 'temperatura', 711.0000, 'ºC'),
	(259113, 122, '2014-03-15 00:24:37.000000', 'temperatura', 770.0000, 'ºC'),
	(259114, 122, '2014-03-15 00:24:38.000000', 'temperatura', 519.0000, 'ºC'),
	(259115, 122, '2014-03-15 00:24:39.000000', 'temperatura', 283.0000, 'ºC'),
	(259116, 122, '2014-03-15 00:24:40.000000', 'temperatura', 1059.0000, 'ºC'),
	(259117, 122, '2014-03-15 00:24:41.000000', 'temperatura', 847.0000, 'ºC'),
	(259118, 122, '2014-03-15 00:24:42.000000', 'temperatura', 1058.0000, 'ºC'),
	(259119, 122, '2014-03-15 00:24:43.000000', 'temperatura', 350.0000, 'ºC'),
	(259120, 122, '2014-03-15 00:24:44.000000', 'temperatura', 976.0000, 'ºC'),
	(259121, 122, '2014-03-15 00:24:45.000000', 'temperatura', 230.0000, 'ºC'),
	(259122, 122, '2014-03-15 00:24:46.000000', 'temperatura', 621.0000, 'ºC'),
	(259123, 122, '2014-03-15 00:24:47.000000', 'temperatura', 17.0000, 'ºC'),
	(259124, 122, '2014-03-15 00:24:48.000000', 'temperatura', 621.0000, 'ºC'),
	(259125, 122, '2014-03-15 00:24:49.000000', 'temperatura', 657.0000, 'ºC'),
	(259126, 122, '2014-03-15 00:24:50.000000', 'temperatura', 220.0000, 'ºC'),
	(259127, 122, '2014-03-15 00:24:51.000000', 'temperatura', 332.0000, 'ºC'),
	(259128, 122, '2014-03-15 00:24:52.000000', 'temperatura', 999.0000, 'ºC'),
	(259129, 122, '2014-03-15 00:24:53.000000', 'temperatura', 399.0000, 'ºC'),
	(259130, 122, '2014-03-15 00:24:54.000000', 'temperatura', 198.0000, 'ºC'),
	(259131, 122, '2014-03-15 00:24:55.000000', 'temperatura', 993.0000, 'ºC'),
	(259132, 122, '2014-03-15 00:24:56.000000', 'temperatura', 772.0000, 'ºC'),
	(259133, 122, '2014-03-15 00:24:57.000000', 'temperatura', 880.0000, 'ºC'),
	(259134, 122, '2014-03-15 00:24:58.000000', 'temperatura', 885.0000, 'ºC'),
	(259135, 122, '2014-03-15 00:24:59.000000', 'temperatura', 586.0000, 'ºC'),
	(259136, 122, '2014-03-15 00:25:00.000000', 'temperatura', 277.0000, 'ºC'),
	(259137, 122, '2014-03-15 00:25:01.000000', 'temperatura', 824.0000, 'ºC'),
	(259138, 122, '2014-03-15 00:25:02.000000', 'temperatura', 893.0000, 'ºC'),
	(259139, 122, '2014-03-15 00:25:03.000000', 'temperatura', 792.0000, 'ºC'),
	(259140, 122, '2014-03-15 00:25:04.000000', 'temperatura', 81.0000, 'ºC'),
	(259141, 122, '2014-03-15 00:25:05.000000', 'temperatura', 430.0000, 'ºC'),
	(259142, 122, '2014-03-15 00:25:06.000000', 'temperatura', 707.0000, 'ºC'),
	(259143, 122, '2014-03-15 00:25:07.000000', 'temperatura', 1045.0000, 'ºC'),
	(259144, 122, '2014-03-15 00:25:08.000000', 'temperatura', 706.0000, 'ºC'),
	(259145, 122, '2014-03-15 00:25:09.000000', 'temperatura', 394.0000, 'ºC'),
	(259146, 122, '2014-03-15 00:25:10.000000', 'temperatura', 1052.0000, 'ºC'),
	(259147, 122, '2014-03-15 00:25:11.000000', 'temperatura', 481.0000, 'ºC'),
	(259148, 122, '2014-03-15 00:25:12.000000', 'temperatura', 447.0000, 'ºC'),
	(259149, 122, '2014-03-15 00:25:13.000000', 'temperatura', 791.0000, 'ºC'),
	(259150, 122, '2014-03-15 00:25:14.000000', 'temperatura', 217.0000, 'ºC'),
	(259151, 122, '2014-03-15 00:25:15.000000', 'temperatura', 1113.0000, 'ºC'),
	(259152, 122, '2014-03-15 00:25:16.000000', 'temperatura', 114.0000, 'ºC'),
	(259153, 122, '2014-03-15 00:25:17.000000', 'temperatura', 833.0000, 'ºC'),
	(259154, 122, '2014-03-15 00:25:18.000000', 'temperatura', 222.0000, 'ºC'),
	(259155, 122, '2014-03-15 00:25:19.000000', 'temperatura', 1010.0000, 'ºC'),
	(259156, 122, '2014-03-15 00:25:20.000000', 'temperatura', 784.0000, 'ºC'),
	(259157, 122, '2014-03-15 00:25:21.000000', 'temperatura', 893.0000, 'ºC'),
	(259158, 122, '2014-03-15 00:25:22.000000', 'temperatura', 913.0000, 'ºC'),
	(259159, 122, '2014-03-15 00:25:23.000000', 'temperatura', 686.0000, 'ºC'),
	(259160, 122, '2014-03-15 00:25:24.000000', 'temperatura', 690.0000, 'ºC'),
	(259161, 122, '2014-03-15 00:25:25.000000', 'temperatura', 192.0000, 'ºC'),
	(259162, 122, '2014-03-15 00:25:26.000000', 'temperatura', 93.0000, 'ºC'),
	(259163, 122, '2014-03-15 00:25:27.000000', 'temperatura', 1090.0000, 'ºC'),
	(259164, 122, '2014-03-15 00:25:28.000000', 'temperatura', 371.0000, 'ºC'),
	(259165, 122, '2014-03-15 00:25:29.000000', 'temperatura', 984.0000, 'ºC'),
	(259166, 122, '2014-03-15 00:25:30.000000', 'temperatura', 209.0000, 'ºC'),
	(259167, 122, '2014-03-15 00:25:31.000000', 'temperatura', 493.0000, 'ºC'),
	(259168, 122, '2014-03-15 00:25:32.000000', 'temperatura', 638.0000, 'ºC'),
	(259169, 122, '2014-03-15 00:25:33.000000', 'temperatura', 513.0000, 'ºC'),
	(259170, 122, '2014-03-15 00:25:34.000000', 'temperatura', 651.0000, 'ºC'),
	(259171, 122, '2014-03-15 00:25:35.000000', 'temperatura', 516.0000, 'ºC'),
	(259172, 122, '2014-03-15 00:25:36.000000', 'temperatura', 626.0000, 'ºC'),
	(259173, 122, '2014-03-15 00:25:37.000000', 'temperatura', 385.0000, 'ºC'),
	(259174, 122, '2014-03-15 00:25:38.000000', 'temperatura', 46.0000, 'ºC'),
	(259175, 122, '2014-03-15 00:25:39.000000', 'temperatura', 278.0000, 'ºC'),
	(259176, 122, '2014-03-15 00:25:40.000000', 'temperatura', 49.0000, 'ºC'),
	(259177, 122, '2014-03-15 00:25:41.000000', 'temperatura', 614.0000, 'ºC'),
	(259178, 122, '2014-03-15 00:25:42.000000', 'temperatura', 523.0000, 'ºC'),
	(259179, 122, '2014-03-15 00:25:43.000000', 'temperatura', 775.0000, 'ºC'),
	(259180, 122, '2014-03-15 00:25:44.000000', 'temperatura', 1105.0000, 'ºC'),
	(259181, 122, '2014-03-15 00:25:45.000000', 'temperatura', 803.0000, 'ºC'),
	(259182, 122, '2014-03-15 00:25:46.000000', 'temperatura', 697.0000, 'ºC'),
	(259183, 122, '2014-03-15 00:25:47.000000', 'temperatura', 1078.0000, 'ºC'),
	(259184, 122, '2014-03-15 00:25:48.000000', 'temperatura', 901.0000, 'ºC'),
	(259185, 122, '2014-03-15 00:25:49.000000', 'temperatura', 69.0000, 'ºC'),
	(259186, 122, '2014-03-15 00:25:50.000000', 'temperatura', 42.0000, 'ºC'),
	(259187, 122, '2014-03-15 00:25:51.000000', 'temperatura', 4.0000, 'ºC'),
	(259188, 122, '2014-03-15 00:25:52.000000', 'temperatura', 1093.0000, 'ºC'),
	(259189, 122, '2014-03-15 00:25:53.000000', 'temperatura', 655.0000, 'ºC'),
	(259190, 122, '2014-03-15 00:25:54.000000', 'temperatura', 1196.0000, 'ºC'),
	(259191, 122, '2014-03-15 00:25:55.000000', 'temperatura', 416.0000, 'ºC'),
	(259192, 122, '2014-03-15 00:25:56.000000', 'temperatura', 894.0000, 'ºC'),
	(259193, 122, '2014-03-15 00:25:57.000000', 'temperatura', 823.0000, 'ºC'),
	(259194, 122, '2014-03-15 00:25:58.000000', 'temperatura', 232.0000, 'ºC'),
	(259195, 122, '2014-03-15 00:25:59.000000', 'temperatura', 1093.0000, 'ºC'),
	(259196, 122, '2014-03-15 00:26:00.000000', 'temperatura', 1167.0000, 'ºC'),
	(259197, 122, '2014-03-15 00:26:01.000000', 'temperatura', 156.0000, 'ºC'),
	(259198, 122, '2014-03-15 00:26:02.000000', 'temperatura', 881.0000, 'ºC'),
	(259199, 122, '2014-03-15 00:26:03.000000', 'temperatura', 336.0000, 'ºC'),
	(259200, 122, '2014-03-15 00:26:04.000000', 'temperatura', 236.0000, 'ºC'),
	(259201, 122, '2014-03-15 00:26:05.000000', 'temperatura', 176.0000, 'ºC'),
	(259202, 122, '2014-03-15 00:26:06.000000', 'temperatura', 170.0000, 'ºC'),
	(259203, 122, '2014-03-15 00:26:07.000000', 'temperatura', 322.0000, 'ºC'),
	(259204, 122, '2014-03-15 00:26:08.000000', 'temperatura', 1101.0000, 'ºC'),
	(259205, 122, '2014-03-15 00:26:09.000000', 'temperatura', 939.0000, 'ºC'),
	(259206, 122, '2014-03-15 00:26:10.000000', 'temperatura', 191.0000, 'ºC'),
	(259207, 122, '2014-03-15 00:26:11.000000', 'temperatura', 541.0000, 'ºC'),
	(259208, 122, '2014-03-15 00:26:12.000000', 'temperatura', 930.0000, 'ºC'),
	(259209, 122, '2014-03-15 00:26:13.000000', 'temperatura', 627.0000, 'ºC'),
	(259210, 122, '2014-03-15 00:26:14.000000', 'temperatura', 348.0000, 'ºC'),
	(259211, 122, '2014-03-15 00:26:15.000000', 'temperatura', 1060.0000, 'ºC'),
	(259212, 122, '2014-03-15 00:26:16.000000', 'temperatura', 653.0000, 'ºC'),
	(259213, 122, '2014-03-15 00:26:17.000000', 'temperatura', 89.0000, 'ºC'),
	(259214, 122, '2014-03-15 00:26:18.000000', 'temperatura', 887.0000, 'ºC'),
	(259215, 122, '2014-03-15 00:26:19.000000', 'temperatura', 567.0000, 'ºC'),
	(259216, 122, '2014-03-15 00:26:20.000000', 'temperatura', 175.0000, 'ºC'),
	(259217, 122, '2014-03-15 00:26:21.000000', 'temperatura', 376.0000, 'ºC'),
	(259218, 122, '2014-03-15 00:26:22.000000', 'temperatura', 155.0000, 'ºC'),
	(259219, 122, '2014-03-15 00:26:23.000000', 'temperatura', 849.0000, 'ºC'),
	(259220, 122, '2014-03-15 00:26:24.000000', 'temperatura', 178.0000, 'ºC'),
	(259221, 122, '2014-03-15 00:26:25.000000', 'temperatura', 745.0000, 'ºC'),
	(259222, 122, '2014-03-15 00:26:26.000000', 'temperatura', 790.0000, 'ºC'),
	(259223, 122, '2014-03-15 00:26:27.000000', 'temperatura', 516.0000, 'ºC'),
	(259224, 122, '2014-03-15 00:26:28.000000', 'temperatura', 211.0000, 'ºC'),
	(259225, 122, '2014-03-15 00:26:29.000000', 'temperatura', 706.0000, 'ºC'),
	(259226, 122, '2014-03-15 00:26:30.000000', 'temperatura', 497.0000, 'ºC'),
	(259227, 122, '2014-03-15 00:26:31.000000', 'temperatura', 369.0000, 'ºC'),
	(259228, 122, '2014-03-15 00:26:32.000000', 'temperatura', 356.0000, 'ºC'),
	(259229, 122, '2014-03-15 00:26:33.000000', 'temperatura', 671.0000, 'ºC'),
	(259230, 122, '2014-03-15 00:26:34.000000', 'temperatura', 1089.0000, 'ºC'),
	(259231, 122, '2014-03-15 00:26:35.000000', 'temperatura', 1030.0000, 'ºC'),
	(259232, 122, '2014-03-15 00:26:36.000000', 'temperatura', 687.0000, 'ºC'),
	(259233, 122, '2014-03-15 00:26:37.000000', 'temperatura', 342.0000, 'ºC'),
	(259234, 122, '2014-03-15 00:26:38.000000', 'temperatura', 851.0000, 'ºC'),
	(259235, 122, '2014-03-15 00:26:39.000000', 'temperatura', 830.0000, 'ºC'),
	(259236, 122, '2014-03-15 00:26:40.000000', 'temperatura', 396.0000, 'ºC'),
	(259237, 122, '2014-03-15 00:26:41.000000', 'temperatura', 693.0000, 'ºC'),
	(259238, 122, '2014-03-15 00:26:42.000000', 'temperatura', 1078.0000, 'ºC'),
	(259239, 122, '2014-03-15 00:26:43.000000', 'temperatura', 910.0000, 'ºC'),
	(259240, 122, '2014-03-15 00:26:44.000000', 'temperatura', 116.0000, 'ºC'),
	(259241, 122, '2014-03-15 00:26:45.000000', 'temperatura', 251.0000, 'ºC'),
	(259242, 122, '2014-03-15 00:26:46.000000', 'temperatura', 906.0000, 'ºC'),
	(259243, 122, '2014-03-15 00:26:47.000000', 'temperatura', 177.0000, 'ºC'),
	(259244, 122, '2014-03-15 00:26:48.000000', 'temperatura', 571.0000, 'ºC'),
	(259245, 122, '2014-03-15 00:26:49.000000', 'temperatura', 1121.0000, 'ºC'),
	(259246, 122, '2014-03-15 00:26:50.000000', 'temperatura', 295.0000, 'ºC'),
	(259247, 122, '2014-03-15 00:26:51.000000', 'temperatura', 513.0000, 'ºC'),
	(259248, 122, '2014-03-15 00:26:52.000000', 'temperatura', 479.0000, 'ºC'),
	(259249, 122, '2014-03-15 00:26:53.000000', 'temperatura', 857.0000, 'ºC'),
	(259250, 122, '2014-03-15 00:26:54.000000', 'temperatura', 446.0000, 'ºC'),
	(259251, 122, '2014-03-15 00:26:55.000000', 'temperatura', 863.0000, 'ºC'),
	(259252, 122, '2014-03-15 00:26:56.000000', 'temperatura', 575.0000, 'ºC'),
	(259253, 122, '2014-03-15 00:26:57.000000', 'temperatura', 287.0000, 'ºC'),
	(259254, 122, '2014-03-15 00:26:58.000000', 'temperatura', 911.0000, 'ºC'),
	(259255, 122, '2014-03-15 00:26:59.000000', 'temperatura', 94.0000, 'ºC'),
	(259256, 122, '2014-03-15 00:27:00.000000', 'temperatura', 138.0000, 'ºC'),
	(259257, 122, '2014-03-15 00:27:01.000000', 'temperatura', 410.0000, 'ºC'),
	(259258, 122, '2014-03-15 00:27:02.000000', 'temperatura', 434.0000, 'ºC'),
	(259259, 122, '2014-03-15 00:27:03.000000', 'temperatura', 943.0000, 'ºC'),
	(259260, 122, '2014-03-15 00:27:04.000000', 'temperatura', 1015.0000, 'ºC'),
	(259261, 122, '2014-03-15 00:27:05.000000', 'temperatura', 1043.0000, 'ºC'),
	(259262, 122, '2014-03-15 00:27:06.000000', 'temperatura', 970.0000, 'ºC'),
	(259263, 122, '2014-03-15 00:27:07.000000', 'temperatura', 523.0000, 'ºC'),
	(259264, 122, '2014-03-15 00:27:08.000000', 'temperatura', 904.0000, 'ºC'),
	(259265, 122, '2014-03-15 00:27:09.000000', 'temperatura', 550.0000, 'ºC'),
	(259266, 122, '2014-03-15 00:27:10.000000', 'temperatura', 42.0000, 'ºC'),
	(259267, 122, '2014-03-15 00:27:11.000000', 'temperatura', 959.0000, 'ºC'),
	(259268, 122, '2014-03-15 00:27:12.000000', 'temperatura', 1069.0000, 'ºC'),
	(259269, 122, '2014-03-15 00:27:13.000000', 'temperatura', 71.0000, 'ºC'),
	(259270, 122, '2014-03-15 00:27:14.000000', 'temperatura', 746.0000, 'ºC'),
	(259271, 122, '2014-03-15 00:27:15.000000', 'temperatura', 1117.0000, 'ºC'),
	(259272, 122, '2014-03-15 00:27:16.000000', 'temperatura', 949.0000, 'ºC'),
	(259273, 122, '2014-03-15 00:27:17.000000', 'temperatura', 194.0000, 'ºC'),
	(259274, 122, '2014-03-15 00:27:18.000000', 'temperatura', 525.0000, 'ºC'),
	(259275, 122, '2014-03-15 00:27:19.000000', 'temperatura', 841.0000, 'ºC'),
	(259276, 122, '2014-03-15 00:27:20.000000', 'temperatura', 233.0000, 'ºC'),
	(259277, 122, '2014-03-15 00:27:21.000000', 'temperatura', 1042.0000, 'ºC'),
	(259278, 122, '2014-03-15 00:27:22.000000', 'temperatura', 911.0000, 'ºC'),
	(259279, 122, '2014-03-15 00:27:23.000000', 'temperatura', 228.0000, 'ºC'),
	(259280, 122, '2014-03-15 00:27:24.000000', 'temperatura', 807.0000, 'ºC'),
	(259281, 122, '2014-03-15 00:27:25.000000', 'temperatura', 954.0000, 'ºC'),
	(259282, 122, '2014-03-15 00:27:26.000000', 'temperatura', 1148.0000, 'ºC'),
	(259283, 122, '2014-03-15 00:27:27.000000', 'temperatura', 479.0000, 'ºC'),
	(259284, 122, '2014-03-15 00:27:28.000000', 'temperatura', 149.0000, 'ºC'),
	(259285, 122, '2014-03-15 00:27:29.000000', 'temperatura', 512.0000, 'ºC'),
	(259286, 122, '2014-03-15 00:27:30.000000', 'temperatura', 913.0000, 'ºC'),
	(259287, 122, '2014-03-15 00:27:31.000000', 'temperatura', 627.0000, 'ºC'),
	(259288, 122, '2014-03-15 00:27:32.000000', 'temperatura', 398.0000, 'ºC'),
	(259289, 122, '2014-03-15 00:27:33.000000', 'temperatura', 110.0000, 'ºC'),
	(259290, 122, '2014-03-15 00:27:34.000000', 'temperatura', 558.0000, 'ºC'),
	(259291, 122, '2014-03-15 00:27:35.000000', 'temperatura', 59.0000, 'ºC'),
	(259292, 122, '2014-03-15 00:27:36.000000', 'temperatura', 1020.0000, 'ºC'),
	(259293, 122, '2014-03-15 00:27:37.000000', 'temperatura', 124.0000, 'ºC'),
	(259294, 122, '2014-03-15 00:27:38.000000', 'temperatura', 1162.0000, 'ºC'),
	(259295, 122, '2014-03-15 00:27:39.000000', 'temperatura', 640.0000, 'ºC'),
	(259296, 122, '2014-03-15 00:27:40.000000', 'temperatura', 911.0000, 'ºC'),
	(259297, 122, '2014-03-15 00:27:41.000000', 'temperatura', 238.0000, 'ºC'),
	(259298, 122, '2014-03-15 00:27:42.000000', 'temperatura', 855.0000, 'ºC'),
	(259299, 122, '2014-03-15 00:27:43.000000', 'temperatura', 1162.0000, 'ºC'),
	(259300, 122, '2014-03-15 00:27:44.000000', 'temperatura', 846.0000, 'ºC'),
	(259301, 122, '2014-03-15 00:27:45.000000', 'temperatura', 744.0000, 'ºC'),
	(259302, 122, '2014-03-15 00:27:46.000000', 'temperatura', 1182.0000, 'ºC'),
	(259303, 122, '2014-03-15 00:27:47.000000', 'temperatura', 78.0000, 'ºC'),
	(259304, 122, '2014-03-15 00:27:48.000000', 'temperatura', 444.0000, 'ºC'),
	(259305, 122, '2014-03-15 00:27:49.000000', 'temperatura', 787.0000, 'ºC'),
	(259306, 122, '2014-03-15 00:27:50.000000', 'temperatura', 202.0000, 'ºC'),
	(259307, 122, '2014-03-15 00:27:51.000000', 'temperatura', 1050.0000, 'ºC'),
	(259308, 122, '2014-03-15 00:27:52.000000', 'temperatura', 1046.0000, 'ºC'),
	(259309, 122, '2014-03-15 00:27:53.000000', 'temperatura', 878.0000, 'ºC'),
	(259310, 122, '2014-03-15 00:27:54.000000', 'temperatura', 55.0000, 'ºC'),
	(259311, 122, '2014-03-15 00:27:55.000000', 'temperatura', 42.0000, 'ºC'),
	(259312, 122, '2014-03-15 00:27:56.000000', 'temperatura', 46.0000, 'ºC'),
	(259313, 122, '2014-03-15 00:27:57.000000', 'temperatura', 104.0000, 'ºC'),
	(259314, 122, '2014-03-15 00:27:58.000000', 'temperatura', 383.0000, 'ºC'),
	(259315, 122, '2014-03-15 00:27:59.000000', 'temperatura', 404.0000, 'ºC'),
	(259316, 122, '2014-03-15 00:28:00.000000', 'temperatura', 869.0000, 'ºC'),
	(259317, 122, '2014-03-15 00:28:01.000000', 'temperatura', 733.0000, 'ºC'),
	(259318, 122, '2014-03-15 00:28:02.000000', 'temperatura', 1060.0000, 'ºC'),
	(259319, 122, '2014-03-15 00:28:03.000000', 'temperatura', 702.0000, 'ºC'),
	(259320, 122, '2014-03-15 00:28:04.000000', 'temperatura', 331.0000, 'ºC'),
	(259321, 122, '2014-03-15 00:28:05.000000', 'temperatura', 749.0000, 'ºC'),
	(259322, 122, '2014-03-15 00:28:06.000000', 'temperatura', 352.0000, 'ºC'),
	(259323, 122, '2014-03-15 00:28:07.000000', 'temperatura', 712.0000, 'ºC'),
	(259324, 122, '2014-03-15 00:28:08.000000', 'temperatura', 108.0000, 'ºC'),
	(259325, 122, '2014-03-15 00:28:09.000000', 'temperatura', 801.0000, 'ºC'),
	(259326, 122, '2014-03-15 00:28:10.000000', 'temperatura', 82.0000, 'ºC'),
	(259327, 122, '2014-03-15 00:28:11.000000', 'temperatura', 409.0000, 'ºC'),
	(259328, 122, '2014-03-15 00:28:12.000000', 'temperatura', 601.0000, 'ºC'),
	(259329, 122, '2014-03-15 00:28:13.000000', 'temperatura', 576.0000, 'ºC'),
	(259330, 122, '2014-03-15 00:28:14.000000', 'temperatura', 1077.0000, 'ºC'),
	(259331, 122, '2014-03-15 00:28:15.000000', 'temperatura', 59.0000, 'ºC'),
	(259332, 122, '2014-03-15 00:28:16.000000', 'temperatura', 663.0000, 'ºC'),
	(259333, 122, '2014-03-15 00:28:17.000000', 'temperatura', 738.0000, 'ºC'),
	(259334, 122, '2014-03-15 00:28:18.000000', 'temperatura', 504.0000, 'ºC'),
	(259335, 122, '2014-03-15 00:28:19.000000', 'temperatura', 305.0000, 'ºC'),
	(259336, 122, '2014-03-15 00:28:20.000000', 'temperatura', 12.0000, 'ºC'),
	(259337, 122, '2014-03-15 00:28:21.000000', 'temperatura', 347.0000, 'ºC'),
	(259338, 122, '2014-03-15 00:28:22.000000', 'temperatura', 499.0000, 'ºC'),
	(259339, 122, '2014-03-15 00:28:23.000000', 'temperatura', 253.0000, 'ºC'),
	(259340, 122, '2014-03-15 00:28:24.000000', 'temperatura', 972.0000, 'ºC'),
	(259341, 122, '2014-03-15 00:28:25.000000', 'temperatura', 499.0000, 'ºC'),
	(259342, 122, '2014-03-15 00:28:26.000000', 'temperatura', 779.0000, 'ºC'),
	(259343, 122, '2014-03-15 00:28:27.000000', 'temperatura', 1199.0000, 'ºC'),
	(259344, 122, '2014-03-15 00:28:28.000000', 'temperatura', 59.0000, 'ºC'),
	(259345, 122, '2014-03-15 00:28:29.000000', 'temperatura', 299.0000, 'ºC'),
	(259346, 122, '2014-03-15 00:28:30.000000', 'temperatura', 119.0000, 'ºC'),
	(259347, 122, '2014-03-15 00:28:31.000000', 'temperatura', 900.0000, 'ºC'),
	(259348, 122, '2014-03-15 00:28:32.000000', 'temperatura', 541.0000, 'ºC'),
	(259349, 122, '2014-03-15 00:28:33.000000', 'temperatura', 6.0000, 'ºC'),
	(259350, 122, '2014-03-15 00:28:34.000000', 'temperatura', 809.0000, 'ºC'),
	(259351, 122, '2014-03-15 00:28:35.000000', 'temperatura', 429.0000, 'ºC'),
	(259352, 122, '2014-03-15 00:28:36.000000', 'temperatura', 915.0000, 'ºC'),
	(259353, 122, '2014-03-15 00:28:37.000000', 'temperatura', 890.0000, 'ºC'),
	(259354, 122, '2014-03-15 00:28:38.000000', 'temperatura', 504.0000, 'ºC'),
	(259355, 122, '2014-03-15 00:28:39.000000', 'temperatura', 1052.0000, 'ºC'),
	(259356, 122, '2014-03-15 00:28:40.000000', 'temperatura', 149.0000, 'ºC'),
	(259357, 122, '2014-03-15 00:28:41.000000', 'temperatura', 1190.0000, 'ºC'),
	(259358, 122, '2014-03-15 00:28:42.000000', 'temperatura', 704.0000, 'ºC'),
	(259359, 122, '2014-03-15 00:28:43.000000', 'temperatura', 1148.0000, 'ºC'),
	(259360, 122, '2014-03-15 00:28:44.000000', 'temperatura', 29.0000, 'ºC'),
	(259361, 122, '2014-03-15 00:28:45.000000', 'temperatura', 302.0000, 'ºC'),
	(259362, 122, '2014-03-15 00:28:46.000000', 'temperatura', 224.0000, 'ºC'),
	(259363, 122, '2014-03-15 00:28:47.000000', 'temperatura', 213.0000, 'ºC'),
	(259364, 122, '2014-03-15 00:28:48.000000', 'temperatura', 394.0000, 'ºC'),
	(259365, 122, '2014-03-15 00:28:49.000000', 'temperatura', 132.0000, 'ºC'),
	(259366, 122, '2014-03-15 00:28:50.000000', 'temperatura', 678.0000, 'ºC'),
	(259367, 122, '2014-03-15 00:28:51.000000', 'temperatura', 595.0000, 'ºC'),
	(259368, 122, '2014-03-15 00:28:52.000000', 'temperatura', 940.0000, 'ºC'),
	(259369, 122, '2014-03-15 00:28:53.000000', 'temperatura', 517.0000, 'ºC'),
	(259370, 122, '2014-03-15 00:28:54.000000', 'temperatura', 964.0000, 'ºC'),
	(259371, 122, '2014-03-15 00:28:55.000000', 'temperatura', 870.0000, 'ºC'),
	(259372, 122, '2014-03-15 00:28:56.000000', 'temperatura', 259.0000, 'ºC'),
	(259373, 122, '2014-03-15 00:28:57.000000', 'temperatura', 1084.0000, 'ºC'),
	(259374, 122, '2014-03-15 00:28:58.000000', 'temperatura', 1044.0000, 'ºC'),
	(259375, 122, '2014-03-15 00:28:59.000000', 'temperatura', 770.0000, 'ºC'),
	(259376, 122, '2014-03-15 00:29:00.000000', 'temperatura', 716.0000, 'ºC'),
	(259377, 122, '2014-03-15 00:29:01.000000', 'temperatura', 72.0000, 'ºC'),
	(259378, 122, '2014-03-15 00:29:02.000000', 'temperatura', 614.0000, 'ºC'),
	(259379, 122, '2014-03-15 00:29:03.000000', 'temperatura', 454.0000, 'ºC'),
	(259380, 122, '2014-03-15 00:29:04.000000', 'temperatura', 428.0000, 'ºC'),
	(259381, 122, '2014-03-15 00:29:05.000000', 'temperatura', 778.0000, 'ºC'),
	(259382, 122, '2014-03-15 00:29:06.000000', 'temperatura', 207.0000, 'ºC'),
	(259383, 122, '2014-03-15 00:29:07.000000', 'temperatura', 1100.0000, 'ºC'),
	(259384, 122, '2014-03-15 00:29:08.000000', 'temperatura', 80.0000, 'ºC'),
	(259385, 122, '2014-03-15 00:29:09.000000', 'temperatura', 699.0000, 'ºC'),
	(259386, 122, '2014-03-15 00:29:10.000000', 'temperatura', 857.0000, 'ºC'),
	(259387, 122, '2014-03-15 00:29:11.000000', 'temperatura', 990.0000, 'ºC'),
	(259388, 122, '2014-03-15 00:29:12.000000', 'temperatura', 1179.0000, 'ºC'),
	(259389, 122, '2014-03-15 00:29:13.000000', 'temperatura', 523.0000, 'ºC'),
	(259390, 122, '2014-03-15 00:29:14.000000', 'temperatura', 281.0000, 'ºC'),
	(259391, 122, '2014-03-15 00:29:15.000000', 'temperatura', 1038.0000, 'ºC'),
	(259392, 122, '2014-03-15 00:29:16.000000', 'temperatura', 745.0000, 'ºC'),
	(259393, 122, '2014-03-15 00:29:17.000000', 'temperatura', 614.0000, 'ºC'),
	(259394, 122, '2014-03-15 00:29:18.000000', 'temperatura', 833.0000, 'ºC'),
	(259395, 122, '2014-03-15 00:29:19.000000', 'temperatura', 1126.0000, 'ºC'),
	(259396, 122, '2014-03-15 00:29:20.000000', 'temperatura', 731.0000, 'ºC'),
	(259397, 122, '2014-03-15 00:29:21.000000', 'temperatura', 278.0000, 'ºC'),
	(259398, 122, '2014-03-15 00:29:22.000000', 'temperatura', 396.0000, 'ºC'),
	(259399, 122, '2014-03-15 00:29:23.000000', 'temperatura', 1149.0000, 'ºC'),
	(259400, 122, '2014-03-15 00:29:24.000000', 'temperatura', 957.0000, 'ºC'),
	(259401, 122, '2014-03-15 00:29:25.000000', 'temperatura', 138.0000, 'ºC'),
	(259402, 122, '2014-03-15 00:29:26.000000', 'temperatura', 220.0000, 'ºC'),
	(259403, 122, '2014-03-15 00:29:27.000000', 'temperatura', 684.0000, 'ºC'),
	(259404, 122, '2014-03-15 00:29:28.000000', 'temperatura', 362.0000, 'ºC'),
	(259405, 122, '2014-03-15 00:29:29.000000', 'temperatura', 959.0000, 'ºC'),
	(259406, 122, '2014-03-15 00:29:30.000000', 'temperatura', 110.0000, 'ºC'),
	(259407, 122, '2014-03-15 00:29:31.000000', 'temperatura', 73.0000, 'ºC'),
	(259408, 122, '2014-03-15 00:29:32.000000', 'temperatura', 35.0000, 'ºC'),
	(259409, 122, '2014-03-15 00:29:33.000000', 'temperatura', 1158.0000, 'ºC'),
	(259410, 122, '2014-03-15 00:29:34.000000', 'temperatura', 883.0000, 'ºC'),
	(259411, 122, '2014-03-15 00:29:35.000000', 'temperatura', 941.0000, 'ºC'),
	(259412, 122, '2014-03-15 00:29:36.000000', 'temperatura', 859.0000, 'ºC'),
	(259413, 122, '2014-03-15 00:29:37.000000', 'temperatura', 270.0000, 'ºC'),
	(259414, 122, '2014-03-15 00:29:38.000000', 'temperatura', 1177.0000, 'ºC'),
	(259415, 122, '2014-03-15 00:29:39.000000', 'temperatura', 273.0000, 'ºC'),
	(259416, 122, '2014-03-15 00:29:40.000000', 'temperatura', 233.0000, 'ºC'),
	(259417, 122, '2014-03-15 00:29:41.000000', 'temperatura', 350.0000, 'ºC'),
	(259418, 122, '2014-03-15 00:29:42.000000', 'temperatura', 1049.0000, 'ºC'),
	(259419, 122, '2014-03-15 00:29:43.000000', 'temperatura', 596.0000, 'ºC'),
	(259420, 122, '2014-03-15 00:29:44.000000', 'temperatura', 1033.0000, 'ºC'),
	(259421, 122, '2014-03-15 00:29:45.000000', 'temperatura', 978.0000, 'ºC'),
	(259422, 122, '2014-03-15 00:29:46.000000', 'temperatura', 590.0000, 'ºC'),
	(259423, 122, '2014-03-15 00:29:47.000000', 'temperatura', 18.0000, 'ºC'),
	(259424, 122, '2014-03-15 00:29:48.000000', 'temperatura', 722.0000, 'ºC'),
	(259425, 122, '2014-03-15 00:29:49.000000', 'temperatura', 1154.0000, 'ºC'),
	(259426, 122, '2014-03-15 00:29:50.000000', 'temperatura', 7.0000, 'ºC'),
	(259427, 122, '2014-03-15 00:29:51.000000', 'temperatura', 174.0000, 'ºC'),
	(259428, 122, '2014-03-15 00:29:52.000000', 'temperatura', 849.0000, 'ºC'),
	(259429, 122, '2014-03-15 00:29:53.000000', 'temperatura', 123.0000, 'ºC'),
	(259430, 122, '2014-03-15 00:29:54.000000', 'temperatura', 467.0000, 'ºC'),
	(259431, 122, '2014-03-15 00:29:55.000000', 'temperatura', 768.0000, 'ºC'),
	(259432, 122, '2014-03-15 00:29:56.000000', 'temperatura', 41.0000, 'ºC'),
	(259433, 122, '2014-03-15 00:29:57.000000', 'temperatura', 301.0000, 'ºC'),
	(259434, 122, '2014-03-15 00:29:58.000000', 'temperatura', 184.0000, 'ºC'),
	(259435, 122, '2014-03-15 00:29:59.000000', 'temperatura', 16.0000, 'ºC'),
	(259436, 122, '2014-03-15 00:30:00.000000', 'temperatura', 727.0000, 'ºC'),
	(259437, 122, '2014-03-15 00:30:01.000000', 'temperatura', 1190.0000, 'ºC'),
	(259438, 122, '2014-03-15 00:30:02.000000', 'temperatura', 168.0000, 'ºC'),
	(259439, 122, '2014-03-15 00:30:03.000000', 'temperatura', 869.0000, 'ºC'),
	(259440, 122, '2014-03-15 00:30:04.000000', 'temperatura', 244.0000, 'ºC'),
	(259441, 122, '2014-03-15 00:30:05.000000', 'temperatura', 1012.0000, 'ºC'),
	(259442, 122, '2014-03-15 00:30:06.000000', 'temperatura', 728.0000, 'ºC'),
	(259443, 122, '2014-03-15 00:30:07.000000', 'temperatura', 606.0000, 'ºC'),
	(259444, 122, '2014-03-15 00:30:08.000000', 'temperatura', 847.0000, 'ºC'),
	(259445, 122, '2014-03-15 00:30:09.000000', 'temperatura', 15.0000, 'ºC'),
	(259446, 122, '2014-03-15 00:30:10.000000', 'temperatura', 1134.0000, 'ºC'),
	(259447, 122, '2014-03-15 00:30:11.000000', 'temperatura', 827.0000, 'ºC'),
	(259448, 122, '2014-03-15 00:30:12.000000', 'temperatura', 733.0000, 'ºC'),
	(259449, 122, '2014-03-15 00:30:13.000000', 'temperatura', 1183.0000, 'ºC'),
	(259450, 122, '2014-03-15 00:30:14.000000', 'temperatura', 117.0000, 'ºC'),
	(259451, 122, '2014-03-15 00:30:15.000000', 'temperatura', 636.0000, 'ºC'),
	(259452, 122, '2014-03-15 00:30:16.000000', 'temperatura', 430.0000, 'ºC'),
	(259453, 122, '2014-03-15 00:30:17.000000', 'temperatura', 241.0000, 'ºC'),
	(259454, 122, '2014-03-15 00:30:18.000000', 'temperatura', 1115.0000, 'ºC'),
	(259455, 122, '2014-03-15 00:30:19.000000', 'temperatura', 54.0000, 'ºC'),
	(259456, 122, '2014-03-15 00:30:20.000000', 'temperatura', 527.0000, 'ºC'),
	(259457, 122, '2014-03-15 00:30:21.000000', 'temperatura', 70.0000, 'ºC'),
	(259458, 122, '2014-03-15 00:30:22.000000', 'temperatura', 1172.0000, 'ºC'),
	(259459, 122, '2014-03-15 00:30:23.000000', 'temperatura', 852.0000, 'ºC'),
	(259460, 122, '2014-03-15 00:30:24.000000', 'temperatura', 741.0000, 'ºC'),
	(259461, 122, '2014-03-15 00:30:25.000000', 'temperatura', 1152.0000, 'ºC'),
	(259462, 122, '2014-03-15 00:30:26.000000', 'temperatura', 1136.0000, 'ºC'),
	(259463, 122, '2014-03-15 00:30:27.000000', 'temperatura', 1025.0000, 'ºC'),
	(259464, 122, '2014-03-15 00:30:28.000000', 'temperatura', 517.0000, 'ºC'),
	(259465, 122, '2014-03-15 00:30:29.000000', 'temperatura', 709.0000, 'ºC'),
	(259466, 122, '2014-03-15 00:30:30.000000', 'temperatura', 798.0000, 'ºC'),
	(259467, 122, '2014-03-15 00:30:31.000000', 'temperatura', 661.0000, 'ºC'),
	(259468, 122, '2014-03-15 00:30:32.000000', 'temperatura', 910.0000, 'ºC'),
	(259469, 122, '2014-03-15 00:30:33.000000', 'temperatura', 171.0000, 'ºC'),
	(259470, 122, '2014-03-15 00:30:34.000000', 'temperatura', 524.0000, 'ºC'),
	(259471, 122, '2014-03-15 00:30:35.000000', 'temperatura', 909.0000, 'ºC'),
	(259472, 122, '2014-03-15 00:30:36.000000', 'temperatura', 574.0000, 'ºC'),
	(259473, 122, '2014-03-15 00:30:37.000000', 'temperatura', 145.0000, 'ºC'),
	(259474, 122, '2014-03-15 00:30:38.000000', 'temperatura', 200.0000, 'ºC'),
	(259475, 122, '2014-03-15 00:30:39.000000', 'temperatura', 566.0000, 'ºC'),
	(259476, 122, '2014-03-15 00:30:40.000000', 'temperatura', 1032.0000, 'ºC'),
	(259477, 122, '2014-03-15 00:30:41.000000', 'temperatura', 1061.0000, 'ºC'),
	(259478, 122, '2014-03-15 00:30:42.000000', 'temperatura', 1011.0000, 'ºC'),
	(259479, 122, '2014-03-15 00:30:43.000000', 'temperatura', 670.0000, 'ºC'),
	(259480, 122, '2014-03-15 00:30:44.000000', 'temperatura', 320.0000, 'ºC'),
	(259481, 122, '2014-03-15 00:30:45.000000', 'temperatura', 790.0000, 'ºC'),
	(259482, 122, '2014-03-15 00:30:46.000000', 'temperatura', 589.0000, 'ºC'),
	(259483, 122, '2014-03-15 00:30:47.000000', 'temperatura', 575.0000, 'ºC'),
	(259484, 122, '2014-03-15 00:30:48.000000', 'temperatura', 1109.0000, 'ºC'),
	(259485, 122, '2014-03-15 00:30:49.000000', 'temperatura', 220.0000, 'ºC'),
	(259486, 122, '2014-03-15 00:30:50.000000', 'temperatura', 174.0000, 'ºC'),
	(259487, 122, '2014-03-15 00:30:51.000000', 'temperatura', 209.0000, 'ºC'),
	(259488, 122, '2014-03-15 00:30:52.000000', 'temperatura', 525.0000, 'ºC'),
	(259489, 122, '2014-03-15 00:30:53.000000', 'temperatura', 798.0000, 'ºC'),
	(259490, 122, '2014-03-15 00:30:54.000000', 'temperatura', 15.0000, 'ºC'),
	(259491, 122, '2014-03-15 00:30:55.000000', 'temperatura', 80.0000, 'ºC'),
	(259492, 122, '2014-03-15 00:30:56.000000', 'temperatura', 359.0000, 'ºC'),
	(259493, 122, '2014-03-15 00:30:57.000000', 'temperatura', 352.0000, 'ºC'),
	(259494, 122, '2014-03-15 00:30:58.000000', 'temperatura', 686.0000, 'ºC'),
	(259495, 122, '2014-03-15 00:30:59.000000', 'temperatura', 1175.0000, 'ºC'),
	(259496, 122, '2014-03-15 00:31:00.000000', 'temperatura', 216.0000, 'ºC'),
	(259497, 122, '2014-03-15 00:31:01.000000', 'temperatura', 1154.0000, 'ºC'),
	(259498, 122, '2014-03-15 00:31:02.000000', 'temperatura', 324.0000, 'ºC'),
	(259499, 122, '2014-03-15 00:31:03.000000', 'temperatura', 557.0000, 'ºC'),
	(259500, 122, '2014-03-15 00:31:04.000000', 'temperatura', 616.0000, 'ºC'),
	(259501, 122, '2014-03-15 00:31:05.000000', 'temperatura', 207.0000, 'ºC'),
	(259502, 122, '2014-03-15 00:31:06.000000', 'temperatura', 389.0000, 'ºC'),
	(259503, 122, '2014-03-15 00:31:07.000000', 'temperatura', 123.0000, 'ºC'),
	(259504, 122, '2014-03-15 00:31:08.000000', 'temperatura', 650.0000, 'ºC'),
	(259505, 122, '2014-03-15 00:31:09.000000', 'temperatura', 480.0000, 'ºC'),
	(259506, 122, '2014-03-15 00:31:10.000000', 'temperatura', 452.0000, 'ºC'),
	(259507, 122, '2014-03-15 00:31:11.000000', 'temperatura', 820.0000, 'ºC'),
	(259508, 122, '2014-03-15 00:31:12.000000', 'temperatura', 346.0000, 'ºC'),
	(259509, 122, '2014-03-15 00:31:13.000000', 'temperatura', 469.0000, 'ºC'),
	(259510, 122, '2014-03-15 00:31:14.000000', 'temperatura', 109.0000, 'ºC'),
	(259511, 122, '2014-03-15 00:31:15.000000', 'temperatura', 339.0000, 'ºC'),
	(259512, 122, '2014-03-15 00:31:16.000000', 'temperatura', 167.0000, 'ºC'),
	(259513, 122, '2014-03-15 00:31:17.000000', 'temperatura', 1020.0000, 'ºC'),
	(259514, 122, '2014-03-15 00:31:18.000000', 'temperatura', 1001.0000, 'ºC'),
	(259515, 122, '2014-03-15 00:31:19.000000', 'temperatura', 743.0000, 'ºC'),
	(259516, 122, '2014-03-15 00:31:20.000000', 'temperatura', 714.0000, 'ºC'),
	(259517, 122, '2014-03-15 00:31:21.000000', 'temperatura', 140.0000, 'ºC'),
	(259518, 122, '2014-03-15 00:31:22.000000', 'temperatura', 960.0000, 'ºC'),
	(259519, 122, '2014-03-15 00:31:23.000000', 'temperatura', 781.0000, 'ºC'),
	(259520, 122, '2014-03-15 00:31:24.000000', 'temperatura', 1025.0000, 'ºC'),
	(259521, 122, '2014-03-15 00:31:25.000000', 'temperatura', 382.0000, 'ºC'),
	(259522, 122, '2014-03-15 00:31:26.000000', 'temperatura', 36.0000, 'ºC'),
	(259523, 122, '2014-03-15 00:31:27.000000', 'temperatura', 236.0000, 'ºC'),
	(259524, 122, '2014-03-15 00:31:28.000000', 'temperatura', 1072.0000, 'ºC'),
	(259525, 122, '2014-03-15 00:31:29.000000', 'temperatura', 1053.0000, 'ºC'),
	(259526, 122, '2014-03-15 00:31:30.000000', 'temperatura', 847.0000, 'ºC'),
	(259527, 122, '2014-03-15 00:31:31.000000', 'temperatura', 1078.0000, 'ºC'),
	(259528, 122, '2014-03-15 00:31:32.000000', 'temperatura', 451.0000, 'ºC'),
	(259529, 122, '2014-03-15 00:31:33.000000', 'temperatura', 221.0000, 'ºC'),
	(259530, 122, '2014-03-15 00:31:34.000000', 'temperatura', 952.0000, 'ºC'),
	(259531, 122, '2014-03-15 00:31:35.000000', 'temperatura', 498.0000, 'ºC'),
	(259532, 122, '2014-03-15 00:31:36.000000', 'temperatura', 833.0000, 'ºC'),
	(259533, 122, '2014-03-15 00:31:37.000000', 'temperatura', 272.0000, 'ºC'),
	(259534, 122, '2014-03-15 00:31:38.000000', 'temperatura', 64.0000, 'ºC'),
	(259535, 122, '2014-03-15 00:31:39.000000', 'temperatura', 702.0000, 'ºC'),
	(259536, 122, '2014-03-15 00:31:40.000000', 'temperatura', 918.0000, 'ºC'),
	(259537, 122, '2014-03-15 00:31:41.000000', 'temperatura', 86.0000, 'ºC'),
	(259538, 122, '2014-03-15 00:31:42.000000', 'temperatura', 76.0000, 'ºC'),
	(259539, 122, '2014-03-15 00:31:43.000000', 'temperatura', 121.0000, 'ºC'),
	(259540, 122, '2014-03-15 00:31:44.000000', 'temperatura', 380.0000, 'ºC'),
	(259541, 122, '2014-03-15 00:31:45.000000', 'temperatura', 338.0000, 'ºC'),
	(259542, 122, '2014-03-15 00:31:46.000000', 'temperatura', 549.0000, 'ºC'),
	(259543, 122, '2014-03-15 00:31:47.000000', 'temperatura', 530.0000, 'ºC'),
	(259544, 122, '2014-03-15 00:31:48.000000', 'temperatura', 1004.0000, 'ºC'),
	(259545, 122, '2014-03-15 00:31:49.000000', 'temperatura', 1031.0000, 'ºC'),
	(259546, 122, '2014-03-15 00:31:50.000000', 'temperatura', 943.0000, 'ºC'),
	(259547, 122, '2014-03-15 00:31:51.000000', 'temperatura', 423.0000, 'ºC'),
	(259548, 122, '2014-03-15 00:31:52.000000', 'temperatura', 487.0000, 'ºC'),
	(259549, 122, '2014-03-15 00:31:53.000000', 'temperatura', 1167.0000, 'ºC'),
	(259550, 122, '2014-03-15 00:31:54.000000', 'temperatura', 775.0000, 'ºC'),
	(259551, 122, '2014-03-15 00:31:55.000000', 'temperatura', 376.0000, 'ºC'),
	(259552, 122, '2014-03-15 00:31:56.000000', 'temperatura', 753.0000, 'ºC'),
	(259553, 122, '2014-03-15 00:31:57.000000', 'temperatura', 238.0000, 'ºC'),
	(259554, 122, '2014-03-15 00:31:58.000000', 'temperatura', 131.0000, 'ºC'),
	(259555, 122, '2014-03-15 00:31:59.000000', 'temperatura', 1141.0000, 'ºC'),
	(259556, 122, '2014-03-15 00:32:00.000000', 'temperatura', 512.0000, 'ºC'),
	(259557, 122, '2014-03-15 00:32:01.000000', 'temperatura', 338.0000, 'ºC'),
	(259558, 122, '2014-03-15 00:32:02.000000', 'temperatura', 153.0000, 'ºC'),
	(259559, 122, '2014-03-15 00:32:03.000000', 'temperatura', 954.0000, 'ºC'),
	(259560, 122, '2014-03-15 00:32:04.000000', 'temperatura', 713.0000, 'ºC'),
	(259561, 122, '2014-03-15 00:32:05.000000', 'temperatura', 700.0000, 'ºC'),
	(259562, 122, '2014-03-15 00:32:06.000000', 'temperatura', 163.0000, 'ºC'),
	(259563, 122, '2014-03-15 00:32:07.000000', 'temperatura', 1116.0000, 'ºC'),
	(259564, 122, '2014-03-15 00:32:08.000000', 'temperatura', 291.0000, 'ºC'),
	(259565, 122, '2014-03-15 00:32:09.000000', 'temperatura', 506.0000, 'ºC'),
	(259566, 122, '2014-03-15 00:32:10.000000', 'temperatura', 459.0000, 'ºC'),
	(259567, 122, '2014-03-15 00:32:11.000000', 'temperatura', 778.0000, 'ºC'),
	(259568, 122, '2014-03-15 00:32:12.000000', 'temperatura', 113.0000, 'ºC'),
	(259569, 122, '2014-03-15 00:32:13.000000', 'temperatura', 633.0000, 'ºC'),
	(259570, 122, '2014-03-15 00:32:14.000000', 'temperatura', 425.0000, 'ºC'),
	(259571, 122, '2014-03-15 00:32:15.000000', 'temperatura', 225.0000, 'ºC'),
	(259572, 122, '2014-03-15 00:32:16.000000', 'temperatura', 1052.0000, 'ºC'),
	(259573, 122, '2014-03-15 00:32:17.000000', 'temperatura', 985.0000, 'ºC'),
	(259574, 122, '2014-03-15 00:32:18.000000', 'temperatura', 570.0000, 'ºC'),
	(259575, 122, '2014-03-15 00:32:19.000000', 'temperatura', 1095.0000, 'ºC'),
	(259576, 122, '2014-03-15 00:32:20.000000', 'temperatura', 164.0000, 'ºC'),
	(259577, 122, '2014-03-15 00:32:21.000000', 'temperatura', 1139.0000, 'ºC'),
	(259578, 122, '2014-03-15 00:32:22.000000', 'temperatura', 400.0000, 'ºC'),
	(259579, 122, '2014-03-15 00:32:23.000000', 'temperatura', 986.0000, 'ºC'),
	(259580, 122, '2014-03-15 00:32:24.000000', 'temperatura', 130.0000, 'ºC'),
	(259581, 122, '2014-03-15 00:32:25.000000', 'temperatura', 92.0000, 'ºC'),
	(259582, 122, '2014-03-15 00:32:26.000000', 'temperatura', 70.0000, 'ºC'),
	(259583, 122, '2014-03-15 00:32:27.000000', 'temperatura', 76.0000, 'ºC'),
	(259584, 122, '2014-03-15 00:32:28.000000', 'temperatura', 169.0000, 'ºC'),
	(259585, 122, '2014-03-15 00:32:29.000000', 'temperatura', 618.0000, 'ºC'),
	(259586, 122, '2014-03-15 00:32:30.000000', 'temperatura', 185.0000, 'ºC'),
	(259587, 122, '2014-03-15 00:32:31.000000', 'temperatura', 269.0000, 'ºC'),
	(259588, 122, '2014-03-15 00:32:32.000000', 'temperatura', 790.0000, 'ºC'),
	(259589, 122, '2014-03-15 00:32:33.000000', 'temperatura', 743.0000, 'ºC'),
	(259590, 122, '2014-03-15 00:32:34.000000', 'temperatura', 147.0000, 'ºC'),
	(259591, 122, '2014-03-15 00:32:35.000000', 'temperatura', 907.0000, 'ºC'),
	(259592, 122, '2014-03-15 00:32:36.000000', 'temperatura', 495.0000, 'ºC'),
	(259593, 122, '2014-03-15 00:32:37.000000', 'temperatura', 954.0000, 'ºC'),
	(259594, 122, '2014-03-15 00:32:38.000000', 'temperatura', 884.0000, 'ºC'),
	(259595, 122, '2014-03-15 00:32:39.000000', 'temperatura', 359.0000, 'ºC'),
	(259596, 122, '2014-03-15 00:32:40.000000', 'temperatura', 342.0000, 'ºC'),
	(259597, 122, '2014-03-15 00:32:41.000000', 'temperatura', 634.0000, 'ºC'),
	(259598, 122, '2014-03-15 00:32:42.000000', 'temperatura', 947.0000, 'ºC'),
	(259599, 122, '2014-03-15 00:32:43.000000', 'temperatura', 431.0000, 'ºC'),
	(259600, 122, '2014-03-15 00:32:44.000000', 'temperatura', 516.0000, 'ºC'),
	(259601, 122, '2014-03-15 00:32:45.000000', 'temperatura', 89.0000, 'ºC'),
	(259602, 122, '2014-03-15 00:32:46.000000', 'temperatura', 97.0000, 'ºC'),
	(259603, 122, '2014-03-15 00:32:47.000000', 'temperatura', 216.0000, 'ºC'),
	(259604, 122, '2014-03-15 00:32:48.000000', 'temperatura', 792.0000, 'ºC'),
	(259605, 122, '2014-03-15 00:32:49.000000', 'temperatura', 910.0000, 'ºC'),
	(259606, 122, '2014-03-15 00:32:50.000000', 'temperatura', 975.0000, 'ºC'),
	(259607, 122, '2014-03-15 00:32:51.000000', 'temperatura', 945.0000, 'ºC'),
	(259608, 122, '2014-03-15 00:32:52.000000', 'temperatura', 601.0000, 'ºC'),
	(259609, 122, '2014-03-15 00:32:53.000000', 'temperatura', 170.0000, 'ºC'),
	(259610, 122, '2014-03-15 00:32:54.000000', 'temperatura', 248.0000, 'ºC'),
	(259611, 122, '2014-03-15 00:32:55.000000', 'temperatura', 729.0000, 'ºC'),
	(259612, 122, '2014-03-15 00:32:56.000000', 'temperatura', 503.0000, 'ºC'),
	(259613, 122, '2014-03-15 00:32:57.000000', 'temperatura', 328.0000, 'ºC'),
	(259614, 122, '2014-03-15 00:32:58.000000', 'temperatura', 132.0000, 'ºC'),
	(259615, 122, '2014-03-15 00:32:59.000000', 'temperatura', 877.0000, 'ºC'),
	(259616, 122, '2014-03-15 00:33:00.000000', 'temperatura', 390.0000, 'ºC'),
	(259617, 122, '2014-03-15 00:33:01.000000', 'temperatura', 517.0000, 'ºC'),
	(259618, 122, '2014-03-15 00:33:02.000000', 'temperatura', 217.0000, 'ºC'),
	(259619, 122, '2014-03-15 00:33:03.000000', 'temperatura', 733.0000, 'ºC'),
	(259620, 122, '2014-03-15 00:33:04.000000', 'temperatura', 614.0000, 'ºC'),
	(259621, 122, '2014-03-15 00:33:05.000000', 'temperatura', 874.0000, 'ºC'),
	(259622, 122, '2014-03-15 00:33:06.000000', 'temperatura', 127.0000, 'ºC'),
	(259623, 122, '2014-03-15 00:33:07.000000', 'temperatura', 415.0000, 'ºC'),
	(259624, 122, '2014-03-15 00:33:08.000000', 'temperatura', 494.0000, 'ºC'),
	(259625, 122, '2014-03-15 00:33:09.000000', 'temperatura', 23.0000, 'ºC'),
	(259626, 122, '2014-03-15 00:33:10.000000', 'temperatura', 1037.0000, 'ºC'),
	(259627, 122, '2014-03-15 00:33:11.000000', 'temperatura', 316.0000, 'ºC'),
	(259628, 122, '2014-03-15 00:33:12.000000', 'temperatura', 868.0000, 'ºC'),
	(259629, 122, '2014-03-15 00:33:13.000000', 'temperatura', 991.0000, 'ºC'),
	(259630, 122, '2014-03-15 00:33:14.000000', 'temperatura', 1155.0000, 'ºC'),
	(259631, 122, '2014-03-15 00:33:15.000000', 'temperatura', 400.0000, 'ºC'),
	(259632, 122, '2014-03-15 00:33:16.000000', 'temperatura', 936.0000, 'ºC'),
	(259633, 122, '2014-03-15 00:33:17.000000', 'temperatura', 1081.0000, 'ºC'),
	(259634, 122, '2014-03-15 00:33:18.000000', 'temperatura', 199.0000, 'ºC'),
	(259635, 122, '2014-03-15 00:33:19.000000', 'temperatura', 152.0000, 'ºC'),
	(259636, 122, '2014-03-15 00:33:20.000000', 'temperatura', 163.0000, 'ºC'),
	(259637, 122, '2014-03-15 00:33:21.000000', 'temperatura', 358.0000, 'ºC'),
	(259638, 122, '2014-03-15 00:33:22.000000', 'temperatura', 104.0000, 'ºC'),
	(259639, 122, '2014-03-15 00:33:23.000000', 'temperatura', 648.0000, 'ºC'),
	(259640, 122, '2014-03-15 00:33:24.000000', 'temperatura', 525.0000, 'ºC'),
	(259641, 122, '2014-03-15 00:33:25.000000', 'temperatura', 682.0000, 'ºC'),
	(259642, 122, '2014-03-15 00:33:26.000000', 'temperatura', 634.0000, 'ºC'),
	(259643, 122, '2014-03-15 00:33:27.000000', 'temperatura', 1127.0000, 'ºC'),
	(259644, 122, '2014-03-15 00:33:28.000000', 'temperatura', 131.0000, 'ºC'),
	(259645, 122, '2014-03-15 00:33:29.000000', 'temperatura', 876.0000, 'ºC'),
	(259646, 122, '2014-03-15 00:33:30.000000', 'temperatura', 387.0000, 'ºC'),
	(259647, 122, '2014-03-15 00:33:31.000000', 'temperatura', 508.0000, 'ºC'),
	(259648, 122, '2014-03-15 00:33:32.000000', 'temperatura', 180.0000, 'ºC'),
	(259649, 122, '2014-03-15 00:33:33.000000', 'temperatura', 575.0000, 'ºC'),
	(259650, 122, '2014-03-15 00:33:34.000000', 'temperatura', 1138.0000, 'ºC'),
	(259651, 122, '2014-03-15 00:33:35.000000', 'temperatura', 365.0000, 'ºC'),
	(259652, 122, '2014-03-15 00:33:36.000000', 'temperatura', 812.0000, 'ºC'),
	(259653, 122, '2014-03-15 00:33:37.000000', 'temperatura', 565.0000, 'ºC'),
	(259654, 122, '2014-03-15 00:33:38.000000', 'temperatura', 390.0000, 'ºC'),
	(259655, 122, '2014-03-15 00:33:39.000000', 'temperatura', 254.0000, 'ºC'),
	(259656, 122, '2014-03-15 00:33:40.000000', 'temperatura', 102.0000, 'ºC'),
	(259657, 122, '2014-03-15 00:33:41.000000', 'temperatura', 948.0000, 'ºC'),
	(259658, 122, '2014-03-15 00:33:42.000000', 'temperatura', 834.0000, 'ºC'),
	(259659, 122, '2014-03-15 00:33:43.000000', 'temperatura', 127.0000, 'ºC'),
	(259660, 122, '2014-03-15 00:33:44.000000', 'temperatura', 535.0000, 'ºC'),
	(259661, 122, '2014-03-15 00:33:45.000000', 'temperatura', 1094.0000, 'ºC'),
	(259662, 122, '2014-03-15 00:33:46.000000', 'temperatura', 267.0000, 'ºC'),
	(259663, 122, '2014-03-15 00:33:47.000000', 'temperatura', 453.0000, 'ºC'),
	(259664, 122, '2014-03-15 00:33:48.000000', 'temperatura', 263.0000, 'ºC'),
	(259665, 122, '2014-03-15 00:33:49.000000', 'temperatura', 1156.0000, 'ºC'),
	(259666, 122, '2014-03-15 00:33:50.000000', 'temperatura', 193.0000, 'ºC'),
	(259667, 122, '2014-03-15 00:33:51.000000', 'temperatura', 1099.0000, 'ºC'),
	(259668, 122, '2014-03-15 00:33:52.000000', 'temperatura', 115.0000, 'ºC'),
	(259669, 122, '2014-03-15 00:33:53.000000', 'temperatura', 878.0000, 'ºC'),
	(259670, 122, '2014-03-15 00:33:54.000000', 'temperatura', 447.0000, 'ºC'),
	(259671, 122, '2014-03-15 00:33:55.000000', 'temperatura', 801.0000, 'ºC'),
	(259672, 122, '2014-03-15 00:33:56.000000', 'temperatura', 263.0000, 'ºC'),
	(259673, 122, '2014-03-15 00:33:57.000000', 'temperatura', 115.0000, 'ºC'),
	(259674, 122, '2014-03-15 00:33:58.000000', 'temperatura', 985.0000, 'ºC'),
	(259675, 122, '2014-03-15 00:33:59.000000', 'temperatura', 983.0000, 'ºC'),
	(259676, 122, '2014-03-15 00:34:00.000000', 'temperatura', 757.0000, 'ºC'),
	(259677, 122, '2014-03-15 00:34:01.000000', 'temperatura', 840.0000, 'ºC'),
	(259678, 122, '2014-03-15 00:34:02.000000', 'temperatura', 726.0000, 'ºC'),
	(259679, 122, '2014-03-15 00:34:03.000000', 'temperatura', 1112.0000, 'ºC'),
	(259680, 122, '2014-03-15 00:34:04.000000', 'temperatura', 983.0000, 'ºC'),
	(259681, 122, '2014-03-15 00:34:05.000000', 'temperatura', 379.0000, 'ºC'),
	(259682, 122, '2014-03-15 00:34:06.000000', 'temperatura', 147.0000, 'ºC'),
	(259683, 122, '2014-03-15 00:34:07.000000', 'temperatura', 796.0000, 'ºC'),
	(259684, 122, '2014-03-15 00:34:08.000000', 'temperatura', 1143.0000, 'ºC'),
	(259685, 122, '2014-03-15 00:34:09.000000', 'temperatura', 927.0000, 'ºC'),
	(259686, 122, '2014-03-15 00:34:10.000000', 'temperatura', 5.0000, 'ºC'),
	(259687, 122, '2014-03-15 00:34:11.000000', 'temperatura', 845.0000, 'ºC'),
	(259688, 122, '2014-03-15 00:34:12.000000', 'temperatura', 609.0000, 'ºC'),
	(259689, 122, '2014-03-15 00:34:13.000000', 'temperatura', 511.0000, 'ºC'),
	(259690, 122, '2014-03-15 00:34:14.000000', 'temperatura', 731.0000, 'ºC'),
	(259691, 122, '2014-03-15 00:34:15.000000', 'temperatura', 920.0000, 'ºC'),
	(259692, 122, '2014-03-15 00:34:16.000000', 'temperatura', 8.0000, 'ºC'),
	(259693, 122, '2014-03-15 00:34:17.000000', 'temperatura', 883.0000, 'ºC'),
	(259694, 122, '2014-03-15 00:34:18.000000', 'temperatura', 788.0000, 'ºC'),
	(259695, 122, '2014-03-15 00:34:19.000000', 'temperatura', 92.0000, 'ºC'),
	(259696, 122, '2014-03-15 00:34:20.000000', 'temperatura', 498.0000, 'ºC'),
	(259697, 122, '2014-03-15 00:34:21.000000', 'temperatura', 1015.0000, 'ºC'),
	(259698, 122, '2014-03-15 00:34:22.000000', 'temperatura', 1181.0000, 'ºC'),
	(259699, 122, '2014-03-15 00:34:23.000000', 'temperatura', 461.0000, 'ºC'),
	(259700, 122, '2014-03-15 00:34:24.000000', 'temperatura', 1162.0000, 'ºC'),
	(259701, 122, '2014-03-15 00:34:25.000000', 'temperatura', 828.0000, 'ºC'),
	(259702, 122, '2014-03-15 00:34:26.000000', 'temperatura', 653.0000, 'ºC'),
	(259703, 122, '2014-03-15 00:34:27.000000', 'temperatura', 781.0000, 'ºC'),
	(259704, 122, '2014-03-15 00:34:28.000000', 'temperatura', 750.0000, 'ºC'),
	(259705, 122, '2014-03-15 00:34:29.000000', 'temperatura', 204.0000, 'ºC'),
	(259706, 122, '2014-03-15 00:34:30.000000', 'temperatura', 1170.0000, 'ºC'),
	(259707, 122, '2014-03-15 00:34:31.000000', 'temperatura', 439.0000, 'ºC'),
	(259708, 122, '2014-03-15 00:34:32.000000', 'temperatura', 1085.0000, 'ºC'),
	(259709, 122, '2014-03-15 00:34:33.000000', 'temperatura', 509.0000, 'ºC'),
	(259710, 122, '2014-03-15 00:34:34.000000', 'temperatura', 489.0000, 'ºC'),
	(259711, 122, '2014-03-15 00:34:35.000000', 'temperatura', 918.0000, 'ºC'),
	(259712, 122, '2014-03-15 00:34:36.000000', 'temperatura', 723.0000, 'ºC'),
	(259713, 122, '2014-03-15 00:34:37.000000', 'temperatura', 864.0000, 'ºC'),
	(259714, 122, '2014-03-15 00:34:38.000000', 'temperatura', 951.0000, 'ºC'),
	(259715, 122, '2014-03-15 00:34:39.000000', 'temperatura', 962.0000, 'ºC'),
	(259716, 122, '2014-03-15 00:34:40.000000', 'temperatura', 760.0000, 'ºC'),
	(259717, 122, '2014-03-15 00:34:41.000000', 'temperatura', 913.0000, 'ºC'),
	(259718, 122, '2014-03-15 00:34:42.000000', 'temperatura', 1087.0000, 'ºC'),
	(259719, 122, '2014-03-15 00:34:43.000000', 'temperatura', 295.0000, 'ºC'),
	(259720, 122, '2014-03-15 00:34:44.000000', 'temperatura', 614.0000, 'ºC'),
	(259721, 122, '2014-03-15 00:34:45.000000', 'temperatura', 986.0000, 'ºC'),
	(259722, 122, '2014-03-15 00:34:46.000000', 'temperatura', 687.0000, 'ºC'),
	(259723, 122, '2014-03-15 00:34:47.000000', 'temperatura', 481.0000, 'ºC'),
	(259724, 122, '2014-03-15 00:34:48.000000', 'temperatura', 341.0000, 'ºC'),
	(259725, 122, '2014-03-15 00:34:49.000000', 'temperatura', 264.0000, 'ºC'),
	(259726, 122, '2014-03-15 00:34:50.000000', 'temperatura', 295.0000, 'ºC'),
	(259727, 122, '2014-03-15 00:34:51.000000', 'temperatura', 687.0000, 'ºC'),
	(259728, 122, '2014-03-15 00:34:52.000000', 'temperatura', 148.0000, 'ºC'),
	(259729, 122, '2014-03-15 00:34:53.000000', 'temperatura', 1082.0000, 'ºC'),
	(259730, 122, '2014-03-15 00:34:54.000000', 'temperatura', 166.0000, 'ºC'),
	(259731, 122, '2014-03-15 00:34:55.000000', 'temperatura', 1184.0000, 'ºC'),
	(259732, 122, '2014-03-15 00:34:56.000000', 'temperatura', 622.0000, 'ºC'),
	(259733, 122, '2014-03-15 00:34:57.000000', 'temperatura', 761.0000, 'ºC'),
	(259734, 122, '2014-03-15 00:34:58.000000', 'temperatura', 737.0000, 'ºC'),
	(259735, 122, '2014-03-15 00:34:59.000000', 'temperatura', 205.0000, 'ºC'),
	(259736, 122, '2014-03-15 00:35:00.000000', 'temperatura', 13.0000, 'ºC'),
	(259737, 122, '2014-03-15 00:35:01.000000', 'temperatura', 649.0000, 'ºC'),
	(259738, 122, '2014-03-15 00:35:02.000000', 'temperatura', 807.0000, 'ºC'),
	(259739, 122, '2014-03-15 00:35:03.000000', 'temperatura', 891.0000, 'ºC'),
	(259740, 122, '2014-03-15 00:35:04.000000', 'temperatura', 832.0000, 'ºC'),
	(259741, 122, '2014-03-15 00:35:05.000000', 'temperatura', 289.0000, 'ºC'),
	(259742, 122, '2014-03-15 00:35:06.000000', 'temperatura', 147.0000, 'ºC'),
	(259743, 122, '2014-03-15 00:35:07.000000', 'temperatura', 1072.0000, 'ºC'),
	(259744, 122, '2014-03-15 00:35:08.000000', 'temperatura', 118.0000, 'ºC'),
	(259745, 122, '2014-03-15 00:35:09.000000', 'temperatura', 974.0000, 'ºC'),
	(259746, 122, '2014-03-15 00:35:10.000000', 'temperatura', 918.0000, 'ºC'),
	(259747, 122, '2014-03-15 00:35:11.000000', 'temperatura', 469.0000, 'ºC'),
	(259748, 122, '2014-03-15 00:35:12.000000', 'temperatura', 791.0000, 'ºC'),
	(259749, 122, '2014-03-15 00:35:13.000000', 'temperatura', 148.0000, 'ºC'),
	(259750, 122, '2014-03-15 00:35:14.000000', 'temperatura', 768.0000, 'ºC'),
	(259751, 122, '2014-03-15 00:35:15.000000', 'temperatura', 995.0000, 'ºC'),
	(259752, 122, '2014-03-15 00:35:16.000000', 'temperatura', 274.0000, 'ºC'),
	(259753, 122, '2014-03-15 00:35:17.000000', 'temperatura', 786.0000, 'ºC'),
	(259754, 122, '2014-03-15 00:35:18.000000', 'temperatura', 709.0000, 'ºC'),
	(259755, 122, '2014-03-15 00:35:19.000000', 'temperatura', 1185.0000, 'ºC'),
	(259756, 122, '2014-03-15 00:35:20.000000', 'temperatura', 197.0000, 'ºC'),
	(259757, 122, '2014-03-15 00:35:21.000000', 'temperatura', 1034.0000, 'ºC'),
	(259758, 122, '2014-03-15 00:35:22.000000', 'temperatura', 976.0000, 'ºC'),
	(259759, 122, '2014-03-15 00:35:23.000000', 'temperatura', 581.0000, 'ºC'),
	(259760, 122, '2014-03-15 00:35:24.000000', 'temperatura', 1175.0000, 'ºC'),
	(259761, 122, '2014-03-15 00:35:25.000000', 'temperatura', 534.0000, 'ºC'),
	(259762, 122, '2014-03-15 00:35:26.000000', 'temperatura', 344.0000, 'ºC'),
	(259763, 122, '2014-03-15 00:35:27.000000', 'temperatura', 120.0000, 'ºC'),
	(259764, 122, '2014-03-15 00:35:28.000000', 'temperatura', 769.0000, 'ºC'),
	(259765, 122, '2014-03-15 00:35:29.000000', 'temperatura', 1084.0000, 'ºC'),
	(259766, 122, '2014-03-15 00:35:30.000000', 'temperatura', 714.0000, 'ºC'),
	(259767, 122, '2014-03-15 00:35:31.000000', 'temperatura', 317.0000, 'ºC'),
	(259768, 122, '2014-03-15 00:35:32.000000', 'temperatura', 644.0000, 'ºC'),
	(259769, 122, '2014-03-15 00:35:33.000000', 'temperatura', 1070.0000, 'ºC'),
	(259770, 122, '2014-03-15 00:35:34.000000', 'temperatura', 1020.0000, 'ºC'),
	(259771, 122, '2014-03-15 00:35:35.000000', 'temperatura', 689.0000, 'ºC'),
	(259772, 122, '2014-03-15 00:35:36.000000', 'temperatura', 384.0000, 'ºC'),
	(259773, 122, '2014-03-15 00:35:37.000000', 'temperatura', 1056.0000, 'ºC'),
	(259774, 122, '2014-03-15 00:35:38.000000', 'temperatura', 527.0000, 'ºC'),
	(259775, 122, '2014-03-15 00:35:39.000000', 'temperatura', 666.0000, 'ºC'),
	(259776, 122, '2014-03-15 00:35:40.000000', 'temperatura', 553.0000, 'ºC'),
	(259777, 122, '2014-03-15 00:35:41.000000', 'temperatura', 764.0000, 'ºC'),
	(259778, 122, '2014-03-15 00:35:42.000000', 'temperatura', 965.0000, 'ºC'),
	(259779, 122, '2014-03-15 00:35:43.000000', 'temperatura', 130.0000, 'ºC'),
	(259780, 122, '2014-03-15 00:35:44.000000', 'temperatura', 158.0000, 'ºC'),
	(259781, 122, '2014-03-15 00:35:45.000000', 'temperatura', 400.0000, 'ºC'),
	(259782, 122, '2014-03-15 00:35:46.000000', 'temperatura', 327.0000, 'ºC'),
	(259783, 122, '2014-03-15 00:35:47.000000', 'temperatura', 433.0000, 'ºC'),
	(259784, 122, '2014-03-15 00:35:48.000000', 'temperatura', 1187.0000, 'ºC'),
	(259785, 122, '2014-03-15 00:35:49.000000', 'temperatura', 1034.0000, 'ºC'),
	(259786, 122, '2014-03-15 00:35:50.000000', 'temperatura', 410.0000, 'ºC'),
	(259787, 122, '2014-03-15 00:35:51.000000', 'temperatura', 148.0000, 'ºC'),
	(259788, 122, '2014-03-15 00:35:52.000000', 'temperatura', 710.0000, 'ºC'),
	(259789, 122, '2014-03-15 00:35:53.000000', 'temperatura', 706.0000, 'ºC'),
	(259790, 122, '2014-03-15 00:35:54.000000', 'temperatura', 202.0000, 'ºC'),
	(259791, 122, '2014-03-15 00:35:55.000000', 'temperatura', 91.0000, 'ºC'),
	(259792, 122, '2014-03-15 00:35:56.000000', 'temperatura', 1052.0000, 'ºC'),
	(259793, 122, '2014-03-15 00:35:57.000000', 'temperatura', 187.0000, 'ºC'),
	(259794, 122, '2014-03-15 00:35:58.000000', 'temperatura', 181.0000, 'ºC'),
	(259795, 122, '2014-03-15 00:35:59.000000', 'temperatura', 343.0000, 'ºC'),
	(259796, 122, '2014-03-15 00:36:00.000000', 'temperatura', 1173.0000, 'ºC'),
	(259797, 122, '2014-03-15 00:36:01.000000', 'temperatura', 34.0000, 'ºC'),
	(259798, 122, '2014-03-15 00:36:02.000000', 'temperatura', 254.0000, 'ºC'),
	(259799, 122, '2014-03-15 00:36:03.000000', 'temperatura', 1169.0000, 'ºC'),
	(259800, 122, '2014-03-15 00:36:04.000000', 'temperatura', 282.0000, 'ºC'),
	(259801, 122, '2014-03-15 00:36:05.000000', 'temperatura', 303.0000, 'ºC'),
	(259802, 122, '2014-03-15 00:36:06.000000', 'temperatura', 672.0000, 'ºC'),
	(259803, 122, '2014-03-15 00:36:07.000000', 'temperatura', 51.0000, 'ºC'),
	(259804, 122, '2014-03-15 00:36:08.000000', 'temperatura', 639.0000, 'ºC'),
	(259805, 122, '2014-03-15 00:36:09.000000', 'temperatura', 643.0000, 'ºC'),
	(259806, 122, '2014-03-15 00:36:10.000000', 'temperatura', 96.0000, 'ºC'),
	(259807, 122, '2014-03-15 00:36:11.000000', 'temperatura', 954.0000, 'ºC'),
	(259808, 122, '2014-03-15 00:36:12.000000', 'temperatura', 882.0000, 'ºC'),
	(259809, 122, '2014-03-15 00:36:13.000000', 'temperatura', 349.0000, 'ºC'),
	(259810, 122, '2014-03-15 00:36:14.000000', 'temperatura', 300.0000, 'ºC'),
	(259811, 122, '2014-03-15 00:36:15.000000', 'temperatura', 453.0000, 'ºC'),
	(259812, 122, '2014-03-15 00:36:16.000000', 'temperatura', 165.0000, 'ºC'),
	(259813, 122, '2014-03-15 00:36:17.000000', 'temperatura', 667.0000, 'ºC'),
	(259814, 122, '2014-03-15 00:36:18.000000', 'temperatura', 440.0000, 'ºC'),
	(259815, 122, '2014-03-15 00:36:19.000000', 'temperatura', 199.0000, 'ºC'),
	(259816, 122, '2014-03-15 00:36:20.000000', 'temperatura', 877.0000, 'ºC'),
	(259817, 122, '2014-03-15 00:36:21.000000', 'temperatura', 189.0000, 'ºC'),
	(259818, 122, '2014-03-15 00:36:22.000000', 'temperatura', 713.0000, 'ºC'),
	(259819, 122, '2014-03-15 00:36:23.000000', 'temperatura', 598.0000, 'ºC'),
	(259820, 122, '2014-03-15 00:36:24.000000', 'temperatura', 851.0000, 'ºC'),
	(259821, 122, '2014-03-15 00:36:25.000000', 'temperatura', 61.0000, 'ºC'),
	(259822, 122, '2014-03-15 00:36:26.000000', 'temperatura', 156.0000, 'ºC'),
	(259823, 122, '2014-03-15 00:36:27.000000', 'temperatura', 594.0000, 'ºC'),
	(259824, 122, '2014-03-15 00:36:28.000000', 'temperatura', 103.0000, 'ºC'),
	(259825, 122, '2014-03-15 00:36:29.000000', 'temperatura', 1132.0000, 'ºC'),
	(259826, 122, '2014-03-15 00:36:30.000000', 'temperatura', 552.0000, 'ºC'),
	(259827, 122, '2014-03-15 00:36:31.000000', 'temperatura', 567.0000, 'ºC'),
	(259828, 122, '2014-03-15 00:36:32.000000', 'temperatura', 1179.0000, 'ºC'),
	(259829, 122, '2014-03-15 00:36:33.000000', 'temperatura', 594.0000, 'ºC'),
	(259830, 122, '2014-03-15 00:36:34.000000', 'temperatura', 632.0000, 'ºC'),
	(259831, 122, '2014-03-15 00:36:35.000000', 'temperatura', 179.0000, 'ºC'),
	(259832, 122, '2014-03-15 00:36:36.000000', 'temperatura', 198.0000, 'ºC'),
	(259833, 122, '2014-03-15 00:36:37.000000', 'temperatura', 454.0000, 'ºC'),
	(259834, 122, '2014-03-15 00:36:38.000000', 'temperatura', 476.0000, 'ºC'),
	(259835, 122, '2014-03-15 00:36:39.000000', 'temperatura', 1019.0000, 'ºC'),
	(259836, 122, '2014-03-15 00:36:40.000000', 'temperatura', 69.0000, 'ºC'),
	(259837, 122, '2014-03-15 00:36:41.000000', 'temperatura', 886.0000, 'ºC'),
	(259838, 122, '2014-03-15 00:36:42.000000', 'temperatura', 624.0000, 'ºC'),
	(259839, 122, '2014-03-15 00:36:43.000000', 'temperatura', 461.0000, 'ºC'),
	(259840, 122, '2014-03-15 00:36:44.000000', 'temperatura', 434.0000, 'ºC'),
	(259841, 122, '2014-03-15 00:36:45.000000', 'temperatura', 788.0000, 'ºC'),
	(259842, 122, '2014-03-15 00:36:46.000000', 'temperatura', 239.0000, 'ºC'),
	(259843, 122, '2014-03-15 00:36:47.000000', 'temperatura', 30.0000, 'ºC'),
	(259844, 122, '2014-03-15 00:36:48.000000', 'temperatura', 632.0000, 'ºC'),
	(259845, 122, '2014-03-15 00:36:49.000000', 'temperatura', 674.0000, 'ºC'),
	(259846, 122, '2014-03-15 00:36:50.000000', 'temperatura', 274.0000, 'ºC'),
	(259847, 122, '2014-03-15 00:36:51.000000', 'temperatura', 547.0000, 'ºC'),
	(259848, 122, '2014-03-15 00:36:52.000000', 'temperatura', 713.0000, 'ºC'),
	(259849, 122, '2014-03-15 00:36:53.000000', 'temperatura', 726.0000, 'ºC'),
	(259850, 122, '2014-03-15 00:36:54.000000', 'temperatura', 291.0000, 'ºC'),
	(259851, 122, '2014-03-15 00:36:55.000000', 'temperatura', 477.0000, 'ºC'),
	(259852, 122, '2014-03-15 00:36:56.000000', 'temperatura', 314.0000, 'ºC'),
	(259853, 122, '2014-03-15 00:36:57.000000', 'temperatura', 139.0000, 'ºC'),
	(259854, 122, '2014-03-15 00:36:58.000000', 'temperatura', 955.0000, 'ºC'),
	(259855, 122, '2014-03-15 00:36:59.000000', 'temperatura', 758.0000, 'ºC'),
	(259856, 122, '2014-03-15 00:37:00.000000', 'temperatura', 924.0000, 'ºC'),
	(259857, 122, '2014-03-15 00:37:01.000000', 'temperatura', 1145.0000, 'ºC'),
	(259858, 122, '2014-03-15 00:37:02.000000', 'temperatura', 556.0000, 'ºC'),
	(259859, 122, '2014-03-15 00:37:03.000000', 'temperatura', 545.0000, 'ºC'),
	(259860, 122, '2014-03-15 00:37:04.000000', 'temperatura', 1055.0000, 'ºC'),
	(259861, 122, '2014-03-15 00:37:05.000000', 'temperatura', 44.0000, 'ºC'),
	(259862, 122, '2014-03-15 00:37:06.000000', 'temperatura', 653.0000, 'ºC'),
	(259863, 122, '2014-03-15 00:37:07.000000', 'temperatura', 733.0000, 'ºC'),
	(259864, 122, '2014-03-15 00:37:08.000000', 'temperatura', 509.0000, 'ºC'),
	(259865, 122, '2014-03-15 00:37:09.000000', 'temperatura', 345.0000, 'ºC'),
	(259866, 122, '2014-03-15 00:37:10.000000', 'temperatura', 199.0000, 'ºC'),
	(259867, 122, '2014-03-15 00:37:11.000000', 'temperatura', 1160.0000, 'ºC'),
	(259868, 122, '2014-03-15 00:37:12.000000', 'temperatura', 405.0000, 'ºC'),
	(259869, 122, '2014-03-15 00:37:13.000000', 'temperatura', 945.0000, 'ºC'),
	(259870, 122, '2014-03-15 00:37:14.000000', 'temperatura', 1110.0000, 'ºC'),
	(259871, 122, '2014-03-15 00:37:15.000000', 'temperatura', 315.0000, 'ºC'),
	(259872, 122, '2014-03-15 00:37:16.000000', 'temperatura', 645.0000, 'ºC'),
	(259873, 122, '2014-03-15 00:37:17.000000', 'temperatura', 1082.0000, 'ºC'),
	(259874, 122, '2014-03-15 00:37:18.000000', 'temperatura', 1076.0000, 'ºC'),
	(259875, 122, '2014-03-15 00:37:19.000000', 'temperatura', 935.0000, 'ºC'),
	(259876, 122, '2014-03-15 00:37:20.000000', 'temperatura', 247.0000, 'ºC'),
	(259877, 122, '2014-03-15 00:37:21.000000', 'temperatura', 832.0000, 'ºC'),
	(259878, 122, '2014-03-15 00:37:22.000000', 'temperatura', 1018.0000, 'ºC'),
	(259879, 122, '2014-03-15 00:37:23.000000', 'temperatura', 196.0000, 'ºC'),
	(259880, 122, '2014-03-15 00:37:24.000000', 'temperatura', 327.0000, 'ºC'),
	(259881, 122, '2014-03-15 00:37:25.000000', 'temperatura', 1048.0000, 'ºC'),
	(259882, 122, '2014-03-15 00:37:26.000000', 'temperatura', 657.0000, 'ºC'),
	(259883, 122, '2014-03-15 00:37:27.000000', 'temperatura', 142.0000, 'ºC'),
	(259884, 122, '2014-03-15 00:37:28.000000', 'temperatura', 1140.0000, 'ºC'),
	(259885, 122, '2014-03-15 00:37:29.000000', 'temperatura', 476.0000, 'ºC'),
	(259886, 122, '2014-03-15 00:37:30.000000', 'temperatura', 157.0000, 'ºC'),
	(259887, 122, '2014-03-15 00:37:31.000000', 'temperatura', 561.0000, 'ºC'),
	(259888, 122, '2014-03-15 00:37:32.000000', 'temperatura', 1133.0000, 'ºC'),
	(259889, 122, '2014-03-15 00:37:33.000000', 'temperatura', 383.0000, 'ºC'),
	(259890, 122, '2014-03-15 00:37:34.000000', 'temperatura', 914.0000, 'ºC'),
	(259891, 122, '2014-03-15 00:37:35.000000', 'temperatura', 1025.0000, 'ºC'),
	(259892, 122, '2014-03-15 00:37:36.000000', 'temperatura', 1182.0000, 'ºC'),
	(259893, 122, '2014-03-15 00:37:37.000000', 'temperatura', 437.0000, 'ºC'),
	(259894, 122, '2014-03-15 00:37:38.000000', 'temperatura', 1040.0000, 'ºC'),
	(259895, 122, '2014-03-15 00:37:39.000000', 'temperatura', 287.0000, 'ºC'),
	(259896, 122, '2014-03-15 00:37:40.000000', 'temperatura', 719.0000, 'ºC'),
	(259897, 122, '2014-03-15 00:37:41.000000', 'temperatura', 331.0000, 'ºC'),
	(259898, 122, '2014-03-15 00:37:42.000000', 'temperatura', 700.0000, 'ºC'),
	(259899, 122, '2014-03-15 00:37:43.000000', 'temperatura', 108.0000, 'ºC'),
	(259900, 122, '2014-03-15 00:37:44.000000', 'temperatura', 841.0000, 'ºC'),
	(259901, 122, '2014-03-15 00:37:45.000000', 'temperatura', 282.0000, 'ºC'),
	(259902, 122, '2014-03-15 00:37:46.000000', 'temperatura', 85.0000, 'ºC'),
	(259903, 122, '2014-03-15 00:37:47.000000', 'temperatura', 779.0000, 'ºC'),
	(259904, 122, '2014-03-15 00:37:48.000000', 'temperatura', 43.0000, 'ºC'),
	(259905, 122, '2014-03-15 00:37:49.000000', 'temperatura', 276.0000, 'ºC'),
	(259906, 122, '2014-03-15 00:37:50.000000', 'temperatura', 51.0000, 'ºC'),
	(259907, 122, '2014-03-15 00:37:51.000000', 'temperatura', 629.0000, 'ºC'),
	(259908, 122, '2014-03-15 00:37:52.000000', 'temperatura', 593.0000, 'ºC'),
	(259909, 122, '2014-03-15 00:37:53.000000', 'temperatura', 1077.0000, 'ºC'),
	(259910, 122, '2014-03-15 00:37:54.000000', 'temperatura', 5.0000, 'ºC'),
	(259911, 122, '2014-03-15 00:37:55.000000', 'temperatura', 398.0000, 'ºC'),
	(259912, 122, '2014-03-15 00:37:56.000000', 'temperatura', 772.0000, 'ºC'),
	(259913, 122, '2014-03-15 00:37:57.000000', 'temperatura', 269.0000, 'ºC'),
	(259914, 122, '2014-03-15 00:37:58.000000', 'temperatura', 227.0000, 'ºC'),
	(259915, 122, '2014-03-15 00:37:59.000000', 'temperatura', 329.0000, 'ºC'),
	(259916, 122, '2014-03-15 00:38:00.000000', 'temperatura', 964.0000, 'ºC'),
	(259917, 122, '2014-03-15 00:38:01.000000', 'temperatura', 235.0000, 'ºC'),
	(259918, 122, '2014-03-15 00:38:02.000000', 'temperatura', 684.0000, 'ºC'),
	(259919, 122, '2014-03-15 00:38:03.000000', 'temperatura', 316.0000, 'ºC'),
	(259920, 122, '2014-03-15 00:38:04.000000', 'temperatura', 726.0000, 'ºC'),
	(259921, 122, '2014-03-15 00:38:05.000000', 'temperatura', 285.0000, 'ºC'),
	(259922, 122, '2014-03-15 00:38:06.000000', 'temperatura', 445.0000, 'ºC'),
	(259923, 122, '2014-03-15 00:38:07.000000', 'temperatura', 170.0000, 'ºC'),
	(259924, 122, '2014-03-15 00:38:08.000000', 'temperatura', 715.0000, 'ºC'),
	(259925, 122, '2014-03-15 00:38:09.000000', 'temperatura', 665.0000, 'ºC'),
	(259926, 122, '2014-03-15 00:38:10.000000', 'temperatura', 1183.0000, 'ºC'),
	(259927, 122, '2014-03-15 00:38:11.000000', 'temperatura', 318.0000, 'ºC'),
	(259928, 122, '2014-03-15 00:38:12.000000', 'temperatura', 443.0000, 'ºC'),
	(259929, 122, '2014-03-15 00:38:13.000000', 'temperatura', 59.0000, 'ºC'),
	(259930, 122, '2014-03-15 00:38:14.000000', 'temperatura', 170.0000, 'ºC'),
	(259931, 122, '2014-03-15 00:38:15.000000', 'temperatura', 672.0000, 'ºC'),
	(259932, 122, '2014-03-15 00:38:16.000000', 'temperatura', 449.0000, 'ºC'),
	(259933, 122, '2014-03-15 00:38:17.000000', 'temperatura', 232.0000, 'ºC'),
	(259934, 122, '2014-03-15 00:38:18.000000', 'temperatura', 1011.0000, 'ºC'),
	(259935, 122, '2014-03-15 00:38:19.000000', 'temperatura', 761.0000, 'ºC'),
	(259936, 122, '2014-03-15 00:38:20.000000', 'temperatura', 770.0000, 'ºC'),
	(259937, 122, '2014-03-15 00:38:21.000000', 'temperatura', 370.0000, 'ºC'),
	(259938, 122, '2014-03-15 00:38:22.000000', 'temperatura', 740.0000, 'ºC'),
	(259939, 122, '2014-03-15 00:38:23.000000', 'temperatura', 191.0000, 'ºC'),
	(259940, 122, '2014-03-15 00:38:24.000000', 'temperatura', 1136.0000, 'ºC'),
	(259941, 122, '2014-03-15 00:38:25.000000', 'temperatura', 305.0000, 'ºC'),
	(259942, 122, '2014-03-15 00:38:26.000000', 'temperatura', 521.0000, 'ºC'),
	(259943, 122, '2014-03-15 00:38:27.000000', 'temperatura', 487.0000, 'ºC'),
	(259944, 122, '2014-03-15 00:38:28.000000', 'temperatura', 874.0000, 'ºC'),
	(259945, 122, '2014-03-15 00:38:29.000000', 'temperatura', 509.0000, 'ºC'),
	(259946, 122, '2014-03-15 00:38:30.000000', 'temperatura', 1122.0000, 'ºC'),
	(259947, 122, '2014-03-15 00:38:31.000000', 'temperatura', 486.0000, 'ºC'),
	(259948, 122, '2014-03-15 00:38:32.000000', 'temperatura', 262.0000, 'ºC'),
	(259949, 122, '2014-03-15 00:38:33.000000', 'temperatura', 1053.0000, 'ºC'),
	(259950, 122, '2014-03-15 00:38:34.000000', 'temperatura', 881.0000, 'ºC'),
	(259951, 122, '2014-03-15 00:38:35.000000', 'temperatura', 47.0000, 'ºC'),
	(259952, 122, '2014-03-15 00:38:36.000000', 'temperatura', 1191.0000, 'ºC'),
	(259953, 122, '2014-03-15 00:38:37.000000', 'temperatura', 1017.0000, 'ºC'),
	(259954, 122, '2014-03-15 00:38:38.000000', 'temperatura', 311.0000, 'ºC'),
	(259955, 122, '2014-03-15 00:38:39.000000', 'temperatura', 905.0000, 'ºC'),
	(259956, 122, '2014-03-15 00:38:40.000000', 'temperatura', 1191.0000, 'ºC'),
	(259957, 122, '2014-03-15 00:38:41.000000', 'temperatura', 840.0000, 'ºC'),
	(259958, 122, '2014-03-15 00:38:42.000000', 'temperatura', 630.0000, 'ºC'),
	(259959, 122, '2014-03-15 00:38:43.000000', 'temperatura', 631.0000, 'ºC'),
	(259960, 122, '2014-03-15 00:38:44.000000', 'temperatura', 63.0000, 'ºC'),
	(259961, 122, '2014-03-15 00:38:45.000000', 'temperatura', 823.0000, 'ºC'),
	(259962, 122, '2014-03-15 00:38:46.000000', 'temperatura', 326.0000, 'ºC'),
	(259963, 122, '2014-03-15 00:38:47.000000', 'temperatura', 361.0000, 'ºC'),
	(259964, 122, '2014-03-15 00:38:48.000000', 'temperatura', 829.0000, 'ºC'),
	(259965, 122, '2014-03-15 00:38:49.000000', 'temperatura', 661.0000, 'ºC'),
	(259966, 122, '2014-03-15 00:38:50.000000', 'temperatura', 818.0000, 'ºC'),
	(259967, 122, '2014-03-15 00:38:51.000000', 'temperatura', 908.0000, 'ºC'),
	(259968, 122, '2014-03-15 00:38:52.000000', 'temperatura', 887.0000, 'ºC'),
	(259969, 122, '2014-03-15 00:38:53.000000', 'temperatura', 510.0000, 'ºC'),
	(259970, 122, '2014-03-15 00:38:54.000000', 'temperatura', 1090.0000, 'ºC'),
	(259971, 122, '2014-03-15 00:38:55.000000', 'temperatura', 319.0000, 'ºC'),
	(259972, 122, '2014-03-15 00:38:56.000000', 'temperatura', 726.0000, 'ºC'),
	(259973, 122, '2014-03-15 00:38:57.000000', 'temperatura', 274.0000, 'ºC'),
	(259974, 122, '2014-03-15 00:38:58.000000', 'temperatura', 394.0000, 'ºC'),
	(259975, 122, '2014-03-15 00:38:59.000000', 'temperatura', 1146.0000, 'ºC'),
	(259976, 122, '2014-03-15 00:39:00.000000', 'temperatura', 950.0000, 'ºC'),
	(259977, 122, '2014-03-15 00:39:01.000000', 'temperatura', 114.0000, 'ºC'),
	(259978, 122, '2014-03-15 00:39:02.000000', 'temperatura', 120.0000, 'ºC'),
	(259979, 122, '2014-03-15 00:39:03.000000', 'temperatura', 257.0000, 'ºC'),
	(259980, 122, '2014-03-15 00:39:04.000000', 'temperatura', 926.0000, 'ºC'),
	(259981, 122, '2014-03-15 00:39:05.000000', 'temperatura', 261.0000, 'ºC'),
	(259982, 122, '2014-03-15 00:39:06.000000', 'temperatura', 926.0000, 'ºC'),
	(259983, 122, '2014-03-15 00:39:07.000000', 'temperatura', 247.0000, 'ºC'),
	(259984, 122, '2014-03-15 00:39:08.000000', 'temperatura', 856.0000, 'ºC'),
	(259985, 122, '2014-03-15 00:39:09.000000', 'temperatura', 1143.0000, 'ºC'),
	(259986, 122, '2014-03-15 00:39:10.000000', 'temperatura', 746.0000, 'ºC'),
	(259987, 122, '2014-03-15 00:39:11.000000', 'temperatura', 301.0000, 'ºC'),
	(259988, 122, '2014-03-15 00:39:12.000000', 'temperatura', 467.0000, 'ºC'),
	(259989, 122, '2014-03-15 00:39:13.000000', 'temperatura', 232.0000, 'ºC'),
	(259990, 122, '2014-03-15 00:39:14.000000', 'temperatura', 959.0000, 'ºC'),
	(259991, 122, '2014-03-15 00:39:15.000000', 'temperatura', 500.0000, 'ºC'),
	(259992, 122, '2014-03-15 00:39:16.000000', 'temperatura', 825.0000, 'ºC'),
	(259993, 122, '2014-03-15 00:39:17.000000', 'temperatura', 226.0000, 'ºC'),
	(259994, 122, '2014-03-15 00:39:18.000000', 'temperatura', 1055.0000, 'ºC'),
	(259995, 122, '2014-03-15 00:39:19.000000', 'temperatura', 996.0000, 'ºC'),
	(259996, 122, '2014-03-15 00:39:20.000000', 'temperatura', 617.0000, 'ºC'),
	(259997, 122, '2014-03-15 00:39:21.000000', 'temperatura', 96.0000, 'ºC'),
	(259998, 122, '2014-03-15 00:39:22.000000', 'temperatura', 1030.0000, 'ºC'),
	(259999, 122, '2014-03-15 00:39:23.000000', 'temperatura', 64.0000, 'ºC'),
	(260000, 122, '2014-03-15 00:39:24.000000', 'temperatura', 828.0000, 'ºC'),
	(260001, 122, '2014-03-15 00:39:25.000000', 'temperatura', 351.0000, 'ºC'),
	(260002, 122, '2014-03-15 00:39:26.000000', 'temperatura', 469.0000, 'ºC'),
	(260003, 122, '2014-03-15 00:39:27.000000', 'temperatura', 94.0000, 'ºC'),
	(260004, 122, '2014-03-15 00:39:28.000000', 'temperatura', 264.0000, 'ºC'),
	(260005, 122, '2014-03-15 00:39:29.000000', 'temperatura', 1039.0000, 'ºC'),
	(260006, 122, '2014-03-15 00:39:30.000000', 'temperatura', 803.0000, 'ºC'),
	(260007, 122, '2014-03-15 00:39:31.000000', 'temperatura', 898.0000, 'ºC'),
	(260008, 122, '2014-03-15 00:39:32.000000', 'temperatura', 884.0000, 'ºC'),
	(260009, 122, '2014-03-15 00:39:33.000000', 'temperatura', 523.0000, 'ºC'),
	(260010, 122, '2014-03-15 00:39:34.000000', 'temperatura', 1166.0000, 'ºC'),
	(260011, 122, '2014-03-15 00:39:35.000000', 'temperatura', 662.0000, 'ºC'),
	(260012, 122, '2014-03-15 00:39:36.000000', 'temperatura', 1010.0000, 'ºC'),
	(260013, 122, '2014-03-15 00:39:37.000000', 'temperatura', 665.0000, 'ºC'),
	(260014, 122, '2014-03-15 00:39:38.000000', 'temperatura', 295.0000, 'ºC'),
	(260015, 122, '2014-03-15 00:39:39.000000', 'temperatura', 679.0000, 'ºC'),
	(260016, 122, '2014-03-15 00:39:40.000000', 'temperatura', 113.0000, 'ºC'),
	(260017, 122, '2014-03-15 00:39:41.000000', 'temperatura', 926.0000, 'ºC'),
	(260018, 122, '2014-03-15 00:39:42.000000', 'temperatura', 693.0000, 'ºC'),
	(260019, 122, '2014-03-15 00:39:43.000000', 'temperatura', 687.0000, 'ºC'),
	(260020, 122, '2014-03-15 00:39:44.000000', 'temperatura', 156.0000, 'ºC'),
	(260021, 122, '2014-03-15 00:39:45.000000', 'temperatura', 1121.0000, 'ºC'),
	(260022, 122, '2014-03-15 00:39:46.000000', 'temperatura', 336.0000, 'ºC'),
	(260023, 122, '2014-03-15 00:39:47.000000', 'temperatura', 718.0000, 'ºC'),
	(260024, 122, '2014-03-15 00:39:48.000000', 'temperatura', 182.0000, 'ºC'),
	(260025, 122, '2014-03-15 00:39:49.000000', 'temperatura', 1157.0000, 'ºC'),
	(260026, 122, '2014-03-15 00:39:50.000000', 'temperatura', 441.0000, 'ºC'),
	(260027, 122, '2014-03-15 00:39:51.000000', 'temperatura', 1136.0000, 'ºC'),
	(260028, 122, '2014-03-15 00:39:52.000000', 'temperatura', 754.0000, 'ºC'),
	(260029, 122, '2014-03-15 00:39:53.000000', 'temperatura', 362.0000, 'ºC'),
	(260030, 122, '2014-03-15 00:39:54.000000', 'temperatura', 751.0000, 'ºC'),
	(260031, 122, '2014-03-15 00:39:55.000000', 'temperatura', 267.0000, 'ºC'),
	(260032, 122, '2014-03-15 00:39:56.000000', 'temperatura', 283.0000, 'ºC'),
	(260033, 122, '2014-03-15 00:39:57.000000', 'temperatura', 616.0000, 'ºC'),
	(260034, 122, '2014-03-15 00:39:58.000000', 'temperatura', 1029.0000, 'ºC'),
	(260035, 122, '2014-03-15 00:39:59.000000', 'temperatura', 898.0000, 'ºC'),
	(260036, 122, '2014-03-15 00:40:00.000000', 'temperatura', 202.0000, 'ºC'),
	(260037, 122, '2014-03-15 00:40:01.000000', 'temperatura', 720.0000, 'ºC'),
	(260038, 122, '2014-03-15 00:40:02.000000', 'temperatura', 592.0000, 'ºC'),
	(260039, 122, '2014-03-15 00:40:03.000000', 'temperatura', 801.0000, 'ºC'),
	(260040, 122, '2014-03-15 00:40:04.000000', 'temperatura', 1030.0000, 'ºC'),
	(260041, 122, '2014-03-15 00:40:05.000000', 'temperatura', 348.0000, 'ºC'),
	(260042, 122, '2014-03-15 00:40:06.000000', 'temperatura', 1048.0000, 'ºC'),
	(260043, 122, '2014-03-15 00:40:07.000000', 'temperatura', 598.0000, 'ºC'),
	(260044, 122, '2014-03-15 00:40:08.000000', 'temperatura', 1046.0000, 'ºC'),
	(260045, 122, '2014-03-15 00:40:09.000000', 'temperatura', 1037.0000, 'ºC'),
	(260046, 122, '2014-03-15 00:40:10.000000', 'temperatura', 848.0000, 'ºC'),
	(260047, 122, '2014-03-15 00:40:11.000000', 'temperatura', 1127.0000, 'ºC'),
	(260048, 122, '2014-03-15 00:40:12.000000', 'temperatura', 694.0000, 'ºC'),
	(260049, 122, '2014-03-15 00:40:13.000000', 'temperatura', 88.0000, 'ºC'),
	(260050, 122, '2014-03-15 00:40:14.000000', 'temperatura', 761.0000, 'ºC'),
	(260051, 122, '2014-03-15 00:40:15.000000', 'temperatura', 1138.0000, 'ºC'),
	(260052, 122, '2014-03-15 00:40:16.000000', 'temperatura', 1009.0000, 'ºC'),
	(260053, 122, '2014-03-15 00:40:17.000000', 'temperatura', 432.0000, 'ºC'),
	(260054, 122, '2014-03-15 00:40:18.000000', 'temperatura', 332.0000, 'ºC'),
	(260055, 122, '2014-03-15 00:40:19.000000', 'temperatura', 367.0000, 'ºC'),
	(260056, 122, '2014-03-15 00:40:20.000000', 'temperatura', 837.0000, 'ºC'),
	(260057, 122, '2014-03-15 00:40:21.000000', 'temperatura', 683.0000, 'ºC'),
	(260058, 122, '2014-03-15 00:40:22.000000', 'temperatura', 908.0000, 'ºC'),
	(260059, 122, '2014-03-15 00:40:23.000000', 'temperatura', 91.0000, 'ºC'),
	(260060, 122, '2014-03-15 00:40:24.000000', 'temperatura', 131.0000, 'ºC'),
	(260061, 122, '2014-03-15 00:40:25.000000', 'temperatura', 384.0000, 'ºC'),
	(260062, 122, '2014-03-15 00:40:26.000000', 'temperatura', 325.0000, 'ºC'),
	(260063, 122, '2014-03-15 00:40:27.000000', 'temperatura', 476.0000, 'ºC'),
	(260064, 122, '2014-03-15 00:40:28.000000', 'temperatura', 203.0000, 'ºC'),
	(260065, 122, '2014-03-15 00:40:29.000000', 'temperatura', 789.0000, 'ºC'),
	(260066, 122, '2014-03-15 00:40:30.000000', 'temperatura', 938.0000, 'ºC'),
	(260067, 122, '2014-03-15 00:40:31.000000', 'temperatura', 1122.0000, 'ºC'),
	(260068, 122, '2014-03-15 00:40:32.000000', 'temperatura', 396.0000, 'ºC'),
	(260069, 122, '2014-03-15 00:40:33.000000', 'temperatura', 1015.0000, 'ºC'),
	(260070, 122, '2014-03-15 00:40:34.000000', 'temperatura', 288.0000, 'ºC'),
	(260071, 122, '2014-03-15 00:40:35.000000', 'temperatura', 793.0000, 'ºC'),
	(260072, 122, '2014-03-15 00:40:36.000000', 'temperatura', 704.0000, 'ºC'),
	(260073, 122, '2014-03-15 00:40:37.000000', 'temperatura', 1139.0000, 'ºC'),
	(260074, 122, '2014-03-15 00:40:38.000000', 'temperatura', 1187.0000, 'ºC'),
	(260075, 122, '2014-03-15 00:40:39.000000', 'temperatura', 116.0000, 'ºC'),
	(260076, 122, '2014-03-15 00:40:40.000000', 'temperatura', 619.0000, 'ºC'),
	(260077, 122, '2014-03-15 00:40:41.000000', 'temperatura', 350.0000, 'ºC'),
	(260078, 122, '2014-03-15 00:40:42.000000', 'temperatura', 1094.0000, 'ºC'),
	(260079, 122, '2014-03-15 00:40:43.000000', 'temperatura', 819.0000, 'ºC'),
	(260080, 122, '2014-03-15 00:40:44.000000', 'temperatura', 814.0000, 'ºC'),
	(260081, 122, '2014-03-15 00:40:45.000000', 'temperatura', 412.0000, 'ºC'),
	(260082, 122, '2014-03-15 00:40:46.000000', 'temperatura', 820.0000, 'ºC'),
	(260083, 122, '2014-03-15 00:40:47.000000', 'temperatura', 465.0000, 'ºC'),
	(260084, 122, '2014-03-15 00:40:48.000000', 'temperatura', 1063.0000, 'ºC'),
	(260085, 122, '2014-03-15 00:40:49.000000', 'temperatura', 322.0000, 'ºC'),
	(260086, 122, '2014-03-15 00:40:50.000000', 'temperatura', 823.0000, 'ºC'),
	(260087, 122, '2014-03-15 00:40:51.000000', 'temperatura', 750.0000, 'ºC'),
	(260088, 122, '2014-03-15 00:40:52.000000', 'temperatura', 79.0000, 'ºC'),
	(260089, 122, '2014-03-15 00:40:53.000000', 'temperatura', 547.0000, 'ºC'),
	(260090, 122, '2014-03-15 00:40:54.000000', 'temperatura', 100.0000, 'ºC'),
	(260091, 122, '2014-03-15 00:40:55.000000', 'temperatura', 56.0000, 'ºC'),
	(260092, 122, '2014-03-15 00:40:56.000000', 'temperatura', 1183.0000, 'ºC'),
	(260093, 122, '2014-03-15 00:40:57.000000', 'temperatura', 948.0000, 'ºC'),
	(260094, 122, '2014-03-15 00:40:58.000000', 'temperatura', 1192.0000, 'ºC'),
	(260095, 122, '2014-03-15 00:40:59.000000', 'temperatura', 717.0000, 'ºC'),
	(260096, 122, '2014-03-15 00:41:00.000000', 'temperatura', 7.0000, 'ºC'),
	(260097, 122, '2014-03-15 00:41:01.000000', 'temperatura', 286.0000, 'ºC'),
	(260098, 122, '2014-03-15 00:41:02.000000', 'temperatura', 208.0000, 'ºC'),
	(260099, 122, '2014-03-15 00:41:03.000000', 'temperatura', 182.0000, 'ºC'),
	(260100, 122, '2014-03-15 00:41:04.000000', 'temperatura', 285.0000, 'ºC'),
	(260101, 122, '2014-03-15 00:41:05.000000', 'temperatura', 883.0000, 'ºC'),
	(260102, 122, '2014-03-15 00:41:06.000000', 'temperatura', 1160.0000, 'ºC'),
	(260103, 122, '2014-03-15 00:41:07.000000', 'temperatura', 753.0000, 'ºC'),
	(260104, 122, '2014-03-15 00:41:08.000000', 'temperatura', 282.0000, 'ºC'),
	(260105, 122, '2014-03-15 00:41:09.000000', 'temperatura', 354.0000, 'ºC'),
	(260106, 122, '2014-03-15 00:41:10.000000', 'temperatura', 925.0000, 'ºC'),
	(260107, 122, '2014-03-15 00:41:11.000000', 'temperatura', 1161.0000, 'ºC'),
	(260108, 122, '2014-03-15 00:41:12.000000', 'temperatura', 630.0000, 'ºC'),
	(260109, 122, '2014-03-15 00:41:13.000000', 'temperatura', 869.0000, 'ºC'),
	(260110, 122, '2014-03-15 00:41:14.000000', 'temperatura', 54.0000, 'ºC'),
	(260111, 122, '2014-03-15 00:41:15.000000', 'temperatura', 64.0000, 'ºC'),
	(260112, 122, '2014-03-15 00:41:16.000000', 'temperatura', 157.0000, 'ºC'),
	(260113, 122, '2014-03-15 00:41:17.000000', 'temperatura', 594.0000, 'ºC'),
	(260114, 122, '2014-03-15 00:41:18.000000', 'temperatura', 98.0000, 'ºC'),
	(260115, 122, '2014-03-15 00:41:19.000000', 'temperatura', 1112.0000, 'ºC'),
	(260116, 122, '2014-03-15 00:41:20.000000', 'temperatura', 464.0000, 'ºC'),
	(260117, 122, '2014-03-15 00:41:21.000000', 'temperatura', 185.0000, 'ºC'),
	(260118, 122, '2014-03-15 00:41:22.000000', 'temperatura', 733.0000, 'ºC'),
	(260119, 122, '2014-03-15 00:41:23.000000', 'temperatura', 711.0000, 'ºC'),
	(260120, 122, '2014-03-15 00:41:24.000000', 'temperatura', 157.0000, 'ºC'),
	(260121, 122, '2014-03-15 00:41:25.000000', 'temperatura', 1054.0000, 'ºC'),
	(260122, 122, '2014-03-15 00:41:26.000000', 'temperatura', 1199.0000, 'ºC'),
	(260123, 122, '2014-03-15 00:41:27.000000', 'temperatura', 435.0000, 'ºC'),
	(260124, 122, '2014-03-15 00:41:28.000000', 'temperatura', 975.0000, 'ºC'),
	(260125, 122, '2014-03-15 00:41:29.000000', 'temperatura', 1173.0000, 'ºC'),
	(260126, 122, '2014-03-15 00:41:30.000000', 'temperatura', 539.0000, 'ºC'),
	(260127, 122, '2014-03-15 00:41:31.000000', 'temperatura', 377.0000, 'ºC'),
	(260128, 122, '2014-03-15 00:41:32.000000', 'temperatura', 267.0000, 'ºC'),
	(260129, 122, '2014-03-15 00:41:33.000000', 'temperatura', 204.0000, 'ºC'),
	(260130, 122, '2014-03-15 00:41:34.000000', 'temperatura', 221.0000, 'ºC'),
	(260131, 122, '2014-03-15 00:41:35.000000', 'temperatura', 495.0000, 'ºC'),
	(260132, 122, '2014-03-15 00:41:36.000000', 'temperatura', 612.0000, 'ºC'),
	(260133, 122, '2014-03-15 00:41:37.000000', 'temperatura', 377.0000, 'ºC'),
	(260134, 122, '2014-03-15 00:41:38.000000', 'temperatura', 47.0000, 'ºC'),
	(260135, 122, '2014-03-15 00:41:39.000000', 'temperatura', 304.0000, 'ºC'),
	(260136, 122, '2014-03-15 00:41:40.000000', 'temperatura', 180.0000, 'ºC'),
	(260137, 122, '2014-03-15 00:41:41.000000', 'temperatura', 1188.0000, 'ºC'),
	(260138, 122, '2014-03-15 00:41:42.000000', 'temperatura', 602.0000, 'ºC'),
	(260139, 122, '2014-03-15 00:41:43.000000', 'temperatura', 646.0000, 'ºC'),
	(260140, 122, '2014-03-15 00:41:44.000000', 'temperatura', 222.0000, 'ºC'),
	(260141, 122, '2014-03-15 00:41:45.000000', 'temperatura', 375.0000, 'ºC'),
	(260142, 122, '2014-03-15 00:41:46.000000', 'temperatura', 11.0000, 'ºC'),
	(260143, 122, '2014-03-15 00:41:47.000000', 'temperatura', 129.0000, 'ºC'),
	(260144, 122, '2014-03-15 00:41:48.000000', 'temperatura', 610.0000, 'ºC'),
	(260145, 122, '2014-03-15 00:41:49.000000', 'temperatura', 267.0000, 'ºC'),
	(260146, 122, '2014-03-15 00:41:50.000000', 'temperatura', 704.0000, 'ºC'),
	(260147, 122, '2014-03-15 00:41:51.000000', 'temperatura', 320.0000, 'ºC'),
	(260148, 122, '2014-03-15 00:41:52.000000', 'temperatura', 688.0000, 'ºC'),
	(260149, 122, '2014-03-15 00:41:53.000000', 'temperatura', 82.0000, 'ºC'),
	(260150, 122, '2014-03-15 00:41:54.000000', 'temperatura', 747.0000, 'ºC'),
	(260151, 122, '2014-03-15 00:41:55.000000', 'temperatura', 1087.0000, 'ºC'),
	(260152, 122, '2014-03-15 00:41:56.000000', 'temperatura', 797.0000, 'ºC'),
	(260153, 122, '2014-03-15 00:41:57.000000', 'temperatura', 725.0000, 'ºC'),
	(260154, 122, '2014-03-15 00:41:58.000000', 'temperatura', 33.0000, 'ºC'),
	(260155, 122, '2014-03-15 00:41:59.000000', 'temperatura', 392.0000, 'ºC'),
	(260156, 122, '2014-03-15 00:42:00.000000', 'temperatura', 659.0000, 'ºC'),
	(260157, 122, '2014-03-15 00:42:01.000000', 'temperatura', 920.0000, 'ºC'),
	(260158, 122, '2014-03-15 00:42:02.000000', 'temperatura', 223.0000, 'ºC'),
	(260159, 122, '2014-03-15 00:42:03.000000', 'temperatura', 757.0000, 'ºC'),
	(260160, 122, '2014-03-15 00:42:04.000000', 'temperatura', 716.0000, 'ºC'),
	(260161, 122, '2014-03-15 00:42:05.000000', 'temperatura', 108.0000, 'ºC'),
	(260162, 122, '2014-03-15 00:42:06.000000', 'temperatura', 795.0000, 'ºC'),
	(260163, 122, '2014-03-15 00:42:07.000000', 'temperatura', 52.0000, 'ºC'),
	(260164, 122, '2014-03-15 00:42:08.000000', 'temperatura', 273.0000, 'ºC'),
	(260165, 122, '2014-03-15 00:42:09.000000', 'temperatura', 10.0000, 'ºC'),
	(260166, 122, '2014-03-15 00:42:10.000000', 'temperatura', 433.0000, 'ºC'),
	(260167, 122, '2014-03-15 00:42:11.000000', 'temperatura', 935.0000, 'ºC'),
	(260168, 122, '2014-03-15 00:42:12.000000', 'temperatura', 975.0000, 'ºC'),
	(260169, 122, '2014-03-15 00:42:13.000000', 'temperatura', 870.0000, 'ºC'),
	(260170, 122, '2014-03-15 00:42:14.000000', 'temperatura', 225.0000, 'ºC'),
	(260171, 122, '2014-03-15 00:42:15.000000', 'temperatura', 915.0000, 'ºC'),
	(260172, 122, '2014-03-15 00:42:16.000000', 'temperatura', 302.0000, 'ºC'),
	(260173, 122, '2014-03-15 00:42:17.000000', 'temperatura', 1165.0000, 'ºC'),
	(260174, 122, '2014-03-15 00:42:18.000000', 'temperatura', 120.0000, 'ºC'),
	(260175, 122, '2014-03-15 00:42:19.000000', 'temperatura', 704.0000, 'ºC'),
	(260176, 122, '2014-03-15 00:42:20.000000', 'temperatura', 760.0000, 'ºC'),
	(260177, 122, '2014-03-15 00:42:21.000000', 'temperatura', 490.0000, 'ºC'),
	(260178, 122, '2014-03-15 00:42:22.000000', 'temperatura', 168.0000, 'ºC'),
	(260179, 122, '2014-03-15 00:42:23.000000', 'temperatura', 573.0000, 'ºC'),
	(260180, 122, '2014-03-15 00:42:24.000000', 'temperatura', 1162.0000, 'ºC'),
	(260181, 122, '2014-03-15 00:42:25.000000', 'temperatura', 490.0000, 'ºC'),
	(260182, 122, '2014-03-15 00:42:26.000000', 'temperatura', 166.0000, 'ºC'),
	(260183, 122, '2014-03-15 00:42:27.000000', 'temperatura', 560.0000, 'ºC'),
	(260184, 122, '2014-03-15 00:42:28.000000', 'temperatura', 1103.0000, 'ºC'),
	(260185, 122, '2014-03-15 00:42:29.000000', 'temperatura', 234.0000, 'ºC'),
	(260186, 122, '2014-03-15 00:42:30.000000', 'temperatura', 263.0000, 'ºC'),
	(260187, 122, '2014-03-15 00:42:31.000000', 'temperatura', 613.0000, 'ºC'),
	(260188, 122, '2014-03-15 00:42:32.000000', 'temperatura', 1077.0000, 'ºC'),
	(260189, 122, '2014-03-15 00:42:33.000000', 'temperatura', 1147.0000, 'ºC'),
	(260190, 122, '2014-03-15 00:42:34.000000', 'temperatura', 105.0000, 'ºC'),
	(260191, 122, '2014-03-15 00:42:35.000000', 'temperatura', 686.0000, 'ºC'),
	(260192, 122, '2014-03-15 00:42:36.000000', 'temperatura', 712.0000, 'ºC'),
	(260193, 122, '2014-03-15 00:42:37.000000', 'temperatura', 305.0000, 'ºC'),
	(260194, 122, '2014-03-15 00:42:38.000000', 'temperatura', 590.0000, 'ºC'),
	(260195, 122, '2014-03-15 00:42:39.000000', 'temperatura', 833.0000, 'ºC'),
	(260196, 122, '2014-03-15 00:42:40.000000', 'temperatura', 1196.0000, 'ºC'),
	(260197, 122, '2014-03-15 00:42:41.000000', 'temperatura', 1081.0000, 'ºC'),
	(260198, 122, '2014-03-15 00:42:42.000000', 'temperatura', 618.0000, 'ºC'),
	(260199, 122, '2014-03-15 00:42:43.000000', 'temperatura', 1047.0000, 'ºC'),
	(260200, 122, '2014-03-15 00:42:44.000000', 'temperatura', 983.0000, 'ºC'),
	(260201, 122, '2014-03-15 00:42:45.000000', 'temperatura', 574.0000, 'ºC'),
	(260202, 122, '2014-03-15 00:42:46.000000', 'temperatura', 1119.0000, 'ºC'),
	(260203, 122, '2014-03-15 00:42:47.000000', 'temperatura', 276.0000, 'ºC'),
	(260204, 122, '2014-03-15 00:42:48.000000', 'temperatura', 424.0000, 'ºC'),
	(260205, 122, '2014-03-15 00:42:49.000000', 'temperatura', 90.0000, 'ºC'),
	(260206, 122, '2014-03-15 00:42:50.000000', 'temperatura', 379.0000, 'ºC'),
	(260207, 122, '2014-03-15 00:42:51.000000', 'temperatura', 428.0000, 'ºC'),
	(260208, 122, '2014-03-15 00:42:52.000000', 'temperatura', 1000.0000, 'ºC'),
	(260209, 122, '2014-03-15 00:42:53.000000', 'temperatura', 119.0000, 'ºC'),
	(260210, 122, '2014-03-15 00:42:54.000000', 'temperatura', 1193.0000, 'ºC'),
	(260211, 122, '2014-03-15 00:42:55.000000', 'temperatura', 810.0000, 'ºC'),
	(260212, 122, '2014-03-15 00:42:56.000000', 'temperatura', 473.0000, 'ºC'),
	(260213, 122, '2014-03-15 00:42:57.000000', 'temperatura', 1135.0000, 'ºC'),
	(260214, 122, '2014-03-15 00:42:58.000000', 'temperatura', 654.0000, 'ºC'),
	(260215, 122, '2014-03-15 00:42:59.000000', 'temperatura', 1068.0000, 'ºC'),
	(260216, 122, '2014-03-15 00:43:00.000000', 'temperatura', 976.0000, 'ºC'),
	(260217, 122, '2014-03-15 00:43:01.000000', 'temperatura', 479.0000, 'ºC'),
	(260218, 122, '2014-03-15 00:43:02.000000', 'temperatura', 669.0000, 'ºC'),
	(260219, 122, '2014-03-15 00:43:03.000000', 'temperatura', 705.0000, 'ºC'),
	(260220, 122, '2014-03-15 00:43:04.000000', 'temperatura', 321.0000, 'ºC'),
	(260221, 122, '2014-03-15 00:43:05.000000', 'temperatura', 692.0000, 'ºC'),
	(260222, 122, '2014-03-15 00:43:06.000000', 'temperatura', 94.0000, 'ºC'),
	(260223, 122, '2014-03-15 00:43:07.000000', 'temperatura', 798.0000, 'ºC'),
	(260224, 122, '2014-03-15 00:43:08.000000', 'temperatura', 105.0000, 'ºC'),
	(260225, 122, '2014-03-15 00:43:09.000000', 'temperatura', 534.0000, 'ºC'),
	(260226, 122, '2014-03-15 00:43:10.000000', 'temperatura', 1154.0000, 'ºC'),
	(260227, 122, '2014-03-15 00:43:11.000000', 'temperatura', 570.0000, 'ºC'),
	(260228, 122, '2014-03-15 00:43:12.000000', 'temperatura', 588.0000, 'ºC'),
	(260229, 122, '2014-03-15 00:43:13.000000', 'temperatura', 31.0000, 'ºC'),
	(260230, 122, '2014-03-15 00:43:14.000000', 'temperatura', 792.0000, 'ºC'),
	(260231, 122, '2014-03-15 00:43:15.000000', 'temperatura', 266.0000, 'ºC'),
	(260232, 122, '2014-03-15 00:43:16.000000', 'temperatura', 155.0000, 'ºC'),
	(260233, 122, '2014-03-15 00:43:17.000000', 'temperatura', 1177.0000, 'ºC'),
	(260234, 122, '2014-03-15 00:43:18.000000', 'temperatura', 622.0000, 'ºC'),
	(260235, 122, '2014-03-15 00:43:19.000000', 'temperatura', 778.0000, 'ºC'),
	(260236, 122, '2014-03-15 00:43:20.000000', 'temperatura', 826.0000, 'ºC'),
	(260237, 122, '2014-03-15 00:43:21.000000', 'temperatura', 597.0000, 'ºC'),
	(260238, 122, '2014-03-15 00:43:22.000000', 'temperatura', 508.0000, 'ºC'),
	(260239, 122, '2014-03-15 00:43:23.000000', 'temperatura', 749.0000, 'ºC'),
	(260240, 122, '2014-03-15 00:43:24.000000', 'temperatura', 1022.0000, 'ºC'),
	(260241, 122, '2014-03-15 00:43:25.000000', 'temperatura', 461.0000, 'ºC'),
	(260242, 122, '2014-03-15 00:43:26.000000', 'temperatura', 440.0000, 'ºC'),
	(260243, 122, '2014-03-15 00:43:27.000000', 'temperatura', 819.0000, 'ºC'),
	(260244, 122, '2014-03-15 00:43:28.000000', 'temperatura', 377.0000, 'ºC'),
	(260245, 122, '2014-03-15 00:43:29.000000', 'temperatura', 627.0000, 'ºC'),
	(260246, 122, '2014-03-15 00:43:30.000000', 'temperatura', 805.0000, 'ºC'),
	(260247, 122, '2014-03-15 00:43:31.000000', 'temperatura', 942.0000, 'ºC'),
	(260248, 122, '2014-03-15 00:43:32.000000', 'temperatura', 1098.0000, 'ºC'),
	(260249, 122, '2014-03-15 00:43:33.000000', 'temperatura', 263.0000, 'ºC'),
	(260250, 122, '2014-03-15 00:43:34.000000', 'temperatura', 423.0000, 'ºC'),
	(260251, 122, '2014-03-15 00:43:35.000000', 'temperatura', 127.0000, 'ºC'),
	(260252, 122, '2014-03-15 00:43:36.000000', 'temperatura', 568.0000, 'ºC'),
	(260253, 122, '2014-03-15 00:43:37.000000', 'temperatura', 56.0000, 'ºC'),
	(260254, 122, '2014-03-15 00:43:38.000000', 'temperatura', 979.0000, 'ºC'),
	(260255, 122, '2014-03-15 00:43:39.000000', 'temperatura', 1125.0000, 'ºC'),
	(260256, 122, '2014-03-15 00:43:40.000000', 'temperatura', 290.0000, 'ºC'),
	(260257, 122, '2014-03-15 00:43:41.000000', 'temperatura', 474.0000, 'ºC'),
	(260258, 122, '2014-03-15 00:43:42.000000', 'temperatura', 301.0000, 'ºC'),
	(260259, 122, '2014-03-15 00:43:43.000000', 'temperatura', 84.0000, 'ºC'),
	(260260, 122, '2014-03-15 00:43:44.000000', 'temperatura', 718.0000, 'ºC'),
	(260261, 122, '2014-03-15 00:43:45.000000', 'temperatura', 940.0000, 'ºC'),
	(260262, 122, '2014-03-15 00:43:46.000000', 'temperatura', 144.0000, 'ºC'),
	(260263, 122, '2014-03-15 00:43:47.000000', 'temperatura', 300.0000, 'ºC'),
	(260264, 122, '2014-03-15 00:43:48.000000', 'temperatura', 1071.0000, 'ºC'),
	(260265, 122, '2014-03-15 00:43:49.000000', 'temperatura', 856.0000, 'ºC'),
	(260266, 122, '2014-03-15 00:43:50.000000', 'temperatura', 1065.0000, 'ºC'),
	(260267, 122, '2014-03-15 00:43:51.000000', 'temperatura', 359.0000, 'ºC'),
	(260268, 122, '2014-03-15 00:43:52.000000', 'temperatura', 1002.0000, 'ºC'),
	(260269, 122, '2014-03-15 00:43:53.000000', 'temperatura', 331.0000, 'ºC'),
	(260270, 122, '2014-03-15 00:43:54.000000', 'temperatura', 1050.0000, 'ºC'),
	(260271, 122, '2014-03-15 00:43:55.000000', 'temperatura', 656.0000, 'ºC'),
	(260272, 122, '2014-03-15 00:43:56.000000', 'temperatura', 132.0000, 'ºC'),
	(260273, 122, '2014-03-15 00:43:57.000000', 'temperatura', 1091.0000, 'ºC'),
	(260274, 122, '2014-03-15 00:43:58.000000', 'temperatura', 261.0000, 'ºC'),
	(260275, 122, '2014-03-15 00:43:59.000000', 'temperatura', 431.0000, 'ºC'),
	(260276, 122, '2014-03-15 00:44:00.000000', 'temperatura', 173.0000, 'ºC'),
	(260277, 122, '2014-03-15 00:44:01.000000', 'temperatura', 773.0000, 'ºC'),
	(260278, 122, '2014-03-15 00:44:02.000000', 'temperatura', 948.0000, 'ºC'),
	(260279, 122, '2014-03-15 00:44:03.000000', 'temperatura', 20.0000, 'ºC'),
	(260280, 122, '2014-03-15 00:44:04.000000', 'temperatura', 855.0000, 'ºC'),
	(260281, 122, '2014-03-15 00:44:05.000000', 'temperatura', 616.0000, 'ºC'),
	(260282, 122, '2014-03-15 00:44:06.000000', 'temperatura', 517.0000, 'ºC'),
	(260283, 122, '2014-03-15 00:44:07.000000', 'temperatura', 738.0000, 'ºC'),
	(260284, 122, '2014-03-15 00:44:08.000000', 'temperatura', 940.0000, 'ºC'),
	(260285, 122, '2014-03-15 00:44:09.000000', 'temperatura', 84.0000, 'ºC'),
	(260286, 122, '2014-03-15 00:44:10.000000', 'temperatura', 0.0000, 'ºC'),
	(260287, 122, '2014-03-15 00:44:11.000000', 'temperatura', 949.0000, 'ºC'),
	(260288, 122, '2014-03-15 00:44:12.000000', 'temperatura', 1145.0000, 'ºC'),
	(260289, 122, '2014-03-15 00:44:13.000000', 'temperatura', 478.0000, 'ºC'),
	(260290, 122, '2014-03-15 00:44:14.000000', 'temperatura', 156.0000, 'ºC'),
	(260291, 122, '2014-03-15 00:44:15.000000', 'temperatura', 548.0000, 'ºC'),
	(260292, 122, '2014-03-15 00:44:16.000000', 'temperatura', 1070.0000, 'ºC'),
	(260293, 122, '2014-03-15 00:44:17.000000', 'temperatura', 106.0000, 'ºC'),
	(260294, 122, '2014-03-15 00:44:18.000000', 'temperatura', 921.0000, 'ºC'),
	(260295, 122, '2014-03-15 00:44:19.000000', 'temperatura', 689.0000, 'ºC'),
	(260296, 122, '2014-03-15 00:44:20.000000', 'temperatura', 682.0000, 'ºC'),
	(260297, 122, '2014-03-15 00:44:21.000000', 'temperatura', 144.0000, 'ºC'),
	(260298, 122, '2014-03-15 00:44:22.000000', 'temperatura', 1075.0000, 'ºC'),
	(260299, 122, '2014-03-15 00:44:23.000000', 'temperatura', 144.0000, 'ºC'),
	(260300, 122, '2014-03-15 00:44:24.000000', 'temperatura', 1095.0000, 'ºC'),
	(260301, 122, '2014-03-15 00:44:25.000000', 'temperatura', 245.0000, 'ºC'),
	(260302, 122, '2014-03-15 00:44:26.000000', 'temperatura', 341.0000, 'ºC'),
	(260303, 122, '2014-03-15 00:44:27.000000', 'temperatura', 968.0000, 'ºC'),
	(260304, 122, '2014-03-15 00:44:28.000000', 'temperatura', 218.0000, 'ºC'),
	(260305, 122, '2014-03-15 00:44:29.000000', 'temperatura', 585.0000, 'ºC'),
	(260306, 122, '2014-03-15 00:44:30.000000', 'temperatura', 1074.0000, 'ºC'),
	(260307, 122, '2014-03-15 00:44:31.000000', 'temperatura', 15.0000, 'ºC'),
	(260308, 122, '2014-03-15 00:44:32.000000', 'temperatura', 453.0000, 'ºC'),
	(260309, 122, '2014-03-15 00:44:33.000000', 'temperatura', 1022.0000, 'ºC'),
	(260310, 122, '2014-03-15 00:44:34.000000', 'temperatura', 150.0000, 'ºC'),
	(260311, 122, '2014-03-15 00:44:35.000000', 'temperatura', 83.0000, 'ºC'),
	(260312, 122, '2014-03-15 00:44:36.000000', 'temperatura', 1168.0000, 'ºC'),
	(260313, 122, '2014-03-15 00:44:37.000000', 'temperatura', 790.0000, 'ºC'),
	(260314, 122, '2014-03-15 00:44:38.000000', 'temperatura', 445.0000, 'ºC'),
	(260315, 122, '2014-03-15 00:44:39.000000', 'temperatura', 1057.0000, 'ºC'),
	(260316, 122, '2014-03-15 00:44:40.000000', 'temperatura', 352.0000, 'ºC'),
	(260317, 122, '2014-03-15 00:44:41.000000', 'temperatura', 990.0000, 'ºC'),
	(260318, 122, '2014-03-15 00:44:42.000000', 'temperatura', 294.0000, 'ºC'),
	(260319, 122, '2014-03-15 00:44:43.000000', 'temperatura', 902.0000, 'ºC'),
	(260320, 122, '2014-03-15 00:44:44.000000', 'temperatura', 26.0000, 'ºC'),
	(260321, 122, '2014-03-15 00:44:45.000000', 'temperatura', 1025.0000, 'ºC'),
	(260322, 122, '2014-03-15 00:44:46.000000', 'temperatura', 248.0000, 'ºC'),
	(260323, 122, '2014-03-15 00:44:47.000000', 'temperatura', 566.0000, 'ºC'),
	(260324, 122, '2014-03-15 00:44:48.000000', 'temperatura', 887.0000, 'ºC'),
	(260325, 122, '2014-03-15 00:44:49.000000', 'temperatura', 339.0000, 'ºC'),
	(260326, 122, '2014-03-15 00:44:50.000000', 'temperatura', 232.0000, 'ºC'),
	(260327, 122, '2014-03-15 00:44:51.000000', 'temperatura', 145.0000, 'ºC'),
	(260328, 122, '2014-03-15 00:44:52.000000', 'temperatura', 29.0000, 'ºC'),
	(260329, 122, '2014-03-15 00:44:53.000000', 'temperatura', 911.0000, 'ºC'),
	(260330, 122, '2014-03-15 00:44:54.000000', 'temperatura', 868.0000, 'ºC'),
	(260331, 122, '2014-03-15 00:44:55.000000', 'temperatura', 410.0000, 'ºC'),
	(260332, 122, '2014-03-15 00:44:56.000000', 'temperatura', 643.0000, 'ºC'),
	(260333, 122, '2014-03-15 00:44:57.000000', 'temperatura', 788.0000, 'ºC'),
	(260334, 122, '2014-03-15 00:44:58.000000', 'temperatura', 811.0000, 'ºC'),
	(260335, 122, '2014-03-15 00:44:59.000000', 'temperatura', 492.0000, 'ºC'),
	(260336, 122, '2014-03-15 00:45:00.000000', 'temperatura', 28.0000, 'ºC'),
	(260337, 122, '2014-03-15 00:45:01.000000', 'temperatura', 1065.0000, 'ºC'),
	(260338, 122, '2014-03-15 00:45:02.000000', 'temperatura', 441.0000, 'ºC'),
	(260339, 122, '2014-03-15 00:45:03.000000', 'temperatura', 210.0000, 'ºC'),
	(260340, 122, '2014-03-15 00:45:04.000000', 'temperatura', 928.0000, 'ºC'),
	(260341, 122, '2014-03-15 00:45:05.000000', 'temperatura', 412.0000, 'ºC'),
	(260342, 122, '2014-03-15 00:45:06.000000', 'temperatura', 476.0000, 'ºC'),
	(260343, 122, '2014-03-15 00:45:07.000000', 'temperatura', 1146.0000, 'ºC'),
	(260344, 122, '2014-03-15 00:45:08.000000', 'temperatura', 701.0000, 'ºC'),
	(260345, 122, '2014-03-15 00:45:09.000000', 'temperatura', 67.0000, 'ºC'),
	(260346, 122, '2014-03-15 00:45:10.000000', 'temperatura', 631.0000, 'ºC'),
	(260347, 122, '2014-03-15 00:45:11.000000', 'temperatura', 557.0000, 'ºC'),
	(260348, 122, '2014-03-15 00:45:12.000000', 'temperatura', 890.0000, 'ºC'),
	(260349, 122, '2014-03-15 00:45:13.000000', 'temperatura', 381.0000, 'ºC'),
	(260350, 122, '2014-03-15 00:45:14.000000', 'temperatura', 435.0000, 'ºC'),
	(260351, 122, '2014-03-15 00:45:15.000000', 'temperatura', 1033.0000, 'ºC'),
	(260352, 122, '2014-03-15 00:45:16.000000', 'temperatura', 261.0000, 'ºC'),
	(260353, 122, '2014-03-15 00:45:17.000000', 'temperatura', 607.0000, 'ºC'),
	(260354, 122, '2014-03-15 00:45:18.000000', 'temperatura', 1053.0000, 'ºC'),
	(260355, 122, '2014-03-15 00:45:19.000000', 'temperatura', 1045.0000, 'ºC'),
	(260356, 122, '2014-03-15 00:45:20.000000', 'temperatura', 866.0000, 'ºC'),
	(260357, 122, '2014-03-15 00:45:21.000000', 'temperatura', 1197.0000, 'ºC'),
	(260358, 122, '2014-03-15 00:45:22.000000', 'temperatura', 986.0000, 'ºC'),
	(260359, 122, '2014-03-15 00:45:23.000000', 'temperatura', 139.0000, 'ºC'),
	(260360, 122, '2014-03-15 00:45:24.000000', 'temperatura', 139.0000, 'ºC'),
	(260361, 122, '2014-03-15 00:45:25.000000', 'temperatura', 277.0000, 'ºC'),
	(260362, 122, '2014-03-15 00:45:26.000000', 'temperatura', 970.0000, 'ºC'),
	(260363, 122, '2014-03-15 00:45:27.000000', 'temperatura', 418.0000, 'ºC'),
	(260364, 122, '2014-03-15 00:45:28.000000', 'temperatura', 383.0000, 'ºC'),
	(260365, 122, '2014-03-15 00:45:29.000000', 'temperatura', 659.0000, 'ºC'),
	(260366, 122, '2014-03-15 00:45:30.000000', 'temperatura', 949.0000, 'ºC'),
	(260367, 122, '2014-03-15 00:45:31.000000', 'temperatura', 369.0000, 'ºC'),
	(260368, 122, '2014-03-15 00:45:32.000000', 'temperatura', 196.0000, 'ºC'),
	(260369, 122, '2014-03-15 00:45:33.000000', 'temperatura', 1077.0000, 'ºC'),
	(260370, 122, '2014-03-15 00:45:34.000000', 'temperatura', 1194.0000, 'ºC'),
	(260371, 122, '2014-03-15 00:45:35.000000', 'temperatura', 339.0000, 'ºC'),
	(260372, 122, '2014-03-15 00:45:36.000000', 'temperatura', 516.0000, 'ºC'),
	(260373, 122, '2014-03-15 00:45:37.000000', 'temperatura', 363.0000, 'ºC'),
	(260374, 122, '2014-03-15 00:45:38.000000', 'temperatura', 268.0000, 'ºC'),
	(260375, 122, '2014-03-15 00:45:39.000000', 'temperatura', 253.0000, 'ºC'),
	(260376, 122, '2014-03-15 00:45:40.000000', 'temperatura', 460.0000, 'ºC'),
	(260377, 122, '2014-03-15 00:45:41.000000', 'temperatura', 340.0000, 'ºC'),
	(260378, 122, '2014-03-15 00:45:42.000000', 'temperatura', 322.0000, 'ºC'),
	(260379, 122, '2014-03-15 00:45:43.000000', 'temperatura', 589.0000, 'ºC'),
	(260380, 122, '2014-03-15 00:45:44.000000', 'temperatura', 782.0000, 'ºC'),
	(260381, 122, '2014-03-15 00:45:45.000000', 'temperatura', 943.0000, 'ºC'),
	(260382, 122, '2014-03-15 00:45:46.000000', 'temperatura', 1167.0000, 'ºC'),
	(260383, 122, '2014-03-15 00:45:47.000000', 'temperatura', 608.0000, 'ºC'),
	(260384, 122, '2014-03-15 00:45:48.000000', 'temperatura', 739.0000, 'ºC'),
	(260385, 122, '2014-03-15 00:45:49.000000', 'temperatura', 674.0000, 'ºC'),
	(260386, 122, '2014-03-15 00:45:50.000000', 'temperatura', 1151.0000, 'ºC'),
	(260387, 122, '2014-03-15 00:45:51.000000', 'temperatura', 134.0000, 'ºC'),
	(260388, 122, '2014-03-15 00:45:52.000000', 'temperatura', 816.0000, 'ºC'),
	(260389, 122, '2014-03-15 00:45:53.000000', 'temperatura', 80.0000, 'ºC'),
	(260390, 122, '2014-03-15 00:45:54.000000', 'temperatura', 351.0000, 'ºC'),
	(260391, 122, '2014-03-15 00:45:55.000000', 'temperatura', 317.0000, 'ºC'),
	(260392, 122, '2014-03-15 00:45:56.000000', 'temperatura', 532.0000, 'ºC'),
	(260393, 122, '2014-03-15 00:45:57.000000', 'temperatura', 508.0000, 'ºC'),
	(260394, 122, '2014-03-15 00:45:58.000000', 'temperatura', 947.0000, 'ºC'),
	(260395, 122, '2014-03-15 00:45:59.000000', 'temperatura', 810.0000, 'ºC'),
	(260396, 122, '2014-03-15 00:46:00.000000', 'temperatura', 11.0000, 'ºC'),
	(260397, 122, '2014-03-15 00:46:01.000000', 'temperatura', 23.0000, 'ºC'),
	(260398, 122, '2014-03-15 00:46:02.000000', 'temperatura', 83.0000, 'ºC'),
	(260399, 122, '2014-03-15 00:46:03.000000', 'temperatura', 346.0000, 'ºC'),
	(260400, 122, '2014-03-15 00:46:04.000000', 'temperatura', 284.0000, 'ºC'),
	(260401, 122, '2014-03-15 00:46:05.000000', 'temperatura', 379.0000, 'ºC'),
	(260402, 122, '2014-03-15 00:46:06.000000', 'temperatura', 1046.0000, 'ºC'),
	(260403, 122, '2014-03-15 00:46:07.000000', 'temperatura', 494.0000, 'ºC'),
	(260404, 122, '2014-03-15 00:46:08.000000', 'temperatura', 530.0000, 'ºC'),
	(260405, 122, '2014-03-15 00:46:09.000000', 'temperatura', 1170.0000, 'ºC'),
	(260406, 122, '2014-03-15 00:46:10.000000', 'temperatura', 659.0000, 'ºC'),
	(260407, 122, '2014-03-15 00:46:11.000000', 'temperatura', 985.0000, 'ºC'),
	(260408, 122, '2014-03-15 00:46:12.000000', 'temperatura', 550.0000, 'ºC'),
	(260409, 122, '2014-03-15 00:46:13.000000', 'temperatura', 996.0000, 'ºC'),
	(260410, 122, '2014-03-15 00:46:14.000000', 'temperatura', 932.0000, 'ºC'),
	(260411, 122, '2014-03-15 00:46:15.000000', 'temperatura', 470.0000, 'ºC'),
	(260412, 122, '2014-03-15 00:46:16.000000', 'temperatura', 754.0000, 'ºC'),
	(260413, 122, '2014-03-15 00:46:17.000000', 'temperatura', 1162.0000, 'ºC'),
	(260414, 122, '2014-03-15 00:46:18.000000', 'temperatura', 1148.0000, 'ºC'),
	(260415, 122, '2014-03-15 00:46:19.000000', 'temperatura', 1056.0000, 'ºC'),
	(260416, 122, '2014-03-15 00:46:20.000000', 'temperatura', 636.0000, 'ºC'),
	(260417, 122, '2014-03-15 00:46:21.000000', 'temperatura', 13.0000, 'ºC'),
	(260418, 122, '2014-03-15 00:46:22.000000', 'temperatura', 558.0000, 'ºC'),
	(260419, 122, '2014-03-15 00:46:23.000000', 'temperatura', 349.0000, 'ºC'),
	(260420, 122, '2014-03-15 00:46:24.000000', 'temperatura', 73.0000, 'ºC'),
	(260421, 122, '2014-03-15 00:46:25.000000', 'temperatura', 517.0000, 'ºC'),
	(260422, 122, '2014-03-15 00:46:26.000000', 'temperatura', 1167.0000, 'ºC'),
	(260423, 122, '2014-03-15 00:46:27.000000', 'temperatura', 687.0000, 'ºC'),
	(260424, 122, '2014-03-15 00:46:28.000000', 'temperatura', 1132.0000, 'ºC'),
	(260425, 122, '2014-03-15 00:46:29.000000', 'temperatura', 1.0000, 'ºC'),
	(260426, 122, '2014-03-15 00:46:30.000000', 'temperatura', 209.0000, 'ºC'),
	(260427, 122, '2014-03-15 00:46:31.000000', 'temperatura', 1044.0000, 'ºC'),
	(260428, 122, '2014-03-15 00:46:32.000000', 'temperatura', 992.0000, 'ºC'),
	(260429, 122, '2014-03-15 00:46:33.000000', 'temperatura', 629.0000, 'ºC'),
	(260430, 122, '2014-03-15 00:46:34.000000', 'temperatura', 169.0000, 'ºC'),
	(260431, 122, '2014-03-15 00:46:35.000000', 'temperatura', 159.0000, 'ºC'),
	(260432, 122, '2014-03-15 00:46:36.000000', 'temperatura', 290.0000, 'ºC'),
	(260433, 122, '2014-03-15 00:46:37.000000', 'temperatura', 972.0000, 'ºC'),
	(260434, 122, '2014-03-15 00:46:38.000000', 'temperatura', 392.0000, 'ºC'),
	(260435, 122, '2014-03-15 00:46:39.000000', 'temperatura', 245.0000, 'ºC'),
	(260436, 122, '2014-03-15 00:46:40.000000', 'temperatura', 48.0000, 'ºC'),
	(260437, 122, '2014-03-15 00:46:41.000000', 'temperatura', 704.0000, 'ºC'),
	(260438, 122, '2014-03-15 00:46:42.000000', 'temperatura', 977.0000, 'ºC'),
	(260439, 122, '2014-03-15 00:46:43.000000', 'temperatura', 374.0000, 'ºC'),
	(260440, 122, '2014-03-15 00:46:44.000000', 'temperatura', 139.0000, 'ºC'),
	(260441, 122, '2014-03-15 00:46:45.000000', 'temperatura', 775.0000, 'ºC'),
	(260442, 122, '2014-03-15 00:46:46.000000', 'temperatura', 1060.0000, 'ºC'),
	(260443, 122, '2014-03-15 00:46:47.000000', 'temperatura', 573.0000, 'ºC'),
	(260444, 122, '2014-03-15 00:46:48.000000', 'temperatura', 886.0000, 'ºC'),
	(260445, 122, '2014-03-15 00:46:49.000000', 'temperatura', 313.0000, 'ºC'),
	(260446, 122, '2014-03-15 00:46:50.000000', 'temperatura', 106.0000, 'ºC'),
	(260447, 122, '2014-03-15 00:46:51.000000', 'temperatura', 793.0000, 'ºC'),
	(260448, 122, '2014-03-15 00:46:52.000000', 'temperatura', 48.0000, 'ºC'),
	(260449, 122, '2014-03-15 00:46:53.000000', 'temperatura', 263.0000, 'ºC'),
	(260450, 122, '2014-03-15 00:46:54.000000', 'temperatura', 1168.0000, 'ºC'),
	(260451, 122, '2014-03-15 00:46:55.000000', 'temperatura', 253.0000, 'ºC'),
	(260452, 122, '2014-03-15 00:46:56.000000', 'temperatura', 161.0000, 'ºC'),
	(260453, 122, '2014-03-15 00:46:57.000000', 'temperatura', 45.0000, 'ºC'),
	(260454, 122, '2014-03-15 00:46:58.000000', 'temperatura', 945.0000, 'ºC'),
	(260455, 122, '2014-03-15 00:46:59.000000', 'temperatura', 988.0000, 'ºC'),
	(260456, 122, '2014-03-15 00:47:00.000000', 'temperatura', 908.0000, 'ºC'),
	(260457, 122, '2014-03-15 00:47:01.000000', 'temperatura', 377.0000, 'ºC'),
	(260458, 122, '2014-03-15 00:47:02.000000', 'temperatura', 360.0000, 'ºC'),
	(260459, 122, '2014-03-15 00:47:03.000000', 'temperatura', 669.0000, 'ºC'),
	(260460, 122, '2014-03-15 00:47:04.000000', 'temperatura', 1066.0000, 'ºC'),
	(260461, 122, '2014-03-15 00:47:05.000000', 'temperatura', 926.0000, 'ºC'),
	(260462, 122, '2014-03-15 00:47:06.000000', 'temperatura', 229.0000, 'ºC'),
	(260463, 122, '2014-03-15 00:47:07.000000', 'temperatura', 769.0000, 'ºC'),
	(260464, 122, '2014-03-15 00:47:08.000000', 'temperatura', 759.0000, 'ºC'),
	(260465, 122, '2014-03-15 00:47:09.000000', 'temperatura', 288.0000, 'ºC'),
	(260466, 122, '2014-03-15 00:47:10.000000', 'temperatura', 366.0000, 'ºC'),
	(260467, 122, '2014-03-15 00:47:11.000000', 'temperatura', 963.0000, 'ºC'),
	(260468, 122, '2014-03-15 00:47:12.000000', 'temperatura', 118.0000, 'ºC'),
	(260469, 122, '2014-03-15 00:47:13.000000', 'temperatura', 101.0000, 'ºC'),
	(260470, 122, '2014-03-15 00:47:14.000000', 'temperatura', 154.0000, 'ºC'),
	(260471, 122, '2014-03-15 00:47:15.000000', 'temperatura', 467.0000, 'ºC'),
	(260472, 122, '2014-03-15 00:47:16.000000', 'temperatura', 673.0000, 'ºC'),
	(260473, 122, '2014-03-15 00:47:17.000000', 'temperatura', 764.0000, 'ºC'),
	(260474, 122, '2014-03-15 00:47:18.000000', 'temperatura', 603.0000, 'ºC'),
	(260475, 122, '2014-03-15 00:47:19.000000', 'temperatura', 723.0000, 'ºC'),
	(260476, 122, '2014-03-15 00:47:20.000000', 'temperatura', 606.0000, 'ºC'),
	(260477, 122, '2014-03-15 00:47:21.000000', 'temperatura', 862.0000, 'ºC'),
	(260478, 122, '2014-03-15 00:47:22.000000', 'temperatura', 94.0000, 'ºC'),
	(260479, 122, '2014-03-15 00:47:23.000000', 'temperatura', 284.0000, 'ºC'),
	(260480, 122, '2014-03-15 00:47:24.000000', 'temperatura', 1138.0000, 'ºC'),
	(260481, 122, '2014-03-15 00:47:25.000000', 'temperatura', 39.0000, 'ºC'),
	(260482, 122, '2014-03-15 00:47:26.000000', 'temperatura', 381.0000, 'ºC'),
	(260483, 122, '2014-03-15 00:47:27.000000', 'temperatura', 588.0000, 'ºC'),
	(260484, 122, '2014-03-15 00:47:28.000000', 'temperatura', 598.0000, 'ºC'),
	(260485, 122, '2014-03-15 00:47:29.000000', 'temperatura', 27.0000, 'ºC'),
	(260486, 122, '2014-03-15 00:47:30.000000', 'temperatura', 743.0000, 'ºC'),
	(260487, 122, '2014-03-15 00:47:31.000000', 'temperatura', 32.0000, 'ºC'),
	(260488, 122, '2014-03-15 00:47:32.000000', 'temperatura', 334.0000, 'ºC'),
	(260489, 122, '2014-03-15 00:47:33.000000', 'temperatura', 375.0000, 'ºC'),
	(260490, 122, '2014-03-15 00:47:34.000000', 'temperatura', 871.0000, 'ºC'),
	(260491, 122, '2014-03-15 00:47:35.000000', 'temperatura', 832.0000, 'ºC'),
	(260492, 122, '2014-03-15 00:47:36.000000', 'temperatura', 348.0000, 'ºC'),
	(260493, 122, '2014-03-15 00:47:37.000000', 'temperatura', 444.0000, 'ºC'),
	(260494, 122, '2014-03-15 00:47:38.000000', 'temperatura', 1178.0000, 'ºC'),
	(260495, 122, '2014-03-15 00:47:39.000000', 'temperatura', 956.0000, 'ºC'),
	(260496, 122, '2014-03-15 00:47:40.000000', 'temperatura', 48.0000, 'ºC'),
	(260497, 122, '2014-03-15 00:47:41.000000', 'temperatura', 973.0000, 'ºC'),
	(260498, 122, '2014-03-15 00:47:42.000000', 'temperatura', 1119.0000, 'ºC'),
	(260499, 122, '2014-03-15 00:47:43.000000', 'temperatura', 278.0000, 'ºC'),
	(260500, 122, '2014-03-15 00:47:44.000000', 'temperatura', 436.0000, 'ºC'),
	(260501, 122, '2014-03-15 00:47:45.000000', 'temperatura', 143.0000, 'ºC'),
	(260502, 122, '2014-03-15 00:47:46.000000', 'temperatura', 607.0000, 'ºC'),
	(260503, 122, '2014-03-15 00:47:47.000000', 'temperatura', 208.0000, 'ºC'),
	(260504, 122, '2014-03-15 00:47:48.000000', 'temperatura', 418.0000, 'ºC'),
	(260505, 122, '2014-03-15 00:47:49.000000', 'temperatura', 268.0000, 'ºC'),
	(260506, 122, '2014-03-15 00:47:50.000000', 'temperatura', 87.0000, 'ºC'),
	(260507, 122, '2014-03-15 00:47:51.000000', 'temperatura', 833.0000, 'ºC'),
	(260508, 122, '2014-03-15 00:47:52.000000', 'temperatura', 302.0000, 'ºC'),
	(260509, 122, '2014-03-15 00:47:53.000000', 'temperatura', 212.0000, 'ºC'),
	(260510, 122, '2014-03-15 00:47:54.000000', 'temperatura', 155.0000, 'ºC'),
	(260511, 122, '2014-03-15 00:47:55.000000', 'temperatura', 137.0000, 'ºC'),
	(260512, 122, '2014-03-15 00:47:56.000000', 'temperatura', 224.0000, 'ºC'),
	(260513, 122, '2014-03-15 00:47:57.000000', 'temperatura', 706.0000, 'ºC'),
	(260514, 122, '2014-03-15 00:47:58.000000', 'temperatura', 460.0000, 'ºC'),
	(260515, 122, '2014-03-15 00:47:59.000000', 'temperatura', 184.0000, 'ºC'),
	(260516, 122, '2014-03-15 00:48:00.000000', 'temperatura', 741.0000, 'ºC'),
	(260517, 122, '2014-03-15 00:48:01.000000', 'temperatura', 751.0000, 'ºC'),
	(260518, 122, '2014-03-15 00:48:02.000000', 'temperatura', 333.0000, 'ºC'),
	(260519, 122, '2014-03-15 00:48:03.000000', 'temperatura', 613.0000, 'ºC'),
	(260520, 122, '2014-03-15 00:48:04.000000', 'temperatura', 867.0000, 'ºC'),
	(260521, 122, '2014-03-15 00:48:05.000000', 'temperatura', 95.0000, 'ºC'),
	(260522, 122, '2014-03-15 00:48:06.000000', 'temperatura', 273.0000, 'ºC'),
	(260523, 122, '2014-03-15 00:48:07.000000', 'temperatura', 1083.0000, 'ºC'),
	(260524, 122, '2014-03-15 00:48:08.000000', 'temperatura', 996.0000, 'ºC'),
	(260525, 122, '2014-03-15 00:48:09.000000', 'temperatura', 531.0000, 'ºC'),
	(260526, 122, '2014-03-15 00:48:10.000000', 'temperatura', 867.0000, 'ºC'),
	(260527, 122, '2014-03-15 00:48:11.000000', 'temperatura', 342.0000, 'ºC'),
	(260528, 122, '2014-03-15 00:48:12.000000', 'temperatura', 310.0000, 'ºC'),
	(260529, 122, '2014-03-15 00:48:13.000000', 'temperatura', 524.0000, 'ºC'),
	(260530, 122, '2014-03-15 00:48:14.000000', 'temperatura', 491.0000, 'ºC'),
	(260531, 122, '2014-03-15 00:48:15.000000', 'temperatura', 884.0000, 'ºC'),
	(260532, 122, '2014-03-15 00:48:16.000000', 'temperatura', 546.0000, 'ºC'),
	(260533, 122, '2014-03-15 00:48:17.000000', 'temperatura', 78.0000, 'ºC'),
	(260534, 122, '2014-03-15 00:48:18.000000', 'temperatura', 1155.0000, 'ºC'),
	(260535, 122, '2014-03-15 00:48:19.000000', 'temperatura', 739.0000, 'ºC'),
	(260536, 122, '2014-03-15 00:48:20.000000', 'temperatura', 232.0000, 'ºC'),
	(260537, 122, '2014-03-15 00:48:21.000000', 'temperatura', 142.0000, 'ºC'),
	(260538, 122, '2014-03-15 00:48:22.000000', 'temperatura', 17.0000, 'ºC'),
	(260539, 122, '2014-03-15 00:48:23.000000', 'temperatura', 857.0000, 'ºC'),
	(260540, 122, '2014-03-15 00:48:24.000000', 'temperatura', 637.0000, 'ºC'),
	(260541, 122, '2014-03-15 00:48:25.000000', 'temperatura', 612.0000, 'ºC'),
	(260542, 122, '2014-03-15 00:48:26.000000', 'temperatura', 1150.0000, 'ºC'),
	(260543, 122, '2014-03-15 00:48:27.000000', 'temperatura', 316.0000, 'ºC'),
	(260544, 122, '2014-03-15 00:48:28.000000', 'temperatura', 531.0000, 'ºC'),
	(260545, 122, '2014-03-15 00:48:29.000000', 'temperatura', 506.0000, 'ºC'),
	(260546, 122, '2014-03-15 00:48:30.000000', 'temperatura', 940.0000, 'ºC'),
	(260547, 122, '2014-03-15 00:48:31.000000', 'temperatura', 781.0000, 'ºC'),
	(260548, 122, '2014-03-15 00:48:32.000000', 'temperatura', 1087.0000, 'ºC'),
	(260549, 122, '2014-03-15 00:48:33.000000', 'temperatura', 690.0000, 'ºC'),
	(260550, 122, '2014-03-15 00:48:34.000000', 'temperatura', 190.0000, 'ºC'),
	(260551, 122, '2014-03-15 00:48:35.000000', 'temperatura', 82.0000, 'ºC'),
	(260552, 122, '2014-03-15 00:48:36.000000', 'temperatura', 1038.0000, 'ºC'),
	(260553, 122, '2014-03-15 00:48:37.000000', 'temperatura', 147.0000, 'ºC'),
	(260554, 122, '2014-03-15 00:48:38.000000', 'temperatura', 21.0000, 'ºC'),
	(260555, 122, '2014-03-15 00:48:39.000000', 'temperatura', 866.0000, 'ºC'),
	(260556, 122, '2014-03-15 00:48:40.000000', 'temperatura', 665.0000, 'ºC'),
	(260557, 122, '2014-03-15 00:48:41.000000', 'temperatura', 728.0000, 'ºC'),
	(260558, 122, '2014-03-15 00:48:42.000000', 'temperatura', 445.0000, 'ºC'),
	(260559, 122, '2014-03-15 00:48:43.000000', 'temperatura', 44.0000, 'ºC'),
	(260560, 122, '2014-03-15 00:48:44.000000', 'temperatura', 82.0000, 'ºC'),
	(260561, 122, '2014-03-15 00:48:45.000000', 'temperatura', 280.0000, 'ºC'),
	(260562, 122, '2014-03-15 00:48:46.000000', 'temperatura', 1157.0000, 'ºC'),
	(260563, 122, '2014-03-15 00:48:47.000000', 'temperatura', 142.0000, 'ºC'),
	(260564, 122, '2014-03-15 00:48:48.000000', 'temperatura', 841.0000, 'ºC'),
	(260565, 122, '2014-03-15 00:48:49.000000', 'temperatura', 179.0000, 'ºC'),
	(260566, 122, '2014-03-15 00:48:50.000000', 'temperatura', 774.0000, 'ºC'),
	(260567, 122, '2014-03-15 00:48:51.000000', 'temperatura', 931.0000, 'ºC'),
	(260568, 122, '2014-03-15 00:48:52.000000', 'temperatura', 1133.0000, 'ºC'),
	(260569, 122, '2014-03-15 00:48:53.000000', 'temperatura', 473.0000, 'ºC'),
	(260570, 122, '2014-03-15 00:48:54.000000', 'temperatura', 169.0000, 'ºC'),
	(260571, 122, '2014-03-15 00:48:55.000000', 'temperatura', 624.0000, 'ºC'),
	(260572, 122, '2014-03-15 00:48:56.000000', 'temperatura', 216.0000, 'ºC'),
	(260573, 122, '2014-03-15 00:48:57.000000', 'temperatura', 407.0000, 'ºC'),
	(260574, 122, '2014-03-15 00:48:58.000000', 'temperatura', 187.0000, 'ºC'),
	(260575, 122, '2014-03-15 00:48:59.000000', 'temperatura', 915.0000, 'ºC'),
	(260576, 122, '2014-03-15 00:49:00.000000', 'temperatura', 413.0000, 'ºC'),
	(260577, 122, '2014-03-15 00:49:01.000000', 'temperatura', 520.0000, 'ºC'),
	(260578, 122, '2014-03-15 00:49:02.000000', 'temperatura', 163.0000, 'ºC'),
	(260579, 122, '2014-03-15 00:49:03.000000', 'temperatura', 454.0000, 'ºC'),
	(260580, 122, '2014-03-15 00:49:04.000000', 'temperatura', 583.0000, 'ºC'),
	(260581, 122, '2014-03-15 00:49:05.000000', 'temperatura', 355.0000, 'ºC'),
	(260582, 122, '2014-03-15 00:49:06.000000', 'temperatura', 26.0000, 'ºC'),
	(260583, 122, '2014-03-15 00:49:07.000000', 'temperatura', 264.0000, 'ºC'),
	(260584, 122, '2014-03-15 00:49:08.000000', 'temperatura', 43.0000, 'ºC'),
	(260585, 122, '2014-03-15 00:49:09.000000', 'temperatura', 622.0000, 'ºC'),
	(260586, 122, '2014-03-15 00:49:10.000000', 'temperatura', 581.0000, 'ºC'),
	(260587, 122, '2014-03-15 00:49:11.000000', 'temperatura', 1041.0000, 'ºC'),
	(260588, 122, '2014-03-15 00:49:12.000000', 'temperatura', 1061.0000, 'ºC'),
	(260589, 122, '2014-03-15 00:49:13.000000', 'temperatura', 985.0000, 'ºC'),
	(260590, 122, '2014-03-15 00:49:14.000000', 'temperatura', 543.0000, 'ºC'),
	(260591, 122, '2014-03-15 00:49:15.000000', 'temperatura', 958.0000, 'ºC'),
	(260592, 122, '2014-03-15 00:49:16.000000', 'temperatura', 760.0000, 'ºC'),
	(260593, 122, '2014-03-15 00:49:17.000000', 'temperatura', 930.0000, 'ºC'),
	(260594, 122, '2014-03-15 00:49:18.000000', 'temperatura', 1170.0000, 'ºC'),
	(260595, 122, '2014-03-15 00:49:19.000000', 'temperatura', 661.0000, 'ºC'),
	(260596, 122, '2014-03-15 00:49:20.000000', 'temperatura', 996.0000, 'ºC'),
	(260597, 122, '2014-03-15 00:49:21.000000', 'temperatura', 598.0000, 'ºC'),
	(260598, 122, '2014-03-15 00:49:22.000000', 'temperatura', 0.0000, 'ºC'),
	(260599, 122, '2014-03-15 00:49:23.000000', 'temperatura', 610.0000, 'ºC'),
	(260600, 122, '2014-03-15 00:49:24.000000', 'temperatura', 647.0000, 'ºC'),
	(260601, 122, '2014-03-15 00:49:25.000000', 'temperatura', 207.0000, 'ºC'),
	(260602, 122, '2014-03-15 00:49:26.000000', 'temperatura', 295.0000, 'ºC'),
	(260603, 122, '2014-03-15 00:49:27.000000', 'temperatura', 854.0000, 'ºC'),
	(260604, 122, '2014-03-15 00:49:28.000000', 'temperatura', 984.0000, 'ºC'),
	(260605, 122, '2014-03-15 00:49:29.000000', 'temperatura', 1158.0000, 'ºC'),
	(260606, 122, '2014-03-15 00:49:30.000000', 'temperatura', 441.0000, 'ºC'),
	(260607, 122, '2014-03-15 00:49:31.000000', 'temperatura', 1131.0000, 'ºC'),
	(260608, 122, '2014-03-15 00:49:32.000000', 'temperatura', 732.0000, 'ºC'),
	(260609, 122, '2014-03-15 00:49:33.000000', 'temperatura', 267.0000, 'ºC'),
	(260610, 122, '2014-03-15 00:49:34.000000', 'temperatura', 340.0000, 'ºC'),
	(260611, 122, '2014-03-15 00:49:35.000000', 'temperatura', 900.0000, 'ºC'),
	(260612, 122, '2014-03-15 00:49:36.000000', 'temperatura', 1080.0000, 'ºC'),
	(260613, 122, '2014-03-15 00:49:37.000000', 'temperatura', 303.0000, 'ºC'),
	(260614, 122, '2014-03-15 00:49:38.000000', 'temperatura', 672.0000, 'ºC'),
	(260615, 122, '2014-03-15 00:49:39.000000', 'temperatura', 53.0000, 'ºC'),
	(260616, 122, '2014-03-15 00:49:40.000000', 'temperatura', 651.0000, 'ºC'),
	(260617, 122, '2014-03-15 00:49:41.000000', 'temperatura', 695.0000, 'ºC'),
	(260618, 122, '2014-03-15 00:49:42.000000', 'temperatura', 324.0000, 'ºC'),
	(260619, 122, '2014-03-15 00:49:43.000000', 'temperatura', 736.0000, 'ºC'),
	(260620, 122, '2014-03-15 00:49:44.000000', 'temperatura', 308.0000, 'ºC'),
	(260621, 122, '2014-03-15 00:49:45.000000', 'temperatura', 531.0000, 'ºC'),
	(260622, 122, '2014-03-15 00:49:46.000000', 'temperatura', 532.0000, 'ºC'),
	(260623, 122, '2014-03-15 00:49:47.000000', 'temperatura', 1069.0000, 'ºC'),
	(260624, 122, '2014-03-15 00:49:48.000000', 'temperatura', 148.0000, 'ºC'),
	(260625, 122, '2014-03-15 00:49:49.000000', 'temperatura', 1134.0000, 'ºC'),
	(260626, 122, '2014-03-15 00:49:50.000000', 'temperatura', 429.0000, 'ºC'),
	(260627, 122, '2014-03-15 00:49:51.000000', 'temperatura', 1140.0000, 'ºC'),
	(260628, 122, '2014-03-15 00:49:52.000000', 'temperatura', 814.0000, 'ºC'),
	(260629, 122, '2014-03-15 00:49:53.000000', 'temperatura', 652.0000, 'ºC'),
	(260630, 122, '2014-03-15 00:49:54.000000', 'temperatura', 818.0000, 'ºC'),
	(260631, 122, '2014-03-15 00:49:55.000000', 'temperatura', 934.0000, 'ºC'),
	(260632, 122, '2014-03-15 00:49:56.000000', 'temperatura', 1016.0000, 'ºC'),
	(260633, 122, '2014-03-15 00:49:57.000000', 'temperatura', 1079.0000, 'ºC'),
	(260634, 122, '2014-03-15 00:49:58.000000', 'temperatura', 1149.0000, 'ºC'),
	(260635, 122, '2014-03-15 00:49:59.000000', 'temperatura', 106.0000, 'ºC'),
	(260636, 122, '2014-03-15 00:50:00.000000', 'temperatura', 684.0000, 'ºC'),
	(260637, 122, '2014-03-15 00:50:01.000000', 'temperatura', 704.0000, 'ºC'),
	(260638, 122, '2014-03-15 00:50:02.000000', 'temperatura', 268.0000, 'ºC'),
	(260639, 122, '2014-03-15 00:50:03.000000', 'temperatura', 429.0000, 'ºC'),
	(260640, 122, '2014-03-15 00:50:04.000000', 'temperatura', 139.0000, 'ºC'),
	(260641, 122, '2014-03-15 00:50:05.000000', 'temperatura', 612.0000, 'ºC'),
	(260642, 122, '2014-03-15 00:50:06.000000', 'temperatura', 241.0000, 'ºC'),
	(260643, 122, '2014-03-15 00:50:07.000000', 'temperatura', 571.0000, 'ºC'),
	(260644, 122, '2014-03-15 00:50:08.000000', 'temperatura', 932.0000, 'ºC'),
	(260645, 122, '2014-03-15 00:50:09.000000', 'temperatura', 547.0000, 'ºC'),
	(260646, 122, '2014-03-15 00:50:10.000000', 'temperatura', 1139.0000, 'ºC'),
	(260647, 122, '2014-03-15 00:50:11.000000', 'temperatura', 455.0000, 'ºC'),
	(260648, 122, '2014-03-15 00:50:12.000000', 'temperatura', 58.0000, 'ºC'),
	(260649, 122, '2014-03-15 00:50:13.000000', 'temperatura', 126.0000, 'ºC'),
	(260650, 122, '2014-03-15 00:50:14.000000', 'temperatura', 457.0000, 'ºC'),
	(260651, 122, '2014-03-15 00:50:15.000000', 'temperatura', 706.0000, 'ºC'),
	(260652, 122, '2014-03-15 00:50:16.000000', 'temperatura', 961.0000, 'ºC'),
	(260653, 122, '2014-03-15 00:50:17.000000', 'temperatura', 286.0000, 'ºC'),
	(260654, 122, '2014-03-15 00:50:18.000000', 'temperatura', 949.0000, 'ºC'),
	(260655, 122, '2014-03-15 00:50:19.000000', 'temperatura', 286.0000, 'ºC'),
	(260656, 122, '2014-03-15 00:50:20.000000', 'temperatura', 985.0000, 'ºC'),
	(260657, 122, '2014-03-15 00:50:21.000000', 'temperatura', 468.0000, 'ºC'),
	(260658, 122, '2014-03-15 00:50:22.000000', 'temperatura', 583.0000, 'ºC'),
	(260659, 122, '2014-03-15 00:50:23.000000', 'temperatura', 312.0000, 'ºC'),
	(260660, 122, '2014-03-15 00:50:24.000000', 'temperatura', 1012.0000, 'ºC'),
	(260661, 122, '2014-03-15 00:50:25.000000', 'temperatura', 525.0000, 'ºC'),
	(260662, 122, '2014-03-15 00:50:26.000000', 'temperatura', 788.0000, 'ºC'),
	(260663, 122, '2014-03-15 00:50:27.000000', 'temperatura', 1165.0000, 'ºC'),
	(260664, 122, '2014-03-15 00:50:28.000000', 'temperatura', 1061.0000, 'ºC'),
	(260665, 122, '2014-03-15 00:50:29.000000', 'temperatura', 611.0000, 'ºC'),
	(260666, 122, '2014-03-15 00:50:30.000000', 'temperatura', 1075.0000, 'ºC'),
	(260667, 122, '2014-03-15 00:50:31.000000', 'temperatura', 1140.0000, 'ºC'),
	(260668, 122, '2014-03-15 00:50:32.000000', 'temperatura', 78.0000, 'ºC'),
	(260669, 122, '2014-03-15 00:50:33.000000', 'temperatura', 570.0000, 'ºC'),
	(260670, 122, '2014-03-15 00:50:34.000000', 'temperatura', 215.0000, 'ºC'),
	(260671, 122, '2014-03-15 00:50:35.000000', 'temperatura', 568.0000, 'ºC'),
	(260672, 122, '2014-03-15 00:50:36.000000', 'temperatura', 993.0000, 'ºC'),
	(260673, 122, '2014-03-15 00:50:37.000000', 'temperatura', 864.0000, 'ºC'),
	(260674, 122, '2014-03-15 00:50:38.000000', 'temperatura', 139.0000, 'ºC'),
	(260675, 122, '2014-03-15 00:50:39.000000', 'temperatura', 505.0000, 'ºC'),
	(260676, 122, '2014-03-15 00:50:40.000000', 'temperatura', 907.0000, 'ºC'),
	(260677, 122, '2014-03-15 00:50:41.000000', 'temperatura', 621.0000, 'ºC'),
	(260678, 122, '2014-03-15 00:50:42.000000', 'temperatura', 384.0000, 'ºC'),
	(260679, 122, '2014-03-15 00:50:43.000000', 'temperatura', 59.0000, 'ºC'),
	(260680, 122, '2014-03-15 00:50:44.000000', 'temperatura', 344.0000, 'ºC'),
	(260681, 122, '2014-03-15 00:50:45.000000', 'temperatura', 344.0000, 'ºC'),
	(260682, 122, '2014-03-15 00:50:46.000000', 'temperatura', 687.0000, 'ºC'),
	(260683, 122, '2014-03-15 00:50:47.000000', 'temperatura', 6.0000, 'ºC'),
	(260684, 122, '2014-03-15 00:50:48.000000', 'temperatura', 367.0000, 'ºC'),
	(260685, 122, '2014-03-15 00:50:49.000000', 'temperatura', 618.0000, 'ºC'),
	(260686, 122, '2014-03-15 00:50:50.000000', 'temperatura', 788.0000, 'ºC'),
	(260687, 122, '2014-03-15 00:50:51.000000', 'temperatura', 889.0000, 'ºC'),
	(260688, 122, '2014-03-15 00:50:52.000000', 'temperatura', 880.0000, 'ºC'),
	(260689, 122, '2014-03-15 00:50:53.000000', 'temperatura', 533.0000, 'ºC'),
	(260690, 122, '2014-03-15 00:50:54.000000', 'temperatura', 27.0000, 'ºC'),
	(260691, 122, '2014-03-15 00:50:55.000000', 'temperatura', 935.0000, 'ºC'),
	(260692, 122, '2014-03-15 00:50:56.000000', 'temperatura', 997.0000, 'ºC'),
	(260693, 122, '2014-03-15 00:50:57.000000', 'temperatura', 980.0000, 'ºC'),
	(260694, 122, '2014-03-15 00:50:58.000000', 'temperatura', 708.0000, 'ºC'),
	(260695, 122, '2014-03-15 00:50:59.000000', 'temperatura', 600.0000, 'ºC'),
	(260696, 122, '2014-03-15 00:51:00.000000', 'temperatura', 877.0000, 'ºC'),
	(260697, 122, '2014-03-15 00:51:01.000000', 'temperatura', 187.0000, 'ºC'),
	(260698, 122, '2014-03-15 00:51:02.000000', 'temperatura', 703.0000, 'ºC'),
	(260699, 122, '2014-03-15 00:51:03.000000', 'temperatura', 555.0000, 'ºC'),
	(260700, 122, '2014-03-15 00:51:04.000000', 'temperatura', 664.0000, 'ºC'),
	(260701, 122, '2014-03-15 00:51:05.000000', 'temperatura', 459.0000, 'ºC'),
	(260702, 122, '2014-03-15 00:51:06.000000', 'temperatura', 302.0000, 'ºC'),
	(260703, 122, '2014-03-15 00:51:07.000000', 'temperatura', 132.0000, 'ºC'),
	(260704, 122, '2014-03-15 00:51:08.000000', 'temperatura', 958.0000, 'ºC'),
	(260705, 122, '2014-03-15 00:51:09.000000', 'temperatura', 792.0000, 'ºC'),
	(260706, 122, '2014-03-15 00:51:10.000000', 'temperatura', 1086.0000, 'ºC'),
	(260707, 122, '2014-03-15 00:51:11.000000', 'temperatura', 656.0000, 'ºC'),
	(260708, 122, '2014-03-15 00:51:12.000000', 'temperatura', 23.0000, 'ºC'),
	(260709, 122, '2014-03-15 00:51:13.000000', 'temperatura', 548.0000, 'ºC'),
	(260710, 122, '2014-03-15 00:51:14.000000', 'temperatura', 271.0000, 'ºC'),
	(260711, 122, '2014-03-15 00:51:15.000000', 'temperatura', 913.0000, 'ºC'),
	(260712, 122, '2014-03-15 00:51:16.000000', 'temperatura', 150.0000, 'ºC'),
	(260713, 122, '2014-03-15 00:51:17.000000', 'temperatura', 411.0000, 'ºC'),
	(260714, 122, '2014-03-15 00:51:18.000000', 'temperatura', 405.0000, 'ºC'),
	(260715, 122, '2014-03-15 00:51:19.000000', 'temperatura', 792.0000, 'ºC'),
	(260716, 122, '2014-03-15 00:51:20.000000', 'temperatura', 346.0000, 'ºC'),
	(260717, 122, '2014-03-15 00:51:21.000000', 'temperatura', 553.0000, 'ºC'),
	(260718, 122, '2014-03-15 00:51:22.000000', 'temperatura', 528.0000, 'ºC'),
	(260719, 122, '2014-03-15 00:51:23.000000', 'temperatura', 984.0000, 'ºC'),
	(260720, 122, '2014-03-15 00:51:24.000000', 'temperatura', 933.0000, 'ºC'),
	(260721, 122, '2014-03-15 00:51:25.000000', 'temperatura', 516.0000, 'ºC'),
	(260722, 122, '2014-03-15 00:51:26.000000', 'temperatura', 981.0000, 'ºC'),
	(260723, 122, '2014-03-15 00:51:27.000000', 'temperatura', 959.0000, 'ºC'),
	(260724, 122, '2014-03-15 00:51:28.000000', 'temperatura', 651.0000, 'ºC'),
	(260725, 122, '2014-03-15 00:51:29.000000', 'temperatura', 377.0000, 'ºC'),
	(260726, 122, '2014-03-15 00:51:30.000000', 'temperatura', 1135.0000, 'ºC'),
	(260727, 122, '2014-03-15 00:51:31.000000', 'temperatura', 944.0000, 'ºC'),
	(260728, 122, '2014-03-15 00:51:32.000000', 'temperatura', 115.0000, 'ºC'),
	(260729, 122, '2014-03-15 00:51:33.000000', 'temperatura', 144.0000, 'ºC'),
	(260730, 122, '2014-03-15 00:51:34.000000', 'temperatura', 376.0000, 'ºC'),
	(260731, 122, '2014-03-15 00:51:35.000000', 'temperatura', 248.0000, 'ºC'),
	(260732, 122, '2014-03-15 00:51:36.000000', 'temperatura', 114.0000, 'ºC'),
	(260733, 122, '2014-03-15 00:51:37.000000', 'temperatura', 1026.0000, 'ºC'),
	(260734, 122, '2014-03-15 00:51:38.000000', 'temperatura', 1186.0000, 'ºC'),
	(260735, 122, '2014-03-15 00:51:39.000000', 'temperatura', 456.0000, 'ºC'),
	(260736, 122, '2014-03-15 00:51:40.000000', 'temperatura', 1121.0000, 'ºC'),
	(260737, 122, '2014-03-15 00:51:41.000000', 'temperatura', 637.0000, 'ºC'),
	(260738, 122, '2014-03-15 00:51:42.000000', 'temperatura', 1025.0000, 'ºC'),
	(260739, 122, '2014-03-15 00:51:43.000000', 'temperatura', 812.0000, 'ºC'),
	(260740, 122, '2014-03-15 00:51:44.000000', 'temperatura', 986.0000, 'ºC'),
	(260741, 122, '2014-03-15 00:51:45.000000', 'temperatura', 95.0000, 'ºC'),
	(260742, 122, '2014-03-15 00:51:46.000000', 'temperatura', 1118.0000, 'ºC'),
	(260743, 122, '2014-03-15 00:51:47.000000', 'temperatura', 507.0000, 'ºC'),
	(260744, 122, '2014-03-15 00:51:48.000000', 'temperatura', 380.0000, 'ºC'),
	(260745, 122, '2014-03-15 00:51:49.000000', 'temperatura', 381.0000, 'ºC'),
	(260746, 122, '2014-03-15 00:51:50.000000', 'temperatura', 764.0000, 'ºC'),
	(260747, 122, '2014-03-15 00:51:51.000000', 'temperatura', 276.0000, 'ºC'),
	(260748, 122, '2014-03-15 00:51:52.000000', 'temperatura', 292.0000, 'ºC'),
	(260749, 122, '2014-03-15 00:51:53.000000', 'temperatura', 630.0000, 'ºC'),
	(260750, 122, '2014-03-15 00:51:54.000000', 'temperatura', 1075.0000, 'ºC'),
	(260751, 122, '2014-03-15 00:51:55.000000', 'temperatura', 1087.0000, 'ºC'),
	(260752, 122, '2014-03-15 00:51:56.000000', 'temperatura', 1010.0000, 'ºC'),
	(260753, 122, '2014-03-15 00:51:57.000000', 'temperatura', 588.0000, 'ºC'),
	(260754, 122, '2014-03-15 00:51:58.000000', 'temperatura', 1110.0000, 'ºC'),
	(260755, 122, '2014-03-15 00:51:59.000000', 'temperatura', 187.0000, 'ºC'),
	(260756, 122, '2014-03-15 00:52:00.000000', 'temperatura', 7.0000, 'ºC'),
	(260757, 122, '2014-03-15 00:52:01.000000', 'temperatura', 675.0000, 'ºC'),
	(260758, 122, '2014-03-15 00:52:02.000000', 'temperatura', 953.0000, 'ºC'),
	(260759, 122, '2014-03-15 00:52:03.000000', 'temperatura', 340.0000, 'ºC'),
	(260760, 122, '2014-03-15 00:52:04.000000', 'temperatura', 42.0000, 'ºC'),
	(260761, 122, '2014-03-15 00:52:05.000000', 'temperatura', 390.0000, 'ºC'),
	(260762, 122, '2014-03-15 00:52:06.000000', 'temperatura', 624.0000, 'ºC'),
	(260763, 122, '2014-03-15 00:52:07.000000', 'temperatura', 749.0000, 'ºC'),
	(260764, 122, '2014-03-15 00:52:08.000000', 'temperatura', 676.0000, 'ºC'),
	(260765, 122, '2014-03-15 00:52:09.000000', 'temperatura', 1131.0000, 'ºC'),
	(260766, 122, '2014-03-15 00:52:10.000000', 'temperatura', 30.0000, 'ºC'),
	(260767, 122, '2014-03-15 00:52:11.000000', 'temperatura', 355.0000, 'ºC'),
	(260768, 122, '2014-03-15 00:52:12.000000', 'temperatura', 488.0000, 'ºC'),
	(260769, 122, '2014-03-15 00:52:13.000000', 'temperatura', 175.0000, 'ºC'),
	(260770, 122, '2014-03-15 00:52:14.000000', 'temperatura', 612.0000, 'ºC'),
	(260771, 122, '2014-03-15 00:52:15.000000', 'temperatura', 136.0000, 'ºC'),
	(260772, 122, '2014-03-15 00:52:16.000000', 'temperatura', 44.0000, 'ºC'),
	(260773, 122, '2014-03-15 00:52:17.000000', 'temperatura', 1014.0000, 'ºC'),
	(260774, 122, '2014-03-15 00:52:18.000000', 'temperatura', 137.0000, 'ºC'),
	(260775, 122, '2014-03-15 00:52:19.000000', 'temperatura', 43.0000, 'ºC'),
	(260776, 122, '2014-03-15 00:52:20.000000', 'temperatura', 1005.0000, 'ºC'),
	(260777, 122, '2014-03-15 00:52:21.000000', 'temperatura', 94.0000, 'ºC'),
	(260778, 122, '2014-03-15 00:52:22.000000', 'temperatura', 1059.0000, 'ºC'),
	(260779, 122, '2014-03-15 00:52:23.000000', 'temperatura', 213.0000, 'ºC'),
	(260780, 122, '2014-03-15 00:52:24.000000', 'temperatura', 288.0000, 'ºC'),
	(260781, 122, '2014-03-15 00:52:25.000000', 'temperatura', 800.0000, 'ºC'),
	(260782, 122, '2014-03-15 00:52:26.000000', 'temperatura', 739.0000, 'ºC'),
	(260783, 122, '2014-03-15 00:52:27.000000', 'temperatura', 94.0000, 'ºC'),
	(260784, 122, '2014-03-15 00:52:28.000000', 'temperatura', 653.0000, 'ºC'),
	(260785, 122, '2014-03-15 00:52:29.000000', 'temperatura', 584.0000, 'ºC'),
	(260786, 122, '2014-03-15 00:52:30.000000', 'temperatura', 962.0000, 'ºC'),
	(260787, 122, '2014-03-15 00:52:31.000000', 'temperatura', 660.0000, 'ºC'),
	(260788, 122, '2014-03-15 00:52:32.000000', 'temperatura', 412.0000, 'ºC'),
	(260789, 122, '2014-03-15 00:52:33.000000', 'temperatura', 82.0000, 'ºC'),
	(260790, 122, '2014-03-15 00:52:34.000000', 'temperatura', 374.0000, 'ºC'),
	(260791, 122, '2014-03-15 00:52:35.000000', 'temperatura', 427.0000, 'ºC'),
	(260792, 122, '2014-03-15 00:52:36.000000', 'temperatura', 1010.0000, 'ºC'),
	(260793, 122, '2014-03-15 00:52:37.000000', 'temperatura', 170.0000, 'ºC'),
	(260794, 122, '2014-03-15 00:52:38.000000', 'temperatura', 220.0000, 'ºC'),
	(260795, 122, '2014-03-15 00:52:39.000000', 'temperatura', 589.0000, 'ºC'),
	(260796, 122, '2014-03-15 00:52:40.000000', 'temperatura', 1088.0000, 'ºC'),
	(260797, 122, '2014-03-15 00:52:41.000000', 'temperatura', 72.0000, 'ºC'),
	(260798, 122, '2014-03-15 00:52:42.000000', 'temperatura', 698.0000, 'ºC'),
	(260799, 122, '2014-03-15 00:52:43.000000', 'temperatura', 872.0000, 'ºC'),
	(260800, 122, '2014-03-15 00:52:44.000000', 'temperatura', 1069.0000, 'ºC'),
	(260801, 122, '2014-03-15 00:52:45.000000', 'temperatura', 328.0000, 'ºC'),
	(260802, 122, '2014-03-15 00:52:46.000000', 'temperatura', 834.0000, 'ºC'),
	(260803, 122, '2014-03-15 00:52:47.000000', 'temperatura', 787.0000, 'ºC'),
	(260804, 122, '2014-03-15 00:52:48.000000', 'temperatura', 234.0000, 'ºC'),
	(260805, 122, '2014-03-15 00:52:49.000000', 'temperatura', 9.0000, 'ºC'),
	(260806, 122, '2014-03-15 00:52:50.000000', 'temperatura', 543.0000, 'ºC'),
	(260807, 122, '2014-03-15 00:52:51.000000', 'temperatura', 288.0000, 'ºC'),
	(260808, 122, '2014-03-15 00:52:52.000000', 'temperatura', 1010.0000, 'ºC'),
	(260809, 122, '2014-03-15 00:52:53.000000', 'temperatura', 588.0000, 'ºC'),
	(260810, 122, '2014-03-15 00:52:54.000000', 'temperatura', 1110.0000, 'ºC'),
	(260811, 122, '2014-03-15 00:52:55.000000', 'temperatura', 186.0000, 'ºC'),
	(260812, 122, '2014-03-15 00:52:56.000000', 'temperatura', 2.0000, 'ºC'),
	(260813, 122, '2014-03-15 00:52:57.000000', 'temperatura', 651.0000, 'ºC'),
	(260814, 122, '2014-03-15 00:52:58.000000', 'temperatura', 852.0000, 'ºC'),
	(260815, 122, '2014-03-15 00:52:59.000000', 'temperatura', 1106.0000, 'ºC'),
	(260816, 122, '2014-03-15 00:53:00.000000', 'temperatura', 575.0000, 'ºC'),
	(260817, 122, '2014-03-15 00:53:01.000000', 'temperatura', 756.0000, 'ºC'),
	(260818, 122, '2014-03-15 00:53:02.000000', 'temperatura', 855.0000, 'ºC'),
	(260819, 122, '2014-03-15 00:53:03.000000', 'temperatura', 808.0000, 'ºC'),
	(260820, 122, '2014-03-15 00:53:04.000000', 'temperatura', 276.0000, 'ºC'),
	(260821, 122, '2014-03-15 00:53:05.000000', 'temperatura', 155.0000, 'ºC'),
	(260822, 122, '2014-03-15 00:53:06.000000', 'temperatura', 1149.0000, 'ºC'),
	(260823, 122, '2014-03-15 00:53:07.000000', 'temperatura', 481.0000, 'ºC'),
	(260824, 122, '2014-03-15 00:53:08.000000', 'temperatura', 159.0000, 'ºC'),
	(260825, 122, '2014-03-15 00:53:09.000000', 'temperatura', 551.0000, 'ºC'),
	(260826, 122, '2014-03-15 00:53:10.000000', 'temperatura', 1077.0000, 'ºC'),
	(260827, 122, '2014-03-15 00:53:11.000000', 'temperatura', 135.0000, 'ºC'),
	(260828, 122, '2014-03-15 00:53:12.000000', 'temperatura', 1045.0000, 'ºC'),
	(260829, 122, '2014-03-15 00:53:13.000000', 'temperatura', 21.0000, 'ºC'),
	(260830, 122, '2014-03-15 00:53:14.000000', 'temperatura', 569.0000, 'ºC'),
	(260831, 122, '2014-03-15 00:53:15.000000', 'temperatura', 381.0000, 'ºC'),
	(260832, 122, '2014-03-15 00:53:16.000000', 'temperatura', 199.0000, 'ºC'),
	(260833, 122, '2014-03-15 00:53:17.000000', 'temperatura', 1053.0000, 'ºC'),
	(260834, 122, '2014-03-15 00:53:18.000000', 'temperatura', 1069.0000, 'ºC'),
	(260835, 122, '2014-03-15 00:53:19.000000', 'temperatura', 986.0000, 'ºC'),
	(260836, 122, '2014-03-15 00:53:20.000000', 'temperatura', 525.0000, 'ºC'),
	(260837, 122, '2014-03-15 00:53:21.000000', 'temperatura', 865.0000, 'ºC'),
	(260838, 122, '2014-03-15 00:53:22.000000', 'temperatura', 351.0000, 'ºC'),
	(260839, 122, '2014-03-15 00:53:23.000000', 'temperatura', 360.0000, 'ºC'),
	(260840, 122, '2014-03-15 00:53:24.000000', 'temperatura', 749.0000, 'ºC'),
	(260841, 122, '2014-03-15 00:53:25.000000', 'temperatura', 264.0000, 'ºC'),
	(260842, 122, '2014-03-15 00:53:26.000000', 'temperatura', 272.0000, 'ºC'),
	(260843, 122, '2014-03-15 00:53:27.000000', 'temperatura', 571.0000, 'ºC'),
	(260844, 122, '2014-03-15 00:53:28.000000', 'temperatura', 839.0000, 'ºC'),
	(260845, 122, '2014-03-15 00:53:29.000000', 'temperatura', 84.0000, 'ºC'),
	(260846, 122, '2014-03-15 00:53:30.000000', 'temperatura', 304.0000, 'ºC'),
	(260847, 122, '2014-03-15 00:53:31.000000', 'temperatura', 68.0000, 'ºC'),
	(260848, 122, '2014-03-15 00:53:32.000000', 'temperatura', 627.0000, 'ºC'),
	(260849, 122, '2014-03-15 00:53:33.000000', 'temperatura', 533.0000, 'ºC'),
	(260850, 122, '2014-03-15 00:53:34.000000', 'temperatura', 786.0000, 'ºC'),
	(260851, 122, '2014-03-15 00:53:35.000000', 'temperatura', 1129.0000, 'ºC'),
	(260852, 122, '2014-03-15 00:53:36.000000', 'temperatura', 890.0000, 'ºC'),
	(260853, 122, '2014-03-15 00:53:37.000000', 'temperatura', 1060.0000, 'ºC'),
	(260854, 122, '2014-03-15 00:53:38.000000', 'temperatura', 234.0000, 'ºC'),
	(260855, 122, '2014-03-15 00:53:39.000000', 'temperatura', 387.0000, 'ºC'),
	(260856, 122, '2014-03-15 00:53:40.000000', 'temperatura', 37.0000, 'ºC'),
	(260857, 122, '2014-03-15 00:53:41.000000', 'temperatura', 222.0000, 'ºC'),
	(260858, 122, '2014-03-15 00:53:42.000000', 'temperatura', 1001.0000, 'ºC'),
	(260859, 122, '2014-03-15 00:53:43.000000', 'temperatura', 739.0000, 'ºC'),
	(260860, 122, '2014-03-15 00:53:44.000000', 'temperatura', 692.0000, 'ºC'),
	(260861, 122, '2014-03-15 00:53:45.000000', 'temperatura', 43.0000, 'ºC'),
	(260862, 122, '2014-03-15 00:53:46.000000', 'temperatura', 538.0000, 'ºC'),
	(260863, 122, '2014-03-15 00:53:47.000000', 'temperatura', 164.0000, 'ºC'),
	(260864, 122, '2014-03-15 00:53:48.000000', 'temperatura', 408.0000, 'ºC'),
	(260865, 122, '2014-03-15 00:53:49.000000', 'temperatura', 345.0000, 'ºC'),
	(260866, 122, '2014-03-15 00:53:50.000000', 'temperatura', 502.0000, 'ºC'),
	(260867, 122, '2014-03-15 00:53:51.000000', 'temperatura', 277.0000, 'ºC'),
	(260868, 122, '2014-03-15 00:53:52.000000', 'temperatura', 1081.0000, 'ºC'),
	(260869, 122, '2014-03-15 00:53:53.000000', 'temperatura', 972.0000, 'ºC'),
	(260870, 122, '2014-03-15 00:53:54.000000', 'temperatura', 420.0000, 'ºC'),
	(260871, 122, '2014-03-15 00:53:55.000000', 'temperatura', 385.0000, 'ºC'),
	(260872, 122, '2014-03-15 00:53:56.000000', 'temperatura', 663.0000, 'ºC'),
	(260873, 122, '2014-03-15 00:53:57.000000', 'temperatura', 963.0000, 'ºC'),
	(260874, 122, '2014-03-15 00:53:58.000000', 'temperatura', 424.0000, 'ºC'),
	(260875, 122, '2014-03-15 00:53:59.000000', 'temperatura', 430.0000, 'ºC'),
	(260876, 122, '2014-03-15 00:54:00.000000', 'temperatura', 882.0000, 'ºC'),
	(260877, 122, '2014-03-15 00:54:01.000000', 'temperatura', 719.0000, 'ºC'),
	(260878, 122, '2014-03-15 00:54:02.000000', 'temperatura', 948.0000, 'ºC'),
	(260879, 122, '2014-03-15 00:54:03.000000', 'temperatura', 185.0000, 'ºC'),
	(260880, 122, '2014-03-15 00:54:04.000000', 'temperatura', 481.0000, 'ºC'),
	(260881, 122, '2014-03-15 00:54:05.000000', 'temperatura', 649.0000, 'ºC'),
	(260882, 122, '2014-03-15 00:54:06.000000', 'temperatura', 605.0000, 'ºC'),
	(260883, 122, '2014-03-15 00:54:07.000000', 'temperatura', 1078.0000, 'ºC'),
	(260884, 122, '2014-03-15 00:54:08.000000', 'temperatura', 1177.0000, 'ºC'),
	(260885, 122, '2014-03-15 00:54:09.000000', 'temperatura', 248.0000, 'ºC'),
	(260886, 122, '2014-03-15 00:54:10.000000', 'temperatura', 113.0000, 'ºC'),
	(260887, 122, '2014-03-15 00:54:11.000000', 'temperatura', 1021.0000, 'ºC'),
	(260888, 122, '2014-03-15 00:54:12.000000', 'temperatura', 1165.0000, 'ºC'),
	(260889, 122, '2014-03-15 00:54:13.000000', 'temperatura', 364.0000, 'ºC'),
	(260890, 122, '2014-03-15 00:54:14.000000', 'temperatura', 724.0000, 'ºC'),
	(260891, 122, '2014-03-15 00:54:15.000000', 'temperatura', 128.0000, 'ºC'),
	(260892, 122, '2014-03-15 00:54:16.000000', 'temperatura', 871.0000, 'ºC'),
	(260893, 122, '2014-03-15 00:54:17.000000', 'temperatura', 369.0000, 'ºC'),
	(260894, 122, '2014-03-15 00:54:18.000000', 'temperatura', 432.0000, 'ºC'),
	(260895, 122, '2014-03-15 00:54:19.000000', 'temperatura', 1055.0000, 'ºC'),
	(260896, 122, '2014-03-15 00:54:20.000000', 'temperatura', 378.0000, 'ºC'),
	(260897, 122, '2014-03-15 00:54:21.000000', 'temperatura', 1127.0000, 'ºC'),
	(260898, 122, '2014-03-15 00:54:22.000000', 'temperatura', 899.0000, 'ºC'),
	(260899, 122, '2014-03-15 00:54:23.000000', 'temperatura', 1118.0000, 'ºC'),
	(260900, 122, '2014-03-15 00:54:24.000000', 'temperatura', 491.0000, 'ºC'),
	(260901, 122, '2014-03-15 00:54:25.000000', 'temperatura', 302.0000, 'ºC'),
	(260902, 122, '2014-03-15 00:54:26.000000', 'temperatura', 38.0000, 'ºC'),
	(260903, 122, '2014-03-15 00:54:27.000000', 'temperatura', 483.0000, 'ºC'),
	(260904, 122, '2014-03-15 00:54:28.000000', 'temperatura', 1101.0000, 'ºC'),
	(260905, 122, '2014-03-15 00:54:29.000000', 'temperatura', 459.0000, 'ºC'),
	(260906, 122, '2014-03-15 00:54:30.000000', 'temperatura', 190.0000, 'ºC'),
	(260907, 122, '2014-03-15 00:54:31.000000', 'temperatura', 773.0000, 'ºC'),
	(260908, 122, '2014-03-15 00:54:32.000000', 'temperatura', 895.0000, 'ºC'),
	(260909, 122, '2014-03-15 00:54:33.000000', 'temperatura', 959.0000, 'ºC'),
	(260910, 122, '2014-03-15 00:54:34.000000', 'temperatura', 910.0000, 'ºC'),
	(260911, 122, '2014-03-15 00:54:35.000000', 'temperatura', 475.0000, 'ºC'),
	(260912, 122, '2014-03-15 00:54:36.000000', 'temperatura', 845.0000, 'ºC'),
	(260913, 122, '2014-03-15 00:54:37.000000', 'temperatura', 398.0000, 'ºC'),
	(260914, 122, '2014-03-15 00:54:38.000000', 'temperatura', 658.0000, 'ºC'),
	(260915, 122, '2014-03-15 00:54:39.000000', 'temperatura', 896.0000, 'ºC'),
	(260916, 122, '2014-03-15 00:54:40.000000', 'temperatura', 108.0000, 'ºC'),
	(260917, 122, '2014-03-15 00:54:41.000000', 'temperatura', 251.0000, 'ºC'),
	(260918, 122, '2014-03-15 00:54:42.000000', 'temperatura', 931.0000, 'ºC'),
	(260919, 122, '2014-03-15 00:54:43.000000', 'temperatura', 303.0000, 'ºC'),
	(260920, 122, '2014-03-15 00:54:44.000000', 'temperatura', 1121.0000, 'ºC'),
	(260921, 122, '2014-03-15 00:54:45.000000', 'temperatura', 1098.0000, 'ºC'),
	(260922, 122, '2014-03-15 00:54:46.000000', 'temperatura', 929.0000, 'ºC'),
	(260923, 122, '2014-03-15 00:54:47.000000', 'temperatura', 150.0000, 'ºC'),
	(260924, 122, '2014-03-15 00:54:48.000000', 'temperatura', 365.0000, 'ºC'),
	(260925, 122, '2014-03-15 00:54:49.000000', 'temperatura', 175.0000, 'ºC'),
	(260926, 122, '2014-03-15 00:54:50.000000', 'temperatura', 982.0000, 'ºC'),
	(260927, 122, '2014-03-15 00:54:51.000000', 'temperatura', 783.0000, 'ºC'),
	(260928, 122, '2014-03-15 00:54:52.000000', 'temperatura', 971.0000, 'ºC'),
	(260929, 122, '2014-03-15 00:54:53.000000', 'temperatura', 107.0000, 'ºC'),
	(260930, 122, '2014-03-15 00:54:54.000000', 'temperatura', 23.0000, 'ºC'),
	(260931, 122, '2014-03-15 00:54:55.000000', 'temperatura', 992.0000, 'ºC'),
	(260932, 122, '2014-03-15 00:54:56.000000', 'temperatura', 92.0000, 'ºC'),
	(260933, 122, '2014-03-15 00:54:57.000000', 'temperatura', 1084.0000, 'ºC'),
	(260934, 122, '2014-03-15 00:54:58.000000', 'temperatura', 345.0000, 'ºC'),
	(260935, 122, '2014-03-15 00:54:59.000000', 'temperatura', 875.0000, 'ºC'),
	(260936, 122, '2014-03-15 00:55:00.000000', 'temperatura', 942.0000, 'ºC'),
	(260937, 122, '2014-03-15 00:55:01.000000', 'temperatura', 882.0000, 'ºC'),
	(260938, 122, '2014-03-15 00:55:02.000000', 'temperatura', 385.0000, 'ºC'),
	(260939, 122, '2014-03-15 00:55:03.000000', 'temperatura', 480.0000, 'ºC'),
	(260940, 122, '2014-03-15 00:55:04.000000', 'temperatura', 47.0000, 'ºC'),
	(260941, 122, '2014-03-15 00:55:05.000000', 'temperatura', 1195.0000, 'ºC'),
	(260942, 122, '2014-03-15 00:55:06.000000', 'temperatura', 1035.0000, 'ºC'),
	(260943, 122, '2014-03-15 00:55:07.000000', 'temperatura', 389.0000, 'ºC'),
	(260944, 122, '2014-03-15 00:55:08.000000', 'temperatura', 40.0000, 'ºC'),
	(260945, 122, '2014-03-15 00:55:09.000000', 'temperatura', 236.0000, 'ºC'),
	(260946, 122, '2014-03-15 00:55:10.000000', 'temperatura', 1060.0000, 'ºC'),
	(260947, 122, '2014-03-15 00:55:11.000000', 'temperatura', 994.0000, 'ºC'),
	(260948, 122, '2014-03-15 00:55:12.000000', 'temperatura', 588.0000, 'ºC'),
	(260949, 122, '2014-03-15 00:55:13.000000', 'temperatura', 1159.0000, 'ºC'),
	(260950, 122, '2014-03-15 00:55:14.000000', 'temperatura', 431.0000, 'ºC'),
	(260951, 122, '2014-03-15 00:55:15.000000', 'temperatura', 1079.0000, 'ºC'),
	(260952, 122, '2014-03-15 00:55:16.000000', 'temperatura', 500.0000, 'ºC'),
	(260953, 122, '2014-03-15 00:55:17.000000', 'temperatura', 467.0000, 'ºC'),
	(260954, 122, '2014-03-15 00:55:18.000000', 'temperatura', 833.0000, 'ºC'),
	(260955, 122, '2014-03-15 00:55:19.000000', 'temperatura', 365.0000, 'ºC'),
	(260956, 122, '2014-03-15 00:55:20.000000', 'temperatura', 527.0000, 'ºC'),
	(260957, 122, '2014-03-15 00:55:21.000000', 'temperatura', 341.0000, 'ºC'),
	(260958, 122, '2014-03-15 00:55:22.000000', 'temperatura', 122.0000, 'ºC'),
	(260959, 122, '2014-03-15 00:55:23.000000', 'temperatura', 790.0000, 'ºC'),
	(260960, 122, '2014-03-15 00:55:24.000000', 'temperatura', 1186.0000, 'ºC'),
	(260961, 122, '2014-03-15 00:55:25.000000', 'temperatura', 1158.0000, 'ºC'),
	(260962, 122, '2014-03-15 00:55:26.000000', 'temperatura', 1033.0000, 'ºC'),
	(260963, 122, '2014-03-15 00:55:27.000000', 'temperatura', 493.0000, 'ºC'),
	(260964, 122, '2014-03-15 00:55:28.000000', 'temperatura', 567.0000, 'ºC'),
	(260965, 122, '2014-03-15 00:55:29.000000', 'temperatura', 157.0000, 'ºC'),
	(260966, 122, '2014-03-15 00:55:30.000000', 'temperatura', 283.0000, 'ºC'),
	(260967, 122, '2014-03-15 00:55:31.000000', 'temperatura', 947.0000, 'ºC'),
	(260968, 122, '2014-03-15 00:55:32.000000', 'temperatura', 283.0000, 'ºC'),
	(260969, 122, '2014-03-15 00:55:33.000000', 'temperatura', 975.0000, 'ºC'),
	(260970, 122, '2014-03-15 00:55:34.000000', 'temperatura', 428.0000, 'ºC'),
	(260971, 122, '2014-03-15 00:55:35.000000', 'temperatura', 415.0000, 'ºC'),
	(260972, 122, '2014-03-15 00:55:36.000000', 'temperatura', 792.0000, 'ºC'),
	(260973, 122, '2014-03-15 00:55:37.000000', 'temperatura', 314.0000, 'ºC'),
	(260974, 122, '2014-03-15 00:55:38.000000', 'temperatura', 395.0000, 'ºC'),
	(260975, 122, '2014-03-15 00:55:39.000000', 'temperatura', 1036.0000, 'ºC'),
	(260976, 122, '2014-03-15 00:55:40.000000', 'temperatura', 393.0000, 'ºC'),
	(260977, 122, '2014-03-15 00:55:41.000000', 'temperatura', 56.0000, 'ºC'),
	(260978, 122, '2014-03-15 00:55:42.000000', 'temperatura', 304.0000, 'ºC'),
	(260979, 122, '2014-03-15 00:55:43.000000', 'temperatura', 153.0000, 'ºC'),
	(260980, 122, '2014-03-15 00:55:44.000000', 'temperatura', 1054.0000, 'ºC'),
	(260981, 122, '2014-03-15 00:55:45.000000', 'temperatura', 12.0000, 'ºC'),
	(260982, 122, '2014-03-15 00:55:46.000000', 'temperatura', 499.0000, 'ºC'),
	(260983, 122, '2014-03-15 00:55:47.000000', 'temperatura', 60.0000, 'ºC'),
	(260984, 122, '2014-03-15 00:55:48.000000', 'temperatura', 3.0000, 'ºC'),
	(260985, 122, '2014-03-15 00:55:49.000000', 'temperatura', 1037.0000, 'ºC'),
	(260986, 122, '2014-03-15 00:55:50.000000', 'temperatura', 376.0000, 'ºC'),
	(260987, 122, '2014-03-15 00:55:51.000000', 'temperatura', 1169.0000, 'ºC'),
	(260988, 122, '2014-03-15 00:55:52.000000', 'temperatura', 1118.0000, 'ºC'),
	(260989, 122, '2014-03-15 00:55:53.000000', 'temperatura', 881.0000, 'ºC'),
	(260990, 122, '2014-03-15 00:55:54.000000', 'temperatura', 1054.0000, 'ºC'),
	(260991, 122, '2014-03-15 00:55:55.000000', 'temperatura', 225.0000, 'ºC'),
	(260992, 122, '2014-03-15 00:55:56.000000', 'temperatura', 366.0000, 'ºC'),
	(260993, 122, '2014-03-15 00:55:57.000000', 'temperatura', 1153.0000, 'ºC'),
	(260994, 122, '2014-03-15 00:55:58.000000', 'temperatura', 1068.0000, 'ºC'),
	(260995, 122, '2014-03-15 00:55:59.000000', 'temperatura', 680.0000, 'ºC'),
	(260996, 122, '2014-03-15 00:56:00.000000', 'temperatura', 199.0000, 'ºC'),
	(260997, 122, '2014-03-15 00:56:01.000000', 'temperatura', 155.0000, 'ºC'),
	(260998, 122, '2014-03-15 00:56:02.000000', 'temperatura', 180.0000, 'ºC'),
	(260999, 122, '2014-03-15 00:56:03.000000', 'temperatura', 435.0000, 'ºC'),
	(261000, 122, '2014-03-15 00:56:04.000000', 'temperatura', 434.0000, 'ºC'),
	(261001, 122, '2014-03-15 00:56:05.000000', 'temperatura', 865.0000, 'ºC'),
	(261002, 122, '2014-03-15 00:56:06.000000', 'temperatura', 626.0000, 'ºC'),
	(261003, 122, '2014-03-15 00:56:07.000000', 'temperatura', 534.0000, 'ºC'),
	(261004, 122, '2014-03-15 00:56:08.000000', 'temperatura', 791.0000, 'ºC'),
	(261005, 122, '2014-03-15 00:56:09.000000', 'temperatura', 1155.0000, 'ºC'),
	(261006, 122, '2014-03-15 00:56:10.000000', 'temperatura', 1003.0000, 'ºC'),
	(261007, 122, '2014-03-15 00:56:11.000000', 'temperatura', 350.0000, 'ºC'),
	(261008, 122, '2014-03-15 00:56:12.000000', 'temperatura', 1143.0000, 'ºC'),
	(261009, 122, '2014-03-15 00:56:13.000000', 'temperatura', 1063.0000, 'ºC'),
	(261010, 122, '2014-03-15 00:56:14.000000', 'temperatura', 687.0000, 'ºC'),
	(261011, 122, '2014-03-15 00:56:15.000000', 'temperatura', 249.0000, 'ºC'),
	(261012, 122, '2014-03-15 00:56:16.000000', 'temperatura', 383.0000, 'ºC'),
	(261013, 122, '2014-03-15 00:56:17.000000', 'temperatura', 1169.0000, 'ºC'),
	(261014, 122, '2014-03-15 00:56:18.000000', 'temperatura', 1095.0000, 'ºC'),
	(261015, 122, '2014-03-15 00:56:19.000000', 'temperatura', 770.0000, 'ºC'),
	(261016, 122, '2014-03-15 00:56:20.000000', 'temperatura', 565.0000, 'ºC'),
	(261017, 122, '2014-03-15 00:56:21.000000', 'temperatura', 514.0000, 'ºC'),
	(261018, 122, '2014-03-15 00:56:22.000000', 'temperatura', 877.0000, 'ºC'),
	(261019, 122, '2014-03-15 00:56:23.000000', 'temperatura', 443.0000, 'ºC'),
	(261020, 122, '2014-03-15 00:56:24.000000', 'temperatura', 784.0000, 'ºC'),
	(261021, 122, '2014-03-15 00:56:25.000000', 'temperatura', 191.0000, 'ºC'),
	(261022, 122, '2014-03-15 00:56:26.000000', 'temperatura', 1005.0000, 'ºC'),
	(261023, 122, '2014-03-15 00:56:27.000000', 'temperatura', 851.0000, 'ºC'),
	(261024, 122, '2014-03-15 00:56:28.000000', 'temperatura', 40.0000, 'ºC'),
	(261025, 122, '2014-03-15 00:56:29.000000', 'temperatura', 47.0000, 'ºC'),
	(261026, 122, '2014-03-15 00:56:30.000000', 'temperatura', 118.0000, 'ºC'),
	(261027, 122, '2014-03-15 00:56:31.000000', 'temperatura', 448.0000, 'ºC'),
	(261028, 122, '2014-03-15 00:56:32.000000', 'temperatura', 685.0000, 'ºC'),
	(261029, 122, '2014-03-15 00:56:33.000000', 'temperatura', 884.0000, 'ºC'),
	(261030, 122, '2014-03-15 00:56:34.000000', 'temperatura', 1166.0000, 'ºC'),
	(261031, 122, '2014-03-15 00:56:35.000000', 'temperatura', 778.0000, 'ºC'),
	(261032, 122, '2014-03-15 00:56:36.000000', 'temperatura', 391.0000, 'ºC'),
	(261033, 122, '2014-03-15 00:56:37.000000', 'temperatura', 824.0000, 'ºC'),
	(261034, 122, '2014-03-15 00:56:38.000000', 'temperatura', 545.0000, 'ºC'),
	(261035, 122, '2014-03-15 00:56:39.000000', 'temperatura', 254.0000, 'ºC'),
	(261036, 122, '2014-03-15 00:56:40.000000', 'temperatura', 834.0000, 'ºC'),
	(261037, 122, '2014-03-15 00:56:41.000000', 'temperatura', 1011.0000, 'ºC'),
	(261038, 122, '2014-03-15 00:56:42.000000', 'temperatura', 151.0000, 'ºC'),
	(261039, 122, '2014-03-15 00:56:43.000000', 'temperatura', 125.0000, 'ºC'),
	(261040, 122, '2014-03-15 00:56:44.000000', 'temperatura', 172.0000, 'ºC'),
	(261041, 122, '2014-03-15 00:56:45.000000', 'temperatura', 484.0000, 'ºC'),
	(261042, 122, '2014-03-15 00:56:46.000000', 'temperatura', 705.0000, 'ºC'),
	(261043, 122, '2014-03-15 00:56:47.000000', 'temperatura', 876.0000, 'ºC'),
	(261044, 122, '2014-03-15 00:56:48.000000', 'temperatura', 1062.0000, 'ºC'),
	(261045, 122, '2014-03-15 00:56:49.000000', 'temperatura', 284.0000, 'ºC'),
	(261046, 122, '2014-03-15 00:56:50.000000', 'temperatura', 635.0000, 'ºC'),
	(261047, 122, '2014-03-15 00:56:51.000000', 'temperatura', 1121.0000, 'ºC'),
	(261048, 122, '2014-03-15 00:56:52.000000', 'temperatura', 103.0000, 'ºC'),
	(261049, 122, '2014-03-15 00:56:53.000000', 'temperatura', 751.0000, 'ºC'),
	(261050, 122, '2014-03-15 00:56:54.000000', 'temperatura', 1045.0000, 'ºC'),
	(261051, 122, '2014-03-15 00:56:55.000000', 'temperatura', 574.0000, 'ºC'),
	(261052, 122, '2014-03-15 00:56:56.000000', 'temperatura', 935.0000, 'ºC'),
	(261053, 122, '2014-03-15 00:56:57.000000', 'temperatura', 554.0000, 'ºC'),
	(261054, 122, '2014-03-15 00:56:58.000000', 'temperatura', 1165.0000, 'ºC'),
	(261055, 122, '2014-03-15 00:56:59.000000', 'temperatura', 563.0000, 'ºC'),
	(261056, 122, '2014-03-15 00:57:00.000000', 'temperatura', 519.0000, 'ºC'),
	(261057, 122, '2014-03-15 00:57:01.000000', 'temperatura', 908.0000, 'ºC'),
	(261058, 122, '2014-03-15 00:57:02.000000', 'temperatura', 582.0000, 'ºC'),
	(261059, 122, '2014-03-15 00:57:03.000000', 'temperatura', 187.0000, 'ºC'),
	(261060, 122, '2014-03-15 00:57:04.000000', 'temperatura', 391.0000, 'ºC'),
	(261061, 122, '2014-03-15 00:57:05.000000', 'temperatura', 195.0000, 'ºC'),
	(261062, 122, '2014-03-15 00:57:06.000000', 'temperatura', 1001.0000, 'ºC'),
	(261063, 122, '2014-03-15 00:57:07.000000', 'temperatura', 822.0000, 'ºC'),
	(261064, 122, '2014-03-15 00:57:08.000000', 'temperatura', 1109.0000, 'ºC'),
	(261065, 122, '2014-03-15 00:57:09.000000', 'temperatura', 677.0000, 'ºC'),
	(261066, 122, '2014-03-15 00:57:10.000000', 'temperatura', 59.0000, 'ºC'),
	(261067, 122, '2014-03-15 00:57:11.000000', 'temperatura', 664.0000, 'ºC'),
	(261068, 122, '2014-03-15 00:57:12.000000', 'temperatura', 746.0000, 'ºC'),
	(261069, 122, '2014-03-15 00:57:13.000000', 'temperatura', 535.0000, 'ºC'),
	(261070, 122, '2014-03-15 00:57:14.000000', 'temperatura', 441.0000, 'ºC'),
	(261071, 122, '2014-03-15 00:57:15.000000', 'temperatura', 599.0000, 'ºC'),
	(261072, 122, '2014-03-15 00:57:16.000000', 'temperatura', 471.0000, 'ºC'),
	(261073, 122, '2014-03-15 00:57:17.000000', 'temperatura', 561.0000, 'ºC'),
	(261074, 122, '2014-03-15 00:57:18.000000', 'temperatura', 193.0000, 'ºC'),
	(261075, 122, '2014-03-15 00:57:19.000000', 'temperatura', 483.0000, 'ºC'),
	(261076, 122, '2014-03-15 00:57:20.000000', 'temperatura', 636.0000, 'ºC'),
	(261077, 122, '2014-03-15 00:57:21.000000', 'temperatura', 531.0000, 'ºC'),
	(261078, 122, '2014-03-15 00:57:22.000000', 'temperatura', 746.0000, 'ºC'),
	(261079, 122, '2014-03-15 00:57:23.000000', 'temperatura', 939.0000, 'ºC'),
	(261080, 122, '2014-03-15 00:57:24.000000', 'temperatura', 56.0000, 'ºC'),
	(261081, 122, '2014-03-15 00:57:25.000000', 'temperatura', 1065.0000, 'ºC'),
	(261082, 122, '2014-03-15 00:57:26.000000', 'temperatura', 355.0000, 'ºC'),
	(261083, 122, '2014-03-15 00:57:27.000000', 'temperatura', 982.0000, 'ºC'),
	(261084, 122, '2014-03-15 00:57:28.000000', 'temperatura', 243.0000, 'ºC'),
	(261085, 122, '2014-03-15 00:57:29.000000', 'temperatura', 673.0000, 'ºC'),
	(261086, 122, '2014-03-15 00:57:30.000000', 'temperatura', 235.0000, 'ºC'),
	(261087, 122, '2014-03-15 00:57:31.000000', 'temperatura', 355.0000, 'ºC'),
	(261088, 122, '2014-03-15 00:57:32.000000', 'temperatura', 1070.0000, 'ºC'),
	(261089, 122, '2014-03-15 00:57:33.000000', 'temperatura', 687.0000, 'ºC'),
	(261090, 122, '2014-03-15 00:57:34.000000', 'temperatura', 227.0000, 'ºC'),
	(261091, 122, '2014-03-15 00:57:35.000000', 'temperatura', 273.0000, 'ºC'),
	(261092, 122, '2014-03-15 00:57:36.000000', 'temperatura', 687.0000, 'ºC'),
	(261093, 122, '2014-03-15 00:57:37.000000', 'temperatura', 214.0000, 'ºC'),
	(261094, 122, '2014-03-15 00:57:38.000000', 'temperatura', 211.0000, 'ºC'),
	(261095, 122, '2014-03-15 00:57:39.000000', 'temperatura', 412.0000, 'ºC'),
	(261096, 122, '2014-03-15 00:57:40.000000', 'temperatura', 226.0000, 'ºC'),
	(261097, 122, '2014-03-15 00:57:41.000000', 'temperatura', 1097.0000, 'ºC'),
	(261098, 122, '2014-03-15 00:57:42.000000', 'temperatura', 5.0000, 'ºC'),
	(261099, 122, '2014-03-15 00:57:43.000000', 'temperatura', 335.0000, 'ºC'),
	(261100, 122, '2014-03-15 00:57:44.000000', 'temperatura', 463.0000, 'ºC'),
	(261101, 122, '2014-03-15 00:57:45.000000', 'temperatura', 108.0000, 'ºC'),
	(261102, 122, '2014-03-15 00:57:46.000000', 'temperatura', 352.0000, 'ºC'),
	(261103, 122, '2014-03-15 00:57:47.000000', 'temperatura', 235.0000, 'ºC'),
	(261104, 122, '2014-03-15 00:57:48.000000', 'temperatura', 121.0000, 'ºC'),
	(261105, 122, '2014-03-15 00:57:49.000000', 'temperatura', 1101.0000, 'ºC'),
	(261106, 122, '2014-03-15 00:57:50.000000', 'temperatura', 343.0000, 'ºC'),
	(261107, 122, '2014-03-15 00:57:51.000000', 'temperatura', 812.0000, 'ºC'),
	(261108, 122, '2014-03-15 00:57:52.000000', 'temperatura', 633.0000, 'ºC'),
	(261109, 122, '2014-03-15 00:57:53.000000', 'temperatura', 729.0000, 'ºC'),
	(261110, 122, '2014-03-15 00:57:54.000000', 'temperatura', 546.0000, 'ºC'),
	(261111, 122, '2014-03-15 00:57:55.000000', 'temperatura', 545.0000, 'ºC'),
	(261112, 122, '2014-03-15 00:57:56.000000', 'temperatura', 1087.0000, 'ºC'),
	(261113, 122, '2014-03-15 00:57:57.000000', 'temperatura', 200.0000, 'ºC'),
	(261114, 122, '2014-03-15 00:57:58.000000', 'temperatura', 138.0000, 'ºC'),
	(261115, 122, '2014-03-15 00:57:59.000000', 'temperatura', 92.0000, 'ºC'),
	(261116, 122, '2014-03-15 00:58:00.000000', 'temperatura', 45.0000, 'ºC'),
	(261117, 122, '2014-03-15 00:58:01.000000', 'temperatura', 1152.0000, 'ºC'),
	(261118, 122, '2014-03-15 00:58:02.000000', 'temperatura', 825.0000, 'ºC'),
	(261119, 122, '2014-03-15 00:58:03.000000', 'temperatura', 669.0000, 'ºC'),
	(261120, 122, '2014-03-15 00:58:04.000000', 'temperatura', 871.0000, 'ºC'),
	(261121, 122, '2014-03-15 00:58:05.000000', 'temperatura', 1149.0000, 'ºC'),
	(261122, 122, '2014-03-15 00:58:06.000000', 'temperatura', 731.0000, 'ºC'),
	(261123, 122, '2014-03-15 00:58:07.000000', 'temperatura', 208.0000, 'ºC'),
	(261124, 122, '2014-03-15 00:58:08.000000', 'temperatura', 47.0000, 'ºC'),
	(261125, 122, '2014-03-15 00:58:09.000000', 'temperatura', 811.0000, 'ºC'),
	(261126, 122, '2014-03-15 00:58:10.000000', 'temperatura', 315.0000, 'ºC'),
	(261127, 122, '2014-03-15 00:58:11.000000', 'temperatura', 344.0000, 'ºC'),
	(261128, 122, '2014-03-15 00:58:12.000000', 'temperatura', 774.0000, 'ºC'),
	(261129, 122, '2014-03-15 00:58:13.000000', 'temperatura', 439.0000, 'ºC'),
	(261130, 122, '2014-03-15 00:58:14.000000', 'temperatura', 1075.0000, 'ºC'),
	(261131, 122, '2014-03-15 00:58:15.000000', 'temperatura', 457.0000, 'ºC'),
	(261132, 122, '2014-03-15 00:58:16.000000', 'temperatura', 260.0000, 'ºC'),
	(261133, 122, '2014-03-15 00:58:17.000000', 'temperatura', 1128.0000, 'ºC'),
	(261134, 122, '2014-03-15 00:58:18.000000', 'temperatura', 63.0000, 'ºC'),
	(261135, 122, '2014-03-15 00:58:19.000000', 'temperatura', 529.0000, 'ºC'),
	(261136, 122, '2014-03-15 00:58:20.000000', 'temperatura', 57.0000, 'ºC'),
	(261137, 122, '2014-03-15 00:58:21.000000', 'temperatura', 1100.0000, 'ºC'),
	(261138, 122, '2014-03-15 00:58:22.000000', 'temperatura', 530.0000, 'ºC'),
	(261139, 122, '2014-03-15 00:58:23.000000', 'temperatura', 550.0000, 'ºC'),
	(261140, 122, '2014-03-15 00:58:24.000000', 'temperatura', 1162.0000, 'ºC'),
	(261141, 122, '2014-03-15 00:58:25.000000', 'temperatura', 561.0000, 'ºC'),
	(261142, 122, '2014-03-15 00:58:26.000000', 'temperatura', 517.0000, 'ºC'),
	(261143, 122, '2014-03-15 00:58:27.000000', 'temperatura', 903.0000, 'ºC'),
	(261144, 122, '2014-03-15 00:58:28.000000', 'temperatura', 563.0000, 'ºC'),
	(261145, 122, '2014-03-15 00:58:29.000000', 'temperatura', 109.0000, 'ºC'),
	(261146, 122, '2014-03-15 00:58:30.000000', 'temperatura', 57.0000, 'ºC'),
	(261147, 122, '2014-03-15 00:58:31.000000', 'temperatura', 1158.0000, 'ºC'),
	(261148, 122, '2014-03-15 00:58:32.000000', 'temperatura', 817.0000, 'ºC'),
	(261149, 122, '2014-03-15 00:58:33.000000', 'temperatura', 614.0000, 'ºC'),
	(261150, 122, '2014-03-15 00:58:34.000000', 'temperatura', 621.0000, 'ºC'),
	(261151, 122, '2014-03-15 00:58:35.000000', 'temperatura', 61.0000, 'ºC'),
	(261152, 122, '2014-03-15 00:58:36.000000', 'temperatura', 845.0000, 'ºC'),
	(261153, 122, '2014-03-15 00:58:37.000000', 'temperatura', 441.0000, 'ºC'),
	(261154, 122, '2014-03-15 00:58:38.000000', 'temperatura', 871.0000, 'ºC'),
	(261155, 122, '2014-03-15 00:58:39.000000', 'temperatura', 633.0000, 'ºC'),
	(261156, 122, '2014-03-15 00:58:40.000000', 'temperatura', 551.0000, 'ºC'),
	(261157, 122, '2014-03-15 00:58:41.000000', 'temperatura', 855.0000, 'ºC'),
	(261158, 122, '2014-03-15 00:58:42.000000', 'temperatura', 225.0000, 'ºC'),
	(261159, 122, '2014-03-15 00:58:43.000000', 'temperatura', 960.0000, 'ºC'),
	(261160, 122, '2014-03-15 00:58:44.000000', 'temperatura', 527.0000, 'ºC'),
	(261161, 122, '2014-03-15 00:58:45.000000', 'temperatura', 956.0000, 'ºC'),
	(261162, 122, '2014-03-15 00:58:46.000000', 'temperatura', 799.0000, 'ºC'),
	(261163, 122, '2014-03-15 00:58:47.000000', 'temperatura', 1126.0000, 'ºC'),
	(261164, 122, '2014-03-15 00:58:48.000000', 'temperatura', 833.0000, 'ºC'),
	(261165, 122, '2014-03-15 00:58:49.000000', 'temperatura', 789.0000, 'ºC'),
	(261166, 122, '2014-03-15 00:58:50.000000', 'temperatura', 246.0000, 'ºC'),
	(261167, 122, '2014-03-15 00:58:51.000000', 'temperatura', 64.0000, 'ºC'),
	(261168, 122, '2014-03-15 00:58:52.000000', 'temperatura', 783.0000, 'ºC'),
	(261169, 122, '2014-03-15 00:58:53.000000', 'temperatura', 122.0000, 'ºC'),
	(261170, 122, '2014-03-15 00:58:54.000000', 'temperatura', 661.0000, 'ºC'),
	(261171, 122, '2014-03-15 00:58:55.000000', 'temperatura', 539.0000, 'ºC'),
	(261172, 122, '2014-03-15 00:58:56.000000', 'temperatura', 712.0000, 'ºC'),
	(261173, 122, '2014-03-15 00:58:57.000000', 'temperatura', 745.0000, 'ºC'),
	(261174, 122, '2014-03-15 00:58:58.000000', 'temperatura', 390.0000, 'ºC'),
	(261175, 122, '2014-03-15 00:58:59.000000', 'temperatura', 916.0000, 'ºC'),
	(261176, 122, '2014-03-15 00:59:00.000000', 'temperatura', 1012.0000, 'ºC'),
	(261177, 122, '2014-03-15 00:59:01.000000', 'temperatura', 1110.0000, 'ºC'),
	(261178, 122, '2014-03-15 00:59:02.000000', 'temperatura', 115.0000, 'ºC'),
	(261179, 122, '2014-03-15 00:59:03.000000', 'temperatura', 847.0000, 'ºC'),
	(261180, 122, '2014-03-15 00:59:04.000000', 'temperatura', 290.0000, 'ºC'),
	(261181, 122, '2014-03-15 00:59:05.000000', 'temperatura', 111.0000, 'ºC'),
	(261182, 122, '2014-03-15 00:59:06.000000', 'temperatura', 885.0000, 'ºC'),
	(261183, 122, '2014-03-15 00:59:07.000000', 'temperatura', 490.0000, 'ºC'),
	(261184, 122, '2014-03-15 00:59:08.000000', 'temperatura', 999.0000, 'ºC'),
	(261185, 122, '2014-03-15 00:59:09.000000', 'temperatura', 1124.0000, 'ºC'),
	(261186, 122, '2014-03-15 00:59:10.000000', 'temperatura', 222.0000, 'ºC'),
	(261187, 122, '2014-03-15 00:59:11.000000', 'temperatura', 139.0000, 'ºC'),
	(261188, 122, '2014-03-15 00:59:12.000000', 'temperatura', 29.0000, 'ºC'),
	(261189, 122, '2014-03-15 00:59:13.000000', 'temperatura', 928.0000, 'ºC'),
	(261190, 122, '2014-03-15 00:59:14.000000', 'temperatura', 955.0000, 'ºC'),
	(261191, 122, '2014-03-15 00:59:15.000000', 'temperatura', 791.0000, 'ºC'),
	(261192, 122, '2014-03-15 00:59:16.000000', 'temperatura', 1089.0000, 'ºC'),
	(261193, 122, '2014-03-15 00:59:17.000000', 'temperatura', 675.0000, 'ºC'),
	(261194, 122, '2014-03-15 00:59:18.000000', 'temperatura', 107.0000, 'ºC'),
	(261195, 122, '2014-03-15 00:59:19.000000', 'temperatura', 913.0000, 'ºC'),
	(261196, 122, '2014-03-15 00:59:20.000000', 'temperatura', 642.0000, 'ºC'),
	(261197, 122, '2014-03-15 00:59:21.000000', 'temperatura', 471.0000, 'ºC'),
	(261198, 122, '2014-03-15 00:59:22.000000', 'temperatura', 431.0000, 'ºC'),
	(261199, 122, '2014-03-15 00:59:23.000000', 'temperatura', 743.0000, 'ºC'),
	(261200, 122, '2014-03-15 00:59:24.000000', 'temperatura', 23.0000, 'ºC'),
	(261201, 122, '2014-03-15 00:59:25.000000', 'temperatura', 284.0000, 'ºC'),
	(261202, 122, '2014-03-15 00:59:26.000000', 'temperatura', 152.0000, 'ºC'),
	(261203, 122, '2014-03-15 00:59:27.000000', 'temperatura', 1107.0000, 'ºC'),
	(261204, 122, '2014-03-15 00:59:28.000000', 'temperatura', 281.0000, 'ºC'),
	(261205, 122, '2014-03-15 00:59:29.000000', 'temperatura', 484.0000, 'ºC'),
	(261206, 122, '2014-03-15 00:59:30.000000', 'temperatura', 378.0000, 'ºC'),
	(261207, 122, '2014-03-15 00:59:31.000000', 'temperatura', 436.0000, 'ºC'),
	(261208, 122, '2014-03-15 00:59:32.000000', 'temperatura', 1049.0000, 'ºC'),
	(261209, 122, '2014-03-15 00:59:33.000000', 'temperatura', 338.0000, 'ºC'),
	(261210, 122, '2014-03-15 00:59:34.000000', 'temperatura', 945.0000, 'ºC'),
	(261211, 122, '2014-03-15 00:59:35.000000', 'temperatura', 109.0000, 'ºC'),
	(261212, 122, '2014-03-15 00:59:36.000000', 'temperatura', 109.0000, 'ºC'),
	(261213, 122, '2014-03-15 00:59:37.000000', 'temperatura', 221.0000, 'ºC'),
	(261214, 122, '2014-03-15 00:59:38.000000', 'temperatura', 777.0000, 'ºC'),
	(261215, 122, '2014-03-15 00:59:39.000000', 'temperatura', 823.0000, 'ºC'),
	(261216, 122, '2014-03-15 00:59:40.000000', 'temperatura', 587.0000, 'ºC'),
	(261217, 122, '2014-03-15 00:59:41.000000', 'temperatura', 463.0000, 'ºC'),
	(261218, 122, '2014-03-15 00:59:42.000000', 'temperatura', 558.0000, 'ºC'),
	(261219, 122, '2014-03-15 00:59:43.000000', 'temperatura', 198.0000, 'ºC'),
	(261220, 122, '2014-03-15 00:59:44.000000', 'temperatura', 518.0000, 'ºC'),
	(261221, 122, '2014-03-15 00:59:45.000000', 'temperatura', 796.0000, 'ºC'),
	(261222, 122, '2014-03-15 00:59:46.000000', 'temperatura', 25.0000, 'ºC'),
	(261223, 122, '2014-03-15 00:59:47.000000', 'temperatura', 141.0000, 'ºC'),
	(261224, 122, '2014-03-15 00:59:48.000000', 'temperatura', 627.0000, 'ºC'),
	(261225, 122, '2014-03-15 00:59:49.000000', 'temperatura', 313.0000, 'ºC'),
	(261226, 122, '2014-03-15 00:59:50.000000', 'temperatura', 886.0000, 'ºC'),
	(261227, 122, '2014-03-15 00:59:51.000000', 'temperatura', 1091.0000, 'ºC'),
	(261228, 122, '2014-03-15 00:59:52.000000', 'temperatura', 397.0000, 'ºC'),
	(261229, 122, '2014-03-15 00:59:53.000000', 'temperatura', 1114.0000, 'ºC'),
	(261230, 122, '2014-03-15 00:59:54.000000', 'temperatura', 780.0000, 'ºC'),
	(261231, 122, '2014-03-15 00:59:55.000000', 'temperatura', 559.0000, 'ºC'),
	(261232, 122, '2014-03-15 00:59:56.000000', 'temperatura', 455.0000, 'ºC'),
	(261233, 122, '2014-03-15 00:59:57.000000', 'temperatura', 596.0000, 'ºC'),
	(261234, 122, '2014-03-15 00:59:58.000000', 'temperatura', 417.0000, 'ºC'),
	(261235, 122, '2014-03-15 00:59:59.000000', 'temperatura', 299.0000, 'ºC'),
	(261236, 122, '2014-03-15 01:00:00.000000', 'temperatura', 244.0000, 'ºC'),
	(261237, 122, '2014-03-15 01:00:01.000000', 'temperatura', 321.0000, 'ºC'),
	(261238, 122, '2014-03-15 01:00:02.000000', 'temperatura', 876.0000, 'ºC'),
	(261239, 122, '2014-03-15 01:00:03.000000', 'temperatura', 1016.0000, 'ºC'),
	(261240, 122, '2014-03-15 01:00:04.000000', 'temperatura', 53.0000, 'ºC'),
	(261241, 122, '2014-03-15 01:00:05.000000', 'temperatura', 819.0000, 'ºC'),
	(261242, 122, '2014-03-15 01:00:06.000000', 'temperatura', 335.0000, 'ºC'),
	(261243, 122, '2014-03-15 01:00:07.000000', 'temperatura', 417.0000, 'ºC'),
	(261244, 122, '2014-03-15 01:00:08.000000', 'temperatura', 1083.0000, 'ºC'),
	(261245, 122, '2014-03-15 01:00:09.000000', 'temperatura', 564.0000, 'ºC'),
	(261246, 122, '2014-03-15 01:00:10.000000', 'temperatura', 771.0000, 'ºC'),
	(261247, 122, '2014-03-15 01:00:11.000000', 'temperatura', 964.0000, 'ºC'),
	(261248, 122, '2014-03-15 01:00:12.000000', 'temperatura', 105.0000, 'ºC'),
	(261249, 122, '2014-03-15 01:00:13.000000', 'temperatura', 36.0000, 'ºC'),
	(261250, 122, '2014-03-15 01:00:14.000000', 'temperatura', 1066.0000, 'ºC'),
	(261251, 122, '2014-03-15 01:00:15.000000', 'temperatura', 422.0000, 'ºC'),
	(261252, 122, '2014-03-15 01:00:16.000000', 'temperatura', 112.0000, 'ºC'),
	(261253, 122, '2014-03-15 01:00:17.000000', 'temperatura', 496.0000, 'ºC'),
	(261254, 122, '2014-03-15 01:00:18.000000', 'temperatura', 943.0000, 'ºC'),
	(261255, 122, '2014-03-15 01:00:19.000000', 'temperatura', 828.0000, 'ºC'),
	(261256, 122, '2014-03-15 01:00:20.000000', 'temperatura', 110.0000, 'ºC'),
	(261257, 122, '2014-03-15 01:00:21.000000', 'temperatura', 468.0000, 'ºC'),
	(261258, 122, '2014-03-15 01:00:22.000000', 'temperatura', 812.0000, 'ºC'),
	(261259, 122, '2014-03-15 01:00:23.000000', 'temperatura', 255.0000, 'ºC'),
	(261260, 122, '2014-03-15 01:00:24.000000', 'temperatura', 38.0000, 'ºC'),
	(261261, 122, '2014-03-15 01:00:25.000000', 'temperatura', 627.0000, 'ºC'),
	(261262, 122, '2014-03-15 01:00:26.000000', 'temperatura', 620.0000, 'ºC'),
	(261263, 122, '2014-03-15 01:00:27.000000', 'temperatura', 22.0000, 'ºC'),
	(261264, 122, '2014-03-15 01:00:28.000000', 'temperatura', 651.0000, 'ºC'),
	(261265, 122, '2014-03-15 01:00:29.000000', 'temperatura', 789.0000, 'ºC'),
	(261266, 122, '2014-03-15 01:00:30.000000', 'temperatura', 794.0000, 'ºC'),
	(261267, 122, '2014-03-15 01:00:31.000000', 'temperatura', 403.0000, 'ºC'),
	(261268, 122, '2014-03-15 01:00:32.000000', 'temperatura', 832.0000, 'ºC'),
	(261269, 122, '2014-03-15 01:00:33.000000', 'temperatura', 551.0000, 'ºC'),
	(261270, 122, '2014-03-15 01:00:34.000000', 'temperatura', 262.0000, 'ºC'),
	(261271, 122, '2014-03-15 01:00:35.000000', 'temperatura', 857.0000, 'ºC'),
	(261272, 122, '2014-03-15 01:00:36.000000', 'temperatura', 1097.0000, 'ºC'),
	(261273, 122, '2014-03-15 01:00:37.000000', 'temperatura', 517.0000, 'ºC'),
	(261274, 122, '2014-03-15 01:00:38.000000', 'temperatura', 494.0000, 'ºC'),
	(261275, 122, '2014-03-15 01:00:39.000000', 'temperatura', 920.0000, 'ºC'),
	(261276, 122, '2014-03-15 01:00:40.000000', 'temperatura', 718.0000, 'ºC'),
	(261277, 122, '2014-03-15 01:00:41.000000', 'temperatura', 829.0000, 'ºC'),
	(261278, 122, '2014-03-15 01:00:42.000000', 'temperatura', 793.0000, 'ºC'),
	(261279, 122, '2014-03-15 01:00:43.000000', 'temperatura', 279.0000, 'ºC'),
	(261280, 122, '2014-03-15 01:00:44.000000', 'temperatura', 215.0000, 'ºC'),
	(261281, 122, '2014-03-15 01:00:45.000000', 'temperatura', 238.0000, 'ºC'),
	(261282, 122, '2014-03-15 01:00:46.000000', 'temperatura', 547.0000, 'ºC'),
	(261283, 122, '2014-03-15 01:00:47.000000', 'temperatura', 823.0000, 'ºC'),
	(261284, 122, '2014-03-15 01:00:48.000000', 'temperatura', 71.0000, 'ºC'),
	(261285, 122, '2014-03-15 01:00:49.000000', 'temperatura', 290.0000, 'ºC'),
	(261286, 122, '2014-03-15 01:00:50.000000', 'temperatura', 36.0000, 'ºC'),
	(261287, 122, '2014-03-15 01:00:51.000000', 'temperatura', 509.0000, 'ºC'),
	(261288, 122, '2014-03-15 01:00:52.000000', 'temperatura', 38.0000, 'ºC'),
	(261289, 122, '2014-03-15 01:00:53.000000', 'temperatura', 1065.0000, 'ºC'),
	(261290, 122, '2014-03-15 01:00:54.000000', 'temperatura', 410.0000, 'ºC'),
	(261291, 122, '2014-03-15 01:00:55.000000', 'temperatura', 55.0000, 'ºC'),
	(261292, 122, '2014-03-15 01:00:56.000000', 'temperatura', 246.0000, 'ºC'),
	(261293, 122, '2014-03-15 01:00:57.000000', 'temperatura', 1065.0000, 'ºC'),
	(261294, 122, '2014-03-15 01:00:58.000000', 'temperatura', 986.0000, 'ºC'),
	(261295, 122, '2014-03-15 01:00:59.000000', 'temperatura', 538.0000, 'ºC'),
	(261296, 122, '2014-03-15 01:01:00.000000', 'temperatura', 930.0000, 'ºC'),
	(261297, 122, '2014-03-15 01:01:01.000000', 'temperatura', 636.0000, 'ºC'),
	(261298, 122, '2014-03-15 01:01:02.000000', 'temperatura', 392.0000, 'ºC'),
	(261299, 122, '2014-03-15 01:01:03.000000', 'temperatura', 52.0000, 'ºC'),
	(261300, 122, '2014-03-15 01:01:04.000000', 'temperatura', 286.0000, 'ºC'),
	(261301, 122, '2014-03-15 01:01:05.000000', 'temperatura', 75.0000, 'ºC'),
	(261302, 122, '2014-03-15 01:01:06.000000', 'temperatura', 718.0000, 'ºC'),
	(261303, 122, '2014-03-15 01:01:07.000000', 'temperatura', 963.0000, 'ºC'),
	(261304, 122, '2014-03-15 01:01:08.000000', 'temperatura', 261.0000, 'ºC'),
	(261305, 122, '2014-03-15 01:01:09.000000', 'temperatura', 819.0000, 'ºC'),
	(261306, 122, '2014-03-15 01:01:10.000000', 'temperatura', 910.0000, 'ºC'),
	(261307, 122, '2014-03-15 01:01:11.000000', 'temperatura', 895.0000, 'ºC'),
	(261308, 122, '2014-03-15 01:01:12.000000', 'temperatura', 546.0000, 'ºC'),
	(261309, 122, '2014-03-15 01:01:13.000000', 'temperatura', 45.0000, 'ºC'),
	(261310, 122, '2014-03-15 01:01:14.000000', 'temperatura', 986.0000, 'ºC'),
	(261311, 122, '2014-03-15 01:01:15.000000', 'temperatura', 1197.0000, 'ºC'),
	(261312, 122, '2014-03-15 01:01:16.000000', 'temperatura', 628.0000, 'ºC'),
	(261313, 122, '2014-03-15 01:01:17.000000', 'temperatura', 747.0000, 'ºC'),
	(261314, 122, '2014-03-15 01:01:18.000000', 'temperatura', 654.0000, 'ºC'),
	(261315, 122, '2014-03-15 01:01:19.000000', 'temperatura', 1027.0000, 'ºC'),
	(261316, 122, '2014-03-15 01:01:20.000000', 'temperatura', 775.0000, 'ºC'),
	(261317, 122, '2014-03-15 01:01:21.000000', 'temperatura', 796.0000, 'ºC'),
	(261318, 122, '2014-03-15 01:01:22.000000', 'temperatura', 456.0000, 'ºC'),
	(261319, 122, '2014-03-15 01:01:23.000000', 'temperatura', 1090.0000, 'ºC'),
	(261320, 122, '2014-03-15 01:01:24.000000', 'temperatura', 483.0000, 'ºC'),
	(261321, 122, '2014-03-15 01:01:25.000000', 'temperatura', 348.0000, 'ºC'),
	(261322, 122, '2014-03-15 01:01:26.000000', 'temperatura', 290.0000, 'ºC'),
	(261323, 122, '2014-03-15 01:01:27.000000', 'temperatura', 405.0000, 'ºC'),
	(261324, 122, '2014-03-15 01:01:28.000000', 'temperatura', 1155.0000, 'ºC'),
	(261325, 122, '2014-03-15 01:01:29.000000', 'temperatura', 960.0000, 'ºC'),
	(261326, 122, '2014-03-15 01:01:30.000000', 'temperatura', 136.0000, 'ºC'),
	(261327, 122, '2014-03-15 01:01:31.000000', 'temperatura', 202.0000, 'ºC'),
	(261328, 122, '2014-03-15 01:01:32.000000', 'temperatura', 600.0000, 'ºC'),
	(261329, 122, '2014-03-15 01:01:33.000000', 'temperatura', 1195.0000, 'ºC'),
	(261330, 122, '2014-03-15 01:01:34.000000', 'temperatura', 578.0000, 'ºC'),
	(261331, 122, '2014-03-15 01:01:35.000000', 'temperatura', 504.0000, 'ºC'),
	(261332, 122, '2014-03-15 01:01:36.000000', 'temperatura', 786.0000, 'ºC'),
	(261333, 122, '2014-03-15 01:01:37.000000', 'temperatura', 17.0000, 'ºC'),
	(261334, 122, '2014-03-15 01:01:38.000000', 'temperatura', 130.0000, 'ºC'),
	(261335, 122, '2014-03-15 01:01:39.000000', 'temperatura', 600.0000, 'ºC'),
	(261336, 122, '2014-03-15 01:01:40.000000', 'temperatura', 211.0000, 'ºC'),
	(261337, 122, '2014-03-15 01:01:41.000000', 'temperatura', 456.0000, 'ºC'),
	(261338, 122, '2014-03-15 01:01:42.000000', 'temperatura', 447.0000, 'ºC'),
	(261339, 122, '2014-03-15 01:01:43.000000', 'temperatura', 865.0000, 'ºC'),
	(261340, 122, '2014-03-15 01:01:44.000000', 'temperatura', 587.0000, 'ºC'),
	(261341, 122, '2014-03-15 01:01:45.000000', 'temperatura', 338.0000, 'ºC'),
	(261342, 122, '2014-03-15 01:01:46.000000', 'temperatura', 1131.0000, 'ºC'),
	(261343, 122, '2014-03-15 01:01:47.000000', 'temperatura', 1040.0000, 'ºC'),
	(261344, 122, '2014-03-15 01:01:48.000000', 'temperatura', 610.0000, 'ºC'),
	(261345, 122, '2014-03-15 01:01:49.000000', 'temperatura', 1128.0000, 'ºC'),
	(261346, 122, '2014-03-15 01:01:50.000000', 'temperatura', 213.0000, 'ºC'),
	(261347, 122, '2014-03-15 01:01:51.000000', 'temperatura', 80.0000, 'ºC'),
	(261348, 122, '2014-03-15 01:01:52.000000', 'temperatura', 962.0000, 'ºC'),
	(261349, 122, '2014-03-15 01:01:53.000000', 'temperatura', 970.0000, 'ºC'),
	(261350, 122, '2014-03-15 01:01:54.000000', 'temperatura', 766.0000, 'ºC'),
	(261351, 122, '2014-03-15 01:01:55.000000', 'temperatura', 919.0000, 'ºC'),
	(261352, 122, '2014-03-15 01:01:56.000000', 'temperatura', 1099.0000, 'ºC'),
	(261353, 122, '2014-03-15 01:01:57.000000', 'temperatura', 336.0000, 'ºC'),
	(261354, 122, '2014-03-15 01:01:58.000000', 'temperatura', 784.0000, 'ºC'),
	(261355, 122, '2014-03-15 01:01:59.000000', 'temperatura', 513.0000, 'ºC'),
	(261356, 122, '2014-03-15 01:02:00.000000', 'temperatura', 212.0000, 'ºC'),
	(261357, 122, '2014-03-15 01:02:01.000000', 'temperatura', 721.0000, 'ºC'),
	(261358, 122, '2014-03-15 01:02:02.000000', 'temperatura', 571.0000, 'ºC'),
	(261359, 122, '2014-03-15 01:02:03.000000', 'temperatura', 692.0000, 'ºC'),
	(261360, 122, '2014-03-15 01:02:04.000000', 'temperatura', 548.0000, 'ºC'),
	(261361, 122, '2014-03-15 01:02:05.000000', 'temperatura', 663.0000, 'ºC'),
	(261362, 122, '2014-03-15 01:02:06.000000', 'temperatura', 471.0000, 'ºC'),
	(261363, 122, '2014-03-15 01:02:07.000000', 'temperatura', 368.0000, 'ºC'),
	(261364, 122, '2014-03-15 01:02:08.000000', 'temperatura', 427.0000, 'ºC'),
	(261365, 122, '2014-03-15 01:02:09.000000', 'temperatura', 1033.0000, 'ºC'),
	(261366, 122, '2014-03-15 01:02:10.000000', 'temperatura', 283.0000, 'ºC'),
	(261367, 122, '2014-03-15 01:02:11.000000', 'temperatura', 715.0000, 'ºC'),
	(261368, 122, '2014-03-15 01:02:12.000000', 'temperatura', 328.0000, 'ºC'),
	(261369, 122, '2014-03-15 01:02:13.000000', 'temperatura', 697.0000, 'ºC'),
	(261370, 122, '2014-03-15 01:02:14.000000', 'temperatura', 99.0000, 'ºC'),
	(261371, 122, '2014-03-15 01:02:15.000000', 'temperatura', 804.0000, 'ºC'),
	(261372, 122, '2014-03-15 01:02:16.000000', 'temperatura', 124.0000, 'ºC'),
	(261373, 122, '2014-03-15 01:02:17.000000', 'temperatura', 607.0000, 'ºC'),
	(261374, 122, '2014-03-15 01:02:18.000000', 'temperatura', 264.0000, 'ºC'),
	(261375, 122, '2014-03-15 01:02:19.000000', 'temperatura', 700.0000, 'ºC'),
	(261376, 122, '2014-03-15 01:02:20.000000', 'temperatura', 307.0000, 'ºC'),
	(261377, 122, '2014-03-15 01:02:21.000000', 'temperatura', 637.0000, 'ºC'),
	(261378, 122, '2014-03-15 01:02:22.000000', 'temperatura', 1064.0000, 'ºC'),
	(261379, 122, '2014-03-15 01:02:23.000000', 'temperatura', 1010.0000, 'ºC'),
	(261380, 122, '2014-03-15 01:02:24.000000', 'temperatura', 660.0000, 'ºC'),
	(261381, 122, '2014-03-15 01:02:25.000000', 'temperatura', 268.0000, 'ºC'),
	(261382, 122, '2014-03-15 01:02:26.000000', 'temperatura', 563.0000, 'ºC'),
	(261383, 122, '2014-03-15 01:02:27.000000', 'temperatura', 809.0000, 'ºC'),
	(261384, 122, '2014-03-15 01:02:28.000000', 'temperatura', 1158.0000, 'ºC'),
	(261385, 122, '2014-03-15 01:02:29.000000', 'temperatura', 963.0000, 'ºC'),
	(261386, 122, '2014-03-15 01:02:30.000000', 'temperatura', 143.0000, 'ºC'),
	(261387, 122, '2014-03-15 01:02:31.000000', 'temperatura', 224.0000, 'ºC'),
	(261388, 122, '2014-03-15 01:02:32.000000', 'temperatura', 692.0000, 'ºC'),
	(261389, 122, '2014-03-15 01:02:33.000000', 'temperatura', 389.0000, 'ºC'),
	(261390, 122, '2014-03-15 01:02:34.000000', 'temperatura', 1070.0000, 'ºC'),
	(261391, 122, '2014-03-15 01:02:35.000000', 'temperatura', 582.0000, 'ºC'),
	(261392, 122, '2014-03-15 01:02:36.000000', 'temperatura', 901.0000, 'ºC'),
	(261393, 122, '2014-03-15 01:02:37.000000', 'temperatura', 362.0000, 'ºC'),
	(261394, 122, '2014-03-15 01:02:38.000000', 'temperatura', 305.0000, 'ºC'),
	(261395, 122, '2014-03-15 01:02:39.000000', 'temperatura', 439.0000, 'ºC'),
	(261396, 122, '2014-03-15 01:02:40.000000', 'temperatura', 79.0000, 'ºC'),
	(261397, 122, '2014-03-15 01:02:41.000000', 'temperatura', 281.0000, 'ºC'),
	(261398, 122, '2014-03-15 01:02:42.000000', 'temperatura', 1170.0000, 'ºC'),
	(261399, 122, '2014-03-15 01:02:43.000000', 'temperatura', 205.0000, 'ºC'),
	(261400, 122, '2014-03-15 01:02:44.000000', 'temperatura', 1114.0000, 'ºC'),
	(261401, 122, '2014-03-15 01:02:45.000000', 'temperatura', 157.0000, 'ºC'),
	(261402, 122, '2014-03-15 01:02:46.000000', 'temperatura', 1045.0000, 'ºC'),
	(261403, 122, '2014-03-15 01:02:47.000000', 'temperatura', 1154.0000, 'ºC'),
	(261404, 122, '2014-03-15 01:02:48.000000', 'temperatura', 233.0000, 'ºC'),
	(261405, 122, '2014-03-15 01:02:49.000000', 'temperatura', 105.0000, 'ºC'),
	(261406, 122, '2014-03-15 01:02:50.000000', 'temperatura', 1027.0000, 'ºC'),
	(261407, 122, '2014-03-15 01:02:51.000000', 'temperatura', 20.0000, 'ºC'),
	(261408, 122, '2014-03-15 01:02:52.000000', 'temperatura', 620.0000, 'ºC'),
	(261409, 122, '2014-03-15 01:02:53.000000', 'temperatura', 640.0000, 'ºC'),
	(261410, 122, '2014-03-15 01:02:54.000000', 'temperatura', 142.0000, 'ºC'),
	(261411, 122, '2014-03-15 01:02:55.000000', 'temperatura', 1190.0000, 'ºC'),
	(261412, 122, '2014-03-15 01:02:56.000000', 'temperatura', 722.0000, 'ºC'),
	(261413, 122, '2014-03-15 01:02:57.000000', 'temperatura', 44.0000, 'ºC'),
	(261414, 122, '2014-03-15 01:02:58.000000', 'temperatura', 454.0000, 'ºC'),
	(261415, 122, '2014-03-15 01:02:59.000000', 'temperatura', 937.0000, 'ºC'),
	(261416, 122, '2014-03-15 01:03:00.000000', 'temperatura', 922.0000, 'ºC'),
	(261417, 122, '2014-03-15 01:03:01.000000', 'temperatura', 601.0000, 'ºC'),
	(261418, 122, '2014-03-15 01:03:02.000000', 'temperatura', 241.0000, 'ºC'),
	(261419, 122, '2014-03-15 01:03:03.000000', 'temperatura', 603.0000, 'ºC'),
	(261420, 122, '2014-03-15 01:03:04.000000', 'temperatura', 1093.0000, 'ºC'),
	(261421, 122, '2014-03-15 01:03:05.000000', 'temperatura', 55.0000, 'ºC'),
	(261422, 122, '2014-03-15 01:03:06.000000', 'temperatura', 595.0000, 'ºC'),
	(261423, 122, '2014-03-15 01:03:07.000000', 'temperatura', 414.0000, 'ºC'),
	(261424, 122, '2014-03-15 01:03:08.000000', 'temperatura', 283.0000, 'ºC'),
	(261425, 122, '2014-03-15 01:03:09.000000', 'temperatura', 174.0000, 'ºC'),
	(261426, 122, '2014-03-15 01:03:10.000000', 'temperatura', 23.0000, 'ºC'),
	(261427, 122, '2014-03-15 01:03:11.000000', 'temperatura', 793.0000, 'ºC'),
	(261428, 122, '2014-03-15 01:03:12.000000', 'temperatura', 296.0000, 'ºC'),
	(261429, 122, '2014-03-15 01:03:13.000000', 'temperatura', 303.0000, 'ºC'),
	(261430, 122, '2014-03-15 01:03:14.000000', 'temperatura', 628.0000, 'ºC'),
	(261431, 122, '2014-03-15 01:03:15.000000', 'temperatura', 1031.0000, 'ºC'),
	(261432, 122, '2014-03-15 01:03:16.000000', 'temperatura', 870.0000, 'ºC'),
	(261433, 122, '2014-03-15 01:03:17.000000', 'temperatura', 57.0000, 'ºC'),
	(261434, 122, '2014-03-15 01:03:18.000000', 'temperatura', 76.0000, 'ºC'),
	(261435, 122, '2014-03-15 01:03:19.000000', 'temperatura', 208.0000, 'ºC'),
	(261436, 122, '2014-03-15 01:03:20.000000', 'temperatura', 816.0000, 'ºC'),
	(261437, 122, '2014-03-15 01:03:21.000000', 'temperatura', 1053.0000, 'ºC'),
	(261438, 122, '2014-03-15 01:03:22.000000', 'temperatura', 418.0000, 'ºC'),
	(261439, 122, '2014-03-15 01:03:23.000000', 'temperatura', 132.0000, 'ºC'),
	(261440, 122, '2014-03-15 01:03:24.000000', 'temperatura', 607.0000, 'ºC'),
	(261441, 122, '2014-03-15 01:03:25.000000', 'temperatura', 239.0000, 'ºC'),
	(261442, 122, '2014-03-15 01:03:26.000000', 'temperatura', 574.0000, 'ºC'),
	(261443, 122, '2014-03-15 01:03:27.000000', 'temperatura', 956.0000, 'ºC'),
	(261444, 122, '2014-03-15 01:03:28.000000', 'temperatura', 656.0000, 'ºC'),
	(261445, 122, '2014-03-15 01:03:29.000000', 'temperatura', 414.0000, 'ºC'),
	(261446, 122, '2014-03-15 01:03:30.000000', 'temperatura', 104.0000, 'ºC'),
	(261447, 122, '2014-03-15 01:03:31.000000', 'temperatura', 476.0000, 'ºC'),
	(261448, 122, '2014-03-15 01:03:32.000000', 'temperatura', 870.0000, 'ºC'),
	(261449, 122, '2014-03-15 01:03:33.000000', 'temperatura', 523.0000, 'ºC'),
	(261450, 122, '2014-03-15 01:03:34.000000', 'temperatura', 6.0000, 'ºC'),
	(261451, 122, '2014-03-15 01:03:35.000000', 'temperatura', 863.0000, 'ºC'),
	(261452, 122, '2014-03-15 01:03:36.000000', 'temperatura', 695.0000, 'ºC'),
	(261453, 122, '2014-03-15 01:03:37.000000', 'temperatura', 887.0000, 'ºC'),
	(261454, 122, '2014-03-15 01:03:38.000000', 'temperatura', 1151.0000, 'ºC'),
	(261455, 122, '2014-03-15 01:03:39.000000', 'temperatura', 693.0000, 'ºC'),
	(261456, 122, '2014-03-15 01:03:40.000000', 'temperatura', 13.0000, 'ºC'),
	(261457, 122, '2014-03-15 01:03:41.000000', 'temperatura', 387.0000, 'ºC'),
	(261458, 122, '2014-03-15 01:03:42.000000', 'temperatura', 694.0000, 'ºC'),
	(261459, 122, '2014-03-15 01:03:43.000000', 'temperatura', 1113.0000, 'ºC'),
	(261460, 122, '2014-03-15 01:03:44.000000', 'temperatura', 1082.0000, 'ºC'),
	(261461, 122, '2014-03-15 01:03:45.000000', 'temperatura', 870.0000, 'ºC'),
	(261462, 122, '2014-03-15 01:03:46.000000', 'temperatura', 1107.0000, 'ºC'),
	(261463, 122, '2014-03-15 01:03:47.000000', 'temperatura', 525.0000, 'ºC'),
	(261464, 122, '2014-03-15 01:03:48.000000', 'temperatura', 506.0000, 'ºC'),
	(261465, 122, '2014-03-15 01:03:49.000000', 'temperatura', 952.0000, 'ºC'),
	(261466, 122, '2014-03-15 01:03:50.000000', 'temperatura', 846.0000, 'ºC'),
	(261467, 122, '2014-03-15 01:03:51.000000', 'temperatura', 173.0000, 'ºC'),
	(261468, 122, '2014-03-15 01:03:52.000000', 'temperatura', 729.0000, 'ºC'),
	(261469, 122, '2014-03-15 01:03:53.000000', 'temperatura', 725.0000, 'ºC'),
	(261470, 122, '2014-03-15 01:03:54.000000', 'temperatura', 239.0000, 'ºC'),
	(261471, 122, '2014-03-15 01:03:55.000000', 'temperatura', 220.0000, 'ºC'),
	(261472, 122, '2014-03-15 01:03:56.000000', 'temperatura', 384.0000, 'ºC'),
	(261473, 122, '2014-03-15 01:03:57.000000', 'temperatura', 59.0000, 'ºC'),
	(261474, 122, '2014-03-15 01:03:58.000000', 'temperatura', 344.0000, 'ºC'),
	(261475, 122, '2014-03-15 01:03:59.000000', 'temperatura', 346.0000, 'ºC'),
	(261476, 122, '2014-03-15 01:04:00.000000', 'temperatura', 696.0000, 'ºC'),
	(261477, 122, '2014-03-15 01:04:01.000000', 'temperatura', 43.0000, 'ºC'),
	(261478, 122, '2014-03-15 01:04:02.000000', 'temperatura', 526.0000, 'ºC'),
	(261479, 122, '2014-03-15 01:04:03.000000', 'temperatura', 101.0000, 'ºC'),
	(261480, 122, '2014-03-15 01:04:04.000000', 'temperatura', 127.0000, 'ºC'),
	(261481, 122, '2014-03-15 01:04:05.000000', 'temperatura', 332.0000, 'ºC'),
	(261482, 122, '2014-03-15 01:04:06.000000', 'temperatura', 79.0000, 'ºC'),
	(261483, 122, '2014-03-15 01:04:07.000000', 'temperatura', 601.0000, 'ºC'),
	(261484, 122, '2014-03-15 01:04:08.000000', 'temperatura', 369.0000, 'ºC'),
	(261485, 122, '2014-03-15 01:04:09.000000', 'temperatura', 40.0000, 'ºC'),
	(261486, 122, '2014-03-15 01:04:10.000000', 'temperatura', 297.0000, 'ºC'),
	(261487, 122, '2014-03-15 01:04:11.000000', 'temperatura', 163.0000, 'ºC'),
	(261488, 122, '2014-03-15 01:04:12.000000', 'temperatura', 1124.0000, 'ºC'),
	(261489, 122, '2014-03-15 01:04:13.000000', 'temperatura', 332.0000, 'ºC'),
	(261490, 122, '2014-03-15 01:04:14.000000', 'temperatura', 688.0000, 'ºC'),
	(261491, 122, '2014-03-15 01:04:15.000000', 'temperatura', 43.0000, 'ºC'),
	(261492, 122, '2014-03-15 01:04:16.000000', 'temperatura', 554.0000, 'ºC'),
	(261493, 122, '2014-03-15 01:04:17.000000', 'temperatura', 241.0000, 'ºC'),
	(261494, 122, '2014-03-15 01:04:18.000000', 'temperatura', 741.0000, 'ºC'),
	(261495, 122, '2014-03-15 01:04:19.000000', 'temperatura', 586.0000, 'ºC'),
	(261496, 122, '2014-03-15 01:04:20.000000', 'temperatura', 706.0000, 'ºC'),
	(261497, 122, '2014-03-15 01:04:21.000000', 'temperatura', 571.0000, 'ºC'),
	(261498, 122, '2014-03-15 01:04:22.000000', 'temperatura', 738.0000, 'ºC'),
	(261499, 122, '2014-03-15 01:04:23.000000', 'temperatura', 776.0000, 'ºC'),
	(261500, 122, '2014-03-15 01:04:24.000000', 'temperatura', 469.0000, 'ºC'),
	(261501, 122, '2014-03-15 01:04:25.000000', 'temperatura', 17.0000, 'ºC'),
	(261502, 122, '2014-03-15 01:04:26.000000', 'temperatura', 1079.0000, 'ºC'),
	(261503, 122, '2014-03-15 01:04:27.000000', 'temperatura', 542.0000, 'ºC'),
	(261504, 122, '2014-03-15 01:04:28.000000', 'temperatura', 676.0000, 'ºC'),
	(261505, 122, '2014-03-15 01:04:29.000000', 'temperatura', 555.0000, 'ºC'),
	(261506, 122, '2014-03-15 01:04:30.000000', 'temperatura', 745.0000, 'ºC'),
	(261507, 122, '2014-03-15 01:04:31.000000', 'temperatura', 860.0000, 'ºC'),
	(261508, 122, '2014-03-15 01:04:32.000000', 'temperatura', 867.0000, 'ºC'),
	(261509, 122, '2014-03-15 01:04:33.000000', 'temperatura', 555.0000, 'ºC'),
	(261510, 122, '2014-03-15 01:04:34.000000', 'temperatura', 175.0000, 'ºC'),
	(261511, 122, '2014-03-15 01:04:35.000000', 'temperatura', 412.0000, 'ºC'),
	(261512, 122, '2014-03-15 01:04:36.000000', 'temperatura', 333.0000, 'ºC'),
	(261513, 122, '2014-03-15 01:04:37.000000', 'temperatura', 432.0000, 'ºC'),
	(261514, 122, '2014-03-15 01:04:38.000000', 'temperatura', 1160.0000, 'ºC'),
	(261515, 122, '2014-03-15 01:04:39.000000', 'temperatura', 906.0000, 'ºC'),
	(261516, 122, '2014-03-15 01:04:40.000000', 'temperatura', 1049.0000, 'ºC'),
	(261517, 122, '2014-03-15 01:04:41.000000', 'temperatura', 129.0000, 'ºC'),
	(261518, 122, '2014-03-15 01:04:42.000000', 'temperatura', 1097.0000, 'ºC'),
	(261519, 122, '2014-03-15 01:04:43.000000', 'temperatura', 299.0000, 'ºC'),
	(261520, 122, '2014-03-15 01:04:44.000000', 'temperatura', 605.0000, 'ºC'),
	(261521, 122, '2014-03-15 01:04:45.000000', 'temperatura', 929.0000, 'ºC'),
	(261522, 122, '2014-03-15 01:04:46.000000', 'temperatura', 430.0000, 'ºC'),
	(261523, 122, '2014-03-15 01:04:47.000000', 'temperatura', 564.0000, 'ºC'),
	(261524, 122, '2014-03-15 01:04:48.000000', 'temperatura', 330.0000, 'ºC'),
	(261525, 122, '2014-03-15 01:04:49.000000', 'temperatura', 1160.0000, 'ºC'),
	(261526, 122, '2014-03-15 01:04:50.000000', 'temperatura', 9.0000, 'ºC'),
	(261527, 122, '2014-03-15 01:04:51.000000', 'temperatura', 166.0000, 'ºC'),
	(261528, 122, '2014-03-15 01:04:52.000000', 'temperatura', 802.0000, 'ºC'),
	(261529, 122, '2014-03-15 01:04:53.000000', 'temperatura', 1112.0000, 'ºC'),
	(261530, 122, '2014-03-15 01:04:54.000000', 'temperatura', 757.0000, 'ºC'),
	(261531, 122, '2014-03-15 01:04:55.000000', 'temperatura', 448.0000, 'ºC'),
	(261532, 122, '2014-03-15 01:04:56.000000', 'temperatura', 1169.0000, 'ºC'),
	(261533, 122, '2014-03-15 01:04:57.000000', 'temperatura', 901.0000, 'ºC'),
	(261534, 122, '2014-03-15 01:04:58.000000', 'temperatura', 997.0000, 'ºC'),
	(261535, 122, '2014-03-15 01:04:59.000000', 'temperatura', 1086.0000, 'ºC'),
	(261536, 122, '2014-03-15 01:05:00.000000', 'temperatura', 37.0000, 'ºC'),
	(261537, 122, '2014-03-15 01:05:01.000000', 'temperatura', 528.0000, 'ºC'),
	(261538, 122, '2014-03-15 01:05:02.000000', 'temperatura', 129.0000, 'ºC'),
	(261539, 122, '2014-03-15 01:05:03.000000', 'temperatura', 264.0000, 'ºC'),
	(261540, 122, '2014-03-15 01:05:04.000000', 'temperatura', 931.0000, 'ºC'),
	(261541, 122, '2014-03-15 01:05:05.000000', 'temperatura', 263.0000, 'ºC'),
	(261542, 122, '2014-03-15 01:05:06.000000', 'temperatura', 922.0000, 'ºC'),
	(261543, 122, '2014-03-15 01:05:07.000000', 'temperatura', 223.0000, 'ºC'),
	(261544, 122, '2014-03-15 01:05:08.000000', 'temperatura', 749.0000, 'ºC'),
	(261545, 122, '2014-03-15 01:05:09.000000', 'temperatura', 679.0000, 'ºC'),
	(261546, 118, '2014-04-01 00:00:00.000000', 'temperatura', 89.0000, 'ºC'),
	(261547, 118, '2014-04-01 00:00:01.000000', 'temperatura', 609.0000, 'ºC'),
	(261548, 118, '2014-04-01 00:00:02.000000', 'temperatura', 382.0000, 'ºC'),
	(261549, 118, '2014-04-01 00:00:03.000000', 'temperatura', 80.0000, 'ºC'),
	(261550, 118, '2014-04-01 00:00:04.000000', 'temperatura', 456.0000, 'ºC'),
	(261551, 118, '2014-04-01 00:00:05.000000', 'temperatura', 842.0000, 'ºC'),
	(261552, 118, '2014-04-01 00:00:06.000000', 'temperatura', 443.0000, 'ºC'),
	(261553, 118, '2014-04-01 00:00:07.000000', 'temperatura', 887.0000, 'ºC'),
	(261554, 118, '2014-04-01 00:00:08.000000', 'temperatura', 706.0000, 'ºC'),
	(261555, 118, '2014-04-01 00:00:09.000000', 'temperatura', 871.0000, 'ºC'),
	(261556, 118, '2014-04-01 00:00:10.000000', 'temperatura', 1036.0000, 'ºC'),
	(261557, 118, '2014-04-01 00:00:11.000000', 'temperatura', 170.0000, 'ºC'),
	(261558, 118, '2014-04-01 00:00:12.000000', 'temperatura', 142.0000, 'ºC'),
	(261559, 118, '2014-04-01 00:00:13.000000', 'temperatura', 201.0000, 'ºC'),
	(261560, 118, '2014-04-01 00:00:14.000000', 'temperatura', 579.0000, 'ºC'),
	(261561, 118, '2014-04-01 00:00:15.000000', 'temperatura', 1092.0000, 'ºC'),
	(261562, 118, '2014-04-01 00:00:16.000000', 'temperatura', 126.0000, 'ºC'),
	(261563, 118, '2014-04-01 00:00:17.000000', 'temperatura', 951.0000, 'ºC'),
	(261564, 118, '2014-04-01 00:00:18.000000', 'temperatura', 778.0000, 'ºC'),
	(261565, 118, '2014-04-01 00:00:19.000000', 'temperatura', 1038.0000, 'ºC'),
	(261566, 118, '2014-04-01 00:00:20.000000', 'temperatura', 457.0000, 'ºC'),
	(261567, 118, '2014-04-01 00:00:21.000000', 'temperatura', 371.0000, 'ºC'),
	(261568, 118, '2014-04-01 00:00:22.000000', 'temperatura', 484.0000, 'ºC'),
	(261569, 118, '2014-04-01 00:00:23.000000', 'temperatura', 108.0000, 'ºC'),
	(261570, 118, '2014-04-01 00:00:24.000000', 'temperatura', 290.0000, 'ºC'),
	(261571, 118, '2014-04-01 00:00:25.000000', 'temperatura', 1123.0000, 'ºC'),
	(261572, 118, '2014-04-01 00:00:26.000000', 'temperatura', 1149.0000, 'ºC'),
	(261573, 118, '2014-04-01 00:00:27.000000', 'temperatura', 1173.0000, 'ºC'),
	(261574, 118, '2014-04-01 00:00:28.000000', 'temperatura', 20.0000, 'ºC'),
	(261575, 118, '2014-04-01 00:00:29.000000', 'temperatura', 184.0000, 'ºC'),
	(261576, 118, '2014-04-01 00:00:30.000000', 'temperatura', 857.0000, 'ºC'),
	(261577, 118, '2014-04-01 00:00:31.000000', 'temperatura', 135.0000, 'ºC'),
	(261578, 118, '2014-04-01 00:00:32.000000', 'temperatura', 502.0000, 'ºC'),
	(261579, 118, '2014-04-01 00:00:33.000000', 'temperatura', 909.0000, 'ºC'),
	(261580, 118, '2014-04-01 00:00:34.000000', 'temperatura', 636.0000, 'ºC'),
	(261581, 118, '2014-04-01 00:00:35.000000', 'temperatura', 457.0000, 'ºC'),
	(261582, 118, '2014-04-01 00:00:36.000000', 'temperatura', 374.0000, 'ºC'),
	(261583, 118, '2014-04-01 00:00:37.000000', 'temperatura', 503.0000, 'ºC'),
	(261584, 118, '2014-04-01 00:00:38.000000', 'temperatura', 190.0000, 'ºC'),
	(261585, 118, '2014-04-01 00:00:39.000000', 'temperatura', 645.0000, 'ºC'),
	(261586, 118, '2014-04-01 00:00:40.000000', 'temperatura', 252.0000, 'ºC'),
	(261587, 118, '2014-04-01 00:00:41.000000', 'temperatura', 529.0000, 'ºC'),
	(261588, 118, '2014-04-01 00:00:42.000000', 'temperatura', 687.0000, 'ºC'),
	(261589, 118, '2014-04-01 00:00:43.000000', 'temperatura', 647.0000, 'ºC'),
	(261590, 118, '2014-04-01 00:00:44.000000', 'temperatura', 1178.0000, 'ºC'),
	(261591, 118, '2014-04-01 00:00:45.000000', 'temperatura', 347.0000, 'ºC'),
	(261592, 118, '2014-04-01 00:00:46.000000', 'temperatura', 603.0000, 'ºC'),
	(261593, 118, '2014-04-01 00:00:47.000000', 'temperatura', 772.0000, 'ºC'),
	(261594, 118, '2014-04-01 00:00:48.000000', 'temperatura', 854.0000, 'ºC'),
	(261595, 118, '2014-04-01 00:00:49.000000', 'temperatura', 753.0000, 'ºC'),
	(261596, 118, '2014-04-01 00:00:50.000000', 'temperatura', 5.0000, 'ºC'),
	(261597, 118, '2014-04-01 00:00:51.000000', 'temperatura', 167.0000, 'ºC'),
	(261598, 118, '2014-04-01 00:00:52.000000', 'temperatura', 821.0000, 'ºC'),
	(261599, 118, '2014-04-01 00:00:53.000000', 'temperatura', 4.0000, 'ºC'),
	(261600, 118, '2014-04-01 00:00:54.000000', 'temperatura', 1156.0000, 'ºC'),
	(261601, 118, '2014-04-01 00:00:55.000000', 'temperatura', 968.0000, 'ºC'),
	(261602, 118, '2014-04-01 00:00:56.000000', 'temperatura', 173.0000, 'ºC'),
	(261603, 118, '2014-04-01 00:00:57.000000', 'temperatura', 363.0000, 'ºC'),
	(261604, 118, '2014-04-01 00:00:58.000000', 'temperatura', 95.0000, 'ºC'),
	(261605, 118, '2014-04-01 00:00:59.000000', 'temperatura', 587.0000, 'ºC'),
	(261606, 118, '2014-04-01 00:01:00.000000', 'temperatura', 249.0000, 'ºC'),
	(261607, 118, '2014-04-01 00:01:01.000000', 'temperatura', 685.0000, 'ºC'),
	(261608, 118, '2014-04-01 00:01:02.000000', 'temperatura', 279.0000, 'ºC'),
	(261609, 118, '2014-04-01 00:01:03.000000', 'temperatura', 538.0000, 'ºC'),
	(261610, 118, '2014-04-01 00:01:04.000000', 'temperatura', 657.0000, 'ºC'),
	(261611, 118, '2014-04-01 00:01:05.000000', 'temperatura', 470.0000, 'ºC'),
	(261612, 118, '2014-04-01 00:01:06.000000', 'temperatura', 381.0000, 'ºC'),
	(261613, 118, '2014-04-01 00:01:07.000000', 'temperatura', 495.0000, 'ºC'),
	(261614, 118, '2014-04-01 00:01:08.000000', 'temperatura', 133.0000, 'ºC'),
	(261615, 118, '2014-04-01 00:01:09.000000', 'temperatura', 381.0000, 'ºC'),
	(261616, 118, '2014-04-01 00:01:10.000000', 'temperatura', 305.0000, 'ºC'),
	(261617, 118, '2014-04-01 00:01:11.000000', 'temperatura', 382.0000, 'ºC'),
	(261618, 118, '2014-04-01 00:01:12.000000', 'temperatura', 998.0000, 'ºC'),
	(261619, 118, '2014-04-01 00:01:13.000000', 'temperatura', 244.0000, 'ºC'),
	(261620, 118, '2014-04-01 00:01:14.000000', 'temperatura', 628.0000, 'ºC'),
	(261621, 118, '2014-04-01 00:01:15.000000', 'temperatura', 7.0000, 'ºC'),
	(261622, 118, '2014-04-01 00:01:16.000000', 'temperatura', 553.0000, 'ºC'),
	(261623, 118, '2014-04-01 00:01:17.000000', 'temperatura', 345.0000, 'ºC'),
	(261624, 118, '2014-04-01 00:01:18.000000', 'temperatura', 66.0000, 'ºC'),
	(261625, 118, '2014-04-01 00:01:19.000000', 'temperatura', 495.0000, 'ºC'),
	(261626, 118, '2014-04-01 00:01:20.000000', 'temperatura', 1077.0000, 'ºC'),
	(261627, 118, '2014-04-01 00:01:21.000000', 'temperatura', 303.0000, 'ºC'),
	(261628, 118, '2014-04-01 00:01:22.000000', 'temperatura', 682.0000, 'ºC'),
	(261629, 118, '2014-04-01 00:01:23.000000', 'temperatura', 100.0000, 'ºC'),
	(261630, 118, '2014-04-01 00:01:24.000000', 'temperatura', 857.0000, 'ºC'),
	(261631, 118, '2014-04-01 00:01:25.000000', 'temperatura', 386.0000, 'ºC'),
	(261632, 118, '2014-04-01 00:01:26.000000', 'temperatura', 560.0000, 'ºC'),
	(261633, 118, '2014-04-01 00:01:27.000000', 'temperatura', 441.0000, 'ºC'),
	(261634, 118, '2014-04-01 00:01:28.000000', 'temperatura', 527.0000, 'ºC'),
	(261635, 118, '2014-04-01 00:01:29.000000', 'temperatura', 113.0000, 'ºC'),
	(261636, 118, '2014-04-01 00:01:30.000000', 'temperatura', 183.0000, 'ºC'),
	(261637, 118, '2014-04-01 00:01:31.000000', 'temperatura', 577.0000, 'ºC'),
	(261638, 118, '2014-04-01 00:01:32.000000', 'temperatura', 1139.0000, 'ºC'),
	(261639, 118, '2014-04-01 00:01:33.000000', 'temperatura', 361.0000, 'ºC'),
	(261640, 118, '2014-04-01 00:01:34.000000', 'temperatura', 789.0000, 'ºC'),
	(261641, 118, '2014-04-01 00:01:35.000000', 'temperatura', 465.0000, 'ºC'),
	(261642, 118, '2014-04-01 00:01:36.000000', 'temperatura', 1157.0000, 'ºC'),
	(261643, 118, '2014-04-01 00:01:37.000000', 'temperatura', 790.0000, 'ºC'),
	(261644, 118, '2014-04-01 00:01:38.000000', 'temperatura', 481.0000, 'ºC'),
	(261645, 118, '2014-04-01 00:01:39.000000', 'temperatura', 34.0000, 'ºC'),
	(261646, 118, '2014-04-01 00:01:40.000000', 'temperatura', 1129.0000, 'ºC'),
	(261647, 118, '2014-04-01 00:01:41.000000', 'temperatura', 742.0000, 'ºC'),
	(261648, 118, '2014-04-01 00:01:42.000000', 'temperatura', 325.0000, 'ºC'),
	(261649, 118, '2014-04-01 00:01:43.000000', 'temperatura', 598.0000, 'ºC'),
	(261650, 118, '2014-04-01 00:01:44.000000', 'temperatura', 816.0000, 'ºC'),
	(261651, 118, '2014-04-01 00:01:45.000000', 'temperatura', 1085.0000, 'ºC'),
	(261652, 118, '2014-04-01 00:01:46.000000', 'temperatura', 580.0000, 'ºC'),
	(261653, 118, '2014-04-01 00:01:47.000000', 'temperatura', 844.0000, 'ºC'),
	(261654, 118, '2014-04-01 00:01:48.000000', 'temperatura', 82.0000, 'ºC'),
	(261655, 118, '2014-04-01 00:01:49.000000', 'temperatura', 276.0000, 'ºC'),
	(261656, 118, '2014-04-01 00:01:50.000000', 'temperatura', 1136.0000, 'ºC'),
	(261657, 118, '2014-04-01 00:01:51.000000', 'temperatura', 51.0000, 'ºC'),
	(261658, 118, '2014-04-01 00:01:52.000000', 'temperatura', 450.0000, 'ºC'),
	(261659, 118, '2014-04-01 00:01:53.000000', 'temperatura', 897.0000, 'ºC'),
	(261660, 118, '2014-04-01 00:01:54.000000', 'temperatura', 736.0000, 'ºC'),
	(261661, 118, '2014-04-01 00:01:55.000000', 'temperatura', 990.0000, 'ºC'),
	(261662, 118, '2014-04-01 00:01:56.000000', 'temperatura', 340.0000, 'ºC'),
	(261663, 118, '2014-04-01 00:01:57.000000', 'temperatura', 1130.0000, 'ºC'),
	(261664, 118, '2014-04-01 00:01:58.000000', 'temperatura', 1033.0000, 'ºC'),
	(261665, 118, '2014-04-01 00:01:59.000000', 'temperatura', 577.0000, 'ºC'),
	(261666, 118, '2014-04-01 00:02:00.000000', 'temperatura', 984.0000, 'ºC'),
	(261667, 118, '2014-04-01 00:02:01.000000', 'temperatura', 788.0000, 'ºC'),
	(261668, 118, '2014-04-01 00:02:02.000000', 'temperatura', 991.0000, 'ºC'),
	(261669, 118, '2014-04-01 00:02:03.000000', 'temperatura', 193.0000, 'ºC'),
	(261670, 118, '2014-04-01 00:02:04.000000', 'temperatura', 389.0000, 'ºC'),
	(261671, 118, '2014-04-01 00:02:05.000000', 'temperatura', 167.0000, 'ºC'),
	(261672, 118, '2014-04-01 00:02:06.000000', 'temperatura', 870.0000, 'ºC'),
	(261673, 118, '2014-04-01 00:02:07.000000', 'temperatura', 248.0000, 'ºC'),
	(261674, 118, '2014-04-01 00:02:08.000000', 'temperatura', 1032.0000, 'ºC'),
	(261675, 118, '2014-04-01 00:02:09.000000', 'temperatura', 815.0000, 'ºC'),
	(261676, 118, '2014-04-01 00:02:10.000000', 'temperatura', 979.0000, 'ºC'),
	(261677, 118, '2014-04-01 00:02:11.000000', 'temperatura', 51.0000, 'ºC'),
	(261678, 118, '2014-04-01 00:02:12.000000', 'temperatura', 918.0000, 'ºC'),
	(261679, 118, '2014-04-01 00:02:13.000000', 'temperatura', 839.0000, 'ºC'),
	(261680, 118, '2014-04-01 00:02:14.000000', 'temperatura', 239.0000, 'ºC'),
	(261681, 118, '2014-04-01 00:02:15.000000', 'temperatura', 1081.0000, 'ºC'),
	(261682, 118, '2014-04-01 00:02:16.000000', 'temperatura', 1089.0000, 'ºC'),
	(261683, 118, '2014-04-01 00:02:17.000000', 'temperatura', 1000.0000, 'ºC'),
	(261684, 118, '2014-04-01 00:02:18.000000', 'temperatura', 535.0000, 'ºC'),
	(261685, 118, '2014-04-01 00:02:19.000000', 'temperatura', 876.0000, 'ºC'),
	(261686, 118, '2014-04-01 00:02:20.000000', 'temperatura', 377.0000, 'ºC'),
	(261687, 118, '2014-04-01 00:02:21.000000', 'temperatura', 456.0000, 'ºC'),
	(261688, 118, '2014-04-01 00:02:22.000000', 'temperatura', 1150.0000, 'ºC'),
	(261689, 118, '2014-04-01 00:02:23.000000', 'temperatura', 783.0000, 'ºC'),
	(261690, 118, '2014-04-01 00:02:24.000000', 'temperatura', 467.0000, 'ºC'),
	(261691, 118, '2014-04-01 00:02:25.000000', 'temperatura', 1184.0000, 'ºC'),
	(261692, 118, '2014-04-01 00:02:26.000000', 'temperatura', 922.0000, 'ºC'),
	(261693, 118, '2014-04-01 00:02:27.000000', 'temperatura', 1059.0000, 'ºC'),
	(261694, 118, '2014-04-01 00:02:28.000000', 'temperatura', 127.0000, 'ºC'),
	(261695, 118, '2014-04-01 00:02:29.000000', 'temperatura', 1059.0000, 'ºC'),
	(261696, 118, '2014-04-01 00:02:30.000000', 'temperatura', 116.0000, 'ºC'),
	(261697, 118, '2014-04-01 00:02:31.000000', 'temperatura', 1001.0000, 'ºC'),
	(261698, 118, '2014-04-01 00:02:32.000000', 'temperatura', 1059.0000, 'ºC'),
	(261699, 118, '2014-04-01 00:02:33.000000', 'temperatura', 1091.0000, 'ºC'),
	(261700, 118, '2014-04-01 00:02:34.000000', 'temperatura', 1079.0000, 'ºC'),
	(261701, 118, '2014-04-01 00:02:35.000000', 'temperatura', 924.0000, 'ºC'),
	(261702, 118, '2014-04-01 00:02:36.000000', 'temperatura', 182.0000, 'ºC'),
	(261703, 118, '2014-04-01 00:02:37.000000', 'temperatura', 539.0000, 'ºC'),
	(261704, 118, '2014-04-01 00:02:38.000000', 'temperatura', 948.0000, 'ºC'),
	(261705, 118, '2014-04-01 00:02:39.000000', 'temperatura', 725.0000, 'ºC'),
	(261706, 118, '2014-04-01 00:02:40.000000', 'temperatura', 780.0000, 'ºC'),
	(261707, 118, '2014-04-01 00:02:41.000000', 'temperatura', 528.0000, 'ºC'),
	(261708, 118, '2014-04-01 00:02:42.000000', 'temperatura', 300.0000, 'ºC'),
	(261709, 118, '2014-04-01 00:02:43.000000', 'temperatura', 1117.0000, 'ºC'),
	(261710, 118, '2014-04-01 00:02:44.000000', 'temperatura', 1084.0000, 'ºC'),
	(261711, 118, '2014-04-01 00:02:45.000000', 'temperatura', 872.0000, 'ºC'),
	(261712, 118, '2014-04-01 00:02:46.000000', 'temperatura', 1105.0000, 'ºC'),
	(261713, 118, '2014-04-01 00:02:47.000000', 'temperatura', 512.0000, 'ºC'),
	(261714, 118, '2014-04-01 00:02:48.000000', 'temperatura', 443.0000, 'ºC'),
	(261715, 118, '2014-04-01 00:02:49.000000', 'temperatura', 681.0000, 'ºC'),
	(261716, 118, '2014-04-01 00:02:50.000000', 'temperatura', 875.0000, 'ºC'),
	(261717, 118, '2014-04-01 00:02:51.000000', 'temperatura', 1134.0000, 'ºC'),
	(261718, 118, '2014-04-01 00:02:52.000000', 'temperatura', 645.0000, 'ºC'),
	(261719, 118, '2014-04-01 00:02:53.000000', 'temperatura', 1025.0000, 'ºC'),
	(261720, 118, '2014-04-01 00:02:54.000000', 'temperatura', 791.0000, 'ºC'),
	(261721, 118, '2014-04-01 00:02:55.000000', 'temperatura', 878.0000, 'ºC'),
	(261722, 118, '2014-04-01 00:02:56.000000', 'temperatura', 817.0000, 'ºC'),
	(261723, 118, '2014-04-01 00:02:57.000000', 'temperatura', 253.0000, 'ºC'),
	(261724, 118, '2014-04-01 00:02:58.000000', 'temperatura', 15.0000, 'ºC'),
	(261725, 118, '2014-04-01 00:02:59.000000', 'temperatura', 514.0000, 'ºC'),
	(261726, 118, '2014-04-01 00:03:00.000000', 'temperatura', 126.0000, 'ºC'),
	(261727, 118, '2014-04-01 00:03:01.000000', 'temperatura', 289.0000, 'ºC'),
	(261728, 118, '2014-04-01 00:03:02.000000', 'temperatura', 1070.0000, 'ºC'),
	(261729, 118, '2014-04-01 00:03:03.000000', 'temperatura', 880.0000, 'ºC'),
	(261730, 118, '2014-04-01 00:03:04.000000', 'temperatura', 1193.0000, 'ºC'),
	(261731, 118, '2014-04-01 00:03:05.000000', 'temperatura', 926.0000, 'ºC'),
	(261732, 118, '2014-04-01 00:03:06.000000', 'temperatura', 1051.0000, 'ºC'),
	(261733, 118, '2014-04-01 00:03:07.000000', 'temperatura', 77.0000, 'ºC'),
	(261734, 118, '2014-04-01 00:03:08.000000', 'temperatura', 831.0000, 'ºC'),
	(261735, 118, '2014-04-01 00:03:09.000000', 'temperatura', 324.0000, 'ºC'),
	(261736, 118, '2014-04-01 00:03:10.000000', 'temperatura', 329.0000, 'ºC'),
	(261737, 118, '2014-04-01 00:03:11.000000', 'temperatura', 674.0000, 'ºC'),
	(261738, 118, '2014-04-01 00:03:12.000000', 'temperatura', 1183.0000, 'ºC'),
	(261739, 118, '2014-04-01 00:03:13.000000', 'temperatura', 294.0000, 'ºC'),
	(261740, 118, '2014-04-01 00:03:14.000000', 'temperatura', 320.0000, 'ºC'),
	(261741, 118, '2014-04-01 00:03:15.000000', 'temperatura', 720.0000, 'ºC'),
	(261742, 118, '2014-04-01 00:03:16.000000', 'temperatura', 242.0000, 'ºC'),
	(261743, 118, '2014-04-01 00:03:17.000000', 'temperatura', 248.0000, 'ºC'),
	(261744, 118, '2014-04-01 00:03:18.000000', 'temperatura', 517.0000, 'ºC'),
	(261745, 118, '2014-04-01 00:03:19.000000', 'temperatura', 642.0000, 'ºC'),
	(261746, 118, '2014-04-01 00:03:20.000000', 'temperatura', 456.0000, 'ºC'),
	(261747, 118, '2014-04-01 00:03:21.000000', 'temperatura', 358.0000, 'ºC'),
	(261748, 118, '2014-04-01 00:03:22.000000', 'temperatura', 422.0000, 'ºC'),
	(261749, 118, '2014-04-01 00:03:23.000000', 'temperatura', 1037.0000, 'ºC'),
	(261750, 118, '2014-04-01 00:03:24.000000', 'temperatura', 317.0000, 'ºC'),
	(261751, 118, '2014-04-01 00:03:25.000000', 'temperatura', 874.0000, 'ºC'),
	(261752, 118, '2014-04-01 00:03:26.000000', 'temperatura', 1022.0000, 'ºC'),
	(261753, 118, '2014-04-01 00:03:27.000000', 'temperatura', 87.0000, 'ºC'),
	(261754, 118, '2014-04-01 00:03:28.000000', 'temperatura', 969.0000, 'ºC'),
	(261755, 118, '2014-04-01 00:03:29.000000', 'temperatura', 987.0000, 'ºC'),
	(261756, 118, '2014-04-01 00:03:30.000000', 'temperatura', 826.0000, 'ºC'),
	(261757, 118, '2014-04-01 00:03:31.000000', 'temperatura', 1172.0000, 'ºC'),
	(261758, 118, '2014-04-01 00:03:32.000000', 'temperatura', 983.0000, 'ºC'),
	(261759, 118, '2014-04-01 00:03:33.000000', 'temperatura', 198.0000, 'ºC'),
	(261760, 118, '2014-04-01 00:03:34.000000', 'temperatura', 441.0000, 'ºC'),
	(261761, 118, '2014-04-01 00:03:35.000000', 'temperatura', 412.0000, 'ºC'),
	(261762, 118, '2014-04-01 00:03:36.000000', 'temperatura', 738.0000, 'ºC'),
	(261763, 118, '2014-04-01 00:03:37.000000', 'temperatura', 53.0000, 'ºC'),
	(261764, 118, '2014-04-01 00:03:38.000000', 'temperatura', 453.0000, 'ºC'),
	(261765, 118, '2014-04-01 00:03:39.000000', 'temperatura', 908.0000, 'ºC'),
	(261766, 118, '2014-04-01 00:03:40.000000', 'temperatura', 778.0000, 'ºC'),
	(261767, 118, '2014-04-01 00:03:41.000000', 'temperatura', 1169.0000, 'ºC'),
	(261768, 118, '2014-04-01 00:03:42.000000', 'temperatura', 1111.0000, 'ºC'),
	(261769, 118, '2014-04-01 00:03:43.000000', 'temperatura', 850.0000, 'ºC'),
	(261770, 118, '2014-04-01 00:03:44.000000', 'temperatura', 915.0000, 'ºC'),
	(261771, 118, '2014-04-01 00:03:45.000000', 'temperatura', 824.0000, 'ºC'),
	(261772, 118, '2014-04-01 00:03:46.000000', 'temperatura', 179.0000, 'ºC'),
	(261773, 118, '2014-04-01 00:03:47.000000', 'temperatura', 821.0000, 'ºC'),
	(261774, 118, '2014-04-01 00:03:48.000000', 'temperatura', 1168.0000, 'ºC'),
	(261775, 118, '2014-04-01 00:03:49.000000', 'temperatura', 979.0000, 'ºC'),
	(261776, 118, '2014-04-01 00:03:50.000000', 'temperatura', 192.0000, 'ºC'),
	(261777, 118, '2014-04-01 00:03:51.000000', 'temperatura', 424.0000, 'ºC'),
	(261778, 118, '2014-04-01 00:03:52.000000', 'temperatura', 343.0000, 'ºC'),
	(261779, 118, '2014-04-01 00:03:53.000000', 'temperatura', 445.0000, 'ºC'),
	(261780, 118, '2014-04-01 00:03:54.000000', 'temperatura', 1197.0000, 'ºC'),
	(261781, 118, '2014-04-01 00:03:55.000000', 'temperatura', 1051.0000, 'ºC'),
	(261782, 118, '2014-04-01 00:03:56.000000', 'temperatura', 462.0000, 'ºC'),
	(261783, 118, '2014-04-01 00:03:57.000000', 'temperatura', 357.0000, 'ºC'),
	(261784, 118, '2014-04-01 00:03:58.000000', 'temperatura', 401.0000, 'ºC'),
	(261785, 118, '2014-04-01 00:03:59.000000', 'temperatura', 933.0000, 'ºC'),
	(261786, 118, '2014-04-01 00:04:00.000000', 'temperatura', 1062.0000, 'ºC'),
	(261787, 118, '2014-04-01 00:04:01.000000', 'temperatura', 113.0000, 'ºC'),
	(261788, 118, '2014-04-01 00:04:02.000000', 'temperatura', 981.0000, 'ºC'),
	(261789, 118, '2014-04-01 00:04:03.000000', 'temperatura', 963.0000, 'ºC'),
	(261790, 118, '2014-04-01 00:04:04.000000', 'temperatura', 675.0000, 'ºC'),
	(261791, 118, '2014-04-01 00:04:05.000000', 'temperatura', 485.0000, 'ºC'),
	(261792, 118, '2014-04-01 00:04:06.000000', 'temperatura', 399.0000, 'ºC'),
	(261793, 118, '2014-04-01 00:04:07.000000', 'temperatura', 543.0000, 'ºC'),
	(261794, 118, '2014-04-01 00:04:08.000000', 'temperatura', 318.0000, 'ºC'),
	(261795, 118, '2014-04-01 00:04:09.000000', 'temperatura', 1160.0000, 'ºC'),
	(261796, 118, '2014-04-01 00:04:10.000000', 'temperatura', 48.0000, 'ºC'),
	(261797, 118, '2014-04-01 00:04:11.000000', 'temperatura', 362.0000, 'ºC'),
	(261798, 118, '2014-04-01 00:04:12.000000', 'temperatura', 464.0000, 'ºC'),
	(261799, 118, '2014-04-01 00:04:13.000000', 'temperatura', 35.0000, 'ºC'),
	(261800, 118, '2014-04-01 00:04:14.000000', 'temperatura', 1183.0000, 'ºC'),
	(261801, 118, '2014-04-01 00:04:15.000000', 'temperatura', 1010.0000, 'ºC'),
	(261802, 118, '2014-04-01 00:04:16.000000', 'temperatura', 303.0000, 'ºC'),
	(261803, 118, '2014-04-01 00:04:17.000000', 'temperatura', 883.0000, 'ºC'),
	(261804, 118, '2014-04-01 00:04:18.000000', 'temperatura', 1107.0000, 'ºC'),
	(261805, 118, '2014-04-01 00:04:19.000000', 'temperatura', 489.0000, 'ºC'),
	(261806, 118, '2014-04-01 00:04:20.000000', 'temperatura', 322.0000, 'ºC'),
	(261807, 118, '2014-04-01 00:04:21.000000', 'temperatura', 143.0000, 'ºC'),
	(261808, 118, '2014-04-01 00:04:22.000000', 'temperatura', 951.0000, 'ºC'),
	(261809, 118, '2014-04-01 00:04:23.000000', 'temperatura', 727.0000, 'ºC'),
	(261810, 118, '2014-04-01 00:04:24.000000', 'temperatura', 784.0000, 'ºC'),
	(261811, 118, '2014-04-01 00:04:25.000000', 'temperatura', 537.0000, 'ºC'),
	(261812, 118, '2014-04-01 00:04:26.000000', 'temperatura', 333.0000, 'ºC'),
	(261813, 118, '2014-04-01 00:04:27.000000', 'temperatura', 57.0000, 'ºC'),
	(261814, 118, '2014-04-01 00:04:28.000000', 'temperatura', 483.0000, 'ºC'),
	(261815, 118, '2014-04-01 00:04:29.000000', 'temperatura', 1048.0000, 'ºC'),
	(261816, 118, '2014-04-01 00:04:30.000000', 'temperatura', 190.0000, 'ºC'),
	(261817, 118, '2014-04-01 00:04:31.000000', 'temperatura', 205.0000, 'ºC'),
	(261818, 118, '2014-04-01 00:04:32.000000', 'temperatura', 455.0000, 'ºC'),
	(261819, 118, '2014-04-01 00:04:33.000000', 'temperatura', 464.0000, 'ºC'),
	(261820, 118, '2014-04-01 00:04:34.000000', 'temperatura', 952.0000, 'ºC'),
	(261821, 118, '2014-04-01 00:04:35.000000', 'temperatura', 969.0000, 'ºC'),
	(261822, 118, '2014-04-01 00:04:36.000000', 'temperatura', 790.0000, 'ºC'),
	(261823, 118, '2014-04-01 00:04:37.000000', 'temperatura', 1044.0000, 'ºC'),
	(261824, 118, '2014-04-01 00:04:38.000000', 'temperatura', 450.0000, 'ºC'),
	(261825, 118, '2014-04-01 00:04:39.000000', 'temperatura', 319.0000, 'ºC'),
	(261826, 118, '2014-04-01 00:04:40.000000', 'temperatura', 247.0000, 'ºC'),
	(261827, 118, '2014-04-01 00:04:41.000000', 'temperatura', 277.0000, 'ºC'),
	(261828, 118, '2014-04-01 00:04:42.000000', 'temperatura', 645.0000, 'ºC'),
	(261829, 118, '2014-04-01 00:04:43.000000', 'temperatura', 1192.0000, 'ºC'),
	(261830, 118, '2014-04-01 00:04:44.000000', 'temperatura', 428.0000, 'ºC'),
	(261831, 118, '2014-04-01 00:04:45.000000', 'temperatura', 963.0000, 'ºC'),
	(261832, 118, '2014-04-01 00:04:46.000000', 'temperatura', 1133.0000, 'ºC'),
	(261833, 118, '2014-04-01 00:04:47.000000', 'temperatura', 375.0000, 'ºC'),
	(261834, 118, '2014-04-01 00:04:48.000000', 'temperatura', 878.0000, 'ºC'),
	(261835, 118, '2014-04-01 00:04:49.000000', 'temperatura', 864.0000, 'ºC'),
	(261836, 118, '2014-04-01 00:04:50.000000', 'temperatura', 489.0000, 'ºC'),
	(261837, 118, '2014-04-01 00:04:51.000000', 'temperatura', 1053.0000, 'ºC'),
	(261838, 118, '2014-04-01 00:04:52.000000', 'temperatura', 199.0000, 'ºC'),
	(261839, 118, '2014-04-01 00:04:53.000000', 'temperatura', 235.0000, 'ºC'),
	(261840, 118, '2014-04-01 00:04:54.000000', 'temperatura', 579.0000, 'ºC'),
	(261841, 118, '2014-04-01 00:04:55.000000', 'temperatura', 990.0000, 'ºC'),
	(261842, 118, '2014-04-01 00:04:56.000000', 'temperatura', 813.0000, 'ºC'),
	(261843, 118, '2014-04-01 00:04:57.000000', 'temperatura', 1096.0000, 'ºC'),
	(261844, 118, '2014-04-01 00:04:58.000000', 'temperatura', 642.0000, 'ºC'),
	(261845, 118, '2014-04-01 00:04:59.000000', 'temperatura', 1122.0000, 'ºC'),
	(261846, 118, '2014-04-01 00:05:00.000000', 'temperatura', 85.0000, 'ºC'),
	(261847, 118, '2014-04-01 00:05:01.000000', 'temperatura', 657.0000, 'ºC'),
	(261848, 118, '2014-04-01 00:05:02.000000', 'temperatura', 633.0000, 'ºC'),
	(261849, 118, '2014-04-01 00:05:03.000000', 'temperatura', 1193.0000, 'ºC'),
	(261850, 118, '2014-04-01 00:05:04.000000', 'temperatura', 466.0000, 'ºC'),
	(261851, 118, '2014-04-01 00:05:05.000000', 'temperatura', 1152.0000, 'ºC'),
	(261852, 118, '2014-04-01 00:05:06.000000', 'temperatura', 765.0000, 'ºC'),
	(261853, 118, '2014-04-01 00:05:07.000000', 'temperatura', 367.0000, 'ºC'),
	(261854, 118, '2014-04-01 00:05:08.000000', 'temperatura', 739.0000, 'ºC'),
	(261855, 118, '2014-04-01 00:05:09.000000', 'temperatura', 197.0000, 'ºC'),
	(261856, 118, '2014-04-01 00:05:10.000000', 'temperatura', 1168.0000, 'ºC'),
	(261857, 118, '2014-04-01 00:05:11.000000', 'temperatura', 449.0000, 'ºC'),
	(261858, 118, '2014-04-01 00:05:12.000000', 'temperatura', 1143.0000, 'ºC'),
	(261859, 118, '2014-04-01 00:05:13.000000', 'temperatura', 769.0000, 'ºC'),
	(261860, 118, '2014-04-01 00:05:14.000000', 'temperatura', 415.0000, 'ºC'),
	(261861, 118, '2014-04-01 00:05:15.000000', 'temperatura', 967.0000, 'ºC'),
	(261862, 118, '2014-04-01 00:05:16.000000', 'temperatura', 1192.0000, 'ºC'),
	(261863, 118, '2014-04-01 00:05:17.000000', 'temperatura', 662.0000, 'ºC'),
	(261864, 118, '2014-04-01 00:05:18.000000', 'temperatura', 931.0000, 'ºC'),
	(261865, 118, '2014-04-01 00:05:19.000000', 'temperatura', 269.0000, 'ºC'),
	(261866, 118, '2014-04-01 00:05:20.000000', 'temperatura', 952.0000, 'ºC'),
	(261867, 118, '2014-04-01 00:05:21.000000', 'temperatura', 356.0000, 'ºC'),
	(261868, 118, '2014-04-01 00:05:22.000000', 'temperatura', 125.0000, 'ºC'),
	(261869, 118, '2014-04-01 00:05:23.000000', 'temperatura', 755.0000, 'ºC'),
	(261870, 118, '2014-04-01 00:05:24.000000', 'temperatura', 1000.0000, 'ºC'),
	(261871, 118, '2014-04-01 00:05:25.000000', 'temperatura', 336.0000, 'ºC'),
	(261872, 118, '2014-04-01 00:05:26.000000', 'temperatura', 1083.0000, 'ºC'),
	(261873, 118, '2014-04-01 00:05:27.000000', 'temperatura', 804.0000, 'ºC'),
	(261874, 118, '2014-04-01 00:05:28.000000', 'temperatura', 774.0000, 'ºC'),
	(261875, 118, '2014-04-01 00:05:29.000000', 'temperatura', 258.0000, 'ºC'),
	(261876, 118, '2014-04-01 00:05:30.000000', 'temperatura', 167.0000, 'ºC'),
	(261877, 118, '2014-04-01 00:05:31.000000', 'temperatura', 63.0000, 'ºC'),
	(261878, 118, '2014-04-01 00:05:32.000000', 'temperatura', 1014.0000, 'ºC'),
	(261879, 118, '2014-04-01 00:05:33.000000', 'temperatura', 83.0000, 'ºC'),
	(261880, 118, '2014-04-01 00:05:34.000000', 'temperatura', 972.0000, 'ºC'),
	(261881, 118, '2014-04-01 00:05:35.000000', 'temperatura', 1012.0000, 'ºC'),
	(261882, 118, '2014-04-01 00:05:36.000000', 'temperatura', 944.0000, 'ºC'),
	(261883, 118, '2014-04-01 00:05:37.000000', 'temperatura', 483.0000, 'ºC'),
	(261884, 118, '2014-04-01 00:05:38.000000', 'temperatura', 787.0000, 'ºC'),
	(261885, 118, '2014-04-01 00:05:39.000000', 'temperatura', 83.0000, 'ºC'),
	(261886, 118, '2014-04-01 00:05:40.000000', 'temperatura', 456.0000, 'ºC'),
	(261887, 118, '2014-04-01 00:05:41.000000', 'temperatura', 833.0000, 'ºC'),
	(261888, 118, '2014-04-01 00:05:42.000000', 'temperatura', 398.0000, 'ºC'),
	(261889, 118, '2014-04-01 00:05:43.000000', 'temperatura', 691.0000, 'ºC'),
	(261890, 118, '2014-04-01 00:05:44.000000', 'temperatura', 1060.0000, 'ºC'),
	(261891, 118, '2014-04-01 00:05:45.000000', 'temperatura', 828.0000, 'ºC'),
	(261892, 118, '2014-04-01 00:05:46.000000', 'temperatura', 960.0000, 'ºC'),
	(261893, 118, '2014-04-01 00:05:47.000000', 'temperatura', 1117.0000, 'ºC'),
	(261894, 118, '2014-04-01 00:05:48.000000', 'temperatura', 304.0000, 'ºC'),
	(261895, 118, '2014-04-01 00:05:49.000000', 'temperatura', 573.0000, 'ºC'),
	(261896, 118, '2014-04-01 00:05:50.000000', 'temperatura', 750.0000, 'ºC'),
	(261897, 118, '2014-04-01 00:05:51.000000', 'temperatura', 833.0000, 'ºC'),
	(261898, 118, '2014-04-01 00:05:52.000000', 'temperatura', 715.0000, 'ºC'),
	(261899, 118, '2014-04-01 00:05:53.000000', 'temperatura', 1078.0000, 'ºC'),
	(261900, 118, '2014-04-01 00:05:54.000000', 'temperatura', 845.0000, 'ºC'),
	(261901, 118, '2014-04-01 00:05:55.000000', 'temperatura', 991.0000, 'ºC'),
	(261902, 118, '2014-04-01 00:05:56.000000', 'temperatura', 19.0000, 'ºC'),
	(261903, 118, '2014-04-01 00:05:57.000000', 'temperatura', 725.0000, 'ºC'),
	(261904, 118, '2014-04-01 00:05:58.000000', 'temperatura', 1169.0000, 'ºC'),
	(261905, 118, '2014-04-01 00:05:59.000000', 'temperatura', 68.0000, 'ºC'),
	(261906, 118, '2014-04-01 00:06:00.000000', 'temperatura', 434.0000, 'ºC'),
	(261907, 118, '2014-04-01 00:06:01.000000', 'temperatura', 767.0000, 'ºC'),
	(261908, 118, '2014-04-01 00:06:02.000000', 'temperatura', 134.0000, 'ºC'),
	(261909, 118, '2014-04-01 00:06:03.000000', 'temperatura', 767.0000, 'ºC'),
	(261910, 118, '2014-04-01 00:06:04.000000', 'temperatura', 1037.0000, 'ºC'),
	(261911, 118, '2014-04-01 00:06:05.000000', 'temperatura', 483.0000, 'ºC'),
	(261912, 118, '2014-04-01 00:06:06.000000', 'temperatura', 505.0000, 'ºC'),
	(261913, 118, '2014-04-01 00:06:07.000000', 'temperatura', 1075.0000, 'ºC'),
	(261914, 118, '2014-04-01 00:06:08.000000', 'temperatura', 260.0000, 'ºC'),
	(261915, 118, '2014-04-01 00:06:09.000000', 'temperatura', 478.0000, 'ºC'),
	(261916, 118, '2014-04-01 00:06:10.000000', 'temperatura', 409.0000, 'ºC'),
	(261917, 118, '2014-04-01 00:06:11.000000', 'temperatura', 612.0000, 'ºC'),
	(261918, 118, '2014-04-01 00:06:12.000000', 'temperatura', 631.0000, 'ºC'),
	(261919, 118, '2014-04-01 00:06:13.000000', 'temperatura', 122.0000, 'ºC'),
	(261920, 118, '2014-04-01 00:06:14.000000', 'temperatura', 1119.0000, 'ºC'),
	(261921, 118, '2014-04-01 00:06:15.000000', 'temperatura', 427.0000, 'ºC'),
	(261922, 118, '2014-04-01 00:06:16.000000', 'temperatura', 1177.0000, 'ºC'),
	(261923, 118, '2014-04-01 00:06:17.000000', 'temperatura', 1008.0000, 'ºC'),
	(261924, 118, '2014-04-01 00:06:18.000000', 'temperatura', 308.0000, 'ºC'),
	(261925, 118, '2014-04-01 00:06:19.000000', 'temperatura', 918.0000, 'ºC'),
	(261926, 118, '2014-04-01 00:06:20.000000', 'temperatura', 67.0000, 'ºC'),
	(261927, 118, '2014-04-01 00:06:21.000000', 'temperatura', 1181.0000, 'ºC'),
	(261928, 118, '2014-04-01 00:06:22.000000', 'temperatura', 905.0000, 'ºC'),
	(261929, 118, '2014-04-01 00:06:23.000000', 'temperatura', 984.0000, 'ºC'),
	(261930, 118, '2014-04-01 00:06:24.000000', 'temperatura', 1004.0000, 'ºC'),
	(261931, 118, '2014-04-01 00:06:25.000000', 'temperatura', 869.0000, 'ºC'),
	(261932, 118, '2014-04-01 00:06:26.000000', 'temperatura', 134.0000, 'ºC'),
	(261933, 118, '2014-04-01 00:06:27.000000', 'temperatura', 462.0000, 'ºC'),
	(261934, 118, '2014-04-01 00:06:28.000000', 'temperatura', 709.0000, 'ºC'),
	(261935, 118, '2014-04-01 00:06:29.000000', 'temperatura', 958.0000, 'ºC'),
	(261936, 118, '2014-04-01 00:06:30.000000', 'temperatura', 266.0000, 'ºC'),
	(261937, 118, '2014-04-01 00:06:31.000000', 'temperatura', 857.0000, 'ºC'),
	(261938, 118, '2014-04-01 00:06:32.000000', 'temperatura', 1085.0000, 'ºC'),
	(261939, 118, '2014-04-01 00:06:33.000000', 'temperatura', 456.0000, 'ºC'),
	(261940, 118, '2014-04-01 00:06:34.000000', 'temperatura', 223.0000, 'ºC'),
	(261941, 118, '2014-04-01 00:06:35.000000', 'temperatura', 951.0000, 'ºC'),
	(261942, 118, '2014-04-01 00:06:36.000000', 'temperatura', 485.0000, 'ºC'),
	(261943, 118, '2014-04-01 00:06:37.000000', 'temperatura', 773.0000, 'ºC'),
	(261944, 118, '2014-04-01 00:06:38.000000', 'temperatura', 11.0000, 'ºC'),
	(261945, 118, '2014-04-01 00:06:39.000000', 'temperatura', 136.0000, 'ºC'),
	(261946, 118, '2014-04-01 00:06:40.000000', 'temperatura', 646.0000, 'ºC'),
	(261947, 118, '2014-04-01 00:06:41.000000', 'temperatura', 425.0000, 'ºC'),
	(261948, 118, '2014-04-01 00:06:42.000000', 'temperatura', 186.0000, 'ºC'),
	(261949, 118, '2014-04-01 00:06:43.000000', 'temperatura', 858.0000, 'ºC'),
	(261950, 118, '2014-04-01 00:06:44.000000', 'temperatura', 130.0000, 'ºC'),
	(261951, 118, '2014-04-01 00:06:45.000000', 'temperatura', 479.0000, 'ºC'),
	(261952, 118, '2014-04-01 00:06:46.000000', 'temperatura', 803.0000, 'ºC'),
	(261953, 118, '2014-04-01 00:06:47.000000', 'temperatura', 181.0000, 'ºC'),
	(261954, 118, '2014-04-01 00:06:48.000000', 'temperatura', 897.0000, 'ºC'),
	(261955, 118, '2014-04-01 00:06:49.000000', 'temperatura', 340.0000, 'ºC'),
	(261956, 118, '2014-04-01 00:06:50.000000', 'temperatura', 212.0000, 'ºC'),
	(261957, 118, '2014-04-01 00:06:51.000000', 'temperatura', 38.0000, 'ºC'),
	(261958, 118, '2014-04-01 00:06:52.000000', 'temperatura', 754.0000, 'ºC'),
	(261959, 118, '2014-04-01 00:06:53.000000', 'temperatura', 58.0000, 'ºC'),
	(261960, 118, '2014-04-01 00:06:54.000000', 'temperatura', 430.0000, 'ºC'),
	(261961, 118, '2014-04-01 00:06:55.000000', 'temperatura', 773.0000, 'ºC'),
	(261962, 118, '2014-04-01 00:06:56.000000', 'temperatura', 178.0000, 'ºC'),
	(261963, 118, '2014-04-01 00:06:57.000000', 'temperatura', 973.0000, 'ºC'),
	(261964, 118, '2014-04-01 00:06:58.000000', 'temperatura', 729.0000, 'ºC'),
	(261965, 118, '2014-04-01 00:06:59.000000', 'temperatura', 726.0000, 'ºC'),
	(261966, 118, '2014-04-01 00:07:00.000000', 'temperatura', 243.0000, 'ºC'),
	(261967, 118, '2014-04-01 00:07:01.000000', 'temperatura', 239.0000, 'ºC'),
	(261968, 118, '2014-04-01 00:07:02.000000', 'temperatura', 465.0000, 'ºC'),
	(261969, 118, '2014-04-01 00:07:03.000000', 'temperatura', 409.0000, 'ºC'),
	(261970, 118, '2014-04-01 00:07:04.000000', 'temperatura', 650.0000, 'ºC'),
	(261971, 118, '2014-04-01 00:07:05.000000', 'temperatura', 822.0000, 'ºC'),
	(261972, 118, '2014-04-01 00:07:06.000000', 'temperatura', 964.0000, 'ºC'),
	(261973, 118, '2014-04-01 00:07:07.000000', 'temperatura', 1151.0000, 'ºC'),
	(261974, 118, '2014-04-01 00:07:08.000000', 'temperatura', 465.0000, 'ºC'),
	(261975, 118, '2014-04-01 00:07:09.000000', 'temperatura', 70.0000, 'ºC'),
	(261976, 118, '2014-04-01 00:07:10.000000', 'temperatura', 159.0000, 'ºC'),
	(261977, 118, '2014-04-01 00:07:11.000000', 'temperatura', 586.0000, 'ºC'),
	(261978, 118, '2014-04-01 00:07:12.000000', 'temperatura', 50.0000, 'ºC'),
	(261979, 118, '2014-04-01 00:07:13.000000', 'temperatura', 895.0000, 'ºC'),
	(261980, 118, '2014-04-01 00:07:14.000000', 'temperatura', 726.0000, 'ºC'),
	(261981, 118, '2014-04-01 00:07:15.000000', 'temperatura', 946.0000, 'ºC'),
	(261982, 118, '2014-04-01 00:07:16.000000', 'temperatura', 150.0000, 'ºC'),
	(261983, 118, '2014-04-01 00:07:17.000000', 'temperatura', 312.0000, 'ºC'),
	(261984, 118, '2014-04-01 00:07:18.000000', 'temperatura', 1113.0000, 'ºC'),
	(261985, 118, '2014-04-01 00:07:19.000000', 'temperatura', 1028.0000, 'ºC'),
	(261986, 118, '2014-04-01 00:07:20.000000', 'temperatura', 601.0000, 'ºC'),
	(261987, 118, '2014-04-01 00:07:21.000000', 'temperatura', 1123.0000, 'ºC'),
	(261988, 118, '2014-04-01 00:07:22.000000', 'temperatura', 211.0000, 'ºC'),
	(261989, 118, '2014-04-01 00:07:23.000000', 'temperatura', 86.0000, 'ºC'),
	(261990, 118, '2014-04-01 00:07:24.000000', 'temperatura', 997.0000, 'ºC'),
	(261991, 118, '2014-04-01 00:07:25.000000', 'temperatura', 1130.0000, 'ºC'),
	(261992, 118, '2014-04-01 00:07:26.000000', 'temperatura', 257.0000, 'ºC'),
	(261993, 118, '2014-04-01 00:07:27.000000', 'temperatura', 296.0000, 'ºC'),
	(261994, 118, '2014-04-01 00:07:28.000000', 'temperatura', 708.0000, 'ºC'),
	(261995, 118, '2014-04-01 00:07:29.000000', 'temperatura', 256.0000, 'ºC'),
	(261996, 118, '2014-04-01 00:07:30.000000', 'temperatura', 353.0000, 'ºC'),
	(261997, 118, '2014-04-01 00:07:31.000000', 'temperatura', 999.0000, 'ºC'),
	(261998, 118, '2014-04-01 00:07:32.000000', 'temperatura', 336.0000, 'ºC'),
	(261999, 118, '2014-04-01 00:07:33.000000', 'temperatura', 1084.0000, 'ºC'),
	(262000, 118, '2014-04-01 00:07:34.000000', 'temperatura', 812.0000, 'ºC'),
	(262001, 118, '2014-04-01 00:07:35.000000', 'temperatura', 811.0000, 'ºC'),
	(262002, 118, '2014-04-01 00:07:36.000000', 'temperatura', 417.0000, 'ºC'),
	(262003, 118, '2014-04-01 00:07:37.000000', 'temperatura', 853.0000, 'ºC'),
	(262004, 118, '2014-04-01 00:07:38.000000', 'temperatura', 613.0000, 'ºC'),
	(262005, 118, '2014-04-01 00:07:39.000000', 'temperatura', 507.0000, 'ºC'),
	(262006, 118, '2014-04-01 00:07:40.000000', 'temperatura', 697.0000, 'ºC'),
	(262007, 118, '2014-04-01 00:07:41.000000', 'temperatura', 763.0000, 'ºC'),
	(262008, 118, '2014-04-01 00:07:42.000000', 'temperatura', 527.0000, 'ºC'),
	(262009, 118, '2014-04-01 00:07:43.000000', 'temperatura', 344.0000, 'ºC'),
	(262010, 118, '2014-04-01 00:07:44.000000', 'temperatura', 139.0000, 'ºC'),
	(262011, 118, '2014-04-01 00:07:45.000000', 'temperatura', 866.0000, 'ºC'),
	(262012, 118, '2014-04-01 00:07:46.000000', 'temperatura', 312.0000, 'ºC'),
	(262013, 118, '2014-04-01 00:07:47.000000', 'temperatura', 161.0000, 'ºC'),
	(262014, 118, '2014-04-01 00:07:48.000000', 'temperatura', 1071.0000, 'ºC'),
	(262015, 118, '2014-04-01 00:07:49.000000', 'temperatura', 73.0000, 'ºC'),
	(262016, 118, '2014-04-01 00:07:50.000000', 'temperatura', 754.0000, 'ºC'),
	(262017, 118, '2014-04-01 00:07:51.000000', 'temperatura', 1149.0000, 'ºC'),
	(262018, 118, '2014-04-01 00:07:52.000000', 'temperatura', 1085.0000, 'ºC'),
	(262019, 118, '2014-04-01 00:07:53.000000', 'temperatura', 779.0000, 'ºC'),
	(262020, 118, '2014-04-01 00:07:54.000000', 'temperatura', 638.0000, 'ºC'),
	(262021, 118, '2014-04-01 00:07:55.000000', 'temperatura', 857.0000, 'ºC'),
	(262022, 118, '2014-04-01 00:07:56.000000', 'temperatura', 1168.0000, 'ºC'),
	(262023, 118, '2014-04-01 00:07:57.000000', 'temperatura', 871.0000, 'ºC'),
	(262024, 118, '2014-04-01 00:07:58.000000', 'temperatura', 852.0000, 'ºC'),
	(262025, 118, '2014-04-01 00:07:59.000000', 'temperatura', 446.0000, 'ºC'),
	(262026, 118, '2014-04-01 00:08:00.000000', 'temperatura', 877.0000, 'ºC'),
	(262027, 118, '2014-04-01 00:08:01.000000', 'temperatura', 648.0000, 'ºC'),
	(262028, 118, '2014-04-01 00:08:02.000000', 'temperatura', 607.0000, 'ºC'),
	(262029, 118, '2014-04-01 00:08:03.000000', 'temperatura', 1093.0000, 'ºC'),
	(262030, 118, '2014-04-01 00:08:04.000000', 'temperatura', 44.0000, 'ºC'),
	(262031, 118, '2014-04-01 00:08:05.000000', 'temperatura', 540.0000, 'ºC'),
	(262032, 118, '2014-04-01 00:08:06.000000', 'temperatura', 168.0000, 'ºC'),
	(262033, 118, '2014-04-01 00:08:07.000000', 'temperatura', 420.0000, 'ºC'),
	(262034, 118, '2014-04-01 00:08:08.000000', 'temperatura', 398.0000, 'ºC'),
	(262035, 118, '2014-04-01 00:08:09.000000', 'temperatura', 730.0000, 'ºC'),
	(262036, 118, '2014-04-01 00:08:10.000000', 'temperatura', 55.0000, 'ºC'),
	(262037, 118, '2014-04-01 00:08:11.000000', 'temperatura', 486.0000, 'ºC'),
	(262038, 118, '2014-04-01 00:08:12.000000', 'temperatura', 1068.0000, 'ºC'),
	(262039, 118, '2014-04-01 00:08:13.000000', 'temperatura', 281.0000, 'ºC'),
	(262040, 118, '2014-04-01 00:08:14.000000', 'temperatura', 599.0000, 'ºC'),
	(262041, 118, '2014-04-01 00:08:15.000000', 'temperatura', 956.0000, 'ºC'),
	(262042, 118, '2014-04-01 00:08:16.000000', 'temperatura', 584.0000, 'ºC'),
	(262043, 118, '2014-04-01 00:08:17.000000', 'temperatura', 52.0000, 'ºC'),
	(262044, 118, '2014-04-01 00:08:18.000000', 'temperatura', 906.0000, 'ºC'),
	(262045, 118, '2014-04-01 00:08:19.000000', 'temperatura', 776.0000, 'ºC'),
	(262046, 118, '2014-04-01 00:08:20.000000', 'temperatura', 1161.0000, 'ºC'),
	(262047, 118, '2014-04-01 00:08:21.000000', 'temperatura', 1080.0000, 'ºC'),
	(262048, 118, '2014-04-01 00:08:22.000000', 'temperatura', 716.0000, 'ºC'),
	(262049, 118, '2014-04-01 00:08:23.000000', 'temperatura', 342.0000, 'ºC'),
	(262050, 118, '2014-04-01 00:08:24.000000', 'temperatura', 761.0000, 'ºC'),
	(262051, 118, '2014-04-01 00:08:25.000000', 'temperatura', 379.0000, 'ºC'),
	(262052, 118, '2014-04-01 00:08:26.000000', 'temperatura', 813.0000, 'ºC'),
	(262053, 118, '2014-04-01 00:08:27.000000', 'temperatura', 528.0000, 'ºC'),
	(262054, 118, '2014-04-01 00:08:28.000000', 'temperatura', 202.0000, 'ºC'),
	(262055, 118, '2014-04-01 00:08:29.000000', 'temperatura', 627.0000, 'ºC'),
	(262056, 118, '2014-04-01 00:08:30.000000', 'temperatura', 131.0000, 'ºC'),
	(262057, 118, '2014-04-01 00:08:31.000000', 'temperatura', 1171.0000, 'ºC'),
	(262058, 118, '2014-04-01 00:08:32.000000', 'temperatura', 665.0000, 'ºC'),
	(262059, 118, '2014-04-01 00:08:33.000000', 'temperatura', 1011.0000, 'ºC'),
	(262060, 118, '2014-04-01 00:08:34.000000', 'temperatura', 661.0000, 'ºC'),
	(262061, 118, '2014-04-01 00:08:35.000000', 'temperatura', 274.0000, 'ºC'),
	(262062, 118, '2014-04-01 00:08:36.000000', 'temperatura', 586.0000, 'ºC'),
	(262063, 118, '2014-04-01 00:08:37.000000', 'temperatura', 907.0000, 'ºC'),
	(262064, 118, '2014-04-01 00:08:38.000000', 'temperatura', 378.0000, 'ºC'),
	(262065, 118, '2014-04-01 00:08:39.000000', 'temperatura', 369.0000, 'ºC'),
	(262066, 118, '2014-04-01 00:08:40.000000', 'temperatura', 712.0000, 'ºC'),
	(262067, 118, '2014-04-01 00:08:41.000000', 'temperatura', 54.0000, 'ºC'),
	(262068, 118, '2014-04-01 00:08:42.000000', 'temperatura', 535.0000, 'ºC'),
	(262069, 118, '2014-04-01 00:08:43.000000', 'temperatura', 114.0000, 'ºC'),
	(262070, 118, '2014-04-01 00:08:44.000000', 'temperatura', 165.0000, 'ºC'),
	(262071, 118, '2014-04-01 00:08:45.000000', 'temperatura', 485.0000, 'ºC'),
	(262072, 118, '2014-04-01 00:08:46.000000', 'temperatura', 730.0000, 'ºC'),
	(262073, 118, '2014-04-01 00:08:47.000000', 'temperatura', 997.0000, 'ºC'),
	(262074, 118, '2014-04-01 00:08:48.000000', 'temperatura', 393.0000, 'ºC'),
	(262075, 118, '2014-04-01 00:08:49.000000', 'temperatura', 175.0000, 'ºC'),
	(262076, 118, '2014-04-01 00:08:50.000000', 'temperatura', 896.0000, 'ºC'),
	(262077, 118, '2014-04-01 00:08:51.000000', 'temperatura', 355.0000, 'ºC'),
	(262078, 118, '2014-04-01 00:08:52.000000', 'temperatura', 290.0000, 'ºC'),
	(262079, 118, '2014-04-01 00:08:53.000000', 'temperatura', 383.0000, 'ºC'),
	(262080, 118, '2014-04-01 00:08:54.000000', 'temperatura', 1048.0000, 'ºC'),
	(262081, 118, '2014-04-01 00:08:55.000000', 'temperatura', 492.0000, 'ºC'),
	(262082, 118, '2014-04-01 00:08:56.000000', 'temperatura', 514.0000, 'ºC'),
	(262083, 118, '2014-04-01 00:08:57.000000', 'temperatura', 1095.0000, 'ºC'),
	(262084, 118, '2014-04-01 00:08:58.000000', 'temperatura', 332.0000, 'ºC'),
	(262085, 118, '2014-04-01 00:08:59.000000', 'temperatura', 776.0000, 'ºC'),
	(262086, 118, '2014-04-01 00:09:00.000000', 'temperatura', 483.0000, 'ºC'),
	(262087, 118, '2014-04-01 00:09:01.000000', 'temperatura', 90.0000, 'ºC'),
	(262088, 118, '2014-04-01 00:09:02.000000', 'temperatura', 199.0000, 'ºC'),
	(262089, 118, '2014-04-01 00:09:03.000000', 'temperatura', 727.0000, 'ºC'),
	(262090, 118, '2014-04-01 00:09:04.000000', 'temperatura', 638.0000, 'ºC'),
	(262091, 118, '2014-04-01 00:09:05.000000', 'temperatura', 1008.0000, 'ºC'),
	(262092, 118, '2014-04-01 00:09:06.000000', 'temperatura', 728.0000, 'ºC'),
	(262093, 118, '2014-04-01 00:09:07.000000', 'temperatura', 616.0000, 'ºC'),
	(262094, 118, '2014-04-01 00:09:08.000000', 'temperatura', 897.0000, 'ºC'),
	(262095, 118, '2014-04-01 00:09:09.000000', 'temperatura', 238.0000, 'ºC'),
	(262096, 118, '2014-04-01 00:09:10.000000', 'temperatura', 900.0000, 'ºC'),
	(262097, 118, '2014-04-01 00:09:11.000000', 'temperatura', 186.0000, 'ºC'),
	(262098, 118, '2014-04-01 00:09:12.000000', 'temperatura', 632.0000, 'ºC'),
	(262099, 118, '2014-04-01 00:09:13.000000', 'temperatura', 201.0000, 'ºC'),
	(262100, 118, '2014-04-01 00:09:14.000000', 'temperatura', 311.0000, 'ºC'),
	(262101, 118, '2014-04-01 00:09:15.000000', 'temperatura', 952.0000, 'ºC'),
	(262102, 118, '2014-04-01 00:09:16.000000', 'temperatura', 227.0000, 'ºC'),
	(262103, 118, '2014-04-01 00:09:17.000000', 'temperatura', 678.0000, 'ºC'),
	(262104, 118, '2014-04-01 00:09:18.000000', 'temperatura', 312.0000, 'ºC'),
	(262105, 118, '2014-04-01 00:09:19.000000', 'temperatura', 726.0000, 'ºC'),
	(262106, 118, '2014-04-01 00:09:20.000000', 'temperatura', 295.0000, 'ºC'),
	(262107, 118, '2014-04-01 00:09:21.000000', 'temperatura', 497.0000, 'ºC'),
	(262108, 118, '2014-04-01 00:09:22.000000', 'temperatura', 402.0000, 'ºC'),
	(262109, 118, '2014-04-01 00:09:23.000000', 'temperatura', 520.0000, 'ºC'),
	(262110, 118, '2014-04-01 00:09:24.000000', 'temperatura', 193.0000, 'ºC'),
	(262111, 118, '2014-04-01 00:09:25.000000', 'temperatura', 607.0000, 'ºC'),
	(262112, 118, '2014-04-01 00:09:26.000000', 'temperatura', 55.0000, 'ºC'),
	(262113, 118, '2014-04-01 00:09:27.000000', 'temperatura', 853.0000, 'ºC'),
	(262114, 118, '2014-04-01 00:09:28.000000', 'temperatura', 502.0000, 'ºC'),
	(262115, 118, '2014-04-01 00:09:29.000000', 'temperatura', 1153.0000, 'ºC'),
	(262116, 118, '2014-04-01 00:09:30.000000', 'temperatura', 660.0000, 'ºC'),
	(262117, 118, '2014-04-01 00:09:31.000000', 'temperatura', 1039.0000, 'ºC'),
	(262118, 118, '2014-04-01 00:09:32.000000', 'temperatura', 817.0000, 'ºC'),
	(262119, 118, '2014-04-01 00:09:33.000000', 'temperatura', 966.0000, 'ºC'),
	(262120, 118, '2014-04-01 00:09:34.000000', 'temperatura', 1181.0000, 'ºC'),
	(262121, 118, '2014-04-01 00:09:35.000000', 'temperatura', 608.0000, 'ºC'),
	(262122, 118, '2014-04-01 00:09:36.000000', 'temperatura', 696.0000, 'ºC'),
	(262123, 118, '2014-04-01 00:09:37.000000', 'temperatura', 458.0000, 'ºC'),
	(262124, 118, '2014-04-01 00:09:38.000000', 'temperatura', 202.0000, 'ºC'),
	(262125, 118, '2014-04-01 00:09:39.000000', 'temperatura', 838.0000, 'ºC'),
	(262126, 118, '2014-04-01 00:09:40.000000', 'temperatura', 1182.0000, 'ºC'),
	(262127, 118, '2014-04-01 00:09:41.000000', 'temperatura', 997.0000, 'ºC'),
	(262128, 118, '2014-04-01 00:09:42.000000', 'temperatura', 239.0000, 'ºC'),
	(262129, 118, '2014-04-01 00:09:43.000000', 'temperatura', 606.0000, 'ºC'),
	(262130, 118, '2014-04-01 00:09:44.000000', 'temperatura', 1112.0000, 'ºC'),
	(262131, 118, '2014-04-01 00:09:45.000000', 'temperatura', 144.0000, 'ºC'),
	(262132, 118, '2014-04-01 00:09:46.000000', 'temperatura', 984.0000, 'ºC'),
	(262133, 118, '2014-04-01 00:09:47.000000', 'temperatura', 887.0000, 'ºC'),
	(262134, 118, '2014-04-01 00:09:48.000000', 'temperatura', 285.0000, 'ºC'),
	(262135, 118, '2014-04-01 00:09:49.000000', 'temperatura', 1166.0000, 'ºC'),
	(262136, 118, '2014-04-01 00:09:50.000000', 'temperatura', 174.0000, 'ºC'),
	(262137, 118, '2014-04-01 00:09:51.000000', 'temperatura', 971.0000, 'ºC'),
	(262138, 118, '2014-04-01 00:09:52.000000', 'temperatura', 735.0000, 'ºC'),
	(262139, 118, '2014-04-01 00:09:53.000000', 'temperatura', 761.0000, 'ºC'),
	(262140, 118, '2014-04-01 00:09:54.000000', 'temperatura', 403.0000, 'ºC'),
	(262141, 118, '2014-04-01 00:09:55.000000', 'temperatura', 932.0000, 'ºC'),
	(262142, 118, '2014-04-01 00:09:56.000000', 'temperatura', 1051.0000, 'ºC'),
	(262143, 118, '2014-04-01 00:09:57.000000', 'temperatura', 60.0000, 'ºC'),
	(262144, 118, '2014-04-01 00:09:58.000000', 'temperatura', 746.0000, 'ºC'),
	(262145, 118, '2014-04-01 00:09:59.000000', 'temperatura', 1153.0000, 'ºC'),
	(262146, 118, '2014-04-01 00:10:00.000000', 'temperatura', 1126.0000, 'ºC'),
	(262147, 118, '2014-04-01 00:10:01.000000', 'temperatura', 972.0000, 'ºC'),
	(262148, 118, '2014-04-01 00:10:02.000000', 'temperatura', 282.0000, 'ºC'),
	(262149, 118, '2014-04-01 00:10:03.000000', 'temperatura', 895.0000, 'ºC'),
	(262150, 118, '2014-04-01 00:10:04.000000', 'temperatura', 28.0000, 'ºC'),
	(262151, 118, '2014-04-01 00:10:05.000000', 'temperatura', 1056.0000, 'ºC'),
	(262152, 118, '2014-04-01 00:10:06.000000', 'temperatura', 399.0000, 'ºC'),
	(262153, 118, '2014-04-01 00:10:07.000000', 'temperatura', 25.0000, 'ºC'),
	(262154, 118, '2014-04-01 00:10:08.000000', 'temperatura', 128.0000, 'ºC'),
	(262155, 118, '2014-04-01 00:10:09.000000', 'temperatura', 564.0000, 'ºC'),
	(262156, 118, '2014-04-01 00:10:10.000000', 'temperatura', 40.0000, 'ºC'),
	(262157, 118, '2014-04-01 00:10:11.000000', 'temperatura', 908.0000, 'ºC'),
	(262158, 118, '2014-04-01 00:10:12.000000', 'temperatura', 818.0000, 'ºC'),
	(262159, 118, '2014-04-01 00:10:13.000000', 'temperatura', 170.0000, 'ºC'),
	(262160, 118, '2014-04-01 00:10:14.000000', 'temperatura', 794.0000, 'ºC'),
	(262161, 118, '2014-04-01 00:10:15.000000', 'temperatura', 1060.0000, 'ºC'),
	(262162, 118, '2014-04-01 00:10:16.000000', 'temperatura', 521.0000, 'ºC'),
	(262163, 118, '2014-04-01 00:10:17.000000', 'temperatura', 624.0000, 'ºC'),
	(262164, 118, '2014-04-01 00:10:18.000000', 'temperatura', 359.0000, 'ºC'),
	(262165, 118, '2014-04-01 00:10:19.000000', 'temperatura', 1123.0000, 'ºC'),
	(262166, 118, '2014-04-01 00:10:20.000000', 'temperatura', 936.0000, 'ºC'),
	(262167, 118, '2014-04-01 00:10:21.000000', 'temperatura', 115.0000, 'ºC'),
	(262168, 118, '2014-04-01 00:10:22.000000', 'temperatura', 167.0000, 'ºC'),
	(262169, 118, '2014-04-01 00:10:23.000000', 'temperatura', 489.0000, 'ºC'),
	(262170, 118, '2014-04-01 00:10:24.000000', 'temperatura', 746.0000, 'ºC'),
	(262171, 118, '2014-04-01 00:10:25.000000', 'temperatura', 1065.0000, 'ºC'),
	(262172, 118, '2014-04-01 00:10:26.000000', 'temperatura', 685.0000, 'ºC'),
	(262173, 118, '2014-04-01 00:10:27.000000', 'temperatura', 230.0000, 'ºC'),
	(262174, 118, '2014-04-01 00:10:28.000000', 'temperatura', 298.0000, 'ºC'),
	(262175, 118, '2014-04-01 00:10:29.000000', 'temperatura', 798.0000, 'ºC'),
	(262176, 118, '2014-04-01 00:10:30.000000', 'temperatura', 698.0000, 'ºC'),
	(262177, 118, '2014-04-01 00:10:31.000000', 'temperatura', 1097.0000, 'ºC'),
	(262178, 118, '2014-04-01 00:10:32.000000', 'temperatura', 989.0000, 'ºC'),
	(262179, 118, '2014-04-01 00:10:33.000000', 'temperatura', 456.0000, 'ºC'),
	(262180, 118, '2014-04-01 00:10:34.000000', 'temperatura', 514.0000, 'ºC'),
	(262181, 118, '2014-04-01 00:10:35.000000', 'temperatura', 2.0000, 'ºC'),
	(262182, 118, '2014-04-01 00:10:36.000000', 'temperatura', 868.0000, 'ºC'),
	(262183, 118, '2014-04-01 00:10:37.000000', 'temperatura', 733.0000, 'ºC'),
	(262184, 118, '2014-04-01 00:10:38.000000', 'temperatura', 1064.0000, 'ºC'),
	(262185, 118, '2014-04-01 00:10:39.000000', 'temperatura', 721.0000, 'ºC'),
	(262186, 118, '2014-04-01 00:10:40.000000', 'temperatura', 415.0000, 'ºC'),
	(262187, 118, '2014-04-01 00:10:41.000000', 'temperatura', 1110.0000, 'ºC'),
	(262188, 118, '2014-04-01 00:10:42.000000', 'temperatura', 706.0000, 'ºC'),
	(262189, 118, '2014-04-01 00:10:43.000000', 'temperatura', 201.0000, 'ºC'),
	(262190, 118, '2014-04-01 00:10:44.000000', 'temperatura', 87.0000, 'ºC'),
	(262191, 118, '2014-04-01 00:10:45.000000', 'temperatura', 1034.0000, 'ºC'),
	(262192, 118, '2014-04-01 00:10:46.000000', 'temperatura', 107.0000, 'ºC'),
	(262193, 118, '2014-04-01 00:10:47.000000', 'temperatura', 1036.0000, 'ºC'),
	(262194, 118, '2014-04-01 00:10:48.000000', 'temperatura', 60.0000, 'ºC'),
	(262195, 118, '2014-04-01 00:10:49.000000', 'temperatura', 792.0000, 'ºC'),
	(262196, 118, '2014-04-01 00:10:50.000000', 'temperatura', 179.0000, 'ºC'),
	(262197, 118, '2014-04-01 00:10:51.000000', 'temperatura', 922.0000, 'ºC'),
	(262198, 118, '2014-04-01 00:10:52.000000', 'temperatura', 474.0000, 'ºC'),
	(262199, 118, '2014-04-01 00:10:53.000000', 'temperatura', 804.0000, 'ºC'),
	(262200, 118, '2014-04-01 00:10:54.000000', 'temperatura', 198.0000, 'ºC'),
	(262201, 118, '2014-04-01 00:10:55.000000', 'temperatura', 980.0000, 'ºC'),
	(262202, 118, '2014-04-01 00:10:56.000000', 'temperatura', 704.0000, 'ºC'),
	(262203, 118, '2014-04-01 00:10:57.000000', 'temperatura', 584.0000, 'ºC'),
	(262204, 118, '2014-04-01 00:10:58.000000', 'temperatura', 805.0000, 'ºC'),
	(262205, 118, '2014-04-01 00:10:59.000000', 'temperatura', 1074.0000, 'ºC'),
	(262206, 118, '2014-04-01 00:11:00.000000', 'temperatura', 557.0000, 'ºC'),
	(262207, 118, '2014-04-01 00:11:01.000000', 'temperatura', 761.0000, 'ºC'),
	(262208, 118, '2014-04-01 00:11:02.000000', 'temperatura', 938.0000, 'ºC'),
	(262209, 118, '2014-04-01 00:11:03.000000', 'temperatura', 4.0000, 'ºC'),
	(262210, 118, '2014-04-01 00:11:04.000000', 'temperatura', 808.0000, 'ºC'),
	(262211, 118, '2014-04-01 00:11:05.000000', 'temperatura', 430.0000, 'ºC'),
	(262212, 118, '2014-04-01 00:11:06.000000', 'temperatura', 927.0000, 'ºC'),
	(262213, 118, '2014-04-01 00:11:07.000000', 'temperatura', 945.0000, 'ºC'),
	(262214, 118, '2014-04-01 00:11:08.000000', 'temperatura', 744.0000, 'ºC'),
	(262215, 118, '2014-04-01 00:11:09.000000', 'temperatura', 886.0000, 'ºC'),
	(262216, 118, '2014-04-01 00:11:10.000000', 'temperatura', 999.0000, 'ºC'),
	(262217, 118, '2014-04-01 00:11:11.000000', 'temperatura', 1136.0000, 'ºC'),
	(262218, 118, '2014-04-01 00:11:12.000000', 'temperatura', 284.0000, 'ºC'),
	(262219, 118, '2014-04-01 00:11:13.000000', 'temperatura', 411.0000, 'ºC'),
	(262220, 118, '2014-04-01 00:11:14.000000', 'temperatura', 6.0000, 'ºC'),
	(262221, 118, '2014-04-01 00:11:15.000000', 'temperatura', 1195.0000, 'ºC'),
	(262222, 118, '2014-04-01 00:11:16.000000', 'temperatura', 1157.0000, 'ºC'),
	(262223, 118, '2014-04-01 00:11:17.000000', 'temperatura', 1000.0000, 'ºC'),
	(262224, 118, '2014-04-01 00:11:18.000000', 'temperatura', 330.0000, 'ºC'),
	(262225, 118, '2014-04-01 00:11:19.000000', 'temperatura', 1050.0000, 'ºC'),
	(262226, 118, '2014-04-01 00:11:20.000000', 'temperatura', 661.0000, 'ºC'),
	(262227, 118, '2014-04-01 00:11:21.000000', 'temperatura', 154.0000, 'ºC'),
	(262228, 118, '2014-04-01 00:11:22.000000', 'temperatura', 1189.0000, 'ºC'),
	(262229, 118, '2014-04-01 00:11:23.000000', 'temperatura', 684.0000, 'ºC'),
	(262230, 118, '2014-04-01 00:11:24.000000', 'temperatura', 1053.0000, 'ºC'),
	(262231, 118, '2014-04-01 00:11:25.000000', 'temperatura', 813.0000, 'ºC'),
	(262232, 118, '2014-04-01 00:11:26.000000', 'temperatura', 905.0000, 'ºC'),
	(262233, 118, '2014-04-01 00:11:27.000000', 'temperatura', 886.0000, 'ºC'),
	(262234, 118, '2014-04-01 00:11:28.000000', 'temperatura', 519.0000, 'ºC'),
	(262235, 118, '2014-04-01 00:11:29.000000', 'temperatura', 1135.0000, 'ºC'),
	(262236, 118, '2014-04-01 00:11:30.000000', 'temperatura', 519.0000, 'ºC'),
	(262237, 118, '2014-04-01 00:11:31.000000', 'temperatura', 390.0000, 'ºC'),
	(262238, 118, '2014-04-01 00:11:32.000000', 'temperatura', 396.0000, 'ºC'),
	(262239, 118, '2014-04-01 00:11:33.000000', 'temperatura', 808.0000, 'ºC'),
	(262240, 118, '2014-04-01 00:11:34.000000', 'temperatura', 453.0000, 'ºC'),
	(262241, 118, '2014-04-01 00:11:35.000000', 'temperatura', 1041.0000, 'ºC'),
	(262242, 118, '2014-04-01 00:11:36.000000', 'temperatura', 245.0000, 'ºC'),
	(262243, 118, '2014-04-01 00:11:37.000000', 'temperatura', 504.0000, 'ºC'),
	(262244, 118, '2014-04-01 00:11:38.000000', 'temperatura', 587.0000, 'ºC'),
	(262245, 118, '2014-04-01 00:11:39.000000', 'temperatura', 221.0000, 'ºC'),
	(262246, 118, '2014-04-01 00:11:40.000000', 'temperatura', 544.0000, 'ºC'),
	(262247, 118, '2014-04-01 00:11:41.000000', 'temperatura', 860.0000, 'ºC'),
	(262248, 118, '2014-04-01 00:11:42.000000', 'temperatura', 268.0000, 'ºC'),
	(262249, 118, '2014-04-01 00:11:43.000000', 'temperatura', 1162.0000, 'ºC'),
	(262250, 118, '2014-04-01 00:11:44.000000', 'temperatura', 205.0000, 'ºC'),
	(262251, 118, '2014-04-01 00:11:45.000000', 'temperatura', 1140.0000, 'ºC'),
	(262252, 118, '2014-04-01 00:11:46.000000', 'temperatura', 287.0000, 'ºC'),
	(262253, 118, '2014-04-01 00:11:47.000000', 'temperatura', 413.0000, 'ºC'),
	(262254, 118, '2014-04-01 00:11:48.000000', 'temperatura', 7.0000, 'ºC'),
	(262255, 118, '2014-04-01 00:11:49.000000', 'temperatura', 1195.0000, 'ºC'),
	(262256, 118, '2014-04-01 00:11:50.000000', 'temperatura', 1154.0000, 'ºC'),
	(262257, 118, '2014-04-01 00:11:51.000000', 'temperatura', 986.0000, 'ºC'),
	(262258, 118, '2014-04-01 00:11:52.000000', 'temperatura', 267.0000, 'ºC'),
	(262259, 118, '2014-04-01 00:11:53.000000', 'temperatura', 780.0000, 'ºC'),
	(262260, 118, '2014-04-01 00:11:54.000000', 'temperatura', 701.0000, 'ºC'),
	(262261, 118, '2014-04-01 00:11:55.000000', 'temperatura', 1162.0000, 'ºC'),
	(262262, 118, '2014-04-01 00:11:56.000000', 'temperatura', 107.0000, 'ºC'),
	(262263, 118, '2014-04-01 00:11:57.000000', 'temperatura', 652.0000, 'ºC'),
	(262264, 118, '2014-04-01 00:11:58.000000', 'temperatura', 540.0000, 'ºC'),
	(262265, 118, '2014-04-01 00:11:59.000000', 'temperatura', 744.0000, 'ºC'),
	(262266, 118, '2014-04-01 00:12:00.000000', 'temperatura', 900.0000, 'ºC'),
	(262267, 118, '2014-04-01 00:12:01.000000', 'temperatura', 1067.0000, 'ºC'),
	(262268, 118, '2014-04-01 00:12:02.000000', 'temperatura', 237.0000, 'ºC'),
	(262269, 118, '2014-04-01 00:12:03.000000', 'temperatura', 386.0000, 'ºC'),
	(262270, 118, '2014-04-01 00:12:04.000000', 'temperatura', 18.0000, 'ºC'),
	(262271, 118, '2014-04-01 00:12:05.000000', 'temperatura', 134.0000, 'ºC'),
	(262272, 118, '2014-04-01 00:12:06.000000', 'temperatura', 617.0000, 'ºC'),
	(262273, 118, '2014-04-01 00:12:07.000000', 'temperatura', 284.0000, 'ºC'),
	(262274, 118, '2014-04-01 00:12:08.000000', 'temperatura', 768.0000, 'ºC'),
	(262275, 118, '2014-04-01 00:12:09.000000', 'temperatura', 589.0000, 'ºC'),
	(262276, 118, '2014-04-01 00:12:10.000000', 'temperatura', 642.0000, 'ºC'),
	(262277, 118, '2014-04-01 00:12:11.000000', 'temperatura', 243.0000, 'ºC'),
	(262278, 118, '2014-04-01 00:12:12.000000', 'temperatura', 492.0000, 'ºC'),
	(262279, 118, '2014-04-01 00:12:13.000000', 'temperatura', 528.0000, 'ºC'),
	(262280, 118, '2014-04-01 00:12:14.000000', 'temperatura', 1165.0000, 'ºC'),
	(262281, 118, '2014-04-01 00:12:15.000000', 'temperatura', 640.0000, 'ºC'),
	(262282, 118, '2014-04-01 00:12:16.000000', 'temperatura', 907.0000, 'ºC'),
	(262283, 118, '2014-04-01 00:12:17.000000', 'temperatura', 215.0000, 'ºC'),
	(262284, 118, '2014-04-01 00:12:18.000000', 'temperatura', 754.0000, 'ºC'),
	(262285, 118, '2014-04-01 00:12:19.000000', 'temperatura', 728.0000, 'ºC'),
	(262286, 118, '2014-04-01 00:12:20.000000', 'temperatura', 175.0000, 'ºC'),
	(262287, 118, '2014-04-01 00:12:21.000000', 'temperatura', 1095.0000, 'ºC'),
	(262288, 118, '2014-04-01 00:12:22.000000', 'temperatura', 148.0000, 'ºC'),
	(262289, 118, '2014-04-01 00:12:23.000000', 'temperatura', 1057.0000, 'ºC'),
	(262290, 118, '2014-04-01 00:12:24.000000', 'temperatura', 40.0000, 'ºC'),
	(262291, 118, '2014-04-01 00:12:25.000000', 'temperatura', 629.0000, 'ºC'),
	(262292, 118, '2014-04-01 00:12:26.000000', 'temperatura', 625.0000, 'ºC'),
	(262293, 118, '2014-04-01 00:12:27.000000', 'temperatura', 40.0000, 'ºC'),
	(262294, 118, '2014-04-01 00:12:28.000000', 'temperatura', 727.0000, 'ºC'),
	(262295, 118, '2014-04-01 00:12:29.000000', 'temperatura', 1114.0000, 'ºC'),
	(262296, 118, '2014-04-01 00:12:30.000000', 'temperatura', 988.0000, 'ºC'),
	(262297, 118, '2014-04-01 00:12:31.000000', 'temperatura', 401.0000, 'ºC'),
	(262298, 118, '2014-04-01 00:12:32.000000', 'temperatura', 242.0000, 'ºC'),
	(262299, 118, '2014-04-01 00:12:33.000000', 'temperatura', 5.0000, 'ºC'),
	(262300, 118, '2014-04-01 00:12:34.000000', 'temperatura', 499.0000, 'ºC'),
	(262301, 118, '2014-04-01 00:12:35.000000', 'temperatura', 80.0000, 'ºC'),
	(262302, 118, '2014-04-01 00:12:36.000000', 'temperatura', 104.0000, 'ºC'),
	(262303, 118, '2014-04-01 00:12:37.000000', 'temperatura', 283.0000, 'ºC'),
	(262304, 118, '2014-04-01 00:12:38.000000', 'temperatura', 1101.0000, 'ºC'),
	(262305, 118, '2014-04-01 00:12:39.000000', 'temperatura', 1056.0000, 'ºC'),
	(262306, 118, '2014-04-01 00:12:40.000000', 'temperatura', 777.0000, 'ºC'),
	(262307, 118, '2014-04-01 00:12:41.000000', 'temperatura', 719.0000, 'ºC'),
	(262308, 118, '2014-04-01 00:12:42.000000', 'temperatura', 65.0000, 'ºC'),
	(262309, 118, '2014-04-01 00:12:43.000000', 'temperatura', 567.0000, 'ºC'),
	(262310, 118, '2014-04-01 00:12:44.000000', 'temperatura', 242.0000, 'ºC'),
	(262311, 118, '2014-04-01 00:12:45.000000', 'temperatura', 710.0000, 'ºC'),
	(262312, 118, '2014-04-01 00:12:46.000000', 'temperatura', 423.0000, 'ºC'),
	(262313, 118, '2014-04-01 00:12:47.000000', 'temperatura', 1187.0000, 'ºC'),
	(262314, 118, '2014-04-01 00:12:48.000000', 'temperatura', 1064.0000, 'ºC'),
	(262315, 118, '2014-04-01 00:12:49.000000', 'temperatura', 560.0000, 'ºC'),
	(262316, 118, '2014-04-01 00:12:50.000000', 'temperatura', 810.0000, 'ºC'),
	(262317, 118, '2014-04-01 00:12:51.000000', 'temperatura', 1171.0000, 'ºC'),
	(262318, 118, '2014-04-01 00:12:52.000000', 'temperatura', 1025.0000, 'ºC'),
	(262319, 118, '2014-04-01 00:12:53.000000', 'temperatura', 413.0000, 'ºC'),
	(262320, 118, '2014-04-01 00:12:54.000000', 'temperatura', 191.0000, 'ºC'),
	(262321, 118, '2014-04-01 00:12:55.000000', 'temperatura', 918.0000, 'ºC'),
	(262322, 118, '2014-04-01 00:12:56.000000', 'temperatura', 415.0000, 'ºC'),
	(262323, 118, '2014-04-01 00:12:57.000000', 'temperatura', 520.0000, 'ºC'),
	(262324, 118, '2014-04-01 00:12:58.000000', 'temperatura', 159.0000, 'ºC'),
	(262325, 118, '2014-04-01 00:12:59.000000', 'temperatura', 433.0000, 'ºC'),
	(262326, 118, '2014-04-01 00:13:00.000000', 'temperatura', 490.0000, 'ºC'),
	(262327, 118, '2014-04-01 00:13:01.000000', 'temperatura', 1151.0000, 'ºC'),
	(262328, 118, '2014-04-01 00:13:02.000000', 'temperatura', 686.0000, 'ºC'),
	(262329, 118, '2014-04-01 00:13:03.000000', 'temperatura', 1179.0000, 'ºC'),
	(262330, 118, '2014-04-01 00:13:04.000000', 'temperatura', 237.0000, 'ºC'),
	(262331, 118, '2014-04-01 00:13:05.000000', 'temperatura', 47.0000, 'ºC'),
	(262332, 118, '2014-04-01 00:13:06.000000', 'temperatura', 726.0000, 'ºC'),
	(262333, 118, '2014-04-01 00:13:07.000000', 'temperatura', 1089.0000, 'ºC'),
	(262334, 118, '2014-04-01 00:13:08.000000', 'temperatura', 865.0000, 'ºC'),
	(262335, 118, '2014-04-01 00:13:09.000000', 'temperatura', 1062.0000, 'ºC'),
	(262336, 118, '2014-04-01 00:13:10.000000', 'temperatura', 312.0000, 'ºC'),
	(262337, 118, '2014-04-01 00:13:11.000000', 'temperatura', 777.0000, 'ºC'),
	(262338, 118, '2014-04-01 00:13:12.000000', 'temperatura', 548.0000, 'ºC'),
	(262339, 118, '2014-04-01 00:13:13.000000', 'temperatura', 408.0000, 'ºC'),
	(262340, 118, '2014-04-01 00:13:14.000000', 'temperatura', 399.0000, 'ºC'),
	(262341, 118, '2014-04-01 00:13:15.000000', 'temperatura', 771.0000, 'ºC'),
	(262342, 118, '2014-04-01 00:13:16.000000', 'temperatura', 260.0000, 'ºC'),
	(262343, 118, '2014-04-01 00:13:17.000000', 'temperatura', 187.0000, 'ºC'),
	(262344, 118, '2014-04-01 00:13:18.000000', 'temperatura', 157.0000, 'ºC'),
	(262345, 118, '2014-04-01 00:13:19.000000', 'temperatura', 223.0000, 'ºC'),
	(262346, 118, '2014-04-01 00:13:20.000000', 'temperatura', 645.0000, 'ºC'),
	(262347, 118, '2014-04-01 00:13:21.000000', 'temperatura', 158.0000, 'ºC'),
	(262348, 118, '2014-04-01 00:13:22.000000', 'temperatura', 55.0000, 'ºC'),
	(262349, 118, '2014-04-01 00:13:23.000000', 'temperatura', 999.0000, 'ºC'),
	(262350, 118, '2014-04-01 00:13:24.000000', 'temperatura', 33.0000, 'ºC'),
	(262351, 118, '2014-04-01 00:13:25.000000', 'temperatura', 768.0000, 'ºC'),
	(262352, 118, '2014-04-01 00:13:26.000000', 'temperatura', 142.0000, 'ºC'),
	(262353, 118, '2014-04-01 00:13:27.000000', 'temperatura', 808.0000, 'ºC'),
	(262354, 118, '2014-04-01 00:13:28.000000', 'temperatura', 13.0000, 'ºC'),
	(262355, 118, '2014-04-01 00:13:29.000000', 'temperatura', 42.0000, 'ºC'),
	(262356, 118, '2014-04-01 00:13:30.000000', 'temperatura', 170.0000, 'ºC'),
	(262357, 118, '2014-04-01 00:13:31.000000', 'temperatura', 727.0000, 'ºC'),
	(262358, 118, '2014-04-01 00:13:32.000000', 'temperatura', 724.0000, 'ºC'),
	(262359, 118, '2014-04-01 00:13:33.000000', 'temperatura', 240.0000, 'ºC'),
	(262360, 118, '2014-04-01 00:13:34.000000', 'temperatura', 229.0000, 'ºC'),
	(262361, 118, '2014-04-01 00:13:35.000000', 'temperatura', 426.0000, 'ºC'),
	(262362, 118, '2014-04-01 00:13:36.000000', 'temperatura', 243.0000, 'ºC'),
	(262363, 118, '2014-04-01 00:13:37.000000', 'temperatura', 1137.0000, 'ºC'),
	(262364, 118, '2014-04-01 00:13:38.000000', 'temperatura', 156.0000, 'ºC'),
	(262365, 118, '2014-04-01 00:13:39.000000', 'temperatura', 968.0000, 'ºC'),
	(262366, 118, '2014-04-01 00:13:40.000000', 'temperatura', 774.0000, 'ºC'),
	(262367, 118, '2014-04-01 00:13:41.000000', 'temperatura', 965.0000, 'ºC'),
	(262368, 118, '2014-04-01 00:13:42.000000', 'temperatura', 103.0000, 'ºC'),
	(262369, 118, '2014-04-01 00:13:43.000000', 'temperatura', 23.0000, 'ºC'),
	(262370, 118, '2014-04-01 00:13:44.000000', 'temperatura', 1005.0000, 'ºC'),
	(262371, 118, '2014-04-01 00:13:45.000000', 'temperatura', 156.0000, 'ºC'),
	(262372, 118, '2014-04-01 00:13:46.000000', 'temperatura', 167.0000, 'ºC'),
	(262373, 118, '2014-04-01 00:13:47.000000', 'temperatura', 367.0000, 'ºC'),
	(262374, 118, '2014-04-01 00:13:48.000000', 'temperatura', 134.0000, 'ºC'),
	(262375, 118, '2014-04-01 00:13:49.000000', 'temperatura', 768.0000, 'ºC'),
	(262376, 118, '2014-04-01 00:13:50.000000', 'temperatura', 1039.0000, 'ºC'),
	(262377, 118, '2014-04-01 00:13:51.000000', 'temperatura', 490.0000, 'ºC'),
	(262378, 118, '2014-04-01 00:13:52.000000', 'temperatura', 536.0000, 'ºC'),
	(262379, 118, '2014-04-01 00:13:53.000000', 'temperatura', 10.0000, 'ºC'),
	(262380, 118, '2014-04-01 00:13:54.000000', 'temperatura', 840.0000, 'ºC'),
	(262381, 118, '2014-04-01 00:13:55.000000', 'temperatura', 574.0000, 'ºC'),
	(262382, 118, '2014-04-01 00:13:56.000000', 'temperatura', 350.0000, 'ºC'),
	(262383, 118, '2014-04-01 00:13:57.000000', 'temperatura', 27.0000, 'ºC'),
	(262384, 118, '2014-04-01 00:13:58.000000', 'temperatura', 286.0000, 'ºC'),
	(262385, 118, '2014-04-01 00:13:59.000000', 'temperatura', 149.0000, 'ºC'),
	(262386, 118, '2014-04-01 00:14:00.000000', 'temperatura', 1087.0000, 'ºC'),
	(262387, 118, '2014-04-01 00:14:01.000000', 'temperatura', 189.0000, 'ºC'),
	(262388, 118, '2014-04-01 00:14:02.000000', 'temperatura', 83.0000, 'ºC'),
	(262389, 118, '2014-04-01 00:14:03.000000', 'temperatura', 1051.0000, 'ºC'),
	(262390, 118, '2014-04-01 00:14:04.000000', 'temperatura', 207.0000, 'ºC'),
	(262391, 118, '2014-04-01 00:14:05.000000', 'temperatura', 282.0000, 'ºC'),
	(262392, 118, '2014-04-01 00:14:06.000000', 'temperatura', 787.0000, 'ºC'),
	(262393, 118, '2014-04-01 00:14:07.000000', 'temperatura', 692.0000, 'ºC'),
	(262394, 118, '2014-04-01 00:14:08.000000', 'temperatura', 1101.0000, 'ºC'),
	(262395, 118, '2014-04-01 00:14:09.000000', 'temperatura', 1026.0000, 'ºC'),
	(262396, 118, '2014-04-01 00:14:10.000000', 'temperatura', 631.0000, 'ºC'),
	(262397, 118, '2014-04-01 00:14:11.000000', 'temperatura', 74.0000, 'ºC'),
	(262398, 118, '2014-04-01 00:14:12.000000', 'temperatura', 880.0000, 'ºC'),
	(262399, 118, '2014-04-01 00:14:13.000000', 'temperatura', 579.0000, 'ºC'),
	(262400, 118, '2014-04-01 00:14:14.000000', 'temperatura', 254.0000, 'ºC'),
	(262401, 118, '2014-04-01 00:14:15.000000', 'temperatura', 732.0000, 'ºC'),
	(262402, 118, '2014-04-01 00:14:16.000000', 'temperatura', 500.0000, 'ºC'),
	(262403, 118, '2014-04-01 00:14:17.000000', 'temperatura', 306.0000, 'ºC'),
	(262404, 118, '2014-04-01 00:14:18.000000', 'temperatura', 28.0000, 'ºC'),
	(262405, 118, '2014-04-01 00:14:19.000000', 'temperatura', 423.0000, 'ºC'),
	(262406, 118, '2014-04-01 00:14:20.000000', 'temperatura', 831.0000, 'ºC'),
	(262407, 118, '2014-04-01 00:14:21.000000', 'temperatura', 488.0000, 'ºC'),
	(262408, 118, '2014-04-01 00:14:22.000000', 'temperatura', 1145.0000, 'ºC'),
	(262409, 118, '2014-04-01 00:14:23.000000', 'temperatura', 664.0000, 'ºC'),
	(262410, 118, '2014-04-01 00:14:24.000000', 'temperatura', 1084.0000, 'ºC'),
	(262411, 118, '2014-04-01 00:14:25.000000', 'temperatura', 1028.0000, 'ºC'),
	(262412, 118, '2014-04-01 00:14:26.000000', 'temperatura', 689.0000, 'ºC'),
	(262413, 118, '2014-04-01 00:14:27.000000', 'temperatura', 362.0000, 'ºC'),
	(262414, 118, '2014-04-01 00:14:28.000000', 'temperatura', 944.0000, 'ºC'),
	(262415, 118, '2014-04-01 00:14:29.000000', 'temperatura', 33.0000, 'ºC'),
	(262416, 118, '2014-04-01 00:14:30.000000', 'temperatura', 936.0000, 'ºC'),
	(262417, 118, '2014-04-01 00:14:31.000000', 'temperatura', 979.0000, 'ºC'),
	(262418, 118, '2014-04-01 00:14:32.000000', 'temperatura', 887.0000, 'ºC'),
	(262419, 118, '2014-04-01 00:14:33.000000', 'temperatura', 300.0000, 'ºC'),
	(262420, 118, '2014-04-01 00:14:34.000000', 'temperatura', 38.0000, 'ºC'),
	(262421, 118, '2014-04-01 00:14:35.000000', 'temperatura', 492.0000, 'ºC'),
	(262422, 118, '2014-04-01 00:14:36.000000', 'temperatura', 1148.0000, 'ºC'),
	(262423, 118, '2014-04-01 00:14:37.000000', 'temperatura', 661.0000, 'ºC'),
	(262424, 118, '2014-04-01 00:14:38.000000', 'temperatura', 1063.0000, 'ºC'),
	(262425, 118, '2014-04-01 00:14:39.000000', 'temperatura', 933.0000, 'ºC'),
	(262426, 118, '2014-04-01 00:14:40.000000', 'temperatura', 277.0000, 'ºC'),
	(262427, 118, '2014-04-01 00:14:41.000000', 'temperatura', 986.0000, 'ºC'),
	(262428, 118, '2014-04-01 00:14:42.000000', 'temperatura', 498.0000, 'ºC'),
	(262429, 118, '2014-04-01 00:14:43.000000', 'temperatura', 733.0000, 'ºC'),
	(262430, 118, '2014-04-01 00:14:44.000000', 'temperatura', 973.0000, 'ºC'),
	(262431, 118, '2014-04-01 00:14:45.000000', 'temperatura', 266.0000, 'ºC'),
	(262432, 118, '2014-04-01 00:14:46.000000', 'temperatura', 812.0000, 'ºC'),
	(262433, 118, '2014-04-01 00:14:47.000000', 'temperatura', 863.0000, 'ºC'),
	(262434, 118, '2014-04-01 00:14:48.000000', 'temperatura', 678.0000, 'ºC'),
	(262435, 118, '2014-04-01 00:14:49.000000', 'temperatura', 802.0000, 'ºC'),
	(262436, 118, '2014-04-01 00:14:50.000000', 'temperatura', 778.0000, 'ºC'),
	(262437, 118, '2014-04-01 00:14:51.000000', 'temperatura', 284.0000, 'ºC'),
	(262438, 118, '2014-04-01 00:14:52.000000', 'temperatura', 287.0000, 'ºC'),
	(262439, 118, '2014-04-01 00:14:53.000000', 'temperatura', 581.0000, 'ºC'),
	(262440, 118, '2014-04-01 00:14:54.000000', 'temperatura', 848.0000, 'ºC'),
	(262441, 118, '2014-04-01 00:14:55.000000', 'temperatura', 94.0000, 'ºC'),
	(262442, 118, '2014-04-01 00:14:56.000000', 'temperatura', 329.0000, 'ºC'),
	(262443, 118, '2014-04-01 00:14:57.000000', 'temperatura', 163.0000, 'ºC'),
	(262444, 118, '2014-04-01 00:14:58.000000', 'temperatura', 1027.0000, 'ºC'),
	(262445, 118, '2014-04-01 00:14:59.000000', 'temperatura', 1045.0000, 'ºC'),
	(262446, 118, '2014-04-01 00:15:00.000000', 'temperatura', 948.0000, 'ºC'),
	(262447, 118, '2014-04-01 00:15:01.000000', 'temperatura', 405.0000, 'ºC'),
	(262448, 118, '2014-04-01 00:15:02.000000', 'temperatura', 381.0000, 'ºC'),
	(262449, 118, '2014-04-01 00:15:03.000000', 'temperatura', 689.0000, 'ºC'),
	(262450, 118, '2014-04-01 00:15:04.000000', 'temperatura', 1105.0000, 'ºC'),
	(262451, 118, '2014-04-01 00:15:05.000000', 'temperatura', 1059.0000, 'ºC'),
	(262452, 118, '2014-04-01 00:15:06.000000', 'temperatura', 780.0000, 'ºC'),
	(262453, 118, '2014-04-01 00:15:07.000000', 'temperatura', 725.0000, 'ºC'),
	(262454, 118, '2014-04-01 00:15:08.000000', 'temperatura', 84.0000, 'ºC'),
	(262455, 118, '2014-04-01 00:15:09.000000', 'temperatura', 645.0000, 'ºC'),
	(262456, 118, '2014-04-01 00:15:10.000000', 'temperatura', 575.0000, 'ºC'),
	(262457, 118, '2014-04-01 00:15:11.000000', 'temperatura', 939.0000, 'ºC'),
	(262458, 118, '2014-04-01 00:15:12.000000', 'temperatura', 569.0000, 'ºC'),
	(262459, 118, '2014-04-01 00:15:13.000000', 'temperatura', 31.0000, 'ºC'),
	(262460, 118, '2014-04-01 00:15:14.000000', 'temperatura', 846.0000, 'ºC'),
	(262461, 118, '2014-04-01 00:15:15.000000', 'temperatura', 541.0000, 'ºC'),
	(262462, 118, '2014-04-01 00:15:16.000000', 'temperatura', 165.0000, 'ºC'),
	(262463, 118, '2014-04-01 00:15:17.000000', 'temperatura', 402.0000, 'ºC'),
	(262464, 118, '2014-04-01 00:15:18.000000', 'temperatura', 316.0000, 'ºC'),
	(262465, 118, '2014-04-01 00:15:19.000000', 'temperatura', 376.0000, 'ºC'),
	(262466, 118, '2014-04-01 00:15:20.000000', 'temperatura', 930.0000, 'ºC'),
	(262467, 118, '2014-04-01 00:15:21.000000', 'temperatura', 1123.0000, 'ºC'),
	(262468, 118, '2014-04-01 00:15:22.000000', 'temperatura', 424.0000, 'ºC'),
	(262469, 118, '2014-04-01 00:15:23.000000', 'temperatura', 1153.0000, 'ºC'),
	(262470, 118, '2014-04-01 00:15:24.000000', 'temperatura', 893.0000, 'ºC'),
	(262471, 118, '2014-04-01 00:15:25.000000', 'temperatura', 1007.0000, 'ºC'),
	(262472, 118, '2014-04-01 00:15:26.000000', 'temperatura', 1157.0000, 'ºC'),
	(262473, 118, '2014-04-01 00:15:27.000000', 'temperatura', 365.0000, 'ºC'),
	(262474, 118, '2014-04-01 00:15:28.000000', 'temperatura', 752.0000, 'ºC'),
	(262475, 118, '2014-04-01 00:15:29.000000', 'temperatura', 266.0000, 'ºC'),
	(262476, 118, '2014-04-01 00:15:30.000000', 'temperatura', 277.0000, 'ºC'),
	(262477, 118, '2014-04-01 00:15:31.000000', 'temperatura', 584.0000, 'ºC'),
	(262478, 118, '2014-04-01 00:15:32.000000', 'temperatura', 893.0000, 'ºC'),
	(262479, 118, '2014-04-01 00:15:33.000000', 'temperatura', 311.0000, 'ºC'),
	(262480, 118, '2014-04-01 00:15:34.000000', 'temperatura', 79.0000, 'ºC'),
	(262481, 118, '2014-04-01 00:15:35.000000', 'temperatura', 663.0000, 'ºC'),
	(262482, 118, '2014-04-01 00:15:36.000000', 'temperatura', 676.0000, 'ºC'),
	(262483, 118, '2014-04-01 00:15:37.000000', 'temperatura', 192.0000, 'ºC'),
	(262484, 118, '2014-04-01 00:15:38.000000', 'temperatura', 132.0000, 'ºC'),
	(262485, 118, '2014-04-01 00:15:39.000000', 'temperatura', 86.0000, 'ºC'),
	(262486, 118, '2014-04-01 00:15:40.000000', 'temperatura', 35.0000, 'ºC'),
	(262487, 118, '2014-04-01 00:15:41.000000', 'temperatura', 1118.0000, 'ºC'),
	(262488, 118, '2014-04-01 00:15:42.000000', 'temperatura', 685.0000, 'ºC'),
	(262489, 118, '2014-04-01 00:15:43.000000', 'temperatura', 72.0000, 'ºC'),
	(262490, 118, '2014-04-01 00:15:44.000000', 'temperatura', 705.0000, 'ºC'),
	(262491, 118, '2014-04-01 00:15:45.000000', 'temperatura', 911.0000, 'ºC'),
	(262492, 118, '2014-04-01 00:15:46.000000', 'temperatura', 39.0000, 'ºC'),
	(262493, 118, '2014-04-01 00:15:47.000000', 'temperatura', 1062.0000, 'ºC'),
	(262494, 118, '2014-04-01 00:15:48.000000', 'temperatura', 393.0000, 'ºC'),
	(262495, 118, '2014-04-01 00:15:49.000000', 'temperatura', 1178.0000, 'ºC'),
	(262496, 118, '2014-04-01 00:15:50.000000', 'temperatura', 1115.0000, 'ºC'),
	(262497, 118, '2014-04-01 00:15:51.000000', 'temperatura', 839.0000, 'ºC'),
	(262498, 118, '2014-04-01 00:15:52.000000', 'temperatura', 850.0000, 'ºC'),
	(262499, 118, '2014-04-01 00:15:53.000000', 'temperatura', 536.0000, 'ºC'),
	(262500, 118, '2014-04-01 00:15:54.000000', 'temperatura', 129.0000, 'ºC'),
	(262501, 118, '2014-04-01 00:15:55.000000', 'temperatura', 239.0000, 'ºC'),
	(262502, 118, '2014-04-01 00:15:56.000000', 'temperatura', 810.0000, 'ºC'),
	(262503, 118, '2014-04-01 00:15:57.000000', 'temperatura', 930.0000, 'ºC'),
	(262504, 118, '2014-04-01 00:15:58.000000', 'temperatura', 1021.0000, 'ºC'),
	(262505, 118, '2014-04-01 00:15:59.000000', 'temperatura', 1118.0000, 'ºC'),
	(262506, 118, '2014-04-01 00:16:00.000000', 'temperatura', 125.0000, 'ºC'),
	(262507, 118, '2014-04-01 00:16:01.000000', 'temperatura', 870.0000, 'ºC'),
	(262508, 118, '2014-04-01 00:16:02.000000', 'temperatura', 378.0000, 'ºC'),
	(262509, 118, '2014-04-01 00:16:03.000000', 'temperatura', 481.0000, 'ºC'),
	(262510, 118, '2014-04-01 00:16:04.000000', 'temperatura', 72.0000, 'ºC'),
	(262511, 118, '2014-04-01 00:16:05.000000', 'temperatura', 117.0000, 'ºC'),
	(262512, 118, '2014-04-01 00:16:06.000000', 'temperatura', 368.0000, 'ºC'),
	(262513, 118, '2014-04-01 00:16:07.000000', 'temperatura', 291.0000, 'ºC'),
	(262514, 118, '2014-04-01 00:16:08.000000', 'temperatura', 352.0000, 'ºC'),
	(262515, 118, '2014-04-01 00:16:09.000000', 'temperatura', 888.0000, 'ºC'),
	(262516, 118, '2014-04-01 00:16:10.000000', 'temperatura', 985.0000, 'ºC'),
	(262517, 118, '2014-04-01 00:16:11.000000', 'temperatura', 1059.0000, 'ºC'),
	(262518, 118, '2014-04-01 00:16:12.000000', 'temperatura', 1141.0000, 'ºC'),
	(262519, 118, '2014-04-01 00:16:13.000000', 'temperatura', 129.0000, 'ºC'),
	(262520, 118, '2014-04-01 00:16:14.000000', 'temperatura', 824.0000, 'ºC'),
	(262521, 118, '2014-04-01 00:16:15.000000', 'temperatura', 133.0000, 'ºC'),
	(262522, 118, '2014-04-01 00:16:16.000000', 'temperatura', 594.0000, 'ºC'),
	(262523, 118, '2014-04-01 00:16:17.000000', 'temperatura', 169.0000, 'ºC'),
	(262524, 118, '2014-04-01 00:16:18.000000', 'temperatura', 266.0000, 'ºC'),
	(262525, 118, '2014-04-01 00:16:19.000000', 'temperatura', 821.0000, 'ºC'),
	(262526, 118, '2014-04-01 00:16:20.000000', 'temperatura', 908.0000, 'ºC'),
	(262527, 118, '2014-04-01 00:16:21.000000', 'temperatura', 879.0000, 'ºC'),
	(262528, 118, '2014-04-01 00:16:22.000000', 'temperatura', 472.0000, 'ºC'),
	(262529, 118, '2014-04-01 00:16:23.000000', 'temperatura', 924.0000, 'ºC'),
	(262530, 118, '2014-04-01 00:16:24.000000', 'temperatura', 802.0000, 'ºC'),
	(262531, 118, '2014-04-01 00:16:25.000000', 'temperatura', 38.0000, 'ºC'),
	(262532, 118, '2014-04-01 00:16:26.000000', 'temperatura', 185.0000, 'ºC'),
	(262533, 118, '2014-04-01 00:16:27.000000', 'temperatura', 812.0000, 'ºC'),
	(262534, 118, '2014-04-01 00:16:28.000000', 'temperatura', 1105.0000, 'ºC'),
	(262535, 118, '2014-04-01 00:16:29.000000', 'temperatura', 688.0000, 'ºC'),
	(262536, 118, '2014-04-01 00:16:30.000000', 'temperatura', 125.0000, 'ºC'),
	(262537, 118, '2014-04-01 00:16:31.000000', 'temperatura', 965.0000, 'ºC'),
	(262538, 118, '2014-04-01 00:16:32.000000', 'temperatura', 847.0000, 'ºC'),
	(262539, 118, '2014-04-01 00:16:33.000000', 'temperatura', 143.0000, 'ºC'),
	(262540, 118, '2014-04-01 00:16:34.000000', 'temperatura', 575.0000, 'ºC'),
	(262541, 118, '2014-04-01 00:16:35.000000', 'temperatura', 44.0000, 'ºC'),
	(262542, 118, '2014-04-01 00:16:36.000000', 'temperatura', 898.0000, 'ºC'),
	(262543, 118, '2014-04-01 00:16:37.000000', 'temperatura', 758.0000, 'ºC'),
	(262544, 118, '2014-04-01 00:16:38.000000', 'temperatura', 1095.0000, 'ºC'),
	(262545, 118, '2014-04-01 00:16:39.000000', 'temperatura', 802.0000, 'ºC'),
	(262546, 118, '2014-04-01 00:16:40.000000', 'temperatura', 725.0000, 'ºC'),
	(262547, 118, '2014-04-01 00:16:41.000000', 'temperatura', 19.0000, 'ºC'),
	(262548, 118, '2014-04-01 00:16:42.000000', 'temperatura', 323.0000, 'ºC'),
	(262549, 118, '2014-04-01 00:16:43.000000', 'temperatura', 356.0000, 'ºC'),
	(262550, 118, '2014-04-01 00:16:44.000000', 'temperatura', 812.0000, 'ºC'),
	(262551, 118, '2014-04-01 00:16:45.000000', 'temperatura', 592.0000, 'ºC'),
	(262552, 118, '2014-04-01 00:16:46.000000', 'temperatura', 527.0000, 'ºC'),
	(262553, 118, '2014-04-01 00:16:47.000000', 'temperatura', 857.0000, 'ºC'),
	(262554, 118, '2014-04-01 00:16:48.000000', 'temperatura', 307.0000, 'ºC'),
	(262555, 118, '2014-04-01 00:16:49.000000', 'temperatura', 162.0000, 'ºC'),
	(262556, 118, '2014-04-01 00:16:50.000000', 'temperatura', 1090.0000, 'ºC'),
	(262557, 118, '2014-04-01 00:16:51.000000', 'temperatura', 164.0000, 'ºC'),
	(262558, 118, '2014-04-01 00:16:52.000000', 'temperatura', 1150.0000, 'ºC'),
	(262559, 118, '2014-04-01 00:16:53.000000', 'temperatura', 458.0000, 'ºC'),
	(262560, 118, '2014-04-01 00:16:54.000000', 'temperatura', 41.0000, 'ºC'),
	(262561, 118, '2014-04-01 00:16:55.000000', 'temperatura', 32.0000, 'ºC'),
	(262562, 118, '2014-04-01 00:16:56.000000', 'temperatura', 39.0000, 'ºC'),
	(262563, 118, '2014-04-01 00:16:57.000000', 'temperatura', 97.0000, 'ºC'),
	(262564, 118, '2014-04-01 00:16:58.000000', 'temperatura', 368.0000, 'ºC'),
	(262565, 118, '2014-04-01 00:16:59.000000', 'temperatura', 349.0000, 'ºC'),
	(262566, 118, '2014-04-01 00:17:00.000000', 'temperatura', 643.0000, 'ºC'),
	(262567, 118, '2014-04-01 00:17:01.000000', 'temperatura', 967.0000, 'ºC'),
	(262568, 118, '2014-04-01 00:17:02.000000', 'temperatura', 508.0000, 'ºC'),
	(262569, 118, '2014-04-01 00:17:03.000000', 'temperatura', 840.0000, 'ºC'),
	(262570, 118, '2014-04-01 00:17:04.000000', 'temperatura', 277.0000, 'ºC'),
	(262571, 118, '2014-04-01 00:17:05.000000', 'temperatura', 64.0000, 'ºC'),
	(262572, 118, '2014-04-01 00:17:06.000000', 'temperatura', 691.0000, 'ºC'),
	(262573, 118, '2014-04-01 00:17:07.000000', 'temperatura', 862.0000, 'ºC'),
	(262574, 118, '2014-04-01 00:17:08.000000', 'temperatura', 1039.0000, 'ºC'),
	(262575, 118, '2014-04-01 00:17:09.000000', 'temperatura', 209.0000, 'ºC'),
	(262576, 118, '2014-04-01 00:17:10.000000', 'temperatura', 329.0000, 'ºC'),
	(262577, 118, '2014-04-01 00:17:11.000000', 'temperatura', 1017.0000, 'ºC'),
	(262578, 118, '2014-04-01 00:17:12.000000', 'temperatura', 501.0000, 'ºC'),
	(262579, 118, '2014-04-01 00:17:13.000000', 'temperatura', 652.0000, 'ºC'),
	(262580, 118, '2014-04-01 00:17:14.000000', 'temperatura', 560.0000, 'ºC'),
	(262581, 118, '2014-04-01 00:17:15.000000', 'temperatura', 842.0000, 'ºC'),
	(262582, 118, '2014-04-01 00:17:16.000000', 'temperatura', 130.0000, 'ºC'),
	(262583, 118, '2014-04-01 00:17:17.000000', 'temperatura', 526.0000, 'ºC'),
	(262584, 118, '2014-04-01 00:17:18.000000', 'temperatura', 1039.0000, 'ºC'),
	(262585, 118, '2014-04-01 00:17:19.000000', 'temperatura', 16.0000, 'ºC'),
	(262586, 118, '2014-04-01 00:17:20.000000', 'temperatura', 566.0000, 'ºC'),
	(262587, 118, '2014-04-01 00:17:21.000000', 'temperatura', 383.0000, 'ºC'),
	(262588, 118, '2014-04-01 00:17:22.000000', 'temperatura', 217.0000, 'ºC'),
	(262589, 118, '2014-04-01 00:17:23.000000', 'temperatura', 1134.0000, 'ºC'),
	(262590, 118, '2014-04-01 00:17:24.000000', 'temperatura', 223.0000, 'ºC'),
	(262591, 118, '2014-04-01 00:17:25.000000', 'temperatura', 112.0000, 'ºC'),
	(262592, 118, '2014-04-01 00:17:26.000000', 'temperatura', 1093.0000, 'ºC'),
	(262593, 118, '2014-04-01 00:17:27.000000', 'temperatura', 327.0000, 'ºC'),
	(262594, 118, '2014-04-01 00:17:28.000000', 'temperatura', 759.0000, 'ºC'),
	(262595, 118, '2014-04-01 00:17:29.000000', 'temperatura', 412.0000, 'ºC'),
	(262596, 118, '2014-04-01 00:17:30.000000', 'temperatura', 984.0000, 'ºC'),
	(262597, 118, '2014-04-01 00:17:31.000000', 'temperatura', 87.0000, 'ºC'),
	(262598, 118, '2014-04-01 00:17:32.000000', 'temperatura', 1081.0000, 'ºC'),
	(262599, 118, '2014-04-01 00:17:33.000000', 'temperatura', 343.0000, 'ºC'),
	(262600, 118, '2014-04-01 00:17:34.000000', 'temperatura', 875.0000, 'ºC'),
	(262601, 118, '2014-04-01 00:17:35.000000', 'temperatura', 945.0000, 'ºC'),
	(262602, 118, '2014-04-01 00:17:36.000000', 'temperatura', 903.0000, 'ºC'),
	(262603, 118, '2014-04-01 00:17:37.000000', 'temperatura', 479.0000, 'ºC'),
	(262604, 118, '2014-04-01 00:17:38.000000', 'temperatura', 886.0000, 'ºC'),
	(262605, 118, '2014-04-01 00:17:39.000000', 'temperatura', 594.0000, 'ºC'),
	(262606, 118, '2014-04-01 00:17:40.000000', 'temperatura', 312.0000, 'ºC'),
	(262607, 118, '2014-04-01 00:17:41.000000', 'temperatura', 978.0000, 'ºC'),
	(262608, 118, '2014-04-01 00:17:42.000000', 'temperatura', 355.0000, 'ºC'),
	(262609, 118, '2014-04-01 00:17:43.000000', 'temperatura', 41.0000, 'ºC'),
	(262610, 118, '2014-04-01 00:17:44.000000', 'temperatura', 339.0000, 'ºC'),
	(262611, 118, '2014-04-01 00:17:45.000000', 'temperatura', 376.0000, 'ºC'),
	(262612, 118, '2014-04-01 00:17:46.000000', 'temperatura', 860.0000, 'ºC'),
	(262613, 118, '2014-04-01 00:17:47.000000', 'temperatura', 775.0000, 'ºC'),
	(262614, 118, '2014-04-01 00:17:48.000000', 'temperatura', 95.0000, 'ºC'),
	(262615, 118, '2014-04-01 00:17:49.000000', 'temperatura', 548.0000, 'ºC'),
	(262616, 118, '2014-04-01 00:17:50.000000', 'temperatura', 58.0000, 'ºC'),
	(262617, 118, '2014-04-01 00:17:51.000000', 'temperatura', 1047.0000, 'ºC'),
	(262618, 118, '2014-04-01 00:17:52.000000', 'temperatura', 260.0000, 'ºC'),
	(262619, 118, '2014-04-01 00:17:53.000000', 'temperatura', 562.0000, 'ºC'),
	(262620, 118, '2014-04-01 00:17:54.000000', 'temperatura', 829.0000, 'ºC'),
	(262621, 118, '2014-04-01 00:17:55.000000', 'temperatura', 58.0000, 'ºC'),
	(262622, 118, '2014-04-01 00:17:56.000000', 'temperatura', 203.0000, 'ºC'),
	(262623, 118, '2014-04-01 00:17:57.000000', 'temperatura', 843.0000, 'ºC'),
	(262624, 118, '2014-04-01 00:17:58.000000', 'temperatura', 4.0000, 'ºC'),
	(262625, 118, '2014-04-01 00:17:59.000000', 'temperatura', 1094.0000, 'ºC'),
	(262626, 118, '2014-04-01 00:18:00.000000', 'temperatura', 656.0000, 'ºC'),
	(262627, 118, '2014-04-01 00:18:01.000000', 'temperatura', 1199.0000, 'ºC'),
	(262628, 118, '2014-04-01 00:18:02.000000', 'temperatura', 427.0000, 'ºC'),
	(262629, 118, '2014-04-01 00:18:03.000000', 'temperatura', 939.0000, 'ºC'),
	(262630, 118, '2014-04-01 00:18:04.000000', 'temperatura', 1013.0000, 'ºC'),
	(262631, 118, '2014-04-01 00:18:05.000000', 'temperatura', 1052.0000, 'ºC'),
	(262632, 118, '2014-04-01 00:18:06.000000', 'temperatura', 1018.0000, 'ºC'),
	(262633, 118, '2014-04-01 00:18:07.000000', 'temperatura', 735.0000, 'ºC'),
	(262634, 118, '2014-04-01 00:18:08.000000', 'temperatura', 624.0000, 'ºC'),
	(262635, 118, '2014-04-01 00:18:09.000000', 'temperatura', 914.0000, 'ºC'),
	(262636, 118, '2014-04-01 00:18:10.000000', 'temperatura', 300.0000, 'ºC'),
	(262637, 118, '2014-04-01 00:18:11.000000', 'temperatura', 1157.0000, 'ºC'),
	(262638, 118, '2014-04-01 00:18:12.000000', 'temperatura', 85.0000, 'ºC'),
	(262639, 118, '2014-04-01 00:18:13.000000', 'temperatura', 555.0000, 'ºC'),
	(262640, 118, '2014-04-01 00:18:14.000000', 'temperatura', 122.0000, 'ºC'),
	(262641, 118, '2014-04-01 00:18:15.000000', 'temperatura', 144.0000, 'ºC'),
	(262642, 118, '2014-04-01 00:18:16.000000', 'temperatura', 353.0000, 'ºC'),
	(262643, 118, '2014-04-01 00:18:17.000000', 'temperatura', 136.0000, 'ºC'),
	(262644, 118, '2014-04-01 00:18:18.000000', 'temperatura', 821.0000, 'ºC'),
	(262645, 118, '2014-04-01 00:18:19.000000', 'temperatura', 98.0000, 'ºC'),
	(262646, 118, '2014-04-01 00:18:20.000000', 'temperatura', 426.0000, 'ºC'),
	(262647, 118, '2014-04-01 00:18:21.000000', 'temperatura', 636.0000, 'ºC'),
	(262648, 118, '2014-04-01 00:18:22.000000', 'temperatura', 703.0000, 'ºC'),
	(262649, 118, '2014-04-01 00:18:23.000000', 'temperatura', 407.0000, 'ºC'),
	(262650, 118, '2014-04-01 00:18:24.000000', 'temperatura', 1125.0000, 'ºC'),
	(262651, 118, '2014-04-01 00:18:25.000000', 'temperatura', 805.0000, 'ºC'),
	(262652, 118, '2014-04-01 00:18:26.000000', 'temperatura', 653.0000, 'ºC'),
	(262653, 118, '2014-04-01 00:18:27.000000', 'temperatura', 849.0000, 'ºC'),
	(262654, 118, '2014-04-01 00:18:28.000000', 'temperatura', 1085.0000, 'ºC'),
	(262655, 118, '2014-04-01 00:18:29.000000', 'temperatura', 480.0000, 'ºC'),
	(262656, 118, '2014-04-01 00:18:30.000000', 'temperatura', 347.0000, 'ºC'),
	(262657, 118, '2014-04-01 00:18:31.000000', 'temperatura', 293.0000, 'ºC'),
	(262658, 118, '2014-04-01 00:18:32.000000', 'temperatura', 423.0000, 'ºC'),
	(262659, 118, '2014-04-01 00:18:33.000000', 'temperatura', 39.0000, 'ºC'),
	(262660, 118, '2014-04-01 00:18:34.000000', 'temperatura', 127.0000, 'ºC'),
	(262661, 118, '2014-04-01 00:18:35.000000', 'temperatura', 518.0000, 'ºC'),
	(262662, 118, '2014-04-01 00:18:36.000000', 'temperatura', 1008.0000, 'ºC'),
	(262663, 118, '2014-04-01 00:18:37.000000', 'temperatura', 1088.0000, 'ºC'),
	(262664, 118, '2014-04-01 00:18:38.000000', 'temperatura', 18.0000, 'ºC'),
	(262665, 118, '2014-04-01 00:18:39.000000', 'temperatura', 425.0000, 'ºC'),
	(262666, 118, '2014-04-01 00:18:40.000000', 'temperatura', 872.0000, 'ºC'),
	(262667, 118, '2014-04-01 00:18:41.000000', 'temperatura', 685.0000, 'ºC'),
	(262668, 118, '2014-04-01 00:18:42.000000', 'temperatura', 812.0000, 'ºC'),
	(262669, 118, '2014-04-01 00:18:43.000000', 'temperatura', 803.0000, 'ºC'),
	(262670, 118, '2014-04-01 00:18:44.000000', 'temperatura', 379.0000, 'ºC'),
	(262671, 118, '2014-04-01 00:18:45.000000', 'temperatura', 689.0000, 'ºC'),
	(262672, 118, '2014-04-01 00:18:46.000000', 'temperatura', 1108.0000, 'ºC'),
	(262673, 118, '2014-04-01 00:18:47.000000', 'temperatura', 1074.0000, 'ºC'),
	(262674, 118, '2014-04-01 00:18:48.000000', 'temperatura', 847.0000, 'ºC'),
	(262675, 118, '2014-04-01 00:18:49.000000', 'temperatura', 1011.0000, 'ºC'),
	(262676, 118, '2014-04-01 00:18:50.000000', 'temperatura', 117.0000, 'ºC'),
	(262677, 118, '2014-04-01 00:18:51.000000', 'temperatura', 1153.0000, 'ºC'),
	(262678, 118, '2014-04-01 00:18:52.000000', 'temperatura', 615.0000, 'ºC'),
	(262679, 118, '2014-04-01 00:18:53.000000', 'temperatura', 814.0000, 'ºC'),
	(262680, 118, '2014-04-01 00:18:54.000000', 'temperatura', 1027.0000, 'ºC'),
	(262681, 118, '2014-04-01 00:18:55.000000', 'temperatura', 293.0000, 'ºC'),
	(262682, 118, '2014-04-01 00:18:56.000000', 'temperatura', 784.0000, 'ºC'),
	(262683, 118, '2014-04-01 00:18:57.000000', 'temperatura', 640.0000, 'ºC'),
	(262684, 118, '2014-04-01 00:18:58.000000', 'temperatura', 851.0000, 'ºC'),
	(262685, 118, '2014-04-01 00:18:59.000000', 'temperatura', 1134.0000, 'ºC'),
	(262686, 118, '2014-04-01 00:19:00.000000', 'temperatura', 717.0000, 'ºC'),
	(262687, 118, '2014-04-01 00:19:01.000000', 'temperatura', 185.0000, 'ºC'),
	(262688, 118, '2014-04-01 00:19:02.000000', 'temperatura', 1174.0000, 'ºC'),
	(262689, 118, '2014-04-01 00:19:03.000000', 'temperatura', 514.0000, 'ºC'),
	(262690, 118, '2014-04-01 00:19:04.000000', 'temperatura', 249.0000, 'ºC'),
	(262691, 118, '2014-04-01 00:19:05.000000', 'temperatura', 903.0000, 'ºC'),
	(262692, 118, '2014-04-01 00:19:06.000000', 'temperatura', 170.0000, 'ºC'),
	(262693, 118, '2014-04-01 00:19:07.000000', 'temperatura', 540.0000, 'ºC'),
	(262694, 118, '2014-04-01 00:19:08.000000', 'temperatura', 991.0000, 'ºC'),
	(262695, 118, '2014-04-01 00:19:09.000000', 'temperatura', 937.0000, 'ºC'),
	(262696, 118, '2014-04-01 00:19:10.000000', 'temperatura', 512.0000, 'ºC'),
	(262697, 118, '2014-04-01 00:19:11.000000', 'temperatura', 950.0000, 'ºC'),
	(262698, 118, '2014-04-01 00:19:12.000000', 'temperatura', 813.0000, 'ºC'),
	(262699, 118, '2014-04-01 00:19:13.000000', 'temperatura', 17.0000, 'ºC'),
	(262700, 118, '2014-04-01 00:19:14.000000', 'temperatura', 44.0000, 'ºC'),
	(262701, 118, '2014-04-01 00:19:15.000000', 'temperatura', 172.0000, 'ºC'),
	(262702, 118, '2014-04-01 00:19:16.000000', 'temperatura', 729.0000, 'ºC'),
	(262703, 118, '2014-04-01 00:19:17.000000', 'temperatura', 727.0000, 'ºC'),
	(262704, 118, '2014-04-01 00:19:18.000000', 'temperatura', 250.0000, 'ºC'),
	(262705, 118, '2014-04-01 00:19:19.000000', 'temperatura', 270.0000, 'ºC'),
	(262706, 118, '2014-04-01 00:19:20.000000', 'temperatura', 598.0000, 'ºC'),
	(262707, 118, '2014-04-01 00:19:21.000000', 'temperatura', 984.0000, 'ºC'),
	(262708, 118, '2014-04-01 00:19:22.000000', 'temperatura', 724.0000, 'ºC'),
	(262709, 118, '2014-04-01 00:19:23.000000', 'temperatura', 670.0000, 'ºC'),
	(262710, 118, '2014-04-01 00:19:24.000000', 'temperatura', 1179.0000, 'ºC'),
	(262711, 118, '2014-04-01 00:19:25.000000', 'temperatura', 287.0000, 'ºC'),
	(262712, 118, '2014-04-01 00:19:26.000000', 'temperatura', 296.0000, 'ºC'),
	(262713, 118, '2014-04-01 00:19:27.000000', 'temperatura', 619.0000, 'ºC'),
	(262714, 118, '2014-04-01 00:19:28.000000', 'temperatura', 1008.0000, 'ºC'),
	(262715, 118, '2014-04-01 00:19:29.000000', 'temperatura', 783.0000, 'ºC'),
	(262716, 118, '2014-04-01 00:19:30.000000', 'temperatura', 891.0000, 'ºC'),
	(262717, 118, '2014-04-01 00:19:31.000000', 'temperatura', 906.0000, 'ºC'),
	(262718, 118, '2014-04-01 00:19:32.000000', 'temperatura', 656.0000, 'ºC'),
	(262719, 118, '2014-04-01 00:19:33.000000', 'temperatura', 566.0000, 'ºC'),
	(262720, 118, '2014-04-01 00:19:34.000000', 'temperatura', 862.0000, 'ºC'),
	(262721, 118, '2014-04-01 00:19:35.000000', 'temperatura', 212.0000, 'ºC'),
	(262722, 118, '2014-04-01 00:19:36.000000', 'temperatura', 874.0000, 'ºC'),
	(262723, 118, '2014-04-01 00:19:37.000000', 'temperatura', 133.0000, 'ºC'),
	(262724, 118, '2014-04-01 00:19:38.000000', 'temperatura', 444.0000, 'ºC'),
	(262725, 118, '2014-04-01 00:19:39.000000', 'temperatura', 620.0000, 'ºC'),
	(262726, 118, '2014-04-01 00:19:40.000000', 'temperatura', 570.0000, 'ºC'),
	(262727, 118, '2014-04-01 00:19:41.000000', 'temperatura', 991.0000, 'ºC'),
	(262728, 118, '2014-04-01 00:19:42.000000', 'temperatura', 846.0000, 'ºC'),
	(262729, 118, '2014-04-01 00:19:43.000000', 'temperatura', 57.0000, 'ºC'),
	(262730, 118, '2014-04-01 00:19:44.000000', 'temperatura', 147.0000, 'ºC'),
	(262731, 118, '2014-04-01 00:19:45.000000', 'temperatura', 565.0000, 'ºC'),
	(262732, 118, '2014-04-01 00:19:46.000000', 'temperatura', 1184.0000, 'ºC'),
	(262733, 118, '2014-04-01 00:19:47.000000', 'temperatura', 626.0000, 'ºC'),
	(262734, 118, '2014-04-01 00:19:48.000000', 'temperatura', 779.0000, 'ºC'),
	(262735, 118, '2014-04-01 00:19:49.000000', 'temperatura', 817.0000, 'ºC'),
	(262736, 118, '2014-04-01 00:19:50.000000', 'temperatura', 550.0000, 'ºC'),
	(262737, 118, '2014-04-01 00:19:51.000000', 'temperatura', 300.0000, 'ºC'),
	(262738, 118, '2014-04-01 00:19:52.000000', 'temperatura', 1050.0000, 'ºC'),
	(262739, 118, '2014-04-01 00:19:53.000000', 'temperatura', 752.0000, 'ºC'),
	(262740, 118, '2014-04-01 00:19:54.000000', 'temperatura', 607.0000, 'ºC'),
	(262741, 118, '2014-04-01 00:19:55.000000', 'temperatura', 781.0000, 'ºC'),
	(262742, 118, '2014-04-01 00:19:56.000000', 'temperatura', 886.0000, 'ºC'),
	(262743, 118, '2014-04-01 00:19:57.000000', 'temperatura', 887.0000, 'ºC'),
	(262744, 118, '2014-04-01 00:19:58.000000', 'temperatura', 578.0000, 'ºC'),
	(262745, 118, '2014-04-01 00:19:59.000000', 'temperatura', 228.0000, 'ºC'),
	(262746, 118, '2014-04-01 00:20:00.000000', 'temperatura', 607.0000, 'ºC'),
	(262747, 118, '2014-04-01 00:20:01.000000', 'temperatura', 1152.0000, 'ºC'),
	(262748, 118, '2014-04-01 00:20:02.000000', 'temperatura', 339.0000, 'ºC'),
	(262749, 118, '2014-04-01 00:20:03.000000', 'temperatura', 640.0000, 'ºC'),
	(262750, 118, '2014-04-01 00:20:04.000000', 'temperatura', 983.0000, 'ºC'),
	(262751, 118, '2014-04-01 00:20:05.000000', 'temperatura', 594.0000, 'ºC'),
	(262752, 118, '2014-04-01 00:20:06.000000', 'temperatura', 25.0000, 'ºC'),
	(262753, 118, '2014-04-01 00:20:07.000000', 'temperatura', 741.0000, 'ºC'),
	(262754, 118, '2014-04-01 00:20:08.000000', 'temperatura', 31.0000, 'ºC'),
	(262755, 118, '2014-04-01 00:20:09.000000', 'temperatura', 331.0000, 'ºC'),
	(262756, 118, '2014-04-01 00:20:10.000000', 'temperatura', 365.0000, 'ºC'),
	(262757, 118, '2014-04-01 00:20:11.000000', 'temperatura', 830.0000, 'ºC'),
	(262758, 118, '2014-04-01 00:20:12.000000', 'temperatura', 656.0000, 'ºC'),
	(262759, 118, '2014-04-01 00:20:13.000000', 'temperatura', 789.0000, 'ºC'),
	(262760, 118, '2014-04-01 00:20:14.000000', 'temperatura', 780.0000, 'ºC'),
	(262761, 118, '2014-04-01 00:20:15.000000', 'temperatura', 332.0000, 'ºC'),
	(262762, 118, '2014-04-01 00:20:16.000000', 'temperatura', 520.0000, 'ºC'),
	(262763, 118, '2014-04-01 00:20:17.000000', 'temperatura', 403.0000, 'ºC'),
	(262764, 118, '2014-04-01 00:20:18.000000', 'temperatura', 458.0000, 'ºC'),
	(262765, 118, '2014-04-01 00:20:19.000000', 'temperatura', 1082.0000, 'ºC'),
	(262766, 118, '2014-04-01 00:20:20.000000', 'temperatura', 437.0000, 'ºC'),
	(262767, 118, '2014-04-01 00:20:21.000000', 'temperatura', 137.0000, 'ºC'),
	(262768, 118, '2014-04-01 00:20:22.000000', 'temperatura', 575.0000, 'ºC'),
	(262769, 118, '2014-04-01 00:20:23.000000', 'temperatura', 67.0000, 'ºC'),
	(262770, 118, '2014-04-01 00:20:24.000000', 'temperatura', 1008.0000, 'ºC'),
	(262771, 118, '2014-04-01 00:20:25.000000', 'temperatura', 42.0000, 'ºC'),
	(262772, 118, '2014-04-01 00:20:26.000000', 'temperatura', 784.0000, 'ºC'),
	(262773, 118, '2014-04-01 00:20:27.000000', 'temperatura', 197.0000, 'ºC'),
	(262774, 118, '2014-04-01 00:20:28.000000', 'temperatura', 1034.0000, 'ºC'),
	(262775, 118, '2014-04-01 00:20:29.000000', 'temperatura', 978.0000, 'ºC'),
	(262776, 118, '2014-04-01 00:20:30.000000', 'temperatura', 589.0000, 'ºC'),
	(262777, 118, '2014-04-01 00:20:31.000000', 'temperatura', 11.0000, 'ºC'),
	(262778, 118, '2014-04-01 00:20:32.000000', 'temperatura', 690.0000, 'ºC'),
	(262779, 118, '2014-04-01 00:20:33.000000', 'temperatura', 1017.0000, 'ºC'),
	(262780, 118, '2014-04-01 00:20:34.000000', 'temperatura', 614.0000, 'ºC'),
	(262781, 118, '2014-04-01 00:20:35.000000', 'temperatura', 21.0000, 'ºC'),
	(262782, 118, '2014-04-01 00:20:36.000000', 'temperatura', 663.0000, 'ºC'),
	(262783, 118, '2014-04-01 00:20:37.000000', 'temperatura', 851.0000, 'ºC'),
	(262784, 118, '2014-04-01 00:20:38.000000', 'temperatura', 1068.0000, 'ºC'),
	(262785, 118, '2014-04-01 00:20:39.000000', 'temperatura', 389.0000, 'ºC'),
	(262786, 118, '2014-04-01 00:20:40.000000', 'temperatura', 1141.0000, 'ºC'),
	(262787, 118, '2014-04-01 00:20:41.000000', 'temperatura', 938.0000, 'ºC'),
	(262788, 118, '2014-04-01 00:20:42.000000', 'temperatura', 68.0000, 'ºC'),
	(262789, 118, '2014-04-01 00:20:43.000000', 'temperatura', 1127.0000, 'ºC'),
	(262790, 118, '2014-04-01 00:20:44.000000', 'temperatura', 633.0000, 'ºC'),
	(262791, 118, '2014-04-01 00:20:45.000000', 'temperatura', 983.0000, 'ºC'),
	(262792, 118, '2014-04-01 00:20:46.000000', 'temperatura', 617.0000, 'ºC'),
	(262793, 118, '2014-04-01 00:20:47.000000', 'temperatura', 136.0000, 'ºC'),
	(262794, 118, '2014-04-01 00:20:48.000000', 'temperatura', 31.0000, 'ºC'),
	(262795, 118, '2014-04-01 00:20:49.000000', 'temperatura', 948.0000, 'ºC'),
	(262796, 118, '2014-04-01 00:20:50.000000', 'temperatura', 1046.0000, 'ºC'),
	(262797, 118, '2014-04-01 00:20:51.000000', 'temperatura', 1186.0000, 'ºC'),
	(262798, 118, '2014-04-01 00:20:52.000000', 'temperatura', 392.0000, 'ºC'),
	(262799, 118, '2014-04-01 00:20:53.000000', 'temperatura', 803.0000, 'ºC'),
	(262800, 118, '2014-04-01 00:20:54.000000', 'temperatura', 440.0000, 'ºC'),
	(262801, 118, '2014-04-01 00:20:55.000000', 'temperatura', 990.0000, 'ºC'),
	(262802, 118, '2014-04-01 00:20:56.000000', 'temperatura', 32.0000, 'ºC'),
	(262803, 118, '2014-04-01 00:20:57.000000', 'temperatura', 789.0000, 'ºC'),
	(262804, 118, '2014-04-01 00:20:58.000000', 'temperatura', 251.0000, 'ºC'),
	(262805, 118, '2014-04-01 00:20:59.000000', 'temperatura', 86.0000, 'ºC'),
	(262806, 118, '2014-04-01 00:21:00.000000', 'temperatura', 878.0000, 'ºC'),
	(262807, 118, '2014-04-01 00:21:01.000000', 'temperatura', 534.0000, 'ºC'),
	(262808, 118, '2014-04-01 00:21:02.000000', 'temperatura', 35.0000, 'ºC'),
	(262809, 118, '2014-04-01 00:21:03.000000', 'temperatura', 974.0000, 'ºC'),
	(262810, 118, '2014-04-01 00:21:04.000000', 'temperatura', 1166.0000, 'ºC'),
	(262811, 118, '2014-04-01 00:21:05.000000', 'temperatura', 510.0000, 'ºC'),
	(262812, 118, '2014-04-01 00:21:06.000000', 'temperatura', 250.0000, 'ºC'),
	(262813, 118, '2014-04-01 00:21:07.000000', 'temperatura', 921.0000, 'ºC'),
	(262814, 118, '2014-04-01 00:21:08.000000', 'temperatura', 256.0000, 'ºC'),
	(262815, 118, '2014-04-01 00:21:09.000000', 'temperatura', 918.0000, 'ºC'),
	(262816, 118, '2014-04-01 00:21:10.000000', 'temperatura', 223.0000, 'ºC'),
	(262817, 118, '2014-04-01 00:21:11.000000', 'temperatura', 761.0000, 'ºC'),
	(262818, 118, '2014-04-01 00:21:12.000000', 'temperatura', 737.0000, 'ºC'),
	(262819, 118, '2014-04-01 00:21:13.000000', 'temperatura', 200.0000, 'ºC'),
	(262820, 118, '2014-04-01 00:21:14.000000', 'temperatura', 1192.0000, 'ºC'),
	(262821, 118, '2014-04-01 00:21:15.000000', 'temperatura', 558.0000, 'ºC'),
	(262822, 118, '2014-04-01 00:21:16.000000', 'temperatura', 416.0000, 'ºC'),
	(262823, 118, '2014-04-01 00:21:17.000000', 'temperatura', 405.0000, 'ºC'),
	(262824, 118, '2014-04-01 00:21:18.000000', 'temperatura', 777.0000, 'ºC'),
	(262825, 118, '2014-04-01 00:21:19.000000', 'temperatura', 271.0000, 'ºC'),
	(262826, 118, '2014-04-01 00:21:20.000000', 'temperatura', 224.0000, 'ºC'),
	(262827, 118, '2014-04-01 00:21:21.000000', 'temperatura', 308.0000, 'ºC'),
	(262828, 118, '2014-04-01 00:21:22.000000', 'temperatura', 868.0000, 'ºC'),
	(262829, 118, '2014-04-01 00:21:23.000000', 'temperatura', 1015.0000, 'ºC'),
	(262830, 118, '2014-04-01 00:21:24.000000', 'temperatura', 74.0000, 'ºC'),
	(262831, 118, '2014-04-01 00:21:25.000000', 'temperatura', 925.0000, 'ºC'),
	(262832, 118, '2014-04-01 00:21:26.000000', 'temperatura', 802.0000, 'ºC'),
	(262833, 118, '2014-04-01 00:21:27.000000', 'temperatura', 36.0000, 'ºC'),
	(262834, 118, '2014-04-01 00:21:28.000000', 'temperatura', 173.0000, 'ºC'),
	(262835, 118, '2014-04-01 00:21:29.000000', 'temperatura', 759.0000, 'ºC'),
	(262836, 118, '2014-04-01 00:21:30.000000', 'temperatura', 878.0000, 'ºC'),
	(262837, 118, '2014-04-01 00:21:31.000000', 'temperatura', 912.0000, 'ºC'),
	(262838, 118, '2014-04-01 00:21:32.000000', 'temperatura', 725.0000, 'ºC'),
	(262839, 118, '2014-04-01 00:21:33.000000', 'temperatura', 889.0000, 'ºC'),
	(262840, 118, '2014-04-01 00:21:34.000000', 'temperatura', 1074.0000, 'ºC'),
	(262841, 118, '2014-04-01 00:21:35.000000', 'temperatura', 300.0000, 'ºC'),
	(262842, 118, '2014-04-01 00:21:36.000000', 'temperatura', 681.0000, 'ºC'),
	(262843, 118, '2014-04-01 00:21:37.000000', 'temperatura', 103.0000, 'ºC'),
	(262844, 118, '2014-04-01 00:21:38.000000', 'temperatura', 873.0000, 'ºC'),
	(262845, 118, '2014-04-01 00:21:39.000000', 'temperatura', 459.0000, 'ºC'),
	(262846, 118, '2014-04-01 00:21:40.000000', 'temperatura', 873.0000, 'ºC'),
	(262847, 118, '2014-04-01 00:21:41.000000', 'temperatura', 592.0000, 'ºC'),
	(262848, 118, '2014-04-01 00:21:42.000000', 'temperatura', 338.0000, 'ºC'),
	(262849, 118, '2014-04-01 00:21:43.000000', 'temperatura', 1116.0000, 'ºC'),
	(262850, 118, '2014-04-01 00:21:44.000000', 'temperatura', 965.0000, 'ºC'),
	(262851, 118, '2014-04-01 00:21:45.000000', 'temperatura', 279.0000, 'ºC'),
	(262852, 118, '2014-04-01 00:21:46.000000', 'temperatura', 901.0000, 'ºC'),
	(262853, 118, '2014-04-01 00:21:47.000000', 'temperatura', 67.0000, 'ºC'),
	(262854, 118, '2014-04-01 00:21:48.000000', 'temperatura', 32.0000, 'ºC'),
	(262855, 118, '2014-04-01 00:21:49.000000', 'temperatura', 1160.0000, 'ºC'),
	(262856, 118, '2014-04-01 00:21:50.000000', 'temperatura', 906.0000, 'ºC'),
	(262857, 118, '2014-04-01 00:21:51.000000', 'temperatura', 1048.0000, 'ºC'),
	(262858, 118, '2014-04-01 00:21:52.000000', 'temperatura', 122.0000, 'ºC'),
	(262859, 118, '2014-04-01 00:21:53.000000', 'temperatura', 1070.0000, 'ºC'),
	(262860, 118, '2014-04-01 00:21:54.000000', 'temperatura', 181.0000, 'ºC'),
	(262861, 118, '2014-04-01 00:21:55.000000', 'temperatura', 99.0000, 'ºC'),
	(262862, 118, '2014-04-01 00:21:56.000000', 'temperatura', 1150.0000, 'ºC'),
	(262863, 118, '2014-04-01 00:21:57.000000', 'temperatura', 656.0000, 'ºC'),
	(262864, 118, '2014-04-01 00:21:58.000000', 'temperatura', 1028.0000, 'ºC'),
	(262865, 118, '2014-04-01 00:21:59.000000', 'temperatura', 772.0000, 'ºC'),
	(262866, 118, '2014-04-01 00:22:00.000000', 'temperatura', 778.0000, 'ºC'),
	(262867, 118, '2014-04-01 00:22:01.000000', 'temperatura', 372.0000, 'ºC'),
	(262868, 118, '2014-04-01 00:22:02.000000', 'temperatura', 728.0000, 'ºC'),
	(262869, 118, '2014-04-01 00:22:03.000000', 'temperatura', 127.0000, 'ºC'),
	(262870, 118, '2014-04-01 00:22:04.000000', 'temperatura', 848.0000, 'ºC'),
	(262871, 118, '2014-04-01 00:22:05.000000', 'temperatura', 261.0000, 'ºC'),
	(262872, 118, '2014-04-01 00:22:06.000000', 'temperatura', 1162.0000, 'ºC'),
	(262873, 118, '2014-04-01 00:22:07.000000', 'temperatura', 227.0000, 'ºC'),
	(262874, 118, '2014-04-01 00:22:08.000000', 'temperatura', 51.0000, 'ºC'),
	(262875, 118, '2014-04-01 00:22:09.000000', 'temperatura', 774.0000, 'ºC'),
	(262876, 118, '2014-04-01 00:22:10.000000', 'temperatura', 118.0000, 'ºC'),
	(262877, 118, '2014-04-01 00:22:11.000000', 'temperatura', 670.0000, 'ºC'),
	(262878, 118, '2014-04-01 00:22:12.000000', 'temperatura', 594.0000, 'ºC'),
	(262879, 118, '2014-04-01 00:22:13.000000', 'temperatura', 963.0000, 'ºC'),
	(262880, 118, '2014-04-01 00:22:14.000000', 'temperatura', 631.0000, 'ºC'),
	(262881, 118, '2014-04-01 00:22:15.000000', 'temperatura', 267.0000, 'ºC'),
	(262882, 118, '2014-04-01 00:22:16.000000', 'temperatura', 644.0000, 'ºC'),
	(262883, 118, '2014-04-01 00:22:17.000000', 'temperatura', 20.0000, 'ºC'),
	(262884, 118, '2014-04-01 00:22:18.000000', 'temperatura', 566.0000, 'ºC'),
	(262885, 118, '2014-04-01 00:22:19.000000', 'temperatura', 371.0000, 'ºC'),
	(262886, 118, '2014-04-01 00:22:20.000000', 'temperatura', 158.0000, 'ºC'),
	(262887, 118, '2014-04-01 00:22:21.000000', 'temperatura', 877.0000, 'ºC'),
	(262888, 118, '2014-04-01 00:22:22.000000', 'temperatura', 312.0000, 'ºC'),
	(262889, 118, '2014-04-01 00:22:23.000000', 'temperatura', 131.0000, 'ºC'),
	(262890, 118, '2014-04-01 00:22:24.000000', 'temperatura', 917.0000, 'ºC'),
	(262891, 118, '2014-04-01 00:22:25.000000', 'temperatura', 595.0000, 'ºC'),
	(262892, 118, '2014-04-01 00:22:26.000000', 'temperatura', 223.0000, 'ºC'),
	(262893, 118, '2014-04-01 00:22:27.000000', 'temperatura', 532.0000, 'ºC'),
	(262894, 118, '2014-04-01 00:22:28.000000', 'temperatura', 790.0000, 'ºC'),
	(262895, 118, '2014-04-01 00:22:29.000000', 'temperatura', 1153.0000, 'ºC'),
	(262896, 118, '2014-04-01 00:22:30.000000', 'temperatura', 997.0000, 'ºC'),
	(262897, 118, '2014-04-01 00:22:31.000000', 'temperatura', 327.0000, 'ºC'),
	(262898, 118, '2014-04-01 00:22:32.000000', 'temperatura', 1043.0000, 'ºC'),
	(262899, 118, '2014-04-01 00:22:33.000000', 'temperatura', 635.0000, 'ºC'),
	(262900, 118, '2014-04-01 00:22:34.000000', 'temperatura', 46.0000, 'ºC'),
	(262901, 118, '2014-04-01 00:22:35.000000', 'temperatura', 728.0000, 'ºC'),
	(262902, 118, '2014-04-01 00:22:36.000000', 'temperatura', 1101.0000, 'ºC'),
	(262903, 118, '2014-04-01 00:22:37.000000', 'temperatura', 922.0000, 'ºC'),
	(262904, 118, '2014-04-01 00:22:38.000000', 'temperatura', 106.0000, 'ºC'),
	(262905, 118, '2014-04-01 00:22:39.000000', 'temperatura', 164.0000, 'ºC'),
	(262906, 118, '2014-04-01 00:22:40.000000', 'temperatura', 503.0000, 'ºC'),
	(262907, 118, '2014-04-01 00:22:41.000000', 'temperatura', 824.0000, 'ºC'),
	(262908, 118, '2014-04-01 00:22:42.000000', 'temperatura', 211.0000, 'ºC'),
	(262909, 118, '2014-04-01 00:22:43.000000', 'temperatura', 982.0000, 'ºC'),
	(262910, 118, '2014-04-01 00:22:44.000000', 'temperatura', 680.0000, 'ºC'),
	(262911, 118, '2014-04-01 00:22:45.000000', 'temperatura', 455.0000, 'ºC'),
	(262912, 118, '2014-04-01 00:22:46.000000', 'temperatura', 232.0000, 'ºC'),
	(262913, 118, '2014-04-01 00:22:47.000000', 'temperatura', 999.0000, 'ºC'),
	(262914, 118, '2014-04-01 00:22:48.000000', 'temperatura', 700.0000, 'ºC'),
	(262915, 118, '2014-04-01 00:22:49.000000', 'temperatura', 500.0000, 'ºC'),
	(262916, 118, '2014-04-01 00:22:50.000000', 'temperatura', 403.0000, 'ºC'),
	(262917, 118, '2014-04-01 00:22:51.000000', 'temperatura', 517.0000, 'ºC'),
	(262918, 118, '2014-04-01 00:22:52.000000', 'temperatura', 174.0000, 'ºC'),
	(262919, 118, '2014-04-01 00:22:53.000000', 'temperatura', 522.0000, 'ºC'),
	(262920, 118, '2014-04-01 00:22:54.000000', 'temperatura', 886.0000, 'ºC'),
	(262921, 118, '2014-04-01 00:22:55.000000', 'temperatura', 466.0000, 'ºC'),
	(262922, 118, '2014-04-01 00:22:56.000000', 'temperatura', 874.0000, 'ºC'),
	(262923, 118, '2014-04-01 00:22:57.000000', 'temperatura', 572.0000, 'ºC'),
	(262924, 118, '2014-04-01 00:22:58.000000', 'temperatura', 237.0000, 'ºC'),
	(262925, 118, '2014-04-01 00:22:59.000000', 'temperatura', 670.0000, 'ºC'),
	(262926, 118, '2014-04-01 00:23:00.000000', 'temperatura', 238.0000, 'ºC'),
	(262927, 118, '2014-04-01 00:23:01.000000', 'temperatura', 381.0000, 'ºC'),
	(262928, 118, '2014-04-01 00:23:02.000000', 'temperatura', 1192.0000, 'ºC'),
	(262929, 118, '2014-04-01 00:23:03.000000', 'temperatura', 17.0000, 'ºC'),
	(262930, 118, '2014-04-01 00:23:04.000000', 'temperatura', 110.0000, 'ºC'),
	(262931, 118, '2014-04-01 00:23:05.000000', 'temperatura', 499.0000, 'ºC'),
	(262932, 118, '2014-04-01 00:23:06.000000', 'temperatura', 966.0000, 'ºC'),
	(262933, 118, '2014-04-01 00:23:07.000000', 'temperatura', 931.0000, 'ºC'),
	(262934, 118, '2014-04-01 00:23:08.000000', 'temperatura', 561.0000, 'ºC'),
	(262935, 118, '2014-04-01 00:23:09.000000', 'temperatura', 11.0000, 'ºC'),
	(262936, 118, '2014-04-01 00:23:10.000000', 'temperatura', 771.0000, 'ºC'),
	(262937, 118, '2014-04-01 00:23:11.000000', 'temperatura', 222.0000, 'ºC'),
	(262938, 118, '2014-04-01 00:23:12.000000', 'temperatura', 1199.0000, 'ºC'),
	(262939, 118, '2014-04-01 00:23:13.000000', 'temperatura', 530.0000, 'ºC'),
	(262940, 118, '2014-04-01 00:23:14.000000', 'temperatura', 252.0000, 'ºC'),
	(262941, 118, '2014-04-01 00:23:15.000000', 'temperatura', 871.0000, 'ºC'),
	(262942, 118, '2014-04-01 00:23:16.000000', 'temperatura', 0.0000, 'ºC'),
	(262943, 118, '2014-04-01 00:23:17.000000', 'temperatura', 988.0000, 'ºC'),
	(262944, 118, '2014-04-01 00:23:18.000000', 'temperatura', 142.0000, 'ºC'),
	(262945, 118, '2014-04-01 00:23:19.000000', 'temperatura', 145.0000, 'ºC'),
	(262946, 118, '2014-04-01 00:23:20.000000', 'temperatura', 298.0000, 'ºC'),
	(262947, 118, '2014-04-01 00:23:21.000000', 'temperatura', 1057.0000, 'ºC'),
	(262948, 118, '2014-04-01 00:23:22.000000', 'temperatura', 793.0000, 'ºC'),
	(262949, 118, '2014-04-01 00:23:23.000000', 'temperatura', 792.0000, 'ºC'),
	(262950, 118, '2014-04-01 00:23:24.000000', 'temperatura', 380.0000, 'ºC'),
	(262951, 118, '2014-04-01 00:23:25.000000', 'temperatura', 727.0000, 'ºC'),
	(262952, 118, '2014-04-01 00:23:26.000000', 'temperatura', 97.0000, 'ºC'),
	(262953, 118, '2014-04-01 00:23:27.000000', 'temperatura', 703.0000, 'ºC'),
	(262954, 118, '2014-04-01 00:23:28.000000', 'temperatura', 823.0000, 'ºC'),
	(262955, 118, '2014-04-01 00:23:29.000000', 'temperatura', 806.0000, 'ºC'),
	(262956, 118, '2014-04-01 00:23:30.000000', 'temperatura', 364.0000, 'ºC'),
	(262957, 118, '2014-04-01 00:23:31.000000', 'temperatura', 602.0000, 'ºC'),
	(262958, 118, '2014-04-01 00:23:32.000000', 'temperatura', 719.0000, 'ºC'),
	(262959, 118, '2014-04-01 00:23:33.000000', 'temperatura', 591.0000, 'ºC'),
	(262960, 118, '2014-04-01 00:23:34.000000', 'temperatura', 796.0000, 'ºC'),
	(262961, 118, '2014-04-01 00:23:35.000000', 'temperatura', 1007.0000, 'ºC'),
	(262962, 118, '2014-04-01 00:23:36.000000', 'temperatura', 248.0000, 'ºC'),
	(262963, 118, '2014-04-01 00:23:37.000000', 'temperatura', 621.0000, 'ºC'),
	(262964, 118, '2014-04-01 00:23:38.000000', 'temperatura', 1160.0000, 'ºC'),
	(262965, 118, '2014-04-01 00:23:39.000000', 'temperatura', 340.0000, 'ºC'),
	(262966, 118, '2014-04-01 00:23:40.000000', 'temperatura', 618.0000, 'ºC'),
	(262967, 118, '2014-04-01 00:23:41.000000', 'temperatura', 871.0000, 'ºC'),
	(262968, 118, '2014-04-01 00:23:42.000000', 'temperatura', 103.0000, 'ºC'),
	(262969, 118, '2014-04-01 00:23:43.000000', 'temperatura', 300.0000, 'ºC'),
	(262970, 118, '2014-04-01 00:23:44.000000', 'temperatura', 1192.0000, 'ºC'),
	(262971, 118, '2014-04-01 00:23:45.000000', 'temperatura', 262.0000, 'ºC'),
	(262972, 118, '2014-04-01 00:23:46.000000', 'temperatura', 134.0000, 'ºC'),
	(262973, 118, '2014-04-01 00:23:47.000000', 'temperatura', 1083.0000, 'ºC'),
	(262974, 118, '2014-04-01 00:23:48.000000', 'temperatura', 216.0000, 'ºC'),
	(262975, 118, '2014-04-01 00:23:49.000000', 'temperatura', 231.0000, 'ºC'),
	(262976, 118, '2014-04-01 00:23:50.000000', 'temperatura', 507.0000, 'ºC'),
	(262977, 118, '2014-04-01 00:23:51.000000', 'temperatura', 641.0000, 'ºC'),
	(262978, 118, '2014-04-01 00:23:52.000000', 'temperatura', 484.0000, 'ºC'),
	(262979, 118, '2014-04-01 00:23:53.000000', 'temperatura', 499.0000, 'ºC'),
	(262980, 118, '2014-04-01 00:23:54.000000', 'temperatura', 1044.0000, 'ºC'),
	(262981, 118, '2014-04-01 00:23:55.000000', 'temperatura', 123.0000, 'ºC'),
	(262982, 118, '2014-04-01 00:23:56.000000', 'temperatura', 1084.0000, 'ºC'),
	(262983, 118, '2014-04-01 00:23:57.000000', 'temperatura', 250.0000, 'ºC'),
	(262984, 118, '2014-04-01 00:23:58.000000', 'temperatura', 401.0000, 'ºC'),
	(262985, 118, '2014-04-01 00:23:59.000000', 'temperatura', 55.0000, 'ºC'),
	(262986, 118, '2014-04-01 00:24:00.000000', 'temperatura', 271.0000, 'ºC'),
	(262987, 118, '2014-04-01 00:24:01.000000', 'temperatura', 1192.0000, 'ºC'),
	(262988, 118, '2014-04-01 00:24:02.000000', 'temperatura', 346.0000, 'ºC'),
	(262989, 118, '2014-04-01 00:24:03.000000', 'temperatura', 557.0000, 'ºC'),
	(262990, 118, '2014-04-01 00:24:04.000000', 'temperatura', 545.0000, 'ºC'),
	(262991, 118, '2014-04-01 00:24:05.000000', 'temperatura', 1056.0000, 'ºC'),
	(262992, 118, '2014-04-01 00:24:06.000000', 'temperatura', 45.0000, 'ºC'),
	(262993, 118, '2014-04-01 00:24:07.000000', 'temperatura', 656.0000, 'ºC'),
	(262994, 118, '2014-04-01 00:24:08.000000', 'temperatura', 747.0000, 'ºC'),
	(262995, 118, '2014-04-01 00:24:09.000000', 'temperatura', 567.0000, 'ºC'),
	(262996, 118, '2014-04-01 00:24:10.000000', 'temperatura', 594.0000, 'ºC'),
	(262997, 118, '2014-04-01 00:24:11.000000', 'temperatura', 72.0000, 'ºC'),
	(262998, 118, '2014-04-01 00:24:12.000000', 'temperatura', 977.0000, 'ºC'),
	(262999, 118, '2014-04-01 00:24:13.000000', 'temperatura', 1070.0000, 'ºC'),
	(263000, 118, '2014-04-01 00:24:14.000000', 'temperatura', 20.0000, 'ºC'),
	(263001, 118, '2014-04-01 00:24:15.000000', 'temperatura', 491.0000, 'ºC'),
	(263002, 118, '2014-04-01 00:24:16.000000', 'temperatura', 1195.0000, 'ºC'),
	(263003, 118, '2014-04-01 00:24:17.000000', 'temperatura', 903.0000, 'ºC'),
	(263004, 118, '2014-04-01 00:24:18.000000', 'temperatura', 931.0000, 'ºC'),
	(263005, 118, '2014-04-01 00:24:19.000000', 'temperatura', 747.0000, 'ºC'),
	(263006, 118, '2014-04-01 00:24:20.000000', 'temperatura', 942.0000, 'ºC'),
	(263007, 118, '2014-04-01 00:24:21.000000', 'temperatura', 69.0000, 'ºC'),
	(263008, 118, '2014-04-01 00:24:22.000000', 'temperatura', 1121.0000, 'ºC'),
	(263009, 118, '2014-04-01 00:24:23.000000', 'temperatura', 598.0000, 'ºC'),
	(263010, 118, '2014-04-01 00:24:24.000000', 'temperatura', 828.0000, 'ºC'),
	(263011, 118, '2014-04-01 00:24:25.000000', 'temperatura', 1144.0000, 'ºC'),
	(263012, 118, '2014-04-01 00:24:26.000000', 'temperatura', 838.0000, 'ºC'),
	(263013, 118, '2014-04-01 00:24:27.000000', 'temperatura', 760.0000, 'ºC'),
	(263014, 118, '2014-04-01 00:24:28.000000', 'temperatura', 86.0000, 'ºC'),
	(263015, 118, '2014-04-01 00:24:29.000000', 'temperatura', 549.0000, 'ºC'),
	(263016, 118, '2014-04-01 00:24:30.000000', 'temperatura', 88.0000, 'ºC'),
	(263017, 118, '2014-04-01 00:24:31.000000', 'temperatura', 1195.0000, 'ºC'),
	(263018, 118, '2014-04-01 00:24:32.000000', 'temperatura', 912.0000, 'ºC'),
	(263019, 118, '2014-04-01 00:24:33.000000', 'temperatura', 976.0000, 'ºC'),
	(263020, 118, '2014-04-01 00:24:34.000000', 'temperatura', 941.0000, 'ºC'),
	(263021, 118, '2014-04-01 00:24:35.000000', 'temperatura', 581.0000, 'ºC'),
	(263022, 118, '2014-04-01 00:24:36.000000', 'temperatura', 81.0000, 'ºC'),
	(263023, 118, '2014-04-01 00:24:37.000000', 'temperatura', 1061.0000, 'ºC'),
	(263024, 118, '2014-04-01 00:24:38.000000', 'temperatura', 262.0000, 'ºC'),
	(263025, 118, '2014-04-01 00:24:39.000000', 'temperatura', 528.0000, 'ºC'),
	(263026, 118, '2014-04-01 00:24:40.000000', 'temperatura', 654.0000, 'ºC'),
	(263027, 118, '2014-04-01 00:24:41.000000', 'temperatura', 487.0000, 'ºC'),
	(263028, 118, '2014-04-01 00:24:42.000000', 'temperatura', 472.0000, 'ºC'),
	(263029, 118, '2014-04-01 00:24:43.000000', 'temperatura', 902.0000, 'ºC'),
	(263030, 118, '2014-04-01 00:24:44.000000', 'temperatura', 693.0000, 'ºC'),
	(263031, 118, '2014-04-01 00:24:45.000000', 'temperatura', 758.0000, 'ºC'),
	(263032, 118, '2014-04-01 00:24:46.000000', 'temperatura', 514.0000, 'ºC'),
	(263033, 118, '2014-04-01 00:24:47.000000', 'temperatura', 298.0000, 'ºC'),
	(263034, 118, '2014-04-01 00:24:48.000000', 'temperatura', 1146.0000, 'ºC'),
	(263035, 118, '2014-04-01 00:24:49.000000', 'temperatura', 37.0000, 'ºC'),
	(263036, 118, '2014-04-01 00:24:50.000000', 'temperatura', 349.0000, 'ºC'),
	(263037, 118, '2014-04-01 00:24:51.000000', 'temperatura', 432.0000, 'ºC'),
	(263038, 118, '2014-04-01 00:24:52.000000', 'temperatura', 1113.0000, 'ºC'),
	(263039, 118, '2014-04-01 00:24:53.000000', 'temperatura', 671.0000, 'ºC'),
	(263040, 118, '2014-04-01 00:24:54.000000', 'temperatura', 16.0000, 'ºC'),
	(263041, 118, '2014-04-01 00:24:55.000000', 'temperatura', 466.0000, 'ºC'),
	(263042, 118, '2014-04-01 00:24:56.000000', 'temperatura', 1084.0000, 'ºC'),
	(263043, 118, '2014-04-01 00:24:57.000000', 'temperatura', 421.0000, 'ºC'),
	(263044, 118, '2014-04-01 00:24:58.000000', 'temperatura', 53.0000, 'ºC'),
	(263045, 118, '2014-04-01 00:24:59.000000', 'temperatura', 202.0000, 'ºC'),
	(263046, 118, '2014-04-01 00:25:00.000000', 'temperatura', 853.0000, 'ºC'),
	(263047, 118, '2014-04-01 00:25:01.000000', 'temperatura', 57.0000, 'ºC'),
	(263048, 118, '2014-04-01 00:25:02.000000', 'temperatura', 129.0000, 'ºC'),
	(263049, 118, '2014-04-01 00:25:03.000000', 'temperatura', 475.0000, 'ºC'),
	(263050, 118, '2014-04-01 00:25:04.000000', 'temperatura', 787.0000, 'ºC'),
	(263051, 118, '2014-04-01 00:25:05.000000', 'temperatura', 110.0000, 'ºC'),
	(263052, 118, '2014-04-01 00:25:06.000000', 'temperatura', 592.0000, 'ºC'),
	(263053, 118, '2014-04-01 00:25:07.000000', 'temperatura', 230.0000, 'ºC'),
	(263054, 118, '2014-04-01 00:25:08.000000', 'temperatura', 573.0000, 'ºC'),
	(263055, 118, '2014-04-01 00:25:09.000000', 'temperatura', 977.0000, 'ºC'),
	(263056, 118, '2014-04-01 00:25:10.000000', 'temperatura', 767.0000, 'ºC'),
	(263057, 118, '2014-04-01 00:25:11.000000', 'temperatura', 905.0000, 'ºC'),
	(263058, 118, '2014-04-01 00:25:12.000000', 'temperatura', 1025.0000, 'ºC'),
	(263059, 118, '2014-04-01 00:25:13.000000', 'temperatura', 9.0000, 'ºC'),
	(263060, 118, '2014-04-01 00:25:14.000000', 'temperatura', 572.0000, 'ºC'),
	(263061, 118, '2014-04-01 00:25:15.000000', 'temperatura', 433.0000, 'ºC'),
	(263062, 118, '2014-04-01 00:25:16.000000', 'temperatura', 451.0000, 'ºC'),
	(263063, 118, '2014-04-01 00:25:17.000000', 'temperatura', 957.0000, 'ºC'),
	(263064, 118, '2014-04-01 00:25:18.000000', 'temperatura', 1032.0000, 'ºC'),
	(263065, 118, '2014-04-01 00:25:19.000000', 'temperatura', 1088.0000, 'ºC'),
	(263066, 118, '2014-04-01 00:25:20.000000', 'temperatura', 1146.0000, 'ºC'),
	(263067, 118, '2014-04-01 00:25:21.000000', 'temperatura', 68.0000, 'ºC'),
	(263068, 118, '2014-04-01 00:25:22.000000', 'temperatura', 499.0000, 'ºC'),
	(263069, 118, '2014-04-01 00:25:23.000000', 'temperatura', 1095.0000, 'ºC'),
	(263070, 118, '2014-04-01 00:25:24.000000', 'temperatura', 375.0000, 'ºC'),
	(263071, 118, '2014-04-01 00:25:25.000000', 'temperatura', 993.0000, 'ºC'),
	(263072, 118, '2014-04-01 00:25:26.000000', 'temperatura', 239.0000, 'ºC'),
	(263073, 118, '2014-04-01 00:25:27.000000', 'temperatura', 618.0000, 'ºC'),
	(263074, 118, '2014-04-01 00:25:28.000000', 'temperatura', 1172.0000, 'ºC'),
	(263075, 118, '2014-04-01 00:25:29.000000', 'temperatura', 407.0000, 'ºC'),
	(263076, 118, '2014-04-01 00:25:30.000000', 'temperatura', 921.0000, 'ºC'),
	(263077, 118, '2014-04-01 00:25:31.000000', 'temperatura', 983.0000, 'ºC'),
	(263078, 118, '2014-04-01 00:25:32.000000', 'temperatura', 953.0000, 'ºC'),
	(263079, 118, '2014-04-01 00:25:33.000000', 'temperatura', 617.0000, 'ºC'),
	(263080, 118, '2014-04-01 00:25:34.000000', 'temperatura', 226.0000, 'ºC'),
	(263081, 118, '2014-04-01 00:25:35.000000', 'temperatura', 480.0000, 'ºC'),
	(263082, 118, '2014-04-01 00:25:36.000000', 'temperatura', 524.0000, 'ºC'),
	(263083, 118, '2014-04-01 00:25:37.000000', 'temperatura', 1177.0000, 'ºC'),
	(263084, 118, '2014-04-01 00:25:38.000000', 'temperatura', 716.0000, 'ºC'),
	(263085, 118, '2014-04-01 00:25:39.000000', 'temperatura', 49.0000, 'ºC'),
	(263086, 118, '2014-04-01 00:25:40.000000', 'temperatura', 496.0000, 'ºC'),
	(263087, 118, '2014-04-01 00:25:41.000000', 'temperatura', 1132.0000, 'ºC'),
	(263088, 118, '2014-04-01 00:25:42.000000', 'temperatura', 576.0000, 'ºC'),
	(263089, 118, '2014-04-01 00:25:43.000000', 'temperatura', 683.0000, 'ºC'),
	(263090, 118, '2014-04-01 00:25:44.000000', 'temperatura', 487.0000, 'ºC'),
	(263091, 118, '2014-04-01 00:25:45.000000', 'temperatura', 389.0000, 'ºC'),
	(263092, 118, '2014-04-01 00:25:46.000000', 'temperatura', 482.0000, 'ºC'),
	(263093, 118, '2014-04-01 00:25:47.000000', 'temperatura', 44.0000, 'ºC'),
	(263094, 118, '2014-04-01 00:25:48.000000', 'temperatura', 1175.0000, 'ºC'),
	(263095, 118, '2014-04-01 00:25:49.000000', 'temperatura', 943.0000, 'ºC'),
	(263096, 118, '2014-04-01 00:25:50.000000', 'temperatura', 1191.0000, 'ºC'),
	(263097, 118, '2014-04-01 00:25:51.000000', 'temperatura', 725.0000, 'ºC'),
	(263098, 118, '2014-04-01 00:25:52.000000', 'temperatura', 54.0000, 'ºC'),
	(263099, 118, '2014-04-01 00:25:53.000000', 'temperatura', 496.0000, 'ºC'),
	(263100, 118, '2014-04-01 00:25:54.000000', 'temperatura', 1119.0000, 'ºC'),
	(263101, 118, '2014-04-01 00:25:55.000000', 'temperatura', 508.0000, 'ºC'),
	(263102, 118, '2014-04-01 00:25:56.000000', 'temperatura', 382.0000, 'ºC'),
	(263103, 118, '2014-04-01 00:25:57.000000', 'temperatura', 387.0000, 'ºC'),
	(263104, 118, '2014-04-01 00:25:58.000000', 'temperatura', 789.0000, 'ºC'),
	(263105, 118, '2014-04-01 00:25:59.000000', 'temperatura', 383.0000, 'ºC'),
	(263106, 118, '2014-04-01 00:26:00.000000', 'temperatura', 751.0000, 'ºC'),
	(263107, 118, '2014-04-01 00:26:01.000000', 'temperatura', 206.0000, 'ºC'),
	(263108, 118, '2014-04-01 00:26:02.000000', 'temperatura', 1178.0000, 'ºC'),
	(263109, 118, '2014-04-01 00:26:03.000000', 'temperatura', 473.0000, 'ºC'),
	(263110, 118, '2014-04-01 00:26:04.000000', 'temperatura', 32.0000, 'ºC'),
	(263111, 118, '2014-04-01 00:26:05.000000', 'temperatura', 1143.0000, 'ºC'),
	(263112, 118, '2014-04-01 00:26:06.000000', 'temperatura', 816.0000, 'ºC'),
	(263113, 118, '2014-04-01 00:26:07.000000', 'temperatura', 653.0000, 'ºC'),
	(263114, 118, '2014-04-01 00:26:08.000000', 'temperatura', 818.0000, 'ºC'),
	(263115, 118, '2014-04-01 00:26:09.000000', 'temperatura', 932.0000, 'ºC'),
	(263116, 118, '2014-04-01 00:26:10.000000', 'temperatura', 1005.0000, 'ºC'),
	(263117, 118, '2014-04-01 00:26:11.000000', 'temperatura', 1030.0000, 'ºC'),
	(263118, 118, '2014-04-01 00:26:12.000000', 'temperatura', 934.0000, 'ºC'),
	(263119, 118, '2014-04-01 00:26:13.000000', 'temperatura', 381.0000, 'ºC'),
	(263120, 118, '2014-04-01 00:26:14.000000', 'temperatura', 305.0000, 'ºC'),
	(263121, 118, '2014-04-01 00:26:15.000000', 'temperatura', 382.0000, 'ºC'),
	(263122, 118, '2014-04-01 00:26:16.000000', 'temperatura', 993.0000, 'ºC'),
	(263123, 118, '2014-04-01 00:26:17.000000', 'temperatura', 223.0000, 'ºC'),
	(263124, 118, '2014-04-01 00:26:18.000000', 'temperatura', 536.0000, 'ºC'),
	(263125, 118, '2014-04-01 00:26:19.000000', 'temperatura', 812.0000, 'ºC'),
	(263126, 118, '2014-04-01 00:26:20.000000', 'temperatura', 50.0000, 'ºC'),
	(263127, 118, '2014-04-01 00:26:21.000000', 'temperatura', 214.0000, 'ºC'),
	(263128, 118, '2014-04-01 00:26:22.000000', 'temperatura', 922.0000, 'ºC'),
	(263129, 118, '2014-04-01 00:26:23.000000', 'temperatura', 370.0000, 'ºC'),
	(263130, 118, '2014-04-01 00:26:24.000000', 'temperatura', 285.0000, 'ºC'),
	(263131, 118, '2014-04-01 00:26:25.000000', 'temperatura', 313.0000, 'ºC'),
	(263132, 118, '2014-04-01 00:26:26.000000', 'temperatura', 712.0000, 'ºC'),
	(263133, 118, '2014-04-01 00:26:27.000000', 'temperatura', 223.0000, 'ºC'),
	(263134, 118, '2014-04-01 00:26:28.000000', 'temperatura', 179.0000, 'ºC'),
	(263135, 118, '2014-04-01 00:26:29.000000', 'temperatura', 227.0000, 'ºC'),
	(263136, 118, '2014-04-01 00:26:30.000000', 'temperatura', 597.0000, 'ºC'),
	(263137, 118, '2014-04-01 00:26:31.000000', 'temperatura', 1103.0000, 'ºC'),
	(263138, 118, '2014-04-01 00:26:32.000000', 'temperatura', 128.0000, 'ºC'),
	(263139, 118, '2014-04-01 00:26:33.000000', 'temperatura', 928.0000, 'ºC'),
	(263140, 118, '2014-04-01 00:26:34.000000', 'temperatura', 660.0000, 'ºC'),
	(263141, 118, '2014-04-01 00:26:35.000000', 'temperatura', 514.0000, 'ºC'),
	(263142, 118, '2014-04-01 00:26:36.000000', 'temperatura', 592.0000, 'ºC'),
	(263143, 118, '2014-04-01 00:26:37.000000', 'temperatura', 220.0000, 'ºC'),
	(263144, 118, '2014-04-01 00:26:38.000000', 'temperatura', 521.0000, 'ºC'),
	(263145, 118, '2014-04-01 00:26:39.000000', 'temperatura', 748.0000, 'ºC'),
	(263146, 118, '2014-04-01 00:26:40.000000', 'temperatura', 976.0000, 'ºC'),
	(263147, 118, '2014-04-01 00:26:41.000000', 'temperatura', 238.0000, 'ºC'),
	(263148, 118, '2014-04-01 00:26:42.000000', 'temperatura', 661.0000, 'ºC'),
	(263149, 118, '2014-04-01 00:26:43.000000', 'temperatura', 190.0000, 'ºC'),
	(263150, 118, '2014-04-01 00:26:44.000000', 'temperatura', 170.0000, 'ºC'),
	(263151, 118, '2014-04-01 00:26:45.000000', 'temperatura', 281.0000, 'ºC'),
	(263152, 118, '2014-04-01 00:26:46.000000', 'temperatura', 897.0000, 'ºC'),
	(263153, 118, '2014-04-01 00:26:47.000000', 'temperatura', 39.0000, 'ºC'),
	(263154, 118, '2014-04-01 00:26:48.000000', 'temperatura', 1107.0000, 'ºC'),
	(263155, 118, '2014-04-01 00:26:49.000000', 'temperatura', 617.0000, 'ºC'),
	(263156, 118, '2014-04-01 00:26:50.000000', 'temperatura', 966.0000, 'ºC'),
	(263157, 118, '2014-04-01 00:26:51.000000', 'temperatura', 579.0000, 'ºC'),
	(263158, 118, '2014-04-01 00:26:52.000000', 'temperatura', 1197.0000, 'ºC'),
	(263159, 118, '2014-04-01 00:26:53.000000', 'temperatura', 651.0000, 'ºC'),
	(263160, 118, '2014-04-01 00:26:54.000000', 'temperatura', 862.0000, 'ºC'),
	(263161, 118, '2014-04-01 00:26:55.000000', 'temperatura', 1158.0000, 'ºC'),
	(263162, 118, '2014-04-01 00:26:56.000000', 'temperatura', 803.0000, 'ºC'),
	(263163, 118, '2014-04-01 00:26:57.000000', 'temperatura', 544.0000, 'ºC'),
	(263164, 118, '2014-04-01 00:26:58.000000', 'temperatura', 312.0000, 'ºC'),
	(263165, 118, '2014-04-01 00:26:59.000000', 'temperatura', 1129.0000, 'ºC'),
	(263166, 118, '2014-04-01 00:27:00.000000', 'temperatura', 1106.0000, 'ºC'),
	(263167, 118, '2014-04-01 00:27:01.000000', 'temperatura', 947.0000, 'ºC'),
	(263168, 118, '2014-04-01 00:27:02.000000', 'temperatura', 217.0000, 'ºC'),
	(263169, 118, '2014-04-01 00:27:03.000000', 'temperatura', 642.0000, 'ºC'),
	(263170, 118, '2014-04-01 00:27:04.000000', 'temperatura', 162.0000, 'ºC'),
	(263171, 118, '2014-04-01 00:27:05.000000', 'temperatura', 85.0000, 'ºC'),
	(263172, 118, '2014-04-01 00:27:06.000000', 'temperatura', 1137.0000, 'ºC'),
	(263173, 118, '2014-04-01 00:27:07.000000', 'temperatura', 630.0000, 'ºC'),
	(263174, 118, '2014-04-01 00:27:08.000000', 'temperatura', 940.0000, 'ºC'),
	(263175, 118, '2014-04-01 00:27:09.000000', 'temperatura', 412.0000, 'ºC'),
	(263176, 118, '2014-04-01 00:27:10.000000', 'temperatura', 441.0000, 'ºC'),
	(263177, 118, '2014-04-01 00:27:11.000000', 'temperatura', 967.0000, 'ºC'),
	(263178, 118, '2014-04-01 00:27:12.000000', 'temperatura', 1113.0000, 'ºC'),
	(263179, 118, '2014-04-01 00:27:13.000000', 'temperatura', 266.0000, 'ºC'),
	(263180, 118, '2014-04-01 00:27:14.000000', 'temperatura', 389.0000, 'ºC'),
	(263181, 118, '2014-04-01 00:27:15.000000', 'temperatura', 1150.0000, 'ºC'),
	(263182, 118, '2014-04-01 00:27:16.000000', 'temperatura', 984.0000, 'ºC'),
	(263183, 118, '2014-04-01 00:27:17.000000', 'temperatura', 268.0000, 'ºC'),
	(263184, 118, '2014-04-01 00:27:18.000000', 'temperatura', 788.0000, 'ºC'),
	(263185, 118, '2014-04-01 00:27:19.000000', 'temperatura', 737.0000, 'ºC'),
	(263186, 118, '2014-04-01 00:27:20.000000', 'temperatura', 121.0000, 'ºC'),
	(263187, 118, '2014-04-01 00:27:21.000000', 'temperatura', 796.0000, 'ºC'),
	(263188, 118, '2014-04-01 00:27:22.000000', 'temperatura', 19.0000, 'ºC'),
	(263189, 118, '2014-04-01 00:27:23.000000', 'temperatura', 104.0000, 'ºC'),
	(263190, 118, '2014-04-01 00:27:24.000000', 'temperatura', 466.0000, 'ºC'),
	(263191, 118, '2014-04-01 00:27:25.000000', 'temperatura', 819.0000, 'ºC'),
	(263192, 118, '2014-04-01 00:27:26.000000', 'temperatura', 297.0000, 'ºC'),
	(263193, 118, '2014-04-01 00:27:27.000000', 'temperatura', 229.0000, 'ºC'),
	(263194, 118, '2014-04-01 00:27:28.000000', 'temperatura', 256.0000, 'ºC'),
	(263195, 118, '2014-04-01 00:27:29.000000', 'temperatura', 592.0000, 'ºC'),
	(263196, 118, '2014-04-01 00:27:30.000000', 'temperatura', 994.0000, 'ºC'),
	(263197, 118, '2014-04-01 00:27:31.000000', 'temperatura', 794.0000, 'ºC'),
	(263198, 118, '2014-04-01 00:27:32.000000', 'temperatura', 989.0000, 'ºC'),
	(263199, 118, '2014-04-01 00:27:33.000000', 'temperatura', 164.0000, 'ºC'),
	(263200, 118, '2014-04-01 00:27:34.000000', 'temperatura', 251.0000, 'ºC'),
	(263201, 118, '2014-04-01 00:27:35.000000', 'temperatura', 763.0000, 'ºC'),
	(263202, 118, '2014-04-01 00:27:36.000000', 'temperatura', 664.0000, 'ºC'),
	(263203, 118, '2014-04-01 00:27:37.000000', 'temperatura', 1031.0000, 'ºC'),
	(263204, 118, '2014-04-01 00:27:38.000000', 'temperatura', 763.0000, 'ºC'),
	(263205, 118, '2014-04-01 00:27:39.000000', 'temperatura', 722.0000, 'ºC'),
	(263206, 118, '2014-04-01 00:27:40.000000', 'temperatura', 124.0000, 'ºC'),
	(263207, 118, '2014-04-01 00:27:41.000000', 'temperatura', 851.0000, 'ºC'),
	(263208, 118, '2014-04-01 00:27:42.000000', 'temperatura', 287.0000, 'ºC'),
	(263209, 118, '2014-04-01 00:27:43.000000', 'temperatura', 81.0000, 'ºC'),
	(263210, 118, '2014-04-01 00:27:44.000000', 'temperatura', 746.0000, 'ºC'),
	(263211, 118, '2014-04-01 00:27:45.000000', 'temperatura', 1086.0000, 'ºC'),
	(263212, 118, '2014-04-01 00:27:46.000000', 'temperatura', 795.0000, 'ºC'),
	(263213, 118, '2014-04-01 00:27:47.000000', 'temperatura', 714.0000, 'ºC'),
	(263214, 118, '2014-04-01 00:27:48.000000', 'temperatura', 1189.0000, 'ºC'),
	(263215, 118, '2014-04-01 00:27:49.000000', 'temperatura', 200.0000, 'ºC'),
	(263216, 118, '2014-04-01 00:27:50.000000', 'temperatura', 1036.0000, 'ºC'),
	(263217, 118, '2014-04-01 00:27:51.000000', 'temperatura', 981.0000, 'ºC'),
	(263218, 118, '2014-04-01 00:27:52.000000', 'temperatura', 595.0000, 'ºC'),
	(263219, 118, '2014-04-01 00:27:53.000000', 'temperatura', 35.0000, 'ºC'),
	(263220, 118, '2014-04-01 00:27:54.000000', 'temperatura', 789.0000, 'ºC'),
	(263221, 118, '2014-04-01 00:27:55.000000', 'temperatura', 239.0000, 'ºC'),
	(263222, 118, '2014-04-01 00:27:56.000000', 'temperatura', 30.0000, 'ºC'),
	(263223, 118, '2014-04-01 00:27:57.000000', 'temperatura', 632.0000, 'ºC'),
	(263224, 118, '2014-04-01 00:27:58.000000', 'temperatura', 673.0000, 'ºC'),
	(263225, 118, '2014-04-01 00:27:59.000000', 'temperatura', 270.0000, 'ºC'),
	(263226, 118, '2014-04-01 00:28:00.000000', 'temperatura', 530.0000, 'ºC'),
	(263227, 118, '2014-04-01 00:28:01.000000', 'temperatura', 642.0000, 'ºC'),
	(263228, 118, '2014-04-01 00:28:02.000000', 'temperatura', 419.0000, 'ºC'),
	(263229, 118, '2014-04-01 00:28:03.000000', 'temperatura', 171.0000, 'ºC'),
	(263230, 118, '2014-04-01 00:28:04.000000', 'temperatura', 798.0000, 'ºC'),
	(263231, 118, '2014-04-01 00:28:05.000000', 'temperatura', 1078.0000, 'ºC'),
	(263232, 118, '2014-04-01 00:28:06.000000', 'temperatura', 595.0000, 'ºC'),
	(263233, 118, '2014-04-01 00:28:07.000000', 'temperatura', 942.0000, 'ºC'),
	(263234, 118, '2014-04-01 00:28:08.000000', 'temperatura', 526.0000, 'ºC'),
	(263235, 118, '2014-04-01 00:28:09.000000', 'temperatura', 1003.0000, 'ºC'),
	(263236, 118, '2014-04-01 00:28:10.000000', 'temperatura', 1037.0000, 'ºC'),
	(263237, 118, '2014-04-01 00:28:11.000000', 'temperatura', 980.0000, 'ºC'),
	(263238, 118, '2014-04-01 00:28:12.000000', 'temperatura', 586.0000, 'ºC'),
	(263239, 118, '2014-04-01 00:28:13.000000', 'temperatura', 1192.0000, 'ºC'),
	(263240, 118, '2014-04-01 00:28:14.000000', 'temperatura', 601.0000, 'ºC'),
	(263241, 118, '2014-04-01 00:28:15.000000', 'temperatura', 632.0000, 'ºC'),
	(263242, 118, '2014-04-01 00:28:16.000000', 'temperatura', 156.0000, 'ºC'),
	(263243, 118, '2014-04-01 00:28:17.000000', 'temperatura', 86.0000, 'ºC'),
	(263244, 118, '2014-04-01 00:28:18.000000', 'temperatura', 1163.0000, 'ºC'),
	(263245, 118, '2014-04-01 00:28:19.000000', 'temperatura', 758.0000, 'ºC'),
	(263246, 118, '2014-04-01 00:28:20.000000', 'temperatura', 299.0000, 'ºC'),
	(263247, 118, '2014-04-01 00:28:21.000000', 'temperatura', 423.0000, 'ºC'),
	(263248, 118, '2014-04-01 00:28:22.000000', 'temperatura', 16.0000, 'ºC'),
	(263249, 118, '2014-04-01 00:28:23.000000', 'temperatura', 15.0000, 'ºC'),
	(263250, 118, '2014-04-01 00:28:24.000000', 'temperatura', 25.0000, 'ºC'),
	(263251, 118, '2014-04-01 00:28:25.000000', 'temperatura', 80.0000, 'ºC'),
	(263252, 118, '2014-04-01 00:28:26.000000', 'temperatura', 326.0000, 'ºC'),
	(263253, 118, '2014-04-01 00:28:27.000000', 'temperatura', 193.0000, 'ºC'),
	(263254, 118, '2014-04-01 00:28:28.000000', 'temperatura', 1185.0000, 'ºC'),
	(263255, 118, '2014-04-01 00:28:29.000000', 'temperatura', 547.0000, 'ºC'),
	(263256, 118, '2014-04-01 00:28:30.000000', 'temperatura', 379.0000, 'ºC'),
	(263257, 118, '2014-04-01 00:28:31.000000', 'temperatura', 257.0000, 'ºC'),
	(263258, 118, '2014-04-01 00:28:32.000000', 'temperatura', 146.0000, 'ºC'),
	(263259, 118, '2014-04-01 00:28:33.000000', 'temperatura', 1163.0000, 'ºC'),
	(263260, 118, '2014-04-01 00:28:34.000000', 'temperatura', 574.0000, 'ºC'),
	(263261, 118, '2014-04-01 00:28:35.000000', 'temperatura', 582.0000, 'ºC'),
	(263262, 118, '2014-04-01 00:28:36.000000', 'temperatura', 1187.0000, 'ºC'),
	(263263, 118, '2014-04-01 00:28:37.000000', 'temperatura', 592.0000, 'ºC'),
	(263264, 118, '2014-04-01 00:28:38.000000', 'temperatura', 598.0000, 'ºC'),
	(263265, 118, '2014-04-01 00:28:39.000000', 'temperatura', 16.0000, 'ºC'),
	(263266, 118, '2014-04-01 00:28:40.000000', 'temperatura', 685.0000, 'ºC'),
	(263267, 118, '2014-04-01 00:28:41.000000', 'temperatura', 976.0000, 'ºC'),
	(263268, 118, '2014-04-01 00:28:42.000000', 'temperatura', 429.0000, 'ºC'),
	(263269, 118, '2014-04-01 00:28:43.000000', 'temperatura', 415.0000, 'ºC'),
	(263270, 118, '2014-04-01 00:28:44.000000', 'temperatura', 788.0000, 'ºC'),
	(263271, 118, '2014-04-01 00:28:45.000000', 'temperatura', 297.0000, 'ºC'),
	(263272, 118, '2014-04-01 00:28:46.000000', 'temperatura', 320.0000, 'ºC'),
	(263273, 118, '2014-04-01 00:28:47.000000', 'temperatura', 709.0000, 'ºC'),
	(263274, 118, '2014-04-01 00:28:48.000000', 'temperatura', 187.0000, 'ºC'),
	(263275, 118, '2014-04-01 00:28:49.000000', 'temperatura', 6.0000, 'ºC'),
	(263276, 118, '2014-04-01 00:28:50.000000', 'temperatura', 671.0000, 'ºC'),
	(263277, 118, '2014-04-01 00:28:51.000000', 'temperatura', 938.0000, 'ºC'),
	(263278, 118, '2014-04-01 00:28:52.000000', 'temperatura', 275.0000, 'ºC'),
	(263279, 118, '2014-04-01 00:28:53.000000', 'temperatura', 964.0000, 'ºC'),
	(263280, 118, '2014-04-01 00:28:54.000000', 'temperatura', 395.0000, 'ºC'),
	(263281, 118, '2014-04-01 00:28:55.000000', 'temperatura', 285.0000, 'ºC'),
	(263282, 118, '2014-04-01 00:28:56.000000', 'temperatura', 240.0000, 'ºC'),
	(263283, 118, '2014-04-01 00:28:57.000000', 'temperatura', 347.0000, 'ºC'),
	(263284, 118, '2014-04-01 00:28:58.000000', 'temperatura', 1014.0000, 'ºC'),
	(263285, 118, '2014-04-01 00:28:59.000000', 'temperatura', 430.0000, 'ºC'),
	(263286, 118, '2014-04-01 00:29:00.000000', 'temperatura', 308.0000, 'ºC'),
	(263287, 118, '2014-04-01 00:29:01.000000', 'temperatura', 253.0000, 'ºC'),
	(263288, 118, '2014-04-01 00:29:02.000000', 'temperatura', 338.0000, 'ºC'),
	(263289, 118, '2014-04-01 00:29:03.000000', 'temperatura', 935.0000, 'ºC'),
	(263290, 118, '2014-04-01 00:29:04.000000', 'temperatura', 60.0000, 'ºC'),
	(263291, 118, '2014-04-01 00:29:05.000000', 'temperatura', 1094.0000, 'ºC'),
	(263292, 118, '2014-04-01 00:29:06.000000', 'temperatura', 493.0000, 'ºC'),
	(263293, 118, '2014-04-01 00:29:07.000000', 'temperatura', 382.0000, 'ºC'),
	(263294, 118, '2014-04-01 00:29:08.000000', 'temperatura', 431.0000, 'ºC'),
	(263295, 118, '2014-04-01 00:29:09.000000', 'temperatura', 1010.0000, 'ºC'),
	(263296, 118, '2014-04-01 00:29:10.000000', 'temperatura', 159.0000, 'ºC'),
	(263297, 118, '2014-04-01 00:29:11.000000', 'temperatura', 164.0000, 'ºC'),
	(263298, 118, '2014-04-01 00:29:12.000000', 'temperatura', 343.0000, 'ºC'),
	(263299, 118, '2014-04-01 00:29:13.000000', 'temperatura', 25.0000, 'ºC'),
	(263300, 118, '2014-04-01 00:29:14.000000', 'temperatura', 295.0000, 'ºC'),
	(263301, 118, '2014-04-01 00:29:15.000000', 'temperatura', 203.0000, 'ºC'),
	(263302, 118, '2014-04-01 00:29:16.000000', 'temperatura', 129.0000, 'ºC'),
	(263303, 118, '2014-04-01 00:29:17.000000', 'temperatura', 37.0000, 'ºC'),
	(263304, 118, '2014-04-01 00:29:18.000000', 'temperatura', 998.0000, 'ºC'),
	(263305, 118, '2014-04-01 00:29:19.000000', 'temperatura', 81.0000, 'ºC'),
	(263306, 118, '2014-04-01 00:29:20.000000', 'temperatura', 1012.0000, 'ºC'),
	(263307, 118, '2014-04-01 00:29:21.000000', 'temperatura', 19.0000, 'ºC'),
	(263308, 118, '2014-04-01 00:29:22.000000', 'temperatura', 656.0000, 'ºC'),
	(263309, 118, '2014-04-01 00:29:23.000000', 'temperatura', 825.0000, 'ºC'),
	(263310, 118, '2014-04-01 00:29:24.000000', 'temperatura', 956.0000, 'ºC'),
	(263311, 118, '2014-04-01 00:29:25.000000', 'temperatura', 1106.0000, 'ºC'),
	(263312, 118, '2014-04-01 00:29:26.000000', 'temperatura', 263.0000, 'ºC'),
	(263313, 118, '2014-04-01 00:29:27.000000', 'temperatura', 396.0000, 'ºC'),
	(263314, 118, '2014-04-01 00:29:28.000000', 'temperatura', 1191.0000, 'ºC'),
	(263315, 118, '2014-04-01 00:29:29.000000', 'temperatura', 1168.0000, 'ºC'),
	(263316, 118, '2014-04-01 00:29:30.000000', 'temperatura', 1067.0000, 'ºC'),
	(263317, 118, '2014-04-01 00:29:31.000000', 'temperatura', 633.0000, 'ºC'),
	(263318, 118, '2014-04-01 00:29:32.000000', 'temperatura', 1163.0000, 'ºC'),
	(263319, 118, '2014-04-01 00:29:33.000000', 'temperatura', 315.0000, 'ºC'),
	(263320, 118, '2014-04-01 00:29:34.000000', 'temperatura', 488.0000, 'ºC'),
	(263321, 118, '2014-04-01 00:29:35.000000', 'temperatura', 296.0000, 'ºC'),
	(263322, 118, '2014-04-01 00:29:36.000000', 'temperatura', 15.0000, 'ºC'),
	(263323, 118, '2014-04-01 00:29:37.000000', 'temperatura', 389.0000, 'ºC'),
	(263324, 118, '2014-04-01 00:29:38.000000', 'temperatura', 700.0000, 'ºC'),
	(263325, 118, '2014-04-01 00:29:39.000000', 'temperatura', 1136.0000, 'ºC'),
	(263326, 118, '2014-04-01 00:29:40.000000', 'temperatura', 1177.0000, 'ºC'),
	(263327, 118, '2014-04-01 00:29:41.000000', 'temperatura', 79.0000, 'ºC'),
	(263328, 118, '2014-04-01 00:29:42.000000', 'temperatura', 466.0000, 'ºC'),
	(263329, 118, '2014-04-01 00:29:43.000000', 'temperatura', 893.0000, 'ºC'),
	(263330, 118, '2014-04-01 00:29:44.000000', 'temperatura', 669.0000, 'ºC'),
	(263331, 118, '2014-04-01 00:29:45.000000', 'temperatura', 666.0000, 'ºC'),
	(263332, 118, '2014-04-01 00:29:46.000000', 'temperatura', 122.0000, 'ºC'),
	(263333, 118, '2014-04-01 00:29:47.000000', 'temperatura', 1013.0000, 'ºC'),
	(263334, 118, '2014-04-01 00:29:48.000000', 'temperatura', 1101.0000, 'ºC'),
	(263335, 118, '2014-04-01 00:29:49.000000', 'temperatura', 65.0000, 'ºC'),
	(263336, 118, '2014-04-01 00:29:50.000000', 'temperatura', 622.0000, 'ºC'),
	(263337, 118, '2014-04-01 00:29:51.000000', 'temperatura', 516.0000, 'ºC'),
	(263338, 118, '2014-04-01 00:29:52.000000', 'temperatura', 712.0000, 'ºC'),
	(263339, 118, '2014-04-01 00:29:53.000000', 'temperatura', 816.0000, 'ºC'),
	(263340, 118, '2014-04-01 00:29:54.000000', 'temperatura', 744.0000, 'ºC'),
	(263341, 118, '2014-04-01 00:29:55.000000', 'temperatura', 72.0000, 'ºC'),
	(263342, 118, '2014-04-01 00:29:56.000000', 'temperatura', 526.0000, 'ºC'),
	(263343, 118, '2014-04-01 00:29:57.000000', 'temperatura', 18.0000, 'ºC'),
	(263344, 118, '2014-04-01 00:29:58.000000', 'temperatura', 911.0000, 'ºC'),
	(263345, 118, '2014-04-01 00:29:59.000000', 'temperatura', 900.0000, 'ºC'),
	(263346, 118, '2014-04-01 00:30:00.000000', 'temperatura', 571.0000, 'ºC'),
	(263347, 118, '2014-04-01 00:30:01.000000', 'temperatura', 153.0000, 'ºC'),
	(263348, 118, '2014-04-01 00:30:02.000000', 'temperatura', 251.0000, 'ºC'),
	(263349, 118, '2014-04-01 00:30:03.000000', 'temperatura', 798.0000, 'ºC'),
	(263350, 118, '2014-04-01 00:30:04.000000', 'temperatura', 838.0000, 'ºC'),
	(263351, 118, '2014-04-01 00:30:05.000000', 'temperatura', 596.0000, 'ºC'),
	(263352, 118, '2014-04-01 00:30:06.000000', 'temperatura', 467.0000, 'ºC'),
	(263353, 118, '2014-04-01 00:30:07.000000', 'temperatura', 549.0000, 'ºC'),
	(263354, 118, '2014-04-01 00:30:08.000000', 'temperatura', 142.0000, 'ºC'),
	(263355, 118, '2014-04-01 00:30:09.000000', 'temperatura', 264.0000, 'ºC'),
	(263356, 118, '2014-04-01 00:30:10.000000', 'temperatura', 895.0000, 'ºC'),
	(263357, 118, '2014-04-01 00:30:11.000000', 'temperatura', 82.0000, 'ºC'),
	(263358, 118, '2014-04-01 00:30:12.000000', 'temperatura', 125.0000, 'ºC'),
	(263359, 118, '2014-04-01 00:30:13.000000', 'temperatura', 382.0000, 'ºC'),
	(263360, 118, '2014-04-01 00:30:14.000000', 'temperatura', 335.0000, 'ºC'),
	(263361, 118, '2014-04-01 00:30:15.000000', 'temperatura', 528.0000, 'ºC'),
	(263362, 118, '2014-04-01 00:30:16.000000', 'temperatura', 437.0000, 'ºC'),
	(263363, 118, '2014-04-01 00:30:17.000000', 'temperatura', 601.0000, 'ºC'),
	(263364, 118, '2014-04-01 00:30:18.000000', 'temperatura', 493.0000, 'ºC'),
	(263365, 118, '2014-04-01 00:30:19.000000', 'temperatura', 663.0000, 'ºC'),
	(263366, 118, '2014-04-01 00:30:20.000000', 'temperatura', 635.0000, 'ºC'),
	(263367, 118, '2014-04-01 00:30:21.000000', 'temperatura', 1187.0000, 'ºC'),
	(263368, 118, '2014-04-01 00:30:22.000000', 'temperatura', 433.0000, 'ºC'),
	(263369, 118, '2014-04-01 00:30:23.000000', 'temperatura', 1004.0000, 'ºC'),
	(263370, 118, '2014-04-01 00:30:24.000000', 'temperatura', 120.0000, 'ºC'),
	(263371, 118, '2014-04-01 00:30:25.000000', 'temperatura', 1191.0000, 'ºC'),
	(263372, 118, '2014-04-01 00:30:26.000000', 'temperatura', 794.0000, 'ºC'),
	(263373, 118, '2014-04-01 00:30:27.000000', 'temperatura', 396.0000, 'ºC'),
	(263374, 118, '2014-04-01 00:30:28.000000', 'temperatura', 802.0000, 'ºC'),
	(263375, 118, '2014-04-01 00:30:29.000000', 'temperatura', 420.0000, 'ºC'),
	(263376, 118, '2014-04-01 00:30:30.000000', 'temperatura', 893.0000, 'ºC'),
	(263377, 118, '2014-04-01 00:30:31.000000', 'temperatura', 808.0000, 'ºC'),
	(263378, 118, '2014-04-01 00:30:32.000000', 'temperatura', 160.0000, 'ºC'),
	(263379, 118, '2014-04-01 00:30:33.000000', 'temperatura', 775.0000, 'ºC'),
	(263380, 118, '2014-04-01 00:30:34.000000', 'temperatura', 997.0000, 'ºC'),
	(263381, 118, '2014-04-01 00:30:35.000000', 'temperatura', 261.0000, 'ºC'),
	(263382, 118, '2014-04-01 00:30:36.000000', 'temperatura', 713.0000, 'ºC'),
	(263383, 118, '2014-04-01 00:30:37.000000', 'temperatura', 384.0000, 'ºC'),
	(263384, 118, '2014-04-01 00:30:38.000000', 'temperatura', 982.0000, 'ºC'),
	(263385, 118, '2014-04-01 00:30:39.000000', 'temperatura', 156.0000, 'ºC'),
	(263386, 118, '2014-04-01 00:30:40.000000', 'temperatura', 235.0000, 'ºC'),
	(263387, 118, '2014-04-01 00:30:41.000000', 'temperatura', 708.0000, 'ºC'),
	(263388, 118, '2014-04-01 00:30:42.000000', 'temperatura', 433.0000, 'ºC'),
	(263389, 118, '2014-04-01 00:30:43.000000', 'temperatura', 45.0000, 'ºC'),
	(263390, 118, '2014-04-01 00:30:44.000000', 'temperatura', 126.0000, 'ºC'),
	(263391, 118, '2014-04-01 00:30:45.000000', 'temperatura', 493.0000, 'ºC'),
	(263392, 118, '2014-04-01 00:30:46.000000', 'temperatura', 888.0000, 'ºC'),
	(263393, 118, '2014-04-01 00:30:47.000000', 'temperatura', 563.0000, 'ºC'),
	(263394, 118, '2014-04-01 00:30:48.000000', 'temperatura', 152.0000, 'ºC'),
	(263395, 118, '2014-04-01 00:30:49.000000', 'temperatura', 272.0000, 'ºC'),
	(263396, 118, '2014-04-01 00:30:50.000000', 'temperatura', 903.0000, 'ºC'),
	(263397, 118, '2014-04-01 00:30:51.000000', 'temperatura', 99.0000, 'ºC'),
	(263398, 118, '2014-04-01 00:30:52.000000', 'temperatura', 186.0000, 'ºC'),
	(263399, 118, '2014-04-01 00:30:53.000000', 'temperatura', 635.0000, 'ºC'),
	(263400, 118, '2014-04-01 00:30:54.000000', 'temperatura', 217.0000, 'ºC'),
	(263401, 118, '2014-04-01 00:30:55.000000', 'temperatura', 380.0000, 'ºC'),
	(263402, 118, '2014-04-01 00:30:56.000000', 'temperatura', 48.0000, 'ºC'),
	(263403, 118, '2014-04-01 00:30:57.000000', 'temperatura', 304.0000, 'ºC'),
	(263404, 118, '2014-04-01 00:30:58.000000', 'temperatura', 174.0000, 'ºC'),
	(263405, 118, '2014-04-01 00:30:59.000000', 'temperatura', 1158.0000, 'ºC'),
	(263406, 118, '2014-04-01 00:31:00.000000', 'temperatura', 470.0000, 'ºC'),
	(263407, 118, '2014-04-01 00:31:01.000000', 'temperatura', 74.0000, 'ºC'),
	(263408, 118, '2014-04-01 00:31:02.000000', 'temperatura', 163.0000, 'ºC'),
	(263409, 118, '2014-04-01 00:31:03.000000', 'temperatura', 593.0000, 'ºC'),
	(263410, 118, '2014-04-01 00:31:04.000000', 'temperatura', 77.0000, 'ºC'),
	(263411, 118, '2014-04-01 00:31:05.000000', 'temperatura', 1006.0000, 'ºC'),
	(263412, 118, '2014-04-01 00:31:06.000000', 'temperatura', 1198.0000, 'ºC'),
	(263413, 118, '2014-04-01 00:31:07.000000', 'temperatura', 573.0000, 'ºC'),
	(263414, 118, '2014-04-01 00:31:08.000000', 'temperatura', 472.0000, 'ºC'),
	(263415, 118, '2014-04-01 00:31:09.000000', 'temperatura', 641.0000, 'ºC'),
	(263416, 118, '2014-04-01 00:31:10.000000', 'temperatura', 590.0000, 'ºC'),
	(263417, 118, '2014-04-01 00:31:11.000000', 'temperatura', 1027.0000, 'ºC'),
	(263418, 118, '2014-04-01 00:31:12.000000', 'temperatura', 966.0000, 'ºC'),
	(263419, 118, '2014-04-01 00:31:13.000000', 'temperatura', 549.0000, 'ºC'),
	(263420, 118, '2014-04-01 00:31:14.000000', 'temperatura', 1046.0000, 'ºC'),
	(263421, 118, '2014-04-01 00:31:15.000000', 'temperatura', 1185.0000, 'ºC'),
	(263422, 118, '2014-04-01 00:31:16.000000', 'temperatura', 388.0000, 'ºC'),
	(263423, 118, '2014-04-01 00:31:17.000000', 'temperatura', 787.0000, 'ºC'),
	(263424, 118, '2014-04-01 00:31:18.000000', 'temperatura', 369.0000, 'ºC'),
	(263425, 118, '2014-04-01 00:31:19.000000', 'temperatura', 683.0000, 'ºC'),
	(263426, 118, '2014-04-01 00:31:20.000000', 'temperatura', 1111.0000, 'ºC'),
	(263427, 118, '2014-04-01 00:31:21.000000', 'temperatura', 1106.0000, 'ºC'),
	(263428, 118, '2014-04-01 00:31:22.000000', 'temperatura', 996.0000, 'ºC'),
	(263429, 118, '2014-04-01 00:31:23.000000', 'temperatura', 463.0000, 'ºC'),
	(263430, 118, '2014-04-01 00:31:24.000000', 'temperatura', 528.0000, 'ºC'),
	(263431, 118, '2014-04-01 00:31:25.000000', 'temperatura', 53.0000, 'ºC'),
	(263432, 118, '2014-04-01 00:31:26.000000', 'temperatura', 1080.0000, 'ºC'),
	(263433, 118, '2014-04-01 00:31:27.000000', 'temperatura', 443.0000, 'ºC'),
	(263434, 118, '2014-04-01 00:31:28.000000', 'temperatura', 175.0000, 'ºC'),
	(263435, 118, '2014-04-01 00:31:29.000000', 'temperatura', 747.0000, 'ºC'),
	(263436, 118, '2014-04-01 00:31:30.000000', 'temperatura', 809.0000, 'ºC'),
	(263437, 118, '2014-04-01 00:31:31.000000', 'temperatura', 604.0000, 'ºC'),
	(263438, 118, '2014-04-01 00:31:32.000000', 'temperatura', 595.0000, 'ºC'),
	(263439, 118, '2014-04-01 00:31:33.000000', 'temperatura', 1161.0000, 'ºC'),
	(263440, 118, '2014-04-01 00:31:34.000000', 'temperatura', 424.0000, 'ºC'),
	(263441, 118, '2014-04-01 00:31:35.000000', 'temperatura', 1036.0000, 'ºC'),
	(263442, 118, '2014-04-01 00:31:36.000000', 'temperatura', 308.0000, 'ºC'),
	(263443, 118, '2014-04-01 00:31:37.000000', 'temperatura', 832.0000, 'ºC'),
	(263444, 118, '2014-04-01 00:31:38.000000', 'temperatura', 836.0000, 'ºC'),
	(263445, 118, '2014-04-01 00:31:39.000000', 'temperatura', 486.0000, 'ºC'),
	(263446, 118, '2014-04-01 00:31:40.000000', 'temperatura', 1122.0000, 'ºC'),
	(263447, 118, '2014-04-01 00:31:41.000000', 'temperatura', 551.0000, 'ºC'),
	(263448, 118, '2014-04-01 00:31:42.000000', 'temperatura', 591.0000, 'ºC'),
	(263449, 118, '2014-04-01 00:31:43.000000', 'temperatura', 104.0000, 'ºC'),
	(263450, 118, '2014-04-01 00:31:44.000000', 'temperatura', 1147.0000, 'ºC'),
	(263451, 118, '2014-04-01 00:31:45.000000', 'temperatura', 624.0000, 'ºC'),
	(263452, 118, '2014-04-01 00:31:46.000000', 'temperatura', 877.0000, 'ºC'),
	(263453, 118, '2014-04-01 00:31:47.000000', 'temperatura', 114.0000, 'ºC'),
	(263454, 118, '2014-04-01 00:31:48.000000', 'temperatura', 340.0000, 'ºC'),
	(263455, 118, '2014-04-01 00:31:49.000000', 'temperatura', 158.0000, 'ºC'),
	(263456, 118, '2014-04-01 00:31:50.000000', 'temperatura', 971.0000, 'ºC'),
	(263457, 118, '2014-04-01 00:31:51.000000', 'temperatura', 780.0000, 'ºC'),
	(263458, 118, '2014-04-01 00:31:52.000000', 'temperatura', 987.0000, 'ºC'),
	(263459, 118, '2014-04-01 00:31:53.000000', 'temperatura', 197.0000, 'ºC'),
	(263460, 118, '2014-04-01 00:31:54.000000', 'temperatura', 425.0000, 'ºC'),
	(263461, 118, '2014-04-01 00:31:55.000000', 'temperatura', 336.0000, 'ºC'),
	(263462, 118, '2014-04-01 00:31:56.000000', 'temperatura', 402.0000, 'ºC'),
	(263463, 118, '2014-04-01 00:31:57.000000', 'temperatura', 1004.0000, 'ºC'),
	(263464, 118, '2014-04-01 00:31:58.000000', 'temperatura', 214.0000, 'ºC'),
	(263465, 118, '2014-04-01 00:31:59.000000', 'temperatura', 461.0000, 'ºC'),
	(263466, 118, '2014-04-01 00:32:00.000000', 'temperatura', 460.0000, 'ºC'),
	(263467, 118, '2014-04-01 00:32:01.000000', 'temperatura', 920.0000, 'ºC'),
	(263468, 118, '2014-04-01 00:32:02.000000', 'temperatura', 821.0000, 'ºC'),
	(263469, 118, '2014-04-01 00:32:03.000000', 'temperatura', 144.0000, 'ºC'),
	(263470, 118, '2014-04-01 00:32:04.000000', 'temperatura', 659.0000, 'ºC'),
	(263471, 118, '2014-04-01 00:32:05.000000', 'temperatura', 461.0000, 'ºC'),
	(263472, 118, '2014-04-01 00:32:06.000000', 'temperatura', 329.0000, 'ºC'),
	(263473, 118, '2014-04-01 00:32:07.000000', 'temperatura', 263.0000, 'ºC'),
	(263474, 118, '2014-04-01 00:32:08.000000', 'temperatura', 329.0000, 'ºC'),
	(263475, 118, '2014-04-01 00:32:09.000000', 'temperatura', 857.0000, 'ºC'),
	(263476, 118, '2014-04-01 00:32:10.000000', 'temperatura', 897.0000, 'ºC'),
	(263477, 118, '2014-04-01 00:32:11.000000', 'temperatura', 717.0000, 'ºC'),
	(263478, 118, '2014-04-01 00:32:12.000000', 'temperatura', 894.0000, 'ºC'),
	(263479, 118, '2014-04-01 00:32:13.000000', 'temperatura', 1121.0000, 'ºC'),
	(263480, 118, '2014-04-01 00:32:14.000000', 'temperatura', 521.0000, 'ºC'),
	(263481, 118, '2014-04-01 00:32:15.000000', 'temperatura', 443.0000, 'ºC'),
	(263482, 118, '2014-04-01 00:32:16.000000', 'temperatura', 652.0000, 'ºC'),
	(263483, 118, '2014-04-01 00:32:17.000000', 'temperatura', 734.0000, 'ºC'),
	(263484, 118, '2014-04-01 00:32:18.000000', 'temperatura', 511.0000, 'ºC'),
	(263485, 118, '2014-04-01 00:32:19.000000', 'temperatura', 357.0000, 'ºC'),
	(263486, 118, '2014-04-01 00:32:20.000000', 'temperatura', 250.0000, 'ºC'),
	(263487, 118, '2014-04-01 00:32:21.000000', 'temperatura', 181.0000, 'ºC'),
	(263488, 118, '2014-04-01 00:32:22.000000', 'temperatura', 154.0000, 'ºC'),
	(263489, 118, '2014-04-01 00:32:23.000000', 'temperatura', 227.0000, 'ºC'),
	(263490, 118, '2014-04-01 00:32:24.000000', 'temperatura', 675.0000, 'ºC'),
	(263491, 118, '2014-04-01 00:32:25.000000', 'temperatura', 293.0000, 'ºC'),
	(263492, 118, '2014-04-01 00:32:26.000000', 'temperatura', 642.0000, 'ºC'),
	(263493, 118, '2014-04-01 00:32:27.000000', 'temperatura', 1131.0000, 'ºC'),
	(263494, 118, '2014-04-01 00:32:28.000000', 'temperatura', 130.0000, 'ºC'),
	(263495, 118, '2014-04-01 00:32:29.000000', 'temperatura', 856.0000, 'ºC'),
	(263496, 118, '2014-04-01 00:32:30.000000', 'temperatura', 293.0000, 'ºC'),
	(263497, 118, '2014-04-01 00:32:31.000000', 'temperatura', 95.0000, 'ºC'),
	(263498, 118, '2014-04-01 00:32:32.000000', 'temperatura', 796.0000, 'ºC'),
	(263499, 118, '2014-04-01 00:32:33.000000', 'temperatura', 96.0000, 'ºC'),
	(263500, 118, '2014-04-01 00:32:34.000000', 'temperatura', 494.0000, 'ºC'),
	(263501, 118, '2014-04-01 00:32:35.000000', 'temperatura', 981.0000, 'ºC'),
	(263502, 118, '2014-04-01 00:32:36.000000', 'temperatura', 1025.0000, 'ºC'),
	(263503, 118, '2014-04-01 00:32:37.000000', 'temperatura', 984.0000, 'ºC'),
	(263504, 118, '2014-04-01 00:32:38.000000', 'temperatura', 642.0000, 'ºC'),
	(263505, 118, '2014-04-01 00:32:39.000000', 'temperatura', 262.0000, 'ºC'),
	(263506, 118, '2014-04-01 00:32:40.000000', 'temperatura', 582.0000, 'ºC'),
	(263507, 118, '2014-04-01 00:32:41.000000', 'temperatura', 926.0000, 'ºC'),
	(263508, 118, '2014-04-01 00:32:42.000000', 'temperatura', 484.0000, 'ºC'),
	(263509, 118, '2014-04-01 00:32:43.000000', 'temperatura', 842.0000, 'ºC'),
	(263510, 118, '2014-04-01 00:32:44.000000', 'temperatura', 360.0000, 'ºC'),
	(263511, 118, '2014-04-01 00:32:45.000000', 'temperatura', 474.0000, 'ºC'),
	(263512, 118, '2014-04-01 00:32:46.000000', 'temperatura', 89.0000, 'ºC'),
	(263513, 118, '2014-04-01 00:32:47.000000', 'temperatura', 224.0000, 'ºC'),
	(263514, 118, '2014-04-01 00:32:48.000000', 'temperatura', 852.0000, 'ºC'),
	(263515, 118, '2014-04-01 00:32:49.000000', 'temperatura', 1192.0000, 'ºC'),
	(263516, 118, '2014-04-01 00:32:50.000000', 'temperatura', 1002.0000, 'ºC'),
	(263517, 118, '2014-04-01 00:32:51.000000', 'temperatura', 234.0000, 'ºC'),
	(263518, 118, '2014-04-01 00:32:52.000000', 'temperatura', 565.0000, 'ºC'),
	(263519, 118, '2014-04-01 00:32:53.000000', 'temperatura', 922.0000, 'ºC'),
	(263520, 118, '2014-04-01 00:32:54.000000', 'temperatura', 519.0000, 'ºC'),
	(263521, 118, '2014-04-01 00:32:55.000000', 'temperatura', 1027.0000, 'ºC'),
	(263522, 118, '2014-04-01 00:32:56.000000', 'temperatura', 1180.0000, 'ºC'),
	(263523, 118, '2014-04-01 00:32:57.000000', 'temperatura', 419.0000, 'ºC'),
	(263524, 118, '2014-04-01 00:32:58.000000', 'temperatura', 953.0000, 'ºC'),
	(263525, 118, '2014-04-01 00:32:59.000000', 'temperatura', 1112.0000, 'ºC'),
	(263526, 118, '2014-04-01 00:33:00.000000', 'temperatura', 300.0000, 'ºC'),
	(263527, 118, '2014-04-01 00:33:01.000000', 'temperatura', 563.0000, 'ºC'),
	(263528, 118, '2014-04-01 00:33:02.000000', 'temperatura', 718.0000, 'ºC'),
	(263529, 118, '2014-04-01 00:33:03.000000', 'temperatura', 701.0000, 'ºC'),
	(263530, 118, '2014-04-01 00:33:04.000000', 'temperatura', 150.0000, 'ºC'),
	(263531, 118, '2014-04-01 00:33:05.000000', 'temperatura', 1048.0000, 'ºC'),
	(263532, 118, '2014-04-01 00:33:06.000000', 'temperatura', 1189.0000, 'ºC'),
	(263533, 118, '2014-04-01 00:33:07.000000', 'temperatura', 403.0000, 'ºC'),
	(263534, 118, '2014-04-01 00:33:08.000000', 'temperatura', 849.0000, 'ºC'),
	(263535, 118, '2014-04-01 00:33:09.000000', 'temperatura', 636.0000, 'ºC'),
	(263536, 118, '2014-04-01 00:33:10.000000', 'temperatura', 635.0000, 'ºC'),
	(263537, 118, '2014-04-01 00:33:11.000000', 'temperatura', 66.0000, 'ºC'),
	(263538, 118, '2014-04-01 00:33:12.000000', 'temperatura', 828.0000, 'ºC'),
	(263539, 118, '2014-04-01 00:33:13.000000', 'temperatura', 340.0000, 'ºC'),
	(263540, 118, '2014-04-01 00:33:14.000000', 'temperatura', 417.0000, 'ºC'),
	(263541, 118, '2014-04-01 00:33:15.000000', 'temperatura', 1065.0000, 'ºC'),
	(263542, 118, '2014-04-01 00:33:16.000000', 'temperatura', 473.0000, 'ºC'),
	(263543, 118, '2014-04-01 00:33:17.000000', 'temperatura', 372.0000, 'ºC'),
	(263544, 118, '2014-04-01 00:33:18.000000', 'temperatura', 440.0000, 'ºC'),
	(263545, 118, '2014-04-01 00:33:19.000000', 'temperatura', 1086.0000, 'ºC'),
	(263546, 118, '2014-04-01 00:33:20.000000', 'temperatura', 511.0000, 'ºC'),
	(263547, 118, '2014-04-01 00:33:21.000000', 'temperatura', 499.0000, 'ºC'),
	(263548, 118, '2014-04-01 00:33:22.000000', 'temperatura', 960.0000, 'ºC'),
	(263549, 118, '2014-04-01 00:33:23.000000', 'temperatura', 905.0000, 'ºC'),
	(263550, 118, '2014-04-01 00:33:24.000000', 'temperatura', 444.0000, 'ºC'),
	(263551, 118, '2014-04-01 00:33:25.000000', 'temperatura', 704.0000, 'ºC'),
	(263552, 118, '2014-04-01 00:33:26.000000', 'temperatura', 991.0000, 'ºC'),
	(263553, 118, '2014-04-01 00:33:27.000000', 'temperatura', 444.0000, 'ºC'),
	(263554, 118, '2014-04-01 00:33:28.000000', 'temperatura', 446.0000, 'ºC'),
	(263555, 118, '2014-04-01 00:33:29.000000', 'temperatura', 901.0000, 'ºC'),
	(263556, 118, '2014-04-01 00:33:30.000000', 'temperatura', 764.0000, 'ºC'),
	(263557, 118, '2014-04-01 00:33:31.000000', 'temperatura', 1121.0000, 'ºC'),
	(263558, 118, '2014-04-01 00:33:32.000000', 'temperatura', 910.0000, 'ºC'),
	(263559, 118, '2014-04-01 00:33:33.000000', 'temperatura', 1189.0000, 'ºC'),
	(263560, 118, '2014-04-01 00:33:34.000000', 'temperatura', 816.0000, 'ºC'),
	(263561, 118, '2014-04-01 00:33:35.000000', 'temperatura', 515.0000, 'ºC'),
	(263562, 118, '2014-04-01 00:33:36.000000', 'temperatura', 127.0000, 'ºC'),
	(263563, 118, '2014-04-01 00:33:37.000000', 'temperatura', 289.0000, 'ºC'),
	(263564, 118, '2014-04-01 00:33:38.000000', 'temperatura', 1065.0000, 'ºC'),
	(263565, 118, '2014-04-01 00:33:39.000000', 'temperatura', 860.0000, 'ºC'),
	(263566, 118, '2014-04-01 00:33:40.000000', 'temperatura', 1102.0000, 'ºC'),
	(263567, 118, '2014-04-01 00:33:41.000000', 'temperatura', 534.0000, 'ºC'),
	(263568, 118, '2014-04-01 00:33:42.000000', 'temperatura', 564.0000, 'ºC'),
	(263569, 118, '2014-04-01 00:33:43.000000', 'temperatura', 16.0000, 'ºC'),
	(263570, 118, '2014-04-01 00:33:44.000000', 'temperatura', 790.0000, 'ºC'),
	(263571, 118, '2014-04-01 00:33:45.000000', 'temperatura', 302.0000, 'ºC'),
	(263572, 118, '2014-04-01 00:33:46.000000', 'temperatura', 339.0000, 'ºC'),
	(263573, 118, '2014-04-01 00:33:47.000000', 'temperatura', 791.0000, 'ºC'),
	(263574, 118, '2014-04-01 00:33:48.000000', 'temperatura', 537.0000, 'ºC'),
	(263575, 118, '2014-04-01 00:33:49.000000', 'temperatura', 314.0000, 'ºC'),
	(263576, 118, '2014-04-01 00:33:50.000000', 'temperatura', 1158.0000, 'ºC'),
	(263577, 118, '2014-04-01 00:33:51.000000', 'temperatura', 48.0000, 'ºC'),
	(263578, 118, '2014-04-01 00:33:52.000000', 'temperatura', 369.0000, 'ºC'),
	(263579, 118, '2014-04-01 00:33:53.000000', 'temperatura', 500.0000, 'ºC'),
	(263580, 118, '2014-04-01 00:33:54.000000', 'temperatura', 195.0000, 'ºC'),
	(263581, 118, '2014-04-01 00:33:55.000000', 'temperatura', 675.0000, 'ºC'),
	(263582, 118, '2014-04-01 00:33:56.000000', 'temperatura', 389.0000, 'ºC'),
	(263583, 118, '2014-04-01 00:33:57.000000', 'temperatura', 1119.0000, 'ºC'),
	(263584, 118, '2014-04-01 00:33:58.000000', 'temperatura', 832.0000, 'ºC'),
	(263585, 118, '2014-04-01 00:33:59.000000', 'temperatura', 804.0000, 'ºC'),
	(263586, 118, '2014-04-01 00:34:00.000000', 'temperatura', 321.0000, 'ºC'),
	(263587, 118, '2014-04-01 00:34:01.000000', 'temperatura', 396.0000, 'ºC'),
	(263588, 118, '2014-04-01 00:34:02.000000', 'temperatura', 1015.0000, 'ºC'),
	(263589, 118, '2014-04-01 00:34:03.000000', 'temperatura', 291.0000, 'ºC'),
	(263590, 118, '2014-04-01 00:34:04.000000', 'temperatura', 808.0000, 'ºC'),
	(263591, 118, '2014-04-01 00:34:05.000000', 'temperatura', 766.0000, 'ºC'),
	(263592, 118, '2014-04-01 00:34:06.000000', 'temperatura', 210.0000, 'ºC'),
	(263593, 118, '2014-04-01 00:34:07.000000', 'temperatura', 1152.0000, 'ºC'),
	(263594, 118, '2014-04-01 00:34:08.000000', 'temperatura', 328.0000, 'ºC'),
	(263595, 118, '2014-04-01 00:34:09.000000', 'temperatura', 586.0000, 'ºC'),
	(263596, 118, '2014-04-01 00:34:10.000000', 'temperatura', 747.0000, 'ºC'),
	(263597, 118, '2014-04-01 00:34:11.000000', 'temperatura', 779.0000, 'ºC'),
	(263598, 118, '2014-04-01 00:34:12.000000', 'temperatura', 451.0000, 'ºC'),
	(263599, 118, '2014-04-01 00:34:13.000000', 'temperatura', 1120.0000, 'ºC'),
	(263600, 118, '2014-04-01 00:34:14.000000', 'temperatura', 649.0000, 'ºC'),
	(263601, 118, '2014-04-01 00:34:15.000000', 'temperatura', 1085.0000, 'ºC'),
	(263602, 118, '2014-04-01 00:34:16.000000', 'temperatura', 1077.0000, 'ºC'),
	(263603, 118, '2014-04-01 00:34:17.000000', 'temperatura', 931.0000, 'ºC'),
	(263604, 118, '2014-04-01 00:34:18.000000', 'temperatura', 225.0000, 'ºC'),
	(263605, 118, '2014-04-01 00:34:19.000000', 'temperatura', 731.0000, 'ºC'),
	(263606, 118, '2014-04-01 00:34:20.000000', 'temperatura', 583.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(263607, 118, '2014-04-01 00:34:21.000000', 'temperatura', 721.0000, 'ºC'),
	(263608, 118, '2014-04-01 00:34:22.000000', 'temperatura', 658.0000, 'ºC'),
	(263609, 118, '2014-04-01 00:34:23.000000', 'temperatura', 1128.0000, 'ºC'),
	(263610, 118, '2014-04-01 00:34:24.000000', 'temperatura', 67.0000, 'ºC'),
	(263611, 118, '2014-04-01 00:34:25.000000', 'temperatura', 551.0000, 'ºC'),
	(263612, 118, '2014-04-01 00:34:26.000000', 'temperatura', 152.0000, 'ºC'),
	(263613, 118, '2014-04-01 00:34:27.000000', 'temperatura', 310.0000, 'ºC'),
	(263614, 118, '2014-04-01 00:34:28.000000', 'temperatura', 1095.0000, 'ºC'),
	(263615, 118, '2014-04-01 00:34:29.000000', 'temperatura', 945.0000, 'ºC'),
	(263616, 118, '2014-04-01 00:34:30.000000', 'temperatura', 242.0000, 'ºC'),
	(263617, 118, '2014-04-01 00:34:31.000000', 'temperatura', 776.0000, 'ºC'),
	(263618, 118, '2014-04-01 00:34:32.000000', 'temperatura', 753.0000, 'ºC'),
	(263619, 118, '2014-04-01 00:34:33.000000', 'temperatura', 236.0000, 'ºC'),
	(263620, 118, '2014-04-01 00:34:34.000000', 'temperatura', 124.0000, 'ºC'),
	(263621, 118, '2014-04-01 00:34:35.000000', 'temperatura', 1112.0000, 'ºC'),
	(263622, 118, '2014-04-01 00:34:36.000000', 'temperatura', 390.0000, 'ºC'),
	(263623, 118, '2014-04-01 00:34:37.000000', 'temperatura', 1011.0000, 'ºC'),
	(263624, 118, '2014-04-01 00:34:38.000000', 'temperatura', 288.0000, 'ºC'),
	(263625, 118, '2014-04-01 00:34:39.000000', 'temperatura', 808.0000, 'ºC'),
	(263626, 118, '2014-04-01 00:34:40.000000', 'temperatura', 777.0000, 'ºC'),
	(263627, 118, '2014-04-01 00:34:41.000000', 'temperatura', 262.0000, 'ºC'),
	(263628, 118, '2014-04-01 00:34:42.000000', 'temperatura', 177.0000, 'ºC'),
	(263629, 118, '2014-04-01 00:34:43.000000', 'temperatura', 101.0000, 'ºC'),
	(263630, 118, '2014-04-01 00:34:44.000000', 'temperatura', 1173.0000, 'ºC'),
	(263631, 118, '2014-04-01 00:34:45.000000', 'temperatura', 763.0000, 'ºC'),
	(263632, 118, '2014-04-01 00:34:46.000000', 'temperatura', 296.0000, 'ºC'),
	(263633, 118, '2014-04-01 00:34:47.000000', 'temperatura', 394.0000, 'ºC'),
	(263634, 118, '2014-04-01 00:34:48.000000', 'temperatura', 1081.0000, 'ºC'),
	(263635, 118, '2014-04-01 00:34:49.000000', 'temperatura', 624.0000, 'ºC'),
	(263636, 118, '2014-04-01 00:34:50.000000', 'temperatura', 1076.0000, 'ºC'),
	(263637, 118, '2014-04-01 00:34:51.000000', 'temperatura', 1109.0000, 'ºC'),
	(263638, 118, '2014-04-01 00:34:52.000000', 'temperatura', 1120.0000, 'ºC'),
	(263639, 118, '2014-04-01 00:34:53.000000', 'temperatura', 1071.0000, 'ºC'),
	(263640, 118, '2014-04-01 00:34:54.000000', 'temperatura', 797.0000, 'ºC'),
	(263641, 118, '2014-04-01 00:34:55.000000', 'temperatura', 770.0000, 'ºC'),
	(263642, 118, '2014-04-01 00:34:56.000000', 'temperatura', 262.0000, 'ºC'),
	(263643, 118, '2014-04-01 00:34:57.000000', 'temperatura', 199.0000, 'ºC'),
	(263644, 118, '2014-04-01 00:34:58.000000', 'temperatura', 210.0000, 'ºC'),
	(263645, 118, '2014-04-01 00:34:59.000000', 'temperatura', 453.0000, 'ºC'),
	(263646, 118, '2014-04-01 00:35:00.000000', 'temperatura', 436.0000, 'ºC'),
	(263647, 118, '2014-04-01 00:35:01.000000', 'temperatura', 821.0000, 'ºC'),
	(263648, 118, '2014-04-01 00:35:02.000000', 'temperatura', 399.0000, 'ºC'),
	(263649, 118, '2014-04-01 00:35:03.000000', 'temperatura', 732.0000, 'ºC'),
	(263650, 118, '2014-04-01 00:35:04.000000', 'temperatura', 62.0000, 'ºC'),
	(263651, 118, '2014-04-01 00:35:05.000000', 'temperatura', 516.0000, 'ºC'),
	(263652, 118, '2014-04-01 00:35:06.000000', 'temperatura', 1193.0000, 'ºC'),
	(263653, 118, '2014-04-01 00:35:07.000000', 'temperatura', 817.0000, 'ºC'),
	(263654, 118, '2014-04-01 00:35:08.000000', 'temperatura', 507.0000, 'ºC'),
	(263655, 118, '2014-04-01 00:35:09.000000', 'temperatura', 85.0000, 'ºC'),
	(263656, 118, '2014-04-01 00:35:10.000000', 'temperatura', 105.0000, 'ºC'),
	(263657, 118, '2014-04-01 00:35:11.000000', 'temperatura', 269.0000, 'ºC'),
	(263658, 118, '2014-04-01 00:35:12.000000', 'temperatura', 1030.0000, 'ºC'),
	(263659, 118, '2014-04-01 00:35:13.000000', 'temperatura', 746.0000, 'ºC'),
	(263660, 118, '2014-04-01 00:35:14.000000', 'temperatura', 641.0000, 'ºC'),
	(263661, 118, '2014-04-01 00:35:15.000000', 'temperatura', 964.0000, 'ºC'),
	(263662, 118, '2014-04-01 00:35:16.000000', 'temperatura', 500.0000, 'ºC'),
	(263663, 118, '2014-04-01 00:35:17.000000', 'temperatura', 810.0000, 'ºC'),
	(263664, 118, '2014-04-01 00:35:18.000000', 'temperatura', 147.0000, 'ºC'),
	(263665, 118, '2014-04-01 00:35:19.000000', 'temperatura', 707.0000, 'ºC'),
	(263666, 118, '2014-04-01 00:35:20.000000', 'temperatura', 695.0000, 'ºC'),
	(263667, 118, '2014-04-01 00:35:21.000000', 'temperatura', 154.0000, 'ºC'),
	(263668, 118, '2014-04-01 00:35:22.000000', 'temperatura', 1087.0000, 'ºC'),
	(263669, 118, '2014-04-01 00:35:23.000000', 'temperatura', 174.0000, 'ºC'),
	(263670, 118, '2014-04-01 00:35:24.000000', 'temperatura', 8.0000, 'ºC'),
	(263671, 118, '2014-04-01 00:35:25.000000', 'temperatura', 720.0000, 'ºC'),
	(263672, 118, '2014-04-01 00:35:26.000000', 'temperatura', 1174.0000, 'ºC'),
	(263673, 118, '2014-04-01 00:35:27.000000', 'temperatura', 112.0000, 'ºC'),
	(263674, 118, '2014-04-01 00:35:28.000000', 'temperatura', 640.0000, 'ºC'),
	(263675, 118, '2014-04-01 00:35:29.000000', 'temperatura', 461.0000, 'ºC'),
	(263676, 118, '2014-04-01 00:35:30.000000', 'temperatura', 389.0000, 'ºC'),
	(263677, 118, '2014-04-01 00:35:31.000000', 'temperatura', 562.0000, 'ºC'),
	(263678, 118, '2014-04-01 00:35:32.000000', 'temperatura', 443.0000, 'ºC'),
	(263679, 118, '2014-04-01 00:35:33.000000', 'temperatura', 529.0000, 'ºC'),
	(263680, 118, '2014-04-01 00:35:34.000000', 'temperatura', 117.0000, 'ºC'),
	(263681, 118, '2014-04-01 00:35:35.000000', 'temperatura', 199.0000, 'ºC'),
	(263682, 118, '2014-04-01 00:35:36.000000', 'temperatura', 645.0000, 'ºC'),
	(263683, 118, '2014-04-01 00:35:37.000000', 'temperatura', 226.0000, 'ºC'),
	(263684, 118, '2014-04-01 00:35:38.000000', 'temperatura', 397.0000, 'ºC'),
	(263685, 118, '2014-04-01 00:35:39.000000', 'temperatura', 109.0000, 'ºC'),
	(263686, 118, '2014-04-01 00:35:40.000000', 'temperatura', 555.0000, 'ºC'),
	(263687, 118, '2014-04-01 00:35:41.000000', 'temperatura', 47.0000, 'ºC'),
	(263688, 118, '2014-04-01 00:35:42.000000', 'temperatura', 971.0000, 'ºC'),
	(263689, 118, '2014-04-01 00:35:43.000000', 'temperatura', 1112.0000, 'ºC'),
	(263690, 118, '2014-04-01 00:35:44.000000', 'temperatura', 251.0000, 'ºC'),
	(263691, 118, '2014-04-01 00:35:45.000000', 'temperatura', 317.0000, 'ºC'),
	(263692, 118, '2014-04-01 00:35:46.000000', 'temperatura', 832.0000, 'ºC'),
	(263693, 118, '2014-04-01 00:35:47.000000', 'temperatura', 809.0000, 'ºC'),
	(263694, 118, '2014-04-01 00:35:48.000000', 'temperatura', 351.0000, 'ºC'),
	(263695, 118, '2014-04-01 00:35:49.000000', 'temperatura', 526.0000, 'ºC'),
	(263696, 118, '2014-04-01 00:35:50.000000', 'temperatura', 380.0000, 'ºC'),
	(263697, 118, '2014-04-01 00:35:51.000000', 'temperatura', 320.0000, 'ºC'),
	(263698, 118, '2014-04-01 00:35:52.000000', 'temperatura', 462.0000, 'ºC'),
	(263699, 118, '2014-04-01 00:35:53.000000', 'temperatura', 149.0000, 'ºC'),
	(263700, 118, '2014-04-01 00:35:54.000000', 'temperatura', 561.0000, 'ºC'),
	(263701, 118, '2014-04-01 00:35:55.000000', 'temperatura', 1158.0000, 'ºC'),
	(263702, 118, '2014-04-01 00:35:56.000000', 'temperatura', 507.0000, 'ºC'),
	(263703, 118, '2014-04-01 00:35:57.000000', 'temperatura', 263.0000, 'ºC'),
	(263704, 118, '2014-04-01 00:35:58.000000', 'temperatura', 995.0000, 'ºC'),
	(263705, 118, '2014-04-01 00:35:59.000000', 'temperatura', 585.0000, 'ºC'),
	(263706, 118, '2014-04-01 00:36:00.000000', 'temperatura', 1142.0000, 'ºC'),
	(263707, 118, '2014-04-01 00:36:01.000000', 'temperatura', 356.0000, 'ºC'),
	(263708, 118, '2014-04-01 00:36:02.000000', 'temperatura', 752.0000, 'ºC'),
	(263709, 118, '2014-04-01 00:36:03.000000', 'temperatura', 294.0000, 'ºC'),
	(263710, 118, '2014-04-01 00:36:04.000000', 'temperatura', 413.0000, 'ºC'),
	(263711, 118, '2014-04-01 00:36:05.000000', 'temperatura', 1186.0000, 'ºC'),
	(263712, 118, '2014-04-01 00:36:06.000000', 'temperatura', 1089.0000, 'ºC'),
	(263713, 118, '2014-04-01 00:36:07.000000', 'temperatura', 690.0000, 'ºC'),
	(263714, 118, '2014-04-01 00:36:08.000000', 'temperatura', 182.0000, 'ºC'),
	(263715, 118, '2014-04-01 00:36:09.000000', 'temperatura', 41.0000, 'ºC'),
	(263716, 118, '2014-04-01 00:36:10.000000', 'temperatura', 859.0000, 'ºC'),
	(263717, 118, '2014-04-01 00:36:11.000000', 'temperatura', 572.0000, 'ºC'),
	(263718, 118, '2014-04-01 00:36:12.000000', 'temperatura', 283.0000, 'ºC'),
	(263719, 118, '2014-04-01 00:36:13.000000', 'temperatura', 900.0000, 'ºC'),
	(263720, 118, '2014-04-01 00:36:14.000000', 'temperatura', 54.0000, 'ºC'),
	(263721, 118, '2014-04-01 00:36:15.000000', 'temperatura', 1168.0000, 'ºC'),
	(263722, 118, '2014-04-01 00:36:16.000000', 'temperatura', 877.0000, 'ºC'),
	(263723, 118, '2014-04-01 00:36:17.000000', 'temperatura', 885.0000, 'ºC'),
	(263724, 118, '2014-04-01 00:36:18.000000', 'temperatura', 591.0000, 'ºC'),
	(263725, 118, '2014-04-01 00:36:19.000000', 'temperatura', 303.0000, 'ºC'),
	(263726, 118, '2014-04-01 00:36:20.000000', 'temperatura', 941.0000, 'ºC'),
	(263727, 118, '2014-04-01 00:36:21.000000', 'temperatura', 198.0000, 'ºC'),
	(263728, 118, '2014-04-01 00:36:22.000000', 'temperatura', 568.0000, 'ºC'),
	(263729, 118, '2014-04-01 00:36:23.000000', 'temperatura', 1045.0000, 'ºC'),
	(263730, 118, '2014-04-01 00:36:24.000000', 'temperatura', 1120.0000, 'ºC'),
	(263731, 118, '2014-04-01 00:36:25.000000', 'temperatura', 67.0000, 'ºC'),
	(263732, 118, '2014-04-01 00:36:26.000000', 'temperatura', 577.0000, 'ºC'),
	(263733, 118, '2014-04-01 00:36:27.000000', 'temperatura', 283.0000, 'ºC'),
	(263734, 118, '2014-04-01 00:36:28.000000', 'temperatura', 884.0000, 'ºC'),
	(263735, 118, '2014-04-01 00:36:29.000000', 'temperatura', 1171.0000, 'ºC'),
	(263736, 118, '2014-04-01 00:36:30.000000', 'temperatura', 804.0000, 'ºC'),
	(263737, 118, '2014-04-01 00:36:31.000000', 'temperatura', 508.0000, 'ºC'),
	(263738, 118, '2014-04-01 00:36:32.000000', 'temperatura', 128.0000, 'ºC'),
	(263739, 118, '2014-04-01 00:36:33.000000', 'temperatura', 319.0000, 'ºC'),
	(263740, 118, '2014-04-01 00:36:34.000000', 'temperatura', 9.0000, 'ºC'),
	(263741, 118, '2014-04-01 00:36:35.000000', 'temperatura', 288.0000, 'ºC'),
	(263742, 118, '2014-04-01 00:36:36.000000', 'temperatura', 216.0000, 'ºC'),
	(263743, 118, '2014-04-01 00:36:37.000000', 'temperatura', 214.0000, 'ºC'),
	(263744, 118, '2014-04-01 00:36:38.000000', 'temperatura', 421.0000, 'ºC'),
	(263745, 118, '2014-04-01 00:36:39.000000', 'temperatura', 267.0000, 'ºC'),
	(263746, 118, '2014-04-01 00:36:40.000000', 'temperatura', 72.0000, 'ºC'),
	(263747, 118, '2014-04-01 00:36:41.000000', 'temperatura', 759.0000, 'ºC'),
	(263748, 118, '2014-04-01 00:36:42.000000', 'temperatura', 1179.0000, 'ºC'),
	(263749, 118, '2014-04-01 00:36:43.000000', 'temperatura', 18.0000, 'ºC'),
	(263750, 118, '2014-04-01 00:36:44.000000', 'temperatura', 154.0000, 'ºC'),
	(263751, 118, '2014-04-01 00:36:45.000000', 'temperatura', 717.0000, 'ºC'),
	(263752, 118, '2014-04-01 00:36:46.000000', 'temperatura', 723.0000, 'ºC'),
	(263753, 118, '2014-04-01 00:36:47.000000', 'temperatura', 266.0000, 'ºC'),
	(263754, 118, '2014-04-01 00:36:48.000000', 'temperatura', 361.0000, 'ºC'),
	(263755, 118, '2014-04-01 00:36:49.000000', 'temperatura', 1005.0000, 'ºC'),
	(263756, 118, '2014-04-01 00:36:50.000000', 'temperatura', 344.0000, 'ºC'),
	(263757, 118, '2014-04-01 00:36:51.000000', 'temperatura', 1107.0000, 'ºC'),
	(263758, 118, '2014-04-01 00:36:52.000000', 'temperatura', 904.0000, 'ºC'),
	(263759, 118, '2014-04-01 00:36:53.000000', 'temperatura', 1197.0000, 'ºC'),
	(263760, 118, '2014-04-01 00:36:54.000000', 'temperatura', 876.0000, 'ºC'),
	(263761, 118, '2014-04-01 00:36:55.000000', 'temperatura', 788.0000, 'ºC'),
	(263762, 118, '2014-04-01 00:36:56.000000', 'temperatura', 114.0000, 'ºC'),
	(263763, 118, '2014-04-01 00:36:57.000000', 'temperatura', 605.0000, 'ºC'),
	(263764, 118, '2014-04-01 00:36:58.000000', 'temperatura', 282.0000, 'ºC'),
	(263765, 118, '2014-04-01 00:36:59.000000', 'temperatura', 798.0000, 'ºC'),
	(263766, 118, '2014-04-01 00:37:00.000000', 'temperatura', 745.0000, 'ºC'),
	(263767, 118, '2014-04-01 00:37:01.000000', 'temperatura', 131.0000, 'ºC'),
	(263768, 118, '2014-04-01 00:37:02.000000', 'temperatura', 821.0000, 'ºC'),
	(263769, 118, '2014-04-01 00:37:03.000000', 'temperatura', 111.0000, 'ºC'),
	(263770, 118, '2014-04-01 00:37:04.000000', 'temperatura', 494.0000, 'ºC'),
	(263771, 118, '2014-04-01 00:37:05.000000', 'temperatura', 938.0000, 'ºC'),
	(263772, 118, '2014-04-01 00:37:06.000000', 'temperatura', 807.0000, 'ºC'),
	(263773, 118, '2014-04-01 00:37:07.000000', 'temperatura', 22.0000, 'ºC'),
	(263774, 118, '2014-04-01 00:37:08.000000', 'temperatura', 90.0000, 'ºC'),
	(263775, 118, '2014-04-01 00:37:09.000000', 'temperatura', 382.0000, 'ºC'),
	(263776, 118, '2014-04-01 00:37:10.000000', 'temperatura', 443.0000, 'ºC'),
	(263777, 118, '2014-04-01 00:37:11.000000', 'temperatura', 1070.0000, 'ºC'),
	(263778, 118, '2014-04-01 00:37:12.000000', 'temperatura', 419.0000, 'ºC'),
	(263779, 118, '2014-04-01 00:37:13.000000', 'temperatura', 89.0000, 'ºC'),
	(263780, 118, '2014-04-01 00:37:14.000000', 'temperatura', 386.0000, 'ºC'),
	(263781, 118, '2014-04-01 00:37:15.000000', 'temperatura', 464.0000, 'ºC'),
	(263782, 118, '2014-04-01 00:37:16.000000', 'temperatura', 1161.0000, 'ºC'),
	(263783, 118, '2014-04-01 00:37:17.000000', 'temperatura', 814.0000, 'ºC'),
	(263784, 118, '2014-04-01 00:37:18.000000', 'temperatura', 589.0000, 'ºC'),
	(263785, 118, '2014-04-01 00:37:19.000000', 'temperatura', 503.0000, 'ºC'),
	(263786, 118, '2014-04-01 00:37:20.000000', 'temperatura', 749.0000, 'ºC'),
	(263787, 118, '2014-04-01 00:37:21.000000', 'temperatura', 1037.0000, 'ºC'),
	(263788, 118, '2014-04-01 00:37:22.000000', 'temperatura', 539.0000, 'ºC'),
	(263789, 118, '2014-04-01 00:37:23.000000', 'temperatura', 782.0000, 'ºC'),
	(263790, 118, '2014-04-01 00:37:24.000000', 'temperatura', 1096.0000, 'ºC'),
	(263791, 118, '2014-04-01 00:37:25.000000', 'temperatura', 735.0000, 'ºC'),
	(263792, 118, '2014-04-01 00:37:26.000000', 'temperatura', 386.0000, 'ºC'),
	(263793, 118, '2014-04-01 00:37:27.000000', 'temperatura', 928.0000, 'ºC'),
	(263794, 118, '2014-04-01 00:37:28.000000', 'temperatura', 1080.0000, 'ºC'),
	(263795, 118, '2014-04-01 00:37:29.000000', 'temperatura', 219.0000, 'ºC'),
	(263796, 118, '2014-04-01 00:37:30.000000', 'temperatura', 253.0000, 'ºC'),
	(263797, 118, '2014-04-01 00:37:31.000000', 'temperatura', 609.0000, 'ºC'),
	(263798, 118, '2014-04-01 00:37:32.000000', 'temperatura', 1088.0000, 'ºC'),
	(263799, 118, '2014-04-01 00:37:33.000000', 'temperatura', 14.0000, 'ºC'),
	(263800, 118, '2014-04-01 00:37:34.000000', 'temperatura', 407.0000, 'ºC'),
	(263801, 118, '2014-04-01 00:37:35.000000', 'temperatura', 791.0000, 'ºC'),
	(263802, 118, '2014-04-01 00:37:36.000000', 'temperatura', 334.0000, 'ºC'),
	(263803, 118, '2014-04-01 00:37:37.000000', 'temperatura', 499.0000, 'ºC'),
	(263804, 118, '2014-04-01 00:37:38.000000', 'temperatura', 295.0000, 'ºC'),
	(263805, 118, '2014-04-01 00:37:39.000000', 'temperatura', 1177.0000, 'ºC'),
	(263806, 118, '2014-04-01 00:37:40.000000', 'temperatura', 200.0000, 'ºC'),
	(263807, 118, '2014-04-01 00:37:41.000000', 'temperatura', 1070.0000, 'ºC'),
	(263808, 118, '2014-04-01 00:37:42.000000', 'temperatura', 1149.0000, 'ºC'),
	(263809, 118, '2014-04-01 00:37:43.000000', 'temperatura', 139.0000, 'ºC'),
	(263810, 118, '2014-04-01 00:37:44.000000', 'temperatura', 845.0000, 'ºC'),
	(263811, 118, '2014-04-01 00:37:45.000000', 'temperatura', 209.0000, 'ºC'),
	(263812, 118, '2014-04-01 00:37:46.000000', 'temperatura', 913.0000, 'ºC'),
	(263813, 118, '2014-04-01 00:37:47.000000', 'temperatura', 337.0000, 'ºC'),
	(263814, 118, '2014-04-01 00:37:48.000000', 'temperatura', 145.0000, 'ºC'),
	(263815, 118, '2014-04-01 00:37:49.000000', 'temperatura', 914.0000, 'ºC'),
	(263816, 118, '2014-04-01 00:37:50.000000', 'temperatura', 538.0000, 'ºC'),
	(263817, 118, '2014-04-01 00:37:51.000000', 'temperatura', 1149.0000, 'ºC'),
	(263818, 118, '2014-04-01 00:37:52.000000', 'temperatura', 532.0000, 'ºC'),
	(263819, 118, '2014-04-01 00:37:53.000000', 'temperatura', 412.0000, 'ºC'),
	(263820, 118, '2014-04-01 00:37:54.000000', 'temperatura', 466.0000, 'ºC'),
	(263821, 118, '2014-04-01 00:37:55.000000', 'temperatura', 1093.0000, 'ºC'),
	(263822, 118, '2014-04-01 00:37:56.000000', 'temperatura', 468.0000, 'ºC'),
	(263823, 118, '2014-04-01 00:37:57.000000', 'temperatura', 261.0000, 'ºC'),
	(263824, 118, '2014-04-01 00:37:58.000000', 'temperatura', 1104.0000, 'ºC'),
	(263825, 118, '2014-04-01 00:37:59.000000', 'temperatura', 1134.0000, 'ºC'),
	(263826, 118, '2014-04-01 00:38:00.000000', 'temperatura', 1159.0000, 'ºC'),
	(263827, 118, '2014-04-01 00:38:01.000000', 'temperatura', 1196.0000, 'ºC'),
	(263828, 118, '2014-04-01 00:38:02.000000', 'temperatura', 102.0000, 'ºC'),
	(263829, 118, '2014-04-01 00:38:03.000000', 'temperatura', 521.0000, 'ºC'),
	(263830, 118, '2014-04-01 00:38:04.000000', 'temperatura', 1099.0000, 'ºC'),
	(263831, 118, '2014-04-01 00:38:05.000000', 'temperatura', 335.0000, 'ºC'),
	(263832, 118, '2014-04-01 00:38:06.000000', 'temperatura', 777.0000, 'ºC'),
	(263833, 118, '2014-04-01 00:38:07.000000', 'temperatura', 479.0000, 'ºC'),
	(263834, 118, '2014-04-01 00:38:08.000000', 'temperatura', 68.0000, 'ºC'),
	(263835, 118, '2014-04-01 00:38:09.000000', 'temperatura', 101.0000, 'ºC'),
	(263836, 118, '2014-04-01 00:38:10.000000', 'temperatura', 303.0000, 'ºC'),
	(263837, 118, '2014-04-01 00:38:11.000000', 'temperatura', 11.0000, 'ºC'),
	(263838, 118, '2014-04-01 00:38:12.000000', 'temperatura', 349.0000, 'ºC'),
	(263839, 118, '2014-04-01 00:38:13.000000', 'temperatura', 512.0000, 'ºC'),
	(263840, 118, '2014-04-01 00:38:14.000000', 'temperatura', 312.0000, 'ºC'),
	(263841, 118, '2014-04-01 00:38:15.000000', 'temperatura', 26.0000, 'ºC'),
	(263842, 118, '2014-04-01 00:38:16.000000', 'temperatura', 393.0000, 'ºC'),
	(263843, 118, '2014-04-01 00:38:17.000000', 'temperatura', 689.0000, 'ºC'),
	(263844, 118, '2014-04-01 00:38:18.000000', 'temperatura', 1064.0000, 'ºC'),
	(263845, 118, '2014-04-01 00:38:19.000000', 'temperatura', 854.0000, 'ºC'),
	(263846, 118, '2014-04-01 00:38:20.000000', 'temperatura', 1080.0000, 'ºC'),
	(263847, 118, '2014-04-01 00:38:21.000000', 'temperatura', 438.0000, 'ºC'),
	(263848, 118, '2014-04-01 00:38:22.000000', 'temperatura', 152.0000, 'ºC'),
	(263849, 118, '2014-04-01 00:38:23.000000', 'temperatura', 643.0000, 'ºC'),
	(263850, 118, '2014-04-01 00:38:24.000000', 'temperatura', 362.0000, 'ºC'),
	(263851, 118, '2014-04-01 00:38:25.000000', 'temperatura', 1083.0000, 'ºC'),
	(263852, 118, '2014-04-01 00:38:26.000000', 'temperatura', 727.0000, 'ºC'),
	(263853, 118, '2014-04-01 00:38:27.000000', 'temperatura', 385.0000, 'ºC'),
	(263854, 118, '2014-04-01 00:38:28.000000', 'temperatura', 947.0000, 'ºC'),
	(263855, 118, '2014-04-01 00:38:29.000000', 'temperatura', 1181.0000, 'ºC'),
	(263856, 118, '2014-04-01 00:38:30.000000', 'temperatura', 664.0000, 'ºC'),
	(263857, 118, '2014-04-01 00:38:31.000000', 'temperatura', 978.0000, 'ºC'),
	(263858, 118, '2014-04-01 00:38:32.000000', 'temperatura', 498.0000, 'ºC'),
	(263859, 118, '2014-04-01 00:38:33.000000', 'temperatura', 758.0000, 'ºC'),
	(263860, 118, '2014-04-01 00:38:34.000000', 'temperatura', 1097.0000, 'ºC'),
	(263861, 118, '2014-04-01 00:38:35.000000', 'temperatura', 810.0000, 'ºC'),
	(263862, 118, '2014-04-01 00:38:36.000000', 'temperatura', 760.0000, 'ºC'),
	(263863, 118, '2014-04-01 00:38:37.000000', 'temperatura', 169.0000, 'ºC'),
	(263864, 118, '2014-04-01 00:38:38.000000', 'temperatura', 965.0000, 'ºC'),
	(263865, 118, '2014-04-01 00:38:39.000000', 'temperatura', 718.0000, 'ºC'),
	(263866, 118, '2014-04-01 00:38:40.000000', 'temperatura', 696.0000, 'ºC'),
	(263867, 118, '2014-04-01 00:38:41.000000', 'temperatura', 127.0000, 'ºC'),
	(263868, 118, '2014-04-01 00:38:42.000000', 'temperatura', 946.0000, 'ºC'),
	(263869, 118, '2014-04-01 00:38:43.000000', 'temperatura', 752.0000, 'ºC'),
	(263870, 118, '2014-04-01 00:38:44.000000', 'temperatura', 922.0000, 'ºC'),
	(263871, 118, '2014-04-01 00:38:45.000000', 'temperatura', 1154.0000, 'ºC'),
	(263872, 118, '2014-04-01 00:38:46.000000', 'temperatura', 607.0000, 'ºC'),
	(263873, 118, '2014-04-01 00:38:47.000000', 'temperatura', 770.0000, 'ºC'),
	(263874, 118, '2014-04-01 00:38:48.000000', 'temperatura', 830.0000, 'ºC'),
	(263875, 118, '2014-04-01 00:38:49.000000', 'temperatura', 643.0000, 'ºC'),
	(263876, 118, '2014-04-01 00:38:50.000000', 'temperatura', 722.0000, 'ºC'),
	(263877, 118, '2014-04-01 00:38:51.000000', 'temperatura', 485.0000, 'ºC'),
	(263878, 118, '2014-04-01 00:38:52.000000', 'temperatura', 256.0000, 'ºC'),
	(263879, 118, '2014-04-01 00:38:53.000000', 'temperatura', 1028.0000, 'ºC'),
	(263880, 118, '2014-04-01 00:38:54.000000', 'temperatura', 773.0000, 'ºC'),
	(263881, 118, '2014-04-01 00:38:55.000000', 'temperatura', 779.0000, 'ºC'),
	(263882, 118, '2014-04-01 00:38:56.000000', 'temperatura', 376.0000, 'ºC'),
	(263883, 118, '2014-04-01 00:38:57.000000', 'temperatura', 743.0000, 'ºC'),
	(263884, 118, '2014-04-01 00:38:58.000000', 'temperatura', 187.0000, 'ºC'),
	(263885, 118, '2014-04-01 00:38:59.000000', 'temperatura', 1107.0000, 'ºC'),
	(263886, 118, '2014-04-01 00:39:00.000000', 'temperatura', 175.0000, 'ºC'),
	(263887, 118, '2014-04-01 00:39:01.000000', 'temperatura', 1156.0000, 'ºC'),
	(263888, 118, '2014-04-01 00:39:02.000000', 'temperatura', 452.0000, 'ºC'),
	(263889, 118, '2014-04-01 00:39:03.000000', 'temperatura', 1195.0000, 'ºC'),
	(263890, 118, '2014-04-01 00:39:04.000000', 'temperatura', 1021.0000, 'ºC'),
	(263891, 118, '2014-04-01 00:39:05.000000', 'temperatura', 319.0000, 'ºC'),
	(263892, 118, '2014-04-01 00:39:06.000000', 'temperatura', 933.0000, 'ºC'),
	(263893, 118, '2014-04-01 00:39:07.000000', 'temperatura', 109.0000, 'ºC'),
	(263894, 118, '2014-04-01 00:39:08.000000', 'temperatura', 148.0000, 'ºC'),
	(263895, 118, '2014-04-01 00:39:09.000000', 'temperatura', 411.0000, 'ºC'),
	(263896, 118, '2014-04-01 00:39:10.000000', 'temperatura', 410.0000, 'ºC'),
	(263897, 118, '2014-04-01 00:39:11.000000', 'temperatura', 820.0000, 'ºC'),
	(263898, 118, '2014-04-01 00:39:12.000000', 'temperatura', 472.0000, 'ºC'),
	(263899, 118, '2014-04-01 00:39:13.000000', 'temperatura', 1097.0000, 'ºC'),
	(263900, 118, '2014-04-01 00:39:14.000000', 'temperatura', 473.0000, 'ºC'),
	(263901, 118, '2014-04-01 00:39:15.000000', 'temperatura', 273.0000, 'ºC'),
	(263902, 118, '2014-04-01 00:39:16.000000', 'temperatura', 1145.0000, 'ºC'),
	(263903, 118, '2014-04-01 00:39:17.000000', 'temperatura', 107.0000, 'ºC'),
	(263904, 118, '2014-04-01 00:39:18.000000', 'temperatura', 700.0000, 'ºC'),
	(263905, 118, '2014-04-01 00:39:19.000000', 'temperatura', 780.0000, 'ºC'),
	(263906, 118, '2014-04-01 00:39:20.000000', 'temperatura', 601.0000, 'ºC'),
	(263907, 118, '2014-04-01 00:39:21.000000', 'temperatura', 664.0000, 'ºC'),
	(263908, 118, '2014-04-01 00:39:22.000000', 'temperatura', 316.0000, 'ºC'),
	(263909, 118, '2014-04-01 00:39:23.000000', 'temperatura', 792.0000, 'ºC'),
	(263910, 118, '2014-04-01 00:39:24.000000', 'temperatura', 611.0000, 'ºC'),
	(263911, 118, '2014-04-01 00:39:25.000000', 'temperatura', 678.0000, 'ºC'),
	(263912, 118, '2014-04-01 00:39:26.000000', 'temperatura', 358.0000, 'ºC'),
	(263913, 118, '2014-04-01 00:39:27.000000', 'temperatura', 956.0000, 'ºC'),
	(263914, 118, '2014-04-01 00:39:28.000000', 'temperatura', 108.0000, 'ºC'),
	(263915, 118, '2014-04-01 00:39:29.000000', 'temperatura', 72.0000, 'ºC'),
	(263916, 118, '2014-04-01 00:39:30.000000', 'temperatura', 36.0000, 'ºC'),
	(263917, 118, '2014-04-01 00:39:31.000000', 'temperatura', 1163.0000, 'ºC'),
	(263918, 118, '2014-04-01 00:39:32.000000', 'temperatura', 908.0000, 'ºC'),
	(263919, 118, '2014-04-01 00:39:33.000000', 'temperatura', 1050.0000, 'ºC'),
	(263920, 118, '2014-04-01 00:39:34.000000', 'temperatura', 130.0000, 'ºC'),
	(263921, 118, '2014-04-01 00:39:35.000000', 'temperatura', 1097.0000, 'ºC'),
	(263922, 118, '2014-04-01 00:39:36.000000', 'temperatura', 298.0000, 'ºC'),
	(263923, 118, '2014-04-01 00:39:37.000000', 'temperatura', 600.0000, 'ºC'),
	(263924, 118, '2014-04-01 00:39:38.000000', 'temperatura', 907.0000, 'ºC'),
	(263925, 118, '2014-04-01 00:39:39.000000', 'temperatura', 333.0000, 'ºC'),
	(263926, 118, '2014-04-01 00:39:40.000000', 'temperatura', 143.0000, 'ºC'),
	(263927, 118, '2014-04-01 00:39:41.000000', 'temperatura', 920.0000, 'ºC'),
	(263928, 118, '2014-04-01 00:39:42.000000', 'temperatura', 571.0000, 'ºC'),
	(263929, 118, '2014-04-01 00:39:43.000000', 'temperatura', 95.0000, 'ºC'),
	(263930, 118, '2014-04-01 00:39:44.000000', 'temperatura', 1162.0000, 'ºC'),
	(263931, 118, '2014-04-01 00:39:45.000000', 'temperatura', 725.0000, 'ºC'),
	(263932, 118, '2014-04-01 00:39:46.000000', 'temperatura', 142.0000, 'ºC'),
	(263933, 118, '2014-04-01 00:39:47.000000', 'temperatura', 934.0000, 'ºC'),
	(263934, 118, '2014-04-01 00:39:48.000000', 'temperatura', 647.0000, 'ºC'),
	(263935, 118, '2014-04-01 00:39:49.000000', 'temperatura', 430.0000, 'ºC'),
	(263936, 118, '2014-04-01 00:39:50.000000', 'temperatura', 212.0000, 'ºC'),
	(263937, 118, '2014-04-01 00:39:51.000000', 'temperatura', 968.0000, 'ºC'),
	(263938, 118, '2014-04-01 00:39:52.000000', 'temperatura', 606.0000, 'ºC'),
	(263939, 118, '2014-04-01 00:39:53.000000', 'temperatura', 128.0000, 'ºC'),
	(263940, 118, '2014-04-01 00:39:54.000000', 'temperatura', 21.0000, 'ºC'),
	(263941, 118, '2014-04-01 00:39:55.000000', 'temperatura', 922.0000, 'ºC'),
	(263942, 118, '2014-04-01 00:39:56.000000', 'temperatura', 946.0000, 'ºC'),
	(263943, 118, '2014-04-01 00:39:57.000000', 'temperatura', 765.0000, 'ºC'),
	(263944, 118, '2014-04-01 00:39:58.000000', 'temperatura', 989.0000, 'ºC'),
	(263945, 118, '2014-04-01 00:39:59.000000', 'temperatura', 252.0000, 'ºC'),
	(263946, 118, '2014-04-01 00:40:00.000000', 'temperatura', 691.0000, 'ºC'),
	(263947, 118, '2014-04-01 00:40:01.000000', 'temperatura', 299.0000, 'ºC'),
	(263948, 118, '2014-04-01 00:40:02.000000', 'temperatura', 622.0000, 'ºC'),
	(263949, 118, '2014-04-01 00:40:03.000000', 'temperatura', 1013.0000, 'ºC'),
	(263950, 118, '2014-04-01 00:40:04.000000', 'temperatura', 802.0000, 'ºC'),
	(263951, 118, '2014-04-01 00:40:05.000000', 'temperatura', 972.0000, 'ºC'),
	(263952, 118, '2014-04-01 00:40:06.000000', 'temperatura', 52.0000, 'ºC'),
	(263953, 118, '2014-04-01 00:40:07.000000', 'temperatura', 946.0000, 'ºC'),
	(263954, 118, '2014-04-01 00:40:08.000000', 'temperatura', 973.0000, 'ºC'),
	(263955, 118, '2014-04-01 00:40:09.000000', 'temperatura', 828.0000, 'ºC'),
	(263956, 118, '2014-04-01 00:40:10.000000', 'temperatura', 23.0000, 'ºC'),
	(263957, 118, '2014-04-01 00:40:11.000000', 'temperatura', 30.0000, 'ºC'),
	(263958, 118, '2014-04-01 00:40:12.000000', 'temperatura', 81.0000, 'ºC'),
	(263959, 118, '2014-04-01 00:40:13.000000', 'temperatura', 315.0000, 'ºC'),
	(263960, 118, '2014-04-01 00:40:14.000000', 'temperatura', 135.0000, 'ºC'),
	(263961, 118, '2014-04-01 00:40:15.000000', 'temperatura', 928.0000, 'ºC'),
	(263962, 118, '2014-04-01 00:40:16.000000', 'temperatura', 635.0000, 'ºC'),
	(263963, 118, '2014-04-01 00:40:17.000000', 'temperatura', 393.0000, 'ºC'),
	(263964, 118, '2014-04-01 00:40:18.000000', 'temperatura', 61.0000, 'ºC'),
	(263965, 118, '2014-04-01 00:40:19.000000', 'temperatura', 328.0000, 'ºC'),
	(263966, 118, '2014-04-01 00:40:20.000000', 'temperatura', 254.0000, 'ºC'),
	(263967, 118, '2014-04-01 00:40:21.000000', 'temperatura', 289.0000, 'ºC'),
	(263968, 118, '2014-04-01 00:40:22.000000', 'temperatura', 683.0000, 'ºC'),
	(263969, 118, '2014-04-01 00:40:23.000000', 'temperatura', 149.0000, 'ºC'),
	(263970, 118, '2014-04-01 00:40:24.000000', 'temperatura', 1095.0000, 'ºC'),
	(263971, 118, '2014-04-01 00:40:25.000000', 'temperatura', 230.0000, 'ºC'),
	(263972, 118, '2014-04-01 00:40:26.000000', 'temperatura', 267.0000, 'ºC'),
	(263973, 118, '2014-04-01 00:40:27.000000', 'temperatura', 643.0000, 'ºC'),
	(263974, 118, '2014-04-01 00:40:28.000000', 'temperatura', 14.0000, 'ºC'),
	(263975, 118, '2014-04-01 00:40:29.000000', 'temperatura', 545.0000, 'ºC'),
	(263976, 118, '2014-04-01 00:40:30.000000', 'temperatura', 280.0000, 'ºC'),
	(263977, 118, '2014-04-01 00:40:31.000000', 'temperatura', 965.0000, 'ºC'),
	(263978, 118, '2014-04-01 00:40:32.000000', 'temperatura', 387.0000, 'ºC'),
	(263979, 118, '2014-04-01 00:40:33.000000', 'temperatura', 238.0000, 'ºC'),
	(263980, 118, '2014-04-01 00:40:34.000000', 'temperatura', 32.0000, 'ºC'),
	(263981, 118, '2014-04-01 00:40:35.000000', 'temperatura', 646.0000, 'ºC'),
	(263982, 118, '2014-04-01 00:40:36.000000', 'temperatura', 736.0000, 'ºC'),
	(263983, 118, '2014-04-01 00:40:37.000000', 'temperatura', 542.0000, 'ºC'),
	(263984, 118, '2014-04-01 00:40:38.000000', 'temperatura', 501.0000, 'ºC'),
	(263985, 118, '2014-04-01 00:40:39.000000', 'temperatura', 882.0000, 'ºC'),
	(263986, 118, '2014-04-01 00:40:40.000000', 'temperatura', 504.0000, 'ºC'),
	(263987, 118, '2014-04-01 00:40:41.000000', 'temperatura', 1078.0000, 'ºC'),
	(263988, 118, '2014-04-01 00:40:42.000000', 'temperatura', 275.0000, 'ºC'),
	(263989, 118, '2014-04-01 00:40:43.000000', 'temperatura', 544.0000, 'ºC'),
	(263990, 118, '2014-04-01 00:40:44.000000', 'temperatura', 693.0000, 'ºC'),
	(263991, 118, '2014-04-01 00:40:45.000000', 'temperatura', 635.0000, 'ºC'),
	(263992, 118, '2014-04-01 00:40:46.000000', 'temperatura', 1095.0000, 'ºC'),
	(263993, 118, '2014-04-01 00:40:47.000000', 'temperatura', 1172.0000, 'ºC'),
	(263994, 118, '2014-04-01 00:40:48.000000', 'temperatura', 175.0000, 'ºC'),
	(263995, 118, '2014-04-01 00:40:49.000000', 'temperatura', 960.0000, 'ºC'),
	(263996, 118, '2014-04-01 00:40:50.000000', 'temperatura', 675.0000, 'ºC'),
	(263997, 118, '2014-04-01 00:40:51.000000', 'temperatura', 496.0000, 'ºC'),
	(263998, 118, '2014-04-01 00:40:52.000000', 'temperatura', 457.0000, 'ºC'),
	(263999, 118, '2014-04-01 00:40:53.000000', 'temperatura', 797.0000, 'ºC'),
	(264000, 118, '2014-04-01 00:40:54.000000', 'temperatura', 215.0000, 'ºC'),
	(264001, 118, '2014-04-01 00:40:55.000000', 'temperatura', 1083.0000, 'ºC'),
	(264002, 118, '2014-04-01 00:40:56.000000', 'temperatura', 1170.0000, 'ºC'),
	(264003, 118, '2014-04-01 00:40:57.000000', 'temperatura', 202.0000, 'ºC'),
	(264004, 118, '2014-04-01 00:40:58.000000', 'temperatura', 1099.0000, 'ºC'),
	(264005, 118, '2014-04-01 00:40:59.000000', 'temperatura', 89.0000, 'ºC'),
	(264006, 118, '2014-04-01 00:41:00.000000', 'temperatura', 749.0000, 'ºC'),
	(264007, 118, '2014-04-01 00:41:01.000000', 'temperatura', 1080.0000, 'ºC'),
	(264008, 118, '2014-04-01 00:41:02.000000', 'temperatura', 755.0000, 'ºC'),
	(264009, 118, '2014-04-01 00:41:03.000000', 'temperatura', 533.0000, 'ºC'),
	(264010, 118, '2014-04-01 00:41:04.000000', 'temperatura', 401.0000, 'ºC'),
	(264011, 118, '2014-04-01 00:41:05.000000', 'temperatura', 404.0000, 'ºC'),
	(264012, 118, '2014-04-01 00:41:06.000000', 'temperatura', 821.0000, 'ºC'),
	(264013, 118, '2014-04-01 00:41:07.000000', 'temperatura', 494.0000, 'ºC'),
	(264014, 118, '2014-04-01 00:41:08.000000', 'temperatura', 6.0000, 'ºC'),
	(264015, 118, '2014-04-01 00:41:09.000000', 'temperatura', 948.0000, 'ºC'),
	(264016, 118, '2014-04-01 00:41:10.000000', 'temperatura', 1122.0000, 'ºC'),
	(264017, 118, '2014-04-01 00:41:11.000000', 'temperatura', 367.0000, 'ºC'),
	(264018, 118, '2014-04-01 00:41:12.000000', 'temperatura', 868.0000, 'ºC'),
	(264019, 118, '2014-04-01 00:41:13.000000', 'temperatura', 840.0000, 'ºC'),
	(264020, 118, '2014-04-01 00:41:14.000000', 'temperatura', 397.0000, 'ºC'),
	(264021, 118, '2014-04-01 00:41:15.000000', 'temperatura', 667.0000, 'ºC'),
	(264022, 118, '2014-04-01 00:41:16.000000', 'temperatura', 945.0000, 'ºC'),
	(264023, 118, '2014-04-01 00:41:17.000000', 'temperatura', 323.0000, 'ºC'),
	(264024, 118, '2014-04-01 00:41:18.000000', 'temperatura', 1182.0000, 'ºC'),
	(264025, 118, '2014-04-01 00:41:19.000000', 'temperatura', 143.0000, 'ºC'),
	(264026, 118, '2014-04-01 00:41:20.000000', 'temperatura', 767.0000, 'ºC'),
	(264027, 118, '2014-04-01 00:41:21.000000', 'temperatura', 1006.0000, 'ºC'),
	(264028, 118, '2014-04-01 00:41:22.000000', 'temperatura', 329.0000, 'ºC'),
	(264029, 118, '2014-04-01 00:41:23.000000', 'temperatura', 1027.0000, 'ºC'),
	(264030, 118, '2014-04-01 00:41:24.000000', 'temperatura', 548.0000, 'ºC'),
	(264031, 118, '2014-04-01 00:41:25.000000', 'temperatura', 863.0000, 'ºC'),
	(264032, 118, '2014-04-01 00:41:26.000000', 'temperatura', 268.0000, 'ºC'),
	(264033, 118, '2014-04-01 00:41:27.000000', 'temperatura', 1151.0000, 'ºC'),
	(264034, 118, '2014-04-01 00:41:28.000000', 'temperatura', 155.0000, 'ºC'),
	(264035, 118, '2014-04-01 00:41:29.000000', 'temperatura', 920.0000, 'ºC'),
	(264036, 118, '2014-04-01 00:41:30.000000', 'temperatura', 535.0000, 'ºC'),
	(264037, 118, '2014-04-01 00:41:31.000000', 'temperatura', 1117.0000, 'ºC'),
	(264038, 118, '2014-04-01 00:41:32.000000', 'temperatura', 381.0000, 'ºC'),
	(264039, 118, '2014-04-01 00:41:33.000000', 'temperatura', 954.0000, 'ºC'),
	(264040, 118, '2014-04-01 00:41:34.000000', 'temperatura', 27.0000, 'ºC'),
	(264041, 118, '2014-04-01 00:41:35.000000', 'temperatura', 873.0000, 'ºC'),
	(264042, 118, '2014-04-01 00:41:36.000000', 'temperatura', 683.0000, 'ºC'),
	(264043, 118, '2014-04-01 00:41:37.000000', 'temperatura', 797.0000, 'ºC'),
	(264044, 118, '2014-04-01 00:41:38.000000', 'temperatura', 739.0000, 'ºC'),
	(264045, 118, '2014-04-01 00:41:39.000000', 'temperatura', 102.0000, 'ºC'),
	(264046, 118, '2014-04-01 00:41:40.000000', 'temperatura', 695.0000, 'ºC'),
	(264047, 118, '2014-04-01 00:41:41.000000', 'temperatura', 770.0000, 'ºC'),
	(264048, 118, '2014-04-01 00:41:42.000000', 'temperatura', 564.0000, 'ºC'),
	(264049, 118, '2014-04-01 00:41:43.000000', 'temperatura', 513.0000, 'ºC'),
	(264050, 118, '2014-04-01 00:41:44.000000', 'temperatura', 872.0000, 'ºC'),
	(264051, 118, '2014-04-01 00:41:45.000000', 'temperatura', 421.0000, 'ºC'),
	(264052, 118, '2014-04-01 00:41:46.000000', 'temperatura', 688.0000, 'ºC'),
	(264053, 118, '2014-04-01 00:41:47.000000', 'temperatura', 978.0000, 'ºC'),
	(264054, 118, '2014-04-01 00:41:48.000000', 'temperatura', 428.0000, 'ºC'),
	(264055, 118, '2014-04-01 00:41:49.000000', 'temperatura', 408.0000, 'ºC'),
	(264056, 118, '2014-04-01 00:41:50.000000', 'temperatura', 755.0000, 'ºC'),
	(264057, 118, '2014-04-01 00:41:51.000000', 'temperatura', 151.0000, 'ºC'),
	(264058, 118, '2014-04-01 00:41:52.000000', 'temperatura', 893.0000, 'ºC'),
	(264059, 118, '2014-04-01 00:41:53.000000', 'temperatura', 410.0000, 'ºC'),
	(264060, 118, '2014-04-01 00:41:54.000000', 'temperatura', 572.0000, 'ºC'),
	(264061, 118, '2014-04-01 00:41:55.000000', 'temperatura', 429.0000, 'ºC'),
	(264062, 118, '2014-04-01 00:41:56.000000', 'temperatura', 431.0000, 'ºC'),
	(264063, 118, '2014-04-01 00:41:57.000000', 'temperatura', 869.0000, 'ºC'),
	(264064, 118, '2014-04-01 00:41:58.000000', 'temperatura', 651.0000, 'ºC'),
	(264065, 118, '2014-04-01 00:41:59.000000', 'temperatura', 647.0000, 'ºC'),
	(264066, 118, '2014-04-01 00:42:00.000000', 'temperatura', 86.0000, 'ºC'),
	(264067, 118, '2014-04-01 00:42:01.000000', 'temperatura', 888.0000, 'ºC'),
	(264068, 118, '2014-04-01 00:42:02.000000', 'temperatura', 584.0000, 'ºC'),
	(264069, 118, '2014-04-01 00:42:03.000000', 'temperatura', 255.0000, 'ºC'),
	(264070, 118, '2014-04-01 00:42:04.000000', 'temperatura', 724.0000, 'ºC'),
	(264071, 118, '2014-04-01 00:42:05.000000', 'temperatura', 455.0000, 'ºC'),
	(264072, 118, '2014-04-01 00:42:06.000000', 'temperatura', 105.0000, 'ºC'),
	(264073, 118, '2014-04-01 00:42:07.000000', 'temperatura', 359.0000, 'ºC'),
	(264074, 118, '2014-04-01 00:42:08.000000', 'temperatura', 280.0000, 'ºC'),
	(264075, 118, '2014-04-01 00:42:09.000000', 'temperatura', 322.0000, 'ºC'),
	(264076, 118, '2014-04-01 00:42:10.000000', 'temperatura', 773.0000, 'ºC'),
	(264077, 118, '2014-04-01 00:42:11.000000', 'temperatura', 497.0000, 'ºC'),
	(264078, 118, '2014-04-01 00:42:12.000000', 'temperatura', 166.0000, 'ºC'),
	(264079, 118, '2014-04-01 00:42:13.000000', 'temperatura', 543.0000, 'ºC'),
	(264080, 118, '2014-04-01 00:42:14.000000', 'temperatura', 1014.0000, 'ºC'),
	(264081, 118, '2014-04-01 00:42:15.000000', 'temperatura', 1043.0000, 'ºC'),
	(264082, 118, '2014-04-01 00:42:16.000000', 'temperatura', 971.0000, 'ºC'),
	(264083, 118, '2014-04-01 00:42:17.000000', 'temperatura', 530.0000, 'ºC'),
	(264084, 118, '2014-04-01 00:42:18.000000', 'temperatura', 934.0000, 'ºC'),
	(264085, 118, '2014-04-01 00:42:19.000000', 'temperatura', 684.0000, 'ºC'),
	(264086, 118, '2014-04-01 00:42:20.000000', 'temperatura', 616.0000, 'ºC'),
	(264087, 118, '2014-04-01 00:42:21.000000', 'temperatura', 1030.0000, 'ºC'),
	(264088, 118, '2014-04-01 00:42:22.000000', 'temperatura', 901.0000, 'ºC'),
	(264089, 118, '2014-04-01 00:42:23.000000', 'temperatura', 214.0000, 'ºC'),
	(264090, 118, '2014-04-01 00:42:24.000000', 'temperatura', 771.0000, 'ºC'),
	(264091, 118, '2014-04-01 00:42:25.000000', 'temperatura', 813.0000, 'ºC'),
	(264092, 118, '2014-04-01 00:42:26.000000', 'temperatura', 551.0000, 'ºC'),
	(264093, 118, '2014-04-01 00:42:27.000000', 'temperatura', 317.0000, 'ºC'),
	(264094, 118, '2014-04-01 00:42:28.000000', 'temperatura', 1132.0000, 'ºC'),
	(264095, 118, '2014-04-01 00:42:29.000000', 'temperatura', 1112.0000, 'ºC'),
	(264096, 118, '2014-04-01 00:42:30.000000', 'temperatura', 962.0000, 'ºC'),
	(264097, 118, '2014-04-01 00:42:31.000000', 'temperatura', 277.0000, 'ºC'),
	(264098, 118, '2014-04-01 00:42:32.000000', 'temperatura', 897.0000, 'ºC'),
	(264099, 118, '2014-04-01 00:42:33.000000', 'temperatura', 54.0000, 'ºC'),
	(264100, 118, '2014-04-01 00:42:34.000000', 'temperatura', 1182.0000, 'ºC'),
	(264101, 118, '2014-04-01 00:42:35.000000', 'temperatura', 945.0000, 'ºC'),
	(264102, 118, '2014-04-01 00:42:36.000000', 'temperatura', 1183.0000, 'ºC'),
	(264103, 118, '2014-04-01 00:42:37.000000', 'temperatura', 677.0000, 'ºC'),
	(264104, 118, '2014-04-01 00:42:38.000000', 'temperatura', 1040.0000, 'ºC'),
	(264105, 118, '2014-04-01 00:42:39.000000', 'temperatura', 768.0000, 'ºC'),
	(264106, 118, '2014-04-01 00:42:40.000000', 'temperatura', 723.0000, 'ºC'),
	(264107, 118, '2014-04-01 00:42:41.000000', 'temperatura', 108.0000, 'ºC'),
	(264108, 118, '2014-04-01 00:42:42.000000', 'temperatura', 773.0000, 'ºC'),
	(264109, 118, '2014-04-01 00:42:43.000000', 'temperatura', 1140.0000, 'ºC'),
	(264110, 118, '2014-04-01 00:42:44.000000', 'temperatura', 983.0000, 'ºC'),
	(264111, 118, '2014-04-01 00:42:45.000000', 'temperatura', 297.0000, 'ºC'),
	(264112, 118, '2014-04-01 00:42:46.000000', 'temperatura', 935.0000, 'ºC'),
	(264113, 118, '2014-04-01 00:42:47.000000', 'temperatura', 185.0000, 'ºC'),
	(264114, 118, '2014-04-01 00:42:48.000000', 'temperatura', 522.0000, 'ºC'),
	(264115, 118, '2014-04-01 00:42:49.000000', 'temperatura', 853.0000, 'ºC'),
	(264116, 118, '2014-04-01 00:42:50.000000', 'temperatura', 300.0000, 'ºC'),
	(264117, 118, '2014-04-01 00:42:51.000000', 'temperatura', 140.0000, 'ºC'),
	(264118, 118, '2014-04-01 00:42:52.000000', 'temperatura', 1001.0000, 'ºC'),
	(264119, 118, '2014-04-01 00:42:53.000000', 'temperatura', 987.0000, 'ºC'),
	(264120, 118, '2014-04-01 00:42:54.000000', 'temperatura', 733.0000, 'ºC'),
	(264121, 118, '2014-04-01 00:42:55.000000', 'temperatura', 705.0000, 'ºC'),
	(264122, 118, '2014-04-01 00:42:56.000000', 'temperatura', 127.0000, 'ºC'),
	(264123, 118, '2014-04-01 00:42:57.000000', 'temperatura', 921.0000, 'ºC'),
	(264124, 118, '2014-04-01 00:42:58.000000', 'temperatura', 624.0000, 'ºC'),
	(264125, 118, '2014-04-01 00:42:59.000000', 'temperatura', 356.0000, 'ºC'),
	(264126, 118, '2014-04-01 00:43:00.000000', 'temperatura', 1110.0000, 'ºC'),
	(264127, 118, '2014-04-01 00:43:01.000000', 'temperatura', 883.0000, 'ºC'),
	(264128, 118, '2014-04-01 00:43:02.000000', 'temperatura', 1084.0000, 'ºC'),
	(264129, 118, '2014-04-01 00:43:03.000000', 'temperatura', 372.0000, 'ºC'),
	(264130, 118, '2014-04-01 00:43:04.000000', 'temperatura', 1007.0000, 'ºC'),
	(264131, 118, '2014-04-01 00:43:05.000000', 'temperatura', 320.0000, 'ºC'),
	(264132, 118, '2014-04-01 00:43:06.000000', 'temperatura', 979.0000, 'ºC'),
	(264133, 118, '2014-04-01 00:43:07.000000', 'temperatura', 337.0000, 'ºC'),
	(264134, 118, '2014-04-01 00:43:08.000000', 'temperatura', 1149.0000, 'ºC'),
	(264135, 118, '2014-04-01 00:43:09.000000', 'temperatura', 1133.0000, 'ºC'),
	(264136, 118, '2014-04-01 00:43:10.000000', 'temperatura', 1018.0000, 'ºC'),
	(264137, 118, '2014-04-01 00:43:11.000000', 'temperatura', 491.0000, 'ºC'),
	(264138, 118, '2014-04-01 00:43:12.000000', 'temperatura', 603.0000, 'ºC'),
	(264139, 118, '2014-04-01 00:43:13.000000', 'temperatura', 342.0000, 'ºC'),
	(264140, 118, '2014-04-01 00:43:14.000000', 'temperatura', 1099.0000, 'ºC'),
	(264141, 118, '2014-04-01 00:43:15.000000', 'temperatura', 873.0000, 'ºC'),
	(264142, 118, '2014-04-01 00:43:16.000000', 'temperatura', 1068.0000, 'ºC'),
	(264143, 118, '2014-04-01 00:43:17.000000', 'temperatura', 321.0000, 'ºC'),
	(264144, 118, '2014-04-01 00:43:18.000000', 'temperatura', 800.0000, 'ºC'),
	(264145, 118, '2014-04-01 00:43:19.000000', 'temperatura', 640.0000, 'ºC'),
	(264146, 118, '2014-04-01 00:43:20.000000', 'temperatura', 801.0000, 'ºC'),
	(264147, 118, '2014-04-01 00:43:21.000000', 'temperatura', 886.0000, 'ºC'),
	(264148, 118, '2014-04-01 00:43:22.000000', 'temperatura', 824.0000, 'ºC'),
	(264149, 118, '2014-04-01 00:43:23.000000', 'temperatura', 266.0000, 'ºC'),
	(264150, 118, '2014-04-01 00:43:24.000000', 'temperatura', 58.0000, 'ºC'),
	(264151, 118, '2014-04-01 00:43:25.000000', 'temperatura', 691.0000, 'ºC'),
	(264152, 118, '2014-04-01 00:43:26.000000', 'temperatura', 880.0000, 'ºC'),
	(264153, 118, '2014-04-01 00:43:27.000000', 'temperatura', 1130.0000, 'ºC'),
	(264154, 118, '2014-04-01 00:43:28.000000', 'temperatura', 609.0000, 'ºC'),
	(264155, 118, '2014-04-01 00:43:29.000000', 'temperatura', 856.0000, 'ºC'),
	(264156, 118, '2014-04-01 00:43:30.000000', 'temperatura', 53.0000, 'ºC'),
	(264157, 118, '2014-04-01 00:43:31.000000', 'temperatura', 100.0000, 'ºC'),
	(264158, 118, '2014-04-01 00:43:32.000000', 'temperatura', 339.0000, 'ºC'),
	(264159, 118, '2014-04-01 00:43:33.000000', 'temperatura', 195.0000, 'ºC'),
	(264160, 118, '2014-04-01 00:43:34.000000', 'temperatura', 1159.0000, 'ºC'),
	(264161, 118, '2014-04-01 00:43:35.000000', 'temperatura', 411.0000, 'ºC'),
	(264162, 118, '2014-04-01 00:43:36.000000', 'temperatura', 980.0000, 'ºC'),
	(264163, 118, '2014-04-01 00:43:37.000000', 'temperatura', 68.0000, 'ºC'),
	(264164, 118, '2014-04-01 00:43:38.000000', 'temperatura', 997.0000, 'ºC'),
	(264165, 118, '2014-04-01 00:43:39.000000', 'temperatura', 1185.0000, 'ºC'),
	(264166, 118, '2014-04-01 00:43:40.000000', 'temperatura', 531.0000, 'ºC'),
	(264167, 118, '2014-04-01 00:43:41.000000', 'temperatura', 302.0000, 'ºC'),
	(264168, 118, '2014-04-01 00:43:42.000000', 'temperatura', 1118.0000, 'ºC'),
	(264169, 118, '2014-04-01 00:43:43.000000', 'temperatura', 1086.0000, 'ºC'),
	(264170, 118, '2014-04-01 00:43:44.000000', 'temperatura', 877.0000, 'ºC'),
	(264171, 118, '2014-04-01 00:43:45.000000', 'temperatura', 1124.0000, 'ºC'),
	(264172, 118, '2014-04-01 00:43:46.000000', 'temperatura', 593.0000, 'ºC'),
	(264173, 118, '2014-04-01 00:43:47.000000', 'temperatura', 792.0000, 'ºC'),
	(264174, 118, '2014-04-01 00:43:48.000000', 'temperatura', 984.0000, 'ºC'),
	(264175, 118, '2014-04-01 00:43:49.000000', 'temperatura', 141.0000, 'ºC'),
	(264176, 118, '2014-04-01 00:43:50.000000', 'temperatura', 154.0000, 'ºC'),
	(264177, 118, '2014-04-01 00:43:51.000000', 'temperatura', 348.0000, 'ºC'),
	(264178, 118, '2014-04-01 00:43:52.000000', 'temperatura', 80.0000, 'ºC'),
	(264179, 118, '2014-04-01 00:43:53.000000', 'temperatura', 554.0000, 'ºC'),
	(264180, 118, '2014-04-01 00:43:54.000000', 'temperatura', 131.0000, 'ºC'),
	(264181, 118, '2014-04-01 00:43:55.000000', 'temperatura', 195.0000, 'ºC'),
	(264182, 118, '2014-04-01 00:43:56.000000', 'temperatura', 582.0000, 'ºC'),
	(264183, 118, '2014-04-01 00:43:57.000000', 'temperatura', 1126.0000, 'ºC'),
	(264184, 118, '2014-04-01 00:43:58.000000', 'temperatura', 284.0000, 'ºC'),
	(264185, 118, '2014-04-01 00:43:59.000000', 'temperatura', 443.0000, 'ºC'),
	(264186, 118, '2014-04-01 00:44:00.000000', 'temperatura', 161.0000, 'ºC'),
	(264187, 118, '2014-04-01 00:44:01.000000', 'temperatura', 678.0000, 'ºC'),
	(264188, 118, '2014-04-01 00:44:02.000000', 'temperatura', 509.0000, 'ºC'),
	(264189, 118, '2014-04-01 00:44:03.000000', 'temperatura', 512.0000, 'ºC'),
	(264190, 118, '2014-04-01 00:44:04.000000', 'temperatura', 1032.0000, 'ºC'),
	(264191, 118, '2014-04-01 00:44:05.000000', 'temperatura', 25.0000, 'ºC'),
	(264192, 118, '2014-04-01 00:44:06.000000', 'temperatura', 631.0000, 'ºC'),
	(264193, 118, '2014-04-01 00:44:07.000000', 'temperatura', 679.0000, 'ºC'),
	(264194, 118, '2014-04-01 00:44:08.000000', 'temperatura', 304.0000, 'ºC'),
	(264195, 118, '2014-04-01 00:44:09.000000', 'temperatura', 683.0000, 'ºC'),
	(264196, 118, '2014-04-01 00:44:10.000000', 'temperatura', 102.0000, 'ºC'),
	(264197, 118, '2014-04-01 00:44:11.000000', 'temperatura', 861.0000, 'ºC'),
	(264198, 118, '2014-04-01 00:44:12.000000', 'temperatura', 402.0000, 'ºC'),
	(264199, 118, '2014-04-01 00:44:13.000000', 'temperatura', 626.0000, 'ºC'),
	(264200, 118, '2014-04-01 00:44:14.000000', 'temperatura', 726.0000, 'ºC'),
	(264201, 118, '2014-04-01 00:44:15.000000', 'temperatura', 553.0000, 'ºC'),
	(264202, 118, '2014-04-01 00:44:16.000000', 'temperatura', 588.0000, 'ºC'),
	(264203, 118, '2014-04-01 00:44:17.000000', 'temperatura', 80.0000, 'ºC'),
	(264204, 118, '2014-04-01 00:44:18.000000', 'temperatura', 1038.0000, 'ºC'),
	(264205, 118, '2014-04-01 00:44:19.000000', 'temperatura', 149.0000, 'ºC'),
	(264206, 118, '2014-04-01 00:44:20.000000', 'temperatura', 32.0000, 'ºC'),
	(264207, 118, '2014-04-01 00:44:21.000000', 'temperatura', 913.0000, 'ºC'),
	(264208, 118, '2014-04-01 00:44:22.000000', 'temperatura', 870.0000, 'ºC'),
	(264209, 118, '2014-04-01 00:44:23.000000', 'temperatura', 411.0000, 'ºC'),
	(264210, 118, '2014-04-01 00:44:24.000000', 'temperatura', 644.0000, 'ºC'),
	(264211, 118, '2014-04-01 00:44:25.000000', 'temperatura', 789.0000, 'ºC'),
	(264212, 118, '2014-04-01 00:44:26.000000', 'temperatura', 812.0000, 'ºC'),
	(264213, 118, '2014-04-01 00:44:27.000000', 'temperatura', 493.0000, 'ºC'),
	(264214, 118, '2014-04-01 00:44:28.000000', 'temperatura', 31.0000, 'ºC'),
	(264215, 118, '2014-04-01 00:44:29.000000', 'temperatura', 1075.0000, 'ºC'),
	(264216, 118, '2014-04-01 00:44:30.000000', 'temperatura', 484.0000, 'ºC'),
	(264217, 118, '2014-04-01 00:44:31.000000', 'temperatura', 393.0000, 'ºC'),
	(264218, 118, '2014-04-01 00:44:32.000000', 'temperatura', 515.0000, 'ºC'),
	(264219, 118, '2014-04-01 00:44:33.000000', 'temperatura', 196.0000, 'ºC'),
	(264220, 118, '2014-04-01 00:44:34.000000', 'temperatura', 636.0000, 'ºC'),
	(264221, 118, '2014-04-01 00:44:35.000000', 'temperatura', 191.0000, 'ºC'),
	(264222, 118, '2014-04-01 00:44:36.000000', 'temperatura', 249.0000, 'ºC'),
	(264223, 118, '2014-04-01 00:44:37.000000', 'temperatura', 672.0000, 'ºC'),
	(264224, 118, '2014-04-01 00:44:38.000000', 'temperatura', 215.0000, 'ºC'),
	(264225, 118, '2014-04-01 00:44:39.000000', 'temperatura', 260.0000, 'ºC'),
	(264226, 118, '2014-04-01 00:44:40.000000', 'temperatura', 653.0000, 'ºC'),
	(264227, 118, '2014-04-01 00:44:41.000000', 'temperatura', 86.0000, 'ºC'),
	(264228, 118, '2014-04-01 00:44:42.000000', 'temperatura', 874.0000, 'ºC'),
	(264229, 118, '2014-04-01 00:44:43.000000', 'temperatura', 509.0000, 'ºC'),
	(264230, 118, '2014-04-01 00:44:44.000000', 'temperatura', 1125.0000, 'ºC'),
	(264231, 118, '2014-04-01 00:44:45.000000', 'temperatura', 498.0000, 'ºC'),
	(264232, 118, '2014-04-01 00:44:46.000000', 'temperatura', 315.0000, 'ºC'),
	(264233, 118, '2014-04-01 00:44:47.000000', 'temperatura', 82.0000, 'ºC'),
	(264234, 118, '2014-04-01 00:44:48.000000', 'temperatura', 664.0000, 'ºC'),
	(264235, 118, '2014-04-01 00:44:49.000000', 'temperatura', 675.0000, 'ºC'),
	(264236, 118, '2014-04-01 00:44:50.000000', 'temperatura', 184.0000, 'ºC'),
	(264237, 118, '2014-04-01 00:44:51.000000', 'temperatura', 94.0000, 'ºC'),
	(264238, 118, '2014-04-01 00:44:52.000000', 'temperatura', 1119.0000, 'ºC'),
	(264239, 118, '2014-04-01 00:44:53.000000', 'temperatura', 514.0000, 'ºC'),
	(264240, 118, '2014-04-01 00:44:54.000000', 'temperatura', 413.0000, 'ºC'),
	(264241, 118, '2014-04-01 00:44:55.000000', 'temperatura', 525.0000, 'ºC'),
	(264242, 118, '2014-04-01 00:44:56.000000', 'temperatura', 184.0000, 'ºC'),
	(264243, 118, '2014-04-01 00:44:57.000000', 'temperatura', 548.0000, 'ºC'),
	(264244, 118, '2014-04-01 00:44:58.000000', 'temperatura', 986.0000, 'ºC'),
	(264245, 118, '2014-04-01 00:44:59.000000', 'temperatura', 889.0000, 'ºC'),
	(264246, 118, '2014-04-01 00:45:00.000000', 'temperatura', 286.0000, 'ºC'),
	(264247, 118, '2014-04-01 00:45:01.000000', 'temperatura', 1164.0000, 'ºC'),
	(264248, 118, '2014-04-01 00:45:02.000000', 'temperatura', 163.0000, 'ºC'),
	(264249, 118, '2014-04-01 00:45:03.000000', 'temperatura', 924.0000, 'ºC'),
	(264250, 118, '2014-04-01 00:45:04.000000', 'temperatura', 529.0000, 'ºC'),
	(264251, 118, '2014-04-01 00:45:05.000000', 'temperatura', 1075.0000, 'ºC'),
	(264252, 118, '2014-04-01 00:45:06.000000', 'temperatura', 187.0000, 'ºC'),
	(264253, 118, '2014-04-01 00:45:07.000000', 'temperatura', 112.0000, 'ºC'),
	(264254, 118, '2014-04-01 00:45:08.000000', 'temperatura', 1.0000, 'ºC'),
	(264255, 118, '2014-04-01 00:45:09.000000', 'temperatura', 869.0000, 'ºC'),
	(264256, 118, '2014-04-01 00:45:10.000000', 'temperatura', 740.0000, 'ºC'),
	(264257, 118, '2014-04-01 00:45:11.000000', 'temperatura', 1096.0000, 'ºC'),
	(264258, 118, '2014-04-01 00:45:12.000000', 'temperatura', 859.0000, 'ºC'),
	(264259, 118, '2014-04-01 00:45:13.000000', 'temperatura', 1006.0000, 'ºC'),
	(264260, 118, '2014-04-01 00:45:14.000000', 'temperatura', 55.0000, 'ºC'),
	(264261, 118, '2014-04-01 00:45:15.000000', 'temperatura', 859.0000, 'ºC'),
	(264262, 118, '2014-04-01 00:45:16.000000', 'temperatura', 531.0000, 'ºC'),
	(264263, 118, '2014-04-01 00:45:17.000000', 'temperatura', 76.0000, 'ºC'),
	(264264, 118, '2014-04-01 00:45:18.000000', 'temperatura', 1190.0000, 'ºC'),
	(264265, 118, '2014-04-01 00:45:19.000000', 'temperatura', 922.0000, 'ºC'),
	(264266, 118, '2014-04-01 00:45:20.000000', 'temperatura', 1040.0000, 'ºC'),
	(264267, 118, '2014-04-01 00:45:21.000000', 'temperatura', 36.0000, 'ºC'),
	(264268, 118, '2014-04-01 00:45:22.000000', 'temperatura', 661.0000, 'ºC'),
	(264269, 118, '2014-04-01 00:45:23.000000', 'temperatura', 798.0000, 'ºC'),
	(264270, 118, '2014-04-01 00:45:24.000000', 'temperatura', 806.0000, 'ºC'),
	(264271, 118, '2014-04-01 00:45:25.000000', 'temperatura', 437.0000, 'ºC'),
	(264272, 118, '2014-04-01 00:45:26.000000', 'temperatura', 968.0000, 'ºC'),
	(264273, 118, '2014-04-01 00:45:27.000000', 'temperatura', 1131.0000, 'ºC'),
	(264274, 118, '2014-04-01 00:45:28.000000', 'temperatura', 348.0000, 'ºC'),
	(264275, 118, '2014-04-01 00:45:29.000000', 'temperatura', 750.0000, 'ºC'),
	(264276, 118, '2014-04-01 00:45:30.000000', 'temperatura', 305.0000, 'ºC'),
	(264277, 118, '2014-04-01 00:45:31.000000', 'temperatura', 476.0000, 'ºC'),
	(264278, 118, '2014-04-01 00:45:32.000000', 'temperatura', 267.0000, 'ºC'),
	(264279, 118, '2014-04-01 00:45:33.000000', 'temperatura', 1108.0000, 'ºC'),
	(264280, 118, '2014-04-01 00:45:34.000000', 'temperatura', 1139.0000, 'ºC'),
	(264281, 118, '2014-04-01 00:45:35.000000', 'temperatura', 1173.0000, 'ºC'),
	(264282, 118, '2014-04-01 00:45:36.000000', 'temperatura', 48.0000, 'ºC'),
	(264283, 118, '2014-04-01 00:45:37.000000', 'temperatura', 319.0000, 'ºC'),
	(264284, 118, '2014-04-01 00:45:38.000000', 'temperatura', 254.0000, 'ºC'),
	(264285, 118, '2014-04-01 00:45:39.000000', 'temperatura', 312.0000, 'ºC'),
	(264286, 118, '2014-04-01 00:45:40.000000', 'temperatura', 798.0000, 'ºC'),
	(264287, 118, '2014-04-01 00:45:41.000000', 'temperatura', 657.0000, 'ºC'),
	(264288, 118, '2014-04-01 00:45:42.000000', 'temperatura', 889.0000, 'ºC'),
	(264289, 118, '2014-04-01 00:45:43.000000', 'temperatura', 75.0000, 'ºC'),
	(264290, 118, '2014-04-01 00:45:44.000000', 'temperatura', 110.0000, 'ºC'),
	(264291, 118, '2014-04-01 00:45:45.000000', 'temperatura', 324.0000, 'ºC'),
	(264292, 118, '2014-04-01 00:45:46.000000', 'temperatura', 92.0000, 'ºC'),
	(264293, 118, '2014-04-01 00:45:47.000000', 'temperatura', 686.0000, 'ºC'),
	(264294, 118, '2014-04-01 00:45:48.000000', 'temperatura', 756.0000, 'ºC'),
	(264295, 118, '2014-04-01 00:45:49.000000', 'temperatura', 522.0000, 'ºC'),
	(264296, 118, '2014-04-01 00:45:50.000000', 'temperatura', 341.0000, 'ºC'),
	(264297, 118, '2014-04-01 00:45:51.000000', 'temperatura', 139.0000, 'ºC'),
	(264298, 118, '2014-04-01 00:45:52.000000', 'temperatura', 874.0000, 'ºC'),
	(264299, 118, '2014-04-01 00:45:53.000000', 'temperatura', 355.0000, 'ºC'),
	(264300, 118, '2014-04-01 00:45:54.000000', 'temperatura', 352.0000, 'ºC'),
	(264301, 118, '2014-04-01 00:45:55.000000', 'temperatura', 695.0000, 'ºC'),
	(264302, 118, '2014-04-01 00:45:56.000000', 'temperatura', 18.0000, 'ºC'),
	(264303, 118, '2014-04-01 00:45:57.000000', 'temperatura', 408.0000, 'ºC'),
	(264304, 118, '2014-04-01 00:45:58.000000', 'temperatura', 785.0000, 'ºC'),
	(264305, 118, '2014-04-01 00:45:59.000000', 'temperatura', 302.0000, 'ºC'),
	(264306, 118, '2014-04-01 00:46:00.000000', 'temperatura', 357.0000, 'ºC'),
	(264307, 118, '2014-04-01 00:46:01.000000', 'temperatura', 878.0000, 'ºC'),
	(264308, 118, '2014-04-01 00:46:02.000000', 'temperatura', 920.0000, 'ºC'),
	(264309, 118, '2014-04-01 00:46:03.000000', 'temperatura', 766.0000, 'ºC'),
	(264310, 118, '2014-04-01 00:46:04.000000', 'temperatura', 1073.0000, 'ºC'),
	(264311, 118, '2014-04-01 00:46:05.000000', 'temperatura', 665.0000, 'ºC'),
	(264312, 118, '2014-04-01 00:46:06.000000', 'temperatura', 108.0000, 'ºC'),
	(264313, 118, '2014-04-01 00:46:07.000000', 'temperatura', 944.0000, 'ºC'),
	(264314, 118, '2014-04-01 00:46:08.000000', 'temperatura', 797.0000, 'ºC'),
	(264315, 118, '2014-04-01 00:46:09.000000', 'temperatura', 1155.0000, 'ºC'),
	(264316, 118, '2014-04-01 00:46:10.000000', 'temperatura', 985.0000, 'ºC'),
	(264317, 118, '2014-04-01 00:46:11.000000', 'temperatura', 261.0000, 'ºC'),
	(264318, 118, '2014-04-01 00:46:12.000000', 'temperatura', 750.0000, 'ºC'),
	(264319, 118, '2014-04-01 00:46:13.000000', 'temperatura', 565.0000, 'ºC'),
	(264320, 118, '2014-04-01 00:46:14.000000', 'temperatura', 578.0000, 'ºC'),
	(264321, 118, '2014-04-01 00:46:15.000000', 'temperatura', 1194.0000, 'ºC'),
	(264322, 118, '2014-04-01 00:46:16.000000', 'temperatura', 637.0000, 'ºC'),
	(264323, 118, '2014-04-01 00:46:17.000000', 'temperatura', 802.0000, 'ºC'),
	(264324, 118, '2014-04-01 00:46:18.000000', 'temperatura', 900.0000, 'ºC'),
	(264325, 118, '2014-04-01 00:46:19.000000', 'temperatura', 893.0000, 'ºC'),
	(264326, 118, '2014-04-01 00:46:20.000000', 'temperatura', 567.0000, 'ºC'),
	(264327, 118, '2014-04-01 00:46:21.000000', 'temperatura', 157.0000, 'ºC'),
	(264328, 118, '2014-04-01 00:46:22.000000', 'temperatura', 285.0000, 'ºC'),
	(264329, 118, '2014-04-01 00:46:23.000000', 'temperatura', 952.0000, 'ºC'),
	(264330, 118, '2014-04-01 00:46:24.000000', 'temperatura', 306.0000, 'ºC'),
	(264331, 118, '2014-04-01 00:46:25.000000', 'temperatura', 1077.0000, 'ºC'),
	(264332, 118, '2014-04-01 00:46:26.000000', 'temperatura', 867.0000, 'ºC'),
	(264333, 118, '2014-04-01 00:46:27.000000', 'temperatura', 1102.0000, 'ºC'),
	(264334, 118, '2014-04-01 00:46:28.000000', 'temperatura', 512.0000, 'ºC'),
	(264335, 118, '2014-04-01 00:46:29.000000', 'temperatura', 454.0000, 'ºC'),
	(264336, 118, '2014-04-01 00:46:30.000000', 'temperatura', 733.0000, 'ºC'),
	(264337, 118, '2014-04-01 00:46:31.000000', 'temperatura', 1104.0000, 'ºC'),
	(264338, 118, '2014-04-01 00:46:32.000000', 'temperatura', 923.0000, 'ºC'),
	(264339, 118, '2014-04-01 00:46:33.000000', 'temperatura', 102.0000, 'ºC'),
	(264340, 118, '2014-04-01 00:46:34.000000', 'temperatura', 140.0000, 'ºC'),
	(264341, 118, '2014-04-01 00:46:35.000000', 'temperatura', 395.0000, 'ºC'),
	(264342, 118, '2014-04-01 00:46:36.000000', 'temperatura', 357.0000, 'ºC'),
	(264343, 118, '2014-04-01 00:46:37.000000', 'temperatura', 599.0000, 'ºC'),
	(264344, 118, '2014-04-01 00:46:38.000000', 'temperatura', 723.0000, 'ºC'),
	(264345, 118, '2014-04-01 00:46:39.000000', 'temperatura', 622.0000, 'ºC'),
	(264346, 118, '2014-04-01 00:46:40.000000', 'temperatura', 940.0000, 'ºC'),
	(264347, 118, '2014-04-01 00:46:41.000000', 'temperatura', 436.0000, 'ºC'),
	(264348, 118, '2014-04-01 00:46:42.000000', 'temperatura', 559.0000, 'ºC'),
	(264349, 118, '2014-04-01 00:46:43.000000', 'temperatura', 289.0000, 'ºC'),
	(264350, 118, '2014-04-01 00:46:44.000000', 'temperatura', 966.0000, 'ºC'),
	(264351, 118, '2014-04-01 00:46:45.000000', 'temperatura', 363.0000, 'ºC'),
	(264352, 118, '2014-04-01 00:46:46.000000', 'temperatura', 118.0000, 'ºC'),
	(264353, 118, '2014-04-01 00:46:47.000000', 'temperatura', 701.0000, 'ºC'),
	(264354, 118, '2014-04-01 00:46:48.000000', 'temperatura', 751.0000, 'ºC'),
	(264355, 118, '2014-04-01 00:46:49.000000', 'temperatura', 453.0000, 'ºC'),
	(264356, 118, '2014-04-01 00:46:50.000000', 'temperatura', 12.0000, 'ºC'),
	(264357, 118, '2014-04-01 00:46:51.000000', 'temperatura', 1101.0000, 'ºC'),
	(264358, 118, '2014-04-01 00:46:52.000000', 'temperatura', 668.0000, 'ºC'),
	(264359, 118, '2014-04-01 00:46:53.000000', 'temperatura', 40.0000, 'ºC'),
	(264360, 118, '2014-04-01 00:46:54.000000', 'temperatura', 595.0000, 'ºC'),
	(264361, 118, '2014-04-01 00:46:55.000000', 'temperatura', 454.0000, 'ºC'),
	(264362, 118, '2014-04-01 00:46:56.000000', 'temperatura', 489.0000, 'ºC'),
	(264363, 118, '2014-04-01 00:46:57.000000', 'temperatura', 1081.0000, 'ºC'),
	(264364, 118, '2014-04-01 00:46:58.000000', 'temperatura', 339.0000, 'ºC'),
	(264365, 118, '2014-04-01 00:46:59.000000', 'temperatura', 852.0000, 'ºC'),
	(264366, 118, '2014-04-01 00:47:00.000000', 'temperatura', 843.0000, 'ºC'),
	(264367, 118, '2014-04-01 00:47:01.000000', 'temperatura', 459.0000, 'ºC'),
	(264368, 118, '2014-04-01 00:47:02.000000', 'temperatura', 969.0000, 'ºC'),
	(264369, 118, '2014-04-01 00:47:03.000000', 'temperatura', 1067.0000, 'ºC'),
	(264370, 118, '2014-04-01 00:47:04.000000', 'temperatura', 29.0000, 'ºC'),
	(264371, 118, '2014-04-01 00:47:05.000000', 'temperatura', 546.0000, 'ºC'),
	(264372, 118, '2014-04-01 00:47:06.000000', 'temperatura', 242.0000, 'ºC'),
	(264373, 118, '2014-04-01 00:47:07.000000', 'temperatura', 772.0000, 'ºC'),
	(264374, 118, '2014-04-01 00:47:08.000000', 'temperatura', 735.0000, 'ºC'),
	(264375, 118, '2014-04-01 00:47:09.000000', 'temperatura', 161.0000, 'ºC'),
	(264376, 118, '2014-04-01 00:47:10.000000', 'temperatura', 1000.0000, 'ºC'),
	(264377, 118, '2014-04-01 00:47:11.000000', 'temperatura', 918.0000, 'ºC'),
	(264378, 118, '2014-04-01 00:47:12.000000', 'temperatura', 389.0000, 'ºC'),
	(264379, 118, '2014-04-01 00:47:13.000000', 'temperatura', 391.0000, 'ºC'),
	(264380, 118, '2014-04-01 00:47:14.000000', 'temperatura', 789.0000, 'ºC'),
	(264381, 118, '2014-04-01 00:47:15.000000', 'temperatura', 373.0000, 'ºC'),
	(264382, 118, '2014-04-01 00:47:16.000000', 'temperatura', 699.0000, 'ºC'),
	(264383, 118, '2014-04-01 00:47:17.000000', 'temperatura', 1176.0000, 'ºC'),
	(264384, 118, '2014-04-01 00:47:18.000000', 'temperatura', 184.0000, 'ºC'),
	(264385, 118, '2014-04-01 00:47:19.000000', 'temperatura', 991.0000, 'ºC'),
	(264386, 118, '2014-04-01 00:47:20.000000', 'temperatura', 803.0000, 'ºC'),
	(264387, 118, '2014-04-01 00:47:21.000000', 'temperatura', 1042.0000, 'ºC'),
	(264388, 118, '2014-04-01 00:47:22.000000', 'temperatura', 404.0000, 'ºC'),
	(264389, 118, '2014-04-01 00:47:23.000000', 'temperatura', 93.0000, 'ºC'),
	(264390, 118, '2014-04-01 00:47:24.000000', 'temperatura', 453.0000, 'ºC'),
	(264391, 118, '2014-04-01 00:47:25.000000', 'temperatura', 787.0000, 'ºC'),
	(264392, 118, '2014-04-01 00:47:26.000000', 'temperatura', 177.0000, 'ºC'),
	(264393, 118, '2014-04-01 00:47:27.000000', 'temperatura', 922.0000, 'ºC'),
	(264394, 118, '2014-04-01 00:47:28.000000', 'temperatura', 481.0000, 'ºC'),
	(264395, 118, '2014-04-01 00:47:29.000000', 'temperatura', 841.0000, 'ºC'),
	(264396, 118, '2014-04-01 00:47:30.000000', 'temperatura', 363.0000, 'ºC'),
	(264397, 118, '2014-04-01 00:47:31.000000', 'temperatura', 491.0000, 'ºC'),
	(264398, 118, '2014-04-01 00:47:32.000000', 'temperatura', 165.0000, 'ºC'),
	(264399, 118, '2014-04-01 00:47:33.000000', 'temperatura', 553.0000, 'ºC'),
	(264400, 118, '2014-04-01 00:47:34.000000', 'temperatura', 1072.0000, 'ºC'),
	(264401, 118, '2014-04-01 00:47:35.000000', 'temperatura', 103.0000, 'ºC'),
	(264402, 118, '2014-04-01 00:47:36.000000', 'temperatura', 896.0000, 'ºC'),
	(264403, 118, '2014-04-01 00:47:37.000000', 'temperatura', 574.0000, 'ºC'),
	(264404, 118, '2014-04-01 00:47:38.000000', 'temperatura', 180.0000, 'ºC'),
	(264405, 118, '2014-04-01 00:47:39.000000', 'temperatura', 381.0000, 'ºC'),
	(264406, 118, '2014-04-01 00:47:40.000000', 'temperatura', 165.0000, 'ºC'),
	(264407, 118, '2014-04-01 00:47:41.000000', 'temperatura', 884.0000, 'ºC'),
	(264408, 118, '2014-04-01 00:47:42.000000', 'temperatura', 323.0000, 'ºC'),
	(264409, 118, '2014-04-01 00:47:43.000000', 'temperatura', 166.0000, 'ºC'),
	(264410, 118, '2014-04-01 00:47:44.000000', 'temperatura', 1062.0000, 'ºC'),
	(264411, 118, '2014-04-01 00:47:45.000000', 'temperatura', 11.0000, 'ºC'),
	(264412, 118, '2014-04-01 00:47:46.000000', 'temperatura', 469.0000, 'ºC'),
	(264413, 118, '2014-04-01 00:47:47.000000', 'temperatura', 1111.0000, 'ºC'),
	(264414, 118, '2014-04-01 00:47:48.000000', 'temperatura', 552.0000, 'ºC'),
	(264415, 118, '2014-04-01 00:47:49.000000', 'temperatura', 624.0000, 'ºC'),
	(264416, 118, '2014-04-01 00:47:50.000000', 'temperatura', 266.0000, 'ºC'),
	(264417, 118, '2014-04-01 00:47:51.000000', 'temperatura', 659.0000, 'ºC'),
	(264418, 118, '2014-04-01 00:47:52.000000', 'temperatura', 96.0000, 'ºC'),
	(264419, 118, '2014-04-01 00:47:53.000000', 'temperatura', 903.0000, 'ºC'),
	(264420, 118, '2014-04-01 00:47:54.000000', 'temperatura', 630.0000, 'ºC'),
	(264421, 118, '2014-04-01 00:47:55.000000', 'temperatura', 440.0000, 'ºC'),
	(264422, 118, '2014-04-01 00:47:56.000000', 'temperatura', 312.0000, 'ºC'),
	(264423, 118, '2014-04-01 00:47:57.000000', 'temperatura', 238.0000, 'ºC'),
	(264424, 118, '2014-04-01 00:47:58.000000', 'temperatura', 254.0000, 'ºC'),
	(264425, 118, '2014-04-01 00:47:59.000000', 'temperatura', 559.0000, 'ºC'),
	(264426, 118, '2014-04-01 00:48:00.000000', 'temperatura', 833.0000, 'ºC'),
	(264427, 118, '2014-04-01 00:48:01.000000', 'temperatura', 87.0000, 'ºC'),
	(264428, 118, '2014-04-01 00:48:02.000000', 'temperatura', 337.0000, 'ºC'),
	(264429, 118, '2014-04-01 00:48:03.000000', 'temperatura', 223.0000, 'ºC'),
	(264430, 118, '2014-04-01 00:48:04.000000', 'temperatura', 105.0000, 'ºC'),
	(264431, 118, '2014-04-01 00:48:05.000000', 'temperatura', 1057.0000, 'ºC'),
	(264432, 118, '2014-04-01 00:48:06.000000', 'temperatura', 170.0000, 'ºC'),
	(264433, 118, '2014-04-01 00:48:07.000000', 'temperatura', 78.0000, 'ºC'),
	(264434, 118, '2014-04-01 00:48:08.000000', 'temperatura', 1083.0000, 'ºC'),
	(264435, 118, '2014-04-01 00:48:09.000000', 'temperatura', 379.0000, 'ºC'),
	(264436, 118, '2014-04-01 00:48:10.000000', 'temperatura', 1047.0000, 'ºC'),
	(264437, 118, '2014-04-01 00:48:11.000000', 'temperatura', 501.0000, 'ºC'),
	(264438, 118, '2014-04-01 00:48:12.000000', 'temperatura', 563.0000, 'ºC'),
	(264439, 118, '2014-04-01 00:48:13.000000', 'temperatura', 112.0000, 'ºC'),
	(264440, 118, '2014-04-01 00:48:14.000000', 'temperatura', 71.0000, 'ºC'),
	(264441, 118, '2014-04-01 00:48:15.000000', 'temperatura', 18.0000, 'ºC'),
	(264442, 118, '2014-04-01 00:48:16.000000', 'temperatura', 1081.0000, 'ºC'),
	(264443, 118, '2014-04-01 00:48:17.000000', 'temperatura', 550.0000, 'ºC'),
	(264444, 118, '2014-04-01 00:48:18.000000', 'temperatura', 706.0000, 'ºC'),
	(264445, 118, '2014-04-01 00:48:19.000000', 'temperatura', 684.0000, 'ºC'),
	(264446, 118, '2014-04-01 00:48:20.000000', 'temperatura', 100.0000, 'ºC'),
	(264447, 118, '2014-04-01 00:48:21.000000', 'temperatura', 848.0000, 'ºC'),
	(264448, 118, '2014-04-01 00:48:22.000000', 'temperatura', 340.0000, 'ºC'),
	(264449, 118, '2014-04-01 00:48:23.000000', 'temperatura', 356.0000, 'ºC'),
	(264450, 118, '2014-04-01 00:48:24.000000', 'temperatura', 762.0000, 'ºC'),
	(264451, 118, '2014-04-01 00:48:25.000000', 'temperatura', 341.0000, 'ºC'),
	(264452, 118, '2014-04-01 00:48:26.000000', 'temperatura', 622.0000, 'ºC'),
	(264453, 118, '2014-04-01 00:48:27.000000', 'temperatura', 887.0000, 'ºC'),
	(264454, 118, '2014-04-01 00:48:28.000000', 'temperatura', 168.0000, 'ºC'),
	(264455, 118, '2014-04-01 00:48:29.000000', 'temperatura', 580.0000, 'ºC'),
	(264456, 118, '2014-04-01 00:48:30.000000', 'temperatura', 1195.0000, 'ºC'),
	(264457, 118, '2014-04-01 00:48:31.000000', 'temperatura', 639.0000, 'ºC'),
	(264458, 118, '2014-04-01 00:48:32.000000', 'temperatura', 807.0000, 'ºC'),
	(264459, 118, '2014-04-01 00:48:33.000000', 'temperatura', 921.0000, 'ºC'),
	(264460, 118, '2014-04-01 00:48:34.000000', 'temperatura', 982.0000, 'ºC'),
	(264461, 118, '2014-04-01 00:48:35.000000', 'temperatura', 948.0000, 'ºC'),
	(264462, 118, '2014-04-01 00:48:36.000000', 'temperatura', 595.0000, 'ºC'),
	(264463, 118, '2014-04-01 00:48:37.000000', 'temperatura', 132.0000, 'ºC'),
	(264464, 118, '2014-04-01 00:48:38.000000', 'temperatura', 75.0000, 'ºC'),
	(264465, 118, '2014-04-01 00:48:39.000000', 'temperatura', 1180.0000, 'ºC'),
	(264466, 118, '2014-04-01 00:48:40.000000', 'temperatura', 874.0000, 'ºC'),
	(264467, 118, '2014-04-01 00:48:41.000000', 'temperatura', 831.0000, 'ºC'),
	(264468, 118, '2014-04-01 00:48:42.000000', 'temperatura', 332.0000, 'ºC'),
	(264469, 118, '2014-04-01 00:48:43.000000', 'temperatura', 369.0000, 'ºC'),
	(264470, 118, '2014-04-01 00:48:44.000000', 'temperatura', 848.0000, 'ºC'),
	(264471, 118, '2014-04-01 00:48:45.000000', 'temperatura', 733.0000, 'ºC'),
	(264472, 118, '2014-04-01 00:48:46.000000', 'temperatura', 1122.0000, 'ºC'),
	(264473, 118, '2014-04-01 00:48:47.000000', 'temperatura', 1014.0000, 'ºC'),
	(264474, 118, '2014-04-01 00:48:48.000000', 'temperatura', 502.0000, 'ºC'),
	(264475, 118, '2014-04-01 00:48:49.000000', 'temperatura', 668.0000, 'ºC'),
	(264476, 118, '2014-04-01 00:48:50.000000', 'temperatura', 634.0000, 'ºC'),
	(264477, 118, '2014-04-01 00:48:51.000000', 'temperatura', 1168.0000, 'ºC'),
	(264478, 118, '2014-04-01 00:48:52.000000', 'temperatura', 340.0000, 'ºC'),
	(264479, 118, '2014-04-01 00:48:53.000000', 'temperatura', 594.0000, 'ºC'),
	(264480, 118, '2014-04-01 00:48:54.000000', 'temperatura', 751.0000, 'ºC'),
	(264481, 118, '2014-04-01 00:48:55.000000', 'temperatura', 773.0000, 'ºC'),
	(264482, 118, '2014-04-01 00:48:56.000000', 'temperatura', 415.0000, 'ºC'),
	(264483, 118, '2014-04-01 00:48:57.000000', 'temperatura', 955.0000, 'ºC'),
	(264484, 118, '2014-04-01 00:48:58.000000', 'temperatura', 1129.0000, 'ºC'),
	(264485, 118, '2014-04-01 00:48:59.000000', 'temperatura', 380.0000, 'ºC'),
	(264486, 118, '2014-04-01 00:49:00.000000', 'temperatura', 913.0000, 'ºC'),
	(264487, 118, '2014-04-01 00:49:01.000000', 'temperatura', 1028.0000, 'ºC'),
	(264488, 118, '2014-04-01 00:49:02.000000', 'temperatura', 2.0000, 'ºC'),
	(264489, 118, '2014-04-01 00:49:03.000000', 'temperatura', 524.0000, 'ºC'),
	(264490, 118, '2014-04-01 00:49:04.000000', 'temperatura', 217.0000, 'ºC'),
	(264491, 118, '2014-04-01 00:49:05.000000', 'temperatura', 713.0000, 'ºC'),
	(264492, 118, '2014-04-01 00:49:06.000000', 'temperatura', 513.0000, 'ºC'),
	(264493, 118, '2014-04-01 00:49:07.000000', 'temperatura', 429.0000, 'ºC'),
	(264494, 118, '2014-04-01 00:49:08.000000', 'temperatura', 606.0000, 'ºC'),
	(264495, 118, '2014-04-01 00:49:09.000000', 'temperatura', 544.0000, 'ºC'),
	(264496, 118, '2014-04-01 00:49:10.000000', 'temperatura', 901.0000, 'ºC'),
	(264497, 118, '2014-04-01 00:49:11.000000', 'temperatura', 475.0000, 'ºC'),
	(264498, 118, '2014-04-01 00:49:12.000000', 'temperatura', 874.0000, 'ºC'),
	(264499, 118, '2014-04-01 00:49:13.000000', 'temperatura', 544.0000, 'ºC'),
	(264500, 118, '2014-04-01 00:49:14.000000', 'temperatura', 98.0000, 'ºC'),
	(264501, 118, '2014-04-01 00:49:15.000000', 'temperatura', 58.0000, 'ºC'),
	(264502, 118, '2014-04-01 00:49:16.000000', 'temperatura', 1199.0000, 'ºC'),
	(264503, 118, '2014-04-01 00:49:17.000000', 'temperatura', 1018.0000, 'ºC'),
	(264504, 118, '2014-04-01 00:49:18.000000', 'temperatura', 296.0000, 'ºC'),
	(264505, 118, '2014-04-01 00:49:19.000000', 'temperatura', 828.0000, 'ºC'),
	(264506, 118, '2014-04-01 00:49:20.000000', 'temperatura', 850.0000, 'ºC'),
	(264507, 118, '2014-04-01 00:49:21.000000', 'temperatura', 567.0000, 'ºC'),
	(264508, 118, '2014-04-01 00:49:22.000000', 'temperatura', 284.0000, 'ºC'),
	(264509, 118, '2014-04-01 00:49:23.000000', 'temperatura', 923.0000, 'ºC'),
	(264510, 118, '2014-04-01 00:49:24.000000', 'temperatura', 160.0000, 'ºC'),
	(264511, 118, '2014-04-01 00:49:25.000000', 'temperatura', 434.0000, 'ºC'),
	(264512, 118, '2014-04-01 00:49:26.000000', 'temperatura', 490.0000, 'ºC'),
	(264513, 118, '2014-04-01 00:49:27.000000', 'temperatura', 1147.0000, 'ºC'),
	(264514, 118, '2014-04-01 00:49:28.000000', 'temperatura', 665.0000, 'ºC'),
	(264515, 118, '2014-04-01 00:49:29.000000', 'temperatura', 1086.0000, 'ºC'),
	(264516, 118, '2014-04-01 00:49:30.000000', 'temperatura', 1035.0000, 'ºC'),
	(264517, 118, '2014-04-01 00:49:31.000000', 'temperatura', 716.0000, 'ºC'),
	(264518, 118, '2014-04-01 00:49:32.000000', 'temperatura', 478.0000, 'ºC'),
	(264519, 118, '2014-04-01 00:49:33.000000', 'temperatura', 242.0000, 'ºC'),
	(264520, 118, '2014-04-01 00:49:34.000000', 'temperatura', 975.0000, 'ºC'),
	(264521, 118, '2014-04-01 00:49:35.000000', 'temperatura', 552.0000, 'ºC'),
	(264522, 118, '2014-04-01 00:49:36.000000', 'temperatura', 1036.0000, 'ºC'),
	(264523, 118, '2014-04-01 00:49:37.000000', 'temperatura', 1121.0000, 'ºC'),
	(264524, 118, '2014-04-01 00:49:38.000000', 'temperatura', 100.0000, 'ºC'),
	(264525, 118, '2014-04-01 00:49:39.000000', 'temperatura', 739.0000, 'ºC'),
	(264526, 118, '2014-04-01 00:49:40.000000', 'temperatura', 994.0000, 'ºC'),
	(264527, 118, '2014-04-01 00:49:41.000000', 'temperatura', 352.0000, 'ºC'),
	(264528, 118, '2014-04-01 00:49:42.000000', 'temperatura', 1181.0000, 'ºC'),
	(264529, 118, '2014-04-01 00:49:43.000000', 'temperatura', 51.0000, 'ºC'),
	(264530, 118, '2014-04-01 00:49:44.000000', 'temperatura', 309.0000, 'ºC'),
	(264531, 118, '2014-04-01 00:49:45.000000', 'temperatura', 195.0000, 'ºC'),
	(264532, 118, '2014-04-01 00:49:46.000000', 'temperatura', 46.0000, 'ºC'),
	(264533, 118, '2014-04-01 00:49:47.000000', 'temperatura', 849.0000, 'ºC'),
	(264534, 118, '2014-04-01 00:49:48.000000', 'temperatura', 505.0000, 'ºC'),
	(264535, 118, '2014-04-01 00:49:49.000000', 'temperatura', 1177.0000, 'ºC'),
	(264536, 118, '2014-04-01 00:49:50.000000', 'temperatura', 774.0000, 'ºC'),
	(264537, 118, '2014-04-01 00:49:51.000000', 'temperatura', 336.0000, 'ºC'),
	(264538, 118, '2014-04-01 00:49:52.000000', 'temperatura', 561.0000, 'ºC'),
	(264539, 118, '2014-04-01 00:49:53.000000', 'temperatura', 597.0000, 'ºC'),
	(264540, 118, '2014-04-01 00:49:54.000000', 'temperatura', 101.0000, 'ºC'),
	(264541, 118, '2014-04-01 00:49:55.000000', 'temperatura', 1115.0000, 'ºC'),
	(264542, 118, '2014-04-01 00:49:56.000000', 'temperatura', 474.0000, 'ºC'),
	(264543, 118, '2014-04-01 00:49:57.000000', 'temperatura', 225.0000, 'ºC'),
	(264544, 118, '2014-04-01 00:49:58.000000', 'temperatura', 905.0000, 'ºC'),
	(264545, 118, '2014-04-01 00:49:59.000000', 'temperatura', 250.0000, 'ºC'),
	(264546, 118, '2014-04-01 00:50:00.000000', 'temperatura', 936.0000, 'ºC'),
	(264547, 118, '2014-04-01 00:50:01.000000', 'temperatura', 328.0000, 'ºC'),
	(264548, 118, '2014-04-01 00:50:02.000000', 'temperatura', 33.0000, 'ºC'),
	(264549, 118, '2014-04-01 00:50:03.000000', 'temperatura', 382.0000, 'ºC'),
	(264550, 118, '2014-04-01 00:50:04.000000', 'temperatura', 610.0000, 'ºC'),
	(264551, 118, '2014-04-01 00:50:05.000000', 'temperatura', 704.0000, 'ºC'),
	(264552, 118, '2014-04-01 00:50:06.000000', 'temperatura', 491.0000, 'ºC'),
	(264553, 118, '2014-04-01 00:50:07.000000', 'temperatura', 346.0000, 'ºC'),
	(264554, 118, '2014-04-01 00:50:08.000000', 'temperatura', 255.0000, 'ºC'),
	(264555, 118, '2014-04-01 00:50:09.000000', 'temperatura', 240.0000, 'ºC'),
	(264556, 118, '2014-04-01 00:50:10.000000', 'temperatura', 433.0000, 'ºC'),
	(264557, 118, '2014-04-01 00:50:11.000000', 'temperatura', 247.0000, 'ºC'),
	(264558, 118, '2014-04-01 00:50:12.000000', 'temperatura', 1135.0000, 'ºC'),
	(264559, 118, '2014-04-01 00:50:13.000000', 'temperatura', 135.0000, 'ºC'),
	(264560, 118, '2014-04-01 00:50:14.000000', 'temperatura', 871.0000, 'ºC'),
	(264561, 118, '2014-04-01 00:50:15.000000', 'temperatura', 350.0000, 'ºC'),
	(264562, 118, '2014-04-01 00:50:16.000000', 'temperatura', 339.0000, 'ºC'),
	(264563, 118, '2014-04-01 00:50:17.000000', 'temperatura', 644.0000, 'ºC'),
	(264564, 118, '2014-04-01 00:50:18.000000', 'temperatura', 1005.0000, 'ºC'),
	(264565, 118, '2014-04-01 00:50:19.000000', 'temperatura', 693.0000, 'ºC'),
	(264566, 118, '2014-04-01 00:50:20.000000', 'temperatura', 449.0000, 'ºC'),
	(264567, 118, '2014-04-01 00:50:21.000000', 'temperatura', 169.0000, 'ºC'),
	(264568, 118, '2014-04-01 00:50:22.000000', 'temperatura', 698.0000, 'ºC'),
	(264569, 118, '2014-04-01 00:50:23.000000', 'temperatura', 584.0000, 'ºC'),
	(264570, 118, '2014-04-01 00:50:24.000000', 'temperatura', 826.0000, 'ºC'),
	(264571, 118, '2014-04-01 00:50:25.000000', 'temperatura', 1179.0000, 'ºC'),
	(264572, 118, '2014-04-01 00:50:26.000000', 'temperatura', 1016.0000, 'ºC'),
	(264573, 118, '2014-04-01 00:50:27.000000', 'temperatura', 345.0000, 'ºC'),
	(264574, 118, '2014-04-01 00:50:28.000000', 'temperatura', 1078.0000, 'ºC'),
	(264575, 118, '2014-04-01 00:50:29.000000', 'temperatura', 753.0000, 'ºC'),
	(264576, 118, '2014-04-01 00:50:30.000000', 'temperatura', 532.0000, 'ºC'),
	(264577, 118, '2014-04-01 00:50:31.000000', 'temperatura', 404.0000, 'ºC'),
	(264578, 118, '2014-04-01 00:50:32.000000', 'temperatura', 423.0000, 'ºC'),
	(264579, 118, '2014-04-01 00:50:33.000000', 'temperatura', 905.0000, 'ºC'),
	(264580, 118, '2014-04-01 00:50:34.000000', 'temperatura', 854.0000, 'ºC'),
	(264581, 118, '2014-04-01 00:50:35.000000', 'temperatura', 355.0000, 'ºC'),
	(264582, 118, '2014-04-01 00:50:36.000000', 'temperatura', 415.0000, 'ºC'),
	(264583, 118, '2014-04-01 00:50:37.000000', 'temperatura', 1008.0000, 'ºC'),
	(264584, 118, '2014-04-01 00:50:38.000000', 'temperatura', 198.0000, 'ºC'),
	(264585, 118, '2014-04-01 00:50:39.000000', 'temperatura', 366.0000, 'ºC'),
	(264586, 118, '2014-04-01 00:50:40.000000', 'temperatura', 36.0000, 'ºC'),
	(264587, 118, '2014-04-01 00:50:41.000000', 'temperatura', 282.0000, 'ºC'),
	(264588, 118, '2014-04-01 00:50:42.000000', 'temperatura', 101.0000, 'ºC'),
	(264589, 118, '2014-04-01 00:50:43.000000', 'temperatura', 862.0000, 'ºC'),
	(264590, 118, '2014-04-01 00:50:44.000000', 'temperatura', 406.0000, 'ºC'),
	(264591, 118, '2014-04-01 00:50:45.000000', 'temperatura', 647.0000, 'ºC'),
	(264592, 118, '2014-04-01 00:50:46.000000', 'temperatura', 816.0000, 'ºC'),
	(264593, 118, '2014-04-01 00:50:47.000000', 'temperatura', 940.0000, 'ºC'),
	(264594, 118, '2014-04-01 00:50:48.000000', 'temperatura', 1054.0000, 'ºC'),
	(264595, 118, '2014-04-01 00:50:49.000000', 'temperatura', 50.0000, 'ºC'),
	(264596, 118, '2014-04-01 00:50:50.000000', 'temperatura', 690.0000, 'ºC'),
	(264597, 118, '2014-04-01 00:50:51.000000', 'temperatura', 898.0000, 'ºC'),
	(264598, 118, '2014-04-01 00:50:52.000000', 'temperatura', 20.0000, 'ºC'),
	(264599, 118, '2014-04-01 00:50:53.000000', 'temperatura', 1005.0000, 'ºC'),
	(264600, 118, '2014-04-01 00:50:54.000000', 'temperatura', 169.0000, 'ºC'),
	(264601, 118, '2014-04-01 00:50:55.000000', 'temperatura', 229.0000, 'ºC'),
	(264602, 118, '2014-04-01 00:50:56.000000', 'temperatura', 639.0000, 'ºC'),
	(264603, 118, '2014-04-01 00:50:57.000000', 'temperatura', 108.0000, 'ºC'),
	(264604, 118, '2014-04-01 00:50:58.000000', 'temperatura', 1024.0000, 'ºC'),
	(264605, 118, '2014-04-01 00:50:59.000000', 'temperatura', 1196.0000, 'ºC'),
	(264606, 118, '2014-04-01 00:51:00.000000', 'temperatura', 507.0000, 'ºC'),
	(264607, 118, '2014-04-01 00:51:01.000000', 'temperatura', 147.0000, 'ºC'),
	(264608, 118, '2014-04-01 00:51:02.000000', 'temperatura', 418.0000, 'ºC'),
	(264609, 118, '2014-04-01 00:51:03.000000', 'temperatura', 446.0000, 'ºC'),
	(264610, 118, '2014-04-01 00:51:04.000000', 'temperatura', 977.0000, 'ºC'),
	(264611, 118, '2014-04-01 00:51:05.000000', 'temperatura', 1147.0000, 'ºC'),
	(264612, 118, '2014-04-01 00:51:06.000000', 'temperatura', 405.0000, 'ºC'),
	(264613, 118, '2014-04-01 00:51:07.000000', 'temperatura', 985.0000, 'ºC'),
	(264614, 118, '2014-04-01 00:51:08.000000', 'temperatura', 112.0000, 'ºC'),
	(264615, 118, '2014-04-01 00:51:09.000000', 'temperatura', 3.0000, 'ºC'),
	(264616, 118, '2014-04-01 00:51:10.000000', 'temperatura', 879.0000, 'ºC'),
	(264617, 118, '2014-04-01 00:51:11.000000', 'temperatura', 786.0000, 'ºC'),
	(264618, 118, '2014-04-01 00:51:12.000000', 'temperatura', 93.0000, 'ºC'),
	(264619, 118, '2014-04-01 00:51:13.000000', 'temperatura', 507.0000, 'ºC'),
	(264620, 118, '2014-04-01 00:51:14.000000', 'temperatura', 1058.0000, 'ºC'),
	(264621, 118, '2014-04-01 00:51:15.000000', 'temperatura', 171.0000, 'ºC'),
	(264622, 118, '2014-04-01 00:51:16.000000', 'temperatura', 78.0000, 'ºC'),
	(264623, 118, '2014-04-01 00:51:17.000000', 'temperatura', 1080.0000, 'ºC'),
	(264624, 118, '2014-04-01 00:51:18.000000', 'temperatura', 366.0000, 'ºC'),
	(264625, 118, '2014-04-01 00:51:19.000000', 'temperatura', 989.0000, 'ºC'),
	(264626, 118, '2014-04-01 00:51:20.000000', 'temperatura', 248.0000, 'ºC'),
	(264627, 118, '2014-04-01 00:51:21.000000', 'temperatura', 674.0000, 'ºC'),
	(264628, 118, '2014-04-01 00:51:22.000000', 'temperatura', 228.0000, 'ºC'),
	(264629, 118, '2014-04-01 00:51:23.000000', 'temperatura', 316.0000, 'ºC'),
	(264630, 118, '2014-04-01 00:51:24.000000', 'temperatura', 899.0000, 'ºC'),
	(264631, 118, '2014-04-01 00:51:25.000000', 'temperatura', 1148.0000, 'ºC'),
	(264632, 118, '2014-04-01 00:51:26.000000', 'temperatura', 641.0000, 'ºC'),
	(264633, 118, '2014-04-01 00:51:27.000000', 'temperatura', 964.0000, 'ºC'),
	(264634, 118, '2014-04-01 00:51:28.000000', 'temperatura', 498.0000, 'ºC'),
	(264635, 118, '2014-04-01 00:51:29.000000', 'temperatura', 797.0000, 'ºC'),
	(264636, 118, '2014-04-01 00:51:30.000000', 'temperatura', 92.0000, 'ºC'),
	(264637, 118, '2014-04-01 00:51:31.000000', 'temperatura', 468.0000, 'ºC'),
	(264638, 118, '2014-04-01 00:51:32.000000', 'temperatura', 866.0000, 'ºC'),
	(264639, 118, '2014-04-01 00:51:33.000000', 'temperatura', 528.0000, 'ºC'),
	(264640, 118, '2014-04-01 00:51:34.000000', 'temperatura', 42.0000, 'ºC'),
	(264641, 118, '2014-04-01 00:51:35.000000', 'temperatura', 1026.0000, 'ºC'),
	(264642, 118, '2014-04-01 00:51:36.000000', 'temperatura', 205.0000, 'ºC'),
	(264643, 118, '2014-04-01 00:51:37.000000', 'temperatura', 346.0000, 'ºC'),
	(264644, 118, '2014-04-01 00:51:38.000000', 'temperatura', 1115.0000, 'ºC'),
	(264645, 118, '2014-04-01 00:51:39.000000', 'temperatura', 938.0000, 'ºC'),
	(264646, 118, '2014-04-01 00:51:40.000000', 'temperatura', 145.0000, 'ºC'),
	(264647, 118, '2014-04-01 00:51:41.000000', 'temperatura', 313.0000, 'ºC'),
	(264648, 118, '2014-04-01 00:51:42.000000', 'temperatura', 1131.0000, 'ºC'),
	(264649, 118, '2014-04-01 00:51:43.000000', 'temperatura', 1118.0000, 'ºC'),
	(264650, 118, '2014-04-01 00:51:44.000000', 'temperatura', 995.0000, 'ºC'),
	(264651, 118, '2014-04-01 00:51:45.000000', 'temperatura', 421.0000, 'ºC'),
	(264652, 118, '2014-04-01 00:51:46.000000', 'temperatura', 321.0000, 'ºC'),
	(264653, 118, '2014-04-01 00:51:47.000000', 'temperatura', 343.0000, 'ºC'),
	(264654, 118, '2014-04-01 00:51:48.000000', 'temperatura', 751.0000, 'ºC'),
	(264655, 118, '2014-04-01 00:51:49.000000', 'temperatura', 327.0000, 'ºC'),
	(264656, 118, '2014-04-01 00:51:50.000000', 'temperatura', 583.0000, 'ºC'),
	(264657, 118, '2014-04-01 00:51:51.000000', 'temperatura', 733.0000, 'ºC'),
	(264658, 118, '2014-04-01 00:51:52.000000', 'temperatura', 719.0000, 'ºC'),
	(264659, 118, '2014-04-01 00:51:53.000000', 'temperatura', 197.0000, 'ºC'),
	(264660, 118, '2014-04-01 00:51:54.000000', 'temperatura', 28.0000, 'ºC'),
	(264661, 118, '2014-04-01 00:51:55.000000', 'temperatura', 748.0000, 'ºC'),
	(264662, 118, '2014-04-01 00:51:56.000000', 'temperatura', 56.0000, 'ºC'),
	(264663, 118, '2014-04-01 00:51:57.000000', 'temperatura', 438.0000, 'ºC'),
	(264664, 118, '2014-04-01 00:51:58.000000', 'temperatura', 824.0000, 'ºC'),
	(264665, 118, '2014-04-01 00:51:59.000000', 'temperatura', 406.0000, 'ºC'),
	(264666, 118, '2014-04-01 00:52:00.000000', 'temperatura', 758.0000, 'ºC'),
	(264667, 118, '2014-04-01 00:52:01.000000', 'temperatura', 172.0000, 'ºC'),
	(264668, 118, '2014-04-01 00:52:02.000000', 'temperatura', 987.0000, 'ºC'),
	(264669, 118, '2014-04-01 00:52:03.000000', 'temperatura', 818.0000, 'ºC'),
	(264670, 118, '2014-04-01 00:52:04.000000', 'temperatura', 1129.0000, 'ºC'),
	(264671, 118, '2014-04-01 00:52:05.000000', 'temperatura', 794.0000, 'ºC'),
	(264672, 118, '2014-04-01 00:52:06.000000', 'temperatura', 584.0000, 'ºC'),
	(264673, 118, '2014-04-01 00:52:07.000000', 'temperatura', 537.0000, 'ºC'),
	(264674, 118, '2014-04-01 00:52:08.000000', 'temperatura', 932.0000, 'ºC'),
	(264675, 118, '2014-04-01 00:52:09.000000', 'temperatura', 653.0000, 'ºC'),
	(264676, 118, '2014-04-01 00:52:10.000000', 'temperatura', 466.0000, 'ºC'),
	(264677, 118, '2014-04-01 00:52:11.000000', 'temperatura', 373.0000, 'ºC'),
	(264678, 118, '2014-04-01 00:52:12.000000', 'temperatura', 468.0000, 'ºC'),
	(264679, 118, '2014-04-01 00:52:13.000000', 'temperatura', 22.0000, 'ºC'),
	(264680, 118, '2014-04-01 00:52:14.000000', 'temperatura', 1106.0000, 'ºC'),
	(264681, 118, '2014-04-01 00:52:15.000000', 'temperatura', 666.0000, 'ºC'),
	(264682, 118, '2014-04-01 00:52:16.000000', 'temperatura', 12.0000, 'ºC'),
	(264683, 118, '2014-04-01 00:52:17.000000', 'temperatura', 463.0000, 'ºC'),
	(264684, 118, '2014-04-01 00:52:18.000000', 'temperatura', 1077.0000, 'ºC'),
	(264685, 118, '2014-04-01 00:52:19.000000', 'temperatura', 397.0000, 'ºC'),
	(264686, 118, '2014-04-01 00:52:20.000000', 'temperatura', 1156.0000, 'ºC'),
	(264687, 118, '2014-04-01 00:52:21.000000', 'temperatura', 987.0000, 'ºC'),
	(264688, 118, '2014-04-01 00:52:22.000000', 'temperatura', 271.0000, 'ºC'),
	(264689, 118, '2014-04-01 00:52:23.000000', 'temperatura', 792.0000, 'ºC'),
	(264690, 118, '2014-04-01 00:52:24.000000', 'temperatura', 746.0000, 'ºC'),
	(264691, 118, '2014-04-01 00:52:25.000000', 'temperatura', 157.0000, 'ºC'),
	(264692, 118, '2014-04-01 00:52:26.000000', 'temperatura', 947.0000, 'ºC'),
	(264693, 118, '2014-04-01 00:52:27.000000', 'temperatura', 666.0000, 'ºC'),
	(264694, 118, '2014-04-01 00:52:28.000000', 'temperatura', 488.0000, 'ºC'),
	(264695, 118, '2014-04-01 00:52:29.000000', 'temperatura', 443.0000, 'ºC'),
	(264696, 118, '2014-04-01 00:52:30.000000', 'temperatura', 751.0000, 'ºC'),
	(264697, 118, '2014-04-01 00:52:31.000000', 'temperatura', 26.0000, 'ºC'),
	(264698, 118, '2014-04-01 00:52:32.000000', 'temperatura', 279.0000, 'ºC'),
	(264699, 118, '2014-04-01 00:52:33.000000', 'temperatura', 115.0000, 'ºC'),
	(264700, 118, '2014-04-01 00:52:34.000000', 'temperatura', 940.0000, 'ºC'),
	(264701, 118, '2014-04-01 00:52:35.000000', 'temperatura', 757.0000, 'ºC'),
	(264702, 118, '2014-04-01 00:52:36.000000', 'temperatura', 963.0000, 'ºC'),
	(264703, 118, '2014-04-01 00:52:37.000000', 'temperatura', 146.0000, 'ºC'),
	(264704, 118, '2014-04-01 00:52:38.000000', 'temperatura', 239.0000, 'ºC'),
	(264705, 118, '2014-04-01 00:52:39.000000', 'temperatura', 761.0000, 'ºC'),
	(264706, 118, '2014-04-01 00:52:40.000000', 'temperatura', 688.0000, 'ºC'),
	(264707, 118, '2014-04-01 00:52:41.000000', 'temperatura', 1155.0000, 'ºC'),
	(264708, 118, '2014-04-01 00:52:42.000000', 'temperatura', 113.0000, 'ºC'),
	(264709, 118, '2014-04-01 00:52:43.000000', 'temperatura', 699.0000, 'ºC'),
	(264710, 118, '2014-04-01 00:52:44.000000', 'temperatura', 759.0000, 'ºC'),
	(264711, 118, '2014-04-01 00:52:45.000000', 'temperatura', 498.0000, 'ºC'),
	(264712, 118, '2014-04-01 00:52:46.000000', 'temperatura', 215.0000, 'ºC'),
	(264713, 118, '2014-04-01 00:52:47.000000', 'temperatura', 778.0000, 'ºC'),
	(264714, 118, '2014-04-01 00:52:48.000000', 'temperatura', 847.0000, 'ºC'),
	(264715, 118, '2014-04-01 00:52:49.000000', 'temperatura', 703.0000, 'ºC'),
	(264716, 118, '2014-04-01 00:52:50.000000', 'temperatura', 974.0000, 'ºC'),
	(264717, 118, '2014-04-01 00:52:51.000000', 'temperatura', 361.0000, 'ºC'),
	(264718, 118, '2014-04-01 00:52:52.000000', 'temperatura', 82.0000, 'ºC'),
	(264719, 118, '2014-04-01 00:52:53.000000', 'temperatura', 531.0000, 'ºC'),
	(264720, 118, '2014-04-01 00:52:54.000000', 'temperatura', 6.0000, 'ºC'),
	(264721, 118, '2014-04-01 00:52:55.000000', 'temperatura', 838.0000, 'ºC'),
	(264722, 118, '2014-04-01 00:52:56.000000', 'temperatura', 571.0000, 'ºC'),
	(264723, 118, '2014-04-01 00:52:57.000000', 'temperatura', 343.0000, 'ºC'),
	(264724, 118, '2014-04-01 00:52:58.000000', 'temperatura', 3.0000, 'ºC'),
	(264725, 118, '2014-04-01 00:52:59.000000', 'temperatura', 185.0000, 'ºC'),
	(264726, 118, '2014-04-01 00:53:00.000000', 'temperatura', 917.0000, 'ºC'),
	(264727, 118, '2014-04-01 00:53:01.000000', 'temperatura', 431.0000, 'ºC'),
	(264728, 118, '2014-04-01 00:53:02.000000', 'temperatura', 604.0000, 'ºC'),
	(264729, 118, '2014-04-01 00:53:03.000000', 'temperatura', 526.0000, 'ºC'),
	(264730, 118, '2014-04-01 00:53:04.000000', 'temperatura', 818.0000, 'ºC'),
	(264731, 118, '2014-04-01 00:53:05.000000', 'temperatura', 115.0000, 'ºC'),
	(264732, 118, '2014-04-01 00:53:06.000000', 'temperatura', 519.0000, 'ºC'),
	(264733, 118, '2014-04-01 00:53:07.000000', 'temperatura', 1053.0000, 'ºC'),
	(264734, 118, '2014-04-01 00:53:08.000000', 'temperatura', 107.0000, 'ºC'),
	(264735, 118, '2014-04-01 00:53:09.000000', 'temperatura', 975.0000, 'ºC'),
	(264736, 118, '2014-04-01 00:53:10.000000', 'temperatura', 955.0000, 'ºC'),
	(264737, 118, '2014-04-01 00:53:11.000000', 'temperatura', 652.0000, 'ºC'),
	(264738, 118, '2014-04-01 00:53:12.000000', 'temperatura', 396.0000, 'ºC'),
	(264739, 118, '2014-04-01 00:53:13.000000', 'temperatura', 22.0000, 'ºC'),
	(264740, 118, '2014-04-01 00:53:14.000000', 'temperatura', 122.0000, 'ºC'),
	(264741, 118, '2014-04-01 00:53:15.000000', 'temperatura', 547.0000, 'ºC'),
	(264742, 118, '2014-04-01 00:53:16.000000', 'temperatura', 1167.0000, 'ºC'),
	(264743, 118, '2014-04-01 00:53:17.000000', 'temperatura', 597.0000, 'ºC'),
	(264744, 118, '2014-04-01 00:53:18.000000', 'temperatura', 684.0000, 'ºC'),
	(264745, 118, '2014-04-01 00:53:19.000000', 'temperatura', 428.0000, 'ºC'),
	(264746, 118, '2014-04-01 00:53:20.000000', 'temperatura', 89.0000, 'ºC'),
	(264747, 118, '2014-04-01 00:53:21.000000', 'temperatura', 361.0000, 'ºC'),
	(264748, 118, '2014-04-01 00:53:22.000000', 'temperatura', 340.0000, 'ºC'),
	(264749, 118, '2014-04-01 00:53:23.000000', 'temperatura', 618.0000, 'ºC'),
	(264750, 118, '2014-04-01 00:53:24.000000', 'temperatura', 870.0000, 'ºC'),
	(264751, 118, '2014-04-01 00:53:25.000000', 'temperatura', 96.0000, 'ºC'),
	(264752, 118, '2014-04-01 00:53:26.000000', 'temperatura', 269.0000, 'ºC'),
	(264753, 118, '2014-04-01 00:53:27.000000', 'temperatura', 1059.0000, 'ºC'),
	(264754, 118, '2014-04-01 00:53:28.000000', 'temperatura', 888.0000, 'ºC'),
	(264755, 118, '2014-04-01 00:53:29.000000', 'temperatura', 66.0000, 'ºC'),
	(264756, 118, '2014-04-01 00:53:30.000000', 'temperatura', 63.0000, 'ºC'),
	(264757, 118, '2014-04-01 00:53:31.000000', 'temperatura', 118.0000, 'ºC'),
	(264758, 118, '2014-04-01 00:53:32.000000', 'temperatura', 401.0000, 'ºC'),
	(264759, 118, '2014-04-01 00:53:33.000000', 'temperatura', 454.0000, 'ºC'),
	(264760, 118, '2014-04-01 00:53:34.000000', 'temperatura', 1067.0000, 'ºC'),
	(264761, 118, '2014-04-01 00:53:35.000000', 'temperatura', 375.0000, 'ºC'),
	(264762, 118, '2014-04-01 00:53:36.000000', 'temperatura', 1073.0000, 'ºC'),
	(264763, 118, '2014-04-01 00:53:37.000000', 'temperatura', 642.0000, 'ºC'),
	(264764, 118, '2014-04-01 00:53:38.000000', 'temperatura', 1191.0000, 'ºC'),
	(264765, 118, '2014-04-01 00:53:39.000000', 'temperatura', 431.0000, 'ºC'),
	(264766, 118, '2014-04-01 00:53:40.000000', 'temperatura', 982.0000, 'ºC'),
	(264767, 118, '2014-04-01 00:53:41.000000', 'temperatura', 17.0000, 'ºC'),
	(264768, 118, '2014-04-01 00:53:42.000000', 'temperatura', 741.0000, 'ºC'),
	(264769, 118, '2014-04-01 00:53:43.000000', 'temperatura', 54.0000, 'ºC'),
	(264770, 118, '2014-04-01 00:53:44.000000', 'temperatura', 446.0000, 'ºC'),
	(264771, 118, '2014-04-01 00:53:45.000000', 'temperatura', 870.0000, 'ºC'),
	(264772, 118, '2014-04-01 00:53:46.000000', 'temperatura', 611.0000, 'ºC'),
	(264773, 118, '2014-04-01 00:53:47.000000', 'temperatura', 446.0000, 'ºC'),
	(264774, 118, '2014-04-01 00:53:48.000000', 'temperatura', 397.0000, 'ºC'),
	(264775, 118, '2014-04-01 00:53:49.000000', 'temperatura', 649.0000, 'ºC'),
	(264776, 118, '2014-04-01 00:53:50.000000', 'temperatura', 853.0000, 'ºC'),
	(264777, 118, '2014-04-01 00:53:51.000000', 'temperatura', 1121.0000, 'ºC'),
	(264778, 118, '2014-04-01 00:53:52.000000', 'temperatura', 645.0000, 'ºC'),
	(264779, 118, '2014-04-01 00:53:53.000000', 'temperatura', 1062.0000, 'ºC'),
	(264780, 118, '2014-04-01 00:53:54.000000', 'temperatura', 976.0000, 'ºC'),
	(264781, 118, '2014-04-01 00:53:55.000000', 'temperatura', 495.0000, 'ºC'),
	(264782, 118, '2014-04-01 00:53:56.000000', 'temperatura', 745.0000, 'ºC'),
	(264783, 118, '2014-04-01 00:53:57.000000', 'temperatura', 1042.0000, 'ºC'),
	(264784, 118, '2014-04-01 00:53:58.000000', 'temperatura', 575.0000, 'ºC'),
	(264785, 118, '2014-04-01 00:53:59.000000', 'temperatura', 949.0000, 'ºC'),
	(264786, 118, '2014-04-01 00:54:00.000000', 'temperatura', 622.0000, 'ºC'),
	(264787, 118, '2014-04-01 00:54:01.000000', 'temperatura', 263.0000, 'ºC'),
	(264788, 118, '2014-04-01 00:54:02.000000', 'temperatura', 648.0000, 'ºC'),
	(264789, 118, '2014-04-01 00:54:03.000000', 'temperatura', 55.0000, 'ºC'),
	(264790, 118, '2014-04-01 00:54:04.000000', 'temperatura', 728.0000, 'ºC'),
	(264791, 118, '2014-04-01 00:54:05.000000', 'temperatura', 1075.0000, 'ºC'),
	(264792, 118, '2014-04-01 00:54:06.000000', 'temperatura', 794.0000, 'ºC'),
	(264793, 118, '2014-04-01 00:54:07.000000', 'temperatura', 745.0000, 'ºC'),
	(264794, 118, '2014-04-01 00:54:08.000000', 'temperatura', 144.0000, 'ºC'),
	(264795, 118, '2014-04-01 00:54:09.000000', 'temperatura', 884.0000, 'ºC'),
	(264796, 118, '2014-04-01 00:54:10.000000', 'temperatura', 389.0000, 'ºC'),
	(264797, 118, '2014-04-01 00:54:11.000000', 'temperatura', 492.0000, 'ºC'),
	(264798, 118, '2014-04-01 00:54:12.000000', 'temperatura', 96.0000, 'ºC'),
	(264799, 118, '2014-04-01 00:54:13.000000', 'temperatura', 202.0000, 'ºC'),
	(264800, 118, '2014-04-01 00:54:14.000000', 'temperatura', 722.0000, 'ºC'),
	(264801, 118, '2014-04-01 00:54:15.000000', 'temperatura', 608.0000, 'ºC'),
	(264802, 118, '2014-04-01 00:54:16.000000', 'temperatura', 871.0000, 'ºC'),
	(264803, 118, '2014-04-01 00:54:17.000000', 'temperatura', 131.0000, 'ºC'),
	(264804, 118, '2014-04-01 00:54:18.000000', 'temperatura', 445.0000, 'ºC'),
	(264805, 118, '2014-04-01 00:54:19.000000', 'temperatura', 633.0000, 'ºC'),
	(264806, 118, '2014-04-01 00:54:20.000000', 'temperatura', 632.0000, 'ºC'),
	(264807, 118, '2014-04-01 00:54:21.000000', 'temperatura', 58.0000, 'ºC'),
	(264808, 118, '2014-04-01 00:54:22.000000', 'temperatura', 797.0000, 'ºC'),
	(264809, 118, '2014-04-01 00:54:23.000000', 'temperatura', 212.0000, 'ºC'),
	(264810, 118, '2014-04-01 00:54:24.000000', 'temperatura', 1070.0000, 'ºC'),
	(264811, 118, '2014-04-01 00:54:25.000000', 'temperatura', 1114.0000, 'ºC'),
	(264812, 118, '2014-04-01 00:54:26.000000', 'temperatura', 1161.0000, 'ºC'),
	(264813, 118, '2014-04-01 00:54:27.000000', 'temperatura', 61.0000, 'ºC'),
	(264814, 118, '2014-04-01 00:54:28.000000', 'temperatura', 424.0000, 'ºC'),
	(264815, 118, '2014-04-01 00:54:29.000000', 'temperatura', 739.0000, 'ºC'),
	(264816, 118, '2014-04-01 00:54:30.000000', 'temperatura', 21.0000, 'ºC'),
	(264817, 118, '2014-04-01 00:54:31.000000', 'temperatura', 292.0000, 'ºC'),
	(264818, 118, '2014-04-01 00:54:32.000000', 'temperatura', 194.0000, 'ºC'),
	(264819, 118, '2014-04-01 00:54:33.000000', 'temperatura', 95.0000, 'ºC'),
	(264820, 118, '2014-04-01 00:54:34.000000', 'temperatura', 1094.0000, 'ºC'),
	(264821, 118, '2014-04-01 00:54:35.000000', 'temperatura', 384.0000, 'ºC'),
	(264822, 118, '2014-04-01 00:54:36.000000', 'temperatura', 1041.0000, 'ºC'),
	(264823, 118, '2014-04-01 00:54:37.000000', 'temperatura', 452.0000, 'ºC'),
	(264824, 118, '2014-04-01 00:54:38.000000', 'temperatura', 336.0000, 'ºC'),
	(264825, 118, '2014-04-01 00:54:39.000000', 'temperatura', 327.0000, 'ºC'),
	(264826, 118, '2014-04-01 00:54:40.000000', 'temperatura', 627.0000, 'ºC'),
	(264827, 118, '2014-04-01 00:54:41.000000', 'temperatura', 954.0000, 'ºC'),
	(264828, 118, '2014-04-01 00:54:42.000000', 'temperatura', 490.0000, 'ºC'),
	(264829, 118, '2014-04-01 00:54:43.000000', 'temperatura', 787.0000, 'ºC'),
	(264830, 118, '2014-04-01 00:54:44.000000', 'temperatura', 67.0000, 'ºC'),
	(264831, 118, '2014-04-01 00:54:45.000000', 'temperatura', 376.0000, 'ºC'),
	(264832, 118, '2014-04-01 00:54:46.000000', 'temperatura', 476.0000, 'ºC'),
	(264833, 118, '2014-04-01 00:54:47.000000', 'temperatura', 56.0000, 'ºC'),
	(264834, 118, '2014-04-01 00:54:48.000000', 'temperatura', 51.0000, 'ºC'),
	(264835, 118, '2014-04-01 00:54:49.000000', 'temperatura', 87.0000, 'ºC'),
	(264836, 118, '2014-04-01 00:54:50.000000', 'temperatura', 283.0000, 'ºC'),
	(264837, 118, '2014-04-01 00:54:51.000000', 'temperatura', 1155.0000, 'ºC'),
	(264838, 118, '2014-04-01 00:54:52.000000', 'temperatura', 127.0000, 'ºC'),
	(264839, 118, '2014-04-01 00:54:53.000000', 'temperatura', 771.0000, 'ºC'),
	(264840, 118, '2014-04-01 00:54:54.000000', 'temperatura', 1074.0000, 'ºC'),
	(264841, 118, '2014-04-01 00:54:55.000000', 'temperatura', 658.0000, 'ºC'),
	(264842, 118, '2014-04-01 00:54:56.000000', 'temperatura', 66.0000, 'ºC'),
	(264843, 118, '2014-04-01 00:54:57.000000', 'temperatura', 758.0000, 'ºC'),
	(264844, 118, '2014-04-01 00:54:58.000000', 'temperatura', 1193.0000, 'ºC'),
	(264845, 118, '2014-04-01 00:54:59.000000', 'temperatura', 92.0000, 'ºC'),
	(264846, 118, '2014-04-01 00:55:00.000000', 'temperatura', 482.0000, 'ºC'),
	(264847, 118, '2014-04-01 00:55:01.000000', 'temperatura', 933.0000, 'ºC'),
	(264848, 118, '2014-04-01 00:55:02.000000', 'temperatura', 818.0000, 'ºC'),
	(264849, 118, '2014-04-01 00:55:03.000000', 'temperatura', 94.0000, 'ºC'),
	(264850, 118, '2014-04-01 00:55:04.000000', 'temperatura', 416.0000, 'ºC'),
	(264851, 118, '2014-04-01 00:55:05.000000', 'temperatura', 600.0000, 'ºC'),
	(264852, 118, '2014-04-01 00:55:06.000000', 'temperatura', 552.0000, 'ºC'),
	(264853, 118, '2014-04-01 00:55:07.000000', 'temperatura', 960.0000, 'ºC'),
	(264854, 118, '2014-04-01 00:55:08.000000', 'temperatura', 744.0000, 'ºC'),
	(264855, 118, '2014-04-01 00:55:09.000000', 'temperatura', 841.0000, 'ºC'),
	(264856, 118, '2014-04-01 00:55:10.000000', 'temperatura', 774.0000, 'ºC'),
	(264857, 118, '2014-04-01 00:55:11.000000', 'temperatura', 149.0000, 'ºC'),
	(264858, 118, '2014-04-01 00:55:12.000000', 'temperatura', 821.0000, 'ºC'),
	(264859, 118, '2014-04-01 00:55:13.000000', 'temperatura', 60.0000, 'ºC'),
	(264860, 118, '2014-04-01 00:55:14.000000', 'temperatura', 237.0000, 'ºC'),
	(264861, 118, '2014-04-01 00:55:15.000000', 'temperatura', 1004.0000, 'ºC'),
	(264862, 118, '2014-04-01 00:55:16.000000', 'temperatura', 712.0000, 'ºC'),
	(264863, 118, '2014-04-01 00:55:17.000000', 'temperatura', 549.0000, 'ºC'),
	(264864, 118, '2014-04-01 00:55:18.000000', 'temperatura', 609.0000, 'ºC'),
	(264865, 118, '2014-04-01 00:55:19.000000', 'temperatura', 199.0000, 'ºC'),
	(264866, 118, '2014-04-01 00:55:20.000000', 'temperatura', 368.0000, 'ºC'),
	(264867, 118, '2014-04-01 00:55:21.000000', 'temperatura', 44.0000, 'ºC'),
	(264868, 118, '2014-04-01 00:55:22.000000', 'temperatura', 316.0000, 'ºC'),
	(264869, 118, '2014-04-01 00:55:23.000000', 'temperatura', 249.0000, 'ºC'),
	(264870, 118, '2014-04-01 00:55:24.000000', 'temperatura', 297.0000, 'ºC'),
	(264871, 118, '2014-04-01 00:55:25.000000', 'temperatura', 737.0000, 'ºC'),
	(264872, 118, '2014-04-01 00:55:26.000000', 'temperatura', 394.0000, 'ºC'),
	(264873, 118, '2014-04-01 00:55:27.000000', 'temperatura', 959.0000, 'ºC'),
	(264874, 118, '2014-04-01 00:55:28.000000', 'temperatura', 15.0000, 'ºC'),
	(264875, 118, '2014-04-01 00:55:29.000000', 'temperatura', 799.0000, 'ºC'),
	(264876, 118, '2014-04-01 00:55:30.000000', 'temperatura', 350.0000, 'ºC'),
	(264877, 118, '2014-04-01 00:55:31.000000', 'temperatura', 552.0000, 'ºC'),
	(264878, 118, '2014-04-01 00:55:32.000000', 'temperatura', 510.0000, 'ºC'),
	(264879, 118, '2014-04-01 00:55:33.000000', 'temperatura', 894.0000, 'ºC'),
	(264880, 118, '2014-04-01 00:55:34.000000', 'temperatura', 544.0000, 'ºC'),
	(264881, 118, '2014-04-01 00:55:35.000000', 'temperatura', 35.0000, 'ºC'),
	(264882, 118, '2014-04-01 00:55:36.000000', 'temperatura', 944.0000, 'ºC'),
	(264883, 118, '2014-04-01 00:55:37.000000', 'temperatura', 1017.0000, 'ºC'),
	(264884, 118, '2014-04-01 00:55:38.000000', 'temperatura', 1051.0000, 'ºC'),
	(264885, 118, '2014-04-01 00:55:39.000000', 'temperatura', 1007.0000, 'ºC'),
	(264886, 118, '2014-04-01 00:55:40.000000', 'temperatura', 680.0000, 'ºC'),
	(264887, 118, '2014-04-01 00:55:41.000000', 'temperatura', 381.0000, 'ºC'),
	(264888, 118, '2014-04-01 00:55:42.000000', 'temperatura', 1067.0000, 'ºC'),
	(264889, 118, '2014-04-01 00:55:43.000000', 'temperatura', 590.0000, 'ºC'),
	(264890, 118, '2014-04-01 00:55:44.000000', 'temperatura', 949.0000, 'ºC'),
	(264891, 118, '2014-04-01 00:55:45.000000', 'temperatura', 575.0000, 'ºC'),
	(264892, 118, '2014-04-01 00:55:46.000000', 'temperatura', 29.0000, 'ºC'),
	(264893, 118, '2014-04-01 00:55:47.000000', 'temperatura', 821.0000, 'ºC'),
	(264894, 118, '2014-04-01 00:55:48.000000', 'temperatura', 419.0000, 'ºC'),
	(264895, 118, '2014-04-01 00:55:49.000000', 'temperatura', 833.0000, 'ºC'),
	(264896, 118, '2014-04-01 00:55:50.000000', 'temperatura', 510.0000, 'ºC'),
	(264897, 118, '2014-04-01 00:55:51.000000', 'temperatura', 50.0000, 'ºC'),
	(264898, 118, '2014-04-01 00:55:52.000000', 'temperatura', 1120.0000, 'ºC'),
	(264899, 118, '2014-04-01 00:55:53.000000', 'temperatura', 649.0000, 'ºC'),
	(264900, 118, '2014-04-01 00:55:54.000000', 'temperatura', 1086.0000, 'ºC'),
	(264901, 118, '2014-04-01 00:55:55.000000', 'temperatura', 1085.0000, 'ºC'),
	(264902, 118, '2014-04-01 00:55:56.000000', 'temperatura', 966.0000, 'ºC'),
	(264903, 118, '2014-04-01 00:55:57.000000', 'temperatura', 377.0000, 'ºC'),
	(264904, 118, '2014-04-01 00:55:58.000000', 'temperatura', 188.0000, 'ºC'),
	(264905, 118, '2014-04-01 00:55:59.000000', 'temperatura', 1008.0000, 'ºC'),
	(264906, 118, '2014-04-01 00:56:00.000000', 'temperatura', 876.0000, 'ºC'),
	(264907, 118, '2014-04-01 00:56:01.000000', 'temperatura', 158.0000, 'ºC'),
	(264908, 118, '2014-04-01 00:56:02.000000', 'temperatura', 562.0000, 'ºC'),
	(264909, 118, '2014-04-01 00:56:03.000000', 'temperatura', 1138.0000, 'ºC'),
	(264910, 118, '2014-04-01 00:56:04.000000', 'temperatura', 402.0000, 'ºC'),
	(264911, 118, '2014-04-01 00:56:05.000000', 'temperatura', 998.0000, 'ºC'),
	(264912, 118, '2014-04-01 00:56:06.000000', 'temperatura', 182.0000, 'ºC'),
	(264913, 118, '2014-04-01 00:56:07.000000', 'temperatura', 319.0000, 'ºC'),
	(264914, 118, '2014-04-01 00:56:08.000000', 'temperatura', 1048.0000, 'ºC'),
	(264915, 118, '2014-04-01 00:56:09.000000', 'temperatura', 684.0000, 'ºC'),
	(264916, 118, '2014-04-01 00:56:10.000000', 'temperatura', 276.0000, 'ºC'),
	(264917, 118, '2014-04-01 00:56:11.000000', 'temperatura', 530.0000, 'ºC'),
	(264918, 118, '2014-04-01 00:56:12.000000', 'temperatura', 622.0000, 'ºC'),
	(264919, 118, '2014-04-01 00:56:13.000000', 'temperatura', 319.0000, 'ºC'),
	(264920, 118, '2014-04-01 00:56:14.000000', 'temperatura', 932.0000, 'ºC'),
	(264921, 118, '2014-04-01 00:56:15.000000', 'temperatura', 104.0000, 'ºC'),
	(264922, 118, '2014-04-01 00:56:16.000000', 'temperatura', 124.0000, 'ºC'),
	(264923, 118, '2014-04-01 00:56:17.000000', 'temperatura', 308.0000, 'ºC'),
	(264924, 118, '2014-04-01 00:56:18.000000', 'temperatura', 1168.0000, 'ºC'),
	(264925, 118, '2014-04-01 00:56:19.000000', 'temperatura', 115.0000, 'ºC'),
	(264926, 118, '2014-04-01 00:56:20.000000', 'temperatura', 675.0000, 'ºC'),
	(264927, 118, '2014-04-01 00:56:21.000000', 'temperatura', 627.0000, 'ºC'),
	(264928, 118, '2014-04-01 00:56:22.000000', 'temperatura', 1113.0000, 'ºC'),
	(264929, 118, '2014-04-01 00:56:23.000000', 'temperatura', 85.0000, 'ºC'),
	(264930, 118, '2014-04-01 00:56:24.000000', 'temperatura', 687.0000, 'ºC'),
	(264931, 118, '2014-04-01 00:56:25.000000', 'temperatura', 780.0000, 'ºC'),
	(264932, 118, '2014-04-01 00:56:26.000000', 'temperatura', 641.0000, 'ºC'),
	(264933, 118, '2014-04-01 00:56:27.000000', 'temperatura', 863.0000, 'ºC'),
	(264934, 118, '2014-04-01 00:56:28.000000', 'temperatura', 1194.0000, 'ºC'),
	(264935, 118, '2014-04-01 00:56:29.000000', 'temperatura', 979.0000, 'ºC'),
	(264936, 118, '2014-04-01 00:56:30.000000', 'temperatura', 115.0000, 'ºC'),
	(264937, 118, '2014-04-01 00:56:31.000000', 'temperatura', 38.0000, 'ºC'),
	(264938, 118, '2014-04-01 00:56:32.000000', 'temperatura', 1044.0000, 'ºC'),
	(264939, 118, '2014-04-01 00:56:33.000000', 'temperatura', 307.0000, 'ºC'),
	(264940, 118, '2014-04-01 00:56:34.000000', 'temperatura', 803.0000, 'ºC'),
	(264941, 118, '2014-04-01 00:56:35.000000', 'temperatura', 694.0000, 'ºC'),
	(264942, 118, '2014-04-01 00:56:36.000000', 'temperatura', 1064.0000, 'ºC'),
	(264943, 118, '2014-04-01 00:56:37.000000', 'temperatura', 838.0000, 'ºC'),
	(264944, 118, '2014-04-01 00:56:38.000000', 'temperatura', 1000.0000, 'ºC'),
	(264945, 118, '2014-04-01 00:56:39.000000', 'temperatura', 83.0000, 'ºC'),
	(264946, 118, '2014-04-01 00:56:40.000000', 'temperatura', 1019.0000, 'ºC'),
	(264947, 118, '2014-04-01 00:56:41.000000', 'temperatura', 43.0000, 'ºC'),
	(264948, 118, '2014-04-01 00:56:42.000000', 'temperatura', 761.0000, 'ºC'),
	(264949, 118, '2014-04-01 00:56:43.000000', 'temperatura', 75.0000, 'ºC'),
	(264950, 118, '2014-04-01 00:56:44.000000', 'temperatura', 494.0000, 'ºC'),
	(264951, 118, '2014-04-01 00:56:45.000000', 'temperatura', 1046.0000, 'ºC'),
	(264952, 118, '2014-04-01 00:56:46.000000', 'temperatura', 147.0000, 'ºC'),
	(264953, 118, '2014-04-01 00:56:47.000000', 'temperatura', 1199.0000, 'ºC'),
	(264954, 118, '2014-04-01 00:56:48.000000', 'temperatura', 752.0000, 'ºC'),
	(264955, 118, '2014-04-01 00:56:49.000000', 'temperatura', 166.0000, 'ºC'),
	(264956, 118, '2014-04-01 00:56:50.000000', 'temperatura', 973.0000, 'ºC'),
	(264957, 118, '2014-04-01 00:56:51.000000', 'temperatura', 770.0000, 'ºC'),
	(264958, 118, '2014-04-01 00:56:52.000000', 'temperatura', 928.0000, 'ºC'),
	(264959, 118, '2014-04-01 00:56:53.000000', 'temperatura', 1133.0000, 'ºC'),
	(264960, 118, '2014-04-01 00:56:54.000000', 'temperatura', 481.0000, 'ºC'),
	(264961, 118, '2014-04-01 00:56:55.000000', 'temperatura', 207.0000, 'ºC'),
	(264962, 118, '2014-04-01 00:56:56.000000', 'temperatura', 792.0000, 'ºC'),
	(264963, 118, '2014-04-01 00:56:57.000000', 'temperatura', 938.0000, 'ºC'),
	(264964, 118, '2014-04-01 00:56:58.000000', 'temperatura', 1114.0000, 'ºC'),
	(264965, 118, '2014-04-01 00:56:59.000000', 'temperatura', 356.0000, 'ºC'),
	(264966, 118, '2014-04-01 00:57:00.000000', 'temperatura', 841.0000, 'ºC'),
	(264967, 118, '2014-04-01 00:57:01.000000', 'temperatura', 736.0000, 'ºC'),
	(264968, 118, '2014-04-01 00:57:02.000000', 'temperatura', 1158.0000, 'ºC'),
	(264969, 118, '2014-04-01 00:57:03.000000', 'temperatura', 1181.0000, 'ºC'),
	(264970, 118, '2014-04-01 00:57:04.000000', 'temperatura', 34.0000, 'ºC'),
	(264971, 118, '2014-04-01 00:57:05.000000', 'temperatura', 227.0000, 'ºC'),
	(264972, 118, '2014-04-01 00:57:06.000000', 'temperatura', 1033.0000, 'ºC'),
	(264973, 118, '2014-04-01 00:57:07.000000', 'temperatura', 885.0000, 'ºC'),
	(264974, 118, '2014-04-01 00:57:08.000000', 'temperatura', 124.0000, 'ºC'),
	(264975, 118, '2014-04-01 00:57:09.000000', 'temperatura', 369.0000, 'ºC'),
	(264976, 118, '2014-04-01 00:57:10.000000', 'temperatura', 270.0000, 'ºC'),
	(264977, 118, '2014-04-01 00:57:11.000000', 'temperatura', 246.0000, 'ºC'),
	(264978, 118, '2014-04-01 00:57:12.000000', 'temperatura', 418.0000, 'ºC'),
	(264979, 118, '2014-04-01 00:57:13.000000', 'temperatura', 153.0000, 'ºC'),
	(264980, 118, '2014-04-01 00:57:14.000000', 'temperatura', 713.0000, 'ºC'),
	(264981, 118, '2014-04-01 00:57:15.000000', 'temperatura', 707.0000, 'ºC'),
	(264982, 118, '2014-04-01 00:57:16.000000', 'temperatura', 197.0000, 'ºC'),
	(264983, 118, '2014-04-01 00:57:17.000000', 'temperatura', 64.0000, 'ºC'),
	(264984, 118, '2014-04-01 00:57:18.000000', 'temperatura', 930.0000, 'ºC'),
	(264985, 118, '2014-04-01 00:57:19.000000', 'temperatura', 858.0000, 'ºC'),
	(264986, 118, '2014-04-01 00:57:20.000000', 'temperatura', 299.0000, 'ºC'),
	(264987, 118, '2014-04-01 00:57:21.000000', 'temperatura', 122.0000, 'ºC'),
	(264988, 118, '2014-04-01 00:57:22.000000', 'temperatura', 914.0000, 'ºC'),
	(264989, 118, '2014-04-01 00:57:23.000000', 'temperatura', 606.0000, 'ºC'),
	(264990, 118, '2014-04-01 00:57:24.000000', 'temperatura', 288.0000, 'ºC'),
	(264991, 118, '2014-04-01 00:57:25.000000', 'temperatura', 824.0000, 'ºC'),
	(264992, 118, '2014-04-01 00:57:26.000000', 'temperatura', 853.0000, 'ºC'),
	(264993, 118, '2014-04-01 00:57:27.000000', 'temperatura', 596.0000, 'ºC'),
	(264994, 118, '2014-04-01 00:57:28.000000', 'temperatura', 423.0000, 'ºC'),
	(264995, 118, '2014-04-01 00:57:29.000000', 'temperatura', 325.0000, 'ºC'),
	(264996, 118, '2014-04-01 00:57:30.000000', 'temperatura', 357.0000, 'ºC'),
	(264997, 118, '2014-04-01 00:57:31.000000', 'temperatura', 810.0000, 'ºC'),
	(264998, 118, '2014-04-01 00:57:32.000000', 'temperatura', 579.0000, 'ºC'),
	(264999, 118, '2014-04-01 00:57:33.000000', 'temperatura', 466.0000, 'ºC'),
	(265000, 118, '2014-04-01 00:57:34.000000', 'temperatura', 595.0000, 'ºC'),
	(265001, 118, '2014-04-01 00:57:35.000000', 'temperatura', 378.0000, 'ºC'),
	(265002, 118, '2014-04-01 00:57:36.000000', 'temperatura', 105.0000, 'ºC'),
	(265003, 118, '2014-04-01 00:57:37.000000', 'temperatura', 593.0000, 'ºC'),
	(265004, 118, '2014-04-01 00:57:38.000000', 'temperatura', 247.0000, 'ºC'),
	(265005, 118, '2014-04-01 00:57:39.000000', 'temperatura', 660.0000, 'ºC'),
	(265006, 118, '2014-04-01 00:57:40.000000', 'temperatura', 157.0000, 'ºC'),
	(265007, 118, '2014-04-01 00:57:41.000000', 'temperatura', 6.0000, 'ºC'),
	(265008, 118, '2014-04-01 00:57:42.000000', 'temperatura', 761.0000, 'ºC'),
	(265009, 118, '2014-04-01 00:57:43.000000', 'temperatura', 187.0000, 'ºC'),
	(265010, 118, '2014-04-01 00:57:44.000000', 'temperatura', 1054.0000, 'ºC'),
	(265011, 118, '2014-04-01 00:57:45.000000', 'temperatura', 1107.0000, 'ºC'),
	(265012, 118, '2014-04-01 00:57:46.000000', 'temperatura', 1176.0000, 'ºC'),
	(265013, 118, '2014-04-01 00:57:47.000000', 'temperatura', 157.0000, 'ºC'),
	(265014, 118, '2014-04-01 00:57:48.000000', 'temperatura', 861.0000, 'ºC'),
	(265015, 118, '2014-04-01 00:57:49.000000', 'temperatura', 231.0000, 'ºC'),
	(265016, 118, '2014-04-01 00:57:50.000000', 'temperatura', 972.0000, 'ºC'),
	(265017, 118, '2014-04-01 00:57:51.000000', 'temperatura', 569.0000, 'ºC'),
	(265018, 118, '2014-04-01 00:57:52.000000', 'temperatura', 1131.0000, 'ºC'),
	(265019, 118, '2014-04-01 00:57:53.000000', 'temperatura', 346.0000, 'ºC'),
	(265020, 118, '2014-04-01 00:57:54.000000', 'temperatura', 737.0000, 'ºC'),
	(265021, 118, '2014-04-01 00:57:55.000000', 'temperatura', 250.0000, 'ºC'),
	(265022, 118, '2014-04-01 00:57:56.000000', 'temperatura', 239.0000, 'ºC'),
	(265023, 118, '2014-04-01 00:57:57.000000', 'temperatura', 447.0000, 'ºC'),
	(265024, 118, '2014-04-01 00:57:58.000000', 'temperatura', 316.0000, 'ºC'),
	(265025, 118, '2014-04-01 00:57:59.000000', 'temperatura', 239.0000, 'ºC'),
	(265026, 118, '2014-04-01 00:58:00.000000', 'temperatura', 250.0000, 'ºC'),
	(265027, 118, '2014-04-01 00:58:01.000000', 'temperatura', 532.0000, 'ºC'),
	(265028, 118, '2014-04-01 00:58:02.000000', 'temperatura', 710.0000, 'ºC'),
	(265029, 118, '2014-04-01 00:58:03.000000', 'temperatura', 756.0000, 'ºC'),
	(265030, 118, '2014-04-01 00:58:04.000000', 'temperatura', 451.0000, 'ºC'),
	(265031, 118, '2014-04-01 00:58:05.000000', 'temperatura', 1187.0000, 'ºC'),
	(265032, 118, '2014-04-01 00:58:06.000000', 'temperatura', 984.0000, 'ºC'),
	(265033, 118, '2014-04-01 00:58:07.000000', 'temperatura', 159.0000, 'ºC'),
	(265034, 118, '2014-04-01 00:58:08.000000', 'temperatura', 241.0000, 'ºC'),
	(265035, 118, '2014-04-01 00:58:09.000000', 'temperatura', 730.0000, 'ºC'),
	(265036, 118, '2014-04-01 00:58:10.000000', 'temperatura', 529.0000, 'ºC'),
	(265037, 118, '2014-04-01 00:58:11.000000', 'temperatura', 453.0000, 'ºC'),
	(265038, 118, '2014-04-01 00:58:12.000000', 'temperatura', 678.0000, 'ºC'),
	(265039, 118, '2014-04-01 00:58:13.000000', 'temperatura', 833.0000, 'ºC'),
	(265040, 118, '2014-04-01 00:58:14.000000', 'temperatura', 931.0000, 'ºC'),
	(265041, 118, '2014-04-01 00:58:15.000000', 'temperatura', 957.0000, 'ºC'),
	(265042, 118, '2014-04-01 00:58:16.000000', 'temperatura', 792.0000, 'ºC'),
	(265043, 118, '2014-04-01 00:58:17.000000', 'temperatura', 1089.0000, 'ºC'),
	(265044, 118, '2014-04-01 00:58:18.000000', 'temperatura', 672.0000, 'ºC'),
	(265045, 118, '2014-04-01 00:58:19.000000', 'temperatura', 90.0000, 'ºC'),
	(265046, 118, '2014-04-01 00:58:20.000000', 'temperatura', 837.0000, 'ºC'),
	(265047, 118, '2014-04-01 00:58:21.000000', 'temperatura', 314.0000, 'ºC'),
	(265048, 118, '2014-04-01 00:58:22.000000', 'temperatura', 262.0000, 'ºC'),
	(265049, 118, '2014-04-01 00:58:23.000000', 'temperatura', 367.0000, 'ºC'),
	(265050, 118, '2014-04-01 00:58:24.000000', 'temperatura', 1049.0000, 'ºC'),
	(265051, 118, '2014-04-01 00:58:25.000000', 'temperatura', 545.0000, 'ºC'),
	(265052, 118, '2014-04-01 00:58:26.000000', 'temperatura', 777.0000, 'ºC'),
	(265053, 118, '2014-04-01 00:58:27.000000', 'temperatura', 1053.0000, 'ºC'),
	(265054, 118, '2014-04-01 00:58:28.000000', 'temperatura', 533.0000, 'ºC'),
	(265055, 118, '2014-04-01 00:58:29.000000', 'temperatura', 709.0000, 'ºC'),
	(265056, 118, '2014-04-01 00:58:30.000000', 'temperatura', 743.0000, 'ºC'),
	(265057, 118, '2014-04-01 00:58:31.000000', 'temperatura', 391.0000, 'ºC'),
	(265058, 118, '2014-04-01 00:58:32.000000', 'temperatura', 928.0000, 'ºC'),
	(265059, 118, '2014-04-01 00:58:33.000000', 'temperatura', 1065.0000, 'ºC'),
	(265060, 118, '2014-04-01 00:58:34.000000', 'temperatura', 140.0000, 'ºC'),
	(265061, 118, '2014-04-01 00:58:35.000000', 'temperatura', 1108.0000, 'ºC'),
	(265062, 118, '2014-04-01 00:58:36.000000', 'temperatura', 319.0000, 'ºC'),
	(265063, 118, '2014-04-01 00:58:37.000000', 'temperatura', 672.0000, 'ºC'),
	(265064, 118, '2014-04-01 00:58:38.000000', 'temperatura', 2.0000, 'ºC'),
	(265065, 118, '2014-04-01 00:58:39.000000', 'temperatura', 396.0000, 'ºC'),
	(265066, 118, '2014-04-01 00:58:40.000000', 'temperatura', 773.0000, 'ºC'),
	(265067, 118, '2014-04-01 00:58:41.000000', 'temperatura', 280.0000, 'ºC'),
	(265068, 118, '2014-04-01 00:58:42.000000', 'temperatura', 282.0000, 'ºC'),
	(265069, 118, '2014-04-01 00:58:43.000000', 'temperatura', 571.0000, 'ºC'),
	(265070, 118, '2014-04-01 00:58:44.000000', 'temperatura', 808.0000, 'ºC'),
	(265071, 118, '2014-04-01 00:58:45.000000', 'temperatura', 1129.0000, 'ºC'),
	(265072, 118, '2014-04-01 00:58:46.000000', 'temperatura', 820.0000, 'ºC'),
	(265073, 118, '2014-04-01 00:58:47.000000', 'temperatura', 713.0000, 'ºC'),
	(265074, 118, '2014-04-01 00:58:48.000000', 'temperatura', 1105.0000, 'ºC'),
	(265075, 118, '2014-04-01 00:58:49.000000', 'temperatura', 988.0000, 'ºC'),
	(265076, 118, '2014-04-01 00:58:50.000000', 'temperatura', 424.0000, 'ºC'),
	(265077, 118, '2014-04-01 00:58:51.000000', 'temperatura', 359.0000, 'ºC'),
	(265078, 118, '2014-04-01 00:58:52.000000', 'temperatura', 522.0000, 'ºC'),
	(265079, 118, '2014-04-01 00:58:53.000000', 'temperatura', 334.0000, 'ºC'),
	(265080, 118, '2014-04-01 00:58:54.000000', 'temperatura', 106.0000, 'ºC'),
	(265081, 118, '2014-04-01 00:58:55.000000', 'temperatura', 729.0000, 'ºC'),
	(265082, 118, '2014-04-01 00:58:56.000000', 'temperatura', 926.0000, 'ºC'),
	(265083, 118, '2014-04-01 00:58:57.000000', 'temperatura', 44.0000, 'ºC'),
	(265084, 118, '2014-04-01 00:58:58.000000', 'temperatura', 1043.0000, 'ºC'),
	(265085, 118, '2014-04-01 00:58:59.000000', 'temperatura', 281.0000, 'ºC'),
	(265086, 118, '2014-04-01 00:59:00.000000', 'temperatura', 677.0000, 'ºC'),
	(265087, 118, '2014-04-01 00:59:01.000000', 'temperatura', 145.0000, 'ºC'),
	(265088, 118, '2014-04-01 00:59:02.000000', 'temperatura', 1093.0000, 'ºC'),
	(265089, 118, '2014-04-01 00:59:03.000000', 'temperatura', 232.0000, 'ºC'),
	(265090, 118, '2014-04-01 00:59:04.000000', 'temperatura', 281.0000, 'ºC'),
	(265091, 118, '2014-04-01 00:59:05.000000', 'temperatura', 710.0000, 'ºC'),
	(265092, 118, '2014-04-01 00:59:06.000000', 'temperatura', 308.0000, 'ºC'),
	(265093, 118, '2014-04-01 00:59:07.000000', 'temperatura', 608.0000, 'ºC'),
	(265094, 118, '2014-04-01 00:59:08.000000', 'temperatura', 919.0000, 'ºC'),
	(265095, 118, '2014-04-01 00:59:09.000000', 'temperatura', 369.0000, 'ºC'),
	(265096, 118, '2014-04-01 00:59:10.000000', 'temperatura', 290.0000, 'ºC'),
	(265097, 118, '2014-04-01 00:59:11.000000', 'temperatura', 344.0000, 'ºC'),
	(265098, 118, '2014-04-01 00:59:12.000000', 'temperatura', 851.0000, 'ºC'),
	(265099, 118, '2014-04-01 00:59:13.000000', 'temperatura', 824.0000, 'ºC'),
	(265100, 118, '2014-04-01 00:59:14.000000', 'temperatura', 367.0000, 'ºC'),
	(265101, 118, '2014-04-01 00:59:15.000000', 'temperatura', 563.0000, 'ºC'),
	(265102, 118, '2014-04-01 00:59:16.000000', 'temperatura', 515.0000, 'ºC'),
	(265103, 118, '2014-04-01 00:59:17.000000', 'temperatura', 887.0000, 'ºC'),
	(265104, 118, '2014-04-01 00:59:18.000000', 'temperatura', 491.0000, 'ºC'),
	(265105, 118, '2014-04-01 00:59:19.000000', 'temperatura', 992.0000, 'ºC'),
	(265106, 118, '2014-04-01 00:59:20.000000', 'temperatura', 1090.0000, 'ºC'),
	(265107, 118, '2014-04-01 00:59:21.000000', 'temperatura', 73.0000, 'ºC'),
	(265108, 118, '2014-04-01 00:59:22.000000', 'temperatura', 697.0000, 'ºC'),
	(265109, 118, '2014-04-01 00:59:23.000000', 'temperatura', 864.0000, 'ºC'),
	(265110, 118, '2014-04-01 00:59:24.000000', 'temperatura', 1032.0000, 'ºC'),
	(265111, 118, '2014-04-01 00:59:25.000000', 'temperatura', 168.0000, 'ºC'),
	(265112, 118, '2014-04-01 00:59:26.000000', 'temperatura', 146.0000, 'ºC'),
	(265113, 118, '2014-04-01 00:59:27.000000', 'temperatura', 224.0000, 'ºC'),
	(265114, 118, '2014-04-01 00:59:28.000000', 'temperatura', 685.0000, 'ºC'),
	(265115, 118, '2014-04-01 00:59:29.000000', 'temperatura', 352.0000, 'ºC'),
	(265116, 118, '2014-04-01 00:59:30.000000', 'temperatura', 907.0000, 'ºC'),
	(265117, 118, '2014-04-01 00:59:31.000000', 'temperatura', 1079.0000, 'ºC'),
	(265118, 118, '2014-04-01 00:59:32.000000', 'temperatura', 276.0000, 'ºC'),
	(265119, 118, '2014-04-01 00:59:33.000000', 'temperatura', 543.0000, 'ºC'),
	(265120, 118, '2014-04-01 00:59:34.000000', 'temperatura', 686.0000, 'ºC'),
	(265121, 118, '2014-04-01 00:59:35.000000', 'temperatura', 602.0000, 'ºC'),
	(265122, 118, '2014-04-01 00:59:36.000000', 'temperatura', 954.0000, 'ºC'),
	(265123, 118, '2014-04-01 00:59:37.000000', 'temperatura', 565.0000, 'ºC'),
	(265124, 118, '2014-04-01 00:59:38.000000', 'temperatura', 1161.0000, 'ºC'),
	(265125, 118, '2014-04-01 00:59:39.000000', 'temperatura', 511.0000, 'ºC'),
	(265126, 118, '2014-04-01 00:59:40.000000', 'temperatura', 274.0000, 'ºC'),
	(265127, 118, '2014-04-01 00:59:41.000000', 'temperatura', 1037.0000, 'ºC'),
	(265128, 118, '2014-04-01 00:59:42.000000', 'temperatura', 764.0000, 'ºC'),
	(265129, 118, '2014-04-01 00:59:43.000000', 'temperatura', 709.0000, 'ºC'),
	(265130, 118, '2014-04-01 00:59:44.000000', 'temperatura', 52.0000, 'ºC'),
	(265131, 118, '2014-04-01 00:59:45.000000', 'temperatura', 536.0000, 'ºC'),
	(265132, 118, '2014-04-01 00:59:46.000000', 'temperatura', 123.0000, 'ºC'),
	(265133, 118, '2014-04-01 00:59:47.000000', 'temperatura', 209.0000, 'ºC'),
	(265134, 118, '2014-04-01 00:59:48.000000', 'temperatura', 676.0000, 'ºC'),
	(265135, 118, '2014-04-01 00:59:49.000000', 'temperatura', 353.0000, 'ºC'),
	(265136, 118, '2014-04-01 00:59:50.000000', 'temperatura', 937.0000, 'ºC'),
	(265137, 118, '2014-04-01 00:59:51.000000', 'temperatura', 28.0000, 'ºC'),
	(265138, 118, '2014-04-01 00:59:52.000000', 'temperatura', 928.0000, 'ºC'),
	(265139, 118, '2014-04-01 00:59:53.000000', 'temperatura', 956.0000, 'ºC'),
	(265140, 118, '2014-04-01 00:59:54.000000', 'temperatura', 797.0000, 'ºC'),
	(265141, 118, '2014-04-01 00:59:55.000000', 'temperatura', 1120.0000, 'ºC'),
	(265142, 118, '2014-04-01 00:59:56.000000', 'temperatura', 806.0000, 'ºC'),
	(265143, 118, '2014-04-01 00:59:57.000000', 'temperatura', 672.0000, 'ºC'),
	(265144, 118, '2014-04-01 00:59:58.000000', 'temperatura', 942.0000, 'ºC'),
	(265145, 118, '2014-04-01 00:59:59.000000', 'temperatura', 296.0000, 'ºC'),
	(265146, 118, '2014-04-01 01:00:00.000000', 'temperatura', 1056.0000, 'ºC'),
	(265147, 118, '2014-04-01 01:00:01.000000', 'temperatura', 790.0000, 'ºC'),
	(265148, 118, '2014-04-01 01:00:02.000000', 'temperatura', 783.0000, 'ºC'),
	(265149, 118, '2014-04-01 01:00:03.000000', 'temperatura', 344.0000, 'ºC'),
	(265150, 118, '2014-04-01 01:00:04.000000', 'temperatura', 571.0000, 'ºC'),
	(265151, 118, '2014-04-01 01:00:05.000000', 'temperatura', 626.0000, 'ºC'),
	(265152, 118, '2014-04-01 01:00:06.000000', 'temperatura', 216.0000, 'ºC'),
	(265153, 118, '2014-04-01 01:00:07.000000', 'temperatura', 404.0000, 'ºC'),
	(265154, 118, '2014-04-01 01:00:08.000000', 'temperatura', 170.0000, 'ºC'),
	(265155, 118, '2014-04-01 01:00:09.000000', 'temperatura', 840.0000, 'ºC'),
	(265156, 118, '2014-04-01 01:00:10.000000', 'temperatura', 92.0000, 'ºC'),
	(265157, 118, '2014-04-01 01:00:11.000000', 'temperatura', 341.0000, 'ºC'),
	(265158, 118, '2014-04-01 01:00:12.000000', 'temperatura', 227.0000, 'ºC'),
	(265159, 118, '2014-04-01 01:00:13.000000', 'temperatura', 112.0000, 'ºC'),
	(265160, 118, '2014-04-01 01:00:14.000000', 'temperatura', 1081.0000, 'ºC'),
	(265161, 118, '2014-04-01 01:00:15.000000', 'temperatura', 269.0000, 'ºC'),
	(265162, 118, '2014-04-01 01:00:16.000000', 'temperatura', 503.0000, 'ºC'),
	(265163, 118, '2014-04-01 01:00:17.000000', 'temperatura', 509.0000, 'ºC'),
	(265164, 118, '2014-04-01 01:00:18.000000', 'temperatura', 1037.0000, 'ºC'),
	(265165, 118, '2014-04-01 01:00:19.000000', 'temperatura', 57.0000, 'ºC'),
	(265166, 118, '2014-04-01 01:00:20.000000', 'temperatura', 777.0000, 'ºC'),
	(265167, 118, '2014-04-01 01:00:21.000000', 'temperatura', 113.0000, 'ºC'),
	(265168, 118, '2014-04-01 01:00:22.000000', 'temperatura', 633.0000, 'ºC'),
	(265169, 118, '2014-04-01 01:00:23.000000', 'temperatura', 428.0000, 'ºC'),
	(265170, 118, '2014-04-01 01:00:24.000000', 'temperatura', 241.0000, 'ºC'),
	(265171, 118, '2014-04-01 01:00:25.000000', 'temperatura', 1122.0000, 'ºC'),
	(265172, 118, '2014-04-01 01:00:26.000000', 'temperatura', 87.0000, 'ºC'),
	(265173, 118, '2014-04-01 01:00:27.000000', 'temperatura', 671.0000, 'ºC'),
	(265174, 118, '2014-04-01 01:00:28.000000', 'temperatura', 692.0000, 'ºC'),
	(265175, 118, '2014-04-01 01:00:29.000000', 'temperatura', 248.0000, 'ºC'),
	(265176, 118, '2014-04-01 01:00:30.000000', 'temperatura', 364.0000, 'ºC'),
	(265177, 118, '2014-04-01 01:00:31.000000', 'temperatura', 1076.0000, 'ºC'),
	(265178, 118, '2014-04-01 01:00:32.000000', 'temperatura', 687.0000, 'ºC'),
	(265179, 118, '2014-04-01 01:00:33.000000', 'temperatura', 211.0000, 'ºC'),
	(265180, 118, '2014-04-01 01:00:34.000000', 'temperatura', 192.0000, 'ºC'),
	(265181, 118, '2014-04-01 01:00:35.000000', 'temperatura', 328.0000, 'ºC'),
	(265182, 118, '2014-04-01 01:00:36.000000', 'temperatura', 1066.0000, 'ºC'),
	(265183, 118, '2014-04-01 01:00:37.000000', 'temperatura', 744.0000, 'ºC'),
	(265184, 118, '2014-04-01 01:00:38.000000', 'temperatura', 526.0000, 'ºC'),
	(265185, 118, '2014-04-01 01:00:39.000000', 'temperatura', 395.0000, 'ºC'),
	(265186, 118, '2014-04-01 01:00:40.000000', 'temperatura', 400.0000, 'ºC'),
	(265187, 118, '2014-04-01 01:00:41.000000', 'temperatura', 814.0000, 'ºC'),
	(265188, 118, '2014-04-01 01:00:42.000000', 'temperatura', 472.0000, 'ºC'),
	(265189, 118, '2014-04-01 01:00:43.000000', 'temperatura', 1117.0000, 'ºC'),
	(265190, 118, '2014-04-01 01:00:44.000000', 'temperatura', 568.0000, 'ºC'),
	(265191, 118, '2014-04-01 01:00:45.000000', 'temperatura', 691.0000, 'ºC'),
	(265192, 118, '2014-04-01 01:00:46.000000', 'temperatura', 552.0000, 'ºC'),
	(265193, 118, '2014-04-01 01:00:47.000000', 'temperatura', 688.0000, 'ºC'),
	(265194, 118, '2014-04-01 01:00:48.000000', 'temperatura', 582.0000, 'ºC'),
	(265195, 118, '2014-04-01 01:00:49.000000', 'temperatura', 850.0000, 'ºC'),
	(265196, 118, '2014-04-01 01:00:50.000000', 'temperatura', 102.0000, 'ºC'),
	(265197, 118, '2014-04-01 01:00:51.000000', 'temperatura', 362.0000, 'ºC'),
	(265198, 118, '2014-04-01 01:00:52.000000', 'temperatura', 302.0000, 'ºC'),
	(265199, 118, '2014-04-01 01:00:53.000000', 'temperatura', 427.0000, 'ºC'),
	(265200, 118, '2014-04-01 01:00:54.000000', 'temperatura', 31.0000, 'ºC'),
	(265201, 118, '2014-04-01 01:00:55.000000', 'temperatura', 72.0000, 'ºC'),
	(265202, 118, '2014-04-01 01:00:56.000000', 'temperatura', 267.0000, 'ºC'),
	(265203, 118, '2014-04-01 01:00:57.000000', 'temperatura', 1121.0000, 'ºC'),
	(265204, 118, '2014-04-01 01:00:58.000000', 'temperatura', 5.0000, 'ºC'),
	(265205, 118, '2014-04-01 01:00:59.000000', 'temperatura', 262.0000, 'ºC'),
	(265206, 118, '2014-04-01 01:01:00.000000', 'temperatura', 95.0000, 'ºC'),
	(265207, 118, '2014-04-01 01:01:01.000000', 'temperatura', 890.0000, 'ºC'),
	(265208, 118, '2014-04-01 01:01:02.000000', 'temperatura', 565.0000, 'ºC'),
	(265209, 118, '2014-04-01 01:01:03.000000', 'temperatura', 155.0000, 'ºC'),
	(265210, 118, '2014-04-01 01:01:04.000000', 'temperatura', 281.0000, 'ºC'),
	(265211, 118, '2014-04-01 01:01:05.000000', 'temperatura', 941.0000, 'ºC'),
	(265212, 118, '2014-04-01 01:01:06.000000', 'temperatura', 261.0000, 'ºC'),
	(265213, 118, '2014-04-01 01:01:07.000000', 'temperatura', 883.0000, 'ºC'),
	(265214, 118, '2014-04-01 01:01:08.000000', 'temperatura', 31.0000, 'ºC'),
	(265215, 118, '2014-04-01 01:01:09.000000', 'temperatura', 1109.0000, 'ºC'),
	(265216, 118, '2014-04-01 01:01:10.000000', 'temperatura', 650.0000, 'ºC'),
	(265217, 118, '2014-04-01 01:01:11.000000', 'temperatura', 1123.0000, 'ºC'),
	(265218, 118, '2014-04-01 01:01:12.000000', 'temperatura', 69.0000, 'ºC'),
	(265219, 118, '2014-04-01 01:01:13.000000', 'temperatura', 574.0000, 'ºC'),
	(265220, 118, '2014-04-01 01:01:14.000000', 'temperatura', 263.0000, 'ºC'),
	(265221, 118, '2014-04-01 01:01:15.000000', 'temperatura', 794.0000, 'ºC'),
	(265222, 118, '2014-04-01 01:01:16.000000', 'temperatura', 781.0000, 'ºC'),
	(265223, 118, '2014-04-01 01:01:17.000000', 'temperatura', 324.0000, 'ºC'),
	(265224, 118, '2014-04-01 01:01:18.000000', 'temperatura', 478.0000, 'ºC'),
	(265225, 118, '2014-04-01 01:01:19.000000', 'temperatura', 217.0000, 'ºC'),
	(265226, 118, '2014-04-01 01:01:20.000000', 'temperatura', 851.0000, 'ºC'),
	(265227, 118, '2014-04-01 01:01:21.000000', 'temperatura', 7.0000, 'ºC'),
	(265228, 118, '2014-04-01 01:01:22.000000', 'temperatura', 1079.0000, 'ºC'),
	(265229, 118, '2014-04-01 01:01:23.000000', 'temperatura', 578.0000, 'ºC'),
	(265230, 118, '2014-04-01 01:01:24.000000', 'temperatura', 852.0000, 'ºC'),
	(265231, 118, '2014-04-01 01:01:25.000000', 'temperatura', 125.0000, 'ºC'),
	(265232, 118, '2014-04-01 01:01:26.000000', 'temperatura', 469.0000, 'ºC'),
	(265233, 118, '2014-04-01 01:01:27.000000', 'temperatura', 770.0000, 'ºC'),
	(265234, 118, '2014-04-01 01:01:28.000000', 'temperatura', 43.0000, 'ºC'),
	(265235, 118, '2014-04-01 01:01:29.000000', 'temperatura', 308.0000, 'ºC'),
	(265236, 118, '2014-04-01 01:01:30.000000', 'temperatura', 213.0000, 'ºC'),
	(265237, 118, '2014-04-01 01:01:31.000000', 'temperatura', 138.0000, 'ºC'),
	(265238, 118, '2014-04-01 01:01:32.000000', 'temperatura', 53.0000, 'ºC'),
	(265239, 118, '2014-04-01 01:01:33.000000', 'temperatura', 1052.0000, 'ºC'),
	(265240, 118, '2014-04-01 01:01:34.000000', 'temperatura', 301.0000, 'ºC'),
	(265241, 118, '2014-04-01 01:01:35.000000', 'temperatura', 751.0000, 'ºC'),
	(265242, 118, '2014-04-01 01:01:36.000000', 'temperatura', 452.0000, 'ºC'),
	(265243, 118, '2014-04-01 01:01:37.000000', 'temperatura', 7.0000, 'ºC'),
	(265244, 118, '2014-04-01 01:01:38.000000', 'temperatura', 1081.0000, 'ºC'),
	(265245, 118, '2014-04-01 01:01:39.000000', 'temperatura', 585.0000, 'ºC'),
	(265246, 118, '2014-04-01 01:01:40.000000', 'temperatura', 880.0000, 'ºC'),
	(265247, 118, '2014-04-01 01:01:41.000000', 'temperatura', 248.0000, 'ºC'),
	(265248, 118, '2014-04-01 01:01:42.000000', 'temperatura', 998.0000, 'ºC'),
	(265249, 118, '2014-04-01 01:01:43.000000', 'temperatura', 646.0000, 'ºC'),
	(265250, 118, '2014-04-01 01:01:44.000000', 'temperatura', 239.0000, 'ºC'),
	(265251, 118, '2014-04-01 01:01:45.000000', 'temperatura', 456.0000, 'ºC'),
	(265252, 118, '2014-04-01 01:01:46.000000', 'temperatura', 363.0000, 'ºC'),
	(265253, 118, '2014-04-01 01:01:47.000000', 'temperatura', 448.0000, 'ºC'),
	(265254, 118, '2014-04-01 01:01:48.000000', 'temperatura', 1153.0000, 'ºC'),
	(265255, 118, '2014-04-01 01:01:49.000000', 'temperatura', 821.0000, 'ºC'),
	(265256, 118, '2014-04-01 01:01:50.000000', 'temperatura', 648.0000, 'ºC'),
	(265257, 118, '2014-04-01 01:01:51.000000', 'temperatura', 774.0000, 'ºC'),
	(265258, 118, '2014-04-01 01:01:52.000000', 'temperatura', 729.0000, 'ºC'),
	(265259, 118, '2014-04-01 01:01:53.000000', 'temperatura', 122.0000, 'ºC'),
	(265260, 118, '2014-04-01 01:01:54.000000', 'temperatura', 824.0000, 'ºC'),
	(265261, 118, '2014-04-01 01:01:55.000000', 'temperatura', 155.0000, 'ºC'),
	(265262, 118, '2014-04-01 01:01:56.000000', 'temperatura', 701.0000, 'ºC'),
	(265263, 118, '2014-04-01 01:01:57.000000', 'temperatura', 643.0000, 'ºC'),
	(265264, 118, '2014-04-01 01:01:58.000000', 'temperatura', 1112.0000, 'ºC'),
	(265265, 118, '2014-04-01 01:01:59.000000', 'temperatura', 33.0000, 'ºC'),
	(265266, 118, '2014-04-01 01:02:00.000000', 'temperatura', 429.0000, 'ºC'),
	(265267, 118, '2014-04-01 01:02:01.000000', 'temperatura', 846.0000, 'ºC'),
	(265268, 118, '2014-04-01 01:02:02.000000', 'temperatura', 545.0000, 'ºC'),
	(265269, 118, '2014-04-01 01:02:03.000000', 'temperatura', 185.0000, 'ºC'),
	(265270, 118, '2014-04-01 01:02:04.000000', 'temperatura', 494.0000, 'ºC'),
	(265271, 118, '2014-04-01 01:02:05.000000', 'temperatura', 712.0000, 'ºC'),
	(265272, 118, '2014-04-01 01:02:06.000000', 'temperatura', 878.0000, 'ºC'),
	(265273, 118, '2014-04-01 01:02:07.000000', 'temperatura', 1056.0000, 'ºC'),
	(265274, 118, '2014-04-01 01:02:08.000000', 'temperatura', 248.0000, 'ºC'),
	(265275, 118, '2014-04-01 01:02:09.000000', 'temperatura', 472.0000, 'ºC'),
	(265276, 118, '2014-04-01 01:02:10.000000', 'temperatura', 414.0000, 'ºC'),
	(265277, 118, '2014-04-01 01:02:11.000000', 'temperatura', 656.0000, 'ºC'),
	(265278, 118, '2014-04-01 01:02:12.000000', 'temperatura', 838.0000, 'ºC'),
	(265279, 118, '2014-04-01 01:02:13.000000', 'temperatura', 1023.0000, 'ºC'),
	(265280, 118, '2014-04-01 01:02:14.000000', 'temperatura', 199.0000, 'ºC'),
	(265281, 118, '2014-04-01 01:02:15.000000', 'temperatura', 329.0000, 'ºC'),
	(265282, 118, '2014-04-01 01:02:16.000000', 'temperatura', 1050.0000, 'ºC'),
	(265283, 118, '2014-04-01 01:02:17.000000', 'temperatura', 660.0000, 'ºC'),
	(265284, 118, '2014-04-01 01:02:18.000000', 'temperatura', 154.0000, 'ºC'),
	(265285, 118, '2014-04-01 01:02:19.000000', 'temperatura', 1188.0000, 'ºC'),
	(265286, 118, '2014-04-01 01:02:20.000000', 'temperatura', 678.0000, 'ºC'),
	(265287, 118, '2014-04-01 01:02:21.000000', 'temperatura', 1025.0000, 'ºC'),
	(265288, 118, '2014-04-01 01:02:22.000000', 'temperatura', 694.0000, 'ºC'),
	(265289, 118, '2014-04-01 01:02:23.000000', 'temperatura', 396.0000, 'ºC'),
	(265290, 118, '2014-04-01 01:02:24.000000', 'temperatura', 1100.0000, 'ºC'),
	(265291, 118, '2014-04-01 01:02:25.000000', 'temperatura', 710.0000, 'ºC'),
	(265292, 118, '2014-04-01 01:02:26.000000', 'temperatura', 251.0000, 'ºC'),
	(265293, 118, '2014-04-01 01:02:27.000000', 'temperatura', 326.0000, 'ºC'),
	(265294, 118, '2014-04-01 01:02:28.000000', 'temperatura', 879.0000, 'ºC'),
	(265295, 118, '2014-04-01 01:02:29.000000', 'temperatura', 1017.0000, 'ºC'),
	(265296, 118, '2014-04-01 01:02:30.000000', 'temperatura', 47.0000, 'ºC'),
	(265297, 118, '2014-04-01 01:02:31.000000', 'temperatura', 786.0000, 'ºC'),
	(265298, 118, '2014-04-01 01:02:32.000000', 'temperatura', 188.0000, 'ºC'),
	(265299, 118, '2014-04-01 01:02:33.000000', 'temperatura', 983.0000, 'ºC'),
	(265300, 118, '2014-04-01 01:02:34.000000', 'temperatura', 753.0000, 'ºC'),
	(265301, 118, '2014-04-01 01:02:35.000000', 'temperatura', 815.0000, 'ºC'),
	(265302, 118, '2014-04-01 01:02:36.000000', 'temperatura', 617.0000, 'ºC'),
	(265303, 118, '2014-04-01 01:02:37.000000', 'temperatura', 638.0000, 'ºC'),
	(265304, 118, '2014-04-01 01:02:38.000000', 'temperatura', 143.0000, 'ºC'),
	(265305, 118, '2014-04-01 01:02:39.000000', 'temperatura', 1198.0000, 'ºC'),
	(265306, 118, '2014-04-01 01:02:40.000000', 'temperatura', 764.0000, 'ºC'),
	(265307, 118, '2014-04-01 01:02:41.000000', 'temperatura', 224.0000, 'ºC'),
	(265308, 118, '2014-04-01 01:02:42.000000', 'temperatura', 30.0000, 'ºC'),
	(265309, 118, '2014-04-01 01:02:43.000000', 'temperatura', 680.0000, 'ºC'),
	(265310, 118, '2014-04-01 01:02:44.000000', 'temperatura', 911.0000, 'ºC'),
	(265311, 118, '2014-04-01 01:02:45.000000', 'temperatura', 114.0000, 'ºC'),
	(265312, 118, '2014-04-01 01:02:46.000000', 'temperatura', 239.0000, 'ºC'),
	(265313, 118, '2014-04-01 01:02:47.000000', 'temperatura', 852.0000, 'ºC'),
	(265314, 118, '2014-04-01 01:02:48.000000', 'temperatura', 1146.0000, 'ºC'),
	(265315, 118, '2014-04-01 01:02:49.000000', 'temperatura', 772.0000, 'ºC'),
	(265316, 118, '2014-04-01 01:02:50.000000', 'temperatura', 422.0000, 'ºC'),
	(265317, 118, '2014-04-01 01:02:51.000000', 'temperatura', 996.0000, 'ºC'),
	(265318, 118, '2014-04-01 01:02:52.000000', 'temperatura', 115.0000, 'ºC'),
	(265319, 118, '2014-04-01 01:02:53.000000', 'temperatura', 1188.0000, 'ºC'),
	(265320, 118, '2014-04-01 01:02:54.000000', 'temperatura', 794.0000, 'ºC'),
	(265321, 118, '2014-04-01 01:02:55.000000', 'temperatura', 409.0000, 'ºC'),
	(265322, 118, '2014-04-01 01:02:56.000000', 'temperatura', 861.0000, 'ºC'),
	(265323, 118, '2014-04-01 01:02:57.000000', 'temperatura', 678.0000, 'ºC'),
	(265324, 118, '2014-04-01 01:02:58.000000', 'temperatura', 808.0000, 'ºC'),
	(265325, 118, '2014-04-01 01:02:59.000000', 'temperatura', 808.0000, 'ºC'),
	(265326, 118, '2014-04-01 01:03:00.000000', 'temperatura', 415.0000, 'ºC'),
	(265327, 118, '2014-04-01 01:03:01.000000', 'temperatura', 852.0000, 'ºC'),
	(265328, 118, '2014-04-01 01:03:02.000000', 'temperatura', 617.0000, 'ºC'),
	(265329, 118, '2014-04-01 01:03:03.000000', 'temperatura', 526.0000, 'ºC'),
	(265330, 118, '2014-04-01 01:03:04.000000', 'temperatura', 782.0000, 'ºC'),
	(265331, 118, '2014-04-01 01:03:05.000000', 'temperatura', 1134.0000, 'ºC'),
	(265332, 118, '2014-04-01 01:03:06.000000', 'temperatura', 923.0000, 'ºC'),
	(265333, 118, '2014-04-01 01:03:07.000000', 'temperatura', 12.0000, 'ºC'),
	(265334, 118, '2014-04-01 01:03:08.000000', 'temperatura', 894.0000, 'ºC'),
	(265335, 118, '2014-04-01 01:03:09.000000', 'temperatura', 834.0000, 'ºC'),
	(265336, 118, '2014-04-01 01:03:10.000000', 'temperatura', 289.0000, 'ºC'),
	(265337, 118, '2014-04-01 01:03:11.000000', 'temperatura', 143.0000, 'ºC'),
	(265338, 118, '2014-04-01 01:03:12.000000', 'temperatura', 1047.0000, 'ºC'),
	(265339, 118, '2014-04-01 01:03:13.000000', 'temperatura', 8.0000, 'ºC'),
	(265340, 118, '2014-04-01 01:03:14.000000', 'temperatura', 497.0000, 'ºC'),
	(265341, 118, '2014-04-01 01:03:15.000000', 'temperatura', 64.0000, 'ºC'),
	(265342, 118, '2014-04-01 01:03:16.000000', 'temperatura', 29.0000, 'ºC'),
	(265343, 118, '2014-04-01 01:03:17.000000', 'temperatura', 1154.0000, 'ºC'),
	(265344, 118, '2014-04-01 01:03:18.000000', 'temperatura', 884.0000, 'ºC'),
	(265345, 118, '2014-04-01 01:03:19.000000', 'temperatura', 960.0000, 'ºC'),
	(265346, 118, '2014-04-01 01:03:20.000000', 'temperatura', 946.0000, 'ºC'),
	(265347, 118, '2014-04-01 01:03:21.000000', 'temperatura', 653.0000, 'ºC'),
	(265348, 118, '2014-04-01 01:03:22.000000', 'temperatura', 428.0000, 'ºC'),
	(265349, 118, '2014-04-01 01:03:23.000000', 'temperatura', 178.0000, 'ºC'),
	(265350, 118, '2014-04-01 01:03:24.000000', 'temperatura', 809.0000, 'ºC'),
	(265351, 118, '2014-04-01 01:03:25.000000', 'temperatura', 1111.0000, 'ºC'),
	(265352, 118, '2014-04-01 01:03:26.000000', 'temperatura', 729.0000, 'ºC'),
	(265353, 118, '2014-04-01 01:03:27.000000', 'temperatura', 314.0000, 'ºC'),
	(265354, 118, '2014-04-01 01:03:28.000000', 'temperatura', 582.0000, 'ºC'),
	(265355, 118, '2014-04-01 01:03:29.000000', 'temperatura', 767.0000, 'ºC'),
	(265356, 118, '2014-04-01 01:03:30.000000', 'temperatura', 892.0000, 'ºC'),
	(265357, 118, '2014-04-01 01:03:31.000000', 'temperatura', 959.0000, 'ºC'),
	(265358, 118, '2014-04-01 01:03:32.000000', 'temperatura', 919.0000, 'ºC'),
	(265359, 118, '2014-04-01 01:03:33.000000', 'temperatura', 517.0000, 'ºC'),
	(265360, 118, '2014-04-01 01:03:34.000000', 'temperatura', 1030.0000, 'ºC'),
	(265361, 118, '2014-04-01 01:03:35.000000', 'temperatura', 1.0000, 'ºC'),
	(265362, 118, '2014-04-01 01:03:36.000000', 'temperatura', 515.0000, 'ºC'),
	(265363, 118, '2014-04-01 01:03:37.000000', 'temperatura', 172.0000, 'ºC'),
	(265364, 118, '2014-04-01 01:03:38.000000', 'temperatura', 514.0000, 'ºC'),
	(265365, 118, '2014-04-01 01:03:39.000000', 'temperatura', 854.0000, 'ºC'),
	(265366, 118, '2014-04-01 01:03:40.000000', 'temperatura', 328.0000, 'ºC'),
	(265367, 118, '2014-04-01 01:03:41.000000', 'temperatura', 280.0000, 'ºC'),
	(265368, 118, '2014-04-01 01:03:42.000000', 'temperatura', 418.0000, 'ºC'),
	(265369, 118, '2014-04-01 01:03:43.000000', 'temperatura', 50.0000, 'ºC'),
	(265370, 118, '2014-04-01 01:03:44.000000', 'temperatura', 197.0000, 'ºC'),
	(265371, 118, '2014-04-01 01:03:45.000000', 'temperatura', 834.0000, 'ºC'),
	(265372, 118, '2014-04-01 01:03:46.000000', 'temperatura', 1182.0000, 'ºC'),
	(265373, 118, '2014-04-01 01:03:47.000000', 'temperatura', 1006.0000, 'ºC'),
	(265374, 118, '2014-04-01 01:03:48.000000', 'temperatura', 284.0000, 'ºC'),
	(265375, 118, '2014-04-01 01:03:49.000000', 'temperatura', 801.0000, 'ºC'),
	(265376, 118, '2014-04-01 01:03:50.000000', 'temperatura', 757.0000, 'ºC'),
	(265377, 118, '2014-04-01 01:03:51.000000', 'temperatura', 181.0000, 'ºC'),
	(265378, 118, '2014-04-01 01:03:52.000000', 'temperatura', 1036.0000, 'ºC'),
	(265379, 118, '2014-04-01 01:03:53.000000', 'temperatura', 1038.0000, 'ºC'),
	(265380, 118, '2014-04-01 01:03:54.000000', 'temperatura', 883.0000, 'ºC'),
	(265381, 118, '2014-04-01 01:03:55.000000', 'temperatura', 103.0000, 'ºC'),
	(265382, 118, '2014-04-01 01:03:56.000000', 'temperatura', 263.0000, 'ºC'),
	(265383, 118, '2014-04-01 01:03:57.000000', 'temperatura', 1007.0000, 'ºC'),
	(265384, 118, '2014-04-01 01:03:58.000000', 'temperatura', 647.0000, 'ºC'),
	(265385, 118, '2014-04-01 01:03:59.000000', 'temperatura', 216.0000, 'ºC'),
	(265386, 118, '2014-04-01 01:04:00.000000', 'temperatura', 339.0000, 'ºC'),
	(265387, 118, '2014-04-01 01:04:01.000000', 'temperatura', 1047.0000, 'ºC'),
	(265388, 118, '2014-04-01 01:04:02.000000', 'temperatura', 617.0000, 'ºC'),
	(265389, 118, '2014-04-01 01:04:03.000000', 'temperatura', 1147.0000, 'ºC'),
	(265390, 118, '2014-04-01 01:04:04.000000', 'temperatura', 285.0000, 'ºC'),
	(265391, 118, '2014-04-01 01:04:05.000000', 'temperatura', 384.0000, 'ºC'),
	(265392, 118, '2014-04-01 01:04:06.000000', 'temperatura', 1067.0000, 'ºC'),
	(265393, 118, '2014-04-01 01:04:07.000000', 'temperatura', 581.0000, 'ºC'),
	(265394, 118, '2014-04-01 01:04:08.000000', 'temperatura', 907.0000, 'ºC'),
	(265395, 118, '2014-04-01 01:04:09.000000', 'temperatura', 393.0000, 'ºC'),
	(265396, 118, '2014-04-01 01:04:10.000000', 'temperatura', 445.0000, 'ºC'),
	(265397, 118, '2014-04-01 01:04:11.000000', 'temperatura', 1044.0000, 'ºC'),
	(265398, 118, '2014-04-01 01:04:12.000000', 'temperatura', 286.0000, 'ºC'),
	(265399, 118, '2014-04-01 01:04:13.000000', 'temperatura', 701.0000, 'ºC'),
	(265400, 118, '2014-04-01 01:04:14.000000', 'temperatura', 245.0000, 'ºC'),
	(265401, 118, '2014-04-01 01:04:15.000000', 'temperatura', 321.0000, 'ºC'),
	(265402, 118, '2014-04-01 01:04:16.000000', 'temperatura', 873.0000, 'ºC'),
	(265403, 118, '2014-04-01 01:04:17.000000', 'temperatura', 1003.0000, 'ºC'),
	(265404, 118, '2014-04-01 01:04:18.000000', 'temperatura', 1195.0000, 'ºC'),
	(265405, 118, '2014-04-01 01:04:19.000000', 'temperatura', 565.0000, 'ºC'),
	(265406, 118, '2014-04-01 01:04:20.000000', 'temperatura', 443.0000, 'ºC'),
	(265407, 118, '2014-04-01 01:04:21.000000', 'temperatura', 522.0000, 'ºC'),
	(265408, 118, '2014-04-01 01:04:22.000000', 'temperatura', 78.0000, 'ºC'),
	(265409, 118, '2014-04-01 01:04:23.000000', 'temperatura', 28.0000, 'ºC'),
	(265410, 118, '2014-04-01 01:04:24.000000', 'temperatura', 1105.0000, 'ºC'),
	(265411, 118, '2014-04-01 01:04:25.000000', 'temperatura', 640.0000, 'ºC'),
	(265412, 118, '2014-04-01 01:04:26.000000', 'temperatura', 1085.0000, 'ºC'),
	(265413, 118, '2014-04-01 01:04:27.000000', 'temperatura', 1108.0000, 'ºC'),
	(265414, 118, '2014-04-01 01:04:28.000000', 'temperatura', 1086.0000, 'ºC'),
	(265415, 118, '2014-04-01 01:04:29.000000', 'temperatura', 905.0000, 'ºC'),
	(265416, 118, '2014-04-01 01:04:30.000000', 'temperatura', 68.0000, 'ºC'),
	(265417, 118, '2014-04-01 01:04:31.000000', 'temperatura', 23.0000, 'ºC'),
	(265418, 118, '2014-04-01 01:04:32.000000', 'temperatura', 1114.0000, 'ºC'),
	(265419, 118, '2014-04-01 01:04:33.000000', 'temperatura', 702.0000, 'ºC'),
	(265420, 118, '2014-04-01 01:04:34.000000', 'temperatura', 168.0000, 'ºC'),
	(265421, 118, '2014-04-01 01:04:35.000000', 'temperatura', 1134.0000, 'ºC'),
	(265422, 118, '2014-04-01 01:04:36.000000', 'temperatura', 365.0000, 'ºC'),
	(265423, 118, '2014-04-01 01:04:37.000000', 'temperatura', 826.0000, 'ºC'),
	(265424, 118, '2014-04-01 01:04:38.000000', 'temperatura', 635.0000, 'ºC'),
	(265425, 118, '2014-04-01 01:04:39.000000', 'temperatura', 697.0000, 'ºC'),
	(265426, 118, '2014-04-01 01:04:40.000000', 'temperatura', 382.0000, 'ºC'),
	(265427, 118, '2014-04-01 01:04:41.000000', 'temperatura', 1019.0000, 'ºC'),
	(265428, 118, '2014-04-01 01:04:42.000000', 'temperatura', 351.0000, 'ºC'),
	(265429, 118, '2014-04-01 01:04:43.000000', 'temperatura', 1096.0000, 'ºC'),
	(265430, 118, '2014-04-01 01:04:44.000000', 'temperatura', 830.0000, 'ºC'),
	(265431, 118, '2014-04-01 01:04:45.000000', 'temperatura', 861.0000, 'ºC'),
	(265432, 118, '2014-04-01 01:04:46.000000', 'temperatura', 618.0000, 'ºC'),
	(265433, 118, '2014-04-01 01:04:47.000000', 'temperatura', 505.0000, 'ºC'),
	(265434, 118, '2014-04-01 01:04:48.000000', 'temperatura', 671.0000, 'ºC'),
	(265435, 118, '2014-04-01 01:04:49.000000', 'temperatura', 642.0000, 'ºC'),
	(265436, 118, '2014-04-01 01:04:50.000000', 'temperatura', 1199.0000, 'ºC'),
	(265437, 118, '2014-04-01 01:04:51.000000', 'temperatura', 468.0000, 'ºC'),
	(265438, 118, '2014-04-01 01:04:52.000000', 'temperatura', 1142.0000, 'ºC'),
	(265439, 118, '2014-04-01 01:04:53.000000', 'temperatura', 708.0000, 'ºC'),
	(265440, 118, '2014-04-01 01:04:54.000000', 'temperatura', 113.0000, 'ºC'),
	(265441, 118, '2014-04-01 01:04:55.000000', 'temperatura', 844.0000, 'ºC'),
	(265442, 118, '2014-04-01 01:04:56.000000', 'temperatura', 279.0000, 'ºC'),
	(265443, 118, '2014-04-01 01:04:57.000000', 'temperatura', 64.0000, 'ºC'),
	(265444, 118, '2014-04-01 01:04:58.000000', 'temperatura', 682.0000, 'ºC'),
	(265445, 118, '2014-04-01 01:04:59.000000', 'temperatura', 818.0000, 'ºC'),
	(265446, 118, '2014-04-01 01:05:00.000000', 'temperatura', 847.0000, 'ºC'),
	(265447, 118, '2014-04-01 01:05:01.000000', 'temperatura', 582.0000, 'ºC'),
	(265448, 118, '2014-04-01 01:05:02.000000', 'temperatura', 370.0000, 'ºC'),
	(265449, 118, '2014-04-01 01:05:03.000000', 'temperatura', 102.0000, 'ºC'),
	(265450, 118, '2014-04-01 01:05:04.000000', 'temperatura', 601.0000, 'ºC'),
	(265451, 118, '2014-04-01 01:05:05.000000', 'temperatura', 302.0000, 'ºC'),
	(265452, 118, '2014-04-01 01:05:06.000000', 'temperatura', 906.0000, 'ºC'),
	(265453, 118, '2014-04-01 01:05:07.000000', 'temperatura', 24.0000, 'ºC'),
	(265454, 118, '2014-04-01 01:05:08.000000', 'temperatura', 1005.0000, 'ºC'),
	(265455, 118, '2014-04-01 01:05:09.000000', 'temperatura', 152.0000, 'ºC'),
	(265456, 118, '2014-04-01 01:05:10.000000', 'temperatura', 145.0000, 'ºC'),
	(265457, 118, '2014-04-01 01:05:11.000000', 'temperatura', 268.0000, 'ºC'),
	(265458, 118, '2014-04-01 01:05:12.000000', 'temperatura', 906.0000, 'ºC'),
	(265459, 118, '2014-04-01 01:05:13.000000', 'temperatura', 126.0000, 'ºC'),
	(265460, 118, '2014-04-01 01:05:14.000000', 'temperatura', 314.0000, 'ºC'),
	(265461, 118, '2014-04-01 01:05:15.000000', 'temperatura', 1190.0000, 'ºC'),
	(265462, 118, '2014-04-01 01:05:16.000000', 'temperatura', 212.0000, 'ºC'),
	(265463, 118, '2014-04-01 01:05:17.000000', 'temperatura', 1089.0000, 'ºC'),
	(265464, 118, '2014-04-01 01:05:18.000000', 'temperatura', 8.0000, 'ºC'),
	(265465, 118, '2014-04-01 01:05:19.000000', 'temperatura', 373.0000, 'ºC'),
	(265466, 118, '2014-04-01 01:05:20.000000', 'temperatura', 642.0000, 'ºC'),
	(265467, 118, '2014-04-01 01:05:21.000000', 'temperatura', 893.0000, 'ºC'),
	(265468, 118, '2014-04-01 01:05:22.000000', 'temperatura', 138.0000, 'ºC'),
	(265469, 118, '2014-04-01 01:05:23.000000', 'temperatura', 414.0000, 'ºC'),
	(265470, 118, '2014-04-01 01:05:24.000000', 'temperatura', 456.0000, 'ºC'),
	(265471, 118, '2014-04-01 01:05:25.000000', 'temperatura', 1036.0000, 'ºC'),
	(265472, 118, '2014-04-01 01:05:26.000000', 'temperatura', 215.0000, 'ºC'),
	(265473, 118, '2014-04-01 01:05:27.000000', 'temperatura', 368.0000, 'ºC'),
	(265474, 118, '2014-04-01 01:05:28.000000', 'temperatura', 1194.0000, 'ºC'),
	(265475, 118, '2014-04-01 01:05:29.000000', 'temperatura', 66.0000, 'ºC'),
	(265476, 118, '2014-04-01 01:05:30.000000', 'temperatura', 348.0000, 'ºC'),
	(265477, 118, '2014-04-01 01:05:31.000000', 'temperatura', 342.0000, 'ºC'),
	(265478, 118, '2014-04-01 01:05:32.000000', 'temperatura', 667.0000, 'ºC'),
	(265479, 118, '2014-04-01 01:05:33.000000', 'temperatura', 1109.0000, 'ºC'),
	(265480, 118, '2014-04-01 01:05:34.000000', 'temperatura', 1143.0000, 'ºC'),
	(265481, 118, '2014-04-01 01:05:35.000000', 'temperatura', 1192.0000, 'ºC'),
	(265482, 118, '2014-04-01 01:05:36.000000', 'temperatura', 130.0000, 'ºC'),
	(265483, 118, '2014-04-01 01:05:37.000000', 'temperatura', 674.0000, 'ºC'),
	(265484, 118, '2014-04-01 01:05:38.000000', 'temperatura', 581.0000, 'ºC'),
	(265485, 118, '2014-04-01 01:05:39.000000', 'temperatura', 882.0000, 'ºC'),
	(265486, 118, '2014-04-01 01:05:40.000000', 'temperatura', 266.0000, 'ºC'),
	(265487, 118, '2014-04-01 01:05:41.000000', 'temperatura', 1088.0000, 'ºC'),
	(265488, 118, '2014-04-01 01:05:42.000000', 'temperatura', 1042.0000, 'ºC'),
	(265489, 118, '2014-04-01 01:05:43.000000', 'temperatura', 745.0000, 'ºC'),
	(265490, 118, '2014-04-01 01:05:44.000000', 'temperatura', 602.0000, 'ºC'),
	(265491, 118, '2014-04-01 01:05:45.000000', 'temperatura', 774.0000, 'ºC'),
	(265492, 118, '2014-04-01 01:05:46.000000', 'temperatura', 864.0000, 'ºC'),
	(265493, 118, '2014-04-01 01:05:47.000000', 'temperatura', 799.0000, 'ºC'),
	(265494, 118, '2014-04-01 01:05:48.000000', 'temperatura', 203.0000, 'ºC'),
	(265495, 118, '2014-04-01 01:05:49.000000', 'temperatura', 1018.0000, 'ºC'),
	(265496, 118, '2014-04-01 01:05:50.000000', 'temperatura', 882.0000, 'ºC'),
	(265497, 118, '2014-04-01 01:05:51.000000', 'temperatura', 157.0000, 'ºC'),
	(265498, 118, '2014-04-01 01:05:52.000000', 'temperatura', 539.0000, 'ºC'),
	(265499, 118, '2014-04-01 01:05:53.000000', 'temperatura', 1025.0000, 'ºC'),
	(265500, 118, '2014-04-01 01:05:54.000000', 'temperatura', 1107.0000, 'ºC'),
	(265501, 118, '2014-04-01 01:05:55.000000', 'temperatura', 63.0000, 'ºC'),
	(265502, 118, '2014-04-01 01:05:56.000000', 'temperatura', 593.0000, 'ºC'),
	(265503, 118, '2014-04-01 01:05:57.000000', 'temperatura', 375.0000, 'ºC'),
	(265504, 118, '2014-04-01 01:05:58.000000', 'temperatura', 99.0000, 'ºC'),
	(265505, 118, '2014-04-01 01:05:59.000000', 'temperatura', 568.0000, 'ºC'),
	(265506, 118, '2014-04-01 01:06:00.000000', 'temperatura', 145.0000, 'ºC'),
	(265507, 118, '2014-04-01 01:06:01.000000', 'temperatura', 222.0000, 'ºC'),
	(265508, 118, '2014-04-01 01:06:02.000000', 'temperatura', 675.0000, 'ºC'),
	(265509, 118, '2014-04-01 01:06:03.000000', 'temperatura', 307.0000, 'ºC'),
	(265510, 118, '2014-04-01 01:06:04.000000', 'temperatura', 714.0000, 'ºC'),
	(265511, 118, '2014-04-01 01:06:05.000000', 'temperatura', 248.0000, 'ºC'),
	(265512, 118, '2014-04-01 01:06:06.000000', 'temperatura', 297.0000, 'ºC'),
	(265513, 118, '2014-04-01 01:06:07.000000', 'temperatura', 741.0000, 'ºC'),
	(265514, 118, '2014-04-01 01:06:08.000000', 'temperatura', 417.0000, 'ºC'),
	(265515, 118, '2014-04-01 01:06:09.000000', 'temperatura', 1060.0000, 'ºC'),
	(265516, 118, '2014-04-01 01:06:10.000000', 'temperatura', 450.0000, 'ºC'),
	(265517, 118, '2014-04-01 01:06:11.000000', 'temperatura', 272.0000, 'ºC'),
	(265518, 118, '2014-04-01 01:06:12.000000', 'temperatura', 10.0000, 'ºC'),
	(265519, 118, '2014-04-01 01:06:13.000000', 'temperatura', 435.0000, 'ºC'),
	(265520, 118, '2014-04-01 01:06:14.000000', 'temperatura', 945.0000, 'ºC'),
	(265521, 118, '2014-04-01 01:06:15.000000', 'temperatura', 1021.0000, 'ºC'),
	(265522, 118, '2014-04-01 01:06:16.000000', 'temperatura', 1069.0000, 'ºC'),
	(265523, 118, '2014-04-01 01:06:17.000000', 'temperatura', 1081.0000, 'ºC'),
	(265524, 118, '2014-04-01 01:06:18.000000', 'temperatura', 1001.0000, 'ºC'),
	(265525, 118, '2014-04-01 01:06:19.000000', 'temperatura', 564.0000, 'ºC'),
	(265526, 118, '2014-04-01 01:06:20.000000', 'temperatura', 1016.0000, 'ºC'),
	(265527, 118, '2014-04-01 01:06:21.000000', 'temperatura', 988.0000, 'ºC'),
	(265528, 118, '2014-04-01 01:06:22.000000', 'temperatura', 692.0000, 'ºC'),
	(265529, 118, '2014-04-01 01:06:23.000000', 'temperatura', 497.0000, 'ºC'),
	(265530, 118, '2014-04-01 01:06:24.000000', 'temperatura', 411.0000, 'ºC'),
	(265531, 118, '2014-04-01 01:06:25.000000', 'temperatura', 562.0000, 'ºC'),
	(265532, 118, '2014-04-01 01:06:26.000000', 'temperatura', 377.0000, 'ºC'),
	(265533, 118, '2014-04-01 01:06:27.000000', 'temperatura', 202.0000, 'ºC'),
	(265534, 118, '2014-04-01 01:06:28.000000', 'temperatura', 1080.0000, 'ºC'),
	(265535, 118, '2014-04-01 01:06:29.000000', 'temperatura', 1194.0000, 'ºC'),
	(265536, 118, '2014-04-01 01:06:30.000000', 'temperatura', 330.0000, 'ºC'),
	(265537, 118, '2014-04-01 01:06:31.000000', 'temperatura', 470.0000, 'ºC'),
	(265538, 118, '2014-04-01 01:06:32.000000', 'temperatura', 160.0000, 'ºC'),
	(265539, 118, '2014-04-01 01:06:33.000000', 'temperatura', 590.0000, 'ºC'),
	(265540, 118, '2014-04-01 01:06:34.000000', 'temperatura', 72.0000, 'ºC'),
	(265541, 118, '2014-04-01 01:06:35.000000', 'temperatura', 990.0000, 'ºC'),
	(265542, 118, '2014-04-01 01:06:36.000000', 'temperatura', 1133.0000, 'ºC'),
	(265543, 118, '2014-04-01 01:06:37.000000', 'temperatura', 296.0000, 'ºC'),
	(265544, 118, '2014-04-01 01:06:38.000000', 'temperatura', 482.0000, 'ºC'),
	(265545, 118, '2014-04-01 01:06:39.000000', 'temperatura', 324.0000, 'ºC'),
	(265546, 118, '2014-04-01 01:06:40.000000', 'temperatura', 174.0000, 'ºC'),
	(265547, 118, '2014-04-01 01:06:41.000000', 'temperatura', 1097.0000, 'ºC'),
	(265548, 118, '2014-04-01 01:06:42.000000', 'temperatura', 164.0000, 'ºC'),
	(265549, 118, '2014-04-01 01:06:43.000000', 'temperatura', 1128.0000, 'ºC'),
	(265550, 118, '2014-04-01 01:06:44.000000', 'temperatura', 350.0000, 'ºC'),
	(265551, 118, '2014-04-01 01:06:45.000000', 'temperatura', 764.0000, 'ºC'),
	(265552, 118, '2014-04-01 01:06:46.000000', 'temperatura', 374.0000, 'ºC'),
	(265553, 118, '2014-04-01 01:06:47.000000', 'temperatura', 776.0000, 'ºC'),
	(265554, 118, '2014-04-01 01:06:48.000000', 'temperatura', 359.0000, 'ºC'),
	(265555, 118, '2014-04-01 01:06:49.000000', 'temperatura', 666.0000, 'ºC'),
	(265556, 118, '2014-04-01 01:06:50.000000', 'temperatura', 1056.0000, 'ºC'),
	(265557, 118, '2014-04-01 01:06:51.000000', 'temperatura', 880.0000, 'ºC'),
	(265558, 118, '2014-04-01 01:06:52.000000', 'temperatura', 32.0000, 'ºC'),
	(265559, 118, '2014-04-01 01:06:53.000000', 'temperatura', 1122.0000, 'ºC'),
	(265560, 118, '2014-04-01 01:06:54.000000', 'temperatura', 716.0000, 'ºC'),
	(265561, 118, '2014-04-01 01:06:55.000000', 'temperatura', 213.0000, 'ºC'),
	(265562, 118, '2014-04-01 01:06:56.000000', 'temperatura', 116.0000, 'ºC'),
	(265563, 118, '2014-04-01 01:06:57.000000', 'temperatura', 1141.0000, 'ºC'),
	(265564, 118, '2014-04-01 01:06:58.000000', 'temperatura', 558.0000, 'ºC'),
	(265565, 118, '2014-04-01 01:06:59.000000', 'temperatura', 566.0000, 'ºC'),
	(265566, 118, '2014-04-01 01:07:00.000000', 'temperatura', 1158.0000, 'ºC'),
	(265567, 118, '2014-04-01 01:07:01.000000', 'temperatura', 492.0000, 'ºC'),
	(265568, 118, '2014-04-01 01:07:02.000000', 'temperatura', 188.0000, 'ºC'),
	(265569, 118, '2014-04-01 01:07:03.000000', 'temperatura', 663.0000, 'ºC'),
	(265570, 118, '2014-04-01 01:07:04.000000', 'temperatura', 350.0000, 'ºC'),
	(265571, 118, '2014-04-01 01:07:05.000000', 'temperatura', 963.0000, 'ºC'),
	(265572, 118, '2014-04-01 01:07:06.000000', 'temperatura', 164.0000, 'ºC'),
	(265573, 118, '2014-04-01 01:07:07.000000', 'temperatura', 331.0000, 'ºC'),
	(265574, 118, '2014-04-01 01:07:08.000000', 'temperatura', 1166.0000, 'ºC'),
	(265575, 118, '2014-04-01 01:07:09.000000', 'temperatura', 37.0000, 'ºC'),
	(265576, 118, '2014-04-01 01:07:10.000000', 'temperatura', 285.0000, 'ºC'),
	(265577, 118, '2014-04-01 01:07:11.000000', 'temperatura', 118.0000, 'ºC'),
	(265578, 118, '2014-04-01 01:07:12.000000', 'temperatura', 934.0000, 'ºC'),
	(265579, 118, '2014-04-01 01:07:13.000000', 'temperatura', 718.0000, 'ºC'),
	(265580, 118, '2014-04-01 01:07:14.000000', 'temperatura', 788.0000, 'ºC'),
	(265581, 118, '2014-04-01 01:07:15.000000', 'temperatura', 588.0000, 'ºC'),
	(265582, 118, '2014-04-01 01:07:16.000000', 'temperatura', 576.0000, 'ºC'),
	(265583, 118, '2014-04-01 01:07:17.000000', 'temperatura', 1117.0000, 'ºC'),
	(265584, 118, '2014-04-01 01:07:18.000000', 'temperatura', 258.0000, 'ºC'),
	(265585, 118, '2014-04-01 01:07:19.000000', 'temperatura', 340.0000, 'ºC'),
	(265586, 118, '2014-04-01 01:07:20.000000', 'temperatura', 924.0000, 'ºC'),
	(265587, 118, '2014-04-01 01:07:21.000000', 'temperatura', 0.0000, 'ºC'),
	(265588, 118, '2014-04-01 01:07:22.000000', 'temperatura', 831.0000, 'ºC'),
	(265589, 118, '2014-04-01 01:07:23.000000', 'temperatura', 553.0000, 'ºC'),
	(265590, 118, '2014-04-01 01:07:24.000000', 'temperatura', 272.0000, 'ºC'),
	(265591, 118, '2014-04-01 01:07:25.000000', 'temperatura', 902.0000, 'ºC'),
	(265592, 118, '2014-04-01 01:07:26.000000', 'temperatura', 95.0000, 'ºC'),
	(265593, 118, '2014-04-01 01:07:27.000000', 'temperatura', 171.0000, 'ºC'),
	(265594, 118, '2014-04-01 01:07:28.000000', 'temperatura', 568.0000, 'ºC'),
	(265595, 118, '2014-04-01 01:07:29.000000', 'temperatura', 1129.0000, 'ºC'),
	(265596, 118, '2014-04-01 01:07:30.000000', 'temperatura', 343.0000, 'ºC'),
	(265597, 118, '2014-04-01 01:07:31.000000', 'temperatura', 726.0000, 'ºC'),
	(265598, 118, '2014-04-01 01:07:32.000000', 'temperatura', 201.0000, 'ºC'),
	(265599, 118, '2014-04-01 01:07:33.000000', 'temperatura', 28.0000, 'ºC'),
	(265600, 118, '2014-04-01 01:07:34.000000', 'temperatura', 736.0000, 'ºC'),
	(265601, 118, '2014-04-01 01:07:35.000000', 'temperatura', 1198.0000, 'ºC'),
	(265602, 118, '2014-04-01 01:07:36.000000', 'temperatura', 183.0000, 'ºC'),
	(265603, 118, '2014-04-01 01:07:37.000000', 'temperatura', 922.0000, 'ºC'),
	(265604, 118, '2014-04-01 01:07:38.000000', 'temperatura', 462.0000, 'ºC'),
	(265605, 118, '2014-04-01 01:07:39.000000', 'temperatura', 742.0000, 'ºC'),
	(265606, 118, '2014-04-01 01:07:40.000000', 'temperatura', 1128.0000, 'ºC'),
	(265607, 118, '2014-04-01 01:07:41.000000', 'temperatura', 1011.0000, 'ºC'),
	(265608, 118, '2014-04-01 01:07:42.000000', 'temperatura', 474.0000, 'ºC'),
	(265609, 118, '2014-04-01 01:07:43.000000', 'temperatura', 538.0000, 'ºC'),
	(265610, 118, '2014-04-01 01:07:44.000000', 'temperatura', 68.0000, 'ºC'),
	(265611, 118, '2014-04-01 01:07:45.000000', 'temperatura', 1125.0000, 'ºC'),
	(265612, 118, '2014-04-01 01:07:46.000000', 'temperatura', 624.0000, 'ºC'),
	(265613, 118, '2014-04-01 01:07:47.000000', 'temperatura', 944.0000, 'ºC'),
	(265614, 118, '2014-04-01 01:07:48.000000', 'temperatura', 448.0000, 'ºC'),
	(265615, 118, '2014-04-01 01:07:49.000000', 'temperatura', 610.0000, 'ºC'),
	(265616, 118, '2014-04-01 01:07:50.000000', 'temperatura', 507.0000, 'ºC'),
	(265617, 118, '2014-04-01 01:07:51.000000', 'temperatura', 703.0000, 'ºC'),
	(265618, 118, '2014-04-01 01:07:52.000000', 'temperatura', 796.0000, 'ºC'),
	(265619, 118, '2014-04-01 01:07:53.000000', 'temperatura', 672.0000, 'ºC'),
	(265620, 118, '2014-04-01 01:07:54.000000', 'temperatura', 971.0000, 'ºC'),
	(265621, 118, '2014-04-01 01:07:55.000000', 'temperatura', 440.0000, 'ºC'),
	(265622, 118, '2014-04-01 01:07:56.000000', 'temperatura', 489.0000, 'ºC'),
	(265623, 118, '2014-04-01 01:07:57.000000', 'temperatura', 1125.0000, 'ºC'),
	(265624, 118, '2014-04-01 01:07:58.000000', 'temperatura', 559.0000, 'ºC'),
	(265625, 118, '2014-04-01 01:07:59.000000', 'temperatura', 622.0000, 'ºC'),
	(265626, 118, '2014-04-01 01:08:00.000000', 'temperatura', 230.0000, 'ºC'),
	(265627, 118, '2014-04-01 01:08:01.000000', 'temperatura', 486.0000, 'ºC'),
	(265628, 118, '2014-04-01 01:08:02.000000', 'temperatura', 542.0000, 'ºC'),
	(265629, 118, '2014-04-01 01:08:03.000000', 'temperatura', 53.0000, 'ºC'),
	(265630, 118, '2014-04-01 01:08:04.000000', 'temperatura', 1039.0000, 'ºC'),
	(265631, 118, '2014-04-01 01:08:05.000000', 'temperatura', 237.0000, 'ºC'),
	(265632, 118, '2014-04-01 01:08:06.000000', 'temperatura', 468.0000, 'ºC'),
	(265633, 118, '2014-04-01 01:08:07.000000', 'temperatura', 429.0000, 'ºC'),
	(265634, 118, '2014-04-01 01:08:08.000000', 'temperatura', 742.0000, 'ºC'),
	(265635, 118, '2014-04-01 01:08:09.000000', 'temperatura', 25.0000, 'ºC'),
	(265636, 118, '2014-04-01 01:08:10.000000', 'temperatura', 297.0000, 'ºC'),
	(265637, 118, '2014-04-01 01:08:11.000000', 'temperatura', 210.0000, 'ºC'),
	(265638, 118, '2014-04-01 01:08:12.000000', 'temperatura', 161.0000, 'ºC'),
	(265639, 118, '2014-04-01 01:08:13.000000', 'temperatura', 174.0000, 'ºC'),
	(265640, 118, '2014-04-01 01:08:14.000000', 'temperatura', 387.0000, 'ºC'),
	(265641, 118, '2014-04-01 01:08:15.000000', 'temperatura', 213.0000, 'ºC'),
	(265642, 118, '2014-04-01 01:08:16.000000', 'temperatura', 1104.0000, 'ºC'),
	(265643, 118, '2014-04-01 01:08:17.000000', 'temperatura', 83.0000, 'ºC'),
	(265644, 118, '2014-04-01 01:08:18.000000', 'temperatura', 702.0000, 'ºC'),
	(265645, 118, '2014-04-01 01:08:19.000000', 'temperatura', 860.0000, 'ºC'),
	(265646, 118, '2014-04-01 01:08:20.000000', 'temperatura', 997.0000, 'ºC'),
	(265647, 118, '2014-04-01 01:08:21.000000', 'temperatura', 5.0000, 'ºC'),
	(265648, 118, '2014-04-01 01:08:22.000000', 'temperatura', 636.0000, 'ºC'),
	(265649, 118, '2014-04-01 01:08:23.000000', 'temperatura', 765.0000, 'ºC'),
	(265650, 118, '2014-04-01 01:08:24.000000', 'temperatura', 717.0000, 'ºC'),
	(265651, 118, '2014-04-01 01:08:25.000000', 'temperatura', 89.0000, 'ºC'),
	(265652, 118, '2014-04-01 01:08:26.000000', 'temperatura', 696.0000, 'ºC'),
	(265653, 118, '2014-04-01 01:08:27.000000', 'temperatura', 815.0000, 'ºC'),
	(265654, 118, '2014-04-01 01:08:28.000000', 'temperatura', 785.0000, 'ºC'),
	(265655, 118, '2014-04-01 01:08:29.000000', 'temperatura', 283.0000, 'ºC'),
	(265656, 118, '2014-04-01 01:08:30.000000', 'temperatura', 260.0000, 'ºC'),
	(265657, 118, '2014-04-01 01:08:31.000000', 'temperatura', 451.0000, 'ºC'),
	(265658, 118, '2014-04-01 01:08:32.000000', 'temperatura', 275.0000, 'ºC'),
	(265659, 118, '2014-04-01 01:08:33.000000', 'temperatura', 22.0000, 'ºC'),
	(265660, 118, '2014-04-01 01:08:34.000000', 'temperatura', 487.0000, 'ºC'),
	(265661, 118, '2014-04-01 01:08:35.000000', 'temperatura', 1169.0000, 'ºC'),
	(265662, 118, '2014-04-01 01:08:36.000000', 'temperatura', 783.0000, 'ºC'),
	(265663, 118, '2014-04-01 01:08:37.000000', 'temperatura', 408.0000, 'ºC'),
	(265664, 118, '2014-04-01 01:08:38.000000', 'temperatura', 891.0000, 'ºC'),
	(265665, 118, '2014-04-01 01:08:39.000000', 'temperatura', 834.0000, 'ºC'),
	(265666, 118, '2014-04-01 01:08:40.000000', 'temperatura', 298.0000, 'ºC'),
	(265667, 118, '2014-04-01 01:08:41.000000', 'temperatura', 186.0000, 'ºC'),
	(265668, 118, '2014-04-01 01:08:42.000000', 'temperatura', 37.0000, 'ºC'),
	(265669, 118, '2014-04-01 01:08:43.000000', 'temperatura', 830.0000, 'ºC'),
	(265670, 118, '2014-04-01 01:08:44.000000', 'temperatura', 437.0000, 'ºC'),
	(265671, 118, '2014-04-01 01:08:45.000000', 'temperatura', 898.0000, 'ºC'),
	(265672, 118, '2014-04-01 01:08:46.000000', 'temperatura', 777.0000, 'ºC'),
	(265673, 118, '2014-04-01 01:08:47.000000', 'temperatura', 1194.0000, 'ºC'),
	(265674, 118, '2014-04-01 01:08:48.000000', 'temperatura', 38.0000, 'ºC'),
	(265675, 118, '2014-04-01 01:08:49.000000', 'temperatura', 209.0000, 'ºC'),
	(265676, 118, '2014-04-01 01:08:50.000000', 'temperatura', 931.0000, 'ºC'),
	(265677, 118, '2014-04-01 01:08:51.000000', 'temperatura', 427.0000, 'ºC'),
	(265678, 118, '2014-04-01 01:08:52.000000', 'temperatura', 545.0000, 'ºC'),
	(265679, 118, '2014-04-01 01:08:53.000000', 'temperatura', 246.0000, 'ºC'),
	(265680, 118, '2014-04-01 01:08:54.000000', 'temperatura', 792.0000, 'ºC'),
	(265681, 118, '2014-04-01 01:08:55.000000', 'temperatura', 824.0000, 'ºC'),
	(265682, 118, '2014-04-01 01:08:56.000000', 'temperatura', 543.0000, 'ºC'),
	(265683, 118, '2014-04-01 01:08:57.000000', 'temperatura', 243.0000, 'ºC'),
	(265684, 118, '2014-04-01 01:08:58.000000', 'temperatura', 787.0000, 'ºC'),
	(265685, 118, '2014-04-01 01:08:59.000000', 'temperatura', 808.0000, 'ºC'),
	(265686, 118, '2014-04-01 01:09:00.000000', 'temperatura', 479.0000, 'ºC'),
	(265687, 118, '2014-04-01 01:09:01.000000', 'temperatura', 1170.0000, 'ºC'),
	(265688, 118, '2014-04-01 01:09:02.000000', 'temperatura', 817.0000, 'ºC'),
	(265689, 118, '2014-04-01 01:09:03.000000', 'temperatura', 572.0000, 'ºC'),
	(265690, 118, '2014-04-01 01:09:04.000000', 'temperatura', 409.0000, 'ºC'),
	(265691, 118, '2014-04-01 01:09:05.000000', 'temperatura', 332.0000, 'ºC'),
	(265692, 118, '2014-04-01 01:09:06.000000', 'temperatura', 433.0000, 'ºC'),
	(265693, 118, '2014-04-01 01:09:07.000000', 'temperatura', 1170.0000, 'ºC'),
	(265694, 118, '2014-04-01 01:09:08.000000', 'temperatura', 949.0000, 'ºC'),
	(265695, 118, '2014-04-01 01:09:09.000000', 'temperatura', 39.0000, 'ºC'),
	(265696, 118, '2014-04-01 01:09:10.000000', 'temperatura', 946.0000, 'ºC'),
	(265697, 118, '2014-04-01 01:09:11.000000', 'temperatura', 1013.0000, 'ºC'),
	(265698, 118, '2014-04-01 01:09:12.000000', 'temperatura', 1027.0000, 'ºC'),
	(265699, 118, '2014-04-01 01:09:13.000000', 'temperatura', 898.0000, 'ºC'),
	(265700, 118, '2014-04-01 01:09:14.000000', 'temperatura', 208.0000, 'ºC'),
	(265701, 118, '2014-04-01 01:09:15.000000', 'temperatura', 747.0000, 'ºC'),
	(265702, 118, '2014-04-01 01:09:16.000000', 'temperatura', 710.0000, 'ºC'),
	(265703, 118, '2014-04-01 01:09:17.000000', 'temperatura', 112.0000, 'ºC'),
	(265704, 118, '2014-04-01 01:09:18.000000', 'temperatura', 828.0000, 'ºC'),
	(265705, 118, '2014-04-01 01:09:19.000000', 'temperatura', 206.0000, 'ºC'),
	(265706, 118, '2014-04-01 01:09:20.000000', 'temperatura', 946.0000, 'ºC'),
	(265707, 118, '2014-04-01 01:09:21.000000', 'temperatura', 512.0000, 'ºC'),
	(265708, 118, '2014-04-01 01:09:22.000000', 'temperatura', 923.0000, 'ºC'),
	(265709, 118, '2014-04-01 01:09:23.000000', 'temperatura', 680.0000, 'ºC'),
	(265710, 118, '2014-04-01 01:09:24.000000', 'temperatura', 632.0000, 'ºC'),
	(265711, 118, '2014-04-01 01:09:25.000000', 'temperatura', 1121.0000, 'ºC'),
	(265712, 118, '2014-04-01 01:09:26.000000', 'temperatura', 108.0000, 'ºC'),
	(265713, 118, '2014-04-01 01:09:27.000000', 'temperatura', 777.0000, 'ºC'),
	(265714, 118, '2014-04-01 01:09:28.000000', 'temperatura', 1164.0000, 'ºC'),
	(265715, 118, '2014-04-01 01:09:29.000000', 'temperatura', 1086.0000, 'ºC'),
	(265716, 118, '2014-04-01 01:09:30.000000', 'temperatura', 741.0000, 'ºC'),
	(265717, 118, '2014-04-01 01:09:31.000000', 'temperatura', 448.0000, 'ºC'),
	(265718, 118, '2014-04-01 01:09:32.000000', 'temperatura', 17.0000, 'ºC'),
	(265719, 118, '2014-04-01 01:09:33.000000', 'temperatura', 1141.0000, 'ºC'),
	(265720, 118, '2014-04-01 01:09:34.000000', 'temperatura', 853.0000, 'ºC'),
	(265721, 118, '2014-04-01 01:09:35.000000', 'temperatura', 844.0000, 'ºC'),
	(265722, 118, '2014-04-01 01:09:36.000000', 'temperatura', 462.0000, 'ºC'),
	(265723, 118, '2014-04-01 01:09:37.000000', 'temperatura', 977.0000, 'ºC'),
	(265724, 118, '2014-04-01 01:09:38.000000', 'temperatura', 1102.0000, 'ºC'),
	(265725, 118, '2014-04-01 01:09:39.000000', 'temperatura', 177.0000, 'ºC'),
	(265726, 118, '2014-04-01 01:09:40.000000', 'temperatura', 1180.0000, 'ºC'),
	(265727, 118, '2014-04-01 01:09:41.000000', 'temperatura', 569.0000, 'ºC'),
	(265728, 118, '2014-04-01 01:09:42.000000', 'temperatura', 506.0000, 'ºC'),
	(265729, 118, '2014-04-01 01:09:43.000000', 'temperatura', 825.0000, 'ºC'),
	(265730, 118, '2014-04-01 01:09:44.000000', 'temperatura', 205.0000, 'ºC'),
	(265731, 118, '2014-04-01 01:09:45.000000', 'temperatura', 952.0000, 'ºC'),
	(265732, 118, '2014-04-01 01:09:46.000000', 'temperatura', 545.0000, 'ºC'),
	(265733, 118, '2014-04-01 01:09:47.000000', 'temperatura', 1068.0000, 'ºC'),
	(265734, 118, '2014-04-01 01:09:48.000000', 'temperatura', 108.0000, 'ºC'),
	(265735, 118, '2014-04-01 01:09:49.000000', 'temperatura', 935.0000, 'ºC'),
	(265736, 118, '2014-04-01 01:09:50.000000', 'temperatura', 752.0000, 'ºC'),
	(265737, 118, '2014-04-01 01:09:51.000000', 'temperatura', 957.0000, 'ºC'),
	(265738, 118, '2014-04-01 01:09:52.000000', 'temperatura', 127.0000, 'ºC'),
	(265739, 118, '2014-04-01 01:09:53.000000', 'temperatura', 164.0000, 'ºC'),
	(265740, 118, '2014-04-01 01:09:54.000000', 'temperatura', 439.0000, 'ºC'),
	(265741, 118, '2014-04-01 01:09:55.000000', 'temperatura', 503.0000, 'ºC'),
	(265742, 118, '2014-04-01 01:09:56.000000', 'temperatura', 1.0000, 'ºC'),
	(265743, 118, '2014-04-01 01:09:57.000000', 'temperatura', 896.0000, 'ºC'),
	(265744, 118, '2014-04-01 01:09:58.000000', 'temperatura', 876.0000, 'ºC'),
	(265745, 118, '2014-04-01 01:09:59.000000', 'temperatura', 493.0000, 'ºC'),
	(265746, 118, '2014-04-01 01:10:00.000000', 'temperatura', 1040.0000, 'ºC'),
	(265747, 118, '2014-04-01 01:10:01.000000', 'temperatura', 118.0000, 'ºC'),
	(265748, 118, '2014-04-01 01:10:02.000000', 'temperatura', 1071.0000, 'ºC'),
	(265749, 118, '2014-04-01 01:10:03.000000', 'temperatura', 203.0000, 'ºC'),
	(265750, 118, '2014-04-01 01:10:04.000000', 'temperatura', 203.0000, 'ºC'),
	(265751, 118, '2014-04-01 01:10:05.000000', 'temperatura', 404.0000, 'ºC'),
	(265752, 118, '2014-04-01 01:10:06.000000', 'temperatura', 212.0000, 'ºC'),
	(265753, 118, '2014-04-01 01:10:07.000000', 'temperatura', 1048.0000, 'ºC'),
	(265754, 118, '2014-04-01 01:10:08.000000', 'temperatura', 1004.0000, 'ºC'),
	(265755, 118, '2014-04-01 01:10:09.000000', 'temperatura', 678.0000, 'ºC'),
	(265756, 118, '2014-04-01 01:10:10.000000', 'temperatura', 376.0000, 'ºC'),
	(265757, 118, '2014-04-01 01:10:11.000000', 'temperatura', 1048.0000, 'ºC'),
	(265758, 118, '2014-04-01 01:10:12.000000', 'temperatura', 512.0000, 'ºC'),
	(265759, 118, '2014-04-01 01:10:13.000000', 'temperatura', 617.0000, 'ºC'),
	(265760, 118, '2014-04-01 01:10:14.000000', 'temperatura', 350.0000, 'ºC'),
	(265761, 118, '2014-04-01 01:10:15.000000', 'temperatura', 1098.0000, 'ºC'),
	(265762, 118, '2014-04-01 01:10:16.000000', 'temperatura', 842.0000, 'ºC'),
	(265763, 118, '2014-04-01 01:10:17.000000', 'temperatura', 914.0000, 'ºC'),
	(265764, 118, '2014-04-01 01:10:18.000000', 'temperatura', 847.0000, 'ºC'),
	(265765, 118, '2014-04-01 01:10:19.000000', 'temperatura', 291.0000, 'ºC'),
	(265766, 118, '2014-04-01 01:10:20.000000', 'temperatura', 115.0000, 'ºC'),
	(265767, 118, '2014-04-01 01:10:21.000000', 'temperatura', 904.0000, 'ºC'),
	(265768, 118, '2014-04-01 01:10:22.000000', 'temperatura', 576.0000, 'ºC'),
	(265769, 118, '2014-04-01 01:10:23.000000', 'temperatura', 168.0000, 'ºC'),
	(265770, 118, '2014-04-01 01:10:24.000000', 'temperatura', 314.0000, 'ºC'),
	(265771, 118, '2014-04-01 01:10:25.000000', 'temperatura', 1066.0000, 'ºC'),
	(265772, 118, '2014-04-01 01:10:26.000000', 'temperatura', 789.0000, 'ºC'),
	(265773, 118, '2014-04-01 01:10:27.000000', 'temperatura', 749.0000, 'ºC'),
	(265774, 118, '2014-04-01 01:10:28.000000', 'temperatura', 175.0000, 'ºC'),
	(265775, 118, '2014-04-01 01:10:29.000000', 'temperatura', 1030.0000, 'ºC'),
	(265776, 118, '2014-04-01 01:10:30.000000', 'temperatura', 1025.0000, 'ºC'),
	(265777, 118, '2014-04-01 01:10:31.000000', 'temperatura', 837.0000, 'ºC'),
	(265778, 118, '2014-04-01 01:10:32.000000', 'temperatura', 1108.0000, 'ºC'),
	(265779, 118, '2014-04-01 01:10:33.000000', 'temperatura', 632.0000, 'ºC'),
	(265780, 118, '2014-04-01 01:10:34.000000', 'temperatura', 1037.0000, 'ºC'),
	(265781, 118, '2014-04-01 01:10:35.000000', 'temperatura', 889.0000, 'ºC'),
	(265782, 118, '2014-04-01 01:10:36.000000', 'temperatura', 136.0000, 'ºC'),
	(265783, 118, '2014-04-01 01:10:37.000000', 'temperatura', 411.0000, 'ºC'),
	(265784, 118, '2014-04-01 01:10:38.000000', 'temperatura', 449.0000, 'ºC'),
	(265785, 118, '2014-04-01 01:10:39.000000', 'temperatura', 1012.0000, 'ºC'),
	(265786, 118, '2014-04-01 01:10:40.000000', 'temperatura', 115.0000, 'ºC'),
	(265787, 118, '2014-04-01 01:10:41.000000', 'temperatura', 1137.0000, 'ºC'),
	(265788, 118, '2014-04-01 01:10:42.000000', 'temperatura', 540.0000, 'ºC'),
	(265789, 118, '2014-04-01 01:10:43.000000', 'temperatura', 490.0000, 'ºC'),
	(265790, 118, '2014-04-01 01:10:44.000000', 'temperatura', 830.0000, 'ºC'),
	(265791, 118, '2014-04-01 01:10:45.000000', 'temperatura', 283.0000, 'ºC'),
	(265792, 118, '2014-04-01 01:10:46.000000', 'temperatura', 122.0000, 'ºC'),
	(265793, 118, '2014-04-01 01:10:47.000000', 'temperatura', 965.0000, 'ºC'),
	(265794, 118, '2014-04-01 01:10:48.000000', 'temperatura', 858.0000, 'ºC'),
	(265795, 118, '2014-04-01 01:10:49.000000', 'temperatura', 194.0000, 'ºC'),
	(265796, 118, '2014-04-01 01:10:50.000000', 'temperatura', 799.0000, 'ºC'),
	(265797, 118, '2014-04-01 01:10:51.000000', 'temperatura', 1015.0000, 'ºC'),
	(265798, 118, '2014-04-01 01:10:52.000000', 'temperatura', 275.0000, 'ºC'),
	(265799, 118, '2014-04-01 01:10:53.000000', 'temperatura', 732.0000, 'ºC'),
	(265800, 118, '2014-04-01 01:10:54.000000', 'temperatura', 437.0000, 'ºC'),
	(265801, 118, '2014-04-01 01:10:55.000000', 'temperatura', 1190.0000, 'ºC'),
	(265802, 118, '2014-04-01 01:10:56.000000', 'temperatura', 1040.0000, 'ºC'),
	(265803, 118, '2014-04-01 01:10:57.000000', 'temperatura', 427.0000, 'ºC'),
	(265804, 118, '2014-04-01 01:10:58.000000', 'temperatura', 219.0000, 'ºC'),
	(265805, 118, '2014-04-01 01:10:59.000000', 'temperatura', 1014.0000, 'ºC'),
	(265806, 118, '2014-04-01 01:11:00.000000', 'temperatura', 812.0000, 'ºC'),
	(265807, 118, '2014-04-01 01:11:01.000000', 'temperatura', 1019.0000, 'ºC'),
	(265808, 118, '2014-04-01 01:11:02.000000', 'temperatura', 259.0000, 'ºC'),
	(265809, 118, '2014-04-01 01:11:03.000000', 'temperatura', 640.0000, 'ºC'),
	(265810, 118, '2014-04-01 01:11:04.000000', 'temperatura', 21.0000, 'ºC'),
	(265811, 118, '2014-04-01 01:11:05.000000', 'temperatura', 586.0000, 'ºC'),
	(265812, 118, '2014-04-01 01:11:06.000000', 'temperatura', 468.0000, 'ºC'),
	(265813, 118, '2014-04-01 01:11:07.000000', 'temperatura', 582.0000, 'ºC'),
	(265814, 118, '2014-04-01 01:11:08.000000', 'temperatura', 308.0000, 'ºC'),
	(265815, 118, '2014-04-01 01:11:09.000000', 'temperatura', 993.0000, 'ºC'),
	(265816, 118, '2014-04-01 01:11:10.000000', 'temperatura', 442.0000, 'ºC'),
	(265817, 118, '2014-04-01 01:11:11.000000', 'temperatura', 433.0000, 'ºC'),
	(265818, 118, '2014-04-01 01:11:12.000000', 'temperatura', 841.0000, 'ºC'),
	(265819, 118, '2014-04-01 01:11:13.000000', 'temperatura', 503.0000, 'ºC'),
	(265820, 118, '2014-04-01 01:11:14.000000', 'temperatura', 1193.0000, 'ºC'),
	(265821, 118, '2014-04-01 01:11:15.000000', 'temperatura', 856.0000, 'ºC'),
	(265822, 118, '2014-04-01 01:11:16.000000', 'temperatura', 700.0000, 'ºC'),
	(265823, 118, '2014-04-01 01:11:17.000000', 'temperatura', 935.0000, 'ºC'),
	(265824, 118, '2014-04-01 01:11:18.000000', 'temperatura', 177.0000, 'ºC'),
	(265825, 118, '2014-04-01 01:11:19.000000', 'temperatura', 479.0000, 'ºC'),
	(265826, 118, '2014-04-01 01:11:20.000000', 'temperatura', 663.0000, 'ºC'),
	(265827, 118, '2014-04-01 01:11:21.000000', 'temperatura', 678.0000, 'ºC'),
	(265828, 118, '2014-04-01 01:11:22.000000', 'temperatura', 205.0000, 'ºC'),
	(265829, 118, '2014-04-01 01:11:23.000000', 'temperatura', 188.0000, 'ºC'),
	(265830, 118, '2014-04-01 01:11:24.000000', 'temperatura', 326.0000, 'ºC'),
	(265831, 118, '2014-04-01 01:11:25.000000', 'temperatura', 1067.0000, 'ºC'),
	(265832, 118, '2014-04-01 01:11:26.000000', 'temperatura', 758.0000, 'ºC'),
	(265833, 118, '2014-04-01 01:11:27.000000', 'temperatura', 591.0000, 'ºC'),
	(265834, 118, '2014-04-01 01:11:28.000000', 'temperatura', 680.0000, 'ºC'),
	(265835, 118, '2014-04-01 01:11:29.000000', 'temperatura', 430.0000, 'ºC'),
	(265836, 118, '2014-04-01 01:11:30.000000', 'temperatura', 107.0000, 'ºC'),
	(265837, 118, '2014-04-01 01:11:31.000000', 'temperatura', 449.0000, 'ºC'),
	(265838, 118, '2014-04-01 01:11:32.000000', 'temperatura', 721.0000, 'ºC'),
	(265839, 118, '2014-04-01 01:11:33.000000', 'temperatura', 1062.0000, 'ºC'),
	(265840, 118, '2014-04-01 01:11:34.000000', 'temperatura', 744.0000, 'ºC'),
	(265841, 118, '2014-04-01 01:11:35.000000', 'temperatura', 535.0000, 'ºC'),
	(265842, 118, '2014-04-01 01:11:36.000000', 'temperatura', 446.0000, 'ºC'),
	(265843, 118, '2014-04-01 01:11:37.000000', 'temperatura', 625.0000, 'ºC'),
	(265844, 118, '2014-04-01 01:11:38.000000', 'temperatura', 586.0000, 'ºC'),
	(265845, 118, '2014-04-01 01:11:39.000000', 'temperatura', 1056.0000, 'ºC'),
	(265846, 118, '2014-04-01 01:11:40.000000', 'temperatura', 1124.0000, 'ºC'),
	(265847, 118, '2014-04-01 01:11:41.000000', 'temperatura', 53.0000, 'ºC'),
	(265848, 118, '2014-04-01 01:11:42.000000', 'temperatura', 490.0000, 'ºC'),
	(265849, 118, '2014-04-01 01:11:43.000000', 'temperatura', 1095.0000, 'ºC'),
	(265850, 118, '2014-04-01 01:11:44.000000', 'temperatura', 403.0000, 'ºC'),
	(265851, 118, '2014-04-01 01:11:45.000000', 'temperatura', 1133.0000, 'ºC'),
	(265852, 118, '2014-04-01 01:11:46.000000', 'temperatura', 855.0000, 'ºC'),
	(265853, 118, '2014-04-01 01:11:47.000000', 'temperatura', 877.0000, 'ºC'),
	(265854, 118, '2014-04-01 01:11:48.000000', 'temperatura', 621.0000, 'ºC'),
	(265855, 118, '2014-04-01 01:11:49.000000', 'temperatura', 476.0000, 'ºC'),
	(265856, 118, '2014-04-01 01:11:50.000000', 'temperatura', 515.0000, 'ºC'),
	(265857, 118, '2014-04-01 01:11:51.000000', 'temperatura', 1149.0000, 'ºC'),
	(265858, 118, '2014-04-01 01:11:52.000000', 'temperatura', 602.0000, 'ºC'),
	(265859, 118, '2014-04-01 01:11:53.000000', 'temperatura', 760.0000, 'ºC'),
	(265860, 118, '2014-04-01 01:11:54.000000', 'temperatura', 797.0000, 'ºC'),
	(265861, 118, '2014-04-01 01:11:55.000000', 'temperatura', 507.0000, 'ºC'),
	(265862, 118, '2014-04-01 01:11:56.000000', 'temperatura', 141.0000, 'ºC'),
	(265863, 118, '2014-04-01 01:11:57.000000', 'temperatura', 386.0000, 'ºC'),
	(265864, 118, '2014-04-01 01:11:58.000000', 'temperatura', 306.0000, 'ºC'),
	(265865, 118, '2014-04-01 01:11:59.000000', 'temperatura', 373.0000, 'ºC'),
	(265866, 118, '2014-04-01 01:12:00.000000', 'temperatura', 947.0000, 'ºC'),
	(265867, 118, '2014-04-01 01:12:01.000000', 'temperatura', 19.0000, 'ºC'),
	(265868, 118, '2014-04-01 01:12:02.000000', 'temperatura', 854.0000, 'ºC'),
	(265869, 118, '2014-04-01 01:12:03.000000', 'temperatura', 613.0000, 'ºC'),
	(265870, 118, '2014-04-01 01:12:04.000000', 'temperatura', 503.0000, 'ºC'),
	(265871, 118, '2014-04-01 01:12:05.000000', 'temperatura', 675.0000, 'ºC'),
	(265872, 118, '2014-04-01 01:12:06.000000', 'temperatura', 667.0000, 'ºC'),
	(265873, 118, '2014-04-01 01:12:07.000000', 'temperatura', 109.0000, 'ºC'),
	(265874, 118, '2014-04-01 01:12:08.000000', 'temperatura', 946.0000, 'ºC'),
	(265875, 118, '2014-04-01 01:12:09.000000', 'temperatura', 805.0000, 'ºC'),
	(265876, 118, '2014-04-01 01:12:10.000000', 'temperatura', 1185.0000, 'ºC'),
	(265877, 118, '2014-04-01 01:12:11.000000', 'temperatura', 1112.0000, 'ºC'),
	(265878, 118, '2014-04-01 01:12:12.000000', 'temperatura', 805.0000, 'ºC'),
	(265879, 118, '2014-04-01 01:12:13.000000', 'temperatura', 691.0000, 'ºC'),
	(265880, 118, '2014-04-01 01:12:14.000000', 'temperatura', 1040.0000, 'ºC'),
	(265881, 118, '2014-04-01 01:12:15.000000', 'temperatura', 727.0000, 'ºC'),
	(265882, 118, '2014-04-01 01:12:16.000000', 'temperatura', 517.0000, 'ºC'),
	(265883, 118, '2014-04-01 01:12:17.000000', 'temperatura', 406.0000, 'ºC'),
	(265884, 118, '2014-04-01 01:12:18.000000', 'temperatura', 476.0000, 'ºC'),
	(265885, 118, '2014-04-01 01:12:19.000000', 'temperatura', 1163.0000, 'ºC'),
	(265886, 118, '2014-04-01 01:12:20.000000', 'temperatura', 789.0000, 'ºC'),
	(265887, 118, '2014-04-01 01:12:21.000000', 'temperatura', 456.0000, 'ºC'),
	(265888, 118, '2014-04-01 01:12:22.000000', 'temperatura', 1114.0000, 'ºC'),
	(265889, 118, '2014-04-01 01:12:23.000000', 'temperatura', 604.0000, 'ºC'),
	(265890, 118, '2014-04-01 01:12:24.000000', 'temperatura', 876.0000, 'ºC'),
	(265891, 118, '2014-04-01 01:12:25.000000', 'temperatura', 170.0000, 'ºC'),
	(265892, 118, '2014-04-01 01:12:26.000000', 'temperatura', 620.0000, 'ºC'),
	(265893, 118, '2014-04-01 01:12:27.000000', 'temperatura', 193.0000, 'ºC'),
	(265894, 118, '2014-04-01 01:12:28.000000', 'temperatura', 307.0000, 'ºC'),
	(265895, 118, '2014-04-01 01:12:29.000000', 'temperatura', 954.0000, 'ºC'),
	(265896, 118, '2014-04-01 01:12:30.000000', 'temperatura', 250.0000, 'ºC'),
	(265897, 118, '2014-04-01 01:12:31.000000', 'temperatura', 787.0000, 'ºC'),
	(265898, 118, '2014-04-01 01:12:32.000000', 'temperatura', 788.0000, 'ºC'),
	(265899, 118, '2014-04-01 01:12:33.000000', 'temperatura', 380.0000, 'ºC'),
	(265900, 118, '2014-04-01 01:12:34.000000', 'temperatura', 733.0000, 'ºC'),
	(265901, 118, '2014-04-01 01:12:35.000000', 'temperatura', 129.0000, 'ºC'),
	(265902, 118, '2014-04-01 01:12:36.000000', 'temperatura', 845.0000, 'ºC'),
	(265903, 118, '2014-04-01 01:12:37.000000', 'temperatura', 238.0000, 'ºC'),
	(265904, 118, '2014-04-01 01:12:38.000000', 'temperatura', 1054.0000, 'ºC'),
	(265905, 118, '2014-04-01 01:12:39.000000', 'temperatura', 959.0000, 'ºC'),
	(265906, 118, '2014-04-01 01:12:40.000000', 'temperatura', 431.0000, 'ºC'),
	(265907, 118, '2014-04-01 01:12:41.000000', 'temperatura', 479.0000, 'ºC'),
	(265908, 118, '2014-04-01 01:12:42.000000', 'temperatura', 1104.0000, 'ºC'),
	(265909, 118, '2014-04-01 01:12:43.000000', 'temperatura', 481.0000, 'ºC'),
	(265910, 118, '2014-04-01 01:12:44.000000', 'temperatura', 294.0000, 'ºC'),
	(265911, 118, '2014-04-01 01:12:45.000000', 'temperatura', 26.0000, 'ºC'),
	(265912, 118, '2014-04-01 01:12:46.000000', 'temperatura', 450.0000, 'ºC'),
	(265913, 118, '2014-04-01 01:12:47.000000', 'temperatura', 974.0000, 'ºC'),
	(265914, 118, '2014-04-01 01:12:48.000000', 'temperatura', 1118.0000, 'ºC'),
	(265915, 118, '2014-04-01 01:12:49.000000', 'temperatura', 270.0000, 'ºC'),
	(265916, 118, '2014-04-01 01:12:50.000000', 'temperatura', 397.0000, 'ºC'),
	(265917, 118, '2014-04-01 01:12:51.000000', 'temperatura', 1174.0000, 'ºC'),
	(265918, 118, '2014-04-01 01:12:52.000000', 'temperatura', 1079.0000, 'ºC'),
	(265919, 118, '2014-04-01 01:12:53.000000', 'temperatura', 676.0000, 'ºC'),
	(265920, 118, '2014-04-01 01:12:54.000000', 'temperatura', 144.0000, 'ºC'),
	(265921, 118, '2014-04-01 01:12:55.000000', 'temperatura', 1090.0000, 'ºC'),
	(265922, 118, '2014-04-01 01:12:56.000000', 'temperatura', 221.0000, 'ºC'),
	(265923, 118, '2014-04-01 01:12:57.000000', 'temperatura', 232.0000, 'ºC'),
	(265924, 118, '2014-04-01 01:12:58.000000', 'temperatura', 500.0000, 'ºC'),
	(265925, 118, '2014-04-01 01:12:59.000000', 'temperatura', 606.0000, 'ºC'),
	(265926, 118, '2014-04-01 01:13:00.000000', 'temperatura', 329.0000, 'ºC'),
	(265927, 118, '2014-04-01 01:13:01.000000', 'temperatura', 1026.0000, 'ºC'),
	(265928, 118, '2014-04-01 01:13:02.000000', 'temperatura', 544.0000, 'ºC'),
	(265929, 118, '2014-04-01 01:13:03.000000', 'temperatura', 841.0000, 'ºC'),
	(265930, 118, '2014-04-01 01:13:04.000000', 'temperatura', 175.0000, 'ºC'),
	(265931, 118, '2014-04-01 01:13:05.000000', 'temperatura', 752.0000, 'ºC'),
	(265932, 118, '2014-04-01 01:13:06.000000', 'temperatura', 834.0000, 'ºC'),
	(265933, 118, '2014-04-01 01:13:07.000000', 'temperatura', 718.0000, 'ºC'),
	(265934, 118, '2014-04-01 01:13:08.000000', 'temperatura', 1085.0000, 'ºC'),
	(265935, 118, '2014-04-01 01:13:09.000000', 'temperatura', 874.0000, 'ºC'),
	(265936, 118, '2014-04-01 01:13:10.000000', 'temperatura', 1116.0000, 'ºC'),
	(265937, 118, '2014-04-01 01:13:11.000000', 'temperatura', 557.0000, 'ºC'),
	(265938, 118, '2014-04-01 01:13:12.000000', 'temperatura', 639.0000, 'ºC'),
	(265939, 118, '2014-04-01 01:13:13.000000', 'temperatura', 324.0000, 'ºC'),
	(265940, 118, '2014-04-01 01:13:14.000000', 'temperatura', 903.0000, 'ºC'),
	(265941, 118, '2014-04-01 01:13:15.000000', 'temperatura', 1146.0000, 'ºC'),
	(265942, 118, '2014-04-01 01:13:16.000000', 'temperatura', 619.0000, 'ºC'),
	(265943, 118, '2014-04-01 01:13:17.000000', 'temperatura', 858.0000, 'ºC'),
	(265944, 118, '2014-04-01 01:13:18.000000', 'temperatura', 35.0000, 'ºC'),
	(265945, 118, '2014-04-01 01:13:19.000000', 'temperatura', 1199.0000, 'ºC'),
	(265946, 118, '2014-04-01 01:13:20.000000', 'temperatura', 1092.0000, 'ºC'),
	(265947, 118, '2014-04-01 01:13:21.000000', 'temperatura', 662.0000, 'ºC'),
	(265948, 118, '2014-04-01 01:13:22.000000', 'temperatura', 34.0000, 'ºC'),
	(265949, 118, '2014-04-01 01:13:23.000000', 'temperatura', 587.0000, 'ºC'),
	(265950, 118, '2014-04-01 01:13:24.000000', 'temperatura', 431.0000, 'ºC'),
	(265951, 118, '2014-04-01 01:13:25.000000', 'temperatura', 396.0000, 'ºC'),
	(265952, 118, '2014-04-01 01:13:26.000000', 'temperatura', 687.0000, 'ºC'),
	(265953, 118, '2014-04-01 01:13:27.000000', 'temperatura', 1049.0000, 'ºC'),
	(265954, 118, '2014-04-01 01:13:28.000000', 'temperatura', 784.0000, 'ºC'),
	(265955, 118, '2014-04-01 01:13:29.000000', 'temperatura', 772.0000, 'ºC'),
	(265956, 118, '2014-04-01 01:13:30.000000', 'temperatura', 309.0000, 'ºC'),
	(265957, 118, '2014-04-01 01:13:31.000000', 'temperatura', 431.0000, 'ºC'),
	(265958, 118, '2014-04-01 01:13:32.000000', 'temperatura', 29.0000, 'ºC'),
	(265959, 118, '2014-04-01 01:13:33.000000', 'temperatura', 51.0000, 'ºC'),
	(265960, 118, '2014-04-01 01:13:34.000000', 'temperatura', 169.0000, 'ºC'),
	(265961, 118, '2014-04-01 01:13:35.000000', 'temperatura', 691.0000, 'ºC'),
	(265962, 118, '2014-04-01 01:13:36.000000', 'temperatura', 550.0000, 'ºC'),
	(265963, 118, '2014-04-01 01:13:37.000000', 'temperatura', 677.0000, 'ºC'),
	(265964, 118, '2014-04-01 01:13:38.000000', 'temperatura', 535.0000, 'ºC'),
	(265965, 118, '2014-04-01 01:13:39.000000', 'temperatura', 647.0000, 'ºC'),
	(265966, 118, '2014-04-01 01:13:40.000000', 'temperatura', 429.0000, 'ºC'),
	(265967, 118, '2014-04-01 01:13:41.000000', 'temperatura', 205.0000, 'ºC'),
	(265968, 118, '2014-04-01 01:13:42.000000', 'temperatura', 936.0000, 'ºC'),
	(265969, 118, '2014-04-01 01:13:43.000000', 'temperatura', 469.0000, 'ºC'),
	(265970, 118, '2014-04-01 01:13:44.000000', 'temperatura', 735.0000, 'ºC'),
	(265971, 118, '2014-04-01 01:13:45.000000', 'temperatura', 1069.0000, 'ºC'),
	(265972, 118, '2014-04-01 01:13:46.000000', 'temperatura', 741.0000, 'ºC'),
	(265973, 118, '2014-04-01 01:13:47.000000', 'temperatura', 498.0000, 'ºC'),
	(265974, 118, '2014-04-01 01:13:48.000000', 'temperatura', 266.0000, 'ºC'),
	(265975, 118, '2014-04-01 01:13:49.000000', 'temperatura', 1038.0000, 'ºC'),
	(265976, 118, '2014-04-01 01:13:50.000000', 'temperatura', 792.0000, 'ºC'),
	(265977, 118, '2014-04-01 01:13:51.000000', 'temperatura', 846.0000, 'ºC'),
	(265978, 118, '2014-04-01 01:13:52.000000', 'temperatura', 655.0000, 'ºC'),
	(265979, 118, '2014-04-01 01:13:53.000000', 'temperatura', 737.0000, 'ºC'),
	(265980, 118, '2014-04-01 01:13:54.000000', 'temperatura', 522.0000, 'ºC'),
	(265981, 118, '2014-04-01 01:13:55.000000', 'temperatura', 401.0000, 'ºC'),
	(265982, 118, '2014-04-01 01:13:56.000000', 'temperatura', 437.0000, 'ºC'),
	(265983, 118, '2014-04-01 01:13:57.000000', 'temperatura', 982.0000, 'ºC'),
	(265984, 118, '2014-04-01 01:13:58.000000', 'temperatura', 0.0000, 'ºC'),
	(265985, 118, '2014-04-01 01:13:59.000000', 'temperatura', 654.0000, 'ºC'),
	(265986, 118, '2014-04-01 01:14:00.000000', 'temperatura', 872.0000, 'ºC'),
	(265987, 118, '2014-04-01 01:14:01.000000', 'temperatura', 1197.0000, 'ºC'),
	(265988, 118, '2014-04-01 01:14:02.000000', 'temperatura', 970.0000, 'ºC'),
	(265989, 118, '2014-04-01 01:14:03.000000', 'temperatura', 60.0000, 'ºC'),
	(265990, 118, '2014-04-01 01:14:04.000000', 'temperatura', 988.0000, 'ºC'),
	(265991, 118, '2014-04-01 01:14:05.000000', 'temperatura', 1163.0000, 'ºC'),
	(265992, 118, '2014-04-01 01:14:06.000000', 'temperatura', 450.0000, 'ºC'),
	(265993, 118, '2014-04-01 01:14:07.000000', 'temperatura', 1164.0000, 'ºC'),
	(265994, 118, '2014-04-01 01:14:08.000000', 'temperatura', 868.0000, 'ºC'),
	(265995, 118, '2014-04-01 01:14:09.000000', 'temperatura', 849.0000, 'ºC'),
	(265996, 118, '2014-04-01 01:14:10.000000', 'temperatura', 442.0000, 'ºC'),
	(265997, 118, '2014-04-01 01:14:11.000000', 'temperatura', 863.0000, 'ºC'),
	(265998, 118, '2014-04-01 01:14:12.000000', 'temperatura', 589.0000, 'ºC'),
	(265999, 118, '2014-04-01 01:14:13.000000', 'temperatura', 358.0000, 'ºC'),
	(266000, 118, '2014-04-01 01:14:14.000000', 'temperatura', 22.0000, 'ºC'),
	(266001, 118, '2014-04-01 01:14:15.000000', 'temperatura', 236.0000, 'ºC'),
	(266002, 118, '2014-04-01 01:14:16.000000', 'temperatura', 1114.0000, 'ºC'),
	(266003, 118, '2014-04-01 01:14:17.000000', 'temperatura', 63.0000, 'ºC'),
	(266004, 118, '2014-04-01 01:14:18.000000', 'temperatura', 572.0000, 'ºC'),
	(266005, 118, '2014-04-01 01:14:19.000000', 'temperatura', 273.0000, 'ºC'),
	(266006, 118, '2014-04-01 01:14:20.000000', 'temperatura', 849.0000, 'ºC'),
	(266007, 118, '2014-04-01 01:14:21.000000', 'temperatura', 1025.0000, 'ºC'),
	(266008, 118, '2014-04-01 01:14:22.000000', 'temperatura', 180.0000, 'ºC'),
	(266009, 118, '2014-04-01 01:14:23.000000', 'temperatura', 225.0000, 'ºC'),
	(266010, 118, '2014-04-01 01:14:24.000000', 'temperatura', 586.0000, 'ºC'),
	(266011, 118, '2014-04-01 01:14:25.000000', 'temperatura', 1057.0000, 'ºC'),
	(266012, 118, '2014-04-01 01:14:26.000000', 'temperatura', 1126.0000, 'ºC'),
	(266013, 118, '2014-04-01 01:14:27.000000', 'temperatura', 58.0000, 'ºC'),
	(266014, 118, '2014-04-01 01:14:28.000000', 'temperatura', 512.0000, 'ºC'),
	(266015, 118, '2014-04-01 01:14:29.000000', 'temperatura', 1187.0000, 'ºC'),
	(266016, 118, '2014-04-01 01:14:30.000000', 'temperatura', 800.0000, 'ºC'),
	(266017, 118, '2014-04-01 01:14:31.000000', 'temperatura', 441.0000, 'ºC'),
	(266018, 118, '2014-04-01 01:14:32.000000', 'temperatura', 1004.0000, 'ºC'),
	(266019, 118, '2014-04-01 01:14:33.000000', 'temperatura', 97.0000, 'ºC'),
	(266020, 118, '2014-04-01 01:14:34.000000', 'temperatura', 1073.0000, 'ºC'),
	(266021, 118, '2014-04-01 01:14:35.000000', 'temperatura', 276.0000, 'ºC'),
	(266022, 118, '2014-04-01 01:14:36.000000', 'temperatura', 562.0000, 'ºC'),
	(266023, 118, '2014-04-01 01:14:37.000000', 'temperatura', 784.0000, 'ºC'),
	(266024, 118, '2014-04-01 01:14:38.000000', 'temperatura', 1031.0000, 'ºC'),
	(266025, 118, '2014-04-01 01:14:39.000000', 'temperatura', 405.0000, 'ºC'),
	(266026, 118, '2014-04-01 01:14:40.000000', 'temperatura', 131.0000, 'ºC'),
	(266027, 118, '2014-04-01 01:14:41.000000', 'temperatura', 643.0000, 'ºC'),
	(266028, 118, '2014-04-01 01:14:42.000000', 'temperatura', 420.0000, 'ºC'),
	(266029, 118, '2014-04-01 01:14:43.000000', 'temperatura', 174.0000, 'ºC'),
	(266030, 118, '2014-04-01 01:14:44.000000', 'temperatura', 811.0000, 'ºC'),
	(266031, 118, '2014-04-01 01:14:45.000000', 'temperatura', 1134.0000, 'ºC'),
	(266032, 118, '2014-04-01 01:14:46.000000', 'temperatura', 838.0000, 'ºC'),
	(266033, 118, '2014-04-01 01:14:47.000000', 'temperatura', 788.0000, 'ºC'),
	(266034, 118, '2014-04-01 01:14:48.000000', 'temperatura', 227.0000, 'ºC'),
	(266035, 118, '2014-04-01 01:14:49.000000', 'temperatura', 1169.0000, 'ºC'),
	(266036, 118, '2014-04-01 01:14:50.000000', 'temperatura', 365.0000, 'ºC'),
	(266037, 118, '2014-04-01 01:14:51.000000', 'temperatura', 718.0000, 'ºC'),
	(266038, 118, '2014-04-01 01:14:52.000000', 'temperatura', 97.0000, 'ºC'),
	(266039, 118, '2014-04-01 01:14:53.000000', 'temperatura', 731.0000, 'ºC'),
	(266040, 118, '2014-04-01 01:14:54.000000', 'temperatura', 965.0000, 'ºC'),
	(266041, 118, '2014-04-01 01:14:55.000000', 'temperatura', 232.0000, 'ºC'),
	(266042, 118, '2014-04-01 01:14:56.000000', 'temperatura', 666.0000, 'ºC'),
	(266043, 118, '2014-04-01 01:14:57.000000', 'temperatura', 235.0000, 'ºC'),
	(266044, 118, '2014-04-01 01:14:58.000000', 'temperatura', 376.0000, 'ºC'),
	(266045, 118, '2014-04-01 01:14:59.000000', 'temperatura', 1176.0000, 'ºC'),
	(266046, 118, '2014-04-01 01:15:00.000000', 'temperatura', 1153.0000, 'ºC'),
	(266047, 118, '2014-04-01 01:15:01.000000', 'temperatura', 1038.0000, 'ºC'),
	(266048, 118, '2014-04-01 01:15:02.000000', 'temperatura', 530.0000, 'ºC'),
	(266049, 118, '2014-04-01 01:15:03.000000', 'temperatura', 738.0000, 'ºC'),
	(266050, 118, '2014-04-01 01:15:04.000000', 'temperatura', 900.0000, 'ºC'),
	(266051, 118, '2014-04-01 01:15:05.000000', 'temperatura', 1084.0000, 'ºC'),
	(266052, 118, '2014-04-01 01:15:06.000000', 'temperatura', 324.0000, 'ºC'),
	(266053, 118, '2014-04-01 01:15:07.000000', 'temperatura', 768.0000, 'ºC'),
	(266054, 118, '2014-04-01 01:15:08.000000', 'temperatura', 467.0000, 'ºC'),
	(266055, 118, '2014-04-01 01:15:09.000000', 'temperatura', 31.0000, 'ºC'),
	(266056, 118, '2014-04-01 01:15:10.000000', 'temperatura', 1157.0000, 'ºC'),
	(266057, 118, '2014-04-01 01:15:11.000000', 'temperatura', 893.0000, 'ºC'),
	(266058, 118, '2014-04-01 01:15:12.000000', 'temperatura', 992.0000, 'ºC'),
	(266059, 118, '2014-04-01 01:15:13.000000', 'temperatura', 1080.0000, 'ºC'),
	(266060, 118, '2014-04-01 01:15:14.000000', 'temperatura', 28.0000, 'ºC'),
	(266061, 118, '2014-04-01 01:15:15.000000', 'temperatura', 500.0000, 'ºC'),
	(266062, 118, '2014-04-01 01:15:16.000000', 'temperatura', 15.0000, 'ºC'),
	(266063, 118, '2014-04-01 01:15:17.000000', 'temperatura', 975.0000, 'ºC'),
	(266064, 118, '2014-04-01 01:15:18.000000', 'temperatura', 30.0000, 'ºC'),
	(266065, 118, '2014-04-01 01:15:19.000000', 'temperatura', 825.0000, 'ºC'),
	(266066, 118, '2014-04-01 01:15:20.000000', 'temperatura', 436.0000, 'ºC'),
	(266067, 118, '2014-04-01 01:15:21.000000', 'temperatura', 908.0000, 'ºC'),
	(266068, 118, '2014-04-01 01:15:22.000000', 'temperatura', 830.0000, 'ºC'),
	(266069, 118, '2014-04-01 01:15:23.000000', 'temperatura', 228.0000, 'ºC'),
	(266070, 118, '2014-04-01 01:15:24.000000', 'temperatura', 1051.0000, 'ºC'),
	(266071, 118, '2014-04-01 01:15:25.000000', 'temperatura', 970.0000, 'ºC'),
	(266072, 118, '2014-04-01 01:15:26.000000', 'temperatura', 497.0000, 'ºC'),
	(266073, 118, '2014-04-01 01:15:27.000000', 'temperatura', 775.0000, 'ºC'),
	(266074, 118, '2014-04-01 01:15:28.000000', 'temperatura', 1187.0000, 'ºC'),
	(266075, 118, '2014-04-01 01:15:29.000000', 'temperatura', 9.0000, 'ºC'),
	(266076, 118, '2014-04-01 01:15:30.000000', 'temperatura', 86.0000, 'ºC'),
	(266077, 118, '2014-04-01 01:15:31.000000', 'temperatura', 403.0000, 'ºC'),
	(266078, 118, '2014-04-01 01:15:32.000000', 'temperatura', 559.0000, 'ºC'),
	(266079, 118, '2014-04-01 01:15:33.000000', 'temperatura', 386.0000, 'ºC'),
	(266080, 118, '2014-04-01 01:15:34.000000', 'temperatura', 254.0000, 'ºC'),
	(266081, 118, '2014-04-01 01:15:35.000000', 'temperatura', 111.0000, 'ºC'),
	(266082, 118, '2014-04-01 01:15:36.000000', 'temperatura', 992.0000, 'ºC'),
	(266083, 118, '2014-04-01 01:15:37.000000', 'temperatura', 1029.0000, 'ºC'),
	(266084, 118, '2014-04-01 01:15:38.000000', 'temperatura', 971.0000, 'ºC'),
	(266085, 118, '2014-04-01 01:15:39.000000', 'temperatura', 569.0000, 'ºC'),
	(266086, 118, '2014-04-01 01:15:40.000000', 'temperatura', 1130.0000, 'ºC'),
	(266087, 118, '2014-04-01 01:15:41.000000', 'temperatura', 347.0000, 'ºC'),
	(266088, 118, '2014-04-01 01:15:42.000000', 'temperatura', 742.0000, 'ºC'),
	(266089, 118, '2014-04-01 01:15:43.000000', 'temperatura', 270.0000, 'ºC'),
	(266090, 118, '2014-04-01 01:15:44.000000', 'temperatura', 324.0000, 'ºC'),
	(266091, 118, '2014-04-01 01:15:45.000000', 'temperatura', 812.0000, 'ºC'),
	(266092, 118, '2014-04-01 01:15:46.000000', 'temperatura', 690.0000, 'ºC'),
	(266093, 118, '2014-04-01 01:15:47.000000', 'temperatura', 1013.0000, 'ºC'),
	(266094, 118, '2014-04-01 01:15:48.000000', 'temperatura', 597.0000, 'ºC'),
	(266095, 118, '2014-04-01 01:15:49.000000', 'temperatura', 1144.0000, 'ºC'),
	(266096, 118, '2014-04-01 01:15:50.000000', 'temperatura', 329.0000, 'ºC'),
	(266097, 118, '2014-04-01 01:15:51.000000', 'temperatura', 613.0000, 'ºC'),
	(266098, 118, '2014-04-01 01:15:52.000000', 'temperatura', 881.0000, 'ºC'),
	(266099, 118, '2014-04-01 01:15:53.000000', 'temperatura', 164.0000, 'ºC'),
	(266100, 118, '2014-04-01 01:15:54.000000', 'temperatura', 579.0000, 'ºC'),
	(266101, 118, '2014-04-01 01:15:55.000000', 'temperatura', 2.0000, 'ºC'),
	(266102, 118, '2014-04-01 01:15:56.000000', 'temperatura', 676.0000, 'ºC'),
	(266103, 118, '2014-04-01 01:15:57.000000', 'temperatura', 974.0000, 'ºC'),
	(266104, 118, '2014-04-01 01:15:58.000000', 'temperatura', 441.0000, 'ºC'),
	(266105, 118, '2014-04-01 01:15:59.000000', 'temperatura', 483.0000, 'ºC'),
	(266106, 118, '2014-04-01 01:16:00.000000', 'temperatura', 1095.0000, 'ºC'),
	(266107, 118, '2014-04-01 01:16:01.000000', 'temperatura', 424.0000, 'ºC'),
	(266108, 118, '2014-04-01 01:16:02.000000', 'temperatura', 35.0000, 'ºC'),
	(266109, 118, '2014-04-01 01:16:03.000000', 'temperatura', 104.0000, 'ºC'),
	(266110, 118, '2014-04-01 01:16:04.000000', 'temperatura', 414.0000, 'ºC'),
	(266111, 118, '2014-04-01 01:16:05.000000', 'temperatura', 561.0000, 'ºC'),
	(266112, 118, '2014-04-01 01:16:06.000000', 'temperatura', 365.0000, 'ºC'),
	(266113, 118, '2014-04-01 01:16:07.000000', 'temperatura', 139.0000, 'ºC'),
	(266114, 118, '2014-04-01 01:16:08.000000', 'temperatura', 801.0000, 'ºC'),
	(266115, 118, '2014-04-01 01:16:09.000000', 'temperatura', 1188.0000, 'ºC'),
	(266116, 118, '2014-04-01 01:16:10.000000', 'temperatura', 1138.0000, 'ºC'),
	(266117, 118, '2014-04-01 01:16:11.000000', 'temperatura', 926.0000, 'ºC'),
	(266118, 118, '2014-04-01 01:16:12.000000', 'temperatura', 17.0000, 'ºC'),
	(266119, 118, '2014-04-01 01:16:13.000000', 'temperatura', 906.0000, 'ºC'),
	(266120, 118, '2014-04-01 01:16:14.000000', 'temperatura', 882.0000, 'ºC'),
	(266121, 118, '2014-04-01 01:16:15.000000', 'temperatura', 490.0000, 'ºC'),
	(266122, 118, '2014-04-01 01:16:16.000000', 'temperatura', 1004.0000, 'ºC'),
	(266123, 118, '2014-04-01 01:16:17.000000', 'temperatura', 1152.0000, 'ºC'),
	(266124, 118, '2014-04-01 01:16:18.000000', 'temperatura', 348.0000, 'ºC'),
	(266125, 118, '2014-04-01 01:16:19.000000', 'temperatura', 686.0000, 'ºC'),
	(266126, 118, '2014-04-01 01:16:20.000000', 'temperatura', 1187.0000, 'ºC'),
	(266127, 118, '2014-04-01 01:16:21.000000', 'temperatura', 276.0000, 'ºC'),
	(266128, 118, '2014-04-01 01:16:22.000000', 'temperatura', 219.0000, 'ºC'),
	(266129, 118, '2014-04-01 01:16:23.000000', 'temperatura', 268.0000, 'ºC'),
	(266130, 118, '2014-04-01 01:16:24.000000', 'temperatura', 685.0000, 'ºC'),
	(266131, 118, '2014-04-01 01:16:25.000000', 'temperatura', 219.0000, 'ºC'),
	(266132, 118, '2014-04-01 01:16:26.000000', 'temperatura', 244.0000, 'ºC'),
	(266133, 118, '2014-04-01 01:16:27.000000', 'temperatura', 560.0000, 'ºC'),
	(266134, 118, '2014-04-01 01:16:28.000000', 'temperatura', 871.0000, 'ºC'),
	(266135, 118, '2014-04-01 01:16:29.000000', 'temperatura', 273.0000, 'ºC'),
	(266136, 118, '2014-04-01 01:16:30.000000', 'temperatura', 1153.0000, 'ºC'),
	(266137, 118, '2014-04-01 01:16:31.000000', 'temperatura', 145.0000, 'ºC'),
	(266138, 118, '2014-04-01 01:16:32.000000', 'temperatura', 867.0000, 'ºC'),
	(266139, 118, '2014-04-01 01:16:33.000000', 'temperatura', 303.0000, 'ºC'),
	(266140, 118, '2014-04-01 01:16:34.000000', 'temperatura', 112.0000, 'ºC'),
	(266141, 118, '2014-04-01 01:16:35.000000', 'temperatura', 852.0000, 'ºC'),
	(266142, 118, '2014-04-01 01:16:36.000000', 'temperatura', 324.0000, 'ºC'),
	(266143, 118, '2014-04-01 01:16:37.000000', 'temperatura', 265.0000, 'ºC'),
	(266144, 118, '2014-04-01 01:16:38.000000', 'temperatura', 353.0000, 'ºC'),
	(266145, 118, '2014-04-01 01:16:39.000000', 'temperatura', 971.0000, 'ºC'),
	(266146, 118, '2014-04-01 01:16:40.000000', 'temperatura', 196.0000, 'ºC'),
	(266147, 118, '2014-04-01 01:16:41.000000', 'temperatura', 467.0000, 'ºC'),
	(266148, 118, '2014-04-01 01:16:42.000000', 'temperatura', 549.0000, 'ºC'),
	(266149, 118, '2014-04-01 01:16:43.000000', 'temperatura', 143.0000, 'ºC'),
	(266150, 118, '2014-04-01 01:16:44.000000', 'temperatura', 269.0000, 'ºC'),
	(266151, 118, '2014-04-01 01:16:45.000000', 'temperatura', 915.0000, 'ºC'),
	(266152, 118, '2014-04-01 01:16:46.000000', 'temperatura', 170.0000, 'ºC'),
	(266153, 118, '2014-04-01 01:16:47.000000', 'temperatura', 503.0000, 'ºC'),
	(266154, 118, '2014-04-01 01:16:48.000000', 'temperatura', 809.0000, 'ºC'),
	(266155, 118, '2014-04-01 01:16:49.000000', 'temperatura', 133.0000, 'ºC'),
	(266156, 118, '2014-04-01 01:16:50.000000', 'temperatura', 641.0000, 'ºC'),
	(266157, 118, '2014-04-01 01:16:51.000000', 'temperatura', 406.0000, 'ºC'),
	(266158, 118, '2014-04-01 01:16:52.000000', 'temperatura', 105.0000, 'ºC'),
	(266159, 118, '2014-04-01 01:16:53.000000', 'temperatura', 511.0000, 'ºC'),
	(266160, 118, '2014-04-01 01:16:54.000000', 'temperatura', 1039.0000, 'ºC'),
	(266161, 118, '2014-04-01 01:16:55.000000', 'temperatura', 64.0000, 'ºC'),
	(266162, 118, '2014-04-01 01:16:56.000000', 'temperatura', 801.0000, 'ºC'),
	(266163, 118, '2014-04-01 01:16:57.000000', 'temperatura', 214.0000, 'ºC'),
	(266164, 118, '2014-04-01 01:16:58.000000', 'temperatura', 1068.0000, 'ºC'),
	(266165, 118, '2014-04-01 01:16:59.000000', 'temperatura', 1097.0000, 'ºC'),
	(266166, 118, '2014-04-01 01:17:00.000000', 'temperatura', 1082.0000, 'ºC'),
	(266167, 118, '2014-04-01 01:17:01.000000', 'temperatura', 919.0000, 'ºC'),
	(266168, 118, '2014-04-01 01:17:02.000000', 'temperatura', 148.0000, 'ºC'),
	(266169, 118, '2014-04-01 01:17:03.000000', 'temperatura', 387.0000, 'ºC'),
	(266170, 118, '2014-04-01 01:17:04.000000', 'temperatura', 288.0000, 'ºC'),
	(266171, 118, '2014-04-01 01:17:05.000000', 'temperatura', 282.0000, 'ºC'),
	(266172, 118, '2014-04-01 01:17:06.000000', 'temperatura', 544.0000, 'ºC'),
	(266173, 118, '2014-04-01 01:17:07.000000', 'temperatura', 676.0000, 'ºC'),
	(266174, 118, '2014-04-01 01:17:08.000000', 'temperatura', 548.0000, 'ºC'),
	(266175, 118, '2014-04-01 01:17:09.000000', 'temperatura', 712.0000, 'ºC'),
	(266176, 118, '2014-04-01 01:17:10.000000', 'temperatura', 717.0000, 'ºC'),
	(266177, 118, '2014-04-01 01:17:11.000000', 'temperatura', 247.0000, 'ºC'),
	(266178, 118, '2014-04-01 01:17:12.000000', 'temperatura', 288.0000, 'ºC'),
	(266179, 118, '2014-04-01 01:17:13.000000', 'temperatura', 700.0000, 'ºC'),
	(266180, 118, '2014-04-01 01:17:14.000000', 'temperatura', 235.0000, 'ºC'),
	(266181, 118, '2014-04-01 01:17:15.000000', 'temperatura', 275.0000, 'ºC'),
	(266182, 118, '2014-04-01 01:17:16.000000', 'temperatura', 671.0000, 'ºC'),
	(266183, 118, '2014-04-01 01:17:17.000000', 'temperatura', 131.0000, 'ºC'),
	(266184, 118, '2014-04-01 01:17:18.000000', 'temperatura', 1041.0000, 'ºC'),
	(266185, 118, '2014-04-01 01:17:19.000000', 'temperatura', 11.0000, 'ºC'),
	(266186, 118, '2014-04-01 01:17:20.000000', 'temperatura', 536.0000, 'ºC'),
	(266187, 118, '2014-04-01 01:17:21.000000', 'temperatura', 245.0000, 'ºC'),
	(266188, 118, '2014-04-01 01:17:22.000000', 'temperatura', 817.0000, 'ºC'),
	(266189, 118, '2014-04-01 01:17:23.000000', 'temperatura', 952.0000, 'ºC'),
	(266190, 118, '2014-04-01 01:17:24.000000', 'temperatura', 1110.0000, 'ºC'),
	(266191, 118, '2014-04-01 01:17:25.000000', 'temperatura', 292.0000, 'ºC'),
	(266192, 118, '2014-04-01 01:17:26.000000', 'temperatura', 532.0000, 'ºC'),
	(266193, 118, '2014-04-01 01:17:27.000000', 'temperatura', 584.0000, 'ºC'),
	(266194, 118, '2014-04-01 01:17:28.000000', 'temperatura', 126.0000, 'ºC'),
	(266195, 118, '2014-04-01 01:17:29.000000', 'temperatura', 79.0000, 'ºC'),
	(266196, 118, '2014-04-01 01:17:30.000000', 'temperatura', 18.0000, 'ºC'),
	(266197, 118, '2014-04-01 01:17:31.000000', 'temperatura', 1055.0000, 'ºC'),
	(266198, 118, '2014-04-01 01:17:32.000000', 'temperatura', 418.0000, 'ºC'),
	(266199, 118, '2014-04-01 01:17:33.000000', 'temperatura', 127.0000, 'ºC'),
	(266200, 118, '2014-04-01 01:17:34.000000', 'temperatura', 580.0000, 'ºC'),
	(266201, 118, '2014-04-01 01:17:35.000000', 'temperatura', 122.0000, 'ºC'),
	(266202, 118, '2014-04-01 01:17:36.000000', 'temperatura', 70.0000, 'ºC'),
	(266203, 118, '2014-04-01 01:17:37.000000', 'temperatura', 1185.0000, 'ºC'),
	(266204, 118, '2014-04-01 01:17:38.000000', 'temperatura', 913.0000, 'ºC'),
	(266205, 118, '2014-04-01 01:17:39.000000', 'temperatura', 1013.0000, 'ºC'),
	(266206, 118, '2014-04-01 01:17:40.000000', 'temperatura', 1124.0000, 'ºC'),
	(266207, 118, '2014-04-01 01:17:41.000000', 'temperatura', 181.0000, 'ºC'),
	(266208, 118, '2014-04-01 01:17:42.000000', 'temperatura', 1134.0000, 'ºC'),
	(266209, 118, '2014-04-01 01:17:43.000000', 'temperatura', 326.0000, 'ºC'),
	(266210, 118, '2014-04-01 01:17:44.000000', 'temperatura', 631.0000, 'ºC'),
	(266211, 118, '2014-04-01 01:17:45.000000', 'temperatura', 975.0000, 'ºC'),
	(266212, 118, '2014-04-01 01:17:46.000000', 'temperatura', 583.0000, 'ºC'),
	(266213, 118, '2014-04-01 01:17:47.000000', 'temperatura', 1190.0000, 'ºC'),
	(266214, 118, '2014-04-01 01:17:48.000000', 'temperatura', 601.0000, 'ºC'),
	(266215, 118, '2014-04-01 01:17:49.000000', 'temperatura', 638.0000, 'ºC'),
	(266216, 118, '2014-04-01 01:17:50.000000', 'temperatura', 185.0000, 'ºC'),
	(266217, 118, '2014-04-01 01:17:51.000000', 'temperatura', 214.0000, 'ºC'),
	(266218, 118, '2014-04-01 01:17:52.000000', 'temperatura', 516.0000, 'ºC'),
	(266219, 118, '2014-04-01 01:17:53.000000', 'temperatura', 737.0000, 'ºC'),
	(266220, 118, '2014-04-01 01:17:54.000000', 'temperatura', 938.0000, 'ºC'),
	(266221, 118, '2014-04-01 01:17:55.000000', 'temperatura', 81.0000, 'ºC'),
	(266222, 118, '2014-04-01 01:17:56.000000', 'temperatura', 1188.0000, 'ºC'),
	(266223, 118, '2014-04-01 01:17:57.000000', 'temperatura', 901.0000, 'ºC'),
	(266224, 118, '2014-04-01 01:17:58.000000', 'temperatura', 940.0000, 'ºC'),
	(266225, 118, '2014-04-01 01:17:59.000000', 'temperatura', 798.0000, 'ºC'),
	(266226, 118, '2014-04-01 01:18:00.000000', 'temperatura', 1170.0000, 'ºC'),
	(266227, 118, '2014-04-01 01:18:01.000000', 'temperatura', 1057.0000, 'ºC'),
	(266228, 118, '2014-04-01 01:18:02.000000', 'temperatura', 576.0000, 'ºC'),
	(266229, 118, '2014-04-01 01:18:03.000000', 'temperatura', 909.0000, 'ºC'),
	(266230, 118, '2014-04-01 01:18:04.000000', 'temperatura', 418.0000, 'ºC'),
	(266231, 118, '2014-04-01 01:18:05.000000', 'temperatura', 564.0000, 'ºC'),
	(266232, 118, '2014-04-01 01:18:06.000000', 'temperatura', 368.0000, 'ºC'),
	(266233, 118, '2014-04-01 01:18:07.000000', 'temperatura', 146.0000, 'ºC'),
	(266234, 118, '2014-04-01 01:18:08.000000', 'temperatura', 829.0000, 'ºC'),
	(266235, 118, '2014-04-01 01:18:09.000000', 'temperatura', 108.0000, 'ºC'),
	(266236, 118, '2014-04-01 01:18:10.000000', 'temperatura', 451.0000, 'ºC'),
	(266237, 118, '2014-04-01 01:18:11.000000', 'temperatura', 731.0000, 'ºC'),
	(266238, 118, '2014-04-01 01:18:12.000000', 'temperatura', 1101.0000, 'ºC'),
	(266239, 118, '2014-04-01 01:18:13.000000', 'temperatura', 916.0000, 'ºC'),
	(266240, 118, '2014-04-01 01:18:14.000000', 'temperatura', 75.0000, 'ºC'),
	(266241, 118, '2014-04-01 01:18:15.000000', 'temperatura', 28.0000, 'ºC'),
	(266242, 118, '2014-04-01 01:18:16.000000', 'temperatura', 1115.0000, 'ºC'),
	(266243, 118, '2014-04-01 01:18:17.000000', 'temperatura', 692.0000, 'ºC'),
	(266244, 118, '2014-04-01 01:18:18.000000', 'temperatura', 117.0000, 'ºC'),
	(266245, 118, '2014-04-01 01:18:19.000000', 'temperatura', 910.0000, 'ºC'),
	(266246, 118, '2014-04-01 01:18:20.000000', 'temperatura', 599.0000, 'ºC'),
	(266247, 118, '2014-04-01 01:18:21.000000', 'temperatura', 265.0000, 'ºC'),
	(266248, 118, '2014-04-01 01:18:22.000000', 'temperatura', 729.0000, 'ºC'),
	(266249, 118, '2014-04-01 01:18:23.000000', 'temperatura', 449.0000, 'ºC'),
	(266250, 118, '2014-04-01 01:18:24.000000', 'temperatura', 59.0000, 'ºC'),
	(266251, 118, '2014-04-01 01:18:25.000000', 'temperatura', 150.0000, 'ºC'),
	(266252, 118, '2014-04-01 01:18:26.000000', 'temperatura', 574.0000, 'ºC'),
	(266253, 118, '2014-04-01 01:18:27.000000', 'temperatura', 20.0000, 'ºC'),
	(266254, 118, '2014-04-01 01:18:28.000000', 'temperatura', 779.0000, 'ºC'),
	(266255, 118, '2014-04-01 01:18:29.000000', 'temperatura', 236.0000, 'ºC'),
	(266256, 118, '2014-04-01 01:18:30.000000', 'temperatura', 43.0000, 'ºC'),
	(266257, 118, '2014-04-01 01:18:31.000000', 'temperatura', 708.0000, 'ºC'),
	(266258, 118, '2014-04-01 01:18:32.000000', 'temperatura', 1011.0000, 'ºC'),
	(266259, 118, '2014-04-01 01:18:33.000000', 'temperatura', 533.0000, 'ºC'),
	(266260, 118, '2014-04-01 01:18:34.000000', 'temperatura', 833.0000, 'ºC'),
	(266261, 118, '2014-04-01 01:18:35.000000', 'temperatura', 167.0000, 'ºC'),
	(266262, 118, '2014-04-01 01:18:36.000000', 'temperatura', 737.0000, 'ºC'),
	(266263, 118, '2014-04-01 01:18:37.000000', 'temperatura', 782.0000, 'ºC'),
	(266264, 118, '2014-04-01 01:18:38.000000', 'temperatura', 500.0000, 'ºC'),
	(266265, 118, '2014-04-01 01:18:39.000000', 'temperatura', 157.0000, 'ºC'),
	(266266, 118, '2014-04-01 01:18:40.000000', 'temperatura', 484.0000, 'ºC'),
	(266267, 118, '2014-04-01 01:18:41.000000', 'temperatura', 748.0000, 'ºC'),
	(266268, 118, '2014-04-01 01:18:42.000000', 'temperatura', 1090.0000, 'ºC'),
	(266269, 118, '2014-04-01 01:18:43.000000', 'temperatura', 805.0000, 'ºC'),
	(266270, 118, '2014-04-01 01:18:44.000000', 'temperatura', 756.0000, 'ºC'),
	(266271, 118, '2014-04-01 01:18:45.000000', 'temperatura', 166.0000, 'ºC'),
	(266272, 118, '2014-04-01 01:18:46.000000', 'temperatura', 960.0000, 'ºC'),
	(266273, 118, '2014-04-01 01:18:47.000000', 'temperatura', 706.0000, 'ºC'),
	(266274, 118, '2014-04-01 01:18:48.000000', 'temperatura', 647.0000, 'ºC'),
	(266275, 118, '2014-04-01 01:18:49.000000', 'temperatura', 1120.0000, 'ºC'),
	(266276, 118, '2014-04-01 01:18:50.000000', 'temperatura', 57.0000, 'ºC'),
	(266277, 118, '2014-04-01 01:18:51.000000', 'temperatura', 526.0000, 'ºC'),
	(266278, 118, '2014-04-01 01:18:52.000000', 'temperatura', 62.0000, 'ºC'),
	(266279, 118, '2014-04-01 01:18:53.000000', 'temperatura', 1130.0000, 'ºC'),
	(266280, 118, '2014-04-01 01:18:54.000000', 'temperatura', 665.0000, 'ºC'),
	(266281, 118, '2014-04-01 01:18:55.000000', 'temperatura', 1137.0000, 'ºC'),
	(266282, 118, '2014-04-01 01:18:56.000000', 'temperatura', 89.0000, 'ºC'),
	(266283, 118, '2014-04-01 01:18:57.000000', 'temperatura', 635.0000, 'ºC'),
	(266284, 118, '2014-04-01 01:18:58.000000', 'temperatura', 509.0000, 'ºC'),
	(266285, 118, '2014-04-01 01:18:59.000000', 'temperatura', 640.0000, 'ºC'),
	(266286, 118, '2014-04-01 01:19:00.000000', 'temperatura', 473.0000, 'ºC'),
	(266287, 118, '2014-04-01 01:19:01.000000', 'temperatura', 445.0000, 'ºC'),
	(266288, 118, '2014-04-01 01:19:02.000000', 'temperatura', 808.0000, 'ºC'),
	(266289, 118, '2014-04-01 01:19:03.000000', 'temperatura', 305.0000, 'ºC'),
	(266290, 118, '2014-04-01 01:19:04.000000', 'temperatura', 300.0000, 'ºC'),
	(266291, 118, '2014-04-01 01:19:05.000000', 'temperatura', 587.0000, 'ºC'),
	(266292, 118, '2014-04-01 01:19:06.000000', 'temperatura', 835.0000, 'ºC'),
	(266293, 118, '2014-04-01 01:19:07.000000', 'temperatura', 13.0000, 'ºC'),
	(266294, 118, '2014-04-01 01:19:08.000000', 'temperatura', 1163.0000, 'ºC'),
	(266295, 118, '2014-04-01 01:19:09.000000', 'temperatura', 976.0000, 'ºC'),
	(266296, 118, '2014-04-01 01:19:10.000000', 'temperatura', 192.0000, 'ºC'),
	(266297, 118, '2014-04-01 01:19:11.000000', 'temperatura', 430.0000, 'ºC'),
	(266298, 118, '2014-04-01 01:19:12.000000', 'temperatura', 377.0000, 'ºC'),
	(266299, 118, '2014-04-01 01:19:13.000000', 'temperatura', 594.0000, 'ºC'),
	(266300, 118, '2014-04-01 01:19:14.000000', 'temperatura', 641.0000, 'ºC'),
	(266301, 118, '2014-04-01 01:19:15.000000', 'temperatura', 225.0000, 'ºC'),
	(266302, 118, '2014-04-01 01:19:16.000000', 'temperatura', 400.0000, 'ºC'),
	(266303, 118, '2014-04-01 01:19:17.000000', 'temperatura', 126.0000, 'ºC'),
	(266304, 118, '2014-04-01 01:19:18.000000', 'temperatura', 629.0000, 'ºC'),
	(266305, 118, '2014-04-01 01:19:19.000000', 'temperatura', 367.0000, 'ºC'),
	(266306, 118, '2014-04-01 01:19:20.000000', 'temperatura', 1150.0000, 'ºC'),
	(266307, 118, '2014-04-01 01:19:21.000000', 'temperatura', 1049.0000, 'ºC'),
	(266308, 118, '2014-04-01 01:19:22.000000', 'temperatura', 594.0000, 'ºC'),
	(266309, 118, '2014-04-01 01:19:23.000000', 'temperatura', 1024.0000, 'ºC'),
	(266310, 118, '2014-04-01 01:19:24.000000', 'temperatura', 940.0000, 'ºC'),
	(266311, 118, '2014-04-01 01:19:25.000000', 'temperatura', 426.0000, 'ºC'),
	(266312, 118, '2014-04-01 01:19:26.000000', 'temperatura', 514.0000, 'ºC'),
	(266313, 118, '2014-04-01 01:19:27.000000', 'temperatura', 90.0000, 'ºC'),
	(266314, 118, '2014-04-01 01:19:28.000000', 'temperatura', 109.0000, 'ºC'),
	(266315, 118, '2014-04-01 01:19:29.000000', 'temperatura', 275.0000, 'ºC'),
	(266316, 118, '2014-04-01 01:19:30.000000', 'temperatura', 1049.0000, 'ºC'),
	(266317, 118, '2014-04-01 01:19:31.000000', 'temperatura', 821.0000, 'ºC'),
	(266318, 118, '2014-04-01 01:19:32.000000', 'temperatura', 957.0000, 'ºC'),
	(266319, 118, '2014-04-01 01:19:33.000000', 'temperatura', 1122.0000, 'ºC'),
	(266320, 118, '2014-04-01 01:19:34.000000', 'temperatura', 339.0000, 'ºC'),
	(266321, 118, '2014-04-01 01:19:35.000000', 'temperatura', 732.0000, 'ºC'),
	(266322, 118, '2014-04-01 01:19:36.000000', 'temperatura', 243.0000, 'ºC'),
	(266323, 118, '2014-04-01 01:19:37.000000', 'temperatura', 217.0000, 'ºC'),
	(266324, 118, '2014-04-01 01:19:38.000000', 'temperatura', 359.0000, 'ºC'),
	(266325, 118, '2014-04-01 01:19:39.000000', 'temperatura', 1143.0000, 'ºC'),
	(266326, 118, '2014-04-01 01:19:40.000000', 'temperatura', 1041.0000, 'ºC'),
	(266327, 118, '2014-04-01 01:19:41.000000', 'temperatura', 573.0000, 'ºC'),
	(266328, 118, '2014-04-01 01:19:42.000000', 'temperatura', 945.0000, 'ºC'),
	(266329, 118, '2014-04-01 01:19:43.000000', 'temperatura', 605.0000, 'ºC'),
	(266330, 118, '2014-04-01 01:19:44.000000', 'temperatura', 192.0000, 'ºC'),
	(266331, 118, '2014-04-01 01:19:45.000000', 'temperatura', 346.0000, 'ºC'),
	(266332, 118, '2014-04-01 01:19:46.000000', 'temperatura', 1155.0000, 'ºC'),
	(266333, 118, '2014-04-01 01:19:47.000000', 'temperatura', 1139.0000, 'ºC'),
	(266334, 118, '2014-04-01 01:19:48.000000', 'temperatura', 1027.0000, 'ºC'),
	(266335, 118, '2014-04-01 01:19:49.000000', 'temperatura', 518.0000, 'ºC'),
	(266336, 118, '2014-04-01 01:19:50.000000', 'temperatura', 713.0000, 'ºC'),
	(266337, 118, '2014-04-01 01:19:51.000000', 'temperatura', 809.0000, 'ºC'),
	(266338, 118, '2014-04-01 01:19:52.000000', 'temperatura', 706.0000, 'ºC'),
	(266339, 118, '2014-04-01 01:19:53.000000', 'temperatura', 1104.0000, 'ºC'),
	(266340, 118, '2014-04-01 01:19:54.000000', 'temperatura', 1003.0000, 'ºC'),
	(266341, 118, '2014-04-01 01:19:55.000000', 'temperatura', 504.0000, 'ºC'),
	(266342, 118, '2014-04-01 01:19:56.000000', 'temperatura', 711.0000, 'ºC'),
	(266343, 118, '2014-04-01 01:19:57.000000', 'temperatura', 843.0000, 'ºC'),
	(266344, 118, '2014-04-01 01:19:58.000000', 'temperatura', 881.0000, 'ºC'),
	(266345, 118, '2014-04-01 01:19:59.000000', 'temperatura', 679.0000, 'ºC'),
	(266346, 118, '2014-04-01 01:20:00.000000', 'temperatura', 751.0000, 'ºC'),
	(266347, 118, '2014-04-01 01:20:01.000000', 'temperatura', 519.0000, 'ºC'),
	(266348, 118, '2014-04-01 01:20:02.000000', 'temperatura', 343.0000, 'ºC'),
	(266349, 118, '2014-04-01 01:20:03.000000', 'temperatura', 159.0000, 'ºC'),
	(266350, 118, '2014-04-01 01:20:04.000000', 'temperatura', 966.0000, 'ºC'),
	(266351, 118, '2014-04-01 01:20:05.000000', 'temperatura', 755.0000, 'ºC'),
	(266352, 118, '2014-04-01 01:20:06.000000', 'temperatura', 878.0000, 'ºC'),
	(266353, 118, '2014-04-01 01:20:07.000000', 'temperatura', 924.0000, 'ºC'),
	(266354, 118, '2014-04-01 01:20:08.000000', 'temperatura', 788.0000, 'ºC'),
	(266355, 118, '2014-04-01 01:20:09.000000', 'temperatura', 1166.0000, 'ºC'),
	(266356, 118, '2014-04-01 01:20:10.000000', 'temperatura', 1068.0000, 'ºC'),
	(266357, 118, '2014-04-01 01:20:11.000000', 'temperatura', 642.0000, 'ºC'),
	(266358, 118, '2014-04-01 01:20:12.000000', 'temperatura', 5.0000, 'ºC'),
	(266359, 118, '2014-04-01 01:20:13.000000', 'temperatura', 500.0000, 'ºC'),
	(266360, 118, '2014-04-01 01:20:14.000000', 'temperatura', 87.0000, 'ºC'),
	(266361, 118, '2014-04-01 01:20:15.000000', 'temperatura', 133.0000, 'ºC'),
	(266362, 118, '2014-04-01 01:20:16.000000', 'temperatura', 406.0000, 'ºC'),
	(266363, 118, '2014-04-01 01:20:17.000000', 'temperatura', 432.0000, 'ºC'),
	(266364, 118, '2014-04-01 01:20:18.000000', 'temperatura', 940.0000, 'ºC'),
	(266365, 118, '2014-04-01 01:20:19.000000', 'temperatura', 1006.0000, 'ºC'),
	(266366, 118, '2014-04-01 01:20:20.000000', 'temperatura', 1010.0000, 'ºC'),
	(266367, 118, '2014-04-01 01:20:21.000000', 'temperatura', 834.0000, 'ºC'),
	(266368, 118, '2014-04-01 01:20:22.000000', 'temperatura', 1139.0000, 'ºC'),
	(266369, 118, '2014-04-01 01:20:23.000000', 'temperatura', 796.0000, 'ºC'),
	(266370, 118, '2014-04-01 01:20:24.000000', 'temperatura', 560.0000, 'ºC'),
	(266371, 118, '2014-04-01 01:20:25.000000', 'temperatura', 415.0000, 'ºC'),
	(266372, 118, '2014-04-01 01:20:26.000000', 'temperatura', 395.0000, 'ºC'),
	(266373, 118, '2014-04-01 01:20:27.000000', 'temperatura', 730.0000, 'ºC'),
	(266374, 118, '2014-04-01 01:20:28.000000', 'temperatura', 68.0000, 'ºC'),
	(266375, 118, '2014-04-01 01:20:29.000000', 'temperatura', 547.0000, 'ºC'),
	(266376, 118, '2014-04-01 01:20:30.000000', 'temperatura', 134.0000, 'ºC'),
	(266377, 118, '2014-04-01 01:20:31.000000', 'temperatura', 229.0000, 'ºC'),
	(266378, 118, '2014-04-01 01:20:32.000000', 'temperatura', 745.0000, 'ºC'),
	(266379, 118, '2014-04-01 01:20:33.000000', 'temperatura', 639.0000, 'ºC'),
	(266380, 118, '2014-04-01 01:20:34.000000', 'temperatura', 958.0000, 'ºC'),
	(266381, 118, '2014-04-01 01:20:35.000000', 'temperatura', 473.0000, 'ºC'),
	(266382, 118, '2014-04-01 01:20:36.000000', 'temperatura', 694.0000, 'ºC'),
	(266383, 118, '2014-04-01 01:20:37.000000', 'temperatura', 852.0000, 'ºC'),
	(266384, 118, '2014-04-01 01:20:38.000000', 'temperatura', 978.0000, 'ºC'),
	(266385, 118, '2014-04-01 01:20:39.000000', 'temperatura', 1136.0000, 'ºC'),
	(266386, 118, '2014-04-01 01:20:40.000000', 'temperatura', 346.0000, 'ºC'),
	(266387, 118, '2014-04-01 01:20:41.000000', 'temperatura', 722.0000, 'ºC'),
	(266388, 118, '2014-04-01 01:20:42.000000', 'temperatura', 170.0000, 'ºC'),
	(266389, 118, '2014-04-01 01:20:43.000000', 'temperatura', 1088.0000, 'ºC'),
	(266390, 118, '2014-04-01 01:20:44.000000', 'temperatura', 130.0000, 'ºC'),
	(266391, 118, '2014-04-01 01:20:45.000000', 'temperatura', 987.0000, 'ºC'),
	(266392, 118, '2014-04-01 01:20:46.000000', 'temperatura', 944.0000, 'ºC'),
	(266393, 118, '2014-04-01 01:20:47.000000', 'temperatura', 561.0000, 'ºC'),
	(266394, 118, '2014-04-01 01:20:48.000000', 'temperatura', 1172.0000, 'ºC'),
	(266395, 118, '2014-04-01 01:20:49.000000', 'temperatura', 579.0000, 'ºC'),
	(266396, 118, '2014-04-01 01:20:50.000000', 'temperatura', 579.0000, 'ºC'),
	(266397, 118, '2014-04-01 01:20:51.000000', 'temperatura', 1158.0000, 'ºC'),
	(266398, 118, '2014-04-01 01:20:52.000000', 'temperatura', 453.0000, 'ºC'),
	(266399, 118, '2014-04-01 01:20:53.000000', 'temperatura', 1193.0000, 'ºC'),
	(266400, 118, '2014-04-01 01:20:54.000000', 'temperatura', 1007.0000, 'ºC'),
	(266401, 118, '2014-04-01 01:20:55.000000', 'temperatura', 254.0000, 'ºC'),
	(266402, 118, '2014-04-01 01:20:56.000000', 'temperatura', 652.0000, 'ºC'),
	(266403, 118, '2014-04-01 01:20:57.000000', 'temperatura', 99.0000, 'ºC'),
	(266404, 118, '2014-04-01 01:20:58.000000', 'temperatura', 940.0000, 'ºC'),
	(266405, 118, '2014-04-01 01:20:59.000000', 'temperatura', 803.0000, 'ºC'),
	(266406, 118, '2014-04-01 01:21:00.000000', 'temperatura', 1193.0000, 'ºC'),
	(266407, 118, '2014-04-01 01:21:01.000000', 'temperatura', 1159.0000, 'ºC'),
	(266408, 118, '2014-04-01 01:21:02.000000', 'temperatura', 1014.0000, 'ºC'),
	(266409, 118, '2014-04-01 01:21:03.000000', 'temperatura', 395.0000, 'ºC'),
	(266410, 118, '2014-04-01 01:21:04.000000', 'temperatura', 132.0000, 'ºC'),
	(266411, 118, '2014-04-01 01:21:05.000000', 'temperatura', 675.0000, 'ºC'),
	(266412, 118, '2014-04-01 01:21:06.000000', 'temperatura', 579.0000, 'ºC'),
	(266413, 118, '2014-04-01 01:21:07.000000', 'temperatura', 870.0000, 'ºC'),
	(266414, 118, '2014-04-01 01:21:08.000000', 'temperatura', 213.0000, 'ºC'),
	(266415, 118, '2014-04-01 01:21:09.000000', 'temperatura', 855.0000, 'ºC'),
	(266416, 118, '2014-04-01 01:21:10.000000', 'temperatura', 37.0000, 'ºC'),
	(266417, 118, '2014-04-01 01:21:11.000000', 'temperatura', 19.0000, 'ºC'),
	(266418, 118, '2014-04-01 01:21:12.000000', 'temperatura', 1186.0000, 'ºC'),
	(266419, 118, '2014-04-01 01:21:13.000000', 'temperatura', 1074.0000, 'ºC'),
	(266420, 118, '2014-04-01 01:21:14.000000', 'temperatura', 613.0000, 'ºC'),
	(266421, 118, '2014-04-01 01:21:15.000000', 'temperatura', 1042.0000, 'ºC'),
	(266422, 118, '2014-04-01 01:21:16.000000', 'temperatura', 972.0000, 'ºC'),
	(266423, 118, '2014-04-01 01:21:17.000000', 'temperatura', 535.0000, 'ºC'),
	(266424, 118, '2014-04-01 01:21:18.000000', 'temperatura', 961.0000, 'ºC'),
	(266425, 118, '2014-04-01 01:21:19.000000', 'temperatura', 799.0000, 'ºC'),
	(266426, 118, '2014-04-01 01:21:20.000000', 'temperatura', 1111.0000, 'ºC'),
	(266427, 118, '2014-04-01 01:21:21.000000', 'temperatura', 762.0000, 'ºC'),
	(266428, 118, '2014-04-01 01:21:22.000000', 'temperatura', 475.0000, 'ºC'),
	(266429, 118, '2014-04-01 01:21:23.000000', 'temperatura', 88.0000, 'ºC'),
	(266430, 118, '2014-04-01 01:21:24.000000', 'temperatura', 219.0000, 'ºC'),
	(266431, 118, '2014-04-01 01:21:25.000000', 'temperatura', 830.0000, 'ºC'),
	(266432, 118, '2014-04-01 01:21:26.000000', 'temperatura', 1093.0000, 'ºC'),
	(266433, 118, '2014-04-01 01:21:27.000000', 'temperatura', 577.0000, 'ºC'),
	(266434, 118, '2014-04-01 01:21:28.000000', 'temperatura', 804.0000, 'ºC'),
	(266435, 118, '2014-04-01 01:21:29.000000', 'temperatura', 1090.0000, 'ºC'),
	(266436, 118, '2014-04-01 01:21:30.000000', 'temperatura', 639.0000, 'ºC'),
	(266437, 118, '2014-04-01 01:21:31.000000', 'temperatura', 1125.0000, 'ºC'),
	(266438, 118, '2014-04-01 01:21:32.000000', 'temperatura', 108.0000, 'ºC'),
	(266439, 118, '2014-04-01 01:21:33.000000', 'temperatura', 765.0000, 'ºC'),
	(266440, 118, '2014-04-01 01:21:34.000000', 'temperatura', 1102.0000, 'ºC'),
	(266441, 118, '2014-04-01 01:21:35.000000', 'temperatura', 814.0000, 'ºC'),
	(266442, 118, '2014-04-01 01:21:36.000000', 'temperatura', 764.0000, 'ºC'),
	(266443, 118, '2014-04-01 01:21:37.000000', 'temperatura', 178.0000, 'ºC'),
	(266444, 118, '2014-04-01 01:21:38.000000', 'temperatura', 1002.0000, 'ºC'),
	(266445, 118, '2014-04-01 01:21:39.000000', 'temperatura', 874.0000, 'ºC'),
	(266446, 118, '2014-04-01 01:21:40.000000', 'temperatura', 163.0000, 'ºC'),
	(266447, 118, '2014-04-01 01:21:41.000000', 'temperatura', 597.0000, 'ºC'),
	(266448, 118, '2014-04-01 01:21:42.000000', 'temperatura', 94.0000, 'ºC'),
	(266449, 118, '2014-04-01 01:21:43.000000', 'temperatura', 1079.0000, 'ºC'),
	(266450, 118, '2014-04-01 01:21:44.000000', 'temperatura', 314.0000, 'ºC'),
	(266451, 118, '2014-04-01 01:21:45.000000', 'temperatura', 732.0000, 'ºC'),
	(266452, 118, '2014-04-01 01:21:46.000000', 'temperatura', 321.0000, 'ºC'),
	(266453, 118, '2014-04-01 01:21:47.000000', 'temperatura', 610.0000, 'ºC'),
	(266454, 118, '2014-04-01 01:21:48.000000', 'temperatura', 887.0000, 'ºC'),
	(266455, 118, '2014-04-01 01:21:49.000000', 'temperatura', 205.0000, 'ºC'),
	(266456, 118, '2014-04-01 01:21:50.000000', 'temperatura', 764.0000, 'ºC'),
	(266457, 118, '2014-04-01 01:21:51.000000', 'temperatura', 804.0000, 'ºC'),
	(266458, 118, '2014-04-01 01:21:52.000000', 'temperatura', 529.0000, 'ºC'),
	(266459, 118, '2014-04-01 01:21:53.000000', 'temperatura', 235.0000, 'ºC'),
	(266460, 118, '2014-04-01 01:21:54.000000', 'temperatura', 787.0000, 'ºC'),
	(266461, 118, '2014-04-01 01:21:55.000000', 'temperatura', 831.0000, 'ºC'),
	(266462, 118, '2014-04-01 01:21:56.000000', 'temperatura', 597.0000, 'ºC'),
	(266463, 118, '2014-04-01 01:21:57.000000', 'temperatura', 489.0000, 'ºC'),
	(266464, 118, '2014-04-01 01:21:58.000000', 'temperatura', 655.0000, 'ºC'),
	(266465, 118, '2014-04-01 01:21:59.000000', 'temperatura', 610.0000, 'ºC'),
	(266466, 118, '2014-04-01 01:22:00.000000', 'temperatura', 1087.0000, 'ºC'),
	(266467, 118, '2014-04-01 01:22:01.000000', 'temperatura', 3.0000, 'ºC'),
	(266468, 118, '2014-04-01 01:22:02.000000', 'temperatura', 355.0000, 'ºC'),
	(266469, 118, '2014-04-01 01:22:03.000000', 'temperatura', 567.0000, 'ºC'),
	(266470, 118, '2014-04-01 01:22:04.000000', 'temperatura', 570.0000, 'ºC'),
	(266471, 118, '2014-04-01 01:22:05.000000', 'temperatura', 1151.0000, 'ºC'),
	(266472, 118, '2014-04-01 01:22:06.000000', 'temperatura', 446.0000, 'ºC'),
	(266473, 118, '2014-04-01 01:22:07.000000', 'temperatura', 1176.0000, 'ºC'),
	(266474, 118, '2014-04-01 01:22:08.000000', 'temperatura', 941.0000, 'ºC'),
	(266475, 118, '2014-04-01 01:22:09.000000', 'temperatura', 1179.0000, 'ºC'),
	(266476, 118, '2014-04-01 01:22:10.000000', 'temperatura', 671.0000, 'ºC'),
	(266477, 118, '2014-04-01 01:22:11.000000', 'temperatura', 1021.0000, 'ºC'),
	(266478, 118, '2014-04-01 01:22:12.000000', 'temperatura', 693.0000, 'ºC'),
	(266479, 118, '2014-04-01 01:22:13.000000', 'temperatura', 403.0000, 'ºC'),
	(266480, 118, '2014-04-01 01:22:14.000000', 'temperatura', 1136.0000, 'ºC'),
	(266481, 118, '2014-04-01 01:22:15.000000', 'temperatura', 873.0000, 'ºC'),
	(266482, 118, '2014-04-01 01:22:16.000000', 'temperatura', 957.0000, 'ºC'),
	(266483, 118, '2014-04-01 01:22:17.000000', 'temperatura', 966.0000, 'ºC'),
	(266484, 118, '2014-04-01 01:22:18.000000', 'temperatura', 760.0000, 'ºC'),
	(266485, 118, '2014-04-01 01:22:19.000000', 'temperatura', 901.0000, 'ºC'),
	(266486, 118, '2014-04-01 01:22:20.000000', 'temperatura', 1027.0000, 'ºC'),
	(266487, 118, '2014-04-01 01:22:21.000000', 'temperatura', 30.0000, 'ºC'),
	(266488, 118, '2014-04-01 01:22:22.000000', 'temperatura', 671.0000, 'ºC'),
	(266489, 118, '2014-04-01 01:22:23.000000', 'temperatura', 867.0000, 'ºC'),
	(266490, 118, '2014-04-01 01:22:24.000000', 'temperatura', 1123.0000, 'ºC'),
	(266491, 118, '2014-04-01 01:22:25.000000', 'temperatura', 614.0000, 'ºC'),
	(266492, 118, '2014-04-01 01:22:26.000000', 'temperatura', 900.0000, 'ºC'),
	(266493, 118, '2014-04-01 01:22:27.000000', 'temperatura', 257.0000, 'ºC'),
	(266494, 118, '2014-04-01 01:22:28.000000', 'temperatura', 988.0000, 'ºC'),
	(266495, 118, '2014-04-01 01:22:29.000000', 'temperatura', 570.0000, 'ºC'),
	(266496, 118, '2014-04-01 01:22:30.000000', 'temperatura', 1086.0000, 'ºC'),
	(266497, 118, '2014-04-01 01:22:31.000000', 'temperatura', 122.0000, 'ºC'),
	(266498, 118, '2014-04-01 01:22:32.000000', 'temperatura', 951.0000, 'ºC'),
	(266499, 118, '2014-04-01 01:22:33.000000', 'temperatura', 788.0000, 'ºC'),
	(266500, 118, '2014-04-01 01:22:34.000000', 'temperatura', 1088.0000, 'ºC'),
	(266501, 118, '2014-04-01 01:22:35.000000', 'temperatura', 675.0000, 'ºC'),
	(266502, 118, '2014-04-01 01:22:36.000000', 'temperatura', 113.0000, 'ºC'),
	(266503, 118, '2014-04-01 01:22:37.000000', 'temperatura', 941.0000, 'ºC'),
	(266504, 118, '2014-04-01 01:22:38.000000', 'temperatura', 768.0000, 'ºC'),
	(266505, 118, '2014-04-01 01:22:39.000000', 'temperatura', 1015.0000, 'ºC'),
	(266506, 118, '2014-04-01 01:22:40.000000', 'temperatura', 373.0000, 'ºC'),
	(266507, 118, '2014-04-01 01:22:41.000000', 'temperatura', 18.0000, 'ºC'),
	(266508, 118, '2014-04-01 01:22:42.000000', 'temperatura', 173.0000, 'ºC'),
	(266509, 118, '2014-04-01 01:22:43.000000', 'temperatura', 813.0000, 'ºC'),
	(266510, 118, '2014-04-01 01:22:44.000000', 'temperatura', 1144.0000, 'ºC'),
	(266511, 118, '2014-04-01 01:22:45.000000', 'temperatura', 881.0000, 'ºC'),
	(266512, 118, '2014-04-01 01:22:46.000000', 'temperatura', 973.0000, 'ºC'),
	(266513, 118, '2014-04-01 01:22:47.000000', 'temperatura', 1023.0000, 'ºC'),
	(266514, 118, '2014-04-01 01:22:48.000000', 'temperatura', 998.0000, 'ºC'),
	(266515, 118, '2014-04-01 01:22:49.000000', 'temperatura', 722.0000, 'ºC'),
	(266516, 118, '2014-04-01 01:22:50.000000', 'temperatura', 614.0000, 'ºC'),
	(266517, 118, '2014-04-01 01:22:51.000000', 'temperatura', 907.0000, 'ºC'),
	(266518, 118, '2014-04-01 01:22:52.000000', 'temperatura', 293.0000, 'ºC'),
	(266519, 118, '2014-04-01 01:22:53.000000', 'temperatura', 1146.0000, 'ºC'),
	(266520, 118, '2014-04-01 01:22:54.000000', 'temperatura', 48.0000, 'ºC'),
	(266521, 118, '2014-04-01 01:22:55.000000', 'temperatura', 406.0000, 'ºC'),
	(266522, 118, '2014-04-01 01:22:56.000000', 'temperatura', 683.0000, 'ºC'),
	(266523, 118, '2014-04-01 01:22:57.000000', 'temperatura', 1000.0000, 'ºC'),
	(266524, 118, '2014-04-01 01:22:58.000000', 'temperatura', 549.0000, 'ºC'),
	(266525, 118, '2014-04-01 01:22:59.000000', 'temperatura', 948.0000, 'ºC'),
	(266526, 118, '2014-04-01 01:23:00.000000', 'temperatura', 692.0000, 'ºC'),
	(266527, 118, '2014-04-01 01:23:01.000000', 'temperatura', 616.0000, 'ºC'),
	(266528, 118, '2014-04-01 01:23:02.000000', 'temperatura', 1004.0000, 'ºC'),
	(266529, 118, '2014-04-01 01:23:03.000000', 'temperatura', 774.0000, 'ºC'),
	(266530, 118, '2014-04-01 01:23:04.000000', 'temperatura', 856.0000, 'ºC'),
	(266531, 118, '2014-04-01 01:23:05.000000', 'temperatura', 762.0000, 'ºC'),
	(266532, 118, '2014-04-01 01:23:06.000000', 'temperatura', 39.0000, 'ºC'),
	(266533, 118, '2014-04-01 01:23:07.000000', 'temperatura', 312.0000, 'ºC'),
	(266534, 118, '2014-04-01 01:23:08.000000', 'temperatura', 243.0000, 'ºC'),
	(266535, 118, '2014-04-01 01:23:09.000000', 'temperatura', 278.0000, 'ºC'),
	(266536, 118, '2014-04-01 01:23:10.000000', 'temperatura', 663.0000, 'ºC'),
	(266537, 118, '2014-04-01 01:23:11.000000', 'temperatura', 82.0000, 'ºC'),
	(266538, 118, '2014-04-01 01:23:12.000000', 'temperatura', 822.0000, 'ºC'),
	(266539, 118, '2014-04-01 01:23:13.000000', 'temperatura', 263.0000, 'ºC'),
	(266540, 118, '2014-04-01 01:23:14.000000', 'temperatura', 52.0000, 'ºC'),
	(266541, 118, '2014-04-01 01:23:15.000000', 'temperatura', 669.0000, 'ºC'),
	(266542, 118, '2014-04-01 01:23:16.000000', 'temperatura', 790.0000, 'ºC'),
	(266543, 118, '2014-04-01 01:23:17.000000', 'temperatura', 743.0000, 'ºC'),
	(266544, 118, '2014-04-01 01:23:18.000000', 'temperatura', 146.0000, 'ºC'),
	(266545, 118, '2014-04-01 01:23:19.000000', 'temperatura', 903.0000, 'ºC'),
	(266546, 118, '2014-04-01 01:23:20.000000', 'temperatura', 476.0000, 'ºC'),
	(266547, 118, '2014-04-01 01:23:21.000000', 'temperatura', 872.0000, 'ºC'),
	(266548, 118, '2014-04-01 01:23:22.000000', 'temperatura', 533.0000, 'ºC'),
	(266549, 118, '2014-04-01 01:23:23.000000', 'temperatura', 49.0000, 'ºC'),
	(266550, 118, '2014-04-01 01:23:24.000000', 'temperatura', 1048.0000, 'ºC'),
	(266551, 118, '2014-04-01 01:23:25.000000', 'temperatura', 292.0000, 'ºC'),
	(266552, 118, '2014-04-01 01:23:26.000000', 'temperatura', 716.0000, 'ºC'),
	(266553, 118, '2014-04-01 01:23:27.000000', 'temperatura', 306.0000, 'ºC'),
	(266554, 118, '2014-04-01 01:23:28.000000', 'temperatura', 583.0000, 'ºC'),
	(266555, 118, '2014-04-01 01:23:29.000000', 'temperatura', 798.0000, 'ºC'),
	(266556, 118, '2014-04-01 01:23:30.000000', 'temperatura', 1042.0000, 'ºC'),
	(266557, 118, '2014-04-01 01:23:31.000000', 'temperatura', 413.0000, 'ºC'),
	(266558, 118, '2014-04-01 01:23:32.000000', 'temperatura', 143.0000, 'ºC'),
	(266559, 118, '2014-04-01 01:23:33.000000', 'temperatura', 676.0000, 'ºC'),
	(266560, 118, '2014-04-01 01:23:34.000000', 'temperatura', 552.0000, 'ºC'),
	(266561, 118, '2014-04-01 01:23:35.000000', 'temperatura', 731.0000, 'ºC'),
	(266562, 118, '2014-04-01 01:23:36.000000', 'temperatura', 800.0000, 'ºC'),
	(266563, 118, '2014-04-01 01:23:37.000000', 'temperatura', 608.0000, 'ºC'),
	(266564, 118, '2014-04-01 01:23:38.000000', 'temperatura', 639.0000, 'ºC'),
	(266565, 118, '2014-04-01 01:23:39.000000', 'temperatura', 174.0000, 'ºC'),
	(266566, 118, '2014-04-01 01:23:40.000000', 'temperatura', 154.0000, 'ºC'),
	(266567, 118, '2014-04-01 01:23:41.000000', 'temperatura', 245.0000, 'ºC'),
	(266568, 118, '2014-04-01 01:23:42.000000', 'temperatura', 767.0000, 'ºC'),
	(266569, 118, '2014-04-01 01:23:43.000000', 'temperatura', 698.0000, 'ºC'),
	(266570, 118, '2014-04-01 01:23:44.000000', 'temperatura', 1192.0000, 'ºC'),
	(266571, 118, '2014-04-01 01:23:45.000000', 'temperatura', 264.0000, 'ºC'),
	(266572, 118, '2014-04-01 01:23:46.000000', 'temperatura', 147.0000, 'ºC'),
	(266573, 118, '2014-04-01 01:23:47.000000', 'temperatura', 1144.0000, 'ºC'),
	(266574, 118, '2014-04-01 01:23:48.000000', 'temperatura', 478.0000, 'ºC'),
	(266575, 118, '2014-04-01 01:23:49.000000', 'temperatura', 158.0000, 'ºC'),
	(266576, 118, '2014-04-01 01:23:50.000000', 'temperatura', 557.0000, 'ºC'),
	(266577, 118, '2014-04-01 01:23:51.000000', 'temperatura', 1110.0000, 'ºC'),
	(266578, 118, '2014-04-01 01:23:52.000000', 'temperatura', 282.0000, 'ºC'),
	(266579, 118, '2014-04-01 01:23:53.000000', 'temperatura', 481.0000, 'ºC'),
	(266580, 118, '2014-04-01 01:23:54.000000', 'temperatura', 359.0000, 'ºC'),
	(266581, 118, '2014-04-01 01:23:55.000000', 'temperatura', 352.0000, 'ºC'),
	(266582, 118, '2014-04-01 01:23:56.000000', 'temperatura', 682.0000, 'ºC'),
	(266583, 118, '2014-04-01 01:23:57.000000', 'temperatura', 1155.0000, 'ºC'),
	(266584, 118, '2014-04-01 01:23:58.000000', 'temperatura', 130.0000, 'ºC'),
	(266585, 118, '2014-04-01 01:23:59.000000', 'temperatura', 784.0000, 'ºC'),
	(266586, 118, '2014-04-01 01:24:00.000000', 'temperatura', 1131.0000, 'ºC'),
	(266587, 118, '2014-04-01 01:24:01.000000', 'temperatura', 902.0000, 'ºC'),
	(266588, 118, '2014-04-01 01:24:02.000000', 'temperatura', 1119.0000, 'ºC'),
	(266589, 118, '2014-04-01 01:24:03.000000', 'temperatura', 488.0000, 'ºC'),
	(266590, 118, '2014-04-01 01:24:04.000000', 'temperatura', 283.0000, 'ºC'),
	(266591, 118, '2014-04-01 01:24:05.000000', 'temperatura', 1152.0000, 'ºC'),
	(266592, 118, '2014-04-01 01:24:06.000000', 'temperatura', 114.0000, 'ºC'),
	(266593, 118, '2014-04-01 01:24:07.000000', 'temperatura', 711.0000, 'ºC'),
	(266594, 118, '2014-04-01 01:24:08.000000', 'temperatura', 817.0000, 'ºC'),
	(266595, 118, '2014-04-01 01:24:09.000000', 'temperatura', 750.0000, 'ºC'),
	(266596, 118, '2014-04-01 01:24:10.000000', 'temperatura', 99.0000, 'ºC'),
	(266597, 118, '2014-04-01 01:24:11.000000', 'temperatura', 647.0000, 'ºC'),
	(266598, 118, '2014-04-01 01:24:12.000000', 'temperatura', 537.0000, 'ºC'),
	(266599, 118, '2014-04-01 01:24:13.000000', 'temperatura', 744.0000, 'ºC'),
	(266600, 118, '2014-04-01 01:24:14.000000', 'temperatura', 910.0000, 'ºC'),
	(266601, 118, '2014-04-01 01:24:15.000000', 'temperatura', 1119.0000, 'ºC'),
	(266602, 118, '2014-04-01 01:24:16.000000', 'temperatura', 464.0000, 'ºC'),
	(266603, 118, '2014-04-01 01:24:17.000000', 'temperatura', 165.0000, 'ºC'),
	(266604, 118, '2014-04-01 01:24:18.000000', 'temperatura', 633.0000, 'ºC'),
	(266605, 118, '2014-04-01 01:24:19.000000', 'temperatura', 269.0000, 'ºC'),
	(266606, 118, '2014-04-01 01:24:20.000000', 'temperatura', 646.0000, 'ºC'),
	(266607, 118, '2014-04-01 01:24:21.000000', 'temperatura', 24.0000, 'ºC'),
	(266608, 118, '2014-04-01 01:24:22.000000', 'temperatura', 581.0000, 'ºC'),
	(266609, 118, '2014-04-01 01:24:23.000000', 'temperatura', 436.0000, 'ºC'),
	(266610, 118, '2014-04-01 01:24:24.000000', 'temperatura', 437.0000, 'ºC'),
	(266611, 118, '2014-04-01 01:24:25.000000', 'temperatura', 877.0000, 'ºC'),
	(266612, 118, '2014-04-01 01:24:26.000000', 'temperatura', 675.0000, 'ºC'),
	(266613, 118, '2014-04-01 01:24:27.000000', 'temperatura', 742.0000, 'ºC'),
	(266614, 118, '2014-04-01 01:24:28.000000', 'temperatura', 489.0000, 'ºC'),
	(266615, 118, '2014-04-01 01:24:29.000000', 'temperatura', 218.0000, 'ºC'),
	(266616, 118, '2014-04-01 01:24:30.000000', 'temperatura', 824.0000, 'ºC'),
	(266617, 118, '2014-04-01 01:24:31.000000', 'temperatura', 1067.0000, 'ºC'),
	(266618, 118, '2014-04-01 01:24:32.000000', 'temperatura', 464.0000, 'ºC'),
	(266619, 118, '2014-04-01 01:24:33.000000', 'temperatura', 319.0000, 'ºC'),
	(266620, 118, '2014-04-01 01:24:34.000000', 'temperatura', 203.0000, 'ºC'),
	(266621, 118, '2014-04-01 01:24:35.000000', 'temperatura', 59.0000, 'ºC'),
	(266622, 118, '2014-04-01 01:24:36.000000', 'temperatura', 885.0000, 'ºC'),
	(266623, 118, '2014-04-01 01:24:37.000000', 'temperatura', 650.0000, 'ºC'),
	(266624, 118, '2014-04-01 01:24:38.000000', 'temperatura', 596.0000, 'ºC'),
	(266625, 118, '2014-04-01 01:24:39.000000', 'temperatura', 1028.0000, 'ºC'),
	(266626, 118, '2014-04-01 01:24:40.000000', 'temperatura', 954.0000, 'ºC'),
	(266627, 118, '2014-04-01 01:24:41.000000', 'temperatura', 485.0000, 'ºC'),
	(266628, 118, '2014-04-01 01:24:42.000000', 'temperatura', 763.0000, 'ºC'),
	(266629, 118, '2014-04-01 01:24:43.000000', 'temperatura', 1160.0000, 'ºC'),
	(266630, 118, '2014-04-01 01:24:44.000000', 'temperatura', 1113.0000, 'ºC'),
	(266631, 118, '2014-04-01 01:24:45.000000', 'temperatura', 886.0000, 'ºC'),
	(266632, 118, '2014-04-01 01:24:46.000000', 'temperatura', 1091.0000, 'ºC'),
	(266633, 118, '2014-04-01 01:24:47.000000', 'temperatura', 396.0000, 'ºC'),
	(266634, 118, '2014-04-01 01:24:48.000000', 'temperatura', 1110.0000, 'ºC'),
	(266635, 118, '2014-04-01 01:24:49.000000', 'temperatura', 762.0000, 'ºC'),
	(266636, 118, '2014-04-01 01:24:50.000000', 'temperatura', 481.0000, 'ºC'),
	(266637, 118, '2014-04-01 01:24:51.000000', 'temperatura', 119.0000, 'ºC'),
	(266638, 118, '2014-04-01 01:24:52.000000', 'temperatura', 353.0000, 'ºC'),
	(266639, 118, '2014-04-01 01:24:53.000000', 'temperatura', 208.0000, 'ºC'),
	(266640, 118, '2014-04-01 01:24:54.000000', 'temperatura', 1180.0000, 'ºC'),
	(266641, 118, '2014-04-01 01:24:55.000000', 'temperatura', 477.0000, 'ºC'),
	(266642, 118, '2014-04-01 01:24:56.000000', 'temperatura', 44.0000, 'ºC'),
	(266643, 118, '2014-04-01 01:24:57.000000', 'temperatura', 1193.0000, 'ºC'),
	(266644, 118, '2014-04-01 01:24:58.000000', 'temperatura', 1030.0000, 'ºC'),
	(266645, 118, '2014-04-01 01:24:59.000000', 'temperatura', 375.0000, 'ºC'),
	(266646, 118, '2014-04-01 01:25:00.000000', 'temperatura', 1182.0000, 'ºC'),
	(266647, 118, '2014-04-01 01:25:01.000000', 'temperatura', 1188.0000, 'ºC'),
	(266648, 118, '2014-04-01 01:25:02.000000', 'temperatura', 1192.0000, 'ºC'),
	(266649, 118, '2014-04-01 01:25:03.000000', 'temperatura', 1198.0000, 'ºC'),
	(266650, 118, '2014-04-01 01:25:04.000000', 'temperatura', 15.0000, 'ºC'),
	(266651, 118, '2014-04-01 01:25:05.000000', 'temperatura', 80.0000, 'ºC'),
	(266652, 118, '2014-04-01 01:25:06.000000', 'temperatura', 355.0000, 'ºC'),
	(266653, 118, '2014-04-01 01:25:07.000000', 'temperatura', 334.0000, 'ºC'),
	(266654, 118, '2014-04-01 01:25:08.000000', 'temperatura', 609.0000, 'ºC'),
	(266655, 118, '2014-04-01 01:25:09.000000', 'temperatura', 843.0000, 'ºC'),
	(266656, 118, '2014-04-01 01:25:10.000000', 'temperatura', 1189.0000, 'ºC'),
	(266657, 118, '2014-04-01 01:25:11.000000', 'temperatura', 1015.0000, 'ºC'),
	(266658, 118, '2014-04-01 01:25:12.000000', 'temperatura', 311.0000, 'ºC'),
	(266659, 118, '2014-04-01 01:25:13.000000', 'temperatura', 910.0000, 'ºC'),
	(266660, 118, '2014-04-01 01:25:14.000000', 'temperatura', 16.0000, 'ºC'),
	(266661, 118, '2014-04-01 01:25:15.000000', 'temperatura', 950.0000, 'ºC'),
	(266662, 118, '2014-04-01 01:25:16.000000', 'temperatura', 1102.0000, 'ºC'),
	(266663, 118, '2014-04-01 01:25:17.000000', 'temperatura', 261.0000, 'ºC'),
	(266664, 118, '2014-04-01 01:25:18.000000', 'temperatura', 400.0000, 'ºC'),
	(266665, 118, '2014-04-01 01:25:19.000000', 'temperatura', 17.0000, 'ºC'),
	(266666, 118, '2014-04-01 01:25:20.000000', 'temperatura', 84.0000, 'ºC'),
	(266667, 118, '2014-04-01 01:25:21.000000', 'temperatura', 370.0000, 'ºC'),
	(266668, 118, '2014-04-01 01:25:22.000000', 'temperatura', 401.0000, 'ºC'),
	(266669, 118, '2014-04-01 01:25:23.000000', 'temperatura', 893.0000, 'ºC'),
	(266670, 118, '2014-04-01 01:25:24.000000', 'temperatura', 865.0000, 'ºC'),
	(266671, 118, '2014-04-01 01:25:25.000000', 'temperatura', 444.0000, 'ºC'),
	(266672, 118, '2014-04-01 01:25:26.000000', 'temperatura', 824.0000, 'ºC'),
	(266673, 118, '2014-04-01 01:25:27.000000', 'temperatura', 392.0000, 'ºC'),
	(266674, 118, '2014-04-01 01:25:28.000000', 'temperatura', 687.0000, 'ºC'),
	(266675, 118, '2014-04-01 01:25:29.000000', 'temperatura', 1062.0000, 'ºC'),
	(266676, 118, '2014-04-01 01:25:30.000000', 'temperatura', 847.0000, 'ºC'),
	(266677, 118, '2014-04-01 01:25:31.000000', 'temperatura', 1050.0000, 'ºC'),
	(266678, 118, '2014-04-01 01:25:32.000000', 'temperatura', 308.0000, 'ºC'),
	(266679, 118, '2014-04-01 01:25:33.000000', 'temperatura', 790.0000, 'ºC'),
	(266680, 118, '2014-04-01 01:25:34.000000', 'temperatura', 627.0000, 'ºC'),
	(266681, 118, '2014-04-01 01:25:35.000000', 'temperatura', 764.0000, 'ºC'),
	(266682, 118, '2014-04-01 01:25:36.000000', 'temperatura', 741.0000, 'ºC'),
	(266683, 118, '2014-04-01 01:25:37.000000', 'temperatura', 215.0000, 'ºC'),
	(266684, 118, '2014-04-01 01:25:38.000000', 'temperatura', 50.0000, 'ºC'),
	(266685, 118, '2014-04-01 01:25:39.000000', 'temperatura', 808.0000, 'ºC'),
	(266686, 118, '2014-04-01 01:25:40.000000', 'temperatura', 288.0000, 'ºC'),
	(266687, 118, '2014-04-01 01:25:41.000000', 'temperatura', 217.0000, 'ºC'),
	(266688, 118, '2014-04-01 01:25:42.000000', 'temperatura', 222.0000, 'ºC'),
	(266689, 118, '2014-04-01 01:25:43.000000', 'temperatura', 460.0000, 'ºC'),
	(266690, 118, '2014-04-01 01:25:44.000000', 'temperatura', 433.0000, 'ºC'),
	(266691, 118, '2014-04-01 01:25:45.000000', 'temperatura', 787.0000, 'ºC'),
	(266692, 118, '2014-04-01 01:25:46.000000', 'temperatura', 238.0000, 'ºC'),
	(266693, 118, '2014-04-01 01:25:47.000000', 'temperatura', 27.0000, 'ºC'),
	(266694, 118, '2014-04-01 01:25:48.000000', 'temperatura', 622.0000, 'ºC'),
	(266695, 118, '2014-04-01 01:25:49.000000', 'temperatura', 628.0000, 'ºC'),
	(266696, 118, '2014-04-01 01:25:50.000000', 'temperatura', 76.0000, 'ºC'),
	(266697, 118, '2014-04-01 01:25:51.000000', 'temperatura', 896.0000, 'ºC'),
	(266698, 118, '2014-04-01 01:25:52.000000', 'temperatura', 651.0000, 'ºC'),
	(266699, 118, '2014-04-01 01:25:53.000000', 'temperatura', 568.0000, 'ºC'),
	(266700, 118, '2014-04-01 01:25:54.000000', 'temperatura', 888.0000, 'ºC'),
	(266701, 118, '2014-04-01 01:25:55.000000', 'temperatura', 335.0000, 'ºC'),
	(266702, 118, '2014-04-01 01:25:56.000000', 'temperatura', 212.0000, 'ºC'),
	(266703, 118, '2014-04-01 01:25:57.000000', 'temperatura', 55.0000, 'ºC'),
	(266704, 118, '2014-04-01 01:25:58.000000', 'temperatura', 839.0000, 'ºC'),
	(266705, 118, '2014-04-01 01:25:59.000000', 'temperatura', 433.0000, 'ºC'),
	(266706, 118, '2014-04-01 01:26:00.000000', 'temperatura', 846.0000, 'ºC'),
	(266707, 118, '2014-04-01 01:26:01.000000', 'temperatura', 531.0000, 'ºC'),
	(266708, 118, '2014-04-01 01:26:02.000000', 'temperatura', 119.0000, 'ºC'),
	(266709, 118, '2014-04-01 01:26:03.000000', 'temperatura', 202.0000, 'ºC'),
	(266710, 118, '2014-04-01 01:26:04.000000', 'temperatura', 653.0000, 'ºC'),
	(266711, 118, '2014-04-01 01:26:05.000000', 'temperatura', 261.0000, 'ºC'),
	(266712, 118, '2014-04-01 01:26:06.000000', 'temperatura', 547.0000, 'ºC'),
	(266713, 118, '2014-04-01 01:26:07.000000', 'temperatura', 752.0000, 'ºC'),
	(266714, 118, '2014-04-01 01:26:08.000000', 'temperatura', 918.0000, 'ºC'),
	(266715, 118, '2014-04-01 01:26:09.000000', 'temperatura', 1137.0000, 'ºC'),
	(266716, 118, '2014-04-01 01:26:10.000000', 'temperatura', 532.0000, 'ºC'),
	(266717, 118, '2014-04-01 01:26:11.000000', 'temperatura', 449.0000, 'ºC'),
	(266718, 118, '2014-04-01 01:26:12.000000', 'temperatura', 650.0000, 'ºC'),
	(266719, 118, '2014-04-01 01:26:13.000000', 'temperatura', 701.0000, 'ºC'),
	(266720, 118, '2014-04-01 01:26:14.000000', 'temperatura', 357.0000, 'ºC'),
	(266721, 118, '2014-04-01 01:26:15.000000', 'temperatura', 883.0000, 'ºC'),
	(266722, 118, '2014-04-01 01:26:16.000000', 'temperatura', 943.0000, 'ºC'),
	(266723, 118, '2014-04-01 01:26:17.000000', 'temperatura', 869.0000, 'ºC'),
	(266724, 118, '2014-04-01 01:26:18.000000', 'temperatura', 316.0000, 'ºC'),
	(266725, 118, '2014-04-01 01:26:19.000000', 'temperatura', 173.0000, 'ºC'),
	(266726, 118, '2014-04-01 01:26:20.000000', 'temperatura', 1118.0000, 'ºC'),
	(266727, 118, '2014-04-01 01:26:21.000000', 'temperatura', 269.0000, 'ºC'),
	(266728, 118, '2014-04-01 01:26:22.000000', 'temperatura', 393.0000, 'ºC'),
	(266729, 118, '2014-04-01 01:26:23.000000', 'temperatura', 1158.0000, 'ºC'),
	(266730, 118, '2014-04-01 01:26:24.000000', 'temperatura', 1013.0000, 'ºC'),
	(266731, 118, '2014-04-01 01:26:25.000000', 'temperatura', 393.0000, 'ºC'),
	(266732, 118, '2014-04-01 01:26:26.000000', 'temperatura', 124.0000, 'ºC'),
	(266733, 118, '2014-04-01 01:26:27.000000', 'temperatura', 642.0000, 'ºC'),
	(266734, 118, '2014-04-01 01:26:28.000000', 'temperatura', 438.0000, 'ºC'),
	(266735, 118, '2014-04-01 01:26:29.000000', 'temperatura', 263.0000, 'ºC'),
	(266736, 118, '2014-04-01 01:26:30.000000', 'temperatura', 4.0000, 'ºC'),
	(266737, 118, '2014-04-01 01:26:31.000000', 'temperatura', 432.0000, 'ºC'),
	(266738, 118, '2014-04-01 01:26:32.000000', 'temperatura', 946.0000, 'ºC'),
	(266739, 118, '2014-04-01 01:26:33.000000', 'temperatura', 1034.0000, 'ºC'),
	(266740, 118, '2014-04-01 01:26:34.000000', 'temperatura', 1134.0000, 'ºC'),
	(266741, 118, '2014-04-01 01:26:35.000000', 'temperatura', 170.0000, 'ºC'),
	(266742, 118, '2014-04-01 01:26:36.000000', 'temperatura', 1046.0000, 'ºC'),
	(266743, 118, '2014-04-01 01:26:37.000000', 'temperatura', 1124.0000, 'ºC'),
	(266744, 118, '2014-04-01 01:26:38.000000', 'temperatura', 79.0000, 'ºC'),
	(266745, 118, '2014-04-01 01:26:39.000000', 'temperatura', 623.0000, 'ºC'),
	(266746, 118, '2014-04-01 01:26:40.000000', 'temperatura', 479.0000, 'ºC'),
	(266747, 118, '2014-04-01 01:26:41.000000', 'temperatura', 528.0000, 'ºC'),
	(266748, 118, '2014-04-01 01:26:42.000000', 'temperatura', 1.0000, 'ºC'),
	(266749, 118, '2014-04-01 01:26:43.000000', 'temperatura', 825.0000, 'ºC'),
	(266750, 118, '2014-04-01 01:26:44.000000', 'temperatura', 519.0000, 'ºC'),
	(266751, 118, '2014-04-01 01:26:45.000000', 'temperatura', 123.0000, 'ºC'),
	(266752, 118, '2014-04-01 01:26:46.000000', 'temperatura', 257.0000, 'ºC'),
	(266753, 118, '2014-04-01 01:26:47.000000', 'temperatura', 917.0000, 'ºC'),
	(266754, 118, '2014-04-01 01:26:48.000000', 'temperatura', 214.0000, 'ºC'),
	(266755, 118, '2014-04-01 01:26:49.000000', 'temperatura', 720.0000, 'ºC'),
	(266756, 118, '2014-04-01 01:26:50.000000', 'temperatura', 560.0000, 'ºC'),
	(266757, 118, '2014-04-01 01:26:51.000000', 'temperatura', 639.0000, 'ºC'),
	(266758, 118, '2014-04-01 01:26:52.000000', 'temperatura', 316.0000, 'ºC'),
	(266759, 118, '2014-04-01 01:26:53.000000', 'temperatura', 863.0000, 'ºC'),
	(266760, 118, '2014-04-01 01:26:54.000000', 'temperatura', 969.0000, 'ºC'),
	(266761, 118, '2014-04-01 01:26:55.000000', 'temperatura', 1056.0000, 'ºC'),
	(266762, 118, '2014-04-01 01:26:56.000000', 'temperatura', 1172.0000, 'ºC'),
	(266763, 118, '2014-04-01 01:26:57.000000', 'temperatura', 293.0000, 'ºC'),
	(266764, 118, '2014-04-01 01:26:58.000000', 'temperatura', 350.0000, 'ºC'),
	(266765, 118, '2014-04-01 01:26:59.000000', 'temperatura', 869.0000, 'ºC'),
	(266766, 118, '2014-04-01 01:27:00.000000', 'temperatura', 898.0000, 'ºC'),
	(266767, 118, '2014-04-01 01:27:01.000000', 'temperatura', 683.0000, 'ºC'),
	(266768, 118, '2014-04-01 01:27:02.000000', 'temperatura', 719.0000, 'ºC'),
	(266769, 118, '2014-04-01 01:27:03.000000', 'temperatura', 350.0000, 'ºC'),
	(266770, 118, '2014-04-01 01:27:04.000000', 'temperatura', 791.0000, 'ºC'),
	(266771, 118, '2014-04-01 01:27:05.000000', 'temperatura', 508.0000, 'ºC'),
	(266772, 118, '2014-04-01 01:27:06.000000', 'temperatura', 167.0000, 'ºC'),
	(266773, 118, '2014-04-01 01:27:07.000000', 'temperatura', 512.0000, 'ºC'),
	(266774, 118, '2014-04-01 01:27:08.000000', 'temperatura', 858.0000, 'ºC'),
	(266775, 118, '2014-04-01 01:27:09.000000', 'temperatura', 357.0000, 'ºC'),
	(266776, 118, '2014-04-01 01:27:10.000000', 'temperatura', 411.0000, 'ºC'),
	(266777, 118, '2014-04-01 01:27:11.000000', 'temperatura', 982.0000, 'ºC'),
	(266778, 118, '2014-04-01 01:27:12.000000', 'temperatura', 78.0000, 'ºC'),
	(266779, 118, '2014-04-01 01:27:13.000000', 'temperatura', 1047.0000, 'ºC'),
	(266780, 118, '2014-04-01 01:27:14.000000', 'temperatura', 200.0000, 'ºC'),
	(266781, 118, '2014-04-01 01:27:15.000000', 'temperatura', 259.0000, 'ºC'),
	(266782, 118, '2014-04-01 01:27:16.000000', 'temperatura', 694.0000, 'ºC'),
	(266783, 118, '2014-04-01 01:27:17.000000', 'temperatura', 295.0000, 'ºC'),
	(266784, 118, '2014-04-01 01:27:18.000000', 'temperatura', 591.0000, 'ºC'),
	(266785, 118, '2014-04-01 01:27:19.000000', 'temperatura', 874.0000, 'ºC'),
	(266786, 118, '2014-04-01 01:27:20.000000', 'temperatura', 196.0000, 'ºC'),
	(266787, 118, '2014-04-01 01:27:21.000000', 'temperatura', 758.0000, 'ºC'),
	(266788, 118, '2014-04-01 01:27:22.000000', 'temperatura', 802.0000, 'ºC'),
	(266789, 118, '2014-04-01 01:27:23.000000', 'temperatura', 539.0000, 'ºC'),
	(266790, 118, '2014-04-01 01:27:24.000000', 'temperatura', 288.0000, 'ºC'),
	(266791, 118, '2014-04-01 01:27:25.000000', 'temperatura', 1026.0000, 'ºC'),
	(266792, 118, '2014-04-01 01:27:26.000000', 'temperatura', 664.0000, 'ºC'),
	(266793, 118, '2014-04-01 01:27:27.000000', 'temperatura', 243.0000, 'ºC'),
	(266794, 118, '2014-04-01 01:27:28.000000', 'temperatura', 422.0000, 'ºC'),
	(266795, 118, '2014-04-01 01:27:29.000000', 'temperatura', 183.0000, 'ºC'),
	(266796, 118, '2014-04-01 01:27:30.000000', 'temperatura', 848.0000, 'ºC'),
	(266797, 118, '2014-04-01 01:27:31.000000', 'temperatura', 91.0000, 'ºC'),
	(266798, 118, '2014-04-01 01:27:32.000000', 'temperatura', 312.0000, 'ºC'),
	(266799, 118, '2014-04-01 01:27:33.000000', 'temperatura', 87.0000, 'ºC'),
	(266800, 118, '2014-04-01 01:27:34.000000', 'temperatura', 700.0000, 'ºC'),
	(266801, 118, '2014-04-01 01:27:35.000000', 'temperatura', 838.0000, 'ºC'),
	(266802, 118, '2014-04-01 01:27:36.000000', 'temperatura', 890.0000, 'ºC'),
	(266803, 118, '2014-04-01 01:27:37.000000', 'temperatura', 737.0000, 'ºC'),
	(266804, 118, '2014-04-01 01:27:38.000000', 'temperatura', 1018.0000, 'ºC'),
	(266805, 118, '2014-04-01 01:27:39.000000', 'temperatura', 476.0000, 'ºC'),
	(266806, 118, '2014-04-01 01:27:40.000000', 'temperatura', 528.0000, 'ºC'),
	(266807, 118, '2014-04-01 01:27:41.000000', 'temperatura', 12.0000, 'ºC'),
	(266808, 118, '2014-04-01 01:27:42.000000', 'temperatura', 876.0000, 'ºC'),
	(266809, 118, '2014-04-01 01:27:43.000000', 'temperatura', 744.0000, 'ºC'),
	(266810, 118, '2014-04-01 01:27:44.000000', 'temperatura', 1094.0000, 'ºC'),
	(266811, 118, '2014-04-01 01:27:45.000000', 'temperatura', 839.0000, 'ºC'),
	(266812, 118, '2014-04-01 01:27:46.000000', 'temperatura', 913.0000, 'ºC'),
	(266813, 118, '2014-04-01 01:27:47.000000', 'temperatura', 848.0000, 'ºC'),
	(266814, 118, '2014-04-01 01:27:48.000000', 'temperatura', 303.0000, 'ºC'),
	(266815, 118, '2014-04-01 01:27:49.000000', 'temperatura', 170.0000, 'ºC'),
	(266816, 118, '2014-04-01 01:27:50.000000', 'temperatura', 1141.0000, 'ºC'),
	(266817, 118, '2014-04-01 01:27:51.000000', 'temperatura', 396.0000, 'ºC'),
	(266818, 118, '2014-04-01 01:27:52.000000', 'temperatura', 960.0000, 'ºC'),
	(266819, 118, '2014-04-01 01:27:53.000000', 'temperatura', 9.0000, 'ºC'),
	(266820, 118, '2014-04-01 01:27:54.000000', 'temperatura', 767.0000, 'ºC'),
	(266821, 118, '2014-04-01 01:27:55.000000', 'temperatura', 210.0000, 'ºC'),
	(266822, 118, '2014-04-01 01:27:56.000000', 'temperatura', 1150.0000, 'ºC'),
	(266823, 118, '2014-04-01 01:27:57.000000', 'temperatura', 319.0000, 'ºC'),
	(266824, 118, '2014-04-01 01:27:58.000000', 'temperatura', 545.0000, 'ºC'),
	(266825, 118, '2014-04-01 01:27:59.000000', 'temperatura', 569.0000, 'ºC'),
	(266826, 118, '2014-04-01 01:28:00.000000', 'temperatura', 12.0000, 'ºC'),
	(266827, 118, '2014-04-01 01:28:01.000000', 'temperatura', 754.0000, 'ºC'),
	(266828, 118, '2014-04-01 01:28:02.000000', 'temperatura', 134.0000, 'ºC'),
	(266829, 118, '2014-04-01 01:28:03.000000', 'temperatura', 808.0000, 'ºC'),
	(266830, 118, '2014-04-01 01:28:04.000000', 'temperatura', 37.0000, 'ºC'),
	(266831, 118, '2014-04-01 01:28:05.000000', 'temperatura', 162.0000, 'ºC'),
	(266832, 118, '2014-04-01 01:28:06.000000', 'temperatura', 701.0000, 'ºC'),
	(266833, 118, '2014-04-01 01:28:07.000000', 'temperatura', 619.0000, 'ºC'),
	(266834, 118, '2014-04-01 01:28:08.000000', 'temperatura', 994.0000, 'ºC'),
	(266835, 118, '2014-04-01 01:28:09.000000', 'temperatura', 714.0000, 'ºC'),
	(266836, 118, '2014-04-01 01:28:10.000000', 'temperatura', 587.0000, 'ºC'),
	(266837, 118, '2014-04-01 01:28:11.000000', 'temperatura', 793.0000, 'ºC'),
	(266838, 118, '2014-04-01 01:28:12.000000', 'temperatura', 1004.0000, 'ºC'),
	(266839, 118, '2014-04-01 01:28:13.000000', 'temperatura', 244.0000, 'ºC'),
	(266840, 118, '2014-04-01 01:28:14.000000', 'temperatura', 608.0000, 'ºC'),
	(266841, 118, '2014-04-01 01:28:15.000000', 'temperatura', 1108.0000, 'ºC'),
	(266842, 118, '2014-04-01 01:28:16.000000', 'temperatura', 118.0000, 'ºC'),
	(266843, 118, '2014-04-01 01:28:17.000000', 'temperatura', 866.0000, 'ºC'),
	(266844, 118, '2014-04-01 01:28:18.000000', 'temperatura', 374.0000, 'ºC'),
	(266845, 118, '2014-04-01 01:28:19.000000', 'temperatura', 475.0000, 'ºC'),
	(266846, 118, '2014-04-01 01:28:20.000000', 'temperatura', 54.0000, 'ºC'),
	(266847, 118, '2014-04-01 01:28:21.000000', 'temperatura', 43.0000, 'ºC'),
	(266848, 118, '2014-04-01 01:28:22.000000', 'temperatura', 53.0000, 'ºC'),
	(266849, 118, '2014-04-01 01:28:23.000000', 'temperatura', 138.0000, 'ºC'),
	(266850, 118, '2014-04-01 01:28:24.000000', 'temperatura', 531.0000, 'ºC'),
	(266851, 118, '2014-04-01 01:28:25.000000', 'temperatura', 1042.0000, 'ºC'),
	(266852, 118, '2014-04-01 01:28:26.000000', 'temperatura', 17.0000, 'ºC'),
	(266853, 118, '2014-04-01 01:28:27.000000', 'temperatura', 558.0000, 'ºC'),
	(266854, 118, '2014-04-01 01:28:28.000000', 'temperatura', 341.0000, 'ºC'),
	(266855, 118, '2014-04-01 01:28:29.000000', 'temperatura', 30.0000, 'ºC'),
	(266856, 118, '2014-04-01 01:28:30.000000', 'temperatura', 328.0000, 'ºC'),
	(266857, 118, '2014-04-01 01:28:31.000000', 'temperatura', 351.0000, 'ºC'),
	(266858, 118, '2014-04-01 01:28:32.000000', 'temperatura', 772.0000, 'ºC'),
	(266859, 118, '2014-04-01 01:28:33.000000', 'temperatura', 408.0000, 'ºC'),
	(266860, 118, '2014-04-01 01:28:34.000000', 'temperatura', 925.0000, 'ºC'),
	(266861, 118, '2014-04-01 01:28:35.000000', 'temperatura', 1003.0000, 'ºC'),
	(266862, 118, '2014-04-01 01:28:36.000000', 'temperatura', 1037.0000, 'ºC'),
	(266863, 118, '2014-04-01 01:28:37.000000', 'temperatura', 978.0000, 'ºC'),
	(266864, 118, '2014-04-01 01:28:38.000000', 'temperatura', 577.0000, 'ºC'),
	(266865, 118, '2014-04-01 01:28:39.000000', 'temperatura', 1155.0000, 'ºC'),
	(266866, 118, '2014-04-01 01:28:40.000000', 'temperatura', 442.0000, 'ºC'),
	(266867, 118, '2014-04-01 01:28:41.000000', 'temperatura', 1148.0000, 'ºC'),
	(266868, 118, '2014-04-01 01:28:42.000000', 'temperatura', 814.0000, 'ºC'),
	(266869, 118, '2014-04-01 01:28:43.000000', 'temperatura', 628.0000, 'ºC'),
	(266870, 118, '2014-04-01 01:28:44.000000', 'temperatura', 695.0000, 'ºC'),
	(266871, 118, '2014-04-01 01:28:45.000000', 'temperatura', 394.0000, 'ºC'),
	(266872, 118, '2014-04-01 01:28:46.000000', 'temperatura', 1085.0000, 'ºC'),
	(266873, 118, '2014-04-01 01:28:47.000000', 'temperatura', 643.0000, 'ºC'),
	(266874, 118, '2014-04-01 01:28:48.000000', 'temperatura', 1163.0000, 'ºC'),
	(266875, 118, '2014-04-01 01:28:49.000000', 'temperatura', 284.0000, 'ºC'),
	(266876, 118, '2014-04-01 01:28:50.000000', 'temperatura', 331.0000, 'ºC'),
	(266877, 118, '2014-04-01 01:28:51.000000', 'temperatura', 806.0000, 'ºC'),
	(266878, 118, '2014-04-01 01:28:52.000000', 'temperatura', 635.0000, 'ºC'),
	(266879, 118, '2014-04-01 01:28:53.000000', 'temperatura', 757.0000, 'ºC'),
	(266880, 118, '2014-04-01 01:28:54.000000', 'temperatura', 682.0000, 'ºC'),
	(266881, 118, '2014-04-01 01:28:55.000000', 'temperatura', 1138.0000, 'ºC'),
	(266882, 118, '2014-04-01 01:28:56.000000', 'temperatura', 45.0000, 'ºC'),
	(266883, 118, '2014-04-01 01:28:57.000000', 'temperatura', 412.0000, 'ºC'),
	(266884, 118, '2014-04-01 01:28:58.000000', 'temperatura', 726.0000, 'ºC'),
	(266885, 118, '2014-04-01 01:28:59.000000', 'temperatura', 1196.0000, 'ºC'),
	(266886, 118, '2014-04-01 01:29:00.000000', 'temperatura', 199.0000, 'ºC'),
	(266887, 118, '2014-04-01 01:29:01.000000', 'temperatura', 1010.0000, 'ºC'),
	(266888, 118, '2014-04-01 01:29:02.000000', 'temperatura', 852.0000, 'ºC'),
	(266889, 118, '2014-04-01 01:29:03.000000', 'temperatura', 32.0000, 'ºC'),
	(266890, 118, '2014-04-01 01:29:04.000000', 'temperatura', 2.0000, 'ºC'),
	(266891, 118, '2014-04-01 01:29:05.000000', 'temperatura', 1116.0000, 'ºC'),
	(266892, 118, '2014-04-01 01:29:06.000000', 'temperatura', 774.0000, 'ºC'),
	(266893, 118, '2014-04-01 01:29:07.000000', 'temperatura', 524.0000, 'ºC'),
	(266894, 118, '2014-04-01 01:29:08.000000', 'temperatura', 297.0000, 'ºC'),
	(266895, 118, '2014-04-01 01:29:09.000000', 'temperatura', 1115.0000, 'ºC'),
	(266896, 118, '2014-04-01 01:29:10.000000', 'temperatura', 1085.0000, 'ºC'),
	(266897, 118, '2014-04-01 01:29:11.000000', 'temperatura', 879.0000, 'ºC'),
	(266898, 118, '2014-04-01 01:29:12.000000', 'temperatura', 1142.0000, 'ºC'),
	(266899, 118, '2014-04-01 01:29:13.000000', 'temperatura', 673.0000, 'ºC'),
	(266900, 118, '2014-04-01 01:29:14.000000', 'temperatura', 1137.0000, 'ºC'),
	(266901, 118, '2014-04-01 01:29:15.000000', 'temperatura', 69.0000, 'ºC'),
	(266902, 118, '2014-04-01 01:29:16.000000', 'temperatura', 534.0000, 'ºC'),
	(266903, 118, '2014-04-01 01:29:17.000000', 'temperatura', 64.0000, 'ºC'),
	(266904, 118, '2014-04-01 01:29:18.000000', 'temperatura', 1116.0000, 'ºC'),
	(266905, 118, '2014-04-01 01:29:19.000000', 'temperatura', 591.0000, 'ºC'),
	(266906, 118, '2014-04-01 01:29:20.000000', 'temperatura', 807.0000, 'ºC'),
	(266907, 118, '2014-04-01 01:29:21.000000', 'temperatura', 1061.0000, 'ºC'),
	(266908, 118, '2014-04-01 01:29:22.000000', 'temperatura', 487.0000, 'ºC'),
	(266909, 118, '2014-04-01 01:29:23.000000', 'temperatura', 450.0000, 'ºC'),
	(266910, 118, '2014-04-01 01:29:24.000000', 'temperatura', 789.0000, 'ºC'),
	(266911, 118, '2014-04-01 01:29:25.000000', 'temperatura', 198.0000, 'ºC'),
	(266912, 118, '2014-04-01 01:29:26.000000', 'temperatura', 1020.0000, 'ºC'),
	(266913, 118, '2014-04-01 01:29:27.000000', 'temperatura', 910.0000, 'ºC'),
	(266914, 118, '2014-04-01 01:29:28.000000', 'temperatura', 289.0000, 'ºC'),
	(266915, 118, '2014-04-01 01:29:29.000000', 'temperatura', 1115.0000, 'ºC'),
	(266916, 118, '2014-04-01 01:29:30.000000', 'temperatura', 1110.0000, 'ºC'),
	(266917, 118, '2014-04-01 01:29:31.000000', 'temperatura', 1005.0000, 'ºC'),
	(266918, 118, '2014-04-01 01:29:32.000000', 'temperatura', 497.0000, 'ºC'),
	(266919, 118, '2014-04-01 01:29:33.000000', 'temperatura', 670.0000, 'ºC'),
	(266920, 118, '2014-04-01 01:29:34.000000', 'temperatura', 658.0000, 'ºC'),
	(266921, 118, '2014-04-01 01:29:35.000000', 'temperatura', 79.0000, 'ºC'),
	(266922, 118, '2014-04-01 01:29:36.000000', 'temperatura', 824.0000, 'ºC'),
	(266923, 118, '2014-04-01 01:29:37.000000', 'temperatura', 284.0000, 'ºC'),
	(266924, 118, '2014-04-01 01:29:38.000000', 'temperatura', 148.0000, 'ºC'),
	(266925, 118, '2014-04-01 01:29:39.000000', 'temperatura', 1089.0000, 'ºC'),
	(266926, 118, '2014-04-01 01:29:40.000000', 'temperatura', 199.0000, 'ºC'),
	(266927, 118, '2014-04-01 01:29:41.000000', 'temperatura', 131.0000, 'ºC'),
	(266928, 118, '2014-04-01 01:29:42.000000', 'temperatura', 58.0000, 'ºC'),
	(266929, 118, '2014-04-01 01:29:43.000000', 'temperatura', 1095.0000, 'ºC'),
	(266930, 118, '2014-04-01 01:29:44.000000', 'temperatura', 504.0000, 'ºC'),
	(266931, 118, '2014-04-01 01:29:45.000000', 'temperatura', 436.0000, 'ºC'),
	(266932, 118, '2014-04-01 01:29:46.000000', 'temperatura', 666.0000, 'ºC'),
	(266933, 118, '2014-04-01 01:29:47.000000', 'temperatura', 824.0000, 'ºC'),
	(266934, 118, '2014-04-01 01:29:48.000000', 'temperatura', 921.0000, 'ºC'),
	(266935, 118, '2014-04-01 01:29:49.000000', 'temperatura', 935.0000, 'ºC'),
	(266936, 118, '2014-04-01 01:29:50.000000', 'temperatura', 712.0000, 'ºC'),
	(266937, 118, '2014-04-01 01:29:51.000000', 'temperatura', 756.0000, 'ºC'),
	(266938, 118, '2014-04-01 01:29:52.000000', 'temperatura', 443.0000, 'ºC'),
	(266939, 118, '2014-04-01 01:29:53.000000', 'temperatura', 1150.0000, 'ºC'),
	(266940, 118, '2014-04-01 01:29:54.000000', 'temperatura', 819.0000, 'ºC'),
	(266941, 118, '2014-04-01 01:29:55.000000', 'temperatura', 646.0000, 'ºC'),
	(266942, 118, '2014-04-01 01:29:56.000000', 'temperatura', 774.0000, 'ºC'),
	(266943, 118, '2014-04-01 01:29:57.000000', 'temperatura', 731.0000, 'ºC'),
	(266944, 118, '2014-04-01 01:29:58.000000', 'temperatura', 133.0000, 'ºC'),
	(266945, 118, '2014-04-01 01:29:59.000000', 'temperatura', 874.0000, 'ºC'),
	(266946, 118, '2014-04-01 01:30:00.000000', 'temperatura', 372.0000, 'ºC'),
	(266947, 118, '2014-04-01 01:30:01.000000', 'temperatura', 438.0000, 'ºC'),
	(266948, 118, '2014-04-01 01:30:02.000000', 'temperatura', 1073.0000, 'ºC'),
	(266949, 118, '2014-04-01 01:30:03.000000', 'temperatura', 454.0000, 'ºC'),
	(266950, 118, '2014-04-01 01:30:04.000000', 'temperatura', 252.0000, 'ºC'),
	(266951, 118, '2014-04-01 01:30:05.000000', 'temperatura', 1099.0000, 'ºC'),
	(266952, 118, '2014-04-01 01:30:06.000000', 'temperatura', 1140.0000, 'ºC'),
	(266953, 118, '2014-04-01 01:30:07.000000', 'temperatura', 4.0000, 'ºC'),
	(266954, 118, '2014-04-01 01:30:08.000000', 'temperatura', 198.0000, 'ºC'),
	(266955, 118, '2014-04-01 01:30:09.000000', 'temperatura', 980.0000, 'ºC'),
	(266956, 118, '2014-04-01 01:30:10.000000', 'temperatura', 707.0000, 'ºC'),
	(266957, 118, '2014-04-01 01:30:11.000000', 'temperatura', 594.0000, 'ºC'),
	(266958, 118, '2014-04-01 01:30:12.000000', 'temperatura', 848.0000, 'ºC'),
	(266959, 118, '2014-04-01 01:30:13.000000', 'temperatura', 61.0000, 'ºC'),
	(266960, 118, '2014-04-01 01:30:14.000000', 'temperatura', 163.0000, 'ºC'),
	(266961, 118, '2014-04-01 01:30:15.000000', 'temperatura', 631.0000, 'ºC'),
	(266962, 118, '2014-04-01 01:30:16.000000', 'temperatura', 264.0000, 'ºC'),
	(266963, 118, '2014-04-01 01:30:17.000000', 'temperatura', 631.0000, 'ºC'),
	(266964, 118, '2014-04-01 01:30:18.000000', 'temperatura', 1163.0000, 'ºC'),
	(266965, 118, '2014-04-01 01:30:19.000000', 'temperatura', 320.0000, 'ºC'),
	(266966, 118, '2014-04-01 01:30:20.000000', 'temperatura', 513.0000, 'ºC'),
	(266967, 118, '2014-04-01 01:30:21.000000', 'temperatura', 404.0000, 'ºC'),
	(266968, 118, '2014-04-01 01:30:22.000000', 'temperatura', 484.0000, 'ºC'),
	(266969, 118, '2014-04-01 01:30:23.000000', 'temperatura', 8.0000, 'ºC'),
	(266970, 118, '2014-04-01 01:30:24.000000', 'temperatura', 986.0000, 'ºC'),
	(266971, 118, '2014-04-01 01:30:25.000000', 'temperatura', 108.0000, 'ºC'),
	(266972, 118, '2014-04-01 01:30:26.000000', 'temperatura', 1184.0000, 'ºC'),
	(266973, 118, '2014-04-01 01:30:27.000000', 'temperatura', 797.0000, 'ºC'),
	(266974, 118, '2014-04-01 01:30:28.000000', 'temperatura', 432.0000, 'ºC'),
	(266975, 118, '2014-04-01 01:30:29.000000', 'temperatura', 969.0000, 'ºC'),
	(266976, 118, '2014-04-01 01:30:30.000000', 'temperatura', 1148.0000, 'ºC'),
	(266977, 118, '2014-04-01 01:30:31.000000', 'temperatura', 436.0000, 'ºC'),
	(266978, 118, '2014-04-01 01:30:32.000000', 'temperatura', 1135.0000, 'ºC'),
	(266979, 118, '2014-04-01 01:30:33.000000', 'temperatura', 768.0000, 'ºC'),
	(266980, 118, '2014-04-01 01:30:34.000000', 'temperatura', 436.0000, 'ºC'),
	(266981, 118, '2014-04-01 01:30:35.000000', 'temperatura', 1075.0000, 'ºC'),
	(266982, 118, '2014-04-01 01:30:36.000000', 'temperatura', 467.0000, 'ºC'),
	(266983, 118, '2014-04-01 01:30:37.000000', 'temperatura', 312.0000, 'ºC'),
	(266984, 118, '2014-04-01 01:30:38.000000', 'temperatura', 160.0000, 'ºC'),
	(266985, 118, '2014-04-01 01:30:39.000000', 'temperatura', 1062.0000, 'ºC'),
	(266986, 118, '2014-04-01 01:30:40.000000', 'temperatura', 33.0000, 'ºC'),
	(266987, 118, '2014-04-01 01:30:41.000000', 'temperatura', 577.0000, 'ºC'),
	(266988, 118, '2014-04-01 01:30:42.000000', 'temperatura', 387.0000, 'ºC'),
	(266989, 118, '2014-04-01 01:30:43.000000', 'temperatura', 207.0000, 'ºC'),
	(266990, 118, '2014-04-01 01:30:44.000000', 'temperatura', 1072.0000, 'ºC'),
	(266991, 118, '2014-04-01 01:30:45.000000', 'temperatura', 1139.0000, 'ºC'),
	(266992, 118, '2014-04-01 01:30:46.000000', 'temperatura', 79.0000, 'ºC'),
	(266993, 118, '2014-04-01 01:30:47.000000', 'temperatura', 579.0000, 'ºC'),
	(266994, 118, '2014-04-01 01:30:48.000000', 'temperatura', 257.0000, 'ºC'),
	(266995, 118, '2014-04-01 01:30:49.000000', 'temperatura', 751.0000, 'ºC'),
	(266996, 118, '2014-04-01 01:30:50.000000', 'temperatura', 582.0000, 'ºC'),
	(266997, 118, '2014-04-01 01:30:51.000000', 'temperatura', 659.0000, 'ºC'),
	(266998, 118, '2014-04-01 01:30:52.000000', 'temperatura', 348.0000, 'ºC'),
	(266999, 118, '2014-04-01 01:30:53.000000', 'temperatura', 966.0000, 'ºC'),
	(267000, 118, '2014-04-01 01:30:54.000000', 'temperatura', 185.0000, 'ºC'),
	(267001, 118, '2014-04-01 01:30:55.000000', 'temperatura', 426.0000, 'ºC'),
	(267002, 118, '2014-04-01 01:30:56.000000', 'temperatura', 378.0000, 'ºC'),
	(267003, 118, '2014-04-01 01:30:57.000000', 'temperatura', 611.0000, 'ºC'),
	(267004, 118, '2014-04-01 01:30:58.000000', 'temperatura', 722.0000, 'ºC'),
	(267005, 118, '2014-04-01 01:30:59.000000', 'temperatura', 577.0000, 'ºC'),
	(267006, 118, '2014-04-01 01:31:00.000000', 'temperatura', 718.0000, 'ºC'),
	(267007, 118, '2014-04-01 01:31:01.000000', 'temperatura', 662.0000, 'ºC'),
	(267008, 118, '2014-04-01 01:31:02.000000', 'temperatura', 1157.0000, 'ºC'),
	(267009, 118, '2014-04-01 01:31:03.000000', 'temperatura', 198.0000, 'ºC'),
	(267010, 118, '2014-04-01 01:31:04.000000', 'temperatura', 1120.0000, 'ºC'),
	(267011, 118, '2014-04-01 01:31:05.000000', 'temperatura', 207.0000, 'ºC'),
	(267012, 118, '2014-04-01 01:31:06.000000', 'temperatura', 74.0000, 'ºC'),
	(267013, 118, '2014-04-01 01:31:07.000000', 'temperatura', 949.0000, 'ºC'),
	(267014, 118, '2014-04-01 01:31:08.000000', 'temperatura', 924.0000, 'ºC'),
	(267015, 118, '2014-04-01 01:31:09.000000', 'temperatura', 573.0000, 'ºC'),
	(267016, 118, '2014-04-01 01:31:10.000000', 'temperatura', 93.0000, 'ºC'),
	(267017, 118, '2014-04-01 01:31:11.000000', 'temperatura', 1148.0000, 'ºC'),
	(267018, 118, '2014-04-01 01:31:12.000000', 'temperatura', 660.0000, 'ºC'),
	(267019, 118, '2014-04-01 01:31:13.000000', 'temperatura', 1058.0000, 'ºC'),
	(267020, 118, '2014-04-01 01:31:14.000000', 'temperatura', 908.0000, 'ºC'),
	(267021, 118, '2014-04-01 01:31:15.000000', 'temperatura', 168.0000, 'ºC'),
	(267022, 118, '2014-04-01 01:31:16.000000', 'temperatura', 516.0000, 'ºC'),
	(267023, 118, '2014-04-01 01:31:17.000000', 'temperatura', 879.0000, 'ºC'),
	(267024, 118, '2014-04-01 01:31:18.000000', 'temperatura', 444.0000, 'ºC'),
	(267025, 118, '2014-04-01 01:31:19.000000', 'temperatura', 784.0000, 'ºC'),
	(267026, 118, '2014-04-01 01:31:20.000000', 'temperatura', 190.0000, 'ºC'),
	(267027, 118, '2014-04-01 01:31:21.000000', 'temperatura', 996.0000, 'ºC'),
	(267028, 118, '2014-04-01 01:31:22.000000', 'temperatura', 812.0000, 'ºC'),
	(267029, 118, '2014-04-01 01:31:23.000000', 'temperatura', 1070.0000, 'ºC'),
	(267030, 118, '2014-04-01 01:31:24.000000', 'temperatura', 518.0000, 'ºC'),
	(267031, 118, '2014-04-01 01:31:25.000000', 'temperatura', 577.0000, 'ºC'),
	(267032, 118, '2014-04-01 01:31:26.000000', 'temperatura', 135.0000, 'ºC'),
	(267033, 118, '2014-04-01 01:31:27.000000', 'temperatura', 143.0000, 'ºC'),
	(267034, 118, '2014-04-01 01:31:28.000000', 'temperatura', 309.0000, 'ºC'),
	(267035, 118, '2014-04-01 01:31:29.000000', 'temperatura', 1118.0000, 'ºC'),
	(267036, 118, '2014-04-01 01:31:30.000000', 'temperatura', 1065.0000, 'ºC'),
	(267037, 118, '2014-04-01 01:31:31.000000', 'temperatura', 769.0000, 'ºC'),
	(267038, 118, '2014-04-01 01:31:32.000000', 'temperatura', 653.0000, 'ºC'),
	(267039, 118, '2014-04-01 01:31:33.000000', 'temperatura', 958.0000, 'ºC'),
	(267040, 118, '2014-04-01 01:31:34.000000', 'temperatura', 433.0000, 'ºC'),
	(267041, 118, '2014-04-01 01:31:35.000000', 'temperatura', 488.0000, 'ºC'),
	(267042, 118, '2014-04-01 01:31:36.000000', 'temperatura', 1144.0000, 'ºC'),
	(267043, 118, '2014-04-01 01:31:37.000000', 'temperatura', 658.0000, 'ºC'),
	(267044, 118, '2014-04-01 01:31:38.000000', 'temperatura', 1055.0000, 'ºC'),
	(267045, 118, '2014-04-01 01:31:39.000000', 'temperatura', 905.0000, 'ºC'),
	(267046, 118, '2014-04-01 01:31:40.000000', 'temperatura', 159.0000, 'ºC'),
	(267047, 118, '2014-04-01 01:31:41.000000', 'temperatura', 479.0000, 'ºC'),
	(267048, 118, '2014-04-01 01:31:42.000000', 'temperatura', 718.0000, 'ºC'),
	(267049, 118, '2014-04-01 01:31:43.000000', 'temperatura', 953.0000, 'ºC'),
	(267050, 118, '2014-04-01 01:31:44.000000', 'temperatura', 212.0000, 'ºC'),
	(267051, 118, '2014-04-01 01:31:45.000000', 'temperatura', 604.0000, 'ºC'),
	(267052, 118, '2014-04-01 01:31:46.000000', 'temperatura', 1181.0000, 'ºC'),
	(267053, 118, '2014-04-01 01:31:47.000000', 'temperatura', 495.0000, 'ºC'),
	(267054, 118, '2014-04-01 01:31:48.000000', 'temperatura', 131.0000, 'ºC'),
	(267055, 118, '2014-04-01 01:31:49.000000', 'temperatura', 373.0000, 'ºC'),
	(267056, 118, '2014-04-01 01:31:50.000000', 'temperatura', 271.0000, 'ºC'),
	(267057, 118, '2014-04-01 01:31:51.000000', 'temperatura', 236.0000, 'ºC'),
	(267058, 118, '2014-04-01 01:31:52.000000', 'temperatura', 367.0000, 'ºC'),
	(267059, 118, '2014-04-01 01:31:53.000000', 'temperatura', 1127.0000, 'ºC'),
	(267060, 118, '2014-04-01 01:31:54.000000', 'temperatura', 935.0000, 'ºC'),
	(267061, 118, '2014-04-01 01:31:55.000000', 'temperatura', 95.0000, 'ºC'),
	(267062, 118, '2014-04-01 01:31:56.000000', 'temperatura', 72.0000, 'ºC'),
	(267063, 118, '2014-04-01 01:31:57.000000', 'temperatura', 74.0000, 'ºC'),
	(267064, 118, '2014-04-01 01:31:58.000000', 'temperatura', 153.0000, 'ºC'),
	(267065, 118, '2014-04-01 01:31:59.000000', 'temperatura', 544.0000, 'ºC'),
	(267066, 118, '2014-04-01 01:32:00.000000', 'temperatura', 1064.0000, 'ºC'),
	(267067, 118, '2014-04-01 01:32:01.000000', 'temperatura', 87.0000, 'ºC'),
	(267068, 118, '2014-04-01 01:32:02.000000', 'temperatura', 842.0000, 'ºC'),
	(267069, 118, '2014-04-01 01:32:03.000000', 'temperatura', 350.0000, 'ºC'),
	(267070, 118, '2014-04-01 01:32:04.000000', 'temperatura', 427.0000, 'ºC'),
	(267071, 118, '2014-04-01 01:32:05.000000', 'temperatura', 1083.0000, 'ºC'),
	(267072, 118, '2014-04-01 01:32:06.000000', 'temperatura', 537.0000, 'ºC'),
	(267073, 118, '2014-04-01 01:32:07.000000', 'temperatura', 634.0000, 'ºC'),
	(267074, 118, '2014-04-01 01:32:08.000000', 'temperatura', 362.0000, 'ºC'),
	(267075, 118, '2014-04-01 01:32:09.000000', 'temperatura', 1108.0000, 'ºC'),
	(267076, 118, '2014-04-01 01:32:10.000000', 'temperatura', 853.0000, 'ºC'),
	(267077, 118, '2014-04-01 01:32:11.000000', 'temperatura', 942.0000, 'ºC'),
	(267078, 118, '2014-04-01 01:32:12.000000', 'temperatura', 952.0000, 'ºC'),
	(267079, 118, '2014-04-01 01:32:13.000000', 'temperatura', 732.0000, 'ºC'),
	(267080, 118, '2014-04-01 01:32:14.000000', 'temperatura', 808.0000, 'ºC'),
	(267081, 118, '2014-04-01 01:32:15.000000', 'temperatura', 644.0000, 'ºC'),
	(267082, 118, '2014-04-01 01:32:16.000000', 'temperatura', 794.0000, 'ºC'),
	(267083, 118, '2014-04-01 01:32:17.000000', 'temperatura', 840.0000, 'ºC'),
	(267084, 118, '2014-04-01 01:32:18.000000', 'temperatura', 617.0000, 'ºC'),
	(267085, 118, '2014-04-01 01:32:19.000000', 'temperatura', 566.0000, 'ºC'),
	(267086, 118, '2014-04-01 01:32:20.000000', 'temperatura', 981.0000, 'ºC'),
	(267087, 118, '2014-04-01 01:32:21.000000', 'temperatura', 805.0000, 'ºC'),
	(267088, 118, '2014-04-01 01:32:22.000000', 'temperatura', 1082.0000, 'ºC'),
	(267089, 118, '2014-04-01 01:32:23.000000', 'temperatura', 596.0000, 'ºC'),
	(267090, 118, '2014-04-01 01:32:24.000000', 'temperatura', 934.0000, 'ºC'),
	(267091, 118, '2014-04-01 01:32:25.000000', 'temperatura', 485.0000, 'ºC'),
	(267092, 118, '2014-04-01 01:32:26.000000', 'temperatura', 821.0000, 'ºC'),
	(267093, 118, '2014-04-01 01:32:27.000000', 'temperatura', 252.0000, 'ºC'),
	(267094, 118, '2014-04-01 01:32:28.000000', 'temperatura', 1196.0000, 'ºC'),
	(267095, 118, '2014-04-01 01:32:29.000000', 'temperatura', 425.0000, 'ºC'),
	(267096, 118, '2014-04-01 01:32:30.000000', 'temperatura', 940.0000, 'ºC'),
	(267097, 118, '2014-04-01 01:32:31.000000', 'temperatura', 1022.0000, 'ºC'),
	(267098, 118, '2014-04-01 01:32:32.000000', 'temperatura', 1094.0000, 'ºC'),
	(267099, 118, '2014-04-01 01:32:33.000000', 'temperatura', 1.0000, 'ºC'),
	(267100, 118, '2014-04-01 01:32:34.000000', 'temperatura', 324.0000, 'ºC'),
	(267101, 118, '2014-04-01 01:32:35.000000', 'temperatura', 420.0000, 'ºC'),
	(267102, 118, '2014-04-01 01:32:36.000000', 'temperatura', 1126.0000, 'ºC'),
	(267103, 118, '2014-04-01 01:32:37.000000', 'temperatura', 771.0000, 'ºC'),
	(267104, 118, '2014-04-01 01:32:38.000000', 'temperatura', 476.0000, 'ºC'),
	(267105, 118, '2014-04-01 01:32:39.000000', 'temperatura', 69.0000, 'ºC'),
	(267106, 118, '2014-04-01 01:32:40.000000', 'temperatura', 115.0000, 'ºC'),
	(267107, 118, '2014-04-01 01:32:41.000000', 'temperatura', 371.0000, 'ºC'),
	(267108, 118, '2014-04-01 01:32:42.000000', 'temperatura', 310.0000, 'ºC'),
	(267109, 118, '2014-04-01 01:32:43.000000', 'temperatura', 437.0000, 'ºC'),
	(267110, 118, '2014-04-01 01:32:44.000000', 'temperatura', 56.0000, 'ºC'),
	(267111, 118, '2014-04-01 01:32:45.000000', 'temperatura', 171.0000, 'ºC'),
	(267112, 118, '2014-04-01 01:32:46.000000', 'temperatura', 687.0000, 'ºC'),
	(267113, 118, '2014-04-01 01:32:47.000000', 'temperatura', 524.0000, 'ºC'),
	(267114, 118, '2014-04-01 01:32:48.000000', 'temperatura', 559.0000, 'ºC'),
	(267115, 118, '2014-04-01 01:32:49.000000', 'temperatura', 22.0000, 'ºC'),
	(267116, 118, '2014-04-01 01:32:50.000000', 'temperatura', 835.0000, 'ºC'),
	(267117, 118, '2014-04-01 01:32:51.000000', 'temperatura', 511.0000, 'ºC'),
	(267118, 118, '2014-04-01 01:32:52.000000', 'temperatura', 48.0000, 'ºC'),
	(267119, 118, '2014-04-01 01:32:53.000000', 'temperatura', 1107.0000, 'ºC'),
	(267120, 118, '2014-04-01 01:32:54.000000', 'temperatura', 592.0000, 'ºC'),
	(267121, 118, '2014-04-01 01:32:55.000000', 'temperatura', 839.0000, 'ºC'),
	(267122, 118, '2014-04-01 01:32:56.000000', 'temperatura', 21.0000, 'ºC'),
	(267123, 118, '2014-04-01 01:32:57.000000', 'temperatura', 1186.0000, 'ºC'),
	(267124, 118, '2014-04-01 01:32:58.000000', 'temperatura', 1070.0000, 'ºC'),
	(267125, 118, '2014-04-01 01:32:59.000000', 'temperatura', 592.0000, 'ºC'),
	(267126, 118, '2014-04-01 01:33:00.000000', 'temperatura', 950.0000, 'ºC'),
	(267127, 118, '2014-04-01 01:33:01.000000', 'temperatura', 575.0000, 'ºC'),
	(267128, 118, '2014-04-01 01:33:02.000000', 'temperatura', 25.0000, 'ºC'),
	(267129, 118, '2014-04-01 01:33:03.000000', 'temperatura', 799.0000, 'ºC'),
	(267130, 118, '2014-04-01 01:33:04.000000', 'temperatura', 323.0000, 'ºC'),
	(267131, 118, '2014-04-01 01:33:05.000000', 'temperatura', 417.0000, 'ºC'),
	(267132, 118, '2014-04-01 01:33:06.000000', 'temperatura', 1118.0000, 'ºC'),
	(267133, 118, '2014-04-01 01:33:07.000000', 'temperatura', 740.0000, 'ºC'),
	(267134, 118, '2014-04-01 01:33:08.000000', 'temperatura', 345.0000, 'ºC'),
	(267135, 118, '2014-04-01 01:33:09.000000', 'temperatura', 708.0000, 'ºC'),
	(267136, 118, '2014-04-01 01:33:10.000000', 'temperatura', 104.0000, 'ºC'),
	(267137, 118, '2014-04-01 01:33:11.000000', 'temperatura', 795.0000, 'ºC'),
	(267138, 118, '2014-04-01 01:33:12.000000', 'temperatura', 65.0000, 'ºC'),
	(267139, 118, '2014-04-01 01:33:13.000000', 'temperatura', 339.0000, 'ºC'),
	(267140, 118, '2014-04-01 01:33:14.000000', 'temperatura', 302.0000, 'ºC'),
	(267141, 118, '2014-04-01 01:33:15.000000', 'temperatura', 495.0000, 'ºC'),
	(267142, 118, '2014-04-01 01:33:16.000000', 'temperatura', 368.0000, 'ºC'),
	(267143, 118, '2014-04-01 01:33:17.000000', 'temperatura', 354.0000, 'ºC'),
	(267144, 118, '2014-04-01 01:33:18.000000', 'temperatura', 666.0000, 'ºC'),
	(267145, 118, '2014-04-01 01:33:19.000000', 'temperatura', 1069.0000, 'ºC'),
	(267146, 118, '2014-04-01 01:33:20.000000', 'temperatura', 947.0000, 'ºC'),
	(267147, 118, '2014-04-01 01:33:21.000000', 'temperatura', 328.0000, 'ºC'),
	(267148, 118, '2014-04-01 01:33:22.000000', 'temperatura', 1.0000, 'ºC'),
	(267149, 118, '2014-04-01 01:33:23.000000', 'temperatura', 219.0000, 'ºC'),
	(267150, 118, '2014-04-01 01:33:24.000000', 'temperatura', 1095.0000, 'ºC'),
	(267151, 118, '2014-04-01 01:33:25.000000', 'temperatura', 17.0000, 'ºC'),
	(267152, 118, '2014-04-01 01:33:26.000000', 'temperatura', 402.0000, 'ºC'),
	(267153, 118, '2014-04-01 01:33:27.000000', 'temperatura', 761.0000, 'ºC'),
	(267154, 118, '2014-04-01 01:33:28.000000', 'temperatura', 197.0000, 'ºC'),
	(267155, 118, '2014-04-01 01:33:29.000000', 'temperatura', 1103.0000, 'ºC'),
	(267156, 118, '2014-04-01 01:33:30.000000', 'temperatura', 124.0000, 'ºC'),
	(267157, 118, '2014-04-01 01:33:31.000000', 'temperatura', 913.0000, 'ºC'),
	(267158, 118, '2014-04-01 01:33:32.000000', 'temperatura', 593.0000, 'ºC'),
	(267159, 118, '2014-04-01 01:33:33.000000', 'temperatura', 226.0000, 'ºC'),
	(267160, 118, '2014-04-01 01:33:34.000000', 'temperatura', 550.0000, 'ºC'),
	(267161, 118, '2014-04-01 01:33:35.000000', 'temperatura', 874.0000, 'ºC'),
	(267162, 118, '2014-04-01 01:33:36.000000', 'temperatura', 318.0000, 'ºC'),
	(267163, 118, '2014-04-01 01:33:37.000000', 'temperatura', 172.0000, 'ºC'),
	(267164, 118, '2014-04-01 01:33:38.000000', 'temperatura', 1104.0000, 'ºC'),
	(267165, 118, '2014-04-01 01:33:39.000000', 'temperatura', 207.0000, 'ºC'),
	(267166, 118, '2014-04-01 01:33:40.000000', 'temperatura', 123.0000, 'ºC'),
	(267167, 118, '2014-04-01 01:33:41.000000', 'temperatura', 1196.0000, 'ºC'),
	(267168, 118, '2014-04-01 01:33:42.000000', 'temperatura', 809.0000, 'ºC'),
	(267169, 118, '2014-04-01 01:33:43.000000', 'temperatura', 457.0000, 'ºC'),
	(267170, 118, '2014-04-01 01:33:44.000000', 'temperatura', 1061.0000, 'ºC'),
	(267171, 118, '2014-04-01 01:33:45.000000', 'temperatura', 333.0000, 'ºC'),
	(267172, 118, '2014-04-01 01:33:46.000000', 'temperatura', 884.0000, 'ºC'),
	(267173, 118, '2014-04-01 01:33:47.000000', 'temperatura', 1021.0000, 'ºC'),
	(267174, 118, '2014-04-01 01:33:48.000000', 'temperatura', 55.0000, 'ºC'),
	(267175, 118, '2014-04-01 01:33:49.000000', 'temperatura', 810.0000, 'ºC'),
	(267176, 118, '2014-04-01 01:33:50.000000', 'temperatura', 286.0000, 'ºC'),
	(267177, 118, '2014-04-01 01:33:51.000000', 'temperatura', 200.0000, 'ºC'),
	(267178, 118, '2014-04-01 01:33:52.000000', 'temperatura', 145.0000, 'ºC'),
	(267179, 118, '2014-04-01 01:33:53.000000', 'temperatura', 124.0000, 'ºC'),
	(267180, 118, '2014-04-01 01:33:54.000000', 'temperatura', 186.0000, 'ºC'),
	(267181, 118, '2014-04-01 01:33:55.000000', 'temperatura', 559.0000, 'ºC'),
	(267182, 118, '2014-04-01 01:33:56.000000', 'temperatura', 1035.0000, 'ºC'),
	(267183, 118, '2014-04-01 01:33:57.000000', 'temperatura', 1102.0000, 'ºC'),
	(267184, 118, '2014-04-01 01:33:58.000000', 'temperatura', 3.0000, 'ºC'),
	(267185, 118, '2014-04-01 01:33:59.000000', 'temperatura', 310.0000, 'ºC'),
	(267186, 118, '2014-04-01 01:34:00.000000', 'temperatura', 342.0000, 'ºC'),
	(267187, 118, '2014-04-01 01:34:01.000000', 'temperatura', 781.0000, 'ºC'),
	(267188, 118, '2014-04-01 01:34:02.000000', 'temperatura', 477.0000, 'ºC'),
	(267189, 118, '2014-04-01 01:34:03.000000', 'temperatura', 46.0000, 'ºC'),
	(267190, 118, '2014-04-01 01:34:04.000000', 'temperatura', 1197.0000, 'ºC'),
	(267191, 118, '2014-04-01 01:34:05.000000', 'temperatura', 1048.0000, 'ºC'),
	(267192, 118, '2014-04-01 01:34:06.000000', 'temperatura', 451.0000, 'ºC'),
	(267193, 118, '2014-04-01 01:34:07.000000', 'temperatura', 312.0000, 'ºC'),
	(267194, 118, '2014-04-01 01:34:08.000000', 'temperatura', 206.0000, 'ºC'),
	(267195, 118, '2014-04-01 01:34:09.000000', 'temperatura', 94.0000, 'ºC'),
	(267196, 118, '2014-04-01 01:34:10.000000', 'temperatura', 1055.0000, 'ºC'),
	(267197, 118, '2014-04-01 01:34:11.000000', 'temperatura', 191.0000, 'ºC'),
	(267198, 118, '2014-04-01 01:34:12.000000', 'temperatura', 190.0000, 'ºC'),
	(267199, 118, '2014-04-01 01:34:13.000000', 'temperatura', 380.0000, 'ºC'),
	(267200, 118, '2014-04-01 01:34:14.000000', 'temperatura', 129.0000, 'ºC'),
	(267201, 118, '2014-04-01 01:34:15.000000', 'temperatura', 707.0000, 'ºC'),
	(267202, 118, '2014-04-01 01:34:16.000000', 'temperatura', 747.0000, 'ºC'),
	(267203, 118, '2014-04-01 01:34:17.000000', 'temperatura', 414.0000, 'ºC'),
	(267204, 118, '2014-04-01 01:34:18.000000', 'temperatura', 1028.0000, 'ºC'),
	(267205, 118, '2014-04-01 01:34:19.000000', 'temperatura', 301.0000, 'ºC'),
	(267206, 118, '2014-04-01 01:34:20.000000', 'temperatura', 820.0000, 'ºC'),
	(267207, 118, '2014-04-01 01:34:21.000000', 'temperatura', 799.0000, 'ºC'),
	(267208, 118, '2014-04-01 01:34:22.000000', 'temperatura', 334.0000, 'ºC'),
	(267209, 118, '2014-04-01 01:34:23.000000', 'temperatura', 473.0000, 'ºC'),
	(267210, 118, '2014-04-01 01:34:24.000000', 'temperatura', 163.0000, 'ºC'),
	(267211, 118, '2014-04-01 01:34:25.000000', 'temperatura', 599.0000, 'ºC'),
	(267212, 118, '2014-04-01 01:34:26.000000', 'temperatura', 106.0000, 'ºC'),
	(267213, 118, '2014-04-01 01:34:27.000000', 'temperatura', 1133.0000, 'ºC'),
	(267214, 118, '2014-04-01 01:34:28.000000', 'temperatura', 547.0000, 'ºC'),
	(267215, 118, '2014-04-01 01:34:29.000000', 'temperatura', 538.0000, 'ºC'),
	(267216, 118, '2014-04-01 01:34:30.000000', 'temperatura', 1047.0000, 'ºC'),
	(267217, 118, '2014-04-01 01:34:31.000000', 'temperatura', 21.0000, 'ºC'),
	(267218, 118, '2014-04-01 01:34:32.000000', 'temperatura', 568.0000, 'ºC'),
	(267219, 118, '2014-04-01 01:34:33.000000', 'temperatura', 374.0000, 'ºC'),
	(267220, 118, '2014-04-01 01:34:34.000000', 'temperatura', 170.0000, 'ºC'),
	(267221, 118, '2014-04-01 01:34:35.000000', 'temperatura', 926.0000, 'ºC'),
	(267222, 118, '2014-04-01 01:34:36.000000', 'temperatura', 520.0000, 'ºC'),
	(267223, 118, '2014-04-01 01:34:37.000000', 'temperatura', 1025.0000, 'ºC'),
	(267224, 118, '2014-04-01 01:34:38.000000', 'temperatura', 1162.0000, 'ºC'),
	(267225, 118, '2014-04-01 01:34:39.000000', 'temperatura', 339.0000, 'ºC'),
	(267226, 118, '2014-04-01 01:34:40.000000', 'temperatura', 607.0000, 'ºC'),
	(267227, 118, '2014-04-01 01:34:41.000000', 'temperatura', 819.0000, 'ºC'),
	(267228, 118, '2014-04-01 01:34:42.000000', 'temperatura', 1076.0000, 'ºC'),
	(267229, 118, '2014-04-01 01:34:43.000000', 'temperatura', 523.0000, 'ºC'),
	(267230, 118, '2014-04-01 01:34:44.000000', 'temperatura', 588.0000, 'ºC'),
	(267231, 118, '2014-04-01 01:34:45.000000', 'temperatura', 170.0000, 'ºC'),
	(267232, 118, '2014-04-01 01:34:46.000000', 'temperatura', 287.0000, 'ºC'),
	(267233, 118, '2014-04-01 01:34:47.000000', 'temperatura', 924.0000, 'ºC'),
	(267234, 118, '2014-04-01 01:34:48.000000', 'temperatura', 162.0000, 'ºC'),
	(267235, 118, '2014-04-01 01:34:49.000000', 'temperatura', 436.0000, 'ºC'),
	(267236, 118, '2014-04-01 01:34:50.000000', 'temperatura', 496.0000, 'ºC'),
	(267237, 118, '2014-04-01 01:34:51.000000', 'temperatura', 1174.0000, 'ºC'),
	(267238, 118, '2014-04-01 01:34:52.000000', 'temperatura', 780.0000, 'ºC'),
	(267239, 118, '2014-04-01 01:34:53.000000', 'temperatura', 382.0000, 'ºC'),
	(267240, 118, '2014-04-01 01:34:54.000000', 'temperatura', 767.0000, 'ºC'),
	(267241, 118, '2014-04-01 01:34:55.000000', 'temperatura', 289.0000, 'ºC'),
	(267242, 118, '2014-04-01 01:34:56.000000', 'temperatura', 345.0000, 'ºC'),
	(267243, 118, '2014-04-01 01:34:57.000000', 'temperatura', 858.0000, 'ºC'),
	(267244, 118, '2014-04-01 01:34:58.000000', 'temperatura', 856.0000, 'ºC'),
	(267245, 118, '2014-04-01 01:34:59.000000', 'temperatura', 509.0000, 'ºC'),
	(267246, 118, '2014-04-01 01:35:00.000000', 'temperatura', 1174.0000, 'ºC'),
	(267247, 118, '2014-04-01 01:35:01.000000', 'temperatura', 744.0000, 'ºC'),
	(267248, 118, '2014-04-01 01:35:02.000000', 'temperatura', 198.0000, 'ºC'),
	(267249, 118, '2014-04-01 01:35:03.000000', 'temperatura', 1161.0000, 'ºC'),
	(267250, 118, '2014-04-01 01:35:04.000000', 'temperatura', 409.0000, 'ºC'),
	(267251, 118, '2014-04-01 01:35:05.000000', 'temperatura', 965.0000, 'ºC'),
	(267252, 118, '2014-04-01 01:35:06.000000', 'temperatura', 1197.0000, 'ºC'),
	(267253, 118, '2014-04-01 01:35:07.000000', 'temperatura', 689.0000, 'ºC'),
	(267254, 118, '2014-04-01 01:35:08.000000', 'temperatura', 1056.0000, 'ºC'),
	(267255, 118, '2014-04-01 01:35:09.000000', 'temperatura', 815.0000, 'ºC'),
	(267256, 118, '2014-04-01 01:35:10.000000', 'temperatura', 905.0000, 'ºC'),
	(267257, 118, '2014-04-01 01:35:11.000000', 'temperatura', 881.0000, 'ºC'),
	(267258, 118, '2014-04-01 01:35:12.000000', 'temperatura', 490.0000, 'ºC'),
	(267259, 118, '2014-04-01 01:35:13.000000', 'temperatura', 1009.0000, 'ºC'),
	(267260, 118, '2014-04-01 01:35:14.000000', 'temperatura', 1176.0000, 'ºC'),
	(267261, 118, '2014-04-01 01:35:15.000000', 'temperatura', 451.0000, 'ºC'),
	(267262, 118, '2014-04-01 01:35:16.000000', 'temperatura', 1130.0000, 'ºC'),
	(267263, 118, '2014-04-01 01:35:17.000000', 'temperatura', 697.0000, 'ºC'),
	(267264, 118, '2014-04-01 01:35:18.000000', 'temperatura', 94.0000, 'ºC'),
	(267265, 118, '2014-04-01 01:35:19.000000', 'temperatura', 781.0000, 'ºC'),
	(267266, 118, '2014-04-01 01:35:20.000000', 'temperatura', 24.0000, 'ºC'),
	(267267, 118, '2014-04-01 01:35:21.000000', 'temperatura', 176.0000, 'ºC'),
	(267268, 118, '2014-04-01 01:35:22.000000', 'temperatura', 808.0000, 'ºC'),
	(267269, 118, '2014-04-01 01:35:23.000000', 'temperatura', 1111.0000, 'ºC'),
	(267270, 118, '2014-04-01 01:35:24.000000', 'temperatura', 734.0000, 'ºC'),
	(267271, 118, '2014-04-01 01:35:25.000000', 'temperatura', 336.0000, 'ºC'),
	(267272, 118, '2014-04-01 01:35:26.000000', 'temperatura', 680.0000, 'ºC'),
	(267273, 118, '2014-04-01 01:35:27.000000', 'temperatura', 1191.0000, 'ºC'),
	(267274, 118, '2014-04-01 01:35:28.000000', 'temperatura', 317.0000, 'ºC'),
	(267275, 118, '2014-04-01 01:35:29.000000', 'temperatura', 411.0000, 'ºC'),
	(267276, 118, '2014-04-01 01:35:30.000000', 'temperatura', 1107.0000, 'ºC'),
	(267277, 118, '2014-04-01 01:35:31.000000', 'temperatura', 702.0000, 'ºC'),
	(267278, 118, '2014-04-01 01:35:32.000000', 'temperatura', 188.0000, 'ºC'),
	(267279, 118, '2014-04-01 01:35:33.000000', 'temperatura', 36.0000, 'ºC'),
	(267280, 118, '2014-04-01 01:35:34.000000', 'temperatura', 817.0000, 'ºC'),
	(267281, 118, '2014-04-01 01:35:35.000000', 'temperatura', 375.0000, 'ºC'),
	(267282, 118, '2014-04-01 01:35:36.000000', 'temperatura', 626.0000, 'ºC'),
	(267283, 118, '2014-04-01 01:35:37.000000', 'temperatura', 806.0000, 'ºC'),
	(267284, 118, '2014-04-01 01:35:38.000000', 'temperatura', 951.0000, 'ºC'),
	(267285, 118, '2014-04-01 01:35:39.000000', 'temperatura', 1136.0000, 'ºC'),
	(267286, 118, '2014-04-01 01:35:40.000000', 'temperatura', 430.0000, 'ºC'),
	(267287, 118, '2014-04-01 01:35:41.000000', 'temperatura', 1141.0000, 'ºC'),
	(267288, 118, '2014-04-01 01:35:42.000000', 'temperatura', 817.0000, 'ºC'),
	(267289, 118, '2014-04-01 01:35:43.000000', 'temperatura', 664.0000, 'ºC'),
	(267290, 118, '2014-04-01 01:35:44.000000', 'temperatura', 867.0000, 'ºC'),
	(267291, 118, '2014-04-01 01:35:45.000000', 'temperatura', 1142.0000, 'ºC'),
	(267292, 118, '2014-04-01 01:35:46.000000', 'temperatura', 713.0000, 'ºC'),
	(267293, 118, '2014-04-01 01:35:47.000000', 'temperatura', 138.0000, 'ºC'),
	(267294, 118, '2014-04-01 01:35:48.000000', 'temperatura', 950.0000, 'ºC'),
	(267295, 118, '2014-04-01 01:35:49.000000', 'temperatura', 738.0000, 'ºC'),
	(267296, 118, '2014-04-01 01:35:50.000000', 'temperatura', 839.0000, 'ºC'),
	(267297, 118, '2014-04-01 01:35:51.000000', 'temperatura', 783.0000, 'ºC'),
	(267298, 118, '2014-04-01 01:35:52.000000', 'temperatura', 199.0000, 'ºC'),
	(267299, 118, '2014-04-01 01:35:53.000000', 'temperatura', 1046.0000, 'ºC'),
	(267300, 118, '2014-04-01 01:35:54.000000', 'temperatura', 1033.0000, 'ºC'),
	(267301, 118, '2014-04-01 01:35:55.000000', 'temperatura', 829.0000, 'ºC'),
	(267302, 118, '2014-04-01 01:35:56.000000', 'temperatura', 1044.0000, 'ºC'),
	(267303, 118, '2014-04-01 01:35:57.000000', 'temperatura', 334.0000, 'ºC'),
	(267304, 118, '2014-04-01 01:35:58.000000', 'temperatura', 939.0000, 'ºC'),
	(267305, 118, '2014-04-01 01:35:59.000000', 'temperatura', 91.0000, 'ºC'),
	(267306, 118, '2014-04-01 01:36:00.000000', 'temperatura', 42.0000, 'ºC'),
	(267307, 118, '2014-04-01 01:36:01.000000', 'temperatura', 1135.0000, 'ºC'),
	(267308, 118, '2014-04-01 01:36:02.000000', 'temperatura', 751.0000, 'ºC'),
	(267309, 118, '2014-04-01 01:36:03.000000', 'temperatura', 351.0000, 'ºC'),
	(267310, 118, '2014-04-01 01:36:04.000000', 'temperatura', 701.0000, 'ºC'),
	(267311, 118, '2014-04-01 01:36:05.000000', 'temperatura', 51.0000, 'ºC'),
	(267312, 118, '2014-04-01 01:36:06.000000', 'temperatura', 555.0000, 'ºC'),
	(267313, 118, '2014-04-01 01:36:07.000000', 'temperatura', 220.0000, 'ºC'),
	(267314, 118, '2014-04-01 01:36:08.000000', 'temperatura', 637.0000, 'ºC'),
	(267315, 118, '2014-04-01 01:36:09.000000', 'temperatura', 125.0000, 'ºC'),
	(267316, 118, '2014-04-01 01:36:10.000000', 'temperatura', 1116.0000, 'ºC'),
	(267317, 118, '2014-04-01 01:36:11.000000', 'temperatura', 405.0000, 'ºC'),
	(267318, 118, '2014-04-01 01:36:12.000000', 'temperatura', 1076.0000, 'ºC'),
	(267319, 118, '2014-04-01 01:36:13.000000', 'temperatura', 565.0000, 'ºC'),
	(267320, 118, '2014-04-01 01:36:14.000000', 'temperatura', 798.0000, 'ºC'),
	(267321, 118, '2014-04-01 01:36:15.000000', 'temperatura', 1096.0000, 'ºC'),
	(267322, 118, '2014-04-01 01:36:16.000000', 'temperatura', 686.0000, 'ºC'),
	(267323, 118, '2014-04-01 01:36:17.000000', 'temperatura', 142.0000, 'ºC'),
	(267324, 118, '2014-04-01 01:36:18.000000', 'temperatura', 1054.0000, 'ºC'),
	(267325, 118, '2014-04-01 01:36:19.000000', 'temperatura', 44.0000, 'ºC'),
	(267326, 118, '2014-04-01 01:36:20.000000', 'temperatura', 657.0000, 'ºC'),
	(267327, 118, '2014-04-01 01:36:21.000000', 'temperatura', 756.0000, 'ºC'),
	(267328, 118, '2014-04-01 01:36:22.000000', 'temperatura', 607.0000, 'ºC'),
	(267329, 118, '2014-04-01 01:36:23.000000', 'temperatura', 768.0000, 'ºC'),
	(267330, 118, '2014-04-01 01:36:24.000000', 'temperatura', 821.0000, 'ºC'),
	(267331, 118, '2014-04-01 01:36:25.000000', 'temperatura', 603.0000, 'ºC'),
	(267332, 118, '2014-04-01 01:36:26.000000', 'temperatura', 549.0000, 'ºC'),
	(267333, 118, '2014-04-01 01:36:27.000000', 'temperatura', 939.0000, 'ºC'),
	(267334, 118, '2014-04-01 01:36:28.000000', 'temperatura', 649.0000, 'ºC'),
	(267335, 118, '2014-04-01 01:36:29.000000', 'temperatura', 428.0000, 'ºC'),
	(267336, 118, '2014-04-01 01:36:30.000000', 'temperatura', 194.0000, 'ºC'),
	(267337, 118, '2014-04-01 01:36:31.000000', 'temperatura', 887.0000, 'ºC'),
	(267338, 118, '2014-04-01 01:36:32.000000', 'temperatura', 252.0000, 'ºC'),
	(267339, 118, '2014-04-01 01:36:33.000000', 'temperatura', 998.0000, 'ºC'),
	(267340, 118, '2014-04-01 01:36:34.000000', 'temperatura', 637.0000, 'ºC'),
	(267341, 118, '2014-04-01 01:36:35.000000', 'temperatura', 189.0000, 'ºC'),
	(267342, 118, '2014-04-01 01:36:36.000000', 'temperatura', 235.0000, 'ºC'),
	(267343, 118, '2014-04-01 01:36:37.000000', 'temperatura', 611.0000, 'ºC'),
	(267344, 118, '2014-04-01 01:36:38.000000', 'temperatura', 1149.0000, 'ºC'),
	(267345, 118, '2014-04-01 01:36:39.000000', 'temperatura', 313.0000, 'ºC'),
	(267346, 118, '2014-04-01 01:36:40.000000', 'temperatura', 517.0000, 'ºC'),
	(267347, 118, '2014-04-01 01:36:41.000000', 'temperatura', 446.0000, 'ºC'),
	(267348, 118, '2014-04-01 01:36:42.000000', 'temperatura', 681.0000, 'ºC'),
	(267349, 118, '2014-04-01 01:36:43.000000', 'temperatura', 868.0000, 'ºC'),
	(267350, 118, '2014-04-01 01:36:44.000000', 'temperatura', 1099.0000, 'ºC'),
	(267351, 118, '2014-04-01 01:36:45.000000', 'temperatura', 489.0000, 'ºC'),
	(267352, 118, '2014-04-01 01:36:46.000000', 'temperatura', 350.0000, 'ºC'),
	(267353, 118, '2014-04-01 01:36:47.000000', 'temperatura', 281.0000, 'ºC'),
	(267354, 118, '2014-04-01 01:36:48.000000', 'temperatura', 357.0000, 'ºC'),
	(267355, 118, '2014-04-01 01:36:49.000000', 'temperatura', 942.0000, 'ºC'),
	(267356, 118, '2014-04-01 01:36:50.000000', 'temperatura', 41.0000, 'ºC'),
	(267357, 118, '2014-04-01 01:36:51.000000', 'temperatura', 980.0000, 'ºC'),
	(267358, 118, '2014-04-01 01:36:52.000000', 'temperatura', 1175.0000, 'ºC'),
	(267359, 118, '2014-04-01 01:36:53.000000', 'temperatura', 536.0000, 'ºC'),
	(267360, 118, '2014-04-01 01:36:54.000000', 'temperatura', 355.0000, 'ºC'),
	(267361, 118, '2014-04-01 01:36:55.000000', 'temperatura', 166.0000, 'ºC'),
	(267362, 118, '2014-04-01 01:36:56.000000', 'temperatura', 968.0000, 'ºC'),
	(267363, 118, '2014-04-01 01:36:57.000000', 'temperatura', 742.0000, 'ºC'),
	(267364, 118, '2014-04-01 01:36:58.000000', 'temperatura', 808.0000, 'ºC'),
	(267365, 118, '2014-04-01 01:36:59.000000', 'temperatura', 613.0000, 'ºC'),
	(267366, 118, '2014-04-01 01:37:00.000000', 'temperatura', 642.0000, 'ºC'),
	(267367, 118, '2014-04-01 01:37:01.000000', 'temperatura', 170.0000, 'ºC'),
	(267368, 118, '2014-04-01 01:37:02.000000', 'temperatura', 127.0000, 'ºC'),
	(267369, 118, '2014-04-01 01:37:03.000000', 'temperatura', 126.0000, 'ºC'),
	(267370, 118, '2014-04-01 01:37:04.000000', 'temperatura', 247.0000, 'ºC'),
	(267371, 118, '2014-04-01 01:37:05.000000', 'temperatura', 857.0000, 'ºC'),
	(267372, 118, '2014-04-01 01:37:06.000000', 'temperatura', 1147.0000, 'ºC'),
	(267373, 118, '2014-04-01 01:37:07.000000', 'temperatura', 763.0000, 'ºC'),
	(267374, 118, '2014-04-01 01:37:08.000000', 'temperatura', 375.0000, 'ºC'),
	(267375, 118, '2014-04-01 01:37:09.000000', 'temperatura', 788.0000, 'ºC'),
	(267376, 118, '2014-04-01 01:37:10.000000', 'temperatura', 416.0000, 'ºC'),
	(267377, 118, '2014-04-01 01:37:11.000000', 'temperatura', 916.0000, 'ºC'),
	(267378, 118, '2014-04-01 01:37:12.000000', 'temperatura', 933.0000, 'ºC'),
	(267379, 118, '2014-04-01 01:37:13.000000', 'temperatura', 715.0000, 'ºC'),
	(267380, 118, '2014-04-01 01:37:14.000000', 'temperatura', 779.0000, 'ºC'),
	(267381, 118, '2014-04-01 01:37:15.000000', 'temperatura', 548.0000, 'ºC'),
	(267382, 118, '2014-04-01 01:37:16.000000', 'temperatura', 406.0000, 'ºC'),
	(267383, 118, '2014-04-01 01:37:17.000000', 'temperatura', 385.0000, 'ºC'),
	(267384, 118, '2014-04-01 01:37:18.000000', 'temperatura', 709.0000, 'ºC'),
	(267385, 118, '2014-04-01 01:37:19.000000', 'temperatura', 1190.0000, 'ºC'),
	(267386, 118, '2014-04-01 01:37:20.000000', 'temperatura', 224.0000, 'ºC'),
	(267387, 118, '2014-04-01 01:37:21.000000', 'temperatura', 1151.0000, 'ºC'),
	(267388, 118, '2014-04-01 01:37:22.000000', 'temperatura', 285.0000, 'ºC'),
	(267389, 118, '2014-04-01 01:37:23.000000', 'temperatura', 370.0000, 'ºC'),
	(267390, 118, '2014-04-01 01:37:24.000000', 'temperatura', 998.0000, 'ºC'),
	(267391, 118, '2014-04-01 01:37:25.000000', 'temperatura', 278.0000, 'ºC'),
	(267392, 118, '2014-04-01 01:37:26.000000', 'temperatura', 795.0000, 'ºC'),
	(267393, 118, '2014-04-01 01:37:27.000000', 'temperatura', 744.0000, 'ºC'),
	(267394, 118, '2014-04-01 01:37:28.000000', 'temperatura', 135.0000, 'ºC'),
	(267395, 118, '2014-04-01 01:37:29.000000', 'temperatura', 845.0000, 'ºC'),
	(267396, 118, '2014-04-01 01:37:30.000000', 'temperatura', 220.0000, 'ºC'),
	(267397, 118, '2014-04-01 01:37:31.000000', 'temperatura', 966.0000, 'ºC'),
	(267398, 118, '2014-04-01 01:37:32.000000', 'temperatura', 572.0000, 'ºC'),
	(267399, 118, '2014-04-01 01:37:33.000000', 'temperatura', 1160.0000, 'ºC'),
	(267400, 118, '2014-04-01 01:37:34.000000', 'temperatura', 487.0000, 'ºC'),
	(267401, 118, '2014-04-01 01:37:35.000000', 'temperatura', 155.0000, 'ºC'),
	(267402, 118, '2014-04-01 01:37:36.000000', 'temperatura', 515.0000, 'ºC'),
	(267403, 118, '2014-04-01 01:37:37.000000', 'temperatura', 910.0000, 'ºC'),
	(267404, 118, '2014-04-01 01:37:38.000000', 'temperatura', 605.0000, 'ºC'),
	(267405, 118, '2014-04-01 01:37:39.000000', 'temperatura', 294.0000, 'ºC'),
	(267406, 118, '2014-04-01 01:37:40.000000', 'temperatura', 858.0000, 'ºC'),
	(267407, 118, '2014-04-01 01:37:41.000000', 'temperatura', 1008.0000, 'ºC'),
	(267408, 118, '2014-04-01 01:37:42.000000', 'temperatura', 65.0000, 'ºC'),
	(267409, 119, '2014-04-01 00:00:00.000000', 'temperatura', 726.0000, 'ºC'),
	(267410, 119, '2014-04-01 00:00:01.000000', 'temperatura', 918.0000, 'ºC'),
	(267411, 119, '2014-04-01 00:00:02.000000', 'temperatura', 13.0000, 'ºC'),
	(267412, 119, '2014-04-01 00:00:03.000000', 'temperatura', 913.0000, 'ºC'),
	(267413, 119, '2014-04-01 00:00:04.000000', 'temperatura', 924.0000, 'ºC'),
	(267414, 119, '2014-04-01 00:00:05.000000', 'temperatura', 682.0000, 'ºC'),
	(267415, 119, '2014-04-01 00:00:06.000000', 'temperatura', 639.0000, 'ºC'),
	(267416, 119, '2014-04-01 00:00:07.000000', 'temperatura', 1151.0000, 'ºC'),
	(267417, 119, '2014-04-01 00:00:08.000000', 'temperatura', 236.0000, 'ºC'),
	(267418, 119, '2014-04-01 00:00:09.000000', 'temperatura', 128.0000, 'ºC'),
	(267419, 119, '2014-04-01 00:00:10.000000', 'temperatura', 1134.0000, 'ºC'),
	(267420, 119, '2014-04-01 00:00:11.000000', 'temperatura', 487.0000, 'ºC'),
	(267421, 119, '2014-04-01 00:00:12.000000', 'temperatura', 233.0000, 'ºC'),
	(267422, 119, '2014-04-01 00:00:13.000000', 'temperatura', 903.0000, 'ºC'),
	(267423, 119, '2014-04-01 00:00:14.000000', 'temperatura', 218.0000, 'ºC'),
	(267424, 119, '2014-04-01 00:00:15.000000', 'temperatura', 782.0000, 'ºC'),
	(267425, 119, '2014-04-01 00:00:16.000000', 'temperatura', 855.0000, 'ºC'),
	(267426, 119, '2014-04-01 00:00:17.000000', 'temperatura', 731.0000, 'ºC'),
	(267427, 119, '2014-04-01 00:00:18.000000', 'temperatura', 1091.0000, 'ºC'),
	(267428, 119, '2014-04-01 00:00:19.000000', 'temperatura', 863.0000, 'ºC'),
	(267429, 119, '2014-04-01 00:00:20.000000', 'temperatura', 1042.0000, 'ºC'),
	(267430, 119, '2014-04-01 00:00:21.000000', 'temperatura', 222.0000, 'ºC'),
	(267431, 119, '2014-04-01 00:00:22.000000', 'temperatura', 384.0000, 'ºC'),
	(267432, 119, '2014-04-01 00:00:23.000000', 'temperatura', 54.0000, 'ºC'),
	(267433, 119, '2014-04-01 00:00:24.000000', 'temperatura', 319.0000, 'ºC'),
	(267434, 119, '2014-04-01 00:00:25.000000', 'temperatura', 232.0000, 'ºC'),
	(267435, 119, '2014-04-01 00:00:26.000000', 'temperatura', 206.0000, 'ºC'),
	(267436, 119, '2014-04-01 00:00:27.000000', 'temperatura', 333.0000, 'ºC'),
	(267437, 119, '2014-04-01 00:00:28.000000', 'temperatura', 1048.0000, 'ºC'),
	(267438, 119, '2014-04-01 00:00:29.000000', 'temperatura', 639.0000, 'ºC'),
	(267439, 119, '2014-04-01 00:00:30.000000', 'temperatura', 54.0000, 'ºC'),
	(267440, 119, '2014-04-01 00:00:31.000000', 'temperatura', 755.0000, 'ºC'),
	(267441, 119, '2014-04-01 00:00:32.000000', 'temperatura', 11.0000, 'ºC'),
	(267442, 119, '2014-04-01 00:00:33.000000', 'temperatura', 189.0000, 'ºC'),
	(267443, 119, '2014-04-01 00:00:34.000000', 'temperatura', 915.0000, 'ºC'),
	(267444, 119, '2014-04-01 00:00:35.000000', 'temperatura', 407.0000, 'ºC'),
	(267445, 119, '2014-04-01 00:00:36.000000', 'temperatura', 492.0000, 'ºC'),
	(267446, 119, '2014-04-01 00:00:37.000000', 'temperatura', 39.0000, 'ºC'),
	(267447, 119, '2014-04-01 00:00:38.000000', 'temperatura', 1120.0000, 'ºC'),
	(267448, 119, '2014-04-01 00:00:39.000000', 'temperatura', 682.0000, 'ºC'),
	(267449, 119, '2014-04-01 00:00:40.000000', 'temperatura', 52.0000, 'ºC'),
	(267450, 119, '2014-04-01 00:00:41.000000', 'temperatura', 613.0000, 'ºC'),
	(267451, 119, '2014-04-01 00:00:42.000000', 'temperatura', 511.0000, 'ºC'),
	(267452, 119, '2014-04-01 00:00:43.000000', 'temperatura', 716.0000, 'ºC'),
	(267453, 119, '2014-04-01 00:00:44.000000', 'temperatura', 849.0000, 'ºC'),
	(267454, 119, '2014-04-01 00:00:45.000000', 'temperatura', 897.0000, 'ºC'),
	(267455, 119, '2014-04-01 00:00:46.000000', 'temperatura', 736.0000, 'ºC'),
	(267456, 119, '2014-04-01 00:00:47.000000', 'temperatura', 991.0000, 'ºC'),
	(267457, 119, '2014-04-01 00:00:48.000000', 'temperatura', 349.0000, 'ºC'),
	(267458, 119, '2014-04-01 00:00:49.000000', 'temperatura', 1171.0000, 'ºC'),
	(267459, 119, '2014-04-01 00:00:50.000000', 'temperatura', 9.0000, 'ºC'),
	(267460, 119, '2014-04-01 00:00:51.000000', 'temperatura', 133.0000, 'ºC'),
	(267461, 119, '2014-04-01 00:00:52.000000', 'temperatura', 639.0000, 'ºC'),
	(267462, 119, '2014-04-01 00:00:53.000000', 'temperatura', 395.0000, 'ºC'),
	(267463, 119, '2014-04-01 00:00:54.000000', 'temperatura', 59.0000, 'ºC'),
	(267464, 119, '2014-04-01 00:00:55.000000', 'temperatura', 309.0000, 'ºC'),
	(267465, 119, '2014-04-01 00:00:56.000000', 'temperatura', 171.0000, 'ºC'),
	(267466, 119, '2014-04-01 00:00:57.000000', 'temperatura', 1127.0000, 'ºC'),
	(267467, 119, '2014-04-01 00:00:58.000000', 'temperatura', 321.0000, 'ºC'),
	(267468, 119, '2014-04-01 00:00:59.000000', 'temperatura', 627.0000, 'ºC'),
	(267469, 119, '2014-04-01 00:01:00.000000', 'temperatura', 973.0000, 'ºC'),
	(267470, 119, '2014-04-01 00:01:01.000000', 'temperatura', 585.0000, 'ºC'),
	(267471, 119, '2014-04-01 00:01:02.000000', 'temperatura', 7.0000, 'ºC'),
	(267472, 119, '2014-04-01 00:01:03.000000', 'temperatura', 682.0000, 'ºC'),
	(267473, 119, '2014-04-01 00:01:04.000000', 'temperatura', 986.0000, 'ºC'),
	(267474, 119, '2014-04-01 00:01:05.000000', 'temperatura', 485.0000, 'ºC'),
	(267475, 119, '2014-04-01 00:01:06.000000', 'temperatura', 666.0000, 'ºC'),
	(267476, 119, '2014-04-01 00:01:07.000000', 'temperatura', 678.0000, 'ºC'),
	(267477, 119, '2014-04-01 00:01:08.000000', 'temperatura', 191.0000, 'ºC'),
	(267478, 119, '2014-04-01 00:01:09.000000', 'temperatura', 124.0000, 'ºC'),
	(267479, 119, '2014-04-01 00:01:10.000000', 'temperatura', 46.0000, 'ºC'),
	(267480, 119, '2014-04-01 00:01:11.000000', 'temperatura', 1060.0000, 'ºC'),
	(267481, 119, '2014-04-01 00:01:12.000000', 'temperatura', 361.0000, 'ºC'),
	(267482, 119, '2014-04-01 00:01:13.000000', 'temperatura', 1026.0000, 'ºC'),
	(267483, 119, '2014-04-01 00:01:14.000000', 'temperatura', 447.0000, 'ºC'),
	(267484, 119, '2014-04-01 00:01:15.000000', 'temperatura', 356.0000, 'ºC'),
	(267485, 119, '2014-04-01 00:01:16.000000', 'temperatura', 442.0000, 'ºC'),
	(267486, 119, '2014-04-01 00:01:17.000000', 'temperatura', 1143.0000, 'ºC'),
	(267487, 119, '2014-04-01 00:01:18.000000', 'temperatura', 789.0000, 'ºC'),
	(267488, 119, '2014-04-01 00:01:19.000000', 'temperatura', 516.0000, 'ºC'),
	(267489, 119, '2014-04-01 00:01:20.000000', 'temperatura', 213.0000, 'ºC'),
	(267490, 119, '2014-04-01 00:01:21.000000', 'temperatura', 716.0000, 'ºC'),
	(267491, 119, '2014-04-01 00:01:22.000000', 'temperatura', 544.0000, 'ºC'),
	(267492, 119, '2014-04-01 00:01:23.000000', 'temperatura', 571.0000, 'ºC'),
	(267493, 119, '2014-04-01 00:01:24.000000', 'temperatura', 26.0000, 'ºC'),
	(267494, 119, '2014-04-01 00:01:25.000000', 'temperatura', 816.0000, 'ºC'),
	(267495, 119, '2014-04-01 00:01:26.000000', 'temperatura', 403.0000, 'ºC'),
	(267496, 119, '2014-04-01 00:01:27.000000', 'temperatura', 766.0000, 'ºC'),
	(267497, 119, '2014-04-01 00:01:28.000000', 'temperatura', 221.0000, 'ºC'),
	(267498, 119, '2014-04-01 00:01:29.000000', 'temperatura', 10.0000, 'ºC'),
	(267499, 119, '2014-04-01 00:01:30.000000', 'temperatura', 587.0000, 'ºC'),
	(267500, 119, '2014-04-01 00:01:31.000000', 'temperatura', 506.0000, 'ºC'),
	(267501, 119, '2014-04-01 00:01:32.000000', 'temperatura', 770.0000, 'ºC'),
	(267502, 119, '2014-04-01 00:01:33.000000', 'temperatura', 1131.0000, 'ºC'),
	(267503, 119, '2014-04-01 00:01:34.000000', 'temperatura', 947.0000, 'ºC'),
	(267504, 119, '2014-04-01 00:01:35.000000', 'temperatura', 143.0000, 'ºC'),
	(267505, 119, '2014-04-01 00:01:36.000000', 'temperatura', 275.0000, 'ºC'),
	(267506, 119, '2014-04-01 00:01:37.000000', 'temperatura', 943.0000, 'ºC'),
	(267507, 119, '2014-04-01 00:01:38.000000', 'temperatura', 294.0000, 'ºC'),
	(267508, 119, '2014-04-01 00:01:39.000000', 'temperatura', 1041.0000, 'ºC'),
	(267509, 119, '2014-04-01 00:01:40.000000', 'temperatura', 722.0000, 'ºC'),
	(267510, 119, '2014-04-01 00:01:41.000000', 'temperatura', 487.0000, 'ºC'),
	(267511, 119, '2014-04-01 00:01:42.000000', 'temperatura', 272.0000, 'ºC'),
	(267512, 119, '2014-04-01 00:01:43.000000', 'temperatura', 1097.0000, 'ºC'),
	(267513, 119, '2014-04-01 00:01:44.000000', 'temperatura', 1070.0000, 'ºC'),
	(267514, 119, '2014-04-01 00:01:45.000000', 'temperatura', 860.0000, 'ºC'),
	(267515, 119, '2014-04-01 00:01:46.000000', 'temperatura', 1091.0000, 'ºC'),
	(267516, 119, '2014-04-01 00:01:47.000000', 'temperatura', 476.0000, 'ºC'),
	(267517, 119, '2014-04-01 00:01:48.000000', 'temperatura', 305.0000, 'ºC'),
	(267518, 119, '2014-04-01 00:01:49.000000', 'temperatura', 101.0000, 'ºC'),
	(267519, 119, '2014-04-01 00:01:50.000000', 'temperatura', 788.0000, 'ºC'),
	(267520, 119, '2014-04-01 00:01:51.000000', 'temperatura', 40.0000, 'ºC'),
	(267521, 119, '2014-04-01 00:01:52.000000', 'temperatura', 236.0000, 'ºC'),
	(267522, 119, '2014-04-01 00:01:53.000000', 'temperatura', 1058.0000, 'ºC'),
	(267523, 119, '2014-04-01 00:01:54.000000', 'temperatura', 985.0000, 'ºC'),
	(267524, 119, '2014-04-01 00:01:55.000000', 'temperatura', 551.0000, 'ºC'),
	(267525, 119, '2014-04-01 00:01:56.000000', 'temperatura', 1001.0000, 'ºC'),
	(267526, 119, '2014-04-01 00:01:57.000000', 'temperatura', 953.0000, 'ºC'),
	(267527, 119, '2014-04-01 00:01:58.000000', 'temperatura', 561.0000, 'ºC'),
	(267528, 119, '2014-04-01 00:01:59.000000', 'temperatura', 1145.0000, 'ºC'),
	(267529, 119, '2014-04-01 00:02:00.000000', 'temperatura', 446.0000, 'ºC'),
	(267530, 119, '2014-04-01 00:02:01.000000', 'temperatura', 1192.0000, 'ºC'),
	(267531, 119, '2014-04-01 00:02:02.000000', 'temperatura', 1026.0000, 'ºC'),
	(267532, 119, '2014-04-01 00:02:03.000000', 'temperatura', 352.0000, 'ºC'),
	(267533, 119, '2014-04-01 00:02:04.000000', 'temperatura', 1081.0000, 'ºC'),
	(267534, 119, '2014-04-01 00:02:05.000000', 'temperatura', 752.0000, 'ºC'),
	(267535, 119, '2014-04-01 00:02:06.000000', 'temperatura', 516.0000, 'ºC'),
	(267536, 119, '2014-04-01 00:02:07.000000', 'temperatura', 324.0000, 'ºC'),
	(267537, 119, '2014-04-01 00:02:08.000000', 'temperatura', 72.0000, 'ºC'),
	(267538, 119, '2014-04-01 00:02:09.000000', 'temperatura', 588.0000, 'ºC'),
	(267539, 119, '2014-04-01 00:02:10.000000', 'temperatura', 326.0000, 'ºC'),
	(267540, 119, '2014-04-01 00:02:11.000000', 'temperatura', 1067.0000, 'ºC'),
	(267541, 119, '2014-04-01 00:02:12.000000', 'temperatura', 756.0000, 'ºC'),
	(267542, 119, '2014-04-01 00:02:13.000000', 'temperatura', 578.0000, 'ºC'),
	(267543, 119, '2014-04-01 00:02:14.000000', 'temperatura', 624.0000, 'ºC'),
	(267544, 119, '2014-04-01 00:02:15.000000', 'temperatura', 188.0000, 'ºC'),
	(267545, 119, '2014-04-01 00:02:16.000000', 'temperatura', 267.0000, 'ºC'),
	(267546, 119, '2014-04-01 00:02:17.000000', 'temperatura', 773.0000, 'ºC'),
	(267547, 119, '2014-04-01 00:02:18.000000', 'temperatura', 664.0000, 'ºC'),
	(267548, 119, '2014-04-01 00:02:19.000000', 'temperatura', 1003.0000, 'ºC'),
	(267549, 119, '2014-04-01 00:02:20.000000', 'temperatura', 620.0000, 'ºC'),
	(267550, 119, '2014-04-01 00:02:21.000000', 'temperatura', 95.0000, 'ºC'),
	(267551, 119, '2014-04-01 00:02:22.000000', 'temperatura', 1015.0000, 'ºC'),
	(267552, 119, '2014-04-01 00:02:23.000000', 'temperatura', 1191.0000, 'ºC'),
	(267553, 119, '2014-04-01 00:02:24.000000', 'temperatura', 509.0000, 'ºC'),
	(267554, 119, '2014-04-01 00:02:25.000000', 'temperatura', 174.0000, 'ºC'),
	(267555, 119, '2014-04-01 00:02:26.000000', 'temperatura', 543.0000, 'ºC'),
	(267556, 119, '2014-04-01 00:02:27.000000', 'temperatura', 993.0000, 'ºC'),
	(267557, 119, '2014-04-01 00:02:28.000000', 'temperatura', 938.0000, 'ºC'),
	(267558, 119, '2014-04-01 00:02:29.000000', 'temperatura', 513.0000, 'ºC'),
	(267559, 119, '2014-04-01 00:02:30.000000', 'temperatura', 949.0000, 'ºC'),
	(267560, 119, '2014-04-01 00:02:31.000000', 'temperatura', 806.0000, 'ºC'),
	(267561, 119, '2014-04-01 00:02:32.000000', 'temperatura', 1183.0000, 'ºC'),
	(267562, 119, '2014-04-01 00:02:33.000000', 'temperatura', 1100.0000, 'ºC'),
	(267563, 119, '2014-04-01 00:02:34.000000', 'temperatura', 749.0000, 'ºC'),
	(267564, 119, '2014-04-01 00:02:35.000000', 'temperatura', 448.0000, 'ºC'),
	(267565, 119, '2014-04-01 00:02:36.000000', 'temperatura', 1192.0000, 'ºC'),
	(267566, 119, '2014-04-01 00:02:37.000000', 'temperatura', 1017.0000, 'ºC'),
	(267567, 119, '2014-04-01 00:02:38.000000', 'temperatura', 310.0000, 'ºC'),
	(267568, 119, '2014-04-01 00:02:39.000000', 'temperatura', 900.0000, 'ºC'),
	(267569, 119, '2014-04-01 00:02:40.000000', 'temperatura', 1171.0000, 'ºC'),
	(267570, 119, '2014-04-01 00:02:41.000000', 'temperatura', 753.0000, 'ºC'),
	(267571, 119, '2014-04-01 00:02:42.000000', 'temperatura', 255.0000, 'ºC'),
	(267572, 119, '2014-04-01 00:02:43.000000', 'temperatura', 217.0000, 'ºC'),
	(267573, 119, '2014-04-01 00:02:44.000000', 'temperatura', 318.0000, 'ºC'),
	(267574, 119, '2014-04-01 00:02:45.000000', 'temperatura', 943.0000, 'ºC'),
	(267575, 119, '2014-04-01 00:02:46.000000', 'temperatura', 158.0000, 'ºC'),
	(267576, 119, '2014-04-01 00:02:47.000000', 'temperatura', 363.0000, 'ºC'),
	(267577, 119, '2014-04-01 00:02:48.000000', 'temperatura', 143.0000, 'ºC'),
	(267578, 119, '2014-04-01 00:02:49.000000', 'temperatura', 825.0000, 'ºC'),
	(267579, 119, '2014-04-01 00:02:50.000000', 'temperatura', 99.0000, 'ºC'),
	(267580, 119, '2014-04-01 00:02:51.000000', 'temperatura', 418.0000, 'ºC'),
	(267581, 119, '2014-04-01 00:02:52.000000', 'temperatura', 593.0000, 'ºC'),
	(267582, 119, '2014-04-01 00:02:53.000000', 'temperatura', 512.0000, 'ºC'),
	(267583, 119, '2014-04-01 00:02:54.000000', 'temperatura', 783.0000, 'ºC'),
	(267584, 119, '2014-04-01 00:02:55.000000', 'temperatura', 1180.0000, 'ºC'),
	(267585, 119, '2014-04-01 00:02:56.000000', 'temperatura', 1150.0000, 'ºC'),
	(267586, 119, '2014-04-01 00:02:57.000000', 'temperatura', 1010.0000, 'ºC'),
	(267587, 119, '2014-04-01 00:02:58.000000', 'temperatura', 399.0000, 'ºC'),
	(267588, 119, '2014-04-01 00:02:59.000000', 'temperatura', 168.0000, 'ºC'),
	(267589, 119, '2014-04-01 00:03:00.000000', 'temperatura', 841.0000, 'ºC'),
	(267590, 119, '2014-04-01 00:03:01.000000', 'temperatura', 104.0000, 'ºC'),
	(267591, 119, '2014-04-01 00:03:02.000000', 'temperatura', 397.0000, 'ºC'),
	(267592, 119, '2014-04-01 00:03:03.000000', 'temperatura', 472.0000, 'ºC'),
	(267593, 119, '2014-04-01 00:03:04.000000', 'temperatura', 1171.0000, 'ºC'),
	(267594, 119, '2014-04-01 00:03:05.000000', 'temperatura', 839.0000, 'ºC'),
	(267595, 119, '2014-04-01 00:03:06.000000', 'temperatura', 682.0000, 'ºC'),
	(267596, 119, '2014-04-01 00:03:07.000000', 'temperatura', 893.0000, 'ºC'),
	(267597, 119, '2014-04-01 00:03:08.000000', 'temperatura', 18.0000, 'ºC'),
	(267598, 119, '2014-04-01 00:03:09.000000', 'temperatura', 1014.0000, 'ºC'),
	(267599, 119, '2014-04-01 00:03:10.000000', 'temperatura', 215.0000, 'ºC'),
	(267600, 119, '2014-04-01 00:03:11.000000', 'temperatura', 436.0000, 'ºC'),
	(267601, 119, '2014-04-01 00:03:12.000000', 'temperatura', 333.0000, 'ºC'),
	(267602, 119, '2014-04-01 00:03:13.000000', 'temperatura', 357.0000, 'ºC'),
	(267603, 119, '2014-04-01 00:03:14.000000', 'temperatura', 790.0000, 'ºC'),
	(267604, 119, '2014-04-01 00:03:15.000000', 'temperatura', 476.0000, 'ºC'),
	(267605, 119, '2014-04-01 00:03:16.000000', 'temperatura', 10.0000, 'ºC'),
	(267606, 119, '2014-04-01 00:03:17.000000', 'temperatura', 1025.0000, 'ºC'),
	(267607, 119, '2014-04-01 00:03:18.000000', 'temperatura', 294.0000, 'ºC'),
	(267608, 119, '2014-04-01 00:03:19.000000', 'temperatura', 794.0000, 'ºC'),
	(267609, 119, '2014-04-01 00:03:20.000000', 'temperatura', 690.0000, 'ºC'),
	(267610, 119, '2014-04-01 00:03:21.000000', 'temperatura', 1067.0000, 'ºC'),
	(267611, 119, '2014-04-01 00:03:22.000000', 'temperatura', 864.0000, 'ºC'),
	(267612, 119, '2014-04-01 00:03:23.000000', 'temperatura', 1123.0000, 'ºC'),
	(267613, 119, '2014-04-01 00:03:24.000000', 'temperatura', 623.0000, 'ºC'),
	(267614, 119, '2014-04-01 00:03:25.000000', 'temperatura', 948.0000, 'ºC'),
	(267615, 119, '2014-04-01 00:03:26.000000', 'temperatura', 468.0000, 'ºC'),
	(267616, 119, '2014-04-01 00:03:27.000000', 'temperatura', 700.0000, 'ºC'),
	(267617, 119, '2014-04-01 00:03:28.000000', 'temperatura', 895.0000, 'ºC'),
	(267618, 119, '2014-04-01 00:03:29.000000', 'temperatura', 1176.0000, 'ºC'),
	(267619, 119, '2014-04-01 00:03:30.000000', 'temperatura', 794.0000, 'ºC'),
	(267620, 119, '2014-04-01 00:03:31.000000', 'temperatura', 441.0000, 'ºC'),
	(267621, 119, '2014-04-01 00:03:32.000000', 'temperatura', 1027.0000, 'ºC'),
	(267622, 119, '2014-04-01 00:03:33.000000', 'temperatura', 209.0000, 'ºC'),
	(267623, 119, '2014-04-01 00:03:34.000000', 'temperatura', 368.0000, 'ºC'),
	(267624, 119, '2014-04-01 00:03:35.000000', 'temperatura', 10.0000, 'ºC'),
	(267625, 119, '2014-04-01 00:03:36.000000', 'temperatura', 148.0000, 'ºC'),
	(267626, 119, '2014-04-01 00:03:37.000000', 'temperatura', 710.0000, 'ºC'),
	(267627, 119, '2014-04-01 00:03:38.000000', 'temperatura', 709.0000, 'ºC'),
	(267628, 119, '2014-04-01 00:03:39.000000', 'temperatura', 213.0000, 'ºC'),
	(267629, 119, '2014-04-01 00:03:40.000000', 'temperatura', 139.0000, 'ºC'),
	(267630, 119, '2014-04-01 00:03:41.000000', 'temperatura', 55.0000, 'ºC'),
	(267631, 119, '2014-04-01 00:03:42.000000', 'temperatura', 1058.0000, 'ºC'),
	(267632, 119, '2014-04-01 00:03:43.000000', 'temperatura', 325.0000, 'ºC'),
	(267633, 119, '2014-04-01 00:03:44.000000', 'temperatura', 852.0000, 'ºC'),
	(267634, 119, '2014-04-01 00:03:45.000000', 'temperatura', 887.0000, 'ºC'),
	(267635, 119, '2014-04-01 00:03:46.000000', 'temperatura', 677.0000, 'ºC'),
	(267636, 119, '2014-04-01 00:03:47.000000', 'temperatura', 725.0000, 'ºC'),
	(267637, 119, '2014-04-01 00:03:48.000000', 'temperatura', 397.0000, 'ºC'),
	(267638, 119, '2014-04-01 00:03:49.000000', 'temperatura', 1009.0000, 'ºC'),
	(267639, 119, '2014-04-01 00:03:50.000000', 'temperatura', 253.0000, 'ºC'),
	(267640, 119, '2014-04-01 00:03:51.000000', 'temperatura', 639.0000, 'ºC'),
	(267641, 119, '2014-04-01 00:03:52.000000', 'temperatura', 39.0000, 'ºC'),
	(267642, 119, '2014-04-01 00:03:53.000000', 'temperatura', 677.0000, 'ºC'),
	(267643, 119, '2014-04-01 00:03:54.000000', 'temperatura', 868.0000, 'ºC'),
	(267644, 119, '2014-04-01 00:03:55.000000', 'temperatura', 1111.0000, 'ºC'),
	(267645, 119, '2014-04-01 00:03:56.000000', 'temperatura', 551.0000, 'ºC'),
	(267646, 119, '2014-04-01 00:03:57.000000', 'temperatura', 623.0000, 'ºC'),
	(267647, 119, '2014-04-01 00:03:58.000000', 'temperatura', 263.0000, 'ºC'),
	(267648, 119, '2014-04-01 00:03:59.000000', 'temperatura', 647.0000, 'ºC'),
	(267649, 119, '2014-04-01 00:04:00.000000', 'temperatura', 46.0000, 'ºC'),
	(267650, 119, '2014-04-01 00:04:01.000000', 'temperatura', 688.0000, 'ºC'),
	(267651, 119, '2014-04-01 00:04:02.000000', 'temperatura', 902.0000, 'ºC'),
	(267652, 119, '2014-04-01 00:04:03.000000', 'temperatura', 46.0000, 'ºC'),
	(267653, 119, '2014-04-01 00:04:04.000000', 'temperatura', 1127.0000, 'ºC'),
	(267654, 119, '2014-04-01 00:04:05.000000', 'temperatura', 698.0000, 'ºC'),
	(267655, 119, '2014-04-01 00:04:06.000000', 'temperatura', 108.0000, 'ºC'),
	(267656, 119, '2014-04-01 00:04:07.000000', 'temperatura', 846.0000, 'ºC'),
	(267657, 119, '2014-04-01 00:04:08.000000', 'temperatura', 307.0000, 'ºC'),
	(267658, 119, '2014-04-01 00:04:09.000000', 'temperatura', 198.0000, 'ºC'),
	(267659, 119, '2014-04-01 00:04:10.000000', 'temperatura', 69.0000, 'ºC'),
	(267660, 119, '2014-04-01 00:04:11.000000', 'temperatura', 953.0000, 'ºC'),
	(267661, 119, '2014-04-01 00:04:12.000000', 'temperatura', 956.0000, 'ºC'),
	(267662, 119, '2014-04-01 00:04:13.000000', 'temperatura', 721.0000, 'ºC'),
	(267663, 119, '2014-04-01 00:04:14.000000', 'temperatura', 738.0000, 'ºC'),
	(267664, 119, '2014-04-01 00:04:15.000000', 'temperatura', 328.0000, 'ºC'),
	(267665, 119, '2014-04-01 00:04:16.000000', 'temperatura', 627.0000, 'ºC'),
	(267666, 119, '2014-04-01 00:04:17.000000', 'temperatura', 953.0000, 'ºC'),
	(267667, 119, '2014-04-01 00:04:18.000000', 'temperatura', 482.0000, 'ºC'),
	(267668, 119, '2014-04-01 00:04:19.000000', 'temperatura', 751.0000, 'ºC'),
	(267669, 119, '2014-04-01 00:04:20.000000', 'temperatura', 1111.0000, 'ºC'),
	(267670, 119, '2014-04-01 00:04:21.000000', 'temperatura', 903.0000, 'ºC'),
	(267671, 119, '2014-04-01 00:04:22.000000', 'temperatura', 1181.0000, 'ºC'),
	(267672, 119, '2014-04-01 00:04:23.000000', 'temperatura', 796.0000, 'ºC'),
	(267673, 119, '2014-04-01 00:04:24.000000', 'temperatura', 440.0000, 'ºC'),
	(267674, 119, '2014-04-01 00:04:25.000000', 'temperatura', 1010.0000, 'ºC'),
	(267675, 119, '2014-04-01 00:04:26.000000', 'temperatura', 130.0000, 'ºC'),
	(267676, 119, '2014-04-01 00:04:27.000000', 'temperatura', 21.0000, 'ºC'),
	(267677, 119, '2014-04-01 00:04:28.000000', 'temperatura', 916.0000, 'ºC'),
	(267678, 119, '2014-04-01 00:04:29.000000', 'temperatura', 916.0000, 'ºC'),
	(267679, 119, '2014-04-01 00:04:30.000000', 'temperatura', 634.0000, 'ºC'),
	(267680, 119, '2014-04-01 00:04:31.000000', 'temperatura', 422.0000, 'ºC'),
	(267681, 119, '2014-04-01 00:04:32.000000', 'temperatura', 209.0000, 'ºC'),
	(267682, 119, '2014-04-01 00:04:33.000000', 'temperatura', 981.0000, 'ºC'),
	(267683, 119, '2014-04-01 00:04:34.000000', 'temperatura', 678.0000, 'ºC'),
	(267684, 119, '2014-04-01 00:04:35.000000', 'temperatura', 446.0000, 'ºC'),
	(267685, 119, '2014-04-01 00:04:36.000000', 'temperatura', 198.0000, 'ºC'),
	(267686, 119, '2014-04-01 00:04:37.000000', 'temperatura', 850.0000, 'ºC'),
	(267687, 119, '2014-04-01 00:04:38.000000', 'temperatura', 59.0000, 'ºC'),
	(267688, 119, '2014-04-01 00:04:39.000000', 'temperatura', 147.0000, 'ºC'),
	(267689, 119, '2014-04-01 00:04:40.000000', 'temperatura', 556.0000, 'ºC'),
	(267690, 119, '2014-04-01 00:04:41.000000', 'temperatura', 1138.0000, 'ºC'),
	(267691, 119, '2014-04-01 00:04:42.000000', 'temperatura', 424.0000, 'ºC'),
	(267692, 119, '2014-04-01 00:04:43.000000', 'temperatura', 1108.0000, 'ºC'),
	(267693, 119, '2014-04-01 00:04:44.000000', 'temperatura', 670.0000, 'ºC'),
	(267694, 119, '2014-04-01 00:04:45.000000', 'temperatura', 23.0000, 'ºC'),
	(267695, 119, '2014-04-01 00:04:46.000000', 'temperatura', 506.0000, 'ºC'),
	(267696, 119, '2014-04-01 00:04:47.000000', 'temperatura', 62.0000, 'ºC'),
	(267697, 119, '2014-04-01 00:04:48.000000', 'temperatura', 1191.0000, 'ºC'),
	(267698, 119, '2014-04-01 00:04:49.000000', 'temperatura', 970.0000, 'ºC'),
	(267699, 119, '2014-04-01 00:04:50.000000', 'temperatura', 80.0000, 'ºC'),
	(267700, 119, '2014-04-01 00:04:51.000000', 'temperatura', 1087.0000, 'ºC'),
	(267701, 119, '2014-04-01 00:04:52.000000', 'temperatura', 399.0000, 'ºC'),
	(267702, 119, '2014-04-01 00:04:53.000000', 'temperatura', 1131.0000, 'ºC'),
	(267703, 119, '2014-04-01 00:04:54.000000', 'temperatura', 862.0000, 'ºC'),
	(267704, 119, '2014-04-01 00:04:55.000000', 'temperatura', 916.0000, 'ºC'),
	(267705, 119, '2014-04-01 00:04:56.000000', 'temperatura', 793.0000, 'ºC'),
	(267706, 119, '2014-04-01 00:04:57.000000', 'temperatura', 19.0000, 'ºC'),
	(267707, 119, '2014-04-01 00:04:58.000000', 'temperatura', 115.0000, 'ºC'),
	(267708, 119, '2014-04-01 00:04:59.000000', 'temperatura', 520.0000, 'ºC'),
	(267709, 119, '2014-04-01 00:05:00.000000', 'temperatura', 1054.0000, 'ºC'),
	(267710, 119, '2014-04-01 00:05:01.000000', 'temperatura', 111.0000, 'ºC'),
	(267711, 119, '2014-04-01 00:05:02.000000', 'temperatura', 993.0000, 'ºC'),
	(267712, 119, '2014-04-01 00:05:03.000000', 'temperatura', 1033.0000, 'ºC'),
	(267713, 119, '2014-04-01 00:05:04.000000', 'temperatura', 987.0000, 'ºC'),
	(267714, 119, '2014-04-01 00:05:05.000000', 'temperatura', 636.0000, 'ºC'),
	(267715, 119, '2014-04-01 00:05:06.000000', 'temperatura', 218.0000, 'ºC'),
	(267716, 119, '2014-04-01 00:05:07.000000', 'temperatura', 383.0000, 'ºC'),
	(267717, 119, '2014-04-01 00:05:08.000000', 'temperatura', 63.0000, 'ºC'),
	(267718, 119, '2014-04-01 00:05:09.000000', 'temperatura', 364.0000, 'ºC'),
	(267719, 119, '2014-04-01 00:05:10.000000', 'temperatura', 432.0000, 'ºC'),
	(267720, 119, '2014-04-01 00:05:11.000000', 'temperatura', 1067.0000, 'ºC'),
	(267721, 119, '2014-04-01 00:05:12.000000', 'temperatura', 440.0000, 'ºC'),
	(267722, 119, '2014-04-01 00:05:13.000000', 'temperatura', 201.0000, 'ºC'),
	(267723, 119, '2014-04-01 00:05:14.000000', 'temperatura', 886.0000, 'ºC'),
	(267724, 119, '2014-04-01 00:05:15.000000', 'temperatura', 227.0000, 'ºC'),
	(267725, 119, '2014-04-01 00:05:16.000000', 'temperatura', 879.0000, 'ºC'),
	(267726, 119, '2014-04-01 00:05:17.000000', 'temperatura', 115.0000, 'ºC'),
	(267727, 119, '2014-04-01 00:05:18.000000', 'temperatura', 338.0000, 'ºC'),
	(267728, 119, '2014-04-01 00:05:19.000000', 'temperatura', 145.0000, 'ºC'),
	(267729, 119, '2014-04-01 00:05:20.000000', 'temperatura', 912.0000, 'ºC'),
	(267730, 119, '2014-04-01 00:05:21.000000', 'temperatura', 527.0000, 'ºC'),
	(267731, 119, '2014-04-01 00:05:22.000000', 'temperatura', 1098.0000, 'ºC'),
	(267732, 119, '2014-04-01 00:05:23.000000', 'temperatura', 309.0000, 'ºC'),
	(267733, 119, '2014-04-01 00:05:24.000000', 'temperatura', 653.0000, 'ºC'),
	(267734, 119, '2014-04-01 00:05:25.000000', 'temperatura', 1137.0000, 'ºC'),
	(267735, 119, '2014-04-01 00:05:26.000000', 'temperatura', 125.0000, 'ºC'),
	(267736, 119, '2014-04-01 00:05:27.000000', 'temperatura', 818.0000, 'ºC'),
	(267737, 119, '2014-04-01 00:05:28.000000', 'temperatura', 112.0000, 'ºC'),
	(267738, 119, '2014-04-01 00:05:29.000000', 'temperatura', 508.0000, 'ºC'),
	(267739, 119, '2014-04-01 00:05:30.000000', 'temperatura', 1005.0000, 'ºC'),
	(267740, 119, '2014-04-01 00:05:31.000000', 'temperatura', 1102.0000, 'ºC'),
	(267741, 119, '2014-04-01 00:05:32.000000', 'temperatura', 96.0000, 'ºC'),
	(267742, 119, '2014-04-01 00:05:33.000000', 'temperatura', 773.0000, 'ºC'),
	(267743, 119, '2014-04-01 00:05:34.000000', 'temperatura', 1178.0000, 'ºC'),
	(267744, 119, '2014-04-01 00:05:35.000000', 'temperatura', 1170.0000, 'ºC'),
	(267745, 119, '2014-04-01 00:05:36.000000', 'temperatura', 1118.0000, 'ºC'),
	(267746, 119, '2014-04-01 00:05:37.000000', 'temperatura', 879.0000, 'ºC'),
	(267747, 119, '2014-04-01 00:05:38.000000', 'temperatura', 1042.0000, 'ºC'),
	(267748, 119, '2014-04-01 00:05:39.000000', 'temperatura', 173.0000, 'ºC'),
	(267749, 119, '2014-04-01 00:05:40.000000', 'temperatura', 140.0000, 'ºC'),
	(267750, 119, '2014-04-01 00:05:41.000000', 'temperatura', 182.0000, 'ºC'),
	(267751, 119, '2014-04-01 00:05:42.000000', 'temperatura', 490.0000, 'ºC'),
	(267752, 119, '2014-04-01 00:05:43.000000', 'temperatura', 703.0000, 'ºC'),
	(267753, 119, '2014-04-01 00:05:44.000000', 'temperatura', 849.0000, 'ºC'),
	(267754, 119, '2014-04-01 00:05:45.000000', 'temperatura', 933.0000, 'ºC'),
	(267755, 119, '2014-04-01 00:05:46.000000', 'temperatura', 919.0000, 'ºC'),
	(267756, 119, '2014-04-01 00:05:47.000000', 'temperatura', 597.0000, 'ºC'),
	(267757, 119, '2014-04-01 00:05:48.000000', 'temperatura', 229.0000, 'ºC'),
	(267758, 119, '2014-04-01 00:05:49.000000', 'temperatura', 555.0000, 'ºC'),
	(267759, 119, '2014-04-01 00:05:50.000000', 'temperatura', 890.0000, 'ºC'),
	(267760, 119, '2014-04-01 00:05:51.000000', 'temperatura', 383.0000, 'ºC'),
	(267761, 119, '2014-04-01 00:05:52.000000', 'temperatura', 446.0000, 'ºC'),
	(267762, 119, '2014-04-01 00:05:53.000000', 'temperatura', 1081.0000, 'ºC'),
	(267763, 119, '2014-04-01 00:05:54.000000', 'temperatura', 466.0000, 'ºC'),
	(267764, 119, '2014-04-01 00:05:55.000000', 'temperatura', 290.0000, 'ºC'),
	(267765, 119, '2014-04-01 00:05:56.000000', 'temperatura', 52.0000, 'ºC'),
	(267766, 119, '2014-04-01 00:05:57.000000', 'temperatura', 590.0000, 'ºC'),
	(267767, 119, '2014-04-01 00:05:58.000000', 'temperatura', 393.0000, 'ºC'),
	(267768, 119, '2014-04-01 00:05:59.000000', 'temperatura', 197.0000, 'ºC'),
	(267769, 119, '2014-04-01 00:06:00.000000', 'temperatura', 1004.0000, 'ºC'),
	(267770, 119, '2014-04-01 00:06:01.000000', 'temperatura', 832.0000, 'ºC'),
	(267771, 119, '2014-04-01 00:06:02.000000', 'temperatura', 1147.0000, 'ºC'),
	(267772, 119, '2014-04-01 00:06:03.000000', 'temperatura', 842.0000, 'ºC'),
	(267773, 119, '2014-04-01 00:06:04.000000', 'temperatura', 769.0000, 'ºC'),
	(267774, 119, '2014-04-01 00:06:05.000000', 'temperatura', 120.0000, 'ºC'),
	(267775, 119, '2014-04-01 00:06:06.000000', 'temperatura', 692.0000, 'ºC'),
	(267776, 119, '2014-04-01 00:06:07.000000', 'temperatura', 703.0000, 'ºC'),
	(267777, 119, '2014-04-01 00:06:08.000000', 'temperatura', 238.0000, 'ºC'),
	(267778, 119, '2014-04-01 00:06:09.000000', 'temperatura', 282.0000, 'ºC'),
	(267779, 119, '2014-04-01 00:06:10.000000', 'temperatura', 698.0000, 'ºC'),
	(267780, 119, '2014-04-01 00:06:11.000000', 'temperatura', 243.0000, 'ºC'),
	(267781, 119, '2014-04-01 00:06:12.000000', 'temperatura', 320.0000, 'ºC'),
	(267782, 119, '2014-04-01 00:06:13.000000', 'temperatura', 874.0000, 'ºC'),
	(267783, 119, '2014-04-01 00:06:14.000000', 'temperatura', 1009.0000, 'ºC'),
	(267784, 119, '2014-04-01 00:06:15.000000', 'temperatura', 23.0000, 'ºC'),
	(267785, 119, '2014-04-01 00:06:16.000000', 'temperatura', 691.0000, 'ºC'),
	(267786, 119, '2014-04-01 00:06:17.000000', 'temperatura', 986.0000, 'ºC'),
	(267787, 119, '2014-04-01 00:06:18.000000', 'temperatura', 458.0000, 'ºC'),
	(267788, 119, '2014-04-01 00:06:19.000000', 'temperatura', 531.0000, 'ºC'),
	(267789, 119, '2014-04-01 00:06:20.000000', 'temperatura', 84.0000, 'ºC'),
	(267790, 119, '2014-04-01 00:06:21.000000', 'temperatura', 25.0000, 'ºC'),
	(267791, 119, '2014-04-01 00:06:22.000000', 'temperatura', 1074.0000, 'ºC'),
	(267792, 119, '2014-04-01 00:06:23.000000', 'temperatura', 496.0000, 'ºC'),
	(267793, 119, '2014-04-01 00:06:24.000000', 'temperatura', 457.0000, 'ºC'),
	(267794, 119, '2014-04-01 00:06:25.000000', 'temperatura', 799.0000, 'ºC'),
	(267795, 119, '2014-04-01 00:06:26.000000', 'temperatura', 224.0000, 'ºC'),
	(267796, 119, '2014-04-01 00:06:27.000000', 'temperatura', 1123.0000, 'ºC'),
	(267797, 119, '2014-04-01 00:06:28.000000', 'temperatura', 145.0000, 'ºC'),
	(267798, 119, '2014-04-01 00:06:29.000000', 'temperatura', 955.0000, 'ºC'),
	(267799, 119, '2014-04-01 00:06:30.000000', 'temperatura', 742.0000, 'ºC'),
	(267800, 119, '2014-04-01 00:06:31.000000', 'temperatura', 847.0000, 'ºC'),
	(267801, 119, '2014-04-01 00:06:32.000000', 'temperatura', 808.0000, 'ºC'),
	(267802, 119, '2014-04-01 00:06:33.000000', 'temperatura', 298.0000, 'ºC'),
	(267803, 119, '2014-04-01 00:06:34.000000', 'temperatura', 267.0000, 'ºC'),
	(267804, 119, '2014-04-01 00:06:35.000000', 'temperatura', 443.0000, 'ºC'),
	(267805, 119, '2014-04-01 00:06:36.000000', 'temperatura', 215.0000, 'ºC'),
	(267806, 119, '2014-04-01 00:06:37.000000', 'temperatura', 945.0000, 'ºC'),
	(267807, 119, '2014-04-01 00:06:38.000000', 'temperatura', 479.0000, 'ºC'),
	(267808, 119, '2014-04-01 00:06:39.000000', 'temperatura', 761.0000, 'ºC'),
	(267809, 119, '2014-04-01 00:06:40.000000', 'temperatura', 1171.0000, 'ºC'),
	(267810, 119, '2014-04-01 00:06:41.000000', 'temperatura', 1172.0000, 'ºC'),
	(267811, 119, '2014-04-01 00:06:42.000000', 'temperatura', 1147.0000, 'ºC'),
	(267812, 119, '2014-04-01 00:06:43.000000', 'temperatura', 1019.0000, 'ºC'),
	(267813, 119, '2014-04-01 00:06:44.000000', 'temperatura', 455.0000, 'ºC'),
	(267814, 119, '2014-04-01 00:06:45.000000', 'temperatura', 418.0000, 'ºC'),
	(267815, 119, '2014-04-01 00:06:46.000000', 'temperatura', 728.0000, 'ºC'),
	(267816, 119, '2014-04-01 00:06:47.000000', 'temperatura', 1184.0000, 'ºC'),
	(267817, 119, '2014-04-01 00:06:48.000000', 'temperatura', 135.0000, 'ºC'),
	(267818, 119, '2014-04-01 00:06:49.000000', 'temperatura', 727.0000, 'ºC'),
	(267819, 119, '2014-04-01 00:06:50.000000', 'temperatura', 828.0000, 'ºC'),
	(267820, 119, '2014-04-01 00:06:51.000000', 'temperatura', 761.0000, 'ºC'),
	(267821, 119, '2014-04-01 00:06:52.000000', 'temperatura', 123.0000, 'ºC'),
	(267822, 119, '2014-04-01 00:06:53.000000', 'temperatura', 730.0000, 'ºC'),
	(267823, 119, '2014-04-01 00:06:54.000000', 'temperatura', 884.0000, 'ºC'),
	(267824, 119, '2014-04-01 00:06:55.000000', 'temperatura', 1027.0000, 'ºC'),
	(267825, 119, '2014-04-01 00:06:56.000000', 'temperatura', 86.0000, 'ºC'),
	(267826, 119, '2014-04-01 00:06:57.000000', 'temperatura', 950.0000, 'ºC'),
	(267827, 119, '2014-04-01 00:06:58.000000', 'temperatura', 891.0000, 'ºC'),
	(267828, 119, '2014-04-01 00:06:59.000000', 'temperatura', 405.0000, 'ºC'),
	(267829, 119, '2014-04-01 00:07:00.000000', 'temperatura', 555.0000, 'ºC'),
	(267830, 119, '2014-04-01 00:07:01.000000', 'temperatura', 358.0000, 'ºC'),
	(267831, 119, '2014-04-01 00:07:02.000000', 'temperatura', 125.0000, 'ºC'),
	(267832, 119, '2014-04-01 00:07:03.000000', 'temperatura', 752.0000, 'ºC'),
	(267833, 119, '2014-04-01 00:07:04.000000', 'temperatura', 984.0000, 'ºC'),
	(267834, 119, '2014-04-01 00:07:05.000000', 'temperatura', 264.0000, 'ºC'),
	(267835, 119, '2014-04-01 00:07:06.000000', 'temperatura', 771.0000, 'ºC'),
	(267836, 119, '2014-04-01 00:07:07.000000', 'temperatura', 664.0000, 'ºC'),
	(267837, 119, '2014-04-01 00:07:08.000000', 'temperatura', 1007.0000, 'ºC'),
	(267838, 119, '2014-04-01 00:07:09.000000', 'temperatura', 645.0000, 'ºC'),
	(267839, 119, '2014-04-01 00:07:10.000000', 'temperatura', 203.0000, 'ºC'),
	(267840, 119, '2014-04-01 00:07:11.000000', 'temperatura', 282.0000, 'ºC'),
	(267841, 119, '2014-04-01 00:07:12.000000', 'temperatura', 799.0000, 'ºC'),
	(267842, 119, '2014-04-01 00:07:13.000000', 'temperatura', 752.0000, 'ºC'),
	(267843, 119, '2014-04-01 00:07:14.000000', 'temperatura', 163.0000, 'ºC'),
	(267844, 119, '2014-04-01 00:07:15.000000', 'temperatura', 961.0000, 'ºC'),
	(267845, 119, '2014-04-01 00:07:16.000000', 'temperatura', 714.0000, 'ºC'),
	(267846, 119, '2014-04-01 00:07:17.000000', 'temperatura', 687.0000, 'ºC'),
	(267847, 119, '2014-04-01 00:07:18.000000', 'temperatura', 95.0000, 'ºC'),
	(267848, 119, '2014-04-01 00:07:19.000000', 'temperatura', 814.0000, 'ºC'),
	(267849, 119, '2014-04-01 00:07:20.000000', 'temperatura', 187.0000, 'ºC'),
	(267850, 119, '2014-04-01 00:07:21.000000', 'temperatura', 892.0000, 'ºC'),
	(267851, 119, '2014-04-01 00:07:22.000000', 'temperatura', 300.0000, 'ºC'),
	(267852, 119, '2014-04-01 00:07:23.000000', 'temperatura', 25.0000, 'ºC'),
	(267853, 119, '2014-04-01 00:07:24.000000', 'temperatura', 424.0000, 'ºC'),
	(267854, 119, '2014-04-01 00:07:25.000000', 'temperatura', 845.0000, 'ºC'),
	(267855, 119, '2014-04-01 00:07:26.000000', 'temperatura', 556.0000, 'ºC'),
	(267856, 119, '2014-04-01 00:07:27.000000', 'temperatura', 246.0000, 'ºC'),
	(267857, 119, '2014-04-01 00:07:28.000000', 'temperatura', 760.0000, 'ºC'),
	(267858, 119, '2014-04-01 00:07:29.000000', 'temperatura', 665.0000, 'ºC'),
	(267859, 119, '2014-04-01 00:07:30.000000', 'temperatura', 1043.0000, 'ºC'),
	(267860, 119, '2014-04-01 00:07:31.000000', 'temperatura', 822.0000, 'ºC'),
	(267861, 119, '2014-04-01 00:07:32.000000', 'temperatura', 982.0000, 'ºC'),
	(267862, 119, '2014-04-01 00:07:33.000000', 'temperatura', 42.0000, 'ºC'),
	(267863, 119, '2014-04-01 00:07:34.000000', 'temperatura', 866.0000, 'ºC'),
	(267864, 119, '2014-04-01 00:07:35.000000', 'temperatura', 606.0000, 'ºC'),
	(267865, 119, '2014-04-01 00:07:36.000000', 'temperatura', 431.0000, 'ºC'),
	(267866, 119, '2014-04-01 00:07:37.000000', 'temperatura', 339.0000, 'ºC'),
	(267867, 119, '2014-04-01 00:07:38.000000', 'temperatura', 403.0000, 'ºC'),
	(267868, 119, '2014-04-01 00:07:39.000000', 'temperatura', 998.0000, 'ºC'),
	(267869, 119, '2014-04-01 00:07:40.000000', 'temperatura', 181.0000, 'ºC'),
	(267870, 119, '2014-04-01 00:07:41.000000', 'temperatura', 312.0000, 'ºC'),
	(267871, 119, '2014-04-01 00:07:42.000000', 'temperatura', 1018.0000, 'ºC'),
	(267872, 119, '2014-04-01 00:07:43.000000', 'temperatura', 552.0000, 'ºC'),
	(267873, 119, '2014-04-01 00:07:44.000000', 'temperatura', 907.0000, 'ºC'),
	(267874, 119, '2014-04-01 00:07:45.000000', 'temperatura', 481.0000, 'ºC'),
	(267875, 119, '2014-04-01 00:07:46.000000', 'temperatura', 886.0000, 'ºC'),
	(267876, 119, '2014-04-01 00:07:47.000000', 'temperatura', 585.0000, 'ºC'),
	(267877, 119, '2014-04-01 00:07:48.000000', 'temperatura', 268.0000, 'ºC'),
	(267878, 119, '2014-04-01 00:07:49.000000', 'temperatura', 784.0000, 'ºC'),
	(267879, 119, '2014-04-01 00:07:50.000000', 'temperatura', 717.0000, 'ºC'),
	(267880, 119, '2014-04-01 00:07:51.000000', 'temperatura', 35.0000, 'ºC'),
	(267881, 119, '2014-04-01 00:07:52.000000', 'temperatura', 422.0000, 'ºC'),
	(267882, 119, '2014-04-01 00:07:53.000000', 'temperatura', 808.0000, 'ºC'),
	(267883, 119, '2014-04-01 00:07:54.000000', 'temperatura', 373.0000, 'ºC'),
	(267884, 119, '2014-04-01 00:07:55.000000', 'temperatura', 644.0000, 'ºC'),
	(267885, 119, '2014-04-01 00:07:56.000000', 'temperatura', 898.0000, 'ºC'),
	(267886, 119, '2014-04-01 00:07:57.000000', 'temperatura', 160.0000, 'ºC'),
	(267887, 119, '2014-04-01 00:07:58.000000', 'temperatura', 507.0000, 'ºC'),
	(267888, 119, '2014-04-01 00:07:59.000000', 'temperatura', 856.0000, 'ºC'),
	(267889, 119, '2014-04-01 00:08:00.000000', 'temperatura', 359.0000, 'ºC'),
	(267890, 119, '2014-04-01 00:08:01.000000', 'temperatura', 425.0000, 'ºC'),
	(267891, 119, '2014-04-01 00:08:02.000000', 'temperatura', 1052.0000, 'ºC'),
	(267892, 119, '2014-04-01 00:08:03.000000', 'temperatura', 386.0000, 'ºC'),
	(267893, 119, '2014-04-01 00:08:04.000000', 'temperatura', 1172.0000, 'ºC'),
	(267894, 119, '2014-04-01 00:08:05.000000', 'temperatura', 1101.0000, 'ºC'),
	(267895, 119, '2014-04-01 00:08:06.000000', 'temperatura', 792.0000, 'ºC'),
	(267896, 119, '2014-04-01 00:08:07.000000', 'temperatura', 658.0000, 'ºC'),
	(267897, 119, '2014-04-01 00:08:08.000000', 'temperatura', 914.0000, 'ºC'),
	(267898, 119, '2014-04-01 00:08:09.000000', 'temperatura', 197.0000, 'ºC'),
	(267899, 119, '2014-04-01 00:08:10.000000', 'temperatura', 642.0000, 'ºC'),
	(267900, 119, '2014-04-01 00:08:11.000000', 'temperatura', 219.0000, 'ºC'),
	(267901, 119, '2014-04-01 00:08:12.000000', 'temperatura', 368.0000, 'ºC'),
	(267902, 119, '2014-04-01 00:08:13.000000', 'temperatura', 1186.0000, 'ºC'),
	(267903, 119, '2014-04-01 00:08:14.000000', 'temperatura', 28.0000, 'ºC'),
	(267904, 119, '2014-04-01 00:08:15.000000', 'temperatura', 179.0000, 'ºC'),
	(267905, 119, '2014-04-01 00:08:16.000000', 'temperatura', 814.0000, 'ºC'),
	(267906, 119, '2014-04-01 00:08:17.000000', 'temperatura', 1133.0000, 'ºC'),
	(267907, 119, '2014-04-01 00:08:18.000000', 'temperatura', 824.0000, 'ºC'),
	(267908, 119, '2014-04-01 00:08:19.000000', 'temperatura', 719.0000, 'ºC'),
	(267909, 119, '2014-04-01 00:08:20.000000', 'temperatura', 1125.0000, 'ºC'),
	(267910, 119, '2014-04-01 00:08:21.000000', 'temperatura', 1069.0000, 'ºC'),
	(267911, 119, '2014-04-01 00:08:22.000000', 'temperatura', 772.0000, 'ºC'),
	(267912, 119, '2014-04-01 00:08:23.000000', 'temperatura', 652.0000, 'ºC'),
	(267913, 119, '2014-04-01 00:08:24.000000', 'temperatura', 943.0000, 'ºC'),
	(267914, 119, '2014-04-01 00:08:25.000000', 'temperatura', 360.0000, 'ºC'),
	(267915, 119, '2014-04-01 00:08:26.000000', 'temperatura', 173.0000, 'ºC'),
	(267916, 119, '2014-04-01 00:08:27.000000', 'temperatura', 986.0000, 'ºC'),
	(267917, 119, '2014-04-01 00:08:28.000000', 'temperatura', 809.0000, 'ºC'),
	(267918, 119, '2014-04-01 00:08:29.000000', 'temperatura', 1088.0000, 'ºC'),
	(267919, 119, '2014-04-01 00:08:30.000000', 'temperatura', 614.0000, 'ºC'),
	(267920, 119, '2014-04-01 00:08:31.000000', 'temperatura', 1007.0000, 'ºC'),
	(267921, 119, '2014-04-01 00:08:32.000000', 'temperatura', 792.0000, 'ºC'),
	(267922, 119, '2014-04-01 00:08:33.000000', 'temperatura', 940.0000, 'ºC'),
	(267923, 119, '2014-04-01 00:08:34.000000', 'temperatura', 1123.0000, 'ºC'),
	(267924, 119, '2014-04-01 00:08:35.000000', 'temperatura', 396.0000, 'ºC'),
	(267925, 119, '2014-04-01 00:08:36.000000', 'temperatura', 1013.0000, 'ºC'),
	(267926, 119, '2014-04-01 00:08:37.000000', 'temperatura', 277.0000, 'ºC'),
	(267927, 119, '2014-04-01 00:08:38.000000', 'temperatura', 744.0000, 'ºC'),
	(267928, 119, '2014-04-01 00:08:39.000000', 'temperatura', 492.0000, 'ºC'),
	(267929, 119, '2014-04-01 00:08:40.000000', 'temperatura', 228.0000, 'ºC'),
	(267930, 119, '2014-04-01 00:08:41.000000', 'temperatura', 866.0000, 'ºC'),
	(267931, 119, '2014-04-01 00:08:42.000000', 'temperatura', 47.0000, 'ºC'),
	(267932, 119, '2014-04-01 00:08:43.000000', 'temperatura', 38.0000, 'ºC'),
	(267933, 119, '2014-04-01 00:08:44.000000', 'temperatura', 49.0000, 'ºC'),
	(267934, 119, '2014-04-01 00:08:45.000000', 'temperatura', 132.0000, 'ºC'),
	(267935, 119, '2014-04-01 00:08:46.000000', 'temperatura', 513.0000, 'ºC'),
	(267936, 119, '2014-04-01 00:08:47.000000', 'temperatura', 970.0000, 'ºC'),
	(267937, 119, '2014-04-01 00:08:48.000000', 'temperatura', 909.0000, 'ºC'),
	(267938, 119, '2014-04-01 00:08:49.000000', 'temperatura', 438.0000, 'ºC'),
	(267939, 119, '2014-04-01 00:08:50.000000', 'temperatura', 665.0000, 'ºC'),
	(267940, 119, '2014-04-01 00:08:51.000000', 'temperatura', 808.0000, 'ºC'),
	(267941, 119, '2014-04-01 00:08:52.000000', 'temperatura', 847.0000, 'ºC'),
	(267942, 119, '2014-04-01 00:08:53.000000', 'temperatura', 611.0000, 'ºC'),
	(267943, 119, '2014-04-01 00:08:54.000000', 'temperatura', 513.0000, 'ºC'),
	(267944, 119, '2014-04-01 00:08:55.000000', 'temperatura', 734.0000, 'ºC'),
	(267945, 119, '2014-04-01 00:08:56.000000', 'temperatura', 933.0000, 'ºC'),
	(267946, 119, '2014-04-01 00:08:57.000000', 'temperatura', 64.0000, 'ºC'),
	(267947, 119, '2014-04-01 00:08:58.000000', 'temperatura', 1119.0000, 'ºC'),
	(267948, 119, '2014-04-01 00:08:59.000000', 'temperatura', 603.0000, 'ºC'),
	(267949, 119, '2014-04-01 00:09:00.000000', 'temperatura', 860.0000, 'ºC'),
	(267950, 119, '2014-04-01 00:09:01.000000', 'temperatura', 93.0000, 'ºC'),
	(267951, 119, '2014-04-01 00:09:02.000000', 'temperatura', 283.0000, 'ºC'),
	(267952, 119, '2014-04-01 00:09:03.000000', 'temperatura', 1136.0000, 'ºC'),
	(267953, 119, '2014-04-01 00:09:04.000000', 'temperatura', 31.0000, 'ºC'),
	(267954, 119, '2014-04-01 00:09:05.000000', 'temperatura', 349.0000, 'ºC'),
	(267955, 119, '2014-04-01 00:09:06.000000', 'temperatura', 453.0000, 'ºC'),
	(267956, 119, '2014-04-01 00:09:07.000000', 'temperatura', 19.0000, 'ºC'),
	(267957, 119, '2014-04-01 00:09:08.000000', 'temperatura', 1137.0000, 'ºC'),
	(267958, 119, '2014-04-01 00:09:09.000000', 'temperatura', 826.0000, 'ºC'),
	(267959, 119, '2014-04-01 00:09:10.000000', 'temperatura', 719.0000, 'ºC'),
	(267960, 119, '2014-04-01 00:09:11.000000', 'temperatura', 1119.0000, 'ºC'),
	(267961, 119, '2014-04-01 00:09:12.000000', 'temperatura', 1037.0000, 'ºC'),
	(267962, 119, '2014-04-01 00:09:13.000000', 'temperatura', 628.0000, 'ºC'),
	(267963, 119, '2014-04-01 00:09:14.000000', 'temperatura', 31.0000, 'ºC'),
	(267964, 119, '2014-04-01 00:09:15.000000', 'temperatura', 669.0000, 'ºC'),
	(267965, 119, '2014-04-01 00:09:16.000000', 'temperatura', 855.0000, 'ºC'),
	(267966, 119, '2014-04-01 00:09:17.000000', 'temperatura', 1067.0000, 'ºC'),
	(267967, 119, '2014-04-01 00:09:18.000000', 'temperatura', 369.0000, 'ºC'),
	(267968, 119, '2014-04-01 00:09:19.000000', 'temperatura', 1046.0000, 'ºC'),
	(267969, 119, '2014-04-01 00:09:20.000000', 'temperatura', 522.0000, 'ºC'),
	(267970, 119, '2014-04-01 00:09:21.000000', 'temperatura', 673.0000, 'ºC'),
	(267971, 119, '2014-04-01 00:09:22.000000', 'temperatura', 598.0000, 'ºC'),
	(267972, 119, '2014-04-01 00:09:23.000000', 'temperatura', 972.0000, 'ºC'),
	(267973, 119, '2014-04-01 00:09:24.000000', 'temperatura', 668.0000, 'ºC'),
	(267974, 119, '2014-04-01 00:09:25.000000', 'temperatura', 426.0000, 'ºC'),
	(267975, 119, '2014-04-01 00:09:26.000000', 'temperatura', 123.0000, 'ºC'),
	(267976, 119, '2014-04-01 00:09:27.000000', 'temperatura', 540.0000, 'ºC'),
	(267977, 119, '2014-04-01 00:09:28.000000', 'temperatura', 1132.0000, 'ºC'),
	(267978, 119, '2014-04-01 00:09:29.000000', 'temperatura', 441.0000, 'ºC'),
	(267979, 119, '2014-04-01 00:09:30.000000', 'temperatura', 6.0000, 'ºC'),
	(267980, 119, '2014-04-01 00:09:31.000000', 'temperatura', 1111.0000, 'ºC'),
	(267981, 119, '2014-04-01 00:09:32.000000', 'temperatura', 736.0000, 'ºC'),
	(267982, 119, '2014-04-01 00:09:33.000000', 'temperatura', 349.0000, 'ºC'),
	(267983, 119, '2014-04-01 00:09:34.000000', 'temperatura', 735.0000, 'ºC'),
	(267984, 119, '2014-04-01 00:09:35.000000', 'temperatura', 231.0000, 'ºC'),
	(267985, 119, '2014-04-01 00:09:36.000000', 'temperatura', 149.0000, 'ºC'),
	(267986, 119, '2014-04-01 00:09:37.000000', 'temperatura', 53.0000, 'ºC'),
	(267987, 119, '2014-04-01 00:09:38.000000', 'temperatura', 1019.0000, 'ºC'),
	(267988, 119, '2014-04-01 00:09:39.000000', 'temperatura', 135.0000, 'ºC'),
	(267989, 119, '2014-04-01 00:09:40.000000', 'temperatura', 19.0000, 'ºC'),
	(267990, 119, '2014-04-01 00:09:41.000000', 'temperatura', 890.0000, 'ºC'),
	(267991, 119, '2014-04-01 00:09:42.000000', 'temperatura', 795.0000, 'ºC'),
	(267992, 119, '2014-04-01 00:09:43.000000', 'temperatura', 104.0000, 'ºC'),
	(267993, 119, '2014-04-01 00:09:44.000000', 'temperatura', 538.0000, 'ºC'),
	(267994, 119, '2014-04-01 00:09:45.000000', 'temperatura', 1177.0000, 'ºC'),
	(267995, 119, '2014-04-01 00:09:46.000000', 'temperatura', 674.0000, 'ºC'),
	(267996, 119, '2014-04-01 00:09:47.000000', 'temperatura', 1036.0000, 'ºC'),
	(267997, 119, '2014-04-01 00:09:48.000000', 'temperatura', 761.0000, 'ºC'),
	(267998, 119, '2014-04-01 00:09:49.000000', 'temperatura', 697.0000, 'ºC'),
	(267999, 119, '2014-04-01 00:09:50.000000', 'temperatura', 3.0000, 'ºC'),
	(268000, 119, '2014-04-01 00:09:51.000000', 'temperatura', 324.0000, 'ºC'),
	(268001, 119, '2014-04-01 00:09:52.000000', 'temperatura', 412.0000, 'ºC'),
	(268002, 119, '2014-04-01 00:09:53.000000', 'temperatura', 1088.0000, 'ºC'),
	(268003, 119, '2014-04-01 00:09:54.000000', 'temperatura', 604.0000, 'ºC'),
	(268004, 119, '2014-04-01 00:09:55.000000', 'temperatura', 959.0000, 'ºC'),
	(268005, 119, '2014-04-01 00:09:56.000000', 'temperatura', 582.0000, 'ºC'),
	(268006, 119, '2014-04-01 00:09:57.000000', 'temperatura', 32.0000, 'ºC'),
	(268007, 119, '2014-04-01 00:09:58.000000', 'temperatura', 814.0000, 'ºC'),
	(268008, 119, '2014-04-01 00:09:59.000000', 'temperatura', 376.0000, 'ºC'),
	(268009, 119, '2014-04-01 00:10:00.000000', 'temperatura', 637.0000, 'ºC'),
	(268010, 119, '2014-04-01 00:10:01.000000', 'temperatura', 859.0000, 'ºC'),
	(268011, 119, '2014-04-01 00:10:02.000000', 'temperatura', 1185.0000, 'ºC'),
	(268012, 119, '2014-04-01 00:10:03.000000', 'temperatura', 949.0000, 'ºC'),
	(268013, 119, '2014-04-01 00:10:04.000000', 'temperatura', 1188.0000, 'ºC'),
	(268014, 119, '2014-04-01 00:10:05.000000', 'temperatura', 693.0000, 'ºC'),
	(268015, 119, '2014-04-01 00:10:06.000000', 'temperatura', 1102.0000, 'ºC'),
	(268016, 119, '2014-04-01 00:10:07.000000', 'temperatura', 1031.0000, 'ºC'),
	(268017, 119, '2014-04-01 00:10:08.000000', 'temperatura', 651.0000, 'ºC'),
	(268018, 119, '2014-04-01 00:10:09.000000', 'temperatura', 161.0000, 'ºC'),
	(268019, 119, '2014-04-01 00:10:10.000000', 'temperatura', 54.0000, 'ºC'),
	(268020, 119, '2014-04-01 00:10:11.000000', 'temperatura', 986.0000, 'ºC'),
	(268021, 119, '2014-04-01 00:10:12.000000', 'temperatura', 1169.0000, 'ºC'),
	(268022, 119, '2014-04-01 00:10:13.000000', 'temperatura', 490.0000, 'ºC'),
	(268023, 119, '2014-04-01 00:10:14.000000', 'temperatura', 141.0000, 'ºC'),
	(268024, 119, '2014-04-01 00:10:15.000000', 'temperatura', 435.0000, 'ºC'),
	(268025, 119, '2014-04-01 00:10:16.000000', 'temperatura', 552.0000, 'ºC'),
	(268026, 119, '2014-04-01 00:10:17.000000', 'temperatura', 255.0000, 'ºC'),
	(268027, 119, '2014-04-01 00:10:18.000000', 'temperatura', 821.0000, 'ºC'),
	(268028, 119, '2014-04-01 00:10:19.000000', 'temperatura', 941.0000, 'ºC'),
	(268029, 119, '2014-04-01 00:10:20.000000', 'temperatura', 1044.0000, 'ºC'),
	(268030, 119, '2014-04-01 00:10:21.000000', 'temperatura', 1194.0000, 'ºC'),
	(268031, 119, '2014-04-01 00:10:22.000000', 'temperatura', 440.0000, 'ºC'),
	(268032, 119, '2014-04-01 00:10:23.000000', 'temperatura', 1019.0000, 'ºC'),
	(268033, 119, '2014-04-01 00:10:24.000000', 'temperatura', 175.0000, 'ºC'),
	(268034, 119, '2014-04-01 00:10:25.000000', 'temperatura', 218.0000, 'ºC'),
	(268035, 119, '2014-04-01 00:10:26.000000', 'temperatura', 564.0000, 'ºC'),
	(268036, 119, '2014-04-01 00:10:27.000000', 'temperatura', 970.0000, 'ºC'),
	(268037, 119, '2014-04-01 00:10:28.000000', 'temperatura', 757.0000, 'ºC'),
	(268038, 119, '2014-04-01 00:10:29.000000', 'temperatura', 875.0000, 'ºC'),
	(268039, 119, '2014-04-01 00:10:30.000000', 'temperatura', 903.0000, 'ºC'),
	(268040, 119, '2014-04-01 00:10:31.000000', 'temperatura', 691.0000, 'ºC'),
	(268041, 119, '2014-04-01 00:10:32.000000', 'temperatura', 745.0000, 'ºC'),
	(268042, 119, '2014-04-01 00:10:33.000000', 'temperatura', 454.0000, 'ºC'),
	(268043, 119, '2014-04-01 00:10:34.000000', 'temperatura', 36.0000, 'ºC'),
	(268044, 119, '2014-04-01 00:10:35.000000', 'temperatura', 17.0000, 'ºC'),
	(268045, 119, '2014-04-01 00:10:36.000000', 'temperatura', 1177.0000, 'ºC'),
	(268046, 119, '2014-04-01 00:10:37.000000', 'temperatura', 1035.0000, 'ºC'),
	(268047, 119, '2014-04-01 00:10:38.000000', 'temperatura', 445.0000, 'ºC'),
	(268048, 119, '2014-04-01 00:10:39.000000', 'temperatura', 321.0000, 'ºC'),
	(268049, 119, '2014-04-01 00:10:40.000000', 'temperatura', 269.0000, 'ºC'),
	(268050, 119, '2014-04-01 00:10:41.000000', 'temperatura', 385.0000, 'ºC'),
	(268051, 119, '2014-04-01 00:10:42.000000', 'temperatura', 1116.0000, 'ºC'),
	(268052, 119, '2014-04-01 00:10:43.000000', 'temperatura', 826.0000, 'ºC'),
	(268053, 119, '2014-04-01 00:10:44.000000', 'temperatura', 781.0000, 'ºC'),
	(268054, 119, '2014-04-01 00:10:45.000000', 'temperatura', 230.0000, 'ºC'),
	(268055, 119, '2014-04-01 00:10:46.000000', 'temperatura', 7.0000, 'ºC'),
	(268056, 119, '2014-04-01 00:10:47.000000', 'temperatura', 544.0000, 'ºC'),
	(268057, 119, '2014-04-01 00:10:48.000000', 'temperatura', 299.0000, 'ºC'),
	(268058, 119, '2014-04-01 00:10:49.000000', 'temperatura', 1064.0000, 'ºC'),
	(268059, 119, '2014-04-01 00:10:50.000000', 'temperatura', 825.0000, 'ºC'),
	(268060, 119, '2014-04-01 00:10:51.000000', 'temperatura', 934.0000, 'ºC'),
	(268061, 119, '2014-04-01 00:10:52.000000', 'temperatura', 996.0000, 'ºC'),
	(268062, 119, '2014-04-01 00:10:53.000000', 'temperatura', 978.0000, 'ºC'),
	(268063, 119, '2014-04-01 00:10:54.000000', 'temperatura', 701.0000, 'ºC'),
	(268064, 119, '2014-04-01 00:10:55.000000', 'temperatura', 573.0000, 'ºC'),
	(268065, 119, '2014-04-01 00:10:56.000000', 'temperatura', 762.0000, 'ºC'),
	(268066, 119, '2014-04-01 00:10:57.000000', 'temperatura', 890.0000, 'ºC'),
	(268067, 119, '2014-04-01 00:10:58.000000', 'temperatura', 964.0000, 'ºC'),
	(268068, 119, '2014-04-01 00:10:59.000000', 'temperatura', 953.0000, 'ºC'),
	(268069, 119, '2014-04-01 00:11:00.000000', 'temperatura', 674.0000, 'ºC'),
	(268070, 119, '2014-04-01 00:11:01.000000', 'temperatura', 510.0000, 'ºC'),
	(268071, 119, '2014-04-01 00:11:02.000000', 'temperatura', 529.0000, 'ºC'),
	(268072, 119, '2014-04-01 00:11:03.000000', 'temperatura', 1116.0000, 'ºC'),
	(268073, 119, '2014-04-01 00:11:04.000000', 'temperatura', 394.0000, 'ºC'),
	(268074, 119, '2014-04-01 00:11:05.000000', 'temperatura', 1020.0000, 'ºC'),
	(268075, 119, '2014-04-01 00:11:06.000000', 'temperatura', 321.0000, 'ºC'),
	(268076, 119, '2014-04-01 00:11:07.000000', 'temperatura', 946.0000, 'ºC'),
	(268077, 119, '2014-04-01 00:11:08.000000', 'temperatura', 167.0000, 'ºC'),
	(268078, 119, '2014-04-01 00:11:09.000000', 'temperatura', 397.0000, 'ºC'),
	(268079, 119, '2014-04-01 00:11:10.000000', 'temperatura', 285.0000, 'ºC'),
	(268080, 119, '2014-04-01 00:11:11.000000', 'temperatura', 234.0000, 'ºC'),
	(268081, 119, '2014-04-01 00:11:12.000000', 'temperatura', 315.0000, 'ºC'),
	(268082, 119, '2014-04-01 00:11:13.000000', 'temperatura', 872.0000, 'ºC'),
	(268083, 119, '2014-04-01 00:11:14.000000', 'temperatura', 1016.0000, 'ºC'),
	(268084, 119, '2014-04-01 00:11:15.000000', 'temperatura', 67.0000, 'ºC'),
	(268085, 119, '2014-04-01 00:11:16.000000', 'temperatura', 887.0000, 'ºC'),
	(268086, 119, '2014-04-01 00:11:17.000000', 'temperatura', 632.0000, 'ºC'),
	(268087, 119, '2014-04-01 00:11:18.000000', 'temperatura', 501.0000, 'ºC'),
	(268088, 119, '2014-04-01 00:11:19.000000', 'temperatura', 610.0000, 'ºC'),
	(268089, 119, '2014-04-01 00:11:20.000000', 'temperatura', 346.0000, 'ºC'),
	(268090, 119, '2014-04-01 00:11:21.000000', 'temperatura', 1100.0000, 'ºC'),
	(268091, 119, '2014-04-01 00:11:22.000000', 'temperatura', 862.0000, 'ºC'),
	(268092, 119, '2014-04-01 00:11:23.000000', 'temperatura', 1013.0000, 'ºC'),
	(268093, 119, '2014-04-01 00:11:24.000000', 'temperatura', 78.0000, 'ºC'),
	(268094, 119, '2014-04-01 00:11:25.000000', 'temperatura', 951.0000, 'ºC'),
	(268095, 119, '2014-04-01 00:11:26.000000', 'temperatura', 921.0000, 'ºC'),
	(268096, 119, '2014-04-01 00:11:27.000000', 'temperatura', 555.0000, 'ºC'),
	(268097, 119, '2014-04-01 00:11:28.000000', 'temperatura', 12.0000, 'ºC'),
	(268098, 119, '2014-04-01 00:11:29.000000', 'temperatura', 793.0000, 'ºC'),
	(268099, 119, '2014-04-01 00:11:30.000000', 'temperatura', 332.0000, 'ºC'),
	(268100, 119, '2014-04-01 00:11:31.000000', 'temperatura', 481.0000, 'ºC'),
	(268101, 119, '2014-04-01 00:11:32.000000', 'temperatura', 209.0000, 'ºC'),
	(268102, 119, '2014-04-01 00:11:33.000000', 'temperatura', 801.0000, 'ºC'),
	(268103, 119, '2014-04-01 00:11:34.000000', 'temperatura', 980.0000, 'ºC'),
	(268104, 119, '2014-04-01 00:11:35.000000', 'temperatura', 97.0000, 'ºC'),
	(268105, 119, '2014-04-01 00:11:36.000000', 'temperatura', 1146.0000, 'ºC'),
	(268106, 119, '2014-04-01 00:11:37.000000', 'temperatura', 639.0000, 'ºC'),
	(268107, 119, '2014-04-01 00:11:38.000000', 'temperatura', 959.0000, 'ºC'),
	(268108, 119, '2014-04-01 00:11:39.000000', 'temperatura', 479.0000, 'ºC'),
	(268109, 119, '2014-04-01 00:11:40.000000', 'temperatura', 719.0000, 'ºC'),
	(268110, 119, '2014-04-01 00:11:41.000000', 'temperatura', 956.0000, 'ºC'),
	(268111, 119, '2014-04-01 00:11:42.000000', 'temperatura', 225.0000, 'ºC'),
	(268112, 119, '2014-04-01 00:11:43.000000', 'temperatura', 659.0000, 'ºC'),
	(268113, 119, '2014-04-01 00:11:44.000000', 'temperatura', 219.0000, 'ºC'),
	(268114, 119, '2014-04-01 00:11:45.000000', 'temperatura', 320.0000, 'ºC'),
	(268115, 119, '2014-04-01 00:11:46.000000', 'temperatura', 943.0000, 'ºC'),
	(268116, 119, '2014-04-01 00:11:47.000000', 'temperatura', 157.0000, 'ºC'),
	(268117, 119, '2014-04-01 00:11:48.000000', 'temperatura', 357.0000, 'ºC'),
	(268118, 119, '2014-04-01 00:11:49.000000', 'temperatura', 111.0000, 'ºC'),
	(268119, 119, '2014-04-01 00:11:50.000000', 'temperatura', 688.0000, 'ºC'),
	(268120, 119, '2014-04-01 00:11:51.000000', 'temperatura', 704.0000, 'ºC'),
	(268121, 119, '2014-04-01 00:11:52.000000', 'temperatura', 260.0000, 'ºC'),
	(268122, 119, '2014-04-01 00:11:53.000000', 'temperatura', 388.0000, 'ºC'),
	(268123, 119, '2014-04-01 00:11:54.000000', 'temperatura', 1158.0000, 'ºC'),
	(268124, 119, '2014-04-01 00:11:55.000000', 'temperatura', 1028.0000, 'ºC'),
	(268125, 119, '2014-04-01 00:11:56.000000', 'temperatura', 467.0000, 'ºC'),
	(268126, 119, '2014-04-01 00:11:57.000000', 'temperatura', 450.0000, 'ºC'),
	(268127, 119, '2014-04-01 00:11:58.000000', 'temperatura', 849.0000, 'ºC'),
	(268128, 119, '2014-04-01 00:11:59.000000', 'temperatura', 495.0000, 'ºC'),
	(268129, 119, '2014-04-01 00:12:00.000000', 'temperatura', 1129.0000, 'ºC'),
	(268130, 119, '2014-04-01 00:12:01.000000', 'temperatura', 559.0000, 'ºC'),
	(268131, 119, '2014-04-01 00:12:02.000000', 'temperatura', 612.0000, 'ºC'),
	(268132, 119, '2014-04-01 00:12:03.000000', 'temperatura', 181.0000, 'ºC'),
	(268133, 119, '2014-04-01 00:12:04.000000', 'temperatura', 272.0000, 'ºC'),
	(268134, 119, '2014-04-01 00:12:05.000000', 'temperatura', 816.0000, 'ºC'),
	(268135, 119, '2014-04-01 00:12:06.000000', 'temperatura', 863.0000, 'ºC'),
	(268136, 119, '2014-04-01 00:12:07.000000', 'temperatura', 669.0000, 'ºC'),
	(268137, 119, '2014-04-01 00:12:08.000000', 'temperatura', 756.0000, 'ºC'),
	(268138, 119, '2014-04-01 00:12:09.000000', 'temperatura', 573.0000, 'ºC'),
	(268139, 119, '2014-04-01 00:12:10.000000', 'temperatura', 597.0000, 'ºC'),
	(268140, 119, '2014-04-01 00:12:11.000000', 'temperatura', 69.0000, 'ºC'),
	(268141, 119, '2014-04-01 00:12:12.000000', 'temperatura', 953.0000, 'ºC'),
	(268142, 119, '2014-04-01 00:12:13.000000', 'temperatura', 960.0000, 'ºC'),
	(268143, 119, '2014-04-01 00:12:14.000000', 'temperatura', 740.0000, 'ºC'),
	(268144, 119, '2014-04-01 00:12:15.000000', 'temperatura', 819.0000, 'ºC'),
	(268145, 119, '2014-04-01 00:12:16.000000', 'temperatura', 677.0000, 'ºC'),
	(268146, 119, '2014-04-01 00:12:17.000000', 'temperatura', 929.0000, 'ºC'),
	(268147, 119, '2014-04-01 00:12:18.000000', 'temperatura', 214.0000, 'ºC'),
	(268148, 119, '2014-04-01 00:12:19.000000', 'temperatura', 683.0000, 'ºC'),
	(268149, 119, '2014-04-01 00:12:20.000000', 'temperatura', 375.0000, 'ºC'),
	(268150, 119, '2014-04-01 00:12:21.000000', 'temperatura', 1026.0000, 'ºC'),
	(268151, 119, '2014-04-01 00:12:22.000000', 'temperatura', 406.0000, 'ºC'),
	(268152, 119, '2014-04-01 00:12:23.000000', 'temperatura', 153.0000, 'ºC'),
	(268153, 119, '2014-04-01 00:12:24.000000', 'temperatura', 746.0000, 'ºC'),
	(268154, 119, '2014-04-01 00:12:25.000000', 'temperatura', 871.0000, 'ºC'),
	(268155, 119, '2014-04-01 00:12:26.000000', 'temperatura', 916.0000, 'ºC'),
	(268156, 119, '2014-04-01 00:12:27.000000', 'temperatura', 770.0000, 'ºC'),
	(268157, 119, '2014-04-01 00:12:28.000000', 'temperatura', 1100.0000, 'ºC'),
	(268158, 119, '2014-04-01 00:12:29.000000', 'temperatura', 794.0000, 'ºC'),
	(268159, 119, '2014-04-01 00:12:30.000000', 'temperatura', 669.0000, 'ºC'),
	(268160, 119, '2014-04-01 00:12:31.000000', 'temperatura', 962.0000, 'ºC'),
	(268161, 119, '2014-04-01 00:12:32.000000', 'temperatura', 404.0000, 'ºC'),
	(268162, 119, '2014-04-01 00:12:33.000000', 'temperatura', 336.0000, 'ºC'),
	(268163, 119, '2014-04-01 00:12:34.000000', 'temperatura', 468.0000, 'ºC'),
	(268164, 119, '2014-04-01 00:12:35.000000', 'temperatura', 132.0000, 'ºC'),
	(268165, 119, '2014-04-01 00:12:36.000000', 'temperatura', 458.0000, 'ºC'),
	(268166, 119, '2014-04-01 00:12:37.000000', 'temperatura', 693.0000, 'ºC'),
	(268167, 119, '2014-04-01 00:12:38.000000', 'temperatura', 891.0000, 'ºC'),
	(268168, 119, '2014-04-01 00:12:39.000000', 'temperatura', 1177.0000, 'ºC'),
	(268169, 119, '2014-04-01 00:12:40.000000', 'temperatura', 813.0000, 'ºC'),
	(268170, 119, '2014-04-01 00:12:41.000000', 'temperatura', 533.0000, 'ºC'),
	(268171, 119, '2014-04-01 00:12:42.000000', 'temperatura', 228.0000, 'ºC'),
	(268172, 119, '2014-04-01 00:12:43.000000', 'temperatura', 742.0000, 'ºC'),
	(268173, 119, '2014-04-01 00:12:44.000000', 'temperatura', 624.0000, 'ºC'),
	(268174, 119, '2014-04-01 00:12:45.000000', 'temperatura', 898.0000, 'ºC'),
	(268175, 119, '2014-04-01 00:12:46.000000', 'temperatura', 216.0000, 'ºC'),
	(268176, 119, '2014-04-01 00:12:47.000000', 'temperatura', 787.0000, 'ºC'),
	(268177, 119, '2014-04-01 00:12:48.000000', 'temperatura', 887.0000, 'ºC'),
	(268178, 119, '2014-04-01 00:12:49.000000', 'temperatura', 877.0000, 'ºC'),
	(268179, 119, '2014-04-01 00:12:50.000000', 'temperatura', 521.0000, 'ºC'),
	(268180, 119, '2014-04-01 00:12:51.000000', 'temperatura', 1176.0000, 'ºC'),
	(268181, 119, '2014-04-01 00:12:52.000000', 'temperatura', 717.0000, 'ºC'),
	(268182, 119, '2014-04-01 00:12:53.000000', 'temperatura', 59.0000, 'ºC'),
	(268183, 119, '2014-04-01 00:12:54.000000', 'temperatura', 542.0000, 'ºC'),
	(268184, 119, '2014-04-01 00:12:55.000000', 'temperatura', 136.0000, 'ºC'),
	(268185, 119, '2014-04-01 00:12:56.000000', 'temperatura', 255.0000, 'ºC'),
	(268186, 119, '2014-04-01 00:12:57.000000', 'temperatura', 868.0000, 'ºC'),
	(268187, 119, '2014-04-01 00:12:58.000000', 'temperatura', 1175.0000, 'ºC'),
	(268188, 119, '2014-04-01 00:12:59.000000', 'temperatura', 872.0000, 'ºC'),
	(268189, 119, '2014-04-01 00:13:00.000000', 'temperatura', 834.0000, 'ºC'),
	(268190, 119, '2014-04-01 00:13:01.000000', 'temperatura', 353.0000, 'ºC'),
	(268191, 119, '2014-04-01 00:13:02.000000', 'temperatura', 465.0000, 'ºC'),
	(268192, 119, '2014-04-01 00:13:03.000000', 'temperatura', 68.0000, 'ºC'),
	(268193, 119, '2014-04-01 00:13:04.000000', 'temperatura', 145.0000, 'ºC'),
	(268194, 119, '2014-04-01 00:13:05.000000', 'temperatura', 523.0000, 'ºC'),
	(268195, 119, '2014-04-01 00:13:06.000000', 'temperatura', 979.0000, 'ºC'),
	(268196, 119, '2014-04-01 00:13:07.000000', 'temperatura', 925.0000, 'ºC'),
	(268197, 119, '2014-04-01 00:13:08.000000', 'temperatura', 489.0000, 'ºC'),
	(268198, 119, '2014-04-01 00:13:09.000000', 'temperatura', 870.0000, 'ºC'),
	(268199, 119, '2014-04-01 00:13:10.000000', 'temperatura', 484.0000, 'ºC'),
	(268200, 119, '2014-04-01 00:13:11.000000', 'temperatura', 1012.0000, 'ºC'),
	(268201, 119, '2014-04-01 00:13:12.000000', 'temperatura', 7.0000, 'ºC'),
	(268202, 119, '2014-04-01 00:13:13.000000', 'temperatura', 598.0000, 'ºC'),
	(268203, 119, '2014-04-01 00:13:14.000000', 'temperatura', 570.0000, 'ºC'),
	(268204, 119, '2014-04-01 00:13:15.000000', 'temperatura', 1056.0000, 'ºC'),
	(268205, 119, '2014-04-01 00:13:16.000000', 'temperatura', 1169.0000, 'ºC'),
	(268206, 119, '2014-04-01 00:13:17.000000', 'temperatura', 281.0000, 'ºC'),
	(268207, 119, '2014-04-01 00:13:18.000000', 'temperatura', 296.0000, 'ºC'),
	(268208, 119, '2014-04-01 00:13:19.000000', 'temperatura', 638.0000, 'ºC'),
	(268209, 119, '2014-04-01 00:13:20.000000', 'temperatura', 1104.0000, 'ºC'),
	(268210, 119, '2014-04-01 00:13:21.000000', 'temperatura', 4.0000, 'ºC'),
	(268211, 119, '2014-04-01 00:13:22.000000', 'temperatura', 311.0000, 'ºC'),
	(268212, 119, '2014-04-01 00:13:23.000000', 'temperatura', 341.0000, 'ºC'),
	(268213, 119, '2014-04-01 00:13:24.000000', 'temperatura', 772.0000, 'ºC'),
	(268214, 119, '2014-04-01 00:13:25.000000', 'temperatura', 439.0000, 'ºC'),
	(268215, 119, '2014-04-01 00:13:26.000000', 'temperatura', 1080.0000, 'ºC'),
	(268216, 119, '2014-04-01 00:13:27.000000', 'temperatura', 483.0000, 'ºC'),
	(268217, 119, '2014-04-01 00:13:28.000000', 'temperatura', 377.0000, 'ºC'),
	(268218, 119, '2014-04-01 00:13:29.000000', 'temperatura', 437.0000, 'ºC'),
	(268219, 119, '2014-04-01 00:13:30.000000', 'temperatura', 1054.0000, 'ºC'),
	(268220, 119, '2014-04-01 00:13:31.000000', 'temperatura', 361.0000, 'ºC'),
	(268221, 119, '2014-04-01 00:13:32.000000', 'temperatura', 1043.0000, 'ºC'),
	(268222, 119, '2014-04-01 00:13:33.000000', 'temperatura', 531.0000, 'ºC'),
	(268223, 119, '2014-04-01 00:13:34.000000', 'temperatura', 729.0000, 'ºC'),
	(268224, 119, '2014-04-01 00:13:35.000000', 'temperatura', 850.0000, 'ºC'),
	(268225, 119, '2014-04-01 00:13:36.000000', 'temperatura', 862.0000, 'ºC'),
	(268226, 119, '2014-04-01 00:13:37.000000', 'temperatura', 563.0000, 'ºC'),
	(268227, 119, '2014-04-01 00:13:38.000000', 'temperatura', 230.0000, 'ºC'),
	(268228, 119, '2014-04-01 00:13:39.000000', 'temperatura', 659.0000, 'ºC'),
	(268229, 119, '2014-04-01 00:13:40.000000', 'temperatura', 207.0000, 'ºC'),
	(268230, 119, '2014-04-01 00:13:41.000000', 'temperatura', 259.0000, 'ºC'),
	(268231, 119, '2014-04-01 00:13:42.000000', 'temperatura', 672.0000, 'ºC'),
	(268232, 119, '2014-04-01 00:13:43.000000', 'temperatura', 187.0000, 'ºC'),
	(268233, 119, '2014-04-01 00:13:44.000000', 'temperatura', 118.0000, 'ºC'),
	(268234, 119, '2014-04-01 00:13:45.000000', 'temperatura', 30.0000, 'ºC'),
	(268235, 119, '2014-04-01 00:13:46.000000', 'temperatura', 997.0000, 'ºC'),
	(268236, 119, '2014-04-01 00:13:47.000000', 'temperatura', 95.0000, 'ºC'),
	(268237, 119, '2014-04-01 00:13:48.000000', 'temperatura', 1085.0000, 'ºC'),
	(268238, 119, '2014-04-01 00:13:49.000000', 'temperatura', 342.0000, 'ºC'),
	(268239, 119, '2014-04-01 00:13:50.000000', 'temperatura', 854.0000, 'ºC'),
	(268240, 119, '2014-04-01 00:13:51.000000', 'temperatura', 843.0000, 'ºC'),
	(268241, 119, '2014-04-01 00:13:52.000000', 'temperatura', 455.0000, 'ºC'),
	(268242, 119, '2014-04-01 00:13:53.000000', 'temperatura', 946.0000, 'ºC'),
	(268243, 119, '2014-04-01 00:13:54.000000', 'temperatura', 966.0000, 'ºC'),
	(268244, 119, '2014-04-01 00:13:55.000000', 'temperatura', 791.0000, 'ºC'),
	(268245, 119, '2014-04-01 00:13:56.000000', 'temperatura', 1059.0000, 'ºC'),
	(268246, 119, '2014-04-01 00:13:57.000000', 'temperatura', 522.0000, 'ºC'),
	(268247, 119, '2014-04-01 00:13:58.000000', 'temperatura', 631.0000, 'ºC'),
	(268248, 119, '2014-04-01 00:13:59.000000', 'temperatura', 393.0000, 'ºC'),
	(268249, 119, '2014-04-01 00:14:00.000000', 'temperatura', 73.0000, 'ºC'),
	(268250, 119, '2014-04-01 00:14:01.000000', 'temperatura', 384.0000, 'ºC'),
	(268251, 119, '2014-04-01 00:14:02.000000', 'temperatura', 501.0000, 'ºC'),
	(268252, 119, '2014-04-01 00:14:03.000000', 'temperatura', 154.0000, 'ºC'),
	(268253, 119, '2014-04-01 00:14:04.000000', 'temperatura', 466.0000, 'ºC'),
	(268254, 119, '2014-04-01 00:14:05.000000', 'temperatura', 670.0000, 'ºC'),
	(268255, 119, '2014-04-01 00:14:06.000000', 'temperatura', 752.0000, 'ºC'),
	(268256, 119, '2014-04-01 00:14:07.000000', 'temperatura', 551.0000, 'ºC'),
	(268257, 119, '2014-04-01 00:14:08.000000', 'temperatura', 500.0000, 'ºC'),
	(268258, 119, '2014-04-01 00:14:09.000000', 'temperatura', 845.0000, 'ºC'),
	(268259, 119, '2014-04-01 00:14:10.000000', 'temperatura', 328.0000, 'ºC'),
	(268260, 119, '2014-04-01 00:14:11.000000', 'temperatura', 304.0000, 'ºC'),
	(268261, 119, '2014-04-01 00:14:12.000000', 'temperatura', 535.0000, 'ºC'),
	(268262, 119, '2014-04-01 00:14:13.000000', 'temperatura', 566.0000, 'ºC'),
	(268263, 119, '2014-04-01 00:14:14.000000', 'temperatura', 23.0000, 'ºC'),
	(268264, 119, '2014-04-01 00:14:15.000000', 'temperatura', 819.0000, 'ºC'),
	(268265, 119, '2014-04-01 00:14:16.000000', 'temperatura', 428.0000, 'ºC'),
	(268266, 119, '2014-04-01 00:14:17.000000', 'temperatura', 883.0000, 'ºC'),
	(268267, 119, '2014-04-01 00:14:18.000000', 'temperatura', 729.0000, 'ºC'),
	(268268, 119, '2014-04-01 00:14:19.000000', 'temperatura', 998.0000, 'ºC'),
	(268269, 119, '2014-04-01 00:14:20.000000', 'temperatura', 405.0000, 'ºC'),
	(268270, 119, '2014-04-01 00:14:21.000000', 'temperatura', 230.0000, 'ºC'),
	(268271, 119, '2014-04-01 00:14:22.000000', 'temperatura', 1138.0000, 'ºC'),
	(268272, 119, '2014-04-01 00:14:23.000000', 'temperatura', 199.0000, 'ºC'),
	(268273, 119, '2014-04-01 00:14:24.000000', 'temperatura', 1180.0000, 'ºC'),
	(268274, 119, '2014-04-01 00:14:25.000000', 'temperatura', 504.0000, 'ºC'),
	(268275, 119, '2014-04-01 00:14:26.000000', 'temperatura', 182.0000, 'ºC'),
	(268276, 119, '2014-04-01 00:14:27.000000', 'temperatura', 598.0000, 'ºC'),
	(268277, 119, '2014-04-01 00:14:28.000000', 'temperatura', 43.0000, 'ºC'),
	(268278, 119, '2014-04-01 00:14:29.000000', 'temperatura', 821.0000, 'ºC'),
	(268279, 119, '2014-04-01 00:14:30.000000', 'temperatura', 377.0000, 'ºC'),
	(268280, 119, '2014-04-01 00:14:31.000000', 'temperatura', 625.0000, 'ºC'),
	(268281, 119, '2014-04-01 00:14:32.000000', 'temperatura', 791.0000, 'ºC'),
	(268282, 119, '2014-04-01 00:14:33.000000', 'temperatura', 882.0000, 'ºC'),
	(268283, 119, '2014-04-01 00:14:34.000000', 'temperatura', 839.0000, 'ºC'),
	(268284, 119, '2014-04-01 00:14:35.000000', 'temperatura', 348.0000, 'ºC'),
	(268285, 119, '2014-04-01 00:14:36.000000', 'temperatura', 424.0000, 'ºC'),
	(268286, 119, '2014-04-01 00:14:37.000000', 'temperatura', 1077.0000, 'ºC'),
	(268287, 119, '2014-04-01 00:14:38.000000', 'temperatura', 515.0000, 'ºC'),
	(268288, 119, '2014-04-01 00:14:39.000000', 'temperatura', 542.0000, 'ºC'),
	(268289, 119, '2014-04-01 00:14:40.000000', 'temperatura', 1167.0000, 'ºC'),
	(268290, 119, '2014-04-01 00:14:41.000000', 'temperatura', 611.0000, 'ºC'),
	(268291, 119, '2014-04-01 00:14:42.000000', 'temperatura', 754.0000, 'ºC'),
	(268292, 119, '2014-04-01 00:14:43.000000', 'temperatura', 736.0000, 'ºC'),
	(268293, 119, '2014-04-01 00:14:44.000000', 'temperatura', 218.0000, 'ºC'),
	(268294, 119, '2014-04-01 00:14:45.000000', 'temperatura', 82.0000, 'ºC'),
	(268295, 119, '2014-04-01 00:14:46.000000', 'temperatura', 957.0000, 'ºC'),
	(268296, 119, '2014-04-01 00:14:47.000000', 'temperatura', 942.0000, 'ºC'),
	(268297, 119, '2014-04-01 00:14:48.000000', 'temperatura', 637.0000, 'ºC'),
	(268298, 119, '2014-04-01 00:14:49.000000', 'temperatura', 359.0000, 'ºC'),
	(268299, 119, '2014-04-01 00:14:50.000000', 'temperatura', 1086.0000, 'ºC'),
	(268300, 119, '2014-04-01 00:14:51.000000', 'temperatura', 753.0000, 'ºC'),
	(268301, 119, '2014-04-01 00:14:52.000000', 'temperatura', 507.0000, 'ºC'),
	(268302, 119, '2014-04-01 00:14:53.000000', 'temperatura', 276.0000, 'ºC'),
	(268303, 119, '2014-04-01 00:14:54.000000', 'temperatura', 1061.0000, 'ºC'),
	(268304, 119, '2014-04-01 00:14:55.000000', 'temperatura', 876.0000, 'ºC'),
	(268305, 119, '2014-04-01 00:14:56.000000', 'temperatura', 1197.0000, 'ºC'),
	(268306, 119, '2014-04-01 00:14:57.000000', 'temperatura', 958.0000, 'ºC'),
	(268307, 119, '2014-04-01 00:14:58.000000', 'temperatura', 1.0000, 'ºC'),
	(268308, 119, '2014-04-01 00:14:59.000000', 'temperatura', 731.0000, 'ºC'),
	(268309, 119, '2014-04-01 00:15:00.000000', 'temperatura', 52.0000, 'ºC'),
	(268310, 119, '2014-04-01 00:15:01.000000', 'temperatura', 466.0000, 'ºC'),
	(268311, 119, '2014-04-01 00:15:02.000000', 'temperatura', 974.0000, 'ºC'),
	(268312, 119, '2014-04-01 00:15:03.000000', 'temperatura', 1076.0000, 'ºC'),
	(268313, 119, '2014-04-01 00:15:04.000000', 'temperatura', 55.0000, 'ºC'),
	(268314, 119, '2014-04-01 00:15:05.000000', 'temperatura', 648.0000, 'ºC'),
	(268315, 119, '2014-04-01 00:15:06.000000', 'temperatura', 677.0000, 'ºC'),
	(268316, 119, '2014-04-01 00:15:07.000000', 'temperatura', 242.0000, 'ºC'),
	(268317, 119, '2014-04-01 00:15:08.000000', 'temperatura', 378.0000, 'ºC'),
	(268318, 119, '2014-04-01 00:15:09.000000', 'temperatura', 1164.0000, 'ºC'),
	(268319, 119, '2014-04-01 00:15:10.000000', 'temperatura', 1087.0000, 'ºC'),
	(268320, 119, '2014-04-01 00:15:11.000000', 'temperatura', 745.0000, 'ºC'),
	(268321, 119, '2014-04-01 00:15:12.000000', 'temperatura', 465.0000, 'ºC'),
	(268322, 119, '2014-04-01 00:15:13.000000', 'temperatura', 91.0000, 'ºC'),
	(268323, 119, '2014-04-01 00:15:14.000000', 'temperatura', 261.0000, 'ºC'),
	(268324, 119, '2014-04-01 00:15:15.000000', 'temperatura', 1031.0000, 'ºC'),
	(268325, 119, '2014-04-01 00:15:16.000000', 'temperatura', 772.0000, 'ºC'),
	(268326, 119, '2014-04-01 00:15:17.000000', 'temperatura', 769.0000, 'ºC'),
	(268327, 119, '2014-04-01 00:15:18.000000', 'temperatura', 329.0000, 'ºC'),
	(268328, 119, '2014-04-01 00:15:19.000000', 'temperatura', 537.0000, 'ºC'),
	(268329, 119, '2014-04-01 00:15:20.000000', 'temperatura', 499.0000, 'ºC'),
	(268330, 119, '2014-04-01 00:15:21.000000', 'temperatura', 884.0000, 'ºC'),
	(268331, 119, '2014-04-01 00:15:22.000000', 'temperatura', 526.0000, 'ºC'),
	(268332, 119, '2014-04-01 00:15:23.000000', 'temperatura', 1176.0000, 'ºC'),
	(268333, 119, '2014-04-01 00:15:24.000000', 'temperatura', 705.0000, 'ºC'),
	(268334, 119, '2014-04-01 00:15:25.000000', 'temperatura', 1197.0000, 'ºC'),
	(268335, 119, '2014-04-01 00:15:26.000000', 'temperatura', 271.0000, 'ºC'),
	(268336, 119, '2014-04-01 00:15:27.000000', 'temperatura', 164.0000, 'ºC'),
	(268337, 119, '2014-04-01 00:15:28.000000', 'temperatura', 8.0000, 'ºC'),
	(268338, 119, '2014-04-01 00:15:29.000000', 'temperatura', 749.0000, 'ºC'),
	(268339, 119, '2014-04-01 00:15:30.000000', 'temperatura', 122.0000, 'ºC'),
	(268340, 119, '2014-04-01 00:15:31.000000', 'temperatura', 764.0000, 'ºC'),
	(268341, 119, '2014-04-01 00:15:32.000000', 'temperatura', 1053.0000, 'ºC'),
	(268342, 119, '2014-04-01 00:15:33.000000', 'temperatura', 572.0000, 'ºC'),
	(268343, 119, '2014-04-01 00:15:34.000000', 'temperatura', 905.0000, 'ºC'),
	(268344, 119, '2014-04-01 00:15:35.000000', 'temperatura', 406.0000, 'ºC'),
	(268345, 119, '2014-04-01 00:15:36.000000', 'temperatura', 516.0000, 'ºC'),
	(268346, 119, '2014-04-01 00:15:37.000000', 'temperatura', 164.0000, 'ºC'),
	(268347, 119, '2014-04-01 00:15:38.000000', 'temperatura', 473.0000, 'ºC'),
	(268348, 119, '2014-04-01 00:15:39.000000', 'temperatura', 675.0000, 'ºC'),
	(268349, 119, '2014-04-01 00:15:40.000000', 'temperatura', 753.0000, 'ºC'),
	(268350, 119, '2014-04-01 00:15:41.000000', 'temperatura', 543.0000, 'ºC'),
	(268351, 119, '2014-04-01 00:15:42.000000', 'temperatura', 456.0000, 'ºC'),
	(268352, 119, '2014-04-01 00:15:43.000000', 'temperatura', 651.0000, 'ºC'),
	(268353, 119, '2014-04-01 00:15:44.000000', 'temperatura', 687.0000, 'ºC'),
	(268354, 119, '2014-04-01 00:15:45.000000', 'temperatura', 282.0000, 'ºC'),
	(268355, 119, '2014-04-01 00:15:46.000000', 'temperatura', 549.0000, 'ºC'),
	(268356, 119, '2014-04-01 00:15:47.000000', 'temperatura', 701.0000, 'ºC'),
	(268357, 119, '2014-04-01 00:15:48.000000', 'temperatura', 657.0000, 'ºC'),
	(268358, 119, '2014-04-01 00:15:49.000000', 'temperatura', 1181.0000, 'ºC'),
	(268359, 119, '2014-04-01 00:15:50.000000', 'temperatura', 338.0000, 'ºC'),
	(268360, 119, '2014-04-01 00:15:51.000000', 'temperatura', 545.0000, 'ºC'),
	(268361, 119, '2014-04-01 00:15:52.000000', 'temperatura', 513.0000, 'ºC'),
	(268362, 119, '2014-04-01 00:15:53.000000', 'temperatura', 932.0000, 'ºC'),
	(268363, 119, '2014-04-01 00:15:54.000000', 'temperatura', 720.0000, 'ºC'),
	(268364, 119, '2014-04-01 00:15:55.000000', 'temperatura', 804.0000, 'ºC'),
	(268365, 119, '2014-04-01 00:15:56.000000', 'temperatura', 662.0000, 'ºC'),
	(268366, 119, '2014-04-01 00:15:57.000000', 'temperatura', 897.0000, 'ºC'),
	(268367, 119, '2014-04-01 00:15:58.000000', 'temperatura', 98.0000, 'ºC'),
	(268368, 119, '2014-04-01 00:15:59.000000', 'temperatura', 202.0000, 'ºC'),
	(268369, 119, '2014-04-01 00:16:00.000000', 'temperatura', 714.0000, 'ºC'),
	(268370, 119, '2014-04-01 00:16:01.000000', 'temperatura', 566.0000, 'ºC'),
	(268371, 119, '2014-04-01 00:16:02.000000', 'temperatura', 687.0000, 'ºC'),
	(268372, 119, '2014-04-01 00:16:03.000000', 'temperatura', 537.0000, 'ºC'),
	(268373, 119, '2014-04-01 00:16:04.000000', 'temperatura', 626.0000, 'ºC'),
	(268374, 119, '2014-04-01 00:16:05.000000', 'temperatura', 320.0000, 'ºC'),
	(268375, 119, '2014-04-01 00:16:06.000000', 'temperatura', 922.0000, 'ºC'),
	(268376, 119, '2014-04-01 00:16:07.000000', 'temperatura', 51.0000, 'ºC'),
	(268377, 119, '2014-04-01 00:16:08.000000', 'temperatura', 1088.0000, 'ºC'),
	(268378, 119, '2014-04-01 00:16:09.000000', 'temperatura', 486.0000, 'ºC'),
	(268379, 119, '2014-04-01 00:16:10.000000', 'temperatura', 369.0000, 'ºC'),
	(268380, 119, '2014-04-01 00:16:11.000000', 'temperatura', 385.0000, 'ºC'),
	(268381, 119, '2014-04-01 00:16:12.000000', 'temperatura', 820.0000, 'ºC'),
	(268382, 119, '2014-04-01 00:16:13.000000', 'temperatura', 547.0000, 'ºC'),
	(268383, 119, '2014-04-01 00:16:14.000000', 'temperatura', 276.0000, 'ºC'),
	(268384, 119, '2014-04-01 00:16:15.000000', 'temperatura', 938.0000, 'ºC'),
	(268385, 119, '2014-04-01 00:16:16.000000', 'temperatura', 263.0000, 'ºC'),
	(268386, 119, '2014-04-01 00:16:17.000000', 'temperatura', 900.0000, 'ºC'),
	(268387, 119, '2014-04-01 00:16:18.000000', 'temperatura', 112.0000, 'ºC'),
	(268388, 119, '2014-04-01 00:16:19.000000', 'temperatura', 261.0000, 'ºC'),
	(268389, 119, '2014-04-01 00:16:20.000000', 'temperatura', 971.0000, 'ºC'),
	(268390, 119, '2014-04-01 00:16:21.000000', 'temperatura', 472.0000, 'ºC'),
	(268391, 119, '2014-04-01 00:16:22.000000', 'temperatura', 647.0000, 'ºC'),
	(268392, 119, '2014-04-01 00:16:23.000000', 'temperatura', 620.0000, 'ºC'),
	(268393, 119, '2014-04-01 00:16:24.000000', 'temperatura', 1161.0000, 'ºC'),
	(268394, 119, '2014-04-01 00:16:25.000000', 'temperatura', 345.0000, 'ºC'),
	(268395, 119, '2014-04-01 00:16:26.000000', 'temperatura', 643.0000, 'ºC'),
	(268396, 119, '2014-04-01 00:16:27.000000', 'temperatura', 980.0000, 'ºC'),
	(268397, 119, '2014-04-01 00:16:28.000000', 'temperatura', 571.0000, 'ºC'),
	(268398, 119, '2014-04-01 00:16:29.000000', 'temperatura', 1115.0000, 'ºC'),
	(268399, 119, '2014-04-01 00:16:30.000000', 'temperatura', 262.0000, 'ºC'),
	(268400, 119, '2014-04-01 00:16:31.000000', 'temperatura', 364.0000, 'ºC'),
	(268401, 119, '2014-04-01 00:16:32.000000', 'temperatura', 1036.0000, 'ºC'),
	(268402, 119, '2014-04-01 00:16:33.000000', 'temperatura', 490.0000, 'ºC'),
	(268403, 119, '2014-04-01 00:16:34.000000', 'temperatura', 543.0000, 'ºC'),
	(268404, 119, '2014-04-01 00:16:35.000000', 'temperatura', 45.0000, 'ºC'),
	(268405, 119, '2014-04-01 00:16:36.000000', 'temperatura', 998.0000, 'ºC'),
	(268406, 119, '2014-04-01 00:16:37.000000', 'temperatura', 53.0000, 'ºC'),
	(268407, 119, '2014-04-01 00:16:38.000000', 'temperatura', 873.0000, 'ºC'),
	(268408, 119, '2014-04-01 00:16:39.000000', 'temperatura', 606.0000, 'ºC'),
	(268409, 119, '2014-04-01 00:16:40.000000', 'temperatura', 410.0000, 'ºC'),
	(268410, 119, '2014-04-01 00:16:41.000000', 'temperatura', 232.0000, 'ºC'),
	(268411, 119, '2014-04-01 00:16:42.000000', 'temperatura', 1132.0000, 'ºC'),
	(268412, 119, '2014-04-01 00:16:43.000000', 'temperatura', 164.0000, 'ºC'),
	(268413, 119, '2014-04-01 00:16:44.000000', 'temperatura', 1023.0000, 'ºC'),
	(268414, 119, '2014-04-01 00:16:45.000000', 'temperatura', 1026.0000, 'ºC'),
	(268415, 119, '2014-04-01 00:16:46.000000', 'temperatura', 861.0000, 'ºC'),
	(268416, 119, '2014-04-01 00:16:47.000000', 'temperatura', 29.0000, 'ºC'),
	(268417, 119, '2014-04-01 00:16:48.000000', 'temperatura', 1160.0000, 'ºC'),
	(268418, 119, '2014-04-01 00:16:49.000000', 'temperatura', 914.0000, 'ºC'),
	(268419, 119, '2014-04-01 00:16:50.000000', 'temperatura', 1089.0000, 'ºC'),
	(268420, 119, '2014-04-01 00:16:51.000000', 'temperatura', 303.0000, 'ºC'),
	(268421, 119, '2014-04-01 00:16:52.000000', 'temperatura', 651.0000, 'ºC'),
	(268422, 119, '2014-04-01 00:16:53.000000', 'temperatura', 1147.0000, 'ºC'),
	(268423, 119, '2014-04-01 00:16:54.000000', 'temperatura', 181.0000, 'ºC'),
	(268424, 119, '2014-04-01 00:16:55.000000', 'temperatura', 1064.0000, 'ºC'),
	(268425, 119, '2014-04-01 00:16:56.000000', 'temperatura', 1180.0000, 'ºC'),
	(268426, 119, '2014-04-01 00:16:57.000000', 'temperatura', 306.0000, 'ºC'),
	(268427, 119, '2014-04-01 00:16:58.000000', 'temperatura', 391.0000, 'ºC'),
	(268428, 119, '2014-04-01 00:16:59.000000', 'temperatura', 1036.0000, 'ºC'),
	(268429, 119, '2014-04-01 00:17:00.000000', 'temperatura', 409.0000, 'ºC'),
	(268430, 119, '2014-04-01 00:17:01.000000', 'temperatura', 136.0000, 'ºC'),
	(268431, 119, '2014-04-01 00:17:02.000000', 'temperatura', 653.0000, 'ºC'),
	(268432, 119, '2014-04-01 00:17:03.000000', 'temperatura', 457.0000, 'ºC'),
	(268433, 119, '2014-04-01 00:17:04.000000', 'temperatura', 326.0000, 'ºC'),
	(268434, 119, '2014-04-01 00:17:05.000000', 'temperatura', 261.0000, 'ºC'),
	(268435, 119, '2014-04-01 00:17:06.000000', 'temperatura', 329.0000, 'ºC'),
	(268436, 119, '2014-04-01 00:17:07.000000', 'temperatura', 862.0000, 'ºC'),
	(268437, 119, '2014-04-01 00:17:08.000000', 'temperatura', 924.0000, 'ºC'),
	(268438, 119, '2014-04-01 00:17:09.000000', 'temperatura', 836.0000, 'ºC'),
	(268439, 119, '2014-04-01 00:17:10.000000', 'temperatura', 205.0000, 'ºC'),
	(268440, 119, '2014-04-01 00:17:11.000000', 'temperatura', 918.0000, 'ºC'),
	(268441, 119, '2014-04-01 00:17:12.000000', 'temperatura', 377.0000, 'ºC'),
	(268442, 119, '2014-04-01 00:17:13.000000', 'temperatura', 330.0000, 'ºC'),
	(268443, 119, '2014-04-01 00:17:14.000000', 'temperatura', 520.0000, 'ºC'),
	(268444, 119, '2014-04-01 00:17:15.000000', 'temperatura', 409.0000, 'ºC'),
	(268445, 119, '2014-04-01 00:17:16.000000', 'temperatura', 486.0000, 'ºC'),
	(268446, 119, '2014-04-01 00:17:17.000000', 'temperatura', 3.0000, 'ºC'),
	(268447, 119, '2014-04-01 00:17:18.000000', 'temperatura', 958.0000, 'ºC'),
	(268448, 119, '2014-04-01 00:17:19.000000', 'temperatura', 1181.0000, 'ºC'),
	(268449, 119, '2014-04-01 00:17:20.000000', 'temperatura', 632.0000, 'ºC'),
	(268450, 119, '2014-04-01 00:17:21.000000', 'temperatura', 819.0000, 'ºC'),
	(268451, 119, '2014-04-01 00:17:22.000000', 'temperatura', 997.0000, 'ºC'),
	(268452, 119, '2014-04-01 00:17:23.000000', 'temperatura', 128.0000, 'ºC'),
	(268453, 119, '2014-04-01 00:17:24.000000', 'temperatura', 50.0000, 'ºC'),
	(268454, 119, '2014-04-01 00:17:25.000000', 'temperatura', 1066.0000, 'ºC'),
	(268455, 119, '2014-04-01 00:17:26.000000', 'temperatura', 381.0000, 'ºC'),
	(268456, 119, '2014-04-01 00:17:27.000000', 'temperatura', 1106.0000, 'ºC'),
	(268457, 119, '2014-04-01 00:17:28.000000', 'temperatura', 790.0000, 'ºC'),
	(268458, 119, '2014-04-01 00:17:29.000000', 'temperatura', 633.0000, 'ºC'),
	(268459, 119, '2014-04-01 00:17:30.000000', 'temperatura', 794.0000, 'ºC'),
	(268460, 119, '2014-04-01 00:17:31.000000', 'temperatura', 873.0000, 'ºC'),
	(268461, 119, '2014-04-01 00:17:32.000000', 'temperatura', 782.0000, 'ºC'),
	(268462, 119, '2014-04-01 00:17:33.000000', 'temperatura', 93.0000, 'ºC'),
	(268463, 119, '2014-04-01 00:17:34.000000', 'temperatura', 520.0000, 'ºC'),
	(268464, 119, '2014-04-01 00:17:35.000000', 'temperatura', 1120.0000, 'ºC'),
	(268465, 119, '2014-04-01 00:17:36.000000', 'temperatura', 441.0000, 'ºC'),
	(268466, 119, '2014-04-01 00:17:37.000000', 'temperatura', 47.0000, 'ºC'),
	(268467, 119, '2014-04-01 00:17:38.000000', 'temperatura', 110.0000, 'ºC'),
	(268468, 119, '2014-04-01 00:17:39.000000', 'temperatura', 412.0000, 'ºC'),
	(268469, 119, '2014-04-01 00:17:40.000000', 'temperatura', 528.0000, 'ºC'),
	(268470, 119, '2014-04-01 00:17:41.000000', 'temperatura', 204.0000, 'ºC'),
	(268471, 119, '2014-04-01 00:17:42.000000', 'temperatura', 639.0000, 'ºC'),
	(268472, 119, '2014-04-01 00:17:43.000000', 'temperatura', 184.0000, 'ºC'),
	(268473, 119, '2014-04-01 00:17:44.000000', 'temperatura', 204.0000, 'ºC'),
	(268474, 119, '2014-04-01 00:17:45.000000', 'temperatura', 466.0000, 'ºC'),
	(268475, 119, '2014-04-01 00:17:46.000000', 'temperatura', 519.0000, 'ºC'),
	(268476, 119, '2014-04-01 00:17:47.000000', 'temperatura', 0.0000, 'ºC'),
	(268477, 119, '2014-04-01 00:17:48.000000', 'temperatura', 842.0000, 'ºC'),
	(268478, 119, '2014-04-01 00:17:49.000000', 'temperatura', 609.0000, 'ºC'),
	(268479, 119, '2014-04-01 00:17:50.000000', 'temperatura', 522.0000, 'ºC'),
	(268480, 119, '2014-04-01 00:17:51.000000', 'temperatura', 784.0000, 'ºC'),
	(268481, 119, '2014-04-01 00:17:52.000000', 'temperatura', 1155.0000, 'ºC'),
	(268482, 119, '2014-04-01 00:17:53.000000', 'temperatura', 1024.0000, 'ºC'),
	(268483, 119, '2014-04-01 00:17:54.000000', 'temperatura', 452.0000, 'ºC'),
	(268484, 119, '2014-04-01 00:17:55.000000', 'temperatura', 392.0000, 'ºC'),
	(268485, 119, '2014-04-01 00:17:56.000000', 'temperatura', 602.0000, 'ºC'),
	(268486, 119, '2014-04-01 00:17:57.000000', 'temperatura', 635.0000, 'ºC'),
	(268487, 119, '2014-04-01 00:17:58.000000', 'temperatura', 169.0000, 'ºC'),
	(268488, 119, '2014-04-01 00:17:59.000000', 'temperatura', 140.0000, 'ºC'),
	(268489, 119, '2014-04-01 00:18:00.000000', 'temperatura', 196.0000, 'ºC'),
	(268490, 119, '2014-04-01 00:18:01.000000', 'temperatura', 559.0000, 'ºC'),
	(268491, 119, '2014-04-01 00:18:02.000000', 'temperatura', 1007.0000, 'ºC'),
	(268492, 119, '2014-04-01 00:18:03.000000', 'temperatura', 958.0000, 'ºC'),
	(268493, 119, '2014-04-01 00:18:04.000000', 'temperatura', 571.0000, 'ºC'),
	(268494, 119, '2014-04-01 00:18:05.000000', 'temperatura', 1179.0000, 'ºC'),
	(268495, 119, '2014-04-01 00:18:06.000000', 'temperatura', 583.0000, 'ºC'),
	(268496, 119, '2014-04-01 00:18:07.000000', 'temperatura', 581.0000, 'ºC'),
	(268497, 119, '2014-04-01 00:18:08.000000', 'temperatura', 1154.0000, 'ºC'),
	(268498, 119, '2014-04-01 00:18:09.000000', 'temperatura', 429.0000, 'ºC'),
	(268499, 119, '2014-04-01 00:18:10.000000', 'temperatura', 1084.0000, 'ºC'),
	(268500, 119, '2014-04-01 00:18:11.000000', 'temperatura', 533.0000, 'ºC'),
	(268501, 119, '2014-04-01 00:18:12.000000', 'temperatura', 614.0000, 'ºC'),
	(268502, 119, '2014-04-01 00:18:13.000000', 'temperatura', 269.0000, 'ºC'),
	(268503, 119, '2014-04-01 00:18:14.000000', 'temperatura', 705.0000, 'ºC'),
	(268504, 119, '2014-04-01 00:18:15.000000', 'temperatura', 318.0000, 'ºC'),
	(268505, 119, '2014-04-01 00:18:16.000000', 'temperatura', 674.0000, 'ºC'),
	(268506, 119, '2014-04-01 00:18:17.000000', 'temperatura', 18.0000, 'ºC'),
	(268507, 119, '2014-04-01 00:18:18.000000', 'temperatura', 469.0000, 'ºC'),
	(268508, 119, '2014-04-01 00:18:19.000000', 'temperatura', 1090.0000, 'ºC'),
	(268509, 119, '2014-04-01 00:18:20.000000', 'temperatura', 443.0000, 'ºC'),
	(268510, 119, '2014-04-01 00:18:21.000000', 'temperatura', 147.0000, 'ºC'),
	(268511, 119, '2014-04-01 00:18:22.000000', 'temperatura', 607.0000, 'ºC'),
	(268512, 119, '2014-04-01 00:18:23.000000', 'temperatura', 193.0000, 'ºC'),
	(268513, 119, '2014-04-01 00:18:24.000000', 'temperatura', 345.0000, 'ºC'),
	(268514, 119, '2014-04-01 00:18:25.000000', 'temperatura', 1147.0000, 'ºC'),
	(268515, 119, '2014-04-01 00:18:26.000000', 'temperatura', 1099.0000, 'ºC'),
	(268516, 119, '2014-04-01 00:18:27.000000', 'temperatura', 855.0000, 'ºC'),
	(268517, 119, '2014-04-01 00:18:28.000000', 'temperatura', 980.0000, 'ºC'),
	(268518, 119, '2014-04-01 00:18:29.000000', 'temperatura', 1136.0000, 'ºC'),
	(268519, 119, '2014-04-01 00:18:30.000000', 'temperatura', 340.0000, 'ºC'),
	(268520, 119, '2014-04-01 00:18:31.000000', 'temperatura', 691.0000, 'ºC'),
	(268521, 119, '2014-04-01 00:18:32.000000', 'temperatura', 37.0000, 'ºC'),
	(268522, 119, '2014-04-01 00:18:33.000000', 'temperatura', 513.0000, 'ºC'),
	(268523, 119, '2014-04-01 00:18:34.000000', 'temperatura', 54.0000, 'ºC'),
	(268524, 119, '2014-04-01 00:18:35.000000', 'temperatura', 1130.0000, 'ºC'),
	(268525, 119, '2014-04-01 00:18:36.000000', 'temperatura', 690.0000, 'ºC'),
	(268526, 119, '2014-04-01 00:18:37.000000', 'temperatura', 61.0000, 'ºC'),
	(268527, 119, '2014-04-01 00:18:38.000000', 'temperatura', 636.0000, 'ºC'),
	(268528, 119, '2014-04-01 00:18:39.000000', 'temperatura', 598.0000, 'ºC'),
	(268529, 119, '2014-04-01 00:18:40.000000', 'temperatura', 1082.0000, 'ºC'),
	(268530, 119, '2014-04-01 00:18:41.000000', 'temperatura', 18.0000, 'ºC'),
	(268531, 119, '2014-04-01 00:18:42.000000', 'temperatura', 441.0000, 'ºC'),
	(268532, 119, '2014-04-01 00:18:43.000000', 'temperatura', 955.0000, 'ºC'),
	(268533, 119, '2014-04-01 00:18:44.000000', 'temperatura', 1052.0000, 'ºC'),
	(268534, 119, '2014-04-01 00:18:45.000000', 'temperatura', 1195.0000, 'ºC'),
	(268535, 119, '2014-04-01 00:18:46.000000', 'temperatura', 418.0000, 'ºC'),
	(268536, 119, '2014-04-01 00:18:47.000000', 'temperatura', 908.0000, 'ºC'),
	(268537, 119, '2014-04-01 00:18:48.000000', 'temperatura', 885.0000, 'ºC'),
	(268538, 119, '2014-04-01 00:18:49.000000', 'temperatura', 501.0000, 'ºC'),
	(268539, 119, '2014-04-01 00:18:50.000000', 'temperatura', 1051.0000, 'ºC'),
	(268540, 119, '2014-04-01 00:18:51.000000', 'temperatura', 153.0000, 'ºC'),
	(268541, 119, '2014-04-01 00:18:52.000000', 'temperatura', 14.0000, 'ºC'),
	(268542, 119, '2014-04-01 00:18:53.000000', 'temperatura', 809.0000, 'ºC'),
	(268543, 119, '2014-04-01 00:18:54.000000', 'temperatura', 406.0000, 'ºC'),
	(268544, 119, '2014-04-01 00:18:55.000000', 'temperatura', 802.0000, 'ºC'),
	(268545, 119, '2014-04-01 00:18:56.000000', 'temperatura', 393.0000, 'ºC'),
	(268546, 119, '2014-04-01 00:18:57.000000', 'temperatura', 757.0000, 'ºC'),
	(268547, 119, '2014-04-01 00:18:58.000000', 'temperatura', 210.0000, 'ºC'),
	(268548, 119, '2014-04-01 00:18:59.000000', 'temperatura', 1177.0000, 'ºC'),
	(268549, 119, '2014-04-01 00:19:00.000000', 'temperatura', 455.0000, 'ºC'),
	(268550, 119, '2014-04-01 00:19:01.000000', 'temperatura', 1146.0000, 'ºC'),
	(268551, 119, '2014-04-01 00:19:02.000000', 'temperatura', 764.0000, 'ºC'),
	(268552, 119, '2014-04-01 00:19:03.000000', 'temperatura', 384.0000, 'ºC'),
	(268553, 119, '2014-04-01 00:19:04.000000', 'temperatura', 830.0000, 'ºC'),
	(268554, 119, '2014-04-01 00:19:05.000000', 'temperatura', 597.0000, 'ºC'),
	(268555, 119, '2014-04-01 00:19:06.000000', 'temperatura', 495.0000, 'ºC'),
	(268556, 119, '2014-04-01 00:19:07.000000', 'temperatura', 684.0000, 'ºC'),
	(268557, 119, '2014-04-01 00:19:08.000000', 'temperatura', 738.0000, 'ºC'),
	(268558, 119, '2014-04-01 00:19:09.000000', 'temperatura', 436.0000, 'ºC'),
	(268559, 119, '2014-04-01 00:19:10.000000', 'temperatura', 1168.0000, 'ºC'),
	(268560, 119, '2014-04-01 00:19:11.000000', 'temperatura', 931.0000, 'ºC'),
	(268561, 119, '2014-04-01 00:19:12.000000', 'temperatura', 1153.0000, 'ºC'),
	(268562, 119, '2014-04-01 00:19:13.000000', 'temperatura', 570.0000, 'ºC'),
	(268563, 119, '2014-04-01 00:19:14.000000', 'temperatura', 593.0000, 'ºC'),
	(268564, 119, '2014-04-01 00:19:15.000000', 'temperatura', 54.0000, 'ºC'),
	(268565, 119, '2014-04-01 00:19:16.000000', 'temperatura', 892.0000, 'ºC'),
	(268566, 119, '2014-04-01 00:19:17.000000', 'temperatura', 700.0000, 'ºC'),
	(268567, 119, '2014-04-01 00:19:18.000000', 'temperatura', 822.0000, 'ºC'),
	(268568, 119, '2014-04-01 00:19:19.000000', 'temperatura', 810.0000, 'ºC'),
	(268569, 119, '2014-04-01 00:19:20.000000', 'temperatura', 385.0000, 'ºC'),
	(268570, 119, '2014-04-01 00:19:21.000000', 'temperatura', 696.0000, 'ºC'),
	(268571, 119, '2014-04-01 00:19:22.000000', 'temperatura', 1127.0000, 'ºC'),
	(268572, 119, '2014-04-01 00:19:23.000000', 'temperatura', 1144.0000, 'ºC'),
	(268573, 119, '2014-04-01 00:19:24.000000', 'temperatura', 1143.0000, 'ºC'),
	(268574, 119, '2014-04-01 00:19:25.000000', 'temperatura', 1083.0000, 'ºC'),
	(268575, 119, '2014-04-01 00:19:26.000000', 'temperatura', 784.0000, 'ºC'),
	(268576, 119, '2014-04-01 00:19:27.000000', 'temperatura', 674.0000, 'ºC'),
	(268577, 119, '2014-04-01 00:19:28.000000', 'temperatura', 1018.0000, 'ºC'),
	(268578, 119, '2014-04-01 00:19:29.000000', 'temperatura', 667.0000, 'ºC'),
	(268579, 119, '2014-04-01 00:19:30.000000', 'temperatura', 283.0000, 'ºC'),
	(268580, 119, '2014-04-01 00:19:31.000000', 'temperatura', 616.0000, 'ºC'),
	(268581, 119, '2014-04-01 00:19:32.000000', 'temperatura', 1029.0000, 'ºC'),
	(268582, 119, '2014-04-01 00:19:33.000000', 'temperatura', 897.0000, 'ºC'),
	(268583, 119, '2014-04-01 00:19:34.000000', 'temperatura', 200.0000, 'ºC'),
	(268584, 119, '2014-04-01 00:19:35.000000', 'temperatura', 709.0000, 'ºC'),
	(268585, 119, '2014-04-01 00:19:36.000000', 'temperatura', 548.0000, 'ºC'),
	(268586, 119, '2014-04-01 00:19:37.000000', 'temperatura', 610.0000, 'ºC'),
	(268587, 119, '2014-04-01 00:19:38.000000', 'temperatura', 209.0000, 'ºC'),
	(268588, 119, '2014-04-01 00:19:39.000000', 'temperatura', 414.0000, 'ºC'),
	(268589, 119, '2014-04-01 00:19:40.000000', 'temperatura', 245.0000, 'ºC'),
	(268590, 119, '2014-04-01 00:19:41.000000', 'temperatura', 1185.0000, 'ºC'),
	(268591, 119, '2014-04-01 00:19:42.000000', 'temperatura', 388.0000, 'ºC'),
	(268592, 119, '2014-04-01 00:19:43.000000', 'temperatura', 784.0000, 'ºC'),
	(268593, 119, '2014-04-01 00:19:44.000000', 'temperatura', 359.0000, 'ºC'),
	(268594, 119, '2014-04-01 00:19:45.000000', 'temperatura', 644.0000, 'ºC'),
	(268595, 119, '2014-04-01 00:19:46.000000', 'temperatura', 943.0000, 'ºC'),
	(268596, 119, '2014-04-01 00:19:47.000000', 'temperatura', 382.0000, 'ºC'),
	(268597, 119, '2014-04-01 00:19:48.000000', 'temperatura', 284.0000, 'ºC'),
	(268598, 119, '2014-04-01 00:19:49.000000', 'temperatura', 275.0000, 'ºC'),
	(268599, 119, '2014-04-01 00:19:50.000000', 'temperatura', 521.0000, 'ºC'),
	(268600, 119, '2014-04-01 00:19:51.000000', 'temperatura', 580.0000, 'ºC'),
	(268601, 119, '2014-04-01 00:19:52.000000', 'temperatura', 138.0000, 'ºC'),
	(268602, 119, '2014-04-01 00:19:53.000000', 'temperatura', 150.0000, 'ºC'),
	(268603, 119, '2014-04-01 00:19:54.000000', 'temperatura', 337.0000, 'ºC'),
	(268604, 119, '2014-04-01 00:19:55.000000', 'temperatura', 38.0000, 'ºC'),
	(268605, 119, '2014-04-01 00:19:56.000000', 'temperatura', 376.0000, 'ºC'),
	(268606, 119, '2014-04-01 00:19:57.000000', 'temperatura', 568.0000, 'ºC'),
	(268607, 119, '2014-04-01 00:19:58.000000', 'temperatura', 513.0000, 'ºC'),
	(268608, 119, '2014-04-01 00:19:59.000000', 'temperatura', 860.0000, 'ºC'),
	(268609, 119, '2014-04-01 00:20:00.000000', 'temperatura', 364.0000, 'ºC'),
	(268610, 119, '2014-04-01 00:20:01.000000', 'temperatura', 439.0000, 'ºC'),
	(268611, 119, '2014-04-01 00:20:02.000000', 'temperatura', 1102.0000, 'ºC'),
	(268612, 119, '2014-04-01 00:20:03.000000', 'temperatura', 595.0000, 'ºC'),
	(268613, 119, '2014-04-01 00:20:04.000000', 'temperatura', 871.0000, 'ºC'),
	(268614, 119, '2014-04-01 00:20:05.000000', 'temperatura', 169.0000, 'ºC'),
	(268615, 119, '2014-04-01 00:20:06.000000', 'temperatura', 631.0000, 'ºC'),
	(268616, 119, '2014-04-01 00:20:07.000000', 'temperatura', 249.0000, 'ºC'),
	(268617, 119, '2014-04-01 00:20:08.000000', 'temperatura', 554.0000, 'ºC'),
	(268618, 119, '2014-04-01 00:20:09.000000', 'temperatura', 822.0000, 'ºC'),
	(268619, 119, '2014-04-01 00:20:10.000000', 'temperatura', 47.0000, 'ºC'),
	(268620, 119, '2014-04-01 00:20:11.000000', 'temperatura', 171.0000, 'ºC'),
	(268621, 119, '2014-04-01 00:20:12.000000', 'temperatura', 714.0000, 'ºC'),
	(268622, 119, '2014-04-01 00:20:13.000000', 'temperatura', 659.0000, 'ºC'),
	(268623, 119, '2014-04-01 00:20:14.000000', 'temperatura', 1152.0000, 'ºC'),
	(268624, 119, '2014-04-01 00:20:15.000000', 'temperatura', 186.0000, 'ºC'),
	(268625, 119, '2014-04-01 00:20:16.000000', 'temperatura', 1073.0000, 'ºC'),
	(268626, 119, '2014-04-01 00:20:17.000000', 'temperatura', 9.0000, 'ºC'),
	(268627, 119, '2014-04-01 00:20:18.000000', 'temperatura', 427.0000, 'ºC'),
	(268628, 119, '2014-04-01 00:20:19.000000', 'temperatura', 908.0000, 'ºC'),
	(268629, 119, '2014-04-01 00:20:20.000000', 'temperatura', 860.0000, 'ºC'),
	(268630, 119, '2014-04-01 00:20:21.000000', 'temperatura', 376.0000, 'ºC'),
	(268631, 119, '2014-04-01 00:20:22.000000', 'temperatura', 502.0000, 'ºC'),
	(268632, 119, '2014-04-01 00:20:23.000000', 'temperatura', 183.0000, 'ºC'),
	(268633, 119, '2014-04-01 00:20:24.000000', 'temperatura', 610.0000, 'ºC'),
	(268634, 119, '2014-04-01 00:20:25.000000', 'temperatura', 101.0000, 'ºC'),
	(268635, 119, '2014-04-01 00:20:26.000000', 'temperatura', 1073.0000, 'ºC'),
	(268636, 119, '2014-04-01 00:20:27.000000', 'temperatura', 264.0000, 'ºC'),
	(268637, 119, '2014-04-01 00:20:28.000000', 'temperatura', 501.0000, 'ºC'),
	(268638, 119, '2014-04-01 00:20:29.000000', 'temperatura', 513.0000, 'ºC'),
	(268639, 119, '2014-04-01 00:20:30.000000', 'temperatura', 1065.0000, 'ºC'),
	(268640, 119, '2014-04-01 00:20:31.000000', 'temperatura', 184.0000, 'ºC'),
	(268641, 119, '2014-04-01 00:20:32.000000', 'temperatura', 127.0000, 'ºC'),
	(268642, 119, '2014-04-01 00:20:33.000000', 'temperatura', 85.0000, 'ºC'),
	(268643, 119, '2014-04-01 00:20:34.000000', 'temperatura', 41.0000, 'ºC'),
	(268644, 119, '2014-04-01 00:20:35.000000', 'temperatura', 1153.0000, 'ºC'),
	(268645, 119, '2014-04-01 00:20:36.000000', 'temperatura', 841.0000, 'ºC'),
	(268646, 119, '2014-04-01 00:20:37.000000', 'temperatura', 747.0000, 'ºC'),
	(268647, 119, '2014-04-01 00:20:38.000000', 'temperatura', 13.0000, 'ºC'),
	(268648, 119, '2014-04-01 00:20:39.000000', 'temperatura', 222.0000, 'ºC'),
	(268649, 119, '2014-04-01 00:20:40.000000', 'temperatura', 1073.0000, 'ºC'),
	(268650, 119, '2014-04-01 00:20:41.000000', 'temperatura', 1100.0000, 'ºC'),
	(268651, 119, '2014-04-01 00:20:42.000000', 'temperatura', 1081.0000, 'ºC'),
	(268652, 119, '2014-04-01 00:20:43.000000', 'temperatura', 907.0000, 'ºC'),
	(268653, 119, '2014-04-01 00:20:44.000000', 'temperatura', 91.0000, 'ºC'),
	(268654, 119, '2014-04-01 00:20:45.000000', 'temperatura', 136.0000, 'ºC'),
	(268655, 119, '2014-04-01 00:20:46.000000', 'temperatura', 406.0000, 'ºC'),
	(268656, 119, '2014-04-01 00:20:47.000000', 'temperatura', 425.0000, 'ºC'),
	(268657, 119, '2014-04-01 00:20:48.000000', 'temperatura', 907.0000, 'ºC'),
	(268658, 119, '2014-04-01 00:20:49.000000', 'temperatura', 859.0000, 'ºC'),
	(268659, 119, '2014-04-01 00:20:50.000000', 'temperatura', 374.0000, 'ºC'),
	(268660, 119, '2014-04-01 00:20:51.000000', 'temperatura', 493.0000, 'ºC'),
	(268661, 119, '2014-04-01 00:20:52.000000', 'temperatura', 146.0000, 'ºC'),
	(268662, 119, '2014-04-01 00:20:53.000000', 'temperatura', 450.0000, 'ºC'),
	(268663, 119, '2014-04-01 00:20:54.000000', 'temperatura', 612.0000, 'ºC'),
	(268664, 119, '2014-04-01 00:20:55.000000', 'temperatura', 510.0000, 'ºC'),
	(268665, 119, '2014-04-01 00:20:56.000000', 'temperatura', 717.0000, 'ºC'),
	(268666, 119, '2014-04-01 00:20:57.000000', 'temperatura', 856.0000, 'ºC'),
	(268667, 119, '2014-04-01 00:20:58.000000', 'temperatura', 928.0000, 'ºC'),
	(268668, 119, '2014-04-01 00:20:59.000000', 'temperatura', 871.0000, 'ºC'),
	(268669, 119, '2014-04-01 00:21:00.000000', 'temperatura', 371.0000, 'ºC'),
	(268670, 119, '2014-04-01 00:21:01.000000', 'temperatura', 444.0000, 'ºC'),
	(268671, 119, '2014-04-01 00:21:02.000000', 'temperatura', 1106.0000, 'ºC'),
	(268672, 119, '2014-04-01 00:21:03.000000', 'temperatura', 599.0000, 'ºC'),
	(268673, 119, '2014-04-01 00:21:04.000000', 'temperatura', 877.0000, 'ºC'),
	(268674, 119, '2014-04-01 00:21:05.000000', 'temperatura', 188.0000, 'ºC'),
	(268675, 119, '2014-04-01 00:21:06.000000', 'temperatura', 709.0000, 'ºC'),
	(268676, 119, '2014-04-01 00:21:07.000000', 'temperatura', 581.0000, 'ºC'),
	(268677, 119, '2014-04-01 00:21:08.000000', 'temperatura', 779.0000, 'ºC'),
	(268678, 119, '2014-04-01 00:21:09.000000', 'temperatura', 955.0000, 'ºC'),
	(268679, 119, '2014-04-01 00:21:10.000000', 'temperatura', 36.0000, 'ºC'),
	(268680, 119, '2014-04-01 00:21:11.000000', 'temperatura', 915.0000, 'ºC'),
	(268681, 119, '2014-04-01 00:21:12.000000', 'temperatura', 868.0000, 'ºC'),
	(268682, 119, '2014-04-01 00:21:13.000000', 'temperatura', 394.0000, 'ºC'),
	(268683, 119, '2014-04-01 00:21:14.000000', 'temperatura', 567.0000, 'ºC'),
	(268684, 119, '2014-04-01 00:21:15.000000', 'temperatura', 456.0000, 'ºC'),
	(268685, 119, '2014-04-01 00:21:16.000000', 'temperatura', 578.0000, 'ºC'),
	(268686, 119, '2014-04-01 00:21:17.000000', 'temperatura', 324.0000, 'ºC'),
	(268687, 119, '2014-04-01 00:21:18.000000', 'temperatura', 1086.0000, 'ºC'),
	(268688, 119, '2014-04-01 00:21:19.000000', 'temperatura', 858.0000, 'ºC'),
	(268689, 119, '2014-04-01 00:21:20.000000', 'temperatura', 1031.0000, 'ºC'),
	(268690, 119, '2014-04-01 00:21:21.000000', 'temperatura', 184.0000, 'ºC'),
	(268691, 119, '2014-04-01 00:21:22.000000', 'temperatura', 228.0000, 'ºC'),
	(268692, 119, '2014-04-01 00:21:23.000000', 'temperatura', 589.0000, 'ºC'),
	(268693, 119, '2014-04-01 00:21:24.000000', 'temperatura', 1061.0000, 'ºC'),
	(268694, 119, '2014-04-01 00:21:25.000000', 'temperatura', 1139.0000, 'ºC'),
	(268695, 119, '2014-04-01 00:21:26.000000', 'temperatura', 113.0000, 'ºC'),
	(268696, 119, '2014-04-01 00:21:27.000000', 'temperatura', 750.0000, 'ºC'),
	(268697, 119, '2014-04-01 00:21:28.000000', 'temperatura', 1009.0000, 'ºC'),
	(268698, 119, '2014-04-01 00:21:29.000000', 'temperatura', 397.0000, 'ºC'),
	(268699, 119, '2014-04-01 00:21:30.000000', 'temperatura', 158.0000, 'ºC'),
	(268700, 119, '2014-04-01 00:21:31.000000', 'temperatura', 798.0000, 'ºC'),
	(268701, 119, '2014-04-01 00:21:32.000000', 'temperatura', 1116.0000, 'ºC'),
	(268702, 119, '2014-04-01 00:21:33.000000', 'temperatura', 788.0000, 'ºC'),
	(268703, 119, '2014-04-01 00:21:34.000000', 'temperatura', 591.0000, 'ºC'),
	(268704, 119, '2014-04-01 00:21:35.000000', 'temperatura', 592.0000, 'ºC'),
	(268705, 119, '2014-04-01 00:21:36.000000', 'temperatura', 1186.0000, 'ºC'),
	(268706, 119, '2014-04-01 00:21:37.000000', 'temperatura', 555.0000, 'ºC'),
	(268707, 119, '2014-04-01 00:21:38.000000', 'temperatura', 420.0000, 'ºC'),
	(268708, 119, '2014-04-01 00:21:39.000000', 'temperatura', 433.0000, 'ºC'),
	(268709, 119, '2014-04-01 00:21:40.000000', 'temperatura', 907.0000, 'ºC'),
	(268710, 119, '2014-04-01 00:21:41.000000', 'temperatura', 834.0000, 'ºC'),
	(268711, 119, '2014-04-01 00:21:42.000000', 'temperatura', 251.0000, 'ºC'),
	(268712, 119, '2014-04-01 00:21:43.000000', 'temperatura', 1153.0000, 'ºC'),
	(268713, 119, '2014-04-01 00:21:44.000000', 'temperatura', 212.0000, 'ºC'),
	(268714, 119, '2014-04-01 00:21:45.000000', 'temperatura', 0.0000, 'ºC'),
	(268715, 119, '2014-04-01 00:21:46.000000', 'temperatura', 568.0000, 'ºC'),
	(268716, 119, '2014-04-01 00:21:47.000000', 'temperatura', 438.0000, 'ºC'),
	(268717, 119, '2014-04-01 00:21:48.000000', 'temperatura', 486.0000, 'ºC'),
	(268718, 119, '2014-04-01 00:21:49.000000', 'temperatura', 1117.0000, 'ºC'),
	(268719, 119, '2014-04-01 00:21:50.000000', 'temperatura', 527.0000, 'ºC'),
	(268720, 119, '2014-04-01 00:21:51.000000', 'temperatura', 485.0000, 'ºC'),
	(268721, 119, '2014-04-01 00:21:52.000000', 'temperatura', 845.0000, 'ºC'),
	(268722, 119, '2014-04-01 00:21:53.000000', 'temperatura', 369.0000, 'ºC'),
	(268723, 119, '2014-04-01 00:21:54.000000', 'temperatura', 509.0000, 'ºC'),
	(268724, 119, '2014-04-01 00:21:55.000000', 'temperatura', 241.0000, 'ºC'),
	(268725, 119, '2014-04-01 00:21:56.000000', 'temperatura', 879.0000, 'ºC'),
	(268726, 119, '2014-04-01 00:21:57.000000', 'temperatura', 70.0000, 'ºC'),
	(268727, 119, '2014-04-01 00:21:58.000000', 'temperatura', 115.0000, 'ºC'),
	(268728, 119, '2014-04-01 00:21:59.000000', 'temperatura', 365.0000, 'ºC'),
	(268729, 119, '2014-04-01 00:22:00.000000', 'temperatura', 281.0000, 'ºC'),
	(268730, 119, '2014-04-01 00:22:01.000000', 'temperatura', 311.0000, 'ºC'),
	(268731, 119, '2014-04-01 00:22:02.000000', 'temperatura', 712.0000, 'ºC'),
	(268732, 119, '2014-04-01 00:22:03.000000', 'temperatura', 227.0000, 'ºC'),
	(268733, 119, '2014-04-01 00:22:04.000000', 'temperatura', 199.0000, 'ºC'),
	(268734, 119, '2014-04-01 00:22:05.000000', 'temperatura', 316.0000, 'ºC'),
	(268735, 119, '2014-04-01 00:22:06.000000', 'temperatura', 984.0000, 'ºC'),
	(268736, 119, '2014-04-01 00:22:07.000000', 'temperatura', 372.0000, 'ºC'),
	(268737, 119, '2014-04-01 00:22:08.000000', 'temperatura', 110.0000, 'ºC'),
	(268738, 119, '2014-04-01 00:22:09.000000', 'temperatura', 634.0000, 'ºC'),
	(268739, 119, '2014-04-01 00:22:10.000000', 'temperatura', 442.0000, 'ºC'),
	(268740, 119, '2014-04-01 00:22:11.000000', 'temperatura', 307.0000, 'ºC'),
	(268741, 119, '2014-04-01 00:22:12.000000', 'temperatura', 210.0000, 'ºC'),
	(268742, 119, '2014-04-01 00:22:13.000000', 'temperatura', 128.0000, 'ºC'),
	(268743, 119, '2014-04-01 00:22:14.000000', 'temperatura', 10.0000, 'ºC'),
	(268744, 119, '2014-04-01 00:22:15.000000', 'temperatura', 869.0000, 'ºC'),
	(268745, 119, '2014-04-01 00:22:16.000000', 'temperatura', 714.0000, 'ºC'),
	(268746, 119, '2014-04-01 00:22:17.000000', 'temperatura', 962.0000, 'ºC'),
	(268747, 119, '2014-04-01 00:22:18.000000', 'temperatura', 269.0000, 'ºC'),
	(268748, 119, '2014-04-01 00:22:19.000000', 'temperatura', 862.0000, 'ºC'),
	(268749, 119, '2014-04-01 00:22:20.000000', 'temperatura', 1102.0000, 'ºC'),
	(268750, 119, '2014-04-01 00:22:21.000000', 'temperatura', 524.0000, 'ºC'),
	(268751, 119, '2014-04-01 00:22:22.000000', 'temperatura', 514.0000, 'ºC'),
	(268752, 119, '2014-04-01 00:22:23.000000', 'temperatura', 998.0000, 'ºC'),
	(268753, 119, '2014-04-01 00:22:24.000000', 'temperatura', 1051.0000, 'ºC'),
	(268754, 119, '2014-04-01 00:22:25.000000', 'temperatura', 1060.0000, 'ºC'),
	(268755, 119, '2014-04-01 00:22:26.000000', 'temperatura', 948.0000, 'ºC'),
	(268756, 119, '2014-04-01 00:22:27.000000', 'temperatura', 361.0000, 'ºC'),
	(268757, 119, '2014-04-01 00:22:28.000000', 'temperatura', 160.0000, 'ºC'),
	(268758, 119, '2014-04-01 00:22:29.000000', 'temperatura', 917.0000, 'ºC'),
	(268759, 119, '2014-04-01 00:22:30.000000', 'temperatura', 505.0000, 'ºC'),
	(268760, 119, '2014-04-01 00:22:31.000000', 'temperatura', 976.0000, 'ºC'),
	(268761, 119, '2014-04-01 00:22:32.000000', 'temperatura', 965.0000, 'ºC'),
	(268762, 119, '2014-04-01 00:22:33.000000', 'temperatura', 697.0000, 'ºC'),
	(268763, 119, '2014-04-01 00:22:34.000000', 'temperatura', 589.0000, 'ºC'),
	(268764, 119, '2014-04-01 00:22:35.000000', 'temperatura', 857.0000, 'ºC'),
	(268765, 119, '2014-04-01 00:22:36.000000', 'temperatura', 120.0000, 'ºC'),
	(268766, 119, '2014-04-01 00:22:37.000000', 'temperatura', 426.0000, 'ºC'),
	(268767, 119, '2014-04-01 00:22:38.000000', 'temperatura', 573.0000, 'ºC'),
	(268768, 119, '2014-04-01 00:22:39.000000', 'temperatura', 385.0000, 'ºC'),
	(268769, 119, '2014-04-01 00:22:40.000000', 'temperatura', 207.0000, 'ºC'),
	(268770, 119, '2014-04-01 00:22:41.000000', 'temperatura', 1081.0000, 'ºC'),
	(268771, 119, '2014-04-01 00:22:42.000000', 'temperatura', 1185.0000, 'ºC'),
	(268772, 119, '2014-04-01 00:22:43.000000', 'temperatura', 284.0000, 'ºC'),
	(268773, 119, '2014-04-01 00:22:44.000000', 'temperatura', 264.0000, 'ºC'),
	(268774, 119, '2014-04-01 00:22:45.000000', 'temperatura', 468.0000, 'ºC'),
	(268775, 119, '2014-04-01 00:22:46.000000', 'temperatura', 350.0000, 'ºC'),
	(268776, 119, '2014-04-01 00:22:47.000000', 'temperatura', 348.0000, 'ºC'),
	(268777, 119, '2014-04-01 00:22:48.000000', 'temperatura', 687.0000, 'ºC'),
	(268778, 119, '2014-04-01 00:22:49.000000', 'temperatura', 1192.0000, 'ºC'),
	(268779, 119, '2014-04-01 00:22:50.000000', 'temperatura', 302.0000, 'ºC'),
	(268780, 119, '2014-04-01 00:22:51.000000', 'temperatura', 334.0000, 'ºC'),
	(268781, 119, '2014-04-01 00:22:52.000000', 'temperatura', 762.0000, 'ºC'),
	(268782, 119, '2014-04-01 00:22:53.000000', 'temperatura', 409.0000, 'ºC'),
	(268783, 119, '2014-04-01 00:22:54.000000', 'temperatura', 962.0000, 'ºC'),
	(268784, 119, '2014-04-01 00:22:55.000000', 'temperatura', 1182.0000, 'ºC'),
	(268785, 119, '2014-04-01 00:22:56.000000', 'temperatura', 626.0000, 'ºC'),
	(268786, 119, '2014-04-01 00:22:57.000000', 'temperatura', 786.0000, 'ºC'),
	(268787, 119, '2014-04-01 00:22:58.000000', 'temperatura', 849.0000, 'ºC'),
	(268788, 119, '2014-04-01 00:22:59.000000', 'temperatura', 688.0000, 'ºC'),
	(268789, 119, '2014-04-01 00:23:00.000000', 'temperatura', 894.0000, 'ºC'),
	(268790, 119, '2014-04-01 00:23:01.000000', 'temperatura', 9.0000, 'ºC'),
	(268791, 119, '2014-04-01 00:23:02.000000', 'temperatura', 960.0000, 'ºC'),
	(268792, 119, '2014-04-01 00:23:03.000000', 'temperatura', 1176.0000, 'ºC'),
	(268793, 119, '2014-04-01 00:23:04.000000', 'temperatura', 600.0000, 'ºC'),
	(268794, 119, '2014-04-01 00:23:05.000000', 'temperatura', 671.0000, 'ºC'),
	(268795, 119, '2014-04-01 00:23:06.000000', 'temperatura', 355.0000, 'ºC'),
	(268796, 119, '2014-04-01 00:23:07.000000', 'temperatura', 964.0000, 'ºC'),
	(268797, 119, '2014-04-01 00:23:08.000000', 'temperatura', 157.0000, 'ºC'),
	(268798, 119, '2014-04-01 00:23:09.000000', 'temperatura', 291.0000, 'ºC'),
	(268799, 119, '2014-04-01 00:23:10.000000', 'temperatura', 987.0000, 'ºC'),
	(268800, 119, '2014-04-01 00:23:11.000000', 'temperatura', 461.0000, 'ºC'),
	(268801, 119, '2014-04-01 00:23:12.000000', 'temperatura', 543.0000, 'ºC'),
	(268802, 119, '2014-04-01 00:23:13.000000', 'temperatura', 134.0000, 'ºC'),
	(268803, 119, '2014-04-01 00:23:14.000000', 'temperatura', 241.0000, 'ºC'),
	(268804, 119, '2014-04-01 00:23:15.000000', 'temperatura', 806.0000, 'ºC'),
	(268805, 119, '2014-04-01 00:23:16.000000', 'temperatura', 904.0000, 'ºC'),
	(268806, 119, '2014-04-01 00:23:17.000000', 'temperatura', 903.0000, 'ºC'),
	(268807, 119, '2014-04-01 00:23:18.000000', 'temperatura', 605.0000, 'ºC'),
	(268808, 119, '2014-04-01 00:23:19.000000', 'temperatura', 317.0000, 'ºC'),
	(268809, 119, '2014-04-01 00:23:20.000000', 'temperatura', 969.0000, 'ºC'),
	(268810, 119, '2014-04-01 00:23:21.000000', 'temperatura', 296.0000, 'ºC'),
	(268811, 119, '2014-04-01 00:23:22.000000', 'temperatura', 972.0000, 'ºC'),
	(268812, 119, '2014-04-01 00:23:23.000000', 'temperatura', 374.0000, 'ºC'),
	(268813, 119, '2014-04-01 00:23:24.000000', 'temperatura', 155.0000, 'ºC'),
	(268814, 119, '2014-04-01 00:23:25.000000', 'temperatura', 852.0000, 'ºC'),
	(268815, 119, '2014-04-01 00:23:26.000000', 'temperatura', 198.0000, 'ºC'),
	(268816, 119, '2014-04-01 00:23:27.000000', 'temperatura', 832.0000, 'ºC'),
	(268817, 119, '2014-04-01 00:23:28.000000', 'temperatura', 1168.0000, 'ºC'),
	(268818, 119, '2014-04-01 00:23:29.000000', 'temperatura', 943.0000, 'ºC'),
	(268819, 119, '2014-04-01 00:23:30.000000', 'temperatura', 11.0000, 'ºC'),
	(268820, 119, '2014-04-01 00:23:31.000000', 'temperatura', 827.0000, 'ºC'),
	(268821, 119, '2014-04-01 00:23:32.000000', 'temperatura', 503.0000, 'ºC'),
	(268822, 119, '2014-04-01 00:23:33.000000', 'temperatura', 33.0000, 'ºC'),
	(268823, 119, '2014-04-01 00:23:34.000000', 'temperatura', 1056.0000, 'ºC'),
	(268824, 119, '2014-04-01 00:23:35.000000', 'temperatura', 383.0000, 'ºC'),
	(268825, 119, '2014-04-01 00:23:36.000000', 'temperatura', 1148.0000, 'ºC'),
	(268826, 119, '2014-04-01 00:23:37.000000', 'temperatura', 993.0000, 'ºC'),
	(268827, 119, '2014-04-01 00:23:38.000000', 'temperatura', 320.0000, 'ºC'),
	(268828, 119, '2014-04-01 00:23:39.000000', 'temperatura', 1022.0000, 'ºC'),
	(268829, 119, '2014-04-01 00:23:40.000000', 'temperatura', 552.0000, 'ºC'),
	(268830, 119, '2014-04-01 00:23:41.000000', 'temperatura', 892.0000, 'ºC'),
	(268831, 119, '2014-04-01 00:23:42.000000', 'temperatura', 407.0000, 'ºC'),
	(268832, 119, '2014-04-01 00:23:43.000000', 'temperatura', 556.0000, 'ºC'),
	(268833, 119, '2014-04-01 00:23:44.000000', 'temperatura', 362.0000, 'ºC'),
	(268834, 119, '2014-04-01 00:23:45.000000', 'temperatura', 142.0000, 'ºC'),
	(268835, 119, '2014-04-01 00:23:46.000000', 'temperatura', 825.0000, 'ºC'),
	(268836, 119, '2014-04-01 00:23:47.000000', 'temperatura', 100.0000, 'ºC'),
	(268837, 119, '2014-04-01 00:23:48.000000', 'temperatura', 423.0000, 'ºC'),
	(268838, 119, '2014-04-01 00:23:49.000000', 'temperatura', 617.0000, 'ºC'),
	(268839, 119, '2014-04-01 00:23:50.000000', 'temperatura', 615.0000, 'ºC'),
	(268840, 119, '2014-04-01 00:23:51.000000', 'temperatura', 26.0000, 'ºC'),
	(268841, 119, '2014-04-01 00:23:52.000000', 'temperatura', 685.0000, 'ºC'),
	(268842, 119, '2014-04-01 00:23:53.000000', 'temperatura', 948.0000, 'ºC'),
	(268843, 119, '2014-04-01 00:23:54.000000', 'temperatura', 285.0000, 'ºC'),
	(268844, 119, '2014-04-01 00:23:55.000000', 'temperatura', 980.0000, 'ºC'),
	(268845, 119, '2014-04-01 00:23:56.000000', 'temperatura', 445.0000, 'ºC'),
	(268846, 119, '2014-04-01 00:23:57.000000', 'temperatura', 487.0000, 'ºC'),
	(268847, 119, '2014-04-01 00:23:58.000000', 'temperatura', 1102.0000, 'ºC'),
	(268848, 119, '2014-04-01 00:23:59.000000', 'temperatura', 450.0000, 'ºC'),
	(268849, 119, '2014-04-01 00:24:00.000000', 'temperatura', 142.0000, 'ºC'),
	(268850, 119, '2014-04-01 00:24:01.000000', 'temperatura', 563.0000, 'ºC'),
	(268851, 119, '2014-04-01 00:24:02.000000', 'temperatura', 1188.0000, 'ºC'),
	(268852, 119, '2014-04-01 00:24:03.000000', 'temperatura', 654.0000, 'ºC'),
	(268853, 119, '2014-04-01 00:24:04.000000', 'temperatura', 904.0000, 'ºC'),
	(268854, 119, '2014-04-01 00:24:05.000000', 'temperatura', 159.0000, 'ºC'),
	(268855, 119, '2014-04-01 00:24:06.000000', 'temperatura', 486.0000, 'ºC'),
	(268856, 119, '2014-04-01 00:24:07.000000', 'temperatura', 750.0000, 'ºC'),
	(268857, 119, '2014-04-01 00:24:08.000000', 'temperatura', 1093.0000, 'ºC'),
	(268858, 119, '2014-04-01 00:24:09.000000', 'temperatura', 818.0000, 'ºC'),
	(268859, 119, '2014-04-01 00:24:10.000000', 'temperatura', 809.0000, 'ºC'),
	(268860, 119, '2014-04-01 00:24:11.000000', 'temperatura', 393.0000, 'ºC'),
	(268861, 119, '2014-04-01 00:24:12.000000', 'temperatura', 739.0000, 'ºC'),
	(268862, 119, '2014-04-01 00:24:13.000000', 'temperatura', 115.0000, 'ºC'),
	(268863, 119, '2014-04-01 00:24:14.000000', 'temperatura', 761.0000, 'ºC'),
	(268864, 119, '2014-04-01 00:24:15.000000', 'temperatura', 1059.0000, 'ºC'),
	(268865, 119, '2014-04-01 00:24:16.000000', 'temperatura', 615.0000, 'ºC'),
	(268866, 119, '2014-04-01 00:24:17.000000', 'temperatura', 1095.0000, 'ºC'),
	(268867, 119, '2014-04-01 00:24:18.000000', 'temperatura', 31.0000, 'ºC'),
	(268868, 119, '2014-04-01 00:24:19.000000', 'temperatura', 469.0000, 'ºC'),
	(268869, 119, '2014-04-01 00:24:20.000000', 'temperatura', 1054.0000, 'ºC'),
	(268870, 119, '2014-04-01 00:24:21.000000', 'temperatura', 263.0000, 'ºC'),
	(268871, 119, '2014-04-01 00:24:22.000000', 'temperatura', 554.0000, 'ºC'),
	(268872, 119, '2014-04-01 00:24:23.000000', 'temperatura', 780.0000, 'ºC'),
	(268873, 119, '2014-04-01 00:24:24.000000', 'temperatura', 1041.0000, 'ºC'),
	(268874, 119, '2014-04-01 00:24:25.000000', 'temperatura', 465.0000, 'ºC'),
	(268875, 119, '2014-04-01 00:24:26.000000', 'temperatura', 400.0000, 'ºC'),
	(268876, 119, '2014-04-01 00:24:27.000000', 'temperatura', 607.0000, 'ºC'),
	(268877, 119, '2014-04-01 00:24:28.000000', 'temperatura', 635.0000, 'ºC'),
	(268878, 119, '2014-04-01 00:24:29.000000', 'temperatura', 157.0000, 'ºC'),
	(268879, 119, '2014-04-01 00:24:30.000000', 'temperatura', 77.0000, 'ºC'),
	(268880, 119, '2014-04-01 00:24:31.000000', 'temperatura', 1117.0000, 'ºC'),
	(268881, 119, '2014-04-01 00:24:32.000000', 'temperatura', 555.0000, 'ºC'),
	(268882, 119, '2014-04-01 00:24:33.000000', 'temperatura', 624.0000, 'ºC'),
	(268883, 119, '2014-04-01 00:24:34.000000', 'temperatura', 255.0000, 'ºC'),
	(268884, 119, '2014-04-01 00:24:35.000000', 'temperatura', 602.0000, 'ºC'),
	(268885, 119, '2014-04-01 00:24:36.000000', 'temperatura', 1047.0000, 'ºC'),
	(268886, 119, '2014-04-01 00:24:37.000000', 'temperatura', 1029.0000, 'ºC'),
	(268887, 119, '2014-04-01 00:24:38.000000', 'temperatura', 804.0000, 'ºC'),
	(268888, 119, '2014-04-01 00:24:39.000000', 'temperatura', 932.0000, 'ºC'),
	(268889, 119, '2014-04-01 00:24:40.000000', 'temperatura', 1052.0000, 'ºC'),
	(268890, 119, '2014-04-01 00:24:41.000000', 'temperatura', 63.0000, 'ºC'),
	(268891, 119, '2014-04-01 00:24:42.000000', 'temperatura', 759.0000, 'ºC'),
	(268892, 119, '2014-04-01 00:24:43.000000', 'temperatura', 6.0000, 'ºC'),
	(268893, 119, '2014-04-01 00:24:44.000000', 'temperatura', 156.0000, 'ºC'),
	(268894, 119, '2014-04-01 00:24:45.000000', 'temperatura', 761.0000, 'ºC'),
	(268895, 119, '2014-04-01 00:24:46.000000', 'temperatura', 940.0000, 'ºC'),
	(268896, 119, '2014-04-01 00:24:47.000000', 'temperatura', 14.0000, 'ºC'),
	(268897, 119, '2014-04-01 00:24:48.000000', 'temperatura', 853.0000, 'ºC'),
	(268898, 119, '2014-04-01 00:24:49.000000', 'temperatura', 623.0000, 'ºC'),
	(268899, 119, '2014-04-01 00:24:50.000000', 'temperatura', 556.0000, 'ºC'),
	(268900, 119, '2014-04-01 00:24:51.000000', 'temperatura', 911.0000, 'ºC'),
	(268901, 119, '2014-04-01 00:24:52.000000', 'temperatura', 490.0000, 'ºC'),
	(268902, 119, '2014-04-01 00:24:53.000000', 'temperatura', 914.0000, 'ºC'),
	(268903, 119, '2014-04-01 00:24:54.000000', 'temperatura', 703.0000, 'ºC'),
	(268904, 119, '2014-04-01 00:24:55.000000', 'temperatura', 774.0000, 'ºC'),
	(268905, 119, '2014-04-01 00:24:56.000000', 'temperatura', 561.0000, 'ºC'),
	(268906, 119, '2014-04-01 00:24:57.000000', 'temperatura', 484.0000, 'ºC'),
	(268907, 119, '2014-04-01 00:24:58.000000', 'temperatura', 739.0000, 'ºC'),
	(268908, 119, '2014-04-01 00:24:59.000000', 'temperatura', 1042.0000, 'ºC'),
	(268909, 119, '2014-04-01 00:25:00.000000', 'temperatura', 593.0000, 'ºC'),
	(268910, 119, '2014-04-01 00:25:01.000000', 'temperatura', 1039.0000, 'ºC'),
	(268911, 119, '2014-04-01 00:25:02.000000', 'temperatura', 1017.0000, 'ºC'),
	(268912, 119, '2014-04-01 00:25:03.000000', 'temperatura', 769.0000, 'ºC'),
	(268913, 119, '2014-04-01 00:25:04.000000', 'temperatura', 793.0000, 'ºC'),
	(268914, 119, '2014-04-01 00:25:05.000000', 'temperatura', 458.0000, 'ºC'),
	(268915, 119, '2014-04-01 00:25:06.000000', 'temperatura', 1111.0000, 'ºC'),
	(268916, 119, '2014-04-01 00:25:07.000000', 'temperatura', 584.0000, 'ºC'),
	(268917, 119, '2014-04-01 00:25:08.000000', 'temperatura', 786.0000, 'ºC'),
	(268918, 119, '2014-04-01 00:25:09.000000', 'temperatura', 978.0000, 'ºC'),
	(268919, 119, '2014-04-01 00:25:10.000000', 'temperatura', 134.0000, 'ºC'),
	(268920, 119, '2014-04-01 00:25:11.000000', 'temperatura', 134.0000, 'ºC'),
	(268921, 119, '2014-04-01 00:25:12.000000', 'temperatura', 269.0000, 'ºC'),
	(268922, 119, '2014-04-01 00:25:13.000000', 'temperatura', 943.0000, 'ºC'),
	(268923, 119, '2014-04-01 00:25:14.000000', 'temperatura', 309.0000, 'ºC'),
	(268924, 119, '2014-04-01 00:25:15.000000', 'temperatura', 1118.0000, 'ºC'),
	(268925, 119, '2014-04-01 00:25:16.000000', 'temperatura', 1061.0000, 'ºC'),
	(268926, 119, '2014-04-01 00:25:17.000000', 'temperatura', 752.0000, 'ºC'),
	(268927, 119, '2014-04-01 00:25:18.000000', 'temperatura', 578.0000, 'ºC'),
	(268928, 119, '2014-04-01 00:25:19.000000', 'temperatura', 636.0000, 'ºC'),
	(268929, 119, '2014-04-01 00:25:20.000000', 'temperatura', 248.0000, 'ºC'),
	(268930, 119, '2014-04-01 00:25:21.000000', 'temperatura', 529.0000, 'ºC'),
	(268931, 119, '2014-04-01 00:25:22.000000', 'temperatura', 702.0000, 'ºC'),
	(268932, 119, '2014-04-01 00:25:23.000000', 'temperatura', 722.0000, 'ºC'),
	(268933, 119, '2014-04-01 00:25:24.000000', 'temperatura', 305.0000, 'ºC'),
	(268934, 119, '2014-04-01 00:25:25.000000', 'temperatura', 562.0000, 'ºC'),
	(268935, 119, '2014-04-01 00:25:26.000000', 'temperatura', 692.0000, 'ºC'),
	(268936, 119, '2014-04-01 00:25:27.000000', 'temperatura', 578.0000, 'ºC'),
	(268937, 119, '2014-04-01 00:25:28.000000', 'temperatura', 813.0000, 'ºC'),
	(268938, 119, '2014-04-01 00:25:29.000000', 'temperatura', 1133.0000, 'ºC'),
	(268939, 119, '2014-04-01 00:25:30.000000', 'temperatura', 827.0000, 'ºC'),
	(268940, 119, '2014-04-01 00:25:31.000000', 'temperatura', 734.0000, 'ºC'),
	(268941, 119, '2014-04-01 00:25:32.000000', 'temperatura', 1190.0000, 'ºC'),
	(268942, 119, '2014-04-01 00:25:33.000000', 'temperatura', 150.0000, 'ºC'),
	(268943, 119, '2014-04-01 00:25:34.000000', 'temperatura', 780.0000, 'ºC'),
	(268944, 119, '2014-04-01 00:25:35.000000', 'temperatura', 1051.0000, 'ºC'),
	(268945, 119, '2014-04-01 00:25:36.000000', 'temperatura', 516.0000, 'ºC'),
	(268946, 119, '2014-04-01 00:25:37.000000', 'temperatura', 627.0000, 'ºC'),
	(268947, 119, '2014-04-01 00:25:38.000000', 'temperatura', 387.0000, 'ºC'),
	(268948, 119, '2014-04-01 00:25:39.000000', 'temperatura', 53.0000, 'ºC'),
	(268949, 119, '2014-04-01 00:25:40.000000', 'temperatura', 306.0000, 'ºC'),
	(268950, 119, '2014-04-01 00:25:41.000000', 'temperatura', 170.0000, 'ºC'),
	(268951, 119, '2014-04-01 00:25:42.000000', 'temperatura', 1134.0000, 'ºC'),
	(268952, 119, '2014-04-01 00:25:43.000000', 'temperatura', 358.0000, 'ºC'),
	(268953, 119, '2014-04-01 00:25:44.000000', 'temperatura', 792.0000, 'ºC'),
	(268954, 119, '2014-04-01 00:25:45.000000', 'temperatura', 483.0000, 'ºC'),
	(268955, 119, '2014-04-01 00:25:46.000000', 'temperatura', 41.0000, 'ºC'),
	(268956, 119, '2014-04-01 00:25:47.000000', 'temperatura', 1158.0000, 'ºC'),
	(268957, 119, '2014-04-01 00:25:48.000000', 'temperatura', 868.0000, 'ºC'),
	(268958, 119, '2014-04-01 00:25:49.000000', 'temperatura', 863.0000, 'ºC'),
	(268959, 119, '2014-04-01 00:25:50.000000', 'temperatura', 515.0000, 'ºC'),
	(268960, 119, '2014-04-01 00:25:51.000000', 'temperatura', 1185.0000, 'ºC'),
	(268961, 119, '2014-04-01 00:25:52.000000', 'temperatura', 779.0000, 'ºC'),
	(268962, 119, '2014-04-01 00:25:53.000000', 'temperatura', 344.0000, 'ºC'),
	(268963, 119, '2014-04-01 00:25:54.000000', 'temperatura', 580.0000, 'ºC'),
	(268964, 119, '2014-04-01 00:25:55.000000', 'temperatura', 670.0000, 'ºC'),
	(268965, 119, '2014-04-01 00:25:56.000000', 'temperatura', 409.0000, 'ºC'),
	(268966, 119, '2014-04-01 00:25:57.000000', 'temperatura', 38.0000, 'ºC'),
	(268967, 119, '2014-04-01 00:25:58.000000', 'temperatura', 163.0000, 'ºC'),
	(268968, 119, '2014-04-01 00:25:59.000000', 'temperatura', 699.0000, 'ºC'),
	(268969, 119, '2014-04-01 00:26:00.000000', 'temperatura', 609.0000, 'ºC'),
	(268970, 119, '2014-04-01 00:26:01.000000', 'temperatura', 946.0000, 'ºC'),
	(268971, 119, '2014-04-01 00:26:02.000000', 'temperatura', 507.0000, 'ºC'),
	(268972, 119, '2014-04-01 00:26:03.000000', 'temperatura', 894.0000, 'ºC'),
	(268973, 119, '2014-04-01 00:26:04.000000', 'temperatura', 552.0000, 'ºC'),
	(268974, 119, '2014-04-01 00:26:05.000000', 'temperatura', 77.0000, 'ºC'),
	(268975, 119, '2014-04-01 00:26:06.000000', 'temperatura', 1131.0000, 'ºC'),
	(268976, 119, '2014-04-01 00:26:07.000000', 'temperatura', 624.0000, 'ºC'),
	(268977, 119, '2014-04-01 00:26:08.000000', 'temperatura', 928.0000, 'ºC'),
	(268978, 119, '2014-04-01 00:26:09.000000', 'temperatura', 368.0000, 'ºC'),
	(268979, 119, '2014-04-01 00:26:10.000000', 'temperatura', 255.0000, 'ºC'),
	(268980, 119, '2014-04-01 00:26:11.000000', 'temperatura', 171.0000, 'ºC'),
	(268981, 119, '2014-04-01 00:26:12.000000', 'temperatura', 92.0000, 'ºC'),
	(268982, 119, '2014-04-01 00:26:13.000000', 'temperatura', 1146.0000, 'ºC'),
	(268983, 119, '2014-04-01 00:26:14.000000', 'temperatura', 657.0000, 'ºC'),
	(268984, 119, '2014-04-01 00:26:15.000000', 'temperatura', 1046.0000, 'ºC'),
	(268985, 119, '2014-04-01 00:26:16.000000', 'temperatura', 859.0000, 'ºC'),
	(268986, 119, '2014-04-01 00:26:17.000000', 'temperatura', 1159.0000, 'ºC'),
	(268987, 119, '2014-04-01 00:26:18.000000', 'temperatura', 817.0000, 'ºC'),
	(268988, 119, '2014-04-01 00:26:19.000000', 'temperatura', 609.0000, 'ºC'),
	(268989, 119, '2014-04-01 00:26:20.000000', 'temperatura', 596.0000, 'ºC'),
	(268990, 119, '2014-04-01 00:26:21.000000', 'temperatura', 1153.0000, 'ºC'),
	(268991, 119, '2014-04-01 00:26:22.000000', 'temperatura', 377.0000, 'ºC'),
	(268992, 119, '2014-04-01 00:26:23.000000', 'temperatura', 826.0000, 'ºC'),
	(268993, 119, '2014-04-01 00:26:24.000000', 'temperatura', 601.0000, 'ºC'),
	(268994, 119, '2014-04-01 00:26:25.000000', 'temperatura', 525.0000, 'ºC'),
	(268995, 119, '2014-04-01 00:26:26.000000', 'temperatura', 824.0000, 'ºC'),
	(268996, 119, '2014-04-01 00:26:27.000000', 'temperatura', 144.0000, 'ºC'),
	(268997, 119, '2014-04-01 00:26:28.000000', 'temperatura', 649.0000, 'ºC'),
	(268998, 119, '2014-04-01 00:26:29.000000', 'temperatura', 414.0000, 'ºC'),
	(268999, 119, '2014-04-01 00:26:30.000000', 'temperatura', 121.0000, 'ºC'),
	(269000, 119, '2014-04-01 00:26:31.000000', 'temperatura', 567.0000, 'ºC'),
	(269001, 119, '2014-04-01 00:26:32.000000', 'temperatura', 71.0000, 'ºC'),
	(269002, 119, '2014-04-01 00:26:33.000000', 'temperatura', 1055.0000, 'ºC'),
	(269003, 119, '2014-04-01 00:26:34.000000', 'temperatura', 263.0000, 'ºC'),
	(269004, 119, '2014-04-01 00:26:35.000000', 'temperatura', 549.0000, 'ºC'),
	(269005, 119, '2014-04-01 00:26:36.000000', 'temperatura', 759.0000, 'ºC'),
	(269006, 119, '2014-04-01 00:26:37.000000', 'temperatura', 947.0000, 'ºC'),
	(269007, 119, '2014-04-01 00:26:38.000000', 'temperatura', 58.0000, 'ºC'),
	(269008, 119, '2014-04-01 00:26:39.000000', 'temperatura', 1050.0000, 'ºC'),
	(269009, 119, '2014-04-01 00:26:40.000000', 'temperatura', 274.0000, 'ºC'),
	(269010, 119, '2014-04-01 00:26:41.000000', 'temperatura', 624.0000, 'ºC'),
	(269011, 119, '2014-04-01 00:26:42.000000', 'temperatura', 1097.0000, 'ºC'),
	(269012, 119, '2014-04-01 00:26:43.000000', 'temperatura', 12.0000, 'ºC'),
	(269013, 119, '2014-04-01 00:26:44.000000', 'temperatura', 371.0000, 'ºC'),
	(269014, 119, '2014-04-01 00:26:45.000000', 'temperatura', 617.0000, 'ºC'),
	(269015, 119, '2014-04-01 00:26:46.000000', 'temperatura', 775.0000, 'ºC'),
	(269016, 119, '2014-04-01 00:26:47.000000', 'temperatura', 824.0000, 'ºC'),
	(269017, 119, '2014-04-01 00:26:48.000000', 'temperatura', 596.0000, 'ºC'),
	(269018, 119, '2014-04-01 00:26:49.000000', 'temperatura', 507.0000, 'ºC'),
	(269019, 119, '2014-04-01 00:26:50.000000', 'temperatura', 748.0000, 'ºC'),
	(269020, 119, '2014-04-01 00:26:51.000000', 'temperatura', 1022.0000, 'ºC'),
	(269021, 119, '2014-04-01 00:26:52.000000', 'temperatura', 463.0000, 'ºC'),
	(269022, 119, '2014-04-01 00:26:53.000000', 'temperatura', 451.0000, 'ºC'),
	(269023, 119, '2014-04-01 00:26:54.000000', 'temperatura', 866.0000, 'ºC'),
	(269024, 119, '2014-04-01 00:26:55.000000', 'temperatura', 579.0000, 'ºC'),
	(269025, 119, '2014-04-01 00:26:56.000000', 'temperatura', 295.0000, 'ºC'),
	(269026, 119, '2014-04-01 00:26:57.000000', 'temperatura', 938.0000, 'ºC'),
	(269027, 119, '2014-04-01 00:26:58.000000', 'temperatura', 206.0000, 'ºC'),
	(269028, 119, '2014-04-01 00:26:59.000000', 'temperatura', 615.0000, 'ºC'),
	(269029, 119, '2014-04-01 00:27:00.000000', 'temperatura', 59.0000, 'ºC'),
	(269030, 119, '2014-04-01 00:27:01.000000', 'temperatura', 852.0000, 'ºC'),
	(269031, 119, '2014-04-01 00:27:02.000000', 'temperatura', 482.0000, 'ºC'),
	(269032, 119, '2014-04-01 00:27:03.000000', 'temperatura', 1053.0000, 'ºC'),
	(269033, 119, '2014-04-01 00:27:04.000000', 'temperatura', 220.0000, 'ºC'),
	(269034, 119, '2014-04-01 00:27:05.000000', 'temperatura', 341.0000, 'ºC'),
	(269035, 119, '2014-04-01 00:27:06.000000', 'temperatura', 1048.0000, 'ºC'),
	(269036, 119, '2014-04-01 00:27:07.000000', 'temperatura', 617.0000, 'ºC'),
	(269037, 119, '2014-04-01 00:27:08.000000', 'temperatura', 1143.0000, 'ºC'),
	(269038, 119, '2014-04-01 00:27:09.000000', 'temperatura', 261.0000, 'ºC'),
	(269039, 119, '2014-04-01 00:27:10.000000', 'temperatura', 278.0000, 'ºC'),
	(269040, 119, '2014-04-01 00:27:11.000000', 'temperatura', 609.0000, 'ºC'),
	(269041, 119, '2014-04-01 00:27:12.000000', 'temperatura', 1009.0000, 'ºC'),
	(269042, 119, '2014-04-01 00:27:13.000000', 'temperatura', 818.0000, 'ºC'),
	(269043, 119, '2014-04-01 00:27:14.000000', 'temperatura', 1063.0000, 'ºC'),
	(269044, 119, '2014-04-01 00:27:15.000000', 'temperatura', 461.0000, 'ºC'),
	(269045, 119, '2014-04-01 00:27:16.000000', 'temperatura', 319.0000, 'ºC'),
	(269046, 119, '2014-04-01 00:27:17.000000', 'temperatura', 211.0000, 'ºC'),
	(269047, 119, '2014-04-01 00:27:18.000000', 'temperatura', 99.0000, 'ºC'),
	(269048, 119, '2014-04-01 00:27:19.000000', 'temperatura', 1061.0000, 'ºC'),
	(269049, 119, '2014-04-01 00:27:20.000000', 'temperatura', 209.0000, 'ºC'),
	(269050, 119, '2014-04-01 00:27:21.000000', 'temperatura', 265.0000, 'ºC'),
	(269051, 119, '2014-04-01 00:27:22.000000', 'temperatura', 696.0000, 'ºC'),
	(269052, 119, '2014-04-01 00:27:23.000000', 'temperatura', 286.0000, 'ºC'),
	(269053, 119, '2014-04-01 00:27:24.000000', 'temperatura', 543.0000, 'ºC'),
	(269054, 119, '2014-04-01 00:27:25.000000', 'temperatura', 658.0000, 'ºC'),
	(269055, 119, '2014-04-01 00:27:26.000000', 'temperatura', 462.0000, 'ºC'),
	(269056, 119, '2014-04-01 00:27:27.000000', 'temperatura', 337.0000, 'ºC'),
	(269057, 119, '2014-04-01 00:27:28.000000', 'temperatura', 299.0000, 'ºC'),
	(269058, 119, '2014-04-01 00:27:29.000000', 'temperatura', 482.0000, 'ºC'),
	(269059, 119, '2014-04-01 00:27:30.000000', 'temperatura', 317.0000, 'ºC'),
	(269060, 119, '2014-04-01 00:27:31.000000', 'temperatura', 136.0000, 'ºC'),
	(269061, 119, '2014-04-01 00:27:32.000000', 'temperatura', 932.0000, 'ºC'),
	(269062, 119, '2014-04-01 00:27:33.000000', 'temperatura', 653.0000, 'ºC'),
	(269063, 119, '2014-04-01 00:27:34.000000', 'temperatura', 468.0000, 'ºC'),
	(269064, 119, '2014-04-01 00:27:35.000000', 'temperatura', 381.0000, 'ºC'),
	(269065, 119, '2014-04-01 00:27:36.000000', 'temperatura', 501.0000, 'ºC'),
	(269066, 119, '2014-04-01 00:27:37.000000', 'temperatura', 164.0000, 'ºC'),
	(269067, 119, '2014-04-01 00:27:38.000000', 'temperatura', 515.0000, 'ºC'),
	(269068, 119, '2014-04-01 00:27:39.000000', 'temperatura', 886.0000, 'ºC'),
	(269069, 119, '2014-04-01 00:27:40.000000', 'temperatura', 486.0000, 'ºC'),
	(269070, 119, '2014-04-01 00:27:41.000000', 'temperatura', 971.0000, 'ºC'),
	(269071, 119, '2014-04-01 00:27:42.000000', 'temperatura', 999.0000, 'ºC'),
	(269072, 119, '2014-04-01 00:27:43.000000', 'temperatura', 884.0000, 'ºC'),
	(269073, 119, '2014-04-01 00:27:44.000000', 'temperatura', 221.0000, 'ºC'),
	(269074, 119, '2014-04-01 00:27:45.000000', 'temperatura', 855.0000, 'ºC'),
	(269075, 119, '2014-04-01 00:27:46.000000', 'temperatura', 14.0000, 'ºC'),
	(269076, 119, '2014-04-01 00:27:47.000000', 'temperatura', 1104.0000, 'ºC'),
	(269077, 119, '2014-04-01 00:27:48.000000', 'temperatura', 678.0000, 'ºC'),
	(269078, 119, '2014-04-01 00:27:49.000000', 'temperatura', 78.0000, 'ºC'),
	(269079, 119, '2014-04-01 00:27:50.000000', 'temperatura', 758.0000, 'ºC'),
	(269080, 119, '2014-04-01 00:27:51.000000', 'temperatura', 1156.0000, 'ºC'),
	(269081, 119, '2014-04-01 00:27:52.000000', 'temperatura', 1105.0000, 'ºC'),
	(269082, 119, '2014-04-01 00:27:53.000000', 'temperatura', 859.0000, 'ºC'),
	(269083, 119, '2014-04-01 00:27:54.000000', 'temperatura', 980.0000, 'ºC'),
	(269084, 119, '2014-04-01 00:27:55.000000', 'temperatura', 1121.0000, 'ºC'),
	(269085, 119, '2014-04-01 00:27:56.000000', 'temperatura', 269.0000, 'ºC'),
	(269086, 119, '2014-04-01 00:27:57.000000', 'temperatura', 383.0000, 'ºC'),
	(269087, 119, '2014-04-01 00:27:58.000000', 'temperatura', 1106.0000, 'ºC'),
	(269088, 119, '2014-04-01 00:27:59.000000', 'temperatura', 782.0000, 'ºC'),
	(269089, 119, '2014-04-01 00:28:00.000000', 'temperatura', 593.0000, 'ºC'),
	(269090, 119, '2014-04-01 00:28:01.000000', 'temperatura', 618.0000, 'ºC'),
	(269091, 119, '2014-04-01 00:28:02.000000', 'temperatura', 114.0000, 'ºC'),
	(269092, 119, '2014-04-01 00:28:03.000000', 'temperatura', 1117.0000, 'ºC'),
	(269093, 119, '2014-04-01 00:28:04.000000', 'temperatura', 441.0000, 'ºC'),
	(269094, 119, '2014-04-01 00:28:05.000000', 'temperatura', 57.0000, 'ºC'),
	(269095, 119, '2014-04-01 00:28:06.000000', 'temperatura', 160.0000, 'ºC'),
	(269096, 119, '2014-04-01 00:28:07.000000', 'temperatura', 632.0000, 'ºC'),
	(269097, 119, '2014-04-01 00:28:08.000000', 'temperatura', 280.0000, 'ºC'),
	(269098, 119, '2014-04-01 00:28:09.000000', 'temperatura', 703.0000, 'ºC'),
	(269099, 119, '2014-04-01 00:28:10.000000', 'temperatura', 274.0000, 'ºC'),
	(269100, 119, '2014-04-01 00:28:11.000000', 'temperatura', 465.0000, 'ºC'),
	(269101, 119, '2014-04-01 00:28:12.000000', 'temperatura', 302.0000, 'ºC'),
	(269102, 119, '2014-04-01 00:28:13.000000', 'temperatura', 115.0000, 'ºC'),
	(269103, 119, '2014-04-01 00:28:14.000000', 'temperatura', 871.0000, 'ºC'),
	(269104, 119, '2014-04-01 00:28:15.000000', 'temperatura', 410.0000, 'ºC'),
	(269105, 119, '2014-04-01 00:28:16.000000', 'temperatura', 636.0000, 'ºC'),
	(269106, 119, '2014-04-01 00:28:17.000000', 'temperatura', 753.0000, 'ºC'),
	(269107, 119, '2014-04-01 00:28:18.000000', 'temperatura', 656.0000, 'ºC'),
	(269108, 119, '2014-04-01 00:28:19.000000', 'temperatura', 1020.0000, 'ºC'),
	(269109, 119, '2014-04-01 00:28:20.000000', 'temperatura', 734.0000, 'ºC'),
	(269110, 119, '2014-04-01 00:28:21.000000', 'temperatura', 611.0000, 'ºC'),
	(269111, 119, '2014-04-01 00:28:22.000000', 'temperatura', 854.0000, 'ºC'),
	(269112, 119, '2014-04-01 00:28:23.000000', 'temperatura', 37.0000, 'ºC'),
	(269113, 119, '2014-04-01 00:28:24.000000', 'temperatura', 25.0000, 'ºC'),
	(269114, 119, '2014-04-01 00:28:25.000000', 'temperatura', 11.0000, 'ºC'),
	(269115, 119, '2014-04-01 00:28:26.000000', 'temperatura', 1184.0000, 'ºC'),
	(269116, 119, '2014-04-01 00:28:27.000000', 'temperatura', 1084.0000, 'ºC'),
	(269117, 119, '2014-04-01 00:28:28.000000', 'temperatura', 671.0000, 'ºC'),
	(269118, 119, '2014-04-01 00:28:29.000000', 'temperatura', 103.0000, 'ºC'),
	(269119, 119, '2014-04-01 00:28:30.000000', 'temperatura', 900.0000, 'ºC'),
	(269120, 119, '2014-04-01 00:28:31.000000', 'temperatura', 594.0000, 'ºC'),
	(269121, 119, '2014-04-01 00:28:32.000000', 'temperatura', 272.0000, 'ºC'),
	(269122, 119, '2014-04-01 00:28:33.000000', 'temperatura', 775.0000, 'ºC'),
	(269123, 119, '2014-04-01 00:28:34.000000', 'temperatura', 662.0000, 'ºC'),
	(269124, 119, '2014-04-01 00:28:35.000000', 'temperatura', 985.0000, 'ºC'),
	(269125, 119, '2014-04-01 00:28:36.000000', 'temperatura', 538.0000, 'ºC'),
	(269126, 119, '2014-04-01 00:28:37.000000', 'temperatura', 934.0000, 'ºC'),
	(269127, 119, '2014-04-01 00:28:38.000000', 'temperatura', 660.0000, 'ºC'),
	(269128, 119, '2014-04-01 00:28:39.000000', 'temperatura', 496.0000, 'ºC'),
	(269129, 119, '2014-04-01 00:28:40.000000', 'temperatura', 502.0000, 'ºC'),
	(269130, 119, '2014-04-01 00:28:41.000000', 'temperatura', 1022.0000, 'ºC'),
	(269131, 119, '2014-04-01 00:28:42.000000', 'temperatura', 4.0000, 'ºC'),
	(269132, 119, '2014-04-01 00:28:43.000000', 'temperatura', 555.0000, 'ºC'),
	(269133, 119, '2014-04-01 00:28:44.000000', 'temperatura', 364.0000, 'ºC'),
	(269134, 119, '2014-04-01 00:28:45.000000', 'temperatura', 156.0000, 'ºC'),
	(269135, 119, '2014-04-01 00:28:46.000000', 'temperatura', 887.0000, 'ºC'),
	(269136, 119, '2014-04-01 00:28:47.000000', 'temperatura', 369.0000, 'ºC'),
	(269137, 119, '2014-04-01 00:28:48.000000', 'temperatura', 385.0000, 'ºC'),
	(269138, 119, '2014-04-01 00:28:49.000000', 'temperatura', 818.0000, 'ºC'),
	(269139, 119, '2014-04-01 00:28:50.000000', 'temperatura', 534.0000, 'ºC'),
	(269140, 119, '2014-04-01 00:28:51.000000', 'temperatura', 216.0000, 'ºC'),
	(269141, 119, '2014-04-01 00:28:52.000000', 'temperatura', 680.0000, 'ºC'),
	(269142, 119, '2014-04-01 00:28:53.000000', 'temperatura', 352.0000, 'ºC'),
	(269143, 119, '2014-04-01 00:28:54.000000', 'temperatura', 922.0000, 'ºC'),
	(269144, 119, '2014-04-01 00:28:55.000000', 'temperatura', 1153.0000, 'ºC'),
	(269145, 119, '2014-04-01 00:28:56.000000', 'temperatura', 601.0000, 'ºC'),
	(269146, 119, '2014-04-01 00:28:57.000000', 'temperatura', 746.0000, 'ºC'),
	(269147, 119, '2014-04-01 00:28:58.000000', 'temperatura', 727.0000, 'ºC'),
	(269148, 119, '2014-04-01 00:28:59.000000', 'temperatura', 199.0000, 'ºC'),
	(269149, 119, '2014-04-01 00:29:00.000000', 'temperatura', 13.0000, 'ºC'),
	(269150, 119, '2014-04-01 00:29:01.000000', 'temperatura', 671.0000, 'ºC'),
	(269151, 119, '2014-04-01 00:29:02.000000', 'temperatura', 913.0000, 'ºC'),
	(269152, 119, '2014-04-01 00:29:03.000000', 'temperatura', 154.0000, 'ºC'),
	(269153, 119, '2014-04-01 00:29:04.000000', 'temperatura', 433.0000, 'ºC'),
	(269154, 119, '2014-04-01 00:29:05.000000', 'temperatura', 503.0000, 'ºC'),
	(269155, 119, '2014-04-01 00:29:06.000000', 'temperatura', 14.0000, 'ºC'),
	(269156, 119, '2014-04-01 00:29:07.000000', 'temperatura', 964.0000, 'ºC'),
	(269157, 119, '2014-04-01 00:29:08.000000', 'temperatura', 1178.0000, 'ºC'),
	(269158, 119, '2014-04-01 00:29:09.000000', 'temperatura', 598.0000, 'ºC'),
	(269159, 119, '2014-04-01 00:29:10.000000', 'temperatura', 657.0000, 'ºC'),
	(269160, 119, '2014-04-01 00:29:11.000000', 'temperatura', 290.0000, 'ºC'),
	(269161, 119, '2014-04-01 00:29:12.000000', 'temperatura', 681.0000, 'ºC'),
	(269162, 119, '2014-04-01 00:29:13.000000', 'temperatura', 137.0000, 'ºC'),
	(269163, 119, '2014-04-01 00:29:14.000000', 'temperatura', 1041.0000, 'ºC'),
	(269164, 119, '2014-04-01 00:29:15.000000', 'temperatura', 1196.0000, 'ºC'),
	(269165, 119, '2014-04-01 00:29:16.000000', 'temperatura', 456.0000, 'ºC'),
	(269166, 119, '2014-04-01 00:29:17.000000', 'temperatura', 1091.0000, 'ºC'),
	(269167, 119, '2014-04-01 00:29:18.000000', 'temperatura', 488.0000, 'ºC'),
	(269168, 119, '2014-04-01 00:29:19.000000', 'temperatura', 366.0000, 'ºC'),
	(269169, 119, '2014-04-01 00:29:20.000000', 'temperatura', 370.0000, 'ºC'),
	(269170, 119, '2014-04-01 00:29:21.000000', 'temperatura', 750.0000, 'ºC'),
	(269171, 119, '2014-04-01 00:29:22.000000', 'temperatura', 243.0000, 'ºC'),
	(269172, 119, '2014-04-01 00:29:23.000000', 'temperatura', 164.0000, 'ºC'),
	(269173, 119, '2014-04-01 00:29:24.000000', 'temperatura', 90.0000, 'ºC'),
	(269174, 119, '2014-04-01 00:29:25.000000', 'temperatura', 1161.0000, 'ºC'),
	(269175, 119, '2014-04-01 00:29:26.000000', 'temperatura', 734.0000, 'ºC'),
	(269176, 119, '2014-04-01 00:29:27.000000', 'temperatura', 189.0000, 'ºC'),
	(269177, 119, '2014-04-01 00:29:28.000000', 'temperatura', 1141.0000, 'ºC'),
	(269178, 119, '2014-04-01 00:29:29.000000', 'temperatura', 338.0000, 'ºC'),
	(269179, 119, '2014-04-01 00:29:30.000000', 'temperatura', 670.0000, 'ºC'),
	(269180, 119, '2014-04-01 00:29:31.000000', 'temperatura', 1137.0000, 'ºC'),
	(269181, 119, '2014-04-01 00:29:32.000000', 'temperatura', 76.0000, 'ºC'),
	(269182, 119, '2014-04-01 00:29:33.000000', 'temperatura', 570.0000, 'ºC'),
	(269183, 119, '2014-04-01 00:29:34.000000', 'temperatura', 223.0000, 'ºC'),
	(269184, 119, '2014-04-01 00:29:35.000000', 'temperatura', 605.0000, 'ºC'),
	(269185, 119, '2014-04-01 00:29:36.000000', 'temperatura', 1157.0000, 'ºC'),
	(269186, 119, '2014-04-01 00:29:37.000000', 'temperatura', 368.0000, 'ºC'),
	(269187, 119, '2014-04-01 00:29:38.000000', 'temperatura', 772.0000, 'ºC'),
	(269188, 119, '2014-04-01 00:29:39.000000', 'temperatura', 354.0000, 'ºC'),
	(269189, 119, '2014-04-01 00:29:40.000000', 'temperatura', 658.0000, 'ºC'),
	(269190, 119, '2014-04-01 00:29:41.000000', 'temperatura', 1025.0000, 'ºC'),
	(269191, 119, '2014-04-01 00:29:42.000000', 'temperatura', 754.0000, 'ºC'),
	(269192, 119, '2014-04-01 00:29:43.000000', 'temperatura', 695.0000, 'ºC'),
	(269193, 119, '2014-04-01 00:29:44.000000', 'temperatura', 14.0000, 'ºC'),
	(269194, 119, '2014-04-01 00:29:45.000000', 'temperatura', 386.0000, 'ºC'),
	(269195, 119, '2014-04-01 00:29:46.000000', 'temperatura', 686.0000, 'ºC'),
	(269196, 119, '2014-04-01 00:29:47.000000', 'temperatura', 1075.0000, 'ºC'),
	(269197, 119, '2014-04-01 00:29:48.000000', 'temperatura', 916.0000, 'ºC'),
	(269198, 119, '2014-04-01 00:29:49.000000', 'temperatura', 155.0000, 'ºC'),
	(269199, 119, '2014-04-01 00:29:50.000000', 'temperatura', 430.0000, 'ºC'),
	(269200, 119, '2014-04-01 00:29:51.000000', 'temperatura', 482.0000, 'ºC'),
	(269201, 119, '2014-04-01 00:29:52.000000', 'temperatura', 1123.0000, 'ºC'),
	(269202, 119, '2014-04-01 00:29:53.000000', 'temperatura', 569.0000, 'ºC'),
	(269203, 119, '2014-04-01 00:29:54.000000', 'temperatura', 677.0000, 'ºC'),
	(269204, 119, '2014-04-01 00:29:55.000000', 'temperatura', 478.0000, 'ºC'),
	(269205, 119, '2014-04-01 00:29:56.000000', 'temperatura', 360.0000, 'ºC'),
	(269206, 119, '2014-04-01 00:29:57.000000', 'temperatura', 365.0000, 'ºC'),
	(269207, 119, '2014-04-01 00:29:58.000000', 'temperatura', 748.0000, 'ºC'),
	(269208, 119, '2014-04-01 00:29:59.000000', 'temperatura', 243.0000, 'ºC'),
	(269209, 119, '2014-04-01 00:30:00.000000', 'temperatura', 172.0000, 'ºC'),
	(269210, 119, '2014-04-01 00:30:01.000000', 'temperatura', 132.0000, 'ºC'),
	(269211, 119, '2014-04-01 00:30:02.000000', 'temperatura', 146.0000, 'ºC'),
	(269212, 119, '2014-04-01 00:30:03.000000', 'temperatura', 334.0000, 'ºC'),
	(269213, 119, '2014-04-01 00:30:04.000000', 'temperatura', 34.0000, 'ºC'),
	(269214, 119, '2014-04-01 00:30:05.000000', 'temperatura', 366.0000, 'ºC'),
	(269215, 119, '2014-04-01 00:30:06.000000', 'temperatura', 531.0000, 'ºC'),
	(269216, 119, '2014-04-01 00:30:07.000000', 'temperatura', 358.0000, 'ºC'),
	(269217, 119, '2014-04-01 00:30:08.000000', 'temperatura', 196.0000, 'ºC'),
	(269218, 119, '2014-04-01 00:30:09.000000', 'temperatura', 1107.0000, 'ºC'),
	(269219, 119, '2014-04-01 00:30:10.000000', 'temperatura', 148.0000, 'ºC'),
	(269220, 119, '2014-04-01 00:30:11.000000', 'temperatura', 1021.0000, 'ºC'),
	(269221, 119, '2014-04-01 00:30:12.000000', 'temperatura', 1059.0000, 'ºC'),
	(269222, 119, '2014-04-01 00:30:13.000000', 'temperatura', 1032.0000, 'ºC'),
	(269223, 119, '2014-04-01 00:30:14.000000', 'temperatura', 783.0000, 'ºC'),
	(269224, 119, '2014-04-01 00:30:15.000000', 'temperatura', 820.0000, 'ºC'),
	(269225, 119, '2014-04-01 00:30:16.000000', 'temperatura', 550.0000, 'ºC'),
	(269226, 119, '2014-04-01 00:30:17.000000', 'temperatura', 291.0000, 'ºC'),
	(269227, 119, '2014-04-01 00:30:18.000000', 'temperatura', 1008.0000, 'ºC'),
	(269228, 119, '2014-04-01 00:30:19.000000', 'temperatura', 564.0000, 'ºC'),
	(269229, 119, '2014-04-01 00:30:20.000000', 'temperatura', 999.0000, 'ºC'),
	(269230, 119, '2014-04-01 00:30:21.000000', 'temperatura', 903.0000, 'ºC'),
	(269231, 119, '2014-04-01 00:30:22.000000', 'temperatura', 319.0000, 'ºC'),
	(269232, 119, '2014-04-01 00:30:23.000000', 'temperatura', 88.0000, 'ºC'),
	(269233, 119, '2014-04-01 00:30:24.000000', 'temperatura', 680.0000, 'ºC'),
	(269234, 119, '2014-04-01 00:30:25.000000', 'temperatura', 740.0000, 'ºC'),
	(269235, 119, '2014-04-01 00:30:26.000000', 'temperatura', 458.0000, 'ºC'),
	(269236, 119, '2014-04-01 00:30:27.000000', 'temperatura', 73.0000, 'ºC'),
	(269237, 119, '2014-04-01 00:30:28.000000', 'temperatura', 190.0000, 'ºC'),
	(269238, 119, '2014-04-01 00:30:29.000000', 'temperatura', 732.0000, 'ºC'),
	(269239, 119, '2014-04-01 00:30:30.000000', 'temperatura', 692.0000, 'ºC'),
	(269240, 119, '2014-04-01 00:30:31.000000', 'temperatura', 65.0000, 'ºC'),
	(269241, 119, '2014-04-01 00:30:32.000000', 'temperatura', 648.0000, 'ºC'),
	(269242, 119, '2014-04-01 00:30:33.000000', 'temperatura', 646.0000, 'ºC'),
	(269243, 119, '2014-04-01 00:30:34.000000', 'temperatura', 86.0000, 'ºC'),
	(269244, 119, '2014-04-01 00:30:35.000000', 'temperatura', 892.0000, 'ºC'),
	(269245, 119, '2014-04-01 00:30:36.000000', 'temperatura', 603.0000, 'ºC'),
	(269246, 119, '2014-04-01 00:30:37.000000', 'temperatura', 338.0000, 'ºC'),
	(269247, 119, '2014-04-01 00:30:38.000000', 'temperatura', 1082.0000, 'ºC'),
	(269248, 119, '2014-04-01 00:30:39.000000', 'temperatura', 798.0000, 'ºC'),
	(269249, 119, '2014-04-01 00:30:40.000000', 'temperatura', 743.0000, 'ºC'),
	(269250, 119, '2014-04-01 00:30:41.000000', 'temperatura', 123.0000, 'ºC'),
	(269251, 119, '2014-04-01 00:30:42.000000', 'temperatura', 785.0000, 'ºC'),
	(269252, 119, '2014-04-01 00:30:43.000000', 'temperatura', 1159.0000, 'ºC'),
	(269253, 119, '2014-04-01 00:30:44.000000', 'temperatura', 1037.0000, 'ºC'),
	(269254, 119, '2014-04-01 00:30:45.000000', 'temperatura', 510.0000, 'ºC'),
	(269255, 119, '2014-04-01 00:30:46.000000', 'temperatura', 641.0000, 'ºC'),
	(269256, 119, '2014-04-01 00:30:47.000000', 'temperatura', 475.0000, 'ºC'),
	(269257, 119, '2014-04-01 00:30:48.000000', 'temperatura', 453.0000, 'ºC'),
	(269258, 119, '2014-04-01 00:30:49.000000', 'temperatura', 839.0000, 'ºC'),
	(269259, 119, '2014-04-01 00:30:50.000000', 'temperatura', 435.0000, 'ºC'),
	(269260, 119, '2014-04-01 00:30:51.000000', 'temperatura', 861.0000, 'ºC'),
	(269261, 119, '2014-04-01 00:30:52.000000', 'temperatura', 598.0000, 'ºC'),
	(269262, 119, '2014-04-01 00:30:53.000000', 'temperatura', 409.0000, 'ºC'),
	(269263, 119, '2014-04-01 00:30:54.000000', 'temperatura', 251.0000, 'ºC'),
	(269264, 119, '2014-04-01 00:30:55.000000', 'temperatura', 29.0000, 'ºC'),
	(269265, 119, '2014-04-01 00:30:56.000000', 'temperatura', 593.0000, 'ºC'),
	(269266, 119, '2014-04-01 00:30:57.000000', 'temperatura', 476.0000, 'ºC'),
	(269267, 119, '2014-04-01 00:30:58.000000', 'temperatura', 604.0000, 'ºC'),
	(269268, 119, '2014-04-01 00:30:59.000000', 'temperatura', 391.0000, 'ºC'),
	(269269, 119, '2014-04-01 00:31:00.000000', 'temperatura', 144.0000, 'ºC'),
	(269270, 119, '2014-04-01 00:31:01.000000', 'temperatura', 748.0000, 'ºC'),
	(269271, 119, '2014-04-01 00:31:02.000000', 'temperatura', 908.0000, 'ºC'),
	(269272, 119, '2014-04-01 00:31:03.000000', 'temperatura', 1097.0000, 'ºC'),
	(269273, 119, '2014-04-01 00:31:04.000000', 'temperatura', 360.0000, 'ºC'),
	(269274, 119, '2014-04-01 00:31:05.000000', 'temperatura', 911.0000, 'ºC'),
	(269275, 119, '2014-04-01 00:31:06.000000', 'temperatura', 1074.0000, 'ºC'),
	(269276, 119, '2014-04-01 00:31:07.000000', 'temperatura', 239.0000, 'ºC'),
	(269277, 119, '2014-04-01 00:31:08.000000', 'temperatura', 374.0000, 'ºC'),
	(269278, 119, '2014-04-01 00:31:09.000000', 'temperatura', 1153.0000, 'ºC'),
	(269279, 119, '2014-04-01 00:31:10.000000', 'temperatura', 1043.0000, 'ºC'),
	(269280, 119, '2014-04-01 00:31:11.000000', 'temperatura', 555.0000, 'ºC'),
	(269281, 119, '2014-04-01 00:31:12.000000', 'temperatura', 849.0000, 'ºC'),
	(269282, 119, '2014-04-01 00:31:13.000000', 'temperatura', 180.0000, 'ºC'),
	(269283, 119, '2014-04-01 00:31:14.000000', 'temperatura', 752.0000, 'ºC'),
	(269284, 119, '2014-04-01 00:31:15.000000', 'temperatura', 823.0000, 'ºC'),
	(269285, 119, '2014-04-01 00:31:16.000000', 'temperatura', 658.0000, 'ºC'),
	(269286, 119, '2014-04-01 00:31:17.000000', 'temperatura', 824.0000, 'ºC'),
	(269287, 119, '2014-04-01 00:31:18.000000', 'temperatura', 943.0000, 'ºC'),
	(269288, 119, '2014-04-01 00:31:19.000000', 'temperatura', 1046.0000, 'ºC'),
	(269289, 119, '2014-04-01 00:31:20.000000', 'temperatura', 0.0000, 'ºC'),
	(269290, 119, '2014-04-01 00:31:21.000000', 'temperatura', 461.0000, 'ºC'),
	(269291, 119, '2014-04-01 00:31:22.000000', 'temperatura', 1108.0000, 'ºC'),
	(269292, 119, '2014-04-01 00:31:23.000000', 'temperatura', 556.0000, 'ºC'),
	(269293, 119, '2014-04-01 00:31:24.000000', 'temperatura', 655.0000, 'ºC'),
	(269294, 119, '2014-04-01 00:31:25.000000', 'temperatura', 410.0000, 'ºC'),
	(269295, 119, '2014-04-01 00:31:26.000000', 'temperatura', 86.0000, 'ºC'),
	(269296, 119, '2014-04-01 00:31:27.000000', 'temperatura', 401.0000, 'ºC'),
	(269297, 119, '2014-04-01 00:31:28.000000', 'temperatura', 549.0000, 'ºC'),
	(269298, 119, '2014-04-01 00:31:29.000000', 'temperatura', 339.0000, 'ºC'),
	(269299, 119, '2014-04-01 00:31:30.000000', 'temperatura', 51.0000, 'ºC'),
	(269300, 119, '2014-04-01 00:31:31.000000', 'temperatura', 439.0000, 'ºC'),
	(269301, 119, '2014-04-01 00:31:32.000000', 'temperatura', 840.0000, 'ºC'),
	(269302, 119, '2014-04-01 00:31:33.000000', 'temperatura', 484.0000, 'ºC'),
	(269303, 119, '2014-04-01 00:31:34.000000', 'temperatura', 1102.0000, 'ºC'),
	(269304, 119, '2014-04-01 00:31:35.000000', 'temperatura', 458.0000, 'ºC'),
	(269305, 119, '2014-04-01 00:31:36.000000', 'temperatura', 183.0000, 'ºC'),
	(269306, 119, '2014-04-01 00:31:37.000000', 'temperatura', 742.0000, 'ºC'),
	(269307, 119, '2014-04-01 00:31:38.000000', 'temperatura', 760.0000, 'ºC'),
	(269308, 119, '2014-04-01 00:31:39.000000', 'temperatura', 375.0000, 'ºC'),
	(269309, 119, '2014-04-01 00:31:40.000000', 'temperatura', 798.0000, 'ºC'),
	(269310, 119, '2014-04-01 00:31:41.000000', 'temperatura', 463.0000, 'ºC'),
	(269311, 119, '2014-04-01 00:31:42.000000', 'temperatura', 1122.0000, 'ºC'),
	(269312, 119, '2014-04-01 00:31:43.000000', 'temperatura', 622.0000, 'ºC'),
	(269313, 119, '2014-04-01 00:31:44.000000', 'temperatura', 942.0000, 'ºC'),
	(269314, 119, '2014-04-01 00:31:45.000000', 'temperatura', 448.0000, 'ºC'),
	(269315, 119, '2014-04-01 00:31:46.000000', 'temperatura', 612.0000, 'ºC'),
	(269316, 119, '2014-04-01 00:31:47.000000', 'temperatura', 516.0000, 'ºC'),
	(269317, 119, '2014-04-01 00:31:48.000000', 'temperatura', 745.0000, 'ºC'),
	(269318, 119, '2014-04-01 00:31:49.000000', 'temperatura', 976.0000, 'ºC'),
	(269319, 119, '2014-04-01 00:31:50.000000', 'temperatura', 246.0000, 'ºC'),
	(269320, 119, '2014-04-01 00:31:51.000000', 'temperatura', 702.0000, 'ºC'),
	(269321, 119, '2014-04-01 00:31:52.000000', 'temperatura', 371.0000, 'ºC'),
	(269322, 119, '2014-04-01 00:31:53.000000', 'temperatura', 952.0000, 'ºC'),
	(269323, 119, '2014-04-01 00:31:54.000000', 'temperatura', 45.0000, 'ºC'),
	(269324, 119, '2014-04-01 00:31:55.000000', 'temperatura', 973.0000, 'ºC'),
	(269325, 119, '2014-04-01 00:31:56.000000', 'temperatura', 1129.0000, 'ºC'),
	(269326, 119, '2014-04-01 00:31:57.000000', 'temperatura', 324.0000, 'ºC'),
	(269327, 119, '2014-04-01 00:31:58.000000', 'temperatura', 637.0000, 'ºC'),
	(269328, 119, '2014-04-01 00:31:59.000000', 'temperatura', 1013.0000, 'ºC'),
	(269329, 119, '2014-04-01 00:32:00.000000', 'temperatura', 756.0000, 'ºC'),
	(269330, 119, '2014-04-01 00:32:01.000000', 'temperatura', 740.0000, 'ºC'),
	(269331, 119, '2014-04-01 00:32:02.000000', 'temperatura', 234.0000, 'ºC'),
	(269332, 119, '2014-04-01 00:32:03.000000', 'temperatura', 151.0000, 'ºC'),
	(269333, 119, '2014-04-01 00:32:04.000000', 'temperatura', 51.0000, 'ºC'),
	(269334, 119, '2014-04-01 00:32:05.000000', 'temperatura', 1003.0000, 'ºC'),
	(269335, 119, '2014-04-01 00:32:06.000000', 'temperatura', 62.0000, 'ºC'),
	(269336, 119, '2014-04-01 00:32:07.000000', 'temperatura', 902.0000, 'ºC'),
	(269337, 119, '2014-04-01 00:32:08.000000', 'temperatura', 723.0000, 'ºC'),
	(269338, 119, '2014-04-01 00:32:09.000000', 'temperatura', 913.0000, 'ºC'),
	(269339, 119, '2014-04-01 00:32:10.000000', 'temperatura', 1194.0000, 'ºC'),
	(269340, 119, '2014-04-01 00:32:11.000000', 'temperatura', 831.0000, 'ºC'),
	(269341, 119, '2014-04-01 00:32:12.000000', 'temperatura', 573.0000, 'ºC'),
	(269342, 119, '2014-04-01 00:32:13.000000', 'temperatura', 375.0000, 'ºC'),
	(269343, 119, '2014-04-01 00:32:14.000000', 'temperatura', 155.0000, 'ºC'),
	(269344, 119, '2014-04-01 00:32:15.000000', 'temperatura', 849.0000, 'ºC'),
	(269345, 119, '2014-04-01 00:32:16.000000', 'temperatura', 183.0000, 'ºC'),
	(269346, 119, '2014-04-01 00:32:17.000000', 'temperatura', 766.0000, 'ºC'),
	(269347, 119, '2014-04-01 00:32:18.000000', 'temperatura', 884.0000, 'ºC'),
	(269348, 119, '2014-04-01 00:32:19.000000', 'temperatura', 920.0000, 'ºC'),
	(269349, 119, '2014-04-01 00:32:20.000000', 'temperatura', 749.0000, 'ºC'),
	(269350, 119, '2014-04-01 00:32:21.000000', 'temperatura', 985.0000, 'ºC'),
	(269351, 119, '2014-04-01 00:32:22.000000', 'temperatura', 281.0000, 'ºC'),
	(269352, 119, '2014-04-01 00:32:23.000000', 'temperatura', 850.0000, 'ºC'),
	(269353, 119, '2014-04-01 00:32:24.000000', 'temperatura', 1009.0000, 'ºC'),
	(269354, 119, '2014-04-01 00:32:25.000000', 'temperatura', 92.0000, 'ºC'),
	(269355, 119, '2014-04-01 00:32:26.000000', 'temperatura', 1035.0000, 'ºC'),
	(269356, 119, '2014-04-01 00:32:27.000000', 'temperatura', 99.0000, 'ºC'),
	(269357, 119, '2014-04-01 00:32:28.000000', 'temperatura', 990.0000, 'ºC'),
	(269358, 119, '2014-04-01 00:32:29.000000', 'temperatura', 1052.0000, 'ºC'),
	(269359, 119, '2014-04-01 00:32:30.000000', 'temperatura', 1092.0000, 'ºC'),
	(269360, 119, '2014-04-01 00:32:31.000000', 'temperatura', 1106.0000, 'ºC'),
	(269361, 119, '2014-04-01 00:32:32.000000', 'temperatura', 1052.0000, 'ºC'),
	(269362, 119, '2014-04-01 00:32:33.000000', 'temperatura', 745.0000, 'ºC'),
	(269363, 119, '2014-04-01 00:32:34.000000', 'temperatura', 567.0000, 'ºC'),
	(269364, 119, '2014-04-01 00:32:35.000000', 'temperatura', 602.0000, 'ºC'),
	(269365, 119, '2014-04-01 00:32:36.000000', 'temperatura', 111.0000, 'ºC'),
	(269366, 119, '2014-04-01 00:32:37.000000', 'temperatura', 1148.0000, 'ºC'),
	(269367, 119, '2014-04-01 00:32:38.000000', 'temperatura', 606.0000, 'ºC'),
	(269368, 119, '2014-04-01 00:32:39.000000', 'temperatura', 788.0000, 'ºC'),
	(269369, 119, '2014-04-01 00:32:40.000000', 'temperatura', 920.0000, 'ºC'),
	(269370, 119, '2014-04-01 00:32:41.000000', 'temperatura', 1040.0000, 'ºC'),
	(269371, 119, '2014-04-01 00:32:42.000000', 'temperatura', 39.0000, 'ºC'),
	(269372, 119, '2014-04-01 00:32:43.000000', 'temperatura', 676.0000, 'ºC'),
	(269373, 119, '2014-04-01 00:32:44.000000', 'temperatura', 864.0000, 'ºC'),
	(269374, 119, '2014-04-01 00:32:45.000000', 'temperatura', 1094.0000, 'ºC'),
	(269375, 119, '2014-04-01 00:32:46.000000', 'temperatura', 476.0000, 'ºC'),
	(269376, 119, '2014-04-01 00:32:47.000000', 'temperatura', 297.0000, 'ºC'),
	(269377, 119, '2014-04-01 00:32:48.000000', 'temperatura', 61.0000, 'ºC'),
	(269378, 119, '2014-04-01 00:32:49.000000', 'temperatura', 612.0000, 'ºC'),
	(269379, 119, '2014-04-01 00:32:50.000000', 'temperatura', 478.0000, 'ºC'),
	(269380, 119, '2014-04-01 00:32:51.000000', 'temperatura', 553.0000, 'ºC'),
	(269381, 119, '2014-04-01 00:32:52.000000', 'temperatura', 131.0000, 'ºC'),
	(269382, 119, '2014-04-01 00:32:53.000000', 'temperatura', 200.0000, 'ºC'),
	(269383, 119, '2014-04-01 00:32:54.000000', 'temperatura', 604.0000, 'ºC'),
	(269384, 119, '2014-04-01 00:32:55.000000', 'temperatura', 21.0000, 'ºC'),
	(269385, 119, '2014-04-01 00:32:56.000000', 'temperatura', 693.0000, 'ºC'),
	(269386, 119, '2014-04-01 00:32:57.000000', 'temperatura', 1002.0000, 'ºC'),
	(269387, 119, '2014-04-01 00:32:58.000000', 'temperatura', 531.0000, 'ºC'),
	(269388, 119, '2014-04-01 00:32:59.000000', 'temperatura', 851.0000, 'ºC'),
	(269389, 119, '2014-04-01 00:33:00.000000', 'temperatura', 260.0000, 'ºC'),
	(269390, 119, '2014-04-01 00:33:01.000000', 'temperatura', 1150.0000, 'ºC'),
	(269391, 119, '2014-04-01 00:33:02.000000', 'temperatura', 169.0000, 'ºC'),
	(269392, 119, '2014-04-01 00:33:03.000000', 'temperatura', 997.0000, 'ºC'),
	(269393, 119, '2014-04-01 00:33:04.000000', 'temperatura', 876.0000, 'ºC'),
	(269394, 119, '2014-04-01 00:33:05.000000', 'temperatura', 190.0000, 'ºC'),
	(269395, 119, '2014-04-01 00:33:06.000000', 'temperatura', 724.0000, 'ºC'),
	(269396, 119, '2014-04-01 00:33:07.000000', 'temperatura', 648.0000, 'ºC'),
	(269397, 119, '2014-04-01 00:33:08.000000', 'temperatura', 1072.0000, 'ºC'),
	(269398, 119, '2014-04-01 00:33:09.000000', 'temperatura', 1013.0000, 'ºC'),
	(269399, 119, '2014-04-01 00:33:10.000000', 'temperatura', 653.0000, 'ºC'),
	(269400, 119, '2014-04-01 00:33:11.000000', 'temperatura', 224.0000, 'ºC'),
	(269401, 119, '2014-04-01 00:33:12.000000', 'temperatura', 362.0000, 'ºC'),
	(269402, 119, '2014-04-01 00:33:13.000000', 'temperatura', 1138.0000, 'ºC'),
	(269403, 119, '2014-04-01 00:33:14.000000', 'temperatura', 1006.0000, 'ºC'),
	(269404, 119, '2014-04-01 00:33:15.000000', 'temperatura', 416.0000, 'ºC'),
	(269405, 119, '2014-04-01 00:33:16.000000', 'temperatura', 261.0000, 'ºC'),
	(269406, 119, '2014-04-01 00:33:17.000000', 'temperatura', 59.0000, 'ºC'),
	(269407, 119, '2014-04-01 00:33:18.000000', 'temperatura', 712.0000, 'ºC'),
	(269408, 119, '2014-04-01 00:33:19.000000', 'temperatura', 985.0000, 'ºC'),
	(269409, 119, '2014-04-01 00:33:20.000000', 'temperatura', 388.0000, 'ºC'),
	(269410, 119, '2014-04-01 00:33:21.000000', 'temperatura', 187.0000, 'ºC'),
	(269411, 119, '2014-04-01 00:33:22.000000', 'temperatura', 969.0000, 'ºC'),
	(269412, 119, '2014-04-01 00:33:23.000000', 'temperatura', 687.0000, 'ºC'),
	(269413, 119, '2014-04-01 00:33:24.000000', 'temperatura', 526.0000, 'ºC'),
	(269414, 119, '2014-04-01 00:33:25.000000', 'temperatura', 572.0000, 'ºC'),
	(269415, 119, '2014-04-01 00:33:26.000000', 'temperatura', 83.0000, 'ºC'),
	(269416, 119, '2014-04-01 00:33:27.000000', 'temperatura', 1100.0000, 'ºC'),
	(269417, 119, '2014-04-01 00:33:28.000000', 'temperatura', 453.0000, 'ºC'),
	(269418, 119, '2014-04-01 00:33:29.000000', 'temperatura', 162.0000, 'ºC'),
	(269419, 119, '2014-04-01 00:33:30.000000', 'temperatura', 652.0000, 'ºC'),
	(269420, 119, '2014-04-01 00:33:31.000000', 'temperatura', 375.0000, 'ºC'),
	(269421, 119, '2014-04-01 00:33:32.000000', 'temperatura', 1122.0000, 'ºC'),
	(269422, 119, '2014-04-01 00:33:33.000000', 'temperatura', 882.0000, 'ºC'),
	(269423, 119, '2014-04-01 00:33:34.000000', 'temperatura', 1046.0000, 'ºC'),
	(269424, 119, '2014-04-01 00:33:35.000000', 'temperatura', 183.0000, 'ºC'),
	(269425, 119, '2014-04-01 00:33:36.000000', 'temperatura', 179.0000, 'ºC'),
	(269426, 119, '2014-04-01 00:33:37.000000', 'temperatura', 345.0000, 'ºC'),
	(269427, 119, '2014-04-01 00:33:38.000000', 'temperatura', 1189.0000, 'ºC'),
	(269428, 119, '2014-04-01 00:33:39.000000', 'temperatura', 110.0000, 'ºC'),
	(269429, 119, '2014-04-01 00:33:40.000000', 'temperatura', 585.0000, 'ºC'),
	(269430, 119, '2014-04-01 00:33:41.000000', 'temperatura', 196.0000, 'ºC'),
	(269431, 119, '2014-04-01 00:33:42.000000', 'temperatura', 425.0000, 'ºC'),
	(269432, 119, '2014-04-01 00:33:43.000000', 'temperatura', 339.0000, 'ºC'),
	(269433, 119, '2014-04-01 00:33:44.000000', 'temperatura', 419.0000, 'ºC'),
	(269434, 119, '2014-04-01 00:33:45.000000', 'temperatura', 1079.0000, 'ºC'),
	(269435, 119, '2014-04-01 00:33:46.000000', 'temperatura', 540.0000, 'ºC'),
	(269436, 119, '2014-04-01 00:33:47.000000', 'temperatura', 663.0000, 'ºC'),
	(269437, 119, '2014-04-01 00:33:48.000000', 'temperatura', 497.0000, 'ºC'),
	(269438, 119, '2014-04-01 00:33:49.000000', 'temperatura', 494.0000, 'ºC'),
	(269439, 119, '2014-04-01 00:33:50.000000', 'temperatura', 981.0000, 'ºC'),
	(269440, 119, '2014-04-01 00:33:51.000000', 'temperatura', 1024.0000, 'ºC'),
	(269441, 119, '2014-04-01 00:33:52.000000', 'temperatura', 977.0000, 'ºC'),
	(269442, 119, '2014-04-01 00:33:53.000000', 'temperatura', 613.0000, 'ºC'),
	(269443, 119, '2014-04-01 00:33:54.000000', 'temperatura', 135.0000, 'ºC'),
	(269444, 119, '2014-04-01 00:33:55.000000', 'temperatura', 37.0000, 'ºC'),
	(269445, 119, '2014-04-01 00:33:56.000000', 'temperatura', 982.0000, 'ºC'),
	(269446, 119, '2014-04-01 00:33:57.000000', 'temperatura', 1196.0000, 'ºC'),
	(269447, 119, '2014-04-01 00:33:58.000000', 'temperatura', 637.0000, 'ºC'),
	(269448, 119, '2014-04-01 00:33:59.000000', 'temperatura', 798.0000, 'ºC'),
	(269449, 119, '2014-04-01 00:34:00.000000', 'temperatura', 878.0000, 'ºC'),
	(269450, 119, '2014-04-01 00:34:01.000000', 'temperatura', 797.0000, 'ºC'),
	(269451, 119, '2014-04-01 00:34:02.000000', 'temperatura', 152.0000, 'ºC'),
	(269452, 119, '2014-04-01 00:34:03.000000', 'temperatura', 769.0000, 'ºC'),
	(269453, 119, '2014-04-01 00:34:04.000000', 'temperatura', 991.0000, 'ºC'),
	(269454, 119, '2014-04-01 00:34:05.000000', 'temperatura', 247.0000, 'ºC'),
	(269455, 119, '2014-04-01 00:34:06.000000', 'temperatura', 665.0000, 'ºC'),
	(269456, 119, '2014-04-01 00:34:07.000000', 'temperatura', 181.0000, 'ºC'),
	(269457, 119, '2014-04-01 00:34:08.000000', 'temperatura', 114.0000, 'ºC'),
	(269458, 119, '2014-04-01 00:34:09.000000', 'temperatura', 26.0000, 'ºC'),
	(269459, 119, '2014-04-01 00:34:10.000000', 'temperatura', 986.0000, 'ºC'),
	(269460, 119, '2014-04-01 00:34:11.000000', 'temperatura', 56.0000, 'ºC'),
	(269461, 119, '2014-04-01 00:34:12.000000', 'temperatura', 921.0000, 'ºC'),
	(269462, 119, '2014-04-01 00:34:13.000000', 'temperatura', 837.0000, 'ºC'),
	(269463, 119, '2014-04-01 00:34:14.000000', 'temperatura', 223.0000, 'ºC'),
	(269464, 119, '2014-04-01 00:34:15.000000', 'temperatura', 1006.0000, 'ºC'),
	(269465, 119, '2014-04-01 00:34:16.000000', 'temperatura', 759.0000, 'ºC'),
	(269466, 119, '2014-04-01 00:34:17.000000', 'temperatura', 780.0000, 'ºC'),
	(269467, 119, '2014-04-01 00:34:18.000000', 'temperatura', 424.0000, 'ºC'),
	(269468, 119, '2014-04-01 00:34:19.000000', 'temperatura', 981.0000, 'ºC'),
	(269469, 119, '2014-04-01 00:34:20.000000', 'temperatura', 33.0000, 'ºC'),
	(269470, 119, '2014-04-01 00:34:21.000000', 'temperatura', 821.0000, 'ºC'),
	(269471, 119, '2014-04-01 00:34:22.000000', 'temperatura', 406.0000, 'ºC'),
	(269472, 119, '2014-04-01 00:34:23.000000', 'temperatura', 771.0000, 'ºC'),
	(269473, 119, '2014-04-01 00:34:24.000000', 'temperatura', 234.0000, 'ºC'),
	(269474, 119, '2014-04-01 00:34:25.000000', 'temperatura', 57.0000, 'ºC'),
	(269475, 119, '2014-04-01 00:34:26.000000', 'temperatura', 783.0000, 'ºC'),
	(269476, 119, '2014-04-01 00:34:27.000000', 'temperatura', 147.0000, 'ºC'),
	(269477, 119, '2014-04-01 00:34:28.000000', 'temperatura', 786.0000, 'ºC'),
	(269478, 119, '2014-04-01 00:34:29.000000', 'temperatura', 1087.0000, 'ºC'),
	(269479, 119, '2014-04-01 00:34:30.000000', 'temperatura', 681.0000, 'ºC'),
	(269480, 119, '2014-04-01 00:34:31.000000', 'temperatura', 143.0000, 'ºC'),
	(269481, 119, '2014-04-01 00:34:32.000000', 'temperatura', 1073.0000, 'ºC'),
	(269482, 119, '2014-04-01 00:34:33.000000', 'temperatura', 138.0000, 'ºC'),
	(269483, 119, '2014-04-01 00:34:34.000000', 'temperatura', 1071.0000, 'ºC'),
	(269484, 119, '2014-04-01 00:34:35.000000', 'temperatura', 141.0000, 'ºC'),
	(269485, 119, '2014-04-01 00:34:36.000000', 'temperatura', 1092.0000, 'ºC'),
	(269486, 119, '2014-04-01 00:34:37.000000', 'temperatura', 239.0000, 'ºC'),
	(269487, 119, '2014-04-01 00:34:38.000000', 'temperatura', 318.0000, 'ºC'),
	(269488, 119, '2014-04-01 00:34:39.000000', 'temperatura', 875.0000, 'ºC'),
	(269489, 119, '2014-04-01 00:34:40.000000', 'temperatura', 1020.0000, 'ºC'),
	(269490, 119, '2014-04-01 00:34:41.000000', 'temperatura', 76.0000, 'ºC'),
	(269491, 119, '2014-04-01 00:34:42.000000', 'temperatura', 919.0000, 'ºC'),
	(269492, 119, '2014-04-01 00:34:43.000000', 'temperatura', 769.0000, 'ºC'),
	(269493, 119, '2014-04-01 00:34:44.000000', 'temperatura', 1090.0000, 'ºC'),
	(269494, 119, '2014-04-01 00:34:45.000000', 'temperatura', 742.0000, 'ºC'),
	(269495, 119, '2014-04-01 00:34:46.000000', 'temperatura', 442.0000, 'ºC'),
	(269496, 119, '2014-04-01 00:34:47.000000', 'temperatura', 1185.0000, 'ºC'),
	(269497, 119, '2014-04-01 00:34:48.000000', 'temperatura', 1000.0000, 'ºC'),
	(269498, 119, '2014-04-01 00:34:49.000000', 'temperatura', 245.0000, 'ºC'),
	(269499, 119, '2014-04-01 00:34:50.000000', 'temperatura', 625.0000, 'ºC'),
	(269500, 119, '2014-04-01 00:34:51.000000', 'temperatura', 1190.0000, 'ºC'),
	(269501, 119, '2014-04-01 00:34:52.000000', 'temperatura', 475.0000, 'ºC'),
	(269502, 119, '2014-04-01 00:34:53.000000', 'temperatura', 4.0000, 'ºC'),
	(269503, 119, '2014-04-01 00:34:54.000000', 'temperatura', 997.0000, 'ºC'),
	(269504, 119, '2014-04-01 00:34:55.000000', 'temperatura', 176.0000, 'ºC'),
	(269505, 119, '2014-04-01 00:34:56.000000', 'temperatura', 286.0000, 'ºC'),
	(269506, 119, '2014-04-01 00:34:57.000000', 'temperatura', 904.0000, 'ºC'),
	(269507, 119, '2014-04-01 00:34:58.000000', 'temperatura', 62.0000, 'ºC'),
	(269508, 119, '2014-04-01 00:34:59.000000', 'temperatura', 1198.0000, 'ºC'),
	(269509, 119, '2014-04-01 00:35:00.000000', 'temperatura', 1005.0000, 'ºC'),
	(269510, 119, '2014-04-01 00:35:01.000000', 'temperatura', 229.0000, 'ºC'),
	(269511, 119, '2014-04-01 00:35:02.000000', 'temperatura', 534.0000, 'ºC'),
	(269512, 119, '2014-04-01 00:35:03.000000', 'temperatura', 782.0000, 'ºC'),
	(269513, 119, '2014-04-01 00:35:04.000000', 'temperatura', 1110.0000, 'ºC'),
	(269514, 119, '2014-04-01 00:35:05.000000', 'temperatura', 801.0000, 'ºC'),
	(269515, 119, '2014-04-01 00:35:06.000000', 'temperatura', 679.0000, 'ºC'),
	(269516, 119, '2014-04-01 00:35:07.000000', 'temperatura', 992.0000, 'ºC'),
	(269517, 119, '2014-04-01 00:35:08.000000', 'temperatura', 524.0000, 'ºC'),
	(269518, 119, '2014-04-01 00:35:09.000000', 'temperatura', 845.0000, 'ºC'),
	(269519, 119, '2014-04-01 00:35:10.000000', 'temperatura', 251.0000, 'ºC'),
	(269520, 119, '2014-04-01 00:35:11.000000', 'temperatura', 1122.0000, 'ºC'),
	(269521, 119, '2014-04-01 00:35:12.000000', 'temperatura', 57.0000, 'ºC'),
	(269522, 119, '2014-04-01 00:35:13.000000', 'temperatura', 518.0000, 'ºC'),
	(269523, 119, '2014-04-01 00:35:14.000000', 'temperatura', 19.0000, 'ºC'),
	(269524, 119, '2014-04-01 00:35:15.000000', 'temperatura', 943.0000, 'ºC'),
	(269525, 119, '2014-04-01 00:35:16.000000', 'temperatura', 1057.0000, 'ºC'),
	(269526, 119, '2014-04-01 00:35:17.000000', 'temperatura', 57.0000, 'ºC'),
	(269527, 119, '2014-04-01 00:35:18.000000', 'temperatura', 716.0000, 'ºC'),
	(269528, 119, '2014-04-01 00:35:19.000000', 'temperatura', 1007.0000, 'ºC'),
	(269529, 119, '2014-04-01 00:35:20.000000', 'temperatura', 488.0000, 'ºC'),
	(269530, 119, '2014-04-01 00:35:21.000000', 'temperatura', 621.0000, 'ºC'),
	(269531, 119, '2014-04-01 00:35:22.000000', 'temperatura', 442.0000, 'ºC'),
	(269532, 119, '2014-04-01 00:35:23.000000', 'temperatura', 348.0000, 'ºC'),
	(269533, 119, '2014-04-01 00:35:24.000000', 'temperatura', 414.0000, 'ºC'),
	(269534, 119, '2014-04-01 00:35:25.000000', 'temperatura', 1025.0000, 'ºC'),
	(269535, 119, '2014-04-01 00:35:26.000000', 'temperatura', 284.0000, 'ºC'),
	(269536, 119, '2014-04-01 00:35:27.000000', 'temperatura', 744.0000, 'ºC'),
	(269537, 119, '2014-04-01 00:35:28.000000', 'temperatura', 470.0000, 'ºC'),
	(269538, 119, '2014-04-01 00:35:29.000000', 'temperatura', 119.0000, 'ºC'),
	(269539, 119, '2014-04-01 00:35:30.000000', 'temperatura', 386.0000, 'ºC'),
	(269540, 119, '2014-04-01 00:35:31.000000', 'temperatura', 371.0000, 'ºC'),
	(269541, 119, '2014-04-01 00:35:32.000000', 'temperatura', 700.0000, 'ºC'),
	(269542, 119, '2014-04-01 00:35:33.000000', 'temperatura', 1185.0000, 'ºC'),
	(269543, 119, '2014-04-01 00:35:34.000000', 'temperatura', 225.0000, 'ºC'),
	(269544, 119, '2014-04-01 00:35:35.000000', 'temperatura', 1173.0000, 'ºC'),
	(269545, 119, '2014-04-01 00:35:36.000000', 'temperatura', 388.0000, 'ºC'),
	(269546, 119, '2014-04-01 00:35:37.000000', 'temperatura', 820.0000, 'ºC'),
	(269547, 119, '2014-04-01 00:35:38.000000', 'temperatura', 540.0000, 'ºC'),
	(269548, 119, '2014-04-01 00:35:39.000000', 'temperatura', 240.0000, 'ºC'),
	(269549, 119, '2014-04-01 00:35:40.000000', 'temperatura', 781.0000, 'ºC'),
	(269550, 119, '2014-04-01 00:35:41.000000', 'temperatura', 787.0000, 'ºC'),
	(269551, 119, '2014-04-01 00:35:42.000000', 'temperatura', 390.0000, 'ºC'),
	(269552, 119, '2014-04-01 00:35:43.000000', 'temperatura', 790.0000, 'ºC'),
	(269553, 119, '2014-04-01 00:35:44.000000', 'temperatura', 380.0000, 'ºC'),
	(269554, 119, '2014-04-01 00:35:45.000000', 'temperatura', 731.0000, 'ºC'),
	(269555, 119, '2014-04-01 00:35:46.000000', 'temperatura', 114.0000, 'ºC'),
	(269556, 119, '2014-04-01 00:35:47.000000', 'temperatura', 780.0000, 'ºC'),
	(269557, 119, '2014-04-01 00:35:48.000000', 'temperatura', 1158.0000, 'ºC'),
	(269558, 119, '2014-04-01 00:35:49.000000', 'temperatura', 1052.0000, 'ºC'),
	(269559, 119, '2014-04-01 00:35:50.000000', 'temperatura', 585.0000, 'ºC'),
	(269560, 119, '2014-04-01 00:35:51.000000', 'temperatura', 970.0000, 'ºC'),
	(269561, 119, '2014-04-01 00:35:52.000000', 'temperatura', 696.0000, 'ºC'),
	(269562, 119, '2014-04-01 00:35:53.000000', 'temperatura', 571.0000, 'ºC'),
	(269563, 119, '2014-04-01 00:35:54.000000', 'temperatura', 767.0000, 'ºC'),
	(269564, 119, '2014-04-01 00:35:55.000000', 'temperatura', 920.0000, 'ºC'),
	(269565, 119, '2014-04-01 00:35:56.000000', 'temperatura', 1103.0000, 'ºC'),
	(269566, 119, '2014-04-01 00:35:57.000000', 'temperatura', 353.0000, 'ºC'),
	(269567, 119, '2014-04-01 00:35:58.000000', 'temperatura', 857.0000, 'ºC'),
	(269568, 119, '2014-04-01 00:35:59.000000', 'temperatura', 828.0000, 'ºC'),
	(269569, 119, '2014-04-01 00:36:00.000000', 'temperatura', 369.0000, 'ºC'),
	(269570, 119, '2014-04-01 00:36:01.000000', 'temperatura', 563.0000, 'ºC'),
	(269571, 119, '2014-04-01 00:36:02.000000', 'temperatura', 505.0000, 'ºC'),
	(269572, 119, '2014-04-01 00:36:03.000000', 'temperatura', 840.0000, 'ºC'),
	(269573, 119, '2014-04-01 00:36:04.000000', 'temperatura', 283.0000, 'ºC'),
	(269574, 119, '2014-04-01 00:36:05.000000', 'temperatura', 95.0000, 'ºC'),
	(269575, 119, '2014-04-01 00:36:06.000000', 'temperatura', 827.0000, 'ºC'),
	(269576, 119, '2014-04-01 00:36:07.000000', 'temperatura', 251.0000, 'ºC'),
	(269577, 119, '2014-04-01 00:36:08.000000', 'temperatura', 1176.0000, 'ºC'),
	(269578, 119, '2014-04-01 00:36:09.000000', 'temperatura', 328.0000, 'ºC'),
	(269579, 119, '2014-04-01 00:36:10.000000', 'temperatura', 510.0000, 'ºC'),
	(269580, 119, '2014-04-01 00:36:11.000000', 'temperatura', 366.0000, 'ºC'),
	(269581, 119, '2014-04-01 00:36:12.000000', 'temperatura', 300.0000, 'ºC'),
	(269582, 119, '2014-04-01 00:36:13.000000', 'temperatura', 402.0000, 'ºC'),
	(269583, 119, '2014-04-01 00:36:14.000000', 'temperatura', 1112.0000, 'ºC'),
	(269584, 119, '2014-04-01 00:36:15.000000', 'temperatura', 755.0000, 'ºC'),
	(269585, 119, '2014-04-01 00:36:16.000000', 'temperatura', 440.0000, 'ºC'),
	(269586, 119, '2014-04-01 00:36:17.000000', 'temperatura', 1136.0000, 'ºC'),
	(269587, 119, '2014-04-01 00:36:18.000000', 'temperatura', 758.0000, 'ºC'),
	(269588, 119, '2014-04-01 00:36:19.000000', 'temperatura', 383.0000, 'ºC'),
	(269589, 119, '2014-04-01 00:36:20.000000', 'temperatura', 840.0000, 'ºC'),
	(269590, 119, '2014-04-01 00:36:21.000000', 'temperatura', 654.0000, 'ºC'),
	(269591, 119, '2014-04-01 00:36:22.000000', 'temperatura', 751.0000, 'ºC'),
	(269592, 119, '2014-04-01 00:36:23.000000', 'temperatura', 594.0000, 'ºC'),
	(269593, 119, '2014-04-01 00:36:24.000000', 'temperatura', 717.0000, 'ºC'),
	(269594, 119, '2014-04-01 00:36:25.000000', 'temperatura', 602.0000, 'ºC'),
	(269595, 119, '2014-04-01 00:36:26.000000', 'temperatura', 861.0000, 'ºC'),
	(269596, 119, '2014-04-01 00:36:27.000000', 'temperatura', 100.0000, 'ºC'),
	(269597, 119, '2014-04-01 00:36:28.000000', 'temperatura', 317.0000, 'ºC'),
	(269598, 119, '2014-04-01 00:36:29.000000', 'temperatura', 84.0000, 'ºC'),
	(269599, 119, '2014-04-01 00:36:30.000000', 'temperatura', 672.0000, 'ºC'),
	(269600, 119, '2014-04-01 00:36:31.000000', 'temperatura', 706.0000, 'ºC'),
	(269601, 119, '2014-04-01 00:36:32.000000', 'temperatura', 318.0000, 'ºC'),
	(269602, 119, '2014-04-01 00:36:33.000000', 'temperatura', 669.0000, 'ºC'),
	(269603, 119, '2014-04-01 00:36:34.000000', 'temperatura', 1193.0000, 'ºC'),
	(269604, 119, '2014-04-01 00:36:35.000000', 'temperatura', 358.0000, 'ºC'),
	(269605, 119, '2014-04-01 00:36:36.000000', 'temperatura', 612.0000, 'ºC'),
	(269606, 119, '2014-04-01 00:36:37.000000', 'temperatura', 788.0000, 'ºC'),
	(269607, 119, '2014-04-01 00:36:38.000000', 'temperatura', 902.0000, 'ºC'),
	(269608, 119, '2014-04-01 00:36:39.000000', 'temperatura', 946.0000, 'ºC'),
	(269609, 119, '2014-04-01 00:36:40.000000', 'temperatura', 823.0000, 'ºC'),
	(269610, 119, '2014-04-01 00:36:41.000000', 'temperatura', 81.0000, 'ºC'),
	(269611, 119, '2014-04-01 00:36:42.000000', 'temperatura', 335.0000, 'ºC'),
	(269612, 119, '2014-04-01 00:36:43.000000', 'temperatura', 233.0000, 'ºC'),
	(269613, 119, '2014-04-01 00:36:44.000000', 'temperatura', 161.0000, 'ºC'),
	(269614, 119, '2014-04-01 00:36:45.000000', 'temperatura', 107.0000, 'ºC'),
	(269615, 119, '2014-04-01 00:36:46.000000', 'temperatura', 53.0000, 'ºC'),
	(269616, 119, '2014-04-01 00:36:47.000000', 'temperatura', 1145.0000, 'ºC'),
	(269617, 119, '2014-04-01 00:36:48.000000', 'temperatura', 764.0000, 'ºC'),
	(269618, 119, '2014-04-01 00:36:49.000000', 'temperatura', 387.0000, 'ºC'),
	(269619, 119, '2014-04-01 00:36:50.000000', 'temperatura', 843.0000, 'ºC'),
	(269620, 119, '2014-04-01 00:36:51.000000', 'temperatura', 653.0000, 'ºC'),
	(269621, 119, '2014-04-01 00:36:52.000000', 'temperatura', 738.0000, 'ºC'),
	(269622, 119, '2014-04-01 00:36:53.000000', 'temperatura', 531.0000, 'ºC'),
	(269623, 119, '2014-04-01 00:36:54.000000', 'temperatura', 442.0000, 'ºC'),
	(269624, 119, '2014-04-01 00:36:55.000000', 'temperatura', 619.0000, 'ºC'),
	(269625, 119, '2014-04-01 00:36:56.000000', 'temperatura', 568.0000, 'ºC'),
	(269626, 119, '2014-04-01 00:36:57.000000', 'temperatura', 983.0000, 'ºC'),
	(269627, 119, '2014-04-01 00:36:58.000000', 'temperatura', 811.0000, 'ºC'),
	(269628, 119, '2014-04-01 00:36:59.000000', 'temperatura', 1106.0000, 'ºC'),
	(269629, 119, '2014-04-01 00:37:00.000000', 'temperatura', 697.0000, 'ºC'),
	(269630, 119, '2014-04-01 00:37:01.000000', 'temperatura', 167.0000, 'ºC'),
	(269631, 119, '2014-04-01 00:37:02.000000', 'temperatura', 1147.0000, 'ºC'),
	(269632, 119, '2014-04-01 00:37:03.000000', 'temperatura', 434.0000, 'ºC'),
	(269633, 119, '2014-04-01 00:37:04.000000', 'temperatura', 1129.0000, 'ºC'),
	(269634, 119, '2014-04-01 00:37:05.000000', 'temperatura', 742.0000, 'ºC'),
	(269635, 119, '2014-04-01 00:37:06.000000', 'temperatura', 324.0000, 'ºC'),
	(269636, 119, '2014-04-01 00:37:07.000000', 'temperatura', 593.0000, 'ºC'),
	(269637, 119, '2014-04-01 00:37:08.000000', 'temperatura', 796.0000, 'ºC'),
	(269638, 119, '2014-04-01 00:37:09.000000', 'temperatura', 1002.0000, 'ºC'),
	(269639, 119, '2014-04-01 00:37:10.000000', 'temperatura', 220.0000, 'ºC'),
	(269640, 119, '2014-04-01 00:37:11.000000', 'temperatura', 494.0000, 'ºC'),
	(269641, 119, '2014-04-01 00:37:12.000000', 'temperatura', 612.0000, 'ºC'),
	(269642, 119, '2014-04-01 00:37:13.000000', 'temperatura', 376.0000, 'ºC'),
	(269643, 119, '2014-04-01 00:37:14.000000', 'temperatura', 47.0000, 'ºC'),
	(269644, 119, '2014-04-01 00:37:15.000000', 'temperatura', 305.0000, 'ºC'),
	(269645, 119, '2014-04-01 00:37:16.000000', 'temperatura', 185.0000, 'ºC'),
	(269646, 119, '2014-04-01 00:37:17.000000', 'temperatura', 11.0000, 'ºC'),
	(269647, 119, '2014-04-01 00:37:18.000000', 'temperatura', 701.0000, 'ºC'),
	(269648, 119, '2014-04-01 00:37:19.000000', 'temperatura', 1074.0000, 'ºC'),
	(269649, 119, '2014-04-01 00:37:20.000000', 'temperatura', 866.0000, 'ºC'),
	(269650, 119, '2014-04-01 00:37:21.000000', 'temperatura', 1109.0000, 'ºC'),
	(269651, 119, '2014-04-01 00:37:22.000000', 'temperatura', 548.0000, 'ºC'),
	(269652, 119, '2014-04-01 00:37:23.000000', 'temperatura', 613.0000, 'ºC'),
	(269653, 119, '2014-04-01 00:37:24.000000', 'temperatura', 221.0000, 'ºC'),
	(269654, 119, '2014-04-01 00:37:25.000000', 'temperatura', 467.0000, 'ºC'),
	(269655, 119, '2014-04-01 00:37:26.000000', 'temperatura', 474.0000, 'ºC'),
	(269656, 119, '2014-04-01 00:37:27.000000', 'temperatura', 970.0000, 'ºC'),
	(269657, 119, '2014-04-01 00:37:28.000000', 'temperatura', 1027.0000, 'ºC'),
	(269658, 119, '2014-04-01 00:37:29.000000', 'temperatura', 1025.0000, 'ºC'),
	(269659, 119, '2014-04-01 00:37:30.000000', 'temperatura', 845.0000, 'ºC'),
	(269660, 119, '2014-04-01 00:37:31.000000', 'temperatura', 1151.0000, 'ºC'),
	(269661, 119, '2014-04-01 00:37:32.000000', 'temperatura', 821.0000, 'ºC'),
	(269662, 119, '2014-04-01 00:37:33.000000', 'temperatura', 652.0000, 'ºC'),
	(269663, 119, '2014-04-01 00:37:34.000000', 'temperatura', 799.0000, 'ºC'),
	(269664, 119, '2014-04-01 00:37:35.000000', 'temperatura', 839.0000, 'ºC'),
	(269665, 119, '2014-04-01 00:37:36.000000', 'temperatura', 596.0000, 'ºC'),
	(269666, 119, '2014-04-01 00:37:37.000000', 'temperatura', 466.0000, 'ºC'),
	(269667, 119, '2014-04-01 00:37:38.000000', 'temperatura', 541.0000, 'ºC'),
	(269668, 119, '2014-04-01 00:37:39.000000', 'temperatura', 110.0000, 'ºC'),
	(269669, 119, '2014-04-01 00:37:40.000000', 'temperatura', 124.0000, 'ºC'),
	(269670, 119, '2014-04-01 00:37:41.000000', 'temperatura', 294.0000, 'ºC'),
	(269671, 119, '2014-04-01 00:37:42.000000', 'temperatura', 1097.0000, 'ºC'),
	(269672, 119, '2014-04-01 00:37:43.000000', 'temperatura', 1004.0000, 'ºC'),
	(269673, 119, '2014-04-01 00:37:44.000000', 'temperatura', 527.0000, 'ºC'),
	(269674, 119, '2014-04-01 00:37:45.000000', 'temperatura', 826.0000, 'ºC'),
	(269675, 119, '2014-04-01 00:37:46.000000', 'temperatura', 148.0000, 'ºC'),
	(269676, 119, '2014-04-01 00:37:47.000000', 'temperatura', 664.0000, 'ºC'),
	(269677, 119, '2014-04-01 00:37:48.000000', 'temperatura', 476.0000, 'ºC'),
	(269678, 119, '2014-04-01 00:37:49.000000', 'temperatura', 390.0000, 'ºC'),
	(269679, 119, '2014-04-01 00:37:50.000000', 'temperatura', 521.0000, 'ºC'),
	(269680, 119, '2014-04-01 00:37:51.000000', 'temperatura', 235.0000, 'ºC'),
	(269681, 119, '2014-04-01 00:37:52.000000', 'temperatura', 814.0000, 'ºC'),
	(269682, 119, '2014-04-01 00:37:53.000000', 'temperatura', 963.0000, 'ºC'),
	(269683, 119, '2014-04-01 00:37:54.000000', 'temperatura', 1176.0000, 'ºC'),
	(269684, 119, '2014-04-01 00:37:55.000000', 'temperatura', 589.0000, 'ºC'),
	(269685, 119, '2014-04-01 00:37:56.000000', 'temperatura', 619.0000, 'ºC'),
	(269686, 119, '2014-04-01 00:37:57.000000', 'temperatura', 129.0000, 'ºC'),
	(269687, 119, '2014-04-01 00:37:58.000000', 'temperatura', 1187.0000, 'ºC'),
	(269688, 119, '2014-04-01 00:37:59.000000', 'temperatura', 749.0000, 'ºC'),
	(269689, 119, '2014-04-01 00:38:00.000000', 'temperatura', 187.0000, 'ºC'),
	(269690, 119, '2014-04-01 00:38:01.000000', 'temperatura', 1085.0000, 'ºC'),
	(269691, 119, '2014-04-01 00:38:02.000000', 'temperatura', 65.0000, 'ºC'),
	(269692, 119, '2014-04-01 00:38:03.000000', 'temperatura', 672.0000, 'ºC'),
	(269693, 119, '2014-04-01 00:38:04.000000', 'temperatura', 763.0000, 'ºC'),
	(269694, 119, '2014-04-01 00:38:05.000000', 'temperatura', 602.0000, 'ºC'),
	(269695, 119, '2014-04-01 00:38:06.000000', 'temperatura', 722.0000, 'ºC'),
	(269696, 119, '2014-04-01 00:38:07.000000', 'temperatura', 605.0000, 'ºC'),
	(269697, 119, '2014-04-01 00:38:08.000000', 'temperatura', 859.0000, 'ºC'),
	(269698, 119, '2014-04-01 00:38:09.000000', 'temperatura', 79.0000, 'ºC'),
	(269699, 119, '2014-04-01 00:38:10.000000', 'temperatura', 221.0000, 'ºC'),
	(269700, 119, '2014-04-01 00:38:11.000000', 'temperatura', 869.0000, 'ºC'),
	(269701, 119, '2014-04-01 00:38:12.000000', 'temperatura', 81.0000, 'ºC'),
	(269702, 119, '2014-04-01 00:38:13.000000', 'temperatura', 199.0000, 'ºC'),
	(269703, 119, '2014-04-01 00:38:14.000000', 'temperatura', 753.0000, 'ºC'),
	(269704, 119, '2014-04-01 00:38:15.000000', 'temperatura', 769.0000, 'ºC'),
	(269705, 119, '2014-04-01 00:38:16.000000', 'temperatura', 388.0000, 'ºC'),
	(269706, 119, '2014-04-01 00:38:17.000000', 'temperatura', 831.0000, 'ºC'),
	(269707, 119, '2014-04-01 00:38:18.000000', 'temperatura', 590.0000, 'ºC'),
	(269708, 119, '2014-04-01 00:38:19.000000', 'temperatura', 460.0000, 'ºC'),
	(269709, 119, '2014-04-01 00:38:20.000000', 'temperatura', 530.0000, 'ºC'),
	(269710, 119, '2014-04-01 00:38:21.000000', 'temperatura', 72.0000, 'ºC'),
	(269711, 119, '2014-04-01 00:38:22.000000', 'temperatura', 1168.0000, 'ºC'),
	(269712, 119, '2014-04-01 00:38:23.000000', 'temperatura', 825.0000, 'ºC'),
	(269713, 119, '2014-04-01 00:38:24.000000', 'temperatura', 620.0000, 'ºC'),
	(269714, 119, '2014-04-01 00:38:25.000000', 'temperatura', 626.0000, 'ºC'),
	(269715, 119, '2014-04-01 00:38:26.000000', 'temperatura', 71.0000, 'ºC'),
	(269716, 119, '2014-04-01 00:38:27.000000', 'temperatura', 877.0000, 'ºC'),
	(269717, 119, '2014-04-01 00:38:28.000000', 'temperatura', 574.0000, 'ºC'),
	(269718, 119, '2014-04-01 00:38:29.000000', 'temperatura', 239.0000, 'ºC'),
	(269719, 119, '2014-04-01 00:38:30.000000', 'temperatura', 672.0000, 'ºC'),
	(269720, 119, '2014-04-01 00:38:31.000000', 'temperatura', 245.0000, 'ºC'),
	(269721, 119, '2014-04-01 00:38:32.000000', 'temperatura', 408.0000, 'ºC'),
	(269722, 119, '2014-04-01 00:38:33.000000', 'temperatura', 108.0000, 'ºC'),
	(269723, 119, '2014-04-01 00:38:34.000000', 'temperatura', 514.0000, 'ºC'),
	(269724, 119, '2014-04-01 00:38:35.000000', 'temperatura', 1047.0000, 'ºC'),
	(269725, 119, '2014-04-01 00:38:36.000000', 'temperatura', 92.0000, 'ºC'),
	(269726, 119, '2014-04-01 00:38:37.000000', 'temperatura', 919.0000, 'ºC'),
	(269727, 119, '2014-04-01 00:38:38.000000', 'temperatura', 723.0000, 'ºC'),
	(269728, 119, '2014-04-01 00:38:39.000000', 'temperatura', 856.0000, 'ºC'),
	(269729, 119, '2014-04-01 00:38:40.000000', 'temperatura', 911.0000, 'ºC'),
	(269730, 119, '2014-04-01 00:38:41.000000', 'temperatura', 789.0000, 'ºC'),
	(269731, 119, '2014-04-01 00:38:42.000000', 'temperatura', 10.0000, 'ºC'),
	(269732, 119, '2014-04-01 00:38:43.000000', 'temperatura', 85.0000, 'ºC'),
	(269733, 119, '2014-04-01 00:38:44.000000', 'temperatura', 394.0000, 'ºC'),
	(269734, 119, '2014-04-01 00:38:45.000000', 'temperatura', 517.0000, 'ºC'),
	(269735, 119, '2014-04-01 00:38:46.000000', 'temperatura', 204.0000, 'ºC'),
	(269736, 119, '2014-04-01 00:38:47.000000', 'temperatura', 670.0000, 'ºC'),
	(269737, 119, '2014-04-01 00:38:48.000000', 'temperatura', 339.0000, 'ºC'),
	(269738, 119, '2014-04-01 00:38:49.000000', 'temperatura', 884.0000, 'ºC'),
	(269739, 119, '2014-04-01 00:38:50.000000', 'temperatura', 1004.0000, 'ºC'),
	(269740, 119, '2014-04-01 00:38:51.000000', 'temperatura', 1168.0000, 'ºC'),
	(269741, 119, '2014-04-01 00:38:52.000000', 'temperatura', 427.0000, 'ºC'),
	(269742, 119, '2014-04-01 00:38:53.000000', 'temperatura', 1033.0000, 'ºC'),
	(269743, 119, '2014-04-01 00:38:54.000000', 'temperatura', 284.0000, 'ºC'),
	(269744, 119, '2014-04-01 00:38:55.000000', 'temperatura', 721.0000, 'ºC'),
	(269745, 119, '2014-04-01 00:38:56.000000', 'temperatura', 356.0000, 'ºC'),
	(269746, 119, '2014-04-01 00:38:57.000000', 'temperatura', 815.0000, 'ºC'),
	(269747, 119, '2014-04-01 00:38:58.000000', 'temperatura', 609.0000, 'ºC'),
	(269748, 119, '2014-04-01 00:38:59.000000', 'temperatura', 599.0000, 'ºC'),
	(269749, 119, '2014-04-01 00:39:00.000000', 'temperatura', 1169.0000, 'ºC'),
	(269750, 119, '2014-04-01 00:39:01.000000', 'temperatura', 447.0000, 'ºC'),
	(269751, 119, '2014-04-01 00:39:02.000000', 'temperatura', 1130.0000, 'ºC'),
	(269752, 119, '2014-04-01 00:39:03.000000', 'temperatura', 709.0000, 'ºC'),
	(269753, 119, '2014-04-01 00:39:04.000000', 'temperatura', 155.0000, 'ºC'),
	(269754, 119, '2014-04-01 00:39:05.000000', 'temperatura', 1050.0000, 'ºC'),
	(269755, 119, '2014-04-01 00:39:06.000000', 'temperatura', 1186.0000, 'ºC'),
	(269756, 119, '2014-04-01 00:39:07.000000', 'temperatura', 379.0000, 'ºC'),
	(269757, 119, '2014-04-01 00:39:08.000000', 'temperatura', 736.0000, 'ºC'),
	(269758, 119, '2014-04-01 00:39:09.000000', 'temperatura', 145.0000, 'ºC'),
	(269759, 119, '2014-04-01 00:39:10.000000', 'temperatura', 917.0000, 'ºC'),
	(269760, 119, '2014-04-01 00:39:11.000000', 'temperatura', 550.0000, 'ºC'),
	(269761, 119, '2014-04-01 00:39:12.000000', 'temperatura', 1.0000, 'ºC'),
	(269762, 119, '2014-04-01 00:39:13.000000', 'temperatura', 753.0000, 'ºC'),
	(269763, 119, '2014-04-01 00:39:14.000000', 'temperatura', 164.0000, 'ºC'),
	(269764, 119, '2014-04-01 00:39:15.000000', 'temperatura', 960.0000, 'ºC'),
	(269765, 119, '2014-04-01 00:39:16.000000', 'temperatura', 708.0000, 'ºC'),
	(269766, 119, '2014-04-01 00:39:17.000000', 'temperatura', 662.0000, 'ºC'),
	(269767, 119, '2014-04-01 00:39:18.000000', 'temperatura', 1184.0000, 'ºC'),
	(269768, 119, '2014-04-01 00:39:19.000000', 'temperatura', 336.0000, 'ºC'),
	(269769, 119, '2014-04-01 00:39:20.000000', 'temperatura', 530.0000, 'ºC'),
	(269770, 119, '2014-04-01 00:39:21.000000', 'temperatura', 443.0000, 'ºC'),
	(269771, 119, '2014-04-01 00:39:22.000000', 'temperatura', 624.0000, 'ºC'),
	(269772, 119, '2014-04-01 00:39:23.000000', 'temperatura', 592.0000, 'ºC'),
	(269773, 119, '2014-04-01 00:39:24.000000', 'temperatura', 1090.0000, 'ºC'),
	(269774, 119, '2014-04-01 00:39:25.000000', 'temperatura', 74.0000, 'ºC'),
	(269775, 119, '2014-04-01 00:39:26.000000', 'temperatura', 701.0000, 'ºC'),
	(269776, 119, '2014-04-01 00:39:27.000000', 'temperatura', 882.0000, 'ºC'),
	(269777, 119, '2014-04-01 00:39:28.000000', 'temperatura', 1107.0000, 'ºC'),
	(269778, 119, '2014-04-01 00:39:29.000000', 'temperatura', 489.0000, 'ºC'),
	(269779, 119, '2014-04-01 00:39:30.000000', 'temperatura', 327.0000, 'ºC'),
	(269780, 119, '2014-04-01 00:39:31.000000', 'temperatura', 169.0000, 'ºC'),
	(269781, 119, '2014-04-01 00:39:32.000000', 'temperatura', 1063.0000, 'ºC'),
	(269782, 119, '2014-04-01 00:39:33.000000', 'temperatura', 9.0000, 'ºC'),
	(269783, 119, '2014-04-01 00:39:34.000000', 'temperatura', 455.0000, 'ºC'),
	(269784, 119, '2014-04-01 00:39:35.000000', 'temperatura', 1049.0000, 'ºC'),
	(269785, 119, '2014-04-01 00:39:36.000000', 'temperatura', 280.0000, 'ºC'),
	(269786, 119, '2014-04-01 00:39:37.000000', 'temperatura', 654.0000, 'ºC'),
	(269787, 119, '2014-04-01 00:39:38.000000', 'temperatura', 31.0000, 'ºC'),
	(269788, 119, '2014-04-01 00:39:39.000000', 'temperatura', 595.0000, 'ºC'),
	(269789, 119, '2014-04-01 00:39:40.000000', 'temperatura', 482.0000, 'ºC'),
	(269790, 119, '2014-04-01 00:39:41.000000', 'temperatura', 627.0000, 'ºC'),
	(269791, 119, '2014-04-01 00:39:42.000000', 'temperatura', 487.0000, 'ºC'),
	(269792, 119, '2014-04-01 00:39:43.000000', 'temperatura', 555.0000, 'ºC'),
	(269793, 119, '2014-04-01 00:39:44.000000', 'temperatura', 116.0000, 'ºC'),
	(269794, 119, '2014-04-01 00:39:45.000000', 'temperatura', 114.0000, 'ºC'),
	(269795, 119, '2014-04-01 00:39:46.000000', 'temperatura', 223.0000, 'ºC'),
	(269796, 119, '2014-04-01 00:39:47.000000', 'temperatura', 773.0000, 'ºC'),
	(269797, 119, '2014-04-01 00:39:48.000000', 'temperatura', 798.0000, 'ºC'),
	(269798, 119, '2014-04-01 00:39:49.000000', 'temperatura', 472.0000, 'ºC'),
	(269799, 119, '2014-04-01 00:39:50.000000', 'temperatura', 1166.0000, 'ºC'),
	(269800, 119, '2014-04-01 00:39:51.000000', 'temperatura', 813.0000, 'ºC'),
	(269801, 119, '2014-04-01 00:39:52.000000', 'temperatura', 566.0000, 'ºC'),
	(269802, 119, '2014-04-01 00:39:53.000000', 'temperatura', 394.0000, 'ºC'),
	(269803, 119, '2014-04-01 00:39:54.000000', 'temperatura', 272.0000, 'ºC'),
	(269804, 119, '2014-04-01 00:39:55.000000', 'temperatura', 177.0000, 'ºC'),
	(269805, 119, '2014-04-01 00:39:56.000000', 'temperatura', 71.0000, 'ºC'),
	(269806, 119, '2014-04-01 00:39:57.000000', 'temperatura', 1024.0000, 'ºC'),
	(269807, 119, '2014-04-01 00:39:58.000000', 'temperatura', 108.0000, 'ºC'),
	(269808, 119, '2014-04-01 00:39:59.000000', 'temperatura', 1066.0000, 'ºC'),
	(269809, 119, '2014-04-01 00:40:00.000000', 'temperatura', 210.0000, 'ºC'),
	(269810, 119, '2014-04-01 00:40:01.000000', 'temperatura', 250.0000, 'ºC'),
	(269811, 119, '2014-04-01 00:40:02.000000', 'temperatura', 623.0000, 'ºC'),
	(269812, 119, '2014-04-01 00:40:03.000000', 'temperatura', 1163.0000, 'ºC'),
	(269813, 119, '2014-04-01 00:40:04.000000', 'temperatura', 349.0000, 'ºC'),
	(269814, 119, '2014-04-01 00:40:05.000000', 'temperatura', 656.0000, 'ºC'),
	(269815, 119, '2014-04-01 00:40:06.000000', 'temperatura', 1034.0000, 'ºC'),
	(269816, 119, '2014-04-01 00:40:07.000000', 'temperatura', 802.0000, 'ºC'),
	(269817, 119, '2014-04-01 00:40:08.000000', 'temperatura', 909.0000, 'ºC'),
	(269818, 119, '2014-04-01 00:40:09.000000', 'temperatura', 937.0000, 'ºC'),
	(269819, 119, '2014-04-01 00:40:10.000000', 'temperatura', 761.0000, 'ºC'),
	(269820, 119, '2014-04-01 00:40:11.000000', 'temperatura', 993.0000, 'ºC'),
	(269821, 119, '2014-04-01 00:40:12.000000', 'temperatura', 282.0000, 'ºC'),
	(269822, 119, '2014-04-01 00:40:13.000000', 'temperatura', 830.0000, 'ºC'),
	(269823, 119, '2014-04-01 00:40:14.000000', 'temperatura', 907.0000, 'ºC'),
	(269824, 119, '2014-04-01 00:40:15.000000', 'temperatura', 844.0000, 'ºC'),
	(269825, 119, '2014-04-01 00:40:16.000000', 'temperatura', 300.0000, 'ºC'),
	(269826, 119, '2014-04-01 00:40:17.000000', 'temperatura', 167.0000, 'ºC'),
	(269827, 119, '2014-04-01 00:40:18.000000', 'temperatura', 1136.0000, 'ºC'),
	(269828, 119, '2014-04-01 00:40:19.000000', 'temperatura', 380.0000, 'ºC'),
	(269829, 119, '2014-04-01 00:40:20.000000', 'temperatura', 891.0000, 'ºC'),
	(269830, 119, '2014-04-01 00:40:21.000000', 'temperatura', 917.0000, 'ºC'),
	(269831, 119, '2014-04-01 00:40:22.000000', 'temperatura', 713.0000, 'ºC'),
	(269832, 119, '2014-04-01 00:40:23.000000', 'temperatura', 814.0000, 'ºC'),
	(269833, 119, '2014-04-01 00:40:24.000000', 'temperatura', 731.0000, 'ºC'),
	(269834, 119, '2014-04-01 00:40:25.000000', 'temperatura', 12.0000, 'ºC'),
	(269835, 119, '2014-04-01 00:40:26.000000', 'temperatura', 267.0000, 'ºC'),
	(269836, 119, '2014-04-01 00:40:27.000000', 'temperatura', 103.0000, 'ºC'),
	(269837, 119, '2014-04-01 00:40:28.000000', 'temperatura', 912.0000, 'ºC'),
	(269838, 119, '2014-04-01 00:40:29.000000', 'temperatura', 652.0000, 'ºC'),
	(269839, 119, '2014-04-01 00:40:30.000000', 'temperatura', 524.0000, 'ºC'),
	(269840, 119, '2014-04-01 00:40:31.000000', 'temperatura', 664.0000, 'ºC'),
	(269841, 119, '2014-04-01 00:40:32.000000', 'temperatura', 550.0000, 'ºC'),
	(269842, 119, '2014-04-01 00:40:33.000000', 'temperatura', 759.0000, 'ºC'),
	(269843, 119, '2014-04-01 00:40:34.000000', 'temperatura', 947.0000, 'ºC'),
	(269844, 119, '2014-04-01 00:40:35.000000', 'temperatura', 55.0000, 'ºC'),
	(269845, 119, '2014-04-01 00:40:36.000000', 'temperatura', 1035.0000, 'ºC'),
	(269846, 119, '2014-04-01 00:40:37.000000', 'temperatura', 212.0000, 'ºC'),
	(269847, 119, '2014-04-01 00:40:38.000000', 'temperatura', 355.0000, 'ºC'),
	(269848, 119, '2014-04-01 00:40:39.000000', 'temperatura', 1141.0000, 'ºC'),
	(269849, 119, '2014-04-01 00:40:40.000000', 'temperatura', 1039.0000, 'ºC'),
	(269850, 119, '2014-04-01 00:40:41.000000', 'temperatura', 573.0000, 'ºC'),
	(269851, 119, '2014-04-01 00:40:42.000000', 'temperatura', 949.0000, 'ºC'),
	(269852, 119, '2014-04-01 00:40:43.000000', 'temperatura', 626.0000, 'ºC'),
	(269853, 119, '2014-04-01 00:40:44.000000', 'temperatura', 285.0000, 'ºC'),
	(269854, 119, '2014-04-01 00:40:45.000000', 'temperatura', 747.0000, 'ºC'),
	(269855, 119, '2014-04-01 00:40:46.000000', 'temperatura', 482.0000, 'ºC'),
	(269856, 119, '2014-04-01 00:40:47.000000', 'temperatura', 169.0000, 'ºC'),
	(269857, 119, '2014-04-01 00:40:48.000000', 'temperatura', 600.0000, 'ºC'),
	(269858, 119, '2014-04-01 00:40:49.000000', 'temperatura', 95.0000, 'ºC'),
	(269859, 119, '2014-04-01 00:40:50.000000', 'temperatura', 1072.0000, 'ºC'),
	(269860, 119, '2014-04-01 00:40:51.000000', 'temperatura', 279.0000, 'ºC'),
	(269861, 119, '2014-04-01 00:40:52.000000', 'temperatura', 577.0000, 'ºC'),
	(269862, 119, '2014-04-01 00:40:53.000000', 'temperatura', 849.0000, 'ºC'),
	(269863, 119, '2014-04-01 00:40:54.000000', 'temperatura', 113.0000, 'ºC'),
	(269864, 119, '2014-04-01 00:40:55.000000', 'temperatura', 419.0000, 'ºC'),
	(269865, 119, '2014-04-01 00:40:56.000000', 'temperatura', 559.0000, 'ºC'),
	(269866, 119, '2014-04-01 00:40:57.000000', 'temperatura', 335.0000, 'ºC'),
	(269867, 119, '2014-04-01 00:40:58.000000', 'temperatura', 0.0000, 'ºC'),
	(269868, 119, '2014-04-01 00:40:59.000000', 'temperatura', 195.0000, 'ºC'),
	(269869, 119, '2014-04-01 00:41:00.000000', 'temperatura', 977.0000, 'ºC'),
	(269870, 119, '2014-04-01 00:41:01.000000', 'temperatura', 698.0000, 'ºC'),
	(269871, 119, '2014-04-01 00:41:02.000000', 'temperatura', 561.0000, 'ºC'),
	(269872, 119, '2014-04-01 00:41:03.000000', 'temperatura', 711.0000, 'ºC'),
	(269873, 119, '2014-04-01 00:41:04.000000', 'temperatura', 671.0000, 'ºC'),
	(269874, 119, '2014-04-01 00:41:05.000000', 'temperatura', 25.0000, 'ºC'),
	(269875, 119, '2014-04-01 00:41:06.000000', 'temperatura', 511.0000, 'ºC'),
	(269876, 119, '2014-04-01 00:41:07.000000', 'temperatura', 82.0000, 'ºC'),
	(269877, 119, '2014-04-01 00:41:08.000000', 'temperatura', 75.0000, 'ºC'),
	(269878, 119, '2014-04-01 00:41:09.000000', 'temperatura', 130.0000, 'ºC'),
	(269879, 119, '2014-04-01 00:41:10.000000', 'temperatura', 428.0000, 'ºC'),
	(269880, 119, '2014-04-01 00:41:11.000000', 'temperatura', 549.0000, 'ºC'),
	(269881, 119, '2014-04-01 00:41:12.000000', 'temperatura', 264.0000, 'ºC'),
	(269882, 119, '2014-04-01 00:41:13.000000', 'temperatura', 870.0000, 'ºC'),
	(269883, 119, '2014-04-01 00:41:14.000000', 'temperatura', 1159.0000, 'ºC'),
	(269884, 119, '2014-04-01 00:41:15.000000', 'temperatura', 785.0000, 'ºC'),
	(269885, 119, '2014-04-01 00:41:16.000000', 'temperatura', 447.0000, 'ºC'),
	(269886, 119, '2014-04-01 00:41:17.000000', 'temperatura', 1084.0000, 'ºC'),
	(269887, 119, '2014-04-01 00:41:18.000000', 'temperatura', 477.0000, 'ºC'),
	(269888, 119, '2014-04-01 00:41:19.000000', 'temperatura', 336.0000, 'ºC'),
	(269889, 119, '2014-04-01 00:41:20.000000', 'temperatura', 247.0000, 'ºC'),
	(269890, 119, '2014-04-01 00:41:21.000000', 'temperatura', 230.0000, 'ºC'),
	(269891, 119, '2014-04-01 00:41:22.000000', 'temperatura', 410.0000, 'ºC'),
	(269892, 119, '2014-04-01 00:41:23.000000', 'temperatura', 161.0000, 'ºC'),
	(269893, 119, '2014-04-01 00:41:24.000000', 'temperatura', 773.0000, 'ºC'),
	(269894, 119, '2014-04-01 00:41:25.000000', 'temperatura', 982.0000, 'ºC'),
	(269895, 119, '2014-04-01 00:41:26.000000', 'temperatura', 192.0000, 'ºC'),
	(269896, 119, '2014-04-01 00:41:27.000000', 'temperatura', 413.0000, 'ºC'),
	(269897, 119, '2014-04-01 00:41:28.000000', 'temperatura', 291.0000, 'ºC'),
	(269898, 119, '2014-04-01 00:41:29.000000', 'temperatura', 218.0000, 'ºC'),
	(269899, 119, '2014-04-01 00:41:30.000000', 'temperatura', 215.0000, 'ºC'),
	(269900, 119, '2014-04-01 00:41:31.000000', 'temperatura', 423.0000, 'ºC'),
	(269901, 119, '2014-04-01 00:41:32.000000', 'temperatura', 269.0000, 'ºC'),
	(269902, 119, '2014-04-01 00:41:33.000000', 'temperatura', 77.0000, 'ºC'),
	(269903, 119, '2014-04-01 00:41:34.000000', 'temperatura', 778.0000, 'ºC'),
	(269904, 119, '2014-04-01 00:41:35.000000', 'temperatura', 60.0000, 'ºC'),
	(269905, 119, '2014-04-01 00:41:36.000000', 'temperatura', 365.0000, 'ºC'),
	(269906, 119, '2014-04-01 00:41:37.000000', 'temperatura', 446.0000, 'ºC'),
	(269907, 119, '2014-04-01 00:41:38.000000', 'temperatura', 1134.0000, 'ºC'),
	(269908, 119, '2014-04-01 00:41:39.000000', 'temperatura', 735.0000, 'ºC'),
	(269909, 119, '2014-04-01 00:41:40.000000', 'temperatura', 274.0000, 'ºC'),
	(269910, 119, '2014-04-01 00:41:41.000000', 'temperatura', 365.0000, 'ºC'),
	(269911, 119, '2014-04-01 00:41:42.000000', 'temperatura', 1003.0000, 'ºC'),
	(269912, 119, '2014-04-01 00:41:43.000000', 'temperatura', 322.0000, 'ºC'),
	(269913, 119, '2014-04-01 00:41:44.000000', 'temperatura', 1002.0000, 'ºC'),
	(269914, 119, '2014-04-01 00:41:45.000000', 'temperatura', 444.0000, 'ºC'),
	(269915, 119, '2014-04-01 00:41:46.000000', 'temperatura', 413.0000, 'ºC'),
	(269916, 119, '2014-04-01 00:41:47.000000', 'temperatura', 736.0000, 'ºC'),
	(269917, 119, '2014-04-01 00:41:48.000000', 'temperatura', 41.0000, 'ºC'),
	(269918, 119, '2014-04-01 00:41:49.000000', 'temperatura', 396.0000, 'ºC'),
	(269919, 119, '2014-04-01 00:41:50.000000', 'temperatura', 656.0000, 'ºC'),
	(269920, 119, '2014-04-01 00:41:51.000000', 'temperatura', 895.0000, 'ºC'),
	(269921, 119, '2014-04-01 00:41:52.000000', 'temperatura', 108.0000, 'ºC'),
	(269922, 119, '2014-04-01 00:41:53.000000', 'temperatura', 255.0000, 'ºC'),
	(269923, 119, '2014-04-01 00:41:54.000000', 'temperatura', 953.0000, 'ºC'),
	(269924, 119, '2014-04-01 00:41:55.000000', 'temperatura', 400.0000, 'ºC'),
	(269925, 119, '2014-04-01 00:41:56.000000', 'temperatura', 340.0000, 'ºC'),
	(269926, 119, '2014-04-01 00:41:57.000000', 'temperatura', 502.0000, 'ºC'),
	(269927, 119, '2014-04-01 00:41:58.000000', 'temperatura', 290.0000, 'ºC'),
	(269928, 119, '2014-04-01 00:41:59.000000', 'temperatura', 1145.0000, 'ºC'),
	(269929, 119, '2014-04-01 00:42:00.000000', 'temperatura', 56.0000, 'ºC'),
	(269930, 119, '2014-04-01 00:42:01.000000', 'temperatura', 446.0000, 'ºC'),
	(269931, 119, '2014-04-01 00:42:02.000000', 'temperatura', 861.0000, 'ºC'),
	(269932, 119, '2014-04-01 00:42:03.000000', 'temperatura', 570.0000, 'ºC'),
	(269933, 119, '2014-04-01 00:42:04.000000', 'temperatura', 264.0000, 'ºC'),
	(269934, 119, '2014-04-01 00:42:05.000000', 'temperatura', 814.0000, 'ºC'),
	(269935, 119, '2014-04-01 00:42:06.000000', 'temperatura', 875.0000, 'ºC'),
	(269936, 119, '2014-04-01 00:42:07.000000', 'temperatura', 735.0000, 'ºC'),
	(269937, 119, '2014-04-01 00:42:08.000000', 'temperatura', 1052.0000, 'ºC'),
	(269938, 119, '2014-04-01 00:42:09.000000', 'temperatura', 656.0000, 'ºC'),
	(269939, 119, '2014-04-01 00:42:10.000000', 'temperatura', 124.0000, 'ºC'),
	(269940, 119, '2014-04-01 00:42:11.000000', 'temperatura', 1054.0000, 'ºC'),
	(269941, 119, '2014-04-01 00:42:12.000000', 'temperatura', 98.0000, 'ºC'),
	(269942, 119, '2014-04-01 00:42:13.000000', 'temperatura', 926.0000, 'ºC'),
	(269943, 119, '2014-04-01 00:42:14.000000', 'temperatura', 739.0000, 'ºC'),
	(269944, 119, '2014-04-01 00:42:15.000000', 'temperatura', 916.0000, 'ºC'),
	(269945, 119, '2014-04-01 00:42:16.000000', 'temperatura', 1165.0000, 'ºC'),
	(269946, 119, '2014-04-01 00:42:17.000000', 'temperatura', 676.0000, 'ºC'),
	(269947, 119, '2014-04-01 00:42:18.000000', 'temperatura', 1084.0000, 'ºC'),
	(269948, 119, '2014-04-01 00:42:19.000000', 'temperatura', 996.0000, 'ºC'),
	(269949, 119, '2014-04-01 00:42:20.000000', 'temperatura', 526.0000, 'ºC'),
	(269950, 119, '2014-04-01 00:42:21.000000', 'temperatura', 842.0000, 'ºC'),
	(269951, 119, '2014-04-01 00:42:22.000000', 'temperatura', 234.0000, 'ºC'),
	(269952, 119, '2014-04-01 00:42:23.000000', 'temperatura', 1043.0000, 'ºC'),
	(269953, 119, '2014-04-01 00:42:24.000000', 'temperatura', 915.0000, 'ºC'),
	(269954, 119, '2014-04-01 00:42:25.000000', 'temperatura', 245.0000, 'ºC'),
	(269955, 119, '2014-04-01 00:42:26.000000', 'temperatura', 879.0000, 'ºC'),
	(269956, 119, '2014-04-01 00:42:27.000000', 'temperatura', 64.0000, 'ºC'),
	(269957, 119, '2014-04-01 00:42:28.000000', 'temperatura', 81.0000, 'ºC'),
	(269958, 119, '2014-04-01 00:42:29.000000', 'temperatura', 214.0000, 'ºC'),
	(269959, 119, '2014-04-01 00:42:30.000000', 'temperatura', 828.0000, 'ºC'),
	(269960, 119, '2014-04-01 00:42:31.000000', 'temperatura', 1097.0000, 'ºC'),
	(269961, 119, '2014-04-01 00:42:32.000000', 'temperatura', 603.0000, 'ºC'),
	(269962, 119, '2014-04-01 00:42:33.000000', 'temperatura', 926.0000, 'ºC'),
	(269963, 119, '2014-04-01 00:42:34.000000', 'temperatura', 418.0000, 'ºC'),
	(269964, 119, '2014-04-01 00:42:35.000000', 'temperatura', 516.0000, 'ºC'),
	(269965, 119, '2014-04-01 00:42:36.000000', 'temperatura', 124.0000, 'ºC'),
	(269966, 119, '2014-04-01 00:42:37.000000', 'temperatura', 273.0000, 'ºC'),
	(269967, 119, '2014-04-01 00:42:38.000000', 'temperatura', 993.0000, 'ºC'),
	(269968, 119, '2014-04-01 00:42:39.000000', 'temperatura', 546.0000, 'ºC'),
	(269969, 119, '2014-04-01 00:42:40.000000', 'temperatura', 952.0000, 'ºC'),
	(269970, 119, '2014-04-01 00:42:41.000000', 'temperatura', 725.0000, 'ºC'),
	(269971, 119, '2014-04-01 00:42:42.000000', 'temperatura', 766.0000, 'ºC'),
	(269972, 119, '2014-04-01 00:42:43.000000', 'temperatura', 458.0000, 'ºC'),
	(269973, 119, '2014-04-01 00:42:44.000000', 'temperatura', 1192.0000, 'ºC'),
	(269974, 119, '2014-04-01 00:42:45.000000', 'temperatura', 985.0000, 'ºC'),
	(269975, 119, '2014-04-01 00:42:46.000000', 'temperatura', 150.0000, 'ºC'),
	(269976, 119, '2014-04-01 00:42:47.000000', 'temperatura', 196.0000, 'ºC'),
	(269977, 119, '2014-04-01 00:42:48.000000', 'temperatura', 528.0000, 'ºC'),
	(269978, 119, '2014-04-01 00:42:49.000000', 'temperatura', 856.0000, 'ºC'),
	(269979, 119, '2014-04-01 00:42:50.000000', 'temperatura', 294.0000, 'ºC'),
	(269980, 119, '2014-04-01 00:42:51.000000', 'temperatura', 105.0000, 'ºC'),
	(269981, 119, '2014-04-01 00:42:52.000000', 'temperatura', 841.0000, 'ºC'),
	(269982, 119, '2014-04-01 00:42:53.000000', 'temperatura', 293.0000, 'ºC'),
	(269983, 119, '2014-04-01 00:42:54.000000', 'temperatura', 140.0000, 'ºC'),
	(269984, 119, '2014-04-01 00:42:55.000000', 'temperatura', 1023.0000, 'ºC'),
	(269985, 119, '2014-04-01 00:42:56.000000', 'temperatura', 1096.0000, 'ºC'),
	(269986, 119, '2014-04-01 00:42:57.000000', 'temperatura', 11.0000, 'ºC'),
	(269987, 119, '2014-04-01 00:42:58.000000', 'temperatura', 366.0000, 'ºC'),
	(269988, 119, '2014-04-01 00:42:59.000000', 'temperatura', 600.0000, 'ºC'),
	(269989, 119, '2014-04-01 00:43:00.000000', 'temperatura', 700.0000, 'ºC'),
	(269990, 119, '2014-04-01 00:43:01.000000', 'temperatura', 503.0000, 'ºC'),
	(269991, 119, '2014-04-01 00:43:02.000000', 'temperatura', 414.0000, 'ºC'),
	(269992, 119, '2014-04-01 00:43:03.000000', 'temperatura', 564.0000, 'ºC'),
	(269993, 119, '2014-04-01 00:43:04.000000', 'temperatura', 376.0000, 'ºC'),
	(269994, 119, '2014-04-01 00:43:05.000000', 'temperatura', 190.0000, 'ºC'),
	(269995, 119, '2014-04-01 00:43:06.000000', 'temperatura', 1021.0000, 'ºC'),
	(269996, 119, '2014-04-01 00:43:07.000000', 'temperatura', 937.0000, 'ºC'),
	(269997, 119, '2014-04-01 00:43:08.000000', 'temperatura', 422.0000, 'ºC'),
	(269998, 119, '2014-04-01 00:43:09.000000', 'temperatura', 501.0000, 'ºC'),
	(269999, 119, '2014-04-01 00:43:10.000000', 'temperatura', 39.0000, 'ºC'),
	(270000, 119, '2014-04-01 00:43:11.000000', 'temperatura', 1093.0000, 'ºC'),
	(270001, 119, '2014-04-01 00:43:12.000000', 'temperatura', 546.0000, 'ºC'),
	(270002, 119, '2014-04-01 00:43:13.000000', 'temperatura', 652.0000, 'ºC'),
	(270003, 119, '2014-04-01 00:43:14.000000', 'temperatura', 422.0000, 'ºC'),
	(270004, 119, '2014-04-01 00:43:15.000000', 'temperatura', 157.0000, 'ºC'),
	(270005, 119, '2014-04-01 00:43:16.000000', 'temperatura', 717.0000, 'ºC'),
	(270006, 119, '2014-04-01 00:43:17.000000', 'temperatura', 716.0000, 'ºC'),
	(270007, 119, '2014-04-01 00:43:18.000000', 'temperatura', 231.0000, 'ºC'),
	(270008, 119, '2014-04-01 00:43:19.000000', 'temperatura', 207.0000, 'ºC'),
	(270009, 119, '2014-04-01 00:43:20.000000', 'temperatura', 340.0000, 'ºC'),
	(270010, 119, '2014-04-01 00:43:21.000000', 'temperatura', 1080.0000, 'ºC'),
	(270011, 119, '2014-04-01 00:43:22.000000', 'temperatura', 781.0000, 'ºC'),
	(270012, 119, '2014-04-01 00:43:23.000000', 'temperatura', 665.0000, 'ºC'),
	(270013, 119, '2014-04-01 00:43:24.000000', 'temperatura', 983.0000, 'ºC'),
	(270014, 119, '2014-04-01 00:43:25.000000', 'temperatura', 519.0000, 'ºC'),
	(270015, 119, '2014-04-01 00:43:26.000000', 'temperatura', 848.0000, 'ºC'),
	(270016, 119, '2014-04-01 00:43:27.000000', 'temperatura', 284.0000, 'ºC'),
	(270017, 119, '2014-04-01 00:43:28.000000', 'temperatura', 76.0000, 'ºC'),
	(270018, 119, '2014-04-01 00:43:29.000000', 'temperatura', 730.0000, 'ºC'),
	(270019, 119, '2014-04-01 00:43:30.000000', 'temperatura', 1022.0000, 'ºC'),
	(270020, 119, '2014-04-01 00:43:31.000000', 'temperatura', 518.0000, 'ºC'),
	(270021, 119, '2014-04-01 00:43:32.000000', 'temperatura', 728.0000, 'ºC'),
	(270022, 119, '2014-04-01 00:43:33.000000', 'temperatura', 884.0000, 'ºC'),
	(270023, 119, '2014-04-01 00:43:34.000000', 'temperatura', 1039.0000, 'ºC'),
	(270024, 119, '2014-04-01 00:43:35.000000', 'temperatura', 142.0000, 'ºC'),
	(270025, 119, '2014-04-01 00:43:36.000000', 'temperatura', 1192.0000, 'ºC'),
	(270026, 119, '2014-04-01 00:43:37.000000', 'temperatura', 736.0000, 'ºC'),
	(270027, 119, '2014-04-01 00:43:38.000000', 'temperatura', 103.0000, 'ºC'),
	(270028, 119, '2014-04-01 00:43:39.000000', 'temperatura', 710.0000, 'ºC'),
	(270029, 119, '2014-04-01 00:43:40.000000', 'temperatura', 840.0000, 'ºC'),
	(270030, 119, '2014-04-01 00:43:41.000000', 'temperatura', 872.0000, 'ºC'),
	(270031, 119, '2014-04-01 00:43:42.000000', 'temperatura', 640.0000, 'ºC'),
	(270032, 119, '2014-04-01 00:43:43.000000', 'temperatura', 583.0000, 'ºC'),
	(270033, 119, '2014-04-01 00:43:44.000000', 'temperatura', 996.0000, 'ºC'),
	(270034, 119, '2014-04-01 00:43:45.000000', 'temperatura', 831.0000, 'ºC'),
	(270035, 119, '2014-04-01 00:43:46.000000', 'temperatura', 1170.0000, 'ºC'),
	(270036, 119, '2014-04-01 00:43:47.000000', 'temperatura', 957.0000, 'ºC'),
	(270037, 119, '2014-04-01 00:43:48.000000', 'temperatura', 74.0000, 'ºC'),
	(270038, 119, '2014-04-01 00:43:49.000000', 'temperatura', 1099.0000, 'ºC'),
	(270039, 119, '2014-04-01 00:43:50.000000', 'temperatura', 473.0000, 'ºC'),
	(270040, 119, '2014-04-01 00:43:51.000000', 'temperatura', 268.0000, 'ºC'),
	(270041, 119, '2014-04-01 00:43:52.000000', 'temperatura', 1123.0000, 'ºC'),
	(270042, 119, '2014-04-01 00:43:53.000000', 'temperatura', 11.0000, 'ºC'),
	(270043, 119, '2014-04-01 00:43:54.000000', 'temperatura', 287.0000, 'ºC'),
	(270044, 119, '2014-04-01 00:43:55.000000', 'temperatura', 203.0000, 'ºC'),
	(270045, 119, '2014-04-01 00:43:56.000000', 'temperatura', 152.0000, 'ºC'),
	(270046, 119, '2014-04-01 00:43:57.000000', 'temperatura', 153.0000, 'ºC'),
	(270047, 119, '2014-04-01 00:43:58.000000', 'temperatura', 310.0000, 'ºC'),
	(270048, 119, '2014-04-01 00:43:59.000000', 'temperatura', 1092.0000, 'ºC'),
	(270049, 119, '2014-04-01 00:44:00.000000', 'temperatura', 930.0000, 'ºC'),
	(270050, 119, '2014-04-01 00:44:01.000000', 'temperatura', 174.0000, 'ºC'),
	(270051, 119, '2014-04-01 00:44:02.000000', 'temperatura', 480.0000, 'ºC'),
	(270052, 119, '2014-04-01 00:44:03.000000', 'temperatura', 680.0000, 'ºC'),
	(270053, 119, '2014-04-01 00:44:04.000000', 'temperatura', 759.0000, 'ºC'),
	(270054, 119, '2014-04-01 00:44:05.000000', 'temperatura', 555.0000, 'ºC'),
	(270055, 119, '2014-04-01 00:44:06.000000', 'temperatura', 498.0000, 'ºC'),
	(270056, 119, '2014-04-01 00:44:07.000000', 'temperatura', 826.0000, 'ºC'),
	(270057, 119, '2014-04-01 00:44:08.000000', 'temperatura', 236.0000, 'ºC'),
	(270058, 119, '2014-04-01 00:44:09.000000', 'temperatura', 1102.0000, 'ºC'),
	(270059, 119, '2014-04-01 00:44:10.000000', 'temperatura', 2.0000, 'ºC'),
	(270060, 119, '2014-04-01 00:44:11.000000', 'temperatura', 304.0000, 'ºC'),
	(270061, 119, '2014-04-01 00:44:12.000000', 'temperatura', 316.0000, 'ºC'),
	(270062, 119, '2014-04-01 00:44:13.000000', 'temperatura', 668.0000, 'ºC'),
	(270063, 119, '2014-04-01 00:44:14.000000', 'temperatura', 1191.0000, 'ºC'),
	(270064, 119, '2014-04-01 00:44:15.000000', 'temperatura', 352.0000, 'ºC'),
	(270065, 119, '2014-04-01 00:44:16.000000', 'temperatura', 590.0000, 'ºC'),
	(270066, 119, '2014-04-01 00:44:17.000000', 'temperatura', 693.0000, 'ºC'),
	(270067, 119, '2014-04-01 00:44:18.000000', 'temperatura', 495.0000, 'ºC'),
	(270068, 119, '2014-04-01 00:44:19.000000', 'temperatura', 399.0000, 'ºC'),
	(270069, 119, '2014-04-01 00:44:20.000000', 'temperatura', 509.0000, 'ºC'),
	(270070, 119, '2014-04-01 00:44:21.000000', 'temperatura', 147.0000, 'ºC'),
	(270071, 119, '2014-04-01 00:44:22.000000', 'temperatura', 408.0000, 'ºC'),
	(270072, 119, '2014-04-01 00:44:23.000000', 'temperatura', 402.0000, 'ºC'),
	(270073, 119, '2014-04-01 00:44:24.000000', 'temperatura', 784.0000, 'ºC'),
	(270074, 119, '2014-04-01 00:44:25.000000', 'temperatura', 316.0000, 'ºC'),
	(270075, 119, '2014-04-01 00:44:26.000000', 'temperatura', 429.0000, 'ºC'),
	(270076, 119, '2014-04-01 00:44:27.000000', 'temperatura', 1195.0000, 'ºC'),
	(270077, 119, '2014-04-01 00:44:28.000000', 'temperatura', 1091.0000, 'ºC'),
	(270078, 119, '2014-04-01 00:44:29.000000', 'temperatura', 668.0000, 'ºC'),
	(270079, 119, '2014-04-01 00:44:30.000000', 'temperatura', 69.0000, 'ºC'),
	(270080, 119, '2014-04-01 00:44:31.000000', 'temperatura', 740.0000, 'ºC'),
	(270081, 119, '2014-04-01 00:44:32.000000', 'temperatura', 1094.0000, 'ºC'),
	(270082, 119, '2014-04-01 00:44:33.000000', 'temperatura', 851.0000, 'ºC'),
	(270083, 119, '2014-04-01 00:44:34.000000', 'temperatura', 972.0000, 'ºC'),
	(270084, 119, '2014-04-01 00:44:35.000000', 'temperatura', 1109.0000, 'ºC'),
	(270085, 119, '2014-04-01 00:44:36.000000', 'temperatura', 230.0000, 'ºC'),
	(270086, 119, '2014-04-01 00:44:37.000000', 'temperatura', 221.0000, 'ºC'),
	(270087, 119, '2014-04-01 00:44:38.000000', 'temperatura', 418.0000, 'ºC'),
	(270088, 119, '2014-04-01 00:44:39.000000', 'temperatura', 225.0000, 'ºC'),
	(270089, 119, '2014-04-01 00:44:40.000000', 'temperatura', 1071.0000, 'ºC'),
	(270090, 119, '2014-04-01 00:44:41.000000', 'temperatura', 1083.0000, 'ºC'),
	(270091, 119, '2014-04-01 00:44:42.000000', 'temperatura', 1002.0000, 'ºC'),
	(270092, 119, '2014-04-01 00:44:43.000000', 'temperatura', 561.0000, 'ºC'),
	(270093, 119, '2014-04-01 00:44:44.000000', 'temperatura', 1002.0000, 'ºC'),
	(270094, 119, '2014-04-01 00:44:45.000000', 'temperatura', 924.0000, 'ºC'),
	(270095, 119, '2014-04-01 00:44:46.000000', 'temperatura', 415.0000, 'ºC'),
	(270096, 119, '2014-04-01 00:44:47.000000', 'temperatura', 506.0000, 'ºC'),
	(270097, 119, '2014-04-01 00:44:48.000000', 'temperatura', 83.0000, 'ºC'),
	(270098, 119, '2014-04-01 00:44:49.000000', 'temperatura', 100.0000, 'ºC'),
	(270099, 119, '2014-04-01 00:44:50.000000', 'temperatura', 252.0000, 'ºC'),
	(270100, 119, '2014-04-01 00:44:51.000000', 'temperatura', 958.0000, 'ºC'),
	(270101, 119, '2014-04-01 00:44:52.000000', 'temperatura', 436.0000, 'ºC'),
	(270102, 119, '2014-04-01 00:44:53.000000', 'temperatura', 507.0000, 'ºC'),
	(270103, 119, '2014-04-01 00:44:54.000000', 'temperatura', 29.0000, 'ºC'),
	(270104, 119, '2014-04-01 00:44:55.000000', 'temperatura', 1021.0000, 'ºC'),
	(270105, 119, '2014-04-01 00:44:56.000000', 'temperatura', 220.0000, 'ºC'),
	(270106, 119, '2014-04-01 00:44:57.000000', 'temperatura', 438.0000, 'ºC'),
	(270107, 119, '2014-04-01 00:44:58.000000', 'temperatura', 329.0000, 'ºC'),
	(270108, 119, '2014-04-01 00:44:59.000000', 'temperatura', 332.0000, 'ºC'),
	(270109, 119, '2014-04-01 00:45:00.000000', 'temperatura', 673.0000, 'ºC'),
	(270110, 119, '2014-04-01 00:45:01.000000', 'temperatura', 1170.0000, 'ºC'),
	(270111, 119, '2014-04-01 00:45:02.000000', 'temperatura', 233.0000, 'ºC'),
	(270112, 119, '2014-04-01 00:45:03.000000', 'temperatura', 56.0000, 'ºC'),
	(270113, 119, '2014-04-01 00:45:04.000000', 'temperatura', 779.0000, 'ºC'),
	(270114, 119, '2014-04-01 00:45:05.000000', 'temperatura', 128.0000, 'ºC'),
	(270115, 119, '2014-04-01 00:45:06.000000', 'temperatura', 706.0000, 'ºC'),
	(270116, 119, '2014-04-01 00:45:07.000000', 'temperatura', 743.0000, 'ºC'),
	(270117, 119, '2014-04-01 00:45:08.000000', 'temperatura', 400.0000, 'ºC'),
	(270118, 119, '2014-04-01 00:45:09.000000', 'temperatura', 972.0000, 'ºC'),
	(270119, 119, '2014-04-01 00:45:10.000000', 'temperatura', 61.0000, 'ºC'),
	(270120, 119, '2014-04-01 00:45:11.000000', 'temperatura', 988.0000, 'ºC'),
	(270121, 119, '2014-04-01 00:45:12.000000', 'temperatura', 1157.0000, 'ºC'),
	(270122, 119, '2014-04-01 00:45:13.000000', 'temperatura', 421.0000, 'ºC'),
	(270123, 119, '2014-04-01 00:45:14.000000', 'temperatura', 1036.0000, 'ºC'),
	(270124, 119, '2014-04-01 00:45:15.000000', 'temperatura', 319.0000, 'ºC'),
	(270125, 119, '2014-04-01 00:45:16.000000', 'temperatura', 885.0000, 'ºC'),
	(270126, 119, '2014-04-01 00:45:17.000000', 'temperatura', 1070.0000, 'ºC'),
	(270127, 119, '2014-04-01 00:45:18.000000', 'temperatura', 294.0000, 'ºC'),
	(270128, 119, '2014-04-01 00:45:19.000000', 'temperatura', 663.0000, 'ºC'),
	(270129, 119, '2014-04-01 00:45:20.000000', 'temperatura', 34.0000, 'ºC'),
	(270130, 119, '2014-04-01 00:45:21.000000', 'temperatura', 579.0000, 'ºC'),
	(270131, 119, '2014-04-01 00:45:22.000000', 'temperatura', 392.0000, 'ºC'),
	(270132, 119, '2014-04-01 00:45:23.000000', 'temperatura', 227.0000, 'ºC'),
	(270133, 119, '2014-04-01 00:45:24.000000', 'temperatura', 1156.0000, 'ºC'),
	(270134, 119, '2014-04-01 00:45:25.000000', 'temperatura', 302.0000, 'ºC'),
	(270135, 119, '2014-04-01 00:45:26.000000', 'temperatura', 441.0000, 'ºC'),
	(270136, 119, '2014-04-01 00:45:27.000000', 'temperatura', 101.0000, 'ºC'),
	(270137, 119, '2014-04-01 00:45:28.000000', 'temperatura', 384.0000, 'ºC'),
	(270138, 119, '2014-04-01 00:45:29.000000', 'temperatura', 414.0000, 'ºC'),
	(270139, 119, '2014-04-01 00:45:30.000000', 'temperatura', 921.0000, 'ºC'),
	(270140, 119, '2014-04-01 00:45:31.000000', 'temperatura', 961.0000, 'ºC'),
	(270141, 119, '2014-04-01 00:45:32.000000', 'temperatura', 843.0000, 'ºC'),
	(270142, 119, '2014-04-01 00:45:33.000000', 'temperatura', 133.0000, 'ºC'),
	(270143, 119, '2014-04-01 00:45:34.000000', 'temperatura', 537.0000, 'ºC'),
	(270144, 119, '2014-04-01 00:45:35.000000', 'temperatura', 1085.0000, 'ºC'),
	(270145, 119, '2014-04-01 00:45:36.000000', 'temperatura', 215.0000, 'ºC'),
	(270146, 119, '2014-04-01 00:45:37.000000', 'temperatura', 221.0000, 'ºC'),
	(270147, 119, '2014-04-01 00:45:38.000000', 'temperatura', 462.0000, 'ºC'),
	(270148, 119, '2014-04-01 00:45:39.000000', 'temperatura', 447.0000, 'ºC'),
	(270149, 119, '2014-04-01 00:45:40.000000', 'temperatura', 850.0000, 'ºC'),
	(270150, 119, '2014-04-01 00:45:41.000000', 'temperatura', 509.0000, 'ºC'),
	(270151, 119, '2014-04-01 00:45:42.000000', 'temperatura', 1197.0000, 'ºC'),
	(270152, 119, '2014-04-01 00:45:43.000000', 'temperatura', 856.0000, 'ºC'),
	(270153, 119, '2014-04-01 00:45:44.000000', 'temperatura', 692.0000, 'ºC'),
	(270154, 119, '2014-04-01 00:45:45.000000', 'temperatura', 893.0000, 'ºC'),
	(270155, 119, '2014-04-01 00:45:46.000000', 'temperatura', 1187.0000, 'ºC'),
	(270156, 119, '2014-04-01 00:45:47.000000', 'temperatura', 857.0000, 'ºC'),
	(270157, 119, '2014-04-01 00:45:48.000000', 'temperatura', 726.0000, 'ºC'),
	(270158, 119, '2014-04-01 00:45:49.000000', 'temperatura', 1059.0000, 'ºC'),
	(270159, 119, '2014-04-01 00:45:50.000000', 'temperatura', 718.0000, 'ºC'),
	(270160, 119, '2014-04-01 00:45:51.000000', 'temperatura', 413.0000, 'ºC'),
	(270161, 119, '2014-04-01 00:45:52.000000', 'temperatura', 1112.0000, 'ºC'),
	(270162, 119, '2014-04-01 00:45:53.000000', 'temperatura', 720.0000, 'ºC'),
	(270163, 119, '2014-04-01 00:45:54.000000', 'temperatura', 265.0000, 'ºC'),
	(270164, 119, '2014-04-01 00:45:55.000000', 'temperatura', 364.0000, 'ºC'),
	(270165, 119, '2014-04-01 00:45:56.000000', 'temperatura', 1026.0000, 'ºC'),
	(270166, 119, '2014-04-01 00:45:57.000000', 'temperatura', 437.0000, 'ºC'),
	(270167, 119, '2014-04-01 00:45:58.000000', 'temperatura', 310.0000, 'ºC'),
	(270168, 119, '2014-04-01 00:45:59.000000', 'temperatura', 240.0000, 'ºC'),
	(270169, 119, '2014-04-01 00:46:00.000000', 'temperatura', 271.0000, 'ºC'),
	(270170, 119, '2014-04-01 00:46:01.000000', 'temperatura', 633.0000, 'ºC'),
	(270171, 119, '2014-04-01 00:46:02.000000', 'temperatura', 1152.0000, 'ºC'),
	(270172, 119, '2014-04-01 00:46:03.000000', 'temperatura', 263.0000, 'ºC'),
	(270173, 119, '2014-04-01 00:46:04.000000', 'temperatura', 258.0000, 'ºC'),
	(270174, 119, '2014-04-01 00:46:05.000000', 'temperatura', 503.0000, 'ºC'),
	(270175, 119, '2014-04-01 00:46:06.000000', 'temperatura', 541.0000, 'ºC'),
	(270176, 119, '2014-04-01 00:46:07.000000', 'temperatura', 1196.0000, 'ºC'),
	(270177, 119, '2014-04-01 00:46:08.000000', 'temperatura', 757.0000, 'ºC'),
	(270178, 119, '2014-04-01 00:46:09.000000', 'temperatura', 199.0000, 'ºC'),
	(270179, 119, '2014-04-01 00:46:10.000000', 'temperatura', 1124.0000, 'ºC'),
	(270180, 119, '2014-04-01 00:46:11.000000', 'temperatura', 223.0000, 'ºC'),
	(270181, 119, '2014-04-01 00:46:12.000000', 'temperatura', 146.0000, 'ºC'),
	(270182, 119, '2014-04-01 00:46:13.000000', 'temperatura', 59.0000, 'ºC'),
	(270183, 119, '2014-04-01 00:46:14.000000', 'temperatura', 1059.0000, 'ºC'),
	(270184, 119, '2014-04-01 00:46:15.000000', 'temperatura', 319.0000, 'ºC'),
	(270185, 119, '2014-04-01 00:46:16.000000', 'temperatura', 818.0000, 'ºC'),
	(270186, 119, '2014-04-01 00:46:17.000000', 'temperatura', 734.0000, 'ºC'),
	(270187, 119, '2014-04-01 00:46:18.000000', 'temperatura', 17.0000, 'ºC'),
	(270188, 119, '2014-04-01 00:46:19.000000', 'temperatura', 282.0000, 'ºC'),
	(270189, 119, '2014-04-01 00:46:20.000000', 'temperatura', 162.0000, 'ºC'),
	(270190, 119, '2014-04-01 00:46:21.000000', 'temperatura', 1162.0000, 'ºC'),
	(270191, 119, '2014-04-01 00:46:22.000000', 'temperatura', 526.0000, 'ºC'),
	(270192, 119, '2014-04-01 00:46:23.000000', 'temperatura', 343.0000, 'ºC'),
	(270193, 119, '2014-04-01 00:46:24.000000', 'temperatura', 140.0000, 'ºC'),
	(270194, 119, '2014-04-01 00:46:25.000000', 'temperatura', 869.0000, 'ºC'),
	(270195, 119, '2014-04-01 00:46:26.000000', 'temperatura', 324.0000, 'ºC'),
	(270196, 119, '2014-04-01 00:46:27.000000', 'temperatura', 217.0000, 'ºC'),
	(270197, 119, '2014-04-01 00:46:28.000000', 'temperatura', 110.0000, 'ºC'),
	(270198, 119, '2014-04-01 00:46:29.000000', 'temperatura', 1103.0000, 'ºC'),
	(270199, 119, '2014-04-01 00:46:30.000000', 'temperatura', 383.0000, 'ºC'),
	(270200, 119, '2014-04-01 00:46:31.000000', 'temperatura', 1006.0000, 'ºC'),
	(270201, 119, '2014-04-01 00:46:32.000000', 'temperatura', 282.0000, 'ºC'),
	(270202, 119, '2014-04-01 00:46:33.000000', 'temperatura', 791.0000, 'ºC'),
	(270203, 119, '2014-04-01 00:46:34.000000', 'temperatura', 712.0000, 'ºC'),
	(270204, 119, '2014-04-01 00:46:35.000000', 'temperatura', 1187.0000, 'ºC'),
	(270205, 119, '2014-04-01 00:46:36.000000', 'temperatura', 199.0000, 'ºC'),
	(270206, 119, '2014-04-01 00:46:37.000000', 'temperatura', 1034.0000, 'ºC'),
	(270207, 119, '2014-04-01 00:46:38.000000', 'temperatura', 974.0000, 'ºC'),
	(270208, 119, '2014-04-01 00:46:39.000000', 'temperatura', 571.0000, 'ºC'),
	(270209, 119, '2014-04-01 00:46:40.000000', 'temperatura', 1130.0000, 'ºC'),
	(270210, 119, '2014-04-01 00:46:41.000000', 'temperatura', 338.0000, 'ºC'),
	(270211, 119, '2014-04-01 00:46:42.000000', 'temperatura', 700.0000, 'ºC'),
	(270212, 119, '2014-04-01 00:46:43.000000', 'temperatura', 85.0000, 'ºC'),
	(270213, 119, '2014-04-01 00:46:44.000000', 'temperatura', 727.0000, 'ºC'),
	(270214, 119, '2014-04-01 00:46:45.000000', 'temperatura', 982.0000, 'ºC'),
	(270215, 119, '2014-04-01 00:46:46.000000', 'temperatura', 329.0000, 'ºC'),
	(270216, 119, '2014-04-01 00:46:47.000000', 'temperatura', 1097.0000, 'ºC'),
	(270217, 119, '2014-04-01 00:46:48.000000', 'temperatura', 901.0000, 'ºC'),
	(270218, 119, '2014-04-01 00:46:49.000000', 'temperatura', 14.0000, 'ºC'),
	(270219, 119, '2014-04-01 00:46:50.000000', 'temperatura', 966.0000, 'ºC'),
	(270220, 119, '2014-04-01 00:46:51.000000', 'temperatura', 1190.0000, 'ºC'),
	(270221, 119, '2014-04-01 00:46:52.000000', 'temperatura', 653.0000, 'ºC'),
	(270222, 119, '2014-04-01 00:46:53.000000', 'temperatura', 897.0000, 'ºC'),
	(270223, 119, '2014-04-01 00:46:54.000000', 'temperatura', 124.0000, 'ºC'),
	(270224, 119, '2014-04-01 00:46:55.000000', 'temperatura', 332.0000, 'ºC'),
	(270225, 119, '2014-04-01 00:46:56.000000', 'temperatura', 87.0000, 'ºC'),
	(270226, 119, '2014-04-01 00:46:57.000000', 'temperatura', 640.0000, 'ºC'),
	(270227, 119, '2014-04-01 00:46:58.000000', 'temperatura', 540.0000, 'ºC'),
	(270228, 119, '2014-04-01 00:46:59.000000', 'temperatura', 778.0000, 'ºC'),
	(270229, 119, '2014-04-01 00:47:00.000000', 'temperatura', 1073.0000, 'ºC'),
	(270230, 119, '2014-04-01 00:47:01.000000', 'temperatura', 632.0000, 'ºC'),
	(270231, 119, '2014-04-01 00:47:02.000000', 'temperatura', 1140.0000, 'ºC'),
	(270232, 119, '2014-04-01 00:47:03.000000', 'temperatura', 203.0000, 'ºC'),
	(270233, 119, '2014-04-01 00:47:04.000000', 'temperatura', 1196.0000, 'ºC'),
	(270234, 119, '2014-04-01 00:47:05.000000', 'temperatura', 572.0000, 'ºC'),
	(270235, 119, '2014-04-01 00:47:06.000000', 'temperatura', 471.0000, 'ºC'),
	(270236, 119, '2014-04-01 00:47:07.000000', 'temperatura', 642.0000, 'ºC'),
	(270237, 119, '2014-04-01 00:47:08.000000', 'temperatura', 596.0000, 'ºC'),
	(270238, 119, '2014-04-01 00:47:09.000000', 'temperatura', 1054.0000, 'ºC'),
	(270239, 119, '2014-04-01 00:47:10.000000', 'temperatura', 1085.0000, 'ºC'),
	(270240, 119, '2014-04-01 00:47:11.000000', 'temperatura', 1061.0000, 'ºC'),
	(270241, 119, '2014-04-01 00:47:12.000000', 'temperatura', 850.0000, 'ºC'),
	(270242, 119, '2014-04-01 00:47:13.000000', 'temperatura', 1067.0000, 'ºC'),
	(270243, 119, '2014-04-01 00:47:14.000000', 'temperatura', 386.0000, 'ºC'),
	(270244, 119, '2014-04-01 00:47:15.000000', 'temperatura', 1128.0000, 'ºC'),
	(270245, 119, '2014-04-01 00:47:16.000000', 'temperatura', 885.0000, 'ºC'),
	(270246, 119, '2014-04-01 00:47:17.000000', 'temperatura', 1040.0000, 'ºC'),
	(270247, 119, '2014-04-01 00:47:18.000000', 'temperatura', 144.0000, 'ºC'),
	(270248, 119, '2014-04-01 00:47:19.000000', 'temperatura', 2.0000, 'ºC'),
	(270249, 119, '2014-04-01 00:47:20.000000', 'temperatura', 777.0000, 'ºC'),
	(270250, 119, '2014-04-01 00:47:21.000000', 'temperatura', 282.0000, 'ºC'),
	(270251, 119, '2014-04-01 00:47:22.000000', 'temperatura', 276.0000, 'ºC'),
	(270252, 119, '2014-04-01 00:47:23.000000', 'temperatura', 538.0000, 'ºC'),
	(270253, 119, '2014-04-01 00:47:24.000000', 'temperatura', 660.0000, 'ºC'),
	(270254, 119, '2014-04-01 00:47:25.000000', 'temperatura', 488.0000, 'ºC'),
	(270255, 119, '2014-04-01 00:47:26.000000', 'temperatura', 459.0000, 'ºC'),
	(270256, 119, '2014-04-01 00:47:27.000000', 'temperatura', 831.0000, 'ºC'),
	(270257, 119, '2014-04-01 00:47:28.000000', 'temperatura', 381.0000, 'ºC'),
	(270258, 119, '2014-04-01 00:47:29.000000', 'temperatura', 611.0000, 'ºC'),
	(270259, 119, '2014-04-01 00:47:30.000000', 'temperatura', 712.0000, 'ºC'),
	(270260, 119, '2014-04-01 00:47:31.000000', 'temperatura', 529.0000, 'ºC'),
	(270261, 119, '2014-04-01 00:47:32.000000', 'temperatura', 510.0000, 'ºC'),
	(270262, 119, '2014-04-01 00:47:33.000000', 'temperatura', 962.0000, 'ºC'),
	(270263, 119, '2014-04-01 00:47:34.000000', 'temperatura', 879.0000, 'ºC'),
	(270264, 119, '2014-04-01 00:47:35.000000', 'temperatura', 310.0000, 'ºC'),
	(270265, 119, '2014-04-01 00:47:36.000000', 'temperatura', 115.0000, 'ºC'),
	(270266, 119, '2014-04-01 00:47:37.000000', 'temperatura', 844.0000, 'ºC'),
	(270267, 119, '2014-04-01 00:47:38.000000', 'temperatura', 278.0000, 'ºC'),
	(270268, 119, '2014-04-01 00:47:39.000000', 'temperatura', 58.0000, 'ºC'),
	(270269, 119, '2014-04-01 00:47:40.000000', 'temperatura', 655.0000, 'ºC'),
	(270270, 119, '2014-04-01 00:47:41.000000', 'temperatura', 701.0000, 'ºC'),
	(270271, 119, '2014-04-01 00:47:42.000000', 'temperatura', 342.0000, 'ºC'),
	(270272, 119, '2014-04-01 00:47:43.000000', 'temperatura', 807.0000, 'ºC'),
	(270273, 119, '2014-04-01 00:47:44.000000', 'temperatura', 610.0000, 'ºC'),
	(270274, 119, '2014-04-01 00:47:45.000000', 'temperatura', 630.0000, 'ºC'),
	(270275, 119, '2014-04-01 00:47:46.000000', 'temperatura', 119.0000, 'ºC'),
	(270276, 119, '2014-04-01 00:47:47.000000', 'temperatura', 1104.0000, 'ºC'),
	(270277, 119, '2014-04-01 00:47:48.000000', 'temperatura', 366.0000, 'ºC'),
	(270278, 119, '2014-04-01 00:47:49.000000', 'temperatura', 917.0000, 'ºC'),
	(270279, 119, '2014-04-01 00:47:50.000000', 'temperatura', 1087.0000, 'ºC'),
	(270280, 119, '2014-04-01 00:47:51.000000', 'temperatura', 287.0000, 'ºC'),
	(270281, 119, '2014-04-01 00:47:52.000000', 'temperatura', 573.0000, 'ºC'),
	(270282, 119, '2014-04-01 00:47:53.000000', 'temperatura', 806.0000, 'ºC'),
	(270283, 119, '2014-04-01 00:47:54.000000', 'temperatura', 1110.0000, 'ºC'),
	(270284, 119, '2014-04-01 00:47:55.000000', 'temperatura', 734.0000, 'ºC'),
	(270285, 119, '2014-04-01 00:47:56.000000', 'temperatura', 338.0000, 'ºC'),
	(270286, 119, '2014-04-01 00:47:57.000000', 'temperatura', 691.0000, 'ºC'),
	(270287, 119, '2014-04-01 00:47:58.000000', 'temperatura', 42.0000, 'ºC'),
	(270288, 119, '2014-04-01 00:47:59.000000', 'temperatura', 535.0000, 'ºC'),
	(270289, 119, '2014-04-01 00:48:00.000000', 'temperatura', 149.0000, 'ºC'),
	(270290, 119, '2014-04-01 00:48:01.000000', 'temperatura', 340.0000, 'ºC'),
	(270291, 119, '2014-04-01 00:48:02.000000', 'temperatura', 57.0000, 'ºC'),
	(270292, 119, '2014-04-01 00:48:03.000000', 'temperatura', 462.0000, 'ºC'),
	(270293, 119, '2014-04-01 00:48:04.000000', 'temperatura', 940.0000, 'ºC'),
	(270294, 119, '2014-04-01 00:48:05.000000', 'temperatura', 916.0000, 'ºC'),
	(270295, 119, '2014-04-01 00:48:06.000000', 'temperatura', 560.0000, 'ºC'),
	(270296, 119, '2014-04-01 00:48:07.000000', 'temperatura', 54.0000, 'ºC'),
	(270297, 119, '2014-04-01 00:48:08.000000', 'temperatura', 988.0000, 'ºC'),
	(270298, 119, '2014-04-01 00:48:09.000000', 'temperatura', 1179.0000, 'ºC'),
	(270299, 119, '2014-04-01 00:48:10.000000', 'temperatura', 533.0000, 'ºC'),
	(270300, 119, '2014-04-01 00:48:11.000000', 'temperatura', 330.0000, 'ºC'),
	(270301, 119, '2014-04-01 00:48:12.000000', 'temperatura', 49.0000, 'ºC'),
	(270302, 119, '2014-04-01 00:48:13.000000', 'temperatura', 455.0000, 'ºC'),
	(270303, 119, '2014-04-01 00:48:14.000000', 'temperatura', 928.0000, 'ºC'),
	(270304, 119, '2014-04-01 00:48:15.000000', 'temperatura', 876.0000, 'ºC'),
	(270305, 119, '2014-04-01 00:48:16.000000', 'temperatura', 397.0000, 'ºC'),
	(270306, 119, '2014-04-01 00:48:17.000000', 'temperatura', 558.0000, 'ºC'),
	(270307, 119, '2014-04-01 00:48:18.000000', 'temperatura', 399.0000, 'ºC'),
	(270308, 119, '2014-04-01 00:48:19.000000', 'temperatura', 322.0000, 'ºC'),
	(270309, 119, '2014-04-01 00:48:20.000000', 'temperatura', 412.0000, 'ºC'),
	(270310, 119, '2014-04-01 00:48:21.000000', 'temperatura', 1094.0000, 'ºC'),
	(270311, 119, '2014-04-01 00:48:22.000000', 'temperatura', 636.0000, 'ºC'),
	(270312, 119, '2014-04-01 00:48:23.000000', 'temperatura', 1096.0000, 'ºC'),
	(270313, 119, '2014-04-01 00:48:24.000000', 'temperatura', 1174.0000, 'ºC'),
	(270314, 119, '2014-04-01 00:48:25.000000', 'temperatura', 181.0000, 'ºC'),
	(270315, 119, '2014-04-01 00:48:26.000000', 'temperatura', 987.0000, 'ºC'),
	(270316, 119, '2014-04-01 00:48:27.000000', 'temperatura', 789.0000, 'ºC'),
	(270317, 119, '2014-04-01 00:48:28.000000', 'temperatura', 986.0000, 'ºC'),
	(270318, 119, '2014-04-01 00:48:29.000000', 'temperatura', 162.0000, 'ºC'),
	(270319, 119, '2014-04-01 00:48:30.000000', 'temperatura', 255.0000, 'ºC'),
	(270320, 119, '2014-04-01 00:48:31.000000', 'temperatura', 789.0000, 'ºC'),
	(270321, 119, '2014-04-01 00:48:32.000000', 'temperatura', 782.0000, 'ºC'),
	(270322, 119, '2014-04-01 00:48:33.000000', 'temperatura', 342.0000, 'ºC'),
	(270323, 119, '2014-04-01 00:48:34.000000', 'temperatura', 565.0000, 'ºC'),
	(270324, 119, '2014-04-01 00:48:35.000000', 'temperatura', 598.0000, 'ºC'),
	(270325, 119, '2014-04-01 00:48:36.000000', 'temperatura', 95.0000, 'ºC'),
	(270326, 119, '2014-04-01 00:48:37.000000', 'temperatura', 1082.0000, 'ºC'),
	(270327, 119, '2014-04-01 00:48:38.000000', 'temperatura', 326.0000, 'ºC'),
	(270328, 119, '2014-04-01 00:48:39.000000', 'temperatura', 785.0000, 'ºC'),
	(270329, 119, '2014-04-01 00:48:40.000000', 'temperatura', 548.0000, 'ºC'),
	(270330, 119, '2014-04-01 00:48:41.000000', 'temperatura', 385.0000, 'ºC'),
	(270331, 119, '2014-04-01 00:48:42.000000', 'temperatura', 283.0000, 'ºC'),
	(270332, 119, '2014-04-01 00:48:43.000000', 'temperatura', 261.0000, 'ºC'),
	(270333, 119, '2014-04-01 00:48:44.000000', 'temperatura', 454.0000, 'ºC'),
	(270334, 119, '2014-04-01 00:48:45.000000', 'temperatura', 287.0000, 'ºC'),
	(270335, 119, '2014-04-01 00:48:46.000000', 'temperatura', 72.0000, 'ºC'),
	(270336, 119, '2014-04-01 00:48:47.000000', 'temperatura', 703.0000, 'ºC'),
	(270337, 119, '2014-04-01 00:48:48.000000', 'temperatura', 898.0000, 'ºC'),
	(270338, 119, '2014-04-01 00:48:49.000000', 'temperatura', 1183.0000, 'ºC'),
	(270339, 119, '2014-04-01 00:48:50.000000', 'temperatura', 819.0000, 'ºC'),
	(270340, 119, '2014-04-01 00:48:51.000000', 'temperatura', 548.0000, 'ºC'),
	(270341, 119, '2014-04-01 00:48:52.000000', 'temperatura', 284.0000, 'ºC'),
	(270342, 119, '2014-04-01 00:48:53.000000', 'temperatura', 976.0000, 'ºC'),
	(270343, 119, '2014-04-01 00:48:54.000000', 'temperatura', 429.0000, 'ºC'),
	(270344, 119, '2014-04-01 00:48:55.000000', 'temperatura', 418.0000, 'ºC'),
	(270345, 119, '2014-04-01 00:48:56.000000', 'temperatura', 803.0000, 'ºC'),
	(270346, 119, '2014-04-01 00:48:57.000000', 'temperatura', 362.0000, 'ºC'),
	(270347, 119, '2014-04-01 00:48:58.000000', 'temperatura', 600.0000, 'ºC'),
	(270348, 119, '2014-04-01 00:48:59.000000', 'temperatura', 716.0000, 'ºC'),
	(270349, 119, '2014-04-01 00:49:00.000000', 'temperatura', 579.0000, 'ºC'),
	(270350, 119, '2014-04-01 00:49:01.000000', 'temperatura', 749.0000, 'ºC'),
	(270351, 119, '2014-04-01 00:49:02.000000', 'temperatura', 806.0000, 'ºC'),
	(270352, 119, '2014-04-01 00:49:03.000000', 'temperatura', 585.0000, 'ºC'),
	(270353, 119, '2014-04-01 00:49:04.000000', 'temperatura', 509.0000, 'ºC'),
	(270354, 119, '2014-04-01 00:49:05.000000', 'temperatura', 790.0000, 'ºC'),
	(270355, 119, '2014-04-01 00:49:06.000000', 'temperatura', 21.0000, 'ºC'),
	(270356, 119, '2014-04-01 00:49:07.000000', 'temperatura', 138.0000, 'ºC'),
	(270357, 119, '2014-04-01 00:49:08.000000', 'temperatura', 625.0000, 'ºC'),
	(270358, 119, '2014-04-01 00:49:09.000000', 'temperatura', 314.0000, 'ºC'),
	(270359, 119, '2014-04-01 00:49:10.000000', 'temperatura', 895.0000, 'ºC'),
	(270360, 119, '2014-04-01 00:49:11.000000', 'temperatura', 1133.0000, 'ºC'),
	(270361, 119, '2014-04-01 00:49:12.000000', 'temperatura', 583.0000, 'ºC'),
	(270362, 119, '2014-04-01 00:49:13.000000', 'temperatura', 713.0000, 'ºC'),
	(270363, 119, '2014-04-01 00:49:14.000000', 'temperatura', 618.0000, 'ºC'),
	(270364, 119, '2014-04-01 00:49:15.000000', 'temperatura', 951.0000, 'ºC'),
	(270365, 119, '2014-04-01 00:49:16.000000', 'temperatura', 503.0000, 'ºC'),
	(270366, 119, '2014-04-01 00:49:17.000000', 'temperatura', 861.0000, 'ºC'),
	(270367, 119, '2014-04-01 00:49:18.000000', 'temperatura', 398.0000, 'ºC'),
	(270368, 119, '2014-04-01 00:49:19.000000', 'temperatura', 607.0000, 'ºC'),
	(270369, 119, '2014-04-01 00:49:20.000000', 'temperatura', 642.0000, 'ºC'),
	(270370, 119, '2014-04-01 00:49:21.000000', 'temperatura', 188.0000, 'ºC'),
	(270371, 119, '2014-04-01 00:49:22.000000', 'temperatura', 217.0000, 'ºC'),
	(270372, 119, '2014-04-01 00:49:23.000000', 'temperatura', 519.0000, 'ºC'),
	(270373, 119, '2014-04-01 00:49:24.000000', 'temperatura', 747.0000, 'ºC'),
	(270374, 119, '2014-04-01 00:49:25.000000', 'temperatura', 978.0000, 'ºC'),
	(270375, 119, '2014-04-01 00:49:26.000000', 'temperatura', 247.0000, 'ºC'),
	(270376, 119, '2014-04-01 00:49:27.000000', 'temperatura', 704.0000, 'ºC'),
	(270377, 119, '2014-04-01 00:49:28.000000', 'temperatura', 379.0000, 'ºC'),
	(270378, 119, '2014-04-01 00:49:29.000000', 'temperatura', 983.0000, 'ºC'),
	(270379, 119, '2014-04-01 00:49:30.000000', 'temperatura', 180.0000, 'ºC'),
	(270380, 119, '2014-04-01 00:49:31.000000', 'temperatura', 352.0000, 'ºC'),
	(270381, 119, '2014-04-01 00:49:32.000000', 'temperatura', 19.0000, 'ºC'),
	(270382, 119, '2014-04-01 00:49:33.000000', 'temperatura', 240.0000, 'ºC'),
	(270383, 119, '2014-04-01 00:49:34.000000', 'temperatura', 1142.0000, 'ºC'),
	(270384, 119, '2014-04-01 00:49:35.000000', 'temperatura', 191.0000, 'ºC'),
	(270385, 119, '2014-04-01 00:49:36.000000', 'temperatura', 1131.0000, 'ºC'),
	(270386, 119, '2014-04-01 00:49:37.000000', 'temperatura', 281.0000, 'ºC'),
	(270387, 119, '2014-04-01 00:49:38.000000', 'temperatura', 413.0000, 'ºC'),
	(270388, 119, '2014-04-01 00:49:39.000000', 'temperatura', 24.0000, 'ºC'),
	(270389, 119, '2014-04-01 00:49:40.000000', 'temperatura', 80.0000, 'ºC'),
	(270390, 119, '2014-04-01 00:49:41.000000', 'temperatura', 329.0000, 'ºC'),
	(270391, 119, '2014-04-01 00:49:42.000000', 'temperatura', 203.0000, 'ºC'),
	(270392, 119, '2014-04-01 00:49:43.000000', 'temperatura', 31.0000, 'ºC'),
	(270393, 119, '2014-04-01 00:49:44.000000', 'temperatura', 747.0000, 'ºC'),
	(270394, 119, '2014-04-01 00:49:45.000000', 'temperatura', 43.0000, 'ºC'),
	(270395, 119, '2014-04-01 00:49:46.000000', 'temperatura', 372.0000, 'ºC'),
	(270396, 119, '2014-04-01 00:49:47.000000', 'temperatura', 531.0000, 'ºC'),
	(270397, 119, '2014-04-01 00:49:48.000000', 'temperatura', 342.0000, 'ºC'),
	(270398, 119, '2014-04-01 00:49:49.000000', 'temperatura', 116.0000, 'ºC'),
	(270399, 119, '2014-04-01 00:49:50.000000', 'temperatura', 755.0000, 'ºC'),
	(270400, 119, '2014-04-01 00:49:51.000000', 'temperatura', 1028.0000, 'ºC'),
	(270401, 119, '2014-04-01 00:49:52.000000', 'temperatura', 475.0000, 'ºC'),
	(270402, 119, '2014-04-01 00:49:53.000000', 'temperatura', 491.0000, 'ºC'),
	(270403, 119, '2014-04-01 00:49:54.000000', 'temperatura', 1031.0000, 'ºC'),
	(270404, 119, '2014-04-01 00:49:55.000000', 'temperatura', 82.0000, 'ºC'),
	(270405, 119, '2014-04-01 00:49:56.000000', 'temperatura', 916.0000, 'ºC'),
	(270406, 119, '2014-04-01 00:49:57.000000', 'temperatura', 736.0000, 'ºC'),
	(270407, 119, '2014-04-01 00:49:58.000000', 'temperatura', 931.0000, 'ºC'),
	(270408, 119, '2014-04-01 00:49:59.000000', 'temperatura', 50.0000, 'ºC'),
	(270409, 119, '2014-04-01 00:50:00.000000', 'temperatura', 1056.0000, 'ºC'),
	(270410, 119, '2014-04-01 00:50:01.000000', 'temperatura', 332.0000, 'ºC'),
	(270411, 119, '2014-04-01 00:50:02.000000', 'temperatura', 892.0000, 'ºC'),
	(270412, 119, '2014-04-01 00:50:03.000000', 'temperatura', 1063.0000, 'ºC'),
	(270413, 119, '2014-04-01 00:50:04.000000', 'temperatura', 240.0000, 'ºC'),
	(270414, 119, '2014-04-01 00:50:05.000000', 'temperatura', 410.0000, 'ºC'),
	(270415, 119, '2014-04-01 00:50:06.000000', 'temperatura', 133.0000, 'ºC'),
	(270416, 119, '2014-04-01 00:50:07.000000', 'temperatura', 635.0000, 'ºC'),
	(270417, 119, '2014-04-01 00:50:08.000000', 'temperatura', 374.0000, 'ºC'),
	(270418, 119, '2014-04-01 00:50:09.000000', 'temperatura', 1168.0000, 'ºC'),
	(270419, 119, '2014-04-01 00:50:10.000000', 'temperatura', 1118.0000, 'ºC'),
	(270420, 119, '2014-04-01 00:50:11.000000', 'temperatura', 887.0000, 'ºC'),
	(270421, 119, '2014-04-01 00:50:12.000000', 'temperatura', 1079.0000, 'ºC'),
	(270422, 119, '2014-04-01 00:50:13.000000', 'temperatura', 337.0000, 'ºC'),
	(270423, 119, '2014-04-01 00:50:14.000000', 'temperatura', 849.0000, 'ºC'),
	(270424, 119, '2014-04-01 00:50:15.000000', 'temperatura', 834.0000, 'ºC'),
	(270425, 119, '2014-04-01 00:50:16.000000', 'temperatura', 423.0000, 'ºC'),
	(270426, 119, '2014-04-01 00:50:17.000000', 'temperatura', 812.0000, 'ºC'),
	(270427, 119, '2014-04-01 00:50:18.000000', 'temperatura', 392.0000, 'ºC'),
	(270428, 119, '2014-04-01 00:50:19.000000', 'temperatura', 723.0000, 'ºC'),
	(270429, 119, '2014-04-01 00:50:20.000000', 'temperatura', 42.0000, 'ºC'),
	(270430, 119, '2014-04-01 00:50:21.000000', 'temperatura', 441.0000, 'ºC'),
	(270431, 119, '2014-04-01 00:50:22.000000', 'temperatura', 880.0000, 'ºC'),
	(270432, 119, '2014-04-01 00:50:23.000000', 'temperatura', 676.0000, 'ºC'),
	(270433, 119, '2014-04-01 00:50:24.000000', 'temperatura', 742.0000, 'ºC'),
	(270434, 119, '2014-04-01 00:50:25.000000', 'temperatura', 482.0000, 'ºC'),
	(270435, 119, '2014-04-01 00:50:26.000000', 'temperatura', 185.0000, 'ºC'),
	(270436, 119, '2014-04-01 00:50:27.000000', 'temperatura', 680.0000, 'ºC'),
	(270437, 119, '2014-04-01 00:50:28.000000', 'temperatura', 445.0000, 'ºC'),
	(270438, 119, '2014-04-01 00:50:29.000000', 'temperatura', 186.0000, 'ºC'),
	(270439, 119, '2014-04-01 00:50:30.000000', 'temperatura', 797.0000, 'ºC'),
	(270440, 119, '2014-04-01 00:50:31.000000', 'temperatura', 1027.0000, 'ºC'),
	(270441, 119, '2014-04-01 00:50:32.000000', 'temperatura', 343.0000, 'ºC'),
	(270442, 119, '2014-04-01 00:50:33.000000', 'temperatura', 1034.0000, 'ºC'),
	(270443, 119, '2014-04-01 00:50:34.000000', 'temperatura', 541.0000, 'ºC'),
	(270444, 119, '2014-04-01 00:50:35.000000', 'temperatura', 806.0000, 'ºC'),
	(270445, 119, '2014-04-01 00:50:36.000000', 'temperatura', 8.0000, 'ºC'),
	(270446, 119, '2014-04-01 00:50:37.000000', 'temperatura', 22.0000, 'ºC'),
	(270447, 119, '2014-04-01 00:50:38.000000', 'temperatura', 88.0000, 'ºC'),
	(270448, 119, '2014-04-01 00:50:39.000000', 'temperatura', 372.0000, 'ºC'),
	(270449, 119, '2014-04-01 00:50:40.000000', 'temperatura', 396.0000, 'ºC'),
	(270450, 119, '2014-04-01 00:50:41.000000', 'temperatura', 865.0000, 'ºC'),
	(270451, 119, '2014-04-01 00:50:42.000000', 'temperatura', 737.0000, 'ºC'),
	(270452, 119, '2014-04-01 00:50:43.000000', 'temperatura', 1090.0000, 'ºC'),
	(270453, 119, '2014-04-01 00:50:44.000000', 'temperatura', 839.0000, 'ºC'),
	(270454, 119, '2014-04-01 00:50:45.000000', 'temperatura', 928.0000, 'ºC'),
	(270455, 119, '2014-04-01 00:50:46.000000', 'temperatura', 921.0000, 'ºC'),
	(270456, 119, '2014-04-01 00:50:47.000000', 'temperatura', 621.0000, 'ºC'),
	(270457, 119, '2014-04-01 00:50:48.000000', 'temperatura', 342.0000, 'ºC'),
	(270458, 119, '2014-04-01 00:50:49.000000', 'temperatura', 1049.0000, 'ºC'),
	(270459, 119, '2014-04-01 00:50:50.000000', 'temperatura', 618.0000, 'ºC'),
	(270460, 119, '2014-04-01 00:50:51.000000', 'temperatura', 1143.0000, 'ºC'),
	(270461, 119, '2014-04-01 00:50:52.000000', 'temperatura', 260.0000, 'ºC'),
	(270462, 119, '2014-04-01 00:50:53.000000', 'temperatura', 275.0000, 'ºC'),
	(270463, 119, '2014-04-01 00:50:54.000000', 'temperatura', 596.0000, 'ºC'),
	(270464, 119, '2014-04-01 00:50:55.000000', 'temperatura', 952.0000, 'ºC'),
	(270465, 119, '2014-04-01 00:50:56.000000', 'temperatura', 575.0000, 'ºC'),
	(270466, 119, '2014-04-01 00:50:57.000000', 'temperatura', 20.0000, 'ºC'),
	(270467, 119, '2014-04-01 00:50:58.000000', 'temperatura', 773.0000, 'ºC'),
	(270468, 119, '2014-04-01 00:50:59.000000', 'temperatura', 205.0000, 'ºC'),
	(270469, 119, '2014-04-01 00:51:00.000000', 'temperatura', 1109.0000, 'ºC'),
	(270470, 119, '2014-04-01 00:51:01.000000', 'temperatura', 131.0000, 'ºC'),
	(270471, 119, '2014-04-01 00:51:02.000000', 'temperatura', 927.0000, 'ºC'),
	(270472, 119, '2014-04-01 00:51:03.000000', 'temperatura', 642.0000, 'ºC'),
	(270473, 119, '2014-04-01 00:51:04.000000', 'temperatura', 429.0000, 'ºC'),
	(270474, 119, '2014-04-01 00:51:05.000000', 'temperatura', 221.0000, 'ºC'),
	(270475, 119, '2014-04-01 00:51:06.000000', 'temperatura', 1016.0000, 'ºC'),
	(270476, 119, '2014-04-01 00:51:07.000000', 'temperatura', 819.0000, 'ºC'),
	(270477, 119, '2014-04-01 00:51:08.000000', 'temperatura', 1046.0000, 'ºC'),
	(270478, 119, '2014-04-01 00:51:09.000000', 'temperatura', 373.0000, 'ºC'),
	(270479, 119, '2014-04-01 00:51:10.000000', 'temperatura', 1127.0000, 'ºC'),
	(270480, 119, '2014-04-01 00:51:11.000000', 'temperatura', 915.0000, 'ºC'),
	(270481, 119, '2014-04-01 00:51:12.000000', 'temperatura', 1198.0000, 'ºC'),
	(270482, 119, '2014-04-01 00:51:13.000000', 'temperatura', 845.0000, 'ºC'),
	(270483, 119, '2014-04-01 00:51:14.000000', 'temperatura', 632.0000, 'ºC'),
	(270484, 119, '2014-04-01 00:51:15.000000', 'temperatura', 624.0000, 'ºC'),
	(270485, 119, '2014-04-01 00:51:16.000000', 'temperatura', 24.0000, 'ºC'),
	(270486, 119, '2014-04-01 00:51:17.000000', 'temperatura', 648.0000, 'ºC'),
	(270487, 119, '2014-04-01 00:51:18.000000', 'temperatura', 771.0000, 'ºC'),
	(270488, 119, '2014-04-01 00:51:19.000000', 'temperatura', 712.0000, 'ºC'),
	(270489, 119, '2014-04-01 00:51:20.000000', 'temperatura', 46.0000, 'ºC'),
	(270490, 119, '2014-04-01 00:51:21.000000', 'temperatura', 496.0000, 'ºC'),
	(270491, 119, '2014-04-01 00:51:22.000000', 'temperatura', 1141.0000, 'ºC'),
	(270492, 119, '2014-04-01 00:51:23.000000', 'temperatura', 617.0000, 'ºC'),
	(270493, 119, '2014-04-01 00:51:24.000000', 'temperatura', 864.0000, 'ºC'),
	(270494, 119, '2014-04-01 00:51:25.000000', 'temperatura', 70.0000, 'ºC'),
	(270495, 119, '2014-04-01 00:51:26.000000', 'temperatura', 159.0000, 'ºC'),
	(270496, 119, '2014-04-01 00:51:27.000000', 'temperatura', 584.0000, 'ºC'),
	(270497, 119, '2014-04-01 00:51:28.000000', 'temperatura', 44.0000, 'ºC'),
	(270498, 119, '2014-04-01 00:51:29.000000', 'temperatura', 868.0000, 'ºC'),
	(270499, 119, '2014-04-01 00:51:30.000000', 'temperatura', 607.0000, 'ºC'),
	(270500, 119, '2014-04-01 00:51:31.000000', 'temperatura', 435.0000, 'ºC'),
	(270501, 119, '2014-04-01 00:51:32.000000', 'temperatura', 351.0000, 'ºC'),
	(270502, 119, '2014-04-01 00:51:33.000000', 'temperatura', 452.0000, 'ºC'),
	(270503, 119, '2014-04-01 00:51:34.000000', 'temperatura', 8.0000, 'ºC'),
	(270504, 119, '2014-04-01 00:51:35.000000', 'temperatura', 1085.0000, 'ºC'),
	(270505, 119, '2014-04-01 00:51:36.000000', 'temperatura', 599.0000, 'ºC'),
	(270506, 119, '2014-04-01 00:51:37.000000', 'temperatura', 944.0000, 'ºC'),
	(270507, 119, '2014-04-01 00:51:38.000000', 'temperatura', 521.0000, 'ºC'),
	(270508, 119, '2014-04-01 00:51:39.000000', 'temperatura', 974.0000, 'ºC'),
	(270509, 119, '2014-04-01 00:51:40.000000', 'temperatura', 907.0000, 'ºC'),
	(270510, 119, '2014-04-01 00:51:41.000000', 'temperatura', 414.0000, 'ºC'),
	(270511, 119, '2014-04-01 00:51:42.000000', 'temperatura', 551.0000, 'ºC'),
	(270512, 119, '2014-04-01 00:51:43.000000', 'temperatura', 314.0000, 'ºC'),
	(270513, 119, '2014-04-01 00:51:44.000000', 'temperatura', 1114.0000, 'ºC'),
	(270514, 119, '2014-04-01 00:51:45.000000', 'temperatura', 1032.0000, 'ºC'),
	(270515, 119, '2014-04-01 00:51:46.000000', 'temperatura', 618.0000, 'ºC'),
	(270516, 119, '2014-04-01 00:51:47.000000', 'temperatura', 1194.0000, 'ºC'),
	(270517, 119, '2014-04-01 00:51:48.000000', 'temperatura', 517.0000, 'ºC'),
	(270518, 119, '2014-04-01 00:51:49.000000', 'temperatura', 203.0000, 'ºC'),
	(270519, 119, '2014-04-01 00:51:50.000000', 'temperatura', 665.0000, 'ºC'),
	(270520, 119, '2014-04-01 00:51:51.000000', 'temperatura', 315.0000, 'ºC'),
	(270521, 119, '2014-04-01 00:51:52.000000', 'temperatura', 783.0000, 'ºC'),
	(270522, 119, '2014-04-01 00:51:53.000000', 'temperatura', 569.0000, 'ºC'),
	(270523, 119, '2014-04-01 00:51:54.000000', 'temperatura', 496.0000, 'ºC'),
	(270524, 119, '2014-04-01 00:51:55.000000', 'temperatura', 774.0000, 'ºC'),
	(270525, 119, '2014-04-01 00:51:56.000000', 'temperatura', 1181.0000, 'ºC'),
	(270526, 119, '2014-04-01 00:51:57.000000', 'temperatura', 1184.0000, 'ºC'),
	(270527, 119, '2014-04-01 00:51:58.000000', 'temperatura', 1178.0000, 'ºC'),
	(270528, 119, '2014-04-01 00:51:59.000000', 'temperatura', 1140.0000, 'ºC'),
	(270529, 119, '2014-04-01 00:52:00.000000', 'temperatura', 964.0000, 'ºC'),
	(270530, 119, '2014-04-01 00:52:01.000000', 'temperatura', 203.0000, 'ºC'),
	(270531, 119, '2014-04-01 00:52:02.000000', 'temperatura', 522.0000, 'ºC'),
	(270532, 119, '2014-04-01 00:52:03.000000', 'temperatura', 801.0000, 'ºC'),
	(270533, 119, '2014-04-01 00:52:04.000000', 'temperatura', 42.0000, 'ºC'),
	(270534, 119, '2014-04-01 00:52:05.000000', 'temperatura', 205.0000, 'ºC'),
	(270535, 119, '2014-04-01 00:52:06.000000', 'temperatura', 902.0000, 'ºC'),
	(270536, 119, '2014-04-01 00:52:07.000000', 'temperatura', 294.0000, 'ºC'),
	(270537, 119, '2014-04-01 00:52:08.000000', 'temperatura', 1165.0000, 'ºC'),
	(270538, 119, '2014-04-01 00:52:09.000000', 'temperatura', 143.0000, 'ºC'),
	(270539, 119, '2014-04-01 00:52:10.000000', 'temperatura', 822.0000, 'ºC'),
	(270540, 119, '2014-04-01 00:52:11.000000', 'temperatura', 81.0000, 'ºC'),
	(270541, 119, '2014-04-01 00:52:12.000000', 'temperatura', 339.0000, 'ºC'),
	(270542, 119, '2014-04-01 00:52:13.000000', 'temperatura', 252.0000, 'ºC'),
	(270543, 119, '2014-04-01 00:52:14.000000', 'temperatura', 243.0000, 'ºC'),
	(270544, 119, '2014-04-01 00:52:15.000000', 'temperatura', 459.0000, 'ºC'),
	(270545, 119, '2014-04-01 00:52:16.000000', 'temperatura', 369.0000, 'ºC'),
	(270546, 119, '2014-04-01 00:52:17.000000', 'temperatura', 468.0000, 'ºC'),
	(270547, 119, '2014-04-01 00:52:18.000000', 'temperatura', 35.0000, 'ºC'),
	(270548, 119, '2014-04-01 00:52:19.000000', 'temperatura', 1168.0000, 'ºC'),
	(270549, 119, '2014-04-01 00:52:20.000000', 'temperatura', 938.0000, 'ºC'),
	(270550, 119, '2014-04-01 00:52:21.000000', 'temperatura', 1184.0000, 'ºC'),
	(270551, 119, '2014-04-01 00:52:22.000000', 'temperatura', 707.0000, 'ºC'),
	(270552, 119, '2014-04-01 00:52:23.000000', 'temperatura', 1186.0000, 'ºC'),
	(270553, 119, '2014-04-01 00:52:24.000000', 'temperatura', 208.0000, 'ºC'),
	(270554, 119, '2014-04-01 00:52:25.000000', 'temperatura', 1081.0000, 'ºC'),
	(270555, 119, '2014-04-01 00:52:26.000000', 'temperatura', 1181.0000, 'ºC'),
	(270556, 119, '2014-04-01 00:52:27.000000', 'temperatura', 262.0000, 'ºC'),
	(270557, 119, '2014-04-01 00:52:28.000000', 'temperatura', 167.0000, 'ºC'),
	(270558, 119, '2014-04-01 00:52:29.000000', 'temperatura', 51.0000, 'ºC'),
	(270559, 119, '2014-04-01 00:52:30.000000', 'temperatura', 956.0000, 'ºC'),
	(270560, 119, '2014-04-01 00:52:31.000000', 'temperatura', 1026.0000, 'ºC'),
	(270561, 119, '2014-04-01 00:52:32.000000', 'temperatura', 1063.0000, 'ºC'),
	(270562, 119, '2014-04-01 00:52:33.000000', 'temperatura', 1036.0000, 'ºC'),
	(270563, 119, '2014-04-01 00:52:34.000000', 'temperatura', 791.0000, 'ºC'),
	(270564, 119, '2014-04-01 00:52:35.000000', 'temperatura', 847.0000, 'ºC'),
	(270565, 119, '2014-04-01 00:52:36.000000', 'temperatura', 664.0000, 'ºC'),
	(270566, 119, '2014-04-01 00:52:37.000000', 'temperatura', 780.0000, 'ºC'),
	(270567, 119, '2014-04-01 00:52:38.000000', 'temperatura', 706.0000, 'ºC'),
	(270568, 119, '2014-04-01 00:52:39.000000', 'temperatura', 1192.0000, 'ºC'),
	(270569, 119, '2014-04-01 00:52:40.000000', 'temperatura', 241.0000, 'ºC'),
	(270570, 119, '2014-04-01 00:52:41.000000', 'temperatura', 32.0000, 'ºC'),
	(270571, 119, '2014-04-01 00:52:42.000000', 'temperatura', 636.0000, 'ºC'),
	(270572, 119, '2014-04-01 00:52:43.000000', 'temperatura', 684.0000, 'ºC'),
	(270573, 119, '2014-04-01 00:52:44.000000', 'temperatura', 314.0000, 'ºC'),
	(270574, 119, '2014-04-01 00:52:45.000000', 'temperatura', 718.0000, 'ºC'),
	(270575, 119, '2014-04-01 00:52:46.000000', 'temperatura', 248.0000, 'ºC'),
	(270576, 119, '2014-04-01 00:52:47.000000', 'temperatura', 288.0000, 'ºC'),
	(270577, 119, '2014-04-01 00:52:48.000000', 'temperatura', 696.0000, 'ºC'),
	(270578, 119, '2014-04-01 00:52:49.000000', 'temperatura', 216.0000, 'ºC'),
	(270579, 119, '2014-04-01 00:52:50.000000', 'temperatura', 193.0000, 'ºC'),
	(270580, 119, '2014-04-01 00:52:51.000000', 'temperatura', 318.0000, 'ºC'),
	(270581, 119, '2014-04-01 00:52:52.000000', 'temperatura', 1013.0000, 'ºC'),
	(270582, 119, '2014-04-01 00:52:53.000000', 'temperatura', 509.0000, 'ºC'),
	(270583, 119, '2014-04-01 00:52:54.000000', 'temperatura', 706.0000, 'ºC'),
	(270584, 119, '2014-04-01 00:52:55.000000', 'temperatura', 804.0000, 'ºC'),
	(270585, 119, '2014-04-01 00:52:56.000000', 'temperatura', 701.0000, 'ºC'),
	(270586, 119, '2014-04-01 00:52:57.000000', 'temperatura', 1095.0000, 'ºC'),
	(270587, 119, '2014-04-01 00:52:58.000000', 'temperatura', 974.0000, 'ºC'),
	(270588, 119, '2014-04-01 00:52:59.000000', 'temperatura', 385.0000, 'ºC'),
	(270589, 119, '2014-04-01 00:53:00.000000', 'temperatura', 201.0000, 'ºC'),
	(270590, 119, '2014-04-01 00:53:01.000000', 'temperatura', 1054.0000, 'ºC'),
	(270591, 119, '2014-04-01 00:53:02.000000', 'temperatura', 1064.0000, 'ºC'),
	(270592, 119, '2014-04-01 00:53:03.000000', 'temperatura', 960.0000, 'ºC'),
	(270593, 119, '2014-04-01 00:53:04.000000', 'temperatura', 408.0000, 'ºC'),
	(270594, 119, '2014-04-01 00:53:05.000000', 'temperatura', 362.0000, 'ºC'),
	(270595, 119, '2014-04-01 00:53:06.000000', 'temperatura', 584.0000, 'ºC'),
	(270596, 119, '2014-04-01 00:53:07.000000', 'temperatura', 636.0000, 'ºC'),
	(270597, 119, '2014-04-01 00:53:08.000000', 'temperatura', 227.0000, 'ºC'),
	(270598, 119, '2014-04-01 00:53:09.000000', 'temperatura', 428.0000, 'ºC'),
	(270599, 119, '2014-04-01 00:53:10.000000', 'temperatura', 260.0000, 'ºC'),
	(270600, 119, '2014-04-01 00:53:11.000000', 'temperatura', 18.0000, 'ºC'),
	(270601, 119, '2014-04-01 00:53:12.000000', 'temperatura', 508.0000, 'ºC'),
	(270602, 119, '2014-04-01 00:53:13.000000', 'temperatura', 90.0000, 'ºC'),
	(270603, 119, '2014-04-01 00:53:14.000000', 'temperatura', 123.0000, 'ºC'),
	(270604, 119, '2014-04-01 00:53:15.000000', 'temperatura', 345.0000, 'ºC'),
	(270605, 119, '2014-04-01 00:53:16.000000', 'temperatura', 158.0000, 'ºC'),
	(270606, 119, '2014-04-01 00:53:17.000000', 'temperatura', 955.0000, 'ºC'),
	(270607, 119, '2014-04-01 00:53:18.000000', 'temperatura', 700.0000, 'ºC'),
	(270608, 119, '2014-04-01 00:53:19.000000', 'temperatura', 638.0000, 'ºC'),
	(270609, 119, '2014-04-01 00:53:20.000000', 'temperatura', 1089.0000, 'ºC'),
	(270610, 119, '2014-04-01 00:53:21.000000', 'temperatura', 1131.0000, 'ºC'),
	(270611, 119, '2014-04-01 00:53:22.000000', 'temperatura', 1190.0000, 'ºC'),
	(270612, 119, '2014-04-01 00:53:23.000000', 'temperatura', 156.0000, 'ºC'),
	(270613, 119, '2014-04-01 00:53:24.000000', 'temperatura', 812.0000, 'ºC'),
	(270614, 119, '2014-04-01 00:53:25.000000', 'temperatura', 1190.0000, 'ºC'),
	(270615, 119, '2014-04-01 00:53:26.000000', 'temperatura', 1117.0000, 'ºC'),
	(270616, 119, '2014-04-01 00:53:27.000000', 'temperatura', 816.0000, 'ºC'),
	(270617, 119, '2014-04-01 00:53:28.000000', 'temperatura', 730.0000, 'ºC'),
	(270618, 119, '2014-04-01 00:53:29.000000', 'temperatura', 3.0000, 'ºC'),
	(270619, 119, '2014-04-01 00:53:30.000000', 'temperatura', 226.0000, 'ºC'),
	(270620, 119, '2014-04-01 00:53:31.000000', 'temperatura', 1121.0000, 'ºC'),
	(270621, 119, '2014-04-01 00:53:32.000000', 'temperatura', 128.0000, 'ºC'),
	(270622, 119, '2014-04-01 00:53:33.000000', 'temperatura', 875.0000, 'ºC'),
	(270623, 119, '2014-04-01 00:53:34.000000', 'temperatura', 393.0000, 'ºC'),
	(270624, 119, '2014-04-01 00:53:35.000000', 'temperatura', 541.0000, 'ºC'),
	(270625, 119, '2014-04-01 00:53:36.000000', 'temperatura', 324.0000, 'ºC'),
	(270626, 119, '2014-04-01 00:53:37.000000', 'temperatura', 1199.0000, 'ºC'),
	(270627, 119, '2014-04-01 00:53:38.000000', 'temperatura', 225.0000, 'ºC'),
	(270628, 119, '2014-04-01 00:53:39.000000', 'temperatura', 1126.0000, 'ºC'),
	(270629, 119, '2014-04-01 00:53:40.000000', 'temperatura', 155.0000, 'ºC'),
	(270630, 119, '2014-04-01 00:53:41.000000', 'temperatura', 999.0000, 'ºC'),
	(270631, 119, '2014-04-01 00:53:42.000000', 'temperatura', 928.0000, 'ºC'),
	(270632, 119, '2014-04-01 00:53:43.000000', 'temperatura', 446.0000, 'ºC'),
	(270633, 119, '2014-04-01 00:53:44.000000', 'temperatura', 646.0000, 'ºC'),
	(270634, 119, '2014-04-01 00:53:45.000000', 'temperatura', 692.0000, 'ºC'),
	(270635, 119, '2014-04-01 00:53:46.000000', 'temperatura', 322.0000, 'ºC'),
	(270636, 119, '2014-04-01 00:53:47.000000', 'temperatura', 737.0000, 'ºC'),
	(270637, 119, '2014-04-01 00:53:48.000000', 'temperatura', 317.0000, 'ºC'),
	(270638, 119, '2014-04-01 00:53:49.000000', 'temperatura', 576.0000, 'ºC'),
	(270639, 119, '2014-04-01 00:53:50.000000', 'temperatura', 728.0000, 'ºC'),
	(270640, 119, '2014-04-01 00:53:51.000000', 'temperatura', 713.0000, 'ºC'),
	(270641, 119, '2014-04-01 00:53:52.000000', 'temperatura', 183.0000, 'ºC'),
	(270642, 119, '2014-04-01 00:53:53.000000', 'temperatura', 1178.0000, 'ºC'),
	(270643, 119, '2014-04-01 00:53:54.000000', 'temperatura', 538.0000, 'ºC'),
	(270644, 119, '2014-04-01 00:53:55.000000', 'temperatura', 356.0000, 'ºC'),
	(270645, 119, '2014-04-01 00:53:56.000000', 'temperatura', 169.0000, 'ºC'),
	(270646, 119, '2014-04-01 00:53:57.000000', 'temperatura', 977.0000, 'ºC'),
	(270647, 119, '2014-04-01 00:53:58.000000', 'temperatura', 780.0000, 'ºC'),
	(270648, 119, '2014-04-01 00:53:59.000000', 'temperatura', 969.0000, 'ºC'),
	(270649, 119, '2014-04-01 00:54:00.000000', 'temperatura', 104.0000, 'ºC'),
	(270650, 119, '2014-04-01 00:54:01.000000', 'temperatura', 13.0000, 'ºC'),
	(270651, 119, '2014-04-01 00:54:02.000000', 'temperatura', 955.0000, 'ºC'),
	(270652, 119, '2014-04-01 00:54:03.000000', 'temperatura', 1137.0000, 'ºC'),
	(270653, 119, '2014-04-01 00:54:04.000000', 'temperatura', 421.0000, 'ºC'),
	(270654, 119, '2014-04-01 00:54:05.000000', 'temperatura', 1095.0000, 'ºC'),
	(270655, 119, '2014-04-01 00:54:06.000000', 'temperatura', 611.0000, 'ºC'),
	(270656, 119, '2014-04-01 00:54:07.000000', 'temperatura', 972.0000, 'ºC'),
	(270657, 119, '2014-04-01 00:54:08.000000', 'temperatura', 628.0000, 'ºC'),
	(270658, 119, '2014-04-01 00:54:09.000000', 'temperatura', 225.0000, 'ºC'),
	(270659, 119, '2014-04-01 00:54:10.000000', 'temperatura', 439.0000, 'ºC'),
	(270660, 119, '2014-04-01 00:54:11.000000', 'temperatura', 322.0000, 'ºC'),
	(270661, 119, '2014-04-01 00:54:12.000000', 'temperatura', 291.0000, 'ºC'),
	(270662, 119, '2014-04-01 00:54:13.000000', 'temperatura', 493.0000, 'ºC'),
	(270663, 119, '2014-04-01 00:54:14.000000', 'temperatura', 389.0000, 'ºC'),
	(270664, 119, '2014-04-01 00:54:15.000000', 'temperatura', 468.0000, 'ºC'),
	(270665, 119, '2014-04-01 00:54:16.000000', 'temperatura', 1174.0000, 'ºC'),
	(270666, 119, '2014-04-01 00:54:17.000000', 'temperatura', 865.0000, 'ºC'),
	(270667, 119, '2014-04-01 00:54:18.000000', 'temperatura', 803.0000, 'ºC'),
	(270668, 119, '2014-04-01 00:54:19.000000', 'temperatura', 223.0000, 'ºC'),
	(270669, 119, '2014-04-01 00:54:20.000000', 'temperatura', 1104.0000, 'ºC'),
	(270670, 119, '2014-04-01 00:54:21.000000', 'temperatura', 52.0000, 'ºC'),
	(270671, 119, '2014-04-01 00:54:22.000000', 'temperatura', 548.0000, 'ºC'),
	(270672, 119, '2014-04-01 00:54:23.000000', 'temperatura', 183.0000, 'ºC'),
	(270673, 119, '2014-04-01 00:54:24.000000', 'temperatura', 474.0000, 'ºC'),
	(270674, 119, '2014-04-01 00:54:25.000000', 'temperatura', 620.0000, 'ºC'),
	(270675, 119, '2014-04-01 00:54:26.000000', 'temperatura', 477.0000, 'ºC'),
	(270676, 119, '2014-04-01 00:54:27.000000', 'temperatura', 528.0000, 'ºC'),
	(270677, 119, '2014-04-01 00:54:28.000000', 'temperatura', 7.0000, 'ºC'),
	(270678, 119, '2014-04-01 00:54:29.000000', 'temperatura', 854.0000, 'ºC'),
	(270679, 119, '2014-04-01 00:54:30.000000', 'temperatura', 649.0000, 'ºC'),
	(270680, 119, '2014-04-01 00:54:31.000000', 'temperatura', 683.0000, 'ºC'),
	(270681, 119, '2014-04-01 00:54:32.000000', 'temperatura', 268.0000, 'ºC'),
	(270682, 119, '2014-04-01 00:54:33.000000', 'temperatura', 493.0000, 'ºC'),
	(270683, 119, '2014-04-01 00:54:34.000000', 'temperatura', 462.0000, 'ºC'),
	(270684, 119, '2014-04-01 00:54:35.000000', 'temperatura', 830.0000, 'ºC'),
	(270685, 119, '2014-04-01 00:54:36.000000', 'temperatura', 366.0000, 'ºC'),
	(270686, 119, '2014-04-01 00:54:37.000000', 'temperatura', 540.0000, 'ºC'),
	(270687, 119, '2014-04-01 00:54:38.000000', 'temperatura', 403.0000, 'ºC'),
	(270688, 119, '2014-04-01 00:54:39.000000', 'temperatura', 396.0000, 'ºC'),
	(270689, 119, '2014-04-01 00:54:40.000000', 'temperatura', 772.0000, 'ºC'),
	(270690, 119, '2014-04-01 00:54:41.000000', 'temperatura', 272.0000, 'ºC'),
	(270691, 119, '2014-04-01 00:54:42.000000', 'temperatura', 244.0000, 'ºC'),
	(270692, 119, '2014-04-01 00:54:43.000000', 'temperatura', 405.0000, 'ºC'),
	(270693, 119, '2014-04-01 00:54:44.000000', 'temperatura', 95.0000, 'ºC'),
	(270694, 119, '2014-04-01 00:54:45.000000', 'temperatura', 458.0000, 'ºC'),
	(270695, 119, '2014-04-01 00:54:46.000000', 'temperatura', 805.0000, 'ºC'),
	(270696, 119, '2014-04-01 00:54:47.000000', 'temperatura', 250.0000, 'ºC'),
	(270697, 119, '2014-04-01 00:54:48.000000', 'temperatura', 39.0000, 'ºC'),
	(270698, 119, '2014-04-01 00:54:49.000000', 'temperatura', 644.0000, 'ºC'),
	(270699, 119, '2014-04-01 00:54:50.000000', 'temperatura', 705.0000, 'ºC'),
	(270700, 119, '2014-04-01 00:54:51.000000', 'temperatura', 392.0000, 'ºC'),
	(270701, 119, '2014-04-01 00:54:52.000000', 'temperatura', 1045.0000, 'ºC'),
	(270702, 119, '2014-04-01 00:54:53.000000', 'temperatura', 450.0000, 'ºC'),
	(270703, 119, '2014-04-01 00:54:54.000000', 'temperatura', 315.0000, 'ºC'),
	(270704, 119, '2014-04-01 00:54:55.000000', 'temperatura', 227.0000, 'ºC'),
	(270705, 119, '2014-04-01 00:54:56.000000', 'temperatura', 191.0000, 'ºC'),
	(270706, 119, '2014-04-01 00:54:57.000000', 'temperatura', 274.0000, 'ºC'),
	(270707, 119, '2014-04-01 00:54:58.000000', 'temperatura', 798.0000, 'ºC'),
	(270708, 119, '2014-04-01 00:54:59.000000', 'temperatura', 768.0000, 'ºC'),
	(270709, 119, '2014-04-01 00:55:00.000000', 'temperatura', 249.0000, 'ºC'),
	(270710, 119, '2014-04-01 00:55:01.000000', 'temperatura', 138.0000, 'ºC'),
	(270711, 119, '2014-04-01 00:55:02.000000', 'temperatura', 1145.0000, 'ºC'),
	(270712, 119, '2014-04-01 00:55:03.000000', 'temperatura', 511.0000, 'ºC'),
	(270713, 119, '2014-04-01 00:55:04.000000', 'temperatura', 320.0000, 'ºC'),
	(270714, 119, '2014-04-01 00:55:05.000000', 'temperatura', 69.0000, 'ºC'),
	(270715, 119, '2014-04-01 00:55:06.000000', 'temperatura', 584.0000, 'ºC'),
	(270716, 119, '2014-04-01 00:55:07.000000', 'temperatura', 316.0000, 'ºC'),
	(270717, 119, '2014-04-01 00:55:08.000000', 'temperatura', 1026.0000, 'ºC'),
	(270718, 119, '2014-04-01 00:55:09.000000', 'temperatura', 581.0000, 'ºC'),
	(270719, 119, '2014-04-01 00:55:10.000000', 'temperatura', 1030.0000, 'ºC'),
	(270720, 119, '2014-04-01 00:55:11.000000', 'temperatura', 1006.0000, 'ºC'),
	(270721, 119, '2014-04-01 00:55:12.000000', 'temperatura', 741.0000, 'ºC'),
	(270722, 119, '2014-04-01 00:55:13.000000', 'temperatura', 689.0000, 'ºC'),
	(270723, 119, '2014-04-01 00:55:14.000000', 'temperatura', 22.0000, 'ºC'),
	(270724, 119, '2014-04-01 00:55:15.000000', 'temperatura', 442.0000, 'ºC'),
	(270725, 119, '2014-04-01 00:55:16.000000', 'temperatura', 945.0000, 'ºC'),
	(270726, 119, '2014-04-01 00:55:17.000000', 'temperatura', 1000.0000, 'ºC'),
	(270727, 119, '2014-04-01 00:55:18.000000', 'temperatura', 964.0000, 'ºC'),
	(270728, 119, '2014-04-01 00:55:19.000000', 'temperatura', 624.0000, 'ºC'),
	(270729, 119, '2014-04-01 00:55:20.000000', 'temperatura', 225.0000, 'ºC'),
	(270730, 119, '2014-04-01 00:55:21.000000', 'temperatura', 453.0000, 'ºC'),
	(270731, 119, '2014-04-01 00:55:22.000000', 'temperatura', 391.0000, 'ºC'),
	(270732, 119, '2014-04-01 00:55:23.000000', 'temperatura', 596.0000, 'ºC'),
	(270733, 119, '2014-04-01 00:55:24.000000', 'temperatura', 609.0000, 'ºC'),
	(270734, 119, '2014-04-01 00:55:25.000000', 'temperatura', 57.0000, 'ºC'),
	(270735, 119, '2014-04-01 00:55:26.000000', 'temperatura', 860.0000, 'ºC'),
	(270736, 119, '2014-04-01 00:55:27.000000', 'temperatura', 530.0000, 'ºC'),
	(270737, 119, '2014-04-01 00:55:28.000000', 'temperatura', 68.0000, 'ºC'),
	(270738, 119, '2014-04-01 00:55:29.000000', 'temperatura', 1150.0000, 'ºC'),
	(270739, 119, '2014-04-01 00:55:30.000000', 'temperatura', 749.0000, 'ºC'),
	(270740, 119, '2014-04-01 00:55:31.000000', 'temperatura', 293.0000, 'ºC'),
	(270741, 119, '2014-04-01 00:55:32.000000', 'temperatura', 422.0000, 'ºC'),
	(270742, 119, '2014-04-01 00:55:33.000000', 'temperatura', 28.0000, 'ºC'),
	(270743, 119, '2014-04-01 00:55:34.000000', 'temperatura', 75.0000, 'ºC'),
	(270744, 119, '2014-04-01 00:55:35.000000', 'temperatura', 292.0000, 'ºC'),
	(270745, 119, '2014-04-01 00:55:36.000000', 'temperatura', 37.0000, 'ºC'),
	(270746, 119, '2014-04-01 00:55:37.000000', 'temperatura', 507.0000, 'ºC'),
	(270747, 119, '2014-04-01 00:55:38.000000', 'temperatura', 26.0000, 'ºC'),
	(270748, 119, '2014-04-01 00:55:39.000000', 'temperatura', 1009.0000, 'ºC'),
	(270749, 119, '2014-04-01 00:55:40.000000', 'temperatura', 167.0000, 'ºC'),
	(270750, 119, '2014-04-01 00:55:41.000000', 'temperatura', 208.0000, 'ºC'),
	(270751, 119, '2014-04-01 00:55:42.000000', 'temperatura', 540.0000, 'ºC'),
	(270752, 119, '2014-04-01 00:55:43.000000', 'temperatura', 878.0000, 'ºC'),
	(270753, 119, '2014-04-01 00:55:44.000000', 'temperatura', 369.0000, 'ºC'),
	(270754, 119, '2014-04-01 00:55:45.000000', 'temperatura', 411.0000, 'ºC'),
	(270755, 119, '2014-04-01 00:55:46.000000', 'temperatura', 948.0000, 'ºC'),
	(270756, 119, '2014-04-01 00:55:47.000000', 'temperatura', 1108.0000, 'ºC'),
	(270757, 119, '2014-04-01 00:55:48.000000', 'temperatura', 296.0000, 'ºC'),
	(270758, 119, '2014-04-01 00:55:49.000000', 'temperatura', 558.0000, 'ºC'),
	(270759, 119, '2014-04-01 00:55:50.000000', 'temperatura', 702.0000, 'ºC'),
	(270760, 119, '2014-04-01 00:55:51.000000', 'temperatura', 635.0000, 'ºC'),
	(270761, 119, '2014-04-01 00:55:52.000000', 'temperatura', 1071.0000, 'ºC'),
	(270762, 119, '2014-04-01 00:55:53.000000', 'temperatura', 1051.0000, 'ºC'),
	(270763, 119, '2014-04-01 00:55:54.000000', 'temperatura', 841.0000, 'ºC'),
	(270764, 119, '2014-04-01 00:55:55.000000', 'temperatura', 1054.0000, 'ºC'),
	(270765, 119, '2014-04-01 00:55:56.000000', 'temperatura', 349.0000, 'ºC'),
	(270766, 119, '2014-04-01 00:55:57.000000', 'temperatura', 981.0000, 'ºC'),
	(270767, 119, '2014-04-01 00:55:58.000000', 'temperatura', 260.0000, 'ºC'),
	(270768, 119, '2014-04-01 00:55:59.000000', 'temperatura', 758.0000, 'ºC'),
	(270769, 119, '2014-04-01 00:56:00.000000', 'temperatura', 611.0000, 'ºC'),
	(270770, 119, '2014-04-01 00:56:01.000000', 'temperatura', 782.0000, 'ºC'),
	(270771, 119, '2014-04-01 00:56:02.000000', 'temperatura', 876.0000, 'ºC'),
	(270772, 119, '2014-04-01 00:56:03.000000', 'temperatura', 834.0000, 'ºC'),
	(270773, 119, '2014-04-01 00:56:04.000000', 'temperatura', 342.0000, 'ºC'),
	(270774, 119, '2014-04-01 00:56:05.000000', 'temperatura', 411.0000, 'ºC'),
	(270775, 119, '2014-04-01 00:56:06.000000', 'temperatura', 1027.0000, 'ºC'),
	(270776, 119, '2014-04-01 00:56:07.000000', 'temperatura', 303.0000, 'ºC'),
	(270777, 119, '2014-04-01 00:56:08.000000', 'temperatura', 835.0000, 'ºC'),
	(270778, 119, '2014-04-01 00:56:09.000000', 'temperatura', 868.0000, 'ºC'),
	(270779, 119, '2014-04-01 00:56:10.000000', 'temperatura', 633.0000, 'ºC'),
	(270780, 119, '2014-04-01 00:56:11.000000', 'temperatura', 564.0000, 'ºC'),
	(270781, 119, '2014-04-01 00:56:12.000000', 'temperatura', 921.0000, 'ºC'),
	(270782, 119, '2014-04-01 00:56:13.000000', 'temperatura', 511.0000, 'ºC'),
	(270783, 119, '2014-04-01 00:56:14.000000', 'temperatura', 995.0000, 'ºC'),
	(270784, 119, '2014-04-01 00:56:15.000000', 'temperatura', 1042.0000, 'ºC'),
	(270785, 119, '2014-04-01 00:56:16.000000', 'temperatura', 1025.0000, 'ºC'),
	(270786, 119, '2014-04-01 00:56:17.000000', 'temperatura', 802.0000, 'ºC'),
	(270787, 119, '2014-04-01 00:56:18.000000', 'temperatura', 933.0000, 'ºC'),
	(270788, 119, '2014-04-01 00:56:19.000000', 'temperatura', 1062.0000, 'ºC'),
	(270789, 119, '2014-04-01 00:56:20.000000', 'temperatura', 109.0000, 'ºC'),
	(270790, 119, '2014-04-01 00:56:21.000000', 'temperatura', 960.0000, 'ºC'),
	(270791, 119, '2014-04-01 00:56:22.000000', 'temperatura', 874.0000, 'ºC'),
	(270792, 119, '2014-04-01 00:56:23.000000', 'temperatura', 291.0000, 'ºC'),
	(270793, 119, '2014-04-01 00:56:24.000000', 'temperatura', 33.0000, 'ºC'),
	(270794, 119, '2014-04-01 00:56:25.000000', 'temperatura', 491.0000, 'ºC'),
	(270795, 119, '2014-04-01 00:56:26.000000', 'temperatura', 1160.0000, 'ºC'),
	(270796, 119, '2014-04-01 00:56:27.000000', 'temperatura', 724.0000, 'ºC'),
	(270797, 119, '2014-04-01 00:56:28.000000', 'temperatura', 142.0000, 'ºC'),
	(270798, 119, '2014-04-01 00:56:29.000000', 'temperatura', 939.0000, 'ºC'),
	(270799, 119, '2014-04-01 00:56:30.000000', 'temperatura', 670.0000, 'ºC'),
	(270800, 119, '2014-04-01 00:56:31.000000', 'temperatura', 532.0000, 'ºC'),
	(270801, 119, '2014-04-01 00:56:32.000000', 'temperatura', 650.0000, 'ºC'),
	(270802, 119, '2014-04-01 00:56:33.000000', 'temperatura', 456.0000, 'ºC'),
	(270803, 119, '2014-04-01 00:56:34.000000', 'temperatura', 329.0000, 'ºC'),
	(270804, 119, '2014-04-01 00:56:35.000000', 'temperatura', 277.0000, 'ºC'),
	(270805, 119, '2014-04-01 00:56:36.000000', 'temperatura', 401.0000, 'ºC'),
	(270806, 119, '2014-04-01 00:56:37.000000', 'temperatura', 1171.0000, 'ºC'),
	(270807, 119, '2014-04-01 00:56:38.000000', 'temperatura', 1056.0000, 'ºC'),
	(270808, 119, '2014-04-01 00:56:39.000000', 'temperatura', 564.0000, 'ºC'),
	(270809, 119, '2014-04-01 00:56:40.000000', 'temperatura', 855.0000, 'ºC'),
	(270810, 119, '2014-04-01 00:56:41.000000', 'temperatura', 182.0000, 'ºC'),
	(270811, 119, '2014-04-01 00:56:42.000000', 'temperatura', 746.0000, 'ºC'),
	(270812, 119, '2014-04-01 00:56:43.000000', 'temperatura', 786.0000, 'ºC'),
	(270813, 119, '2014-04-01 00:56:44.000000', 'temperatura', 492.0000, 'ºC'),
	(270814, 119, '2014-04-01 00:56:45.000000', 'temperatura', 101.0000, 'ºC'),
	(270815, 119, '2014-04-01 00:56:46.000000', 'temperatura', 230.0000, 'ºC'),
	(270816, 119, '2014-04-01 00:56:47.000000', 'temperatura', 849.0000, 'ºC'),
	(270817, 119, '2014-04-01 00:56:48.000000', 'temperatura', 1157.0000, 'ºC'),
	(270818, 119, '2014-04-01 00:56:49.000000', 'temperatura', 835.0000, 'ºC'),
	(270819, 119, '2014-04-01 00:56:50.000000', 'temperatura', 707.0000, 'ºC'),
	(270820, 119, '2014-04-01 00:56:51.000000', 'temperatura', 1031.0000, 'ºC'),
	(270821, 119, '2014-04-01 00:56:52.000000', 'temperatura', 633.0000, 'ºC'),
	(270822, 119, '2014-04-01 00:56:53.000000', 'temperatura', 75.0000, 'ºC'),
	(270823, 119, '2014-04-01 00:56:54.000000', 'temperatura', 873.0000, 'ºC'),
	(270824, 119, '2014-04-01 00:56:55.000000', 'temperatura', 544.0000, 'ºC'),
	(270825, 119, '2014-04-01 00:56:56.000000', 'temperatura', 98.0000, 'ºC'),
	(270826, 119, '2014-04-01 00:56:57.000000', 'temperatura', 62.0000, 'ºC'),
	(270827, 119, '2014-04-01 00:56:58.000000', 'temperatura', 15.0000, 'ºC'),
	(270828, 119, '2014-04-01 00:56:59.000000', 'temperatura', 1090.0000, 'ºC'),
	(270829, 119, '2014-04-01 00:57:00.000000', 'temperatura', 603.0000, 'ºC'),
	(270830, 119, '2014-04-01 00:57:01.000000', 'temperatura', 949.0000, 'ºC'),
	(270831, 119, '2014-04-01 00:57:02.000000', 'temperatura', 535.0000, 'ºC'),
	(270832, 119, '2014-04-01 00:57:03.000000', 'temperatura', 1028.0000, 'ºC'),
	(270833, 119, '2014-04-01 00:57:04.000000', 'temperatura', 1136.0000, 'ºC'),
	(270834, 119, '2014-04-01 00:57:05.000000', 'temperatura', 196.0000, 'ºC'),
	(270835, 119, '2014-04-01 00:57:06.000000', 'temperatura', 1171.0000, 'ºC'),
	(270836, 119, '2014-04-01 00:57:07.000000', 'temperatura', 470.0000, 'ºC'),
	(270837, 119, '2014-04-01 00:57:08.000000', 'temperatura', 35.0000, 'ºC'),
	(270838, 119, '2014-04-01 00:57:09.000000', 'temperatura', 1168.0000, 'ºC'),
	(270839, 119, '2014-04-01 00:57:10.000000', 'temperatura', 934.0000, 'ºC'),
	(270840, 119, '2014-04-01 00:57:11.000000', 'temperatura', 1169.0000, 'ºC'),
	(270841, 119, '2014-04-01 00:57:12.000000', 'temperatura', 641.0000, 'ºC'),
	(270842, 119, '2014-04-01 00:57:13.000000', 'temperatura', 897.0000, 'ºC'),
	(270843, 119, '2014-04-01 00:57:14.000000', 'temperatura', 165.0000, 'ºC'),
	(270844, 119, '2014-04-01 00:57:15.000000', 'temperatura', 532.0000, 'ºC'),
	(270845, 119, '2014-04-01 00:57:16.000000', 'temperatura', 966.0000, 'ºC'),
	(270846, 119, '2014-04-01 00:57:17.000000', 'temperatura', 836.0000, 'ºC'),
	(270847, 119, '2014-04-01 00:57:18.000000', 'temperatura', 81.0000, 'ºC'),
	(270848, 119, '2014-04-01 00:57:19.000000', 'temperatura', 298.0000, 'ºC'),
	(270849, 119, '2014-04-01 00:57:20.000000', 'temperatura', 48.0000, 'ºC'),
	(270850, 119, '2014-04-01 00:57:21.000000', 'temperatura', 545.0000, 'ºC'),
	(270851, 119, '2014-04-01 00:57:22.000000', 'temperatura', 180.0000, 'ºC'),
	(270852, 119, '2014-04-01 00:57:23.000000', 'temperatura', 469.0000, 'ºC'),
	(270853, 119, '2014-04-01 00:57:24.000000', 'temperatura', 603.0000, 'ºC'),
	(270854, 119, '2014-04-01 00:57:25.000000', 'temperatura', 411.0000, 'ºC'),
	(270855, 119, '2014-04-01 00:57:26.000000', 'temperatura', 246.0000, 'ºC'),
	(270856, 119, '2014-04-01 00:57:27.000000', 'temperatura', 1197.0000, 'ºC'),
	(270857, 119, '2014-04-01 00:57:28.000000', 'temperatura', 446.0000, 'ºC'),
	(270858, 119, '2014-04-01 00:57:29.000000', 'temperatura', 1042.0000, 'ºC'),
	(270859, 119, '2014-04-01 00:57:30.000000', 'temperatura', 272.0000, 'ºC'),
	(270860, 119, '2014-04-01 00:57:31.000000', 'temperatura', 634.0000, 'ºC'),
	(270861, 119, '2014-04-01 00:57:32.000000', 'temperatura', 1156.0000, 'ºC'),
	(270862, 119, '2014-04-01 00:57:33.000000', 'temperatura', 277.0000, 'ºC'),
	(270863, 119, '2014-04-01 00:57:34.000000', 'temperatura', 319.0000, 'ºC'),
	(270864, 119, '2014-04-01 00:57:35.000000', 'temperatura', 763.0000, 'ºC'),
	(270865, 119, '2014-04-01 00:57:36.000000', 'temperatura', 461.0000, 'ºC'),
	(270866, 119, '2014-04-01 00:57:37.000000', 'temperatura', 14.0000, 'ºC'),
	(270867, 119, '2014-04-01 00:57:38.000000', 'temperatura', 1089.0000, 'ºC'),
	(270868, 119, '2014-04-01 00:57:39.000000', 'temperatura', 601.0000, 'ºC'),
	(270869, 119, '2014-04-01 00:57:40.000000', 'temperatura', 940.0000, 'ºC'),
	(270870, 119, '2014-04-01 00:57:41.000000', 'temperatura', 496.0000, 'ºC'),
	(270871, 119, '2014-04-01 00:57:42.000000', 'temperatura', 860.0000, 'ºC'),
	(270872, 119, '2014-04-01 00:57:43.000000', 'temperatura', 414.0000, 'ºC'),
	(270873, 119, '2014-04-01 00:57:44.000000', 'temperatura', 690.0000, 'ºC'),
	(270874, 119, '2014-04-01 00:57:45.000000', 'temperatura', 1010.0000, 'ºC'),
	(270875, 119, '2014-04-01 00:57:46.000000', 'temperatura', 579.0000, 'ºC'),
	(270876, 119, '2014-04-01 00:57:47.000000', 'temperatura', 1064.0000, 'ºC'),
	(270877, 119, '2014-04-01 00:57:48.000000', 'temperatura', 1187.0000, 'ºC'),
	(270878, 119, '2014-04-01 00:57:49.000000', 'temperatura', 341.0000, 'ºC'),
	(270879, 119, '2014-04-01 00:57:50.000000', 'temperatura', 545.0000, 'ºC'),
	(270880, 119, '2014-04-01 00:57:51.000000', 'temperatura', 502.0000, 'ºC'),
	(270881, 119, '2014-04-01 00:57:52.000000', 'temperatura', 877.0000, 'ºC'),
	(270882, 119, '2014-04-01 00:57:53.000000', 'temperatura', 477.0000, 'ºC'),
	(270883, 119, '2014-04-01 00:57:54.000000', 'temperatura', 956.0000, 'ºC'),
	(270884, 119, '2014-04-01 00:57:55.000000', 'temperatura', 951.0000, 'ºC'),
	(270885, 119, '2014-04-01 00:57:56.000000', 'temperatura', 688.0000, 'ºC'),
	(270886, 119, '2014-04-01 00:57:57.000000', 'temperatura', 586.0000, 'ºC'),
	(270887, 119, '2014-04-01 00:57:58.000000', 'temperatura', 867.0000, 'ºC'),
	(270888, 119, '2014-04-01 00:57:59.000000', 'temperatura', 176.0000, 'ºC'),
	(270889, 119, '2014-04-01 00:58:00.000000', 'temperatura', 680.0000, 'ºC'),
	(270890, 119, '2014-04-01 00:58:01.000000', 'temperatura', 474.0000, 'ºC'),
	(270891, 119, '2014-04-01 00:58:02.000000', 'temperatura', 331.0000, 'ºC'),
	(270892, 119, '2014-04-01 00:58:03.000000', 'temperatura', 233.0000, 'ºC'),
	(270893, 119, '2014-04-01 00:58:04.000000', 'temperatura', 171.0000, 'ºC'),
	(270894, 119, '2014-04-01 00:58:05.000000', 'temperatura', 157.0000, 'ºC'),
	(270895, 119, '2014-04-01 00:58:06.000000', 'temperatura', 272.0000, 'ºC'),
	(270896, 119, '2014-04-01 00:58:07.000000', 'temperatura', 891.0000, 'ºC'),
	(270897, 119, '2014-04-01 00:58:08.000000', 'temperatura', 40.0000, 'ºC'),
	(270898, 119, '2014-04-01 00:58:09.000000', 'temperatura', 1125.0000, 'ºC'),
	(270899, 119, '2014-04-01 00:58:10.000000', 'temperatura', 706.0000, 'ºC'),
	(270900, 119, '2014-04-01 00:58:11.000000', 'temperatura', 156.0000, 'ºC'),
	(270901, 119, '2014-04-01 00:58:12.000000', 'temperatura', 1061.0000, 'ºC'),
	(270902, 119, '2014-04-01 00:58:13.000000', 'temperatura', 40.0000, 'ºC'),
	(270903, 119, '2014-04-01 00:58:14.000000', 'temperatura', 616.0000, 'ºC'),
	(270904, 119, '2014-04-01 00:58:15.000000', 'temperatura', 561.0000, 'ºC'),
	(270905, 119, '2014-04-01 00:58:16.000000', 'temperatura', 955.0000, 'ºC'),
	(270906, 119, '2014-04-01 00:58:17.000000', 'temperatura', 696.0000, 'ºC'),
	(270907, 119, '2014-04-01 00:58:18.000000', 'temperatura', 613.0000, 'ºC'),
	(270908, 119, '2014-04-01 00:58:19.000000', 'temperatura', 977.0000, 'ºC'),
	(270909, 119, '2014-04-01 00:58:20.000000', 'temperatura', 647.0000, 'ºC'),
	(270910, 119, '2014-04-01 00:58:21.000000', 'temperatura', 306.0000, 'ºC'),
	(270911, 119, '2014-04-01 00:58:22.000000', 'temperatura', 789.0000, 'ºC'),
	(270912, 119, '2014-04-01 00:58:23.000000', 'temperatura', 627.0000, 'ºC'),
	(270913, 119, '2014-04-01 00:58:24.000000', 'temperatura', 769.0000, 'ºC'),
	(270914, 119, '2014-04-01 00:58:25.000000', 'temperatura', 765.0000, 'ºC'),
	(270915, 119, '2014-04-01 00:58:26.000000', 'temperatura', 319.0000, 'ºC'),
	(270916, 119, '2014-04-01 00:58:27.000000', 'temperatura', 499.0000, 'ºC'),
	(270917, 119, '2014-04-01 00:58:28.000000', 'temperatura', 338.0000, 'ºC'),
	(270918, 119, '2014-04-01 00:58:29.000000', 'temperatura', 195.0000, 'ºC'),
	(270919, 119, '2014-04-01 00:58:30.000000', 'temperatura', 1159.0000, 'ºC'),
	(270920, 119, '2014-04-01 00:58:31.000000', 'temperatura', 412.0000, 'ºC'),
	(270921, 119, '2014-04-01 00:58:32.000000', 'temperatura', 985.0000, 'ºC'),
	(270922, 119, '2014-04-01 00:58:33.000000', 'temperatura', 87.0000, 'ºC'),
	(270923, 119, '2014-04-01 00:58:34.000000', 'temperatura', 1083.0000, 'ºC'),
	(270924, 119, '2014-04-01 00:58:35.000000', 'temperatura', 354.0000, 'ºC'),
	(270925, 119, '2014-04-01 00:58:36.000000', 'temperatura', 919.0000, 'ºC'),
	(270926, 119, '2014-04-01 00:58:37.000000', 'temperatura', 1135.0000, 'ºC'),
	(270927, 119, '2014-04-01 00:58:38.000000', 'temperatura', 518.0000, 'ºC'),
	(270928, 119, '2014-04-01 00:58:39.000000', 'temperatura', 387.0000, 'ºC'),
	(270929, 119, '2014-04-01 00:58:40.000000', 'temperatura', 381.0000, 'ºC'),
	(270930, 119, '2014-04-01 00:58:41.000000', 'temperatura', 745.0000, 'ºC'),
	(270931, 119, '2014-04-01 00:58:42.000000', 'temperatura', 181.0000, 'ºC'),
	(270932, 119, '2014-04-01 00:58:43.000000', 'temperatura', 1072.0000, 'ºC'),
	(270933, 119, '2014-04-01 00:58:44.000000', 'temperatura', 16.0000, 'ºC'),
	(270934, 119, '2014-04-01 00:58:45.000000', 'temperatura', 467.0000, 'ºC'),
	(270935, 119, '2014-04-01 00:58:46.000000', 'temperatura', 1085.0000, 'ºC'),
	(270936, 119, '2014-04-01 00:58:47.000000', 'temperatura', 427.0000, 'ºC'),
	(270937, 119, '2014-04-01 00:58:48.000000', 'temperatura', 81.0000, 'ºC'),
	(270938, 119, '2014-04-01 00:58:49.000000', 'temperatura', 325.0000, 'ºC'),
	(270939, 119, '2014-04-01 00:58:50.000000', 'temperatura', 180.0000, 'ºC'),
	(270940, 119, '2014-04-01 00:58:51.000000', 'temperatura', 1125.0000, 'ºC'),
	(270941, 119, '2014-04-01 00:58:52.000000', 'temperatura', 286.0000, 'ºC'),
	(270942, 119, '2014-04-01 00:58:53.000000', 'temperatura', 454.0000, 'ºC'),
	(270943, 119, '2014-04-01 00:58:54.000000', 'temperatura', 214.0000, 'ºC'),
	(270944, 119, '2014-04-01 00:58:55.000000', 'temperatura', 908.0000, 'ºC'),
	(270945, 119, '2014-04-01 00:58:56.000000', 'temperatura', 301.0000, 'ºC'),
	(270946, 119, '2014-04-01 00:58:57.000000', 'temperatura', 1178.0000, 'ºC'),
	(270947, 119, '2014-04-01 00:58:58.000000', 'temperatura', 190.0000, 'ºC'),
	(270948, 119, '2014-04-01 00:58:59.000000', 'temperatura', 1014.0000, 'ºC'),
	(270949, 119, '2014-04-01 00:59:00.000000', 'temperatura', 900.0000, 'ºC'),
	(270950, 119, '2014-04-01 00:59:01.000000', 'temperatura', 259.0000, 'ºC'),
	(270951, 119, '2014-04-01 00:59:02.000000', 'temperatura', 997.0000, 'ºC'),
	(270952, 119, '2014-04-01 00:59:03.000000', 'temperatura', 609.0000, 'ºC'),
	(270953, 119, '2014-04-01 00:59:04.000000', 'temperatura', 52.0000, 'ºC'),
	(270954, 119, '2014-04-01 00:59:05.000000', 'temperatura', 834.0000, 'ºC'),
	(270955, 119, '2014-04-01 00:59:06.000000', 'temperatura', 415.0000, 'ºC'),
	(270956, 119, '2014-04-01 00:59:07.000000', 'temperatura', 774.0000, 'ºC'),
	(270957, 119, '2014-04-01 00:59:08.000000', 'temperatura', 226.0000, 'ºC'),
	(270958, 119, '2014-04-01 00:59:09.000000', 'temperatura', 7.0000, 'ºC'),
	(270959, 119, '2014-04-01 00:59:10.000000', 'temperatura', 559.0000, 'ºC'),
	(270960, 119, '2014-04-01 00:59:11.000000', 'temperatura', 374.0000, 'ºC'),
	(270961, 119, '2014-04-01 00:59:12.000000', 'temperatura', 192.0000, 'ºC'),
	(270962, 119, '2014-04-01 00:59:13.000000', 'temperatura', 1041.0000, 'ºC'),
	(270963, 119, '2014-04-01 00:59:14.000000', 'temperatura', 1029.0000, 'ºC'),
	(270964, 119, '2014-04-01 00:59:15.000000', 'temperatura', 821.0000, 'ºC'),
	(270965, 119, '2014-04-01 00:59:16.000000', 'temperatura', 1018.0000, 'ºC'),
	(270966, 119, '2014-04-01 00:59:17.000000', 'temperatura', 227.0000, 'ºC'),
	(270967, 119, '2014-04-01 00:59:18.000000', 'temperatura', 483.0000, 'ºC'),
	(270968, 119, '2014-04-01 00:59:19.000000', 'temperatura', 536.0000, 'ºC'),
	(270969, 119, '2014-04-01 00:59:20.000000', 'temperatura', 29.0000, 'ºC'),
	(270970, 119, '2014-04-01 00:59:21.000000', 'temperatura', 938.0000, 'ºC'),
	(270971, 119, '2014-04-01 00:59:22.000000', 'temperatura', 1005.0000, 'ºC'),
	(270972, 119, '2014-04-01 00:59:23.000000', 'temperatura', 1011.0000, 'ºC'),
	(270973, 119, '2014-04-01 00:59:24.000000', 'temperatura', 841.0000, 'ºC'),
	(270974, 119, '2014-04-01 00:59:25.000000', 'temperatura', 1170.0000, 'ºC'),
	(270975, 119, '2014-04-01 00:59:26.000000', 'temperatura', 929.0000, 'ºC'),
	(270976, 119, '2014-04-01 00:59:27.000000', 'temperatura', 1135.0000, 'ºC'),
	(270977, 119, '2014-04-01 00:59:28.000000', 'temperatura', 491.0000, 'ºC'),
	(270978, 119, '2014-04-01 00:59:29.000000', 'temperatura', 248.0000, 'ºC'),
	(270979, 119, '2014-04-01 00:59:30.000000', 'temperatura', 969.0000, 'ºC'),
	(270980, 119, '2014-04-01 00:59:31.000000', 'temperatura', 501.0000, 'ºC'),
	(270981, 119, '2014-04-01 00:59:32.000000', 'temperatura', 797.0000, 'ºC'),
	(270982, 119, '2014-04-01 00:59:33.000000', 'temperatura', 85.0000, 'ºC'),
	(270983, 119, '2014-04-01 00:59:34.000000', 'temperatura', 435.0000, 'ºC'),
	(270984, 119, '2014-04-01 00:59:35.000000', 'temperatura', 720.0000, 'ºC'),
	(270985, 119, '2014-04-01 00:59:36.000000', 'temperatura', 1096.0000, 'ºC'),
	(270986, 119, '2014-04-01 00:59:37.000000', 'temperatura', 918.0000, 'ºC'),
	(270987, 119, '2014-04-01 00:59:38.000000', 'temperatura', 104.0000, 'ºC'),
	(270988, 119, '2014-04-01 00:59:39.000000', 'temperatura', 167.0000, 'ºC'),
	(270989, 119, '2014-04-01 00:59:40.000000', 'temperatura', 522.0000, 'ºC'),
	(270990, 119, '2014-04-01 00:59:41.000000', 'temperatura', 910.0000, 'ºC'),
	(270991, 119, '2014-04-01 00:59:42.000000', 'temperatura', 585.0000, 'ºC'),
	(270992, 119, '2014-04-01 00:59:43.000000', 'temperatura', 196.0000, 'ºC'),
	(270993, 119, '2014-04-01 00:59:44.000000', 'temperatura', 427.0000, 'ºC'),
	(270994, 119, '2014-04-01 00:59:45.000000', 'temperatura', 344.0000, 'ºC'),
	(270995, 119, '2014-04-01 00:59:46.000000', 'temperatura', 443.0000, 'ºC'),
	(270996, 119, '2014-04-01 00:59:47.000000', 'temperatura', 1181.0000, 'ºC'),
	(270997, 119, '2014-04-01 00:59:48.000000', 'temperatura', 977.0000, 'ºC'),
	(270998, 119, '2014-04-01 00:59:49.000000', 'temperatura', 144.0000, 'ºC'),
	(270999, 119, '2014-04-01 00:59:50.000000', 'temperatura', 190.0000, 'ºC'),
	(271000, 119, '2014-04-01 00:59:51.000000', 'temperatura', 517.0000, 'ºC'),
	(271001, 119, '2014-04-01 00:59:52.000000', 'temperatura', 817.0000, 'ºC'),
	(271002, 119, '2014-04-01 00:59:53.000000', 'temperatura', 134.0000, 'ºC'),
	(271003, 119, '2014-04-01 00:59:54.000000', 'temperatura', 620.0000, 'ºC'),
	(271004, 119, '2014-04-01 00:59:55.000000', 'temperatura', 297.0000, 'ºC'),
	(271005, 119, '2014-04-01 00:59:56.000000', 'temperatura', 826.0000, 'ºC'),
	(271006, 119, '2014-04-01 00:59:57.000000', 'temperatura', 841.0000, 'ºC'),
	(271007, 119, '2014-04-01 00:59:58.000000', 'temperatura', 528.0000, 'ºC'),
	(271008, 119, '2014-04-01 00:59:59.000000', 'temperatura', 115.0000, 'ºC'),
	(271009, 119, '2014-04-01 01:00:00.000000', 'temperatura', 191.0000, 'ºC'),
	(271010, 119, '2014-04-01 01:00:01.000000', 'temperatura', 613.0000, 'ºC'),
	(271011, 119, '2014-04-01 01:00:02.000000', 'temperatura', 93.0000, 'ºC'),
	(271012, 119, '2014-04-01 01:00:03.000000', 'temperatura', 1024.0000, 'ºC'),
	(271013, 119, '2014-04-01 01:00:04.000000', 'temperatura', 45.0000, 'ºC'),
	(271014, 119, '2014-04-01 01:00:05.000000', 'temperatura', 750.0000, 'ºC'),
	(271015, 119, '2014-04-01 01:00:06.000000', 'temperatura', 16.0000, 'ºC'),
	(271016, 119, '2014-04-01 01:00:07.000000', 'temperatura', 233.0000, 'ºC'),
	(271017, 119, '2014-04-01 01:00:08.000000', 'temperatura', 1115.0000, 'ºC'),
	(271018, 119, '2014-04-01 01:00:09.000000', 'temperatura', 75.0000, 'ºC'),
	(271019, 119, '2014-04-01 01:00:10.000000', 'temperatura', 633.0000, 'ºC'),
	(271020, 119, '2014-04-01 01:00:11.000000', 'temperatura', 539.0000, 'ºC'),
	(271021, 119, '2014-04-01 01:00:12.000000', 'temperatura', 797.0000, 'ºC'),
	(271022, 119, '2014-04-01 01:00:13.000000', 'temperatura', 1168.0000, 'ºC'),
	(271023, 119, '2014-04-01 01:00:14.000000', 'temperatura', 1051.0000, 'ºC'),
	(271024, 119, '2014-04-01 01:00:15.000000', 'temperatura', 551.0000, 'ºC'),
	(271025, 119, '2014-04-01 01:00:16.000000', 'temperatura', 804.0000, 'ºC'),
	(271026, 119, '2014-04-01 01:00:17.000000', 'temperatura', 1166.0000, 'ºC'),
	(271027, 119, '2014-04-01 01:00:18.000000', 'temperatura', 1017.0000, 'ºC'),
	(271028, 119, '2014-04-01 01:00:19.000000', 'temperatura', 387.0000, 'ºC'),
	(271029, 119, '2014-04-01 01:00:20.000000', 'temperatura', 86.0000, 'ºC'),
	(271030, 119, '2014-04-01 01:00:21.000000', 'temperatura', 469.0000, 'ºC'),
	(271031, 119, '2014-04-01 01:00:22.000000', 'temperatura', 886.0000, 'ºC'),
	(271032, 119, '2014-04-01 01:00:23.000000', 'temperatura', 625.0000, 'ºC'),
	(271033, 119, '2014-04-01 01:00:24.000000', 'temperatura', 468.0000, 'ºC'),
	(271034, 119, '2014-04-01 01:00:25.000000', 'temperatura', 467.0000, 'ºC'),
	(271035, 119, '2014-04-01 01:00:26.000000', 'temperatura', 928.0000, 'ºC'),
	(271036, 119, '2014-04-01 01:00:27.000000', 'temperatura', 841.0000, 'ºC'),
	(271037, 119, '2014-04-01 01:00:28.000000', 'temperatura', 223.0000, 'ºC'),
	(271038, 119, '2014-04-01 01:00:29.000000', 'temperatura', 992.0000, 'ºC'),
	(271039, 119, '2014-04-01 01:00:30.000000', 'temperatura', 692.0000, 'ºC'),
	(271040, 119, '2014-04-01 01:00:31.000000', 'temperatura', 486.0000, 'ºC'),
	(271041, 119, '2014-04-01 01:00:32.000000', 'temperatura', 352.0000, 'ºC'),
	(271042, 119, '2014-04-01 01:00:33.000000', 'temperatura', 305.0000, 'ºC'),
	(271043, 119, '2014-04-01 01:00:34.000000', 'temperatura', 469.0000, 'ºC'),
	(271044, 119, '2014-04-01 01:00:35.000000', 'temperatura', 229.0000, 'ºC'),
	(271045, 119, '2014-04-01 01:00:36.000000', 'temperatura', 939.0000, 'ºC'),
	(271046, 119, '2014-04-01 01:00:37.000000', 'temperatura', 408.0000, 'ºC'),
	(271047, 119, '2014-04-01 01:00:38.000000', 'temperatura', 425.0000, 'ºC'),
	(271048, 119, '2014-04-01 01:00:39.000000', 'temperatura', 902.0000, 'ºC'),
	(271049, 119, '2014-04-01 01:00:40.000000', 'temperatura', 835.0000, 'ºC'),
	(271050, 119, '2014-04-01 01:00:41.000000', 'temperatura', 270.0000, 'ºC'),
	(271051, 119, '2014-04-01 01:00:42.000000', 'temperatura', 46.0000, 'ºC'),
	(271052, 119, '2014-04-01 01:00:43.000000', 'temperatura', 618.0000, 'ºC'),
	(271053, 119, '2014-04-01 01:00:44.000000', 'temperatura', 554.0000, 'ºC'),
	(271054, 119, '2014-04-01 01:00:45.000000', 'temperatura', 915.0000, 'ºC'),
	(271055, 119, '2014-04-01 01:00:46.000000', 'temperatura', 514.0000, 'ºC'),
	(271056, 119, '2014-04-01 01:00:47.000000', 'temperatura', 1027.0000, 'ºC'),
	(271057, 119, '2014-04-01 01:00:48.000000', 'temperatura', 1192.0000, 'ºC'),
	(271058, 119, '2014-04-01 01:00:49.000000', 'temperatura', 479.0000, 'ºC'),
	(271059, 119, '2014-04-01 01:00:50.000000', 'temperatura', 22.0000, 'ºC'),
	(271060, 119, '2014-04-01 01:00:51.000000', 'temperatura', 1072.0000, 'ºC'),
	(271061, 119, '2014-04-01 01:00:52.000000', 'temperatura', 496.0000, 'ºC'),
	(271062, 119, '2014-04-01 01:00:53.000000', 'temperatura', 465.0000, 'ºC'),
	(271063, 119, '2014-04-01 01:00:54.000000', 'temperatura', 839.0000, 'ºC'),
	(271064, 119, '2014-04-01 01:00:55.000000', 'temperatura', 397.0000, 'ºC'),
	(271065, 119, '2014-04-01 01:00:56.000000', 'temperatura', 668.0000, 'ºC'),
	(271066, 119, '2014-04-01 01:00:57.000000', 'temperatura', 952.0000, 'ºC'),
	(271067, 119, '2014-04-01 01:00:58.000000', 'temperatura', 355.0000, 'ºC'),
	(271068, 119, '2014-04-01 01:00:59.000000', 'temperatura', 118.0000, 'ºC'),
	(271069, 119, '2014-04-01 01:01:00.000000', 'temperatura', 727.0000, 'ºC'),
	(271070, 119, '2014-04-01 01:01:01.000000', 'temperatura', 880.0000, 'ºC'),
	(271071, 119, '2014-04-01 01:01:02.000000', 'temperatura', 1021.0000, 'ºC'),
	(271072, 119, '2014-04-01 01:01:03.000000', 'temperatura', 64.0000, 'ºC'),
	(271073, 119, '2014-04-01 01:01:04.000000', 'temperatura', 857.0000, 'ºC'),
	(271074, 119, '2014-04-01 01:01:05.000000', 'temperatura', 496.0000, 'ºC'),
	(271075, 119, '2014-04-01 01:01:06.000000', 'temperatura', 1108.0000, 'ºC'),
	(271076, 119, '2014-04-01 01:01:07.000000', 'temperatura', 452.0000, 'ºC'),
	(271077, 119, '2014-04-01 01:01:08.000000', 'temperatura', 139.0000, 'ºC'),
	(271078, 119, '2014-04-01 01:01:09.000000', 'temperatura', 539.0000, 'ºC'),
	(271079, 119, '2014-04-01 01:01:10.000000', 'temperatura', 1077.0000, 'ºC'),
	(271080, 119, '2014-04-01 01:01:11.000000', 'temperatura', 170.0000, 'ºC'),
	(271081, 119, '2014-04-01 01:01:12.000000', 'temperatura', 19.0000, 'ºC'),
	(271082, 119, '2014-04-01 01:01:13.000000', 'temperatura', 786.0000, 'ºC'),
	(271083, 119, '2014-04-01 01:01:14.000000', 'temperatura', 274.0000, 'ºC'),
	(271084, 119, '2014-04-01 01:01:15.000000', 'temperatura', 214.0000, 'ºC'),
	(271085, 119, '2014-04-01 01:01:16.000000', 'temperatura', 245.0000, 'ºC'),
	(271086, 119, '2014-04-01 01:01:17.000000', 'temperatura', 585.0000, 'ºC'),
	(271087, 119, '2014-04-01 01:01:18.000000', 'temperatura', 991.0000, 'ºC'),
	(271088, 119, '2014-04-01 01:01:19.000000', 'temperatura', 801.0000, 'ºC'),
	(271089, 119, '2014-04-01 01:01:20.000000', 'temperatura', 1031.0000, 'ºC'),
	(271090, 119, '2014-04-01 01:01:21.000000', 'temperatura', 352.0000, 'ºC'),
	(271091, 119, '2014-04-01 01:01:22.000000', 'temperatura', 1067.0000, 'ºC'),
	(271092, 119, '2014-04-01 01:01:23.000000', 'temperatura', 680.0000, 'ºC'),
	(271093, 119, '2014-04-01 01:01:24.000000', 'temperatura', 200.0000, 'ºC'),
	(271094, 119, '2014-04-01 01:01:25.000000', 'temperatura', 159.0000, 'ºC'),
	(271095, 119, '2014-04-01 01:01:26.000000', 'temperatura', 195.0000, 'ºC'),
	(271096, 119, '2014-04-01 01:01:27.000000', 'temperatura', 500.0000, 'ºC'),
	(271097, 119, '2014-04-01 01:01:28.000000', 'temperatura', 716.0000, 'ºC'),
	(271098, 119, '2014-04-01 01:01:29.000000', 'temperatura', 882.0000, 'ºC'),
	(271099, 119, '2014-04-01 01:01:30.000000', 'temperatura', 1061.0000, 'ºC'),
	(271100, 119, '2014-04-01 01:01:31.000000', 'temperatura', 259.0000, 'ºC'),
	(271101, 119, '2014-04-01 01:01:32.000000', 'temperatura', 514.0000, 'ºC'),
	(271102, 119, '2014-04-01 01:01:33.000000', 'temperatura', 591.0000, 'ºC'),
	(271103, 119, '2014-04-01 01:01:34.000000', 'temperatura', 215.0000, 'ºC'),
	(271104, 119, '2014-04-01 01:01:35.000000', 'temperatura', 501.0000, 'ºC'),
	(271105, 119, '2014-04-01 01:01:36.000000', 'temperatura', 663.0000, 'ºC'),
	(271106, 119, '2014-04-01 01:01:37.000000', 'temperatura', 613.0000, 'ºC'),
	(271107, 119, '2014-04-01 01:01:38.000000', 'temperatura', 1077.0000, 'ºC'),
	(271108, 119, '2014-04-01 01:01:39.000000', 'temperatura', 1144.0000, 'ºC'),
	(271109, 119, '2014-04-01 01:01:40.000000', 'temperatura', 90.0000, 'ºC'),
	(271110, 119, '2014-04-01 01:01:41.000000', 'temperatura', 619.0000, 'ºC'),
	(271111, 119, '2014-04-01 01:01:42.000000', 'temperatura', 425.0000, 'ºC'),
	(271112, 119, '2014-04-01 01:01:43.000000', 'temperatura', 270.0000, 'ºC'),
	(271113, 119, '2014-04-01 01:01:44.000000', 'temperatura', 74.0000, 'ºC'),
	(271114, 119, '2014-04-01 01:01:45.000000', 'temperatura', 762.0000, 'ºC'),
	(271115, 119, '2014-04-01 01:01:46.000000', 'temperatura', 1190.0000, 'ºC'),
	(271116, 119, '2014-04-01 01:01:47.000000', 'temperatura', 61.0000, 'ºC'),
	(271117, 119, '2014-04-01 01:01:48.000000', 'temperatura', 337.0000, 'ºC'),
	(271118, 119, '2014-04-01 01:01:49.000000', 'temperatura', 302.0000, 'ºC'),
	(271119, 119, '2014-04-01 01:01:50.000000', 'temperatura', 500.0000, 'ºC'),
	(271120, 119, '2014-04-01 01:01:51.000000', 'temperatura', 393.0000, 'ºC'),
	(271121, 119, '2014-04-01 01:01:52.000000', 'temperatura', 466.0000, 'ºC'),
	(271122, 119, '2014-04-01 01:01:53.000000', 'temperatura', 1151.0000, 'ºC'),
	(271123, 119, '2014-04-01 01:01:54.000000', 'temperatura', 756.0000, 'ºC'),
	(271124, 119, '2014-04-01 01:01:55.000000', 'temperatura', 329.0000, 'ºC'),
	(271125, 119, '2014-04-01 01:01:56.000000', 'temperatura', 577.0000, 'ºC'),
	(271126, 119, '2014-04-01 01:01:57.000000', 'temperatura', 701.0000, 'ºC'),
	(271127, 119, '2014-04-01 01:01:58.000000', 'temperatura', 571.0000, 'ºC'),
	(271128, 119, '2014-04-01 01:01:59.000000', 'temperatura', 753.0000, 'ºC'),
	(271129, 119, '2014-04-01 01:02:00.000000', 'temperatura', 854.0000, 'ºC'),
	(271130, 119, '2014-04-01 01:02:01.000000', 'temperatura', 811.0000, 'ºC'),
	(271131, 119, '2014-04-01 01:02:02.000000', 'temperatura', 294.0000, 'ºC'),
	(271132, 119, '2014-04-01 01:02:03.000000', 'temperatura', 239.0000, 'ºC'),
	(271133, 119, '2014-04-01 01:02:04.000000', 'temperatura', 311.0000, 'ºC'),
	(271134, 119, '2014-04-01 01:02:05.000000', 'temperatura', 840.0000, 'ºC'),
	(271135, 119, '2014-04-01 01:02:06.000000', 'temperatura', 865.0000, 'ºC'),
	(271136, 119, '2014-04-01 01:02:07.000000', 'temperatura', 607.0000, 'ºC'),
	(271137, 119, '2014-04-01 01:02:08.000000', 'temperatura', 443.0000, 'ºC'),
	(271138, 119, '2014-04-01 01:02:09.000000', 'temperatura', 391.0000, 'ºC'),
	(271139, 119, '2014-04-01 01:02:10.000000', 'temperatura', 626.0000, 'ºC'),
	(271140, 119, '2014-04-01 01:02:11.000000', 'temperatura', 758.0000, 'ºC'),
	(271141, 119, '2014-04-01 01:02:12.000000', 'temperatura', 714.0000, 'ºC'),
	(271142, 119, '2014-04-01 01:02:13.000000', 'temperatura', 94.0000, 'ºC'),
	(271143, 119, '2014-04-01 01:02:14.000000', 'temperatura', 729.0000, 'ºC'),
	(271144, 119, '2014-04-01 01:02:15.000000', 'temperatura', 965.0000, 'ºC'),
	(271145, 119, '2014-04-01 01:02:16.000000', 'temperatura', 238.0000, 'ºC'),
	(271146, 119, '2014-04-01 01:02:17.000000', 'temperatura', 694.0000, 'ºC'),
	(271147, 119, '2014-04-01 01:02:18.000000', 'temperatura', 358.0000, 'ºC'),
	(271148, 119, '2014-04-01 01:02:19.000000', 'temperatura', 908.0000, 'ºC'),
	(271149, 119, '2014-04-01 01:02:20.000000', 'temperatura', 1068.0000, 'ºC'),
	(271150, 119, '2014-04-01 01:02:21.000000', 'temperatura', 213.0000, 'ºC'),
	(271151, 119, '2014-04-01 01:02:22.000000', 'temperatura', 265.0000, 'ºC'),
	(271152, 119, '2014-04-01 01:02:23.000000', 'temperatura', 685.0000, 'ºC'),
	(271153, 119, '2014-04-01 01:02:24.000000', 'temperatura', 230.0000, 'ºC'),
	(271154, 119, '2014-04-01 01:02:25.000000', 'temperatura', 295.0000, 'ºC'),
	(271155, 119, '2014-04-01 01:02:26.000000', 'temperatura', 786.0000, 'ºC'),
	(271156, 119, '2014-04-01 01:02:27.000000', 'temperatura', 645.0000, 'ºC'),
	(271157, 119, '2014-04-01 01:02:28.000000', 'temperatura', 868.0000, 'ºC'),
	(271158, 119, '2014-04-01 01:02:29.000000', 'temperatura', 5.0000, 'ºC'),
	(271159, 119, '2014-04-01 01:02:30.000000', 'temperatura', 1024.0000, 'ºC'),
	(271160, 119, '2014-04-01 01:02:31.000000', 'temperatura', 304.0000, 'ºC'),
	(271161, 119, '2014-04-01 01:02:32.000000', 'temperatura', 847.0000, 'ºC'),
	(271162, 119, '2014-04-01 01:02:33.000000', 'temperatura', 924.0000, 'ºC'),
	(271163, 119, '2014-04-01 01:02:34.000000', 'temperatura', 880.0000, 'ºC'),
	(271164, 119, '2014-04-01 01:02:35.000000', 'temperatura', 430.0000, 'ºC'),
	(271165, 119, '2014-04-01 01:02:36.000000', 'temperatura', 710.0000, 'ºC'),
	(271166, 119, '2014-04-01 01:02:37.000000', 'temperatura', 1062.0000, 'ºC'),
	(271167, 119, '2014-04-01 01:02:38.000000', 'temperatura', 777.0000, 'ºC'),
	(271168, 119, '2014-04-01 01:02:39.000000', 'temperatura', 702.0000, 'ºC'),
	(271169, 119, '2014-04-01 01:02:40.000000', 'temperatura', 1178.0000, 'ºC'),
	(271170, 119, '2014-04-01 01:02:41.000000', 'temperatura', 184.0000, 'ºC'),
	(271171, 119, '2014-04-01 01:02:42.000000', 'temperatura', 987.0000, 'ºC'),
	(271172, 119, '2014-04-01 01:02:43.000000', 'temperatura', 782.0000, 'ºC'),
	(271173, 119, '2014-04-01 01:02:44.000000', 'temperatura', 952.0000, 'ºC'),
	(271174, 119, '2014-04-01 01:02:45.000000', 'temperatura', 15.0000, 'ºC'),
	(271175, 119, '2014-04-01 01:02:46.000000', 'temperatura', 819.0000, 'ºC'),
	(271176, 119, '2014-04-01 01:02:47.000000', 'temperatura', 450.0000, 'ºC'),
	(271177, 119, '2014-04-01 01:02:48.000000', 'temperatura', 995.0000, 'ºC'),
	(271178, 119, '2014-04-01 01:02:49.000000', 'temperatura', 25.0000, 'ºC'),
	(271179, 119, '2014-04-01 01:02:50.000000', 'temperatura', 739.0000, 'ºC'),
	(271180, 119, '2014-04-01 01:02:51.000000', 'temperatura', 20.0000, 'ºC'),
	(271181, 119, '2014-04-01 01:02:52.000000', 'temperatura', 284.0000, 'ºC'),
	(271182, 119, '2014-04-01 01:02:53.000000', 'temperatura', 162.0000, 'ºC'),
	(271183, 119, '2014-04-01 01:02:54.000000', 'temperatura', 1159.0000, 'ºC'),
	(271184, 119, '2014-04-01 01:02:55.000000', 'temperatura', 510.0000, 'ºC'),
	(271185, 119, '2014-04-01 01:02:56.000000', 'temperatura', 271.0000, 'ºC'),
	(271186, 119, '2014-04-01 01:02:57.000000', 'temperatura', 1026.0000, 'ºC'),
	(271187, 119, '2014-04-01 01:02:58.000000', 'temperatura', 719.0000, 'ºC'),
	(271188, 119, '2014-04-01 01:02:59.000000', 'temperatura', 515.0000, 'ºC'),
	(271189, 119, '2014-04-01 01:03:00.000000', 'temperatura', 418.0000, 'ºC'),
	(271190, 119, '2014-04-01 01:03:01.000000', 'temperatura', 546.0000, 'ºC'),
	(271191, 119, '2014-04-01 01:03:02.000000', 'temperatura', 277.0000, 'ºC'),
	(271192, 119, '2014-04-01 01:03:03.000000', 'temperatura', 949.0000, 'ºC'),
	(271193, 119, '2014-04-01 01:03:04.000000', 'temperatura', 313.0000, 'ºC'),
	(271194, 119, '2014-04-01 01:03:05.000000', 'temperatura', 1117.0000, 'ºC'),
	(271195, 119, '2014-04-01 01:03:06.000000', 'temperatura', 1049.0000, 'ºC'),
	(271196, 119, '2014-04-01 01:03:07.000000', 'temperatura', 695.0000, 'ºC'),
	(271197, 119, '2014-04-01 01:03:08.000000', 'temperatura', 327.0000, 'ºC'),
	(271198, 119, '2014-04-01 01:03:09.000000', 'temperatura', 753.0000, 'ºC'),
	(271199, 119, '2014-04-01 01:03:10.000000', 'temperatura', 383.0000, 'ºC'),
	(271200, 119, '2014-04-01 01:03:11.000000', 'temperatura', 856.0000, 'ºC'),
	(271201, 119, '2014-04-01 01:03:12.000000', 'temperatura', 732.0000, 'ºC'),
	(271202, 119, '2014-04-01 01:03:13.000000', 'temperatura', 1093.0000, 'ºC'),
	(271203, 119, '2014-04-01 01:03:14.000000', 'temperatura', 870.0000, 'ºC'),
	(271204, 119, '2014-04-01 01:03:15.000000', 'temperatura', 1069.0000, 'ºC'),
	(271205, 119, '2014-04-01 01:03:16.000000', 'temperatura', 339.0000, 'ºC'),
	(271206, 119, '2014-04-01 01:03:17.000000', 'temperatura', 886.0000, 'ºC'),
	(271207, 119, '2014-04-01 01:03:18.000000', 'temperatura', 1013.0000, 'ºC'),
	(271208, 119, '2014-04-01 01:03:19.000000', 'temperatura', 9.0000, 'ºC'),
	(271209, 119, '2014-04-01 01:03:20.000000', 'temperatura', 608.0000, 'ºC'),
	(271210, 119, '2014-04-01 01:03:21.000000', 'temperatura', 610.0000, 'ºC'),
	(271211, 119, '2014-04-01 01:03:22.000000', 'temperatura', 30.0000, 'ºC'),
	(271212, 119, '2014-04-01 01:03:23.000000', 'temperatura', 717.0000, 'ºC'),
	(271213, 119, '2014-04-01 01:03:24.000000', 'temperatura', 1098.0000, 'ºC'),
	(271214, 119, '2014-04-01 01:03:25.000000', 'temperatura', 938.0000, 'ºC'),
	(271215, 119, '2014-04-01 01:03:26.000000', 'temperatura', 199.0000, 'ºC'),
	(271216, 119, '2014-04-01 01:03:27.000000', 'temperatura', 579.0000, 'ºC'),
	(271217, 119, '2014-04-01 01:03:28.000000', 'temperatura', 1098.0000, 'ºC'),
	(271218, 119, '2014-04-01 01:03:29.000000', 'temperatura', 155.0000, 'ºC'),
	(271219, 119, '2014-04-01 01:03:30.000000', 'temperatura', 1083.0000, 'ºC'),
	(271220, 119, '2014-04-01 01:03:31.000000', 'temperatura', 149.0000, 'ºC'),
	(271221, 119, '2014-04-01 01:03:32.000000', 'temperatura', 1095.0000, 'ºC'),
	(271222, 119, '2014-04-01 01:03:33.000000', 'temperatura', 228.0000, 'ºC'),
	(271223, 119, '2014-04-01 01:03:34.000000', 'temperatura', 257.0000, 'ºC'),
	(271224, 119, '2014-04-01 01:03:35.000000', 'temperatura', 603.0000, 'ºC'),
	(271225, 119, '2014-04-01 01:03:36.000000', 'temperatura', 1042.0000, 'ºC'),
	(271226, 119, '2014-04-01 01:03:37.000000', 'temperatura', 1004.0000, 'ºC'),
	(271227, 119, '2014-04-01 01:03:38.000000', 'temperatura', 695.0000, 'ºC'),
	(271228, 119, '2014-04-01 01:03:39.000000', 'temperatura', 461.0000, 'ºC'),
	(271229, 119, '2014-04-01 01:03:40.000000', 'temperatura', 223.0000, 'ºC'),
	(271230, 119, '2014-04-01 01:03:41.000000', 'temperatura', 931.0000, 'ºC'),
	(271231, 119, '2014-04-01 01:03:42.000000', 'temperatura', 386.0000, 'ºC'),
	(271232, 119, '2014-04-01 01:03:43.000000', 'temperatura', 337.0000, 'ºC'),
	(271233, 119, '2014-04-01 01:03:44.000000', 'temperatura', 529.0000, 'ºC'),
	(271234, 119, '2014-04-01 01:03:45.000000', 'temperatura', 434.0000, 'ºC'),
	(271235, 119, '2014-04-01 01:03:46.000000', 'temperatura', 584.0000, 'ºC'),
	(271236, 119, '2014-04-01 01:03:47.000000', 'temperatura', 419.0000, 'ºC'),
	(271237, 119, '2014-04-01 01:03:48.000000', 'temperatura', 342.0000, 'ºC'),
	(271238, 119, '2014-04-01 01:03:49.000000', 'temperatura', 452.0000, 'ºC'),
	(271239, 119, '2014-04-01 01:03:50.000000', 'temperatura', 38.0000, 'ºC'),
	(271240, 119, '2014-04-01 01:03:51.000000', 'temperatura', 32.0000, 'ºC'),
	(271241, 119, '2014-04-01 01:03:52.000000', 'temperatura', 48.0000, 'ºC'),
	(271242, 119, '2014-04-01 01:03:53.000000', 'temperatura', 144.0000, 'ºC'),
	(271243, 119, '2014-04-01 01:03:54.000000', 'temperatura', 574.0000, 'ºC'),
	(271244, 119, '2014-04-01 01:03:55.000000', 'temperatura', 42.0000, 'ºC'),
	(271245, 119, '2014-04-01 01:03:56.000000', 'temperatura', 887.0000, 'ºC'),
	(271246, 119, '2014-04-01 01:03:57.000000', 'temperatura', 711.0000, 'ºC'),
	(271247, 119, '2014-04-01 01:03:58.000000', 'temperatura', 895.0000, 'ºC'),
	(271248, 119, '2014-04-01 01:03:59.000000', 'temperatura', 1140.0000, 'ºC'),
	(271249, 119, '2014-04-01 01:04:00.000000', 'temperatura', 618.0000, 'ºC'),
	(271250, 119, '2014-04-01 01:04:01.000000', 'temperatura', 870.0000, 'ºC'),
	(271251, 119, '2014-04-01 01:04:02.000000', 'temperatura', 97.0000, 'ºC'),
	(271252, 119, '2014-04-01 01:04:03.000000', 'temperatura', 275.0000, 'ºC'),
	(271253, 119, '2014-04-01 01:04:04.000000', 'temperatura', 1083.0000, 'ºC'),
	(271254, 119, '2014-04-01 01:04:05.000000', 'temperatura', 992.0000, 'ºC'),
	(271255, 119, '2014-04-01 01:04:06.000000', 'temperatura', 512.0000, 'ºC'),
	(271256, 119, '2014-04-01 01:04:07.000000', 'temperatura', 783.0000, 'ºC'),
	(271257, 119, '2014-04-01 01:04:08.000000', 'temperatura', 1180.0000, 'ºC'),
	(271258, 119, '2014-04-01 01:04:09.000000', 'temperatura', 1151.0000, 'ºC'),
	(271259, 119, '2014-04-01 01:04:10.000000', 'temperatura', 1017.0000, 'ºC'),
	(271260, 119, '2014-04-01 01:04:11.000000', 'temperatura', 433.0000, 'ºC'),
	(271261, 119, '2014-04-01 01:04:12.000000', 'temperatura', 313.0000, 'ºC'),
	(271262, 119, '2014-04-01 01:04:13.000000', 'temperatura', 269.0000, 'ºC'),
	(271263, 119, '2014-04-01 01:04:14.000000', 'temperatura', 404.0000, 'ºC'),
	(271264, 119, '2014-04-01 01:04:15.000000', 'temperatura', 16.0000, 'ºC'),
	(271265, 119, '2014-04-01 01:04:16.000000', 'temperatura', 66.0000, 'ºC'),
	(271266, 119, '2014-04-01 01:04:17.000000', 'temperatura', 283.0000, 'ºC'),
	(271267, 119, '2014-04-01 01:04:18.000000', 'temperatura', 19.0000, 'ºC'),
	(271268, 119, '2014-04-01 01:04:19.000000', 'temperatura', 445.0000, 'ºC'),
	(271269, 119, '2014-04-01 01:04:20.000000', 'temperatura', 970.0000, 'ºC'),
	(271270, 119, '2014-04-01 01:04:21.000000', 'temperatura', 1114.0000, 'ºC'),
	(271271, 119, '2014-04-01 01:04:22.000000', 'temperatura', 260.0000, 'ºC'),
	(271272, 119, '2014-04-01 01:04:23.000000', 'temperatura', 357.0000, 'ºC'),
	(271273, 119, '2014-04-01 01:04:24.000000', 'temperatura', 1009.0000, 'ºC'),
	(271274, 119, '2014-04-01 01:04:25.000000', 'temperatura', 371.0000, 'ºC'),
	(271275, 119, '2014-04-01 01:04:26.000000', 'temperatura', 32.0000, 'ºC'),
	(271276, 119, '2014-04-01 01:04:27.000000', 'temperatura', 246.0000, 'ºC'),
	(271277, 119, '2014-04-01 01:04:28.000000', 'temperatura', 1135.0000, 'ºC'),
	(271278, 119, '2014-04-01 01:04:29.000000', 'temperatura', 136.0000, 'ºC'),
	(271279, 119, '2014-04-01 01:04:30.000000', 'temperatura', 877.0000, 'ºC'),
	(271280, 119, '2014-04-01 01:04:31.000000', 'temperatura', 378.0000, 'ºC'),
	(271281, 119, '2014-04-01 01:04:32.000000', 'temperatura', 459.0000, 'ºC'),
	(271282, 119, '2014-04-01 01:04:33.000000', 'temperatura', 1161.0000, 'ºC'),
	(271283, 119, '2014-04-01 01:04:34.000000', 'temperatura', 827.0000, 'ºC'),
	(271284, 119, '2014-04-01 01:04:35.000000', 'temperatura', 653.0000, 'ºC'),
	(271285, 119, '2014-04-01 01:04:36.000000', 'temperatura', 783.0000, 'ºC'),
	(271286, 119, '2014-04-01 01:04:37.000000', 'temperatura', 758.0000, 'ºC'),
	(271287, 119, '2014-04-01 01:04:38.000000', 'temperatura', 240.0000, 'ºC'),
	(271288, 119, '2014-04-01 01:04:39.000000', 'temperatura', 130.0000, 'ºC'),
	(271289, 119, '2014-04-01 01:04:40.000000', 'temperatura', 1127.0000, 'ºC'),
	(271290, 119, '2014-04-01 01:04:41.000000', 'temperatura', 445.0000, 'ºC'),
	(271291, 119, '2014-04-01 01:04:42.000000', 'temperatura', 47.0000, 'ºC'),
	(271292, 119, '2014-04-01 01:04:43.000000', 'temperatura', 99.0000, 'ºC'),
	(271293, 119, '2014-04-01 01:04:44.000000', 'temperatura', 355.0000, 'ºC'),
	(271294, 119, '2014-04-01 01:04:45.000000', 'temperatura', 278.0000, 'ºC'),
	(271295, 119, '2014-04-01 01:04:46.000000', 'temperatura', 326.0000, 'ºC'),
	(271296, 119, '2014-04-01 01:04:47.000000', 'temperatura', 795.0000, 'ºC'),
	(271297, 119, '2014-04-01 01:04:48.000000', 'temperatura', 600.0000, 'ºC'),
	(271298, 119, '2014-04-01 01:04:49.000000', 'temperatura', 613.0000, 'ºC'),
	(271299, 119, '2014-04-01 01:04:50.000000', 'temperatura', 66.0000, 'ºC'),
	(271300, 119, '2014-04-01 01:04:51.000000', 'temperatura', 892.0000, 'ºC'),
	(271301, 119, '2014-04-01 01:04:52.000000', 'temperatura', 663.0000, 'ºC'),
	(271302, 119, '2014-04-01 01:04:53.000000', 'temperatura', 639.0000, 'ºC'),
	(271303, 119, '2014-04-01 01:04:54.000000', 'temperatura', 5.0000, 'ºC'),
	(271304, 119, '2014-04-01 01:04:55.000000', 'temperatura', 511.0000, 'ºC'),
	(271305, 119, '2014-04-01 01:04:56.000000', 'temperatura', 138.0000, 'ºC'),
	(271306, 119, '2014-04-01 01:04:57.000000', 'temperatura', 359.0000, 'ºC'),
	(271307, 119, '2014-04-01 01:04:58.000000', 'temperatura', 183.0000, 'ºC'),
	(271308, 119, '2014-04-01 01:04:59.000000', 'temperatura', 1037.0000, 'ºC'),
	(271309, 119, '2014-04-01 01:05:00.000000', 'temperatura', 1036.0000, 'ºC'),
	(271310, 119, '2014-04-01 01:05:01.000000', 'temperatura', 869.0000, 'ºC'),
	(271311, 119, '2014-04-01 01:05:02.000000', 'temperatura', 36.0000, 'ºC'),
	(271312, 119, '2014-04-01 01:05:03.000000', 'temperatura', 1176.0000, 'ºC'),
	(271313, 119, '2014-04-01 01:05:04.000000', 'temperatura', 972.0000, 'ºC'),
	(271314, 119, '2014-04-01 01:05:05.000000', 'temperatura', 133.0000, 'ºC'),
	(271315, 119, '2014-04-01 01:05:06.000000', 'temperatura', 149.0000, 'ºC'),
	(271316, 119, '2014-04-01 01:05:07.000000', 'temperatura', 347.0000, 'ºC'),
	(271317, 119, '2014-04-01 01:05:08.000000', 'temperatura', 90.0000, 'ºC'),
	(271318, 119, '2014-04-01 01:05:09.000000', 'temperatura', 607.0000, 'ºC'),
	(271319, 119, '2014-04-01 01:05:10.000000', 'temperatura', 365.0000, 'ºC'),
	(271320, 119, '2014-04-01 01:05:11.000000', 'temperatura', 4.0000, 'ºC'),
	(271321, 119, '2014-04-01 01:05:12.000000', 'temperatura', 128.0000, 'ºC'),
	(271322, 119, '2014-04-01 01:05:13.000000', 'temperatura', 629.0000, 'ºC'),
	(271323, 119, '2014-04-01 01:05:14.000000', 'temperatura', 359.0000, 'ºC'),
	(271324, 119, '2014-04-01 01:05:15.000000', 'temperatura', 1111.0000, 'ºC'),
	(271325, 119, '2014-04-01 01:05:16.000000', 'temperatura', 877.0000, 'ºC'),
	(271326, 119, '2014-04-01 01:05:17.000000', 'temperatura', 1053.0000, 'ºC'),
	(271327, 119, '2014-04-01 01:05:18.000000', 'temperatura', 234.0000, 'ºC'),
	(271328, 119, '2014-04-01 01:05:19.000000', 'temperatura', 414.0000, 'ºC'),
	(271329, 119, '2014-04-01 01:05:20.000000', 'temperatura', 166.0000, 'ºC'),
	(271330, 119, '2014-04-01 01:05:21.000000', 'temperatura', 790.0000, 'ºC'),
	(271331, 119, '2014-04-01 01:05:22.000000', 'temperatura', 1053.0000, 'ºC'),
	(271332, 119, '2014-04-01 01:05:23.000000', 'temperatura', 496.0000, 'ºC'),
	(271333, 119, '2014-04-01 01:05:24.000000', 'temperatura', 521.0000, 'ºC'),
	(271334, 119, '2014-04-01 01:05:25.000000', 'temperatura', 1116.0000, 'ºC'),
	(271335, 119, '2014-04-01 01:05:26.000000', 'temperatura', 419.0000, 'ºC'),
	(271336, 119, '2014-04-01 01:05:27.000000', 'temperatura', 1146.0000, 'ºC'),
	(271337, 119, '2014-04-01 01:05:28.000000', 'temperatura', 876.0000, 'ºC'),
	(271338, 119, '2014-04-01 01:05:29.000000', 'temperatura', 942.0000, 'ºC'),
	(271339, 119, '2014-04-01 01:05:30.000000', 'temperatura', 880.0000, 'ºC'),
	(271340, 119, '2014-04-01 01:05:31.000000', 'temperatura', 376.0000, 'ºC'),
	(271341, 119, '2014-04-01 01:05:32.000000', 'temperatura', 442.0000, 'ºC'),
	(271342, 119, '2014-04-01 01:05:33.000000', 'temperatura', 1081.0000, 'ºC'),
	(271343, 119, '2014-04-01 01:05:34.000000', 'temperatura', 480.0000, 'ºC'),
	(271344, 119, '2014-04-01 01:05:35.000000', 'temperatura', 359.0000, 'ºC'),
	(271345, 119, '2014-04-01 01:05:36.000000', 'temperatura', 355.0000, 'ºC'),
	(271346, 119, '2014-04-01 01:05:37.000000', 'temperatura', 700.0000, 'ºC'),
	(271347, 119, '2014-04-01 01:05:38.000000', 'temperatura', 34.0000, 'ºC'),
	(271348, 119, '2014-04-01 01:05:39.000000', 'temperatura', 470.0000, 'ºC'),
	(271349, 119, '2014-04-01 01:05:40.000000', 'temperatura', 1048.0000, 'ºC'),
	(271350, 119, '2014-04-01 01:05:41.000000', 'temperatura', 229.0000, 'ºC'),
	(271351, 119, '2014-04-01 01:05:42.000000', 'temperatura', 404.0000, 'ºC'),
	(271352, 119, '2014-04-01 01:05:43.000000', 'temperatura', 132.0000, 'ºC'),
	(271353, 119, '2014-04-01 01:05:44.000000', 'temperatura', 649.0000, 'ºC'),
	(271354, 119, '2014-04-01 01:05:45.000000', 'temperatura', 448.0000, 'ºC'),
	(271355, 119, '2014-04-01 01:05:46.000000', 'temperatura', 294.0000, 'ºC'),
	(271356, 119, '2014-04-01 01:05:47.000000', 'temperatura', 127.0000, 'ºC'),
	(271357, 119, '2014-04-01 01:05:48.000000', 'temperatura', 952.0000, 'ºC'),
	(271358, 119, '2014-04-01 01:05:49.000000', 'temperatura', 779.0000, 'ºC'),
	(271359, 119, '2014-04-01 01:05:50.000000', 'temperatura', 1039.0000, 'ºC'),
	(271360, 119, '2014-04-01 01:05:51.000000', 'temperatura', 460.0000, 'ºC'),
	(271361, 119, '2014-04-01 01:05:52.000000', 'temperatura', 383.0000, 'ºC'),
	(271362, 119, '2014-04-01 01:05:53.000000', 'temperatura', 535.0000, 'ºC'),
	(271363, 119, '2014-04-01 01:05:54.000000', 'temperatura', 327.0000, 'ºC'),
	(271364, 119, '2014-04-01 01:05:55.000000', 'temperatura', 29.0000, 'ºC'),
	(271365, 119, '2014-04-01 01:05:56.000000', 'temperatura', 366.0000, 'ºC'),
	(271366, 119, '2014-04-01 01:05:57.000000', 'temperatura', 543.0000, 'ºC'),
	(271367, 119, '2014-04-01 01:05:58.000000', 'temperatura', 419.0000, 'ºC'),
	(271368, 119, '2014-04-01 01:05:59.000000', 'temperatura', 467.0000, 'ºC'),
	(271369, 119, '2014-04-01 01:06:00.000000', 'temperatura', 1077.0000, 'ºC'),
	(271370, 119, '2014-04-01 01:06:01.000000', 'temperatura', 383.0000, 'ºC'),
	(271371, 119, '2014-04-01 01:06:02.000000', 'temperatura', 1086.0000, 'ºC'),
	(271372, 119, '2014-04-01 01:06:03.000000', 'temperatura', 682.0000, 'ºC'),
	(271373, 119, '2014-04-01 01:06:04.000000', 'temperatura', 153.0000, 'ºC'),
	(271374, 119, '2014-04-01 01:06:05.000000', 'temperatura', 1118.0000, 'ºC'),
	(271375, 119, '2014-04-01 01:06:06.000000', 'temperatura', 331.0000, 'ºC'),
	(271376, 119, '2014-04-01 01:06:07.000000', 'temperatura', 704.0000, 'ºC'),
	(271377, 119, '2014-04-01 01:06:08.000000', 'temperatura', 126.0000, 'ºC'),
	(271378, 119, '2014-04-01 01:06:09.000000', 'temperatura', 919.0000, 'ºC'),
	(271379, 119, '2014-04-01 01:06:10.000000', 'temperatura', 617.0000, 'ºC'),
	(271380, 119, '2014-04-01 01:06:11.000000', 'temperatura', 328.0000, 'ºC'),
	(271381, 119, '2014-04-01 01:06:12.000000', 'temperatura', 991.0000, 'ºC'),
	(271382, 119, '2014-04-01 01:06:13.000000', 'temperatura', 370.0000, 'ºC'),
	(271383, 119, '2014-04-01 01:06:14.000000', 'temperatura', 78.0000, 'ºC'),
	(271384, 119, '2014-04-01 01:06:15.000000', 'temperatura', 479.0000, 'ºC'),
	(271385, 119, '2014-04-01 01:06:16.000000', 'temperatura', 962.0000, 'ºC'),
	(271386, 119, '2014-04-01 01:06:17.000000', 'temperatura', 976.0000, 'ºC'),
	(271387, 119, '2014-04-01 01:06:18.000000', 'temperatura', 791.0000, 'ºC'),
	(271388, 119, '2014-04-01 01:06:19.000000', 'temperatura', 1031.0000, 'ºC'),
	(271389, 119, '2014-04-01 01:06:20.000000', 'temperatura', 379.0000, 'ºC'),
	(271390, 119, '2014-04-01 01:06:21.000000', 'temperatura', 5.0000, 'ºC'),
	(271391, 119, '2014-04-01 01:06:22.000000', 'temperatura', 87.0000, 'ºC'),
	(271392, 119, '2014-04-01 01:06:23.000000', 'temperatura', 423.0000, 'ºC'),
	(271393, 119, '2014-04-01 01:06:24.000000', 'temperatura', 652.0000, 'ºC'),
	(271394, 119, '2014-04-01 01:06:25.000000', 'temperatura', 794.0000, 'ºC'),
	(271395, 119, '2014-04-01 01:06:26.000000', 'temperatura', 811.0000, 'ºC'),
	(271396, 119, '2014-04-01 01:06:27.000000', 'temperatura', 476.0000, 'ºC'),
	(271397, 119, '2014-04-01 01:06:28.000000', 'temperatura', 1146.0000, 'ºC'),
	(271398, 119, '2014-04-01 01:06:29.000000', 'temperatura', 703.0000, 'ºC'),
	(271399, 119, '2014-04-01 01:06:30.000000', 'temperatura', 79.0000, 'ºC'),
	(271400, 119, '2014-04-01 01:06:31.000000', 'temperatura', 687.0000, 'ºC'),
	(271401, 119, '2014-04-01 01:06:32.000000', 'temperatura', 797.0000, 'ºC'),
	(271402, 119, '2014-04-01 01:06:33.000000', 'temperatura', 727.0000, 'ºC'),
	(271403, 119, '2014-04-01 01:06:34.000000', 'temperatura', 43.0000, 'ºC'),
	(271404, 119, '2014-04-01 01:06:35.000000', 'temperatura', 433.0000, 'ºC'),
	(271405, 119, '2014-04-01 01:06:36.000000', 'temperatura', 839.0000, 'ºC'),
	(271406, 119, '2014-04-01 01:06:37.000000', 'temperatura', 497.0000, 'ºC'),
	(271407, 119, '2014-04-01 01:06:38.000000', 'temperatura', 1167.0000, 'ºC'),
	(271408, 119, '2014-04-01 01:06:39.000000', 'temperatura', 747.0000, 'ºC'),
	(271409, 119, '2014-04-01 01:06:40.000000', 'temperatura', 232.0000, 'ºC'),
	(271410, 119, '2014-04-01 01:06:41.000000', 'temperatura', 121.0000, 'ºC'),
	(271411, 119, '2014-04-01 01:06:42.000000', 'temperatura', 1108.0000, 'ºC'),
	(271412, 119, '2014-04-01 01:06:43.000000', 'temperatura', 377.0000, 'ºC'),
	(271413, 119, '2014-04-01 01:06:44.000000', 'temperatura', 963.0000, 'ºC'),
	(271414, 119, '2014-04-01 01:06:45.000000', 'temperatura', 84.0000, 'ºC'),
	(271415, 119, '2014-04-01 01:06:46.000000', 'temperatura', 1130.0000, 'ºC'),
	(271416, 119, '2014-04-01 01:06:47.000000', 'temperatura', 599.0000, 'ºC'),
	(271417, 119, '2014-04-01 01:06:48.000000', 'temperatura', 806.0000, 'ºC'),
	(271418, 119, '2014-04-01 01:06:49.000000', 'temperatura', 1033.0000, 'ºC'),
	(271419, 119, '2014-04-01 01:06:50.000000', 'temperatura', 347.0000, 'ºC'),
	(271420, 119, '2014-04-01 01:06:51.000000', 'temperatura', 1038.0000, 'ºC'),
	(271421, 119, '2014-04-01 01:06:52.000000', 'temperatura', 550.0000, 'ºC'),
	(271422, 119, '2014-04-01 01:06:53.000000', 'temperatura', 835.0000, 'ºC'),
	(271423, 119, '2014-04-01 01:06:54.000000', 'temperatura', 124.0000, 'ºC'),
	(271424, 119, '2014-04-01 01:06:55.000000', 'temperatura', 517.0000, 'ºC'),
	(271425, 119, '2014-04-01 01:06:56.000000', 'temperatura', 1011.0000, 'ºC'),
	(271426, 119, '2014-04-01 01:06:57.000000', 'temperatura', 1108.0000, 'ºC'),
	(271427, 119, '2014-04-01 01:06:58.000000', 'temperatura', 106.0000, 'ºC'),
	(271428, 119, '2014-04-01 01:06:59.000000', 'temperatura', 806.0000, 'ºC'),
	(271429, 119, '2014-04-01 01:07:00.000000', 'temperatura', 113.0000, 'ºC'),
	(271430, 119, '2014-04-01 01:07:01.000000', 'temperatura', 549.0000, 'ºC'),
	(271431, 119, '2014-04-01 01:07:02.000000', 'temperatura', 5.0000, 'ºC'),
	(271432, 119, '2014-04-01 01:07:03.000000', 'temperatura', 778.0000, 'ºC'),
	(271433, 119, '2014-04-01 01:07:04.000000', 'temperatura', 275.0000, 'ºC'),
	(271434, 119, '2014-04-01 01:07:05.000000', 'temperatura', 243.0000, 'ºC'),
	(271435, 119, '2014-04-01 01:07:06.000000', 'temperatura', 392.0000, 'ºC'),
	(271436, 119, '2014-04-01 01:07:07.000000', 'temperatura', 30.0000, 'ºC'),
	(271437, 119, '2014-04-01 01:07:08.000000', 'temperatura', 173.0000, 'ºC'),
	(271438, 119, '2014-04-01 01:07:09.000000', 'temperatura', 777.0000, 'ºC'),
	(271439, 119, '2014-04-01 01:07:10.000000', 'temperatura', 967.0000, 'ºC'),
	(271440, 119, '2014-04-01 01:07:11.000000', 'temperatura', 105.0000, 'ºC'),
	(271441, 119, '2014-04-01 01:07:12.000000', 'temperatura', 23.0000, 'ºC'),
	(271442, 119, '2014-04-01 01:07:13.000000', 'temperatura', 999.0000, 'ºC'),
	(271443, 119, '2014-04-01 01:07:14.000000', 'temperatura', 129.0000, 'ºC'),
	(271444, 119, '2014-04-01 01:07:15.000000', 'temperatura', 48.0000, 'ºC'),
	(271445, 119, '2014-04-01 01:07:16.000000', 'temperatura', 1055.0000, 'ºC'),
	(271446, 119, '2014-04-01 01:07:17.000000', 'temperatura', 329.0000, 'ºC'),
	(271447, 119, '2014-04-01 01:07:18.000000', 'temperatura', 882.0000, 'ºC'),
	(271448, 119, '2014-04-01 01:07:19.000000', 'temperatura', 1025.0000, 'ºC'),
	(271449, 119, '2014-04-01 01:07:20.000000', 'temperatura', 79.0000, 'ºC'),
	(271450, 119, '2014-04-01 01:07:21.000000', 'temperatura', 918.0000, 'ºC'),
	(271451, 119, '2014-04-01 01:07:22.000000', 'temperatura', 756.0000, 'ºC'),
	(271452, 119, '2014-04-01 01:07:23.000000', 'temperatura', 1025.0000, 'ºC'),
	(271453, 119, '2014-04-01 01:07:24.000000', 'temperatura', 460.0000, 'ºC'),
	(271454, 119, '2014-04-01 01:07:25.000000', 'temperatura', 425.0000, 'ºC'),
	(271455, 119, '2014-04-01 01:07:26.000000', 'temperatura', 743.0000, 'ºC'),
	(271456, 119, '2014-04-01 01:07:27.000000', 'temperatura', 43.0000, 'ºC'),
	(271457, 119, '2014-04-01 01:07:28.000000', 'temperatura', 384.0000, 'ºC'),
	(271458, 119, '2014-04-01 01:07:29.000000', 'temperatura', 592.0000, 'ºC'),
	(271459, 119, '2014-04-01 01:07:30.000000', 'temperatura', 610.0000, 'ºC'),
	(271460, 119, '2014-04-01 01:07:31.000000', 'temperatura', 74.0000, 'ºC'),
	(271461, 119, '2014-04-01 01:07:32.000000', 'temperatura', 941.0000, 'ºC'),
	(271462, 119, '2014-04-01 01:07:33.000000', 'temperatura', 885.0000, 'ºC'),
	(271463, 119, '2014-04-01 01:07:34.000000', 'temperatura', 399.0000, 'ºC'),
	(271464, 119, '2014-04-01 01:07:35.000000', 'temperatura', 544.0000, 'ºC'),
	(271465, 119, '2014-04-01 01:07:36.000000', 'temperatura', 321.0000, 'ºC'),
	(271466, 119, '2014-04-01 01:07:37.000000', 'temperatura', 1175.0000, 'ºC'),
	(271467, 119, '2014-04-01 01:07:38.000000', 'temperatura', 111.0000, 'ºC'),
	(271468, 119, '2014-04-01 01:07:39.000000', 'temperatura', 631.0000, 'ºC'),
	(271469, 119, '2014-04-01 01:07:40.000000', 'temperatura', 424.0000, 'ºC'),
	(271470, 119, '2014-04-01 01:07:41.000000', 'temperatura', 226.0000, 'ºC'),
	(271471, 119, '2014-04-01 01:07:42.000000', 'temperatura', 1059.0000, 'ºC'),
	(271472, 119, '2014-04-01 01:07:43.000000', 'temperatura', 1020.0000, 'ºC'),
	(271473, 119, '2014-04-01 01:07:44.000000', 'temperatura', 720.0000, 'ºC'),
	(271474, 119, '2014-04-01 01:07:45.000000', 'temperatura', 540.0000, 'ºC'),
	(271475, 119, '2014-04-01 01:07:46.000000', 'temperatura', 542.0000, 'ºC'),
	(271476, 119, '2014-04-01 01:07:47.000000', 'temperatura', 1089.0000, 'ºC'),
	(271477, 119, '2014-04-01 01:07:48.000000', 'temperatura', 222.0000, 'ºC'),
	(271478, 119, '2014-04-01 01:07:49.000000', 'temperatura', 242.0000, 'ºC'),
	(271479, 119, '2014-04-01 01:07:50.000000', 'temperatura', 544.0000, 'ºC'),
	(271480, 119, '2014-04-01 01:07:51.000000', 'temperatura', 794.0000, 'ºC'),
	(271481, 119, '2014-04-01 01:07:52.000000', 'temperatura', 1140.0000, 'ºC'),
	(271482, 119, '2014-04-01 01:07:53.000000', 'temperatura', 917.0000, 'ºC'),
	(271483, 119, '2014-04-01 01:07:54.000000', 'temperatura', 1167.0000, 'ºC'),
	(271484, 119, '2014-04-01 01:07:55.000000', 'temperatura', 685.0000, 'ºC'),
	(271485, 119, '2014-04-01 01:07:56.000000', 'temperatura', 1126.0000, 'ºC'),
	(271486, 119, '2014-04-01 01:07:57.000000', 'temperatura', 1172.0000, 'ºC'),
	(271487, 119, '2014-04-01 01:07:58.000000', 'temperatura', 83.0000, 'ºC'),
	(271488, 119, '2014-04-01 01:07:59.000000', 'temperatura', 502.0000, 'ºC'),
	(271489, 119, '2014-04-01 01:08:00.000000', 'temperatura', 1060.0000, 'ºC'),
	(271490, 119, '2014-04-01 01:08:01.000000', 'temperatura', 193.0000, 'ºC'),
	(271491, 119, '2014-04-01 01:08:02.000000', 'temperatura', 189.0000, 'ºC'),
	(271492, 119, '2014-04-01 01:08:03.000000', 'temperatura', 364.0000, 'ºC'),
	(271493, 119, '2014-04-01 01:08:04.000000', 'temperatura', 53.0000, 'ºC'),
	(271494, 119, '2014-04-01 01:08:05.000000', 'temperatura', 373.0000, 'ºC'),
	(271495, 119, '2014-04-01 01:08:06.000000', 'temperatura', 509.0000, 'ºC'),
	(271496, 119, '2014-04-01 01:08:07.000000', 'temperatura', 225.0000, 'ºC'),
	(271497, 119, '2014-04-01 01:08:08.000000', 'temperatura', 800.0000, 'ºC'),
	(271498, 119, '2014-04-01 01:08:09.000000', 'temperatura', 925.0000, 'ºC'),
	(271499, 119, '2014-04-01 01:08:10.000000', 'temperatura', 1025.0000, 'ºC'),
	(271500, 119, '2014-04-01 01:08:11.000000', 'temperatura', 1150.0000, 'ºC'),
	(271501, 119, '2014-04-01 01:08:12.000000', 'temperatura', 276.0000, 'ºC'),
	(271502, 119, '2014-04-01 01:08:13.000000', 'temperatura', 331.0000, 'ºC'),
	(271503, 119, '2014-04-01 01:08:14.000000', 'temperatura', 826.0000, 'ºC'),
	(271504, 119, '2014-04-01 01:08:15.000000', 'temperatura', 739.0000, 'ºC'),
	(271505, 119, '2014-04-01 01:08:16.000000', 'temperatura', 19.0000, 'ºC'),
	(271506, 119, '2014-04-01 01:08:17.000000', 'temperatura', 278.0000, 'ºC'),
	(271507, 119, '2014-04-01 01:08:18.000000', 'temperatura', 131.0000, 'ºC'),
	(271508, 119, '2014-04-01 01:08:19.000000', 'temperatura', 1023.0000, 'ºC'),
	(271509, 119, '2014-04-01 01:08:20.000000', 'temperatura', 1124.0000, 'ºC'),
	(271510, 119, '2014-04-01 01:08:21.000000', 'temperatura', 152.0000, 'ºC'),
	(271511, 119, '2014-04-01 01:08:22.000000', 'temperatura', 986.0000, 'ºC'),
	(271512, 119, '2014-04-01 01:08:23.000000', 'temperatura', 878.0000, 'ºC'),
	(271513, 119, '2014-04-01 01:08:24.000000', 'temperatura', 229.0000, 'ºC'),
	(271514, 119, '2014-04-01 01:08:25.000000', 'temperatura', 911.0000, 'ºC'),
	(271515, 119, '2014-04-01 01:08:26.000000', 'temperatura', 272.0000, 'ºC'),
	(271516, 119, '2014-04-01 01:08:27.000000', 'temperatura', 1025.0000, 'ºC'),
	(271517, 119, '2014-04-01 01:08:28.000000', 'temperatura', 711.0000, 'ºC'),
	(271518, 119, '2014-04-01 01:08:29.000000', 'temperatura', 478.0000, 'ºC'),
	(271519, 119, '2014-04-01 01:08:30.000000', 'temperatura', 261.0000, 'ºC'),
	(271520, 119, '2014-04-01 01:08:31.000000', 'temperatura', 1069.0000, 'ºC'),
	(271521, 119, '2014-04-01 01:08:32.000000', 'temperatura', 964.0000, 'ºC'),
	(271522, 119, '2014-04-01 01:08:33.000000', 'temperatura', 413.0000, 'ºC'),
	(271523, 119, '2014-04-01 01:08:34.000000', 'temperatura', 374.0000, 'ºC'),
	(271524, 119, '2014-04-01 01:08:35.000000', 'temperatura', 630.0000, 'ºC'),
	(271525, 119, '2014-04-01 01:08:36.000000', 'temperatura', 828.0000, 'ºC'),
	(271526, 119, '2014-04-01 01:08:37.000000', 'temperatura', 1050.0000, 'ºC'),
	(271527, 119, '2014-04-01 01:08:38.000000', 'temperatura', 366.0000, 'ºC'),
	(271528, 119, '2014-04-01 01:08:39.000000', 'temperatura', 1081.0000, 'ºC'),
	(271529, 119, '2014-04-01 01:08:40.000000', 'temperatura', 708.0000, 'ºC'),
	(271530, 119, '2014-04-01 01:08:41.000000', 'temperatura', 296.0000, 'ºC'),
	(271531, 119, '2014-04-01 01:08:42.000000', 'temperatura', 557.0000, 'ºC'),
	(271532, 119, '2014-04-01 01:08:43.000000', 'temperatura', 698.0000, 'ºC'),
	(271533, 119, '2014-04-01 01:08:44.000000', 'temperatura', 621.0000, 'ºC'),
	(271534, 119, '2014-04-01 01:08:45.000000', 'temperatura', 1012.0000, 'ºC'),
	(271535, 119, '2014-04-01 01:08:46.000000', 'temperatura', 794.0000, 'ºC'),
	(271536, 119, '2014-04-01 01:08:47.000000', 'temperatura', 938.0000, 'ºC'),
	(271537, 119, '2014-04-01 01:08:48.000000', 'temperatura', 1108.0000, 'ºC'),
	(271538, 119, '2014-04-01 01:08:49.000000', 'temperatura', 327.0000, 'ºC'),
	(271539, 119, '2014-04-01 01:08:50.000000', 'temperatura', 711.0000, 'ºC'),
	(271540, 119, '2014-04-01 01:08:51.000000', 'temperatura', 174.0000, 'ºC'),
	(271541, 119, '2014-04-01 01:08:52.000000', 'temperatura', 1139.0000, 'ºC'),
	(271542, 119, '2014-04-01 01:08:53.000000', 'temperatura', 375.0000, 'ºC'),
	(271543, 119, '2014-04-01 01:08:54.000000', 'temperatura', 856.0000, 'ºC'),
	(271544, 119, '2014-04-01 01:08:55.000000', 'temperatura', 754.0000, 'ºC'),
	(271545, 119, '2014-04-01 01:08:56.000000', 'temperatura', 4.0000, 'ºC'),
	(271546, 119, '2014-04-01 01:08:57.000000', 'temperatura', 159.0000, 'ºC'),
	(271547, 119, '2014-04-01 01:08:58.000000', 'temperatura', 782.0000, 'ºC'),
	(271548, 119, '2014-04-01 01:08:59.000000', 'temperatura', 1033.0000, 'ºC'),
	(271549, 119, '2014-04-01 01:09:00.000000', 'temperatura', 422.0000, 'ºC'),
	(271550, 119, '2014-04-01 01:09:01.000000', 'temperatura', 212.0000, 'ºC'),
	(271551, 119, '2014-04-01 01:09:02.000000', 'temperatura', 992.0000, 'ºC'),
	(271552, 119, '2014-04-01 01:09:03.000000', 'temperatura', 724.0000, 'ºC'),
	(271553, 119, '2014-04-01 01:09:04.000000', 'temperatura', 645.0000, 'ºC'),
	(271554, 119, '2014-04-01 01:09:05.000000', 'temperatura', 1054.0000, 'ºC'),
	(271555, 119, '2014-04-01 01:09:06.000000', 'temperatura', 937.0000, 'ºC'),
	(271556, 119, '2014-04-01 01:09:07.000000', 'temperatura', 322.0000, 'ºC'),
	(271557, 119, '2014-04-01 01:09:08.000000', 'temperatura', 1198.0000, 'ºC'),
	(271558, 119, '2014-04-01 01:09:09.000000', 'temperatura', 224.0000, 'ºC'),
	(271559, 119, '2014-04-01 01:09:10.000000', 'temperatura', 1129.0000, 'ºC'),
	(271560, 119, '2014-04-01 01:09:11.000000', 'temperatura', 172.0000, 'ºC'),
	(271561, 119, '2014-04-01 01:09:12.000000', 'temperatura', 1072.0000, 'ºC'),
	(271562, 119, '2014-04-01 01:09:13.000000', 'temperatura', 47.0000, 'ºC'),
	(271563, 119, '2014-04-01 01:09:14.000000', 'temperatura', 619.0000, 'ºC'),
	(271564, 119, '2014-04-01 01:09:15.000000', 'temperatura', 556.0000, 'ºC'),
	(271565, 119, '2014-04-01 01:09:16.000000', 'temperatura', 924.0000, 'ºC'),
	(271566, 119, '2014-04-01 01:09:17.000000', 'temperatura', 551.0000, 'ºC'),
	(271567, 119, '2014-04-01 01:09:18.000000', 'temperatura', 1183.0000, 'ºC'),
	(271568, 119, '2014-04-01 01:09:19.000000', 'temperatura', 663.0000, 'ºC'),
	(271569, 119, '2014-04-01 01:09:20.000000', 'temperatura', 969.0000, 'ºC'),
	(271570, 119, '2014-04-01 01:09:21.000000', 'temperatura', 453.0000, 'ºC'),
	(271571, 119, '2014-04-01 01:09:22.000000', 'temperatura', 560.0000, 'ºC'),
	(271572, 119, '2014-04-01 01:09:23.000000', 'temperatura', 242.0000, 'ºC'),
	(271573, 119, '2014-04-01 01:09:24.000000', 'temperatura', 730.0000, 'ºC'),
	(271574, 119, '2014-04-01 01:09:25.000000', 'temperatura', 522.0000, 'ºC'),
	(271575, 119, '2014-04-01 01:09:26.000000', 'temperatura', 424.0000, 'ºC'),
	(271576, 119, '2014-04-01 01:09:27.000000', 'temperatura', 553.0000, 'ºC'),
	(271577, 119, '2014-04-01 01:09:28.000000', 'temperatura', 295.0000, 'ºC'),
	(271578, 119, '2014-04-01 01:09:29.000000', 'temperatura', 1017.0000, 'ºC'),
	(271579, 119, '2014-04-01 01:09:30.000000', 'temperatura', 600.0000, 'ºC'),
	(271580, 119, '2014-04-01 01:09:31.000000', 'temperatura', 1150.0000, 'ºC'),
	(271581, 119, '2014-04-01 01:09:32.000000', 'temperatura', 352.0000, 'ºC'),
	(271582, 119, '2014-04-01 01:09:33.000000', 'temperatura', 708.0000, 'ºC'),
	(271583, 119, '2014-04-01 01:09:34.000000', 'temperatura', 85.0000, 'ºC'),
	(271584, 119, '2014-04-01 01:09:35.000000', 'temperatura', 702.0000, 'ºC'),
	(271585, 119, '2014-04-01 01:09:36.000000', 'temperatura', 856.0000, 'ºC'),
	(271586, 119, '2014-04-01 01:09:37.000000', 'temperatura', 974.0000, 'ºC'),
	(271587, 119, '2014-04-01 01:09:38.000000', 'temperatura', 1104.0000, 'ºC'),
	(271588, 119, '2014-04-01 01:09:39.000000', 'temperatura', 198.0000, 'ºC'),
	(271589, 119, '2014-04-01 01:09:40.000000', 'temperatura', 79.0000, 'ºC'),
	(271590, 119, '2014-04-01 01:09:41.000000', 'temperatura', 1002.0000, 'ºC'),
	(271591, 119, '2014-04-01 01:09:42.000000', 'temperatura', 1172.0000, 'ºC'),
	(271592, 119, '2014-04-01 01:09:43.000000', 'temperatura', 454.0000, 'ºC'),
	(271593, 119, '2014-04-01 01:09:44.000000', 'temperatura', 1154.0000, 'ºC'),
	(271594, 119, '2014-04-01 01:09:45.000000', 'temperatura', 810.0000, 'ºC'),
	(271595, 119, '2014-04-01 01:09:46.000000', 'temperatura', 587.0000, 'ºC'),
	(271596, 119, '2014-04-01 01:09:47.000000', 'temperatura', 508.0000, 'ºC'),
	(271597, 119, '2014-04-01 01:09:48.000000', 'temperatura', 778.0000, 'ºC'),
	(271598, 119, '2014-04-01 01:09:49.000000', 'temperatura', 1166.0000, 'ºC'),
	(271599, 119, '2014-04-01 01:09:50.000000', 'temperatura', 1098.0000, 'ºC'),
	(271600, 119, '2014-04-01 01:09:51.000000', 'temperatura', 790.0000, 'ºC'),
	(271601, 119, '2014-04-01 01:09:52.000000', 'temperatura', 658.0000, 'ºC'),
	(271602, 119, '2014-04-01 01:09:53.000000', 'temperatura', 919.0000, 'ºC'),
	(271603, 119, '2014-04-01 01:09:54.000000', 'temperatura', 220.0000, 'ºC'),
	(271604, 119, '2014-04-01 01:09:55.000000', 'temperatura', 747.0000, 'ºC'),
	(271605, 119, '2014-04-01 01:09:56.000000', 'temperatura', 675.0000, 'ºC'),
	(271606, 119, '2014-04-01 01:09:57.000000', 'temperatura', 1134.0000, 'ºC'),
	(271607, 119, '2014-04-01 01:09:58.000000', 'temperatura', 46.0000, 'ºC'),
	(271608, 119, '2014-04-01 01:09:59.000000', 'temperatura', 429.0000, 'ºC'),
	(271609, 119, '2014-04-01 01:10:00.000000', 'temperatura', 805.0000, 'ºC'),
	(271610, 119, '2014-04-01 01:10:01.000000', 'temperatura', 340.0000, 'ºC'),
	(271611, 119, '2014-04-01 01:10:02.000000', 'temperatura', 485.0000, 'ºC'),
	(271612, 119, '2014-04-01 01:10:03.000000', 'temperatura', 205.0000, 'ºC'),
	(271613, 119, '2014-04-01 01:10:04.000000', 'temperatura', 771.0000, 'ºC'),
	(271614, 119, '2014-04-01 01:10:05.000000', 'temperatura', 841.0000, 'ºC'),
	(271615, 119, '2014-04-01 01:10:06.000000', 'temperatura', 690.0000, 'ºC'),
	(271616, 119, '2014-04-01 01:10:07.000000', 'temperatura', 930.0000, 'ºC'),
	(271617, 119, '2014-04-01 01:10:08.000000', 'temperatura', 181.0000, 'ºC'),
	(271618, 119, '2014-04-01 01:10:09.000000', 'temperatura', 515.0000, 'ºC'),
	(271619, 119, '2014-04-01 01:10:10.000000', 'temperatura', 833.0000, 'ºC'),
	(271620, 119, '2014-04-01 01:10:11.000000', 'temperatura', 222.0000, 'ºC'),
	(271621, 119, '2014-04-01 01:10:12.000000', 'temperatura', 1010.0000, 'ºC'),
	(271622, 119, '2014-04-01 01:10:13.000000', 'temperatura', 783.0000, 'ºC'),
	(271623, 119, '2014-04-01 01:10:14.000000', 'temperatura', 888.0000, 'ºC'),
	(271624, 119, '2014-04-01 01:10:15.000000', 'temperatura', 889.0000, 'ºC'),
	(271625, 119, '2014-04-01 01:10:16.000000', 'temperatura', 584.0000, 'ºC'),
	(271626, 119, '2014-04-01 01:10:17.000000', 'temperatura', 251.0000, 'ºC'),
	(271627, 119, '2014-04-01 01:10:18.000000', 'temperatura', 705.0000, 'ºC'),
	(271628, 119, '2014-04-01 01:10:19.000000', 'temperatura', 372.0000, 'ºC'),
	(271629, 119, '2014-04-01 01:10:20.000000', 'temperatura', 947.0000, 'ºC'),
	(271630, 119, '2014-04-01 01:10:21.000000', 'temperatura', 19.0000, 'ºC'),
	(271631, 119, '2014-04-01 01:10:22.000000', 'temperatura', 855.0000, 'ºC'),
	(271632, 119, '2014-04-01 01:10:23.000000', 'temperatura', 619.0000, 'ºC'),
	(271633, 119, '2014-04-01 01:10:24.000000', 'temperatura', 530.0000, 'ºC'),
	(271634, 119, '2014-04-01 01:10:25.000000', 'temperatura', 791.0000, 'ºC'),
	(271635, 119, '2014-04-01 01:10:26.000000', 'temperatura', 1168.0000, 'ºC'),
	(271636, 119, '2014-04-01 01:10:27.000000', 'temperatura', 1068.0000, 'ºC'),
	(271637, 119, '2014-04-01 01:10:28.000000', 'temperatura', 635.0000, 'ºC'),
	(271638, 119, '2014-04-01 01:10:29.000000', 'temperatura', 1173.0000, 'ºC'),
	(271639, 119, '2014-04-01 01:10:30.000000', 'temperatura', 359.0000, 'ºC'),
	(271640, 119, '2014-04-01 01:10:31.000000', 'temperatura', 676.0000, 'ºC'),
	(271641, 119, '2014-04-01 01:10:32.000000', 'temperatura', 1106.0000, 'ºC'),
	(271642, 119, '2014-04-01 01:10:33.000000', 'temperatura', 1100.0000, 'ºC'),
	(271643, 119, '2014-04-01 01:10:34.000000', 'temperatura', 981.0000, 'ºC'),
	(271644, 119, '2014-04-01 01:10:35.000000', 'temperatura', 409.0000, 'ºC'),
	(271645, 119, '2014-04-01 01:10:36.000000', 'temperatura', 301.0000, 'ºC'),
	(271646, 119, '2014-04-01 01:10:37.000000', 'temperatura', 279.0000, 'ºC'),
	(271647, 119, '2014-04-01 01:10:38.000000', 'temperatura', 493.0000, 'ºC'),
	(271648, 119, '2014-04-01 01:10:39.000000', 'temperatura', 429.0000, 'ºC'),
	(271649, 119, '2014-04-01 01:10:40.000000', 'temperatura', 667.0000, 'ºC'),
	(271650, 119, '2014-04-01 01:10:41.000000', 'temperatura', 848.0000, 'ºC'),
	(271651, 119, '2014-04-01 01:10:42.000000', 'temperatura', 1037.0000, 'ºC'),
	(271652, 119, '2014-04-01 01:10:43.000000', 'temperatura', 245.0000, 'ºC'),
	(271653, 119, '2014-04-01 01:10:44.000000', 'temperatura', 512.0000, 'ºC'),
	(271654, 119, '2014-04-01 01:10:45.000000', 'temperatura', 626.0000, 'ºC'),
	(271655, 119, '2014-04-01 01:10:46.000000', 'temperatura', 394.0000, 'ºC'),
	(271656, 119, '2014-04-01 01:10:47.000000', 'temperatura', 94.0000, 'ºC'),
	(271657, 119, '2014-04-01 01:10:48.000000', 'temperatura', 486.0000, 'ºC'),
	(271658, 119, '2014-04-01 01:10:49.000000', 'temperatura', 949.0000, 'ºC'),
	(271659, 119, '2014-04-01 01:10:50.000000', 'temperatura', 890.0000, 'ºC'),
	(271660, 119, '2014-04-01 01:10:51.000000', 'temperatura', 400.0000, 'ºC'),
	(271661, 119, '2014-04-01 01:10:52.000000', 'temperatura', 532.0000, 'ºC'),
	(271662, 119, '2014-04-01 01:10:53.000000', 'temperatura', 261.0000, 'ºC'),
	(271663, 119, '2014-04-01 01:10:54.000000', 'temperatura', 910.0000, 'ºC'),
	(271664, 119, '2014-04-01 01:10:55.000000', 'temperatura', 165.0000, 'ºC'),
	(271665, 119, '2014-04-01 01:10:56.000000', 'temperatura', 498.0000, 'ºC'),
	(271666, 119, '2014-04-01 01:10:57.000000', 'temperatura', 793.0000, 'ºC'),
	(271667, 119, '2014-04-01 01:10:58.000000', 'temperatura', 73.0000, 'ºC'),
	(271668, 119, '2014-04-01 01:10:59.000000', 'temperatura', 387.0000, 'ºC'),
	(271669, 119, '2014-04-01 01:11:00.000000', 'temperatura', 516.0000, 'ºC'),
	(271670, 119, '2014-04-01 01:11:01.000000', 'temperatura', 219.0000, 'ºC'),
	(271671, 119, '2014-04-01 01:11:02.000000', 'temperatura', 749.0000, 'ºC'),
	(271672, 119, '2014-04-01 01:11:03.000000', 'temperatura', 688.0000, 'ºC'),
	(271673, 119, '2014-04-01 01:11:04.000000', 'temperatura', 1192.0000, 'ºC'),
	(271674, 119, '2014-04-01 01:11:05.000000', 'temperatura', 297.0000, 'ºC'),
	(271675, 119, '2014-04-01 01:11:06.000000', 'temperatura', 308.0000, 'ºC'),
	(271676, 119, '2014-04-01 01:11:07.000000', 'temperatura', 653.0000, 'ºC'),
	(271677, 119, '2014-04-01 01:11:08.000000', 'temperatura', 1139.0000, 'ºC'),
	(271678, 119, '2014-04-01 01:11:09.000000', 'temperatura', 137.0000, 'ºC'),
	(271679, 119, '2014-04-01 01:11:10.000000', 'temperatura', 869.0000, 'ºC'),
	(271680, 119, '2014-04-01 01:11:11.000000', 'temperatura', 333.0000, 'ºC'),
	(271681, 119, '2014-04-01 01:11:12.000000', 'temperatura', 259.0000, 'ºC'),
	(271682, 119, '2014-04-01 01:11:13.000000', 'temperatura', 296.0000, 'ºC'),
	(271683, 119, '2014-04-01 01:11:14.000000', 'temperatura', 703.0000, 'ºC'),
	(271684, 119, '2014-04-01 01:11:15.000000', 'temperatura', 227.0000, 'ºC'),
	(271685, 119, '2014-04-01 01:11:16.000000', 'temperatura', 228.0000, 'ºC'),
	(271686, 119, '2014-04-01 01:11:17.000000', 'temperatura', 459.0000, 'ºC'),
	(271687, 119, '2014-04-01 01:11:18.000000', 'temperatura', 413.0000, 'ºC'),
	(271688, 119, '2014-04-01 01:11:19.000000', 'temperatura', 689.0000, 'ºC'),
	(271689, 119, '2014-04-01 01:11:20.000000', 'temperatura', 1005.0000, 'ºC'),
	(271690, 119, '2014-04-01 01:11:21.000000', 'temperatura', 557.0000, 'ºC'),
	(271691, 119, '2014-04-01 01:11:22.000000', 'temperatura', 972.0000, 'ºC'),
	(271692, 119, '2014-04-01 01:11:23.000000', 'temperatura', 791.0000, 'ºC'),
	(271693, 119, '2014-04-01 01:11:24.000000', 'temperatura', 1040.0000, 'ºC'),
	(271694, 119, '2014-04-01 01:11:25.000000', 'temperatura', 428.0000, 'ºC'),
	(271695, 119, '2014-04-01 01:11:26.000000', 'temperatura', 218.0000, 'ºC'),
	(271696, 119, '2014-04-01 01:11:27.000000', 'temperatura', 1008.0000, 'ºC'),
	(271697, 119, '2014-04-01 01:11:28.000000', 'temperatura', 786.0000, 'ºC'),
	(271698, 119, '2014-04-01 01:11:29.000000', 'temperatura', 907.0000, 'ºC'),
	(271699, 119, '2014-04-01 01:11:30.000000', 'temperatura', 977.0000, 'ºC'),
	(271700, 119, '2014-04-01 01:11:31.000000', 'temperatura', 964.0000, 'ºC'),
	(271701, 119, '2014-04-01 01:11:32.000000', 'temperatura', 689.0000, 'ºC'),
	(271702, 119, '2014-04-01 01:11:33.000000', 'temperatura', 555.0000, 'ºC'),
	(271703, 119, '2014-04-01 01:11:34.000000', 'temperatura', 706.0000, 'ºC'),
	(271704, 119, '2014-04-01 01:11:35.000000', 'temperatura', 668.0000, 'ºC'),
	(271705, 119, '2014-04-01 01:11:36.000000', 'temperatura', 22.0000, 'ºC'),
	(271706, 119, '2014-04-01 01:11:37.000000', 'temperatura', 508.0000, 'ºC'),
	(271707, 119, '2014-04-01 01:11:38.000000', 'temperatura', 73.0000, 'ºC'),
	(271708, 119, '2014-04-01 01:11:39.000000', 'temperatura', 41.0000, 'ºC'),
	(271709, 119, '2014-04-01 01:11:40.000000', 'temperatura', 1186.0000, 'ºC'),
	(271710, 119, '2014-04-01 01:11:41.000000', 'temperatura', 1010.0000, 'ºC'),
	(271711, 119, '2014-04-01 01:11:42.000000', 'temperatura', 292.0000, 'ºC'),
	(271712, 119, '2014-04-01 01:11:43.000000', 'temperatura', 832.0000, 'ºC'),
	(271713, 119, '2014-04-01 01:11:44.000000', 'temperatura', 882.0000, 'ºC'),
	(271714, 119, '2014-04-01 01:11:45.000000', 'temperatura', 715.0000, 'ºC'),
	(271715, 119, '2014-04-01 01:11:46.000000', 'temperatura', 930.0000, 'ºC'),
	(271716, 119, '2014-04-01 01:11:47.000000', 'temperatura', 107.0000, 'ºC'),
	(271717, 119, '2014-04-01 01:11:48.000000', 'temperatura', 144.0000, 'ºC'),
	(271718, 119, '2014-04-01 01:11:49.000000', 'temperatura', 398.0000, 'ºC'),
	(271719, 119, '2014-04-01 01:11:50.000000', 'temperatura', 359.0000, 'ºC'),
	(271720, 119, '2014-04-01 01:11:51.000000', 'temperatura', 603.0000, 'ºC'),
	(271721, 119, '2014-04-01 01:11:52.000000', 'temperatura', 740.0000, 'ºC'),
	(271722, 119, '2014-04-01 01:11:53.000000', 'temperatura', 688.0000, 'ºC'),
	(271723, 119, '2014-04-01 01:11:54.000000', 'temperatura', 22.0000, 'ºC'),
	(271724, 119, '2014-04-01 01:11:55.000000', 'temperatura', 445.0000, 'ºC'),
	(271725, 119, '2014-04-01 01:11:56.000000', 'temperatura', 962.0000, 'ºC'),
	(271726, 119, '2014-04-01 01:11:57.000000', 'temperatura', 1073.0000, 'ºC'),
	(271727, 119, '2014-04-01 01:11:58.000000', 'temperatura', 80.0000, 'ºC'),
	(271728, 119, '2014-04-01 01:11:59.000000', 'temperatura', 781.0000, 'ºC'),
	(271729, 119, '2014-04-01 01:12:00.000000', 'temperatura', 67.0000, 'ºC'),
	(271730, 119, '2014-04-01 01:12:01.000000', 'temperatura', 394.0000, 'ºC'),
	(271731, 119, '2014-04-01 01:12:02.000000', 'temperatura', 566.0000, 'ºC'),
	(271732, 119, '2014-04-01 01:12:03.000000', 'temperatura', 450.0000, 'ºC'),
	(271733, 119, '2014-04-01 01:12:04.000000', 'temperatura', 554.0000, 'ºC'),
	(271734, 119, '2014-04-01 01:12:05.000000', 'temperatura', 221.0000, 'ºC'),
	(271735, 119, '2014-04-01 01:12:06.000000', 'temperatura', 643.0000, 'ºC'),
	(271736, 119, '2014-04-01 01:12:07.000000', 'temperatura', 154.0000, 'ºC'),
	(271737, 119, '2014-04-01 01:12:08.000000', 'temperatura', 39.0000, 'ºC'),
	(271738, 119, '2014-04-01 01:12:09.000000', 'temperatura', 933.0000, 'ºC'),
	(271739, 119, '2014-04-01 01:12:10.000000', 'temperatura', 948.0000, 'ºC'),
	(271740, 119, '2014-04-01 01:12:11.000000', 'temperatura', 744.0000, 'ºC'),
	(271741, 119, '2014-04-01 01:12:12.000000', 'temperatura', 874.0000, 'ºC'),
	(271742, 119, '2014-04-01 01:12:13.000000', 'temperatura', 941.0000, 'ºC'),
	(271743, 119, '2014-04-01 01:12:14.000000', 'temperatura', 884.0000, 'ºC'),
	(271744, 119, '2014-04-01 01:12:15.000000', 'temperatura', 398.0000, 'ºC'),
	(271745, 119, '2014-04-01 01:12:16.000000', 'temperatura', 538.0000, 'ºC'),
	(271746, 119, '2014-04-01 01:12:17.000000', 'temperatura', 296.0000, 'ºC'),
	(271747, 119, '2014-04-01 01:12:18.000000', 'temperatura', 1069.0000, 'ºC'),
	(271748, 119, '2014-04-01 01:12:19.000000', 'temperatura', 854.0000, 'ºC'),
	(271749, 119, '2014-04-01 01:12:20.000000', 'temperatura', 1063.0000, 'ºC'),
	(271750, 119, '2014-04-01 01:12:21.000000', 'temperatura', 357.0000, 'ºC'),
	(271751, 119, '2014-04-01 01:12:22.000000', 'temperatura', 993.0000, 'ºC'),
	(271752, 119, '2014-04-01 01:12:23.000000', 'temperatura', 296.0000, 'ºC'),
	(271753, 119, '2014-04-01 01:12:24.000000', 'temperatura', 900.0000, 'ºC'),
	(271754, 119, '2014-04-01 01:12:25.000000', 'temperatura', 15.0000, 'ºC'),
	(271755, 119, '2014-04-01 01:12:26.000000', 'temperatura', 977.0000, 'ºC'),
	(271756, 119, '2014-04-01 01:12:27.000000', 'temperatura', 37.0000, 'ºC'),
	(271757, 119, '2014-04-01 01:12:28.000000', 'temperatura', 855.0000, 'ºC'),
	(271758, 119, '2014-04-01 01:12:29.000000', 'temperatura', 565.0000, 'ºC'),
	(271759, 119, '2014-04-01 01:12:30.000000', 'temperatura', 259.0000, 'ºC'),
	(271760, 119, '2014-04-01 01:12:31.000000', 'temperatura', 800.0000, 'ºC'),
	(271761, 119, '2014-04-01 01:12:32.000000', 'temperatura', 825.0000, 'ºC'),
	(271762, 119, '2014-04-01 01:12:33.000000', 'temperatura', 526.0000, 'ºC'),
	(271763, 119, '2014-04-01 01:12:34.000000', 'temperatura', 154.0000, 'ºC'),
	(271764, 119, '2014-04-01 01:12:35.000000', 'temperatura', 391.0000, 'ºC'),
	(271765, 119, '2014-04-01 01:12:36.000000', 'temperatura', 297.0000, 'ºC'),
	(271766, 119, '2014-04-01 01:12:37.000000', 'temperatura', 310.0000, 'ºC'),
	(271767, 119, '2014-04-01 01:12:38.000000', 'temperatura', 662.0000, 'ºC'),
	(271768, 119, '2014-04-01 01:12:39.000000', 'temperatura', 1178.0000, 'ºC'),
	(271769, 119, '2014-04-01 01:12:40.000000', 'temperatura', 304.0000, 'ºC'),
	(271770, 119, '2014-04-01 01:12:41.000000', 'temperatura', 387.0000, 'ºC'),
	(271771, 119, '2014-04-01 01:12:42.000000', 'temperatura', 1023.0000, 'ºC'),
	(271772, 119, '2014-04-01 01:12:43.000000', 'temperatura', 357.0000, 'ºC'),
	(271773, 119, '2014-04-01 01:12:44.000000', 'temperatura', 1113.0000, 'ºC'),
	(271774, 119, '2014-04-01 01:12:45.000000', 'temperatura', 897.0000, 'ºC'),
	(271775, 119, '2014-04-01 01:12:46.000000', 'temperatura', 1146.0000, 'ºC'),
	(271776, 119, '2014-04-01 01:12:47.000000', 'temperatura', 641.0000, 'ºC'),
	(271777, 119, '2014-04-01 01:12:48.000000', 'temperatura', 967.0000, 'ºC'),
	(271778, 119, '2014-04-01 01:12:49.000000', 'temperatura', 513.0000, 'ºC'),
	(271779, 119, '2014-04-01 01:12:50.000000', 'temperatura', 866.0000, 'ºC'),
	(271780, 119, '2014-04-01 01:12:51.000000', 'temperatura', 389.0000, 'ºC'),
	(271781, 119, '2014-04-01 01:12:52.000000', 'temperatura', 548.0000, 'ºC'),
	(271782, 119, '2014-04-01 01:12:53.000000', 'temperatura', 372.0000, 'ºC'),
	(271783, 119, '2014-04-01 01:12:54.000000', 'temperatura', 219.0000, 'ºC'),
	(271784, 119, '2014-04-01 01:12:55.000000', 'temperatura', 1180.0000, 'ºC'),
	(271785, 119, '2014-04-01 01:12:56.000000', 'temperatura', 444.0000, 'ºC'),
	(271786, 119, '2014-04-01 01:12:57.000000', 'temperatura', 1077.0000, 'ºC'),
	(271787, 119, '2014-04-01 01:12:58.000000', 'temperatura', 457.0000, 'ºC'),
	(271788, 119, '2014-04-01 01:12:59.000000', 'temperatura', 252.0000, 'ºC'),
	(271789, 119, '2014-04-01 01:13:00.000000', 'temperatura', 1091.0000, 'ºC'),
	(271790, 119, '2014-04-01 01:13:01.000000', 'temperatura', 1100.0000, 'ºC'),
	(271791, 119, '2014-04-01 01:13:02.000000', 'temperatura', 1028.0000, 'ºC'),
	(271792, 119, '2014-04-01 01:13:03.000000', 'temperatura', 638.0000, 'ºC'),
	(271793, 119, '2014-04-01 01:13:04.000000', 'temperatura', 109.0000, 'ºC'),
	(271794, 119, '2014-04-01 01:13:05.000000', 'temperatura', 1032.0000, 'ºC'),
	(271795, 119, '2014-04-01 01:13:06.000000', 'temperatura', 32.0000, 'ºC'),
	(271796, 119, '2014-04-01 01:13:07.000000', 'temperatura', 667.0000, 'ºC'),
	(271797, 119, '2014-04-01 01:13:08.000000', 'temperatura', 837.0000, 'ºC'),
	(271798, 119, '2014-04-01 01:13:09.000000', 'temperatura', 987.0000, 'ºC'),
	(271799, 119, '2014-04-01 01:13:10.000000', 'temperatura', 23.0000, 'ºC'),
	(271800, 119, '2014-04-01 01:13:11.000000', 'temperatura', 753.0000, 'ºC'),
	(271801, 119, '2014-04-01 01:13:12.000000', 'temperatura', 97.0000, 'ºC'),
	(271802, 119, '2014-04-01 01:13:13.000000', 'temperatura', 626.0000, 'ºC'),
	(271803, 119, '2014-04-01 01:13:14.000000', 'temperatura', 442.0000, 'ºC'),
	(271804, 119, '2014-04-01 01:13:15.000000', 'temperatura', 329.0000, 'ºC'),
	(271805, 119, '2014-04-01 01:13:16.000000', 'temperatura', 322.0000, 'ºC'),
	(271806, 119, '2014-04-01 01:13:17.000000', 'temperatura', 623.0000, 'ºC'),
	(271807, 119, '2014-04-01 01:13:18.000000', 'temperatura', 949.0000, 'ºC'),
	(271808, 119, '2014-04-01 01:13:19.000000', 'temperatura', 476.0000, 'ºC'),
	(271809, 119, '2014-04-01 01:13:20.000000', 'temperatura', 736.0000, 'ºC'),
	(271810, 119, '2014-04-01 01:13:21.000000', 'temperatura', 1050.0000, 'ºC'),
	(271811, 119, '2014-04-01 01:13:22.000000', 'temperatura', 644.0000, 'ºC'),
	(271812, 119, '2014-04-01 01:13:23.000000', 'temperatura', 69.0000, 'ºC'),
	(271813, 119, '2014-04-01 01:13:24.000000', 'temperatura', 816.0000, 'ºC'),
	(271814, 119, '2014-04-01 01:13:25.000000', 'temperatura', 272.0000, 'ºC'),
	(271815, 119, '2014-04-01 01:13:26.000000', 'temperatura', 115.0000, 'ºC'),
	(271816, 119, '2014-04-01 01:13:27.000000', 'temperatura', 956.0000, 'ºC'),
	(271817, 119, '2014-04-01 01:13:28.000000', 'temperatura', 837.0000, 'ºC'),
	(271818, 119, '2014-04-01 01:13:29.000000', 'temperatura', 115.0000, 'ºC'),
	(271819, 119, '2014-04-01 01:13:30.000000', 'temperatura', 468.0000, 'ºC'),
	(271820, 119, '2014-04-01 01:13:31.000000', 'temperatura', 795.0000, 'ºC'),
	(271821, 119, '2014-04-01 01:13:32.000000', 'temperatura', 171.0000, 'ºC'),
	(271822, 119, '2014-04-01 01:13:33.000000', 'temperatura', 869.0000, 'ºC'),
	(271823, 119, '2014-04-01 01:13:34.000000', 'temperatura', 233.0000, 'ºC'),
	(271824, 119, '2014-04-01 01:13:35.000000', 'temperatura', 960.0000, 'ºC'),
	(271825, 119, '2014-04-01 01:13:36.000000', 'temperatura', 502.0000, 'ºC'),
	(271826, 119, '2014-04-01 01:13:37.000000', 'temperatura', 828.0000, 'ºC'),
	(271827, 119, '2014-04-01 01:13:38.000000', 'temperatura', 235.0000, 'ºC'),
	(271828, 119, '2014-04-01 01:13:39.000000', 'temperatura', 1094.0000, 'ºC'),
	(271829, 119, '2014-04-01 01:13:40.000000', 'temperatura', 1164.0000, 'ºC'),
	(271830, 119, '2014-04-01 01:13:41.000000', 'temperatura', 138.0000, 'ºC'),
	(271831, 119, '2014-04-01 01:13:42.000000', 'temperatura', 801.0000, 'ºC'),
	(271832, 119, '2014-04-01 01:13:43.000000', 'temperatura', 1190.0000, 'ºC'),
	(271833, 119, '2014-04-01 01:13:44.000000', 'temperatura', 1146.0000, 'ºC'),
	(271834, 119, '2014-04-01 01:13:45.000000', 'temperatura', 961.0000, 'ºC'),
	(271835, 119, '2014-04-01 01:13:46.000000', 'temperatura', 167.0000, 'ºC'),
	(271836, 119, '2014-04-01 01:13:47.000000', 'temperatura', 355.0000, 'ºC'),
	(271837, 119, '2014-04-01 01:13:48.000000', 'temperatura', 73.0000, 'ºC'),
	(271838, 119, '2014-04-01 01:13:49.000000', 'temperatura', 500.0000, 'ºC'),
	(271839, 119, '2014-04-01 01:13:50.000000', 'temperatura', 1081.0000, 'ºC'),
	(271840, 119, '2014-04-01 01:13:51.000000', 'temperatura', 307.0000, 'ºC'),
	(271841, 119, '2014-04-01 01:13:52.000000', 'temperatura', 690.0000, 'ºC'),
	(271842, 119, '2014-04-01 01:13:53.000000', 'temperatura', 130.0000, 'ºC'),
	(271843, 119, '2014-04-01 01:13:54.000000', 'temperatura', 983.0000, 'ºC'),
	(271844, 119, '2014-04-01 01:13:55.000000', 'temperatura', 924.0000, 'ºC'),
	(271845, 119, '2014-04-01 01:13:56.000000', 'temperatura', 473.0000, 'ºC'),
	(271846, 119, '2014-04-01 01:13:57.000000', 'temperatura', 794.0000, 'ºC'),
	(271847, 119, '2014-04-01 01:13:58.000000', 'temperatura', 151.0000, 'ºC'),
	(271848, 119, '2014-04-01 01:13:59.000000', 'temperatura', 774.0000, 'ºC'),
	(271849, 119, '2014-04-01 01:14:00.000000', 'temperatura', 1015.0000, 'ºC'),
	(271850, 119, '2014-04-01 01:14:01.000000', 'temperatura', 357.0000, 'ºC'),
	(271851, 119, '2014-04-01 01:14:02.000000', 'temperatura', 1138.0000, 'ºC'),
	(271852, 119, '2014-04-01 01:14:03.000000', 'temperatura', 1022.0000, 'ºC'),
	(271853, 119, '2014-04-01 01:14:04.000000', 'temperatura', 495.0000, 'ºC'),
	(271854, 119, '2014-04-01 01:14:05.000000', 'temperatura', 610.0000, 'ºC'),
	(271855, 119, '2014-04-01 01:14:06.000000', 'temperatura', 364.0000, 'ºC'),
	(271856, 119, '2014-04-01 01:14:07.000000', 'temperatura', 1192.0000, 'ºC'),
	(271857, 119, '2014-04-01 01:14:08.000000', 'temperatura', 69.0000, 'ºC'),
	(271858, 119, '2014-04-01 01:14:09.000000', 'temperatura', 370.0000, 'ºC'),
	(271859, 119, '2014-04-01 01:14:10.000000', 'temperatura', 441.0000, 'ºC'),
	(271860, 119, '2014-04-01 01:14:11.000000', 'temperatura', 1095.0000, 'ºC'),
	(271861, 119, '2014-04-01 01:14:12.000000', 'temperatura', 553.0000, 'ºC'),
	(271862, 119, '2014-04-01 01:14:13.000000', 'temperatura', 681.0000, 'ºC'),
	(271863, 119, '2014-04-01 01:14:14.000000', 'temperatura', 547.0000, 'ºC'),
	(271864, 119, '2014-04-01 01:14:15.000000', 'temperatura', 691.0000, 'ºC'),
	(271865, 119, '2014-04-01 01:14:16.000000', 'temperatura', 614.0000, 'ºC'),
	(271866, 119, '2014-04-01 01:14:17.000000', 'temperatura', 996.0000, 'ºC'),
	(271867, 119, '2014-04-01 01:14:18.000000', 'temperatura', 741.0000, 'ºC'),
	(271868, 119, '2014-04-01 01:14:19.000000', 'temperatura', 718.0000, 'ºC'),
	(271869, 119, '2014-04-01 01:14:20.000000', 'temperatura', 168.0000, 'ºC'),
	(271870, 119, '2014-04-01 01:14:21.000000', 'temperatura', 1084.0000, 'ºC'),
	(271871, 119, '2014-04-01 01:14:22.000000', 'temperatura', 117.0000, 'ºC'),
	(271872, 119, '2014-04-01 01:14:23.000000', 'temperatura', 934.0000, 'ºC'),
	(271873, 119, '2014-04-01 01:14:24.000000', 'temperatura', 721.0000, 'ºC'),
	(271874, 119, '2014-04-01 01:14:25.000000', 'temperatura', 800.0000, 'ºC'),
	(271875, 119, '2014-04-01 01:14:26.000000', 'temperatura', 641.0000, 'ºC'),
	(271876, 119, '2014-04-01 01:14:27.000000', 'temperatura', 803.0000, 'ºC'),
	(271877, 119, '2014-04-01 01:14:28.000000', 'temperatura', 893.0000, 'ºC'),
	(271878, 119, '2014-04-01 01:14:29.000000', 'temperatura', 857.0000, 'ºC'),
	(271879, 119, '2014-04-01 01:14:30.000000', 'temperatura', 407.0000, 'ºC'),
	(271880, 119, '2014-04-01 01:14:31.000000', 'temperatura', 666.0000, 'ºC'),
	(271881, 119, '2014-04-01 01:14:32.000000', 'temperatura', 908.0000, 'ºC'),
	(271882, 119, '2014-04-01 01:14:33.000000', 'temperatura', 144.0000, 'ºC'),
	(271883, 119, '2014-04-01 01:14:34.000000', 'temperatura', 397.0000, 'ºC'),
	(271884, 119, '2014-04-01 01:14:35.000000', 'temperatura', 353.0000, 'ºC'),
	(271885, 119, '2014-04-01 01:14:36.000000', 'temperatura', 573.0000, 'ºC'),
	(271886, 119, '2014-04-01 01:14:37.000000', 'temperatura', 606.0000, 'ºC'),
	(271887, 119, '2014-04-01 01:14:38.000000', 'temperatura', 114.0000, 'ºC'),
	(271888, 119, '2014-04-01 01:14:39.000000', 'temperatura', 1153.0000, 'ºC'),
	(271889, 119, '2014-04-01 01:14:40.000000', 'temperatura', 623.0000, 'ºC'),
	(271890, 119, '2014-04-01 01:14:41.000000', 'temperatura', 856.0000, 'ºC'),
	(271891, 119, '2014-04-01 01:14:42.000000', 'temperatura', 13.0000, 'ºC'),
	(271892, 119, '2014-04-01 01:14:43.000000', 'temperatura', 1096.0000, 'ºC'),
	(271893, 119, '2014-04-01 01:14:44.000000', 'temperatura', 643.0000, 'ºC'),
	(271894, 119, '2014-04-01 01:14:45.000000', 'temperatura', 1127.0000, 'ºC'),
	(271895, 119, '2014-04-01 01:14:46.000000', 'temperatura', 105.0000, 'ºC'),
	(271896, 119, '2014-04-01 01:14:47.000000', 'temperatura', 744.0000, 'ºC'),
	(271897, 119, '2014-04-01 01:14:48.000000', 'temperatura', 1005.0000, 'ºC'),
	(271898, 119, '2014-04-01 01:14:49.000000', 'temperatura', 393.0000, 'ºC'),
	(271899, 119, '2014-04-01 01:14:50.000000', 'temperatura', 150.0000, 'ºC'),
	(271900, 119, '2014-04-01 01:14:51.000000', 'temperatura', 773.0000, 'ºC'),
	(271901, 119, '2014-04-01 01:14:52.000000', 'temperatura', 1014.0000, 'ºC'),
	(271902, 119, '2014-04-01 01:14:53.000000', 'temperatura', 351.0000, 'ºC'),
	(271903, 119, '2014-04-01 01:14:54.000000', 'temperatura', 1114.0000, 'ºC'),
	(271904, 119, '2014-04-01 01:14:55.000000', 'temperatura', 919.0000, 'ºC'),
	(271905, 119, '2014-04-01 01:14:56.000000', 'temperatura', 54.0000, 'ºC'),
	(271906, 119, '2014-04-01 01:14:57.000000', 'temperatura', 1113.0000, 'ºC'),
	(271907, 119, '2014-04-01 01:14:58.000000', 'temperatura', 605.0000, 'ºC'),
	(271908, 119, '2014-04-01 01:14:59.000000', 'temperatura', 884.0000, 'ºC'),
	(271909, 119, '2014-04-01 01:15:00.000000', 'temperatura', 207.0000, 'ºC'),
	(271910, 119, '2014-04-01 01:15:01.000000', 'temperatura', 781.0000, 'ºC'),
	(271911, 119, '2014-04-01 01:15:02.000000', 'temperatura', 888.0000, 'ºC'),
	(271912, 119, '2014-04-01 01:15:03.000000', 'temperatura', 895.0000, 'ºC'),
	(271913, 119, '2014-04-01 01:15:04.000000', 'temperatura', 613.0000, 'ºC'),
	(271914, 119, '2014-04-01 01:15:05.000000', 'temperatura', 380.0000, 'ºC'),
	(271915, 119, '2014-04-01 01:15:06.000000', 'temperatura', 64.0000, 'ºC'),
	(271916, 119, '2014-04-01 01:15:07.000000', 'temperatura', 377.0000, 'ºC'),
	(271917, 119, '2014-04-01 01:15:08.000000', 'temperatura', 495.0000, 'ºC'),
	(271918, 119, '2014-04-01 01:15:09.000000', 'temperatura', 143.0000, 'ºC'),
	(271919, 119, '2014-04-01 01:15:10.000000', 'temperatura', 432.0000, 'ºC'),
	(271920, 119, '2014-04-01 01:15:11.000000', 'temperatura', 532.0000, 'ºC'),
	(271921, 119, '2014-04-01 01:15:12.000000', 'temperatura', 164.0000, 'ºC'),
	(271922, 119, '2014-04-01 01:15:13.000000', 'temperatura', 423.0000, 'ºC'),
	(271923, 119, '2014-04-01 01:15:14.000000', 'temperatura', 424.0000, 'ºC'),
	(271924, 119, '2014-04-01 01:15:15.000000', 'temperatura', 852.0000, 'ºC'),
	(271925, 119, '2014-04-01 01:15:16.000000', 'temperatura', 587.0000, 'ºC'),
	(271926, 119, '2014-04-01 01:15:17.000000', 'temperatura', 382.0000, 'ºC'),
	(271927, 119, '2014-04-01 01:15:18.000000', 'temperatura', 150.0000, 'ºC'),
	(271928, 119, '2014-04-01 01:15:19.000000', 'temperatura', 803.0000, 'ºC'),
	(271929, 119, '2014-04-01 01:15:20.000000', 'temperatura', 1165.0000, 'ºC'),
	(271930, 119, '2014-04-01 01:15:21.000000', 'temperatura', 1017.0000, 'ºC'),
	(271931, 119, '2014-04-01 01:15:22.000000', 'temperatura', 389.0000, 'ºC'),
	(271932, 119, '2014-04-01 01:15:23.000000', 'temperatura', 96.0000, 'ºC'),
	(271933, 119, '2014-04-01 01:15:24.000000', 'temperatura', 515.0000, 'ºC'),
	(271934, 119, '2014-04-01 01:15:25.000000', 'temperatura', 1085.0000, 'ºC'),
	(271935, 119, '2014-04-01 01:15:26.000000', 'temperatura', 279.0000, 'ºC'),
	(271936, 119, '2014-04-01 01:15:27.000000', 'temperatura', 544.0000, 'ºC'),
	(271937, 119, '2014-04-01 01:15:28.000000', 'temperatura', 681.0000, 'ºC'),
	(271938, 119, '2014-04-01 01:15:29.000000', 'temperatura', 575.0000, 'ºC'),
	(271939, 119, '2014-04-01 01:15:30.000000', 'temperatura', 833.0000, 'ºC'),
	(271940, 119, '2014-04-01 01:15:31.000000', 'temperatura', 41.0000, 'ºC'),
	(271941, 119, '2014-04-01 01:15:32.000000', 'temperatura', 104.0000, 'ºC'),
	(271942, 119, '2014-04-01 01:15:33.000000', 'temperatura', 398.0000, 'ºC'),
	(271943, 119, '2014-04-01 01:15:34.000000', 'temperatura', 478.0000, 'ºC'),
	(271944, 119, '2014-04-01 01:15:35.000000', 'temperatura', 1197.0000, 'ºC'),
	(271945, 119, '2014-04-01 01:15:36.000000', 'temperatura', 953.0000, 'ºC'),
	(271946, 119, '2014-04-01 01:15:37.000000', 'temperatura', 1172.0000, 'ºC'),
	(271947, 119, '2014-04-01 01:15:38.000000', 'temperatura', 603.0000, 'ºC'),
	(271948, 119, '2014-04-01 01:15:39.000000', 'temperatura', 700.0000, 'ºC'),
	(271949, 119, '2014-04-01 01:15:40.000000', 'temperatura', 492.0000, 'ºC'),
	(271950, 119, '2014-04-01 01:15:41.000000', 'temperatura', 360.0000, 'ºC'),
	(271951, 119, '2014-04-01 01:15:42.000000', 'temperatura', 322.0000, 'ºC'),
	(271952, 119, '2014-04-01 01:15:43.000000', 'temperatura', 533.0000, 'ºC'),
	(271953, 119, '2014-04-01 01:15:44.000000', 'temperatura', 500.0000, 'ºC'),
	(271954, 119, '2014-04-01 01:15:45.000000', 'temperatura', 899.0000, 'ºC'),
	(271955, 119, '2014-04-01 01:15:46.000000', 'temperatura', 596.0000, 'ºC'),
	(271956, 119, '2014-04-01 01:15:47.000000', 'temperatura', 283.0000, 'ºC'),
	(271957, 119, '2014-04-01 01:15:48.000000', 'temperatura', 829.0000, 'ºC'),
	(271958, 119, '2014-04-01 01:15:49.000000', 'temperatura', 894.0000, 'ºC'),
	(271959, 119, '2014-04-01 01:15:50.000000', 'temperatura', 785.0000, 'ºC'),
	(271960, 119, '2014-04-01 01:15:51.000000', 'temperatura', 45.0000, 'ºC'),
	(271961, 119, '2014-04-01 01:15:52.000000', 'temperatura', 268.0000, 'ºC'),
	(271962, 119, '2014-04-01 01:15:53.000000', 'temperatura', 5.0000, 'ºC'),
	(271963, 119, '2014-04-01 01:15:54.000000', 'temperatura', 422.0000, 'ºC'),
	(271964, 119, '2014-04-01 01:15:55.000000', 'temperatura', 897.0000, 'ºC'),
	(271965, 119, '2014-04-01 01:15:56.000000', 'temperatura', 819.0000, 'ºC'),
	(271966, 119, '2014-04-01 01:15:57.000000', 'temperatura', 204.0000, 'ºC'),
	(271967, 119, '2014-04-01 01:15:58.000000', 'temperatura', 964.0000, 'ºC'),
	(271968, 119, '2014-04-01 01:15:59.000000', 'temperatura', 607.0000, 'ºC'),
	(271969, 119, '2014-04-01 01:16:00.000000', 'temperatura', 144.0000, 'ºC'),
	(271970, 119, '2014-04-01 01:16:01.000000', 'temperatura', 99.0000, 'ºC'),
	(271971, 119, '2014-04-01 01:16:02.000000', 'temperatura', 65.0000, 'ºC'),
	(271972, 119, '2014-04-01 01:16:03.000000', 'temperatura', 27.0000, 'ºC'),
	(271973, 119, '2014-04-01 01:16:04.000000', 'temperatura', 1142.0000, 'ºC'),
	(271974, 119, '2014-04-01 01:16:05.000000', 'temperatura', 828.0000, 'ºC'),
	(271975, 119, '2014-04-01 01:16:06.000000', 'temperatura', 717.0000, 'ºC'),
	(271976, 119, '2014-04-01 01:16:07.000000', 'temperatura', 1099.0000, 'ºC'),
	(271977, 119, '2014-04-01 01:16:08.000000', 'temperatura', 943.0000, 'ºC'),
	(271978, 119, '2014-04-01 01:16:09.000000', 'temperatura', 222.0000, 'ºC'),
	(271979, 119, '2014-04-01 01:16:10.000000', 'temperatura', 680.0000, 'ºC'),
	(271980, 119, '2014-04-01 01:16:11.000000', 'temperatura', 336.0000, 'ºC'),
	(271981, 119, '2014-04-01 01:16:12.000000', 'temperatura', 839.0000, 'ºC'),
	(271982, 119, '2014-04-01 01:16:13.000000', 'temperatura', 789.0000, 'ºC'),
	(271983, 119, '2014-04-01 01:16:14.000000', 'temperatura', 228.0000, 'ºC'),
	(271984, 119, '2014-04-01 01:16:15.000000', 'temperatura', 1174.0000, 'ºC'),
	(271985, 119, '2014-04-01 01:16:16.000000', 'temperatura', 387.0000, 'ºC'),
	(271986, 119, '2014-04-01 01:16:17.000000', 'temperatura', 812.0000, 'ºC'),
	(271987, 119, '2014-04-01 01:16:18.000000', 'temperatura', 501.0000, 'ºC'),
	(271988, 119, '2014-04-01 01:16:19.000000', 'temperatura', 67.0000, 'ºC'),
	(271989, 119, '2014-04-01 01:16:20.000000', 'temperatura', 36.0000, 'ºC'),
	(271990, 119, '2014-04-01 01:16:21.000000', 'temperatura', 1177.0000, 'ºC'),
	(271991, 119, '2014-04-01 01:16:22.000000', 'temperatura', 979.0000, 'ºC'),
	(271992, 119, '2014-04-01 01:16:23.000000', 'temperatura', 165.0000, 'ºC'),
	(271993, 119, '2014-04-01 01:16:24.000000', 'temperatura', 289.0000, 'ºC'),
	(271994, 119, '2014-04-01 01:16:25.000000', 'temperatura', 949.0000, 'ºC'),
	(271995, 119, '2014-04-01 01:16:26.000000', 'temperatura', 279.0000, 'ºC'),
	(271996, 119, '2014-04-01 01:16:27.000000', 'temperatura', 949.0000, 'ºC'),
	(271997, 119, '2014-04-01 01:16:28.000000', 'temperatura', 308.0000, 'ºC'),
	(271998, 119, '2014-04-01 01:16:29.000000', 'temperatura', 1095.0000, 'ºC'),
	(271999, 119, '2014-04-01 01:16:30.000000', 'temperatura', 949.0000, 'ºC'),
	(272000, 119, '2014-04-01 01:16:31.000000', 'temperatura', 263.0000, 'ºC'),
	(272001, 119, '2014-04-01 01:16:32.000000', 'temperatura', 868.0000, 'ºC'),
	(272002, 119, '2014-04-01 01:16:33.000000', 'temperatura', 1153.0000, 'ºC'),
	(272003, 119, '2014-04-01 01:16:34.000000', 'temperatura', 759.0000, 'ºC'),
	(272004, 119, '2014-04-01 01:16:35.000000', 'temperatura', 338.0000, 'ºC'),
	(272005, 119, '2014-04-01 01:16:36.000000', 'temperatura', 613.0000, 'ºC'),
	(272006, 119, '2014-04-01 01:16:37.000000', 'temperatura', 853.0000, 'ºC'),
	(272007, 119, '2014-04-01 01:16:38.000000', 'temperatura', 27.0000, 'ºC'),
	(272008, 119, '2014-04-01 01:16:39.000000', 'temperatura', 1175.0000, 'ºC'),
	(272009, 119, '2014-04-01 01:16:40.000000', 'temperatura', 993.0000, 'ºC'),
	(272010, 119, '2014-04-01 01:16:41.000000', 'temperatura', 241.0000, 'ºC'),
	(272011, 119, '2014-04-01 01:16:42.000000', 'temperatura', 627.0000, 'ºC'),
	(272012, 119, '2014-04-01 01:16:43.000000', 'temperatura', 13.0000, 'ºC'),
	(272013, 119, '2014-04-01 01:16:44.000000', 'temperatura', 584.0000, 'ºC'),
	(272014, 119, '2014-04-01 01:16:45.000000', 'temperatura', 482.0000, 'ºC'),
	(272015, 119, '2014-04-01 01:16:46.000000', 'temperatura', 658.0000, 'ºC'),
	(272016, 119, '2014-04-01 01:16:47.000000', 'temperatura', 645.0000, 'ºC'),
	(272017, 119, '2014-04-01 01:16:48.000000', 'temperatura', 50.0000, 'ºC'),
	(272018, 119, '2014-04-01 01:16:49.000000', 'temperatura', 718.0000, 'ºC'),
	(272019, 119, '2014-04-01 01:16:50.000000', 'temperatura', 1039.0000, 'ºC'),
	(272020, 119, '2014-04-01 01:16:51.000000', 'temperatura', 641.0000, 'ºC'),
	(272021, 119, '2014-04-01 01:16:52.000000', 'temperatura', 87.0000, 'ºC'),
	(272022, 119, '2014-04-01 01:16:53.000000', 'temperatura', 914.0000, 'ºC'),
	(272023, 119, '2014-04-01 01:16:54.000000', 'temperatura', 708.0000, 'ºC'),
	(272024, 119, '2014-04-01 01:16:55.000000', 'temperatura', 800.0000, 'ºC'),
	(272025, 119, '2014-04-01 01:16:56.000000', 'temperatura', 674.0000, 'ºC'),
	(272026, 119, '2014-04-01 01:16:57.000000', 'temperatura', 974.0000, 'ºC'),
	(272027, 119, '2014-04-01 01:16:58.000000', 'temperatura', 447.0000, 'ºC'),
	(272028, 119, '2014-04-01 01:16:59.000000', 'temperatura', 512.0000, 'ºC'),
	(272029, 119, '2014-04-01 01:17:00.000000', 'temperatura', 21.0000, 'ºC'),
	(272030, 119, '2014-04-01 01:17:01.000000', 'temperatura', 968.0000, 'ºC'),
	(272031, 119, '2014-04-01 01:17:02.000000', 'temperatura', 1180.0000, 'ºC'),
	(272032, 119, '2014-04-01 01:17:03.000000', 'temperatura', 597.0000, 'ºC'),
	(272033, 119, '2014-04-01 01:17:04.000000', 'temperatura', 643.0000, 'ºC'),
	(272034, 119, '2014-04-01 01:17:05.000000', 'temperatura', 225.0000, 'ºC'),
	(272035, 119, '2014-04-01 01:17:06.000000', 'temperatura', 395.0000, 'ºC'),
	(272036, 119, '2014-04-01 01:17:07.000000', 'temperatura', 102.0000, 'ºC'),
	(272037, 119, '2014-04-01 01:17:08.000000', 'temperatura', 525.0000, 'ºC'),
	(272038, 119, '2014-04-01 01:17:09.000000', 'temperatura', 1121.0000, 'ºC'),
	(272039, 119, '2014-04-01 01:17:10.000000', 'temperatura', 431.0000, 'ºC'),
	(272040, 119, '2014-04-01 01:17:11.000000', 'temperatura', 1192.0000, 'ºC'),
	(272041, 119, '2014-04-01 01:17:12.000000', 'temperatura', 1068.0000, 'ºC'),
	(272042, 119, '2014-04-01 01:17:13.000000', 'temperatura', 563.0000, 'ºC'),
	(272043, 119, '2014-04-01 01:17:14.000000', 'temperatura', 810.0000, 'ºC'),
	(272044, 119, '2014-04-01 01:17:15.000000', 'temperatura', 1164.0000, 'ºC'),
	(272045, 119, '2014-04-01 01:17:16.000000', 'temperatura', 990.0000, 'ºC'),
	(272046, 119, '2014-04-01 01:17:17.000000', 'temperatura', 259.0000, 'ºC'),
	(272047, 119, '2014-04-01 01:17:18.000000', 'temperatura', 724.0000, 'ºC'),
	(272048, 119, '2014-04-01 01:17:19.000000', 'temperatura', 444.0000, 'ºC'),
	(272049, 119, '2014-04-01 01:17:20.000000', 'temperatura', 48.0000, 'ºC'),
	(272050, 119, '2014-04-01 01:17:21.000000', 'temperatura', 110.0000, 'ºC'),
	(272051, 119, '2014-04-01 01:17:22.000000', 'temperatura', 405.0000, 'ºC'),
	(272052, 119, '2014-04-01 01:17:23.000000', 'temperatura', 497.0000, 'ºC'),
	(272053, 119, '2014-04-01 01:17:24.000000', 'temperatura', 71.0000, 'ºC'),
	(272054, 119, '2014-04-01 01:17:25.000000', 'temperatura', 63.0000, 'ºC'),
	(272055, 119, '2014-04-01 01:17:26.000000', 'temperatura', 105.0000, 'ºC'),
	(272056, 119, '2014-04-01 01:17:27.000000', 'temperatura', 334.0000, 'ºC'),
	(272057, 119, '2014-04-01 01:17:28.000000', 'temperatura', 155.0000, 'ºC'),
	(272058, 119, '2014-04-01 01:17:29.000000', 'temperatura', 974.0000, 'ºC'),
	(272059, 119, '2014-04-01 01:17:30.000000', 'temperatura', 806.0000, 'ºC'),
	(272060, 119, '2014-04-01 01:17:31.000000', 'temperatura', 1107.0000, 'ºC'),
	(272061, 119, '2014-04-01 01:17:32.000000', 'temperatura', 718.0000, 'ºC'),
	(272062, 119, '2014-04-01 01:17:33.000000', 'temperatura', 269.0000, 'ºC'),
	(272063, 119, '2014-04-01 01:17:34.000000', 'temperatura', 391.0000, 'ºC'),
	(272064, 119, '2014-04-01 01:17:35.000000', 'temperatura', 1147.0000, 'ºC'),
	(272065, 119, '2014-04-01 01:17:36.000000', 'temperatura', 966.0000, 'ºC'),
	(272066, 119, '2014-04-01 01:17:37.000000', 'temperatura', 188.0000, 'ºC'),
	(272067, 119, '2014-04-01 01:17:38.000000', 'temperatura', 443.0000, 'ºC'),
	(272068, 119, '2014-04-01 01:17:39.000000', 'temperatura', 449.0000, 'ºC'),
	(272069, 119, '2014-04-01 01:17:40.000000', 'temperatura', 918.0000, 'ºC'),
	(272070, 119, '2014-04-01 01:17:41.000000', 'temperatura', 846.0000, 'ºC'),
	(272071, 119, '2014-04-01 01:17:42.000000', 'temperatura', 273.0000, 'ºC'),
	(272072, 119, '2014-04-01 01:17:43.000000', 'temperatura', 30.0000, 'ºC'),
	(272073, 119, '2014-04-01 01:17:44.000000', 'temperatura', 532.0000, 'ºC'),
	(272074, 119, '2014-04-01 01:17:45.000000', 'temperatura', 170.0000, 'ºC'),
	(272075, 119, '2014-04-01 01:17:46.000000', 'temperatura', 452.0000, 'ºC'),
	(272076, 119, '2014-04-01 01:17:47.000000', 'temperatura', 553.0000, 'ºC'),
	(272077, 119, '2014-04-01 01:17:48.000000', 'temperatura', 210.0000, 'ºC'),
	(272078, 119, '2014-04-01 01:17:49.000000', 'temperatura', 590.0000, 'ºC'),
	(272079, 119, '2014-04-01 01:17:50.000000', 'temperatura', 1120.0000, 'ºC'),
	(272080, 119, '2014-04-01 01:17:51.000000', 'temperatura', 230.0000, 'ºC'),
	(272081, 119, '2014-04-01 01:17:52.000000', 'temperatura', 190.0000, 'ºC'),
	(272082, 119, '2014-04-01 01:17:53.000000', 'temperatura', 262.0000, 'ºC'),
	(272083, 119, '2014-04-01 01:17:54.000000', 'temperatura', 739.0000, 'ºC'),
	(272084, 119, '2014-04-01 01:17:55.000000', 'temperatura', 510.0000, 'ºC'),
	(272085, 119, '2014-04-01 01:17:56.000000', 'temperatura', 336.0000, 'ºC'),
	(272086, 119, '2014-04-01 01:17:57.000000', 'temperatura', 147.0000, 'ºC'),
	(272087, 119, '2014-04-01 01:17:58.000000', 'temperatura', 928.0000, 'ºC'),
	(272088, 119, '2014-04-01 01:17:59.000000', 'temperatura', 599.0000, 'ºC'),
	(272089, 119, '2014-04-01 01:18:00.000000', 'temperatura', 211.0000, 'ºC'),
	(272090, 119, '2014-04-01 01:18:01.000000', 'temperatura', 458.0000, 'ºC'),
	(272091, 119, '2014-04-01 01:18:02.000000', 'temperatura', 460.0000, 'ºC'),
	(272092, 119, '2014-04-01 01:18:03.000000', 'temperatura', 925.0000, 'ºC'),
	(272093, 119, '2014-04-01 01:18:04.000000', 'temperatura', 844.0000, 'ºC'),
	(272094, 119, '2014-04-01 01:18:05.000000', 'temperatura', 247.0000, 'ºC'),
	(272095, 119, '2014-04-01 01:18:06.000000', 'temperatura', 1102.0000, 'ºC'),
	(272096, 119, '2014-04-01 01:18:07.000000', 'temperatura', 1172.0000, 'ºC'),
	(272097, 119, '2014-04-01 01:18:08.000000', 'temperatura', 155.0000, 'ºC'),
	(272098, 119, '2014-04-01 01:18:09.000000', 'temperatura', 859.0000, 'ºC'),
	(272099, 119, '2014-04-01 01:18:10.000000', 'temperatura', 231.0000, 'ºC'),
	(272100, 119, '2014-04-01 01:18:11.000000', 'temperatura', 977.0000, 'ºC'),
	(272101, 119, '2014-04-01 01:18:12.000000', 'temperatura', 594.0000, 'ºC'),
	(272102, 119, '2014-04-01 01:18:13.000000', 'temperatura', 41.0000, 'ºC'),
	(272103, 119, '2014-04-01 01:18:14.000000', 'temperatura', 821.0000, 'ºC'),
	(272104, 119, '2014-04-01 01:18:15.000000', 'temperatura', 384.0000, 'ºC'),
	(272105, 119, '2014-04-01 01:18:16.000000', 'temperatura', 656.0000, 'ºC'),
	(272106, 119, '2014-04-01 01:18:17.000000', 'temperatura', 929.0000, 'ºC'),
	(272107, 119, '2014-04-01 01:18:18.000000', 'temperatura', 277.0000, 'ºC'),
	(272108, 119, '2014-04-01 01:18:19.000000', 'temperatura', 999.0000, 'ºC'),
	(272109, 119, '2014-04-01 01:18:20.000000', 'temperatura', 563.0000, 'ºC'),
	(272110, 119, '2014-04-01 01:18:21.000000', 'temperatura', 1020.0000, 'ºC'),
	(272111, 119, '2014-04-01 01:18:22.000000', 'temperatura', 1010.0000, 'ºC'),
	(272112, 119, '2014-04-01 01:18:23.000000', 'temperatura', 793.0000, 'ºC'),
	(272113, 119, '2014-04-01 01:18:24.000000', 'temperatura', 934.0000, 'ºC'),
	(272114, 119, '2014-04-01 01:18:25.000000', 'temperatura', 1093.0000, 'ºC'),
	(272115, 119, '2014-04-01 01:18:26.000000', 'temperatura', 262.0000, 'ºC'),
	(272116, 119, '2014-04-01 01:18:27.000000', 'temperatura', 433.0000, 'ºC'),
	(272117, 119, '2014-04-01 01:18:28.000000', 'temperatura', 179.0000, 'ºC'),
	(272118, 119, '2014-04-01 01:18:29.000000', 'temperatura', 795.0000, 'ºC'),
	(272119, 119, '2014-04-01 01:18:30.000000', 'temperatura', 1038.0000, 'ºC'),
	(272120, 119, '2014-04-01 01:18:31.000000', 'temperatura', 406.0000, 'ºC'),
	(272121, 119, '2014-04-01 01:18:32.000000', 'temperatura', 117.0000, 'ºC'),
	(272122, 119, '2014-04-01 01:18:33.000000', 'temperatura', 567.0000, 'ºC'),
	(272123, 119, '2014-04-01 01:18:34.000000', 'temperatura', 86.0000, 'ºC'),
	(272124, 119, '2014-04-01 01:18:35.000000', 'temperatura', 1129.0000, 'ºC'),
	(272125, 119, '2014-04-01 01:18:36.000000', 'temperatura', 587.0000, 'ºC'),
	(272126, 119, '2014-04-01 01:18:37.000000', 'temperatura', 749.0000, 'ºC'),
	(272127, 119, '2014-04-01 01:18:38.000000', 'temperatura', 786.0000, 'ºC'),
	(272128, 119, '2014-04-01 01:18:39.000000', 'temperatura', 483.0000, 'ºC'),
	(272129, 119, '2014-04-01 01:18:40.000000', 'temperatura', 55.0000, 'ºC'),
	(272130, 119, '2014-04-01 01:18:41.000000', 'temperatura', 30.0000, 'ºC'),
	(272131, 119, '2014-04-01 01:18:42.000000', 'temperatura', 1184.0000, 'ºC'),
	(272132, 119, '2014-04-01 01:18:43.000000', 'temperatura', 1029.0000, 'ºC'),
	(272133, 119, '2014-04-01 01:18:44.000000', 'temperatura', 394.0000, 'ºC'),
	(272134, 119, '2014-04-01 01:18:45.000000', 'temperatura', 85.0000, 'ºC'),
	(272135, 119, '2014-04-01 01:18:46.000000', 'temperatura', 442.0000, 'ºC'),
	(272136, 119, '2014-04-01 01:18:47.000000', 'temperatura', 756.0000, 'ºC'),
	(272137, 119, '2014-04-01 01:18:48.000000', 'temperatura', 56.0000, 'ºC'),
	(272138, 119, '2014-04-01 01:18:49.000000', 'temperatura', 411.0000, 'ºC'),
	(272139, 119, '2014-04-01 01:18:50.000000', 'temperatura', 688.0000, 'ºC'),
	(272140, 119, '2014-04-01 01:18:51.000000', 'temperatura', 1008.0000, 'ºC'),
	(272141, 119, '2014-04-01 01:18:52.000000', 'temperatura', 577.0000, 'ºC'),
	(272142, 119, '2014-04-01 01:18:53.000000', 'temperatura', 1059.0000, 'ºC'),
	(272143, 119, '2014-04-01 01:18:54.000000', 'temperatura', 1167.0000, 'ºC'),
	(272144, 119, '2014-04-01 01:18:55.000000', 'temperatura', 257.0000, 'ºC'),
	(272145, 119, '2014-04-01 01:18:56.000000', 'temperatura', 186.0000, 'ºC'),
	(272146, 119, '2014-04-01 01:18:57.000000', 'temperatura', 157.0000, 'ºC'),
	(272147, 119, '2014-04-01 01:18:58.000000', 'temperatura', 229.0000, 'ºC'),
	(272148, 119, '2014-04-01 01:18:59.000000', 'temperatura', 674.0000, 'ºC'),
	(272149, 119, '2014-04-01 01:19:00.000000', 'temperatura', 285.0000, 'ºC'),
	(272150, 119, '2014-04-01 01:19:01.000000', 'temperatura', 603.0000, 'ºC'),
	(272151, 119, '2014-04-01 01:19:02.000000', 'temperatura', 961.0000, 'ºC'),
	(272152, 119, '2014-04-01 01:19:03.000000', 'temperatura', 596.0000, 'ºC'),
	(272153, 119, '2014-04-01 01:19:04.000000', 'temperatura', 99.0000, 'ºC'),
	(272154, 119, '2014-04-01 01:19:05.000000', 'temperatura', 1104.0000, 'ºC'),
	(272155, 119, '2014-04-01 01:19:06.000000', 'temperatura', 427.0000, 'ºC'),
	(272156, 119, '2014-04-01 01:19:07.000000', 'temperatura', 22.0000, 'ºC'),
	(272157, 119, '2014-04-01 01:19:08.000000', 'temperatura', 29.0000, 'ºC'),
	(272158, 119, '2014-04-01 01:19:09.000000', 'temperatura', 79.0000, 'ºC'),
	(272159, 119, '2014-04-01 01:19:10.000000', 'temperatura', 311.0000, 'ºC'),
	(272160, 119, '2014-04-01 01:19:11.000000', 'temperatura', 118.0000, 'ºC'),
	(272161, 119, '2014-04-01 01:19:12.000000', 'temperatura', 857.0000, 'ºC'),
	(272162, 119, '2014-04-01 01:19:13.000000', 'temperatura', 331.0000, 'ºC'),
	(272163, 119, '2014-04-01 01:19:14.000000', 'temperatura', 287.0000, 'ºC'),
	(272164, 119, '2014-04-01 01:19:15.000000', 'temperatura', 440.0000, 'ºC'),
	(272165, 119, '2014-04-01 01:19:16.000000', 'temperatura', 140.0000, 'ºC'),
	(272166, 119, '2014-04-01 01:19:17.000000', 'temperatura', 580.0000, 'ºC'),
	(272167, 119, '2014-04-01 01:19:18.000000', 'temperatura', 81.0000, 'ºC'),
	(272168, 119, '2014-04-01 01:19:19.000000', 'temperatura', 1067.0000, 'ºC'),
	(272169, 119, '2014-04-01 01:19:20.000000', 'temperatura', 294.0000, 'ºC'),
	(272170, 119, '2014-04-01 01:19:21.000000', 'temperatura', 666.0000, 'ºC'),
	(272171, 119, '2014-04-01 01:19:22.000000', 'temperatura', 49.0000, 'ºC'),
	(272172, 119, '2014-04-01 01:19:23.000000', 'temperatura', 647.0000, 'ºC'),
	(272173, 119, '2014-04-01 01:19:24.000000', 'temperatura', 689.0000, 'ºC'),
	(272174, 119, '2014-04-01 01:19:25.000000', 'temperatura', 304.0000, 'ºC'),
	(272175, 119, '2014-04-01 01:19:26.000000', 'temperatura', 652.0000, 'ºC'),
	(272176, 119, '2014-04-01 01:19:27.000000', 'temperatura', 1150.0000, 'ºC'),
	(272177, 119, '2014-04-01 01:19:28.000000', 'temperatura', 192.0000, 'ºC'),
	(272178, 119, '2014-04-01 01:19:29.000000', 'temperatura', 1114.0000, 'ºC'),
	(272179, 119, '2014-04-01 01:19:30.000000', 'temperatura', 192.0000, 'ºC'),
	(272180, 119, '2014-04-01 01:19:31.000000', 'temperatura', 18.0000, 'ºC'),
	(272181, 119, '2014-04-01 01:19:32.000000', 'temperatura', 717.0000, 'ºC'),
	(272182, 119, '2014-04-01 01:19:33.000000', 'temperatura', 1131.0000, 'ºC'),
	(272183, 119, '2014-04-01 01:19:34.000000', 'temperatura', 1106.0000, 'ºC'),
	(272184, 119, '2014-04-01 01:19:35.000000', 'temperatura', 936.0000, 'ºC'),
	(272185, 119, '2014-04-01 01:19:36.000000', 'temperatura', 163.0000, 'ºC'),
	(272186, 119, '2014-04-01 01:19:37.000000', 'temperatura', 408.0000, 'ºC'),
	(272187, 119, '2014-04-01 01:19:38.000000', 'temperatura', 351.0000, 'ºC'),
	(272188, 119, '2014-04-01 01:19:39.000000', 'temperatura', 530.0000, 'ºC'),
	(272189, 119, '2014-04-01 01:19:40.000000', 'temperatura', 399.0000, 'ºC'),
	(272190, 119, '2014-04-01 01:19:41.000000', 'temperatura', 405.0000, 'ºC'),
	(272191, 119, '2014-04-01 01:19:42.000000', 'temperatura', 829.0000, 'ºC'),
	(272192, 119, '2014-04-01 01:19:43.000000', 'temperatura', 532.0000, 'ºC'),
	(272193, 119, '2014-04-01 01:19:44.000000', 'temperatura', 172.0000, 'ºC'),
	(272194, 119, '2014-04-01 01:19:45.000000', 'temperatura', 466.0000, 'ºC'),
	(272195, 119, '2014-04-01 01:19:46.000000', 'temperatura', 615.0000, 'ºC'),
	(272196, 119, '2014-04-01 01:19:47.000000', 'temperatura', 475.0000, 'ºC'),
	(272197, 119, '2014-04-01 01:19:48.000000', 'temperatura', 532.0000, 'ºC'),
	(272198, 119, '2014-04-01 01:19:49.000000', 'temperatura', 35.0000, 'ºC'),
	(272199, 119, '2014-04-01 01:19:50.000000', 'temperatura', 980.0000, 'ºC'),
	(272200, 119, '2014-04-01 01:19:51.000000', 'temperatura', 1195.0000, 'ºC'),
	(272201, 119, '2014-04-01 01:19:52.000000', 'temperatura', 635.0000, 'ºC'),
	(272202, 119, '2014-04-01 01:19:53.000000', 'temperatura', 792.0000, 'ºC'),
	(272203, 119, '2014-04-01 01:19:54.000000', 'temperatura', 855.0000, 'ºC'),
	(272204, 119, '2014-04-01 01:19:55.000000', 'temperatura', 701.0000, 'ºC'),
	(272205, 119, '2014-04-01 01:19:56.000000', 'temperatura', 940.0000, 'ºC'),
	(272206, 119, '2014-04-01 01:19:57.000000', 'temperatura', 197.0000, 'ºC'),
	(272207, 119, '2014-04-01 01:19:58.000000', 'temperatura', 565.0000, 'ºC'),
	(272208, 119, '2014-04-01 01:19:59.000000', 'temperatura', 1036.0000, 'ºC'),
	(272209, 119, '2014-04-01 01:20:00.000000', 'temperatura', 1083.0000, 'ºC'),
	(272210, 119, '2014-04-01 01:20:01.000000', 'temperatura', 1110.0000, 'ºC'),
	(272211, 119, '2014-04-01 01:20:02.000000', 'temperatura', 1100.0000, 'ºC'),
	(272212, 119, '2014-04-01 01:20:03.000000', 'temperatura', 972.0000, 'ºC'),
	(272213, 119, '2014-04-01 01:20:04.000000', 'temperatura', 361.0000, 'ºC'),
	(272214, 119, '2014-04-01 01:20:05.000000', 'temperatura', 90.0000, 'ºC'),
	(272215, 119, '2014-04-01 01:20:06.000000', 'temperatura', 568.0000, 'ºC'),
	(272216, 119, '2014-04-01 01:20:07.000000', 'temperatura', 169.0000, 'ºC'),
	(272217, 119, '2014-04-01 01:20:08.000000', 'temperatura', 340.0000, 'ºC'),
	(272218, 119, '2014-04-01 01:20:09.000000', 'temperatura', 1195.0000, 'ºC'),
	(272219, 119, '2014-04-01 01:20:10.000000', 'temperatura', 155.0000, 'ºC'),
	(272220, 119, '2014-04-01 01:20:11.000000', 'temperatura', 792.0000, 'ºC'),
	(272221, 119, '2014-04-01 01:20:12.000000', 'temperatura', 1095.0000, 'ºC'),
	(272222, 119, '2014-04-01 01:20:13.000000', 'temperatura', 699.0000, 'ºC'),
	(272223, 119, '2014-04-01 01:20:14.000000', 'temperatura', 210.0000, 'ºC'),
	(272224, 119, '2014-04-01 01:20:15.000000', 'temperatura', 152.0000, 'ºC'),
	(272225, 119, '2014-04-01 01:20:16.000000', 'temperatura', 134.0000, 'ºC'),
	(272226, 119, '2014-04-01 01:20:17.000000', 'temperatura', 212.0000, 'ºC'),
	(272227, 119, '2014-04-01 01:20:18.000000', 'temperatura', 660.0000, 'ºC'),
	(272228, 119, '2014-04-01 01:20:19.000000', 'temperatura', 265.0000, 'ºC'),
	(272229, 119, '2014-04-01 01:20:20.000000', 'temperatura', 545.0000, 'ºC'),
	(272230, 119, '2014-04-01 01:20:21.000000', 'temperatura', 730.0000, 'ºC'),
	(272231, 119, '2014-04-01 01:20:22.000000', 'temperatura', 814.0000, 'ºC'),
	(272232, 119, '2014-04-01 01:20:23.000000', 'temperatura', 684.0000, 'ºC'),
	(272233, 119, '2014-04-01 01:20:24.000000', 'temperatura', 976.0000, 'ºC'),
	(272234, 119, '2014-04-01 01:20:25.000000', 'temperatura', 428.0000, 'ºC'),
	(272235, 119, '2014-04-01 01:20:26.000000', 'temperatura', 412.0000, 'ºC'),
	(272236, 119, '2014-04-01 01:20:27.000000', 'temperatura', 779.0000, 'ºC'),
	(272237, 119, '2014-04-01 01:20:28.000000', 'temperatura', 260.0000, 'ºC'),
	(272238, 119, '2014-04-01 01:20:29.000000', 'temperatura', 164.0000, 'ºC'),
	(272239, 119, '2014-04-01 01:20:30.000000', 'temperatura', 41.0000, 'ºC'),
	(272240, 119, '2014-04-01 01:20:31.000000', 'temperatura', 911.0000, 'ºC'),
	(272241, 119, '2014-04-01 01:20:32.000000', 'temperatura', 835.0000, 'ºC'),
	(272242, 119, '2014-04-01 01:20:33.000000', 'temperatura', 240.0000, 'ºC'),
	(272243, 119, '2014-04-01 01:20:34.000000', 'temperatura', 1095.0000, 'ºC'),
	(272244, 119, '2014-04-01 01:20:35.000000', 'temperatura', 1155.0000, 'ºC'),
	(272245, 119, '2014-04-01 01:20:36.000000', 'temperatura', 91.0000, 'ºC'),
	(272246, 119, '2014-04-01 01:20:37.000000', 'temperatura', 589.0000, 'ºC'),
	(272247, 119, '2014-04-01 01:20:38.000000', 'temperatura', 275.0000, 'ºC'),
	(272248, 119, '2014-04-01 01:20:39.000000', 'temperatura', 806.0000, 'ºC'),
	(272249, 119, '2014-04-01 01:20:40.000000', 'temperatura', 805.0000, 'ºC'),
	(272250, 119, '2014-04-01 01:20:41.000000', 'temperatura', 408.0000, 'ºC'),
	(272251, 119, '2014-04-01 01:20:42.000000', 'temperatura', 827.0000, 'ºC'),
	(272252, 119, '2014-04-01 01:20:43.000000', 'temperatura', 510.0000, 'ºC'),
	(272253, 119, '2014-04-01 01:20:44.000000', 'temperatura', 70.0000, 'ºC'),
	(272254, 119, '2014-04-01 01:20:45.000000', 'temperatura', 21.0000, 'ºC'),
	(272255, 119, '2014-04-01 01:20:46.000000', 'temperatura', 1095.0000, 'ºC'),
	(272256, 119, '2014-04-01 01:20:47.000000', 'temperatura', 611.0000, 'ºC'),
	(272257, 119, '2014-04-01 01:20:48.000000', 'temperatura', 970.0000, 'ºC'),
	(272258, 119, '2014-04-01 01:20:49.000000', 'temperatura', 617.0000, 'ºC'),
	(272259, 119, '2014-04-01 01:20:50.000000', 'temperatura', 178.0000, 'ºC'),
	(272260, 119, '2014-04-01 01:20:51.000000', 'temperatura', 239.0000, 'ºC'),
	(272261, 119, '2014-04-01 01:20:52.000000', 'temperatura', 661.0000, 'ºC'),
	(272262, 119, '2014-04-01 01:20:53.000000', 'temperatura', 190.0000, 'ºC'),
	(272263, 119, '2014-04-01 01:20:54.000000', 'temperatura', 168.0000, 'ºC'),
	(272264, 119, '2014-04-01 01:20:55.000000', 'temperatura', 270.0000, 'ºC'),
	(272265, 119, '2014-04-01 01:20:56.000000', 'temperatura', 845.0000, 'ºC'),
	(272266, 119, '2014-04-01 01:20:57.000000', 'temperatura', 1017.0000, 'ºC'),
	(272267, 119, '2014-04-01 01:20:58.000000', 'temperatura', 149.0000, 'ºC'),
	(272268, 119, '2014-04-01 01:20:59.000000', 'temperatura', 96.0000, 'ºC'),
	(272269, 119, '2014-04-01 01:21:00.000000', 'temperatura', 33.0000, 'ºC'),
	(272270, 119, '2014-04-01 01:21:01.000000', 'temperatura', 1079.0000, 'ºC'),
	(272271, 119, '2014-04-01 01:21:02.000000', 'temperatura', 495.0000, 'ºC'),
	(272272, 119, '2014-04-01 01:21:03.000000', 'temperatura', 439.0000, 'ºC'),
	(272273, 119, '2014-04-01 01:21:04.000000', 'temperatura', 711.0000, 'ºC'),
	(272274, 119, '2014-04-01 01:21:05.000000', 'temperatura', 1038.0000, 'ºC'),
	(272275, 119, '2014-04-01 01:21:06.000000', 'temperatura', 659.0000, 'ºC'),
	(272276, 119, '2014-04-01 01:21:07.000000', 'temperatura', 181.0000, 'ºC'),
	(272277, 119, '2014-04-01 01:21:08.000000', 'temperatura', 130.0000, 'ºC'),
	(272278, 119, '2014-04-01 01:21:09.000000', 'temperatura', 105.0000, 'ºC'),
	(272279, 119, '2014-04-01 01:21:10.000000', 'temperatura', 138.0000, 'ºC'),
	(272280, 119, '2014-04-01 01:21:11.000000', 'temperatura', 373.0000, 'ºC'),
	(272281, 119, '2014-04-01 01:21:12.000000', 'temperatura', 253.0000, 'ºC'),
	(272282, 119, '2014-04-01 01:21:13.000000', 'temperatura', 145.0000, 'ºC'),
	(272283, 119, '2014-04-01 01:21:14.000000', 'temperatura', 1168.0000, 'ºC'),
	(272284, 119, '2014-04-01 01:21:15.000000', 'temperatura', 603.0000, 'ºC'),
	(272285, 119, '2014-04-01 01:21:16.000000', 'temperatura', 714.0000, 'ºC'),
	(272286, 119, '2014-04-01 01:21:17.000000', 'temperatura', 562.0000, 'ºC'),
	(272287, 119, '2014-04-01 01:21:18.000000', 'temperatura', 670.0000, 'ºC'),
	(272288, 119, '2014-04-01 01:21:19.000000', 'temperatura', 462.0000, 'ºC'),
	(272289, 119, '2014-04-01 01:21:20.000000', 'temperatura', 300.0000, 'ºC'),
	(272290, 119, '2014-04-01 01:21:21.000000', 'temperatura', 115.0000, 'ºC'),
	(272291, 119, '2014-04-01 01:21:22.000000', 'temperatura', 876.0000, 'ºC'),
	(272292, 119, '2014-04-01 01:21:23.000000', 'temperatura', 437.0000, 'ºC'),
	(272293, 119, '2014-04-01 01:21:24.000000', 'temperatura', 756.0000, 'ºC'),
	(272294, 119, '2014-04-01 01:21:25.000000', 'temperatura', 69.0000, 'ºC'),
	(272295, 119, '2014-04-01 01:21:26.000000', 'temperatura', 478.0000, 'ºC'),
	(272296, 119, '2014-04-01 01:21:27.000000', 'temperatura', 984.0000, 'ºC'),
	(272297, 119, '2014-04-01 01:21:28.000000', 'temperatura', 1084.0000, 'ºC'),
	(272298, 119, '2014-04-01 01:21:29.000000', 'temperatura', 71.0000, 'ºC'),
	(272299, 119, '2014-04-01 01:21:30.000000', 'temperatura', 702.0000, 'ºC'),
	(272300, 119, '2014-04-01 01:21:31.000000', 'temperatura', 899.0000, 'ºC'),
	(272301, 119, '2014-04-01 01:21:32.000000', 'temperatura', 1189.0000, 'ºC'),
	(272302, 119, '2014-04-01 01:21:33.000000', 'temperatura', 850.0000, 'ºC'),
	(272303, 119, '2014-04-01 01:21:34.000000', 'temperatura', 683.0000, 'ºC'),
	(272304, 119, '2014-04-01 01:21:35.000000', 'temperatura', 864.0000, 'ºC'),
	(272305, 119, '2014-04-01 01:21:36.000000', 'temperatura', 1073.0000, 'ºC'),
	(272306, 119, '2014-04-01 01:21:37.000000', 'temperatura', 371.0000, 'ºC'),
	(272307, 119, '2014-04-01 01:21:38.000000', 'temperatura', 1038.0000, 'ºC'),
	(272308, 119, '2014-04-01 01:21:39.000000', 'temperatura', 477.0000, 'ºC'),
	(272309, 119, '2014-04-01 01:21:40.000000', 'temperatura', 471.0000, 'ºC'),
	(272310, 119, '2014-04-01 01:21:41.000000', 'temperatura', 924.0000, 'ºC'),
	(272311, 119, '2014-04-01 01:21:42.000000', 'temperatura', 809.0000, 'ºC'),
	(272312, 119, '2014-04-01 01:21:43.000000', 'temperatura', 71.0000, 'ºC'),
	(272313, 119, '2014-04-01 01:21:44.000000', 'temperatura', 331.0000, 'ºC'),
	(272314, 119, '2014-04-01 01:21:45.000000', 'temperatura', 240.0000, 'ºC'),
	(272315, 119, '2014-04-01 01:21:46.000000', 'temperatura', 209.0000, 'ºC'),
	(272316, 119, '2014-04-01 01:21:47.000000', 'temperatura', 326.0000, 'ºC'),
	(272317, 119, '2014-04-01 01:21:48.000000', 'temperatura', 1004.0000, 'ºC'),
	(272318, 119, '2014-04-01 01:21:49.000000', 'temperatura', 442.0000, 'ºC'),
	(272319, 119, '2014-04-01 01:21:50.000000', 'temperatura', 397.0000, 'ºC'),
	(272320, 119, '2014-04-01 01:21:51.000000', 'temperatura', 661.0000, 'ºC'),
	(272321, 119, '2014-04-01 01:21:52.000000', 'temperatura', 916.0000, 'ºC'),
	(272322, 119, '2014-04-01 01:21:53.000000', 'temperatura', 197.0000, 'ºC'),
	(272323, 119, '2014-04-01 01:21:54.000000', 'temperatura', 638.0000, 'ºC'),
	(272324, 119, '2014-04-01 01:21:55.000000', 'temperatura', 199.0000, 'ºC'),
	(272325, 119, '2014-04-01 01:21:56.000000', 'temperatura', 281.0000, 'ºC'),
	(272326, 119, '2014-04-01 01:21:57.000000', 'temperatura', 807.0000, 'ºC'),
	(272327, 119, '2014-04-01 01:21:58.000000', 'temperatura', 793.0000, 'ºC'),
	(272328, 119, '2014-04-01 01:21:59.000000', 'temperatura', 345.0000, 'ºC'),
	(272329, 119, '2014-04-01 01:22:00.000000', 'temperatura', 545.0000, 'ºC'),
	(272330, 119, '2014-04-01 01:22:01.000000', 'temperatura', 492.0000, 'ºC'),
	(272331, 119, '2014-04-01 01:22:02.000000', 'temperatura', 824.0000, 'ºC'),
	(272332, 119, '2014-04-01 01:22:03.000000', 'temperatura', 245.0000, 'ºC'),
	(272333, 119, '2014-04-01 01:22:04.000000', 'temperatura', 1152.0000, 'ºC'),
	(272334, 119, '2014-04-01 01:22:05.000000', 'temperatura', 228.0000, 'ºC'),
	(272335, 119, '2014-04-01 01:22:06.000000', 'temperatura', 82.0000, 'ºC'),
	(272336, 119, '2014-04-01 01:22:07.000000', 'temperatura', 928.0000, 'ºC'),
	(272337, 119, '2014-04-01 01:22:08.000000', 'temperatura', 795.0000, 'ºC'),
	(272338, 119, '2014-04-01 01:22:09.000000', 'temperatura', 1189.0000, 'ºC'),
	(272339, 119, '2014-04-01 01:22:10.000000', 'temperatura', 1162.0000, 'ºC'),
	(272340, 119, '2014-04-01 01:22:11.000000', 'temperatura', 1042.0000, 'ºC'),
	(272341, 119, '2014-04-01 01:22:12.000000', 'temperatura', 526.0000, 'ºC'),
	(272342, 119, '2014-04-01 01:22:13.000000', 'temperatura', 704.0000, 'ºC'),
	(272343, 119, '2014-04-01 01:22:14.000000', 'temperatura', 741.0000, 'ºC'),
	(272344, 119, '2014-04-01 01:22:15.000000', 'temperatura', 396.0000, 'ºC'),
	(272345, 119, '2014-04-01 01:22:16.000000', 'temperatura', 958.0000, 'ºC'),
	(272346, 119, '2014-04-01 01:22:17.000000', 'temperatura', 2.0000, 'ºC'),
	(272347, 119, '2014-04-01 01:22:18.000000', 'temperatura', 738.0000, 'ºC'),
	(272348, 119, '2014-04-01 01:22:19.000000', 'temperatura', 83.0000, 'ºC'),
	(272349, 119, '2014-04-01 01:22:20.000000', 'temperatura', 602.0000, 'ºC'),
	(272350, 119, '2014-04-01 01:22:21.000000', 'temperatura', 363.0000, 'ºC'),
	(272351, 119, '2014-04-01 01:22:22.000000', 'temperatura', 6.0000, 'ºC'),
	(272352, 119, '2014-04-01 01:22:23.000000', 'temperatura', 144.0000, 'ºC'),
	(272353, 119, '2014-04-01 01:22:24.000000', 'temperatura', 703.0000, 'ºC'),
	(272354, 119, '2014-04-01 01:22:25.000000', 'temperatura', 684.0000, 'ºC'),
	(272355, 119, '2014-04-01 01:22:26.000000', 'temperatura', 110.0000, 'ºC'),
	(272356, 119, '2014-04-01 01:22:27.000000', 'temperatura', 898.0000, 'ºC'),
	(272357, 119, '2014-04-01 01:22:28.000000', 'temperatura', 561.0000, 'ºC'),
	(272358, 119, '2014-04-01 01:22:29.000000', 'temperatura', 110.0000, 'ºC'),
	(272359, 119, '2014-04-01 01:22:30.000000', 'temperatura', 70.0000, 'ºC'),
	(272360, 119, '2014-04-01 01:22:31.000000', 'temperatura', 18.0000, 'ºC'),
	(272361, 119, '2014-04-01 01:22:32.000000', 'temperatura', 1080.0000, 'ºC'),
	(272362, 119, '2014-04-01 01:22:33.000000', 'temperatura', 547.0000, 'ºC'),
	(272363, 119, '2014-04-01 01:22:34.000000', 'temperatura', 696.0000, 'ºC'),
	(272364, 119, '2014-04-01 01:22:35.000000', 'temperatura', 641.0000, 'ºC'),
	(272365, 119, '2014-04-01 01:22:36.000000', 'temperatura', 1118.0000, 'ºC'),
	(272366, 119, '2014-04-01 01:22:37.000000', 'temperatura', 65.0000, 'ºC'),
	(272367, 119, '2014-04-01 01:22:38.000000', 'temperatura', 571.0000, 'ºC'),
	(272368, 119, '2014-04-01 01:22:39.000000', 'temperatura', 260.0000, 'ºC'),
	(272369, 119, '2014-04-01 01:22:40.000000', 'temperatura', 787.0000, 'ºC'),
	(272370, 119, '2014-04-01 01:22:41.000000', 'temperatura', 756.0000, 'ºC'),
	(272371, 119, '2014-04-01 01:22:42.000000', 'temperatura', 219.0000, 'ºC'),
	(272372, 119, '2014-04-01 01:22:43.000000', 'temperatura', 26.0000, 'ºC'),
	(272373, 119, '2014-04-01 01:22:44.000000', 'temperatura', 675.0000, 'ºC'),
	(272374, 119, '2014-04-01 01:22:45.000000', 'temperatura', 898.0000, 'ºC'),
	(272375, 119, '2014-04-01 01:22:46.000000', 'temperatura', 67.0000, 'ºC'),
	(272376, 119, '2014-04-01 01:22:47.000000', 'temperatura', 41.0000, 'ºC'),
	(272377, 119, '2014-04-01 01:22:48.000000', 'temperatura', 5.0000, 'ºC'),
	(272378, 119, '2014-04-01 01:22:49.000000', 'temperatura', 1103.0000, 'ºC'),
	(272379, 119, '2014-04-01 01:22:50.000000', 'temperatura', 698.0000, 'ºC'),
	(272380, 119, '2014-04-01 01:22:51.000000', 'temperatura', 182.0000, 'ºC'),
	(272381, 119, '2014-04-01 01:22:52.000000', 'temperatura', 18.0000, 'ºC'),
	(272382, 119, '2014-04-01 01:22:53.000000', 'temperatura', 745.0000, 'ºC'),
	(272383, 119, '2014-04-01 01:22:54.000000', 'temperatura', 70.0000, 'ºC'),
	(272384, 119, '2014-04-01 01:22:55.000000', 'temperatura', 517.0000, 'ºC'),
	(272385, 119, '2014-04-01 01:22:56.000000', 'temperatura', 1174.0000, 'ºC'),
	(272386, 119, '2014-04-01 01:22:57.000000', 'temperatura', 719.0000, 'ºC'),
	(272387, 119, '2014-04-01 01:22:58.000000', 'temperatura', 73.0000, 'ºC'),
	(272388, 119, '2014-04-01 01:22:59.000000', 'temperatura', 608.0000, 'ºC'),
	(272389, 119, '2014-04-01 01:23:00.000000', 'temperatura', 423.0000, 'ºC'),
	(272390, 119, '2014-04-01 01:23:01.000000', 'temperatura', 292.0000, 'ºC'),
	(272391, 119, '2014-04-01 01:23:02.000000', 'temperatura', 193.0000, 'ºC'),
	(272392, 119, '2014-04-01 01:23:03.000000', 'temperatura', 86.0000, 'ºC'),
	(272393, 119, '2014-04-01 01:23:04.000000', 'temperatura', 1055.0000, 'ºC'),
	(272394, 119, '2014-04-01 01:23:05.000000', 'temperatura', 214.0000, 'ºC'),
	(272395, 119, '2014-04-01 01:23:06.000000', 'temperatura', 307.0000, 'ºC'),
	(272396, 119, '2014-04-01 01:23:07.000000', 'temperatura', 895.0000, 'ºC'),
	(272397, 119, '2014-04-01 01:23:08.000000', 'temperatura', 1152.0000, 'ºC'),
	(272398, 119, '2014-04-01 01:23:09.000000', 'temperatura', 677.0000, 'ºC'),
	(272399, 119, '2014-04-01 01:23:10.000000', 'temperatura', 1131.0000, 'ºC'),
	(272400, 119, '2014-04-01 01:23:11.000000', 'temperatura', 23.0000, 'ºC'),
	(272401, 119, '2014-04-01 01:23:12.000000', 'temperatura', 323.0000, 'ºC'),
	(272402, 119, '2014-04-01 01:23:13.000000', 'temperatura', 344.0000, 'ºC'),
	(272403, 119, '2014-04-01 01:23:14.000000', 'temperatura', 754.0000, 'ºC'),
	(272404, 119, '2014-04-01 01:23:15.000000', 'temperatura', 339.0000, 'ºC'),
	(272405, 119, '2014-04-01 01:23:16.000000', 'temperatura', 632.0000, 'ºC'),
	(272406, 119, '2014-04-01 01:23:17.000000', 'temperatura', 943.0000, 'ºC'),
	(272407, 119, '2014-04-01 01:23:18.000000', 'temperatura', 419.0000, 'ºC'),
	(272408, 119, '2014-04-01 01:23:19.000000', 'temperatura', 467.0000, 'ºC'),
	(272409, 119, '2014-04-01 01:23:20.000000', 'temperatura', 1080.0000, 'ºC'),
	(272410, 119, '2014-04-01 01:23:21.000000', 'temperatura', 399.0000, 'ºC'),
	(272411, 119, '2014-04-01 01:23:22.000000', 'temperatura', 1154.0000, 'ºC'),
	(272412, 119, '2014-04-01 01:23:23.000000', 'temperatura', 973.0000, 'ºC'),
	(272413, 119, '2014-04-01 01:23:24.000000', 'temperatura', 205.0000, 'ºC'),
	(272414, 119, '2014-04-01 01:23:25.000000', 'temperatura', 508.0000, 'ºC'),
	(272415, 119, '2014-04-01 01:23:26.000000', 'temperatura', 724.0000, 'ºC'),
	(272416, 119, '2014-04-01 01:23:27.000000', 'temperatura', 897.0000, 'ºC'),
	(272417, 119, '2014-04-01 01:23:28.000000', 'temperatura', 1113.0000, 'ºC'),
	(272418, 119, '2014-04-01 01:23:29.000000', 'temperatura', 473.0000, 'ºC'),
	(272419, 119, '2014-04-01 01:23:30.000000', 'temperatura', 226.0000, 'ºC'),
	(272420, 119, '2014-04-01 01:23:31.000000', 'temperatura', 914.0000, 'ºC'),
	(272421, 119, '2014-04-01 01:23:32.000000', 'temperatura', 291.0000, 'ºC'),
	(272422, 119, '2014-04-01 01:23:33.000000', 'temperatura', 1113.0000, 'ºC'),
	(272423, 119, '2014-04-01 01:23:34.000000', 'temperatura', 1094.0000, 'ºC'),
	(272424, 119, '2014-04-01 01:23:35.000000', 'temperatura', 932.0000, 'ºC'),
	(272425, 119, '2014-04-01 01:23:36.000000', 'temperatura', 180.0000, 'ºC'),
	(272426, 119, '2014-04-01 01:23:37.000000', 'temperatura', 501.0000, 'ºC'),
	(272427, 119, '2014-04-01 01:23:38.000000', 'temperatura', 767.0000, 'ºC'),
	(272428, 119, '2014-04-01 01:23:39.000000', 'temperatura', 1134.0000, 'ºC'),
	(272429, 119, '2014-04-01 01:23:40.000000', 'temperatura', 969.0000, 'ºC'),
	(272430, 119, '2014-04-01 01:23:41.000000', 'temperatura', 241.0000, 'ºC'),
	(272431, 119, '2014-04-01 01:23:42.000000', 'temperatura', 701.0000, 'ºC'),
	(272432, 119, '2014-04-01 01:23:43.000000', 'temperatura', 382.0000, 'ºC'),
	(272433, 119, '2014-04-01 01:23:44.000000', 'temperatura', 1006.0000, 'ºC'),
	(272434, 119, '2014-04-01 01:23:45.000000', 'temperatura', 285.0000, 'ºC'),
	(272435, 119, '2014-04-01 01:23:46.000000', 'temperatura', 810.0000, 'ºC'),
	(272436, 119, '2014-04-01 01:23:47.000000', 'temperatura', 792.0000, 'ºC'),
	(272437, 119, '2014-04-01 01:23:48.000000', 'temperatura', 332.0000, 'ºC'),
	(272438, 119, '2014-04-01 01:23:49.000000', 'temperatura', 485.0000, 'ºC'),
	(272439, 119, '2014-04-01 01:23:50.000000', 'temperatura', 229.0000, 'ºC'),
	(272440, 119, '2014-04-01 01:23:51.000000', 'temperatura', 891.0000, 'ºC'),
	(272441, 119, '2014-04-01 01:23:52.000000', 'temperatura', 167.0000, 'ºC'),
	(272442, 119, '2014-04-01 01:23:53.000000', 'temperatura', 563.0000, 'ºC'),
	(272443, 119, '2014-04-01 01:23:54.000000', 'temperatura', 1115.0000, 'ºC'),
	(272444, 119, '2014-04-01 01:23:55.000000', 'temperatura', 287.0000, 'ºC'),
	(272445, 119, '2014-04-01 01:23:56.000000', 'temperatura', 489.0000, 'ºC'),
	(272446, 119, '2014-04-01 01:23:57.000000', 'temperatura', 387.0000, 'ºC'),
	(272447, 119, '2014-04-01 01:23:58.000000', 'temperatura', 468.0000, 'ºC'),
	(272448, 119, '2014-04-01 01:23:59.000000', 'temperatura', 1177.0000, 'ºC'),
	(272449, 119, '2014-04-01 01:24:00.000000', 'temperatura', 883.0000, 'ºC'),
	(272450, 119, '2014-04-01 01:24:01.000000', 'temperatura', 884.0000, 'ºC'),
	(272451, 119, '2014-04-01 01:24:02.000000', 'temperatura', 572.0000, 'ºC'),
	(272452, 119, '2014-04-01 01:24:03.000000', 'temperatura', 210.0000, 'ºC'),
	(272453, 119, '2014-04-01 01:24:04.000000', 'temperatura', 533.0000, 'ºC'),
	(272454, 119, '2014-04-01 01:24:05.000000', 'temperatura', 837.0000, 'ºC'),
	(272455, 119, '2014-04-01 01:24:06.000000', 'temperatura', 184.0000, 'ºC'),
	(272456, 119, '2014-04-01 01:24:07.000000', 'temperatura', 812.0000, 'ºC'),
	(272457, 119, '2014-04-01 01:24:08.000000', 'temperatura', 1106.0000, 'ºC'),
	(272458, 119, '2014-04-01 01:24:09.000000', 'temperatura', 696.0000, 'ºC'),
	(272459, 119, '2014-04-01 01:24:10.000000', 'temperatura', 162.0000, 'ºC'),
	(272460, 119, '2014-04-01 01:24:11.000000', 'temperatura', 1121.0000, 'ºC'),
	(272461, 119, '2014-04-01 01:24:12.000000', 'temperatura', 319.0000, 'ºC'),
	(272462, 119, '2014-04-01 01:24:13.000000', 'temperatura', 632.0000, 'ºC'),
	(272463, 119, '2014-04-01 01:24:14.000000', 'temperatura', 1004.0000, 'ºC'),
	(272464, 119, '2014-04-01 01:24:15.000000', 'temperatura', 724.0000, 'ºC'),
	(272465, 119, '2014-04-01 01:24:16.000000', 'temperatura', 610.0000, 'ºC'),
	(272466, 119, '2014-04-01 01:24:17.000000', 'temperatura', 876.0000, 'ºC'),
	(272467, 119, '2014-04-01 01:24:18.000000', 'temperatura', 153.0000, 'ºC'),
	(272468, 119, '2014-04-01 01:24:19.000000', 'temperatura', 535.0000, 'ºC'),
	(272469, 119, '2014-04-01 01:24:20.000000', 'temperatura', 1017.0000, 'ºC'),
	(272470, 119, '2014-04-01 01:24:21.000000', 'temperatura', 1081.0000, 'ºC'),
	(272471, 119, '2014-04-01 01:24:22.000000', 'temperatura', 1153.0000, 'ºC'),
	(272472, 119, '2014-04-01 01:24:23.000000', 'temperatura', 123.0000, 'ºC'),
	(272473, 119, '2014-04-01 01:24:24.000000', 'temperatura', 756.0000, 'ºC'),
	(272474, 119, '2014-04-01 01:24:25.000000', 'temperatura', 1011.0000, 'ºC'),
	(272475, 119, '2014-04-01 01:24:26.000000', 'temperatura', 390.0000, 'ºC'),
	(272476, 119, '2014-04-01 01:24:27.000000', 'temperatura', 117.0000, 'ºC'),
	(272477, 119, '2014-04-01 01:24:28.000000', 'temperatura', 614.0000, 'ºC'),
	(272478, 119, '2014-04-01 01:24:29.000000', 'temperatura', 319.0000, 'ºC'),
	(272479, 119, '2014-04-01 01:24:30.000000', 'temperatura', 954.0000, 'ºC'),
	(272480, 119, '2014-04-01 01:24:31.000000', 'temperatura', 213.0000, 'ºC'),
	(272481, 119, '2014-04-01 01:24:32.000000', 'temperatura', 606.0000, 'ºC'),
	(272482, 119, '2014-04-01 01:24:33.000000', 'temperatura', 1188.0000, 'ºC'),
	(272483, 119, '2014-04-01 01:24:34.000000', 'temperatura', 526.0000, 'ºC'),
	(272484, 119, '2014-04-01 01:24:35.000000', 'temperatura', 263.0000, 'ºC'),
	(272485, 119, '2014-04-01 01:24:36.000000', 'temperatura', 940.0000, 'ºC'),
	(272486, 119, '2014-04-01 01:24:37.000000', 'temperatura', 311.0000, 'ºC'),
	(272487, 119, '2014-04-01 01:24:38.000000', 'temperatura', 1137.0000, 'ºC'),
	(272488, 119, '2014-04-01 01:24:39.000000', 'temperatura', 1152.0000, 'ºC'),
	(272489, 119, '2014-04-01 01:24:40.000000', 'temperatura', 1147.0000, 'ºC'),
	(272490, 119, '2014-04-01 01:24:41.000000', 'temperatura', 1081.0000, 'ºC'),
	(272491, 119, '2014-04-01 01:24:42.000000', 'temperatura', 763.0000, 'ºC'),
	(272492, 119, '2014-04-01 01:24:43.000000', 'temperatura', 574.0000, 'ºC'),
	(272493, 119, '2014-04-01 01:24:44.000000', 'temperatura', 583.0000, 'ºC'),
	(272494, 119, '2014-04-01 01:24:45.000000', 'temperatura', 1190.0000, 'ºC'),
	(272495, 119, '2014-04-01 01:24:46.000000', 'temperatura', 603.0000, 'ºC'),
	(272496, 119, '2014-04-01 01:24:47.000000', 'temperatura', 647.0000, 'ºC'),
	(272497, 119, '2014-04-01 01:24:48.000000', 'temperatura', 226.0000, 'ºC'),
	(272498, 119, '2014-04-01 01:24:49.000000', 'temperatura', 388.0000, 'ºC'),
	(272499, 119, '2014-04-01 01:24:50.000000', 'temperatura', 61.0000, 'ºC'),
	(272500, 119, '2014-04-01 01:24:51.000000', 'temperatura', 345.0000, 'ºC'),
	(272501, 119, '2014-04-01 01:24:52.000000', 'temperatura', 340.0000, 'ºC'),
	(272502, 119, '2014-04-01 01:24:53.000000', 'temperatura', 668.0000, 'ºC'),
	(272503, 119, '2014-04-01 01:24:54.000000', 'temperatura', 1120.0000, 'ºC'),
	(272504, 119, '2014-04-01 01:24:55.000000', 'temperatura', 1195.0000, 'ºC'),
	(272505, 119, '2014-04-01 01:24:56.000000', 'temperatura', 215.0000, 'ºC'),
	(272506, 119, '2014-04-01 01:24:57.000000', 'temperatura', 1091.0000, 'ºC'),
	(272507, 119, '2014-04-01 01:24:58.000000', 'temperatura', 12.0000, 'ºC'),
	(272508, 119, '2014-04-01 01:24:59.000000', 'temperatura', 385.0000, 'ºC'),
	(272509, 119, '2014-04-01 01:25:00.000000', 'temperatura', 693.0000, 'ºC'),
	(272510, 119, '2014-04-01 01:25:01.000000', 'temperatura', 1108.0000, 'ºC'),
	(272511, 119, '2014-04-01 01:25:02.000000', 'temperatura', 1060.0000, 'ºC'),
	(272512, 119, '2014-04-01 01:25:03.000000', 'temperatura', 779.0000, 'ºC'),
	(272513, 119, '2014-04-01 01:25:04.000000', 'temperatura', 713.0000, 'ºC'),
	(272514, 119, '2014-04-01 01:25:05.000000', 'temperatura', 29.0000, 'ºC'),
	(272515, 119, '2014-04-01 01:25:06.000000', 'temperatura', 407.0000, 'ºC'),
	(272516, 119, '2014-04-01 01:25:07.000000', 'temperatura', 749.0000, 'ºC'),
	(272517, 119, '2014-04-01 01:25:08.000000', 'temperatura', 125.0000, 'ºC'),
	(272518, 119, '2014-04-01 01:25:09.000000', 'temperatura', 779.0000, 'ºC'),
	(272519, 119, '2014-04-01 01:25:10.000000', 'temperatura', 1122.0000, 'ºC'),
	(272520, 119, '2014-04-01 01:25:11.000000', 'temperatura', 871.0000, 'ºC'),
	(272521, 119, '2014-04-01 01:25:12.000000', 'temperatura', 989.0000, 'ºC'),
	(272522, 119, '2014-04-01 01:25:13.000000', 'temperatura', 1133.0000, 'ºC'),
	(272523, 119, '2014-04-01 01:25:14.000000', 'temperatura', 297.0000, 'ºC'),
	(272524, 119, '2014-04-01 01:25:15.000000', 'temperatura', 489.0000, 'ºC'),
	(272525, 119, '2014-04-01 01:25:16.000000', 'temperatura', 355.0000, 'ºC'),
	(272526, 119, '2014-04-01 01:25:17.000000', 'temperatura', 305.0000, 'ºC'),
	(272527, 119, '2014-04-01 01:25:18.000000', 'temperatura', 464.0000, 'ºC'),
	(272528, 119, '2014-04-01 01:25:19.000000', 'temperatura', 205.0000, 'ºC'),
	(272529, 119, '2014-04-01 01:25:20.000000', 'temperatura', 832.0000, 'ºC'),
	(272530, 119, '2014-04-01 01:25:21.000000', 'temperatura', 1148.0000, 'ºC'),
	(272531, 119, '2014-04-01 01:25:22.000000', 'temperatura', 844.0000, 'ºC'),
	(272532, 119, '2014-04-01 01:25:23.000000', 'temperatura', 774.0000, 'ºC'),
	(272533, 119, '2014-04-01 01:25:24.000000', 'temperatura', 139.0000, 'ºC'),
	(272534, 119, '2014-04-01 01:25:25.000000', 'temperatura', 776.0000, 'ºC'),
	(272535, 119, '2014-04-01 01:25:26.000000', 'temperatura', 1060.0000, 'ºC'),
	(272536, 119, '2014-04-01 01:25:27.000000', 'temperatura', 576.0000, 'ºC'),
	(272537, 119, '2014-04-01 01:25:28.000000', 'temperatura', 898.0000, 'ºC'),
	(272538, 119, '2014-04-01 01:25:29.000000', 'temperatura', 364.0000, 'ºC'),
	(272539, 119, '2014-04-01 01:25:30.000000', 'temperatura', 327.0000, 'ºC'),
	(272540, 119, '2014-04-01 01:25:31.000000', 'temperatura', 542.0000, 'ºC'),
	(272541, 119, '2014-04-01 01:25:32.000000', 'temperatura', 531.0000, 'ºC'),
	(272542, 119, '2014-04-01 01:25:33.000000', 'temperatura', 1030.0000, 'ºC'),
	(272543, 119, '2014-04-01 01:25:34.000000', 'temperatura', 1156.0000, 'ºC'),
	(272544, 119, '2014-04-01 01:25:35.000000', 'temperatura', 292.0000, 'ºC'),
	(272545, 119, '2014-04-01 01:25:36.000000', 'temperatura', 391.0000, 'ºC'),
	(272546, 119, '2014-04-01 01:25:37.000000', 'temperatura', 1082.0000, 'ºC'),
	(272547, 119, '2014-04-01 01:25:38.000000', 'temperatura', 636.0000, 'ºC'),
	(272548, 119, '2014-04-01 01:25:39.000000', 'temperatura', 1137.0000, 'ºC'),
	(272549, 119, '2014-04-01 01:25:40.000000', 'temperatura', 174.0000, 'ºC'),
	(272550, 119, '2014-04-01 01:25:41.000000', 'temperatura', 1061.0000, 'ºC'),
	(272551, 119, '2014-04-01 01:25:42.000000', 'temperatura', 1184.0000, 'ºC'),
	(272552, 119, '2014-04-01 01:25:43.000000', 'temperatura', 339.0000, 'ºC'),
	(272553, 119, '2014-04-01 01:25:44.000000', 'temperatura', 542.0000, 'ºC'),
	(272554, 119, '2014-04-01 01:25:45.000000', 'temperatura', 494.0000, 'ºC'),
	(272555, 119, '2014-04-01 01:25:46.000000', 'temperatura', 846.0000, 'ºC'),
	(272556, 119, '2014-04-01 01:25:47.000000', 'temperatura', 346.0000, 'ºC'),
	(272557, 119, '2014-04-01 01:25:48.000000', 'temperatura', 393.0000, 'ºC'),
	(272558, 119, '2014-04-01 01:25:49.000000', 'temperatura', 929.0000, 'ºC'),
	(272559, 119, '2014-04-01 01:25:50.000000', 'temperatura', 1067.0000, 'ºC'),
	(272560, 119, '2014-04-01 01:25:51.000000', 'temperatura', 146.0000, 'ºC'),
	(272561, 119, '2014-04-01 01:25:52.000000', 'temperatura', 1131.0000, 'ºC'),
	(272562, 119, '2014-04-01 01:25:53.000000', 'temperatura', 418.0000, 'ºC'),
	(272563, 119, '2014-04-01 01:25:54.000000', 'temperatura', 1098.0000, 'ºC'),
	(272564, 119, '2014-04-01 01:25:55.000000', 'temperatura', 638.0000, 'ºC'),
	(272565, 119, '2014-04-01 01:25:56.000000', 'temperatura', 1093.0000, 'ºC'),
	(272566, 119, '2014-04-01 01:25:57.000000', 'temperatura', 1152.0000, 'ºC'),
	(272567, 119, '2014-04-01 01:25:58.000000', 'temperatura', 83.0000, 'ºC'),
	(272568, 119, '2014-04-01 01:25:59.000000', 'temperatura', 559.0000, 'ºC'),
	(272569, 119, '2014-04-01 01:26:00.000000', 'temperatura', 145.0000, 'ºC'),
	(272570, 119, '2014-04-01 01:26:01.000000', 'temperatura', 249.0000, 'ºC'),
	(272571, 119, '2014-04-01 01:26:02.000000', 'temperatura', 812.0000, 'ºC'),
	(272572, 119, '2014-04-01 01:26:03.000000', 'temperatura', 915.0000, 'ºC'),
	(272573, 119, '2014-04-01 01:26:04.000000', 'temperatura', 937.0000, 'ºC'),
	(272574, 119, '2014-04-01 01:26:05.000000', 'temperatura', 740.0000, 'ºC'),
	(272575, 119, '2014-04-01 01:26:06.000000', 'temperatura', 890.0000, 'ºC'),
	(272576, 119, '2014-04-01 01:26:07.000000', 'temperatura', 1030.0000, 'ºC'),
	(272577, 119, '2014-04-01 01:26:08.000000', 'temperatura', 83.0000, 'ºC'),
	(272578, 119, '2014-04-01 01:26:09.000000', 'temperatura', 923.0000, 'ºC'),
	(272579, 119, '2014-04-01 01:26:10.000000', 'temperatura', 769.0000, 'ºC'),
	(272580, 119, '2014-04-01 01:26:11.000000', 'temperatura', 1074.0000, 'ºC'),
	(272581, 119, '2014-04-01 01:26:12.000000', 'temperatura', 664.0000, 'ºC'),
	(272582, 119, '2014-04-01 01:26:13.000000', 'temperatura', 100.0000, 'ºC'),
	(272583, 119, '2014-04-01 01:26:14.000000', 'temperatura', 907.0000, 'ºC'),
	(272584, 119, '2014-04-01 01:26:15.000000', 'temperatura', 636.0000, 'ºC'),
	(272585, 119, '2014-04-01 01:26:16.000000', 'temperatura', 460.0000, 'ºC'),
	(272586, 119, '2014-04-01 01:26:17.000000', 'temperatura', 394.0000, 'ºC'),
	(272587, 119, '2014-04-01 01:26:18.000000', 'temperatura', 588.0000, 'ºC'),
	(272588, 119, '2014-04-01 01:26:19.000000', 'temperatura', 557.0000, 'ºC'),
	(272589, 119, '2014-04-01 01:26:20.000000', 'temperatura', 1024.0000, 'ºC'),
	(272590, 119, '2014-04-01 01:26:21.000000', 'temperatura', 1050.0000, 'ºC'),
	(272591, 119, '2014-04-01 01:26:22.000000', 'temperatura', 977.0000, 'ºC'),
	(272592, 119, '2014-04-01 01:26:23.000000', 'temperatura', 535.0000, 'ºC'),
	(272593, 119, '2014-04-01 01:26:24.000000', 'temperatura', 946.0000, 'ºC'),
	(272594, 119, '2014-04-01 01:26:25.000000', 'temperatura', 726.0000, 'ºC'),
	(272595, 119, '2014-04-01 01:26:26.000000', 'temperatura', 790.0000, 'ºC'),
	(272596, 119, '2014-04-01 01:26:27.000000', 'temperatura', 576.0000, 'ºC'),
	(272597, 119, '2014-04-01 01:26:28.000000', 'temperatura', 507.0000, 'ºC'),
	(272598, 119, '2014-04-01 01:26:29.000000', 'temperatura', 809.0000, 'ºC'),
	(272599, 119, '2014-04-01 01:26:30.000000', 'temperatura', 123.0000, 'ºC'),
	(272600, 119, '2014-04-01 01:26:31.000000', 'temperatura', 588.0000, 'ºC'),
	(272601, 119, '2014-04-01 01:26:32.000000', 'temperatura', 173.0000, 'ºC'),
	(272602, 119, '2014-04-01 01:26:33.000000', 'temperatura', 300.0000, 'ºC'),
	(272603, 119, '2014-04-01 01:26:34.000000', 'temperatura', 983.0000, 'ºC'),
	(272604, 119, '2014-04-01 01:26:35.000000', 'temperatura', 415.0000, 'ºC'),
	(272605, 119, '2014-04-01 01:26:36.000000', 'temperatura', 329.0000, 'ºC'),
	(272606, 119, '2014-04-01 01:26:37.000000', 'temperatura', 397.0000, 'ºC'),
	(272607, 119, '2014-04-01 01:26:38.000000', 'temperatura', 998.0000, 'ºC'),
	(272608, 119, '2014-04-01 01:26:39.000000', 'temperatura', 202.0000, 'ºC'),
	(272609, 119, '2014-04-01 01:26:40.000000', 'temperatura', 414.0000, 'ºC'),
	(272610, 119, '2014-04-01 01:26:41.000000', 'temperatura', 265.0000, 'ºC'),
	(272611, 119, '2014-04-01 01:26:42.000000', 'temperatura', 86.0000, 'ºC'),
	(272612, 119, '2014-04-01 01:26:43.000000', 'temperatura', 834.0000, 'ºC'),
	(272613, 119, '2014-04-01 01:26:44.000000', 'temperatura', 313.0000, 'ºC'),
	(272614, 119, '2014-04-01 01:26:45.000000', 'temperatura', 264.0000, 'ºC'),
	(272615, 119, '2014-04-01 01:26:46.000000', 'temperatura', 379.0000, 'ºC'),
	(272616, 119, '2014-04-01 01:26:47.000000', 'temperatura', 1106.0000, 'ºC'),
	(272617, 119, '2014-04-01 01:26:48.000000', 'temperatura', 793.0000, 'ºC'),
	(272618, 119, '2014-04-01 01:26:49.000000', 'temperatura', 646.0000, 'ºC'),
	(272619, 119, '2014-04-01 01:26:50.000000', 'temperatura', 852.0000, 'ºC'),
	(272620, 119, '2014-04-01 01:26:51.000000', 'temperatura', 1124.0000, 'ºC'),
	(272621, 119, '2014-04-01 01:26:52.000000', 'temperatura', 663.0000, 'ºC'),
	(272622, 119, '2014-04-01 01:26:53.000000', 'temperatura', 1144.0000, 'ºC'),
	(272623, 119, '2014-04-01 01:26:54.000000', 'temperatura', 132.0000, 'ºC'),
	(272624, 119, '2014-04-01 01:26:55.000000', 'temperatura', 830.0000, 'ºC'),
	(272625, 119, '2014-04-01 01:26:56.000000', 'temperatura', 154.0000, 'ºC'),
	(272626, 119, '2014-04-01 01:26:57.000000', 'temperatura', 680.0000, 'ºC'),
	(272627, 119, '2014-04-01 01:26:58.000000', 'temperatura', 537.0000, 'ºC'),
	(272628, 119, '2014-04-01 01:26:59.000000', 'temperatura', 645.0000, 'ºC'),
	(272629, 119, '2014-04-01 01:27:00.000000', 'temperatura', 417.0000, 'ºC'),
	(272630, 119, '2014-04-01 01:27:01.000000', 'temperatura', 150.0000, 'ºC'),
	(272631, 119, '2014-04-01 01:27:02.000000', 'temperatura', 700.0000, 'ºC'),
	(272632, 119, '2014-04-01 01:27:03.000000', 'temperatura', 651.0000, 'ºC'),
	(272633, 119, '2014-04-01 01:27:04.000000', 'temperatura', 1153.0000, 'ºC'),
	(272634, 119, '2014-04-01 01:27:05.000000', 'temperatura', 215.0000, 'ºC'),
	(272635, 119, '2014-04-01 01:27:06.000000', 'temperatura', 17.0000, 'ºC'),
	(272636, 119, '2014-04-01 01:27:07.000000', 'temperatura', 641.0000, 'ºC'),
	(272637, 119, '2014-04-01 01:27:08.000000', 'temperatura', 755.0000, 'ºC'),
	(272638, 119, '2014-04-01 01:27:09.000000', 'temperatura', 652.0000, 'ºC'),
	(272639, 119, '2014-04-01 01:27:10.000000', 'temperatura', 996.0000, 'ºC'),
	(272640, 119, '2014-04-01 01:27:11.000000', 'temperatura', 624.0000, 'ºC'),
	(272641, 119, '2014-04-01 01:27:12.000000', 'temperatura', 134.0000, 'ºC'),
	(272642, 119, '2014-04-01 01:27:13.000000', 'temperatura', 1196.0000, 'ºC'),
	(272643, 119, '2014-04-01 01:27:14.000000', 'temperatura', 781.0000, 'ºC'),
	(272644, 119, '2014-04-01 01:27:15.000000', 'temperatura', 315.0000, 'ºC'),
	(272645, 119, '2014-04-01 01:27:16.000000', 'temperatura', 434.0000, 'ºC'),
	(272646, 119, '2014-04-01 01:27:17.000000', 'temperatura', 27.0000, 'ºC'),
	(272647, 119, '2014-04-01 01:27:18.000000', 'temperatura', 32.0000, 'ºC'),
	(272648, 119, '2014-04-01 01:27:19.000000', 'temperatura', 80.0000, 'ºC'),
	(272649, 119, '2014-04-01 01:27:20.000000', 'temperatura', 304.0000, 'ºC'),
	(272650, 119, '2014-04-01 01:27:21.000000', 'temperatura', 79.0000, 'ºC'),
	(272651, 119, '2014-04-01 01:27:22.000000', 'temperatura', 684.0000, 'ºC'),
	(272652, 119, '2014-04-01 01:27:23.000000', 'temperatura', 784.0000, 'ºC'),
	(272653, 119, '2014-04-01 01:27:24.000000', 'temperatura', 670.0000, 'ºC'),
	(272654, 119, '2014-04-01 01:27:25.000000', 'temperatura', 996.0000, 'ºC'),
	(272655, 119, '2014-04-01 01:27:26.000000', 'temperatura', 572.0000, 'ºC'),
	(272656, 119, '2014-04-01 01:27:27.000000', 'temperatura', 1072.0000, 'ºC'),
	(272657, 119, '2014-04-01 01:27:28.000000', 'temperatura', 45.0000, 'ºC'),
	(272658, 119, '2014-04-01 01:27:29.000000', 'temperatura', 608.0000, 'ºC'),
	(272659, 119, '2014-04-01 01:27:30.000000', 'temperatura', 508.0000, 'ºC'),
	(272660, 119, '2014-04-01 01:27:31.000000', 'temperatura', 717.0000, 'ºC'),
	(272661, 119, '2014-04-01 01:27:32.000000', 'temperatura', 859.0000, 'ºC'),
	(272662, 119, '2014-04-01 01:27:33.000000', 'temperatura', 944.0000, 'ºC'),
	(272663, 119, '2014-04-01 01:27:34.000000', 'temperatura', 944.0000, 'ºC'),
	(272664, 119, '2014-04-01 01:27:35.000000', 'temperatura', 691.0000, 'ºC'),
	(272665, 119, '2014-04-01 01:27:36.000000', 'temperatura', 621.0000, 'ºC'),
	(272666, 119, '2014-04-01 01:27:37.000000', 'temperatura', 1032.0000, 'ºC'),
	(272667, 119, '2014-04-01 01:27:38.000000', 'temperatura', 898.0000, 'ºC'),
	(272668, 119, '2014-04-01 01:27:39.000000', 'temperatura', 197.0000, 'ºC'),
	(272669, 119, '2014-04-01 01:27:40.000000', 'temperatura', 689.0000, 'ºC'),
	(272670, 119, '2014-04-01 01:27:41.000000', 'temperatura', 454.0000, 'ºC'),
	(272671, 120, '2014-04-01 00:00:00.000000', 'temperatura', 852.0000, 'ºC'),
	(272672, 120, '2014-04-01 00:00:01.000000', 'temperatura', 52.0000, 'ºC'),
	(272673, 120, '2014-04-01 00:00:02.000000', 'temperatura', 103.0000, 'ºC'),
	(272674, 120, '2014-04-01 00:00:03.000000', 'temperatura', 363.0000, 'ºC'),
	(272675, 120, '2014-04-01 00:00:04.000000', 'temperatura', 304.0000, 'ºC'),
	(272676, 120, '2014-04-01 00:00:05.000000', 'temperatura', 433.0000, 'ºC'),
	(272677, 120, '2014-04-01 00:00:06.000000', 'temperatura', 53.0000, 'ºC'),
	(272678, 120, '2014-04-01 00:00:07.000000', 'temperatura', 167.0000, 'ºC'),
	(272679, 120, '2014-04-01 00:00:08.000000', 'temperatura', 678.0000, 'ºC'),
	(272680, 120, '2014-04-01 00:00:09.000000', 'temperatura', 487.0000, 'ºC'),
	(272681, 120, '2014-04-01 00:00:10.000000', 'temperatura', 402.0000, 'ºC'),
	(272682, 120, '2014-04-01 00:00:11.000000', 'temperatura', 549.0000, 'ºC'),
	(272683, 120, '2014-04-01 00:00:12.000000', 'temperatura', 341.0000, 'ºC'),
	(272684, 120, '2014-04-01 00:00:13.000000', 'temperatura', 58.0000, 'ºC'),
	(272685, 120, '2014-04-01 00:00:14.000000', 'temperatura', 466.0000, 'ºC'),
	(272686, 120, '2014-04-01 00:00:15.000000', 'temperatura', 956.0000, 'ºC'),
	(272687, 120, '2014-04-01 00:00:16.000000', 'temperatura', 983.0000, 'ºC'),
	(272688, 120, '2014-04-01 00:00:17.000000', 'temperatura', 846.0000, 'ºC'),
	(272689, 120, '2014-04-01 00:00:18.000000', 'temperatura', 84.0000, 'ºC'),
	(272690, 120, '2014-04-01 00:00:19.000000', 'temperatura', 282.0000, 'ºC'),
	(272691, 120, '2014-04-01 00:00:20.000000', 'temperatura', 1160.0000, 'ºC'),
	(272692, 120, '2014-04-01 00:00:21.000000', 'temperatura', 154.0000, 'ºC'),
	(272693, 120, '2014-04-01 00:00:22.000000', 'temperatura', 890.0000, 'ºC'),
	(272694, 120, '2014-04-01 00:00:23.000000', 'temperatura', 387.0000, 'ºC'),
	(272695, 120, '2014-04-01 00:00:24.000000', 'temperatura', 467.0000, 'ºC'),
	(272696, 120, '2014-04-01 00:00:25.000000', 'temperatura', 1175.0000, 'ºC'),
	(272697, 120, '2014-04-01 00:00:26.000000', 'temperatura', 875.0000, 'ºC'),
	(272698, 120, '2014-04-01 00:00:27.000000', 'temperatura', 850.0000, 'ºC'),
	(272699, 120, '2014-04-01 00:00:28.000000', 'temperatura', 426.0000, 'ºC'),
	(272700, 120, '2014-04-01 00:00:29.000000', 'temperatura', 782.0000, 'ºC'),
	(272701, 120, '2014-04-01 00:00:30.000000', 'temperatura', 232.0000, 'ºC'),
	(272702, 120, '2014-04-01 00:00:31.000000', 'temperatura', 13.0000, 'ºC'),
	(272703, 120, '2014-04-01 00:00:32.000000', 'temperatura', 569.0000, 'ºC'),
	(272704, 120, '2014-04-01 00:00:33.000000', 'temperatura', 406.0000, 'ºC'),
	(272705, 120, '2014-04-01 00:00:34.000000', 'temperatura', 325.0000, 'ºC'),
	(272706, 120, '2014-04-01 00:00:35.000000', 'temperatura', 408.0000, 'ºC'),
	(272707, 120, '2014-04-01 00:00:36.000000', 'temperatura', 1064.0000, 'ºC'),
	(272708, 120, '2014-04-01 00:00:37.000000', 'temperatura', 497.0000, 'ºC'),
	(272709, 120, '2014-04-01 00:00:38.000000', 'temperatura', 494.0000, 'ºC'),
	(272710, 120, '2014-04-01 00:00:39.000000', 'temperatura', 980.0000, 'ºC'),
	(272711, 120, '2014-04-01 00:00:40.000000', 'temperatura', 1018.0000, 'ºC'),
	(272712, 120, '2014-04-01 00:00:41.000000', 'temperatura', 951.0000, 'ºC'),
	(272713, 120, '2014-04-01 00:00:42.000000', 'temperatura', 502.0000, 'ºC'),
	(272714, 120, '2014-04-01 00:00:43.000000', 'temperatura', 855.0000, 'ºC'),
	(272715, 120, '2014-04-01 00:00:44.000000', 'temperatura', 371.0000, 'ºC'),
	(272716, 120, '2014-04-01 00:00:45.000000', 'temperatura', 491.0000, 'ºC'),
	(272717, 120, '2014-04-01 00:00:46.000000', 'temperatura', 144.0000, 'ºC'),
	(272718, 120, '2014-04-01 00:00:47.000000', 'temperatura', 445.0000, 'ºC'),
	(272719, 120, '2014-04-01 00:00:48.000000', 'temperatura', 596.0000, 'ºC'),
	(272720, 120, '2014-04-01 00:00:49.000000', 'temperatura', 444.0000, 'ºC'),
	(272721, 120, '2014-04-01 00:00:50.000000', 'temperatura', 432.0000, 'ºC'),
	(272722, 120, '2014-04-01 00:00:51.000000', 'temperatura', 828.0000, 'ºC'),
	(272723, 120, '2014-04-01 00:00:52.000000', 'temperatura', 447.0000, 'ºC'),
	(272724, 120, '2014-04-01 00:00:53.000000', 'temperatura', 950.0000, 'ºC'),
	(272725, 120, '2014-04-01 00:00:54.000000', 'temperatura', 1009.0000, 'ºC'),
	(272726, 120, '2014-04-01 00:00:55.000000', 'temperatura', 996.0000, 'ºC'),
	(272727, 120, '2014-04-01 00:00:56.000000', 'temperatura', 753.0000, 'ºC'),
	(272728, 120, '2014-04-01 00:00:57.000000', 'temperatura', 777.0000, 'ºC'),
	(272729, 120, '2014-04-01 00:00:58.000000', 'temperatura', 429.0000, 'ºC'),
	(272730, 120, '2014-04-01 00:00:59.000000', 'temperatura', 1014.0000, 'ºC'),
	(272731, 120, '2014-04-01 00:01:00.000000', 'temperatura', 183.0000, 'ºC'),
	(272732, 120, '2014-04-01 00:01:01.000000', 'temperatura', 273.0000, 'ºC'),
	(272733, 120, '2014-04-01 00:01:02.000000', 'temperatura', 816.0000, 'ºC'),
	(272734, 120, '2014-04-01 00:01:03.000000', 'temperatura', 860.0000, 'ºC'),
	(272735, 120, '2014-04-01 00:01:04.000000', 'temperatura', 654.0000, 'ºC'),
	(272736, 120, '2014-04-01 00:01:05.000000', 'temperatura', 692.0000, 'ºC'),
	(272737, 120, '2014-04-01 00:01:06.000000', 'temperatura', 296.0000, 'ºC'),
	(272738, 120, '2014-04-01 00:01:07.000000', 'temperatura', 604.0000, 'ºC'),
	(272739, 120, '2014-04-01 00:01:08.000000', 'temperatura', 933.0000, 'ºC'),
	(272740, 120, '2014-04-01 00:01:09.000000', 'temperatura', 453.0000, 'ºC'),
	(272741, 120, '2014-04-01 00:01:10.000000', 'temperatura', 665.0000, 'ºC'),
	(272742, 120, '2014-04-01 00:01:11.000000', 'temperatura', 769.0000, 'ºC'),
	(272743, 120, '2014-04-01 00:01:12.000000', 'temperatura', 650.0000, 'ºC'),
	(272744, 120, '2014-04-01 00:01:13.000000', 'temperatura', 943.0000, 'ºC'),
	(272745, 120, '2014-04-01 00:01:14.000000', 'temperatura', 366.0000, 'ºC'),
	(272746, 120, '2014-04-01 00:01:15.000000', 'temperatura', 201.0000, 'ºC'),
	(272747, 120, '2014-04-01 00:01:16.000000', 'temperatura', 1106.0000, 'ºC'),
	(272748, 120, '2014-04-01 00:01:17.000000', 'temperatura', 130.0000, 'ºC'),
	(272749, 120, '2014-04-01 00:01:18.000000', 'temperatura', 932.0000, 'ºC'),
	(272750, 120, '2014-04-01 00:01:19.000000', 'temperatura', 671.0000, 'ºC'),
	(272751, 120, '2014-04-01 00:01:20.000000', 'temperatura', 559.0000, 'ºC'),
	(272752, 120, '2014-04-01 00:01:21.000000', 'temperatura', 780.0000, 'ºC'),
	(272753, 120, '2014-04-01 00:01:22.000000', 'temperatura', 1027.0000, 'ºC'),
	(272754, 120, '2014-04-01 00:01:23.000000', 'temperatura', 393.0000, 'ºC'),
	(272755, 120, '2014-04-01 00:01:24.000000', 'temperatura', 84.0000, 'ºC'),
	(272756, 120, '2014-04-01 00:01:25.000000', 'temperatura', 445.0000, 'ºC'),
	(272757, 120, '2014-04-01 00:01:26.000000', 'temperatura', 770.0000, 'ºC'),
	(272758, 120, '2014-04-01 00:01:27.000000', 'temperatura', 116.0000, 'ºC'),
	(272759, 120, '2014-04-01 00:01:28.000000', 'temperatura', 672.0000, 'ºC'),
	(272760, 120, '2014-04-01 00:01:29.000000', 'temperatura', 610.0000, 'ºC'),
	(272761, 120, '2014-04-01 00:01:30.000000', 'temperatura', 1037.0000, 'ºC'),
	(272762, 120, '2014-04-01 00:01:31.000000', 'temperatura', 955.0000, 'ºC'),
	(272763, 120, '2014-04-01 00:01:32.000000', 'temperatura', 466.0000, 'ºC'),
	(272764, 120, '2014-04-01 00:01:33.000000', 'temperatura', 665.0000, 'ºC'),
	(272765, 120, '2014-04-01 00:01:34.000000', 'temperatura', 725.0000, 'ºC'),
	(272766, 120, '2014-04-01 00:01:35.000000', 'temperatura', 433.0000, 'ºC'),
	(272767, 120, '2014-04-01 00:01:36.000000', 'temperatura', 1190.0000, 'ºC'),
	(272768, 120, '2014-04-01 00:01:37.000000', 'temperatura', 1051.0000, 'ºC'),
	(272769, 120, '2014-04-01 00:01:38.000000', 'temperatura', 484.0000, 'ºC'),
	(272770, 120, '2014-04-01 00:01:39.000000', 'temperatura', 470.0000, 'ºC'),
	(272771, 120, '2014-04-01 00:01:40.000000', 'temperatura', 900.0000, 'ºC'),
	(272772, 120, '2014-04-01 00:01:41.000000', 'temperatura', 687.0000, 'ºC'),
	(272773, 120, '2014-04-01 00:01:42.000000', 'temperatura', 736.0000, 'ºC'),
	(272774, 120, '2014-04-01 00:01:43.000000', 'temperatura', 419.0000, 'ºC'),
	(272775, 120, '2014-04-01 00:01:44.000000', 'temperatura', 1087.0000, 'ºC'),
	(272776, 120, '2014-04-01 00:01:45.000000', 'temperatura', 581.0000, 'ºC'),
	(272777, 120, '2014-04-01 00:01:46.000000', 'temperatura', 844.0000, 'ºC'),
	(272778, 120, '2014-04-01 00:01:47.000000', 'temperatura', 79.0000, 'ºC'),
	(272779, 120, '2014-04-01 00:01:48.000000', 'temperatura', 261.0000, 'ºC'),
	(272780, 120, '2014-04-01 00:01:49.000000', 'temperatura', 1071.0000, 'ºC'),
	(272781, 120, '2014-04-01 00:01:50.000000', 'temperatura', 970.0000, 'ºC'),
	(272782, 120, '2014-04-01 00:01:51.000000', 'temperatura', 439.0000, 'ºC'),
	(272783, 120, '2014-04-01 00:01:52.000000', 'temperatura', 483.0000, 'ºC'),
	(272784, 120, '2014-04-01 00:01:53.000000', 'temperatura', 1101.0000, 'ºC'),
	(272785, 120, '2014-04-01 00:01:54.000000', 'temperatura', 454.0000, 'ºC'),
	(272786, 120, '2014-04-01 00:01:55.000000', 'temperatura', 167.0000, 'ºC'),
	(272787, 120, '2014-04-01 00:01:56.000000', 'temperatura', 676.0000, 'ºC'),
	(272788, 120, '2014-04-01 00:01:57.000000', 'temperatura', 477.0000, 'ºC'),
	(272789, 120, '2014-04-01 00:01:58.000000', 'temperatura', 357.0000, 'ºC'),
	(272790, 120, '2014-04-01 00:01:59.000000', 'temperatura', 357.0000, 'ºC'),
	(272791, 120, '2014-04-01 00:02:00.000000', 'temperatura', 712.0000, 'ºC'),
	(272792, 120, '2014-04-01 00:02:01.000000', 'temperatura', 89.0000, 'ºC'),
	(272793, 120, '2014-04-01 00:02:02.000000', 'temperatura', 712.0000, 'ºC'),
	(272794, 120, '2014-04-01 00:02:03.000000', 'temperatura', 891.0000, 'ºC'),
	(272795, 120, '2014-04-01 00:02:04.000000', 'temperatura', 1119.0000, 'ºC'),
	(272796, 120, '2014-04-01 00:02:05.000000', 'temperatura', 525.0000, 'ºC'),
	(272797, 120, '2014-04-01 00:02:06.000000', 'temperatura', 468.0000, 'ºC'),
	(272798, 120, '2014-04-01 00:02:07.000000', 'temperatura', 764.0000, 'ºC'),
	(272799, 120, '2014-04-01 00:02:08.000000', 'temperatura', 17.0000, 'ºC'),
	(272800, 120, '2014-04-01 00:02:09.000000', 'temperatura', 193.0000, 'ºC'),
	(272801, 120, '2014-04-01 00:02:10.000000', 'temperatura', 914.0000, 'ºC'),
	(272802, 120, '2014-04-01 00:02:11.000000', 'temperatura', 393.0000, 'ºC'),
	(272803, 120, '2014-04-01 00:02:12.000000', 'temperatura', 424.0000, 'ºC'),
	(272804, 120, '2014-04-01 00:02:13.000000', 'temperatura', 942.0000, 'ºC'),
	(272805, 120, '2014-04-01 00:02:14.000000', 'temperatura', 1038.0000, 'ºC'),
	(272806, 120, '2014-04-01 00:02:15.000000', 'temperatura', 1166.0000, 'ºC'),
	(272807, 120, '2014-04-01 00:02:16.000000', 'temperatura', 313.0000, 'ºC'),
	(272808, 120, '2014-04-01 00:02:17.000000', 'temperatura', 470.0000, 'ºC'),
	(272809, 120, '2014-04-01 00:02:18.000000', 'temperatura', 212.0000, 'ºC'),
	(272810, 120, '2014-04-01 00:02:19.000000', 'temperatura', 849.0000, 'ºC'),
	(272811, 120, '2014-04-01 00:02:20.000000', 'temperatura', 12.0000, 'ºC'),
	(272812, 120, '2014-04-01 00:02:21.000000', 'temperatura', 1112.0000, 'ºC'),
	(272813, 120, '2014-04-01 00:02:22.000000', 'temperatura', 726.0000, 'ºC'),
	(272814, 120, '2014-04-01 00:02:23.000000', 'temperatura', 295.0000, 'ºC'),
	(272815, 120, '2014-04-01 00:02:24.000000', 'temperatura', 499.0000, 'ºC'),
	(272816, 120, '2014-04-01 00:02:25.000000', 'temperatura', 407.0000, 'ºC'),
	(272817, 120, '2014-04-01 00:02:26.000000', 'temperatura', 539.0000, 'ºC'),
	(272818, 120, '2014-04-01 00:02:27.000000', 'temperatura', 275.0000, 'ºC'),
	(272819, 120, '2014-04-01 00:02:28.000000', 'temperatura', 957.0000, 'ºC'),
	(272820, 120, '2014-04-01 00:02:29.000000', 'temperatura', 361.0000, 'ºC'),
	(272821, 120, '2014-04-01 00:02:30.000000', 'temperatura', 135.0000, 'ºC'),
	(272822, 120, '2014-04-01 00:02:31.000000', 'temperatura', 791.0000, 'ºC'),
	(272823, 120, '2014-04-01 00:02:32.000000', 'temperatura', 1153.0000, 'ºC'),
	(272824, 120, '2014-04-01 00:02:33.000000', 'temperatura', 990.0000, 'ºC'),
	(272825, 120, '2014-04-01 00:02:34.000000', 'temperatura', 292.0000, 'ºC'),
	(272826, 120, '2014-04-01 00:02:35.000000', 'temperatura', 891.0000, 'ºC'),
	(272827, 120, '2014-04-01 00:02:36.000000', 'temperatura', 1180.0000, 'ºC'),
	(272828, 120, '2014-04-01 00:02:37.000000', 'temperatura', 826.0000, 'ºC'),
	(272829, 120, '2014-04-01 00:02:38.000000', 'temperatura', 590.0000, 'ºC'),
	(272830, 120, '2014-04-01 00:02:39.000000', 'temperatura', 473.0000, 'ºC'),
	(272831, 120, '2014-04-01 00:02:40.000000', 'temperatura', 595.0000, 'ºC'),
	(272832, 120, '2014-04-01 00:02:41.000000', 'temperatura', 358.0000, 'ºC'),
	(272833, 120, '2014-04-01 00:02:42.000000', 'temperatura', 4.0000, 'ºC'),
	(272834, 120, '2014-04-01 00:02:43.000000', 'temperatura', 146.0000, 'ºC'),
	(272835, 120, '2014-04-01 00:02:44.000000', 'temperatura', 718.0000, 'ºC'),
	(272836, 120, '2014-04-01 00:02:45.000000', 'temperatura', 755.0000, 'ºC'),
	(272837, 120, '2014-04-01 00:02:46.000000', 'temperatura', 420.0000, 'ºC'),
	(272838, 120, '2014-04-01 00:02:47.000000', 'temperatura', 1038.0000, 'ºC'),
	(272839, 120, '2014-04-01 00:02:48.000000', 'temperatura', 327.0000, 'ºC'),
	(272840, 120, '2014-04-01 00:02:49.000000', 'temperatura', 925.0000, 'ºC'),
	(272841, 120, '2014-04-01 00:02:50.000000', 'temperatura', 43.0000, 'ºC'),
	(272842, 120, '2014-04-01 00:02:51.000000', 'temperatura', 1040.0000, 'ºC'),
	(272843, 120, '2014-04-01 00:02:52.000000', 'temperatura', 270.0000, 'ºC'),
	(272844, 120, '2014-04-01 00:02:53.000000', 'temperatura', 633.0000, 'ºC'),
	(272845, 120, '2014-04-01 00:02:54.000000', 'temperatura', 1154.0000, 'ºC'),
	(272846, 120, '2014-04-01 00:02:55.000000', 'temperatura', 274.0000, 'ºC'),
	(272847, 120, '2014-04-01 00:02:56.000000', 'temperatura', 307.0000, 'ºC'),
	(272848, 120, '2014-04-01 00:02:57.000000', 'temperatura', 712.0000, 'ºC'),
	(272849, 120, '2014-04-01 00:02:58.000000', 'temperatura', 241.0000, 'ºC'),
	(272850, 120, '2014-04-01 00:02:59.000000', 'temperatura', 270.0000, 'ºC'),
	(272851, 120, '2014-04-01 00:03:00.000000', 'temperatura', 627.0000, 'ºC'),
	(272852, 120, '2014-04-01 00:03:01.000000', 'temperatura', 1124.0000, 'ºC'),
	(272853, 120, '2014-04-01 00:03:02.000000', 'temperatura', 139.0000, 'ºC'),
	(272854, 120, '2014-04-01 00:03:03.000000', 'temperatura', 926.0000, 'ºC'),
	(272855, 120, '2014-04-01 00:03:04.000000', 'temperatura', 614.0000, 'ºC'),
	(272856, 120, '2014-04-01 00:03:05.000000', 'temperatura', 290.0000, 'ºC'),
	(272857, 120, '2014-04-01 00:03:06.000000', 'temperatura', 809.0000, 'ºC'),
	(272858, 120, '2014-04-01 00:03:07.000000', 'temperatura', 775.0000, 'ºC'),
	(272859, 120, '2014-04-01 00:03:08.000000', 'temperatura', 247.0000, 'ºC'),
	(272860, 120, '2014-04-01 00:03:09.000000', 'temperatura', 112.0000, 'ºC'),
	(272861, 120, '2014-04-01 00:03:10.000000', 'temperatura', 1021.0000, 'ºC'),
	(272862, 120, '2014-04-01 00:03:11.000000', 'temperatura', 1170.0000, 'ºC'),
	(272863, 120, '2014-04-01 00:03:12.000000', 'temperatura', 386.0000, 'ºC'),
	(272864, 120, '2014-04-01 00:03:13.000000', 'temperatura', 819.0000, 'ºC'),
	(272865, 120, '2014-04-01 00:03:14.000000', 'temperatura', 538.0000, 'ºC'),
	(272866, 120, '2014-04-01 00:03:15.000000', 'temperatura', 233.0000, 'ºC'),
	(272867, 120, '2014-04-01 00:03:16.000000', 'temperatura', 753.0000, 'ºC'),
	(272868, 120, '2014-04-01 00:03:17.000000', 'temperatura', 664.0000, 'ºC'),
	(272869, 120, '2014-04-01 00:03:18.000000', 'temperatura', 1064.0000, 'ºC'),
	(272870, 120, '2014-04-01 00:03:19.000000', 'temperatura', 926.0000, 'ºC'),
	(272871, 120, '2014-04-01 00:03:20.000000', 'temperatura', 239.0000, 'ºC'),
	(272872, 120, '2014-04-01 00:03:21.000000', 'temperatura', 818.0000, 'ºC'),
	(272873, 120, '2014-04-01 00:03:22.000000', 'temperatura', 973.0000, 'ºC'),
	(272874, 120, '2014-04-01 00:03:23.000000', 'temperatura', 11.0000, 'ºC'),
	(272875, 120, '2014-04-01 00:03:24.000000', 'temperatura', 736.0000, 'ºC'),
	(272876, 120, '2014-04-01 00:03:25.000000', 'temperatura', 47.0000, 'ºC'),
	(272877, 120, '2014-04-01 00:03:26.000000', 'temperatura', 426.0000, 'ºC'),
	(272878, 120, '2014-04-01 00:03:27.000000', 'temperatura', 793.0000, 'ºC'),
	(272879, 120, '2014-04-01 00:03:28.000000', 'temperatura', 287.0000, 'ºC'),
	(272880, 120, '2014-04-01 00:03:29.000000', 'temperatura', 258.0000, 'ºC'),
	(272881, 120, '2014-04-01 00:03:30.000000', 'temperatura', 427.0000, 'ºC'),
	(272882, 120, '2014-04-01 00:03:31.000000', 'temperatura', 160.0000, 'ºC'),
	(272883, 120, '2014-04-01 00:03:32.000000', 'temperatura', 722.0000, 'ºC'),
	(272884, 120, '2014-04-01 00:03:33.000000', 'temperatura', 730.0000, 'ºC'),
	(272885, 120, '2014-04-01 00:03:34.000000', 'temperatura', 286.0000, 'ºC'),
	(272886, 120, '2014-04-01 00:03:35.000000', 'temperatura', 440.0000, 'ºC'),
	(272887, 120, '2014-04-01 00:03:36.000000', 'temperatura', 142.0000, 'ºC'),
	(272888, 120, '2014-04-01 00:03:37.000000', 'temperatura', 591.0000, 'ºC'),
	(272889, 120, '2014-04-01 00:03:38.000000', 'temperatura', 131.0000, 'ºC'),
	(272890, 120, '2014-04-01 00:03:39.000000', 'temperatura', 82.0000, 'ºC'),
	(272891, 120, '2014-04-01 00:03:40.000000', 'temperatura', 17.0000, 'ºC'),
	(272892, 120, '2014-04-01 00:03:41.000000', 'temperatura', 1038.0000, 'ºC'),
	(272893, 120, '2014-04-01 00:03:42.000000', 'temperatura', 339.0000, 'ºC'),
	(272894, 120, '2014-04-01 00:03:43.000000', 'temperatura', 982.0000, 'ºC'),
	(272895, 120, '2014-04-01 00:03:44.000000', 'temperatura', 294.0000, 'ºC'),
	(272896, 120, '2014-04-01 00:03:45.000000', 'temperatura', 925.0000, 'ºC'),
	(272897, 120, '2014-04-01 00:03:46.000000', 'temperatura', 145.0000, 'ºC'),
	(272898, 120, '2014-04-01 00:03:47.000000', 'temperatura', 348.0000, 'ºC'),
	(272899, 120, '2014-04-01 00:03:48.000000', 'temperatura', 105.0000, 'ºC'),
	(272900, 120, '2014-04-01 00:03:49.000000', 'temperatura', 683.0000, 'ºC'),
	(272901, 120, '2014-04-01 00:03:50.000000', 'temperatura', 698.0000, 'ºC'),
	(272902, 120, '2014-04-01 00:03:51.000000', 'temperatura', 245.0000, 'ºC'),
	(272903, 120, '2014-04-01 00:03:52.000000', 'temperatura', 330.0000, 'ºC'),
	(272904, 120, '2014-04-01 00:03:53.000000', 'temperatura', 917.0000, 'ºC'),
	(272905, 120, '2014-04-01 00:03:54.000000', 'temperatura', 1196.0000, 'ºC'),
	(272906, 120, '2014-04-01 00:03:55.000000', 'temperatura', 829.0000, 'ºC'),
	(272907, 120, '2014-04-01 00:03:56.000000', 'temperatura', 556.0000, 'ºC'),
	(272908, 120, '2014-04-01 00:03:57.000000', 'temperatura', 292.0000, 'ºC'),
	(272909, 120, '2014-04-01 00:03:58.000000', 'temperatura', 996.0000, 'ºC'),
	(272910, 120, '2014-04-01 00:03:59.000000', 'temperatura', 501.0000, 'ºC'),
	(272911, 120, '2014-04-01 00:04:00.000000', 'temperatura', 721.0000, 'ºC'),
	(272912, 120, '2014-04-01 00:04:01.000000', 'temperatura', 902.0000, 'ºC'),
	(272913, 120, '2014-04-01 00:04:02.000000', 'temperatura', 1145.0000, 'ºC'),
	(272914, 120, '2014-04-01 00:04:03.000000', 'temperatura', 622.0000, 'ºC'),
	(272915, 120, '2014-04-01 00:04:04.000000', 'temperatura', 875.0000, 'ºC'),
	(272916, 120, '2014-04-01 00:04:05.000000', 'temperatura', 109.0000, 'ºC'),
	(272917, 120, '2014-04-01 00:04:06.000000', 'temperatura', 320.0000, 'ºC'),
	(272918, 120, '2014-04-01 00:04:07.000000', 'temperatura', 75.0000, 'ºC'),
	(272919, 120, '2014-04-01 00:04:08.000000', 'temperatura', 615.0000, 'ºC'),
	(272920, 120, '2014-04-01 00:04:09.000000', 'temperatura', 451.0000, 'ºC'),
	(272921, 120, '2014-04-01 00:04:10.000000', 'temperatura', 410.0000, 'ºC'),
	(272922, 120, '2014-04-01 00:04:11.000000', 'temperatura', 700.0000, 'ºC'),
	(272923, 120, '2014-04-01 00:04:12.000000', 'temperatura', 1067.0000, 'ºC'),
	(272924, 120, '2014-04-01 00:04:13.000000', 'temperatura', 837.0000, 'ºC'),
	(272925, 120, '2014-04-01 00:04:14.000000', 'temperatura', 985.0000, 'ºC'),
	(272926, 120, '2014-04-01 00:04:15.000000', 'temperatura', 13.0000, 'ºC'),
	(272927, 120, '2014-04-01 00:04:16.000000', 'temperatura', 711.0000, 'ºC'),
	(272928, 120, '2014-04-01 00:04:17.000000', 'temperatura', 1118.0000, 'ºC'),
	(272929, 120, '2014-04-01 00:04:18.000000', 'temperatura', 1057.0000, 'ºC'),
	(272930, 120, '2014-04-01 00:04:19.000000', 'temperatura', 731.0000, 'ºC'),
	(272931, 120, '2014-04-01 00:04:20.000000', 'temperatura', 486.0000, 'ºC'),
	(272932, 120, '2014-04-01 00:04:21.000000', 'temperatura', 235.0000, 'ºC'),
	(272933, 120, '2014-04-01 00:04:22.000000', 'temperatura', 918.0000, 'ºC'),
	(272934, 120, '2014-04-01 00:04:23.000000', 'temperatura', 285.0000, 'ºC'),
	(272935, 120, '2014-04-01 00:04:24.000000', 'temperatura', 1070.0000, 'ºC'),
	(272936, 120, '2014-04-01 00:04:25.000000', 'temperatura', 898.0000, 'ºC'),
	(272937, 120, '2014-04-01 00:04:26.000000', 'temperatura', 82.0000, 'ºC'),
	(272938, 120, '2014-04-01 00:04:27.000000', 'temperatura', 113.0000, 'ºC'),
	(272939, 120, '2014-04-01 00:04:28.000000', 'temperatura', 321.0000, 'ºC'),
	(272940, 120, '2014-04-01 00:04:29.000000', 'temperatura', 64.0000, 'ºC'),
	(272941, 120, '2014-04-01 00:04:30.000000', 'temperatura', 561.0000, 'ºC'),
	(272942, 120, '2014-04-01 00:04:31.000000', 'temperatura', 211.0000, 'ºC'),
	(272943, 120, '2014-04-01 00:04:32.000000', 'temperatura', 574.0000, 'ºC'),
	(272944, 120, '2014-04-01 00:04:33.000000', 'temperatura', 1038.0000, 'ºC'),
	(272945, 120, '2014-04-01 00:04:34.000000', 'temperatura', 1068.0000, 'ºC'),
	(272946, 120, '2014-04-01 00:04:35.000000', 'temperatura', 1028.0000, 'ºC'),
	(272947, 120, '2014-04-01 00:04:36.000000', 'temperatura', 737.0000, 'ºC'),
	(272948, 120, '2014-04-01 00:04:37.000000', 'temperatura', 599.0000, 'ºC'),
	(272949, 120, '2014-04-01 00:04:38.000000', 'temperatura', 784.0000, 'ºC'),
	(272950, 120, '2014-04-01 00:04:39.000000', 'temperatura', 923.0000, 'ºC'),
	(272951, 120, '2014-04-01 00:04:40.000000', 'temperatura', 1065.0000, 'ºC'),
	(272952, 120, '2014-04-01 00:04:41.000000', 'temperatura', 157.0000, 'ºC'),
	(272953, 120, '2014-04-01 00:04:42.000000', 'temperatura', 1190.0000, 'ºC'),
	(272954, 120, '2014-04-01 00:04:43.000000', 'temperatura', 682.0000, 'ºC'),
	(272955, 120, '2014-04-01 00:04:44.000000', 'temperatura', 1037.0000, 'ºC'),
	(272956, 120, '2014-04-01 00:04:45.000000', 'temperatura', 739.0000, 'ºC'),
	(272957, 120, '2014-04-01 00:04:46.000000', 'temperatura', 587.0000, 'ºC'),
	(272958, 120, '2014-04-01 00:04:47.000000', 'temperatura', 719.0000, 'ºC'),
	(272959, 120, '2014-04-01 00:04:48.000000', 'temperatura', 633.0000, 'ºC'),
	(272960, 120, '2014-04-01 00:04:49.000000', 'temperatura', 1009.0000, 'ºC'),
	(272961, 120, '2014-04-01 00:04:50.000000', 'temperatura', 747.0000, 'ºC'),
	(272962, 120, '2014-04-01 00:04:51.000000', 'temperatura', 708.0000, 'ºC'),
	(272963, 120, '2014-04-01 00:04:52.000000', 'temperatura', 100.0000, 'ºC'),
	(272964, 120, '2014-04-01 00:04:53.000000', 'temperatura', 776.0000, 'ºC'),
	(272965, 120, '2014-04-01 00:04:54.000000', 'temperatura', 1182.0000, 'ºC'),
	(272966, 120, '2014-04-01 00:04:55.000000', 'temperatura', 1180.0000, 'ºC'),
	(272967, 120, '2014-04-01 00:04:56.000000', 'temperatura', 1156.0000, 'ºC'),
	(272968, 120, '2014-04-01 00:04:57.000000', 'temperatura', 1041.0000, 'ºC'),
	(272969, 120, '2014-04-01 00:04:58.000000', 'temperatura', 539.0000, 'ºC'),
	(272970, 120, '2014-04-01 00:04:59.000000', 'temperatura', 771.0000, 'ºC'),
	(272971, 120, '2014-04-01 00:05:00.000000', 'temperatura', 1038.0000, 'ºC'),
	(272972, 120, '2014-04-01 00:05:01.000000', 'temperatura', 479.0000, 'ºC'),
	(272973, 120, '2014-04-01 00:05:02.000000', 'temperatura', 482.0000, 'ºC'),
	(272974, 120, '2014-04-01 00:05:03.000000', 'temperatura', 971.0000, 'ºC'),
	(272975, 120, '2014-04-01 00:05:04.000000', 'temperatura', 1012.0000, 'ºC'),
	(272976, 120, '2014-04-01 00:05:05.000000', 'temperatura', 947.0000, 'ºC'),
	(272977, 120, '2014-04-01 00:05:06.000000', 'temperatura', 501.0000, 'ºC'),
	(272978, 120, '2014-04-01 00:05:07.000000', 'temperatura', 864.0000, 'ºC'),
	(272979, 120, '2014-04-01 00:05:08.000000', 'temperatura', 419.0000, 'ºC'),
	(272980, 120, '2014-04-01 00:05:09.000000', 'temperatura', 702.0000, 'ºC'),
	(272981, 120, '2014-04-01 00:05:10.000000', 'temperatura', 1052.0000, 'ºC'),
	(272982, 120, '2014-04-01 00:05:11.000000', 'temperatura', 757.0000, 'ºC'),
	(272983, 120, '2014-04-01 00:05:12.000000', 'temperatura', 627.0000, 'ºC'),
	(272984, 120, '2014-04-01 00:05:13.000000', 'temperatura', 866.0000, 'ºC'),
	(272985, 120, '2014-04-01 00:05:14.000000', 'temperatura', 49.0000, 'ºC'),
	(272986, 120, '2014-04-01 00:05:15.000000', 'temperatura', 46.0000, 'ºC'),
	(272987, 120, '2014-04-01 00:05:16.000000', 'temperatura', 84.0000, 'ºC'),
	(272988, 120, '2014-04-01 00:05:17.000000', 'temperatura', 284.0000, 'ºC'),
	(272989, 120, '2014-04-01 00:05:18.000000', 'temperatura', 1170.0000, 'ºC'),
	(272990, 120, '2014-04-01 00:05:19.000000', 'temperatura', 196.0000, 'ºC'),
	(272991, 120, '2014-04-01 00:05:20.000000', 'temperatura', 1071.0000, 'ºC'),
	(272992, 120, '2014-04-01 00:05:21.000000', 'temperatura', 1167.0000, 'ºC'),
	(272993, 120, '2014-04-01 00:05:22.000000', 'temperatura', 224.0000, 'ºC'),
	(272994, 120, '2014-04-01 00:05:23.000000', 'temperatura', 21.0000, 'ºC'),
	(272995, 120, '2014-04-01 00:05:24.000000', 'temperatura', 631.0000, 'ºC'),
	(272996, 120, '2014-04-01 00:05:25.000000', 'temperatura', 691.0000, 'ºC'),
	(272997, 120, '2014-04-01 00:05:26.000000', 'temperatura', 365.0000, 'ºC'),
	(272998, 120, '2014-04-01 00:05:27.000000', 'temperatura', 953.0000, 'ºC'),
	(272999, 120, '2014-04-01 00:05:28.000000', 'temperatura', 70.0000, 'ºC'),
	(273000, 120, '2014-04-01 00:05:29.000000', 'temperatura', 1092.0000, 'ºC'),
	(273001, 120, '2014-04-01 00:05:30.000000', 'temperatura', 450.0000, 'ºC'),
	(273002, 120, '2014-04-01 00:05:31.000000', 'temperatura', 175.0000, 'ºC'),
	(273003, 120, '2014-04-01 00:05:32.000000', 'temperatura', 723.0000, 'ºC'),
	(273004, 120, '2014-04-01 00:05:33.000000', 'temperatura', 692.0000, 'ºC'),
	(273005, 120, '2014-04-01 00:05:34.000000', 'temperatura', 92.0000, 'ºC'),
	(273006, 120, '2014-04-01 00:05:35.000000', 'temperatura', 785.0000, 'ºC'),
	(273007, 120, '2014-04-01 00:05:36.000000', 'temperatura', 50.0000, 'ºC'),
	(273008, 120, '2014-04-01 00:05:37.000000', 'temperatura', 297.0000, 'ºC'),
	(273009, 120, '2014-04-01 00:05:38.000000', 'temperatura', 133.0000, 'ºC'),
	(273010, 120, '2014-04-01 00:05:39.000000', 'temperatura', 974.0000, 'ºC'),
	(273011, 120, '2014-04-01 00:05:40.000000', 'temperatura', 871.0000, 'ºC'),
	(273012, 120, '2014-04-01 00:05:41.000000', 'temperatura', 235.0000, 'ºC'),
	(273013, 120, '2014-04-01 00:05:42.000000', 'temperatura', 961.0000, 'ºC'),
	(273014, 120, '2014-04-01 00:05:43.000000', 'temperatura', 503.0000, 'ºC'),
	(273015, 120, '2014-04-01 00:05:44.000000', 'temperatura', 831.0000, 'ºC'),
	(273016, 120, '2014-04-01 00:05:45.000000', 'temperatura', 248.0000, 'ºC'),
	(273017, 120, '2014-04-01 00:05:46.000000', 'temperatura', 1147.0000, 'ºC'),
	(273018, 120, '2014-04-01 00:05:47.000000', 'temperatura', 191.0000, 'ºC'),
	(273019, 120, '2014-04-01 00:05:48.000000', 'temperatura', 1115.0000, 'ºC'),
	(273020, 120, '2014-04-01 00:05:49.000000', 'temperatura', 202.0000, 'ºC'),
	(273021, 120, '2014-04-01 00:05:50.000000', 'temperatura', 64.0000, 'ºC'),
	(273022, 120, '2014-04-01 00:05:51.000000', 'temperatura', 914.0000, 'ºC'),
	(273023, 120, '2014-04-01 00:05:52.000000', 'temperatura', 781.0000, 'ºC'),
	(273024, 120, '2014-04-01 00:05:53.000000', 'temperatura', 1163.0000, 'ºC'),
	(273025, 120, '2014-04-01 00:05:54.000000', 'temperatura', 1073.0000, 'ºC'),
	(273026, 120, '2014-04-01 00:05:55.000000', 'temperatura', 675.0000, 'ºC'),
	(273027, 120, '2014-04-01 00:05:56.000000', 'temperatura', 158.0000, 'ºC'),
	(273028, 120, '2014-04-01 00:05:57.000000', 'temperatura', 1166.0000, 'ºC'),
	(273029, 120, '2014-04-01 00:05:58.000000', 'temperatura', 554.0000, 'ºC'),
	(273030, 120, '2014-04-01 00:05:59.000000', 'temperatura', 472.0000, 'ºC'),
	(273031, 120, '2014-04-01 00:06:00.000000', 'temperatura', 700.0000, 'ºC'),
	(273032, 120, '2014-04-01 00:06:01.000000', 'temperatura', 883.0000, 'ºC'),
	(273033, 120, '2014-04-01 00:06:02.000000', 'temperatura', 1116.0000, 'ºC'),
	(273034, 120, '2014-04-01 00:06:03.000000', 'temperatura', 531.0000, 'ºC'),
	(273035, 120, '2014-04-01 00:06:04.000000', 'temperatura', 509.0000, 'ºC'),
	(273036, 120, '2014-04-01 00:06:05.000000', 'temperatura', 950.0000, 'ºC'),
	(273037, 120, '2014-04-01 00:06:06.000000', 'temperatura', 827.0000, 'ºC'),
	(273038, 120, '2014-04-01 00:06:07.000000', 'temperatura', 83.0000, 'ºC'),
	(273039, 120, '2014-04-01 00:06:08.000000', 'temperatura', 336.0000, 'ºC'),
	(273040, 120, '2014-04-01 00:06:09.000000', 'temperatura', 232.0000, 'ºC'),
	(273041, 120, '2014-04-01 00:06:10.000000', 'temperatura', 150.0000, 'ºC'),
	(273042, 120, '2014-04-01 00:06:11.000000', 'temperatura', 57.0000, 'ºC'),
	(273043, 120, '2014-04-01 00:06:12.000000', 'temperatura', 1032.0000, 'ºC'),
	(273044, 120, '2014-04-01 00:06:13.000000', 'temperatura', 193.0000, 'ºC'),
	(273045, 120, '2014-04-01 00:06:14.000000', 'temperatura', 270.0000, 'ºC'),
	(273046, 120, '2014-04-01 00:06:15.000000', 'temperatura', 770.0000, 'ºC'),
	(273047, 120, '2014-04-01 00:06:16.000000', 'temperatura', 640.0000, 'ºC'),
	(273048, 120, '2014-04-01 00:06:17.000000', 'temperatura', 892.0000, 'ºC'),
	(273049, 120, '2014-04-01 00:06:18.000000', 'temperatura', 142.0000, 'ºC'),
	(273050, 120, '2014-04-01 00:06:19.000000', 'temperatura', 432.0000, 'ºC'),
	(273051, 120, '2014-04-01 00:06:20.000000', 'temperatura', 534.0000, 'ºC'),
	(273052, 120, '2014-04-01 00:06:21.000000', 'temperatura', 177.0000, 'ºC'),
	(273053, 120, '2014-04-01 00:06:22.000000', 'temperatura', 482.0000, 'ºC'),
	(273054, 120, '2014-04-01 00:06:23.000000', 'temperatura', 679.0000, 'ºC'),
	(273055, 120, '2014-04-01 00:06:24.000000', 'temperatura', 751.0000, 'ºC'),
	(273056, 120, '2014-04-01 00:06:25.000000', 'temperatura', 517.0000, 'ºC'),
	(273057, 120, '2014-04-01 00:06:26.000000', 'temperatura', 333.0000, 'ºC'),
	(273058, 120, '2014-04-01 00:06:27.000000', 'temperatura', 113.0000, 'ºC'),
	(273059, 120, '2014-04-01 00:06:28.000000', 'temperatura', 768.0000, 'ºC'),
	(273060, 120, '2014-04-01 00:06:29.000000', 'temperatura', 1101.0000, 'ºC'),
	(273061, 120, '2014-04-01 00:06:30.000000', 'temperatura', 803.0000, 'ºC'),
	(273062, 120, '2014-04-01 00:06:31.000000', 'temperatura', 714.0000, 'ºC'),
	(273063, 120, '2014-04-01 00:06:32.000000', 'temperatura', 1158.0000, 'ºC'),
	(273064, 120, '2014-04-01 00:06:33.000000', 'temperatura', 49.0000, 'ºC'),
	(273065, 120, '2014-04-01 00:06:34.000000', 'temperatura', 374.0000, 'ºC'),
	(273066, 120, '2014-04-01 00:06:35.000000', 'temperatura', 523.0000, 'ºC'),
	(273067, 120, '2014-04-01 00:06:36.000000', 'temperatura', 291.0000, 'ºC'),
	(273068, 120, '2014-04-01 00:06:37.000000', 'temperatura', 1087.0000, 'ºC'),
	(273069, 120, '2014-04-01 00:06:38.000000', 'temperatura', 962.0000, 'ºC'),
	(273070, 120, '2014-04-01 00:06:39.000000', 'temperatura', 352.0000, 'ºC'),
	(273071, 120, '2014-04-01 00:06:40.000000', 'temperatura', 72.0000, 'ºC'),
	(273072, 120, '2014-04-01 00:06:41.000000', 'temperatura', 506.0000, 'ºC'),
	(273073, 120, '2014-04-01 00:06:42.000000', 'temperatura', 1113.0000, 'ºC'),
	(273074, 120, '2014-04-01 00:06:43.000000', 'temperatura', 449.0000, 'ºC'),
	(273075, 120, '2014-04-01 00:06:44.000000', 'temperatura', 106.0000, 'ºC'),
	(273076, 120, '2014-04-01 00:06:45.000000', 'temperatura', 382.0000, 'ºC'),
	(273077, 120, '2014-04-01 00:06:46.000000', 'temperatura', 393.0000, 'ºC'),
	(273078, 120, '2014-04-01 00:06:47.000000', 'temperatura', 818.0000, 'ºC'),
	(273079, 120, '2014-04-01 00:06:48.000000', 'temperatura', 513.0000, 'ºC'),
	(273080, 120, '2014-04-01 00:06:49.000000', 'temperatura', 110.0000, 'ºC'),
	(273081, 120, '2014-04-01 00:06:50.000000', 'temperatura', 214.0000, 'ºC'),
	(273082, 120, '2014-04-01 00:06:51.000000', 'temperatura', 740.0000, 'ºC'),
	(273083, 120, '2014-04-01 00:06:52.000000', 'temperatura', 659.0000, 'ºC'),
	(273084, 120, '2014-04-01 00:06:53.000000', 'temperatura', 1074.0000, 'ºC'),
	(273085, 120, '2014-04-01 00:06:54.000000', 'temperatura', 996.0000, 'ºC'),
	(273086, 120, '2014-04-01 00:06:55.000000', 'temperatura', 556.0000, 'ºC'),
	(273087, 120, '2014-04-01 00:06:56.000000', 'temperatura', 992.0000, 'ºC'),
	(273088, 120, '2014-04-01 00:06:57.000000', 'temperatura', 896.0000, 'ºC'),
	(273089, 120, '2014-04-01 00:06:58.000000', 'temperatura', 301.0000, 'ºC'),
	(273090, 120, '2014-04-01 00:06:59.000000', 'temperatura', 18.0000, 'ºC'),
	(273091, 120, '2014-04-01 00:07:00.000000', 'temperatura', 388.0000, 'ºC'),
	(273092, 120, '2014-04-01 00:07:01.000000', 'temperatura', 687.0000, 'ºC'),
	(273093, 120, '2014-04-01 00:07:02.000000', 'temperatura', 1071.0000, 'ºC'),
	(273094, 120, '2014-04-01 00:07:03.000000', 'temperatura', 895.0000, 'ºC'),
	(273095, 120, '2014-04-01 00:07:04.000000', 'temperatura', 62.0000, 'ºC'),
	(273096, 120, '2014-04-01 00:07:05.000000', 'temperatura', 27.0000, 'ºC'),
	(273097, 120, '2014-04-01 00:07:06.000000', 'temperatura', 1147.0000, 'ºC'),
	(273098, 120, '2014-04-01 00:07:07.000000', 'temperatura', 857.0000, 'ºC'),
	(273099, 120, '2014-04-01 00:07:08.000000', 'temperatura', 844.0000, 'ºC'),
	(273100, 120, '2014-04-01 00:07:09.000000', 'temperatura', 449.0000, 'ºC'),
	(273101, 120, '2014-04-01 00:07:10.000000', 'temperatura', 912.0000, 'ºC'),
	(273102, 120, '2014-04-01 00:07:11.000000', 'temperatura', 814.0000, 'ºC'),
	(273103, 120, '2014-04-01 00:07:12.000000', 'temperatura', 133.0000, 'ºC'),
	(273104, 120, '2014-04-01 00:07:13.000000', 'temperatura', 624.0000, 'ºC'),
	(273105, 120, '2014-04-01 00:07:14.000000', 'temperatura', 323.0000, 'ºC'),
	(273106, 120, '2014-04-01 00:07:15.000000', 'temperatura', 943.0000, 'ºC'),
	(273107, 120, '2014-04-01 00:07:16.000000', 'temperatura', 147.0000, 'ºC'),
	(273108, 120, '2014-04-01 00:07:17.000000', 'temperatura', 306.0000, 'ºC'),
	(273109, 120, '2014-04-01 00:07:18.000000', 'temperatura', 1089.0000, 'ºC'),
	(273110, 120, '2014-04-01 00:07:19.000000', 'temperatura', 929.0000, 'ºC'),
	(273111, 120, '2014-04-01 00:07:20.000000', 'temperatura', 180.0000, 'ºC'),
	(273112, 120, '2014-04-01 00:07:21.000000', 'temperatura', 510.0000, 'ºC'),
	(273113, 120, '2014-04-01 00:07:22.000000', 'temperatura', 812.0000, 'ºC'),
	(273114, 120, '2014-04-01 00:07:23.000000', 'temperatura', 129.0000, 'ºC'),
	(273115, 120, '2014-04-01 00:07:24.000000', 'temperatura', 609.0000, 'ºC'),
	(273116, 120, '2014-04-01 00:07:25.000000', 'temperatura', 260.0000, 'ºC'),
	(273117, 120, '2014-04-01 00:07:26.000000', 'temperatura', 673.0000, 'ºC'),
	(273118, 120, '2014-04-01 00:07:27.000000', 'temperatura', 186.0000, 'ºC'),
	(273119, 120, '2014-04-01 00:07:28.000000', 'temperatura', 110.0000, 'ºC'),
	(273120, 120, '2014-04-01 00:07:29.000000', 'temperatura', 1195.0000, 'ºC'),
	(273121, 120, '2014-04-01 00:07:30.000000', 'temperatura', 845.0000, 'ºC'),
	(273122, 120, '2014-04-01 00:07:31.000000', 'temperatura', 639.0000, 'ºC'),
	(273123, 120, '2014-04-01 00:07:32.000000', 'temperatura', 659.0000, 'ºC'),
	(273124, 120, '2014-04-01 00:07:33.000000', 'temperatura', 181.0000, 'ºC'),
	(273125, 120, '2014-04-01 00:07:34.000000', 'temperatura', 126.0000, 'ºC'),
	(273126, 120, '2014-04-01 00:07:35.000000', 'temperatura', 90.0000, 'ºC'),
	(273127, 120, '2014-04-01 00:07:36.000000', 'temperatura', 71.0000, 'ºC'),
	(273128, 120, '2014-04-01 00:07:37.000000', 'temperatura', 85.0000, 'ºC'),
	(273129, 120, '2014-04-01 00:07:38.000000', 'temperatura', 212.0000, 'ºC'),
	(273130, 120, '2014-04-01 00:07:39.000000', 'temperatura', 806.0000, 'ºC'),
	(273131, 120, '2014-04-01 00:07:40.000000', 'temperatura', 994.0000, 'ºC'),
	(273132, 120, '2014-04-01 00:07:41.000000', 'temperatura', 151.0000, 'ºC'),
	(273133, 120, '2014-04-01 00:07:42.000000', 'temperatura', 175.0000, 'ºC'),
	(273134, 120, '2014-04-01 00:07:43.000000', 'temperatura', 424.0000, 'ºC'),
	(273135, 120, '2014-04-01 00:07:44.000000', 'temperatura', 396.0000, 'ºC'),
	(273136, 120, '2014-04-01 00:07:45.000000', 'temperatura', 709.0000, 'ºC'),
	(273137, 120, '2014-04-01 00:07:46.000000', 'temperatura', 1155.0000, 'ºC'),
	(273138, 120, '2014-04-01 00:07:47.000000', 'temperatura', 48.0000, 'ºC'),
	(273139, 120, '2014-04-01 00:07:48.000000', 'temperatura', 378.0000, 'ºC'),
	(273140, 120, '2014-04-01 00:07:49.000000', 'temperatura', 544.0000, 'ºC'),
	(273141, 120, '2014-04-01 00:07:50.000000', 'temperatura', 387.0000, 'ºC'),
	(273142, 120, '2014-04-01 00:07:51.000000', 'temperatura', 303.0000, 'ºC'),
	(273143, 120, '2014-04-01 00:07:52.000000', 'temperatura', 354.0000, 'ºC'),
	(273144, 120, '2014-04-01 00:07:53.000000', 'temperatura', 863.0000, 'ºC'),
	(273145, 120, '2014-04-01 00:07:54.000000', 'temperatura', 853.0000, 'ºC'),
	(273146, 120, '2014-04-01 00:07:55.000000', 'temperatura', 478.0000, 'ºC'),
	(273147, 120, '2014-04-01 00:07:56.000000', 'temperatura', 1032.0000, 'ºC'),
	(273148, 120, '2014-04-01 00:07:57.000000', 'temperatura', 125.0000, 'ºC'),
	(273149, 120, '2014-04-01 00:07:58.000000', 'temperatura', 1128.0000, 'ºC'),
	(273150, 120, '2014-04-01 00:07:59.000000', 'temperatura', 467.0000, 'ºC'),
	(273151, 120, '2014-04-01 00:08:00.000000', 'temperatura', 150.0000, 'ºC'),
	(273152, 120, '2014-04-01 00:08:01.000000', 'temperatura', 550.0000, 'ºC'),
	(273153, 120, '2014-04-01 00:08:02.000000', 'temperatura', 1100.0000, 'ºC'),
	(273154, 120, '2014-04-01 00:08:03.000000', 'temperatura', 252.0000, 'ºC'),
	(273155, 120, '2014-04-01 00:08:04.000000', 'temperatura', 359.0000, 'ºC'),
	(273156, 120, '2014-04-01 00:08:05.000000', 'temperatura', 1041.0000, 'ºC'),
	(273157, 120, '2014-04-01 00:08:06.000000', 'temperatura', 529.0000, 'ºC'),
	(273158, 120, '2014-04-01 00:08:07.000000', 'temperatura', 722.0000, 'ºC'),
	(273159, 120, '2014-04-01 00:08:08.000000', 'temperatura', 823.0000, 'ºC'),
	(273160, 120, '2014-04-01 00:08:09.000000', 'temperatura', 750.0000, 'ºC'),
	(273161, 120, '2014-04-01 00:08:10.000000', 'temperatura', 81.0000, 'ºC'),
	(273162, 120, '2014-04-01 00:08:11.000000', 'temperatura', 556.0000, 'ºC'),
	(273163, 120, '2014-04-01 00:08:12.000000', 'temperatura', 137.0000, 'ºC'),
	(273164, 120, '2014-04-01 00:08:13.000000', 'temperatura', 217.0000, 'ºC'),
	(273165, 120, '2014-04-01 00:08:14.000000', 'temperatura', 676.0000, 'ºC'),
	(273166, 120, '2014-04-01 00:08:15.000000', 'temperatura', 328.0000, 'ºC'),
	(273167, 120, '2014-04-01 00:08:16.000000', 'temperatura', 814.0000, 'ºC'),
	(273168, 120, '2014-04-01 00:08:17.000000', 'temperatura', 685.0000, 'ºC'),
	(273169, 120, '2014-04-01 00:08:18.000000', 'temperatura', 984.0000, 'ºC'),
	(273170, 120, '2014-04-01 00:08:19.000000', 'temperatura', 464.0000, 'ºC'),
	(273171, 120, '2014-04-01 00:08:20.000000', 'temperatura', 569.0000, 'ºC'),
	(273172, 120, '2014-04-01 00:08:21.000000', 'temperatura', 252.0000, 'ºC'),
	(273173, 120, '2014-04-01 00:08:22.000000', 'temperatura', 755.0000, 'ºC'),
	(273174, 120, '2014-04-01 00:08:23.000000', 'temperatura', 620.0000, 'ºC'),
	(273175, 120, '2014-04-01 00:08:24.000000', 'temperatura', 835.0000, 'ºC'),
	(273176, 120, '2014-04-01 00:08:25.000000', 'temperatura', 1117.0000, 'ºC'),
	(273177, 120, '2014-04-01 00:08:26.000000', 'temperatura', 677.0000, 'ºC'),
	(273178, 120, '2014-04-01 00:08:27.000000', 'temperatura', 38.0000, 'ºC'),
	(273179, 120, '2014-04-01 00:08:28.000000', 'temperatura', 557.0000, 'ºC'),
	(273180, 120, '2014-04-01 00:08:29.000000', 'temperatura', 273.0000, 'ºC'),
	(273181, 120, '2014-04-01 00:08:30.000000', 'temperatura', 896.0000, 'ºC'),
	(273182, 120, '2014-04-01 00:08:31.000000', 'temperatura', 59.0000, 'ºC'),
	(273183, 120, '2014-04-01 00:08:32.000000', 'temperatura', 7.0000, 'ºC'),
	(273184, 120, '2014-04-01 00:08:33.000000', 'temperatura', 1060.0000, 'ºC'),
	(273185, 120, '2014-04-01 00:08:34.000000', 'temperatura', 477.0000, 'ºC'),
	(273186, 120, '2014-04-01 00:08:35.000000', 'temperatura', 407.0000, 'ºC'),
	(273187, 120, '2014-04-01 00:08:36.000000', 'temperatura', 606.0000, 'ºC'),
	(273188, 120, '2014-04-01 00:08:37.000000', 'temperatura', 610.0000, 'ºC'),
	(273189, 120, '2014-04-01 00:08:38.000000', 'temperatura', 31.0000, 'ºC'),
	(273190, 120, '2014-04-01 00:08:39.000000', 'temperatura', 725.0000, 'ºC'),
	(273191, 120, '2014-04-01 00:08:40.000000', 'temperatura', 1134.0000, 'ºC'),
	(273192, 120, '2014-04-01 00:08:41.000000', 'temperatura', 1093.0000, 'ºC'),
	(273193, 120, '2014-04-01 00:08:42.000000', 'temperatura', 865.0000, 'ºC'),
	(273194, 120, '2014-04-01 00:08:43.000000', 'temperatura', 1048.0000, 'ºC'),
	(273195, 120, '2014-04-01 00:08:44.000000', 'temperatura', 243.0000, 'ºC'),
	(273196, 120, '2014-04-01 00:08:45.000000', 'temperatura', 472.0000, 'ºC'),
	(273197, 120, '2014-04-01 00:08:46.000000', 'temperatura', 432.0000, 'ºC'),
	(273198, 120, '2014-04-01 00:08:47.000000', 'temperatura', 746.0000, 'ºC'),
	(273199, 120, '2014-04-01 00:08:48.000000', 'temperatura', 32.0000, 'ºC'),
	(273200, 120, '2014-04-01 00:08:49.000000', 'temperatura', 324.0000, 'ºC'),
	(273201, 120, '2014-04-01 00:08:50.000000', 'temperatura', 323.0000, 'ºC'),
	(273202, 120, '2014-04-01 00:08:51.000000', 'temperatura', 644.0000, 'ºC'),
	(273203, 120, '2014-04-01 00:08:52.000000', 'temperatura', 1054.0000, 'ºC'),
	(273204, 120, '2014-04-01 00:08:53.000000', 'temperatura', 935.0000, 'ºC'),
	(273205, 120, '2014-04-01 00:08:54.000000', 'temperatura', 316.0000, 'ºC'),
	(273206, 120, '2014-04-01 00:08:55.000000', 'temperatura', 1173.0000, 'ºC'),
	(273207, 120, '2014-04-01 00:08:56.000000', 'temperatura', 117.0000, 'ºC'),
	(273208, 120, '2014-04-01 00:08:57.000000', 'temperatura', 668.0000, 'ºC'),
	(273209, 120, '2014-04-01 00:08:58.000000', 'temperatura', 591.0000, 'ºC'),
	(273210, 120, '2014-04-01 00:08:59.000000', 'temperatura', 948.0000, 'ºC'),
	(273211, 120, '2014-04-01 00:09:00.000000', 'temperatura', 571.0000, 'ºC'),
	(273212, 120, '2014-04-01 00:09:01.000000', 'temperatura', 10.0000, 'ºC'),
	(273213, 120, '2014-04-01 00:09:02.000000', 'temperatura', 739.0000, 'ºC'),
	(273214, 120, '2014-04-01 00:09:03.000000', 'temperatura', 65.0000, 'ºC'),
	(273215, 120, '2014-04-01 00:09:04.000000', 'temperatura', 508.0000, 'ºC'),
	(273216, 120, '2014-04-01 00:09:05.000000', 'temperatura', 1144.0000, 'ºC'),
	(273217, 120, '2014-04-01 00:09:06.000000', 'temperatura', 599.0000, 'ºC'),
	(273218, 120, '2014-04-01 00:09:07.000000', 'temperatura', 763.0000, 'ºC'),
	(273219, 120, '2014-04-01 00:09:08.000000', 'temperatura', 816.0000, 'ºC'),
	(273220, 120, '2014-04-01 00:09:09.000000', 'temperatura', 594.0000, 'ºC'),
	(273221, 120, '2014-04-01 00:09:10.000000', 'temperatura', 522.0000, 'ºC'),
	(273222, 120, '2014-04-01 00:09:11.000000', 'temperatura', 828.0000, 'ºC'),
	(273223, 120, '2014-04-01 00:09:12.000000', 'temperatura', 174.0000, 'ºC'),
	(273224, 120, '2014-04-01 00:09:13.000000', 'temperatura', 785.0000, 'ºC'),
	(273225, 120, '2014-04-01 00:09:14.000000', 'temperatura', 1005.0000, 'ºC'),
	(273226, 120, '2014-04-01 00:09:15.000000', 'temperatura', 271.0000, 'ºC'),
	(273227, 120, '2014-04-01 00:09:16.000000', 'temperatura', 738.0000, 'ºC'),
	(273228, 120, '2014-04-01 00:09:17.000000', 'temperatura', 480.0000, 'ºC'),
	(273229, 120, '2014-04-01 00:09:18.000000', 'temperatura', 184.0000, 'ºC'),
	(273230, 120, '2014-04-01 00:09:19.000000', 'temperatura', 684.0000, 'ºC'),
	(273231, 120, '2014-04-01 00:09:20.000000', 'temperatura', 466.0000, 'ºC'),
	(273232, 120, '2014-04-01 00:09:21.000000', 'temperatura', 278.0000, 'ºC'),
	(273233, 120, '2014-04-01 00:09:22.000000', 'temperatura', 1194.0000, 'ºC'),
	(273234, 120, '2014-04-01 00:09:23.000000', 'temperatura', 334.0000, 'ºC'),
	(273235, 120, '2014-04-01 00:09:24.000000', 'temperatura', 490.0000, 'ºC'),
	(273236, 120, '2014-04-01 00:09:25.000000', 'temperatura', 246.0000, 'ºC'),
	(273237, 120, '2014-04-01 00:09:26.000000', 'temperatura', 964.0000, 'ºC'),
	(273238, 120, '2014-04-01 00:09:27.000000', 'temperatura', 480.0000, 'ºC'),
	(273239, 120, '2014-04-01 00:09:28.000000', 'temperatura', 710.0000, 'ºC'),
	(273240, 120, '2014-04-01 00:09:29.000000', 'temperatura', 910.0000, 'ºC'),
	(273241, 120, '2014-04-01 00:09:30.000000', 'temperatura', 19.0000, 'ºC'),
	(273242, 120, '2014-04-01 00:09:31.000000', 'temperatura', 966.0000, 'ºC'),
	(273243, 120, '2014-04-01 00:09:32.000000', 'temperatura', 1175.0000, 'ºC'),
	(273244, 120, '2014-04-01 00:09:33.000000', 'temperatura', 578.0000, 'ºC'),
	(273245, 120, '2014-04-01 00:09:34.000000', 'temperatura', 563.0000, 'ºC'),
	(273246, 120, '2014-04-01 00:09:35.000000', 'temperatura', 1082.0000, 'ºC'),
	(273247, 120, '2014-04-01 00:09:36.000000', 'temperatura', 123.0000, 'ºC'),
	(273248, 120, '2014-04-01 00:09:37.000000', 'temperatura', 970.0000, 'ºC'),
	(273249, 120, '2014-04-01 00:09:38.000000', 'temperatura', 881.0000, 'ºC'),
	(273250, 120, '2014-04-01 00:09:39.000000', 'temperatura', 295.0000, 'ºC'),
	(273251, 120, '2014-04-01 00:09:40.000000', 'temperatura', 35.0000, 'ºC'),
	(273252, 120, '2014-04-01 00:09:41.000000', 'temperatura', 488.0000, 'ºC'),
	(273253, 120, '2014-04-01 00:09:42.000000', 'temperatura', 1135.0000, 'ºC'),
	(273254, 120, '2014-04-01 00:09:43.000000', 'temperatura', 611.0000, 'ºC'),
	(273255, 120, '2014-04-01 00:09:44.000000', 'temperatura', 850.0000, 'ºC'),
	(273256, 120, '2014-04-01 00:09:45.000000', 'temperatura', 18.0000, 'ºC'),
	(273257, 120, '2014-04-01 00:09:46.000000', 'temperatura', 1142.0000, 'ºC'),
	(273258, 120, '2014-04-01 00:09:47.000000', 'temperatura', 854.0000, 'ºC'),
	(273259, 120, '2014-04-01 00:09:48.000000', 'temperatura', 847.0000, 'ºC'),
	(273260, 120, '2014-04-01 00:09:49.000000', 'temperatura', 472.0000, 'ºC'),
	(273261, 120, '2014-04-01 00:09:50.000000', 'temperatura', 1022.0000, 'ºC'),
	(273262, 120, '2014-04-01 00:09:51.000000', 'temperatura', 91.0000, 'ºC'),
	(273263, 120, '2014-04-01 00:09:52.000000', 'temperatura', 992.0000, 'ºC'),
	(273264, 120, '2014-04-01 00:09:53.000000', 'temperatura', 1085.0000, 'ºC'),
	(273265, 120, '2014-04-01 00:09:54.000000', 'temperatura', 51.0000, 'ºC'),
	(273266, 120, '2014-04-01 00:09:55.000000', 'temperatura', 600.0000, 'ºC'),
	(273267, 120, '2014-04-01 00:09:56.000000', 'temperatura', 448.0000, 'ºC'),
	(273268, 120, '2014-04-01 00:09:57.000000', 'temperatura', 439.0000, 'ºC'),
	(273269, 120, '2014-04-01 00:09:58.000000', 'temperatura', 852.0000, 'ºC'),
	(273270, 120, '2014-04-01 00:09:59.000000', 'temperatura', 545.0000, 'ºC'),
	(273271, 120, '2014-04-01 00:10:00.000000', 'temperatura', 168.0000, 'ºC'),
	(273272, 120, '2014-04-01 00:10:01.000000', 'temperatura', 406.0000, 'ºC'),
	(273273, 120, '2014-04-01 00:10:02.000000', 'temperatura', 326.0000, 'ºC'),
	(273274, 120, '2014-04-01 00:10:03.000000', 'temperatura', 413.0000, 'ºC'),
	(273275, 120, '2014-04-01 00:10:04.000000', 'temperatura', 1085.0000, 'ºC'),
	(273276, 120, '2014-04-01 00:10:05.000000', 'temperatura', 590.0000, 'ºC'),
	(273277, 120, '2014-04-01 00:10:06.000000', 'temperatura', 893.0000, 'ºC'),
	(273278, 120, '2014-04-01 00:10:07.000000', 'temperatura', 295.0000, 'ºC'),
	(273279, 120, '2014-04-01 00:10:08.000000', 'temperatura', 1199.0000, 'ºC'),
	(273280, 120, '2014-04-01 00:10:09.000000', 'temperatura', 308.0000, 'ºC'),
	(273281, 120, '2014-04-01 00:10:10.000000', 'temperatura', 344.0000, 'ºC'),
	(273282, 120, '2014-04-01 00:10:11.000000', 'temperatura', 795.0000, 'ºC'),
	(273283, 120, '2014-04-01 00:10:12.000000', 'temperatura', 546.0000, 'ºC'),
	(273284, 120, '2014-04-01 00:10:13.000000', 'temperatura', 346.0000, 'ºC'),
	(273285, 120, '2014-04-01 00:10:14.000000', 'temperatura', 93.0000, 'ºC'),
	(273286, 120, '2014-04-01 00:10:15.000000', 'temperatura', 625.0000, 'ºC'),
	(273287, 120, '2014-04-01 00:10:16.000000', 'temperatura', 449.0000, 'ºC'),
	(273288, 120, '2014-04-01 00:10:17.000000', 'temperatura', 368.0000, 'ºC'),
	(273289, 120, '2014-04-01 00:10:18.000000', 'temperatura', 495.0000, 'ºC'),
	(273290, 120, '2014-04-01 00:10:19.000000', 'temperatura', 172.0000, 'ºC'),
	(273291, 120, '2014-04-01 00:10:20.000000', 'temperatura', 575.0000, 'ºC'),
	(273292, 120, '2014-04-01 00:10:21.000000', 'temperatura', 1161.0000, 'ºC'),
	(273293, 120, '2014-04-01 00:10:22.000000', 'temperatura', 481.0000, 'ºC'),
	(273294, 120, '2014-04-01 00:10:23.000000', 'temperatura', 120.0000, 'ºC'),
	(273295, 120, '2014-04-01 00:10:24.000000', 'temperatura', 357.0000, 'ºC'),
	(273296, 120, '2014-04-01 00:10:25.000000', 'temperatura', 226.0000, 'ºC'),
	(273297, 120, '2014-04-01 00:10:26.000000', 'temperatura', 60.0000, 'ºC'),
	(273298, 120, '2014-04-01 00:10:27.000000', 'temperatura', 823.0000, 'ºC'),
	(273299, 120, '2014-04-01 00:10:28.000000', 'temperatura', 336.0000, 'ºC'),
	(273300, 120, '2014-04-01 00:10:29.000000', 'temperatura', 410.0000, 'ºC'),
	(273301, 120, '2014-04-01 00:10:30.000000', 'temperatura', 1041.0000, 'ºC'),
	(273302, 120, '2014-04-01 00:10:31.000000', 'temperatura', 378.0000, 'ºC'),
	(273303, 120, '2014-04-01 00:10:32.000000', 'temperatura', 1168.0000, 'ºC'),
	(273304, 120, '2014-04-01 00:10:33.000000', 'temperatura', 1105.0000, 'ºC'),
	(273305, 120, '2014-04-01 00:10:34.000000', 'temperatura', 820.0000, 'ºC'),
	(273306, 120, '2014-04-01 00:10:35.000000', 'temperatura', 788.0000, 'ºC'),
	(273307, 120, '2014-04-01 00:10:36.000000', 'temperatura', 279.0000, 'ºC'),
	(273308, 120, '2014-04-01 00:10:37.000000', 'temperatura', 234.0000, 'ºC'),
	(273309, 120, '2014-04-01 00:10:38.000000', 'temperatura', 333.0000, 'ºC'),
	(273310, 120, '2014-04-01 00:10:39.000000', 'temperatura', 962.0000, 'ºC'),
	(273311, 120, '2014-04-01 00:10:40.000000', 'temperatura', 211.0000, 'ºC'),
	(273312, 120, '2014-04-01 00:10:41.000000', 'temperatura', 569.0000, 'ºC'),
	(273313, 120, '2014-04-01 00:10:42.000000', 'temperatura', 1012.0000, 'ºC'),
	(273314, 120, '2014-04-01 00:10:43.000000', 'temperatura', 955.0000, 'ºC'),
	(273315, 120, '2014-04-01 00:10:44.000000', 'temperatura', 539.0000, 'ºC'),
	(273316, 120, '2014-04-01 00:10:45.000000', 'temperatura', 1032.0000, 'ºC'),
	(273317, 120, '2014-04-01 00:10:46.000000', 'temperatura', 1141.0000, 'ºC'),
	(273318, 120, '2014-04-01 00:10:47.000000', 'temperatura', 210.0000, 'ºC'),
	(273319, 120, '2014-04-01 00:10:48.000000', 'temperatura', 30.0000, 'ºC'),
	(273320, 120, '2014-04-01 00:10:49.000000', 'temperatura', 719.0000, 'ºC'),
	(273321, 120, '2014-04-01 00:10:50.000000', 'temperatura', 1103.0000, 'ºC'),
	(273322, 120, '2014-04-01 00:10:51.000000', 'temperatura', 962.0000, 'ºC'),
	(273323, 120, '2014-04-01 00:10:52.000000', 'temperatura', 300.0000, 'ºC'),
	(273324, 120, '2014-04-01 00:10:53.000000', 'temperatura', 1014.0000, 'ºC'),
	(273325, 120, '2014-04-01 00:10:54.000000', 'temperatura', 573.0000, 'ºC'),
	(273326, 120, '2014-04-01 00:10:55.000000', 'temperatura', 1021.0000, 'ºC'),
	(273327, 120, '2014-04-01 00:10:56.000000', 'temperatura', 987.0000, 'ºC'),
	(273328, 120, '2014-04-01 00:10:57.000000', 'temperatura', 673.0000, 'ºC'),
	(273329, 120, '2014-04-01 00:10:58.000000', 'temperatura', 403.0000, 'ºC'),
	(273330, 120, '2014-04-01 00:10:59.000000', 'temperatura', 1196.0000, 'ºC'),
	(273331, 120, '2014-04-01 00:11:00.000000', 'temperatura', 1174.0000, 'ºC'),
	(273332, 120, '2014-04-01 00:11:01.000000', 'temperatura', 1082.0000, 'ºC'),
	(273333, 120, '2014-04-01 00:11:02.000000', 'temperatura', 688.0000, 'ºC'),
	(273334, 120, '2014-04-01 00:11:03.000000', 'temperatura', 194.0000, 'ºC'),
	(273335, 120, '2014-04-01 00:11:04.000000', 'temperatura', 109.0000, 'ºC'),
	(273336, 120, '2014-04-01 00:11:05.000000', 'temperatura', 1162.0000, 'ºC'),
	(273337, 120, '2014-04-01 00:11:06.000000', 'temperatura', 683.0000, 'ºC'),
	(273338, 120, '2014-04-01 00:11:07.000000', 'temperatura', 1129.0000, 'ºC'),
	(273339, 120, '2014-04-01 00:11:08.000000', 'temperatura', 1195.0000, 'ºC'),
	(273340, 120, '2014-04-01 00:11:09.000000', 'temperatura', 192.0000, 'ºC'),
	(273341, 120, '2014-04-01 00:11:10.000000', 'temperatura', 972.0000, 'ºC'),
	(273342, 120, '2014-04-01 00:11:11.000000', 'temperatura', 687.0000, 'ºC'),
	(273343, 120, '2014-04-01 00:11:12.000000', 'temperatura', 518.0000, 'ºC'),
	(273344, 120, '2014-04-01 00:11:13.000000', 'temperatura', 529.0000, 'ºC'),
	(273345, 120, '2014-04-01 00:11:14.000000', 'temperatura', 1092.0000, 'ºC'),
	(273346, 120, '2014-04-01 00:11:15.000000', 'temperatura', 274.0000, 'ºC'),
	(273347, 120, '2014-04-01 00:11:16.000000', 'temperatura', 496.0000, 'ºC'),
	(273348, 120, '2014-04-01 00:11:17.000000', 'temperatura', 456.0000, 'ºC'),
	(273349, 120, '2014-04-01 00:11:18.000000', 'temperatura', 795.0000, 'ºC'),
	(273350, 120, '2014-04-01 00:11:19.000000', 'temperatura', 208.0000, 'ºC'),
	(273351, 120, '2014-04-01 00:11:20.000000', 'temperatura', 1056.0000, 'ºC'),
	(273352, 120, '2014-04-01 00:11:21.000000', 'temperatura', 1056.0000, 'ºC'),
	(273353, 120, '2014-04-01 00:11:22.000000', 'temperatura', 910.0000, 'ºC'),
	(273354, 120, '2014-04-01 00:11:23.000000', 'temperatura', 186.0000, 'ºC'),
	(273355, 120, '2014-04-01 00:11:24.000000', 'temperatura', 598.0000, 'ºC'),
	(273356, 120, '2014-04-01 00:11:25.000000', 'temperatura', 35.0000, 'ºC'),
	(273357, 120, '2014-04-01 00:11:26.000000', 'temperatura', 781.0000, 'ºC'),
	(273358, 120, '2014-04-01 00:11:27.000000', 'temperatura', 200.0000, 'ºC'),
	(273359, 120, '2014-04-01 00:11:28.000000', 'temperatura', 1057.0000, 'ºC'),
	(273360, 120, '2014-04-01 00:11:29.000000', 'temperatura', 1087.0000, 'ºC'),
	(273361, 120, '2014-04-01 00:11:30.000000', 'temperatura', 1065.0000, 'ºC'),
	(273362, 120, '2014-04-01 00:11:31.000000', 'temperatura', 865.0000, 'ºC'),
	(273363, 120, '2014-04-01 00:11:32.000000', 'temperatura', 1131.0000, 'ºC'),
	(273364, 120, '2014-04-01 00:11:33.000000', 'temperatura', 659.0000, 'ºC'),
	(273365, 120, '2014-04-01 00:11:34.000000', 'temperatura', 1103.0000, 'ºC'),
	(273366, 120, '2014-04-01 00:11:35.000000', 'temperatura', 1140.0000, 'ºC'),
	(273367, 120, '2014-04-01 00:11:36.000000', 'temperatura', 1192.0000, 'ºC'),
	(273368, 120, '2014-04-01 00:11:37.000000', 'temperatura', 139.0000, 'ºC'),
	(273369, 120, '2014-04-01 00:11:38.000000', 'temperatura', 721.0000, 'ºC'),
	(273370, 120, '2014-04-01 00:11:39.000000', 'temperatura', 786.0000, 'ºC'),
	(273371, 120, '2014-04-01 00:11:40.000000', 'temperatura', 569.0000, 'ºC'),
	(273372, 120, '2014-04-01 00:11:41.000000', 'temperatura', 489.0000, 'ºC'),
	(273373, 120, '2014-04-01 00:11:42.000000', 'temperatura', 737.0000, 'ºC'),
	(273374, 120, '2014-04-01 00:11:43.000000', 'temperatura', 1021.0000, 'ºC'),
	(273375, 120, '2014-04-01 00:11:44.000000', 'temperatura', 492.0000, 'ºC'),
	(273376, 120, '2014-04-01 00:11:45.000000', 'temperatura', 599.0000, 'ºC'),
	(273377, 120, '2014-04-01 00:11:46.000000', 'temperatura', 318.0000, 'ºC'),
	(273378, 120, '2014-04-01 00:11:47.000000', 'temperatura', 993.0000, 'ºC'),
	(273379, 120, '2014-04-01 00:11:48.000000', 'temperatura', 411.0000, 'ºC'),
	(273380, 120, '2014-04-01 00:11:49.000000', 'temperatura', 278.0000, 'ºC'),
	(273381, 120, '2014-04-01 00:11:50.000000', 'temperatura', 156.0000, 'ºC'),
	(273382, 120, '2014-04-01 00:11:51.000000', 'temperatura', 1145.0000, 'ºC'),
	(273383, 120, '2014-04-01 00:11:52.000000', 'temperatura', 461.0000, 'ºC'),
	(273384, 120, '2014-04-01 00:11:53.000000', 'temperatura', 70.0000, 'ºC'),
	(273385, 120, '2014-04-01 00:11:54.000000', 'temperatura', 165.0000, 'ºC'),
	(273386, 120, '2014-04-01 00:11:55.000000', 'temperatura', 618.0000, 'ºC'),
	(273387, 120, '2014-04-01 00:11:56.000000', 'temperatura', 195.0000, 'ºC'),
	(273388, 120, '2014-04-01 00:11:57.000000', 'temperatura', 321.0000, 'ºC'),
	(273389, 120, '2014-04-01 00:11:58.000000', 'temperatura', 1022.0000, 'ºC'),
	(273390, 120, '2014-04-01 00:11:59.000000', 'temperatura', 546.0000, 'ºC'),
	(273391, 120, '2014-04-01 00:12:00.000000', 'temperatura', 866.0000, 'ºC'),
	(273392, 120, '2014-04-01 00:12:01.000000', 'temperatura', 294.0000, 'ºC'),
	(273393, 120, '2014-04-01 00:12:02.000000', 'temperatura', 70.0000, 'ºC'),
	(273394, 120, '2014-04-01 00:12:03.000000', 'temperatura', 670.0000, 'ºC'),
	(273395, 120, '2014-04-01 00:12:04.000000', 'temperatura', 738.0000, 'ºC'),
	(273396, 120, '2014-04-01 00:12:05.000000', 'temperatura', 484.0000, 'ºC'),
	(273397, 120, '2014-04-01 00:12:06.000000', 'temperatura', 204.0000, 'ºC'),
	(273398, 120, '2014-04-01 00:12:07.000000', 'temperatura', 767.0000, 'ºC'),
	(273399, 120, '2014-04-01 00:12:08.000000', 'temperatura', 825.0000, 'ºC'),
	(273400, 120, '2014-04-01 00:12:09.000000', 'temperatura', 626.0000, 'ºC'),
	(273401, 120, '2014-04-01 00:12:10.000000', 'temperatura', 653.0000, 'ºC'),
	(273402, 120, '2014-04-01 00:12:11.000000', 'temperatura', 188.0000, 'ºC'),
	(273403, 120, '2014-04-01 00:12:12.000000', 'temperatura', 182.0000, 'ºC'),
	(273404, 120, '2014-04-01 00:12:13.000000', 'temperatura', 348.0000, 'ºC'),
	(273405, 120, '2014-04-01 00:12:14.000000', 'temperatura', 1195.0000, 'ºC'),
	(273406, 120, '2014-04-01 00:12:15.000000', 'temperatura', 130.0000, 'ºC'),
	(273407, 120, '2014-04-01 00:12:16.000000', 'temperatura', 664.0000, 'ºC'),
	(273408, 120, '2014-04-01 00:12:17.000000', 'temperatura', 531.0000, 'ºC'),
	(273409, 120, '2014-04-01 00:12:18.000000', 'temperatura', 663.0000, 'ºC'),
	(273410, 120, '2014-04-01 00:12:19.000000', 'temperatura', 525.0000, 'ºC'),
	(273411, 120, '2014-04-01 00:12:20.000000', 'temperatura', 634.0000, 'ºC'),
	(273412, 120, '2014-04-01 00:12:21.000000', 'temperatura', 394.0000, 'ºC'),
	(273413, 120, '2014-04-01 00:12:22.000000', 'temperatura', 71.0000, 'ºC'),
	(273414, 120, '2014-04-01 00:12:23.000000', 'temperatura', 374.0000, 'ºC'),
	(273415, 120, '2014-04-01 00:12:24.000000', 'temperatura', 458.0000, 'ºC'),
	(273416, 120, '2014-04-01 00:12:25.000000', 'temperatura', 1169.0000, 'ºC'),
	(273417, 120, '2014-04-01 00:12:26.000000', 'temperatura', 870.0000, 'ºC'),
	(273418, 120, '2014-04-01 00:12:27.000000', 'temperatura', 846.0000, 'ºC'),
	(273419, 120, '2014-04-01 00:12:28.000000', 'temperatura', 417.0000, 'ºC'),
	(273420, 120, '2014-04-01 00:12:29.000000', 'temperatura', 749.0000, 'ºC'),
	(273421, 120, '2014-04-01 00:12:30.000000', 'temperatura', 94.0000, 'ºC'),
	(273422, 120, '2014-04-01 00:12:31.000000', 'temperatura', 622.0000, 'ºC'),
	(273423, 120, '2014-04-01 00:12:32.000000', 'temperatura', 431.0000, 'ºC'),
	(273424, 120, '2014-04-01 00:12:33.000000', 'temperatura', 288.0000, 'ºC'),
	(273425, 120, '2014-04-01 00:12:34.000000', 'temperatura', 147.0000, 'ºC'),
	(273426, 120, '2014-04-01 00:12:35.000000', 'temperatura', 1074.0000, 'ºC'),
	(273427, 120, '2014-04-01 00:12:36.000000', 'temperatura', 129.0000, 'ºC'),
	(273428, 120, '2014-04-01 00:12:37.000000', 'temperatura', 1025.0000, 'ºC'),
	(273429, 120, '2014-04-01 00:12:38.000000', 'temperatura', 1136.0000, 'ºC'),
	(273430, 120, '2014-04-01 00:12:39.000000', 'temperatura', 205.0000, 'ºC'),
	(273431, 120, '2014-04-01 00:12:40.000000', 'temperatura', 19.0000, 'ºC'),
	(273432, 120, '2014-04-01 00:12:41.000000', 'temperatura', 682.0000, 'ºC'),
	(273433, 120, '2014-04-01 00:12:42.000000', 'temperatura', 950.0000, 'ºC'),
	(273434, 120, '2014-04-01 00:12:43.000000', 'temperatura', 307.0000, 'ºC'),
	(273435, 120, '2014-04-01 00:12:44.000000', 'temperatura', 1087.0000, 'ºC'),
	(273436, 120, '2014-04-01 00:12:45.000000', 'temperatura', 912.0000, 'ºC'),
	(273437, 120, '2014-04-01 00:12:46.000000', 'temperatura', 102.0000, 'ºC'),
	(273438, 120, '2014-04-01 00:12:47.000000', 'temperatura', 172.0000, 'ºC'),
	(273439, 120, '2014-04-01 00:12:48.000000', 'temperatura', 554.0000, 'ºC'),
	(273440, 120, '2014-04-01 00:12:49.000000', 'temperatura', 1057.0000, 'ºC'),
	(273441, 120, '2014-04-01 00:12:50.000000', 'temperatura', 24.0000, 'ºC'),
	(273442, 120, '2014-04-01 00:12:51.000000', 'temperatura', 550.0000, 'ºC'),
	(273443, 120, '2014-04-01 00:12:52.000000', 'temperatura', 277.0000, 'ºC'),
	(273444, 120, '2014-04-01 00:12:53.000000', 'temperatura', 935.0000, 'ºC'),
	(273445, 120, '2014-04-01 00:12:54.000000', 'temperatura', 244.0000, 'ºC'),
	(273446, 120, '2014-04-01 00:12:55.000000', 'temperatura', 815.0000, 'ºC'),
	(273447, 120, '2014-04-01 00:12:56.000000', 'temperatura', 943.0000, 'ºC'),
	(273448, 120, '2014-04-01 00:12:57.000000', 'temperatura', 1069.0000, 'ºC'),
	(273449, 120, '2014-04-01 00:12:58.000000', 'temperatura', 120.0000, 'ºC'),
	(273450, 120, '2014-04-01 00:12:59.000000', 'temperatura', 991.0000, 'ºC'),
	(273451, 120, '2014-04-01 00:13:00.000000', 'temperatura', 997.0000, 'ºC'),
	(273452, 120, '2014-04-01 00:13:01.000000', 'temperatura', 810.0000, 'ºC'),
	(273453, 120, '2014-04-01 00:13:02.000000', 'temperatura', 1061.0000, 'ºC'),
	(273454, 120, '2014-04-01 00:13:03.000000', 'temperatura', 475.0000, 'ºC'),
	(273455, 120, '2014-04-01 00:13:04.000000', 'temperatura', 391.0000, 'ºC'),
	(273456, 120, '2014-04-01 00:13:05.000000', 'temperatura', 531.0000, 'ºC'),
	(273457, 120, '2014-04-01 00:13:06.000000', 'temperatura', 282.0000, 'ºC'),
	(273458, 120, '2014-04-01 00:13:07.000000', 'temperatura', 1016.0000, 'ºC'),
	(273459, 120, '2014-04-01 00:13:08.000000', 'temperatura', 637.0000, 'ºC'),
	(273460, 120, '2014-04-01 00:13:09.000000', 'temperatura', 135.0000, 'ºC'),
	(273461, 120, '2014-04-01 00:13:10.000000', 'temperatura', 1166.0000, 'ºC'),
	(273462, 120, '2014-04-01 00:13:11.000000', 'temperatura', 625.0000, 'ºC'),
	(273463, 120, '2014-04-01 00:13:12.000000', 'temperatura', 828.0000, 'ºC'),
	(273464, 120, '2014-04-01 00:13:13.000000', 'temperatura', 1066.0000, 'ºC'),
	(273465, 120, '2014-04-01 00:13:14.000000', 'temperatura', 445.0000, 'ºC'),
	(273466, 120, '2014-04-01 00:13:15.000000', 'temperatura', 227.0000, 'ºC'),
	(273467, 120, '2014-04-01 00:13:16.000000', 'temperatura', 1003.0000, 'ºC'),
	(273468, 120, '2014-04-01 00:13:17.000000', 'temperatura', 732.0000, 'ºC'),
	(273469, 120, '2014-04-01 00:13:18.000000', 'temperatura', 651.0000, 'ºC'),
	(273470, 120, '2014-04-01 00:13:19.000000', 'temperatura', 1059.0000, 'ºC'),
	(273471, 120, '2014-04-01 00:13:20.000000', 'temperatura', 942.0000, 'ºC'),
	(273472, 120, '2014-04-01 00:13:21.000000', 'temperatura', 336.0000, 'ºC'),
	(273473, 120, '2014-04-01 00:13:22.000000', 'temperatura', 52.0000, 'ºC'),
	(273474, 120, '2014-04-01 00:13:23.000000', 'temperatura', 453.0000, 'ºC'),
	(273475, 120, '2014-04-01 00:13:24.000000', 'temperatura', 911.0000, 'ºC'),
	(273476, 120, '2014-04-01 00:13:25.000000', 'temperatura', 795.0000, 'ºC'),
	(273477, 120, '2014-04-01 00:13:26.000000', 'temperatura', 42.0000, 'ºC'),
	(273478, 120, '2014-04-01 00:13:27.000000', 'temperatura', 225.0000, 'ºC'),
	(273479, 120, '2014-04-01 00:13:28.000000', 'temperatura', 1001.0000, 'ºC'),
	(273480, 120, '2014-04-01 00:13:29.000000', 'temperatura', 730.0000, 'ºC'),
	(273481, 120, '2014-04-01 00:13:30.000000', 'temperatura', 647.0000, 'ºC'),
	(273482, 120, '2014-04-01 00:13:31.000000', 'temperatura', 1045.0000, 'ºC'),
	(273483, 120, '2014-04-01 00:13:32.000000', 'temperatura', 884.0000, 'ºC'),
	(273484, 120, '2014-04-01 00:13:33.000000', 'temperatura', 88.0000, 'ºC'),
	(273485, 120, '2014-04-01 00:13:34.000000', 'temperatura', 189.0000, 'ºC'),
	(273486, 120, '2014-04-01 00:13:35.000000', 'temperatura', 679.0000, 'ºC'),
	(273487, 120, '2014-04-01 00:13:36.000000', 'temperatura', 430.0000, 'ºC'),
	(273488, 120, '2014-04-01 00:13:37.000000', 'temperatura', 111.0000, 'ºC'),
	(273489, 120, '2014-04-01 00:13:38.000000', 'temperatura', 468.0000, 'ºC'),
	(273490, 120, '2014-04-01 00:13:39.000000', 'temperatura', 809.0000, 'ºC'),
	(273491, 120, '2014-04-01 00:13:40.000000', 'temperatura', 238.0000, 'ºC'),
	(273492, 120, '2014-04-01 00:13:41.000000', 'temperatura', 1167.0000, 'ºC'),
	(273493, 120, '2014-04-01 00:13:42.000000', 'temperatura', 319.0000, 'ºC'),
	(273494, 120, '2014-04-01 00:13:43.000000', 'temperatura', 496.0000, 'ºC'),
	(273495, 120, '2014-04-01 00:13:44.000000', 'temperatura', 321.0000, 'ºC'),
	(273496, 120, '2014-04-01 00:13:45.000000', 'temperatura', 121.0000, 'ºC'),
	(273497, 120, '2014-04-01 00:13:46.000000', 'temperatura', 839.0000, 'ºC'),
	(273498, 120, '2014-04-01 00:13:47.000000', 'temperatura', 236.0000, 'ºC'),
	(273499, 120, '2014-04-01 00:13:48.000000', 'temperatura', 1061.0000, 'ºC'),
	(273500, 120, '2014-04-01 00:13:49.000000', 'temperatura', 997.0000, 'ºC'),
	(273501, 120, '2014-04-01 00:13:50.000000', 'temperatura', 603.0000, 'ºC'),
	(273502, 120, '2014-04-01 00:13:51.000000', 'temperatura', 25.0000, 'ºC'),
	(273503, 120, '2014-04-01 00:13:52.000000', 'temperatura', 718.0000, 'ºC'),
	(273504, 120, '2014-04-01 00:13:53.000000', 'temperatura', 1113.0000, 'ºC'),
	(273505, 120, '2014-04-01 00:13:54.000000', 'temperatura', 1010.0000, 'ºC'),
	(273506, 120, '2014-04-01 00:13:55.000000', 'temperatura', 515.0000, 'ºC'),
	(273507, 120, '2014-04-01 00:13:56.000000', 'temperatura', 744.0000, 'ºC'),
	(273508, 120, '2014-04-01 00:13:57.000000', 'temperatura', 978.0000, 'ºC'),
	(273509, 120, '2014-04-01 00:13:58.000000', 'temperatura', 255.0000, 'ºC'),
	(273510, 120, '2014-04-01 00:13:59.000000', 'temperatura', 744.0000, 'ºC'),
	(273511, 120, '2014-04-01 00:14:00.000000', 'temperatura', 556.0000, 'ºC'),
	(273512, 120, '2014-04-01 00:14:01.000000', 'temperatura', 549.0000, 'ºC'),
	(273513, 120, '2014-04-01 00:14:02.000000', 'temperatura', 1077.0000, 'ºC'),
	(273514, 120, '2014-04-01 00:14:03.000000', 'temperatura', 139.0000, 'ºC'),
	(273515, 120, '2014-04-01 00:14:04.000000', 'temperatura', 1062.0000, 'ºC'),
	(273516, 120, '2014-04-01 00:14:05.000000', 'temperatura', 95.0000, 'ºC'),
	(273517, 120, '2014-04-01 00:14:06.000000', 'temperatura', 889.0000, 'ºC'),
	(273518, 120, '2014-04-01 00:14:07.000000', 'temperatura', 563.0000, 'ºC'),
	(273519, 120, '2014-04-01 00:14:08.000000', 'temperatura', 145.0000, 'ºC'),
	(273520, 120, '2014-04-01 00:14:09.000000', 'temperatura', 238.0000, 'ºC'),
	(273521, 120, '2014-04-01 00:14:10.000000', 'temperatura', 754.0000, 'ºC'),
	(273522, 120, '2014-04-01 00:14:11.000000', 'temperatura', 656.0000, 'ºC'),
	(273523, 120, '2014-04-01 00:14:12.000000', 'temperatura', 1018.0000, 'ºC'),
	(273524, 120, '2014-04-01 00:14:13.000000', 'temperatura', 722.0000, 'ºC'),
	(273525, 120, '2014-04-01 00:14:14.000000', 'temperatura', 557.0000, 'ºC'),
	(273526, 120, '2014-04-01 00:14:15.000000', 'temperatura', 622.0000, 'ºC'),
	(273527, 120, '2014-04-01 00:14:16.000000', 'temperatura', 236.0000, 'ºC'),
	(273528, 120, '2014-04-01 00:14:17.000000', 'temperatura', 518.0000, 'ºC'),
	(273529, 120, '2014-04-01 00:14:18.000000', 'temperatura', 680.0000, 'ºC'),
	(273530, 120, '2014-04-01 00:14:19.000000', 'temperatura', 647.0000, 'ºC'),
	(273531, 120, '2014-04-01 00:14:20.000000', 'temperatura', 1194.0000, 'ºC'),
	(273532, 120, '2014-04-01 00:14:21.000000', 'temperatura', 429.0000, 'ºC'),
	(273533, 120, '2014-04-01 00:14:22.000000', 'temperatura', 967.0000, 'ºC'),
	(273534, 120, '2014-04-01 00:14:23.000000', 'temperatura', 1145.0000, 'ºC'),
	(273535, 120, '2014-04-01 00:14:24.000000', 'temperatura', 425.0000, 'ºC'),
	(273536, 120, '2014-04-01 00:14:25.000000', 'temperatura', 1091.0000, 'ºC'),
	(273537, 120, '2014-04-01 00:14:26.000000', 'temperatura', 579.0000, 'ºC'),
	(273538, 120, '2014-04-01 00:14:27.000000', 'temperatura', 825.0000, 'ºC'),
	(273539, 120, '2014-04-01 00:14:28.000000', 'temperatura', 1186.0000, 'ºC'),
	(273540, 120, '2014-04-01 00:14:29.000000', 'temperatura', 1057.0000, 'ºC'),
	(273541, 120, '2014-04-01 00:14:30.000000', 'temperatura', 528.0000, 'ºC'),
	(273542, 120, '2014-04-01 00:14:31.000000', 'temperatura', 668.0000, 'ºC'),
	(273543, 120, '2014-04-01 00:14:32.000000', 'temperatura', 557.0000, 'ºC'),
	(273544, 120, '2014-04-01 00:14:33.000000', 'temperatura', 782.0000, 'ºC'),
	(273545, 120, '2014-04-01 00:14:34.000000', 'temperatura', 1038.0000, 'ºC'),
	(273546, 120, '2014-04-01 00:14:35.000000', 'temperatura', 447.0000, 'ºC'),
	(273547, 120, '2014-04-01 00:14:36.000000', 'temperatura', 320.0000, 'ºC'),
	(273548, 120, '2014-04-01 00:14:37.000000', 'temperatura', 261.0000, 'ºC'),
	(273549, 120, '2014-04-01 00:14:38.000000', 'temperatura', 343.0000, 'ºC'),
	(273550, 120, '2014-04-01 00:14:39.000000', 'temperatura', 934.0000, 'ºC'),
	(273551, 120, '2014-04-01 00:14:40.000000', 'temperatura', 42.0000, 'ºC'),
	(273552, 120, '2014-04-01 00:14:41.000000', 'temperatura', 1006.0000, 'ºC'),
	(273553, 120, '2014-04-01 00:14:42.000000', 'temperatura', 107.0000, 'ºC'),
	(273554, 120, '2014-04-01 00:14:43.000000', 'temperatura', 1116.0000, 'ºC'),
	(273555, 120, '2014-04-01 00:14:44.000000', 'temperatura', 462.0000, 'ºC'),
	(273556, 120, '2014-04-01 00:14:45.000000', 'temperatura', 160.0000, 'ºC'),
	(273557, 120, '2014-04-01 00:14:46.000000', 'temperatura', 614.0000, 'ºC'),
	(273558, 120, '2014-04-01 00:14:47.000000', 'temperatura', 193.0000, 'ºC'),
	(273559, 120, '2014-04-01 00:14:48.000000', 'temperatura', 321.0000, 'ºC'),
	(273560, 120, '2014-04-01 00:14:49.000000', 'temperatura', 1027.0000, 'ºC'),
	(273561, 120, '2014-04-01 00:14:50.000000', 'temperatura', 573.0000, 'ºC'),
	(273562, 120, '2014-04-01 00:14:51.000000', 'temperatura', 985.0000, 'ºC'),
	(273563, 120, '2014-04-01 00:14:52.000000', 'temperatura', 805.0000, 'ºC'),
	(273564, 120, '2014-04-01 00:14:53.000000', 'temperatura', 1072.0000, 'ºC'),
	(273565, 120, '2014-04-01 00:14:54.000000', 'temperatura', 544.0000, 'ºC'),
	(273566, 120, '2014-04-01 00:14:55.000000', 'temperatura', 706.0000, 'ºC'),
	(273567, 120, '2014-04-01 00:14:56.000000', 'temperatura', 697.0000, 'ºC'),
	(273568, 120, '2014-04-01 00:14:57.000000', 'temperatura', 168.0000, 'ºC'),
	(273569, 120, '2014-04-01 00:14:58.000000', 'temperatura', 1148.0000, 'ºC'),
	(273570, 120, '2014-04-01 00:14:59.000000', 'temperatura', 438.0000, 'ºC'),
	(273571, 120, '2014-04-01 00:15:00.000000', 'temperatura', 1145.0000, 'ºC'),
	(273572, 120, '2014-04-01 00:15:01.000000', 'temperatura', 813.0000, 'ºC'),
	(273573, 120, '2014-04-01 00:15:02.000000', 'temperatura', 632.0000, 'ºC'),
	(273574, 120, '2014-04-01 00:15:03.000000', 'temperatura', 721.0000, 'ºC'),
	(273575, 120, '2014-04-01 00:15:04.000000', 'temperatura', 509.0000, 'ºC'),
	(273576, 120, '2014-04-01 00:15:05.000000', 'temperatura', 382.0000, 'ºC'),
	(273577, 120, '2014-04-01 00:15:06.000000', 'temperatura', 385.0000, 'ºC'),
	(273578, 120, '2014-04-01 00:15:07.000000', 'temperatura', 779.0000, 'ºC'),
	(273579, 120, '2014-04-01 00:15:08.000000', 'temperatura', 339.0000, 'ºC'),
	(273580, 120, '2014-04-01 00:15:09.000000', 'temperatura', 560.0000, 'ºC'),
	(273581, 120, '2014-04-01 00:15:10.000000', 'temperatura', 581.0000, 'ºC'),
	(273582, 120, '2014-04-01 00:15:11.000000', 'temperatura', 27.0000, 'ºC'),
	(273583, 120, '2014-04-01 00:15:12.000000', 'temperatura', 792.0000, 'ºC'),
	(273584, 120, '2014-04-01 00:15:13.000000', 'temperatura', 279.0000, 'ºC'),
	(273585, 120, '2014-04-01 00:15:14.000000', 'temperatura', 221.0000, 'ºC'),
	(273586, 120, '2014-04-01 00:15:15.000000', 'temperatura', 267.0000, 'ºC'),
	(273587, 120, '2014-04-01 00:15:16.000000', 'temperatura', 674.0000, 'ºC'),
	(273588, 120, '2014-04-01 00:15:17.000000', 'temperatura', 168.0000, 'ºC'),
	(273589, 120, '2014-04-01 00:15:18.000000', 'temperatura', 17.0000, 'ºC'),
	(273590, 120, '2014-04-01 00:15:19.000000', 'temperatura', 783.0000, 'ºC'),
	(273591, 120, '2014-04-01 00:15:20.000000', 'temperatura', 264.0000, 'ºC'),
	(273592, 120, '2014-04-01 00:15:21.000000', 'temperatura', 171.0000, 'ºC'),
	(273593, 120, '2014-04-01 00:15:22.000000', 'temperatura', 62.0000, 'ºC'),
	(273594, 120, '2014-04-01 00:15:23.000000', 'temperatura', 1000.0000, 'ºC'),
	(273595, 120, '2014-04-01 00:15:24.000000', 'temperatura', 15.0000, 'ºC'),
	(273596, 120, '2014-04-01 00:15:25.000000', 'temperatura', 674.0000, 'ºC'),
	(273597, 120, '2014-04-01 00:15:26.000000', 'temperatura', 924.0000, 'ºC'),
	(273598, 120, '2014-04-01 00:15:27.000000', 'temperatura', 199.0000, 'ºC'),
	(273599, 120, '2014-04-01 00:15:28.000000', 'temperatura', 625.0000, 'ºC'),
	(273600, 120, '2014-04-01 00:15:29.000000', 'temperatura', 126.0000, 'ºC'),
	(273601, 120, '2014-04-01 00:15:30.000000', 'temperatura', 1156.0000, 'ºC'),
	(273602, 120, '2014-04-01 00:15:31.000000', 'temperatura', 601.0000, 'ºC'),
	(273603, 120, '2014-04-01 00:15:32.000000', 'temperatura', 741.0000, 'ºC'),
	(273604, 120, '2014-04-01 00:15:33.000000', 'temperatura', 700.0000, 'ºC'),
	(273605, 120, '2014-04-01 00:15:34.000000', 'temperatura', 78.0000, 'ºC'),
	(273606, 120, '2014-04-01 00:15:35.000000', 'temperatura', 690.0000, 'ºC'),
	(273607, 120, '2014-04-01 00:15:36.000000', 'temperatura', 815.0000, 'ºC'),
	(273608, 120, '2014-04-01 00:15:37.000000', 'temperatura', 809.0000, 'ºC'),
	(273609, 120, '2014-04-01 00:15:38.000000', 'temperatura', 399.0000, 'ºC'),
	(273610, 120, '2014-04-01 00:15:39.000000', 'temperatura', 768.0000, 'ºC'),
	(273611, 120, '2014-04-01 00:15:40.000000', 'temperatura', 242.0000, 'ºC'),
	(273612, 120, '2014-04-01 00:15:41.000000', 'temperatura', 108.0000, 'ºC'),
	(273613, 120, '2014-04-01 00:15:42.000000', 'temperatura', 1014.0000, 'ºC'),
	(273614, 120, '2014-04-01 00:15:43.000000', 'temperatura', 1147.0000, 'ºC'),
	(273615, 120, '2014-04-01 00:15:44.000000', 'temperatura', 295.0000, 'ºC'),
	(273616, 120, '2014-04-01 00:15:45.000000', 'temperatura', 433.0000, 'ºC'),
	(273617, 120, '2014-04-01 00:15:46.000000', 'temperatura', 79.0000, 'ºC'),
	(273618, 120, '2014-04-01 00:15:47.000000', 'temperatura', 299.0000, 'ºC'),
	(273619, 120, '2014-04-01 00:15:48.000000', 'temperatura', 59.0000, 'ºC'),
	(273620, 120, '2014-04-01 00:15:49.000000', 'temperatura', 598.0000, 'ºC'),
	(273621, 120, '2014-04-01 00:15:50.000000', 'temperatura', 414.0000, 'ºC'),
	(273622, 120, '2014-04-01 00:15:51.000000', 'temperatura', 277.0000, 'ºC'),
	(273623, 120, '2014-04-01 00:15:52.000000', 'temperatura', 141.0000, 'ºC'),
	(273624, 120, '2014-04-01 00:15:53.000000', 'temperatura', 1077.0000, 'ºC'),
	(273625, 120, '2014-04-01 00:15:54.000000', 'temperatura', 162.0000, 'ºC'),
	(273626, 120, '2014-04-01 00:15:55.000000', 'temperatura', 1178.0000, 'ºC'),
	(273627, 120, '2014-04-01 00:15:56.000000', 'temperatura', 605.0000, 'ºC'),
	(273628, 120, '2014-04-01 00:15:57.000000', 'temperatura', 692.0000, 'ºC'),
	(273629, 120, '2014-04-01 00:15:58.000000', 'temperatura', 445.0000, 'ºC'),
	(273630, 120, '2014-04-01 00:15:59.000000', 'temperatura', 148.0000, 'ºC'),
	(273631, 120, '2014-04-01 00:16:00.000000', 'temperatura', 608.0000, 'ºC'),
	(273632, 120, '2014-04-01 00:16:01.000000', 'temperatura', 195.0000, 'ºC'),
	(273633, 120, '2014-04-01 00:16:02.000000', 'temperatura', 353.0000, 'ºC'),
	(273634, 120, '2014-04-01 00:16:03.000000', 'temperatura', 1180.0000, 'ºC'),
	(273635, 120, '2014-04-01 00:16:04.000000', 'temperatura', 43.0000, 'ºC'),
	(273636, 120, '2014-04-01 00:16:05.000000', 'temperatura', 276.0000, 'ºC'),
	(273637, 120, '2014-04-01 00:16:06.000000', 'temperatura', 51.0000, 'ºC'),
	(273638, 120, '2014-04-01 00:16:07.000000', 'temperatura', 627.0000, 'ºC'),
	(273639, 120, '2014-04-01 00:16:08.000000', 'temperatura', 583.0000, 'ºC'),
	(273640, 120, '2014-04-01 00:16:09.000000', 'temperatura', 1035.0000, 'ºC'),
	(273641, 120, '2014-04-01 00:16:10.000000', 'temperatura', 1028.0000, 'ºC'),
	(273642, 120, '2014-04-01 00:16:11.000000', 'temperatura', 833.0000, 'ºC'),
	(273643, 120, '2014-04-01 00:16:12.000000', 'temperatura', 1080.0000, 'ºC'),
	(273644, 120, '2014-04-01 00:16:13.000000', 'temperatura', 504.0000, 'ºC'),
	(273645, 120, '2014-04-01 00:16:14.000000', 'temperatura', 481.0000, 'ºC'),
	(273646, 120, '2014-04-01 00:16:15.000000', 'temperatura', 893.0000, 'ºC'),
	(273647, 120, '2014-04-01 00:16:16.000000', 'temperatura', 622.0000, 'ºC'),
	(273648, 120, '2014-04-01 00:16:17.000000', 'temperatura', 431.0000, 'ºC'),
	(273649, 120, '2014-04-01 00:16:18.000000', 'temperatura', 292.0000, 'ºC'),
	(273650, 120, '2014-04-01 00:16:19.000000', 'temperatura', 165.0000, 'ºC'),
	(273651, 120, '2014-04-01 00:16:20.000000', 'temperatura', 1149.0000, 'ºC'),
	(273652, 120, '2014-04-01 00:16:21.000000', 'temperatura', 453.0000, 'ºC'),
	(273653, 120, '2014-04-01 00:16:22.000000', 'temperatura', 15.0000, 'ºC'),
	(273654, 120, '2014-04-01 00:16:23.000000', 'temperatura', 1120.0000, 'ºC'),
	(273655, 120, '2014-04-01 00:16:24.000000', 'temperatura', 754.0000, 'ºC'),
	(273656, 120, '2014-04-01 00:16:25.000000', 'temperatura', 413.0000, 'ºC'),
	(273657, 120, '2014-04-01 00:16:26.000000', 'temperatura', 1001.0000, 'ºC'),
	(273658, 120, '2014-04-01 00:16:27.000000', 'temperatura', 167.0000, 'ºC'),
	(273659, 120, '2014-04-01 00:16:28.000000', 'temperatura', 233.0000, 'ºC'),
	(273660, 120, '2014-04-01 00:16:29.000000', 'temperatura', 662.0000, 'ºC'),
	(273661, 120, '2014-04-01 00:16:30.000000', 'temperatura', 214.0000, 'ºC'),
	(273662, 120, '2014-04-01 00:16:31.000000', 'temperatura', 284.0000, 'ºC'),
	(273663, 120, '2014-04-01 00:16:32.000000', 'temperatura', 779.0000, 'ºC'),
	(273664, 120, '2014-04-01 00:16:33.000000', 'temperatura', 641.0000, 'ºC'),
	(273665, 120, '2014-04-01 00:16:34.000000', 'temperatura', 870.0000, 'ºC'),
	(273666, 120, '2014-04-01 00:16:35.000000', 'temperatura', 27.0000, 'ºC'),
	(273667, 120, '2014-04-01 00:16:36.000000', 'temperatura', 1124.0000, 'ºC'),
	(273668, 120, '2014-04-01 00:16:37.000000', 'temperatura', 741.0000, 'ºC'),
	(273669, 120, '2014-04-01 00:16:38.000000', 'temperatura', 331.0000, 'ºC'),
	(273670, 120, '2014-04-01 00:16:39.000000', 'temperatura', 635.0000, 'ºC'),
	(273671, 120, '2014-04-01 00:16:40.000000', 'temperatura', 982.0000, 'ºC'),
	(273672, 120, '2014-04-01 00:16:41.000000', 'temperatura', 605.0000, 'ºC'),
	(273673, 120, '2014-04-01 00:16:42.000000', 'temperatura', 79.0000, 'ºC'),
	(273674, 120, '2014-04-01 00:16:43.000000', 'temperatura', 980.0000, 'ºC'),
	(273675, 120, '2014-04-01 00:16:44.000000', 'temperatura', 1066.0000, 'ºC'),
	(273676, 120, '2014-04-01 00:16:45.000000', 'temperatura', 1188.0000, 'ºC'),
	(273677, 120, '2014-04-01 00:16:46.000000', 'temperatura', 342.0000, 'ºC'),
	(273678, 120, '2014-04-01 00:16:47.000000', 'temperatura', 550.0000, 'ºC'),
	(273679, 120, '2014-04-01 00:16:48.000000', 'temperatura', 521.0000, 'ºC'),
	(273680, 120, '2014-04-01 00:16:49.000000', 'temperatura', 957.0000, 'ºC'),
	(273681, 120, '2014-04-01 00:16:50.000000', 'temperatura', 821.0000, 'ºC'),
	(273682, 120, '2014-04-01 00:16:51.000000', 'temperatura', 33.0000, 'ºC'),
	(273683, 120, '2014-04-01 00:16:52.000000', 'temperatura', 106.0000, 'ºC'),
	(273684, 120, '2014-04-01 00:16:53.000000', 'temperatura', 429.0000, 'ºC'),
	(273685, 120, '2014-04-01 00:16:54.000000', 'temperatura', 627.0000, 'ºC'),
	(273686, 120, '2014-04-01 00:16:55.000000', 'temperatura', 647.0000, 'ºC'),
	(273687, 120, '2014-04-01 00:16:56.000000', 'temperatura', 158.0000, 'ºC'),
	(273688, 120, '2014-04-01 00:16:57.000000', 'temperatura', 49.0000, 'ºC'),
	(273689, 120, '2014-04-01 00:16:58.000000', 'temperatura', 970.0000, 'ºC'),
	(273690, 120, '2014-04-01 00:16:59.000000', 'temperatura', 1106.0000, 'ºC'),
	(273691, 120, '2014-04-01 00:17:00.000000', 'temperatura', 218.0000, 'ºC'),
	(273692, 120, '2014-04-01 00:17:01.000000', 'temperatura', 175.0000, 'ºC'),
	(273693, 120, '2014-04-01 00:17:02.000000', 'temperatura', 221.0000, 'ºC'),
	(273694, 120, '2014-04-01 00:17:03.000000', 'temperatura', 581.0000, 'ºC'),
	(273695, 120, '2014-04-01 00:17:04.000000', 'temperatura', 1044.0000, 'ºC'),
	(273696, 120, '2014-04-01 00:17:05.000000', 'temperatura', 1076.0000, 'ºC'),
	(273697, 120, '2014-04-01 00:17:06.000000', 'temperatura', 1048.0000, 'ºC'),
	(273698, 120, '2014-04-01 00:17:07.000000', 'temperatura', 813.0000, 'ºC'),
	(273699, 120, '2014-04-01 00:17:08.000000', 'temperatura', 921.0000, 'ºC'),
	(273700, 120, '2014-04-01 00:17:09.000000', 'temperatura', 968.0000, 'ºC'),
	(273701, 120, '2014-04-01 00:17:10.000000', 'temperatura', 876.0000, 'ºC'),
	(273702, 120, '2014-04-01 00:17:11.000000', 'temperatura', 278.0000, 'ºC'),
	(273703, 120, '2014-04-01 00:17:12.000000', 'temperatura', 1163.0000, 'ºC'),
	(273704, 120, '2014-04-01 00:17:13.000000', 'temperatura', 181.0000, 'ºC'),
	(273705, 120, '2014-04-01 00:17:14.000000', 'temperatura', 1015.0000, 'ºC'),
	(273706, 120, '2014-04-01 00:17:15.000000', 'temperatura', 932.0000, 'ºC'),
	(273707, 120, '2014-04-01 00:17:16.000000', 'temperatura', 417.0000, 'ºC'),
	(273708, 120, '2014-04-01 00:17:17.000000', 'temperatura', 488.0000, 'ºC'),
	(273709, 120, '2014-04-01 00:17:18.000000', 'temperatura', 1190.0000, 'ºC'),
	(273710, 120, '2014-04-01 00:17:19.000000', 'temperatura', 888.0000, 'ºC'),
	(273711, 120, '2014-04-01 00:17:20.000000', 'temperatura', 870.0000, 'ºC'),
	(273712, 120, '2014-04-01 00:17:21.000000', 'temperatura', 486.0000, 'ºC'),
	(273713, 120, '2014-04-01 00:17:22.000000', 'temperatura', 1022.0000, 'ºC'),
	(273714, 120, '2014-04-01 00:17:23.000000', 'temperatura', 53.0000, 'ºC'),
	(273715, 120, '2014-04-01 00:17:24.000000', 'temperatura', 800.0000, 'ºC'),
	(273716, 120, '2014-04-01 00:17:25.000000', 'temperatura', 242.0000, 'ºC'),
	(273717, 120, '2014-04-01 00:17:26.000000', 'temperatura', 9.0000, 'ºC'),
	(273718, 120, '2014-04-01 00:17:27.000000', 'temperatura', 519.0000, 'ºC'),
	(273719, 120, '2014-04-01 00:17:28.000000', 'temperatura', 167.0000, 'ºC'),
	(273720, 120, '2014-04-01 00:17:29.000000', 'temperatura', 480.0000, 'ºC'),
	(273721, 120, '2014-04-01 00:17:30.000000', 'temperatura', 701.0000, 'ºC'),
	(273722, 120, '2014-04-01 00:17:31.000000', 'temperatura', 865.0000, 'ºC'),
	(273723, 120, '2014-04-01 00:17:32.000000', 'temperatura', 1022.0000, 'ºC'),
	(273724, 120, '2014-04-01 00:17:33.000000', 'temperatura', 117.0000, 'ºC'),
	(273725, 120, '2014-04-01 00:17:34.000000', 'temperatura', 1120.0000, 'ºC'),
	(273726, 120, '2014-04-01 00:17:35.000000', 'temperatura', 450.0000, 'ºC'),
	(273727, 120, '2014-04-01 00:17:36.000000', 'temperatura', 91.0000, 'ºC'),
	(273728, 120, '2014-04-01 00:17:37.000000', 'temperatura', 305.0000, 'ºC'),
	(273729, 120, '2014-04-01 00:17:38.000000', 'temperatura', 53.0000, 'ºC'),
	(273730, 120, '2014-04-01 00:17:39.000000', 'temperatura', 551.0000, 'ºC'),
	(273731, 120, '2014-04-01 00:17:40.000000', 'temperatura', 195.0000, 'ºC'),
	(273732, 120, '2014-04-01 00:17:41.000000', 'temperatura', 521.0000, 'ºC'),
	(273733, 120, '2014-04-01 00:17:42.000000', 'temperatura', 822.0000, 'ºC'),
	(273734, 120, '2014-04-01 00:17:43.000000', 'temperatura', 149.0000, 'ºC'),
	(273735, 120, '2014-04-01 00:17:44.000000', 'temperatura', 679.0000, 'ºC'),
	(273736, 120, '2014-04-01 00:17:45.000000', 'temperatura', 547.0000, 'ºC'),
	(273737, 120, '2014-04-01 00:17:46.000000', 'temperatura', 701.0000, 'ºC'),
	(273738, 120, '2014-04-01 00:17:47.000000', 'temperatura', 662.0000, 'ºC'),
	(273739, 120, '2014-04-01 00:17:48.000000', 'temperatura', 9.0000, 'ºC'),
	(273740, 120, '2014-04-01 00:17:49.000000', 'temperatura', 459.0000, 'ºC'),
	(273741, 120, '2014-04-01 00:17:50.000000', 'temperatura', 1071.0000, 'ºC'),
	(273742, 120, '2014-04-01 00:17:51.000000', 'temperatura', 375.0000, 'ºC'),
	(273743, 120, '2014-04-01 00:17:52.000000', 'temperatura', 1062.0000, 'ºC'),
	(273744, 120, '2014-04-01 00:17:53.000000', 'temperatura', 588.0000, 'ºC'),
	(273745, 120, '2014-04-01 00:17:54.000000', 'temperatura', 955.0000, 'ºC'),
	(273746, 120, '2014-04-01 00:17:55.000000', 'temperatura', 610.0000, 'ºC'),
	(273747, 120, '2014-04-01 00:17:56.000000', 'temperatura', 188.0000, 'ºC'),
	(273748, 120, '2014-04-01 00:17:57.000000', 'temperatura', 308.0000, 'ºC'),
	(273749, 120, '2014-04-01 00:17:58.000000', 'temperatura', 976.0000, 'ºC'),
	(273750, 120, '2014-04-01 00:17:59.000000', 'temperatura', 358.0000, 'ºC'),
	(273751, 120, '2014-04-01 00:18:00.000000', 'temperatura', 63.0000, 'ºC'),
	(273752, 120, '2014-04-01 00:18:01.000000', 'temperatura', 442.0000, 'ºC'),
	(273753, 120, '2014-04-01 00:18:02.000000', 'temperatura', 822.0000, 'ºC'),
	(273754, 120, '2014-04-01 00:18:03.000000', 'temperatura', 382.0000, 'ºC'),
	(273755, 120, '2014-04-01 00:18:04.000000', 'temperatura', 645.0000, 'ºC'),
	(273756, 120, '2014-04-01 00:18:05.000000', 'temperatura', 879.0000, 'ºC'),
	(273757, 120, '2014-04-01 00:18:06.000000', 'temperatura', 62.0000, 'ºC'),
	(273758, 120, '2014-04-01 00:18:07.000000', 'temperatura', 72.0000, 'ºC'),
	(273759, 120, '2014-04-01 00:18:08.000000', 'temperatura', 175.0000, 'ºC'),
	(273760, 120, '2014-04-01 00:18:09.000000', 'temperatura', 661.0000, 'ºC'),
	(273761, 120, '2014-04-01 00:18:10.000000', 'temperatura', 380.0000, 'ºC'),
	(273762, 120, '2014-04-01 00:18:11.000000', 'temperatura', 1119.0000, 'ºC'),
	(273763, 120, '2014-04-01 00:18:12.000000', 'temperatura', 853.0000, 'ºC'),
	(273764, 120, '2014-04-01 00:18:13.000000', 'temperatura', 910.0000, 'ºC'),
	(273765, 120, '2014-04-01 00:18:14.000000', 'temperatura', 791.0000, 'ºC'),
	(273766, 120, '2014-04-01 00:18:15.000000', 'temperatura', 28.0000, 'ºC'),
	(273767, 120, '2014-04-01 00:18:16.000000', 'temperatura', 164.0000, 'ºC'),
	(273768, 120, '2014-04-01 00:18:17.000000', 'temperatura', 738.0000, 'ºC'),
	(273769, 120, '2014-04-01 00:18:18.000000', 'temperatura', 800.0000, 'ºC'),
	(273770, 120, '2014-04-01 00:18:19.000000', 'temperatura', 585.0000, 'ºC'),
	(273771, 120, '2014-04-01 00:18:20.000000', 'temperatura', 527.0000, 'ºC'),
	(273772, 120, '2014-04-01 00:18:21.000000', 'temperatura', 879.0000, 'ºC'),
	(273773, 120, '2014-04-01 00:18:22.000000', 'temperatura', 413.0000, 'ºC'),
	(273774, 120, '2014-04-01 00:18:23.000000', 'temperatura', 631.0000, 'ºC'),
	(273775, 120, '2014-04-01 00:18:24.000000', 'temperatura', 714.0000, 'ºC'),
	(273776, 120, '2014-04-01 00:18:25.000000', 'temperatura', 478.0000, 'ºC'),
	(273777, 120, '2014-04-01 00:18:26.000000', 'temperatura', 248.0000, 'ºC'),
	(273778, 120, '2014-04-01 00:18:27.000000', 'temperatura', 1008.0000, 'ºC'),
	(273779, 120, '2014-04-01 00:18:28.000000', 'temperatura', 695.0000, 'ºC'),
	(273780, 120, '2014-04-01 00:18:29.000000', 'temperatura', 454.0000, 'ºC'),
	(273781, 120, '2014-04-01 00:18:30.000000', 'temperatura', 184.0000, 'ºC'),
	(273782, 120, '2014-04-01 00:18:31.000000', 'temperatura', 760.0000, 'ºC'),
	(273783, 120, '2014-04-01 00:18:32.000000', 'temperatura', 846.0000, 'ºC'),
	(273784, 120, '2014-04-01 00:18:33.000000', 'temperatura', 750.0000, 'ºC'),
	(273785, 120, '2014-04-01 00:18:34.000000', 'temperatura', 15.0000, 'ºC'),
	(273786, 120, '2014-04-01 00:18:35.000000', 'temperatura', 226.0000, 'ºC'),
	(273787, 120, '2014-04-01 00:18:36.000000', 'temperatura', 1086.0000, 'ºC'),
	(273788, 120, '2014-04-01 00:18:37.000000', 'temperatura', 1153.0000, 'ºC'),
	(273789, 120, '2014-04-01 00:18:38.000000', 'temperatura', 105.0000, 'ºC'),
	(273790, 120, '2014-04-01 00:18:39.000000', 'temperatura', 667.0000, 'ºC'),
	(273791, 120, '2014-04-01 00:18:40.000000', 'temperatura', 620.0000, 'ºC'),
	(273792, 120, '2014-04-01 00:18:41.000000', 'temperatura', 1101.0000, 'ºC'),
	(273793, 120, '2014-04-01 00:18:42.000000', 'temperatura', 43.0000, 'ºC'),
	(273794, 120, '2014-04-01 00:18:43.000000', 'temperatura', 514.0000, 'ºC'),
	(273795, 120, '2014-04-01 00:18:44.000000', 'temperatura', 40.0000, 'ºC'),
	(273796, 120, '2014-04-01 00:18:45.000000', 'temperatura', 1058.0000, 'ºC'),
	(273797, 120, '2014-04-01 00:18:46.000000', 'temperatura', 372.0000, 'ºC'),
	(273798, 120, '2014-04-01 00:18:47.000000', 'temperatura', 1088.0000, 'ºC'),
	(273799, 120, '2014-04-01 00:18:48.000000', 'temperatura', 725.0000, 'ºC'),
	(273800, 120, '2014-04-01 00:18:49.000000', 'temperatura', 358.0000, 'ºC'),
	(273801, 120, '2014-04-01 00:18:50.000000', 'temperatura', 818.0000, 'ºC'),
	(273802, 120, '2014-04-01 00:18:51.000000', 'temperatura', 614.0000, 'ºC'),
	(273803, 120, '2014-04-01 00:18:52.000000', 'temperatura', 618.0000, 'ºC'),
	(273804, 120, '2014-04-01 00:18:53.000000', 'temperatura', 50.0000, 'ºC'),
	(273805, 120, '2014-04-01 00:18:54.000000', 'temperatura', 794.0000, 'ºC'),
	(273806, 120, '2014-04-01 00:18:55.000000', 'temperatura', 221.0000, 'ºC'),
	(273807, 120, '2014-04-01 00:18:56.000000', 'temperatura', 1125.0000, 'ºC'),
	(273808, 120, '2014-04-01 00:18:57.000000', 'temperatura', 161.0000, 'ºC'),
	(273809, 120, '2014-04-01 00:18:58.000000', 'temperatura', 1032.0000, 'ºC'),
	(273810, 120, '2014-04-01 00:18:59.000000', 'temperatura', 1077.0000, 'ºC'),
	(273811, 120, '2014-04-01 00:19:00.000000', 'temperatura', 1089.0000, 'ºC'),
	(273812, 120, '2014-04-01 00:19:01.000000', 'temperatura', 1014.0000, 'ºC'),
	(273813, 120, '2014-04-01 00:19:02.000000', 'temperatura', 605.0000, 'ºC'),
	(273814, 120, '2014-04-01 00:19:03.000000', 'temperatura', 1182.0000, 'ºC'),
	(273815, 120, '2014-04-01 00:19:04.000000', 'temperatura', 496.0000, 'ºC'),
	(273816, 120, '2014-04-01 00:19:05.000000', 'temperatura', 135.0000, 'ºC'),
	(273817, 120, '2014-04-01 00:19:06.000000', 'temperatura', 387.0000, 'ºC'),
	(273818, 120, '2014-04-01 00:19:07.000000', 'temperatura', 331.0000, 'ºC'),
	(273819, 120, '2014-04-01 00:19:08.000000', 'temperatura', 492.0000, 'ºC'),
	(273820, 120, '2014-04-01 00:19:09.000000', 'temperatura', 270.0000, 'ºC'),
	(273821, 120, '2014-04-01 00:19:10.000000', 'temperatura', 1073.0000, 'ºC'),
	(273822, 120, '2014-04-01 00:19:11.000000', 'temperatura', 954.0000, 'ºC'),
	(273823, 120, '2014-04-01 00:19:12.000000', 'temperatura', 353.0000, 'ºC'),
	(273824, 120, '2014-04-01 00:19:13.000000', 'temperatura', 102.0000, 'ºC'),
	(273825, 120, '2014-04-01 00:19:14.000000', 'temperatura', 654.0000, 'ºC'),
	(273826, 120, '2014-04-01 00:19:15.000000', 'temperatura', 565.0000, 'ºC'),
	(273827, 120, '2014-04-01 00:19:16.000000', 'temperatura', 864.0000, 'ºC'),
	(273828, 120, '2014-04-01 00:19:17.000000', 'temperatura', 223.0000, 'ºC'),
	(273829, 120, '2014-04-01 00:19:18.000000', 'temperatura', 924.0000, 'ºC'),
	(273830, 120, '2014-04-01 00:19:19.000000', 'temperatura', 350.0000, 'ºC'),
	(273831, 120, '2014-04-01 00:19:20.000000', 'temperatura', 181.0000, 'ºC'),
	(273832, 120, '2014-04-01 00:19:21.000000', 'temperatura', 1055.0000, 'ºC'),
	(273833, 120, '2014-04-01 00:19:22.000000', 'temperatura', 1131.0000, 'ºC'),
	(273834, 120, '2014-04-01 00:19:23.000000', 'temperatura', 91.0000, 'ºC'),
	(273835, 120, '2014-04-01 00:19:24.000000', 'temperatura', 662.0000, 'ºC'),
	(273836, 120, '2014-04-01 00:19:25.000000', 'temperatura', 636.0000, 'ºC'),
	(273837, 120, '2014-04-01 00:19:26.000000', 'temperatura', 1197.0000, 'ºC'),
	(273838, 120, '2014-04-01 00:19:27.000000', 'temperatura', 477.0000, 'ºC'),
	(273839, 120, '2014-04-01 00:19:28.000000', 'temperatura', 1193.0000, 'ºC'),
	(273840, 120, '2014-04-01 00:19:29.000000', 'temperatura', 936.0000, 'ºC'),
	(273841, 120, '2014-04-01 00:19:30.000000', 'temperatura', 1100.0000, 'ºC'),
	(273842, 120, '2014-04-01 00:19:31.000000', 'temperatura', 294.0000, 'ºC'),
	(273843, 120, '2014-04-01 00:19:32.000000', 'temperatura', 572.0000, 'ºC'),
	(273844, 120, '2014-04-01 00:19:33.000000', 'temperatura', 775.0000, 'ºC'),
	(273845, 120, '2014-04-01 00:19:34.000000', 'temperatura', 962.0000, 'ºC'),
	(273846, 120, '2014-04-01 00:19:35.000000', 'temperatura', 83.0000, 'ºC'),
	(273847, 120, '2014-04-01 00:19:36.000000', 'temperatura', 1130.0000, 'ºC'),
	(273848, 120, '2014-04-01 00:19:37.000000', 'temperatura', 602.0000, 'ºC'),
	(273849, 120, '2014-04-01 00:19:38.000000', 'temperatura', 822.0000, 'ºC'),
	(273850, 120, '2014-04-01 00:19:39.000000', 'temperatura', 1105.0000, 'ºC'),
	(273851, 120, '2014-04-01 00:19:40.000000', 'temperatura', 657.0000, 'ºC'),
	(273852, 120, '2014-04-01 00:19:41.000000', 'temperatura', 1170.0000, 'ºC'),
	(273853, 120, '2014-04-01 00:19:42.000000', 'temperatura', 280.0000, 'ºC'),
	(273854, 120, '2014-04-01 00:19:43.000000', 'temperatura', 289.0000, 'ºC'),
	(273855, 120, '2014-04-01 00:19:44.000000', 'temperatura', 608.0000, 'ºC'),
	(273856, 120, '2014-04-01 00:19:45.000000', 'temperatura', 973.0000, 'ºC'),
	(273857, 120, '2014-04-01 00:19:46.000000', 'temperatura', 641.0000, 'ºC'),
	(273858, 120, '2014-04-01 00:19:47.000000', 'temperatura', 287.0000, 'ºC'),
	(273859, 120, '2014-04-01 00:19:48.000000', 'temperatura', 712.0000, 'ºC'),
	(273860, 120, '2014-04-01 00:19:49.000000', 'temperatura', 299.0000, 'ºC'),
	(273861, 120, '2014-04-01 00:19:50.000000', 'temperatura', 559.0000, 'ºC'),
	(273862, 120, '2014-04-01 00:19:51.000000', 'temperatura', 701.0000, 'ºC'),
	(273863, 120, '2014-04-01 00:19:52.000000', 'temperatura', 627.0000, 'ºC'),
	(273864, 120, '2014-04-01 00:19:53.000000', 'temperatura', 1033.0000, 'ºC'),
	(273865, 120, '2014-04-01 00:19:54.000000', 'temperatura', 882.0000, 'ºC'),
	(273866, 120, '2014-04-01 00:19:55.000000', 'temperatura', 115.0000, 'ºC'),
	(273867, 120, '2014-04-01 00:19:56.000000', 'temperatura', 328.0000, 'ºC'),
	(273868, 120, '2014-04-01 00:19:57.000000', 'temperatura', 97.0000, 'ºC'),
	(273869, 120, '2014-04-01 00:19:58.000000', 'temperatura', 702.0000, 'ºC'),
	(273870, 120, '2014-04-01 00:19:59.000000', 'temperatura', 820.0000, 'ºC'),
	(273871, 120, '2014-04-01 00:20:00.000000', 'temperatura', 795.0000, 'ºC'),
	(273872, 120, '2014-04-01 00:20:01.000000', 'temperatura', 316.0000, 'ºC'),
	(273873, 120, '2014-04-01 00:20:02.000000', 'temperatura', 395.0000, 'ºC'),
	(273874, 120, '2014-04-01 00:20:03.000000', 'temperatura', 1025.0000, 'ºC'),
	(273875, 120, '2014-04-01 00:20:04.000000', 'temperatura', 343.0000, 'ºC'),
	(273876, 120, '2014-04-01 00:20:05.000000', 'temperatura', 1041.0000, 'ºC'),
	(273877, 120, '2014-04-01 00:20:06.000000', 'temperatura', 578.0000, 'ºC'),
	(273878, 120, '2014-04-01 00:20:07.000000', 'temperatura', 965.0000, 'ºC'),
	(273879, 120, '2014-04-01 00:20:08.000000', 'temperatura', 691.0000, 'ºC'),
	(273880, 120, '2014-04-01 00:20:09.000000', 'temperatura', 560.0000, 'ºC'),
	(273881, 120, '2014-04-01 00:20:10.000000', 'temperatura', 730.0000, 'ºC'),
	(273882, 120, '2014-04-01 00:20:11.000000', 'temperatura', 770.0000, 'ºC'),
	(273883, 120, '2014-04-01 00:20:12.000000', 'temperatura', 460.0000, 'ºC'),
	(273884, 120, '2014-04-01 00:20:13.000000', 'temperatura', 1192.0000, 'ºC'),
	(273885, 120, '2014-04-01 00:20:14.000000', 'temperatura', 980.0000, 'ºC'),
	(273886, 120, '2014-04-01 00:20:15.000000', 'temperatura', 125.0000, 'ºC'),
	(273887, 120, '2014-04-01 00:20:16.000000', 'temperatura', 84.0000, 'ºC'),
	(273888, 120, '2014-04-01 00:20:17.000000', 'temperatura', 45.0000, 'ºC'),
	(273889, 120, '2014-04-01 00:20:18.000000', 'temperatura', 1173.0000, 'ºC'),
	(273890, 120, '2014-04-01 00:20:19.000000', 'temperatura', 933.0000, 'ºC'),
	(273891, 120, '2014-04-01 00:20:20.000000', 'temperatura', 1146.0000, 'ºC'),
	(273892, 120, '2014-04-01 00:20:21.000000', 'temperatura', 533.0000, 'ºC'),
	(273893, 120, '2014-04-01 00:20:22.000000', 'temperatura', 425.0000, 'ºC'),
	(273894, 120, '2014-04-01 00:20:23.000000', 'temperatura', 528.0000, 'ºC'),
	(273895, 120, '2014-04-01 00:20:24.000000', 'temperatura', 165.0000, 'ºC'),
	(273896, 120, '2014-04-01 00:20:25.000000', 'temperatura', 442.0000, 'ºC'),
	(273897, 120, '2014-04-01 00:20:26.000000', 'temperatura', 516.0000, 'ºC'),
	(273898, 120, '2014-04-01 00:20:27.000000', 'temperatura', 54.0000, 'ºC'),
	(273899, 120, '2014-04-01 00:20:28.000000', 'temperatura', 1123.0000, 'ºC'),
	(273900, 120, '2014-04-01 00:20:29.000000', 'temperatura', 653.0000, 'ºC'),
	(273901, 120, '2014-04-01 00:20:30.000000', 'temperatura', 1095.0000, 'ºC'),
	(273902, 120, '2014-04-01 00:20:31.000000', 'temperatura', 1115.0000, 'ºC'),
	(273903, 120, '2014-04-01 00:20:32.000000', 'temperatura', 1094.0000, 'ºC'),
	(273904, 120, '2014-04-01 00:20:33.000000', 'temperatura', 926.0000, 'ºC'),
	(273905, 120, '2014-04-01 00:20:34.000000', 'temperatura', 148.0000, 'ºC'),
	(273906, 120, '2014-04-01 00:20:35.000000', 'temperatura', 361.0000, 'ºC'),
	(273907, 120, '2014-04-01 00:20:36.000000', 'temperatura', 161.0000, 'ºC'),
	(273908, 120, '2014-04-01 00:20:37.000000', 'temperatura', 925.0000, 'ºC'),
	(273909, 120, '2014-04-01 00:20:38.000000', 'temperatura', 541.0000, 'ºC'),
	(273910, 120, '2014-04-01 00:20:39.000000', 'temperatura', 1132.0000, 'ºC'),
	(273911, 120, '2014-04-01 00:20:40.000000', 'temperatura', 435.0000, 'ºC'),
	(273912, 120, '2014-04-01 00:20:41.000000', 'temperatura', 1182.0000, 'ºC'),
	(273913, 120, '2014-04-01 00:20:42.000000', 'temperatura', 1003.0000, 'ºC'),
	(273914, 120, '2014-04-01 00:20:43.000000', 'temperatura', 269.0000, 'ºC'),
	(273915, 120, '2014-04-01 00:20:44.000000', 'temperatura', 739.0000, 'ºC'),
	(273916, 120, '2014-04-01 00:20:45.000000', 'temperatura', 487.0000, 'ºC'),
	(273917, 120, '2014-04-01 00:20:46.000000', 'temperatura', 220.0000, 'ºC'),
	(273918, 120, '2014-04-01 00:20:47.000000', 'temperatura', 840.0000, 'ºC'),
	(273919, 120, '2014-04-01 00:20:48.000000', 'temperatura', 1139.0000, 'ºC'),
	(273920, 120, '2014-04-01 00:20:49.000000', 'temperatura', 777.0000, 'ºC'),
	(273921, 120, '2014-04-01 00:20:50.000000', 'temperatura', 466.0000, 'ºC'),
	(273922, 120, '2014-04-01 00:20:51.000000', 'temperatura', 2.0000, 'ºC'),
	(273923, 120, '2014-04-01 00:20:52.000000', 'temperatura', 1013.0000, 'ºC'),
	(273924, 120, '2014-04-01 00:20:53.000000', 'temperatura', 260.0000, 'ºC'),
	(273925, 120, '2014-04-01 00:20:54.000000', 'temperatura', 659.0000, 'ºC'),
	(273926, 120, '2014-04-01 00:20:55.000000', 'temperatura', 115.0000, 'ºC'),
	(273927, 120, '2014-04-01 00:20:56.000000', 'temperatura', 1001.0000, 'ºC'),
	(273928, 120, '2014-04-01 00:20:57.000000', 'temperatura', 1059.0000, 'ºC'),
	(273929, 120, '2014-04-01 00:20:58.000000', 'temperatura', 1091.0000, 'ºC'),
	(273930, 120, '2014-04-01 00:20:59.000000', 'temperatura', 1082.0000, 'ºC'),
	(273931, 120, '2014-04-01 00:21:00.000000', 'temperatura', 936.0000, 'ºC'),
	(273932, 120, '2014-04-01 00:21:01.000000', 'temperatura', 233.0000, 'ºC'),
	(273933, 120, '2014-04-01 00:21:02.000000', 'temperatura', 757.0000, 'ºC'),
	(273934, 120, '2014-04-01 00:21:03.000000', 'temperatura', 688.0000, 'ºC'),
	(273935, 120, '2014-04-01 00:21:04.000000', 'temperatura', 1168.0000, 'ºC'),
	(273936, 120, '2014-04-01 00:21:05.000000', 'temperatura', 178.0000, 'ºC'),
	(273937, 120, '2014-04-01 00:21:06.000000', 'temperatura', 987.0000, 'ºC'),
	(273938, 120, '2014-04-01 00:21:07.000000', 'temperatura', 803.0000, 'ºC'),
	(273939, 120, '2014-04-01 00:21:08.000000', 'temperatura', 1052.0000, 'ºC'),
	(273940, 120, '2014-04-01 00:21:09.000000', 'temperatura', 454.0000, 'ºC'),
	(273941, 120, '2014-04-01 00:21:10.000000', 'temperatura', 311.0000, 'ºC'),
	(273942, 120, '2014-04-01 00:21:11.000000', 'temperatura', 197.0000, 'ºC'),
	(273943, 120, '2014-04-01 00:21:12.000000', 'temperatura', 49.0000, 'ºC'),
	(273944, 120, '2014-04-01 00:21:13.000000', 'temperatura', 857.0000, 'ºC'),
	(273945, 120, '2014-04-01 00:21:14.000000', 'temperatura', 540.0000, 'ºC'),
	(273946, 120, '2014-04-01 00:21:15.000000', 'temperatura', 127.0000, 'ºC'),
	(273947, 120, '2014-04-01 00:21:16.000000', 'temperatura', 216.0000, 'ºC'),
	(273948, 120, '2014-04-01 00:21:17.000000', 'temperatura', 701.0000, 'ºC'),
	(273949, 120, '2014-04-01 00:21:18.000000', 'temperatura', 457.0000, 'ºC'),
	(273950, 120, '2014-04-01 00:21:19.000000', 'temperatura', 181.0000, 'ºC'),
	(273951, 120, '2014-04-01 00:21:20.000000', 'temperatura', 736.0000, 'ºC'),
	(273952, 120, '2014-04-01 00:21:21.000000', 'temperatura', 736.0000, 'ºC'),
	(273953, 120, '2014-04-01 00:21:22.000000', 'temperatura', 272.0000, 'ºC'),
	(273954, 120, '2014-04-01 00:21:23.000000', 'temperatura', 354.0000, 'ºC'),
	(273955, 120, '2014-04-01 00:21:24.000000', 'temperatura', 953.0000, 'ºC'),
	(273956, 120, '2014-04-01 00:21:25.000000', 'temperatura', 105.0000, 'ºC'),
	(273957, 120, '2014-04-01 00:21:26.000000', 'temperatura', 67.0000, 'ºC'),
	(273958, 120, '2014-04-01 00:21:27.000000', 'temperatura', 19.0000, 'ºC'),
	(273959, 120, '2014-04-01 00:21:28.000000', 'temperatura', 1096.0000, 'ºC'),
	(273960, 120, '2014-04-01 00:21:29.000000', 'temperatura', 625.0000, 'ºC'),
	(273961, 120, '2014-04-01 00:21:30.000000', 'temperatura', 1035.0000, 'ºC'),
	(273962, 120, '2014-04-01 00:21:31.000000', 'temperatura', 902.0000, 'ºC'),
	(273963, 120, '2014-04-01 00:21:32.000000', 'temperatura', 207.0000, 'ºC'),
	(273964, 120, '2014-04-01 00:21:33.000000', 'temperatura', 726.0000, 'ºC'),
	(273965, 120, '2014-04-01 00:21:34.000000', 'temperatura', 611.0000, 'ºC'),
	(273966, 120, '2014-04-01 00:21:35.000000', 'temperatura', 878.0000, 'ºC'),
	(273967, 120, '2014-04-01 00:21:36.000000', 'temperatura', 158.0000, 'ºC'),
	(273968, 120, '2014-04-01 00:21:37.000000', 'temperatura', 557.0000, 'ºC'),
	(273969, 120, '2014-04-01 00:21:38.000000', 'temperatura', 1112.0000, 'ºC'),
	(273970, 120, '2014-04-01 00:21:39.000000', 'temperatura', 287.0000, 'ºC'),
	(273971, 120, '2014-04-01 00:21:40.000000', 'temperatura', 500.0000, 'ºC'),
	(273972, 120, '2014-04-01 00:21:41.000000', 'temperatura', 442.0000, 'ºC'),
	(273973, 120, '2014-04-01 00:21:42.000000', 'temperatura', 709.0000, 'ºC'),
	(273974, 120, '2014-04-01 00:21:43.000000', 'temperatura', 1019.0000, 'ºC'),
	(273975, 120, '2014-04-01 00:21:44.000000', 'temperatura', 570.0000, 'ºC'),
	(273976, 120, '2014-04-01 00:21:45.000000', 'temperatura', 992.0000, 'ºC'),
	(273977, 120, '2014-04-01 00:21:46.000000', 'temperatura', 852.0000, 'ºC'),
	(273978, 120, '2014-04-01 00:21:47.000000', 'temperatura', 82.0000, 'ºC'),
	(273979, 120, '2014-04-01 00:21:48.000000', 'temperatura', 255.0000, 'ºC'),
	(273980, 120, '2014-04-01 00:21:49.000000', 'temperatura', 1031.0000, 'ºC'),
	(273981, 120, '2014-04-01 00:21:50.000000', 'temperatura', 790.0000, 'ºC'),
	(273982, 120, '2014-04-01 00:21:51.000000', 'temperatura', 855.0000, 'ºC'),
	(273983, 120, '2014-04-01 00:21:52.000000', 'temperatura', 709.0000, 'ºC'),
	(273984, 120, '2014-04-01 00:21:53.000000', 'temperatura', 978.0000, 'ºC'),
	(273985, 120, '2014-04-01 00:21:54.000000', 'temperatura', 365.0000, 'ºC'),
	(273986, 120, '2014-04-01 00:21:55.000000', 'temperatura', 92.0000, 'ºC'),
	(273987, 120, '2014-04-01 00:21:56.000000', 'temperatura', 567.0000, 'ºC'),
	(273988, 120, '2014-04-01 00:21:57.000000', 'temperatura', 158.0000, 'ºC'),
	(273989, 120, '2014-04-01 00:21:58.000000', 'temperatura', 287.0000, 'ºC'),
	(273990, 120, '2014-04-01 00:21:59.000000', 'temperatura', 965.0000, 'ºC'),
	(273991, 120, '2014-04-01 00:22:00.000000', 'temperatura', 364.0000, 'ºC'),
	(273992, 120, '2014-04-01 00:22:01.000000', 'temperatura', 126.0000, 'ºC'),
	(273993, 120, '2014-04-01 00:22:02.000000', 'temperatura', 737.0000, 'ºC'),
	(273994, 120, '2014-04-01 00:22:03.000000', 'temperatura', 908.0000, 'ºC'),
	(273995, 120, '2014-04-01 00:22:04.000000', 'temperatura', 1130.0000, 'ºC'),
	(273996, 120, '2014-04-01 00:22:05.000000', 'temperatura', 526.0000, 'ºC'),
	(273997, 120, '2014-04-01 00:22:06.000000', 'temperatura', 442.0000, 'ºC'),
	(273998, 120, '2014-04-01 00:22:07.000000', 'temperatura', 632.0000, 'ºC'),
	(273999, 120, '2014-04-01 00:22:08.000000', 'temperatura', 635.0000, 'ºC'),
	(274000, 120, '2014-04-01 00:22:09.000000', 'temperatura', 80.0000, 'ºC'),
	(274001, 120, '2014-04-01 00:22:10.000000', 'temperatura', 893.0000, 'ºC'),
	(274002, 120, '2014-04-01 00:22:11.000000', 'temperatura', 627.0000, 'ºC'),
	(274003, 120, '2014-04-01 00:22:12.000000', 'temperatura', 455.0000, 'ºC'),
	(274004, 120, '2014-04-01 00:22:13.000000', 'temperatura', 394.0000, 'ºC'),
	(274005, 120, '2014-04-01 00:22:14.000000', 'temperatura', 607.0000, 'ºC'),
	(274006, 120, '2014-04-01 00:22:15.000000', 'temperatura', 653.0000, 'ºC'),
	(274007, 120, '2014-04-01 00:22:16.000000', 'temperatura', 244.0000, 'ºC'),
	(274008, 120, '2014-04-01 00:22:17.000000', 'temperatura', 462.0000, 'ºC'),
	(274009, 120, '2014-04-01 00:22:18.000000', 'temperatura', 380.0000, 'ºC'),
	(274010, 120, '2014-04-01 00:22:19.000000', 'temperatura', 514.0000, 'ºC'),
	(274011, 120, '2014-04-01 00:22:20.000000', 'temperatura', 230.0000, 'ºC'),
	(274012, 120, '2014-04-01 00:22:21.000000', 'temperatura', 809.0000, 'ºC'),
	(274013, 120, '2014-04-01 00:22:22.000000', 'temperatura', 956.0000, 'ºC'),
	(274014, 120, '2014-04-01 00:22:23.000000', 'temperatura', 1155.0000, 'ºC'),
	(274015, 120, '2014-04-01 00:22:24.000000', 'temperatura', 506.0000, 'ºC'),
	(274016, 120, '2014-04-01 00:22:25.000000', 'temperatura', 264.0000, 'ºC'),
	(274017, 120, '2014-04-01 00:22:26.000000', 'temperatura', 1005.0000, 'ºC'),
	(274018, 120, '2014-04-01 00:22:27.000000', 'temperatura', 633.0000, 'ºC'),
	(274019, 120, '2014-04-01 00:22:28.000000', 'temperatura', 152.0000, 'ºC'),
	(274020, 120, '2014-04-01 00:22:29.000000', 'temperatura', 60.0000, 'ºC'),
	(274021, 120, '2014-04-01 00:22:30.000000', 'temperatura', 1044.0000, 'ºC'),
	(274022, 120, '2014-04-01 00:22:31.000000', 'temperatura', 242.0000, 'ºC'),
	(274023, 120, '2014-04-01 00:22:32.000000', 'temperatura', 478.0000, 'ºC'),
	(274024, 120, '2014-04-01 00:22:33.000000', 'temperatura', 464.0000, 'ºC'),
	(274025, 120, '2014-04-01 00:22:34.000000', 'temperatura', 888.0000, 'ºC'),
	(274026, 120, '2014-04-01 00:22:35.000000', 'temperatura', 648.0000, 'ºC'),
	(274027, 120, '2014-04-01 00:22:36.000000', 'temperatura', 578.0000, 'ºC'),
	(274028, 120, '2014-04-01 00:22:37.000000', 'temperatura', 944.0000, 'ºC'),
	(274029, 120, '2014-04-01 00:22:38.000000', 'temperatura', 589.0000, 'ºC'),
	(274030, 120, '2014-04-01 00:22:39.000000', 'temperatura', 113.0000, 'ºC'),
	(274031, 120, '2014-04-01 00:22:40.000000', 'temperatura', 1198.0000, 'ºC'),
	(274032, 120, '2014-04-01 00:22:41.000000', 'temperatura', 852.0000, 'ºC'),
	(274033, 120, '2014-04-01 00:22:42.000000', 'temperatura', 666.0000, 'ºC'),
	(274034, 120, '2014-04-01 00:22:43.000000', 'temperatura', 773.0000, 'ºC'),
	(274035, 120, '2014-04-01 00:22:44.000000', 'temperatura', 667.0000, 'ºC'),
	(274036, 120, '2014-04-01 00:22:45.000000', 'temperatura', 1019.0000, 'ºC'),
	(274037, 120, '2014-04-01 00:22:46.000000', 'temperatura', 694.0000, 'ºC'),
	(274038, 120, '2014-04-01 00:22:47.000000', 'temperatura', 413.0000, 'ºC'),
	(274039, 120, '2014-04-01 00:22:48.000000', 'temperatura', 1186.0000, 'ºC'),
	(274040, 120, '2014-04-01 00:22:49.000000', 'temperatura', 1089.0000, 'ºC'),
	(274041, 120, '2014-04-01 00:22:50.000000', 'temperatura', 687.0000, 'ºC'),
	(274042, 120, '2014-04-01 00:22:51.000000', 'temperatura', 168.0000, 'ºC'),
	(274043, 120, '2014-04-01 00:22:52.000000', 'temperatura', 1180.0000, 'ºC'),
	(274044, 120, '2014-04-01 00:22:53.000000', 'temperatura', 598.0000, 'ºC'),
	(274045, 120, '2014-04-01 00:22:54.000000', 'temperatura', 649.0000, 'ºC'),
	(274046, 120, '2014-04-01 00:22:55.000000', 'temperatura', 253.0000, 'ºC'),
	(274047, 120, '2014-04-01 00:22:56.000000', 'temperatura', 517.0000, 'ºC'),
	(274048, 120, '2014-04-01 00:22:57.000000', 'temperatura', 629.0000, 'ºC'),
	(274049, 120, '2014-04-01 00:22:58.000000', 'temperatura', 394.0000, 'ºC'),
	(274050, 120, '2014-04-01 00:22:59.000000', 'temperatura', 81.0000, 'ºC'),
	(274051, 120, '2014-04-01 00:23:00.000000', 'temperatura', 424.0000, 'ºC'),
	(274052, 120, '2014-04-01 00:23:01.000000', 'temperatura', 679.0000, 'ºC'),
	(274053, 120, '2014-04-01 00:23:02.000000', 'temperatura', 921.0000, 'ºC'),
	(274054, 120, '2014-04-01 00:23:03.000000', 'temperatura', 171.0000, 'ºC'),
	(274055, 120, '2014-04-01 00:23:04.000000', 'temperatura', 492.0000, 'ºC'),
	(274056, 120, '2014-04-01 00:23:05.000000', 'temperatura', 746.0000, 'ºC'),
	(274057, 120, '2014-04-01 00:23:06.000000', 'temperatura', 1053.0000, 'ºC'),
	(274058, 120, '2014-04-01 00:23:07.000000', 'temperatura', 631.0000, 'ºC'),
	(274059, 120, '2014-04-01 00:23:08.000000', 'temperatura', 1196.0000, 'ºC'),
	(274060, 120, '2014-04-01 00:23:09.000000', 'temperatura', 485.0000, 'ºC'),
	(274061, 120, '2014-04-01 00:23:10.000000', 'temperatura', 39.0000, 'ºC'),
	(274062, 120, '2014-04-01 00:23:11.000000', 'temperatura', 1142.0000, 'ºC'),
	(274063, 120, '2014-04-01 00:23:12.000000', 'temperatura', 791.0000, 'ºC'),
	(274064, 120, '2014-04-01 00:23:13.000000', 'temperatura', 533.0000, 'ºC'),
	(274065, 120, '2014-04-01 00:23:14.000000', 'temperatura', 289.0000, 'ºC'),
	(274066, 120, '2014-04-01 00:23:15.000000', 'temperatura', 1048.0000, 'ºC'),
	(274067, 120, '2014-04-01 00:23:16.000000', 'temperatura', 773.0000, 'ºC'),
	(274068, 120, '2014-04-01 00:23:17.000000', 'temperatura', 721.0000, 'ºC'),
	(274069, 120, '2014-04-01 00:23:18.000000', 'temperatura', 86.0000, 'ºC'),
	(274070, 120, '2014-04-01 00:23:19.000000', 'temperatura', 669.0000, 'ºC'),
	(274071, 120, '2014-04-01 00:23:20.000000', 'temperatura', 686.0000, 'ºC'),
	(274072, 120, '2014-04-01 00:23:21.000000', 'temperatura', 226.0000, 'ºC'),
	(274073, 120, '2014-04-01 00:23:22.000000', 'temperatura', 271.0000, 'ºC'),
	(274074, 120, '2014-04-01 00:23:23.000000', 'temperatura', 676.0000, 'ºC'),
	(274075, 120, '2014-04-01 00:23:24.000000', 'temperatura', 169.0000, 'ºC'),
	(274076, 120, '2014-04-01 00:23:25.000000', 'temperatura', 19.0000, 'ºC'),
	(274077, 120, '2014-04-01 00:23:26.000000', 'temperatura', 786.0000, 'ºC'),
	(274078, 120, '2014-04-01 00:23:27.000000', 'temperatura', 276.0000, 'ºC'),
	(274079, 120, '2014-04-01 00:23:28.000000', 'temperatura', 220.0000, 'ºC'),
	(274080, 120, '2014-04-01 00:23:29.000000', 'temperatura', 275.0000, 'ºC'),
	(274081, 120, '2014-04-01 00:23:30.000000', 'temperatura', 715.0000, 'ºC'),
	(274082, 120, '2014-04-01 00:23:31.000000', 'temperatura', 350.0000, 'ºC'),
	(274083, 120, '2014-04-01 00:23:32.000000', 'temperatura', 804.0000, 'ºC'),
	(274084, 120, '2014-04-01 00:23:33.000000', 'temperatura', 572.0000, 'ºC'),
	(274085, 120, '2014-04-01 00:23:34.000000', 'temperatura', 448.0000, 'ºC'),
	(274086, 120, '2014-04-01 00:23:35.000000', 'temperatura', 526.0000, 'ºC'),
	(274087, 120, '2014-04-01 00:23:36.000000', 'temperatura', 86.0000, 'ºC'),
	(274088, 120, '2014-04-01 00:23:37.000000', 'temperatura', 50.0000, 'ºC'),
	(274089, 120, '2014-04-01 00:23:38.000000', 'temperatura', 1195.0000, 'ºC'),
	(274090, 120, '2014-04-01 00:23:39.000000', 'temperatura', 1027.0000, 'ºC'),
	(274091, 120, '2014-04-01 00:23:40.000000', 'temperatura', 349.0000, 'ºC'),
	(274092, 120, '2014-04-01 00:23:41.000000', 'temperatura', 1064.0000, 'ºC'),
	(274093, 120, '2014-04-01 00:23:42.000000', 'temperatura', 672.0000, 'ºC'),
	(274094, 120, '2014-04-01 00:23:43.000000', 'temperatura', 169.0000, 'ºC'),
	(274095, 120, '2014-04-01 00:23:44.000000', 'temperatura', 30.0000, 'ºC'),
	(274096, 120, '2014-04-01 00:23:45.000000', 'temperatura', 843.0000, 'ºC'),
	(274097, 120, '2014-04-01 00:23:46.000000', 'temperatura', 526.0000, 'ºC'),
	(274098, 120, '2014-04-01 00:23:47.000000', 'temperatura', 99.0000, 'ºC'),
	(274099, 120, '2014-04-01 00:23:48.000000', 'temperatura', 121.0000, 'ºC'),
	(274100, 120, '2014-04-01 00:23:49.000000', 'temperatura', 307.0000, 'ºC'),
	(274101, 120, '2014-04-01 00:23:50.000000', 'temperatura', 1173.0000, 'ºC'),
	(274102, 120, '2014-04-01 00:23:51.000000', 'temperatura', 146.0000, 'ºC'),
	(274103, 120, '2014-04-01 00:23:52.000000', 'temperatura', 810.0000, 'ºC'),
	(274104, 120, '2014-04-01 00:23:53.000000', 'temperatura', 11.0000, 'ºC'),
	(274105, 120, '2014-04-01 00:23:54.000000', 'temperatura', 25.0000, 'ºC'),
	(274106, 120, '2014-04-01 00:23:55.000000', 'temperatura', 93.0000, 'ºC'),
	(274107, 120, '2014-04-01 00:23:56.000000', 'temperatura', 390.0000, 'ºC'),
	(274108, 120, '2014-04-01 00:23:57.000000', 'temperatura', 473.0000, 'ºC'),
	(274109, 120, '2014-04-01 00:23:58.000000', 'temperatura', 1193.0000, 'ºC'),
	(274110, 120, '2014-04-01 00:23:59.000000', 'temperatura', 950.0000, 'ºC'),
	(274111, 120, '2014-04-01 00:24:00.000000', 'temperatura', 1170.0000, 'ºC'),
	(274112, 120, '2014-04-01 00:24:01.000000', 'temperatura', 599.0000, 'ºC'),
	(274113, 120, '2014-04-01 00:24:02.000000', 'temperatura', 684.0000, 'ºC'),
	(274114, 120, '2014-04-01 00:24:03.000000', 'temperatura', 427.0000, 'ºC'),
	(274115, 120, '2014-04-01 00:24:04.000000', 'temperatura', 82.0000, 'ºC'),
	(274116, 120, '2014-04-01 00:24:05.000000', 'temperatura', 331.0000, 'ºC'),
	(274117, 120, '2014-04-01 00:24:06.000000', 'temperatura', 208.0000, 'ºC'),
	(274118, 120, '2014-04-01 00:24:07.000000', 'temperatura', 47.0000, 'ºC'),
	(274119, 120, '2014-04-01 00:24:08.000000', 'temperatura', 813.0000, 'ºC'),
	(274120, 120, '2014-04-01 00:24:09.000000', 'temperatura', 324.0000, 'ºC'),
	(274121, 120, '2014-04-01 00:24:10.000000', 'temperatura', 382.0000, 'ºC'),
	(274122, 120, '2014-04-01 00:24:11.000000', 'temperatura', 939.0000, 'ºC'),
	(274123, 120, '2014-04-01 00:24:12.000000', 'temperatura', 1149.0000, 'ºC'),
	(274124, 120, '2014-04-01 00:24:13.000000', 'temperatura', 530.0000, 'ºC'),
	(274125, 120, '2014-04-01 00:24:14.000000', 'temperatura', 404.0000, 'ºC'),
	(274126, 120, '2014-04-01 00:24:15.000000', 'temperatura', 430.0000, 'ºC'),
	(274127, 120, '2014-04-01 00:24:16.000000', 'temperatura', 939.0000, 'ºC'),
	(274128, 120, '2014-04-01 00:24:17.000000', 'temperatura', 1006.0000, 'ºC'),
	(274129, 120, '2014-04-01 00:24:18.000000', 'temperatura', 1015.0000, 'ºC'),
	(274130, 120, '2014-04-01 00:24:19.000000', 'temperatura', 854.0000, 'ºC'),
	(274131, 120, '2014-04-01 00:24:20.000000', 'temperatura', 27.0000, 'ºC'),
	(274132, 120, '2014-04-01 00:24:21.000000', 'temperatura', 1174.0000, 'ºC'),
	(274133, 120, '2014-04-01 00:24:22.000000', 'temperatura', 989.0000, 'ºC'),
	(274134, 120, '2014-04-01 00:24:23.000000', 'temperatura', 226.0000, 'ºC'),
	(274135, 120, '2014-04-01 00:24:24.000000', 'temperatura', 560.0000, 'ºC'),
	(274136, 120, '2014-04-01 00:24:25.000000', 'temperatura', 924.0000, 'ºC'),
	(274137, 120, '2014-04-01 00:24:26.000000', 'temperatura', 542.0000, 'ºC'),
	(274138, 120, '2014-04-01 00:24:27.000000', 'temperatura', 1135.0000, 'ºC'),
	(274139, 120, '2014-04-01 00:24:28.000000', 'temperatura', 453.0000, 'ºC'),
	(274140, 120, '2014-04-01 00:24:29.000000', 'temperatura', 59.0000, 'ºC'),
	(274141, 120, '2014-04-01 00:24:30.000000', 'temperatura', 137.0000, 'ºC'),
	(274142, 120, '2014-04-01 00:24:31.000000', 'temperatura', 509.0000, 'ºC'),
	(274143, 120, '2014-04-01 00:24:32.000000', 'temperatura', 933.0000, 'ºC'),
	(274144, 120, '2014-04-01 00:24:33.000000', 'temperatura', 739.0000, 'ºC'),
	(274145, 120, '2014-04-01 00:24:34.000000', 'temperatura', 896.0000, 'ºC'),
	(274146, 120, '2014-04-01 00:24:35.000000', 'temperatura', 1063.0000, 'ºC'),
	(274147, 120, '2014-04-01 00:24:36.000000', 'temperatura', 230.0000, 'ºC'),
	(274148, 120, '2014-04-01 00:24:37.000000', 'temperatura', 360.0000, 'ºC'),
	(274149, 120, '2014-04-01 00:24:38.000000', 'temperatura', 1110.0000, 'ºC'),
	(274150, 120, '2014-04-01 00:24:39.000000', 'temperatura', 871.0000, 'ºC'),
	(274151, 120, '2014-04-01 00:24:40.000000', 'temperatura', 1026.0000, 'ºC'),
	(274152, 120, '2014-04-01 00:24:41.000000', 'temperatura', 119.0000, 'ºC'),
	(274153, 120, '2014-04-01 00:24:42.000000', 'temperatura', 1114.0000, 'ºC'),
	(274154, 120, '2014-04-01 00:24:43.000000', 'temperatura', 416.0000, 'ºC'),
	(274155, 120, '2014-04-01 00:24:44.000000', 'temperatura', 1138.0000, 'ºC'),
	(274156, 120, '2014-04-01 00:24:45.000000', 'temperatura', 842.0000, 'ºC'),
	(274157, 120, '2014-04-01 00:24:46.000000', 'temperatura', 798.0000, 'ºC'),
	(274158, 120, '2014-04-01 00:24:47.000000', 'temperatura', 264.0000, 'ºC'),
	(274159, 120, '2014-04-01 00:24:48.000000', 'temperatura', 127.0000, 'ºC'),
	(274160, 120, '2014-04-01 00:24:49.000000', 'temperatura', 1042.0000, 'ºC'),
	(274161, 120, '2014-04-01 00:24:50.000000', 'temperatura', 30.0000, 'ºC'),
	(274162, 120, '2014-04-01 00:24:51.000000', 'temperatura', 626.0000, 'ºC'),
	(274163, 120, '2014-04-01 00:24:52.000000', 'temperatura', 641.0000, 'ºC'),
	(274164, 120, '2014-04-01 00:24:53.000000', 'temperatura', 128.0000, 'ºC'),
	(274165, 120, '2014-04-01 00:24:54.000000', 'temperatura', 1116.0000, 'ºC'),
	(274166, 120, '2014-04-01 00:24:55.000000', 'temperatura', 396.0000, 'ºC'),
	(274167, 120, '2014-04-01 00:24:56.000000', 'temperatura', 1032.0000, 'ºC'),
	(274168, 120, '2014-04-01 00:24:57.000000', 'temperatura', 371.0000, 'ºC'),
	(274169, 120, '2014-04-01 00:24:58.000000', 'temperatura', 1162.0000, 'ºC'),
	(274170, 120, '2014-04-01 00:24:59.000000', 'temperatura', 1095.0000, 'ºC'),
	(274171, 120, '2014-04-01 00:25:00.000000', 'temperatura', 793.0000, 'ºC'),
	(274172, 120, '2014-04-01 00:25:01.000000', 'temperatura', 678.0000, 'ºC'),
	(274173, 120, '2014-04-01 00:25:02.000000', 'temperatura', 1012.0000, 'ºC'),
	(274174, 120, '2014-04-01 00:25:03.000000', 'temperatura', 626.0000, 'ºC'),
	(274175, 120, '2014-04-01 00:25:04.000000', 'temperatura', 96.0000, 'ºC'),
	(274176, 120, '2014-04-01 00:25:05.000000', 'temperatura', 1000.0000, 'ºC'),
	(274177, 120, '2014-04-01 00:25:06.000000', 'temperatura', 1115.0000, 'ºC'),
	(274178, 120, '2014-04-01 00:25:07.000000', 'temperatura', 176.0000, 'ºC'),
	(274179, 120, '2014-04-01 00:25:08.000000', 'temperatura', 1134.0000, 'ºC'),
	(274180, 120, '2014-04-01 00:25:09.000000', 'temperatura', 341.0000, 'ºC'),
	(274181, 120, '2014-04-01 00:25:10.000000', 'temperatura', 704.0000, 'ºC'),
	(274182, 120, '2014-04-01 00:25:11.000000', 'temperatura', 97.0000, 'ºC'),
	(274183, 120, '2014-04-01 00:25:12.000000', 'temperatura', 774.0000, 'ºC'),
	(274184, 120, '2014-04-01 00:25:13.000000', 'temperatura', 1182.0000, 'ºC'),
	(274185, 120, '2014-04-01 00:25:14.000000', 'temperatura', 1185.0000, 'ºC'),
	(274186, 120, '2014-04-01 00:25:15.000000', 'temperatura', 1180.0000, 'ºC'),
	(274187, 120, '2014-04-01 00:25:16.000000', 'temperatura', 1147.0000, 'ºC'),
	(274188, 120, '2014-04-01 00:25:17.000000', 'temperatura', 996.0000, 'ºC'),
	(274189, 120, '2014-04-01 00:25:18.000000', 'temperatura', 339.0000, 'ºC'),
	(274190, 120, '2014-04-01 00:25:19.000000', 'temperatura', 1105.0000, 'ºC'),
	(274191, 120, '2014-04-01 00:25:20.000000', 'temperatura', 911.0000, 'ºC'),
	(274192, 120, '2014-04-01 00:25:21.000000', 'temperatura', 41.0000, 'ºC'),
	(274193, 120, '2014-04-01 00:25:22.000000', 'temperatura', 1070.0000, 'ºC'),
	(274194, 120, '2014-04-01 00:25:23.000000', 'temperatura', 430.0000, 'ºC'),
	(274195, 120, '2014-04-01 00:25:24.000000', 'temperatura', 139.0000, 'ºC'),
	(274196, 120, '2014-04-01 00:25:25.000000', 'temperatura', 608.0000, 'ºC'),
	(274197, 120, '2014-04-01 00:25:26.000000', 'temperatura', 222.0000, 'ºC'),
	(274198, 120, '2014-04-01 00:25:27.000000', 'temperatura', 485.0000, 'ºC'),
	(274199, 120, '2014-04-01 00:25:28.000000', 'temperatura', 561.0000, 'ºC'),
	(274200, 120, '2014-04-01 00:25:29.000000', 'temperatura', 150.0000, 'ºC'),
	(274201, 120, '2014-04-01 00:25:30.000000', 'temperatura', 268.0000, 'ºC'),
	(274202, 120, '2014-04-01 00:25:31.000000', 'temperatura', 890.0000, 'ºC'),
	(274203, 120, '2014-04-01 00:25:32.000000', 'temperatura', 47.0000, 'ºC'),
	(274204, 120, '2014-04-01 00:25:33.000000', 'temperatura', 1165.0000, 'ºC'),
	(274205, 120, '2014-04-01 00:25:34.000000', 'temperatura', 886.0000, 'ºC'),
	(274206, 120, '2014-04-01 00:25:35.000000', 'temperatura', 933.0000, 'ºC'),
	(274207, 120, '2014-04-01 00:25:36.000000', 'temperatura', 810.0000, 'ºC'),
	(274208, 120, '2014-04-01 00:25:37.000000', 'temperatura', 49.0000, 'ºC'),
	(274209, 120, '2014-04-01 00:25:38.000000', 'temperatura', 215.0000, 'ºC'),
	(274210, 120, '2014-04-01 00:25:39.000000', 'temperatura', 930.0000, 'ºC'),
	(274211, 120, '2014-04-01 00:25:40.000000', 'temperatura', 405.0000, 'ºC'),
	(274212, 120, '2014-04-01 00:25:41.000000', 'temperatura', 434.0000, 'ºC'),
	(274213, 120, '2014-04-01 00:25:42.000000', 'temperatura', 957.0000, 'ºC'),
	(274214, 120, '2014-04-01 00:25:43.000000', 'temperatura', 1084.0000, 'ºC'),
	(274215, 120, '2014-04-01 00:25:44.000000', 'temperatura', 150.0000, 'ºC'),
	(274216, 120, '2014-04-01 00:25:45.000000', 'temperatura', 1099.0000, 'ºC'),
	(274217, 120, '2014-04-01 00:25:46.000000', 'temperatura', 246.0000, 'ºC'),
	(274218, 120, '2014-04-01 00:25:47.000000', 'temperatura', 331.0000, 'ºC'),
	(274219, 120, '2014-04-01 00:25:48.000000', 'temperatura', 919.0000, 'ºC'),
	(274220, 120, '2014-04-01 00:25:49.000000', 'temperatura', 2.0000, 'ºC'),
	(274221, 120, '2014-04-01 00:25:50.000000', 'temperatura', 854.0000, 'ºC'),
	(274222, 120, '2014-04-01 00:25:51.000000', 'temperatura', 665.0000, 'ºC'),
	(274223, 120, '2014-04-01 00:25:52.000000', 'temperatura', 765.0000, 'ºC'),
	(274224, 120, '2014-04-01 00:25:53.000000', 'temperatura', 628.0000, 'ºC'),
	(274225, 120, '2014-04-01 00:25:54.000000', 'temperatura', 846.0000, 'ºC'),
	(274226, 120, '2014-04-01 00:25:55.000000', 'temperatura', 1148.0000, 'ºC'),
	(274227, 120, '2014-04-01 00:25:56.000000', 'temperatura', 800.0000, 'ºC'),
	(274228, 120, '2014-04-01 00:25:57.000000', 'temperatura', 556.0000, 'ºC'),
	(274229, 120, '2014-04-01 00:25:58.000000', 'temperatura', 384.0000, 'ºC'),
	(274230, 120, '2014-04-01 00:25:59.000000', 'temperatura', 249.0000, 'ºC'),
	(274231, 120, '2014-04-01 00:26:00.000000', 'temperatura', 96.0000, 'ºC'),
	(274232, 120, '2014-04-01 00:26:01.000000', 'temperatura', 931.0000, 'ºC'),
	(274233, 120, '2014-04-01 00:26:02.000000', 'temperatura', 767.0000, 'ºC'),
	(274234, 120, '2014-04-01 00:26:03.000000', 'temperatura', 1043.0000, 'ºC'),
	(274235, 120, '2014-04-01 00:26:04.000000', 'temperatura', 516.0000, 'ºC'),
	(274236, 120, '2014-04-01 00:26:05.000000', 'temperatura', 651.0000, 'ºC'),
	(274237, 120, '2014-04-01 00:26:06.000000', 'temperatura', 507.0000, 'ºC'),
	(274238, 120, '2014-04-01 00:26:07.000000', 'temperatura', 582.0000, 'ºC'),
	(274239, 120, '2014-04-01 00:26:08.000000', 'temperatura', 188.0000, 'ºC'),
	(274240, 120, '2014-04-01 00:26:09.000000', 'temperatura', 397.0000, 'ºC'),
	(274241, 120, '2014-04-01 00:26:10.000000', 'temperatura', 220.0000, 'ºC'),
	(274242, 120, '2014-04-01 00:26:11.000000', 'temperatura', 1111.0000, 'ºC'),
	(274243, 120, '2014-04-01 00:26:12.000000', 'temperatura', 95.0000, 'ºC'),
	(274244, 120, '2014-04-01 00:26:13.000000', 'temperatura', 741.0000, 'ºC'),
	(274245, 120, '2014-04-01 00:26:14.000000', 'temperatura', 1023.0000, 'ºC'),
	(274246, 120, '2014-04-01 00:26:15.000000', 'temperatura', 493.0000, 'ºC'),
	(274247, 120, '2014-04-01 00:26:16.000000', 'temperatura', 597.0000, 'ºC'),
	(274248, 120, '2014-04-01 00:26:17.000000', 'temperatura', 303.0000, 'ºC'),
	(274249, 120, '2014-04-01 00:26:18.000000', 'temperatura', 928.0000, 'ºC'),
	(274250, 120, '2014-04-01 00:26:19.000000', 'temperatura', 130.0000, 'ºC'),
	(274251, 120, '2014-04-01 00:26:20.000000', 'temperatura', 266.0000, 'ºC'),
	(274252, 120, '2014-04-01 00:26:21.000000', 'temperatura', 941.0000, 'ºC'),
	(274253, 120, '2014-04-01 00:26:22.000000', 'temperatura', 306.0000, 'ºC'),
	(274254, 120, '2014-04-01 00:26:23.000000', 'temperatura', 1110.0000, 'ºC'),
	(274255, 120, '2014-04-01 00:26:24.000000', 'temperatura', 1030.0000, 'ºC'),
	(274256, 120, '2014-04-01 00:26:25.000000', 'temperatura', 623.0000, 'ºC'),
	(274257, 120, '2014-04-01 00:26:26.000000', 'temperatura', 25.0000, 'ºC'),
	(274258, 120, '2014-04-01 00:26:27.000000', 'temperatura', 656.0000, 'ºC'),
	(274259, 120, '2014-04-01 00:26:28.000000', 'temperatura', 807.0000, 'ºC'),
	(274260, 120, '2014-04-01 00:26:29.000000', 'temperatura', 867.0000, 'ºC'),
	(274261, 120, '2014-04-01 00:26:30.000000', 'temperatura', 712.0000, 'ºC'),
	(274262, 120, '2014-04-01 00:26:31.000000', 'temperatura', 961.0000, 'ºC'),
	(274263, 120, '2014-04-01 00:26:32.000000', 'temperatura', 271.0000, 'ºC'),
	(274264, 120, '2014-04-01 00:26:33.000000', 'temperatura', 873.0000, 'ºC'),
	(274265, 120, '2014-04-01 00:26:34.000000', 'temperatura', 1154.0000, 'ºC'),
	(274266, 120, '2014-04-01 00:26:35.000000', 'temperatura', 748.0000, 'ºC'),
	(274267, 120, '2014-04-01 00:26:36.000000', 'temperatura', 279.0000, 'ºC'),
	(274268, 120, '2014-04-01 00:26:37.000000', 'temperatura', 351.0000, 'ºC'),
	(274269, 120, '2014-04-01 00:26:38.000000', 'temperatura', 917.0000, 'ºC'),
	(274270, 120, '2014-04-01 00:26:39.000000', 'temperatura', 1134.0000, 'ºC'),
	(274271, 120, '2014-04-01 00:26:40.000000', 'temperatura', 521.0000, 'ºC'),
	(274272, 120, '2014-04-01 00:26:41.000000', 'temperatura', 404.0000, 'ºC'),
	(274273, 120, '2014-04-01 00:26:42.000000', 'temperatura', 458.0000, 'ºC'),
	(274274, 120, '2014-04-01 00:26:43.000000', 'temperatura', 1079.0000, 'ºC'),
	(274275, 120, '2014-04-01 00:26:44.000000', 'temperatura', 419.0000, 'ºC'),
	(274276, 120, '2014-04-01 00:26:45.000000', 'temperatura', 61.0000, 'ºC'),
	(274277, 120, '2014-04-01 00:26:46.000000', 'temperatura', 246.0000, 'ºC'),
	(274278, 120, '2014-04-01 00:26:47.000000', 'temperatura', 1050.0000, 'ºC'),
	(274279, 120, '2014-04-01 00:26:48.000000', 'temperatura', 911.0000, 'ºC'),
	(274280, 120, '2014-04-01 00:26:49.000000', 'temperatura', 204.0000, 'ºC'),
	(274281, 120, '2014-04-01 00:26:50.000000', 'temperatura', 689.0000, 'ºC'),
	(274282, 120, '2014-04-01 00:26:51.000000', 'temperatura', 433.0000, 'ºC'),
	(274283, 120, '2014-04-01 00:26:52.000000', 'temperatura', 97.0000, 'ºC'),
	(274284, 120, '2014-04-01 00:26:53.000000', 'temperatura', 387.0000, 'ºC'),
	(274285, 120, '2014-04-01 00:26:54.000000', 'temperatura', 446.0000, 'ºC'),
	(274286, 120, '2014-04-01 00:26:55.000000', 'temperatura', 1067.0000, 'ºC'),
	(274287, 120, '2014-04-01 00:26:56.000000', 'temperatura', 397.0000, 'ºC'),
	(274288, 120, '2014-04-01 00:26:57.000000', 'temperatura', 1187.0000, 'ºC'),
	(274289, 120, '2014-04-01 00:26:58.000000', 'temperatura', 1145.0000, 'ºC'),
	(274290, 120, '2014-04-01 00:26:59.000000', 'temperatura', 962.0000, 'ºC'),
	(274291, 120, '2014-04-01 00:27:00.000000', 'temperatura', 176.0000, 'ºC'),
	(274292, 120, '2014-04-01 00:27:01.000000', 'temperatura', 396.0000, 'ºC'),
	(274293, 120, '2014-04-01 00:27:02.000000', 'temperatura', 250.0000, 'ºC'),
	(274294, 120, '2014-04-01 00:27:03.000000', 'temperatura', 65.0000, 'ºC'),
	(274295, 120, '2014-04-01 00:27:04.000000', 'temperatura', 777.0000, 'ºC'),
	(274296, 120, '2014-04-01 00:27:05.000000', 'temperatura', 87.0000, 'ºC'),
	(274297, 120, '2014-04-01 00:27:06.000000', 'temperatura', 507.0000, 'ºC'),
	(274298, 120, '2014-04-01 00:27:07.000000', 'temperatura', 1074.0000, 'ºC'),
	(274299, 120, '2014-04-01 00:27:08.000000', 'temperatura', 247.0000, 'ºC'),
	(274300, 120, '2014-04-01 00:27:09.000000', 'temperatura', 417.0000, 'ºC'),
	(274301, 120, '2014-04-01 00:27:10.000000', 'temperatura', 142.0000, 'ºC'),
	(274302, 120, '2014-04-01 00:27:11.000000', 'temperatura', 661.0000, 'ºC'),
	(274303, 120, '2014-04-01 00:27:12.000000', 'temperatura', 479.0000, 'ºC'),
	(274304, 120, '2014-04-01 00:27:13.000000', 'temperatura', 411.0000, 'ºC'),
	(274305, 120, '2014-04-01 00:27:14.000000', 'temperatura', 621.0000, 'ºC'),
	(274306, 120, '2014-04-01 00:27:15.000000', 'temperatura', 671.0000, 'ºC'),
	(274307, 120, '2014-04-01 00:27:16.000000', 'temperatura', 292.0000, 'ºC'),
	(274308, 120, '2014-04-01 00:27:17.000000', 'temperatura', 646.0000, 'ºC'),
	(274309, 120, '2014-04-01 00:27:18.000000', 'temperatura', 1157.0000, 'ºC'),
	(274310, 120, '2014-04-01 00:27:19.000000', 'temperatura', 246.0000, 'ºC'),
	(274311, 120, '2014-04-01 00:27:20.000000', 'temperatura', 162.0000, 'ºC'),
	(274312, 120, '2014-04-01 00:27:21.000000', 'temperatura', 71.0000, 'ºC'),
	(274313, 120, '2014-04-01 00:27:22.000000', 'temperatura', 1069.0000, 'ºC'),
	(274314, 120, '2014-04-01 00:27:23.000000', 'temperatura', 335.0000, 'ºC'),
	(274315, 120, '2014-04-01 00:27:24.000000', 'temperatura', 866.0000, 'ºC'),
	(274316, 120, '2014-04-01 00:27:25.000000', 'temperatura', 927.0000, 'ºC'),
	(274317, 120, '2014-04-01 00:27:26.000000', 'temperatura', 836.0000, 'ºC'),
	(274318, 120, '2014-04-01 00:27:27.000000', 'temperatura', 200.0000, 'ºC'),
	(274319, 120, '2014-04-01 00:27:28.000000', 'temperatura', 893.0000, 'ºC'),
	(274320, 120, '2014-04-01 00:27:29.000000', 'temperatura', 265.0000, 'ºC'),
	(274321, 120, '2014-04-01 00:27:30.000000', 'temperatura', 1046.0000, 'ºC'),
	(274322, 120, '2014-04-01 00:27:31.000000', 'temperatura', 835.0000, 'ºC'),
	(274323, 120, '2014-04-01 00:27:32.000000', 'temperatura', 1038.0000, 'ºC'),
	(274324, 120, '2014-04-01 00:27:33.000000', 'temperatura', 287.0000, 'ºC'),
	(274325, 120, '2014-04-01 00:27:34.000000', 'temperatura', 722.0000, 'ºC'),
	(274326, 120, '2014-04-01 00:27:35.000000', 'temperatura', 348.0000, 'ºC'),
	(274327, 120, '2014-04-01 00:27:36.000000', 'temperatura', 775.0000, 'ºC'),
	(274328, 120, '2014-04-01 00:27:37.000000', 'temperatura', 432.0000, 'ºC'),
	(274329, 120, '2014-04-01 00:27:38.000000', 'temperatura', 1037.0000, 'ºC'),
	(274330, 120, '2014-04-01 00:27:39.000000', 'temperatura', 287.0000, 'ºC'),
	(274331, 120, '2014-04-01 00:27:40.000000', 'temperatura', 727.0000, 'ºC'),
	(274332, 120, '2014-04-01 00:27:41.000000', 'temperatura', 375.0000, 'ºC'),
	(274333, 120, '2014-04-01 00:27:42.000000', 'temperatura', 892.0000, 'ºC'),
	(274334, 120, '2014-04-01 00:27:43.000000', 'temperatura', 935.0000, 'ºC'),
	(274335, 120, '2014-04-01 00:27:44.000000', 'temperatura', 801.0000, 'ºC'),
	(274336, 120, '2014-04-01 00:27:45.000000', 'temperatura', 1.0000, 'ºC'),
	(274337, 120, '2014-04-01 00:27:46.000000', 'temperatura', 2.0000, 'ºC'),
	(274338, 120, '2014-04-01 00:27:47.000000', 'temperatura', 6.0000, 'ºC'),
	(274339, 120, '2014-04-01 00:27:48.000000', 'temperatura', 25.0000, 'ºC'),
	(274340, 120, '2014-04-01 00:27:49.000000', 'temperatura', 108.0000, 'ºC'),
	(274341, 120, '2014-04-01 00:27:50.000000', 'temperatura', 466.0000, 'ºC'),
	(274342, 120, '2014-04-01 00:27:51.000000', 'temperatura', 804.0000, 'ºC'),
	(274343, 120, '2014-04-01 00:27:52.000000', 'temperatura', 224.0000, 'ºC'),
	(274344, 120, '2014-04-01 00:27:53.000000', 'temperatura', 1109.0000, 'ºC'),
	(274345, 120, '2014-04-01 00:27:54.000000', 'temperatura', 71.0000, 'ºC'),
	(274346, 120, '2014-04-01 00:27:55.000000', 'temperatura', 631.0000, 'ºC'),
	(274347, 120, '2014-04-01 00:27:56.000000', 'temperatura', 541.0000, 'ºC'),
	(274348, 120, '2014-04-01 00:27:57.000000', 'temperatura', 811.0000, 'ºC'),
	(274349, 120, '2014-04-01 00:27:58.000000', 'temperatura', 36.0000, 'ºC'),
	(274350, 120, '2014-04-01 00:27:59.000000', 'temperatura', 144.0000, 'ºC'),
	(274351, 120, '2014-04-01 00:28:00.000000', 'temperatura', 615.0000, 'ºC'),
	(274352, 120, '2014-04-01 00:28:01.000000', 'temperatura', 245.0000, 'ºC'),
	(274353, 120, '2014-04-01 00:28:02.000000', 'temperatura', 578.0000, 'ºC'),
	(274354, 120, '2014-04-01 00:28:03.000000', 'temperatura', 956.0000, 'ºC'),
	(274355, 120, '2014-04-01 00:28:04.000000', 'temperatura', 646.0000, 'ºC'),
	(274356, 120, '2014-04-01 00:28:05.000000', 'temperatura', 361.0000, 'ºC'),
	(274357, 120, '2014-04-01 00:28:06.000000', 'temperatura', 1070.0000, 'ºC'),
	(274358, 120, '2014-04-01 00:28:07.000000', 'temperatura', 668.0000, 'ºC'),
	(274359, 120, '2014-04-01 00:28:08.000000', 'temperatura', 129.0000, 'ºC'),
	(274360, 120, '2014-04-01 00:28:09.000000', 'temperatura', 1041.0000, 'ºC'),
	(274361, 120, '2014-04-01 00:28:10.000000', 'temperatura', 18.0000, 'ºC'),
	(274362, 120, '2014-04-01 00:28:11.000000', 'temperatura', 569.0000, 'ºC'),
	(274363, 120, '2014-04-01 00:28:12.000000', 'temperatura', 390.0000, 'ºC'),
	(274364, 120, '2014-04-01 00:28:13.000000', 'temperatura', 242.0000, 'ºC'),
	(274365, 120, '2014-04-01 00:28:14.000000', 'temperatura', 43.0000, 'ºC'),
	(274366, 120, '2014-04-01 00:28:15.000000', 'temperatura', 688.0000, 'ºC'),
	(274367, 120, '2014-04-01 00:28:16.000000', 'temperatura', 911.0000, 'ºC'),
	(274368, 120, '2014-04-01 00:28:17.000000', 'temperatura', 91.0000, 'ºC'),
	(274369, 120, '2014-04-01 00:28:18.000000', 'temperatura', 121.0000, 'ºC'),
	(274370, 120, '2014-04-01 00:28:19.000000', 'temperatura', 336.0000, 'ºC'),
	(274371, 120, '2014-04-01 00:28:20.000000', 'temperatura', 117.0000, 'ºC'),
	(274372, 120, '2014-04-01 00:28:21.000000', 'temperatura', 778.0000, 'ºC'),
	(274373, 120, '2014-04-01 00:28:22.000000', 'temperatura', 1139.0000, 'ºC'),
	(274374, 120, '2014-04-01 00:28:23.000000', 'temperatura', 962.0000, 'ºC'),
	(274375, 120, '2014-04-01 00:28:24.000000', 'temperatura', 195.0000, 'ºC'),
	(274376, 120, '2014-04-01 00:28:25.000000', 'temperatura', 487.0000, 'ºC'),
	(274377, 120, '2014-04-01 00:28:26.000000', 'temperatura', 650.0000, 'ºC'),
	(274378, 120, '2014-04-01 00:28:27.000000', 'temperatura', 589.0000, 'ºC'),
	(274379, 120, '2014-04-01 00:28:28.000000', 'temperatura', 995.0000, 'ºC'),
	(274380, 120, '2014-04-01 00:28:29.000000', 'temperatura', 808.0000, 'ºC'),
	(274381, 120, '2014-04-01 00:28:30.000000', 'temperatura', 1055.0000, 'ºC'),
	(274382, 120, '2014-04-01 00:28:31.000000', 'temperatura', 453.0000, 'ºC'),
	(274383, 120, '2014-04-01 00:28:32.000000', 'temperatura', 300.0000, 'ºC'),
	(274384, 120, '2014-04-01 00:28:33.000000', 'temperatura', 144.0000, 'ºC'),
	(274385, 120, '2014-04-01 00:28:34.000000', 'temperatura', 1017.0000, 'ºC'),
	(274386, 120, '2014-04-01 00:28:35.000000', 'temperatura', 1056.0000, 'ºC'),
	(274387, 120, '2014-04-01 00:28:36.000000', 'temperatura', 1028.0000, 'ºC'),
	(274388, 120, '2014-04-01 00:28:37.000000', 'temperatura', 773.0000, 'ºC'),
	(274389, 120, '2014-04-01 00:28:38.000000', 'temperatura', 783.0000, 'ºC'),
	(274390, 120, '2014-04-01 00:28:39.000000', 'temperatura', 393.0000, 'ºC'),
	(274391, 120, '2014-04-01 00:28:40.000000', 'temperatura', 820.0000, 'ºC'),
	(274392, 120, '2014-04-01 00:28:41.000000', 'temperatura', 521.0000, 'ºC'),
	(274393, 120, '2014-04-01 00:28:42.000000', 'temperatura', 145.0000, 'ºC'),
	(274394, 120, '2014-04-01 00:28:43.000000', 'temperatura', 363.0000, 'ºC'),
	(274395, 120, '2014-04-01 00:28:44.000000', 'temperatura', 178.0000, 'ºC'),
	(274396, 120, '2014-04-01 00:28:45.000000', 'temperatura', 1003.0000, 'ºC'),
	(274397, 120, '2014-04-01 00:28:46.000000', 'temperatura', 882.0000, 'ºC'),
	(274398, 120, '2014-04-01 00:28:47.000000', 'temperatura', 200.0000, 'ºC'),
	(274399, 120, '2014-04-01 00:28:48.000000', 'temperatura', 755.0000, 'ºC'),
	(274400, 120, '2014-04-01 00:28:49.000000', 'temperatura', 776.0000, 'ºC'),
	(274401, 120, '2014-04-01 00:28:50.000000', 'temperatura', 416.0000, 'ºC'),
	(274402, 120, '2014-04-01 00:28:51.000000', 'temperatura', 952.0000, 'ºC'),
	(274403, 120, '2014-04-01 00:28:52.000000', 'temperatura', 1114.0000, 'ºC'),
	(274404, 120, '2014-04-01 00:28:53.000000', 'temperatura', 313.0000, 'ºC'),
	(274405, 120, '2014-04-01 00:28:54.000000', 'temperatura', 623.0000, 'ºC'),
	(274406, 120, '2014-04-01 00:28:55.000000', 'temperatura', 979.0000, 'ºC'),
	(274407, 120, '2014-04-01 00:28:56.000000', 'temperatura', 625.0000, 'ºC'),
	(274408, 120, '2014-04-01 00:28:57.000000', 'temperatura', 187.0000, 'ºC'),
	(274409, 120, '2014-04-01 00:28:58.000000', 'temperatura', 261.0000, 'ºC'),
	(274410, 120, '2014-04-01 00:28:59.000000', 'temperatura', 744.0000, 'ºC'),
	(274411, 120, '2014-04-01 00:29:00.000000', 'temperatura', 540.0000, 'ºC'),
	(274412, 120, '2014-04-01 00:29:01.000000', 'temperatura', 466.0000, 'ºC'),
	(274413, 120, '2014-04-01 00:29:02.000000', 'temperatura', 711.0000, 'ºC'),
	(274414, 120, '2014-04-01 00:29:03.000000', 'temperatura', 959.0000, 'ºC'),
	(274415, 120, '2014-04-01 00:29:04.000000', 'temperatura', 261.0000, 'ºC'),
	(274416, 120, '2014-04-01 00:29:05.000000', 'temperatura', 831.0000, 'ºC'),
	(274417, 120, '2014-04-01 00:29:06.000000', 'temperatura', 970.0000, 'ºC'),
	(274418, 120, '2014-04-01 00:29:07.000000', 'temperatura', 1157.0000, 'ºC'),
	(274419, 120, '2014-04-01 00:29:08.000000', 'temperatura', 475.0000, 'ºC'),
	(274420, 120, '2014-04-01 00:29:09.000000', 'temperatura', 103.0000, 'ºC'),
	(274421, 120, '2014-04-01 00:29:10.000000', 'temperatura', 294.0000, 'ºC'),
	(274422, 120, '2014-04-01 00:29:11.000000', 'temperatura', 1162.0000, 'ºC'),
	(274423, 120, '2014-04-01 00:29:12.000000', 'temperatura', 126.0000, 'ºC'),
	(274424, 120, '2014-04-01 00:29:13.000000', 'temperatura', 743.0000, 'ºC'),
	(274425, 120, '2014-04-01 00:29:14.000000', 'temperatura', 940.0000, 'ºC'),
	(274426, 120, '2014-04-01 00:29:15.000000', 'temperatura', 73.0000, 'ºC'),
	(274427, 120, '2014-04-01 00:29:16.000000', 'temperatura', 1143.0000, 'ºC'),
	(274428, 120, '2014-04-01 00:29:17.000000', 'temperatura', 697.0000, 'ºC'),
	(274429, 120, '2014-04-01 00:29:18.000000', 'temperatura', 58.0000, 'ºC'),
	(274430, 120, '2014-04-01 00:29:19.000000', 'temperatura', 600.0000, 'ºC'),
	(274431, 120, '2014-04-01 00:29:20.000000', 'temperatura', 427.0000, 'ºC'),
	(274432, 120, '2014-04-01 00:29:21.000000', 'temperatura', 333.0000, 'ºC'),
	(274433, 120, '2014-04-01 00:29:22.000000', 'temperatura', 385.0000, 'ºC'),
	(274434, 120, '2014-04-01 00:29:23.000000', 'temperatura', 928.0000, 'ºC'),
	(274435, 120, '2014-04-01 00:29:24.000000', 'temperatura', 1085.0000, 'ºC'),
	(274436, 120, '2014-04-01 00:29:25.000000', 'temperatura', 240.0000, 'ºC'),
	(274437, 120, '2014-04-01 00:29:26.000000', 'temperatura', 345.0000, 'ºC'),
	(274438, 120, '2014-04-01 00:29:27.000000', 'temperatura', 1008.0000, 'ºC'),
	(274439, 120, '2014-04-01 00:29:28.000000', 'temperatura', 403.0000, 'ºC'),
	(274440, 120, '2014-04-01 00:29:29.000000', 'temperatura', 193.0000, 'ºC'),
	(274441, 120, '2014-04-01 00:29:30.000000', 'temperatura', 955.0000, 'ºC'),
	(274442, 120, '2014-04-01 00:29:31.000000', 'temperatura', 595.0000, 'ºC'),
	(274443, 120, '2014-04-01 00:29:32.000000', 'temperatura', 113.0000, 'ºC'),
	(274444, 120, '2014-04-01 00:29:33.000000', 'temperatura', 1180.0000, 'ºC'),
	(274445, 120, '2014-04-01 00:29:34.000000', 'temperatura', 761.0000, 'ºC'),
	(274446, 120, '2014-04-01 00:29:35.000000', 'temperatura', 267.0000, 'ºC'),
	(274447, 120, '2014-04-01 00:29:36.000000', 'temperatura', 250.0000, 'ºC'),
	(274448, 120, '2014-04-01 00:29:37.000000', 'temperatura', 452.0000, 'ºC'),
	(274449, 120, '2014-04-01 00:29:38.000000', 'temperatura', 307.0000, 'ºC'),
	(274450, 120, '2014-04-01 00:29:39.000000', 'temperatura', 183.0000, 'ºC'),
	(274451, 120, '2014-04-01 00:29:40.000000', 'temperatura', 1194.0000, 'ºC'),
	(274452, 120, '2014-04-01 00:29:41.000000', 'temperatura', 621.0000, 'ºC'),
	(274453, 120, '2014-04-01 00:29:42.000000', 'temperatura', 722.0000, 'ºC'),
	(274454, 120, '2014-04-01 00:29:43.000000', 'temperatura', 549.0000, 'ºC'),
	(274455, 120, '2014-04-01 00:29:44.000000', 'temperatura', 578.0000, 'ºC'),
	(274456, 120, '2014-04-01 00:29:45.000000', 'temperatura', 43.0000, 'ºC'),
	(274457, 120, '2014-04-01 00:29:46.000000', 'temperatura', 883.0000, 'ºC'),
	(274458, 120, '2014-04-01 00:29:47.000000', 'temperatura', 685.0000, 'ºC'),
	(274459, 120, '2014-04-01 00:29:48.000000', 'temperatura', 778.0000, 'ºC'),
	(274460, 120, '2014-04-01 00:29:49.000000', 'temperatura', 634.0000, 'ºC'),
	(274461, 120, '2014-04-01 00:29:50.000000', 'temperatura', 839.0000, 'ºC'),
	(274462, 120, '2014-04-01 00:29:51.000000', 'temperatura', 1093.0000, 'ºC'),
	(274463, 120, '2014-04-01 00:29:52.000000', 'temperatura', 548.0000, 'ºC'),
	(274464, 120, '2014-04-01 00:29:53.000000', 'temperatura', 660.0000, 'ºC'),
	(274465, 120, '2014-04-01 00:29:54.000000', 'temperatura', 458.0000, 'ºC'),
	(274466, 120, '2014-04-01 00:29:55.000000', 'temperatura', 309.0000, 'ºC'),
	(274467, 120, '2014-04-01 00:29:56.000000', 'temperatura', 173.0000, 'ºC'),
	(274468, 120, '2014-04-01 00:29:57.000000', 'temperatura', 1140.0000, 'ºC'),
	(274469, 120, '2014-04-01 00:29:58.000000', 'temperatura', 380.0000, 'ºC'),
	(274470, 120, '2014-04-01 00:29:59.000000', 'temperatura', 882.0000, 'ºC'),
	(274471, 120, '2014-04-01 00:30:00.000000', 'temperatura', 871.0000, 'ºC'),
	(274472, 120, '2014-04-01 00:30:01.000000', 'temperatura', 510.0000, 'ºC'),
	(274473, 120, '2014-04-01 00:30:02.000000', 'temperatura', 1138.0000, 'ºC'),
	(274474, 120, '2014-04-01 00:30:03.000000', 'temperatura', 559.0000, 'ºC'),
	(274475, 120, '2014-04-01 00:30:04.000000', 'temperatura', 581.0000, 'ºC'),
	(274476, 120, '2014-04-01 00:30:05.000000', 'temperatura', 31.0000, 'ºC'),
	(274477, 120, '2014-04-01 00:30:06.000000', 'temperatura', 811.0000, 'ºC'),
	(274478, 120, '2014-04-01 00:30:07.000000', 'temperatura', 361.0000, 'ºC'),
	(274479, 120, '2014-04-01 00:30:08.000000', 'temperatura', 573.0000, 'ºC'),
	(274480, 120, '2014-04-01 00:30:09.000000', 'temperatura', 584.0000, 'ºC'),
	(274481, 120, '2014-04-01 00:30:10.000000', 'temperatura', 2.0000, 'ºC'),
	(274482, 120, '2014-04-01 00:30:11.000000', 'temperatura', 657.0000, 'ºC'),
	(274483, 120, '2014-04-01 00:30:12.000000', 'temperatura', 879.0000, 'ºC'),
	(274484, 120, '2014-04-01 00:30:13.000000', 'temperatura', 23.0000, 'ºC'),
	(274485, 120, '2014-04-01 00:30:14.000000', 'temperatura', 1082.0000, 'ºC'),
	(274486, 120, '2014-04-01 00:30:15.000000', 'temperatura', 539.0000, 'ºC'),
	(274487, 120, '2014-04-01 00:30:16.000000', 'temperatura', 649.0000, 'ºC'),
	(274488, 120, '2014-04-01 00:30:17.000000', 'temperatura', 428.0000, 'ºC'),
	(274489, 120, '2014-04-01 00:30:18.000000', 'temperatura', 196.0000, 'ºC'),
	(274490, 120, '2014-04-01 00:30:19.000000', 'temperatura', 895.0000, 'ºC'),
	(274491, 120, '2014-04-01 00:30:20.000000', 'temperatura', 286.0000, 'ºC'),
	(274492, 120, '2014-04-01 00:30:21.000000', 'temperatura', 1146.0000, 'ºC'),
	(274493, 120, '2014-04-01 00:30:22.000000', 'temperatura', 73.0000, 'ºC'),
	(274494, 120, '2014-04-01 00:30:23.000000', 'temperatura', 526.0000, 'ºC'),
	(274495, 120, '2014-04-01 00:30:24.000000', 'temperatura', 15.0000, 'ºC'),
	(274496, 120, '2014-04-01 00:30:25.000000', 'temperatura', 894.0000, 'ºC'),
	(274497, 120, '2014-04-01 00:30:26.000000', 'temperatura', 826.0000, 'ºC'),
	(274498, 120, '2014-04-01 00:30:27.000000', 'temperatura', 250.0000, 'ºC'),
	(274499, 120, '2014-04-01 00:30:28.000000', 'temperatura', 1172.0000, 'ºC'),
	(274500, 120, '2014-04-01 00:30:29.000000', 'temperatura', 309.0000, 'ºC'),
	(274501, 120, '2014-04-01 00:30:30.000000', 'temperatura', 429.0000, 'ºC'),
	(274502, 120, '2014-04-01 00:30:31.000000', 'temperatura', 20.0000, 'ºC'),
	(274503, 120, '2014-04-01 00:30:32.000000', 'temperatura', 14.0000, 'ºC'),
	(274504, 120, '2014-04-01 00:30:33.000000', 'temperatura', 11.0000, 'ºC'),
	(274505, 120, '2014-04-01 00:30:34.000000', 'temperatura', 13.0000, 'ºC'),
	(274506, 120, '2014-04-01 00:30:35.000000', 'temperatura', 33.0000, 'ºC'),
	(274507, 120, '2014-04-01 00:30:36.000000', 'temperatura', 125.0000, 'ºC'),
	(274508, 120, '2014-04-01 00:30:37.000000', 'temperatura', 528.0000, 'ºC'),
	(274509, 120, '2014-04-01 00:30:38.000000', 'temperatura', 1065.0000, 'ºC'),
	(274510, 120, '2014-04-01 00:30:39.000000', 'temperatura', 143.0000, 'ºC'),
	(274511, 120, '2014-04-01 00:30:40.000000', 'temperatura', 1121.0000, 'ºC'),
	(274512, 120, '2014-04-01 00:30:41.000000', 'temperatura', 374.0000, 'ºC'),
	(274513, 120, '2014-04-01 00:30:42.000000', 'temperatura', 907.0000, 'ºC'),
	(274514, 120, '2014-04-01 00:30:43.000000', 'temperatura', 1014.0000, 'ºC'),
	(274515, 120, '2014-04-01 00:30:44.000000', 'temperatura', 1152.0000, 'ºC'),
	(274516, 120, '2014-04-01 00:30:45.000000', 'temperatura', 316.0000, 'ºC'),
	(274517, 120, '2014-04-01 00:30:46.000000', 'temperatura', 526.0000, 'ºC'),
	(274518, 120, '2014-04-01 00:30:47.000000', 'temperatura', 482.0000, 'ºC'),
	(274519, 120, '2014-04-01 00:30:48.000000', 'temperatura', 833.0000, 'ºC'),
	(274520, 120, '2014-04-01 00:30:49.000000', 'temperatura', 319.0000, 'ºC'),
	(274521, 120, '2014-04-01 00:30:50.000000', 'temperatura', 296.0000, 'ºC'),
	(274522, 120, '2014-04-01 00:30:51.000000', 'temperatura', 525.0000, 'ºC'),
	(274523, 120, '2014-04-01 00:30:52.000000', 'temperatura', 536.0000, 'ºC'),
	(274524, 120, '2014-04-01 00:30:53.000000', 'temperatura', 1107.0000, 'ºC'),
	(274525, 120, '2014-04-01 00:30:54.000000', 'temperatura', 325.0000, 'ºC'),
	(274526, 120, '2014-04-01 00:30:55.000000', 'temperatura', 708.0000, 'ºC'),
	(274527, 120, '2014-04-01 00:30:56.000000', 'temperatura', 163.0000, 'ºC'),
	(274528, 120, '2014-04-01 00:30:57.000000', 'temperatura', 1093.0000, 'ºC'),
	(274529, 120, '2014-04-01 00:30:58.000000', 'temperatura', 177.0000, 'ºC'),
	(274530, 120, '2014-04-01 00:30:59.000000', 'temperatura', 8.0000, 'ºC'),
	(274531, 120, '2014-04-01 00:31:00.000000', 'temperatura', 706.0000, 'ºC'),
	(274532, 120, '2014-04-01 00:31:01.000000', 'temperatura', 1110.0000, 'ºC'),
	(274533, 120, '2014-04-01 00:31:02.000000', 'temperatura', 1030.0000, 'ºC'),
	(274534, 120, '2014-04-01 00:31:03.000000', 'temperatura', 619.0000, 'ºC'),
	(274535, 120, '2014-04-01 00:31:04.000000', 'temperatura', 9.0000, 'ºC'),
	(274536, 120, '2014-04-01 00:31:05.000000', 'temperatura', 588.0000, 'ºC'),
	(274537, 120, '2014-04-01 00:31:06.000000', 'temperatura', 511.0000, 'ºC'),
	(274538, 120, '2014-04-01 00:31:07.000000', 'temperatura', 792.0000, 'ºC'),
	(274539, 120, '2014-04-01 00:31:08.000000', 'temperatura', 30.0000, 'ºC'),
	(274540, 120, '2014-04-01 00:31:09.000000', 'temperatura', 171.0000, 'ºC'),
	(274541, 120, '2014-04-01 00:31:10.000000', 'temperatura', 768.0000, 'ºC'),
	(274542, 120, '2014-04-01 00:31:11.000000', 'temperatura', 929.0000, 'ºC'),
	(274543, 120, '2014-04-01 00:31:12.000000', 'temperatura', 1139.0000, 'ºC'),
	(274544, 120, '2014-04-01 00:31:13.000000', 'temperatura', 508.0000, 'ºC'),
	(274545, 120, '2014-04-01 00:31:14.000000', 'temperatura', 324.0000, 'ºC'),
	(274546, 120, '2014-04-01 00:31:15.000000', 'temperatura', 99.0000, 'ºC'),
	(274547, 120, '2014-04-01 00:31:16.000000', 'temperatura', 721.0000, 'ºC'),
	(274548, 120, '2014-04-01 00:31:17.000000', 'temperatura', 907.0000, 'ºC'),
	(274549, 120, '2014-04-01 00:31:18.000000', 'temperatura', 1175.0000, 'ºC'),
	(274550, 120, '2014-04-01 00:31:19.000000', 'temperatura', 755.0000, 'ºC'),
	(274551, 120, '2014-04-01 00:31:20.000000', 'temperatura', 249.0000, 'ºC'),
	(274552, 120, '2014-04-01 00:31:21.000000', 'temperatura', 182.0000, 'ºC'),
	(274553, 120, '2014-04-01 00:31:22.000000', 'temperatura', 164.0000, 'ºC'),
	(274554, 120, '2014-04-01 00:31:23.000000', 'temperatura', 275.0000, 'ºC'),
	(274555, 120, '2014-04-01 00:31:24.000000', 'temperatura', 884.0000, 'ºC'),
	(274556, 120, '2014-04-01 00:31:25.000000', 'temperatura', 1194.0000, 'ºC'),
	(274557, 120, '2014-04-01 00:31:26.000000', 'temperatura', 918.0000, 'ºC'),
	(274558, 120, '2014-04-01 00:31:27.000000', 'temperatura', 1007.0000, 'ºC'),
	(274559, 120, '2014-04-01 00:31:28.000000', 'temperatura', 1085.0000, 'ºC'),
	(274560, 120, '2014-04-01 00:31:29.000000', 'temperatura', 1.0000, 'ºC'),
	(274561, 120, '2014-04-01 00:31:30.000000', 'temperatura', 354.0000, 'ºC'),
	(274562, 120, '2014-04-01 00:31:31.000000', 'temperatura', 565.0000, 'ºC'),
	(274563, 120, '2014-04-01 00:31:32.000000', 'temperatura', 563.0000, 'ºC'),
	(274564, 120, '2014-04-01 00:31:33.000000', 'temperatura', 1122.0000, 'ºC'),
	(274565, 120, '2014-04-01 00:31:34.000000', 'temperatura', 320.0000, 'ºC'),
	(274566, 120, '2014-04-01 00:31:35.000000', 'temperatura', 635.0000, 'ºC'),
	(274567, 120, '2014-04-01 00:31:36.000000', 'temperatura', 1015.0000, 'ºC'),
	(274568, 120, '2014-04-01 00:31:37.000000', 'temperatura', 770.0000, 'ºC'),
	(274569, 120, '2014-04-01 00:31:38.000000', 'temperatura', 806.0000, 'ºC'),
	(274570, 120, '2014-04-01 00:31:39.000000', 'temperatura', 522.0000, 'ºC'),
	(274571, 120, '2014-04-01 00:31:40.000000', 'temperatura', 191.0000, 'ºC'),
	(274572, 120, '2014-04-01 00:31:41.000000', 'temperatura', 590.0000, 'ºC'),
	(274573, 120, '2014-04-01 00:31:42.000000', 'temperatura', 1176.0000, 'ºC'),
	(274574, 120, '2014-04-01 00:31:43.000000', 'temperatura', 513.0000, 'ºC'),
	(274575, 120, '2014-04-01 00:31:44.000000', 'temperatura', 235.0000, 'ºC'),
	(274576, 120, '2014-04-01 00:31:45.000000', 'temperatura', 839.0000, 'ºC'),
	(274577, 120, '2014-04-01 00:31:46.000000', 'temperatura', 1091.0000, 'ºC'),
	(274578, 120, '2014-04-01 00:31:47.000000', 'temperatura', 539.0000, 'ºC'),
	(274579, 120, '2014-04-01 00:31:48.000000', 'temperatura', 622.0000, 'ºC'),
	(274580, 120, '2014-04-01 00:31:49.000000', 'temperatura', 293.0000, 'ºC'),
	(274581, 120, '2014-04-01 00:31:50.000000', 'temperatura', 798.0000, 'ºC'),
	(274582, 120, '2014-04-01 00:31:51.000000', 'temperatura', 714.0000, 'ºC'),
	(274583, 120, '2014-04-01 00:31:52.000000', 'temperatura', 1176.0000, 'ºC'),
	(274584, 120, '2014-04-01 00:31:53.000000', 'temperatura', 137.0000, 'ºC'),
	(274585, 120, '2014-04-01 00:31:54.000000', 'temperatura', 759.0000, 'ºC'),
	(274586, 120, '2014-04-01 00:31:55.000000', 'temperatura', 985.0000, 'ºC'),
	(274587, 120, '2014-04-01 00:31:56.000000', 'temperatura', 249.0000, 'ºC'),
	(274588, 120, '2014-04-01 00:31:57.000000', 'temperatura', 691.0000, 'ºC'),
	(274589, 120, '2014-04-01 00:31:58.000000', 'temperatura', 308.0000, 'ºC'),
	(274590, 120, '2014-04-01 00:31:59.000000', 'temperatura', 665.0000, 'ºC'),
	(274591, 120, '2014-04-01 00:32:00.000000', 'temperatura', 3.0000, 'ºC'),
	(274592, 120, '2014-04-01 00:32:01.000000', 'temperatura', 422.0000, 'ºC'),
	(274593, 120, '2014-04-01 00:32:02.000000', 'temperatura', 899.0000, 'ºC'),
	(274594, 120, '2014-04-01 00:32:03.000000', 'temperatura', 832.0000, 'ºC'),
	(274595, 120, '2014-04-01 00:32:04.000000', 'temperatura', 263.0000, 'ºC'),
	(274596, 120, '2014-04-01 00:32:05.000000', 'temperatura', 20.0000, 'ºC'),
	(274597, 120, '2014-04-01 00:32:06.000000', 'temperatura', 511.0000, 'ºC'),
	(274598, 120, '2014-04-01 00:32:07.000000', 'temperatura', 93.0000, 'ºC'),
	(274599, 120, '2014-04-01 00:32:08.000000', 'temperatura', 136.0000, 'ºC'),
	(274600, 120, '2014-04-01 00:32:09.000000', 'temperatura', 399.0000, 'ºC'),
	(274601, 120, '2014-04-01 00:32:10.000000', 'temperatura', 389.0000, 'ºC'),
	(274602, 120, '2014-04-01 00:32:11.000000', 'temperatura', 747.0000, 'ºC'),
	(274603, 120, '2014-04-01 00:32:12.000000', 'temperatura', 169.0000, 'ºC'),
	(274604, 120, '2014-04-01 00:32:13.000000', 'temperatura', 1005.0000, 'ºC'),
	(274605, 120, '2014-04-01 00:32:14.000000', 'temperatura', 918.0000, 'ºC'),
	(274606, 120, '2014-04-01 00:32:15.000000', 'temperatura', 374.0000, 'ºC'),
	(274607, 120, '2014-04-01 00:32:16.000000', 'temperatura', 318.0000, 'ºC'),
	(274608, 120, '2014-04-01 00:32:17.000000', 'temperatura', 467.0000, 'ºC'),
	(274609, 120, '2014-04-01 00:32:18.000000', 'temperatura', 182.0000, 'ºC'),
	(274610, 120, '2014-04-01 00:32:19.000000', 'temperatura', 712.0000, 'ºC'),
	(274611, 120, '2014-04-01 00:32:20.000000', 'temperatura', 613.0000, 'ºC'),
	(274612, 120, '2014-04-01 00:32:21.000000', 'temperatura', 928.0000, 'ºC'),
	(274613, 120, '2014-04-01 00:32:22.000000', 'temperatura', 401.0000, 'ºC'),
	(274614, 120, '2014-04-01 00:32:23.000000', 'temperatura', 422.0000, 'ºC'),
	(274615, 120, '2014-04-01 00:32:24.000000', 'temperatura', 908.0000, 'ºC'),
	(274616, 120, '2014-04-01 00:32:25.000000', 'temperatura', 875.0000, 'ºC'),
	(274617, 120, '2014-04-01 00:32:26.000000', 'temperatura', 452.0000, 'ºC'),
	(274618, 120, '2014-04-01 00:32:27.000000', 'temperatura', 837.0000, 'ºC'),
	(274619, 120, '2014-04-01 00:32:28.000000', 'temperatura', 427.0000, 'ºC'),
	(274620, 120, '2014-04-01 00:32:29.000000', 'temperatura', 823.0000, 'ºC'),
	(274621, 120, '2014-04-01 00:32:30.000000', 'temperatura', 437.0000, 'ºC'),
	(274622, 120, '2014-04-01 00:32:31.000000', 'temperatura', 916.0000, 'ºC'),
	(274623, 120, '2014-04-01 00:32:32.000000', 'temperatura', 868.0000, 'ºC'),
	(274624, 120, '2014-04-01 00:32:33.000000', 'temperatura', 394.0000, 'ºC'),
	(274625, 120, '2014-04-01 00:32:34.000000', 'temperatura', 566.0000, 'ºC'),
	(274626, 120, '2014-04-01 00:32:35.000000', 'temperatura', 450.0000, 'ºC'),
	(274627, 120, '2014-04-01 00:32:36.000000', 'temperatura', 552.0000, 'ºC'),
	(274628, 120, '2014-04-01 00:32:37.000000', 'temperatura', 211.0000, 'ºC'),
	(274629, 120, '2014-04-01 00:32:38.000000', 'temperatura', 599.0000, 'ºC'),
	(274630, 120, '2014-04-01 00:32:39.000000', 'temperatura', 1161.0000, 'ºC'),
	(274631, 120, '2014-04-01 00:32:40.000000', 'temperatura', 411.0000, 'ºC'),
	(274632, 120, '2014-04-01 00:32:41.000000', 'temperatura', 970.0000, 'ºC'),
	(274633, 120, '2014-04-01 00:32:42.000000', 'temperatura', 20.0000, 'ºC'),
	(274634, 120, '2014-04-01 00:32:43.000000', 'temperatura', 792.0000, 'ºC'),
	(274635, 120, '2014-04-01 00:32:44.000000', 'temperatura', 297.0000, 'ºC'),
	(274636, 120, '2014-04-01 00:32:45.000000', 'temperatura', 310.0000, 'ºC'),
	(274637, 120, '2014-04-01 00:32:46.000000', 'temperatura', 661.0000, 'ºC'),
	(274638, 120, '2014-04-01 00:32:47.000000', 'temperatura', 1174.0000, 'ºC'),
	(274639, 120, '2014-04-01 00:32:48.000000', 'temperatura', 290.0000, 'ºC'),
	(274640, 120, '2014-04-01 00:32:49.000000', 'temperatura', 326.0000, 'ºC'),
	(274641, 120, '2014-04-01 00:32:50.000000', 'temperatura', 761.0000, 'ºC'),
	(274642, 120, '2014-04-01 00:32:51.000000', 'temperatura', 426.0000, 'ºC'),
	(274643, 120, '2014-04-01 00:32:52.000000', 'temperatura', 1047.0000, 'ºC'),
	(274644, 120, '2014-04-01 00:32:53.000000', 'temperatura', 359.0000, 'ºC'),
	(274645, 120, '2014-04-01 00:32:54.000000', 'temperatura', 1056.0000, 'ºC'),
	(274646, 120, '2014-04-01 00:32:55.000000', 'temperatura', 602.0000, 'ºC'),
	(274647, 120, '2014-04-01 00:32:56.000000', 'temperatura', 1041.0000, 'ºC'),
	(274648, 120, '2014-04-01 00:32:57.000000', 'temperatura', 999.0000, 'ºC'),
	(274649, 120, '2014-04-01 00:32:58.000000', 'temperatura', 674.0000, 'ºC'),
	(274650, 120, '2014-04-01 00:32:59.000000', 'temperatura', 375.0000, 'ºC'),
	(274651, 120, '2014-04-01 00:33:00.000000', 'temperatura', 1052.0000, 'ºC'),
	(274652, 120, '2014-04-01 00:33:01.000000', 'temperatura', 537.0000, 'ºC'),
	(274653, 120, '2014-04-01 00:33:02.000000', 'temperatura', 727.0000, 'ºC'),
	(274654, 120, '2014-04-01 00:33:03.000000', 'temperatura', 824.0000, 'ºC'),
	(274655, 120, '2014-04-01 00:33:04.000000', 'temperatura', 743.0000, 'ºC'),
	(274656, 120, '2014-04-01 00:33:05.000000', 'temperatura', 40.0000, 'ºC'),
	(274657, 120, '2014-04-01 00:33:06.000000', 'temperatura', 372.0000, 'ºC'),
	(274658, 120, '2014-04-01 00:33:07.000000', 'temperatura', 542.0000, 'ºC'),
	(274659, 120, '2014-04-01 00:33:08.000000', 'temperatura', 394.0000, 'ºC'),
	(274660, 120, '2014-04-01 00:33:09.000000', 'temperatura', 346.0000, 'ºC'),
	(274661, 120, '2014-04-01 00:33:10.000000', 'temperatura', 545.0000, 'ºC'),
	(274662, 120, '2014-04-01 00:33:11.000000', 'temperatura', 491.0000, 'ºC'),
	(274663, 120, '2014-04-01 00:33:12.000000', 'temperatura', 818.0000, 'ºC'),
	(274664, 120, '2014-04-01 00:33:13.000000', 'temperatura', 219.0000, 'ºC'),
	(274665, 120, '2014-04-01 00:33:14.000000', 'temperatura', 1040.0000, 'ºC'),
	(274666, 120, '2014-04-01 00:33:15.000000', 'temperatura', 945.0000, 'ºC'),
	(274667, 120, '2014-04-01 00:33:16.000000', 'temperatura', 406.0000, 'ºC'),
	(274668, 120, '2014-04-01 00:33:17.000000', 'temperatura', 395.0000, 'ºC'),
	(274669, 120, '2014-04-01 00:33:18.000000', 'temperatura', 759.0000, 'ºC'),
	(274670, 120, '2014-04-01 00:33:19.000000', 'temperatura', 208.0000, 'ºC'),
	(274671, 120, '2014-04-01 00:33:20.000000', 'temperatura', 1166.0000, 'ºC'),
	(274672, 120, '2014-04-01 00:33:21.000000', 'temperatura', 407.0000, 'ºC'),
	(274673, 120, '2014-04-01 00:33:22.000000', 'temperatura', 935.0000, 'ºC'),
	(274674, 120, '2014-04-01 00:33:23.000000', 'temperatura', 1056.0000, 'ºC'),
	(274675, 120, '2014-04-01 00:33:24.000000', 'temperatura', 73.0000, 'ºC'),
	(274676, 120, '2014-04-01 00:33:25.000000', 'temperatura', 800.0000, 'ºC'),
	(274677, 120, '2014-04-01 00:33:26.000000', 'temperatura', 179.0000, 'ºC'),
	(274678, 120, '2014-04-01 00:33:27.000000', 'temperatura', 898.0000, 'ºC'),
	(274679, 120, '2014-04-01 00:33:28.000000', 'temperatura', 354.0000, 'ºC'),
	(274680, 120, '2014-04-01 00:33:29.000000', 'temperatura', 274.0000, 'ºC'),
	(274681, 120, '2014-04-01 00:33:30.000000', 'temperatura', 309.0000, 'ºC'),
	(274682, 120, '2014-04-01 00:33:31.000000', 'temperatura', 724.0000, 'ºC'),
	(274683, 120, '2014-04-01 00:33:32.000000', 'temperatura', 293.0000, 'ºC'),
	(274684, 120, '2014-04-01 00:33:33.000000', 'temperatura', 495.0000, 'ºC'),
	(274685, 120, '2014-04-01 00:33:34.000000', 'temperatura', 395.0000, 'ºC'),
	(274686, 120, '2014-04-01 00:33:35.000000', 'temperatura', 490.0000, 'ºC'),
	(274687, 120, '2014-04-01 00:33:36.000000', 'temperatura', 67.0000, 'ºC'),
	(274688, 120, '2014-04-01 00:33:37.000000', 'temperatura', 65.0000, 'ºC'),
	(274689, 120, '2014-04-01 00:33:38.000000', 'temperatura', 126.0000, 'ºC'),
	(274690, 120, '2014-04-01 00:33:39.000000', 'temperatura', 436.0000, 'ºC'),
	(274691, 120, '2014-04-01 00:33:40.000000', 'temperatura', 600.0000, 'ºC'),
	(274692, 120, '2014-04-01 00:33:41.000000', 'temperatura', 495.0000, 'ºC'),
	(274693, 120, '2014-04-01 00:33:42.000000', 'temperatura', 674.0000, 'ºC'),
	(274694, 120, '2014-04-01 00:33:43.000000', 'temperatura', 687.0000, 'ºC'),
	(274695, 120, '2014-04-01 00:33:44.000000', 'temperatura', 211.0000, 'ºC'),
	(274696, 120, '2014-04-01 00:33:45.000000', 'temperatura', 197.0000, 'ºC'),
	(274697, 120, '2014-04-01 00:33:46.000000', 'temperatura', 352.0000, 'ºC'),
	(274698, 120, '2014-04-01 00:33:47.000000', 'temperatura', 1168.0000, 'ºC'),
	(274699, 120, '2014-04-01 00:33:48.000000', 'temperatura', 1187.0000, 'ºC'),
	(274700, 120, '2014-04-01 00:33:49.000000', 'temperatura', 29.0000, 'ºC'),
	(274701, 120, '2014-04-01 00:33:50.000000', 'temperatura', 184.0000, 'ºC'),
	(274702, 120, '2014-04-01 00:33:51.000000', 'temperatura', 835.0000, 'ºC'),
	(274703, 120, '2014-04-01 00:33:52.000000', 'temperatura', 22.0000, 'ºC'),
	(274704, 120, '2014-04-01 00:33:53.000000', 'temperatura', 7.0000, 'ºC'),
	(274705, 120, '2014-04-01 00:33:54.000000', 'temperatura', 1171.0000, 'ºC'),
	(274706, 120, '2014-04-01 00:33:55.000000', 'temperatura', 1031.0000, 'ºC'),
	(274707, 120, '2014-04-01 00:33:56.000000', 'temperatura', 446.0000, 'ºC'),
	(274708, 120, '2014-04-01 00:33:57.000000', 'temperatura', 335.0000, 'ºC'),
	(274709, 120, '2014-04-01 00:33:58.000000', 'temperatura', 338.0000, 'ºC'),
	(274710, 120, '2014-04-01 00:33:59.000000', 'temperatura', 684.0000, 'ºC'),
	(274711, 120, '2014-04-01 00:34:00.000000', 'temperatura', 8.0000, 'ºC'),
	(274712, 120, '2014-04-01 00:34:01.000000', 'temperatura', 388.0000, 'ºC'),
	(274713, 120, '2014-04-01 00:34:02.000000', 'temperatura', 718.0000, 'ºC'),
	(274714, 120, '2014-04-01 00:34:03.000000', 'temperatura', 25.0000, 'ºC'),
	(274715, 120, '2014-04-01 00:34:04.000000', 'temperatura', 373.0000, 'ºC'),
	(274716, 120, '2014-04-01 00:34:05.000000', 'temperatura', 589.0000, 'ºC'),
	(274717, 120, '2014-04-01 00:34:06.000000', 'temperatura', 629.0000, 'ºC'),
	(274718, 120, '2014-04-01 00:34:07.000000', 'temperatura', 176.0000, 'ºC'),
	(274719, 120, '2014-04-01 00:34:08.000000', 'temperatura', 193.0000, 'ºC'),
	(274720, 120, '2014-04-01 00:34:09.000000', 'temperatura', 439.0000, 'ºC'),
	(274721, 120, '2014-04-01 00:34:10.000000', 'temperatura', 417.0000, 'ºC'),
	(274722, 120, '2014-04-01 00:34:11.000000', 'temperatura', 770.0000, 'ºC'),
	(274723, 120, '2014-04-01 00:34:12.000000', 'temperatura', 196.0000, 'ºC'),
	(274724, 120, '2014-04-01 00:34:13.000000', 'temperatura', 1072.0000, 'ºC'),
	(274725, 120, '2014-04-01 00:34:14.000000', 'temperatura', 1173.0000, 'ºC'),
	(274726, 120, '2014-04-01 00:34:15.000000', 'temperatura', 248.0000, 'ºC'),
	(274727, 120, '2014-04-01 00:34:16.000000', 'temperatura', 124.0000, 'ºC'),
	(274728, 120, '2014-04-01 00:34:17.000000', 'temperatura', 1074.0000, 'ºC'),
	(274729, 120, '2014-04-01 00:34:18.000000', 'temperatura', 200.0000, 'ºC'),
	(274730, 120, '2014-04-01 00:34:19.000000', 'temperatura', 177.0000, 'ºC'),
	(274731, 120, '2014-04-01 00:34:20.000000', 'temperatura', 286.0000, 'ºC'),
	(274732, 120, '2014-04-01 00:34:21.000000', 'temperatura', 901.0000, 'ºC'),
	(274733, 120, '2014-04-01 00:34:22.000000', 'temperatura', 47.0000, 'ºC'),
	(274734, 120, '2014-04-01 00:34:23.000000', 'temperatura', 1131.0000, 'ºC'),
	(274735, 120, '2014-04-01 00:34:24.000000', 'temperatura', 714.0000, 'ºC'),
	(274736, 120, '2014-04-01 00:34:25.000000', 'temperatura', 178.0000, 'ºC'),
	(274737, 120, '2014-04-01 00:34:26.000000', 'temperatura', 1149.0000, 'ºC'),
	(274738, 120, '2014-04-01 00:34:27.000000', 'temperatura', 412.0000, 'ºC'),
	(274739, 120, '2014-04-01 00:34:28.000000', 'temperatura', 1013.0000, 'ºC'),
	(274740, 120, '2014-04-01 00:34:29.000000', 'temperatura', 230.0000, 'ºC'),
	(274741, 120, '2014-04-01 00:34:30.000000', 'temperatura', 512.0000, 'ºC'),
	(274742, 120, '2014-04-01 00:34:31.000000', 'temperatura', 671.0000, 'ºC'),
	(274743, 120, '2014-04-01 00:34:32.000000', 'temperatura', 620.0000, 'ºC'),
	(274744, 120, '2014-04-01 00:34:33.000000', 'temperatura', 1085.0000, 'ºC'),
	(274745, 120, '2014-04-01 00:34:34.000000', 'temperatura', 1168.0000, 'ºC'),
	(274746, 120, '2014-04-01 00:34:35.000000', 'temperatura', 186.0000, 'ºC'),
	(274747, 120, '2014-04-01 00:34:36.000000', 'temperatura', 1024.0000, 'ºC'),
	(274748, 120, '2014-04-01 00:34:37.000000', 'temperatura', 964.0000, 'ºC'),
	(274749, 120, '2014-04-01 00:34:38.000000', 'temperatura', 548.0000, 'ºC'),
	(274750, 120, '2014-04-01 00:34:39.000000', 'temperatura', 1048.0000, 'ºC'),
	(274751, 120, '2014-04-01 00:34:40.000000', 'temperatura', 1199.0000, 'ºC'),
	(274752, 120, '2014-04-01 00:34:41.000000', 'temperatura', 450.0000, 'ºC'),
	(274753, 120, '2014-04-01 00:34:42.000000', 'temperatura', 1052.0000, 'ºC'),
	(274754, 120, '2014-04-01 00:34:43.000000', 'temperatura', 311.0000, 'ºC'),
	(274755, 120, '2014-04-01 00:34:44.000000', 'temperatura', 801.0000, 'ºC'),
	(274756, 120, '2014-04-01 00:34:45.000000', 'temperatura', 671.0000, 'ºC'),
	(274757, 120, '2014-04-01 00:34:46.000000', 'temperatura', 953.0000, 'ºC'),
	(274758, 120, '2014-04-01 00:34:47.000000', 'temperatura', 355.0000, 'ºC'),
	(274759, 120, '2014-04-01 00:34:48.000000', 'temperatura', 113.0000, 'ºC'),
	(274760, 120, '2014-04-01 00:34:49.000000', 'temperatura', 701.0000, 'ºC'),
	(274761, 120, '2014-04-01 00:34:50.000000', 'temperatura', 766.0000, 'ºC'),
	(274762, 120, '2014-04-01 00:34:51.000000', 'temperatura', 526.0000, 'ºC'),
	(274763, 120, '2014-04-01 00:34:52.000000', 'temperatura', 335.0000, 'ºC'),
	(274764, 120, '2014-04-01 00:34:53.000000', 'temperatura', 97.0000, 'ºC'),
	(274765, 120, '2014-04-01 00:34:54.000000', 'temperatura', 681.0000, 'ºC'),
	(274766, 120, '2014-04-01 00:34:55.000000', 'temperatura', 716.0000, 'ºC'),
	(274767, 120, '2014-04-01 00:34:56.000000', 'temperatura', 335.0000, 'ºC'),
	(274768, 120, '2014-04-01 00:34:57.000000', 'temperatura', 729.0000, 'ºC'),
	(274769, 120, '2014-04-01 00:34:58.000000', 'temperatura', 242.0000, 'ºC'),
	(274770, 120, '2014-04-01 00:34:59.000000', 'temperatura', 222.0000, 'ºC'),
	(274771, 120, '2014-04-01 00:35:00.000000', 'temperatura', 384.0000, 'ºC'),
	(274772, 120, '2014-04-01 00:35:01.000000', 'temperatura', 54.0000, 'ºC'),
	(274773, 120, '2014-04-01 00:35:02.000000', 'temperatura', 320.0000, 'ºC'),
	(274774, 120, '2014-04-01 00:35:03.000000', 'temperatura', 238.0000, 'ºC'),
	(274775, 120, '2014-04-01 00:35:04.000000', 'temperatura', 232.0000, 'ºC'),
	(274776, 120, '2014-04-01 00:35:05.000000', 'temperatura', 446.0000, 'ºC'),
	(274777, 120, '2014-04-01 00:35:06.000000', 'temperatura', 332.0000, 'ºC'),
	(274778, 120, '2014-04-01 00:35:07.000000', 'temperatura', 325.0000, 'ºC'),
	(274779, 120, '2014-04-01 00:35:08.000000', 'temperatura', 629.0000, 'ºC'),
	(274780, 120, '2014-04-01 00:35:09.000000', 'temperatura', 972.0000, 'ºC'),
	(274781, 120, '2014-04-01 00:35:10.000000', 'temperatura', 574.0000, 'ºC'),
	(274782, 120, '2014-04-01 00:35:11.000000', 'temperatura', 1152.0000, 'ºC'),
	(274783, 120, '2014-04-01 00:35:12.000000', 'temperatura', 438.0000, 'ºC'),
	(274784, 120, '2014-04-01 00:35:13.000000', 'temperatura', 1134.0000, 'ºC'),
	(274785, 120, '2014-04-01 00:35:14.000000', 'temperatura', 759.0000, 'ºC'),
	(274786, 120, '2014-04-01 00:35:15.000000', 'temperatura', 391.0000, 'ºC'),
	(274787, 120, '2014-04-01 00:35:16.000000', 'temperatura', 878.0000, 'ºC'),
	(274788, 120, '2014-04-01 00:35:17.000000', 'temperatura', 817.0000, 'ºC'),
	(274789, 120, '2014-04-01 00:35:18.000000', 'temperatura', 251.0000, 'ºC'),
	(274790, 120, '2014-04-01 00:35:19.000000', 'temperatura', 6.0000, 'ºC'),
	(274791, 120, '2014-04-01 00:35:20.000000', 'temperatura', 477.0000, 'ºC'),
	(274792, 120, '2014-04-01 00:35:21.000000', 'temperatura', 1167.0000, 'ºC'),
	(274793, 120, '2014-04-01 00:35:22.000000', 'temperatura', 806.0000, 'ºC'),
	(274794, 120, '2014-04-01 00:35:23.000000', 'temperatura', 528.0000, 'ºC'),
	(274795, 120, '2014-04-01 00:35:24.000000', 'temperatura', 223.0000, 'ºC'),
	(274796, 120, '2014-04-01 00:35:25.000000', 'temperatura', 733.0000, 'ºC'),
	(274797, 120, '2014-04-01 00:35:26.000000', 'temperatura', 596.0000, 'ºC'),
	(274798, 120, '2014-04-01 00:35:27.000000', 'temperatura', 781.0000, 'ºC'),
	(274799, 120, '2014-04-01 00:35:28.000000', 'temperatura', 919.0000, 'ºC'),
	(274800, 120, '2014-04-01 00:35:29.000000', 'temperatura', 1050.0000, 'ºC'),
	(274801, 120, '2014-04-01 00:35:30.000000', 'temperatura', 93.0000, 'ºC'),
	(274802, 120, '2014-04-01 00:35:31.000000', 'temperatura', 915.0000, 'ºC'),
	(274803, 120, '2014-04-01 00:35:32.000000', 'temperatura', 698.0000, 'ºC'),
	(274804, 120, '2014-04-01 00:35:33.000000', 'temperatura', 746.0000, 'ºC'),
	(274805, 120, '2014-04-01 00:35:34.000000', 'temperatura', 437.0000, 'ºC'),
	(274806, 120, '2014-04-01 00:35:35.000000', 'temperatura', 1145.0000, 'ºC'),
	(274807, 120, '2014-04-01 00:35:36.000000', 'temperatura', 817.0000, 'ºC'),
	(274808, 120, '2014-04-01 00:35:37.000000', 'temperatura', 648.0000, 'ºC'),
	(274809, 120, '2014-04-01 00:35:38.000000', 'temperatura', 792.0000, 'ºC'),
	(274810, 120, '2014-04-01 00:35:39.000000', 'temperatura', 818.0000, 'ºC'),
	(274811, 120, '2014-04-01 00:35:40.000000', 'temperatura', 511.0000, 'ºC'),
	(274812, 120, '2014-04-01 00:35:41.000000', 'temperatura', 104.0000, 'ºC'),
	(274813, 120, '2014-04-01 00:35:42.000000', 'temperatura', 186.0000, 'ºC'),
	(274814, 120, '2014-04-01 00:35:43.000000', 'temperatura', 619.0000, 'ºC'),
	(274815, 120, '2014-04-01 00:35:44.000000', 'temperatura', 135.0000, 'ºC'),
	(274816, 120, '2014-04-01 00:35:45.000000', 'temperatura', 22.0000, 'ºC'),
	(274817, 120, '2014-04-01 00:35:46.000000', 'temperatura', 903.0000, 'ºC'),
	(274818, 120, '2014-04-01 00:35:47.000000', 'temperatura', 849.0000, 'ºC'),
	(274819, 120, '2014-04-01 00:35:48.000000', 'temperatura', 336.0000, 'ºC'),
	(274820, 120, '2014-04-01 00:35:49.000000', 'temperatura', 333.0000, 'ºC'),
	(274821, 120, '2014-04-01 00:35:50.000000', 'temperatura', 657.0000, 'ºC'),
	(274822, 120, '2014-04-01 00:35:51.000000', 'temperatura', 1087.0000, 'ºC'),
	(274823, 120, '2014-04-01 00:35:52.000000', 'temperatura', 1066.0000, 'ºC'),
	(274824, 120, '2014-04-01 00:35:53.000000', 'temperatura', 870.0000, 'ºC'),
	(274825, 120, '2014-04-01 00:35:54.000000', 'temperatura', 1150.0000, 'ºC'),
	(274826, 120, '2014-04-01 00:35:55.000000', 'temperatura', 740.0000, 'ºC'),
	(274827, 120, '2014-04-01 00:35:56.000000', 'temperatura', 250.0000, 'ºC'),
	(274828, 120, '2014-04-01 00:35:57.000000', 'temperatura', 230.0000, 'ºC'),
	(274829, 120, '2014-04-01 00:35:58.000000', 'temperatura', 402.0000, 'ºC'),
	(274830, 120, '2014-04-01 00:35:59.000000', 'temperatura', 121.0000, 'ºC'),
	(274831, 120, '2014-04-01 00:36:00.000000', 'temperatura', 601.0000, 'ºC'),
	(274832, 120, '2014-04-01 00:36:01.000000', 'temperatura', 240.0000, 'ºC'),
	(274833, 120, '2014-04-01 00:36:02.000000', 'temperatura', 599.0000, 'ºC'),
	(274834, 120, '2014-04-01 00:36:03.000000', 'temperatura', 1077.0000, 'ºC'),
	(274835, 120, '2014-04-01 00:36:04.000000', 'temperatura', 1187.0000, 'ºC'),
	(274836, 120, '2014-04-01 00:36:05.000000', 'temperatura', 303.0000, 'ºC'),
	(274837, 120, '2014-04-01 00:36:06.000000', 'temperatura', 355.0000, 'ºC'),
	(274838, 120, '2014-04-01 00:36:07.000000', 'temperatura', 867.0000, 'ºC'),
	(274839, 120, '2014-04-01 00:36:08.000000', 'temperatura', 869.0000, 'ºC'),
	(274840, 120, '2014-04-01 00:36:09.000000', 'temperatura', 544.0000, 'ºC'),
	(274841, 120, '2014-04-01 00:36:10.000000', 'temperatura', 116.0000, 'ºC'),
	(274842, 120, '2014-04-01 00:36:11.000000', 'temperatura', 146.0000, 'ºC'),
	(274843, 120, '2014-04-01 00:36:12.000000', 'temperatura', 383.0000, 'ºC'),
	(274844, 120, '2014-04-01 00:36:13.000000', 'temperatura', 280.0000, 'ºC'),
	(274845, 120, '2014-04-01 00:36:14.000000', 'temperatura', 249.0000, 'ºC'),
	(274846, 120, '2014-04-01 00:36:15.000000', 'temperatura', 407.0000, 'ºC'),
	(274847, 120, '2014-04-01 00:36:16.000000', 'temperatura', 88.0000, 'ºC'),
	(274848, 120, '2014-04-01 00:36:17.000000', 'temperatura', 419.0000, 'ºC'),
	(274849, 120, '2014-04-01 00:36:18.000000', 'temperatura', 631.0000, 'ºC'),
	(274850, 120, '2014-04-01 00:36:19.000000', 'temperatura', 697.0000, 'ºC'),
	(274851, 120, '2014-04-01 00:36:20.000000', 'temperatura', 394.0000, 'ºC'),
	(274852, 120, '2014-04-01 00:36:21.000000', 'temperatura', 1079.0000, 'ºC'),
	(274853, 120, '2014-04-01 00:36:22.000000', 'temperatura', 612.0000, 'ºC'),
	(274854, 120, '2014-04-01 00:36:23.000000', 'temperatura', 1024.0000, 'ºC'),
	(274855, 120, '2014-04-01 00:36:24.000000', 'temperatura', 884.0000, 'ºC'),
	(274856, 120, '2014-04-01 00:36:25.000000', 'temperatura', 150.0000, 'ºC'),
	(274857, 120, '2014-04-01 00:36:26.000000', 'temperatura', 496.0000, 'ºC'),
	(274858, 120, '2014-04-01 00:36:27.000000', 'temperatura', 831.0000, 'ºC'),
	(274859, 120, '2014-04-01 00:36:28.000000', 'temperatura', 269.0000, 'ºC'),
	(274860, 120, '2014-04-01 00:36:29.000000', 'temperatura', 52.0000, 'ºC'),
	(274861, 120, '2014-04-01 00:36:30.000000', 'temperatura', 654.0000, 'ºC'),
	(274862, 120, '2014-04-01 00:36:31.000000', 'temperatura', 715.0000, 'ºC'),
	(274863, 120, '2014-04-01 00:36:32.000000', 'temperatura', 414.0000, 'ºC'),
	(274864, 120, '2014-04-01 00:36:33.000000', 'temperatura', 1123.0000, 'ºC'),
	(274865, 120, '2014-04-01 00:36:34.000000', 'temperatura', 776.0000, 'ºC'),
	(274866, 120, '2014-04-01 00:36:35.000000', 'temperatura', 509.0000, 'ºC'),
	(274867, 120, '2014-04-01 00:36:36.000000', 'temperatura', 219.0000, 'ºC'),
	(274868, 120, '2014-04-01 00:36:37.000000', 'temperatura', 770.0000, 'ºC'),
	(274869, 120, '2014-04-01 00:36:38.000000', 'temperatura', 792.0000, 'ºC'),
	(274870, 120, '2014-04-01 00:36:39.000000', 'temperatura', 449.0000, 'ºC'),
	(274871, 120, '2014-04-01 00:36:40.000000', 'temperatura', 1072.0000, 'ºC'),
	(274872, 120, '2014-04-01 00:36:41.000000', 'temperatura', 414.0000, 'ºC'),
	(274873, 120, '2014-04-01 00:36:42.000000', 'temperatura', 55.0000, 'ºC'),
	(274874, 120, '2014-04-01 00:36:43.000000', 'temperatura', 233.0000, 'ºC'),
	(274875, 120, '2014-04-01 00:36:44.000000', 'temperatura', 1001.0000, 'ºC'),
	(274876, 120, '2014-04-01 00:36:45.000000', 'temperatura', 705.0000, 'ºC'),
	(274877, 120, '2014-04-01 00:36:46.000000', 'temperatura', 523.0000, 'ºC'),
	(274878, 120, '2014-04-01 00:36:47.000000', 'temperatura', 501.0000, 'ºC'),
	(274879, 120, '2014-04-01 00:36:48.000000', 'temperatura', 938.0000, 'ºC'),
	(274880, 120, '2014-04-01 00:36:49.000000', 'temperatura', 787.0000, 'ºC'),
	(274881, 120, '2014-04-01 00:36:50.000000', 'temperatura', 1120.0000, 'ºC'),
	(274882, 120, '2014-04-01 00:36:51.000000', 'temperatura', 841.0000, 'ºC'),
	(274883, 120, '2014-04-01 00:36:52.000000', 'temperatura', 843.0000, 'ºC'),
	(274884, 120, '2014-04-01 00:36:53.000000', 'temperatura', 494.0000, 'ºC'),
	(274885, 120, '2014-04-01 00:36:54.000000', 'temperatura', 1140.0000, 'ºC'),
	(274886, 120, '2014-04-01 00:36:55.000000', 'temperatura', 619.0000, 'ºC'),
	(274887, 120, '2014-04-01 00:36:56.000000', 'temperatura', 874.0000, 'ºC'),
	(274888, 120, '2014-04-01 00:36:57.000000', 'temperatura', 116.0000, 'ºC'),
	(274889, 120, '2014-04-01 00:36:58.000000', 'temperatura', 358.0000, 'ºC'),
	(274890, 120, '2014-04-01 00:36:59.000000', 'temperatura', 241.0000, 'ºC'),
	(274891, 120, '2014-04-01 00:37:00.000000', 'temperatura', 130.0000, 'ºC'),
	(274892, 120, '2014-04-01 00:37:01.000000', 'temperatura', 1131.0000, 'ºC'),
	(274893, 120, '2014-04-01 00:37:02.000000', 'temperatura', 465.0000, 'ºC'),
	(274894, 120, '2014-04-01 00:37:03.000000', 'temperatura', 133.0000, 'ºC'),
	(274895, 120, '2014-04-01 00:37:04.000000', 'temperatura', 468.0000, 'ºC'),
	(274896, 120, '2014-04-01 00:37:05.000000', 'temperatura', 745.0000, 'ºC'),
	(274897, 120, '2014-04-01 00:37:06.000000', 'temperatura', 1118.0000, 'ºC'),
	(274898, 120, '2014-04-01 00:37:07.000000', 'temperatura', 956.0000, 'ºC'),
	(274899, 120, '2014-04-01 00:37:08.000000', 'temperatura', 228.0000, 'ºC'),
	(274900, 120, '2014-04-01 00:37:09.000000', 'temperatura', 671.0000, 'ºC'),
	(274901, 120, '2014-04-01 00:37:10.000000', 'temperatura', 270.0000, 'ºC'),
	(274902, 120, '2014-04-01 00:37:11.000000', 'temperatura', 540.0000, 'ºC'),
	(274903, 120, '2014-04-01 00:37:12.000000', 'temperatura', 691.0000, 'ºC'),
	(274904, 120, '2014-04-01 00:37:13.000000', 'temperatura', 634.0000, 'ºC'),
	(274905, 120, '2014-04-01 00:37:14.000000', 'temperatura', 1098.0000, 'ºC'),
	(274906, 120, '2014-04-01 00:37:15.000000', 'temperatura', 1188.0000, 'ºC'),
	(274907, 120, '2014-04-01 00:37:16.000000', 'temperatura', 245.0000, 'ºC'),
	(274908, 120, '2014-04-01 00:37:17.000000', 'temperatura', 62.0000, 'ºC'),
	(274909, 120, '2014-04-01 00:37:18.000000', 'temperatura', 775.0000, 'ºC'),
	(274910, 120, '2014-04-01 00:37:19.000000', 'temperatura', 90.0000, 'ºC'),
	(274911, 120, '2014-04-01 00:37:20.000000', 'temperatura', 525.0000, 'ºC'),
	(274912, 120, '2014-04-01 00:37:21.000000', 'temperatura', 1154.0000, 'ºC'),
	(274913, 120, '2014-04-01 00:37:22.000000', 'temperatura', 598.0000, 'ºC'),
	(274914, 120, '2014-04-01 00:37:23.000000', 'temperatura', 728.0000, 'ºC'),
	(274915, 120, '2014-04-01 00:37:24.000000', 'temperatura', 647.0000, 'ºC'),
	(274916, 120, '2014-04-01 00:37:25.000000', 'temperatura', 1053.0000, 'ºC'),
	(274917, 120, '2014-04-01 00:37:26.000000', 'temperatura', 922.0000, 'ºC'),
	(274918, 120, '2014-04-01 00:37:27.000000', 'temperatura', 252.0000, 'ºC'),
	(274919, 120, '2014-04-01 00:37:28.000000', 'temperatura', 896.0000, 'ºC'),
	(274920, 120, '2014-04-01 00:37:29.000000', 'temperatura', 122.0000, 'ºC'),
	(274921, 120, '2014-04-01 00:37:30.000000', 'temperatura', 322.0000, 'ºC'),
	(274922, 120, '2014-04-01 00:37:31.000000', 'temperatura', 45.0000, 'ºC'),
	(274923, 120, '2014-04-01 00:37:32.000000', 'temperatura', 459.0000, 'ºC'),
	(274924, 120, '2014-04-01 00:37:33.000000', 'temperatura', 960.0000, 'ºC'),
	(274925, 120, '2014-04-01 00:37:34.000000', 'temperatura', 1026.0000, 'ºC'),
	(274926, 120, '2014-04-01 00:37:35.000000', 'temperatura', 1049.0000, 'ºC'),
	(274927, 120, '2014-04-01 00:37:36.000000', 'temperatura', 969.0000, 'ºC'),
	(274928, 120, '2014-04-01 00:37:37.000000', 'temperatura', 496.0000, 'ºC'),
	(274929, 120, '2014-04-01 00:37:38.000000', 'temperatura', 774.0000, 'ºC'),
	(274930, 120, '2014-04-01 00:37:39.000000', 'temperatura', 1181.0000, 'ºC'),
	(274931, 120, '2014-04-01 00:37:40.000000', 'temperatura', 1184.0000, 'ºC'),
	(274932, 120, '2014-04-01 00:37:41.000000', 'temperatura', 1179.0000, 'ºC'),
	(274933, 120, '2014-04-01 00:37:42.000000', 'temperatura', 1145.0000, 'ºC'),
	(274934, 120, '2014-04-01 00:37:43.000000', 'temperatura', 985.0000, 'ºC'),
	(274935, 120, '2014-04-01 00:37:44.000000', 'temperatura', 292.0000, 'ºC'),
	(274936, 120, '2014-04-01 00:37:45.000000', 'temperatura', 904.0000, 'ºC'),
	(274937, 120, '2014-04-01 00:37:46.000000', 'temperatura', 47.0000, 'ºC'),
	(274938, 120, '2014-04-01 00:37:47.000000', 'temperatura', 1124.0000, 'ºC'),
	(274939, 120, '2014-04-01 00:37:48.000000', 'temperatura', 678.0000, 'ºC'),
	(274940, 120, '2014-04-01 00:37:49.000000', 'temperatura', 17.0000, 'ºC'),
	(274941, 120, '2014-04-01 00:37:50.000000', 'temperatura', 454.0000, 'ºC'),
	(274942, 120, '2014-04-01 00:37:51.000000', 'temperatura', 1019.0000, 'ºC'),
	(274943, 120, '2014-04-01 00:37:52.000000', 'temperatura', 132.0000, 'ºC'),
	(274944, 120, '2014-04-01 00:37:53.000000', 'temperatura', 3.0000, 'ºC'),
	(274945, 120, '2014-04-01 00:37:54.000000', 'temperatura', 822.0000, 'ºC'),
	(274946, 120, '2014-04-01 00:37:55.000000', 'temperatura', 502.0000, 'ºC'),
	(274947, 120, '2014-04-01 00:37:56.000000', 'temperatura', 43.0000, 'ºC'),
	(274948, 120, '2014-04-01 00:37:57.000000', 'temperatura', 1108.0000, 'ºC'),
	(274949, 120, '2014-04-01 00:37:58.000000', 'temperatura', 613.0000, 'ºC'),
	(274950, 120, '2014-04-01 00:37:59.000000', 'temperatura', 940.0000, 'ºC'),
	(274951, 120, '2014-04-01 00:38:00.000000', 'temperatura', 461.0000, 'ºC'),
	(274952, 120, '2014-04-01 00:38:01.000000', 'temperatura', 688.0000, 'ºC'),
	(274953, 120, '2014-04-01 00:38:02.000000', 'temperatura', 857.0000, 'ºC'),
	(274954, 120, '2014-04-01 00:38:03.000000', 'temperatura', 1023.0000, 'ºC'),
	(274955, 120, '2014-04-01 00:38:04.000000', 'temperatura', 143.0000, 'ºC'),
	(274956, 120, '2014-04-01 00:38:05.000000', 'temperatura', 48.0000, 'ºC'),
	(274957, 120, '2014-04-01 00:38:06.000000', 'temperatura', 1010.0000, 'ºC'),
	(274958, 120, '2014-04-01 00:38:07.000000', 'temperatura', 107.0000, 'ºC'),
	(274959, 120, '2014-04-01 00:38:08.000000', 'temperatura', 1105.0000, 'ºC'),
	(274960, 120, '2014-04-01 00:38:09.000000', 'temperatura', 406.0000, 'ºC'),
	(274961, 120, '2014-04-01 00:38:10.000000', 'temperatura', 1115.0000, 'ºC'),
	(274962, 120, '2014-04-01 00:38:11.000000', 'temperatura', 759.0000, 'ºC'),
	(274963, 120, '2014-04-01 00:38:12.000000', 'temperatura', 450.0000, 'ºC'),
	(274964, 120, '2014-04-01 00:38:13.000000', 'temperatura', 1173.0000, 'ºC'),
	(274965, 120, '2014-04-01 00:38:14.000000', 'temperatura', 917.0000, 'ºC'),
	(274966, 120, '2014-04-01 00:38:15.000000', 'temperatura', 1064.0000, 'ºC'),
	(274967, 120, '2014-04-01 00:38:16.000000', 'temperatura', 171.0000, 'ºC'),
	(274968, 120, '2014-04-01 00:38:17.000000', 'temperatura', 63.0000, 'ºC'),
	(274969, 120, '2014-04-01 00:38:18.000000', 'temperatura', 1002.0000, 'ºC'),
	(274970, 120, '2014-04-01 00:38:19.000000', 'temperatura', 20.0000, 'ºC'),
	(274971, 120, '2014-04-01 00:38:20.000000', 'temperatura', 697.0000, 'ºC'),
	(274972, 120, '2014-04-01 00:38:21.000000', 'temperatura', 1023.0000, 'ºC'),
	(274973, 120, '2014-04-01 00:38:22.000000', 'temperatura', 625.0000, 'ºC'),
	(274974, 120, '2014-04-01 00:38:23.000000', 'temperatura', 59.0000, 'ºC'),
	(274975, 120, '2014-04-01 00:38:24.000000', 'temperatura', 819.0000, 'ºC'),
	(274976, 120, '2014-04-01 00:38:25.000000', 'temperatura', 319.0000, 'ºC'),
	(274977, 120, '2014-04-01 00:38:26.000000', 'temperatura', 338.0000, 'ºC'),
	(274978, 120, '2014-04-01 00:38:27.000000', 'temperatura', 734.0000, 'ºC'),
	(274979, 120, '2014-04-01 00:38:28.000000', 'temperatura', 256.0000, 'ºC'),
	(274980, 120, '2014-04-01 00:38:29.000000', 'temperatura', 280.0000, 'ºC'),
	(274981, 120, '2014-04-01 00:38:30.000000', 'temperatura', 633.0000, 'ºC'),
	(274982, 120, '2014-04-01 00:38:31.000000', 'temperatura', 1125.0000, 'ºC'),
	(274983, 120, '2014-04-01 00:38:32.000000', 'temperatura', 126.0000, 'ºC'),
	(274984, 120, '2014-04-01 00:38:33.000000', 'temperatura', 857.0000, 'ºC'),
	(274985, 120, '2014-04-01 00:38:34.000000', 'temperatura', 306.0000, 'ºC'),
	(274986, 120, '2014-04-01 00:38:35.000000', 'temperatura', 161.0000, 'ºC'),
	(274987, 120, '2014-04-01 00:38:36.000000', 'temperatura', 1088.0000, 'ºC'),
	(274988, 120, '2014-04-01 00:38:37.000000', 'temperatura', 157.0000, 'ºC'),
	(274989, 120, '2014-04-01 00:38:38.000000', 'temperatura', 1121.0000, 'ºC'),
	(274990, 120, '2014-04-01 00:38:39.000000', 'temperatura', 334.0000, 'ºC'),
	(274991, 120, '2014-04-01 00:38:40.000000', 'temperatura', 706.0000, 'ºC'),
	(274992, 120, '2014-04-01 00:38:41.000000', 'temperatura', 129.0000, 'ºC'),
	(274993, 120, '2014-04-01 00:38:42.000000', 'temperatura', 928.0000, 'ºC'),
	(274994, 120, '2014-04-01 00:38:43.000000', 'temperatura', 655.0000, 'ºC'),
	(274995, 120, '2014-04-01 00:38:44.000000', 'temperatura', 491.0000, 'ºC'),
	(274996, 120, '2014-04-01 00:38:45.000000', 'temperatura', 490.0000, 'ºC'),
	(274997, 120, '2014-04-01 00:38:46.000000', 'temperatura', 977.0000, 'ºC'),
	(274998, 120, '2014-04-01 00:38:47.000000', 'temperatura', 1017.0000, 'ºC'),
	(274999, 120, '2014-04-01 00:38:48.000000', 'temperatura', 955.0000, 'ºC'),
	(275000, 120, '2014-04-01 00:38:49.000000', 'temperatura', 525.0000, 'ºC'),
	(275001, 120, '2014-04-01 00:38:50.000000', 'temperatura', 958.0000, 'ºC'),
	(275002, 120, '2014-04-01 00:38:51.000000', 'temperatura', 815.0000, 'ºC'),
	(275003, 120, '2014-04-01 00:38:52.000000', 'temperatura', 3.0000, 'ºC'),
	(275004, 120, '2014-04-01 00:38:53.000000', 'temperatura', 1169.0000, 'ºC'),
	(275005, 120, '2014-04-01 00:38:54.000000', 'temperatura', 1039.0000, 'ºC'),
	(275006, 120, '2014-04-01 00:38:55.000000', 'temperatura', 486.0000, 'ºC'),
	(275007, 120, '2014-04-01 00:38:56.000000', 'temperatura', 513.0000, 'ºC'),
	(275008, 120, '2014-04-01 00:38:57.000000', 'temperatura', 1111.0000, 'ºC'),
	(275009, 120, '2014-04-01 00:38:58.000000', 'temperatura', 413.0000, 'ºC'),
	(275010, 120, '2014-04-01 00:38:59.000000', 'temperatura', 1132.0000, 'ºC'),
	(275011, 120, '2014-04-01 00:39:00.000000', 'temperatura', 825.0000, 'ºC'),
	(275012, 120, '2014-04-01 00:39:01.000000', 'temperatura', 727.0000, 'ºC'),
	(275013, 120, '2014-04-01 00:39:02.000000', 'temperatura', 1159.0000, 'ºC'),
	(275014, 120, '2014-04-01 00:39:03.000000', 'temperatura', 18.0000, 'ºC'),
	(275015, 120, '2014-04-01 00:39:04.000000', 'temperatura', 211.0000, 'ºC'),
	(275016, 120, '2014-04-01 00:39:05.000000', 'temperatura', 1003.0000, 'ºC'),
	(275017, 120, '2014-04-01 00:39:06.000000', 'temperatura', 784.0000, 'ºC'),
	(275018, 120, '2014-04-01 00:39:07.000000', 'temperatura', 909.0000, 'ºC'),
	(275019, 120, '2014-04-01 00:39:08.000000', 'temperatura', 996.0000, 'ºC'),
	(275020, 120, '2014-04-01 00:39:09.000000', 'temperatura', 1053.0000, 'ºC'),
	(275021, 120, '2014-04-01 00:39:10.000000', 'temperatura', 1077.0000, 'ºC'),
	(275022, 120, '2014-04-01 00:39:11.000000', 'temperatura', 1027.0000, 'ºC'),
	(275023, 120, '2014-04-01 00:39:12.000000', 'temperatura', 706.0000, 'ºC'),
	(275024, 120, '2014-04-01 00:39:13.000000', 'temperatura', 446.0000, 'ºC'),
	(275025, 120, '2014-04-01 00:39:14.000000', 'temperatura', 115.0000, 'ºC'),
	(275026, 120, '2014-04-01 00:39:15.000000', 'temperatura', 435.0000, 'ºC'),
	(275027, 120, '2014-04-01 00:39:16.000000', 'temperatura', 634.0000, 'ºC'),
	(275028, 120, '2014-04-01 00:39:17.000000', 'temperatura', 663.0000, 'ºC'),
	(275029, 120, '2014-04-01 00:39:18.000000', 'temperatura', 215.0000, 'ºC'),
	(275030, 120, '2014-04-01 00:39:19.000000', 'temperatura', 288.0000, 'ºC'),
	(275031, 120, '2014-04-01 00:39:20.000000', 'temperatura', 794.0000, 'ºC'),
	(275032, 120, '2014-04-01 00:39:21.000000', 'temperatura', 706.0000, 'ºC'),
	(275033, 120, '2014-04-01 00:39:22.000000', 'temperatura', 1148.0000, 'ºC'),
	(275034, 120, '2014-04-01 00:39:23.000000', 'temperatura', 22.0000, 'ºC'),
	(275035, 120, '2014-04-01 00:39:24.000000', 'temperatura', 268.0000, 'ºC'),
	(275036, 120, '2014-04-01 00:39:25.000000', 'temperatura', 72.0000, 'ºC'),
	(275037, 120, '2014-04-01 00:39:26.000000', 'temperatura', 758.0000, 'ºC'),
	(275038, 120, '2014-04-01 00:39:27.000000', 'temperatura', 1173.0000, 'ºC'),
	(275039, 120, '2014-04-01 00:39:28.000000', 'temperatura', 1193.0000, 'ºC'),
	(275040, 120, '2014-04-01 00:39:29.000000', 'temperatura', 46.0000, 'ºC'),
	(275041, 120, '2014-04-01 00:39:30.000000', 'temperatura', 253.0000, 'ºC'),
	(275042, 120, '2014-04-01 00:39:31.000000', 'temperatura', 1128.0000, 'ºC'),
	(275043, 120, '2014-04-01 00:39:32.000000', 'temperatura', 82.0000, 'ºC'),
	(275044, 120, '2014-04-01 00:39:33.000000', 'temperatura', 625.0000, 'ºC'),
	(275045, 120, '2014-04-01 00:39:34.000000', 'temperatura', 479.0000, 'ºC'),
	(275046, 120, '2014-04-01 00:39:35.000000', 'temperatura', 521.0000, 'ºC'),
	(275047, 120, '2014-04-01 00:39:36.000000', 'temperatura', 1169.0000, 'ºC'),
	(275048, 120, '2014-04-01 00:39:37.000000', 'temperatura', 683.0000, 'ºC'),
	(275049, 120, '2014-04-01 00:39:38.000000', 'temperatura', 1108.0000, 'ºC'),
	(275050, 120, '2014-04-01 00:39:39.000000', 'temperatura', 1092.0000, 'ºC'),
	(275051, 120, '2014-04-01 00:39:40.000000', 'temperatura', 935.0000, 'ºC'),
	(275052, 120, '2014-04-01 00:39:41.000000', 'temperatura', 199.0000, 'ºC'),
	(275053, 120, '2014-04-01 00:39:42.000000', 'temperatura', 592.0000, 'ºC'),
	(275054, 120, '2014-04-01 00:39:43.000000', 'temperatura', 1164.0000, 'ºC'),
	(275055, 120, '2014-04-01 00:39:44.000000', 'temperatura', 443.0000, 'ºC'),
	(275056, 120, '2014-04-01 00:39:45.000000', 'temperatura', 1122.0000, 'ºC'),
	(275057, 120, '2014-04-01 00:39:46.000000', 'temperatura', 684.0000, 'ºC'),
	(275058, 120, '2014-04-01 00:39:47.000000', 'temperatura', 54.0000, 'ºC'),
	(275059, 120, '2014-04-01 00:39:48.000000', 'temperatura', 620.0000, 'ºC'),
	(275060, 120, '2014-04-01 00:39:49.000000', 'temperatura', 535.0000, 'ºC'),
	(275061, 120, '2014-04-01 00:39:50.000000', 'temperatura', 819.0000, 'ºC'),
	(275062, 120, '2014-04-01 00:39:51.000000', 'temperatura', 89.0000, 'ºC'),
	(275063, 120, '2014-04-01 00:39:52.000000', 'temperatura', 390.0000, 'ºC'),
	(275064, 120, '2014-04-01 00:39:53.000000', 'temperatura', 483.0000, 'ºC'),
	(275065, 120, '2014-04-01 00:39:54.000000', 'temperatura', 46.0000, 'ºC'),
	(275066, 120, '2014-04-01 00:39:55.000000', 'temperatura', 1180.0000, 'ºC'),
	(275067, 120, '2014-04-01 00:39:56.000000', 'temperatura', 963.0000, 'ºC'),
	(275068, 120, '2014-04-01 00:39:57.000000', 'temperatura', 74.0000, 'ºC'),
	(275069, 120, '2014-04-01 00:39:58.000000', 'temperatura', 1083.0000, 'ºC'),
	(275070, 120, '2014-04-01 00:39:59.000000', 'temperatura', 394.0000, 'ºC'),
	(275071, 120, '2014-04-01 00:40:00.000000', 'temperatura', 1121.0000, 'ºC'),
	(275072, 120, '2014-04-01 00:40:01.000000', 'temperatura', 825.0000, 'ºC'),
	(275073, 120, '2014-04-01 00:40:02.000000', 'temperatura', 763.0000, 'ºC'),
	(275074, 120, '2014-04-01 00:40:03.000000', 'temperatura', 138.0000, 'ºC'),
	(275075, 120, '2014-04-01 00:40:04.000000', 'temperatura', 803.0000, 'ºC'),
	(275076, 120, '2014-04-01 00:40:05.000000', 'temperatura', 1.0000, 'ºC'),
	(275077, 120, '2014-04-01 00:40:06.000000', 'temperatura', 1195.0000, 'ºC'),
	(275078, 120, '2014-04-01 00:40:07.000000', 'temperatura', 1173.0000, 'ºC'),
	(275079, 120, '2014-04-01 00:40:08.000000', 'temperatura', 1079.0000, 'ºC'),
	(275080, 120, '2014-04-01 00:40:09.000000', 'temperatura', 680.0000, 'ºC'),
	(275081, 120, '2014-04-01 00:40:10.000000', 'temperatura', 162.0000, 'ºC'),
	(275082, 120, '2014-04-01 00:40:11.000000', 'temperatura', 1170.0000, 'ºC'),
	(275083, 120, '2014-04-01 00:40:12.000000', 'temperatura', 565.0000, 'ºC'),
	(275084, 120, '2014-04-01 00:40:13.000000', 'temperatura', 517.0000, 'ºC'),
	(275085, 120, '2014-04-01 00:40:14.000000', 'temperatura', 888.0000, 'ºC'),
	(275086, 120, '2014-04-01 00:40:15.000000', 'temperatura', 491.0000, 'ºC'),
	(275087, 120, '2014-04-01 00:40:16.000000', 'temperatura', 990.0000, 'ºC'),
	(275088, 120, '2014-04-01 00:40:17.000000', 'temperatura', 1077.0000, 'ºC'),
	(275089, 120, '2014-04-01 00:40:18.000000', 'temperatura', 16.0000, 'ºC'),
	(275090, 120, '2014-04-01 00:40:19.000000', 'temperatura', 449.0000, 'ºC'),
	(275091, 120, '2014-04-01 00:40:20.000000', 'temperatura', 997.0000, 'ºC'),
	(275092, 120, '2014-04-01 00:40:21.000000', 'temperatura', 40.0000, 'ºC'),
	(275093, 120, '2014-04-01 00:40:22.000000', 'temperatura', 809.0000, 'ºC'),
	(275094, 120, '2014-04-01 00:40:23.000000', 'temperatura', 328.0000, 'ºC'),
	(275095, 120, '2014-04-01 00:40:24.000000', 'temperatura', 410.0000, 'ºC'),
	(275096, 120, '2014-04-01 00:40:25.000000', 'temperatura', 1067.0000, 'ºC'),
	(275097, 120, '2014-04-01 00:40:26.000000', 'temperatura', 506.0000, 'ºC'),
	(275098, 120, '2014-04-01 00:40:27.000000', 'temperatura', 529.0000, 'ºC'),
	(275099, 120, '2014-04-01 00:40:28.000000', 'temperatura', 1128.0000, 'ºC'),
	(275100, 120, '2014-04-01 00:40:29.000000', 'temperatura', 452.0000, 'ºC'),
	(275101, 120, '2014-04-01 00:40:30.000000', 'temperatura', 79.0000, 'ºC'),
	(275102, 120, '2014-04-01 00:40:31.000000', 'temperatura', 240.0000, 'ºC'),
	(275103, 120, '2014-04-01 00:40:32.000000', 'temperatura', 964.0000, 'ºC'),
	(275104, 120, '2014-04-01 00:40:33.000000', 'temperatura', 497.0000, 'ºC'),
	(275105, 120, '2014-04-01 00:40:34.000000', 'temperatura', 797.0000, 'ºC'),
	(275106, 120, '2014-04-01 00:40:35.000000', 'temperatura', 92.0000, 'ºC'),
	(275107, 120, '2014-04-01 00:40:36.000000', 'temperatura', 471.0000, 'ºC'),
	(275108, 120, '2014-04-01 00:40:37.000000', 'temperatura', 879.0000, 'ºC'),
	(275109, 120, '2014-04-01 00:40:38.000000', 'temperatura', 580.0000, 'ºC'),
	(275110, 120, '2014-04-01 00:40:39.000000', 'temperatura', 267.0000, 'ºC'),
	(275111, 120, '2014-04-01 00:40:40.000000', 'temperatura', 795.0000, 'ºC'),
	(275112, 120, '2014-04-01 00:40:41.000000', 'temperatura', 772.0000, 'ºC'),
	(275113, 120, '2014-04-01 00:40:42.000000', 'temperatura', 277.0000, 'ºC'),
	(275114, 120, '2014-04-01 00:40:43.000000', 'temperatura', 270.0000, 'ºC'),
	(275115, 120, '2014-04-01 00:40:44.000000', 'temperatura', 519.0000, 'ºC'),
	(275116, 120, '2014-04-01 00:40:45.000000', 'temperatura', 584.0000, 'ºC'),
	(275117, 120, '2014-04-01 00:40:46.000000', 'temperatura', 165.0000, 'ºC'),
	(275118, 120, '2014-04-01 00:40:47.000000', 'temperatura', 272.0000, 'ºC'),
	(275119, 120, '2014-04-01 00:40:48.000000', 'temperatura', 868.0000, 'ºC'),
	(275120, 120, '2014-04-01 00:40:49.000000', 'temperatura', 1123.0000, 'ºC'),
	(275121, 120, '2014-04-01 00:40:50.000000', 'temperatura', 611.0000, 'ºC'),
	(275122, 120, '2014-04-01 00:40:51.000000', 'temperatura', 889.0000, 'ºC'),
	(275123, 120, '2014-04-01 00:40:52.000000', 'temperatura', 210.0000, 'ºC'),
	(275124, 120, '2014-04-01 00:40:53.000000', 'temperatura', 783.0000, 'ºC'),
	(275125, 120, '2014-04-01 00:40:54.000000', 'temperatura', 888.0000, 'ºC'),
	(275126, 120, '2014-04-01 00:40:55.000000', 'temperatura', 889.0000, 'ºC'),
	(275127, 120, '2014-04-01 00:40:56.000000', 'temperatura', 583.0000, 'ºC'),
	(275128, 120, '2014-04-01 00:40:57.000000', 'temperatura', 249.0000, 'ºC'),
	(275129, 120, '2014-04-01 00:40:58.000000', 'temperatura', 694.0000, 'ºC'),
	(275130, 120, '2014-04-01 00:40:59.000000', 'temperatura', 324.0000, 'ºC'),
	(275131, 120, '2014-04-01 00:41:00.000000', 'temperatura', 740.0000, 'ºC'),
	(275132, 120, '2014-04-01 00:41:01.000000', 'temperatura', 328.0000, 'ºC'),
	(275133, 120, '2014-04-01 00:41:02.000000', 'temperatura', 620.0000, 'ºC'),
	(275134, 120, '2014-04-01 00:41:03.000000', 'temperatura', 915.0000, 'ºC'),
	(275135, 120, '2014-04-01 00:41:04.000000', 'temperatura', 317.0000, 'ºC'),
	(275136, 120, '2014-04-01 00:41:05.000000', 'temperatura', 39.0000, 'ºC'),
	(275137, 120, '2014-04-01 00:41:06.000000', 'temperatura', 446.0000, 'ºC'),
	(275138, 120, '2014-04-01 00:41:07.000000', 'temperatura', 915.0000, 'ºC'),
	(275139, 120, '2014-04-01 00:41:08.000000', 'temperatura', 837.0000, 'ºC'),
	(275140, 120, '2014-04-01 00:41:09.000000', 'temperatura', 240.0000, 'ºC'),
	(275141, 120, '2014-04-01 00:41:10.000000', 'temperatura', 1091.0000, 'ºC'),
	(275142, 120, '2014-04-01 00:41:11.000000', 'temperatura', 1136.0000, 'ºC'),
	(275143, 120, '2014-04-01 00:41:12.000000', 'temperatura', 5.0000, 'ºC'),
	(275144, 120, '2014-04-01 00:41:13.000000', 'temperatura', 217.0000, 'ºC'),
	(275145, 120, '2014-04-01 00:41:14.000000', 'temperatura', 1071.0000, 'ºC'),
	(275146, 120, '2014-04-01 00:41:15.000000', 'temperatura', 1103.0000, 'ºC'),
	(275147, 120, '2014-04-01 00:41:16.000000', 'temperatura', 1104.0000, 'ºC'),
	(275148, 120, '2014-04-01 00:41:17.000000', 'temperatura', 1011.0000, 'ºC'),
	(275149, 120, '2014-04-01 00:41:18.000000', 'temperatura', 543.0000, 'ºC'),
	(275150, 120, '2014-04-01 00:41:19.000000', 'temperatura', 883.0000, 'ºC'),
	(275151, 120, '2014-04-01 00:41:20.000000', 'temperatura', 386.0000, 'ºC'),
	(275152, 120, '2014-04-01 00:41:21.000000', 'temperatura', 484.0000, 'ºC'),
	(275153, 120, '2014-04-01 00:41:22.000000', 'temperatura', 60.0000, 'ºC'),
	(275154, 120, '2014-04-01 00:41:23.000000', 'temperatura', 47.0000, 'ºC'),
	(275155, 120, '2014-04-01 00:41:24.000000', 'temperatura', 58.0000, 'ºC'),
	(275156, 120, '2014-04-01 00:41:25.000000', 'temperatura', 150.0000, 'ºC'),
	(275157, 120, '2014-04-01 00:41:26.000000', 'temperatura', 578.0000, 'ºC'),
	(275158, 120, '2014-04-01 00:41:27.000000', 'temperatura', 38.0000, 'ºC'),
	(275159, 120, '2014-04-01 00:41:28.000000', 'temperatura', 857.0000, 'ºC'),
	(275160, 120, '2014-04-01 00:41:29.000000', 'temperatura', 572.0000, 'ºC'),
	(275161, 120, '2014-04-01 00:41:30.000000', 'temperatura', 289.0000, 'ºC'),
	(275162, 120, '2014-04-01 00:41:31.000000', 'temperatura', 931.0000, 'ºC'),
	(275163, 120, '2014-04-01 00:41:32.000000', 'temperatura', 186.0000, 'ºC'),
	(275164, 120, '2014-04-01 00:41:33.000000', 'temperatura', 541.0000, 'ºC'),
	(275165, 120, '2014-04-01 00:41:34.000000', 'temperatura', 944.0000, 'ºC'),
	(275166, 120, '2014-04-01 00:41:35.000000', 'temperatura', 698.0000, 'ºC'),
	(275167, 120, '2014-04-01 00:41:36.000000', 'temperatura', 661.0000, 'ºC'),
	(275168, 120, '2014-04-01 00:41:37.000000', 'temperatura', 10.0000, 'ºC'),
	(275169, 120, '2014-04-01 00:41:38.000000', 'temperatura', 469.0000, 'ºC'),
	(275170, 120, '2014-04-01 00:41:39.000000', 'temperatura', 1112.0000, 'ºC'),
	(275171, 120, '2014-04-01 00:41:40.000000', 'temperatura', 557.0000, 'ºC'),
	(275172, 120, '2014-04-01 00:41:41.000000', 'temperatura', 648.0000, 'ºC'),
	(275173, 120, '2014-04-01 00:41:42.000000', 'temperatura', 369.0000, 'ºC'),
	(275174, 120, '2014-04-01 00:41:43.000000', 'temperatura', 1103.0000, 'ºC'),
	(275175, 120, '2014-04-01 00:41:44.000000', 'temperatura', 810.0000, 'ºC'),
	(275176, 120, '2014-04-01 00:41:45.000000', 'temperatura', 738.0000, 'ºC'),
	(275177, 120, '2014-04-01 00:41:46.000000', 'temperatura', 63.0000, 'ºC'),
	(275178, 120, '2014-04-01 00:41:47.000000', 'temperatura', 502.0000, 'ºC'),
	(275179, 120, '2014-04-01 00:41:48.000000', 'temperatura', 1122.0000, 'ºC'),
	(275180, 120, '2014-04-01 00:41:49.000000', 'temperatura', 504.0000, 'ºC'),
	(275181, 120, '2014-04-01 00:41:50.000000', 'temperatura', 354.0000, 'ºC'),
	(275182, 120, '2014-04-01 00:41:51.000000', 'temperatura', 259.0000, 'ºC'),
	(275183, 120, '2014-04-01 00:41:52.000000', 'temperatura', 231.0000, 'ºC'),
	(275184, 120, '2014-04-01 00:41:53.000000', 'temperatura', 382.0000, 'ºC'),
	(275185, 120, '2014-04-01 00:41:54.000000', 'temperatura', 15.0000, 'ºC'),
	(275186, 120, '2014-04-01 00:41:55.000000', 'temperatura', 131.0000, 'ºC'),
	(275187, 120, '2014-04-01 00:41:56.000000', 'temperatura', 612.0000, 'ºC'),
	(275188, 120, '2014-04-01 00:41:57.000000', 'temperatura', 266.0000, 'ºC'),
	(275189, 120, '2014-04-01 00:41:58.000000', 'temperatura', 697.0000, 'ºC'),
	(275190, 120, '2014-04-01 00:41:59.000000', 'temperatura', 284.0000, 'ºC'),
	(275191, 120, '2014-04-01 00:42:00.000000', 'temperatura', 530.0000, 'ºC'),
	(275192, 120, '2014-04-01 00:42:01.000000', 'temperatura', 600.0000, 'ºC'),
	(275193, 120, '2014-04-01 00:42:02.000000', 'temperatura', 209.0000, 'ºC'),
	(275194, 120, '2014-04-01 00:42:03.000000', 'temperatura', 446.0000, 'ºC'),
	(275195, 120, '2014-04-01 00:42:04.000000', 'temperatura', 405.0000, 'ºC'),
	(275196, 120, '2014-04-01 00:42:05.000000', 'temperatura', 686.0000, 'ºC'),
	(275197, 120, '2014-04-01 00:42:06.000000', 'temperatura', 1016.0000, 'ºC'),
	(275198, 120, '2014-04-01 00:42:07.000000', 'temperatura', 621.0000, 'ºC'),
	(275199, 120, '2014-04-01 00:42:08.000000', 'temperatura', 60.0000, 'ºC'),
	(275200, 120, '2014-04-01 00:42:09.000000', 'temperatura', 838.0000, 'ºC'),
	(275201, 120, '2014-04-01 00:42:10.000000', 'temperatura', 407.0000, 'ºC'),
	(275202, 120, '2014-04-01 00:42:11.000000', 'temperatura', 725.0000, 'ºC'),
	(275203, 120, '2014-04-01 00:42:12.000000', 'temperatura', 4.0000, 'ºC'),
	(275204, 120, '2014-04-01 00:42:13.000000', 'temperatura', 244.0000, 'ºC'),
	(275205, 120, '2014-04-01 00:42:14.000000', 'temperatura', 9.0000, 'ºC'),
	(275206, 120, '2014-04-01 00:42:15.000000', 'temperatura', 512.0000, 'ºC'),
	(275207, 120, '2014-04-01 00:42:16.000000', 'temperatura', 134.0000, 'ºC'),
	(275208, 120, '2014-04-01 00:42:17.000000', 'temperatura', 337.0000, 'ºC'),
	(275209, 120, '2014-04-01 00:42:18.000000', 'temperatura', 80.0000, 'ºC'),
	(275210, 120, '2014-04-01 00:42:19.000000', 'temperatura', 593.0000, 'ºC'),
	(275211, 120, '2014-04-01 00:42:20.000000', 'temperatura', 322.0000, 'ºC'),
	(275212, 120, '2014-04-01 00:42:21.000000', 'temperatura', 1035.0000, 'ºC'),
	(275213, 120, '2014-04-01 00:42:22.000000', 'temperatura', 606.0000, 'ºC'),
	(275214, 120, '2014-04-01 00:42:23.000000', 'temperatura', 1129.0000, 'ºC'),
	(275215, 120, '2014-04-01 00:42:24.000000', 'temperatura', 225.0000, 'ºC'),
	(275216, 120, '2014-04-01 00:42:25.000000', 'temperatura', 141.0000, 'ºC'),
	(275217, 120, '2014-04-01 00:42:26.000000', 'temperatura', 30.0000, 'ºC'),
	(275218, 120, '2014-04-01 00:42:27.000000', 'temperatura', 927.0000, 'ºC'),
	(275219, 120, '2014-04-01 00:42:28.000000', 'temperatura', 944.0000, 'ºC'),
	(275220, 120, '2014-04-01 00:42:29.000000', 'temperatura', 740.0000, 'ºC'),
	(275221, 120, '2014-04-01 00:42:30.000000', 'temperatura', 871.0000, 'ºC'),
	(275222, 120, '2014-04-01 00:42:31.000000', 'temperatura', 933.0000, 'ºC'),
	(275223, 120, '2014-04-01 00:42:32.000000', 'temperatura', 852.0000, 'ºC'),
	(275224, 120, '2014-04-01 00:42:33.000000', 'temperatura', 263.0000, 'ºC'),
	(275225, 120, '2014-04-01 00:42:34.000000', 'temperatura', 1160.0000, 'ºC'),
	(275226, 120, '2014-04-01 00:42:35.000000', 'temperatura', 211.0000, 'ºC'),
	(275227, 120, '2014-04-01 00:42:36.000000', 'temperatura', 1175.0000, 'ºC'),
	(275228, 120, '2014-04-01 00:42:37.000000', 'temperatura', 444.0000, 'ºC'),
	(275229, 120, '2014-04-01 00:42:38.000000', 'temperatura', 1094.0000, 'ºC'),
	(275230, 120, '2014-04-01 00:42:39.000000', 'temperatura', 537.0000, 'ºC'),
	(275231, 120, '2014-04-01 00:42:40.000000', 'temperatura', 607.0000, 'ºC'),
	(275232, 120, '2014-04-01 00:42:41.000000', 'temperatura', 221.0000, 'ºC'),
	(275233, 120, '2014-04-01 00:42:42.000000', 'temperatura', 486.0000, 'ºC'),
	(275234, 120, '2014-04-01 00:42:43.000000', 'temperatura', 568.0000, 'ºC'),
	(275235, 120, '2014-04-01 00:42:44.000000', 'temperatura', 182.0000, 'ºC'),
	(275236, 120, '2014-04-01 00:42:45.000000', 'temperatura', 407.0000, 'ºC'),
	(275237, 120, '2014-04-01 00:42:46.000000', 'temperatura', 291.0000, 'ºC'),
	(275238, 120, '2014-04-01 00:42:47.000000', 'temperatura', 234.0000, 'ºC'),
	(275239, 120, '2014-04-01 00:42:48.000000', 'temperatura', 297.0000, 'ºC'),
	(275240, 120, '2014-04-01 00:42:49.000000', 'temperatura', 781.0000, 'ºC'),
	(275241, 120, '2014-04-01 00:42:50.000000', 'temperatura', 618.0000, 'ºC'),
	(275242, 120, '2014-04-01 00:42:51.000000', 'temperatura', 747.0000, 'ºC'),
	(275243, 120, '2014-04-01 00:42:52.000000', 'temperatura', 679.0000, 'ºC'),
	(275244, 120, '2014-04-01 00:42:53.000000', 'temperatura', 1158.0000, 'ºC'),
	(275245, 120, '2014-04-01 00:42:54.000000', 'temperatura', 152.0000, 'ºC'),
	(275246, 120, '2014-04-01 00:42:55.000000', 'temperatura', 887.0000, 'ºC'),
	(275247, 120, '2014-04-01 00:42:56.000000', 'temperatura', 378.0000, 'ºC'),
	(275248, 120, '2014-04-01 00:42:57.000000', 'temperatura', 430.0000, 'ºC'),
	(275249, 120, '2014-04-01 00:42:58.000000', 'temperatura', 1016.0000, 'ºC'),
	(275250, 120, '2014-04-01 00:42:59.000000', 'temperatura', 190.0000, 'ºC'),
	(275251, 120, '2014-04-01 00:43:00.000000', 'temperatura', 305.0000, 'ºC'),
	(275252, 120, '2014-04-01 00:43:01.000000', 'temperatura', 952.0000, 'ºC'),
	(275253, 120, '2014-04-01 00:43:02.000000', 'temperatura', 248.0000, 'ºC'),
	(275254, 120, '2014-04-01 00:43:03.000000', 'temperatura', 783.0000, 'ºC'),
	(275255, 120, '2014-04-01 00:43:04.000000', 'temperatura', 771.0000, 'ºC'),
	(275256, 120, '2014-04-01 00:43:05.000000', 'temperatura', 306.0000, 'ºC'),
	(275257, 120, '2014-04-01 00:43:06.000000', 'temperatura', 416.0000, 'ºC'),
	(275258, 120, '2014-04-01 00:43:07.000000', 'temperatura', 1165.0000, 'ºC'),
	(275259, 120, '2014-04-01 00:43:08.000000', 'temperatura', 978.0000, 'ºC'),
	(275260, 120, '2014-04-01 00:43:09.000000', 'temperatura', 193.0000, 'ºC'),
	(275261, 120, '2014-04-01 00:43:10.000000', 'temperatura', 431.0000, 'ºC'),
	(275262, 120, '2014-04-01 00:43:11.000000', 'temperatura', 378.0000, 'ºC'),
	(275263, 120, '2014-04-01 00:43:12.000000', 'temperatura', 599.0000, 'ºC'),
	(275264, 120, '2014-04-01 00:43:13.000000', 'temperatura', 661.0000, 'ºC'),
	(275265, 120, '2014-04-01 00:43:14.000000', 'temperatura', 306.0000, 'ºC'),
	(275266, 120, '2014-04-01 00:43:15.000000', 'temperatura', 751.0000, 'ºC'),
	(275267, 120, '2014-04-01 00:43:16.000000', 'temperatura', 435.0000, 'ºC'),
	(275268, 120, '2014-04-01 00:43:17.000000', 'temperatura', 1122.0000, 'ºC'),
	(275269, 120, '2014-04-01 00:43:18.000000', 'temperatura', 707.0000, 'ºC'),
	(275270, 120, '2014-04-01 00:43:19.000000', 'temperatura', 170.0000, 'ºC'),
	(275271, 120, '2014-04-01 00:43:20.000000', 'temperatura', 1127.0000, 'ºC'),
	(275272, 120, '2014-04-01 00:43:21.000000', 'temperatura', 328.0000, 'ºC'),
	(275273, 120, '2014-04-01 00:43:22.000000', 'temperatura', 659.0000, 'ºC'),
	(275274, 120, '2014-04-01 00:43:23.000000', 'temperatura', 1111.0000, 'ºC'),
	(275275, 120, '2014-04-01 00:43:24.000000', 'temperatura', 1178.0000, 'ºC'),
	(275276, 120, '2014-04-01 00:43:25.000000', 'temperatura', 156.0000, 'ºC'),
	(275277, 120, '2014-04-01 00:43:26.000000', 'temperatura', 848.0000, 'ºC'),
	(275278, 120, '2014-04-01 00:43:27.000000', 'temperatura', 172.0000, 'ºC'),
	(275279, 120, '2014-04-01 00:43:28.000000', 'temperatura', 719.0000, 'ºC'),
	(275280, 120, '2014-04-01 00:43:29.000000', 'temperatura', 676.0000, 'ºC'),
	(275281, 120, '2014-04-01 00:43:30.000000', 'temperatura', 27.0000, 'ºC'),
	(275282, 120, '2014-04-01 00:43:31.000000', 'temperatura', 504.0000, 'ºC'),
	(275283, 120, '2014-04-01 00:43:32.000000', 'temperatura', 43.0000, 'ºC'),
	(275284, 120, '2014-04-01 00:43:33.000000', 'temperatura', 1100.0000, 'ºC'),
	(275285, 120, '2014-04-01 00:43:34.000000', 'temperatura', 575.0000, 'ºC'),
	(275286, 120, '2014-04-01 00:43:35.000000', 'temperatura', 772.0000, 'ºC'),
	(275287, 120, '2014-04-01 00:43:36.000000', 'temperatura', 938.0000, 'ºC'),
	(275288, 120, '2014-04-01 00:43:37.000000', 'temperatura', 1174.0000, 'ºC'),
	(275289, 120, '2014-04-01 00:43:38.000000', 'temperatura', 658.0000, 'ºC'),
	(275290, 120, '2014-04-01 00:43:39.000000', 'temperatura', 969.0000, 'ºC'),
	(275291, 120, '2014-04-01 00:43:40.000000', 'temperatura', 469.0000, 'ºC'),
	(275292, 120, '2014-04-01 00:43:41.000000', 'temperatura', 639.0000, 'ºC'),
	(275293, 120, '2014-04-01 00:43:42.000000', 'temperatura', 590.0000, 'ºC'),
	(275294, 120, '2014-04-01 00:43:43.000000', 'temperatura', 1031.0000, 'ºC'),
	(275295, 120, '2014-04-01 00:43:44.000000', 'temperatura', 986.0000, 'ºC'),
	(275296, 120, '2014-04-01 00:43:45.000000', 'temperatura', 638.0000, 'ºC'),
	(275297, 120, '2014-04-01 00:43:46.000000', 'temperatura', 232.0000, 'ºC'),
	(275298, 120, '2014-04-01 00:43:47.000000', 'temperatura', 445.0000, 'ºC'),
	(275299, 120, '2014-04-01 00:43:48.000000', 'temperatura', 330.0000, 'ºC'),
	(275300, 120, '2014-04-01 00:43:49.000000', 'temperatura', 316.0000, 'ºC'),
	(275301, 120, '2014-04-01 00:43:50.000000', 'temperatura', 589.0000, 'ºC'),
	(275302, 120, '2014-04-01 00:43:51.000000', 'temperatura', 801.0000, 'ºC'),
	(275303, 120, '2014-04-01 00:43:52.000000', 'temperatura', 1035.0000, 'ºC'),
	(275304, 120, '2014-04-01 00:43:53.000000', 'temperatura', 375.0000, 'ºC'),
	(275305, 120, '2014-04-01 00:43:54.000000', 'temperatura', 1168.0000, 'ºC'),
	(275306, 120, '2014-04-01 00:43:55.000000', 'temperatura', 1118.0000, 'ºC'),
	(275307, 120, '2014-04-01 00:43:56.000000', 'temperatura', 885.0000, 'ºC'),
	(275308, 120, '2014-04-01 00:43:57.000000', 'temperatura', 1071.0000, 'ºC'),
	(275309, 120, '2014-04-01 00:43:58.000000', 'temperatura', 299.0000, 'ºC'),
	(275310, 120, '2014-04-01 00:43:59.000000', 'temperatura', 685.0000, 'ºC'),
	(275311, 120, '2014-04-01 00:44:00.000000', 'temperatura', 126.0000, 'ºC'),
	(275312, 120, '2014-04-01 00:44:01.000000', 'temperatura', 978.0000, 'ºC'),
	(275313, 120, '2014-04-01 00:44:02.000000', 'temperatura', 910.0000, 'ºC'),
	(275314, 120, '2014-04-01 00:44:03.000000', 'temperatura', 418.0000, 'ºC'),
	(275315, 120, '2014-04-01 00:44:04.000000', 'temperatura', 560.0000, 'ºC'),
	(275316, 120, '2014-04-01 00:44:05.000000', 'temperatura', 347.0000, 'ºC'),
	(275317, 120, '2014-04-01 00:44:06.000000', 'temperatura', 56.0000, 'ºC'),
	(275318, 120, '2014-04-01 00:44:07.000000', 'temperatura', 438.0000, 'ºC'),
	(275319, 120, '2014-04-01 00:44:08.000000', 'temperatura', 825.0000, 'ºC'),
	(275320, 120, '2014-04-01 00:44:09.000000', 'temperatura', 411.0000, 'ºC'),
	(275321, 120, '2014-04-01 00:44:10.000000', 'temperatura', 778.0000, 'ºC'),
	(275322, 120, '2014-04-01 00:44:11.000000', 'temperatura', 261.0000, 'ºC'),
	(275323, 120, '2014-04-01 00:44:12.000000', 'temperatura', 168.0000, 'ºC'),
	(275324, 120, '2014-04-01 00:44:13.000000', 'temperatura', 61.0000, 'ºC'),
	(275325, 120, '2014-04-01 00:44:14.000000', 'temperatura', 998.0000, 'ºC'),
	(275326, 120, '2014-04-01 00:44:15.000000', 'temperatura', 9.0000, 'ºC'),
	(275327, 120, '2014-04-01 00:44:16.000000', 'temperatura', 652.0000, 'ºC'),
	(275328, 120, '2014-04-01 00:44:17.000000', 'temperatura', 831.0000, 'ºC'),
	(275329, 120, '2014-04-01 00:44:18.000000', 'temperatura', 1003.0000, 'ºC'),
	(275330, 120, '2014-04-01 00:44:19.000000', 'temperatura', 121.0000, 'ºC'),
	(275331, 120, '2014-04-01 00:44:20.000000', 'temperatura', 1198.0000, 'ºC'),
	(275332, 120, '2014-04-01 00:44:21.000000', 'temperatura', 826.0000, 'ºC'),
	(275333, 120, '2014-04-01 00:44:22.000000', 'temperatura', 537.0000, 'ºC'),
	(275334, 120, '2014-04-01 00:44:23.000000', 'temperatura', 210.0000, 'ºC'),
	(275335, 120, '2014-04-01 00:44:24.000000', 'temperatura', 636.0000, 'ºC'),
	(275336, 120, '2014-04-01 00:44:25.000000', 'temperatura', 150.0000, 'ºC'),
	(275337, 120, '2014-04-01 00:44:26.000000', 'temperatura', 46.0000, 'ºC'),
	(275338, 120, '2014-04-01 00:44:27.000000', 'temperatura', 977.0000, 'ºC'),
	(275339, 120, '2014-04-01 00:44:28.000000', 'temperatura', 1149.0000, 'ºC'),
	(275340, 120, '2014-04-01 00:44:29.000000', 'temperatura', 416.0000, 'ºC'),
	(275341, 120, '2014-04-01 00:44:30.000000', 'temperatura', 1033.0000, 'ºC'),
	(275342, 120, '2014-04-01 00:44:31.000000', 'temperatura', 318.0000, 'ºC'),
	(275343, 120, '2014-04-01 00:44:32.000000', 'temperatura', 890.0000, 'ºC'),
	(275344, 120, '2014-04-01 00:44:33.000000', 'temperatura', 1098.0000, 'ºC'),
	(275345, 120, '2014-04-01 00:44:34.000000', 'temperatura', 420.0000, 'ºC'),
	(275346, 120, '2014-04-01 00:44:35.000000', 'temperatura', 8.0000, 'ºC'),
	(275347, 120, '2014-04-01 00:44:36.000000', 'temperatura', 1180.0000, 'ºC'),
	(275348, 120, '2014-04-01 00:44:37.000000', 'temperatura', 1078.0000, 'ºC'),
	(275349, 120, '2014-04-01 00:44:38.000000', 'temperatura', 649.0000, 'ºC'),
	(275350, 120, '2014-04-01 00:44:39.000000', 'temperatura', 13.0000, 'ºC'),
	(275351, 120, '2014-04-01 00:44:40.000000', 'temperatura', 516.0000, 'ºC'),
	(275352, 120, '2014-04-01 00:44:41.000000', 'temperatura', 143.0000, 'ºC'),
	(275353, 120, '2014-04-01 00:44:42.000000', 'temperatura', 366.0000, 'ºC'),
	(275354, 120, '2014-04-01 00:44:43.000000', 'temperatura', 202.0000, 'ºC'),
	(275355, 120, '2014-04-01 00:44:44.000000', 'temperatura', 1112.0000, 'ºC'),
	(275356, 120, '2014-04-01 00:44:45.000000', 'temperatura', 156.0000, 'ºC'),
	(275357, 120, '2014-04-01 00:44:46.000000', 'temperatura', 1042.0000, 'ºC'),
	(275358, 120, '2014-04-01 00:44:47.000000', 'temperatura', 1144.0000, 'ºC'),
	(275359, 120, '2014-04-01 00:44:48.000000', 'temperatura', 195.0000, 'ºC'),
	(275360, 120, '2014-04-01 00:44:49.000000', 'temperatura', 1144.0000, 'ºC'),
	(275361, 120, '2014-04-01 00:44:50.000000', 'temperatura', 335.0000, 'ºC'),
	(275362, 120, '2014-04-01 00:44:51.000000', 'temperatura', 644.0000, 'ºC'),
	(275363, 120, '2014-04-01 00:44:52.000000', 'temperatura', 1015.0000, 'ºC'),
	(275364, 120, '2014-04-01 00:44:53.000000', 'temperatura', 743.0000, 'ºC'),
	(275365, 120, '2014-04-01 00:44:54.000000', 'temperatura', 672.0000, 'ºC'),
	(275366, 120, '2014-04-01 00:44:55.000000', 'temperatura', 1130.0000, 'ºC'),
	(275367, 120, '2014-04-01 00:44:56.000000', 'temperatura', 37.0000, 'ºC'),
	(275368, 120, '2014-04-01 00:44:57.000000', 'temperatura', 394.0000, 'ºC'),
	(275369, 120, '2014-04-01 00:44:58.000000', 'temperatura', 660.0000, 'ºC'),
	(275370, 120, '2014-04-01 00:44:59.000000', 'temperatura', 917.0000, 'ºC'),
	(275371, 120, '2014-04-01 00:45:00.000000', 'temperatura', 207.0000, 'ºC'),
	(275372, 120, '2014-04-01 00:45:01.000000', 'temperatura', 686.0000, 'ºC'),
	(275373, 120, '2014-04-01 00:45:02.000000', 'temperatura', 408.0000, 'ºC'),
	(275374, 120, '2014-04-01 00:45:03.000000', 'temperatura', 1181.0000, 'ºC'),
	(275375, 120, '2014-04-01 00:45:04.000000', 'temperatura', 1083.0000, 'ºC'),
	(275376, 120, '2014-04-01 00:45:05.000000', 'temperatura', 671.0000, 'ºC'),
	(275377, 120, '2014-04-01 00:45:06.000000', 'temperatura', 108.0000, 'ºC'),
	(275378, 120, '2014-04-01 00:45:07.000000', 'temperatura', 927.0000, 'ºC'),
	(275379, 120, '2014-04-01 00:45:08.000000', 'temperatura', 714.0000, 'ºC'),
	(275380, 120, '2014-04-01 00:45:09.000000', 'temperatura', 786.0000, 'ºC'),
	(275381, 120, '2014-04-01 00:45:10.000000', 'temperatura', 588.0000, 'ºC'),
	(275382, 120, '2014-04-01 00:45:11.000000', 'temperatura', 585.0000, 'ºC'),
	(275383, 120, '2014-04-01 00:45:12.000000', 'temperatura', 1160.0000, 'ºC'),
	(275384, 120, '2014-04-01 00:45:13.000000', 'temperatura', 447.0000, 'ºC'),
	(275385, 120, '2014-04-01 00:45:14.000000', 'temperatura', 1154.0000, 'ºC'),
	(275386, 120, '2014-04-01 00:45:15.000000', 'temperatura', 832.0000, 'ºC'),
	(275387, 120, '2014-04-01 00:45:16.000000', 'temperatura', 696.0000, 'ºC'),
	(275388, 120, '2014-04-01 00:45:17.000000', 'temperatura', 987.0000, 'ºC'),
	(275389, 120, '2014-04-01 00:45:18.000000', 'temperatura', 447.0000, 'ºC'),
	(275390, 120, '2014-04-01 00:45:19.000000', 'temperatura', 473.0000, 'ºC'),
	(275391, 120, '2014-04-01 00:45:20.000000', 'temperatura', 1024.0000, 'ºC'),
	(275392, 120, '2014-04-01 00:45:21.000000', 'temperatura', 104.0000, 'ºC'),
	(275393, 120, '2014-04-01 00:45:22.000000', 'temperatura', 1047.0000, 'ºC'),
	(275394, 120, '2014-04-01 00:45:23.000000', 'temperatura', 123.0000, 'ºC'),
	(275395, 120, '2014-04-01 00:45:24.000000', 'temperatura', 1074.0000, 'ºC'),
	(275396, 120, '2014-04-01 00:45:25.000000', 'temperatura', 203.0000, 'ºC'),
	(275397, 120, '2014-04-01 00:45:26.000000', 'temperatura', 194.0000, 'ºC'),
	(275398, 120, '2014-04-01 00:45:27.000000', 'temperatura', 359.0000, 'ºC'),
	(275399, 120, '2014-04-01 00:45:28.000000', 'temperatura', 15.0000, 'ºC'),
	(275400, 120, '2014-04-01 00:45:29.000000', 'temperatura', 197.0000, 'ºC'),
	(275401, 120, '2014-04-01 00:45:30.000000', 'temperatura', 942.0000, 'ºC'),
	(275402, 120, '2014-04-01 00:45:31.000000', 'temperatura', 517.0000, 'ºC'),
	(275403, 120, '2014-04-01 00:45:32.000000', 'temperatura', 962.0000, 'ºC'),
	(275404, 120, '2014-04-01 00:45:33.000000', 'temperatura', 859.0000, 'ºC'),
	(275405, 120, '2014-04-01 00:45:34.000000', 'temperatura', 209.0000, 'ºC'),
	(275406, 120, '2014-04-01 00:45:35.000000', 'temperatura', 870.0000, 'ºC'),
	(275407, 120, '2014-04-01 00:45:36.000000', 'temperatura', 123.0000, 'ºC'),
	(275408, 120, '2014-04-01 00:45:37.000000', 'temperatura', 406.0000, 'ºC'),
	(275409, 120, '2014-04-01 00:45:38.000000', 'temperatura', 463.0000, 'ºC'),
	(275410, 120, '2014-04-01 00:45:39.000000', 'temperatura', 1096.0000, 'ºC'),
	(275411, 120, '2014-04-01 00:45:40.000000', 'temperatura', 491.0000, 'ºC'),
	(275412, 120, '2014-04-01 00:45:41.000000', 'temperatura', 369.0000, 'ºC'),
	(275413, 120, '2014-04-01 00:45:42.000000', 'temperatura', 371.0000, 'ºC'),
	(275414, 120, '2014-04-01 00:45:43.000000', 'temperatura', 749.0000, 'ºC'),
	(275415, 120, '2014-04-01 00:45:44.000000', 'temperatura', 232.0000, 'ºC'),
	(275416, 120, '2014-04-01 00:45:45.000000', 'temperatura', 113.0000, 'ºC'),
	(275417, 120, '2014-04-01 00:45:46.000000', 'temperatura', 1071.0000, 'ºC'),
	(275418, 120, '2014-04-01 00:45:47.000000', 'temperatura', 215.0000, 'ºC'),
	(275419, 120, '2014-04-01 00:45:48.000000', 'temperatura', 261.0000, 'ºC'),
	(275420, 120, '2014-04-01 00:45:49.000000', 'temperatura', 663.0000, 'ºC'),
	(275421, 120, '2014-04-01 00:45:50.000000', 'temperatura', 131.0000, 'ºC'),
	(275422, 120, '2014-04-01 00:45:51.000000', 'temperatura', 1069.0000, 'ºC'),
	(275423, 120, '2014-04-01 00:45:52.000000', 'temperatura', 152.0000, 'ºC'),
	(275424, 120, '2014-04-01 00:45:53.000000', 'temperatura', 1152.0000, 'ºC'),
	(275425, 120, '2014-04-01 00:45:54.000000', 'temperatura', 506.0000, 'ºC'),
	(275426, 120, '2014-04-01 00:45:55.000000', 'temperatura', 273.0000, 'ºC'),
	(275427, 120, '2014-04-01 00:45:56.000000', 'temperatura', 1050.0000, 'ºC'),
	(275428, 120, '2014-04-01 00:45:57.000000', 'temperatura', 829.0000, 'ºC'),
	(275429, 120, '2014-04-01 00:45:58.000000', 'temperatura', 997.0000, 'ºC'),
	(275430, 120, '2014-04-01 00:45:59.000000', 'temperatura', 96.0000, 'ºC'),
	(275431, 120, '2014-04-01 00:46:00.000000', 'temperatura', 1092.0000, 'ºC'),
	(275432, 120, '2014-04-01 00:46:01.000000', 'temperatura', 371.0000, 'ºC'),
	(275433, 120, '2014-04-01 00:46:02.000000', 'temperatura', 981.0000, 'ºC'),
	(275434, 120, '2014-04-01 00:46:03.000000', 'temperatura', 191.0000, 'ºC'),
	(275435, 120, '2014-04-01 00:46:04.000000', 'temperatura', 411.0000, 'ºC'),
	(275436, 120, '2014-04-01 00:46:05.000000', 'temperatura', 284.0000, 'ºC'),
	(275437, 120, '2014-04-01 00:46:06.000000', 'temperatura', 187.0000, 'ºC'),
	(275438, 120, '2014-04-01 00:46:07.000000', 'temperatura', 85.0000, 'ºC'),
	(275439, 120, '2014-04-01 00:46:08.000000', 'temperatura', 1066.0000, 'ºC'),
	(275440, 120, '2014-04-01 00:46:09.000000', 'temperatura', 273.0000, 'ºC'),
	(275441, 120, '2014-04-01 00:46:10.000000', 'temperatura', 566.0000, 'ºC'),
	(275442, 120, '2014-04-01 00:46:11.000000', 'temperatura', 815.0000, 'ºC'),
	(275443, 120, '2014-04-01 00:46:12.000000', 'temperatura', 1177.0000, 'ºC'),
	(275444, 120, '2014-04-01 00:46:13.000000', 'temperatura', 1038.0000, 'ºC'),
	(275445, 120, '2014-04-01 00:46:14.000000', 'temperatura', 462.0000, 'ºC'),
	(275446, 120, '2014-04-01 00:46:15.000000', 'temperatura', 394.0000, 'ºC'),
	(275447, 120, '2014-04-01 00:46:16.000000', 'temperatura', 587.0000, 'ºC'),
	(275448, 120, '2014-04-01 00:46:17.000000', 'temperatura', 552.0000, 'ºC'),
	(275449, 120, '2014-04-01 00:46:18.000000', 'temperatura', 998.0000, 'ºC'),
	(275450, 120, '2014-04-01 00:46:19.000000', 'temperatura', 935.0000, 'ºC'),
	(275451, 120, '2014-04-01 00:46:20.000000', 'temperatura', 483.0000, 'ºC'),
	(275452, 120, '2014-04-01 00:46:21.000000', 'temperatura', 808.0000, 'ºC'),
	(275453, 120, '2014-04-01 00:46:22.000000', 'temperatura', 194.0000, 'ºC'),
	(275454, 120, '2014-04-01 00:46:23.000000', 'temperatura', 948.0000, 'ºC'),
	(275455, 120, '2014-04-01 00:46:24.000000', 'temperatura', 556.0000, 'ºC'),
	(275456, 120, '2014-04-01 00:46:25.000000', 'temperatura', 1136.0000, 'ºC'),
	(275457, 120, '2014-04-01 00:46:26.000000', 'temperatura', 412.0000, 'ºC'),
	(275458, 120, '2014-04-01 00:46:27.000000', 'temperatura', 1055.0000, 'ºC'),
	(275459, 120, '2014-04-01 00:46:28.000000', 'temperatura', 438.0000, 'ºC'),
	(275460, 120, '2014-04-01 00:46:29.000000', 'temperatura', 227.0000, 'ºC'),
	(275461, 120, '2014-04-01 00:46:30.000000', 'temperatura', 1020.0000, 'ºC'),
	(275462, 120, '2014-04-01 00:46:31.000000', 'temperatura', 822.0000, 'ºC'),
	(275463, 120, '2014-04-01 00:46:32.000000', 'temperatura', 1048.0000, 'ºC'),
	(275464, 120, '2014-04-01 00:46:33.000000', 'temperatura', 375.0000, 'ºC'),
	(275465, 120, '2014-04-01 00:46:34.000000', 'temperatura', 1133.0000, 'ºC'),
	(275466, 120, '2014-04-01 00:46:35.000000', 'temperatura', 939.0000, 'ºC'),
	(275467, 120, '2014-04-01 00:46:36.000000', 'temperatura', 97.0000, 'ºC'),
	(275468, 120, '2014-04-01 00:46:37.000000', 'temperatura', 69.0000, 'ºC'),
	(275469, 120, '2014-04-01 00:46:38.000000', 'temperatura', 52.0000, 'ºC'),
	(275470, 120, '2014-04-01 00:46:39.000000', 'temperatura', 57.0000, 'ºC'),
	(275471, 120, '2014-04-01 00:46:40.000000', 'temperatura', 128.0000, 'ºC'),
	(275472, 120, '2014-04-01 00:46:41.000000', 'temperatura', 470.0000, 'ºC'),
	(275473, 120, '2014-04-01 00:46:42.000000', 'temperatura', 766.0000, 'ºC'),
	(275474, 120, '2014-04-01 00:46:43.000000', 'temperatura', 21.0000, 'ºC'),
	(275475, 120, '2014-04-01 00:46:44.000000', 'temperatura', 209.0000, 'ºC'),
	(275476, 120, '2014-04-01 00:46:45.000000', 'temperatura', 982.0000, 'ºC'),
	(275477, 120, '2014-04-01 00:46:46.000000', 'temperatura', 684.0000, 'ºC'),
	(275478, 120, '2014-04-01 00:46:47.000000', 'temperatura', 473.0000, 'ºC'),
	(275479, 120, '2014-04-01 00:46:48.000000', 'temperatura', 313.0000, 'ºC'),
	(275480, 120, '2014-04-01 00:46:49.000000', 'temperatura', 149.0000, 'ºC'),
	(275481, 120, '2014-04-01 00:46:50.000000', 'temperatura', 1005.0000, 'ºC'),
	(275482, 120, '2014-04-01 00:46:51.000000', 'temperatura', 979.0000, 'ºC'),
	(275483, 120, '2014-04-01 00:46:52.000000', 'temperatura', 678.0000, 'ºC'),
	(275484, 120, '2014-04-01 00:46:53.000000', 'temperatura', 457.0000, 'ºC'),
	(275485, 120, '2014-04-01 00:46:54.000000', 'temperatura', 250.0000, 'ºC'),
	(275486, 120, '2014-04-01 00:46:55.000000', 'temperatura', 1078.0000, 'ºC'),
	(275487, 120, '2014-04-01 00:46:56.000000', 'temperatura', 1041.0000, 'ºC'),
	(275488, 120, '2014-04-01 00:46:57.000000', 'temperatura', 770.0000, 'ºC'),
	(275489, 120, '2014-04-01 00:46:58.000000', 'temperatura', 729.0000, 'ºC'),
	(275490, 120, '2014-04-01 00:46:59.000000', 'temperatura', 137.0000, 'ºC'),
	(275491, 120, '2014-04-01 00:47:00.000000', 'temperatura', 895.0000, 'ºC'),
	(275492, 120, '2014-04-01 00:47:01.000000', 'temperatura', 468.0000, 'ºC'),
	(275493, 120, '2014-04-01 00:47:02.000000', 'temperatura', 855.0000, 'ºC'),
	(275494, 120, '2014-04-01 00:47:03.000000', 'temperatura', 471.0000, 'ºC'),
	(275495, 120, '2014-04-01 00:47:04.000000', 'temperatura', 992.0000, 'ºC'),
	(275496, 120, '2014-04-01 00:47:05.000000', 'temperatura', 1145.0000, 'ºC'),
	(275497, 120, '2014-04-01 00:47:06.000000', 'temperatura', 352.0000, 'ºC'),
	(275498, 120, '2014-04-01 00:47:07.000000', 'temperatura', 724.0000, 'ºC'),
	(275499, 120, '2014-04-01 00:47:08.000000', 'temperatura', 164.0000, 'ºC'),
	(275500, 120, '2014-04-01 00:47:09.000000', 'temperatura', 1049.0000, 'ºC'),
	(275501, 120, '2014-04-01 00:47:10.000000', 'temperatura', 1155.0000, 'ºC'),
	(275502, 120, '2014-04-01 00:47:11.000000', 'temperatura', 229.0000, 'ºC'),
	(275503, 120, '2014-04-01 00:47:12.000000', 'temperatura', 78.0000, 'ºC'),
	(275504, 120, '2014-04-01 00:47:13.000000', 'temperatura', 903.0000, 'ºC'),
	(275505, 120, '2014-04-01 00:47:14.000000', 'temperatura', 683.0000, 'ºC'),
	(275506, 120, '2014-04-01 00:47:15.000000', 'temperatura', 704.0000, 'ºC'),
	(275507, 120, '2014-04-01 00:47:16.000000', 'temperatura', 275.0000, 'ºC'),
	(275508, 120, '2014-04-01 00:47:17.000000', 'temperatura', 460.0000, 'ºC'),
	(275509, 120, '2014-04-01 00:47:18.000000', 'temperatura', 279.0000, 'ºC'),
	(275510, 120, '2014-04-01 00:47:19.000000', 'temperatura', 13.0000, 'ºC'),
	(275511, 120, '2014-04-01 00:47:20.000000', 'temperatura', 430.0000, 'ºC'),
	(275512, 120, '2014-04-01 00:47:21.000000', 'temperatura', 909.0000, 'ºC'),
	(275513, 120, '2014-04-01 00:47:22.000000', 'temperatura', 857.0000, 'ºC'),
	(275514, 120, '2014-04-01 00:47:23.000000', 'temperatura', 358.0000, 'ºC'),
	(275515, 120, '2014-04-01 00:47:24.000000', 'temperatura', 420.0000, 'ºC'),
	(275516, 120, '2014-04-01 00:47:25.000000', 'temperatura', 1027.0000, 'ºC'),
	(275517, 120, '2014-04-01 00:47:26.000000', 'temperatura', 276.0000, 'ºC'),
	(275518, 120, '2014-04-01 00:47:27.000000', 'temperatura', 701.0000, 'ºC'),
	(275519, 120, '2014-04-01 00:47:28.000000', 'temperatura', 275.0000, 'ºC'),
	(275520, 120, '2014-04-01 00:47:29.000000', 'temperatura', 474.0000, 'ºC'),
	(275521, 120, '2014-04-01 00:47:30.000000', 'temperatura', 347.0000, 'ºC'),
	(275522, 120, '2014-04-01 00:47:31.000000', 'temperatura', 311.0000, 'ºC'),
	(275523, 120, '2014-04-01 00:47:32.000000', 'temperatura', 516.0000, 'ºC'),
	(275524, 120, '2014-04-01 00:47:33.000000', 'temperatura', 447.0000, 'ºC'),
	(275525, 120, '2014-04-01 00:47:34.000000', 'temperatura', 689.0000, 'ºC'),
	(275526, 120, '2014-04-01 00:47:35.000000', 'temperatura', 902.0000, 'ºC'),
	(275527, 120, '2014-04-01 00:47:36.000000', 'temperatura', 46.0000, 'ºC'),
	(275528, 120, '2014-04-01 00:47:37.000000', 'temperatura', 1122.0000, 'ºC'),
	(275529, 120, '2014-04-01 00:47:38.000000', 'temperatura', 672.0000, 'ºC'),
	(275530, 120, '2014-04-01 00:47:39.000000', 'temperatura', 1198.0000, 'ºC'),
	(275531, 120, '2014-04-01 00:47:40.000000', 'temperatura', 371.0000, 'ºC'),
	(275532, 120, '2014-04-01 00:47:41.000000', 'temperatura', 664.0000, 'ºC'),
	(275533, 120, '2014-04-01 00:47:42.000000', 'temperatura', 1007.0000, 'ºC'),
	(275534, 120, '2014-04-01 00:47:43.000000', 'temperatura', 643.0000, 'ºC'),
	(275535, 120, '2014-04-01 00:47:44.000000', 'temperatura', 193.0000, 'ºC'),
	(275536, 120, '2014-04-01 00:47:45.000000', 'temperatura', 237.0000, 'ºC'),
	(275537, 120, '2014-04-01 00:47:46.000000', 'temperatura', 606.0000, 'ºC'),
	(275538, 120, '2014-04-01 00:47:47.000000', 'temperatura', 1120.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(275539, 120, '2014-04-01 00:47:48.000000', 'temperatura', 181.0000, 'ºC'),
	(275540, 120, '2014-04-01 00:47:49.000000', 'temperatura', 1147.0000, 'ºC'),
	(275541, 120, '2014-04-01 00:47:50.000000', 'temperatura', 394.0000, 'ºC'),
	(275542, 120, '2014-04-01 00:47:51.000000', 'temperatura', 926.0000, 'ºC'),
	(275543, 120, '2014-04-01 00:47:52.000000', 'temperatura', 1051.0000, 'ºC'),
	(275544, 120, '2014-04-01 00:47:53.000000', 'temperatura', 77.0000, 'ºC'),
	(275545, 120, '2014-04-01 00:47:54.000000', 'temperatura', 833.0000, 'ºC'),
	(275546, 120, '2014-04-01 00:47:55.000000', 'temperatura', 335.0000, 'ºC'),
	(275547, 120, '2014-04-01 00:47:56.000000', 'temperatura', 378.0000, 'ºC'),
	(275548, 120, '2014-04-01 00:47:57.000000', 'temperatura', 882.0000, 'ºC'),
	(275549, 120, '2014-04-01 00:47:58.000000', 'temperatura', 878.0000, 'ºC'),
	(275550, 120, '2014-04-01 00:47:59.000000', 'temperatura', 546.0000, 'ºC'),
	(275551, 120, '2014-04-01 00:48:00.000000', 'temperatura', 96.0000, 'ºC'),
	(275552, 120, '2014-04-01 00:48:01.000000', 'temperatura', 43.0000, 'ºC'),
	(275553, 120, '2014-04-01 00:48:02.000000', 'temperatura', 1129.0000, 'ºC'),
	(275554, 120, '2014-04-01 00:48:03.000000', 'temperatura', 714.0000, 'ºC'),
	(275555, 120, '2014-04-01 00:48:04.000000', 'temperatura', 186.0000, 'ºC'),
	(275556, 120, '2014-04-01 00:48:05.000000', 'temperatura', 1185.0000, 'ºC'),
	(275557, 120, '2014-04-01 00:48:06.000000', 'temperatura', 570.0000, 'ºC'),
	(275558, 120, '2014-04-01 00:48:07.000000', 'temperatura', 494.0000, 'ºC'),
	(275559, 120, '2014-04-01 00:48:08.000000', 'temperatura', 759.0000, 'ºC'),
	(275560, 120, '2014-04-01 00:48:09.000000', 'temperatura', 1116.0000, 'ºC'),
	(275561, 120, '2014-04-01 00:48:10.000000', 'temperatura', 902.0000, 'ºC'),
	(275562, 120, '2014-04-01 00:48:11.000000', 'temperatura', 1165.0000, 'ºC'),
	(275563, 120, '2014-04-01 00:48:12.000000', 'temperatura', 718.0000, 'ºC'),
	(275564, 120, '2014-04-01 00:48:13.000000', 'temperatura', 97.0000, 'ºC'),
	(275565, 120, '2014-04-01 00:48:14.000000', 'temperatura', 731.0000, 'ºC'),
	(275566, 120, '2014-04-01 00:48:15.000000', 'temperatura', 964.0000, 'ºC'),
	(275567, 120, '2014-04-01 00:48:16.000000', 'temperatura', 226.0000, 'ºC'),
	(275568, 120, '2014-04-01 00:48:17.000000', 'temperatura', 641.0000, 'ºC'),
	(275569, 120, '2014-04-01 00:48:18.000000', 'temperatura', 126.0000, 'ºC'),
	(275570, 120, '2014-04-01 00:48:19.000000', 'temperatura', 1109.0000, 'ºC'),
	(275571, 120, '2014-04-01 00:48:20.000000', 'temperatura', 368.0000, 'ºC'),
	(275572, 120, '2014-04-01 00:48:21.000000', 'temperatura', 912.0000, 'ºC'),
	(275573, 120, '2014-04-01 00:48:22.000000', 'temperatura', 1055.0000, 'ºC'),
	(275574, 120, '2014-04-01 00:48:23.000000', 'temperatura', 140.0000, 'ºC'),
	(275575, 120, '2014-04-01 00:48:24.000000', 'temperatura', 1138.0000, 'ºC'),
	(275576, 120, '2014-04-01 00:48:25.000000', 'temperatura', 470.0000, 'ºC'),
	(275577, 120, '2014-04-01 00:48:26.000000', 'temperatura', 136.0000, 'ºC'),
	(275578, 120, '2014-04-01 00:48:27.000000', 'temperatura', 472.0000, 'ºC'),
	(275579, 120, '2014-04-01 00:48:28.000000', 'temperatura', 750.0000, 'ºC'),
	(275580, 120, '2014-04-01 00:48:29.000000', 'temperatura', 1134.0000, 'ºC'),
	(275581, 120, '2014-04-01 00:48:30.000000', 'temperatura', 1020.0000, 'ºC'),
	(275582, 120, '2014-04-01 00:48:31.000000', 'temperatura', 500.0000, 'ºC'),
	(275583, 120, '2014-04-01 00:48:32.000000', 'temperatura', 641.0000, 'ºC'),
	(275584, 120, '2014-04-01 00:48:33.000000', 'temperatura', 506.0000, 'ºC'),
	(275585, 120, '2014-04-01 00:48:34.000000', 'temperatura', 606.0000, 'ºC'),
	(275586, 120, '2014-04-01 00:48:35.000000', 'temperatura', 313.0000, 'ºC'),
	(275587, 120, '2014-04-01 00:48:36.000000', 'temperatura', 947.0000, 'ºC'),
	(275588, 120, '2014-04-01 00:48:37.000000', 'temperatura', 198.0000, 'ºC'),
	(275589, 120, '2014-04-01 00:48:38.000000', 'temperatura', 549.0000, 'ºC'),
	(275590, 120, '2014-04-01 00:48:39.000000', 'temperatura', 951.0000, 'ºC'),
	(275591, 120, '2014-04-01 00:48:40.000000', 'temperatura', 710.0000, 'ºC'),
	(275592, 120, '2014-04-01 00:48:41.000000', 'temperatura', 695.0000, 'ºC'),
	(275593, 120, '2014-04-01 00:48:42.000000', 'temperatura', 148.0000, 'ºC'),
	(275594, 120, '2014-04-01 00:48:43.000000', 'temperatura', 1057.0000, 'ºC'),
	(275595, 120, '2014-04-01 00:48:44.000000', 'temperatura', 38.0000, 'ºC'),
	(275596, 120, '2014-04-01 00:48:45.000000', 'temperatura', 621.0000, 'ºC'),
	(275597, 120, '2014-04-01 00:48:46.000000', 'temperatura', 592.0000, 'ºC'),
	(275598, 120, '2014-04-01 00:48:47.000000', 'temperatura', 1096.0000, 'ºC'),
	(275599, 120, '2014-04-01 00:48:48.000000', 'temperatura', 107.0000, 'ºC'),
	(275600, 120, '2014-04-01 00:48:49.000000', 'temperatura', 848.0000, 'ºC'),
	(275601, 120, '2014-04-01 00:48:50.000000', 'temperatura', 317.0000, 'ºC'),
	(275602, 120, '2014-04-01 00:48:51.000000', 'temperatura', 243.0000, 'ºC'),
	(275603, 120, '2014-04-01 00:48:52.000000', 'temperatura', 264.0000, 'ºC'),
	(275604, 120, '2014-04-01 00:48:53.000000', 'temperatura', 590.0000, 'ºC'),
	(275605, 120, '2014-04-01 00:48:54.000000', 'temperatura', 961.0000, 'ºC'),
	(275606, 120, '2014-04-01 00:48:55.000000', 'temperatura', 633.0000, 'ºC'),
	(275607, 120, '2014-04-01 00:48:56.000000', 'temperatura', 282.0000, 'ºC'),
	(275608, 120, '2014-04-01 00:48:57.000000', 'temperatura', 713.0000, 'ºC'),
	(275609, 120, '2014-04-01 00:48:58.000000', 'temperatura', 321.0000, 'ºC'),
	(275610, 120, '2014-04-01 00:48:59.000000', 'temperatura', 666.0000, 'ºC'),
	(275611, 120, '2014-04-01 00:49:00.000000', 'temperatura', 1165.0000, 'ºC'),
	(275612, 120, '2014-04-01 00:49:01.000000', 'temperatura', 230.0000, 'ºC'),
	(275613, 120, '2014-04-01 00:49:02.000000', 'temperatura', 53.0000, 'ºC'),
	(275614, 120, '2014-04-01 00:49:03.000000', 'temperatura', 778.0000, 'ºC'),
	(275615, 120, '2014-04-01 00:49:04.000000', 'temperatura', 131.0000, 'ºC'),
	(275616, 120, '2014-04-01 00:49:05.000000', 'temperatura', 723.0000, 'ºC'),
	(275617, 120, '2014-04-01 00:49:06.000000', 'temperatura', 820.0000, 'ºC'),
	(275618, 120, '2014-04-01 00:49:07.000000', 'temperatura', 734.0000, 'ºC'),
	(275619, 120, '2014-04-01 00:49:08.000000', 'temperatura', 9.0000, 'ºC'),
	(275620, 120, '2014-04-01 00:49:09.000000', 'temperatura', 243.0000, 'ºC'),
	(275621, 120, '2014-04-01 00:49:10.000000', 'temperatura', 1190.0000, 'ºC'),
	(275622, 120, '2014-04-01 00:49:11.000000', 'temperatura', 420.0000, 'ºC'),
	(275623, 120, '2014-04-01 00:49:12.000000', 'temperatura', 933.0000, 'ºC'),
	(275624, 120, '2014-04-01 00:49:13.000000', 'temperatura', 1005.0000, 'ºC'),
	(275625, 120, '2014-04-01 00:49:14.000000', 'temperatura', 1024.0000, 'ºC'),
	(275626, 120, '2014-04-01 00:49:15.000000', 'temperatura', 906.0000, 'ºC'),
	(275627, 120, '2014-04-01 00:49:16.000000', 'temperatura', 261.0000, 'ºC'),
	(275628, 120, '2014-04-01 00:49:17.000000', 'temperatura', 987.0000, 'ºC'),
	(275629, 120, '2014-04-01 00:49:18.000000', 'temperatura', 550.0000, 'ºC'),
	(275630, 120, '2014-04-01 00:49:19.000000', 'temperatura', 993.0000, 'ºC'),
	(275631, 120, '2014-04-01 00:49:20.000000', 'temperatura', 913.0000, 'ºC'),
	(275632, 120, '2014-04-01 00:49:21.000000', 'temperatura', 386.0000, 'ºC'),
	(275633, 120, '2014-04-01 00:49:22.000000', 'temperatura', 393.0000, 'ºC'),
	(275634, 120, '2014-04-01 00:49:23.000000', 'temperatura', 807.0000, 'ºC'),
	(275635, 120, '2014-04-01 00:49:24.000000', 'temperatura', 456.0000, 'ºC'),
	(275636, 120, '2014-04-01 00:49:25.000000', 'temperatura', 1062.0000, 'ºC'),
	(275637, 120, '2014-04-01 00:49:26.000000', 'temperatura', 340.0000, 'ºC'),
	(275638, 120, '2014-04-01 00:49:27.000000', 'temperatura', 913.0000, 'ºC'),
	(275639, 120, '2014-04-01 00:49:28.000000', 'temperatura', 1147.0000, 'ºC'),
	(275640, 120, '2014-04-01 00:49:29.000000', 'temperatura', 598.0000, 'ºC'),
	(275641, 120, '2014-04-01 00:49:30.000000', 'temperatura', 750.0000, 'ºC'),
	(275642, 120, '2014-04-01 00:49:31.000000', 'temperatura', 755.0000, 'ºC'),
	(275643, 120, '2014-04-01 00:49:32.000000', 'temperatura', 327.0000, 'ºC'),
	(275644, 120, '2014-04-01 00:49:33.000000', 'temperatura', 572.0000, 'ºC'),
	(275645, 120, '2014-04-01 00:49:34.000000', 'temperatura', 676.0000, 'ºC'),
	(275646, 120, '2014-04-01 00:49:35.000000', 'temperatura', 466.0000, 'ºC'),
	(275647, 120, '2014-04-01 00:49:36.000000', 'temperatura', 303.0000, 'ºC'),
	(275648, 120, '2014-04-01 00:49:37.000000', 'temperatura', 118.0000, 'ºC'),
	(275649, 120, '2014-04-01 00:49:38.000000', 'temperatura', 882.0000, 'ºC'),
	(275650, 120, '2014-04-01 00:49:39.000000', 'temperatura', 455.0000, 'ºC'),
	(275651, 120, '2014-04-01 00:49:40.000000', 'temperatura', 830.0000, 'ºC'),
	(275652, 120, '2014-04-01 00:49:41.000000', 'temperatura', 385.0000, 'ºC'),
	(275653, 120, '2014-04-01 00:49:42.000000', 'temperatura', 635.0000, 'ºC'),
	(275654, 120, '2014-04-01 00:49:43.000000', 'temperatura', 820.0000, 'ºC'),
	(275655, 120, '2014-04-01 00:49:44.000000', 'temperatura', 994.0000, 'ºC'),
	(275656, 120, '2014-04-01 00:49:45.000000', 'temperatura', 113.0000, 'ºC'),
	(275657, 120, '2014-04-01 00:49:46.000000', 'temperatura', 1183.0000, 'ºC'),
	(275658, 120, '2014-04-01 00:49:47.000000', 'temperatura', 777.0000, 'ºC'),
	(275659, 120, '2014-04-01 00:49:48.000000', 'temperatura', 338.0000, 'ºC'),
	(275660, 120, '2014-04-01 00:49:49.000000', 'temperatura', 559.0000, 'ºC'),
	(275661, 120, '2014-04-01 00:49:50.000000', 'temperatura', 580.0000, 'ºC'),
	(275662, 120, '2014-04-01 00:49:51.000000', 'temperatura', 23.0000, 'ºC'),
	(275663, 120, '2014-04-01 00:49:52.000000', 'temperatura', 777.0000, 'ºC'),
	(275664, 120, '2014-04-01 00:49:53.000000', 'temperatura', 215.0000, 'ºC'),
	(275665, 120, '2014-04-01 00:49:54.000000', 'temperatura', 1146.0000, 'ºC'),
	(275666, 120, '2014-04-01 00:49:55.000000', 'temperatura', 283.0000, 'ºC'),
	(275667, 120, '2014-04-01 00:49:56.000000', 'temperatura', 378.0000, 'ºC'),
	(275668, 120, '2014-04-01 00:49:57.000000', 'temperatura', 1043.0000, 'ºC'),
	(275669, 120, '2014-04-01 00:49:58.000000', 'temperatura', 481.0000, 'ºC'),
	(275670, 120, '2014-04-01 00:49:59.000000', 'temperatura', 475.0000, 'ºC'),
	(275671, 120, '2014-04-01 00:50:00.000000', 'temperatura', 934.0000, 'ºC'),
	(275672, 120, '2014-04-01 00:50:01.000000', 'temperatura', 843.0000, 'ºC'),
	(275673, 120, '2014-04-01 00:50:02.000000', 'temperatura', 215.0000, 'ºC'),
	(275674, 120, '2014-04-01 00:50:03.000000', 'temperatura', 947.0000, 'ºC'),
	(275675, 120, '2014-04-01 00:50:04.000000', 'temperatura', 489.0000, 'ºC'),
	(275676, 120, '2014-04-01 00:50:05.000000', 'temperatura', 807.0000, 'ºC'),
	(275677, 120, '2014-04-01 00:50:06.000000', 'temperatura', 165.0000, 'ºC'),
	(275678, 120, '2014-04-01 00:50:07.000000', 'temperatura', 808.0000, 'ºC'),
	(275679, 120, '2014-04-01 00:50:08.000000', 'temperatura', 1143.0000, 'ºC'),
	(275680, 120, '2014-04-01 00:50:09.000000', 'temperatura', 893.0000, 'ºC'),
	(275681, 120, '2014-04-01 00:50:10.000000', 'temperatura', 1035.0000, 'ºC'),
	(275682, 120, '2014-04-01 00:50:11.000000', 'temperatura', 96.0000, 'ºC'),
	(275683, 120, '2014-04-01 00:50:12.000000', 'temperatura', 976.0000, 'ºC'),
	(275684, 120, '2014-04-01 00:50:13.000000', 'temperatura', 994.0000, 'ºC'),
	(275685, 120, '2014-04-01 00:50:14.000000', 'temperatura', 842.0000, 'ºC'),
	(275686, 120, '2014-04-01 00:50:15.000000', 'temperatura', 29.0000, 'ºC'),
	(275687, 120, '2014-04-01 00:50:16.000000', 'temperatura', 17.0000, 'ºC'),
	(275688, 120, '2014-04-01 00:50:17.000000', 'temperatura', 2.0000, 'ºC'),
	(275689, 120, '2014-04-01 00:50:18.000000', 'temperatura', 1158.0000, 'ºC'),
	(275690, 120, '2014-04-01 00:50:19.000000', 'temperatura', 983.0000, 'ºC'),
	(275691, 120, '2014-04-01 00:50:20.000000', 'temperatura', 244.0000, 'ºC'),
	(275692, 120, '2014-04-01 00:50:21.000000', 'temperatura', 670.0000, 'ºC'),
	(275693, 120, '2014-04-01 00:50:22.000000', 'temperatura', 217.0000, 'ºC'),
	(275694, 120, '2014-04-01 00:50:23.000000', 'temperatura', 277.0000, 'ºC'),
	(275695, 120, '2014-04-01 00:50:24.000000', 'temperatura', 735.0000, 'ºC'),
	(275696, 120, '2014-04-01 00:50:25.000000', 'temperatura', 444.0000, 'ºC'),
	(275697, 120, '2014-04-01 00:50:26.000000', 'temperatura', 15.0000, 'ºC'),
	(275698, 120, '2014-04-01 00:50:27.000000', 'temperatura', 1145.0000, 'ºC'),
	(275699, 120, '2014-04-01 00:50:28.000000', 'temperatura', 880.0000, 'ºC'),
	(275700, 120, '2014-04-01 00:50:29.000000', 'temperatura', 963.0000, 'ºC'),
	(275701, 120, '2014-04-01 00:50:30.000000', 'temperatura', 978.0000, 'ºC'),
	(275702, 120, '2014-04-01 00:50:31.000000', 'temperatura', 800.0000, 'ºC'),
	(275703, 120, '2014-04-01 00:50:32.000000', 'temperatura', 1069.0000, 'ºC'),
	(275704, 120, '2014-04-01 00:50:33.000000', 'temperatura', 545.0000, 'ºC'),
	(275705, 120, '2014-04-01 00:50:34.000000', 'temperatura', 718.0000, 'ºC'),
	(275706, 120, '2014-04-01 00:50:35.000000', 'temperatura', 757.0000, 'ºC'),
	(275707, 120, '2014-04-01 00:50:36.000000', 'temperatura', 429.0000, 'ºC'),
	(275708, 120, '2014-04-01 00:50:37.000000', 'temperatura', 1074.0000, 'ºC'),
	(275709, 120, '2014-04-01 00:50:38.000000', 'temperatura', 483.0000, 'ºC'),
	(275710, 120, '2014-04-01 00:50:39.000000', 'temperatura', 393.0000, 'ºC'),
	(275711, 120, '2014-04-01 00:50:40.000000', 'temperatura', 517.0000, 'ºC'),
	(275712, 120, '2014-04-01 00:50:41.000000', 'temperatura', 207.0000, 'ºC'),
	(275713, 120, '2014-04-01 00:50:42.000000', 'temperatura', 686.0000, 'ºC'),
	(275714, 120, '2014-04-01 00:50:43.000000', 'temperatura', 409.0000, 'ºC'),
	(275715, 120, '2014-04-01 00:50:44.000000', 'temperatura', 1187.0000, 'ºC'),
	(275716, 120, '2014-04-01 00:50:45.000000', 'temperatura', 1109.0000, 'ºC'),
	(275717, 120, '2014-04-01 00:50:46.000000', 'temperatura', 785.0000, 'ºC'),
	(275718, 120, '2014-04-01 00:50:47.000000', 'temperatura', 597.0000, 'ºC'),
	(275719, 120, '2014-04-01 00:50:48.000000', 'temperatura', 633.0000, 'ºC'),
	(275720, 120, '2014-04-01 00:50:49.000000', 'temperatura', 171.0000, 'ºC'),
	(275721, 120, '2014-04-01 00:50:50.000000', 'temperatura', 158.0000, 'ºC'),
	(275722, 120, '2014-04-01 00:50:51.000000', 'temperatura', 279.0000, 'ºC'),
	(275723, 120, '2014-04-01 00:50:52.000000', 'temperatura', 920.0000, 'ºC'),
	(275724, 120, '2014-04-01 00:50:53.000000', 'temperatura', 165.0000, 'ºC'),
	(275725, 120, '2014-04-01 00:50:54.000000', 'temperatura', 465.0000, 'ºC'),
	(275726, 120, '2014-04-01 00:50:55.000000', 'temperatura', 629.0000, 'ºC'),
	(275727, 120, '2014-04-01 00:50:56.000000', 'temperatura', 550.0000, 'ºC'),
	(275728, 120, '2014-04-01 00:50:57.000000', 'temperatura', 866.0000, 'ºC'),
	(275729, 120, '2014-04-01 00:50:58.000000', 'temperatura', 280.0000, 'ºC'),
	(275730, 120, '2014-04-01 00:50:59.000000', 'temperatura', 0.0000, 'ºC'),
	(275731, 120, '2014-04-01 00:51:00.000000', 'temperatura', 363.0000, 'ºC'),
	(275732, 120, '2014-04-01 00:51:01.000000', 'temperatura', 616.0000, 'ºC'),
	(275733, 120, '2014-04-01 00:51:02.000000', 'temperatura', 790.0000, 'ºC'),
	(275734, 120, '2014-04-01 00:51:03.000000', 'temperatura', 903.0000, 'ºC'),
	(275735, 120, '2014-04-01 00:51:04.000000', 'temperatura', 943.0000, 'ºC'),
	(275736, 120, '2014-04-01 00:51:05.000000', 'temperatura', 810.0000, 'ºC'),
	(275737, 120, '2014-04-01 00:51:06.000000', 'temperatura', 20.0000, 'ºC'),
	(275738, 120, '2014-04-01 00:51:07.000000', 'temperatura', 69.0000, 'ºC'),
	(275739, 120, '2014-04-01 00:51:08.000000', 'temperatura', 288.0000, 'ºC'),
	(275740, 120, '2014-04-01 00:51:09.000000', 'temperatura', 35.0000, 'ºC'),
	(275741, 120, '2014-04-01 00:51:10.000000', 'temperatura', 508.0000, 'ºC'),
	(275742, 120, '2014-04-01 00:51:11.000000', 'temperatura', 36.0000, 'ºC'),
	(275743, 120, '2014-04-01 00:51:12.000000', 'temperatura', 1055.0000, 'ºC'),
	(275744, 120, '2014-04-01 00:51:13.000000', 'temperatura', 371.0000, 'ºC'),
	(275745, 120, '2014-04-01 00:51:14.000000', 'temperatura', 1088.0000, 'ºC'),
	(275746, 120, '2014-04-01 00:51:15.000000', 'temperatura', 729.0000, 'ºC'),
	(275747, 120, '2014-04-01 00:51:16.000000', 'temperatura', 380.0000, 'ºC'),
	(275748, 120, '2014-04-01 00:51:17.000000', 'temperatura', 916.0000, 'ºC'),
	(275749, 120, '2014-04-01 00:51:18.000000', 'temperatura', 1037.0000, 'ºC'),
	(275750, 120, '2014-04-01 00:51:19.000000', 'temperatura', 41.0000, 'ºC'),
	(275751, 120, '2014-04-01 00:51:20.000000', 'temperatura', 691.0000, 'ºC'),
	(275752, 120, '2014-04-01 00:51:21.000000', 'temperatura', 935.0000, 'ºC'),
	(275753, 120, '2014-04-01 00:51:22.000000', 'temperatura', 201.0000, 'ºC'),
	(275754, 120, '2014-04-01 00:51:23.000000', 'temperatura', 600.0000, 'ºC'),
	(275755, 120, '2014-04-01 00:51:24.000000', 'temperatura', 1197.0000, 'ºC'),
	(275756, 120, '2014-04-01 00:51:25.000000', 'temperatura', 588.0000, 'ºC'),
	(275757, 120, '2014-04-01 00:51:26.000000', 'temperatura', 550.0000, 'ºC'),
	(275758, 120, '2014-04-01 00:51:27.000000', 'temperatura', 983.0000, 'ºC'),
	(275759, 120, '2014-04-01 00:51:28.000000', 'temperatura', 869.0000, 'ºC'),
	(275760, 120, '2014-04-01 00:51:29.000000', 'temperatura', 196.0000, 'ºC'),
	(275761, 120, '2014-04-01 00:51:30.000000', 'temperatura', 773.0000, 'ºC'),
	(275762, 120, '2014-04-01 00:51:31.000000', 'temperatura', 877.0000, 'ºC'),
	(275763, 120, '2014-04-01 00:51:32.000000', 'temperatura', 867.0000, 'ºC'),
	(275764, 120, '2014-04-01 00:51:33.000000', 'temperatura', 503.0000, 'ºC'),
	(275765, 120, '2014-04-01 00:51:34.000000', 'temperatura', 1117.0000, 'ºC'),
	(275766, 120, '2014-04-01 00:51:35.000000', 'temperatura', 477.0000, 'ºC'),
	(275767, 120, '2014-04-01 00:51:36.000000', 'temperatura', 234.0000, 'ºC'),
	(275768, 120, '2014-04-01 00:51:37.000000', 'temperatura', 939.0000, 'ºC'),
	(275769, 120, '2014-04-01 00:51:38.000000', 'temperatura', 393.0000, 'ºC'),
	(275770, 120, '2014-04-01 00:51:39.000000', 'temperatura', 349.0000, 'ºC'),
	(275771, 120, '2014-04-01 00:51:40.000000', 'temperatura', 566.0000, 'ºC'),
	(275772, 120, '2014-04-01 00:51:41.000000', 'temperatura', 584.0000, 'ºC'),
	(275773, 120, '2014-04-01 00:51:42.000000', 'temperatura', 20.0000, 'ºC'),
	(275774, 120, '2014-04-01 00:51:43.000000', 'temperatura', 752.0000, 'ºC'),
	(275775, 120, '2014-04-01 00:51:44.000000', 'temperatura', 100.0000, 'ºC'),
	(275776, 120, '2014-04-01 00:51:45.000000', 'temperatura', 642.0000, 'ºC'),
	(275777, 120, '2014-04-01 00:51:46.000000', 'temperatura', 513.0000, 'ºC'),
	(275778, 120, '2014-04-01 00:51:47.000000', 'temperatura', 638.0000, 'ºC'),
	(275779, 120, '2014-04-01 00:51:48.000000', 'temperatura', 452.0000, 'ºC'),
	(275780, 120, '2014-04-01 00:51:49.000000', 'temperatura', 345.0000, 'ºC'),
	(275781, 120, '2014-04-01 00:51:50.000000', 'temperatura', 369.0000, 'ºC'),
	(275782, 120, '2014-04-01 00:51:51.000000', 'temperatura', 812.0000, 'ºC'),
	(275783, 120, '2014-04-01 00:51:52.000000', 'temperatura', 552.0000, 'ºC'),
	(275784, 120, '2014-04-01 00:51:53.000000', 'temperatura', 326.0000, 'ºC'),
	(275785, 120, '2014-04-01 00:51:54.000000', 'temperatura', 1173.0000, 'ºC'),
	(275786, 120, '2014-04-01 00:51:55.000000', 'temperatura', 88.0000, 'ºC'),
	(275787, 120, '2014-04-01 00:51:56.000000', 'temperatura', 522.0000, 'ºC'),
	(275788, 120, '2014-04-01 00:51:57.000000', 'temperatura', 1147.0000, 'ºC'),
	(275789, 120, '2014-04-01 00:51:58.000000', 'temperatura', 567.0000, 'ºC'),
	(275790, 120, '2014-04-01 00:51:59.000000', 'temperatura', 597.0000, 'ºC'),
	(275791, 120, '2014-04-01 00:52:00.000000', 'temperatura', 86.0000, 'ºC'),
	(275792, 120, '2014-04-01 00:52:01.000000', 'temperatura', 1036.0000, 'ºC'),
	(275793, 120, '2014-04-01 00:52:02.000000', 'temperatura', 124.0000, 'ºC'),
	(275794, 120, '2014-04-01 00:52:03.000000', 'temperatura', 1113.0000, 'ºC'),
	(275795, 120, '2014-04-01 00:52:04.000000', 'temperatura', 394.0000, 'ºC'),
	(275796, 120, '2014-04-01 00:52:05.000000', 'temperatura', 1030.0000, 'ºC'),
	(275797, 120, '2014-04-01 00:52:06.000000', 'temperatura', 369.0000, 'ºC'),
	(275798, 120, '2014-04-01 00:52:07.000000', 'temperatura', 1153.0000, 'ºC'),
	(275799, 120, '2014-04-01 00:52:08.000000', 'temperatura', 1062.0000, 'ºC'),
	(275800, 120, '2014-04-01 00:52:09.000000', 'temperatura', 652.0000, 'ºC'),
	(275801, 120, '2014-04-01 00:52:10.000000', 'temperatura', 73.0000, 'ºC'),
	(275802, 120, '2014-04-01 00:52:11.000000', 'temperatura', 809.0000, 'ºC'),
	(275803, 120, '2014-04-01 00:52:12.000000', 'temperatura', 227.0000, 'ºC'),
	(275804, 120, '2014-04-01 00:52:13.000000', 'temperatura', 1109.0000, 'ºC'),
	(275805, 120, '2014-04-01 00:52:14.000000', 'temperatura', 65.0000, 'ºC'),
	(275806, 120, '2014-04-01 00:52:15.000000', 'temperatura', 599.0000, 'ºC'),
	(275807, 120, '2014-04-01 00:52:16.000000', 'temperatura', 399.0000, 'ºC'),
	(275808, 120, '2014-04-01 00:52:17.000000', 'temperatura', 199.0000, 'ºC'),
	(275809, 120, '2014-04-01 00:52:18.000000', 'temperatura', 1000.0000, 'ºC'),
	(275810, 120, '2014-04-01 00:52:19.000000', 'temperatura', 804.0000, 'ºC'),
	(275811, 120, '2014-04-01 00:52:20.000000', 'temperatura', 1021.0000, 'ºC'),
	(275812, 120, '2014-04-01 00:52:21.000000', 'temperatura', 290.0000, 'ºC'),
	(275813, 120, '2014-04-01 00:52:22.000000', 'temperatura', 791.0000, 'ºC'),
	(275814, 120, '2014-04-01 00:52:23.000000', 'temperatura', 684.0000, 'ºC'),
	(275815, 120, '2014-04-01 00:52:24.000000', 'temperatura', 1049.0000, 'ºC'),
	(275816, 120, '2014-04-01 00:52:25.000000', 'temperatura', 791.0000, 'ºC'),
	(275817, 120, '2014-04-01 00:52:26.000000', 'temperatura', 808.0000, 'ºC'),
	(275818, 120, '2014-04-01 00:52:27.000000', 'temperatura', 471.0000, 'ºC'),
	(275819, 120, '2014-04-01 00:52:28.000000', 'temperatura', 1129.0000, 'ºC'),
	(275820, 120, '2014-04-01 00:52:29.000000', 'temperatura', 632.0000, 'ºC'),
	(275821, 120, '2014-04-01 00:52:30.000000', 'temperatura', 975.0000, 'ºC'),
	(275822, 120, '2014-04-01 00:52:31.000000', 'temperatura', 577.0000, 'ºC'),
	(275823, 120, '2014-04-01 00:52:32.000000', 'temperatura', 1164.0000, 'ºC'),
	(275824, 120, '2014-04-01 00:52:33.000000', 'temperatura', 486.0000, 'ºC'),
	(275825, 120, '2014-04-01 00:52:34.000000', 'temperatura', 141.0000, 'ºC'),
	(275826, 120, '2014-04-01 00:52:35.000000', 'temperatura', 446.0000, 'ºC'),
	(275827, 120, '2014-04-01 00:52:36.000000', 'temperatura', 608.0000, 'ºC'),
	(275828, 120, '2014-04-01 00:52:37.000000', 'temperatura', 504.0000, 'ºC'),
	(275829, 120, '2014-04-01 00:52:38.000000', 'temperatura', 696.0000, 'ºC'),
	(275830, 120, '2014-04-01 00:52:39.000000', 'temperatura', 768.0000, 'ºC'),
	(275831, 120, '2014-04-01 00:52:40.000000', 'temperatura', 554.0000, 'ºC'),
	(275832, 120, '2014-04-01 00:52:41.000000', 'temperatura', 466.0000, 'ºC'),
	(275833, 120, '2014-04-01 00:52:42.000000', 'temperatura', 667.0000, 'ºC'),
	(275834, 120, '2014-04-01 00:52:43.000000', 'temperatura', 739.0000, 'ºC'),
	(275835, 120, '2014-04-01 00:52:44.000000', 'temperatura', 496.0000, 'ºC'),
	(275836, 120, '2014-04-01 00:52:45.000000', 'temperatura', 261.0000, 'ºC'),
	(275837, 120, '2014-04-01 00:52:46.000000', 'temperatura', 1017.0000, 'ºC'),
	(275838, 120, '2014-04-01 00:52:47.000000', 'temperatura', 705.0000, 'ºC'),
	(275839, 120, '2014-04-01 00:52:48.000000', 'temperatura', 474.0000, 'ºC'),
	(275840, 120, '2014-04-01 00:52:49.000000', 'temperatura', 257.0000, 'ºC'),
	(275841, 120, '2014-04-01 00:52:50.000000', 'temperatura', 1061.0000, 'ºC'),
	(275842, 120, '2014-04-01 00:52:51.000000', 'temperatura', 935.0000, 'ºC'),
	(275843, 120, '2014-04-01 00:52:52.000000', 'temperatura', 295.0000, 'ºC'),
	(275844, 120, '2014-04-01 00:52:53.000000', 'temperatura', 1068.0000, 'ºC'),
	(275845, 120, '2014-04-01 00:52:54.000000', 'temperatura', 857.0000, 'ºC'),
	(275846, 120, '2014-04-01 00:52:55.000000', 'temperatura', 1082.0000, 'ºC'),
	(275847, 120, '2014-04-01 00:52:56.000000', 'temperatura', 437.0000, 'ºC'),
	(275848, 120, '2014-04-01 00:52:57.000000', 'temperatura', 141.0000, 'ºC'),
	(275849, 120, '2014-04-01 00:52:58.000000', 'temperatura', 596.0000, 'ºC'),
	(275850, 120, '2014-04-01 00:52:59.000000', 'temperatura', 155.0000, 'ºC'),
	(275851, 120, '2014-04-01 00:53:00.000000', 'temperatura', 190.0000, 'ºC'),
	(275852, 120, '2014-04-01 00:53:01.000000', 'temperatura', 484.0000, 'ºC'),
	(275853, 120, '2014-04-01 00:53:02.000000', 'temperatura', 651.0000, 'ºC'),
	(275854, 120, '2014-04-01 00:53:03.000000', 'temperatura', 604.0000, 'ºC'),
	(275855, 120, '2014-04-01 00:53:04.000000', 'temperatura', 1066.0000, 'ºC'),
	(275856, 120, '2014-04-01 00:53:05.000000', 'temperatura', 1121.0000, 'ºC'),
	(275857, 120, '2014-04-01 00:53:06.000000', 'temperatura', 7.0000, 'ºC'),
	(275858, 120, '2014-04-01 00:53:07.000000', 'temperatura', 272.0000, 'ºC'),
	(275859, 120, '2014-04-01 00:53:08.000000', 'temperatura', 141.0000, 'ºC'),
	(275860, 120, '2014-04-01 00:53:09.000000', 'temperatura', 1090.0000, 'ºC'),
	(275861, 120, '2014-04-01 00:53:10.000000', 'temperatura', 227.0000, 'ºC'),
	(275862, 120, '2014-04-01 00:53:11.000000', 'temperatura', 263.0000, 'ºC'),
	(275863, 120, '2014-04-01 00:53:12.000000', 'temperatura', 636.0000, 'ºC'),
	(275864, 120, '2014-04-01 00:53:13.000000', 'temperatura', 1191.0000, 'ºC'),
	(275865, 120, '2014-04-01 00:53:14.000000', 'temperatura', 446.0000, 'ºC'),
	(275866, 120, '2014-04-01 00:53:15.000000', 'temperatura', 1060.0000, 'ºC'),
	(275867, 120, '2014-04-01 00:53:16.000000', 'temperatura', 363.0000, 'ºC'),
	(275868, 120, '2014-04-01 00:53:17.000000', 'temperatura', 1035.0000, 'ºC'),
	(275869, 120, '2014-04-01 00:53:18.000000', 'temperatura', 487.0000, 'ºC'),
	(275870, 120, '2014-04-01 00:53:19.000000', 'temperatura', 528.0000, 'ºC'),
	(275871, 120, '2014-04-01 00:53:20.000000', 'temperatura', 1181.0000, 'ºC'),
	(275872, 120, '2014-04-01 00:53:21.000000', 'temperatura', 722.0000, 'ºC'),
	(275873, 120, '2014-04-01 00:53:22.000000', 'temperatura', 67.0000, 'ºC'),
	(275874, 120, '2014-04-01 00:53:23.000000', 'temperatura', 570.0000, 'ºC'),
	(275875, 120, '2014-04-01 00:53:24.000000', 'temperatura', 249.0000, 'ºC'),
	(275876, 120, '2014-04-01 00:53:25.000000', 'temperatura', 738.0000, 'ºC'),
	(275877, 120, '2014-04-01 00:53:26.000000', 'temperatura', 540.0000, 'ºC'),
	(275878, 120, '2014-04-01 00:53:27.000000', 'temperatura', 488.0000, 'ºC'),
	(275879, 120, '2014-04-01 00:53:28.000000', 'temperatura', 819.0000, 'ºC'),
	(275880, 120, '2014-04-01 00:53:29.000000', 'temperatura', 234.0000, 'ºC'),
	(275881, 120, '2014-04-01 00:53:30.000000', 'temperatura', 1113.0000, 'ºC'),
	(275882, 120, '2014-04-01 00:53:31.000000', 'temperatura', 62.0000, 'ºC'),
	(275883, 120, '2014-04-01 00:53:32.000000', 'temperatura', 571.0000, 'ºC'),
	(275884, 120, '2014-04-01 00:53:33.000000', 'temperatura', 271.0000, 'ºC'),
	(275885, 120, '2014-04-01 00:53:34.000000', 'temperatura', 840.0000, 'ºC'),
	(275886, 120, '2014-04-01 00:53:35.000000', 'temperatura', 990.0000, 'ºC'),
	(275887, 120, '2014-04-01 00:53:36.000000', 'temperatura', 28.0000, 'ºC'),
	(275888, 120, '2014-04-01 00:53:37.000000', 'temperatura', 773.0000, 'ºC'),
	(275889, 120, '2014-04-01 00:53:38.000000', 'temperatura', 180.0000, 'ºC'),
	(275890, 120, '2014-04-01 00:53:39.000000', 'temperatura', 983.0000, 'ºC'),
	(275891, 120, '2014-04-01 00:53:40.000000', 'temperatura', 774.0000, 'ºC'),
	(275892, 120, '2014-04-01 00:53:41.000000', 'temperatura', 922.0000, 'ºC'),
	(275893, 120, '2014-04-01 00:53:42.000000', 'temperatura', 1088.0000, 'ºC'),
	(275894, 120, '2014-04-01 00:53:43.000000', 'temperatura', 276.0000, 'ºC'),
	(275895, 120, '2014-04-01 00:53:44.000000', 'temperatura', 517.0000, 'ºC'),
	(275896, 120, '2014-04-01 00:53:45.000000', 'temperatura', 557.0000, 'ºC'),
	(275897, 120, '2014-04-01 00:53:46.000000', 'temperatura', 36.0000, 'ºC'),
	(275898, 120, '2014-04-01 00:53:47.000000', 'temperatura', 906.0000, 'ºC'),
	(275899, 120, '2014-04-01 00:53:48.000000', 'temperatura', 825.0000, 'ºC'),
	(275900, 120, '2014-04-01 00:53:49.000000', 'temperatura', 205.0000, 'ºC'),
	(275901, 120, '2014-04-01 00:53:50.000000', 'temperatura', 953.0000, 'ºC'),
	(275902, 120, '2014-04-01 00:53:51.000000', 'temperatura', 550.0000, 'ºC'),
	(275903, 120, '2014-04-01 00:53:52.000000', 'temperatura', 1090.0000, 'ºC'),
	(275904, 120, '2014-04-01 00:53:53.000000', 'temperatura', 202.0000, 'ºC'),
	(275905, 120, '2014-04-01 00:53:54.000000', 'temperatura', 138.0000, 'ºC'),
	(275906, 120, '2014-04-01 00:53:55.000000', 'temperatura', 86.0000, 'ºC'),
	(275907, 120, '2014-04-01 00:53:56.000000', 'temperatura', 17.0000, 'ºC'),
	(275908, 120, '2014-04-01 00:53:57.000000', 'temperatura', 1029.0000, 'ºC'),
	(275909, 120, '2014-04-01 00:53:58.000000', 'temperatura', 292.0000, 'ºC'),
	(275910, 120, '2014-04-01 00:53:59.000000', 'temperatura', 774.0000, 'ºC'),
	(275911, 120, '2014-04-01 00:54:00.000000', 'temperatura', 596.0000, 'ºC'),
	(275912, 120, '2014-04-01 00:54:01.000000', 'temperatura', 658.0000, 'ºC'),
	(275913, 120, '2014-04-01 00:54:02.000000', 'temperatura', 302.0000, 'ºC'),
	(275914, 120, '2014-04-01 00:54:03.000000', 'temperatura', 738.0000, 'ºC'),
	(275915, 120, '2014-04-01 00:54:04.000000', 'temperatura', 384.0000, 'ºC'),
	(275916, 120, '2014-04-01 00:54:05.000000', 'temperatura', 908.0000, 'ºC'),
	(275917, 120, '2014-04-01 00:54:06.000000', 'temperatura', 986.0000, 'ºC'),
	(275918, 120, '2014-04-01 00:54:07.000000', 'temperatura', 1007.0000, 'ºC'),
	(275919, 120, '2014-04-01 00:54:08.000000', 'temperatura', 876.0000, 'ºC'),
	(275920, 120, '2014-04-01 00:54:09.000000', 'temperatura', 161.0000, 'ºC'),
	(275921, 120, '2014-04-01 00:54:10.000000', 'temperatura', 577.0000, 'ºC'),
	(275922, 120, '2014-04-01 00:54:11.000000', 'temperatura', 2.0000, 'ºC'),
	(275923, 120, '2014-04-01 00:54:12.000000', 'temperatura', 679.0000, 'ºC'),
	(275924, 120, '2014-04-01 00:54:13.000000', 'temperatura', 992.0000, 'ºC'),
	(275925, 120, '2014-04-01 00:54:14.000000', 'temperatura', 522.0000, 'ºC'),
	(275926, 120, '2014-04-01 00:54:15.000000', 'temperatura', 834.0000, 'ºC'),
	(275927, 120, '2014-04-01 00:54:16.000000', 'temperatura', 205.0000, 'ºC'),
	(275928, 120, '2014-04-01 00:54:17.000000', 'temperatura', 924.0000, 'ºC'),
	(275929, 120, '2014-04-01 00:54:18.000000', 'temperatura', 405.0000, 'ºC'),
	(275930, 120, '2014-04-01 00:54:19.000000', 'temperatura', 454.0000, 'ºC'),
	(275931, 120, '2014-04-01 00:54:20.000000', 'temperatura', 1056.0000, 'ºC'),
	(275932, 120, '2014-04-01 00:54:21.000000', 'temperatura', 316.0000, 'ºC'),
	(275933, 120, '2014-04-01 00:54:22.000000', 'temperatura', 813.0000, 'ºC'),
	(275934, 120, '2014-04-01 00:54:23.000000', 'temperatura', 719.0000, 'ºC'),
	(275935, 120, '2014-04-01 00:54:24.000000', 'temperatura', 1155.0000, 'ºC'),
	(275936, 120, '2014-04-01 00:54:25.000000', 'temperatura', 18.0000, 'ºC'),
	(275937, 120, '2014-04-01 00:54:26.000000', 'temperatura', 227.0000, 'ºC'),
	(275938, 120, '2014-04-01 00:54:27.000000', 'temperatura', 1082.0000, 'ºC'),
	(275939, 120, '2014-04-01 00:54:28.000000', 'temperatura', 1128.0000, 'ºC'),
	(275940, 120, '2014-04-01 00:54:29.000000', 'temperatura', 1195.0000, 'ºC'),
	(275941, 120, '2014-04-01 00:54:30.000000', 'temperatura', 193.0000, 'ºC'),
	(275942, 120, '2014-04-01 00:54:31.000000', 'temperatura', 980.0000, 'ºC'),
	(275943, 120, '2014-04-01 00:54:32.000000', 'temperatura', 720.0000, 'ºC'),
	(275944, 120, '2014-04-01 00:54:33.000000', 'temperatura', 659.0000, 'ºC'),
	(275945, 120, '2014-04-01 00:54:34.000000', 'temperatura', 1139.0000, 'ºC'),
	(275946, 120, '2014-04-01 00:54:35.000000', 'temperatura', 118.0000, 'ºC'),
	(275947, 120, '2014-04-01 00:54:36.000000', 'temperatura', 772.0000, 'ºC'),
	(275948, 120, '2014-04-01 00:54:37.000000', 'temperatura', 1109.0000, 'ºC'),
	(275949, 120, '2014-04-01 00:54:38.000000', 'temperatura', 828.0000, 'ºC'),
	(275950, 120, '2014-04-01 00:54:39.000000', 'temperatura', 813.0000, 'ºC'),
	(275951, 120, '2014-04-01 00:54:40.000000', 'temperatura', 384.0000, 'ºC'),
	(275952, 120, '2014-04-01 00:54:41.000000', 'temperatura', 680.0000, 'ºC'),
	(275953, 120, '2014-04-01 00:54:42.000000', 'temperatura', 1050.0000, 'ºC'),
	(275954, 120, '2014-04-01 00:54:43.000000', 'temperatura', 810.0000, 'ºC'),
	(275955, 120, '2014-04-01 00:54:44.000000', 'temperatura', 899.0000, 'ºC'),
	(275956, 120, '2014-04-01 00:54:45.000000', 'temperatura', 868.0000, 'ºC'),
	(275957, 120, '2014-04-01 00:54:46.000000', 'temperatura', 444.0000, 'ºC'),
	(275958, 120, '2014-04-01 00:54:47.000000', 'temperatura', 814.0000, 'ºC'),
	(275959, 120, '2014-04-01 00:54:48.000000', 'temperatura', 337.0000, 'ºC'),
	(275960, 120, '2014-04-01 00:54:49.000000', 'temperatura', 447.0000, 'ºC'),
	(275961, 120, '2014-04-01 00:54:50.000000', 'temperatura', 23.0000, 'ºC'),
	(275962, 120, '2014-04-01 00:54:51.000000', 'temperatura', 1173.0000, 'ºC'),
	(275963, 120, '2014-04-01 00:54:52.000000', 'temperatura', 998.0000, 'ºC'),
	(275964, 120, '2014-04-01 00:54:53.000000', 'temperatura', 273.0000, 'ºC'),
	(275965, 120, '2014-04-01 00:54:54.000000', 'temperatura', 771.0000, 'ºC'),
	(275966, 120, '2014-04-01 00:54:55.000000', 'temperatura', 638.0000, 'ºC'),
	(275967, 120, '2014-04-01 00:54:56.000000', 'temperatura', 876.0000, 'ºC'),
	(275968, 120, '2014-04-01 00:54:57.000000', 'temperatura', 69.0000, 'ºC'),
	(275969, 120, '2014-04-01 00:54:58.000000', 'temperatura', 114.0000, 'ºC'),
	(275970, 120, '2014-04-01 00:54:59.000000', 'temperatura', 366.0000, 'ºC'),
	(275971, 120, '2014-04-01 00:55:00.000000', 'temperatura', 290.0000, 'ºC'),
	(275972, 120, '2014-04-01 00:55:01.000000', 'temperatura', 349.0000, 'ºC'),
	(275973, 120, '2014-04-01 00:55:02.000000', 'temperatura', 877.0000, 'ºC'),
	(275974, 120, '2014-04-01 00:55:03.000000', 'temperatura', 939.0000, 'ºC'),
	(275975, 120, '2014-04-01 00:55:04.000000', 'temperatura', 862.0000, 'ºC'),
	(275976, 120, '2014-04-01 00:55:05.000000', 'temperatura', 296.0000, 'ºC'),
	(275977, 120, '2014-04-01 00:55:06.000000', 'temperatura', 94.0000, 'ºC'),
	(275978, 120, '2014-04-01 00:55:07.000000', 'temperatura', 782.0000, 'ºC'),
	(275979, 120, '2014-04-01 00:55:08.000000', 'temperatura', 28.0000, 'ºC'),
	(275980, 120, '2014-04-01 00:55:09.000000', 'temperatura', 194.0000, 'ºC'),
	(275981, 120, '2014-04-01 00:55:10.000000', 'temperatura', 888.0000, 'ºC'),
	(275982, 120, '2014-04-01 00:55:11.000000', 'temperatura', 258.0000, 'ºC'),
	(275983, 120, '2014-04-01 00:55:12.000000', 'temperatura', 1028.0000, 'ºC'),
	(275984, 120, '2014-04-01 00:55:13.000000', 'temperatura', 767.0000, 'ºC'),
	(275985, 120, '2014-04-01 00:55:14.000000', 'temperatura', 751.0000, 'ºC'),
	(275986, 120, '2014-04-01 00:55:15.000000', 'temperatura', 254.0000, 'ºC'),
	(275987, 120, '2014-04-01 00:55:16.000000', 'temperatura', 217.0000, 'ºC'),
	(275988, 120, '2014-04-01 00:55:17.000000', 'temperatura', 324.0000, 'ºC'),
	(275989, 120, '2014-04-01 00:55:18.000000', 'temperatura', 969.0000, 'ºC'),
	(275990, 120, '2014-04-01 00:55:19.000000', 'temperatura', 276.0000, 'ºC'),
	(275991, 120, '2014-04-01 00:55:20.000000', 'temperatura', 871.0000, 'ºC'),
	(275992, 120, '2014-04-01 00:55:21.000000', 'temperatura', 1128.0000, 'ºC'),
	(275993, 120, '2014-04-01 00:55:22.000000', 'temperatura', 626.0000, 'ºC'),
	(275994, 120, '2014-04-01 00:55:23.000000', 'temperatura', 949.0000, 'ºC'),
	(275995, 120, '2014-04-01 00:55:24.000000', 'temperatura', 465.0000, 'ºC'),
	(275996, 120, '2014-04-01 00:55:25.000000', 'temperatura', 679.0000, 'ºC'),
	(275997, 120, '2014-04-01 00:55:26.000000', 'temperatura', 802.0000, 'ºC'),
	(275998, 120, '2014-04-01 00:55:27.000000', 'temperatura', 771.0000, 'ºC'),
	(275999, 120, '2014-04-01 00:55:28.000000', 'temperatura', 251.0000, 'ºC'),
	(276000, 120, '2014-04-01 00:55:29.000000', 'temperatura', 144.0000, 'ºC'),
	(276001, 120, '2014-04-01 00:55:30.000000', 'temperatura', 1167.0000, 'ºC'),
	(276002, 120, '2014-04-01 00:55:31.000000', 'temperatura', 604.0000, 'ºC'),
	(276003, 120, '2014-04-01 00:55:32.000000', 'temperatura', 721.0000, 'ºC'),
	(276004, 120, '2014-04-01 00:55:33.000000', 'temperatura', 590.0000, 'ºC'),
	(276005, 120, '2014-04-01 00:55:34.000000', 'temperatura', 790.0000, 'ºC'),
	(276006, 120, '2014-04-01 00:55:35.000000', 'temperatura', 981.0000, 'ºC'),
	(276007, 120, '2014-04-01 00:55:36.000000', 'temperatura', 136.0000, 'ºC'),
	(276008, 120, '2014-04-01 00:55:37.000000', 'temperatura', 135.0000, 'ºC'),
	(276009, 120, '2014-04-01 00:55:38.000000', 'temperatura', 266.0000, 'ºC'),
	(276010, 120, '2014-04-01 00:55:39.000000', 'temperatura', 929.0000, 'ºC'),
	(276011, 120, '2014-04-01 00:55:40.000000', 'temperatura', 248.0000, 'ºC'),
	(276012, 120, '2014-04-01 00:55:41.000000', 'temperatura', 852.0000, 'ºC'),
	(276013, 120, '2014-04-01 00:55:42.000000', 'temperatura', 1117.0000, 'ºC'),
	(276014, 120, '2014-04-01 00:55:43.000000', 'temperatura', 629.0000, 'ºC'),
	(276015, 120, '2014-04-01 00:55:44.000000', 'temperatura', 995.0000, 'ºC'),
	(276016, 120, '2014-04-01 00:55:45.000000', 'temperatura', 690.0000, 'ºC'),
	(276017, 120, '2014-04-01 00:55:46.000000', 'temperatura', 463.0000, 'ºC'),
	(276018, 120, '2014-04-01 00:55:47.000000', 'temperatura', 246.0000, 'ºC'),
	(276019, 120, '2014-04-01 00:55:48.000000', 'temperatura', 1040.0000, 'ºC'),
	(276020, 120, '2014-04-01 00:55:49.000000', 'temperatura', 863.0000, 'ºC'),
	(276021, 120, '2014-04-01 00:55:50.000000', 'temperatura', 1198.0000, 'ºC'),
	(276022, 120, '2014-04-01 00:55:51.000000', 'temperatura', 998.0000, 'ºC'),
	(276023, 120, '2014-04-01 00:55:52.000000', 'temperatura', 199.0000, 'ºC'),
	(276024, 120, '2014-04-01 00:55:53.000000', 'temperatura', 401.0000, 'ºC'),
	(276025, 120, '2014-04-01 00:55:54.000000', 'temperatura', 207.0000, 'ºC'),
	(276026, 120, '2014-04-01 00:55:55.000000', 'temperatura', 1035.0000, 'ºC'),
	(276027, 120, '2014-04-01 00:55:56.000000', 'temperatura', 954.0000, 'ºC'),
	(276028, 120, '2014-04-01 00:55:57.000000', 'temperatura', 466.0000, 'ºC'),
	(276029, 120, '2014-04-01 00:55:58.000000', 'temperatura', 670.0000, 'ºC'),
	(276030, 120, '2014-04-01 00:55:59.000000', 'temperatura', 749.0000, 'ºC'),
	(276031, 120, '2014-04-01 00:56:00.000000', 'temperatura', 538.0000, 'ºC'),
	(276032, 120, '2014-04-01 00:56:01.000000', 'temperatura', 441.0000, 'ºC'),
	(276033, 120, '2014-04-01 00:56:02.000000', 'temperatura', 594.0000, 'ºC'),
	(276034, 120, '2014-04-01 00:56:03.000000', 'temperatura', 446.0000, 'ºC'),
	(276035, 120, '2014-04-01 00:56:04.000000', 'temperatura', 451.0000, 'ºC'),
	(276036, 120, '2014-04-01 00:56:05.000000', 'temperatura', 915.0000, 'ºC'),
	(276037, 120, '2014-04-01 00:56:06.000000', 'temperatura', 822.0000, 'ºC'),
	(276038, 120, '2014-04-01 00:56:07.000000', 'temperatura', 167.0000, 'ºC'),
	(276039, 120, '2014-04-01 00:56:08.000000', 'temperatura', 771.0000, 'ºC'),
	(276040, 120, '2014-04-01 00:56:09.000000', 'temperatura', 953.0000, 'ºC'),
	(276041, 120, '2014-04-01 00:56:10.000000', 'temperatura', 53.0000, 'ºC'),
	(276042, 120, '2014-04-01 00:56:11.000000', 'temperatura', 1007.0000, 'ºC'),
	(276043, 120, '2014-04-01 00:56:12.000000', 'temperatura', 78.0000, 'ºC'),
	(276044, 120, '2014-04-01 00:56:13.000000', 'temperatura', 966.0000, 'ºC'),
	(276045, 120, '2014-04-01 00:56:14.000000', 'temperatura', 999.0000, 'ºC'),
	(276046, 120, '2014-04-01 00:56:15.000000', 'temperatura', 895.0000, 'ºC'),
	(276047, 120, '2014-04-01 00:56:16.000000', 'temperatura', 281.0000, 'ºC'),
	(276048, 120, '2014-04-01 00:56:17.000000', 'temperatura', 1119.0000, 'ºC'),
	(276049, 120, '2014-04-01 00:56:18.000000', 'temperatura', 1155.0000, 'ºC'),
	(276050, 120, '2014-04-01 00:56:19.000000', 'temperatura', 17.0000, 'ºC'),
	(276051, 120, '2014-04-01 00:56:20.000000', 'temperatura', 220.0000, 'ºC'),
	(276052, 120, '2014-04-01 00:56:21.000000', 'temperatura', 1050.0000, 'ºC'),
	(276053, 120, '2014-04-01 00:56:22.000000', 'temperatura', 990.0000, 'ºC'),
	(276054, 120, '2014-04-01 00:56:23.000000', 'temperatura', 603.0000, 'ºC'),
	(276055, 120, '2014-04-01 00:56:24.000000', 'temperatura', 43.0000, 'ºC'),
	(276056, 120, '2014-04-01 00:56:25.000000', 'temperatura', 809.0000, 'ºC'),
	(276057, 120, '2014-04-01 00:56:26.000000', 'temperatura', 317.0000, 'ºC'),
	(276058, 120, '2014-04-01 00:56:27.000000', 'temperatura', 355.0000, 'ºC'),
	(276059, 120, '2014-04-01 00:56:28.000000', 'temperatura', 827.0000, 'ºC'),
	(276060, 120, '2014-04-01 00:56:29.000000', 'temperatura', 671.0000, 'ºC'),
	(276061, 120, '2014-04-01 00:56:30.000000', 'temperatura', 876.0000, 'ºC'),
	(276062, 120, '2014-04-01 00:56:31.000000', 'temperatura', 1165.0000, 'ºC'),
	(276063, 120, '2014-04-01 00:56:32.000000', 'temperatura', 798.0000, 'ºC'),
	(276064, 120, '2014-04-01 00:56:33.000000', 'temperatura', 497.0000, 'ºC'),
	(276065, 120, '2014-04-01 00:56:34.000000', 'temperatura', 92.0000, 'ºC'),
	(276066, 120, '2014-04-01 00:56:35.000000', 'temperatura', 169.0000, 'ºC'),
	(276067, 120, '2014-04-01 00:56:36.000000', 'temperatura', 570.0000, 'ºC'),
	(276068, 120, '2014-04-01 00:56:37.000000', 'temperatura', 1145.0000, 'ºC'),
	(276069, 120, '2014-04-01 00:56:38.000000', 'temperatura', 414.0000, 'ºC'),
	(276070, 120, '2014-04-01 00:56:39.000000', 'temperatura', 1034.0000, 'ºC'),
	(276071, 120, '2014-04-01 00:56:40.000000', 'temperatura', 328.0000, 'ºC'),
	(276072, 120, '2014-04-01 00:56:41.000000', 'temperatura', 939.0000, 'ºC'),
	(276073, 120, '2014-04-01 00:56:42.000000', 'temperatura', 111.0000, 'ºC'),
	(276074, 120, '2014-04-01 00:56:43.000000', 'temperatura', 141.0000, 'ºC'),
	(276075, 120, '2014-04-01 00:56:44.000000', 'temperatura', 369.0000, 'ºC'),
	(276076, 120, '2014-04-01 00:56:45.000000', 'temperatura', 225.0000, 'ºC'),
	(276077, 120, '2014-04-01 00:56:46.000000', 'temperatura', 17.0000, 'ºC'),
	(276078, 120, '2014-04-01 00:56:47.000000', 'temperatura', 612.0000, 'ºC'),
	(276079, 120, '2014-04-01 00:56:48.000000', 'temperatura', 608.0000, 'ºC'),
	(276080, 120, '2014-04-01 00:56:49.000000', 'temperatura', 5.0000, 'ºC'),
	(276081, 120, '2014-04-01 00:56:50.000000', 'temperatura', 602.0000, 'ºC'),
	(276082, 120, '2014-04-01 00:56:51.000000', 'temperatura', 595.0000, 'ºC'),
	(276083, 120, '2014-04-01 00:56:52.000000', 'temperatura', 1170.0000, 'ºC'),
	(276084, 120, '2014-04-01 00:56:53.000000', 'temperatura', 467.0000, 'ºC'),
	(276085, 120, '2014-04-01 00:56:54.000000', 'temperatura', 26.0000, 'ºC'),
	(276086, 120, '2014-04-01 00:56:55.000000', 'temperatura', 1128.0000, 'ºC'),
	(276087, 120, '2014-04-01 00:56:56.000000', 'temperatura', 764.0000, 'ºC'),
	(276088, 120, '2014-04-01 00:56:57.000000', 'temperatura', 434.0000, 'ºC'),
	(276089, 120, '2014-04-01 00:56:58.000000', 'temperatura', 1079.0000, 'ºC'),
	(276090, 120, '2014-04-01 00:56:59.000000', 'temperatura', 494.0000, 'ºC'),
	(276091, 120, '2014-04-01 00:57:00.000000', 'temperatura', 433.0000, 'ºC'),
	(276092, 120, '2014-04-01 00:57:01.000000', 'temperatura', 684.0000, 'ºC'),
	(276093, 120, '2014-04-01 00:57:02.000000', 'temperatura', 920.0000, 'ºC'),
	(276094, 120, '2014-04-01 00:57:03.000000', 'temperatura', 149.0000, 'ºC'),
	(276095, 120, '2014-04-01 00:57:04.000000', 'temperatura', 385.0000, 'ºC'),
	(276096, 120, '2014-04-01 00:57:05.000000', 'temperatura', 281.0000, 'ºC'),
	(276097, 120, '2014-04-01 00:57:06.000000', 'temperatura', 248.0000, 'ºC'),
	(276098, 120, '2014-04-01 00:57:07.000000', 'temperatura', 397.0000, 'ºC'),
	(276099, 120, '2014-04-01 00:57:08.000000', 'temperatura', 42.0000, 'ºC'),
	(276100, 120, '2014-04-01 00:57:09.000000', 'temperatura', 222.0000, 'ºC'),
	(276101, 120, '2014-04-01 00:57:10.000000', 'temperatura', 982.0000, 'ºC'),
	(276102, 120, '2014-04-01 00:57:11.000000', 'temperatura', 643.0000, 'ºC'),
	(276103, 120, '2014-04-01 00:57:12.000000', 'temperatura', 272.0000, 'ºC'),
	(276104, 120, '2014-04-01 00:57:13.000000', 'temperatura', 631.0000, 'ºC'),
	(276105, 120, '2014-04-01 00:57:14.000000', 'temperatura', 1138.0000, 'ºC'),
	(276106, 120, '2014-04-01 00:57:15.000000', 'temperatura', 200.0000, 'ºC'),
	(276107, 120, '2014-04-01 00:57:16.000000', 'temperatura', 1187.0000, 'ºC'),
	(276108, 120, '2014-04-01 00:57:17.000000', 'temperatura', 536.0000, 'ºC'),
	(276109, 120, '2014-04-01 00:57:18.000000', 'temperatura', 319.0000, 'ºC'),
	(276110, 120, '2014-04-01 00:57:19.000000', 'temperatura', 1189.0000, 'ºC'),
	(276111, 120, '2014-04-01 00:57:20.000000', 'temperatura', 186.0000, 'ºC'),
	(276112, 120, '2014-04-01 00:57:21.000000', 'temperatura', 965.0000, 'ºC'),
	(276113, 120, '2014-04-01 00:57:22.000000', 'temperatura', 666.0000, 'ºC'),
	(276114, 120, '2014-04-01 00:57:23.000000', 'temperatura', 437.0000, 'ºC'),
	(276115, 120, '2014-04-01 00:57:24.000000', 'temperatura', 185.0000, 'ºC'),
	(276116, 120, '2014-04-01 00:57:25.000000', 'temperatura', 816.0000, 'ºC'),
	(276117, 120, '2014-04-01 00:57:26.000000', 'temperatura', 1125.0000, 'ºC'),
	(276118, 120, '2014-04-01 00:57:27.000000', 'temperatura', 778.0000, 'ºC'),
	(276119, 120, '2014-04-01 00:57:28.000000', 'temperatura', 514.0000, 'ºC'),
	(276120, 120, '2014-04-01 00:57:29.000000', 'temperatura', 238.0000, 'ºC'),
	(276121, 120, '2014-04-01 00:57:30.000000', 'temperatura', 848.0000, 'ºC'),
	(276122, 120, '2014-04-01 00:57:31.000000', 'temperatura', 1127.0000, 'ºC'),
	(276123, 120, '2014-04-01 00:57:32.000000', 'temperatura', 691.0000, 'ºC'),
	(276124, 120, '2014-04-01 00:57:33.000000', 'temperatura', 75.0000, 'ºC'),
	(276125, 120, '2014-04-01 00:57:34.000000', 'temperatura', 702.0000, 'ºC'),
	(276126, 120, '2014-04-01 00:57:35.000000', 'temperatura', 887.0000, 'ºC'),
	(276127, 120, '2014-04-01 00:57:36.000000', 'temperatura', 1128.0000, 'ºC'),
	(276128, 120, '2014-04-01 00:57:37.000000', 'temperatura', 578.0000, 'ºC'),
	(276129, 120, '2014-04-01 00:57:38.000000', 'temperatura', 708.0000, 'ºC'),
	(276130, 120, '2014-04-01 00:57:39.000000', 'temperatura', 606.0000, 'ºC'),
	(276131, 120, '2014-04-01 00:57:40.000000', 'temperatura', 907.0000, 'ºC'),
	(276132, 120, '2014-04-01 00:57:41.000000', 'temperatura', 319.0000, 'ºC'),
	(276133, 120, '2014-04-01 00:57:42.000000', 'temperatura', 74.0000, 'ºC'),
	(276134, 120, '2014-04-01 00:57:43.000000', 'temperatura', 613.0000, 'ºC'),
	(276135, 120, '2014-04-01 00:57:44.000000', 'temperatura', 444.0000, 'ºC'),
	(276136, 120, '2014-04-01 00:57:45.000000', 'temperatura', 382.0000, 'ºC'),
	(276137, 120, '2014-04-01 00:57:46.000000', 'temperatura', 576.0000, 'ºC'),
	(276138, 120, '2014-04-01 00:57:47.000000', 'temperatura', 538.0000, 'ºC'),
	(276139, 120, '2014-04-01 00:57:48.000000', 'temperatura', 959.0000, 'ºC'),
	(276140, 120, '2014-04-01 00:57:49.000000', 'temperatura', 784.0000, 'ºC'),
	(276141, 120, '2014-04-01 00:57:50.000000', 'temperatura', 1043.0000, 'ºC'),
	(276142, 120, '2014-04-01 00:57:51.000000', 'temperatura', 461.0000, 'ºC'),
	(276143, 120, '2014-04-01 00:57:52.000000', 'temperatura', 379.0000, 'ºC'),
	(276144, 120, '2014-04-01 00:57:53.000000', 'temperatura', 513.0000, 'ºC'),
	(276145, 120, '2014-04-01 00:57:54.000000', 'temperatura', 227.0000, 'ºC'),
	(276146, 120, '2014-04-01 00:57:55.000000', 'temperatura', 798.0000, 'ºC'),
	(276147, 120, '2014-04-01 00:57:56.000000', 'temperatura', 907.0000, 'ºC'),
	(276148, 120, '2014-04-01 00:57:57.000000', 'temperatura', 942.0000, 'ºC'),
	(276149, 120, '2014-04-01 00:57:58.000000', 'temperatura', 792.0000, 'ºC'),
	(276150, 120, '2014-04-01 00:57:59.000000', 'temperatura', 1134.0000, 'ºC'),
	(276151, 120, '2014-04-01 00:58:00.000000', 'temperatura', 892.0000, 'ºC'),
	(276152, 120, '2014-04-01 00:58:01.000000', 'temperatura', 1060.0000, 'ºC'),
	(276153, 120, '2014-04-01 00:58:02.000000', 'temperatura', 224.0000, 'ºC'),
	(276154, 120, '2014-04-01 00:58:03.000000', 'temperatura', 343.0000, 'ºC'),
	(276155, 120, '2014-04-01 00:58:04.000000', 'temperatura', 1041.0000, 'ºC'),
	(276156, 120, '2014-04-01 00:58:05.000000', 'temperatura', 579.0000, 'ºC'),
	(276157, 120, '2014-04-01 00:58:06.000000', 'temperatura', 971.0000, 'ºC'),
	(276158, 120, '2014-04-01 00:58:07.000000', 'temperatura', 718.0000, 'ºC'),
	(276159, 120, '2014-04-01 00:58:08.000000', 'temperatura', 679.0000, 'ºC'),
	(276160, 120, '2014-04-01 00:58:09.000000', 'temperatura', 40.0000, 'ºC'),
	(276161, 120, '2014-04-01 00:58:10.000000', 'temperatura', 566.0000, 'ºC'),
	(276162, 120, '2014-04-01 00:58:11.000000', 'temperatura', 307.0000, 'ºC'),
	(276163, 120, '2014-04-01 00:58:12.000000', 'temperatura', 1039.0000, 'ºC'),
	(276164, 120, '2014-04-01 00:58:13.000000', 'temperatura', 676.0000, 'ºC'),
	(276165, 120, '2014-04-01 00:58:14.000000', 'temperatura', 263.0000, 'ºC'),
	(276166, 120, '2014-04-01 00:58:15.000000', 'temperatura', 489.0000, 'ºC'),
	(276167, 120, '2014-04-01 00:58:16.000000', 'temperatura', 455.0000, 'ºC'),
	(276168, 120, '2014-04-01 00:58:17.000000', 'temperatura', 808.0000, 'ºC'),
	(276169, 120, '2014-04-01 00:58:18.000000', 'temperatura', 276.0000, 'ºC'),
	(276170, 120, '2014-04-01 00:58:19.000000', 'temperatura', 155.0000, 'ºC'),
	(276171, 120, '2014-04-01 00:58:20.000000', 'temperatura', 1148.0000, 'ºC'),
	(276172, 120, '2014-04-01 00:58:21.000000', 'temperatura', 478.0000, 'ºC'),
	(276173, 120, '2014-04-01 00:58:22.000000', 'temperatura', 143.0000, 'ºC'),
	(276174, 120, '2014-04-01 00:58:23.000000', 'temperatura', 484.0000, 'ºC'),
	(276175, 120, '2014-04-01 00:58:24.000000', 'temperatura', 790.0000, 'ºC'),
	(276176, 120, '2014-04-01 00:58:25.000000', 'temperatura', 101.0000, 'ºC'),
	(276177, 120, '2014-04-01 00:58:26.000000', 'temperatura', 533.0000, 'ºC'),
	(276178, 121, '2014-04-01 00:00:00.000000', 'temperatura', 618.0000, 'ºC'),
	(276179, 121, '2014-04-01 00:00:01.000000', 'temperatura', 801.0000, 'ºC'),
	(276180, 121, '2014-04-01 00:00:02.000000', 'temperatura', 949.0000, 'ºC'),
	(276181, 121, '2014-04-01 00:00:03.000000', 'temperatura', 1146.0000, 'ºC'),
	(276182, 121, '2014-04-01 00:00:04.000000', 'temperatura', 482.0000, 'ºC'),
	(276183, 121, '2014-04-01 00:00:05.000000', 'temperatura', 173.0000, 'ºC'),
	(276184, 121, '2014-04-01 00:00:06.000000', 'temperatura', 621.0000, 'ºC'),
	(276185, 121, '2014-04-01 00:00:07.000000', 'temperatura', 186.0000, 'ºC'),
	(276186, 121, '2014-04-01 00:00:08.000000', 'temperatura', 267.0000, 'ºC'),
	(276187, 121, '2014-04-01 00:00:09.000000', 'temperatura', 779.0000, 'ºC'),
	(276188, 121, '2014-04-01 00:00:10.000000', 'temperatura', 694.0000, 'ºC'),
	(276189, 121, '2014-04-01 00:00:11.000000', 'temperatura', 1133.0000, 'ºC'),
	(276190, 121, '2014-04-01 00:00:12.000000', 'temperatura', 1182.0000, 'ºC'),
	(276191, 121, '2014-04-01 00:00:13.000000', 'temperatura', 112.0000, 'ºC'),
	(276192, 121, '2014-04-01 00:00:14.000000', 'temperatura', 617.0000, 'ºC'),
	(276193, 121, '2014-04-01 00:00:15.000000', 'temperatura', 348.0000, 'ºC'),
	(276194, 121, '2014-04-01 00:00:16.000000', 'temperatura', 1090.0000, 'ºC'),
	(276195, 121, '2014-04-01 00:00:17.000000', 'temperatura', 806.0000, 'ºC'),
	(276196, 121, '2014-04-01 00:00:18.000000', 'temperatura', 761.0000, 'ºC'),
	(276197, 121, '2014-04-01 00:00:19.000000', 'temperatura', 186.0000, 'ºC'),
	(276198, 121, '2014-04-01 00:00:20.000000', 'temperatura', 1049.0000, 'ºC'),
	(276199, 121, '2014-04-01 00:00:21.000000', 'temperatura', 1087.0000, 'ºC'),
	(276200, 121, '2014-04-01 00:00:22.000000', 'temperatura', 1088.0000, 'ºC'),
	(276201, 121, '2014-04-01 00:00:23.000000', 'temperatura', 981.0000, 'ºC'),
	(276202, 121, '2014-04-01 00:00:24.000000', 'temperatura', 440.0000, 'ºC'),
	(276203, 121, '2014-04-01 00:00:25.000000', 'temperatura', 457.0000, 'ºC'),
	(276204, 121, '2014-04-01 00:00:26.000000', 'temperatura', 967.0000, 'ºC'),
	(276205, 121, '2014-04-01 00:00:27.000000', 'temperatura', 1064.0000, 'ºC'),
	(276206, 121, '2014-04-01 00:00:28.000000', 'temperatura', 18.0000, 'ºC'),
	(276207, 121, '2014-04-01 00:00:29.000000', 'temperatura', 502.0000, 'ºC'),
	(276208, 121, '2014-04-01 00:00:30.000000', 'temperatura', 53.0000, 'ºC'),
	(276209, 121, '2014-04-01 00:00:31.000000', 'temperatura', 1159.0000, 'ºC'),
	(276210, 121, '2014-04-01 00:00:32.000000', 'temperatura', 839.0000, 'ºC'),
	(276211, 121, '2014-04-01 00:00:33.000000', 'temperatura', 717.0000, 'ºC'),
	(276212, 121, '2014-04-01 00:00:34.000000', 'temperatura', 1071.0000, 'ºC'),
	(276213, 121, '2014-04-01 00:00:35.000000', 'temperatura', 802.0000, 'ºC'),
	(276214, 121, '2014-04-01 00:00:36.000000', 'temperatura', 797.0000, 'ºC'),
	(276215, 121, '2014-04-01 00:00:37.000000', 'temperatura', 382.0000, 'ºC'),
	(276216, 121, '2014-04-01 00:00:38.000000', 'temperatura', 717.0000, 'ºC'),
	(276217, 121, '2014-04-01 00:00:39.000000', 'temperatura', 41.0000, 'ºC'),
	(276218, 121, '2014-04-01 00:00:40.000000', 'temperatura', 453.0000, 'ºC'),
	(276219, 121, '2014-04-01 00:00:41.000000', 'temperatura', 945.0000, 'ºC'),
	(276220, 121, '2014-04-01 00:00:42.000000', 'temperatura', 964.0000, 'ºC'),
	(276221, 121, '2014-04-01 00:00:43.000000', 'temperatura', 786.0000, 'ºC'),
	(276222, 121, '2014-04-01 00:00:44.000000', 'temperatura', 1037.0000, 'ºC'),
	(276223, 121, '2014-04-01 00:00:45.000000', 'temperatura', 429.0000, 'ºC'),
	(276224, 121, '2014-04-01 00:00:46.000000', 'temperatura', 233.0000, 'ºC'),
	(276225, 121, '2014-04-01 00:00:47.000000', 'temperatura', 1080.0000, 'ºC'),
	(276226, 121, '2014-04-01 00:00:48.000000', 'temperatura', 1103.0000, 'ºC'),
	(276227, 121, '2014-04-01 00:00:49.000000', 'temperatura', 1074.0000, 'ºC'),
	(276228, 121, '2014-04-01 00:00:50.000000', 'temperatura', 862.0000, 'ºC'),
	(276229, 121, '2014-04-01 00:00:51.000000', 'temperatura', 1090.0000, 'ºC'),
	(276230, 121, '2014-04-01 00:00:52.000000', 'temperatura', 464.0000, 'ºC'),
	(276231, 121, '2014-04-01 00:00:53.000000', 'temperatura', 248.0000, 'ºC'),
	(276232, 121, '2014-04-01 00:00:54.000000', 'temperatura', 1051.0000, 'ºC'),
	(276233, 121, '2014-04-01 00:00:55.000000', 'temperatura', 912.0000, 'ºC'),
	(276234, 121, '2014-04-01 00:00:56.000000', 'temperatura', 206.0000, 'ºC'),
	(276235, 121, '2014-04-01 00:00:57.000000', 'temperatura', 695.0000, 'ºC'),
	(276236, 121, '2014-04-01 00:00:58.000000', 'temperatura', 456.0000, 'ºC'),
	(276237, 121, '2014-04-01 00:00:59.000000', 'temperatura', 197.0000, 'ºC'),
	(276238, 121, '2014-04-01 00:01:00.000000', 'temperatura', 818.0000, 'ºC'),
	(276239, 121, '2014-04-01 00:01:01.000000', 'temperatura', 1098.0000, 'ºC'),
	(276240, 121, '2014-04-01 00:01:02.000000', 'temperatura', 638.0000, 'ºC'),
	(276241, 121, '2014-04-01 00:01:03.000000', 'temperatura', 1097.0000, 'ºC'),
	(276242, 121, '2014-04-01 00:01:04.000000', 'temperatura', 1170.0000, 'ºC'),
	(276243, 121, '2014-04-01 00:01:05.000000', 'temperatura', 159.0000, 'ºC'),
	(276244, 121, '2014-04-01 00:01:06.000000', 'temperatura', 888.0000, 'ºC'),
	(276245, 121, '2014-04-01 00:01:07.000000', 'temperatura', 363.0000, 'ºC'),
	(276246, 121, '2014-04-01 00:01:08.000000', 'temperatura', 350.0000, 'ºC'),
	(276247, 121, '2014-04-01 00:01:09.000000', 'temperatura', 662.0000, 'ºC'),
	(276248, 121, '2014-04-01 00:01:10.000000', 'temperatura', 1063.0000, 'ºC'),
	(276249, 121, '2014-04-01 00:01:11.000000', 'temperatura', 926.0000, 'ºC'),
	(276250, 121, '2014-04-01 00:01:12.000000', 'temperatura', 242.0000, 'ºC'),
	(276251, 121, '2014-04-01 00:01:13.000000', 'temperatura', 833.0000, 'ºC'),
	(276252, 121, '2014-04-01 00:01:14.000000', 'temperatura', 1040.0000, 'ºC'),
	(276253, 121, '2014-04-01 00:01:15.000000', 'temperatura', 301.0000, 'ºC'),
	(276254, 121, '2014-04-01 00:01:16.000000', 'temperatura', 784.0000, 'ºC'),
	(276255, 121, '2014-04-01 00:01:17.000000', 'temperatura', 618.0000, 'ºC'),
	(276256, 121, '2014-04-01 00:01:18.000000', 'temperatura', 740.0000, 'ºC'),
	(276257, 121, '2014-04-01 00:01:19.000000', 'temperatura', 645.0000, 'ºC'),
	(276258, 121, '2014-04-01 00:01:20.000000', 'temperatura', 1005.0000, 'ºC'),
	(276259, 121, '2014-04-01 00:01:21.000000', 'temperatura', 690.0000, 'ºC'),
	(276260, 121, '2014-04-01 00:01:22.000000', 'temperatura', 437.0000, 'ºC'),
	(276261, 121, '2014-04-01 00:01:23.000000', 'temperatura', 116.0000, 'ºC'),
	(276262, 121, '2014-04-01 00:01:24.000000', 'temperatura', 467.0000, 'ºC'),
	(276263, 121, '2014-04-01 00:01:25.000000', 'temperatura', 788.0000, 'ºC'),
	(276264, 121, '2014-04-01 00:01:26.000000', 'temperatura', 142.0000, 'ºC'),
	(276265, 121, '2014-04-01 00:01:27.000000', 'temperatura', 745.0000, 'ºC'),
	(276266, 121, '2014-04-01 00:01:28.000000', 'temperatura', 898.0000, 'ºC'),
	(276267, 121, '2014-04-01 00:01:29.000000', 'temperatura', 1058.0000, 'ºC'),
	(276268, 121, '2014-04-01 00:01:30.000000', 'temperatura', 197.0000, 'ºC'),
	(276269, 121, '2014-04-01 00:01:31.000000', 'temperatura', 210.0000, 'ºC'),
	(276270, 121, '2014-04-01 00:01:32.000000', 'temperatura', 460.0000, 'ºC'),
	(276271, 121, '2014-04-01 00:01:33.000000', 'temperatura', 472.0000, 'ºC'),
	(276272, 121, '2014-04-01 00:01:34.000000', 'temperatura', 981.0000, 'ºC'),
	(276273, 121, '2014-04-01 00:01:35.000000', 'temperatura', 1086.0000, 'ºC'),
	(276274, 121, '2014-04-01 00:01:36.000000', 'temperatura', 91.0000, 'ºC'),
	(276275, 121, '2014-04-01 00:01:37.000000', 'temperatura', 796.0000, 'ºC'),
	(276276, 121, '2014-04-01 00:01:38.000000', 'temperatura', 107.0000, 'ºC'),
	(276277, 121, '2014-04-01 00:01:39.000000', 'temperatura', 547.0000, 'ºC'),
	(276278, 121, '2014-04-01 00:01:40.000000', 'temperatura', 13.0000, 'ºC'),
	(276279, 121, '2014-04-01 00:01:41.000000', 'temperatura', 827.0000, 'ºC'),
	(276280, 121, '2014-04-01 00:01:42.000000', 'temperatura', 496.0000, 'ºC'),
	(276281, 121, '2014-04-01 00:01:43.000000', 'temperatura', 0.0000, 'ºC'),
	(276282, 121, '2014-04-01 00:01:44.000000', 'temperatura', 912.0000, 'ºC'),
	(276283, 121, '2014-04-01 00:01:45.000000', 'temperatura', 959.0000, 'ºC'),
	(276284, 121, '2014-04-01 00:01:46.000000', 'temperatura', 863.0000, 'ºC'),
	(276285, 121, '2014-04-01 00:01:47.000000', 'temperatura', 235.0000, 'ºC'),
	(276286, 121, '2014-04-01 00:01:48.000000', 'temperatura', 987.0000, 'ºC'),
	(276287, 121, '2014-04-01 00:01:49.000000', 'temperatura', 631.0000, 'ºC'),
	(276288, 121, '2014-04-01 00:01:50.000000', 'temperatura', 197.0000, 'ºC'),
	(276289, 121, '2014-04-01 00:01:51.000000', 'temperatura', 289.0000, 'ºC'),
	(276290, 121, '2014-04-01 00:01:52.000000', 'temperatura', 854.0000, 'ºC'),
	(276291, 121, '2014-04-01 00:01:53.000000', 'temperatura', 1006.0000, 'ºC'),
	(276292, 121, '2014-04-01 00:01:54.000000', 'temperatura', 69.0000, 'ºC'),
	(276293, 121, '2014-04-01 00:01:55.000000', 'temperatura', 926.0000, 'ºC'),
	(276294, 121, '2014-04-01 00:01:56.000000', 'temperatura', 825.0000, 'ºC'),
	(276295, 121, '2014-04-01 00:01:57.000000', 'temperatura', 148.0000, 'ºC'),
	(276296, 121, '2014-04-01 00:01:58.000000', 'temperatura', 667.0000, 'ºC'),
	(276297, 121, '2014-04-01 00:01:59.000000', 'temperatura', 488.0000, 'ºC'),
	(276298, 121, '2014-04-01 00:02:00.000000', 'temperatura', 442.0000, 'ºC'),
	(276299, 121, '2014-04-01 00:02:01.000000', 'temperatura', 748.0000, 'ºC'),
	(276300, 121, '2014-04-01 00:02:02.000000', 'temperatura', 11.0000, 'ºC'),
	(276301, 121, '2014-04-01 00:02:03.000000', 'temperatura', 213.0000, 'ºC'),
	(276302, 121, '2014-04-01 00:02:04.000000', 'temperatura', 1033.0000, 'ºC'),
	(276303, 121, '2014-04-01 00:02:05.000000', 'temperatura', 927.0000, 'ºC'),
	(276304, 121, '2014-04-01 00:02:06.000000', 'temperatura', 336.0000, 'ºC'),
	(276305, 121, '2014-04-01 00:02:07.000000', 'temperatura', 100.0000, 'ºC'),
	(276306, 121, '2014-04-01 00:02:08.000000', 'temperatura', 694.0000, 'ºC'),
	(276307, 121, '2014-04-01 00:02:09.000000', 'temperatura', 768.0000, 'ºC'),
	(276308, 121, '2014-04-01 00:02:10.000000', 'temperatura', 558.0000, 'ºC'),
	(276309, 121, '2014-04-01 00:02:11.000000', 'temperatura', 488.0000, 'ºC'),
	(276310, 121, '2014-04-01 00:02:12.000000', 'temperatura', 766.0000, 'ºC'),
	(276311, 121, '2014-04-01 00:02:13.000000', 'temperatura', 1166.0000, 'ºC'),
	(276312, 121, '2014-04-01 00:02:14.000000', 'temperatura', 1134.0000, 'ºC'),
	(276313, 121, '2014-04-01 00:02:15.000000', 'temperatura', 971.0000, 'ºC'),
	(276314, 121, '2014-04-01 00:02:16.000000', 'temperatura', 253.0000, 'ºC'),
	(276315, 121, '2014-04-01 00:02:17.000000', 'temperatura', 753.0000, 'ºC'),
	(276316, 121, '2014-04-01 00:02:18.000000', 'temperatura', 607.0000, 'ºC'),
	(276317, 121, '2014-04-01 00:02:19.000000', 'temperatura', 774.0000, 'ºC'),
	(276318, 121, '2014-04-01 00:02:20.000000', 'temperatura', 852.0000, 'ºC'),
	(276319, 121, '2014-04-01 00:02:21.000000', 'temperatura', 738.0000, 'ºC'),
	(276320, 121, '2014-04-01 00:02:22.000000', 'temperatura', 1135.0000, 'ºC'),
	(276321, 121, '2014-04-01 00:02:23.000000', 'temperatura', 1060.0000, 'ºC'),
	(276322, 121, '2014-04-01 00:02:24.000000', 'temperatura', 698.0000, 'ºC'),
	(276323, 121, '2014-04-01 00:02:25.000000', 'temperatura', 308.0000, 'ºC'),
	(276324, 121, '2014-04-01 00:02:26.000000', 'temperatura', 649.0000, 'ºC'),
	(276325, 121, '2014-04-01 00:02:27.000000', 'temperatura', 1121.0000, 'ºC'),
	(276326, 121, '2014-04-01 00:02:28.000000', 'temperatura', 57.0000, 'ºC'),
	(276327, 121, '2014-04-01 00:02:29.000000', 'temperatura', 523.0000, 'ºC'),
	(276328, 121, '2014-04-01 00:02:30.000000', 'temperatura', 45.0000, 'ºC'),
	(276329, 121, '2014-04-01 00:02:31.000000', 'temperatura', 1054.0000, 'ºC'),
	(276330, 121, '2014-04-01 00:02:32.000000', 'temperatura', 339.0000, 'ºC'),
	(276331, 121, '2014-04-01 00:02:33.000000', 'temperatura', 932.0000, 'ºC'),
	(276332, 121, '2014-04-01 00:02:34.000000', 'temperatura', 42.0000, 'ºC'),
	(276333, 121, '2014-04-01 00:02:35.000000', 'temperatura', 1016.0000, 'ºC'),
	(276334, 121, '2014-04-01 00:02:36.000000', 'temperatura', 154.0000, 'ºC'),
	(276335, 121, '2014-04-01 00:02:37.000000', 'temperatura', 123.0000, 'ºC'),
	(276336, 121, '2014-04-01 00:02:38.000000', 'temperatura', 152.0000, 'ºC'),
	(276337, 121, '2014-04-01 00:02:39.000000', 'temperatura', 392.0000, 'ºC'),
	(276338, 121, '2014-04-01 00:02:40.000000', 'temperatura', 307.0000, 'ºC'),
	(276339, 121, '2014-04-01 00:02:41.000000', 'temperatura', 356.0000, 'ºC'),
	(276340, 121, '2014-04-01 00:02:42.000000', 'temperatura', 861.0000, 'ºC'),
	(276341, 121, '2014-04-01 00:02:43.000000', 'temperatura', 837.0000, 'ºC'),
	(276342, 121, '2014-04-01 00:02:44.000000', 'temperatura', 403.0000, 'ºC'),
	(276343, 121, '2014-04-01 00:02:45.000000', 'temperatura', 705.0000, 'ºC'),
	(276344, 121, '2014-04-01 00:02:46.000000', 'temperatura', 1116.0000, 'ºC'),
	(276345, 121, '2014-04-01 00:02:47.000000', 'temperatura', 1064.0000, 'ºC'),
	(276346, 121, '2014-04-01 00:02:48.000000', 'temperatura', 773.0000, 'ºC'),
	(276347, 121, '2014-04-01 00:02:49.000000', 'temperatura', 675.0000, 'ºC'),
	(276348, 121, '2014-04-01 00:02:50.000000', 'temperatura', 1054.0000, 'ºC'),
	(276349, 121, '2014-04-01 00:02:51.000000', 'temperatura', 848.0000, 'ºC'),
	(276350, 121, '2014-04-01 00:02:52.000000', 'temperatura', 1077.0000, 'ºC'),
	(276351, 121, '2014-04-01 00:02:53.000000', 'temperatura', 444.0000, 'ºC'),
	(276352, 121, '2014-04-01 00:02:54.000000', 'temperatura', 188.0000, 'ºC'),
	(276353, 121, '2014-04-01 00:02:55.000000', 'temperatura', 807.0000, 'ºC'),
	(276354, 121, '2014-04-01 00:02:56.000000', 'temperatura', 1073.0000, 'ºC'),
	(276355, 121, '2014-04-01 00:02:57.000000', 'temperatura', 544.0000, 'ºC'),
	(276356, 121, '2014-04-01 00:02:58.000000', 'temperatura', 702.0000, 'ºC'),
	(276357, 121, '2014-04-01 00:02:59.000000', 'temperatura', 680.0000, 'ºC'),
	(276358, 121, '2014-04-01 00:03:00.000000', 'temperatura', 93.0000, 'ºC'),
	(276359, 121, '2014-04-01 00:03:01.000000', 'temperatura', 825.0000, 'ºC'),
	(276360, 121, '2014-04-01 00:03:02.000000', 'temperatura', 249.0000, 'ºC'),
	(276361, 121, '2014-04-01 00:03:03.000000', 'temperatura', 1169.0000, 'ºC'),
	(276362, 121, '2014-04-01 00:03:04.000000', 'temperatura', 300.0000, 'ºC'),
	(276363, 121, '2014-04-01 00:03:05.000000', 'temperatura', 390.0000, 'ºC'),
	(276364, 121, '2014-04-01 00:03:06.000000', 'temperatura', 1054.0000, 'ºC'),
	(276365, 121, '2014-04-01 00:03:07.000000', 'temperatura', 500.0000, 'ºC'),
	(276366, 121, '2014-04-01 00:03:08.000000', 'temperatura', 537.0000, 'ºC'),
	(276367, 121, '2014-04-01 00:03:09.000000', 'temperatura', 1186.0000, 'ºC'),
	(276368, 121, '2014-04-01 00:03:10.000000', 'temperatura', 720.0000, 'ºC'),
	(276369, 121, '2014-04-01 00:03:11.000000', 'temperatura', 43.0000, 'ºC'),
	(276370, 121, '2014-04-01 00:03:12.000000', 'temperatura', 456.0000, 'ºC'),
	(276371, 121, '2014-04-01 00:03:13.000000', 'temperatura', 950.0000, 'ºC'),
	(276372, 121, '2014-04-01 00:03:14.000000', 'temperatura', 983.0000, 'ºC'),
	(276373, 121, '2014-04-01 00:03:15.000000', 'temperatura', 865.0000, 'ºC'),
	(276374, 121, '2014-04-01 00:03:16.000000', 'temperatura', 175.0000, 'ºC'),
	(276375, 121, '2014-04-01 00:03:17.000000', 'temperatura', 683.0000, 'ºC'),
	(276376, 121, '2014-04-01 00:03:18.000000', 'temperatura', 489.0000, 'ºC'),
	(276377, 121, '2014-04-01 00:03:19.000000', 'temperatura', 395.0000, 'ºC'),
	(276378, 121, '2014-04-01 00:03:20.000000', 'temperatura', 511.0000, 'ºC'),
	(276379, 121, '2014-04-01 00:03:21.000000', 'temperatura', 171.0000, 'ºC'),
	(276380, 121, '2014-04-01 00:03:22.000000', 'temperatura', 521.0000, 'ºC'),
	(276381, 121, '2014-04-01 00:03:23.000000', 'temperatura', 894.0000, 'ºC'),
	(276382, 121, '2014-04-01 00:03:24.000000', 'temperatura', 506.0000, 'ºC'),
	(276383, 121, '2014-04-01 00:03:25.000000', 'temperatura', 1051.0000, 'ºC'),
	(276384, 121, '2014-04-01 00:03:26.000000', 'temperatura', 135.0000, 'ºC'),
	(276385, 121, '2014-04-01 00:03:27.000000', 'temperatura', 1123.0000, 'ºC'),
	(276386, 121, '2014-04-01 00:03:28.000000', 'temperatura', 412.0000, 'ºC'),
	(276387, 121, '2014-04-01 00:03:29.000000', 'temperatura', 1089.0000, 'ºC'),
	(276388, 121, '2014-04-01 00:03:30.000000', 'temperatura', 611.0000, 'ºC'),
	(276389, 121, '2014-04-01 00:03:31.000000', 'temperatura', 990.0000, 'ºC'),
	(276390, 121, '2014-04-01 00:03:32.000000', 'temperatura', 715.0000, 'ºC'),
	(276391, 121, '2014-04-01 00:03:33.000000', 'temperatura', 607.0000, 'ºC'),
	(276392, 121, '2014-04-01 00:03:34.000000', 'temperatura', 890.0000, 'ºC'),
	(276393, 121, '2014-04-01 00:03:35.000000', 'temperatura', 231.0000, 'ºC'),
	(276394, 121, '2014-04-01 00:03:36.000000', 'temperatura', 885.0000, 'ºC'),
	(276395, 121, '2014-04-01 00:03:37.000000', 'temperatura', 133.0000, 'ºC'),
	(276396, 121, '2014-04-01 00:03:38.000000', 'temperatura', 410.0000, 'ºC'),
	(276397, 121, '2014-04-01 00:03:39.000000', 'temperatura', 452.0000, 'ºC'),
	(276398, 121, '2014-04-01 00:03:40.000000', 'temperatura', 1031.0000, 'ºC'),
	(276399, 121, '2014-04-01 00:03:41.000000', 'temperatura', 198.0000, 'ºC'),
	(276400, 121, '2014-04-01 00:03:42.000000', 'temperatura', 296.0000, 'ºC'),
	(276401, 121, '2014-04-01 00:03:43.000000', 'temperatura', 890.0000, 'ºC'),
	(276402, 121, '2014-04-01 00:03:44.000000', 'temperatura', 1159.0000, 'ºC'),
	(276403, 121, '2014-04-01 00:03:45.000000', 'temperatura', 728.0000, 'ºC'),
	(276404, 121, '2014-04-01 00:03:46.000000', 'temperatura', 163.0000, 'ºC'),
	(276405, 121, '2014-04-01 00:03:47.000000', 'temperatura', 1031.0000, 'ºC'),
	(276406, 121, '2014-04-01 00:03:48.000000', 'temperatura', 1068.0000, 'ºC'),
	(276407, 121, '2014-04-01 00:03:49.000000', 'temperatura', 1047.0000, 'ºC'),
	(276408, 121, '2014-04-01 00:03:50.000000', 'temperatura', 833.0000, 'ºC'),
	(276409, 121, '2014-04-01 00:03:51.000000', 'temperatura', 1024.0000, 'ºC'),
	(276410, 121, '2014-04-01 00:03:52.000000', 'temperatura', 220.0000, 'ºC'),
	(276411, 121, '2014-04-01 00:03:53.000000', 'temperatura', 427.0000, 'ºC'),
	(276412, 121, '2014-04-01 00:03:54.000000', 'temperatura', 278.0000, 'ºC'),
	(276413, 121, '2014-04-01 00:03:55.000000', 'temperatura', 107.0000, 'ºC'),
	(276414, 121, '2014-04-01 00:03:56.000000', 'temperatura', 903.0000, 'ºC'),
	(276415, 121, '2014-04-01 00:03:57.000000', 'temperatura', 593.0000, 'ºC'),
	(276416, 121, '2014-04-01 00:03:58.000000', 'temperatura', 259.0000, 'ºC'),
	(276417, 121, '2014-04-01 00:03:59.000000', 'temperatura', 715.0000, 'ºC'),
	(276418, 121, '2014-04-01 00:04:00.000000', 'temperatura', 400.0000, 'ºC'),
	(276419, 121, '2014-04-01 00:04:01.000000', 'temperatura', 1053.0000, 'ºC'),
	(276420, 121, '2014-04-01 00:04:02.000000', 'temperatura', 467.0000, 'ºC'),
	(276421, 121, '2014-04-01 00:04:03.000000', 'temperatura', 377.0000, 'ºC'),
	(276422, 121, '2014-04-01 00:04:04.000000', 'temperatura', 485.0000, 'ºC'),
	(276423, 121, '2014-04-01 00:04:05.000000', 'temperatura', 92.0000, 'ºC'),
	(276424, 121, '2014-04-01 00:04:06.000000', 'temperatura', 206.0000, 'ºC'),
	(276425, 121, '2014-04-01 00:04:07.000000', 'temperatura', 755.0000, 'ºC'),
	(276426, 121, '2014-04-01 00:04:08.000000', 'temperatura', 756.0000, 'ºC'),
	(276427, 121, '2014-04-01 00:04:09.000000', 'temperatura', 316.0000, 'ºC'),
	(276428, 121, '2014-04-01 00:04:10.000000', 'temperatura', 513.0000, 'ºC'),
	(276429, 121, '2014-04-01 00:04:11.000000', 'temperatura', 418.0000, 'ºC'),
	(276430, 121, '2014-04-01 00:04:12.000000', 'temperatura', 549.0000, 'ºC'),
	(276431, 121, '2014-04-01 00:04:13.000000', 'temperatura', 295.0000, 'ºC'),
	(276432, 121, '2014-04-01 00:04:14.000000', 'temperatura', 1025.0000, 'ºC'),
	(276433, 121, '2014-04-01 00:04:15.000000', 'temperatura', 642.0000, 'ºC'),
	(276434, 121, '2014-04-01 00:04:16.000000', 'temperatura', 137.0000, 'ºC'),
	(276435, 121, '2014-04-01 00:04:17.000000', 'temperatura', 1159.0000, 'ºC'),
	(276436, 121, '2014-04-01 00:04:18.000000', 'temperatura', 585.0000, 'ºC'),
	(276437, 121, '2014-04-01 00:04:19.000000', 'temperatura', 650.0000, 'ºC'),
	(276438, 121, '2014-04-01 00:04:20.000000', 'temperatura', 294.0000, 'ºC'),
	(276439, 121, '2014-04-01 00:04:21.000000', 'temperatura', 720.0000, 'ºC'),
	(276440, 121, '2014-04-01 00:04:22.000000', 'temperatura', 318.0000, 'ºC'),
	(276441, 121, '2014-04-01 00:04:23.000000', 'temperatura', 632.0000, 'ºC'),
	(276442, 121, '2014-04-01 00:04:24.000000', 'temperatura', 1007.0000, 'ºC'),
	(276443, 121, '2014-04-01 00:04:25.000000', 'temperatura', 740.0000, 'ºC'),
	(276444, 121, '2014-04-01 00:04:26.000000', 'temperatura', 678.0000, 'ºC'),
	(276445, 121, '2014-04-01 00:04:27.000000', 'temperatura', 1173.0000, 'ºC'),
	(276446, 121, '2014-04-01 00:04:28.000000', 'temperatura', 228.0000, 'ºC'),
	(276447, 121, '2014-04-01 00:04:29.000000', 'temperatura', 25.0000, 'ºC'),
	(276448, 121, '2014-04-01 00:04:30.000000', 'temperatura', 638.0000, 'ºC'),
	(276449, 121, '2014-04-01 00:04:31.000000', 'temperatura', 719.0000, 'ºC'),
	(276450, 121, '2014-04-01 00:04:32.000000', 'temperatura', 478.0000, 'ºC'),
	(276451, 121, '2014-04-01 00:04:33.000000', 'temperatura', 237.0000, 'ºC'),
	(276452, 121, '2014-04-01 00:04:34.000000', 'temperatura', 950.0000, 'ºC'),
	(276453, 121, '2014-04-01 00:04:35.000000', 'temperatura', 440.0000, 'ºC'),
	(276454, 121, '2014-04-01 00:04:36.000000', 'temperatura', 551.0000, 'ºC'),
	(276455, 121, '2014-04-01 00:04:37.000000', 'temperatura', 233.0000, 'ºC'),
	(276456, 121, '2014-04-01 00:04:38.000000', 'temperatura', 716.0000, 'ºC'),
	(276457, 121, '2014-04-01 00:04:39.000000', 'temperatura', 478.0000, 'ºC'),
	(276458, 121, '2014-04-01 00:04:40.000000', 'temperatura', 245.0000, 'ºC'),
	(276459, 121, '2014-04-01 00:04:41.000000', 'temperatura', 989.0000, 'ºC'),
	(276460, 121, '2014-04-01 00:04:42.000000', 'temperatura', 610.0000, 'ºC'),
	(276461, 121, '2014-04-01 00:04:43.000000', 'temperatura', 85.0000, 'ºC'),
	(276462, 121, '2014-04-01 00:04:44.000000', 'temperatura', 994.0000, 'ºC'),
	(276463, 121, '2014-04-01 00:04:45.000000', 'temperatura', 1117.0000, 'ºC'),
	(276464, 121, '2014-04-01 00:04:46.000000', 'temperatura', 202.0000, 'ºC'),
	(276465, 121, '2014-04-01 00:04:47.000000', 'temperatura', 60.0000, 'ºC'),
	(276466, 121, '2014-04-01 00:04:48.000000', 'temperatura', 895.0000, 'ºC'),
	(276467, 121, '2014-04-01 00:04:49.000000', 'temperatura', 694.0000, 'ºC'),
	(276468, 121, '2014-04-01 00:04:50.000000', 'temperatura', 785.0000, 'ºC'),
	(276469, 121, '2014-04-01 00:04:51.000000', 'temperatura', 643.0000, 'ºC'),
	(276470, 121, '2014-04-01 00:04:52.000000', 'temperatura', 863.0000, 'ºC'),
	(276471, 121, '2014-04-01 00:04:53.000000', 'temperatura', 1185.0000, 'ºC'),
	(276472, 121, '2014-04-01 00:04:54.000000', 'temperatura', 936.0000, 'ºC'),
	(276473, 121, '2014-04-01 00:04:55.000000', 'temperatura', 1125.0000, 'ºC'),
	(276474, 121, '2014-04-01 00:04:56.000000', 'temperatura', 419.0000, 'ºC'),
	(276475, 121, '2014-04-01 00:04:57.000000', 'temperatura', 1119.0000, 'ºC'),
	(276476, 121, '2014-04-01 00:04:58.000000', 'temperatura', 737.0000, 'ºC'),
	(276477, 121, '2014-04-01 00:04:59.000000', 'temperatura', 331.0000, 'ºC'),
	(276478, 121, '2014-04-01 00:05:00.000000', 'temperatura', 643.0000, 'ºC'),
	(276479, 121, '2014-04-01 00:05:01.000000', 'temperatura', 1024.0000, 'ºC'),
	(276480, 121, '2014-04-01 00:05:02.000000', 'temperatura', 792.0000, 'ºC'),
	(276481, 121, '2014-04-01 00:05:03.000000', 'temperatura', 889.0000, 'ºC'),
	(276482, 121, '2014-04-01 00:05:04.000000', 'temperatura', 871.0000, 'ºC'),
	(276483, 121, '2014-04-01 00:05:05.000000', 'temperatura', 485.0000, 'ºC'),
	(276484, 121, '2014-04-01 00:05:06.000000', 'temperatura', 1013.0000, 'ºC'),
	(276485, 121, '2014-04-01 00:05:07.000000', 'temperatura', 12.0000, 'ºC'),
	(276486, 121, '2014-04-01 00:05:08.000000', 'temperatura', 620.0000, 'ºC'),
	(276487, 121, '2014-04-01 00:05:09.000000', 'temperatura', 665.0000, 'ºC'),
	(276488, 121, '2014-04-01 00:05:10.000000', 'temperatura', 268.0000, 'ºC'),
	(276489, 121, '2014-04-01 00:05:11.000000', 'temperatura', 542.0000, 'ºC'),
	(276490, 121, '2014-04-01 00:05:12.000000', 'temperatura', 709.0000, 'ºC'),
	(276491, 121, '2014-04-01 00:05:13.000000', 'temperatura', 720.0000, 'ºC'),
	(276492, 121, '2014-04-01 00:05:14.000000', 'temperatura', 273.0000, 'ºC'),
	(276493, 121, '2014-04-01 00:05:15.000000', 'temperatura', 406.0000, 'ºC'),
	(276494, 121, '2014-04-01 00:05:16.000000', 'temperatura', 10.0000, 'ºC'),
	(276495, 121, '2014-04-01 00:05:17.000000', 'temperatura', 32.0000, 'ºC'),
	(276496, 121, '2014-04-01 00:05:18.000000', 'temperatura', 131.0000, 'ºC'),
	(276497, 121, '2014-04-01 00:05:19.000000', 'temperatura', 558.0000, 'ºC'),
	(276498, 121, '2014-04-01 00:05:20.000000', 'temperatura', 1198.0000, 'ºC'),
	(276499, 121, '2014-04-01 00:05:21.000000', 'temperatura', 718.0000, 'ºC'),
	(276500, 121, '2014-04-01 00:05:22.000000', 'temperatura', 1194.0000, 'ºC'),
	(276501, 121, '2014-04-01 00:05:23.000000', 'temperatura', 217.0000, 'ºC'),
	(276502, 121, '2014-04-01 00:05:24.000000', 'temperatura', 1105.0000, 'ºC'),
	(276503, 121, '2014-04-01 00:05:25.000000', 'temperatura', 75.0000, 'ºC'),
	(276504, 121, '2014-04-01 00:05:26.000000', 'temperatura', 660.0000, 'ºC'),
	(276505, 121, '2014-04-01 00:05:27.000000', 'temperatura', 673.0000, 'ºC'),
	(276506, 121, '2014-04-01 00:05:28.000000', 'temperatura', 189.0000, 'ºC'),
	(276507, 121, '2014-04-01 00:05:29.000000', 'temperatura', 125.0000, 'ºC'),
	(276508, 121, '2014-04-01 00:05:30.000000', 'temperatura', 59.0000, 'ºC'),
	(276509, 121, '2014-04-01 00:05:31.000000', 'temperatura', 1121.0000, 'ºC'),
	(276510, 121, '2014-04-01 00:05:32.000000', 'temperatura', 628.0000, 'ºC'),
	(276511, 121, '2014-04-01 00:05:33.000000', 'temperatura', 979.0000, 'ºC'),
	(276512, 121, '2014-04-01 00:05:34.000000', 'temperatura', 610.0000, 'ºC'),
	(276513, 121, '2014-04-01 00:05:35.000000', 'temperatura', 114.0000, 'ºC'),
	(276514, 121, '2014-04-01 00:05:36.000000', 'temperatura', 1142.0000, 'ºC'),
	(276515, 121, '2014-04-01 00:05:37.000000', 'temperatura', 566.0000, 'ºC'),
	(276516, 121, '2014-04-01 00:05:38.000000', 'temperatura', 606.0000, 'ºC'),
	(276517, 121, '2014-04-01 00:05:39.000000', 'temperatura', 133.0000, 'ºC'),
	(276518, 121, '2014-04-01 00:05:40.000000', 'temperatura', 46.0000, 'ºC'),
	(276519, 121, '2014-04-01 00:05:41.000000', 'temperatura', 1033.0000, 'ºC'),
	(276520, 121, '2014-04-01 00:05:42.000000', 'temperatura', 228.0000, 'ºC'),
	(276521, 121, '2014-04-01 00:05:43.000000', 'temperatura', 439.0000, 'ºC'),
	(276522, 121, '2014-04-01 00:05:44.000000', 'temperatura', 315.0000, 'ºC'),
	(276523, 121, '2014-04-01 00:05:45.000000', 'temperatura', 256.0000, 'ºC'),
	(276524, 121, '2014-04-01 00:05:46.000000', 'temperatura', 337.0000, 'ºC'),
	(276525, 121, '2014-04-01 00:05:47.000000', 'temperatura', 916.0000, 'ºC'),
	(276526, 121, '2014-04-01 00:05:48.000000', 'temperatura', 1169.0000, 'ºC'),
	(276527, 121, '2014-04-01 00:05:49.000000', 'temperatura', 700.0000, 'ºC'),
	(276528, 121, '2014-04-01 00:05:50.000000', 'temperatura', 1193.0000, 'ºC'),
	(276529, 121, '2014-04-01 00:05:51.000000', 'temperatura', 267.0000, 'ºC'),
	(276530, 121, '2014-04-01 00:05:52.000000', 'temperatura', 154.0000, 'ºC'),
	(276531, 121, '2014-04-01 00:05:53.000000', 'temperatura', 1168.0000, 'ºC'),
	(276532, 121, '2014-04-01 00:05:54.000000', 'temperatura', 582.0000, 'ºC'),
	(276533, 121, '2014-04-01 00:05:55.000000', 'temperatura', 604.0000, 'ºC'),
	(276534, 121, '2014-04-01 00:05:56.000000', 'temperatura', 77.0000, 'ºC'),
	(276535, 121, '2014-04-01 00:05:57.000000', 'temperatura', 974.0000, 'ºC'),
	(276536, 121, '2014-04-01 00:05:58.000000', 'temperatura', 1039.0000, 'ºC'),
	(276537, 121, '2014-04-01 00:05:59.000000', 'temperatura', 1074.0000, 'ºC'),
	(276538, 121, '2014-04-01 00:06:00.000000', 'temperatura', 1054.0000, 'ºC'),
	(276539, 121, '2014-04-01 00:06:01.000000', 'temperatura', 848.0000, 'ºC'),
	(276540, 121, '2014-04-01 00:06:02.000000', 'temperatura', 1079.0000, 'ºC'),
	(276541, 121, '2014-04-01 00:06:03.000000', 'temperatura', 451.0000, 'ºC'),
	(276542, 121, '2014-04-01 00:06:04.000000', 'temperatura', 218.0000, 'ºC'),
	(276543, 121, '2014-04-01 00:06:05.000000', 'temperatura', 938.0000, 'ºC'),
	(276544, 121, '2014-04-01 00:06:06.000000', 'temperatura', 437.0000, 'ºC'),
	(276545, 121, '2014-04-01 00:06:07.000000', 'temperatura', 569.0000, 'ºC'),
	(276546, 121, '2014-04-01 00:06:08.000000', 'temperatura', 336.0000, 'ºC'),
	(276547, 121, '2014-04-01 00:06:09.000000', 'temperatura', 1174.0000, 'ºC'),
	(276548, 121, '2014-04-01 00:06:10.000000', 'temperatura', 61.0000, 'ºC'),
	(276549, 121, '2014-04-01 00:06:11.000000', 'temperatura', 384.0000, 'ºC'),
	(276550, 121, '2014-04-01 00:06:12.000000', 'temperatura', 536.0000, 'ºC'),
	(276551, 121, '2014-04-01 00:06:13.000000', 'temperatura', 329.0000, 'ºC'),
	(276552, 121, '2014-04-01 00:06:14.000000', 'temperatura', 38.0000, 'ºC'),
	(276553, 121, '2014-04-01 00:06:15.000000', 'temperatura', 403.0000, 'ºC'),
	(276554, 121, '2014-04-01 00:06:16.000000', 'temperatura', 700.0000, 'ºC'),
	(276555, 121, '2014-04-01 00:06:17.000000', 'temperatura', 1094.0000, 'ºC'),
	(276556, 121, '2014-04-01 00:06:18.000000', 'temperatura', 968.0000, 'ºC'),
	(276557, 121, '2014-04-01 00:06:19.000000', 'temperatura', 361.0000, 'ºC'),
	(276558, 121, '2014-04-01 00:06:20.000000', 'temperatura', 101.0000, 'ºC'),
	(276559, 121, '2014-04-01 00:06:21.000000', 'temperatura', 624.0000, 'ºC'),
	(276560, 121, '2014-04-01 00:06:22.000000', 'temperatura', 417.0000, 'ºC'),
	(276561, 121, '2014-04-01 00:06:23.000000', 'temperatura', 215.0000, 'ºC'),
	(276562, 121, '2014-04-01 00:06:24.000000', 'temperatura', 1022.0000, 'ºC'),
	(276563, 121, '2014-04-01 00:06:25.000000', 'temperatura', 868.0000, 'ºC'),
	(276564, 121, '2014-04-01 00:06:26.000000', 'temperatura', 71.0000, 'ºC'),
	(276565, 121, '2014-04-01 00:06:27.000000', 'temperatura', 155.0000, 'ºC'),
	(276566, 121, '2014-04-01 00:06:28.000000', 'temperatura', 562.0000, 'ºC'),
	(276567, 121, '2014-04-01 00:06:29.000000', 'temperatura', 1145.0000, 'ºC'),
	(276568, 121, '2014-04-01 00:06:30.000000', 'temperatura', 441.0000, 'ºC'),
	(276569, 121, '2014-04-01 00:06:31.000000', 'temperatura', 1169.0000, 'ºC'),
	(276570, 121, '2014-04-01 00:06:32.000000', 'temperatura', 922.0000, 'ºC'),
	(276571, 121, '2014-04-01 00:06:33.000000', 'temperatura', 1106.0000, 'ºC'),
	(276572, 121, '2014-04-01 00:06:34.000000', 'temperatura', 362.0000, 'ºC'),
	(276573, 121, '2014-04-01 00:06:35.000000', 'temperatura', 894.0000, 'ºC'),
	(276574, 121, '2014-04-01 00:06:36.000000', 'temperatura', 986.0000, 'ºC'),
	(276575, 121, '2014-04-01 00:06:37.000000', 'temperatura', 1047.0000, 'ºC'),
	(276576, 121, '2014-04-01 00:06:38.000000', 'temperatura', 1078.0000, 'ºC'),
	(276577, 121, '2014-04-01 00:06:39.000000', 'temperatura', 1047.0000, 'ºC'),
	(276578, 121, '2014-04-01 00:06:40.000000', 'temperatura', 804.0000, 'ºC'),
	(276579, 121, '2014-04-01 00:06:41.000000', 'temperatura', 877.0000, 'ºC'),
	(276580, 121, '2014-04-01 00:06:42.000000', 'temperatura', 773.0000, 'ºC'),
	(276581, 121, '2014-04-01 00:06:43.000000', 'temperatura', 38.0000, 'ºC'),
	(276582, 121, '2014-04-01 00:06:44.000000', 'temperatura', 268.0000, 'ºC'),
	(276583, 121, '2014-04-01 00:06:45.000000', 'temperatura', 29.0000, 'ºC'),
	(276584, 121, '2014-04-01 00:06:46.000000', 'temperatura', 539.0000, 'ºC'),
	(276585, 121, '2014-04-01 00:06:47.000000', 'temperatura', 210.0000, 'ºC'),
	(276586, 121, '2014-04-01 00:06:48.000000', 'temperatura', 632.0000, 'ºC'),
	(276587, 121, '2014-04-01 00:06:49.000000', 'temperatura', 133.0000, 'ºC'),
	(276588, 121, '2014-04-01 00:06:50.000000', 'temperatura', 1169.0000, 'ºC'),
	(276589, 121, '2014-04-01 00:06:51.000000', 'temperatura', 647.0000, 'ºC'),
	(276590, 121, '2014-04-01 00:06:52.000000', 'temperatura', 927.0000, 'ºC'),
	(276591, 121, '2014-04-01 00:06:53.000000', 'temperatura', 294.0000, 'ºC'),
	(276592, 121, '2014-04-01 00:06:54.000000', 'temperatura', 1088.0000, 'ºC'),
	(276593, 121, '2014-04-01 00:06:55.000000', 'temperatura', 961.0000, 'ºC'),
	(276594, 121, '2014-04-01 00:06:56.000000', 'temperatura', 341.0000, 'ºC'),
	(276595, 121, '2014-04-01 00:06:57.000000', 'temperatura', 22.0000, 'ºC'),
	(276596, 121, '2014-04-01 00:06:58.000000', 'temperatura', 288.0000, 'ºC'),
	(276597, 121, '2014-04-01 00:06:59.000000', 'temperatura', 175.0000, 'ºC'),
	(276598, 121, '2014-04-01 00:07:00.000000', 'temperatura', 12.0000, 'ºC'),
	(276599, 121, '2014-04-01 00:07:01.000000', 'temperatura', 737.0000, 'ºC'),
	(276600, 121, '2014-04-01 00:07:02.000000', 'temperatura', 46.0000, 'ºC'),
	(276601, 121, '2014-04-01 00:07:03.000000', 'temperatura', 421.0000, 'ºC'),
	(276602, 121, '2014-04-01 00:07:04.000000', 'temperatura', 766.0000, 'ºC'),
	(276603, 121, '2014-04-01 00:07:05.000000', 'temperatura', 168.0000, 'ºC'),
	(276604, 121, '2014-04-01 00:07:06.000000', 'temperatura', 943.0000, 'ºC'),
	(276605, 121, '2014-04-01 00:07:07.000000', 'temperatura', 612.0000, 'ºC'),
	(276606, 121, '2014-04-01 00:07:08.000000', 'temperatura', 231.0000, 'ºC'),
	(276607, 121, '2014-04-01 00:07:09.000000', 'temperatura', 518.0000, 'ºC'),
	(276608, 121, '2014-04-01 00:07:10.000000', 'temperatura', 700.0000, 'ºC'),
	(276609, 121, '2014-04-01 00:07:11.000000', 'temperatura', 748.0000, 'ºC'),
	(276610, 121, '2014-04-01 00:07:12.000000', 'temperatura', 437.0000, 'ºC'),
	(276611, 121, '2014-04-01 00:07:13.000000', 'temperatura', 1141.0000, 'ºC'),
	(276612, 121, '2014-04-01 00:07:14.000000', 'temperatura', 797.0000, 'ºC'),
	(276613, 121, '2014-04-01 00:07:15.000000', 'temperatura', 562.0000, 'ºC'),
	(276614, 121, '2014-04-01 00:07:16.000000', 'temperatura', 419.0000, 'ºC'),
	(276615, 121, '2014-04-01 00:07:17.000000', 'temperatura', 410.0000, 'ºC'),
	(276616, 121, '2014-04-01 00:07:18.000000', 'temperatura', 793.0000, 'ºC'),
	(276617, 121, '2014-04-01 00:07:19.000000', 'temperatura', 334.0000, 'ºC'),
	(276618, 121, '2014-04-01 00:07:20.000000', 'temperatura', 494.0000, 'ºC'),
	(276619, 121, '2014-04-01 00:07:21.000000', 'temperatura', 269.0000, 'ºC'),
	(276620, 121, '2014-04-01 00:07:22.000000', 'temperatura', 1061.0000, 'ºC'),
	(276621, 121, '2014-04-01 00:07:23.000000', 'temperatura', 899.0000, 'ºC'),
	(276622, 121, '2014-04-01 00:07:24.000000', 'temperatura', 112.0000, 'ºC'),
	(276623, 121, '2014-04-01 00:07:25.000000', 'temperatura', 263.0000, 'ºC'),
	(276624, 121, '2014-04-01 00:07:26.000000', 'temperatura', 980.0000, 'ºC'),
	(276625, 121, '2014-04-01 00:07:27.000000', 'temperatura', 510.0000, 'ºC'),
	(276626, 121, '2014-04-01 00:07:28.000000', 'temperatura', 812.0000, 'ºC'),
	(276627, 121, '2014-04-01 00:07:29.000000', 'temperatura', 131.0000, 'ºC'),
	(276628, 121, '2014-04-01 00:07:30.000000', 'temperatura', 619.0000, 'ºC'),
	(276629, 121, '2014-04-01 00:07:31.000000', 'temperatura', 304.0000, 'ºC'),
	(276630, 121, '2014-04-01 00:07:32.000000', 'temperatura', 863.0000, 'ºC'),
	(276631, 121, '2014-04-01 00:07:33.000000', 'temperatura', 1003.0000, 'ºC'),
	(276632, 121, '2014-04-01 00:07:34.000000', 'temperatura', 26.0000, 'ºC'),
	(276633, 121, '2014-04-01 00:07:35.000000', 'temperatura', 720.0000, 'ºC'),
	(276634, 121, '2014-04-01 00:07:36.000000', 'temperatura', 1125.0000, 'ºC'),
	(276635, 121, '2014-04-01 00:07:37.000000', 'temperatura', 1064.0000, 'ºC'),
	(276636, 121, '2014-04-01 00:07:38.000000', 'temperatura', 747.0000, 'ºC'),
	(276637, 121, '2014-04-01 00:07:39.000000', 'temperatura', 544.0000, 'ºC'),
	(276638, 121, '2014-04-01 00:07:40.000000', 'temperatura', 477.0000, 'ºC'),
	(276639, 121, '2014-04-01 00:07:41.000000', 'temperatura', 757.0000, 'ºC'),
	(276640, 121, '2014-04-01 00:07:42.000000', 'temperatura', 1151.0000, 'ºC'),
	(276641, 121, '2014-04-01 00:07:43.000000', 'temperatura', 1085.0000, 'ºC'),
	(276642, 121, '2014-04-01 00:07:44.000000', 'temperatura', 772.0000, 'ºC'),
	(276643, 121, '2014-04-01 00:07:45.000000', 'temperatura', 608.0000, 'ºC'),
	(276644, 121, '2014-04-01 00:07:46.000000', 'temperatura', 722.0000, 'ºC'),
	(276645, 121, '2014-04-01 00:07:47.000000', 'temperatura', 587.0000, 'ºC'),
	(276646, 121, '2014-04-01 00:07:48.000000', 'temperatura', 770.0000, 'ºC'),
	(276647, 121, '2014-04-01 00:07:49.000000', 'temperatura', 888.0000, 'ºC'),
	(276648, 121, '2014-04-01 00:07:50.000000', 'temperatura', 932.0000, 'ºC'),
	(276649, 121, '2014-04-01 00:07:51.000000', 'temperatura', 795.0000, 'ºC'),
	(276650, 121, '2014-04-01 00:07:52.000000', 'temperatura', 1181.0000, 'ºC'),
	(276651, 121, '2014-04-01 00:07:53.000000', 'temperatura', 1121.0000, 'ºC'),
	(276652, 121, '2014-04-01 00:07:54.000000', 'temperatura', 860.0000, 'ºC'),
	(276653, 121, '2014-04-01 00:07:55.000000', 'temperatura', 938.0000, 'ºC'),
	(276654, 121, '2014-04-01 00:07:56.000000', 'temperatura', 912.0000, 'ºC'),
	(276655, 121, '2014-04-01 00:07:57.000000', 'temperatura', 546.0000, 'ºC'),
	(276656, 121, '2014-04-01 00:07:58.000000', 'temperatura', 1194.0000, 'ºC'),
	(276657, 121, '2014-04-01 00:07:59.000000', 'temperatura', 734.0000, 'ºC'),
	(276658, 121, '2014-04-01 00:08:00.000000', 'temperatura', 89.0000, 'ºC'),
	(276659, 121, '2014-04-01 00:08:01.000000', 'temperatura', 643.0000, 'ºC'),
	(276660, 121, '2014-04-01 00:08:02.000000', 'temperatura', 547.0000, 'ºC'),
	(276661, 121, '2014-04-01 00:08:03.000000', 'temperatura', 807.0000, 'ºC'),
	(276662, 121, '2014-04-01 00:08:04.000000', 'temperatura', 1193.0000, 'ºC'),
	(276663, 121, '2014-04-01 00:08:05.000000', 'temperatura', 1147.0000, 'ºC'),
	(276664, 121, '2014-04-01 00:08:06.000000', 'temperatura', 957.0000, 'ºC'),
	(276665, 121, '2014-04-01 00:08:07.000000', 'temperatura', 142.0000, 'ºC'),
	(276666, 121, '2014-04-01 00:08:08.000000', 'temperatura', 241.0000, 'ºC'),
	(276667, 121, '2014-04-01 00:08:09.000000', 'temperatura', 779.0000, 'ºC'),
	(276668, 121, '2014-04-01 00:08:10.000000', 'temperatura', 773.0000, 'ºC'),
	(276669, 121, '2014-04-01 00:08:11.000000', 'temperatura', 329.0000, 'ºC'),
	(276670, 121, '2014-04-01 00:08:12.000000', 'temperatura', 528.0000, 'ºC'),
	(276671, 121, '2014-04-01 00:08:13.000000', 'temperatura', 452.0000, 'ºC'),
	(276672, 121, '2014-04-01 00:08:14.000000', 'temperatura', 678.0000, 'ºC'),
	(276673, 121, '2014-04-01 00:08:15.000000', 'temperatura', 832.0000, 'ºC'),
	(276674, 121, '2014-04-01 00:08:16.000000', 'temperatura', 926.0000, 'ºC'),
	(276675, 121, '2014-04-01 00:08:17.000000', 'temperatura', 937.0000, 'ºC'),
	(276676, 121, '2014-04-01 00:08:18.000000', 'temperatura', 708.0000, 'ºC'),
	(276677, 121, '2014-04-01 00:08:19.000000', 'temperatura', 729.0000, 'ºC'),
	(276678, 121, '2014-04-01 00:08:20.000000', 'temperatura', 322.0000, 'ºC'),
	(276679, 121, '2014-04-01 00:08:21.000000', 'temperatura', 625.0000, 'ºC'),
	(276680, 121, '2014-04-01 00:08:22.000000', 'temperatura', 956.0000, 'ºC'),
	(276681, 121, '2014-04-01 00:08:23.000000', 'temperatura', 506.0000, 'ºC'),
	(276682, 121, '2014-04-01 00:08:24.000000', 'temperatura', 865.0000, 'ºC'),
	(276683, 121, '2014-04-01 00:08:25.000000', 'temperatura', 406.0000, 'ºC'),
	(276684, 121, '2014-04-01 00:08:26.000000', 'temperatura', 637.0000, 'ºC'),
	(276685, 121, '2014-04-01 00:08:27.000000', 'temperatura', 766.0000, 'ºC'),
	(276686, 121, '2014-04-01 00:08:28.000000', 'temperatura', 722.0000, 'ºC'),
	(276687, 121, '2014-04-01 00:08:29.000000', 'temperatura', 109.0000, 'ºC'),
	(276688, 121, '2014-04-01 00:08:30.000000', 'temperatura', 781.0000, 'ºC'),
	(276689, 121, '2014-04-01 00:08:31.000000', 'temperatura', 1178.0000, 'ºC'),
	(276690, 121, '2014-04-01 00:08:32.000000', 'temperatura', 1146.0000, 'ºC'),
	(276691, 121, '2014-04-01 00:08:33.000000', 'temperatura', 999.0000, 'ºC'),
	(276692, 121, '2014-04-01 00:08:34.000000', 'temperatura', 357.0000, 'ºC'),
	(276693, 121, '2014-04-01 00:08:35.000000', 'temperatura', 1190.0000, 'ºC'),
	(276694, 121, '2014-04-01 00:08:36.000000', 'temperatura', 76.0000, 'ºC'),
	(276695, 121, '2014-04-01 00:08:37.000000', 'temperatura', 413.0000, 'ºC'),
	(276696, 121, '2014-04-01 00:08:38.000000', 'temperatura', 639.0000, 'ºC'),
	(276697, 121, '2014-04-01 00:08:39.000000', 'temperatura', 754.0000, 'ºC'),
	(276698, 121, '2014-04-01 00:08:40.000000', 'temperatura', 655.0000, 'ºC'),
	(276699, 121, '2014-04-01 00:08:41.000000', 'temperatura', 1015.0000, 'ºC'),
	(276700, 121, '2014-04-01 00:08:42.000000', 'temperatura', 707.0000, 'ºC'),
	(276701, 121, '2014-04-01 00:08:43.000000', 'temperatura', 493.0000, 'ºC'),
	(276702, 121, '2014-04-01 00:08:44.000000', 'temperatura', 345.0000, 'ºC'),
	(276703, 121, '2014-04-01 00:08:45.000000', 'temperatura', 247.0000, 'ºC'),
	(276704, 121, '2014-04-01 00:08:46.000000', 'temperatura', 198.0000, 'ºC'),
	(276705, 121, '2014-04-01 00:08:47.000000', 'temperatura', 250.0000, 'ºC'),
	(276706, 121, '2014-04-01 00:08:48.000000', 'temperatura', 656.0000, 'ºC'),
	(276707, 121, '2014-04-01 00:08:49.000000', 'temperatura', 129.0000, 'ºC'),
	(276708, 121, '2014-04-01 00:08:50.000000', 'temperatura', 1079.0000, 'ºC'),
	(276709, 121, '2014-04-01 00:08:51.000000', 'temperatura', 209.0000, 'ºC'),
	(276710, 121, '2014-04-01 00:08:52.000000', 'temperatura', 210.0000, 'ºC'),
	(276711, 121, '2014-04-01 00:08:53.000000', 'temperatura', 420.0000, 'ºC'),
	(276712, 121, '2014-04-01 00:08:54.000000', 'temperatura', 273.0000, 'ºC'),
	(276713, 121, '2014-04-01 00:08:55.000000', 'temperatura', 106.0000, 'ºC'),
	(276714, 121, '2014-04-01 00:08:56.000000', 'temperatura', 910.0000, 'ºC'),
	(276715, 121, '2014-04-01 00:08:57.000000', 'temperatura', 634.0000, 'ºC'),
	(276716, 121, '2014-04-01 00:08:58.000000', 'temperatura', 438.0000, 'ºC'),
	(276717, 121, '2014-04-01 00:08:59.000000', 'temperatura', 291.0000, 'ºC'),
	(276718, 121, '2014-04-01 00:09:00.000000', 'temperatura', 139.0000, 'ºC'),
	(276719, 121, '2014-04-01 00:09:01.000000', 'temperatura', 1024.0000, 'ºC'),
	(276720, 121, '2014-04-01 00:09:02.000000', 'temperatura', 1103.0000, 'ºC'),
	(276721, 121, '2014-04-01 00:09:03.000000', 'temperatura', 45.0000, 'ºC'),
	(276722, 121, '2014-04-01 00:09:04.000000', 'temperatura', 515.0000, 'ºC'),
	(276723, 121, '2014-04-01 00:09:05.000000', 'temperatura', 43.0000, 'ºC'),
	(276724, 121, '2014-04-01 00:09:06.000000', 'temperatura', 1069.0000, 'ºC'),
	(276725, 121, '2014-04-01 00:09:07.000000', 'temperatura', 416.0000, 'ºC'),
	(276726, 121, '2014-04-01 00:09:08.000000', 'temperatura', 75.0000, 'ºC'),
	(276727, 121, '2014-04-01 00:09:09.000000', 'temperatura', 327.0000, 'ºC'),
	(276728, 121, '2014-04-01 00:09:10.000000', 'temperatura', 211.0000, 'ºC'),
	(276729, 121, '2014-04-01 00:09:11.000000', 'temperatura', 74.0000, 'ºC'),
	(276730, 121, '2014-04-01 00:09:12.000000', 'temperatura', 938.0000, 'ºC'),
	(276731, 121, '2014-04-01 00:09:13.000000', 'temperatura', 867.0000, 'ºC'),
	(276732, 121, '2014-04-01 00:09:14.000000', 'temperatura', 323.0000, 'ºC'),
	(276733, 121, '2014-04-01 00:09:15.000000', 'temperatura', 213.0000, 'ºC'),
	(276734, 121, '2014-04-01 00:09:16.000000', 'temperatura', 95.0000, 'ºC'),
	(276735, 121, '2014-04-01 00:09:17.000000', 'temperatura', 1039.0000, 'ºC'),
	(276736, 121, '2014-04-01 00:09:18.000000', 'temperatura', 110.0000, 'ºC'),
	(276737, 121, '2014-04-01 00:09:19.000000', 'temperatura', 1031.0000, 'ºC'),
	(276738, 121, '2014-04-01 00:09:20.000000', 'temperatura', 28.0000, 'ºC'),
	(276739, 121, '2014-04-01 00:09:21.000000', 'temperatura', 648.0000, 'ºC'),
	(276740, 121, '2014-04-01 00:09:22.000000', 'temperatura', 757.0000, 'ºC'),
	(276741, 121, '2014-04-01 00:09:23.000000', 'temperatura', 640.0000, 'ºC'),
	(276742, 121, '2014-04-01 00:09:24.000000', 'temperatura', 931.0000, 'ºC'),
	(276743, 121, '2014-04-01 00:09:25.000000', 'temperatura', 334.0000, 'ºC'),
	(276744, 121, '2014-04-01 00:09:26.000000', 'temperatura', 79.0000, 'ºC'),
	(276745, 121, '2014-04-01 00:09:27.000000', 'temperatura', 594.0000, 'ºC'),
	(276746, 121, '2014-04-01 00:09:28.000000', 'temperatura', 332.0000, 'ºC'),
	(276747, 121, '2014-04-01 00:09:29.000000', 'temperatura', 1077.0000, 'ºC'),
	(276748, 121, '2014-04-01 00:09:30.000000', 'temperatura', 791.0000, 'ºC'),
	(276749, 121, '2014-04-01 00:09:31.000000', 'temperatura', 722.0000, 'ºC'),
	(276750, 121, '2014-04-01 00:09:32.000000', 'temperatura', 41.0000, 'ºC'),
	(276751, 121, '2014-04-01 00:09:33.000000', 'temperatura', 439.0000, 'ºC'),
	(276752, 121, '2014-04-01 00:09:34.000000', 'temperatura', 872.0000, 'ºC'),
	(276753, 121, '2014-04-01 00:09:35.000000', 'temperatura', 646.0000, 'ºC'),
	(276754, 121, '2014-04-01 00:09:36.000000', 'temperatura', 611.0000, 'ºC'),
	(276755, 121, '2014-04-01 00:09:37.000000', 'temperatura', 1117.0000, 'ºC'),
	(276756, 121, '2014-04-01 00:09:38.000000', 'temperatura', 154.0000, 'ºC'),
	(276757, 121, '2014-04-01 00:09:39.000000', 'temperatura', 1021.0000, 'ºC'),
	(276758, 121, '2014-04-01 00:09:40.000000', 'temperatura', 1044.0000, 'ºC'),
	(276759, 121, '2014-04-01 00:09:41.000000', 'temperatura', 957.0000, 'ºC'),
	(276760, 121, '2014-04-01 00:09:42.000000', 'temperatura', 453.0000, 'ºC'),
	(276761, 121, '2014-04-01 00:09:43.000000', 'temperatura', 595.0000, 'ºC'),
	(276762, 121, '2014-04-01 00:09:44.000000', 'temperatura', 418.0000, 'ºC'),
	(276763, 121, '2014-04-01 00:09:45.000000', 'temperatura', 305.0000, 'ºC'),
	(276764, 121, '2014-04-01 00:09:46.000000', 'temperatura', 270.0000, 'ºC'),
	(276765, 121, '2014-04-01 00:09:47.000000', 'temperatura', 435.0000, 'ºC'),
	(276766, 121, '2014-04-01 00:09:48.000000', 'temperatura', 167.0000, 'ºC'),
	(276767, 121, '2014-04-01 00:09:49.000000', 'temperatura', 731.0000, 'ºC'),
	(276768, 121, '2014-04-01 00:09:50.000000', 'temperatura', 753.0000, 'ºC'),
	(276769, 121, '2014-04-01 00:09:51.000000', 'temperatura', 374.0000, 'ºC'),
	(276770, 121, '2014-04-01 00:09:52.000000', 'temperatura', 811.0000, 'ºC'),
	(276771, 121, '2014-04-01 00:09:53.000000', 'temperatura', 533.0000, 'ºC'),
	(276772, 121, '2014-04-01 00:09:54.000000', 'temperatura', 233.0000, 'ºC'),
	(276773, 121, '2014-04-01 00:09:55.000000', 'temperatura', 766.0000, 'ºC'),
	(276774, 121, '2014-04-01 00:09:56.000000', 'temperatura', 732.0000, 'ºC'),
	(276775, 121, '2014-04-01 00:09:57.000000', 'temperatura', 162.0000, 'ºC'),
	(276776, 121, '2014-04-01 00:09:58.000000', 'temperatura', 1014.0000, 'ºC'),
	(276777, 121, '2014-04-01 00:09:59.000000', 'temperatura', 986.0000, 'ºC'),
	(276778, 121, '2014-04-01 00:10:00.000000', 'temperatura', 687.0000, 'ºC'),
	(276779, 121, '2014-04-01 00:10:01.000000', 'temperatura', 478.0000, 'ºC'),
	(276780, 121, '2014-04-01 00:10:02.000000', 'temperatura', 328.0000, 'ºC'),
	(276781, 121, '2014-04-01 00:10:03.000000', 'temperatura', 210.0000, 'ºC'),
	(276782, 121, '2014-04-01 00:10:04.000000', 'temperatura', 64.0000, 'ºC'),
	(276783, 121, '2014-04-01 00:10:05.000000', 'temperatura', 889.0000, 'ºC'),
	(276784, 121, '2014-04-01 00:10:06.000000', 'temperatura', 656.0000, 'ºC'),
	(276785, 121, '2014-04-01 00:10:07.000000', 'temperatura', 615.0000, 'ºC'),
	(276786, 121, '2014-04-01 00:10:08.000000', 'temperatura', 1105.0000, 'ºC'),
	(276787, 121, '2014-04-01 00:10:09.000000', 'temperatura', 81.0000, 'ºC'),
	(276788, 121, '2014-04-01 00:10:10.000000', 'temperatura', 691.0000, 'ºC'),
	(276789, 121, '2014-04-01 00:10:11.000000', 'temperatura', 810.0000, 'ºC'),
	(276790, 121, '2014-04-01 00:10:12.000000', 'temperatura', 779.0000, 'ºC'),
	(276791, 121, '2014-04-01 00:10:13.000000', 'temperatura', 268.0000, 'ºC'),
	(276792, 121, '2014-04-01 00:10:14.000000', 'temperatura', 200.0000, 'ºC'),
	(276793, 121, '2014-04-01 00:10:15.000000', 'temperatura', 197.0000, 'ºC'),
	(276794, 121, '2014-04-01 00:10:16.000000', 'temperatura', 384.0000, 'ºC'),
	(276795, 121, '2014-04-01 00:10:17.000000', 'temperatura', 131.0000, 'ºC'),
	(276796, 121, '2014-04-01 00:10:18.000000', 'temperatura', 704.0000, 'ºC'),
	(276797, 121, '2014-04-01 00:10:19.000000', 'temperatura', 727.0000, 'ºC'),
	(276798, 121, '2014-04-01 00:10:20.000000', 'temperatura', 324.0000, 'ºC'),
	(276799, 121, '2014-04-01 00:10:21.000000', 'temperatura', 638.0000, 'ºC'),
	(276800, 121, '2014-04-01 00:10:22.000000', 'temperatura', 1021.0000, 'ºC'),
	(276801, 121, '2014-04-01 00:10:23.000000', 'temperatura', 792.0000, 'ºC'),
	(276802, 121, '2014-04-01 00:10:24.000000', 'temperatura', 895.0000, 'ºC'),
	(276803, 121, '2014-04-01 00:10:25.000000', 'temperatura', 902.0000, 'ºC'),
	(276804, 121, '2014-04-01 00:10:26.000000', 'temperatura', 625.0000, 'ºC'),
	(276805, 121, '2014-04-01 00:10:27.000000', 'temperatura', 418.0000, 'ºC'),
	(276806, 121, '2014-04-01 00:10:28.000000', 'temperatura', 218.0000, 'ºC'),
	(276807, 121, '2014-04-01 00:10:29.000000', 'temperatura', 1035.0000, 'ºC'),
	(276808, 121, '2014-04-01 00:10:30.000000', 'temperatura', 921.0000, 'ºC'),
	(276809, 121, '2014-04-01 00:10:31.000000', 'temperatura', 301.0000, 'ºC'),
	(276810, 121, '2014-04-01 00:10:32.000000', 'temperatura', 1143.0000, 'ºC'),
	(276811, 121, '2014-04-01 00:10:33.000000', 'temperatura', 12.0000, 'ºC'),
	(276812, 121, '2014-04-01 00:10:34.000000', 'temperatura', 232.0000, 'ºC'),
	(276813, 121, '2014-04-01 00:10:35.000000', 'temperatura', 1123.0000, 'ºC'),
	(276814, 121, '2014-04-01 00:10:36.000000', 'temperatura', 119.0000, 'ºC'),
	(276815, 121, '2014-04-01 00:10:37.000000', 'temperatura', 829.0000, 'ºC'),
	(276816, 121, '2014-04-01 00:10:38.000000', 'temperatura', 186.0000, 'ºC'),
	(276817, 121, '2014-04-01 00:10:39.000000', 'temperatura', 844.0000, 'ºC'),
	(276818, 121, '2014-04-01 00:10:40.000000', 'temperatura', 61.0000, 'ºC'),
	(276819, 121, '2014-04-01 00:10:41.000000', 'temperatura', 174.0000, 'ºC'),
	(276820, 121, '2014-04-01 00:10:42.000000', 'temperatura', 689.0000, 'ºC'),
	(276821, 121, '2014-04-01 00:10:43.000000', 'temperatura', 522.0000, 'ºC'),
	(276822, 121, '2014-04-01 00:10:44.000000', 'temperatura', 545.0000, 'ºC'),
	(276823, 121, '2014-04-01 00:10:45.000000', 'temperatura', 1160.0000, 'ºC'),
	(276824, 121, '2014-04-01 00:10:46.000000', 'temperatura', 566.0000, 'ºC'),
	(276825, 121, '2014-04-01 00:10:47.000000', 'temperatura', 548.0000, 'ºC'),
	(276826, 121, '2014-04-01 00:10:48.000000', 'temperatura', 1046.0000, 'ºC'),
	(276827, 121, '2014-04-01 00:10:49.000000', 'temperatura', 1183.0000, 'ºC'),
	(276828, 121, '2014-04-01 00:10:50.000000', 'temperatura', 380.0000, 'ºC'),
	(276829, 121, '2014-04-01 00:10:51.000000', 'temperatura', 750.0000, 'ºC'),
	(276830, 121, '2014-04-01 00:10:52.000000', 'temperatura', 211.0000, 'ºC'),
	(276831, 121, '2014-04-01 00:10:53.000000', 'temperatura', 5.0000, 'ºC'),
	(276832, 121, '2014-04-01 00:10:54.000000', 'temperatura', 593.0000, 'ºC'),
	(276833, 121, '2014-04-01 00:10:55.000000', 'temperatura', 549.0000, 'ºC'),
	(276834, 121, '2014-04-01 00:10:56.000000', 'temperatura', 968.0000, 'ºC'),
	(276835, 121, '2014-04-01 00:10:57.000000', 'temperatura', 794.0000, 'ºC'),
	(276836, 121, '2014-04-01 00:10:58.000000', 'temperatura', 1068.0000, 'ºC'),
	(276837, 121, '2014-04-01 00:10:59.000000', 'temperatura', 556.0000, 'ºC'),
	(276838, 121, '2014-04-01 00:11:00.000000', 'temperatura', 778.0000, 'ºC'),
	(276839, 121, '2014-04-01 00:11:01.000000', 'temperatura', 1023.0000, 'ºC'),
	(276840, 121, '2014-04-01 00:11:02.000000', 'temperatura', 380.0000, 'ºC'),
	(276841, 121, '2014-04-01 00:11:03.000000', 'temperatura', 30.0000, 'ºC'),
	(276842, 121, '2014-04-01 00:11:04.000000', 'temperatura', 212.0000, 'ºC'),
	(276843, 121, '2014-04-01 00:11:05.000000', 'temperatura', 971.0000, 'ºC'),
	(276844, 121, '2014-04-01 00:11:06.000000', 'temperatura', 619.0000, 'ºC'),
	(276845, 121, '2014-04-01 00:11:07.000000', 'temperatura', 183.0000, 'ºC'),
	(276846, 121, '2014-04-01 00:11:08.000000', 'temperatura', 258.0000, 'ºC'),
	(276847, 121, '2014-04-01 00:11:09.000000', 'temperatura', 744.0000, 'ºC'),
	(276848, 121, '2014-04-01 00:11:10.000000', 'temperatura', 544.0000, 'ºC'),
	(276849, 121, '2014-04-01 00:11:11.000000', 'temperatura', 489.0000, 'ºC'),
	(276850, 121, '2014-04-01 00:11:12.000000', 'temperatura', 813.0000, 'ºC'),
	(276851, 121, '2014-04-01 00:11:13.000000', 'temperatura', 197.0000, 'ºC'),
	(276852, 121, '2014-04-01 00:11:14.000000', 'temperatura', 948.0000, 'ºC'),
	(276853, 121, '2014-04-01 00:11:15.000000', 'temperatura', 547.0000, 'ºC'),
	(276854, 121, '2014-04-01 00:11:16.000000', 'temperatura', 1095.0000, 'ºC'),
	(276855, 121, '2014-04-01 00:11:17.000000', 'temperatura', 232.0000, 'ºC'),
	(276856, 121, '2014-04-01 00:11:18.000000', 'temperatura', 276.0000, 'ºC'),
	(276857, 121, '2014-04-01 00:11:19.000000', 'temperatura', 683.0000, 'ºC'),
	(276858, 121, '2014-04-01 00:11:20.000000', 'temperatura', 189.0000, 'ºC'),
	(276859, 121, '2014-04-01 00:11:21.000000', 'temperatura', 97.0000, 'ºC'),
	(276860, 121, '2014-04-01 00:11:22.000000', 'temperatura', 1118.0000, 'ºC'),
	(276861, 121, '2014-04-01 00:11:23.000000', 'temperatura', 501.0000, 'ºC'),
	(276862, 121, '2014-04-01 00:11:24.000000', 'temperatura', 352.0000, 'ºC'),
	(276863, 121, '2014-04-01 00:11:25.000000', 'temperatura', 257.0000, 'ºC'),
	(276864, 121, '2014-04-01 00:11:26.000000', 'temperatura', 229.0000, 'ºC'),
	(276865, 121, '2014-04-01 00:11:27.000000', 'temperatura', 374.0000, 'ºC'),
	(276866, 121, '2014-04-01 00:11:28.000000', 'temperatura', 1182.0000, 'ºC'),
	(276867, 121, '2014-04-01 00:11:29.000000', 'temperatura', 1190.0000, 'ºC'),
	(276868, 121, '2014-04-01 00:11:30.000000', 'temperatura', 5.0000, 'ºC'),
	(276869, 121, '2014-04-01 00:11:31.000000', 'temperatura', 55.0000, 'ºC'),
	(276870, 121, '2014-04-01 00:11:32.000000', 'temperatura', 262.0000, 'ºC'),
	(276871, 121, '2014-04-01 00:11:33.000000', 'temperatura', 1145.0000, 'ºC'),
	(276872, 121, '2014-04-01 00:11:34.000000', 'temperatura', 137.0000, 'ºC'),
	(276873, 121, '2014-04-01 00:11:35.000000', 'temperatura', 852.0000, 'ºC'),
	(276874, 121, '2014-04-01 00:11:36.000000', 'temperatura', 251.0000, 'ºC'),
	(276875, 121, '2014-04-01 00:11:37.000000', 'temperatura', 1100.0000, 'ºC'),
	(276876, 121, '2014-04-01 00:11:38.000000', 'temperatura', 1145.0000, 'ºC'),
	(276877, 121, '2014-04-01 00:11:39.000000', 'temperatura', 26.0000, 'ºC'),
	(276878, 121, '2014-04-01 00:11:40.000000', 'temperatura', 298.0000, 'ºC'),
	(276879, 121, '2014-04-01 00:11:41.000000', 'temperatura', 211.0000, 'ºC'),
	(276880, 121, '2014-04-01 00:11:42.000000', 'temperatura', 161.0000, 'ºC'),
	(276881, 121, '2014-04-01 00:11:43.000000', 'temperatura', 174.0000, 'ºC'),
	(276882, 121, '2014-04-01 00:11:44.000000', 'temperatura', 388.0000, 'ºC'),
	(276883, 121, '2014-04-01 00:11:45.000000', 'temperatura', 218.0000, 'ºC'),
	(276884, 121, '2014-04-01 00:11:46.000000', 'temperatura', 1128.0000, 'ºC'),
	(276885, 121, '2014-04-01 00:11:47.000000', 'temperatura', 183.0000, 'ºC'),
	(276886, 121, '2014-04-01 00:11:48.000000', 'temperatura', 1135.0000, 'ºC'),
	(276887, 121, '2014-04-01 00:11:49.000000', 'temperatura', 323.0000, 'ºC'),
	(276888, 121, '2014-04-01 00:11:50.000000', 'temperatura', 613.0000, 'ºC'),
	(276889, 121, '2014-04-01 00:11:51.000000', 'temperatura', 895.0000, 'ºC'),
	(276890, 121, '2014-04-01 00:11:52.000000', 'temperatura', 235.0000, 'ºC'),
	(276891, 121, '2014-04-01 00:11:53.000000', 'temperatura', 893.0000, 'ºC'),
	(276892, 121, '2014-04-01 00:11:54.000000', 'temperatura', 160.0000, 'ºC'),
	(276893, 121, '2014-04-01 00:11:55.000000', 'temperatura', 523.0000, 'ºC'),
	(276894, 121, '2014-04-01 00:11:56.000000', 'temperatura', 935.0000, 'ºC'),
	(276895, 121, '2014-04-01 00:11:57.000000', 'temperatura', 707.0000, 'ºC'),
	(276896, 121, '2014-04-01 00:11:58.000000', 'temperatura', 731.0000, 'ºC'),
	(276897, 121, '2014-04-01 00:11:59.000000', 'temperatura', 333.0000, 'ºC'),
	(276898, 121, '2014-04-01 00:12:00.000000', 'temperatura', 672.0000, 'ºC'),
	(276899, 121, '2014-04-01 00:12:01.000000', 'temperatura', 1164.0000, 'ºC'),
	(276900, 121, '2014-04-01 00:12:02.000000', 'temperatura', 203.0000, 'ºC'),
	(276901, 121, '2014-04-01 00:12:03.000000', 'temperatura', 1123.0000, 'ºC'),
	(276902, 121, '2014-04-01 00:12:04.000000', 'temperatura', 206.0000, 'ºC'),
	(276903, 121, '2014-04-01 00:12:05.000000', 'temperatura', 61.0000, 'ºC'),
	(276904, 121, '2014-04-01 00:12:06.000000', 'temperatura', 890.0000, 'ºC'),
	(276905, 121, '2014-04-01 00:12:07.000000', 'temperatura', 665.0000, 'ºC'),
	(276906, 121, '2014-04-01 00:12:08.000000', 'temperatura', 658.0000, 'ºC'),
	(276907, 121, '2014-04-01 00:12:09.000000', 'temperatura', 95.0000, 'ºC'),
	(276908, 121, '2014-04-01 00:12:10.000000', 'temperatura', 900.0000, 'ºC'),
	(276909, 121, '2014-04-01 00:12:11.000000', 'temperatura', 617.0000, 'ºC'),
	(276910, 121, '2014-04-01 00:12:12.000000', 'temperatura', 384.0000, 'ºC'),
	(276911, 121, '2014-04-01 00:12:13.000000', 'temperatura', 70.0000, 'ºC'),
	(276912, 121, '2014-04-01 00:12:14.000000', 'temperatura', 397.0000, 'ºC'),
	(276913, 121, '2014-04-01 00:12:15.000000', 'temperatura', 575.0000, 'ºC'),
	(276914, 121, '2014-04-01 00:12:16.000000', 'temperatura', 486.0000, 'ºC'),
	(276915, 121, '2014-04-01 00:12:17.000000', 'temperatura', 706.0000, 'ºC'),
	(276916, 121, '2014-04-01 00:12:18.000000', 'temperatura', 872.0000, 'ºC'),
	(276917, 121, '2014-04-01 00:12:19.000000', 'temperatura', 1044.0000, 'ºC'),
	(276918, 121, '2014-04-01 00:12:20.000000', 'temperatura', 204.0000, 'ºC'),
	(276919, 121, '2014-04-01 00:12:21.000000', 'temperatura', 286.0000, 'ºC'),
	(276920, 121, '2014-04-01 00:12:22.000000', 'temperatura', 822.0000, 'ºC'),
	(276921, 121, '2014-04-01 00:12:23.000000', 'temperatura', 850.0000, 'ºC'),
	(276922, 121, '2014-04-01 00:12:24.000000', 'temperatura', 587.0000, 'ºC'),
	(276923, 121, '2014-04-01 00:12:25.000000', 'temperatura', 385.0000, 'ºC'),
	(276924, 121, '2014-04-01 00:12:26.000000', 'temperatura', 163.0000, 'ºC'),
	(276925, 121, '2014-04-01 00:12:27.000000', 'temperatura', 862.0000, 'ºC'),
	(276926, 121, '2014-04-01 00:12:28.000000', 'temperatura', 220.0000, 'ºC'),
	(276927, 121, '2014-04-01 00:12:29.000000', 'temperatura', 916.0000, 'ºC'),
	(276928, 121, '2014-04-01 00:12:30.000000', 'temperatura', 318.0000, 'ºC'),
	(276929, 121, '2014-04-01 00:12:31.000000', 'temperatura', 45.0000, 'ºC'),
	(276930, 121, '2014-04-01 00:12:32.000000', 'temperatura', 469.0000, 'ºC'),
	(276931, 121, '2014-04-01 00:12:33.000000', 'temperatura', 1010.0000, 'ºC'),
	(276932, 121, '2014-04-01 00:12:34.000000', 'temperatura', 44.0000, 'ºC'),
	(276933, 121, '2014-04-01 00:12:35.000000', 'temperatura', 793.0000, 'ºC'),
	(276934, 121, '2014-04-01 00:12:36.000000', 'temperatura', 231.0000, 'ºC'),
	(276935, 121, '2014-04-01 00:12:37.000000', 'temperatura', 1176.0000, 'ºC'),
	(276936, 121, '2014-04-01 00:12:38.000000', 'temperatura', 386.0000, 'ºC'),
	(276937, 121, '2014-04-01 00:12:39.000000', 'temperatura', 806.0000, 'ºC'),
	(276938, 121, '2014-04-01 00:12:40.000000', 'temperatura', 470.0000, 'ºC'),
	(276939, 121, '2014-04-01 00:12:41.000000', 'temperatura', 1133.0000, 'ºC'),
	(276940, 121, '2014-04-01 00:12:42.000000', 'temperatura', 654.0000, 'ºC'),
	(276941, 121, '2014-04-01 00:12:43.000000', 'temperatura', 1073.0000, 'ºC'),
	(276942, 121, '2014-04-01 00:12:44.000000', 'temperatura', 1001.0000, 'ºC'),
	(276943, 121, '2014-04-01 00:12:45.000000', 'temperatura', 589.0000, 'ºC'),
	(276944, 121, '2014-04-01 00:12:46.000000', 'temperatura', 1143.0000, 'ºC'),
	(276945, 121, '2014-04-01 00:12:47.000000', 'temperatura', 347.0000, 'ºC'),
	(276946, 121, '2014-04-01 00:12:48.000000', 'temperatura', 709.0000, 'ºC'),
	(276947, 121, '2014-04-01 00:12:49.000000', 'temperatura', 102.0000, 'ºC'),
	(276948, 121, '2014-04-01 00:12:50.000000', 'temperatura', 783.0000, 'ºC'),
	(276949, 121, '2014-04-01 00:12:51.000000', 'temperatura', 11.0000, 'ºC'),
	(276950, 121, '2014-04-01 00:12:52.000000', 'temperatura', 107.0000, 'ºC'),
	(276951, 121, '2014-04-01 00:12:53.000000', 'temperatura', 504.0000, 'ºC'),
	(276952, 121, '2014-04-01 00:12:54.000000', 'temperatura', 997.0000, 'ºC'),
	(276953, 121, '2014-04-01 00:12:55.000000', 'temperatura', 1072.0000, 'ºC'),
	(276954, 121, '2014-04-01 00:12:56.000000', 'temperatura', 1172.0000, 'ºC'),
	(276955, 121, '2014-04-01 00:12:57.000000', 'temperatura', 242.0000, 'ºC'),
	(276956, 121, '2014-04-01 00:12:58.000000', 'temperatura', 97.0000, 'ºC'),
	(276957, 121, '2014-04-01 00:12:59.000000', 'temperatura', 960.0000, 'ºC'),
	(276958, 121, '2014-04-01 00:13:00.000000', 'temperatura', 910.0000, 'ºC'),
	(276959, 121, '2014-04-01 00:13:01.000000', 'temperatura', 468.0000, 'ºC'),
	(276960, 121, '2014-04-01 00:13:02.000000', 'temperatura', 813.0000, 'ºC'),
	(276961, 121, '2014-04-01 00:13:03.000000', 'temperatura', 259.0000, 'ºC'),
	(276962, 121, '2014-04-01 00:13:04.000000', 'temperatura', 56.0000, 'ºC'),
	(276963, 121, '2014-04-01 00:13:05.000000', 'temperatura', 704.0000, 'ºC'),
	(276964, 121, '2014-04-01 00:13:06.000000', 'temperatura', 953.0000, 'ºC'),
	(276965, 121, '2014-04-01 00:13:07.000000', 'temperatura', 254.0000, 'ºC'),
	(276966, 121, '2014-04-01 00:13:08.000000', 'temperatura', 811.0000, 'ºC'),
	(276967, 121, '2014-04-01 00:13:09.000000', 'temperatura', 892.0000, 'ºC'),
	(276968, 121, '2014-04-01 00:13:10.000000', 'temperatura', 828.0000, 'ºC'),
	(276969, 121, '2014-04-01 00:13:11.000000', 'temperatura', 264.0000, 'ºC'),
	(276970, 121, '2014-04-01 00:13:12.000000', 'temperatura', 39.0000, 'ºC'),
	(276971, 121, '2014-04-01 00:13:13.000000', 'temperatura', 602.0000, 'ºC'),
	(276972, 121, '2014-04-01 00:13:14.000000', 'temperatura', 496.0000, 'ºC'),
	(276973, 121, '2014-04-01 00:13:15.000000', 'temperatura', 671.0000, 'ºC'),
	(276974, 121, '2014-04-01 00:13:16.000000', 'temperatura', 669.0000, 'ºC'),
	(276975, 121, '2014-04-01 00:13:17.000000', 'temperatura', 134.0000, 'ºC'),
	(276976, 121, '2014-04-01 00:13:18.000000', 'temperatura', 1064.0000, 'ºC'),
	(276977, 121, '2014-04-01 00:13:19.000000', 'temperatura', 117.0000, 'ºC'),
	(276978, 121, '2014-04-01 00:13:20.000000', 'temperatura', 992.0000, 'ºC'),
	(276979, 121, '2014-04-01 00:13:21.000000', 'temperatura', 1011.0000, 'ºC'),
	(276980, 121, '2014-04-01 00:13:22.000000', 'temperatura', 877.0000, 'ºC'),
	(276981, 121, '2014-04-01 00:13:23.000000', 'temperatura', 156.0000, 'ºC'),
	(276982, 121, '2014-04-01 00:13:24.000000', 'temperatura', 547.0000, 'ºC'),
	(276983, 121, '2014-04-01 00:13:25.000000', 'temperatura', 1070.0000, 'ºC'),
	(276984, 121, '2014-04-01 00:13:26.000000', 'temperatura', 109.0000, 'ºC'),
	(276985, 121, '2014-04-01 00:13:27.000000', 'temperatura', 936.0000, 'ºC'),
	(276986, 121, '2014-04-01 00:13:28.000000', 'temperatura', 754.0000, 'ºC'),
	(276987, 121, '2014-04-01 00:13:29.000000', 'temperatura', 963.0000, 'ºC'),
	(276988, 121, '2014-04-01 00:13:30.000000', 'temperatura', 154.0000, 'ºC'),
	(276989, 121, '2014-04-01 00:13:31.000000', 'temperatura', 280.0000, 'ºC'),
	(276990, 121, '2014-04-01 00:13:32.000000', 'temperatura', 940.0000, 'ºC'),
	(276991, 121, '2014-04-01 00:13:33.000000', 'temperatura', 259.0000, 'ºC'),
	(276992, 121, '2014-04-01 00:13:34.000000', 'temperatura', 874.0000, 'ºC'),
	(276993, 121, '2014-04-01 00:13:35.000000', 'temperatura', 1196.0000, 'ºC'),
	(276994, 121, '2014-04-01 00:13:36.000000', 'temperatura', 958.0000, 'ºC'),
	(276995, 121, '2014-04-01 00:13:37.000000', 'temperatura', 3.0000, 'ºC'),
	(276996, 121, '2014-04-01 00:13:38.000000', 'temperatura', 743.0000, 'ºC'),
	(276997, 121, '2014-04-01 00:13:39.000000', 'temperatura', 104.0000, 'ºC'),
	(276998, 121, '2014-04-01 00:13:40.000000', 'temperatura', 693.0000, 'ºC'),
	(276999, 121, '2014-04-01 00:13:41.000000', 'temperatura', 753.0000, 'ºC'),
	(277000, 121, '2014-04-01 00:13:42.000000', 'temperatura', 488.0000, 'ºC'),
	(277001, 121, '2014-04-01 00:13:43.000000', 'temperatura', 181.0000, 'ºC'),
	(277002, 121, '2014-04-01 00:13:44.000000', 'temperatura', 643.0000, 'ºC'),
	(277003, 121, '2014-04-01 00:13:45.000000', 'temperatura', 270.0000, 'ºC'),
	(277004, 121, '2014-04-01 00:13:46.000000', 'temperatura', 623.0000, 'ºC'),
	(277005, 121, '2014-04-01 00:13:47.000000', 'temperatura', 1107.0000, 'ºC'),
	(277006, 121, '2014-04-01 00:13:48.000000', 'temperatura', 63.0000, 'ºC'),
	(277007, 121, '2014-04-01 00:13:49.000000', 'temperatura', 596.0000, 'ºC'),
	(277008, 121, '2014-04-01 00:13:50.000000', 'temperatura', 393.0000, 'ºC'),
	(277009, 121, '2014-04-01 00:13:51.000000', 'temperatura', 174.0000, 'ºC'),
	(277010, 121, '2014-04-01 00:13:52.000000', 'temperatura', 895.0000, 'ºC'),
	(277011, 121, '2014-04-01 00:13:53.000000', 'temperatura', 352.0000, 'ºC'),
	(277012, 121, '2014-04-01 00:13:54.000000', 'temperatura', 276.0000, 'ºC'),
	(277013, 121, '2014-04-01 00:13:55.000000', 'temperatura', 324.0000, 'ºC'),
	(277014, 121, '2014-04-01 00:13:56.000000', 'temperatura', 792.0000, 'ºC'),
	(277015, 121, '2014-04-01 00:13:57.000000', 'temperatura', 588.0000, 'ºC'),
	(277016, 121, '2014-04-01 00:13:58.000000', 'temperatura', 563.0000, 'ºC'),
	(277017, 121, '2014-04-01 00:13:59.000000', 'temperatura', 1054.0000, 'ºC'),
	(277018, 121, '2014-04-01 00:14:00.000000', 'temperatura', 1182.0000, 'ºC'),
	(277019, 121, '2014-04-01 00:14:01.000000', 'temperatura', 347.0000, 'ºC'),
	(277020, 121, '2014-04-01 00:14:02.000000', 'temperatura', 591.0000, 'ºC'),
	(277021, 121, '2014-04-01 00:14:03.000000', 'temperatura', 716.0000, 'ºC'),
	(277022, 121, '2014-04-01 00:14:04.000000', 'temperatura', 605.0000, 'ºC'),
	(277023, 121, '2014-04-01 00:14:05.000000', 'temperatura', 877.0000, 'ºC'),
	(277024, 121, '2014-04-01 00:14:06.000000', 'temperatura', 169.0000, 'ºC'),
	(277025, 121, '2014-04-01 00:14:07.000000', 'temperatura', 617.0000, 'ºC'),
	(277026, 121, '2014-04-01 00:14:08.000000', 'temperatura', 179.0000, 'ºC'),
	(277027, 121, '2014-04-01 00:14:09.000000', 'temperatura', 242.0000, 'ºC'),
	(277028, 121, '2014-04-01 00:14:10.000000', 'temperatura', 674.0000, 'ºC'),
	(277029, 121, '2014-04-01 00:14:11.000000', 'temperatura', 243.0000, 'ºC'),
	(277030, 121, '2014-04-01 00:14:12.000000', 'temperatura', 396.0000, 'ºC'),
	(277031, 121, '2014-04-01 00:14:13.000000', 'temperatura', 49.0000, 'ºC'),
	(277032, 121, '2014-04-01 00:14:14.000000', 'temperatura', 257.0000, 'ºC'),
	(277033, 121, '2014-04-01 00:14:15.000000', 'temperatura', 1140.0000, 'ºC'),
	(277034, 121, '2014-04-01 00:14:16.000000', 'temperatura', 130.0000, 'ºC'),
	(277035, 121, '2014-04-01 00:14:17.000000', 'temperatura', 830.0000, 'ºC'),
	(277036, 121, '2014-04-01 00:14:18.000000', 'temperatura', 159.0000, 'ºC'),
	(277037, 121, '2014-04-01 00:14:19.000000', 'temperatura', 708.0000, 'ºC'),
	(277038, 121, '2014-04-01 00:14:20.000000', 'temperatura', 663.0000, 'ºC'),
	(277039, 121, '2014-04-01 00:14:21.000000', 'temperatura', 1190.0000, 'ºC'),
	(277040, 121, '2014-04-01 00:14:22.000000', 'temperatura', 362.0000, 'ºC'),
	(277041, 121, '2014-04-01 00:14:23.000000', 'temperatura', 641.0000, 'ºC'),
	(277042, 121, '2014-04-01 00:14:24.000000', 'temperatura', 918.0000, 'ºC'),
	(277043, 121, '2014-04-01 00:14:25.000000', 'temperatura', 267.0000, 'ºC'),
	(277044, 121, '2014-04-01 00:14:26.000000', 'temperatura', 983.0000, 'ºC'),
	(277045, 121, '2014-04-01 00:14:27.000000', 'temperatura', 513.0000, 'ºC'),
	(277046, 121, '2014-04-01 00:14:28.000000', 'temperatura', 816.0000, 'ºC'),
	(277047, 121, '2014-04-01 00:14:29.000000', 'temperatura', 141.0000, 'ºC'),
	(277048, 121, '2014-04-01 00:14:30.000000', 'temperatura', 658.0000, 'ºC'),
	(277049, 121, '2014-04-01 00:14:31.000000', 'temperatura', 466.0000, 'ºC'),
	(277050, 121, '2014-04-01 00:14:32.000000', 'temperatura', 357.0000, 'ºC'),
	(277051, 121, '2014-04-01 00:14:33.000000', 'temperatura', 386.0000, 'ºC'),
	(277052, 121, '2014-04-01 00:14:34.000000', 'temperatura', 862.0000, 'ºC'),
	(277053, 121, '2014-04-01 00:14:35.000000', 'temperatura', 752.0000, 'ºC'),
	(277054, 121, '2014-04-01 00:14:36.000000', 'temperatura', 1175.0000, 'ºC'),
	(277055, 121, '2014-04-01 00:14:37.000000', 'temperatura', 20.0000, 'ºC'),
	(277056, 121, '2014-04-01 00:14:38.000000', 'temperatura', 174.0000, 'ºC'),
	(277057, 121, '2014-04-01 00:14:39.000000', 'temperatura', 811.0000, 'ºC'),
	(277058, 121, '2014-04-01 00:14:40.000000', 'temperatura', 1131.0000, 'ºC'),
	(277059, 121, '2014-04-01 00:14:41.000000', 'temperatura', 826.0000, 'ºC'),
	(277060, 121, '2014-04-01 00:14:42.000000', 'temperatura', 738.0000, 'ºC'),
	(277061, 121, '2014-04-01 00:14:43.000000', 'temperatura', 9.0000, 'ºC'),
	(277062, 121, '2014-04-01 00:14:44.000000', 'temperatura', 235.0000, 'ºC'),
	(277063, 121, '2014-04-01 00:14:45.000000', 'temperatura', 1148.0000, 'ºC'),
	(277064, 121, '2014-04-01 00:14:46.000000', 'temperatura', 233.0000, 'ºC'),
	(277065, 121, '2014-04-01 00:14:47.000000', 'temperatura', 124.0000, 'ºC'),
	(277066, 121, '2014-04-01 00:14:48.000000', 'temperatura', 1119.0000, 'ºC'),
	(277067, 121, '2014-04-01 00:14:49.000000', 'temperatura', 423.0000, 'ºC'),
	(277068, 121, '2014-04-01 00:14:50.000000', 'temperatura', 1160.0000, 'ºC'),
	(277069, 121, '2014-04-01 00:14:51.000000', 'temperatura', 930.0000, 'ºC'),
	(277070, 121, '2014-04-01 00:14:52.000000', 'temperatura', 1173.0000, 'ºC'),
	(277071, 121, '2014-04-01 00:14:53.000000', 'temperatura', 676.0000, 'ºC'),
	(277072, 121, '2014-04-01 00:14:54.000000', 'temperatura', 1059.0000, 'ºC'),
	(277073, 121, '2014-04-01 00:14:55.000000', 'temperatura', 868.0000, 'ºC'),
	(277074, 121, '2014-04-01 00:14:56.000000', 'temperatura', 1162.0000, 'ºC'),
	(277075, 121, '2014-04-01 00:14:57.000000', 'temperatura', 810.0000, 'ºC'),
	(277076, 121, '2014-04-01 00:14:58.000000', 'temperatura', 562.0000, 'ºC'),
	(277077, 121, '2014-04-01 00:14:59.000000', 'temperatura', 379.0000, 'ºC'),
	(277078, 121, '2014-04-01 00:15:00.000000', 'temperatura', 213.0000, 'ºC'),
	(277079, 121, '2014-04-01 00:15:01.000000', 'temperatura', 1126.0000, 'ºC'),
	(277080, 121, '2014-04-01 00:15:02.000000', 'temperatura', 191.0000, 'ºC'),
	(277081, 121, '2014-04-01 00:15:03.000000', 'temperatura', 1176.0000, 'ºC'),
	(277082, 121, '2014-04-01 00:15:04.000000', 'temperatura', 510.0000, 'ºC'),
	(277083, 121, '2014-04-01 00:15:05.000000', 'temperatura', 223.0000, 'ºC'),
	(277084, 121, '2014-04-01 00:15:06.000000', 'temperatura', 786.0000, 'ºC'),
	(277085, 121, '2014-04-01 00:15:07.000000', 'temperatura', 859.0000, 'ºC'),
	(277086, 121, '2014-04-01 00:15:08.000000', 'temperatura', 737.0000, 'ºC'),
	(277087, 121, '2014-04-01 00:15:09.000000', 'temperatura', 1110.0000, 'ºC'),
	(277088, 121, '2014-04-01 00:15:10.000000', 'temperatura', 940.0000, 'ºC'),
	(277089, 121, '2014-04-01 00:15:11.000000', 'temperatura', 170.0000, 'ºC'),
	(277090, 121, '2014-04-01 00:15:12.000000', 'temperatura', 432.0000, 'ºC'),
	(277091, 121, '2014-04-01 00:15:13.000000', 'temperatura', 448.0000, 'ºC'),
	(277092, 121, '2014-04-01 00:15:14.000000', 'temperatura', 945.0000, 'ºC'),
	(277093, 121, '2014-04-01 00:15:15.000000', 'temperatura', 982.0000, 'ºC'),
	(277094, 121, '2014-04-01 00:15:16.000000', 'temperatura', 874.0000, 'ºC'),
	(277095, 121, '2014-04-01 00:15:17.000000', 'temperatura', 225.0000, 'ºC'),
	(277096, 121, '2014-04-01 00:15:18.000000', 'temperatura', 904.0000, 'ºC'),
	(277097, 121, '2014-04-01 00:15:19.000000', 'temperatura', 245.0000, 'ºC'),
	(277098, 121, '2014-04-01 00:15:20.000000', 'temperatura', 915.0000, 'ºC'),
	(277099, 121, '2014-04-01 00:15:21.000000', 'temperatura', 240.0000, 'ºC'),
	(277100, 121, '2014-04-01 00:15:22.000000', 'temperatura', 857.0000, 'ºC'),
	(277101, 121, '2014-04-01 00:15:23.000000', 'temperatura', 1165.0000, 'ºC'),
	(277102, 121, '2014-04-01 00:15:24.000000', 'temperatura', 855.0000, 'ºC'),
	(277103, 121, '2014-04-01 00:15:25.000000', 'temperatura', 780.0000, 'ºC'),
	(277104, 121, '2014-04-01 00:15:26.000000', 'temperatura', 134.0000, 'ºC'),
	(277105, 121, '2014-04-01 00:15:27.000000', 'temperatura', 733.0000, 'ºC'),
	(277106, 121, '2014-04-01 00:15:28.000000', 'temperatura', 863.0000, 'ºC'),
	(277107, 121, '2014-04-01 00:15:29.000000', 'temperatura', 915.0000, 'ºC'),
	(277108, 121, '2014-04-01 00:15:30.000000', 'temperatura', 789.0000, 'ºC'),
	(277109, 121, '2014-04-01 00:15:31.000000', 'temperatura', 1.0000, 'ºC'),
	(277110, 121, '2014-04-01 00:15:32.000000', 'temperatura', 35.0000, 'ºC'),
	(277111, 121, '2014-04-01 00:15:33.000000', 'temperatura', 176.0000, 'ºC'),
	(277112, 121, '2014-04-01 00:15:34.000000', 'temperatura', 774.0000, 'ºC'),
	(277113, 121, '2014-04-01 00:15:35.000000', 'temperatura', 941.0000, 'ºC'),
	(277114, 121, '2014-04-01 00:15:36.000000', 'temperatura', 1183.0000, 'ºC'),
	(277115, 121, '2014-04-01 00:15:37.000000', 'temperatura', 692.0000, 'ºC'),
	(277116, 121, '2014-04-01 00:15:38.000000', 'temperatura', 1111.0000, 'ºC'),
	(277117, 121, '2014-04-01 00:15:39.000000', 'temperatura', 1081.0000, 'ºC'),
	(277118, 121, '2014-04-01 00:15:40.000000', 'temperatura', 873.0000, 'ºC'),
	(277119, 121, '2014-04-01 00:15:41.000000', 'temperatura', 1123.0000, 'ºC'),
	(277120, 121, '2014-04-01 00:15:42.000000', 'temperatura', 597.0000, 'ºC'),
	(277121, 121, '2014-04-01 00:15:43.000000', 'temperatura', 814.0000, 'ºC'),
	(277122, 121, '2014-04-01 00:15:44.000000', 'temperatura', 1080.0000, 'ºC'),
	(277123, 121, '2014-04-01 00:15:45.000000', 'temperatura', 558.0000, 'ºC'),
	(277124, 121, '2014-04-01 00:15:46.000000', 'temperatura', 752.0000, 'ºC'),
	(277125, 121, '2014-04-01 00:15:47.000000', 'temperatura', 887.0000, 'ºC'),
	(277126, 121, '2014-04-01 00:15:48.000000', 'temperatura', 978.0000, 'ºC'),
	(277127, 121, '2014-04-01 00:15:49.000000', 'temperatura', 1031.0000, 'ºC'),
	(277128, 121, '2014-04-01 00:15:50.000000', 'temperatura', 1020.0000, 'ºC'),
	(277129, 121, '2014-04-01 00:15:51.000000', 'temperatura', 809.0000, 'ºC'),
	(277130, 121, '2014-04-01 00:15:52.000000', 'temperatura', 983.0000, 'ºC'),
	(277131, 121, '2014-04-01 00:15:53.000000', 'temperatura', 89.0000, 'ºC'),
	(277132, 121, '2014-04-01 00:15:54.000000', 'temperatura', 1097.0000, 'ºC'),
	(277133, 121, '2014-04-01 00:15:55.000000', 'temperatura', 418.0000, 'ºC'),
	(277134, 121, '2014-04-01 00:15:56.000000', 'temperatura', 1.0000, 'ºC'),
	(277135, 121, '2014-04-01 00:15:57.000000', 'temperatura', 1152.0000, 'ºC'),
	(277136, 121, '2014-04-01 00:15:58.000000', 'temperatura', 957.0000, 'ºC'),
	(277137, 121, '2014-04-01 00:15:59.000000', 'temperatura', 127.0000, 'ºC'),
	(277138, 121, '2014-04-01 00:16:00.000000', 'temperatura', 167.0000, 'ºC'),
	(277139, 121, '2014-04-01 00:16:01.000000', 'temperatura', 453.0000, 'ºC'),
	(277140, 121, '2014-04-01 00:16:02.000000', 'temperatura', 566.0000, 'ºC'),
	(277141, 121, '2014-04-01 00:16:03.000000', 'temperatura', 272.0000, 'ºC'),
	(277142, 121, '2014-04-01 00:16:04.000000', 'temperatura', 862.0000, 'ºC'),
	(277143, 121, '2014-04-01 00:16:05.000000', 'temperatura', 1094.0000, 'ºC'),
	(277144, 121, '2014-04-01 00:16:06.000000', 'temperatura', 483.0000, 'ºC'),
	(277145, 121, '2014-04-01 00:16:07.000000', 'temperatura', 336.0000, 'ºC'),
	(277146, 121, '2014-04-01 00:16:08.000000', 'temperatura', 231.0000, 'ºC'),
	(277147, 121, '2014-04-01 00:16:09.000000', 'temperatura', 148.0000, 'ºC'),
	(277148, 121, '2014-04-01 00:16:10.000000', 'temperatura', 46.0000, 'ºC'),
	(277149, 121, '2014-04-01 00:16:11.000000', 'temperatura', 986.0000, 'ºC'),
	(277150, 121, '2014-04-01 00:16:12.000000', 'temperatura', 1195.0000, 'ºC'),
	(277151, 121, '2014-04-01 00:16:13.000000', 'temperatura', 615.0000, 'ºC'),
	(277152, 121, '2014-04-01 00:16:14.000000', 'temperatura', 693.0000, 'ºC'),
	(277153, 121, '2014-04-01 00:16:15.000000', 'temperatura', 419.0000, 'ºC'),
	(277154, 121, '2014-04-01 00:16:16.000000', 'temperatura', 16.0000, 'ºC'),
	(277155, 121, '2014-04-01 00:16:17.000000', 'temperatura', 23.0000, 'ºC'),
	(277156, 121, '2014-04-01 00:16:18.000000', 'temperatura', 70.0000, 'ºC'),
	(277157, 121, '2014-04-01 00:16:19.000000', 'temperatura', 280.0000, 'ºC'),
	(277158, 121, '2014-04-01 00:16:20.000000', 'temperatura', 1189.0000, 'ºC'),
	(277159, 121, '2014-04-01 00:16:21.000000', 'temperatura', 308.0000, 'ºC'),
	(277160, 121, '2014-04-01 00:16:22.000000', 'temperatura', 371.0000, 'ºC'),
	(277161, 121, '2014-04-01 00:16:23.000000', 'temperatura', 931.0000, 'ºC'),
	(277162, 121, '2014-04-01 00:16:24.000000', 'temperatura', 1145.0000, 'ºC'),
	(277163, 121, '2014-04-01 00:16:25.000000', 'temperatura', 531.0000, 'ºC'),
	(277164, 121, '2014-04-01 00:16:26.000000', 'temperatura', 422.0000, 'ºC'),
	(277165, 121, '2014-04-01 00:16:27.000000', 'temperatura', 516.0000, 'ºC'),
	(277166, 121, '2014-04-01 00:16:28.000000', 'temperatura', 117.0000, 'ºC'),
	(277167, 121, '2014-04-01 00:16:29.000000', 'temperatura', 235.0000, 'ºC'),
	(277168, 121, '2014-04-01 00:16:30.000000', 'temperatura', 826.0000, 'ºC'),
	(277169, 121, '2014-04-01 00:16:31.000000', 'temperatura', 1023.0000, 'ºC'),
	(277170, 121, '2014-04-01 00:16:32.000000', 'temperatura', 239.0000, 'ºC'),
	(277171, 121, '2014-04-01 00:16:33.000000', 'temperatura', 524.0000, 'ºC'),
	(277172, 121, '2014-04-01 00:16:34.000000', 'temperatura', 707.0000, 'ºC'),
	(277173, 121, '2014-04-01 00:16:35.000000', 'temperatura', 762.0000, 'ºC'),
	(277174, 121, '2014-04-01 00:16:36.000000', 'temperatura', 491.0000, 'ºC'),
	(277175, 121, '2014-04-01 00:16:37.000000', 'temperatura', 170.0000, 'ºC'),
	(277176, 121, '2014-04-01 00:16:38.000000', 'temperatura', 578.0000, 'ºC'),
	(277177, 121, '2014-04-01 00:16:39.000000', 'temperatura', 1181.0000, 'ºC'),
	(277178, 121, '2014-04-01 00:16:40.000000', 'temperatura', 572.0000, 'ºC'),
	(277179, 121, '2014-04-01 00:16:41.000000', 'temperatura', 516.0000, 'ºC'),
	(277180, 121, '2014-04-01 00:16:42.000000', 'temperatura', 863.0000, 'ºC'),
	(277181, 121, '2014-04-01 00:16:43.000000', 'temperatura', 368.0000, 'ºC'),
	(277182, 121, '2014-04-01 00:16:44.000000', 'temperatura', 453.0000, 'ºC'),
	(277183, 121, '2014-04-01 00:16:45.000000', 'temperatura', 1162.0000, 'ºC'),
	(277184, 121, '2014-04-01 00:16:46.000000', 'temperatura', 852.0000, 'ºC'),
	(277185, 121, '2014-04-01 00:16:47.000000', 'temperatura', 773.0000, 'ºC'),
	(277186, 121, '2014-04-01 00:16:48.000000', 'temperatura', 110.0000, 'ºC'),
	(277187, 121, '2014-04-01 00:16:49.000000', 'temperatura', 630.0000, 'ºC'),
	(277188, 121, '2014-04-01 00:16:50.000000', 'temperatura', 423.0000, 'ºC'),
	(277189, 121, '2014-04-01 00:16:51.000000', 'temperatura', 222.0000, 'ºC'),
	(277190, 121, '2014-04-01 00:16:52.000000', 'temperatura', 1045.0000, 'ºC'),
	(277191, 121, '2014-04-01 00:16:53.000000', 'temperatura', 957.0000, 'ºC'),
	(277192, 121, '2014-04-01 00:16:54.000000', 'temperatura', 451.0000, 'ºC'),
	(277193, 121, '2014-04-01 00:16:55.000000', 'temperatura', 584.0000, 'ºC'),
	(277194, 121, '2014-04-01 00:16:56.000000', 'temperatura', 368.0000, 'ºC'),
	(277195, 121, '2014-04-01 00:16:57.000000', 'temperatura', 90.0000, 'ºC'),
	(277196, 121, '2014-04-01 00:16:58.000000', 'temperatura', 545.0000, 'ºC'),
	(277197, 121, '2014-04-01 00:16:59.000000', 'temperatura', 58.0000, 'ºC'),
	(277198, 121, '2014-04-01 00:17:00.000000', 'temperatura', 1054.0000, 'ºC'),
	(277199, 121, '2014-04-01 00:17:01.000000', 'temperatura', 295.0000, 'ºC'),
	(277200, 121, '2014-04-01 00:17:02.000000', 'temperatura', 715.0000, 'ºC'),
	(277201, 121, '2014-04-01 00:17:03.000000', 'temperatura', 291.0000, 'ºC'),
	(277202, 121, '2014-04-01 00:17:04.000000', 'temperatura', 509.0000, 'ºC'),
	(277203, 121, '2014-04-01 00:17:05.000000', 'temperatura', 475.0000, 'ºC'),
	(277204, 121, '2014-04-01 00:17:06.000000', 'temperatura', 845.0000, 'ºC'),
	(277205, 121, '2014-04-01 00:17:07.000000', 'temperatura', 404.0000, 'ºC'),
	(277206, 121, '2014-04-01 00:17:08.000000', 'temperatura', 682.0000, 'ºC'),
	(277207, 121, '2014-04-01 00:17:09.000000', 'temperatura', 1000.0000, 'ºC'),
	(277208, 121, '2014-04-01 00:17:10.000000', 'temperatura', 555.0000, 'ºC'),
	(277209, 121, '2014-04-01 00:17:11.000000', 'temperatura', 974.0000, 'ºC'),
	(277210, 121, '2014-04-01 00:17:12.000000', 'temperatura', 805.0000, 'ºC'),
	(277211, 121, '2014-04-01 00:17:13.000000', 'temperatura', 1103.0000, 'ºC'),
	(277212, 121, '2014-04-01 00:17:14.000000', 'temperatura', 699.0000, 'ºC'),
	(277213, 121, '2014-04-01 00:17:15.000000', 'temperatura', 190.0000, 'ºC'),
	(277214, 121, '2014-04-01 00:17:16.000000', 'temperatura', 53.0000, 'ºC'),
	(277215, 121, '2014-04-01 00:17:17.000000', 'temperatura', 896.0000, 'ºC'),
	(277216, 121, '2014-04-01 00:17:18.000000', 'temperatura', 721.0000, 'ºC'),
	(277217, 121, '2014-04-01 00:17:19.000000', 'temperatura', 918.0000, 'ºC'),
	(277218, 121, '2014-04-01 00:17:20.000000', 'temperatura', 26.0000, 'ºC'),
	(277219, 121, '2014-04-01 00:17:21.000000', 'temperatura', 978.0000, 'ºC'),
	(277220, 121, '2014-04-01 00:17:22.000000', 'temperatura', 11.0000, 'ºC'),
	(277221, 121, '2014-04-01 00:17:23.000000', 'temperatura', 722.0000, 'ºC'),
	(277222, 121, '2014-04-01 00:17:24.000000', 'temperatura', 1177.0000, 'ºC'),
	(277223, 121, '2014-04-01 00:17:25.000000', 'temperatura', 120.0000, 'ºC'),
	(277224, 121, '2014-04-01 00:17:26.000000', 'temperatura', 671.0000, 'ºC'),
	(277225, 121, '2014-04-01 00:17:27.000000', 'temperatura', 595.0000, 'ºC'),
	(277226, 121, '2014-04-01 00:17:28.000000', 'temperatura', 963.0000, 'ºC'),
	(277227, 121, '2014-04-01 00:17:29.000000', 'temperatura', 630.0000, 'ºC'),
	(277228, 121, '2014-04-01 00:17:30.000000', 'temperatura', 261.0000, 'ºC'),
	(277229, 121, '2014-04-01 00:17:31.000000', 'temperatura', 618.0000, 'ºC'),
	(277230, 121, '2014-04-01 00:17:32.000000', 'temperatura', 1104.0000, 'ºC'),
	(277231, 121, '2014-04-01 00:17:33.000000', 'temperatura', 68.0000, 'ºC'),
	(277232, 121, '2014-04-01 00:17:34.000000', 'temperatura', 628.0000, 'ºC'),
	(277233, 121, '2014-04-01 00:17:35.000000', 'temperatura', 538.0000, 'ºC'),
	(277234, 121, '2014-04-01 00:17:36.000000', 'temperatura', 807.0000, 'ºC'),
	(277235, 121, '2014-04-01 00:17:37.000000', 'temperatura', 19.0000, 'ºC'),
	(277236, 121, '2014-04-01 00:17:38.000000', 'temperatura', 74.0000, 'ºC'),
	(277237, 121, '2014-04-01 00:17:39.000000', 'temperatura', 314.0000, 'ºC'),
	(277238, 121, '2014-04-01 00:17:40.000000', 'temperatura', 147.0000, 'ºC'),
	(277239, 121, '2014-04-01 00:17:41.000000', 'temperatura', 995.0000, 'ºC'),
	(277240, 121, '2014-04-01 00:17:42.000000', 'temperatura', 935.0000, 'ºC'),
	(277241, 121, '2014-04-01 00:17:43.000000', 'temperatura', 490.0000, 'ºC'),
	(277242, 121, '2014-04-01 00:17:44.000000', 'temperatura', 848.0000, 'ºC'),
	(277243, 121, '2014-04-01 00:17:45.000000', 'temperatura', 367.0000, 'ºC'),
	(277244, 121, '2014-04-01 00:17:46.000000', 'temperatura', 492.0000, 'ºC'),
	(277245, 121, '2014-04-01 00:17:47.000000', 'temperatura', 159.0000, 'ºC'),
	(277246, 121, '2014-04-01 00:17:48.000000', 'temperatura', 518.0000, 'ºC'),
	(277247, 121, '2014-04-01 00:17:49.000000', 'temperatura', 916.0000, 'ºC'),
	(277248, 121, '2014-04-01 00:17:50.000000', 'temperatura', 625.0000, 'ºC'),
	(277249, 121, '2014-04-01 00:17:51.000000', 'temperatura', 376.0000, 'ºC'),
	(277250, 121, '2014-04-01 00:17:52.000000', 'temperatura', 8.0000, 'ºC'),
	(277251, 121, '2014-04-01 00:17:53.000000', 'temperatura', 112.0000, 'ºC'),
	(277252, 121, '2014-04-01 00:17:54.000000', 'temperatura', 535.0000, 'ºC'),
	(277253, 121, '2014-04-01 00:17:55.000000', 'temperatura', 1142.0000, 'ºC'),
	(277254, 121, '2014-04-01 00:17:56.000000', 'temperatura', 505.0000, 'ºC'),
	(277255, 121, '2014-04-01 00:17:57.000000', 'temperatura', 300.0000, 'ºC'),
	(277256, 121, '2014-04-01 00:17:58.000000', 'temperatura', 1186.0000, 'ºC'),
	(277257, 121, '2014-04-01 00:17:59.000000', 'temperatura', 230.0000, 'ºC'),
	(277258, 121, '2014-04-01 00:18:00.000000', 'temperatura', 1191.0000, 'ºC'),
	(277259, 121, '2014-04-01 00:18:01.000000', 'temperatura', 467.0000, 'ºC'),
	(277260, 121, '2014-04-01 00:18:02.000000', 'temperatura', 1163.0000, 'ºC'),
	(277261, 121, '2014-04-01 00:18:03.000000', 'temperatura', 813.0000, 'ºC'),
	(277262, 121, '2014-04-01 00:18:04.000000', 'temperatura', 577.0000, 'ºC'),
	(277263, 121, '2014-04-01 00:18:05.000000', 'temperatura', 446.0000, 'ºC'),
	(277264, 121, '2014-04-01 00:18:06.000000', 'temperatura', 500.0000, 'ºC'),
	(277265, 121, '2014-04-01 00:18:07.000000', 'temperatura', 1165.0000, 'ºC'),
	(277266, 121, '2014-04-01 00:18:08.000000', 'temperatura', 722.0000, 'ºC'),
	(277267, 121, '2014-04-01 00:18:09.000000', 'temperatura', 116.0000, 'ºC'),
	(277268, 121, '2014-04-01 00:18:10.000000', 'temperatura', 816.0000, 'ºC'),
	(277269, 121, '2014-04-01 00:18:11.000000', 'temperatura', 130.0000, 'ºC'),
	(277270, 121, '2014-04-01 00:18:12.000000', 'temperatura', 606.0000, 'ºC'),
	(277271, 121, '2014-04-01 00:18:13.000000', 'temperatura', 238.0000, 'ºC'),
	(277272, 121, '2014-04-01 00:18:14.000000', 'temperatura', 574.0000, 'ºC'),
	(277273, 121, '2014-04-01 00:18:15.000000', 'temperatura', 957.0000, 'ºC'),
	(277274, 121, '2014-04-01 00:18:16.000000', 'temperatura', 664.0000, 'ºC'),
	(277275, 121, '2014-04-01 00:18:17.000000', 'temperatura', 450.0000, 'ºC'),
	(277276, 121, '2014-04-01 00:18:18.000000', 'temperatura', 257.0000, 'ºC'),
	(277277, 121, '2014-04-01 00:18:19.000000', 'temperatura', 1134.0000, 'ºC'),
	(277278, 121, '2014-04-01 00:18:20.000000', 'temperatura', 102.0000, 'ºC'),
	(277279, 121, '2014-04-01 00:18:21.000000', 'temperatura', 707.0000, 'ºC'),
	(277280, 121, '2014-04-01 00:18:22.000000', 'temperatura', 830.0000, 'ºC'),
	(277281, 121, '2014-04-01 00:18:23.000000', 'temperatura', 831.0000, 'ºC'),
	(277282, 121, '2014-04-01 00:18:24.000000', 'temperatura', 466.0000, 'ºC'),
	(277283, 121, '2014-04-01 00:18:25.000000', 'temperatura', 1035.0000, 'ºC'),
	(277284, 121, '2014-04-01 00:18:26.000000', 'temperatura', 179.0000, 'ºC'),
	(277285, 121, '2014-04-01 00:18:27.000000', 'temperatura', 188.0000, 'ºC'),
	(277286, 121, '2014-04-01 00:18:28.000000', 'temperatura', 405.0000, 'ºC'),
	(277287, 121, '2014-04-01 00:18:29.000000', 'temperatura', 262.0000, 'ºC'),
	(277288, 121, '2014-04-01 00:18:30.000000', 'temperatura', 93.0000, 'ºC'),
	(277289, 121, '2014-04-01 00:18:31.000000', 'temperatura', 883.0000, 'ºC'),
	(277290, 121, '2014-04-01 00:18:32.000000', 'temperatura', 534.0000, 'ºC'),
	(277291, 121, '2014-04-01 00:18:33.000000', 'temperatura', 20.0000, 'ºC'),
	(277292, 121, '2014-04-01 00:18:34.000000', 'temperatura', 901.0000, 'ºC'),
	(277293, 121, '2014-04-01 00:18:35.000000', 'temperatura', 845.0000, 'ºC'),
	(277294, 121, '2014-04-01 00:18:36.000000', 'temperatura', 321.0000, 'ºC'),
	(277295, 121, '2014-04-01 00:18:37.000000', 'temperatura', 273.0000, 'ºC'),
	(277296, 121, '2014-04-01 00:18:38.000000', 'temperatura', 402.0000, 'ºC'),
	(277297, 121, '2014-04-01 00:18:39.000000', 'temperatura', 1191.0000, 'ºC'),
	(277298, 121, '2014-04-01 00:18:40.000000', 'temperatura', 1148.0000, 'ºC'),
	(277299, 121, '2014-04-01 00:18:41.000000', 'temperatura', 967.0000, 'ºC'),
	(277300, 121, '2014-04-01 00:18:42.000000', 'temperatura', 193.0000, 'ºC'),
	(277301, 121, '2014-04-01 00:18:43.000000', 'temperatura', 463.0000, 'ºC'),
	(277302, 121, '2014-04-01 00:18:44.000000', 'temperatura', 539.0000, 'ºC'),
	(277303, 121, '2014-04-01 00:18:45.000000', 'temperatura', 107.0000, 'ºC'),
	(277304, 121, '2014-04-01 00:18:46.000000', 'temperatura', 118.0000, 'ºC'),
	(277305, 121, '2014-04-01 00:18:47.000000', 'temperatura', 268.0000, 'ºC'),
	(277306, 121, '2014-04-01 00:18:48.000000', 'temperatura', 988.0000, 'ºC'),
	(277307, 121, '2014-04-01 00:18:49.000000', 'temperatura', 535.0000, 'ºC'),
	(277308, 121, '2014-04-01 00:18:50.000000', 'temperatura', 910.0000, 'ºC'),
	(277309, 121, '2014-04-01 00:18:51.000000', 'temperatura', 548.0000, 'ºC'),
	(277310, 121, '2014-04-01 00:18:52.000000', 'temperatura', 12.0000, 'ºC'),
	(277311, 121, '2014-04-01 00:18:53.000000', 'temperatura', 814.0000, 'ºC'),
	(277312, 121, '2014-04-01 00:18:54.000000', 'temperatura', 435.0000, 'ºC'),
	(277313, 121, '2014-04-01 00:18:55.000000', 'temperatura', 934.0000, 'ºC'),
	(277314, 121, '2014-04-01 00:18:56.000000', 'temperatura', 966.0000, 'ºC'),
	(277315, 121, '2014-04-01 00:18:57.000000', 'temperatura', 828.0000, 'ºC'),
	(277316, 121, '2014-04-01 00:18:58.000000', 'temperatura', 43.0000, 'ºC'),
	(277317, 121, '2014-04-01 00:18:59.000000', 'temperatura', 129.0000, 'ºC'),
	(277318, 121, '2014-04-01 00:19:00.000000', 'temperatura', 518.0000, 'ºC'),
	(277319, 121, '2014-04-01 00:19:01.000000', 'temperatura', 1005.0000, 'ºC'),
	(277320, 121, '2014-04-01 00:19:02.000000', 'temperatura', 1070.0000, 'ºC'),
	(277321, 121, '2014-04-01 00:19:03.000000', 'temperatura', 1137.0000, 'ºC'),
	(277322, 121, '2014-04-01 00:19:04.000000', 'temperatura', 75.0000, 'ºC'),
	(277323, 121, '2014-04-01 00:19:05.000000', 'temperatura', 566.0000, 'ºC'),
	(277324, 121, '2014-04-01 00:19:06.000000', 'temperatura', 202.0000, 'ºC'),
	(277325, 121, '2014-04-01 00:19:07.000000', 'temperatura', 516.0000, 'ºC'),
	(277326, 121, '2014-04-01 00:19:08.000000', 'temperatura', 772.0000, 'ºC'),
	(277327, 121, '2014-04-01 00:19:09.000000', 'temperatura', 1114.0000, 'ºC'),
	(277328, 121, '2014-04-01 00:19:10.000000', 'temperatura', 855.0000, 'ºC'),
	(277329, 121, '2014-04-01 00:19:11.000000', 'temperatura', 934.0000, 'ºC'),
	(277330, 121, '2014-04-01 00:19:12.000000', 'temperatura', 906.0000, 'ºC'),
	(277331, 121, '2014-04-01 00:19:13.000000', 'temperatura', 526.0000, 'ºC'),
	(277332, 121, '2014-04-01 00:19:14.000000', 'temperatura', 1111.0000, 'ºC'),
	(277333, 121, '2014-04-01 00:19:15.000000', 'temperatura', 381.0000, 'ºC'),
	(277334, 121, '2014-04-01 00:19:16.000000', 'temperatura', 973.0000, 'ºC'),
	(277335, 121, '2014-04-01 00:19:17.000000', 'temperatura', 121.0000, 'ºC'),
	(277336, 121, '2014-04-01 00:19:18.000000', 'temperatura', 86.0000, 'ºC'),
	(277337, 121, '2014-04-01 00:19:19.000000', 'temperatura', 67.0000, 'ºC'),
	(277338, 121, '2014-04-01 00:19:20.000000', 'temperatura', 80.0000, 'ºC'),
	(277339, 121, '2014-04-01 00:19:21.000000', 'temperatura', 199.0000, 'ºC'),
	(277340, 121, '2014-04-01 00:19:22.000000', 'temperatura', 753.0000, 'ºC'),
	(277341, 121, '2014-04-01 00:19:23.000000', 'temperatura', 770.0000, 'ºC'),
	(277342, 121, '2014-04-01 00:19:24.000000', 'temperatura', 393.0000, 'ºC'),
	(277343, 121, '2014-04-01 00:19:25.000000', 'temperatura', 856.0000, 'ºC'),
	(277344, 121, '2014-04-01 00:19:26.000000', 'temperatura', 701.0000, 'ºC'),
	(277345, 121, '2014-04-01 00:19:27.000000', 'temperatura', 937.0000, 'ºC'),
	(277346, 121, '2014-04-01 00:19:28.000000', 'temperatura', 185.0000, 'ºC'),
	(277347, 121, '2014-04-01 00:19:29.000000', 'temperatura', 511.0000, 'ºC'),
	(277348, 121, '2014-04-01 00:19:30.000000', 'temperatura', 803.0000, 'ºC'),
	(277349, 121, '2014-04-01 00:19:31.000000', 'temperatura', 83.0000, 'ºC'),
	(277350, 121, '2014-04-01 00:19:32.000000', 'temperatura', 404.0000, 'ºC'),
	(277351, 121, '2014-04-01 00:19:33.000000', 'temperatura', 572.0000, 'ºC'),
	(277352, 121, '2014-04-01 00:19:34.000000', 'temperatura', 451.0000, 'ºC'),
	(277353, 121, '2014-04-01 00:19:35.000000', 'temperatura', 536.0000, 'ºC'),
	(277354, 121, '2014-04-01 00:19:36.000000', 'temperatura', 129.0000, 'ºC'),
	(277355, 121, '2014-04-01 00:19:37.000000', 'temperatura', 237.0000, 'ºC'),
	(277356, 121, '2014-04-01 00:19:38.000000', 'temperatura', 800.0000, 'ºC'),
	(277357, 121, '2014-04-01 00:19:39.000000', 'temperatura', 890.0000, 'ºC'),
	(277358, 121, '2014-04-01 00:19:40.000000', 'temperatura', 848.0000, 'ºC'),
	(277359, 121, '2014-04-01 00:19:41.000000', 'temperatura', 373.0000, 'ºC'),
	(277360, 121, '2014-04-01 00:19:42.000000', 'temperatura', 520.0000, 'ºC'),
	(277361, 121, '2014-04-01 00:19:43.000000', 'temperatura', 282.0000, 'ºC'),
	(277362, 121, '2014-04-01 00:19:44.000000', 'temperatura', 1052.0000, 'ºC'),
	(277363, 121, '2014-04-01 00:19:45.000000', 'temperatura', 815.0000, 'ºC'),
	(277364, 121, '2014-04-01 00:19:46.000000', 'temperatura', 918.0000, 'ºC'),
	(277365, 121, '2014-04-01 00:19:47.000000', 'temperatura', 947.0000, 'ºC'),
	(277366, 121, '2014-04-01 00:19:48.000000', 'temperatura', 780.0000, 'ºC'),
	(277367, 121, '2014-04-01 00:19:49.000000', 'temperatura', 1058.0000, 'ºC'),
	(277368, 121, '2014-04-01 00:19:50.000000', 'temperatura', 552.0000, 'ºC'),
	(277369, 121, '2014-04-01 00:19:51.000000', 'temperatura', 788.0000, 'ºC'),
	(277370, 121, '2014-04-01 00:19:52.000000', 'temperatura', 1083.0000, 'ºC'),
	(277371, 121, '2014-04-01 00:19:53.000000', 'temperatura', 652.0000, 'ºC'),
	(277372, 121, '2014-04-01 00:19:54.000000', 'temperatura', 10.0000, 'ºC'),
	(277373, 121, '2014-04-01 00:19:55.000000', 'temperatura', 498.0000, 'ºC'),
	(277374, 121, '2014-04-01 00:19:56.000000', 'temperatura', 57.0000, 'ºC'),
	(277375, 121, '2014-04-01 00:19:57.000000', 'temperatura', 1192.0000, 'ºC'),
	(277376, 121, '2014-04-01 00:19:58.000000', 'temperatura', 991.0000, 'ºC'),
	(277377, 121, '2014-04-01 00:19:59.000000', 'temperatura', 180.0000, 'ºC'),
	(277378, 121, '2014-04-01 00:20:00.000000', 'temperatura', 325.0000, 'ºC'),
	(277379, 121, '2014-04-01 00:20:01.000000', 'temperatura', 1088.0000, 'ºC'),
	(277380, 121, '2014-04-01 00:20:02.000000', 'temperatura', 864.0000, 'ºC'),
	(277381, 121, '2014-04-01 00:20:03.000000', 'temperatura', 1056.0000, 'ºC'),
	(277382, 121, '2014-04-01 00:20:04.000000', 'temperatura', 287.0000, 'ºC'),
	(277383, 121, '2014-04-01 00:20:05.000000', 'temperatura', 670.0000, 'ºC'),
	(277384, 121, '2014-04-01 00:20:06.000000', 'temperatura', 88.0000, 'ºC'),
	(277385, 121, '2014-04-01 00:20:07.000000', 'temperatura', 832.0000, 'ºC'),
	(277386, 121, '2014-04-01 00:20:08.000000', 'temperatura', 296.0000, 'ºC'),
	(277387, 121, '2014-04-01 00:20:09.000000', 'temperatura', 185.0000, 'ºC'),
	(277388, 121, '2014-04-01 00:20:10.000000', 'temperatura', 37.0000, 'ºC'),
	(277389, 121, '2014-04-01 00:20:11.000000', 'temperatura', 832.0000, 'ºC'),
	(277390, 121, '2014-04-01 00:20:12.000000', 'temperatura', 447.0000, 'ºC'),
	(277391, 121, '2014-04-01 00:20:13.000000', 'temperatura', 940.0000, 'ºC'),
	(277392, 121, '2014-04-01 00:20:14.000000', 'temperatura', 961.0000, 'ºC'),
	(277393, 121, '2014-04-01 00:20:15.000000', 'temperatura', 783.0000, 'ºC'),
	(277394, 121, '2014-04-01 00:20:16.000000', 'temperatura', 1036.0000, 'ºC'),
	(277395, 121, '2014-04-01 00:20:17.000000', 'temperatura', 429.0000, 'ºC'),
	(277396, 121, '2014-04-01 00:20:18.000000', 'temperatura', 238.0000, 'ºC'),
	(277397, 121, '2014-04-01 00:20:19.000000', 'temperatura', 1103.0000, 'ºC'),
	(277398, 121, '2014-04-01 00:20:20.000000', 'temperatura', 0.0000, 'ºC'),
	(277399, 121, '2014-04-01 00:20:21.000000', 'temperatura', 293.0000, 'ºC'),
	(277400, 121, '2014-04-01 00:20:22.000000', 'temperatura', 265.0000, 'ºC'),
	(277401, 121, '2014-04-01 00:20:23.000000', 'temperatura', 445.0000, 'ºC'),
	(277402, 121, '2014-04-01 00:20:24.000000', 'temperatura', 234.0000, 'ºC'),
	(277403, 121, '2014-04-01 00:20:25.000000', 'temperatura', 1033.0000, 'ºC'),
	(277404, 121, '2014-04-01 00:20:26.000000', 'temperatura', 863.0000, 'ºC'),
	(277405, 121, '2014-04-01 00:20:27.000000', 'temperatura', 18.0000, 'ºC'),
	(277406, 121, '2014-04-01 00:20:28.000000', 'temperatura', 1102.0000, 'ºC'),
	(277407, 121, '2014-04-01 00:20:29.000000', 'temperatura', 658.0000, 'ºC'),
	(277408, 121, '2014-04-01 00:20:30.000000', 'temperatura', 1181.0000, 'ºC'),
	(277409, 121, '2014-04-01 00:20:31.000000', 'temperatura', 334.0000, 'ºC'),
	(277410, 121, '2014-04-01 00:20:32.000000', 'temperatura', 528.0000, 'ºC'),
	(277411, 121, '2014-04-01 00:20:33.000000', 'temperatura', 436.0000, 'ºC'),
	(277412, 121, '2014-04-01 00:20:34.000000', 'temperatura', 599.0000, 'ºC'),
	(277413, 121, '2014-04-01 00:20:35.000000', 'temperatura', 485.0000, 'ºC'),
	(277414, 121, '2014-04-01 00:20:36.000000', 'temperatura', 628.0000, 'ºC'),
	(277415, 121, '2014-04-01 00:20:37.000000', 'temperatura', 487.0000, 'ºC'),
	(277416, 121, '2014-04-01 00:20:38.000000', 'temperatura', 552.0000, 'ºC'),
	(277417, 121, '2014-04-01 00:20:39.000000', 'temperatura', 100.0000, 'ºC'),
	(277418, 121, '2014-04-01 00:20:40.000000', 'temperatura', 43.0000, 'ºC'),
	(277419, 121, '2014-04-01 00:20:41.000000', 'temperatura', 1115.0000, 'ºC'),
	(277420, 121, '2014-04-01 00:20:42.000000', 'temperatura', 647.0000, 'ºC'),
	(277421, 121, '2014-04-01 00:20:43.000000', 'temperatura', 1090.0000, 'ºC'),
	(277422, 121, '2014-04-01 00:20:44.000000', 'temperatura', 1108.0000, 'ºC'),
	(277423, 121, '2014-04-01 00:20:45.000000', 'temperatura', 1074.0000, 'ºC'),
	(277424, 121, '2014-04-01 00:20:46.000000', 'temperatura', 844.0000, 'ºC'),
	(277425, 121, '2014-04-01 00:20:47.000000', 'temperatura', 999.0000, 'ºC'),
	(277426, 121, '2014-04-01 00:20:48.000000', 'temperatura', 62.0000, 'ºC'),
	(277427, 121, '2014-04-01 00:20:49.000000', 'temperatura', 915.0000, 'ºC'),
	(277428, 121, '2014-04-01 00:20:50.000000', 'temperatura', 790.0000, 'ºC'),
	(277429, 121, '2014-04-01 00:20:51.000000', 'temperatura', 5.0000, 'ºC'),
	(277430, 121, '2014-04-01 00:20:52.000000', 'temperatura', 55.0000, 'ºC'),
	(277431, 121, '2014-04-01 00:20:53.000000', 'temperatura', 262.0000, 'ºC'),
	(277432, 121, '2014-04-01 00:20:54.000000', 'temperatura', 1143.0000, 'ºC'),
	(277433, 121, '2014-04-01 00:20:55.000000', 'temperatura', 130.0000, 'ºC'),
	(277434, 121, '2014-04-01 00:20:56.000000', 'temperatura', 821.0000, 'ºC'),
	(277435, 121, '2014-04-01 00:20:57.000000', 'temperatura', 115.0000, 'ºC'),
	(277436, 121, '2014-04-01 00:20:58.000000', 'temperatura', 515.0000, 'ºC'),
	(277437, 121, '2014-04-01 00:20:59.000000', 'temperatura', 1028.0000, 'ºC'),
	(277438, 121, '2014-04-01 00:21:00.000000', 'temperatura', 1195.0000, 'ºC'),
	(277439, 121, '2014-04-01 00:21:01.000000', 'temperatura', 490.0000, 'ºC'),
	(277440, 121, '2014-04-01 00:21:02.000000', 'temperatura', 69.0000, 'ºC'),
	(277441, 121, '2014-04-01 00:21:03.000000', 'temperatura', 73.0000, 'ºC'),
	(277442, 121, '2014-04-01 00:21:04.000000', 'temperatura', 160.0000, 'ºC'),
	(277443, 121, '2014-04-01 00:21:05.000000', 'temperatura', 582.0000, 'ºC'),
	(277444, 121, '2014-04-01 00:21:06.000000', 'temperatura', 30.0000, 'ºC'),
	(277445, 121, '2014-04-01 00:21:07.000000', 'temperatura', 803.0000, 'ºC'),
	(277446, 121, '2014-04-01 00:21:08.000000', 'temperatura', 328.0000, 'ºC'),
	(277447, 121, '2014-04-01 00:21:09.000000', 'temperatura', 431.0000, 'ºC'),
	(277448, 121, '2014-04-01 00:21:10.000000', 'temperatura', 1173.0000, 'ºC'),
	(277449, 121, '2014-04-01 00:21:11.000000', 'temperatura', 972.0000, 'ºC'),
	(277450, 121, '2014-04-01 00:21:12.000000', 'temperatura', 140.0000, 'ºC'),
	(277451, 121, '2014-04-01 00:21:13.000000', 'temperatura', 186.0000, 'ºC'),
	(277452, 121, '2014-04-01 00:21:14.000000', 'temperatura', 509.0000, 'ºC'),
	(277453, 121, '2014-04-01 00:21:15.000000', 'temperatura', 789.0000, 'ºC'),
	(277454, 121, '2014-04-01 00:21:16.000000', 'temperatura', 20.0000, 'ºC'),
	(277455, 121, '2014-04-01 00:21:17.000000', 'temperatura', 131.0000, 'ºC'),
	(277456, 121, '2014-04-01 00:21:18.000000', 'temperatura', 596.0000, 'ºC'),
	(277457, 121, '2014-04-01 00:21:19.000000', 'temperatura', 186.0000, 'ºC'),
	(277458, 121, '2014-04-01 00:21:20.000000', 'temperatura', 344.0000, 'ºC'),
	(277459, 121, '2014-04-01 00:21:21.000000', 'temperatura', 1164.0000, 'ºC'),
	(277460, 121, '2014-04-01 00:21:22.000000', 'temperatura', 1186.0000, 'ºC'),
	(277461, 121, '2014-04-01 00:21:23.000000', 'temperatura', 40.0000, 'ºC'),
	(277462, 121, '2014-04-01 00:21:24.000000', 'temperatura', 243.0000, 'ºC'),
	(277463, 121, '2014-04-01 00:21:25.000000', 'temperatura', 1095.0000, 'ºC'),
	(277464, 121, '2014-04-01 00:21:26.000000', 'temperatura', 1145.0000, 'ºC'),
	(277465, 121, '2014-04-01 00:21:27.000000', 'temperatura', 40.0000, 'ºC'),
	(277466, 121, '2014-04-01 00:21:28.000000', 'temperatura', 365.0000, 'ºC'),
	(277467, 121, '2014-04-01 00:21:29.000000', 'temperatura', 505.0000, 'ºC'),
	(277468, 121, '2014-04-01 00:21:30.000000', 'temperatura', 233.0000, 'ºC'),
	(277469, 121, '2014-04-01 00:21:31.000000', 'temperatura', 850.0000, 'ºC'),
	(277470, 121, '2014-04-01 00:21:32.000000', 'temperatura', 1150.0000, 'ºC'),
	(277471, 121, '2014-04-01 00:21:33.000000', 'temperatura', 803.0000, 'ºC'),
	(277472, 121, '2014-04-01 00:21:34.000000', 'temperatura', 565.0000, 'ºC'),
	(277473, 121, '2014-04-01 00:21:35.000000', 'temperatura', 417.0000, 'ºC'),
	(277474, 121, '2014-04-01 00:21:36.000000', 'temperatura', 389.0000, 'ºC'),
	(277475, 121, '2014-04-01 00:21:37.000000', 'temperatura', 696.0000, 'ºC'),
	(277476, 121, '2014-04-01 00:21:38.000000', 'temperatura', 1114.0000, 'ºC'),
	(277477, 121, '2014-04-01 00:21:39.000000', 'temperatura', 1084.0000, 'ºC'),
	(277478, 121, '2014-04-01 00:21:40.000000', 'temperatura', 875.0000, 'ºC'),
	(277479, 121, '2014-04-01 00:21:41.000000', 'temperatura', 1126.0000, 'ºC'),
	(277480, 121, '2014-04-01 00:21:42.000000', 'temperatura', 604.0000, 'ºC'),
	(277481, 121, '2014-04-01 00:21:43.000000', 'temperatura', 843.0000, 'ºC'),
	(277482, 121, '2014-04-01 00:21:44.000000', 'temperatura', 4.0000, 'ºC'),
	(277483, 121, '2014-04-01 00:21:45.000000', 'temperatura', 1089.0000, 'ºC'),
	(277484, 121, '2014-04-01 00:21:46.000000', 'temperatura', 636.0000, 'ºC'),
	(277485, 121, '2014-04-01 00:21:47.000000', 'temperatura', 1112.0000, 'ºC'),
	(277486, 121, '2014-04-01 00:21:48.000000', 'temperatura', 53.0000, 'ºC'),
	(277487, 121, '2014-04-01 00:21:49.000000', 'temperatura', 530.0000, 'ºC'),
	(277488, 121, '2014-04-01 00:21:50.000000', 'temperatura', 90.0000, 'ºC'),
	(277489, 121, '2014-04-01 00:21:51.000000', 'temperatura', 62.0000, 'ºC'),
	(277490, 121, '2014-04-01 00:21:52.000000', 'temperatura', 42.0000, 'ºC'),
	(277491, 121, '2014-04-01 00:21:53.000000', 'temperatura', 22.0000, 'ºC'),
	(277492, 121, '2014-04-01 00:21:54.000000', 'temperatura', 1187.0000, 'ºC'),
	(277493, 121, '2014-04-01 00:21:55.000000', 'temperatura', 1068.0000, 'ºC'),
	(277494, 121, '2014-04-01 00:21:56.000000', 'temperatura', 580.0000, 'ºC'),
	(277495, 121, '2014-04-01 00:21:57.000000', 'temperatura', 894.0000, 'ºC'),
	(277496, 121, '2014-04-01 00:21:58.000000', 'temperatura', 334.0000, 'ºC'),
	(277497, 121, '2014-04-01 00:21:59.000000', 'temperatura', 187.0000, 'ºC'),
	(277498, 121, '2014-04-01 00:22:00.000000', 'temperatura', 1134.0000, 'ºC'),
	(277499, 121, '2014-04-01 00:22:01.000000', 'temperatura', 311.0000, 'ºC'),
	(277500, 121, '2014-04-01 00:22:02.000000', 'temperatura', 553.0000, 'ºC'),
	(277501, 121, '2014-04-01 00:22:03.000000', 'temperatura', 630.0000, 'ºC'),
	(277502, 121, '2014-04-01 00:22:04.000000', 'temperatura', 292.0000, 'ºC'),
	(277503, 121, '2014-04-01 00:22:05.000000', 'temperatura', 772.0000, 'ºC'),
	(277504, 121, '2014-04-01 00:22:06.000000', 'temperatura', 585.0000, 'ºC'),
	(277505, 121, '2014-04-01 00:22:07.000000', 'temperatura', 610.0000, 'ºC'),
	(277506, 121, '2014-04-01 00:22:08.000000', 'temperatura', 94.0000, 'ºC'),
	(277507, 121, '2014-04-01 00:22:09.000000', 'temperatura', 1041.0000, 'ºC'),
	(277508, 121, '2014-04-01 00:22:10.000000', 'temperatura', 122.0000, 'ºC'),
	(277509, 121, '2014-04-01 00:22:11.000000', 'temperatura', 1087.0000, 'ºC'),
	(277510, 121, '2014-04-01 00:22:12.000000', 'temperatura', 271.0000, 'ºC'),
	(277511, 121, '2014-04-01 00:22:13.000000', 'temperatura', 496.0000, 'ºC'),
	(277512, 121, '2014-04-01 00:22:14.000000', 'temperatura', 466.0000, 'ºC'),
	(277513, 121, '2014-04-01 00:22:15.000000', 'temperatura', 844.0000, 'ºC'),
	(277514, 121, '2014-04-01 00:22:16.000000', 'temperatura', 419.0000, 'ºC'),
	(277515, 121, '2014-04-01 00:22:17.000000', 'temperatura', 767.0000, 'ºC'),
	(277516, 121, '2014-04-01 00:22:18.000000', 'temperatura', 178.0000, 'ºC'),
	(277517, 121, '2014-04-01 00:22:19.000000', 'temperatura', 988.0000, 'ºC'),
	(277518, 121, '2014-04-01 00:22:20.000000', 'temperatura', 809.0000, 'ºC'),
	(277519, 121, '2014-04-01 00:22:21.000000', 'temperatura', 1080.0000, 'ºC'),
	(277520, 121, '2014-04-01 00:22:22.000000', 'temperatura', 576.0000, 'ºC'),
	(277521, 121, '2014-04-01 00:22:23.000000', 'temperatura', 838.0000, 'ºC'),
	(277522, 121, '2014-04-01 00:22:24.000000', 'temperatura', 64.0000, 'ºC'),
	(277523, 121, '2014-04-01 00:22:25.000000', 'temperatura', 204.0000, 'ºC'),
	(277524, 121, '2014-04-01 00:22:26.000000', 'temperatura', 829.0000, 'ºC'),
	(277525, 121, '2014-04-01 00:22:27.000000', 'temperatura', 1135.0000, 'ºC'),
	(277526, 121, '2014-04-01 00:22:28.000000', 'temperatura', 787.0000, 'ºC'),
	(277527, 121, '2014-04-01 00:22:29.000000', 'temperatura', 531.0000, 'ºC'),
	(277528, 121, '2014-04-01 00:22:30.000000', 'temperatura', 296.0000, 'ºC'),
	(277529, 121, '2014-04-01 00:22:31.000000', 'temperatura', 1085.0000, 'ºC'),
	(277530, 121, '2014-04-01 00:22:32.000000', 'temperatura', 939.0000, 'ºC'),
	(277531, 121, '2014-04-01 00:22:33.000000', 'temperatura', 238.0000, 'ºC'),
	(277532, 121, '2014-04-01 00:22:34.000000', 'temperatura', 776.0000, 'ºC'),
	(277533, 121, '2014-04-01 00:22:35.000000', 'temperatura', 765.0000, 'ºC'),
	(277534, 121, '2014-04-01 00:22:36.000000', 'temperatura', 300.0000, 'ºC'),
	(277535, 121, '2014-04-01 00:22:37.000000', 'temperatura', 403.0000, 'ºC'),
	(277536, 121, '2014-04-01 00:22:38.000000', 'temperatura', 1116.0000, 'ºC'),
	(277537, 121, '2014-04-01 00:22:39.000000', 'temperatura', 772.0000, 'ºC'),
	(277538, 121, '2014-04-01 00:22:40.000000', 'temperatura', 512.0000, 'ºC'),
	(277539, 121, '2014-04-01 00:22:41.000000', 'temperatura', 244.0000, 'ºC'),
	(277540, 121, '2014-04-01 00:22:42.000000', 'temperatura', 887.0000, 'ºC'),
	(277541, 121, '2014-04-01 00:22:43.000000', 'temperatura', 101.0000, 'ºC'),
	(277542, 121, '2014-04-01 00:22:44.000000', 'temperatura', 247.0000, 'ºC'),
	(277543, 121, '2014-04-01 00:22:45.000000', 'temperatura', 932.0000, 'ºC'),
	(277544, 121, '2014-04-01 00:22:46.000000', 'temperatura', 320.0000, 'ºC'),
	(277545, 121, '2014-04-01 00:22:47.000000', 'temperatura', 6.0000, 'ºC'),
	(277546, 121, '2014-04-01 00:22:48.000000', 'temperatura', 268.0000, 'ºC'),
	(277547, 121, '2014-04-01 00:22:49.000000', 'temperatura', 124.0000, 'ºC'),
	(277548, 121, '2014-04-01 00:22:50.000000', 'temperatura', 1018.0000, 'ºC'),
	(277549, 121, '2014-04-01 00:22:51.000000', 'temperatura', 1116.0000, 'ºC'),
	(277550, 121, '2014-04-01 00:22:52.000000', 'temperatura', 128.0000, 'ºC'),
	(277551, 121, '2014-04-01 00:22:53.000000', 'temperatura', 894.0000, 'ºC'),
	(277552, 121, '2014-04-01 00:22:54.000000', 'temperatura', 485.0000, 'ºC'),
	(277553, 121, '2014-04-01 00:22:55.000000', 'temperatura', 944.0000, 'ºC'),
	(277554, 121, '2014-04-01 00:22:56.000000', 'temperatura', 866.0000, 'ºC'),
	(277555, 121, '2014-04-01 00:22:57.000000', 'temperatura', 299.0000, 'ºC'),
	(277556, 121, '2014-04-01 00:22:58.000000', 'temperatura', 96.0000, 'ºC'),
	(277557, 121, '2014-04-01 00:22:59.000000', 'temperatura', 784.0000, 'ºC'),
	(277558, 121, '2014-04-01 00:23:00.000000', 'temperatura', 31.0000, 'ºC'),
	(277559, 121, '2014-04-01 00:23:01.000000', 'temperatura', 207.0000, 'ºC'),
	(277560, 121, '2014-04-01 00:23:02.000000', 'temperatura', 939.0000, 'ºC'),
	(277561, 121, '2014-04-01 00:23:03.000000', 'temperatura', 475.0000, 'ºC'),
	(277562, 121, '2014-04-01 00:23:04.000000', 'temperatura', 758.0000, 'ºC'),
	(277563, 121, '2014-04-01 00:23:05.000000', 'temperatura', 1164.0000, 'ºC'),
	(277564, 121, '2014-04-01 00:23:06.000000', 'temperatura', 1150.0000, 'ºC'),
	(277565, 121, '2014-04-01 00:23:07.000000', 'temperatura', 1057.0000, 'ºC'),
	(277566, 121, '2014-04-01 00:23:08.000000', 'temperatura', 637.0000, 'ºC'),
	(277567, 121, '2014-04-01 00:23:09.000000', 'temperatura', 15.0000, 'ºC'),
	(277568, 121, '2014-04-01 00:23:10.000000', 'temperatura', 562.0000, 'ºC'),
	(277569, 121, '2014-04-01 00:23:11.000000', 'temperatura', 366.0000, 'ºC'),
	(277570, 121, '2014-04-01 00:23:12.000000', 'temperatura', 147.0000, 'ºC'),
	(277571, 121, '2014-04-01 00:23:13.000000', 'temperatura', 835.0000, 'ºC'),
	(277572, 121, '2014-04-01 00:23:14.000000', 'temperatura', 135.0000, 'ºC'),
	(277573, 121, '2014-04-01 00:23:15.000000', 'temperatura', 571.0000, 'ºC'),
	(277574, 121, '2014-04-01 00:23:16.000000', 'temperatura', 52.0000, 'ºC'),
	(277575, 121, '2014-04-01 00:23:17.000000', 'temperatura', 944.0000, 'ºC'),
	(277576, 121, '2014-04-01 00:23:18.000000', 'temperatura', 967.0000, 'ºC'),
	(277577, 121, '2014-04-01 00:23:19.000000', 'temperatura', 805.0000, 'ºC'),
	(277578, 121, '2014-04-01 00:23:20.000000', 'temperatura', 1122.0000, 'ºC'),
	(277579, 121, '2014-04-01 00:23:21.000000', 'temperatura', 796.0000, 'ºC'),
	(277580, 121, '2014-04-01 00:23:22.000000', 'temperatura', 613.0000, 'ºC'),
	(277581, 121, '2014-04-01 00:23:23.000000', 'temperatura', 677.0000, 'ºC'),
	(277582, 121, '2014-04-01 00:23:24.000000', 'temperatura', 346.0000, 'ºC'),
	(277583, 121, '2014-04-01 00:23:25.000000', 'temperatura', 901.0000, 'ºC'),
	(277584, 121, '2014-04-01 00:23:26.000000', 'temperatura', 1068.0000, 'ºC'),
	(277585, 121, '2014-04-01 00:23:27.000000', 'temperatura', 236.0000, 'ºC'),
	(277586, 121, '2014-04-01 00:23:28.000000', 'temperatura', 376.0000, 'ºC'),
	(277587, 121, '2014-04-01 00:23:29.000000', 'temperatura', 1175.0000, 'ºC'),
	(277588, 121, '2014-04-01 00:23:30.000000', 'temperatura', 1144.0000, 'ºC'),
	(277589, 121, '2014-04-01 00:23:31.000000', 'temperatura', 998.0000, 'ºC'),
	(277590, 121, '2014-04-01 00:23:32.000000', 'temperatura', 359.0000, 'ºC'),
	(277591, 121, '2014-04-01 00:23:33.000000', 'temperatura', 3.0000, 'ºC'),
	(277592, 121, '2014-04-01 00:23:34.000000', 'temperatura', 135.0000, 'ºC'),
	(277593, 121, '2014-04-01 00:23:35.000000', 'temperatura', 668.0000, 'ºC'),
	(277594, 121, '2014-04-01 00:23:36.000000', 'temperatura', 535.0000, 'ºC'),
	(277595, 121, '2014-04-01 00:23:37.000000', 'temperatura', 670.0000, 'ºC'),
	(277596, 121, '2014-04-01 00:23:38.000000', 'temperatura', 549.0000, 'ºC'),
	(277597, 121, '2014-04-01 00:23:39.000000', 'temperatura', 732.0000, 'ºC'),
	(277598, 121, '2014-04-01 00:23:40.000000', 'temperatura', 816.0000, 'ºC'),
	(277599, 121, '2014-04-01 00:23:41.000000', 'temperatura', 685.0000, 'ºC'),
	(277600, 121, '2014-04-01 00:23:42.000000', 'temperatura', 978.0000, 'ºC'),
	(277601, 121, '2014-04-01 00:23:43.000000', 'temperatura', 434.0000, 'ºC'),
	(277602, 121, '2014-04-01 00:23:44.000000', 'temperatura', 435.0000, 'ºC'),
	(277603, 121, '2014-04-01 00:23:45.000000', 'temperatura', 876.0000, 'ºC'),
	(277604, 121, '2014-04-01 00:23:46.000000', 'temperatura', 673.0000, 'ºC'),
	(277605, 121, '2014-04-01 00:23:47.000000', 'temperatura', 738.0000, 'ºC'),
	(277606, 121, '2014-04-01 00:23:48.000000', 'temperatura', 470.0000, 'ºC'),
	(277607, 121, '2014-04-01 00:23:49.000000', 'temperatura', 137.0000, 'ºC'),
	(277608, 121, '2014-04-01 00:23:50.000000', 'temperatura', 478.0000, 'ºC'),
	(277609, 121, '2014-04-01 00:23:51.000000', 'temperatura', 779.0000, 'ºC'),
	(277610, 121, '2014-04-01 00:23:52.000000', 'temperatura', 59.0000, 'ºC'),
	(277611, 121, '2014-04-01 00:23:53.000000', 'temperatura', 360.0000, 'ºC'),
	(277612, 121, '2014-04-01 00:23:54.000000', 'temperatura', 423.0000, 'ºC'),
	(277613, 121, '2014-04-01 00:23:55.000000', 'temperatura', 1038.0000, 'ºC'),
	(277614, 121, '2014-04-01 00:23:56.000000', 'temperatura', 319.0000, 'ºC'),
	(277615, 121, '2014-04-01 00:23:57.000000', 'temperatura', 882.0000, 'ºC'),
	(277616, 121, '2014-04-01 00:23:58.000000', 'temperatura', 1054.0000, 'ºC'),
	(277617, 121, '2014-04-01 00:23:59.000000', 'temperatura', 225.0000, 'ºC'),
	(277618, 121, '2014-04-01 00:24:00.000000', 'temperatura', 362.0000, 'ºC'),
	(277619, 121, '2014-04-01 00:24:01.000000', 'temperatura', 1138.0000, 'ºC'),
	(277620, 121, '2014-04-01 00:24:02.000000', 'temperatura', 1003.0000, 'ºC'),
	(277621, 121, '2014-04-01 00:24:03.000000', 'temperatura', 403.0000, 'ºC'),
	(277622, 121, '2014-04-01 00:24:04.000000', 'temperatura', 204.0000, 'ºC'),
	(277623, 121, '2014-04-01 00:24:05.000000', 'temperatura', 1012.0000, 'ºC'),
	(277624, 121, '2014-04-01 00:24:06.000000', 'temperatura', 847.0000, 'ºC'),
	(277625, 121, '2014-04-01 00:24:07.000000', 'temperatura', 2.0000, 'ºC'),
	(277626, 121, '2014-04-01 00:24:08.000000', 'temperatura', 1069.0000, 'ºC'),
	(277627, 121, '2014-04-01 00:24:09.000000', 'temperatura', 539.0000, 'ºC'),
	(277628, 121, '2014-04-01 00:24:10.000000', 'temperatura', 688.0000, 'ºC'),
	(277629, 121, '2014-04-01 00:24:11.000000', 'temperatura', 626.0000, 'ºC'),
	(277630, 121, '2014-04-01 00:24:12.000000', 'temperatura', 1065.0000, 'ºC'),
	(277631, 121, '2014-04-01 00:24:13.000000', 'temperatura', 1046.0000, 'ºC'),
	(277632, 121, '2014-04-01 00:24:14.000000', 'temperatura', 835.0000, 'ºC'),
	(277633, 121, '2014-04-01 00:24:15.000000', 'temperatura', 1038.0000, 'ºC'),
	(277634, 121, '2014-04-01 00:24:16.000000', 'temperatura', 286.0000, 'ºC'),
	(277635, 121, '2014-04-01 00:24:17.000000', 'temperatura', 717.0000, 'ºC'),
	(277636, 121, '2014-04-01 00:24:18.000000', 'temperatura', 329.0000, 'ºC'),
	(277637, 121, '2014-04-01 00:24:19.000000', 'temperatura', 694.0000, 'ºC'),
	(277638, 121, '2014-04-01 00:24:20.000000', 'temperatura', 84.0000, 'ºC'),
	(277639, 121, '2014-04-01 00:24:21.000000', 'temperatura', 737.0000, 'ºC'),
	(277640, 121, '2014-04-01 00:24:22.000000', 'temperatura', 1033.0000, 'ºC'),
	(277641, 121, '2014-04-01 00:24:23.000000', 'temperatura', 554.0000, 'ºC'),
	(277642, 121, '2014-04-01 00:24:24.000000', 'temperatura', 871.0000, 'ºC'),
	(277643, 121, '2014-04-01 00:24:25.000000', 'temperatura', 293.0000, 'ºC'),
	(277644, 121, '2014-04-01 00:24:26.000000', 'temperatura', 52.0000, 'ºC'),
	(277645, 121, '2014-04-01 00:24:27.000000', 'temperatura', 583.0000, 'ºC'),
	(277646, 121, '2014-04-01 00:24:28.000000', 'temperatura', 361.0000, 'ºC'),
	(277647, 121, '2014-04-01 00:24:29.000000', 'temperatura', 55.0000, 'ºC'),
	(277648, 121, '2014-04-01 00:24:30.000000', 'temperatura', 391.0000, 'ºC'),
	(277649, 121, '2014-04-01 00:24:31.000000', 'temperatura', 590.0000, 'ºC'),
	(277650, 121, '2014-04-01 00:24:32.000000', 'temperatura', 579.0000, 'ºC'),
	(277651, 121, '2014-04-01 00:24:33.000000', 'temperatura', 1124.0000, 'ºC'),
	(277652, 121, '2014-04-01 00:24:34.000000', 'temperatura', 286.0000, 'ºC'),
	(277653, 121, '2014-04-01 00:24:35.000000', 'temperatura', 458.0000, 'ºC'),
	(277654, 121, '2014-04-01 00:24:36.000000', 'temperatura', 230.0000, 'ºC'),
	(277655, 121, '2014-04-01 00:24:37.000000', 'temperatura', 979.0000, 'ºC'),
	(277656, 121, '2014-04-01 00:24:38.000000', 'temperatura', 603.0000, 'ºC'),
	(277657, 121, '2014-04-01 00:24:39.000000', 'temperatura', 79.0000, 'ºC'),
	(277658, 121, '2014-04-01 00:24:40.000000', 'temperatura', 988.0000, 'ºC'),
	(277659, 121, '2014-04-01 00:24:41.000000', 'temperatura', 1101.0000, 'ºC'),
	(277660, 121, '2014-04-01 00:24:42.000000', 'temperatura', 143.0000, 'ºC'),
	(277661, 121, '2014-04-01 00:24:43.000000', 'temperatura', 1013.0000, 'ºC'),
	(277662, 121, '2014-04-01 00:24:44.000000', 'temperatura', 1035.0000, 'ºC'),
	(277663, 121, '2014-04-01 00:24:45.000000', 'temperatura', 936.0000, 'ºC'),
	(277664, 121, '2014-04-01 00:24:46.000000', 'temperatura', 377.0000, 'ºC'),
	(277665, 121, '2014-04-01 00:24:47.000000', 'temperatura', 278.0000, 'ºC'),
	(277666, 121, '2014-04-01 00:24:48.000000', 'temperatura', 259.0000, 'ºC'),
	(277667, 121, '2014-04-01 00:24:49.000000', 'temperatura', 462.0000, 'ºC'),
	(277668, 121, '2014-04-01 00:24:50.000000', 'temperatura', 332.0000, 'ºC'),
	(277669, 121, '2014-04-01 00:24:51.000000', 'temperatura', 275.0000, 'ºC'),
	(277670, 121, '2014-04-01 00:24:52.000000', 'temperatura', 378.0000, 'ºC'),
	(277671, 121, '2014-04-01 00:24:53.000000', 'temperatura', 1067.0000, 'ºC'),
	(277672, 121, '2014-04-01 00:24:54.000000', 'temperatura', 603.0000, 'ºC'),
	(277673, 121, '2014-04-01 00:24:55.000000', 'temperatura', 1015.0000, 'ºC'),
	(277674, 121, '2014-04-01 00:24:56.000000', 'temperatura', 865.0000, 'ºC'),
	(277675, 121, '2014-04-01 00:24:57.000000', 'temperatura', 82.0000, 'ºC'),
	(277676, 121, '2014-04-01 00:24:58.000000', 'temperatura', 213.0000, 'ºC'),
	(277677, 121, '2014-04-01 00:24:59.000000', 'temperatura', 822.0000, 'ºC'),
	(277678, 121, '2014-04-01 00:25:00.000000', 'temperatura', 1071.0000, 'ºC'),
	(277679, 121, '2014-04-01 00:25:01.000000', 'temperatura', 491.0000, 'ºC'),
	(277680, 121, '2014-04-01 00:25:02.000000', 'temperatura', 439.0000, 'ºC'),
	(277681, 121, '2014-04-01 00:25:03.000000', 'temperatura', 725.0000, 'ºC'),
	(277682, 121, '2014-04-01 00:25:04.000000', 'temperatura', 1108.0000, 'ºC'),
	(277683, 121, '2014-04-01 00:25:05.000000', 'temperatura', 964.0000, 'ºC'),
	(277684, 121, '2014-04-01 00:25:06.000000', 'temperatura', 298.0000, 'ºC'),
	(277685, 121, '2014-04-01 00:25:07.000000', 'temperatura', 997.0000, 'ºC'),
	(277686, 121, '2014-04-01 00:25:08.000000', 'temperatura', 492.0000, 'ºC'),
	(277687, 121, '2014-04-01 00:25:09.000000', 'temperatura', 672.0000, 'ºC'),
	(277688, 121, '2014-04-01 00:25:10.000000', 'temperatura', 682.0000, 'ºC'),
	(277689, 121, '2014-04-01 00:25:11.000000', 'temperatura', 195.0000, 'ºC'),
	(277690, 121, '2014-04-01 00:25:12.000000', 'temperatura', 128.0000, 'ºC'),
	(277691, 121, '2014-04-01 00:25:13.000000', 'temperatura', 58.0000, 'ºC'),
	(277692, 121, '2014-04-01 00:25:14.000000', 'temperatura', 1105.0000, 'ºC'),
	(277693, 121, '2014-04-01 00:25:15.000000', 'temperatura', 553.0000, 'ºC'),
	(277694, 121, '2014-04-01 00:25:16.000000', 'temperatura', 649.0000, 'ºC'),
	(277695, 121, '2014-04-01 00:25:17.000000', 'temperatura', 386.0000, 'ºC'),
	(277696, 121, '2014-04-01 00:25:18.000000', 'temperatura', 1183.0000, 'ºC'),
	(277697, 121, '2014-04-01 00:25:19.000000', 'temperatura', 1159.0000, 'ºC'),
	(277698, 121, '2014-04-01 00:25:20.000000', 'temperatura', 1046.0000, 'ºC'),
	(277699, 121, '2014-04-01 00:25:21.000000', 'temperatura', 553.0000, 'ºC'),
	(277700, 121, '2014-04-01 00:25:22.000000', 'temperatura', 829.0000, 'ºC'),
	(277701, 121, '2014-04-01 00:25:23.000000', 'temperatura', 84.0000, 'ºC'),
	(277702, 121, '2014-04-01 00:25:24.000000', 'temperatura', 335.0000, 'ºC'),
	(277703, 121, '2014-04-01 00:25:25.000000', 'temperatura', 222.0000, 'ºC'),
	(277704, 121, '2014-04-01 00:25:26.000000', 'temperatura', 104.0000, 'ºC'),
	(277705, 121, '2014-04-01 00:25:27.000000', 'temperatura', 1058.0000, 'ºC'),
	(277706, 121, '2014-04-01 00:25:28.000000', 'temperatura', 178.0000, 'ºC'),
	(277707, 121, '2014-04-01 00:25:29.000000', 'temperatura', 116.0000, 'ºC'),
	(277708, 121, '2014-04-01 00:25:30.000000', 'temperatura', 47.0000, 'ºC'),
	(277709, 121, '2014-04-01 00:25:31.000000', 'temperatura', 1087.0000, 'ºC'),
	(277710, 121, '2014-04-01 00:25:32.000000', 'temperatura', 494.0000, 'ºC'),
	(277711, 121, '2014-04-01 00:25:33.000000', 'temperatura', 408.0000, 'ºC'),
	(277712, 121, '2014-04-01 00:25:34.000000', 'temperatura', 560.0000, 'ºC'),
	(277713, 121, '2014-04-01 00:25:35.000000', 'temperatura', 376.0000, 'ºC'),
	(277714, 121, '2014-04-01 00:25:36.000000', 'temperatura', 201.0000, 'ºC'),
	(277715, 121, '2014-04-01 00:25:37.000000', 'temperatura', 1079.0000, 'ºC'),
	(277716, 121, '2014-04-01 00:25:38.000000', 'temperatura', 1192.0000, 'ºC'),
	(277717, 121, '2014-04-01 00:25:39.000000', 'temperatura', 324.0000, 'ºC'),
	(277718, 121, '2014-04-01 00:25:40.000000', 'temperatura', 444.0000, 'ºC'),
	(277719, 121, '2014-04-01 00:25:41.000000', 'temperatura', 48.0000, 'ºC'),
	(277720, 121, '2014-04-01 00:25:42.000000', 'temperatura', 107.0000, 'ºC'),
	(277721, 121, '2014-04-01 00:25:43.000000', 'temperatura', 391.0000, 'ºC'),
	(277722, 121, '2014-04-01 00:25:44.000000', 'temperatura', 437.0000, 'ºC'),
	(277723, 121, '2014-04-01 00:25:45.000000', 'temperatura', 1010.0000, 'ºC'),
	(277724, 121, '2014-04-01 00:25:46.000000', 'temperatura', 140.0000, 'ºC'),
	(277725, 121, '2014-04-01 00:25:47.000000', 'temperatura', 72.0000, 'ºC'),
	(277726, 121, '2014-04-01 00:25:48.000000', 'temperatura', 1138.0000, 'ºC'),
	(277727, 121, '2014-04-01 00:25:49.000000', 'temperatura', 677.0000, 'ºC'),
	(277728, 121, '2014-04-01 00:25:50.000000', 'temperatura', 1172.0000, 'ºC'),
	(277729, 121, '2014-04-01 00:25:51.000000', 'temperatura', 230.0000, 'ºC'),
	(277730, 121, '2014-04-01 00:25:52.000000', 'temperatura', 33.0000, 'ºC'),
	(277731, 121, '2014-04-01 00:25:53.000000', 'temperatura', 674.0000, 'ºC'),
	(277732, 121, '2014-04-01 00:25:54.000000', 'temperatura', 875.0000, 'ºC'),
	(277733, 121, '2014-04-01 00:25:55.000000', 'temperatura', 1151.0000, 'ºC'),
	(277734, 121, '2014-04-01 00:25:56.000000', 'temperatura', 732.0000, 'ºC'),
	(277735, 121, '2014-04-01 00:25:57.000000', 'temperatura', 206.0000, 'ºC'),
	(277736, 121, '2014-04-01 00:25:58.000000', 'temperatura', 35.0000, 'ºC'),
	(277737, 121, '2014-04-01 00:25:59.000000', 'temperatura', 757.0000, 'ºC'),
	(277738, 121, '2014-04-01 00:26:00.000000', 'temperatura', 83.0000, 'ºC'),
	(277739, 121, '2014-04-01 00:26:01.000000', 'temperatura', 541.0000, 'ºC'),
	(277740, 121, '2014-04-01 00:26:02.000000', 'temperatura', 58.0000, 'ºC'),
	(277741, 121, '2014-04-01 00:26:03.000000', 'temperatura', 1067.0000, 'ºC'),
	(277742, 121, '2014-04-01 00:26:04.000000', 'temperatura', 362.0000, 'ºC'),
	(277743, 121, '2014-04-01 00:26:05.000000', 'temperatura', 1010.0000, 'ºC'),
	(277744, 121, '2014-04-01 00:26:06.000000', 'temperatura', 365.0000, 'ºC'),
	(277745, 121, '2014-04-01 00:26:07.000000', 'temperatura', 1193.0000, 'ºC'),
	(277746, 121, '2014-04-01 00:26:08.000000', 'temperatura', 74.0000, 'ºC'),
	(277747, 121, '2014-04-01 00:26:09.000000', 'temperatura', 389.0000, 'ºC'),
	(277748, 121, '2014-04-01 00:26:10.000000', 'temperatura', 526.0000, 'ºC'),
	(277749, 121, '2014-04-01 00:26:11.000000', 'temperatura', 263.0000, 'ºC'),
	(277750, 121, '2014-04-01 00:26:12.000000', 'temperatura', 937.0000, 'ºC'),
	(277751, 121, '2014-04-01 00:26:13.000000', 'temperatura', 297.0000, 'ºC'),
	(277752, 121, '2014-04-01 00:26:14.000000', 'temperatura', 1073.0000, 'ºC'),
	(277753, 121, '2014-04-01 00:26:15.000000', 'temperatura', 875.0000, 'ºC'),
	(277754, 121, '2014-04-01 00:26:16.000000', 'temperatura', 1156.0000, 'ºC'),
	(277755, 121, '2014-04-01 00:26:17.000000', 'temperatura', 757.0000, 'ºC'),
	(277756, 121, '2014-04-01 00:26:18.000000', 'temperatura', 317.0000, 'ºC'),
	(277757, 121, '2014-04-01 00:26:19.000000', 'temperatura', 515.0000, 'ºC'),
	(277758, 121, '2014-04-01 00:26:20.000000', 'temperatura', 425.0000, 'ºC'),
	(277759, 121, '2014-04-01 00:26:21.000000', 'temperatura', 580.0000, 'ºC'),
	(277760, 121, '2014-04-01 00:26:22.000000', 'temperatura', 425.0000, 'ºC'),
	(277761, 121, '2014-04-01 00:26:23.000000', 'temperatura', 387.0000, 'ºC'),
	(277762, 121, '2014-04-01 00:26:24.000000', 'temperatura', 658.0000, 'ºC'),
	(277763, 121, '2014-04-01 00:26:25.000000', 'temperatura', 930.0000, 'ºC'),
	(277764, 121, '2014-04-01 00:26:26.000000', 'temperatura', 276.0000, 'ºC'),
	(277765, 121, '2014-04-01 00:26:27.000000', 'temperatura', 993.0000, 'ºC'),
	(277766, 121, '2014-04-01 00:26:28.000000', 'temperatura', 534.0000, 'ºC'),
	(277767, 121, '2014-04-01 00:26:29.000000', 'temperatura', 894.0000, 'ºC'),
	(277768, 121, '2014-04-01 00:26:30.000000', 'temperatura', 468.0000, 'ºC'),
	(277769, 121, '2014-04-01 00:26:31.000000', 'temperatura', 857.0000, 'ºC'),
	(277770, 121, '2014-04-01 00:26:32.000000', 'temperatura', 484.0000, 'ºC'),
	(277771, 121, '2014-04-01 00:26:33.000000', 'temperatura', 1048.0000, 'ºC'),
	(277772, 121, '2014-04-01 00:26:34.000000', 'temperatura', 190.0000, 'ºC'),
	(277773, 121, '2014-04-01 00:26:35.000000', 'temperatura', 208.0000, 'ºC'),
	(277774, 121, '2014-04-01 00:26:36.000000', 'temperatura', 468.0000, 'ºC'),
	(277775, 121, '2014-04-01 00:26:37.000000', 'temperatura', 516.0000, 'ºC'),
	(277776, 121, '2014-04-01 00:26:38.000000', 'temperatura', 1177.0000, 'ºC'),
	(277777, 121, '2014-04-01 00:26:39.000000', 'temperatura', 739.0000, 'ºC'),
	(277778, 121, '2014-04-01 00:26:40.000000', 'temperatura', 163.0000, 'ºC'),
	(277779, 121, '2014-04-01 00:26:41.000000', 'temperatura', 998.0000, 'ºC'),
	(277780, 121, '2014-04-01 00:26:42.000000', 'temperatura', 902.0000, 'ºC'),
	(277781, 121, '2014-04-01 00:26:43.000000', 'temperatura', 317.0000, 'ºC'),
	(277782, 121, '2014-04-01 00:26:44.000000', 'temperatura', 78.0000, 'ºC'),
	(277783, 121, '2014-04-01 00:26:45.000000', 'temperatura', 638.0000, 'ºC'),
	(277784, 121, '2014-04-01 00:26:46.000000', 'temperatura', 559.0000, 'ºC'),
	(277785, 121, '2014-04-01 00:26:47.000000', 'temperatura', 881.0000, 'ºC'),
	(277786, 121, '2014-04-01 00:26:48.000000', 'temperatura', 329.0000, 'ºC'),
	(277787, 121, '2014-04-01 00:26:49.000000', 'temperatura', 201.0000, 'ºC'),
	(277788, 121, '2014-04-01 00:26:50.000000', 'temperatura', 19.0000, 'ºC'),
	(277789, 121, '2014-04-01 00:26:51.000000', 'temperatura', 692.0000, 'ºC'),
	(277790, 121, '2014-04-01 00:26:52.000000', 'temperatura', 1003.0000, 'ºC'),
	(277791, 121, '2014-04-01 00:26:53.000000', 'temperatura', 541.0000, 'ºC'),
	(277792, 121, '2014-04-01 00:26:54.000000', 'temperatura', 895.0000, 'ºC'),
	(277793, 121, '2014-04-01 00:26:55.000000', 'temperatura', 455.0000, 'ºC'),
	(277794, 121, '2014-04-01 00:26:56.000000', 'temperatura', 789.0000, 'ºC'),
	(277795, 121, '2014-04-01 00:26:57.000000', 'temperatura', 182.0000, 'ºC'),
	(277796, 121, '2014-04-01 00:26:58.000000', 'temperatura', 941.0000, 'ºC'),
	(277797, 121, '2014-04-01 00:26:59.000000', 'temperatura', 562.0000, 'ºC'),
	(277798, 121, '2014-04-01 00:27:00.000000', 'temperatura', 1186.0000, 'ºC'),
	(277799, 121, '2014-04-01 00:27:01.000000', 'temperatura', 645.0000, 'ºC'),
	(277800, 121, '2014-04-01 00:27:02.000000', 'temperatura', 869.0000, 'ºC'),
	(277801, 121, '2014-04-01 00:27:03.000000', 'temperatura', 11.0000, 'ºC'),
	(277802, 121, '2014-04-01 00:27:04.000000', 'temperatura', 1047.0000, 'ºC'),
	(277803, 121, '2014-04-01 00:27:05.000000', 'temperatura', 404.0000, 'ºC'),
	(277804, 121, '2014-04-01 00:27:06.000000', 'temperatura', 79.0000, 'ºC'),
	(277805, 121, '2014-04-01 00:27:07.000000', 'temperatura', 383.0000, 'ºC'),
	(277806, 121, '2014-04-01 00:27:08.000000', 'temperatura', 481.0000, 'ºC'),
	(277807, 121, '2014-04-01 00:27:09.000000', 'temperatura', 54.0000, 'ºC'),
	(277808, 121, '2014-04-01 00:27:10.000000', 'temperatura', 26.0000, 'ºC'),
	(277809, 121, '2014-04-01 00:27:11.000000', 'temperatura', 1172.0000, 'ºC'),
	(277810, 121, '2014-04-01 00:27:12.000000', 'temperatura', 979.0000, 'ºC'),
	(277811, 121, '2014-04-01 00:27:13.000000', 'temperatura', 181.0000, 'ºC'),
	(277812, 121, '2014-04-01 00:27:14.000000', 'temperatura', 368.0000, 'ºC'),
	(277813, 121, '2014-04-01 00:27:15.000000', 'temperatura', 97.0000, 'ºC'),
	(277814, 121, '2014-04-01 00:27:16.000000', 'temperatura', 582.0000, 'ºC'),
	(277815, 121, '2014-04-01 00:27:17.000000', 'temperatura', 220.0000, 'ºC'),
	(277816, 121, '2014-04-01 00:27:18.000000', 'temperatura', 553.0000, 'ºC'),
	(277817, 121, '2014-04-01 00:27:19.000000', 'temperatura', 906.0000, 'ºC'),
	(277818, 121, '2014-04-01 00:27:20.000000', 'temperatura', 472.0000, 'ºC'),
	(277819, 121, '2014-04-01 00:27:21.000000', 'temperatura', 841.0000, 'ºC'),
	(277820, 121, '2014-04-01 00:27:22.000000', 'temperatura', 392.0000, 'ºC'),
	(277821, 121, '2014-04-01 00:27:23.000000', 'temperatura', 636.0000, 'ºC'),
	(277822, 121, '2014-04-01 00:27:24.000000', 'temperatura', 804.0000, 'ºC'),
	(277823, 121, '2014-04-01 00:27:25.000000', 'temperatura', 912.0000, 'ºC'),
	(277824, 121, '2014-04-01 00:27:26.000000', 'temperatura', 947.0000, 'ºC'),
	(277825, 121, '2014-04-01 00:27:27.000000', 'temperatura', 802.0000, 'ºC'),
	(277826, 121, '2014-04-01 00:27:28.000000', 'temperatura', 1171.0000, 'ºC'),
	(277827, 121, '2014-04-01 00:27:29.000000', 'temperatura', 1046.0000, 'ºC'),
	(277828, 121, '2014-04-01 00:27:30.000000', 'temperatura', 520.0000, 'ºC'),
	(277829, 121, '2014-04-01 00:27:31.000000', 'temperatura', 660.0000, 'ºC'),
	(277830, 121, '2014-04-01 00:27:32.000000', 'temperatura', 543.0000, 'ºC'),
	(277831, 121, '2014-04-01 00:27:33.000000', 'temperatura', 733.0000, 'ºC'),
	(277832, 121, '2014-04-01 00:27:34.000000', 'temperatura', 838.0000, 'ºC'),
	(277833, 121, '2014-04-01 00:27:35.000000', 'temperatura', 793.0000, 'ºC'),
	(277834, 121, '2014-04-01 00:27:36.000000', 'temperatura', 251.0000, 'ºC'),
	(277835, 121, '2014-04-01 00:27:37.000000', 'temperatura', 78.0000, 'ºC'),
	(277836, 121, '2014-04-01 00:27:38.000000', 'temperatura', 836.0000, 'ºC'),
	(277837, 121, '2014-04-01 00:27:39.000000', 'temperatura', 348.0000, 'ºC'),
	(277838, 121, '2014-04-01 00:27:40.000000', 'temperatura', 430.0000, 'ºC'),
	(277839, 121, '2014-04-01 00:27:41.000000', 'temperatura', 1107.0000, 'ºC'),
	(277840, 121, '2014-04-01 00:27:42.000000', 'temperatura', 646.0000, 'ºC'),
	(277841, 121, '2014-04-01 00:27:43.000000', 'temperatura', 1109.0000, 'ºC'),
	(277842, 121, '2014-04-01 00:27:44.000000', 'temperatura', 8.0000, 'ºC'),
	(277843, 121, '2014-04-01 00:27:45.000000', 'temperatura', 314.0000, 'ºC'),
	(277844, 121, '2014-04-01 00:27:46.000000', 'temperatura', 347.0000, 'ºC'),
	(277845, 121, '2014-04-01 00:27:47.000000', 'temperatura', 791.0000, 'ºC'),
	(277846, 121, '2014-04-01 00:27:48.000000', 'temperatura', 515.0000, 'ºC'),
	(277847, 121, '2014-04-01 00:27:49.000000', 'temperatura', 202.0000, 'ºC'),
	(277848, 121, '2014-04-01 00:27:50.000000', 'temperatura', 665.0000, 'ºC'),
	(277849, 121, '2014-04-01 00:27:51.000000', 'temperatura', 321.0000, 'ºC'),
	(277850, 121, '2014-04-01 00:27:52.000000', 'temperatura', 808.0000, 'ºC'),
	(277851, 121, '2014-04-01 00:27:53.000000', 'temperatura', 680.0000, 'ºC'),
	(277852, 121, '2014-04-01 00:27:54.000000', 'temperatura', 977.0000, 'ºC'),
	(277853, 121, '2014-04-01 00:27:55.000000', 'temperatura', 446.0000, 'ºC'),
	(277854, 121, '2014-04-01 00:27:56.000000', 'temperatura', 499.0000, 'ºC'),
	(277855, 121, '2014-04-01 00:27:57.000000', 'temperatura', 1156.0000, 'ºC'),
	(277856, 121, '2014-04-01 00:27:58.000000', 'temperatura', 683.0000, 'ºC'),
	(277857, 121, '2014-04-01 00:27:59.000000', 'temperatura', 1150.0000, 'ºC'),
	(277858, 121, '2014-04-01 00:28:00.000000', 'temperatura', 100.0000, 'ºC'),
	(277859, 121, '2014-04-01 00:28:01.000000', 'temperatura', 649.0000, 'ºC'),
	(277860, 121, '2014-04-01 00:28:02.000000', 'temperatura', 546.0000, 'ºC'),
	(277861, 121, '2014-04-01 00:28:03.000000', 'temperatura', 784.0000, 'ºC'),
	(277862, 121, '2014-04-01 00:28:04.000000', 'temperatura', 1081.0000, 'ºC'),
	(277863, 121, '2014-04-01 00:28:05.000000', 'temperatura', 653.0000, 'ºC'),
	(277864, 121, '2014-04-01 00:28:06.000000', 'temperatura', 25.0000, 'ºC'),
	(277865, 121, '2014-04-01 00:28:07.000000', 'temperatura', 564.0000, 'ºC'),
	(277866, 121, '2014-04-01 00:28:08.000000', 'temperatura', 348.0000, 'ºC'),
	(277867, 121, '2014-04-01 00:28:09.000000', 'temperatura', 46.0000, 'ºC'),
	(277868, 121, '2014-04-01 00:28:10.000000', 'temperatura', 388.0000, 'ºC'),
	(277869, 121, '2014-04-01 00:28:11.000000', 'temperatura', 602.0000, 'ºC'),
	(277870, 121, '2014-04-01 00:28:12.000000', 'temperatura', 646.0000, 'ºC'),
	(277871, 121, '2014-04-01 00:28:13.000000', 'temperatura', 223.0000, 'ºC'),
	(277872, 121, '2014-04-01 00:28:14.000000', 'temperatura', 379.0000, 'ºC'),
	(277873, 121, '2014-04-01 00:28:15.000000', 'temperatura', 28.0000, 'ºC'),
	(277874, 121, '2014-04-01 00:28:16.000000', 'temperatura', 201.0000, 'ºC'),
	(277875, 121, '2014-04-01 00:28:17.000000', 'temperatura', 922.0000, 'ºC'),
	(277876, 121, '2014-04-01 00:28:18.000000', 'temperatura', 407.0000, 'ºC'),
	(277877, 121, '2014-04-01 00:28:19.000000', 'temperatura', 472.0000, 'ºC'),
	(277878, 121, '2014-04-01 00:28:20.000000', 'temperatura', 1138.0000, 'ºC'),
	(277879, 121, '2014-04-01 00:28:21.000000', 'temperatura', 673.0000, 'ºC'),
	(277880, 121, '2014-04-01 00:28:22.000000', 'temperatura', 1155.0000, 'ºC'),
	(277881, 121, '2014-04-01 00:28:23.000000', 'temperatura', 153.0000, 'ºC'),
	(277882, 121, '2014-04-01 00:28:24.000000', 'temperatura', 903.0000, 'ºC'),
	(277883, 121, '2014-04-01 00:28:25.000000', 'temperatura', 454.0000, 'ºC'),
	(277884, 121, '2014-04-01 00:28:26.000000', 'temperatura', 762.0000, 'ºC'),
	(277885, 121, '2014-04-01 00:28:27.000000', 'temperatura', 49.0000, 'ºC'),
	(277886, 121, '2014-04-01 00:28:28.000000', 'temperatura', 358.0000, 'ºC'),
	(277887, 121, '2014-04-01 00:28:29.000000', 'temperatura', 442.0000, 'ºC'),
	(277888, 121, '2014-04-01 00:28:30.000000', 'temperatura', 1140.0000, 'ºC'),
	(277889, 121, '2014-04-01 00:28:31.000000', 'temperatura', 773.0000, 'ºC'),
	(277890, 121, '2014-04-01 00:28:32.000000', 'temperatura', 446.0000, 'ºC'),
	(277891, 121, '2014-04-01 00:28:33.000000', 'temperatura', 1113.0000, 'ºC'),
	(277892, 121, '2014-04-01 00:28:34.000000', 'temperatura', 625.0000, 'ºC'),
	(277893, 121, '2014-04-01 00:28:35.000000', 'temperatura', 987.0000, 'ºC'),
	(277894, 121, '2014-04-01 00:28:36.000000', 'temperatura', 659.0000, 'ºC'),
	(277895, 121, '2014-04-01 00:28:37.000000', 'temperatura', 334.0000, 'ºC'),
	(277896, 121, '2014-04-01 00:28:38.000000', 'temperatura', 896.0000, 'ºC'),
	(277897, 121, '2014-04-01 00:28:39.000000', 'temperatura', 1077.0000, 'ºC'),
	(277898, 121, '2014-04-01 00:28:40.000000', 'temperatura', 299.0000, 'ºC'),
	(277899, 121, '2014-04-01 00:28:41.000000', 'temperatura', 662.0000, 'ºC'),
	(277900, 121, '2014-04-01 00:28:42.000000', 'temperatura', 16.0000, 'ºC'),
	(277901, 121, '2014-04-01 00:28:43.000000', 'temperatura', 494.0000, 'ºC'),
	(277902, 121, '2014-04-01 00:28:44.000000', 'temperatura', 20.0000, 'ºC'),
	(277903, 121, '2014-04-01 00:28:45.000000', 'temperatura', 1021.0000, 'ºC'),
	(277904, 121, '2014-04-01 00:28:46.000000', 'temperatura', 246.0000, 'ºC'),
	(277905, 121, '2014-04-01 00:28:47.000000', 'temperatura', 566.0000, 'ºC'),
	(277906, 121, '2014-04-01 00:28:48.000000', 'temperatura', 894.0000, 'ºC'),
	(277907, 121, '2014-04-01 00:28:49.000000', 'temperatura', 370.0000, 'ºC'),
	(277908, 121, '2014-04-01 00:28:50.000000', 'temperatura', 370.0000, 'ºC'),
	(277909, 121, '2014-04-01 00:28:51.000000', 'temperatura', 739.0000, 'ºC'),
	(277910, 121, '2014-04-01 00:28:52.000000', 'temperatura', 186.0000, 'ºC'),
	(277911, 121, '2014-04-01 00:28:53.000000', 'temperatura', 1115.0000, 'ºC'),
	(277912, 121, '2014-04-01 00:28:54.000000', 'temperatura', 216.0000, 'ºC'),
	(277913, 121, '2014-04-01 00:28:55.000000', 'temperatura', 136.0000, 'ºC'),
	(277914, 121, '2014-04-01 00:28:56.000000', 'temperatura', 31.0000, 'ºC'),
	(277915, 121, '2014-04-01 00:28:57.000000', 'temperatura', 949.0000, 'ºC'),
	(277916, 121, '2014-04-01 00:28:58.000000', 'temperatura', 1053.0000, 'ºC'),
	(277917, 121, '2014-04-01 00:28:59.000000', 'temperatura', 18.0000, 'ºC'),
	(277918, 121, '2014-04-01 00:29:00.000000', 'temperatura', 532.0000, 'ºC'),
	(277919, 121, '2014-04-01 00:29:01.000000', 'temperatura', 205.0000, 'ºC'),
	(277920, 121, '2014-04-01 00:29:02.000000', 'temperatura', 631.0000, 'ºC'),
	(277921, 121, '2014-04-01 00:29:03.000000', 'temperatura', 140.0000, 'ºC'),
	(277922, 121, '2014-04-01 00:29:04.000000', 'temperatura', 8.0000, 'ºC'),
	(277923, 121, '2014-04-01 00:29:05.000000', 'temperatura', 819.0000, 'ºC'),
	(277924, 121, '2014-04-01 00:29:06.000000', 'temperatura', 471.0000, 'ºC'),
	(277925, 121, '2014-04-01 00:29:07.000000', 'temperatura', 1098.0000, 'ºC'),
	(277926, 121, '2014-04-01 00:29:08.000000', 'temperatura', 478.0000, 'ºC'),
	(277927, 121, '2014-04-01 00:29:09.000000', 'temperatura', 298.0000, 'ºC'),
	(277928, 121, '2014-04-01 00:29:10.000000', 'temperatura', 57.0000, 'ºC'),
	(277929, 121, '2014-04-01 00:29:11.000000', 'temperatura', 592.0000, 'ºC'),
	(277930, 121, '2014-04-01 00:29:12.000000', 'temperatura', 388.0000, 'ºC'),
	(277931, 121, '2014-04-01 00:29:13.000000', 'temperatura', 166.0000, 'ºC'),
	(277932, 121, '2014-04-01 00:29:14.000000', 'temperatura', 867.0000, 'ºC'),
	(277933, 121, '2014-04-01 00:29:15.000000', 'temperatura', 235.0000, 'ºC'),
	(277934, 121, '2014-04-01 00:29:16.000000', 'temperatura', 977.0000, 'ºC'),
	(277935, 121, '2014-04-01 00:29:17.000000', 'temperatura', 580.0000, 'ºC'),
	(277936, 121, '2014-04-01 00:29:18.000000', 'temperatura', 1171.0000, 'ºC'),
	(277937, 121, '2014-04-01 00:29:19.000000', 'temperatura', 513.0000, 'ºC'),
	(277938, 121, '2014-04-01 00:29:20.000000', 'temperatura', 251.0000, 'ºC'),
	(277939, 121, '2014-04-01 00:29:21.000000', 'temperatura', 920.0000, 'ºC'),
	(277940, 121, '2014-04-01 00:29:22.000000', 'temperatura', 247.0000, 'ºC'),
	(277941, 121, '2014-04-01 00:29:23.000000', 'temperatura', 877.0000, 'ºC'),
	(277942, 121, '2014-04-01 00:29:24.000000', 'temperatura', 42.0000, 'ºC'),
	(277943, 121, '2014-04-01 00:29:25.000000', 'temperatura', 1181.0000, 'ºC'),
	(277944, 121, '2014-04-01 00:29:26.000000', 'temperatura', 978.0000, 'ºC'),
	(277945, 121, '2014-04-01 00:29:27.000000', 'temperatura', 146.0000, 'ºC'),
	(277946, 121, '2014-04-01 00:29:28.000000', 'temperatura', 199.0000, 'ºC'),
	(277947, 121, '2014-04-01 00:29:29.000000', 'temperatura', 557.0000, 'ºC'),
	(277948, 121, '2014-04-01 00:29:30.000000', 'temperatura', 989.0000, 'ºC'),
	(277949, 121, '2014-04-01 00:29:31.000000', 'temperatura', 874.0000, 'ºC'),
	(277950, 121, '2014-04-01 00:29:32.000000', 'temperatura', 202.0000, 'ºC'),
	(277951, 121, '2014-04-01 00:29:33.000000', 'temperatura', 791.0000, 'ºC'),
	(277952, 121, '2014-04-01 00:29:34.000000', 'temperatura', 948.0000, 'ºC'),
	(277953, 121, '2014-04-01 00:29:35.000000', 'temperatura', 1168.0000, 'ºC'),
	(277954, 121, '2014-04-01 00:29:36.000000', 'temperatura', 596.0000, 'ºC'),
	(277955, 121, '2014-04-01 00:29:37.000000', 'temperatura', 677.0000, 'ºC'),
	(277956, 121, '2014-04-01 00:29:38.000000', 'temperatura', 399.0000, 'ºC'),
	(277957, 121, '2014-04-01 00:29:39.000000', 'temperatura', 1162.0000, 'ºC'),
	(277958, 121, '2014-04-01 00:29:40.000000', 'temperatura', 1015.0000, 'ºC'),
	(277959, 121, '2014-04-01 00:29:41.000000', 'temperatura', 390.0000, 'ºC'),
	(277960, 121, '2014-04-01 00:29:42.000000', 'temperatura', 107.0000, 'ºC'),
	(277961, 121, '2014-04-01 00:29:43.000000', 'temperatura', 562.0000, 'ºC'),
	(277962, 121, '2014-04-01 00:29:44.000000', 'temperatura', 91.0000, 'ºC'),
	(277963, 121, '2014-04-01 00:29:45.000000', 'temperatura', 1168.0000, 'ºC'),
	(277964, 121, '2014-04-01 00:29:46.000000', 'temperatura', 769.0000, 'ºC'),
	(277965, 121, '2014-04-01 00:29:47.000000', 'temperatura', 343.0000, 'ºC'),
	(277966, 121, '2014-04-01 00:29:48.000000', 'temperatura', 606.0000, 'ºC'),
	(277967, 121, '2014-04-01 00:29:49.000000', 'temperatura', 803.0000, 'ºC'),
	(277968, 121, '2014-04-01 00:29:50.000000', 'temperatura', 996.0000, 'ºC'),
	(277969, 121, '2014-04-01 00:29:51.000000', 'temperatura', 172.0000, 'ºC'),
	(277970, 121, '2014-04-01 00:29:52.000000', 'temperatura', 274.0000, 'ºC'),
	(277971, 121, '2014-04-01 00:29:53.000000', 'temperatura', 855.0000, 'ºC'),
	(277972, 121, '2014-04-01 00:29:54.000000', 'temperatura', 1054.0000, 'ºC'),
	(277973, 121, '2014-04-01 00:29:55.000000', 'temperatura', 306.0000, 'ºC'),
	(277974, 121, '2014-04-01 00:29:56.000000', 'temperatura', 769.0000, 'ºC'),
	(277975, 121, '2014-04-01 00:29:57.000000', 'temperatura', 525.0000, 'ºC'),
	(277976, 121, '2014-04-01 00:29:58.000000', 'temperatura', 319.0000, 'ºC'),
	(277977, 121, '2014-04-01 00:29:59.000000', 'temperatura', 20.0000, 'ºC'),
	(277978, 121, '2014-04-01 00:30:00.000000', 'temperatura', 346.0000, 'ºC'),
	(277979, 121, '2014-04-01 00:30:01.000000', 'temperatura', 470.0000, 'ºC'),
	(277980, 121, '2014-04-01 00:30:02.000000', 'temperatura', 112.0000, 'ºC'),
	(277981, 121, '2014-04-01 00:30:03.000000', 'temperatura', 351.0000, 'ºC'),
	(277982, 121, '2014-04-01 00:30:04.000000', 'temperatura', 221.0000, 'ºC'),
	(277983, 121, '2014-04-01 00:30:05.000000', 'temperatura', 52.0000, 'ºC'),
	(277984, 121, '2014-04-01 00:30:06.000000', 'temperatura', 798.0000, 'ºC'),
	(277985, 121, '2014-04-01 00:30:07.000000', 'temperatura', 233.0000, 'ºC'),
	(277986, 121, '2014-04-01 00:30:08.000000', 'temperatura', 1172.0000, 'ºC'),
	(277987, 121, '2014-04-01 00:30:09.000000', 'temperatura', 364.0000, 'ºC'),
	(277988, 121, '2014-04-01 00:30:10.000000', 'temperatura', 701.0000, 'ºC'),
	(277989, 121, '2014-04-01 00:30:11.000000', 'temperatura', 14.0000, 'ºC'),
	(277990, 121, '2014-04-01 00:30:12.000000', 'temperatura', 367.0000, 'ºC'),
	(277991, 121, '2014-04-01 00:30:13.000000', 'temperatura', 594.0000, 'ºC'),
	(277992, 121, '2014-04-01 00:30:14.000000', 'temperatura', 670.0000, 'ºC'),
	(277993, 121, '2014-04-01 00:30:15.000000', 'temperatura', 370.0000, 'ºC'),
	(277994, 121, '2014-04-01 00:30:16.000000', 'temperatura', 1038.0000, 'ºC'),
	(277995, 121, '2014-04-01 00:30:17.000000', 'temperatura', 483.0000, 'ºC'),
	(277996, 121, '2014-04-01 00:30:18.000000', 'temperatura', 499.0000, 'ºC'),
	(277997, 121, '2014-04-01 00:30:19.000000', 'temperatura', 1047.0000, 'ºC'),
	(277998, 121, '2014-04-01 00:30:20.000000', 'temperatura', 141.0000, 'ºC'),
	(277999, 121, '2014-04-01 00:30:21.000000', 'temperatura', 1163.0000, 'ºC'),
	(278000, 121, '2014-04-01 00:30:22.000000', 'temperatura', 592.0000, 'ºC'),
	(278001, 121, '2014-04-01 00:30:23.000000', 'temperatura', 670.0000, 'ºC'),
	(278002, 121, '2014-04-01 00:30:24.000000', 'temperatura', 375.0000, 'ºC'),
	(278003, 121, '2014-04-01 00:30:25.000000', 'temperatura', 1064.0000, 'ºC'),
	(278004, 121, '2014-04-01 00:30:26.000000', 'temperatura', 598.0000, 'ºC'),
	(278005, 121, '2014-04-01 00:30:27.000000', 'temperatura', 999.0000, 'ºC'),
	(278006, 121, '2014-04-01 00:30:28.000000', 'temperatura', 800.0000, 'ºC'),
	(278007, 121, '2014-04-01 00:30:29.000000', 'temperatura', 1004.0000, 'ºC'),
	(278008, 121, '2014-04-01 00:30:30.000000', 'temperatura', 221.0000, 'ºC'),
	(278009, 121, '2014-04-01 00:30:31.000000', 'temperatura', 495.0000, 'ºC'),
	(278010, 121, '2014-04-01 00:30:32.000000', 'temperatura', 610.0000, 'ºC'),
	(278011, 121, '2014-04-01 00:30:33.000000', 'temperatura', 367.0000, 'ºC'),
	(278012, 121, '2014-04-01 00:30:34.000000', 'temperatura', 6.0000, 'ºC'),
	(278013, 121, '2014-04-01 00:30:35.000000', 'temperatura', 130.0000, 'ºC'),
	(278014, 121, '2014-04-01 00:30:36.000000', 'temperatura', 631.0000, 'ºC'),
	(278015, 121, '2014-04-01 00:30:37.000000', 'temperatura', 367.0000, 'ºC'),
	(278016, 121, '2014-04-01 00:30:38.000000', 'temperatura', 1142.0000, 'ºC'),
	(278017, 121, '2014-04-01 00:30:39.000000', 'temperatura', 1011.0000, 'ºC'),
	(278018, 121, '2014-04-01 00:30:40.000000', 'temperatura', 429.0000, 'ºC'),
	(278019, 121, '2014-04-01 00:30:41.000000', 'temperatura', 310.0000, 'ºC'),
	(278020, 121, '2014-04-01 00:30:42.000000', 'temperatura', 267.0000, 'ºC'),
	(278021, 121, '2014-04-01 00:30:43.000000', 'temperatura', 403.0000, 'ºC'),
	(278022, 121, '2014-04-01 00:30:44.000000', 'temperatura', 16.0000, 'ºC'),
	(278023, 121, '2014-04-01 00:30:45.000000', 'temperatura', 71.0000, 'ºC'),
	(278024, 121, '2014-04-01 00:30:46.000000', 'temperatura', 308.0000, 'ºC'),
	(278025, 121, '2014-04-01 00:30:47.000000', 'temperatura', 127.0000, 'ºC'),
	(278026, 121, '2014-04-01 00:30:48.000000', 'temperatura', 912.0000, 'ºC'),
	(278027, 121, '2014-04-01 00:30:49.000000', 'temperatura', 577.0000, 'ºC'),
	(278028, 121, '2014-04-01 00:30:50.000000', 'temperatura', 153.0000, 'ºC'),
	(278029, 121, '2014-04-01 00:30:51.000000', 'temperatura', 233.0000, 'ºC'),
	(278030, 121, '2014-04-01 00:30:52.000000', 'temperatura', 706.0000, 'ºC'),
	(278031, 121, '2014-04-01 00:30:53.000000', 'temperatura', 430.0000, 'ºC'),
	(278032, 121, '2014-04-01 00:30:54.000000', 'temperatura', 34.0000, 'ºC'),
	(278033, 121, '2014-04-01 00:30:55.000000', 'temperatura', 81.0000, 'ºC'),
	(278034, 121, '2014-04-01 00:30:56.000000', 'temperatura', 303.0000, 'ºC'),
	(278035, 121, '2014-04-01 00:30:57.000000', 'temperatura', 74.0000, 'ºC'),
	(278036, 121, '2014-04-01 00:30:58.000000', 'temperatura', 661.0000, 'ºC'),
	(278037, 121, '2014-04-01 00:30:59.000000', 'temperatura', 684.0000, 'ºC'),
	(278038, 121, '2014-04-01 00:31:00.000000', 'temperatura', 237.0000, 'ºC'),
	(278039, 121, '2014-04-01 00:31:01.000000', 'temperatura', 333.0000, 'ºC'),
	(278040, 121, '2014-04-01 00:31:02.000000', 'temperatura', 956.0000, 'ºC'),
	(278041, 121, '2014-04-01 00:31:03.000000', 'temperatura', 179.0000, 'ºC'),
	(278042, 121, '2014-04-01 00:31:04.000000', 'temperatura', 429.0000, 'ºC'),
	(278043, 121, '2014-04-01 00:31:05.000000', 'temperatura', 408.0000, 'ºC'),
	(278044, 121, '2014-04-01 00:31:06.000000', 'temperatura', 754.0000, 'ºC'),
	(278045, 121, '2014-04-01 00:31:07.000000', 'temperatura', 146.0000, 'ºC'),
	(278046, 121, '2014-04-01 00:31:08.000000', 'temperatura', 868.0000, 'ºC'),
	(278047, 121, '2014-04-01 00:31:09.000000', 'temperatura', 305.0000, 'ºC'),
	(278048, 121, '2014-04-01 00:31:10.000000', 'temperatura', 119.0000, 'ºC'),
	(278049, 121, '2014-04-01 00:31:11.000000', 'temperatura', 883.0000, 'ºC'),
	(278050, 121, '2014-04-01 00:31:12.000000', 'temperatura', 458.0000, 'ºC'),
	(278051, 121, '2014-04-01 00:31:13.000000', 'temperatura', 842.0000, 'ºC'),
	(278052, 121, '2014-04-01 00:31:14.000000', 'temperatura', 438.0000, 'ºC'),
	(278053, 121, '2014-04-01 00:31:15.000000', 'temperatura', 862.0000, 'ºC'),
	(278054, 121, '2014-04-01 00:31:16.000000', 'temperatura', 596.0000, 'ºC'),
	(278055, 121, '2014-04-01 00:31:17.000000', 'temperatura', 394.0000, 'ºC'),
	(278056, 121, '2014-04-01 00:31:18.000000', 'temperatura', 181.0000, 'ºC'),
	(278057, 121, '2014-04-01 00:31:19.000000', 'temperatura', 927.0000, 'ºC'),
	(278058, 121, '2014-04-01 00:31:20.000000', 'temperatura', 491.0000, 'ºC'),
	(278059, 121, '2014-04-01 00:31:21.000000', 'temperatura', 875.0000, 'ºC'),
	(278060, 121, '2014-04-01 00:31:22.000000', 'temperatura', 501.0000, 'ºC'),
	(278061, 121, '2014-04-01 00:31:23.000000', 'temperatura', 1082.0000, 'ºC'),
	(278062, 121, '2014-04-01 00:31:24.000000', 'temperatura', 308.0000, 'ºC'),
	(278063, 121, '2014-04-01 00:31:25.000000', 'temperatura', 695.0000, 'ºC'),
	(278064, 121, '2014-04-01 00:31:26.000000', 'temperatura', 153.0000, 'ºC'),
	(278065, 121, '2014-04-01 00:31:27.000000', 'temperatura', 1078.0000, 'ºC'),
	(278066, 121, '2014-04-01 00:31:28.000000', 'temperatura', 131.0000, 'ºC'),
	(278067, 121, '2014-04-01 00:31:29.000000', 'temperatura', 1024.0000, 'ºC'),
	(278068, 121, '2014-04-01 00:31:30.000000', 'temperatura', 1126.0000, 'ºC'),
	(278069, 121, '2014-04-01 00:31:31.000000', 'temperatura', 158.0000, 'ºC'),
	(278070, 121, '2014-04-01 00:31:32.000000', 'temperatura', 1012.0000, 'ºC'),
	(278071, 121, '2014-04-01 00:31:33.000000', 'temperatura', 985.0000, 'ºC'),
	(278072, 121, '2014-04-01 00:31:34.000000', 'temperatura', 693.0000, 'ºC'),
	(278073, 121, '2014-04-01 00:31:35.000000', 'temperatura', 509.0000, 'ºC'),
	(278074, 121, '2014-04-01 00:31:36.000000', 'temperatura', 465.0000, 'ºC'),
	(278075, 121, '2014-04-01 00:31:37.000000', 'temperatura', 800.0000, 'ºC'),
	(278076, 121, '2014-04-01 00:31:38.000000', 'temperatura', 204.0000, 'ºC'),
	(278077, 121, '2014-04-01 00:31:39.000000', 'temperatura', 1021.0000, 'ºC'),
	(278078, 121, '2014-04-01 00:31:40.000000', 'temperatura', 895.0000, 'ºC'),
	(278079, 121, '2014-04-01 00:31:41.000000', 'temperatura', 213.0000, 'ºC'),
	(278080, 121, '2014-04-01 00:31:42.000000', 'temperatura', 779.0000, 'ºC'),
	(278081, 121, '2014-04-01 00:31:43.000000', 'temperatura', 857.0000, 'ºC'),
	(278082, 121, '2014-04-01 00:31:44.000000', 'temperatura', 750.0000, 'ºC'),
	(278083, 121, '2014-04-01 00:31:45.000000', 'temperatura', 1178.0000, 'ºC'),
	(278084, 121, '2014-04-01 00:31:46.000000', 'temperatura', 42.0000, 'ºC'),
	(278085, 121, '2014-04-01 00:31:47.000000', 'temperatura', 276.0000, 'ºC'),
	(278086, 121, '2014-04-01 00:31:48.000000', 'temperatura', 52.0000, 'ºC'),
	(278087, 121, '2014-04-01 00:31:49.000000', 'temperatura', 636.0000, 'ºC'),
	(278088, 121, '2014-04-01 00:31:50.000000', 'temperatura', 623.0000, 'ºC'),
	(278089, 121, '2014-04-01 00:31:51.000000', 'temperatura', 6.0000, 'ºC'),
	(278090, 121, '2014-04-01 00:31:52.000000', 'temperatura', 563.0000, 'ºC'),
	(278091, 121, '2014-04-01 00:31:53.000000', 'temperatura', 398.0000, 'ºC'),
	(278092, 121, '2014-04-01 00:31:54.000000', 'temperatura', 302.0000, 'ºC'),
	(278093, 121, '2014-04-01 00:31:55.000000', 'temperatura', 315.0000, 'ºC'),
	(278094, 121, '2014-04-01 00:31:56.000000', 'temperatura', 671.0000, 'ºC'),
	(278095, 121, '2014-04-01 00:31:57.000000', 'temperatura', 11.0000, 'ºC'),
	(278096, 121, '2014-04-01 00:31:58.000000', 'temperatura', 443.0000, 'ºC'),
	(278097, 121, '2014-04-01 00:31:59.000000', 'temperatura', 983.0000, 'ºC'),
	(278098, 121, '2014-04-01 00:32:00.000000', 'temperatura', 1187.0000, 'ºC'),
	(278099, 121, '2014-04-01 00:32:01.000000', 'temperatura', 587.0000, 'ºC'),
	(278100, 121, '2014-04-01 00:32:02.000000', 'temperatura', 573.0000, 'ºC'),
	(278101, 121, '2014-04-01 00:32:03.000000', 'temperatura', 1106.0000, 'ºC'),
	(278102, 121, '2014-04-01 00:32:04.000000', 'temperatura', 212.0000, 'ºC'),
	(278103, 121, '2014-04-01 00:32:05.000000', 'temperatura', 142.0000, 'ºC'),
	(278104, 121, '2014-04-01 00:32:06.000000', 'temperatura', 74.0000, 'ºC'),
	(278105, 121, '2014-04-01 00:32:07.000000', 'temperatura', 1143.0000, 'ºC'),
	(278106, 121, '2014-04-01 00:32:08.000000', 'temperatura', 696.0000, 'ºC'),
	(278107, 121, '2014-04-01 00:32:09.000000', 'temperatura', 52.0000, 'ºC'),
	(278108, 121, '2014-04-01 00:32:10.000000', 'temperatura', 573.0000, 'ºC'),
	(278109, 121, '2014-04-01 00:32:11.000000', 'temperatura', 307.0000, 'ºC'),
	(278110, 121, '2014-04-01 00:32:12.000000', 'temperatura', 1016.0000, 'ºC'),
	(278111, 121, '2014-04-01 00:32:13.000000', 'temperatura', 560.0000, 'ºC'),
	(278112, 121, '2014-04-01 00:32:14.000000', 'temperatura', 951.0000, 'ºC'),
	(278113, 121, '2014-04-01 00:32:15.000000', 'temperatura', 676.0000, 'ºC'),
	(278114, 121, '2014-04-01 00:32:16.000000', 'temperatura', 528.0000, 'ºC'),
	(278115, 121, '2014-04-01 00:32:17.000000', 'temperatura', 611.0000, 'ºC'),
	(278116, 121, '2014-04-01 00:32:18.000000', 'temperatura', 272.0000, 'ºC'),
	(278117, 121, '2014-04-01 00:32:19.000000', 'temperatura', 729.0000, 'ºC'),
	(278118, 121, '2014-04-01 00:32:20.000000', 'temperatura', 429.0000, 'ºC'),
	(278119, 121, '2014-04-01 00:32:21.000000', 'temperatura', 1159.0000, 'ºC'),
	(278120, 121, '2014-04-01 00:32:22.000000', 'temperatura', 909.0000, 'ºC'),
	(278121, 121, '2014-04-01 00:32:23.000000', 'temperatura', 1067.0000, 'ºC'),
	(278122, 121, '2014-04-01 00:32:24.000000', 'temperatura', 208.0000, 'ºC'),
	(278123, 121, '2014-04-01 00:32:25.000000', 'temperatura', 240.0000, 'ºC'),
	(278124, 121, '2014-04-01 00:32:26.000000', 'temperatura', 575.0000, 'ºC'),
	(278125, 121, '2014-04-01 00:32:27.000000', 'temperatura', 957.0000, 'ºC'),
	(278126, 121, '2014-04-01 00:32:28.000000', 'temperatura', 660.0000, 'ºC'),
	(278127, 121, '2014-04-01 00:32:29.000000', 'temperatura', 431.0000, 'ºC'),
	(278128, 121, '2014-04-01 00:32:30.000000', 'temperatura', 176.0000, 'ºC'),
	(278129, 121, '2014-04-01 00:32:31.000000', 'temperatura', 786.0000, 'ºC'),
	(278130, 121, '2014-04-01 00:32:32.000000', 'temperatura', 1001.0000, 'ºC'),
	(278131, 121, '2014-04-01 00:32:33.000000', 'temperatura', 251.0000, 'ºC'),
	(278132, 121, '2014-04-01 00:32:34.000000', 'temperatura', 651.0000, 'ºC'),
	(278133, 121, '2014-04-01 00:32:35.000000', 'temperatura', 101.0000, 'ºC'),
	(278134, 121, '2014-04-01 00:32:36.000000', 'temperatura', 955.0000, 'ºC'),
	(278135, 121, '2014-04-01 00:32:37.000000', 'temperatura', 870.0000, 'ºC'),
	(278136, 121, '2014-04-01 00:32:38.000000', 'temperatura', 285.0000, 'ºC'),
	(278137, 121, '2014-04-01 00:32:39.000000', 'temperatura', 18.0000, 'ºC'),
	(278138, 121, '2014-04-01 00:32:40.000000', 'temperatura', 436.0000, 'ºC'),
	(278139, 121, '2014-04-01 00:32:41.000000', 'temperatura', 924.0000, 'ºC'),
	(278140, 121, '2014-04-01 00:32:42.000000', 'temperatura', 916.0000, 'ºC'),
	(278141, 121, '2014-04-01 00:32:43.000000', 'temperatura', 605.0000, 'ºC'),
	(278142, 121, '2014-04-01 00:32:44.000000', 'temperatura', 277.0000, 'ºC'),
	(278143, 121, '2014-04-01 00:32:45.000000', 'temperatura', 772.0000, 'ºC'),
	(278144, 121, '2014-04-01 00:32:46.000000', 'temperatura', 631.0000, 'ºC'),
	(278145, 121, '2014-04-01 00:32:47.000000', 'temperatura', 836.0000, 'ºC'),
	(278146, 121, '2014-04-01 00:32:48.000000', 'temperatura', 1091.0000, 'ºC'),
	(278147, 121, '2014-04-01 00:32:49.000000', 'temperatura', 546.0000, 'ºC'),
	(278148, 121, '2014-04-01 00:32:50.000000', 'temperatura', 658.0000, 'ºC'),
	(278149, 121, '2014-04-01 00:32:51.000000', 'temperatura', 454.0000, 'ºC'),
	(278150, 121, '2014-04-01 00:32:52.000000', 'temperatura', 295.0000, 'ºC'),
	(278151, 121, '2014-04-01 00:32:53.000000', 'temperatura', 114.0000, 'ºC'),
	(278152, 121, '2014-04-01 00:32:54.000000', 'temperatura', 886.0000, 'ºC'),
	(278153, 121, '2014-04-01 00:32:55.000000', 'temperatura', 486.0000, 'ºC'),
	(278154, 121, '2014-04-01 00:32:56.000000', 'temperatura', 976.0000, 'ºC'),
	(278155, 121, '2014-04-01 00:32:57.000000', 'temperatura', 1021.0000, 'ºC'),
	(278156, 121, '2014-04-01 00:32:58.000000', 'temperatura', 977.0000, 'ºC'),
	(278157, 121, '2014-04-01 00:32:59.000000', 'temperatura', 621.0000, 'ºC'),
	(278158, 121, '2014-04-01 00:33:00.000000', 'temperatura', 177.0000, 'ºC'),
	(278159, 121, '2014-04-01 00:33:01.000000', 'temperatura', 221.0000, 'ºC'),
	(278160, 121, '2014-04-01 00:33:02.000000', 'temperatura', 574.0000, 'ºC'),
	(278161, 121, '2014-04-01 00:33:03.000000', 'temperatura', 1009.0000, 'ºC'),
	(278162, 121, '2014-04-01 00:33:04.000000', 'temperatura', 922.0000, 'ºC'),
	(278163, 121, '2014-04-01 00:33:05.000000', 'temperatura', 385.0000, 'ºC'),
	(278164, 121, '2014-04-01 00:33:06.000000', 'temperatura', 359.0000, 'ºC'),
	(278165, 121, '2014-04-01 00:33:07.000000', 'temperatura', 639.0000, 'ºC'),
	(278166, 121, '2014-04-01 00:33:08.000000', 'temperatura', 921.0000, 'ºC'),
	(278167, 121, '2014-04-01 00:33:09.000000', 'temperatura', 287.0000, 'ºC'),
	(278168, 121, '2014-04-01 00:33:10.000000', 'temperatura', 1075.0000, 'ºC'),
	(278169, 121, '2014-04-01 00:33:11.000000', 'temperatura', 912.0000, 'ºC'),
	(278170, 121, '2014-04-01 00:33:12.000000', 'temperatura', 135.0000, 'ºC'),
	(278171, 121, '2014-04-01 00:33:13.000000', 'temperatura', 342.0000, 'ºC'),
	(278172, 121, '2014-04-01 00:33:14.000000', 'temperatura', 103.0000, 'ºC'),
	(278173, 121, '2014-04-01 00:33:15.000000', 'temperatura', 690.0000, 'ºC'),
	(278174, 121, '2014-04-01 00:33:16.000000', 'temperatura', 741.0000, 'ºC'),
	(278175, 121, '2014-04-01 00:33:17.000000', 'temperatura', 436.0000, 'ºC'),
	(278176, 121, '2014-04-01 00:33:18.000000', 'temperatura', 1159.0000, 'ºC'),
	(278177, 121, '2014-04-01 00:33:19.000000', 'temperatura', 888.0000, 'ºC'),
	(278178, 121, '2014-04-01 00:33:20.000000', 'temperatura', 964.0000, 'ºC'),
	(278179, 121, '2014-04-01 00:33:21.000000', 'temperatura', 955.0000, 'ºC'),
	(278180, 121, '2014-04-01 00:33:22.000000', 'temperatura', 685.0000, 'ºC'),
	(278181, 121, '2014-04-01 00:33:23.000000', 'temperatura', 558.0000, 'ºC'),
	(278182, 121, '2014-04-01 00:33:24.000000', 'temperatura', 735.0000, 'ºC'),
	(278183, 121, '2014-04-01 00:33:25.000000', 'temperatura', 801.0000, 'ºC'),
	(278184, 121, '2014-04-01 00:33:26.000000', 'temperatura', 603.0000, 'ºC'),
	(278185, 121, '2014-04-01 00:33:27.000000', 'temperatura', 610.0000, 'ºC'),
	(278186, 121, '2014-04-01 00:33:28.000000', 'temperatura', 43.0000, 'ºC'),
	(278187, 121, '2014-04-01 00:33:29.000000', 'temperatura', 784.0000, 'ºC'),
	(278188, 121, '2014-04-01 00:33:30.000000', 'temperatura', 190.0000, 'ºC'),
	(278189, 121, '2014-04-01 00:33:31.000000', 'temperatura', 1002.0000, 'ºC'),
	(278190, 121, '2014-04-01 00:33:32.000000', 'temperatura', 840.0000, 'ºC'),
	(278191, 121, '2014-04-01 00:33:33.000000', 'temperatura', 1193.0000, 'ºC'),
	(278192, 121, '2014-04-01 00:33:34.000000', 'temperatura', 1046.0000, 'ºC'),
	(278193, 121, '2014-04-01 00:33:35.000000', 'temperatura', 451.0000, 'ºC'),
	(278194, 121, '2014-04-01 00:33:36.000000', 'temperatura', 316.0000, 'ºC'),
	(278195, 121, '2014-04-01 00:33:37.000000', 'temperatura', 229.0000, 'ºC'),
	(278196, 121, '2014-04-01 00:33:38.000000', 'temperatura', 196.0000, 'ºC'),
	(278197, 121, '2014-04-01 00:33:39.000000', 'temperatura', 296.0000, 'ºC'),
	(278198, 121, '2014-04-01 00:33:40.000000', 'temperatura', 893.0000, 'ºC'),
	(278199, 121, '2014-04-01 00:33:41.000000', 'temperatura', 1175.0000, 'ºC'),
	(278200, 121, '2014-04-01 00:33:42.000000', 'temperatura', 797.0000, 'ºC'),
	(278201, 121, '2014-04-01 00:33:43.000000', 'temperatura', 461.0000, 'ºC'),
	(278202, 121, '2014-04-01 00:33:44.000000', 'temperatura', 1116.0000, 'ºC'),
	(278203, 121, '2014-04-01 00:33:45.000000', 'temperatura', 597.0000, 'ºC'),
	(278204, 121, '2014-04-01 00:33:46.000000', 'temperatura', 837.0000, 'ºC'),
	(278205, 121, '2014-04-01 00:33:47.000000', 'temperatura', 1194.0000, 'ºC'),
	(278206, 121, '2014-04-01 00:33:48.000000', 'temperatura', 1061.0000, 'ºC'),
	(278207, 121, '2014-04-01 00:33:49.000000', 'temperatura', 522.0000, 'ºC'),
	(278208, 121, '2014-04-01 00:33:50.000000', 'temperatura', 628.0000, 'ºC'),
	(278209, 121, '2014-04-01 00:33:51.000000', 'temperatura', 376.0000, 'ºC'),
	(278210, 121, '2014-04-01 00:33:52.000000', 'temperatura', 1197.0000, 'ºC'),
	(278211, 121, '2014-04-01 00:33:53.000000', 'temperatura', 57.0000, 'ºC'),
	(278212, 121, '2014-04-01 00:33:54.000000', 'temperatura', 294.0000, 'ºC'),
	(278213, 121, '2014-04-01 00:33:55.000000', 'temperatura', 99.0000, 'ºC'),
	(278214, 121, '2014-04-01 00:33:56.000000', 'temperatura', 816.0000, 'ºC'),
	(278215, 121, '2014-04-01 00:33:57.000000', 'temperatura', 182.0000, 'ºC'),
	(278216, 121, '2014-04-01 00:33:58.000000', 'temperatura', 860.0000, 'ºC'),
	(278217, 121, '2014-04-01 00:33:59.000000', 'temperatura', 158.0000, 'ºC'),
	(278218, 121, '2014-04-01 00:34:00.000000', 'temperatura', 610.0000, 'ºC'),
	(278219, 121, '2014-04-01 00:34:01.000000', 'temperatura', 176.0000, 'ºC'),
	(278220, 121, '2014-04-01 00:34:02.000000', 'temperatura', 251.0000, 'ºC'),
	(278221, 121, '2014-04-01 00:34:03.000000', 'temperatura', 726.0000, 'ºC'),
	(278222, 121, '2014-04-01 00:34:04.000000', 'temperatura', 478.0000, 'ºC'),
	(278223, 121, '2014-04-01 00:34:05.000000', 'temperatura', 214.0000, 'ºC'),
	(278224, 121, '2014-04-01 00:34:06.000000', 'temperatura', 835.0000, 'ºC'),
	(278225, 121, '2014-04-01 00:34:07.000000', 'temperatura', 1134.0000, 'ºC'),
	(278226, 121, '2014-04-01 00:34:08.000000', 'temperatura', 766.0000, 'ºC'),
	(278227, 121, '2014-04-01 00:34:09.000000', 'temperatura', 429.0000, 'ºC'),
	(278228, 121, '2014-04-01 00:34:10.000000', 'temperatura', 1049.0000, 'ºC'),
	(278229, 121, '2014-04-01 00:34:11.000000', 'temperatura', 357.0000, 'ºC'),
	(278230, 121, '2014-04-01 00:34:12.000000', 'temperatura', 1038.0000, 'ºC'),
	(278231, 121, '2014-04-01 00:34:13.000000', 'temperatura', 520.0000, 'ºC'),
	(278232, 121, '2014-04-01 00:34:14.000000', 'temperatura', 687.0000, 'ºC'),
	(278233, 121, '2014-04-01 00:34:15.000000', 'temperatura', 675.0000, 'ºC'),
	(278234, 121, '2014-04-01 00:34:16.000000', 'temperatura', 113.0000, 'ºC'),
	(278235, 121, '2014-04-01 00:34:17.000000', 'temperatura', 943.0000, 'ºC'),
	(278236, 121, '2014-04-01 00:34:18.000000', 'temperatura', 776.0000, 'ºC'),
	(278237, 121, '2014-04-01 00:34:19.000000', 'temperatura', 1051.0000, 'ºC'),
	(278238, 121, '2014-04-01 00:34:20.000000', 'temperatura', 529.0000, 'ºC'),
	(278239, 121, '2014-04-01 00:34:21.000000', 'temperatura', 693.0000, 'ºC'),
	(278240, 121, '2014-04-01 00:34:22.000000', 'temperatura', 679.0000, 'ºC'),
	(278241, 121, '2014-04-01 00:34:23.000000', 'temperatura', 114.0000, 'ºC'),
	(278242, 121, '2014-04-01 00:34:24.000000', 'temperatura', 933.0000, 'ºC'),
	(278243, 121, '2014-04-01 00:34:25.000000', 'temperatura', 723.0000, 'ºC'),
	(278244, 121, '2014-04-01 00:34:26.000000', 'temperatura', 817.0000, 'ºC'),
	(278245, 121, '2014-04-01 00:34:27.000000', 'temperatura', 716.0000, 'ºC'),
	(278246, 121, '2014-04-01 00:34:28.000000', 'temperatura', 1132.0000, 'ºC'),
	(278247, 121, '2014-04-01 00:34:29.000000', 'temperatura', 1111.0000, 'ºC'),
	(278248, 121, '2014-04-01 00:34:30.000000', 'temperatura', 958.0000, 'ºC'),
	(278249, 121, '2014-04-01 00:34:31.000000', 'temperatura', 257.0000, 'ºC'),
	(278250, 121, '2014-04-01 00:34:32.000000', 'temperatura', 814.0000, 'ºC'),
	(278251, 121, '2014-04-01 00:34:33.000000', 'temperatura', 900.0000, 'ºC'),
	(278252, 121, '2014-04-01 00:34:34.000000', 'temperatura', 857.0000, 'ºC'),
	(278253, 121, '2014-04-01 00:34:35.000000', 'temperatura', 386.0000, 'ºC'),
	(278254, 121, '2014-04-01 00:34:36.000000', 'temperatura', 558.0000, 'ºC'),
	(278255, 121, '2014-04-01 00:34:37.000000', 'temperatura', 434.0000, 'ºC'),
	(278256, 121, '2014-04-01 00:34:38.000000', 'temperatura', 496.0000, 'ºC'),
	(278257, 121, '2014-04-01 00:34:39.000000', 'temperatura', 1180.0000, 'ºC'),
	(278258, 121, '2014-04-01 00:34:40.000000', 'temperatura', 811.0000, 'ºC'),
	(278259, 121, '2014-04-01 00:34:41.000000', 'temperatura', 514.0000, 'ºC'),
	(278260, 121, '2014-04-01 00:34:42.000000', 'temperatura', 138.0000, 'ºC'),
	(278261, 121, '2014-04-01 00:34:43.000000', 'temperatura', 349.0000, 'ºC'),
	(278262, 121, '2014-04-01 00:34:44.000000', 'temperatura', 133.0000, 'ºC'),
	(278263, 121, '2014-04-01 00:34:45.000000', 'temperatura', 817.0000, 'ºC'),
	(278264, 121, '2014-04-01 00:34:46.000000', 'temperatura', 87.0000, 'ºC'),
	(278265, 121, '2014-04-01 00:34:47.000000', 'temperatura', 383.0000, 'ºC'),
	(278266, 121, '2014-04-01 00:34:48.000000', 'temperatura', 457.0000, 'ºC'),
	(278267, 121, '2014-04-01 00:34:49.000000', 'temperatura', 1133.0000, 'ºC'),
	(278268, 121, '2014-04-01 00:34:50.000000', 'temperatura', 698.0000, 'ºC'),
	(278269, 121, '2014-04-01 00:34:51.000000', 'temperatura', 91.0000, 'ºC'),
	(278270, 121, '2014-04-01 00:34:52.000000', 'temperatura', 763.0000, 'ºC'),
	(278271, 121, '2014-04-01 00:34:53.000000', 'temperatura', 1139.0000, 'ºC'),
	(278272, 121, '2014-04-01 00:34:54.000000', 'temperatura', 1009.0000, 'ºC'),
	(278273, 121, '2014-04-01 00:34:55.000000', 'temperatura', 427.0000, 'ºC'),
	(278274, 121, '2014-04-01 00:34:56.000000', 'temperatura', 308.0000, 'ºC'),
	(278275, 121, '2014-04-01 00:34:57.000000', 'temperatura', 261.0000, 'ºC'),
	(278276, 121, '2014-04-01 00:34:58.000000', 'temperatura', 382.0000, 'ºC'),
	(278277, 121, '2014-04-01 00:34:59.000000', 'temperatura', 1128.0000, 'ºC'),
	(278278, 121, '2014-04-01 00:35:00.000000', 'temperatura', 895.0000, 'ºC'),
	(278279, 121, '2014-04-01 00:35:01.000000', 'temperatura', 1090.0000, 'ºC'),
	(278280, 121, '2014-04-01 00:35:02.000000', 'temperatura', 365.0000, 'ºC'),
	(278281, 121, '2014-04-01 00:35:03.000000', 'temperatura', 955.0000, 'ºC'),
	(278282, 121, '2014-04-01 00:35:04.000000', 'temperatura', 80.0000, 'ºC'),
	(278283, 121, '2014-04-01 00:35:05.000000', 'temperatura', 1137.0000, 'ºC'),
	(278284, 121, '2014-04-01 00:35:06.000000', 'temperatura', 646.0000, 'ºC'),
	(278285, 121, '2014-04-01 00:35:07.000000', 'temperatura', 1019.0000, 'ºC'),
	(278286, 121, '2014-04-01 00:35:08.000000', 'temperatura', 759.0000, 'ºC'),
	(278287, 121, '2014-04-01 00:35:09.000000', 'temperatura', 736.0000, 'ºC'),
	(278288, 121, '2014-04-01 00:35:10.000000', 'temperatura', 205.0000, 'ºC'),
	(278289, 121, '2014-04-01 00:35:11.000000', 'temperatura', 16.0000, 'ºC'),
	(278290, 121, '2014-04-01 00:35:12.000000', 'temperatura', 664.0000, 'ºC'),
	(278291, 121, '2014-04-01 00:35:13.000000', 'temperatura', 875.0000, 'ºC'),
	(278292, 121, '2014-04-01 00:35:14.000000', 'temperatura', 1182.0000, 'ºC'),
	(278293, 121, '2014-04-01 00:35:15.000000', 'temperatura', 887.0000, 'ºC'),
	(278294, 121, '2014-04-01 00:35:16.000000', 'temperatura', 890.0000, 'ºC'),
	(278295, 121, '2014-04-01 00:35:17.000000', 'temperatura', 590.0000, 'ºC'),
	(278296, 121, '2014-04-01 00:35:18.000000', 'temperatura', 278.0000, 'ºC'),
	(278297, 121, '2014-04-01 00:35:19.000000', 'temperatura', 820.0000, 'ºC'),
	(278298, 121, '2014-04-01 00:35:20.000000', 'temperatura', 867.0000, 'ºC'),
	(278299, 121, '2014-04-01 00:35:21.000000', 'temperatura', 675.0000, 'ºC'),
	(278300, 121, '2014-04-01 00:35:22.000000', 'temperatura', 776.0000, 'ºC'),
	(278301, 121, '2014-04-01 00:35:23.000000', 'temperatura', 653.0000, 'ºC'),
	(278302, 121, '2014-04-01 00:35:24.000000', 'temperatura', 940.0000, 'ºC'),
	(278303, 121, '2014-04-01 00:35:25.000000', 'temperatura', 340.0000, 'ºC'),
	(278304, 121, '2014-04-01 00:35:26.000000', 'temperatura', 80.0000, 'ºC'),
	(278305, 121, '2014-04-01 00:35:27.000000', 'temperatura', 583.0000, 'ºC'),
	(278306, 121, '2014-04-01 00:35:28.000000', 'temperatura', 275.0000, 'ºC'),
	(278307, 121, '2014-04-01 00:35:29.000000', 'temperatura', 824.0000, 'ºC'),
	(278308, 121, '2014-04-01 00:35:30.000000', 'temperatura', 897.0000, 'ºC'),
	(278309, 121, '2014-04-01 00:35:31.000000', 'temperatura', 812.0000, 'ºC'),
	(278310, 121, '2014-04-01 00:35:32.000000', 'temperatura', 170.0000, 'ºC'),
	(278311, 121, '2014-04-01 00:35:33.000000', 'temperatura', 813.0000, 'ºC'),
	(278312, 121, '2014-04-01 00:35:34.000000', 'temperatura', 1159.0000, 'ºC'),
	(278313, 121, '2014-04-01 00:35:35.000000', 'temperatura', 953.0000, 'ºC'),
	(278314, 121, '2014-04-01 00:35:36.000000', 'temperatura', 91.0000, 'ºC'),
	(278315, 121, '2014-04-01 00:35:37.000000', 'temperatura', 1198.0000, 'ºC'),
	(278316, 121, '2014-04-01 00:35:38.000000', 'temperatura', 914.0000, 'ºC'),
	(278317, 121, '2014-04-01 00:35:39.000000', 'temperatura', 977.0000, 'ºC'),
	(278318, 121, '2014-04-01 00:35:40.000000', 'temperatura', 945.0000, 'ºC'),
	(278319, 121, '2014-04-01 00:35:41.000000', 'temperatura', 595.0000, 'ºC'),
	(278320, 121, '2014-04-01 00:35:42.000000', 'temperatura', 141.0000, 'ºC'),
	(278321, 121, '2014-04-01 00:35:43.000000', 'temperatura', 119.0000, 'ºC'),
	(278322, 121, '2014-04-01 00:35:44.000000', 'temperatura', 172.0000, 'ºC'),
	(278323, 121, '2014-04-01 00:35:45.000000', 'temperatura', 505.0000, 'ºC'),
	(278324, 121, '2014-04-01 00:35:46.000000', 'temperatura', 807.0000, 'ºC'),
	(278325, 121, '2014-04-01 00:35:47.000000', 'temperatura', 122.0000, 'ºC'),
	(278326, 121, '2014-04-01 00:35:48.000000', 'temperatura', 588.0000, 'ºC'),
	(278327, 121, '2014-04-01 00:35:49.000000', 'temperatura', 176.0000, 'ºC'),
	(278328, 121, '2014-04-01 00:35:50.000000', 'temperatura', 316.0000, 'ºC'),
	(278329, 121, '2014-04-01 00:35:51.000000', 'temperatura', 1051.0000, 'ºC'),
	(278330, 121, '2014-04-01 00:35:52.000000', 'temperatura', 710.0000, 'ºC'),
	(278331, 121, '2014-04-01 00:35:53.000000', 'temperatura', 396.0000, 'ºC'),
	(278332, 121, '2014-04-01 00:35:54.000000', 'temperatura', 1049.0000, 'ºC'),
	(278333, 121, '2014-04-01 00:35:55.000000', 'temperatura', 458.0000, 'ºC'),
	(278334, 121, '2014-04-01 00:35:56.000000', 'temperatura', 343.0000, 'ºC'),
	(278335, 121, '2014-04-01 00:35:57.000000', 'temperatura', 342.0000, 'ºC'),
	(278336, 121, '2014-04-01 00:35:58.000000', 'temperatura', 680.0000, 'ºC'),
	(278337, 121, '2014-04-01 00:35:59.000000', 'temperatura', 1178.0000, 'ºC'),
	(278338, 121, '2014-04-01 00:36:00.000000', 'temperatura', 247.0000, 'ºC'),
	(278339, 121, '2014-04-01 00:36:01.000000', 'temperatura', 102.0000, 'ºC'),
	(278340, 121, '2014-04-01 00:36:02.000000', 'temperatura', 970.0000, 'ºC'),
	(278341, 121, '2014-04-01 00:36:03.000000', 'temperatura', 944.0000, 'ºC'),
	(278342, 121, '2014-04-01 00:36:04.000000', 'temperatura', 611.0000, 'ºC'),
	(278343, 121, '2014-04-01 00:36:05.000000', 'temperatura', 223.0000, 'ºC'),
	(278344, 121, '2014-04-01 00:36:06.000000', 'temperatura', 485.0000, 'ºC'),
	(278345, 121, '2014-04-01 00:36:07.000000', 'temperatura', 555.0000, 'ºC'),
	(278346, 121, '2014-04-01 00:36:08.000000', 'temperatura', 119.0000, 'ºC'),
	(278347, 121, '2014-04-01 00:36:09.000000', 'temperatura', 130.0000, 'ºC'),
	(278348, 121, '2014-04-01 00:36:10.000000', 'temperatura', 296.0000, 'ºC'),
	(278349, 121, '2014-04-01 00:36:11.000000', 'temperatura', 1092.0000, 'ºC'),
	(278350, 121, '2014-04-01 00:36:12.000000', 'temperatura', 969.0000, 'ºC'),
	(278351, 121, '2014-04-01 00:36:13.000000', 'temperatura', 370.0000, 'ºC'),
	(278352, 121, '2014-04-01 00:36:14.000000', 'temperatura', 144.0000, 'ºC'),
	(278353, 121, '2014-04-01 00:36:15.000000', 'temperatura', 812.0000, 'ºC'),
	(278354, 121, '2014-04-01 00:36:16.000000', 'temperatura', 29.0000, 'ºC'),
	(278355, 121, '2014-04-01 00:36:17.000000', 'temperatura', 108.0000, 'ºC'),
	(278356, 121, '2014-04-01 00:36:18.000000', 'temperatura', 454.0000, 'ºC'),
	(278357, 121, '2014-04-01 00:36:19.000000', 'temperatura', 747.0000, 'ºC'),
	(278358, 121, '2014-04-01 00:36:20.000000', 'temperatura', 1175.0000, 'ºC'),
	(278359, 121, '2014-04-01 00:36:21.000000', 'temperatura', 33.0000, 'ºC'),
	(278360, 121, '2014-04-01 00:36:22.000000', 'temperatura', 240.0000, 'ºC'),
	(278361, 121, '2014-04-01 00:36:23.000000', 'temperatura', 1102.0000, 'ºC'),
	(278362, 121, '2014-04-01 00:36:24.000000', 'temperatura', 1191.0000, 'ºC'),
	(278363, 121, '2014-04-01 00:36:25.000000', 'temperatura', 248.0000, 'ºC'),
	(278364, 121, '2014-04-01 00:36:26.000000', 'temperatura', 70.0000, 'ºC'),
	(278365, 121, '2014-04-01 00:36:27.000000', 'temperatura', 806.0000, 'ºC'),
	(278366, 121, '2014-04-01 00:36:28.000000', 'temperatura', 218.0000, 'ºC'),
	(278367, 121, '2014-04-01 00:36:29.000000', 'temperatura', 1074.0000, 'ºC'),
	(278368, 121, '2014-04-01 00:36:30.000000', 'temperatura', 1115.0000, 'ºC'),
	(278369, 121, '2014-04-01 00:36:31.000000', 'temperatura', 1153.0000, 'ºC'),
	(278370, 121, '2014-04-01 00:36:32.000000', 'temperatura', 20.0000, 'ºC'),
	(278371, 121, '2014-04-01 00:36:33.000000', 'temperatura', 244.0000, 'ºC'),
	(278372, 121, '2014-04-01 00:36:34.000000', 'temperatura', 1161.0000, 'ºC'),
	(278373, 121, '2014-04-01 00:36:35.000000', 'temperatura', 275.0000, 'ºC'),
	(278374, 121, '2014-04-01 00:36:36.000000', 'temperatura', 289.0000, 'ºC'),
	(278375, 121, '2014-04-01 00:36:37.000000', 'temperatura', 621.0000, 'ºC'),
	(278376, 121, '2014-04-01 00:36:38.000000', 'temperatura', 1037.0000, 'ºC'),
	(278377, 121, '2014-04-01 00:36:39.000000', 'temperatura', 926.0000, 'ºC'),
	(278378, 121, '2014-04-01 00:36:40.000000', 'temperatura', 317.0000, 'ºC'),
	(278379, 121, '2014-04-01 00:36:41.000000', 'temperatura', 10.0000, 'ºC'),
	(278380, 121, '2014-04-01 00:36:42.000000', 'temperatura', 299.0000, 'ºC'),
	(278381, 121, '2014-04-01 00:36:43.000000', 'temperatura', 264.0000, 'ºC'),
	(278382, 121, '2014-04-01 00:36:44.000000', 'temperatura', 426.0000, 'ºC'),
	(278383, 121, '2014-04-01 00:36:45.000000', 'temperatura', 136.0000, 'ºC'),
	(278384, 121, '2014-04-01 00:36:46.000000', 'temperatura', 602.0000, 'ºC'),
	(278385, 121, '2014-04-01 00:36:47.000000', 'temperatura', 201.0000, 'ºC'),
	(278386, 121, '2014-04-01 00:36:48.000000', 'temperatura', 403.0000, 'ºC'),
	(278387, 121, '2014-04-01 00:36:49.000000', 'temperatura', 213.0000, 'ºC'),
	(278388, 121, '2014-04-01 00:36:50.000000', 'temperatura', 1054.0000, 'ºC'),
	(278389, 121, '2014-04-01 00:36:51.000000', 'temperatura', 1033.0000, 'ºC'),
	(278390, 121, '2014-04-01 00:36:52.000000', 'temperatura', 801.0000, 'ºC'),
	(278391, 121, '2014-04-01 00:36:53.000000', 'temperatura', 909.0000, 'ºC'),
	(278392, 121, '2014-04-01 00:36:54.000000', 'temperatura', 941.0000, 'ºC'),
	(278393, 121, '2014-04-01 00:36:55.000000', 'temperatura', 779.0000, 'ºC'),
	(278394, 121, '2014-04-01 00:36:56.000000', 'temperatura', 1072.0000, 'ºC'),
	(278395, 121, '2014-04-01 00:36:57.000000', 'temperatura', 625.0000, 'ºC'),
	(278396, 121, '2014-04-01 00:36:58.000000', 'temperatura', 1110.0000, 'ºC'),
	(278397, 121, '2014-04-01 00:36:59.000000', 'temperatura', 75.0000, 'ºC'),
	(278398, 121, '2014-04-01 00:37:00.000000', 'temperatura', 645.0000, 'ºC'),
	(278399, 121, '2014-04-01 00:37:01.000000', 'temperatura', 601.0000, 'ºC'),
	(278400, 121, '2014-04-01 00:37:02.000000', 'temperatura', 1070.0000, 'ºC'),
	(278401, 121, '2014-04-01 00:37:03.000000', 'temperatura', 1149.0000, 'ºC'),
	(278402, 121, '2014-04-01 00:37:04.000000', 'temperatura', 132.0000, 'ºC'),
	(278403, 121, '2014-04-01 00:37:05.000000', 'temperatura', 817.0000, 'ºC'),
	(278404, 121, '2014-04-01 00:37:06.000000', 'temperatura', 90.0000, 'ºC'),
	(278405, 121, '2014-04-01 00:37:07.000000', 'temperatura', 398.0000, 'ºC'),
	(278406, 121, '2014-04-01 00:37:08.000000', 'temperatura', 520.0000, 'ºC'),
	(278407, 121, '2014-04-01 00:37:09.000000', 'temperatura', 207.0000, 'ºC'),
	(278408, 121, '2014-04-01 00:37:10.000000', 'temperatura', 677.0000, 'ºC'),
	(278409, 121, '2014-04-01 00:37:11.000000', 'temperatura', 363.0000, 'ºC'),
	(278410, 121, '2014-04-01 00:37:12.000000', 'temperatura', 985.0000, 'ºC'),
	(278411, 121, '2014-04-01 00:37:13.000000', 'temperatura', 236.0000, 'ºC'),
	(278412, 121, '2014-04-01 00:37:14.000000', 'temperatura', 628.0000, 'ºC'),
	(278413, 121, '2014-04-01 00:37:15.000000', 'temperatura', 30.0000, 'ºC'),
	(278414, 121, '2014-04-01 00:37:16.000000', 'temperatura', 667.0000, 'ºC'),
	(278415, 121, '2014-04-01 00:37:17.000000', 'temperatura', 847.0000, 'ºC'),
	(278416, 121, '2014-04-01 00:37:18.000000', 'temperatura', 1032.0000, 'ºC'),
	(278417, 121, '2014-04-01 00:37:19.000000', 'temperatura', 220.0000, 'ºC'),
	(278418, 121, '2014-04-01 00:37:20.000000', 'temperatura', 404.0000, 'ºC'),
	(278419, 121, '2014-04-01 00:37:21.000000', 'temperatura', 162.0000, 'ºC'),
	(278420, 121, '2014-04-01 00:37:22.000000', 'temperatura', 796.0000, 'ºC'),
	(278421, 121, '2014-04-01 00:37:23.000000', 'temperatura', 1098.0000, 'ºC'),
	(278422, 121, '2014-04-01 00:37:24.000000', 'temperatura', 701.0000, 'ºC'),
	(278423, 121, '2014-04-01 00:37:25.000000', 'temperatura', 210.0000, 'ºC'),
	(278424, 121, '2014-04-01 00:37:26.000000', 'temperatura', 150.0000, 'ºC'),
	(278425, 121, '2014-04-01 00:37:27.000000', 'temperatura', 120.0000, 'ºC'),
	(278426, 121, '2014-04-01 00:37:28.000000', 'temperatura', 150.0000, 'ºC'),
	(278427, 121, '2014-04-01 00:37:29.000000', 'temperatura', 390.0000, 'ºC'),
	(278428, 121, '2014-04-01 00:37:30.000000', 'temperatura', 299.0000, 'ºC'),
	(278429, 121, '2014-04-01 00:37:31.000000', 'temperatura', 327.0000, 'ºC'),
	(278430, 121, '2014-04-01 00:37:32.000000', 'temperatura', 739.0000, 'ºC'),
	(278431, 121, '2014-04-01 00:37:33.000000', 'temperatura', 314.0000, 'ºC'),
	(278432, 121, '2014-04-01 00:37:34.000000', 'temperatura', 555.0000, 'ºC'),
	(278433, 121, '2014-04-01 00:37:35.000000', 'temperatura', 631.0000, 'ºC'),
	(278434, 121, '2014-04-01 00:37:36.000000', 'temperatura', 292.0000, 'ºC'),
	(278435, 121, '2014-04-01 00:37:37.000000', 'temperatura', 765.0000, 'ºC'),
	(278436, 121, '2014-04-01 00:37:38.000000', 'temperatura', 553.0000, 'ºC'),
	(278437, 121, '2014-04-01 00:37:39.000000', 'temperatura', 470.0000, 'ºC'),
	(278438, 121, '2014-04-01 00:37:40.000000', 'temperatura', 690.0000, 'ºC'),
	(278439, 121, '2014-04-01 00:37:41.000000', 'temperatura', 839.0000, 'ºC'),
	(278440, 121, '2014-04-01 00:37:42.000000', 'temperatura', 929.0000, 'ºC'),
	(278441, 121, '2014-04-01 00:37:43.000000', 'temperatura', 926.0000, 'ºC'),
	(278442, 121, '2014-04-01 00:37:44.000000', 'temperatura', 643.0000, 'ºC'),
	(278443, 121, '2014-04-01 00:37:45.000000', 'temperatura', 437.0000, 'ºC'),
	(278444, 121, '2014-04-01 00:37:46.000000', 'temperatura', 257.0000, 'ºC'),
	(278445, 121, '2014-04-01 00:37:47.000000', 'temperatura', 1176.0000, 'ºC'),
	(278446, 121, '2014-04-01 00:37:48.000000', 'temperatura', 309.0000, 'ºC'),
	(278447, 121, '2014-04-01 00:37:49.000000', 'temperatura', 417.0000, 'ºC'),
	(278448, 121, '2014-04-01 00:37:50.000000', 'temperatura', 1158.0000, 'ºC'),
	(278449, 121, '2014-04-01 00:37:51.000000', 'temperatura', 942.0000, 'ºC'),
	(278450, 121, '2014-04-01 00:37:52.000000', 'temperatura', 35.0000, 'ºC'),
	(278451, 121, '2014-04-01 00:37:53.000000', 'temperatura', 948.0000, 'ºC'),
	(278452, 121, '2014-04-01 00:37:54.000000', 'temperatura', 1037.0000, 'ºC'),
	(278453, 121, '2014-04-01 00:37:55.000000', 'temperatura', 1140.0000, 'ºC'),
	(278454, 121, '2014-04-01 00:37:56.000000', 'temperatura', 192.0000, 'ºC'),
	(278455, 121, '2014-04-01 00:37:57.000000', 'temperatura', 1140.0000, 'ºC'),
	(278456, 121, '2014-04-01 00:37:58.000000', 'temperatura', 325.0000, 'ºC'),
	(278457, 121, '2014-04-01 00:37:59.000000', 'temperatura', 603.0000, 'ºC'),
	(278458, 121, '2014-04-01 00:38:00.000000', 'temperatura', 842.0000, 'ºC'),
	(278459, 121, '2014-04-01 00:38:01.000000', 'temperatura', 2.0000, 'ºC'),
	(278460, 121, '2014-04-01 00:38:02.000000', 'temperatura', 1083.0000, 'ºC'),
	(278461, 121, '2014-04-01 00:38:03.000000', 'temperatura', 610.0000, 'ºC'),
	(278462, 121, '2014-04-01 00:38:04.000000', 'temperatura', 1000.0000, 'ºC'),
	(278463, 121, '2014-04-01 00:38:05.000000', 'temperatura', 770.0000, 'ºC'),
	(278464, 121, '2014-04-01 00:38:06.000000', 'temperatura', 853.0000, 'ºC'),
	(278465, 121, '2014-04-01 00:38:07.000000', 'temperatura', 756.0000, 'ºC'),
	(278466, 121, '2014-04-01 00:38:08.000000', 'temperatura', 21.0000, 'ºC'),
	(278467, 121, '2014-04-01 00:38:09.000000', 'temperatura', 238.0000, 'ºC'),
	(278468, 121, '2014-04-01 00:38:10.000000', 'temperatura', 1126.0000, 'ºC'),
	(278469, 121, '2014-04-01 00:38:11.000000', 'temperatura', 117.0000, 'ºC'),
	(278470, 121, '2014-04-01 00:38:12.000000', 'temperatura', 809.0000, 'ºC'),
	(278471, 121, '2014-04-01 00:38:13.000000', 'temperatura', 94.0000, 'ºC'),
	(278472, 121, '2014-04-01 00:38:14.000000', 'temperatura', 441.0000, 'ºC'),
	(278473, 121, '2014-04-01 00:38:15.000000', 'temperatura', 726.0000, 'ºC'),
	(278474, 121, '2014-04-01 00:38:16.000000', 'temperatura', 1107.0000, 'ºC'),
	(278475, 121, '2014-04-01 00:38:17.000000', 'temperatura', 956.0000, 'ºC'),
	(278476, 121, '2014-04-01 00:38:18.000000', 'temperatura', 261.0000, 'ºC'),
	(278477, 121, '2014-04-01 00:38:19.000000', 'temperatura', 837.0000, 'ºC'),
	(278478, 121, '2014-04-01 00:38:20.000000', 'temperatura', 1003.0000, 'ºC'),
	(278479, 121, '2014-04-01 00:38:21.000000', 'temperatura', 105.0000, 'ºC'),
	(278480, 121, '2014-04-01 00:38:22.000000', 'temperatura', 1117.0000, 'ºC'),
	(278481, 121, '2014-04-01 00:38:23.000000', 'temperatura', 468.0000, 'ºC'),
	(278482, 121, '2014-04-01 00:38:24.000000', 'temperatura', 191.0000, 'ºC'),
	(278483, 121, '2014-04-01 00:38:25.000000', 'temperatura', 751.0000, 'ºC'),
	(278484, 121, '2014-04-01 00:38:26.000000', 'temperatura', 783.0000, 'ºC'),
	(278485, 121, '2014-04-01 00:38:27.000000', 'temperatura', 461.0000, 'ºC'),
	(278486, 121, '2014-04-01 00:38:28.000000', 'temperatura', 1156.0000, 'ºC'),
	(278487, 121, '2014-04-01 00:38:29.000000', 'temperatura', 796.0000, 'ºC'),
	(278488, 121, '2014-04-01 00:38:30.000000', 'temperatura', 516.0000, 'ºC'),
	(278489, 121, '2014-04-01 00:38:31.000000', 'temperatura', 192.0000, 'ºC'),
	(278490, 121, '2014-04-01 00:38:32.000000', 'temperatura', 613.0000, 'ºC'),
	(278491, 121, '2014-04-01 00:38:33.000000', 'temperatura', 87.0000, 'ºC'),
	(278492, 121, '2014-04-01 00:38:34.000000', 'temperatura', 997.0000, 'ºC'),
	(278493, 121, '2014-04-01 00:38:35.000000', 'temperatura', 1123.0000, 'ºC'),
	(278494, 121, '2014-04-01 00:38:36.000000', 'temperatura', 227.0000, 'ºC'),
	(278495, 121, '2014-04-01 00:38:37.000000', 'temperatura', 166.0000, 'ºC'),
	(278496, 121, '2014-04-01 00:38:38.000000', 'temperatura', 149.0000, 'ºC'),
	(278497, 121, '2014-04-01 00:38:39.000000', 'temperatura', 248.0000, 'ºC'),
	(278498, 121, '2014-04-01 00:38:40.000000', 'temperatura', 792.0000, 'ºC'),
	(278499, 121, '2014-04-01 00:38:41.000000', 'temperatura', 817.0000, 'ºC'),
	(278500, 121, '2014-04-01 00:38:42.000000', 'temperatura', 508.0000, 'ºC'),
	(278501, 121, '2014-04-01 00:38:43.000000', 'temperatura', 91.0000, 'ºC'),
	(278502, 121, '2014-04-01 00:38:44.000000', 'temperatura', 131.0000, 'ºC'),
	(278503, 121, '2014-04-01 00:38:45.000000', 'temperatura', 382.0000, 'ºC'),
	(278504, 121, '2014-04-01 00:38:46.000000', 'temperatura', 319.0000, 'ºC'),
	(278505, 121, '2014-04-01 00:38:47.000000', 'temperatura', 448.0000, 'ºC'),
	(278506, 121, '2014-04-01 00:38:48.000000', 'temperatura', 83.0000, 'ºC'),
	(278507, 121, '2014-04-01 00:38:49.000000', 'temperatura', 271.0000, 'ºC'),
	(278508, 121, '2014-04-01 00:38:50.000000', 'temperatura', 1109.0000, 'ºC'),
	(278509, 121, '2014-04-01 00:38:51.000000', 'temperatura', 1131.0000, 'ºC'),
	(278510, 121, '2014-04-01 00:38:52.000000', 'temperatura', 1130.0000, 'ºC'),
	(278511, 121, '2014-04-01 00:38:53.000000', 'temperatura', 1057.0000, 'ºC'),
	(278512, 121, '2014-04-01 00:38:54.000000', 'temperatura', 694.0000, 'ºC'),
	(278513, 121, '2014-04-01 00:38:55.000000', 'temperatura', 300.0000, 'ºC'),
	(278514, 121, '2014-04-01 00:38:56.000000', 'temperatura', 620.0000, 'ºC'),
	(278515, 121, '2014-04-01 00:38:57.000000', 'temperatura', 998.0000, 'ºC'),
	(278516, 121, '2014-04-01 00:38:58.000000', 'temperatura', 733.0000, 'ºC'),
	(278517, 121, '2014-04-01 00:38:59.000000', 'temperatura', 669.0000, 'ºC'),
	(278518, 121, '2014-04-01 00:39:00.000000', 'temperatura', 1148.0000, 'ºC'),
	(278519, 121, '2014-04-01 00:39:01.000000', 'temperatura', 135.0000, 'ºC'),
	(278520, 121, '2014-04-01 00:39:02.000000', 'temperatura', 829.0000, 'ºC'),
	(278521, 121, '2014-04-01 00:39:03.000000', 'temperatura', 142.0000, 'ºC'),
	(278522, 121, '2014-04-01 00:39:04.000000', 'temperatura', 624.0000, 'ºC'),
	(278523, 121, '2014-04-01 00:39:05.000000', 'temperatura', 296.0000, 'ºC'),
	(278524, 121, '2014-04-01 00:39:06.000000', 'temperatura', 805.0000, 'ºC'),
	(278525, 121, '2014-04-01 00:39:07.000000', 'temperatura', 739.0000, 'ºC'),
	(278526, 121, '2014-04-01 00:39:08.000000', 'temperatura', 80.0000, 'ºC'),
	(278527, 121, '2014-04-01 00:39:09.000000', 'temperatura', 582.0000, 'ºC'),
	(278528, 121, '2014-04-01 00:39:10.000000', 'temperatura', 270.0000, 'ºC'),
	(278529, 121, '2014-04-01 00:39:11.000000', 'temperatura', 807.0000, 'ºC'),
	(278530, 121, '2014-04-01 00:39:12.000000', 'temperatura', 826.0000, 'ºC'),
	(278531, 121, '2014-04-01 00:39:13.000000', 'temperatura', 508.0000, 'ºC'),
	(278532, 121, '2014-04-01 00:39:14.000000', 'temperatura', 63.0000, 'ºC'),
	(278533, 121, '2014-04-01 00:39:15.000000', 'temperatura', 1191.0000, 'ºC'),
	(278534, 121, '2014-04-01 00:39:16.000000', 'temperatura', 969.0000, 'ºC'),
	(278535, 121, '2014-04-01 00:39:17.000000', 'temperatura', 69.0000, 'ºC'),
	(278536, 121, '2014-04-01 00:39:18.000000', 'temperatura', 1042.0000, 'ºC'),
	(278537, 121, '2014-04-01 00:39:19.000000', 'temperatura', 201.0000, 'ºC'),
	(278538, 121, '2014-04-01 00:39:20.000000', 'temperatura', 278.0000, 'ºC'),
	(278539, 121, '2014-04-01 00:39:21.000000', 'temperatura', 791.0000, 'ºC'),
	(278540, 121, '2014-04-01 00:39:22.000000', 'temperatura', 719.0000, 'ºC'),
	(278541, 121, '2014-04-01 00:39:23.000000', 'temperatura', 25.0000, 'ºC'),
	(278542, 121, '2014-04-01 00:39:24.000000', 'temperatura', 369.0000, 'ºC'),
	(278543, 121, '2014-04-01 00:39:25.000000', 'temperatura', 570.0000, 'ºC'),
	(278544, 121, '2014-04-01 00:39:26.000000', 'temperatura', 542.0000, 'ºC'),
	(278545, 121, '2014-04-01 00:39:27.000000', 'temperatura', 1002.0000, 'ºC'),
	(278546, 121, '2014-04-01 00:39:28.000000', 'temperatura', 982.0000, 'ºC'),
	(278547, 121, '2014-04-01 00:39:29.000000', 'temperatura', 707.0000, 'ºC'),
	(278548, 121, '2014-04-01 00:39:30.000000', 'temperatura', 589.0000, 'ºC'),
	(278549, 121, '2014-04-01 00:39:31.000000', 'temperatura', 823.0000, 'ºC'),
	(278550, 121, '2014-04-01 00:39:32.000000', 'temperatura', 1151.0000, 'ºC'),
	(278551, 121, '2014-04-01 00:39:33.000000', 'temperatura', 886.0000, 'ºC'),
	(278552, 121, '2014-04-01 00:39:34.000000', 'temperatura', 975.0000, 'ºC'),
	(278553, 121, '2014-04-01 00:39:35.000000', 'temperatura', 1019.0000, 'ºC'),
	(278554, 121, '2014-04-01 00:39:36.000000', 'temperatura', 970.0000, 'ºC'),
	(278555, 121, '2014-04-01 00:39:37.000000', 'temperatura', 594.0000, 'ºC'),
	(278556, 121, '2014-04-01 00:39:38.000000', 'temperatura', 58.0000, 'ºC'),
	(278557, 121, '2014-04-01 00:39:39.000000', 'temperatura', 911.0000, 'ºC'),
	(278558, 121, '2014-04-01 00:39:40.000000', 'temperatura', 783.0000, 'ºC'),
	(278559, 121, '2014-04-01 00:39:41.000000', 'temperatura', 1180.0000, 'ºC'),
	(278560, 121, '2014-04-01 00:39:42.000000', 'temperatura', 1153.0000, 'ºC'),
	(278561, 121, '2014-04-01 00:39:43.000000', 'temperatura', 1025.0000, 'ºC'),
	(278562, 121, '2014-04-01 00:39:44.000000', 'temperatura', 468.0000, 'ºC'),
	(278563, 121, '2014-04-01 00:39:45.000000', 'temperatura', 465.0000, 'ºC'),
	(278564, 121, '2014-04-01 00:39:46.000000', 'temperatura', 923.0000, 'ºC'),
	(278565, 121, '2014-04-01 00:39:47.000000', 'temperatura', 819.0000, 'ºC'),
	(278566, 121, '2014-04-01 00:39:48.000000', 'temperatura', 128.0000, 'ºC'),
	(278567, 121, '2014-04-01 00:39:49.000000', 'temperatura', 584.0000, 'ºC'),
	(278568, 121, '2014-04-01 00:39:50.000000', 'temperatura', 137.0000, 'ºC'),
	(278569, 121, '2014-04-01 00:39:51.000000', 'temperatura', 133.0000, 'ºC'),
	(278570, 121, '2014-04-01 00:39:52.000000', 'temperatura', 253.0000, 'ºC'),
	(278571, 121, '2014-04-01 00:39:53.000000', 'temperatura', 867.0000, 'ºC'),
	(278572, 121, '2014-04-01 00:39:54.000000', 'temperatura', 1176.0000, 'ºC'),
	(278573, 121, '2014-04-01 00:39:55.000000', 'temperatura', 879.0000, 'ºC'),
	(278574, 121, '2014-04-01 00:39:56.000000', 'temperatura', 869.0000, 'ºC'),
	(278575, 121, '2014-04-01 00:39:57.000000', 'temperatura', 510.0000, 'ºC'),
	(278576, 121, '2014-04-01 00:39:58.000000', 'temperatura', 1141.0000, 'ºC'),
	(278577, 121, '2014-04-01 00:39:59.000000', 'temperatura', 578.0000, 'ºC'),
	(278578, 121, '2014-04-01 00:40:00.000000', 'temperatura', 667.0000, 'ºC'),
	(278579, 121, '2014-04-01 00:40:01.000000', 'temperatura', 403.0000, 'ºC'),
	(278580, 121, '2014-04-01 00:40:02.000000', 'temperatura', 12.0000, 'ºC'),
	(278581, 121, '2014-04-01 00:40:03.000000', 'temperatura', 53.0000, 'ºC'),
	(278582, 121, '2014-04-01 00:40:04.000000', 'temperatura', 228.0000, 'ºC'),
	(278583, 121, '2014-04-01 00:40:05.000000', 'temperatura', 980.0000, 'ºC'),
	(278584, 121, '2014-04-01 00:40:06.000000', 'temperatura', 620.0000, 'ºC'),
	(278585, 121, '2014-04-01 00:40:07.000000', 'temperatura', 159.0000, 'ºC'),
	(278586, 121, '2014-04-01 00:40:08.000000', 'temperatura', 134.0000, 'ºC'),
	(278587, 121, '2014-04-01 00:40:09.000000', 'temperatura', 195.0000, 'ºC'),
	(278588, 121, '2014-04-01 00:40:10.000000', 'temperatura', 574.0000, 'ºC'),
	(278589, 121, '2014-04-01 00:40:11.000000', 'temperatura', 1086.0000, 'ºC'),
	(278590, 121, '2014-04-01 00:40:12.000000', 'temperatura', 109.0000, 'ºC'),
	(278591, 121, '2014-04-01 00:40:13.000000', 'temperatura', 886.0000, 'ºC'),
	(278592, 121, '2014-04-01 00:40:14.000000', 'temperatura', 504.0000, 'ºC'),
	(278593, 121, '2014-04-01 00:40:15.000000', 'temperatura', 1061.0000, 'ºC'),
	(278594, 121, '2014-04-01 00:40:16.000000', 'temperatura', 195.0000, 'ºC'),
	(278595, 121, '2014-04-01 00:40:17.000000', 'temperatura', 193.0000, 'ºC'),
	(278596, 121, '2014-04-01 00:40:18.000000', 'temperatura', 379.0000, 'ºC'),
	(278597, 121, '2014-04-01 00:40:19.000000', 'temperatura', 118.0000, 'ºC'),
	(278598, 121, '2014-04-01 00:40:20.000000', 'temperatura', 652.0000, 'ºC'),
	(278599, 121, '2014-04-01 00:40:21.000000', 'temperatura', 507.0000, 'ºC'),
	(278600, 121, '2014-04-01 00:40:22.000000', 'temperatura', 579.0000, 'ºC'),
	(278601, 121, '2014-04-01 00:40:23.000000', 'temperatura', 176.0000, 'ºC'),
	(278602, 121, '2014-04-01 00:40:24.000000', 'temperatura', 342.0000, 'ºC'),
	(278603, 121, '2014-04-01 00:40:25.000000', 'temperatura', 1181.0000, 'ºC'),
	(278604, 121, '2014-04-01 00:40:26.000000', 'temperatura', 80.0000, 'ºC'),
	(278605, 121, '2014-04-01 00:40:27.000000', 'temperatura', 460.0000, 'ºC'),
	(278606, 121, '2014-04-01 00:40:28.000000', 'temperatura', 859.0000, 'ºC'),
	(278607, 121, '2014-04-01 00:40:29.000000', 'temperatura', 516.0000, 'ºC'),
	(278608, 121, '2014-04-01 00:40:30.000000', 'temperatura', 3.0000, 'ºC'),
	(278609, 121, '2014-04-01 00:40:31.000000', 'temperatura', 870.0000, 'ºC'),
	(278610, 121, '2014-04-01 00:40:32.000000', 'temperatura', 739.0000, 'ºC'),
	(278611, 121, '2014-04-01 00:40:33.000000', 'temperatura', 1085.0000, 'ºC'),
	(278612, 121, '2014-04-01 00:40:34.000000', 'temperatura', 808.0000, 'ºC'),
	(278613, 121, '2014-04-01 00:40:35.000000', 'temperatura', 785.0000, 'ºC'),
	(278614, 121, '2014-04-01 00:40:36.000000', 'temperatura', 300.0000, 'ºC'),
	(278615, 121, '2014-04-01 00:40:37.000000', 'temperatura', 349.0000, 'ºC'),
	(278616, 121, '2014-04-01 00:40:38.000000', 'temperatura', 845.0000, 'ºC'),
	(278617, 121, '2014-04-01 00:40:39.000000', 'temperatura', 779.0000, 'ºC'),
	(278618, 121, '2014-04-01 00:40:40.000000', 'temperatura', 160.0000, 'ºC'),
	(278619, 121, '2014-04-01 00:40:41.000000', 'temperatura', 864.0000, 'ºC'),
	(278620, 121, '2014-04-01 00:40:42.000000', 'temperatura', 241.0000, 'ºC'),
	(278621, 121, '2014-04-01 00:40:43.000000', 'temperatura', 1014.0000, 'ºC'),
	(278622, 121, '2014-04-01 00:40:44.000000', 'temperatura', 748.0000, 'ºC'),
	(278623, 121, '2014-04-01 00:40:45.000000', 'temperatura', 697.0000, 'ºC'),
	(278624, 121, '2014-04-01 00:40:46.000000', 'temperatura', 41.0000, 'ºC'),
	(278625, 121, '2014-04-01 00:40:47.000000', 'temperatura', 516.0000, 'ºC'),
	(278626, 121, '2014-04-01 00:40:48.000000', 'temperatura', 59.0000, 'ºC'),
	(278627, 121, '2014-04-01 00:40:49.000000', 'temperatura', 1145.0000, 'ºC'),
	(278628, 121, '2014-04-01 00:40:50.000000', 'temperatura', 748.0000, 'ºC'),
	(278629, 121, '2014-04-01 00:40:51.000000', 'temperatura', 307.0000, 'ºC'),
	(278630, 121, '2014-04-01 00:40:52.000000', 'temperatura', 489.0000, 'ºC'),
	(278631, 121, '2014-04-01 00:40:53.000000', 'temperatura', 328.0000, 'ºC'),
	(278632, 121, '2014-04-01 00:40:54.000000', 'temperatura', 170.0000, 'ºC'),
	(278633, 121, '2014-04-01 00:40:55.000000', 'temperatura', 1069.0000, 'ºC'),
	(278634, 121, '2014-04-01 00:40:56.000000', 'temperatura', 33.0000, 'ºC'),
	(278635, 121, '2014-04-01 00:40:57.000000', 'temperatura', 559.0000, 'ºC'),
	(278636, 121, '2014-04-01 00:40:58.000000', 'temperatura', 298.0000, 'ºC'),
	(278637, 121, '2014-04-01 00:40:59.000000', 'temperatura', 1015.0000, 'ºC'),
	(278638, 121, '2014-04-01 00:41:00.000000', 'temperatura', 578.0000, 'ºC'),
	(278639, 121, '2014-04-01 00:41:01.000000', 'temperatura', 1047.0000, 'ºC'),
	(278640, 121, '2014-04-01 00:41:02.000000', 'temperatura', 1101.0000, 'ºC'),
	(278641, 121, '2014-04-01 00:41:03.000000', 'temperatura', 1164.0000, 'ºC'),
	(278642, 121, '2014-04-01 00:41:04.000000', 'temperatura', 119.0000, 'ºC'),
	(278643, 121, '2014-04-01 00:41:05.000000', 'temperatura', 702.0000, 'ºC'),
	(278644, 121, '2014-04-01 00:41:06.000000', 'temperatura', 753.0000, 'ºC'),
	(278645, 121, '2014-04-01 00:41:07.000000', 'temperatura', 461.0000, 'ºC'),
	(278646, 121, '2014-04-01 00:41:08.000000', 'temperatura', 46.0000, 'ºC'),
	(278647, 121, '2014-04-01 00:41:09.000000', 'temperatura', 48.0000, 'ºC'),
	(278648, 121, '2014-04-01 00:41:10.000000', 'temperatura', 101.0000, 'ºC'),
	(278649, 121, '2014-04-01 00:41:11.000000', 'temperatura', 362.0000, 'ºC'),
	(278650, 121, '2014-04-01 00:41:12.000000', 'temperatura', 308.0000, 'ºC'),
	(278651, 121, '2014-04-01 00:41:13.000000', 'temperatura', 455.0000, 'ºC'),
	(278652, 121, '2014-04-01 00:41:14.000000', 'temperatura', 150.0000, 'ºC'),
	(278653, 121, '2014-04-01 00:41:15.000000', 'temperatura', 586.0000, 'ºC'),
	(278654, 121, '2014-04-01 00:41:16.000000', 'temperatura', 82.0000, 'ºC'),
	(278655, 121, '2014-04-01 00:41:17.000000', 'temperatura', 1052.0000, 'ºC'),
	(278656, 121, '2014-04-01 00:41:18.000000', 'temperatura', 214.0000, 'ºC'),
	(278657, 121, '2014-04-01 00:41:19.000000', 'temperatura', 313.0000, 'ºC'),
	(278658, 121, '2014-04-01 00:41:20.000000', 'temperatura', 924.0000, 'ºC'),
	(278659, 121, '2014-04-01 00:41:21.000000', 'temperatura', 84.0000, 'ºC'),
	(278660, 121, '2014-04-01 00:41:22.000000', 'temperatura', 47.0000, 'ºC'),
	(278661, 121, '2014-04-01 00:41:23.000000', 'temperatura', 1184.0000, 'ºC'),
	(278662, 121, '2014-04-01 00:41:24.000000', 'temperatura', 979.0000, 'ºC'),
	(278663, 121, '2014-04-01 00:41:25.000000', 'temperatura', 144.0000, 'ºC'),
	(278664, 121, '2014-04-01 00:41:26.000000', 'temperatura', 183.0000, 'ºC'),
	(278665, 121, '2014-04-01 00:41:27.000000', 'temperatura', 486.0000, 'ºC'),
	(278666, 121, '2014-04-01 00:41:28.000000', 'temperatura', 678.0000, 'ºC'),
	(278667, 121, '2014-04-01 00:41:29.000000', 'temperatura', 735.0000, 'ºC'),
	(278668, 121, '2014-04-01 00:41:30.000000', 'temperatura', 442.0000, 'ºC'),
	(278669, 121, '2014-04-01 00:41:31.000000', 'temperatura', 3.0000, 'ºC'),
	(278670, 121, '2014-04-01 00:41:32.000000', 'temperatura', 1093.0000, 'ºC'),
	(278671, 121, '2014-04-01 00:41:33.000000', 'temperatura', 653.0000, 'ºC'),
	(278672, 121, '2014-04-01 00:41:34.000000', 'temperatura', 1188.0000, 'ºC'),
	(278673, 121, '2014-04-01 00:41:35.000000', 'temperatura', 383.0000, 'ºC'),
	(278674, 121, '2014-04-01 00:41:36.000000', 'temperatura', 752.0000, 'ºC'),
	(278675, 121, '2014-04-01 00:41:37.000000', 'temperatura', 209.0000, 'ºC'),
	(278676, 121, '2014-04-01 00:41:38.000000', 'temperatura', 1190.0000, 'ºC'),
	(278677, 121, '2014-04-01 00:41:39.000000', 'temperatura', 525.0000, 'ºC'),
	(278678, 121, '2014-04-01 00:41:40.000000', 'temperatura', 253.0000, 'ºC'),
	(278679, 121, '2014-04-01 00:41:41.000000', 'temperatura', 893.0000, 'ºC'),
	(278680, 121, '2014-04-01 00:41:42.000000', 'temperatura', 106.0000, 'ºC'),
	(278681, 121, '2014-04-01 00:41:43.000000', 'temperatura', 249.0000, 'ºC'),
	(278682, 121, '2014-04-01 00:41:44.000000', 'temperatura', 930.0000, 'ºC'),
	(278683, 121, '2014-04-01 00:41:45.000000', 'temperatura', 301.0000, 'ºC'),
	(278684, 121, '2014-04-01 00:41:46.000000', 'temperatura', 1116.0000, 'ºC'),
	(278685, 121, '2014-04-01 00:41:47.000000', 'temperatura', 1080.0000, 'ºC'),
	(278686, 121, '2014-04-01 00:41:48.000000', 'temperatura', 852.0000, 'ºC'),
	(278687, 121, '2014-04-01 00:41:49.000000', 'temperatura', 1018.0000, 'ºC'),
	(278688, 121, '2014-04-01 00:41:50.000000', 'temperatura', 137.0000, 'ºC'),
	(278689, 121, '2014-04-01 00:41:51.000000', 'temperatura', 31.0000, 'ºC'),
	(278690, 121, '2014-04-01 00:41:52.000000', 'temperatura', 943.0000, 'ºC'),
	(278691, 121, '2014-04-01 00:41:53.000000', 'temperatura', 1023.0000, 'ºC'),
	(278692, 121, '2014-04-01 00:41:54.000000', 'temperatura', 1087.0000, 'ºC'),
	(278693, 121, '2014-04-01 00:41:55.000000', 'temperatura', 1166.0000, 'ºC'),
	(278694, 121, '2014-04-01 00:41:56.000000', 'temperatura', 170.0000, 'ºC'),
	(278695, 121, '2014-04-01 00:41:57.000000', 'temperatura', 952.0000, 'ºC'),
	(278696, 121, '2014-04-01 00:41:58.000000', 'temperatura', 651.0000, 'ºC'),
	(278697, 121, '2014-04-01 00:41:59.000000', 'temperatura', 401.0000, 'ºC'),
	(278698, 121, '2014-04-01 00:42:00.000000', 'temperatura', 52.0000, 'ºC'),
	(278699, 121, '2014-04-01 00:42:01.000000', 'temperatura', 255.0000, 'ºC'),
	(278700, 121, '2014-04-01 00:42:02.000000', 'temperatura', 1121.0000, 'ºC'),
	(278701, 121, '2014-04-01 00:42:03.000000', 'temperatura', 42.0000, 'ºC'),
	(278702, 121, '2014-04-01 00:42:04.000000', 'temperatura', 446.0000, 'ºC'),
	(278703, 121, '2014-04-01 00:42:05.000000', 'temperatura', 904.0000, 'ºC'),
	(278704, 121, '2014-04-01 00:42:06.000000', 'temperatura', 782.0000, 'ºC'),
	(278705, 121, '2014-04-01 00:42:07.000000', 'temperatura', 1199.0000, 'ºC'),
	(278706, 121, '2014-04-01 00:42:08.000000', 'temperatura', 49.0000, 'ºC'),
	(278707, 121, '2014-04-01 00:42:09.000000', 'temperatura', 249.0000, 'ºC'),
	(278708, 121, '2014-04-01 00:42:10.000000', 'temperatura', 1100.0000, 'ºC'),
	(278709, 121, '2014-04-01 00:42:11.000000', 'temperatura', 1152.0000, 'ºC'),
	(278710, 121, '2014-04-01 00:42:12.000000', 'temperatura', 61.0000, 'ºC'),
	(278711, 121, '2014-04-01 00:42:13.000000', 'temperatura', 447.0000, 'ºC'),
	(278712, 121, '2014-04-01 00:42:14.000000', 'temperatura', 856.0000, 'ºC'),
	(278713, 121, '2014-04-01 00:42:15.000000', 'temperatura', 537.0000, 'ºC'),
	(278714, 121, '2014-04-01 00:42:16.000000', 'temperatura', 117.0000, 'ºC'),
	(278715, 121, '2014-04-01 00:42:17.000000', 'temperatura', 176.0000, 'ºC'),
	(278716, 121, '2014-04-01 00:42:18.000000', 'temperatura', 528.0000, 'ºC'),
	(278717, 121, '2014-04-01 00:42:19.000000', 'temperatura', 913.0000, 'ºC'),
	(278718, 121, '2014-04-01 00:42:20.000000', 'temperatura', 582.0000, 'ºC'),
	(278719, 121, '2014-04-01 00:42:21.000000', 'temperatura', 173.0000, 'ºC'),
	(278720, 121, '2014-04-01 00:42:22.000000', 'temperatura', 319.0000, 'ºC'),
	(278721, 121, '2014-04-01 00:42:23.000000', 'temperatura', 1077.0000, 'ºC'),
	(278722, 121, '2014-04-01 00:42:24.000000', 'temperatura', 830.0000, 'ºC'),
	(278723, 121, '2014-04-01 00:42:25.000000', 'temperatura', 917.0000, 'ºC'),
	(278724, 121, '2014-04-01 00:42:26.000000', 'temperatura', 895.0000, 'ºC'),
	(278725, 121, '2014-04-01 00:42:27.000000', 'temperatura', 524.0000, 'ºC'),
	(278726, 121, '2014-04-01 00:42:28.000000', 'temperatura', 1138.0000, 'ºC'),
	(278727, 121, '2014-04-01 00:42:29.000000', 'temperatura', 517.0000, 'ºC'),
	(278728, 121, '2014-04-01 00:42:30.000000', 'temperatura', 371.0000, 'ºC'),
	(278729, 121, '2014-04-01 00:42:31.000000', 'temperatura', 304.0000, 'ºC'),
	(278730, 121, '2014-04-01 00:42:32.000000', 'temperatura', 409.0000, 'ºC'),
	(278731, 121, '2014-04-01 00:42:33.000000', 'temperatura', 1134.0000, 'ºC'),
	(278732, 121, '2014-04-01 00:42:34.000000', 'temperatura', 842.0000, 'ºC'),
	(278733, 121, '2014-04-01 00:42:35.000000', 'temperatura', 811.0000, 'ºC'),
	(278734, 121, '2014-04-01 00:42:36.000000', 'temperatura', 329.0000, 'ºC'),
	(278735, 121, '2014-04-01 00:42:37.000000', 'temperatura', 412.0000, 'ºC'),
	(278736, 121, '2014-04-01 00:42:38.000000', 'temperatura', 1072.0000, 'ºC'),
	(278737, 121, '2014-04-01 00:42:39.000000', 'temperatura', 523.0000, 'ºC'),
	(278738, 121, '2014-04-01 00:42:40.000000', 'temperatura', 603.0000, 'ºC'),
	(278739, 121, '2014-04-01 00:42:41.000000', 'temperatura', 246.0000, 'ºC'),
	(278740, 121, '2014-04-01 00:42:42.000000', 'temperatura', 621.0000, 'ºC'),
	(278741, 121, '2014-04-01 00:42:43.000000', 'temperatura', 1168.0000, 'ºC'),
	(278742, 121, '2014-04-01 00:42:44.000000', 'temperatura', 379.0000, 'ºC'),
	(278743, 121, '2014-04-01 00:42:45.000000', 'temperatura', 790.0000, 'ºC'),
	(278744, 121, '2014-04-01 00:42:46.000000', 'temperatura', 414.0000, 'ºC'),
	(278745, 121, '2014-04-01 00:42:47.000000', 'temperatura', 900.0000, 'ºC'),
	(278746, 121, '2014-04-01 00:42:48.000000', 'temperatura', 857.0000, 'ºC'),
	(278747, 121, '2014-04-01 00:42:49.000000', 'temperatura', 385.0000, 'ºC'),
	(278748, 121, '2014-04-01 00:42:50.000000', 'temperatura', 556.0000, 'ºC'),
	(278749, 121, '2014-04-01 00:42:51.000000', 'temperatura', 427.0000, 'ºC'),
	(278750, 121, '2014-04-01 00:42:52.000000', 'temperatura', 467.0000, 'ºC'),
	(278751, 121, '2014-04-01 00:42:53.000000', 'temperatura', 1055.0000, 'ºC'),
	(278752, 121, '2014-04-01 00:42:54.000000', 'temperatura', 275.0000, 'ºC'),
	(278753, 121, '2014-04-01 00:42:55.000000', 'temperatura', 608.0000, 'ºC'),
	(278754, 121, '2014-04-01 00:42:56.000000', 'temperatura', 1018.0000, 'ºC'),
	(278755, 121, '2014-04-01 00:42:57.000000', 'temperatura', 867.0000, 'ºC'),
	(278756, 121, '2014-04-01 00:42:58.000000', 'temperatura', 80.0000, 'ºC'),
	(278757, 121, '2014-04-01 00:42:59.000000', 'temperatura', 199.0000, 'ºC'),
	(278758, 121, '2014-04-01 00:43:00.000000', 'temperatura', 756.0000, 'ºC'),
	(278759, 121, '2014-04-01 00:43:01.000000', 'temperatura', 783.0000, 'ºC'),
	(278760, 121, '2014-04-01 00:43:02.000000', 'temperatura', 448.0000, 'ºC'),
	(278761, 121, '2014-04-01 00:43:03.000000', 'temperatura', 1089.0000, 'ºC'),
	(278762, 121, '2014-04-01 00:43:04.000000', 'temperatura', 505.0000, 'ºC'),
	(278763, 121, '2014-04-01 00:43:05.000000', 'temperatura', 455.0000, 'ºC'),
	(278764, 121, '2014-04-01 00:43:06.000000', 'temperatura', 763.0000, 'ºC'),
	(278765, 121, '2014-04-01 00:43:07.000000', 'temperatura', 48.0000, 'ºC'),
	(278766, 121, '2014-04-01 00:43:08.000000', 'temperatura', 355.0000, 'ºC'),
	(278767, 121, '2014-04-01 00:43:09.000000', 'temperatura', 428.0000, 'ºC'),
	(278768, 121, '2014-04-01 00:43:10.000000', 'temperatura', 1076.0000, 'ºC'),
	(278769, 121, '2014-04-01 00:43:11.000000', 'temperatura', 498.0000, 'ºC'),
	(278770, 121, '2014-04-01 00:43:12.000000', 'temperatura', 462.0000, 'ºC'),
	(278771, 121, '2014-04-01 00:43:13.000000', 'temperatura', 816.0000, 'ºC'),
	(278772, 121, '2014-04-01 00:43:14.000000', 'temperatura', 293.0000, 'ºC'),
	(278773, 121, '2014-04-01 00:43:15.000000', 'temperatura', 218.0000, 'ºC'),
	(278774, 121, '2014-04-01 00:43:16.000000', 'temperatura', 211.0000, 'ºC'),
	(278775, 121, '2014-04-01 00:43:17.000000', 'temperatura', 401.0000, 'ºC'),
	(278776, 121, '2014-04-01 00:43:18.000000', 'temperatura', 172.0000, 'ºC'),
	(278777, 121, '2014-04-01 00:43:19.000000', 'temperatura', 860.0000, 'ºC'),
	(278778, 121, '2014-04-01 00:43:20.000000', 'temperatura', 182.0000, 'ºC'),
	(278779, 121, '2014-04-01 00:43:21.000000', 'temperatura', 733.0000, 'ºC'),
	(278780, 121, '2014-04-01 00:43:22.000000', 'temperatura', 720.0000, 'ºC'),
	(278781, 121, '2014-04-01 00:43:23.000000', 'temperatura', 199.0000, 'ºC'),
	(278782, 121, '2014-04-01 00:43:24.000000', 'temperatura', 35.0000, 'ºC'),
	(278783, 121, '2014-04-01 00:43:25.000000', 'temperatura', 780.0000, 'ºC'),
	(278784, 121, '2014-04-01 00:43:26.000000', 'temperatura', 195.0000, 'ºC'),
	(278785, 121, '2014-04-01 00:43:27.000000', 'temperatura', 1036.0000, 'ºC'),
	(278786, 121, '2014-04-01 00:43:28.000000', 'temperatura', 994.0000, 'ºC'),
	(278787, 121, '2014-04-01 00:43:29.000000', 'temperatura', 663.0000, 'ºC'),
	(278788, 121, '2014-04-01 00:43:30.000000', 'temperatura', 332.0000, 'ºC'),
	(278789, 121, '2014-04-01 00:43:31.000000', 'temperatura', 875.0000, 'ºC'),
	(278790, 121, '2014-04-01 00:43:32.000000', 'temperatura', 977.0000, 'ºC'),
	(278791, 121, '2014-04-01 00:43:33.000000', 'temperatura', 1061.0000, 'ºC'),
	(278792, 121, '2014-04-01 00:43:34.000000', 'temperatura', 1174.0000, 'ºC'),
	(278793, 121, '2014-04-01 00:43:35.000000', 'temperatura', 287.0000, 'ºC'),
	(278794, 121, '2014-04-01 00:43:36.000000', 'temperatura', 315.0000, 'ºC'),
	(278795, 121, '2014-04-01 00:43:37.000000', 'temperatura', 716.0000, 'ºC'),
	(278796, 121, '2014-04-01 00:43:38.000000', 'temperatura', 234.0000, 'ºC'),
	(278797, 121, '2014-04-01 00:43:39.000000', 'temperatura', 222.0000, 'ºC'),
	(278798, 121, '2014-04-01 00:43:40.000000', 'temperatura', 410.0000, 'ºC'),
	(278799, 121, '2014-04-01 00:43:41.000000', 'temperatura', 185.0000, 'ºC'),
	(278800, 121, '2014-04-01 00:43:42.000000', 'temperatura', 893.0000, 'ºC'),
	(278801, 121, '2014-04-01 00:43:43.000000', 'temperatura', 313.0000, 'ºC'),
	(278802, 121, '2014-04-01 00:43:44.000000', 'temperatura', 87.0000, 'ºC'),
	(278803, 121, '2014-04-01 00:43:45.000000', 'temperatura', 696.0000, 'ºC'),
	(278804, 121, '2014-04-01 00:43:46.000000', 'temperatura', 820.0000, 'ºC'),
	(278805, 121, '2014-04-01 00:43:47.000000', 'temperatura', 812.0000, 'ºC'),
	(278806, 121, '2014-04-01 00:43:48.000000', 'temperatura', 399.0000, 'ºC'),
	(278807, 121, '2014-04-01 00:43:49.000000', 'temperatura', 761.0000, 'ºC'),
	(278808, 121, '2014-04-01 00:43:50.000000', 'temperatura', 207.0000, 'ºC'),
	(278809, 121, '2014-04-01 00:43:51.000000', 'temperatura', 1154.0000, 'ºC'),
	(278810, 121, '2014-04-01 00:43:52.000000', 'temperatura', 350.0000, 'ºC'),
	(278811, 121, '2014-04-01 00:43:53.000000', 'temperatura', 687.0000, 'ºC'),
	(278812, 121, '2014-04-01 00:43:54.000000', 'temperatura', 1185.0000, 'ºC'),
	(278813, 121, '2014-04-01 00:43:55.000000', 'temperatura', 266.0000, 'ºC'),
	(278814, 121, '2014-04-01 00:43:56.000000', 'temperatura', 174.0000, 'ºC'),
	(278815, 121, '2014-04-01 00:43:57.000000', 'temperatura', 71.0000, 'ºC'),
	(278816, 121, '2014-04-01 00:43:58.000000', 'temperatura', 1036.0000, 'ºC'),
	(278817, 121, '2014-04-01 00:43:59.000000', 'temperatura', 168.0000, 'ºC'),
	(278818, 121, '2014-04-01 00:44:00.000000', 'temperatura', 132.0000, 'ºC'),
	(278819, 121, '2014-04-01 00:44:01.000000', 'temperatura', 157.0000, 'ºC'),
	(278820, 121, '2014-04-01 00:44:02.000000', 'temperatura', 389.0000, 'ºC'),
	(278821, 121, '2014-04-01 00:44:03.000000', 'temperatura', 274.0000, 'ºC'),
	(278822, 121, '2014-04-01 00:44:04.000000', 'temperatura', 206.0000, 'ºC'),
	(278823, 121, '2014-04-01 00:44:05.000000', 'temperatura', 207.0000, 'ºC'),
	(278824, 121, '2014-04-01 00:44:06.000000', 'temperatura', 417.0000, 'ºC'),
	(278825, 121, '2014-04-01 00:44:07.000000', 'temperatura', 263.0000, 'ºC'),
	(278826, 121, '2014-04-01 00:44:08.000000', 'temperatura', 66.0000, 'ºC'),
	(278827, 121, '2014-04-01 00:44:09.000000', 'temperatura', 742.0000, 'ºC'),
	(278828, 121, '2014-04-01 00:44:10.000000', 'temperatura', 1111.0000, 'ºC'),
	(278829, 121, '2014-04-01 00:44:11.000000', 'temperatura', 928.0000, 'ºC'),
	(278830, 121, '2014-04-01 00:44:12.000000', 'temperatura', 110.0000, 'ºC'),
	(278831, 121, '2014-04-01 00:44:13.000000', 'temperatura', 167.0000, 'ºC'),
	(278832, 121, '2014-04-01 00:44:14.000000', 'temperatura', 506.0000, 'ºC'),
	(278833, 121, '2014-04-01 00:44:15.000000', 'temperatura', 830.0000, 'ºC'),
	(278834, 121, '2014-04-01 00:44:16.000000', 'temperatura', 233.0000, 'ºC'),
	(278835, 121, '2014-04-01 00:44:17.000000', 'temperatura', 1075.0000, 'ºC'),
	(278836, 121, '2014-04-01 00:44:18.000000', 'temperatura', 1078.0000, 'ºC'),
	(278837, 121, '2014-04-01 00:44:19.000000', 'temperatura', 963.0000, 'ºC'),
	(278838, 121, '2014-04-01 00:44:20.000000', 'temperatura', 383.0000, 'ºC'),
	(278839, 121, '2014-04-01 00:44:21.000000', 'temperatura', 224.0000, 'ºC'),
	(278840, 121, '2014-04-01 00:44:22.000000', 'temperatura', 1174.0000, 'ºC'),
	(278841, 121, '2014-04-01 00:44:23.000000', 'temperatura', 397.0000, 'ºC'),
	(278842, 121, '2014-04-01 00:44:24.000000', 'temperatura', 863.0000, 'ºC'),
	(278843, 121, '2014-04-01 00:44:25.000000', 'temperatura', 727.0000, 'ºC'),
	(278844, 121, '2014-04-01 00:44:26.000000', 'temperatura', 1047.0000, 'ºC'),
	(278845, 121, '2014-04-01 00:44:27.000000', 'temperatura', 652.0000, 'ºC'),
	(278846, 121, '2014-04-01 00:44:28.000000', 'temperatura', 119.0000, 'ºC'),
	(278847, 121, '2014-04-01 00:44:29.000000', 'temperatura', 1039.0000, 'ºC'),
	(278848, 121, '2014-04-01 00:44:30.000000', 'temperatura', 38.0000, 'ºC'),
	(278849, 121, '2014-04-01 00:44:31.000000', 'temperatura', 676.0000, 'ºC'),
	(278850, 121, '2014-04-01 00:44:32.000000', 'temperatura', 865.0000, 'ºC'),
	(278851, 121, '2014-04-01 00:44:33.000000', 'temperatura', 1096.0000, 'ºC'),
	(278852, 121, '2014-04-01 00:44:34.000000', 'temperatura', 487.0000, 'ºC'),
	(278853, 121, '2014-04-01 00:44:35.000000', 'temperatura', 347.0000, 'ºC'),
	(278854, 121, '2014-04-01 00:44:36.000000', 'temperatura', 275.0000, 'ºC'),
	(278855, 121, '2014-04-01 00:44:37.000000', 'temperatura', 334.0000, 'ºC'),
	(278856, 121, '2014-04-01 00:44:38.000000', 'temperatura', 846.0000, 'ºC'),
	(278857, 121, '2014-04-01 00:44:39.000000', 'temperatura', 829.0000, 'ºC'),
	(278858, 121, '2014-04-01 00:44:40.000000', 'temperatura', 406.0000, 'ºC'),
	(278859, 121, '2014-04-01 00:44:41.000000', 'temperatura', 742.0000, 'ºC'),
	(278860, 121, '2014-04-01 00:44:42.000000', 'temperatura', 95.0000, 'ºC'),
	(278861, 121, '2014-04-01 00:44:43.000000', 'temperatura', 648.0000, 'ºC'),
	(278862, 121, '2014-04-01 00:44:44.000000', 'temperatura', 556.0000, 'ºC'),
	(278863, 121, '2014-04-01 00:44:45.000000', 'temperatura', 835.0000, 'ºC'),
	(278864, 121, '2014-04-01 00:44:46.000000', 'temperatura', 109.0000, 'ºC'),
	(278865, 121, '2014-04-01 00:44:47.000000', 'temperatura', 440.0000, 'ºC'),
	(278866, 121, '2014-04-01 00:44:48.000000', 'temperatura', 673.0000, 'ºC'),
	(278867, 121, '2014-04-01 00:44:49.000000', 'temperatura', 845.0000, 'ºC'),
	(278868, 121, '2014-04-01 00:44:50.000000', 'temperatura', 1006.0000, 'ºC'),
	(278869, 121, '2014-04-01 00:44:51.000000', 'temperatura', 95.0000, 'ºC'),
	(278870, 121, '2014-04-01 00:44:52.000000', 'temperatura', 1057.0000, 'ºC'),
	(278871, 121, '2014-04-01 00:44:53.000000', 'temperatura', 203.0000, 'ºC'),
	(278872, 121, '2014-04-01 00:44:54.000000', 'temperatura', 243.0000, 'ºC'),
	(278873, 121, '2014-04-01 00:44:55.000000', 'temperatura', 606.0000, 'ºC'),
	(278874, 121, '2014-04-01 00:44:56.000000', 'temperatura', 1101.0000, 'ºC'),
	(278875, 121, '2014-04-01 00:44:57.000000', 'temperatura', 90.0000, 'ºC'),
	(278876, 121, '2014-04-01 00:44:58.000000', 'temperatura', 748.0000, 'ºC'),
	(278877, 121, '2014-04-01 00:44:59.000000', 'temperatura', 1068.0000, 'ºC'),
	(278878, 121, '2014-04-01 00:45:00.000000', 'temperatura', 697.0000, 'ºC'),
	(278879, 121, '2014-04-01 00:45:01.000000', 'temperatura', 281.0000, 'ºC'),
	(278880, 121, '2014-04-01 00:45:02.000000', 'temperatura', 514.0000, 'ºC'),
	(278881, 121, '2014-04-01 00:45:03.000000', 'temperatura', 529.0000, 'ºC'),
	(278882, 121, '2014-04-01 00:45:04.000000', 'temperatura', 1103.0000, 'ºC'),
	(278883, 121, '2014-04-01 00:45:05.000000', 'temperatura', 328.0000, 'ºC'),
	(278884, 121, '2014-04-01 00:45:06.000000', 'temperatura', 734.0000, 'ºC'),
	(278885, 121, '2014-04-01 00:45:07.000000', 'temperatura', 284.0000, 'ºC'),
	(278886, 121, '2014-04-01 00:45:08.000000', 'temperatura', 417.0000, 'ºC'),
	(278887, 121, '2014-04-01 00:45:09.000000', 'temperatura', 36.0000, 'ºC'),
	(278888, 121, '2014-04-01 00:45:10.000000', 'temperatura', 128.0000, 'ºC'),
	(278889, 121, '2014-04-01 00:45:11.000000', 'temperatura', 533.0000, 'ºC'),
	(278890, 121, '2014-04-01 00:45:12.000000', 'temperatura', 1082.0000, 'ºC'),
	(278891, 121, '2014-04-01 00:45:13.000000', 'temperatura', 213.0000, 'ºC'),
	(278892, 121, '2014-04-01 00:45:14.000000', 'temperatura', 216.0000, 'ºC'),
	(278893, 121, '2014-04-01 00:45:15.000000', 'temperatura', 445.0000, 'ºC'),
	(278894, 121, '2014-04-01 00:45:16.000000', 'temperatura', 377.0000, 'ºC'),
	(278895, 121, '2014-04-01 00:45:17.000000', 'temperatura', 550.0000, 'ºC'),
	(278896, 121, '2014-04-01 00:45:18.000000', 'temperatura', 420.0000, 'ºC'),
	(278897, 121, '2014-04-01 00:45:19.000000', 'temperatura', 448.0000, 'ºC'),
	(278898, 121, '2014-04-01 00:45:20.000000', 'temperatura', 983.0000, 'ºC'),
	(278899, 121, '2014-04-01 00:45:21.000000', 'temperatura', 1172.0000, 'ºC'),
	(278900, 121, '2014-04-01 00:45:22.000000', 'temperatura', 512.0000, 'ºC'),
	(278901, 121, '2014-04-01 00:45:23.000000', 'temperatura', 243.0000, 'ºC'),
	(278902, 121, '2014-04-01 00:45:24.000000', 'temperatura', 878.0000, 'ºC'),
	(278903, 121, '2014-04-01 00:45:25.000000', 'temperatura', 63.0000, 'ºC'),
	(278904, 121, '2014-04-01 00:45:26.000000', 'temperatura', 80.0000, 'ºC'),
	(278905, 121, '2014-04-01 00:45:27.000000', 'temperatura', 211.0000, 'ºC'),
	(278906, 121, '2014-04-01 00:45:28.000000', 'temperatura', 817.0000, 'ºC'),
	(278907, 121, '2014-04-01 00:45:29.000000', 'temperatura', 1054.0000, 'ºC'),
	(278908, 121, '2014-04-01 00:45:30.000000', 'temperatura', 416.0000, 'ºC'),
	(278909, 121, '2014-04-01 00:45:31.000000', 'temperatura', 122.0000, 'ºC'),
	(278910, 121, '2014-04-01 00:45:32.000000', 'temperatura', 561.0000, 'ºC'),
	(278911, 121, '2014-04-01 00:45:33.000000', 'temperatura', 39.0000, 'ºC'),
	(278912, 121, '2014-04-01 00:45:34.000000', 'temperatura', 915.0000, 'ºC'),
	(278913, 121, '2014-04-01 00:45:35.000000', 'temperatura', 857.0000, 'ºC'),
	(278914, 121, '2014-04-01 00:45:36.000000', 'temperatura', 342.0000, 'ºC'),
	(278915, 121, '2014-04-01 00:45:37.000000', 'temperatura', 337.0000, 'ºC'),
	(278916, 121, '2014-04-01 00:45:38.000000', 'temperatura', 662.0000, 'ºC'),
	(278917, 121, '2014-04-01 00:45:39.000000', 'temperatura', 1100.0000, 'ºC'),
	(278918, 121, '2014-04-01 00:45:40.000000', 'temperatura', 1112.0000, 'ºC'),
	(278919, 121, '2014-04-01 00:45:41.000000', 'temperatura', 1060.0000, 'ºC'),
	(278920, 121, '2014-04-01 00:45:42.000000', 'temperatura', 765.0000, 'ºC'),
	(278921, 121, '2014-04-01 00:45:43.000000', 'temperatura', 648.0000, 'ºC'),
	(278922, 121, '2014-04-01 00:45:44.000000', 'temperatura', 943.0000, 'ºC'),
	(278923, 121, '2014-04-01 00:45:45.000000', 'temperatura', 371.0000, 'ºC'),
	(278924, 121, '2014-04-01 00:45:46.000000', 'temperatura', 229.0000, 'ºC'),
	(278925, 121, '2014-04-01 00:45:47.000000', 'temperatura', 31.0000, 'ºC'),
	(278926, 121, '2014-04-01 00:45:48.000000', 'temperatura', 667.0000, 'ºC'),
	(278927, 121, '2014-04-01 00:45:49.000000', 'temperatura', 842.0000, 'ºC'),
	(278928, 121, '2014-04-01 00:45:50.000000', 'temperatura', 1011.0000, 'ºC'),
	(278929, 121, '2014-04-01 00:45:51.000000', 'temperatura', 128.0000, 'ºC'),
	(278930, 121, '2014-04-01 00:45:52.000000', 'temperatura', 8.0000, 'ºC'),
	(278931, 121, '2014-04-01 00:45:53.000000', 'temperatura', 858.0000, 'ºC'),
	(278932, 121, '2014-04-01 00:45:54.000000', 'temperatura', 664.0000, 'ºC'),
	(278933, 121, '2014-04-01 00:45:55.000000', 'temperatura', 746.0000, 'ºC'),
	(278934, 121, '2014-04-01 00:45:56.000000', 'temperatura', 540.0000, 'ºC'),
	(278935, 121, '2014-04-01 00:45:57.000000', 'temperatura', 464.0000, 'ºC'),
	(278936, 121, '2014-04-01 00:45:58.000000', 'temperatura', 698.0000, 'ºC'),
	(278937, 121, '2014-04-01 00:45:59.000000', 'temperatura', 898.0000, 'ºC'),
	(278938, 121, '2014-04-01 00:46:00.000000', 'temperatura', 1197.0000, 'ºC'),
	(278939, 121, '2014-04-01 00:46:01.000000', 'temperatura', 893.0000, 'ºC'),
	(278940, 121, '2014-04-01 00:46:02.000000', 'temperatura', 874.0000, 'ºC'),
	(278941, 121, '2014-04-01 00:46:03.000000', 'temperatura', 491.0000, 'ºC'),
	(278942, 121, '2014-04-01 00:46:04.000000', 'temperatura', 1035.0000, 'ºC'),
	(278943, 121, '2014-04-01 00:46:05.000000', 'temperatura', 100.0000, 'ºC'),
	(278944, 121, '2014-04-01 00:46:06.000000', 'temperatura', 996.0000, 'ºC'),
	(278945, 121, '2014-04-01 00:46:07.000000', 'temperatura', 1079.0000, 'ºC'),
	(278946, 121, '2014-04-01 00:46:08.000000', 'temperatura', 9.0000, 'ºC'),
	(278947, 121, '2014-04-01 00:46:09.000000', 'temperatura', 407.0000, 'ºC'),
	(278948, 121, '2014-04-01 00:46:10.000000', 'temperatura', 808.0000, 'ºC'),
	(278949, 121, '2014-04-01 00:46:11.000000', 'temperatura', 421.0000, 'ºC'),
	(278950, 121, '2014-04-01 00:46:12.000000', 'temperatura', 881.0000, 'ºC'),
	(278951, 121, '2014-04-01 00:46:13.000000', 'temperatura', 742.0000, 'ºC'),
	(278952, 121, '2014-04-01 00:46:14.000000', 'temperatura', 1068.0000, 'ºC'),
	(278953, 121, '2014-04-01 00:46:15.000000', 'temperatura', 716.0000, 'ºC'),
	(278954, 121, '2014-04-01 00:46:16.000000', 'temperatura', 376.0000, 'ºC'),
	(278955, 121, '2014-04-01 00:46:17.000000', 'temperatura', 933.0000, 'ºC'),
	(278956, 121, '2014-04-01 00:46:18.000000', 'temperatura', 1136.0000, 'ºC'),
	(278957, 121, '2014-04-01 00:46:19.000000', 'temperatura', 483.0000, 'ºC'),
	(278958, 121, '2014-04-01 00:46:20.000000', 'temperatura', 207.0000, 'ºC'),
	(278959, 121, '2014-04-01 00:46:21.000000', 'temperatura', 788.0000, 'ºC'),
	(278960, 121, '2014-04-01 00:46:22.000000', 'temperatura', 918.0000, 'ºC'),
	(278961, 121, '2014-04-01 00:46:23.000000', 'temperatura', 1028.0000, 'ºC'),
	(278962, 121, '2014-04-01 00:46:24.000000', 'temperatura', 1185.0000, 'ºC'),
	(278963, 121, '2014-04-01 00:46:25.000000', 'temperatura', 442.0000, 'ºC'),
	(278964, 121, '2014-04-01 00:46:26.000000', 'temperatura', 1055.0000, 'ºC'),
	(278965, 121, '2014-04-01 00:46:27.000000', 'temperatura', 349.0000, 'ºC'),
	(278966, 121, '2014-04-01 00:46:28.000000', 'temperatura', 981.0000, 'ºC'),
	(278967, 121, '2014-04-01 00:46:29.000000', 'temperatura', 260.0000, 'ºC'),
	(278968, 121, '2014-04-01 00:46:30.000000', 'temperatura', 755.0000, 'ºC'),
	(278969, 121, '2014-04-01 00:46:31.000000', 'temperatura', 595.0000, 'ºC'),
	(278970, 121, '2014-04-01 00:46:32.000000', 'temperatura', 712.0000, 'ºC'),
	(278971, 121, '2014-04-01 00:46:33.000000', 'temperatura', 574.0000, 'ºC'),
	(278972, 121, '2014-04-01 00:46:34.000000', 'temperatura', 736.0000, 'ºC'),
	(278973, 121, '2014-04-01 00:46:35.000000', 'temperatura', 756.0000, 'ºC'),
	(278974, 121, '2014-04-01 00:46:36.000000', 'temperatura', 374.0000, 'ºC'),
	(278975, 121, '2014-04-01 00:46:37.000000', 'temperatura', 804.0000, 'ºC'),
	(278976, 121, '2014-04-01 00:46:38.000000', 'temperatura', 498.0000, 'ºC'),
	(278977, 121, '2014-04-01 00:46:39.000000', 'temperatura', 78.0000, 'ºC'),
	(278978, 121, '2014-04-01 00:46:40.000000', 'temperatura', 99.0000, 'ºC'),
	(278979, 121, '2014-04-01 00:46:41.000000', 'temperatura', 258.0000, 'ºC'),
	(278980, 121, '2014-04-01 00:46:42.000000', 'temperatura', 995.0000, 'ºC'),
	(278981, 121, '2014-04-01 00:46:43.000000', 'temperatura', 603.0000, 'ºC'),
	(278982, 121, '2014-04-01 00:46:44.000000', 'temperatura', 31.0000, 'ºC'),
	(278983, 121, '2014-04-01 00:46:45.000000', 'temperatura', 745.0000, 'ºC'),
	(278984, 121, '2014-04-01 00:46:46.000000', 'temperatura', 33.0000, 'ºC'),
	(278985, 121, '2014-04-01 00:46:47.000000', 'temperatura', 331.0000, 'ºC'),
	(278986, 121, '2014-04-01 00:46:48.000000', 'temperatura', 356.0000, 'ºC'),
	(278987, 121, '2014-04-01 00:46:49.000000', 'temperatura', 788.0000, 'ºC'),
	(278988, 121, '2014-04-01 00:46:50.000000', 'temperatura', 471.0000, 'ºC'),
	(278989, 121, '2014-04-01 00:46:51.000000', 'temperatura', 1191.0000, 'ºC'),
	(278990, 121, '2014-04-01 00:46:52.000000', 'temperatura', 945.0000, 'ºC'),
	(278991, 121, '2014-04-01 00:46:53.000000', 'temperatura', 1152.0000, 'ºC'),
	(278992, 121, '2014-04-01 00:46:54.000000', 'temperatura', 527.0000, 'ºC'),
	(278993, 121, '2014-04-01 00:46:55.000000', 'temperatura', 377.0000, 'ºC'),
	(278994, 121, '2014-04-01 00:46:56.000000', 'temperatura', 306.0000, 'ºC'),
	(278995, 121, '2014-04-01 00:46:57.000000', 'temperatura', 398.0000, 'ºC'),
	(278996, 121, '2014-04-01 00:46:58.000000', 'temperatura', 1073.0000, 'ºC'),
	(278997, 121, '2014-04-01 00:46:59.000000', 'temperatura', 572.0000, 'ºC'),
	(278998, 121, '2014-04-01 00:47:00.000000', 'temperatura', 840.0000, 'ºC'),
	(278999, 121, '2014-04-01 00:47:01.000000', 'temperatura', 85.0000, 'ºC'),
	(279000, 121, '2014-04-01 00:47:02.000000', 'temperatura', 304.0000, 'ºC'),
	(279001, 121, '2014-04-01 00:47:03.000000', 'temperatura', 68.0000, 'ºC'),
	(279002, 121, '2014-04-01 00:47:04.000000', 'temperatura', 629.0000, 'ºC'),
	(279003, 121, '2014-04-01 00:47:05.000000', 'temperatura', 539.0000, 'ºC'),
	(279004, 121, '2014-04-01 00:47:06.000000', 'temperatura', 812.0000, 'ºC'),
	(279005, 121, '2014-04-01 00:47:07.000000', 'temperatura', 40.0000, 'ºC'),
	(279006, 121, '2014-04-01 00:47:08.000000', 'temperatura', 167.0000, 'ºC'),
	(279007, 121, '2014-04-01 00:47:09.000000', 'temperatura', 714.0000, 'ºC'),
	(279008, 121, '2014-04-01 00:47:10.000000', 'temperatura', 670.0000, 'ºC'),
	(279009, 121, '2014-04-01 00:47:11.000000', 'temperatura', 7.0000, 'ºC'),
	(279010, 121, '2014-04-01 00:47:12.000000', 'temperatura', 427.0000, 'ºC'),
	(279011, 121, '2014-04-01 00:47:13.000000', 'temperatura', 915.0000, 'ºC'),
	(279012, 121, '2014-04-01 00:47:14.000000', 'temperatura', 895.0000, 'ºC'),
	(279013, 121, '2014-04-01 00:47:15.000000', 'temperatura', 531.0000, 'ºC'),
	(279014, 121, '2014-04-01 00:47:16.000000', 'temperatura', 1168.0000, 'ºC'),
	(279015, 121, '2014-04-01 00:47:17.000000', 'temperatura', 651.0000, 'ºC'),
	(279016, 121, '2014-04-01 00:47:18.000000', 'temperatura', 949.0000, 'ºC'),
	(279017, 121, '2014-04-01 00:47:19.000000', 'temperatura', 392.0000, 'ºC'),
	(279018, 121, '2014-04-01 00:47:20.000000', 'temperatura', 314.0000, 'ºC'),
	(279019, 121, '2014-04-01 00:47:21.000000', 'temperatura', 395.0000, 'ºC'),
	(279020, 121, '2014-04-01 00:47:22.000000', 'temperatura', 1035.0000, 'ºC'),
	(279021, 121, '2014-04-01 00:47:23.000000', 'temperatura', 390.0000, 'ºC'),
	(279022, 121, '2014-04-01 00:47:24.000000', 'temperatura', 43.0000, 'ºC'),
	(279023, 121, '2014-04-01 00:47:25.000000', 'temperatura', 247.0000, 'ºC'),
	(279024, 121, '2014-04-01 00:47:26.000000', 'temperatura', 1107.0000, 'ºC'),
	(279025, 121, '2014-04-01 00:47:27.000000', 'temperatura', 1194.0000, 'ºC'),
	(279026, 121, '2014-04-01 00:47:28.000000', 'temperatura', 250.0000, 'ºC'),
	(279027, 121, '2014-04-01 00:47:29.000000', 'temperatura', 68.0000, 'ºC'),
	(279028, 121, '2014-04-01 00:47:30.000000', 'temperatura', 790.0000, 'ºC'),
	(279029, 121, '2014-04-01 00:47:31.000000', 'temperatura', 146.0000, 'ºC'),
	(279030, 121, '2014-04-01 00:47:32.000000', 'temperatura', 760.0000, 'ºC'),
	(279031, 121, '2014-04-01 00:47:33.000000', 'temperatura', 962.0000, 'ºC'),
	(279032, 121, '2014-04-01 00:47:34.000000', 'temperatura', 132.0000, 'ºC'),
	(279033, 121, '2014-04-01 00:47:35.000000', 'temperatura', 175.0000, 'ºC'),
	(279034, 121, '2014-04-01 00:47:36.000000', 'temperatura', 477.0000, 'ºC'),
	(279035, 121, '2014-04-01 00:47:37.000000', 'temperatura', 663.0000, 'ºC'),
	(279036, 121, '2014-04-01 00:47:38.000000', 'temperatura', 685.0000, 'ºC'),
	(279037, 121, '2014-04-01 00:47:39.000000', 'temperatura', 235.0000, 'ºC'),
	(279038, 121, '2014-04-01 00:47:40.000000', 'temperatura', 320.0000, 'ºC'),
	(279039, 121, '2014-04-01 00:47:41.000000', 'temperatura', 897.0000, 'ºC'),
	(279040, 121, '2014-04-01 00:47:42.000000', 'temperatura', 1125.0000, 'ºC'),
	(279041, 121, '2014-04-01 00:47:43.000000', 'temperatura', 536.0000, 'ºC'),
	(279042, 121, '2014-04-01 00:47:44.000000', 'temperatura', 505.0000, 'ºC'),
	(279043, 121, '2014-04-01 00:47:45.000000', 'temperatura', 915.0000, 'ºC'),
	(279044, 121, '2014-04-01 00:47:46.000000', 'temperatura', 662.0000, 'ºC'),
	(279045, 121, '2014-04-01 00:47:47.000000', 'temperatura', 564.0000, 'ºC'),
	(279046, 121, '2014-04-01 00:47:48.000000', 'temperatura', 837.0000, 'ºC'),
	(279047, 121, '2014-04-01 00:47:49.000000', 'temperatura', 92.0000, 'ºC'),
	(279048, 121, '2014-04-01 00:47:50.000000', 'temperatura', 349.0000, 'ºC'),
	(279049, 121, '2014-04-01 00:47:51.000000', 'temperatura', 270.0000, 'ºC'),
	(279050, 121, '2014-04-01 00:47:52.000000', 'temperatura', 304.0000, 'ºC'),
	(279051, 121, '2014-04-01 00:47:53.000000', 'temperatura', 712.0000, 'ºC'),
	(279052, 121, '2014-04-01 00:47:54.000000', 'temperatura', 247.0000, 'ºC'),
	(279053, 121, '2014-04-01 00:47:55.000000', 'temperatura', 298.0000, 'ºC'),
	(279054, 121, '2014-04-01 00:47:56.000000', 'temperatura', 750.0000, 'ºC'),
	(279055, 121, '2014-04-01 00:47:57.000000', 'temperatura', 457.0000, 'ºC'),
	(279056, 121, '2014-04-01 00:47:58.000000', 'temperatura', 34.0000, 'ºC'),
	(279057, 121, '2014-04-01 00:47:59.000000', 'temperatura', 0.0000, 'ºC'),
	(279058, 121, '2014-04-01 00:48:00.000000', 'temperatura', 1099.0000, 'ºC'),
	(279059, 121, '2014-04-01 00:48:01.000000', 'temperatura', 695.0000, 'ºC'),
	(279060, 121, '2014-04-01 00:48:02.000000', 'temperatura', 179.0000, 'ºC'),
	(279061, 121, '2014-04-01 00:48:03.000000', 'temperatura', 11.0000, 'ºC'),
	(279062, 121, '2014-04-01 00:48:04.000000', 'temperatura', 719.0000, 'ºC'),
	(279063, 121, '2014-04-01 00:48:05.000000', 'temperatura', 1161.0000, 'ºC'),
	(279064, 121, '2014-04-01 00:48:06.000000', 'temperatura', 51.0000, 'ºC'),
	(279065, 121, '2014-04-01 00:48:07.000000', 'temperatura', 371.0000, 'ºC'),
	(279066, 121, '2014-04-01 00:48:08.000000', 'temperatura', 502.0000, 'ºC'),
	(279067, 121, '2014-04-01 00:48:09.000000', 'temperatura', 200.0000, 'ºC'),
	(279068, 121, '2014-04-01 00:48:10.000000', 'temperatura', 692.0000, 'ºC'),
	(279069, 121, '2014-04-01 00:48:11.000000', 'temperatura', 463.0000, 'ºC'),
	(279070, 121, '2014-04-01 00:48:12.000000', 'temperatura', 239.0000, 'ºC'),
	(279071, 121, '2014-04-01 00:48:13.000000', 'temperatura', 1006.0000, 'ºC'),
	(279072, 121, '2014-04-01 00:48:14.000000', 'temperatura', 712.0000, 'ºC'),
	(279073, 121, '2014-04-01 00:48:15.000000', 'temperatura', 545.0000, 'ºC'),
	(279074, 121, '2014-04-01 00:48:16.000000', 'temperatura', 590.0000, 'ºC'),
	(279075, 121, '2014-04-01 00:48:17.000000', 'temperatura', 113.0000, 'ºC'),
	(279076, 121, '2014-04-01 00:48:18.000000', 'temperatura', 1196.0000, 'ºC'),
	(279077, 121, '2014-04-01 00:48:19.000000', 'temperatura', 840.0000, 'ºC'),
	(279078, 121, '2014-04-01 00:48:20.000000', 'temperatura', 614.0000, 'ºC'),
	(279079, 121, '2014-04-01 00:48:21.000000', 'temperatura', 552.0000, 'ºC'),
	(279080, 121, '2014-04-01 00:48:22.000000', 'temperatura', 916.0000, 'ºC'),
	(279081, 121, '2014-04-01 00:48:23.000000', 'temperatura', 527.0000, 'ºC'),
	(279082, 121, '2014-04-01 00:48:24.000000', 'temperatura', 1088.0000, 'ºC'),
	(279083, 121, '2014-04-01 00:48:25.000000', 'temperatura', 257.0000, 'ºC'),
	(279084, 121, '2014-04-01 00:48:26.000000', 'temperatura', 421.0000, 'ºC'),
	(279085, 121, '2014-04-01 00:48:27.000000', 'temperatura', 138.0000, 'ºC'),
	(279086, 121, '2014-04-01 00:48:28.000000', 'temperatura', 624.0000, 'ºC'),
	(279087, 121, '2014-04-01 00:48:29.000000', 'temperatura', 309.0000, 'ºC'),
	(279088, 121, '2014-04-01 00:48:30.000000', 'temperatura', 873.0000, 'ºC'),
	(279089, 121, '2014-04-01 00:48:31.000000', 'temperatura', 1040.0000, 'ºC'),
	(279090, 121, '2014-04-01 00:48:32.000000', 'temperatura', 179.0000, 'ºC'),
	(279091, 121, '2014-04-01 00:48:33.000000', 'temperatura', 179.0000, 'ºC'),
	(279092, 121, '2014-04-01 00:48:34.000000', 'temperatura', 355.0000, 'ºC'),
	(279093, 121, '2014-04-01 00:48:35.000000', 'temperatura', 38.0000, 'ºC'),
	(279094, 121, '2014-04-01 00:48:36.000000', 'temperatura', 328.0000, 'ºC'),
	(279095, 121, '2014-04-01 00:48:37.000000', 'temperatura', 324.0000, 'ºC'),
	(279096, 121, '2014-04-01 00:48:38.000000', 'temperatura', 636.0000, 'ºC'),
	(279097, 121, '2014-04-01 00:48:39.000000', 'temperatura', 1008.0000, 'ºC'),
	(279098, 121, '2014-04-01 00:48:40.000000', 'temperatura', 733.0000, 'ºC'),
	(279099, 121, '2014-04-01 00:48:41.000000', 'temperatura', 641.0000, 'ºC'),
	(279100, 121, '2014-04-01 00:48:42.000000', 'temperatura', 1005.0000, 'ºC'),
	(279101, 121, '2014-04-01 00:48:43.000000', 'temperatura', 706.0000, 'ºC'),
	(279102, 121, '2014-04-01 00:48:44.000000', 'temperatura', 514.0000, 'ºC'),
	(279103, 121, '2014-04-01 00:48:45.000000', 'temperatura', 451.0000, 'ºC'),
	(279104, 121, '2014-04-01 00:48:46.000000', 'temperatura', 715.0000, 'ºC'),
	(279105, 121, '2014-04-01 00:48:47.000000', 'temperatura', 1024.0000, 'ºC'),
	(279106, 121, '2014-04-01 00:48:48.000000', 'temperatura', 573.0000, 'ºC'),
	(279107, 121, '2014-04-01 00:48:49.000000', 'temperatura', 994.0000, 'ºC'),
	(279108, 121, '2014-04-01 00:48:50.000000', 'temperatura', 852.0000, 'ºC'),
	(279109, 121, '2014-04-01 00:48:51.000000', 'temperatura', 77.0000, 'ºC'),
	(279110, 121, '2014-04-01 00:48:52.000000', 'temperatura', 230.0000, 'ºC'),
	(279111, 121, '2014-04-01 00:48:53.000000', 'temperatura', 918.0000, 'ºC'),
	(279112, 121, '2014-04-01 00:48:54.000000', 'temperatura', 303.0000, 'ºC'),
	(279113, 121, '2014-04-01 00:48:55.000000', 'temperatura', 1162.0000, 'ºC'),
	(279114, 121, '2014-04-01 00:48:56.000000', 'temperatura', 101.0000, 'ºC'),
	(279115, 121, '2014-04-01 00:48:57.000000', 'temperatura', 618.0000, 'ºC'),
	(279116, 121, '2014-04-01 00:48:58.000000', 'temperatura', 389.0000, 'ºC'),
	(279117, 121, '2014-04-01 00:48:59.000000', 'temperatura', 89.0000, 'ºC'),
	(279118, 121, '2014-04-01 00:49:00.000000', 'temperatura', 481.0000, 'ºC'),
	(279119, 121, '2014-04-01 00:49:01.000000', 'temperatura', 938.0000, 'ºC'),
	(279120, 121, '2014-04-01 00:49:02.000000', 'temperatura', 847.0000, 'ºC'),
	(279121, 121, '2014-04-01 00:49:03.000000', 'temperatura', 222.0000, 'ºC'),
	(279122, 121, '2014-04-01 00:49:04.000000', 'temperatura', 969.0000, 'ºC'),
	(279123, 121, '2014-04-01 00:49:05.000000', 'temperatura', 581.0000, 'ºC'),
	(279124, 121, '2014-04-01 00:49:06.000000', 'temperatura', 1198.0000, 'ºC'),
	(279125, 121, '2014-04-01 00:49:07.000000', 'temperatura', 647.0000, 'ºC'),
	(279126, 121, '2014-04-01 00:49:08.000000', 'temperatura', 843.0000, 'ºC'),
	(279127, 121, '2014-04-01 00:49:09.000000', 'temperatura', 1073.0000, 'ºC'),
	(279128, 121, '2014-04-01 00:49:10.000000', 'temperatura', 436.0000, 'ºC'),
	(279129, 121, '2014-04-01 00:49:11.000000', 'temperatura', 162.0000, 'ºC'),
	(279130, 121, '2014-04-01 00:49:12.000000', 'temperatura', 704.0000, 'ºC'),
	(279131, 121, '2014-04-01 00:49:13.000000', 'temperatura', 634.0000, 'ºC'),
	(279132, 121, '2014-04-01 00:49:14.000000', 'temperatura', 1060.0000, 'ºC'),
	(279133, 121, '2014-04-01 00:49:15.000000', 'temperatura', 997.0000, 'ºC'),
	(279134, 121, '2014-04-01 00:49:16.000000', 'temperatura', 605.0000, 'ºC'),
	(279135, 121, '2014-04-01 00:49:17.000000', 'temperatura', 33.0000, 'ºC'),
	(279136, 121, '2014-04-01 00:49:18.000000', 'temperatura', 752.0000, 'ºC'),
	(279137, 121, '2014-04-01 00:49:19.000000', 'temperatura', 61.0000, 'ºC'),
	(279138, 121, '2014-04-01 00:49:20.000000', 'temperatura', 450.0000, 'ºC'),
	(279139, 121, '2014-04-01 00:49:21.000000', 'temperatura', 868.0000, 'ºC'),
	(279140, 121, '2014-04-01 00:49:22.000000', 'temperatura', 590.0000, 'ºC'),
	(279141, 121, '2014-04-01 00:49:23.000000', 'temperatura', 348.0000, 'ºC'),
	(279142, 121, '2014-04-01 00:49:24.000000', 'temperatura', 1171.0000, 'ºC'),
	(279143, 121, '2014-04-01 00:49:25.000000', 'temperatura', 10.0000, 'ºC'),
	(279144, 121, '2014-04-01 00:49:26.000000', 'temperatura', 137.0000, 'ºC'),
	(279145, 121, '2014-04-01 00:49:27.000000', 'temperatura', 657.0000, 'ºC'),
	(279146, 121, '2014-04-01 00:49:28.000000', 'temperatura', 474.0000, 'ºC'),
	(279147, 121, '2014-04-01 00:49:29.000000', 'temperatura', 399.0000, 'ºC'),
	(279148, 121, '2014-04-01 00:49:30.000000', 'temperatura', 574.0000, 'ºC'),
	(279149, 121, '2014-04-01 00:49:31.000000', 'temperatura', 473.0000, 'ºC'),
	(279150, 121, '2014-04-01 00:49:32.000000', 'temperatura', 644.0000, 'ºC'),
	(279151, 121, '2014-04-01 00:49:33.000000', 'temperatura', 600.0000, 'ºC'),
	(279152, 121, '2014-04-01 00:49:34.000000', 'temperatura', 1068.0000, 'ºC'),
	(279153, 121, '2014-04-01 00:49:35.000000', 'temperatura', 1140.0000, 'ºC'),
	(279154, 121, '2014-04-01 00:49:36.000000', 'temperatura', 100.0000, 'ºC'),
	(279155, 121, '2014-04-01 00:49:37.000000', 'temperatura', 677.0000, 'ºC'),
	(279156, 121, '2014-04-01 00:49:38.000000', 'temperatura', 689.0000, 'ºC'),
	(279157, 121, '2014-04-01 00:49:39.000000', 'temperatura', 211.0000, 'ºC'),
	(279158, 121, '2014-04-01 00:49:40.000000', 'temperatura', 191.0000, 'ºC'),
	(279159, 121, '2014-04-01 00:49:41.000000', 'temperatura', 321.0000, 'ºC'),
	(279160, 121, '2014-04-01 00:49:42.000000', 'temperatura', 1034.0000, 'ºC'),
	(279161, 121, '2014-04-01 00:49:43.000000', 'temperatura', 607.0000, 'ºC'),
	(279162, 121, '2014-04-01 00:49:44.000000', 'temperatura', 1132.0000, 'ºC'),
	(279163, 121, '2014-04-01 00:49:45.000000', 'temperatura', 239.0000, 'ºC'),
	(279164, 121, '2014-04-01 00:49:46.000000', 'temperatura', 201.0000, 'ºC'),
	(279165, 121, '2014-04-01 00:49:47.000000', 'temperatura', 289.0000, 'ºC'),
	(279166, 121, '2014-04-01 00:49:48.000000', 'temperatura', 840.0000, 'ºC'),
	(279167, 121, '2014-04-01 00:49:49.000000', 'temperatura', 935.0000, 'ºC'),
	(279168, 121, '2014-04-01 00:49:50.000000', 'temperatura', 955.0000, 'ºC'),
	(279169, 121, '2014-04-01 00:49:51.000000', 'temperatura', 769.0000, 'ºC'),
	(279170, 121, '2014-04-01 00:49:52.000000', 'temperatura', 982.0000, 'ºC'),
	(279171, 121, '2014-04-01 00:49:53.000000', 'temperatura', 203.0000, 'ºC'),
	(279172, 121, '2014-04-01 00:49:54.000000', 'temperatura', 471.0000, 'ºC'),
	(279173, 121, '2014-04-01 00:49:55.000000', 'temperatura', 544.0000, 'ºC'),
	(279174, 121, '2014-04-01 00:49:56.000000', 'temperatura', 111.0000, 'ºC'),
	(279175, 121, '2014-04-01 00:49:57.000000', 'temperatura', 120.0000, 'ºC'),
	(279176, 121, '2014-04-01 00:49:58.000000', 'temperatura', 268.0000, 'ºC'),
	(279177, 121, '2014-04-01 00:49:59.000000', 'temperatura', 982.0000, 'ºC'),
	(279178, 121, '2014-04-01 00:50:00.000000', 'temperatura', 505.0000, 'ºC'),
	(279179, 121, '2014-04-01 00:50:01.000000', 'temperatura', 781.0000, 'ºC'),
	(279180, 121, '2014-04-01 00:50:02.000000', 'temperatura', 1189.0000, 'ºC'),
	(279181, 121, '2014-04-01 00:50:03.000000', 'temperatura', 5.0000, 'ºC'),
	(279182, 121, '2014-04-01 00:50:04.000000', 'temperatura', 56.0000, 'ºC'),
	(279183, 121, '2014-04-01 00:50:05.000000', 'temperatura', 267.0000, 'ºC'),
	(279184, 121, '2014-04-01 00:50:06.000000', 'temperatura', 1169.0000, 'ºC'),
	(279185, 121, '2014-04-01 00:50:07.000000', 'temperatura', 241.0000, 'ºC'),
	(279186, 121, '2014-04-01 00:50:08.000000', 'temperatura', 100.0000, 'ºC'),
	(279187, 121, '2014-04-01 00:50:09.000000', 'temperatura', 977.0000, 'ºC'),
	(279188, 121, '2014-04-01 00:50:10.000000', 'temperatura', 987.0000, 'ºC'),
	(279189, 121, '2014-04-01 00:50:11.000000', 'temperatura', 803.0000, 'ºC'),
	(279190, 121, '2014-04-01 00:50:12.000000', 'temperatura', 1057.0000, 'ºC'),
	(279191, 121, '2014-04-01 00:50:13.000000', 'temperatura', 474.0000, 'ºC'),
	(279192, 121, '2014-04-01 00:50:14.000000', 'temperatura', 399.0000, 'ºC'),
	(279193, 121, '2014-04-01 00:50:15.000000', 'temperatura', 574.0000, 'ºC'),
	(279194, 121, '2014-04-01 00:50:16.000000', 'temperatura', 472.0000, 'ºC'),
	(279195, 121, '2014-04-01 00:50:17.000000', 'temperatura', 639.0000, 'ºC'),
	(279196, 121, '2014-04-01 00:50:18.000000', 'temperatura', 580.0000, 'ºC'),
	(279197, 121, '2014-04-01 00:50:19.000000', 'temperatura', 982.0000, 'ºC'),
	(279198, 121, '2014-04-01 00:50:20.000000', 'temperatura', 773.0000, 'ºC'),
	(279199, 121, '2014-04-01 00:50:21.000000', 'temperatura', 917.0000, 'ºC'),
	(279200, 121, '2014-04-01 00:50:22.000000', 'temperatura', 1069.0000, 'ºC'),
	(279201, 121, '2014-04-01 00:50:23.000000', 'temperatura', 192.0000, 'ºC'),
	(279202, 121, '2014-04-01 00:50:24.000000', 'temperatura', 152.0000, 'ºC'),
	(279203, 121, '2014-04-01 00:50:25.000000', 'temperatura', 188.0000, 'ºC'),
	(279204, 121, '2014-04-01 00:50:26.000000', 'temperatura', 484.0000, 'ºC'),
	(279205, 121, '2014-04-01 00:50:27.000000', 'temperatura', 657.0000, 'ºC'),
	(279206, 121, '2014-04-01 00:50:28.000000', 'temperatura', 632.0000, 'ºC'),
	(279207, 121, '2014-04-01 00:50:29.000000', 'temperatura', 1188.0000, 'ºC'),
	(279208, 121, '2014-04-01 00:50:30.000000', 'temperatura', 447.0000, 'ºC'),
	(279209, 121, '2014-04-01 00:50:31.000000', 'temperatura', 1070.0000, 'ºC'),
	(279210, 121, '2014-04-01 00:50:32.000000', 'temperatura', 411.0000, 'ºC'),
	(279211, 121, '2014-04-01 00:50:33.000000', 'temperatura', 46.0000, 'ºC'),
	(279212, 121, '2014-04-01 00:50:34.000000', 'temperatura', 197.0000, 'ºC'),
	(279213, 121, '2014-04-01 00:50:35.000000', 'temperatura', 845.0000, 'ºC'),
	(279214, 121, '2014-04-01 00:50:36.000000', 'temperatura', 38.0000, 'ºC'),
	(279215, 121, '2014-04-01 00:50:37.000000', 'temperatura', 52.0000, 'ºC'),
	(279216, 121, '2014-04-01 00:50:38.000000', 'temperatura', 149.0000, 'ºC'),
	(279217, 121, '2014-04-01 00:50:39.000000', 'temperatura', 588.0000, 'ºC'),
	(279218, 121, '2014-04-01 00:50:40.000000', 'temperatura', 95.0000, 'ºC'),
	(279219, 121, '2014-04-01 00:50:41.000000', 'temperatura', 1109.0000, 'ºC'),
	(279220, 121, '2014-04-01 00:50:42.000000', 'temperatura', 461.0000, 'ºC'),
	(279221, 121, '2014-04-01 00:50:43.000000', 'temperatura', 181.0000, 'ºC'),
	(279222, 121, '2014-04-01 00:50:44.000000', 'temperatura', 721.0000, 'ºC'),
	(279223, 121, '2014-04-01 00:50:45.000000', 'temperatura', 662.0000, 'ºC'),
	(279224, 121, '2014-04-01 00:50:46.000000', 'temperatura', 1148.0000, 'ºC'),
	(279225, 121, '2014-04-01 00:50:47.000000', 'temperatura', 154.0000, 'ºC'),
	(279226, 121, '2014-04-01 00:50:48.000000', 'temperatura', 929.0000, 'ºC'),
	(279227, 121, '2014-04-01 00:50:49.000000', 'temperatura', 582.0000, 'ºC'),
	(279228, 121, '2014-04-01 00:50:50.000000', 'temperatura', 122.0000, 'ºC'),
	(279229, 121, '2014-04-01 00:50:51.000000', 'temperatura', 66.0000, 'ºC'),
	(279230, 121, '2014-04-01 00:50:52.000000', 'temperatura', 1162.0000, 'ºC'),
	(279231, 121, '2014-04-01 00:50:53.000000', 'temperatura', 814.0000, 'ºC'),
	(279232, 121, '2014-04-01 00:50:54.000000', 'temperatura', 586.0000, 'ºC'),
	(279233, 121, '2014-04-01 00:50:55.000000', 'temperatura', 487.0000, 'ºC'),
	(279234, 121, '2014-04-01 00:50:56.000000', 'temperatura', 678.0000, 'ºC'),
	(279235, 121, '2014-04-01 00:50:57.000000', 'temperatura', 730.0000, 'ºC'),
	(279236, 121, '2014-04-01 00:50:58.000000', 'temperatura', 415.0000, 'ºC'),
	(279237, 121, '2014-04-01 00:50:59.000000', 'temperatura', 1085.0000, 'ºC'),
	(279238, 121, '2014-04-01 00:51:00.000000', 'temperatura', 580.0000, 'ºC'),
	(279239, 121, '2014-04-01 00:51:01.000000', 'temperatura', 847.0000, 'ºC'),
	(279240, 121, '2014-04-01 00:51:02.000000', 'temperatura', 94.0000, 'ºC'),
	(279241, 121, '2014-04-01 00:51:03.000000', 'temperatura', 329.0000, 'ºC'),
	(279242, 121, '2014-04-01 00:51:04.000000', 'temperatura', 163.0000, 'ºC'),
	(279243, 121, '2014-04-01 00:51:05.000000', 'temperatura', 1029.0000, 'ºC'),
	(279244, 121, '2014-04-01 00:51:06.000000', 'temperatura', 1056.0000, 'ºC'),
	(279245, 121, '2014-04-01 00:51:07.000000', 'temperatura', 993.0000, 'ºC'),
	(279246, 121, '2014-04-01 00:51:08.000000', 'temperatura', 600.0000, 'ºC'),
	(279247, 121, '2014-04-01 00:51:09.000000', 'temperatura', 18.0000, 'ºC'),
	(279248, 121, '2014-04-01 00:51:10.000000', 'temperatura', 693.0000, 'ºC'),
	(279249, 121, '2014-04-01 00:51:11.000000', 'temperatura', 1012.0000, 'ºC'),
	(279250, 121, '2014-04-01 00:51:12.000000', 'temperatura', 580.0000, 'ºC'),
	(279251, 121, '2014-04-01 00:51:13.000000', 'temperatura', 1064.0000, 'ºC'),
	(279252, 121, '2014-04-01 00:51:14.000000', 'temperatura', 1180.0000, 'ºC'),
	(279253, 121, '2014-04-01 00:51:15.000000', 'temperatura', 310.0000, 'ºC'),
	(279254, 121, '2014-04-01 00:51:16.000000', 'temperatura', 411.0000, 'ºC'),
	(279255, 121, '2014-04-01 00:51:17.000000', 'temperatura', 1123.0000, 'ºC'),
	(279256, 121, '2014-04-01 00:51:18.000000', 'temperatura', 786.0000, 'ºC'),
	(279257, 121, '2014-04-01 00:51:19.000000', 'temperatura', 559.0000, 'ºC'),
	(279258, 121, '2014-04-01 00:51:20.000000', 'temperatura', 436.0000, 'ºC'),
	(279259, 121, '2014-04-01 00:51:21.000000', 'temperatura', 507.0000, 'ºC'),
	(279260, 121, '2014-04-01 00:51:22.000000', 'temperatura', 25.0000, 'ºC'),
	(279261, 121, '2014-04-01 00:51:23.000000', 'temperatura', 1005.0000, 'ºC'),
	(279262, 121, '2014-04-01 00:51:24.000000', 'temperatura', 149.0000, 'ºC'),
	(279263, 121, '2014-04-01 00:51:25.000000', 'temperatura', 132.0000, 'ºC'),
	(279264, 121, '2014-04-01 00:51:26.000000', 'temperatura', 211.0000, 'ºC'),
	(279265, 121, '2014-04-01 00:51:27.000000', 'temperatura', 663.0000, 'ºC'),
	(279266, 121, '2014-04-01 00:51:28.000000', 'temperatura', 281.0000, 'ºC'),
	(279267, 121, '2014-04-01 00:51:29.000000', 'temperatura', 616.0000, 'ºC'),
	(279268, 121, '2014-04-01 00:51:30.000000', 'temperatura', 1039.0000, 'ºC'),
	(279269, 121, '2014-04-01 00:51:31.000000', 'temperatura', 949.0000, 'ºC'),
	(279270, 121, '2014-04-01 00:51:32.000000', 'temperatura', 426.0000, 'ºC'),
	(279271, 121, '2014-04-01 00:51:33.000000', 'temperatura', 485.0000, 'ºC'),
	(279272, 121, '2014-04-01 00:51:34.000000', 'temperatura', 1147.0000, 'ºC'),
	(279273, 121, '2014-04-01 00:51:35.000000', 'temperatura', 681.0000, 'ºC'),
	(279274, 121, '2014-04-01 00:51:36.000000', 'temperatura', 1165.0000, 'ºC'),
	(279275, 121, '2014-04-01 00:51:37.000000', 'temperatura', 180.0000, 'ºC'),
	(279276, 121, '2014-04-01 00:51:38.000000', 'temperatura', 1006.0000, 'ºC'),
	(279277, 121, '2014-04-01 00:51:39.000000', 'temperatura', 892.0000, 'ºC'),
	(279278, 121, '2014-04-01 00:51:40.000000', 'temperatura', 243.0000, 'ºC'),
	(279279, 121, '2014-04-01 00:51:41.000000', 'temperatura', 939.0000, 'ºC'),
	(279280, 121, '2014-04-01 00:51:42.000000', 'temperatura', 367.0000, 'ºC'),
	(279281, 121, '2014-04-01 00:51:43.000000', 'temperatura', 220.0000, 'ºC'),
	(279282, 121, '2014-04-01 00:51:44.000000', 'temperatura', 1197.0000, 'ºC'),
	(279283, 121, '2014-04-01 00:51:45.000000', 'temperatura', 527.0000, 'ºC'),
	(279284, 121, '2014-04-01 00:51:46.000000', 'temperatura', 245.0000, 'ºC'),
	(279285, 121, '2014-04-01 00:51:47.000000', 'temperatura', 843.0000, 'ºC'),
	(279286, 121, '2014-04-01 00:51:48.000000', 'temperatura', 1081.0000, 'ºC'),
	(279287, 121, '2014-04-01 00:51:49.000000', 'temperatura', 477.0000, 'ºC'),
	(279288, 121, '2014-04-01 00:51:50.000000', 'temperatura', 344.0000, 'ºC'),
	(279289, 121, '2014-04-01 00:51:51.000000', 'temperatura', 288.0000, 'ºC'),
	(279290, 121, '2014-04-01 00:51:52.000000', 'temperatura', 408.0000, 'ºC'),
	(279291, 121, '2014-04-01 00:51:53.000000', 'temperatura', 1178.0000, 'ºC'),
	(279292, 121, '2014-04-01 00:51:54.000000', 'temperatura', 1067.0000, 'ºC'),
	(279293, 121, '2014-04-01 00:51:55.000000', 'temperatura', 602.0000, 'ºC'),
	(279294, 121, '2014-04-01 00:51:56.000000', 'temperatura', 1010.0000, 'ºC'),
	(279295, 121, '2014-04-01 00:51:57.000000', 'temperatura', 843.0000, 'ºC'),
	(279296, 121, '2014-04-01 00:51:58.000000', 'temperatura', 1184.0000, 'ºC'),
	(279297, 121, '2014-04-01 00:51:59.000000', 'temperatura', 992.0000, 'ºC'),
	(279298, 121, '2014-04-01 00:52:00.000000', 'temperatura', 210.0000, 'ºC'),
	(279299, 121, '2014-04-01 00:52:01.000000', 'temperatura', 475.0000, 'ºC'),
	(279300, 121, '2014-04-01 00:52:02.000000', 'temperatura', 543.0000, 'ºC'),
	(279301, 121, '2014-04-01 00:52:03.000000', 'temperatura', 93.0000, 'ºC'),
	(279302, 121, '2014-04-01 00:52:04.000000', 'temperatura', 33.0000, 'ºC'),
	(279303, 121, '2014-04-01 00:52:05.000000', 'temperatura', 1090.0000, 'ºC'),
	(279304, 121, '2014-04-01 00:52:06.000000', 'temperatura', 551.0000, 'ºC'),
	(279305, 121, '2014-04-01 00:52:07.000000', 'temperatura', 685.0000, 'ºC'),
	(279306, 121, '2014-04-01 00:52:08.000000', 'temperatura', 572.0000, 'ºC'),
	(279307, 121, '2014-04-01 00:52:09.000000', 'temperatura', 806.0000, 'ºC'),
	(279308, 121, '2014-04-01 00:52:10.000000', 'temperatura', 1113.0000, 'ºC'),
	(279309, 121, '2014-04-01 00:52:11.000000', 'temperatura', 749.0000, 'ºC'),
	(279310, 121, '2014-04-01 00:52:12.000000', 'temperatura', 408.0000, 'ºC'),
	(279311, 121, '2014-04-01 00:52:13.000000', 'temperatura', 992.0000, 'ºC'),
	(279312, 121, '2014-04-01 00:52:14.000000', 'temperatura', 137.0000, 'ºC'),
	(279313, 121, '2014-04-01 00:52:15.000000', 'temperatura', 110.0000, 'ºC'),
	(279314, 121, '2014-04-01 00:52:16.000000', 'temperatura', 137.0000, 'ºC'),
	(279315, 121, '2014-04-01 00:52:17.000000', 'temperatura', 358.0000, 'ºC'),
	(279316, 121, '2014-04-01 00:52:18.000000', 'temperatura', 178.0000, 'ºC'),
	(279317, 121, '2014-04-01 00:52:19.000000', 'temperatura', 1018.0000, 'ºC'),
	(279318, 121, '2014-04-01 00:52:20.000000', 'temperatura', 955.0000, 'ºC'),
	(279319, 121, '2014-04-01 00:52:21.000000', 'temperatura', 521.0000, 'ºC'),
	(279320, 121, '2014-04-01 00:52:22.000000', 'temperatura', 939.0000, 'ºC'),
	(279321, 121, '2014-04-01 00:52:23.000000', 'temperatura', 736.0000, 'ºC'),
	(279322, 121, '2014-04-01 00:52:24.000000', 'temperatura', 861.0000, 'ºC'),
	(279323, 121, '2014-04-01 00:52:25.000000', 'temperatura', 897.0000, 'ºC'),
	(279324, 121, '2014-04-01 00:52:26.000000', 'temperatura', 705.0000, 'ºC'),
	(279325, 121, '2014-04-01 00:52:27.000000', 'temperatura', 835.0000, 'ºC'),
	(279326, 121, '2014-04-01 00:52:28.000000', 'temperatura', 861.0000, 'ºC'),
	(279327, 121, '2014-04-01 00:52:29.000000', 'temperatura', 599.0000, 'ºC'),
	(279328, 121, '2014-04-01 00:52:30.000000', 'temperatura', 411.0000, 'ºC'),
	(279329, 121, '2014-04-01 00:52:31.000000', 'temperatura', 259.0000, 'ºC'),
	(279330, 121, '2014-04-01 00:52:32.000000', 'temperatura', 65.0000, 'ºC'),
	(279331, 121, '2014-04-01 00:52:33.000000', 'temperatura', 747.0000, 'ºC'),
	(279332, 121, '2014-04-01 00:52:34.000000', 'temperatura', 1139.0000, 'ºC'),
	(279333, 121, '2014-04-01 00:52:35.000000', 'temperatura', 1055.0000, 'ºC'),
	(279334, 121, '2014-04-01 00:52:36.000000', 'temperatura', 658.0000, 'ºC'),
	(279335, 121, '2014-04-01 00:52:37.000000', 'temperatura', 125.0000, 'ºC'),
	(279336, 121, '2014-04-01 00:52:38.000000', 'temperatura', 1052.0000, 'ºC'),
	(279337, 121, '2014-04-01 00:52:39.000000', 'temperatura', 84.0000, 'ºC'),
	(279338, 121, '2014-04-01 00:52:40.000000', 'temperatura', 867.0000, 'ºC'),
	(279339, 121, '2014-04-01 00:52:41.000000', 'temperatura', 482.0000, 'ºC'),
	(279340, 121, '2014-04-01 00:52:42.000000', 'temperatura', 1012.0000, 'ºC'),
	(279341, 121, '2014-04-01 00:52:43.000000', 'temperatura', 12.0000, 'ºC'),
	(279342, 121, '2014-04-01 00:52:44.000000', 'temperatura', 626.0000, 'ºC'),
	(279343, 121, '2014-04-01 00:52:45.000000', 'temperatura', 696.0000, 'ºC'),
	(279344, 121, '2014-04-01 00:52:46.000000', 'temperatura', 401.0000, 'ºC'),
	(279345, 121, '2014-04-01 00:52:47.000000', 'temperatura', 1116.0000, 'ºC'),
	(279346, 121, '2014-04-01 00:52:48.000000', 'temperatura', 779.0000, 'ºC'),
	(279347, 121, '2014-04-01 00:52:49.000000', 'temperatura', 547.0000, 'ºC'),
	(279348, 121, '2014-04-01 00:52:50.000000', 'temperatura', 400.0000, 'ºC'),
	(279349, 121, '2014-04-01 00:52:51.000000', 'temperatura', 357.0000, 'ºC'),
	(279350, 121, '2014-04-01 00:52:52.000000', 'temperatura', 589.0000, 'ºC'),
	(279351, 121, '2014-04-01 00:52:53.000000', 'temperatura', 671.0000, 'ºC'),
	(279352, 121, '2014-04-01 00:52:54.000000', 'temperatura', 389.0000, 'ºC'),
	(279353, 121, '2014-04-01 00:52:55.000000', 'temperatura', 1132.0000, 'ºC'),
	(279354, 121, '2014-04-01 00:52:56.000000', 'temperatura', 896.0000, 'ºC'),
	(279355, 121, '2014-04-01 00:52:57.000000', 'temperatura', 1084.0000, 'ºC'),
	(279356, 121, '2014-04-01 00:52:58.000000', 'temperatura', 333.0000, 'ºC'),
	(279357, 121, '2014-04-01 00:52:59.000000', 'temperatura', 813.0000, 'ºC'),
	(279358, 121, '2014-04-01 00:53:00.000000', 'temperatura', 667.0000, 'ºC'),
	(279359, 121, '2014-04-01 00:53:01.000000', 'temperatura', 896.0000, 'ºC'),
	(279360, 121, '2014-04-01 00:53:02.000000', 'temperatura', 78.0000, 'ºC'),
	(279361, 121, '2014-04-01 00:53:03.000000', 'temperatura', 103.0000, 'ºC'),
	(279362, 121, '2014-04-01 00:53:04.000000', 'temperatura', 283.0000, 'ºC'),
	(279363, 121, '2014-04-01 00:53:05.000000', 'temperatura', 1105.0000, 'ºC'),
	(279364, 121, '2014-04-01 00:53:06.000000', 'temperatura', 1078.0000, 'ºC'),
	(279365, 121, '2014-04-01 00:53:07.000000', 'temperatura', 874.0000, 'ºC'),
	(279366, 121, '2014-04-01 00:53:08.000000', 'temperatura', 1137.0000, 'ºC'),
	(279367, 121, '2014-04-01 00:53:09.000000', 'temperatura', 664.0000, 'ºC'),
	(279368, 121, '2014-04-01 00:53:10.000000', 'temperatura', 1110.0000, 'ºC'),
	(279369, 121, '2014-04-01 00:53:11.000000', 'temperatura', 1158.0000, 'ºC'),
	(279370, 121, '2014-04-01 00:53:12.000000', 'temperatura', 62.0000, 'ºC'),
	(279371, 121, '2014-04-01 00:53:13.000000', 'temperatura', 437.0000, 'ºC'),
	(279372, 121, '2014-04-01 00:53:14.000000', 'temperatura', 800.0000, 'ºC'),
	(279373, 121, '2014-04-01 00:53:15.000000', 'temperatura', 290.0000, 'ºC'),
	(279374, 121, '2014-04-01 00:53:16.000000', 'temperatura', 249.0000, 'ºC'),
	(279375, 121, '2014-04-01 00:53:17.000000', 'temperatura', 374.0000, 'ºC'),
	(279376, 121, '2014-04-01 00:53:18.000000', 'temperatura', 1127.0000, 'ºC'),
	(279377, 121, '2014-04-01 00:53:19.000000', 'temperatura', 911.0000, 'ºC'),
	(279378, 121, '2014-04-01 00:53:20.000000', 'temperatura', 1176.0000, 'ºC'),
	(279379, 121, '2014-04-01 00:53:21.000000', 'temperatura', 747.0000, 'ºC'),
	(279380, 121, '2014-04-01 00:53:22.000000', 'temperatura', 206.0000, 'ºC'),
	(279381, 121, '2014-04-01 00:53:23.000000', 'temperatura', 1191.0000, 'ºC'),
	(279382, 121, '2014-04-01 00:53:24.000000', 'temperatura', 536.0000, 'ºC'),
	(279383, 121, '2014-04-01 00:53:25.000000', 'temperatura', 309.0000, 'ºC'),
	(279384, 121, '2014-04-01 00:53:26.000000', 'temperatura', 1136.0000, 'ºC'),
	(279385, 121, '2014-04-01 00:53:27.000000', 'temperatura', 1156.0000, 'ºC'),
	(279386, 121, '2014-04-01 00:53:28.000000', 'temperatura', 1172.0000, 'ºC'),
	(279387, 121, '2014-04-01 00:53:29.000000', 'temperatura', 1193.0000, 'ºC'),
	(279388, 121, '2014-04-01 00:53:30.000000', 'temperatura', 48.0000, 'ºC'),
	(279389, 121, '2014-04-01 00:53:31.000000', 'temperatura', 262.0000, 'ºC'),
	(279390, 121, '2014-04-01 00:53:32.000000', 'temperatura', 1165.0000, 'ºC'),
	(279391, 121, '2014-04-01 00:53:33.000000', 'temperatura', 241.0000, 'ºC'),
	(279392, 121, '2014-04-01 00:53:34.000000', 'temperatura', 111.0000, 'ºC'),
	(279393, 121, '2014-04-01 00:53:35.000000', 'temperatura', 1033.0000, 'ºC'),
	(279394, 121, '2014-04-01 00:53:36.000000', 'temperatura', 32.0000, 'ºC'),
	(279395, 121, '2014-04-01 00:53:37.000000', 'temperatura', 661.0000, 'ºC'),
	(279396, 121, '2014-04-01 00:53:38.000000', 'temperatura', 811.0000, 'ºC'),
	(279397, 121, '2014-04-01 00:53:39.000000', 'temperatura', 870.0000, 'ºC'),
	(279398, 121, '2014-04-01 00:53:40.000000', 'temperatura', 720.0000, 'ºC'),
	(279399, 121, '2014-04-01 00:53:41.000000', 'temperatura', 988.0000, 'ºC'),
	(279400, 121, '2014-04-01 00:53:42.000000', 'temperatura', 382.0000, 'ºC'),
	(279401, 121, '2014-04-01 00:53:43.000000', 'temperatura', 148.0000, 'ºC'),
	(279402, 121, '2014-04-01 00:53:44.000000', 'temperatura', 792.0000, 'ºC'),
	(279403, 121, '2014-04-01 00:53:45.000000', 'temperatura', 1116.0000, 'ºC'),
	(279404, 121, '2014-04-01 00:53:46.000000', 'temperatura', 806.0000, 'ºC'),
	(279405, 121, '2014-04-01 00:53:47.000000', 'temperatura', 681.0000, 'ºC'),
	(279406, 121, '2014-04-01 00:53:48.000000', 'temperatura', 988.0000, 'ºC'),
	(279407, 121, '2014-04-01 00:53:49.000000', 'temperatura', 496.0000, 'ºC'),
	(279408, 121, '2014-04-01 00:53:50.000000', 'temperatura', 718.0000, 'ºC'),
	(279409, 121, '2014-04-01 00:53:51.000000', 'temperatura', 901.0000, 'ºC'),
	(279410, 121, '2014-04-01 00:53:52.000000', 'temperatura', 1154.0000, 'ºC'),
	(279411, 121, '2014-04-01 00:53:53.000000', 'temperatura', 668.0000, 'ºC'),
	(279412, 121, '2014-04-01 00:53:54.000000', 'temperatura', 1076.0000, 'ºC'),
	(279413, 121, '2014-04-01 00:53:55.000000', 'temperatura', 976.0000, 'ºC'),
	(279414, 121, '2014-04-01 00:53:56.000000', 'temperatura', 455.0000, 'ºC'),
	(279415, 121, '2014-04-01 00:53:57.000000', 'temperatura', 548.0000, 'ºC'),
	(279416, 121, '2014-04-01 00:53:58.000000', 'temperatura', 174.0000, 'ºC'),
	(279417, 121, '2014-04-01 00:53:59.000000', 'temperatura', 426.0000, 'ºC'),
	(279418, 121, '2014-04-01 00:54:00.000000', 'temperatura', 408.0000, 'ºC'),
	(279419, 121, '2014-04-01 00:54:01.000000', 'temperatura', 764.0000, 'ºC'),
	(279420, 121, '2014-04-01 00:54:02.000000', 'temperatura', 195.0000, 'ºC'),
	(279421, 121, '2014-04-01 00:54:03.000000', 'temperatura', 1086.0000, 'ºC'),
	(279422, 121, '2014-04-01 00:54:04.000000', 'temperatura', 44.0000, 'ºC'),
	(279423, 121, '2014-04-01 00:54:05.000000', 'temperatura', 561.0000, 'ºC'),
	(279424, 121, '2014-04-01 00:54:06.000000', 'temperatura', 275.0000, 'ºC'),
	(279425, 121, '2014-04-01 00:54:07.000000', 'temperatura', 893.0000, 'ºC'),
	(279426, 121, '2014-04-01 00:54:08.000000', 'temperatura', 39.0000, 'ºC'),
	(279427, 121, '2014-04-01 00:54:09.000000', 'temperatura', 1118.0000, 'ºC'),
	(279428, 121, '2014-04-01 00:54:10.000000', 'temperatura', 675.0000, 'ºC'),
	(279429, 121, '2014-04-01 00:54:11.000000', 'temperatura', 18.0000, 'ºC'),
	(279430, 121, '2014-04-01 00:54:12.000000', 'temperatura', 468.0000, 'ºC'),
	(279431, 121, '2014-04-01 00:54:13.000000', 'temperatura', 1086.0000, 'ºC'),
	(279432, 121, '2014-04-01 00:54:14.000000', 'temperatura', 425.0000, 'ºC'),
	(279433, 121, '2014-04-01 00:54:15.000000', 'temperatura', 68.0000, 'ºC'),
	(279434, 121, '2014-04-01 00:54:16.000000', 'temperatura', 267.0000, 'ºC'),
	(279435, 121, '2014-04-01 00:54:17.000000', 'temperatura', 1129.0000, 'ºC'),
	(279436, 121, '2014-04-01 00:54:18.000000', 'temperatura', 46.0000, 'ºC'),
	(279437, 121, '2014-04-01 00:54:19.000000', 'temperatura', 445.0000, 'ºC'),
	(279438, 121, '2014-04-01 00:54:20.000000', 'temperatura', 887.0000, 'ºC'),
	(279439, 121, '2014-04-01 00:54:21.000000', 'temperatura', 702.0000, 'ºC'),
	(279440, 121, '2014-04-01 00:54:22.000000', 'temperatura', 846.0000, 'ºC'),
	(279441, 121, '2014-04-01 00:54:23.000000', 'temperatura', 926.0000, 'ºC'),
	(279442, 121, '2014-04-01 00:54:24.000000', 'temperatura', 893.0000, 'ºC'),
	(279443, 121, '2014-04-01 00:54:25.000000', 'temperatura', 486.0000, 'ºC'),
	(279444, 121, '2014-04-01 00:54:26.000000', 'temperatura', 951.0000, 'ºC'),
	(279445, 121, '2014-04-01 00:54:27.000000', 'temperatura', 898.0000, 'ºC'),
	(279446, 121, '2014-04-01 00:54:28.000000', 'temperatura', 437.0000, 'ºC'),
	(279447, 121, '2014-04-01 00:54:29.000000', 'temperatura', 693.0000, 'ºC'),
	(279448, 121, '2014-04-01 00:54:30.000000', 'temperatura', 953.0000, 'ºC'),
	(279449, 121, '2014-04-01 00:54:31.000000', 'temperatura', 289.0000, 'ºC'),
	(279450, 121, '2014-04-01 00:54:32.000000', 'temperatura', 985.0000, 'ºC'),
	(279451, 121, '2014-04-01 00:54:33.000000', 'temperatura', 458.0000, 'ºC'),
	(279452, 121, '2014-04-01 00:54:34.000000', 'temperatura', 536.0000, 'ºC'),
	(279453, 121, '2014-04-01 00:54:35.000000', 'temperatura', 106.0000, 'ºC'),
	(279454, 121, '2014-04-01 00:54:36.000000', 'temperatura', 122.0000, 'ºC'),
	(279455, 121, '2014-04-01 00:54:37.000000', 'temperatura', 293.0000, 'ºC'),
	(279456, 121, '2014-04-01 00:54:38.000000', 'temperatura', 1101.0000, 'ºC'),
	(279457, 121, '2014-04-01 00:54:39.000000', 'temperatura', 1026.0000, 'ºC'),
	(279458, 121, '2014-04-01 00:54:40.000000', 'temperatura', 629.0000, 'ºC'),
	(279459, 121, '2014-04-01 00:54:41.000000', 'temperatura', 65.0000, 'ºC'),
	(279460, 121, '2014-04-01 00:54:42.000000', 'temperatura', 841.0000, 'ºC'),
	(279461, 121, '2014-04-01 00:54:43.000000', 'temperatura', 410.0000, 'ºC'),
	(279462, 121, '2014-04-01 00:54:44.000000', 'temperatura', 725.0000, 'ºC'),
	(279463, 121, '2014-04-01 00:54:45.000000', 'temperatura', 1197.0000, 'ºC'),
	(279464, 121, '2014-04-01 00:54:46.000000', 'temperatura', 210.0000, 'ºC'),
	(279465, 121, '2014-04-01 00:54:47.000000', 'temperatura', 1058.0000, 'ºC'),
	(279466, 121, '2014-04-01 00:54:48.000000', 'temperatura', 1064.0000, 'ºC'),
	(279467, 121, '2014-04-01 00:54:49.000000', 'temperatura', 945.0000, 'ºC'),
	(279468, 121, '2014-04-01 00:54:50.000000', 'temperatura', 331.0000, 'ºC'),
	(279469, 121, '2014-04-01 00:54:51.000000', 'temperatura', 24.0000, 'ºC'),
	(279470, 121, '2014-04-01 00:54:52.000000', 'temperatura', 328.0000, 'ºC'),
	(279471, 121, '2014-04-01 00:54:53.000000', 'temperatura', 366.0000, 'ºC'),
	(279472, 121, '2014-04-01 00:54:54.000000', 'temperatura', 849.0000, 'ºC'),
	(279473, 121, '2014-04-01 00:54:55.000000', 'temperatura', 745.0000, 'ºC'),
	(279474, 121, '2014-04-01 00:54:56.000000', 'temperatura', 1181.0000, 'ºC'),
	(279475, 121, '2014-04-01 00:54:57.000000', 'temperatura', 71.0000, 'ºC'),
	(279476, 121, '2014-04-01 00:54:58.000000', 'temperatura', 409.0000, 'ºC'),
	(279477, 121, '2014-04-01 00:54:59.000000', 'temperatura', 635.0000, 'ºC'),
	(279478, 121, '2014-04-01 00:55:00.000000', 'temperatura', 750.0000, 'ºC'),
	(279479, 121, '2014-04-01 00:55:01.000000', 'temperatura', 642.0000, 'ºC'),
	(279480, 121, '2014-04-01 00:55:02.000000', 'temperatura', 962.0000, 'ºC'),
	(279481, 121, '2014-04-01 00:55:03.000000', 'temperatura', 486.0000, 'ºC'),
	(279482, 121, '2014-04-01 00:55:04.000000', 'temperatura', 743.0000, 'ºC'),
	(279483, 121, '2014-04-01 00:55:05.000000', 'temperatura', 1059.0000, 'ºC'),
	(279484, 121, '2014-04-01 00:55:06.000000', 'temperatura', 664.0000, 'ºC'),
	(279485, 121, '2014-04-01 00:55:07.000000', 'temperatura', 146.0000, 'ºC'),
	(279486, 121, '2014-04-01 00:55:08.000000', 'temperatura', 1139.0000, 'ºC'),
	(279487, 121, '2014-04-01 00:55:09.000000', 'temperatura', 457.0000, 'ºC'),
	(279488, 121, '2014-04-01 00:55:10.000000', 'temperatura', 70.0000, 'ºC'),
	(279489, 121, '2014-04-01 00:55:11.000000', 'temperatura', 179.0000, 'ºC'),
	(279490, 121, '2014-04-01 00:55:12.000000', 'temperatura', 684.0000, 'ºC'),
	(279491, 121, '2014-04-01 00:55:13.000000', 'temperatura', 482.0000, 'ºC'),
	(279492, 121, '2014-04-01 00:55:14.000000', 'temperatura', 360.0000, 'ºC'),
	(279493, 121, '2014-04-01 00:55:15.000000', 'temperatura', 356.0000, 'ºC'),
	(279494, 121, '2014-04-01 00:55:16.000000', 'temperatura', 697.0000, 'ºC'),
	(279495, 121, '2014-04-01 00:55:17.000000', 'temperatura', 21.0000, 'ºC'),
	(279496, 121, '2014-04-01 00:55:18.000000', 'temperatura', 414.0000, 'ºC'),
	(279497, 121, '2014-04-01 00:55:19.000000', 'temperatura', 805.0000, 'ºC'),
	(279498, 121, '2014-04-01 00:55:20.000000', 'temperatura', 387.0000, 'ºC'),
	(279499, 121, '2014-04-01 00:55:21.000000', 'temperatura', 718.0000, 'ºC'),
	(279500, 121, '2014-04-01 00:55:22.000000', 'temperatura', 29.0000, 'ºC'),
	(279501, 121, '2014-04-01 00:55:23.000000', 'temperatura', 393.0000, 'ºC'),
	(279502, 121, '2014-04-01 00:55:24.000000', 'temperatura', 677.0000, 'ºC'),
	(279503, 121, '2014-04-01 00:55:25.000000', 'temperatura', 1009.0000, 'ºC'),
	(279504, 121, '2014-04-01 00:55:26.000000', 'temperatura', 611.0000, 'ºC'),
	(279505, 121, '2014-04-01 00:55:27.000000', 'temperatura', 32.0000, 'ºC'),
	(279506, 121, '2014-04-01 00:55:28.000000', 'temperatura', 726.0000, 'ºC'),
	(279507, 121, '2014-04-01 00:55:29.000000', 'temperatura', 1134.0000, 'ºC'),
	(279508, 121, '2014-04-01 00:55:30.000000', 'temperatura', 1093.0000, 'ºC'),
	(279509, 121, '2014-04-01 00:55:31.000000', 'temperatura', 863.0000, 'ºC'),
	(279510, 121, '2014-04-01 00:55:32.000000', 'temperatura', 1035.0000, 'ºC'),
	(279511, 121, '2014-04-01 00:55:33.000000', 'temperatura', 189.0000, 'ºC'),
	(279512, 121, '2014-04-01 00:55:34.000000', 'temperatura', 239.0000, 'ºC'),
	(279513, 121, '2014-04-01 00:55:35.000000', 'temperatura', 627.0000, 'ºC'),
	(279514, 121, '2014-04-01 00:55:36.000000', 'temperatura', 22.0000, 'ºC'),
	(279515, 121, '2014-04-01 00:55:37.000000', 'temperatura', 627.0000, 'ºC'),
	(279516, 121, '2014-04-01 00:55:38.000000', 'temperatura', 669.0000, 'ºC'),
	(279517, 121, '2014-04-01 00:55:39.000000', 'temperatura', 266.0000, 'ºC'),
	(279518, 121, '2014-04-01 00:55:40.000000', 'temperatura', 524.0000, 'ºC'),
	(279519, 121, '2014-04-01 00:55:41.000000', 'temperatura', 622.0000, 'ºC'),
	(279520, 121, '2014-04-01 00:55:42.000000', 'temperatura', 339.0000, 'ºC'),
	(279521, 121, '2014-04-01 00:55:43.000000', 'temperatura', 1030.0000, 'ºC'),
	(279522, 121, '2014-04-01 00:55:44.000000', 'temperatura', 532.0000, 'ºC'),
	(279523, 121, '2014-04-01 00:55:45.000000', 'temperatura', 771.0000, 'ºC'),
	(279524, 121, '2014-04-01 00:55:46.000000', 'temperatura', 1060.0000, 'ºC'),
	(279525, 121, '2014-04-01 00:55:47.000000', 'temperatura', 587.0000, 'ºC'),
	(279526, 121, '2014-04-01 00:55:48.000000', 'temperatura', 957.0000, 'ºC'),
	(279527, 121, '2014-04-01 00:55:49.000000', 'temperatura', 625.0000, 'ºC'),
	(279528, 121, '2014-04-01 00:55:50.000000', 'temperatura', 255.0000, 'ºC'),
	(279529, 121, '2014-04-01 00:55:51.000000', 'temperatura', 601.0000, 'ºC'),
	(279530, 121, '2014-04-01 00:55:52.000000', 'temperatura', 1038.0000, 'ºC'),
	(279531, 121, '2014-04-01 00:55:53.000000', 'temperatura', 990.0000, 'ºC'),
	(279532, 121, '2014-04-01 00:55:54.000000', 'temperatura', 637.0000, 'ºC'),
	(279533, 121, '2014-04-01 00:55:55.000000', 'temperatura', 215.0000, 'ºC'),
	(279534, 121, '2014-04-01 00:55:56.000000', 'temperatura', 365.0000, 'ºC'),
	(279535, 121, '2014-04-01 00:55:57.000000', 'temperatura', 1179.0000, 'ºC'),
	(279536, 121, '2014-04-01 00:55:58.000000', 'temperatura', 0.0000, 'ºC'),
	(279537, 121, '2014-04-01 00:55:59.000000', 'temperatura', 65.0000, 'ºC'),
	(279538, 121, '2014-04-01 00:56:00.000000', 'temperatura', 327.0000, 'ºC'),
	(279539, 121, '2014-04-01 00:56:01.000000', 'temperatura', 238.0000, 'ºC'),
	(279540, 121, '2014-04-01 00:56:02.000000', 'temperatura', 212.0000, 'ºC'),
	(279541, 121, '2014-04-01 00:56:03.000000', 'temperatura', 346.0000, 'ºC'),
	(279542, 121, '2014-04-01 00:56:04.000000', 'temperatura', 1093.0000, 'ºC'),
	(279543, 121, '2014-04-01 00:56:05.000000', 'temperatura', 827.0000, 'ºC'),
	(279544, 121, '2014-04-01 00:56:06.000000', 'temperatura', 856.0000, 'ºC'),
	(279545, 121, '2014-04-01 00:56:07.000000', 'temperatura', 600.0000, 'ºC'),
	(279546, 121, '2014-04-01 00:56:08.000000', 'temperatura', 432.0000, 'ºC'),
	(279547, 121, '2014-04-01 00:56:09.000000', 'temperatura', 361.0000, 'ºC'),
	(279548, 121, '2014-04-01 00:56:10.000000', 'temperatura', 509.0000, 'ºC'),
	(279549, 121, '2014-04-01 00:56:11.000000', 'temperatura', 265.0000, 'ºC'),
	(279550, 121, '2014-04-01 00:56:12.000000', 'temperatura', 997.0000, 'ºC'),
	(279551, 121, '2014-04-01 00:56:13.000000', 'temperatura', 589.0000, 'ºC'),
	(279552, 121, '2014-04-01 00:56:14.000000', 'temperatura', 1156.0000, 'ºC'),
	(279553, 121, '2014-04-01 00:56:15.000000', 'temperatura', 413.0000, 'ºC'),
	(279554, 121, '2014-04-01 00:56:16.000000', 'temperatura', 998.0000, 'ºC'),
	(279555, 121, '2014-04-01 00:56:17.000000', 'temperatura', 149.0000, 'ºC'),
	(279556, 121, '2014-04-01 00:56:18.000000', 'temperatura', 154.0000, 'ºC'),
	(279557, 121, '2014-04-01 00:56:19.000000', 'temperatura', 322.0000, 'ºC'),
	(279558, 121, '2014-04-01 00:56:20.000000', 'temperatura', 1147.0000, 'ºC'),
	(279559, 121, '2014-04-01 00:56:21.000000', 'temperatura', 1172.0000, 'ºC'),
	(279560, 121, '2014-04-01 00:56:22.000000', 'temperatura', 19.0000, 'ºC'),
	(279561, 121, '2014-04-01 00:56:23.000000', 'temperatura', 178.0000, 'ºC'),
	(279562, 121, '2014-04-01 00:56:24.000000', 'temperatura', 833.0000, 'ºC'),
	(279563, 121, '2014-04-01 00:56:25.000000', 'temperatura', 31.0000, 'ºC'),
	(279564, 121, '2014-04-01 00:56:26.000000', 'temperatura', 59.0000, 'ºC'),
	(279565, 121, '2014-04-01 00:56:27.000000', 'temperatura', 204.0000, 'ºC'),
	(279566, 121, '2014-04-01 00:56:28.000000', 'temperatura', 840.0000, 'ºC'),
	(279567, 121, '2014-04-01 00:56:29.000000', 'temperatura', 1190.0000, 'ºC'),
	(279568, 121, '2014-04-01 00:56:30.000000', 'temperatura', 1030.0000, 'ºC'),
	(279569, 121, '2014-04-01 00:56:31.000000', 'temperatura', 381.0000, 'ºC'),
	(279570, 121, '2014-04-01 00:56:32.000000', 'temperatura', 17.0000, 'ºC'),
	(279571, 121, '2014-04-01 00:56:33.000000', 'temperatura', 141.0000, 'ºC'),
	(279572, 121, '2014-04-01 00:56:34.000000', 'temperatura', 654.0000, 'ºC'),
	(279573, 121, '2014-04-01 00:56:35.000000', 'temperatura', 448.0000, 'ºC'),
	(279574, 121, '2014-04-01 00:56:36.000000', 'temperatura', 278.0000, 'ºC'),
	(279575, 121, '2014-04-01 00:56:37.000000', 'temperatura', 48.0000, 'ºC'),
	(279576, 121, '2014-04-01 00:56:38.000000', 'temperatura', 604.0000, 'ºC'),
	(279577, 121, '2014-04-01 00:56:39.000000', 'temperatura', 479.0000, 'ºC'),
	(279578, 121, '2014-04-01 00:56:40.000000', 'temperatura', 581.0000, 'ºC'),
	(279579, 121, '2014-04-01 00:56:41.000000', 'temperatura', 269.0000, 'ºC'),
	(279580, 121, '2014-04-01 00:56:42.000000', 'temperatura', 801.0000, 'ºC'),
	(279581, 121, '2014-04-01 00:56:43.000000', 'temperatura', 800.0000, 'ºC'),
	(279582, 121, '2014-04-01 00:56:44.000000', 'temperatura', 399.0000, 'ºC'),
	(279583, 121, '2014-04-01 00:56:45.000000', 'temperatura', 795.0000, 'ºC'),
	(279584, 121, '2014-04-01 00:56:46.000000', 'temperatura', 377.0000, 'ºC'),
	(279585, 121, '2014-04-01 00:56:47.000000', 'temperatura', 700.0000, 'ºC'),
	(279586, 121, '2014-04-01 00:56:48.000000', 'temperatura', 1171.0000, 'ºC'),
	(279587, 121, '2014-04-01 00:56:49.000000', 'temperatura', 156.0000, 'ºC'),
	(279588, 121, '2014-04-01 00:56:50.000000', 'temperatura', 866.0000, 'ºC'),
	(279589, 121, '2014-04-01 00:56:51.000000', 'temperatura', 262.0000, 'ºC'),
	(279590, 121, '2014-04-01 00:56:52.000000', 'temperatura', 1113.0000, 'ºC'),
	(279591, 121, '2014-04-01 00:56:53.000000', 'temperatura', 1181.0000, 'ºC'),
	(279592, 121, '2014-04-01 00:56:54.000000', 'temperatura', 167.0000, 'ºC'),
	(279593, 121, '2014-04-01 00:56:55.000000', 'temperatura', 891.0000, 'ºC'),
	(279594, 121, '2014-04-01 00:56:56.000000', 'temperatura', 354.0000, 'ºC'),
	(279595, 121, '2014-04-01 00:56:57.000000', 'temperatura', 300.0000, 'ºC'),
	(279596, 121, '2014-04-01 00:56:58.000000', 'temperatura', 437.0000, 'ºC'),
	(279597, 121, '2014-04-01 00:56:59.000000', 'temperatura', 86.0000, 'ºC'),
	(279598, 121, '2014-04-01 00:57:00.000000', 'temperatura', 319.0000, 'ºC'),
	(279599, 121, '2014-04-01 00:57:01.000000', 'temperatura', 138.0000, 'ºC'),
	(279600, 121, '2014-04-01 00:57:02.000000', 'temperatura', 933.0000, 'ºC'),
	(279601, 121, '2014-04-01 00:57:03.000000', 'temperatura', 653.0000, 'ºC'),
	(279602, 121, '2014-04-01 00:57:04.000000', 'temperatura', 467.0000, 'ºC'),
	(279603, 121, '2014-04-01 00:57:05.000000', 'temperatura', 376.0000, 'ºC'),
	(279604, 121, '2014-04-01 00:57:06.000000', 'temperatura', 480.0000, 'ºC'),
	(279605, 121, '2014-04-01 00:57:07.000000', 'temperatura', 73.0000, 'ºC'),
	(279606, 121, '2014-04-01 00:57:08.000000', 'temperatura', 126.0000, 'ºC'),
	(279607, 121, '2014-04-01 00:57:09.000000', 'temperatura', 412.0000, 'ºC'),
	(279608, 121, '2014-04-01 00:57:10.000000', 'temperatura', 481.0000, 'ºC'),
	(279609, 121, '2014-04-01 00:57:11.000000', 'temperatura', 1172.0000, 'ºC'),
	(279610, 121, '2014-04-01 00:57:12.000000', 'temperatura', 816.0000, 'ºC'),
	(279611, 121, '2014-04-01 00:57:13.000000', 'temperatura', 565.0000, 'ºC'),
	(279612, 121, '2014-04-01 00:57:14.000000', 'temperatura', 377.0000, 'ºC'),
	(279613, 121, '2014-04-01 00:57:15.000000', 'temperatura', 190.0000, 'ºC'),
	(279614, 121, '2014-04-01 00:57:16.000000', 'temperatura', 1020.0000, 'ºC'),
	(279615, 121, '2014-04-01 00:57:17.000000', 'temperatura', 929.0000, 'ºC'),
	(279616, 121, '2014-04-01 00:57:18.000000', 'temperatura', 387.0000, 'ºC'),
	(279617, 121, '2014-04-01 00:57:19.000000', 'temperatura', 347.0000, 'ºC'),
	(279618, 121, '2014-04-01 00:57:20.000000', 'temperatura', 576.0000, 'ºC'),
	(279619, 121, '2014-04-01 00:57:21.000000', 'temperatura', 639.0000, 'ºC'),
	(279620, 121, '2014-04-01 00:57:22.000000', 'temperatura', 267.0000, 'ºC'),
	(279621, 121, '2014-04-01 00:57:23.000000', 'temperatura', 618.0000, 'ºC'),
	(279622, 121, '2014-04-01 00:57:24.000000', 'temperatura', 1092.0000, 'ºC'),
	(279623, 121, '2014-04-01 00:57:25.000000', 'temperatura', 5.0000, 'ºC'),
	(279624, 121, '2014-04-01 00:57:26.000000', 'temperatura', 351.0000, 'ºC'),
	(279625, 121, '2014-04-01 00:57:27.000000', 'temperatura', 538.0000, 'ºC'),
	(279626, 121, '2014-04-01 00:57:28.000000', 'temperatura', 438.0000, 'ºC'),
	(279627, 121, '2014-04-01 00:57:29.000000', 'temperatura', 577.0000, 'ºC'),
	(279628, 121, '2014-04-01 00:57:30.000000', 'temperatura', 371.0000, 'ºC'),
	(279629, 121, '2014-04-01 00:57:31.000000', 'temperatura', 123.0000, 'ºC'),
	(279630, 121, '2014-04-01 00:57:32.000000', 'temperatura', 705.0000, 'ºC'),
	(279631, 121, '2014-04-01 00:57:33.000000', 'temperatura', 754.0000, 'ºC'),
	(279632, 121, '2014-04-01 00:57:34.000000', 'temperatura', 457.0000, 'ºC'),
	(279633, 121, '2014-04-01 00:57:35.000000', 'temperatura', 22.0000, 'ºC'),
	(279634, 121, '2014-04-01 00:57:36.000000', 'temperatura', 1141.0000, 'ºC'),
	(279635, 121, '2014-04-01 00:57:37.000000', 'temperatura', 838.0000, 'ºC'),
	(279636, 121, '2014-04-01 00:57:38.000000', 'temperatura', 768.0000, 'ºC'),
	(279637, 121, '2014-04-01 00:57:39.000000', 'temperatura', 129.0000, 'ºC'),
	(279638, 121, '2014-04-01 00:57:40.000000', 'temperatura', 739.0000, 'ºC'),
	(279639, 121, '2014-04-01 00:57:41.000000', 'temperatura', 908.0000, 'ºC'),
	(279640, 121, '2014-04-01 00:57:42.000000', 'temperatura', 1125.0000, 'ºC'),
	(279641, 121, '2014-04-01 00:57:43.000000', 'temperatura', 502.0000, 'ºC'),
	(279642, 121, '2014-04-01 00:57:44.000000', 'temperatura', 336.0000, 'ºC'),
	(279643, 121, '2014-04-01 00:57:45.000000', 'temperatura', 172.0000, 'ºC'),
	(279644, 121, '2014-04-01 00:57:46.000000', 'temperatura', 1055.0000, 'ºC'),
	(279645, 121, '2014-04-01 00:57:47.000000', 'temperatura', 1157.0000, 'ºC'),
	(279646, 121, '2014-04-01 00:57:48.000000', 'temperatura', 223.0000, 'ºC'),
	(279647, 121, '2014-04-01 00:57:49.000000', 'temperatura', 43.0000, 'ºC'),
	(279648, 121, '2014-04-01 00:57:50.000000', 'temperatura', 747.0000, 'ºC'),
	(279649, 121, '2014-04-01 00:57:51.000000', 'temperatura', 7.0000, 'ºC'),
	(279650, 121, '2014-04-01 00:57:52.000000', 'temperatura', 195.0000, 'ºC'),
	(279651, 121, '2014-04-01 00:57:53.000000', 'temperatura', 952.0000, 'ºC'),
	(279652, 121, '2014-04-01 00:57:54.000000', 'temperatura', 578.0000, 'ºC'),
	(279653, 121, '2014-04-01 00:57:55.000000', 'temperatura', 35.0000, 'ºC'),
	(279654, 121, '2014-04-01 00:57:56.000000', 'temperatura', 841.0000, 'ºC'),
	(279655, 121, '2014-04-01 00:57:57.000000', 'temperatura', 499.0000, 'ºC'),
	(279656, 121, '2014-04-01 00:57:58.000000', 'temperatura', 1175.0000, 'ºC'),
	(279657, 121, '2014-04-01 00:57:59.000000', 'temperatura', 777.0000, 'ºC'),
	(279658, 121, '2014-04-01 00:58:00.000000', 'temperatura', 359.0000, 'ºC'),
	(279659, 121, '2014-04-01 00:58:01.000000', 'temperatura', 666.0000, 'ºC'),
	(279660, 121, '2014-04-01 00:58:02.000000', 'temperatura', 1053.0000, 'ºC'),
	(279661, 121, '2014-04-01 00:58:03.000000', 'temperatura', 867.0000, 'ºC'),
	(279662, 121, '2014-04-01 00:58:04.000000', 'temperatura', 1175.0000, 'ºC'),
	(279663, 121, '2014-04-01 00:58:05.000000', 'temperatura', 876.0000, 'ºC'),
	(279664, 121, '2014-04-01 00:58:06.000000', 'temperatura', 857.0000, 'ºC'),
	(279665, 121, '2014-04-01 00:58:07.000000', 'temperatura', 456.0000, 'ºC'),
	(279666, 121, '2014-04-01 00:58:08.000000', 'temperatura', 910.0000, 'ºC'),
	(279667, 121, '2014-04-01 00:58:09.000000', 'temperatura', 781.0000, 'ºC'),
	(279668, 121, '2014-04-01 00:58:10.000000', 'temperatura', 1174.0000, 'ºC'),
	(279669, 121, '2014-04-01 00:58:11.000000', 'temperatura', 1131.0000, 'ºC'),
	(279670, 121, '2014-04-01 00:58:12.000000', 'temperatura', 930.0000, 'ºC'),
	(279671, 121, '2014-04-01 00:58:13.000000', 'temperatura', 60.0000, 'ºC'),
	(279672, 121, '2014-04-01 00:58:14.000000', 'temperatura', 1111.0000, 'ºC'),
	(279673, 121, '2014-04-01 00:58:15.000000', 'temperatura', 575.0000, 'ºC'),
	(279674, 121, '2014-04-01 00:58:16.000000', 'temperatura', 743.0000, 'ºC'),
	(279675, 121, '2014-04-01 00:58:17.000000', 'temperatura', 792.0000, 'ºC'),
	(279676, 121, '2014-04-01 00:58:18.000000', 'temperatura', 529.0000, 'ºC'),
	(279677, 121, '2014-04-01 00:58:19.000000', 'temperatura', 272.0000, 'ºC'),
	(279678, 121, '2014-04-01 00:58:20.000000', 'temperatura', 970.0000, 'ºC'),
	(279679, 121, '2014-04-01 00:58:21.000000', 'temperatura', 438.0000, 'ºC'),
	(279680, 121, '2014-04-01 00:58:22.000000', 'temperatura', 478.0000, 'ºC'),
	(279681, 121, '2014-04-01 00:58:23.000000', 'temperatura', 1079.0000, 'ºC'),
	(279682, 121, '2014-04-01 00:58:24.000000', 'temperatura', 359.0000, 'ºC'),
	(279683, 121, '2014-04-01 00:58:25.000000', 'temperatura', 958.0000, 'ºC'),
	(279684, 121, '2014-04-01 00:58:26.000000', 'temperatura', 113.0000, 'ºC'),
	(279685, 121, '2014-04-01 00:58:27.000000', 'temperatura', 91.0000, 'ºC'),
	(279686, 121, '2014-04-01 00:58:28.000000', 'temperatura', 117.0000, 'ºC'),
	(279687, 121, '2014-04-01 00:58:29.000000', 'temperatura', 312.0000, 'ºC'),
	(279688, 121, '2014-04-01 00:58:30.000000', 'temperatura', 11.0000, 'ºC'),
	(279689, 121, '2014-04-01 00:58:31.000000', 'temperatura', 317.0000, 'ºC'),
	(279690, 121, '2014-04-01 00:58:32.000000', 'temperatura', 355.0000, 'ºC'),
	(279691, 121, '2014-04-01 00:58:33.000000', 'temperatura', 826.0000, 'ºC'),
	(279692, 121, '2014-04-01 00:58:34.000000', 'temperatura', 663.0000, 'ºC'),
	(279693, 121, '2014-04-01 00:58:35.000000', 'temperatura', 838.0000, 'ºC'),
	(279694, 121, '2014-04-01 00:58:36.000000', 'temperatura', 1003.0000, 'ºC'),
	(279695, 121, '2014-04-01 00:58:37.000000', 'temperatura', 99.0000, 'ºC'),
	(279696, 121, '2014-04-01 00:58:38.000000', 'temperatura', 1087.0000, 'ºC'),
	(279697, 121, '2014-04-01 00:58:39.000000', 'temperatura', 339.0000, 'ºC'),
	(279698, 121, '2014-04-01 00:58:40.000000', 'temperatura', 833.0000, 'ºC'),
	(279699, 121, '2014-04-01 00:58:41.000000', 'temperatura', 751.0000, 'ºC'),
	(279700, 121, '2014-04-01 00:58:42.000000', 'temperatura', 53.0000, 'ºC'),
	(279701, 121, '2014-04-01 00:58:43.000000', 'temperatura', 416.0000, 'ºC'),
	(279702, 121, '2014-04-01 00:58:44.000000', 'temperatura', 719.0000, 'ºC'),
	(279703, 121, '2014-04-01 00:58:45.000000', 'temperatura', 1147.0000, 'ºC'),
	(279704, 121, '2014-04-01 00:58:46.000000', 'temperatura', 1178.0000, 'ºC'),
	(279705, 121, '2014-04-01 00:58:47.000000', 'temperatura', 50.0000, 'ºC'),
	(279706, 121, '2014-04-01 00:58:48.000000', 'temperatura', 316.0000, 'ºC'),
	(279707, 121, '2014-04-01 00:58:49.000000', 'temperatura', 232.0000, 'ºC'),
	(279708, 121, '2014-04-01 00:58:50.000000', 'temperatura', 214.0000, 'ºC'),
	(279709, 121, '2014-04-01 00:58:51.000000', 'temperatura', 372.0000, 'ºC'),
	(279710, 121, '2014-04-01 00:58:52.000000', 'temperatura', 17.0000, 'ºC'),
	(279711, 121, '2014-04-01 00:58:53.000000', 'temperatura', 172.0000, 'ºC'),
	(279712, 121, '2014-04-01 00:58:54.000000', 'temperatura', 808.0000, 'ºC'),
	(279713, 121, '2014-04-01 00:58:55.000000', 'temperatura', 1125.0000, 'ºC'),
	(279714, 121, '2014-04-01 00:58:56.000000', 'temperatura', 803.0000, 'ºC'),
	(279715, 121, '2014-04-01 00:58:57.000000', 'temperatura', 638.0000, 'ºC'),
	(279716, 121, '2014-04-01 00:58:58.000000', 'temperatura', 782.0000, 'ºC'),
	(279717, 121, '2014-04-01 00:58:59.000000', 'temperatura', 797.0000, 'ºC'),
	(279718, 121, '2014-04-01 00:59:00.000000', 'temperatura', 438.0000, 'ºC'),
	(279719, 121, '2014-04-01 00:59:01.000000', 'temperatura', 999.0000, 'ºC'),
	(279720, 121, '2014-04-01 00:59:02.000000', 'temperatura', 83.0000, 'ºC'),
	(279721, 121, '2014-04-01 00:59:03.000000', 'temperatura', 1020.0000, 'ºC'),
	(279722, 121, '2014-04-01 00:59:04.000000', 'temperatura', 50.0000, 'ºC'),
	(279723, 121, '2014-04-01 00:59:05.000000', 'temperatura', 792.0000, 'ºC'),
	(279724, 121, '2014-04-01 00:59:06.000000', 'temperatura', 211.0000, 'ºC'),
	(279725, 121, '2014-04-01 00:59:07.000000', 'temperatura', 1080.0000, 'ºC'),
	(279726, 121, '2014-04-01 00:59:08.000000', 'temperatura', 1165.0000, 'ºC'),
	(279727, 121, '2014-04-01 00:59:09.000000', 'temperatura', 187.0000, 'ºC'),
	(279728, 121, '2014-04-01 00:59:10.000000', 'temperatura', 1038.0000, 'ºC'),
	(279729, 121, '2014-04-01 00:59:11.000000', 'temperatura', 1032.0000, 'ºC'),
	(279730, 121, '2014-04-01 00:59:12.000000', 'temperatura', 846.0000, 'ºC'),
	(279731, 121, '2014-04-01 00:59:13.000000', 'temperatura', 1135.0000, 'ºC'),
	(279732, 121, '2014-04-01 00:59:14.000000', 'temperatura', 736.0000, 'ºC'),
	(279733, 121, '2014-04-01 00:59:15.000000', 'temperatura', 276.0000, 'ºC'),
	(279734, 121, '2014-04-01 00:59:16.000000', 'temperatura', 372.0000, 'ºC'),
	(279735, 121, '2014-04-01 00:59:17.000000', 'temperatura', 1031.0000, 'ºC'),
	(279736, 121, '2014-04-01 00:59:18.000000', 'temperatura', 443.0000, 'ºC'),
	(279737, 121, '2014-04-01 00:59:19.000000', 'temperatura', 320.0000, 'ºC'),
	(279738, 121, '2014-04-01 00:59:20.000000', 'temperatura', 271.0000, 'ºC'),
	(279739, 121, '2014-04-01 00:59:21.000000', 'temperatura', 398.0000, 'ºC'),
	(279740, 121, '2014-04-01 00:59:22.000000', 'temperatura', 1178.0000, 'ºC'),
	(279741, 121, '2014-04-01 00:59:23.000000', 'temperatura', 1095.0000, 'ºC'),
	(279742, 121, '2014-04-01 00:59:24.000000', 'temperatura', 740.0000, 'ºC'),
	(279743, 121, '2014-04-01 00:59:25.000000', 'temperatura', 416.0000, 'ºC'),
	(279744, 121, '2014-04-01 00:59:26.000000', 'temperatura', 1059.0000, 'ºC'),
	(279745, 121, '2014-04-01 00:59:27.000000', 'temperatura', 448.0000, 'ºC'),
	(279746, 121, '2014-04-01 00:59:28.000000', 'temperatura', 265.0000, 'ºC'),
	(279747, 121, '2014-04-01 00:59:29.000000', 'temperatura', 1183.0000, 'ºC'),
	(279748, 121, '2014-04-01 00:59:30.000000', 'temperatura', 317.0000, 'ºC'),
	(279749, 121, '2014-04-01 00:59:31.000000', 'temperatura', 438.0000, 'ºC'),
	(279750, 121, '2014-04-01 00:59:32.000000', 'temperatura', 41.0000, 'ºC'),
	(279751, 121, '2014-04-01 00:59:33.000000', 'temperatura', 89.0000, 'ºC'),
	(279752, 121, '2014-04-01 00:59:34.000000', 'temperatura', 323.0000, 'ºC'),
	(279753, 121, '2014-04-01 00:59:35.000000', 'temperatura', 151.0000, 'ºC'),
	(279754, 121, '2014-04-01 00:59:36.000000', 'temperatura', 984.0000, 'ºC'),
	(279755, 121, '2014-04-01 00:59:37.000000', 'temperatura', 867.0000, 'ºC'),
	(279756, 121, '2014-04-01 00:59:38.000000', 'temperatura', 184.0000, 'ºC'),
	(279757, 121, '2014-04-01 00:59:39.000000', 'temperatura', 720.0000, 'ºC'),
	(279758, 121, '2014-04-01 00:59:40.000000', 'temperatura', 647.0000, 'ºC'),
	(279759, 121, '2014-04-01 00:59:41.000000', 'temperatura', 1078.0000, 'ºC'),
	(279760, 121, '2014-04-01 00:59:42.000000', 'temperatura', 1049.0000, 'ºC'),
	(279761, 121, '2014-04-01 00:59:43.000000', 'temperatura', 811.0000, 'ºC'),
	(279762, 121, '2014-04-01 00:59:44.000000', 'temperatura', 908.0000, 'ºC'),
	(279763, 121, '2014-04-01 00:59:45.000000', 'temperatura', 907.0000, 'ºC'),
	(279764, 121, '2014-04-01 00:59:46.000000', 'temperatura', 612.0000, 'ºC'),
	(279765, 121, '2014-04-01 00:59:47.000000', 'temperatura', 340.0000, 'ºC'),
	(279766, 121, '2014-04-01 00:59:48.000000', 'temperatura', 1066.0000, 'ºC'),
	(279767, 121, '2014-04-01 00:59:49.000000', 'temperatura', 708.0000, 'ºC'),
	(279768, 121, '2014-04-01 00:59:50.000000', 'temperatura', 342.0000, 'ºC'),
	(279769, 121, '2014-04-01 00:59:51.000000', 'temperatura', 789.0000, 'ºC'),
	(279770, 121, '2014-04-01 00:59:52.000000', 'temperatura', 519.0000, 'ºC'),
	(279771, 121, '2014-04-01 00:59:53.000000', 'temperatura', 227.0000, 'ºC'),
	(279772, 121, '2014-04-01 00:59:54.000000', 'temperatura', 779.0000, 'ºC'),
	(279773, 121, '2014-04-01 00:59:55.000000', 'temperatura', 813.0000, 'ºC'),
	(279774, 121, '2014-04-01 00:59:56.000000', 'temperatura', 530.0000, 'ºC'),
	(279775, 121, '2014-04-01 00:59:57.000000', 'temperatura', 213.0000, 'ºC'),
	(279776, 121, '2014-04-01 00:59:58.000000', 'temperatura', 675.0000, 'ºC'),
	(279777, 121, '2014-04-01 00:59:59.000000', 'temperatura', 336.0000, 'ºC'),
	(279778, 121, '2014-04-01 01:00:00.000000', 'temperatura', 854.0000, 'ºC'),
	(279779, 121, '2014-04-01 01:00:01.000000', 'temperatura', 864.0000, 'ºC'),
	(279780, 121, '2014-04-01 01:00:02.000000', 'temperatura', 556.0000, 'ºC'),
	(279781, 121, '2014-04-01 01:00:03.000000', 'temperatura', 191.0000, 'ºC'),
	(279782, 121, '2014-04-01 01:00:04.000000', 'temperatura', 489.0000, 'ºC'),
	(279783, 121, '2014-04-01 01:00:05.000000', 'temperatura', 669.0000, 'ºC'),
	(279784, 121, '2014-04-01 01:00:06.000000', 'temperatura', 679.0000, 'ºC'),
	(279785, 121, '2014-04-01 01:00:07.000000', 'temperatura', 191.0000, 'ºC'),
	(279786, 121, '2014-04-01 01:00:08.000000', 'temperatura', 117.0000, 'ºC'),
	(279787, 121, '2014-04-01 01:00:09.000000', 'temperatura', 11.0000, 'ºC'),
	(279788, 121, '2014-04-01 01:00:10.000000', 'temperatura', 908.0000, 'ºC'),
	(279789, 121, '2014-04-01 01:00:11.000000', 'temperatura', 904.0000, 'ºC'),
	(279790, 121, '2014-04-01 01:00:12.000000', 'temperatura', 599.0000, 'ºC'),
	(279791, 121, '2014-04-01 01:00:13.000000', 'temperatura', 282.0000, 'ºC'),
	(279792, 121, '2014-04-01 01:00:14.000000', 'temperatura', 814.0000, 'ºC'),
	(279793, 121, '2014-04-01 01:00:15.000000', 'temperatura', 825.0000, 'ºC'),
	(279794, 121, '2014-04-01 01:00:16.000000', 'temperatura', 482.0000, 'ºC'),
	(279795, 121, '2014-04-01 01:00:17.000000', 'temperatura', 1135.0000, 'ºC'),
	(279796, 121, '2014-04-01 01:00:18.000000', 'temperatura', 631.0000, 'ºC'),
	(279797, 121, '2014-04-01 01:00:19.000000', 'temperatura', 952.0000, 'ºC'),
	(279798, 121, '2014-04-01 01:00:20.000000', 'temperatura', 465.0000, 'ºC'),
	(279799, 121, '2014-04-01 01:00:21.000000', 'temperatura', 670.0000, 'ºC'),
	(279800, 121, '2014-04-01 01:00:22.000000', 'temperatura', 757.0000, 'ºC'),
	(279801, 121, '2014-04-01 01:00:23.000000', 'temperatura', 573.0000, 'ºC'),
	(279802, 121, '2014-04-01 01:00:24.000000', 'temperatura', 595.0000, 'ºC'),
	(279803, 121, '2014-04-01 01:00:25.000000', 'temperatura', 55.0000, 'ºC'),
	(279804, 121, '2014-04-01 01:00:26.000000', 'temperatura', 891.0000, 'ºC'),
	(279805, 121, '2014-04-01 01:00:27.000000', 'temperatura', 692.0000, 'ºC'),
	(279806, 121, '2014-04-01 01:00:28.000000', 'temperatura', 786.0000, 'ºC'),
	(279807, 121, '2014-04-01 01:00:29.000000', 'temperatura', 656.0000, 'ºC'),
	(279808, 121, '2014-04-01 01:00:30.000000', 'temperatura', 920.0000, 'ºC'),
	(279809, 121, '2014-04-01 01:00:31.000000', 'temperatura', 233.0000, 'ºC'),
	(279810, 121, '2014-04-01 01:00:32.000000', 'temperatura', 805.0000, 'ºC'),
	(279811, 121, '2014-04-01 01:00:33.000000', 'temperatura', 925.0000, 'ºC'),
	(279812, 121, '2014-04-01 01:00:34.000000', 'temperatura', 1013.0000, 'ºC'),
	(279813, 121, '2014-04-01 01:00:35.000000', 'temperatura', 1092.0000, 'ºC'),
	(279814, 121, '2014-04-01 01:00:36.000000', 'temperatura', 19.0000, 'ºC'),
	(279815, 121, '2014-04-01 01:00:37.000000', 'temperatura', 422.0000, 'ºC'),
	(279816, 121, '2014-04-01 01:00:38.000000', 'temperatura', 853.0000, 'ºC'),
	(279817, 121, '2014-04-01 01:00:39.000000', 'temperatura', 601.0000, 'ºC'),
	(279818, 121, '2014-04-01 01:00:40.000000', 'temperatura', 446.0000, 'ºC'),
	(279819, 121, '2014-04-01 01:00:41.000000', 'temperatura', 425.0000, 'ºC'),
	(279820, 121, '2014-04-01 01:00:42.000000', 'temperatura', 789.0000, 'ºC'),
	(279821, 121, '2014-04-01 01:00:43.000000', 'temperatura', 272.0000, 'ºC'),
	(279822, 121, '2014-04-01 01:00:44.000000', 'temperatura', 192.0000, 'ºC'),
	(279823, 121, '2014-04-01 01:00:45.000000', 'temperatura', 145.0000, 'ºC'),
	(279824, 121, '2014-04-01 01:00:46.000000', 'temperatura', 150.0000, 'ºC'),
	(279825, 121, '2014-04-01 01:00:47.000000', 'temperatura', 316.0000, 'ºC'),
	(279826, 121, '2014-04-01 01:00:48.000000', 'temperatura', 1131.0000, 'ºC'),
	(279827, 121, '2014-04-01 01:00:49.000000', 'temperatura', 1105.0000, 'ºC'),
	(279828, 121, '2014-04-01 01:00:50.000000', 'temperatura', 933.0000, 'ºC'),
	(279829, 121, '2014-04-01 01:00:51.000000', 'temperatura', 153.0000, 'ºC'),
	(279830, 121, '2014-04-01 01:00:52.000000', 'temperatura', 365.0000, 'ºC'),
	(279831, 121, '2014-04-01 01:00:53.000000', 'temperatura', 166.0000, 'ºC'),
	(279832, 121, '2014-04-01 01:00:54.000000', 'temperatura', 937.0000, 'ºC'),
	(279833, 121, '2014-04-01 01:00:55.000000', 'temperatura', 588.0000, 'ºC'),
	(279834, 121, '2014-04-01 01:00:56.000000', 'temperatura', 127.0000, 'ºC'),
	(279835, 121, '2014-04-01 01:00:57.000000', 'temperatura', 72.0000, 'ºC'),
	(279836, 121, '2014-04-01 01:00:58.000000', 'temperatura', 1178.0000, 'ºC'),
	(279837, 121, '2014-04-01 01:00:59.000000', 'temperatura', 877.0000, 'ºC'),
	(279838, 121, '2014-04-01 01:01:00.000000', 'temperatura', 849.0000, 'ºC'),
	(279839, 121, '2014-04-01 01:01:01.000000', 'temperatura', 417.0000, 'ºC'),
	(279840, 121, '2014-04-01 01:01:02.000000', 'temperatura', 739.0000, 'ºC'),
	(279841, 121, '2014-04-01 01:01:03.000000', 'temperatura', 43.0000, 'ºC'),
	(279842, 121, '2014-04-01 01:01:04.000000', 'temperatura', 398.0000, 'ºC'),
	(279843, 121, '2014-04-01 01:01:05.000000', 'temperatura', 662.0000, 'ºC'),
	(279844, 121, '2014-04-01 01:01:06.000000', 'temperatura', 917.0000, 'ºC'),
	(279845, 121, '2014-04-01 01:01:07.000000', 'temperatura', 198.0000, 'ºC'),
	(279846, 121, '2014-04-01 01:01:08.000000', 'temperatura', 640.0000, 'ºC'),
	(279847, 121, '2014-04-01 01:01:09.000000', 'temperatura', 207.0000, 'ºC'),
	(279848, 121, '2014-04-01 01:01:10.000000', 'temperatura', 316.0000, 'ºC'),
	(279849, 121, '2014-04-01 01:01:11.000000', 'temperatura', 958.0000, 'ºC'),
	(279850, 121, '2014-04-01 01:01:12.000000', 'temperatura', 243.0000, 'ºC'),
	(279851, 121, '2014-04-01 01:01:13.000000', 'temperatura', 740.0000, 'ºC'),
	(279852, 121, '2014-04-01 01:01:14.000000', 'temperatura', 572.0000, 'ºC'),
	(279853, 121, '2014-04-01 01:01:15.000000', 'temperatura', 641.0000, 'ºC'),
	(279854, 121, '2014-04-01 01:01:16.000000', 'temperatura', 290.0000, 'ºC'),
	(279855, 121, '2014-04-01 01:01:17.000000', 'temperatura', 728.0000, 'ºC'),
	(279856, 121, '2014-04-01 01:01:18.000000', 'temperatura', 370.0000, 'ºC'),
	(279857, 121, '2014-04-01 01:01:19.000000', 'temperatura', 865.0000, 'ºC'),
	(279858, 121, '2014-04-01 01:01:20.000000', 'temperatura', 816.0000, 'ºC'),
	(279859, 121, '2014-04-01 01:01:21.000000', 'temperatura', 286.0000, 'ºC'),
	(279860, 121, '2014-04-01 01:01:22.000000', 'temperatura', 183.0000, 'ºC'),
	(279861, 121, '2014-04-01 01:01:23.000000', 'temperatura', 57.0000, 'ºC'),
	(279862, 121, '2014-04-01 01:01:24.000000', 'temperatura', 938.0000, 'ºC'),
	(279863, 121, '2014-04-01 01:01:25.000000', 'temperatura', 918.0000, 'ºC'),
	(279864, 121, '2014-04-01 01:01:26.000000', 'temperatura', 578.0000, 'ºC'),
	(279865, 121, '2014-04-01 01:01:27.000000', 'temperatura', 134.0000, 'ºC'),
	(279866, 121, '2014-04-01 01:01:28.000000', 'temperatura', 138.0000, 'ºC'),
	(279867, 121, '2014-04-01 01:01:29.000000', 'temperatura', 287.0000, 'ºC'),
	(279868, 121, '2014-04-01 01:01:30.000000', 'temperatura', 1022.0000, 'ºC'),
	(279869, 121, '2014-04-01 01:01:31.000000', 'temperatura', 650.0000, 'ºC'),
	(279870, 121, '2014-04-01 01:01:32.000000', 'temperatura', 183.0000, 'ºC'),
	(279871, 121, '2014-04-01 01:01:33.000000', 'temperatura', 166.0000, 'ºC'),
	(279872, 121, '2014-04-01 01:01:34.000000', 'temperatura', 283.0000, 'ºC'),
	(279873, 121, '2014-04-01 01:01:35.000000', 'temperatura', 918.0000, 'ºC'),
	(279874, 121, '2014-04-01 01:01:36.000000', 'temperatura', 140.0000, 'ºC'),
	(279875, 121, '2014-04-01 01:01:37.000000', 'temperatura', 345.0000, 'ºC'),
	(279876, 121, '2014-04-01 01:01:38.000000', 'temperatura', 107.0000, 'ºC'),
	(279877, 121, '2014-04-01 01:01:39.000000', 'temperatura', 699.0000, 'ºC'),
	(279878, 121, '2014-04-01 01:01:40.000000', 'temperatura', 773.0000, 'ºC'),
	(279879, 121, '2014-04-01 01:01:41.000000', 'temperatura', 572.0000, 'ºC'),
	(279880, 121, '2014-04-01 01:01:42.000000', 'temperatura', 539.0000, 'ºC'),
	(279881, 121, '2014-04-01 01:01:43.000000', 'temperatura', 981.0000, 'ºC'),
	(279882, 121, '2014-04-01 01:01:44.000000', 'temperatura', 888.0000, 'ºC'),
	(279883, 121, '2014-04-01 01:01:45.000000', 'temperatura', 299.0000, 'ºC'),
	(279884, 121, '2014-04-01 01:01:46.000000', 'temperatura', 32.0000, 'ºC'),
	(279885, 121, '2014-04-01 01:01:47.000000', 'temperatura', 462.0000, 'ºC'),
	(279886, 121, '2014-04-01 01:01:48.000000', 'temperatura', 1015.0000, 'ºC'),
	(279887, 121, '2014-04-01 01:01:49.000000', 'temperatura', 91.0000, 'ºC'),
	(279888, 121, '2014-04-01 01:01:50.000000', 'temperatura', 1010.0000, 'ºC'),
	(279889, 121, '2014-04-01 01:01:51.000000', 'temperatura', 1176.0000, 'ºC'),
	(279890, 121, '2014-04-01 01:01:52.000000', 'temperatura', 453.0000, 'ºC'),
	(279891, 121, '2014-04-01 01:01:53.000000', 'temperatura', 1136.0000, 'ºC'),
	(279892, 121, '2014-04-01 01:01:54.000000', 'temperatura', 722.0000, 'ºC'),
	(279893, 121, '2014-04-01 01:01:55.000000', 'temperatura', 204.0000, 'ºC'),
	(279894, 121, '2014-04-01 01:01:56.000000', 'temperatura', 51.0000, 'ºC'),
	(279895, 121, '2014-04-01 01:01:57.000000', 'temperatura', 846.0000, 'ºC'),
	(279896, 121, '2014-04-01 01:01:58.000000', 'temperatura', 476.0000, 'ºC'),
	(279897, 121, '2014-04-01 01:01:59.000000', 'temperatura', 1043.0000, 'ºC'),
	(279898, 121, '2014-04-01 01:02:00.000000', 'temperatura', 187.0000, 'ºC'),
	(279899, 121, '2014-04-01 01:02:01.000000', 'temperatura', 205.0000, 'ºC'),
	(279900, 121, '2014-04-01 01:02:02.000000', 'temperatura', 465.0000, 'ºC'),
	(279901, 121, '2014-04-01 01:02:03.000000', 'temperatura', 512.0000, 'ºC'),
	(279902, 121, '2014-04-01 01:02:04.000000', 'temperatura', 1166.0000, 'ºC'),
	(279903, 121, '2014-04-01 01:02:05.000000', 'temperatura', 694.0000, 'ºC'),
	(279904, 121, '2014-04-01 01:02:06.000000', 'temperatura', 1171.0000, 'ºC'),
	(279905, 121, '2014-04-01 01:02:07.000000', 'temperatura', 172.0000, 'ºC'),
	(279906, 121, '2014-04-01 01:02:08.000000', 'temperatura', 951.0000, 'ºC'),
	(279907, 121, '2014-04-01 01:02:09.000000', 'temperatura', 638.0000, 'ºC'),
	(279908, 121, '2014-04-01 01:02:10.000000', 'temperatura', 339.0000, 'ºC'),
	(279909, 121, '2014-04-01 01:02:11.000000', 'temperatura', 982.0000, 'ºC'),
	(279910, 121, '2014-04-01 01:02:12.000000', 'temperatura', 291.0000, 'ºC'),
	(279911, 121, '2014-04-01 01:02:13.000000', 'temperatura', 910.0000, 'ºC'),
	(279912, 121, '2014-04-01 01:02:14.000000', 'temperatura', 78.0000, 'ºC'),
	(279913, 121, '2014-04-01 01:02:15.000000', 'temperatura', 59.0000, 'ºC'),
	(279914, 121, '2014-04-01 01:02:16.000000', 'temperatura', 61.0000, 'ºC'),
	(279915, 121, '2014-04-01 01:02:17.000000', 'temperatura', 130.0000, 'ºC'),
	(279916, 121, '2014-04-01 01:02:18.000000', 'temperatura', 466.0000, 'ºC'),
	(279917, 121, '2014-04-01 01:02:19.000000', 'temperatura', 740.0000, 'ºC'),
	(279918, 121, '2014-04-01 01:02:20.000000', 'temperatura', 1105.0000, 'ºC'),
	(279919, 121, '2014-04-01 01:02:21.000000', 'temperatura', 904.0000, 'ºC'),
	(279920, 121, '2014-04-01 01:02:22.000000', 'temperatura', 8.0000, 'ºC'),
	(279921, 121, '2014-04-01 01:02:23.000000', 'temperatura', 926.0000, 'ºC'),
	(279922, 121, '2014-04-01 01:02:24.000000', 'temperatura', 1007.0000, 'ºC'),
	(279923, 121, '2014-04-01 01:02:25.000000', 'temperatura', 1056.0000, 'ºC'),
	(279924, 121, '2014-04-01 01:02:26.000000', 'temperatura', 1061.0000, 'ºC'),
	(279925, 121, '2014-04-01 01:02:27.000000', 'temperatura', 937.0000, 'ºC'),
	(279926, 121, '2014-04-01 01:02:28.000000', 'temperatura', 301.0000, 'ºC'),
	(279927, 121, '2014-04-01 01:02:29.000000', 'temperatura', 1095.0000, 'ºC'),
	(279928, 121, '2014-04-01 01:02:30.000000', 'temperatura', 972.0000, 'ºC'),
	(279929, 121, '2014-04-01 01:02:31.000000', 'temperatura', 376.0000, 'ºC'),
	(279930, 121, '2014-04-01 01:02:32.000000', 'temperatura', 165.0000, 'ºC'),
	(279931, 121, '2014-04-01 01:02:33.000000', 'temperatura', 899.0000, 'ºC'),
	(279932, 121, '2014-04-01 01:02:34.000000', 'temperatura', 400.0000, 'ºC'),
	(279933, 121, '2014-04-01 01:02:35.000000', 'temperatura', 503.0000, 'ºC'),
	(279934, 121, '2014-04-01 01:02:36.000000', 'temperatura', 116.0000, 'ºC'),
	(279935, 121, '2014-04-01 01:02:37.000000', 'temperatura', 273.0000, 'ºC'),
	(279936, 121, '2014-04-01 01:02:38.000000', 'temperatura', 1015.0000, 'ºC'),
	(279937, 121, '2014-04-01 01:02:39.000000', 'temperatura', 656.0000, 'ºC'),
	(279938, 121, '2014-04-01 01:02:40.000000', 'temperatura', 236.0000, 'ºC'),
	(279939, 121, '2014-04-01 01:02:41.000000', 'temperatura', 413.0000, 'ºC'),
	(279940, 121, '2014-04-01 01:02:42.000000', 'temperatura', 158.0000, 'ºC'),
	(279941, 121, '2014-04-01 01:02:43.000000', 'temperatura', 752.0000, 'ºC'),
	(279942, 121, '2014-04-01 01:02:44.000000', 'temperatura', 887.0000, 'ºC'),
	(279943, 121, '2014-04-01 01:02:45.000000', 'temperatura', 980.0000, 'ºC'),
	(279944, 121, '2014-04-01 01:02:46.000000', 'temperatura', 1039.0000, 'ºC'),
	(279945, 121, '2014-04-01 01:02:47.000000', 'temperatura', 1057.0000, 'ºC'),
	(279946, 121, '2014-04-01 01:02:48.000000', 'temperatura', 968.0000, 'ºC'),
	(279947, 121, '2014-04-01 01:02:49.000000', 'temperatura', 467.0000, 'ºC'),
	(279948, 121, '2014-04-01 01:02:50.000000', 'temperatura', 633.0000, 'ºC'),
	(279949, 121, '2014-04-01 01:02:51.000000', 'temperatura', 563.0000, 'ºC'),
	(279950, 121, '2014-04-01 01:02:52.000000', 'temperatura', 917.0000, 'ºC'),
	(279951, 121, '2014-04-01 01:02:53.000000', 'temperatura', 496.0000, 'ºC'),
	(279952, 121, '2014-04-01 01:02:54.000000', 'temperatura', 932.0000, 'ºC'),
	(279953, 121, '2014-04-01 01:02:55.000000', 'temperatura', 771.0000, 'ºC'),
	(279954, 121, '2014-04-01 01:02:56.000000', 'temperatura', 1058.0000, 'ºC'),
	(279955, 121, '2014-04-01 01:02:57.000000', 'temperatura', 578.0000, 'ºC'),
	(279956, 121, '2014-04-01 01:02:58.000000', 'temperatura', 915.0000, 'ºC'),
	(279957, 121, '2014-04-01 01:02:59.000000', 'temperatura', 442.0000, 'ºC'),
	(279958, 121, '2014-04-01 01:03:00.000000', 'temperatura', 667.0000, 'ºC'),
	(279959, 121, '2014-04-01 01:03:01.000000', 'temperatura', 809.0000, 'ºC'),
	(279960, 121, '2014-04-01 01:03:02.000000', 'temperatura', 846.0000, 'ºC'),
	(279961, 121, '2014-04-01 01:03:03.000000', 'temperatura', 602.0000, 'ºC'),
	(279962, 121, '2014-04-01 01:03:04.000000', 'temperatura', 474.0000, 'ºC'),
	(279963, 121, '2014-04-01 01:03:05.000000', 'temperatura', 564.0000, 'ºC'),
	(279964, 121, '2014-04-01 01:03:06.000000', 'temperatura', 198.0000, 'ºC'),
	(279965, 121, '2014-04-01 01:03:07.000000', 'temperatura', 498.0000, 'ºC'),
	(279966, 121, '2014-04-01 01:03:08.000000', 'temperatura', 698.0000, 'ºC'),
	(279967, 121, '2014-04-01 01:03:09.000000', 'temperatura', 797.0000, 'ºC'),
	(279968, 121, '2014-04-01 01:03:10.000000', 'temperatura', 692.0000, 'ºC'),
	(279969, 121, '2014-04-01 01:03:11.000000', 'temperatura', 1068.0000, 'ºC'),
	(279970, 121, '2014-04-01 01:03:12.000000', 'temperatura', 867.0000, 'ºC'),
	(279971, 121, '2014-04-01 01:03:13.000000', 'temperatura', 1128.0000, 'ºC'),
	(279972, 121, '2014-04-01 01:03:14.000000', 'temperatura', 641.0000, 'ºC'),
	(279973, 121, '2014-04-01 01:03:15.000000', 'temperatura', 1020.0000, 'ºC'),
	(279974, 121, '2014-04-01 01:03:16.000000', 'temperatura', 778.0000, 'ºC'),
	(279975, 121, '2014-04-01 01:03:17.000000', 'temperatura', 829.0000, 'ºC'),
	(279976, 121, '2014-04-01 01:03:18.000000', 'temperatura', 612.0000, 'ºC'),
	(279977, 121, '2014-04-01 01:03:19.000000', 'temperatura', 576.0000, 'ºC'),
	(279978, 121, '2014-04-01 01:03:20.000000', 'temperatura', 1043.0000, 'ºC'),
	(279979, 121, '2014-04-01 01:03:21.000000', 'temperatura', 1086.0000, 'ºC'),
	(279980, 121, '2014-04-01 01:03:22.000000', 'temperatura', 1101.0000, 'ºC'),
	(279981, 121, '2014-04-01 01:03:23.000000', 'temperatura', 1050.0000, 'ºC'),
	(279982, 121, '2014-04-01 01:03:24.000000', 'temperatura', 747.0000, 'ºC'),
	(279983, 121, '2014-04-01 01:03:25.000000', 'temperatura', 583.0000, 'ºC'),
	(279984, 121, '2014-04-01 01:03:26.000000', 'temperatura', 678.0000, 'ºC'),
	(279985, 121, '2014-04-01 01:03:27.000000', 'temperatura', 439.0000, 'ºC'),
	(279986, 121, '2014-04-01 01:03:28.000000', 'temperatura', 164.0000, 'ºC'),
	(279987, 121, '2014-04-01 01:03:29.000000', 'temperatura', 704.0000, 'ºC'),
	(279988, 121, '2014-04-01 01:03:30.000000', 'temperatura', 628.0000, 'ºC'),
	(279989, 121, '2014-04-01 01:03:31.000000', 'temperatura', 1026.0000, 'ºC'),
	(279990, 121, '2014-04-01 01:03:32.000000', 'temperatura', 848.0000, 'ºC'),
	(279991, 121, '2014-04-01 01:03:33.000000', 'temperatura', 1161.0000, 'ºC'),
	(279992, 121, '2014-04-01 01:03:34.000000', 'temperatura', 864.0000, 'ºC'),
	(279993, 121, '2014-04-01 01:03:35.000000', 'temperatura', 837.0000, 'ºC'),
	(279994, 121, '2014-04-01 01:03:36.000000', 'temperatura', 393.0000, 'ºC'),
	(279995, 121, '2014-04-01 01:03:37.000000', 'temperatura', 653.0000, 'ºC'),
	(279996, 121, '2014-04-01 01:03:38.000000', 'temperatura', 886.0000, 'ºC'),
	(279997, 121, '2014-04-01 01:03:39.000000', 'temperatura', 72.0000, 'ºC'),
	(279998, 121, '2014-04-01 01:03:40.000000', 'temperatura', 104.0000, 'ºC'),
	(279999, 121, '2014-04-01 01:03:41.000000', 'temperatura', 305.0000, 'ºC'),
	(280000, 121, '2014-04-01 01:03:42.000000', 'temperatura', 14.0000, 'ºC'),
	(280001, 121, '2014-04-01 01:03:43.000000', 'temperatura', 353.0000, 'ºC'),
	(280002, 121, '2014-04-01 01:03:44.000000', 'temperatura', 523.0000, 'ºC'),
	(280003, 121, '2014-04-01 01:03:45.000000', 'temperatura', 358.0000, 'ºC'),
	(280004, 121, '2014-04-01 01:03:46.000000', 'temperatura', 220.0000, 'ºC'),
	(280005, 121, '2014-04-01 01:03:47.000000', 'temperatura', 28.0000, 'ºC'),
	(280006, 121, '2014-04-01 01:03:48.000000', 'temperatura', 681.0000, 'ºC'),
	(280007, 121, '2014-04-01 01:03:49.000000', 'temperatura', 923.0000, 'ºC'),
	(280008, 121, '2014-04-01 01:03:50.000000', 'temperatura', 170.0000, 'ºC'),
	(280009, 121, '2014-04-01 01:03:51.000000', 'temperatura', 483.0000, 'ºC'),
	(280010, 121, '2014-04-01 01:03:52.000000', 'temperatura', 705.0000, 'ºC'),
	(280011, 121, '2014-04-01 01:03:53.000000', 'temperatura', 878.0000, 'ºC'),
	(280012, 121, '2014-04-01 01:03:54.000000', 'temperatura', 1073.0000, 'ºC'),
	(280013, 121, '2014-04-01 01:03:55.000000', 'temperatura', 333.0000, 'ºC'),
	(280014, 121, '2014-04-01 01:03:56.000000', 'temperatura', 846.0000, 'ºC'),
	(280015, 121, '2014-04-01 01:03:57.000000', 'temperatura', 834.0000, 'ºC'),
	(280016, 121, '2014-04-01 01:03:58.000000', 'temperatura', 429.0000, 'ºC'),
	(280017, 121, '2014-04-01 01:03:59.000000', 'temperatura', 845.0000, 'ºC'),
	(280018, 121, '2014-04-01 01:04:00.000000', 'temperatura', 539.0000, 'ºC'),
	(280019, 121, '2014-04-01 01:04:01.000000', 'temperatura', 161.0000, 'ºC'),
	(280020, 121, '2014-04-01 01:04:02.000000', 'temperatura', 386.0000, 'ºC'),
	(280021, 121, '2014-04-01 01:04:03.000000', 'temperatura', 249.0000, 'ºC'),
	(280022, 121, '2014-04-01 01:04:04.000000', 'temperatura', 89.0000, 'ºC'),
	(280023, 121, '2014-04-01 01:04:05.000000', 'temperatura', 897.0000, 'ºC'),
	(280024, 121, '2014-04-01 01:04:06.000000', 'temperatura', 617.0000, 'ºC'),
	(280025, 121, '2014-04-01 01:04:07.000000', 'temperatura', 397.0000, 'ºC'),
	(280026, 121, '2014-04-01 01:04:08.000000', 'temperatura', 131.0000, 'ºC'),
	(280027, 121, '2014-04-01 01:04:09.000000', 'temperatura', 668.0000, 'ºC'),
	(280028, 121, '2014-04-01 01:04:10.000000', 'temperatura', 548.0000, 'ºC'),
	(280029, 121, '2014-04-01 01:04:11.000000', 'temperatura', 735.0000, 'ºC'),
	(280030, 121, '2014-04-01 01:04:12.000000', 'temperatura', 834.0000, 'ºC'),
	(280031, 121, '2014-04-01 01:04:13.000000', 'temperatura', 763.0000, 'ºC'),
	(280032, 121, '2014-04-01 01:04:14.000000', 'temperatura', 113.0000, 'ºC'),
	(280033, 121, '2014-04-01 01:04:15.000000', 'temperatura', 679.0000, 'ºC'),
	(280034, 121, '2014-04-01 01:04:16.000000', 'temperatura', 655.0000, 'ºC'),
	(280035, 121, '2014-04-01 01:04:17.000000', 'temperatura', 38.0000, 'ºC'),
	(280036, 121, '2014-04-01 01:04:18.000000', 'temperatura', 627.0000, 'ºC'),
	(280037, 121, '2014-04-01 01:04:19.000000', 'temperatura', 620.0000, 'ºC'),
	(280038, 121, '2014-04-01 01:04:20.000000', 'temperatura', 18.0000, 'ºC'),
	(280039, 121, '2014-04-01 01:04:21.000000', 'temperatura', 634.0000, 'ºC'),
	(280040, 121, '2014-04-01 01:04:22.000000', 'temperatura', 715.0000, 'ºC'),
	(280041, 121, '2014-04-01 01:04:23.000000', 'temperatura', 471.0000, 'ºC'),
	(280042, 121, '2014-04-01 01:04:24.000000', 'temperatura', 214.0000, 'ºC'),
	(280043, 121, '2014-04-01 01:04:25.000000', 'temperatura', 857.0000, 'ºC'),
	(280044, 121, '2014-04-01 01:04:26.000000', 'temperatura', 43.0000, 'ºC'),
	(280045, 121, '2014-04-01 01:04:27.000000', 'temperatura', 43.0000, 'ºC'),
	(280046, 121, '2014-04-01 01:04:28.000000', 'temperatura', 89.0000, 'ºC'),
	(280047, 121, '2014-04-01 01:04:29.000000', 'temperatura', 314.0000, 'ºC'),
	(280048, 121, '2014-04-01 01:04:30.000000', 'temperatura', 103.0000, 'ºC'),
	(280049, 121, '2014-04-01 01:04:31.000000', 'temperatura', 775.0000, 'ºC'),
	(280050, 121, '2014-04-01 01:04:32.000000', 'temperatura', 1164.0000, 'ºC'),
	(280051, 121, '2014-04-01 01:04:33.000000', 'temperatura', 1098.0000, 'ºC'),
	(280052, 121, '2014-04-01 01:04:34.000000', 'temperatura', 796.0000, 'ºC'),
	(280053, 121, '2014-04-01 01:04:35.000000', 'temperatura', 689.0000, 'ºC'),
	(280054, 121, '2014-04-01 01:04:36.000000', 'temperatura', 1055.0000, 'ºC'),
	(280055, 121, '2014-04-01 01:04:37.000000', 'temperatura', 811.0000, 'ºC'),
	(280056, 121, '2014-04-01 01:04:38.000000', 'temperatura', 889.0000, 'ºC'),
	(280057, 121, '2014-04-01 01:04:39.000000', 'temperatura', 812.0000, 'ºC'),
	(280058, 121, '2014-04-01 01:04:40.000000', 'temperatura', 192.0000, 'ºC'),
	(280059, 121, '2014-04-01 01:04:41.000000', 'temperatura', 926.0000, 'ºC'),
	(280060, 121, '2014-04-01 01:04:42.000000', 'temperatura', 454.0000, 'ºC'),
	(280061, 121, '2014-04-01 01:04:43.000000', 'temperatura', 695.0000, 'ºC'),
	(280062, 121, '2014-04-01 01:04:44.000000', 'temperatura', 912.0000, 'ºC'),
	(280063, 121, '2014-04-01 01:04:45.000000', 'temperatura', 74.0000, 'ºC'),
	(280064, 121, '2014-04-01 01:04:46.000000', 'temperatura', 34.0000, 'ºC'),
	(280065, 121, '2014-04-01 01:04:47.000000', 'temperatura', 1150.0000, 'ºC'),
	(280066, 121, '2014-04-01 01:04:48.000000', 'temperatura', 849.0000, 'ºC'),
	(280067, 121, '2014-04-01 01:04:49.000000', 'temperatura', 796.0000, 'ºC'),
	(280068, 121, '2014-04-01 01:04:50.000000', 'temperatura', 232.0000, 'ºC'),
	(280069, 121, '2014-04-01 01:04:51.000000', 'temperatura', 1175.0000, 'ºC'),
	(280070, 121, '2014-04-01 01:04:52.000000', 'temperatura', 378.0000, 'ºC'),
	(280071, 121, '2014-04-01 01:04:53.000000', 'temperatura', 764.0000, 'ºC'),
	(280072, 121, '2014-04-01 01:04:54.000000', 'temperatura', 287.0000, 'ºC'),
	(280073, 121, '2014-04-01 01:04:55.000000', 'temperatura', 345.0000, 'ºC'),
	(280074, 121, '2014-04-01 01:04:56.000000', 'temperatura', 864.0000, 'ºC'),
	(280075, 121, '2014-04-01 01:04:57.000000', 'temperatura', 884.0000, 'ºC'),
	(280076, 121, '2014-04-01 01:04:58.000000', 'temperatura', 628.0000, 'ºC'),
	(280077, 121, '2014-04-01 01:04:59.000000', 'temperatura', 489.0000, 'ºC'),
	(280078, 121, '2014-04-01 01:05:00.000000', 'temperatura', 561.0000, 'ºC'),
	(280079, 121, '2014-04-01 01:05:01.000000', 'temperatura', 137.0000, 'ºC'),
	(280080, 121, '2014-04-01 01:05:02.000000', 'temperatura', 205.0000, 'ºC'),
	(280081, 121, '2014-04-01 01:05:03.000000', 'temperatura', 613.0000, 'ºC'),
	(280082, 121, '2014-04-01 01:05:04.000000', 'temperatura', 52.0000, 'ºC'),
	(280083, 121, '2014-04-01 01:05:05.000000', 'temperatura', 821.0000, 'ºC'),
	(280084, 121, '2014-04-01 01:05:06.000000', 'temperatura', 347.0000, 'ºC'),
	(280085, 121, '2014-04-01 01:05:07.000000', 'temperatura', 476.0000, 'ºC'),
	(280086, 121, '2014-04-01 01:05:08.000000', 'temperatura', 138.0000, 'ºC'),
	(280087, 121, '2014-04-01 01:05:09.000000', 'temperatura', 461.0000, 'ºC'),
	(280088, 121, '2014-04-01 01:05:10.000000', 'temperatura', 692.0000, 'ºC'),
	(280089, 121, '2014-04-01 01:05:11.000000', 'temperatura', 876.0000, 'ºC'),
	(280090, 121, '2014-04-01 01:05:12.000000', 'temperatura', 1106.0000, 'ºC'),
	(280091, 121, '2014-04-01 01:05:13.000000', 'temperatura', 501.0000, 'ºC'),
	(280092, 121, '2014-04-01 01:05:14.000000', 'temperatura', 390.0000, 'ºC'),
	(280093, 121, '2014-04-01 01:05:15.000000', 'temperatura', 447.0000, 'ºC'),
	(280094, 121, '2014-04-01 01:05:16.000000', 'temperatura', 1064.0000, 'ºC'),
	(280095, 121, '2014-04-01 01:05:17.000000', 'temperatura', 379.0000, 'ºC'),
	(280096, 121, '2014-04-01 01:05:18.000000', 'temperatura', 1106.0000, 'ºC'),
	(280097, 121, '2014-04-01 01:05:19.000000', 'temperatura', 793.0000, 'ºC'),
	(280098, 121, '2014-04-01 01:05:20.000000', 'temperatura', 646.0000, 'ºC'),
	(280099, 121, '2014-04-01 01:05:21.000000', 'temperatura', 852.0000, 'ºC'),
	(280100, 121, '2014-04-01 01:05:22.000000', 'temperatura', 1123.0000, 'ºC'),
	(280101, 121, '2014-04-01 01:05:23.000000', 'temperatura', 660.0000, 'ºC'),
	(280102, 121, '2014-04-01 01:05:24.000000', 'temperatura', 1129.0000, 'ºC'),
	(280103, 121, '2014-04-01 01:05:25.000000', 'temperatura', 69.0000, 'ºC'),
	(280104, 121, '2014-04-01 01:05:26.000000', 'temperatura', 555.0000, 'ºC'),
	(280105, 121, '2014-04-01 01:05:27.000000', 'temperatura', 170.0000, 'ºC'),
	(280106, 121, '2014-04-01 01:05:28.000000', 'temperatura', 384.0000, 'ºC'),
	(280107, 121, '2014-04-01 01:05:29.000000', 'temperatura', 213.0000, 'ºC'),
	(280108, 121, '2014-04-01 01:05:30.000000', 'temperatura', 1111.0000, 'ºC'),
	(280109, 121, '2014-04-01 01:05:31.000000', 'temperatura', 117.0000, 'ºC'),
	(280110, 121, '2014-04-01 01:05:32.000000', 'temperatura', 854.0000, 'ºC'),
	(280111, 121, '2014-04-01 01:05:33.000000', 'temperatura', 319.0000, 'ºC'),
	(280112, 121, '2014-04-01 01:05:34.000000', 'temperatura', 235.0000, 'ºC'),
	(280113, 121, '2014-04-01 01:05:35.000000', 'temperatura', 216.0000, 'ºC'),
	(280114, 121, '2014-04-01 01:05:36.000000', 'temperatura', 375.0000, 'ºC'),
	(280115, 121, '2014-04-01 01:05:37.000000', 'temperatura', 29.0000, 'ºC'),
	(280116, 121, '2014-04-01 01:05:38.000000', 'temperatura', 221.0000, 'ºC'),
	(280117, 121, '2014-04-01 01:05:39.000000', 'temperatura', 1020.0000, 'ºC'),
	(280118, 121, '2014-04-01 01:05:40.000000', 'temperatura', 836.0000, 'ºC'),
	(280119, 121, '2014-04-01 01:05:41.000000', 'temperatura', 1119.0000, 'ºC'),
	(280120, 121, '2014-04-01 01:05:42.000000', 'temperatura', 687.0000, 'ºC'),
	(280121, 121, '2014-04-01 01:05:43.000000', 'temperatura', 81.0000, 'ºC'),
	(280122, 121, '2014-04-01 01:05:44.000000', 'temperatura', 746.0000, 'ºC'),
	(280123, 121, '2014-04-01 01:05:45.000000', 'temperatura', 1084.0000, 'ºC'),
	(280124, 121, '2014-04-01 01:05:46.000000', 'temperatura', 782.0000, 'ºC'),
	(280125, 121, '2014-04-01 01:05:47.000000', 'temperatura', 661.0000, 'ºC'),
	(280126, 121, '2014-04-01 01:05:48.000000', 'temperatura', 958.0000, 'ºC'),
	(280127, 121, '2014-04-01 01:05:49.000000', 'temperatura', 407.0000, 'ºC'),
	(280128, 121, '2014-04-01 01:05:50.000000', 'temperatura', 363.0000, 'ºC'),
	(280129, 121, '2014-04-01 01:05:51.000000', 'temperatura', 592.0000, 'ºC'),
	(280130, 121, '2014-04-01 01:05:52.000000', 'temperatura', 673.0000, 'ºC'),
	(280131, 121, '2014-04-01 01:05:53.000000', 'temperatura', 389.0000, 'ºC'),
	(280132, 121, '2014-04-01 01:05:54.000000', 'temperatura', 1126.0000, 'ºC'),
	(280133, 121, '2014-04-01 01:05:55.000000', 'temperatura', 865.0000, 'ºC'),
	(280134, 121, '2014-04-01 01:05:56.000000', 'temperatura', 949.0000, 'ºC'),
	(280135, 121, '2014-04-01 01:05:57.000000', 'temperatura', 947.0000, 'ºC'),
	(280136, 121, '2014-04-01 01:05:58.000000', 'temperatura', 692.0000, 'ºC'),
	(280137, 121, '2014-04-01 01:05:59.000000', 'temperatura', 618.0000, 'ºC'),
	(280138, 121, '2014-04-01 01:06:00.000000', 'temperatura', 1014.0000, 'ºC'),
	(280139, 121, '2014-04-01 01:06:01.000000', 'temperatura', 815.0000, 'ºC'),
	(280140, 121, '2014-04-01 01:06:02.000000', 'temperatura', 1036.0000, 'ºC'),
	(280141, 121, '2014-04-01 01:06:03.000000', 'temperatura', 336.0000, 'ºC'),
	(280142, 121, '2014-04-01 01:06:04.000000', 'temperatura', 973.0000, 'ºC'),
	(280143, 121, '2014-04-01 01:06:05.000000', 'temperatura', 256.0000, 'ºC'),
	(280144, 121, '2014-04-01 01:06:06.000000', 'temperatura', 761.0000, 'ºC'),
	(280145, 121, '2014-04-01 01:06:07.000000', 'temperatura', 640.0000, 'ºC'),
	(280146, 121, '2014-04-01 01:06:08.000000', 'temperatura', 915.0000, 'ºC'),
	(280147, 121, '2014-04-01 01:06:09.000000', 'temperatura', 256.0000, 'ºC'),
	(280148, 121, '2014-04-01 01:06:10.000000', 'temperatura', 938.0000, 'ºC'),
	(280149, 121, '2014-04-01 01:06:11.000000', 'temperatura', 319.0000, 'ºC'),
	(280150, 121, '2014-04-01 01:06:12.000000', 'temperatura', 1185.0000, 'ºC'),
	(280151, 121, '2014-04-01 01:06:13.000000', 'temperatura', 166.0000, 'ºC'),
	(280152, 121, '2014-04-01 01:06:14.000000', 'temperatura', 877.0000, 'ºC'),
	(280153, 121, '2014-04-01 01:06:15.000000', 'temperatura', 288.0000, 'ºC'),
	(280154, 121, '2014-04-01 01:06:16.000000', 'temperatura', 9.0000, 'ºC'),
	(280155, 121, '2014-04-01 01:06:17.000000', 'temperatura', 381.0000, 'ºC'),
	(280156, 121, '2014-04-01 01:06:18.000000', 'temperatura', 680.0000, 'ºC'),
	(280157, 121, '2014-04-01 01:06:19.000000', 'temperatura', 1057.0000, 'ºC'),
	(280158, 121, '2014-04-01 01:06:20.000000', 'temperatura', 843.0000, 'ºC'),
	(280159, 121, '2014-04-01 01:06:21.000000', 'temperatura', 1046.0000, 'ºC'),
	(280160, 121, '2014-04-01 01:06:22.000000', 'temperatura', 304.0000, 'ºC'),
	(280161, 121, '2014-04-01 01:06:23.000000', 'temperatura', 779.0000, 'ºC'),
	(280162, 121, '2014-04-01 01:06:24.000000', 'temperatura', 587.0000, 'ºC'),
	(280163, 121, '2014-04-01 01:06:25.000000', 'temperatura', 595.0000, 'ºC'),
	(280164, 121, '2014-04-01 01:06:26.000000', 'temperatura', 16.0000, 'ºC'),
	(280165, 121, '2014-04-01 01:06:27.000000', 'temperatura', 697.0000, 'ºC'),
	(280166, 121, '2014-04-01 01:06:28.000000', 'temperatura', 1037.0000, 'ºC'),
	(280167, 121, '2014-04-01 01:06:29.000000', 'temperatura', 695.0000, 'ºC'),
	(280168, 121, '2014-04-01 01:06:30.000000', 'temperatura', 364.0000, 'ºC'),
	(280169, 121, '2014-04-01 01:06:31.000000', 'temperatura', 934.0000, 'ºC'),
	(280170, 121, '2014-04-01 01:06:32.000000', 'temperatura', 1179.0000, 'ºC'),
	(280171, 121, '2014-04-01 01:06:33.000000', 'temperatura', 694.0000, 'ºC'),
	(280172, 121, '2014-04-01 01:06:34.000000', 'temperatura', 1133.0000, 'ºC'),
	(280173, 121, '2014-04-01 01:06:35.000000', 'temperatura', 1183.0000, 'ºC'),
	(280174, 121, '2014-04-01 01:06:36.000000', 'temperatura', 116.0000, 'ºC'),
	(280175, 121, '2014-04-01 01:06:37.000000', 'temperatura', 632.0000, 'ºC'),
	(280176, 121, '2014-04-01 01:06:38.000000', 'temperatura', 412.0000, 'ºC'),
	(280177, 121, '2014-04-01 01:06:39.000000', 'temperatura', 164.0000, 'ºC'),
	(280178, 121, '2014-04-01 01:06:40.000000', 'temperatura', 787.0000, 'ºC'),
	(280179, 121, '2014-04-01 01:06:41.000000', 'temperatura', 1043.0000, 'ºC'),
	(280180, 121, '2014-04-01 01:06:42.000000', 'temperatura', 452.0000, 'ºC'),
	(280181, 121, '2014-04-01 01:06:43.000000', 'temperatura', 334.0000, 'ºC'),
	(280182, 121, '2014-04-01 01:06:44.000000', 'temperatura', 316.0000, 'ºC'),
	(280183, 121, '2014-04-01 01:06:45.000000', 'temperatura', 575.0000, 'ºC'),
	(280184, 121, '2014-04-01 01:06:46.000000', 'temperatura', 729.0000, 'ºC'),
	(280185, 121, '2014-04-01 01:06:47.000000', 'temperatura', 719.0000, 'ºC'),
	(280186, 121, '2014-04-01 01:06:48.000000', 'temperatura', 207.0000, 'ºC'),
	(280187, 121, '2014-04-01 01:06:49.000000', 'temperatura', 82.0000, 'ºC'),
	(280188, 121, '2014-04-01 01:06:50.000000', 'temperatura', 989.0000, 'ºC'),
	(280189, 121, '2014-04-01 01:06:51.000000', 'temperatura', 1101.0000, 'ºC'),
	(280190, 121, '2014-04-01 01:06:52.000000', 'temperatura', 136.0000, 'ºC'),
	(280191, 121, '2014-04-01 01:06:53.000000', 'temperatura', 977.0000, 'ºC'),
	(280192, 121, '2014-04-01 01:06:54.000000', 'temperatura', 879.0000, 'ºC'),
	(280193, 121, '2014-04-01 01:06:55.000000', 'temperatura', 265.0000, 'ºC'),
	(280194, 121, '2014-04-01 01:06:56.000000', 'temperatura', 1088.0000, 'ºC'),
	(280195, 121, '2014-04-01 01:06:57.000000', 'temperatura', 1047.0000, 'ºC'),
	(280196, 121, '2014-04-01 01:06:58.000000', 'temperatura', 772.0000, 'ºC'),
	(280197, 121, '2014-04-01 01:06:59.000000', 'temperatura', 718.0000, 'ºC'),
	(280198, 121, '2014-04-01 01:07:00.000000', 'temperatura', 75.0000, 'ºC'),
	(280199, 121, '2014-04-01 01:07:01.000000', 'temperatura', 621.0000, 'ºC'),
	(280200, 121, '2014-04-01 01:07:02.000000', 'temperatura', 480.0000, 'ºC'),
	(280201, 121, '2014-04-01 01:07:03.000000', 'temperatura', 537.0000, 'ºC'),
	(280202, 121, '2014-04-01 01:07:04.000000', 'temperatura', 46.0000, 'ºC'),
	(280203, 121, '2014-04-01 01:07:05.000000', 'temperatura', 1020.0000, 'ºC'),
	(280204, 121, '2014-04-01 01:07:06.000000', 'temperatura', 162.0000, 'ºC'),
	(280205, 121, '2014-04-01 01:07:07.000000', 'temperatura', 150.0000, 'ºC'),
	(280206, 121, '2014-04-01 01:07:08.000000', 'temperatura', 263.0000, 'ºC'),
	(280207, 121, '2014-04-01 01:07:09.000000', 'temperatura', 867.0000, 'ºC'),
	(280208, 121, '2014-04-01 01:07:10.000000', 'temperatura', 1148.0000, 'ºC'),
	(280209, 121, '2014-04-01 01:07:11.000000', 'temperatura', 738.0000, 'ºC'),
	(280210, 121, '2014-04-01 01:07:12.000000', 'temperatura', 248.0000, 'ºC'),
	(280211, 121, '2014-04-01 01:07:13.000000', 'temperatura', 227.0000, 'ºC'),
	(280212, 121, '2014-04-01 01:07:14.000000', 'temperatura', 390.0000, 'ºC'),
	(280213, 121, '2014-04-01 01:07:15.000000', 'temperatura', 71.0000, 'ºC'),
	(280214, 121, '2014-04-01 01:07:16.000000', 'temperatura', 383.0000, 'ºC'),
	(280215, 121, '2014-04-01 01:07:17.000000', 'temperatura', 502.0000, 'ºC'),
	(280216, 121, '2014-04-01 01:07:18.000000', 'temperatura', 163.0000, 'ºC'),
	(280217, 121, '2014-04-01 01:07:19.000000', 'temperatura', 510.0000, 'ºC'),
	(280218, 121, '2014-04-01 01:07:20.000000', 'temperatura', 863.0000, 'ºC'),
	(280219, 121, '2014-04-01 01:07:21.000000', 'temperatura', 384.0000, 'ºC'),
	(280220, 121, '2014-04-01 01:07:22.000000', 'temperatura', 531.0000, 'ºC'),
	(280221, 121, '2014-04-01 01:07:23.000000', 'temperatura', 304.0000, 'ºC'),
	(280222, 121, '2014-04-01 01:07:24.000000', 'temperatura', 1126.0000, 'ºC'),
	(280223, 121, '2014-04-01 01:07:25.000000', 'temperatura', 1118.0000, 'ºC'),
	(280224, 121, '2014-04-01 01:07:26.000000', 'temperatura', 1015.0000, 'ºC'),
	(280225, 121, '2014-04-01 01:07:27.000000', 'temperatura', 521.0000, 'ºC'),
	(280226, 121, '2014-04-01 01:07:28.000000', 'temperatura', 760.0000, 'ºC'),
	(280227, 121, '2014-04-01 01:07:29.000000', 'temperatura', 1040.0000, 'ºC'),
	(280228, 121, '2014-04-01 01:07:30.000000', 'temperatura', 517.0000, 'ºC'),
	(280229, 121, '2014-04-01 01:07:31.000000', 'temperatura', 668.0000, 'ºC'),
	(280230, 121, '2014-04-01 01:07:32.000000', 'temperatura', 589.0000, 'ºC'),
	(280231, 121, '2014-04-01 01:07:33.000000', 'temperatura', 940.0000, 'ºC'),
	(280232, 121, '2014-04-01 01:07:34.000000', 'temperatura', 533.0000, 'ºC'),
	(280233, 121, '2014-04-01 01:07:35.000000', 'temperatura', 1046.0000, 'ºC'),
	(280234, 121, '2014-04-01 01:07:36.000000', 'temperatura', 33.0000, 'ºC'),
	(280235, 121, '2014-04-01 01:07:37.000000', 'temperatura', 626.0000, 'ºC'),
	(280236, 121, '2014-04-01 01:07:38.000000', 'temperatura', 633.0000, 'ºC'),
	(280237, 121, '2014-04-01 01:07:39.000000', 'temperatura', 88.0000, 'ºC'),
	(280238, 121, '2014-04-01 01:07:40.000000', 'temperatura', 941.0000, 'ºC'),
	(280239, 121, '2014-04-01 01:07:41.000000', 'temperatura', 840.0000, 'ºC'),
	(280240, 121, '2014-04-01 01:07:42.000000', 'temperatura', 177.0000, 'ºC'),
	(280241, 121, '2014-04-01 01:07:43.000000', 'temperatura', 765.0000, 'ºC'),
	(280242, 121, '2014-04-01 01:07:44.000000', 'temperatura', 897.0000, 'ºC'),
	(280243, 121, '2014-04-01 01:07:45.000000', 'temperatura', 991.0000, 'ºC'),
	(280244, 121, '2014-04-01 01:07:46.000000', 'temperatura', 1063.0000, 'ºC'),
	(280245, 121, '2014-04-01 01:07:47.000000', 'temperatura', 1143.0000, 'ºC'),
	(280246, 121, '2014-04-01 01:07:48.000000', 'temperatura', 128.0000, 'ºC'),
	(280247, 121, '2014-04-01 01:07:49.000000', 'temperatura', 810.0000, 'ºC'),
	(280248, 121, '2014-04-01 01:07:50.000000', 'temperatura', 65.0000, 'ºC'),
	(280249, 121, '2014-04-01 01:07:51.000000', 'temperatura', 297.0000, 'ºC'),
	(280250, 121, '2014-04-01 01:07:52.000000', 'temperatura', 89.0000, 'ºC'),
	(280251, 121, '2014-04-01 01:07:53.000000', 'temperatura', 757.0000, 'ºC'),
	(280252, 121, '2014-04-01 01:07:54.000000', 'temperatura', 1117.0000, 'ºC'),
	(280253, 121, '2014-04-01 01:07:55.000000', 'temperatura', 916.0000, 'ºC'),
	(280254, 121, '2014-04-01 01:07:56.000000', 'temperatura', 30.0000, 'ºC'),
	(280255, 121, '2014-04-01 01:07:57.000000', 'temperatura', 1000.0000, 'ºC'),
	(280256, 121, '2014-04-01 01:07:58.000000', 'temperatura', 113.0000, 'ºC'),
	(280257, 121, '2014-04-01 01:07:59.000000', 'temperatura', 1165.0000, 'ºC'),
	(280258, 121, '2014-04-01 01:08:00.000000', 'temperatura', 688.0000, 'ºC'),
	(280259, 121, '2014-04-01 01:08:01.000000', 'temperatura', 1145.0000, 'ºC'),
	(280260, 121, '2014-04-01 01:08:02.000000', 'temperatura', 59.0000, 'ºC'),
	(280261, 121, '2014-04-01 01:08:03.000000', 'temperatura', 461.0000, 'ºC'),
	(280262, 121, '2014-04-01 01:08:04.000000', 'temperatura', 930.0000, 'ºC'),
	(280263, 121, '2014-04-01 01:08:05.000000', 'temperatura', 866.0000, 'ºC'),
	(280264, 121, '2014-04-01 01:08:06.000000', 'temperatura', 339.0000, 'ºC'),
	(280265, 121, '2014-04-01 01:08:07.000000', 'temperatura', 300.0000, 'ºC'),
	(280266, 121, '2014-04-01 01:08:08.000000', 'temperatura', 481.0000, 'ºC'),
	(280267, 121, '2014-04-01 01:08:09.000000', 'temperatura', 308.0000, 'ºC'),
	(280268, 121, '2014-04-01 01:08:10.000000', 'temperatura', 96.0000, 'ºC'),
	(280269, 121, '2014-04-01 01:08:11.000000', 'temperatura', 757.0000, 'ºC'),
	(280270, 121, '2014-04-01 01:08:12.000000', 'temperatura', 1099.0000, 'ºC'),
	(280271, 121, '2014-04-01 01:08:13.000000', 'temperatura', 821.0000, 'ºC'),
	(280272, 121, '2014-04-01 01:08:14.000000', 'temperatura', 812.0000, 'ºC'),
	(280273, 121, '2014-04-01 01:08:15.000000', 'temperatura', 398.0000, 'ºC'),
	(280274, 121, '2014-04-01 01:08:16.000000', 'temperatura', 751.0000, 'ºC'),
	(280275, 121, '2014-04-01 01:08:17.000000', 'temperatura', 165.0000, 'ºC'),
	(280276, 121, '2014-04-01 01:08:18.000000', 'temperatura', 972.0000, 'ºC'),
	(280277, 121, '2014-04-01 01:08:19.000000', 'temperatura', 764.0000, 'ºC'),
	(280278, 121, '2014-04-01 01:08:20.000000', 'temperatura', 906.0000, 'ºC'),
	(280279, 121, '2014-04-01 01:08:21.000000', 'temperatura', 1036.0000, 'ºC'),
	(280280, 121, '2014-04-01 01:08:22.000000', 'temperatura', 66.0000, 'ºC'),
	(280281, 121, '2014-04-01 01:08:23.000000', 'temperatura', 821.0000, 'ºC'),
	(280282, 121, '2014-04-01 01:08:24.000000', 'temperatura', 307.0000, 'ºC'),
	(280283, 121, '2014-04-01 01:08:25.000000', 'temperatura', 273.0000, 'ºC'),
	(280284, 121, '2014-04-01 01:08:26.000000', 'temperatura', 443.0000, 'ºC'),
	(280285, 121, '2014-04-01 01:08:27.000000', 'temperatura', 196.0000, 'ºC'),
	(280286, 121, '2014-04-01 01:08:28.000000', 'temperatura', 852.0000, 'ºC'),
	(280287, 121, '2014-04-01 01:08:29.000000', 'temperatura', 72.0000, 'ºC'),
	(280288, 121, '2014-04-01 01:08:30.000000', 'temperatura', 207.0000, 'ºC'),
	(280289, 121, '2014-04-01 01:08:31.000000', 'temperatura', 817.0000, 'ºC'),
	(280290, 121, '2014-04-01 01:08:32.000000', 'temperatura', 1065.0000, 'ºC'),
	(280291, 121, '2014-04-01 01:08:33.000000', 'temperatura', 473.0000, 'ºC'),
	(280292, 121, '2014-04-01 01:08:34.000000', 'temperatura', 372.0000, 'ºC'),
	(280293, 121, '2014-04-01 01:08:35.000000', 'temperatura', 440.0000, 'ºC'),
	(280294, 121, '2014-04-01 01:08:36.000000', 'temperatura', 1084.0000, 'ºC'),
	(280295, 121, '2014-04-01 01:08:37.000000', 'temperatura', 500.0000, 'ºC'),
	(280296, 121, '2014-04-01 01:08:38.000000', 'temperatura', 450.0000, 'ºC'),
	(280297, 121, '2014-04-01 01:08:39.000000', 'temperatura', 751.0000, 'ºC'),
	(280298, 121, '2014-04-01 01:08:40.000000', 'temperatura', 6.0000, 'ºC'),
	(280299, 121, '2014-04-01 01:08:41.000000', 'temperatura', 176.0000, 'ºC'),
	(280300, 121, '2014-04-01 01:08:42.000000', 'temperatura', 864.0000, 'ºC'),
	(280301, 121, '2014-04-01 01:08:43.000000', 'temperatura', 192.0000, 'ºC'),
	(280302, 121, '2014-04-01 01:08:44.000000', 'temperatura', 768.0000, 'ºC'),
	(280303, 121, '2014-04-01 01:08:45.000000', 'temperatura', 865.0000, 'ºC'),
	(280304, 121, '2014-04-01 01:08:46.000000', 'temperatura', 821.0000, 'ºC'),
	(280305, 121, '2014-04-01 01:08:47.000000', 'temperatura', 310.0000, 'ºC'),
	(280306, 121, '2014-04-01 01:08:48.000000', 'temperatura', 290.0000, 'ºC'),
	(280307, 121, '2014-04-01 01:08:49.000000', 'temperatura', 518.0000, 'ºC'),
	(280308, 121, '2014-04-01 01:08:50.000000', 'temperatura', 519.0000, 'ºC'),
	(280309, 121, '2014-04-01 01:08:51.000000', 'temperatura', 1044.0000, 'ºC'),
	(280310, 121, '2014-04-01 01:08:52.000000', 'temperatura', 64.0000, 'ºC'),
	(280311, 121, '2014-04-01 01:08:53.000000', 'temperatura', 787.0000, 'ºC'),
	(280312, 121, '2014-04-01 01:08:54.000000', 'temperatura', 143.0000, 'ºC'),
	(280313, 121, '2014-04-01 01:08:55.000000', 'temperatura', 754.0000, 'ºC'),
	(280314, 121, '2014-04-01 01:08:56.000000', 'temperatura', 941.0000, 'ºC'),
	(280315, 121, '2014-04-01 01:08:57.000000', 'temperatura', 43.0000, 'ºC'),
	(280316, 121, '2014-04-01 01:08:58.000000', 'temperatura', 993.0000, 'ºC'),
	(280317, 121, '2014-04-01 01:08:59.000000', 'temperatura', 35.0000, 'ºC'),
	(280318, 121, '2014-04-01 01:09:00.000000', 'temperatura', 800.0000, 'ºC'),
	(280319, 121, '2014-04-01 01:09:01.000000', 'temperatura', 293.0000, 'ºC'),
	(280320, 121, '2014-04-01 01:09:02.000000', 'temperatura', 267.0000, 'ºC'),
	(280321, 121, '2014-04-01 01:09:03.000000', 'temperatura', 455.0000, 'ºC'),
	(280322, 121, '2014-04-01 01:09:04.000000', 'temperatura', 277.0000, 'ºC'),
	(280323, 121, '2014-04-01 01:09:05.000000', 'temperatura', 18.0000, 'ºC'),
	(280324, 121, '2014-04-01 01:09:06.000000', 'temperatura', 460.0000, 'ºC'),
	(280325, 121, '2014-04-01 01:09:07.000000', 'temperatura', 1049.0000, 'ºC'),
	(280326, 121, '2014-04-01 01:09:08.000000', 'temperatura', 263.0000, 'ºC'),
	(280327, 121, '2014-04-01 01:09:09.000000', 'temperatura', 569.0000, 'ºC'),
	(280328, 121, '2014-04-01 01:09:10.000000', 'temperatura', 855.0000, 'ºC'),
	(280329, 121, '2014-04-01 01:09:11.000000', 'temperatura', 170.0000, 'ºC'),
	(280330, 121, '2014-04-01 01:09:12.000000', 'temperatura', 686.0000, 'ºC'),
	(280331, 121, '2014-04-01 01:09:13.000000', 'temperatura', 521.0000, 'ºC'),
	(280332, 121, '2014-04-01 01:09:14.000000', 'temperatura', 548.0000, 'ºC'),
	(280333, 121, '2014-04-01 01:09:15.000000', 'temperatura', 1178.0000, 'ºC'),
	(280334, 121, '2014-04-01 01:09:16.000000', 'temperatura', 646.0000, 'ºC'),
	(280335, 121, '2014-04-01 01:09:17.000000', 'temperatura', 896.0000, 'ºC'),
	(280336, 121, '2014-04-01 01:09:18.000000', 'temperatura', 144.0000, 'ºC'),
	(280337, 121, '2014-04-01 01:09:19.000000', 'temperatura', 432.0000, 'ºC'),
	(280338, 121, '2014-04-01 01:09:20.000000', 'temperatura', 527.0000, 'ºC'),
	(280339, 121, '2014-04-01 01:09:21.000000', 'temperatura', 140.0000, 'ºC'),
	(280340, 121, '2014-04-01 01:09:22.000000', 'temperatura', 321.0000, 'ºC'),
	(280341, 121, '2014-04-01 01:09:23.000000', 'temperatura', 1186.0000, 'ºC'),
	(280342, 121, '2014-04-01 01:09:24.000000', 'temperatura', 165.0000, 'ºC'),
	(280343, 121, '2014-04-01 01:09:25.000000', 'temperatura', 870.0000, 'ºC'),
	(280344, 121, '2014-04-01 01:09:26.000000', 'temperatura', 255.0000, 'ºC'),
	(280345, 121, '2014-04-01 01:09:27.000000', 'temperatura', 1063.0000, 'ºC'),
	(280346, 121, '2014-04-01 01:09:28.000000', 'temperatura', 953.0000, 'ºC'),
	(280347, 121, '2014-04-01 01:09:29.000000', 'temperatura', 377.0000, 'ºC'),
	(280348, 121, '2014-04-01 01:09:30.000000', 'temperatura', 224.0000, 'ºC'),
	(280349, 121, '2014-04-01 01:09:31.000000', 'temperatura', 1192.0000, 'ºC'),
	(280350, 121, '2014-04-01 01:09:32.000000', 'temperatura', 487.0000, 'ºC'),
	(280351, 121, '2014-04-01 01:09:33.000000', 'temperatura', 60.0000, 'ºC'),
	(280352, 121, '2014-04-01 01:09:34.000000', 'temperatura', 41.0000, 'ºC'),
	(280353, 121, '2014-04-01 01:09:35.000000', 'temperatura', 23.0000, 'ºC'),
	(280354, 121, '2014-04-01 01:09:36.000000', 'temperatura', 1193.0000, 'ºC'),
	(280355, 121, '2014-04-01 01:09:37.000000', 'temperatura', 1099.0000, 'ºC'),
	(280356, 121, '2014-04-01 01:09:38.000000', 'temperatura', 713.0000, 'ºC'),
	(280357, 121, '2014-04-01 01:09:39.000000', 'temperatura', 271.0000, 'ºC'),
	(280358, 121, '2014-04-01 01:09:40.000000', 'temperatura', 417.0000, 'ºC'),
	(280359, 121, '2014-04-01 01:09:41.000000', 'temperatura', 73.0000, 'ºC'),
	(280360, 121, '2014-04-01 01:09:42.000000', 'temperatura', 315.0000, 'ºC'),
	(280361, 121, '2014-04-01 01:09:43.000000', 'temperatura', 154.0000, 'ºC'),
	(280362, 121, '2014-04-01 01:09:44.000000', 'temperatura', 1026.0000, 'ºC'),
	(280363, 121, '2014-04-01 01:09:45.000000', 'temperatura', 1071.0000, 'ºC'),
	(280364, 121, '2014-04-01 01:09:46.000000', 'temperatura', 1075.0000, 'ºC'),
	(280365, 121, '2014-04-01 01:09:47.000000', 'temperatura', 963.0000, 'ºC'),
	(280366, 121, '2014-04-01 01:09:48.000000', 'temperatura', 389.0000, 'ºC'),
	(280367, 121, '2014-04-01 01:09:49.000000', 'temperatura', 256.0000, 'ºC'),
	(280368, 121, '2014-04-01 01:09:50.000000', 'temperatura', 116.0000, 'ºC'),
	(280369, 121, '2014-04-01 01:09:51.000000', 'temperatura', 1011.0000, 'ºC'),
	(280370, 121, '2014-04-01 01:09:52.000000', 'temperatura', 1107.0000, 'ºC'),
	(280371, 121, '2014-04-01 01:09:53.000000', 'temperatura', 103.0000, 'ºC'),
	(280372, 121, '2014-04-01 01:09:54.000000', 'temperatura', 796.0000, 'ºC'),
	(280373, 121, '2014-04-01 01:09:55.000000', 'temperatura', 70.0000, 'ºC'),
	(280374, 121, '2014-04-01 01:09:56.000000', 'temperatura', 362.0000, 'ºC'),
	(280375, 121, '2014-04-01 01:09:57.000000', 'temperatura', 401.0000, 'ºC'),
	(280376, 121, '2014-04-01 01:09:58.000000', 'temperatura', 921.0000, 'ºC'),
	(280377, 121, '2014-04-01 01:09:59.000000', 'temperatura', 1001.0000, 'ºC'),
	(280378, 121, '2014-04-01 01:10:00.000000', 'temperatura', 1042.0000, 'ºC'),
	(280379, 121, '2014-04-01 01:10:01.000000', 'temperatura', 1008.0000, 'ºC'),
	(280380, 121, '2014-04-01 01:10:02.000000', 'temperatura', 713.0000, 'ºC'),
	(280381, 121, '2014-04-01 01:10:03.000000', 'temperatura', 544.0000, 'ºC'),
	(280382, 121, '2014-04-01 01:10:04.000000', 'temperatura', 582.0000, 'ºC'),
	(280383, 121, '2014-04-01 01:10:05.000000', 'temperatura', 76.0000, 'ºC'),
	(280384, 121, '2014-04-01 01:10:06.000000', 'temperatura', 1036.0000, 'ºC'),
	(280385, 121, '2014-04-01 01:10:07.000000', 'temperatura', 150.0000, 'ºC'),
	(280386, 121, '2014-04-01 01:10:08.000000', 'temperatura', 45.0000, 'ºC'),
	(280387, 121, '2014-04-01 01:10:09.000000', 'temperatura', 975.0000, 'ºC'),
	(280388, 121, '2014-04-01 01:10:10.000000', 'temperatura', 1140.0000, 'ºC'),
	(280389, 121, '2014-04-01 01:10:11.000000', 'temperatura', 375.0000, 'ºC'),
	(280390, 121, '2014-04-01 01:10:12.000000', 'temperatura', 857.0000, 'ºC'),
	(280391, 121, '2014-04-01 01:10:13.000000', 'temperatura', 758.0000, 'ºC'),
	(280392, 121, '2014-04-01 01:10:14.000000', 'temperatura', 20.0000, 'ºC'),
	(280393, 121, '2014-04-01 01:10:15.000000', 'temperatura', 226.0000, 'ºC'),
	(280394, 121, '2014-04-01 01:10:16.000000', 'temperatura', 1071.0000, 'ºC'),
	(280395, 121, '2014-04-01 01:10:17.000000', 'temperatura', 1077.0000, 'ºC'),
	(280396, 121, '2014-04-01 01:10:18.000000', 'temperatura', 975.0000, 'ºC'),
	(280397, 121, '2014-04-01 01:10:19.000000', 'temperatura', 443.0000, 'ºC'),
	(280398, 121, '2014-04-01 01:10:20.000000', 'temperatura', 492.0000, 'ºC'),
	(280399, 121, '2014-04-01 01:10:21.000000', 'temperatura', 1133.0000, 'ºC'),
	(280400, 121, '2014-04-01 01:10:22.000000', 'temperatura', 586.0000, 'ºC'),
	(280401, 121, '2014-04-01 01:10:23.000000', 'temperatura', 731.0000, 'ºC'),
	(280402, 121, '2014-04-01 01:10:24.000000', 'temperatura', 701.0000, 'ºC'),
	(280403, 121, '2014-04-01 01:10:25.000000', 'temperatura', 110.0000, 'ºC'),
	(280404, 121, '2014-04-01 01:10:26.000000', 'temperatura', 847.0000, 'ºC'),
	(280405, 121, '2014-04-01 01:10:27.000000', 'temperatura', 306.0000, 'ºC'),
	(280406, 121, '2014-04-01 01:10:28.000000', 'temperatura', 191.0000, 'ºC'),
	(280407, 121, '2014-04-01 01:10:29.000000', 'temperatura', 35.0000, 'ºC'),
	(280408, 121, '2014-04-01 01:10:30.000000', 'temperatura', 805.0000, 'ºC'),
	(280409, 121, '2014-04-01 01:10:31.000000', 'temperatura', 319.0000, 'ºC'),
	(280410, 121, '2014-04-01 01:10:32.000000', 'temperatura', 381.0000, 'ºC'),
	(280411, 121, '2014-04-01 01:10:33.000000', 'temperatura', 949.0000, 'ºC'),
	(280412, 121, '2014-04-01 01:10:34.000000', 'temperatura', 0.0000, 'ºC'),
	(280413, 121, '2014-04-01 01:10:35.000000', 'temperatura', 755.0000, 'ºC'),
	(280414, 121, '2014-04-01 01:10:36.000000', 'temperatura', 175.0000, 'ºC'),
	(280415, 121, '2014-04-01 01:10:37.000000', 'temperatura', 1012.0000, 'ºC'),
	(280416, 121, '2014-04-01 01:10:38.000000', 'temperatura', 933.0000, 'ºC'),
	(280417, 121, '2014-04-01 01:10:39.000000', 'temperatura', 433.0000, 'ºC'),
	(280418, 121, '2014-04-01 01:10:40.000000', 'temperatura', 563.0000, 'ºC'),
	(280419, 121, '2014-04-01 01:10:41.000000', 'temperatura', 319.0000, 'ºC'),
	(280420, 121, '2014-04-01 01:10:42.000000', 'temperatura', 1107.0000, 'ºC'),
	(280421, 121, '2014-04-01 01:10:43.000000', 'temperatura', 977.0000, 'ºC'),
	(280422, 121, '2014-04-01 01:10:44.000000', 'temperatura', 364.0000, 'ºC'),
	(280423, 121, '2014-04-01 01:10:45.000000', 'temperatura', 90.0000, 'ºC'),
	(280424, 121, '2014-04-01 01:10:46.000000', 'temperatura', 560.0000, 'ºC'),
	(280425, 121, '2014-04-01 01:10:47.000000', 'temperatura', 132.0000, 'ºC'),
	(280426, 121, '2014-04-01 01:10:48.000000', 'temperatura', 177.0000, 'ºC'),
	(280427, 121, '2014-04-01 01:10:49.000000', 'temperatura', 490.0000, 'ºC'),
	(280428, 121, '2014-04-01 01:10:50.000000', 'temperatura', 718.0000, 'ºC'),
	(280429, 121, '2014-04-01 01:10:51.000000', 'temperatura', 924.0000, 'ºC'),
	(280430, 121, '2014-04-01 01:10:52.000000', 'temperatura', 65.0000, 'ºC'),
	(280431, 121, '2014-04-01 01:10:53.000000', 'temperatura', 1153.0000, 'ºC'),
	(280432, 121, '2014-04-01 01:10:54.000000', 'temperatura', 770.0000, 'ºC'),
	(280433, 121, '2014-04-01 01:10:55.000000', 'temperatura', 392.0000, 'ºC'),
	(280434, 121, '2014-04-01 01:10:56.000000', 'temperatura', 850.0000, 'ºC'),
	(280435, 121, '2014-04-01 01:10:57.000000', 'temperatura', 676.0000, 'ºC'),
	(280436, 121, '2014-04-01 01:10:58.000000', 'temperatura', 828.0000, 'ºC'),
	(280437, 121, '2014-04-01 01:10:59.000000', 'temperatura', 914.0000, 'ºC'),
	(280438, 121, '2014-04-01 01:11:00.000000', 'temperatura', 886.0000, 'ºC'),
	(280439, 121, '2014-04-01 01:11:01.000000', 'temperatura', 488.0000, 'ºC'),
	(280440, 121, '2014-04-01 01:11:02.000000', 'temperatura', 984.0000, 'ºC'),
	(280441, 121, '2014-04-01 01:11:03.000000', 'temperatura', 1056.0000, 'ºC'),
	(280442, 121, '2014-04-01 01:11:04.000000', 'temperatura', 1128.0000, 'ºC'),
	(280443, 121, '2014-04-01 01:11:05.000000', 'temperatura', 75.0000, 'ºC'),
	(280444, 121, '2014-04-01 01:11:06.000000', 'temperatura', 589.0000, 'ºC'),
	(280445, 121, '2014-04-01 01:11:07.000000', 'temperatura', 320.0000, 'ºC'),
	(280446, 121, '2014-04-01 01:11:08.000000', 'temperatura', 1036.0000, 'ºC'),
	(280447, 121, '2014-04-01 01:11:09.000000', 'temperatura', 619.0000, 'ºC'),
	(280448, 121, '2014-04-01 01:11:10.000000', 'temperatura', 1188.0000, 'ºC'),
	(280449, 121, '2014-04-01 01:11:11.000000', 'temperatura', 483.0000, 'ºC'),
	(280450, 121, '2014-04-01 01:11:12.000000', 'temperatura', 51.0000, 'ºC'),
	(280451, 121, '2014-04-01 01:11:13.000000', 'temperatura', 6.0000, 'ºC'),
	(280452, 121, '2014-04-01 01:11:14.000000', 'temperatura', 1077.0000, 'ºC'),
	(280453, 121, '2014-04-01 01:11:15.000000', 'temperatura', 568.0000, 'ºC'),
	(280454, 121, '2014-04-01 01:11:16.000000', 'temperatura', 810.0000, 'ºC'),
	(280455, 121, '2014-04-01 01:11:17.000000', 'temperatura', 1148.0000, 'ºC'),
	(280456, 121, '2014-04-01 01:11:18.000000', 'temperatura', 909.0000, 'ºC'),
	(280457, 121, '2014-04-01 01:11:19.000000', 'temperatura', 1104.0000, 'ºC'),
	(280458, 121, '2014-04-01 01:11:20.000000', 'temperatura', 390.0000, 'ºC'),
	(280459, 121, '2014-04-01 01:11:21.000000', 'temperatura', 1042.0000, 'ºC'),
	(280460, 121, '2014-04-01 01:11:22.000000', 'temperatura', 438.0000, 'ºC'),
	(280461, 121, '2014-04-01 01:11:23.000000', 'temperatura', 267.0000, 'ºC'),
	(280462, 121, '2014-04-01 01:11:24.000000', 'temperatura', 20.0000, 'ºC'),
	(280463, 121, '2014-04-01 01:11:25.000000', 'temperatura', 501.0000, 'ºC'),
	(280464, 121, '2014-04-01 01:11:26.000000', 'temperatura', 43.0000, 'ºC'),
	(280465, 121, '2014-04-01 01:11:27.000000', 'temperatura', 1114.0000, 'ºC'),
	(280466, 121, '2014-04-01 01:11:28.000000', 'temperatura', 642.0000, 'ºC'),
	(280467, 121, '2014-04-01 01:11:29.000000', 'temperatura', 1066.0000, 'ºC'),
	(280468, 121, '2014-04-01 01:11:30.000000', 'temperatura', 1005.0000, 'ºC'),
	(280469, 121, '2014-04-01 01:11:31.000000', 'temperatura', 629.0000, 'ºC'),
	(280470, 121, '2014-04-01 01:11:32.000000', 'temperatura', 129.0000, 'ºC'),
	(280471, 121, '2014-04-01 01:11:33.000000', 'temperatura', 1158.0000, 'ºC'),
	(280472, 121, '2014-04-01 01:11:34.000000', 'temperatura', 606.0000, 'ºC'),
	(280473, 121, '2014-04-01 01:11:35.000000', 'temperatura', 756.0000, 'ºC'),
	(280474, 121, '2014-04-01 01:11:36.000000', 'temperatura', 761.0000, 'ºC'),
	(280475, 121, '2014-04-01 01:11:37.000000', 'temperatura', 338.0000, 'ºC'),
	(280476, 121, '2014-04-01 01:11:38.000000', 'temperatura', 608.0000, 'ºC'),
	(280477, 121, '2014-04-01 01:11:39.000000', 'temperatura', 827.0000, 'ºC'),
	(280478, 121, '2014-04-01 01:11:40.000000', 'temperatura', 1110.0000, 'ºC'),
	(280479, 121, '2014-04-01 01:11:41.000000', 'temperatura', 669.0000, 'ºC'),
	(280480, 121, '2014-04-01 01:11:42.000000', 'temperatura', 17.0000, 'ºC'),
	(280481, 121, '2014-04-01 01:11:43.000000', 'temperatura', 476.0000, 'ºC'),
	(280482, 121, '2014-04-01 01:11:44.000000', 'temperatura', 1131.0000, 'ºC'),
	(280483, 121, '2014-04-01 01:11:45.000000', 'temperatura', 628.0000, 'ºC'),
	(280484, 121, '2014-04-01 01:11:46.000000', 'temperatura', 946.0000, 'ºC'),
	(280485, 121, '2014-04-01 01:11:47.000000', 'temperatura', 446.0000, 'ºC'),
	(280486, 121, '2014-04-01 01:11:48.000000', 'temperatura', 594.0000, 'ºC'),
	(280487, 121, '2014-04-01 01:11:49.000000', 'temperatura', 433.0000, 'ºC'),
	(280488, 121, '2014-04-01 01:11:50.000000', 'temperatura', 381.0000, 'ºC'),
	(280489, 121, '2014-04-01 01:11:51.000000', 'temperatura', 609.0000, 'ºC'),
	(280490, 121, '2014-04-01 01:11:52.000000', 'temperatura', 701.0000, 'ºC'),
	(280491, 121, '2014-04-01 01:11:53.000000', 'temperatura', 480.0000, 'ºC'),
	(280492, 121, '2014-04-01 01:11:54.000000', 'temperatura', 298.0000, 'ºC'),
	(280493, 121, '2014-04-01 01:11:55.000000', 'temperatura', 48.0000, 'ºC'),
	(280494, 121, '2014-04-01 01:11:56.000000', 'temperatura', 547.0000, 'ºC'),
	(280495, 121, '2014-04-01 01:11:57.000000', 'temperatura', 190.0000, 'ºC'),
	(280496, 121, '2014-04-01 01:11:58.000000', 'temperatura', 512.0000, 'ºC'),
	(280497, 121, '2014-04-01 01:11:59.000000', 'temperatura', 791.0000, 'ºC'),
	(280498, 121, '2014-04-01 01:12:00.000000', 'temperatura', 18.0000, 'ºC'),
	(280499, 121, '2014-04-01 01:12:01.000000', 'temperatura', 118.0000, 'ºC'),
	(280500, 121, '2014-04-01 01:12:02.000000', 'temperatura', 535.0000, 'ºC'),
	(280501, 121, '2014-04-01 01:12:03.000000', 'temperatura', 1121.0000, 'ºC'),
	(280502, 121, '2014-04-01 01:12:04.000000', 'temperatura', 400.0000, 'ºC'),
	(280503, 121, '2014-04-01 01:12:05.000000', 'temperatura', 1038.0000, 'ºC'),
	(280504, 121, '2014-04-01 01:12:06.000000', 'temperatura', 390.0000, 'ºC'),
	(280505, 121, '2014-04-01 01:12:07.000000', 'temperatura', 39.0000, 'ºC'),
	(280506, 121, '2014-04-01 01:12:08.000000', 'temperatura', 222.0000, 'ºC'),
	(280507, 121, '2014-04-01 01:12:09.000000', 'temperatura', 995.0000, 'ºC'),
	(280508, 121, '2014-04-01 01:12:10.000000', 'temperatura', 711.0000, 'ºC'),
	(280509, 121, '2014-04-01 01:12:11.000000', 'temperatura', 567.0000, 'ºC'),
	(280510, 121, '2014-04-01 01:12:12.000000', 'temperatura', 706.0000, 'ºC'),
	(280511, 121, '2014-04-01 01:12:13.000000', 'temperatura', 629.0000, 'ºC'),
	(280512, 121, '2014-04-01 01:12:14.000000', 'temperatura', 1025.0000, 'ºC'),
	(280513, 121, '2014-04-01 01:12:15.000000', 'temperatura', 842.0000, 'ºC'),
	(280514, 121, '2014-04-01 01:12:16.000000', 'temperatura', 1133.0000, 'ºC'),
	(280515, 121, '2014-04-01 01:12:17.000000', 'temperatura', 738.0000, 'ºC'),
	(280516, 121, '2014-04-01 01:12:18.000000', 'temperatura', 294.0000, 'ºC'),
	(280517, 121, '2014-04-01 01:12:19.000000', 'temperatura', 456.0000, 'ºC'),
	(280518, 121, '2014-04-01 01:12:20.000000', 'temperatura', 199.0000, 'ºC'),
	(280519, 121, '2014-04-01 01:12:21.000000', 'temperatura', 826.0000, 'ºC'),
	(280520, 121, '2014-04-01 01:12:22.000000', 'temperatura', 1135.0000, 'ºC'),
	(280521, 121, '2014-04-01 01:12:23.000000', 'temperatura', 796.0000, 'ºC'),
	(280522, 121, '2014-04-01 01:12:24.000000', 'temperatura', 575.0000, 'ºC'),
	(280523, 121, '2014-04-01 01:12:25.000000', 'temperatura', 488.0000, 'ºC'),
	(280524, 121, '2014-04-01 01:12:26.000000', 'temperatura', 717.0000, 'ºC'),
	(280525, 121, '2014-04-01 01:12:27.000000', 'temperatura', 921.0000, 'ºC'),
	(280526, 121, '2014-04-01 01:12:28.000000', 'temperatura', 53.0000, 'ºC'),
	(280527, 121, '2014-04-01 01:12:29.000000', 'temperatura', 1102.0000, 'ºC'),
	(280528, 121, '2014-04-01 01:12:30.000000', 'temperatura', 552.0000, 'ºC'),
	(280529, 121, '2014-04-01 01:12:31.000000', 'temperatura', 656.0000, 'ºC'),
	(280530, 121, '2014-04-01 01:12:32.000000', 'temperatura', 425.0000, 'ºC'),
	(280531, 121, '2014-04-01 01:12:33.000000', 'temperatura', 155.0000, 'ºC'),
	(280532, 121, '2014-04-01 01:12:34.000000', 'temperatura', 700.0000, 'ºC'),
	(280533, 121, '2014-04-01 01:12:35.000000', 'temperatura', 636.0000, 'ºC'),
	(280534, 121, '2014-04-01 01:12:36.000000', 'temperatura', 1080.0000, 'ºC'),
	(280535, 121, '2014-04-01 01:12:37.000000', 'temperatura', 1094.0000, 'ºC'),
	(280536, 121, '2014-04-01 01:12:38.000000', 'temperatura', 1029.0000, 'ºC'),
	(280537, 121, '2014-04-01 01:12:39.000000', 'temperatura', 665.0000, 'ºC'),
	(280538, 121, '2014-04-01 01:12:40.000000', 'temperatura', 239.0000, 'ºC'),
	(280539, 121, '2014-04-01 01:12:41.000000', 'temperatura', 400.0000, 'ºC'),
	(280540, 121, '2014-04-01 01:12:42.000000', 'temperatura', 83.0000, 'ºC'),
	(280541, 121, '2014-04-01 01:12:43.000000', 'temperatura', 417.0000, 'ºC'),
	(280542, 121, '2014-04-01 01:12:44.000000', 'temperatura', 637.0000, 'ºC'),
	(280543, 121, '2014-04-01 01:12:45.000000', 'temperatura', 732.0000, 'ºC'),
	(280544, 121, '2014-04-01 01:12:46.000000', 'temperatura', 550.0000, 'ºC'),
	(280545, 121, '2014-04-01 01:12:47.000000', 'temperatura', 553.0000, 'ºC'),
	(280546, 121, '2014-04-01 01:12:48.000000', 'temperatura', 1119.0000, 'ºC'),
	(280547, 121, '2014-04-01 01:12:49.000000', 'temperatura', 334.0000, 'ºC'),
	(280548, 121, '2014-04-01 01:12:50.000000', 'temperatura', 715.0000, 'ºC'),
	(280549, 121, '2014-04-01 01:12:51.000000', 'temperatura', 173.0000, 'ºC'),
	(280550, 121, '2014-04-01 01:12:52.000000', 'temperatura', 1121.0000, 'ºC'),
	(280551, 121, '2014-04-01 01:12:53.000000', 'temperatura', 288.0000, 'ºC'),
	(280552, 121, '2014-04-01 01:12:54.000000', 'temperatura', 477.0000, 'ºC'),
	(280553, 121, '2014-04-01 01:12:55.000000', 'temperatura', 322.0000, 'ºC'),
	(280554, 121, '2014-04-01 01:12:56.000000', 'temperatura', 177.0000, 'ºC'),
	(280555, 121, '2014-04-01 01:12:57.000000', 'temperatura', 1123.0000, 'ºC'),
	(280556, 121, '2014-04-01 01:12:58.000000', 'temperatura', 281.0000, 'ºC'),
	(280557, 121, '2014-04-01 01:12:59.000000', 'temperatura', 439.0000, 'ºC'),
	(280558, 121, '2014-04-01 01:13:00.000000', 'temperatura', 152.0000, 'ºC'),
	(280559, 121, '2014-04-01 01:13:01.000000', 'temperatura', 645.0000, 'ºC'),
	(280560, 121, '2014-04-01 01:13:02.000000', 'temperatura', 368.0000, 'ºC'),
	(280561, 121, '2014-04-01 01:13:03.000000', 'temperatura', 1106.0000, 'ºC'),
	(280562, 121, '2014-04-01 01:13:04.000000', 'temperatura', 827.0000, 'ºC'),
	(280563, 121, '2014-04-01 01:13:05.000000', 'temperatura', 818.0000, 'ºC'),
	(280564, 121, '2014-04-01 01:13:06.000000', 'temperatura', 410.0000, 'ºC'),
	(280565, 121, '2014-04-01 01:13:07.000000', 'temperatura', 795.0000, 'ºC'),
	(280566, 121, '2014-04-01 01:13:08.000000', 'temperatura', 347.0000, 'ºC'),
	(280567, 121, '2014-04-01 01:13:09.000000', 'temperatura', 551.0000, 'ºC'),
	(280568, 121, '2014-04-01 01:13:10.000000', 'temperatura', 515.0000, 'ºC'),
	(280569, 121, '2014-04-01 01:13:11.000000', 'temperatura', 921.0000, 'ºC'),
	(280570, 121, '2014-04-01 01:13:12.000000', 'temperatura', 660.0000, 'ºC'),
	(280571, 121, '2014-04-01 01:13:13.000000', 'temperatura', 536.0000, 'ºC'),
	(280572, 121, '2014-04-01 01:13:14.000000', 'temperatura', 703.0000, 'ºC'),
	(280573, 121, '2014-04-01 01:13:15.000000', 'temperatura', 706.0000, 'ºC'),
	(280574, 121, '2014-04-01 01:13:16.000000', 'temperatura', 223.0000, 'ºC'),
	(280575, 121, '2014-04-01 01:13:17.000000', 'temperatura', 198.0000, 'ºC'),
	(280576, 121, '2014-04-01 01:13:18.000000', 'temperatura', 322.0000, 'ºC'),
	(280577, 121, '2014-04-01 01:13:19.000000', 'temperatura', 1018.0000, 'ºC'),
	(280578, 121, '2014-04-01 01:13:20.000000', 'temperatura', 521.0000, 'ºC'),
	(280579, 121, '2014-04-01 01:13:21.000000', 'temperatura', 753.0000, 'ºC'),
	(280580, 121, '2014-04-01 01:13:22.000000', 'temperatura', 1004.0000, 'ºC'),
	(280581, 121, '2014-04-01 01:13:23.000000', 'temperatura', 359.0000, 'ºC'),
	(280582, 121, '2014-04-01 01:13:24.000000', 'temperatura', 1184.0000, 'ºC'),
	(280583, 121, '2014-04-01 01:13:25.000000', 'temperatura', 44.0000, 'ºC'),
	(280584, 121, '2014-04-01 01:13:26.000000', 'temperatura', 270.0000, 'ºC'),
	(280585, 121, '2014-04-01 01:13:27.000000', 'temperatura', 18.0000, 'ºC'),
	(280586, 121, '2014-04-01 01:13:28.000000', 'temperatura', 478.0000, 'ºC'),
	(280587, 121, '2014-04-01 01:13:29.000000', 'temperatura', 1138.0000, 'ºC'),
	(280588, 121, '2014-04-01 01:13:30.000000', 'temperatura', 655.0000, 'ºC'),
	(280589, 121, '2014-04-01 01:13:31.000000', 'temperatura', 1064.0000, 'ºC'),
	(280590, 121, '2014-04-01 01:13:32.000000', 'temperatura', 954.0000, 'ºC'),
	(280591, 121, '2014-04-01 01:13:33.000000', 'temperatura', 379.0000, 'ºC'),
	(280592, 121, '2014-04-01 01:13:34.000000', 'temperatura', 235.0000, 'ºC'),
	(280593, 121, '2014-04-01 01:13:35.000000', 'temperatura', 39.0000, 'ºC'),
	(280594, 121, '2014-04-01 01:13:36.000000', 'temperatura', 690.0000, 'ºC'),
	(280595, 121, '2014-04-01 01:13:37.000000', 'temperatura', 935.0000, 'ºC'),
	(280596, 121, '2014-04-01 01:13:38.000000', 'temperatura', 205.0000, 'ºC'),
	(280597, 121, '2014-04-01 01:13:39.000000', 'temperatura', 618.0000, 'ºC'),
	(280598, 121, '2014-04-01 01:13:40.000000', 'temperatura', 77.0000, 'ºC'),
	(280599, 121, '2014-04-01 01:13:41.000000', 'temperatura', 933.0000, 'ºC'),
	(280600, 121, '2014-04-01 01:13:42.000000', 'temperatura', 831.0000, 'ºC'),
	(280601, 121, '2014-04-01 01:13:43.000000', 'temperatura', 160.0000, 'ºC'),
	(280602, 121, '2014-04-01 01:13:44.000000', 'temperatura', 707.0000, 'ºC'),
	(280603, 121, '2014-04-01 01:13:45.000000', 'temperatura', 654.0000, 'ºC'),
	(280604, 121, '2014-04-01 01:13:46.000000', 'temperatura', 1149.0000, 'ºC'),
	(280605, 121, '2014-04-01 01:13:47.000000', 'temperatura', 186.0000, 'ºC'),
	(280606, 121, '2014-04-01 01:13:48.000000', 'temperatura', 1080.0000, 'ºC'),
	(280607, 121, '2014-04-01 01:13:49.000000', 'temperatura', 45.0000, 'ºC'),
	(280608, 121, '2014-04-01 01:13:50.000000', 'temperatura', 585.0000, 'ºC'),
	(280609, 121, '2014-04-01 01:13:51.000000', 'temperatura', 391.0000, 'ºC'),
	(280610, 121, '2014-04-01 01:13:52.000000', 'temperatura', 199.0000, 'ºC'),
	(280611, 121, '2014-04-01 01:13:53.000000', 'temperatura', 1022.0000, 'ºC'),
	(280612, 121, '2014-04-01 01:13:54.000000', 'temperatura', 914.0000, 'ºC'),
	(280613, 121, '2014-04-01 01:13:55.000000', 'temperatura', 307.0000, 'ºC'),
	(280614, 121, '2014-04-01 01:13:56.000000', 'temperatura', 1190.0000, 'ºC'),
	(280615, 121, '2014-04-01 01:13:57.000000', 'temperatura', 230.0000, 'ºC'),
	(280616, 121, '2014-04-01 01:13:58.000000', 'temperatura', 1181.0000, 'ºC'),
	(280617, 121, '2014-04-01 01:13:59.000000', 'temperatura', 416.0000, 'ºC'),
	(280618, 121, '2014-04-01 01:14:00.000000', 'temperatura', 936.0000, 'ºC'),
	(280619, 121, '2014-04-01 01:14:01.000000', 'temperatura', 1034.0000, 'ºC'),
	(280620, 121, '2014-04-01 01:14:02.000000', 'temperatura', 1163.0000, 'ºC'),
	(280621, 121, '2014-04-01 01:14:03.000000', 'temperatura', 314.0000, 'ºC'),
	(280622, 121, '2014-04-01 01:14:04.000000', 'temperatura', 479.0000, 'ºC'),
	(280623, 121, '2014-04-01 01:14:05.000000', 'temperatura', 254.0000, 'ºC'),
	(280624, 121, '2014-04-01 01:14:06.000000', 'temperatura', 1035.0000, 'ºC'),
	(280625, 121, '2014-04-01 01:14:07.000000', 'temperatura', 812.0000, 'ºC'),
	(280626, 121, '2014-04-01 01:14:08.000000', 'temperatura', 956.0000, 'ºC'),
	(280627, 121, '2014-04-01 01:14:09.000000', 'temperatura', 1144.0000, 'ºC'),
	(280628, 121, '2014-04-01 01:14:10.000000', 'temperatura', 451.0000, 'ºC'),
	(280629, 121, '2014-04-01 01:14:11.000000', 'temperatura', 24.0000, 'ºC'),
	(280630, 121, '2014-04-01 01:14:12.000000', 'temperatura', 1168.0000, 'ºC'),
	(280631, 121, '2014-04-01 01:14:13.000000', 'temperatura', 969.0000, 'ºC'),
	(280632, 121, '2014-04-01 01:14:14.000000', 'temperatura', 143.0000, 'ºC'),
	(280633, 121, '2014-04-01 01:14:15.000000', 'temperatura', 208.0000, 'ºC'),
	(280634, 121, '2014-04-01 01:14:16.000000', 'temperatura', 612.0000, 'ºC'),
	(280635, 121, '2014-04-01 01:14:17.000000', 'temperatura', 35.0000, 'ºC'),
	(280636, 121, '2014-04-01 01:14:18.000000', 'temperatura', 741.0000, 'ºC'),
	(280637, 121, '2014-04-01 01:14:19.000000', 'temperatura', 0.0000, 'ºC'),
	(280638, 121, '2014-04-01 01:14:20.000000', 'temperatura', 178.0000, 'ºC'),
	(280639, 121, '2014-04-01 01:14:21.000000', 'temperatura', 889.0000, 'ºC'),
	(280640, 121, '2014-04-01 01:14:22.000000', 'temperatura', 312.0000, 'ºC'),
	(280641, 121, '2014-04-01 01:14:23.000000', 'temperatura', 95.0000, 'ºC'),
	(280642, 121, '2014-04-01 01:14:24.000000', 'temperatura', 739.0000, 'ºC'),
	(280643, 121, '2014-04-01 01:14:25.000000', 'temperatura', 1011.0000, 'ºC'),
	(280644, 121, '2014-04-01 01:14:26.000000', 'temperatura', 439.0000, 'ºC'),
	(280645, 121, '2014-04-01 01:14:27.000000', 'temperatura', 361.0000, 'ºC'),
	(280646, 121, '2014-04-01 01:14:28.000000', 'temperatura', 488.0000, 'ºC'),
	(280647, 121, '2014-04-01 01:14:29.000000', 'temperatura', 160.0000, 'ºC'),
	(280648, 121, '2014-04-01 01:14:30.000000', 'temperatura', 535.0000, 'ºC'),
	(280649, 121, '2014-04-01 01:14:31.000000', 'temperatura', 996.0000, 'ºC'),
	(280650, 121, '2014-04-01 01:14:32.000000', 'temperatura', 977.0000, 'ºC'),
	(280651, 121, '2014-04-01 01:14:33.000000', 'temperatura', 695.0000, 'ºC'),
	(280652, 121, '2014-04-01 01:14:34.000000', 'temperatura', 546.0000, 'ºC'),
	(280653, 121, '2014-04-01 01:14:35.000000', 'temperatura', 647.0000, 'ºC'),
	(280654, 121, '2014-04-01 01:14:36.000000', 'temperatura', 396.0000, 'ºC'),
	(280655, 121, '2014-04-01 01:14:37.000000', 'temperatura', 40.0000, 'ºC'),
	(280656, 121, '2014-04-01 01:14:38.000000', 'temperatura', 212.0000, 'ºC'),
	(280657, 121, '2014-04-01 01:14:39.000000', 'temperatura', 942.0000, 'ºC'),
	(280658, 121, '2014-04-01 01:14:40.000000', 'temperatura', 475.0000, 'ºC'),
	(280659, 121, '2014-04-01 01:14:41.000000', 'temperatura', 750.0000, 'ºC'),
	(280660, 121, '2014-04-01 01:14:42.000000', 'temperatura', 1124.0000, 'ºC'),
	(280661, 121, '2014-04-01 01:14:43.000000', 'temperatura', 971.0000, 'ºC'),
	(280662, 121, '2014-04-01 01:14:44.000000', 'temperatura', 286.0000, 'ºC'),
	(280663, 121, '2014-04-01 01:14:45.000000', 'temperatura', 914.0000, 'ºC'),
	(280664, 121, '2014-04-01 01:14:46.000000', 'temperatura', 112.0000, 'ºC'),
	(280665, 121, '2014-04-01 01:14:47.000000', 'temperatura', 219.0000, 'ºC'),
	(280666, 121, '2014-04-01 01:14:48.000000', 'temperatura', 761.0000, 'ºC'),
	(280667, 121, '2014-04-01 01:14:49.000000', 'temperatura', 749.0000, 'ºC'),
	(280668, 121, '2014-04-01 01:14:50.000000', 'temperatura', 261.0000, 'ºC'),
	(280669, 121, '2014-04-01 01:14:51.000000', 'temperatura', 260.0000, 'ºC'),
	(280670, 121, '2014-04-01 01:14:52.000000', 'temperatura', 518.0000, 'ºC'),
	(280671, 121, '2014-04-01 01:14:53.000000', 'temperatura', 610.0000, 'ºC'),
	(280672, 121, '2014-04-01 01:14:54.000000', 'temperatura', 295.0000, 'ºC'),
	(280673, 121, '2014-04-01 01:14:55.000000', 'temperatura', 848.0000, 'ºC'),
	(280674, 121, '2014-04-01 01:14:56.000000', 'temperatura', 954.0000, 'ºC'),
	(280675, 121, '2014-04-01 01:14:57.000000', 'temperatura', 1026.0000, 'ºC'),
	(280676, 121, '2014-04-01 01:14:58.000000', 'temperatura', 1069.0000, 'ºC'),
	(280677, 121, '2014-04-01 01:14:59.000000', 'temperatura', 1066.0000, 'ºC'),
	(280678, 121, '2014-04-01 01:15:00.000000', 'temperatura', 925.0000, 'ºC'),
	(280679, 121, '2014-04-01 01:15:01.000000', 'temperatura', 228.0000, 'ºC'),
	(280680, 121, '2014-04-01 01:15:02.000000', 'temperatura', 764.0000, 'ºC'),
	(280681, 121, '2014-04-01 01:15:03.000000', 'temperatura', 735.0000, 'ºC'),
	(280682, 121, '2014-04-01 01:15:04.000000', 'temperatura', 186.0000, 'ºC'),
	(280683, 121, '2014-04-01 01:15:05.000000', 'temperatura', 1124.0000, 'ºC'),
	(280684, 121, '2014-04-01 01:15:06.000000', 'temperatura', 262.0000, 'ºC'),
	(280685, 121, '2014-04-01 01:15:07.000000', 'temperatura', 338.0000, 'ºC'),
	(280686, 121, '2014-04-01 01:15:08.000000', 'temperatura', 906.0000, 'ºC'),
	(280687, 121, '2014-04-01 01:15:09.000000', 'temperatura', 1117.0000, 'ºC'),
	(280688, 121, '2014-04-01 01:15:10.000000', 'temperatura', 468.0000, 'ºC'),
	(280689, 121, '2014-04-01 01:15:11.000000', 'temperatura', 189.0000, 'ºC'),
	(280690, 121, '2014-04-01 01:15:12.000000', 'temperatura', 742.0000, 'ºC'),
	(280691, 121, '2014-04-01 01:15:13.000000', 'temperatura', 742.0000, 'ºC'),
	(280692, 121, '2014-04-01 01:15:14.000000', 'temperatura', 286.0000, 'ºC'),
	(280693, 121, '2014-04-01 01:15:15.000000', 'temperatura', 406.0000, 'ºC'),
	(280694, 121, '2014-04-01 01:15:16.000000', 'temperatura', 1171.0000, 'ºC'),
	(280695, 121, '2014-04-01 01:15:17.000000', 'temperatura', 1038.0000, 'ºC'),
	(280696, 121, '2014-04-01 01:15:18.000000', 'temperatura', 479.0000, 'ºC'),
	(280697, 121, '2014-04-01 01:15:19.000000', 'temperatura', 481.0000, 'ºC'),
	(280698, 121, '2014-04-01 01:15:20.000000', 'temperatura', 970.0000, 'ºC'),
	(280699, 121, '2014-04-01 01:15:21.000000', 'temperatura', 1006.0000, 'ºC'),
	(280700, 121, '2014-04-01 01:15:22.000000', 'temperatura', 922.0000, 'ºC'),
	(280701, 121, '2014-04-01 01:15:23.000000', 'temperatura', 390.0000, 'ºC'),
	(280702, 121, '2014-04-01 01:15:24.000000', 'temperatura', 383.0000, 'ºC'),
	(280703, 121, '2014-04-01 01:15:25.000000', 'temperatura', 749.0000, 'ºC'),
	(280704, 121, '2014-04-01 01:15:26.000000', 'temperatura', 195.0000, 'ºC'),
	(280705, 121, '2014-04-01 01:15:27.000000', 'temperatura', 1130.0000, 'ºC'),
	(280706, 121, '2014-04-01 01:15:28.000000', 'temperatura', 264.0000, 'ºC'),
	(280707, 121, '2014-04-01 01:15:29.000000', 'temperatura', 330.0000, 'ºC'),
	(280708, 121, '2014-04-01 01:15:30.000000', 'temperatura', 858.0000, 'ºC'),
	(280709, 121, '2014-04-01 01:15:31.000000', 'temperatura', 900.0000, 'ºC'),
	(280710, 121, '2014-04-01 01:15:32.000000', 'temperatura', 726.0000, 'ºC'),
	(280711, 121, '2014-04-01 01:15:33.000000', 'temperatura', 932.0000, 'ºC'),
	(280712, 121, '2014-04-01 01:15:34.000000', 'temperatura', 81.0000, 'ºC'),
	(280713, 121, '2014-04-01 01:15:35.000000', 'temperatura', 12.0000, 'ºC'),
	(280714, 121, '2014-04-01 01:15:36.000000', 'temperatura', 1016.0000, 'ºC'),
	(280715, 121, '2014-04-01 01:15:37.000000', 'temperatura', 246.0000, 'ºC'),
	(280716, 121, '2014-04-01 01:15:38.000000', 'temperatura', 582.0000, 'ºC'),
	(280717, 121, '2014-04-01 01:15:39.000000', 'temperatura', 971.0000, 'ºC'),
	(280718, 121, '2014-04-01 01:15:40.000000', 'temperatura', 712.0000, 'ºC'),
	(280719, 121, '2014-04-01 01:15:41.000000', 'temperatura', 648.0000, 'ºC'),
	(280720, 121, '2014-04-01 01:15:42.000000', 'temperatura', 1102.0000, 'ºC'),
	(280721, 121, '2014-04-01 01:15:43.000000', 'temperatura', 1166.0000, 'ºC'),
	(280722, 121, '2014-04-01 01:15:44.000000', 'temperatura', 126.0000, 'ºC'),
	(280723, 121, '2014-04-01 01:15:45.000000', 'temperatura', 734.0000, 'ºC'),
	(280724, 121, '2014-04-01 01:15:46.000000', 'temperatura', 891.0000, 'ºC'),
	(280725, 121, '2014-04-01 01:15:47.000000', 'temperatura', 1052.0000, 'ºC'),
	(280726, 121, '2014-04-01 01:15:48.000000', 'temperatura', 189.0000, 'ºC'),
	(280727, 121, '2014-04-01 01:15:49.000000', 'temperatura', 187.0000, 'ºC'),
	(280728, 121, '2014-04-01 01:15:50.000000', 'temperatura', 371.0000, 'ºC'),
	(280729, 121, '2014-04-01 01:15:51.000000', 'temperatura', 92.0000, 'ºC'),
	(280730, 121, '2014-04-01 01:15:52.000000', 'temperatura', 550.0000, 'ºC'),
	(280731, 121, '2014-04-01 01:15:53.000000', 'temperatura', 74.0000, 'ºC'),
	(280732, 121, '2014-04-01 01:15:54.000000', 'temperatura', 1118.0000, 'ºC'),
	(280733, 121, '2014-04-01 01:15:55.000000', 'temperatura', 571.0000, 'ºC'),
	(280734, 121, '2014-04-01 01:15:56.000000', 'temperatura', 702.0000, 'ºC'),
	(280735, 121, '2014-04-01 01:15:57.000000', 'temperatura', 595.0000, 'ºC'),
	(280736, 121, '2014-04-01 01:15:58.000000', 'temperatura', 872.0000, 'ºC'),
	(280737, 121, '2014-04-01 01:15:59.000000', 'temperatura', 174.0000, 'ºC'),
	(280738, 121, '2014-04-01 01:16:00.000000', 'temperatura', 655.0000, 'ºC'),
	(280739, 121, '2014-04-01 01:16:01.000000', 'temperatura', 353.0000, 'ºC'),
	(280740, 121, '2014-04-01 01:16:02.000000', 'temperatura', 1001.0000, 'ºC'),
	(280741, 121, '2014-04-01 01:16:03.000000', 'temperatura', 345.0000, 'ºC'),
	(280742, 121, '2014-04-01 01:16:04.000000', 'temperatura', 1125.0000, 'ºC'),
	(280743, 121, '2014-04-01 01:16:05.000000', 'temperatura', 988.0000, 'ºC'),
	(280744, 121, '2014-04-01 01:16:06.000000', 'temperatura', 367.0000, 'ºC'),
	(280745, 121, '2014-04-01 01:16:07.000000', 'temperatura', 72.0000, 'ºC'),
	(280746, 121, '2014-04-01 01:16:08.000000', 'temperatura', 459.0000, 'ºC'),
	(280747, 121, '2014-04-01 01:16:09.000000', 'temperatura', 879.0000, 'ºC'),
	(280748, 121, '2014-04-01 01:16:10.000000', 'temperatura', 619.0000, 'ºC'),
	(280749, 121, '2014-04-01 01:16:11.000000', 'temperatura', 458.0000, 'ºC'),
	(280750, 121, '2014-04-01 01:16:12.000000', 'temperatura', 434.0000, 'ºC'),
	(280751, 121, '2014-04-01 01:16:13.000000', 'temperatura', 797.0000, 'ºC'),
	(280752, 121, '2014-04-01 01:16:14.000000', 'temperatura', 284.0000, 'ºC'),
	(280753, 121, '2014-04-01 01:16:15.000000', 'temperatura', 230.0000, 'ºC'),
	(280754, 121, '2014-04-01 01:16:16.000000', 'temperatura', 297.0000, 'ºC'),
	(280755, 121, '2014-04-01 01:16:17.000000', 'temperatura', 796.0000, 'ºC'),
	(280756, 121, '2014-04-01 01:16:18.000000', 'temperatura', 690.0000, 'ºC'),
	(280757, 121, '2014-04-01 01:16:19.000000', 'temperatura', 1064.0000, 'ºC'),
	(280758, 121, '2014-04-01 01:16:20.000000', 'temperatura', 847.0000, 'ºC'),
	(280759, 121, '2014-04-01 01:16:21.000000', 'temperatura', 1046.0000, 'ºC'),
	(280760, 121, '2014-04-01 01:16:22.000000', 'temperatura', 288.0000, 'ºC'),
	(280761, 121, '2014-04-01 01:16:23.000000', 'temperatura', 705.0000, 'ºC'),
	(280762, 121, '2014-04-01 01:16:24.000000', 'temperatura', 259.0000, 'ºC'),
	(280763, 121, '2014-04-01 01:16:25.000000', 'temperatura', 380.0000, 'ºC'),
	(280764, 121, '2014-04-01 01:16:26.000000', 'temperatura', 1124.0000, 'ºC'),
	(280765, 121, '2014-04-01 01:16:27.000000', 'temperatura', 879.0000, 'ºC'),
	(280766, 121, '2014-04-01 01:16:28.000000', 'temperatura', 1025.0000, 'ºC'),
	(280767, 121, '2014-04-01 01:16:29.000000', 'temperatura', 87.0000, 'ºC'),
	(280768, 121, '2014-04-01 01:16:30.000000', 'temperatura', 960.0000, 'ºC'),
	(280769, 121, '2014-04-01 01:16:31.000000', 'temperatura', 941.0000, 'ºC'),
	(280770, 121, '2014-04-01 01:16:32.000000', 'temperatura', 626.0000, 'ºC'),
	(280771, 121, '2014-04-01 01:16:33.000000', 'temperatura', 305.0000, 'ºC'),
	(280772, 121, '2014-04-01 01:16:34.000000', 'temperatura', 848.0000, 'ºC'),
	(280773, 121, '2014-04-01 01:16:35.000000', 'temperatura', 927.0000, 'ºC'),
	(280774, 121, '2014-04-01 01:16:36.000000', 'temperatura', 889.0000, 'ºC'),
	(280775, 121, '2014-04-01 01:16:37.000000', 'temperatura', 466.0000, 'ºC'),
	(280776, 121, '2014-04-01 01:16:38.000000', 'temperatura', 865.0000, 'ºC'),
	(280777, 121, '2014-04-01 01:16:39.000000', 'temperatura', 527.0000, 'ºC'),
	(280778, 121, '2014-04-01 01:16:40.000000', 'temperatura', 40.0000, 'ºC'),
	(280779, 121, '2014-04-01 01:16:41.000000', 'temperatura', 1021.0000, 'ºC'),
	(280780, 121, '2014-04-01 01:16:42.000000', 'temperatura', 185.0000, 'ºC'),
	(280781, 121, '2014-04-01 01:16:43.000000', 'temperatura', 262.0000, 'ºC'),
	(280782, 121, '2014-04-01 01:16:44.000000', 'temperatura', 757.0000, 'ºC'),
	(280783, 121, '2014-04-01 01:16:45.000000', 'temperatura', 600.0000, 'ºC'),
	(280784, 121, '2014-04-01 01:16:46.000000', 'temperatura', 727.0000, 'ºC'),
	(280785, 121, '2014-04-01 01:16:47.000000', 'temperatura', 636.0000, 'ºC'),
	(280786, 121, '2014-04-01 01:16:48.000000', 'temperatura', 1001.0000, 'ºC'),
	(280787, 121, '2014-04-01 01:16:49.000000', 'temperatura', 695.0000, 'ºC'),
	(280788, 121, '2014-04-01 01:16:50.000000', 'temperatura', 474.0000, 'ºC'),
	(280789, 121, '2014-04-01 01:16:51.000000', 'temperatura', 285.0000, 'ºC'),
	(280790, 121, '2014-04-01 01:16:52.000000', 'temperatura', 3.0000, 'ºC'),
	(280791, 121, '2014-04-01 01:16:53.000000', 'temperatura', 360.0000, 'ºC'),
	(280792, 121, '2014-04-01 01:16:54.000000', 'temperatura', 592.0000, 'ºC'),
	(280793, 121, '2014-04-01 01:16:55.000000', 'temperatura', 679.0000, 'ºC'),
	(280794, 121, '2014-04-01 01:16:56.000000', 'temperatura', 420.0000, 'ºC'),
	(280795, 121, '2014-04-01 01:16:57.000000', 'temperatura', 66.0000, 'ºC'),
	(280796, 121, '2014-04-01 01:16:58.000000', 'temperatura', 268.0000, 'ºC'),
	(280797, 121, '2014-04-01 01:16:59.000000', 'temperatura', 1143.0000, 'ºC'),
	(280798, 121, '2014-04-01 01:17:00.000000', 'temperatura', 112.0000, 'ºC'),
	(280799, 121, '2014-04-01 01:17:01.000000', 'temperatura', 729.0000, 'ºC'),
	(280800, 121, '2014-04-01 01:17:02.000000', 'temperatura', 913.0000, 'ºC'),
	(280801, 121, '2014-04-01 01:17:03.000000', 'temperatura', 1177.0000, 'ºC'),
	(280802, 121, '2014-04-01 01:17:04.000000', 'temperatura', 746.0000, 'ºC'),
	(280803, 121, '2014-04-01 01:17:05.000000', 'temperatura', 201.0000, 'ºC'),
	(280804, 121, '2014-04-01 01:17:06.000000', 'temperatura', 1169.0000, 'ºC'),
	(280805, 121, '2014-04-01 01:17:07.000000', 'temperatura', 440.0000, 'ºC'),
	(280806, 121, '2014-04-01 01:17:08.000000', 'temperatura', 1094.0000, 'ºC'),
	(280807, 121, '2014-04-01 01:17:09.000000', 'temperatura', 549.0000, 'ºC'),
	(280808, 121, '2014-04-01 01:17:10.000000', 'temperatura', 665.0000, 'ºC'),
	(280809, 121, '2014-04-01 01:17:11.000000', 'temperatura', 478.0000, 'ºC'),
	(280810, 121, '2014-04-01 01:17:12.000000', 'temperatura', 394.0000, 'ºC'),
	(280811, 121, '2014-04-01 01:17:13.000000', 'temperatura', 539.0000, 'ºC'),
	(280812, 121, '2014-04-01 01:17:14.000000', 'temperatura', 311.0000, 'ºC'),
	(280813, 121, '2014-04-01 01:17:15.000000', 'temperatura', 1141.0000, 'ºC'),
	(280814, 121, '2014-04-01 01:17:16.000000', 'temperatura', 1173.0000, 'ºC'),
	(280815, 121, '2014-04-01 01:17:17.000000', 'temperatura', 43.0000, 'ºC'),
	(280816, 121, '2014-04-01 01:17:18.000000', 'temperatura', 297.0000, 'ºC'),
	(280817, 121, '2014-04-01 01:17:19.000000', 'temperatura', 155.0000, 'ºC'),
	(280818, 121, '2014-04-01 01:17:20.000000', 'temperatura', 1085.0000, 'ºC'),
	(280819, 121, '2014-04-01 01:17:21.000000', 'temperatura', 161.0000, 'ºC'),
	(280820, 121, '2014-04-01 01:17:22.000000', 'temperatura', 1149.0000, 'ºC'),
	(280821, 121, '2014-04-01 01:17:23.000000', 'temperatura', 463.0000, 'ºC'),
	(280822, 121, '2014-04-01 01:17:24.000000', 'temperatura', 69.0000, 'ºC'),
	(280823, 121, '2014-04-01 01:17:25.000000', 'temperatura', 158.0000, 'ºC'),
	(280824, 121, '2014-04-01 01:17:26.000000', 'temperatura', 584.0000, 'ºC'),
	(280825, 121, '2014-04-01 01:17:27.000000', 'temperatura', 45.0000, 'ºC'),
	(280826, 121, '2014-04-01 01:17:28.000000', 'temperatura', 874.0000, 'ºC'),
	(280827, 121, '2014-04-01 01:17:29.000000', 'temperatura', 635.0000, 'ºC'),
	(280828, 121, '2014-04-01 01:17:30.000000', 'temperatura', 555.0000, 'ºC'),
	(280829, 121, '2014-04-01 01:17:31.000000', 'temperatura', 871.0000, 'ºC'),
	(280830, 121, '2014-04-01 01:17:32.000000', 'temperatura', 289.0000, 'ºC'),
	(280831, 121, '2014-04-01 01:17:33.000000', 'temperatura', 34.0000, 'ºC'),
	(280832, 121, '2014-04-01 01:17:34.000000', 'temperatura', 504.0000, 'ºC'),
	(280833, 121, '2014-04-01 01:17:35.000000', 'temperatura', 16.0000, 'ºC'),
	(280834, 121, '2014-04-01 01:17:36.000000', 'temperatura', 970.0000, 'ºC'),
	(280835, 121, '2014-04-01 01:17:37.000000', 'temperatura', 1.0000, 'ºC'),
	(280836, 121, '2014-04-01 01:17:38.000000', 'temperatura', 697.0000, 'ºC'),
	(280837, 121, '2014-04-01 01:17:39.000000', 'temperatura', 1081.0000, 'ºC'),
	(280838, 121, '2014-04-01 01:17:40.000000', 'temperatura', 914.0000, 'ºC'),
	(280839, 121, '2014-04-01 01:17:41.000000', 'temperatura', 130.0000, 'ºC'),
	(280840, 121, '2014-04-01 01:17:42.000000', 'temperatura', 308.0000, 'ºC'),
	(280841, 121, '2014-04-01 01:17:43.000000', 'temperatura', 1150.0000, 'ºC'),
	(280842, 121, '2014-04-01 01:17:44.000000', 'temperatura', 25.0000, 'ºC'),
	(280843, 121, '2014-04-01 01:17:45.000000', 'temperatura', 275.0000, 'ºC'),
	(280844, 121, '2014-04-01 01:17:46.000000', 'temperatura', 101.0000, 'ºC'),
	(280845, 121, '2014-04-01 01:17:47.000000', 'temperatura', 882.0000, 'ºC'),
	(280846, 121, '2014-04-01 01:17:48.000000', 'temperatura', 507.0000, 'ºC'),
	(280847, 121, '2014-04-01 01:17:49.000000', 'temperatura', 1088.0000, 'ºC'),
	(280848, 121, '2014-04-01 01:17:50.000000', 'temperatura', 318.0000, 'ºC'),
	(280849, 121, '2014-04-01 01:17:51.000000', 'temperatura', 730.0000, 'ºC'),
	(280850, 121, '2014-04-01 01:17:52.000000', 'temperatura', 294.0000, 'ºC'),
	(280851, 121, '2014-04-01 01:17:53.000000', 'temperatura', 480.0000, 'ºC'),
	(280852, 121, '2014-04-01 01:17:54.000000', 'temperatura', 320.0000, 'ºC'),
	(280853, 121, '2014-04-01 01:17:55.000000', 'temperatura', 159.0000, 'ºC'),
	(280854, 121, '2014-04-01 01:17:56.000000', 'temperatura', 1034.0000, 'ºC'),
	(280855, 121, '2014-04-01 01:17:57.000000', 'temperatura', 1096.0000, 'ºC'),
	(280856, 121, '2014-04-01 01:17:58.000000', 'temperatura', 1177.0000, 'ºC'),
	(280857, 121, '2014-04-01 01:17:59.000000', 'temperatura', 198.0000, 'ºC'),
	(280858, 121, '2014-04-01 01:18:00.000000', 'temperatura', 1059.0000, 'ºC'),
	(280859, 121, '2014-04-01 01:18:01.000000', 'temperatura', 1101.0000, 'ºC'),
	(280860, 121, '2014-04-01 01:18:02.000000', 'temperatura', 1130.0000, 'ºC'),
	(280861, 121, '2014-04-01 01:18:03.000000', 'temperatura', 1146.0000, 'ºC'),
	(280862, 121, '2014-04-01 01:18:04.000000', 'temperatura', 1141.0000, 'ºC'),
	(280863, 121, '2014-04-01 01:18:05.000000', 'temperatura', 1069.0000, 'ºC'),
	(280864, 121, '2014-04-01 01:18:06.000000', 'temperatura', 720.0000, 'ºC'),
	(280865, 121, '2014-04-01 01:18:07.000000', 'temperatura', 394.0000, 'ºC'),
	(280866, 121, '2014-04-01 01:18:08.000000', 'temperatura', 1013.0000, 'ºC'),
	(280867, 121, '2014-04-01 01:18:09.000000', 'temperatura', 280.0000, 'ºC'),
	(280868, 121, '2014-04-01 01:18:10.000000', 'temperatura', 764.0000, 'ºC'),
	(280869, 121, '2014-04-01 01:18:11.000000', 'temperatura', 580.0000, 'ºC'),
	(280870, 121, '2014-04-01 01:18:12.000000', 'temperatura', 609.0000, 'ºC'),
	(280871, 121, '2014-04-01 01:18:13.000000', 'temperatura', 104.0000, 'ºC'),
	(280872, 121, '2014-04-01 01:18:14.000000', 'temperatura', 1095.0000, 'ºC'),
	(280873, 121, '2014-04-01 01:18:15.000000', 'temperatura', 363.0000, 'ºC'),
	(280874, 121, '2014-04-01 01:18:16.000000', 'temperatura', 933.0000, 'ºC'),
	(280875, 121, '2014-04-01 01:18:17.000000', 'temperatura', 1173.0000, 'ºC'),
	(280876, 121, '2014-04-01 01:18:18.000000', 'temperatura', 667.0000, 'ºC'),
	(280877, 121, '2014-04-01 01:18:19.000000', 'temperatura', 1015.0000, 'ºC'),
	(280878, 121, '2014-04-01 01:18:20.000000', 'temperatura', 678.0000, 'ºC'),
	(280879, 121, '2014-04-01 01:18:21.000000', 'temperatura', 343.0000, 'ºC'),
	(280880, 121, '2014-04-01 01:18:22.000000', 'temperatura', 883.0000, 'ºC'),
	(280881, 121, '2014-04-01 01:18:23.000000', 'temperatura', 985.0000, 'ºC'),
	(280882, 121, '2014-04-01 01:18:24.000000', 'temperatura', 1079.0000, 'ºC'),
	(280883, 121, '2014-04-01 01:18:25.000000', 'temperatura', 38.0000, 'ºC'),
	(280884, 121, '2014-04-01 01:18:26.000000', 'temperatura', 553.0000, 'ºC'),
	(280885, 121, '2014-04-01 01:18:27.000000', 'temperatura', 254.0000, 'ºC'),
	(280886, 121, '2014-04-01 01:18:28.000000', 'temperatura', 811.0000, 'ºC'),
	(280887, 121, '2014-04-01 01:18:29.000000', 'temperatura', 893.0000, 'ºC'),
	(280888, 121, '2014-04-01 01:18:30.000000', 'temperatura', 831.0000, 'ºC'),
	(280889, 121, '2014-04-01 01:18:31.000000', 'temperatura', 276.0000, 'ºC'),
	(280890, 121, '2014-04-01 01:18:32.000000', 'temperatura', 87.0000, 'ºC'),
	(280891, 121, '2014-04-01 01:18:33.000000', 'temperatura', 807.0000, 'ºC'),
	(280892, 121, '2014-04-01 01:18:34.000000', 'temperatura', 174.0000, 'ºC'),
	(280893, 121, '2014-04-01 01:18:35.000000', 'temperatura', 853.0000, 'ºC'),
	(280894, 121, '2014-04-01 01:18:36.000000', 'temperatura', 140.0000, 'ºC'),
	(280895, 121, '2014-04-01 01:18:37.000000', 'temperatura', 542.0000, 'ºC'),
	(280896, 121, '2014-04-01 01:18:38.000000', 'temperatura', 1090.0000, 'ºC'),
	(280897, 121, '2014-04-01 01:18:39.000000', 'temperatura', 223.0000, 'ºC'),
	(280898, 121, '2014-04-01 01:18:40.000000', 'temperatura', 248.0000, 'ºC'),
	(280899, 121, '2014-04-01 01:18:41.000000', 'temperatura', 569.0000, 'ºC'),
	(280900, 121, '2014-04-01 01:18:42.000000', 'temperatura', 902.0000, 'ºC'),
	(280901, 121, '2014-04-01 01:18:43.000000', 'temperatura', 404.0000, 'ºC'),
	(280902, 121, '2014-04-01 01:18:44.000000', 'temperatura', 513.0000, 'ºC'),
	(280903, 121, '2014-04-01 01:18:45.000000', 'temperatura', 155.0000, 'ºC'),
	(280904, 121, '2014-04-01 01:18:46.000000', 'temperatura', 436.0000, 'ºC'),
	(280905, 121, '2014-04-01 01:18:47.000000', 'temperatura', 516.0000, 'ºC'),
	(280906, 121, '2014-04-01 01:18:48.000000', 'temperatura', 73.0000, 'ºC'),
	(280907, 121, '2014-04-01 01:18:49.000000', 'temperatura', 15.0000, 'ºC'),
	(280908, 121, '2014-04-01 01:18:50.000000', 'temperatura', 1060.0000, 'ºC'),
	(280909, 121, '2014-04-01 01:18:51.000000', 'temperatura', 452.0000, 'ºC'),
	(280910, 121, '2014-04-01 01:18:52.000000', 'temperatura', 284.0000, 'ºC'),
	(280911, 121, '2014-04-01 01:18:53.000000', 'temperatura', 61.0000, 'ºC'),
	(280912, 121, '2014-04-01 01:18:54.000000', 'temperatura', 655.0000, 'ºC'),
	(280913, 121, '2014-04-01 01:18:55.000000', 'temperatura', 691.0000, 'ºC'),
	(280914, 121, '2014-04-01 01:18:56.000000', 'temperatura', 293.0000, 'ºC'),
	(280915, 121, '2014-04-01 01:18:57.000000', 'temperatura', 592.0000, 'ºC'),
	(280916, 121, '2014-04-01 01:18:58.000000', 'temperatura', 880.0000, 'ºC'),
	(280917, 121, '2014-04-01 01:18:59.000000', 'temperatura', 224.0000, 'ºC'),
	(280918, 121, '2014-04-01 01:19:00.000000', 'temperatura', 882.0000, 'ºC'),
	(280919, 121, '2014-04-01 01:19:01.000000', 'temperatura', 140.0000, 'ºC'),
	(280920, 121, '2014-04-01 01:19:02.000000', 'temperatura', 452.0000, 'ºC'),
	(280921, 121, '2014-04-01 01:19:03.000000', 'temperatura', 643.0000, 'ºC'),
	(280922, 121, '2014-04-01 01:19:04.000000', 'temperatura', 658.0000, 'ºC'),
	(280923, 121, '2014-04-01 01:19:05.000000', 'temperatura', 163.0000, 'ºC'),
	(280924, 121, '2014-04-01 01:19:06.000000', 'temperatura', 43.0000, 'ºC'),
	(280925, 121, '2014-04-01 01:19:07.000000', 'temperatura', 923.0000, 'ºC'),
	(280926, 121, '2014-04-01 01:19:08.000000', 'temperatura', 889.0000, 'ºC'),
	(280927, 121, '2014-04-01 01:19:09.000000', 'temperatura', 477.0000, 'ºC'),
	(280928, 121, '2014-04-01 01:19:10.000000', 'temperatura', 915.0000, 'ºC'),
	(280929, 121, '2014-04-01 01:19:11.000000', 'temperatura', 748.0000, 'ºC'),
	(280930, 121, '2014-04-01 01:19:12.000000', 'temperatura', 996.0000, 'ºC'),
	(280931, 121, '2014-04-01 01:19:13.000000', 'temperatura', 335.0000, 'ºC'),
	(280932, 121, '2014-04-01 01:19:14.000000', 'temperatura', 1086.0000, 'ºC'),
	(280933, 121, '2014-04-01 01:19:15.000000', 'temperatura', 828.0000, 'ºC'),
	(280934, 121, '2014-04-01 01:19:16.000000', 'temperatura', 881.0000, 'ºC'),
	(280935, 121, '2014-04-01 01:19:17.000000', 'temperatura', 724.0000, 'ºC'),
	(280936, 121, '2014-04-01 01:19:18.000000', 'temperatura', 976.0000, 'ºC'),
	(280937, 121, '2014-04-01 01:19:19.000000', 'temperatura', 307.0000, 'ºC'),
	(280938, 121, '2014-04-01 01:19:20.000000', 'temperatura', 1008.0000, 'ºC'),
	(280939, 121, '2014-04-01 01:19:21.000000', 'temperatura', 519.0000, 'ºC'),
	(280940, 121, '2014-04-01 01:19:22.000000', 'temperatura', 774.0000, 'ºC'),
	(280941, 121, '2014-04-01 01:19:23.000000', 'temperatura', 1112.0000, 'ºC'),
	(280942, 121, '2014-04-01 01:19:24.000000', 'temperatura', 838.0000, 'ºC'),
	(280943, 121, '2014-04-01 01:19:25.000000', 'temperatura', 856.0000, 'ºC'),
	(280944, 121, '2014-04-01 01:19:26.000000', 'temperatura', 566.0000, 'ºC'),
	(280945, 121, '2014-04-01 01:19:27.000000', 'temperatura', 260.0000, 'ºC'),
	(280946, 121, '2014-04-01 01:19:28.000000', 'temperatura', 806.0000, 'ºC'),
	(280947, 121, '2014-04-01 01:19:29.000000', 'temperatura', 850.0000, 'ºC'),
	(280948, 121, '2014-04-01 01:19:30.000000', 'temperatura', 630.0000, 'ºC'),
	(280949, 121, '2014-04-01 01:19:31.000000', 'temperatura', 603.0000, 'ºC'),
	(280950, 121, '2014-04-01 01:19:32.000000', 'temperatura', 1125.0000, 'ºC'),
	(280951, 121, '2014-04-01 01:19:33.000000', 'temperatura', 216.0000, 'ºC'),
	(280952, 121, '2014-04-01 01:19:34.000000', 'temperatura', 107.0000, 'ºC'),
	(280953, 121, '2014-04-01 01:19:35.000000', 'temperatura', 1085.0000, 'ºC'),
	(280954, 121, '2014-04-01 01:19:36.000000', 'temperatura', 307.0000, 'ºC'),
	(280955, 121, '2014-04-01 01:19:37.000000', 'temperatura', 678.0000, 'ºC'),
	(280956, 121, '2014-04-01 01:19:38.000000', 'temperatura', 69.0000, 'ºC'),
	(280957, 121, '2014-04-01 01:19:39.000000', 'temperatura', 711.0000, 'ºC'),
	(280958, 121, '2014-04-01 01:19:40.000000', 'temperatura', 950.0000, 'ºC'),
	(280959, 121, '2014-04-01 01:19:41.000000', 'temperatura', 218.0000, 'ºC'),
	(280960, 121, '2014-04-01 01:19:42.000000', 'temperatura', 640.0000, 'ºC'),
	(280961, 121, '2014-04-01 01:19:43.000000', 'temperatura', 148.0000, 'ºC'),
	(280962, 121, '2014-04-01 01:19:44.000000', 'temperatura', 21.0000, 'ºC'),
	(280963, 121, '2014-04-01 01:19:45.000000', 'temperatura', 860.0000, 'ºC'),
	(280964, 121, '2014-04-01 01:19:46.000000', 'temperatura', 638.0000, 'ºC'),
	(280965, 121, '2014-04-01 01:19:47.000000', 'temperatura', 612.0000, 'ºC'),
	(280966, 121, '2014-04-01 01:19:48.000000', 'temperatura', 1145.0000, 'ºC'),
	(280967, 121, '2014-04-01 01:19:49.000000', 'temperatura', 290.0000, 'ºC'),
	(280968, 121, '2014-04-01 01:19:50.000000', 'temperatura', 416.0000, 'ºC'),
	(280969, 121, '2014-04-01 01:19:51.000000', 'temperatura', 10.0000, 'ºC'),
	(280970, 121, '2014-04-01 01:19:52.000000', 'temperatura', 4.0000, 'ºC'),
	(280971, 121, '2014-04-01 01:19:53.000000', 'temperatura', 1190.0000, 'ºC'),
	(280972, 121, '2014-04-01 01:19:54.000000', 'temperatura', 1140.0000, 'ºC'),
	(280973, 121, '2014-04-01 01:19:55.000000', 'temperatura', 927.0000, 'ºC'),
	(280974, 121, '2014-04-01 01:19:56.000000', 'temperatura', 18.0000, 'ºC'),
	(280975, 121, '2014-04-01 01:19:57.000000', 'temperatura', 907.0000, 'ºC'),
	(280976, 121, '2014-04-01 01:19:58.000000', 'temperatura', 883.0000, 'ºC'),
	(280977, 121, '2014-04-01 01:19:59.000000', 'temperatura', 495.0000, 'ºC'),
	(280978, 121, '2014-04-01 01:20:00.000000', 'temperatura', 1026.0000, 'ºC'),
	(280979, 121, '2014-04-01 01:20:01.000000', 'temperatura', 46.0000, 'ºC'),
	(280980, 121, '2014-04-01 01:20:02.000000', 'temperatura', 752.0000, 'ºC'),
	(280981, 121, '2014-04-01 01:20:03.000000', 'temperatura', 21.0000, 'ºC'),
	(280982, 121, '2014-04-01 01:20:04.000000', 'temperatura', 252.0000, 'ºC'),
	(280983, 121, '2014-04-01 01:20:05.000000', 'temperatura', 1196.0000, 'ºC'),
	(280984, 121, '2014-04-01 01:20:06.000000', 'temperatura', 426.0000, 'ºC'),
	(280985, 121, '2014-04-01 01:20:07.000000', 'temperatura', 943.0000, 'ºC'),
	(280986, 121, '2014-04-01 01:20:08.000000', 'temperatura', 1038.0000, 'ºC'),
	(280987, 121, '2014-04-01 01:20:09.000000', 'temperatura', 1159.0000, 'ºC'),
	(280988, 121, '2014-04-01 01:20:10.000000', 'temperatura', 285.0000, 'ºC'),
	(280989, 121, '2014-04-01 01:20:11.000000', 'temperatura', 345.0000, 'ºC'),
	(280990, 121, '2014-04-01 01:20:12.000000', 'temperatura', 873.0000, 'ºC'),
	(280991, 121, '2014-04-01 01:20:13.000000', 'temperatura', 928.0000, 'ºC'),
	(280992, 121, '2014-04-01 01:20:14.000000', 'temperatura', 823.0000, 'ºC'),
	(280993, 121, '2014-04-01 01:20:15.000000', 'temperatura', 129.0000, 'ºC'),
	(280994, 121, '2014-04-01 01:20:16.000000', 'temperatura', 579.0000, 'ºC'),
	(280995, 121, '2014-04-01 01:20:17.000000', 'temperatura', 110.0000, 'ºC'),
	(280996, 121, '2014-04-01 01:20:18.000000', 'temperatura', 12.0000, 'ºC'),
	(280997, 121, '2014-04-01 01:20:19.000000', 'temperatura', 929.0000, 'ºC'),
	(280998, 121, '2014-04-01 01:20:20.000000', 'temperatura', 1012.0000, 'ºC'),
	(280999, 121, '2014-04-01 01:20:21.000000', 'temperatura', 1071.0000, 'ºC'),
	(281000, 121, '2014-04-01 01:20:22.000000', 'temperatura', 1120.0000, 'ºC'),
	(281001, 121, '2014-04-01 01:20:23.000000', 'temperatura', 1187.0000, 'ºC'),
	(281002, 121, '2014-04-01 01:20:24.000000', 'temperatura', 175.0000, 'ºC'),
	(281003, 121, '2014-04-01 01:20:25.000000', 'temperatura', 915.0000, 'ºC'),
	(281004, 121, '2014-04-01 01:20:26.000000', 'temperatura', 452.0000, 'ºC'),
	(281005, 121, '2014-04-01 01:20:27.000000', 'temperatura', 713.0000, 'ºC'),
	(281006, 121, '2014-04-01 01:20:28.000000', 'temperatura', 1011.0000, 'ºC'),
	(281007, 121, '2014-04-01 01:20:29.000000', 'temperatura', 516.0000, 'ºC'),
	(281008, 121, '2014-04-01 01:20:30.000000', 'temperatura', 749.0000, 'ºC'),
	(281009, 121, '2014-04-01 01:20:31.000000', 'temperatura', 995.0000, 'ºC'),
	(281010, 121, '2014-04-01 01:20:32.000000', 'temperatura', 330.0000, 'ºC'),
	(281011, 121, '2014-04-01 01:20:33.000000', 'temperatura', 1064.0000, 'ºC'),
	(281012, 121, '2014-04-01 01:20:34.000000', 'temperatura', 731.0000, 'ºC'),
	(281013, 121, '2014-04-01 01:20:35.000000', 'temperatura', 462.0000, 'ºC'),
	(281014, 121, '2014-04-01 01:20:36.000000', 'temperatura', 118.0000, 'ºC'),
	(281015, 121, '2014-04-01 01:20:37.000000', 'temperatura', 406.0000, 'ºC'),
	(281016, 121, '2014-04-01 01:20:38.000000', 'temperatura', 476.0000, 'ºC'),
	(281017, 121, '2014-04-01 01:20:39.000000', 'temperatura', 1162.0000, 'ºC'),
	(281018, 121, '2014-04-01 01:20:40.000000', 'temperatura', 783.0000, 'ºC'),
	(281019, 121, '2014-04-01 01:20:41.000000', 'temperatura', 428.0000, 'ºC'),
	(281020, 121, '2014-04-01 01:20:42.000000', 'temperatura', 993.0000, 'ºC'),
	(281021, 121, '2014-04-01 01:20:43.000000', 'temperatura', 81.0000, 'ºC'),
	(281022, 121, '2014-04-01 01:20:44.000000', 'temperatura', 1028.0000, 'ºC'),
	(281023, 121, '2014-04-01 01:20:45.000000', 'temperatura', 96.0000, 'ºC'),
	(281024, 121, '2014-04-01 01:20:46.000000', 'temperatura', 999.0000, 'ºC'),
	(281025, 121, '2014-04-01 01:20:47.000000', 'temperatura', 1104.0000, 'ºC'),
	(281026, 121, '2014-04-01 01:20:48.000000', 'temperatura', 125.0000, 'ºC'),
	(281027, 121, '2014-04-01 01:20:49.000000', 'temperatura', 912.0000, 'ºC'),
	(281028, 121, '2014-04-01 01:20:50.000000', 'temperatura', 588.0000, 'ºC'),
	(281029, 121, '2014-04-01 01:20:51.000000', 'temperatura', 206.0000, 'ºC'),
	(281030, 121, '2014-04-01 01:20:52.000000', 'temperatura', 463.0000, 'ºC'),
	(281031, 121, '2014-04-01 01:20:53.000000', 'temperatura', 498.0000, 'ºC'),
	(281032, 121, '2014-04-01 01:20:54.000000', 'temperatura', 1100.0000, 'ºC'),
	(281033, 121, '2014-04-01 01:20:55.000000', 'temperatura', 407.0000, 'ºC'),
	(281034, 121, '2014-04-01 01:20:56.000000', 'temperatura', 1138.0000, 'ºC'),
	(281035, 121, '2014-04-01 01:20:57.000000', 'temperatura', 867.0000, 'ºC'),
	(281036, 121, '2014-04-01 01:20:58.000000', 'temperatura', 922.0000, 'ºC'),
	(281037, 121, '2014-04-01 01:20:59.000000', 'temperatura', 809.0000, 'ºC'),
	(281038, 121, '2014-04-01 01:21:00.000000', 'temperatura', 79.0000, 'ºC'),
	(281039, 121, '2014-04-01 01:21:01.000000', 'temperatura', 368.0000, 'ºC'),
	(281040, 121, '2014-04-01 01:21:02.000000', 'temperatura', 404.0000, 'ºC'),
	(281041, 121, '2014-04-01 01:21:03.000000', 'temperatura', 917.0000, 'ºC'),
	(281042, 121, '2014-04-01 01:21:04.000000', 'temperatura', 972.0000, 'ºC'),
	(281043, 121, '2014-04-01 01:21:05.000000', 'temperatura', 909.0000, 'ºC'),
	(281044, 121, '2014-04-01 01:21:06.000000', 'temperatura', 432.0000, 'ºC'),
	(281045, 121, '2014-04-01 01:21:07.000000', 'temperatura', 632.0000, 'ºC'),
	(281046, 121, '2014-04-01 01:21:08.000000', 'temperatura', 665.0000, 'ºC'),
	(281047, 121, '2014-04-01 01:21:09.000000', 'temperatura', 227.0000, 'ºC'),
	(281048, 121, '2014-04-01 01:21:10.000000', 'temperatura', 343.0000, 'ºC'),
	(281049, 121, '2014-04-01 01:21:11.000000', 'temperatura', 1035.0000, 'ºC'),
	(281050, 121, '2014-04-01 01:21:12.000000', 'temperatura', 545.0000, 'ºC'),
	(281051, 121, '2014-04-01 01:21:13.000000', 'temperatura', 823.0000, 'ºC'),
	(281052, 121, '2014-04-01 01:21:14.000000', 'temperatura', 80.0000, 'ºC'),
	(281053, 121, '2014-04-01 01:21:15.000000', 'temperatura', 329.0000, 'ºC'),
	(281054, 121, '2014-04-01 01:21:16.000000', 'temperatura', 206.0000, 'ºC'),
	(281055, 121, '2014-04-01 01:21:17.000000', 'temperatura', 43.0000, 'ºC'),
	(281056, 121, '2014-04-01 01:21:18.000000', 'temperatura', 797.0000, 'ºC'),
	(281057, 121, '2014-04-01 01:21:19.000000', 'temperatura', 257.0000, 'ºC'),
	(281058, 121, '2014-04-01 01:21:20.000000', 'temperatura', 97.0000, 'ºC'),
	(281059, 121, '2014-04-01 01:21:21.000000', 'temperatura', 911.0000, 'ºC'),
	(281060, 121, '2014-04-01 01:21:22.000000', 'temperatura', 667.0000, 'ºC'),
	(281061, 121, '2014-04-01 01:21:23.000000', 'temperatura', 604.0000, 'ºC'),
	(281062, 121, '2014-04-01 01:21:24.000000', 'temperatura', 1017.0000, 'ºC'),
	(281063, 121, '2014-04-01 01:21:25.000000', 'temperatura', 872.0000, 'ºC'),
	(281064, 121, '2014-04-01 01:21:26.000000', 'temperatura', 112.0000, 'ºC'),
	(281065, 121, '2014-04-01 01:21:27.000000', 'temperatura', 342.0000, 'ºC'),
	(281066, 121, '2014-04-01 01:21:28.000000', 'temperatura', 175.0000, 'ºC'),
	(281067, 121, '2014-04-01 01:21:29.000000', 'temperatura', 1049.0000, 'ºC'),
	(281068, 121, '2014-04-01 01:21:30.000000', 'temperatura', 1122.0000, 'ºC'),
	(281069, 121, '2014-04-01 01:21:31.000000', 'temperatura', 61.0000, 'ºC'),
	(281070, 121, '2014-04-01 01:21:32.000000', 'temperatura', 543.0000, 'ºC'),
	(281071, 121, '2014-04-01 01:21:33.000000', 'temperatura', 131.0000, 'ºC'),
	(281072, 121, '2014-04-01 01:21:34.000000', 'temperatura', 225.0000, 'ºC'),
	(281073, 121, '2014-04-01 01:21:35.000000', 'temperatura', 733.0000, 'ºC'),
	(281074, 121, '2014-04-01 01:21:36.000000', 'temperatura', 591.0000, 'ºC'),
	(281075, 121, '2014-04-01 01:21:37.000000', 'temperatura', 757.0000, 'ºC'),
	(281076, 121, '2014-04-01 01:21:38.000000', 'temperatura', 811.0000, 'ºC'),
	(281077, 121, '2014-04-01 01:21:39.000000', 'temperatura', 584.0000, 'ºC'),
	(281078, 121, '2014-04-01 01:21:40.000000', 'temperatura', 487.0000, 'ºC'),
	(281079, 121, '2014-04-01 01:21:41.000000', 'temperatura', 686.0000, 'ºC'),
	(281080, 121, '2014-04-01 01:21:42.000000', 'temperatura', 767.0000, 'ºC'),
	(281081, 121, '2014-04-01 01:21:43.000000', 'temperatura', 579.0000, 'ºC'),
	(281082, 121, '2014-04-01 01:21:44.000000', 'temperatura', 593.0000, 'ºC'),
	(281083, 121, '2014-04-01 01:21:45.000000', 'temperatura', 31.0000, 'ºC'),
	(281084, 121, '2014-04-01 01:21:46.000000', 'temperatura', 774.0000, 'ºC'),
	(281085, 121, '2014-04-01 01:21:47.000000', 'temperatura', 180.0000, 'ºC'),
	(281086, 121, '2014-04-01 01:21:48.000000', 'temperatura', 976.0000, 'ºC'),
	(281087, 121, '2014-04-01 01:21:49.000000', 'temperatura', 741.0000, 'ºC'),
	(281088, 121, '2014-04-01 01:21:50.000000', 'temperatura', 778.0000, 'ºC'),
	(281089, 121, '2014-04-01 01:21:51.000000', 'temperatura', 467.0000, 'ºC'),
	(281090, 121, '2014-04-01 01:21:52.000000', 'temperatura', 0.0000, 'ºC'),
	(281091, 121, '2014-04-01 01:21:53.000000', 'temperatura', 999.0000, 'ºC'),
	(281092, 121, '2014-04-01 01:21:54.000000', 'temperatura', 199.0000, 'ºC'),
	(281093, 121, '2014-04-01 01:21:55.000000', 'temperatura', 395.0000, 'ºC'),
	(281094, 121, '2014-04-01 01:21:56.000000', 'temperatura', 179.0000, 'ºC'),
	(281095, 121, '2014-04-01 01:21:57.000000', 'temperatura', 913.0000, 'ºC'),
	(281096, 121, '2014-04-01 01:21:58.000000', 'temperatura', 428.0000, 'ºC'),
	(281097, 121, '2014-04-01 01:21:59.000000', 'temperatura', 599.0000, 'ºC'),
	(281098, 121, '2014-04-01 01:22:00.000000', 'temperatura', 513.0000, 'ºC'),
	(281099, 121, '2014-04-01 01:22:01.000000', 'temperatura', 770.0000, 'ºC'),
	(281100, 121, '2014-04-01 01:22:02.000000', 'temperatura', 1110.0000, 'ºC'),
	(281101, 121, '2014-04-01 01:22:03.000000', 'temperatura', 840.0000, 'ºC'),
	(281102, 121, '2014-04-01 01:22:04.000000', 'temperatura', 873.0000, 'ºC'),
	(281103, 121, '2014-04-01 01:22:05.000000', 'temperatura', 643.0000, 'ºC'),
	(281104, 121, '2014-04-01 01:22:06.000000', 'temperatura', 599.0000, 'ºC'),
	(281105, 121, '2014-04-01 01:22:07.000000', 'temperatura', 1066.0000, 'ºC'),
	(281106, 121, '2014-04-01 01:22:08.000000', 'temperatura', 1132.0000, 'ºC'),
	(281107, 121, '2014-04-01 01:22:09.000000', 'temperatura', 63.0000, 'ºC'),
	(281108, 121, '2014-04-01 01:22:10.000000', 'temperatura', 520.0000, 'ºC'),
	(281109, 121, '2014-04-01 01:22:11.000000', 'temperatura', 10.0000, 'ºC'),
	(281110, 121, '2014-04-01 01:22:12.000000', 'temperatura', 891.0000, 'ºC'),
	(281111, 121, '2014-04-01 01:22:13.000000', 'temperatura', 826.0000, 'ºC'),
	(281112, 121, '2014-04-01 01:22:14.000000', 'temperatura', 256.0000, 'ºC'),
	(281113, 121, '2014-04-01 01:22:15.000000', 'temperatura', 5.0000, 'ºC'),
	(281114, 121, '2014-04-01 01:22:16.000000', 'temperatura', 457.0000, 'ºC'),
	(281115, 121, '2014-04-01 01:22:17.000000', 'temperatura', 1069.0000, 'ºC'),
	(281116, 121, '2014-04-01 01:22:18.000000', 'temperatura', 375.0000, 'ºC'),
	(281117, 121, '2014-04-01 01:22:19.000000', 'temperatura', 1071.0000, 'ºC'),
	(281118, 121, '2014-04-01 01:22:20.000000', 'temperatura', 628.0000, 'ºC'),
	(281119, 121, '2014-04-01 01:22:21.000000', 'temperatura', 1128.0000, 'ºC'),
	(281120, 121, '2014-04-01 01:22:22.000000', 'temperatura', 157.0000, 'ºC'),
	(281121, 121, '2014-04-01 01:22:23.000000', 'temperatura', 1000.0000, 'ºC'),
	(281122, 121, '2014-04-01 01:22:24.000000', 'temperatura', 930.0000, 'ºC'),
	(281123, 121, '2014-04-01 01:22:25.000000', 'temperatura', 453.0000, 'ºC'),
	(281124, 121, '2014-04-01 01:22:26.000000', 'temperatura', 672.0000, 'ºC'),
	(281125, 121, '2014-04-01 01:22:27.000000', 'temperatura', 804.0000, 'ºC'),
	(281126, 121, '2014-04-01 01:22:28.000000', 'temperatura', 806.0000, 'ºC'),
	(281127, 121, '2014-04-01 01:22:29.000000', 'temperatura', 415.0000, 'ºC'),
	(281128, 121, '2014-04-01 01:22:30.000000', 'temperatura', 859.0000, 'ºC'),
	(281129, 121, '2014-04-01 01:22:31.000000', 'temperatura', 652.0000, 'ºC'),
	(281130, 121, '2014-04-01 01:22:32.000000', 'temperatura', 682.0000, 'ºC'),
	(281131, 121, '2014-04-01 01:22:33.000000', 'temperatura', 255.0000, 'ºC'),
	(281132, 121, '2014-04-01 01:22:34.000000', 'temperatura', 431.0000, 'ºC'),
	(281133, 121, '2014-04-01 01:22:35.000000', 'temperatura', 190.0000, 'ºC'),
	(281134, 121, '2014-04-01 01:22:36.000000', 'temperatura', 859.0000, 'ºC'),
	(281135, 121, '2014-04-01 01:22:37.000000', 'temperatura', 124.0000, 'ºC'),
	(281136, 121, '2014-04-01 01:22:38.000000', 'temperatura', 445.0000, 'ºC'),
	(281137, 121, '2014-04-01 01:22:39.000000', 'temperatura', 652.0000, 'ºC'),
	(281138, 121, '2014-04-01 01:22:40.000000', 'temperatura', 725.0000, 'ºC'),
	(281139, 121, '2014-04-01 01:22:41.000000', 'temperatura', 471.0000, 'ºC'),
	(281140, 121, '2014-04-01 01:22:42.000000', 'temperatura', 181.0000, 'ºC'),
	(281141, 121, '2014-04-01 01:22:43.000000', 'temperatura', 690.0000, 'ºC'),
	(281142, 121, '2014-04-01 01:22:44.000000', 'temperatura', 508.0000, 'ºC'),
	(281143, 121, '2014-04-01 01:22:45.000000', 'temperatura', 472.0000, 'ºC'),
	(281144, 121, '2014-04-01 01:22:46.000000', 'temperatura', 837.0000, 'ºC'),
	(281145, 121, '2014-04-01 01:22:47.000000', 'temperatura', 368.0000, 'ºC'),
	(281146, 121, '2014-04-01 01:22:48.000000', 'temperatura', 529.0000, 'ºC'),
	(281147, 121, '2014-04-01 01:22:49.000000', 'temperatura', 341.0000, 'ºC'),
	(281148, 121, '2014-04-01 01:22:50.000000', 'temperatura', 120.0000, 'ºC'),
	(281149, 121, '2014-04-01 01:22:51.000000', 'temperatura', 775.0000, 'ºC'),
	(281150, 121, '2014-04-01 01:22:52.000000', 'temperatura', 1118.0000, 'ºC'),
	(281151, 121, '2014-04-01 01:22:53.000000', 'temperatura', 863.0000, 'ºC'),
	(281152, 121, '2014-04-01 01:22:54.000000', 'temperatura', 964.0000, 'ºC'),
	(281153, 121, '2014-04-01 01:22:55.000000', 'temperatura', 1030.0000, 'ºC'),
	(281154, 121, '2014-04-01 01:22:56.000000', 'temperatura', 1058.0000, 'ºC'),
	(281155, 121, '2014-04-01 01:22:57.000000', 'temperatura', 1001.0000, 'ºC'),
	(281156, 121, '2014-04-01 01:22:58.000000', 'temperatura', 632.0000, 'ºC'),
	(281157, 121, '2014-04-01 01:22:59.000000', 'temperatura', 157.0000, 'ºC'),
	(281158, 121, '2014-04-01 01:23:00.000000', 'temperatura', 91.0000, 'ºC'),
	(281159, 121, '2014-04-01 01:23:01.000000', 'temperatura', 1181.0000, 'ºC'),
	(281160, 121, '2014-04-01 01:23:02.000000', 'temperatura', 836.0000, 'ºC'),
	(281161, 121, '2014-04-01 01:23:03.000000', 'temperatura', 637.0000, 'ºC'),
	(281162, 121, '2014-04-01 01:23:04.000000', 'temperatura', 675.0000, 'ºC'),
	(281163, 121, '2014-04-01 01:23:05.000000', 'temperatura', 266.0000, 'ºC'),
	(281164, 121, '2014-04-01 01:23:06.000000', 'temperatura', 505.0000, 'ºC'),
	(281165, 121, '2014-04-01 01:23:07.000000', 'temperatura', 528.0000, 'ºC'),
	(281166, 121, '2014-04-01 01:23:08.000000', 'temperatura', 1125.0000, 'ºC'),
	(281167, 121, '2014-04-01 01:23:09.000000', 'temperatura', 440.0000, 'ºC'),
	(281168, 121, '2014-04-01 01:23:10.000000', 'temperatura', 26.0000, 'ºC'),
	(281169, 121, '2014-04-01 01:23:11.000000', 'temperatura', 10.0000, 'ºC'),
	(281170, 121, '2014-04-01 01:23:12.000000', 'temperatura', 1172.0000, 'ºC'),
	(281171, 121, '2014-04-01 01:23:13.000000', 'temperatura', 1032.0000, 'ºC'),
	(281172, 121, '2014-04-01 01:23:14.000000', 'temperatura', 443.0000, 'ºC'),
	(281173, 121, '2014-04-01 01:23:15.000000', 'temperatura', 322.0000, 'ºC'),
	(281174, 121, '2014-04-01 01:23:16.000000', 'temperatura', 279.0000, 'ºC'),
	(281175, 121, '2014-04-01 01:23:17.000000', 'temperatura', 429.0000, 'ºC'),
	(281176, 121, '2014-04-01 01:23:18.000000', 'temperatura', 109.0000, 'ºC'),
	(281177, 121, '2014-04-01 01:23:19.000000', 'temperatura', 459.0000, 'ºC'),
	(281178, 121, '2014-04-01 01:23:20.000000', 'temperatura', 767.0000, 'ºC'),
	(281179, 121, '2014-04-01 01:23:21.000000', 'temperatura', 59.0000, 'ºC'),
	(281180, 121, '2014-04-01 01:23:22.000000', 'temperatura', 395.0000, 'ºC'),
	(281181, 121, '2014-04-01 01:23:23.000000', 'temperatura', 600.0000, 'ºC'),
	(281182, 121, '2014-04-01 01:23:24.000000', 'temperatura', 616.0000, 'ºC'),
	(281183, 121, '2014-04-01 01:23:25.000000', 'temperatura', 80.0000, 'ºC'),
	(281184, 121, '2014-04-01 01:23:26.000000', 'temperatura', 952.0000, 'ºC'),
	(281185, 121, '2014-04-01 01:23:27.000000', 'temperatura', 919.0000, 'ºC'),
	(281186, 121, '2014-04-01 01:23:28.000000', 'temperatura', 539.0000, 'ºC'),
	(281187, 121, '2014-04-01 01:23:29.000000', 'temperatura', 1138.0000, 'ºC'),
	(281188, 121, '2014-04-01 01:23:30.000000', 'temperatura', 475.0000, 'ºC'),
	(281189, 121, '2014-04-01 01:23:31.000000', 'temperatura', 160.0000, 'ºC'),
	(281190, 121, '2014-04-01 01:23:32.000000', 'temperatura', 575.0000, 'ºC'),
	(281191, 121, '2014-04-01 01:23:33.000000', 'temperatura', 1197.0000, 'ºC'),
	(281192, 121, '2014-04-01 01:23:34.000000', 'temperatura', 659.0000, 'ºC'),
	(281193, 121, '2014-04-01 01:23:35.000000', 'temperatura', 905.0000, 'ºC'),
	(281194, 121, '2014-04-01 01:23:36.000000', 'temperatura', 149.0000, 'ºC'),
	(281195, 121, '2014-04-01 01:23:37.000000', 'temperatura', 432.0000, 'ºC'),
	(281196, 121, '2014-04-01 01:23:38.000000', 'temperatura', 513.0000, 'ºC'),
	(281197, 121, '2014-04-01 01:23:39.000000', 'temperatura', 70.0000, 'ºC'),
	(281198, 121, '2014-04-01 01:23:40.000000', 'temperatura', 13.0000, 'ºC'),
	(281199, 121, '2014-04-01 01:23:41.000000', 'temperatura', 1053.0000, 'ºC'),
	(281200, 121, '2014-04-01 01:23:42.000000', 'temperatura', 426.0000, 'ºC'),
	(281201, 121, '2014-04-01 01:23:43.000000', 'temperatura', 173.0000, 'ºC'),
	(281202, 121, '2014-04-01 01:23:44.000000', 'temperatura', 786.0000, 'ºC'),
	(281203, 121, '2014-04-01 01:23:45.000000', 'temperatura', 1013.0000, 'ºC'),
	(281204, 121, '2014-04-01 01:23:46.000000', 'temperatura', 309.0000, 'ºC'),
	(281205, 121, '2014-04-01 01:23:47.000000', 'temperatura', 905.0000, 'ºC'),
	(281206, 121, '2014-04-01 01:23:48.000000', 'temperatura', 1.0000, 'ºC'),
	(281207, 121, '2014-04-01 01:23:49.000000', 'temperatura', 887.0000, 'ºC'),
	(281208, 121, '2014-04-01 01:23:50.000000', 'temperatura', 834.0000, 'ºC'),
	(281209, 121, '2014-04-01 01:23:51.000000', 'temperatura', 311.0000, 'ºC'),
	(281210, 121, '2014-04-01 01:23:52.000000', 'temperatura', 254.0000, 'ºC'),
	(281211, 121, '2014-04-01 01:23:53.000000', 'temperatura', 337.0000, 'ºC'),
	(281212, 121, '2014-04-01 01:23:54.000000', 'temperatura', 921.0000, 'ºC'),
	(281213, 121, '2014-04-01 01:23:55.000000', 'temperatura', 1198.0000, 'ºC'),
	(281214, 121, '2014-04-01 01:23:56.000000', 'temperatura', 826.0000, 'ºC'),
	(281215, 121, '2014-04-01 01:23:57.000000', 'temperatura', 536.0000, 'ºC'),
	(281216, 121, '2014-04-01 01:23:58.000000', 'temperatura', 204.0000, 'ºC'),
	(281217, 121, '2014-04-01 01:23:59.000000', 'temperatura', 612.0000, 'ºC'),
	(281218, 121, '2014-04-01 01:24:00.000000', 'temperatura', 49.0000, 'ºC'),
	(281219, 121, '2014-04-01 01:24:01.000000', 'temperatura', 808.0000, 'ºC'),
	(281220, 121, '2014-04-01 01:24:02.000000', 'temperatura', 294.0000, 'ºC'),
	(281221, 121, '2014-04-01 01:24:03.000000', 'temperatura', 247.0000, 'ºC'),
	(281222, 121, '2014-04-01 01:24:04.000000', 'temperatura', 351.0000, 'ºC'),
	(281223, 121, '2014-04-01 01:24:05.000000', 'temperatura', 1017.0000, 'ºC'),
	(281224, 121, '2014-04-01 01:24:06.000000', 'temperatura', 433.0000, 'ºC'),
	(281225, 121, '2014-04-01 01:24:07.000000', 'temperatura', 314.0000, 'ºC'),
	(281226, 121, '2014-04-01 01:24:08.000000', 'temperatura', 273.0000, 'ºC'),
	(281227, 121, '2014-04-01 01:24:09.000000', 'temperatura', 423.0000, 'ºC'),
	(281228, 121, '2014-04-01 01:24:10.000000', 'temperatura', 98.0000, 'ºC'),
	(281229, 121, '2014-04-01 01:24:11.000000', 'temperatura', 420.0000, 'ºC'),
	(281230, 121, '2014-04-01 01:24:12.000000', 'temperatura', 608.0000, 'ºC'),
	(281231, 121, '2014-04-01 01:24:13.000000', 'temperatura', 581.0000, 'ºC'),
	(281232, 121, '2014-04-01 01:24:14.000000', 'temperatura', 1080.0000, 'ºC'),
	(281233, 121, '2014-04-01 01:24:15.000000', 'temperatura', 59.0000, 'ºC'),
	(281234, 121, '2014-04-01 01:24:16.000000', 'temperatura', 654.0000, 'ºC'),
	(281235, 121, '2014-04-01 01:24:17.000000', 'temperatura', 693.0000, 'ºC'),
	(281236, 121, '2014-04-01 01:24:18.000000', 'temperatura', 306.0000, 'ºC'),
	(281237, 121, '2014-04-01 01:24:19.000000', 'temperatura', 651.0000, 'ºC'),
	(281238, 121, '2014-04-01 01:24:20.000000', 'temperatura', 1138.0000, 'ºC'),
	(281239, 121, '2014-04-01 01:24:21.000000', 'temperatura', 135.0000, 'ºC'),
	(281240, 121, '2014-04-01 01:24:22.000000', 'temperatura', 862.0000, 'ºC'),
	(281241, 121, '2014-04-01 01:24:23.000000', 'temperatura', 307.0000, 'ºC'),
	(281242, 121, '2014-04-01 01:24:24.000000', 'temperatura', 147.0000, 'ºC'),
	(281243, 121, '2014-04-01 01:24:25.000000', 'temperatura', 1017.0000, 'ºC'),
	(281244, 121, '2014-04-01 01:24:26.000000', 'temperatura', 1042.0000, 'ºC'),
	(281245, 121, '2014-04-01 01:24:27.000000', 'temperatura', 960.0000, 'ºC'),
	(281246, 121, '2014-04-01 01:24:28.000000', 'temperatura', 473.0000, 'ºC'),
	(281247, 121, '2014-04-01 01:24:29.000000', 'temperatura', 687.0000, 'ºC'),
	(281248, 121, '2014-04-01 01:24:30.000000', 'temperatura', 817.0000, 'ºC'),
	(281249, 121, '2014-04-01 01:24:31.000000', 'temperatura', 822.0000, 'ºC'),
	(281250, 121, '2014-04-01 01:24:32.000000', 'temperatura', 463.0000, 'ºC'),
	(281251, 121, '2014-04-01 01:24:33.000000', 'temperatura', 1047.0000, 'ºC'),
	(281252, 121, '2014-04-01 01:24:34.000000', 'temperatura', 248.0000, 'ºC'),
	(281253, 121, '2014-04-01 01:24:35.000000', 'temperatura', 498.0000, 'ºC'),
	(281254, 121, '2014-04-01 01:24:36.000000', 'temperatura', 548.0000, 'ºC'),
	(281255, 121, '2014-04-01 01:24:37.000000', 'temperatura', 46.0000, 'ºC'),
	(281256, 121, '2014-04-01 01:24:38.000000', 'temperatura', 986.0000, 'ºC'),
	(281257, 121, '2014-04-01 01:24:39.000000', 'temperatura', 1192.0000, 'ºC'),
	(281258, 121, '2014-04-01 01:24:40.000000', 'temperatura', 602.0000, 'ºC'),
	(281259, 121, '2014-04-01 01:24:41.000000', 'temperatura', 636.0000, 'ºC'),
	(281260, 121, '2014-04-01 01:24:42.000000', 'temperatura', 176.0000, 'ºC'),
	(281261, 121, '2014-04-01 01:24:43.000000', 'temperatura', 170.0000, 'ºC'),
	(281262, 121, '2014-04-01 01:24:44.000000', 'temperatura', 322.0000, 'ºC'),
	(281263, 121, '2014-04-01 01:24:45.000000', 'temperatura', 1100.0000, 'ºC'),
	(281264, 121, '2014-04-01 01:24:46.000000', 'temperatura', 934.0000, 'ºC'),
	(281265, 121, '2014-04-01 01:24:47.000000', 'temperatura', 172.0000, 'ºC'),
	(281266, 121, '2014-04-01 01:24:48.000000', 'temperatura', 458.0000, 'ºC'),
	(281267, 121, '2014-04-01 01:24:49.000000', 'temperatura', 576.0000, 'ºC'),
	(281268, 121, '2014-04-01 01:24:50.000000', 'temperatura', 306.0000, 'ºC'),
	(281269, 121, '2014-04-01 01:24:51.000000', 'temperatura', 1000.0000, 'ºC'),
	(281270, 121, '2014-04-01 01:24:52.000000', 'temperatura', 484.0000, 'ºC'),
	(281271, 121, '2014-04-01 01:24:53.000000', 'temperatura', 622.0000, 'ºC'),
	(281272, 121, '2014-04-01 01:24:54.000000', 'temperatura', 456.0000, 'ºC'),
	(281273, 121, '2014-04-01 01:24:55.000000', 'temperatura', 415.0000, 'ºC'),
	(281274, 121, '2014-04-01 01:24:56.000000', 'temperatura', 707.0000, 'ºC'),
	(281275, 121, '2014-04-01 01:24:57.000000', 'temperatura', 1091.0000, 'ºC'),
	(281276, 121, '2014-04-01 01:24:58.000000', 'temperatura', 934.0000, 'ºC'),
	(281277, 121, '2014-04-01 01:24:59.000000', 'temperatura', 198.0000, 'ºC'),
	(281278, 121, '2014-04-01 01:25:00.000000', 'temperatura', 587.0000, 'ºC'),
	(281279, 121, '2014-04-01 01:25:01.000000', 'temperatura', 1143.0000, 'ºC'),
	(281280, 121, '2014-04-01 01:25:02.000000', 'temperatura', 355.0000, 'ºC'),
	(281281, 121, '2014-04-01 01:25:03.000000', 'temperatura', 744.0000, 'ºC'),
	(281282, 121, '2014-04-01 01:25:04.000000', 'temperatura', 258.0000, 'ºC'),
	(281283, 121, '2014-04-01 01:25:05.000000', 'temperatura', 258.0000, 'ºC'),
	(281284, 121, '2014-04-01 01:25:06.000000', 'temperatura', 517.0000, 'ºC'),
	(281285, 121, '2014-04-01 01:25:07.000000', 'temperatura', 610.0000, 'ºC'),
	(281286, 121, '2014-04-01 01:25:08.000000', 'temperatura', 299.0000, 'ºC'),
	(281287, 121, '2014-04-01 01:25:09.000000', 'temperatura', 866.0000, 'ºC'),
	(281288, 121, '2014-04-01 01:25:10.000000', 'temperatura', 1034.0000, 'ºC'),
	(281289, 121, '2014-04-01 01:25:11.000000', 'temperatura', 171.0000, 'ºC'),
	(281290, 121, '2014-04-01 01:25:12.000000', 'temperatura', 156.0000, 'ºC'),
	(281291, 121, '2014-04-01 01:25:13.000000', 'temperatura', 268.0000, 'ºC'),
	(281292, 121, '2014-04-01 01:25:14.000000', 'temperatura', 871.0000, 'ºC'),
	(281293, 121, '2014-04-01 01:25:15.000000', 'temperatura', 1153.0000, 'ºC'),
	(281294, 121, '2014-04-01 01:25:16.000000', 'temperatura', 753.0000, 'ºC'),
	(281295, 121, '2014-04-01 01:25:17.000000', 'temperatura', 305.0000, 'ºC'),
	(281296, 121, '2014-04-01 01:25:18.000000', 'temperatura', 469.0000, 'ºC'),
	(281297, 121, '2014-04-01 01:25:19.000000', 'temperatura', 228.0000, 'ºC'),
	(281298, 121, '2014-04-01 01:25:20.000000', 'temperatura', 932.0000, 'ºC'),
	(281299, 121, '2014-04-01 01:25:21.000000', 'temperatura', 380.0000, 'ºC'),
	(281300, 121, '2014-04-01 01:25:22.000000', 'temperatura', 304.0000, 'ºC'),
	(281301, 121, '2014-04-01 01:25:23.000000', 'temperatura', 380.0000, 'ºC'),
	(281302, 121, '2014-04-01 01:25:24.000000', 'temperatura', 987.0000, 'ºC'),
	(281303, 121, '2014-04-01 01:25:25.000000', 'temperatura', 195.0000, 'ºC'),
	(281304, 121, '2014-04-01 01:25:26.000000', 'temperatura', 414.0000, 'ºC'),
	(281305, 121, '2014-04-01 01:25:27.000000', 'temperatura', 287.0000, 'ºC'),
	(281306, 121, '2014-04-01 01:25:28.000000', 'temperatura', 191.0000, 'ºC'),
	(281307, 121, '2014-04-01 01:25:29.000000', 'temperatura', 96.0000, 'ºC'),
	(281308, 121, '2014-04-01 01:25:30.000000', 'temperatura', 1110.0000, 'ºC'),
	(281309, 121, '2014-04-01 01:25:31.000000', 'temperatura', 459.0000, 'ºC'),
	(281310, 121, '2014-04-01 01:25:32.000000', 'temperatura', 168.0000, 'ºC'),
	(281311, 121, '2014-04-01 01:25:33.000000', 'temperatura', 662.0000, 'ºC'),
	(281312, 121, '2014-04-01 01:25:34.000000', 'temperatura', 406.0000, 'ºC'),
	(281313, 121, '2014-04-01 01:25:35.000000', 'temperatura', 46.0000, 'ºC'),
	(281314, 121, '2014-04-01 01:25:36.000000', 'temperatura', 213.0000, 'ºC'),
	(281315, 121, '2014-04-01 01:25:37.000000', 'temperatura', 925.0000, 'ºC'),
	(281316, 121, '2014-04-01 01:25:38.000000', 'temperatura', 387.0000, 'ºC'),
	(281317, 121, '2014-04-01 01:25:39.000000', 'temperatura', 362.0000, 'ºC'),
	(281318, 121, '2014-04-01 01:25:40.000000', 'temperatura', 649.0000, 'ºC'),
	(281319, 121, '2014-04-01 01:25:41.000000', 'temperatura', 958.0000, 'ºC'),
	(281320, 121, '2014-04-01 01:25:42.000000', 'temperatura', 446.0000, 'ºC'),
	(281321, 121, '2014-04-01 01:25:43.000000', 'temperatura', 557.0000, 'ºC'),
	(281322, 121, '2014-04-01 01:25:44.000000', 'temperatura', 245.0000, 'ºC'),
	(281323, 121, '2014-04-01 01:25:45.000000', 'temperatura', 756.0000, 'ºC'),
	(281324, 121, '2014-04-01 01:25:46.000000', 'temperatura', 643.0000, 'ºC'),
	(281325, 121, '2014-04-01 01:25:47.000000', 'temperatura', 951.0000, 'ºC'),
	(281326, 121, '2014-04-01 01:25:48.000000', 'temperatura', 425.0000, 'ºC'),
	(281327, 121, '2014-04-01 01:25:49.000000', 'temperatura', 472.0000, 'ºC'),
	(281328, 121, '2014-04-01 01:25:50.000000', 'temperatura', 1084.0000, 'ºC'),
	(281329, 121, '2014-04-01 01:25:51.000000', 'temperatura', 406.0000, 'ºC'),
	(281330, 121, '2014-04-01 01:25:52.000000', 'temperatura', 1178.0000, 'ºC'),
	(281331, 121, '2014-04-01 01:25:53.000000', 'temperatura', 1072.0000, 'ºC'),
	(281332, 121, '2014-04-01 01:25:54.000000', 'temperatura', 629.0000, 'ºC'),
	(281333, 121, '2014-04-01 01:25:55.000000', 'temperatura', 1127.0000, 'ºC'),
	(281334, 121, '2014-04-01 01:25:56.000000', 'temperatura', 149.0000, 'ºC'),
	(281335, 121, '2014-04-01 01:25:57.000000', 'temperatura', 966.0000, 'ºC'),
	(281336, 121, '2014-04-01 01:25:58.000000', 'temperatura', 781.0000, 'ºC'),
	(281337, 121, '2014-04-01 01:25:59.000000', 'temperatura', 1008.0000, 'ºC'),
	(281338, 121, '2014-04-01 01:26:00.000000', 'temperatura', 297.0000, 'ºC'),
	(281339, 121, '2014-04-01 01:26:01.000000', 'temperatura', 861.0000, 'ºC'),
	(281340, 121, '2014-04-01 01:26:02.000000', 'temperatura', 1013.0000, 'ºC'),
	(281341, 121, '2014-04-01 01:26:03.000000', 'temperatura', 85.0000, 'ºC'),
	(281342, 121, '2014-04-01 01:26:04.000000', 'temperatura', 987.0000, 'ºC'),
	(281343, 121, '2014-04-01 01:26:05.000000', 'temperatura', 1079.0000, 'ºC'),
	(281344, 121, '2014-04-01 01:26:06.000000', 'temperatura', 36.0000, 'ºC'),
	(281345, 121, '2014-04-01 01:26:07.000000', 'temperatura', 543.0000, 'ºC'),
	(281346, 121, '2014-04-01 01:26:08.000000', 'temperatura', 206.0000, 'ºC'),
	(281347, 121, '2014-04-01 01:26:09.000000', 'temperatura', 603.0000, 'ºC'),
	(281348, 121, '2014-04-01 01:26:10.000000', 'temperatura', 1197.0000, 'ºC'),
	(281349, 121, '2014-04-01 01:26:11.000000', 'temperatura', 576.0000, 'ºC'),
	(281350, 121, '2014-04-01 01:26:12.000000', 'temperatura', 491.0000, 'ºC'),
	(281351, 121, '2014-04-01 01:26:13.000000', 'temperatura', 726.0000, 'ºC'),
	(281352, 121, '2014-04-01 01:26:14.000000', 'temperatura', 960.0000, 'ºC'),
	(281353, 121, '2014-04-01 01:26:15.000000', 'temperatura', 221.0000, 'ºC'),
	(281354, 121, '2014-04-01 01:26:16.000000', 'temperatura', 625.0000, 'ºC'),
	(281355, 121, '2014-04-01 01:26:17.000000', 'temperatura', 65.0000, 'ºC'),
	(281356, 121, '2014-04-01 01:26:18.000000', 'temperatura', 848.0000, 'ºC'),
	(281357, 121, '2014-04-01 01:26:19.000000', 'temperatura', 448.0000, 'ºC'),
	(281358, 121, '2014-04-01 01:26:20.000000', 'temperatura', 894.0000, 'ºC'),
	(281359, 121, '2014-04-01 01:26:21.000000', 'temperatura', 727.0000, 'ºC'),
	(281360, 121, '2014-04-01 01:26:22.000000', 'temperatura', 955.0000, 'ºC'),
	(281361, 121, '2014-04-01 01:26:23.000000', 'temperatura', 192.0000, 'ºC'),
	(281362, 121, '2014-04-01 01:26:24.000000', 'temperatura', 495.0000, 'ºC'),
	(281363, 121, '2014-04-01 01:26:25.000000', 'temperatura', 701.0000, 'ºC'),
	(281364, 121, '2014-04-01 01:26:26.000000', 'temperatura', 821.0000, 'ºC'),
	(281365, 121, '2014-04-01 01:26:27.000000', 'temperatura', 803.0000, 'ºC'),
	(281366, 121, '2014-04-01 01:26:28.000000', 'temperatura', 353.0000, 'ºC'),
	(281367, 121, '2014-04-01 01:26:29.000000', 'temperatura', 557.0000, 'ºC'),
	(281368, 121, '2014-04-01 01:26:30.000000', 'temperatura', 526.0000, 'ºC'),
	(281369, 121, '2014-04-01 01:26:31.000000', 'temperatura', 961.0000, 'ºC'),
	(281370, 121, '2014-04-01 01:26:32.000000', 'temperatura', 827.0000, 'ºC'),
	(281371, 121, '2014-04-01 01:26:33.000000', 'temperatura', 51.0000, 'ºC'),
	(281372, 121, '2014-04-01 01:26:34.000000', 'temperatura', 176.0000, 'ºC'),
	(281373, 121, '2014-04-01 01:26:35.000000', 'temperatura', 727.0000, 'ºC'),
	(281374, 121, '2014-04-01 01:26:36.000000', 'temperatura', 709.0000, 'ºC'),
	(281375, 121, '2014-04-01 01:26:37.000000', 'temperatura', 165.0000, 'ºC'),
	(281376, 121, '2014-04-01 01:26:38.000000', 'temperatura', 1100.0000, 'ºC'),
	(281377, 121, '2014-04-01 01:26:39.000000', 'temperatura', 202.0000, 'ºC'),
	(281378, 121, '2014-04-01 01:26:40.000000', 'temperatura', 110.0000, 'ºC'),
	(281379, 121, '2014-04-01 01:26:41.000000', 'temperatura', 1145.0000, 'ºC'),
	(281380, 121, '2014-04-01 01:26:42.000000', 'temperatura', 594.0000, 'ºC'),
	(281381, 121, '2014-04-01 01:26:43.000000', 'temperatura', 738.0000, 'ºC'),
	(281382, 121, '2014-04-01 01:26:44.000000', 'temperatura', 710.0000, 'ºC'),
	(281383, 121, '2014-04-01 01:26:45.000000', 'temperatura', 134.0000, 'ºC'),
	(281384, 121, '2014-04-01 01:26:46.000000', 'temperatura', 940.0000, 'ºC'),
	(281385, 121, '2014-04-01 01:26:47.000000', 'temperatura', 700.0000, 'ºC'),
	(281386, 121, '2014-04-01 01:26:48.000000', 'temperatura', 678.0000, 'ºC'),
	(281387, 121, '2014-04-01 01:26:49.000000', 'temperatura', 92.0000, 'ºC'),
	(281388, 121, '2014-04-01 01:26:50.000000', 'temperatura', 824.0000, 'ºC'),
	(281389, 121, '2014-04-01 01:26:51.000000', 'temperatura', 248.0000, 'ºC'),
	(281390, 121, '2014-04-01 01:26:52.000000', 'temperatura', 1167.0000, 'ºC'),
	(281391, 121, '2014-04-01 01:26:53.000000', 'temperatura', 290.0000, 'ºC'),
	(281392, 121, '2014-04-01 01:26:54.000000', 'temperatura', 349.0000, 'ºC'),
	(281393, 121, '2014-04-01 01:26:55.000000', 'temperatura', 876.0000, 'ºC'),
	(281394, 121, '2014-04-01 01:26:56.000000', 'temperatura', 933.0000, 'ºC'),
	(281395, 121, '2014-04-01 01:26:57.000000', 'temperatura', 837.0000, 'ºC'),
	(281396, 121, '2014-04-01 01:26:58.000000', 'temperatura', 189.0000, 'ºC'),
	(281397, 121, '2014-04-01 01:26:59.000000', 'temperatura', 834.0000, 'ºC'),
	(281398, 121, '2014-04-01 01:27:00.000000', 'temperatura', 3.0000, 'ºC'),
	(281399, 121, '2014-04-01 01:27:01.000000', 'temperatura', 1114.0000, 'ºC'),
	(281400, 121, '2014-04-01 01:27:02.000000', 'temperatura', 762.0000, 'ºC'),
	(281401, 121, '2014-04-01 01:27:03.000000', 'temperatura', 467.0000, 'ºC'),
	(281402, 121, '2014-04-01 01:27:04.000000', 'temperatura', 52.0000, 'ºC'),
	(281403, 121, '2014-04-01 01:27:05.000000', 'temperatura', 57.0000, 'ºC'),
	(281404, 121, '2014-04-01 01:27:06.000000', 'temperatura', 130.0000, 'ºC'),
	(281405, 121, '2014-04-01 01:27:07.000000', 'temperatura', 482.0000, 'ºC'),
	(281406, 121, '2014-04-01 01:27:08.000000', 'temperatura', 817.0000, 'ºC'),
	(281407, 121, '2014-04-01 01:27:09.000000', 'temperatura', 242.0000, 'ºC'),
	(281408, 121, '2014-04-01 01:27:10.000000', 'temperatura', 1159.0000, 'ºC'),
	(281409, 121, '2014-04-01 01:27:11.000000', 'temperatura', 271.0000, 'ºC'),
	(281410, 121, '2014-04-01 01:27:12.000000', 'temperatura', 277.0000, 'ºC'),
	(281411, 121, '2014-04-01 01:27:13.000000', 'temperatura', 574.0000, 'ºC'),
	(281412, 121, '2014-04-01 01:27:14.000000', 'temperatura', 839.0000, 'ºC'),
	(281413, 121, '2014-04-01 01:27:15.000000', 'temperatura', 73.0000, 'ºC'),
	(281414, 121, '2014-04-01 01:27:16.000000', 'temperatura', 251.0000, 'ºC'),
	(281415, 121, '2014-04-01 01:27:17.000000', 'temperatura', 1033.0000, 'ºC'),
	(281416, 121, '2014-04-01 01:27:18.000000', 'temperatura', 814.0000, 'ºC'),
	(281417, 121, '2014-04-01 01:27:19.000000', 'temperatura', 971.0000, 'ºC'),
	(281418, 121, '2014-04-01 01:27:20.000000', 'temperatura', 16.0000, 'ºC'),
	(281419, 121, '2014-04-01 01:27:21.000000', 'temperatura', 764.0000, 'ºC'),
	(281420, 121, '2014-04-01 01:27:22.000000', 'temperatura', 174.0000, 'ºC'),
	(281421, 121, '2014-04-01 01:27:23.000000', 'temperatura', 979.0000, 'ºC'),
	(281422, 121, '2014-04-01 01:27:24.000000', 'temperatura', 774.0000, 'ºC'),
	(281423, 121, '2014-04-01 01:27:25.000000', 'temperatura', 934.0000, 'ºC'),
	(281424, 121, '2014-04-01 01:27:26.000000', 'temperatura', 1146.0000, 'ºC'),
	(281425, 121, '2014-04-01 01:27:27.000000', 'temperatura', 529.0000, 'ºC'),
	(281426, 121, '2014-04-01 01:27:28.000000', 'temperatura', 408.0000, 'ºC'),
	(281427, 121, '2014-04-01 01:27:29.000000', 'temperatura', 454.0000, 'ºC'),
	(281428, 121, '2014-04-01 01:27:30.000000', 'temperatura', 1046.0000, 'ºC'),
	(281429, 121, '2014-04-01 01:27:31.000000', 'temperatura', 271.0000, 'ºC'),
	(281430, 121, '2014-04-01 01:27:32.000000', 'temperatura', 615.0000, 'ºC'),
	(281431, 121, '2014-04-01 01:27:33.000000', 'temperatura', 1062.0000, 'ºC'),
	(281432, 121, '2014-04-01 01:27:34.000000', 'temperatura', 1065.0000, 'ºC'),
	(281433, 121, '2014-04-01 01:27:35.000000', 'temperatura', 941.0000, 'ºC'),
	(281434, 121, '2014-04-01 01:27:36.000000', 'temperatura', 310.0000, 'ºC'),
	(281435, 121, '2014-04-01 01:27:37.000000', 'temperatura', 1127.0000, 'ºC'),
	(281436, 121, '2014-04-01 01:27:38.000000', 'temperatura', 1107.0000, 'ºC'),
	(281437, 121, '2014-04-01 01:27:39.000000', 'temperatura', 952.0000, 'ºC'),
	(281438, 121, '2014-04-01 01:27:40.000000', 'temperatura', 243.0000, 'ºC'),
	(281439, 121, '2014-04-01 01:27:41.000000', 'temperatura', 756.0000, 'ºC'),
	(281440, 121, '2014-04-01 01:27:42.000000', 'temperatura', 654.0000, 'ºC'),
	(281441, 121, '2014-04-01 01:27:43.000000', 'temperatura', 1002.0000, 'ºC'),
	(281442, 121, '2014-04-01 01:27:44.000000', 'temperatura', 647.0000, 'ºC'),
	(281443, 121, '2014-04-01 01:27:45.000000', 'temperatura', 230.0000, 'ºC'),
	(281444, 121, '2014-04-01 01:27:46.000000', 'temperatura', 410.0000, 'ºC'),
	(281445, 121, '2014-04-01 01:27:47.000000', 'temperatura', 161.0000, 'ºC'),
	(281446, 121, '2014-04-01 01:27:48.000000', 'temperatura', 777.0000, 'ºC'),
	(281447, 121, '2014-04-01 01:27:49.000000', 'temperatura', 1002.0000, 'ºC'),
	(281448, 121, '2014-04-01 01:27:50.000000', 'temperatura', 278.0000, 'ºC'),
	(281449, 121, '2014-04-01 01:27:51.000000', 'temperatura', 787.0000, 'ºC'),
	(281450, 121, '2014-04-01 01:27:52.000000', 'temperatura', 700.0000, 'ºC'),
	(281451, 121, '2014-04-01 01:27:53.000000', 'temperatura', 1138.0000, 'ºC'),
	(281452, 121, '2014-04-01 01:27:54.000000', 'temperatura', 1192.0000, 'ºC'),
	(281453, 121, '2014-04-01 01:27:55.000000', 'temperatura', 145.0000, 'ºC'),
	(281454, 121, '2014-04-01 01:27:56.000000', 'temperatura', 752.0000, 'ºC'),
	(281455, 121, '2014-04-01 01:27:57.000000', 'temperatura', 923.0000, 'ºC'),
	(281456, 121, '2014-04-01 01:27:58.000000', 'temperatura', 1161.0000, 'ºC'),
	(281457, 121, '2014-04-01 01:27:59.000000', 'temperatura', 636.0000, 'ºC'),
	(281458, 121, '2014-04-01 01:28:00.000000', 'temperatura', 897.0000, 'ºC'),
	(281459, 121, '2014-04-01 01:28:01.000000', 'temperatura', 176.0000, 'ºC'),
	(281460, 121, '2014-04-01 01:28:02.000000', 'temperatura', 591.0000, 'ºC'),
	(281461, 121, '2014-04-01 01:28:03.000000', 'temperatura', 28.0000, 'ºC'),
	(281462, 121, '2014-04-01 01:28:04.000000', 'temperatura', 769.0000, 'ºC'),
	(281463, 121, '2014-04-01 01:28:05.000000', 'temperatura', 160.0000, 'ºC'),
	(281464, 121, '2014-04-01 01:28:06.000000', 'temperatura', 892.0000, 'ºC'),
	(281465, 121, '2014-04-01 01:28:07.000000', 'temperatura', 384.0000, 'ºC'),
	(281466, 121, '2014-04-01 01:28:08.000000', 'temperatura', 441.0000, 'ºC'),
	(281467, 121, '2014-04-01 01:28:09.000000', 'temperatura', 1054.0000, 'ºC'),
	(281468, 121, '2014-04-01 01:28:10.000000', 'temperatura', 348.0000, 'ºC'),
	(281469, 121, '2014-04-01 01:28:11.000000', 'temperatura', 981.0000, 'ºC'),
	(281470, 121, '2014-04-01 01:28:12.000000', 'temperatura', 258.0000, 'ºC'),
	(281471, 121, '2014-04-01 01:28:13.000000', 'temperatura', 750.0000, 'ºC'),
	(281472, 121, '2014-04-01 01:28:14.000000', 'temperatura', 576.0000, 'ºC'),
	(281473, 121, '2014-04-01 01:28:15.000000', 'temperatura', 629.0000, 'ºC'),
	(281474, 121, '2014-04-01 01:28:16.000000', 'temperatura', 217.0000, 'ºC'),
	(281475, 121, '2014-04-01 01:28:17.000000', 'temperatura', 398.0000, 'ºC'),
	(281476, 121, '2014-04-01 01:28:18.000000', 'temperatura', 142.0000, 'ºC'),
	(281477, 121, '2014-04-01 01:28:19.000000', 'temperatura', 715.0000, 'ºC'),
	(281478, 121, '2014-04-01 01:28:20.000000', 'temperatura', 749.0000, 'ºC'),
	(281479, 121, '2014-04-01 01:28:21.000000', 'temperatura', 402.0000, 'ºC'),
	(281480, 121, '2014-04-01 01:28:22.000000', 'temperatura', 965.0000, 'ºC'),
	(281481, 121, '2014-04-01 01:28:23.000000', 'temperatura', 18.0000, 'ºC'),
	(281482, 121, '2014-04-01 01:28:24.000000', 'temperatura', 795.0000, 'ºC'),
	(281483, 121, '2014-04-01 01:28:25.000000', 'temperatura', 321.0000, 'ºC'),
	(281484, 121, '2014-04-01 01:28:26.000000', 'temperatura', 422.0000, 'ºC'),
	(281485, 121, '2014-04-01 01:28:27.000000', 'temperatura', 1148.0000, 'ºC'),
	(281486, 121, '2014-04-01 01:28:28.000000', 'temperatura', 875.0000, 'ºC'),
	(281487, 121, '2014-04-01 01:28:29.000000', 'temperatura', 931.0000, 'ºC'),
	(281488, 121, '2014-04-01 01:28:30.000000', 'temperatura', 832.0000, 'ºC'),
	(281489, 121, '2014-04-01 01:28:31.000000', 'temperatura', 166.0000, 'ºC'),
	(281490, 121, '2014-04-01 01:28:32.000000', 'temperatura', 734.0000, 'ºC'),
	(281491, 121, '2014-04-01 01:28:33.000000', 'temperatura', 772.0000, 'ºC'),
	(281492, 121, '2014-04-01 01:28:34.000000', 'temperatura', 457.0000, 'ºC'),
	(281493, 121, '2014-04-01 01:28:35.000000', 'temperatura', 1173.0000, 'ºC'),
	(281494, 121, '2014-04-01 01:28:36.000000', 'temperatura', 893.0000, 'ºC'),
	(281495, 121, '2014-04-01 01:28:37.000000', 'temperatura', 946.0000, 'ºC'),
	(281496, 121, '2014-04-01 01:28:38.000000', 'temperatura', 851.0000, 'ºC'),
	(281497, 121, '2014-04-01 01:28:39.000000', 'temperatura', 219.0000, 'ºC'),
	(281498, 121, '2014-04-01 01:28:40.000000', 'temperatura', 940.0000, 'ºC'),
	(281499, 121, '2014-04-01 01:28:41.000000', 'temperatura', 444.0000, 'ºC'),
	(281500, 121, '2014-04-01 01:28:42.000000', 'temperatura', 603.0000, 'ºC'),
	(281501, 121, '2014-04-01 01:28:43.000000', 'temperatura', 480.0000, 'ºC'),
	(281502, 121, '2014-04-01 01:28:44.000000', 'temperatura', 595.0000, 'ºC'),
	(281503, 121, '2014-04-01 01:28:45.000000', 'temperatura', 333.0000, 'ºC'),
	(281504, 121, '2014-04-01 01:28:46.000000', 'temperatura', 1083.0000, 'ºC'),
	(281505, 121, '2014-04-01 01:28:47.000000', 'temperatura', 814.0000, 'ºC'),
	(281506, 121, '2014-04-01 01:28:48.000000', 'temperatura', 823.0000, 'ºC'),
	(281507, 121, '2014-04-01 01:28:49.000000', 'temperatura', 472.0000, 'ºC'),
	(281508, 121, '2014-04-01 01:28:50.000000', 'temperatura', 1093.0000, 'ºC'),
	(281509, 121, '2014-04-01 01:28:51.000000', 'temperatura', 447.0000, 'ºC'),
	(281510, 121, '2014-04-01 01:28:52.000000', 'temperatura', 158.0000, 'ºC'),
	(281511, 121, '2014-04-01 01:28:53.000000', 'temperatura', 649.0000, 'ºC'),
	(281512, 121, '2014-04-01 01:28:54.000000', 'temperatura', 373.0000, 'ºC'),
	(281513, 121, '2014-04-01 01:28:55.000000', 'temperatura', 1117.0000, 'ºC'),
	(281514, 121, '2014-04-01 01:28:56.000000', 'temperatura', 866.0000, 'ºC'),
	(281515, 121, '2014-04-01 01:28:57.000000', 'temperatura', 979.0000, 'ºC'),
	(281516, 121, '2014-04-01 01:28:58.000000', 'temperatura', 1100.0000, 'ºC'),
	(281517, 121, '2014-04-01 01:28:59.000000', 'temperatura', 161.0000, 'ºC'),
	(281518, 121, '2014-04-01 01:29:00.000000', 'temperatura', 1108.0000, 'ºC'),
	(281519, 121, '2014-04-01 01:29:01.000000', 'temperatura', 257.0000, 'ºC'),
	(281520, 121, '2014-04-01 01:29:02.000000', 'temperatura', 359.0000, 'ºC'),
	(281521, 121, '2014-04-01 01:29:03.000000', 'temperatura', 1028.0000, 'ºC'),
	(281522, 121, '2014-04-01 01:29:04.000000', 'temperatura', 461.0000, 'ºC'),
	(281523, 121, '2014-04-01 01:29:05.000000', 'temperatura', 421.0000, 'ºC'),
	(281524, 121, '2014-04-01 01:29:06.000000', 'temperatura', 724.0000, 'ºC'),
	(281525, 121, '2014-04-01 01:29:07.000000', 'temperatura', 1159.0000, 'ºC'),
	(281526, 121, '2014-04-01 01:29:08.000000', 'temperatura', 21.0000, 'ºC'),
	(281527, 121, '2014-04-01 01:29:09.000000', 'temperatura', 231.0000, 'ºC'),
	(281528, 121, '2014-04-01 01:29:10.000000', 'temperatura', 1093.0000, 'ºC'),
	(281529, 121, '2014-04-01 01:29:11.000000', 'temperatura', 1170.0000, 'ºC'),
	(281530, 121, '2014-04-01 01:29:12.000000', 'temperatura', 173.0000, 'ºC'),
	(281531, 121, '2014-04-01 01:29:13.000000', 'temperatura', 953.0000, 'ºC'),
	(281532, 121, '2014-04-01 01:29:14.000000', 'temperatura', 648.0000, 'ºC'),
	(281533, 121, '2014-04-01 01:29:15.000000', 'temperatura', 383.0000, 'ºC'),
	(281534, 121, '2014-04-01 01:29:16.000000', 'temperatura', 1170.0000, 'ºC'),
	(281535, 121, '2014-04-01 01:29:17.000000', 'temperatura', 1101.0000, 'ºC'),
	(281536, 121, '2014-04-01 01:29:18.000000', 'temperatura', 794.0000, 'ºC'),
	(281537, 121, '2014-04-01 01:29:19.000000', 'temperatura', 670.0000, 'ºC'),
	(281538, 121, '2014-04-01 01:29:20.000000', 'temperatura', 966.0000, 'ºC'),
	(281539, 121, '2014-04-01 01:29:21.000000', 'temperatura', 422.0000, 'ºC'),
	(281540, 121, '2014-04-01 01:29:22.000000', 'temperatura', 411.0000, 'ºC'),
	(281541, 121, '2014-04-01 01:29:23.000000', 'temperatura', 792.0000, 'ºC'),
	(281542, 121, '2014-04-01 01:29:24.000000', 'temperatura', 327.0000, 'ºC'),
	(281543, 121, '2014-04-01 01:29:25.000000', 'temperatura', 460.0000, 'ºC'),
	(281544, 121, '2014-04-01 01:29:26.000000', 'temperatura', 120.0000, 'ºC'),
	(281545, 121, '2014-04-01 01:29:27.000000', 'temperatura', 418.0000, 'ºC'),
	(281546, 121, '2014-04-01 01:29:28.000000', 'temperatura', 530.0000, 'ºC'),
	(281547, 121, '2014-04-01 01:29:29.000000', 'temperatura', 198.0000, 'ºC'),
	(281548, 121, '2014-04-01 01:29:30.000000', 'temperatura', 602.0000, 'ºC'),
	(281549, 121, '2014-04-01 01:29:31.000000', 'temperatura', 16.0000, 'ºC'),
	(281550, 121, '2014-04-01 01:29:32.000000', 'temperatura', 673.0000, 'ºC'),
	(281551, 121, '2014-04-01 01:29:33.000000', 'temperatura', 919.0000, 'ºC'),
	(281552, 121, '2014-04-01 01:29:34.000000', 'temperatura', 178.0000, 'ºC'),
	(281553, 121, '2014-04-01 01:29:35.000000', 'temperatura', 532.0000, 'ºC'),
	(281554, 121, '2014-04-01 01:29:36.000000', 'temperatura', 926.0000, 'ºC'),
	(281555, 121, '2014-04-01 01:29:37.000000', 'temperatura', 635.0000, 'ºC'),
	(281556, 121, '2014-04-01 01:29:38.000000', 'temperatura', 399.0000, 'ºC'),
	(281557, 121, '2014-04-01 01:29:39.000000', 'temperatura', 90.0000, 'ºC'),
	(281558, 121, '2014-04-01 01:29:40.000000', 'temperatura', 455.0000, 'ºC'),
	(281559, 121, '2014-04-01 01:29:41.000000', 'temperatura', 803.0000, 'ºC'),
	(281560, 121, '2014-04-01 01:29:42.000000', 'temperatura', 249.0000, 'ºC'),
	(281561, 121, '2014-04-01 01:29:43.000000', 'temperatura', 40.0000, 'ºC'),
	(281562, 121, '2014-04-01 01:29:44.000000', 'temperatura', 651.0000, 'ºC'),
	(281563, 121, '2014-04-01 01:29:45.000000', 'temperatura', 735.0000, 'ºC'),
	(281564, 121, '2014-04-01 01:29:46.000000', 'temperatura', 523.0000, 'ºC'),
	(281565, 121, '2014-04-01 01:29:47.000000', 'temperatura', 409.0000, 'ºC'),
	(281566, 121, '2014-04-01 01:29:48.000000', 'temperatura', 477.0000, 'ºC'),
	(281567, 121, '2014-04-01 01:29:49.000000', 'temperatura', 1161.0000, 'ºC'),
	(281568, 121, '2014-04-01 01:29:50.000000', 'temperatura', 774.0000, 'ºC'),
	(281569, 121, '2014-04-01 01:29:51.000000', 'temperatura', 385.0000, 'ºC'),
	(281570, 121, '2014-04-01 01:29:52.000000', 'temperatura', 807.0000, 'ºC'),
	(281571, 121, '2014-04-01 01:29:53.000000', 'temperatura', 479.0000, 'ºC'),
	(281572, 121, '2014-04-01 01:29:54.000000', 'temperatura', 1173.0000, 'ºC'),
	(281573, 121, '2014-04-01 01:29:55.000000', 'temperatura', 830.0000, 'ºC'),
	(281574, 121, '2014-04-01 01:29:56.000000', 'temperatura', 631.0000, 'ºC'),
	(281575, 121, '2014-04-01 01:29:57.000000', 'temperatura', 666.0000, 'ºC'),
	(281576, 121, '2014-04-01 01:29:58.000000', 'temperatura', 237.0000, 'ºC'),
	(281577, 121, '2014-04-01 01:29:59.000000', 'temperatura', 386.0000, 'ºC'),
	(281578, 121, '2014-04-01 01:30:00.000000', 'temperatura', 22.0000, 'ºC'),
	(281579, 121, '2014-04-01 01:30:01.000000', 'temperatura', 152.0000, 'ºC'),
	(281580, 121, '2014-04-01 01:30:02.000000', 'temperatura', 696.0000, 'ºC'),
	(281581, 121, '2014-04-01 01:30:03.000000', 'temperatura', 624.0000, 'ºC'),
	(281582, 121, '2014-04-01 01:30:04.000000', 'temperatura', 1034.0000, 'ºC'),
	(281583, 121, '2014-04-01 01:30:05.000000', 'temperatura', 896.0000, 'ºC'),
	(281584, 121, '2014-04-01 01:30:06.000000', 'temperatura', 179.0000, 'ºC'),
	(281585, 121, '2014-04-01 01:30:07.000000', 'temperatura', 606.0000, 'ºC'),
	(281586, 121, '2014-04-01 01:30:08.000000', 'temperatura', 96.0000, 'ºC'),
	(281587, 121, '2014-04-01 01:30:09.000000', 'temperatura', 1060.0000, 'ºC'),
	(281588, 121, '2014-04-01 01:30:10.000000', 'temperatura', 214.0000, 'ºC'),
	(281589, 121, '2014-04-01 01:30:11.000000', 'temperatura', 289.0000, 'ºC'),
	(281590, 121, '2014-04-01 01:30:12.000000', 'temperatura', 804.0000, 'ºC'),
	(281591, 121, '2014-04-01 01:30:13.000000', 'temperatura', 753.0000, 'ºC'),
	(281592, 121, '2014-04-01 01:30:14.000000', 'temperatura', 152.0000, 'ºC'),
	(281593, 121, '2014-04-01 01:30:15.000000', 'temperatura', 904.0000, 'ºC'),
	(281594, 121, '2014-04-01 01:30:16.000000', 'temperatura', 465.0000, 'ºC'),
	(281595, 121, '2014-04-01 01:30:17.000000', 'temperatura', 811.0000, 'ºC'),
	(281596, 121, '2014-04-01 01:30:18.000000', 'temperatura', 262.0000, 'ºC'),
	(281597, 121, '2014-04-01 01:30:19.000000', 'temperatura', 78.0000, 'ºC'),
	(281598, 121, '2014-04-01 01:30:20.000000', 'temperatura', 803.0000, 'ºC'),
	(281599, 121, '2014-04-01 01:30:21.000000', 'temperatura', 182.0000, 'ºC'),
	(281600, 121, '2014-04-01 01:30:22.000000', 'temperatura', 903.0000, 'ºC'),
	(281601, 121, '2014-04-01 01:30:23.000000', 'temperatura', 368.0000, 'ºC'),
	(281602, 121, '2014-04-01 01:30:24.000000', 'temperatura', 332.0000, 'ºC'),
	(281603, 121, '2014-04-01 01:30:25.000000', 'temperatura', 556.0000, 'ºC'),
	(281604, 121, '2014-04-01 01:30:26.000000', 'temperatura', 584.0000, 'ºC'),
	(281605, 121, '2014-04-01 01:30:27.000000', 'temperatura', 52.0000, 'ºC'),
	(281606, 121, '2014-04-01 01:30:28.000000', 'temperatura', 908.0000, 'ºC'),
	(281607, 121, '2014-04-01 01:30:29.000000', 'temperatura', 785.0000, 'ºC'),
	(281608, 121, '2014-04-01 01:30:30.000000', 'temperatura', 1.0000, 'ºC'),
	(281609, 121, '2014-04-01 01:30:31.000000', 'temperatura', 53.0000, 'ºC'),
	(281610, 121, '2014-04-01 01:30:32.000000', 'temperatura', 259.0000, 'ºC'),
	(281611, 121, '2014-04-01 01:30:33.000000', 'temperatura', 1139.0000, 'ºC'),
	(281612, 121, '2014-04-01 01:30:34.000000', 'temperatura', 118.0000, 'ºC'),
	(281613, 121, '2014-04-01 01:30:35.000000', 'temperatura', 775.0000, 'ºC'),
	(281614, 121, '2014-04-01 01:30:36.000000', 'temperatura', 1119.0000, 'ºC'),
	(281615, 121, '2014-04-01 01:30:37.000000', 'temperatura', 872.0000, 'ºC'),
	(281616, 121, '2014-04-01 01:30:38.000000', 'temperatura', 1001.0000, 'ºC'),
	(281617, 121, '2014-04-01 01:30:39.000000', 'temperatura', 1191.0000, 'ºC'),
	(281618, 121, '2014-04-01 01:30:40.000000', 'temperatura', 552.0000, 'ºC'),
	(281619, 121, '2014-04-01 01:30:41.000000', 'temperatura', 386.0000, 'ºC'),
	(281620, 121, '2014-04-01 01:30:42.000000', 'temperatura', 277.0000, 'ºC'),
	(281621, 121, '2014-04-01 01:30:43.000000', 'temperatura', 228.0000, 'ºC'),
	(281622, 121, '2014-04-01 01:30:44.000000', 'temperatura', 309.0000, 'ºC'),
	(281623, 121, '2014-04-01 01:30:45.000000', 'temperatura', 861.0000, 'ºC'),
	(281624, 121, '2014-04-01 01:30:46.000000', 'temperatura', 978.0000, 'ºC'),
	(281625, 121, '2014-04-01 01:30:47.000000', 'temperatura', 1106.0000, 'ºC'),
	(281626, 121, '2014-04-01 01:30:48.000000', 'temperatura', 200.0000, 'ºC'),
	(281627, 121, '2014-04-01 01:30:49.000000', 'temperatura', 81.0000, 'ºC'),
	(281628, 121, '2014-04-01 01:30:50.000000', 'temperatura', 1005.0000, 'ºC'),
	(281629, 121, '2014-04-01 01:30:51.000000', 'temperatura', 1182.0000, 'ºC'),
	(281630, 121, '2014-04-01 01:30:52.000000', 'temperatura', 495.0000, 'ºC'),
	(281631, 121, '2014-04-01 01:30:53.000000', 'temperatura', 129.0000, 'ºC'),
	(281632, 121, '2014-04-01 01:30:54.000000', 'temperatura', 363.0000, 'ºC'),
	(281633, 121, '2014-04-01 01:30:55.000000', 'temperatura', 225.0000, 'ºC'),
	(281634, 121, '2014-04-01 01:30:56.000000', 'temperatura', 40.0000, 'ºC'),
	(281635, 121, '2014-04-01 01:30:57.000000', 'temperatura', 724.0000, 'ºC'),
	(281636, 121, '2014-04-01 01:30:58.000000', 'temperatura', 1102.0000, 'ºC'),
	(281637, 121, '2014-04-01 01:30:59.000000', 'temperatura', 937.0000, 'ºC'),
	(281638, 121, '2014-04-01 01:31:00.000000', 'temperatura', 181.0000, 'ºC'),
	(281639, 121, '2014-04-01 01:31:01.000000', 'temperatura', 492.0000, 'ºC'),
	(281640, 121, '2014-04-01 01:31:02.000000', 'temperatura', 718.0000, 'ºC'),
	(281641, 121, '2014-04-01 01:31:03.000000', 'temperatura', 913.0000, 'ºC'),
	(281642, 121, '2014-04-01 01:31:04.000000', 'temperatura', 15.0000, 'ºC'),
	(281643, 121, '2014-04-01 01:31:05.000000', 'temperatura', 934.0000, 'ºC'),
	(281644, 121, '2014-04-01 01:31:06.000000', 'temperatura', 1025.0000, 'ºC'),
	(281645, 121, '2014-04-01 01:31:07.000000', 'temperatura', 1123.0000, 'ºC'),
	(281646, 121, '2014-04-01 01:31:08.000000', 'temperatura', 141.0000, 'ºC'),
	(281647, 121, '2014-04-01 01:31:09.000000', 'temperatura', 938.0000, 'ºC'),
	(281648, 121, '2014-04-01 01:31:10.000000', 'temperatura', 666.0000, 'ºC'),
	(281649, 121, '2014-04-01 01:31:11.000000', 'temperatura', 517.0000, 'ºC'),
	(281650, 121, '2014-04-01 01:31:12.000000', 'temperatura', 586.0000, 'ºC'),
	(281651, 121, '2014-04-01 01:31:13.000000', 'temperatura', 179.0000, 'ºC'),
	(281652, 121, '2014-04-01 01:31:14.000000', 'temperatura', 340.0000, 'ºC'),
	(281653, 121, '2014-04-01 01:31:15.000000', 'temperatura', 1161.0000, 'ºC'),
	(281654, 121, '2014-04-01 01:31:16.000000', 'temperatura', 1187.0000, 'ºC'),
	(281655, 121, '2014-04-01 01:31:17.000000', 'temperatura', 53.0000, 'ºC'),
	(281656, 121, '2014-04-01 01:31:18.000000', 'temperatura', 306.0000, 'ºC'),
	(281657, 121, '2014-04-01 01:31:19.000000', 'temperatura', 168.0000, 'ºC'),
	(281658, 121, '2014-04-01 01:31:20.000000', 'temperatura', 1126.0000, 'ºC'),
	(281659, 121, '2014-04-01 01:31:21.000000', 'temperatura', 325.0000, 'ºC'),
	(281660, 121, '2014-04-01 01:31:22.000000', 'temperatura', 647.0000, 'ºC'),
	(281661, 121, '2014-04-01 01:31:23.000000', 'temperatura', 1062.0000, 'ºC'),
	(281662, 121, '2014-04-01 01:31:24.000000', 'temperatura', 970.0000, 'ºC'),
	(281663, 121, '2014-04-01 01:31:25.000000', 'temperatura', 462.0000, 'ºC'),
	(281664, 121, '2014-04-01 01:31:26.000000', 'temperatura', 600.0000, 'ºC'),
	(281665, 121, '2014-04-01 01:31:27.000000', 'temperatura', 415.0000, 'ºC'),
	(281666, 121, '2014-04-01 01:31:28.000000', 'temperatura', 277.0000, 'ºC'),
	(281667, 121, '2014-04-01 01:31:29.000000', 'temperatura', 139.0000, 'ºC'),
	(281668, 121, '2014-04-01 01:31:30.000000', 'temperatura', 1065.0000, 'ºC'),
	(281669, 121, '2014-04-01 01:31:31.000000', 'temperatura', 110.0000, 'ºC'),
	(281670, 121, '2014-04-01 01:31:32.000000', 'temperatura', 954.0000, 'ºC'),
	(281671, 121, '2014-04-01 01:31:33.000000', 'temperatura', 840.0000, 'ºC'),
	(281672, 121, '2014-04-01 01:31:34.000000', 'temperatura', 139.0000, 'ºC'),
	(281673, 121, '2014-04-01 01:31:35.000000', 'temperatura', 574.0000, 'ºC'),
	(281674, 121, '2014-04-01 01:31:36.000000', 'temperatura', 55.0000, 'ºC'),
	(281675, 121, '2014-04-01 01:31:37.000000', 'temperatura', 951.0000, 'ºC'),
	(281676, 121, '2014-04-01 01:31:38.000000', 'temperatura', 992.0000, 'ºC'),
	(281677, 121, '2014-04-01 01:31:39.000000', 'temperatura', 909.0000, 'ºC'),
	(281678, 121, '2014-04-01 01:31:40.000000', 'temperatura', 369.0000, 'ºC'),
	(281679, 121, '2014-04-01 01:31:41.000000', 'temperatura', 319.0000, 'ºC'),
	(281680, 121, '2014-04-01 01:31:42.000000', 'temperatura', 486.0000, 'ºC'),
	(281681, 121, '2014-04-01 01:31:43.000000', 'temperatura', 276.0000, 'ºC'),
	(281682, 121, '2014-04-01 01:31:44.000000', 'temperatura', 1120.0000, 'ºC'),
	(281683, 121, '2014-04-01 01:31:45.000000', 'temperatura', 1172.0000, 'ºC'),
	(281684, 121, '2014-04-01 01:31:46.000000', 'temperatura', 103.0000, 'ºC'),
	(281685, 121, '2014-04-01 01:31:47.000000', 'temperatura', 600.0000, 'ºC'),
	(281686, 121, '2014-04-01 01:31:48.000000', 'temperatura', 290.0000, 'ºC'),
	(281687, 121, '2014-04-01 01:31:49.000000', 'temperatura', 852.0000, 'ºC'),
	(281688, 121, '2014-04-01 01:31:50.000000', 'temperatura', 992.0000, 'ºC'),
	(281689, 121, '2014-04-01 01:31:51.000000', 'temperatura', 2.0000, 'ºC'),
	(281690, 121, '2014-04-01 01:31:52.000000', 'temperatura', 634.0000, 'ºC'),
	(281691, 121, '2014-04-01 01:31:53.000000', 'temperatura', 765.0000, 'ºC'),
	(281692, 121, '2014-04-01 01:31:54.000000', 'temperatura', 723.0000, 'ºC'),
	(281693, 121, '2014-04-01 01:31:55.000000', 'temperatura', 120.0000, 'ºC'),
	(281694, 121, '2014-04-01 01:31:56.000000', 'temperatura', 832.0000, 'ºC'),
	(281695, 121, '2014-04-01 01:31:57.000000', 'temperatura', 200.0000, 'ºC'),
	(281696, 121, '2014-04-01 01:31:58.000000', 'temperatura', 906.0000, 'ºC'),
	(281697, 121, '2014-04-01 01:31:59.000000', 'temperatura', 330.0000, 'ºC'),
	(281698, 121, '2014-04-01 01:32:00.000000', 'temperatura', 134.0000, 'ºC'),
	(281699, 121, '2014-04-01 01:32:01.000000', 'temperatura', 878.0000, 'ºC'),
	(281700, 121, '2014-04-01 01:32:02.000000', 'temperatura', 388.0000, 'ºC'),
	(281701, 121, '2014-04-01 01:32:03.000000', 'temperatura', 507.0000, 'ºC'),
	(281702, 121, '2014-04-01 01:32:04.000000', 'temperatura', 173.0000, 'ºC'),
	(281703, 121, '2014-04-01 01:32:05.000000', 'temperatura', 545.0000, 'ºC'),
	(281704, 121, '2014-04-01 01:32:06.000000', 'temperatura', 1007.0000, 'ºC'),
	(281705, 121, '2014-04-01 01:32:07.000000', 'temperatura', 999.0000, 'ºC'),
	(281706, 121, '2014-04-01 01:32:08.000000', 'temperatura', 774.0000, 'ºC'),
	(281707, 121, '2014-04-01 01:32:09.000000', 'temperatura', 875.0000, 'ºC'),
	(281708, 121, '2014-04-01 01:32:10.000000', 'temperatura', 855.0000, 'ºC'),
	(281709, 121, '2014-04-01 01:32:11.000000', 'temperatura', 448.0000, 'ºC'),
	(281710, 121, '2014-04-01 01:32:12.000000', 'temperatura', 877.0000, 'ºC'),
	(281711, 121, '2014-04-01 01:32:13.000000', 'temperatura', 643.0000, 'ºC'),
	(281712, 121, '2014-04-01 01:32:14.000000', 'temperatura', 583.0000, 'ºC'),
	(281713, 121, '2014-04-01 01:32:15.000000', 'temperatura', 985.0000, 'ºC'),
	(281714, 121, '2014-04-01 01:32:16.000000', 'temperatura', 778.0000, 'ºC'),
	(281715, 121, '2014-04-01 01:32:17.000000', 'temperatura', 934.0000, 'ºC'),
	(281716, 121, '2014-04-01 01:32:18.000000', 'temperatura', 1138.0000, 'ºC'),
	(281717, 121, '2014-04-01 01:32:19.000000', 'temperatura', 487.0000, 'ºC'),
	(281718, 121, '2014-04-01 01:32:20.000000', 'temperatura', 221.0000, 'ºC'),
	(281719, 121, '2014-04-01 01:32:21.000000', 'temperatura', 845.0000, 'ºC'),
	(281720, 121, '2014-04-01 01:32:22.000000', 'temperatura', 1162.0000, 'ºC'),
	(281721, 121, '2014-04-01 01:32:23.000000', 'temperatura', 878.0000, 'ºC'),
	(281722, 121, '2014-04-01 01:32:24.000000', 'temperatura', 901.0000, 'ºC'),
	(281723, 121, '2014-04-01 01:32:25.000000', 'temperatura', 675.0000, 'ºC'),
	(281724, 121, '2014-04-01 01:32:26.000000', 'temperatura', 671.0000, 'ºC'),
	(281725, 121, '2014-04-01 01:32:27.000000', 'temperatura', 129.0000, 'ºC'),
	(281726, 121, '2014-04-01 01:32:28.000000', 'temperatura', 1034.0000, 'ºC'),
	(281727, 121, '2014-04-01 01:32:29.000000', 'temperatura', 1184.0000, 'ºC'),
	(281728, 121, '2014-04-01 01:32:30.000000', 'temperatura', 418.0000, 'ºC'),
	(281729, 121, '2014-04-01 01:32:31.000000', 'temperatura', 940.0000, 'ºC'),
	(281730, 121, '2014-04-01 01:32:32.000000', 'temperatura', 1045.0000, 'ºC'),
	(281731, 121, '2014-04-01 01:32:33.000000', 'temperatura', 5.0000, 'ºC'),
	(281732, 121, '2014-04-01 01:32:34.000000', 'temperatura', 492.0000, 'ºC'),
	(281733, 121, '2014-04-01 01:32:35.000000', 'temperatura', 43.0000, 'ºC'),
	(281734, 121, '2014-04-01 01:32:36.000000', 'temperatura', 1140.0000, 'ºC'),
	(281735, 121, '2014-04-01 01:32:37.000000', 'temperatura', 771.0000, 'ºC'),
	(281736, 121, '2014-04-01 01:32:38.000000', 'temperatura', 436.0000, 'ºC'),
	(281737, 121, '2014-04-01 01:32:39.000000', 'temperatura', 1066.0000, 'ºC'),
	(281738, 121, '2014-04-01 01:32:40.000000', 'temperatura', 426.0000, 'ºC'),
	(281739, 121, '2014-04-01 01:32:41.000000', 'temperatura', 129.0000, 'ºC'),
	(281740, 121, '2014-04-01 01:32:42.000000', 'temperatura', 569.0000, 'ºC'),
	(281741, 121, '2014-04-01 01:32:43.000000', 'temperatura', 56.0000, 'ºC'),
	(281742, 121, '2014-04-01 01:32:44.000000', 'temperatura', 976.0000, 'ºC'),
	(281743, 121, '2014-04-01 01:32:45.000000', 'temperatura', 1113.0000, 'ºC'),
	(281744, 121, '2014-04-01 01:32:46.000000', 'temperatura', 236.0000, 'ºC'),
	(281745, 121, '2014-04-01 01:32:47.000000', 'temperatura', 241.0000, 'ºC'),
	(281746, 121, '2014-04-01 01:32:48.000000', 'temperatura', 497.0000, 'ºC'),
	(281747, 121, '2014-04-01 01:32:49.000000', 'temperatura', 565.0000, 'ºC'),
	(281748, 121, '2014-04-01 01:32:50.000000', 'temperatura', 132.0000, 'ºC'),
	(281749, 121, '2014-04-01 01:32:51.000000', 'temperatura', 166.0000, 'ºC'),
	(281750, 121, '2014-04-01 01:32:52.000000', 'temperatura', 436.0000, 'ºC'),
	(281751, 121, '2014-04-01 01:32:53.000000', 'temperatura', 480.0000, 'ºC'),
	(281752, 121, '2014-04-01 01:32:54.000000', 'temperatura', 1094.0000, 'ºC'),
	(281753, 121, '2014-04-01 01:32:55.000000', 'temperatura', 432.0000, 'ºC'),
	(281754, 121, '2014-04-01 01:32:56.000000', 'temperatura', 76.0000, 'ºC'),
	(281755, 121, '2014-04-01 01:32:57.000000', 'temperatura', 284.0000, 'ºC'),
	(281756, 121, '2014-04-01 01:32:58.000000', 'temperatura', 1192.0000, 'ºC'),
	(281757, 121, '2014-04-01 01:32:59.000000', 'temperatura', 310.0000, 'ºC'),
	(281758, 121, '2014-04-01 01:33:00.000000', 'temperatura', 373.0000, 'ºC'),
	(281759, 121, '2014-04-01 01:33:01.000000', 'temperatura', 937.0000, 'ºC'),
	(281760, 121, '2014-04-01 01:33:02.000000', 'temperatura', 1164.0000, 'ºC'),
	(281761, 121, '2014-04-01 01:33:03.000000', 'temperatura', 611.0000, 'ºC'),
	(281762, 121, '2014-04-01 01:33:04.000000', 'temperatura', 765.0000, 'ºC'),
	(281763, 121, '2014-04-01 01:33:05.000000', 'temperatura', 794.0000, 'ºC'),
	(281764, 121, '2014-04-01 01:33:06.000000', 'temperatura', 472.0000, 'ºC'),
	(281765, 121, '2014-04-01 01:33:07.000000', 'temperatura', 1178.0000, 'ºC'),
	(281766, 121, '2014-04-01 01:33:08.000000', 'temperatura', 877.0000, 'ºC'),
	(281767, 121, '2014-04-01 01:33:09.000000', 'temperatura', 850.0000, 'ºC'),
	(281768, 121, '2014-04-01 01:33:10.000000', 'temperatura', 420.0000, 'ºC'),
	(281769, 121, '2014-04-01 01:33:11.000000', 'temperatura', 752.0000, 'ºC'),
	(281770, 121, '2014-04-01 01:33:12.000000', 'temperatura', 98.0000, 'ºC'),
	(281771, 121, '2014-04-01 01:33:13.000000', 'temperatura', 634.0000, 'ºC'),
	(281772, 121, '2014-04-01 01:33:14.000000', 'temperatura', 475.0000, 'ºC'),
	(281773, 121, '2014-04-01 01:33:15.000000', 'temperatura', 477.0000, 'ºC'),
	(281774, 121, '2014-04-01 01:33:16.000000', 'temperatura', 961.0000, 'ºC'),
	(281775, 121, '2014-04-01 01:33:17.000000', 'temperatura', 972.0000, 'ºC'),
	(281776, 121, '2014-04-01 01:33:18.000000', 'temperatura', 781.0000, 'ºC'),
	(281777, 121, '2014-04-01 01:33:19.000000', 'temperatura', 986.0000, 'ºC'),
	(281778, 121, '2014-04-01 01:33:20.000000', 'temperatura', 188.0000, 'ºC'),
	(281779, 121, '2014-04-01 01:33:21.000000', 'temperatura', 382.0000, 'ºC'),
	(281780, 121, '2014-04-01 01:33:22.000000', 'temperatura', 149.0000, 'ºC'),
	(281781, 121, '2014-04-01 01:33:23.000000', 'temperatura', 798.0000, 'ºC'),
	(281782, 121, '2014-04-01 01:33:24.000000', 'temperatura', 1145.0000, 'ºC'),
	(281783, 121, '2014-04-01 01:33:25.000000', 'temperatura', 932.0000, 'ºC'),
	(281784, 121, '2014-04-01 01:33:26.000000', 'temperatura', 24.0000, 'ºC'),
	(281785, 121, '2014-04-01 01:33:27.000000', 'temperatura', 926.0000, 'ºC'),
	(281786, 121, '2014-04-01 01:33:28.000000', 'temperatura', 957.0000, 'ºC'),
	(281787, 121, '2014-04-01 01:33:29.000000', 'temperatura', 807.0000, 'ºC'),
	(281788, 121, '2014-04-01 01:33:30.000000', 'temperatura', 1166.0000, 'ºC'),
	(281789, 121, '2014-04-01 01:33:31.000000', 'temperatura', 1010.0000, 'ºC'),
	(281790, 121, '2014-04-01 01:33:32.000000', 'temperatura', 350.0000, 'ºC'),
	(281791, 121, '2014-04-01 01:33:33.000000', 'temperatura', 1124.0000, 'ºC'),
	(281792, 121, '2014-04-01 01:33:34.000000', 'temperatura', 968.0000, 'ºC'),
	(281793, 121, '2014-04-01 01:33:35.000000', 'temperatura', 268.0000, 'ºC'),
	(281794, 121, '2014-04-01 01:33:36.000000', 'temperatura', 837.0000, 'ºC'),
	(281795, 121, '2014-04-01 01:33:37.000000', 'temperatura', 983.0000, 'ºC'),
	(281796, 121, '2014-04-01 01:33:38.000000', 'temperatura', 2.0000, 'ºC'),
	(281797, 121, '2014-04-01 01:33:39.000000', 'temperatura', 662.0000, 'ºC'),
	(281798, 121, '2014-04-01 01:33:40.000000', 'temperatura', 903.0000, 'ºC'),
	(281799, 121, '2014-04-01 01:33:41.000000', 'temperatura', 132.0000, 'ºC'),
	(281800, 121, '2014-04-01 01:33:42.000000', 'temperatura', 350.0000, 'ºC'),
	(281801, 121, '2014-04-01 01:33:43.000000', 'temperatura', 156.0000, 'ºC'),
	(281802, 121, '2014-04-01 01:33:44.000000', 'temperatura', 930.0000, 'ºC'),
	(281803, 121, '2014-04-01 01:33:45.000000', 'temperatura', 583.0000, 'ºC'),
	(281804, 121, '2014-04-01 01:33:46.000000', 'temperatura', 127.0000, 'ºC'),
	(281805, 121, '2014-04-01 01:33:47.000000', 'temperatura', 84.0000, 'ºC'),
	(281806, 121, '2014-04-01 01:33:48.000000', 'temperatura', 40.0000, 'ºC'),
	(281807, 121, '2014-04-01 01:33:49.000000', 'temperatura', 1149.0000, 'ºC'),
	(281808, 121, '2014-04-01 01:33:50.000000', 'temperatura', 823.0000, 'ºC'),
	(281809, 121, '2014-04-01 01:33:51.000000', 'temperatura', 672.0000, 'ºC'),
	(281810, 121, '2014-04-01 01:33:52.000000', 'temperatura', 888.0000, 'ºC'),
	(281811, 121, '2014-04-01 01:33:53.000000', 'temperatura', 28.0000, 'ºC'),
	(281812, 121, '2014-04-01 01:33:54.000000', 'temperatura', 1074.0000, 'ºC'),
	(281813, 121, '2014-04-01 01:33:55.000000', 'temperatura', 487.0000, 'ºC'),
	(281814, 121, '2014-04-01 01:33:56.000000', 'temperatura', 414.0000, 'ºC'),
	(281815, 121, '2014-04-01 01:33:57.000000', 'temperatura', 611.0000, 'ºC'),
	(281816, 121, '2014-04-01 01:33:58.000000', 'temperatura', 611.0000, 'ºC'),
	(281817, 121, '2014-04-01 01:33:59.000000', 'temperatura', 23.0000, 'ºC'),
	(281818, 121, '2014-04-01 01:34:00.000000', 'temperatura', 681.0000, 'ºC'),
	(281819, 121, '2014-04-01 01:34:01.000000', 'temperatura', 939.0000, 'ºC'),
	(281820, 121, '2014-04-01 01:34:02.000000', 'temperatura', 252.0000, 'ºC'),
	(281821, 121, '2014-04-01 01:34:03.000000', 'temperatura', 843.0000, 'ºC'),
	(281822, 121, '2014-04-01 01:34:04.000000', 'temperatura', 1059.0000, 'ºC'),
	(281823, 121, '2014-04-01 01:34:05.000000', 'temperatura', 369.0000, 'ºC'),
	(281824, 121, '2014-04-01 01:34:06.000000', 'temperatura', 1066.0000, 'ºC'),
	(281825, 121, '2014-04-01 01:34:07.000000', 'temperatura', 623.0000, 'ºC'),
	(281826, 121, '2014-04-01 01:34:08.000000', 'temperatura', 1118.0000, 'ºC'),
	(281827, 121, '2014-04-01 01:34:09.000000', 'temperatura', 122.0000, 'ºC'),
	(281828, 121, '2014-04-01 01:34:10.000000', 'temperatura', 857.0000, 'ºC'),
	(281829, 121, '2014-04-01 01:34:11.000000', 'temperatura', 321.0000, 'ºC'),
	(281830, 121, '2014-04-01 01:34:12.000000', 'temperatura', 232.0000, 'ºC'),
	(281831, 121, '2014-04-01 01:34:13.000000', 'temperatura', 198.0000, 'ºC'),
	(281832, 121, '2014-04-01 01:34:14.000000', 'temperatura', 293.0000, 'ºC'),
	(281833, 121, '2014-04-01 01:34:15.000000', 'temperatura', 871.0000, 'ºC'),
	(281834, 121, '2014-04-01 01:34:16.000000', 'temperatura', 1077.0000, 'ºC'),
	(281835, 121, '2014-04-01 01:34:17.000000', 'temperatura', 375.0000, 'ºC'),
	(281836, 121, '2014-04-01 01:34:18.000000', 'temperatura', 1042.0000, 'ºC'),
	(281837, 121, '2014-04-01 01:34:19.000000', 'temperatura', 486.0000, 'ºC'),
	(281838, 121, '2014-04-01 01:34:20.000000', 'temperatura', 505.0000, 'ºC'),
	(281839, 121, '2014-04-01 01:34:21.000000', 'temperatura', 1067.0000, 'ºC'),
	(281840, 121, '2014-04-01 01:34:22.000000', 'temperatura', 219.0000, 'ºC'),
	(281841, 121, '2014-04-01 01:34:23.000000', 'temperatura', 297.0000, 'ºC'),
	(281842, 121, '2014-04-01 01:34:24.000000', 'temperatura', 826.0000, 'ºC'),
	(281843, 121, '2014-04-01 01:34:25.000000', 'temperatura', 843.0000, 'ºC'),
	(281844, 121, '2014-04-01 01:34:26.000000', 'temperatura', 534.0000, 'ºC'),
	(281845, 121, '2014-04-01 01:34:27.000000', 'temperatura', 144.0000, 'ºC'),
	(281846, 121, '2014-04-01 01:34:28.000000', 'temperatura', 317.0000, 'ºC'),
	(281847, 121, '2014-04-01 01:34:29.000000', 'temperatura', 1154.0000, 'ºC'),
	(281848, 121, '2014-04-01 01:34:30.000000', 'temperatura', 20.0000, 'ºC'),
	(281849, 121, '2014-04-01 01:34:31.000000', 'temperatura', 237.0000, 'ºC'),
	(281850, 121, '2014-04-01 01:34:32.000000', 'temperatura', 1126.0000, 'ºC'),
	(281851, 121, '2014-04-01 01:34:33.000000', 'temperatura', 119.0000, 'ºC'),
	(281852, 121, '2014-04-01 01:34:34.000000', 'temperatura', 816.0000, 'ºC'),
	(281853, 121, '2014-04-01 01:34:35.000000', 'temperatura', 124.0000, 'ºC'),
	(281854, 121, '2014-04-01 01:34:36.000000', 'temperatura', 574.0000, 'ºC'),
	(281855, 121, '2014-04-01 01:34:37.000000', 'temperatura', 98.0000, 'ºC'),
	(281856, 121, '2014-04-01 01:34:38.000000', 'temperatura', 1167.0000, 'ºC'),
	(281857, 121, '2014-04-01 01:34:39.000000', 'temperatura', 741.0000, 'ºC'),
	(281858, 121, '2014-04-01 01:34:40.000000', 'temperatura', 208.0000, 'ºC'),
	(281859, 121, '2014-04-01 01:34:41.000000', 'temperatura', 14.0000, 'ºC'),
	(281860, 121, '2014-04-01 01:34:42.000000', 'temperatura', 649.0000, 'ºC'),
	(281861, 121, '2014-04-01 01:34:43.000000', 'temperatura', 802.0000, 'ºC'),
	(281862, 121, '2014-04-01 01:34:44.000000', 'temperatura', 864.0000, 'ºC'),
	(281863, 121, '2014-04-01 01:34:45.000000', 'temperatura', 714.0000, 'ºC'),
	(281864, 121, '2014-04-01 01:34:46.000000', 'temperatura', 980.0000, 'ºC'),
	(281865, 121, '2014-04-01 01:34:47.000000', 'temperatura', 356.0000, 'ºC'),
	(281866, 121, '2014-04-01 01:34:48.000000', 'temperatura', 43.0000, 'ºC'),
	(281867, 121, '2014-04-01 01:34:49.000000', 'temperatura', 346.0000, 'ºC'),
	(281868, 121, '2014-04-01 01:34:50.000000', 'temperatura', 400.0000, 'ºC'),
	(281869, 121, '2014-04-01 01:34:51.000000', 'temperatura', 966.0000, 'ºC'),
	(281870, 121, '2014-04-01 01:34:52.000000', 'temperatura', 29.0000, 'ºC'),
	(281871, 121, '2014-04-01 01:34:53.000000', 'temperatura', 847.0000, 'ºC'),
	(281872, 121, '2014-04-01 01:34:54.000000', 'temperatura', 547.0000, 'ºC'),
	(281873, 121, '2014-04-01 01:34:55.000000', 'temperatura', 195.0000, 'ºC'),
	(281874, 121, '2014-04-01 01:34:56.000000', 'temperatura', 536.0000, 'ºC'),
	(281875, 121, '2014-04-01 01:34:57.000000', 'temperatura', 893.0000, 'ºC'),
	(281876, 121, '2014-04-01 01:34:58.000000', 'temperatura', 460.0000, 'ºC'),
	(281877, 121, '2014-04-01 01:34:59.000000', 'temperatura', 821.0000, 'ºC'),
	(281878, 121, '2014-04-01 01:35:00.000000', 'temperatura', 324.0000, 'ºC'),
	(281879, 121, '2014-04-01 01:35:01.000000', 'temperatura', 358.0000, 'ºC'),
	(281880, 121, '2014-04-01 01:35:02.000000', 'temperatura', 817.0000, 'ºC'),
	(281881, 121, '2014-04-01 01:35:03.000000', 'temperatura', 614.0000, 'ºC'),
	(281882, 121, '2014-04-01 01:35:04.000000', 'temperatura', 618.0000, 'ºC'),
	(281883, 121, '2014-04-01 01:35:05.000000', 'temperatura', 51.0000, 'ºC'),
	(281884, 121, '2014-04-01 01:35:06.000000', 'temperatura', 800.0000, 'ºC'),
	(281885, 121, '2014-04-01 01:35:07.000000', 'temperatura', 248.0000, 'ºC'),
	(281886, 121, '2014-04-01 01:35:08.000000', 'temperatura', 39.0000, 'ºC'),
	(281887, 121, '2014-04-01 01:35:09.000000', 'temperatura', 650.0000, 'ºC'),
	(281888, 121, '2014-04-01 01:35:10.000000', 'temperatura', 736.0000, 'ºC'),
	(281889, 121, '2014-04-01 01:35:11.000000', 'temperatura', 532.0000, 'ºC'),
	(281890, 121, '2014-04-01 01:35:12.000000', 'temperatura', 451.0000, 'ºC'),
	(281891, 121, '2014-04-01 01:35:13.000000', 'temperatura', 660.0000, 'ºC'),
	(281892, 121, '2014-04-01 01:35:14.000000', 'temperatura', 747.0000, 'ºC'),
	(281893, 121, '2014-04-01 01:35:15.000000', 'temperatura', 554.0000, 'ºC'),
	(281894, 121, '2014-04-01 01:35:16.000000', 'temperatura', 530.0000, 'ºC'),
	(281895, 121, '2014-04-01 01:35:17.000000', 'temperatura', 991.0000, 'ºC'),
	(281896, 121, '2014-04-01 01:35:18.000000', 'temperatura', 963.0000, 'ºC'),
	(281897, 121, '2014-04-01 01:35:19.000000', 'temperatura', 643.0000, 'ºC'),
	(281898, 121, '2014-04-01 01:35:20.000000', 'temperatura', 328.0000, 'ºC'),
	(281899, 121, '2014-04-01 01:35:21.000000', 'temperatura', 911.0000, 'ºC'),
	(281900, 121, '2014-04-01 01:35:22.000000', 'temperatura', 1173.0000, 'ºC'),
	(281901, 121, '2014-04-01 01:35:23.000000', 'temperatura', 731.0000, 'ºC'),
	(281902, 121, '2014-04-01 01:35:24.000000', 'temperatura', 136.0000, 'ºC'),
	(281903, 121, '2014-04-01 01:35:25.000000', 'temperatura', 887.0000, 'ºC'),
	(281904, 121, '2014-04-01 01:35:26.000000', 'temperatura', 428.0000, 'ºC'),
	(281905, 121, '2014-04-01 01:35:27.000000', 'temperatura', 679.0000, 'ºC'),
	(281906, 121, '2014-04-01 01:35:28.000000', 'temperatura', 910.0000, 'ºC'),
	(281907, 121, '2014-04-01 01:35:29.000000', 'temperatura', 115.0000, 'ºC'),
	(281908, 121, '2014-04-01 01:35:30.000000', 'temperatura', 245.0000, 'ºC'),
	(281909, 121, '2014-04-01 01:35:31.000000', 'temperatura', 880.0000, 'ºC'),
	(281910, 121, '2014-04-01 01:35:32.000000', 'temperatura', 68.0000, 'ºC'),
	(281911, 121, '2014-04-01 01:35:33.000000', 'temperatura', 98.0000, 'ºC'),
	(281912, 121, '2014-04-01 01:35:34.000000', 'temperatura', 287.0000, 'ºC'),
	(281913, 121, '2014-04-01 01:35:35.000000', 'temperatura', 1144.0000, 'ºC'),
	(281914, 121, '2014-04-01 01:35:36.000000', 'temperatura', 56.0000, 'ºC'),
	(281915, 121, '2014-04-01 01:35:37.000000', 'temperatura', 449.0000, 'ºC'),
	(281916, 121, '2014-04-01 01:35:38.000000', 'temperatura', 878.0000, 'ºC'),
	(281917, 121, '2014-04-01 01:35:39.000000', 'temperatura', 642.0000, 'ºC'),
	(281918, 121, '2014-04-01 01:35:40.000000', 'temperatura', 579.0000, 'ºC'),
	(281919, 121, '2014-04-01 01:35:41.000000', 'temperatura', 969.0000, 'ºC'),
	(281920, 121, '2014-04-01 01:35:42.000000', 'temperatura', 708.0000, 'ºC'),
	(281921, 121, '2014-04-01 01:35:43.000000', 'temperatura', 633.0000, 'ºC'),
	(281922, 121, '2014-04-01 01:35:44.000000', 'temperatura', 1041.0000, 'ºC'),
	(281923, 121, '2014-04-01 01:35:45.000000', 'temperatura', 909.0000, 'ºC'),
	(281924, 121, '2014-04-01 01:35:46.000000', 'temperatura', 221.0000, 'ºC'),
	(281925, 121, '2014-04-01 01:35:47.000000', 'temperatura', 777.0000, 'ºC'),
	(281926, 121, '2014-04-01 01:35:48.000000', 'temperatura', 823.0000, 'ºC'),
	(281927, 121, '2014-04-01 01:35:49.000000', 'temperatura', 583.0000, 'ºC'),
	(281928, 121, '2014-04-01 01:35:50.000000', 'temperatura', 449.0000, 'ºC'),
	(281929, 121, '2014-04-01 01:35:51.000000', 'temperatura', 498.0000, 'ºC'),
	(281930, 121, '2014-04-01 01:35:52.000000', 'temperatura', 1141.0000, 'ºC'),
	(281931, 121, '2014-04-01 01:35:53.000000', 'temperatura', 612.0000, 'ºC'),
	(281932, 121, '2014-04-01 01:35:54.000000', 'temperatura', 837.0000, 'ºC'),
	(281933, 121, '2014-04-01 01:35:55.000000', 'temperatura', 1150.0000, 'ºC'),
	(281934, 121, '2014-04-01 01:35:56.000000', 'temperatura', 838.0000, 'ºC'),
	(281935, 121, '2014-04-01 01:35:57.000000', 'temperatura', 741.0000, 'ºC'),
	(281936, 121, '2014-04-01 01:35:58.000000', 'temperatura', 1191.0000, 'ºC'),
	(281937, 121, '2014-04-01 01:35:59.000000', 'temperatura', 132.0000, 'ºC'),
	(281938, 121, '2014-04-01 01:36:00.000000', 'temperatura', 687.0000, 'ºC'),
	(281939, 121, '2014-04-01 01:36:01.000000', 'temperatura', 641.0000, 'ºC'),
	(281940, 121, '2014-04-01 01:36:02.000000', 'temperatura', 1145.0000, 'ºC'),
	(281941, 121, '2014-04-01 01:36:03.000000', 'temperatura', 202.0000, 'ºC'),
	(281942, 121, '2014-04-01 01:36:04.000000', 'temperatura', 1175.0000, 'ºC'),
	(281943, 121, '2014-04-01 01:36:05.000000', 'temperatura', 470.0000, 'ºC'),
	(281944, 121, '2014-04-01 01:36:06.000000', 'temperatura', 24.0000, 'ºC'),
	(281945, 121, '2014-04-01 01:36:07.000000', 'temperatura', 1112.0000, 'ºC'),
	(281946, 121, '2014-04-01 01:36:08.000000', 'temperatura', 687.0000, 'ºC'),
	(281947, 121, '2014-04-01 01:36:09.000000', 'temperatura', 102.0000, 'ºC'),
	(281948, 121, '2014-04-01 01:36:10.000000', 'temperatura', 846.0000, 'ºC'),
	(281949, 121, '2014-04-01 01:36:11.000000', 'temperatura', 327.0000, 'ºC'),
	(281950, 121, '2014-04-01 01:36:12.000000', 'temperatura', 299.0000, 'ºC'),
	(281951, 121, '2014-04-01 01:36:13.000000', 'temperatura', 513.0000, 'ºC'),
	(281952, 121, '2014-04-01 01:36:14.000000', 'temperatura', 468.0000, 'ºC'),
	(281953, 121, '2014-04-01 01:36:15.000000', 'temperatura', 800.0000, 'ºC'),
	(281954, 121, '2014-04-01 01:36:16.000000', 'temperatura', 197.0000, 'ºC'),
	(281955, 121, '2014-04-01 01:36:17.000000', 'temperatura', 985.0000, 'ºC'),
	(281956, 121, '2014-04-01 01:36:18.000000', 'temperatura', 733.0000, 'ºC'),
	(281957, 121, '2014-04-01 01:36:19.000000', 'temperatura', 714.0000, 'ºC'),
	(281958, 121, '2014-04-01 01:36:20.000000', 'temperatura', 170.0000, 'ºC'),
	(281959, 121, '2014-04-01 01:36:21.000000', 'temperatura', 1109.0000, 'ºC'),
	(281960, 121, '2014-04-01 01:36:22.000000', 'temperatura', 235.0000, 'ºC'),
	(281961, 121, '2014-04-01 01:36:23.000000', 'temperatura', 248.0000, 'ºC'),
	(281962, 121, '2014-04-01 01:36:24.000000', 'temperatura', 534.0000, 'ºC'),
	(281963, 121, '2014-04-01 01:36:25.000000', 'temperatura', 729.0000, 'ºC'),
	(281964, 121, '2014-04-01 01:36:26.000000', 'temperatura', 844.0000, 'ºC'),
	(281965, 121, '2014-04-01 01:36:27.000000', 'temperatura', 833.0000, 'ºC'),
	(281966, 121, '2014-04-01 01:36:28.000000', 'temperatura', 431.0000, 'ºC'),
	(281967, 121, '2014-04-01 01:36:29.000000', 'temperatura', 859.0000, 'ºC'),
	(281968, 121, '2014-04-01 01:36:30.000000', 'temperatura', 602.0000, 'ºC'),
	(281969, 121, '2014-04-01 01:36:31.000000', 'temperatura', 433.0000, 'ºC'),
	(281970, 121, '2014-04-01 01:36:32.000000', 'temperatura', 361.0000, 'ºC'),
	(281971, 121, '2014-04-01 01:36:33.000000', 'temperatura', 505.0000, 'ºC'),
	(281972, 121, '2014-04-01 01:36:34.000000', 'temperatura', 243.0000, 'ºC'),
	(281973, 121, '2014-04-01 01:36:35.000000', 'temperatura', 901.0000, 'ºC'),
	(281974, 121, '2014-04-01 01:36:36.000000', 'temperatura', 177.0000, 'ºC'),
	(281975, 121, '2014-04-01 01:36:37.000000', 'temperatura', 583.0000, 'ºC'),
	(281976, 121, '2014-04-01 01:36:38.000000', 'temperatura', 1183.0000, 'ºC'),
	(281977, 121, '2014-04-01 01:36:39.000000', 'temperatura', 568.0000, 'ºC'),
	(281978, 121, '2014-04-01 01:36:40.000000', 'temperatura', 490.0000, 'ºC'),
	(281979, 121, '2014-04-01 01:36:41.000000', 'temperatura', 748.0000, 'ºC'),
	(281980, 121, '2014-04-01 01:36:42.000000', 'temperatura', 1070.0000, 'ºC'),
	(281981, 121, '2014-04-01 01:36:43.000000', 'temperatura', 706.0000, 'ºC'),
	(281982, 121, '2014-04-01 01:36:44.000000', 'temperatura', 321.0000, 'ºC'),
	(281983, 121, '2014-04-01 01:36:45.000000', 'temperatura', 688.0000, 'ºC'),
	(281984, 121, '2014-04-01 01:36:46.000000', 'temperatura', 77.0000, 'ºC'),
	(281985, 121, '2014-04-01 01:36:47.000000', 'temperatura', 723.0000, 'ºC'),
	(281986, 121, '2014-04-01 01:36:48.000000', 'temperatura', 984.0000, 'ºC'),
	(281987, 121, '2014-04-01 01:36:49.000000', 'temperatura', 349.0000, 'ºC'),
	(281988, 121, '2014-04-01 01:36:50.000000', 'temperatura', 1196.0000, 'ºC'),
	(281989, 121, '2014-04-01 01:36:51.000000', 'temperatura', 133.0000, 'ºC'),
	(281990, 121, '2014-04-01 01:36:52.000000', 'temperatura', 676.0000, 'ºC'),
	(281991, 121, '2014-04-01 01:36:53.000000', 'temperatura', 583.0000, 'ºC'),
	(281992, 121, '2014-04-01 01:36:54.000000', 'temperatura', 889.0000, 'ºC'),
	(281993, 121, '2014-04-01 01:36:55.000000', 'temperatura', 296.0000, 'ºC'),
	(281994, 121, '2014-04-01 01:36:56.000000', 'temperatura', 11.0000, 'ºC'),
	(281995, 121, '2014-04-01 01:36:57.000000', 'temperatura', 370.0000, 'ºC'),
	(281996, 121, '2014-04-01 01:36:58.000000', 'temperatura', 618.0000, 'ºC'),
	(281997, 121, '2014-04-01 01:36:59.000000', 'temperatura', 779.0000, 'ºC'),
	(281998, 121, '2014-04-01 01:37:00.000000', 'temperatura', 841.0000, 'ºC'),
	(281999, 121, '2014-04-01 01:37:01.000000', 'temperatura', 670.0000, 'ºC'),
	(282000, 121, '2014-04-01 01:37:02.000000', 'temperatura', 828.0000, 'ºC'),
	(282001, 121, '2014-04-01 01:37:03.000000', 'temperatura', 931.0000, 'ºC'),
	(282002, 121, '2014-04-01 01:37:04.000000', 'temperatura', 971.0000, 'ºC'),
	(282003, 121, '2014-04-01 01:37:05.000000', 'temperatura', 864.0000, 'ºC'),
	(282004, 121, '2014-04-01 01:37:06.000000', 'temperatura', 206.0000, 'ºC'),
	(282005, 121, '2014-04-01 01:37:07.000000', 'temperatura', 840.0000, 'ºC'),
	(282006, 121, '2014-04-01 01:37:08.000000', 'temperatura', 1180.0000, 'ºC'),
	(282007, 121, '2014-04-01 01:37:09.000000', 'temperatura', 983.0000, 'ºC'),
	(282008, 121, '2014-04-01 01:37:10.000000', 'temperatura', 176.0000, 'ºC'),
	(282009, 121, '2014-04-01 01:37:11.000000', 'temperatura', 331.0000, 'ºC'),
	(282010, 121, '2014-04-01 01:37:12.000000', 'temperatura', 1129.0000, 'ºC'),
	(282011, 121, '2014-04-01 01:37:13.000000', 'temperatura', 1052.0000, 'ºC'),
	(282012, 121, '2014-04-01 01:37:14.000000', 'temperatura', 673.0000, 'ºC'),
	(282013, 121, '2014-04-01 01:37:15.000000', 'temperatura', 208.0000, 'ºC'),
	(282014, 121, '2014-04-01 01:37:16.000000', 'temperatura', 221.0000, 'ºC'),
	(282015, 121, '2014-04-01 01:37:17.000000', 'temperatura', 484.0000, 'ºC'),
	(282016, 121, '2014-04-01 01:37:18.000000', 'temperatura', 557.0000, 'ºC'),
	(282017, 121, '2014-04-01 01:37:19.000000', 'temperatura', 133.0000, 'ºC'),
	(282018, 121, '2014-04-01 01:37:20.000000', 'temperatura', 196.0000, 'ºC'),
	(282019, 121, '2014-04-01 01:37:21.000000', 'temperatura', 579.0000, 'ºC'),
	(282020, 121, '2014-04-01 01:37:22.000000', 'temperatura', 1108.0000, 'ºC'),
	(282021, 121, '2014-04-01 01:37:23.000000', 'temperatura', 205.0000, 'ºC'),
	(282022, 121, '2014-04-01 01:37:24.000000', 'temperatura', 100.0000, 'ºC'),
	(282023, 121, '2014-04-01 01:37:25.000000', 'temperatura', 1086.0000, 'ºC'),
	(282024, 121, '2014-04-01 01:37:26.000000', 'temperatura', 332.0000, 'ºC'),
	(282025, 121, '2014-04-01 01:37:27.000000', 'temperatura', 800.0000, 'ºC'),
	(282026, 121, '2014-04-01 01:37:28.000000', 'temperatura', 605.0000, 'ºC'),
	(282027, 121, '2014-04-01 01:37:29.000000', 'temperatura', 627.0000, 'ºC'),
	(282028, 121, '2014-04-01 01:37:30.000000', 'temperatura', 120.0000, 'ºC'),
	(282029, 121, '2014-04-01 01:37:31.000000', 'temperatura', 1118.0000, 'ºC'),
	(282030, 121, '2014-04-01 01:37:32.000000', 'temperatura', 433.0000, 'ºC'),
	(282031, 121, '2014-04-01 01:37:33.000000', 'temperatura', 12.0000, 'ºC'),
	(282032, 121, '2014-04-01 01:37:34.000000', 'temperatura', 1160.0000, 'ºC'),
	(282033, 121, '2014-04-01 01:37:35.000000', 'temperatura', 965.0000, 'ºC'),
	(282034, 121, '2014-04-01 01:37:36.000000', 'temperatura', 145.0000, 'ºC'),
	(282035, 121, '2014-04-01 01:37:37.000000', 'temperatura', 231.0000, 'ºC'),
	(282036, 121, '2014-04-01 01:37:38.000000', 'temperatura', 719.0000, 'ºC'),
	(282037, 121, '2014-04-01 01:37:39.000000', 'temperatura', 503.0000, 'ºC'),
	(282038, 121, '2014-04-01 01:37:40.000000', 'temperatura', 361.0000, 'ºC'),
	(282039, 121, '2014-04-01 01:37:41.000000', 'temperatura', 293.0000, 'ºC'),
	(282040, 121, '2014-04-01 01:37:42.000000', 'temperatura', 386.0000, 'ºC'),
	(282041, 121, '2014-04-01 01:37:43.000000', 'temperatura', 1050.0000, 'ºC'),
	(282042, 121, '2014-04-01 01:37:44.000000', 'temperatura', 493.0000, 'ºC'),
	(282043, 121, '2014-04-01 01:37:45.000000', 'temperatura', 513.0000, 'ºC'),
	(282044, 121, '2014-04-01 01:37:46.000000', 'temperatura', 1089.0000, 'ºC'),
	(282045, 121, '2014-04-01 01:37:47.000000', 'temperatura', 307.0000, 'ºC'),
	(282046, 121, '2014-04-01 01:37:48.000000', 'temperatura', 670.0000, 'ºC'),
	(282047, 121, '2014-04-01 01:37:49.000000', 'temperatura', 26.0000, 'ºC'),
	(282048, 121, '2014-04-01 01:37:50.000000', 'temperatura', 523.0000, 'ºC'),
	(282049, 121, '2014-04-01 01:37:51.000000', 'temperatura', 135.0000, 'ºC'),
	(282050, 121, '2014-04-01 01:37:52.000000', 'temperatura', 306.0000, 'ºC'),
	(282051, 121, '2014-04-01 01:37:53.000000', 'temperatura', 1128.0000, 'ºC'),
	(282052, 121, '2014-04-01 01:37:54.000000', 'temperatura', 1120.0000, 'ºC'),
	(282053, 121, '2014-04-01 01:37:55.000000', 'temperatura', 1017.0000, 'ºC'),
	(282054, 121, '2014-04-01 01:37:56.000000', 'temperatura', 526.0000, 'ºC'),
	(282055, 121, '2014-04-01 01:37:57.000000', 'temperatura', 781.0000, 'ºC'),
	(282056, 121, '2014-04-01 01:37:58.000000', 'temperatura', 1127.0000, 'ºC'),
	(282057, 121, '2014-04-01 01:37:59.000000', 'temperatura', 893.0000, 'ºC'),
	(282058, 121, '2014-04-01 01:38:00.000000', 'temperatura', 1082.0000, 'ºC'),
	(282059, 121, '2014-04-01 01:38:01.000000', 'temperatura', 335.0000, 'ºC'),
	(282060, 121, '2014-04-01 01:38:02.000000', 'temperatura', 828.0000, 'ºC'),
	(282061, 121, '2014-04-01 01:38:03.000000', 'temperatura', 733.0000, 'ºC'),
	(282062, 121, '2014-04-01 01:38:04.000000', 'temperatura', 1185.0000, 'ºC'),
	(282063, 121, '2014-04-01 01:38:05.000000', 'temperatura', 126.0000, 'ºC'),
	(282064, 121, '2014-04-01 01:38:06.000000', 'temperatura', 674.0000, 'ºC'),
	(282065, 121, '2014-04-01 01:38:07.000000', 'temperatura', 592.0000, 'ºC'),
	(282066, 121, '2014-04-01 01:38:08.000000', 'temperatura', 938.0000, 'ºC'),
	(282067, 121, '2014-04-01 01:38:09.000000', 'temperatura', 515.0000, 'ºC'),
	(282068, 121, '2014-04-01 01:38:10.000000', 'temperatura', 964.0000, 'ºC'),
	(282069, 121, '2014-04-01 01:38:11.000000', 'temperatura', 873.0000, 'ºC'),
	(282070, 121, '2014-04-01 01:38:12.000000', 'temperatura', 274.0000, 'ºC'),
	(282071, 121, '2014-04-01 01:38:13.000000', 'temperatura', 1153.0000, 'ºC'),
	(282072, 121, '2014-04-01 01:38:14.000000', 'temperatura', 143.0000, 'ºC'),
	(282073, 121, '2014-04-01 01:38:15.000000', 'temperatura', 857.0000, 'ºC'),
	(282074, 121, '2014-04-01 01:38:16.000000', 'temperatura', 255.0000, 'ºC'),
	(282075, 121, '2014-04-01 01:38:17.000000', 'temperatura', 1106.0000, 'ºC'),
	(282076, 121, '2014-04-01 01:38:18.000000', 'temperatura', 1167.0000, 'ºC'),
	(282077, 121, '2014-04-01 01:38:19.000000', 'temperatura', 115.0000, 'ºC'),
	(282078, 121, '2014-04-01 01:38:20.000000', 'temperatura', 676.0000, 'ºC'),
	(282079, 121, '2014-04-01 01:38:21.000000', 'temperatura', 634.0000, 'ºC'),
	(282080, 121, '2014-04-01 01:38:22.000000', 'temperatura', 1142.0000, 'ºC'),
	(282081, 121, '2014-04-01 01:38:23.000000', 'temperatura', 207.0000, 'ºC'),
	(282082, 121, '2014-04-01 01:38:24.000000', 'temperatura', 12.0000, 'ºC'),
	(282083, 121, '2014-04-01 01:38:25.000000', 'temperatura', 639.0000, 'ºC'),
	(282084, 121, '2014-04-01 01:38:26.000000', 'temperatura', 758.0000, 'ºC'),
	(282085, 121, '2014-04-01 01:38:27.000000', 'temperatura', 674.0000, 'ºC'),
	(282086, 121, '2014-04-01 01:38:28.000000', 'temperatura', 1098.0000, 'ºC'),
	(282087, 122, '2014-04-01 00:00:00.000000', 'temperatura', 850.0000, 'ºC'),
	(282088, 122, '2014-04-01 00:00:01.000000', 'temperatura', 1045.0000, 'ºC'),
	(282089, 122, '2014-04-01 00:00:02.000000', 'temperatura', 275.0000, 'ºC'),
	(282090, 122, '2014-04-01 00:00:03.000000', 'temperatura', 638.0000, 'ºC'),
	(282091, 122, '2014-04-01 00:00:04.000000', 'temperatura', 1169.0000, 'ºC'),
	(282092, 122, '2014-04-01 00:00:05.000000', 'temperatura', 330.0000, 'ºC'),
	(282093, 122, '2014-04-01 00:00:06.000000', 'temperatura', 543.0000, 'ºC'),
	(282094, 122, '2014-04-01 00:00:07.000000', 'temperatura', 526.0000, 'ºC'),
	(282095, 122, '2014-04-01 00:00:08.000000', 'temperatura', 1000.0000, 'ºC'),
	(282096, 122, '2014-04-01 00:00:09.000000', 'temperatura', 1023.0000, 'ºC'),
	(282097, 122, '2014-04-01 00:00:10.000000', 'temperatura', 917.0000, 'ºC'),
	(282098, 122, '2014-04-01 00:00:11.000000', 'temperatura', 317.0000, 'ºC'),
	(282099, 122, '2014-04-01 00:00:12.000000', 'temperatura', 35.0000, 'ºC'),
	(282100, 122, '2014-04-01 00:00:13.000000', 'temperatura', 423.0000, 'ºC'),
	(282101, 122, '2014-04-01 00:00:14.000000', 'temperatura', 810.0000, 'ºC'),
	(282102, 122, '2014-04-01 00:00:15.000000', 'temperatura', 383.0000, 'ºC'),
	(282103, 122, '2014-04-01 00:00:16.000000', 'temperatura', 685.0000, 'ºC'),
	(282104, 122, '2014-04-01 00:00:17.000000', 'temperatura', 1077.0000, 'ºC'),
	(282105, 122, '2014-04-01 00:00:18.000000', 'temperatura', 932.0000, 'ºC'),
	(282106, 122, '2014-04-01 00:00:19.000000', 'temperatura', 228.0000, 'ºC'),
	(282107, 122, '2014-04-01 00:00:20.000000', 'temperatura', 744.0000, 'ºC'),
	(282108, 122, '2014-04-01 00:00:21.000000', 'temperatura', 637.0000, 'ºC'),
	(282109, 122, '2014-04-01 00:00:22.000000', 'temperatura', 953.0000, 'ºC'),
	(282110, 122, '2014-04-01 00:00:23.000000', 'temperatura', 455.0000, 'ºC'),
	(282111, 122, '2014-04-01 00:00:24.000000', 'temperatura', 618.0000, 'ºC'),
	(282112, 122, '2014-04-01 00:00:25.000000', 'temperatura', 525.0000, 'ºC'),
	(282113, 122, '2014-04-01 00:00:26.000000', 'temperatura', 773.0000, 'ºC'),
	(282114, 122, '2014-04-01 00:00:27.000000', 'temperatura', 1089.0000, 'ºC'),
	(282115, 122, '2014-04-01 00:00:28.000000', 'temperatura', 725.0000, 'ºC'),
	(282116, 122, '2014-04-01 00:00:29.000000', 'temperatura', 360.0000, 'ºC'),
	(282117, 122, '2014-04-01 00:00:30.000000', 'temperatura', 824.0000, 'ºC'),
	(282118, 122, '2014-04-01 00:00:31.000000', 'temperatura', 640.0000, 'ºC'),
	(282119, 122, '2014-04-01 00:00:32.000000', 'temperatura', 730.0000, 'ºC'),
	(282120, 122, '2014-04-01 00:00:33.000000', 'temperatura', 528.0000, 'ºC'),
	(282121, 122, '2014-04-01 00:00:34.000000', 'temperatura', 453.0000, 'ºC'),
	(282122, 122, '2014-04-01 00:00:35.000000', 'temperatura', 681.0000, 'ºC'),
	(282123, 122, '2014-04-01 00:00:36.000000', 'temperatura', 848.0000, 'ºC'),
	(282124, 122, '2014-04-01 00:00:37.000000', 'temperatura', 998.0000, 'ºC'),
	(282125, 122, '2014-04-01 00:00:38.000000', 'temperatura', 44.0000, 'ºC'),
	(282126, 122, '2014-04-01 00:00:39.000000', 'temperatura', 825.0000, 'ºC'),
	(282127, 122, '2014-04-01 00:00:40.000000', 'temperatura', 397.0000, 'ºC'),
	(282128, 122, '2014-04-01 00:00:41.000000', 'temperatura', 707.0000, 'ºC'),
	(282129, 122, '2014-04-01 00:00:42.000000', 'temperatura', 1147.0000, 'ºC'),
	(282130, 122, '2014-04-01 00:00:43.000000', 'temperatura', 12.0000, 'ºC'),
	(282131, 122, '2014-04-01 00:00:44.000000', 'temperatura', 221.0000, 'ºC'),
	(282132, 122, '2014-04-01 00:00:45.000000', 'temperatura', 1068.0000, 'ºC'),
	(282133, 122, '2014-04-01 00:00:46.000000', 'temperatura', 1080.0000, 'ºC'),
	(282134, 122, '2014-04-01 00:00:47.000000', 'temperatura', 997.0000, 'ºC'),
	(282135, 122, '2014-04-01 00:00:48.000000', 'temperatura', 543.0000, 'ºC'),
	(282136, 122, '2014-04-01 00:00:49.000000', 'temperatura', 925.0000, 'ºC'),
	(282137, 122, '2014-04-01 00:00:50.000000', 'temperatura', 599.0000, 'ºC'),
	(282138, 122, '2014-04-01 00:00:51.000000', 'temperatura', 218.0000, 'ºC'),
	(282139, 122, '2014-04-01 00:00:52.000000', 'temperatura', 496.0000, 'ºC'),
	(282140, 122, '2014-04-01 00:00:53.000000', 'temperatura', 625.0000, 'ºC'),
	(282141, 122, '2014-04-01 00:00:54.000000', 'temperatura', 437.0000, 'ºC'),
	(282142, 122, '2014-04-01 00:00:55.000000', 'temperatura', 312.0000, 'ºC'),
	(282143, 122, '2014-04-01 00:00:56.000000', 'temperatura', 250.0000, 'ºC'),
	(282144, 122, '2014-04-01 00:00:57.000000', 'temperatura', 315.0000, 'ºC'),
	(282145, 122, '2014-04-01 00:00:58.000000', 'temperatura', 825.0000, 'ºC'),
	(282146, 122, '2014-04-01 00:00:59.000000', 'temperatura', 779.0000, 'ºC'),
	(282147, 122, '2014-04-01 00:01:00.000000', 'temperatura', 223.0000, 'ºC'),
	(282148, 122, '2014-04-01 00:01:01.000000', 'temperatura', 1176.0000, 'ºC'),
	(282149, 122, '2014-04-01 00:01:02.000000', 'temperatura', 412.0000, 'ºC'),
	(282150, 122, '2014-04-01 00:01:03.000000', 'temperatura', 933.0000, 'ºC'),
	(282151, 122, '2014-04-01 00:01:04.000000', 'temperatura', 1029.0000, 'ºC'),
	(282152, 122, '2014-04-01 00:01:05.000000', 'temperatura', 1148.0000, 'ºC'),
	(282153, 122, '2014-04-01 00:01:06.000000', 'temperatura', 254.0000, 'ºC'),
	(282154, 122, '2014-04-01 00:01:07.000000', 'temperatura', 224.0000, 'ºC'),
	(282155, 122, '2014-04-01 00:01:08.000000', 'temperatura', 358.0000, 'ºC'),
	(282156, 122, '2014-04-01 00:01:09.000000', 'temperatura', 1122.0000, 'ºC'),
	(282157, 122, '2014-04-01 00:01:10.000000', 'temperatura', 933.0000, 'ºC'),
	(282158, 122, '2014-04-01 00:01:11.000000', 'temperatura', 102.0000, 'ºC'),
	(282159, 122, '2014-04-01 00:01:12.000000', 'temperatura', 110.0000, 'ºC'),
	(282160, 122, '2014-04-01 00:01:13.000000', 'temperatura', 245.0000, 'ºC'),
	(282161, 122, '2014-04-01 00:01:14.000000', 'temperatura', 895.0000, 'ºC'),
	(282162, 122, '2014-04-01 00:01:15.000000', 'temperatura', 141.0000, 'ºC'),
	(282163, 122, '2014-04-01 00:01:16.000000', 'temperatura', 421.0000, 'ºC'),
	(282164, 122, '2014-04-01 00:01:17.000000', 'temperatura', 481.0000, 'ºC'),
	(282165, 122, '2014-04-01 00:01:18.000000', 'temperatura', 1143.0000, 'ºC'),
	(282166, 122, '2014-04-01 00:01:19.000000', 'temperatura', 671.0000, 'ºC'),
	(282167, 122, '2014-04-01 00:01:20.000000', 'temperatura', 1126.0000, 'ºC'),
	(282168, 122, '2014-04-01 00:01:21.000000', 'temperatura', 19.0000, 'ºC'),
	(282169, 122, '2014-04-01 00:01:22.000000', 'temperatura', 315.0000, 'ºC'),
	(282170, 122, '2014-04-01 00:01:23.000000', 'temperatura', 322.0000, 'ºC'),
	(282171, 122, '2014-04-01 00:01:24.000000', 'temperatura', 663.0000, 'ºC'),
	(282172, 122, '2014-04-01 00:01:25.000000', 'temperatura', 1151.0000, 'ºC'),
	(282173, 122, '2014-04-01 00:01:26.000000', 'temperatura', 165.0000, 'ºC'),
	(282174, 122, '2014-04-01 00:01:27.000000', 'temperatura', 972.0000, 'ºC'),
	(282175, 122, '2014-04-01 00:01:28.000000', 'temperatura', 767.0000, 'ºC'),
	(282176, 122, '2014-04-01 00:01:29.000000', 'temperatura', 917.0000, 'ºC'),
	(282177, 122, '2014-04-01 00:01:30.000000', 'temperatura', 1086.0000, 'ºC'),
	(282178, 122, '2014-04-01 00:01:31.000000', 'temperatura', 281.0000, 'ºC'),
	(282179, 122, '2014-04-01 00:01:32.000000', 'temperatura', 548.0000, 'ºC'),
	(282180, 122, '2014-04-01 00:01:33.000000', 'temperatura', 695.0000, 'ºC'),
	(282181, 122, '2014-04-01 00:01:34.000000', 'temperatura', 632.0000, 'ºC'),
	(282182, 122, '2014-04-01 00:01:35.000000', 'temperatura', 1074.0000, 'ºC'),
	(282183, 122, '2014-04-01 00:01:36.000000', 'temperatura', 1078.0000, 'ºC'),
	(282184, 122, '2014-04-01 00:01:37.000000', 'temperatura', 967.0000, 'ºC'),
	(282185, 122, '2014-04-01 00:01:38.000000', 'temperatura', 400.0000, 'ºC'),
	(282186, 122, '2014-04-01 00:01:39.000000', 'temperatura', 299.0000, 'ºC'),
	(282187, 122, '2014-04-01 00:01:40.000000', 'temperatura', 298.0000, 'ºC'),
	(282188, 122, '2014-04-01 00:01:41.000000', 'temperatura', 593.0000, 'ºC'),
	(282189, 122, '2014-04-01 00:01:42.000000', 'temperatura', 870.0000, 'ºC'),
	(282190, 122, '2014-04-01 00:01:43.000000', 'temperatura', 173.0000, 'ºC'),
	(282191, 122, '2014-04-01 00:01:44.000000', 'temperatura', 655.0000, 'ºC'),
	(282192, 122, '2014-04-01 00:01:45.000000', 'temperatura', 356.0000, 'ºC'),
	(282193, 122, '2014-04-01 00:01:46.000000', 'temperatura', 1015.0000, 'ºC'),
	(282194, 122, '2014-04-01 00:01:47.000000', 'temperatura', 408.0000, 'ºC'),
	(282195, 122, '2014-04-01 00:01:48.000000', 'temperatura', 197.0000, 'ºC'),
	(282196, 122, '2014-04-01 00:01:49.000000', 'temperatura', 958.0000, 'ºC'),
	(282197, 122, '2014-04-01 00:01:50.000000', 'temperatura', 603.0000, 'ºC'),
	(282198, 122, '2014-04-01 00:01:51.000000', 'temperatura', 140.0000, 'ºC'),
	(282199, 122, '2014-04-01 00:01:52.000000', 'temperatura', 93.0000, 'ºC'),
	(282200, 122, '2014-04-01 00:01:53.000000', 'temperatura', 43.0000, 'ºC'),
	(282201, 122, '2014-04-01 00:01:54.000000', 'temperatura', 1139.0000, 'ºC'),
	(282202, 122, '2014-04-01 00:01:55.000000', 'temperatura', 767.0000, 'ºC'),
	(282203, 122, '2014-04-01 00:01:56.000000', 'temperatura', 416.0000, 'ºC'),
	(282204, 122, '2014-04-01 00:01:57.000000', 'temperatura', 981.0000, 'ºC'),
	(282205, 122, '2014-04-01 00:01:58.000000', 'temperatura', 56.0000, 'ºC'),
	(282206, 122, '2014-04-01 00:01:59.000000', 'temperatura', 940.0000, 'ºC'),
	(282207, 122, '2014-04-01 00:02:00.000000', 'temperatura', 932.0000, 'ºC'),
	(282208, 122, '2014-04-01 00:02:01.000000', 'temperatura', 641.0000, 'ºC'),
	(282209, 122, '2014-04-01 00:02:02.000000', 'temperatura', 408.0000, 'ºC'),
	(282210, 122, '2014-04-01 00:02:03.000000', 'temperatura', 119.0000, 'ºC'),
	(282211, 122, '2014-04-01 00:02:04.000000', 'temperatura', 572.0000, 'ºC'),
	(282212, 122, '2014-04-01 00:02:05.000000', 'temperatura', 101.0000, 'ºC'),
	(282213, 122, '2014-04-01 00:02:06.000000', 'temperatura', 1191.0000, 'ºC'),
	(282214, 122, '2014-04-01 00:02:07.000000', 'temperatura', 853.0000, 'ºC'),
	(282215, 122, '2014-04-01 00:02:08.000000', 'temperatura', 691.0000, 'ºC'),
	(282216, 122, '2014-04-01 00:02:09.000000', 'temperatura', 897.0000, 'ºC'),
	(282217, 122, '2014-04-01 00:02:10.000000', 'temperatura', 13.0000, 'ºC'),
	(282218, 122, '2014-04-01 00:02:11.000000', 'temperatura', 975.0000, 'ºC'),
	(282219, 122, '2014-04-01 00:02:12.000000', 'temperatura', 36.0000, 'ºC'),
	(282220, 122, '2014-04-01 00:02:13.000000', 'temperatura', 856.0000, 'ºC'),
	(282221, 122, '2014-04-01 00:02:14.000000', 'temperatura', 571.0000, 'ºC'),
	(282222, 122, '2014-04-01 00:02:15.000000', 'temperatura', 287.0000, 'ºC'),
	(282223, 122, '2014-04-01 00:02:16.000000', 'temperatura', 924.0000, 'ºC'),
	(282224, 122, '2014-04-01 00:02:17.000000', 'temperatura', 161.0000, 'ºC'),
	(282225, 122, '2014-04-01 00:02:18.000000', 'temperatura', 430.0000, 'ºC'),
	(282226, 122, '2014-04-01 00:02:19.000000', 'temperatura', 471.0000, 'ºC'),
	(282227, 122, '2014-04-01 00:02:20.000000', 'temperatura', 1062.0000, 'ºC'),
	(282228, 122, '2014-04-01 00:02:21.000000', 'temperatura', 301.0000, 'ºC'),
	(282229, 122, '2014-04-01 00:02:22.000000', 'temperatura', 718.0000, 'ºC'),
	(282230, 122, '2014-04-01 00:02:23.000000', 'temperatura', 288.0000, 'ºC'),
	(282231, 122, '2014-04-01 00:02:24.000000', 'temperatura', 484.0000, 'ºC'),
	(282232, 122, '2014-04-01 00:02:25.000000', 'temperatura', 360.0000, 'ºC'),
	(282233, 122, '2014-04-01 00:02:26.000000', 'temperatura', 348.0000, 'ºC'),
	(282234, 122, '2014-04-01 00:02:27.000000', 'temperatura', 659.0000, 'ºC'),
	(282235, 122, '2014-04-01 00:02:28.000000', 'temperatura', 1053.0000, 'ºC'),
	(282236, 122, '2014-04-01 00:02:29.000000', 'temperatura', 888.0000, 'ºC'),
	(282237, 122, '2014-04-01 00:02:30.000000', 'temperatura', 80.0000, 'ºC'),
	(282238, 122, '2014-04-01 00:02:31.000000', 'temperatura', 139.0000, 'ºC'),
	(282239, 122, '2014-04-01 00:02:32.000000', 'temperatura', 454.0000, 'ºC'),
	(282240, 122, '2014-04-01 00:02:33.000000', 'temperatura', 654.0000, 'ºC'),
	(282241, 122, '2014-04-01 00:02:34.000000', 'temperatura', 710.0000, 'ºC'),
	(282242, 122, '2014-04-01 00:02:35.000000', 'temperatura', 388.0000, 'ºC'),
	(282243, 122, '2014-04-01 00:02:36.000000', 'temperatura', 1011.0000, 'ºC'),
	(282244, 122, '2014-04-01 00:02:37.000000', 'temperatura', 292.0000, 'ºC'),
	(282245, 122, '2014-04-01 00:02:38.000000', 'temperatura', 826.0000, 'ºC'),
	(282246, 122, '2014-04-01 00:02:39.000000', 'temperatura', 856.0000, 'ºC'),
	(282247, 122, '2014-04-01 00:02:40.000000', 'temperatura', 600.0000, 'ºC'),
	(282248, 122, '2014-04-01 00:02:41.000000', 'temperatura', 434.0000, 'ºC'),
	(282249, 122, '2014-04-01 00:02:42.000000', 'temperatura', 370.0000, 'ºC'),
	(282250, 122, '2014-04-01 00:02:43.000000', 'temperatura', 550.0000, 'ºC'),
	(282251, 122, '2014-04-01 00:02:44.000000', 'temperatura', 438.0000, 'ºC'),
	(282252, 122, '2014-04-01 00:02:45.000000', 'temperatura', 541.0000, 'ºC'),
	(282253, 122, '2014-04-01 00:02:46.000000', 'temperatura', 191.0000, 'ºC'),
	(282254, 122, '2014-04-01 00:02:47.000000', 'temperatura', 531.0000, 'ºC'),
	(282255, 122, '2014-04-01 00:02:48.000000', 'temperatura', 884.0000, 'ºC'),
	(282256, 122, '2014-04-01 00:02:49.000000', 'temperatura', 428.0000, 'ºC'),
	(282257, 122, '2014-04-01 00:02:50.000000', 'temperatura', 688.0000, 'ºC'),
	(282258, 122, '2014-04-01 00:02:51.000000', 'temperatura', 958.0000, 'ºC'),
	(282259, 122, '2014-04-01 00:02:52.000000', 'temperatura', 325.0000, 'ºC'),
	(282260, 122, '2014-04-01 00:02:53.000000', 'temperatura', 1150.0000, 'ºC'),
	(282261, 122, '2014-04-01 00:02:54.000000', 'temperatura', 1178.0000, 'ºC'),
	(282262, 122, '2014-04-01 00:02:55.000000', 'temperatura', 41.0000, 'ºC'),
	(282263, 122, '2014-04-01 00:02:56.000000', 'temperatura', 269.0000, 'ºC'),
	(282264, 122, '2014-04-01 00:02:57.000000', 'temperatura', 24.0000, 'ºC'),
	(282265, 122, '2014-04-01 00:02:58.000000', 'temperatura', 514.0000, 'ºC'),
	(282266, 122, '2014-04-01 00:02:59.000000', 'temperatura', 98.0000, 'ºC'),
	(282267, 122, '2014-04-01 00:03:00.000000', 'temperatura', 149.0000, 'ºC'),
	(282268, 122, '2014-04-01 00:03:01.000000', 'temperatura', 450.0000, 'ºC'),
	(282269, 122, '2014-04-01 00:03:02.000000', 'temperatura', 605.0000, 'ºC'),
	(282270, 122, '2014-04-01 00:03:03.000000', 'temperatura', 477.0000, 'ºC'),
	(282271, 122, '2014-04-01 00:03:04.000000', 'temperatura', 569.0000, 'ºC'),
	(282272, 122, '2014-04-01 00:03:05.000000', 'temperatura', 214.0000, 'ºC'),
	(282273, 122, '2014-04-01 00:03:06.000000', 'temperatura', 566.0000, 'ºC'),
	(282274, 122, '2014-04-01 00:03:07.000000', 'temperatura', 986.0000, 'ºC'),
	(282275, 122, '2014-04-01 00:03:08.000000', 'temperatura', 833.0000, 'ºC'),
	(282276, 122, '2014-04-01 00:03:09.000000', 'temperatura', 9.0000, 'ºC'),
	(282277, 122, '2014-04-01 00:03:10.000000', 'temperatura', 1147.0000, 'ºC'),
	(282278, 122, '2014-04-01 00:03:11.000000', 'temperatura', 908.0000, 'ºC'),
	(282279, 122, '2014-04-01 00:03:12.000000', 'temperatura', 1098.0000, 'ºC'),
	(282280, 122, '2014-04-01 00:03:13.000000', 'temperatura', 368.0000, 'ºC'),
	(282281, 122, '2014-04-01 00:03:14.000000', 'temperatura', 948.0000, 'ºC'),
	(282282, 122, '2014-04-01 00:03:15.000000', 'temperatura', 34.0000, 'ºC'),
	(282283, 122, '2014-04-01 00:03:16.000000', 'temperatura', 929.0000, 'ºC'),
	(282284, 122, '2014-04-01 00:03:17.000000', 'temperatura', 944.0000, 'ºC'),
	(282285, 122, '2014-04-01 00:03:18.000000', 'temperatura', 731.0000, 'ºC'),
	(282286, 122, '2014-04-01 00:03:19.000000', 'temperatura', 823.0000, 'ºC'),
	(282287, 122, '2014-04-01 00:03:20.000000', 'temperatura', 722.0000, 'ºC'),
	(282288, 122, '2014-04-01 00:03:21.000000', 'temperatura', 1143.0000, 'ºC'),
	(282289, 122, '2014-04-01 00:03:22.000000', 'temperatura', 1149.0000, 'ºC'),
	(282290, 122, '2014-04-01 00:03:23.000000', 'temperatura', 1115.0000, 'ºC'),
	(282291, 122, '2014-04-01 00:03:24.000000', 'temperatura', 930.0000, 'ºC'),
	(282292, 122, '2014-04-01 00:03:25.000000', 'temperatura', 106.0000, 'ºC'),
	(282293, 122, '2014-04-01 00:03:26.000000', 'temperatura', 138.0000, 'ºC'),
	(282294, 122, '2014-04-01 00:03:27.000000', 'temperatura', 376.0000, 'ºC'),
	(282295, 122, '2014-04-01 00:03:28.000000', 'temperatura', 265.0000, 'ºC'),
	(282296, 122, '2014-04-01 00:03:29.000000', 'temperatura', 198.0000, 'ºC'),
	(282297, 122, '2014-04-01 00:03:30.000000', 'temperatura', 194.0000, 'ºC'),
	(282298, 122, '2014-04-01 00:03:31.000000', 'temperatura', 379.0000, 'ºC'),
	(282299, 122, '2014-04-01 00:03:32.000000', 'temperatura', 112.0000, 'ºC'),
	(282300, 122, '2014-04-01 00:03:33.000000', 'temperatura', 625.0000, 'ºC'),
	(282301, 122, '2014-04-01 00:03:34.000000', 'temperatura', 389.0000, 'ºC'),
	(282302, 122, '2014-04-01 00:03:35.000000', 'temperatura', 70.0000, 'ºC'),
	(282303, 122, '2014-04-01 00:03:36.000000', 'temperatura', 386.0000, 'ºC'),
	(282304, 122, '2014-04-01 00:03:37.000000', 'temperatura', 518.0000, 'ºC'),
	(282305, 122, '2014-04-01 00:03:38.000000', 'temperatura', 232.0000, 'ºC'),
	(282306, 122, '2014-04-01 00:03:39.000000', 'temperatura', 808.0000, 'ºC'),
	(282307, 122, '2014-04-01 00:03:40.000000', 'temperatura', 943.0000, 'ºC'),
	(282308, 122, '2014-04-01 00:03:41.000000', 'temperatura', 1091.0000, 'ºC'),
	(282309, 122, '2014-04-01 00:03:42.000000', 'temperatura', 225.0000, 'ºC'),
	(282310, 122, '2014-04-01 00:03:43.000000', 'temperatura', 256.0000, 'ºC'),
	(282311, 122, '2014-04-01 00:03:44.000000', 'temperatura', 603.0000, 'ºC'),
	(282312, 122, '2014-04-01 00:03:45.000000', 'temperatura', 1046.0000, 'ºC'),
	(282313, 122, '2014-04-01 00:03:46.000000', 'temperatura', 1024.0000, 'ºC'),
	(282314, 122, '2014-04-01 00:03:47.000000', 'temperatura', 783.0000, 'ºC'),
	(282315, 122, '2014-04-01 00:03:48.000000', 'temperatura', 842.0000, 'ºC'),
	(282316, 122, '2014-04-01 00:03:49.000000', 'temperatura', 664.0000, 'ºC'),
	(282317, 122, '2014-04-01 00:03:50.000000', 'temperatura', 792.0000, 'ºC'),
	(282318, 122, '2014-04-01 00:03:51.000000', 'temperatura', 770.0000, 'ºC'),
	(282319, 122, '2014-04-01 00:03:52.000000', 'temperatura', 274.0000, 'ºC'),
	(282320, 122, '2014-04-01 00:03:53.000000', 'temperatura', 259.0000, 'ºC'),
	(282321, 122, '2014-04-01 00:03:54.000000', 'temperatura', 476.0000, 'ºC'),
	(282322, 122, '2014-04-01 00:03:55.000000', 'temperatura', 403.0000, 'ºC'),
	(282323, 122, '2014-04-01 00:03:56.000000', 'temperatura', 586.0000, 'ºC'),
	(282324, 122, '2014-04-01 00:03:57.000000', 'temperatura', 524.0000, 'ºC'),
	(282325, 122, '2014-04-01 00:03:58.000000', 'temperatura', 860.0000, 'ºC'),
	(282326, 122, '2014-04-01 00:03:59.000000', 'temperatura', 331.0000, 'ºC'),
	(282327, 122, '2014-04-01 00:04:00.000000', 'temperatura', 274.0000, 'ºC'),
	(282328, 122, '2014-04-01 00:04:01.000000', 'temperatura', 379.0000, 'ºC'),
	(282329, 122, '2014-04-01 00:04:02.000000', 'temperatura', 1072.0000, 'ºC'),
	(282330, 122, '2014-04-01 00:04:03.000000', 'temperatura', 625.0000, 'ºC'),
	(282331, 122, '2014-04-01 00:04:04.000000', 'temperatura', 1107.0000, 'ºC'),
	(282332, 122, '2014-04-01 00:04:05.000000', 'temperatura', 64.0000, 'ºC'),
	(282333, 122, '2014-04-01 00:04:06.000000', 'temperatura', 597.0000, 'ºC'),
	(282334, 122, '2014-04-01 00:04:07.000000', 'temperatura', 395.0000, 'ºC'),
	(282335, 122, '2014-04-01 00:04:08.000000', 'temperatura', 184.0000, 'ºC'),
	(282336, 122, '2014-04-01 00:04:09.000000', 'temperatura', 936.0000, 'ºC'),
	(282337, 122, '2014-04-01 00:04:10.000000', 'temperatura', 529.0000, 'ºC'),
	(282338, 122, '2014-04-01 00:04:11.000000', 'temperatura', 1037.0000, 'ºC'),
	(282339, 122, '2014-04-01 00:04:12.000000', 'temperatura', 1198.0000, 'ºC'),
	(282340, 122, '2014-04-01 00:04:13.000000', 'temperatura', 480.0000, 'ºC'),
	(282341, 122, '2014-04-01 00:04:14.000000', 'temperatura', 5.0000, 'ºC'),
	(282342, 122, '2014-04-01 00:04:15.000000', 'temperatura', 987.0000, 'ºC'),
	(282343, 122, '2014-04-01 00:04:16.000000', 'temperatura', 121.0000, 'ºC'),
	(282344, 122, '2014-04-01 00:04:17.000000', 'temperatura', 42.0000, 'ºC'),
	(282345, 122, '2014-04-01 00:04:18.000000', 'temperatura', 1051.0000, 'ºC'),
	(282346, 122, '2014-04-01 00:04:19.000000', 'temperatura', 327.0000, 'ºC'),
	(282347, 122, '2014-04-01 00:04:20.000000', 'temperatura', 883.0000, 'ºC'),
	(282348, 122, '2014-04-01 00:04:21.000000', 'temperatura', 1035.0000, 'ºC'),
	(282349, 122, '2014-04-01 00:04:22.000000', 'temperatura', 128.0000, 'ºC'),
	(282350, 122, '2014-04-01 00:04:23.000000', 'temperatura', 1136.0000, 'ºC'),
	(282351, 122, '2014-04-01 00:04:24.000000', 'temperatura', 495.0000, 'ºC'),
	(282352, 122, '2014-04-01 00:04:25.000000', 'temperatura', 267.0000, 'ºC'),
	(282353, 122, '2014-04-01 00:04:26.000000', 'temperatura', 1052.0000, 'ºC'),
	(282354, 122, '2014-04-01 00:04:27.000000', 'temperatura', 860.0000, 'ºC'),
	(282355, 122, '2014-04-01 00:04:28.000000', 'temperatura', 1144.0000, 'ºC'),
	(282356, 122, '2014-04-01 00:04:29.000000', 'temperatura', 738.0000, 'ºC'),
	(282357, 122, '2014-04-01 00:04:30.000000', 'temperatura', 261.0000, 'ºC'),
	(282358, 122, '2014-04-01 00:04:31.000000', 'temperatura', 293.0000, 'ºC'),
	(282359, 122, '2014-04-01 00:04:32.000000', 'temperatura', 681.0000, 'ºC'),
	(282360, 122, '2014-04-01 00:04:33.000000', 'temperatura', 126.0000, 'ºC'),
	(282361, 122, '2014-04-01 00:04:34.000000', 'temperatura', 987.0000, 'ºC'),
	(282362, 122, '2014-04-01 00:04:35.000000', 'temperatura', 957.0000, 'ºC'),
	(282363, 122, '2014-04-01 00:04:36.000000', 'temperatura', 623.0000, 'ºC'),
	(282364, 122, '2014-04-01 00:04:37.000000', 'temperatura', 247.0000, 'ºC'),
	(282365, 122, '2014-04-01 00:04:38.000000', 'temperatura', 568.0000, 'ºC'),
	(282366, 122, '2014-04-01 00:04:39.000000', 'temperatura', 897.0000, 'ºC'),
	(282367, 122, '2014-04-01 00:04:40.000000', 'temperatura', 384.0000, 'ºC'),
	(282368, 122, '2014-04-01 00:04:41.000000', 'temperatura', 427.0000, 'ºC'),
	(282369, 122, '2014-04-01 00:04:42.000000', 'temperatura', 986.0000, 'ºC'),
	(282370, 122, '2014-04-01 00:04:43.000000', 'temperatura', 49.0000, 'ºC'),
	(282371, 122, '2014-04-01 00:04:44.000000', 'temperatura', 888.0000, 'ºC'),
	(282372, 122, '2014-04-01 00:04:45.000000', 'temperatura', 692.0000, 'ºC'),
	(282373, 122, '2014-04-01 00:04:46.000000', 'temperatura', 799.0000, 'ºC'),
	(282374, 122, '2014-04-01 00:04:47.000000', 'temperatura', 716.0000, 'ºC'),
	(282375, 122, '2014-04-01 00:04:48.000000', 'temperatura', 1187.0000, 'ºC'),
	(282376, 122, '2014-04-01 00:04:49.000000', 'temperatura', 187.0000, 'ºC'),
	(282377, 122, '2014-04-01 00:04:50.000000', 'temperatura', 972.0000, 'ºC'),
	(282378, 122, '2014-04-01 00:04:51.000000', 'temperatura', 702.0000, 'ºC'),
	(282379, 122, '2014-04-01 00:04:52.000000', 'temperatura', 593.0000, 'ºC'),
	(282380, 122, '2014-04-01 00:04:53.000000', 'temperatura', 858.0000, 'ºC'),
	(282381, 122, '2014-04-01 00:04:54.000000', 'temperatura', 112.0000, 'ºC'),
	(282382, 122, '2014-04-01 00:04:55.000000', 'temperatura', 388.0000, 'ºC'),
	(282383, 122, '2014-04-01 00:04:56.000000', 'temperatura', 405.0000, 'ºC'),
	(282384, 122, '2014-04-01 00:04:57.000000', 'temperatura', 862.0000, 'ºC'),
	(282385, 122, '2014-04-01 00:04:58.000000', 'temperatura', 694.0000, 'ºC'),
	(282386, 122, '2014-04-01 00:04:59.000000', 'temperatura', 885.0000, 'ºC'),
	(282387, 122, '2014-04-01 00:05:00.000000', 'temperatura', 1143.0000, 'ºC'),
	(282388, 122, '2014-04-01 00:05:01.000000', 'temperatura', 659.0000, 'ºC'),
	(282389, 122, '2014-04-01 00:05:02.000000', 'temperatura', 1066.0000, 'ºC'),
	(282390, 122, '2014-04-01 00:05:03.000000', 'temperatura', 957.0000, 'ºC'),
	(282391, 122, '2014-04-01 00:05:04.000000', 'temperatura', 385.0000, 'ºC'),
	(282392, 122, '2014-04-01 00:05:05.000000', 'temperatura', 254.0000, 'ºC'),
	(282393, 122, '2014-04-01 00:05:06.000000', 'temperatura', 118.0000, 'ºC'),
	(282394, 122, '2014-04-01 00:05:07.000000', 'temperatura', 1028.0000, 'ºC'),
	(282395, 122, '2014-04-01 00:05:08.000000', 'temperatura', 1187.0000, 'ºC'),
	(282396, 122, '2014-04-01 00:05:09.000000', 'temperatura', 452.0000, 'ºC'),
	(282397, 122, '2014-04-01 00:05:10.000000', 'temperatura', 1099.0000, 'ºC'),
	(282398, 122, '2014-04-01 00:05:11.000000', 'temperatura', 540.0000, 'ºC'),
	(282399, 122, '2014-04-01 00:05:12.000000', 'temperatura', 604.0000, 'ºC'),
	(282400, 122, '2014-04-01 00:05:13.000000', 'temperatura', 198.0000, 'ºC'),
	(282401, 122, '2014-04-01 00:05:14.000000', 'temperatura', 378.0000, 'ºC'),
	(282402, 122, '2014-04-01 00:05:15.000000', 'temperatura', 100.0000, 'ºC'),
	(282403, 122, '2014-04-01 00:05:16.000000', 'temperatura', 563.0000, 'ºC'),
	(282404, 122, '2014-04-01 00:05:17.000000', 'temperatura', 118.0000, 'ºC'),
	(282405, 122, '2014-04-01 00:05:18.000000', 'temperatura', 101.0000, 'ºC'),
	(282406, 122, '2014-04-01 00:05:19.000000', 'temperatura', 152.0000, 'ºC'),
	(282407, 122, '2014-04-01 00:05:20.000000', 'temperatura', 459.0000, 'ºC'),
	(282408, 122, '2014-04-01 00:05:21.000000', 'temperatura', 638.0000, 'ºC'),
	(282409, 122, '2014-04-01 00:05:22.000000', 'temperatura', 612.0000, 'ºC'),
	(282410, 122, '2014-04-01 00:05:23.000000', 'temperatura', 1149.0000, 'ºC'),
	(282411, 122, '2014-04-01 00:05:24.000000', 'temperatura', 308.0000, 'ºC'),
	(282412, 122, '2014-04-01 00:05:25.000000', 'temperatura', 493.0000, 'ºC'),
	(282413, 122, '2014-04-01 00:05:26.000000', 'temperatura', 341.0000, 'ºC'),
	(282414, 122, '2014-04-01 00:05:27.000000', 'temperatura', 226.0000, 'ºC'),
	(282415, 122, '2014-04-01 00:05:28.000000', 'temperatura', 106.0000, 'ºC'),
	(282416, 122, '2014-04-01 00:05:29.000000', 'temperatura', 1056.0000, 'ºC'),
	(282417, 122, '2014-04-01 00:05:30.000000', 'temperatura', 161.0000, 'ºC'),
	(282418, 122, '2014-04-01 00:05:31.000000', 'temperatura', 39.0000, 'ºC'),
	(282419, 122, '2014-04-01 00:05:32.000000', 'temperatura', 914.0000, 'ºC'),
	(282420, 122, '2014-04-01 00:05:33.000000', 'temperatura', 850.0000, 'ºC'),
	(282421, 122, '2014-04-01 00:05:34.000000', 'temperatura', 309.0000, 'ºC'),
	(282422, 122, '2014-04-01 00:05:35.000000', 'temperatura', 196.0000, 'ºC'),
	(282423, 122, '2014-04-01 00:05:36.000000', 'temperatura', 54.0000, 'ºC'),
	(282424, 122, '2014-04-01 00:05:37.000000', 'temperatura', 881.0000, 'ºC'),
	(282425, 122, '2014-04-01 00:05:38.000000', 'temperatura', 645.0000, 'ºC'),
	(282426, 122, '2014-04-01 00:05:39.000000', 'temperatura', 581.0000, 'ºC'),
	(282427, 122, '2014-04-01 00:05:40.000000', 'temperatura', 973.0000, 'ºC'),
	(282428, 122, '2014-04-01 00:05:41.000000', 'temperatura', 720.0000, 'ºC'),
	(282429, 122, '2014-04-01 00:05:42.000000', 'temperatura', 684.0000, 'ºC'),
	(282430, 122, '2014-04-01 00:05:43.000000', 'temperatura', 58.0000, 'ºC'),
	(282431, 122, '2014-04-01 00:05:44.000000', 'temperatura', 639.0000, 'ºC'),
	(282432, 122, '2014-04-01 00:05:45.000000', 'temperatura', 622.0000, 'ºC'),
	(282433, 122, '2014-04-01 00:05:46.000000', 'temperatura', 1194.0000, 'ºC'),
	(282434, 122, '2014-04-01 00:05:47.000000', 'temperatura', 504.0000, 'ºC'),
	(282435, 122, '2014-04-01 00:05:48.000000', 'temperatura', 140.0000, 'ºC'),
	(282436, 122, '2014-04-01 00:05:49.000000', 'temperatura', 388.0000, 'ºC'),
	(282437, 122, '2014-04-01 00:05:50.000000', 'temperatura', 322.0000, 'ºC'),
	(282438, 122, '2014-04-01 00:05:51.000000', 'temperatura', 444.0000, 'ºC'),
	(282439, 122, '2014-04-01 00:05:52.000000', 'temperatura', 57.0000, 'ºC'),
	(282440, 122, '2014-04-01 00:05:53.000000', 'temperatura', 151.0000, 'ºC'),
	(282441, 122, '2014-04-01 00:05:54.000000', 'temperatura', 587.0000, 'ºC'),
	(282442, 122, '2014-04-01 00:05:55.000000', 'temperatura', 83.0000, 'ºC'),
	(282443, 122, '2014-04-01 00:05:56.000000', 'temperatura', 1055.0000, 'ºC'),
	(282444, 122, '2014-04-01 00:05:57.000000', 'temperatura', 223.0000, 'ºC'),
	(282445, 122, '2014-04-01 00:05:58.000000', 'temperatura', 354.0000, 'ºC'),
	(282446, 122, '2014-04-01 00:05:59.000000', 'temperatura', 1099.0000, 'ºC'),
	(282447, 122, '2014-04-01 00:06:00.000000', 'temperatura', 833.0000, 'ºC'),
	(282448, 122, '2014-04-01 00:06:01.000000', 'temperatura', 868.0000, 'ºC'),
	(282449, 122, '2014-04-01 00:06:02.000000', 'temperatura', 645.0000, 'ºC'),
	(282450, 122, '2014-04-01 00:06:03.000000', 'temperatura', 618.0000, 'ºC'),
	(282451, 122, '2014-04-01 00:06:04.000000', 'temperatura', 1155.0000, 'ºC'),
	(282452, 122, '2014-04-01 00:06:05.000000', 'temperatura', 324.0000, 'ºC'),
	(282453, 122, '2014-04-01 00:06:06.000000', 'temperatura', 553.0000, 'ºC'),
	(282454, 122, '2014-04-01 00:06:07.000000', 'temperatura', 595.0000, 'ºC'),
	(282455, 122, '2014-04-01 00:06:08.000000', 'temperatura', 117.0000, 'ºC'),
	(282456, 122, '2014-04-01 00:06:09.000000', 'temperatura', 1199.0000, 'ºC'),
	(282457, 122, '2014-04-01 00:06:10.000000', 'temperatura', 844.0000, 'ºC'),
	(282458, 122, '2014-04-01 00:06:11.000000', 'temperatura', 623.0000, 'ºC'),
	(282459, 122, '2014-04-01 00:06:12.000000', 'temperatura', 587.0000, 'ºC'),
	(282460, 122, '2014-04-01 00:06:13.000000', 'temperatura', 1063.0000, 'ºC'),
	(282461, 122, '2014-04-01 00:06:14.000000', 'temperatura', 1154.0000, 'ºC'),
	(282462, 122, '2014-04-01 00:06:15.000000', 'temperatura', 182.0000, 'ºC'),
	(282463, 122, '2014-04-01 00:06:16.000000', 'temperatura', 1051.0000, 'ºC'),
	(282464, 122, '2014-04-01 00:06:17.000000', 'temperatura', 1107.0000, 'ºC'),
	(282465, 122, '2014-04-01 00:06:18.000000', 'temperatura', 1185.0000, 'ºC'),
	(282466, 122, '2014-04-01 00:06:19.000000', 'temperatura', 205.0000, 'ºC'),
	(282467, 122, '2014-04-01 00:06:20.000000', 'temperatura', 1068.0000, 'ºC'),
	(282468, 122, '2014-04-01 00:06:21.000000', 'temperatura', 1124.0000, 'ºC'),
	(282469, 122, '2014-04-01 00:06:22.000000', 'temperatura', 19.0000, 'ºC'),
	(282470, 122, '2014-04-01 00:06:23.000000', 'temperatura', 324.0000, 'ºC'),
	(282471, 122, '2014-04-01 00:06:24.000000', 'temperatura', 364.0000, 'ºC'),
	(282472, 122, '2014-04-01 00:06:25.000000', 'temperatura', 849.0000, 'ºC'),
	(282473, 122, '2014-04-01 00:06:26.000000', 'temperatura', 751.0000, 'ºC'),
	(282474, 122, '2014-04-01 00:06:27.000000', 'temperatura', 8.0000, 'ºC'),
	(282475, 122, '2014-04-01 00:06:28.000000', 'temperatura', 188.0000, 'ºC'),
	(282476, 122, '2014-04-01 00:06:29.000000', 'temperatura', 918.0000, 'ºC'),
	(282477, 122, '2014-04-01 00:06:30.000000', 'temperatura', 425.0000, 'ºC'),
	(282478, 122, '2014-04-01 00:06:31.000000', 'temperatura', 571.0000, 'ºC'),
	(282479, 122, '2014-04-01 00:06:32.000000', 'temperatura', 382.0000, 'ºC'),
	(282480, 122, '2014-04-01 00:06:33.000000', 'temperatura', 198.0000, 'ºC'),
	(282481, 122, '2014-04-01 00:06:34.000000', 'temperatura', 1045.0000, 'ºC'),
	(282482, 122, '2014-04-01 00:06:35.000000', 'temperatura', 1029.0000, 'ºC'),
	(282483, 122, '2014-04-01 00:06:36.000000', 'temperatura', 810.0000, 'ºC'),
	(282484, 122, '2014-04-01 00:06:37.000000', 'temperatura', 966.0000, 'ºC'),
	(282485, 122, '2014-04-01 00:06:38.000000', 'temperatura', 0.0000, 'ºC'),
	(282486, 122, '2014-04-01 00:06:39.000000', 'temperatura', 703.0000, 'ºC'),
	(282487, 122, '2014-04-01 00:06:40.000000', 'temperatura', 1113.0000, 'ºC'),
	(282488, 122, '2014-04-01 00:06:41.000000', 'temperatura', 1057.0000, 'ºC'),
	(282489, 122, '2014-04-01 00:06:42.000000', 'temperatura', 749.0000, 'ºC'),
	(282490, 122, '2014-04-01 00:06:43.000000', 'temperatura', 572.0000, 'ºC'),
	(282491, 122, '2014-04-01 00:06:44.000000', 'temperatura', 614.0000, 'ºC'),
	(282492, 122, '2014-04-01 00:06:45.000000', 'temperatura', 154.0000, 'ºC'),
	(282493, 122, '2014-04-01 00:06:46.000000', 'temperatura', 129.0000, 'ºC'),
	(282494, 122, '2014-04-01 00:06:47.000000', 'temperatura', 184.0000, 'ºC'),
	(282495, 122, '2014-04-01 00:06:48.000000', 'temperatura', 533.0000, 'ºC'),
	(282496, 122, '2014-04-01 00:06:49.000000', 'temperatura', 914.0000, 'ºC'),
	(282497, 122, '2014-04-01 00:06:50.000000', 'temperatura', 569.0000, 'ºC'),
	(282498, 122, '2014-04-01 00:06:51.000000', 'temperatura', 106.0000, 'ºC'),
	(282499, 122, '2014-04-01 00:06:52.000000', 'temperatura', 22.0000, 'ºC'),
	(282500, 122, '2014-04-01 00:06:53.000000', 'temperatura', 994.0000, 'ºC'),
	(282501, 122, '2014-04-01 00:06:54.000000', 'temperatura', 106.0000, 'ºC'),
	(282502, 122, '2014-04-01 00:06:55.000000', 'temperatura', 1147.0000, 'ºC'),
	(282503, 122, '2014-04-01 00:06:56.000000', 'temperatura', 616.0000, 'ºC'),
	(282504, 122, '2014-04-01 00:06:57.000000', 'temperatura', 840.0000, 'ºC'),
	(282505, 122, '2014-04-01 00:06:58.000000', 'temperatura', 1153.0000, 'ºC'),
	(282506, 122, '2014-04-01 00:06:59.000000', 'temperatura', 846.0000, 'ºC'),
	(282507, 122, '2014-04-01 00:07:00.000000', 'temperatura', 772.0000, 'ºC'),
	(282508, 122, '2014-04-01 00:07:01.000000', 'temperatura', 120.0000, 'ºC'),
	(282509, 122, '2014-04-01 00:07:02.000000', 'temperatura', 687.0000, 'ºC'),
	(282510, 122, '2014-04-01 00:07:03.000000', 'temperatura', 675.0000, 'ºC'),
	(282511, 122, '2014-04-01 00:07:04.000000', 'temperatura', 112.0000, 'ºC'),
	(282512, 122, '2014-04-01 00:07:05.000000', 'temperatura', 939.0000, 'ºC'),
	(282513, 122, '2014-04-01 00:07:06.000000', 'temperatura', 758.0000, 'ºC'),
	(282514, 122, '2014-04-01 00:07:07.000000', 'temperatura', 974.0000, 'ºC'),
	(282515, 122, '2014-04-01 00:07:08.000000', 'temperatura', 196.0000, 'ºC'),
	(282516, 122, '2014-04-01 00:07:09.000000', 'temperatura', 457.0000, 'ºC'),
	(282517, 122, '2014-04-01 00:07:10.000000', 'temperatura', 500.0000, 'ºC'),
	(282518, 122, '2014-04-01 00:07:11.000000', 'temperatura', 1130.0000, 'ºC'),
	(282519, 122, '2014-04-01 00:07:12.000000', 'temperatura', 547.0000, 'ºC'),
	(282520, 122, '2014-04-01 00:07:13.000000', 'temperatura', 549.0000, 'ºC'),
	(282521, 122, '2014-04-01 00:07:14.000000', 'temperatura', 1102.0000, 'ºC'),
	(282522, 122, '2014-04-01 00:07:15.000000', 'temperatura', 266.0000, 'ºC'),
	(282523, 122, '2014-04-01 00:07:16.000000', 'temperatura', 423.0000, 'ºC'),
	(282524, 122, '2014-04-01 00:07:17.000000', 'temperatura', 116.0000, 'ºC'),
	(282525, 122, '2014-04-01 00:07:18.000000', 'temperatura', 512.0000, 'ºC'),
	(282526, 122, '2014-04-01 00:07:19.000000', 'temperatura', 1013.0000, 'ºC'),
	(282527, 122, '2014-04-01 00:07:20.000000', 'temperatura', 1128.0000, 'ºC'),
	(282528, 122, '2014-04-01 00:07:21.000000', 'temperatura', 203.0000, 'ºC'),
	(282529, 122, '2014-04-01 00:07:22.000000', 'temperatura', 30.0000, 'ºC'),
	(282530, 122, '2014-04-01 00:07:23.000000', 'temperatura', 741.0000, 'ºC'),
	(282531, 122, '2014-04-01 00:07:24.000000', 'temperatura', 17.0000, 'ºC'),
	(282532, 122, '2014-04-01 00:07:25.000000', 'temperatura', 263.0000, 'ºC'),
	(282533, 122, '2014-04-01 00:07:26.000000', 'temperatura', 63.0000, 'ºC'),
	(282534, 122, '2014-04-01 00:07:27.000000', 'temperatura', 727.0000, 'ºC'),
	(282535, 122, '2014-04-01 00:07:28.000000', 'temperatura', 1046.0000, 'ºC'),
	(282536, 122, '2014-04-01 00:07:29.000000', 'temperatura', 649.0000, 'ºC'),
	(282537, 122, '2014-04-01 00:07:30.000000', 'temperatura', 107.0000, 'ºC'),
	(282538, 122, '2014-04-01 00:07:31.000000', 'temperatura', 991.0000, 'ºC'),
	(282539, 122, '2014-04-01 00:07:32.000000', 'temperatura', 1035.0000, 'ºC'),
	(282540, 122, '2014-04-01 00:07:33.000000', 'temperatura', 1002.0000, 'ºC'),
	(282541, 122, '2014-04-01 00:07:34.000000', 'temperatura', 703.0000, 'ºC'),
	(282542, 122, '2014-04-01 00:07:35.000000', 'temperatura', 512.0000, 'ºC'),
	(282543, 122, '2014-04-01 00:07:36.000000', 'temperatura', 451.0000, 'ºC'),
	(282544, 122, '2014-04-01 00:07:37.000000', 'temperatura', 718.0000, 'ºC'),
	(282545, 122, '2014-04-01 00:07:38.000000', 'temperatura', 1040.0000, 'ºC'),
	(282546, 122, '2014-04-01 00:07:39.000000', 'temperatura', 644.0000, 'ºC'),
	(282547, 122, '2014-04-01 00:07:40.000000', 'temperatura', 100.0000, 'ºC'),
	(282548, 122, '2014-04-01 00:07:41.000000', 'temperatura', 970.0000, 'ºC'),
	(282549, 122, '2014-04-01 00:07:42.000000', 'temperatura', 952.0000, 'ºC'),
	(282550, 122, '2014-04-01 00:07:43.000000', 'temperatura', 648.0000, 'ºC'),
	(282551, 122, '2014-04-01 00:07:44.000000', 'temperatura', 385.0000, 'ºC'),
	(282552, 122, '2014-04-01 00:07:45.000000', 'temperatura', 1182.0000, 'ºC'),
	(282553, 122, '2014-04-01 00:07:46.000000', 'temperatura', 1156.0000, 'ºC'),
	(282554, 122, '2014-04-01 00:07:47.000000', 'temperatura', 1036.0000, 'ºC'),
	(282555, 122, '2014-04-01 00:07:48.000000', 'temperatura', 511.0000, 'ºC'),
	(282556, 122, '2014-04-01 00:07:49.000000', 'temperatura', 647.0000, 'ºC'),
	(282557, 122, '2014-04-01 00:07:50.000000', 'temperatura', 505.0000, 'ºC'),
	(282558, 122, '2014-04-01 00:07:51.000000', 'temperatura', 581.0000, 'ºC'),
	(282559, 122, '2014-04-01 00:07:52.000000', 'temperatura', 194.0000, 'ºC'),
	(282560, 122, '2014-04-01 00:07:53.000000', 'temperatura', 424.0000, 'ºC'),
	(282561, 122, '2014-04-01 00:07:54.000000', 'temperatura', 342.0000, 'ºC'),
	(282562, 122, '2014-04-01 00:07:55.000000', 'temperatura', 436.0000, 'ºC'),
	(282563, 122, '2014-04-01 00:07:56.000000', 'temperatura', 1154.0000, 'ºC'),
	(282564, 122, '2014-04-01 00:07:57.000000', 'temperatura', 865.0000, 'ºC'),
	(282565, 122, '2014-04-01 00:07:58.000000', 'temperatura', 864.0000, 'ºC'),
	(282566, 122, '2014-04-01 00:07:59.000000', 'temperatura', 523.0000, 'ºC'),
	(282567, 122, '2014-04-01 00:08:00.000000', 'temperatura', 25.0000, 'ºC'),
	(282568, 122, '2014-04-01 00:08:01.000000', 'temperatura', 954.0000, 'ºC'),
	(282569, 122, '2014-04-01 00:08:02.000000', 'temperatura', 1099.0000, 'ºC'),
	(282570, 122, '2014-04-01 00:08:03.000000', 'temperatura', 233.0000, 'ºC'),
	(282571, 122, '2014-04-01 00:08:04.000000', 'temperatura', 266.0000, 'ºC'),
	(282572, 122, '2014-04-01 00:08:05.000000', 'temperatura', 632.0000, 'ºC'),
	(282573, 122, '2014-04-01 00:08:06.000000', 'temperatura', 1164.0000, 'ºC'),
	(282574, 122, '2014-04-01 00:08:07.000000', 'temperatura', 324.0000, 'ºC'),
	(282575, 122, '2014-04-01 00:08:08.000000', 'temperatura', 530.0000, 'ºC'),
	(282576, 122, '2014-04-01 00:08:09.000000', 'temperatura', 476.0000, 'ºC'),
	(282577, 122, '2014-04-01 00:08:10.000000', 'temperatura', 790.0000, 'ºC'),
	(282578, 122, '2014-04-01 00:08:11.000000', 'temperatura', 125.0000, 'ºC'),
	(282579, 122, '2014-04-01 00:08:12.000000', 'temperatura', 653.0000, 'ºC'),
	(282580, 122, '2014-04-01 00:08:13.000000', 'temperatura', 491.0000, 'ºC'),
	(282581, 122, '2014-04-01 00:08:14.000000', 'temperatura', 497.0000, 'ºC'),
	(282582, 122, '2014-04-01 00:08:15.000000', 'temperatura', 1014.0000, 'ºC'),
	(282583, 122, '2014-04-01 00:08:16.000000', 'temperatura', 1179.0000, 'ºC'),
	(282584, 122, '2014-04-01 00:08:17.000000', 'temperatura', 453.0000, 'ºC'),
	(282585, 122, '2014-04-01 00:08:18.000000', 'temperatura', 1127.0000, 'ºC'),
	(282586, 122, '2014-04-01 00:08:19.000000', 'temperatura', 678.0000, 'ºC'),
	(282587, 122, '2014-04-01 00:08:20.000000', 'temperatura', 10.0000, 'ºC'),
	(282588, 122, '2014-04-01 00:08:21.000000', 'temperatura', 416.0000, 'ºC'),
	(282589, 122, '2014-04-01 00:08:22.000000', 'temperatura', 851.0000, 'ºC'),
	(282590, 122, '2014-04-01 00:08:23.000000', 'temperatura', 606.0000, 'ºC'),
	(282591, 122, '2014-04-01 00:08:24.000000', 'temperatura', 480.0000, 'ºC'),
	(282592, 122, '2014-04-01 00:08:25.000000', 'temperatura', 583.0000, 'ºC'),
	(282593, 122, '2014-04-01 00:08:26.000000', 'temperatura', 273.0000, 'ºC'),
	(282594, 122, '2014-04-01 00:08:27.000000', 'temperatura', 819.0000, 'ºC'),
	(282595, 122, '2014-04-01 00:08:28.000000', 'temperatura', 874.0000, 'ºC'),
	(282596, 122, '2014-04-01 00:08:29.000000', 'temperatura', 714.0000, 'ºC'),
	(282597, 122, '2014-04-01 00:08:30.000000', 'temperatura', 951.0000, 'ºC'),
	(282598, 122, '2014-04-01 00:08:31.000000', 'temperatura', 210.0000, 'ºC'),
	(282599, 122, '2014-04-01 00:08:32.000000', 'temperatura', 601.0000, 'ºC'),
	(282600, 122, '2014-04-01 00:08:33.000000', 'temperatura', 1173.0000, 'ºC'),
	(282601, 122, '2014-04-01 00:08:34.000000', 'temperatura', 461.0000, 'ºC'),
	(282602, 122, '2014-04-01 00:08:35.000000', 'temperatura', 1190.0000, 'ºC'),
	(282603, 122, '2014-04-01 00:08:36.000000', 'temperatura', 965.0000, 'ºC'),
	(282604, 122, '2014-04-01 00:08:37.000000', 'temperatura', 54.0000, 'ºC'),
	(282605, 122, '2014-04-01 00:08:38.000000', 'temperatura', 978.0000, 'ºC'),
	(282606, 122, '2014-04-01 00:08:39.000000', 'temperatura', 1129.0000, 'ºC'),
	(282607, 122, '2014-04-01 00:08:40.000000', 'temperatura', 312.0000, 'ºC'),
	(282608, 122, '2014-04-01 00:08:41.000000', 'temperatura', 571.0000, 'ºC'),
	(282609, 122, '2014-04-01 00:08:42.000000', 'temperatura', 722.0000, 'ºC'),
	(282610, 122, '2014-04-01 00:08:43.000000', 'temperatura', 695.0000, 'ºC'),
	(282611, 122, '2014-04-01 00:08:44.000000', 'temperatura', 110.0000, 'ºC'),
	(282612, 122, '2014-04-01 00:08:45.000000', 'temperatura', 867.0000, 'ºC'),
	(282613, 122, '2014-04-01 00:08:46.000000', 'temperatura', 403.0000, 'ºC'),
	(282614, 122, '2014-04-01 00:08:47.000000', 'temperatura', 616.0000, 'ºC'),
	(282615, 122, '2014-04-01 00:08:48.000000', 'temperatura', 670.0000, 'ºC'),
	(282616, 122, '2014-04-01 00:08:49.000000', 'temperatura', 305.0000, 'ºC'),
	(282617, 122, '2014-04-01 00:08:50.000000', 'temperatura', 716.0000, 'ºC'),
	(282618, 122, '2014-04-01 00:08:51.000000', 'temperatura', 266.0000, 'ºC'),
	(282619, 122, '2014-04-01 00:08:52.000000', 'temperatura', 380.0000, 'ºC'),
	(282620, 122, '2014-04-01 00:08:53.000000', 'temperatura', 1104.0000, 'ºC'),
	(282621, 122, '2014-04-01 00:08:54.000000', 'temperatura', 778.0000, 'ºC'),
	(282622, 122, '2014-04-01 00:08:55.000000', 'temperatura', 582.0000, 'ºC'),
	(282623, 122, '2014-04-01 00:08:56.000000', 'temperatura', 574.0000, 'ºC'),
	(282624, 122, '2014-04-01 00:08:57.000000', 'temperatura', 1126.0000, 'ºC'),
	(282625, 122, '2014-04-01 00:08:58.000000', 'temperatura', 308.0000, 'ºC'),
	(282626, 122, '2014-04-01 00:08:59.000000', 'temperatura', 564.0000, 'ºC'),
	(282627, 122, '2014-04-01 00:09:00.000000', 'temperatura', 694.0000, 'ºC'),
	(282628, 122, '2014-04-01 00:09:01.000000', 'temperatura', 581.0000, 'ºC'),
	(282629, 122, '2014-04-01 00:09:02.000000', 'temperatura', 822.0000, 'ºC'),
	(282630, 122, '2014-04-01 00:09:03.000000', 'temperatura', 1168.0000, 'ºC'),
	(282631, 122, '2014-04-01 00:09:04.000000', 'temperatura', 972.0000, 'ºC'),
	(282632, 122, '2014-04-01 00:09:05.000000', 'temperatura', 159.0000, 'ºC'),
	(282633, 122, '2014-04-01 00:09:06.000000', 'temperatura', 280.0000, 'ºC'),
	(282634, 122, '2014-04-01 00:09:07.000000', 'temperatura', 921.0000, 'ºC'),
	(282635, 122, '2014-04-01 00:09:08.000000', 'temperatura', 166.0000, 'ºC'),
	(282636, 122, '2014-04-01 00:09:09.000000', 'temperatura', 469.0000, 'ºC'),
	(282637, 122, '2014-04-01 00:09:10.000000', 'temperatura', 646.0000, 'ºC'),
	(282638, 122, '2014-04-01 00:09:11.000000', 'temperatura', 623.0000, 'ºC'),
	(282639, 122, '2014-04-01 00:09:12.000000', 'temperatura', 1178.0000, 'ºC'),
	(282640, 122, '2014-04-01 00:09:13.000000', 'temperatura', 420.0000, 'ºC'),
	(282641, 122, '2014-04-01 00:09:14.000000', 'temperatura', 967.0000, 'ºC'),
	(282642, 122, '2014-04-01 00:09:15.000000', 'temperatura', 1174.0000, 'ºC'),
	(282643, 122, '2014-04-01 00:09:16.000000', 'temperatura', 573.0000, 'ºC'),
	(282644, 122, '2014-04-01 00:09:17.000000', 'temperatura', 541.0000, 'ºC'),
	(282645, 122, '2014-04-01 00:09:18.000000', 'temperatura', 986.0000, 'ºC'),
	(282646, 122, '2014-04-01 00:09:19.000000', 'temperatura', 909.0000, 'ºC'),
	(282647, 122, '2014-04-01 00:09:20.000000', 'temperatura', 386.0000, 'ºC'),
	(282648, 122, '2014-04-01 00:09:21.000000', 'temperatura', 404.0000, 'ºC'),
	(282649, 122, '2014-04-01 00:09:22.000000', 'temperatura', 861.0000, 'ºC'),
	(282650, 122, '2014-04-01 00:09:23.000000', 'temperatura', 694.0000, 'ºC'),
	(282651, 122, '2014-04-01 00:09:24.000000', 'temperatura', 890.0000, 'ºC'),
	(282652, 122, '2014-04-01 00:09:25.000000', 'temperatura', 1165.0000, 'ºC'),
	(282653, 122, '2014-04-01 00:09:26.000000', 'temperatura', 759.0000, 'ºC'),
	(282654, 122, '2014-04-01 00:09:27.000000', 'temperatura', 298.0000, 'ºC'),
	(282655, 122, '2014-04-01 00:09:28.000000', 'temperatura', 416.0000, 'ºC'),
	(282656, 122, '2014-04-01 00:09:29.000000', 'temperatura', 1184.0000, 'ºC'),
	(282657, 122, '2014-04-01 00:09:30.000000', 'temperatura', 1074.0000, 'ºC'),
	(282658, 122, '2014-04-01 00:09:31.000000', 'temperatura', 620.0000, 'ºC'),
	(282659, 122, '2014-04-01 00:09:32.000000', 'temperatura', 1078.0000, 'ºC'),
	(282660, 122, '2014-04-01 00:09:33.000000', 'temperatura', 1129.0000, 'ºC'),
	(282661, 122, '2014-04-01 00:09:34.000000', 'temperatura', 11.0000, 'ºC'),
	(282662, 122, '2014-04-01 00:09:35.000000', 'temperatura', 271.0000, 'ºC'),
	(282663, 122, '2014-04-01 00:09:36.000000', 'temperatura', 121.0000, 'ºC'),
	(282664, 122, '2014-04-01 00:09:37.000000', 'temperatura', 995.0000, 'ºC'),
	(282665, 122, '2014-04-01 00:09:38.000000', 'temperatura', 1010.0000, 'ºC'),
	(282666, 122, '2014-04-01 00:09:39.000000', 'temperatura', 865.0000, 'ºC'),
	(282667, 122, '2014-04-01 00:09:40.000000', 'temperatura', 96.0000, 'ºC'),
	(282668, 122, '2014-04-01 00:09:41.000000', 'temperatura', 284.0000, 'ºC'),
	(282669, 122, '2014-04-01 00:09:42.000000', 'temperatura', 1134.0000, 'ºC'),
	(282670, 122, '2014-04-01 00:09:43.000000', 'temperatura', 18.0000, 'ºC'),
	(282671, 122, '2014-04-01 00:09:44.000000', 'temperatura', 288.0000, 'ºC'),
	(282672, 122, '2014-04-01 00:09:45.000000', 'temperatura', 185.0000, 'ºC'),
	(282673, 122, '2014-04-01 00:09:46.000000', 'temperatura', 63.0000, 'ºC'),
	(282674, 122, '2014-04-01 00:09:47.000000', 'temperatura', 959.0000, 'ºC'),
	(282675, 122, '2014-04-01 00:09:48.000000', 'temperatura', 1008.0000, 'ºC'),
	(282676, 122, '2014-04-01 00:09:49.000000', 'temperatura', 963.0000, 'ºC'),
	(282677, 122, '2014-04-01 00:09:50.000000', 'temperatura', 592.0000, 'ºC'),
	(282678, 122, '2014-04-01 00:09:51.000000', 'temperatura', 73.0000, 'ºC'),
	(282679, 122, '2014-04-01 00:09:52.000000', 'temperatura', 989.0000, 'ºC'),
	(282680, 122, '2014-04-01 00:09:53.000000', 'temperatura', 1127.0000, 'ºC'),
	(282681, 122, '2014-04-01 00:09:54.000000', 'temperatura', 267.0000, 'ºC'),
	(282682, 122, '2014-04-01 00:09:55.000000', 'temperatura', 353.0000, 'ºC'),
	(282683, 122, '2014-04-01 00:09:56.000000', 'temperatura', 966.0000, 'ºC'),
	(282684, 122, '2014-04-01 00:09:57.000000', 'temperatura', 171.0000, 'ºC'),
	(282685, 122, '2014-04-01 00:09:58.000000', 'temperatura', 359.0000, 'ºC'),
	(282686, 122, '2014-04-01 00:09:59.000000', 'temperatura', 84.0000, 'ºC'),
	(282687, 122, '2014-04-01 00:10:00.000000', 'temperatura', 540.0000, 'ºC'),
	(282688, 122, '2014-04-01 00:10:01.000000', 'temperatura', 49.0000, 'ºC'),
	(282689, 122, '2014-04-01 00:10:02.000000', 'temperatura', 1025.0000, 'ºC'),
	(282690, 122, '2014-04-01 00:10:03.000000', 'temperatura', 180.0000, 'ºC'),
	(282691, 122, '2014-04-01 00:10:04.000000', 'temperatura', 225.0000, 'ºC'),
	(282692, 122, '2014-04-01 00:10:05.000000', 'temperatura', 583.0000, 'ºC'),
	(282693, 122, '2014-04-01 00:10:06.000000', 'temperatura', 1044.0000, 'ºC'),
	(282694, 122, '2014-04-01 00:10:07.000000', 'temperatura', 1069.0000, 'ºC'),
	(282695, 122, '2014-04-01 00:10:08.000000', 'temperatura', 1016.0000, 'ºC'),
	(282696, 122, '2014-04-01 00:10:09.000000', 'temperatura', 674.0000, 'ºC'),
	(282697, 122, '2014-04-01 00:10:10.000000', 'temperatura', 321.0000, 'ºC'),
	(282698, 122, '2014-04-01 00:10:11.000000', 'temperatura', 783.0000, 'ºC'),
	(282699, 122, '2014-04-01 00:10:12.000000', 'temperatura', 554.0000, 'ºC'),
	(282700, 122, '2014-04-01 00:10:13.000000', 'temperatura', 422.0000, 'ºC'),
	(282701, 122, '2014-04-01 00:10:14.000000', 'temperatura', 449.0000, 'ºC'),
	(282702, 122, '2014-04-01 00:10:15.000000', 'temperatura', 976.0000, 'ºC'),
	(282703, 122, '2014-04-01 00:10:16.000000', 'temperatura', 1137.0000, 'ºC'),
	(282704, 122, '2014-04-01 00:10:17.000000', 'temperatura', 357.0000, 'ºC'),
	(282705, 122, '2014-04-01 00:10:18.000000', 'temperatura', 775.0000, 'ºC'),
	(282706, 122, '2014-04-01 00:10:19.000000', 'temperatura', 402.0000, 'ºC'),
	(282707, 122, '2014-04-01 00:10:20.000000', 'temperatura', 886.0000, 'ºC'),
	(282708, 122, '2014-04-01 00:10:21.000000', 'temperatura', 824.0000, 'ºC'),
	(282709, 122, '2014-04-01 00:10:22.000000', 'temperatura', 262.0000, 'ºC'),
	(282710, 122, '2014-04-01 00:10:23.000000', 'temperatura', 39.0000, 'ºC'),
	(282711, 122, '2014-04-01 00:10:24.000000', 'temperatura', 609.0000, 'ºC'),
	(282712, 122, '2014-04-01 00:10:25.000000', 'temperatura', 528.0000, 'ºC'),
	(282713, 122, '2014-04-01 00:10:26.000000', 'temperatura', 816.0000, 'ºC'),
	(282714, 122, '2014-04-01 00:10:27.000000', 'temperatura', 94.0000, 'ºC'),
	(282715, 122, '2014-04-01 00:10:28.000000', 'temperatura', 425.0000, 'ºC'),
	(282716, 122, '2014-04-01 00:10:29.000000', 'temperatura', 641.0000, 'ºC'),
	(282717, 122, '2014-04-01 00:10:30.000000', 'temperatura', 730.0000, 'ºC'),
	(282718, 122, '2014-04-01 00:10:31.000000', 'temperatura', 528.0000, 'ºC'),
	(282719, 122, '2014-04-01 00:10:32.000000', 'temperatura', 451.0000, 'ºC'),
	(282720, 122, '2014-04-01 00:10:33.000000', 'temperatura', 671.0000, 'ºC'),
	(282721, 122, '2014-04-01 00:10:34.000000', 'temperatura', 802.0000, 'ºC'),
	(282722, 122, '2014-04-01 00:10:35.000000', 'temperatura', 796.0000, 'ºC'),
	(282723, 122, '2014-04-01 00:10:36.000000', 'temperatura', 378.0000, 'ºC'),
	(282724, 122, '2014-04-01 00:10:37.000000', 'temperatura', 700.0000, 'ºC'),
	(282725, 122, '2014-04-01 00:10:38.000000', 'temperatura', 1168.0000, 'ºC'),
	(282726, 122, '2014-04-01 00:10:39.000000', 'temperatura', 140.0000, 'ºC'),
	(282727, 122, '2014-04-01 00:10:40.000000', 'temperatura', 797.0000, 'ºC'),
	(282728, 122, '2014-04-01 00:10:41.000000', 'temperatura', 1166.0000, 'ºC'),
	(282729, 122, '2014-04-01 00:10:42.000000', 'temperatura', 1038.0000, 'ºC'),
	(282730, 122, '2014-04-01 00:10:43.000000', 'temperatura', 494.0000, 'ºC'),
	(282731, 122, '2014-04-01 00:10:44.000000', 'temperatura', 554.0000, 'ºC'),
	(282732, 122, '2014-04-01 00:10:45.000000', 'temperatura', 92.0000, 'ºC'),
	(282733, 122, '2014-04-01 00:10:46.000000', 'temperatura', 1196.0000, 'ºC'),
	(282734, 122, '2014-04-01 00:10:47.000000', 'temperatura', 907.0000, 'ºC'),
	(282735, 122, '2014-04-01 00:10:48.000000', 'temperatura', 946.0000, 'ºC'),
	(282736, 122, '2014-04-01 00:10:49.000000', 'temperatura', 808.0000, 'ºC'),
	(282737, 122, '2014-04-01 00:10:50.000000', 'temperatura', 4.0000, 'ºC'),
	(282738, 122, '2014-04-01 00:10:51.000000', 'temperatura', 1196.0000, 'ºC'),
	(282739, 122, '2014-04-01 00:10:52.000000', 'temperatura', 1167.0000, 'ºC'),
	(282740, 122, '2014-04-01 00:10:53.000000', 'temperatura', 1050.0000, 'ºC'),
	(282741, 122, '2014-04-01 00:10:54.000000', 'temperatura', 550.0000, 'ºC'),
	(282742, 122, '2014-04-01 00:10:55.000000', 'temperatura', 797.0000, 'ºC'),
	(282743, 122, '2014-04-01 00:10:56.000000', 'temperatura', 1139.0000, 'ºC'),
	(282744, 122, '2014-04-01 00:10:57.000000', 'temperatura', 903.0000, 'ºC'),
	(282745, 122, '2014-04-01 00:10:58.000000', 'temperatura', 1098.0000, 'ºC'),
	(282746, 122, '2014-04-01 00:10:59.000000', 'temperatura', 383.0000, 'ºC'),
	(282747, 122, '2014-04-01 00:11:00.000000', 'temperatura', 1023.0000, 'ºC'),
	(282748, 122, '2014-04-01 00:11:01.000000', 'temperatura', 363.0000, 'ºC'),
	(282749, 122, '2014-04-01 00:11:02.000000', 'temperatura', 1149.0000, 'ºC'),
	(282750, 122, '2014-04-01 00:11:03.000000', 'temperatura', 1056.0000, 'ºC'),
	(282751, 122, '2014-04-01 00:11:04.000000', 'temperatura', 631.0000, 'ºC'),
	(282752, 122, '2014-04-01 00:11:05.000000', 'temperatura', 1190.0000, 'ºC'),
	(282753, 122, '2014-04-01 00:11:06.000000', 'temperatura', 459.0000, 'ºC'),
	(282754, 122, '2014-04-01 00:11:07.000000', 'temperatura', 1123.0000, 'ºC'),
	(282755, 122, '2014-04-01 00:11:08.000000', 'temperatura', 641.0000, 'ºC'),
	(282756, 122, '2014-04-01 00:11:09.000000', 'temperatura', 1034.0000, 'ºC'),
	(282757, 122, '2014-04-01 00:11:10.000000', 'temperatura', 848.0000, 'ºC'),
	(282758, 122, '2014-04-01 00:11:11.000000', 'temperatura', 1138.0000, 'ºC'),
	(282759, 122, '2014-04-01 00:11:12.000000', 'temperatura', 745.0000, 'ºC'),
	(282760, 122, '2014-04-01 00:11:13.000000', 'temperatura', 313.0000, 'ºC'),
	(282761, 122, '2014-04-01 00:11:14.000000', 'temperatura', 530.0000, 'ºC'),
	(282762, 122, '2014-04-01 00:11:15.000000', 'temperatura', 510.0000, 'ºC'),
	(282763, 122, '2014-04-01 00:11:16.000000', 'temperatura', 961.0000, 'ºC'),
	(282764, 122, '2014-04-01 00:11:17.000000', 'temperatura', 875.0000, 'ºC'),
	(282765, 122, '2014-04-01 00:11:18.000000', 'temperatura', 294.0000, 'ºC'),
	(282766, 122, '2014-04-01 00:11:19.000000', 'temperatura', 44.0000, 'ºC'),
	(282767, 122, '2014-04-01 00:11:20.000000', 'temperatura', 540.0000, 'ºC'),
	(282768, 122, '2014-04-01 00:11:21.000000', 'temperatura', 169.0000, 'ºC'),
	(282769, 122, '2014-04-01 00:11:22.000000', 'temperatura', 424.0000, 'ºC'),
	(282770, 122, '2014-04-01 00:11:23.000000', 'temperatura', 416.0000, 'ºC'),
	(282771, 122, '2014-04-01 00:11:24.000000', 'temperatura', 805.0000, 'ºC'),
	(282772, 122, '2014-04-01 00:11:25.000000', 'temperatura', 379.0000, 'ºC'),
	(282773, 122, '2014-04-01 00:11:26.000000', 'temperatura', 682.0000, 'ºC'),
	(282774, 122, '2014-04-01 00:11:27.000000', 'temperatura', 1073.0000, 'ºC'),
	(282775, 122, '2014-04-01 00:11:28.000000', 'temperatura', 918.0000, 'ºC'),
	(282776, 122, '2014-04-01 00:11:29.000000', 'temperatura', 172.0000, 'ºC'),
	(282777, 122, '2014-04-01 00:11:30.000000', 'temperatura', 507.0000, 'ºC'),
	(282778, 122, '2014-04-01 00:11:31.000000', 'temperatura', 821.0000, 'ºC'),
	(282779, 122, '2014-04-01 00:11:32.000000', 'temperatura', 183.0000, 'ºC'),
	(282780, 122, '2014-04-01 00:11:33.000000', 'temperatura', 853.0000, 'ºC'),
	(282781, 122, '2014-04-01 00:11:34.000000', 'temperatura', 116.0000, 'ºC'),
	(282782, 122, '2014-04-01 00:11:35.000000', 'temperatura', 423.0000, 'ºC'),
	(282783, 122, '2014-04-01 00:11:36.000000', 'temperatura', 568.0000, 'ºC'),
	(282784, 122, '2014-04-01 00:11:37.000000', 'temperatura', 372.0000, 'ºC'),
	(282785, 122, '2014-04-01 00:11:38.000000', 'temperatura', 155.0000, 'ºC'),
	(282786, 122, '2014-04-01 00:11:39.000000', 'temperatura', 858.0000, 'ºC'),
	(282787, 122, '2014-04-01 00:11:40.000000', 'temperatura', 228.0000, 'ºC'),
	(282788, 122, '2014-04-01 00:11:41.000000', 'temperatura', 964.0000, 'ºC'),
	(282789, 122, '2014-04-01 00:11:42.000000', 'temperatura', 540.0000, 'ºC'),
	(282790, 122, '2014-04-01 00:11:43.000000', 'temperatura', 1005.0000, 'ºC'),
	(282791, 122, '2014-04-01 00:11:44.000000', 'temperatura', 1007.0000, 'ºC'),
	(282792, 122, '2014-04-01 00:11:45.000000', 'temperatura', 821.0000, 'ºC'),
	(282793, 122, '2014-04-01 00:11:46.000000', 'temperatura', 1086.0000, 'ºC'),
	(282794, 122, '2014-04-01 00:11:47.000000', 'temperatura', 566.0000, 'ºC'),
	(282795, 122, '2014-04-01 00:11:48.000000', 'temperatura', 772.0000, 'ºC'),
	(282796, 122, '2014-04-01 00:11:49.000000', 'temperatura', 961.0000, 'ºC'),
	(282797, 122, '2014-04-01 00:11:50.000000', 'temperatura', 90.0000, 'ºC'),
	(282798, 122, '2014-04-01 00:11:51.000000', 'temperatura', 1170.0000, 'ºC'),
	(282799, 122, '2014-04-01 00:11:52.000000', 'temperatura', 780.0000, 'ºC'),
	(282800, 122, '2014-04-01 00:11:53.000000', 'temperatura', 389.0000, 'ºC'),
	(282801, 122, '2014-04-01 00:11:54.000000', 'temperatura', 808.0000, 'ºC'),
	(282802, 122, '2014-04-01 00:11:55.000000', 'temperatura', 472.0000, 'ºC'),
	(282803, 122, '2014-04-01 00:11:56.000000', 'temperatura', 1136.0000, 'ºC'),
	(282804, 122, '2014-04-01 00:11:57.000000', 'temperatura', 666.0000, 'ºC'),
	(282805, 122, '2014-04-01 00:11:58.000000', 'temperatura', 1124.0000, 'ºC'),
	(282806, 122, '2014-04-01 00:11:59.000000', 'temperatura', 20.0000, 'ºC'),
	(282807, 122, '2014-04-01 00:12:00.000000', 'temperatura', 329.0000, 'ºC'),
	(282808, 122, '2014-04-01 00:12:01.000000', 'temperatura', 384.0000, 'ºC'),
	(282809, 122, '2014-04-01 00:12:02.000000', 'temperatura', 936.0000, 'ºC'),
	(282810, 122, '2014-04-01 00:12:03.000000', 'temperatura', 1126.0000, 'ºC'),
	(282811, 122, '2014-04-01 00:12:04.000000', 'temperatura', 424.0000, 'ºC'),
	(282812, 122, '2014-04-01 00:12:05.000000', 'temperatura', 1140.0000, 'ºC'),
	(282813, 122, '2014-04-01 00:12:06.000000', 'temperatura', 831.0000, 'ºC'),
	(282814, 122, '2014-04-01 00:12:07.000000', 'temperatura', 736.0000, 'ºC'),
	(282815, 122, '2014-04-01 00:12:08.000000', 'temperatura', 1186.0000, 'ºC'),
	(282816, 122, '2014-04-01 00:12:09.000000', 'temperatura', 124.0000, 'ºC'),
	(282817, 122, '2014-04-01 00:12:10.000000', 'temperatura', 660.0000, 'ºC'),
	(282818, 122, '2014-04-01 00:12:11.000000', 'temperatura', 530.0000, 'ºC'),
	(282819, 122, '2014-04-01 00:12:12.000000', 'temperatura', 670.0000, 'ºC'),
	(282820, 122, '2014-04-01 00:12:13.000000', 'temperatura', 559.0000, 'ºC'),
	(282821, 122, '2014-04-01 00:12:14.000000', 'temperatura', 788.0000, 'ºC'),
	(282822, 122, '2014-04-01 00:12:15.000000', 'temperatura', 1065.0000, 'ºC'),
	(282823, 122, '2014-04-01 00:12:16.000000', 'temperatura', 558.0000, 'ºC'),
	(282824, 122, '2014-04-01 00:12:17.000000', 'temperatura', 798.0000, 'ºC'),
	(282825, 122, '2014-04-01 00:12:18.000000', 'temperatura', 1117.0000, 'ºC'),
	(282826, 122, '2014-04-01 00:12:19.000000', 'temperatura', 791.0000, 'ºC'),
	(282827, 122, '2014-04-01 00:12:20.000000', 'temperatura', 602.0000, 'ºC'),
	(282828, 122, '2014-04-01 00:12:21.000000', 'temperatura', 641.0000, 'ºC'),
	(282829, 122, '2014-04-01 00:12:22.000000', 'temperatura', 197.0000, 'ºC'),
	(282830, 122, '2014-04-01 00:12:23.000000', 'temperatura', 264.0000, 'ºC'),
	(282831, 122, '2014-04-01 00:12:24.000000', 'temperatura', 731.0000, 'ºC'),
	(282832, 122, '2014-04-01 00:12:25.000000', 'temperatura', 460.0000, 'ºC'),
	(282833, 122, '2014-04-01 00:12:26.000000', 'temperatura', 110.0000, 'ºC'),
	(282834, 122, '2014-04-01 00:12:27.000000', 'temperatura', 370.0000, 'ºC'),
	(282835, 122, '2014-04-01 00:12:28.000000', 'temperatura', 320.0000, 'ºC'),
	(282836, 122, '2014-04-01 00:12:29.000000', 'temperatura', 491.0000, 'ºC'),
	(282837, 122, '2014-04-01 00:12:30.000000', 'temperatura', 293.0000, 'ºC'),
	(282838, 122, '2014-04-01 00:12:31.000000', 'temperatura', 1196.0000, 'ºC'),
	(282839, 122, '2014-04-01 00:12:32.000000', 'temperatura', 301.0000, 'ºC'),
	(282840, 122, '2014-04-01 00:12:33.000000', 'temperatura', 315.0000, 'ºC'),
	(282841, 122, '2014-04-01 00:12:34.000000', 'temperatura', 675.0000, 'ºC'),
	(282842, 122, '2014-04-01 00:12:35.000000', 'temperatura', 32.0000, 'ºC'),
	(282843, 122, '2014-04-01 00:12:36.000000', 'temperatura', 532.0000, 'ºC'),
	(282844, 122, '2014-04-01 00:12:37.000000', 'temperatura', 166.0000, 'ºC'),
	(282845, 122, '2014-04-01 00:12:38.000000', 'temperatura', 432.0000, 'ºC'),
	(282846, 122, '2014-04-01 00:12:39.000000', 'temperatura', 466.0000, 'ºC'),
	(282847, 122, '2014-04-01 00:12:40.000000', 'temperatura', 1032.0000, 'ºC'),
	(282848, 122, '2014-04-01 00:12:41.000000', 'temperatura', 163.0000, 'ºC'),
	(282849, 122, '2014-04-01 00:12:42.000000', 'temperatura', 119.0000, 'ºC'),
	(282850, 122, '2014-04-01 00:12:43.000000', 'temperatura', 107.0000, 'ºC'),
	(282851, 122, '2014-04-01 00:12:44.000000', 'temperatura', 178.0000, 'ºC'),
	(282852, 122, '2014-04-01 00:12:45.000000', 'temperatura', 571.0000, 'ºC'),
	(282853, 122, '2014-04-01 00:12:46.000000', 'temperatura', 1123.0000, 'ºC'),
	(282854, 122, '2014-04-01 00:12:47.000000', 'temperatura', 299.0000, 'ºC'),
	(282855, 122, '2014-04-01 00:12:48.000000', 'temperatura', 528.0000, 'ºC'),
	(282856, 122, '2014-04-01 00:12:49.000000', 'temperatura', 543.0000, 'ºC'),
	(282857, 122, '2014-04-01 00:12:50.000000', 'temperatura', 1131.0000, 'ºC'),
	(282858, 122, '2014-04-01 00:12:51.000000', 'temperatura', 426.0000, 'ºC'),
	(282859, 122, '2014-04-01 00:12:52.000000', 'temperatura', 1139.0000, 'ºC'),
	(282860, 122, '2014-04-01 00:12:53.000000', 'temperatura', 818.0000, 'ºC'),
	(282861, 122, '2014-04-01 00:12:54.000000', 'temperatura', 673.0000, 'ºC'),
	(282862, 122, '2014-04-01 00:12:55.000000', 'temperatura', 911.0000, 'ºC'),
	(282863, 122, '2014-04-01 00:12:56.000000', 'temperatura', 139.0000, 'ºC'),
	(282864, 122, '2014-04-01 00:12:57.000000', 'temperatura', 360.0000, 'ºC'),
	(282865, 122, '2014-04-01 00:12:58.000000', 'temperatura', 183.0000, 'ºC'),
	(282866, 122, '2014-04-01 00:12:59.000000', 'temperatura', 1037.0000, 'ºC'),
	(282867, 122, '2014-04-01 00:13:00.000000', 'temperatura', 1035.0000, 'ºC'),
	(282868, 122, '2014-04-01 00:13:01.000000', 'temperatura', 865.0000, 'ºC'),
	(282869, 122, '2014-04-01 00:13:02.000000', 'temperatura', 22.0000, 'ºC'),
	(282870, 122, '2014-04-01 00:13:03.000000', 'temperatura', 1113.0000, 'ºC'),
	(282871, 122, '2014-04-01 00:13:04.000000', 'temperatura', 700.0000, 'ºC'),
	(282872, 122, '2014-04-01 00:13:05.000000', 'temperatura', 161.0000, 'ºC'),
	(282873, 122, '2014-04-01 00:13:06.000000', 'temperatura', 1107.0000, 'ºC'),
	(282874, 122, '2014-04-01 00:13:07.000000', 'temperatura', 251.0000, 'ºC'),
	(282875, 122, '2014-04-01 00:13:08.000000', 'temperatura', 335.0000, 'ºC'),
	(282876, 122, '2014-04-01 00:13:09.000000', 'temperatura', 923.0000, 'ºC'),
	(282877, 122, '2014-04-01 00:13:10.000000', 'temperatura', 10.0000, 'ºC'),
	(282878, 122, '2014-04-01 00:13:11.000000', 'temperatura', 880.0000, 'ºC'),
	(282879, 122, '2014-04-01 00:13:12.000000', 'temperatura', 773.0000, 'ºC'),
	(282880, 122, '2014-04-01 00:13:13.000000', 'temperatura', 23.0000, 'ºC'),
	(282881, 122, '2014-04-01 00:13:14.000000', 'temperatura', 198.0000, 'ºC'),
	(282882, 122, '2014-04-01 00:13:15.000000', 'temperatura', 921.0000, 'ºC'),
	(282883, 122, '2014-04-01 00:13:16.000000', 'temperatura', 410.0000, 'ºC'),
	(282884, 122, '2014-04-01 00:13:17.000000', 'temperatura', 490.0000, 'ºC'),
	(282885, 122, '2014-04-01 00:13:18.000000', 'temperatura', 21.0000, 'ºC'),
	(282886, 122, '2014-04-01 00:13:19.000000', 'temperatura', 1035.0000, 'ºC'),
	(282887, 122, '2014-04-01 00:13:20.000000', 'temperatura', 314.0000, 'ºC'),
	(282888, 122, '2014-04-01 00:13:21.000000', 'temperatura', 864.0000, 'ºC'),
	(282889, 122, '2014-04-01 00:13:22.000000', 'temperatura', 977.0000, 'ºC'),
	(282890, 122, '2014-04-01 00:13:23.000000', 'temperatura', 1094.0000, 'ºC'),
	(282891, 122, '2014-04-01 00:13:24.000000', 'temperatura', 140.0000, 'ºC'),
	(282892, 122, '2014-04-01 00:13:25.000000', 'temperatura', 1017.0000, 'ºC'),
	(282893, 122, '2014-04-01 00:13:26.000000', 'temperatura', 1066.0000, 'ºC'),
	(282894, 122, '2014-04-01 00:13:27.000000', 'temperatura', 1080.0000, 'ºC'),
	(282895, 122, '2014-04-01 00:13:28.000000', 'temperatura', 1004.0000, 'ºC'),
	(282896, 122, '2014-04-01 00:13:29.000000', 'temperatura', 578.0000, 'ºC'),
	(282897, 122, '2014-04-01 00:13:30.000000', 'temperatura', 1079.0000, 'ºC'),
	(282898, 122, '2014-04-01 00:13:31.000000', 'temperatura', 62.0000, 'ºC'),
	(282899, 122, '2014-04-01 00:13:32.000000', 'temperatura', 674.0000, 'ºC'),
	(282900, 122, '2014-04-01 00:13:33.000000', 'temperatura', 786.0000, 'ºC'),
	(282901, 122, '2014-04-01 00:13:34.000000', 'temperatura', 706.0000, 'ºC'),
	(282902, 122, '2014-04-01 00:13:35.000000', 'temperatura', 1175.0000, 'ºC'),
	(282903, 122, '2014-04-01 00:13:36.000000', 'temperatura', 157.0000, 'ºC'),
	(282904, 122, '2014-04-01 00:13:37.000000', 'temperatura', 859.0000, 'ºC'),
	(282905, 122, '2014-04-01 00:13:38.000000', 'temperatura', 227.0000, 'ºC'),
	(282906, 122, '2014-04-01 00:13:39.000000', 'temperatura', 955.0000, 'ºC'),
	(282907, 122, '2014-04-01 00:13:40.000000', 'temperatura', 497.0000, 'ºC'),
	(282908, 122, '2014-04-01 00:13:41.000000', 'temperatura', 821.0000, 'ºC'),
	(282909, 122, '2014-04-01 00:13:42.000000', 'temperatura', 212.0000, 'ºC'),
	(282910, 122, '2014-04-01 00:13:43.000000', 'temperatura', 999.0000, 'ºC'),
	(282911, 122, '2014-04-01 00:13:44.000000', 'temperatura', 760.0000, 'ºC'),
	(282912, 122, '2014-04-01 00:13:45.000000', 'temperatura', 802.0000, 'ºC'),
	(282913, 122, '2014-04-01 00:13:46.000000', 'temperatura', 532.0000, 'ºC'),
	(282914, 122, '2014-04-01 00:13:47.000000', 'temperatura', 253.0000, 'ºC'),
	(282915, 122, '2014-04-01 00:13:48.000000', 'temperatura', 868.0000, 'ºC'),
	(282916, 122, '2014-04-01 00:13:49.000000', 'temperatura', 1184.0000, 'ºC'),
	(282917, 122, '2014-04-01 00:13:50.000000', 'temperatura', 917.0000, 'ºC'),
	(282918, 122, '2014-04-01 00:13:51.000000', 'temperatura', 1033.0000, 'ºC'),
	(282919, 122, '2014-04-01 00:13:52.000000', 'temperatura', 16.0000, 'ºC'),
	(282920, 122, '2014-04-01 00:13:53.000000', 'temperatura', 581.0000, 'ºC'),
	(282921, 122, '2014-04-01 00:13:54.000000', 'temperatura', 458.0000, 'ºC'),
	(282922, 122, '2014-04-01 00:13:55.000000', 'temperatura', 548.0000, 'ºC'),
	(282923, 122, '2014-04-01 00:13:56.000000', 'temperatura', 164.0000, 'ºC'),
	(282924, 122, '2014-04-01 00:13:57.000000', 'temperatura', 379.0000, 'ºC'),
	(282925, 122, '2014-04-01 00:13:58.000000', 'temperatura', 201.0000, 'ºC'),
	(282926, 122, '2014-04-01 00:13:59.000000', 'temperatura', 1071.0000, 'ºC'),
	(282927, 122, '2014-04-01 00:14:00.000000', 'temperatura', 1150.0000, 'ºC'),
	(282928, 122, '2014-04-01 00:14:01.000000', 'temperatura', 139.0000, 'ºC'),
	(282929, 122, '2014-04-01 00:14:02.000000', 'temperatura', 843.0000, 'ºC'),
	(282930, 122, '2014-04-01 00:14:03.000000', 'temperatura', 201.0000, 'ºC'),
	(282931, 122, '2014-04-01 00:14:04.000000', 'temperatura', 878.0000, 'ºC'),
	(282932, 122, '2014-04-01 00:14:05.000000', 'temperatura', 185.0000, 'ºC'),
	(282933, 122, '2014-04-01 00:14:06.000000', 'temperatura', 691.0000, 'ºC'),
	(282934, 122, '2014-04-01 00:14:07.000000', 'temperatura', 501.0000, 'ºC'),
	(282935, 122, '2014-04-01 00:14:08.000000', 'temperatura', 431.0000, 'ºC'),
	(282936, 122, '2014-04-01 00:14:09.000000', 'temperatura', 652.0000, 'ºC'),
	(282937, 122, '2014-04-01 00:14:10.000000', 'temperatura', 768.0000, 'ºC'),
	(282938, 122, '2014-04-01 00:14:11.000000', 'temperatura', 686.0000, 'ºC'),
	(282939, 122, '2014-04-01 00:14:12.000000', 'temperatura', 1128.0000, 'ºC'),
	(282940, 122, '2014-04-01 00:14:13.000000', 'temperatura', 1180.0000, 'ºC'),
	(282941, 122, '2014-04-01 00:14:14.000000', 'temperatura', 117.0000, 'ºC'),
	(282942, 122, '2014-04-01 00:14:15.000000', 'temperatura', 646.0000, 'ºC'),
	(282943, 122, '2014-04-01 00:14:16.000000', 'temperatura', 478.0000, 'ºC'),
	(282944, 122, '2014-04-01 00:14:17.000000', 'temperatura', 451.0000, 'ºC'),
	(282945, 122, '2014-04-01 00:14:18.000000', 'temperatura', 824.0000, 'ºC'),
	(282946, 122, '2014-04-01 00:14:19.000000', 'temperatura', 368.0000, 'ºC'),
	(282947, 122, '2014-04-01 00:14:20.000000', 'temperatura', 566.0000, 'ºC'),
	(282948, 122, '2014-04-01 00:14:21.000000', 'temperatura', 528.0000, 'ºC'),
	(282949, 122, '2014-04-01 00:14:22.000000', 'temperatura', 941.0000, 'ºC'),
	(282950, 122, '2014-04-01 00:14:23.000000', 'temperatura', 724.0000, 'ºC'),
	(282951, 122, '2014-04-01 00:14:24.000000', 'temperatura', 795.0000, 'ºC'),
	(282952, 122, '2014-04-01 00:14:25.000000', 'temperatura', 603.0000, 'ºC'),
	(282953, 122, '2014-04-01 00:14:26.000000', 'temperatura', 630.0000, 'ºC'),
	(282954, 122, '2014-04-01 00:14:27.000000', 'temperatura', 143.0000, 'ºC'),
	(282955, 122, '2014-04-01 00:14:28.000000', 'temperatura', 24.0000, 'ºC'),
	(282956, 122, '2014-04-01 00:14:29.000000', 'temperatura', 893.0000, 'ºC'),
	(282957, 122, '2014-04-01 00:14:30.000000', 'temperatura', 793.0000, 'ºC'),
	(282958, 122, '2014-04-01 00:14:31.000000', 'temperatura', 85.0000, 'ºC'),
	(282959, 122, '2014-04-01 00:14:32.000000', 'temperatura', 446.0000, 'ºC'),
	(282960, 122, '2014-04-01 00:14:33.000000', 'temperatura', 779.0000, 'ºC'),
	(282961, 122, '2014-04-01 00:14:34.000000', 'temperatura', 155.0000, 'ºC'),
	(282962, 122, '2014-04-01 00:14:35.000000', 'temperatura', 838.0000, 'ºC'),
	(282963, 122, '2014-04-01 00:14:36.000000', 'temperatura', 124.0000, 'ºC'),
	(282964, 122, '2014-04-01 00:14:37.000000', 'temperatura', 509.0000, 'ºC'),
	(282965, 122, '2014-04-01 00:14:38.000000', 'temperatura', 973.0000, 'ºC'),
	(282966, 122, '2014-04-01 00:14:39.000000', 'temperatura', 940.0000, 'ºC'),
	(282967, 122, '2014-04-01 00:14:40.000000', 'temperatura', 582.0000, 'ºC'),
	(282968, 122, '2014-04-01 00:14:41.000000', 'temperatura', 91.0000, 'ºC'),
	(282969, 122, '2014-04-01 00:14:42.000000', 'temperatura', 1109.0000, 'ºC'),
	(282970, 122, '2014-04-01 00:14:43.000000', 'temperatura', 471.0000, 'ºC'),
	(282971, 122, '2014-04-01 00:14:44.000000', 'temperatura', 228.0000, 'ºC'),
	(282972, 122, '2014-04-01 00:14:45.000000', 'temperatura', 926.0000, 'ºC'),
	(282973, 122, '2014-04-01 00:14:46.000000', 'temperatura', 350.0000, 'ºC'),
	(282974, 122, '2014-04-01 00:14:47.000000', 'temperatura', 172.0000, 'ºC'),
	(282975, 122, '2014-04-01 00:14:48.000000', 'temperatura', 1012.0000, 'ºC'),
	(282976, 122, '2014-04-01 00:14:49.000000', 'temperatura', 941.0000, 'ºC'),
	(282977, 122, '2014-04-01 00:14:50.000000', 'temperatura', 471.0000, 'ºC'),
	(282978, 122, '2014-04-01 00:14:51.000000', 'temperatura', 732.0000, 'ºC'),
	(282979, 122, '2014-04-01 00:14:52.000000', 'temperatura', 1047.0000, 'ºC'),
	(282980, 122, '2014-04-01 00:14:53.000000', 'temperatura', 640.0000, 'ºC'),
	(282981, 122, '2014-04-01 00:14:54.000000', 'temperatura', 58.0000, 'ºC'),
	(282982, 122, '2014-04-01 00:14:55.000000', 'temperatura', 772.0000, 'ºC'),
	(282983, 122, '2014-04-01 00:14:56.000000', 'temperatura', 85.0000, 'ºC'),
	(282984, 122, '2014-04-01 00:14:57.000000', 'temperatura', 511.0000, 'ºC'),
	(282985, 122, '2014-04-01 00:14:58.000000', 'temperatura', 1101.0000, 'ºC'),
	(282986, 122, '2014-04-01 00:14:59.000000', 'temperatura', 373.0000, 'ºC'),
	(282987, 122, '2014-04-01 00:15:00.000000', 'temperatura', 961.0000, 'ºC'),
	(282988, 122, '2014-04-01 00:15:01.000000', 'temperatura', 88.0000, 'ºC'),
	(282989, 122, '2014-04-01 00:15:02.000000', 'temperatura', 1158.0000, 'ºC'),
	(282990, 122, '2014-04-01 00:15:03.000000', 'temperatura', 725.0000, 'ºC'),
	(282991, 122, '2014-04-01 00:15:04.000000', 'temperatura', 154.0000, 'ºC'),
	(282992, 122, '2014-04-01 00:15:05.000000', 'temperatura', 994.0000, 'ºC'),
	(282993, 122, '2014-04-01 00:15:06.000000', 'temperatura', 907.0000, 'ºC'),
	(282994, 122, '2014-04-01 00:15:07.000000', 'temperatura', 354.0000, 'ºC'),
	(282995, 122, '2014-04-01 00:15:08.000000', 'temperatura', 248.0000, 'ºC'),
	(282996, 122, '2014-04-01 00:15:09.000000', 'temperatura', 181.0000, 'ºC'),
	(282997, 122, '2014-04-01 00:15:10.000000', 'temperatura', 161.0000, 'ºC'),
	(282998, 122, '2014-04-01 00:15:11.000000', 'temperatura', 262.0000, 'ºC'),
	(282999, 122, '2014-04-01 00:15:12.000000', 'temperatura', 826.0000, 'ºC'),
	(283000, 122, '2014-04-01 00:15:13.000000', 'temperatura', 947.0000, 'ºC'),
	(283001, 122, '2014-04-01 00:15:14.000000', 'temperatura', 1055.0000, 'ºC'),
	(283002, 122, '2014-04-01 00:15:15.000000', 'temperatura', 36.0000, 'ºC'),
	(283003, 122, '2014-04-01 00:15:16.000000', 'temperatura', 617.0000, 'ºC'),
	(283004, 122, '2014-04-01 00:15:17.000000', 'temperatura', 577.0000, 'ºC'),
	(283005, 122, '2014-04-01 00:15:18.000000', 'temperatura', 1036.0000, 'ºC'),
	(283006, 122, '2014-04-01 00:15:19.000000', 'temperatura', 1047.0000, 'ºC'),
	(283007, 122, '2014-04-01 00:15:20.000000', 'temperatura', 928.0000, 'ºC'),
	(283008, 122, '2014-04-01 00:15:21.000000', 'temperatura', 301.0000, 'ºC'),
	(283009, 122, '2014-04-01 00:15:22.000000', 'temperatura', 1119.0000, 'ºC'),
	(283010, 122, '2014-04-01 00:15:23.000000', 'temperatura', 1093.0000, 'ºC'),
	(283011, 122, '2014-04-01 00:15:24.000000', 'temperatura', 910.0000, 'ºC'),
	(283012, 122, '2014-04-01 00:15:25.000000', 'temperatura', 72.0000, 'ºC'),
	(283013, 122, '2014-04-01 00:15:26.000000', 'temperatura', 28.0000, 'ºC'),
	(283014, 122, '2014-04-01 00:15:27.000000', 'temperatura', 1127.0000, 'ºC'),
	(283015, 122, '2014-04-01 00:15:28.000000', 'temperatura', 749.0000, 'ºC'),
	(283016, 122, '2014-04-01 00:15:29.000000', 'temperatura', 368.0000, 'ºC'),
	(283017, 122, '2014-04-01 00:15:30.000000', 'temperatura', 791.0000, 'ºC'),
	(283018, 122, '2014-04-01 00:15:31.000000', 'temperatura', 450.0000, 'ºC'),
	(283019, 122, '2014-04-01 00:15:32.000000', 'temperatura', 1081.0000, 'ºC'),
	(283020, 122, '2014-04-01 00:15:33.000000', 'temperatura', 452.0000, 'ºC'),
	(283021, 122, '2014-04-01 00:15:34.000000', 'temperatura', 220.0000, 'ºC'),
	(283022, 122, '2014-04-01 00:15:35.000000', 'temperatura', 944.0000, 'ºC'),
	(283023, 122, '2014-04-01 00:15:36.000000', 'temperatura', 461.0000, 'ºC'),
	(283024, 122, '2014-04-01 00:15:37.000000', 'temperatura', 672.0000, 'ºC'),
	(283025, 122, '2014-04-01 00:15:38.000000', 'temperatura', 777.0000, 'ºC'),
	(283026, 122, '2014-04-01 00:15:39.000000', 'temperatura', 672.0000, 'ºC'),
	(283027, 122, '2014-04-01 00:15:40.000000', 'temperatura', 1029.0000, 'ºC'),
	(283028, 122, '2014-04-01 00:15:41.000000', 'temperatura', 729.0000, 'ºC'),
	(283029, 122, '2014-04-01 00:15:42.000000', 'temperatura', 556.0000, 'ºC'),
	(283030, 122, '2014-04-01 00:15:43.000000', 'temperatura', 597.0000, 'ºC'),
	(283031, 122, '2014-04-01 00:15:44.000000', 'temperatura', 116.0000, 'ºC'),
	(283032, 122, '2014-04-01 00:15:45.000000', 'temperatura', 1192.0000, 'ºC'),
	(283033, 122, '2014-04-01 00:15:46.000000', 'temperatura', 810.0000, 'ºC'),
	(283034, 122, '2014-04-01 00:15:47.000000', 'temperatura', 475.0000, 'ºC'),
	(283035, 122, '2014-04-01 00:15:48.000000', 'temperatura', 1145.0000, 'ºC'),
	(283036, 122, '2014-04-01 00:15:49.000000', 'temperatura', 702.0000, 'ºC'),
	(283037, 122, '2014-04-01 00:15:50.000000', 'temperatura', 77.0000, 'ºC'),
	(283038, 122, '2014-04-01 00:15:51.000000', 'temperatura', 677.0000, 'ºC'),
	(283039, 122, '2014-04-01 00:15:52.000000', 'temperatura', 756.0000, 'ºC'),
	(283040, 122, '2014-04-01 00:15:53.000000', 'temperatura', 551.0000, 'ºC'),
	(283041, 122, '2014-04-01 00:15:54.000000', 'temperatura', 484.0000, 'ºC'),
	(283042, 122, '2014-04-01 00:15:55.000000', 'temperatura', 769.0000, 'ºC'),
	(283043, 122, '2014-04-01 00:15:56.000000', 'temperatura', 1193.0000, 'ºC'),
	(283044, 122, '2014-04-01 00:15:57.000000', 'temperatura', 59.0000, 'ºC'),
	(283045, 122, '2014-04-01 00:15:58.000000', 'temperatura', 315.0000, 'ºC'),
	(283046, 122, '2014-04-01 00:15:59.000000', 'temperatura', 199.0000, 'ºC'),
	(283047, 122, '2014-04-01 00:16:00.000000', 'temperatura', 50.0000, 'ºC'),
	(283048, 122, '2014-04-01 00:16:01.000000', 'temperatura', 854.0000, 'ºC'),
	(283049, 122, '2014-04-01 00:16:02.000000', 'temperatura', 519.0000, 'ºC'),
	(283050, 122, '2014-04-01 00:16:03.000000', 'temperatura', 33.0000, 'ºC'),
	(283051, 122, '2014-04-01 00:16:04.000000', 'temperatura', 1008.0000, 'ºC'),
	(283052, 122, '2014-04-01 00:16:05.000000', 'temperatura', 142.0000, 'ºC'),
	(283053, 122, '2014-04-01 00:16:06.000000', 'temperatura', 87.0000, 'ºC'),
	(283054, 122, '2014-04-01 00:16:07.000000', 'temperatura', 10.0000, 'ºC'),
	(283055, 122, '2014-04-01 00:16:08.000000', 'temperatura', 989.0000, 'ºC'),
	(283056, 122, '2014-04-01 00:16:09.000000', 'temperatura', 114.0000, 'ºC'),
	(283057, 122, '2014-04-01 00:16:10.000000', 'temperatura', 3.0000, 'ºC'),
	(283058, 122, '2014-04-01 00:16:11.000000', 'temperatura', 874.0000, 'ºC'),
	(283059, 122, '2014-04-01 00:16:12.000000', 'temperatura', 760.0000, 'ºC'),
	(283060, 122, '2014-04-01 00:16:13.000000', 'temperatura', 1181.0000, 'ºC'),
	(283061, 122, '2014-04-01 00:16:14.000000', 'temperatura', 24.0000, 'ºC'),
	(283062, 122, '2014-04-01 00:16:15.000000', 'temperatura', 178.0000, 'ºC'),
	(283063, 122, '2014-04-01 00:16:16.000000', 'temperatura', 819.0000, 'ºC'),
	(283064, 122, '2014-04-01 00:16:17.000000', 'temperatura', 1161.0000, 'ºC'),
	(283065, 122, '2014-04-01 00:16:18.000000', 'temperatura', 947.0000, 'ºC'),
	(283066, 122, '2014-04-01 00:16:19.000000', 'temperatura', 55.0000, 'ºC'),
	(283067, 122, '2014-04-01 00:16:20.000000', 'temperatura', 1033.0000, 'ºC'),
	(283068, 122, '2014-04-01 00:16:21.000000', 'temperatura', 199.0000, 'ºC'),
	(283069, 122, '2014-04-01 00:16:22.000000', 'temperatura', 298.0000, 'ºC'),
	(283070, 122, '2014-04-01 00:16:23.000000', 'temperatura', 893.0000, 'ºC'),
	(283071, 122, '2014-04-01 00:16:24.000000', 'temperatura', 1170.0000, 'ºC'),
	(283072, 122, '2014-04-01 00:16:25.000000', 'temperatura', 772.0000, 'ºC'),
	(283073, 122, '2014-04-01 00:16:26.000000', 'temperatura', 352.0000, 'ºC'),
	(283074, 122, '2014-04-01 00:16:27.000000', 'temperatura', 645.0000, 'ºC'),
	(283075, 122, '2014-04-01 00:16:28.000000', 'temperatura', 970.0000, 'ºC'),
	(283076, 122, '2014-04-01 00:16:29.000000', 'temperatura', 514.0000, 'ºC'),
	(283077, 122, '2014-04-01 00:16:30.000000', 'temperatura', 859.0000, 'ºC'),
	(283078, 122, '2014-04-01 00:16:31.000000', 'temperatura', 354.0000, 'ºC'),
	(283079, 122, '2014-04-01 00:16:32.000000', 'temperatura', 394.0000, 'ºC'),
	(283080, 122, '2014-04-01 00:16:33.000000', 'temperatura', 909.0000, 'ºC'),
	(283081, 122, '2014-04-01 00:16:34.000000', 'temperatura', 965.0000, 'ºC'),
	(283082, 122, '2014-04-01 00:16:35.000000', 'temperatura', 898.0000, 'ºC'),
	(283083, 122, '2014-04-01 00:16:36.000000', 'temperatura', 395.0000, 'ºC'),
	(283084, 122, '2014-04-01 00:16:37.000000', 'temperatura', 483.0000, 'ºC'),
	(283085, 122, '2014-04-01 00:16:38.000000', 'temperatura', 29.0000, 'ºC'),
	(283086, 122, '2014-04-01 00:16:39.000000', 'temperatura', 1097.0000, 'ºC'),
	(283087, 122, '2014-04-01 00:16:40.000000', 'temperatura', 597.0000, 'ºC'),
	(283088, 122, '2014-04-01 00:16:41.000000', 'temperatura', 894.0000, 'ºC'),
	(283089, 122, '2014-04-01 00:16:42.000000', 'temperatura', 281.0000, 'ºC'),
	(283090, 122, '2014-04-01 00:16:43.000000', 'temperatura', 1122.0000, 'ºC'),
	(283091, 122, '2014-04-01 00:16:44.000000', 'temperatura', 1167.0000, 'ºC'),
	(283092, 122, '2014-04-01 00:16:45.000000', 'temperatura', 68.0000, 'ºC'),
	(283093, 122, '2014-04-01 00:16:46.000000', 'temperatura', 442.0000, 'ºC'),
	(283094, 122, '2014-04-01 00:16:47.000000', 'temperatura', 808.0000, 'ºC'),
	(283095, 122, '2014-04-01 00:16:48.000000', 'temperatura', 311.0000, 'ºC'),
	(283096, 122, '2014-04-01 00:16:49.000000', 'temperatura', 335.0000, 'ºC'),
	(283097, 122, '2014-04-01 00:16:50.000000', 'temperatura', 741.0000, 'ºC'),
	(283098, 122, '2014-04-01 00:16:51.000000', 'temperatura', 299.0000, 'ºC'),
	(283099, 122, '2014-04-01 00:16:52.000000', 'temperatura', 473.0000, 'ºC'),
	(283100, 122, '2014-04-01 00:16:53.000000', 'temperatura', 269.0000, 'ºC'),
	(283101, 122, '2014-04-01 00:16:54.000000', 'temperatura', 1127.0000, 'ºC'),
	(283102, 122, '2014-04-01 00:16:55.000000', 'temperatura', 29.0000, 'ºC'),
	(283103, 122, '2014-04-01 00:16:56.000000', 'temperatura', 366.0000, 'ºC'),
	(283104, 122, '2014-04-01 00:16:57.000000', 'temperatura', 540.0000, 'ºC'),
	(283105, 122, '2014-04-01 00:16:58.000000', 'temperatura', 404.0000, 'ºC'),
	(283106, 122, '2014-04-01 00:16:59.000000', 'temperatura', 401.0000, 'ºC'),
	(283107, 122, '2014-04-01 00:17:00.000000', 'temperatura', 794.0000, 'ºC'),
	(283108, 122, '2014-04-01 00:17:01.000000', 'temperatura', 369.0000, 'ºC'),
	(283109, 122, '2014-04-01 00:17:02.000000', 'temperatura', 661.0000, 'ºC'),
	(283110, 122, '2014-04-01 00:17:03.000000', 'temperatura', 1000.0000, 'ºC'),
	(283111, 122, '2014-04-01 00:17:04.000000', 'temperatura', 616.0000, 'ºC'),
	(283112, 122, '2014-04-01 00:17:05.000000', 'temperatura', 82.0000, 'ºC'),
	(283113, 122, '2014-04-01 00:17:06.000000', 'temperatura', 961.0000, 'ºC'),
	(283114, 122, '2014-04-01 00:17:07.000000', 'temperatura', 960.0000, 'ºC'),
	(283115, 122, '2014-04-01 00:17:08.000000', 'temperatura', 718.0000, 'ºC'),
	(283116, 122, '2014-04-01 00:17:09.000000', 'temperatura', 710.0000, 'ºC'),
	(283117, 122, '2014-04-01 00:17:10.000000', 'temperatura', 196.0000, 'ºC'),
	(283118, 122, '2014-04-01 00:17:11.000000', 'temperatura', 53.0000, 'ºC'),
	(283119, 122, '2014-04-01 00:17:12.000000', 'temperatura', 875.0000, 'ºC'),
	(283120, 122, '2014-04-01 00:17:13.000000', 'temperatura', 619.0000, 'ºC'),
	(283121, 122, '2014-04-01 00:17:14.000000', 'temperatura', 467.0000, 'ºC'),
	(283122, 122, '2014-04-01 00:17:15.000000', 'temperatura', 482.0000, 'ºC'),
	(283123, 122, '2014-04-01 00:17:16.000000', 'temperatura', 1007.0000, 'ºC'),
	(283124, 122, '2014-04-01 00:17:17.000000', 'temperatura', 1191.0000, 'ºC'),
	(283125, 122, '2014-04-01 00:17:18.000000', 'temperatura', 532.0000, 'ºC'),
	(283126, 122, '2014-04-01 00:17:19.000000', 'temperatura', 290.0000, 'ºC'),
	(283127, 122, '2014-04-01 00:17:20.000000', 'temperatura', 1054.0000, 'ºC'),
	(283128, 122, '2014-04-01 00:17:21.000000', 'temperatura', 799.0000, 'ºC'),
	(283129, 122, '2014-04-01 00:17:22.000000', 'temperatura', 837.0000, 'ºC'),
	(283130, 122, '2014-04-01 00:17:23.000000', 'temperatura', 585.0000, 'ºC'),
	(283131, 122, '2014-04-01 00:17:24.000000', 'temperatura', 414.0000, 'ºC'),
	(283132, 122, '2014-04-01 00:17:25.000000', 'temperatura', 316.0000, 'ºC'),
	(283133, 122, '2014-04-01 00:17:26.000000', 'temperatura', 340.0000, 'ºC'),
	(283134, 122, '2014-04-01 00:17:27.000000', 'temperatura', 750.0000, 'ºC'),
	(283135, 122, '2014-04-01 00:17:28.000000', 'temperatura', 332.0000, 'ºC'),
	(283136, 122, '2014-04-01 00:17:29.000000', 'temperatura', 609.0000, 'ºC'),
	(283137, 122, '2014-04-01 00:17:30.000000', 'temperatura', 852.0000, 'ºC'),
	(283138, 122, '2014-04-01 00:17:31.000000', 'temperatura', 34.0000, 'ºC'),
	(283139, 122, '2014-04-01 00:17:32.000000', 'temperatura', 12.0000, 'ºC'),
	(283140, 122, '2014-04-01 00:17:33.000000', 'temperatura', 1161.0000, 'ºC'),
	(283141, 122, '2014-04-01 00:17:34.000000', 'temperatura', 967.0000, 'ºC'),
	(283142, 122, '2014-04-01 00:17:35.000000', 'temperatura', 155.0000, 'ºC'),
	(283143, 122, '2014-04-01 00:17:36.000000', 'temperatura', 275.0000, 'ºC'),
	(283144, 122, '2014-04-01 00:17:37.000000', 'temperatura', 908.0000, 'ºC'),
	(283145, 122, '2014-04-01 00:17:38.000000', 'temperatura', 115.0000, 'ºC'),
	(283146, 122, '2014-04-01 00:17:39.000000', 'temperatura', 251.0000, 'ºC'),
	(283147, 122, '2014-04-01 00:17:40.000000', 'temperatura', 912.0000, 'ºC'),
	(283148, 122, '2014-04-01 00:17:41.000000', 'temperatura', 209.0000, 'ºC'),
	(283149, 122, '2014-04-01 00:17:42.000000', 'temperatura', 709.0000, 'ºC'),
	(283150, 122, '2014-04-01 00:17:43.000000', 'temperatura', 520.0000, 'ºC'),
	(283151, 122, '2014-04-01 00:17:44.000000', 'temperatura', 471.0000, 'ºC'),
	(283152, 122, '2014-04-01 00:17:45.000000', 'temperatura', 796.0000, 'ºC'),
	(283153, 122, '2014-04-01 00:17:46.000000', 'temperatura', 169.0000, 'ºC'),
	(283154, 122, '2014-04-01 00:17:47.000000', 'temperatura', 856.0000, 'ºC'),
	(283155, 122, '2014-04-01 00:17:48.000000', 'temperatura', 172.0000, 'ºC'),
	(283156, 122, '2014-04-01 00:17:49.000000', 'temperatura', 695.0000, 'ºC'),
	(283157, 122, '2014-04-01 00:17:50.000000', 'temperatura', 559.0000, 'ºC'),
	(283158, 122, '2014-04-01 00:17:51.000000', 'temperatura', 712.0000, 'ºC'),
	(283159, 122, '2014-04-01 00:17:52.000000', 'temperatura', 683.0000, 'ºC'),
	(283160, 122, '2014-04-01 00:17:53.000000', 'temperatura', 77.0000, 'ºC'),
	(283161, 122, '2014-04-01 00:17:54.000000', 'temperatura', 739.0000, 'ºC'),
	(283162, 122, '2014-04-01 00:17:55.000000', 'temperatura', 1063.0000, 'ºC'),
	(283163, 122, '2014-04-01 00:17:56.000000', 'temperatura', 697.0000, 'ºC'),
	(283164, 122, '2014-04-01 00:17:57.000000', 'temperatura', 298.0000, 'ºC'),
	(283165, 122, '2014-04-01 00:17:58.000000', 'temperatura', 599.0000, 'ºC'),
	(283166, 122, '2014-04-01 00:17:59.000000', 'temperatura', 904.0000, 'ºC'),
	(283167, 122, '2014-04-01 00:18:00.000000', 'temperatura', 321.0000, 'ºC'),
	(283168, 122, '2014-04-01 00:18:01.000000', 'temperatura', 96.0000, 'ºC'),
	(283169, 122, '2014-04-01 00:18:02.000000', 'temperatura', 714.0000, 'ºC'),
	(283170, 122, '2014-04-01 00:18:03.000000', 'temperatura', 886.0000, 'ºC'),
	(283171, 122, '2014-04-01 00:18:04.000000', 'temperatura', 1088.0000, 'ºC'),
	(283172, 122, '2014-04-01 00:18:05.000000', 'temperatura', 381.0000, 'ºC'),
	(283173, 122, '2014-04-01 00:18:06.000000', 'temperatura', 1044.0000, 'ºC'),
	(283174, 122, '2014-04-01 00:18:07.000000', 'temperatura', 477.0000, 'ºC'),
	(283175, 122, '2014-04-01 00:18:08.000000', 'temperatura', 451.0000, 'ºC'),
	(283176, 122, '2014-04-01 00:18:09.000000', 'temperatura', 826.0000, 'ºC'),
	(283177, 122, '2014-04-01 00:18:10.000000', 'temperatura', 376.0000, 'ºC'),
	(283178, 122, '2014-04-01 00:18:11.000000', 'temperatura', 604.0000, 'ºC'),
	(283179, 122, '2014-04-01 00:18:12.000000', 'temperatura', 692.0000, 'ºC'),
	(283180, 122, '2014-04-01 00:18:13.000000', 'temperatura', 447.0000, 'ºC'),
	(283181, 122, '2014-04-01 00:18:14.000000', 'temperatura', 163.0000, 'ºC'),
	(283182, 122, '2014-04-01 00:18:15.000000', 'temperatura', 671.0000, 'ºC'),
	(283183, 122, '2014-04-01 00:18:16.000000', 'temperatura', 467.0000, 'ºC'),
	(283184, 122, '2014-04-01 00:18:17.000000', 'temperatura', 324.0000, 'ºC'),
	(283185, 122, '2014-04-01 00:18:18.000000', 'temperatura', 220.0000, 'ºC'),
	(283186, 122, '2014-04-01 00:18:19.000000', 'temperatura', 128.0000, 'ºC'),
	(283187, 122, '2014-04-01 00:18:20.000000', 'temperatura', 1179.0000, 'ºC'),
	(283188, 122, '2014-04-01 00:18:21.000000', 'temperatura', 714.0000, 'ºC'),
	(283189, 122, '2014-04-01 00:18:22.000000', 'temperatura', 34.0000, 'ºC'),
	(283190, 122, '2014-04-01 00:18:23.000000', 'temperatura', 429.0000, 'ºC'),
	(283191, 122, '2014-04-01 00:18:24.000000', 'temperatura', 845.0000, 'ºC'),
	(283192, 122, '2014-04-01 00:18:25.000000', 'temperatura', 535.0000, 'ºC'),
	(283193, 122, '2014-04-01 00:18:26.000000', 'temperatura', 140.0000, 'ºC'),
	(283194, 122, '2014-04-01 00:18:27.000000', 'temperatura', 296.0000, 'ºC'),
	(283195, 122, '2014-04-01 00:18:28.000000', 'temperatura', 1060.0000, 'ºC'),
	(283196, 122, '2014-04-01 00:18:29.000000', 'temperatura', 813.0000, 'ºC'),
	(283197, 122, '2014-04-01 00:18:30.000000', 'temperatura', 888.0000, 'ºC'),
	(283198, 122, '2014-04-01 00:18:31.000000', 'temperatura', 799.0000, 'ºC'),
	(283199, 122, '2014-04-01 00:18:32.000000', 'temperatura', 130.0000, 'ºC'),
	(283200, 122, '2014-04-01 00:18:33.000000', 'temperatura', 657.0000, 'ºC'),
	(283201, 122, '2014-04-01 00:18:34.000000', 'temperatura', 492.0000, 'ºC'),
	(283202, 122, '2014-04-01 00:18:35.000000', 'temperatura', 492.0000, 'ºC'),
	(283203, 122, '2014-04-01 00:18:36.000000', 'temperatura', 985.0000, 'ºC'),
	(283204, 122, '2014-04-01 00:18:37.000000', 'temperatura', 1048.0000, 'ºC'),
	(283205, 122, '2014-04-01 00:18:38.000000', 'temperatura', 1086.0000, 'ºC'),
	(283206, 122, '2014-04-01 00:18:39.000000', 'temperatura', 1088.0000, 'ºC'),
	(283207, 122, '2014-04-01 00:18:40.000000', 'temperatura', 983.0000, 'ºC'),
	(283208, 122, '2014-04-01 00:18:41.000000', 'temperatura', 449.0000, 'ºC'),
	(283209, 122, '2014-04-01 00:18:42.000000', 'temperatura', 498.0000, 'ºC'),
	(283210, 122, '2014-04-01 00:18:43.000000', 'temperatura', 1142.0000, 'ºC'),
	(283211, 122, '2014-04-01 00:18:44.000000', 'temperatura', 616.0000, 'ºC'),
	(283212, 122, '2014-04-01 00:18:45.000000', 'temperatura', 857.0000, 'ºC'),
	(283213, 122, '2014-04-01 00:18:46.000000', 'temperatura', 36.0000, 'ºC'),
	(283214, 122, '2014-04-01 00:18:47.000000', 'temperatura', 10.0000, 'ºC'),
	(283215, 122, '2014-04-01 00:18:48.000000', 'temperatura', 1144.0000, 'ºC'),
	(283216, 122, '2014-04-01 00:18:49.000000', 'temperatura', 888.0000, 'ºC'),
	(283217, 122, '2014-04-01 00:18:50.000000', 'temperatura', 1010.0000, 'ºC'),
	(283218, 122, '2014-04-01 00:18:51.000000', 'temperatura', 1185.0000, 'ºC'),
	(283219, 122, '2014-04-01 00:18:52.000000', 'temperatura', 498.0000, 'ºC'),
	(283220, 122, '2014-04-01 00:18:53.000000', 'temperatura', 134.0000, 'ºC'),
	(283221, 122, '2014-04-01 00:18:54.000000', 'temperatura', 376.0000, 'ºC'),
	(283222, 122, '2014-04-01 00:18:55.000000', 'temperatura', 279.0000, 'ºC'),
	(283223, 122, '2014-04-01 00:18:56.000000', 'temperatura', 267.0000, 'ºC'),
	(283224, 122, '2014-04-01 00:18:57.000000', 'temperatura', 500.0000, 'ºC'),
	(283225, 122, '2014-04-01 00:18:58.000000', 'temperatura', 500.0000, 'ºC'),
	(283226, 122, '2014-04-01 00:18:59.000000', 'temperatura', 998.0000, 'ºC'),
	(283227, 122, '2014-04-01 00:19:00.000000', 'temperatura', 1090.0000, 'ºC'),
	(283228, 122, '2014-04-01 00:19:01.000000', 'temperatura', 56.0000, 'ºC'),
	(283229, 122, '2014-04-01 00:19:02.000000', 'temperatura', 613.0000, 'ºC'),
	(283230, 122, '2014-04-01 00:19:03.000000', 'temperatura', 496.0000, 'ºC'),
	(283231, 122, '2014-04-01 00:19:04.000000', 'temperatura', 643.0000, 'ºC'),
	(283232, 122, '2014-04-01 00:19:05.000000', 'temperatura', 528.0000, 'ºC'),
	(283233, 122, '2014-04-01 00:19:06.000000', 'temperatura', 710.0000, 'ºC'),
	(283234, 122, '2014-04-01 00:19:07.000000', 'temperatura', 766.0000, 'ºC'),
	(283235, 122, '2014-04-01 00:19:08.000000', 'temperatura', 501.0000, 'ºC'),
	(283236, 122, '2014-04-01 00:19:09.000000', 'temperatura', 205.0000, 'ºC'),
	(283237, 122, '2014-04-01 00:19:10.000000', 'temperatura', 726.0000, 'ºC'),
	(283238, 122, '2014-04-01 00:19:11.000000', 'temperatura', 616.0000, 'ºC'),
	(283239, 122, '2014-04-01 00:19:12.000000', 'temperatura', 901.0000, 'ºC'),
	(283240, 122, '2014-04-01 00:19:13.000000', 'temperatura', 258.0000, 'ºC'),
	(283241, 122, '2014-04-01 00:19:14.000000', 'temperatura', 989.0000, 'ºC'),
	(283242, 122, '2014-04-01 00:19:15.000000', 'temperatura', 572.0000, 'ºC'),
	(283243, 122, '2014-04-01 00:19:16.000000', 'temperatura', 1091.0000, 'ºC'),
	(283244, 122, '2014-04-01 00:19:17.000000', 'temperatura', 140.0000, 'ºC'),
	(283245, 122, '2014-04-01 00:19:18.000000', 'temperatura', 1028.0000, 'ºC'),
	(283246, 122, '2014-04-01 00:19:19.000000', 'temperatura', 1122.0000, 'ºC'),
	(283247, 122, '2014-04-01 00:19:20.000000', 'temperatura', 125.0000, 'ºC'),
	(283248, 122, '2014-04-01 00:19:21.000000', 'temperatura', 861.0000, 'ºC'),
	(283249, 122, '2014-04-01 00:19:22.000000', 'temperatura', 330.0000, 'ºC'),
	(283250, 122, '2014-04-01 00:19:23.000000', 'temperatura', 269.0000, 'ºC'),
	(283251, 122, '2014-04-01 00:19:24.000000', 'temperatura', 354.0000, 'ºC'),
	(283252, 122, '2014-04-01 00:19:25.000000', 'temperatura', 964.0000, 'ºC'),
	(283253, 122, '2014-04-01 00:19:26.000000', 'temperatura', 156.0000, 'ºC'),
	(283254, 122, '2014-04-01 00:19:27.000000', 'temperatura', 292.0000, 'ºC'),
	(283255, 122, '2014-04-01 00:19:28.000000', 'temperatura', 991.0000, 'ºC'),
	(283256, 122, '2014-04-01 00:19:29.000000', 'temperatura', 481.0000, 'ºC'),
	(283257, 122, '2014-04-01 00:19:30.000000', 'temperatura', 633.0000, 'ºC'),
	(283258, 122, '2014-04-01 00:19:31.000000', 'temperatura', 521.0000, 'ºC'),
	(283259, 122, '2014-04-01 00:19:32.000000', 'temperatura', 707.0000, 'ºC'),
	(283260, 122, '2014-04-01 00:19:33.000000', 'temperatura', 774.0000, 'ºC'),
	(283261, 122, '2014-04-01 00:19:34.000000', 'temperatura', 549.0000, 'ºC'),
	(283262, 122, '2014-04-01 00:19:35.000000', 'temperatura', 423.0000, 'ºC'),
	(283263, 122, '2014-04-01 00:19:36.000000', 'temperatura', 469.0000, 'ºC'),
	(283264, 122, '2014-04-01 00:19:37.000000', 'temperatura', 1078.0000, 'ºC'),
	(283265, 122, '2014-04-01 00:19:38.000000', 'temperatura', 382.0000, 'ºC'),
	(283266, 122, '2014-04-01 00:19:39.000000', 'temperatura', 1077.0000, 'ºC'),
	(283267, 122, '2014-04-01 00:19:40.000000', 'temperatura', 640.0000, 'ºC'),
	(283268, 122, '2014-04-01 00:19:41.000000', 'temperatura', 1168.0000, 'ºC'),
	(283269, 122, '2014-04-01 00:19:42.000000', 'temperatura', 321.0000, 'ºC'),
	(283270, 122, '2014-04-01 00:19:43.000000', 'temperatura', 500.0000, 'ºC'),
	(283271, 122, '2014-04-01 00:19:44.000000', 'temperatura', 339.0000, 'ºC'),
	(283272, 122, '2014-04-01 00:19:45.000000', 'temperatura', 195.0000, 'ºC'),
	(283273, 122, '2014-04-01 00:19:46.000000', 'temperatura', 1159.0000, 'ºC'),
	(283274, 122, '2014-04-01 00:19:47.000000', 'temperatura', 409.0000, 'ºC'),
	(283275, 122, '2014-04-01 00:19:48.000000', 'temperatura', 970.0000, 'ºC'),
	(283276, 122, '2014-04-01 00:19:49.000000', 'temperatura', 23.0000, 'ºC'),
	(283277, 122, '2014-04-01 00:19:50.000000', 'temperatura', 807.0000, 'ºC'),
	(283278, 122, '2014-04-01 00:19:51.000000', 'temperatura', 364.0000, 'ºC'),
	(283279, 122, '2014-04-01 00:19:52.000000', 'temperatura', 601.0000, 'ºC'),
	(283280, 122, '2014-04-01 00:19:53.000000', 'temperatura', 713.0000, 'ºC'),
	(283281, 122, '2014-04-01 00:19:54.000000', 'temperatura', 564.0000, 'ºC'),
	(283282, 122, '2014-04-01 00:19:55.000000', 'temperatura', 680.0000, 'ºC'),
	(283283, 122, '2014-04-01 00:19:56.000000', 'temperatura', 509.0000, 'ºC'),
	(283284, 122, '2014-04-01 00:19:57.000000', 'temperatura', 507.0000, 'ºC'),
	(283285, 122, '2014-04-01 00:19:58.000000', 'temperatura', 1008.0000, 'ºC'),
	(283286, 122, '2014-04-01 00:19:59.000000', 'temperatura', 1119.0000, 'ºC'),
	(283287, 122, '2014-04-01 00:20:00.000000', 'temperatura', 170.0000, 'ºC'),
	(283288, 122, '2014-04-01 00:20:01.000000', 'temperatura', 1095.0000, 'ºC'),
	(283289, 122, '2014-04-01 00:20:02.000000', 'temperatura', 163.0000, 'ºC'),
	(283290, 122, '2014-04-01 00:20:03.000000', 'temperatura', 1133.0000, 'ºC'),
	(283291, 122, '2014-04-01 00:20:04.000000', 'temperatura', 375.0000, 'ºC'),
	(283292, 122, '2014-04-01 00:20:05.000000', 'temperatura', 878.0000, 'ºC'),
	(283293, 122, '2014-04-01 00:20:06.000000', 'temperatura', 865.0000, 'ºC'),
	(283294, 122, '2014-04-01 00:20:07.000000', 'temperatura', 491.0000, 'ºC'),
	(283295, 122, '2014-04-01 00:20:08.000000', 'temperatura', 1059.0000, 'ºC'),
	(283296, 122, '2014-04-01 00:20:09.000000', 'temperatura', 223.0000, 'ºC'),
	(283297, 122, '2014-04-01 00:20:10.000000', 'temperatura', 337.0000, 'ºC'),
	(283298, 122, '2014-04-01 00:20:11.000000', 'temperatura', 1019.0000, 'ºC'),
	(283299, 122, '2014-04-01 00:20:12.000000', 'temperatura', 485.0000, 'ºC'),
	(283300, 122, '2014-04-01 00:20:13.000000', 'temperatura', 569.0000, 'ºC'),
	(283301, 122, '2014-04-01 00:20:14.000000', 'temperatura', 190.0000, 'ºC'),
	(283302, 122, '2014-04-01 00:20:15.000000', 'temperatura', 443.0000, 'ºC'),
	(283303, 122, '2014-04-01 00:20:16.000000', 'temperatura', 446.0000, 'ºC'),
	(283304, 122, '2014-04-01 00:20:17.000000', 'temperatura', 903.0000, 'ºC'),
	(283305, 122, '2014-04-01 00:20:18.000000', 'temperatura', 778.0000, 'ºC'),
	(283306, 122, '2014-04-01 00:20:19.000000', 'temperatura', 1180.0000, 'ºC'),
	(283307, 122, '2014-04-01 00:20:20.000000', 'temperatura', 1166.0000, 'ºC'),
	(283308, 122, '2014-04-01 00:20:21.000000', 'temperatura', 1091.0000, 'ºC'),
	(283309, 122, '2014-04-01 00:20:22.000000', 'temperatura', 755.0000, 'ºC'),
	(283310, 122, '2014-04-01 00:20:23.000000', 'temperatura', 506.0000, 'ºC'),
	(283311, 122, '2014-04-01 00:20:24.000000', 'temperatura', 263.0000, 'ºC'),
	(283312, 122, '2014-04-01 00:20:25.000000', 'temperatura', 1000.0000, 'ºC'),
	(283313, 122, '2014-04-01 00:20:26.000000', 'temperatura', 608.0000, 'ºC'),
	(283314, 122, '2014-04-01 00:20:27.000000', 'temperatura', 44.0000, 'ºC'),
	(283315, 122, '2014-04-01 00:20:28.000000', 'temperatura', 794.0000, 'ºC'),
	(283316, 122, '2014-04-01 00:20:29.000000', 'temperatura', 238.0000, 'ºC'),
	(283317, 122, '2014-04-01 00:20:30.000000', 'temperatura', 9.0000, 'ºC'),
	(283318, 122, '2014-04-01 00:20:31.000000', 'temperatura', 532.0000, 'ºC'),
	(283319, 122, '2014-04-01 00:20:32.000000', 'temperatura', 233.0000, 'ºC'),
	(283320, 122, '2014-04-01 00:20:33.000000', 'temperatura', 770.0000, 'ºC'),
	(283321, 122, '2014-04-01 00:20:34.000000', 'temperatura', 752.0000, 'ºC'),
	(283322, 122, '2014-04-01 00:20:35.000000', 'temperatura', 252.0000, 'ºC'),
	(283323, 122, '2014-04-01 00:20:36.000000', 'temperatura', 204.0000, 'ºC'),
	(283324, 122, '2014-04-01 00:20:37.000000', 'temperatura', 262.0000, 'ºC'),
	(283325, 122, '2014-04-01 00:20:38.000000', 'temperatura', 700.0000, 'ºC'),
	(283326, 122, '2014-04-01 00:20:39.000000', 'temperatura', 313.0000, 'ºC'),
	(283327, 122, '2014-04-01 00:20:40.000000', 'temperatura', 664.0000, 'ºC'),
	(283328, 122, '2014-04-01 00:20:41.000000', 'temperatura', 1185.0000, 'ºC'),
	(283329, 122, '2014-04-01 00:20:42.000000', 'temperatura', 331.0000, 'ºC'),
	(283330, 122, '2014-04-01 00:20:43.000000', 'temperatura', 502.0000, 'ºC'),
	(283331, 122, '2014-04-01 00:20:44.000000', 'temperatura', 317.0000, 'ºC'),
	(283332, 122, '2014-04-01 00:20:45.000000', 'temperatura', 80.0000, 'ºC'),
	(283333, 122, '2014-04-01 00:20:46.000000', 'temperatura', 651.0000, 'ºC'),
	(283334, 122, '2014-04-01 00:20:47.000000', 'temperatura', 613.0000, 'ºC'),
	(283335, 122, '2014-04-01 00:20:48.000000', 'temperatura', 1114.0000, 'ºC'),
	(283336, 122, '2014-04-01 00:20:49.000000', 'temperatura', 130.0000, 'ºC'),
	(283337, 122, '2014-04-01 00:20:50.000000', 'temperatura', 910.0000, 'ºC'),
	(283338, 122, '2014-04-01 00:20:51.000000', 'temperatura', 562.0000, 'ºC'),
	(283339, 122, '2014-04-01 00:20:52.000000', 'temperatura', 77.0000, 'ºC'),
	(283340, 122, '2014-04-01 00:20:53.000000', 'temperatura', 1101.0000, 'ºC'),
	(283341, 122, '2014-04-01 00:20:54.000000', 'temperatura', 476.0000, 'ºC'),
	(283342, 122, '2014-04-01 00:20:55.000000', 'temperatura', 277.0000, 'ºC'),
	(283343, 122, '2014-04-01 00:20:56.000000', 'temperatura', 1159.0000, 'ºC'),
	(283344, 122, '2014-04-01 00:20:57.000000', 'temperatura', 163.0000, 'ºC'),
	(283345, 122, '2014-04-01 00:20:58.000000', 'temperatura', 940.0000, 'ºC'),
	(283346, 122, '2014-04-01 00:20:59.000000', 'temperatura', 610.0000, 'ºC'),
	(283347, 122, '2014-04-01 00:21:00.000000', 'temperatura', 232.0000, 'ºC'),
	(283348, 122, '2014-04-01 00:21:01.000000', 'temperatura', 530.0000, 'ºC'),
	(283349, 122, '2014-04-01 00:21:02.000000', 'temperatura', 755.0000, 'ºC'),
	(283350, 122, '2014-04-01 00:21:03.000000', 'temperatura', 985.0000, 'ºC'),
	(283351, 122, '2014-04-01 00:21:04.000000', 'temperatura', 262.0000, 'ºC'),
	(283352, 122, '2014-04-01 00:21:05.000000', 'temperatura', 754.0000, 'ºC'),
	(283353, 122, '2014-04-01 00:21:06.000000', 'temperatura', 585.0000, 'ºC'),
	(283354, 122, '2014-04-01 00:21:07.000000', 'temperatura', 662.0000, 'ºC'),
	(283355, 122, '2014-04-01 00:21:08.000000', 'temperatura', 358.0000, 'ºC'),
	(283356, 122, '2014-04-01 00:21:09.000000', 'temperatura', 1002.0000, 'ºC'),
	(283357, 122, '2014-04-01 00:21:10.000000', 'temperatura', 339.0000, 'ºC'),
	(283358, 122, '2014-04-01 00:21:11.000000', 'temperatura', 1090.0000, 'ºC'),
	(283359, 122, '2014-04-01 00:21:12.000000', 'temperatura', 831.0000, 'ºC'),
	(283360, 122, '2014-04-01 00:21:13.000000', 'temperatura', 885.0000, 'ºC'),
	(283361, 122, '2014-04-01 00:21:14.000000', 'temperatura', 732.0000, 'ºC'),
	(283362, 122, '2014-04-01 00:21:15.000000', 'temperatura', 1006.0000, 'ºC'),
	(283363, 122, '2014-04-01 00:21:16.000000', 'temperatura', 436.0000, 'ºC'),
	(283364, 122, '2014-04-01 00:21:17.000000', 'temperatura', 360.0000, 'ºC'),
	(283365, 122, '2014-04-01 00:21:18.000000', 'temperatura', 494.0000, 'ºC'),
	(283366, 122, '2014-04-01 00:21:19.000000', 'temperatura', 189.0000, 'ºC'),
	(283367, 122, '2014-04-01 00:21:20.000000', 'temperatura', 665.0000, 'ºC'),
	(283368, 122, '2014-04-01 00:21:21.000000', 'temperatura', 357.0000, 'ºC'),
	(283369, 122, '2014-04-01 00:21:22.000000', 'temperatura', 993.0000, 'ºC'),
	(283370, 122, '2014-04-01 00:21:23.000000', 'temperatura', 294.0000, 'ºC'),
	(283371, 122, '2014-04-01 00:21:24.000000', 'temperatura', 893.0000, 'ºC'),
	(283372, 122, '2014-04-01 00:21:25.000000', 'temperatura', 1181.0000, 'ºC'),
	(283373, 122, '2014-04-01 00:21:26.000000', 'temperatura', 827.0000, 'ºC'),
	(283374, 122, '2014-04-01 00:21:27.000000', 'temperatura', 592.0000, 'ºC'),
	(283375, 122, '2014-04-01 00:21:28.000000', 'temperatura', 482.0000, 'ºC'),
	(283376, 122, '2014-04-01 00:21:29.000000', 'temperatura', 631.0000, 'ºC'),
	(283377, 122, '2014-04-01 00:21:30.000000', 'temperatura', 513.0000, 'ºC'),
	(283378, 122, '2014-04-01 00:21:31.000000', 'temperatura', 671.0000, 'ºC'),
	(283379, 122, '2014-04-01 00:21:32.000000', 'temperatura', 618.0000, 'ºC'),
	(283380, 122, '2014-04-01 00:21:33.000000', 'temperatura', 1078.0000, 'ºC'),
	(283381, 122, '2014-04-01 00:21:34.000000', 'temperatura', 1136.0000, 'ºC'),
	(283382, 122, '2014-04-01 00:21:35.000000', 'temperatura', 47.0000, 'ºC'),
	(283383, 122, '2014-04-01 00:21:36.000000', 'temperatura', 429.0000, 'ºC'),
	(283384, 122, '2014-04-01 00:21:37.000000', 'temperatura', 802.0000, 'ºC'),
	(283385, 122, '2014-04-01 00:21:38.000000', 'temperatura', 326.0000, 'ºC'),
	(283386, 122, '2014-04-01 00:21:39.000000', 'temperatura', 425.0000, 'ºC'),
	(283387, 122, '2014-04-01 00:21:40.000000', 'temperatura', 1145.0000, 'ºC'),
	(283388, 122, '2014-04-01 00:21:41.000000', 'temperatura', 852.0000, 'ºC'),
	(283389, 122, '2014-04-01 00:21:42.000000', 'temperatura', 825.0000, 'ºC'),
	(283390, 122, '2014-04-01 00:21:43.000000', 'temperatura', 368.0000, 'ºC'),
	(283391, 122, '2014-04-01 00:21:44.000000', 'temperatura', 566.0000, 'ºC'),
	(283392, 122, '2014-04-01 00:21:45.000000', 'temperatura', 528.0000, 'ºC'),
	(283393, 122, '2014-04-01 00:21:46.000000', 'temperatura', 941.0000, 'ºC'),
	(283394, 122, '2014-04-01 00:21:47.000000', 'temperatura', 724.0000, 'ºC'),
	(283395, 122, '2014-04-01 00:21:48.000000', 'temperatura', 795.0000, 'ºC'),
	(283396, 122, '2014-04-01 00:21:49.000000', 'temperatura', 606.0000, 'ºC'),
	(283397, 122, '2014-04-01 00:21:50.000000', 'temperatura', 646.0000, 'ºC'),
	(283398, 122, '2014-04-01 00:21:51.000000', 'temperatura', 211.0000, 'ºC'),
	(283399, 122, '2014-04-01 00:21:52.000000', 'temperatura', 319.0000, 'ºC'),
	(283400, 122, '2014-04-01 00:21:53.000000', 'temperatura', 960.0000, 'ºC'),
	(283401, 122, '2014-04-01 00:21:54.000000', 'temperatura', 243.0000, 'ºC'),
	(283402, 122, '2014-04-01 00:21:55.000000', 'temperatura', 735.0000, 'ºC'),
	(283403, 122, '2014-04-01 00:21:56.000000', 'temperatura', 548.0000, 'ºC'),
	(283404, 122, '2014-04-01 00:21:57.000000', 'temperatura', 535.0000, 'ºC'),
	(283405, 122, '2014-04-01 00:21:58.000000', 'temperatura', 1031.0000, 'ºC'),
	(283406, 122, '2014-04-01 00:21:59.000000', 'temperatura', 1151.0000, 'ºC'),
	(283407, 122, '2014-04-01 00:22:00.000000', 'temperatura', 264.0000, 'ºC'),
	(283408, 122, '2014-04-01 00:22:01.000000', 'temperatura', 265.0000, 'ºC'),
	(283409, 122, '2014-04-01 00:22:02.000000', 'temperatura', 535.0000, 'ºC'),
	(283410, 122, '2014-04-01 00:22:03.000000', 'temperatura', 682.0000, 'ºC'),
	(283411, 122, '2014-04-01 00:22:04.000000', 'temperatura', 602.0000, 'ºC'),
	(283412, 122, '2014-04-01 00:22:05.000000', 'temperatura', 967.0000, 'ºC'),
	(283413, 122, '2014-04-01 00:22:06.000000', 'temperatura', 627.0000, 'ºC'),
	(283414, 122, '2014-04-01 00:22:07.000000', 'temperatura', 236.0000, 'ºC'),
	(283415, 122, '2014-04-01 00:22:08.000000', 'temperatura', 498.0000, 'ºC'),
	(283416, 122, '2014-04-01 00:22:09.000000', 'temperatura', 584.0000, 'ºC'),
	(283417, 122, '2014-04-01 00:22:10.000000', 'temperatura', 228.0000, 'ºC'),
	(283418, 122, '2014-04-01 00:22:11.000000', 'temperatura', 587.0000, 'ºC'),
	(283419, 122, '2014-04-01 00:22:12.000000', 'temperatura', 1052.0000, 'ºC'),
	(283420, 122, '2014-04-01 00:22:13.000000', 'temperatura', 1099.0000, 'ºC'),
	(283421, 122, '2014-04-01 00:22:14.000000', 'temperatura', 1139.0000, 'ºC'),
	(283422, 122, '2014-04-01 00:22:15.000000', 'temperatura', 1199.0000, 'ºC'),
	(283423, 122, '2014-04-01 00:22:16.000000', 'temperatura', 177.0000, 'ºC'),
	(283424, 122, '2014-04-01 00:22:17.000000', 'temperatura', 888.0000, 'ºC'),
	(283425, 122, '2014-04-01 00:22:18.000000', 'temperatura', 313.0000, 'ºC'),
	(283426, 122, '2014-04-01 00:22:19.000000', 'temperatura', 98.0000, 'ºC'),
	(283427, 122, '2014-04-01 00:22:20.000000', 'temperatura', 754.0000, 'ºC'),
	(283428, 122, '2014-04-01 00:22:21.000000', 'temperatura', 1077.0000, 'ºC'),
	(283429, 122, '2014-04-01 00:22:22.000000', 'temperatura', 723.0000, 'ºC'),
	(283430, 122, '2014-04-01 00:22:23.000000', 'temperatura', 383.0000, 'ºC'),
	(283431, 122, '2014-04-01 00:22:24.000000', 'temperatura', 947.0000, 'ºC'),
	(283432, 122, '2014-04-01 00:22:25.000000', 'temperatura', 1188.0000, 'ºC'),
	(283433, 122, '2014-04-01 00:22:26.000000', 'temperatura', 699.0000, 'ºC'),
	(283434, 122, '2014-04-01 00:22:27.000000', 'temperatura', 1130.0000, 'ºC'),
	(283435, 122, '2014-04-01 00:22:28.000000', 'temperatura', 1154.0000, 'ºC'),
	(283436, 122, '2014-04-01 00:22:29.000000', 'temperatura', 1180.0000, 'ºC'),
	(283437, 122, '2014-04-01 00:22:30.000000', 'temperatura', 37.0000, 'ºC'),
	(283438, 122, '2014-04-01 00:22:31.000000', 'temperatura', 248.0000, 'ºC'),
	(283439, 122, '2014-04-01 00:22:32.000000', 'temperatura', 1128.0000, 'ºC'),
	(283440, 122, '2014-04-01 00:22:33.000000', 'temperatura', 97.0000, 'ºC'),
	(283441, 122, '2014-04-01 00:22:34.000000', 'temperatura', 703.0000, 'ºC'),
	(283442, 122, '2014-04-01 00:22:35.000000', 'temperatura', 824.0000, 'ºC'),
	(283443, 122, '2014-04-01 00:22:36.000000', 'temperatura', 810.0000, 'ºC'),
	(283444, 122, '2014-04-01 00:22:37.000000', 'temperatura', 381.0000, 'ºC'),
	(283445, 122, '2014-04-01 00:22:38.000000', 'temperatura', 676.0000, 'ºC'),
	(283446, 122, '2014-04-01 00:22:39.000000', 'temperatura', 1036.0000, 'ºC'),
	(283447, 122, '2014-04-01 00:22:40.000000', 'temperatura', 753.0000, 'ºC'),
	(283448, 122, '2014-04-01 00:22:41.000000', 'temperatura', 657.0000, 'ºC'),
	(283449, 122, '2014-04-01 00:22:42.000000', 'temperatura', 1026.0000, 'ºC'),
	(283450, 122, '2014-04-01 00:22:43.000000', 'temperatura', 759.0000, 'ºC'),
	(283451, 122, '2014-04-01 00:22:44.000000', 'temperatura', 716.0000, 'ºC'),
	(283452, 122, '2014-04-01 00:22:45.000000', 'temperatura', 107.0000, 'ºC'),
	(283453, 122, '2014-04-01 00:22:46.000000', 'temperatura', 785.0000, 'ºC'),
	(283454, 122, '2014-04-01 00:22:47.000000', 'temperatura', 6.0000, 'ºC'),
	(283455, 122, '2014-04-01 00:22:48.000000', 'temperatura', 75.0000, 'ºC'),
	(283456, 122, '2014-04-01 00:22:49.000000', 'temperatura', 357.0000, 'ºC'),
	(283457, 122, '2014-04-01 00:22:50.000000', 'temperatura', 360.0000, 'ºC'),
	(283458, 122, '2014-04-01 00:22:51.000000', 'temperatura', 728.0000, 'ºC'),
	(283459, 122, '2014-04-01 00:22:52.000000', 'temperatura', 163.0000, 'ºC'),
	(283460, 122, '2014-04-01 00:22:53.000000', 'temperatura', 1033.0000, 'ºC'),
	(283461, 122, '2014-04-01 00:22:54.000000', 'temperatura', 1073.0000, 'ºC'),
	(283462, 122, '2014-04-01 00:22:55.000000', 'temperatura', 1069.0000, 'ºC'),
	(283463, 122, '2014-04-01 00:22:56.000000', 'temperatura', 925.0000, 'ºC'),
	(283464, 122, '2014-04-01 00:22:57.000000', 'temperatura', 220.0000, 'ºC'),
	(283465, 122, '2014-04-01 00:22:58.000000', 'temperatura', 724.0000, 'ºC'),
	(283466, 122, '2014-04-01 00:22:59.000000', 'temperatura', 561.0000, 'ºC'),
	(283467, 122, '2014-04-01 00:23:00.000000', 'temperatura', 636.0000, 'ºC'),
	(283468, 122, '2014-04-01 00:23:01.000000', 'temperatura', 294.0000, 'ºC'),
	(283469, 122, '2014-04-01 00:23:02.000000', 'temperatura', 763.0000, 'ºC'),
	(283470, 122, '2014-04-01 00:23:03.000000', 'temperatura', 536.0000, 'ºC'),
	(283471, 122, '2014-04-01 00:23:04.000000', 'temperatura', 390.0000, 'ºC'),
	(283472, 122, '2014-04-01 00:23:05.000000', 'temperatura', 342.0000, 'ºC'),
	(283473, 122, '2014-04-01 00:23:06.000000', 'temperatura', 541.0000, 'ºC'),
	(283474, 122, '2014-04-01 00:23:07.000000', 'temperatura', 481.0000, 'ºC'),
	(283475, 122, '2014-04-01 00:23:08.000000', 'temperatura', 782.0000, 'ºC'),
	(283476, 122, '2014-04-01 00:23:09.000000', 'temperatura', 66.0000, 'ºC'),
	(283477, 122, '2014-04-01 00:23:10.000000', 'temperatura', 384.0000, 'ºC'),
	(283478, 122, '2014-04-01 00:23:11.000000', 'temperatura', 524.0000, 'ºC'),
	(283479, 122, '2014-04-01 00:23:12.000000', 'temperatura', 269.0000, 'ºC'),
	(283480, 122, '2014-04-01 00:23:13.000000', 'temperatura', 972.0000, 'ºC'),
	(283481, 122, '2014-04-01 00:23:14.000000', 'temperatura', 453.0000, 'ºC'),
	(283482, 122, '2014-04-01 00:23:15.000000', 'temperatura', 551.0000, 'ºC'),
	(283483, 122, '2014-04-01 00:23:16.000000', 'temperatura', 197.0000, 'ºC'),
	(283484, 122, '2014-04-01 00:23:17.000000', 'temperatura', 531.0000, 'ºC'),
	(283485, 122, '2014-04-01 00:23:18.000000', 'temperatura', 866.0000, 'ºC'),
	(283486, 122, '2014-04-01 00:23:19.000000', 'temperatura', 336.0000, 'ºC'),
	(283487, 122, '2014-04-01 00:23:20.000000', 'temperatura', 285.0000, 'ºC'),
	(283488, 122, '2014-04-01 00:23:21.000000', 'temperatura', 414.0000, 'ºC'),
	(283489, 122, '2014-04-01 00:23:22.000000', 'temperatura', 18.0000, 'ºC'),
	(283490, 122, '2014-04-01 00:23:23.000000', 'temperatura', 49.0000, 'ºC'),
	(283491, 122, '2014-04-01 00:23:24.000000', 'temperatura', 189.0000, 'ºC'),
	(283492, 122, '2014-04-01 00:23:25.000000', 'temperatura', 801.0000, 'ºC'),
	(283493, 122, '2014-04-01 00:23:26.000000', 'temperatura', 1039.0000, 'ºC'),
	(283494, 122, '2014-04-01 00:23:27.000000', 'temperatura', 391.0000, 'ºC'),
	(283495, 122, '2014-04-01 00:23:28.000000', 'temperatura', 37.0000, 'ºC'),
	(283496, 122, '2014-04-01 00:23:29.000000', 'temperatura', 214.0000, 'ºC'),
	(283497, 122, '2014-04-01 00:23:30.000000', 'temperatura', 958.0000, 'ºC'),
	(283498, 122, '2014-04-01 00:23:31.000000', 'temperatura', 549.0000, 'ºC'),
	(283499, 122, '2014-04-01 00:23:32.000000', 'temperatura', 1070.0000, 'ºC'),
	(283500, 122, '2014-04-01 00:23:33.000000', 'temperatura', 105.0000, 'ºC'),
	(283501, 122, '2014-04-01 00:23:34.000000', 'temperatura', 915.0000, 'ºC'),
	(283502, 122, '2014-04-01 00:23:35.000000', 'temperatura', 659.0000, 'ºC'),
	(283503, 122, '2014-04-01 00:23:36.000000', 'temperatura', 553.0000, 'ºC'),
	(283504, 122, '2014-04-01 00:23:37.000000', 'temperatura', 788.0000, 'ºC'),
	(283505, 122, '2014-04-01 00:23:38.000000', 'temperatura', 1083.0000, 'ºC'),
	(283506, 122, '2014-04-01 00:23:39.000000', 'temperatura', 651.0000, 'ºC'),
	(283507, 122, '2014-04-01 00:23:40.000000', 'temperatura', 8.0000, 'ºC'),
	(283508, 122, '2014-04-01 00:23:41.000000', 'temperatura', 486.0000, 'ºC'),
	(283509, 122, '2014-04-01 00:23:42.000000', 'temperatura', 6.0000, 'ºC'),
	(283510, 122, '2014-04-01 00:23:43.000000', 'temperatura', 973.0000, 'ºC'),
	(283511, 122, '2014-04-01 00:23:44.000000', 'temperatura', 48.0000, 'ºC'),
	(283512, 122, '2014-04-01 00:23:45.000000', 'temperatura', 919.0000, 'ºC'),
	(283513, 122, '2014-04-01 00:23:46.000000', 'temperatura', 854.0000, 'ºC'),
	(283514, 122, '2014-04-01 00:23:47.000000', 'temperatura', 311.0000, 'ºC'),
	(283515, 122, '2014-04-01 00:23:48.000000', 'temperatura', 197.0000, 'ºC'),
	(283516, 122, '2014-04-01 00:23:49.000000', 'temperatura', 50.0000, 'ºC'),
	(283517, 122, '2014-04-01 00:23:50.000000', 'temperatura', 859.0000, 'ºC'),
	(283518, 122, '2014-04-01 00:23:51.000000', 'temperatura', 546.0000, 'ºC'),
	(283519, 122, '2014-04-01 00:23:52.000000', 'temperatura', 155.0000, 'ºC'),
	(283520, 122, '2014-04-01 00:23:53.000000', 'temperatura', 338.0000, 'ºC'),
	(283521, 122, '2014-04-01 00:23:54.000000', 'temperatura', 24.0000, 'ºC'),
	(283522, 122, '2014-04-01 00:23:55.000000', 'temperatura', 305.0000, 'ºC'),
	(283523, 122, '2014-04-01 00:23:56.000000', 'temperatura', 256.0000, 'ºC'),
	(283524, 122, '2014-04-01 00:23:57.000000', 'temperatura', 363.0000, 'ºC'),
	(283525, 122, '2014-04-01 00:23:58.000000', 'temperatura', 1050.0000, 'ºC'),
	(283526, 122, '2014-04-01 00:23:59.000000', 'temperatura', 561.0000, 'ºC'),
	(283527, 122, '2014-04-01 00:24:00.000000', 'temperatura', 857.0000, 'ºC'),
	(283528, 122, '2014-04-01 00:24:01.000000', 'temperatura', 199.0000, 'ºC'),
	(283529, 122, '2014-04-01 00:24:02.000000', 'temperatura', 827.0000, 'ºC'),
	(283530, 122, '2014-04-01 00:24:03.000000', 'temperatura', 1139.0000, 'ºC'),
	(283531, 122, '2014-04-01 00:24:04.000000', 'temperatura', 812.0000, 'ºC'),
	(283532, 122, '2014-04-01 00:24:05.000000', 'temperatura', 647.0000, 'ºC'),
	(283533, 122, '2014-04-01 00:24:06.000000', 'temperatura', 796.0000, 'ºC'),
	(283534, 122, '2014-04-01 00:24:07.000000', 'temperatura', 843.0000, 'ºC'),
	(283535, 122, '2014-04-01 00:24:08.000000', 'temperatura', 625.0000, 'ºC'),
	(283536, 122, '2014-04-01 00:24:09.000000', 'temperatura', 599.0000, 'ºC'),
	(283537, 122, '2014-04-01 00:24:10.000000', 'temperatura', 1118.0000, 'ºC'),
	(283538, 122, '2014-04-01 00:24:11.000000', 'temperatura', 195.0000, 'ºC'),
	(283539, 122, '2014-04-01 00:24:12.000000', 'temperatura', 21.0000, 'ºC'),
	(283540, 122, '2014-04-01 00:24:13.000000', 'temperatura', 719.0000, 'ºC'),
	(283541, 122, '2014-04-01 00:24:14.000000', 'temperatura', 1134.0000, 'ºC'),
	(283542, 122, '2014-04-01 00:24:15.000000', 'temperatura', 1114.0000, 'ºC'),
	(283543, 122, '2014-04-01 00:24:16.000000', 'temperatura', 968.0000, 'ºC'),
	(283544, 122, '2014-04-01 00:24:17.000000', 'temperatura', 297.0000, 'ºC'),
	(283545, 122, '2014-04-01 00:24:18.000000', 'temperatura', 982.0000, 'ºC'),
	(283546, 122, '2014-04-01 00:24:19.000000', 'temperatura', 419.0000, 'ºC'),
	(283547, 122, '2014-04-01 00:24:20.000000', 'temperatura', 352.0000, 'ºC'),
	(283548, 122, '2014-04-01 00:24:21.000000', 'temperatura', 501.0000, 'ºC'),
	(283549, 122, '2014-04-01 00:24:22.000000', 'temperatura', 250.0000, 'ºC'),
	(283550, 122, '2014-04-01 00:24:23.000000', 'temperatura', 948.0000, 'ºC'),
	(283551, 122, '2014-04-01 00:24:24.000000', 'temperatura', 388.0000, 'ºC'),
	(283552, 122, '2014-04-01 00:24:25.000000', 'temperatura', 299.0000, 'ºC'),
	(283553, 122, '2014-04-01 00:24:26.000000', 'temperatura', 330.0000, 'ºC'),
	(283554, 122, '2014-04-01 00:24:27.000000', 'temperatura', 755.0000, 'ºC'),
	(283555, 122, '2014-04-01 00:24:28.000000', 'temperatura', 384.0000, 'ºC'),
	(283556, 122, '2014-04-01 00:24:29.000000', 'temperatura', 855.0000, 'ºC'),
	(283557, 122, '2014-04-01 00:24:30.000000', 'temperatura', 724.0000, 'ºC'),
	(283558, 122, '2014-04-01 00:24:31.000000', 'temperatura', 1057.0000, 'ºC'),
	(283559, 122, '2014-04-01 00:24:32.000000', 'temperatura', 713.0000, 'ºC'),
	(283560, 122, '2014-04-01 00:24:33.000000', 'temperatura', 396.0000, 'ºC'),
	(283561, 122, '2014-04-01 00:24:34.000000', 'temperatura', 1040.0000, 'ºC'),
	(283562, 122, '2014-04-01 00:24:35.000000', 'temperatura', 413.0000, 'ºC'),
	(283563, 122, '2014-04-01 00:24:36.000000', 'temperatura', 146.0000, 'ºC'),
	(283564, 122, '2014-04-01 00:24:37.000000', 'temperatura', 692.0000, 'ºC'),
	(283565, 122, '2014-04-01 00:24:38.000000', 'temperatura', 624.0000, 'ºC'),
	(283566, 122, '2014-04-01 00:24:39.000000', 'temperatura', 1041.0000, 'ºC'),
	(283567, 122, '2014-04-01 00:24:40.000000', 'temperatura', 934.0000, 'ºC'),
	(283568, 122, '2014-04-01 00:24:41.000000', 'temperatura', 349.0000, 'ºC'),
	(283569, 122, '2014-04-01 00:24:42.000000', 'temperatura', 143.0000, 'ºC'),
	(283570, 122, '2014-04-01 00:24:43.000000', 'temperatura', 868.0000, 'ºC'),
	(283571, 122, '2014-04-01 00:24:44.000000', 'temperatura', 314.0000, 'ºC'),
	(283572, 122, '2014-04-01 00:24:45.000000', 'temperatura', 163.0000, 'ºC'),
	(283573, 122, '2014-04-01 00:24:46.000000', 'temperatura', 1076.0000, 'ºC'),
	(283574, 122, '2014-04-01 00:24:47.000000', 'temperatura', 90.0000, 'ºC'),
	(283575, 122, '2014-04-01 00:24:48.000000', 'temperatura', 822.0000, 'ºC'),
	(283576, 122, '2014-04-01 00:24:49.000000', 'temperatura', 239.0000, 'ºC'),
	(283577, 122, '2014-04-01 00:24:50.000000', 'temperatura', 1133.0000, 'ºC'),
	(283578, 122, '2014-04-01 00:24:51.000000', 'temperatura', 146.0000, 'ºC'),
	(283579, 122, '2014-04-01 00:24:52.000000', 'temperatura', 934.0000, 'ºC'),
	(283580, 122, '2014-04-01 00:24:53.000000', 'temperatura', 632.0000, 'ºC'),
	(283581, 122, '2014-04-01 00:24:54.000000', 'temperatura', 358.0000, 'ºC'),
	(283582, 122, '2014-04-01 00:24:55.000000', 'temperatura', 1095.0000, 'ºC'),
	(283583, 122, '2014-04-01 00:24:56.000000', 'temperatura', 801.0000, 'ºC'),
	(283584, 122, '2014-04-01 00:24:57.000000', 'temperatura', 720.0000, 'ºC'),
	(283585, 122, '2014-04-01 00:24:58.000000', 'temperatura', 1197.0000, 'ºC'),
	(283586, 122, '2014-04-01 00:24:59.000000', 'temperatura', 224.0000, 'ºC'),
	(283587, 122, '2014-04-01 00:25:00.000000', 'temperatura', 1133.0000, 'ºC'),
	(283588, 122, '2014-04-01 00:25:01.000000', 'temperatura', 192.0000, 'ºC'),
	(283589, 122, '2014-04-01 00:25:02.000000', 'temperatura', 1160.0000, 'ºC'),
	(283590, 122, '2014-04-01 00:25:03.000000', 'temperatura', 426.0000, 'ºC'),
	(283591, 122, '2014-04-01 00:25:04.000000', 'temperatura', 1049.0000, 'ºC'),
	(283592, 122, '2014-04-01 00:25:05.000000', 'temperatura', 368.0000, 'ºC'),
	(283593, 122, '2014-04-01 00:25:06.000000', 'temperatura', 1093.0000, 'ºC'),
	(283594, 122, '2014-04-01 00:25:07.000000', 'temperatura', 763.0000, 'ºC'),
	(283595, 122, '2014-04-01 00:25:08.000000', 'temperatura', 536.0000, 'ºC'),
	(283596, 122, '2014-04-01 00:25:09.000000', 'temperatura', 393.0000, 'ºC'),
	(283597, 122, '2014-04-01 00:25:10.000000', 'temperatura', 357.0000, 'ºC'),
	(283598, 122, '2014-04-01 00:25:11.000000', 'temperatura', 605.0000, 'ºC'),
	(283599, 122, '2014-04-01 00:25:12.000000', 'temperatura', 754.0000, 'ºC'),
	(283600, 122, '2014-04-01 00:25:13.000000', 'temperatura', 755.0000, 'ºC'),
	(283601, 122, '2014-04-01 00:25:14.000000', 'temperatura', 315.0000, 'ºC'),
	(283602, 122, '2014-04-01 00:25:15.000000', 'temperatura', 509.0000, 'ºC'),
	(283603, 122, '2014-04-01 00:25:16.000000', 'temperatura', 402.0000, 'ºC'),
	(283604, 122, '2014-04-01 00:25:17.000000', 'temperatura', 482.0000, 'ºC'),
	(283605, 122, '2014-04-01 00:25:18.000000', 'temperatura', 7.0000, 'ºC'),
	(283606, 122, '2014-04-01 00:25:19.000000', 'temperatura', 987.0000, 'ºC'),
	(283607, 122, '2014-04-01 00:25:20.000000', 'temperatura', 117.0000, 'ºC'),
	(283608, 122, '2014-04-01 00:25:21.000000', 'temperatura', 24.0000, 'ºC'),
	(283609, 122, '2014-04-01 00:25:22.000000', 'temperatura', 968.0000, 'ºC'),
	(283610, 122, '2014-04-01 00:25:23.000000', 'temperatura', 1170.0000, 'ºC'),
	(283611, 122, '2014-04-01 00:25:24.000000', 'temperatura', 544.0000, 'ºC'),
	(283612, 122, '2014-04-01 00:25:25.000000', 'temperatura', 413.0000, 'ºC'),
	(283613, 122, '2014-04-01 00:25:26.000000', 'temperatura', 434.0000, 'ºC'),
	(283614, 122, '2014-04-01 00:25:27.000000', 'temperatura', 932.0000, 'ºC'),
	(283615, 122, '2014-04-01 00:25:28.000000', 'temperatura', 956.0000, 'ºC'),
	(283616, 122, '2014-04-01 00:25:29.000000', 'temperatura', 785.0000, 'ºC'),
	(283617, 122, '2014-04-01 00:25:30.000000', 'temperatura', 1056.0000, 'ºC'),
	(283618, 122, '2014-04-01 00:25:31.000000', 'temperatura', 528.0000, 'ºC'),
	(283619, 122, '2014-04-01 00:25:32.000000', 'temperatura', 670.0000, 'ºC'),
	(283620, 122, '2014-04-01 00:25:33.000000', 'temperatura', 566.0000, 'ºC'),
	(283621, 122, '2014-04-01 00:25:34.000000', 'temperatura', 821.0000, 'ºC'),
	(283622, 122, '2014-04-01 00:25:35.000000', 'temperatura', 7.0000, 'ºC'),
	(283623, 122, '2014-04-01 00:25:36.000000', 'temperatura', 1175.0000, 'ºC'),
	(283624, 122, '2014-04-01 00:25:37.000000', 'temperatura', 1053.0000, 'ºC'),
	(283625, 122, '2014-04-01 00:25:38.000000', 'temperatura', 541.0000, 'ºC'),
	(283626, 122, '2014-04-01 00:25:39.000000', 'temperatura', 746.0000, 'ºC'),
	(283627, 122, '2014-04-01 00:25:40.000000', 'temperatura', 907.0000, 'ºC'),
	(283628, 122, '2014-04-01 00:25:41.000000', 'temperatura', 1100.0000, 'ºC'),
	(283629, 122, '2014-04-01 00:25:42.000000', 'temperatura', 376.0000, 'ºC'),
	(283630, 122, '2014-04-01 00:25:43.000000', 'temperatura', 982.0000, 'ºC'),
	(283631, 122, '2014-04-01 00:25:44.000000', 'temperatura', 184.0000, 'ºC'),
	(283632, 122, '2014-04-01 00:25:45.000000', 'temperatura', 374.0000, 'ºC'),
	(283633, 122, '2014-04-01 00:25:46.000000', 'temperatura', 117.0000, 'ºC'),
	(283634, 122, '2014-04-01 00:25:47.000000', 'temperatura', 662.0000, 'ºC'),
	(283635, 122, '2014-04-01 00:25:48.000000', 'temperatura', 563.0000, 'ºC'),
	(283636, 122, '2014-04-01 00:25:49.000000', 'temperatura', 828.0000, 'ºC'),
	(283637, 122, '2014-04-01 00:25:50.000000', 'temperatura', 52.0000, 'ºC'),
	(283638, 122, '2014-04-01 00:25:51.000000', 'temperatura', 176.0000, 'ºC'),
	(283639, 122, '2014-04-01 00:25:52.000000', 'temperatura', 725.0000, 'ºC'),
	(283640, 122, '2014-04-01 00:25:53.000000', 'temperatura', 696.0000, 'ºC'),
	(283641, 122, '2014-04-01 00:25:54.000000', 'temperatura', 105.0000, 'ºC'),
	(283642, 122, '2014-04-01 00:25:55.000000', 'temperatura', 839.0000, 'ºC'),
	(283643, 122, '2014-04-01 00:25:56.000000', 'temperatura', 279.0000, 'ºC'),
	(283644, 122, '2014-04-01 00:25:57.000000', 'temperatura', 79.0000, 'ºC'),
	(283645, 122, '2014-04-01 00:25:58.000000', 'temperatura', 760.0000, 'ºC'),
	(283646, 122, '2014-04-01 00:25:59.000000', 'temperatura', 1163.0000, 'ºC'),
	(283647, 122, '2014-04-01 00:26:00.000000', 'temperatura', 1135.0000, 'ºC'),
	(283648, 122, '2014-04-01 00:26:01.000000', 'temperatura', 987.0000, 'ºC'),
	(283649, 122, '2014-04-01 00:26:02.000000', 'temperatura', 331.0000, 'ºC'),
	(283650, 122, '2014-04-01 00:26:03.000000', 'temperatura', 1096.0000, 'ºC'),
	(283651, 122, '2014-04-01 00:26:04.000000', 'temperatura', 884.0000, 'ºC'),
	(283652, 122, '2014-04-01 00:26:05.000000', 'temperatura', 1134.0000, 'ºC'),
	(283653, 122, '2014-04-01 00:26:06.000000', 'temperatura', 619.0000, 'ºC'),
	(283654, 122, '2014-04-01 00:26:07.000000', 'temperatura', 895.0000, 'ºC'),
	(283655, 122, '2014-04-01 00:26:08.000000', 'temperatura', 218.0000, 'ºC'),
	(283656, 122, '2014-04-01 00:26:09.000000', 'temperatura', 805.0000, 'ºC'),
	(283657, 122, '2014-04-01 00:26:10.000000', 'temperatura', 970.0000, 'ºC'),
	(283658, 122, '2014-04-01 00:26:11.000000', 'temperatura', 38.0000, 'ºC'),
	(283659, 122, '2014-04-01 00:26:12.000000', 'temperatura', 879.0000, 'ºC'),
	(283660, 122, '2014-04-01 00:26:13.000000', 'temperatura', 684.0000, 'ºC'),
	(283661, 122, '2014-04-01 00:26:14.000000', 'temperatura', 780.0000, 'ºC'),
	(283662, 122, '2014-04-01 00:26:15.000000', 'temperatura', 650.0000, 'ºC'),
	(283663, 122, '2014-04-01 00:26:16.000000', 'temperatura', 911.0000, 'ºC'),
	(283664, 122, '2014-04-01 00:26:17.000000', 'temperatura', 206.0000, 'ºC'),
	(283665, 122, '2014-04-01 00:26:18.000000', 'temperatura', 696.0000, 'ºC'),
	(283666, 122, '2014-04-01 00:26:19.000000', 'temperatura', 465.0000, 'ºC'),
	(283667, 122, '2014-04-01 00:26:20.000000', 'temperatura', 237.0000, 'ºC'),
	(283668, 122, '2014-04-01 00:26:21.000000', 'temperatura', 988.0000, 'ºC'),
	(283669, 122, '2014-04-01 00:26:22.000000', 'temperatura', 633.0000, 'ºC'),
	(283670, 122, '2014-04-01 00:26:23.000000', 'temperatura', 198.0000, 'ºC'),
	(283671, 122, '2014-04-01 00:26:24.000000', 'temperatura', 294.0000, 'ºC'),
	(283672, 122, '2014-04-01 00:26:25.000000', 'temperatura', 878.0000, 'ºC'),
	(283673, 122, '2014-04-01 00:26:26.000000', 'temperatura', 1105.0000, 'ºC'),
	(283674, 122, '2014-04-01 00:26:27.000000', 'temperatura', 493.0000, 'ºC'),
	(283675, 122, '2014-04-01 00:26:28.000000', 'temperatura', 349.0000, 'ºC'),
	(283676, 122, '2014-04-01 00:26:29.000000', 'temperatura', 270.0000, 'ºC'),
	(283677, 122, '2014-04-01 00:26:30.000000', 'temperatura', 300.0000, 'ºC'),
	(283678, 122, '2014-04-01 00:26:31.000000', 'temperatura', 690.0000, 'ºC'),
	(283679, 122, '2014-04-01 00:26:32.000000', 'temperatura', 151.0000, 'ºC'),
	(283680, 122, '2014-04-01 00:26:33.000000', 'temperatura', 1088.0000, 'ºC'),
	(283681, 122, '2014-04-01 00:26:34.000000', 'temperatura', 185.0000, 'ºC'),
	(283682, 122, '2014-04-01 00:26:35.000000', 'temperatura', 64.0000, 'ºC'),
	(283683, 122, '2014-04-01 00:26:36.000000', 'temperatura', 963.0000, 'ºC'),
	(283684, 122, '2014-04-01 00:26:37.000000', 'temperatura', 1023.0000, 'ºC'),
	(283685, 122, '2014-04-01 00:26:38.000000', 'temperatura', 1026.0000, 'ºC'),
	(283686, 122, '2014-04-01 00:26:39.000000', 'temperatura', 862.0000, 'ºC'),
	(283687, 122, '2014-04-01 00:26:40.000000', 'temperatura', 33.0000, 'ºC'),
	(283688, 122, '2014-04-01 00:26:41.000000', 'temperatura', 1180.0000, 'ºC'),
	(283689, 122, '2014-04-01 00:26:42.000000', 'temperatura', 999.0000, 'ºC'),
	(283690, 122, '2014-04-01 00:26:43.000000', 'temperatura', 259.0000, 'ºC'),
	(283691, 122, '2014-04-01 00:26:44.000000', 'temperatura', 695.0000, 'ºC'),
	(283692, 122, '2014-04-01 00:26:45.000000', 'temperatura', 301.0000, 'ºC'),
	(283693, 122, '2014-04-01 00:26:46.000000', 'temperatura', 620.0000, 'ºC'),
	(283694, 122, '2014-04-01 00:26:47.000000', 'temperatura', 996.0000, 'ºC'),
	(283695, 122, '2014-04-01 00:26:48.000000', 'temperatura', 721.0000, 'ºC'),
	(283696, 122, '2014-04-01 00:26:49.000000', 'temperatura', 620.0000, 'ºC'),
	(283697, 122, '2014-04-01 00:26:50.000000', 'temperatura', 935.0000, 'ºC'),
	(283698, 122, '2014-04-01 00:26:51.000000', 'temperatura', 416.0000, 'ºC'),
	(283699, 122, '2014-04-01 00:26:52.000000', 'temperatura', 474.0000, 'ºC'),
	(283700, 122, '2014-04-01 00:26:53.000000', 'temperatura', 1123.0000, 'ºC'),
	(283701, 122, '2014-04-01 00:26:54.000000', 'temperatura', 596.0000, 'ºC'),
	(283702, 122, '2014-04-01 00:26:55.000000', 'temperatura', 809.0000, 'ºC'),
	(283703, 122, '2014-04-01 00:26:56.000000', 'temperatura', 1058.0000, 'ºC'),
	(283704, 122, '2014-04-01 00:26:57.000000', 'temperatura', 464.0000, 'ºC'),
	(283705, 122, '2014-04-01 00:26:58.000000', 'temperatura', 348.0000, 'ºC'),
	(283706, 122, '2014-04-01 00:26:59.000000', 'temperatura', 348.0000, 'ºC'),
	(283707, 122, '2014-04-01 00:27:00.000000', 'temperatura', 694.0000, 'ºC'),
	(283708, 122, '2014-04-01 00:27:01.000000', 'temperatura', 27.0000, 'ºC'),
	(283709, 122, '2014-04-01 00:27:02.000000', 'temperatura', 456.0000, 'ºC'),
	(283710, 122, '2014-04-01 00:27:03.000000', 'temperatura', 996.0000, 'ºC'),
	(283711, 122, '2014-04-01 00:27:04.000000', 'temperatura', 16.0000, 'ºC'),
	(283712, 122, '2014-04-01 00:27:05.000000', 'temperatura', 691.0000, 'ºC'),
	(283713, 122, '2014-04-01 00:27:06.000000', 'temperatura', 1010.0000, 'ºC'),
	(283714, 122, '2014-04-01 00:27:07.000000', 'temperatura', 574.0000, 'ºC'),
	(283715, 122, '2014-04-01 00:27:08.000000', 'temperatura', 1043.0000, 'ºC'),
	(283716, 122, '2014-04-01 00:27:09.000000', 'temperatura', 1092.0000, 'ºC'),
	(283717, 122, '2014-04-01 00:27:10.000000', 'temperatura', 1132.0000, 'ºC'),
	(283718, 122, '2014-04-01 00:27:11.000000', 'temperatura', 1184.0000, 'ºC'),
	(283719, 122, '2014-04-01 00:27:12.000000', 'temperatura', 126.0000, 'ºC'),
	(283720, 122, '2014-04-01 00:27:13.000000', 'temperatura', 676.0000, 'ºC'),
	(283721, 122, '2014-04-01 00:27:14.000000', 'temperatura', 603.0000, 'ºC'),
	(283722, 122, '2014-04-01 00:27:15.000000', 'temperatura', 987.0000, 'ºC'),
	(283723, 122, '2014-04-01 00:27:16.000000', 'temperatura', 726.0000, 'ºC'),
	(283724, 122, '2014-04-01 00:27:17.000000', 'temperatura', 672.0000, 'ºC'),
	(283725, 122, '2014-04-01 00:27:18.000000', 'temperatura', 1181.0000, 'ºC'),
	(283726, 122, '2014-04-01 00:27:19.000000', 'temperatura', 289.0000, 'ºC'),
	(283727, 122, '2014-04-01 00:27:20.000000', 'temperatura', 305.0000, 'ºC'),
	(283728, 122, '2014-04-01 00:27:21.000000', 'temperatura', 656.0000, 'ºC'),
	(283729, 122, '2014-04-01 00:27:22.000000', 'temperatura', 1166.0000, 'ºC'),
	(283730, 122, '2014-04-01 00:27:23.000000', 'temperatura', 264.0000, 'ºC'),
	(283731, 122, '2014-04-01 00:27:24.000000', 'temperatura', 223.0000, 'ºC'),
	(283732, 122, '2014-04-01 00:27:25.000000', 'temperatura', 324.0000, 'ºC'),
	(283733, 122, '2014-04-01 00:27:26.000000', 'temperatura', 951.0000, 'ºC'),
	(283734, 122, '2014-04-01 00:27:27.000000', 'temperatura', 183.0000, 'ºC'),
	(283735, 122, '2014-04-01 00:27:28.000000', 'temperatura', 463.0000, 'ºC'),
	(283736, 122, '2014-04-01 00:27:29.000000', 'temperatura', 566.0000, 'ºC'),
	(283737, 122, '2014-04-01 00:27:30.000000', 'temperatura', 243.0000, 'ºC'),
	(283738, 122, '2014-04-01 00:27:31.000000', 'temperatura', 717.0000, 'ºC'),
	(283739, 122, '2014-04-01 00:27:32.000000', 'temperatura', 455.0000, 'ºC'),
	(283740, 122, '2014-04-01 00:27:33.000000', 'temperatura', 124.0000, 'ºC'),
	(283741, 122, '2014-04-01 00:27:34.000000', 'temperatura', 456.0000, 'ºC'),
	(283742, 122, '2014-04-01 00:27:35.000000', 'temperatura', 710.0000, 'ºC'),
	(283743, 122, '2014-04-01 00:27:36.000000', 'temperatura', 983.0000, 'ºC'),
	(283744, 122, '2014-04-01 00:27:37.000000', 'temperatura', 385.0000, 'ºC'),
	(283745, 122, '2014-04-01 00:27:38.000000', 'temperatura', 178.0000, 'ºC'),
	(283746, 122, '2014-04-01 00:27:39.000000', 'temperatura', 932.0000, 'ºC'),
	(283747, 122, '2014-04-01 00:27:40.000000', 'temperatura', 530.0000, 'ºC'),
	(283748, 122, '2014-04-01 00:27:41.000000', 'temperatura', 1053.0000, 'ºC'),
	(283749, 122, '2014-04-01 00:27:42.000000', 'temperatura', 75.0000, 'ºC'),
	(283750, 122, '2014-04-01 00:27:43.000000', 'temperatura', 816.0000, 'ºC'),
	(283751, 122, '2014-04-01 00:27:44.000000', 'temperatura', 258.0000, 'ºC'),
	(283752, 122, '2014-04-01 00:27:45.000000', 'temperatura', 40.0000, 'ºC'),
	(283753, 122, '2014-04-01 00:27:46.000000', 'temperatura', 628.0000, 'ºC'),
	(283754, 122, '2014-04-01 00:27:47.000000', 'temperatura', 618.0000, 'ºC'),
	(283755, 122, '2014-04-01 00:27:48.000000', 'temperatura', 9.0000, 'ºC'),
	(283756, 122, '2014-04-01 00:27:49.000000', 'temperatura', 590.0000, 'ºC'),
	(283757, 122, '2014-04-01 00:27:50.000000', 'temperatura', 524.0000, 'ºC'),
	(283758, 122, '2014-04-01 00:27:51.000000', 'temperatura', 852.0000, 'ºC'),
	(283759, 122, '2014-04-01 00:27:52.000000', 'temperatura', 285.0000, 'ºC'),
	(283760, 122, '2014-04-01 00:27:53.000000', 'temperatura', 73.0000, 'ºC'),
	(283761, 122, '2014-04-01 00:27:54.000000', 'temperatura', 709.0000, 'ºC'),
	(283762, 122, '2014-04-01 00:27:55.000000', 'temperatura', 926.0000, 'ºC'),
	(283763, 122, '2014-04-01 00:27:56.000000', 'temperatura', 104.0000, 'ºC'),
	(283764, 122, '2014-04-01 00:27:57.000000', 'temperatura', 143.0000, 'ºC'),
	(283765, 122, '2014-04-01 00:27:58.000000', 'temperatura', 404.0000, 'ºC'),
	(283766, 122, '2014-04-01 00:27:59.000000', 'temperatura', 390.0000, 'ºC'),
	(283767, 122, '2014-04-01 00:28:00.000000', 'temperatura', 738.0000, 'ºC'),
	(283768, 122, '2014-04-01 00:28:01.000000', 'temperatura', 121.0000, 'ºC'),
	(283769, 122, '2014-04-01 00:28:02.000000', 'temperatura', 790.0000, 'ºC'),
	(283770, 122, '2014-04-01 00:28:03.000000', 'temperatura', 1189.0000, 'ºC'),
	(283771, 122, '2014-04-01 00:28:04.000000', 'temperatura', 1175.0000, 'ºC'),
	(283772, 122, '2014-04-01 00:28:05.000000', 'temperatura', 1108.0000, 'ºC'),
	(283773, 122, '2014-04-01 00:28:06.000000', 'temperatura', 816.0000, 'ºC'),
	(283774, 122, '2014-04-01 00:28:07.000000', 'temperatura', 757.0000, 'ºC'),
	(283775, 122, '2014-04-01 00:28:08.000000', 'temperatura', 138.0000, 'ºC'),
	(283776, 122, '2014-04-01 00:28:09.000000', 'temperatura', 817.0000, 'ºC'),
	(283777, 122, '2014-04-01 00:28:10.000000', 'temperatura', 73.0000, 'ºC'),
	(283778, 122, '2014-04-01 00:28:11.000000', 'temperatura', 314.0000, 'ºC'),
	(283779, 122, '2014-04-01 00:28:12.000000', 'temperatura', 154.0000, 'ºC'),
	(283780, 122, '2014-04-01 00:28:13.000000', 'temperatura', 1026.0000, 'ºC'),
	(283781, 122, '2014-04-01 00:28:14.000000', 'temperatura', 1071.0000, 'ºC'),
	(283782, 122, '2014-04-01 00:28:15.000000', 'temperatura', 1076.0000, 'ºC'),
	(283783, 122, '2014-04-01 00:28:16.000000', 'temperatura', 969.0000, 'ºC'),
	(283784, 122, '2014-04-01 00:28:17.000000', 'temperatura', 418.0000, 'ºC'),
	(283785, 122, '2014-04-01 00:28:18.000000', 'temperatura', 383.0000, 'ºC'),
	(283786, 122, '2014-04-01 00:28:19.000000', 'temperatura', 662.0000, 'ºC'),
	(283787, 122, '2014-04-01 00:28:20.000000', 'temperatura', 960.0000, 'ºC'),
	(283788, 122, '2014-04-01 00:28:21.000000', 'temperatura', 417.0000, 'ºC'),
	(283789, 122, '2014-04-01 00:28:22.000000', 'temperatura', 403.0000, 'ºC'),
	(283790, 122, '2014-04-01 00:28:23.000000', 'temperatura', 765.0000, 'ºC'),
	(283791, 122, '2014-04-01 00:28:24.000000', 'temperatura', 216.0000, 'ºC'),
	(283792, 122, '2014-04-01 00:28:25.000000', 'temperatura', 1187.0000, 'ºC'),
	(283793, 122, '2014-04-01 00:28:26.000000', 'temperatura', 485.0000, 'ºC'),
	(283794, 122, '2014-04-01 00:28:27.000000', 'temperatura', 65.0000, 'ºC'),
	(283795, 122, '2014-04-01 00:28:28.000000', 'temperatura', 72.0000, 'ºC'),
	(283796, 122, '2014-04-01 00:28:29.000000', 'temperatura', 164.0000, 'ºC'),
	(283797, 122, '2014-04-01 00:28:30.000000', 'temperatura', 604.0000, 'ºC'),
	(283798, 122, '2014-04-01 00:28:31.000000', 'temperatura', 128.0000, 'ºC'),
	(283799, 122, '2014-04-01 00:28:32.000000', 'temperatura', 28.0000, 'ºC'),
	(283800, 122, '2014-04-01 00:28:33.000000', 'temperatura', 956.0000, 'ºC'),
	(283801, 122, '2014-04-01 00:28:34.000000', 'temperatura', 1096.0000, 'ºC'),
	(283802, 122, '2014-04-01 00:28:35.000000', 'temperatura', 212.0000, 'ºC'),
	(283803, 122, '2014-04-01 00:28:36.000000', 'temperatura', 172.0000, 'ºC'),
	(283804, 122, '2014-04-01 00:28:37.000000', 'temperatura', 227.0000, 'ºC'),
	(283805, 122, '2014-04-01 00:28:38.000000', 'temperatura', 617.0000, 'ºC'),
	(283806, 122, '2014-04-01 00:28:39.000000', 'temperatura', 4.0000, 'ºC'),
	(283807, 122, '2014-04-01 00:28:40.000000', 'temperatura', 573.0000, 'ºC'),
	(283808, 122, '2014-04-01 00:28:41.000000', 'temperatura', 450.0000, 'ºC'),
	(283809, 122, '2014-04-01 00:28:42.000000', 'temperatura', 534.0000, 'ºC'),
	(283810, 122, '2014-04-01 00:28:43.000000', 'temperatura', 119.0000, 'ºC'),
	(283811, 122, '2014-04-01 00:28:44.000000', 'temperatura', 193.0000, 'ºC'),
	(283812, 122, '2014-04-01 00:28:45.000000', 'temperatura', 609.0000, 'ºC'),
	(283813, 122, '2014-04-01 00:28:46.000000', 'temperatura', 65.0000, 'ºC'),
	(283814, 122, '2014-04-01 00:28:47.000000', 'temperatura', 901.0000, 'ºC'),
	(283815, 122, '2014-04-01 00:28:48.000000', 'temperatura', 709.0000, 'ºC'),
	(283816, 122, '2014-04-01 00:28:49.000000', 'temperatura', 843.0000, 'ºC'),
	(283817, 122, '2014-04-01 00:28:50.000000', 'temperatura', 889.0000, 'ºC'),
	(283818, 122, '2014-04-01 00:28:51.000000', 'temperatura', 718.0000, 'ºC'),
	(283819, 122, '2014-04-01 00:28:52.000000', 'temperatura', 921.0000, 'ºC'),
	(283820, 122, '2014-04-01 00:28:53.000000', 'temperatura', 54.0000, 'ºC'),
	(283821, 122, '2014-04-01 00:28:54.000000', 'temperatura', 1107.0000, 'ºC'),
	(283822, 122, '2014-04-01 00:28:55.000000', 'temperatura', 574.0000, 'ºC'),
	(283823, 122, '2014-04-01 00:28:56.000000', 'temperatura', 751.0000, 'ºC'),
	(283824, 122, '2014-04-01 00:28:57.000000', 'temperatura', 831.0000, 'ºC'),
	(283825, 122, '2014-04-01 00:28:58.000000', 'temperatura', 703.0000, 'ºC'),
	(283826, 122, '2014-04-01 00:28:59.000000', 'temperatura', 1021.0000, 'ºC'),
	(283827, 122, '2014-04-01 00:29:00.000000', 'temperatura', 599.0000, 'ºC'),
	(283828, 122, '2014-04-01 00:29:01.000000', 'temperatura', 1133.0000, 'ºC'),
	(283829, 122, '2014-04-01 00:29:02.000000', 'temperatura', 268.0000, 'ºC'),
	(283830, 122, '2014-04-01 00:29:03.000000', 'temperatura', 341.0000, 'ºC'),
	(283831, 122, '2014-04-01 00:29:04.000000', 'temperatura', 900.0000, 'ºC'),
	(283832, 122, '2014-04-01 00:29:05.000000', 'temperatura', 1079.0000, 'ºC'),
	(283833, 122, '2014-04-01 00:29:06.000000', 'temperatura', 295.0000, 'ºC'),
	(283834, 122, '2014-04-01 00:29:07.000000', 'temperatura', 637.0000, 'ºC'),
	(283835, 122, '2014-04-01 00:29:08.000000', 'temperatura', 1103.0000, 'ºC'),
	(283836, 122, '2014-04-01 00:29:09.000000', 'temperatura', 5.0000, 'ºC'),
	(283837, 122, '2014-04-01 00:29:10.000000', 'temperatura', 316.0000, 'ºC'),
	(283838, 122, '2014-04-01 00:29:11.000000', 'temperatura', 363.0000, 'ºC'),
	(283839, 122, '2014-04-01 00:29:12.000000', 'temperatura', 869.0000, 'ºC'),
	(283840, 122, '2014-04-01 00:29:13.000000', 'temperatura', 858.0000, 'ºC'),
	(283841, 122, '2014-04-01 00:29:14.000000', 'temperatura', 484.0000, 'ºC'),
	(283842, 122, '2014-04-01 00:29:15.000000', 'temperatura', 1046.0000, 'ºC'),
	(283843, 122, '2014-04-01 00:29:16.000000', 'temperatura', 177.0000, 'ºC'),
	(283844, 122, '2014-04-01 00:29:17.000000', 'temperatura', 146.0000, 'ºC'),
	(283845, 122, '2014-04-01 00:29:18.000000', 'temperatura', 202.0000, 'ºC'),
	(283846, 122, '2014-04-01 00:29:19.000000', 'temperatura', 571.0000, 'ºC'),
	(283847, 122, '2014-04-01 00:29:20.000000', 'temperatura', 1048.0000, 'ºC'),
	(283848, 122, '2014-04-01 00:29:21.000000', 'temperatura', 1129.0000, 'ºC'),
	(283849, 122, '2014-04-01 00:29:22.000000', 'temperatura', 101.0000, 'ºC'),
	(283850, 122, '2014-04-01 00:29:23.000000', 'temperatura', 719.0000, 'ºC'),
	(283851, 122, '2014-04-01 00:29:24.000000', 'temperatura', 891.0000, 'ºC'),
	(283852, 122, '2014-04-01 00:29:25.000000', 'temperatura', 1099.0000, 'ºC'),
	(283853, 122, '2014-04-01 00:29:26.000000', 'temperatura', 422.0000, 'ºC'),
	(283854, 122, '2014-04-01 00:29:27.000000', 'temperatura', 13.0000, 'ºC'),
	(283855, 122, '2014-04-01 00:29:28.000000', 'temperatura', 0.0000, 'ºC'),
	(283856, 122, '2014-04-01 00:29:29.000000', 'temperatura', 1162.0000, 'ºC'),
	(283857, 122, '2014-04-01 00:29:30.000000', 'temperatura', 1011.0000, 'ºC'),
	(283858, 122, '2014-04-01 00:29:31.000000', 'temperatura', 368.0000, 'ºC'),
	(283859, 122, '2014-04-01 00:29:32.000000', 'temperatura', 7.0000, 'ºC'),
	(283860, 122, '2014-04-01 00:29:33.000000', 'temperatura', 133.0000, 'ºC'),
	(283861, 122, '2014-04-01 00:29:34.000000', 'temperatura', 646.0000, 'ºC'),
	(283862, 122, '2014-04-01 00:29:35.000000', 'temperatura', 429.0000, 'ºC'),
	(283863, 122, '2014-04-01 00:29:36.000000', 'temperatura', 207.0000, 'ºC'),
	(283864, 122, '2014-04-01 00:29:37.000000', 'temperatura', 950.0000, 'ºC'),
	(283865, 122, '2014-04-01 00:29:38.000000', 'temperatura', 530.0000, 'ºC'),
	(283866, 122, '2014-04-01 00:29:39.000000', 'temperatura', 1001.0000, 'ºC'),
	(283867, 122, '2014-04-01 00:29:40.000000', 'temperatura', 1015.0000, 'ºC'),
	(283868, 122, '2014-04-01 00:29:41.000000', 'temperatura', 872.0000, 'ºC'),
	(283869, 122, '2014-04-01 00:29:42.000000', 'temperatura', 115.0000, 'ºC'),
	(283870, 122, '2014-04-01 00:29:43.000000', 'temperatura', 360.0000, 'ºC'),
	(283871, 122, '2014-04-01 00:29:44.000000', 'temperatura', 254.0000, 'ºC'),
	(283872, 122, '2014-04-01 00:29:45.000000', 'temperatura', 191.0000, 'ºC'),
	(283873, 122, '2014-04-01 00:29:46.000000', 'temperatura', 193.0000, 'ºC'),
	(283874, 122, '2014-04-01 00:29:47.000000', 'temperatura', 393.0000, 'ºC'),
	(283875, 122, '2014-04-01 00:29:48.000000', 'temperatura', 187.0000, 'ºC'),
	(283876, 122, '2014-04-01 00:29:49.000000', 'temperatura', 955.0000, 'ºC'),
	(283877, 122, '2014-04-01 00:29:50.000000', 'temperatura', 617.0000, 'ºC'),
	(283878, 122, '2014-04-01 00:29:51.000000', 'temperatura', 217.0000, 'ºC'),
	(283879, 122, '2014-04-01 00:29:52.000000', 'temperatura', 437.0000, 'ºC'),
	(283880, 122, '2014-04-01 00:29:53.000000', 'temperatura', 335.0000, 'ºC'),
	(283881, 122, '2014-04-01 00:29:54.000000', 'temperatura', 364.0000, 'ºC'),
	(283882, 122, '2014-04-01 00:29:55.000000', 'temperatura', 816.0000, 'ºC'),
	(283883, 122, '2014-04-01 00:29:56.000000', 'temperatura', 587.0000, 'ºC'),
	(283884, 122, '2014-04-01 00:29:57.000000', 'temperatura', 488.0000, 'ºC'),
	(283885, 122, '2014-04-01 00:29:58.000000', 'temperatura', 682.0000, 'ºC'),
	(283886, 122, '2014-04-01 00:29:59.000000', 'temperatura', 744.0000, 'ºC'),
	(283887, 122, '2014-04-01 00:30:00.000000', 'temperatura', 474.0000, 'ºC'),
	(283888, 122, '2014-04-01 00:30:01.000000', 'temperatura', 139.0000, 'ºC'),
	(283889, 122, '2014-04-01 00:30:02.000000', 'temperatura', 474.0000, 'ºC'),
	(283890, 122, '2014-04-01 00:30:03.000000', 'temperatura', 755.0000, 'ºC'),
	(283891, 122, '2014-04-01 00:30:04.000000', 'temperatura', 1152.0000, 'ºC'),
	(283892, 122, '2014-04-01 00:30:05.000000', 'temperatura', 1097.0000, 'ºC'),
	(283893, 122, '2014-04-01 00:30:06.000000', 'temperatura', 830.0000, 'ºC'),
	(283894, 122, '2014-04-01 00:30:07.000000', 'temperatura', 857.0000, 'ºC'),
	(283895, 122, '2014-04-01 00:30:08.000000', 'temperatura', 598.0000, 'ºC'),
	(283896, 122, '2014-04-01 00:30:09.000000', 'temperatura', 421.0000, 'ºC'),
	(283897, 122, '2014-04-01 00:30:10.000000', 'temperatura', 308.0000, 'ºC'),
	(283898, 122, '2014-04-01 00:30:11.000000', 'temperatura', 278.0000, 'ºC'),
	(283899, 122, '2014-04-01 00:30:12.000000', 'temperatura', 468.0000, 'ºC'),
	(283900, 122, '2014-04-01 00:30:13.000000', 'temperatura', 307.0000, 'ºC'),
	(283901, 122, '2014-04-01 00:30:14.000000', 'temperatura', 129.0000, 'ºC'),
	(283902, 122, '2014-04-01 00:30:15.000000', 'temperatura', 928.0000, 'ºC'),
	(283903, 122, '2014-04-01 00:30:16.000000', 'temperatura', 651.0000, 'ºC'),
	(283904, 122, '2014-04-01 00:30:17.000000', 'temperatura', 471.0000, 'ºC'),
	(283905, 122, '2014-04-01 00:30:18.000000', 'temperatura', 403.0000, 'ºC'),
	(283906, 122, '2014-04-01 00:30:19.000000', 'temperatura', 601.0000, 'ºC'),
	(283907, 122, '2014-04-01 00:30:20.000000', 'temperatura', 598.0000, 'ºC'),
	(283908, 122, '2014-04-01 00:30:21.000000', 'temperatura', 1188.0000, 'ºC'),
	(283909, 122, '2014-04-01 00:30:22.000000', 'temperatura', 546.0000, 'ºC'),
	(283910, 122, '2014-04-01 00:30:23.000000', 'temperatura', 366.0000, 'ºC'),
	(283911, 122, '2014-04-01 00:30:24.000000', 'temperatura', 192.0000, 'ºC'),
	(283912, 122, '2014-04-01 00:30:25.000000', 'temperatura', 1063.0000, 'ºC'),
	(283913, 122, '2014-04-01 00:30:26.000000', 'temperatura', 1141.0000, 'ºC'),
	(283914, 122, '2014-04-01 00:30:27.000000', 'temperatura', 117.0000, 'ºC'),
	(283915, 122, '2014-04-01 00:30:28.000000', 'temperatura', 760.0000, 'ºC'),
	(283916, 122, '2014-04-01 00:30:29.000000', 'temperatura', 1049.0000, 'ºC'),
	(283917, 122, '2014-04-01 00:30:30.000000', 'temperatura', 565.0000, 'ºC'),
	(283918, 122, '2014-04-01 00:30:31.000000', 'temperatura', 879.0000, 'ºC'),
	(283919, 122, '2014-04-01 00:30:32.000000', 'temperatura', 300.0000, 'ºC'),
	(283920, 122, '2014-04-01 00:30:33.000000', 'temperatura', 64.0000, 'ºC'),
	(283921, 122, '2014-04-01 00:30:34.000000', 'temperatura', 621.0000, 'ºC'),
	(283922, 122, '2014-04-01 00:30:35.000000', 'temperatura', 511.0000, 'ºC'),
	(283923, 122, '2014-04-01 00:30:36.000000', 'temperatura', 696.0000, 'ºC'),
	(283924, 122, '2014-04-01 00:30:37.000000', 'temperatura', 746.0000, 'ºC'),
	(283925, 122, '2014-04-01 00:30:38.000000', 'temperatura', 442.0000, 'ºC'),
	(283926, 122, '2014-04-01 00:30:39.000000', 'temperatura', 1175.0000, 'ºC'),
	(283927, 122, '2014-04-01 00:30:40.000000', 'temperatura', 946.0000, 'ºC'),
	(283928, 122, '2014-04-01 00:30:41.000000', 'temperatura', 7.0000, 'ºC'),
	(283929, 122, '2014-04-01 00:30:42.000000', 'temperatura', 798.0000, 'ºC'),
	(283930, 122, '2014-04-01 00:30:43.000000', 'temperatura', 368.0000, 'ºC'),
	(283931, 122, '2014-04-01 00:30:44.000000', 'temperatura', 649.0000, 'ºC'),
	(283932, 122, '2014-04-01 00:30:45.000000', 'temperatura', 939.0000, 'ºC'),
	(283933, 122, '2014-04-01 00:30:46.000000', 'temperatura', 350.0000, 'ºC'),
	(283934, 122, '2014-04-01 00:30:47.000000', 'temperatura', 131.0000, 'ºC'),
	(283935, 122, '2014-04-01 00:30:48.000000', 'temperatura', 809.0000, 'ºC'),
	(283936, 122, '2014-04-01 00:30:49.000000', 'temperatura', 51.0000, 'ºC'),
	(283937, 122, '2014-04-01 00:30:50.000000', 'temperatura', 227.0000, 'ºC'),
	(283938, 122, '2014-04-01 00:30:51.000000', 'temperatura', 984.0000, 'ºC'),
	(283939, 122, '2014-04-01 00:30:52.000000', 'temperatura', 638.0000, 'ºC'),
	(283940, 122, '2014-04-01 00:30:53.000000', 'temperatura', 239.0000, 'ºC'),
	(283941, 122, '2014-04-01 00:30:54.000000', 'temperatura', 483.0000, 'ºC'),
	(283942, 122, '2014-04-01 00:30:55.000000', 'temperatura', 497.0000, 'ºC'),
	(283943, 122, '2014-04-01 00:30:56.000000', 'temperatura', 1036.0000, 'ºC'),
	(283944, 122, '2014-04-01 00:30:57.000000', 'temperatura', 91.0000, 'ºC'),
	(283945, 122, '2014-04-01 00:30:58.000000', 'temperatura', 946.0000, 'ºC'),
	(283946, 122, '2014-04-01 00:30:59.000000', 'temperatura', 858.0000, 'ºC'),
	(283947, 122, '2014-04-01 00:31:00.000000', 'temperatura', 253.0000, 'ºC'),
	(283948, 122, '2014-04-01 00:31:01.000000', 'temperatura', 1091.0000, 'ºC'),
	(283949, 122, '2014-04-01 00:31:02.000000', 'temperatura', 1095.0000, 'ºC'),
	(283950, 122, '2014-04-01 00:31:03.000000', 'temperatura', 1004.0000, 'ºC'),
	(283951, 122, '2014-04-01 00:31:04.000000', 'temperatura', 535.0000, 'ºC'),
	(283952, 122, '2014-04-01 00:31:05.000000', 'temperatura', 862.0000, 'ºC'),
	(283953, 122, '2014-04-01 00:31:06.000000', 'temperatura', 307.0000, 'ºC'),
	(283954, 122, '2014-04-01 00:31:07.000000', 'temperatura', 151.0000, 'ºC'),
	(283955, 122, '2014-04-01 00:31:08.000000', 'temperatura', 1033.0000, 'ºC'),
	(283956, 122, '2014-04-01 00:31:09.000000', 'temperatura', 1111.0000, 'ºC'),
	(283957, 122, '2014-04-01 00:31:10.000000', 'temperatura', 58.0000, 'ºC'),
	(283958, 122, '2014-04-01 00:31:11.000000', 'temperatura', 557.0000, 'ºC'),
	(283959, 122, '2014-04-01 00:31:12.000000', 'temperatura', 210.0000, 'ºC'),
	(283960, 122, '2014-04-01 00:31:13.000000', 'temperatura', 580.0000, 'ºC'),
	(283961, 122, '2014-04-01 00:31:14.000000', 'temperatura', 1071.0000, 'ºC'),
	(283962, 122, '2014-04-01 00:31:15.000000', 'temperatura', 14.0000, 'ºC'),
	(283963, 122, '2014-04-01 00:31:16.000000', 'temperatura', 458.0000, 'ºC'),
	(283964, 122, '2014-04-01 00:31:17.000000', 'temperatura', 1048.0000, 'ºC'),
	(283965, 122, '2014-04-01 00:31:18.000000', 'temperatura', 268.0000, 'ºC'),
	(283966, 122, '2014-04-01 00:31:19.000000', 'temperatura', 594.0000, 'ºC'),
	(283967, 122, '2014-04-01 00:31:20.000000', 'temperatura', 968.0000, 'ºC'),
	(283968, 122, '2014-04-01 00:31:21.000000', 'temperatura', 658.0000, 'ºC'),
	(283969, 122, '2014-04-01 00:31:22.000000', 'temperatura', 387.0000, 'ºC'),
	(283970, 122, '2014-04-01 00:31:23.000000', 'temperatura', 1163.0000, 'ºC'),
	(283971, 122, '2014-04-01 00:31:24.000000', 'temperatura', 1054.0000, 'ºC'),
	(283972, 122, '2014-04-01 00:31:25.000000', 'temperatura', 583.0000, 'ºC'),
	(283973, 122, '2014-04-01 00:31:26.000000', 'temperatura', 950.0000, 'ºC'),
	(283974, 122, '2014-04-01 00:31:27.000000', 'temperatura', 605.0000, 'ºC'),
	(283975, 122, '2014-04-01 00:31:28.000000', 'temperatura', 175.0000, 'ºC'),
	(283976, 122, '2014-04-01 00:31:29.000000', 'temperatura', 258.0000, 'ºC'),
	(283977, 122, '2014-04-01 00:31:30.000000', 'temperatura', 769.0000, 'ºC'),
	(283978, 122, '2014-04-01 00:31:31.000000', 'temperatura', 669.0000, 'ºC'),
	(283979, 122, '2014-04-01 00:31:32.000000', 'temperatura', 1039.0000, 'ºC'),
	(283980, 122, '2014-04-01 00:31:33.000000', 'temperatura', 788.0000, 'ºC'),
	(283981, 122, '2014-04-01 00:31:34.000000', 'temperatura', 825.0000, 'ºC'),
	(283982, 122, '2014-04-01 00:31:35.000000', 'temperatura', 560.0000, 'ºC'),
	(283983, 122, '2014-04-01 00:31:36.000000', 'temperatura', 325.0000, 'ºC'),
	(283984, 122, '2014-04-01 00:31:37.000000', 'temperatura', 1148.0000, 'ºC'),
	(283985, 122, '2014-04-01 00:31:38.000000', 'temperatura', 1165.0000, 'ºC'),
	(283986, 122, '2014-04-01 00:31:39.000000', 'temperatura', 1182.0000, 'ºC'),
	(283987, 122, '2014-04-01 00:31:40.000000', 'temperatura', 16.0000, 'ºC'),
	(283988, 122, '2014-04-01 00:31:41.000000', 'temperatura', 136.0000, 'ºC'),
	(283989, 122, '2014-04-01 00:31:42.000000', 'temperatura', 629.0000, 'ºC'),
	(283990, 122, '2014-04-01 00:31:43.000000', 'temperatura', 340.0000, 'ºC'),
	(283991, 122, '2014-04-01 00:31:44.000000', 'temperatura', 1012.0000, 'ºC'),
	(283992, 122, '2014-04-01 00:31:45.000000', 'temperatura', 442.0000, 'ºC'),
	(283993, 122, '2014-04-01 00:31:46.000000', 'temperatura', 374.0000, 'ºC'),
	(283994, 122, '2014-04-01 00:31:47.000000', 'temperatura', 545.0000, 'ºC'),
	(283995, 122, '2014-04-01 00:31:48.000000', 'temperatura', 404.0000, 'ºC'),
	(283996, 122, '2014-04-01 00:31:49.000000', 'temperatura', 384.0000, 'ºC'),
	(283997, 122, '2014-04-01 00:31:50.000000', 'temperatura', 709.0000, 'ºC'),
	(283998, 122, '2014-04-01 00:31:51.000000', 'temperatura', 1193.0000, 'ºC'),
	(283999, 122, '2014-04-01 00:31:52.000000', 'temperatura', 240.0000, 'ºC'),
	(284000, 122, '2014-04-01 00:31:53.000000', 'temperatura', 20.0000, 'ºC'),
	(284001, 122, '2014-04-01 00:31:54.000000', 'temperatura', 579.0000, 'ºC'),
	(284002, 122, '2014-04-01 00:31:55.000000', 'temperatura', 437.0000, 'ºC'),
	(284003, 122, '2014-04-01 00:31:56.000000', 'temperatura', 448.0000, 'ºC'),
	(284004, 122, '2014-04-01 00:31:57.000000', 'temperatura', 931.0000, 'ºC'),
	(284005, 122, '2014-04-01 00:31:58.000000', 'temperatura', 912.0000, 'ºC'),
	(284006, 122, '2014-04-01 00:31:59.000000', 'temperatura', 568.0000, 'ºC'),
	(284007, 122, '2014-04-01 00:32:00.000000', 'temperatura', 103.0000, 'ºC'),
	(284008, 122, '2014-04-01 00:32:01.000000', 'temperatura', 10.0000, 'ºC'),
	(284009, 122, '2014-04-01 00:32:02.000000', 'temperatura', 944.0000, 'ºC'),
	(284010, 122, '2014-04-01 00:32:03.000000', 'temperatura', 1091.0000, 'ºC'),
	(284011, 122, '2014-04-01 00:32:04.000000', 'temperatura', 221.0000, 'ºC'),
	(284012, 122, '2014-04-01 00:32:05.000000', 'temperatura', 233.0000, 'ºC'),
	(284013, 122, '2014-04-01 00:32:06.000000', 'temperatura', 503.0000, 'ºC'),
	(284014, 122, '2014-04-01 00:32:07.000000', 'temperatura', 617.0000, 'ºC'),
	(284015, 122, '2014-04-01 00:32:08.000000', 'temperatura', 375.0000, 'ºC'),
	(284016, 122, '2014-04-01 00:32:09.000000', 'temperatura', 24.0000, 'ºC'),
	(284017, 122, '2014-04-01 00:32:10.000000', 'temperatura', 196.0000, 'ºC'),
	(284018, 122, '2014-04-01 00:32:11.000000', 'temperatura', 909.0000, 'ºC'),
	(284019, 122, '2014-04-01 00:32:12.000000', 'temperatura', 359.0000, 'ºC'),
	(284020, 122, '2014-04-01 00:32:13.000000', 'temperatura', 269.0000, 'ºC'),
	(284021, 122, '2014-04-01 00:32:14.000000', 'temperatura', 265.0000, 'ºC'),
	(284022, 122, '2014-04-01 00:32:15.000000', 'temperatura', 522.0000, 'ºC'),
	(284023, 122, '2014-04-01 00:32:16.000000', 'temperatura', 613.0000, 'ºC'),
	(284024, 122, '2014-04-01 00:32:17.000000', 'temperatura', 302.0000, 'ºC'),
	(284025, 122, '2014-04-01 00:32:18.000000', 'temperatura', 870.0000, 'ºC'),
	(284026, 122, '2014-04-01 00:32:19.000000', 'temperatura', 1045.0000, 'ºC'),
	(284027, 122, '2014-04-01 00:32:20.000000', 'temperatura', 217.0000, 'ºC'),
	(284028, 122, '2014-04-01 00:32:21.000000', 'temperatura', 349.0000, 'ºC'),
	(284029, 122, '2014-04-01 00:32:22.000000', 'temperatura', 1096.0000, 'ºC'),
	(284030, 122, '2014-04-01 00:32:23.000000', 'temperatura', 833.0000, 'ºC'),
	(284031, 122, '2014-04-01 00:32:24.000000', 'temperatura', 878.0000, 'ºC'),
	(284032, 122, '2014-04-01 00:32:25.000000', 'temperatura', 690.0000, 'ºC'),
	(284033, 122, '2014-04-01 00:32:26.000000', 'temperatura', 817.0000, 'ºC'),
	(284034, 122, '2014-04-01 00:32:27.000000', 'temperatura', 815.0000, 'ºC'),
	(284035, 122, '2014-04-01 00:32:28.000000', 'temperatura', 426.0000, 'ºC'),
	(284036, 122, '2014-04-01 00:32:29.000000', 'temperatura', 883.0000, 'ºC'),
	(284037, 122, '2014-04-01 00:32:30.000000', 'temperatura', 738.0000, 'ºC'),
	(284038, 122, '2014-04-01 00:32:31.000000', 'temperatura', 1041.0000, 'ºC'),
	(284039, 122, '2014-04-01 00:32:32.000000', 'temperatura', 592.0000, 'ºC'),
	(284040, 122, '2014-04-01 00:32:33.000000', 'temperatura', 1038.0000, 'ºC'),
	(284041, 122, '2014-04-01 00:32:34.000000', 'temperatura', 1015.0000, 'ºC'),
	(284042, 122, '2014-04-01 00:32:35.000000', 'temperatura', 761.0000, 'ºC'),
	(284043, 122, '2014-04-01 00:32:36.000000', 'temperatura', 759.0000, 'ºC'),
	(284044, 122, '2014-04-01 00:32:37.000000', 'temperatura', 313.0000, 'ºC'),
	(284045, 122, '2014-04-01 00:32:38.000000', 'temperatura', 489.0000, 'ºC'),
	(284046, 122, '2014-04-01 00:32:39.000000', 'temperatura', 308.0000, 'ºC'),
	(284047, 122, '2014-04-01 00:32:40.000000', 'temperatura', 71.0000, 'ºC'),
	(284048, 122, '2014-04-01 00:32:41.000000', 'temperatura', 631.0000, 'ºC'),
	(284049, 122, '2014-04-01 00:32:42.000000', 'temperatura', 545.0000, 'ºC'),
	(284050, 122, '2014-04-01 00:32:43.000000', 'temperatura', 832.0000, 'ºC'),
	(284051, 122, '2014-04-01 00:32:44.000000', 'temperatura', 127.0000, 'ºC'),
	(284052, 122, '2014-04-01 00:32:45.000000', 'temperatura', 537.0000, 'ºC'),
	(284053, 122, '2014-04-01 00:32:46.000000', 'temperatura', 1107.0000, 'ºC'),
	(284054, 122, '2014-04-01 00:32:47.000000', 'temperatura', 324.0000, 'ºC'),
	(284055, 122, '2014-04-01 00:32:48.000000', 'temperatura', 697.0000, 'ºC'),
	(284056, 122, '2014-04-01 00:32:49.000000', 'temperatura', 115.0000, 'ºC'),
	(284057, 122, '2014-04-01 00:32:50.000000', 'temperatura', 883.0000, 'ºC'),
	(284058, 122, '2014-04-01 00:32:51.000000', 'temperatura', 470.0000, 'ºC'),
	(284059, 122, '2014-04-01 00:32:52.000000', 'temperatura', 903.0000, 'ºC'),
	(284060, 122, '2014-04-01 00:32:53.000000', 'temperatura', 705.0000, 'ºC'),
	(284061, 122, '2014-04-01 00:32:54.000000', 'temperatura', 818.0000, 'ºC'),
	(284062, 122, '2014-04-01 00:32:55.000000', 'temperatura', 776.0000, 'ºC'),
	(284063, 122, '2014-04-01 00:32:56.000000', 'temperatura', 226.0000, 'ºC'),
	(284064, 122, '2014-04-01 00:32:57.000000', 'temperatura', 1.0000, 'ºC'),
	(284065, 122, '2014-04-01 00:32:58.000000', 'temperatura', 528.0000, 'ºC'),
	(284066, 122, '2014-04-01 00:32:59.000000', 'temperatura', 236.0000, 'ºC'),
	(284067, 122, '2014-04-01 00:33:00.000000', 'temperatura', 796.0000, 'ºC'),
	(284068, 122, '2014-04-01 00:33:01.000000', 'temperatura', 876.0000, 'ºC'),
	(284069, 122, '2014-04-01 00:33:02.000000', 'temperatura', 790.0000, 'ºC'),
	(284070, 122, '2014-04-01 00:33:03.000000', 'temperatura', 123.0000, 'ºC'),
	(284071, 122, '2014-04-01 00:33:04.000000', 'temperatura', 644.0000, 'ºC'),
	(284072, 122, '2014-04-01 00:33:05.000000', 'temperatura', 454.0000, 'ºC'),
	(284073, 122, '2014-04-01 00:33:06.000000', 'temperatura', 336.0000, 'ºC'),
	(284074, 122, '2014-04-01 00:33:07.000000', 'temperatura', 319.0000, 'ºC'),
	(284075, 122, '2014-04-01 00:33:08.000000', 'temperatura', 588.0000, 'ºC'),
	(284076, 122, '2014-04-01 00:33:09.000000', 'temperatura', 782.0000, 'ºC'),
	(284077, 122, '2014-04-01 00:33:10.000000', 'temperatura', 949.0000, 'ºC'),
	(284078, 122, '2014-04-01 00:33:11.000000', 'temperatura', 1197.0000, 'ºC'),
	(284079, 122, '2014-04-01 00:33:12.000000', 'temperatura', 741.0000, 'ºC'),
	(284080, 122, '2014-04-01 00:33:13.000000', 'temperatura', 113.0000, 'ºC'),
	(284081, 122, '2014-04-01 00:33:14.000000', 'temperatura', 742.0000, 'ºC'),
	(284082, 122, '2014-04-01 00:33:15.000000', 'temperatura', 972.0000, 'ºC'),
	(284083, 122, '2014-04-01 00:33:16.000000', 'temperatura', 237.0000, 'ºC'),
	(284084, 122, '2014-04-01 00:33:17.000000', 'temperatura', 666.0000, 'ºC'),
	(284085, 122, '2014-04-01 00:33:18.000000', 'temperatura', 222.0000, 'ºC'),
	(284086, 122, '2014-04-01 00:33:19.000000', 'temperatura', 312.0000, 'ºC'),
	(284087, 122, '2014-04-01 00:33:20.000000', 'temperatura', 896.0000, 'ºC'),
	(284088, 122, '2014-04-01 00:33:21.000000', 'temperatura', 1141.0000, 'ºC'),
	(284089, 122, '2014-04-01 00:33:22.000000', 'temperatura', 620.0000, 'ºC'),
	(284090, 122, '2014-04-01 00:33:23.000000', 'temperatura', 876.0000, 'ºC'),
	(284091, 122, '2014-04-01 00:33:24.000000', 'temperatura', 122.0000, 'ºC'),
	(284092, 122, '2014-04-01 00:33:25.000000', 'temperatura', 384.0000, 'ºC'),
	(284093, 122, '2014-04-01 00:33:26.000000', 'temperatura', 352.0000, 'ºC'),
	(284094, 122, '2014-04-01 00:33:27.000000', 'temperatura', 610.0000, 'ºC'),
	(284095, 122, '2014-04-01 00:33:28.000000', 'temperatura', 795.0000, 'ºC'),
	(284096, 122, '2014-04-01 00:33:29.000000', 'temperatura', 947.0000, 'ºC'),
	(284097, 122, '2014-04-01 00:33:30.000000', 'temperatura', 1148.0000, 'ºC'),
	(284098, 122, '2014-04-01 00:33:31.000000', 'temperatura', 499.0000, 'ºC'),
	(284099, 122, '2014-04-01 00:33:32.000000', 'temperatura', 254.0000, 'ºC'),
	(284100, 122, '2014-04-01 00:33:33.000000', 'temperatura', 974.0000, 'ºC'),
	(284101, 122, '2014-04-01 00:33:34.000000', 'temperatura', 507.0000, 'ºC'),
	(284102, 122, '2014-04-01 00:33:35.000000', 'temperatura', 813.0000, 'ºC'),
	(284103, 122, '2014-04-01 00:33:36.000000', 'temperatura', 144.0000, 'ºC'),
	(284104, 122, '2014-04-01 00:33:37.000000', 'temperatura', 684.0000, 'ºC'),
	(284105, 122, '2014-04-01 00:33:38.000000', 'temperatura', 586.0000, 'ºC'),
	(284106, 122, '2014-04-01 00:33:39.000000', 'temperatura', 879.0000, 'ºC'),
	(284107, 122, '2014-04-01 00:33:40.000000', 'temperatura', 238.0000, 'ºC'),
	(284108, 122, '2014-04-01 00:33:41.000000', 'temperatura', 955.0000, 'ºC'),
	(284109, 122, '2014-04-01 00:33:42.000000', 'temperatura', 458.0000, 'ºC'),
	(284110, 122, '2014-04-01 00:33:43.000000', 'temperatura', 629.0000, 'ºC'),
	(284111, 122, '2014-04-01 00:33:44.000000', 'temperatura', 569.0000, 'ºC'),
	(284112, 122, '2014-04-01 00:33:45.000000', 'temperatura', 958.0000, 'ºC'),
	(284113, 122, '2014-04-01 00:33:46.000000', 'temperatura', 683.0000, 'ºC'),
	(284114, 122, '2014-04-01 00:33:47.000000', 'temperatura', 541.0000, 'ºC'),
	(284115, 122, '2014-04-01 00:33:48.000000', 'temperatura', 658.0000, 'ºC'),
	(284116, 122, '2014-04-01 00:33:49.000000', 'temperatura', 469.0000, 'ºC'),
	(284117, 122, '2014-04-01 00:33:50.000000', 'temperatura', 368.0000, 'ºC'),
	(284118, 122, '2014-04-01 00:33:51.000000', 'temperatura', 437.0000, 'ºC'),
	(284119, 122, '2014-04-01 00:33:52.000000', 'temperatura', 1081.0000, 'ºC'),
	(284120, 122, '2014-04-01 00:33:53.000000', 'temperatura', 494.0000, 'ºC'),
	(284121, 122, '2014-04-01 00:33:54.000000', 'temperatura', 426.0000, 'ºC'),
	(284122, 122, '2014-04-01 00:33:55.000000', 'temperatura', 649.0000, 'ºC'),
	(284123, 122, '2014-04-01 00:33:56.000000', 'temperatura', 767.0000, 'ºC'),
	(284124, 122, '2014-04-01 00:33:57.000000', 'temperatura', 689.0000, 'ºC'),
	(284125, 122, '2014-04-01 00:33:58.000000', 'temperatura', 1144.0000, 'ºC'),
	(284126, 122, '2014-04-01 00:33:59.000000', 'temperatura', 53.0000, 'ºC'),
	(284127, 122, '2014-04-01 00:34:00.000000', 'temperatura', 435.0000, 'ºC'),
	(284128, 122, '2014-04-01 00:34:01.000000', 'temperatura', 816.0000, 'ºC'),
	(284129, 122, '2014-04-01 00:34:02.000000', 'temperatura', 373.0000, 'ºC'),
	(284130, 122, '2014-04-01 00:34:03.000000', 'temperatura', 621.0000, 'ºC'),
	(284131, 122, '2014-04-01 00:34:04.000000', 'temperatura', 785.0000, 'ºC'),
	(284132, 122, '2014-04-01 00:34:05.000000', 'temperatura', 864.0000, 'ºC'),
	(284133, 122, '2014-04-01 00:34:06.000000', 'temperatura', 763.0000, 'ºC'),
	(284134, 122, '2014-04-01 00:34:07.000000', 'temperatura', 24.0000, 'ºC'),
	(284135, 122, '2014-04-01 00:34:08.000000', 'temperatura', 230.0000, 'ºC'),
	(284136, 122, '2014-04-01 00:34:09.000000', 'temperatura', 1080.0000, 'ºC'),
	(284137, 122, '2014-04-01 00:34:10.000000', 'temperatura', 1112.0000, 'ºC'),
	(284138, 122, '2014-04-01 00:34:11.000000', 'temperatura', 1120.0000, 'ºC'),
	(284139, 122, '2014-04-01 00:34:12.000000', 'temperatura', 1062.0000, 'ºC'),
	(284140, 122, '2014-04-01 00:34:13.000000', 'temperatura', 753.0000, 'ºC'),
	(284141, 122, '2014-04-01 00:34:14.000000', 'temperatura', 580.0000, 'ºC'),
	(284142, 122, '2014-04-01 00:34:15.000000', 'temperatura', 643.0000, 'ºC'),
	(284143, 122, '2014-04-01 00:34:16.000000', 'temperatura', 272.0000, 'ºC'),
	(284144, 122, '2014-04-01 00:34:17.000000', 'temperatura', 635.0000, 'ºC'),
	(284145, 122, '2014-04-01 00:34:18.000000', 'temperatura', 1157.0000, 'ºC'),
	(284146, 122, '2014-04-01 00:34:19.000000', 'temperatura', 280.0000, 'ºC'),
	(284147, 122, '2014-04-01 00:34:20.000000', 'temperatura', 332.0000, 'ºC'),
	(284148, 122, '2014-04-01 00:34:21.000000', 'temperatura', 821.0000, 'ºC'),
	(284149, 122, '2014-04-01 00:34:22.000000', 'temperatura', 709.0000, 'ºC'),
	(284150, 122, '2014-04-01 00:34:23.000000', 'temperatura', 1082.0000, 'ºC'),
	(284151, 122, '2014-04-01 00:34:24.000000', 'temperatura', 882.0000, 'ºC'),
	(284152, 122, '2014-04-01 00:34:25.000000', 'temperatura', 1168.0000, 'ºC'),
	(284153, 122, '2014-04-01 00:34:26.000000', 'temperatura', 791.0000, 'ºC'),
	(284154, 122, '2014-04-01 00:34:27.000000', 'temperatura', 453.0000, 'ºC'),
	(284155, 122, '2014-04-01 00:34:28.000000', 'temperatura', 1092.0000, 'ºC'),
	(284156, 122, '2014-04-01 00:34:29.000000', 'temperatura', 502.0000, 'ºC'),
	(284157, 122, '2014-04-01 00:34:30.000000', 'temperatura', 436.0000, 'ºC'),
	(284158, 122, '2014-04-01 00:34:31.000000', 'temperatura', 673.0000, 'ºC'),
	(284159, 122, '2014-04-01 00:34:32.000000', 'temperatura', 858.0000, 'ºC'),
	(284160, 122, '2014-04-01 00:34:33.000000', 'temperatura', 1071.0000, 'ºC'),
	(284161, 122, '2014-04-01 00:34:34.000000', 'temperatura', 381.0000, 'ºC'),
	(284162, 122, '2014-04-01 00:34:35.000000', 'temperatura', 1092.0000, 'ºC'),
	(284163, 122, '2014-04-01 00:34:36.000000', 'temperatura', 719.0000, 'ºC'),
	(284164, 122, '2014-04-01 00:34:37.000000', 'temperatura', 320.0000, 'ºC'),
	(284165, 122, '2014-04-01 00:34:38.000000', 'temperatura', 645.0000, 'ºC'),
	(284166, 122, '2014-04-01 00:34:39.000000', 'temperatura', 1063.0000, 'ºC'),
	(284167, 122, '2014-04-01 00:34:40.000000', 'temperatura', 983.0000, 'ºC'),
	(284168, 122, '2014-04-01 00:34:41.000000', 'temperatura', 525.0000, 'ºC'),
	(284169, 122, '2014-04-01 00:34:42.000000', 'temperatura', 875.0000, 'ºC'),
	(284170, 122, '2014-04-01 00:34:43.000000', 'temperatura', 401.0000, 'ºC'),
	(284171, 122, '2014-04-01 00:34:44.000000', 'temperatura', 581.0000, 'ºC'),
	(284172, 122, '2014-04-01 00:34:45.000000', 'temperatura', 502.0000, 'ºC'),
	(284173, 122, '2014-04-01 00:34:46.000000', 'temperatura', 767.0000, 'ºC'),
	(284174, 122, '2014-04-01 00:34:47.000000', 'temperatura', 1132.0000, 'ºC'),
	(284175, 122, '2014-04-01 00:34:48.000000', 'temperatura', 959.0000, 'ºC'),
	(284176, 122, '2014-04-01 00:34:49.000000', 'temperatura', 197.0000, 'ºC'),
	(284177, 122, '2014-04-01 00:34:50.000000', 'temperatura', 510.0000, 'ºC'),
	(284178, 122, '2014-04-01 00:34:51.000000', 'temperatura', 760.0000, 'ºC'),
	(284179, 122, '2014-04-01 00:34:52.000000', 'temperatura', 1071.0000, 'ºC'),
	(284180, 122, '2014-04-01 00:34:53.000000', 'temperatura', 675.0000, 'ºC'),
	(284181, 122, '2014-04-01 00:34:54.000000', 'temperatura', 164.0000, 'ºC'),
	(284182, 122, '2014-04-01 00:34:55.000000', 'temperatura', 1195.0000, 'ºC'),
	(284183, 122, '2014-04-01 00:34:56.000000', 'temperatura', 685.0000, 'ºC'),
	(284184, 122, '2014-04-01 00:34:57.000000', 'temperatura', 1040.0000, 'ºC'),
	(284185, 122, '2014-04-01 00:34:58.000000', 'temperatura', 744.0000, 'ºC'),
	(284186, 122, '2014-04-01 00:34:59.000000', 'temperatura', 601.0000, 'ºC'),
	(284187, 122, '2014-04-01 00:35:00.000000', 'temperatura', 773.0000, 'ºC'),
	(284188, 122, '2014-04-01 00:35:01.000000', 'temperatura', 863.0000, 'ºC'),
	(284189, 122, '2014-04-01 00:35:02.000000', 'temperatura', 797.0000, 'ºC'),
	(284190, 122, '2014-04-01 00:35:03.000000', 'temperatura', 197.0000, 'ºC'),
	(284191, 122, '2014-04-01 00:35:04.000000', 'temperatura', 994.0000, 'ºC'),
	(284192, 122, '2014-04-01 00:35:05.000000', 'temperatura', 780.0000, 'ºC'),
	(284193, 122, '2014-04-01 00:35:06.000000', 'temperatura', 917.0000, 'ºC'),
	(284194, 122, '2014-04-01 00:35:07.000000', 'temperatura', 1046.0000, 'ºC'),
	(284195, 122, '2014-04-01 00:35:08.000000', 'temperatura', 79.0000, 'ºC'),
	(284196, 122, '2014-04-01 00:35:09.000000', 'temperatura', 860.0000, 'ºC'),
	(284197, 122, '2014-04-01 00:35:10.000000', 'temperatura', 461.0000, 'ºC'),
	(284198, 122, '2014-04-01 00:35:11.000000', 'temperatura', 928.0000, 'ºC'),
	(284199, 122, '2014-04-01 00:35:12.000000', 'temperatura', 857.0000, 'ºC'),
	(284200, 122, '2014-04-01 00:35:13.000000', 'temperatura', 301.0000, 'ºC'),
	(284201, 122, '2014-04-01 00:35:14.000000', 'temperatura', 134.0000, 'ºC'),
	(284202, 122, '2014-04-01 00:35:15.000000', 'temperatura', 966.0000, 'ºC'),
	(284203, 122, '2014-04-01 00:35:16.000000', 'temperatura', 829.0000, 'ºC'),
	(284204, 122, '2014-04-01 00:35:17.000000', 'temperatura', 47.0000, 'ºC'),
	(284205, 122, '2014-04-01 00:35:18.000000', 'temperatura', 147.0000, 'ºC'),
	(284206, 122, '2014-04-01 00:35:19.000000', 'temperatura', 598.0000, 'ºC'),
	(284207, 122, '2014-04-01 00:35:20.000000', 'temperatura', 147.0000, 'ºC'),
	(284208, 122, '2014-04-01 00:35:21.000000', 'temperatura', 142.0000, 'ºC'),
	(284209, 122, '2014-04-01 00:35:22.000000', 'temperatura', 271.0000, 'ºC'),
	(284210, 122, '2014-04-01 00:35:23.000000', 'temperatura', 928.0000, 'ºC'),
	(284211, 122, '2014-04-01 00:35:24.000000', 'temperatura', 226.0000, 'ºC'),
	(284212, 122, '2014-04-01 00:35:25.000000', 'temperatura', 750.0000, 'ºC'),
	(284213, 122, '2014-04-01 00:35:26.000000', 'temperatura', 669.0000, 'ºC'),
	(284214, 122, '2014-04-01 00:35:27.000000', 'temperatura', 1096.0000, 'ºC'),
	(284215, 122, '2014-04-01 00:35:28.000000', 'temperatura', 1076.0000, 'ºC'),
	(284216, 122, '2014-04-01 00:35:29.000000', 'temperatura', 890.0000, 'ºC'),
	(284217, 122, '2014-04-01 00:35:30.000000', 'temperatura', 24.0000, 'ºC'),
	(284218, 122, '2014-04-01 00:35:31.000000', 'temperatura', 1050.0000, 'ºC'),
	(284219, 122, '2014-04-01 00:35:32.000000', 'temperatura', 380.0000, 'ºC'),
	(284220, 122, '2014-04-01 00:35:33.000000', 'temperatura', 1149.0000, 'ºC'),
	(284221, 122, '2014-04-01 00:35:34.000000', 'temperatura', 1008.0000, 'ºC'),
	(284222, 122, '2014-04-01 00:35:35.000000', 'temperatura', 391.0000, 'ºC'),
	(284223, 122, '2014-04-01 00:35:36.000000', 'temperatura', 133.0000, 'ºC'),
	(284224, 122, '2014-04-01 00:35:37.000000', 'temperatura', 693.0000, 'ºC'),
	(284225, 122, '2014-04-01 00:35:38.000000', 'temperatura', 664.0000, 'ºC'),
	(284226, 122, '2014-04-01 00:35:39.000000', 'temperatura', 42.0000, 'ºC'),
	(284227, 122, '2014-04-01 00:35:40.000000', 'temperatura', 619.0000, 'ºC'),
	(284228, 122, '2014-04-01 00:35:41.000000', 'temperatura', 569.0000, 'ºC'),
	(284229, 122, '2014-04-01 00:35:42.000000', 'temperatura', 990.0000, 'ºC'),
	(284230, 122, '2014-04-01 00:35:43.000000', 'temperatura', 841.0000, 'ºC'),
	(284231, 122, '2014-04-01 00:35:44.000000', 'temperatura', 37.0000, 'ºC'),
	(284232, 122, '2014-04-01 00:35:45.000000', 'temperatura', 63.0000, 'ºC'),
	(284233, 122, '2014-04-01 00:35:46.000000', 'temperatura', 203.0000, 'ºC'),
	(284234, 122, '2014-04-01 00:35:47.000000', 'temperatura', 826.0000, 'ºC'),
	(284235, 122, '2014-04-01 00:35:48.000000', 'temperatura', 1124.0000, 'ºC'),
	(284236, 122, '2014-04-01 00:35:49.000000', 'temperatura', 742.0000, 'ºC'),
	(284237, 122, '2014-04-01 00:35:50.000000', 'temperatura', 337.0000, 'ºC'),
	(284238, 122, '2014-04-01 00:35:51.000000', 'temperatura', 659.0000, 'ºC'),
	(284239, 122, '2014-04-01 00:35:52.000000', 'temperatura', 1087.0000, 'ºC'),
	(284240, 122, '2014-04-01 00:35:53.000000', 'temperatura', 1057.0000, 'ºC'),
	(284241, 122, '2014-04-01 00:35:54.000000', 'temperatura', 824.0000, 'ºC'),
	(284242, 122, '2014-04-01 00:35:55.000000', 'temperatura', 950.0000, 'ºC'),
	(284243, 122, '2014-04-01 00:35:56.000000', 'temperatura', 1078.0000, 'ºC'),
	(284244, 122, '2014-04-01 00:35:57.000000', 'temperatura', 141.0000, 'ºC'),
	(284245, 122, '2014-04-01 00:35:58.000000', 'temperatura', 1071.0000, 'ºC'),
	(284246, 122, '2014-04-01 00:35:59.000000', 'temperatura', 134.0000, 'ºC'),
	(284247, 122, '2014-04-01 00:36:00.000000', 'temperatura', 1057.0000, 'ºC'),
	(284248, 122, '2014-04-01 00:36:01.000000', 'temperatura', 83.0000, 'ºC'),
	(284249, 122, '2014-04-01 00:36:02.000000', 'temperatura', 847.0000, 'ºC'),
	(284250, 122, '2014-04-01 00:36:03.000000', 'temperatura', 384.0000, 'ºC'),
	(284251, 122, '2014-04-01 00:36:04.000000', 'temperatura', 579.0000, 'ºC'),
	(284252, 122, '2014-04-01 00:36:05.000000', 'temperatura', 546.0000, 'ºC'),
	(284253, 122, '2014-04-01 00:36:06.000000', 'temperatura', 991.0000, 'ºC'),
	(284254, 122, '2014-04-01 00:36:07.000000', 'temperatura', 919.0000, 'ºC'),
	(284255, 122, '2014-04-01 00:36:08.000000', 'temperatura', 422.0000, 'ºC'),
	(284256, 122, '2014-04-01 00:36:09.000000', 'temperatura', 552.0000, 'ºC'),
	(284257, 122, '2014-04-01 00:36:10.000000', 'temperatura', 294.0000, 'ºC'),
	(284258, 122, '2014-04-01 00:36:11.000000', 'temperatura', 1014.0000, 'ºC'),
	(284259, 122, '2014-04-01 00:36:12.000000', 'temperatura', 591.0000, 'ºC'),
	(284260, 122, '2014-04-01 00:36:13.000000', 'temperatura', 1112.0000, 'ºC'),
	(284261, 122, '2014-04-01 00:36:14.000000', 'temperatura', 187.0000, 'ºC'),
	(284262, 122, '2014-04-01 00:36:15.000000', 'temperatura', 1.0000, 'ºC'),
	(284263, 122, '2014-04-01 00:36:16.000000', 'temperatura', 645.0000, 'ºC'),
	(284264, 122, '2014-04-01 00:36:17.000000', 'temperatura', 822.0000, 'ºC'),
	(284265, 122, '2014-04-01 00:36:18.000000', 'temperatura', 975.0000, 'ºC'),
	(284266, 122, '2014-04-01 00:36:19.000000', 'temperatura', 8.0000, 'ºC'),
	(284267, 122, '2014-04-01 00:36:20.000000', 'temperatura', 717.0000, 'ºC'),
	(284268, 122, '2014-04-01 00:36:21.000000', 'temperatura', 1161.0000, 'ºC'),
	(284269, 122, '2014-04-01 00:36:22.000000', 'temperatura', 56.0000, 'ºC'),
	(284270, 122, '2014-04-01 00:36:23.000000', 'temperatura', 395.0000, 'ºC'),
	(284271, 122, '2014-04-01 00:36:24.000000', 'temperatura', 610.0000, 'ºC'),
	(284272, 122, '2014-04-01 00:36:25.000000', 'temperatura', 665.0000, 'ºC'),
	(284273, 122, '2014-04-01 00:36:26.000000', 'temperatura', 293.0000, 'ºC'),
	(284274, 122, '2014-04-01 00:36:27.000000', 'temperatura', 673.0000, 'ºC'),
	(284275, 122, '2014-04-01 00:36:28.000000', 'temperatura', 86.0000, 'ºC'),
	(284276, 122, '2014-04-01 00:36:29.000000', 'temperatura', 812.0000, 'ºC'),
	(284277, 122, '2014-04-01 00:36:30.000000', 'temperatura', 203.0000, 'ºC'),
	(284278, 122, '2014-04-01 00:36:31.000000', 'temperatura', 978.0000, 'ºC'),
	(284279, 122, '2014-04-01 00:36:32.000000', 'temperatura', 683.0000, 'ºC'),
	(284280, 122, '2014-04-01 00:36:33.000000', 'temperatura', 479.0000, 'ºC'),
	(284281, 122, '2014-04-01 00:36:34.000000', 'temperatura', 349.0000, 'ºC'),
	(284282, 122, '2014-04-01 00:36:35.000000', 'temperatura', 309.0000, 'ºC'),
	(284283, 122, '2014-04-01 00:36:36.000000', 'temperatura', 495.0000, 'ºC'),
	(284284, 122, '2014-04-01 00:36:37.000000', 'temperatura', 352.0000, 'ºC'),
	(284285, 122, '2014-04-01 00:36:38.000000', 'temperatura', 276.0000, 'ºC'),
	(284286, 122, '2014-04-01 00:36:39.000000', 'temperatura', 324.0000, 'ºC'),
	(284287, 122, '2014-04-01 00:36:40.000000', 'temperatura', 792.0000, 'ºC'),
	(284288, 122, '2014-04-01 00:36:41.000000', 'temperatura', 589.0000, 'ºC'),
	(284289, 122, '2014-04-01 00:36:42.000000', 'temperatura', 570.0000, 'ºC'),
	(284290, 122, '2014-04-01 00:36:43.000000', 'temperatura', 1085.0000, 'ºC'),
	(284291, 122, '2014-04-01 00:36:44.000000', 'temperatura', 113.0000, 'ºC'),
	(284292, 122, '2014-04-01 00:36:45.000000', 'temperatura', 911.0000, 'ºC'),
	(284293, 122, '2014-04-01 00:36:46.000000', 'temperatura', 618.0000, 'ºC'),
	(284294, 122, '2014-04-01 00:36:47.000000', 'temperatura', 354.0000, 'ºC'),
	(284295, 122, '2014-04-01 00:36:48.000000', 'temperatura', 1120.0000, 'ºC'),
	(284296, 122, '2014-04-01 00:36:49.000000', 'temperatura', 938.0000, 'ºC'),
	(284297, 122, '2014-04-01 00:36:50.000000', 'temperatura', 132.0000, 'ºC'),
	(284298, 122, '2014-04-01 00:36:51.000000', 'temperatura', 244.0000, 'ºC'),
	(284299, 122, '2014-04-01 00:36:52.000000', 'temperatura', 824.0000, 'ºC'),
	(284300, 122, '2014-04-01 00:36:53.000000', 'temperatura', 990.0000, 'ºC'),
	(284301, 122, '2014-04-01 00:36:54.000000', 'temperatura', 78.0000, 'ºC'),
	(284302, 122, '2014-04-01 00:36:55.000000', 'temperatura', 1020.0000, 'ºC'),
	(284303, 122, '2014-04-01 00:36:56.000000', 'temperatura', 66.0000, 'ºC'),
	(284304, 122, '2014-04-01 00:36:57.000000', 'temperatura', 870.0000, 'ºC'),
	(284305, 122, '2014-04-01 00:36:58.000000', 'temperatura', 552.0000, 'ºC'),
	(284306, 122, '2014-04-01 00:36:59.000000', 'temperatura', 150.0000, 'ºC'),
	(284307, 122, '2014-04-01 00:37:00.000000', 'temperatura', 296.0000, 'ºC'),
	(284308, 122, '2014-04-01 00:37:01.000000', 'temperatura', 1029.0000, 'ºC'),
	(284309, 122, '2014-04-01 00:37:02.000000', 'temperatura', 658.0000, 'ºC'),
	(284310, 122, '2014-04-01 00:37:03.000000', 'temperatura', 203.0000, 'ºC'),
	(284311, 122, '2014-04-01 00:37:04.000000', 'temperatura', 240.0000, 'ºC'),
	(284312, 122, '2014-04-01 00:37:05.000000', 'temperatura', 594.0000, 'ºC'),
	(284313, 122, '2014-04-01 00:37:06.000000', 'temperatura', 1048.0000, 'ºC'),
	(284314, 122, '2014-04-01 00:37:07.000000', 'temperatura', 1059.0000, 'ºC'),
	(284315, 122, '2014-04-01 00:37:08.000000', 'temperatura', 953.0000, 'ºC'),
	(284316, 122, '2014-04-01 00:37:09.000000', 'temperatura', 389.0000, 'ºC'),
	(284317, 122, '2014-04-01 00:37:10.000000', 'temperatura', 287.0000, 'ºC'),
	(284318, 122, '2014-04-01 00:37:11.000000', 'temperatura', 268.0000, 'ºC'),
	(284319, 122, '2014-04-01 00:37:12.000000', 'temperatura', 479.0000, 'ºC'),
	(284320, 122, '2014-04-01 00:37:13.000000', 'temperatura', 393.0000, 'ºC'),
	(284321, 122, '2014-04-01 00:37:14.000000', 'temperatura', 529.0000, 'ºC'),
	(284322, 122, '2014-04-01 00:37:15.000000', 'temperatura', 267.0000, 'ºC'),
	(284323, 122, '2014-04-01 00:37:16.000000', 'temperatura', 945.0000, 'ºC'),
	(284324, 122, '2014-04-01 00:37:17.000000', 'temperatura', 328.0000, 'ºC'),
	(284325, 122, '2014-04-01 00:37:18.000000', 'temperatura', 5.0000, 'ºC'),
	(284326, 122, '2014-04-01 00:37:19.000000', 'temperatura', 241.0000, 'ºC'),
	(284327, 122, '2014-04-01 00:37:20.000000', 'temperatura', 1190.0000, 'ºC'),
	(284328, 122, '2014-04-01 00:37:21.000000', 'temperatura', 427.0000, 'ºC'),
	(284329, 122, '2014-04-01 00:37:22.000000', 'temperatura', 966.0000, 'ºC'),
	(284330, 122, '2014-04-01 00:37:23.000000', 'temperatura', 1151.0000, 'ºC'),
	(284331, 122, '2014-04-01 00:37:24.000000', 'temperatura', 455.0000, 'ºC'),
	(284332, 122, '2014-04-01 00:37:25.000000', 'temperatura', 25.0000, 'ºC'),
	(284333, 122, '2014-04-01 00:37:26.000000', 'temperatura', 1160.0000, 'ºC'),
	(284334, 122, '2014-04-01 00:37:27.000000', 'temperatura', 924.0000, 'ºC'),
	(284335, 122, '2014-04-01 00:37:28.000000', 'temperatura', 1141.0000, 'ºC'),
	(284336, 122, '2014-04-01 00:37:29.000000', 'temperatura', 532.0000, 'ºC'),
	(284337, 122, '2014-04-01 00:37:30.000000', 'temperatura', 438.0000, 'ºC'),
	(284338, 122, '2014-04-01 00:37:31.000000', 'temperatura', 594.0000, 'ºC'),
	(284339, 122, '2014-04-01 00:37:32.000000', 'temperatura', 459.0000, 'ºC'),
	(284340, 122, '2014-04-01 00:37:33.000000', 'temperatura', 512.0000, 'ºC'),
	(284341, 122, '2014-04-01 00:37:34.000000', 'temperatura', 1182.0000, 'ºC'),
	(284342, 122, '2014-04-01 00:37:35.000000', 'temperatura', 774.0000, 'ºC'),
	(284343, 122, '2014-04-01 00:37:36.000000', 'temperatura', 325.0000, 'ºC'),
	(284344, 122, '2014-04-01 00:37:37.000000', 'temperatura', 503.0000, 'ºC'),
	(284345, 122, '2014-04-01 00:37:38.000000', 'temperatura', 342.0000, 'ºC'),
	(284346, 122, '2014-04-01 00:37:39.000000', 'temperatura', 203.0000, 'ºC'),
	(284347, 122, '2014-04-01 00:37:40.000000', 'temperatura', 1187.0000, 'ºC'),
	(284348, 122, '2014-04-01 00:37:41.000000', 'temperatura', 527.0000, 'ºC'),
	(284349, 122, '2014-04-01 00:37:42.000000', 'temperatura', 276.0000, 'ºC'),
	(284350, 122, '2014-04-01 00:37:43.000000', 'temperatura', 1000.0000, 'ºC'),
	(284351, 122, '2014-04-01 00:37:44.000000', 'temperatura', 571.0000, 'ºC'),
	(284352, 122, '2014-04-01 00:37:45.000000', 'temperatura', 1057.0000, 'ºC'),
	(284353, 122, '2014-04-01 00:37:46.000000', 'temperatura', 1173.0000, 'ºC'),
	(284354, 122, '2014-04-01 00:37:47.000000', 'temperatura', 293.0000, 'ºC'),
	(284355, 122, '2014-04-01 00:37:48.000000', 'temperatura', 346.0000, 'ºC'),
	(284356, 122, '2014-04-01 00:37:49.000000', 'temperatura', 851.0000, 'ºC'),
	(284357, 122, '2014-04-01 00:37:50.000000', 'temperatura', 820.0000, 'ºC'),
	(284358, 122, '2014-04-01 00:37:51.000000', 'temperatura', 346.0000, 'ºC'),
	(284359, 122, '2014-04-01 00:37:52.000000', 'temperatura', 470.0000, 'ºC'),
	(284360, 122, '2014-04-01 00:37:53.000000', 'temperatura', 115.0000, 'ºC'),
	(284361, 122, '2014-04-01 00:37:54.000000', 'temperatura', 365.0000, 'ºC'),
	(284362, 122, '2014-04-01 00:37:55.000000', 'temperatura', 279.0000, 'ºC'),
	(284363, 122, '2014-04-01 00:37:56.000000', 'temperatura', 299.0000, 'ºC'),
	(284364, 122, '2014-04-01 00:37:57.000000', 'temperatura', 661.0000, 'ºC'),
	(284365, 122, '2014-04-01 00:37:58.000000', 'temperatura', 9.0000, 'ºC'),
	(284366, 122, '2014-04-01 00:37:59.000000', 'temperatura', 461.0000, 'ºC'),
	(284367, 122, '2014-04-01 00:38:00.000000', 'temperatura', 1079.0000, 'ºC'),
	(284368, 122, '2014-04-01 00:38:01.000000', 'temperatura', 411.0000, 'ºC'),
	(284369, 122, '2014-04-01 00:38:02.000000', 'temperatura', 21.0000, 'ºC'),
	(284370, 122, '2014-04-01 00:38:03.000000', 'temperatura', 72.0000, 'ºC'),
	(284371, 122, '2014-04-01 00:38:04.000000', 'temperatura', 298.0000, 'ºC'),
	(284372, 122, '2014-04-01 00:38:05.000000', 'temperatura', 73.0000, 'ºC'),
	(284373, 122, '2014-04-01 00:38:06.000000', 'temperatura', 673.0000, 'ºC'),
	(284374, 122, '2014-04-01 00:38:07.000000', 'temperatura', 745.0000, 'ºC'),
	(284375, 122, '2014-04-01 00:38:08.000000', 'temperatura', 508.0000, 'ºC'),
	(284376, 122, '2014-04-01 00:38:09.000000', 'temperatura', 306.0000, 'ºC'),
	(284377, 122, '2014-04-01 00:38:10.000000', 'temperatura', 4.0000, 'ºC'),
	(284378, 122, '2014-04-01 00:38:11.000000', 'temperatura', 302.0000, 'ºC'),
	(284379, 122, '2014-04-01 00:38:12.000000', 'temperatura', 301.0000, 'ºC'),
	(284380, 122, '2014-04-01 00:38:13.000000', 'temperatura', 597.0000, 'ºC'),
	(284381, 122, '2014-04-01 00:38:14.000000', 'temperatura', 884.0000, 'ºC'),
	(284382, 122, '2014-04-01 00:38:15.000000', 'temperatura', 228.0000, 'ºC'),
	(284383, 122, '2014-04-01 00:38:16.000000', 'temperatura', 888.0000, 'ºC'),
	(284384, 122, '2014-04-01 00:38:17.000000', 'temperatura', 158.0000, 'ºC'),
	(284385, 122, '2014-04-01 00:38:18.000000', 'temperatura', 526.0000, 'ºC'),
	(284386, 122, '2014-04-01 00:38:19.000000', 'temperatura', 959.0000, 'ºC'),
	(284387, 122, '2014-04-01 00:38:20.000000', 'temperatura', 814.0000, 'ºC'),
	(284388, 122, '2014-04-01 00:38:21.000000', 'temperatura', 1195.0000, 'ºC'),
	(284389, 122, '2014-04-01 00:38:22.000000', 'temperatura', 1133.0000, 'ºC'),
	(284390, 122, '2014-04-01 00:38:23.000000', 'temperatura', 881.0000, 'ºC'),
	(284391, 122, '2014-04-01 00:38:24.000000', 'temperatura', 1005.0000, 'ºC'),
	(284392, 122, '2014-04-01 00:38:25.000000', 'temperatura', 1185.0000, 'ºC'),
	(284393, 122, '2014-04-01 00:38:26.000000', 'temperatura', 511.0000, 'ºC'),
	(284394, 122, '2014-04-01 00:38:27.000000', 'temperatura', 199.0000, 'ºC'),
	(284395, 122, '2014-04-01 00:38:28.000000', 'temperatura', 663.0000, 'ºC'),
	(284396, 122, '2014-04-01 00:38:29.000000', 'temperatura', 317.0000, 'ºC'),
	(284397, 122, '2014-04-01 00:38:30.000000', 'temperatura', 797.0000, 'ºC'),
	(284398, 122, '2014-04-01 00:38:31.000000', 'temperatura', 633.0000, 'ºC'),
	(284399, 122, '2014-04-01 00:38:32.000000', 'temperatura', 777.0000, 'ºC'),
	(284400, 122, '2014-04-01 00:38:33.000000', 'temperatura', 784.0000, 'ºC'),
	(284401, 122, '2014-04-01 00:38:34.000000', 'temperatura', 390.0000, 'ºC'),
	(284402, 122, '2014-04-01 00:38:35.000000', 'temperatura', 799.0000, 'ºC'),
	(284403, 122, '2014-04-01 00:38:36.000000', 'temperatura', 426.0000, 'ºC'),
	(284404, 122, '2014-04-01 00:38:37.000000', 'temperatura', 933.0000, 'ºC'),
	(284405, 122, '2014-04-01 00:38:38.000000', 'temperatura', 986.0000, 'ºC'),
	(284406, 122, '2014-04-01 00:38:39.000000', 'temperatura', 933.0000, 'ºC'),
	(284407, 122, '2014-04-01 00:38:40.000000', 'temperatura', 505.0000, 'ºC'),
	(284408, 122, '2014-04-01 00:38:41.000000', 'temperatura', 929.0000, 'ºC'),
	(284409, 122, '2014-04-01 00:38:42.000000', 'temperatura', 732.0000, 'ºC'),
	(284410, 122, '2014-04-01 00:38:43.000000', 'temperatura', 870.0000, 'ºC'),
	(284411, 122, '2014-04-01 00:38:44.000000', 'temperatura', 957.0000, 'ºC'),
	(284412, 122, '2014-04-01 00:38:45.000000', 'temperatura', 974.0000, 'ºC'),
	(284413, 122, '2014-04-01 00:38:46.000000', 'temperatura', 799.0000, 'ºC'),
	(284414, 122, '2014-04-01 00:38:47.000000', 'temperatura', 1073.0000, 'ºC'),
	(284415, 122, '2014-04-01 00:38:48.000000', 'temperatura', 569.0000, 'ºC'),
	(284416, 122, '2014-04-01 00:38:49.000000', 'temperatura', 826.0000, 'ºC'),
	(284417, 122, '2014-04-01 00:38:50.000000', 'temperatura', 25.0000, 'ºC'),
	(284418, 122, '2014-04-01 00:38:51.000000', 'temperatura', 48.0000, 'ºC'),
	(284419, 122, '2014-04-01 00:38:52.000000', 'temperatura', 165.0000, 'ºC'),
	(284420, 122, '2014-04-01 00:38:53.000000', 'temperatura', 683.0000, 'ºC'),
	(284421, 122, '2014-04-01 00:38:54.000000', 'temperatura', 519.0000, 'ºC'),
	(284422, 122, '2014-04-01 00:38:55.000000', 'temperatura', 545.0000, 'ºC'),
	(284423, 122, '2014-04-01 00:38:56.000000', 'temperatura', 1171.0000, 'ºC'),
	(284424, 122, '2014-04-01 00:38:57.000000', 'temperatura', 622.0000, 'ºC'),
	(284425, 122, '2014-04-01 00:38:58.000000', 'temperatura', 794.0000, 'ºC'),
	(284426, 122, '2014-04-01 00:38:59.000000', 'temperatura', 905.0000, 'ºC'),
	(284427, 122, '2014-04-01 00:39:00.000000', 'temperatura', 946.0000, 'ºC'),
	(284428, 122, '2014-04-01 00:39:01.000000', 'temperatura', 813.0000, 'ºC'),
	(284429, 122, '2014-04-01 00:39:02.000000', 'temperatura', 29.0000, 'ºC'),
	(284430, 122, '2014-04-01 00:39:03.000000', 'temperatura', 105.0000, 'ºC'),
	(284431, 122, '2014-04-01 00:39:04.000000', 'temperatura', 441.0000, 'ºC'),
	(284432, 122, '2014-04-01 00:39:05.000000', 'temperatura', 687.0000, 'ºC'),
	(284433, 122, '2014-04-01 00:39:06.000000', 'temperatura', 916.0000, 'ºC'),
	(284434, 122, '2014-04-01 00:39:07.000000', 'temperatura', 117.0000, 'ºC'),
	(284435, 122, '2014-04-01 00:39:08.000000', 'temperatura', 240.0000, 'ºC'),
	(284436, 122, '2014-04-01 00:39:09.000000', 'temperatura', 848.0000, 'ºC'),
	(284437, 122, '2014-04-01 00:39:10.000000', 'temperatura', 1122.0000, 'ºC'),
	(284438, 122, '2014-04-01 00:39:11.000000', 'temperatura', 667.0000, 'ºC'),
	(284439, 122, '2014-04-01 00:39:12.000000', 'temperatura', 1171.0000, 'ºC'),
	(284440, 122, '2014-04-01 00:39:13.000000', 'temperatura', 251.0000, 'ºC'),
	(284441, 122, '2014-04-01 00:39:14.000000', 'temperatura', 145.0000, 'ºC'),
	(284442, 122, '2014-04-01 00:39:15.000000', 'temperatura', 1172.0000, 'ºC'),
	(284443, 122, '2014-04-01 00:39:16.000000', 'temperatura', 625.0000, 'ºC'),
	(284444, 122, '2014-04-01 00:39:17.000000', 'temperatura', 809.0000, 'ºC'),
	(284445, 122, '2014-04-01 00:39:18.000000', 'temperatura', 969.0000, 'ºC'),
	(284446, 122, '2014-04-01 00:39:19.000000', 'temperatura', 21.0000, 'ºC'),
	(284447, 122, '2014-04-01 00:39:20.000000', 'temperatura', 797.0000, 'ºC'),
	(284448, 122, '2014-04-01 00:39:21.000000', 'temperatura', 323.0000, 'ºC'),
	(284449, 122, '2014-04-01 00:39:22.000000', 'temperatura', 423.0000, 'ºC'),
	(284450, 122, '2014-04-01 00:39:23.000000', 'temperatura', 1147.0000, 'ºC'),
	(284451, 122, '2014-04-01 00:39:24.000000', 'temperatura', 868.0000, 'ºC'),
	(284452, 122, '2014-04-01 00:39:25.000000', 'temperatura', 898.0000, 'ºC'),
	(284453, 122, '2014-04-01 00:39:26.000000', 'temperatura', 688.0000, 'ºC'),
	(284454, 122, '2014-04-01 00:39:27.000000', 'temperatura', 747.0000, 'ºC'),
	(284455, 122, '2014-04-01 00:39:28.000000', 'temperatura', 469.0000, 'ºC'),
	(284456, 122, '2014-04-01 00:39:29.000000', 'temperatura', 107.0000, 'ºC'),
	(284457, 122, '2014-04-01 00:39:30.000000', 'temperatura', 326.0000, 'ºC'),
	(284458, 122, '2014-04-01 00:39:31.000000', 'temperatura', 110.0000, 'ºC'),
	(284459, 122, '2014-04-01 00:39:32.000000', 'temperatura', 775.0000, 'ºC'),
	(284460, 122, '2014-04-01 00:39:33.000000', 'temperatura', 1144.0000, 'ºC'),
	(284461, 122, '2014-04-01 00:39:34.000000', 'temperatura', 996.0000, 'ºC'),
	(284462, 122, '2014-04-01 00:39:35.000000', 'temperatura', 349.0000, 'ºC'),
	(284463, 122, '2014-04-01 00:39:36.000000', 'temperatura', 1155.0000, 'ºC'),
	(284464, 122, '2014-04-01 00:39:37.000000', 'temperatura', 1130.0000, 'ºC'),
	(284465, 122, '2014-04-01 00:39:38.000000', 'temperatura', 986.0000, 'ºC'),
	(284466, 122, '2014-04-01 00:39:39.000000', 'temperatura', 342.0000, 'ºC'),
	(284467, 122, '2014-04-01 00:39:40.000000', 'temperatura', 1149.0000, 'ºC'),
	(284468, 122, '2014-04-01 00:39:41.000000', 'temperatura', 1123.0000, 'ºC'),
	(284469, 122, '2014-04-01 00:39:42.000000', 'temperatura', 966.0000, 'ºC'),
	(284470, 122, '2014-04-01 00:39:43.000000', 'temperatura', 263.0000, 'ºC'),
	(284471, 122, '2014-04-01 00:39:44.000000', 'temperatura', 818.0000, 'ºC'),
	(284472, 122, '2014-04-01 00:39:45.000000', 'temperatura', 899.0000, 'ºC'),
	(284473, 122, '2014-04-01 00:39:46.000000', 'temperatura', 844.0000, 'ºC'),
	(284474, 122, '2014-04-01 00:39:47.000000', 'temperatura', 322.0000, 'ºC'),
	(284475, 122, '2014-04-01 00:39:48.000000', 'temperatura', 280.0000, 'ºC'),
	(284476, 122, '2014-04-01 00:39:49.000000', 'temperatura', 433.0000, 'ºC'),
	(284477, 122, '2014-04-01 00:39:50.000000', 'temperatura', 125.0000, 'ºC'),
	(284478, 122, '2014-04-01 00:39:51.000000', 'temperatura', 528.0000, 'ºC'),
	(284479, 122, '2014-04-01 00:39:52.000000', 'temperatura', 1063.0000, 'ºC'),
	(284480, 122, '2014-04-01 00:39:53.000000', 'temperatura', 133.0000, 'ºC'),
	(284481, 122, '2014-04-01 00:39:54.000000', 'temperatura', 1077.0000, 'ºC'),
	(284482, 122, '2014-04-01 00:39:55.000000', 'temperatura', 188.0000, 'ºC'),
	(284483, 122, '2014-04-01 00:39:56.000000', 'temperatura', 107.0000, 'ºC'),
	(284484, 122, '2014-04-01 00:39:57.000000', 'temperatura', 1174.0000, 'ºC'),
	(284485, 122, '2014-04-01 00:39:58.000000', 'temperatura', 747.0000, 'ºC'),
	(284486, 122, '2014-04-01 00:39:59.000000', 'temperatura', 214.0000, 'ºC'),
	(284487, 122, '2014-04-01 00:40:00.000000', 'temperatura', 31.0000, 'ºC'),
	(284488, 122, '2014-04-01 00:40:01.000000', 'temperatura', 712.0000, 'ºC'),
	(284489, 122, '2014-04-01 00:40:02.000000', 'temperatura', 1069.0000, 'ºC'),
	(284490, 122, '2014-04-01 00:40:03.000000', 'temperatura', 810.0000, 'ºC'),
	(284491, 122, '2014-04-01 00:40:04.000000', 'temperatura', 841.0000, 'ºC'),
	(284492, 122, '2014-04-01 00:40:05.000000', 'temperatura', 578.0000, 'ºC'),
	(284493, 122, '2014-04-01 00:40:06.000000', 'temperatura', 367.0000, 'ºC'),
	(284494, 122, '2014-04-01 00:40:07.000000', 'temperatura', 100.0000, 'ºC'),
	(284495, 122, '2014-04-01 00:40:08.000000', 'temperatura', 600.0000, 'ºC'),
	(284496, 122, '2014-04-01 00:40:09.000000', 'temperatura', 299.0000, 'ºC'),
	(284497, 122, '2014-04-01 00:40:10.000000', 'temperatura', 898.0000, 'ºC'),
	(284498, 122, '2014-04-01 00:40:11.000000', 'temperatura', 1193.0000, 'ºC'),
	(284499, 122, '2014-04-01 00:40:12.000000', 'temperatura', 872.0000, 'ºC'),
	(284500, 122, '2014-04-01 00:40:13.000000', 'temperatura', 779.0000, 'ºC'),
	(284501, 122, '2014-04-01 00:40:14.000000', 'temperatura', 80.0000, 'ºC'),
	(284502, 122, '2014-04-01 00:40:15.000000', 'temperatura', 465.0000, 'ºC'),
	(284503, 122, '2014-04-01 00:40:16.000000', 'temperatura', 885.0000, 'ºC'),
	(284504, 122, '2014-04-01 00:40:17.000000', 'temperatura', 630.0000, 'ºC'),
	(284505, 122, '2014-04-01 00:40:18.000000', 'temperatura', 498.0000, 'ºC'),
	(284506, 122, '2014-04-01 00:40:19.000000', 'temperatura', 598.0000, 'ºC'),
	(284507, 122, '2014-04-01 00:40:20.000000', 'temperatura', 297.0000, 'ºC'),
	(284508, 122, '2014-04-01 00:40:21.000000', 'temperatura', 891.0000, 'ºC'),
	(284509, 122, '2014-04-01 00:40:22.000000', 'temperatura', 1167.0000, 'ºC'),
	(284510, 122, '2014-04-01 00:40:23.000000', 'temperatura', 761.0000, 'ºC'),
	(284511, 122, '2014-04-01 00:40:24.000000', 'temperatura', 304.0000, 'ºC'),
	(284512, 122, '2014-04-01 00:40:25.000000', 'temperatura', 438.0000, 'ºC'),
	(284513, 122, '2014-04-01 00:40:26.000000', 'temperatura', 76.0000, 'ºC'),
	(284514, 122, '2014-04-01 00:40:27.000000', 'temperatura', 270.0000, 'ºC'),
	(284515, 122, '2014-04-01 00:40:28.000000', 'temperatura', 1121.0000, 'ºC'),
	(284516, 122, '2014-04-01 00:40:29.000000', 'temperatura', 1194.0000, 'ºC'),
	(284517, 122, '2014-04-01 00:40:30.000000', 'temperatura', 210.0000, 'ºC'),
	(284518, 122, '2014-04-01 00:40:31.000000', 'temperatura', 1067.0000, 'ºC'),
	(284519, 122, '2014-04-01 00:40:32.000000', 'temperatura', 1107.0000, 'ºC'),
	(284520, 122, '2014-04-01 00:40:33.000000', 'temperatura', 1132.0000, 'ºC'),
	(284521, 122, '2014-04-01 00:40:34.000000', 'temperatura', 1140.0000, 'ºC'),
	(284522, 122, '2014-04-01 00:40:35.000000', 'temperatura', 1105.0000, 'ºC'),
	(284523, 122, '2014-04-01 00:40:36.000000', 'temperatura', 905.0000, 'ºC'),
	(284524, 122, '2014-04-01 00:40:37.000000', 'temperatura', 10.0000, 'ºC'),
	(284525, 122, '2014-04-01 00:40:38.000000', 'temperatura', 935.0000, 'ºC'),
	(284526, 122, '2014-04-01 00:40:39.000000', 'temperatura', 1047.0000, 'ºC'),
	(284527, 122, '2014-04-01 00:40:40.000000', 'temperatura', 29.0000, 'ºC'),
	(284528, 122, '2014-04-01 00:40:41.000000', 'temperatura', 604.0000, 'ºC'),
	(284529, 122, '2014-04-01 00:40:42.000000', 'temperatura', 532.0000, 'ºC'),
	(284530, 122, '2014-04-01 00:40:43.000000', 'temperatura', 851.0000, 'ºC'),
	(284531, 122, '2014-04-01 00:40:44.000000', 'temperatura', 260.0000, 'ºC'),
	(284532, 122, '2014-04-01 00:40:45.000000', 'temperatura', 1148.0000, 'ºC'),
	(284533, 122, '2014-04-01 00:40:46.000000', 'temperatura', 161.0000, 'ºC'),
	(284534, 122, '2014-04-01 00:40:47.000000', 'temperatura', 962.0000, 'ºC'),
	(284535, 122, '2014-04-01 00:40:48.000000', 'temperatura', 726.0000, 'ºC'),
	(284536, 122, '2014-04-01 00:40:49.000000', 'temperatura', 745.0000, 'ºC'),
	(284537, 122, '2014-04-01 00:40:50.000000', 'temperatura', 349.0000, 'ºC'),
	(284538, 122, '2014-04-01 00:40:51.000000', 'temperatura', 711.0000, 'ºC'),
	(284539, 122, '2014-04-01 00:40:52.000000', 'temperatura', 109.0000, 'ºC'),
	(284540, 122, '2014-04-01 00:40:53.000000', 'temperatura', 812.0000, 'ºC'),
	(284541, 122, '2014-04-01 00:40:54.000000', 'temperatura', 132.0000, 'ºC'),
	(284542, 122, '2014-04-01 00:40:55.000000', 'temperatura', 623.0000, 'ºC'),
	(284543, 122, '2014-04-01 00:40:56.000000', 'temperatura', 323.0000, 'ºC'),
	(284544, 122, '2014-04-01 00:40:57.000000', 'temperatura', 944.0000, 'ºC'),
	(284545, 122, '2014-04-01 00:40:58.000000', 'temperatura', 151.0000, 'ºC'),
	(284546, 122, '2014-04-01 00:40:59.000000', 'temperatura', 325.0000, 'ºC'),
	(284547, 122, '2014-04-01 00:41:00.000000', 'temperatura', 1171.0000, 'ºC'),
	(284548, 122, '2014-04-01 00:41:01.000000', 'temperatura', 83.0000, 'ºC'),
	(284549, 122, '2014-04-01 00:41:02.000000', 'temperatura', 502.0000, 'ºC'),
	(284550, 122, '2014-04-01 00:41:03.000000', 'temperatura', 1060.0000, 'ºC'),
	(284551, 122, '2014-04-01 00:41:04.000000', 'temperatura', 194.0000, 'ºC'),
	(284552, 122, '2014-04-01 00:41:05.000000', 'temperatura', 191.0000, 'ºC'),
	(284553, 122, '2014-04-01 00:41:06.000000', 'temperatura', 372.0000, 'ºC'),
	(284554, 122, '2014-04-01 00:41:07.000000', 'temperatura', 87.0000, 'ºC'),
	(284555, 122, '2014-04-01 00:41:08.000000', 'temperatura', 521.0000, 'ºC'),
	(284556, 122, '2014-04-01 00:41:09.000000', 'temperatura', 1144.0000, 'ºC'),
	(284557, 122, '2014-04-01 00:41:10.000000', 'temperatura', 558.0000, 'ºC'),
	(284558, 122, '2014-04-01 00:41:11.000000', 'temperatura', 559.0000, 'ºC'),
	(284559, 122, '2014-04-01 00:41:12.000000', 'temperatura', 1120.0000, 'ºC'),
	(284560, 122, '2014-04-01 00:41:13.000000', 'temperatura', 326.0000, 'ºC'),
	(284561, 122, '2014-04-01 00:41:14.000000', 'temperatura', 669.0000, 'ºC'),
	(284562, 122, '2014-04-01 00:41:15.000000', 'temperatura', 1167.0000, 'ºC'),
	(284563, 122, '2014-04-01 00:41:16.000000', 'temperatura', 227.0000, 'ºC'),
	(284564, 122, '2014-04-01 00:41:17.000000', 'temperatura', 38.0000, 'ºC'),
	(284565, 122, '2014-04-01 00:41:18.000000', 'temperatura', 707.0000, 'ºC'),
	(284566, 122, '2014-04-01 00:41:19.000000', 'temperatura', 1023.0000, 'ºC'),
	(284567, 122, '2014-04-01 00:41:20.000000', 'temperatura', 595.0000, 'ºC'),
	(284568, 122, '2014-04-01 00:41:21.000000', 'temperatura', 1106.0000, 'ºC'),
	(284569, 122, '2014-04-01 00:41:22.000000', 'temperatura', 147.0000, 'ºC'),
	(284570, 122, '2014-04-01 00:41:23.000000', 'temperatura', 1014.0000, 'ºC'),
	(284571, 122, '2014-04-01 00:41:24.000000', 'temperatura', 1032.0000, 'ºC'),
	(284572, 122, '2014-04-01 00:41:25.000000', 'temperatura', 919.0000, 'ºC'),
	(284573, 122, '2014-04-01 00:41:26.000000', 'temperatura', 301.0000, 'ºC'),
	(284574, 122, '2014-04-01 00:41:27.000000', 'temperatura', 1145.0000, 'ºC'),
	(284575, 122, '2014-04-01 00:41:28.000000', 'temperatura', 23.0000, 'ºC'),
	(284576, 122, '2014-04-01 00:41:29.000000', 'temperatura', 282.0000, 'ºC'),
	(284577, 122, '2014-04-01 00:41:30.000000', 'temperatura', 142.0000, 'ºC'),
	(284578, 122, '2014-04-01 00:41:31.000000', 'temperatura', 1063.0000, 'ºC'),
	(284579, 122, '2014-04-01 00:41:32.000000', 'temperatura', 88.0000, 'ºC'),
	(284580, 122, '2014-04-01 00:41:33.000000', 'temperatura', 855.0000, 'ºC'),
	(284581, 122, '2014-04-01 00:41:34.000000', 'temperatura', 408.0000, 'ºC'),
	(284582, 122, '2014-04-01 00:41:35.000000', 'temperatura', 677.0000, 'ºC'),
	(284583, 122, '2014-04-01 00:41:36.000000', 'temperatura', 961.0000, 'ºC'),
	(284584, 122, '2014-04-01 00:41:37.000000', 'temperatura', 374.0000, 'ºC'),
	(284585, 122, '2014-04-01 00:41:38.000000', 'temperatura', 189.0000, 'ºC'),
	(284586, 122, '2014-04-01 00:41:39.000000', 'temperatura', 1022.0000, 'ºC'),
	(284587, 122, '2014-04-01 00:41:40.000000', 'temperatura', 943.0000, 'ºC'),
	(284588, 122, '2014-04-01 00:41:41.000000', 'temperatura', 449.0000, 'ºC'),
	(284589, 122, '2014-04-01 00:41:42.000000', 'temperatura', 619.0000, 'ºC'),
	(284590, 122, '2014-04-01 00:41:43.000000', 'temperatura', 546.0000, 'ºC'),
	(284591, 122, '2014-04-01 00:41:44.000000', 'temperatura', 874.0000, 'ºC'),
	(284592, 122, '2014-04-01 00:41:45.000000', 'temperatura', 333.0000, 'ºC'),
	(284593, 122, '2014-04-01 00:41:46.000000', 'temperatura', 243.0000, 'ºC'),
	(284594, 122, '2014-04-01 00:41:47.000000', 'temperatura', 219.0000, 'ºC'),
	(284595, 122, '2014-04-01 00:41:48.000000', 'temperatura', 364.0000, 'ºC'),
	(284596, 122, '2014-04-01 00:41:49.000000', 'temperatura', 1164.0000, 'ºC'),
	(284597, 122, '2014-04-01 00:41:50.000000', 'temperatura', 1127.0000, 'ºC'),
	(284598, 122, '2014-04-01 00:41:51.000000', 'temperatura', 944.0000, 'ºC'),
	(284599, 122, '2014-04-01 00:41:52.000000', 'temperatura', 141.0000, 'ºC'),
	(284600, 122, '2014-04-01 00:41:53.000000', 'temperatura', 272.0000, 'ºC'),
	(284601, 122, '2014-04-01 00:41:54.000000', 'temperatura', 939.0000, 'ºC'),
	(284602, 122, '2014-04-01 00:41:55.000000', 'temperatura', 277.0000, 'ºC'),
	(284603, 122, '2014-04-01 00:41:56.000000', 'temperatura', 970.0000, 'ºC'),
	(284604, 122, '2014-04-01 00:41:57.000000', 'temperatura', 417.0000, 'ºC'),
	(284605, 122, '2014-04-01 00:41:58.000000', 'temperatura', 379.0000, 'ºC'),
	(284606, 122, '2014-04-01 00:41:59.000000', 'temperatura', 643.0000, 'ºC'),
	(284607, 122, '2014-04-01 00:42:00.000000', 'temperatura', 880.0000, 'ºC'),
	(284608, 122, '2014-04-01 00:42:01.000000', 'temperatura', 72.0000, 'ºC'),
	(284609, 122, '2014-04-01 00:42:02.000000', 'temperatura', 118.0000, 'ºC'),
	(284610, 122, '2014-04-01 00:42:03.000000', 'temperatura', 376.0000, 'ºC'),
	(284611, 122, '2014-04-01 00:42:04.000000', 'temperatura', 325.0000, 'ºC'),
	(284612, 122, '2014-04-01 00:42:05.000000', 'temperatura', 500.0000, 'ºC'),
	(284613, 122, '2014-04-01 00:42:06.000000', 'temperatura', 324.0000, 'ºC'),
	(284614, 122, '2014-04-01 00:42:07.000000', 'temperatura', 119.0000, 'ºC'),
	(284615, 122, '2014-04-01 00:42:08.000000', 'temperatura', 824.0000, 'ºC'),
	(284616, 122, '2014-04-01 00:42:09.000000', 'temperatura', 162.0000, 'ºC'),
	(284617, 122, '2014-04-01 00:42:10.000000', 'temperatura', 741.0000, 'ºC'),
	(284618, 122, '2014-04-01 00:42:11.000000', 'temperatura', 820.0000, 'ºC'),
	(284619, 122, '2014-04-01 00:42:12.000000', 'temperatura', 675.0000, 'ºC'),
	(284620, 122, '2014-04-01 00:42:13.000000', 'temperatura', 916.0000, 'ºC'),
	(284621, 122, '2014-04-01 00:42:14.000000', 'temperatura', 155.0000, 'ºC'),
	(284622, 122, '2014-04-01 00:42:15.000000', 'temperatura', 427.0000, 'ºC'),
	(284623, 122, '2014-04-01 00:42:16.000000', 'temperatura', 473.0000, 'ºC'),
	(284624, 122, '2014-04-01 00:42:17.000000', 'temperatura', 1085.0000, 'ºC'),
	(284625, 122, '2014-04-01 00:42:18.000000', 'temperatura', 406.0000, 'ºC'),
	(284626, 122, '2014-04-01 00:42:19.000000', 'temperatura', 1175.0000, 'ºC'),
	(284627, 122, '2014-04-01 00:42:20.000000', 'temperatura', 1059.0000, 'ºC'),
	(284628, 122, '2014-04-01 00:42:21.000000', 'temperatura', 568.0000, 'ºC'),
	(284629, 122, '2014-04-01 00:42:22.000000', 'temperatura', 863.0000, 'ºC'),
	(284630, 122, '2014-04-01 00:42:23.000000', 'temperatura', 214.0000, 'ºC'),
	(284631, 122, '2014-04-01 00:42:24.000000', 'temperatura', 883.0000, 'ºC'),
	(284632, 122, '2014-04-01 00:42:25.000000', 'temperatura', 170.0000, 'ºC'),
	(284633, 122, '2014-04-01 00:42:26.000000', 'temperatura', 601.0000, 'ºC'),
	(284634, 122, '2014-04-01 00:42:27.000000', 'temperatura', 97.0000, 'ºC'),
	(284635, 122, '2014-04-01 00:42:28.000000', 'temperatura', 1083.0000, 'ºC'),
	(284636, 122, '2014-04-01 00:42:29.000000', 'temperatura', 322.0000, 'ºC'),
	(284637, 122, '2014-04-01 00:42:30.000000', 'temperatura', 764.0000, 'ºC'),
	(284638, 122, '2014-04-01 00:42:31.000000', 'temperatura', 454.0000, 'ºC'),
	(284639, 122, '2014-04-01 00:42:32.000000', 'temperatura', 1177.0000, 'ºC'),
	(284640, 122, '2014-04-01 00:42:33.000000', 'temperatura', 923.0000, 'ºC'),
	(284641, 122, '2014-04-01 00:42:34.000000', 'temperatura', 1085.0000, 'ºC'),
	(284642, 122, '2014-04-01 00:42:35.000000', 'temperatura', 258.0000, 'ºC'),
	(284643, 122, '2014-04-01 00:42:36.000000', 'temperatura', 436.0000, 'ºC'),
	(284644, 122, '2014-04-01 00:42:37.000000', 'temperatura', 208.0000, 'ºC'),
	(284645, 122, '2014-04-01 00:42:38.000000', 'temperatura', 929.0000, 'ºC'),
	(284646, 122, '2014-04-01 00:42:39.000000', 'temperatura', 424.0000, 'ºC'),
	(284647, 122, '2014-04-01 00:42:40.000000', 'temperatura', 532.0000, 'ºC'),
	(284648, 122, '2014-04-01 00:42:41.000000', 'temperatura', 191.0000, 'ºC'),
	(284649, 122, '2014-04-01 00:42:42.000000', 'temperatura', 557.0000, 'ºC'),
	(284650, 122, '2014-04-01 00:42:43.000000', 'temperatura', 1013.0000, 'ºC'),
	(284651, 122, '2014-04-01 00:42:44.000000', 'temperatura', 993.0000, 'ºC'),
	(284652, 122, '2014-04-01 00:42:45.000000', 'temperatura', 727.0000, 'ºC'),
	(284653, 122, '2014-04-01 00:42:46.000000', 'temperatura', 655.0000, 'ºC'),
	(284654, 122, '2014-04-01 00:42:47.000000', 'temperatura', 1098.0000, 'ºC'),
	(284655, 122, '2014-04-01 00:42:48.000000', 'temperatura', 1123.0000, 'ºC'),
	(284656, 122, '2014-04-01 00:42:49.000000', 'temperatura', 1120.0000, 'ºC'),
	(284657, 122, '2014-04-01 00:42:50.000000', 'temperatura', 1034.0000, 'ºC'),
	(284658, 122, '2014-04-01 00:42:51.000000', 'temperatura', 611.0000, 'ºC'),
	(284659, 122, '2014-04-01 00:42:52.000000', 'temperatura', 1151.0000, 'ºC'),
	(284660, 122, '2014-04-01 00:42:53.000000', 'temperatura', 323.0000, 'ºC'),
	(284661, 122, '2014-04-01 00:42:54.000000', 'temperatura', 562.0000, 'ºC'),
	(284662, 122, '2014-04-01 00:42:55.000000', 'temperatura', 644.0000, 'ºC'),
	(284663, 122, '2014-04-01 00:42:56.000000', 'temperatura', 334.0000, 'ºC'),
	(284664, 122, '2014-04-01 00:42:57.000000', 'temperatura', 939.0000, 'ºC'),
	(284665, 122, '2014-04-01 00:42:58.000000', 'temperatura', 91.0000, 'ºC'),
	(284666, 122, '2014-04-01 00:42:59.000000', 'temperatura', 39.0000, 'ºC'),
	(284667, 122, '2014-04-01 00:43:00.000000', 'temperatura', 1121.0000, 'ºC'),
	(284668, 122, '2014-04-01 00:43:01.000000', 'temperatura', 690.0000, 'ºC'),
	(284669, 122, '2014-04-01 00:43:02.000000', 'temperatura', 87.0000, 'ºC'),
	(284670, 122, '2014-04-01 00:43:03.000000', 'temperatura', 765.0000, 'ºC'),
	(284671, 122, '2014-04-01 00:43:04.000000', 'temperatura', 1167.0000, 'ºC'),
	(284672, 122, '2014-04-01 00:43:05.000000', 'temperatura', 1137.0000, 'ºC'),
	(284673, 122, '2014-04-01 00:43:06.000000', 'temperatura', 986.0000, 'ºC'),
	(284674, 122, '2014-04-01 00:43:07.000000', 'temperatura', 322.0000, 'ºC'),
	(284675, 122, '2014-04-01 00:43:08.000000', 'temperatura', 1049.0000, 'ºC'),
	(284676, 122, '2014-04-01 00:43:09.000000', 'temperatura', 679.0000, 'ºC'),
	(284677, 122, '2014-04-01 00:43:10.000000', 'temperatura', 250.0000, 'ºC'),
	(284678, 122, '2014-04-01 00:43:11.000000', 'temperatura', 415.0000, 'ºC'),
	(284679, 122, '2014-04-01 00:43:12.000000', 'temperatura', 124.0000, 'ºC'),
	(284680, 122, '2014-04-01 00:43:13.000000', 'temperatura', 576.0000, 'ºC'),
	(284681, 122, '2014-04-01 00:43:14.000000', 'temperatura', 110.0000, 'ºC'),
	(284682, 122, '2014-04-01 00:43:15.000000', 'temperatura', 22.0000, 'ºC'),
	(284683, 122, '2014-04-01 00:43:16.000000', 'temperatura', 980.0000, 'ºC'),
	(284684, 122, '2014-04-01 00:43:17.000000', 'temperatura', 35.0000, 'ºC'),
	(284685, 122, '2014-04-01 00:43:18.000000', 'temperatura', 834.0000, 'ºC'),
	(284686, 122, '2014-04-01 00:43:19.000000', 'temperatura', 466.0000, 'ºC'),
	(284687, 122, '2014-04-01 00:43:20.000000', 'temperatura', 1030.0000, 'ºC'),
	(284688, 122, '2014-04-01 00:43:21.000000', 'temperatura', 151.0000, 'ºC'),
	(284689, 122, '2014-04-01 00:43:22.000000', 'temperatura', 67.0000, 'ºC'),
	(284690, 122, '2014-04-01 00:43:23.000000', 'temperatura', 1082.0000, 'ºC'),
	(284691, 122, '2014-04-01 00:43:24.000000', 'temperatura', 409.0000, 'ºC'),
	(284692, 122, '2014-04-01 00:43:25.000000', 'temperatura', 0.0000, 'ºC'),
	(284693, 122, '2014-04-01 00:43:26.000000', 'temperatura', 1174.0000, 'ºC'),
	(284694, 122, '2014-04-01 00:43:27.000000', 'temperatura', 1071.0000, 'ºC'),
	(284695, 122, '2014-04-01 00:43:28.000000', 'temperatura', 631.0000, 'ºC'),
	(284696, 122, '2014-04-01 00:43:29.000000', 'temperatura', 1144.0000, 'ºC'),
	(284697, 122, '2014-04-01 00:43:30.000000', 'temperatura', 228.0000, 'ºC'),
	(284698, 122, '2014-04-01 00:43:31.000000', 'temperatura', 108.0000, 'ºC'),
	(284699, 122, '2014-04-01 00:43:32.000000', 'temperatura', 1056.0000, 'ºC'),
	(284700, 122, '2014-04-01 00:43:33.000000', 'temperatura', 157.0000, 'ºC'),
	(284701, 122, '2014-04-01 00:43:34.000000', 'temperatura', 19.0000, 'ºC'),
	(284702, 122, '2014-04-01 00:43:35.000000', 'temperatura', 821.0000, 'ºC'),
	(284703, 122, '2014-04-01 00:43:36.000000', 'temperatura', 452.0000, 'ºC'),
	(284704, 122, '2014-04-01 00:43:37.000000', 'temperatura', 995.0000, 'ºC'),
	(284705, 122, '2014-04-01 00:43:38.000000', 'temperatura', 21.0000, 'ºC'),
	(284706, 122, '2014-04-01 00:43:39.000000', 'temperatura', 721.0000, 'ºC'),
	(284707, 122, '2014-04-01 00:43:40.000000', 'temperatura', 1140.0000, 'ºC'),
	(284708, 122, '2014-04-01 00:43:41.000000', 'temperatura', 1138.0000, 'ºC'),
	(284709, 122, '2014-04-01 00:43:42.000000', 'temperatura', 1071.0000, 'ºC'),
	(284710, 122, '2014-04-01 00:43:43.000000', 'temperatura', 741.0000, 'ºC'),
	(284711, 122, '2014-04-01 00:43:44.000000', 'temperatura', 491.0000, 'ºC'),
	(284712, 122, '2014-04-01 00:43:45.000000', 'temperatura', 235.0000, 'ºC'),
	(284713, 122, '2014-04-01 00:43:46.000000', 'temperatura', 903.0000, 'ºC'),
	(284714, 122, '2014-04-01 00:43:47.000000', 'temperatura', 209.0000, 'ºC'),
	(284715, 122, '2014-04-01 00:43:48.000000', 'temperatura', 736.0000, 'ºC'),
	(284716, 122, '2014-04-01 00:43:49.000000', 'temperatura', 656.0000, 'ºC'),
	(284717, 122, '2014-04-01 00:43:50.000000', 'temperatura', 1070.0000, 'ºC'),
	(284718, 122, '2014-04-01 00:43:51.000000', 'temperatura', 985.0000, 'ºC'),
	(284719, 122, '2014-04-01 00:43:52.000000', 'temperatura', 512.0000, 'ºC'),
	(284720, 122, '2014-04-01 00:43:53.000000', 'temperatura', 808.0000, 'ºC'),
	(284721, 122, '2014-04-01 00:43:54.000000', 'temperatura', 104.0000, 'ºC'),
	(284722, 122, '2014-04-01 00:43:55.000000', 'temperatura', 496.0000, 'ºC'),
	(284723, 122, '2014-04-01 00:43:56.000000', 'temperatura', 970.0000, 'ºC'),
	(284724, 122, '2014-04-01 00:43:57.000000', 'temperatura', 962.0000, 'ºC'),
	(284725, 122, '2014-04-01 00:43:58.000000', 'temperatura', 699.0000, 'ºC'),
	(284726, 122, '2014-04-01 00:43:59.000000', 'temperatura', 609.0000, 'ºC'),
	(284727, 122, '2014-04-01 00:44:00.000000', 'temperatura', 949.0000, 'ºC'),
	(284728, 122, '2014-04-01 00:44:01.000000', 'temperatura', 520.0000, 'ºC'),
	(284729, 122, '2014-04-01 00:44:02.000000', 'temperatura', 954.0000, 'ºC'),
	(284730, 122, '2014-04-01 00:44:03.000000', 'temperatura', 811.0000, 'ºC'),
	(284731, 122, '2014-04-01 00:44:04.000000', 'temperatura', 1193.0000, 'ºC'),
	(284732, 122, '2014-04-01 00:44:05.000000', 'temperatura', 1133.0000, 'ºC'),
	(284733, 122, '2014-04-01 00:44:06.000000', 'temperatura', 886.0000, 'ºC'),
	(284734, 122, '2014-04-01 00:44:07.000000', 'temperatura', 1033.0000, 'ºC'),
	(284735, 122, '2014-04-01 00:44:08.000000', 'temperatura', 104.0000, 'ºC'),
	(284736, 122, '2014-04-01 00:44:09.000000', 'temperatura', 1024.0000, 'ºC'),
	(284737, 122, '2014-04-01 00:44:10.000000', 'temperatura', 10.0000, 'ºC'),
	(284738, 122, '2014-04-01 00:44:11.000000', 'temperatura', 576.0000, 'ºC'),
	(284739, 122, '2014-04-01 00:44:12.000000', 'temperatura', 452.0000, 'ºC'),
	(284740, 122, '2014-04-01 00:44:13.000000', 'temperatura', 533.0000, 'ºC'),
	(284741, 122, '2014-04-01 00:44:14.000000', 'temperatura', 109.0000, 'ºC'),
	(284742, 122, '2014-04-01 00:44:15.000000', 'temperatura', 148.0000, 'ºC'),
	(284743, 122, '2014-04-01 00:44:16.000000', 'temperatura', 411.0000, 'ºC'),
	(284744, 122, '2014-04-01 00:44:17.000000', 'temperatura', 412.0000, 'ºC'),
	(284745, 122, '2014-04-01 00:44:18.000000', 'temperatura', 829.0000, 'ºC'),
	(284746, 122, '2014-04-01 00:44:19.000000', 'temperatura', 509.0000, 'ºC'),
	(284747, 122, '2014-04-01 00:44:20.000000', 'temperatura', 59.0000, 'ºC'),
	(284748, 122, '2014-04-01 00:44:21.000000', 'temperatura', 1166.0000, 'ºC'),
	(284749, 122, '2014-04-01 00:44:22.000000', 'temperatura', 854.0000, 'ºC'),
	(284750, 122, '2014-04-01 00:44:23.000000', 'temperatura', 775.0000, 'ºC'),
	(284751, 122, '2014-04-01 00:44:24.000000', 'temperatura', 111.0000, 'ºC'),
	(284752, 122, '2014-04-01 00:44:25.000000', 'temperatura', 630.0000, 'ºC'),
	(284753, 122, '2014-04-01 00:44:26.000000', 'temperatura', 419.0000, 'ºC'),
	(284754, 122, '2014-04-01 00:44:27.000000', 'temperatura', 203.0000, 'ºC'),
	(284755, 122, '2014-04-01 00:44:28.000000', 'temperatura', 962.0000, 'ºC'),
	(284756, 122, '2014-04-01 00:44:29.000000', 'temperatura', 598.0000, 'ºC'),
	(284757, 122, '2014-04-01 00:44:30.000000', 'temperatura', 106.0000, 'ºC'),
	(284758, 122, '2014-04-01 00:44:31.000000', 'temperatura', 1136.0000, 'ºC'),
	(284759, 122, '2014-04-01 00:44:32.000000', 'temperatura', 561.0000, 'ºC'),
	(284760, 122, '2014-04-01 00:44:33.000000', 'temperatura', 598.0000, 'ºC'),
	(284761, 122, '2014-04-01 00:44:34.000000', 'temperatura', 108.0000, 'ºC'),
	(284762, 122, '2014-04-01 00:44:35.000000', 'temperatura', 1145.0000, 'ºC'),
	(284763, 122, '2014-04-01 00:44:36.000000', 'temperatura', 602.0000, 'ºC'),
	(284764, 122, '2014-04-01 00:44:37.000000', 'temperatura', 778.0000, 'ºC'),
	(284765, 122, '2014-04-01 00:44:38.000000', 'temperatura', 882.0000, 'ºC'),
	(284766, 122, '2014-04-01 00:44:39.000000', 'temperatura', 876.0000, 'ºC'),
	(284767, 122, '2014-04-01 00:44:40.000000', 'temperatura', 537.0000, 'ºC'),
	(284768, 122, '2014-04-01 00:44:41.000000', 'temperatura', 56.0000, 'ºC'),
	(284769, 122, '2014-04-01 00:44:42.000000', 'temperatura', 1072.0000, 'ºC'),
	(284770, 122, '2014-04-01 00:44:43.000000', 'temperatura', 390.0000, 'ºC'),
	(284771, 122, '2014-04-01 00:44:44.000000', 'temperatura', 1134.0000, 'ºC'),
	(284772, 122, '2014-04-01 00:44:45.000000', 'temperatura', 903.0000, 'ºC'),
	(284773, 122, '2014-04-01 00:44:46.000000', 'temperatura', 1112.0000, 'ºC'),
	(284774, 122, '2014-04-01 00:44:47.000000', 'temperatura', 450.0000, 'ºC'),
	(284775, 122, '2014-04-01 00:44:48.000000', 'temperatura', 117.0000, 'ºC'),
	(284776, 122, '2014-04-01 00:44:49.000000', 'temperatura', 436.0000, 'ºC'),
	(284777, 122, '2014-04-01 00:44:50.000000', 'temperatura', 627.0000, 'ºC'),
	(284778, 122, '2014-04-01 00:44:51.000000', 'temperatura', 630.0000, 'ºC'),
	(284779, 122, '2014-04-01 00:44:52.000000', 'temperatura', 66.0000, 'ºC'),
	(284780, 122, '2014-04-01 00:44:53.000000', 'temperatura', 844.0000, 'ºC'),
	(284781, 122, '2014-04-01 00:44:54.000000', 'temperatura', 422.0000, 'ºC'),
	(284782, 122, '2014-04-01 00:44:55.000000', 'temperatura', 779.0000, 'ºC'),
	(284783, 122, '2014-04-01 00:44:56.000000', 'temperatura', 227.0000, 'ºC'),
	(284784, 122, '2014-04-01 00:44:57.000000', 'temperatura', 1.0000, 'ºC'),
	(284785, 122, '2014-04-01 00:44:58.000000', 'temperatura', 525.0000, 'ºC'),
	(284786, 122, '2014-04-01 00:44:59.000000', 'temperatura', 222.0000, 'ºC'),
	(284787, 122, '2014-04-01 00:45:00.000000', 'temperatura', 736.0000, 'ºC'),
	(284788, 122, '2014-04-01 00:45:01.000000', 'temperatura', 613.0000, 'ºC'),
	(284789, 122, '2014-04-01 00:45:02.000000', 'temperatura', 860.0000, 'ºC'),
	(284790, 122, '2014-04-01 00:45:03.000000', 'temperatura', 59.0000, 'ºC'),
	(284791, 122, '2014-04-01 00:45:04.000000', 'temperatura', 118.0000, 'ºC'),
	(284792, 122, '2014-04-01 00:45:05.000000', 'temperatura', 414.0000, 'ºC'),
	(284793, 122, '2014-04-01 00:45:06.000000', 'temperatura', 515.0000, 'ºC'),
	(284794, 122, '2014-04-01 00:45:07.000000', 'temperatura', 134.0000, 'ºC'),
	(284795, 122, '2014-04-01 00:45:08.000000', 'temperatura', 326.0000, 'ºC'),
	(284796, 122, '2014-04-01 00:45:09.000000', 'temperatura', 29.0000, 'ºC'),
	(284797, 122, '2014-04-01 00:45:10.000000', 'temperatura', 366.0000, 'ºC'),
	(284798, 122, '2014-04-01 00:45:11.000000', 'temperatura', 546.0000, 'ºC'),
	(284799, 122, '2014-04-01 00:45:12.000000', 'temperatura', 432.0000, 'ºC'),
	(284800, 122, '2014-04-01 00:45:13.000000', 'temperatura', 520.0000, 'ºC'),
	(284801, 122, '2014-04-01 00:45:14.000000', 'temperatura', 106.0000, 'ºC'),
	(284802, 122, '2014-04-01 00:45:15.000000', 'temperatura', 172.0000, 'ºC'),
	(284803, 122, '2014-04-01 00:45:16.000000', 'temperatura', 540.0000, 'ºC'),
	(284804, 122, '2014-04-01 00:45:17.000000', 'temperatura', 984.0000, 'ºC'),
	(284805, 122, '2014-04-01 00:45:18.000000', 'temperatura', 903.0000, 'ºC'),
	(284806, 122, '2014-04-01 00:45:19.000000', 'temperatura', 364.0000, 'ºC'),
	(284807, 122, '2014-04-01 00:45:20.000000', 'temperatura', 312.0000, 'ºC'),
	(284808, 122, '2014-04-01 00:45:21.000000', 'temperatura', 466.0000, 'ºC'),
	(284809, 122, '2014-04-01 00:45:22.000000', 'temperatura', 196.0000, 'ºC'),
	(284810, 122, '2014-04-01 00:45:23.000000', 'temperatura', 781.0000, 'ºC'),
	(284811, 122, '2014-04-01 00:45:24.000000', 'temperatura', 920.0000, 'ºC'),
	(284812, 122, '2014-04-01 00:45:25.000000', 'temperatura', 1057.0000, 'ºC'),
	(284813, 122, '2014-04-01 00:45:26.000000', 'temperatura', 126.0000, 'ºC'),
	(284814, 122, '2014-04-01 00:45:27.000000', 'temperatura', 1059.0000, 'ºC'),
	(284815, 122, '2014-04-01 00:45:28.000000', 'temperatura', 119.0000, 'ºC'),
	(284816, 122, '2014-04-01 00:45:29.000000', 'temperatura', 1018.0000, 'ºC'),
	(284817, 122, '2014-04-01 00:45:30.000000', 'temperatura', 1134.0000, 'ºC'),
	(284818, 122, '2014-04-01 00:45:31.000000', 'temperatura', 217.0000, 'ºC'),
	(284819, 122, '2014-04-01 00:45:32.000000', 'temperatura', 81.0000, 'ºC'),
	(284820, 122, '2014-04-01 00:45:33.000000', 'temperatura', 957.0000, 'ºC'),
	(284821, 122, '2014-04-01 00:45:34.000000', 'temperatura', 943.0000, 'ºC'),
	(284822, 122, '2014-04-01 00:45:35.000000', 'temperatura', 642.0000, 'ºC'),
	(284823, 122, '2014-04-01 00:45:36.000000', 'temperatura', 381.0000, 'ºC'),
	(284824, 122, '2014-04-01 00:45:37.000000', 'temperatura', 1181.0000, 'ºC'),
	(284825, 122, '2014-04-01 00:45:38.000000', 'temperatura', 1164.0000, 'ºC'),
	(284826, 122, '2014-04-01 00:45:39.000000', 'temperatura', 1077.0000, 'ºC'),
	(284827, 122, '2014-04-01 00:45:40.000000', 'temperatura', 691.0000, 'ºC'),
	(284828, 122, '2014-04-01 00:45:41.000000', 'temperatura', 228.0000, 'ºC'),
	(284829, 122, '2014-04-01 00:45:42.000000', 'temperatura', 265.0000, 'ºC'),
	(284830, 122, '2014-04-01 00:45:43.000000', 'temperatura', 644.0000, 'ºC'),
	(284831, 122, '2014-04-01 00:45:44.000000', 'temperatura', 25.0000, 'ºC'),
	(284832, 122, '2014-04-01 00:45:45.000000', 'temperatura', 592.0000, 'ºC'),
	(284833, 122, '2014-04-01 00:45:46.000000', 'temperatura', 488.0000, 'ºC'),
	(284834, 122, '2014-04-01 00:45:47.000000', 'temperatura', 664.0000, 'ºC'),
	(284835, 122, '2014-04-01 00:45:48.000000', 'temperatura', 654.0000, 'ºC'),
	(284836, 122, '2014-04-01 00:45:49.000000', 'temperatura', 81.0000, 'ºC'),
	(284837, 122, '2014-04-01 00:45:50.000000', 'temperatura', 841.0000, 'ºC'),
	(284838, 122, '2014-04-01 00:45:51.000000', 'temperatura', 364.0000, 'ºC'),
	(284839, 122, '2014-04-01 00:45:52.000000', 'temperatura', 496.0000, 'ºC'),
	(284840, 122, '2014-04-01 00:45:53.000000', 'temperatura', 188.0000, 'ºC'),
	(284841, 122, '2014-04-01 00:45:54.000000', 'temperatura', 652.0000, 'ºC'),
	(284842, 122, '2014-04-01 00:45:55.000000', 'temperatura', 296.0000, 'ºC'),
	(284843, 122, '2014-04-01 00:45:56.000000', 'temperatura', 724.0000, 'ºC'),
	(284844, 122, '2014-04-01 00:45:57.000000', 'temperatura', 332.0000, 'ºC'),
	(284845, 122, '2014-04-01 00:45:58.000000', 'temperatura', 691.0000, 'ºC'),
	(284846, 122, '2014-04-01 00:45:59.000000', 'temperatura', 60.0000, 'ºC'),
	(284847, 122, '2014-04-01 00:46:00.000000', 'temperatura', 627.0000, 'ºC'),
	(284848, 122, '2014-04-01 00:46:01.000000', 'temperatura', 553.0000, 'ºC'),
	(284849, 122, '2014-04-01 00:46:02.000000', 'temperatura', 886.0000, 'ºC'),
	(284850, 122, '2014-04-01 00:46:03.000000', 'temperatura', 372.0000, 'ºC'),
	(284851, 122, '2014-04-01 00:46:04.000000', 'temperatura', 401.0000, 'ºC'),
	(284852, 122, '2014-04-01 00:46:05.000000', 'temperatura', 889.0000, 'ºC'),
	(284853, 122, '2014-04-01 00:46:06.000000', 'temperatura', 843.0000, 'ºC'),
	(284854, 122, '2014-04-01 00:46:07.000000', 'temperatura', 349.0000, 'ºC'),
	(284855, 122, '2014-04-01 00:46:08.000000', 'temperatura', 418.0000, 'ºC'),
	(284856, 122, '2014-04-01 00:46:09.000000', 'temperatura', 1043.0000, 'ºC'),
	(284857, 122, '2014-04-01 00:46:10.000000', 'temperatura', 361.0000, 'ºC'),
	(284858, 122, '2014-04-01 00:46:11.000000', 'temperatura', 1075.0000, 'ºC'),
	(284859, 122, '2014-04-01 00:46:12.000000', 'temperatura', 692.0000, 'ºC'),
	(284860, 122, '2014-04-01 00:46:13.000000', 'temperatura', 236.0000, 'ºC'),
	(284861, 122, '2014-04-01 00:46:14.000000', 'temperatura', 304.0000, 'ºC'),
	(284862, 122, '2014-04-01 00:46:15.000000', 'temperatura', 813.0000, 'ºC'),
	(284863, 122, '2014-04-01 00:46:16.000000', 'temperatura', 753.0000, 'ºC'),
	(284864, 122, '2014-04-01 00:46:17.000000', 'temperatura', 128.0000, 'ºC'),
	(284865, 122, '2014-04-01 00:46:18.000000', 'temperatura', 783.0000, 'ºC'),
	(284866, 122, '2014-04-01 00:46:19.000000', 'temperatura', 1128.0000, 'ºC'),
	(284867, 122, '2014-04-01 00:46:20.000000', 'temperatura', 892.0000, 'ºC'),
	(284868, 122, '2014-04-01 00:46:21.000000', 'temperatura', 1077.0000, 'ºC'),
	(284869, 122, '2014-04-01 00:46:22.000000', 'temperatura', 310.0000, 'ºC'),
	(284870, 122, '2014-04-01 00:46:23.000000', 'temperatura', 718.0000, 'ºC'),
	(284871, 122, '2014-04-01 00:46:24.000000', 'temperatura', 260.0000, 'ºC'),
	(284872, 122, '2014-04-01 00:46:25.000000', 'temperatura', 347.0000, 'ºC'),
	(284873, 122, '2014-04-01 00:46:26.000000', 'temperatura', 954.0000, 'ºC'),
	(284874, 122, '2014-04-01 00:46:27.000000', 'temperatura', 132.0000, 'ºC'),
	(284875, 122, '2014-04-01 00:46:28.000000', 'temperatura', 199.0000, 'ºC'),
	(284876, 122, '2014-04-01 00:46:29.000000', 'temperatura', 600.0000, 'ºC'),
	(284877, 122, '2014-04-01 00:46:30.000000', 'temperatura', 3.0000, 'ºC'),
	(284878, 122, '2014-04-01 00:46:31.000000', 'temperatura', 616.0000, 'ºC'),
	(284879, 122, '2014-04-01 00:46:32.000000', 'temperatura', 670.0000, 'ºC'),
	(284880, 122, '2014-04-01 00:46:33.000000', 'temperatura', 303.0000, 'ºC'),
	(284881, 122, '2014-04-01 00:46:34.000000', 'temperatura', 704.0000, 'ºC'),
	(284882, 122, '2014-04-01 00:46:35.000000', 'temperatura', 212.0000, 'ºC'),
	(284883, 122, '2014-04-01 00:46:36.000000', 'temperatura', 149.0000, 'ºC'),
	(284884, 122, '2014-04-01 00:46:37.000000', 'temperatura', 110.0000, 'ºC'),
	(284885, 122, '2014-04-01 00:46:38.000000', 'temperatura', 105.0000, 'ºC'),
	(284886, 122, '2014-04-01 00:46:39.000000', 'temperatura', 195.0000, 'ºC'),
	(284887, 122, '2014-04-01 00:46:40.000000', 'temperatura', 661.0000, 'ºC'),
	(284888, 122, '2014-04-01 00:46:41.000000', 'temperatura', 321.0000, 'ºC'),
	(284889, 122, '2014-04-01 00:46:42.000000', 'temperatura', 822.0000, 'ºC'),
	(284890, 122, '2014-04-01 00:46:43.000000', 'temperatura', 748.0000, 'ºC'),
	(284891, 122, '2014-04-01 00:46:44.000000', 'temperatura', 72.0000, 'ºC'),
	(284892, 122, '2014-04-01 00:46:45.000000', 'temperatura', 518.0000, 'ºC'),
	(284893, 122, '2014-04-01 00:46:46.000000', 'temperatura', 1173.0000, 'ºC'),
	(284894, 122, '2014-04-01 00:46:47.000000', 'temperatura', 713.0000, 'ºC'),
	(284895, 122, '2014-04-01 00:46:48.000000', 'temperatura', 47.0000, 'ºC'),
	(284896, 122, '2014-04-01 00:46:49.000000', 'temperatura', 497.0000, 'ºC'),
	(284897, 122, '2014-04-01 00:46:50.000000', 'temperatura', 1144.0000, 'ºC'),
	(284898, 122, '2014-04-01 00:46:51.000000', 'temperatura', 630.0000, 'ºC'),
	(284899, 122, '2014-04-01 00:46:52.000000', 'temperatura', 920.0000, 'ºC'),
	(284900, 122, '2014-04-01 00:46:53.000000', 'temperatura', 308.0000, 'ºC'),
	(284901, 122, '2014-04-01 00:46:54.000000', 'temperatura', 1181.0000, 'ºC'),
	(284902, 122, '2014-04-01 00:46:55.000000', 'temperatura', 182.0000, 'ºC'),
	(284903, 122, '2014-04-01 00:46:56.000000', 'temperatura', 966.0000, 'ºC'),
	(284904, 122, '2014-04-01 00:46:57.000000', 'temperatura', 687.0000, 'ºC'),
	(284905, 122, '2014-04-01 00:46:58.000000', 'temperatura', 537.0000, 'ºC'),
	(284906, 122, '2014-04-01 00:46:59.000000', 'temperatura', 624.0000, 'ºC'),
	(284907, 122, '2014-04-01 00:47:00.000000', 'temperatura', 308.0000, 'ºC'),
	(284908, 122, '2014-04-01 00:47:01.000000', 'temperatura', 871.0000, 'ºC'),
	(284909, 122, '2014-04-01 00:47:02.000000', 'temperatura', 1030.0000, 'ºC'),
	(284910, 122, '2014-04-01 00:47:03.000000', 'temperatura', 138.0000, 'ºC'),
	(284911, 122, '2014-04-01 00:47:04.000000', 'temperatura', 1199.0000, 'ºC'),
	(284912, 122, '2014-04-01 00:47:05.000000', 'temperatura', 783.0000, 'ºC'),
	(284913, 122, '2014-04-01 00:47:06.000000', 'temperatura', 316.0000, 'ºC'),
	(284914, 122, '2014-04-01 00:47:07.000000', 'temperatura', 435.0000, 'ºC'),
	(284915, 122, '2014-04-01 00:47:08.000000', 'temperatura', 25.0000, 'ºC'),
	(284916, 122, '2014-04-01 00:47:09.000000', 'temperatura', 20.0000, 'ºC'),
	(284917, 122, '2014-04-01 00:47:10.000000', 'temperatura', 26.0000, 'ºC'),
	(284918, 122, '2014-04-01 00:47:11.000000', 'temperatura', 73.0000, 'ºC'),
	(284919, 122, '2014-04-01 00:47:12.000000', 'temperatura', 284.0000, 'ºC'),
	(284920, 122, '2014-04-01 00:47:13.000000', 'temperatura', 4.0000, 'ºC'),
	(284921, 122, '2014-04-01 00:47:14.000000', 'temperatura', 368.0000, 'ºC'),
	(284922, 122, '2014-04-01 00:47:15.000000', 'temperatura', 628.0000, 'ºC'),
	(284923, 122, '2014-04-01 00:47:16.000000', 'temperatura', 835.0000, 'ºC'),
	(284924, 122, '2014-04-01 00:47:17.000000', 'temperatura', 1093.0000, 'ºC'),
	(284925, 122, '2014-04-01 00:47:18.000000', 'temperatura', 561.0000, 'ºC'),
	(284926, 122, '2014-04-01 00:47:19.000000', 'temperatura', 725.0000, 'ºC'),
	(284927, 122, '2014-04-01 00:47:20.000000', 'temperatura', 744.0000, 'ºC'),
	(284928, 122, '2014-04-01 00:47:21.000000', 'temperatura', 346.0000, 'ºC'),
	(284929, 122, '2014-04-01 00:47:22.000000', 'temperatura', 696.0000, 'ºC'),
	(284930, 122, '2014-04-01 00:47:23.000000', 'temperatura', 43.0000, 'ºC'),
	(284931, 122, '2014-04-01 00:47:24.000000', 'temperatura', 527.0000, 'ºC'),
	(284932, 122, '2014-04-01 00:47:25.000000', 'temperatura', 107.0000, 'ºC'),
	(284933, 122, '2014-04-01 00:47:26.000000', 'temperatura', 153.0000, 'ºC'),
	(284934, 122, '2014-04-01 00:47:27.000000', 'temperatura', 446.0000, 'ºC'),
	(284935, 122, '2014-04-01 00:47:28.000000', 'temperatura', 570.0000, 'ºC'),
	(284936, 122, '2014-04-01 00:47:29.000000', 'temperatura', 311.0000, 'ºC'),
	(284937, 122, '2014-04-01 00:47:30.000000', 'temperatura', 1048.0000, 'ºC'),
	(284938, 122, '2014-04-01 00:47:31.000000', 'temperatura', 707.0000, 'ºC'),
	(284939, 122, '2014-04-01 00:47:32.000000', 'temperatura', 393.0000, 'ºC'),
	(284940, 122, '2014-04-01 00:47:33.000000', 'temperatura', 1045.0000, 'ºC'),
	(284941, 122, '2014-04-01 00:47:34.000000', 'temperatura', 447.0000, 'ºC'),
	(284942, 122, '2014-04-01 00:47:35.000000', 'temperatura', 300.0000, 'ºC'),
	(284943, 122, '2014-04-01 00:47:36.000000', 'temperatura', 159.0000, 'ºC'),
	(284944, 122, '2014-04-01 00:47:37.000000', 'temperatura', 1097.0000, 'ºC'),
	(284945, 122, '2014-04-01 00:47:38.000000', 'temperatura', 206.0000, 'ºC'),
	(284946, 122, '2014-04-01 00:47:39.000000', 'temperatura', 141.0000, 'ºC'),
	(284947, 122, '2014-04-01 00:47:40.000000', 'temperatura', 85.0000, 'ºC'),
	(284948, 122, '2014-04-01 00:47:41.000000', 'temperatura', 4.0000, 'ºC'),
	(284949, 122, '2014-04-01 00:47:42.000000', 'temperatura', 967.0000, 'ºC'),
	(284950, 122, '2014-04-01 00:47:43.000000', 'temperatura', 22.0000, 'ºC'),
	(284951, 122, '2014-04-01 00:47:44.000000', 'temperatura', 812.0000, 'ºC'),
	(284952, 122, '2014-04-01 00:47:45.000000', 'temperatura', 392.0000, 'ºC'),
	(284953, 122, '2014-04-01 00:47:46.000000', 'temperatura', 724.0000, 'ºC'),
	(284954, 122, '2014-04-01 00:47:47.000000', 'temperatura', 44.0000, 'ºC'),
	(284955, 122, '2014-04-01 00:47:48.000000', 'temperatura', 449.0000, 'ºC'),
	(284956, 122, '2014-04-01 00:47:49.000000', 'temperatura', 916.0000, 'ºC'),
	(284957, 122, '2014-04-01 00:47:50.000000', 'temperatura', 831.0000, 'ºC'),
	(284958, 122, '2014-04-01 00:47:51.000000', 'temperatura', 208.0000, 'ºC'),
	(284959, 122, '2014-04-01 00:47:52.000000', 'temperatura', 949.0000, 'ºC'),
	(284960, 122, '2014-04-01 00:47:53.000000', 'temperatura', 522.0000, 'ºC'),
	(284961, 122, '2014-04-01 00:47:54.000000', 'temperatura', 962.0000, 'ºC'),
	(284962, 122, '2014-04-01 00:47:55.000000', 'temperatura', 843.0000, 'ºC'),
	(284963, 122, '2014-04-01 00:47:56.000000', 'temperatura', 130.0000, 'ºC'),
	(284964, 122, '2014-04-01 00:47:57.000000', 'temperatura', 524.0000, 'ºC'),
	(284965, 122, '2014-04-01 00:47:58.000000', 'temperatura', 1030.0000, 'ºC'),
	(284966, 122, '2014-04-01 00:47:59.000000', 'temperatura', 1177.0000, 'ºC'),
	(284967, 122, '2014-04-01 00:48:00.000000', 'temperatura', 395.0000, 'ºC'),
	(284968, 122, '2014-04-01 00:48:01.000000', 'temperatura', 844.0000, 'ºC'),
	(284969, 122, '2014-04-01 00:48:02.000000', 'temperatura', 637.0000, 'ºC'),
	(284970, 122, '2014-04-01 00:48:03.000000', 'temperatura', 652.0000, 'ºC'),
	(284971, 122, '2014-04-01 00:48:04.000000', 'temperatura', 150.0000, 'ºC'),
	(284972, 122, '2014-04-01 00:48:05.000000', 'temperatura', 1193.0000, 'ºC'),
	(284973, 122, '2014-04-01 00:48:06.000000', 'temperatura', 716.0000, 'ºC'),
	(284974, 122, '2014-04-01 00:48:07.000000', 'temperatura', 1.0000, 'ºC'),
	(284975, 122, '2014-04-01 00:48:08.000000', 'temperatura', 259.0000, 'ºC'),
	(284976, 122, '2014-04-01 00:48:09.000000', 'temperatura', 90.0000, 'ºC'),
	(284977, 122, '2014-04-01 00:48:10.000000', 'temperatura', 876.0000, 'ºC'),
	(284978, 122, '2014-04-01 00:48:11.000000', 'temperatura', 509.0000, 'ºC'),
	(284979, 122, '2014-04-01 00:48:12.000000', 'temperatura', 1118.0000, 'ºC'),
	(284980, 122, '2014-04-01 00:48:13.000000', 'temperatura', 465.0000, 'ºC'),
	(284981, 122, '2014-04-01 00:48:14.000000', 'temperatura', 170.0000, 'ºC'),
	(284982, 122, '2014-04-01 00:48:15.000000', 'temperatura', 654.0000, 'ºC'),
	(284983, 122, '2014-04-01 00:48:16.000000', 'temperatura', 362.0000, 'ºC'),
	(284984, 122, '2014-04-01 00:48:17.000000', 'temperatura', 1046.0000, 'ºC'),
	(284985, 122, '2014-04-01 00:48:18.000000', 'temperatura', 548.0000, 'ºC'),
	(284986, 122, '2014-04-01 00:48:19.000000', 'temperatura', 802.0000, 'ºC'),
	(284987, 122, '2014-04-01 00:48:20.000000', 'temperatura', 1166.0000, 'ºC'),
	(284988, 122, '2014-04-01 00:48:21.000000', 'temperatura', 1024.0000, 'ºC'),
	(284989, 122, '2014-04-01 00:48:22.000000', 'temperatura', 424.0000, 'ºC'),
	(284990, 122, '2014-04-01 00:48:23.000000', 'temperatura', 250.0000, 'ºC'),
	(284991, 122, '2014-04-01 00:48:24.000000', 'temperatura', 1176.0000, 'ºC'),
	(284992, 122, '2014-04-01 00:48:25.000000', 'temperatura', 331.0000, 'ºC'),
	(284993, 122, '2014-04-01 00:48:26.000000', 'temperatura', 526.0000, 'ºC'),
	(284994, 122, '2014-04-01 00:48:27.000000', 'temperatura', 440.0000, 'ºC'),
	(284995, 122, '2014-04-01 00:48:28.000000', 'temperatura', 622.0000, 'ºC'),
	(284996, 122, '2014-04-01 00:48:29.000000', 'temperatura', 589.0000, 'ºC'),
	(284997, 122, '2014-04-01 00:48:30.000000', 'temperatura', 1078.0000, 'ºC'),
	(284998, 122, '2014-04-01 00:48:31.000000', 'temperatura', 27.0000, 'ºC'),
	(284999, 122, '2014-04-01 00:48:32.000000', 'temperatura', 499.0000, 'ºC'),
	(285000, 122, '2014-04-01 00:48:33.000000', 'temperatura', 14.0000, 'ºC'),
	(285001, 122, '2014-04-01 00:48:34.000000', 'temperatura', 974.0000, 'ºC'),
	(285002, 122, '2014-04-01 00:48:35.000000', 'temperatura', 27.0000, 'ºC'),
	(285003, 122, '2014-04-01 00:48:36.000000', 'temperatura', 817.0000, 'ºC'),
	(285004, 122, '2014-04-01 00:48:37.000000', 'temperatura', 402.0000, 'ºC'),
	(285005, 122, '2014-04-01 00:48:38.000000', 'temperatura', 761.0000, 'ºC'),
	(285006, 122, '2014-04-01 00:48:39.000000', 'temperatura', 201.0000, 'ºC'),
	(285007, 122, '2014-04-01 00:48:40.000000', 'temperatura', 1121.0000, 'ºC'),
	(285008, 122, '2014-04-01 00:48:41.000000', 'temperatura', 203.0000, 'ºC'),
	(285009, 122, '2014-04-01 00:48:42.000000', 'temperatura', 54.0000, 'ºC'),
	(285010, 122, '2014-04-01 00:48:43.000000', 'temperatura', 861.0000, 'ºC'),
	(285011, 122, '2014-04-01 00:48:44.000000', 'temperatura', 544.0000, 'ºC'),
	(285012, 122, '2014-04-01 00:48:45.000000', 'temperatura', 136.0000, 'ºC'),
	(285013, 122, '2014-04-01 00:48:46.000000', 'temperatura', 249.0000, 'ºC'),
	(285014, 122, '2014-04-01 00:48:47.000000', 'temperatura', 838.0000, 'ºC'),
	(285015, 122, '2014-04-01 00:48:48.000000', 'temperatura', 1045.0000, 'ºC'),
	(285016, 122, '2014-04-01 00:48:49.000000', 'temperatura', 309.0000, 'ºC'),
	(285017, 122, '2014-04-01 00:48:50.000000', 'temperatura', 811.0000, 'ºC'),
	(285018, 122, '2014-04-01 00:48:51.000000', 'temperatura', 731.0000, 'ºC'),
	(285019, 122, '2014-04-01 00:48:52.000000', 'temperatura', 19.0000, 'ºC'),
	(285020, 122, '2014-04-01 00:48:53.000000', 'temperatura', 304.0000, 'ºC'),
	(285021, 122, '2014-04-01 00:48:54.000000', 'temperatura', 262.0000, 'ºC'),
	(285022, 122, '2014-04-01 00:48:55.000000', 'temperatura', 400.0000, 'ºC'),
	(285023, 122, '2014-04-01 00:48:56.000000', 'temperatura', 12.0000, 'ºC'),
	(285024, 122, '2014-04-01 00:48:57.000000', 'temperatura', 62.0000, 'ºC'),
	(285025, 122, '2014-04-01 00:48:58.000000', 'temperatura', 275.0000, 'ºC'),
	(285026, 122, '2014-04-01 00:48:59.000000', 'temperatura', 1190.0000, 'ºC'),
	(285027, 122, '2014-04-01 00:49:00.000000', 'temperatura', 323.0000, 'ºC'),
	(285028, 122, '2014-04-01 00:49:01.000000', 'temperatura', 448.0000, 'ºC'),
	(285029, 122, '2014-04-01 00:49:02.000000', 'temperatura', 69.0000, 'ºC'),
	(285030, 122, '2014-04-01 00:49:03.000000', 'temperatura', 204.0000, 'ºC'),
	(285031, 122, '2014-04-01 00:49:04.000000', 'temperatura', 811.0000, 'ºC'),
	(285032, 122, '2014-04-01 00:49:05.000000', 'temperatura', 1046.0000, 'ºC'),
	(285033, 122, '2014-04-01 00:49:06.000000', 'temperatura', 397.0000, 'ºC'),
	(285034, 122, '2014-04-01 00:49:07.000000', 'temperatura', 48.0000, 'ºC'),
	(285035, 122, '2014-04-01 00:49:08.000000', 'temperatura', 249.0000, 'ºC'),
	(285036, 122, '2014-04-01 00:49:09.000000', 'temperatura', 1102.0000, 'ºC'),
	(285037, 122, '2014-04-01 00:49:10.000000', 'temperatura', 1163.0000, 'ºC'),
	(285038, 122, '2014-04-01 00:49:11.000000', 'temperatura', 109.0000, 'ºC'),
	(285039, 122, '2014-04-01 00:49:12.000000', 'temperatura', 655.0000, 'ºC'),
	(285040, 122, '2014-04-01 00:49:13.000000', 'temperatura', 551.0000, 'ºC'),
	(285041, 122, '2014-04-01 00:49:14.000000', 'temperatura', 789.0000, 'ºC'),
	(285042, 122, '2014-04-01 00:49:15.000000', 'temperatura', 1095.0000, 'ºC'),
	(285043, 122, '2014-04-01 00:49:16.000000', 'temperatura', 707.0000, 'ºC'),
	(285044, 122, '2014-04-01 00:49:17.000000', 'temperatura', 251.0000, 'ºC'),
	(285045, 122, '2014-04-01 00:49:18.000000', 'temperatura', 333.0000, 'ºC'),
	(285046, 122, '2014-04-01 00:49:19.000000', 'temperatura', 912.0000, 'ºC'),
	(285047, 122, '2014-04-01 00:49:20.000000', 'temperatura', 1163.0000, 'ºC'),
	(285048, 122, '2014-04-01 00:49:21.000000', 'temperatura', 679.0000, 'ºC'),
	(285049, 122, '2014-04-01 00:49:22.000000', 'temperatura', 1106.0000, 'ºC'),
	(285050, 122, '2014-04-01 00:49:23.000000', 'temperatura', 1092.0000, 'ºC'),
	(285051, 122, '2014-04-01 00:49:24.000000', 'temperatura', 946.0000, 'ºC'),
	(285052, 122, '2014-04-01 00:49:25.000000', 'temperatura', 253.0000, 'ºC'),
	(285053, 122, '2014-04-01 00:49:26.000000', 'temperatura', 826.0000, 'ºC'),
	(285054, 122, '2014-04-01 00:49:27.000000', 'temperatura', 974.0000, 'ºC'),
	(285055, 122, '2014-04-01 00:49:28.000000', 'temperatura', 1192.0000, 'ºC'),
	(285056, 122, '2014-04-01 00:49:29.000000', 'temperatura', 637.0000, 'ºC'),
	(285057, 122, '2014-04-01 00:49:30.000000', 'temperatura', 809.0000, 'ºC'),
	(285058, 122, '2014-04-01 00:49:31.000000', 'temperatura', 935.0000, 'ºC'),
	(285059, 122, '2014-04-01 00:49:32.000000', 'temperatura', 1048.0000, 'ºC'),
	(285060, 122, '2014-04-01 00:49:33.000000', 'temperatura', 35.0000, 'ºC'),
	(285061, 122, '2014-04-01 00:49:34.000000', 'temperatura', 634.0000, 'ºC'),
	(285062, 122, '2014-04-01 00:49:35.000000', 'temperatura', 665.0000, 'ºC'),
	(285063, 122, '2014-04-01 00:49:36.000000', 'temperatura', 223.0000, 'ºC'),
	(285064, 122, '2014-04-01 00:49:37.000000', 'temperatura', 322.0000, 'ºC'),
	(285065, 122, '2014-04-01 00:49:38.000000', 'temperatura', 939.0000, 'ºC'),
	(285066, 122, '2014-04-01 00:49:39.000000', 'temperatura', 132.0000, 'ºC'),
	(285067, 122, '2014-04-01 00:49:40.000000', 'temperatura', 242.0000, 'ºC'),
	(285068, 122, '2014-04-01 00:49:41.000000', 'temperatura', 814.0000, 'ºC'),
	(285069, 122, '2014-04-01 00:49:42.000000', 'temperatura', 944.0000, 'ºC'),
	(285070, 122, '2014-04-01 00:49:43.000000', 'temperatura', 1080.0000, 'ºC'),
	(285071, 122, '2014-04-01 00:49:44.000000', 'temperatura', 168.0000, 'ºC'),
	(285072, 122, '2014-04-01 00:49:45.000000', 'temperatura', 2.0000, 'ºC'),
	(285073, 122, '2014-04-01 00:49:46.000000', 'temperatura', 706.0000, 'ºC'),
	(285074, 122, '2014-04-01 00:49:47.000000', 'temperatura', 1125.0000, 'ºC'),
	(285075, 122, '2014-04-01 00:49:48.000000', 'temperatura', 1105.0000, 'ºC'),
	(285076, 122, '2014-04-01 00:49:49.000000', 'temperatura', 952.0000, 'ºC'),
	(285077, 122, '2014-04-01 00:49:50.000000', 'temperatura', 244.0000, 'ºC'),
	(285078, 122, '2014-04-01 00:49:51.000000', 'temperatura', 765.0000, 'ºC'),
	(285079, 122, '2014-04-01 00:49:52.000000', 'temperatura', 696.0000, 'ºC'),
	(285080, 122, '2014-04-01 00:49:53.000000', 'temperatura', 1184.0000, 'ºC'),
	(285081, 122, '2014-04-01 00:49:54.000000', 'temperatura', 231.0000, 'ºC'),
	(285082, 122, '2014-04-01 00:49:55.000000', 'temperatura', 3.0000, 'ºC'),
	(285083, 122, '2014-04-01 00:49:56.000000', 'temperatura', 522.0000, 'ºC'),
	(285084, 122, '2014-04-01 00:49:57.000000', 'temperatura', 203.0000, 'ºC'),
	(285085, 122, '2014-04-01 00:49:58.000000', 'temperatura', 651.0000, 'ºC'),
	(285086, 122, '2014-04-01 00:49:59.000000', 'temperatura', 245.0000, 'ºC'),
	(285087, 122, '2014-04-01 00:50:00.000000', 'temperatura', 474.0000, 'ºC'),
	(285088, 122, '2014-04-01 00:50:01.000000', 'temperatura', 434.0000, 'ºC'),
	(285089, 122, '2014-04-01 00:50:02.000000', 'temperatura', 747.0000, 'ºC'),
	(285090, 122, '2014-04-01 00:50:03.000000', 'temperatura', 37.0000, 'ºC'),
	(285091, 122, '2014-04-01 00:50:04.000000', 'temperatura', 343.0000, 'ºC'),
	(285092, 122, '2014-04-01 00:50:05.000000', 'temperatura', 403.0000, 'ºC'),
	(285093, 122, '2014-04-01 00:50:06.000000', 'temperatura', 986.0000, 'ºC'),
	(285094, 122, '2014-04-01 00:50:07.000000', 'temperatura', 121.0000, 'ºC'),
	(285095, 122, '2014-04-01 00:50:08.000000', 'temperatura', 51.0000, 'ºC'),
	(285096, 122, '2014-04-01 00:50:09.000000', 'temperatura', 1089.0000, 'ºC'),
	(285097, 122, '2014-04-01 00:50:10.000000', 'temperatura', 493.0000, 'ºC'),
	(285098, 122, '2014-04-01 00:50:11.000000', 'temperatura', 398.0000, 'ºC'),
	(285099, 122, '2014-04-01 00:50:12.000000', 'temperatura', 510.0000, 'ºC'),
	(285100, 122, '2014-04-01 00:50:13.000000', 'temperatura', 160.0000, 'ºC'),
	(285101, 122, '2014-04-01 00:50:14.000000', 'temperatura', 470.0000, 'ºC'),
	(285102, 122, '2014-04-01 00:50:15.000000', 'temperatura', 669.0000, 'ºC'),
	(285103, 122, '2014-04-01 00:50:16.000000', 'temperatura', 737.0000, 'ºC'),
	(285104, 122, '2014-04-01 00:50:17.000000', 'temperatura', 476.0000, 'ºC'),
	(285105, 122, '2014-04-01 00:50:18.000000', 'temperatura', 172.0000, 'ºC'),
	(285106, 122, '2014-04-01 00:50:19.000000', 'temperatura', 630.0000, 'ºC'),
	(285107, 122, '2014-04-01 00:50:20.000000', 'temperatura', 234.0000, 'ºC'),
	(285108, 122, '2014-04-01 00:50:21.000000', 'temperatura', 481.0000, 'ºC'),
	(285109, 122, '2014-04-01 00:50:22.000000', 'temperatura', 503.0000, 'ºC'),
	(285110, 122, '2014-04-01 00:50:23.000000', 'temperatura', 1071.0000, 'ºC'),
	(285111, 122, '2014-04-01 00:50:24.000000', 'temperatura', 249.0000, 'ºC'),
	(285112, 122, '2014-04-01 00:50:25.000000', 'temperatura', 430.0000, 'ºC'),
	(285113, 122, '2014-04-01 00:50:26.000000', 'temperatura', 206.0000, 'ºC'),
	(285114, 122, '2014-04-01 00:50:27.000000', 'temperatura', 938.0000, 'ºC'),
	(285115, 122, '2014-04-01 00:50:28.000000', 'temperatura', 476.0000, 'ºC'),
	(285116, 122, '2014-04-01 00:50:29.000000', 'temperatura', 763.0000, 'ºC'),
	(285117, 122, '2014-04-01 00:50:30.000000', 'temperatura', 1191.0000, 'ºC'),
	(285118, 122, '2014-04-01 00:50:31.000000', 'temperatura', 63.0000, 'ºC'),
	(285119, 122, '2014-04-01 00:50:32.000000', 'temperatura', 346.0000, 'ºC'),
	(285120, 122, '2014-04-01 00:50:33.000000', 'temperatura', 338.0000, 'ºC'),
	(285121, 122, '2014-04-01 00:50:34.000000', 'temperatura', 655.0000, 'ºC'),
	(285122, 122, '2014-04-01 00:50:35.000000', 'temperatura', 1059.0000, 'ºC'),
	(285123, 122, '2014-04-01 00:50:36.000000', 'temperatura', 933.0000, 'ºC'),
	(285124, 122, '2014-04-01 00:50:37.000000', 'temperatura', 289.0000, 'ºC'),
	(285125, 122, '2014-04-01 00:50:38.000000', 'temperatura', 1044.0000, 'ºC'),
	(285126, 122, '2014-04-01 00:50:39.000000', 'temperatura', 754.0000, 'ºC'),
	(285127, 122, '2014-04-01 00:50:40.000000', 'temperatura', 638.0000, 'ºC'),
	(285128, 122, '2014-04-01 00:50:41.000000', 'temperatura', 930.0000, 'ºC'),
	(285129, 122, '2014-04-01 00:50:42.000000', 'temperatura', 336.0000, 'ºC'),
	(285130, 122, '2014-04-01 00:50:43.000000', 'temperatura', 92.0000, 'ºC'),
	(285131, 122, '2014-04-01 00:50:44.000000', 'temperatura', 650.0000, 'ºC'),
	(285132, 122, '2014-04-01 00:50:45.000000', 'temperatura', 576.0000, 'ºC'),
	(285133, 122, '2014-04-01 00:50:46.000000', 'temperatura', 930.0000, 'ºC'),
	(285134, 122, '2014-04-01 00:50:47.000000', 'temperatura', 521.0000, 'ºC'),
	(285135, 122, '2014-04-01 00:50:48.000000', 'temperatura', 1015.0000, 'ºC'),
	(285136, 122, '2014-04-01 00:50:49.000000', 'temperatura', 1115.0000, 'ºC'),
	(285137, 122, '2014-04-01 00:50:50.000000', 'temperatura', 128.0000, 'ºC'),
	(285138, 122, '2014-04-01 00:50:51.000000', 'temperatura', 897.0000, 'ºC'),
	(285139, 122, '2014-04-01 00:50:52.000000', 'temperatura', 499.0000, 'ºC'),
	(285140, 122, '2014-04-01 00:50:53.000000', 'temperatura', 1008.0000, 'ºC'),
	(285141, 122, '2014-04-01 00:50:54.000000', 'temperatura', 1140.0000, 'ºC'),
	(285142, 122, '2014-04-01 00:50:55.000000', 'temperatura', 279.0000, 'ºC'),
	(285143, 122, '2014-04-01 00:50:56.000000', 'temperatura', 376.0000, 'ºC'),
	(285144, 122, '2014-04-01 00:50:57.000000', 'temperatura', 1042.0000, 'ºC'),
	(285145, 122, '2014-04-01 00:50:58.000000', 'temperatura', 485.0000, 'ºC'),
	(285146, 122, '2014-04-01 00:50:59.000000', 'temperatura', 498.0000, 'ºC'),
	(285147, 122, '2014-04-01 00:51:00.000000', 'temperatura', 1035.0000, 'ºC'),
	(285148, 122, '2014-04-01 00:51:01.000000', 'temperatura', 82.0000, 'ºC'),
	(285149, 122, '2014-04-01 00:51:02.000000', 'temperatura', 905.0000, 'ºC'),
	(285150, 122, '2014-04-01 00:51:03.000000', 'temperatura', 682.0000, 'ºC'),
	(285151, 122, '2014-04-01 00:51:04.000000', 'temperatura', 692.0000, 'ºC'),
	(285152, 122, '2014-04-01 00:51:05.000000', 'temperatura', 216.0000, 'ºC'),
	(285153, 122, '2014-04-01 00:51:06.000000', 'temperatura', 202.0000, 'ºC'),
	(285154, 122, '2014-04-01 00:51:07.000000', 'temperatura', 366.0000, 'ºC'),
	(285155, 122, '2014-04-01 00:51:08.000000', 'temperatura', 21.0000, 'ºC'),
	(285156, 122, '2014-04-01 00:51:09.000000', 'temperatura', 210.0000, 'ºC'),
	(285157, 122, '2014-04-01 00:51:10.000000', 'temperatura', 988.0000, 'ºC'),
	(285158, 122, '2014-04-01 00:51:11.000000', 'temperatura', 710.0000, 'ºC'),
	(285159, 122, '2014-04-01 00:51:12.000000', 'temperatura', 586.0000, 'ºC'),
	(285160, 122, '2014-04-01 00:51:13.000000', 'temperatura', 801.0000, 'ºC'),
	(285161, 122, '2014-04-01 00:51:14.000000', 'temperatura', 1046.0000, 'ºC'),
	(285162, 122, '2014-04-01 00:51:15.000000', 'temperatura', 429.0000, 'ºC'),
	(285163, 122, '2014-04-01 00:51:16.000000', 'temperatura', 205.0000, 'ºC'),
	(285164, 122, '2014-04-01 00:51:17.000000', 'temperatura', 942.0000, 'ºC'),
	(285165, 122, '2014-04-01 00:51:18.000000', 'temperatura', 492.0000, 'ºC'),
	(285166, 122, '2014-04-01 00:51:19.000000', 'temperatura', 837.0000, 'ºC'),
	(285167, 122, '2014-04-01 00:51:20.000000', 'temperatura', 309.0000, 'ºC'),
	(285168, 122, '2014-04-01 00:51:21.000000', 'temperatura', 236.0000, 'ºC'),
	(285169, 122, '2014-04-01 00:51:22.000000', 'temperatura', 253.0000, 'ºC'),
	(285170, 122, '2014-04-01 00:51:23.000000', 'temperatura', 556.0000, 'ºC'),
	(285171, 122, '2014-04-01 00:51:24.000000', 'temperatura', 822.0000, 'ºC'),
	(285172, 122, '2014-04-01 00:51:25.000000', 'temperatura', 45.0000, 'ºC'),
	(285173, 122, '2014-04-01 00:51:26.000000', 'temperatura', 156.0000, 'ºC'),
	(285174, 122, '2014-04-01 00:51:27.000000', 'temperatura', 648.0000, 'ºC'),
	(285175, 122, '2014-04-01 00:51:28.000000', 'temperatura', 373.0000, 'ºC'),
	(285176, 122, '2014-04-01 00:51:29.000000', 'temperatura', 1121.0000, 'ºC'),
	(285177, 122, '2014-04-01 00:51:30.000000', 'temperatura', 887.0000, 'ºC'),
	(285178, 122, '2014-04-01 00:51:31.000000', 'temperatura', 1073.0000, 'ºC'),
	(285179, 122, '2014-04-01 00:51:32.000000', 'temperatura', 305.0000, 'ºC'),
	(285180, 122, '2014-04-01 00:51:33.000000', 'temperatura', 706.0000, 'ºC'),
	(285181, 122, '2014-04-01 00:51:34.000000', 'temperatura', 216.0000, 'ºC'),
	(285182, 122, '2014-04-01 00:51:35.000000', 'temperatura', 163.0000, 'ºC'),
	(285183, 122, '2014-04-01 00:51:36.000000', 'temperatura', 167.0000, 'ºC'),
	(285184, 122, '2014-04-01 00:51:37.000000', 'temperatura', 346.0000, 'ºC'),
	(285185, 122, '2014-04-01 00:51:38.000000', 'temperatura', 29.0000, 'ºC'),
	(285186, 122, '2014-04-01 00:51:39.000000', 'temperatura', 306.0000, 'ºC'),
	(285187, 122, '2014-04-01 00:51:40.000000', 'temperatura', 245.0000, 'ºC'),
	(285188, 122, '2014-04-01 00:51:41.000000', 'temperatura', 306.0000, 'ºC'),
	(285189, 122, '2014-04-01 00:51:42.000000', 'temperatura', 798.0000, 'ºC'),
	(285190, 122, '2014-04-01 00:51:43.000000', 'temperatura', 671.0000, 'ºC'),
	(285191, 122, '2014-04-01 00:51:44.000000', 'temperatura', 962.0000, 'ºC'),
	(285192, 122, '2014-04-01 00:51:45.000000', 'temperatura', 398.0000, 'ºC'),
	(285193, 122, '2014-04-01 00:51:46.000000', 'temperatura', 305.0000, 'ºC'),
	(285194, 122, '2014-04-01 00:51:47.000000', 'temperatura', 331.0000, 'ºC'),
	(285195, 122, '2014-04-01 00:51:48.000000', 'temperatura', 741.0000, 'ºC'),
	(285196, 122, '2014-04-01 00:51:49.000000', 'temperatura', 310.0000, 'ºC'),
	(285197, 122, '2014-04-01 00:51:50.000000', 'temperatura', 531.0000, 'ºC'),
	(285198, 122, '2014-04-01 00:51:51.000000', 'temperatura', 523.0000, 'ºC'),
	(285199, 122, '2014-04-01 00:51:52.000000', 'temperatura', 1023.0000, 'ºC'),
	(285200, 122, '2014-04-01 00:51:53.000000', 'temperatura', 1145.0000, 'ºC'),
	(285201, 122, '2014-04-01 00:51:54.000000', 'temperatura', 258.0000, 'ºC'),
	(285202, 122, '2014-04-01 00:51:55.000000', 'temperatura', 257.0000, 'ºC'),
	(285203, 122, '2014-04-01 00:51:56.000000', 'temperatura', 510.0000, 'ºC'),
	(285204, 122, '2014-04-01 00:51:57.000000', 'temperatura', 582.0000, 'ºC'),
	(285205, 122, '2014-04-01 00:51:58.000000', 'temperatura', 177.0000, 'ºC'),
	(285206, 122, '2014-04-01 00:51:59.000000', 'temperatura', 341.0000, 'ºC'),
	(285207, 122, '2014-04-01 00:52:00.000000', 'temperatura', 1173.0000, 'ºC'),
	(285208, 122, '2014-04-01 00:52:01.000000', 'temperatura', 41.0000, 'ºC'),
	(285209, 122, '2014-04-01 00:52:02.000000', 'temperatura', 290.0000, 'ºC'),
	(285210, 122, '2014-04-01 00:52:03.000000', 'temperatura', 127.0000, 'ºC'),
	(285211, 122, '2014-04-01 00:52:04.000000', 'temperatura', 966.0000, 'ºC'),
	(285212, 122, '2014-04-01 00:52:05.000000', 'temperatura', 848.0000, 'ºC'),
	(285213, 122, '2014-04-01 00:52:06.000000', 'temperatura', 144.0000, 'ºC'),
	(285214, 122, '2014-04-01 00:52:07.000000', 'temperatura', 577.0000, 'ºC'),
	(285215, 122, '2014-04-01 00:52:08.000000', 'temperatura', 53.0000, 'ºC'),
	(285216, 122, '2014-04-01 00:52:09.000000', 'temperatura', 934.0000, 'ºC'),
	(285217, 122, '2014-04-01 00:52:10.000000', 'temperatura', 911.0000, 'ºC'),
	(285218, 122, '2014-04-01 00:52:11.000000', 'temperatura', 556.0000, 'ºC'),
	(285219, 122, '2014-04-01 00:52:12.000000', 'temperatura', 47.0000, 'ºC'),
	(285220, 122, '2014-04-01 00:52:13.000000', 'temperatura', 965.0000, 'ºC'),
	(285221, 122, '2014-04-01 00:52:14.000000', 'temperatura', 1087.0000, 'ºC'),
	(285222, 122, '2014-04-01 00:52:15.000000', 'temperatura', 138.0000, 'ºC'),
	(285223, 122, '2014-04-01 00:52:16.000000', 'temperatura', 1029.0000, 'ºC'),
	(285224, 122, '2014-04-01 00:52:17.000000', 'temperatura', 1131.0000, 'ºC'),
	(285225, 122, '2014-04-01 00:52:18.000000', 'temperatura', 171.0000, 'ºC'),
	(285226, 122, '2014-04-01 00:52:19.000000', 'temperatura', 1062.0000, 'ºC'),
	(285227, 122, '2014-04-01 00:52:20.000000', 'temperatura', 1198.0000, 'ºC'),
	(285228, 122, '2014-04-01 00:52:21.000000', 'temperatura', 403.0000, 'ºC'),
	(285229, 122, '2014-04-01 00:52:22.000000', 'temperatura', 821.0000, 'ºC'),
	(285230, 122, '2014-04-01 00:52:23.000000', 'temperatura', 496.0000, 'ºC'),
	(285231, 122, '2014-04-01 00:52:24.000000', 'temperatura', 17.0000, 'ºC'),
	(285232, 122, '2014-04-01 00:52:25.000000', 'temperatura', 998.0000, 'ºC'),
	(285233, 122, '2014-04-01 00:52:26.000000', 'temperatura', 139.0000, 'ºC'),
	(285234, 122, '2014-04-01 00:52:27.000000', 'temperatura', 102.0000, 'ºC'),
	(285235, 122, '2014-04-01 00:52:28.000000', 'temperatura', 92.0000, 'ºC'),
	(285236, 122, '2014-04-01 00:52:29.000000', 'temperatura', 154.0000, 'ºC'),
	(285237, 122, '2014-04-01 00:52:30.000000', 'temperatura', 494.0000, 'ºC'),
	(285238, 122, '2014-04-01 00:52:31.000000', 'temperatura', 808.0000, 'ºC'),
	(285239, 122, '2014-04-01 00:52:32.000000', 'temperatura', 158.0000, 'ºC'),
	(285240, 122, '2014-04-01 00:52:33.000000', 'temperatura', 766.0000, 'ºC'),
	(285241, 122, '2014-04-01 00:52:34.000000', 'temperatura', 957.0000, 'ºC'),
	(285242, 122, '2014-04-01 00:52:35.000000', 'temperatura', 86.0000, 'ºC'),
	(285243, 122, '2014-04-01 00:52:36.000000', 'temperatura', 1161.0000, 'ºC'),
	(285244, 122, '2014-04-01 00:52:37.000000', 'temperatura', 749.0000, 'ºC'),
	(285245, 122, '2014-04-01 00:52:38.000000', 'temperatura', 264.0000, 'ºC'),
	(285246, 122, '2014-04-01 00:52:39.000000', 'temperatura', 270.0000, 'ºC'),
	(285247, 122, '2014-04-01 00:52:40.000000', 'temperatura', 558.0000, 'ºC'),
	(285248, 122, '2014-04-01 00:52:41.000000', 'temperatura', 781.0000, 'ºC'),
	(285249, 122, '2014-04-01 00:52:42.000000', 'temperatura', 1033.0000, 'ºC'),
	(285250, 122, '2014-04-01 00:52:43.000000', 'temperatura', 420.0000, 'ºC'),
	(285251, 122, '2014-04-01 00:52:44.000000', 'temperatura', 201.0000, 'ºC'),
	(285252, 122, '2014-04-01 00:52:45.000000', 'temperatura', 948.0000, 'ºC'),
	(285253, 122, '2014-04-01 00:52:46.000000', 'temperatura', 536.0000, 'ºC'),
	(285254, 122, '2014-04-01 00:52:47.000000', 'temperatura', 1036.0000, 'ºC'),
	(285255, 122, '2014-04-01 00:52:48.000000', 'temperatura', 1171.0000, 'ºC'),
	(285256, 122, '2014-04-01 00:52:49.000000', 'temperatura', 350.0000, 'ºC'),
	(285257, 122, '2014-04-01 00:52:50.000000', 'temperatura', 638.0000, 'ºC'),
	(285258, 122, '2014-04-01 00:52:51.000000', 'temperatura', 939.0000, 'ºC'),
	(285259, 122, '2014-04-01 00:52:52.000000', 'temperatura', 383.0000, 'ºC'),
	(285260, 122, '2014-04-01 00:52:53.000000', 'temperatura', 298.0000, 'ºC'),
	(285261, 122, '2014-04-01 00:52:54.000000', 'temperatura', 343.0000, 'ºC'),
	(285262, 122, '2014-04-01 00:52:55.000000', 'temperatura', 821.0000, 'ºC'),
	(285263, 122, '2014-04-01 00:52:56.000000', 'temperatura', 677.0000, 'ºC'),
	(285264, 122, '2014-04-01 00:52:57.000000', 'temperatura', 920.0000, 'ºC'),
	(285265, 122, '2014-04-01 00:52:58.000000', 'temperatura', 170.0000, 'ºC'),
	(285266, 122, '2014-04-01 00:52:59.000000', 'temperatura', 490.0000, 'ºC'),
	(285267, 122, '2014-04-01 00:53:00.000000', 'temperatura', 741.0000, 'ºC'),
	(285268, 122, '2014-04-01 00:53:01.000000', 'temperatura', 1036.0000, 'ºC'),
	(285269, 122, '2014-04-01 00:53:02.000000', 'temperatura', 558.0000, 'ºC'),
	(285270, 122, '2014-04-01 00:53:03.000000', 'temperatura', 882.0000, 'ºC'),
	(285271, 122, '2014-04-01 00:53:04.000000', 'temperatura', 338.0000, 'ºC'),
	(285272, 122, '2014-04-01 00:53:05.000000', 'temperatura', 245.0000, 'ºC'),
	(285273, 122, '2014-04-01 00:53:06.000000', 'temperatura', 209.0000, 'ºC'),
	(285274, 122, '2014-04-01 00:53:07.000000', 'temperatura', 312.0000, 'ºC'),
	(285275, 122, '2014-04-01 00:53:08.000000', 'temperatura', 932.0000, 'ºC'),
	(285276, 122, '2014-04-01 00:53:09.000000', 'temperatura', 123.0000, 'ºC'),
	(285277, 122, '2014-04-01 00:53:10.000000', 'temperatura', 222.0000, 'ºC'),
	(285278, 122, '2014-04-01 00:53:11.000000', 'temperatura', 742.0000, 'ºC'),
	(285279, 122, '2014-04-01 00:53:12.000000', 'temperatura', 646.0000, 'ºC'),
	(285280, 122, '2014-04-01 00:53:13.000000', 'temperatura', 1001.0000, 'ºC'),
	(285281, 122, '2014-04-01 00:53:14.000000', 'temperatura', 668.0000, 'ºC'),
	(285282, 122, '2014-04-01 00:53:15.000000', 'temperatura', 339.0000, 'ºC'),
	(285283, 122, '2014-04-01 00:53:16.000000', 'temperatura', 892.0000, 'ºC'),
	(285284, 122, '2014-04-01 00:53:17.000000', 'temperatura', 1043.0000, 'ºC'),
	(285285, 122, '2014-04-01 00:53:18.000000', 'temperatura', 140.0000, 'ºC'),
	(285286, 122, '2014-04-01 00:53:19.000000', 'temperatura', 1169.0000, 'ºC'),
	(285287, 122, '2014-04-01 00:53:20.000000', 'temperatura', 627.0000, 'ºC'),
	(285288, 122, '2014-04-01 00:53:21.000000', 'temperatura', 830.0000, 'ºC'),
	(285289, 122, '2014-04-01 00:53:22.000000', 'temperatura', 1070.0000, 'ºC'),
	(285290, 122, '2014-04-01 00:53:23.000000', 'temperatura', 461.0000, 'ºC'),
	(285291, 122, '2014-04-01 00:53:24.000000', 'temperatura', 295.0000, 'ºC'),
	(285292, 122, '2014-04-01 00:53:25.000000', 'temperatura', 93.0000, 'ºC'),
	(285293, 122, '2014-04-01 00:53:26.000000', 'temperatura', 781.0000, 'ºC'),
	(285294, 122, '2014-04-01 00:53:27.000000', 'temperatura', 28.0000, 'ºC'),
	(285295, 122, '2014-04-01 00:53:28.000000', 'temperatura', 195.0000, 'ºC'),
	(285296, 122, '2014-04-01 00:53:29.000000', 'temperatura', 892.0000, 'ºC'),
	(285297, 122, '2014-04-01 00:53:30.000000', 'temperatura', 274.0000, 'ºC'),
	(285298, 122, '2014-04-01 00:53:31.000000', 'temperatura', 1094.0000, 'ºC'),
	(285299, 122, '2014-04-01 00:53:32.000000', 'temperatura', 1049.0000, 'ºC'),
	(285300, 122, '2014-04-01 00:53:33.000000', 'temperatura', 764.0000, 'ºC'),
	(285301, 122, '2014-04-01 00:53:34.000000', 'temperatura', 672.0000, 'ºC'),
	(285302, 122, '2014-04-01 00:53:35.000000', 'temperatura', 1071.0000, 'ºC'),
	(285303, 122, '2014-04-01 00:53:36.000000', 'temperatura', 937.0000, 'ºC'),
	(285304, 122, '2014-04-01 00:53:37.000000', 'temperatura', 275.0000, 'ºC'),
	(285305, 122, '2014-04-01 00:53:38.000000', 'temperatura', 965.0000, 'ºC'),
	(285306, 122, '2014-04-01 00:53:39.000000', 'temperatura', 398.0000, 'ºC'),
	(285307, 122, '2014-04-01 00:53:40.000000', 'temperatura', 298.0000, 'ºC'),
	(285308, 122, '2014-04-01 00:53:41.000000', 'temperatura', 297.0000, 'ºC'),
	(285309, 122, '2014-04-01 00:53:42.000000', 'temperatura', 591.0000, 'ºC'),
	(285310, 122, '2014-04-01 00:53:43.000000', 'temperatura', 864.0000, 'ºC'),
	(285311, 122, '2014-04-01 00:53:44.000000', 'temperatura', 146.0000, 'ºC'),
	(285312, 122, '2014-04-01 00:53:45.000000', 'temperatura', 541.0000, 'ºC'),
	(285313, 122, '2014-04-01 00:53:46.000000', 'temperatura', 1068.0000, 'ºC'),
	(285314, 122, '2014-04-01 00:53:47.000000', 'temperatura', 117.0000, 'ºC'),
	(285315, 122, '2014-04-01 00:53:48.000000', 'temperatura', 981.0000, 'ºC'),
	(285316, 122, '2014-04-01 00:53:49.000000', 'temperatura', 955.0000, 'ºC'),
	(285317, 122, '2014-04-01 00:53:50.000000', 'temperatura', 633.0000, 'ºC'),
	(285318, 122, '2014-04-01 00:53:51.000000', 'temperatura', 299.0000, 'ºC'),
	(285319, 122, '2014-04-01 00:53:52.000000', 'temperatura', 798.0000, 'ºC'),
	(285320, 122, '2014-04-01 00:53:53.000000', 'temperatura', 694.0000, 'ºC'),
	(285321, 122, '2014-04-01 00:53:54.000000', 'temperatura', 1076.0000, 'ºC'),
	(285322, 122, '2014-04-01 00:53:55.000000', 'temperatura', 897.0000, 'ºC'),
	(285323, 122, '2014-04-01 00:53:56.000000', 'temperatura', 57.0000, 'ºC'),
	(285324, 122, '2014-04-01 00:53:57.000000', 'temperatura', 1197.0000, 'ºC'),
	(285325, 122, '2014-04-01 00:53:58.000000', 'temperatura', 1013.0000, 'ºC'),
	(285326, 122, '2014-04-01 00:53:59.000000', 'temperatura', 273.0000, 'ºC'),
	(285327, 122, '2014-04-01 00:54:00.000000', 'temperatura', 729.0000, 'ºC'),
	(285328, 122, '2014-04-01 00:54:01.000000', 'temperatura', 427.0000, 'ºC'),
	(285329, 122, '2014-04-01 00:54:02.000000', 'temperatura', 1146.0000, 'ºC'),
	(285330, 122, '2014-04-01 00:54:03.000000', 'temperatura', 852.0000, 'ºC'),
	(285331, 122, '2014-04-01 00:54:04.000000', 'temperatura', 820.0000, 'ºC'),
	(285332, 122, '2014-04-01 00:54:05.000000', 'temperatura', 346.0000, 'ºC'),
	(285333, 122, '2014-04-01 00:54:06.000000', 'temperatura', 470.0000, 'ºC'),
	(285334, 122, '2014-04-01 00:54:07.000000', 'temperatura', 111.0000, 'ºC'),
	(285335, 122, '2014-04-01 00:54:08.000000', 'temperatura', 348.0000, 'ºC'),
	(285336, 122, '2014-04-01 00:54:09.000000', 'temperatura', 208.0000, 'ºC'),
	(285337, 122, '2014-04-01 00:54:10.000000', 'temperatura', 1194.0000, 'ºC'),
	(285338, 122, '2014-04-01 00:54:11.000000', 'temperatura', 547.0000, 'ºC'),
	(285339, 122, '2014-04-01 00:54:12.000000', 'temperatura', 353.0000, 'ºC'),
	(285340, 122, '2014-04-01 00:54:13.000000', 'temperatura', 124.0000, 'ºC'),
	(285341, 122, '2014-04-01 00:54:14.000000', 'temperatura', 762.0000, 'ºC'),
	(285342, 122, '2014-04-01 00:54:15.000000', 'temperatura', 1037.0000, 'ºC'),
	(285343, 122, '2014-04-01 00:54:16.000000', 'temperatura', 502.0000, 'ºC'),
	(285344, 122, '2014-04-01 00:54:17.000000', 'temperatura', 599.0000, 'ºC'),
	(285345, 122, '2014-04-01 00:54:18.000000', 'temperatura', 289.0000, 'ºC'),
	(285346, 122, '2014-04-01 00:54:19.000000', 'temperatura', 850.0000, 'ºC'),
	(285347, 122, '2014-04-01 00:54:20.000000', 'temperatura', 983.0000, 'ºC'),
	(285348, 122, '2014-04-01 00:54:21.000000', 'temperatura', 1166.0000, 'ºC'),
	(285349, 122, '2014-04-01 00:54:22.000000', 'temperatura', 482.0000, 'ºC'),
	(285350, 122, '2014-04-01 00:54:23.000000', 'temperatura', 112.0000, 'ºC'),
	(285351, 122, '2014-04-01 00:54:24.000000', 'temperatura', 316.0000, 'ºC'),
	(285352, 122, '2014-04-01 00:54:25.000000', 'temperatura', 44.0000, 'ºC'),
	(285353, 122, '2014-04-01 00:54:26.000000', 'temperatura', 471.0000, 'ºC'),
	(285354, 122, '2014-04-01 00:54:27.000000', 'temperatura', 1024.0000, 'ºC'),
	(285355, 122, '2014-04-01 00:54:28.000000', 'temperatura', 109.0000, 'ºC'),
	(285356, 122, '2014-04-01 00:54:29.000000', 'temperatura', 1073.0000, 'ºC'),
	(285357, 122, '2014-04-01 00:54:30.000000', 'temperatura', 238.0000, 'ºC'),
	(285358, 122, '2014-04-01 00:54:31.000000', 'temperatura', 372.0000, 'ºC'),
	(285359, 122, '2014-04-01 00:54:32.000000', 'temperatura', 1145.0000, 'ºC'),
	(285360, 122, '2014-04-01 00:54:33.000000', 'temperatura', 1009.0000, 'ºC'),
	(285361, 122, '2014-04-01 00:54:34.000000', 'temperatura', 413.0000, 'ºC'),
	(285362, 122, '2014-04-01 00:54:35.000000', 'temperatura', 240.0000, 'ºC'),
	(285363, 122, '2014-04-01 00:54:36.000000', 'temperatura', 1158.0000, 'ºC'),
	(285364, 122, '2014-04-01 00:54:37.000000', 'temperatura', 271.0000, 'ºC'),
	(285365, 122, '2014-04-01 00:54:38.000000', 'temperatura', 280.0000, 'ºC'),
	(285366, 122, '2014-04-01 00:54:39.000000', 'temperatura', 589.0000, 'ºC'),
	(285367, 122, '2014-04-01 00:54:40.000000', 'temperatura', 904.0000, 'ºC'),
	(285368, 122, '2014-04-01 00:54:41.000000', 'temperatura', 355.0000, 'ºC'),
	(285369, 122, '2014-04-01 00:54:42.000000', 'temperatura', 261.0000, 'ºC'),
	(285370, 122, '2014-04-01 00:54:43.000000', 'temperatura', 243.0000, 'ºC'),
	(285371, 122, '2014-04-01 00:54:44.000000', 'temperatura', 430.0000, 'ºC'),
	(285372, 122, '2014-04-01 00:54:45.000000', 'temperatura', 222.0000, 'ºC'),
	(285373, 122, '2014-04-01 00:54:46.000000', 'temperatura', 1020.0000, 'ºC'),
	(285374, 122, '2014-04-01 00:54:47.000000', 'temperatura', 836.0000, 'ºC'),
	(285375, 122, '2014-04-01 00:54:48.000000', 'temperatura', 1122.0000, 'ºC'),
	(285376, 122, '2014-04-01 00:54:49.000000', 'temperatura', 700.0000, 'ºC'),
	(285377, 122, '2014-04-01 00:54:50.000000', 'temperatura', 134.0000, 'ºC'),
	(285378, 122, '2014-04-01 00:54:51.000000', 'temperatura', 973.0000, 'ºC'),
	(285379, 122, '2014-04-01 00:54:52.000000', 'temperatura', 864.0000, 'ºC'),
	(285380, 122, '2014-04-01 00:54:53.000000', 'temperatura', 202.0000, 'ºC'),
	(285381, 122, '2014-04-01 00:54:54.000000', 'temperatura', 816.0000, 'ºC'),
	(285382, 122, '2014-04-01 00:54:55.000000', 'temperatura', 1075.0000, 'ºC'),
	(285383, 122, '2014-04-01 00:54:56.000000', 'temperatura', 527.0000, 'ºC'),
	(285384, 122, '2014-04-01 00:54:57.000000', 'temperatura', 610.0000, 'ºC'),
	(285385, 122, '2014-04-01 00:54:58.000000', 'temperatura', 269.0000, 'ºC'),
	(285386, 122, '2014-04-01 00:54:59.000000', 'temperatura', 717.0000, 'ºC'),
	(285387, 122, '2014-04-01 00:55:00.000000', 'temperatura', 378.0000, 'ºC'),
	(285388, 122, '2014-04-01 00:55:01.000000', 'temperatura', 940.0000, 'ºC'),
	(285389, 122, '2014-04-01 00:55:02.000000', 'temperatura', 1166.0000, 'ºC'),
	(285390, 122, '2014-04-01 00:55:03.000000', 'temperatura', 609.0000, 'ºC'),
	(285391, 122, '2014-04-01 00:55:04.000000', 'temperatura', 747.0000, 'ºC'),
	(285392, 122, '2014-04-01 00:55:05.000000', 'temperatura', 709.0000, 'ºC'),
	(285393, 122, '2014-04-01 00:55:06.000000', 'temperatura', 106.0000, 'ºC'),
	(285394, 122, '2014-04-01 00:55:07.000000', 'temperatura', 803.0000, 'ºC'),
	(285395, 122, '2014-04-01 00:55:08.000000', 'temperatura', 95.0000, 'ºC'),
	(285396, 122, '2014-04-01 00:55:09.000000', 'temperatura', 470.0000, 'ºC'),
	(285397, 122, '2014-04-01 00:55:10.000000', 'temperatura', 863.0000, 'ºC'),
	(285398, 122, '2014-04-01 00:55:11.000000', 'temperatura', 508.0000, 'ºC'),
	(285399, 122, '2014-04-01 00:55:12.000000', 'temperatura', 1149.0000, 'ºC'),
	(285400, 122, '2014-04-01 00:55:13.000000', 'temperatura', 624.0000, 'ºC'),
	(285401, 122, '2014-04-01 00:55:14.000000', 'temperatura', 871.0000, 'ºC'),
	(285402, 122, '2014-04-01 00:55:15.000000', 'temperatura', 87.0000, 'ºC'),
	(285403, 122, '2014-04-01 00:55:16.000000', 'temperatura', 219.0000, 'ºC'),
	(285404, 122, '2014-04-01 00:55:17.000000', 'temperatura', 835.0000, 'ºC'),
	(285405, 122, '2014-04-01 00:55:18.000000', 'temperatura', 1119.0000, 'ºC'),
	(285406, 122, '2014-04-01 00:55:19.000000', 'temperatura', 690.0000, 'ºC'),
	(285407, 122, '2014-04-01 00:55:20.000000', 'temperatura', 94.0000, 'ºC'),
	(285408, 122, '2014-04-01 00:55:21.000000', 'temperatura', 802.0000, 'ºC'),
	(285409, 122, '2014-04-01 00:55:22.000000', 'temperatura', 129.0000, 'ºC'),
	(285410, 122, '2014-04-01 00:55:23.000000', 'temperatura', 638.0000, 'ºC'),
	(285411, 122, '2014-04-01 00:55:24.000000', 'temperatura', 404.0000, 'ºC'),
	(285412, 122, '2014-04-01 00:55:25.000000', 'temperatura', 107.0000, 'ºC'),
	(285413, 122, '2014-04-01 00:55:26.000000', 'temperatura', 524.0000, 'ºC'),
	(285414, 122, '2014-04-01 00:55:27.000000', 'temperatura', 1097.0000, 'ºC'),
	(285415, 122, '2014-04-01 00:55:28.000000', 'temperatura', 315.0000, 'ºC'),
	(285416, 122, '2014-04-01 00:55:29.000000', 'temperatura', 685.0000, 'ºC'),
	(285417, 122, '2014-04-01 00:55:30.000000', 'temperatura', 79.0000, 'ºC'),
	(285418, 122, '2014-04-01 00:55:31.000000', 'temperatura', 742.0000, 'ºC'),
	(285419, 122, '2014-04-01 00:55:32.000000', 'temperatura', 1074.0000, 'ºC'),
	(285420, 122, '2014-04-01 00:55:33.000000', 'temperatura', 746.0000, 'ºC'),
	(285421, 122, '2014-04-01 00:55:34.000000', 'temperatura', 505.0000, 'ºC'),
	(285422, 122, '2014-04-01 00:55:35.000000', 'temperatura', 289.0000, 'ºC'),
	(285423, 122, '2014-04-01 00:55:36.000000', 'temperatura', 1130.0000, 'ºC'),
	(285424, 122, '2014-04-01 00:55:37.000000', 'temperatura', 1186.0000, 'ºC'),
	(285425, 122, '2014-04-01 00:55:38.000000', 'temperatura', 137.0000, 'ºC'),
	(285426, 122, '2014-04-01 00:55:39.000000', 'temperatura', 731.0000, 'ºC'),
	(285427, 122, '2014-04-01 00:55:40.000000', 'temperatura', 841.0000, 'ºC'),
	(285428, 122, '2014-04-01 00:55:41.000000', 'temperatura', 814.0000, 'ºC'),
	(285429, 122, '2014-04-01 00:55:42.000000', 'temperatura', 348.0000, 'ºC'),
	(285430, 122, '2014-04-01 00:55:43.000000', 'temperatura', 497.0000, 'ºC'),
	(285431, 122, '2014-04-01 00:55:44.000000', 'temperatura', 243.0000, 'ºC'),
	(285432, 122, '2014-04-01 00:55:45.000000', 'temperatura', 924.0000, 'ºC'),
	(285433, 122, '2014-04-01 00:55:46.000000', 'temperatura', 289.0000, 'ºC'),
	(285434, 122, '2014-04-01 00:55:47.000000', 'temperatura', 1077.0000, 'ºC'),
	(285435, 122, '2014-04-01 00:55:48.000000', 'temperatura', 917.0000, 'ºC'),
	(285436, 122, '2014-04-01 00:55:49.000000', 'temperatura', 156.0000, 'ºC'),
	(285437, 122, '2014-04-01 00:55:50.000000', 'temperatura', 427.0000, 'ºC'),
	(285438, 122, '2014-04-01 00:55:51.000000', 'temperatura', 470.0000, 'ºC'),
	(285439, 122, '2014-04-01 00:55:52.000000', 'temperatura', 1069.0000, 'ºC'),
	(285440, 122, '2014-04-01 00:55:53.000000', 'temperatura', 336.0000, 'ºC'),
	(285441, 122, '2014-04-01 00:55:54.000000', 'temperatura', 871.0000, 'ºC'),
	(285442, 122, '2014-04-01 00:55:55.000000', 'temperatura', 951.0000, 'ºC'),
	(285443, 122, '2014-04-01 00:55:56.000000', 'temperatura', 940.0000, 'ºC'),
	(285444, 122, '2014-04-01 00:55:57.000000', 'temperatura', 646.0000, 'ºC'),
	(285445, 122, '2014-04-01 00:55:58.000000', 'temperatura', 414.0000, 'ºC'),
	(285446, 122, '2014-04-01 00:55:59.000000', 'temperatura', 129.0000, 'ºC'),
	(285447, 122, '2014-04-01 00:56:00.000000', 'temperatura', 605.0000, 'ºC'),
	(285448, 122, '2014-04-01 00:56:01.000000', 'temperatura', 240.0000, 'ºC'),
	(285449, 122, '2014-04-01 00:56:02.000000', 'temperatura', 584.0000, 'ºC'),
	(285450, 122, '2014-04-01 00:56:03.000000', 'temperatura', 999.0000, 'ºC'),
	(285451, 122, '2014-04-01 00:56:04.000000', 'temperatura', 846.0000, 'ºC'),
	(285452, 122, '2014-04-01 00:56:05.000000', 'temperatura', 33.0000, 'ºC'),
	(285453, 122, '2014-04-01 00:56:06.000000', 'temperatura', 28.0000, 'ºC'),
	(285454, 122, '2014-04-01 00:56:07.000000', 'temperatura', 41.0000, 'ºC'),
	(285455, 122, '2014-04-01 00:56:08.000000', 'temperatura', 121.0000, 'ºC'),
	(285456, 122, '2014-04-01 00:56:09.000000', 'temperatura', 482.0000, 'ºC'),
	(285457, 122, '2014-04-01 00:56:10.000000', 'temperatura', 847.0000, 'ºC'),
	(285458, 122, '2014-04-01 00:56:11.000000', 'temperatura', 392.0000, 'ºC'),
	(285459, 122, '2014-04-01 00:56:12.000000', 'temperatura', 616.0000, 'ºC'),
	(285460, 122, '2014-04-01 00:56:13.000000', 'temperatura', 708.0000, 'ºC'),
	(285461, 122, '2014-04-01 00:56:14.000000', 'temperatura', 491.0000, 'ºC'),
	(285462, 122, '2014-04-01 00:56:15.000000', 'temperatura', 332.0000, 'ºC'),
	(285463, 122, '2014-04-01 00:56:16.000000', 'temperatura', 187.0000, 'ºC'),
	(285464, 122, '2014-04-01 00:56:17.000000', 'temperatura', 1138.0000, 'ºC'),
	(285465, 122, '2014-04-01 00:56:18.000000', 'temperatura', 332.0000, 'ºC'),
	(285466, 122, '2014-04-01 00:56:19.000000', 'temperatura', 647.0000, 'ºC'),
	(285467, 122, '2014-04-01 00:56:20.000000', 'temperatura', 1039.0000, 'ºC'),
	(285468, 122, '2014-04-01 00:56:21.000000', 'temperatura', 855.0000, 'ºC'),
	(285469, 122, '2014-04-01 00:56:22.000000', 'temperatura', 1157.0000, 'ºC'),
	(285470, 122, '2014-04-01 00:56:23.000000', 'temperatura', 820.0000, 'ºC'),
	(285471, 122, '2014-04-01 00:56:24.000000', 'temperatura', 631.0000, 'ºC'),
	(285472, 122, '2014-04-01 00:56:25.000000', 'temperatura', 695.0000, 'ºC'),
	(285473, 122, '2014-04-01 00:56:26.000000', 'temperatura', 382.0000, 'ºC'),
	(285474, 122, '2014-04-01 00:56:27.000000', 'temperatura', 1026.0000, 'ºC'),
	(285475, 122, '2014-04-01 00:56:28.000000', 'temperatura', 384.0000, 'ºC'),
	(285476, 122, '2014-04-01 00:56:29.000000', 'temperatura', 42.0000, 'ºC'),
	(285477, 122, '2014-04-01 00:56:30.000000', 'temperatura', 259.0000, 'ºC'),
	(285478, 122, '2014-04-01 00:56:31.000000', 'temperatura', 1171.0000, 'ºC'),
	(285479, 122, '2014-04-01 00:56:32.000000', 'temperatura', 279.0000, 'ºC'),
	(285480, 122, '2014-04-01 00:56:33.000000', 'temperatura', 282.0000, 'ºC'),
	(285481, 122, '2014-04-01 00:56:34.000000', 'temperatura', 574.0000, 'ºC'),
	(285482, 122, '2014-04-01 00:56:35.000000', 'temperatura', 826.0000, 'ºC'),
	(285483, 122, '2014-04-01 00:56:36.000000', 'temperatura', 6.0000, 'ºC'),
	(285484, 122, '2014-04-01 00:56:37.000000', 'temperatura', 1154.0000, 'ºC'),
	(285485, 122, '2014-04-01 00:56:38.000000', 'temperatura', 953.0000, 'ºC'),
	(285486, 122, '2014-04-01 00:56:39.000000', 'temperatura', 102.0000, 'ºC'),
	(285487, 122, '2014-04-01 00:56:40.000000', 'temperatura', 53.0000, 'ºC'),
	(285488, 122, '2014-04-01 00:56:41.000000', 'temperatura', 1158.0000, 'ºC'),
	(285489, 122, '2014-04-01 00:56:42.000000', 'temperatura', 833.0000, 'ºC'),
	(285490, 122, '2014-04-01 00:56:43.000000', 'temperatura', 689.0000, 'ºC'),
	(285491, 122, '2014-04-01 00:56:44.000000', 'temperatura', 950.0000, 'ºC'),
	(285492, 122, '2014-04-01 00:56:45.000000', 'temperatura', 280.0000, 'ºC'),
	(285493, 122, '2014-04-01 00:56:46.000000', 'temperatura', 952.0000, 'ºC'),
	(285494, 122, '2014-04-01 00:56:47.000000', 'temperatura', 320.0000, 'ºC'),
	(285495, 122, '2014-04-01 00:56:48.000000', 'temperatura', 1145.0000, 'ºC'),
	(285496, 122, '2014-04-01 00:56:49.000000', 'temperatura', 1166.0000, 'ºC'),
	(285497, 122, '2014-04-01 00:56:50.000000', 'temperatura', 1193.0000, 'ºC'),
	(285498, 122, '2014-04-01 00:56:51.000000', 'temperatura', 71.0000, 'ºC'),
	(285499, 122, '2014-04-01 00:56:52.000000', 'temperatura', 374.0000, 'ºC'),
	(285500, 122, '2014-04-01 00:56:53.000000', 'temperatura', 457.0000, 'ºC'),
	(285501, 122, '2014-04-01 00:56:54.000000', 'temperatura', 1166.0000, 'ºC'),
	(285502, 122, '2014-04-01 00:56:55.000000', 'temperatura', 860.0000, 'ºC'),
	(285503, 122, '2014-04-01 00:56:56.000000', 'temperatura', 800.0000, 'ºC'),
	(285504, 122, '2014-04-01 00:56:57.000000', 'temperatura', 220.0000, 'ºC'),
	(285505, 122, '2014-04-01 00:56:58.000000', 'temperatura', 1101.0000, 'ºC'),
	(285506, 122, '2014-04-01 00:56:59.000000', 'temperatura', 46.0000, 'ºC'),
	(285507, 122, '2014-04-01 00:57:00.000000', 'temperatura', 526.0000, 'ºC'),
	(285508, 122, '2014-04-01 00:57:01.000000', 'temperatura', 93.0000, 'ºC'),
	(285509, 122, '2014-04-01 00:57:02.000000', 'temperatura', 87.0000, 'ºC'),
	(285510, 122, '2014-04-01 00:57:03.000000', 'temperatura', 159.0000, 'ºC'),
	(285511, 122, '2014-04-01 00:57:04.000000', 'temperatura', 533.0000, 'ºC'),
	(285512, 122, '2014-04-01 00:57:05.000000', 'temperatura', 991.0000, 'ºC'),
	(285513, 122, '2014-04-01 00:57:06.000000', 'temperatura', 953.0000, 'ºC'),
	(285514, 122, '2014-04-01 00:57:07.000000', 'temperatura', 594.0000, 'ºC'),
	(285515, 122, '2014-04-01 00:57:08.000000', 'temperatura', 113.0000, 'ºC'),
	(285516, 122, '2014-04-01 00:57:09.000000', 'temperatura', 1184.0000, 'ºC'),
	(285517, 122, '2014-04-01 00:57:10.000000', 'temperatura', 782.0000, 'ºC'),
	(285518, 122, '2014-04-01 00:57:11.000000', 'temperatura', 357.0000, 'ºC'),
	(285519, 122, '2014-04-01 00:57:12.000000', 'temperatura', 642.0000, 'ºC'),
	(285520, 122, '2014-04-01 00:57:13.000000', 'temperatura', 936.0000, 'ºC'),
	(285521, 122, '2014-04-01 00:57:14.000000', 'temperatura', 356.0000, 'ºC'),
	(285522, 122, '2014-04-01 00:57:15.000000', 'temperatura', 172.0000, 'ºC'),
	(285523, 122, '2014-04-01 00:57:16.000000', 'temperatura', 992.0000, 'ºC'),
	(285524, 122, '2014-04-01 00:57:17.000000', 'temperatura', 846.0000, 'ºC'),
	(285525, 122, '2014-04-01 00:57:18.000000', 'temperatura', 52.0000, 'ºC'),
	(285526, 122, '2014-04-01 00:57:19.000000', 'temperatura', 125.0000, 'ºC'),
	(285527, 122, '2014-04-01 00:57:20.000000', 'temperatura', 470.0000, 'ºC'),
	(285528, 122, '2014-04-01 00:57:21.000000', 'temperatura', 774.0000, 'ºC'),
	(285529, 122, '2014-04-01 00:57:22.000000', 'temperatura', 61.0000, 'ºC'),
	(285530, 122, '2014-04-01 00:57:23.000000', 'temperatura', 382.0000, 'ºC'),
	(285531, 122, '2014-04-01 00:57:24.000000', 'temperatura', 530.0000, 'ºC'),
	(285532, 122, '2014-04-01 00:57:25.000000', 'temperatura', 302.0000, 'ºC'),
	(285533, 122, '2014-04-01 00:57:26.000000', 'temperatura', 1123.0000, 'ºC'),
	(285534, 122, '2014-04-01 00:57:27.000000', 'temperatura', 1109.0000, 'ºC'),
	(285535, 122, '2014-04-01 00:57:28.000000', 'temperatura', 975.0000, 'ºC'),
	(285536, 122, '2014-04-01 00:57:29.000000', 'temperatura', 348.0000, 'ºC'),
	(285537, 122, '2014-04-01 00:57:30.000000', 'temperatura', 18.0000, 'ºC'),
	(285538, 122, '2014-04-01 00:57:31.000000', 'temperatura', 244.0000, 'ºC'),
	(285539, 122, '2014-04-01 00:57:32.000000', 'temperatura', 1166.0000, 'ºC'),
	(285540, 122, '2014-04-01 00:57:33.000000', 'temperatura', 299.0000, 'ºC'),
	(285541, 122, '2014-04-01 00:57:34.000000', 'temperatura', 399.0000, 'ºC'),
	(285542, 122, '2014-04-01 00:57:35.000000', 'temperatura', 1099.0000, 'ºC'),
	(285543, 122, '2014-04-01 00:57:36.000000', 'temperatura', 698.0000, 'ºC'),
	(285544, 122, '2014-04-01 00:57:37.000000', 'temperatura', 193.0000, 'ºC'),
	(285545, 122, '2014-04-01 00:57:38.000000', 'temperatura', 72.0000, 'ºC'),
	(285546, 122, '2014-04-01 00:57:39.000000', 'temperatura', 982.0000, 'ºC'),
	(285547, 122, '2014-04-01 00:57:40.000000', 'temperatura', 1093.0000, 'ºC'),
	(285548, 122, '2014-04-01 00:57:41.000000', 'temperatura', 118.0000, 'ºC'),
	(285549, 122, '2014-04-01 00:57:42.000000', 'temperatura', 914.0000, 'ºC'),
	(285550, 122, '2014-04-01 00:57:43.000000', 'temperatura', 618.0000, 'ºC'),
	(285551, 122, '2014-04-01 00:57:44.000000', 'temperatura', 346.0000, 'ºC'),
	(285552, 122, '2014-04-01 00:57:45.000000', 'temperatura', 1077.0000, 'ºC'),
	(285553, 122, '2014-04-01 00:57:46.000000', 'temperatura', 748.0000, 'ºC'),
	(285554, 122, '2014-04-01 00:57:47.000000', 'temperatura', 508.0000, 'ºC'),
	(285555, 122, '2014-04-01 00:57:48.000000', 'temperatura', 299.0000, 'ºC'),
	(285556, 122, '2014-04-01 00:57:49.000000', 'temperatura', 1170.0000, 'ºC'),
	(285557, 122, '2014-04-01 00:57:50.000000', 'temperatura', 155.0000, 'ºC'),
	(285558, 122, '2014-04-01 00:57:51.000000', 'temperatura', 864.0000, 'ºC'),
	(285559, 122, '2014-04-01 00:57:52.000000', 'temperatura', 256.0000, 'ºC'),
	(285560, 122, '2014-04-01 00:57:53.000000', 'temperatura', 1088.0000, 'ºC'),
	(285561, 122, '2014-04-01 00:57:54.000000', 'temperatura', 1072.0000, 'ºC'),
	(285562, 122, '2014-04-01 00:57:55.000000', 'temperatura', 896.0000, 'ºC'),
	(285563, 122, '2014-04-01 00:57:56.000000', 'temperatura', 64.0000, 'ºC'),
	(285564, 122, '2014-04-01 00:57:57.000000', 'temperatura', 34.0000, 'ºC'),
	(285565, 122, '2014-04-01 00:57:58.000000', 'temperatura', 1179.0000, 'ºC'),
	(285566, 122, '2014-04-01 00:57:59.000000', 'temperatura', 995.0000, 'ºC'),
	(285567, 122, '2014-04-01 00:58:00.000000', 'temperatura', 237.0000, 'ºC'),
	(285568, 122, '2014-04-01 00:58:01.000000', 'temperatura', 599.0000, 'ºC'),
	(285569, 122, '2014-04-01 00:58:02.000000', 'temperatura', 1085.0000, 'ºC'),
	(285570, 122, '2014-04-01 00:58:03.000000', 'temperatura', 31.0000, 'ºC'),
	(285571, 122, '2014-04-01 00:58:04.000000', 'temperatura', 498.0000, 'ºC'),
	(285572, 122, '2014-04-01 00:58:05.000000', 'temperatura', 0.0000, 'ºC'),
	(285573, 122, '2014-04-01 00:58:06.000000', 'temperatura', 906.0000, 'ºC'),
	(285574, 122, '2014-04-01 00:58:07.000000', 'temperatura', 930.0000, 'ºC'),
	(285575, 122, '2014-04-01 00:58:08.000000', 'temperatura', 732.0000, 'ºC'),
	(285576, 122, '2014-04-01 00:58:09.000000', 'temperatura', 869.0000, 'ºC'),
	(285577, 122, '2014-04-01 00:58:10.000000', 'temperatura', 950.0000, 'ºC'),
	(285578, 122, '2014-04-01 00:58:11.000000', 'temperatura', 942.0000, 'ºC'),
	(285579, 122, '2014-04-01 00:58:12.000000', 'temperatura', 663.0000, 'ºC'),
	(285580, 122, '2014-04-01 00:58:13.000000', 'temperatura', 490.0000, 'ºC'),
	(285581, 122, '2014-04-01 00:58:14.000000', 'temperatura', 460.0000, 'ºC'),
	(285582, 122, '2014-04-01 00:58:15.000000', 'temperatura', 832.0000, 'ºC'),
	(285583, 122, '2014-04-01 00:58:16.000000', 'temperatura', 381.0000, 'ºC'),
	(285584, 122, '2014-04-01 00:58:17.000000', 'temperatura', 607.0000, 'ºC'),
	(285585, 122, '2014-04-01 00:58:18.000000', 'temperatura', 693.0000, 'ºC'),
	(285586, 122, '2014-04-01 00:58:19.000000', 'temperatura', 445.0000, 'ºC'),
	(285587, 122, '2014-04-01 00:58:20.000000', 'temperatura', 147.0000, 'ºC'),
	(285588, 122, '2014-04-01 00:58:21.000000', 'temperatura', 599.0000, 'ºC'),
	(285589, 122, '2014-04-01 00:58:22.000000', 'temperatura', 157.0000, 'ºC'),
	(285590, 122, '2014-04-01 00:58:23.000000', 'temperatura', 187.0000, 'ºC'),
	(285591, 122, '2014-04-01 00:58:24.000000', 'temperatura', 466.0000, 'ºC'),
	(285592, 122, '2014-04-01 00:58:25.000000', 'temperatura', 567.0000, 'ºC'),
	(285593, 122, '2014-04-01 00:58:26.000000', 'temperatura', 237.0000, 'ºC'),
	(285594, 122, '2014-04-01 00:58:27.000000', 'temperatura', 685.0000, 'ºC'),
	(285595, 122, '2014-04-01 00:58:28.000000', 'temperatura', 317.0000, 'ºC'),
	(285596, 122, '2014-04-01 00:58:29.000000', 'temperatura', 727.0000, 'ºC'),
	(285597, 122, '2014-04-01 00:58:30.000000', 'temperatura', 286.0000, 'ºC'),
	(285598, 122, '2014-04-01 00:58:31.000000', 'temperatura', 448.0000, 'ºC'),
	(285599, 122, '2014-04-01 00:58:32.000000', 'temperatura', 184.0000, 'ºC'),
	(285600, 122, '2014-04-01 00:58:33.000000', 'temperatura', 778.0000, 'ºC'),
	(285601, 122, '2014-04-01 00:58:34.000000', 'temperatura', 937.0000, 'ºC'),
	(285602, 122, '2014-04-01 00:58:35.000000', 'temperatura', 1154.0000, 'ºC'),
	(285603, 122, '2014-04-01 00:58:36.000000', 'temperatura', 556.0000, 'ºC'),
	(285604, 122, '2014-04-01 00:58:37.000000', 'temperatura', 520.0000, 'ºC'),
	(285605, 122, '2014-04-01 00:58:38.000000', 'temperatura', 932.0000, 'ºC'),
	(285606, 122, '2014-04-01 00:58:39.000000', 'temperatura', 700.0000, 'ºC'),
	(285607, 122, '2014-04-01 00:58:40.000000', 'temperatura', 705.0000, 'ºC'),
	(285608, 122, '2014-04-01 00:58:41.000000', 'temperatura', 227.0000, 'ºC'),
	(285609, 122, '2014-04-01 00:58:42.000000', 'temperatura', 220.0000, 'ºC'),
	(285610, 122, '2014-04-01 00:58:43.000000', 'temperatura', 417.0000, 'ºC'),
	(285611, 122, '2014-04-01 00:58:44.000000', 'temperatura', 228.0000, 'ºC'),
	(285612, 122, '2014-04-01 00:58:45.000000', 'temperatura', 1087.0000, 'ºC'),
	(285613, 122, '2014-04-01 00:58:46.000000', 'temperatura', 1152.0000, 'ºC'),
	(285614, 122, '2014-04-01 00:58:47.000000', 'temperatura', 100.0000, 'ºC'),
	(285615, 122, '2014-04-01 00:58:48.000000', 'temperatura', 645.0000, 'ºC'),
	(285616, 122, '2014-04-01 00:58:49.000000', 'temperatura', 523.0000, 'ºC'),
	(285617, 122, '2014-04-01 00:58:50.000000', 'temperatura', 683.0000, 'ºC'),
	(285618, 122, '2014-04-01 00:58:51.000000', 'temperatura', 646.0000, 'ºC'),
	(285619, 122, '2014-04-01 00:58:52.000000', 'temperatura', 1180.0000, 'ºC'),
	(285620, 122, '2014-04-01 00:58:53.000000', 'temperatura', 365.0000, 'ºC'),
	(285621, 122, '2014-04-01 00:58:54.000000', 'temperatura', 684.0000, 'ºC'),
	(285622, 122, '2014-04-01 00:58:55.000000', 'temperatura', 1127.0000, 'ºC'),
	(285623, 122, '2014-04-01 00:58:56.000000', 'temperatura', 1181.0000, 'ºC'),
	(285624, 122, '2014-04-01 00:58:57.000000', 'temperatura', 126.0000, 'ºC'),
	(285625, 122, '2014-04-01 00:58:58.000000', 'temperatura', 689.0000, 'ºC'),
	(285626, 122, '2014-04-01 00:58:59.000000', 'temperatura', 664.0000, 'ºC'),
	(285627, 122, '2014-04-01 00:59:00.000000', 'temperatura', 56.0000, 'ºC'),
	(285628, 122, '2014-04-01 00:59:01.000000', 'temperatura', 688.0000, 'ºC'),
	(285629, 122, '2014-04-01 00:59:02.000000', 'temperatura', 874.0000, 'ºC'),
	(285630, 122, '2014-04-01 00:59:03.000000', 'temperatura', 1103.0000, 'ºC'),
	(285631, 122, '2014-04-01 00:59:04.000000', 'temperatura', 497.0000, 'ºC'),
	(285632, 122, '2014-04-01 00:59:05.000000', 'temperatura', 376.0000, 'ºC'),
	(285633, 122, '2014-04-01 00:59:06.000000', 'temperatura', 388.0000, 'ºC'),
	(285634, 122, '2014-04-01 00:59:07.000000', 'temperatura', 815.0000, 'ºC'),
	(285635, 122, '2014-04-01 00:59:08.000000', 'temperatura', 510.0000, 'ºC'),
	(285636, 122, '2014-04-01 00:59:09.000000', 'temperatura', 106.0000, 'ºC'),
	(285637, 122, '2014-04-01 00:59:10.000000', 'temperatura', 202.0000, 'ºC'),
	(285638, 122, '2014-04-01 00:59:11.000000', 'temperatura', 692.0000, 'ºC'),
	(285639, 122, '2014-04-01 00:59:12.000000', 'temperatura', 454.0000, 'ºC'),
	(285640, 122, '2014-04-01 00:59:13.000000', 'temperatura', 196.0000, 'ºC'),
	(285641, 122, '2014-04-01 00:59:14.000000', 'temperatura', 816.0000, 'ºC'),
	(285642, 122, '2014-04-01 00:59:15.000000', 'temperatura', 1091.0000, 'ºC'),
	(285643, 122, '2014-04-01 00:59:16.000000', 'temperatura', 611.0000, 'ºC'),
	(285644, 122, '2014-04-01 00:59:17.000000', 'temperatura', 982.0000, 'ºC'),
	(285645, 122, '2014-04-01 00:59:18.000000', 'temperatura', 679.0000, 'ºC'),
	(285646, 122, '2014-04-01 00:59:19.000000', 'temperatura', 448.0000, 'ºC'),
	(285647, 122, '2014-04-01 00:59:20.000000', 'temperatura', 202.0000, 'ºC'),
	(285648, 122, '2014-04-01 00:59:21.000000', 'temperatura', 868.0000, 'ºC'),
	(285649, 122, '2014-04-01 00:59:22.000000', 'temperatura', 134.0000, 'ºC'),
	(285650, 122, '2014-04-01 00:59:23.000000', 'temperatura', 465.0000, 'ºC'),
	(285651, 122, '2014-04-01 00:59:24.000000', 'temperatura', 725.0000, 'ºC'),
	(285652, 122, '2014-04-01 00:59:25.000000', 'temperatura', 1029.0000, 'ºC'),
	(285653, 122, '2014-04-01 00:59:26.000000', 'temperatura', 573.0000, 'ºC'),
	(285654, 122, '2014-04-01 00:59:27.000000', 'temperatura', 978.0000, 'ºC'),
	(285655, 122, '2014-04-01 00:59:28.000000', 'temperatura', 771.0000, 'ºC'),
	(285656, 122, '2014-04-01 00:59:29.000000', 'temperatura', 923.0000, 'ºC'),
	(285657, 122, '2014-04-01 00:59:30.000000', 'temperatura', 1102.0000, 'ºC'),
	(285658, 122, '2014-04-01 00:59:31.000000', 'temperatura', 340.0000, 'ºC'),
	(285659, 122, '2014-04-01 00:59:32.000000', 'temperatura', 794.0000, 'ºC'),
	(285660, 122, '2014-04-01 00:59:33.000000', 'temperatura', 553.0000, 'ºC'),
	(285661, 122, '2014-04-01 00:59:34.000000', 'temperatura', 382.0000, 'ºC'),
	(285662, 122, '2014-04-01 00:59:35.000000', 'temperatura', 251.0000, 'ºC'),
	(285663, 122, '2014-04-01 00:59:36.000000', 'temperatura', 111.0000, 'ºC'),
	(285664, 122, '2014-04-01 00:59:37.000000', 'temperatura', 1003.0000, 'ºC'),
	(285665, 122, '2014-04-01 00:59:38.000000', 'temperatura', 1081.0000, 'ºC'),
	(285666, 122, '2014-04-01 00:59:39.000000', 'temperatura', 1195.0000, 'ºC'),
	(285667, 122, '2014-04-01 00:59:40.000000', 'temperatura', 334.0000, 'ºC'),
	(285668, 122, '2014-04-01 00:59:41.000000', 'temperatura', 487.0000, 'ºC'),
	(285669, 122, '2014-04-01 00:59:42.000000', 'temperatura', 231.0000, 'ºC'),
	(285670, 122, '2014-04-01 00:59:43.000000', 'temperatura', 894.0000, 'ºC'),
	(285671, 122, '2014-04-01 00:59:44.000000', 'temperatura', 179.0000, 'ºC'),
	(285672, 122, '2014-04-01 00:59:45.000000', 'temperatura', 612.0000, 'ºC'),
	(285673, 122, '2014-04-01 00:59:46.000000', 'temperatura', 124.0000, 'ºC'),
	(285674, 122, '2014-04-01 00:59:47.000000', 'temperatura', 1183.0000, 'ºC'),
	(285675, 122, '2014-04-01 00:59:48.000000', 'temperatura', 746.0000, 'ºC'),
	(285676, 122, '2014-04-01 00:59:49.000000', 'temperatura', 183.0000, 'ºC'),
	(285677, 122, '2014-04-01 00:59:50.000000', 'temperatura', 1074.0000, 'ºC'),
	(285678, 122, '2014-04-01 00:59:51.000000', 'temperatura', 23.0000, 'ºC'),
	(285679, 122, '2014-04-01 00:59:52.000000', 'temperatura', 495.0000, 'ºC'),
	(285680, 122, '2014-04-01 00:59:53.000000', 'temperatura', 7.0000, 'ºC'),
	(285681, 122, '2014-04-01 00:59:54.000000', 'temperatura', 949.0000, 'ºC'),
	(285682, 122, '2014-04-01 00:59:55.000000', 'temperatura', 1124.0000, 'ºC'),
	(285683, 122, '2014-04-01 00:59:56.000000', 'temperatura', 372.0000, 'ºC'),
	(285684, 122, '2014-04-01 00:59:57.000000', 'temperatura', 891.0000, 'ºC'),
	(285685, 122, '2014-04-01 00:59:58.000000', 'temperatura', 937.0000, 'ºC'),
	(285686, 122, '2014-04-01 00:59:59.000000', 'temperatura', 812.0000, 'ºC'),
	(285687, 122, '2014-04-01 01:00:00.000000', 'temperatura', 52.0000, 'ºC'),
	(285688, 122, '2014-04-01 01:00:01.000000', 'temperatura', 222.0000, 'ºC'),
	(285689, 122, '2014-04-01 01:00:02.000000', 'temperatura', 955.0000, 'ºC'),
	(285690, 122, '2014-04-01 01:00:03.000000', 'temperatura', 511.0000, 'ºC'),
	(285691, 122, '2014-04-01 01:00:04.000000', 'temperatura', 891.0000, 'ºC'),
	(285692, 122, '2014-04-01 01:00:05.000000', 'temperatura', 523.0000, 'ºC'),
	(285693, 122, '2014-04-01 01:00:06.000000', 'temperatura', 1139.0000, 'ºC'),
	(285694, 122, '2014-04-01 01:00:07.000000', 'temperatura', 530.0000, 'ºC'),
	(285695, 122, '2014-04-01 01:00:08.000000', 'temperatura', 432.0000, 'ºC'),
	(285696, 122, '2014-04-01 01:00:09.000000', 'temperatura', 572.0000, 'ºC'),
	(285697, 122, '2014-04-01 01:00:10.000000', 'temperatura', 363.0000, 'ºC'),
	(285698, 122, '2014-04-01 01:00:11.000000', 'temperatura', 101.0000, 'ºC'),
	(285699, 122, '2014-04-01 01:00:12.000000', 'temperatura', 615.0000, 'ºC'),
	(285700, 122, '2014-04-01 01:00:13.000000', 'temperatura', 374.0000, 'ºC'),
	(285701, 122, '2014-04-01 01:00:14.000000', 'temperatura', 25.0000, 'ºC'),
	(285702, 122, '2014-04-01 01:00:15.000000', 'temperatura', 204.0000, 'ºC'),
	(285703, 122, '2014-04-01 01:00:16.000000', 'temperatura', 944.0000, 'ºC'),
	(285704, 122, '2014-04-01 01:00:17.000000', 'temperatura', 509.0000, 'ºC'),
	(285705, 122, '2014-04-01 01:00:18.000000', 'temperatura', 914.0000, 'ºC'),
	(285706, 122, '2014-04-01 01:00:19.000000', 'temperatura', 642.0000, 'ºC'),
	(285707, 122, '2014-04-01 01:00:20.000000', 'temperatura', 469.0000, 'ºC'),
	(285708, 122, '2014-04-01 01:00:21.000000', 'temperatura', 421.0000, 'ºC'),
	(285709, 122, '2014-04-01 01:00:22.000000', 'temperatura', 697.0000, 'ºC'),
	(285710, 122, '2014-04-01 01:00:23.000000', 'temperatura', 1023.0000, 'ºC'),
	(285711, 122, '2014-04-01 01:00:24.000000', 'temperatura', 626.0000, 'ºC'),
	(285712, 122, '2014-04-01 01:00:25.000000', 'temperatura', 61.0000, 'ºC'),
	(285713, 122, '2014-04-01 01:00:26.000000', 'temperatura', 825.0000, 'ºC'),
	(285714, 122, '2014-04-01 01:00:27.000000', 'temperatura', 345.0000, 'ºC'),
	(285715, 122, '2014-04-01 01:00:28.000000', 'temperatura', 450.0000, 'ºC'),
	(285716, 122, '2014-04-01 01:00:29.000000', 'temperatura', 14.0000, 'ºC'),
	(285717, 122, '2014-04-01 01:00:30.000000', 'temperatura', 1122.0000, 'ºC'),
	(285718, 122, '2014-04-01 01:00:31.000000', 'temperatura', 769.0000, 'ºC'),
	(285719, 122, '2014-04-01 01:00:32.000000', 'temperatura', 479.0000, 'ºC'),
	(285720, 122, '2014-04-01 01:00:33.000000', 'temperatura', 88.0000, 'ºC'),
	(285721, 122, '2014-04-01 01:00:34.000000', 'temperatura', 204.0000, 'ºC'),
	(285722, 122, '2014-04-01 01:00:35.000000', 'temperatura', 755.0000, 'ºC'),
	(285723, 122, '2014-04-01 01:00:36.000000', 'temperatura', 766.0000, 'ºC'),
	(285724, 122, '2014-04-01 01:00:37.000000', 'temperatura', 366.0000, 'ºC'),
	(285725, 122, '2014-04-01 01:00:38.000000', 'temperatura', 733.0000, 'ºC'),
	(285726, 122, '2014-04-01 01:00:39.000000', 'temperatura', 166.0000, 'ºC'),
	(285727, 122, '2014-04-01 01:00:40.000000', 'temperatura', 1033.0000, 'ºC'),
	(285728, 122, '2014-04-01 01:00:41.000000', 'temperatura', 1066.0000, 'ºC'),
	(285729, 122, '2014-04-01 01:00:42.000000', 'temperatura', 1033.0000, 'ºC'),
	(285730, 122, '2014-04-01 01:00:43.000000', 'temperatura', 769.0000, 'ºC'),
	(285731, 122, '2014-04-01 01:00:44.000000', 'temperatura', 745.0000, 'ºC'),
	(285732, 122, '2014-04-01 01:00:45.000000', 'temperatura', 216.0000, 'ºC'),
	(285733, 122, '2014-04-01 01:00:46.000000', 'temperatura', 49.0000, 'ºC'),
	(285734, 122, '2014-04-01 01:00:47.000000', 'temperatura', 794.0000, 'ºC'),
	(285735, 122, '2014-04-01 01:00:48.000000', 'temperatura', 227.0000, 'ºC'),
	(285736, 122, '2014-04-01 01:00:49.000000', 'temperatura', 1151.0000, 'ºC'),
	(285737, 122, '2014-04-01 01:00:50.000000', 'temperatura', 274.0000, 'ºC'),
	(285738, 122, '2014-04-01 01:00:51.000000', 'temperatura', 317.0000, 'ºC'),
	(285739, 122, '2014-04-01 01:00:52.000000', 'temperatura', 764.0000, 'ºC'),
	(285740, 122, '2014-04-01 01:00:53.000000', 'temperatura', 471.0000, 'ºC'),
	(285741, 122, '2014-04-01 01:00:54.000000', 'temperatura', 65.0000, 'ºC'),
	(285742, 122, '2014-04-01 01:00:55.000000', 'temperatura', 110.0000, 'ºC'),
	(285743, 122, '2014-04-01 01:00:56.000000', 'temperatura', 354.0000, 'ºC'),
	(285744, 122, '2014-04-01 01:00:57.000000', 'temperatura', 242.0000, 'ºC'),
	(285745, 122, '2014-04-01 01:00:58.000000', 'temperatura', 151.0000, 'ºC'),
	(285746, 122, '2014-04-01 01:00:59.000000', 'temperatura', 26.0000, 'ºC'),
	(285747, 122, '2014-04-01 01:01:00.000000', 'temperatura', 878.0000, 'ºC'),
	(285748, 122, '2014-04-01 01:01:01.000000', 'temperatura', 711.0000, 'ºC'),
	(285749, 122, '2014-04-01 01:01:02.000000', 'temperatura', 922.0000, 'ºC'),
	(285750, 122, '2014-04-01 01:01:03.000000', 'temperatura', 80.0000, 'ºC'),
	(285751, 122, '2014-04-01 01:01:04.000000', 'temperatura', 31.0000, 'ºC'),
	(285752, 122, '2014-04-01 01:01:05.000000', 'temperatura', 1118.0000, 'ºC'),
	(285753, 122, '2014-04-01 01:01:06.000000', 'temperatura', 695.0000, 'ºC'),
	(285754, 122, '2014-04-01 01:01:07.000000', 'temperatura', 122.0000, 'ºC'),
	(285755, 122, '2014-04-01 01:01:08.000000', 'temperatura', 928.0000, 'ºC'),
	(285756, 122, '2014-04-01 01:01:09.000000', 'temperatura', 672.0000, 'ºC'),
	(285757, 122, '2014-04-01 01:01:10.000000', 'temperatura', 577.0000, 'ºC'),
	(285758, 122, '2014-04-01 01:01:11.000000', 'temperatura', 871.0000, 'ºC'),
	(285759, 122, '2014-04-01 01:01:12.000000', 'temperatura', 222.0000, 'ºC'),
	(285760, 122, '2014-04-01 01:01:13.000000', 'temperatura', 897.0000, 'ºC'),
	(285761, 122, '2014-04-01 01:01:14.000000', 'temperatura', 222.0000, 'ºC'),
	(285762, 122, '2014-04-01 01:01:15.000000', 'temperatura', 818.0000, 'ºC'),
	(285763, 122, '2014-04-01 01:01:16.000000', 'temperatura', 1025.0000, 'ºC'),
	(285764, 122, '2014-04-01 01:01:17.000000', 'temperatura', 270.0000, 'ºC'),
	(285765, 122, '2014-04-01 01:01:18.000000', 'temperatura', 678.0000, 'ºC'),
	(285766, 122, '2014-04-01 01:01:19.000000', 'temperatura', 181.0000, 'ºC'),
	(285767, 122, '2014-04-01 01:01:20.000000', 'temperatura', 70.0000, 'ºC'),
	(285768, 122, '2014-04-01 01:01:21.000000', 'temperatura', 1010.0000, 'ºC'),
	(285769, 122, '2014-04-01 01:01:22.000000', 'temperatura', 38.0000, 'ºC'),
	(285770, 122, '2014-04-01 01:01:23.000000', 'temperatura', 760.0000, 'ºC'),
	(285771, 122, '2014-04-01 01:01:24.000000', 'temperatura', 88.0000, 'ºC'),
	(285772, 122, '2014-04-01 01:01:25.000000', 'temperatura', 560.0000, 'ºC'),
	(285773, 122, '2014-04-01 01:01:26.000000', 'temperatura', 136.0000, 'ºC'),
	(285774, 122, '2014-04-01 01:01:27.000000', 'temperatura', 201.0000, 'ºC'),
	(285775, 122, '2014-04-01 01:01:28.000000', 'temperatura', 597.0000, 'ºC'),
	(285776, 122, '2014-04-01 01:01:29.000000', 'temperatura', 1185.0000, 'ºC'),
	(285777, 122, '2014-04-01 01:01:30.000000', 'temperatura', 531.0000, 'ºC'),
	(285778, 122, '2014-04-01 01:01:31.000000', 'temperatura', 303.0000, 'ºC'),
	(285779, 122, '2014-04-01 01:01:32.000000', 'temperatura', 1121.0000, 'ºC'),
	(285780, 122, '2014-04-01 01:01:33.000000', 'temperatura', 1097.0000, 'ºC'),
	(285781, 122, '2014-04-01 01:01:34.000000', 'temperatura', 924.0000, 'ºC'),
	(285782, 122, '2014-04-01 01:01:35.000000', 'temperatura', 130.0000, 'ºC'),
	(285783, 122, '2014-04-01 01:01:36.000000', 'temperatura', 276.0000, 'ºC'),
	(285784, 122, '2014-04-01 01:01:37.000000', 'temperatura', 993.0000, 'ºC'),
	(285785, 122, '2014-04-01 01:01:38.000000', 'temperatura', 537.0000, 'ºC'),
	(285786, 122, '2014-04-01 01:01:39.000000', 'temperatura', 908.0000, 'ºC'),
	(285787, 122, '2014-04-01 01:01:40.000000', 'temperatura', 526.0000, 'ºC'),
	(285788, 122, '2014-04-01 01:01:41.000000', 'temperatura', 1109.0000, 'ºC'),
	(285789, 122, '2014-04-01 01:01:42.000000', 'temperatura', 367.0000, 'ºC'),
	(285790, 122, '2014-04-01 01:01:43.000000', 'temperatura', 910.0000, 'ºC'),
	(285791, 122, '2014-04-01 01:01:44.000000', 'temperatura', 1048.0000, 'ºC'),
	(285792, 122, '2014-04-01 01:01:45.000000', 'temperatura', 110.0000, 'ºC'),
	(285793, 122, '2014-04-01 01:01:46.000000', 'temperatura', 1005.0000, 'ºC'),
	(285794, 122, '2014-04-01 01:01:47.000000', 'temperatura', 1099.0000, 'ºC'),
	(285795, 122, '2014-04-01 01:01:48.000000', 'temperatura', 77.0000, 'ºC'),
	(285796, 122, '2014-04-01 01:01:49.000000', 'temperatura', 691.0000, 'ºC'),
	(285797, 122, '2014-04-01 01:01:50.000000', 'temperatura', 822.0000, 'ºC'),
	(285798, 122, '2014-04-01 01:01:51.000000', 'temperatura', 837.0000, 'ºC'),
	(285799, 122, '2014-04-01 01:01:52.000000', 'temperatura', 521.0000, 'ºC'),
	(285800, 122, '2014-04-01 01:01:53.000000', 'temperatura', 93.0000, 'ºC'),
	(285801, 122, '2014-04-01 01:01:54.000000', 'temperatura', 104.0000, 'ºC'),
	(285802, 122, '2014-04-01 01:01:55.000000', 'temperatura', 243.0000, 'ºC'),
	(285803, 122, '2014-04-01 01:01:56.000000', 'temperatura', 902.0000, 'ºC'),
	(285804, 122, '2014-04-01 01:01:57.000000', 'temperatura', 183.0000, 'ºC'),
	(285805, 122, '2014-04-01 01:01:58.000000', 'temperatura', 607.0000, 'ºC'),
	(285806, 122, '2014-04-01 01:01:59.000000', 'temperatura', 87.0000, 'ºC'),
	(285807, 122, '2014-04-01 01:02:00.000000', 'temperatura', 1015.0000, 'ºC'),
	(285808, 122, '2014-04-01 01:02:01.000000', 'temperatura', 13.0000, 'ºC'),
	(285809, 122, '2014-04-01 01:02:02.000000', 'temperatura', 621.0000, 'ºC'),
	(285810, 122, '2014-04-01 01:02:03.000000', 'temperatura', 669.0000, 'ºC'),
	(285811, 122, '2014-04-01 01:02:04.000000', 'temperatura', 279.0000, 'ºC'),
	(285812, 122, '2014-04-01 01:02:05.000000', 'temperatura', 589.0000, 'ºC'),
	(285813, 122, '2014-04-01 01:02:06.000000', 'temperatura', 911.0000, 'ºC'),
	(285814, 122, '2014-04-01 01:02:07.000000', 'temperatura', 387.0000, 'ºC'),
	(285815, 122, '2014-04-01 01:02:08.000000', 'temperatura', 401.0000, 'ºC'),
	(285816, 122, '2014-04-01 01:02:09.000000', 'temperatura', 844.0000, 'ºC'),
	(285817, 122, '2014-04-01 01:02:10.000000', 'temperatura', 620.0000, 'ºC'),
	(285818, 122, '2014-04-01 01:02:11.000000', 'temperatura', 570.0000, 'ºC'),
	(285819, 122, '2014-04-01 01:02:12.000000', 'temperatura', 987.0000, 'ºC'),
	(285820, 122, '2014-04-01 01:02:13.000000', 'temperatura', 827.0000, 'ºC'),
	(285821, 122, '2014-04-01 01:02:14.000000', 'temperatura', 1173.0000, 'ºC'),
	(285822, 122, '2014-04-01 01:02:15.000000', 'temperatura', 987.0000, 'ºC'),
	(285823, 122, '2014-04-01 01:02:16.000000', 'temperatura', 214.0000, 'ºC'),
	(285824, 122, '2014-04-01 01:02:17.000000', 'temperatura', 511.0000, 'ºC'),
	(285825, 122, '2014-04-01 01:02:18.000000', 'temperatura', 715.0000, 'ºC'),
	(285826, 122, '2014-04-01 01:02:19.000000', 'temperatura', 839.0000, 'ºC'),
	(285827, 122, '2014-04-01 01:02:20.000000', 'temperatura', 853.0000, 'ºC'),
	(285828, 122, '2014-04-01 01:02:21.000000', 'temperatura', 549.0000, 'ºC'),
	(285829, 122, '2014-04-01 01:02:22.000000', 'temperatura', 187.0000, 'ºC'),
	(285830, 122, '2014-04-01 01:02:23.000000', 'temperatura', 488.0000, 'ºC'),
	(285831, 122, '2014-04-01 01:02:24.000000', 'temperatura', 681.0000, 'ºC'),
	(285832, 122, '2014-04-01 01:02:25.000000', 'temperatura', 738.0000, 'ºC'),
	(285833, 122, '2014-04-01 01:02:26.000000', 'temperatura', 451.0000, 'ºC'),
	(285834, 122, '2014-04-01 01:02:27.000000', 'temperatura', 38.0000, 'ºC'),
	(285835, 122, '2014-04-01 01:02:28.000000', 'temperatura', 41.0000, 'ºC'),
	(285836, 122, '2014-04-01 01:02:29.000000', 'temperatura', 90.0000, 'ºC'),
	(285837, 122, '2014-04-01 01:02:30.000000', 'temperatura', 326.0000, 'ºC'),
	(285838, 122, '2014-04-01 01:02:31.000000', 'temperatura', 160.0000, 'ºC'),
	(285839, 122, '2014-04-01 01:02:32.000000', 'temperatura', 1022.0000, 'ºC'),
	(285840, 122, '2014-04-01 01:02:33.000000', 'temperatura', 1031.0000, 'ºC'),
	(285841, 122, '2014-04-01 01:02:34.000000', 'temperatura', 892.0000, 'ºC'),
	(285842, 122, '2014-04-01 01:02:35.000000', 'temperatura', 165.0000, 'ºC'),
	(285843, 122, '2014-04-01 01:02:36.000000', 'temperatura', 548.0000, 'ºC'),
	(285844, 122, '2014-04-01 01:02:37.000000', 'temperatura', 1049.0000, 'ºC'),
	(285845, 122, '2014-04-01 01:02:38.000000', 'temperatura', 1198.0000, 'ºC'),
	(285846, 122, '2014-04-01 01:02:39.000000', 'temperatura', 446.0000, 'ºC'),
	(285847, 122, '2014-04-01 01:02:40.000000', 'temperatura', 1036.0000, 'ºC'),
	(285848, 122, '2014-04-01 01:02:41.000000', 'temperatura', 243.0000, 'ºC'),
	(285849, 122, '2014-04-01 01:02:42.000000', 'temperatura', 508.0000, 'ºC'),
	(285850, 122, '2014-04-01 01:02:43.000000', 'temperatura', 612.0000, 'ºC'),
	(285851, 122, '2014-04-01 01:02:44.000000', 'temperatura', 336.0000, 'ºC'),
	(285852, 122, '2014-04-01 01:02:45.000000', 'temperatura', 1045.0000, 'ºC'),
	(285853, 122, '2014-04-01 01:02:46.000000', 'temperatura', 616.0000, 'ºC'),
	(285854, 122, '2014-04-01 01:02:47.000000', 'temperatura', 1146.0000, 'ºC'),
	(285855, 122, '2014-04-01 01:02:48.000000', 'temperatura', 283.0000, 'ºC'),
	(285856, 122, '2014-04-01 01:02:49.000000', 'temperatura', 378.0000, 'ºC'),
	(285857, 122, '2014-04-01 01:02:50.000000', 'temperatura', 1039.0000, 'ºC'),
	(285858, 122, '2014-04-01 01:02:51.000000', 'temperatura', 464.0000, 'ºC'),
	(285859, 122, '2014-04-01 01:02:52.000000', 'temperatura', 401.0000, 'ºC'),
	(285860, 122, '2014-04-01 01:02:53.000000', 'temperatura', 614.0000, 'ºC'),
	(285861, 122, '2014-04-01 01:02:54.000000', 'temperatura', 669.0000, 'ºC'),
	(285862, 122, '2014-04-01 01:02:55.000000', 'temperatura', 304.0000, 'ºC'),
	(285863, 122, '2014-04-01 01:02:56.000000', 'temperatura', 714.0000, 'ºC'),
	(285864, 122, '2014-04-01 01:02:57.000000', 'temperatura', 258.0000, 'ºC'),
	(285865, 122, '2014-04-01 01:02:58.000000', 'temperatura', 350.0000, 'ºC'),
	(285866, 122, '2014-04-01 01:02:59.000000', 'temperatura', 976.0000, 'ºC'),
	(285867, 122, '2014-04-01 01:03:00.000000', 'temperatura', 230.0000, 'ºC'),
	(285868, 122, '2014-04-01 01:03:01.000000', 'temperatura', 624.0000, 'ºC'),
	(285869, 122, '2014-04-01 01:03:02.000000', 'temperatura', 30.0000, 'ºC'),
	(285870, 122, '2014-04-01 01:03:03.000000', 'temperatura', 677.0000, 'ºC'),
	(285871, 122, '2014-04-01 01:03:04.000000', 'temperatura', 895.0000, 'ºC'),
	(285872, 122, '2014-04-01 01:03:05.000000', 'temperatura', 47.0000, 'ºC'),
	(285873, 122, '2014-04-01 01:03:06.000000', 'temperatura', 1149.0000, 'ºC'),
	(285874, 122, '2014-04-01 01:03:07.000000', 'temperatura', 803.0000, 'ºC'),
	(285875, 122, '2014-04-01 01:03:08.000000', 'temperatura', 571.0000, 'ºC'),
	(285876, 122, '2014-04-01 01:03:09.000000', 'temperatura', 446.0000, 'ºC'),
	(285877, 122, '2014-04-01 01:03:10.000000', 'temperatura', 519.0000, 'ºC'),
	(285878, 122, '2014-04-01 01:03:11.000000', 'temperatura', 56.0000, 'ºC'),
	(285879, 122, '2014-04-01 01:03:12.000000', 'temperatura', 1123.0000, 'ºC'),
	(285880, 122, '2014-04-01 01:03:13.000000', 'temperatura', 648.0000, 'ºC'),
	(285881, 122, '2014-04-01 01:03:14.000000', 'temperatura', 1072.0000, 'ºC'),
	(285882, 122, '2014-04-01 01:03:15.000000', 'temperatura', 1018.0000, 'ºC'),
	(285883, 122, '2014-04-01 01:03:16.000000', 'temperatura', 673.0000, 'ºC'),
	(285884, 122, '2014-04-01 01:03:17.000000', 'temperatura', 313.0000, 'ºC'),
	(285885, 122, '2014-04-01 01:03:18.000000', 'temperatura', 747.0000, 'ºC'),
	(285886, 122, '2014-04-01 01:03:19.000000', 'temperatura', 394.0000, 'ºC'),
	(285887, 122, '2014-04-01 01:03:20.000000', 'temperatura', 931.0000, 'ºC'),
	(285888, 122, '2014-04-01 01:03:21.000000', 'temperatura', 1073.0000, 'ºC'),
	(285889, 122, '2014-04-01 01:03:22.000000', 'temperatura', 172.0000, 'ºC'),
	(285890, 122, '2014-04-01 01:03:23.000000', 'temperatura', 40.0000, 'ºC'),
	(285891, 122, '2014-04-01 01:03:24.000000', 'temperatura', 888.0000, 'ºC'),
	(285892, 122, '2014-04-01 01:03:25.000000', 'temperatura', 718.0000, 'ºC'),
	(285893, 122, '2014-04-01 01:03:26.000000', 'temperatura', 926.0000, 'ºC'),
	(285894, 122, '2014-04-01 01:03:27.000000', 'temperatura', 77.0000, 'ºC'),
	(285895, 122, '2014-04-01 01:03:28.000000', 'temperatura', 7.0000, 'ºC'),
	(285896, 122, '2014-04-01 01:03:29.000000', 'temperatura', 1006.0000, 'ºC'),
	(285897, 122, '2014-04-01 01:03:30.000000', 'temperatura', 207.0000, 'ºC'),
	(285898, 122, '2014-04-01 01:03:31.000000', 'temperatura', 419.0000, 'ºC'),
	(285899, 122, '2014-04-01 01:03:32.000000', 'temperatura', 275.0000, 'ºC'),
	(285900, 122, '2014-04-01 01:03:33.000000', 'temperatura', 116.0000, 'ºC'),
	(285901, 122, '2014-04-01 01:03:34.000000', 'temperatura', 957.0000, 'ºC'),
	(285902, 122, '2014-04-01 01:03:35.000000', 'temperatura', 839.0000, 'ºC'),
	(285903, 122, '2014-04-01 01:03:36.000000', 'temperatura', 122.0000, 'ºC'),
	(285904, 122, '2014-04-01 01:03:37.000000', 'temperatura', 496.0000, 'ºC'),
	(285905, 122, '2014-04-01 01:03:38.000000', 'temperatura', 912.0000, 'ºC'),
	(285906, 122, '2014-04-01 01:03:39.000000', 'temperatura', 674.0000, 'ºC'),
	(285907, 122, '2014-04-01 01:03:40.000000', 'temperatura', 635.0000, 'ºC'),
	(285908, 122, '2014-04-01 01:03:41.000000', 'temperatura', 1154.0000, 'ºC'),
	(285909, 122, '2014-04-01 01:03:42.000000', 'temperatura', 265.0000, 'ºC'),
	(285910, 122, '2014-04-01 01:03:43.000000', 'temperatura', 263.0000, 'ºC'),
	(285911, 122, '2014-04-01 01:03:44.000000', 'temperatura', 523.0000, 'ºC'),
	(285912, 122, '2014-04-01 01:03:45.000000', 'temperatura', 624.0000, 'ºC'),
	(285913, 122, '2014-04-01 01:03:46.000000', 'temperatura', 353.0000, 'ºC'),
	(285914, 122, '2014-04-01 01:03:47.000000', 'temperatura', 1091.0000, 'ºC'),
	(285915, 122, '2014-04-01 01:03:48.000000', 'temperatura', 799.0000, 'ºC'),
	(285916, 122, '2014-04-01 01:03:49.000000', 'temperatura', 721.0000, 'ºC'),
	(285917, 122, '2014-04-01 01:03:50.000000', 'temperatura', 7.0000, 'ºC'),
	(285918, 122, '2014-04-01 01:03:51.000000', 'temperatura', 275.0000, 'ºC'),
	(285919, 122, '2014-04-01 01:03:52.000000', 'temperatura', 153.0000, 'ºC'),
	(285920, 122, '2014-04-01 01:03:53.000000', 'temperatura', 1141.0000, 'ºC'),
	(285921, 122, '2014-04-01 01:03:54.000000', 'temperatura', 447.0000, 'ºC'),
	(285922, 122, '2014-04-01 01:03:55.000000', 'temperatura', 14.0000, 'ºC'),
	(285923, 122, '2014-04-01 01:03:56.000000', 'temperatura', 1129.0000, 'ºC'),
	(285924, 122, '2014-04-01 01:03:57.000000', 'temperatura', 801.0000, 'ºC'),
	(285925, 122, '2014-04-01 01:03:58.000000', 'temperatura', 621.0000, 'ºC'),
	(285926, 122, '2014-04-01 01:03:59.000000', 'temperatura', 700.0000, 'ºC'),
	(285927, 122, '2014-04-01 01:04:00.000000', 'temperatura', 441.0000, 'ºC'),
	(285928, 122, '2014-04-01 01:04:01.000000', 'temperatura', 103.0000, 'ºC'),
	(285929, 122, '2014-04-01 01:04:02.000000', 'temperatura', 394.0000, 'ºC'),
	(285930, 122, '2014-04-01 01:04:03.000000', 'temperatura', 461.0000, 'ºC'),
	(285931, 122, '2014-04-01 01:04:04.000000', 'temperatura', 1123.0000, 'ºC'),
	(285932, 122, '2014-04-01 01:04:05.000000', 'temperatura', 631.0000, 'ºC'),
	(285933, 122, '2014-04-01 01:04:06.000000', 'temperatura', 987.0000, 'ºC'),
	(285934, 122, '2014-04-01 01:04:07.000000', 'temperatura', 644.0000, 'ºC'),
	(285935, 122, '2014-04-01 01:04:08.000000', 'temperatura', 260.0000, 'ºC'),
	(285936, 122, '2014-04-01 01:04:09.000000', 'temperatura', 566.0000, 'ºC'),
	(285937, 122, '2014-04-01 01:04:10.000000', 'temperatura', 852.0000, 'ºC'),
	(285938, 122, '2014-04-01 01:04:11.000000', 'temperatura', 161.0000, 'ºC'),
	(285939, 122, '2014-04-01 01:04:12.000000', 'temperatura', 652.0000, 'ºC'),
	(285940, 122, '2014-04-01 01:04:13.000000', 'temperatura', 375.0000, 'ºC'),
	(285941, 122, '2014-04-01 01:04:14.000000', 'temperatura', 1121.0000, 'ºC'),
	(285942, 122, '2014-04-01 01:04:15.000000', 'temperatura', 878.0000, 'ºC'),
	(285943, 122, '2014-04-01 01:04:16.000000', 'temperatura', 1030.0000, 'ºC'),
	(285944, 122, '2014-04-01 01:04:17.000000', 'temperatura', 116.0000, 'ºC'),
	(285945, 122, '2014-04-01 01:04:18.000000', 'temperatura', 1092.0000, 'ºC'),
	(285946, 122, '2014-04-01 01:04:19.000000', 'temperatura', 312.0000, 'ºC'),
	(285947, 122, '2014-04-01 01:04:20.000000', 'temperatura', 686.0000, 'ºC'),
	(285948, 122, '2014-04-01 01:04:21.000000', 'temperatura', 92.0000, 'ºC'),
	(285949, 122, '2014-04-01 01:04:22.000000', 'temperatura', 801.0000, 'ºC'),
	(285950, 122, '2014-04-01 01:04:23.000000', 'temperatura', 133.0000, 'ºC'),
	(285951, 122, '2014-04-01 01:04:24.000000', 'temperatura', 661.0000, 'ºC'),
	(285952, 122, '2014-04-01 01:04:25.000000', 'temperatura', 505.0000, 'ºC'),
	(285953, 122, '2014-04-01 01:04:26.000000', 'temperatura', 542.0000, 'ºC'),
	(285954, 122, '2014-04-01 01:04:27.000000', 'temperatura', 1196.0000, 'ºC'),
	(285955, 122, '2014-04-01 01:04:28.000000', 'temperatura', 755.0000, 'ºC'),
	(285956, 122, '2014-04-01 01:04:29.000000', 'temperatura', 186.0000, 'ºC'),
	(285957, 122, '2014-04-01 01:04:30.000000', 'temperatura', 1068.0000, 'ºC'),
	(285958, 122, '2014-04-01 01:04:31.000000', 'temperatura', 1181.0000, 'ºC'),
	(285959, 122, '2014-04-01 01:04:32.000000', 'temperatura', 300.0000, 'ºC'),
	(285960, 122, '2014-04-01 01:04:33.000000', 'temperatura', 359.0000, 'ºC'),
	(285961, 122, '2014-04-01 01:04:34.000000', 'temperatura', 894.0000, 'ºC'),
	(285962, 122, '2014-04-01 01:04:35.000000', 'temperatura', 994.0000, 'ºC'),
	(285963, 122, '2014-04-01 01:04:36.000000', 'temperatura', 1090.0000, 'ºC'),
	(285964, 122, '2014-04-01 01:04:37.000000', 'temperatura', 66.0000, 'ºC'),
	(285965, 122, '2014-04-01 01:04:38.000000', 'temperatura', 660.0000, 'ºC'),
	(285966, 122, '2014-04-01 01:04:39.000000', 'temperatura', 704.0000, 'ºC'),
	(285967, 122, '2014-04-01 01:04:40.000000', 'temperatura', 340.0000, 'ºC'),
	(285968, 122, '2014-04-01 01:04:41.000000', 'temperatura', 790.0000, 'ºC'),
	(285969, 122, '2014-04-01 01:04:42.000000', 'temperatura', 529.0000, 'ºC'),
	(285970, 122, '2014-04-01 01:04:43.000000', 'temperatura', 278.0000, 'ºC'),
	(285971, 122, '2014-04-01 01:04:44.000000', 'temperatura', 1002.0000, 'ºC'),
	(285972, 122, '2014-04-01 01:04:45.000000', 'temperatura', 575.0000, 'ºC'),
	(285973, 122, '2014-04-01 01:04:46.000000', 'temperatura', 1070.0000, 'ºC'),
	(285974, 122, '2014-04-01 01:04:47.000000', 'temperatura', 26.0000, 'ºC'),
	(285975, 122, '2014-04-01 01:04:48.000000', 'temperatura', 519.0000, 'ºC'),
	(285976, 122, '2014-04-01 01:04:49.000000', 'temperatura', 116.0000, 'ºC'),
	(285977, 122, '2014-04-01 01:04:50.000000', 'temperatura', 227.0000, 'ºC'),
	(285978, 122, '2014-04-01 01:04:51.000000', 'temperatura', 786.0000, 'ºC'),
	(285979, 122, '2014-04-01 01:04:52.000000', 'temperatura', 849.0000, 'ºC'),
	(285980, 122, '2014-04-01 01:04:53.000000', 'temperatura', 689.0000, 'ºC'),
	(285981, 122, '2014-04-01 01:04:54.000000', 'temperatura', 899.0000, 'ºC'),
	(285982, 122, '2014-04-01 01:04:55.000000', 'temperatura', 27.0000, 'ºC'),
	(285983, 122, '2014-04-01 01:04:56.000000', 'temperatura', 1039.0000, 'ºC'),
	(285984, 122, '2014-04-01 01:04:57.000000', 'temperatura', 313.0000, 'ºC'),
	(285985, 122, '2014-04-01 01:04:58.000000', 'temperatura', 848.0000, 'ºC'),
	(285986, 122, '2014-04-01 01:04:59.000000', 'temperatura', 904.0000, 'ºC'),
	(285987, 122, '2014-04-01 01:05:00.000000', 'temperatura', 776.0000, 'ºC'),
	(285988, 122, '2014-04-01 01:05:01.000000', 'temperatura', 1167.0000, 'ºC'),
	(285989, 122, '2014-04-01 01:05:02.000000', 'temperatura', 1109.0000, 'ºC'),
	(285990, 122, '2014-04-01 01:05:03.000000', 'temperatura', 844.0000, 'ºC'),
	(285991, 122, '2014-04-01 01:05:04.000000', 'temperatura', 892.0000, 'ºC'),
	(285992, 122, '2014-04-01 01:05:05.000000', 'temperatura', 731.0000, 'ºC'),
	(285993, 122, '2014-04-01 01:05:06.000000', 'temperatura', 979.0000, 'ºC'),
	(285994, 122, '2014-04-01 01:05:07.000000', 'temperatura', 301.0000, 'ºC'),
	(285995, 122, '2014-04-01 01:05:08.000000', 'temperatura', 968.0000, 'ºC'),
	(285996, 122, '2014-04-01 01:05:09.000000', 'temperatura', 338.0000, 'ºC'),
	(285997, 122, '2014-04-01 01:05:10.000000', 'temperatura', 1186.0000, 'ºC'),
	(285998, 122, '2014-04-01 01:05:11.000000', 'temperatura', 118.0000, 'ºC'),
	(285999, 122, '2014-04-01 01:05:12.000000', 'temperatura', 631.0000, 'ºC'),
	(286000, 122, '2014-04-01 01:05:13.000000', 'temperatura', 401.0000, 'ºC'),
	(286001, 122, '2014-04-01 01:05:14.000000', 'temperatura', 113.0000, 'ºC'),
	(286002, 122, '2014-04-01 01:05:15.000000', 'temperatura', 562.0000, 'ºC'),
	(286003, 122, '2014-04-01 01:05:16.000000', 'temperatura', 71.0000, 'ºC'),
	(286004, 122, '2014-04-01 01:05:17.000000', 'temperatura', 1070.0000, 'ºC'),
	(286005, 122, '2014-04-01 01:05:18.000000', 'temperatura', 340.0000, 'ºC'),
	(286006, 122, '2014-04-01 01:05:19.000000', 'temperatura', 887.0000, 'ºC'),
	(286007, 122, '2014-04-01 01:05:20.000000', 'temperatura', 1018.0000, 'ºC'),
	(286008, 122, '2014-04-01 01:05:21.000000', 'temperatura', 30.0000, 'ºC'),
	(286009, 122, '2014-04-01 01:05:22.000000', 'temperatura', 696.0000, 'ºC'),
	(286010, 122, '2014-04-01 01:05:23.000000', 'temperatura', 991.0000, 'ºC'),
	(286011, 122, '2014-04-01 01:05:24.000000', 'temperatura', 466.0000, 'ºC'),
	(286012, 122, '2014-04-01 01:05:25.000000', 'temperatura', 559.0000, 'ºC'),
	(286013, 122, '2014-04-01 01:05:26.000000', 'temperatura', 198.0000, 'ºC'),
	(286014, 122, '2014-04-01 01:05:27.000000', 'temperatura', 512.0000, 'ºC'),
	(286015, 122, '2014-04-01 01:05:28.000000', 'temperatura', 765.0000, 'ºC'),
	(286016, 122, '2014-04-01 01:05:29.000000', 'temperatura', 1091.0000, 'ºC'),
	(286017, 122, '2014-04-01 01:05:30.000000', 'temperatura', 760.0000, 'ºC'),
	(286018, 122, '2014-04-01 01:05:31.000000', 'temperatura', 527.0000, 'ºC'),
	(286019, 122, '2014-04-01 01:05:32.000000', 'temperatura', 357.0000, 'ºC'),
	(286020, 122, '2014-04-01 01:05:33.000000', 'temperatura', 205.0000, 'ºC'),
	(286021, 122, '2014-04-01 01:05:34.000000', 'temperatura', 1154.0000, 'ºC'),
	(286022, 122, '2014-04-01 01:05:35.000000', 'temperatura', 354.0000, 'ºC'),
	(286023, 122, '2014-04-01 01:05:36.000000', 'temperatura', 708.0000, 'ºC'),
	(286024, 122, '2014-04-01 01:05:37.000000', 'temperatura', 79.0000, 'ºC'),
	(286025, 122, '2014-04-01 01:05:38.000000', 'temperatura', 674.0000, 'ºC'),
	(286026, 122, '2014-04-01 01:05:39.000000', 'temperatura', 730.0000, 'ºC'),
	(286027, 122, '2014-04-01 01:05:40.000000', 'temperatura', 431.0000, 'ºC'),
	(286028, 122, '2014-04-01 01:05:41.000000', 'temperatura', 1165.0000, 'ºC'),
	(286029, 122, '2014-04-01 01:05:42.000000', 'temperatura', 932.0000, 'ºC'),
	(286030, 122, '2014-04-01 01:05:43.000000', 'temperatura', 1164.0000, 'ºC'),
	(286031, 122, '2014-04-01 01:05:44.000000', 'temperatura', 626.0000, 'ºC'),
	(286032, 122, '2014-04-01 01:05:45.000000', 'temperatura', 836.0000, 'ºC'),
	(286033, 122, '2014-04-01 01:05:46.000000', 'temperatura', 1105.0000, 'ºC'),
	(286034, 122, '2014-04-01 01:05:47.000000', 'temperatura', 617.0000, 'ºC'),
	(286035, 122, '2014-04-01 01:05:48.000000', 'temperatura', 971.0000, 'ºC'),
	(286036, 122, '2014-04-01 01:05:49.000000', 'temperatura', 606.0000, 'ºC'),
	(286037, 122, '2014-04-01 01:05:50.000000', 'temperatura', 116.0000, 'ºC'),
	(286038, 122, '2014-04-01 01:05:51.000000', 'temperatura', 1164.0000, 'ºC'),
	(286039, 122, '2014-04-01 01:05:52.000000', 'temperatura', 673.0000, 'ºC'),
	(286040, 122, '2014-04-01 01:05:53.000000', 'temperatura', 1070.0000, 'ºC'),
	(286041, 122, '2014-04-01 01:05:54.000000', 'temperatura', 935.0000, 'ºC'),
	(286042, 122, '2014-04-01 01:05:55.000000', 'temperatura', 264.0000, 'ºC'),
	(286043, 122, '2014-04-01 01:05:56.000000', 'temperatura', 916.0000, 'ºC'),
	(286044, 122, '2014-04-01 01:05:57.000000', 'temperatura', 188.0000, 'ºC'),
	(286045, 122, '2014-04-01 01:05:58.000000', 'temperatura', 591.0000, 'ºC'),
	(286046, 122, '2014-04-01 01:05:59.000000', 'temperatura', 1195.0000, 'ºC'),
	(286047, 122, '2014-04-01 01:06:00.000000', 'temperatura', 599.0000, 'ºC'),
	(286048, 122, '2014-04-01 01:06:01.000000', 'temperatura', 613.0000, 'ºC'),
	(286049, 122, '2014-04-01 01:06:02.000000', 'temperatura', 70.0000, 'ºC'),
	(286050, 122, '2014-04-01 01:06:03.000000', 'temperatura', 908.0000, 'ºC'),
	(286051, 122, '2014-04-01 01:06:04.000000', 'temperatura', 733.0000, 'ºC'),
	(286052, 122, '2014-04-01 01:06:05.000000', 'temperatura', 939.0000, 'ºC'),
	(286053, 122, '2014-04-01 01:06:06.000000', 'temperatura', 98.0000, 'ºC'),
	(286054, 122, '2014-04-01 01:06:07.000000', 'temperatura', 73.0000, 'ºC'),
	(286055, 122, '2014-04-01 01:06:08.000000', 'temperatura', 74.0000, 'ºC'),
	(286056, 122, '2014-04-01 01:06:09.000000', 'temperatura', 149.0000, 'ºC'),
	(286057, 122, '2014-04-01 01:06:10.000000', 'temperatura', 523.0000, 'ºC'),
	(286058, 122, '2014-04-01 01:06:11.000000', 'temperatura', 969.0000, 'ºC'),
	(286059, 122, '2014-04-01 01:06:12.000000', 'temperatura', 878.0000, 'ºC'),
	(286060, 122, '2014-04-01 01:06:13.000000', 'temperatura', 281.0000, 'ºC'),
	(286061, 122, '2014-04-01 01:06:14.000000', 'temperatura', 1174.0000, 'ºC'),
	(286062, 122, '2014-04-01 01:06:15.000000', 'temperatura', 225.0000, 'ºC'),
	(286063, 122, '2014-04-01 01:06:16.000000', 'temperatura', 4.0000, 'ºC'),
	(286064, 122, '2014-04-01 01:06:17.000000', 'temperatura', 546.0000, 'ºC'),
	(286065, 122, '2014-04-01 01:06:18.000000', 'temperatura', 320.0000, 'ºC'),
	(286066, 122, '2014-04-01 01:06:19.000000', 'temperatura', 1161.0000, 'ºC'),
	(286067, 122, '2014-04-01 01:06:20.000000', 'temperatura', 45.0000, 'ºC'),
	(286068, 122, '2014-04-01 01:06:21.000000', 'temperatura', 345.0000, 'ºC'),
	(286069, 122, '2014-04-01 01:06:22.000000', 'temperatura', 388.0000, 'ºC'),
	(286070, 122, '2014-04-01 01:06:23.000000', 'temperatura', 904.0000, 'ºC'),
	(286071, 122, '2014-04-01 01:06:24.000000', 'temperatura', 960.0000, 'ºC'),
	(286072, 122, '2014-04-01 01:06:25.000000', 'temperatura', 886.0000, 'ºC'),
	(286073, 122, '2014-04-01 01:06:26.000000', 'temperatura', 349.0000, 'ºC'),
	(286074, 122, '2014-04-01 01:06:27.000000', 'temperatura', 290.0000, 'ºC'),
	(286075, 122, '2014-04-01 01:06:28.000000', 'temperatura', 403.0000, 'ºC'),
	(286076, 122, '2014-04-01 01:06:29.000000', 'temperatura', 1145.0000, 'ºC'),
	(286077, 122, '2014-04-01 01:06:30.000000', 'temperatura', 917.0000, 'ºC'),
	(286078, 122, '2014-04-01 01:06:31.000000', 'temperatura', 1151.0000, 'ºC'),
	(286079, 122, '2014-04-01 01:06:32.000000', 'temperatura', 604.0000, 'ºC'),
	(286080, 122, '2014-04-01 01:06:33.000000', 'temperatura', 766.0000, 'ºC'),
	(286081, 122, '2014-04-01 01:06:34.000000', 'temperatura', 818.0000, 'ºC'),
	(286082, 122, '2014-04-01 01:06:35.000000', 'temperatura', 595.0000, 'ºC'),
	(286083, 122, '2014-04-01 01:06:36.000000', 'temperatura', 520.0000, 'ºC'),
	(286084, 122, '2014-04-01 01:06:37.000000', 'temperatura', 818.0000, 'ºC'),
	(286085, 122, '2014-04-01 01:06:38.000000', 'temperatura', 129.0000, 'ºC'),
	(286086, 122, '2014-04-01 01:06:39.000000', 'temperatura', 591.0000, 'ºC'),
	(286087, 122, '2014-04-01 01:06:40.000000', 'temperatura', 170.0000, 'ºC'),
	(286088, 122, '2014-04-01 01:06:41.000000', 'temperatura', 276.0000, 'ºC'),
	(286089, 122, '2014-04-01 01:06:42.000000', 'temperatura', 873.0000, 'ºC'),
	(286090, 122, '2014-04-01 01:06:43.000000', 'temperatura', 1137.0000, 'ºC'),
	(286091, 122, '2014-04-01 01:06:44.000000', 'temperatura', 664.0000, 'ºC'),
	(286092, 122, '2014-04-01 01:06:45.000000', 'temperatura', 1111.0000, 'ºC'),
	(286093, 122, '2014-04-01 01:06:46.000000', 'temperatura', 1165.0000, 'ºC'),
	(286094, 122, '2014-04-01 01:06:47.000000', 'temperatura', 92.0000, 'ºC'),
	(286095, 122, '2014-04-01 01:06:48.000000', 'temperatura', 563.0000, 'ºC'),
	(286096, 122, '2014-04-01 01:06:49.000000', 'temperatura', 141.0000, 'ºC'),
	(286097, 122, '2014-04-01 01:06:50.000000', 'temperatura', 216.0000, 'ºC'),
	(286098, 122, '2014-04-01 01:06:51.000000', 'temperatura', 657.0000, 'ºC'),
	(286099, 122, '2014-04-01 01:06:52.000000', 'temperatura', 237.0000, 'ºC'),
	(286100, 122, '2014-04-01 01:06:53.000000', 'temperatura', 413.0000, 'ºC'),
	(286101, 122, '2014-04-01 01:06:54.000000', 'temperatura', 157.0000, 'ºC'),
	(286102, 122, '2014-04-01 01:06:55.000000', 'temperatura', 748.0000, 'ºC'),
	(286103, 122, '2014-04-01 01:06:56.000000', 'temperatura', 867.0000, 'ºC'),
	(286104, 122, '2014-04-01 01:06:57.000000', 'temperatura', 893.0000, 'ºC'),
	(286105, 122, '2014-04-01 01:06:58.000000', 'temperatura', 666.0000, 'ºC'),
	(286106, 122, '2014-04-01 01:06:59.000000', 'temperatura', 648.0000, 'ºC'),
	(286107, 122, '2014-04-01 01:07:00.000000', 'temperatura', 46.0000, 'ºC'),
	(286108, 122, '2014-04-01 01:07:01.000000', 'temperatura', 684.0000, 'ºC'),
	(286109, 122, '2014-04-01 01:07:02.000000', 'temperatura', 885.0000, 'ºC'),
	(286110, 122, '2014-04-01 01:07:03.000000', 'temperatura', 1170.0000, 'ºC'),
	(286111, 122, '2014-04-01 01:07:04.000000', 'temperatura', 799.0000, 'ºC'),
	(286112, 122, '2014-04-01 01:07:05.000000', 'temperatura', 485.0000, 'ºC'),
	(286113, 122, '2014-04-01 01:07:06.000000', 'temperatura', 28.0000, 'ºC'),
	(286114, 122, '2014-04-01 01:07:07.000000', 'temperatura', 1087.0000, 'ºC'),
	(286115, 122, '2014-04-01 01:07:08.000000', 'temperatura', 549.0000, 'ºC'),
	(286116, 122, '2014-04-01 01:07:09.000000', 'temperatura', 687.0000, 'ºC'),
	(286117, 122, '2014-04-01 01:07:10.000000', 'temperatura', 586.0000, 'ºC'),
	(286118, 122, '2014-04-01 01:07:11.000000', 'temperatura', 870.0000, 'ºC'),
	(286119, 122, '2014-04-01 01:07:12.000000', 'temperatura', 194.0000, 'ºC'),
	(286120, 122, '2014-04-01 01:07:13.000000', 'temperatura', 758.0000, 'ºC'),
	(286121, 122, '2014-04-01 01:07:14.000000', 'temperatura', 811.0000, 'ºC'),
	(286122, 122, '2014-04-01 01:07:15.000000', 'temperatura', 582.0000, 'ºC'),
	(286123, 122, '2014-04-01 01:07:16.000000', 'temperatura', 477.0000, 'ºC'),
	(286124, 122, '2014-04-01 01:07:17.000000', 'temperatura', 637.0000, 'ºC'),
	(286125, 122, '2014-04-01 01:07:18.000000', 'temperatura', 558.0000, 'ºC'),
	(286126, 122, '2014-04-01 01:07:19.000000', 'temperatura', 878.0000, 'ºC'),
	(286127, 122, '2014-04-01 01:07:20.000000', 'temperatura', 319.0000, 'ºC'),
	(286128, 122, '2014-04-01 01:07:21.000000', 'temperatura', 159.0000, 'ºC'),
	(286129, 122, '2014-04-01 01:07:22.000000', 'temperatura', 1037.0000, 'ºC'),
	(286130, 122, '2014-04-01 01:07:23.000000', 'temperatura', 1110.0000, 'ºC'),
	(286131, 122, '2014-04-01 01:07:24.000000', 'temperatura', 40.0000, 'ºC'),
	(286132, 122, '2014-04-01 01:07:25.000000', 'temperatura', 469.0000, 'ºC'),
	(286133, 122, '2014-04-01 01:07:26.000000', 'temperatura', 1026.0000, 'ºC'),
	(286134, 122, '2014-04-01 01:07:27.000000', 'temperatura', 125.0000, 'ºC'),
	(286135, 122, '2014-04-01 01:07:28.000000', 'temperatura', 1147.0000, 'ºC'),
	(286136, 122, '2014-04-01 01:07:29.000000', 'temperatura', 561.0000, 'ºC'),
	(286137, 122, '2014-04-01 01:07:30.000000', 'temperatura', 562.0000, 'ºC'),
	(286138, 122, '2014-04-01 01:07:31.000000', 'temperatura', 1130.0000, 'ºC'),
	(286139, 122, '2014-04-01 01:07:32.000000', 'temperatura', 365.0000, 'ºC'),
	(286140, 122, '2014-04-01 01:07:33.000000', 'temperatura', 834.0000, 'ºC'),
	(286141, 122, '2014-04-01 01:07:34.000000', 'temperatura', 678.0000, 'ºC'),
	(286142, 122, '2014-04-01 01:07:35.000000', 'temperatura', 887.0000, 'ºC'),
	(286143, 122, '2014-04-01 01:07:36.000000', 'temperatura', 0.0000, 'ºC'),
	(286144, 122, '2014-04-01 01:07:37.000000', 'temperatura', 941.0000, 'ºC'),
	(286145, 122, '2014-04-01 01:07:38.000000', 'temperatura', 1106.0000, 'ºC'),
	(286146, 122, '2014-04-01 01:07:39.000000', 'temperatura', 306.0000, 'ºC'),
	(286147, 122, '2014-04-01 01:07:40.000000', 'temperatura', 614.0000, 'ºC'),
	(286148, 122, '2014-04-01 01:07:41.000000', 'temperatura', 951.0000, 'ºC'),
	(286149, 122, '2014-04-01 01:07:42.000000', 'temperatura', 513.0000, 'ºC'),
	(286150, 122, '2014-04-01 01:07:43.000000', 'temperatura', 912.0000, 'ºC'),
	(286151, 122, '2014-04-01 01:07:44.000000', 'temperatura', 624.0000, 'ºC'),
	(286152, 122, '2014-04-01 01:07:45.000000', 'temperatura', 383.0000, 'ºC'),
	(286153, 122, '2014-04-01 01:07:46.000000', 'temperatura', 44.0000, 'ºC'),
	(286154, 122, '2014-04-01 01:07:47.000000', 'temperatura', 272.0000, 'ºC'),
	(286155, 122, '2014-04-01 01:07:48.000000', 'temperatura', 29.0000, 'ºC'),
	(286156, 122, '2014-04-01 01:07:49.000000', 'temperatura', 529.0000, 'ºC'),
	(286157, 122, '2014-04-01 01:07:50.000000', 'temperatura', 160.0000, 'ºC'),
	(286158, 122, '2014-04-01 01:07:51.000000', 'temperatura', 412.0000, 'ºC'),
	(286159, 122, '2014-04-01 01:07:52.000000', 'temperatura', 382.0000, 'ºC'),
	(286160, 122, '2014-04-01 01:07:53.000000', 'temperatura', 675.0000, 'ºC'),
	(286161, 122, '2014-04-01 01:07:54.000000', 'temperatura', 1027.0000, 'ºC'),
	(286162, 122, '2014-04-01 01:07:55.000000', 'temperatura', 713.0000, 'ºC'),
	(286163, 122, '2014-04-01 01:07:56.000000', 'temperatura', 485.0000, 'ºC'),
	(286164, 122, '2014-04-01 01:07:57.000000', 'temperatura', 286.0000, 'ºC'),
	(286165, 122, '2014-04-01 01:07:58.000000', 'temperatura', 1177.0000, 'ºC'),
	(286166, 122, '2014-04-01 01:07:59.000000', 'temperatura', 226.0000, 'ºC'),
	(286167, 122, '2014-04-01 01:08:00.000000', 'temperatura', 1198.0000, 'ºC'),
	(286168, 122, '2014-04-01 01:08:01.000000', 'temperatura', 512.0000, 'ºC'),
	(286169, 122, '2014-04-01 01:08:02.000000', 'temperatura', 169.0000, 'ºC'),
	(286170, 122, '2014-04-01 01:08:03.000000', 'temperatura', 507.0000, 'ºC'),
	(286171, 122, '2014-04-01 01:08:04.000000', 'temperatura', 830.0000, 'ºC'),
	(286172, 122, '2014-04-01 01:08:05.000000', 'temperatura', 229.0000, 'ºC'),
	(286173, 122, '2014-04-01 01:08:06.000000', 'temperatura', 1057.0000, 'ºC'),
	(286174, 122, '2014-04-01 01:08:07.000000', 'temperatura', 999.0000, 'ºC'),
	(286175, 122, '2014-04-01 01:08:08.000000', 'temperatura', 622.0000, 'ºC'),
	(286176, 122, '2014-04-01 01:08:09.000000', 'temperatura', 116.0000, 'ºC'),
	(286177, 122, '2014-04-01 01:08:10.000000', 'temperatura', 1115.0000, 'ºC'),
	(286178, 122, '2014-04-01 01:08:11.000000', 'temperatura', 426.0000, 'ºC'),
	(286179, 122, '2014-04-01 01:08:12.000000', 'temperatura', 1187.0000, 'ºC'),
	(286180, 122, '2014-04-01 01:08:13.000000', 'temperatura', 1058.0000, 'ºC'),
	(286181, 122, '2014-04-01 01:08:14.000000', 'temperatura', 527.0000, 'ºC'),
	(286182, 122, '2014-04-01 01:08:15.000000', 'temperatura', 661.0000, 'ºC'),
	(286183, 122, '2014-04-01 01:08:16.000000', 'temperatura', 526.0000, 'ºC'),
	(286184, 122, '2014-04-01 01:08:17.000000', 'temperatura', 646.0000, 'ºC'),
	(286185, 122, '2014-04-01 01:08:18.000000', 'temperatura', 454.0000, 'ºC'),
	(286186, 122, '2014-04-01 01:08:19.000000', 'temperatura', 334.0000, 'ºC'),
	(286187, 122, '2014-04-01 01:08:20.000000', 'temperatura', 308.0000, 'ºC'),
	(286188, 122, '2014-04-01 01:08:21.000000', 'temperatura', 537.0000, 'ºC'),
	(286189, 122, '2014-04-01 01:08:22.000000', 'temperatura', 561.0000, 'ºC'),
	(286190, 122, '2014-04-01 01:08:23.000000', 'temperatura', 1195.0000, 'ºC'),
	(286191, 122, '2014-04-01 01:08:24.000000', 'temperatura', 694.0000, 'ºC'),
	(286192, 122, '2014-04-01 01:08:25.000000', 'temperatura', 1082.0000, 'ºC'),
	(286193, 122, '2014-04-01 01:08:26.000000', 'temperatura', 932.0000, 'ºC'),
	(286194, 122, '2014-04-01 01:08:27.000000', 'temperatura', 215.0000, 'ºC'),
	(286195, 122, '2014-04-01 01:08:28.000000', 'temperatura', 678.0000, 'ºC'),
	(286196, 122, '2014-04-01 01:08:29.000000', 'temperatura', 346.0000, 'ºC'),
	(286197, 122, '2014-04-01 01:08:30.000000', 'temperatura', 895.0000, 'ºC'),
	(286198, 122, '2014-04-01 01:08:31.000000', 'temperatura', 1038.0000, 'ºC'),
	(286199, 122, '2014-04-01 01:08:32.000000', 'temperatura', 107.0000, 'ºC'),
	(286200, 122, '2014-04-01 01:08:33.000000', 'temperatura', 1019.0000, 'ºC'),
	(286201, 122, '2014-04-01 01:08:34.000000', 'temperatura', 1174.0000, 'ºC'),
	(286202, 122, '2014-04-01 01:08:35.000000', 'temperatura', 416.0000, 'ºC'),
	(286203, 122, '2014-04-01 01:08:36.000000', 'temperatura', 958.0000, 'ºC'),
	(286204, 122, '2014-04-01 01:08:37.000000', 'temperatura', 1141.0000, 'ºC'),
	(286205, 122, '2014-04-01 01:08:38.000000', 'temperatura', 432.0000, 'ºC'),
	(286206, 122, '2014-04-01 01:08:39.000000', 'temperatura', 1137.0000, 'ºC'),
	(286207, 122, '2014-04-01 01:08:40.000000', 'temperatura', 791.0000, 'ºC'),
	(286208, 122, '2014-04-01 01:08:41.000000', 'temperatura', 542.0000, 'ºC'),
	(286209, 122, '2014-04-01 01:08:42.000000', 'temperatura', 340.0000, 'ºC'),
	(286210, 122, '2014-04-01 01:08:43.000000', 'temperatura', 75.0000, 'ºC'),
	(286211, 122, '2014-04-01 01:08:44.000000', 'temperatura', 556.0000, 'ºC'),
	(286212, 122, '2014-04-01 01:08:45.000000', 'temperatura', 155.0000, 'ºC'),
	(286213, 122, '2014-04-01 01:08:46.000000', 'temperatura', 305.0000, 'ºC'),
	(286214, 122, '2014-04-01 01:08:47.000000', 'temperatura', 1062.0000, 'ºC'),
	(286215, 122, '2014-04-01 01:08:48.000000', 'temperatura', 797.0000, 'ºC'),
	(286216, 122, '2014-04-01 01:08:49.000000', 'temperatura', 800.0000, 'ºC'),
	(286217, 122, '2014-04-01 01:08:50.000000', 'temperatura', 409.0000, 'ºC'),
	(286218, 122, '2014-04-01 01:08:51.000000', 'temperatura', 844.0000, 'ºC'),
	(286219, 122, '2014-04-01 01:08:52.000000', 'temperatura', 594.0000, 'ºC'),
	(286220, 122, '2014-04-01 01:08:53.000000', 'temperatura', 438.0000, 'ºC'),
	(286221, 122, '2014-04-01 01:08:54.000000', 'temperatura', 408.0000, 'ºC'),
	(286222, 122, '2014-04-01 01:08:55.000000', 'temperatura', 727.0000, 'ºC'),
	(286223, 122, '2014-04-01 01:08:56.000000', 'temperatura', 11.0000, 'ºC'),
	(286224, 122, '2014-04-01 01:08:57.000000', 'temperatura', 274.0000, 'ºC'),
	(286225, 122, '2014-04-01 01:08:58.000000', 'temperatura', 136.0000, 'ºC'),
	(286226, 122, '2014-04-01 01:08:59.000000', 'temperatura', 1061.0000, 'ºC'),
	(286227, 122, '2014-04-01 01:09:00.000000', 'temperatura', 95.0000, 'ºC'),
	(286228, 122, '2014-04-01 01:09:01.000000', 'temperatura', 894.0000, 'ºC'),
	(286229, 122, '2014-04-01 01:09:02.000000', 'temperatura', 586.0000, 'ºC'),
	(286230, 122, '2014-04-01 01:09:03.000000', 'temperatura', 248.0000, 'ºC'),
	(286231, 122, '2014-04-01 01:09:04.000000', 'temperatura', 681.0000, 'ºC'),
	(286232, 122, '2014-04-01 01:09:05.000000', 'temperatura', 262.0000, 'ºC'),
	(286233, 122, '2014-04-01 01:09:06.000000', 'temperatura', 468.0000, 'ºC'),
	(286234, 122, '2014-04-01 01:09:07.000000', 'temperatura', 354.0000, 'ºC'),
	(286235, 122, '2014-04-01 01:09:08.000000', 'temperatura', 368.0000, 'ºC'),
	(286236, 122, '2014-04-01 01:09:09.000000', 'temperatura', 776.0000, 'ºC'),
	(286237, 122, '2014-04-01 01:09:10.000000', 'temperatura', 378.0000, 'ºC'),
	(286238, 122, '2014-04-01 01:09:11.000000', 'temperatura', 762.0000, 'ºC'),
	(286239, 122, '2014-04-01 01:09:12.000000', 'temperatura', 278.0000, 'ºC'),
	(286240, 122, '2014-04-01 01:09:13.000000', 'temperatura', 302.0000, 'ºC'),
	(286241, 122, '2014-04-01 01:09:14.000000', 'temperatura', 676.0000, 'ºC'),
	(286242, 122, '2014-04-01 01:09:15.000000', 'temperatura', 77.0000, 'ºC'),
	(286243, 122, '2014-04-01 01:09:16.000000', 'temperatura', 757.0000, 'ºC'),
	(286244, 122, '2014-04-01 01:09:17.000000', 'temperatura', 1152.0000, 'ºC'),
	(286245, 122, '2014-04-01 01:09:18.000000', 'temperatura', 1093.0000, 'ºC'),
	(286246, 122, '2014-04-01 01:09:19.000000', 'temperatura', 806.0000, 'ºC'),
	(286247, 122, '2014-04-01 01:09:20.000000', 'temperatura', 753.0000, 'ºC'),
	(286248, 122, '2014-04-01 01:09:21.000000', 'temperatura', 150.0000, 'ºC'),
	(286249, 122, '2014-04-01 01:09:22.000000', 'temperatura', 888.0000, 'ºC'),
	(286250, 122, '2014-04-01 01:09:23.000000', 'temperatura', 390.0000, 'ºC'),
	(286251, 122, '2014-04-01 01:09:24.000000', 'temperatura', 489.0000, 'ºC'),
	(286252, 122, '2014-04-01 01:09:25.000000', 'temperatura', 76.0000, 'ºC'),
	(286253, 122, '2014-04-01 01:09:26.000000', 'temperatura', 113.0000, 'ºC'),
	(286254, 122, '2014-04-01 01:09:27.000000', 'temperatura', 339.0000, 'ºC'),
	(286255, 122, '2014-04-01 01:09:28.000000', 'temperatura', 153.0000, 'ºC'),
	(286256, 122, '2014-04-01 01:09:29.000000', 'temperatura', 952.0000, 'ºC'),
	(286257, 122, '2014-04-01 01:09:30.000000', 'temperatura', 700.0000, 'ºC'),
	(286258, 122, '2014-04-01 01:09:31.000000', 'temperatura', 643.0000, 'ºC'),
	(286259, 122, '2014-04-01 01:09:32.000000', 'temperatura', 1116.0000, 'ºC'),
	(286260, 122, '2014-04-01 01:09:33.000000', 'temperatura', 51.0000, 'ºC'),
	(286261, 122, '2014-04-01 01:09:34.000000', 'temperatura', 508.0000, 'ºC'),
	(286262, 122, '2014-04-01 01:09:35.000000', 'temperatura', 1189.0000, 'ºC'),
	(286263, 122, '2014-04-01 01:09:36.000000', 'temperatura', 821.0000, 'ºC'),
	(286264, 122, '2014-04-01 01:09:37.000000', 'temperatura', 537.0000, 'ºC'),
	(286265, 122, '2014-04-01 01:09:38.000000', 'temperatura', 222.0000, 'ºC'),
	(286266, 122, '2014-04-01 01:09:39.000000', 'temperatura', 699.0000, 'ºC'),
	(286267, 122, '2014-04-01 01:09:40.000000', 'temperatura', 429.0000, 'ºC'),
	(286268, 122, '2014-04-01 01:09:41.000000', 'temperatura', 48.0000, 'ºC'),
	(286269, 122, '2014-04-01 01:09:42.000000', 'temperatura', 153.0000, 'ºC'),
	(286270, 122, '2014-04-01 01:09:43.000000', 'temperatura', 623.0000, 'ºC'),
	(286271, 122, '2014-04-01 01:09:44.000000', 'temperatura', 256.0000, 'ºC'),
	(286272, 122, '2014-04-01 01:09:45.000000', 'temperatura', 614.0000, 'ºC'),
	(286273, 122, '2014-04-01 01:09:46.000000', 'temperatura', 1100.0000, 'ºC'),
	(286274, 122, '2014-04-01 01:09:47.000000', 'temperatura', 59.0000, 'ºC'),
	(286275, 122, '2014-04-01 01:09:48.000000', 'temperatura', 595.0000, 'ºC'),
	(286276, 122, '2014-04-01 01:09:49.000000', 'temperatura', 398.0000, 'ºC'),
	(286277, 122, '2014-04-01 01:09:50.000000', 'temperatura', 207.0000, 'ºC'),
	(286278, 122, '2014-04-01 01:09:51.000000', 'temperatura', 1040.0000, 'ºC'),
	(286279, 122, '2014-04-01 01:09:52.000000', 'temperatura', 978.0000, 'ºC'),
	(286280, 122, '2014-04-01 01:09:53.000000', 'temperatura', 574.0000, 'ºC'),
	(286281, 122, '2014-04-01 01:09:54.000000', 'temperatura', 1134.0000, 'ºC'),
	(286282, 122, '2014-04-01 01:09:55.000000', 'temperatura', 347.0000, 'ºC'),
	(286283, 122, '2014-04-01 01:09:56.000000', 'temperatura', 736.0000, 'ºC'),
	(286284, 122, '2014-04-01 01:09:57.000000', 'temperatura', 240.0000, 'ºC'),
	(286285, 122, '2014-04-01 01:09:58.000000', 'temperatura', 193.0000, 'ºC'),
	(286286, 122, '2014-04-01 01:09:59.000000', 'temperatura', 244.0000, 'ºC'),
	(286287, 122, '2014-04-01 01:10:00.000000', 'temperatura', 644.0000, 'ºC'),
	(286288, 122, '2014-04-01 01:10:01.000000', 'temperatura', 86.0000, 'ºC'),
	(286289, 122, '2014-04-01 01:10:02.000000', 'temperatura', 900.0000, 'ºC'),
	(286290, 122, '2014-04-01 01:10:03.000000', 'temperatura', 642.0000, 'ºC'),
	(286291, 122, '2014-04-01 01:10:04.000000', 'temperatura', 510.0000, 'ºC'),
	(286292, 122, '2014-04-01 01:10:05.000000', 'temperatura', 625.0000, 'ºC'),
	(286293, 122, '2014-04-01 01:10:06.000000', 'temperatura', 397.0000, 'ºC'),
	(286294, 122, '2014-04-01 01:10:07.000000', 'temperatura', 111.0000, 'ºC'),
	(286295, 122, '2014-04-01 01:10:08.000000', 'temperatura', 562.0000, 'ºC'),
	(286296, 122, '2014-04-01 01:10:09.000000', 'temperatura', 80.0000, 'ºC'),
	(286297, 122, '2014-04-01 01:10:10.000000', 'temperatura', 1112.0000, 'ºC'),
	(286298, 122, '2014-04-01 01:10:11.000000', 'temperatura', 522.0000, 'ºC'),
	(286299, 122, '2014-04-01 01:10:12.000000', 'temperatura', 474.0000, 'ºC'),
	(286300, 122, '2014-04-01 01:10:13.000000', 'temperatura', 803.0000, 'ºC'),
	(286301, 122, '2014-04-01 01:10:14.000000', 'temperatura', 193.0000, 'ºC'),
	(286302, 122, '2014-04-01 01:10:15.000000', 'temperatura', 956.0000, 'ºC'),
	(286303, 122, '2014-04-01 01:10:16.000000', 'temperatura', 604.0000, 'ºC'),
	(286304, 122, '2014-04-01 01:10:17.000000', 'temperatura', 151.0000, 'ºC'),
	(286305, 122, '2014-04-01 01:10:18.000000', 'temperatura', 145.0000, 'ºC'),
	(286306, 122, '2014-04-01 01:10:19.000000', 'temperatura', 271.0000, 'ºC'),
	(286307, 122, '2014-04-01 01:10:20.000000', 'temperatura', 923.0000, 'ºC'),
	(286308, 122, '2014-04-01 01:10:21.000000', 'temperatura', 199.0000, 'ºC'),
	(286309, 122, '2014-04-01 01:10:22.000000', 'temperatura', 628.0000, 'ºC'),
	(286310, 122, '2014-04-01 01:10:23.000000', 'temperatura', 143.0000, 'ºC'),
	(286311, 122, '2014-04-01 01:10:24.000000', 'temperatura', 34.0000, 'ºC'),
	(286312, 122, '2014-04-01 01:10:25.000000', 'temperatura', 938.0000, 'ºC'),
	(286313, 122, '2014-04-01 01:10:26.000000', 'temperatura', 991.0000, 'ºC'),
	(286314, 122, '2014-04-01 01:10:27.000000', 'temperatura', 940.0000, 'ºC'),
	(286315, 122, '2014-04-01 01:10:28.000000', 'temperatura', 527.0000, 'ºC'),
	(286316, 122, '2014-04-01 01:10:29.000000', 'temperatura', 1014.0000, 'ºC'),
	(286317, 122, '2014-04-01 01:10:30.000000', 'temperatura', 1092.0000, 'ºC'),
	(286318, 122, '2014-04-01 01:10:31.000000', 'temperatura', 16.0000, 'ºC'),
	(286319, 122, '2014-04-01 01:10:32.000000', 'temperatura', 404.0000, 'ºC'),
	(286320, 122, '2014-04-01 01:10:33.000000', 'temperatura', 776.0000, 'ºC'),
	(286321, 122, '2014-04-01 01:10:34.000000', 'temperatura', 266.0000, 'ºC'),
	(286322, 122, '2014-04-01 01:10:35.000000', 'temperatura', 205.0000, 'ºC'),
	(286323, 122, '2014-04-01 01:10:36.000000', 'temperatura', 225.0000, 'ºC'),
	(286324, 122, '2014-04-01 01:10:37.000000', 'temperatura', 509.0000, 'ºC'),
	(286325, 122, '2014-04-01 01:10:38.000000', 'temperatura', 673.0000, 'ºC'),
	(286326, 122, '2014-04-01 01:10:39.000000', 'temperatura', 639.0000, 'ºC'),
	(286327, 122, '2014-04-01 01:10:40.000000', 'temperatura', 1177.0000, 'ºC'),
	(286328, 122, '2014-04-01 01:10:41.000000', 'temperatura', 367.0000, 'ºC'),
	(286329, 122, '2014-04-01 01:10:42.000000', 'temperatura', 705.0000, 'ºC'),
	(286330, 122, '2014-04-01 01:10:43.000000', 'temperatura', 24.0000, 'ºC'),
	(286331, 122, '2014-04-01 01:10:44.000000', 'temperatura', 404.0000, 'ºC'),
	(286332, 122, '2014-04-01 01:10:45.000000', 'temperatura', 749.0000, 'ºC'),
	(286333, 122, '2014-04-01 01:10:46.000000', 'temperatura', 135.0000, 'ºC'),
	(286334, 122, '2014-04-01 01:10:47.000000', 'temperatura', 826.0000, 'ºC'),
	(286335, 122, '2014-04-01 01:10:48.000000', 'temperatura', 128.0000, 'ºC'),
	(286336, 122, '2014-04-01 01:10:49.000000', 'temperatura', 561.0000, 'ºC'),
	(286337, 122, '2014-04-01 01:10:50.000000', 'temperatura', 20.0000, 'ºC'),
	(286338, 122, '2014-04-01 01:10:51.000000', 'temperatura', 820.0000, 'ºC'),
	(286339, 122, '2014-04-01 01:10:52.000000', 'temperatura', 438.0000, 'ºC'),
	(286340, 122, '2014-04-01 01:10:53.000000', 'temperatura', 934.0000, 'ºC'),
	(286341, 122, '2014-04-01 01:10:54.000000', 'temperatura', 954.0000, 'ºC'),
	(286342, 122, '2014-04-01 01:10:55.000000', 'temperatura', 770.0000, 'ºC'),
	(286343, 122, '2014-04-01 01:10:56.000000', 'temperatura', 987.0000, 'ºC'),
	(286344, 122, '2014-04-01 01:10:57.000000', 'temperatura', 226.0000, 'ºC'),
	(286345, 122, '2014-04-01 01:10:58.000000', 'temperatura', 569.0000, 'ºC'),
	(286346, 122, '2014-04-01 01:10:59.000000', 'temperatura', 967.0000, 'ºC'),
	(286347, 122, '2014-04-01 01:11:00.000000', 'temperatura', 727.0000, 'ºC'),
	(286348, 122, '2014-04-01 01:11:01.000000', 'temperatura', 737.0000, 'ºC'),
	(286349, 122, '2014-04-01 01:11:02.000000', 'temperatura', 303.0000, 'ºC'),
	(286350, 122, '2014-04-01 01:11:03.000000', 'temperatura', 507.0000, 'ºC'),
	(286351, 122, '2014-04-01 01:11:04.000000', 'temperatura', 423.0000, 'ºC'),
	(286352, 122, '2014-04-01 01:11:05.000000', 'temperatura', 598.0000, 'ºC'),
	(286353, 122, '2014-04-01 01:11:06.000000', 'temperatura', 520.0000, 'ºC'),
	(286354, 122, '2014-04-01 01:11:07.000000', 'temperatura', 806.0000, 'ºC'),
	(286355, 122, '2014-04-01 01:11:08.000000', 'temperatura', 71.0000, 'ºC'),
	(286356, 122, '2014-04-01 01:11:09.000000', 'temperatura', 339.0000, 'ºC'),
	(286357, 122, '2014-04-01 01:11:10.000000', 'temperatura', 281.0000, 'ºC'),
	(286358, 122, '2014-04-01 01:11:11.000000', 'temperatura', 388.0000, 'ºC'),
	(286359, 122, '2014-04-01 01:11:12.000000', 'temperatura', 1097.0000, 'ºC'),
	(286360, 122, '2014-04-01 01:11:13.000000', 'temperatura', 723.0000, 'ºC'),
	(286361, 122, '2014-04-01 01:11:14.000000', 'temperatura', 325.0000, 'ºC'),
	(286362, 122, '2014-04-01 01:11:15.000000', 'temperatura', 656.0000, 'ºC'),
	(286363, 122, '2014-04-01 01:11:16.000000', 'temperatura', 1105.0000, 'ºC'),
	(286364, 122, '2014-04-01 01:11:17.000000', 'temperatura', 1160.0000, 'ºC'),
	(286365, 122, '2014-04-01 01:11:18.000000', 'temperatura', 83.0000, 'ºC'),
	(286366, 122, '2014-04-01 01:11:19.000000', 'temperatura', 535.0000, 'ºC'),
	(286367, 122, '2014-04-01 01:11:20.000000', 'temperatura', 28.0000, 'ºC'),
	(286368, 122, '2014-04-01 01:11:21.000000', 'temperatura', 934.0000, 'ºC'),
	(286369, 122, '2014-04-01 01:11:22.000000', 'temperatura', 986.0000, 'ºC'),
	(286370, 122, '2014-04-01 01:11:23.000000', 'temperatura', 928.0000, 'ºC'),
	(286371, 122, '2014-04-01 01:11:24.000000', 'temperatura', 485.0000, 'ºC'),
	(286372, 122, '2014-04-01 01:11:25.000000', 'temperatura', 841.0000, 'ºC'),
	(286373, 122, '2014-04-01 01:11:26.000000', 'temperatura', 348.0000, 'ºC'),
	(286374, 122, '2014-04-01 01:11:27.000000', 'temperatura', 419.0000, 'ºC'),
	(286375, 122, '2014-04-01 01:11:28.000000', 'temperatura', 1051.0000, 'ºC'),
	(286376, 122, '2014-04-01 01:11:29.000000', 'temperatura', 399.0000, 'ºC'),
	(286377, 122, '2014-04-01 01:11:30.000000', 'temperatura', 44.0000, 'ºC'),
	(286378, 122, '2014-04-01 01:11:31.000000', 'temperatura', 221.0000, 'ºC'),
	(286379, 122, '2014-04-01 01:11:32.000000', 'temperatura', 974.0000, 'ºC'),
	(286380, 122, '2014-04-01 01:11:33.000000', 'temperatura', 609.0000, 'ºC'),
	(286381, 122, '2014-04-01 01:11:34.000000', 'temperatura', 124.0000, 'ºC'),
	(286382, 122, '2014-04-01 01:11:35.000000', 'temperatura', 1194.0000, 'ºC'),
	(286383, 122, '2014-04-01 01:11:36.000000', 'temperatura', 799.0000, 'ºC'),
	(286384, 122, '2014-04-01 01:11:37.000000', 'temperatura', 411.0000, 'ºC'),
	(286385, 122, '2014-04-01 01:11:38.000000', 'temperatura', 860.0000, 'ºC'),
	(286386, 122, '2014-04-01 01:11:39.000000', 'temperatura', 666.0000, 'ºC'),
	(286387, 122, '2014-04-01 01:11:40.000000', 'temperatura', 752.0000, 'ºC'),
	(286388, 122, '2014-04-01 01:11:41.000000', 'temperatura', 561.0000, 'ºC'),
	(286389, 122, '2014-04-01 01:11:42.000000', 'temperatura', 550.0000, 'ºC'),
	(286390, 122, '2014-04-01 01:11:43.000000', 'temperatura', 1068.0000, 'ºC'),
	(286391, 122, '2014-04-01 01:11:44.000000', 'temperatura', 89.0000, 'ºC'),
	(286392, 122, '2014-04-01 01:11:45.000000', 'temperatura', 842.0000, 'ºC'),
	(286393, 122, '2014-04-01 01:11:46.000000', 'temperatura', 343.0000, 'ºC'),
	(286394, 122, '2014-04-01 01:11:47.000000', 'temperatura', 388.0000, 'ºC'),
	(286395, 122, '2014-04-01 01:11:48.000000', 'temperatura', 913.0000, 'ºC'),
	(286396, 122, '2014-04-01 01:11:49.000000', 'temperatura', 1002.0000, 'ºC'),
	(286397, 122, '2014-04-01 01:11:50.000000', 'temperatura', 1071.0000, 'ºC'),
	(286398, 122, '2014-04-01 01:11:51.000000', 'temperatura', 1150.0000, 'ºC'),
	(286399, 122, '2014-04-01 01:11:52.000000', 'temperatura', 138.0000, 'ºC'),
	(286400, 122, '2014-04-01 01:11:53.000000', 'temperatura', 841.0000, 'ºC'),
	(286401, 122, '2014-04-01 01:11:54.000000', 'temperatura', 193.0000, 'ºC'),
	(286402, 122, '2014-04-01 01:11:55.000000', 'temperatura', 840.0000, 'ºC'),
	(286403, 122, '2014-04-01 01:11:56.000000', 'temperatura', 21.0000, 'ºC'),
	(286404, 122, '2014-04-01 01:11:57.000000', 'temperatura', 1186.0000, 'ºC'),
	(286405, 122, '2014-04-01 01:11:58.000000', 'temperatura', 1066.0000, 'ºC'),
	(286406, 122, '2014-04-01 01:11:59.000000', 'temperatura', 576.0000, 'ºC'),
	(286407, 122, '2014-04-01 01:12:00.000000', 'temperatura', 880.0000, 'ºC'),
	(286408, 122, '2014-04-01 01:12:01.000000', 'temperatura', 272.0000, 'ºC'),
	(286409, 122, '2014-04-01 01:12:02.000000', 'temperatura', 1122.0000, 'ºC'),
	(286410, 122, '2014-04-01 01:12:03.000000', 'temperatura', 1194.0000, 'ºC'),
	(286411, 122, '2014-04-01 01:12:04.000000', 'temperatura', 206.0000, 'ºC'),
	(286412, 122, '2014-04-01 01:12:05.000000', 'temperatura', 1046.0000, 'ºC'),
	(286413, 122, '2014-04-01 01:12:06.000000', 'temperatura', 1012.0000, 'ºC'),
	(286414, 122, '2014-04-01 01:12:07.000000', 'temperatura', 722.0000, 'ºC'),
	(286415, 122, '2014-04-01 01:12:08.000000', 'temperatura', 575.0000, 'ºC'),
	(286416, 122, '2014-04-01 01:12:09.000000', 'temperatura', 711.0000, 'ºC'),
	(286417, 122, '2014-04-01 01:12:10.000000', 'temperatura', 630.0000, 'ºC'),
	(286418, 122, '2014-04-01 01:12:11.000000', 'temperatura', 1016.0000, 'ºC'),
	(286419, 122, '2014-04-01 01:12:12.000000', 'temperatura', 793.0000, 'ºC'),
	(286420, 122, '2014-04-01 01:12:13.000000', 'temperatura', 917.0000, 'ºC'),
	(286421, 122, '2014-04-01 01:12:14.000000', 'temperatura', 1005.0000, 'ºC'),
	(286422, 122, '2014-04-01 01:12:15.000000', 'temperatura', 1075.0000, 'ºC'),
	(286423, 122, '2014-04-01 01:12:16.000000', 'temperatura', 1159.0000, 'ºC'),
	(286424, 122, '2014-04-01 01:12:17.000000', 'temperatura', 170.0000, 'ºC'),
	(286425, 122, '2014-04-01 01:12:18.000000', 'temperatura', 975.0000, 'ºC'),
	(286426, 122, '2014-04-01 01:12:19.000000', 'temperatura', 766.0000, 'ºC'),
	(286427, 122, '2014-04-01 01:12:20.000000', 'temperatura', 906.0000, 'ºC'),
	(286428, 122, '2014-04-01 01:12:21.000000', 'temperatura', 1033.0000, 'ºC'),
	(286429, 122, '2014-04-01 01:12:22.000000', 'temperatura', 45.0000, 'ºC'),
	(286430, 122, '2014-04-01 01:12:23.000000', 'temperatura', 728.0000, 'ºC'),
	(286431, 122, '2014-04-01 01:12:24.000000', 'temperatura', 1106.0000, 'ºC'),
	(286432, 122, '2014-04-01 01:12:25.000000', 'temperatura', 947.0000, 'ºC'),
	(286433, 122, '2014-04-01 01:12:26.000000', 'temperatura', 215.0000, 'ºC'),
	(286434, 122, '2014-04-01 01:12:27.000000', 'temperatura', 636.0000, 'ºC'),
	(286435, 122, '2014-04-01 01:12:28.000000', 'temperatura', 133.0000, 'ºC'),
	(286436, 122, '2014-04-01 01:12:29.000000', 'temperatura', 1160.0000, 'ºC'),
	(286437, 122, '2014-04-01 01:12:30.000000', 'temperatura', 603.0000, 'ºC'),
	(286438, 122, '2014-04-01 01:12:31.000000', 'temperatura', 733.0000, 'ºC'),
	(286439, 122, '2014-04-01 01:12:32.000000', 'temperatura', 657.0000, 'ºC'),
	(286440, 122, '2014-04-01 01:12:33.000000', 'temperatura', 1088.0000, 'ºC'),
	(286441, 122, '2014-04-01 01:12:34.000000', 'temperatura', 1068.0000, 'ºC'),
	(286442, 122, '2014-04-01 01:12:35.000000', 'temperatura', 878.0000, 'ºC'),
	(286443, 122, '2014-04-01 01:12:36.000000', 'temperatura', 1186.0000, 'ºC'),
	(286444, 122, '2014-04-01 01:12:37.000000', 'temperatura', 898.0000, 'ºC'),
	(286445, 122, '2014-04-01 01:12:38.000000', 'temperatura', 931.0000, 'ºC'),
	(286446, 122, '2014-04-01 01:12:39.000000', 'temperatura', 764.0000, 'ºC'),
	(286447, 122, '2014-04-01 01:12:40.000000', 'temperatura', 1025.0000, 'ºC'),
	(286448, 122, '2014-04-01 01:12:41.000000', 'temperatura', 434.0000, 'ºC'),
	(286449, 122, '2014-04-01 01:12:42.000000', 'temperatura', 294.0000, 'ºC'),
	(286450, 122, '2014-04-01 01:12:43.000000', 'temperatura', 169.0000, 'ºC'),
	(286451, 122, '2014-04-01 01:12:44.000000', 'temperatura', 1163.0000, 'ºC'),
	(286452, 122, '2014-04-01 01:12:45.000000', 'temperatura', 511.0000, 'ºC'),
	(286453, 122, '2014-04-01 01:12:46.000000', 'temperatura', 264.0000, 'ºC'),
	(286454, 122, '2014-04-01 01:12:47.000000', 'temperatura', 987.0000, 'ºC'),
	(286455, 122, '2014-04-01 01:12:48.000000', 'temperatura', 544.0000, 'ºC'),
	(286456, 122, '2014-04-01 01:12:49.000000', 'temperatura', 961.0000, 'ºC'),
	(286457, 122, '2014-04-01 01:12:50.000000', 'temperatura', 771.0000, 'ºC'),
	(286458, 122, '2014-04-01 01:12:51.000000', 'temperatura', 974.0000, 'ºC'),
	(286459, 122, '2014-04-01 01:12:52.000000', 'temperatura', 155.0000, 'ºC'),
	(286460, 122, '2014-04-01 01:12:53.000000', 'temperatura', 257.0000, 'ºC'),
	(286461, 122, '2014-04-01 01:12:54.000000', 'temperatura', 817.0000, 'ºC'),
	(286462, 122, '2014-04-01 01:12:55.000000', 'temperatura', 916.0000, 'ºC'),
	(286463, 122, '2014-04-01 01:12:56.000000', 'temperatura', 931.0000, 'ºC'),
	(286464, 122, '2014-04-01 01:12:57.000000', 'temperatura', 706.0000, 'ºC'),
	(286465, 122, '2014-04-01 01:12:58.000000', 'temperatura', 739.0000, 'ºC'),
	(286466, 122, '2014-04-01 01:12:59.000000', 'temperatura', 375.0000, 'ºC'),
	(286467, 122, '2014-04-01 01:13:00.000000', 'temperatura', 861.0000, 'ºC'),
	(286468, 122, '2014-04-01 01:13:01.000000', 'temperatura', 779.0000, 'ºC'),
	(286469, 122, '2014-04-01 01:13:02.000000', 'temperatura', 114.0000, 'ºC'),
	(286470, 122, '2014-04-01 01:13:03.000000', 'temperatura', 632.0000, 'ºC'),
	(286471, 122, '2014-04-01 01:13:04.000000', 'temperatura', 419.0000, 'ºC'),
	(286472, 122, '2014-04-01 01:13:05.000000', 'temperatura', 199.0000, 'ºC'),
	(286473, 122, '2014-04-01 01:13:06.000000', 'temperatura', 940.0000, 'ºC'),
	(286474, 122, '2014-04-01 01:13:07.000000', 'temperatura', 501.0000, 'ºC'),
	(286475, 122, '2014-04-01 01:13:08.000000', 'temperatura', 885.0000, 'ºC'),
	(286476, 122, '2014-04-01 01:13:09.000000', 'temperatura', 523.0000, 'ºC'),
	(286477, 122, '2014-04-01 01:13:10.000000', 'temperatura', 1161.0000, 'ºC'),
	(286478, 122, '2014-04-01 01:13:11.000000', 'temperatura', 636.0000, 'ºC'),
	(286479, 122, '2014-04-01 01:13:12.000000', 'temperatura', 898.0000, 'ºC'),
	(286480, 122, '2014-04-01 01:13:13.000000', 'temperatura', 183.0000, 'ºC'),
	(286481, 122, '2014-04-01 01:13:14.000000', 'temperatura', 621.0000, 'ºC'),
	(286482, 122, '2014-04-01 01:13:15.000000', 'temperatura', 157.0000, 'ºC'),
	(286483, 122, '2014-04-01 01:13:16.000000', 'temperatura', 120.0000, 'ºC'),
	(286484, 122, '2014-04-01 01:13:17.000000', 'temperatura', 133.0000, 'ºC'),
	(286485, 122, '2014-04-01 01:13:18.000000', 'temperatura', 303.0000, 'ºC'),
	(286486, 122, '2014-04-01 01:13:19.000000', 'temperatura', 1117.0000, 'ºC'),
	(286487, 122, '2014-04-01 01:13:20.000000', 'temperatura', 1077.0000, 'ºC'),
	(286488, 122, '2014-04-01 01:13:21.000000', 'temperatura', 835.0000, 'ºC'),
	(286489, 122, '2014-04-01 01:13:22.000000', 'temperatura', 943.0000, 'ºC'),
	(286490, 122, '2014-04-01 01:13:23.000000', 'temperatura', 1012.0000, 'ºC'),
	(286491, 122, '2014-04-01 01:13:24.000000', 'temperatura', 1032.0000, 'ºC'),
	(286492, 122, '2014-04-01 01:13:25.000000', 'temperatura', 925.0000, 'ºC'),
	(286493, 122, '2014-04-01 01:13:26.000000', 'temperatura', 331.0000, 'ºC'),
	(286494, 122, '2014-04-01 01:13:27.000000', 'temperatura', 78.0000, 'ºC'),
	(286495, 122, '2014-04-01 01:13:28.000000', 'temperatura', 597.0000, 'ºC'),
	(286496, 122, '2014-04-01 01:13:29.000000', 'temperatura', 353.0000, 'ºC'),
	(286497, 122, '2014-04-01 01:13:30.000000', 'temperatura', 1174.0000, 'ºC'),
	(286498, 122, '2014-04-01 01:13:31.000000', 'temperatura', 10.0000, 'ºC'),
	(286499, 122, '2014-04-01 01:13:32.000000', 'temperatura', 129.0000, 'ºC'),
	(286500, 122, '2014-04-01 01:13:33.000000', 'temperatura', 615.0000, 'ºC'),
	(286501, 122, '2014-04-01 01:13:34.000000', 'temperatura', 289.0000, 'ºC'),
	(286502, 122, '2014-04-01 01:13:35.000000', 'temperatura', 800.0000, 'ºC'),
	(286503, 122, '2014-04-01 01:13:36.000000', 'temperatura', 735.0000, 'ºC'),
	(286504, 122, '2014-04-01 01:13:37.000000', 'temperatura', 77.0000, 'ºC'),
	(286505, 122, '2014-04-01 01:13:38.000000', 'temperatura', 578.0000, 'ºC'),
	(286506, 122, '2014-04-01 01:13:39.000000', 'temperatura', 260.0000, 'ºC'),
	(286507, 122, '2014-04-01 01:13:40.000000', 'temperatura', 767.0000, 'ºC'),
	(286508, 122, '2014-04-01 01:13:41.000000', 'temperatura', 654.0000, 'ºC'),
	(286509, 122, '2014-04-01 01:13:42.000000', 'temperatura', 969.0000, 'ºC'),
	(286510, 122, '2014-04-01 01:13:43.000000', 'temperatura', 483.0000, 'ºC'),
	(286511, 122, '2014-04-01 01:13:44.000000', 'temperatura', 708.0000, 'ºC'),
	(286512, 122, '2014-04-01 01:13:45.000000', 'temperatura', 893.0000, 'ºC'),
	(286513, 122, '2014-04-01 01:13:46.000000', 'temperatura', 1142.0000, 'ºC'),
	(286514, 122, '2014-04-01 01:13:47.000000', 'temperatura', 633.0000, 'ºC'),
	(286515, 122, '2014-04-01 01:13:48.000000', 'temperatura', 936.0000, 'ºC'),
	(286516, 122, '2014-04-01 01:13:49.000000', 'temperatura', 383.0000, 'ºC'),
	(286517, 122, '2014-04-01 01:13:50.000000', 'temperatura', 306.0000, 'ºC'),
	(286518, 122, '2014-04-01 01:13:51.000000', 'temperatura', 381.0000, 'ºC'),
	(286519, 122, '2014-04-01 01:13:52.000000', 'temperatura', 987.0000, 'ºC'),
	(286520, 122, '2014-04-01 01:13:53.000000', 'temperatura', 195.0000, 'ºC'),
	(286521, 122, '2014-04-01 01:13:54.000000', 'temperatura', 412.0000, 'ºC'),
	(286522, 122, '2014-04-01 01:13:55.000000', 'temperatura', 277.0000, 'ºC'),
	(286523, 122, '2014-04-01 01:13:56.000000', 'temperatura', 147.0000, 'ºC'),
	(286524, 122, '2014-04-01 01:13:57.000000', 'temperatura', 1107.0000, 'ºC'),
	(286525, 122, '2014-04-01 01:13:58.000000', 'temperatura', 294.0000, 'ºC'),
	(286526, 122, '2014-04-01 01:13:59.000000', 'temperatura', 548.0000, 'ºC'),
	(286527, 122, '2014-04-01 01:14:00.000000', 'temperatura', 661.0000, 'ºC'),
	(286528, 122, '2014-04-01 01:14:01.000000', 'temperatura', 460.0000, 'ºC'),
	(286529, 122, '2014-04-01 01:14:02.000000', 'temperatura', 319.0000, 'ºC'),
	(286530, 122, '2014-04-01 01:14:03.000000', 'temperatura', 214.0000, 'ºC'),
	(286531, 122, '2014-04-01 01:14:04.000000', 'temperatura', 115.0000, 'ºC'),
	(286532, 122, '2014-04-01 01:14:05.000000', 'temperatura', 1132.0000, 'ºC'),
	(286533, 122, '2014-04-01 01:14:06.000000', 'temperatura', 518.0000, 'ºC'),
	(286534, 122, '2014-04-01 01:14:07.000000', 'temperatura', 394.0000, 'ºC'),
	(286535, 122, '2014-04-01 01:14:08.000000', 'temperatura', 414.0000, 'ºC'),
	(286536, 122, '2014-04-01 01:14:09.000000', 'temperatura', 891.0000, 'ºC'),
	(286537, 122, '2014-04-01 01:14:10.000000', 'temperatura', 811.0000, 'ºC'),
	(286538, 122, '2014-04-01 01:14:11.000000', 'temperatura', 183.0000, 'ºC'),
	(286539, 122, '2014-04-01 01:14:12.000000', 'temperatura', 885.0000, 'ºC'),
	(286540, 122, '2014-04-01 01:14:13.000000', 'temperatura', 274.0000, 'ºC'),
	(286541, 122, '2014-04-01 01:14:14.000000', 'temperatura', 1118.0000, 'ºC'),
	(286542, 122, '2014-04-01 01:14:15.000000', 'temperatura', 1166.0000, 'ºC'),
	(286543, 122, '2014-04-01 01:14:16.000000', 'temperatura', 78.0000, 'ºC'),
	(286544, 122, '2014-04-01 01:14:17.000000', 'temperatura', 492.0000, 'ºC'),
	(286545, 122, '2014-04-01 01:14:18.000000', 'temperatura', 1026.0000, 'ºC'),
	(286546, 122, '2014-04-01 01:14:19.000000', 'temperatura', 57.0000, 'ºC'),
	(286547, 122, '2014-04-01 01:14:20.000000', 'temperatura', 805.0000, 'ºC'),
	(286548, 122, '2014-04-01 01:14:21.000000', 'temperatura', 256.0000, 'ºC'),
	(286549, 122, '2014-04-01 01:14:22.000000', 'temperatura', 65.0000, 'ºC'),
	(286550, 122, '2014-04-01 01:14:23.000000', 'temperatura', 759.0000, 'ºC'),
	(286551, 122, '2014-04-01 01:14:24.000000', 'temperatura', 1.0000, 'ºC'),
	(286552, 122, '2014-04-01 01:14:25.000000', 'temperatura', 126.0000, 'ºC'),
	(286553, 122, '2014-04-01 01:14:26.000000', 'temperatura', 630.0000, 'ºC'),
	(286554, 122, '2014-04-01 01:14:27.000000', 'temperatura', 371.0000, 'ºC'),
	(286555, 122, '2014-04-01 01:14:28.000000', 'temperatura', 1164.0000, 'ºC'),
	(286556, 122, '2014-04-01 01:14:29.000000', 'temperatura', 1109.0000, 'ºC'),
	(286557, 122, '2014-04-01 01:14:30.000000', 'temperatura', 852.0000, 'ºC'),
	(286558, 122, '2014-04-01 01:14:31.000000', 'temperatura', 936.0000, 'ºC'),
	(286559, 122, '2014-04-01 01:14:32.000000', 'temperatura', 924.0000, 'ºC'),
	(286560, 122, '2014-04-01 01:14:33.000000', 'temperatura', 614.0000, 'ºC'),
	(286561, 122, '2014-04-01 01:14:34.000000', 'temperatura', 298.0000, 'ºC'),
	(286562, 122, '2014-04-01 01:14:35.000000', 'temperatura', 847.0000, 'ºC'),
	(286563, 122, '2014-04-01 01:14:36.000000', 'temperatura', 940.0000, 'ºC'),
	(286564, 122, '2014-04-01 01:14:37.000000', 'temperatura', 961.0000, 'ºC'),
	(286565, 122, '2014-04-01 01:14:38.000000', 'temperatura', 787.0000, 'ºC'),
	(286566, 122, '2014-04-01 01:14:39.000000', 'temperatura', 1050.0000, 'ºC'),
	(286567, 122, '2014-04-01 01:14:40.000000', 'temperatura', 492.0000, 'ºC'),
	(286568, 122, '2014-04-01 01:14:41.000000', 'temperatura', 509.0000, 'ºC'),
	(286569, 122, '2014-04-01 01:14:42.000000', 'temperatura', 1068.0000, 'ºC'),
	(286570, 122, '2014-04-01 01:14:43.000000', 'temperatura', 214.0000, 'ºC'),
	(286571, 122, '2014-04-01 01:14:44.000000', 'temperatura', 268.0000, 'ºC'),
	(286572, 122, '2014-04-01 01:14:45.000000', 'temperatura', 698.0000, 'ºC'),
	(286573, 122, '2014-04-01 01:14:46.000000', 'temperatura', 286.0000, 'ºC'),
	(286574, 122, '2014-04-01 01:14:47.000000', 'temperatura', 537.0000, 'ºC'),
	(286575, 122, '2014-04-01 01:14:48.000000', 'temperatura', 627.0000, 'ºC'),
	(286576, 122, '2014-04-01 01:14:49.000000', 'temperatura', 327.0000, 'ºC'),
	(286577, 122, '2014-04-01 01:14:50.000000', 'temperatura', 951.0000, 'ºC'),
	(286578, 122, '2014-04-01 01:14:51.000000', 'temperatura', 177.0000, 'ºC'),
	(286579, 122, '2014-04-01 01:14:52.000000', 'temperatura', 430.0000, 'ºC'),
	(286580, 122, '2014-04-01 01:14:53.000000', 'temperatura', 420.0000, 'ºC'),
	(286581, 122, '2014-04-01 01:14:54.000000', 'temperatura', 811.0000, 'ºC'),
	(286582, 122, '2014-04-01 01:14:55.000000', 'temperatura', 398.0000, 'ºC'),
	(286583, 122, '2014-04-01 01:14:56.000000', 'temperatura', 754.0000, 'ºC'),
	(286584, 122, '2014-04-01 01:14:57.000000', 'temperatura', 178.0000, 'ºC'),
	(286585, 122, '2014-04-01 01:14:58.000000', 'temperatura', 1028.0000, 'ºC'),
	(286586, 122, '2014-04-01 01:14:59.000000', 'temperatura', 1009.0000, 'ºC'),
	(286587, 122, '2014-04-01 01:15:00.000000', 'temperatura', 758.0000, 'ºC'),
	(286588, 122, '2014-04-01 01:15:01.000000', 'temperatura', 766.0000, 'ºC'),
	(286589, 122, '2014-04-01 01:15:02.000000', 'temperatura', 356.0000, 'ºC'),
	(286590, 122, '2014-04-01 01:15:03.000000', 'temperatura', 680.0000, 'ºC'),
	(286591, 122, '2014-04-01 01:15:04.000000', 'temperatura', 1135.0000, 'ºC'),
	(286592, 122, '2014-04-01 01:15:05.000000', 'temperatura', 34.0000, 'ºC'),
	(286593, 122, '2014-04-01 01:15:06.000000', 'temperatura', 365.0000, 'ºC'),
	(286594, 122, '2014-04-01 01:15:07.000000', 'temperatura', 526.0000, 'ºC'),
	(286595, 122, '2014-04-01 01:15:08.000000', 'temperatura', 335.0000, 'ºC'),
	(286596, 122, '2014-04-01 01:15:09.000000', 'temperatura', 96.0000, 'ºC'),
	(286597, 122, '2014-04-01 01:15:10.000000', 'temperatura', 675.0000, 'ºC'),
	(286598, 122, '2014-04-01 01:15:11.000000', 'temperatura', 686.0000, 'ºC'),
	(286599, 122, '2014-04-01 01:15:12.000000', 'temperatura', 209.0000, 'ºC'),
	(286600, 122, '2014-04-01 01:15:13.000000', 'temperatura', 186.0000, 'ºC'),
	(286601, 122, '2014-04-01 01:15:14.000000', 'temperatura', 305.0000, 'ºC'),
	(286602, 122, '2014-04-01 01:15:15.000000', 'temperatura', 965.0000, 'ºC'),
	(286603, 122, '2014-04-01 01:15:16.000000', 'temperatura', 314.0000, 'ºC'),
	(286604, 122, '2014-04-01 01:15:17.000000', 'temperatura', 1073.0000, 'ºC'),
	(286605, 122, '2014-04-01 01:15:18.000000', 'temperatura', 822.0000, 'ºC'),
	(286606, 122, '2014-04-01 01:15:19.000000', 'temperatura', 893.0000, 'ºC'),
	(286607, 122, '2014-04-01 01:15:20.000000', 'temperatura', 799.0000, 'ºC'),
	(286608, 122, '2014-04-01 01:15:21.000000', 'temperatura', 119.0000, 'ºC'),
	(286609, 122, '2014-04-01 01:15:22.000000', 'temperatura', 596.0000, 'ºC'),
	(286610, 122, '2014-04-01 01:15:23.000000', 'temperatura', 222.0000, 'ºC'),
	(286611, 122, '2014-04-01 01:15:24.000000', 'temperatura', 526.0000, 'ºC'),
	(286612, 122, '2014-04-01 01:15:25.000000', 'temperatura', 764.0000, 'ºC'),
	(286613, 122, '2014-04-01 01:15:26.000000', 'temperatura', 1041.0000, 'ºC'),
	(286614, 122, '2014-04-01 01:15:27.000000', 'temperatura', 514.0000, 'ºC'),
	(286615, 122, '2014-04-01 01:15:28.000000', 'temperatura', 647.0000, 'ºC'),
	(286616, 122, '2014-04-01 01:15:29.000000', 'temperatura', 493.0000, 'ºC'),
	(286617, 122, '2014-04-01 01:15:30.000000', 'temperatura', 526.0000, 'ºC'),
	(286618, 122, '2014-04-01 01:15:31.000000', 'temperatura', 1151.0000, 'ºC'),
	(286619, 122, '2014-04-01 01:15:32.000000', 'temperatura', 578.0000, 'ºC'),
	(286620, 122, '2014-04-01 01:15:33.000000', 'temperatura', 636.0000, 'ºC'),
	(286621, 122, '2014-04-01 01:15:34.000000', 'temperatura', 247.0000, 'ºC'),
	(286622, 122, '2014-04-01 01:15:35.000000', 'temperatura', 528.0000, 'ºC'),
	(286623, 122, '2014-04-01 01:15:36.000000', 'temperatura', 699.0000, 'ºC'),
	(286624, 122, '2014-04-01 01:15:37.000000', 'temperatura', 713.0000, 'ºC'),
	(286625, 122, '2014-04-01 01:15:38.000000', 'temperatura', 267.0000, 'ºC'),
	(286626, 122, '2014-04-01 01:15:39.000000', 'temperatura', 399.0000, 'ºC'),
	(286627, 122, '2014-04-01 01:15:40.000000', 'temperatura', 1191.0000, 'ºC'),
	(286628, 122, '2014-04-01 01:15:41.000000', 'temperatura', 1160.0000, 'ºC'),
	(286629, 122, '2014-04-01 01:15:42.000000', 'temperatura', 1027.0000, 'ºC'),
	(286630, 122, '2014-04-01 01:15:43.000000', 'temperatura', 454.0000, 'ºC'),
	(286631, 122, '2014-04-01 01:15:44.000000', 'temperatura', 390.0000, 'ºC'),
	(286632, 122, '2014-04-01 01:15:45.000000', 'temperatura', 590.0000, 'ºC'),
	(286633, 122, '2014-04-01 01:15:46.000000', 'temperatura', 578.0000, 'ºC'),
	(286634, 122, '2014-04-01 01:15:47.000000', 'temperatura', 1123.0000, 'ºC'),
	(286635, 122, '2014-04-01 01:15:48.000000', 'temperatura', 281.0000, 'ºC'),
	(286636, 122, '2014-04-01 01:15:49.000000', 'temperatura', 437.0000, 'ºC'),
	(286637, 122, '2014-04-01 01:15:50.000000', 'temperatura', 140.0000, 'ºC'),
	(286638, 122, '2014-04-01 01:15:51.000000', 'temperatura', 592.0000, 'ºC'),
	(286639, 122, '2014-04-01 01:15:52.000000', 'temperatura', 138.0000, 'ºC'),
	(286640, 122, '2014-04-01 01:15:53.000000', 'temperatura', 117.0000, 'ºC'),
	(286641, 122, '2014-04-01 01:15:54.000000', 'temperatura', 170.0000, 'ºC'),
	(286642, 122, '2014-04-01 01:15:55.000000', 'temperatura', 501.0000, 'ºC'),
	(286643, 122, '2014-04-01 01:15:56.000000', 'temperatura', 796.0000, 'ºC'),
	(286644, 122, '2014-04-01 01:15:57.000000', 'temperatura', 77.0000, 'ºC'),
	(286645, 122, '2014-04-01 01:15:58.000000', 'temperatura', 398.0000, 'ºC'),
	(286646, 122, '2014-04-01 01:15:59.000000', 'temperatura', 558.0000, 'ºC'),
	(286647, 122, '2014-04-01 01:16:00.000000', 'temperatura', 398.0000, 'ºC'),
	(286648, 122, '2014-04-01 01:16:01.000000', 'temperatura', 316.0000, 'ºC'),
	(286649, 122, '2014-04-01 01:16:02.000000', 'temperatura', 385.0000, 'ºC'),
	(286650, 122, '2014-04-01 01:16:03.000000', 'temperatura', 977.0000, 'ºC'),
	(286651, 122, '2014-04-01 01:16:04.000000', 'temperatura', 133.0000, 'ºC'),
	(286652, 122, '2014-04-01 01:16:05.000000', 'temperatura', 132.0000, 'ºC'),
	(286653, 122, '2014-04-01 01:16:06.000000', 'temperatura', 261.0000, 'ºC'),
	(286654, 122, '2014-04-01 01:16:07.000000', 'temperatura', 910.0000, 'ºC'),
	(286655, 122, '2014-04-01 01:16:08.000000', 'temperatura', 168.0000, 'ºC'),
	(286656, 122, '2014-04-01 01:16:09.000000', 'temperatura', 509.0000, 'ºC'),
	(286657, 122, '2014-04-01 01:16:10.000000', 'temperatura', 844.0000, 'ºC'),
	(286658, 122, '2014-04-01 01:16:11.000000', 'temperatura', 292.0000, 'ºC'),
	(286659, 122, '2014-04-01 01:16:12.000000', 'temperatura', 130.0000, 'ºC'),
	(286660, 122, '2014-04-01 01:16:13.000000', 'temperatura', 976.0000, 'ºC'),
	(286661, 122, '2014-04-01 01:16:14.000000', 'temperatura', 887.0000, 'ºC'),
	(286662, 122, '2014-04-01 01:16:15.000000', 'temperatura', 310.0000, 'ºC'),
	(286663, 122, '2014-04-01 01:16:16.000000', 'temperatura', 87.0000, 'ºC'),
	(286664, 122, '2014-04-01 01:16:17.000000', 'temperatura', 708.0000, 'ºC'),
	(286665, 122, '2014-04-01 01:16:18.000000', 'temperatura', 879.0000, 'ºC'),
	(286666, 122, '2014-04-01 01:16:19.000000', 'temperatura', 1072.0000, 'ºC'),
	(286667, 122, '2014-04-01 01:16:20.000000', 'temperatura', 324.0000, 'ºC'),
	(286668, 122, '2014-04-01 01:16:21.000000', 'temperatura', 806.0000, 'ºC'),
	(286669, 122, '2014-04-01 01:16:22.000000', 'temperatura', 656.0000, 'ºC'),
	(286670, 122, '2014-04-01 01:16:23.000000', 'temperatura', 864.0000, 'ºC'),
	(286671, 122, '2014-04-01 01:16:24.000000', 'temperatura', 1153.0000, 'ºC'),
	(286672, 122, '2014-04-01 01:16:25.000000', 'temperatura', 771.0000, 'ºC'),
	(286673, 122, '2014-04-01 01:16:26.000000', 'temperatura', 398.0000, 'ºC'),
	(286674, 122, '2014-04-01 01:16:27.000000', 'temperatura', 876.0000, 'ºC'),
	(286675, 122, '2014-04-01 01:16:28.000000', 'temperatura', 789.0000, 'ºC'),
	(286676, 122, '2014-04-01 01:16:29.000000', 'temperatura', 118.0000, 'ºC'),
	(286677, 122, '2014-04-01 01:16:30.000000', 'temperatura', 622.0000, 'ºC'),
	(286678, 122, '2014-04-01 01:16:31.000000', 'temperatura', 357.0000, 'ºC'),
	(286679, 122, '2014-04-01 01:16:32.000000', 'temperatura', 1121.0000, 'ºC'),
	(286680, 122, '2014-04-01 01:16:33.000000', 'temperatura', 933.0000, 'ºC'),
	(286681, 122, '2014-04-01 01:16:34.000000', 'temperatura', 105.0000, 'ºC'),
	(286682, 122, '2014-04-01 01:16:35.000000', 'temperatura', 124.0000, 'ºC'),
	(286683, 122, '2014-04-01 01:16:36.000000', 'temperatura', 305.0000, 'ºC'),
	(286684, 122, '2014-04-01 01:16:37.000000', 'temperatura', 1153.0000, 'ºC'),
	(286685, 122, '2014-04-01 01:16:38.000000', 'temperatura', 52.0000, 'ºC'),
	(286686, 122, '2014-04-01 01:16:39.000000', 'temperatura', 399.0000, 'ºC'),
	(286687, 122, '2014-04-01 01:16:40.000000', 'temperatura', 643.0000, 'ºC'),
	(286688, 122, '2014-04-01 01:16:41.000000', 'temperatura', 817.0000, 'ºC'),
	(286689, 122, '2014-04-01 01:16:42.000000', 'temperatura', 955.0000, 'ºC'),
	(286690, 122, '2014-04-01 01:16:43.000000', 'temperatura', 1124.0000, 'ºC'),
	(286691, 122, '2014-04-01 01:16:44.000000', 'temperatura', 358.0000, 'ºC'),
	(286692, 122, '2014-04-01 01:16:45.000000', 'temperatura', 817.0000, 'ºC'),
	(286693, 122, '2014-04-01 01:16:46.000000', 'temperatura', 611.0000, 'ºC'),
	(286694, 122, '2014-04-01 01:16:47.000000', 'temperatura', 603.0000, 'ºC'),
	(286695, 122, '2014-04-01 01:16:48.000000', 'temperatura', 1186.0000, 'ºC'),
	(286696, 122, '2014-04-01 01:16:49.000000', 'temperatura', 520.0000, 'ºC'),
	(286697, 122, '2014-04-01 01:16:50.000000', 'temperatura', 241.0000, 'ºC'),
	(286698, 122, '2014-04-01 01:16:51.000000', 'temperatura', 845.0000, 'ºC'),
	(286699, 122, '2014-04-01 01:16:52.000000', 'temperatura', 1104.0000, 'ºC'),
	(286700, 122, '2014-04-01 01:16:53.000000', 'temperatura', 587.0000, 'ºC'),
	(286701, 122, '2014-04-01 01:16:54.000000', 'temperatura', 823.0000, 'ºC'),
	(286702, 122, '2014-04-01 01:16:55.000000', 'temperatura', 1155.0000, 'ºC'),
	(286703, 122, '2014-04-01 01:16:56.000000', 'temperatura', 907.0000, 'ºC'),
	(286704, 122, '2014-04-01 01:16:57.000000', 'temperatura', 1068.0000, 'ºC'),
	(286705, 122, '2014-04-01 01:16:58.000000', 'temperatura', 220.0000, 'ºC'),
	(286706, 122, '2014-04-01 01:16:59.000000', 'temperatura', 296.0000, 'ºC'),
	(286707, 122, '2014-04-01 01:17:00.000000', 'temperatura', 821.0000, 'ºC'),
	(286708, 122, '2014-04-01 01:17:01.000000', 'temperatura', 816.0000, 'ºC'),
	(286709, 122, '2014-04-01 01:17:02.000000', 'temperatura', 418.0000, 'ºC'),
	(286710, 122, '2014-04-01 01:17:03.000000', 'temperatura', 844.0000, 'ºC'),
	(286711, 122, '2014-04-01 01:17:04.000000', 'temperatura', 565.0000, 'ºC'),
	(286712, 122, '2014-04-01 01:17:05.000000', 'temperatura', 296.0000, 'ºC'),
	(286713, 122, '2014-04-01 01:17:06.000000', 'temperatura', 983.0000, 'ºC'),
	(286714, 122, '2014-04-01 01:17:07.000000', 'temperatura', 430.0000, 'ºC'),
	(286715, 122, '2014-04-01 01:17:08.000000', 'temperatura', 401.0000, 'ºC'),
	(286716, 122, '2014-04-01 01:17:09.000000', 'temperatura', 716.0000, 'ºC'),
	(286717, 122, '2014-04-01 01:17:10.000000', 'temperatura', 1179.0000, 'ºC'),
	(286718, 122, '2014-04-01 01:17:11.000000', 'temperatura', 145.0000, 'ºC'),
	(286719, 122, '2014-04-01 01:17:12.000000', 'temperatura', 788.0000, 'ºC'),
	(286720, 122, '2014-04-01 01:17:13.000000', 'temperatura', 1107.0000, 'ºC'),
	(286721, 122, '2014-04-01 01:17:14.000000', 'temperatura', 773.0000, 'ºC'),
	(286722, 122, '2014-04-01 01:17:15.000000', 'temperatura', 543.0000, 'ºC'),
	(286723, 122, '2014-04-01 01:17:16.000000', 'temperatura', 396.0000, 'ºC'),
	(286724, 122, '2014-04-01 01:17:17.000000', 'temperatura', 351.0000, 'ºC'),
	(286725, 122, '2014-04-01 01:17:18.000000', 'temperatura', 568.0000, 'ºC'),
	(286726, 122, '2014-04-01 01:17:19.000000', 'temperatura', 586.0000, 'ºC'),
	(286727, 122, '2014-04-01 01:17:20.000000', 'temperatura', 26.0000, 'ºC'),
	(286728, 122, '2014-04-01 01:17:21.000000', 'temperatura', 775.0000, 'ºC'),
	(286729, 122, '2014-04-01 01:17:22.000000', 'temperatura', 197.0000, 'ºC'),
	(286730, 122, '2014-04-01 01:17:23.000000', 'temperatura', 1060.0000, 'ºC'),
	(286731, 122, '2014-04-01 01:17:24.000000', 'temperatura', 1110.0000, 'ºC'),
	(286732, 122, '2014-04-01 01:17:25.000000', 'temperatura', 1171.0000, 'ºC'),
	(286733, 122, '2014-04-01 01:17:26.000000', 'temperatura', 126.0000, 'ºC'),
	(286734, 122, '2014-04-01 01:17:27.000000', 'temperatura', 718.0000, 'ºC'),
	(286735, 122, '2014-04-01 01:17:28.000000', 'temperatura', 813.0000, 'ºC'),
	(286736, 122, '2014-04-01 01:17:29.000000', 'temperatura', 713.0000, 'ºC'),
	(286737, 122, '2014-04-01 01:17:30.000000', 'temperatura', 1123.0000, 'ºC'),
	(286738, 122, '2014-04-01 01:17:31.000000', 'temperatura', 1079.0000, 'ºC'),
	(286739, 122, '2014-04-01 01:17:32.000000', 'temperatura', 824.0000, 'ºC'),
	(286740, 122, '2014-04-01 01:17:33.000000', 'temperatura', 885.0000, 'ºC'),
	(286741, 122, '2014-04-01 01:17:34.000000', 'temperatura', 751.0000, 'ºC'),
	(286742, 122, '2014-04-01 01:17:35.000000', 'temperatura', 1104.0000, 'ºC'),
	(286743, 122, '2014-04-01 01:17:36.000000', 'temperatura', 866.0000, 'ºC'),
	(286744, 122, '2014-04-01 01:17:37.000000', 'temperatura', 1018.0000, 'ºC'),
	(286745, 122, '2014-04-01 01:17:38.000000', 'temperatura', 95.0000, 'ºC'),
	(286746, 122, '2014-04-01 01:17:39.000000', 'temperatura', 1020.0000, 'ºC'),
	(286747, 122, '2014-04-01 01:17:40.000000', 'temperatura', 14.0000, 'ºC'),
	(286748, 122, '2014-04-01 01:17:41.000000', 'temperatura', 613.0000, 'ºC'),
	(286749, 122, '2014-04-01 01:17:42.000000', 'temperatura', 621.0000, 'ºC'),
	(286750, 122, '2014-04-01 01:17:43.000000', 'temperatura', 66.0000, 'ºC'),
	(286751, 122, '2014-04-01 01:17:44.000000', 'temperatura', 870.0000, 'ºC'),
	(286752, 122, '2014-04-01 01:17:45.000000', 'temperatura', 553.0000, 'ºC'),
	(286753, 122, '2014-04-01 01:17:46.000000', 'temperatura', 155.0000, 'ºC'),
	(286754, 122, '2014-04-01 01:17:47.000000', 'temperatura', 315.0000, 'ºC'),
	(286755, 122, '2014-04-01 01:17:48.000000', 'temperatura', 1110.0000, 'ºC'),
	(286756, 122, '2014-04-01 01:17:49.000000', 'temperatura', 1004.0000, 'ºC'),
	(286757, 122, '2014-04-01 01:17:50.000000', 'temperatura', 493.0000, 'ºC'),
	(286758, 122, '2014-04-01 01:17:51.000000', 'temperatura', 654.0000, 'ºC'),
	(286759, 122, '2014-04-01 01:17:52.000000', 'temperatura', 591.0000, 'ºC'),
	(286760, 122, '2014-04-01 01:17:53.000000', 'temperatura', 993.0000, 'ºC'),
	(286761, 122, '2014-04-01 01:17:54.000000', 'temperatura', 791.0000, 'ºC'),
	(286762, 122, '2014-04-01 01:17:55.000000', 'temperatura', 976.0000, 'ºC'),
	(286763, 122, '2014-04-01 01:17:56.000000', 'temperatura', 111.0000, 'ºC'),
	(286764, 122, '2014-04-01 01:17:57.000000', 'temperatura', 24.0000, 'ºC'),
	(286765, 122, '2014-04-01 01:17:58.000000', 'temperatura', 988.0000, 'ºC'),
	(286766, 122, '2014-04-01 01:17:59.000000', 'temperatura', 68.0000, 'ºC'),
	(286767, 122, '2014-04-01 01:18:00.000000', 'temperatura', 978.0000, 'ºC'),
	(286768, 122, '2014-04-01 01:18:01.000000', 'temperatura', 1087.0000, 'ºC'),
	(286769, 122, '2014-04-01 01:18:02.000000', 'temperatura', 102.0000, 'ºC'),
	(286770, 122, '2014-04-01 01:18:03.000000', 'temperatura', 847.0000, 'ºC'),
	(286771, 122, '2014-04-01 01:18:04.000000', 'temperatura', 332.0000, 'ºC'),
	(286772, 122, '2014-04-01 01:18:05.000000', 'temperatura', 320.0000, 'ºC'),
	(286773, 122, '2014-04-01 01:18:06.000000', 'temperatura', 604.0000, 'ºC'),
	(286774, 122, '2014-04-01 01:18:07.000000', 'temperatura', 861.0000, 'ºC'),
	(286775, 122, '2014-04-01 01:18:08.000000', 'temperatura', 95.0000, 'ºC'),
	(286776, 122, '2014-04-01 01:18:09.000000', 'temperatura', 290.0000, 'ºC'),
	(286777, 122, '2014-04-01 01:18:10.000000', 'temperatura', 1168.0000, 'ºC'),
	(286778, 122, '2014-04-01 01:18:11.000000', 'temperatura', 170.0000, 'ºC'),
	(286779, 122, '2014-04-01 01:18:12.000000', 'temperatura', 947.0000, 'ºC'),
	(286780, 122, '2014-04-01 01:18:13.000000', 'temperatura', 624.0000, 'ºC'),
	(286781, 122, '2014-04-01 01:18:14.000000', 'temperatura', 280.0000, 'ºC'),
	(286782, 122, '2014-04-01 01:18:15.000000', 'temperatura', 728.0000, 'ºC'),
	(286783, 122, '2014-04-01 01:18:16.000000', 'temperatura', 403.0000, 'ºC'),
	(286784, 122, '2014-04-01 01:18:17.000000', 'temperatura', 1028.0000, 'ºC'),
	(286785, 122, '2014-04-01 01:18:18.000000', 'temperatura', 335.0000, 'ºC'),
	(286786, 122, '2014-04-01 01:18:19.000000', 'temperatura', 988.0000, 'ºC'),
	(286787, 122, '2014-04-01 01:18:20.000000', 'temperatura', 338.0000, 'ºC'),
	(286788, 122, '2014-04-01 01:18:21.000000', 'temperatura', 1126.0000, 'ºC'),
	(286789, 122, '2014-04-01 01:18:22.000000', 'temperatura', 1018.0000, 'ºC'),
	(286790, 122, '2014-04-01 01:18:23.000000', 'temperatura', 511.0000, 'ºC'),
	(286791, 122, '2014-04-01 01:18:24.000000', 'temperatura', 701.0000, 'ºC'),
	(286792, 122, '2014-04-01 01:18:25.000000', 'temperatura', 771.0000, 'ºC'),
	(286793, 122, '2014-04-01 01:18:26.000000', 'temperatura', 555.0000, 'ºC'),
	(286794, 122, '2014-04-01 01:18:27.000000', 'temperatura', 463.0000, 'ºC'),
	(286795, 122, '2014-04-01 01:18:28.000000', 'temperatura', 649.0000, 'ºC'),
	(286796, 122, '2014-04-01 01:18:29.000000', 'temperatura', 658.0000, 'ºC'),
	(286797, 122, '2014-04-01 01:18:30.000000', 'temperatura', 145.0000, 'ºC'),
	(286798, 122, '2014-04-01 01:18:31.000000', 'temperatura', 1149.0000, 'ºC'),
	(286799, 122, '2014-04-01 01:18:32.000000', 'temperatura', 509.0000, 'ºC'),
	(286800, 122, '2014-04-01 01:18:33.000000', 'temperatura', 301.0000, 'ºC'),
	(286801, 122, '2014-04-01 01:18:34.000000', 'temperatura', 1177.0000, 'ºC'),
	(286802, 122, '2014-04-01 01:18:35.000000', 'temperatura', 185.0000, 'ºC'),
	(286803, 122, '2014-04-01 01:18:36.000000', 'temperatura', 991.0000, 'ºC'),
	(286804, 122, '2014-04-01 01:18:37.000000', 'temperatura', 804.0000, 'ºC'),
	(286805, 122, '2014-04-01 01:18:38.000000', 'temperatura', 1046.0000, 'ºC'),
	(286806, 122, '2014-04-01 01:18:39.000000', 'temperatura', 419.0000, 'ºC'),
	(286807, 122, '2014-04-01 01:18:40.000000', 'temperatura', 156.0000, 'ºC'),
	(286808, 122, '2014-04-01 01:18:41.000000', 'temperatura', 723.0000, 'ºC'),
	(286809, 122, '2014-04-01 01:18:42.000000', 'temperatura', 747.0000, 'ºC'),
	(286810, 122, '2014-04-01 01:18:43.000000', 'temperatura', 367.0000, 'ºC'),
	(286811, 122, '2014-04-01 01:18:44.000000', 'temperatura', 796.0000, 'ºC'),
	(286812, 122, '2014-04-01 01:18:45.000000', 'temperatura', 478.0000, 'ºC'),
	(286813, 122, '2014-04-01 01:18:46.000000', 'temperatura', 5.0000, 'ºC'),
	(286814, 122, '2014-04-01 01:18:47.000000', 'temperatura', 989.0000, 'ºC'),
	(286815, 122, '2014-04-01 01:18:48.000000', 'temperatura', 131.0000, 'ºC'),
	(286816, 122, '2014-04-01 01:18:49.000000', 'temperatura', 90.0000, 'ºC'),
	(286817, 122, '2014-04-01 01:18:50.000000', 'temperatura', 59.0000, 'ºC'),
	(286818, 122, '2014-04-01 01:18:51.000000', 'temperatura', 22.0000, 'ºC'),
	(286819, 122, '2014-04-01 01:18:52.000000', 'temperatura', 1134.0000, 'ºC'),
	(286820, 122, '2014-04-01 01:18:53.000000', 'temperatura', 805.0000, 'ºC'),
	(286821, 122, '2014-04-01 01:18:54.000000', 'temperatura', 623.0000, 'ºC'),
	(286822, 122, '2014-04-01 01:18:55.000000', 'temperatura', 700.0000, 'ºC'),
	(286823, 122, '2014-04-01 01:18:56.000000', 'temperatura', 434.0000, 'ºC'),
	(286824, 122, '2014-04-01 01:18:57.000000', 'temperatura', 70.0000, 'ºC'),
	(286825, 122, '2014-04-01 01:18:58.000000', 'temperatura', 246.0000, 'ºC'),
	(286826, 122, '2014-04-01 01:18:59.000000', 'temperatura', 1022.0000, 'ºC'),
	(286827, 122, '2014-04-01 01:19:00.000000', 'temperatura', 774.0000, 'ºC'),
	(286828, 122, '2014-04-01 01:19:01.000000', 'temperatura', 805.0000, 'ºC'),
	(286829, 122, '2014-04-01 01:19:02.000000', 'temperatura', 502.0000, 'ºC'),
	(286830, 122, '2014-04-01 01:19:03.000000', 'temperatura', 95.0000, 'ºC'),
	(286831, 122, '2014-04-01 01:19:04.000000', 'temperatura', 168.0000, 'ºC'),
	(286832, 122, '2014-04-01 01:19:05.000000', 'temperatura', 557.0000, 'ºC'),
	(286833, 122, '2014-04-01 01:19:06.000000', 'temperatura', 1080.0000, 'ºC'),
	(286834, 122, '2014-04-01 01:19:07.000000', 'temperatura', 130.0000, 'ºC'),
	(286835, 122, '2014-04-01 01:19:08.000000', 'temperatura', 1010.0000, 'ºC'),
	(286836, 122, '2014-04-01 01:19:09.000000', 'temperatura', 1059.0000, 'ºC'),
	(286837, 122, '2014-04-01 01:19:10.000000', 'temperatura', 1067.0000, 'ºC'),
	(286838, 122, '2014-04-01 01:19:11.000000', 'temperatura', 958.0000, 'ºC'),
	(286839, 122, '2014-04-01 01:19:12.000000', 'temperatura', 392.0000, 'ºC'),
	(286840, 122, '2014-04-01 01:19:13.000000', 'temperatura', 283.0000, 'ºC'),
	(286841, 122, '2014-04-01 01:19:14.000000', 'temperatura', 241.0000, 'ºC'),
	(286842, 122, '2014-04-01 01:19:15.000000', 'temperatura', 359.0000, 'ºC'),
	(286843, 122, '2014-04-01 01:19:16.000000', 'temperatura', 1069.0000, 'ºC'),
	(286844, 122, '2014-04-01 01:19:17.000000', 'temperatura', 668.0000, 'ºC'),
	(286845, 122, '2014-04-01 01:19:18.000000', 'temperatura', 134.0000, 'ºC'),
	(286846, 122, '2014-04-01 01:19:19.000000', 'temperatura', 1068.0000, 'ºC'),
	(286847, 122, '2014-04-01 01:19:20.000000', 'temperatura', 140.0000, 'ºC'),
	(286848, 122, '2014-04-01 01:19:21.000000', 'temperatura', 1094.0000, 'ºC'),
	(286849, 122, '2014-04-01 01:19:22.000000', 'temperatura', 250.0000, 'ºC'),
	(286850, 122, '2014-04-01 01:19:23.000000', 'temperatura', 371.0000, 'ºC'),
	(286851, 122, '2014-04-01 01:19:24.000000', 'temperatura', 1103.0000, 'ºC'),
	(286852, 122, '2014-04-01 01:19:25.000000', 'temperatura', 804.0000, 'ºC'),
	(286853, 122, '2014-04-01 01:19:26.000000', 'temperatura', 711.0000, 'ºC'),
	(286854, 122, '2014-04-01 01:19:27.000000', 'temperatura', 1144.0000, 'ºC'),
	(286855, 122, '2014-04-01 01:19:28.000000', 'temperatura', 1186.0000, 'ºC'),
	(286856, 122, '2014-04-01 01:19:29.000000', 'temperatura', 99.0000, 'ºC'),
	(286857, 122, '2014-04-01 01:19:30.000000', 'temperatura', 538.0000, 'ºC'),
	(286858, 122, '2014-04-01 01:19:31.000000', 'temperatura', 1193.0000, 'ºC'),
	(286859, 122, '2014-04-01 01:19:32.000000', 'temperatura', 753.0000, 'ºC'),
	(286860, 122, '2014-04-01 01:19:33.000000', 'temperatura', 185.0000, 'ºC'),
	(286861, 122, '2014-04-01 01:19:34.000000', 'temperatura', 1066.0000, 'ºC'),
	(286862, 122, '2014-04-01 01:19:35.000000', 'temperatura', 1174.0000, 'ºC'),
	(286863, 122, '2014-04-01 01:19:36.000000', 'temperatura', 275.0000, 'ºC'),
	(286864, 122, '2014-04-01 01:19:37.000000', 'temperatura', 253.0000, 'ºC'),
	(286865, 122, '2014-04-01 01:19:38.000000', 'temperatura', 440.0000, 'ºC'),
	(286866, 122, '2014-04-01 01:19:39.000000', 'temperatura', 242.0000, 'ºC'),
	(286867, 122, '2014-04-01 01:19:40.000000', 'temperatura', 1090.0000, 'ºC'),
	(286868, 122, '2014-04-01 01:19:41.000000', 'temperatura', 1124.0000, 'ºC'),
	(286869, 122, '2014-04-01 01:19:42.000000', 'temperatura', 1152.0000, 'ºC'),
	(286870, 122, '2014-04-01 01:19:43.000000', 'temperatura', 1189.0000, 'ºC'),
	(286871, 122, '2014-04-01 01:19:44.000000', 'temperatura', 91.0000, 'ºC'),
	(286872, 122, '2014-04-01 01:19:45.000000', 'temperatura', 486.0000, 'ºC'),
	(286873, 122, '2014-04-01 01:19:46.000000', 'temperatura', 958.0000, 'ºC'),
	(286874, 122, '2014-04-01 01:19:47.000000', 'temperatura', 933.0000, 'ºC'),
	(286875, 122, '2014-04-01 01:19:48.000000', 'temperatura', 590.0000, 'ºC'),
	(286876, 122, '2014-04-01 01:19:49.000000', 'temperatura', 153.0000, 'ºC'),
	(286877, 122, '2014-04-01 01:19:50.000000', 'temperatura', 197.0000, 'ºC'),
	(286878, 122, '2014-04-01 01:19:51.000000', 'temperatura', 525.0000, 'ºC'),
	(286879, 122, '2014-04-01 01:19:52.000000', 'temperatura', 833.0000, 'ºC'),
	(286880, 122, '2014-04-01 01:19:53.000000', 'temperatura', 191.0000, 'ºC'),
	(286881, 122, '2014-04-01 01:19:54.000000', 'temperatura', 856.0000, 'ºC'),
	(286882, 122, '2014-04-01 01:19:55.000000', 'temperatura', 109.0000, 'ºC'),
	(286883, 122, '2014-04-01 01:19:56.000000', 'temperatura', 378.0000, 'ºC'),
	(286884, 122, '2014-04-01 01:19:57.000000', 'temperatura', 362.0000, 'ºC'),
	(286885, 122, '2014-04-01 01:19:58.000000', 'temperatura', 679.0000, 'ºC'),
	(286886, 122, '2014-04-01 01:19:59.000000', 'temperatura', 1107.0000, 'ºC'),
	(286887, 122, '2014-04-01 01:20:00.000000', 'temperatura', 1100.0000, 'ºC'),
	(286888, 122, '2014-04-01 01:20:01.000000', 'temperatura', 979.0000, 'ºC'),
	(286889, 122, '2014-04-01 01:20:02.000000', 'temperatura', 393.0000, 'ºC'),
	(286890, 122, '2014-04-01 01:20:03.000000', 'temperatura', 232.0000, 'ºC'),
	(286891, 122, '2014-04-01 01:20:04.000000', 'temperatura', 1181.0000, 'ºC'),
	(286892, 122, '2014-04-01 01:20:05.000000', 'temperatura', 409.0000, 'ºC'),
	(286893, 122, '2014-04-01 01:20:06.000000', 'temperatura', 904.0000, 'ºC'),
	(286894, 122, '2014-04-01 01:20:07.000000', 'temperatura', 891.0000, 'ºC'),
	(286895, 122, '2014-04-01 01:20:08.000000', 'temperatura', 546.0000, 'ºC'),
	(286896, 122, '2014-04-01 01:20:09.000000', 'temperatura', 54.0000, 'ºC'),
	(286897, 122, '2014-04-01 01:20:10.000000', 'temperatura', 1036.0000, 'ºC'),
	(286898, 122, '2014-04-01 01:20:11.000000', 'temperatura', 219.0000, 'ºC'),
	(286899, 122, '2014-04-01 01:20:12.000000', 'temperatura', 385.0000, 'ºC'),
	(286900, 122, '2014-04-01 01:20:13.000000', 'temperatura', 67.0000, 'ºC'),
	(286901, 122, '2014-04-01 01:20:14.000000', 'temperatura', 383.0000, 'ºC'),
	(286902, 122, '2014-04-01 01:20:15.000000', 'temperatura', 516.0000, 'ºC'),
	(286903, 122, '2014-04-01 01:20:16.000000', 'temperatura', 230.0000, 'ºC'),
	(286904, 122, '2014-04-01 01:20:17.000000', 'temperatura', 801.0000, 'ºC'),
	(286905, 122, '2014-04-01 01:20:18.000000', 'temperatura', 918.0000, 'ºC'),
	(286906, 122, '2014-04-01 01:20:19.000000', 'temperatura', 988.0000, 'ºC'),
	(286907, 122, '2014-04-01 01:20:20.000000', 'temperatura', 984.0000, 'ºC'),
	(286908, 122, '2014-04-01 01:20:21.000000', 'temperatura', 757.0000, 'ºC'),
	(286909, 122, '2014-04-01 01:20:22.000000', 'temperatura', 835.0000, 'ºC'),
	(286910, 122, '2014-04-01 01:20:23.000000', 'temperatura', 704.0000, 'ºC'),
	(286911, 122, '2014-04-01 01:20:24.000000', 'temperatura', 1016.0000, 'ºC'),
	(286912, 122, '2014-04-01 01:20:25.000000', 'temperatura', 567.0000, 'ºC'),
	(286913, 122, '2014-04-01 01:20:26.000000', 'temperatura', 987.0000, 'ºC'),
	(286914, 122, '2014-04-01 01:20:27.000000', 'temperatura', 837.0000, 'ºC'),
	(286915, 122, '2014-04-01 01:20:28.000000', 'temperatura', 22.0000, 'ºC'),
	(286916, 122, '2014-04-01 01:20:29.000000', 'temperatura', 0.0000, 'ºC'),
	(286917, 122, '2014-04-01 01:20:30.000000', 'temperatura', 1134.0000, 'ºC'),
	(286918, 122, '2014-04-01 01:20:31.000000', 'temperatura', 871.0000, 'ºC'),
	(286919, 122, '2014-04-01 01:20:32.000000', 'temperatura', 952.0000, 'ºC'),
	(286920, 122, '2014-04-01 01:20:33.000000', 'temperatura', 949.0000, 'ºC'),
	(286921, 122, '2014-04-01 01:20:34.000000', 'temperatura', 691.0000, 'ºC'),
	(286922, 122, '2014-04-01 01:20:35.000000', 'temperatura', 606.0000, 'ºC'),
	(286923, 122, '2014-04-01 01:20:36.000000', 'temperatura', 960.0000, 'ºC'),
	(286924, 122, '2014-04-01 01:20:37.000000', 'temperatura', 581.0000, 'ºC'),
	(286925, 122, '2014-04-01 01:20:38.000000', 'temperatura', 27.0000, 'ºC'),
	(286926, 122, '2014-04-01 01:20:39.000000', 'temperatura', 791.0000, 'ºC'),
	(286927, 122, '2014-04-01 01:20:40.000000', 'temperatura', 275.0000, 'ºC'),
	(286928, 122, '2014-04-01 01:20:41.000000', 'temperatura', 201.0000, 'ºC'),
	(286929, 122, '2014-04-01 01:20:42.000000', 'temperatura', 182.0000, 'ºC'),
	(286930, 122, '2014-04-01 01:20:43.000000', 'temperatura', 309.0000, 'ºC'),
	(286931, 122, '2014-04-01 01:20:44.000000', 'temperatura', 997.0000, 'ºC'),
	(286932, 122, '2014-04-01 01:20:45.000000', 'temperatura', 460.0000, 'ºC'),
	(286933, 122, '2014-04-01 01:20:46.000000', 'temperatura', 507.0000, 'ºC'),
	(286934, 122, '2014-04-01 01:20:47.000000', 'temperatura', 1158.0000, 'ºC'),
	(286935, 122, '2014-04-01 01:20:48.000000', 'temperatura', 667.0000, 'ºC'),
	(286936, 122, '2014-04-01 01:20:49.000000', 'temperatura', 1062.0000, 'ºC'),
	(286937, 122, '2014-04-01 01:20:50.000000', 'temperatura', 911.0000, 'ºC'),
	(286938, 122, '2014-04-01 01:20:51.000000', 'temperatura', 167.0000, 'ºC'),
	(286939, 122, '2014-04-01 01:20:52.000000', 'temperatura', 504.0000, 'ºC'),
	(286940, 122, '2014-04-01 01:20:53.000000', 'temperatura', 818.0000, 'ºC'),
	(286941, 122, '2014-04-01 01:20:54.000000', 'temperatura', 179.0000, 'ºC'),
	(286942, 122, '2014-04-01 01:20:55.000000', 'temperatura', 841.0000, 'ºC'),
	(286943, 122, '2014-04-01 01:20:56.000000', 'temperatura', 69.0000, 'ºC'),
	(286944, 122, '2014-04-01 01:20:57.000000', 'temperatura', 223.0000, 'ºC'),
	(286945, 122, '2014-04-01 01:20:58.000000', 'temperatura', 909.0000, 'ºC'),
	(286946, 122, '2014-04-01 01:20:59.000000', 'temperatura', 274.0000, 'ºC'),
	(286947, 122, '2014-04-01 01:21:00.000000', 'temperatura', 1046.0000, 'ºC'),
	(286948, 122, '2014-04-01 01:21:01.000000', 'temperatura', 807.0000, 'ºC'),
	(286949, 122, '2014-04-01 01:21:02.000000', 'temperatura', 900.0000, 'ºC'),
	(286950, 122, '2014-04-01 01:21:03.000000', 'temperatura', 878.0000, 'ºC'),
	(286951, 122, '2014-04-01 01:21:04.000000', 'temperatura', 489.0000, 'ºC'),
	(286952, 122, '2014-04-01 01:21:05.000000', 'temperatura', 1012.0000, 'ºC'),
	(286953, 122, '2014-04-01 01:21:06.000000', 'temperatura', 1194.0000, 'ºC'),
	(286954, 122, '2014-04-01 01:21:07.000000', 'temperatura', 535.0000, 'ºC'),
	(286955, 122, '2014-04-01 01:21:08.000000', 'temperatura', 292.0000, 'ºC'),
	(286956, 122, '2014-04-01 01:21:09.000000', 'temperatura', 1058.0000, 'ºC'),
	(286957, 122, '2014-04-01 01:21:10.000000', 'temperatura', 813.0000, 'ºC'),
	(286958, 122, '2014-04-01 01:21:11.000000', 'temperatura', 891.0000, 'ºC'),
	(286959, 122, '2014-04-01 01:21:12.000000', 'temperatura', 817.0000, 'ºC'),
	(286960, 122, '2014-04-01 01:21:13.000000', 'temperatura', 211.0000, 'ºC'),
	(286961, 122, '2014-04-01 01:21:14.000000', 'temperatura', 1006.0000, 'ºC'),
	(286962, 122, '2014-04-01 01:21:15.000000', 'temperatura', 799.0000, 'ºC'),
	(286963, 122, '2014-04-01 01:21:16.000000', 'temperatura', 976.0000, 'ºC'),
	(286964, 122, '2014-04-01 01:21:17.000000', 'temperatura', 82.0000, 'ºC'),
	(286965, 122, '2014-04-01 01:21:18.000000', 'temperatura', 1084.0000, 'ºC'),
	(286966, 122, '2014-04-01 01:21:19.000000', 'temperatura', 373.0000, 'ºC'),
	(286967, 122, '2014-04-01 01:21:20.000000', 'temperatura', 1013.0000, 'ºC'),
	(286968, 122, '2014-04-01 01:21:21.000000', 'temperatura', 347.0000, 'ºC'),
	(286969, 122, '2014-04-01 01:21:22.000000', 'temperatura', 1097.0000, 'ºC'),
	(286970, 122, '2014-04-01 01:21:23.000000', 'temperatura', 844.0000, 'ºC'),
	(286971, 122, '2014-04-01 01:21:24.000000', 'temperatura', 929.0000, 'ºC'),
	(286972, 122, '2014-04-01 01:21:25.000000', 'temperatura', 913.0000, 'ºC'),
	(286973, 122, '2014-04-01 01:21:26.000000', 'temperatura', 580.0000, 'ºC'),
	(286974, 122, '2014-04-01 01:21:27.000000', 'temperatura', 163.0000, 'ºC'),
	(286975, 122, '2014-04-01 01:21:28.000000', 'temperatura', 273.0000, 'ºC'),
	(286976, 122, '2014-04-01 01:21:29.000000', 'temperatura', 876.0000, 'ºC'),
	(286977, 122, '2014-04-01 01:21:30.000000', 'temperatura', 1162.0000, 'ºC'),
	(286978, 122, '2014-04-01 01:21:31.000000', 'temperatura', 782.0000, 'ºC'),
	(286979, 122, '2014-04-01 01:21:32.000000', 'temperatura', 427.0000, 'ºC'),
	(286980, 122, '2014-04-01 01:21:33.000000', 'temperatura', 987.0000, 'ºC'),
	(286981, 122, '2014-04-01 01:21:34.000000', 'temperatura', 54.0000, 'ºC'),
	(286982, 122, '2014-04-01 01:21:35.000000', 'temperatura', 909.0000, 'ºC'),
	(286983, 122, '2014-04-01 01:21:36.000000', 'temperatura', 784.0000, 'ºC'),
	(286984, 122, '2014-04-01 01:21:37.000000', 'temperatura', 1195.0000, 'ºC'),
	(286985, 122, '2014-04-01 01:21:38.000000', 'temperatura', 25.0000, 'ºC'),
	(286986, 122, '2014-04-01 01:21:39.000000', 'temperatura', 138.0000, 'ºC'),
	(286987, 122, '2014-04-01 01:21:40.000000', 'temperatura', 615.0000, 'ºC'),
	(286988, 122, '2014-04-01 01:21:41.000000', 'temperatura', 262.0000, 'ºC'),
	(286989, 122, '2014-04-01 01:21:42.000000', 'temperatura', 665.0000, 'ºC'),
	(286990, 122, '2014-04-01 01:21:43.000000', 'temperatura', 141.0000, 'ºC'),
	(286991, 122, '2014-04-01 01:21:44.000000', 'temperatura', 1110.0000, 'ºC'),
	(286992, 122, '2014-04-01 01:21:45.000000', 'temperatura', 328.0000, 'ºC'),
	(286993, 122, '2014-04-01 01:21:46.000000', 'temperatura', 711.0000, 'ºC'),
	(286994, 122, '2014-04-01 01:21:47.000000', 'temperatura', 172.0000, 'ºC'),
	(286995, 122, '2014-04-01 01:21:48.000000', 'temperatura', 1127.0000, 'ºC'),
	(286996, 122, '2014-04-01 01:21:49.000000', 'temperatura', 321.0000, 'ºC'),
	(286997, 122, '2014-04-01 01:21:50.000000', 'temperatura', 625.0000, 'ºC'),
	(286998, 122, '2014-04-01 01:21:51.000000', 'temperatura', 961.0000, 'ºC'),
	(286999, 122, '2014-04-01 01:21:52.000000', 'temperatura', 532.0000, 'ºC'),
	(287000, 122, '2014-04-01 01:21:53.000000', 'temperatura', 978.0000, 'ºC'),
	(287001, 122, '2014-04-01 01:21:54.000000', 'temperatura', 892.0000, 'ºC'),
	(287002, 122, '2014-04-01 01:21:55.000000', 'temperatura', 327.0000, 'ºC'),
	(287003, 122, '2014-04-01 01:21:56.000000', 'temperatura', 159.0000, 'ºC'),
	(287004, 122, '2014-04-01 01:21:57.000000', 'temperatura', 1016.0000, 'ºC'),
	(287005, 122, '2014-04-01 01:21:58.000000', 'temperatura', 1002.0000, 'ºC'),
	(287006, 122, '2014-04-01 01:21:59.000000', 'temperatura', 763.0000, 'ºC'),
	(287007, 122, '2014-04-01 01:22:00.000000', 'temperatura', 808.0000, 'ºC'),
	(287008, 122, '2014-04-01 01:22:01.000000', 'temperatura', 551.0000, 'ºC'),
	(287009, 122, '2014-04-01 01:22:02.000000', 'temperatura', 334.0000, 'ºC'),
	(287010, 122, '2014-04-01 01:22:03.000000', 'temperatura', 15.0000, 'ºC'),
	(287011, 122, '2014-04-01 01:22:04.000000', 'temperatura', 275.0000, 'ºC'),
	(287012, 122, '2014-04-01 01:22:05.000000', 'temperatura', 130.0000, 'ºC'),
	(287013, 122, '2014-04-01 01:22:06.000000', 'temperatura', 1025.0000, 'ºC'),
	(287014, 122, '2014-04-01 01:22:07.000000', 'temperatura', 1134.0000, 'ºC'),
	(287015, 122, '2014-04-01 01:22:08.000000', 'temperatura', 198.0000, 'ºC'),
	(287016, 122, '2014-04-01 01:22:09.000000', 'temperatura', 1190.0000, 'ºC'),
	(287017, 122, '2014-04-01 01:22:10.000000', 'temperatura', 553.0000, 'ºC'),
	(287018, 122, '2014-04-01 01:22:11.000000', 'temperatura', 397.0000, 'ºC'),
	(287019, 122, '2014-04-01 01:22:12.000000', 'temperatura', 327.0000, 'ºC'),
	(287020, 122, '2014-04-01 01:22:13.000000', 'temperatura', 446.0000, 'ºC'),
	(287021, 122, '2014-04-01 01:22:14.000000', 'temperatura', 47.0000, 'ºC'),
	(287022, 122, '2014-04-01 01:22:15.000000', 'temperatura', 99.0000, 'ºC'),
	(287023, 122, '2014-04-01 01:22:16.000000', 'temperatura', 354.0000, 'ºC'),
	(287024, 122, '2014-04-01 01:22:17.000000', 'temperatura', 273.0000, 'ºC'),
	(287025, 122, '2014-04-01 01:22:18.000000', 'temperatura', 305.0000, 'ºC'),
	(287026, 122, '2014-04-01 01:22:19.000000', 'temperatura', 707.0000, 'ºC'),
	(287027, 122, '2014-04-01 01:22:20.000000', 'temperatura', 221.0000, 'ºC'),
	(287028, 122, '2014-04-01 01:22:21.000000', 'temperatura', 184.0000, 'ºC'),
	(287029, 122, '2014-04-01 01:22:22.000000', 'temperatura', 257.0000, 'ºC'),
	(287030, 122, '2014-04-01 01:22:23.000000', 'temperatura', 733.0000, 'ºC'),
	(287031, 122, '2014-04-01 01:22:24.000000', 'temperatura', 494.0000, 'ºC'),
	(287032, 122, '2014-04-01 01:22:25.000000', 'temperatura', 271.0000, 'ºC'),
	(287033, 122, '2014-04-01 01:22:26.000000', 'temperatura', 1075.0000, 'ºC'),
	(287034, 122, '2014-04-01 01:22:27.000000', 'temperatura', 963.0000, 'ºC'),
	(287035, 122, '2014-04-01 01:22:28.000000', 'temperatura', 391.0000, 'ºC'),
	(287036, 122, '2014-04-01 01:22:29.000000', 'temperatura', 267.0000, 'ºC'),
	(287037, 122, '2014-04-01 01:22:30.000000', 'temperatura', 163.0000, 'ºC'),
	(287038, 122, '2014-04-01 01:22:31.000000', 'temperatura', 14.0000, 'ºC'),
	(287039, 122, '2014-04-01 01:22:32.000000', 'temperatura', 783.0000, 'ºC'),
	(287040, 122, '2014-04-01 01:22:33.000000', 'temperatura', 270.0000, 'ºC'),
	(287041, 122, '2014-04-01 01:22:34.000000', 'temperatura', 204.0000, 'ºC'),
	(287042, 122, '2014-04-01 01:22:35.000000', 'temperatura', 210.0000, 'ºC'),
	(287043, 122, '2014-04-01 01:22:36.000000', 'temperatura', 439.0000, 'ºC'),
	(287044, 122, '2014-04-01 01:22:37.000000', 'temperatura', 363.0000, 'ºC'),
	(287045, 122, '2014-04-01 01:22:38.000000', 'temperatura', 502.0000, 'ºC'),
	(287046, 122, '2014-04-01 01:22:39.000000', 'temperatura', 219.0000, 'ºC'),
	(287047, 122, '2014-04-01 01:22:40.000000', 'temperatura', 792.0000, 'ºC'),
	(287048, 122, '2014-04-01 01:22:41.000000', 'temperatura', 903.0000, 'ºC'),
	(287049, 122, '2014-04-01 01:22:42.000000', 'temperatura', 937.0000, 'ºC'),
	(287050, 122, '2014-04-01 01:22:43.000000', 'temperatura', 779.0000, 'ºC'),
	(287051, 122, '2014-04-01 01:22:44.000000', 'temperatura', 1084.0000, 'ºC'),
	(287052, 122, '2014-04-01 01:22:45.000000', 'temperatura', 685.0000, 'ºC'),
	(287053, 122, '2014-04-01 01:22:46.000000', 'temperatura', 172.0000, 'ºC'),
	(287054, 122, '2014-04-01 01:22:47.000000', 'temperatura', 5.0000, 'ºC'),
	(287055, 122, '2014-04-01 01:22:48.000000', 'temperatura', 710.0000, 'ºC'),
	(287056, 122, '2014-04-01 01:22:49.000000', 'temperatura', 1137.0000, 'ºC'),
	(287057, 122, '2014-04-01 01:22:50.000000', 'temperatura', 1155.0000, 'ºC'),
	(287058, 122, '2014-04-01 01:22:51.000000', 'temperatura', 1163.0000, 'ºC'),
	(287059, 122, '2014-04-01 01:22:52.000000', 'temperatura', 1153.0000, 'ºC'),
	(287060, 122, '2014-04-01 01:22:53.000000', 'temperatura', 1076.0000, 'ºC'),
	(287061, 122, '2014-04-01 01:22:54.000000', 'temperatura', 723.0000, 'ºC'),
	(287062, 122, '2014-04-01 01:22:55.000000', 'temperatura', 384.0000, 'ºC'),
	(287063, 122, '2014-04-01 01:22:56.000000', 'temperatura', 954.0000, 'ºC'),
	(287064, 122, '2014-04-01 01:22:57.000000', 'temperatura', 18.0000, 'ºC'),
	(287065, 122, '2014-04-01 01:22:58.000000', 'temperatura', 827.0000, 'ºC'),
	(287066, 122, '2014-04-01 01:22:59.000000', 'temperatura', 484.0000, 'ºC'),
	(287067, 122, '2014-04-01 01:23:00.000000', 'temperatura', 1139.0000, 'ºC'),
	(287068, 122, '2014-04-01 01:23:01.000000', 'temperatura', 643.0000, 'ºC'),
	(287069, 122, '2014-04-01 01:23:02.000000', 'temperatura', 1000.0000, 'ºC'),
	(287070, 122, '2014-04-01 01:23:03.000000', 'temperatura', 669.0000, 'ºC'),
	(287071, 122, '2014-04-01 01:23:04.000000', 'temperatura', 345.0000, 'ºC'),
	(287072, 122, '2014-04-01 01:23:05.000000', 'temperatura', 919.0000, 'ºC'),
	(287073, 122, '2014-04-01 01:23:06.000000', 'temperatura', 1163.0000, 'ºC'),
	(287074, 122, '2014-04-01 01:23:07.000000', 'temperatura', 656.0000, 'ºC'),
	(287075, 122, '2014-04-01 01:23:08.000000', 'temperatura', 991.0000, 'ºC'),
	(287076, 122, '2014-04-01 01:23:09.000000', 'temperatura', 588.0000, 'ºC'),
	(287077, 122, '2014-04-01 01:23:10.000000', 'temperatura', 1166.0000, 'ºC'),
	(287078, 122, '2014-04-01 01:23:11.000000', 'temperatura', 468.0000, 'ºC'),
	(287079, 122, '2014-04-01 01:23:12.000000', 'temperatura', 40.0000, 'ºC'),
	(287080, 122, '2014-04-01 01:23:13.000000', 'temperatura', 0.0000, 'ºC'),
	(287081, 122, '2014-04-01 01:23:14.000000', 'temperatura', 1079.0000, 'ºC'),
	(287082, 122, '2014-04-01 01:23:15.000000', 'temperatura', 595.0000, 'ºC'),
	(287083, 122, '2014-04-01 01:23:16.000000', 'temperatura', 938.0000, 'ºC'),
	(287084, 122, '2014-04-01 01:23:17.000000', 'temperatura', 506.0000, 'ºC'),
	(287085, 122, '2014-04-01 01:23:18.000000', 'temperatura', 914.0000, 'ºC'),
	(287086, 122, '2014-04-01 01:23:19.000000', 'temperatura', 656.0000, 'ºC'),
	(287087, 122, '2014-04-01 01:23:20.000000', 'temperatura', 539.0000, 'ºC'),
	(287088, 122, '2014-04-01 01:23:21.000000', 'temperatura', 726.0000, 'ºC'),
	(287089, 122, '2014-04-01 01:23:22.000000', 'temperatura', 815.0000, 'ºC'),
	(287090, 122, '2014-04-01 01:23:23.000000', 'temperatura', 696.0000, 'ºC'),
	(287091, 122, '2014-04-01 01:23:24.000000', 'temperatura', 1037.0000, 'ºC'),
	(287092, 122, '2014-04-01 01:23:25.000000', 'temperatura', 695.0000, 'ºC'),
	(287093, 122, '2014-04-01 01:23:26.000000', 'temperatura', 367.0000, 'ºC'),
	(287094, 122, '2014-04-01 01:23:27.000000', 'temperatura', 951.0000, 'ºC'),
	(287095, 122, '2014-04-01 01:23:28.000000', 'temperatura', 51.0000, 'ºC'),
	(287096, 122, '2014-04-01 01:23:29.000000', 'temperatura', 1006.0000, 'ºC'),
	(287097, 122, '2014-04-01 01:23:30.000000', 'temperatura', 76.0000, 'ºC'),
	(287098, 122, '2014-04-01 01:23:31.000000', 'temperatura', 963.0000, 'ºC'),
	(287099, 122, '2014-04-01 01:23:32.000000', 'temperatura', 987.0000, 'ºC'),
	(287100, 122, '2014-04-01 01:23:33.000000', 'temperatura', 847.0000, 'ºC'),
	(287101, 122, '2014-04-01 01:23:34.000000', 'temperatura', 73.0000, 'ºC'),
	(287102, 122, '2014-04-01 01:23:35.000000', 'temperatura', 223.0000, 'ºC'),
	(287103, 122, '2014-04-01 01:23:36.000000', 'temperatura', 900.0000, 'ºC'),
	(287104, 122, '2014-04-01 01:23:37.000000', 'temperatura', 229.0000, 'ºC'),
	(287105, 122, '2014-04-01 01:23:38.000000', 'temperatura', 846.0000, 'ºC'),
	(287106, 122, '2014-04-01 01:23:39.000000', 'temperatura', 1143.0000, 'ºC'),
	(287107, 122, '2014-04-01 01:23:40.000000', 'temperatura', 777.0000, 'ºC'),
	(287108, 122, '2014-04-01 01:23:41.000000', 'temperatura', 457.0000, 'ºC'),
	(287109, 122, '2014-04-01 01:23:42.000000', 'temperatura', 1155.0000, 'ºC'),
	(287110, 122, '2014-04-01 01:23:43.000000', 'temperatura', 803.0000, 'ºC'),
	(287111, 122, '2014-04-01 01:23:44.000000', 'temperatura', 551.0000, 'ºC'),
	(287112, 122, '2014-04-01 01:23:45.000000', 'temperatura', 347.0000, 'ºC'),
	(287113, 122, '2014-04-01 01:23:46.000000', 'temperatura', 82.0000, 'ºC'),
	(287114, 122, '2014-04-01 01:23:47.000000', 'temperatura', 570.0000, 'ºC'),
	(287115, 122, '2014-04-01 01:23:48.000000', 'temperatura', 205.0000, 'ºC'),
	(287116, 122, '2014-04-01 01:23:49.000000', 'temperatura', 515.0000, 'ºC'),
	(287117, 122, '2014-04-01 01:23:50.000000', 'temperatura', 760.0000, 'ºC'),
	(287118, 122, '2014-04-01 01:23:51.000000', 'temperatura', 1058.0000, 'ºC'),
	(287119, 122, '2014-04-01 01:23:52.000000', 'temperatura', 609.0000, 'ºC'),
	(287120, 122, '2014-04-01 01:23:53.000000', 'temperatura', 1071.0000, 'ºC'),
	(287121, 122, '2014-04-01 01:23:54.000000', 'temperatura', 1127.0000, 'ºC'),
	(287122, 122, '2014-04-01 01:23:55.000000', 'temperatura', 26.0000, 'ºC'),
	(287123, 122, '2014-04-01 01:23:56.000000', 'temperatura', 347.0000, 'ºC'),
	(287124, 122, '2014-04-01 01:23:57.000000', 'temperatura', 457.0000, 'ºC'),
	(287125, 122, '2014-04-01 01:23:58.000000', 'temperatura', 45.0000, 'ºC'),
	(287126, 122, '2014-04-01 01:23:59.000000', 'temperatura', 53.0000, 'ºC'),
	(287127, 122, '2014-04-01 01:24:00.000000', 'temperatura', 130.0000, 'ºC'),
	(287128, 122, '2014-04-01 01:24:01.000000', 'temperatura', 494.0000, 'ºC'),
	(287129, 122, '2014-04-01 01:24:02.000000', 'temperatura', 882.0000, 'ºC'),
	(287130, 122, '2014-04-01 01:24:03.000000', 'temperatura', 526.0000, 'ºC'),
	(287131, 122, '2014-04-01 01:24:04.000000', 'temperatura', 1183.0000, 'ºC'),
	(287132, 122, '2014-04-01 01:24:05.000000', 'temperatura', 740.0000, 'ºC'),
	(287133, 122, '2014-04-01 01:24:06.000000', 'temperatura', 150.0000, 'ºC'),
	(287134, 122, '2014-04-01 01:24:07.000000', 'temperatura', 932.0000, 'ºC'),
	(287135, 122, '2014-04-01 01:24:08.000000', 'temperatura', 609.0000, 'ºC'),
	(287136, 122, '2014-04-01 01:24:09.000000', 'temperatura', 249.0000, 'ºC'),
	(287137, 122, '2014-04-01 01:24:10.000000', 'temperatura', 619.0000, 'ºC'),
	(287138, 122, '2014-04-01 01:24:11.000000', 'temperatura', 1147.0000, 'ºC'),
	(287139, 122, '2014-04-01 01:24:12.000000', 'temperatura', 278.0000, 'ºC'),
	(287140, 122, '2014-04-01 01:24:13.000000', 'temperatura', 350.0000, 'ºC'),
	(287141, 122, '2014-04-01 01:24:14.000000', 'temperatura', 917.0000, 'ºC'),
	(287142, 122, '2014-04-01 01:24:15.000000', 'temperatura', 1134.0000, 'ºC'),
	(287143, 122, '2014-04-01 01:24:16.000000', 'temperatura', 522.0000, 'ºC'),
	(287144, 122, '2014-04-01 01:24:17.000000', 'temperatura', 409.0000, 'ºC'),
	(287145, 122, '2014-04-01 01:24:18.000000', 'temperatura', 480.0000, 'ºC'),
	(287146, 122, '2014-04-01 01:24:19.000000', 'temperatura', 1174.0000, 'ºC'),
	(287147, 122, '2014-04-01 01:24:20.000000', 'temperatura', 830.0000, 'ºC'),
	(287148, 122, '2014-04-01 01:24:21.000000', 'temperatura', 629.0000, 'ºC'),
	(287149, 122, '2014-04-01 01:24:22.000000', 'temperatura', 655.0000, 'ºC'),
	(287150, 122, '2014-04-01 01:24:23.000000', 'temperatura', 188.0000, 'ºC'),
	(287151, 122, '2014-04-01 01:24:24.000000', 'temperatura', 175.0000, 'ºC'),
	(287152, 122, '2014-04-01 01:24:25.000000', 'temperatura', 311.0000, 'ºC'),
	(287153, 122, '2014-04-01 01:24:26.000000', 'temperatura', 1031.0000, 'ºC'),
	(287154, 122, '2014-04-01 01:24:27.000000', 'temperatura', 624.0000, 'ºC'),
	(287155, 122, '2014-04-01 01:24:28.000000', 'temperatura', 28.0000, 'ºC'),
	(287156, 122, '2014-04-01 01:24:29.000000', 'temperatura', 669.0000, 'ºC'),
	(287157, 122, '2014-04-01 01:24:30.000000', 'temperatura', 861.0000, 'ºC'),
	(287158, 122, '2014-04-01 01:24:31.000000', 'temperatura', 1098.0000, 'ºC'),
	(287159, 122, '2014-04-01 01:24:32.000000', 'temperatura', 507.0000, 'ºC'),
	(287160, 122, '2014-04-01 01:24:33.000000', 'temperatura', 441.0000, 'ºC'),
	(287161, 122, '2014-04-01 01:24:34.000000', 'temperatura', 683.0000, 'ºC'),
	(287162, 122, '2014-04-01 01:24:35.000000', 'temperatura', 894.0000, 'ºC'),
	(287163, 122, '2014-04-01 01:24:36.000000', 'temperatura', 23.0000, 'ºC'),
	(287164, 122, '2014-04-01 01:24:37.000000', 'temperatura', 1033.0000, 'ºC'),
	(287165, 122, '2014-04-01 01:24:38.000000', 'temperatura', 297.0000, 'ºC'),
	(287166, 122, '2014-04-01 01:24:39.000000', 'temperatura', 785.0000, 'ºC'),
	(287167, 122, '2014-04-01 01:24:40.000000', 'temperatura', 635.0000, 'ºC'),
	(287168, 122, '2014-04-01 01:24:41.000000', 'temperatura', 823.0000, 'ºC'),
	(287169, 122, '2014-04-01 01:24:42.000000', 'temperatura', 1007.0000, 'ºC'),
	(287170, 122, '2014-04-01 01:24:43.000000', 'temperatura', 168.0000, 'ºC'),
	(287171, 122, '2014-04-01 01:24:44.000000', 'temperatura', 221.0000, 'ºC'),
	(287172, 122, '2014-04-01 01:24:45.000000', 'temperatura', 601.0000, 'ºC'),
	(287173, 122, '2014-04-01 01:24:46.000000', 'temperatura', 1142.0000, 'ºC'),
	(287174, 122, '2014-04-01 01:24:47.000000', 'temperatura', 308.0000, 'ºC'),
	(287175, 122, '2014-04-01 01:24:48.000000', 'temperatura', 513.0000, 'ºC'),
	(287176, 122, '2014-04-01 01:24:49.000000', 'temperatura', 442.0000, 'ºC'),
	(287177, 122, '2014-04-01 01:24:50.000000', 'temperatura', 670.0000, 'ºC'),
	(287178, 122, '2014-04-01 01:24:51.000000', 'temperatura', 825.0000, 'ºC'),
	(287179, 122, '2014-04-01 01:24:52.000000', 'temperatura', 914.0000, 'ºC'),
	(287180, 122, '2014-04-01 01:24:53.000000', 'temperatura', 898.0000, 'ºC'),
	(287181, 122, '2014-04-01 01:24:54.000000', 'temperatura', 549.0000, 'ºC'),
	(287182, 122, '2014-04-01 01:24:55.000000', 'temperatura', 49.0000, 'ºC'),
	(287183, 122, '2014-04-01 01:24:56.000000', 'temperatura', 999.0000, 'ºC'),
	(287184, 122, '2014-04-01 01:24:57.000000', 'temperatura', 48.0000, 'ºC'),
	(287185, 122, '2014-04-01 01:24:58.000000', 'temperatura', 843.0000, 'ºC'),
	(287186, 122, '2014-04-01 01:24:59.000000', 'temperatura', 470.0000, 'ºC'),
	(287187, 122, '2014-04-01 01:25:00.000000', 'temperatura', 1025.0000, 'ºC'),
	(287188, 122, '2014-04-01 01:25:01.000000', 'temperatura', 114.0000, 'ºC'),
	(287189, 122, '2014-04-01 01:25:02.000000', 'temperatura', 1094.0000, 'ºC'),
	(287190, 122, '2014-04-01 01:25:03.000000', 'temperatura', 329.0000, 'ºC'),
	(287191, 122, '2014-04-01 01:25:04.000000', 'temperatura', 765.0000, 'ºC'),
	(287192, 122, '2014-04-01 01:25:05.000000', 'temperatura', 436.0000, 'ºC'),
	(287193, 122, '2014-04-01 01:25:06.000000', 'temperatura', 1087.0000, 'ºC'),
	(287194, 122, '2014-04-01 01:25:07.000000', 'temperatura', 526.0000, 'ºC'),
	(287195, 122, '2014-04-01 01:25:08.000000', 'temperatura', 572.0000, 'ºC'),
	(287196, 122, '2014-04-01 01:25:09.000000', 'temperatura', 80.0000, 'ºC'),
	(287197, 122, '2014-04-01 01:25:10.000000', 'temperatura', 1083.0000, 'ºC'),
	(287198, 122, '2014-04-01 01:25:11.000000', 'temperatura', 379.0000, 'ºC'),
	(287199, 122, '2014-04-01 01:25:12.000000', 'temperatura', 1045.0000, 'ºC'),
	(287200, 122, '2014-04-01 01:25:13.000000', 'temperatura', 491.0000, 'ºC'),
	(287201, 122, '2014-04-01 01:25:14.000000', 'temperatura', 517.0000, 'ºC'),
	(287202, 122, '2014-04-01 01:25:15.000000', 'temperatura', 1115.0000, 'ºC'),
	(287203, 122, '2014-04-01 01:25:16.000000', 'temperatura', 422.0000, 'ºC'),
	(287204, 122, '2014-04-01 01:25:17.000000', 'temperatura', 1167.0000, 'ºC'),
	(287205, 122, '2014-04-01 01:25:18.000000', 'temperatura', 970.0000, 'ºC'),
	(287206, 122, '2014-04-01 01:25:19.000000', 'temperatura', 148.0000, 'ºC'),
	(287207, 122, '2014-04-01 01:25:20.000000', 'temperatura', 231.0000, 'ºC'),
	(287208, 122, '2014-04-01 01:25:21.000000', 'temperatura', 713.0000, 'ºC'),
	(287209, 122, '2014-04-01 01:25:22.000000', 'temperatura', 471.0000, 'ºC'),
	(287210, 122, '2014-04-01 01:25:23.000000', 'temperatura', 218.0000, 'ºC'),
	(287211, 122, '2014-04-01 01:25:24.000000', 'temperatura', 876.0000, 'ºC'),
	(287212, 122, '2014-04-01 01:25:25.000000', 'temperatura', 126.0000, 'ºC'),
	(287213, 122, '2014-04-01 01:25:26.000000', 'temperatura', 402.0000, 'ºC'),
	(287214, 122, '2014-04-01 01:25:27.000000', 'temperatura', 433.0000, 'ºC'),
	(287215, 122, '2014-04-01 01:25:28.000000', 'temperatura', 961.0000, 'ºC'),
	(287216, 122, '2014-04-01 01:25:29.000000', 'temperatura', 1106.0000, 'ºC'),
	(287217, 122, '2014-04-01 01:25:30.000000', 'temperatura', 246.0000, 'ºC'),
	(287218, 122, '2014-04-01 01:25:31.000000', 'temperatura', 313.0000, 'ºC'),
	(287219, 122, '2014-04-01 01:25:32.000000', 'temperatura', 828.0000, 'ºC'),
	(287220, 122, '2014-04-01 01:25:33.000000', 'temperatura', 802.0000, 'ºC'),
	(287221, 122, '2014-04-01 01:25:34.000000', 'temperatura', 324.0000, 'ºC'),
	(287222, 122, '2014-04-01 01:25:35.000000', 'temperatura', 416.0000, 'ºC'),
	(287223, 122, '2014-04-01 01:25:36.000000', 'temperatura', 1107.0000, 'ºC'),
	(287224, 122, '2014-04-01 01:25:37.000000', 'temperatura', 690.0000, 'ºC'),
	(287225, 122, '2014-04-01 01:25:38.000000', 'temperatura', 130.0000, 'ºC'),
	(287226, 122, '2014-04-01 01:25:39.000000', 'temperatura', 979.0000, 'ºC'),
	(287227, 122, '2014-04-01 01:25:40.000000', 'temperatura', 905.0000, 'ºC'),
	(287228, 122, '2014-04-01 01:25:41.000000', 'temperatura', 389.0000, 'ºC'),
	(287229, 122, '2014-04-01 01:25:42.000000', 'temperatura', 429.0000, 'ºC'),
	(287230, 122, '2014-04-01 01:25:43.000000', 'temperatura', 978.0000, 'ºC'),
	(287231, 122, '2014-04-01 01:25:44.000000', 'temperatura', 3.0000, 'ºC'),
	(287232, 122, '2014-04-01 01:25:45.000000', 'temperatura', 684.0000, 'ºC'),
	(287233, 122, '2014-04-01 01:25:46.000000', 'temperatura', 1010.0000, 'ºC'),
	(287234, 122, '2014-04-01 01:25:47.000000', 'temperatura', 601.0000, 'ºC'),
	(287235, 122, '2014-04-01 01:25:48.000000', 'temperatura', 1174.0000, 'ºC'),
	(287236, 122, '2014-04-01 01:25:49.000000', 'temperatura', 466.0000, 'ºC'),
	(287237, 122, '2014-04-01 01:25:50.000000', 'temperatura', 11.0000, 'ºC'),
	(287238, 122, '2014-04-01 01:25:51.000000', 'temperatura', 1055.0000, 'ºC'),
	(287239, 122, '2014-04-01 01:25:52.000000', 'temperatura', 443.0000, 'ºC'),
	(287240, 122, '2014-04-01 01:25:53.000000', 'temperatura', 250.0000, 'ºC'),
	(287241, 122, '2014-04-01 01:25:54.000000', 'temperatura', 1123.0000, 'ºC'),
	(287242, 122, '2014-04-01 01:25:55.000000', 'temperatura', 66.0000, 'ºC'),
	(287243, 122, '2014-04-01 01:25:56.000000', 'temperatura', 562.0000, 'ºC'),
	(287244, 122, '2014-04-01 01:25:57.000000', 'temperatura', 212.0000, 'ºC'),
	(287245, 122, '2014-04-01 01:25:58.000000', 'temperatura', 576.0000, 'ºC'),
	(287246, 122, '2014-04-01 01:25:59.000000', 'temperatura', 1042.0000, 'ºC'),
	(287247, 122, '2014-04-01 01:26:00.000000', 'temperatura', 1084.0000, 'ºC'),
	(287248, 122, '2014-04-01 01:26:01.000000', 'temperatura', 1092.0000, 'ºC'),
	(287249, 122, '2014-04-01 01:26:02.000000', 'temperatura', 1011.0000, 'ºC'),
	(287250, 122, '2014-04-01 01:26:03.000000', 'temperatura', 578.0000, 'ºC'),
	(287251, 122, '2014-04-01 01:26:04.000000', 'temperatura', 1060.0000, 'ºC'),
	(287252, 122, '2014-04-01 01:26:05.000000', 'temperatura', 1166.0000, 'ºC'),
	(287253, 122, '2014-04-01 01:26:06.000000', 'temperatura', 249.0000, 'ºC'),
	(287254, 122, '2014-04-01 01:26:07.000000', 'temperatura', 147.0000, 'ºC'),
	(287255, 122, '2014-04-01 01:26:08.000000', 'temperatura', 1191.0000, 'ºC'),
	(287256, 122, '2014-04-01 01:26:09.000000', 'temperatura', 713.0000, 'ºC'),
	(287257, 122, '2014-04-01 01:26:10.000000', 'temperatura', 1191.0000, 'ºC'),
	(287258, 122, '2014-04-01 01:26:11.000000', 'temperatura', 218.0000, 'ºC'),
	(287259, 122, '2014-04-01 01:26:12.000000', 'temperatura', 1119.0000, 'ºC'),
	(287260, 122, '2014-04-01 01:26:13.000000', 'temperatura', 141.0000, 'ºC'),
	(287261, 122, '2014-04-01 01:26:14.000000', 'temperatura', 947.0000, 'ºC'),
	(287262, 122, '2014-04-01 01:26:15.000000', 'temperatura', 715.0000, 'ºC'),
	(287263, 122, '2014-04-01 01:26:16.000000', 'temperatura', 733.0000, 'ºC'),
	(287264, 122, '2014-04-01 01:26:17.000000', 'temperatura', 322.0000, 'ºC'),
	(287265, 122, '2014-04-01 01:26:18.000000', 'temperatura', 610.0000, 'ºC'),
	(287266, 122, '2014-04-01 01:26:19.000000', 'temperatura', 886.0000, 'ºC'),
	(287267, 122, '2014-04-01 01:26:20.000000', 'temperatura', 199.0000, 'ºC'),
	(287268, 122, '2014-04-01 01:26:21.000000', 'temperatura', 740.0000, 'ºC'),
	(287269, 122, '2014-04-01 01:26:22.000000', 'temperatura', 700.0000, 'ºC'),
	(287270, 122, '2014-04-01 01:26:23.000000', 'temperatura', 83.0000, 'ºC'),
	(287271, 122, '2014-04-01 01:26:24.000000', 'temperatura', 713.0000, 'ºC'),
	(287272, 122, '2014-04-01 01:26:25.000000', 'temperatura', 919.0000, 'ºC'),
	(287273, 122, '2014-04-01 01:26:26.000000', 'temperatura', 55.0000, 'ºC'),
	(287274, 122, '2014-04-01 01:26:27.000000', 'temperatura', 1117.0000, 'ºC'),
	(287275, 122, '2014-04-01 01:26:28.000000', 'temperatura', 622.0000, 'ºC'),
	(287276, 122, '2014-04-01 01:26:29.000000', 'temperatura', 960.0000, 'ºC'),
	(287277, 122, '2014-04-01 01:26:30.000000', 'temperatura', 533.0000, 'ºC'),
	(287278, 122, '2014-04-01 01:26:31.000000', 'temperatura', 987.0000, 'ºC'),
	(287279, 122, '2014-04-01 01:26:32.000000', 'temperatura', 937.0000, 'ºC'),
	(287280, 122, '2014-04-01 01:26:33.000000', 'temperatura', 523.0000, 'ºC'),
	(287281, 122, '2014-04-01 01:26:34.000000', 'temperatura', 1006.0000, 'ºC'),
	(287282, 122, '2014-04-01 01:26:35.000000', 'temperatura', 1061.0000, 'ºC'),
	(287283, 122, '2014-04-01 01:26:36.000000', 'temperatura', 1088.0000, 'ºC'),
	(287284, 122, '2014-04-01 01:26:37.000000', 'temperatura', 1058.0000, 'ºC'),
	(287285, 122, '2014-04-01 01:26:38.000000', 'temperatura', 827.0000, 'ºC'),
	(287286, 122, '2014-04-01 01:26:39.000000', 'temperatura', 960.0000, 'ºC'),
	(287287, 122, '2014-04-01 01:26:40.000000', 'temperatura', 1121.0000, 'ºC'),
	(287288, 122, '2014-04-01 01:26:41.000000', 'temperatura', 326.0000, 'ºC'),
	(287289, 122, '2014-04-01 01:26:42.000000', 'temperatura', 666.0000, 'ºC'),
	(287290, 122, '2014-04-01 01:26:43.000000', 'temperatura', 1151.0000, 'ºC'),
	(287291, 122, '2014-04-01 01:26:44.000000', 'temperatura', 159.0000, 'ºC'),
	(287292, 122, '2014-04-01 01:26:45.000000', 'temperatura', 943.0000, 'ºC'),
	(287293, 122, '2014-04-01 01:26:46.000000', 'temperatura', 638.0000, 'ºC'),
	(287294, 122, '2014-04-01 01:26:47.000000', 'temperatura', 361.0000, 'ºC'),
	(287295, 122, '2014-04-01 01:26:48.000000', 'temperatura', 1093.0000, 'ºC'),
	(287296, 122, '2014-04-01 01:26:49.000000', 'temperatura', 782.0000, 'ºC'),
	(287297, 122, '2014-04-01 01:26:50.000000', 'temperatura', 631.0000, 'ºC'),
	(287298, 122, '2014-04-01 01:26:51.000000', 'temperatura', 809.0000, 'ºC'),
	(287299, 122, '2014-04-01 01:26:52.000000', 'temperatura', 955.0000, 'ºC'),
	(287300, 122, '2014-04-01 01:26:53.000000', 'temperatura', 1145.0000, 'ºC'),
	(287301, 122, '2014-04-01 01:26:54.000000', 'temperatura', 464.0000, 'ºC'),
	(287302, 122, '2014-04-01 01:26:55.000000', 'temperatura', 82.0000, 'ºC'),
	(287303, 122, '2014-04-01 01:26:56.000000', 'temperatura', 221.0000, 'ºC'),
	(287304, 122, '2014-04-01 01:26:57.000000', 'temperatura', 859.0000, 'ºC'),
	(287305, 122, '2014-04-01 01:26:58.000000', 'temperatura', 32.0000, 'ºC'),
	(287306, 122, '2014-04-01 01:26:59.000000', 'temperatura', 1184.0000, 'ºC'),
	(287307, 122, '2014-04-01 01:27:00.000000', 'temperatura', 1022.0000, 'ºC'),
	(287308, 122, '2014-04-01 01:27:01.000000', 'temperatura', 362.0000, 'ºC'),
	(287309, 122, '2014-04-01 01:27:02.000000', 'temperatura', 1144.0000, 'ºC'),
	(287310, 122, '2014-04-01 01:27:03.000000', 'temperatura', 1033.0000, 'ºC'),
	(287311, 122, '2014-04-01 01:27:04.000000', 'temperatura', 536.0000, 'ºC'),
	(287312, 122, '2014-04-01 01:27:05.000000', 'temperatura', 781.0000, 'ºC'),
	(287313, 122, '2014-04-01 01:27:06.000000', 'temperatura', 1098.0000, 'ºC'),
	(287314, 122, '2014-04-01 01:27:07.000000', 'temperatura', 748.0000, 'ºC'),
	(287315, 122, '2014-04-01 01:27:08.000000', 'temperatura', 444.0000, 'ºC'),
	(287316, 122, '2014-04-01 01:27:09.000000', 'temperatura', 1176.0000, 'ºC'),
	(287317, 122, '2014-04-01 01:27:10.000000', 'temperatura', 949.0000, 'ºC'),
	(287318, 122, '2014-04-01 01:27:11.000000', 'temperatura', 17.0000, 'ºC'),
	(287319, 122, '2014-04-01 01:27:12.000000', 'temperatura', 838.0000, 'ºC'),
	(287320, 122, '2014-04-01 01:27:13.000000', 'temperatura', 542.0000, 'ºC'),
	(287321, 122, '2014-04-01 01:27:14.000000', 'temperatura', 194.0000, 'ºC'),
	(287322, 122, '2014-04-01 01:27:15.000000', 'temperatura', 544.0000, 'ºC'),
	(287323, 122, '2014-04-01 01:27:16.000000', 'temperatura', 938.0000, 'ºC'),
	(287324, 122, '2014-04-01 01:27:17.000000', 'temperatura', 661.0000, 'ºC'),
	(287325, 122, '2014-04-01 01:27:18.000000', 'temperatura', 491.0000, 'ºC'),
	(287326, 122, '2014-04-01 01:27:19.000000', 'temperatura', 471.0000, 'ºC'),
	(287327, 122, '2014-04-01 01:27:20.000000', 'temperatura', 885.0000, 'ºC'),
	(287328, 122, '2014-04-01 01:27:21.000000', 'temperatura', 612.0000, 'ºC'),
	(287329, 122, '2014-04-01 01:27:22.000000', 'temperatura', 406.0000, 'ºC'),
	(287330, 122, '2014-04-01 01:27:23.000000', 'temperatura', 193.0000, 'ºC'),
	(287331, 122, '2014-04-01 01:27:24.000000', 'temperatura', 946.0000, 'ºC'),
	(287332, 122, '2014-04-01 01:27:25.000000', 'temperatura', 554.0000, 'ºC'),
	(287333, 122, '2014-04-01 01:27:26.000000', 'temperatura', 1133.0000, 'ºC'),
	(287334, 122, '2014-04-01 01:27:27.000000', 'temperatura', 401.0000, 'ºC'),
	(287335, 122, '2014-04-01 01:27:28.000000', 'temperatura', 1006.0000, 'ºC'),
	(287336, 122, '2014-04-01 01:27:29.000000', 'temperatura', 229.0000, 'ºC'),
	(287337, 122, '2014-04-01 01:27:30.000000', 'temperatura', 528.0000, 'ºC'),
	(287338, 122, '2014-04-01 01:27:31.000000', 'temperatura', 753.0000, 'ºC'),
	(287339, 122, '2014-04-01 01:27:32.000000', 'temperatura', 979.0000, 'ºC'),
	(287340, 122, '2014-04-01 01:27:33.000000', 'temperatura', 240.0000, 'ºC'),
	(287341, 122, '2014-04-01 01:27:34.000000', 'temperatura', 662.0000, 'ºC'),
	(287342, 122, '2014-04-01 01:27:35.000000', 'temperatura', 192.0000, 'ºC'),
	(287343, 122, '2014-04-01 01:27:36.000000', 'temperatura', 172.0000, 'ºC'),
	(287344, 122, '2014-04-01 01:27:37.000000', 'temperatura', 288.0000, 'ºC'),
	(287345, 122, '2014-04-01 01:27:38.000000', 'temperatura', 922.0000, 'ºC'),
	(287346, 122, '2014-04-01 01:27:39.000000', 'temperatura', 145.0000, 'ºC'),
	(287347, 122, '2014-04-01 01:27:40.000000', 'temperatura', 363.0000, 'ºC'),
	(287348, 122, '2014-04-01 01:27:41.000000', 'temperatura', 179.0000, 'ºC'),
	(287349, 122, '2014-04-01 01:27:42.000000', 'temperatura', 1006.0000, 'ºC'),
	(287350, 122, '2014-04-01 01:27:43.000000', 'temperatura', 893.0000, 'ºC'),
	(287351, 122, '2014-04-01 01:27:44.000000', 'temperatura', 250.0000, 'ºC'),
	(287352, 122, '2014-04-01 01:27:45.000000', 'temperatura', 970.0000, 'ºC'),
	(287353, 122, '2014-04-01 01:27:46.000000', 'temperatura', 500.0000, 'ºC'),
	(287354, 122, '2014-04-01 01:27:47.000000', 'temperatura', 789.0000, 'ºC'),
	(287355, 122, '2014-04-01 01:27:48.000000', 'temperatura', 47.0000, 'ºC'),
	(287356, 122, '2014-04-01 01:27:49.000000', 'temperatura', 270.0000, 'ºC'),
	(287357, 122, '2014-04-01 01:27:50.000000', 'temperatura', 10.0000, 'ºC'),
	(287358, 122, '2014-04-01 01:27:51.000000', 'temperatura', 441.0000, 'ºC'),
	(287359, 122, '2014-04-01 01:27:52.000000', 'temperatura', 975.0000, 'ºC'),
	(287360, 122, '2014-04-01 01:27:53.000000', 'temperatura', 1154.0000, 'ºC'),
	(287361, 122, '2014-04-01 01:27:54.000000', 'temperatura', 444.0000, 'ºC'),
	(287362, 122, '2014-04-01 01:27:55.000000', 'temperatura', 1159.0000, 'ºC'),
	(287363, 122, '2014-04-01 01:27:56.000000', 'temperatura', 864.0000, 'ºC'),
	(287364, 122, '2014-04-01 01:27:57.000000', 'temperatura', 845.0000, 'ºC'),
	(287365, 122, '2014-04-01 01:27:58.000000', 'temperatura', 432.0000, 'ºC'),
	(287366, 122, '2014-04-01 01:27:59.000000', 'temperatura', 824.0000, 'ºC'),
	(287367, 122, '2014-04-01 01:28:00.000000', 'temperatura', 424.0000, 'ºC'),
	(287368, 122, '2014-04-01 01:28:01.000000', 'temperatura', 850.0000, 'ºC'),
	(287369, 122, '2014-04-01 01:28:02.000000', 'temperatura', 577.0000, 'ºC'),
	(287370, 122, '2014-04-01 01:28:03.000000', 'temperatura', 336.0000, 'ºC'),
	(287371, 122, '2014-04-01 01:28:04.000000', 'temperatura', 1148.0000, 'ºC'),
	(287372, 122, '2014-04-01 01:28:05.000000', 'temperatura', 1133.0000, 'ºC'),
	(287373, 122, '2014-04-01 01:28:06.000000', 'temperatura', 1020.0000, 'ºC'),
	(287374, 122, '2014-04-01 01:28:07.000000', 'temperatura', 505.0000, 'ºC'),
	(287375, 122, '2014-04-01 01:28:08.000000', 'temperatura', 663.0000, 'ºC'),
	(287376, 122, '2014-04-01 01:28:09.000000', 'temperatura', 603.0000, 'ºC'),
	(287377, 122, '2014-04-01 01:28:10.000000', 'temperatura', 1025.0000, 'ºC'),
	(287378, 122, '2014-04-01 01:28:11.000000', 'temperatura', 918.0000, 'ºC'),
	(287379, 122, '2014-04-01 01:28:12.000000', 'temperatura', 315.0000, 'ºC'),
	(287380, 122, '2014-04-01 01:28:13.000000', 'temperatura', 22.0000, 'ºC'),
	(287381, 122, '2014-04-01 01:28:14.000000', 'temperatura', 363.0000, 'ºC'),
	(287382, 122, '2014-04-01 01:28:15.000000', 'temperatura', 551.0000, 'ºC'),
	(287383, 122, '2014-04-01 01:28:16.000000', 'temperatura', 464.0000, 'ºC'),
	(287384, 122, '2014-04-01 01:28:17.000000', 'temperatura', 671.0000, 'ºC'),
	(287385, 122, '2014-04-01 01:28:18.000000', 'temperatura', 761.0000, 'ºC'),
	(287386, 122, '2014-04-01 01:28:19.000000', 'temperatura', 594.0000, 'ºC'),
	(287387, 122, '2014-04-01 01:28:20.000000', 'temperatura', 689.0000, 'ºC'),
	(287388, 122, '2014-04-01 01:28:21.000000', 'temperatura', 461.0000, 'ºC'),
	(287389, 122, '2014-04-01 01:28:22.000000', 'temperatura', 240.0000, 'ºC'),
	(287390, 122, '2014-04-01 01:28:23.000000', 'temperatura', 1017.0000, 'ºC'),
	(287391, 122, '2014-04-01 01:28:24.000000', 'temperatura', 765.0000, 'ºC'),
	(287392, 122, '2014-04-01 01:28:25.000000', 'temperatura', 774.0000, 'ºC'),
	(287393, 122, '2014-04-01 01:28:26.000000', 'temperatura', 376.0000, 'ºC'),
	(287394, 122, '2014-04-01 01:28:27.000000', 'temperatura', 761.0000, 'ºC'),
	(287395, 122, '2014-04-01 01:28:28.000000', 'temperatura', 274.0000, 'ºC'),
	(287396, 122, '2014-04-01 01:28:29.000000', 'temperatura', 290.0000, 'ºC'),
	(287397, 122, '2014-04-01 01:28:30.000000', 'temperatura', 627.0000, 'ºC'),
	(287398, 122, '2014-04-01 01:28:31.000000', 'temperatura', 1067.0000, 'ºC'),
	(287399, 122, '2014-04-01 01:28:32.000000', 'temperatura', 1052.0000, 'ºC'),
	(287400, 122, '2014-04-01 01:28:33.000000', 'temperatura', 861.0000, 'ºC'),
	(287401, 122, '2014-04-01 01:28:34.000000', 'temperatura', 1151.0000, 'ºC'),
	(287402, 122, '2014-04-01 01:28:35.000000', 'temperatura', 771.0000, 'ºC'),
	(287403, 122, '2014-04-01 01:28:36.000000', 'temperatura', 404.0000, 'ºC'),
	(287404, 122, '2014-04-01 01:28:37.000000', 'temperatura', 906.0000, 'ºC'),
	(287405, 122, '2014-04-01 01:28:38.000000', 'temperatura', 917.0000, 'ºC'),
	(287406, 122, '2014-04-01 01:28:39.000000', 'temperatura', 671.0000, 'ºC'),
	(287407, 122, '2014-04-01 01:28:40.000000', 'temperatura', 601.0000, 'ºC'),
	(287408, 122, '2014-04-01 01:28:41.000000', 'temperatura', 995.0000, 'ºC'),
	(287409, 122, '2014-04-01 01:28:42.000000', 'temperatura', 770.0000, 'ºC'),
	(287410, 122, '2014-04-01 01:28:43.000000', 'temperatura', 868.0000, 'ºC'),
	(287411, 122, '2014-04-01 01:28:44.000000', 'temperatura', 831.0000, 'ºC'),
	(287412, 122, '2014-04-01 01:28:45.000000', 'temperatura', 349.0000, 'ºC'),
	(287413, 122, '2014-04-01 01:28:46.000000', 'temperatura', 454.0000, 'ºC'),
	(287414, 122, '2014-04-01 01:28:47.000000', 'temperatura', 24.0000, 'ºC'),
	(287415, 122, '2014-04-01 01:28:48.000000', 'temperatura', 1157.0000, 'ºC'),
	(287416, 122, '2014-04-01 01:28:49.000000', 'temperatura', 914.0000, 'ºC'),
	(287417, 122, '2014-04-01 01:28:50.000000', 'temperatura', 1101.0000, 'ºC'),
	(287418, 122, '2014-04-01 01:28:51.000000', 'temperatura', 363.0000, 'ºC'),
	(287419, 122, '2014-04-01 01:28:52.000000', 'temperatura', 912.0000, 'ºC'),
	(287420, 122, '2014-04-01 01:28:53.000000', 'temperatura', 1070.0000, 'ºC'),
	(287421, 122, '2014-04-01 01:28:54.000000', 'temperatura', 214.0000, 'ºC'),
	(287422, 122, '2014-04-01 01:28:55.000000', 'temperatura', 263.0000, 'ºC'),
	(287423, 122, '2014-04-01 01:28:56.000000', 'temperatura', 671.0000, 'ºC'),
	(287424, 122, '2014-04-01 01:28:57.000000', 'temperatura', 169.0000, 'ºC'),
	(287425, 122, '2014-04-01 01:28:58.000000', 'temperatura', 33.0000, 'ºC'),
	(287426, 122, '2014-04-01 01:28:59.000000', 'temperatura', 857.0000, 'ºC'),
	(287427, 122, '2014-04-01 01:29:00.000000', 'temperatura', 586.0000, 'ºC'),
	(287428, 122, '2014-04-01 01:29:01.000000', 'temperatura', 359.0000, 'ºC'),
	(287429, 122, '2014-04-01 01:29:02.000000', 'temperatura', 38.0000, 'ºC'),
	(287430, 122, '2014-04-01 01:29:03.000000', 'temperatura', 313.0000, 'ºC'),
	(287431, 122, '2014-04-01 01:29:04.000000', 'temperatura', 250.0000, 'ºC'),
	(287432, 122, '2014-04-01 01:29:05.000000', 'temperatura', 315.0000, 'ºC'),
	(287433, 122, '2014-04-01 01:29:06.000000', 'temperatura', 824.0000, 'ºC'),
	(287434, 122, '2014-04-01 01:29:07.000000', 'temperatura', 775.0000, 'ºC'),
	(287435, 122, '2014-04-01 01:29:08.000000', 'temperatura', 206.0000, 'ºC'),
	(287436, 122, '2014-04-01 01:29:09.000000', 'temperatura', 1104.0000, 'ºC'),
	(287437, 122, '2014-04-01 01:29:10.000000', 'temperatura', 103.0000, 'ºC'),
	(287438, 122, '2014-04-01 01:29:11.000000', 'temperatura', 802.0000, 'ºC'),
	(287439, 122, '2014-04-01 01:29:12.000000', 'temperatura', 100.0000, 'ºC'),
	(287440, 122, '2014-04-01 01:29:13.000000', 'temperatura', 498.0000, 'ºC'),
	(287441, 122, '2014-04-01 01:29:14.000000', 'temperatura', 989.0000, 'ºC'),
	(287442, 122, '2014-04-01 01:29:15.000000', 'temperatura', 1052.0000, 'ºC'),
	(287443, 122, '2014-04-01 01:29:16.000000', 'temperatura', 1094.0000, 'ºC'),
	(287444, 122, '2014-04-01 01:29:17.000000', 'temperatura', 1113.0000, 'ºC'),
	(287445, 122, '2014-04-01 01:29:18.000000', 'temperatura', 1084.0000, 'ºC'),
	(287446, 122, '2014-04-01 01:29:19.000000', 'temperatura', 882.0000, 'ºC'),
	(287447, 122, '2014-04-01 01:29:20.000000', 'temperatura', 1160.0000, 'ºC'),
	(287448, 122, '2014-04-01 01:29:21.000000', 'temperatura', 752.0000, 'ºC'),
	(287449, 122, '2014-04-01 01:29:22.000000', 'temperatura', 281.0000, 'ºC'),
	(287450, 122, '2014-04-01 01:29:23.000000', 'temperatura', 350.0000, 'ºC'),
	(287451, 122, '2014-04-01 01:29:24.000000', 'temperatura', 909.0000, 'ºC'),
	(287452, 122, '2014-04-01 01:29:25.000000', 'temperatura', 1096.0000, 'ºC'),
	(287453, 122, '2014-04-01 01:29:26.000000', 'temperatura', 353.0000, 'ºC'),
	(287454, 122, '2014-04-01 01:29:27.000000', 'temperatura', 876.0000, 'ºC'),
	(287455, 122, '2014-04-01 01:29:28.000000', 'temperatura', 921.0000, 'ºC'),
	(287456, 122, '2014-04-01 01:29:29.000000', 'temperatura', 777.0000, 'ºC'),
	(287457, 122, '2014-04-01 01:29:30.000000', 'temperatura', 1122.0000, 'ºC'),
	(287458, 122, '2014-04-01 01:29:31.000000', 'temperatura', 882.0000, 'ºC'),
	(287459, 122, '2014-04-01 01:29:32.000000', 'temperatura', 1044.0000, 'ºC'),
	(287460, 122, '2014-04-01 01:29:33.000000', 'temperatura', 172.0000, 'ºC'),
	(287461, 122, '2014-04-01 01:29:34.000000', 'temperatura', 131.0000, 'ºC'),
	(287462, 122, '2014-04-01 01:29:35.000000', 'temperatura', 141.0000, 'ºC'),
	(287463, 122, '2014-04-01 01:29:36.000000', 'temperatura', 309.0000, 'ºC'),
	(287464, 122, '2014-04-01 01:29:37.000000', 'temperatura', 1123.0000, 'ºC'),
	(287465, 122, '2014-04-01 01:29:38.000000', 'temperatura', 1091.0000, 'ºC'),
	(287466, 122, '2014-04-01 01:29:39.000000', 'temperatura', 885.0000, 'ºC'),
	(287467, 122, '2014-04-01 01:29:40.000000', 'temperatura', 1155.0000, 'ºC'),
	(287468, 122, '2014-04-01 01:29:41.000000', 'temperatura', 717.0000, 'ºC'),
	(287469, 122, '2014-04-01 01:29:42.000000', 'temperatura', 123.0000, 'ºC'),
	(287470, 122, '2014-04-01 01:29:43.000000', 'temperatura', 863.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(287471, 122, '2014-04-01 01:29:44.000000', 'temperatura', 348.0000, 'ºC'),
	(287472, 122, '2014-04-01 01:29:45.000000', 'temperatura', 352.0000, 'ºC'),
	(287473, 122, '2014-04-01 01:29:46.000000', 'temperatura', 715.0000, 'ºC'),
	(287474, 122, '2014-04-01 01:29:47.000000', 'temperatura', 122.0000, 'ºC'),
	(287475, 122, '2014-04-01 01:29:48.000000', 'temperatura', 862.0000, 'ºC'),
	(287476, 122, '2014-04-01 01:29:49.000000', 'temperatura', 348.0000, 'ºC'),
	(287477, 122, '2014-04-01 01:29:50.000000', 'temperatura', 352.0000, 'ºC'),
	(287478, 122, '2014-04-01 01:29:51.000000', 'temperatura', 715.0000, 'ºC'),
	(287479, 122, '2014-04-01 01:29:52.000000', 'temperatura', 123.0000, 'ºC'),
	(287480, 122, '2014-04-01 01:29:53.000000', 'temperatura', 869.0000, 'ºC'),
	(287481, 122, '2014-04-01 01:29:54.000000', 'temperatura', 376.0000, 'ºC'),
	(287482, 122, '2014-04-01 01:29:55.000000', 'temperatura', 473.0000, 'ºC'),
	(287483, 122, '2014-04-01 01:29:56.000000', 'temperatura', 37.0000, 'ºC'),
	(287484, 122, '2014-04-01 01:29:57.000000', 'temperatura', 1169.0000, 'ºC'),
	(287485, 122, '2014-04-01 01:29:58.000000', 'temperatura', 933.0000, 'ºC'),
	(287486, 122, '2014-04-01 01:29:59.000000', 'temperatura', 1157.0000, 'ºC'),
	(287487, 122, '2014-04-01 01:30:00.000000', 'temperatura', 588.0000, 'ºC'),
	(287488, 122, '2014-04-01 01:30:01.000000', 'temperatura', 668.0000, 'ºC'),
	(287489, 122, '2014-04-01 01:30:02.000000', 'temperatura', 376.0000, 'ºC'),
	(287490, 122, '2014-04-01 01:30:03.000000', 'temperatura', 1077.0000, 'ºC'),
	(287491, 122, '2014-04-01 01:30:04.000000', 'temperatura', 656.0000, 'ºC'),
	(287492, 122, '2014-04-01 01:30:05.000000', 'temperatura', 50.0000, 'ºC'),
	(287493, 122, '2014-04-01 01:30:06.000000', 'temperatura', 682.0000, 'ºC'),
	(287494, 122, '2014-04-01 01:30:07.000000', 'temperatura', 859.0000, 'ºC'),
	(287495, 122, '2014-04-01 01:30:08.000000', 'temperatura', 1052.0000, 'ºC'),
	(287496, 122, '2014-04-01 01:30:09.000000', 'temperatura', 281.0000, 'ºC'),
	(287497, 122, '2014-04-01 01:30:10.000000', 'temperatura', 652.0000, 'ºC'),
	(287498, 122, '2014-04-01 01:30:11.000000', 'temperatura', 17.0000, 'ºC'),
	(287499, 122, '2014-04-01 01:30:12.000000', 'temperatura', 531.0000, 'ºC'),
	(287500, 122, '2014-04-01 01:30:13.000000', 'temperatura', 201.0000, 'ºC'),
	(287501, 122, '2014-04-01 01:30:14.000000', 'temperatura', 615.0000, 'ºC'),
	(287502, 122, '2014-04-01 01:30:15.000000', 'temperatura', 71.0000, 'ºC'),
	(287503, 122, '2014-04-01 01:30:16.000000', 'temperatura', 909.0000, 'ºC'),
	(287504, 122, '2014-04-01 01:30:17.000000', 'temperatura', 735.0000, 'ºC'),
	(287505, 122, '2014-04-01 01:30:18.000000', 'temperatura', 947.0000, 'ºC'),
	(287506, 122, '2014-04-01 01:30:19.000000', 'temperatura', 129.0000, 'ºC'),
	(287507, 122, '2014-04-01 01:30:20.000000', 'temperatura', 206.0000, 'ºC'),
	(287508, 122, '2014-04-01 01:30:21.000000', 'temperatura', 643.0000, 'ºC'),
	(287509, 122, '2014-04-01 01:30:22.000000', 'temperatura', 197.0000, 'ºC'),
	(287510, 122, '2014-04-01 01:30:23.000000', 'temperatura', 256.0000, 'ºC'),
	(287511, 122, '2014-04-01 01:30:24.000000', 'temperatura', 692.0000, 'ºC'),
	(287512, 122, '2014-04-01 01:30:25.000000', 'temperatura', 292.0000, 'ºC'),
	(287513, 122, '2014-04-01 01:30:26.000000', 'temperatura', 583.0000, 'ºC'),
	(287514, 122, '2014-04-01 01:30:27.000000', 'temperatura', 840.0000, 'ºC'),
	(287515, 122, '2014-04-01 01:30:28.000000', 'temperatura', 51.0000, 'ºC'),
	(287516, 122, '2014-04-01 01:30:29.000000', 'temperatura', 137.0000, 'ºC'),
	(287517, 122, '2014-04-01 01:30:30.000000', 'temperatura', 532.0000, 'ºC'),
	(287518, 122, '2014-04-01 01:30:31.000000', 'temperatura', 1049.0000, 'ºC'),
	(287519, 122, '2014-04-01 01:30:32.000000', 'temperatura', 50.0000, 'ºC'),
	(287520, 122, '2014-04-01 01:30:33.000000', 'temperatura', 704.0000, 'ºC'),
	(287521, 122, '2014-04-01 01:30:34.000000', 'temperatura', 971.0000, 'ºC'),
	(287522, 122, '2014-04-01 01:30:35.000000', 'temperatura', 344.0000, 'ºC'),
	(287523, 122, '2014-04-01 01:30:36.000000', 'temperatura', 7.0000, 'ºC'),
	(287524, 122, '2014-04-01 01:30:37.000000', 'temperatura', 204.0000, 'ºC'),
	(287525, 122, '2014-04-01 01:30:38.000000', 'temperatura', 998.0000, 'ºC'),
	(287526, 122, '2014-04-01 01:30:39.000000', 'temperatura', 780.0000, 'ºC'),
	(287527, 122, '2014-04-01 01:30:40.000000', 'temperatura', 905.0000, 'ºC'),
	(287528, 122, '2014-04-01 01:30:41.000000', 'temperatura', 986.0000, 'ºC'),
	(287529, 122, '2014-04-01 01:30:42.000000', 'temperatura', 1015.0000, 'ºC'),
	(287530, 122, '2014-04-01 01:30:43.000000', 'temperatura', 916.0000, 'ºC'),
	(287531, 122, '2014-04-01 01:30:44.000000', 'temperatura', 339.0000, 'ºC'),
	(287532, 122, '2014-04-01 01:30:45.000000', 'temperatura', 144.0000, 'ºC'),
	(287533, 122, '2014-04-01 01:30:46.000000', 'temperatura', 905.0000, 'ºC'),
	(287534, 122, '2014-04-01 01:30:47.000000', 'temperatura', 495.0000, 'ºC'),
	(287535, 122, '2014-04-01 01:30:48.000000', 'temperatura', 959.0000, 'ºC'),
	(287536, 122, '2014-04-01 01:30:49.000000', 'temperatura', 911.0000, 'ºC'),
	(287537, 122, '2014-04-01 01:30:50.000000', 'temperatura', 480.0000, 'ºC'),
	(287538, 122, '2014-04-01 01:30:51.000000', 'temperatura', 865.0000, 'ºC'),
	(287539, 122, '2014-04-01 01:30:52.000000', 'temperatura', 485.0000, 'ºC'),
	(287540, 122, '2014-04-01 01:30:53.000000', 'temperatura', 1030.0000, 'ºC'),
	(287541, 122, '2014-04-01 01:30:54.000000', 'temperatura', 94.0000, 'ºC'),
	(287542, 122, '2014-04-01 01:30:55.000000', 'temperatura', 984.0000, 'ºC'),
	(287543, 122, '2014-04-01 01:30:56.000000', 'temperatura', 1039.0000, 'ºC'),
	(287544, 122, '2014-04-01 01:30:57.000000', 'temperatura', 1042.0000, 'ºC'),
	(287545, 122, '2014-04-01 01:30:58.000000', 'temperatura', 893.0000, 'ºC'),
	(287546, 122, '2014-04-01 01:30:59.000000', 'temperatura', 140.0000, 'ºC'),
	(287547, 122, '2014-04-01 01:31:00.000000', 'temperatura', 423.0000, 'ºC'),
	(287548, 122, '2014-04-01 01:31:01.000000', 'temperatura', 496.0000, 'ºC'),
	(287549, 122, '2014-04-01 01:31:02.000000', 'temperatura', 12.0000, 'ºC'),
	(287550, 122, '2014-04-01 01:31:03.000000', 'temperatura', 970.0000, 'ºC'),
	(287551, 122, '2014-04-01 01:31:04.000000', 'temperatura', 17.0000, 'ºC'),
	(287552, 122, '2014-04-01 01:31:05.000000', 'temperatura', 775.0000, 'ºC'),
	(287553, 122, '2014-04-01 01:31:06.000000', 'temperatura', 226.0000, 'ºC'),
	(287554, 122, '2014-04-01 01:31:07.000000', 'temperatura', 2.0000, 'ºC'),
	(287555, 122, '2014-04-01 01:31:08.000000', 'temperatura', 535.0000, 'ºC'),
	(287556, 122, '2014-04-01 01:31:09.000000', 'temperatura', 271.0000, 'ºC'),
	(287557, 122, '2014-04-01 01:31:10.000000', 'temperatura', 948.0000, 'ºC'),
	(287558, 122, '2014-04-01 01:31:11.000000', 'temperatura', 327.0000, 'ºC'),
	(287559, 122, '2014-04-01 01:31:12.000000', 'temperatura', 1193.0000, 'ºC'),
	(287560, 122, '2014-04-01 01:31:13.000000', 'temperatura', 184.0000, 'ºC'),
	(287561, 122, '2014-04-01 01:31:14.000000', 'temperatura', 940.0000, 'ºC'),
	(287562, 122, '2014-04-01 01:31:15.000000', 'temperatura', 551.0000, 'ºC'),
	(287563, 122, '2014-04-01 01:31:16.000000', 'temperatura', 1136.0000, 'ºC'),
	(287564, 122, '2014-04-01 01:31:17.000000', 'temperatura', 425.0000, 'ºC'),
	(287565, 122, '2014-04-01 01:31:18.000000', 'temperatura', 1118.0000, 'ºC'),
	(287566, 122, '2014-04-01 01:31:19.000000', 'temperatura', 715.0000, 'ºC'),
	(287567, 122, '2014-04-01 01:31:20.000000', 'temperatura', 224.0000, 'ºC'),
	(287568, 122, '2014-04-01 01:31:21.000000', 'temperatura', 172.0000, 'ºC'),
	(287569, 122, '2014-04-01 01:31:22.000000', 'temperatura', 190.0000, 'ºC'),
	(287570, 122, '2014-04-01 01:31:23.000000', 'temperatura', 435.0000, 'ºC'),
	(287571, 122, '2014-04-01 01:31:24.000000', 'temperatura', 406.0000, 'ºC'),
	(287572, 122, '2014-04-01 01:31:25.000000', 'temperatura', 724.0000, 'ºC'),
	(287573, 122, '2014-04-01 01:31:26.000000', 'temperatura', 1.0000, 'ºC'),
	(287574, 122, '2014-04-01 01:31:27.000000', 'temperatura', 235.0000, 'ºC'),
	(287575, 122, '2014-04-01 01:31:28.000000', 'temperatura', 1173.0000, 'ºC'),
	(287576, 122, '2014-04-01 01:31:29.000000', 'temperatura', 362.0000, 'ºC'),
	(287577, 122, '2014-04-01 01:31:30.000000', 'temperatura', 689.0000, 'ºC'),
	(287578, 122, '2014-04-01 01:31:31.000000', 'temperatura', 1160.0000, 'ºC'),
	(287579, 122, '2014-04-01 01:31:32.000000', 'temperatura', 133.0000, 'ºC'),
	(287580, 122, '2014-04-01 01:31:33.000000', 'temperatura', 785.0000, 'ºC'),
	(287581, 122, '2014-04-01 01:31:34.000000', 'temperatura', 1128.0000, 'ºC'),
	(287582, 122, '2014-04-01 01:31:35.000000', 'temperatura', 886.0000, 'ºC'),
	(287583, 122, '2014-04-01 01:31:36.000000', 'temperatura', 1046.0000, 'ºC'),
	(287584, 122, '2014-04-01 01:31:37.000000', 'temperatura', 172.0000, 'ºC'),
	(287585, 122, '2014-04-01 01:31:38.000000', 'temperatura', 124.0000, 'ºC'),
	(287586, 122, '2014-04-01 01:31:39.000000', 'temperatura', 103.0000, 'ºC'),
	(287587, 122, '2014-04-01 01:31:40.000000', 'temperatura', 144.0000, 'ºC'),
	(287588, 122, '2014-04-01 01:31:41.000000', 'temperatura', 412.0000, 'ºC'),
	(287589, 122, '2014-04-01 01:31:42.000000', 'temperatura', 429.0000, 'ºC'),
	(287590, 122, '2014-04-01 01:31:43.000000', 'temperatura', 910.0000, 'ºC'),
	(287591, 122, '2014-04-01 01:31:44.000000', 'temperatura', 865.0000, 'ºC'),
	(287592, 122, '2014-04-01 01:31:45.000000', 'temperatura', 393.0000, 'ºC'),
	(287593, 122, '2014-04-01 01:31:46.000000', 'temperatura', 570.0000, 'ºC'),
	(287594, 122, '2014-04-01 01:31:47.000000', 'temperatura', 471.0000, 'ºC'),
	(287595, 122, '2014-04-01 01:31:48.000000', 'temperatura', 645.0000, 'ºC'),
	(287596, 122, '2014-04-01 01:31:49.000000', 'temperatura', 615.0000, 'ºC'),
	(287597, 122, '2014-04-01 01:31:50.000000', 'temperatura', 1139.0000, 'ºC'),
	(287598, 122, '2014-04-01 01:31:51.000000', 'temperatura', 250.0000, 'ºC'),
	(287599, 122, '2014-04-01 01:31:52.000000', 'temperatura', 234.0000, 'ºC'),
	(287600, 122, '2014-04-01 01:31:53.000000', 'temperatura', 419.0000, 'ºC'),
	(287601, 122, '2014-04-01 01:31:54.000000', 'temperatura', 196.0000, 'ºC'),
	(287602, 122, '2014-04-01 01:31:55.000000', 'temperatura', 923.0000, 'ºC'),
	(287603, 122, '2014-04-01 01:31:56.000000', 'temperatura', 427.0000, 'ºC'),
	(287604, 122, '2014-04-01 01:31:57.000000', 'temperatura', 567.0000, 'ºC'),
	(287605, 122, '2014-04-01 01:31:58.000000', 'temperatura', 355.0000, 'ºC'),
	(287606, 122, '2014-04-01 01:31:59.000000', 'temperatura', 73.0000, 'ºC'),
	(287607, 122, '2014-04-01 01:32:00.000000', 'temperatura', 502.0000, 'ºC'),
	(287608, 122, '2014-04-01 01:32:01.000000', 'temperatura', 1090.0000, 'ºC'),
	(287609, 122, '2014-04-01 01:32:02.000000', 'temperatura', 347.0000, 'ºC'),
	(287610, 122, '2014-04-01 01:32:03.000000', 'temperatura', 864.0000, 'ºC'),
	(287611, 122, '2014-04-01 01:32:04.000000', 'temperatura', 879.0000, 'ºC'),
	(287612, 122, '2014-04-01 01:32:05.000000', 'temperatura', 606.0000, 'ºC'),
	(287613, 122, '2014-04-01 01:32:06.000000', 'temperatura', 390.0000, 'ºC'),
	(287614, 122, '2014-04-01 01:32:07.000000', 'temperatura', 134.0000, 'ºC'),
	(287615, 122, '2014-04-01 01:32:08.000000', 'temperatura', 701.0000, 'ºC'),
	(287616, 122, '2014-04-01 01:32:09.000000', 'temperatura', 702.0000, 'ºC'),
	(287617, 122, '2014-04-01 01:32:10.000000', 'temperatura', 208.0000, 'ºC'),
	(287618, 122, '2014-04-01 01:32:11.000000', 'temperatura', 135.0000, 'ºC'),
	(287619, 122, '2014-04-01 01:32:12.000000', 'temperatura', 51.0000, 'ºC'),
	(287620, 122, '2014-04-01 01:32:13.000000', 'temperatura', 1051.0000, 'ºC'),
	(287621, 122, '2014-04-01 01:32:14.000000', 'temperatura', 301.0000, 'ºC'),
	(287622, 122, '2014-04-01 01:32:15.000000', 'temperatura', 752.0000, 'ºC'),
	(287623, 122, '2014-04-01 01:32:16.000000', 'temperatura', 458.0000, 'ºC'),
	(287624, 122, '2014-04-01 01:32:17.000000', 'temperatura', 34.0000, 'ºC'),
	(287625, 122, '2014-04-01 01:32:18.000000', 'temperatura', 1197.0000, 'ºC'),
	(287626, 122, '2014-04-01 01:32:19.000000', 'temperatura', 1084.0000, 'ºC'),
	(287627, 122, '2014-04-01 01:32:20.000000', 'temperatura', 630.0000, 'ºC'),
	(287628, 122, '2014-04-01 01:32:21.000000', 'temperatura', 1096.0000, 'ºC'),
	(287629, 122, '2014-04-01 01:32:22.000000', 'temperatura', 1193.0000, 'ºC'),
	(287630, 122, '2014-04-01 01:32:23.000000', 'temperatura', 277.0000, 'ºC'),
	(287631, 122, '2014-04-01 01:32:24.000000', 'temperatura', 206.0000, 'ºC'),
	(287632, 122, '2014-04-01 01:32:25.000000', 'temperatura', 198.0000, 'ºC'),
	(287633, 122, '2014-04-01 01:32:26.000000', 'temperatura', 372.0000, 'ºC'),
	(287634, 122, '2014-04-01 01:32:27.000000', 'temperatura', 70.0000, 'ºC'),
	(287635, 122, '2014-04-01 01:32:28.000000', 'temperatura', 431.0000, 'ºC'),
	(287636, 122, '2014-04-01 01:32:29.000000', 'temperatura', 746.0000, 'ºC'),
	(287637, 122, '2014-04-01 01:32:30.000000', 'temperatura', 37.0000, 'ºC'),
	(287638, 122, '2014-04-01 01:32:31.000000', 'temperatura', 349.0000, 'ºC'),
	(287639, 122, '2014-04-01 01:32:32.000000', 'temperatura', 433.0000, 'ºC'),
	(287640, 122, '2014-04-01 01:32:33.000000', 'temperatura', 1121.0000, 'ºC'),
	(287641, 122, '2014-04-01 01:32:34.000000', 'temperatura', 703.0000, 'ºC'),
	(287642, 122, '2014-04-01 01:32:35.000000', 'temperatura', 155.0000, 'ºC'),
	(287643, 122, '2014-04-01 01:32:36.000000', 'temperatura', 1064.0000, 'ºC'),
	(287644, 122, '2014-04-01 01:32:37.000000', 'temperatura', 58.0000, 'ºC'),
	(287645, 122, '2014-04-01 01:32:38.000000', 'temperatura', 698.0000, 'ºC'),
	(287646, 122, '2014-04-01 01:32:39.000000', 'temperatura', 915.0000, 'ºC'),
	(287647, 122, '2014-04-01 01:32:40.000000', 'temperatura', 83.0000, 'ºC'),
	(287648, 122, '2014-04-01 01:32:41.000000', 'temperatura', 69.0000, 'ºC'),
	(287649, 122, '2014-04-01 01:32:42.000000', 'temperatura', 98.0000, 'ºC'),
	(287650, 122, '2014-04-01 01:32:43.000000', 'temperatura', 281.0000, 'ºC'),
	(287651, 122, '2014-04-01 01:32:44.000000', 'temperatura', 1115.0000, 'ºC'),
	(287652, 122, '2014-04-01 01:32:45.000000', 'temperatura', 1130.0000, 'ºC'),
	(287653, 122, '2014-04-01 01:32:46.000000', 'temperatura', 1106.0000, 'ºC'),
	(287654, 122, '2014-04-01 01:32:47.000000', 'temperatura', 942.0000, 'ºC'),
	(287655, 122, '2014-04-01 01:32:48.000000', 'temperatura', 192.0000, 'ºC'),
	(287656, 122, '2014-04-01 01:32:49.000000', 'temperatura', 534.0000, 'ºC'),
	(287657, 122, '2014-04-01 01:32:50.000000', 'temperatura', 893.0000, 'ºC'),
	(287658, 122, '2014-04-01 01:32:51.000000', 'temperatura', 464.0000, 'ºC'),
	(287659, 122, '2014-04-01 01:32:52.000000', 'temperatura', 840.0000, 'ºC'),
	(287660, 122, '2014-04-01 01:32:53.000000', 'temperatura', 409.0000, 'ºC'),
	(287661, 122, '2014-04-01 01:32:54.000000', 'temperatura', 728.0000, 'ºC'),
	(287662, 122, '2014-04-01 01:32:55.000000', 'temperatura', 13.0000, 'ºC'),
	(287663, 122, '2014-04-01 01:32:56.000000', 'temperatura', 280.0000, 'ºC'),
	(287664, 122, '2014-04-01 01:32:57.000000', 'temperatura', 161.0000, 'ºC'),
	(287665, 122, '2014-04-01 01:32:58.000000', 'temperatura', 1167.0000, 'ºC'),
	(287666, 122, '2014-04-01 01:32:59.000000', 'temperatura', 551.0000, 'ºC'),
	(287667, 122, '2014-04-01 01:33:00.000000', 'temperatura', 455.0000, 'ºC'),
	(287668, 122, '2014-04-01 01:33:01.000000', 'temperatura', 623.0000, 'ºC'),
	(287669, 122, '2014-04-01 01:33:02.000000', 'temperatura', 552.0000, 'ºC'),
	(287670, 122, '2014-04-01 01:33:03.000000', 'temperatura', 889.0000, 'ºC'),
	(287671, 122, '2014-04-01 01:33:04.000000', 'temperatura', 390.0000, 'ºC'),
	(287672, 122, '2014-04-01 01:33:05.000000', 'temperatura', 483.0000, 'ºC'),
	(287673, 122, '2014-04-01 01:33:06.000000', 'temperatura', 46.0000, 'ºC'),
	(287674, 122, '2014-04-01 01:33:07.000000', 'temperatura', 1182.0000, 'ºC'),
	(287675, 122, '2014-04-01 01:33:08.000000', 'temperatura', 970.0000, 'ºC'),
	(287676, 122, '2014-04-01 01:33:09.000000', 'temperatura', 108.0000, 'ºC'),
	(287677, 122, '2014-04-01 01:33:10.000000', 'temperatura', 29.0000, 'ºC'),
	(287678, 122, '2014-04-01 01:33:11.000000', 'temperatura', 1023.0000, 'ºC'),
	(287679, 122, '2014-04-01 01:33:12.000000', 'temperatura', 226.0000, 'ºC'),
	(287680, 122, '2014-04-01 01:33:13.000000', 'temperatura', 462.0000, 'ºC'),
	(287681, 122, '2014-04-01 01:33:14.000000', 'temperatura', 432.0000, 'ºC'),
	(287682, 122, '2014-04-01 01:33:15.000000', 'temperatura', 775.0000, 'ºC'),
	(287683, 122, '2014-04-01 01:33:16.000000', 'temperatura', 180.0000, 'ºC'),
	(287684, 122, '2014-04-01 01:33:17.000000', 'temperatura', 973.0000, 'ºC'),
	(287685, 122, '2014-04-01 01:33:18.000000', 'temperatura', 729.0000, 'ºC'),
	(287686, 122, '2014-04-01 01:33:19.000000', 'temperatura', 724.0000, 'ºC'),
	(287687, 122, '2014-04-01 01:33:20.000000', 'temperatura', 235.0000, 'ºC'),
	(287688, 122, '2014-04-01 01:33:21.000000', 'temperatura', 202.0000, 'ºC'),
	(287689, 122, '2014-04-01 01:33:22.000000', 'temperatura', 305.0000, 'ºC'),
	(287690, 122, '2014-04-01 01:33:23.000000', 'temperatura', 920.0000, 'ºC'),
	(287691, 122, '2014-04-01 01:33:24.000000', 'temperatura', 85.0000, 'ºC'),
	(287692, 122, '2014-04-01 01:33:25.000000', 'temperatura', 67.0000, 'ºC'),
	(287693, 122, '2014-04-01 01:33:26.000000', 'temperatura', 78.0000, 'ºC'),
	(287694, 122, '2014-04-01 01:33:27.000000', 'temperatura', 191.0000, 'ºC'),
	(287695, 122, '2014-04-01 01:33:28.000000', 'temperatura', 722.0000, 'ºC'),
	(287696, 122, '2014-04-01 01:33:29.000000', 'temperatura', 636.0000, 'ºC'),
	(287697, 122, '2014-04-01 01:33:30.000000', 'temperatura', 1014.0000, 'ºC'),
	(287698, 122, '2014-04-01 01:33:31.000000', 'temperatura', 765.0000, 'ºC'),
	(287699, 122, '2014-04-01 01:33:32.000000', 'temperatura', 784.0000, 'ºC'),
	(287700, 122, '2014-04-01 01:33:33.000000', 'temperatura', 424.0000, 'ºC'),
	(287701, 122, '2014-04-01 01:33:34.000000', 'temperatura', 967.0000, 'ºC'),
	(287702, 122, '2014-04-01 01:33:35.000000', 'temperatura', 1166.0000, 'ºC'),
	(287703, 122, '2014-04-01 01:33:36.000000', 'temperatura', 530.0000, 'ºC'),
	(287704, 122, '2014-04-01 01:33:37.000000', 'temperatura', 350.0000, 'ºC'),
	(287705, 122, '2014-04-01 01:33:38.000000', 'temperatura', 161.0000, 'ºC'),
	(287706, 122, '2014-04-01 01:33:39.000000', 'temperatura', 957.0000, 'ºC'),
	(287707, 122, '2014-04-01 01:33:40.000000', 'temperatura', 700.0000, 'ºC'),
	(287708, 122, '2014-04-01 01:33:41.000000', 'temperatura', 630.0000, 'ºC'),
	(287709, 122, '2014-04-01 01:33:42.000000', 'temperatura', 1052.0000, 'ºC'),
	(287710, 122, '2014-04-01 01:33:43.000000', 'temperatura', 972.0000, 'ºC'),
	(287711, 122, '2014-04-01 01:33:44.000000', 'temperatura', 501.0000, 'ºC'),
	(287712, 122, '2014-04-01 01:33:45.000000', 'temperatura', 792.0000, 'ºC'),
	(287713, 122, '2014-04-01 01:33:46.000000', 'temperatura', 57.0000, 'ºC'),
	(287714, 122, '2014-04-01 01:33:47.000000', 'temperatura', 308.0000, 'ºC'),
	(287715, 122, '2014-04-01 01:33:48.000000', 'temperatura', 171.0000, 'ºC'),
	(287716, 122, '2014-04-01 01:33:49.000000', 'temperatura', 1131.0000, 'ºC'),
	(287717, 122, '2014-04-01 01:33:50.000000', 'temperatura', 344.0000, 'ºC'),
	(287718, 122, '2014-04-01 01:33:51.000000', 'temperatura', 726.0000, 'ºC'),
	(287719, 122, '2014-04-01 01:33:52.000000', 'temperatura', 201.0000, 'ºC'),
	(287720, 122, '2014-04-01 01:33:53.000000', 'temperatura', 25.0000, 'ºC'),
	(287721, 122, '2014-04-01 01:33:54.000000', 'temperatura', 724.0000, 'ºC'),
	(287722, 122, '2014-04-01 01:33:55.000000', 'temperatura', 1143.0000, 'ºC'),
	(287723, 122, '2014-04-01 01:33:56.000000', 'temperatura', 1145.0000, 'ºC'),
	(287724, 122, '2014-04-01 01:33:57.000000', 'temperatura', 1096.0000, 'ºC'),
	(287725, 122, '2014-04-01 01:33:58.000000', 'temperatura', 845.0000, 'ºC'),
	(287726, 122, '2014-04-01 01:33:59.000000', 'temperatura', 936.0000, 'ºC'),
	(287727, 122, '2014-04-01 01:34:00.000000', 'temperatura', 948.0000, 'ºC'),
	(287728, 122, '2014-04-01 01:34:01.000000', 'temperatura', 733.0000, 'ºC'),
	(287729, 122, '2014-04-01 01:34:02.000000', 'temperatura', 819.0000, 'ºC'),
	(287730, 122, '2014-04-01 01:34:03.000000', 'temperatura', 696.0000, 'ºC'),
	(287731, 122, '2014-04-01 01:34:04.000000', 'temperatura', 1024.0000, 'ºC'),
	(287732, 122, '2014-04-01 01:34:05.000000', 'temperatura', 634.0000, 'ºC'),
	(287733, 122, '2014-04-01 01:34:06.000000', 'temperatura', 97.0000, 'ºC'),
	(287734, 122, '2014-04-01 01:34:07.000000', 'temperatura', 986.0000, 'ºC'),
	(287735, 122, '2014-04-01 01:34:08.000000', 'temperatura', 1037.0000, 'ºC'),
	(287736, 122, '2014-04-01 01:34:09.000000', 'temperatura', 1029.0000, 'ºC'),
	(287737, 122, '2014-04-01 01:34:10.000000', 'temperatura', 832.0000, 'ºC'),
	(287738, 122, '2014-04-01 01:34:11.000000', 'temperatura', 1075.0000, 'ºC'),
	(287739, 122, '2014-04-01 01:34:12.000000', 'temperatura', 478.0000, 'ºC'),
	(287740, 122, '2014-04-01 01:34:13.000000', 'temperatura', 368.0000, 'ºC'),
	(287741, 122, '2014-04-01 01:34:14.000000', 'temperatura', 406.0000, 'ºC'),
	(287742, 122, '2014-04-01 01:34:15.000000', 'temperatura', 927.0000, 'ºC'),
	(287743, 122, '2014-04-01 01:34:16.000000', 'temperatura', 1018.0000, 'ºC'),
	(287744, 122, '2014-04-01 01:34:17.000000', 'temperatura', 1108.0000, 'ºC'),
	(287745, 122, '2014-04-01 01:34:18.000000', 'temperatura', 87.0000, 'ºC'),
	(287746, 122, '2014-04-01 01:34:19.000000', 'temperatura', 713.0000, 'ºC'),
	(287747, 122, '2014-04-01 01:34:20.000000', 'temperatura', 905.0000, 'ºC'),
	(287748, 122, '2014-04-01 01:34:21.000000', 'temperatura', 1186.0000, 'ºC'),
	(287749, 122, '2014-04-01 01:34:22.000000', 'temperatura', 816.0000, 'ºC'),
	(287750, 122, '2014-04-01 01:34:23.000000', 'temperatura', 522.0000, 'ºC'),
	(287751, 122, '2014-04-01 01:34:24.000000', 'temperatura', 164.0000, 'ºC'),
	(287752, 122, '2014-04-01 01:34:25.000000', 'temperatura', 453.0000, 'ºC'),
	(287753, 122, '2014-04-01 01:34:26.000000', 'temperatura', 575.0000, 'ºC'),
	(287754, 122, '2014-04-01 01:34:27.000000', 'temperatura', 314.0000, 'ºC'),
	(287755, 122, '2014-04-01 01:34:28.000000', 'temperatura', 1047.0000, 'ºC'),
	(287756, 122, '2014-04-01 01:34:29.000000', 'temperatura', 693.0000, 'ºC'),
	(287757, 122, '2014-04-01 01:34:30.000000', 'temperatura', 324.0000, 'ºC'),
	(287758, 122, '2014-04-01 01:34:31.000000', 'temperatura', 741.0000, 'ºC'),
	(287759, 122, '2014-04-01 01:34:32.000000', 'temperatura', 335.0000, 'ºC'),
	(287760, 142, '2015-01-01 00:00:00.000000', 'temperatura', 1060.0000, 'ºC'),
	(287761, 142, '2015-01-01 00:00:01.000000', 'temperatura', 943.0000, 'ºC'),
	(287762, 142, '2015-01-01 00:00:02.000000', 'temperatura', 335.0000, 'ºC'),
	(287763, 142, '2015-01-01 00:00:03.000000', 'temperatura', 47.0000, 'ºC'),
	(287764, 142, '2015-01-01 00:00:04.000000', 'temperatura', 429.0000, 'ºC'),
	(287765, 142, '2015-01-01 00:00:05.000000', 'temperatura', 806.0000, 'ºC'),
	(287766, 142, '2015-01-01 00:00:06.000000', 'temperatura', 344.0000, 'ºC'),
	(287767, 142, '2015-01-01 00:00:07.000000', 'temperatura', 503.0000, 'ºC'),
	(287768, 142, '2015-01-01 00:00:08.000000', 'temperatura', 282.0000, 'ºC'),
	(287769, 142, '2015-01-01 00:00:09.000000', 'temperatura', 1102.0000, 'ºC'),
	(287770, 142, '2015-01-01 00:00:10.000000', 'temperatura', 1065.0000, 'ºC'),
	(287771, 142, '2015-01-01 00:00:11.000000', 'temperatura', 819.0000, 'ºC'),
	(287772, 142, '2015-01-01 00:00:12.000000', 'temperatura', 902.0000, 'ºC'),
	(287773, 142, '2015-01-01 00:00:13.000000', 'temperatura', 854.0000, 'ºC'),
	(287774, 142, '2015-01-01 00:00:14.000000', 'temperatura', 365.0000, 'ºC'),
	(287775, 142, '2015-01-01 00:00:15.000000', 'temperatura', 464.0000, 'ºC'),
	(287776, 142, '2015-01-01 00:00:16.000000', 'temperatura', 26.0000, 'ºC'),
	(287777, 142, '2015-01-01 00:00:17.000000', 'temperatura', 1137.0000, 'ºC'),
	(287778, 142, '2015-01-01 00:00:18.000000', 'temperatura', 809.0000, 'ºC'),
	(287779, 142, '2015-01-01 00:00:19.000000', 'temperatura', 636.0000, 'ºC'),
	(287780, 142, '2015-01-01 00:00:20.000000', 'temperatura', 751.0000, 'ºC'),
	(287781, 142, '2015-01-01 00:00:21.000000', 'temperatura', 646.0000, 'ºC'),
	(287782, 142, '2015-01-01 00:00:22.000000', 'temperatura', 979.0000, 'ºC'),
	(287783, 142, '2015-01-01 00:00:23.000000', 'temperatura', 557.0000, 'ºC'),
	(287784, 142, '2015-01-01 00:00:24.000000', 'temperatura', 1051.0000, 'ºC'),
	(287785, 142, '2015-01-01 00:00:25.000000', 'temperatura', 1183.0000, 'ºC'),
	(287786, 142, '2015-01-01 00:00:26.000000', 'temperatura', 362.0000, 'ºC'),
	(287787, 142, '2015-01-01 00:00:27.000000', 'temperatura', 662.0000, 'ºC'),
	(287788, 142, '2015-01-01 00:00:28.000000', 'temperatura', 1023.0000, 'ºC'),
	(287789, 142, '2015-01-01 00:00:29.000000', 'temperatura', 732.0000, 'ºC'),
	(287790, 142, '2015-01-01 00:00:30.000000', 'temperatura', 592.0000, 'ºC'),
	(287791, 142, '2015-01-01 00:00:31.000000', 'temperatura', 762.0000, 'ºC'),
	(287792, 142, '2015-01-01 00:00:32.000000', 'temperatura', 838.0000, 'ºC'),
	(287793, 142, '2015-01-01 00:00:33.000000', 'temperatura', 701.0000, 'ºC'),
	(287794, 142, '2015-01-01 00:00:34.000000', 'temperatura', 993.0000, 'ºC'),
	(287795, 142, '2015-01-01 00:00:35.000000', 'temperatura', 464.0000, 'ºC'),
	(287796, 142, '2015-01-01 00:00:36.000000', 'temperatura', 540.0000, 'ºC'),
	(287797, 142, '2015-01-01 00:00:37.000000', 'temperatura', 109.0000, 'ºC'),
	(287798, 142, '2015-01-01 00:00:38.000000', 'temperatura', 125.0000, 'ºC'),
	(287799, 142, '2015-01-01 00:00:39.000000', 'temperatura', 299.0000, 'ºC'),
	(287800, 142, '2015-01-01 00:00:40.000000', 'temperatura', 1122.0000, 'ºC'),
	(287801, 142, '2015-01-01 00:00:41.000000', 'temperatura', 1111.0000, 'ºC'),
	(287802, 142, '2015-01-01 00:00:42.000000', 'temperatura', 990.0000, 'ºC'),
	(287803, 142, '2015-01-01 00:00:43.000000', 'temperatura', 419.0000, 'ºC'),
	(287804, 142, '2015-01-01 00:00:44.000000', 'temperatura', 324.0000, 'ºC'),
	(287805, 142, '2015-01-01 00:00:45.000000', 'temperatura', 362.0000, 'ºC'),
	(287806, 142, '2015-01-01 00:00:46.000000', 'temperatura', 841.0000, 'ºC'),
	(287807, 142, '2015-01-01 00:00:47.000000', 'temperatura', 719.0000, 'ºC'),
	(287808, 142, '2015-01-01 00:00:48.000000', 'temperatura', 1072.0000, 'ºC'),
	(287809, 142, '2015-01-01 00:00:49.000000', 'temperatura', 803.0000, 'ºC'),
	(287810, 142, '2015-01-01 00:00:50.000000', 'temperatura', 799.0000, 'ºC'),
	(287811, 142, '2015-01-01 00:00:51.000000', 'temperatura', 387.0000, 'ºC'),
	(287812, 142, '2015-01-01 00:00:52.000000', 'temperatura', 737.0000, 'ºC'),
	(287813, 142, '2015-01-01 00:00:53.000000', 'temperatura', 127.0000, 'ºC'),
	(287814, 142, '2015-01-01 00:00:54.000000', 'temperatura', 825.0000, 'ºC'),
	(287815, 142, '2015-01-01 00:00:55.000000', 'temperatura', 142.0000, 'ºC'),
	(287816, 142, '2015-01-01 00:00:56.000000', 'temperatura', 635.0000, 'ºC'),
	(287817, 142, '2015-01-01 00:00:57.000000', 'temperatura', 349.0000, 'ºC'),
	(287818, 142, '2015-01-01 00:00:58.000000', 'temperatura', 1041.0000, 'ºC'),
	(287819, 142, '2015-01-01 00:00:59.000000', 'temperatura', 560.0000, 'ºC'),
	(287820, 142, '2015-01-01 00:01:00.000000', 'temperatura', 879.0000, 'ºC'),
	(287821, 142, '2015-01-01 00:01:01.000000', 'temperatura', 312.0000, 'ºC'),
	(287822, 142, '2015-01-01 00:01:02.000000', 'temperatura', 125.0000, 'ºC'),
	(287823, 142, '2015-01-01 00:01:03.000000', 'temperatura', 891.0000, 'ºC'),
	(287824, 142, '2015-01-01 00:01:04.000000', 'temperatura', 477.0000, 'ºC'),
	(287825, 142, '2015-01-01 00:01:05.000000', 'temperatura', 915.0000, 'ºC'),
	(287826, 142, '2015-01-01 00:01:06.000000', 'temperatura', 745.0000, 'ºC'),
	(287827, 142, '2015-01-01 00:01:07.000000', 'temperatura', 981.0000, 'ºC'),
	(287828, 142, '2015-01-01 00:01:08.000000', 'temperatura', 271.0000, 'ºC'),
	(287829, 142, '2015-01-01 00:01:09.000000', 'temperatura', 810.0000, 'ºC'),
	(287830, 142, '2015-01-01 00:01:10.000000', 'temperatura', 840.0000, 'ºC'),
	(287831, 142, '2015-01-01 00:01:11.000000', 'temperatura', 568.0000, 'ºC'),
	(287832, 142, '2015-01-01 00:01:12.000000', 'temperatura', 323.0000, 'ºC'),
	(287833, 142, '2015-01-01 00:01:13.000000', 'temperatura', 1111.0000, 'ºC'),
	(287834, 142, '2015-01-01 00:01:14.000000', 'temperatura', 986.0000, 'ºC'),
	(287835, 142, '2015-01-01 00:01:15.000000', 'temperatura', 397.0000, 'ºC'),
	(287836, 142, '2015-01-01 00:01:16.000000', 'temperatura', 227.0000, 'ºC'),
	(287837, 142, '2015-01-01 00:01:17.000000', 'temperatura', 1146.0000, 'ºC'),
	(287838, 142, '2015-01-01 00:01:18.000000', 'temperatura', 251.0000, 'ºC'),
	(287839, 142, '2015-01-01 00:01:19.000000', 'temperatura', 214.0000, 'ºC'),
	(287840, 142, '2015-01-01 00:01:20.000000', 'temperatura', 321.0000, 'ºC'),
	(287841, 142, '2015-01-01 00:01:21.000000', 'temperatura', 961.0000, 'ºC'),
	(287842, 142, '2015-01-01 00:01:22.000000', 'temperatura', 243.0000, 'ºC'),
	(287843, 142, '2015-01-01 00:01:23.000000', 'temperatura', 732.0000, 'ºC'),
	(287844, 142, '2015-01-01 00:01:24.000000', 'temperatura', 530.0000, 'ºC'),
	(287845, 142, '2015-01-01 00:01:25.000000', 'temperatura', 457.0000, 'ºC'),
	(287846, 142, '2015-01-01 00:01:26.000000', 'temperatura', 694.0000, 'ºC'),
	(287847, 142, '2015-01-01 00:01:27.000000', 'temperatura', 900.0000, 'ºC'),
	(287848, 142, '2015-01-01 00:01:28.000000', 'temperatura', 20.0000, 'ºC'),
	(287849, 142, '2015-01-01 00:01:29.000000', 'temperatura', 1000.0000, 'ºC'),
	(287850, 142, '2015-01-01 00:01:30.000000', 'temperatura', 140.0000, 'ºC'),
	(287851, 142, '2015-01-01 00:01:31.000000', 'temperatura', 100.0000, 'ºC'),
	(287852, 142, '2015-01-01 00:01:32.000000', 'temperatura', 80.0000, 'ºC'),
	(287853, 142, '2015-01-01 00:01:33.000000', 'temperatura', 99.0000, 'ºC'),
	(287854, 142, '2015-01-01 00:01:34.000000', 'temperatura', 258.0000, 'ºC'),
	(287855, 142, '2015-01-01 00:01:35.000000', 'temperatura', 993.0000, 'ºC'),
	(287856, 142, '2015-01-01 00:01:36.000000', 'temperatura', 590.0000, 'ºC'),
	(287857, 142, '2015-01-01 00:01:37.000000', 'temperatura', 1171.0000, 'ºC'),
	(287858, 142, '2015-01-01 00:01:38.000000', 'temperatura', 487.0000, 'ºC'),
	(287859, 142, '2015-01-01 00:01:39.000000', 'temperatura', 124.0000, 'ºC'),
	(287860, 142, '2015-01-01 00:01:40.000000', 'temperatura', 359.0000, 'ºC'),
	(287861, 142, '2015-01-01 00:01:41.000000', 'temperatura', 222.0000, 'ºC'),
	(287862, 142, '2015-01-01 00:01:42.000000', 'temperatura', 36.0000, 'ºC'),
	(287863, 142, '2015-01-01 00:01:43.000000', 'temperatura', 713.0000, 'ºC'),
	(287864, 142, '2015-01-01 00:01:44.000000', 'temperatura', 1060.0000, 'ºC'),
	(287865, 142, '2015-01-01 00:01:45.000000', 'temperatura', 758.0000, 'ºC'),
	(287866, 142, '2015-01-01 00:01:46.000000', 'temperatura', 612.0000, 'ºC'),
	(287867, 142, '2015-01-01 00:01:47.000000', 'temperatura', 787.0000, 'ºC'),
	(287868, 142, '2015-01-01 00:01:48.000000', 'temperatura', 898.0000, 'ºC'),
	(287869, 142, '2015-01-01 00:01:49.000000', 'temperatura', 932.0000, 'ºC'),
	(287870, 142, '2015-01-01 00:01:50.000000', 'temperatura', 766.0000, 'ºC'),
	(287871, 142, '2015-01-01 00:01:51.000000', 'temperatura', 1036.0000, 'ºC'),
	(287872, 142, '2015-01-01 00:01:52.000000', 'temperatura', 481.0000, 'ºC'),
	(287873, 142, '2015-01-01 00:01:53.000000', 'temperatura', 499.0000, 'ºC'),
	(287874, 142, '2015-01-01 00:01:54.000000', 'temperatura', 1051.0000, 'ºC'),
	(287875, 142, '2015-01-01 00:01:55.000000', 'temperatura', 159.0000, 'ºC'),
	(287876, 142, '2015-01-01 00:01:56.000000', 'temperatura', 44.0000, 'ºC'),
	(287877, 142, '2015-01-01 00:01:57.000000', 'temperatura', 944.0000, 'ºC'),
	(287878, 142, '2015-01-01 00:01:58.000000', 'temperatura', 989.0000, 'ºC'),
	(287879, 142, '2015-01-01 00:01:59.000000', 'temperatura', 911.0000, 'ºC'),
	(287880, 142, '2015-01-01 00:02:00.000000', 'temperatura', 391.0000, 'ºC'),
	(287881, 142, '2015-01-01 00:02:01.000000', 'temperatura', 420.0000, 'ºC'),
	(287882, 142, '2015-01-01 00:02:02.000000', 'temperatura', 929.0000, 'ºC'),
	(287883, 142, '2015-01-01 00:02:03.000000', 'temperatura', 986.0000, 'ºC'),
	(287884, 142, '2015-01-01 00:02:04.000000', 'temperatura', 942.0000, 'ºC'),
	(287885, 142, '2015-01-01 00:02:05.000000', 'temperatura', 555.0000, 'ºC'),
	(287886, 142, '2015-01-01 00:02:06.000000', 'temperatura', 1147.0000, 'ºC'),
	(287887, 142, '2015-01-01 00:02:07.000000', 'temperatura', 472.0000, 'ºC'),
	(287888, 142, '2015-01-01 00:02:08.000000', 'temperatura', 120.0000, 'ºC'),
	(287889, 142, '2015-01-01 00:02:09.000000', 'temperatura', 383.0000, 'ºC'),
	(287890, 142, '2015-01-01 00:02:10.000000', 'temperatura', 357.0000, 'ºC'),
	(287891, 142, '2015-01-01 00:02:11.000000', 'temperatura', 635.0000, 'ºC'),
	(287892, 142, '2015-01-01 00:02:12.000000', 'temperatura', 904.0000, 'ºC'),
	(287893, 142, '2015-01-01 00:02:13.000000', 'temperatura', 217.0000, 'ºC'),
	(287894, 142, '2015-01-01 00:02:14.000000', 'temperatura', 772.0000, 'ºC'),
	(287895, 142, '2015-01-01 00:02:15.000000', 'temperatura', 812.0000, 'ºC'),
	(287896, 142, '2015-01-01 00:02:16.000000', 'temperatura', 543.0000, 'ºC'),
	(287897, 142, '2015-01-01 00:02:17.000000', 'temperatura', 278.0000, 'ºC'),
	(287898, 142, '2015-01-01 00:02:18.000000', 'temperatura', 961.0000, 'ºC'),
	(287899, 142, '2015-01-01 00:02:19.000000', 'temperatura', 374.0000, 'ºC'),
	(287900, 142, '2015-01-01 00:02:20.000000', 'temperatura', 186.0000, 'ºC'),
	(287901, 142, '2015-01-01 00:02:21.000000', 'temperatura', 1010.0000, 'ºC'),
	(287902, 142, '2015-01-01 00:02:22.000000', 'temperatura', 892.0000, 'ºC'),
	(287903, 142, '2015-01-01 00:02:23.000000', 'temperatura', 229.0000, 'ºC'),
	(287904, 142, '2015-01-01 00:02:24.000000', 'temperatura', 872.0000, 'ºC'),
	(287905, 142, '2015-01-01 00:02:25.000000', 'temperatura', 74.0000, 'ºC'),
	(287906, 142, '2015-01-01 00:02:26.000000', 'temperatura', 154.0000, 'ºC'),
	(287907, 142, '2015-01-01 00:02:27.000000', 'temperatura', 548.0000, 'ºC'),
	(287908, 142, '2015-01-01 00:02:28.000000', 'temperatura', 1078.0000, 'ºC'),
	(287909, 142, '2015-01-01 00:02:29.000000', 'temperatura', 149.0000, 'ºC'),
	(287910, 142, '2015-01-01 00:02:30.000000', 'temperatura', 1109.0000, 'ºC'),
	(287911, 142, '2015-01-01 00:02:31.000000', 'temperatura', 300.0000, 'ºC'),
	(287912, 142, '2015-01-01 00:02:32.000000', 'temperatura', 571.0000, 'ºC'),
	(287913, 142, '2015-01-01 00:02:33.000000', 'temperatura', 759.0000, 'ºC'),
	(287914, 142, '2015-01-01 00:02:34.000000', 'temperatura', 879.0000, 'ºC'),
	(287915, 142, '2015-01-01 00:02:35.000000', 'temperatura', 922.0000, 'ºC'),
	(287916, 142, '2015-01-01 00:02:36.000000', 'temperatura', 772.0000, 'ºC'),
	(287917, 142, '2015-01-01 00:02:37.000000', 'temperatura', 1093.0000, 'ºC'),
	(287918, 142, '2015-01-01 00:02:38.000000', 'temperatura', 752.0000, 'ºC'),
	(287919, 142, '2015-01-01 00:02:39.000000', 'temperatura', 480.0000, 'ºC'),
	(287920, 142, '2015-01-01 00:02:40.000000', 'temperatura', 145.0000, 'ºC'),
	(287921, 142, '2015-01-01 00:02:41.000000', 'temperatura', 484.0000, 'ºC'),
	(287922, 142, '2015-01-01 00:02:42.000000', 'temperatura', 786.0000, 'ºC'),
	(287923, 142, '2015-01-01 00:02:43.000000', 'temperatura', 79.0000, 'ºC'),
	(287924, 142, '2015-01-01 00:02:44.000000', 'temperatura', 438.0000, 'ºC'),
	(287925, 142, '2015-01-01 00:02:45.000000', 'temperatura', 752.0000, 'ºC'),
	(287926, 142, '2015-01-01 00:02:46.000000', 'temperatura', 47.0000, 'ºC'),
	(287927, 142, '2015-01-01 00:02:47.000000', 'temperatura', 381.0000, 'ºC'),
	(287928, 142, '2015-01-01 00:02:48.000000', 'temperatura', 564.0000, 'ºC'),
	(287929, 142, '2015-01-01 00:02:49.000000', 'temperatura', 478.0000, 'ºC'),
	(287930, 142, '2015-01-01 00:02:50.000000', 'temperatura', 699.0000, 'ºC'),
	(287931, 142, '2015-01-01 00:02:51.000000', 'temperatura', 859.0000, 'ºC'),
	(287932, 142, '2015-01-01 00:02:52.000000', 'temperatura', 999.0000, 'ºC'),
	(287933, 142, '2015-01-01 00:02:53.000000', 'temperatura', 21.0000, 'ºC'),
	(287934, 142, '2015-01-01 00:02:54.000000', 'temperatura', 707.0000, 'ºC'),
	(287935, 142, '2015-01-01 00:02:55.000000', 'temperatura', 1074.0000, 'ºC'),
	(287936, 142, '2015-01-01 00:02:56.000000', 'temperatura', 850.0000, 'ºC'),
	(287937, 142, '2015-01-01 00:02:57.000000', 'temperatura', 1028.0000, 'ºC'),
	(287938, 142, '2015-01-01 00:02:58.000000', 'temperatura', 190.0000, 'ºC'),
	(287939, 142, '2015-01-01 00:02:59.000000', 'temperatura', 267.0000, 'ºC'),
	(287940, 142, '2015-01-01 00:03:00.000000', 'temperatura', 767.0000, 'ºC'),
	(287941, 142, '2015-01-01 00:03:01.000000', 'temperatura', 633.0000, 'ºC'),
	(287942, 142, '2015-01-01 00:03:02.000000', 'temperatura', 863.0000, 'ºC'),
	(287943, 142, '2015-01-01 00:03:03.000000', 'temperatura', 19.0000, 'ºC'),
	(287944, 142, '2015-01-01 00:03:04.000000', 'temperatura', 1104.0000, 'ºC'),
	(287945, 142, '2015-01-01 00:03:05.000000', 'temperatura', 663.0000, 'ºC'),
	(287946, 142, '2015-01-01 00:03:06.000000', 'temperatura', 5.0000, 'ºC'),
	(287947, 142, '2015-01-01 00:03:07.000000', 'temperatura', 434.0000, 'ºC'),
	(287948, 142, '2015-01-01 00:03:08.000000', 'temperatura', 959.0000, 'ºC'),
	(287949, 142, '2015-01-01 00:03:09.000000', 'temperatura', 1091.0000, 'ºC'),
	(287950, 142, '2015-01-01 00:03:10.000000', 'temperatura', 180.0000, 'ºC'),
	(287951, 142, '2015-01-01 00:03:11.000000', 'temperatura', 29.0000, 'ºC'),
	(287952, 142, '2015-01-01 00:03:12.000000', 'temperatura', 803.0000, 'ºC'),
	(287953, 142, '2015-01-01 00:03:13.000000', 'temperatura', 330.0000, 'ºC'),
	(287954, 142, '2015-01-01 00:03:14.000000', 'temperatura', 443.0000, 'ºC'),
	(287955, 142, '2015-01-01 00:03:15.000000', 'temperatura', 23.0000, 'ºC'),
	(287956, 142, '2015-01-01 00:03:16.000000', 'temperatura', 1189.0000, 'ºC'),
	(287957, 142, '2015-01-01 00:03:17.000000', 'temperatura', 1076.0000, 'ºC'),
	(287958, 142, '2015-01-01 00:03:18.000000', 'temperatura', 613.0000, 'ºC'),
	(287959, 142, '2015-01-01 00:03:19.000000', 'temperatura', 1038.0000, 'ºC'),
	(287960, 142, '2015-01-01 00:03:20.000000', 'temperatura', 953.0000, 'ºC'),
	(287961, 142, '2015-01-01 00:03:21.000000', 'temperatura', 448.0000, 'ºC'),
	(287962, 142, '2015-01-01 00:03:22.000000', 'temperatura', 584.0000, 'ºC'),
	(287963, 142, '2015-01-01 00:03:23.000000', 'temperatura', 377.0000, 'ºC'),
	(287964, 142, '2015-01-01 00:03:24.000000', 'temperatura', 131.0000, 'ºC'),
	(287965, 142, '2015-01-01 00:03:25.000000', 'temperatura', 726.0000, 'ºC'),
	(287966, 142, '2015-01-01 00:03:26.000000', 'temperatura', 837.0000, 'ºC'),
	(287967, 142, '2015-01-01 00:03:27.000000', 'temperatura', 806.0000, 'ºC'),
	(287968, 142, '2015-01-01 00:03:28.000000', 'temperatura', 319.0000, 'ºC'),
	(287969, 142, '2015-01-01 00:03:29.000000', 'temperatura', 379.0000, 'ºC'),
	(287970, 142, '2015-01-01 00:03:30.000000', 'temperatura', 938.0000, 'ºC'),
	(287971, 142, '2015-01-01 00:03:31.000000', 'temperatura', 1152.0000, 'ºC'),
	(287972, 142, '2015-01-01 00:03:32.000000', 'temperatura', 547.0000, 'ºC'),
	(287973, 142, '2015-01-01 00:03:33.000000', 'temperatura', 480.0000, 'ºC'),
	(287974, 142, '2015-01-01 00:03:34.000000', 'temperatura', 761.0000, 'ºC'),
	(287975, 142, '2015-01-01 00:03:35.000000', 'temperatura', 1163.0000, 'ºC'),
	(287976, 142, '2015-01-01 00:03:36.000000', 'temperatura', 1132.0000, 'ºC'),
	(287977, 142, '2015-01-01 00:03:37.000000', 'temperatura', 975.0000, 'ºC'),
	(287978, 142, '2015-01-01 00:03:38.000000', 'temperatura', 276.0000, 'ºC'),
	(287979, 142, '2015-01-01 00:03:39.000000', 'temperatura', 858.0000, 'ºC'),
	(287980, 142, '2015-01-01 00:03:40.000000', 'temperatura', 1060.0000, 'ºC'),
	(287981, 142, '2015-01-01 00:03:41.000000', 'temperatura', 328.0000, 'ºC'),
	(287982, 142, '2015-01-01 00:03:42.000000', 'temperatura', 861.0000, 'ºC'),
	(287983, 142, '2015-01-01 00:03:43.000000', 'temperatura', 919.0000, 'ºC'),
	(287984, 142, '2015-01-01 00:03:44.000000', 'temperatura', 815.0000, 'ºC'),
	(287985, 142, '2015-01-01 00:03:45.000000', 'temperatura', 118.0000, 'ºC'),
	(287986, 142, '2015-01-01 00:03:46.000000', 'temperatura', 545.0000, 'ºC'),
	(287987, 142, '2015-01-01 00:03:47.000000', 'temperatura', 1172.0000, 'ºC'),
	(287988, 142, '2015-01-01 00:03:48.000000', 'temperatura', 624.0000, 'ºC'),
	(287989, 142, '2015-01-01 00:03:49.000000', 'temperatura', 804.0000, 'ºC'),
	(287990, 142, '2015-01-01 00:03:50.000000', 'temperatura', 948.0000, 'ºC'),
	(287991, 142, '2015-01-01 00:03:51.000000', 'temperatura', 1129.0000, 'ºC'),
	(287992, 142, '2015-01-01 00:03:52.000000', 'temperatura', 400.0000, 'ºC'),
	(287993, 142, '2015-01-01 00:03:53.000000', 'temperatura', 1017.0000, 'ºC'),
	(287994, 142, '2015-01-01 00:03:54.000000', 'temperatura', 283.0000, 'ºC'),
	(287995, 142, '2015-01-01 00:03:55.000000', 'temperatura', 766.0000, 'ºC'),
	(287996, 142, '2015-01-01 00:03:56.000000', 'temperatura', 580.0000, 'ºC'),
	(287997, 142, '2015-01-01 00:03:57.000000', 'temperatura', 605.0000, 'ºC'),
	(287998, 142, '2015-01-01 00:03:58.000000', 'temperatura', 84.0000, 'ºC'),
	(287999, 142, '2015-01-01 00:03:59.000000', 'temperatura', 1004.0000, 'ºC'),
	(288000, 142, '2015-01-01 00:04:00.000000', 'temperatura', 1169.0000, 'ºC'),
	(288001, 142, '2015-01-01 00:04:01.000000', 'temperatura', 432.0000, 'ºC'),
	(288002, 142, '2015-01-01 00:04:02.000000', 'temperatura', 1056.0000, 'ºC'),
	(288003, 142, '2015-01-01 00:04:03.000000', 'temperatura', 384.0000, 'ºC'),
	(288004, 142, '2015-01-01 00:04:04.000000', 'temperatura', 1154.0000, 'ºC'),
	(288005, 142, '2015-01-01 00:04:05.000000', 'temperatura', 1019.0000, 'ºC'),
	(288006, 142, '2015-01-01 00:04:06.000000', 'temperatura', 433.0000, 'ºC'),
	(288007, 142, '2015-01-01 00:04:07.000000', 'temperatura', 309.0000, 'ºC'),
	(288008, 142, '2015-01-01 00:04:08.000000', 'temperatura', 246.0000, 'ºC'),
	(288009, 142, '2015-01-01 00:04:09.000000', 'temperatura', 305.0000, 'ºC'),
	(288010, 142, '2015-01-01 00:04:10.000000', 'temperatura', 788.0000, 'ºC'),
	(288011, 142, '2015-01-01 00:04:11.000000', 'temperatura', 623.0000, 'ºC'),
	(288012, 142, '2015-01-01 00:04:12.000000', 'temperatura', 754.0000, 'ºC'),
	(288013, 142, '2015-01-01 00:04:13.000000', 'temperatura', 702.0000, 'ºC'),
	(288014, 142, '2015-01-01 00:04:14.000000', 'temperatura', 46.0000, 'ºC'),
	(288015, 142, '2015-01-01 00:04:15.000000', 'temperatura', 525.0000, 'ºC'),
	(288016, 142, '2015-01-01 00:04:16.000000', 'temperatura', 89.0000, 'ºC'),
	(288017, 142, '2015-01-01 00:04:17.000000', 'temperatura', 69.0000, 'ºC'),
	(288018, 142, '2015-01-01 00:04:18.000000', 'temperatura', 78.0000, 'ºC'),
	(288019, 142, '2015-01-01 00:04:19.000000', 'temperatura', 183.0000, 'ºC'),
	(288020, 142, '2015-01-01 00:04:20.000000', 'temperatura', 681.0000, 'ºC'),
	(288021, 142, '2015-01-01 00:04:21.000000', 'temperatura', 456.0000, 'ºC'),
	(288022, 142, '2015-01-01 00:04:22.000000', 'temperatura', 239.0000, 'ºC'),
	(288023, 142, '2015-01-01 00:04:23.000000', 'temperatura', 1027.0000, 'ºC'),
	(288024, 142, '2015-01-01 00:04:24.000000', 'temperatura', 818.0000, 'ºC'),
	(288025, 142, '2015-01-01 00:04:25.000000', 'temperatura', 1008.0000, 'ºC'),
	(288026, 142, '2015-01-01 00:04:26.000000', 'temperatura', 188.0000, 'ºC'),
	(288027, 142, '2015-01-01 00:04:27.000000', 'temperatura', 317.0000, 'ºC'),
	(288028, 142, '2015-01-01 00:04:28.000000', 'temperatura', 1023.0000, 'ºC'),
	(288029, 142, '2015-01-01 00:04:29.000000', 'temperatura', 563.0000, 'ºC'),
	(288030, 142, '2015-01-01 00:04:30.000000', 'temperatura', 948.0000, 'ºC'),
	(288031, 142, '2015-01-01 00:04:31.000000', 'temperatura', 649.0000, 'ºC'),
	(288032, 142, '2015-01-01 00:04:32.000000', 'temperatura', 404.0000, 'ºC'),
	(288033, 142, '2015-01-01 00:04:33.000000', 'temperatura', 72.0000, 'ºC'),
	(288034, 142, '2015-01-01 00:04:34.000000', 'temperatura', 347.0000, 'ºC'),
	(288035, 142, '2015-01-01 00:04:35.000000', 'temperatura', 322.0000, 'ºC'),
	(288036, 142, '2015-01-01 00:04:36.000000', 'temperatura', 570.0000, 'ºC'),
	(288037, 142, '2015-01-01 00:04:37.000000', 'temperatura', 684.0000, 'ºC'),
	(288038, 142, '2015-01-01 00:04:38.000000', 'temperatura', 508.0000, 'ºC'),
	(288039, 142, '2015-01-01 00:04:39.000000', 'temperatura', 490.0000, 'ºC'),
	(288040, 142, '2015-01-01 00:04:40.000000', 'temperatura', 927.0000, 'ºC'),
	(288041, 142, '2015-01-01 00:04:41.000000', 'temperatura', 767.0000, 'ºC'),
	(288042, 142, '2015-01-01 00:04:42.000000', 'temperatura', 1054.0000, 'ºC'),
	(288043, 142, '2015-01-01 00:04:43.000000', 'temperatura', 571.0000, 'ºC'),
	(288044, 142, '2015-01-01 00:04:44.000000', 'temperatura', 891.0000, 'ºC'),
	(288045, 142, '2015-01-01 00:04:45.000000', 'temperatura', 343.0000, 'ºC'),
	(288046, 142, '2015-01-01 00:04:46.000000', 'temperatura', 243.0000, 'ºC'),
	(288047, 142, '2015-01-01 00:04:47.000000', 'temperatura', 186.0000, 'ºC'),
	(288048, 142, '2015-01-01 00:04:48.000000', 'temperatura', 200.0000, 'ºC'),
	(288049, 142, '2015-01-01 00:04:49.000000', 'temperatura', 445.0000, 'ºC'),
	(288050, 142, '2015-01-01 00:04:50.000000', 'temperatura', 423.0000, 'ºC'),
	(288051, 142, '2015-01-01 00:04:51.000000', 'temperatura', 781.0000, 'ºC'),
	(288052, 142, '2015-01-01 00:04:52.000000', 'temperatura', 237.0000, 'ºC'),
	(288053, 142, '2015-01-01 00:04:53.000000', 'temperatura', 44.0000, 'ºC'),
	(288054, 142, '2015-01-01 00:04:54.000000', 'temperatura', 707.0000, 'ºC'),
	(288055, 142, '2015-01-01 00:04:55.000000', 'temperatura', 1003.0000, 'ºC'),
	(288056, 142, '2015-01-01 00:04:56.000000', 'temperatura', 497.0000, 'ºC'),
	(288057, 142, '2015-01-01 00:04:57.000000', 'temperatura', 674.0000, 'ºC'),
	(288058, 142, '2015-01-01 00:04:58.000000', 'temperatura', 682.0000, 'ºC'),
	(288059, 142, '2015-01-01 00:04:59.000000', 'temperatura', 188.0000, 'ºC'),
	(288060, 142, '2015-01-01 00:05:00.000000', 'temperatura', 93.0000, 'ºC'),
	(288061, 142, '2015-01-01 00:05:01.000000', 'temperatura', 1104.0000, 'ºC'),
	(288062, 142, '2015-01-01 00:05:02.000000', 'temperatura', 440.0000, 'ºC'),
	(288063, 142, '2015-01-01 00:05:03.000000', 'temperatura', 89.0000, 'ºC'),
	(288064, 142, '2015-01-01 00:05:04.000000', 'temperatura', 326.0000, 'ºC'),
	(288065, 142, '2015-01-01 00:05:05.000000', 'temperatura', 165.0000, 'ºC'),
	(288066, 142, '2015-01-01 00:05:06.000000', 'temperatura', 1045.0000, 'ºC'),
	(288067, 142, '2015-01-01 00:05:07.000000', 'temperatura', 1129.0000, 'ºC'),
	(288068, 142, '2015-01-01 00:05:08.000000', 'temperatura', 114.0000, 'ºC'),
	(288069, 142, '2015-01-01 00:05:09.000000', 'temperatura', 783.0000, 'ºC'),
	(288070, 142, '2015-01-01 00:05:10.000000', 'temperatura', 1172.0000, 'ºC'),
	(288071, 142, '2015-01-01 00:05:11.000000', 'temperatura', 1113.0000, 'ºC'),
	(288072, 142, '2015-01-01 00:05:12.000000', 'temperatura', 850.0000, 'ºC'),
	(288073, 142, '2015-01-01 00:05:13.000000', 'temperatura', 912.0000, 'ºC'),
	(288074, 142, '2015-01-01 00:05:14.000000', 'temperatura', 811.0000, 'ºC'),
	(288075, 142, '2015-01-01 00:05:15.000000', 'temperatura', 118.0000, 'ºC'),
	(288076, 142, '2015-01-01 00:05:16.000000', 'temperatura', 559.0000, 'ºC'),
	(288077, 142, '2015-01-01 00:05:17.000000', 'temperatura', 43.0000, 'ºC'),
	(288078, 142, '2015-01-01 00:05:18.000000', 'temperatura', 935.0000, 'ºC'),
	(288079, 142, '2015-01-01 00:05:19.000000', 'temperatura', 948.0000, 'ºC'),
	(288080, 142, '2015-01-01 00:05:20.000000', 'temperatura', 737.0000, 'ºC'),
	(288081, 142, '2015-01-01 00:05:21.000000', 'temperatura', 839.0000, 'ºC'),
	(288082, 142, '2015-01-01 00:05:22.000000', 'temperatura', 787.0000, 'ºC'),
	(288083, 142, '2015-01-01 00:05:23.000000', 'temperatura', 218.0000, 'ºC'),
	(288084, 142, '2015-01-01 00:05:24.000000', 'temperatura', 1128.0000, 'ºC'),
	(288085, 142, '2015-01-01 00:05:25.000000', 'temperatura', 186.0000, 'ºC'),
	(288086, 142, '2015-01-01 00:05:26.000000', 'temperatura', 1148.0000, 'ºC'),
	(288087, 142, '2015-01-01 00:05:27.000000', 'temperatura', 383.0000, 'ºC'),
	(288088, 142, '2015-01-01 00:05:28.000000', 'temperatura', 871.0000, 'ºC'),
	(288089, 142, '2015-01-01 00:05:29.000000', 'temperatura', 806.0000, 'ºC'),
	(288090, 142, '2015-01-01 00:05:30.000000', 'temperatura', 216.0000, 'ºC'),
	(288091, 142, '2015-01-01 00:05:31.000000', 'temperatura', 1066.0000, 'ºC'),
	(288092, 142, '2015-01-01 00:05:32.000000', 'temperatura', 1079.0000, 'ºC'),
	(288093, 142, '2015-01-01 00:05:33.000000', 'temperatura', 998.0000, 'ºC'),
	(288094, 142, '2015-01-01 00:05:34.000000', 'temperatura', 555.0000, 'ºC'),
	(288095, 142, '2015-01-01 00:05:35.000000', 'temperatura', 981.0000, 'ºC'),
	(288096, 142, '2015-01-01 00:05:36.000000', 'temperatura', 843.0000, 'ºC'),
	(288097, 142, '2015-01-01 00:05:37.000000', 'temperatura', 69.0000, 'ºC'),
	(288098, 142, '2015-01-01 00:05:38.000000', 'temperatura', 216.0000, 'ºC'),
	(288099, 142, '2015-01-01 00:05:39.000000', 'temperatura', 875.0000, 'ºC'),
	(288100, 142, '2015-01-01 00:05:40.000000', 'temperatura', 126.0000, 'ºC'),
	(288101, 142, '2015-01-01 00:05:41.000000', 'temperatura', 407.0000, 'ºC'),
	(288102, 142, '2015-01-01 00:05:42.000000', 'temperatura', 456.0000, 'ºC'),
	(288103, 142, '2015-01-01 00:05:43.000000', 'temperatura', 1059.0000, 'ºC'),
	(288104, 142, '2015-01-01 00:05:44.000000', 'temperatura', 328.0000, 'ºC'),
	(288105, 142, '2015-01-01 00:05:45.000000', 'temperatura', 866.0000, 'ºC'),
	(288106, 142, '2015-01-01 00:05:46.000000', 'temperatura', 944.0000, 'ºC'),
	(288107, 142, '2015-01-01 00:05:47.000000', 'temperatura', 924.0000, 'ºC'),
	(288108, 142, '2015-01-01 00:05:48.000000', 'temperatura', 589.0000, 'ºC'),
	(288109, 142, '2015-01-01 00:05:49.000000', 'temperatura', 173.0000, 'ºC'),
	(288110, 142, '2015-01-01 00:05:50.000000', 'temperatura', 298.0000, 'ºC'),
	(288111, 142, '2015-01-01 00:05:51.000000', 'temperatura', 972.0000, 'ºC'),
	(288112, 142, '2015-01-01 00:05:52.000000', 'temperatura', 365.0000, 'ºC'),
	(288113, 142, '2015-01-01 00:05:53.000000', 'temperatura', 111.0000, 'ºC'),
	(288114, 142, '2015-01-01 00:05:54.000000', 'temperatura', 662.0000, 'ºC'),
	(288115, 142, '2015-01-01 00:05:55.000000', 'temperatura', 575.0000, 'ºC'),
	(288116, 142, '2015-01-01 00:05:56.000000', 'temperatura', 891.0000, 'ºC'),
	(288117, 142, '2015-01-01 00:05:57.000000', 'temperatura', 331.0000, 'ºC'),
	(288118, 142, '2015-01-01 00:05:58.000000', 'temperatura', 184.0000, 'ºC'),
	(288119, 142, '2015-01-01 00:05:59.000000', 'temperatura', 1124.0000, 'ºC'),
	(288120, 142, '2015-01-01 00:06:00.000000', 'temperatura', 269.0000, 'ºC'),
	(288121, 142, '2015-01-01 00:06:01.000000', 'temperatura', 376.0000, 'ºC'),
	(288122, 142, '2015-01-01 00:06:02.000000', 'temperatura', 1072.0000, 'ºC'),
	(288123, 142, '2015-01-01 00:06:03.000000', 'temperatura', 634.0000, 'ºC'),
	(288124, 142, '2015-01-01 00:06:04.000000', 'temperatura', 1152.0000, 'ºC'),
	(288125, 142, '2015-01-01 00:06:05.000000', 'temperatura', 258.0000, 'ºC'),
	(288126, 142, '2015-01-01 00:06:06.000000', 'temperatura', 237.0000, 'ºC'),
	(288127, 142, '2015-01-01 00:06:07.000000', 'temperatura', 412.0000, 'ºC'),
	(288128, 142, '2015-01-01 00:06:08.000000', 'temperatura', 150.0000, 'ºC'),
	(288129, 142, '2015-01-01 00:06:09.000000', 'temperatura', 711.0000, 'ºC'),
	(288130, 142, '2015-01-01 00:06:10.000000', 'temperatura', 709.0000, 'ºC'),
	(288131, 142, '2015-01-01 00:06:11.000000', 'temperatura', 212.0000, 'ºC'),
	(288132, 142, '2015-01-01 00:06:12.000000', 'temperatura', 135.0000, 'ºC'),
	(288133, 142, '2015-01-01 00:06:13.000000', 'temperatura', 38.0000, 'ºC'),
	(288134, 142, '2015-01-01 00:06:14.000000', 'temperatura', 985.0000, 'ºC'),
	(288135, 142, '2015-01-01 00:06:15.000000', 'temperatura', 12.0000, 'ºC'),
	(288136, 142, '2015-01-01 00:06:16.000000', 'temperatura', 705.0000, 'ºC'),
	(288137, 142, '2015-01-01 00:06:17.000000', 'temperatura', 1090.0000, 'ºC'),
	(288138, 142, '2015-01-01 00:06:18.000000', 'temperatura', 936.0000, 'ºC'),
	(288139, 142, '2015-01-01 00:06:19.000000', 'temperatura', 211.0000, 'ºC'),
	(288140, 142, '2015-01-01 00:06:20.000000', 'temperatura', 645.0000, 'ºC'),
	(288141, 142, '2015-01-01 00:06:21.000000', 'temperatura', 193.0000, 'ºC'),
	(288142, 142, '2015-01-01 00:06:22.000000', 'temperatura', 229.0000, 'ºC'),
	(288143, 142, '2015-01-01 00:06:23.000000', 'temperatura', 568.0000, 'ºC'),
	(288144, 142, '2015-01-01 00:06:24.000000', 'temperatura', 953.0000, 'ºC'),
	(288145, 142, '2015-01-01 00:06:25.000000', 'temperatura', 663.0000, 'ºC'),
	(288146, 142, '2015-01-01 00:06:26.000000', 'temperatura', 457.0000, 'ºC'),
	(288147, 142, '2015-01-01 00:06:27.000000', 'temperatura', 297.0000, 'ºC'),
	(288148, 142, '2015-01-01 00:06:28.000000', 'temperatura', 112.0000, 'ºC'),
	(288149, 142, '2015-01-01 00:06:29.000000', 'temperatura', 872.0000, 'ºC'),
	(288150, 142, '2015-01-01 00:06:30.000000', 'temperatura', 422.0000, 'ºC'),
	(288151, 142, '2015-01-01 00:06:31.000000', 'temperatura', 697.0000, 'ºC'),
	(288152, 142, '2015-01-01 00:06:32.000000', 'temperatura', 1019.0000, 'ºC'),
	(288153, 142, '2015-01-01 00:06:33.000000', 'temperatura', 602.0000, 'ºC'),
	(288154, 142, '2015-01-01 00:06:34.000000', 'temperatura', 1155.0000, 'ºC'),
	(288155, 142, '2015-01-01 00:06:35.000000', 'temperatura', 371.0000, 'ºC'),
	(288156, 142, '2015-01-01 00:06:36.000000', 'temperatura', 790.0000, 'ºC'),
	(288157, 142, '2015-01-01 00:06:37.000000', 'temperatura', 436.0000, 'ºC'),
	(288158, 142, '2015-01-01 00:06:38.000000', 'temperatura', 1013.0000, 'ºC'),
	(288159, 142, '2015-01-01 00:06:39.000000', 'temperatura', 157.0000, 'ºC'),
	(288160, 142, '2015-01-01 00:06:40.000000', 'temperatura', 145.0000, 'ºC'),
	(288161, 142, '2015-01-01 00:06:41.000000', 'temperatura', 255.0000, 'ºC'),
	(288162, 142, '2015-01-01 00:06:42.000000', 'temperatura', 841.0000, 'ºC'),
	(288163, 142, '2015-01-01 00:06:43.000000', 'temperatura', 1041.0000, 'ºC'),
	(288164, 142, '2015-01-01 00:06:44.000000', 'temperatura', 281.0000, 'ºC'),
	(288165, 142, '2015-01-01 00:06:45.000000', 'temperatura', 682.0000, 'ºC'),
	(288166, 142, '2015-01-01 00:06:46.000000', 'temperatura', 170.0000, 'ºC'),
	(288167, 142, '2015-01-01 00:06:47.000000', 'temperatura', 5.0000, 'ºC'),
	(288168, 142, '2015-01-01 00:06:48.000000', 'temperatura', 713.0000, 'ºC'),
	(288169, 142, '2015-01-01 00:06:49.000000', 'temperatura', 1153.0000, 'ºC'),
	(288170, 142, '2015-01-01 00:06:50.000000', 'temperatura', 27.0000, 'ºC'),
	(288171, 142, '2015-01-01 00:06:51.000000', 'temperatura', 276.0000, 'ºC'),
	(288172, 142, '2015-01-01 00:06:52.000000', 'temperatura', 99.0000, 'ºC'),
	(288173, 142, '2015-01-01 00:06:53.000000', 'temperatura', 866.0000, 'ºC'),
	(288174, 142, '2015-01-01 00:06:54.000000', 'temperatura', 436.0000, 'ºC'),
	(288175, 142, '2015-01-01 00:06:55.000000', 'temperatura', 783.0000, 'ºC'),
	(288176, 142, '2015-01-01 00:06:56.000000', 'temperatura', 206.0000, 'ºC'),
	(288177, 142, '2015-01-01 00:06:57.000000', 'temperatura', 1080.0000, 'ºC'),
	(288178, 142, '2015-01-01 00:06:58.000000', 'temperatura', 1184.0000, 'ºC'),
	(288179, 142, '2015-01-01 00:06:59.000000', 'temperatura', 281.0000, 'ºC'),
	(288180, 142, '2015-01-01 00:07:00.000000', 'temperatura', 253.0000, 'ºC'),
	(288181, 142, '2015-01-01 00:07:01.000000', 'temperatura', 422.0000, 'ºC'),
	(288182, 142, '2015-01-01 00:07:02.000000', 'temperatura', 153.0000, 'ºC'),
	(288183, 142, '2015-01-01 00:07:03.000000', 'temperatura', 699.0000, 'ºC'),
	(288184, 142, '2015-01-01 00:07:04.000000', 'temperatura', 638.0000, 'ºC'),
	(288185, 142, '2015-01-01 00:07:05.000000', 'temperatura', 1090.0000, 'ºC'),
	(288186, 142, '2015-01-01 00:07:06.000000', 'temperatura', 1139.0000, 'ºC'),
	(288187, 142, '2015-01-01 00:07:07.000000', 'temperatura', 24.0000, 'ºC'),
	(288188, 142, '2015-01-01 00:07:08.000000', 'temperatura', 305.0000, 'ºC'),
	(288189, 142, '2015-01-01 00:07:09.000000', 'temperatura', 251.0000, 'ºC'),
	(288190, 142, '2015-01-01 00:07:10.000000', 'temperatura', 344.0000, 'ºC'),
	(288191, 142, '2015-01-01 00:07:11.000000', 'temperatura', 966.0000, 'ºC'),
	(288192, 142, '2015-01-01 00:07:12.000000', 'temperatura', 198.0000, 'ºC'),
	(288193, 142, '2015-01-01 00:07:13.000000', 'temperatura', 491.0000, 'ºC'),
	(288194, 142, '2015-01-01 00:07:14.000000', 'temperatura', 664.0000, 'ºC'),
	(288195, 142, '2015-01-01 00:07:15.000000', 'temperatura', 647.0000, 'ºC'),
	(288196, 142, '2015-01-01 00:07:16.000000', 'temperatura', 45.0000, 'ºC'),
	(288197, 142, '2015-01-01 00:07:17.000000', 'temperatura', 684.0000, 'ºC'),
	(288198, 142, '2015-01-01 00:07:18.000000', 'temperatura', 885.0000, 'ºC'),
	(288199, 142, '2015-01-01 00:07:19.000000', 'temperatura', 1173.0000, 'ºC'),
	(288200, 142, '2015-01-01 00:07:20.000000', 'temperatura', 813.0000, 'ºC'),
	(288201, 142, '2015-01-01 00:07:21.000000', 'temperatura', 544.0000, 'ºC'),
	(288202, 142, '2015-01-01 00:07:22.000000', 'temperatura', 283.0000, 'ºC'),
	(288203, 142, '2015-01-01 00:07:23.000000', 'temperatura', 984.0000, 'ºC'),
	(288204, 142, '2015-01-01 00:07:24.000000', 'temperatura', 472.0000, 'ºC'),
	(288205, 142, '2015-01-01 00:07:25.000000', 'temperatura', 609.0000, 'ºC'),
	(288206, 142, '2015-01-01 00:07:26.000000', 'temperatura', 428.0000, 'ºC'),
	(288207, 142, '2015-01-01 00:07:27.000000', 'temperatura', 316.0000, 'ºC'),
	(288208, 142, '2015-01-01 00:07:28.000000', 'temperatura', 294.0000, 'ºC'),
	(288209, 142, '2015-01-01 00:07:29.000000', 'temperatura', 521.0000, 'ºC'),
	(288210, 142, '2015-01-01 00:07:30.000000', 'temperatura', 526.0000, 'ºC'),
	(288211, 142, '2015-01-01 00:07:31.000000', 'temperatura', 1067.0000, 'ºC'),
	(288212, 142, '2015-01-01 00:07:32.000000', 'temperatura', 159.0000, 'ºC'),
	(288213, 142, '2015-01-01 00:07:33.000000', 'temperatura', 1194.0000, 'ºC'),
	(288214, 142, '2015-01-01 00:07:34.000000', 'temperatura', 693.0000, 'ºC'),
	(288215, 142, '2015-01-01 00:07:35.000000', 'temperatura', 1084.0000, 'ºC'),
	(288216, 142, '2015-01-01 00:07:36.000000', 'temperatura', 942.0000, 'ºC'),
	(288217, 142, '2015-01-01 00:07:37.000000', 'temperatura', 257.0000, 'ºC'),
	(288218, 142, '2015-01-01 00:07:38.000000', 'temperatura', 860.0000, 'ºC'),
	(288219, 142, '2015-01-01 00:07:39.000000', 'temperatura', 1129.0000, 'ºC'),
	(288220, 142, '2015-01-01 00:07:40.000000', 'temperatura', 664.0000, 'ºC'),
	(288221, 142, '2015-01-01 00:07:41.000000', 'temperatura', 1137.0000, 'ºC'),
	(288222, 142, '2015-01-01 00:07:42.000000', 'temperatura', 92.0000, 'ºC'),
	(288223, 142, '2015-01-01 00:07:43.000000', 'temperatura', 649.0000, 'ºC'),
	(288224, 142, '2015-01-01 00:07:44.000000', 'temperatura', 569.0000, 'ºC'),
	(288225, 142, '2015-01-01 00:07:45.000000', 'temperatura', 901.0000, 'ºC'),
	(288226, 142, '2015-01-01 00:07:46.000000', 'temperatura', 397.0000, 'ºC'),
	(288227, 142, '2015-01-01 00:07:47.000000', 'temperatura', 481.0000, 'ºC'),
	(288228, 142, '2015-01-01 00:07:48.000000', 'temperatura', 17.0000, 'ºC'),
	(288229, 142, '2015-01-01 00:07:49.000000', 'temperatura', 1043.0000, 'ºC'),
	(288230, 142, '2015-01-01 00:07:50.000000', 'temperatura', 362.0000, 'ºC'),
	(288231, 142, '2015-01-01 00:07:51.000000', 'temperatura', 1081.0000, 'ºC'),
	(288232, 142, '2015-01-01 00:07:52.000000', 'temperatura', 721.0000, 'ºC'),
	(288233, 142, '2015-01-01 00:07:53.000000', 'temperatura', 360.0000, 'ºC'),
	(288234, 142, '2015-01-01 00:07:54.000000', 'temperatura', 841.0000, 'ºC'),
	(288235, 142, '2015-01-01 00:07:55.000000', 'temperatura', 725.0000, 'ºC'),
	(288236, 142, '2015-01-01 00:07:56.000000', 'temperatura', 1100.0000, 'ºC'),
	(288237, 142, '2015-01-01 00:07:57.000000', 'temperatura', 927.0000, 'ºC'),
	(288238, 142, '2015-01-01 00:07:58.000000', 'temperatura', 136.0000, 'ºC'),
	(288239, 142, '2015-01-01 00:07:59.000000', 'temperatura', 301.0000, 'ºC'),
	(288240, 142, '2015-01-01 00:08:00.000000', 'temperatura', 1097.0000, 'ºC'),
	(288241, 142, '2015-01-01 00:08:01.000000', 'temperatura', 981.0000, 'ºC'),
	(288242, 142, '2015-01-01 00:08:02.000000', 'temperatura', 414.0000, 'ºC'),
	(288243, 142, '2015-01-01 00:08:03.000000', 'temperatura', 328.0000, 'ºC'),
	(288244, 142, '2015-01-01 00:08:04.000000', 'temperatura', 397.0000, 'ºC'),
	(288245, 142, '2015-01-01 00:08:05.000000', 'temperatura', 1004.0000, 'ºC'),
	(288246, 142, '2015-01-01 00:08:06.000000', 'temperatura', 228.0000, 'ºC'),
	(288247, 142, '2015-01-01 00:08:07.000000', 'temperatura', 530.0000, 'ºC'),
	(288248, 142, '2015-01-01 00:08:08.000000', 'temperatura', 765.0000, 'ºC'),
	(288249, 142, '2015-01-01 00:08:09.000000', 'temperatura', 1035.0000, 'ºC'),
	(288250, 142, '2015-01-01 00:08:10.000000', 'temperatura', 481.0000, 'ºC'),
	(288251, 142, '2015-01-01 00:08:11.000000', 'temperatura', 502.0000, 'ºC'),
	(288252, 142, '2015-01-01 00:08:12.000000', 'temperatura', 1065.0000, 'ºC'),
	(288253, 142, '2015-01-01 00:08:13.000000', 'temperatura', 219.0000, 'ºC'),
	(288254, 142, '2015-01-01 00:08:14.000000', 'temperatura', 302.0000, 'ºC'),
	(288255, 142, '2015-01-01 00:08:15.000000', 'temperatura', 853.0000, 'ºC'),
	(288256, 142, '2015-01-01 00:08:16.000000', 'temperatura', 958.0000, 'ºC'),
	(288257, 142, '2015-01-01 00:08:17.000000', 'temperatura', 1034.0000, 'ºC'),
	(288258, 142, '2015-01-01 00:08:18.000000', 'temperatura', 1094.0000, 'ºC'),
	(288259, 142, '2015-01-01 00:08:19.000000', 'temperatura', 1168.0000, 'ºC'),
	(288260, 142, '2015-01-01 00:08:20.000000', 'temperatura', 161.0000, 'ºC'),
	(288261, 142, '2015-01-01 00:08:21.000000', 'temperatura', 901.0000, 'ºC'),
	(288262, 142, '2015-01-01 00:08:22.000000', 'temperatura', 420.0000, 'ºC'),
	(288263, 142, '2015-01-01 00:08:23.000000', 'temperatura', 601.0000, 'ºC'),
	(288264, 142, '2015-01-01 00:08:24.000000', 'temperatura', 542.0000, 'ºC'),
	(288265, 142, '2015-01-01 00:08:25.000000', 'temperatura', 910.0000, 'ºC'),
	(288266, 142, '2015-01-01 00:08:26.000000', 'temperatura', 523.0000, 'ºC'),
	(288267, 142, '2015-01-01 00:08:27.000000', 'temperatura', 1085.0000, 'ºC'),
	(288268, 142, '2015-01-01 00:08:28.000000', 'temperatura', 256.0000, 'ºC'),
	(288269, 142, '2015-01-01 00:08:29.000000', 'temperatura', 427.0000, 'ºC'),
	(288270, 142, '2015-01-01 00:08:30.000000', 'temperatura', 169.0000, 'ºC'),
	(288271, 142, '2015-01-01 00:08:31.000000', 'temperatura', 761.0000, 'ºC'),
	(288272, 142, '2015-01-01 00:08:32.000000', 'temperatura', 901.0000, 'ºC'),
	(288273, 142, '2015-01-01 00:08:33.000000', 'temperatura', 1023.0000, 'ºC'),
	(288274, 142, '2015-01-01 00:08:34.000000', 'temperatura', 12.0000, 'ºC'),
	(288275, 142, '2015-01-01 00:08:35.000000', 'temperatura', 593.0000, 'ºC'),
	(288276, 142, '2015-01-01 00:08:36.000000', 'temperatura', 530.0000, 'ºC'),
	(288277, 142, '2015-01-01 00:08:37.000000', 'temperatura', 869.0000, 'ºC'),
	(288278, 142, '2015-01-01 00:08:38.000000', 'temperatura', 358.0000, 'ºC'),
	(288279, 142, '2015-01-01 00:08:39.000000', 'temperatura', 384.0000, 'ºC'),
	(288280, 142, '2015-01-01 00:08:40.000000', 'temperatura', 844.0000, 'ºC'),
	(288281, 142, '2015-01-01 00:08:41.000000', 'temperatura', 668.0000, 'ºC'),
	(288282, 142, '2015-01-01 00:08:42.000000', 'temperatura', 811.0000, 'ºC'),
	(288283, 142, '2015-01-01 00:08:43.000000', 'temperatura', 851.0000, 'ºC'),
	(288284, 142, '2015-01-01 00:08:44.000000', 'temperatura', 624.0000, 'ºC'),
	(288285, 142, '2015-01-01 00:08:45.000000', 'temperatura', 565.0000, 'ºC'),
	(288286, 142, '2015-01-01 00:08:46.000000', 'temperatura', 953.0000, 'ºC'),
	(288287, 142, '2015-01-01 00:08:47.000000', 'temperatura', 672.0000, 'ºC'),
	(288288, 142, '2015-01-01 00:08:48.000000', 'temperatura', 501.0000, 'ºC'),
	(288289, 142, '2015-01-01 00:08:49.000000', 'temperatura', 489.0000, 'ºC'),
	(288290, 142, '2015-01-01 00:08:50.000000', 'temperatura', 943.0000, 'ºC'),
	(288291, 142, '2015-01-01 00:08:51.000000', 'temperatura', 848.0000, 'ºC'),
	(288292, 142, '2015-01-01 00:08:52.000000', 'temperatura', 210.0000, 'ºC'),
	(288293, 142, '2015-01-01 00:08:53.000000', 'temperatura', 908.0000, 'ºC'),
	(288294, 142, '2015-01-01 00:08:54.000000', 'temperatura', 310.0000, 'ºC'),
	(288295, 142, '2015-01-01 00:08:55.000000', 'temperatura', 28.0000, 'ºC'),
	(288296, 142, '2015-01-01 00:08:56.000000', 'temperatura', 411.0000, 'ºC'),
	(288297, 142, '2015-01-01 00:08:57.000000', 'temperatura', 769.0000, 'ºC'),
	(288298, 142, '2015-01-01 00:08:58.000000', 'temperatura', 216.0000, 'ºC'),
	(288299, 142, '2015-01-01 00:08:59.000000', 'temperatura', 1170.0000, 'ºC'),
	(288300, 142, '2015-01-01 00:09:00.000000', 'temperatura', 404.0000, 'ºC'),
	(288301, 142, '2015-01-01 00:09:01.000000', 'temperatura', 910.0000, 'ºC'),
	(288302, 142, '2015-01-01 00:09:02.000000', 'temperatura', 937.0000, 'ºC'),
	(288303, 142, '2015-01-01 00:09:03.000000', 'temperatura', 755.0000, 'ºC'),
	(288304, 142, '2015-01-01 00:09:04.000000', 'temperatura', 967.0000, 'ºC'),
	(288305, 142, '2015-01-01 00:09:05.000000', 'temperatura', 170.0000, 'ºC'),
	(288306, 142, '2015-01-01 00:09:06.000000', 'temperatura', 349.0000, 'ºC'),
	(288307, 142, '2015-01-01 00:09:07.000000', 'temperatura', 35.0000, 'ºC'),
	(288308, 142, '2015-01-01 00:09:08.000000', 'temperatura', 328.0000, 'ºC'),
	(288309, 142, '2015-01-01 00:09:09.000000', 'temperatura', 337.0000, 'ºC'),
	(288310, 142, '2015-01-01 00:09:10.000000', 'temperatura', 700.0000, 'ºC'),
	(288311, 142, '2015-01-01 00:09:11.000000', 'temperatura', 91.0000, 'ºC'),
	(288312, 142, '2015-01-01 00:09:12.000000', 'temperatura', 757.0000, 'ºC'),
	(288313, 142, '2015-01-01 00:09:13.000000', 'temperatura', 1111.0000, 'ºC'),
	(288314, 142, '2015-01-01 00:09:14.000000', 'temperatura', 884.0000, 'ºC'),
	(288315, 142, '2015-01-01 00:09:15.000000', 'temperatura', 1088.0000, 'ºC'),
	(288316, 142, '2015-01-01 00:09:16.000000', 'temperatura', 387.0000, 'ºC'),
	(288317, 142, '2015-01-01 00:09:17.000000', 'temperatura', 1073.0000, 'ºC'),
	(288318, 142, '2015-01-01 00:09:18.000000', 'temperatura', 604.0000, 'ºC'),
	(288319, 142, '2015-01-01 00:09:19.000000', 'temperatura', 1002.0000, 'ºC'),
	(288320, 142, '2015-01-01 00:09:20.000000', 'temperatura', 798.0000, 'ºC'),
	(288321, 142, '2015-01-01 00:09:21.000000', 'temperatura', 983.0000, 'ºC'),
	(288322, 142, '2015-01-01 00:09:22.000000', 'temperatura', 121.0000, 'ºC'),
	(288323, 142, '2015-01-01 00:09:23.000000', 'temperatura', 56.0000, 'ºC'),
	(288324, 142, '2015-01-01 00:09:24.000000', 'temperatura', 1117.0000, 'ºC'),
	(288325, 142, '2015-01-01 00:09:25.000000', 'temperatura', 618.0000, 'ºC'),
	(288326, 142, '2015-01-01 00:09:26.000000', 'temperatura', 942.0000, 'ºC'),
	(288327, 142, '2015-01-01 00:09:27.000000', 'temperatura', 454.0000, 'ºC'),
	(288328, 142, '2015-01-01 00:09:28.000000', 'temperatura', 644.0000, 'ºC'),
	(288329, 142, '2015-01-01 00:09:29.000000', 'temperatura', 661.0000, 'ºC'),
	(288330, 142, '2015-01-01 00:09:30.000000', 'temperatura', 171.0000, 'ºC'),
	(288331, 142, '2015-01-01 00:09:31.000000', 'temperatura', 75.0000, 'ºC'),
	(288332, 142, '2015-01-01 00:09:32.000000', 'temperatura', 1061.0000, 'ºC'),
	(288333, 142, '2015-01-01 00:09:33.000000', 'temperatura', 282.0000, 'ºC'),
	(288334, 142, '2015-01-01 00:09:34.000000', 'temperatura', 625.0000, 'ºC'),
	(288335, 142, '2015-01-01 00:09:35.000000', 'temperatura', 1079.0000, 'ºC'),
	(288336, 142, '2015-01-01 00:09:36.000000', 'temperatura', 1124.0000, 'ºC'),
	(288337, 142, '2015-01-01 00:09:37.000000', 'temperatura', 1180.0000, 'ºC'),
	(288338, 142, '2015-01-01 00:09:38.000000', 'temperatura', 129.0000, 'ºC'),
	(288339, 142, '2015-01-01 00:09:39.000000', 'temperatura', 705.0000, 'ºC'),
	(288340, 142, '2015-01-01 00:09:40.000000', 'temperatura', 738.0000, 'ºC'),
	(288341, 142, '2015-01-01 00:09:41.000000', 'temperatura', 377.0000, 'ºC'),
	(288342, 142, '2015-01-01 00:09:42.000000', 'temperatura', 870.0000, 'ºC'),
	(288343, 142, '2015-01-01 00:09:43.000000', 'temperatura', 820.0000, 'ºC'),
	(288344, 142, '2015-01-01 00:09:44.000000', 'temperatura', 291.0000, 'ºC'),
	(288345, 142, '2015-01-01 00:09:45.000000', 'temperatura', 197.0000, 'ºC'),
	(288346, 142, '2015-01-01 00:09:46.000000', 'temperatura', 110.0000, 'ºC'),
	(288347, 142, '2015-01-01 00:09:47.000000', 'temperatura', 1161.0000, 'ºC'),
	(288348, 142, '2015-01-01 00:09:48.000000', 'temperatura', 674.0000, 'ºC'),
	(288349, 142, '2015-01-01 00:09:49.000000', 'temperatura', 1086.0000, 'ºC'),
	(288350, 142, '2015-01-01 00:09:50.000000', 'temperatura', 1011.0000, 'ºC'),
	(288351, 142, '2015-01-01 00:09:51.000000', 'temperatura', 596.0000, 'ºC'),
	(288352, 142, '2015-01-01 00:09:52.000000', 'temperatura', 1149.0000, 'ºC'),
	(288353, 142, '2015-01-01 00:09:53.000000', 'temperatura', 356.0000, 'ºC'),
	(288354, 142, '2015-01-01 00:09:54.000000', 'temperatura', 736.0000, 'ºC'),
	(288355, 142, '2015-01-01 00:09:55.000000', 'temperatura', 210.0000, 'ºC'),
	(288356, 142, '2015-01-01 00:09:56.000000', 'temperatura', 41.0000, 'ºC'),
	(288357, 142, '2015-01-01 00:09:57.000000', 'temperatura', 779.0000, 'ºC'),
	(288358, 142, '2015-01-01 00:09:58.000000', 'temperatura', 171.0000, 'ºC'),
	(288359, 142, '2015-01-01 00:09:59.000000', 'temperatura', 917.0000, 'ºC'),
	(288360, 142, '2015-01-01 00:10:00.000000', 'temperatura', 474.0000, 'ºC'),
	(288361, 142, '2015-01-01 00:10:01.000000', 'temperatura', 821.0000, 'ºC'),
	(288362, 142, '2015-01-01 00:10:02.000000', 'temperatura', 281.0000, 'ºC'),
	(288363, 142, '2015-01-01 00:10:03.000000', 'temperatura', 143.0000, 'ºC'),
	(288364, 142, '2015-01-01 00:10:04.000000', 'temperatura', 1073.0000, 'ºC'),
	(288365, 142, '2015-01-01 00:10:05.000000', 'temperatura', 134.0000, 'ºC'),
	(288366, 142, '2015-01-01 00:10:06.000000', 'temperatura', 1055.0000, 'ºC'),
	(288367, 142, '2015-01-01 00:10:07.000000', 'temperatura', 72.0000, 'ºC'),
	(288368, 142, '2015-01-01 00:10:08.000000', 'temperatura', 794.0000, 'ºC'),
	(288369, 142, '2015-01-01 00:10:09.000000', 'temperatura', 157.0000, 'ºC'),
	(288370, 142, '2015-01-01 00:10:10.000000', 'temperatura', 803.0000, 'ºC'),
	(288371, 142, '2015-01-01 00:10:11.000000', 'temperatura', 1145.0000, 'ºC'),
	(288372, 142, '2015-01-01 00:10:12.000000', 'temperatura', 914.0000, 'ºC'),
	(288373, 142, '2015-01-01 00:10:13.000000', 'temperatura', 1137.0000, 'ºC'),
	(288374, 142, '2015-01-01 00:10:14.000000', 'temperatura', 545.0000, 'ºC'),
	(288375, 142, '2015-01-01 00:10:15.000000', 'temperatura', 514.0000, 'ºC'),
	(288376, 142, '2015-01-01 00:10:16.000000', 'temperatura', 935.0000, 'ºC'),
	(288377, 142, '2015-01-01 00:10:17.000000', 'temperatura', 734.0000, 'ºC'),
	(288378, 142, '2015-01-01 00:10:18.000000', 'temperatura', 866.0000, 'ºC'),
	(288379, 142, '2015-01-01 00:10:19.000000', 'temperatura', 926.0000, 'ºC'),
	(288380, 142, '2015-01-01 00:10:20.000000', 'temperatura', 834.0000, 'ºC'),
	(288381, 142, '2015-01-01 00:10:21.000000', 'temperatura', 191.0000, 'ºC'),
	(288382, 142, '2015-01-01 00:10:22.000000', 'temperatura', 857.0000, 'ºC'),
	(288383, 142, '2015-01-01 00:10:23.000000', 'temperatura', 109.0000, 'ºC'),
	(288384, 142, '2015-01-01 00:10:24.000000', 'temperatura', 374.0000, 'ºC'),
	(288385, 142, '2015-01-01 00:10:25.000000', 'temperatura', 345.0000, 'ºC'),
	(288386, 142, '2015-01-01 00:10:26.000000', 'temperatura', 605.0000, 'ºC'),
	(288387, 142, '2015-01-01 00:10:27.000000', 'temperatura', 788.0000, 'ºC'),
	(288388, 142, '2015-01-01 00:10:28.000000', 'temperatura', 926.0000, 'ºC'),
	(288389, 142, '2015-01-01 00:10:29.000000', 'temperatura', 1068.0000, 'ºC'),
	(288390, 142, '2015-01-01 00:10:30.000000', 'temperatura', 162.0000, 'ºC'),
	(288391, 142, '2015-01-01 00:10:31.000000', 'temperatura', 8.0000, 'ºC'),
	(288392, 142, '2015-01-01 00:10:32.000000', 'temperatura', 751.0000, 'ºC'),
	(288393, 142, '2015-01-01 00:10:33.000000', 'temperatura', 135.0000, 'ºC'),
	(288394, 142, '2015-01-01 00:10:34.000000', 'temperatura', 822.0000, 'ºC'),
	(288395, 142, '2015-01-01 00:10:35.000000', 'temperatura', 105.0000, 'ºC'),
	(288396, 142, '2015-01-01 00:10:36.000000', 'temperatura', 460.0000, 'ºC'),
	(288397, 142, '2015-01-01 00:10:37.000000', 'temperatura', 784.0000, 'ºC'),
	(288398, 142, '2015-01-01 00:10:38.000000', 'temperatura', 140.0000, 'ºC'),
	(288399, 142, '2015-01-01 00:10:39.000000', 'temperatura', 751.0000, 'ºC'),
	(288400, 142, '2015-01-01 00:10:40.000000', 'temperatura', 935.0000, 'ºC'),
	(288401, 142, '2015-01-01 00:10:41.000000', 'temperatura', 22.0000, 'ºC'),
	(288402, 142, '2015-01-01 00:10:42.000000', 'temperatura', 907.0000, 'ºC'),
	(288403, 142, '2015-01-01 00:10:43.000000', 'temperatura', 869.0000, 'ºC'),
	(288404, 142, '2015-01-01 00:10:44.000000', 'temperatura', 425.0000, 'ºC'),
	(288405, 142, '2015-01-01 00:10:45.000000', 'temperatura', 717.0000, 'ºC'),
	(288406, 142, '2015-01-01 00:10:46.000000', 'temperatura', 1110.0000, 'ºC'),
	(288407, 142, '2015-01-01 00:10:47.000000', 'temperatura', 1000.0000, 'ºC'),
	(288408, 142, '2015-01-01 00:10:48.000000', 'temperatura', 473.0000, 'ºC'),
	(288409, 142, '2015-01-01 00:10:49.000000', 'temperatura', 563.0000, 'ºC'),
	(288410, 142, '2015-01-01 00:10:50.000000', 'temperatura', 196.0000, 'ºC'),
	(288411, 142, '2015-01-01 00:10:51.000000', 'temperatura', 491.0000, 'ºC'),
	(288412, 142, '2015-01-01 00:10:52.000000', 'temperatura', 667.0000, 'ºC'),
	(288413, 142, '2015-01-01 00:10:53.000000', 'temperatura', 662.0000, 'ºC'),
	(288414, 142, '2015-01-01 00:10:54.000000', 'temperatura', 112.0000, 'ºC'),
	(288415, 142, '2015-01-01 00:10:55.000000', 'temperatura', 973.0000, 'ºC'),
	(288416, 142, '2015-01-01 00:10:56.000000', 'temperatura', 931.0000, 'ºC'),
	(288417, 142, '2015-01-01 00:10:57.000000', 'temperatura', 535.0000, 'ºC'),
	(288418, 142, '2015-01-01 00:10:58.000000', 'temperatura', 1085.0000, 'ºC'),
	(288419, 142, '2015-01-01 00:10:59.000000', 'temperatura', 219.0000, 'ºC'),
	(288420, 142, '2015-01-01 00:11:00.000000', 'temperatura', 242.0000, 'ºC'),
	(288421, 142, '2015-01-01 00:11:01.000000', 'temperatura', 552.0000, 'ºC'),
	(288422, 142, '2015-01-01 00:11:02.000000', 'temperatura', 834.0000, 'ºC'),
	(288423, 142, '2015-01-01 00:11:03.000000', 'temperatura', 114.0000, 'ºC'),
	(288424, 142, '2015-01-01 00:11:04.000000', 'temperatura', 468.0000, 'ºC'),
	(288425, 142, '2015-01-01 00:11:05.000000', 'temperatura', 799.0000, 'ºC'),
	(288426, 142, '2015-01-01 00:11:06.000000', 'temperatura', 191.0000, 'ºC'),
	(288427, 142, '2015-01-01 00:11:07.000000', 'temperatura', 960.0000, 'ºC'),
	(288428, 142, '2015-01-01 00:11:08.000000', 'temperatura', 628.0000, 'ºC'),
	(288429, 142, '2015-01-01 00:11:09.000000', 'temperatura', 260.0000, 'ºC'),
	(288430, 142, '2015-01-01 00:11:10.000000', 'temperatura', 616.0000, 'ºC'),
	(288431, 142, '2015-01-01 00:11:11.000000', 'temperatura', 1100.0000, 'ºC'),
	(288432, 142, '2015-01-01 00:11:12.000000', 'temperatura', 52.0000, 'ºC'),
	(288433, 142, '2015-01-01 00:11:13.000000', 'temperatura', 561.0000, 'ºC'),
	(288434, 142, '2015-01-01 00:11:14.000000', 'temperatura', 249.0000, 'ºC'),
	(288435, 142, '2015-01-01 00:11:15.000000', 'temperatura', 763.0000, 'ºC'),
	(288436, 142, '2015-01-01 00:11:16.000000', 'temperatura', 667.0000, 'ºC'),
	(288437, 142, '2015-01-01 00:11:17.000000', 'temperatura', 1046.0000, 'ºC'),
	(288438, 142, '2015-01-01 00:11:18.000000', 'temperatura', 831.0000, 'ºC'),
	(288439, 142, '2015-01-01 00:11:19.000000', 'temperatura', 1016.0000, 'ºC'),
	(288440, 142, '2015-01-01 00:11:20.000000', 'temperatura', 186.0000, 'ºC'),
	(288441, 142, '2015-01-01 00:11:21.000000', 'temperatura', 285.0000, 'ºC'),
	(288442, 142, '2015-01-01 00:11:22.000000', 'temperatura', 868.0000, 'ºC'),
	(288443, 142, '2015-01-01 00:11:23.000000', 'temperatura', 1085.0000, 'ºC'),
	(288444, 142, '2015-01-01 00:11:24.000000', 'temperatura', 420.0000, 'ºC'),
	(288445, 142, '2015-01-01 00:11:25.000000', 'temperatura', 47.0000, 'ºC'),
	(288446, 142, '2015-01-01 00:11:26.000000', 'temperatura', 175.0000, 'ºC'),
	(288447, 142, '2015-01-01 00:11:27.000000', 'temperatura', 736.0000, 'ºC'),
	(288448, 142, '2015-01-01 00:11:28.000000', 'temperatura', 753.0000, 'ºC'),
	(288449, 142, '2015-01-01 00:11:29.000000', 'temperatura', 359.0000, 'ºC'),
	(288450, 142, '2015-01-01 00:11:30.000000', 'temperatura', 735.0000, 'ºC'),
	(288451, 142, '2015-01-01 00:11:31.000000', 'temperatura', 200.0000, 'ºC'),
	(288452, 142, '2015-01-01 00:11:32.000000', 'temperatura', 1197.0000, 'ºC'),
	(288453, 142, '2015-01-01 00:11:33.000000', 'temperatura', 583.0000, 'ºC'),
	(288454, 142, '2015-01-01 00:11:34.000000', 'temperatura', 527.0000, 'ºC'),
	(288455, 142, '2015-01-01 00:11:35.000000', 'temperatura', 887.0000, 'ºC'),
	(288456, 142, '2015-01-01 00:11:36.000000', 'temperatura', 451.0000, 'ºC'),
	(288457, 142, '2015-01-01 00:11:37.000000', 'temperatura', 798.0000, 'ºC'),
	(288458, 142, '2015-01-01 00:11:38.000000', 'temperatura', 234.0000, 'ºC'),
	(288459, 142, '2015-01-01 00:11:39.000000', 'temperatura', 1179.0000, 'ºC'),
	(288460, 142, '2015-01-01 00:11:40.000000', 'temperatura', 394.0000, 'ºC'),
	(288461, 142, '2015-01-01 00:11:41.000000', 'temperatura', 834.0000, 'ºC'),
	(288462, 142, '2015-01-01 00:11:42.000000', 'temperatura', 585.0000, 'ºC'),
	(288463, 142, '2015-01-01 00:11:43.000000', 'temperatura', 427.0000, 'ºC'),
	(288464, 142, '2015-01-01 00:11:44.000000', 'temperatura', 381.0000, 'ºC'),
	(288465, 142, '2015-01-01 00:11:45.000000', 'temperatura', 623.0000, 'ºC'),
	(288466, 142, '2015-01-01 00:11:46.000000', 'temperatura', 772.0000, 'ºC'),
	(288467, 142, '2015-01-01 00:11:47.000000', 'temperatura', 792.0000, 'ºC'),
	(288468, 142, '2015-01-01 00:11:48.000000', 'temperatura', 446.0000, 'ºC'),
	(288469, 142, '2015-01-01 00:11:49.000000', 'temperatura', 1053.0000, 'ºC'),
	(288470, 142, '2015-01-01 00:11:50.000000', 'temperatura', 328.0000, 'ºC'),
	(288471, 142, '2015-01-01 00:11:51.000000', 'temperatura', 883.0000, 'ºC'),
	(288472, 142, '2015-01-01 00:11:52.000000', 'temperatura', 1030.0000, 'ºC'),
	(288473, 142, '2015-01-01 00:11:53.000000', 'temperatura', 103.0000, 'ºC'),
	(288474, 142, '2015-01-01 00:11:54.000000', 'temperatura', 1024.0000, 'ºC'),
	(288475, 142, '2015-01-01 00:11:55.000000', 'temperatura', 13.0000, 'ºC'),
	(288476, 142, '2015-01-01 00:11:56.000000', 'temperatura', 594.0000, 'ºC'),
	(288477, 142, '2015-01-01 00:11:57.000000', 'temperatura', 531.0000, 'ºC'),
	(288478, 142, '2015-01-01 00:11:58.000000', 'temperatura', 875.0000, 'ºC'),
	(288479, 142, '2015-01-01 00:11:59.000000', 'temperatura', 379.0000, 'ºC'),
	(288480, 142, '2015-01-01 00:12:00.000000', 'temperatura', 474.0000, 'ºC'),
	(288481, 142, '2015-01-01 00:12:01.000000', 'temperatura', 33.0000, 'ºC'),
	(288482, 142, '2015-01-01 00:12:02.000000', 'temperatura', 1142.0000, 'ºC'),
	(288483, 142, '2015-01-01 00:12:03.000000', 'temperatura', 812.0000, 'ºC'),
	(288484, 142, '2015-01-01 00:12:04.000000', 'temperatura', 634.0000, 'ºC'),
	(288485, 142, '2015-01-01 00:12:05.000000', 'temperatura', 737.0000, 'ºC'),
	(288486, 142, '2015-01-01 00:12:06.000000', 'temperatura', 582.0000, 'ºC'),
	(288487, 142, '2015-01-01 00:12:07.000000', 'temperatura', 700.0000, 'ºC'),
	(288488, 142, '2015-01-01 00:12:08.000000', 'temperatura', 555.0000, 'ºC'),
	(288489, 142, '2015-01-01 00:12:09.000000', 'temperatura', 675.0000, 'ºC'),
	(288490, 142, '2015-01-01 00:12:10.000000', 'temperatura', 512.0000, 'ºC'),
	(288491, 142, '2015-01-01 00:12:11.000000', 'temperatura', 533.0000, 'ºC'),
	(288492, 142, '2015-01-01 00:12:12.000000', 'temperatura', 1132.0000, 'ºC'),
	(288493, 142, '2015-01-01 00:12:13.000000', 'temperatura', 459.0000, 'ºC'),
	(288494, 142, '2015-01-01 00:12:14.000000', 'temperatura', 102.0000, 'ºC'),
	(288495, 142, '2015-01-01 00:12:15.000000', 'temperatura', 333.0000, 'ºC'),
	(288496, 142, '2015-01-01 00:12:16.000000', 'temperatura', 161.0000, 'ºC'),
	(288497, 142, '2015-01-01 00:12:17.000000', 'temperatura', 1006.0000, 'ºC'),
	(288498, 142, '2015-01-01 00:12:18.000000', 'temperatura', 945.0000, 'ºC'),
	(288499, 142, '2015-01-01 00:12:19.000000', 'temperatura', 510.0000, 'ºC'),
	(288500, 142, '2015-01-01 00:12:20.000000', 'temperatura', 917.0000, 'ºC'),
	(288501, 142, '2015-01-01 00:12:21.000000', 'temperatura', 652.0000, 'ºC'),
	(288502, 142, '2015-01-01 00:12:22.000000', 'temperatura', 512.0000, 'ºC'),
	(288503, 142, '2015-01-01 00:12:23.000000', 'temperatura', 602.0000, 'ºC'),
	(288504, 142, '2015-01-01 00:12:24.000000', 'temperatura', 277.0000, 'ºC'),
	(288505, 142, '2015-01-01 00:12:25.000000', 'temperatura', 780.0000, 'ºC'),
	(288506, 142, '2015-01-01 00:12:26.000000', 'temperatura', 669.0000, 'ºC'),
	(288507, 142, '2015-01-01 00:12:27.000000', 'temperatura', 1006.0000, 'ºC'),
	(288508, 142, '2015-01-01 00:12:28.000000', 'temperatura', 622.0000, 'ºC'),
	(288509, 142, '2015-01-01 00:12:29.000000', 'temperatura', 93.0000, 'ºC'),
	(288510, 142, '2015-01-01 00:12:30.000000', 'temperatura', 998.0000, 'ºC'),
	(288511, 142, '2015-01-01 00:12:31.000000', 'temperatura', 1113.0000, 'ºC'),
	(288512, 142, '2015-01-01 00:12:32.000000', 'temperatura', 171.0000, 'ºC'),
	(288513, 142, '2015-01-01 00:12:33.000000', 'temperatura', 1119.0000, 'ºC'),
	(288514, 142, '2015-01-01 00:12:34.000000', 'temperatura', 279.0000, 'ºC'),
	(288515, 142, '2015-01-01 00:12:35.000000', 'temperatura', 441.0000, 'ºC'),
	(288516, 142, '2015-01-01 00:12:36.000000', 'temperatura', 166.0000, 'ºC'),
	(288517, 142, '2015-01-01 00:12:37.000000', 'temperatura', 709.0000, 'ºC'),
	(288518, 142, '2015-01-01 00:12:38.000000', 'temperatura', 647.0000, 'ºC'),
	(288519, 142, '2015-01-01 00:12:39.000000', 'temperatura', 1109.0000, 'ºC'),
	(288520, 142, '2015-01-01 00:12:40.000000', 'temperatura', 4.0000, 'ºC'),
	(288521, 142, '2015-01-01 00:12:41.000000', 'temperatura', 296.0000, 'ºC'),
	(288522, 142, '2015-01-01 00:12:42.000000', 'temperatura', 266.0000, 'ºC'),
	(288523, 142, '2015-01-01 00:12:43.000000', 'temperatura', 444.0000, 'ºC'),
	(288524, 142, '2015-01-01 00:12:44.000000', 'temperatura', 221.0000, 'ºC'),
	(288525, 142, '2015-01-01 00:12:45.000000', 'temperatura', 975.0000, 'ºC'),
	(288526, 142, '2015-01-01 00:12:46.000000', 'temperatura', 610.0000, 'ºC'),
	(288527, 142, '2015-01-01 00:12:47.000000', 'temperatura', 128.0000, 'ºC'),
	(288528, 142, '2015-01-01 00:12:48.000000', 'temperatura', 8.0000, 'ºC'),
	(288529, 142, '2015-01-01 00:12:49.000000', 'temperatura', 856.0000, 'ºC'),
	(288530, 142, '2015-01-01 00:12:50.000000', 'temperatura', 659.0000, 'ºC'),
	(288531, 142, '2015-01-01 00:12:51.000000', 'temperatura', 727.0000, 'ºC'),
	(288532, 142, '2015-01-01 00:12:52.000000', 'temperatura', 460.0000, 'ºC'),
	(288533, 142, '2015-01-01 00:12:53.000000', 'temperatura', 119.0000, 'ºC'),
	(288534, 142, '2015-01-01 00:12:54.000000', 'temperatura', 416.0000, 'ºC'),
	(288535, 142, '2015-01-01 00:12:55.000000', 'temperatura', 524.0000, 'ºC'),
	(288536, 142, '2015-01-01 00:12:56.000000', 'temperatura', 172.0000, 'ºC'),
	(288537, 142, '2015-01-01 00:12:57.000000', 'temperatura', 488.0000, 'ºC'),
	(288538, 142, '2015-01-01 00:12:58.000000', 'temperatura', 726.0000, 'ºC'),
	(288539, 142, '2015-01-01 00:12:59.000000', 'temperatura', 967.0000, 'ºC'),
	(288540, 142, '2015-01-01 00:13:00.000000', 'temperatura', 256.0000, 'ºC'),
	(288541, 142, '2015-01-01 00:13:01.000000', 'temperatura', 778.0000, 'ºC'),
	(288542, 142, '2015-01-01 00:13:02.000000', 'temperatura', 723.0000, 'ºC'),
	(288543, 142, '2015-01-01 00:13:03.000000', 'temperatura', 84.0000, 'ºC'),
	(288544, 142, '2015-01-01 00:13:04.000000', 'temperatura', 650.0000, 'ºC'),
	(288545, 142, '2015-01-01 00:13:05.000000', 'temperatura', 597.0000, 'ºC'),
	(288546, 142, '2015-01-01 00:13:06.000000', 'temperatura', 1035.0000, 'ºC'),
	(288547, 142, '2015-01-01 00:13:07.000000', 'temperatura', 986.0000, 'ºC'),
	(288548, 142, '2015-01-01 00:13:08.000000', 'temperatura', 627.0000, 'ºC'),
	(288549, 142, '2015-01-01 00:13:09.000000', 'temperatura', 176.0000, 'ºC'),
	(288550, 142, '2015-01-01 00:13:10.000000', 'temperatura', 198.0000, 'ºC'),
	(288551, 142, '2015-01-01 00:13:11.000000', 'temperatura', 463.0000, 'ºC'),
	(288552, 142, '2015-01-01 00:13:12.000000', 'temperatura', 524.0000, 'ºC'),
	(288553, 142, '2015-01-01 00:13:13.000000', 'temperatura', 28.0000, 'ºC'),
	(288554, 142, '2015-01-01 00:13:14.000000', 'temperatura', 970.0000, 'ºC'),
	(288555, 142, '2015-01-01 00:13:15.000000', 'temperatura', 1167.0000, 'ºC'),
	(288556, 142, '2015-01-01 00:13:16.000000', 'temperatura', 524.0000, 'ºC'),
	(288557, 142, '2015-01-01 00:13:17.000000', 'temperatura', 319.0000, 'ºC'),
	(288558, 142, '2015-01-01 00:13:18.000000', 'temperatura', 23.0000, 'ºC'),
	(288559, 142, '2015-01-01 00:13:19.000000', 'temperatura', 360.0000, 'ºC'),
	(288560, 142, '2015-01-01 00:13:20.000000', 'temperatura', 531.0000, 'ºC'),
	(288561, 142, '2015-01-01 00:13:21.000000', 'temperatura', 378.0000, 'ºC'),
	(288562, 142, '2015-01-01 00:13:22.000000', 'temperatura', 294.0000, 'ºC'),
	(288563, 142, '2015-01-01 00:13:23.000000', 'temperatura', 339.0000, 'ºC'),
	(288564, 142, '2015-01-01 00:13:24.000000', 'temperatura', 811.0000, 'ºC'),
	(288565, 142, '2015-01-01 00:13:25.000000', 'temperatura', 641.0000, 'ºC'),
	(288566, 142, '2015-01-01 00:13:26.000000', 'temperatura', 770.0000, 'ºC'),
	(288567, 142, '2015-01-01 00:13:27.000000', 'temperatura', 726.0000, 'ºC'),
	(288568, 142, '2015-01-01 00:13:28.000000', 'temperatura', 124.0000, 'ºC'),
	(288569, 142, '2015-01-01 00:13:29.000000', 'temperatura', 843.0000, 'ºC'),
	(288570, 142, '2015-01-01 00:13:30.000000', 'temperatura', 242.0000, 'ºC'),
	(288571, 142, '2015-01-01 00:13:31.000000', 'temperatura', 1084.0000, 'ºC'),
	(288572, 142, '2015-01-01 00:13:32.000000', 'temperatura', 1091.0000, 'ºC'),
	(288573, 142, '2015-01-01 00:13:33.000000', 'temperatura', 1005.0000, 'ºC'),
	(288574, 142, '2015-01-01 00:13:34.000000', 'temperatura', 553.0000, 'ºC'),
	(288575, 142, '2015-01-01 00:13:35.000000', 'temperatura', 950.0000, 'ºC'),
	(288576, 142, '2015-01-01 00:13:36.000000', 'temperatura', 691.0000, 'ºC'),
	(288577, 142, '2015-01-01 00:13:37.000000', 'temperatura', 608.0000, 'ºC'),
	(288578, 142, '2015-01-01 00:13:38.000000', 'temperatura', 964.0000, 'ºC'),
	(288579, 142, '2015-01-01 00:13:39.000000', 'temperatura', 598.0000, 'ºC'),
	(288580, 142, '2015-01-01 00:13:40.000000', 'temperatura', 98.0000, 'ºC'),
	(288581, 142, '2015-01-01 00:13:41.000000', 'temperatura', 1095.0000, 'ºC'),
	(288582, 142, '2015-01-01 00:13:42.000000', 'temperatura', 383.0000, 'ºC'),
	(288583, 142, '2015-01-01 00:13:43.000000', 'temperatura', 1030.0000, 'ºC'),
	(288584, 142, '2015-01-01 00:13:44.000000', 'temperatura', 403.0000, 'ºC'),
	(288585, 142, '2015-01-01 00:13:45.000000', 'temperatura', 125.0000, 'ºC'),
	(288586, 142, '2015-01-01 00:13:46.000000', 'temperatura', 616.0000, 'ºC'),
	(288587, 142, '2015-01-01 00:13:47.000000', 'temperatura', 307.0000, 'ºC'),
	(288588, 142, '2015-01-01 00:13:48.000000', 'temperatura', 887.0000, 'ºC'),
	(288589, 142, '2015-01-01 00:13:49.000000', 'temperatura', 1116.0000, 'ºC'),
	(288590, 142, '2015-01-01 00:13:50.000000', 'temperatura', 520.0000, 'ºC'),
	(288591, 142, '2015-01-01 00:13:51.000000', 'temperatura', 449.0000, 'ºC'),
	(288592, 142, '2015-01-01 00:13:52.000000', 'temperatura', 689.0000, 'ºC'),
	(288593, 142, '2015-01-01 00:13:53.000000', 'temperatura', 895.0000, 'ºC'),
	(288594, 142, '2015-01-01 00:13:54.000000', 'temperatura', 12.0000, 'ºC'),
	(288595, 142, '2015-01-01 00:13:55.000000', 'temperatura', 972.0000, 'ºC'),
	(288596, 142, '2015-01-01 00:13:56.000000', 'temperatura', 26.0000, 'ºC'),
	(288597, 142, '2015-01-01 00:13:57.000000', 'temperatura', 815.0000, 'ºC'),
	(288598, 142, '2015-01-01 00:13:58.000000', 'temperatura', 396.0000, 'ºC'),
	(288599, 142, '2015-01-01 00:13:59.000000', 'temperatura', 737.0000, 'ºC'),
	(288600, 142, '2015-01-01 00:14:00.000000', 'temperatura', 98.0000, 'ºC'),
	(288601, 142, '2015-01-01 00:14:01.000000', 'temperatura', 681.0000, 'ºC'),
	(288602, 142, '2015-01-01 00:14:02.000000', 'temperatura', 708.0000, 'ºC'),
	(288603, 142, '2015-01-01 00:14:03.000000', 'temperatura', 300.0000, 'ºC'),
	(288604, 142, '2015-01-01 00:14:04.000000', 'temperatura', 576.0000, 'ºC'),
	(288605, 142, '2015-01-01 00:14:05.000000', 'temperatura', 781.0000, 'ºC'),
	(288606, 142, '2015-01-01 00:14:06.000000', 'temperatura', 975.0000, 'ºC'),
	(288607, 142, '2015-01-01 00:14:07.000000', 'temperatura', 134.0000, 'ºC'),
	(288608, 142, '2015-01-01 00:14:08.000000', 'temperatura', 144.0000, 'ºC'),
	(288609, 142, '2015-01-01 00:14:09.000000', 'temperatura', 320.0000, 'ºC'),
	(288610, 142, '2015-01-01 00:14:10.000000', 'temperatura', 1169.0000, 'ºC'),
	(288611, 142, '2015-01-01 00:14:11.000000', 'temperatura', 84.0000, 'ºC'),
	(288612, 142, '2015-01-01 00:14:12.000000', 'temperatura', 514.0000, 'ºC'),
	(288613, 142, '2015-01-01 00:14:13.000000', 'temperatura', 1117.0000, 'ºC'),
	(288614, 142, '2015-01-01 00:14:14.000000', 'temperatura', 446.0000, 'ºC'),
	(288615, 142, '2015-01-01 00:14:15.000000', 'temperatura', 79.0000, 'ºC'),
	(288616, 142, '2015-01-01 00:14:16.000000', 'temperatura', 258.0000, 'ºC'),
	(288617, 142, '2015-01-01 00:14:17.000000', 'temperatura', 1053.0000, 'ºC'),
	(288618, 142, '2015-01-01 00:14:18.000000', 'temperatura', 893.0000, 'ºC'),
	(288619, 142, '2015-01-01 00:14:19.000000', 'temperatura', 104.0000, 'ºC'),
	(288620, 142, '2015-01-01 00:14:20.000000', 'temperatura', 243.0000, 'ºC'),
	(288621, 142, '2015-01-01 00:14:21.000000', 'temperatura', 902.0000, 'ºC'),
	(288622, 142, '2015-01-01 00:14:22.000000', 'temperatura', 182.0000, 'ºC'),
	(288623, 142, '2015-01-01 00:14:23.000000', 'temperatura', 604.0000, 'ºC'),
	(288624, 142, '2015-01-01 00:14:24.000000', 'temperatura', 76.0000, 'ºC'),
	(288625, 142, '2015-01-01 00:14:25.000000', 'temperatura', 968.0000, 'ºC'),
	(288626, 142, '2015-01-01 00:14:26.000000', 'temperatura', 1014.0000, 'ºC'),
	(288627, 142, '2015-01-01 00:14:27.000000', 'temperatura', 966.0000, 'ºC'),
	(288628, 142, '2015-01-01 00:14:28.000000', 'temperatura', 590.0000, 'ºC'),
	(288629, 142, '2015-01-01 00:14:29.000000', 'temperatura', 50.0000, 'ºC'),
	(288630, 142, '2015-01-01 00:14:30.000000', 'temperatura', 880.0000, 'ºC'),
	(288631, 142, '2015-01-01 00:14:31.000000', 'temperatura', 651.0000, 'ºC'),
	(288632, 142, '2015-01-01 00:14:32.000000', 'temperatura', 614.0000, 'ºC'),
	(288633, 142, '2015-01-01 00:14:33.000000', 'temperatura', 1118.0000, 'ºC'),
	(288634, 142, '2015-01-01 00:14:34.000000', 'temperatura', 148.0000, 'ºC'),
	(288635, 142, '2015-01-01 00:14:35.000000', 'temperatura', 986.0000, 'ºC'),
	(288636, 142, '2015-01-01 00:14:36.000000', 'temperatura', 889.0000, 'ºC'),
	(288637, 142, '2015-01-01 00:14:37.000000', 'temperatura', 285.0000, 'ºC'),
	(288638, 142, '2015-01-01 00:14:38.000000', 'temperatura', 1161.0000, 'ºC'),
	(288639, 142, '2015-01-01 00:14:39.000000', 'temperatura', 149.0000, 'ºC'),
	(288640, 142, '2015-01-01 00:14:40.000000', 'temperatura', 862.0000, 'ºC'),
	(288641, 142, '2015-01-01 00:14:41.000000', 'temperatura', 266.0000, 'ºC'),
	(288642, 142, '2015-01-01 00:14:42.000000', 'temperatura', 1141.0000, 'ºC'),
	(288643, 142, '2015-01-01 00:14:43.000000', 'temperatura', 111.0000, 'ºC'),
	(288644, 142, '2015-01-01 00:14:44.000000', 'temperatura', 730.0000, 'ºC'),
	(288645, 142, '2015-01-01 00:14:45.000000', 'temperatura', 918.0000, 'ºC'),
	(288646, 142, '2015-01-01 00:14:46.000000', 'temperatura', 2.0000, 'ºC'),
	(288647, 142, '2015-01-01 00:14:47.000000', 'temperatura', 857.0000, 'ºC'),
	(288648, 142, '2015-01-01 00:14:48.000000', 'temperatura', 680.0000, 'ºC'),
	(288649, 142, '2015-01-01 00:14:49.000000', 'temperatura', 828.0000, 'ºC'),
	(288650, 142, '2015-01-01 00:14:50.000000', 'temperatura', 902.0000, 'ºC'),
	(288651, 142, '2015-01-01 00:14:51.000000', 'temperatura', 826.0000, 'ºC'),
	(288652, 142, '2015-01-01 00:14:52.000000', 'temperatura', 224.0000, 'ºC'),
	(288653, 142, '2015-01-01 00:14:53.000000', 'temperatura', 1044.0000, 'ºC'),
	(288654, 142, '2015-01-01 00:14:54.000000', 'temperatura', 946.0000, 'ºC'),
	(288655, 142, '2015-01-01 00:14:55.000000', 'temperatura', 398.0000, 'ºC'),
	(288656, 142, '2015-01-01 00:14:56.000000', 'temperatura', 353.0000, 'ºC'),
	(288657, 142, '2015-01-01 00:14:57.000000', 'temperatura', 571.0000, 'ºC'),
	(288658, 142, '2015-01-01 00:14:58.000000', 'temperatura', 597.0000, 'ºC'),
	(288659, 142, '2015-01-01 00:14:59.000000', 'temperatura', 70.0000, 'ºC'),
	(288660, 142, '2015-01-01 00:15:00.000000', 'temperatura', 963.0000, 'ºC'),
	(288661, 142, '2015-01-01 00:15:01.000000', 'temperatura', 1005.0000, 'ºC'),
	(288662, 142, '2015-01-01 00:15:02.000000', 'temperatura', 938.0000, 'ºC'),
	(288663, 142, '2015-01-01 00:15:03.000000', 'temperatura', 475.0000, 'ºC'),
	(288664, 142, '2015-01-01 00:15:04.000000', 'temperatura', 760.0000, 'ºC'),
	(288665, 142, '2015-01-01 00:15:05.000000', 'temperatura', 1177.0000, 'ºC'),
	(288666, 142, '2015-01-01 00:15:06.000000', 'temperatura', 4.0000, 'ºC'),
	(288667, 142, '2015-01-01 00:15:07.000000', 'temperatura', 89.0000, 'ºC'),
	(288668, 142, '2015-01-01 00:15:08.000000', 'temperatura', 433.0000, 'ºC'),
	(288669, 142, '2015-01-01 00:15:09.000000', 'temperatura', 700.0000, 'ºC'),
	(288670, 142, '2015-01-01 00:15:10.000000', 'temperatura', 999.0000, 'ºC'),
	(288671, 142, '2015-01-01 00:15:11.000000', 'temperatura', 497.0000, 'ºC'),
	(288672, 142, '2015-01-01 00:15:12.000000', 'temperatura', 690.0000, 'ºC'),
	(288673, 142, '2015-01-01 00:15:13.000000', 'temperatura', 756.0000, 'ºC'),
	(288674, 142, '2015-01-01 00:15:14.000000', 'temperatura', 514.0000, 'ºC'),
	(288675, 142, '2015-01-01 00:15:15.000000', 'temperatura', 300.0000, 'ºC'),
	(288676, 142, '2015-01-01 00:15:16.000000', 'temperatura', 1159.0000, 'ºC'),
	(288677, 142, '2015-01-01 00:15:17.000000', 'temperatura', 98.0000, 'ºC'),
	(288678, 142, '2015-01-01 00:15:18.000000', 'temperatura', 610.0000, 'ºC'),
	(288679, 142, '2015-01-01 00:15:19.000000', 'temperatura', 359.0000, 'ºC'),
	(288680, 142, '2015-01-01 00:15:20.000000', 'temperatura', 1166.0000, 'ºC'),
	(288681, 142, '2015-01-01 00:15:21.000000', 'temperatura', 1152.0000, 'ºC'),
	(288682, 142, '2015-01-01 00:15:22.000000', 'temperatura', 1064.0000, 'ºC'),
	(288683, 142, '2015-01-01 00:15:23.000000', 'temperatura', 665.0000, 'ºC'),
	(288684, 142, '2015-01-01 00:15:24.000000', 'temperatura', 134.0000, 'ºC'),
	(288685, 142, '2015-01-01 00:15:25.000000', 'temperatura', 1074.0000, 'ºC'),
	(288686, 142, '2015-01-01 00:15:26.000000', 'temperatura', 171.0000, 'ºC'),
	(288687, 142, '2015-01-01 00:15:27.000000', 'temperatura', 31.0000, 'ºC'),
	(288688, 142, '2015-01-01 00:15:28.000000', 'temperatura', 841.0000, 'ºC'),
	(288689, 142, '2015-01-01 00:15:29.000000', 'temperatura', 516.0000, 'ºC'),
	(288690, 142, '2015-01-01 00:15:30.000000', 'temperatura', 57.0000, 'ºC'),
	(288691, 142, '2015-01-01 00:15:31.000000', 'temperatura', 1135.0000, 'ºC'),
	(288692, 142, '2015-01-01 00:15:32.000000', 'temperatura', 706.0000, 'ºC'),
	(288693, 142, '2015-01-01 00:15:33.000000', 'temperatura', 125.0000, 'ºC'),
	(288694, 142, '2015-01-01 00:15:34.000000', 'temperatura', 907.0000, 'ºC'),
	(288695, 142, '2015-01-01 00:15:35.000000', 'temperatura', 560.0000, 'ºC'),
	(288696, 142, '2015-01-01 00:15:36.000000', 'temperatura', 82.0000, 'ºC'),
	(288697, 142, '2015-01-01 00:15:37.000000', 'temperatura', 1127.0000, 'ºC'),
	(288698, 142, '2015-01-01 00:15:38.000000', 'temperatura', 592.0000, 'ºC'),
	(288699, 142, '2015-01-01 00:15:39.000000', 'temperatura', 778.0000, 'ºC'),
	(288700, 142, '2015-01-01 00:15:40.000000', 'temperatura', 915.0000, 'ºC'),
	(288701, 142, '2015-01-01 00:15:41.000000', 'temperatura', 1043.0000, 'ºC'),
	(288702, 142, '2015-01-01 00:15:42.000000', 'temperatura', 69.0000, 'ºC'),
	(288703, 142, '2015-01-01 00:15:43.000000', 'temperatura', 816.0000, 'ºC'),
	(288704, 142, '2015-01-01 00:15:44.000000', 'temperatura', 275.0000, 'ºC'),
	(288705, 142, '2015-01-01 00:15:45.000000', 'temperatura', 128.0000, 'ºC'),
	(288706, 142, '2015-01-01 00:15:46.000000', 'temperatura', 1017.0000, 'ºC'),
	(288707, 142, '2015-01-01 00:15:47.000000', 'temperatura', 1098.0000, 'ºC'),
	(288708, 142, '2015-01-01 00:15:48.000000', 'temperatura', 40.0000, 'ºC'),
	(288709, 142, '2015-01-01 00:15:49.000000', 'temperatura', 508.0000, 'ºC'),
	(288710, 142, '2015-01-01 00:15:50.000000', 'temperatura', 18.0000, 'ºC'),
	(288711, 142, '2015-01-01 00:15:51.000000', 'temperatura', 968.0000, 'ºC'),
	(288712, 142, '2015-01-01 00:15:52.000000', 'temperatura', 1186.0000, 'ºC'),
	(288713, 142, '2015-01-01 00:15:53.000000', 'temperatura', 625.0000, 'ºC'),
	(288714, 142, '2015-01-01 00:15:54.000000', 'temperatura', 768.0000, 'ºC'),
	(288715, 142, '2015-01-01 00:15:55.000000', 'temperatura', 765.0000, 'ºC'),
	(288716, 142, '2015-01-01 00:15:56.000000', 'temperatura', 323.0000, 'ºC'),
	(288717, 142, '2015-01-01 00:15:57.000000', 'temperatura', 518.0000, 'ºC'),
	(288718, 142, '2015-01-01 00:15:58.000000', 'temperatura', 424.0000, 'ºC'),
	(288719, 142, '2015-01-01 00:15:59.000000', 'temperatura', 566.0000, 'ºC'),
	(288720, 142, '2015-01-01 00:16:00.000000', 'temperatura', 357.0000, 'ºC'),
	(288721, 142, '2015-01-01 00:16:01.000000', 'temperatura', 87.0000, 'ºC'),
	(288722, 142, '2015-01-01 00:16:02.000000', 'temperatura', 563.0000, 'ºC'),
	(288723, 142, '2015-01-01 00:16:03.000000', 'temperatura', 158.0000, 'ºC'),
	(288724, 142, '2015-01-01 00:16:04.000000', 'temperatura', 299.0000, 'ºC'),
	(288725, 142, '2015-01-01 00:16:05.000000', 'temperatura', 1023.0000, 'ºC'),
	(288726, 142, '2015-01-01 00:16:06.000000', 'temperatura', 619.0000, 'ºC'),
	(288727, 142, '2015-01-01 00:16:07.000000', 'temperatura', 25.0000, 'ºC'),
	(288728, 142, '2015-01-01 00:16:08.000000', 'temperatura', 670.0000, 'ºC'),
	(288729, 142, '2015-01-01 00:16:09.000000', 'temperatura', 874.0000, 'ºC'),
	(288730, 142, '2015-01-01 00:16:10.000000', 'temperatura', 1161.0000, 'ºC'),
	(288731, 142, '2015-01-01 00:16:11.000000', 'temperatura', 784.0000, 'ºC'),
	(288732, 142, '2015-01-01 00:16:12.000000', 'temperatura', 438.0000, 'ºC'),
	(288733, 142, '2015-01-01 00:16:13.000000', 'temperatura', 1039.0000, 'ºC'),
	(288734, 142, '2015-01-01 00:16:14.000000', 'temperatura', 282.0000, 'ºC'),
	(288735, 142, '2015-01-01 00:16:15.000000', 'temperatura', 694.0000, 'ºC'),
	(288736, 142, '2015-01-01 00:16:16.000000', 'temperatura', 225.0000, 'ºC'),
	(288737, 142, '2015-01-01 00:16:17.000000', 'temperatura', 243.0000, 'ºC'),
	(288738, 142, '2015-01-01 00:16:18.000000', 'temperatura', 541.0000, 'ºC'),
	(288739, 142, '2015-01-01 00:16:19.000000', 'temperatura', 777.0000, 'ºC'),
	(288740, 142, '2015-01-01 00:16:20.000000', 'temperatura', 1063.0000, 'ºC'),
	(288741, 142, '2015-01-01 00:16:21.000000', 'temperatura', 583.0000, 'ºC'),
	(288742, 142, '2015-01-01 00:16:22.000000', 'temperatura', 928.0000, 'ºC'),
	(288743, 142, '2015-01-01 00:16:23.000000', 'temperatura', 489.0000, 'ºC'),
	(288744, 142, '2015-01-01 00:16:24.000000', 'temperatura', 865.0000, 'ºC'),
	(288745, 142, '2015-01-01 00:16:25.000000', 'temperatura', 456.0000, 'ºC'),
	(288746, 142, '2015-01-01 00:16:26.000000', 'temperatura', 884.0000, 'ºC'),
	(288747, 142, '2015-01-01 00:16:27.000000', 'temperatura', 655.0000, 'ºC'),
	(288748, 142, '2015-01-01 00:16:28.000000', 'temperatura', 624.0000, 'ºC'),
	(288749, 142, '2015-01-01 00:16:29.000000', 'temperatura', 1155.0000, 'ºC'),
	(288750, 142, '2015-01-01 00:16:30.000000', 'temperatura', 303.0000, 'ºC'),
	(288751, 142, '2015-01-01 00:16:31.000000', 'temperatura', 450.0000, 'ºC'),
	(288752, 142, '2015-01-01 00:16:32.000000', 'temperatura', 144.0000, 'ºC'),
	(288753, 142, '2015-01-01 00:16:33.000000', 'temperatura', 568.0000, 'ºC'),
	(288754, 142, '2015-01-01 00:16:34.000000', 'temperatura', 9.0000, 'ºC'),
	(288755, 142, '2015-01-01 00:16:35.000000', 'temperatura', 741.0000, 'ºC'),
	(288756, 142, '2015-01-01 00:16:36.000000', 'temperatura', 77.0000, 'ºC'),
	(288757, 142, '2015-01-01 00:16:37.000000', 'temperatura', 564.0000, 'ºC'),
	(288758, 142, '2015-01-01 00:16:38.000000', 'temperatura', 191.0000, 'ºC'),
	(288759, 142, '2015-01-01 00:16:39.000000', 'temperatura', 464.0000, 'ºC'),
	(288760, 142, '2015-01-01 00:16:40.000000', 'temperatura', 547.0000, 'ºC'),
	(288761, 142, '2015-01-01 00:16:41.000000', 'temperatura', 143.0000, 'ºC'),
	(288762, 142, '2015-01-01 00:16:42.000000', 'temperatura', 275.0000, 'ºC'),
	(288763, 142, '2015-01-01 00:16:43.000000', 'temperatura', 946.0000, 'ºC'),
	(288764, 142, '2015-01-01 00:16:44.000000', 'temperatura', 304.0000, 'ºC'),
	(288765, 142, '2015-01-01 00:16:45.000000', 'temperatura', 1084.0000, 'ºC'),
	(288766, 142, '2015-01-01 00:16:46.000000', 'temperatura', 908.0000, 'ºC'),
	(288767, 142, '2015-01-01 00:16:47.000000', 'temperatura', 88.0000, 'ºC'),
	(288768, 142, '2015-01-01 00:16:48.000000', 'temperatura', 118.0000, 'ºC'),
	(288769, 142, '2015-01-01 00:16:49.000000', 'temperatura', 324.0000, 'ºC'),
	(288770, 142, '2015-01-01 00:16:50.000000', 'temperatura', 69.0000, 'ºC'),
	(288771, 142, '2015-01-01 00:16:51.000000', 'temperatura', 573.0000, 'ºC'),
	(288772, 142, '2015-01-01 00:16:52.000000', 'temperatura', 256.0000, 'ºC'),
	(288773, 142, '2015-01-01 00:16:53.000000', 'temperatura', 765.0000, 'ºC'),
	(288774, 142, '2015-01-01 00:16:54.000000', 'temperatura', 654.0000, 'ºC'),
	(288775, 142, '2015-01-01 00:16:55.000000', 'temperatura', 978.0000, 'ºC'),
	(288776, 142, '2015-01-01 00:16:56.000000', 'temperatura', 528.0000, 'ºC'),
	(288777, 142, '2015-01-01 00:16:57.000000', 'temperatura', 905.0000, 'ºC'),
	(288778, 142, '2015-01-01 00:16:58.000000', 'temperatura', 543.0000, 'ºC'),
	(288779, 142, '2015-01-01 00:16:59.000000', 'temperatura', 2.0000, 'ºC'),
	(288780, 142, '2015-01-01 00:17:00.000000', 'temperatura', 779.0000, 'ºC'),
	(288781, 142, '2015-01-01 00:17:01.000000', 'temperatura', 289.0000, 'ºC'),
	(288782, 142, '2015-01-01 00:17:02.000000', 'temperatura', 308.0000, 'ºC'),
	(288783, 142, '2015-01-01 00:17:03.000000', 'temperatura', 675.0000, 'ºC'),
	(288784, 142, '2015-01-01 00:17:04.000000', 'temperatura', 52.0000, 'ºC'),
	(288785, 142, '2015-01-01 00:17:05.000000', 'temperatura', 637.0000, 'ºC'),
	(288786, 142, '2015-01-01 00:17:06.000000', 'temperatura', 627.0000, 'ºC'),
	(288787, 142, '2015-01-01 00:17:07.000000', 'temperatura', 23.0000, 'ºC'),
	(288788, 142, '2015-01-01 00:17:08.000000', 'temperatura', 638.0000, 'ºC'),
	(288789, 142, '2015-01-01 00:17:09.000000', 'temperatura', 719.0000, 'ºC'),
	(288790, 142, '2015-01-01 00:17:10.000000', 'temperatura', 484.0000, 'ºC'),
	(288791, 142, '2015-01-01 00:17:11.000000', 'temperatura', 261.0000, 'ºC'),
	(288792, 142, '2015-01-01 00:17:12.000000', 'temperatura', 1052.0000, 'ºC'),
	(288793, 142, '2015-01-01 00:17:13.000000', 'temperatura', 881.0000, 'ºC'),
	(288794, 142, '2015-01-01 00:17:14.000000', 'temperatura', 47.0000, 'ºC'),
	(288795, 142, '2015-01-01 00:17:15.000000', 'temperatura', 1191.0000, 'ºC'),
	(288796, 142, '2015-01-01 00:17:16.000000', 'temperatura', 1018.0000, 'ºC'),
	(288797, 142, '2015-01-01 00:17:17.000000', 'temperatura', 315.0000, 'ºC'),
	(288798, 142, '2015-01-01 00:17:18.000000', 'temperatura', 924.0000, 'ºC'),
	(288799, 142, '2015-01-01 00:17:19.000000', 'temperatura', 75.0000, 'ºC'),
	(288800, 142, '2015-01-01 00:17:20.000000', 'temperatura', 3.0000, 'ºC'),
	(288801, 142, '2015-01-01 00:17:21.000000', 'temperatura', 991.0000, 'ºC'),
	(288802, 142, '2015-01-01 00:17:22.000000', 'temperatura', 145.0000, 'ºC'),
	(288803, 142, '2015-01-01 00:17:23.000000', 'temperatura', 153.0000, 'ºC'),
	(288804, 142, '2015-01-01 00:17:24.000000', 'temperatura', 331.0000, 'ºC'),
	(288805, 142, '2015-01-01 00:17:25.000000', 'temperatura', 1194.0000, 'ºC'),
	(288806, 142, '2015-01-01 00:17:26.000000', 'temperatura', 180.0000, 'ºC'),
	(288807, 142, '2015-01-01 00:17:27.000000', 'temperatura', 919.0000, 'ºC'),
	(288808, 142, '2015-01-01 00:17:28.000000', 'temperatura', 453.0000, 'ºC'),
	(288809, 142, '2015-01-01 00:17:29.000000', 'temperatura', 710.0000, 'ºC'),
	(288810, 142, '2015-01-01 00:17:30.000000', 'temperatura', 992.0000, 'ºC'),
	(288811, 142, '2015-01-01 00:17:31.000000', 'temperatura', 429.0000, 'ºC'),
	(288812, 142, '2015-01-01 00:17:32.000000', 'temperatura', 368.0000, 'ºC'),
	(288813, 142, '2015-01-01 00:17:33.000000', 'temperatura', 556.0000, 'ºC'),
	(288814, 142, '2015-01-01 00:17:34.000000', 'temperatura', 476.0000, 'ºC'),
	(288815, 142, '2015-01-01 00:17:35.000000', 'temperatura', 711.0000, 'ºC'),
	(288816, 142, '2015-01-01 00:17:36.000000', 'temperatura', 929.0000, 'ºC'),
	(288817, 142, '2015-01-01 00:17:37.000000', 'temperatura', 113.0000, 'ºC'),
	(288818, 142, '2015-01-01 00:17:38.000000', 'temperatura', 179.0000, 'ºC'),
	(288819, 142, '2015-01-01 00:17:39.000000', 'temperatura', 555.0000, 'ºC'),
	(288820, 142, '2015-01-01 00:17:40.000000', 'temperatura', 1038.0000, 'ºC'),
	(288821, 142, '2015-01-01 00:17:41.000000', 'temperatura', 1128.0000, 'ºC'),
	(288822, 142, '2015-01-01 00:17:42.000000', 'temperatura', 126.0000, 'ºC'),
	(288823, 142, '2015-01-01 00:17:43.000000', 'temperatura', 848.0000, 'ºC'),
	(288824, 142, '2015-01-01 00:17:44.000000', 'temperatura', 261.0000, 'ºC'),
	(288825, 142, '2015-01-01 00:17:45.000000', 'temperatura', 1160.0000, 'ºC'),
	(288826, 142, '2015-01-01 00:17:46.000000', 'temperatura', 219.0000, 'ºC'),
	(288827, 142, '2015-01-01 00:17:47.000000', 'temperatura', 15.0000, 'ºC'),
	(288828, 142, '2015-01-01 00:17:48.000000', 'temperatura', 619.0000, 'ºC'),
	(288829, 142, '2015-01-01 00:17:49.000000', 'temperatura', 648.0000, 'ºC'),
	(288830, 142, '2015-01-01 00:17:50.000000', 'temperatura', 186.0000, 'ºC'),
	(288831, 142, '2015-01-01 00:17:51.000000', 'temperatura', 186.0000, 'ºC'),
	(288832, 142, '2015-01-01 00:17:52.000000', 'temperatura', 373.0000, 'ºC'),
	(288833, 142, '2015-01-01 00:17:53.000000', 'temperatura', 106.0000, 'ºC'),
	(288834, 142, '2015-01-01 00:17:54.000000', 'temperatura', 614.0000, 'ºC'),
	(288835, 142, '2015-01-01 00:17:55.000000', 'temperatura', 351.0000, 'ºC'),
	(288836, 142, '2015-01-01 00:17:56.000000', 'temperatura', 1114.0000, 'ºC'),
	(288837, 142, '2015-01-01 00:17:57.000000', 'temperatura', 916.0000, 'ºC'),
	(288838, 142, '2015-01-01 00:17:58.000000', 'temperatura', 41.0000, 'ºC'),
	(288839, 142, '2015-01-01 00:17:59.000000', 'temperatura', 1057.0000, 'ºC'),
	(288840, 142, '2015-01-01 00:18:00.000000', 'temperatura', 361.0000, 'ºC'),
	(288841, 142, '2015-01-01 00:18:01.000000', 'temperatura', 1037.0000, 'ºC'),
	(288842, 142, '2015-01-01 00:18:02.000000', 'temperatura', 502.0000, 'ºC'),
	(288843, 142, '2015-01-01 00:18:03.000000', 'temperatura', 600.0000, 'ºC'),
	(288844, 142, '2015-01-01 00:18:04.000000', 'temperatura', 295.0000, 'ºC'),
	(288845, 142, '2015-01-01 00:18:05.000000', 'temperatura', 876.0000, 'ºC'),
	(288846, 142, '2015-01-01 00:18:06.000000', 'temperatura', 1094.0000, 'ºC'),
	(288847, 142, '2015-01-01 00:18:07.000000', 'temperatura', 442.0000, 'ºC'),
	(288848, 142, '2015-01-01 00:18:08.000000', 'temperatura', 127.0000, 'ºC'),
	(288849, 142, '2015-01-01 00:18:09.000000', 'temperatura', 511.0000, 'ºC'),
	(288850, 142, '2015-01-01 00:18:10.000000', 'temperatura', 976.0000, 'ºC'),
	(288851, 142, '2015-01-01 00:18:11.000000', 'temperatura', 947.0000, 'ºC'),
	(288852, 142, '2015-01-01 00:18:12.000000', 'temperatura', 608.0000, 'ºC'),
	(288853, 142, '2015-01-01 00:18:13.000000', 'temperatura', 198.0000, 'ºC'),
	(288854, 142, '2015-01-01 00:18:14.000000', 'temperatura', 365.0000, 'ºC'),
	(288855, 142, '2015-01-01 00:18:15.000000', 'temperatura', 34.0000, 'ºC'),
	(288856, 142, '2015-01-01 00:18:16.000000', 'temperatura', 276.0000, 'ºC'),
	(288857, 142, '2015-01-01 00:18:17.000000', 'temperatura', 78.0000, 'ºC'),
	(288858, 142, '2015-01-01 00:18:18.000000', 'temperatura', 762.0000, 'ºC'),
	(288859, 142, '2015-01-01 00:18:19.000000', 'temperatura', 1178.0000, 'ºC'),
	(288860, 142, '2015-01-01 00:18:20.000000', 'temperatura', 4.0000, 'ºC'),
	(288861, 142, '2015-01-01 00:18:21.000000', 'temperatura', 88.0000, 'ºC'),
	(288862, 142, '2015-01-01 00:18:22.000000', 'temperatura', 429.0000, 'ºC'),
	(288863, 142, '2015-01-01 00:18:23.000000', 'temperatura', 678.0000, 'ºC'),
	(288864, 142, '2015-01-01 00:18:24.000000', 'temperatura', 907.0000, 'ºC'),
	(288865, 142, '2015-01-01 00:18:25.000000', 'temperatura', 100.0000, 'ºC'),
	(288866, 142, '2015-01-01 00:18:26.000000', 'temperatura', 180.0000, 'ºC'),
	(288867, 142, '2015-01-01 00:18:27.000000', 'temperatura', 598.0000, 'ºC'),
	(288868, 142, '2015-01-01 00:18:28.000000', 'temperatura', 52.0000, 'ºC'),
	(288869, 142, '2015-01-01 00:18:29.000000', 'temperatura', 868.0000, 'ºC'),
	(288870, 142, '2015-01-01 00:18:30.000000', 'temperatura', 585.0000, 'ºC'),
	(288871, 142, '2015-01-01 00:18:31.000000', 'temperatura', 320.0000, 'ºC'),
	(288872, 142, '2015-01-01 00:18:32.000000', 'temperatura', 1045.0000, 'ºC'),
	(288873, 142, '2015-01-01 00:18:33.000000', 'temperatura', 665.0000, 'ºC'),
	(288874, 142, '2015-01-01 00:18:34.000000', 'temperatura', 190.0000, 'ºC'),
	(288875, 142, '2015-01-01 00:18:35.000000', 'temperatura', 156.0000, 'ºC'),
	(288876, 142, '2015-01-01 00:18:36.000000', 'temperatura', 211.0000, 'ºC'),
	(288877, 142, '2015-01-01 00:18:37.000000', 'temperatura', 587.0000, 'ºC'),
	(288878, 142, '2015-01-01 00:18:38.000000', 'temperatura', 1104.0000, 'ºC'),
	(288879, 142, '2015-01-01 00:18:39.000000', 'temperatura', 160.0000, 'ºC'),
	(288880, 142, '2015-01-01 00:18:40.000000', 'temperatura', 1087.0000, 'ºC'),
	(288881, 142, '2015-01-01 00:18:41.000000', 'temperatura', 155.0000, 'ºC'),
	(288882, 142, '2015-01-01 00:18:42.000000', 'temperatura', 1114.0000, 'ºC'),
	(288883, 142, '2015-01-01 00:18:43.000000', 'temperatura', 307.0000, 'ºC'),
	(288884, 142, '2015-01-01 00:18:44.000000', 'temperatura', 593.0000, 'ºC'),
	(288885, 142, '2015-01-01 00:18:45.000000', 'temperatura', 846.0000, 'ºC'),
	(288886, 142, '2015-01-01 00:18:46.000000', 'temperatura', 52.0000, 'ºC'),
	(288887, 142, '2015-01-01 00:18:47.000000', 'temperatura', 121.0000, 'ºC'),
	(288888, 142, '2015-01-01 00:18:48.000000', 'temperatura', 451.0000, 'ºC'),
	(288889, 142, '2015-01-01 00:18:49.000000', 'temperatura', 692.0000, 'ºC'),
	(288890, 142, '2015-01-01 00:18:50.000000', 'temperatura', 909.0000, 'ºC'),
	(288891, 142, '2015-01-01 00:18:51.000000', 'temperatura', 69.0000, 'ºC'),
	(288892, 142, '2015-01-01 00:18:52.000000', 'temperatura', 19.0000, 'ºC'),
	(288893, 142, '2015-01-01 00:18:53.000000', 'temperatura', 1087.0000, 'ºC'),
	(288894, 142, '2015-01-01 00:18:54.000000', 'temperatura', 579.0000, 'ºC'),
	(288895, 142, '2015-01-01 00:18:55.000000', 'temperatura', 834.0000, 'ºC'),
	(288896, 142, '2015-01-01 00:18:56.000000', 'temperatura', 34.0000, 'ºC'),
	(288897, 142, '2015-01-01 00:18:57.000000', 'temperatura', 68.0000, 'ºC'),
	(288898, 142, '2015-01-01 00:18:58.000000', 'temperatura', 238.0000, 'ºC'),
	(288899, 142, '2015-01-01 00:18:59.000000', 'temperatura', 988.0000, 'ºC'),
	(288900, 142, '2015-01-01 00:19:00.000000', 'temperatura', 624.0000, 'ºC'),
	(288901, 142, '2015-01-01 00:19:01.000000', 'temperatura', 157.0000, 'ºC'),
	(288902, 142, '2015-01-01 00:19:02.000000', 'temperatura', 113.0000, 'ºC'),
	(288903, 142, '2015-01-01 00:19:03.000000', 'temperatura', 94.0000, 'ºC'),
	(288904, 142, '2015-01-01 00:19:04.000000', 'temperatura', 131.0000, 'ºC'),
	(288905, 142, '2015-01-01 00:19:05.000000', 'temperatura', 376.0000, 'ºC'),
	(288906, 142, '2015-01-01 00:19:06.000000', 'temperatura', 284.0000, 'ºC'),
	(288907, 142, '2015-01-01 00:19:07.000000', 'temperatura', 296.0000, 'ºC'),
	(288908, 142, '2015-01-01 00:19:08.000000', 'temperatura', 629.0000, 'ºC'),
	(288909, 142, '2015-01-01 00:19:09.000000', 'temperatura', 1055.0000, 'ºC'),
	(288910, 142, '2015-01-01 00:19:10.000000', 'temperatura', 988.0000, 'ºC'),
	(288911, 142, '2015-01-01 00:19:11.000000', 'temperatura', 578.0000, 'ºC'),
	(288912, 142, '2015-01-01 00:19:12.000000', 'temperatura', 1124.0000, 'ºC'),
	(288913, 142, '2015-01-01 00:19:13.000000', 'temperatura', 287.0000, 'ºC'),
	(288914, 142, '2015-01-01 00:19:14.000000', 'temperatura', 465.0000, 'ºC'),
	(288915, 142, '2015-01-01 00:19:15.000000', 'temperatura', 263.0000, 'ºC'),
	(288916, 142, '2015-01-01 00:19:16.000000', 'temperatura', 1120.0000, 'ºC'),
	(288917, 142, '2015-01-01 00:19:17.000000', 'temperatura', 11.0000, 'ºC'),
	(288918, 142, '2015-01-01 00:19:18.000000', 'temperatura', 295.0000, 'ºC'),
	(288919, 142, '2015-01-01 00:19:19.000000', 'temperatura', 245.0000, 'ºC'),
	(288920, 142, '2015-01-01 00:19:20.000000', 'temperatura', 338.0000, 'ºC'),
	(288921, 142, '2015-01-01 00:19:21.000000', 'temperatura', 956.0000, 'ºC'),
	(288922, 142, '2015-01-01 00:19:22.000000', 'temperatura', 167.0000, 'ºC'),
	(288923, 142, '2015-01-01 00:19:23.000000', 'temperatura', 369.0000, 'ºC'),
	(288924, 142, '2015-01-01 00:19:24.000000', 'temperatura', 142.0000, 'ºC'),
	(288925, 142, '2015-01-01 00:19:25.000000', 'temperatura', 803.0000, 'ºC'),
	(288926, 142, '2015-01-01 00:19:26.000000', 'temperatura', 1192.0000, 'ºC'),
	(288927, 142, '2015-01-01 00:19:27.000000', 'temperatura', 1151.0000, 'ºC'),
	(288928, 142, '2015-01-01 00:19:28.000000', 'temperatura', 977.0000, 'ºC'),
	(288929, 142, '2015-01-01 00:19:29.000000', 'temperatura', 235.0000, 'ºC'),
	(288930, 142, '2015-01-01 00:19:30.000000', 'temperatura', 644.0000, 'ºC'),
	(288931, 142, '2015-01-01 00:19:31.000000', 'temperatura', 114.0000, 'ºC'),
	(288932, 142, '2015-01-01 00:19:32.000000', 'temperatura', 1038.0000, 'ºC'),
	(288933, 142, '2015-01-01 00:19:33.000000', 'temperatura', 48.0000, 'ºC'),
	(288934, 142, '2015-01-01 00:19:34.000000', 'temperatura', 726.0000, 'ºC'),
	(288935, 142, '2015-01-01 00:19:35.000000', 'temperatura', 1086.0000, 'ºC'),
	(288936, 142, '2015-01-01 00:19:36.000000', 'temperatura', 855.0000, 'ºC'),
	(288937, 142, '2015-01-01 00:19:37.000000', 'temperatura', 1016.0000, 'ºC'),
	(288938, 142, '2015-01-01 00:19:38.000000', 'temperatura', 116.0000, 'ºC'),
	(288939, 142, '2015-01-01 00:19:39.000000', 'temperatura', 1131.0000, 'ºC'),
	(288940, 142, '2015-01-01 00:19:40.000000', 'temperatura', 508.0000, 'ºC'),
	(288941, 142, '2015-01-01 00:19:41.000000', 'temperatura', 349.0000, 'ºC'),
	(288942, 142, '2015-01-01 00:19:42.000000', 'temperatura', 220.0000, 'ºC'),
	(288943, 142, '2015-01-01 00:19:43.000000', 'temperatura', 54.0000, 'ºC'),
	(288944, 142, '2015-01-01 00:19:44.000000', 'temperatura', 809.0000, 'ºC'),
	(288945, 142, '2015-01-01 00:19:45.000000', 'temperatura', 286.0000, 'ºC'),
	(288946, 142, '2015-01-01 00:19:46.000000', 'temperatura', 203.0000, 'ºC'),
	(288947, 142, '2015-01-01 00:19:47.000000', 'temperatura', 158.0000, 'ºC'),
	(288948, 142, '2015-01-01 00:19:48.000000', 'temperatura', 182.0000, 'ºC'),
	(288949, 142, '2015-01-01 00:19:49.000000', 'temperatura', 435.0000, 'ºC'),
	(288950, 142, '2015-01-01 00:19:50.000000', 'temperatura', 431.0000, 'ºC'),
	(288951, 142, '2015-01-01 00:19:51.000000', 'temperatura', 848.0000, 'ºC'),
	(288952, 142, '2015-01-01 00:19:52.000000', 'temperatura', 550.0000, 'ºC'),
	(288953, 142, '2015-01-01 00:19:53.000000', 'temperatura', 204.0000, 'ºC'),
	(288954, 142, '2015-01-01 00:19:54.000000', 'temperatura', 570.0000, 'ºC'),
	(288955, 142, '2015-01-01 00:19:55.000000', 'temperatura', 1038.0000, 'ºC'),
	(288956, 142, '2015-01-01 00:19:56.000000', 'temperatura', 1083.0000, 'ºC'),
	(288957, 142, '2015-01-01 00:19:57.000000', 'temperatura', 1102.0000, 'ºC'),
	(288958, 142, '2015-01-01 00:19:58.000000', 'temperatura', 1061.0000, 'ºC'),
	(288959, 142, '2015-01-01 00:19:59.000000', 'temperatura', 801.0000, 'ºC'),
	(288960, 142, '2015-01-01 00:20:00.000000', 'temperatura', 822.0000, 'ºC'),
	(288961, 142, '2015-01-01 00:20:01.000000', 'temperatura', 505.0000, 'ºC'),
	(288962, 142, '2015-01-01 00:20:02.000000', 'temperatura', 63.0000, 'ºC'),
	(288963, 142, '2015-01-01 00:20:03.000000', 'temperatura', 1197.0000, 'ºC'),
	(288964, 142, '2015-01-01 00:20:04.000000', 'temperatura', 998.0000, 'ºC'),
	(288965, 142, '2015-01-01 00:20:05.000000', 'temperatura', 200.0000, 'ºC'),
	(288966, 142, '2015-01-01 00:20:06.000000', 'temperatura', 405.0000, 'ºC'),
	(288967, 142, '2015-01-01 00:20:07.000000', 'temperatura', 226.0000, 'ºC'),
	(288968, 142, '2015-01-01 00:20:08.000000', 'temperatura', 1116.0000, 'ºC'),
	(288969, 142, '2015-01-01 00:20:09.000000', 'temperatura', 104.0000, 'ºC'),
	(288970, 142, '2015-01-01 00:20:10.000000', 'temperatura', 772.0000, 'ºC'),
	(288971, 142, '2015-01-01 00:20:11.000000', 'temperatura', 1147.0000, 'ºC'),
	(288972, 142, '2015-01-01 00:20:12.000000', 'temperatura', 1020.0000, 'ºC'),
	(288973, 142, '2015-01-01 00:20:13.000000', 'temperatura', 461.0000, 'ºC'),
	(288974, 142, '2015-01-01 00:20:14.000000', 'temperatura', 444.0000, 'ºC'),
	(288975, 142, '2015-01-01 00:20:15.000000', 'temperatura', 838.0000, 'ºC'),
	(288976, 142, '2015-01-01 00:20:16.000000', 'temperatura', 458.0000, 'ºC'),
	(288977, 142, '2015-01-01 00:20:17.000000', 'temperatura', 977.0000, 'ºC'),
	(288978, 142, '2015-01-01 00:20:18.000000', 'temperatura', 1113.0000, 'ºC'),
	(288979, 142, '2015-01-01 00:20:19.000000', 'temperatura', 234.0000, 'ºC'),
	(288980, 142, '2015-01-01 00:20:20.000000', 'temperatura', 232.0000, 'ºC'),
	(288981, 142, '2015-01-01 00:20:21.000000', 'temperatura', 460.0000, 'ºC'),
	(288982, 142, '2015-01-01 00:20:22.000000', 'temperatura', 401.0000, 'ºC'),
	(288983, 142, '2015-01-01 00:20:23.000000', 'temperatura', 627.0000, 'ºC'),
	(288984, 142, '2015-01-01 00:20:24.000000', 'temperatura', 731.0000, 'ºC'),
	(288985, 142, '2015-01-01 00:20:25.000000', 'temperatura', 577.0000, 'ºC'),
	(288986, 142, '2015-01-01 00:20:26.000000', 'temperatura', 693.0000, 'ºC'),
	(288987, 142, '2015-01-01 00:20:27.000000', 'temperatura', 533.0000, 'ºC'),
	(288988, 142, '2015-01-01 00:20:28.000000', 'temperatura', 588.0000, 'ºC'),
	(288989, 142, '2015-01-01 00:20:29.000000', 'temperatura', 139.0000, 'ºC'),
	(288990, 142, '2015-01-01 00:20:30.000000', 'temperatura', 131.0000, 'ºC'),
	(288991, 142, '2015-01-01 00:20:31.000000', 'temperatura', 241.0000, 'ºC'),
	(288992, 142, '2015-01-01 00:20:32.000000', 'temperatura', 813.0000, 'ºC'),
	(288993, 142, '2015-01-01 00:20:33.000000', 'temperatura', 940.0000, 'ºC'),
	(288994, 142, '2015-01-01 00:20:34.000000', 'temperatura', 1064.0000, 'ºC'),
	(288995, 142, '2015-01-01 00:20:35.000000', 'temperatura', 101.0000, 'ºC'),
	(288996, 142, '2015-01-01 00:20:36.000000', 'temperatura', 913.0000, 'ºC'),
	(288997, 142, '2015-01-01 00:20:37.000000', 'temperatura', 660.0000, 'ºC'),
	(288998, 142, '2015-01-01 00:20:38.000000', 'temperatura', 565.0000, 'ºC'),
	(288999, 142, '2015-01-01 00:20:39.000000', 'temperatura', 844.0000, 'ºC'),
	(289000, 142, '2015-01-01 00:20:40.000000', 'temperatura', 126.0000, 'ºC'),
	(289001, 142, '2015-01-01 00:20:41.000000', 'temperatura', 499.0000, 'ºC'),
	(289002, 142, '2015-01-01 00:20:42.000000', 'temperatura', 919.0000, 'ºC'),
	(289003, 142, '2015-01-01 00:20:43.000000', 'temperatura', 696.0000, 'ºC'),
	(289004, 142, '2015-01-01 00:20:44.000000', 'temperatura', 723.0000, 'ºC'),
	(289005, 142, '2015-01-01 00:20:45.000000', 'temperatura', 329.0000, 'ºC'),
	(289006, 142, '2015-01-01 00:20:46.000000', 'temperatura', 675.0000, 'ºC'),
	(289007, 142, '2015-01-01 00:20:47.000000', 'temperatura', 1188.0000, 'ºC'),
	(289008, 142, '2015-01-01 00:20:48.000000', 'temperatura', 318.0000, 'ºC'),
	(289009, 142, '2015-01-01 00:20:49.000000', 'temperatura', 426.0000, 'ºC'),
	(289010, 142, '2015-01-01 00:20:50.000000', 'temperatura', 1175.0000, 'ºC'),
	(289011, 142, '2015-01-01 00:20:51.000000', 'temperatura', 997.0000, 'ºC'),
	(289012, 142, '2015-01-01 00:20:52.000000', 'temperatura', 261.0000, 'ºC'),
	(289013, 142, '2015-01-01 00:20:53.000000', 'temperatura', 715.0000, 'ºC'),
	(289014, 142, '2015-01-01 00:20:54.000000', 'temperatura', 394.0000, 'ºC'),
	(289015, 142, '2015-01-01 00:20:55.000000', 'temperatura', 1023.0000, 'ºC'),
	(289016, 142, '2015-01-01 00:20:56.000000', 'temperatura', 336.0000, 'ºC'),
	(289017, 142, '2015-01-01 00:20:57.000000', 'temperatura', 1009.0000, 'ºC'),
	(289018, 142, '2015-01-01 00:20:58.000000', 'temperatura', 440.0000, 'ºC'),
	(289019, 142, '2015-01-01 00:20:59.000000', 'temperatura', 371.0000, 'ºC'),
	(289020, 142, '2015-01-01 00:21:00.000000', 'temperatura', 536.0000, 'ºC'),
	(289021, 142, '2015-01-01 00:21:01.000000', 'temperatura', 366.0000, 'ºC'),
	(289022, 142, '2015-01-01 00:21:02.000000', 'temperatura', 223.0000, 'ºC'),
	(289023, 142, '2015-01-01 00:21:03.000000', 'temperatura', 19.0000, 'ºC'),
	(289024, 142, '2015-01-01 00:21:04.000000', 'temperatura', 626.0000, 'ºC'),
	(289025, 142, '2015-01-01 00:21:05.000000', 'temperatura', 673.0000, 'ºC'),
	(289026, 142, '2015-01-01 00:21:06.000000', 'temperatura', 288.0000, 'ºC'),
	(289027, 142, '2015-01-01 00:21:07.000000', 'temperatura', 623.0000, 'ºC'),
	(289028, 142, '2015-01-01 00:21:08.000000', 'temperatura', 1050.0000, 'ºC'),
	(289029, 142, '2015-01-01 00:21:09.000000', 'temperatura', 980.0000, 'ºC'),
	(289030, 142, '2015-01-01 00:21:10.000000', 'temperatura', 551.0000, 'ºC'),
	(289031, 142, '2015-01-01 00:21:11.000000', 'temperatura', 1016.0000, 'ºC'),
	(289032, 142, '2015-01-01 00:21:12.000000', 'temperatura', 1026.0000, 'ºC'),
	(289033, 142, '2015-01-01 00:21:13.000000', 'temperatura', 886.0000, 'ºC'),
	(289034, 142, '2015-01-01 00:21:14.000000', 'temperatura', 149.0000, 'ºC'),
	(289035, 142, '2015-01-01 00:21:15.000000', 'temperatura', 491.0000, 'ºC'),
	(289036, 142, '2015-01-01 00:21:16.000000', 'temperatura', 805.0000, 'ºC'),
	(289037, 142, '2015-01-01 00:21:17.000000', 'temperatura', 155.0000, 'ºC'),
	(289038, 142, '2015-01-01 00:21:18.000000', 'temperatura', 760.0000, 'ºC'),
	(289039, 142, '2015-01-01 00:21:19.000000', 'temperatura', 937.0000, 'ºC'),
	(289040, 142, '2015-01-01 00:21:20.000000', 'temperatura', 6.0000, 'ºC'),
	(289041, 142, '2015-01-01 00:21:21.000000', 'temperatura', 819.0000, 'ºC'),
	(289042, 142, '2015-01-01 00:21:22.000000', 'temperatura', 476.0000, 'ºC'),
	(289043, 142, '2015-01-01 00:21:23.000000', 'temperatura', 1126.0000, 'ºC'),
	(289044, 142, '2015-01-01 00:21:24.000000', 'temperatura', 600.0000, 'ºC'),
	(289045, 142, '2015-01-01 00:21:25.000000', 'temperatura', 824.0000, 'ºC'),
	(289046, 142, '2015-01-01 00:21:26.000000', 'temperatura', 1121.0000, 'ºC'),
	(289047, 142, '2015-01-01 00:21:27.000000', 'temperatura', 735.0000, 'ºC'),
	(289048, 142, '2015-01-01 00:21:28.000000', 'temperatura', 311.0000, 'ºC'),
	(289049, 142, '2015-01-01 00:21:29.000000', 'temperatura', 550.0000, 'ºC'),
	(289050, 142, '2015-01-01 00:21:30.000000', 'temperatura', 618.0000, 'ºC'),
	(289051, 142, '2015-01-01 00:21:31.000000', 'temperatura', 239.0000, 'ºC'),
	(289052, 142, '2015-01-01 00:21:32.000000', 'temperatura', 541.0000, 'ºC'),
	(289053, 142, '2015-01-01 00:21:33.000000', 'temperatura', 788.0000, 'ºC'),
	(289054, 142, '2015-01-01 00:21:34.000000', 'temperatura', 1120.0000, 'ºC'),
	(289055, 142, '2015-01-01 00:21:35.000000', 'temperatura', 837.0000, 'ºC'),
	(289056, 142, '2015-01-01 00:21:36.000000', 'temperatura', 826.0000, 'ºC'),
	(289057, 142, '2015-01-01 00:21:37.000000', 'temperatura', 417.0000, 'ºC'),
	(289058, 142, '2015-01-01 00:21:38.000000', 'temperatura', 809.0000, 'ºC'),
	(289059, 142, '2015-01-01 00:21:39.000000', 'temperatura', 395.0000, 'ºC'),
	(289060, 142, '2015-01-01 00:21:40.000000', 'temperatura', 749.0000, 'ºC'),
	(289061, 142, '2015-01-01 00:21:41.000000', 'temperatura', 159.0000, 'ºC'),
	(289062, 142, '2015-01-01 00:21:42.000000', 'temperatura', 951.0000, 'ºC'),
	(289063, 142, '2015-01-01 00:21:43.000000', 'temperatura', 675.0000, 'ºC'),
	(289064, 142, '2015-01-01 00:21:44.000000', 'temperatura', 526.0000, 'ºC'),
	(289065, 142, '2015-01-01 00:21:45.000000', 'temperatura', 602.0000, 'ºC'),
	(289066, 142, '2015-01-01 00:21:46.000000', 'temperatura', 234.0000, 'ºC'),
	(289067, 142, '2015-01-01 00:21:47.000000', 'temperatura', 565.0000, 'ºC'),
	(289068, 142, '2015-01-01 00:21:48.000000', 'temperatura', 924.0000, 'ºC'),
	(289069, 142, '2015-01-01 00:21:49.000000', 'temperatura', 526.0000, 'ºC'),
	(289070, 142, '2015-01-01 00:21:50.000000', 'temperatura', 1059.0000, 'ºC'),
	(289071, 142, '2015-01-01 00:21:51.000000', 'temperatura', 117.0000, 'ºC'),
	(289072, 142, '2015-01-01 00:21:52.000000', 'temperatura', 1008.0000, 'ºC'),
	(289073, 142, '2015-01-01 00:21:53.000000', 'temperatura', 1091.0000, 'ºC'),
	(289074, 142, '2015-01-01 00:21:54.000000', 'temperatura', 31.0000, 'ºC'),
	(289075, 142, '2015-01-01 00:21:55.000000', 'temperatura', 482.0000, 'ºC'),
	(289076, 142, '2015-01-01 00:21:56.000000', 'temperatura', 1119.0000, 'ºC'),
	(289077, 142, '2015-01-01 00:21:57.000000', 'temperatura', 549.0000, 'ºC'),
	(289078, 142, '2015-01-01 00:21:58.000000', 'temperatura', 590.0000, 'ºC'),
	(289079, 142, '2015-01-01 00:21:59.000000', 'temperatura', 103.0000, 'ºC'),
	(289080, 142, '2015-01-01 00:22:00.000000', 'temperatura', 1146.0000, 'ºC'),
	(289081, 142, '2015-01-01 00:22:01.000000', 'temperatura', 619.0000, 'ºC'),
	(289082, 142, '2015-01-01 00:22:02.000000', 'temperatura', 857.0000, 'ºC'),
	(289083, 142, '2015-01-01 00:22:03.000000', 'temperatura', 31.0000, 'ºC'),
	(289084, 142, '2015-01-01 00:22:04.000000', 'temperatura', 1184.0000, 'ºC'),
	(289085, 142, '2015-01-01 00:22:05.000000', 'temperatura', 1027.0000, 'ºC'),
	(289086, 142, '2015-01-01 00:22:06.000000', 'temperatura', 383.0000, 'ºC'),
	(289087, 142, '2015-01-01 00:22:07.000000', 'temperatura', 34.0000, 'ºC'),
	(289088, 142, '2015-01-01 00:22:08.000000', 'temperatura', 223.0000, 'ºC'),
	(289089, 142, '2015-01-01 00:22:09.000000', 'temperatura', 1013.0000, 'ºC'),
	(289090, 142, '2015-01-01 00:22:10.000000', 'temperatura', 797.0000, 'ºC'),
	(289091, 142, '2015-01-01 00:22:11.000000', 'temperatura', 945.0000, 'ºC'),
	(289092, 142, '2015-01-01 00:22:12.000000', 'temperatura', 1137.0000, 'ºC'),
	(289093, 142, '2015-01-01 00:22:13.000000', 'temperatura', 448.0000, 'ºC'),
	(289094, 142, '2015-01-01 00:22:14.000000', 'temperatura', 31.0000, 'ºC'),
	(289095, 142, '2015-01-01 00:22:15.000000', 'temperatura', 11.0000, 'ºC'),
	(289096, 142, '2015-01-01 00:22:16.000000', 'temperatura', 1163.0000, 'ºC'),
	(289097, 142, '2015-01-01 00:22:17.000000', 'temperatura', 982.0000, 'ºC'),
	(289098, 142, '2015-01-01 00:22:18.000000', 'temperatura', 223.0000, 'ºC'),
	(289099, 142, '2015-01-01 00:22:19.000000', 'temperatura', 567.0000, 'ºC'),
	(289100, 142, '2015-01-01 00:22:20.000000', 'temperatura', 969.0000, 'ºC'),
	(289101, 142, '2015-01-01 00:22:21.000000', 'temperatura', 744.0000, 'ºC'),
	(289102, 142, '2015-01-01 00:22:22.000000', 'temperatura', 813.0000, 'ºC'),
	(289103, 142, '2015-01-01 00:22:23.000000', 'temperatura', 633.0000, 'ºC'),
	(289104, 142, '2015-01-01 00:22:24.000000', 'temperatura', 726.0000, 'ºC'),
	(289105, 142, '2015-01-01 00:22:25.000000', 'temperatura', 533.0000, 'ºC'),
	(289106, 142, '2015-01-01 00:22:26.000000', 'temperatura', 487.0000, 'ºC'),
	(289107, 142, '2015-01-01 00:22:27.000000', 'temperatura', 835.0000, 'ºC'),
	(289108, 142, '2015-01-01 00:22:28.000000', 'temperatura', 316.0000, 'ºC'),
	(289109, 142, '2015-01-01 00:22:29.000000', 'temperatura', 276.0000, 'ºC'),
	(289110, 142, '2015-01-01 00:22:30.000000', 'temperatura', 430.0000, 'ºC'),
	(289111, 142, '2015-01-01 00:22:31.000000', 'temperatura', 125.0000, 'ºC'),
	(289112, 142, '2015-01-01 00:22:32.000000', 'temperatura', 536.0000, 'ºC'),
	(289113, 142, '2015-01-01 00:22:33.000000', 'temperatura', 1104.0000, 'ºC'),
	(289114, 142, '2015-01-01 00:22:34.000000', 'temperatura', 313.0000, 'ºC'),
	(289115, 142, '2015-01-01 00:22:35.000000', 'temperatura', 655.0000, 'ºC'),
	(289116, 142, '2015-01-01 00:22:36.000000', 'temperatura', 1136.0000, 'ºC'),
	(289117, 142, '2015-01-01 00:22:37.000000', 'temperatura', 117.0000, 'ºC'),
	(289118, 142, '2015-01-01 00:22:38.000000', 'temperatura', 776.0000, 'ºC'),
	(289119, 142, '2015-01-01 00:22:39.000000', 'temperatura', 1130.0000, 'ºC'),
	(289120, 142, '2015-01-01 00:22:40.000000', 'temperatura', 920.0000, 'ºC'),
	(289121, 142, '2015-01-01 00:22:41.000000', 'temperatura', 14.0000, 'ºC'),
	(289122, 142, '2015-01-01 00:22:42.000000', 'temperatura', 909.0000, 'ºC'),
	(289123, 142, '2015-01-01 00:22:43.000000', 'temperatura', 904.0000, 'ºC'),
	(289124, 142, '2015-01-01 00:22:44.000000', 'temperatura', 593.0000, 'ºC'),
	(289125, 142, '2015-01-01 00:22:45.000000', 'temperatura', 254.0000, 'ºC'),
	(289126, 142, '2015-01-01 00:22:46.000000', 'temperatura', 690.0000, 'ºC'),
	(289127, 142, '2015-01-01 00:22:47.000000', 'temperatura', 290.0000, 'ºC'),
	(289128, 142, '2015-01-01 00:22:48.000000', 'temperatura', 582.0000, 'ºC'),
	(289129, 142, '2015-01-01 00:22:49.000000', 'temperatura', 838.0000, 'ºC'),
	(289130, 142, '2015-01-01 00:22:50.000000', 'temperatura', 45.0000, 'ºC'),
	(289131, 142, '2015-01-01 00:22:51.000000', 'temperatura', 112.0000, 'ºC'),
	(289132, 142, '2015-01-01 00:22:52.000000', 'temperatura', 425.0000, 'ºC'),
	(289133, 142, '2015-01-01 00:22:53.000000', 'temperatura', 590.0000, 'ºC'),
	(289134, 142, '2015-01-01 00:22:54.000000', 'temperatura', 477.0000, 'ºC'),
	(289135, 142, '2015-01-01 00:22:55.000000', 'temperatura', 612.0000, 'ºC'),
	(289136, 142, '2015-01-01 00:22:56.000000', 'temperatura', 433.0000, 'ºC'),
	(289137, 142, '2015-01-01 00:22:57.000000', 'temperatura', 328.0000, 'ºC'),
	(289138, 142, '2015-01-01 00:22:58.000000', 'temperatura', 342.0000, 'ºC'),
	(289139, 142, '2015-01-01 00:22:59.000000', 'temperatura', 725.0000, 'ºC'),
	(289140, 142, '2015-01-01 00:23:00.000000', 'temperatura', 201.0000, 'ºC'),
	(289141, 142, '2015-01-01 00:23:01.000000', 'temperatura', 30.0000, 'ºC'),
	(289142, 142, '2015-01-01 00:23:02.000000', 'temperatura', 746.0000, 'ºC'),
	(289143, 142, '2015-01-01 00:23:03.000000', 'temperatura', 41.0000, 'ºC'),
	(289144, 142, '2015-01-01 00:23:04.000000', 'temperatura', 367.0000, 'ºC'),
	(289145, 142, '2015-01-01 00:23:05.000000', 'temperatura', 513.0000, 'ºC'),
	(289146, 142, '2015-01-01 00:23:06.000000', 'temperatura', 266.0000, 'ºC'),
	(289147, 142, '2015-01-01 00:23:07.000000', 'temperatura', 992.0000, 'ºC'),
	(289148, 142, '2015-01-01 00:23:08.000000', 'temperatura', 560.0000, 'ºC'),
	(289149, 142, '2015-01-01 00:23:09.000000', 'temperatura', 1027.0000, 'ºC'),
	(289150, 142, '2015-01-01 00:23:10.000000', 'temperatura', 1055.0000, 'ºC'),
	(289151, 142, '2015-01-01 00:23:11.000000', 'temperatura', 994.0000, 'ºC'),
	(289152, 142, '2015-01-01 00:23:12.000000', 'temperatura', 607.0000, 'ºC'),
	(289153, 142, '2015-01-01 00:23:13.000000', 'temperatura', 54.0000, 'ºC'),
	(289154, 142, '2015-01-01 00:23:14.000000', 'temperatura', 848.0000, 'ºC'),
	(289155, 142, '2015-01-01 00:23:15.000000', 'temperatura', 479.0000, 'ºC'),
	(289156, 142, '2015-01-01 00:23:16.000000', 'temperatura', 1050.0000, 'ºC'),
	(289157, 142, '2015-01-01 00:23:17.000000', 'temperatura', 213.0000, 'ºC'),
	(289158, 142, '2015-01-01 00:23:18.000000', 'temperatura', 317.0000, 'ºC'),
	(289159, 142, '2015-01-01 00:23:19.000000', 'temperatura', 948.0000, 'ºC'),
	(289160, 142, '2015-01-01 00:23:20.000000', 'temperatura', 188.0000, 'ºC'),
	(289161, 142, '2015-01-01 00:23:21.000000', 'temperatura', 495.0000, 'ºC'),
	(289162, 142, '2015-01-01 00:23:22.000000', 'temperatura', 712.0000, 'ºC'),
	(289163, 142, '2015-01-01 00:23:23.000000', 'temperatura', 874.0000, 'ºC'),
	(289164, 142, '2015-01-01 00:23:24.000000', 'temperatura', 1037.0000, 'ºC'),
	(289165, 142, '2015-01-01 00:23:25.000000', 'temperatura', 163.0000, 'ºC'),
	(289166, 142, '2015-01-01 00:23:26.000000', 'temperatura', 102.0000, 'ºC'),
	(289167, 142, '2015-01-01 00:23:27.000000', 'temperatura', 24.0000, 'ºC'),
	(289168, 142, '2015-01-01 00:23:28.000000', 'temperatura', 1014.0000, 'ºC'),
	(289169, 142, '2015-01-01 00:23:29.000000', 'temperatura', 199.0000, 'ºC'),
	(289170, 142, '2015-01-01 00:23:30.000000', 'temperatura', 353.0000, 'ºC'),
	(289171, 142, '2015-01-01 00:23:31.000000', 'temperatura', 1170.0000, 'ºC'),
	(289172, 142, '2015-01-01 00:23:32.000000', 'temperatura', 1192.0000, 'ºC'),
	(289173, 142, '2015-01-01 00:23:33.000000', 'temperatura', 49.0000, 'ºC'),
	(289174, 142, '2015-01-01 00:23:34.000000', 'temperatura', 271.0000, 'ºC'),
	(289175, 142, '2015-01-01 00:23:35.000000', 'temperatura', 7.0000, 'ºC'),
	(289176, 142, '2015-01-01 00:23:36.000000', 'temperatura', 423.0000, 'ºC'),
	(289177, 142, '2015-01-01 00:23:37.000000', 'temperatura', 894.0000, 'ºC'),
	(289178, 142, '2015-01-01 00:23:38.000000', 'temperatura', 803.0000, 'ºC'),
	(289179, 142, '2015-01-01 00:23:39.000000', 'temperatura', 131.0000, 'ºC'),
	(289180, 142, '2015-01-01 00:23:40.000000', 'temperatura', 647.0000, 'ºC'),
	(289181, 142, '2015-01-01 00:23:41.000000', 'temperatura', 441.0000, 'ºC'),
	(289182, 142, '2015-01-01 00:23:42.000000', 'temperatura', 265.0000, 'ºC'),
	(289183, 142, '2015-01-01 00:23:43.000000', 'temperatura', 5.0000, 'ºC'),
	(289184, 142, '2015-01-01 00:23:44.000000', 'temperatura', 427.0000, 'ºC'),
	(289185, 142, '2015-01-01 00:23:45.000000', 'temperatura', 923.0000, 'ºC'),
	(289186, 142, '2015-01-01 00:23:46.000000', 'temperatura', 932.0000, 'ºC'),
	(289187, 142, '2015-01-01 00:23:47.000000', 'temperatura', 692.0000, 'ºC'),
	(289188, 142, '2015-01-01 00:23:48.000000', 'temperatura', 664.0000, 'ºC'),
	(289189, 142, '2015-01-01 00:23:49.000000', 'temperatura', 46.0000, 'ºC'),
	(289190, 142, '2015-01-01 00:23:50.000000', 'temperatura', 639.0000, 'ºC'),
	(289191, 142, '2015-01-01 00:23:51.000000', 'temperatura', 657.0000, 'ºC'),
	(289192, 142, '2015-01-01 00:23:52.000000', 'temperatura', 167.0000, 'ºC'),
	(289193, 142, '2015-01-01 00:23:53.000000', 'temperatura', 67.0000, 'ºC'),
	(289194, 142, '2015-01-01 00:23:54.000000', 'temperatura', 1033.0000, 'ºC'),
	(289195, 142, '2015-01-01 00:23:55.000000', 'temperatura', 164.0000, 'ºC'),
	(289196, 142, '2015-01-01 00:23:56.000000', 'temperatura', 123.0000, 'ºC'),
	(289197, 142, '2015-01-01 00:23:57.000000', 'temperatura', 123.0000, 'ºC'),
	(289198, 142, '2015-01-01 00:23:58.000000', 'temperatura', 245.0000, 'ºC'),
	(289199, 142, '2015-01-01 00:23:59.000000', 'temperatura', 857.0000, 'ºC'),
	(289200, 142, '2015-01-01 00:24:00.000000', 'temperatura', 1150.0000, 'ºC'),
	(289201, 142, '2015-01-01 00:24:01.000000', 'temperatura', 779.0000, 'ºC'),
	(289202, 142, '2015-01-01 00:24:02.000000', 'temperatura', 446.0000, 'ºC'),
	(289203, 142, '2015-01-01 00:24:03.000000', 'temperatura', 1095.0000, 'ºC'),
	(289204, 142, '2015-01-01 00:24:04.000000', 'temperatura', 538.0000, 'ºC'),
	(289205, 142, '2015-01-01 00:24:05.000000', 'temperatura', 603.0000, 'ºC'),
	(289206, 142, '2015-01-01 00:24:06.000000', 'temperatura', 202.0000, 'ºC'),
	(289207, 142, '2015-01-01 00:24:07.000000', 'temperatura', 402.0000, 'ºC'),
	(289208, 142, '2015-01-01 00:24:08.000000', 'temperatura', 203.0000, 'ºC'),
	(289209, 142, '2015-01-01 00:24:09.000000', 'temperatura', 1011.0000, 'ºC'),
	(289210, 142, '2015-01-01 00:24:10.000000', 'temperatura', 847.0000, 'ºC'),
	(289211, 142, '2015-01-01 00:24:11.000000', 'temperatura', 2.0000, 'ºC'),
	(289212, 142, '2015-01-01 00:24:12.000000', 'temperatura', 1070.0000, 'ºC'),
	(289213, 142, '2015-01-01 00:24:13.000000', 'temperatura', 543.0000, 'ºC'),
	(289214, 142, '2015-01-01 00:24:14.000000', 'temperatura', 706.0000, 'ºC'),
	(289215, 142, '2015-01-01 00:24:15.000000', 'temperatura', 702.0000, 'ºC'),
	(289216, 142, '2015-01-01 00:24:16.000000', 'temperatura', 193.0000, 'ºC'),
	(289217, 142, '2015-01-01 00:24:17.000000', 'temperatura', 61.0000, 'ºC'),
	(289218, 142, '2015-01-01 00:24:18.000000', 'temperatura', 925.0000, 'ºC'),
	(289219, 142, '2015-01-01 00:24:19.000000', 'temperatura', 842.0000, 'ºC'),
	(289220, 142, '2015-01-01 00:24:20.000000', 'temperatura', 235.0000, 'ºC'),
	(289221, 142, '2015-01-01 00:24:21.000000', 'temperatura', 1051.0000, 'ºC'),
	(289222, 142, '2015-01-01 00:24:22.000000', 'temperatura', 949.0000, 'ºC'),
	(289223, 142, '2015-01-01 00:24:23.000000', 'temperatura', 393.0000, 'ºC'),
	(289224, 142, '2015-01-01 00:24:24.000000', 'temperatura', 318.0000, 'ºC'),
	(289225, 142, '2015-01-01 00:24:25.000000', 'temperatura', 412.0000, 'ºC'),
	(289226, 142, '2015-01-01 00:24:26.000000', 'temperatura', 1107.0000, 'ºC'),
	(289227, 142, '2015-01-01 00:24:27.000000', 'temperatura', 697.0000, 'ºC'),
	(289228, 142, '2015-01-01 00:24:28.000000', 'temperatura', 168.0000, 'ºC'),
	(289229, 142, '2015-01-01 00:24:29.000000', 'temperatura', 1147.0000, 'ºC'),
	(289230, 142, '2015-01-01 00:24:30.000000', 'temperatura', 432.0000, 'ºC'),
	(289231, 142, '2015-01-01 00:24:31.000000', 'temperatura', 1118.0000, 'ºC'),
	(289232, 142, '2015-01-01 00:24:32.000000', 'temperatura', 694.0000, 'ºC'),
	(289233, 142, '2015-01-01 00:24:33.000000', 'temperatura', 120.0000, 'ºC'),
	(289234, 142, '2015-01-01 00:24:34.000000', 'temperatura', 916.0000, 'ºC'),
	(289235, 142, '2015-01-01 00:24:35.000000', 'temperatura', 620.0000, 'ºC'),
	(289236, 142, '2015-01-01 00:24:36.000000', 'temperatura', 354.0000, 'ºC'),
	(289237, 142, '2015-01-01 00:24:37.000000', 'temperatura', 1112.0000, 'ºC'),
	(289238, 142, '2015-01-01 00:24:38.000000', 'temperatura', 896.0000, 'ºC'),
	(289239, 142, '2015-01-01 00:24:39.000000', 'temperatura', 1146.0000, 'ºC'),
	(289240, 142, '2015-01-01 00:24:40.000000', 'temperatura', 640.0000, 'ºC'),
	(289241, 142, '2015-01-01 00:24:41.000000', 'temperatura', 964.0000, 'ºC'),
	(289242, 142, '2015-01-01 00:24:42.000000', 'temperatura', 501.0000, 'ºC'),
	(289243, 142, '2015-01-01 00:24:43.000000', 'temperatura', 813.0000, 'ºC'),
	(289244, 142, '2015-01-01 00:24:44.000000', 'temperatura', 163.0000, 'ºC'),
	(289245, 142, '2015-01-01 00:24:45.000000', 'temperatura', 777.0000, 'ºC'),
	(289246, 142, '2015-01-01 00:24:46.000000', 'temperatura', 995.0000, 'ºC'),
	(289247, 142, '2015-01-01 00:24:47.000000', 'temperatura', 245.0000, 'ºC'),
	(289248, 142, '2015-01-01 00:24:48.000000', 'temperatura', 642.0000, 'ºC'),
	(289249, 142, '2015-01-01 00:24:49.000000', 'temperatura', 75.0000, 'ºC'),
	(289250, 142, '2015-01-01 00:24:50.000000', 'temperatura', 847.0000, 'ºC'),
	(289251, 142, '2015-01-01 00:24:51.000000', 'temperatura', 414.0000, 'ºC'),
	(289252, 142, '2015-01-01 00:24:52.000000', 'temperatura', 726.0000, 'ºC'),
	(289253, 142, '2015-01-01 00:24:53.000000', 'temperatura', 1192.0000, 'ºC'),
	(289254, 142, '2015-01-01 00:24:54.000000', 'temperatura', 180.0000, 'ºC'),
	(289255, 142, '2015-01-01 00:24:55.000000', 'temperatura', 926.0000, 'ºC'),
	(289256, 142, '2015-01-01 00:24:56.000000', 'temperatura', 491.0000, 'ºC'),
	(289257, 142, '2015-01-01 00:24:57.000000', 'temperatura', 875.0000, 'ºC'),
	(289258, 142, '2015-01-01 00:24:58.000000', 'temperatura', 503.0000, 'ºC'),
	(289259, 142, '2015-01-01 00:24:59.000000', 'temperatura', 1092.0000, 'ºC'),
	(289260, 142, '2015-01-01 00:25:00.000000', 'temperatura', 352.0000, 'ºC'),
	(289261, 142, '2015-01-01 00:25:01.000000', 'temperatura', 883.0000, 'ºC'),
	(289262, 142, '2015-01-01 00:25:02.000000', 'temperatura', 961.0000, 'ºC'),
	(289263, 142, '2015-01-01 00:25:03.000000', 'temperatura', 954.0000, 'ºC'),
	(289264, 142, '2015-01-01 00:25:04.000000', 'temperatura', 690.0000, 'ºC'),
	(289265, 142, '2015-01-01 00:25:05.000000', 'temperatura', 588.0000, 'ºC'),
	(289266, 142, '2015-01-01 00:25:06.000000', 'temperatura', 872.0000, 'ºC'),
	(289267, 142, '2015-01-01 00:25:07.000000', 'temperatura', 195.0000, 'ºC'),
	(289268, 142, '2015-01-01 00:25:08.000000', 'temperatura', 759.0000, 'ºC'),
	(289269, 142, '2015-01-01 00:25:09.000000', 'temperatura', 810.0000, 'ºC'),
	(289270, 142, '2015-01-01 00:25:10.000000', 'temperatura', 576.0000, 'ºC'),
	(289271, 142, '2015-01-01 00:25:11.000000', 'temperatura', 450.0000, 'ºC'),
	(289272, 142, '2015-01-01 00:25:12.000000', 'temperatura', 524.0000, 'ºC'),
	(289273, 142, '2015-01-01 00:25:13.000000', 'temperatura', 68.0000, 'ºC'),
	(289274, 142, '2015-01-01 00:25:14.000000', 'temperatura', 1171.0000, 'ºC'),
	(289275, 142, '2015-01-01 00:25:15.000000', 'temperatura', 851.0000, 'ºC'),
	(289276, 142, '2015-01-01 00:25:16.000000', 'temperatura', 744.0000, 'ºC'),
	(289277, 142, '2015-01-01 00:25:17.000000', 'temperatura', 1165.0000, 'ºC'),
	(289278, 142, '2015-01-01 00:25:18.000000', 'temperatura', 1192.0000, 'ºC'),
	(289279, 142, '2015-01-01 00:25:19.000000', 'temperatura', 68.0000, 'ºC'),
	(289280, 142, '2015-01-01 00:25:20.000000', 'temperatura', 362.0000, 'ºC'),
	(289281, 142, '2015-01-01 00:25:21.000000', 'temperatura', 410.0000, 'ºC'),
	(289282, 142, '2015-01-01 00:25:22.000000', 'temperatura', 961.0000, 'ºC'),
	(289283, 142, '2015-01-01 00:25:23.000000', 'temperatura', 1177.0000, 'ºC'),
	(289284, 142, '2015-01-01 00:25:24.000000', 'temperatura', 602.0000, 'ºC'),
	(289285, 142, '2015-01-01 00:25:25.000000', 'temperatura', 682.0000, 'ºC'),
	(289286, 142, '2015-01-01 00:25:26.000000', 'temperatura', 403.0000, 'ºC'),
	(289287, 142, '2015-01-01 00:25:27.000000', 'temperatura', 1168.0000, 'ºC'),
	(289288, 142, '2015-01-01 00:25:28.000000', 'temperatura', 1033.0000, 'ºC'),
	(289289, 142, '2015-01-01 00:25:29.000000', 'temperatura', 460.0000, 'ºC'),
	(289290, 142, '2015-01-01 00:25:30.000000', 'temperatura', 403.0000, 'ºC'),
	(289291, 142, '2015-01-01 00:25:31.000000', 'temperatura', 635.0000, 'ºC'),
	(289292, 142, '2015-01-01 00:25:32.000000', 'temperatura', 767.0000, 'ºC'),
	(289293, 142, '2015-01-01 00:25:33.000000', 'temperatura', 731.0000, 'ºC'),
	(289294, 142, '2015-01-01 00:25:34.000000', 'temperatura', 155.0000, 'ºC'),
	(289295, 142, '2015-01-01 00:25:35.000000', 'temperatura', 982.0000, 'ºC'),
	(289296, 142, '2015-01-01 00:25:36.000000', 'temperatura', 845.0000, 'ºC'),
	(289297, 142, '2015-01-01 00:25:37.000000', 'temperatura', 80.0000, 'ºC'),
	(289298, 142, '2015-01-01 00:25:38.000000', 'temperatura', 266.0000, 'ºC'),
	(289299, 142, '2015-01-01 00:25:39.000000', 'temperatura', 1092.0000, 'ºC'),
	(289300, 142, '2015-01-01 00:25:40.000000', 'temperatura', 1059.0000, 'ºC'),
	(289301, 142, '2015-01-01 00:25:41.000000', 'temperatura', 822.0000, 'ºC'),
	(289302, 142, '2015-01-01 00:25:42.000000', 'temperatura', 933.0000, 'ºC'),
	(289303, 142, '2015-01-01 00:25:43.000000', 'temperatura', 1000.0000, 'ºC'),
	(289304, 142, '2015-01-01 00:25:44.000000', 'temperatura', 1002.0000, 'ºC'),
	(289305, 142, '2015-01-01 00:25:45.000000', 'temperatura', 809.0000, 'ºC'),
	(289306, 142, '2015-01-01 00:25:46.000000', 'temperatura', 1042.0000, 'ºC'),
	(289307, 142, '2015-01-01 00:25:47.000000', 'temperatura', 382.0000, 'ºC'),
	(289308, 142, '2015-01-01 00:25:48.000000', 'temperatura', 1186.0000, 'ºC'),
	(289309, 142, '2015-01-01 00:25:49.000000', 'temperatura', 1182.0000, 'ºC'),
	(289310, 142, '2015-01-01 00:25:50.000000', 'temperatura', 1153.0000, 'ºC'),
	(289311, 142, '2015-01-01 00:25:51.000000', 'temperatura', 1021.0000, 'ºC'),
	(289312, 142, '2015-01-01 00:25:52.000000', 'temperatura', 448.0000, 'ºC'),
	(289313, 142, '2015-01-01 00:25:53.000000', 'temperatura', 375.0000, 'ºC'),
	(289314, 142, '2015-01-01 00:25:54.000000', 'temperatura', 530.0000, 'ºC'),
	(289315, 142, '2015-01-01 00:25:55.000000', 'temperatura', 329.0000, 'ºC'),
	(289316, 142, '2015-01-01 00:25:56.000000', 'temperatura', 53.0000, 'ºC'),
	(289317, 142, '2015-01-01 00:25:57.000000', 'temperatura', 480.0000, 'ºC'),
	(289318, 142, '2015-01-01 00:25:58.000000', 'temperatura', 1041.0000, 'ºC'),
	(289319, 142, '2015-01-01 00:25:59.000000', 'temperatura', 166.0000, 'ºC'),
	(289320, 142, '2015-01-01 00:26:00.000000', 'temperatura', 106.0000, 'ºC'),
	(289321, 142, '2015-01-01 00:26:01.000000', 'temperatura', 32.0000, 'ºC'),
	(289322, 142, '2015-01-01 00:26:02.000000', 'temperatura', 1042.0000, 'ºC'),
	(289323, 142, '2015-01-01 00:26:03.000000', 'temperatura', 318.0000, 'ºC'),
	(289324, 142, '2015-01-01 00:26:04.000000', 'temperatura', 861.0000, 'ºC'),
	(289325, 142, '2015-01-01 00:26:05.000000', 'temperatura', 953.0000, 'ºC'),
	(289326, 142, '2015-01-01 00:26:06.000000', 'temperatura', 981.0000, 'ºC'),
	(289327, 142, '2015-01-01 00:26:07.000000', 'temperatura', 846.0000, 'ºC'),
	(289328, 142, '2015-01-01 00:26:08.000000', 'temperatura', 90.0000, 'ºC'),
	(289329, 142, '2015-01-01 00:26:09.000000', 'temperatura', 311.0000, 'ºC'),
	(289330, 142, '2015-01-01 00:26:10.000000', 'temperatura', 84.0000, 'ºC'),
	(289331, 142, '2015-01-01 00:26:11.000000', 'temperatura', 689.0000, 'ºC'),
	(289332, 142, '2015-01-01 00:26:12.000000', 'temperatura', 791.0000, 'ºC'),
	(289333, 142, '2015-01-01 00:26:13.000000', 'temperatura', 691.0000, 'ºC'),
	(289334, 142, '2015-01-01 00:26:14.000000', 'temperatura', 1084.0000, 'ºC'),
	(289335, 142, '2015-01-01 00:26:15.000000', 'temperatura', 945.0000, 'ºC'),
	(289336, 142, '2015-01-01 00:26:16.000000', 'temperatura', 273.0000, 'ºC'),
	(289337, 142, '2015-01-01 00:26:17.000000', 'temperatura', 929.0000, 'ºC'),
	(289338, 142, '2015-01-01 00:26:18.000000', 'temperatura', 230.0000, 'ºC'),
	(289339, 142, '2015-01-01 00:26:19.000000', 'temperatura', 763.0000, 'ºC'),
	(289340, 142, '2015-01-01 00:26:20.000000', 'temperatura', 726.0000, 'ºC'),
	(289341, 142, '2015-01-01 00:26:21.000000', 'temperatura', 143.0000, 'ºC'),
	(289342, 142, '2015-01-01 00:26:22.000000', 'temperatura', 934.0000, 'ºC'),
	(289343, 142, '2015-01-01 00:26:23.000000', 'temperatura', 645.0000, 'ºC'),
	(289344, 142, '2015-01-01 00:26:24.000000', 'temperatura', 422.0000, 'ºC'),
	(289345, 142, '2015-01-01 00:26:25.000000', 'temperatura', 175.0000, 'ºC'),
	(289346, 142, '2015-01-01 00:26:26.000000', 'temperatura', 810.0000, 'ºC'),
	(289347, 142, '2015-01-01 00:26:27.000000', 'temperatura', 1126.0000, 'ºC'),
	(289348, 142, '2015-01-01 00:26:28.000000', 'temperatura', 801.0000, 'ºC'),
	(289349, 142, '2015-01-01 00:26:29.000000', 'temperatura', 627.0000, 'ºC'),
	(289350, 142, '2015-01-01 00:26:30.000000', 'temperatura', 730.0000, 'ºC'),
	(289351, 142, '2015-01-01 00:26:31.000000', 'temperatura', 572.0000, 'ºC'),
	(289352, 142, '2015-01-01 00:26:32.000000', 'temperatura', 671.0000, 'ºC'),
	(289353, 142, '2015-01-01 00:26:33.000000', 'temperatura', 440.0000, 'ºC'),
	(289354, 142, '2015-01-01 00:26:34.000000', 'temperatura', 187.0000, 'ºC'),
	(289355, 142, '2015-01-01 00:26:35.000000', 'temperatura', 816.0000, 'ºC'),
	(289356, 142, '2015-01-01 00:26:36.000000', 'temperatura', 1120.0000, 'ºC'),
	(289357, 142, '2015-01-01 00:26:37.000000', 'temperatura', 752.0000, 'ºC'),
	(289358, 142, '2015-01-01 00:26:38.000000', 'temperatura', 399.0000, 'ºC'),
	(289359, 142, '2015-01-01 00:26:39.000000', 'temperatura', 940.0000, 'ºC'),
	(289360, 142, '2015-01-01 00:26:40.000000', 'temperatura', 1103.0000, 'ºC'),
	(289361, 142, '2015-01-01 00:26:41.000000', 'temperatura', 295.0000, 'ºC'),
	(289362, 142, '2015-01-01 00:26:42.000000', 'temperatura', 569.0000, 'ºC'),
	(289363, 142, '2015-01-01 00:26:43.000000', 'temperatura', 759.0000, 'ºC'),
	(289364, 142, '2015-01-01 00:26:44.000000', 'temperatura', 890.0000, 'ºC'),
	(289365, 142, '2015-01-01 00:26:45.000000', 'temperatura', 971.0000, 'ºC'),
	(289366, 142, '2015-01-01 00:26:46.000000', 'temperatura', 985.0000, 'ºC'),
	(289367, 142, '2015-01-01 00:26:47.000000', 'temperatura', 814.0000, 'ºC'),
	(289368, 142, '2015-01-01 00:26:48.000000', 'temperatura', 1115.0000, 'ºC'),
	(289369, 142, '2015-01-01 00:26:49.000000', 'temperatura', 734.0000, 'ºC'),
	(289370, 142, '2015-01-01 00:26:50.000000', 'temperatura', 323.0000, 'ºC'),
	(289371, 142, '2015-01-01 00:26:51.000000', 'temperatura', 617.0000, 'ºC'),
	(289372, 142, '2015-01-01 00:26:52.000000', 'temperatura', 915.0000, 'ºC'),
	(289373, 142, '2015-01-01 00:26:53.000000', 'temperatura', 323.0000, 'ºC'),
	(289374, 142, '2015-01-01 00:26:54.000000', 'temperatura', 70.0000, 'ºC'),
	(289375, 142, '2015-01-01 00:26:55.000000', 'temperatura', 582.0000, 'ºC'),
	(289376, 142, '2015-01-01 00:26:56.000000', 'temperatura', 302.0000, 'ºC'),
	(289377, 142, '2015-01-01 00:26:57.000000', 'temperatura', 964.0000, 'ºC'),
	(289378, 142, '2015-01-01 00:26:58.000000', 'temperatura', 313.0000, 'ºC'),
	(289379, 142, '2015-01-01 00:26:59.000000', 'temperatura', 1077.0000, 'ºC'),
	(289380, 142, '2015-01-01 00:27:00.000000', 'temperatura', 843.0000, 'ºC'),
	(289381, 142, '2015-01-01 00:27:01.000000', 'temperatura', 984.0000, 'ºC'),
	(289382, 142, '2015-01-01 00:27:02.000000', 'temperatura', 1195.0000, 'ºC'),
	(289383, 142, '2015-01-01 00:27:03.000000', 'temperatura', 621.0000, 'ºC'),
	(289384, 142, '2015-01-01 00:27:04.000000', 'temperatura', 721.0000, 'ºC'),
	(289385, 142, '2015-01-01 00:27:05.000000', 'temperatura', 543.0000, 'ºC'),
	(289386, 142, '2015-01-01 00:27:06.000000', 'temperatura', 552.0000, 'ºC'),
	(289387, 142, '2015-01-01 00:27:07.000000', 'temperatura', 1132.0000, 'ºC'),
	(289388, 142, '2015-01-01 00:27:08.000000', 'temperatura', 403.0000, 'ºC'),
	(289389, 142, '2015-01-01 00:27:09.000000', 'temperatura', 1019.0000, 'ºC'),
	(289390, 142, '2015-01-01 00:27:10.000000', 'temperatura', 290.0000, 'ºC'),
	(289391, 142, '2015-01-01 00:27:11.000000', 'temperatura', 790.0000, 'ºC'),
	(289392, 142, '2015-01-01 00:27:12.000000', 'temperatura', 681.0000, 'ºC'),
	(289393, 142, '2015-01-01 00:27:13.000000', 'temperatura', 1035.0000, 'ºC'),
	(289394, 142, '2015-01-01 00:27:14.000000', 'temperatura', 732.0000, 'ºC'),
	(289395, 142, '2015-01-01 00:27:15.000000', 'temperatura', 557.0000, 'ºC'),
	(289396, 142, '2015-01-01 00:27:16.000000', 'temperatura', 590.0000, 'ºC'),
	(289397, 142, '2015-01-01 00:27:17.000000', 'temperatura', 80.0000, 'ºC'),
	(289398, 142, '2015-01-01 00:27:18.000000', 'temperatura', 1029.0000, 'ºC'),
	(289399, 142, '2015-01-01 00:27:19.000000', 'temperatura', 105.0000, 'ºC'),
	(289400, 142, '2015-01-01 00:27:20.000000', 'temperatura', 1041.0000, 'ºC'),
	(289401, 142, '2015-01-01 00:27:21.000000', 'temperatura', 90.0000, 'ºC'),
	(289402, 142, '2015-01-01 00:27:22.000000', 'temperatura', 926.0000, 'ºC'),
	(289403, 142, '2015-01-01 00:27:23.000000', 'temperatura', 762.0000, 'ºC'),
	(289404, 142, '2015-01-01 00:27:24.000000', 'temperatura', 1030.0000, 'ºC'),
	(289405, 142, '2015-01-01 00:27:25.000000', 'temperatura', 467.0000, 'ºC'),
	(289406, 142, '2015-01-01 00:27:26.000000', 'temperatura', 445.0000, 'ºC'),
	(289407, 142, '2015-01-01 00:27:27.000000', 'temperatura', 823.0000, 'ºC'),
	(289408, 142, '2015-01-01 00:27:28.000000', 'temperatura', 380.0000, 'ºC'),
	(289409, 142, '2015-01-01 00:27:29.000000', 'temperatura', 632.0000, 'ºC'),
	(289410, 142, '2015-01-01 00:27:30.000000', 'temperatura', 819.0000, 'ºC'),
	(289411, 142, '2015-01-01 00:27:31.000000', 'temperatura', 1000.0000, 'ºC'),
	(289412, 142, '2015-01-01 00:27:32.000000', 'temperatura', 146.0000, 'ºC'),
	(289413, 142, '2015-01-01 00:27:33.000000', 'temperatura', 127.0000, 'ºC'),
	(289414, 142, '2015-01-01 00:27:34.000000', 'temperatura', 200.0000, 'ºC'),
	(289415, 142, '2015-01-01 00:27:35.000000', 'temperatura', 621.0000, 'ºC'),
	(289416, 142, '2015-01-01 00:27:36.000000', 'temperatura', 103.0000, 'ºC'),
	(289417, 142, '2015-01-01 00:27:37.000000', 'temperatura', 1052.0000, 'ºC'),
	(289418, 142, '2015-01-01 00:27:38.000000', 'temperatura', 154.0000, 'ºC'),
	(289419, 142, '2015-01-01 00:27:39.000000', 'temperatura', 13.0000, 'ºC'),
	(289420, 142, '2015-01-01 00:27:40.000000', 'temperatura', 805.0000, 'ºC'),
	(289421, 142, '2015-01-01 00:27:41.000000', 'temperatura', 387.0000, 'ºC'),
	(289422, 142, '2015-01-01 00:27:42.000000', 'temperatura', 721.0000, 'ºC'),
	(289423, 142, '2015-01-01 00:27:43.000000', 'temperatura', 43.0000, 'ºC'),
	(289424, 142, '2015-01-01 00:27:44.000000', 'temperatura', 454.0000, 'ºC'),
	(289425, 142, '2015-01-01 00:27:45.000000', 'temperatura', 940.0000, 'ºC'),
	(289426, 142, '2015-01-01 00:27:46.000000', 'temperatura', 938.0000, 'ºC'),
	(289427, 142, '2015-01-01 00:27:47.000000', 'temperatura', 671.0000, 'ºC'),
	(289428, 142, '2015-01-01 00:27:48.000000', 'temperatura', 540.0000, 'ºC'),
	(289429, 142, '2015-01-01 00:27:49.000000', 'temperatura', 690.0000, 'ºC'),
	(289430, 142, '2015-01-01 00:27:50.000000', 'temperatura', 628.0000, 'ºC'),
	(289431, 142, '2015-01-01 00:27:51.000000', 'temperatura', 1071.0000, 'ºC'),
	(289432, 142, '2015-01-01 00:27:52.000000', 'temperatura', 1074.0000, 'ºC'),
	(289433, 142, '2015-01-01 00:27:53.000000', 'temperatura', 954.0000, 'ºC'),
	(289434, 142, '2015-01-01 00:27:54.000000', 'temperatura', 352.0000, 'ºC'),
	(289435, 142, '2015-01-01 00:27:55.000000', 'temperatura', 97.0000, 'ºC'),
	(289436, 142, '2015-01-01 00:27:56.000000', 'temperatura', 628.0000, 'ºC'),
	(289437, 142, '2015-01-01 00:27:57.000000', 'temperatura', 450.0000, 'ºC'),
	(289438, 142, '2015-01-01 00:27:58.000000', 'temperatura', 367.0000, 'ºC'),
	(289439, 142, '2015-01-01 00:27:59.000000', 'temperatura', 485.0000, 'ºC'),
	(289440, 142, '2015-01-01 00:28:00.000000', 'temperatura', 124.0000, 'ºC'),
	(289441, 142, '2015-01-01 00:28:01.000000', 'temperatura', 366.0000, 'ºC'),
	(289442, 142, '2015-01-01 00:28:02.000000', 'temperatura', 260.0000, 'ºC'),
	(289443, 142, '2015-01-01 00:28:03.000000', 'temperatura', 201.0000, 'ºC'),
	(289444, 142, '2015-01-01 00:28:04.000000', 'temperatura', 228.0000, 'ºC'),
	(289445, 142, '2015-01-01 00:28:05.000000', 'temperatura', 535.0000, 'ºC'),
	(289446, 142, '2015-01-01 00:28:06.000000', 'temperatura', 790.0000, 'ºC'),
	(289447, 142, '2015-01-01 00:28:07.000000', 'temperatura', 1147.0000, 'ºC'),
	(289448, 142, '2015-01-01 00:28:08.000000', 'temperatura', 967.0000, 'ºC'),
	(289449, 142, '2015-01-01 00:28:09.000000', 'temperatura', 194.0000, 'ºC'),
	(289450, 142, '2015-01-01 00:28:10.000000', 'temperatura', 468.0000, 'ºC'),
	(289451, 142, '2015-01-01 00:28:11.000000', 'temperatura', 559.0000, 'ºC'),
	(289452, 142, '2015-01-01 00:28:12.000000', 'temperatura', 192.0000, 'ºC'),
	(289453, 142, '2015-01-01 00:28:13.000000', 'temperatura', 483.0000, 'ºC'),
	(289454, 142, '2015-01-01 00:28:14.000000', 'temperatura', 640.0000, 'ºC'),
	(289455, 142, '2015-01-01 00:28:15.000000', 'temperatura', 551.0000, 'ºC'),
	(289456, 142, '2015-01-01 00:28:16.000000', 'temperatura', 835.0000, 'ºC'),
	(289457, 142, '2015-01-01 00:28:17.000000', 'temperatura', 125.0000, 'ºC'),
	(289458, 142, '2015-01-01 00:28:18.000000', 'temperatura', 518.0000, 'ºC'),
	(289459, 142, '2015-01-01 00:28:19.000000', 'temperatura', 1018.0000, 'ºC'),
	(289460, 142, '2015-01-01 00:28:20.000000', 'temperatura', 1133.0000, 'ºC'),
	(289461, 142, '2015-01-01 00:28:21.000000', 'temperatura', 214.0000, 'ºC'),
	(289462, 142, '2015-01-01 00:28:22.000000', 'temperatura', 73.0000, 'ºC'),
	(289463, 142, '2015-01-01 00:28:23.000000', 'temperatura', 921.0000, 'ºC'),
	(289464, 142, '2015-01-01 00:28:24.000000', 'temperatura', 788.0000, 'ºC'),
	(289465, 142, '2015-01-01 00:28:25.000000', 'temperatura', 1176.0000, 'ºC'),
	(289466, 142, '2015-01-01 00:28:26.000000', 'temperatura', 1116.0000, 'ºC'),
	(289467, 142, '2015-01-01 00:28:27.000000', 'temperatura', 852.0000, 'ºC'),
	(289468, 142, '2015-01-01 00:28:28.000000', 'temperatura', 915.0000, 'ºC'),
	(289469, 142, '2015-01-01 00:28:29.000000', 'temperatura', 817.0000, 'ºC'),
	(289470, 142, '2015-01-01 00:28:30.000000', 'temperatura', 140.0000, 'ºC'),
	(289471, 142, '2015-01-01 00:28:31.000000', 'temperatura', 649.0000, 'ºC'),
	(289472, 142, '2015-01-01 00:28:32.000000', 'temperatura', 429.0000, 'ºC'),
	(289473, 142, '2015-01-01 00:28:33.000000', 'temperatura', 195.0000, 'ºC'),
	(289474, 142, '2015-01-01 00:28:34.000000', 'temperatura', 889.0000, 'ºC'),
	(289475, 142, '2015-01-01 00:28:35.000000', 'temperatura', 261.0000, 'ºC'),
	(289476, 142, '2015-01-01 00:28:36.000000', 'temperatura', 1040.0000, 'ºC'),
	(289477, 142, '2015-01-01 00:28:37.000000', 'temperatura', 814.0000, 'ºC'),
	(289478, 142, '2015-01-01 00:28:38.000000', 'temperatura', 954.0000, 'ºC'),
	(289479, 142, '2015-01-01 00:28:39.000000', 'temperatura', 1127.0000, 'ºC'),
	(289480, 142, '2015-01-01 00:28:40.000000', 'temperatura', 374.0000, 'ºC'),
	(289481, 142, '2015-01-01 00:28:41.000000', 'temperatura', 890.0000, 'ºC'),
	(289482, 142, '2015-01-01 00:28:42.000000', 'temperatura', 929.0000, 'ºC'),
	(289483, 142, '2015-01-01 00:28:43.000000', 'temperatura', 776.0000, 'ºC'),
	(289484, 142, '2015-01-01 00:28:44.000000', 'temperatura', 1092.0000, 'ºC'),
	(289485, 142, '2015-01-01 00:28:45.000000', 'temperatura', 735.0000, 'ºC'),
	(289486, 142, '2015-01-01 00:28:46.000000', 'temperatura', 399.0000, 'ºC'),
	(289487, 142, '2015-01-01 00:28:47.000000', 'temperatura', 988.0000, 'ºC'),
	(289488, 142, '2015-01-01 00:28:48.000000', 'temperatura', 145.0000, 'ºC'),
	(289489, 142, '2015-01-01 00:28:49.000000', 'temperatura', 159.0000, 'ºC'),
	(289490, 142, '2015-01-01 00:28:50.000000', 'temperatura', 363.0000, 'ºC'),
	(289491, 142, '2015-01-01 00:28:51.000000', 'temperatura', 138.0000, 'ºC'),
	(289492, 142, '2015-01-01 00:28:52.000000', 'temperatura', 802.0000, 'ºC'),
	(289493, 142, '2015-01-01 00:28:53.000000', 'temperatura', 1195.0000, 'ºC'),
	(289494, 142, '2015-01-01 00:28:54.000000', 'temperatura', 1169.0000, 'ºC'),
	(289495, 142, '2015-01-01 00:28:55.000000', 'temperatura', 1060.0000, 'ºC'),
	(289496, 142, '2015-01-01 00:28:56.000000', 'temperatura', 594.0000, 'ºC'),
	(289497, 142, '2015-01-01 00:28:57.000000', 'temperatura', 993.0000, 'ºC'),
	(289498, 142, '2015-01-01 00:28:58.000000', 'temperatura', 781.0000, 'ºC'),
	(289499, 142, '2015-01-01 00:28:59.000000', 'temperatura', 926.0000, 'ºC'),
	(289500, 142, '2015-01-01 00:29:00.000000', 'temperatura', 1090.0000, 'ºC'),
	(289501, 142, '2015-01-01 00:29:01.000000', 'temperatura', 272.0000, 'ºC'),
	(289502, 142, '2015-01-01 00:29:02.000000', 'temperatura', 491.0000, 'ºC'),
	(289503, 142, '2015-01-01 00:29:03.000000', 'temperatura', 440.0000, 'ºC'),
	(289504, 142, '2015-01-01 00:29:04.000000', 'temperatura', 728.0000, 'ºC'),
	(289505, 142, '2015-01-01 00:29:05.000000', 'temperatura', 1120.0000, 'ºC'),
	(289506, 142, '2015-01-01 00:29:06.000000', 'temperatura', 1016.0000, 'ºC'),
	(289507, 142, '2015-01-01 00:29:07.000000', 'temperatura', 520.0000, 'ºC'),
	(289508, 142, '2015-01-01 00:29:08.000000', 'temperatura', 755.0000, 'ºC'),
	(289509, 142, '2015-01-01 00:29:09.000000', 'temperatura', 1014.0000, 'ºC'),
	(289510, 142, '2015-01-01 00:29:10.000000', 'temperatura', 408.0000, 'ºC'),
	(289511, 142, '2015-01-01 00:29:11.000000', 'temperatura', 195.0000, 'ºC'),
	(289512, 142, '2015-01-01 00:29:12.000000', 'temperatura', 954.0000, 'ºC'),
	(289513, 142, '2015-01-01 00:29:13.000000', 'temperatura', 586.0000, 'ºC'),
	(289514, 142, '2015-01-01 00:29:14.000000', 'temperatura', 68.0000, 'ºC'),
	(289515, 142, '2015-01-01 00:29:15.000000', 'temperatura', 982.0000, 'ºC'),
	(289516, 142, '2015-01-01 00:29:16.000000', 'temperatura', 1106.0000, 'ºC'),
	(289517, 142, '2015-01-01 00:29:17.000000', 'temperatura', 185.0000, 'ºC'),
	(289518, 142, '2015-01-01 00:29:18.000000', 'temperatura', 7.0000, 'ºC'),
	(289519, 142, '2015-01-01 00:29:19.000000', 'temperatura', 681.0000, 'ºC'),
	(289520, 142, '2015-01-01 00:29:20.000000', 'temperatura', 986.0000, 'ºC'),
	(289521, 142, '2015-01-01 00:29:21.000000', 'temperatura', 488.0000, 'ºC'),
	(289522, 142, '2015-01-01 00:29:22.000000', 'temperatura', 681.0000, 'ºC'),
	(289523, 142, '2015-01-01 00:29:23.000000', 'temperatura', 743.0000, 'ºC'),
	(289524, 142, '2015-01-01 00:29:24.000000', 'temperatura', 471.0000, 'ºC'),
	(289525, 142, '2015-01-01 00:29:25.000000', 'temperatura', 125.0000, 'ºC'),
	(289526, 142, '2015-01-01 00:29:26.000000', 'temperatura', 415.0000, 'ºC'),
	(289527, 142, '2015-01-01 00:29:27.000000', 'temperatura', 500.0000, 'ºC'),
	(289528, 142, '2015-01-01 00:29:28.000000', 'temperatura', 54.0000, 'ºC'),
	(289529, 142, '2015-01-01 00:29:29.000000', 'temperatura', 1171.0000, 'ºC'),
	(289530, 142, '2015-01-01 00:29:30.000000', 'temperatura', 893.0000, 'ºC'),
	(289531, 142, '2015-01-01 00:29:31.000000', 'temperatura', 954.0000, 'ºC'),
	(289532, 142, '2015-01-01 00:29:32.000000', 'temperatura', 893.0000, 'ºC'),
	(289533, 142, '2015-01-01 00:29:33.000000', 'temperatura', 400.0000, 'ºC'),
	(289534, 142, '2015-01-01 00:29:34.000000', 'temperatura', 523.0000, 'ºC'),
	(289535, 142, '2015-01-01 00:29:35.000000', 'temperatura', 217.0000, 'ºC'),
	(289536, 142, '2015-01-01 00:29:36.000000', 'temperatura', 715.0000, 'ºC'),
	(289537, 142, '2015-01-01 00:29:37.000000', 'temperatura', 525.0000, 'ºC'),
	(289538, 142, '2015-01-01 00:29:38.000000', 'temperatura', 480.0000, 'ºC'),
	(289539, 142, '2015-01-01 00:29:39.000000', 'temperatura', 826.0000, 'ºC'),
	(289540, 142, '2015-01-01 00:29:40.000000', 'temperatura', 288.0000, 'ºC'),
	(289541, 142, '2015-01-01 00:29:41.000000', 'temperatura', 165.0000, 'ºC'),
	(289542, 142, '2015-01-01 00:29:42.000000', 'temperatura', 1163.0000, 'ºC'),
	(289543, 142, '2015-01-01 00:29:43.000000', 'temperatura', 517.0000, 'ºC'),
	(289544, 142, '2015-01-01 00:29:44.000000', 'temperatura', 299.0000, 'ºC'),
	(289545, 142, '2015-01-01 00:29:45.000000', 'temperatura', 1144.0000, 'ºC'),
	(289546, 142, '2015-01-01 00:29:46.000000', 'temperatura', 25.0000, 'ºC'),
	(289547, 142, '2015-01-01 00:29:47.000000', 'temperatura', 293.0000, 'ºC'),
	(289548, 142, '2015-01-01 00:29:48.000000', 'temperatura', 191.0000, 'ºC'),
	(289549, 142, '2015-01-01 00:29:49.000000', 'temperatura', 74.0000, 'ºC'),
	(289550, 142, '2015-01-01 00:29:50.000000', 'temperatura', 998.0000, 'ºC'),
	(289551, 142, '2015-01-01 00:29:51.000000', 'temperatura', 1171.0000, 'ºC'),
	(289552, 142, '2015-01-01 00:29:52.000000', 'temperatura', 458.0000, 'ºC'),
	(289553, 142, '2015-01-01 00:29:53.000000', 'temperatura', 1179.0000, 'ºC'),
	(289554, 142, '2015-01-01 00:29:54.000000', 'temperatura', 922.0000, 'ºC'),
	(289555, 142, '2015-01-01 00:29:55.000000', 'temperatura', 1072.0000, 'ºC'),
	(289556, 142, '2015-01-01 00:29:56.000000', 'temperatura', 196.0000, 'ºC'),
	(289557, 142, '2015-01-01 00:29:57.000000', 'temperatura', 164.0000, 'ºC'),
	(289558, 142, '2015-01-01 00:29:58.000000', 'temperatura', 233.0000, 'ºC'),
	(289559, 142, '2015-01-01 00:29:59.000000', 'temperatura', 672.0000, 'ºC'),
	(289560, 142, '2015-01-01 00:30:00.000000', 'temperatura', 262.0000, 'ºC'),
	(289561, 142, '2015-01-01 00:30:01.000000', 'temperatura', 495.0000, 'ºC'),
	(289562, 142, '2015-01-01 00:30:02.000000', 'temperatura', 488.0000, 'ºC'),
	(289563, 142, '2015-01-01 00:30:03.000000', 'temperatura', 956.0000, 'ºC'),
	(289564, 142, '2015-01-01 00:30:04.000000', 'temperatura', 917.0000, 'ºC'),
	(289565, 142, '2015-01-01 00:30:05.000000', 'temperatura', 518.0000, 'ºC'),
	(289566, 142, '2015-01-01 00:30:06.000000', 'temperatura', 1039.0000, 'ºC'),
	(289567, 142, '2015-01-01 00:30:07.000000', 'temperatura', 40.0000, 'ºC'),
	(289568, 142, '2015-01-01 00:30:08.000000', 'temperatura', 683.0000, 'ºC'),
	(289569, 142, '2015-01-01 00:30:09.000000', 'temperatura', 896.0000, 'ºC'),
	(289570, 142, '2015-01-01 00:30:10.000000', 'temperatura', 32.0000, 'ºC'),
	(289571, 142, '2015-01-01 00:30:11.000000', 'temperatura', 1074.0000, 'ºC'),
	(289572, 142, '2015-01-01 00:30:12.000000', 'temperatura', 475.0000, 'ºC'),
	(289573, 142, '2015-01-01 00:30:13.000000', 'temperatura', 352.0000, 'ºC'),
	(289574, 142, '2015-01-01 00:30:14.000000', 'temperatura', 334.0000, 'ºC'),
	(289575, 142, '2015-01-01 00:30:15.000000', 'temperatura', 616.0000, 'ºC'),
	(289576, 142, '2015-01-01 00:30:16.000000', 'temperatura', 879.0000, 'ºC'),
	(289577, 142, '2015-01-01 00:30:17.000000', 'temperatura', 148.0000, 'ºC'),
	(289578, 142, '2015-01-01 00:30:18.000000', 'temperatura', 502.0000, 'ºC'),
	(289579, 142, '2015-01-01 00:30:19.000000', 'temperatura', 867.0000, 'ºC'),
	(289580, 142, '2015-01-01 00:30:20.000000', 'temperatura', 428.0000, 'ºC'),
	(289581, 142, '2015-01-01 00:30:21.000000', 'temperatura', 740.0000, 'ºC'),
	(289582, 142, '2015-01-01 00:30:22.000000', 'temperatura', 15.0000, 'ºC'),
	(289583, 142, '2015-01-01 00:30:23.000000', 'temperatura', 256.0000, 'ºC'),
	(289584, 142, '2015-01-01 00:30:24.000000', 'temperatura', 36.0000, 'ºC'),
	(289585, 142, '2015-01-01 00:30:25.000000', 'temperatura', 612.0000, 'ºC'),
	(289586, 142, '2015-01-01 00:30:26.000000', 'temperatura', 552.0000, 'ºC'),
	(289587, 142, '2015-01-01 00:30:27.000000', 'temperatura', 926.0000, 'ºC'),
	(289588, 142, '2015-01-01 00:30:28.000000', 'temperatura', 575.0000, 'ºC'),
	(289589, 142, '2015-01-01 00:30:29.000000', 'temperatura', 96.0000, 'ºC'),
	(289590, 142, '2015-01-01 00:30:30.000000', 'temperatura', 1155.0000, 'ºC'),
	(289591, 142, '2015-01-01 00:30:31.000000', 'temperatura', 687.0000, 'ºC'),
	(289592, 142, '2015-01-01 00:30:32.000000', 'temperatura', 1173.0000, 'ºC'),
	(289593, 142, '2015-01-01 00:30:33.000000', 'temperatura', 204.0000, 'ºC'),
	(289594, 142, '2015-01-01 00:30:34.000000', 'temperatura', 1102.0000, 'ºC'),
	(289595, 142, '2015-01-01 00:30:35.000000', 'temperatura', 97.0000, 'ºC'),
	(289596, 142, '2015-01-01 00:30:36.000000', 'temperatura', 781.0000, 'ºC'),
	(289597, 142, '2015-01-01 00:30:37.000000', 'temperatura', 15.0000, 'ºC'),
	(289598, 142, '2015-01-01 00:30:38.000000', 'temperatura', 131.0000, 'ºC'),
	(289599, 142, '2015-01-01 00:30:39.000000', 'temperatura', 613.0000, 'ºC'),
	(289600, 142, '2015-01-01 00:30:40.000000', 'temperatura', 271.0000, 'ºC'),
	(289601, 142, '2015-01-01 00:30:41.000000', 'temperatura', 717.0000, 'ºC'),
	(289602, 142, '2015-01-01 00:30:42.000000', 'temperatura', 372.0000, 'ºC'),
	(289603, 142, '2015-01-01 00:30:43.000000', 'temperatura', 909.0000, 'ºC'),
	(289604, 142, '2015-01-01 00:30:44.000000', 'temperatura', 1032.0000, 'ºC'),
	(289605, 142, '2015-01-01 00:30:45.000000', 'temperatura', 32.0000, 'ºC'),
	(289606, 142, '2015-01-01 00:30:46.000000', 'temperatura', 666.0000, 'ºC'),
	(289607, 142, '2015-01-01 00:30:47.000000', 'temperatura', 832.0000, 'ºC'),
	(289608, 142, '2015-01-01 00:30:48.000000', 'temperatura', 963.0000, 'ºC'),
	(289609, 142, '2015-01-01 00:30:49.000000', 'temperatura', 1119.0000, 'ºC'),
	(289610, 142, '2015-01-01 00:30:50.000000', 'temperatura', 306.0000, 'ºC'),
	(289611, 142, '2015-01-01 00:30:51.000000', 'temperatura', 574.0000, 'ºC'),
	(289612, 142, '2015-01-01 00:30:52.000000', 'temperatura', 755.0000, 'ºC'),
	(289613, 142, '2015-01-01 00:30:53.000000', 'temperatura', 850.0000, 'ºC'),
	(289614, 142, '2015-01-01 00:30:54.000000', 'temperatura', 789.0000, 'ºC'),
	(289615, 142, '2015-01-01 00:30:55.000000', 'temperatura', 194.0000, 'ºC'),
	(289616, 142, '2015-01-01 00:30:56.000000', 'temperatura', 1003.0000, 'ºC'),
	(289617, 142, '2015-01-01 00:30:57.000000', 'temperatura', 833.0000, 'ºC'),
	(289618, 142, '2015-01-01 00:30:58.000000', 'temperatura', 1157.0000, 'ºC'),
	(289619, 142, '2015-01-01 00:30:59.000000', 'temperatura', 886.0000, 'ºC'),
	(289620, 142, '2015-01-01 00:31:00.000000', 'temperatura', 960.0000, 'ºC'),
	(289621, 142, '2015-01-01 00:31:01.000000', 'temperatura', 944.0000, 'ºC'),
	(289622, 142, '2015-01-01 00:31:02.000000', 'temperatura', 640.0000, 'ºC'),
	(289623, 142, '2015-01-01 00:31:03.000000', 'temperatura', 367.0000, 'ºC'),
	(289624, 142, '2015-01-01 00:31:04.000000', 'temperatura', 1118.0000, 'ºC'),
	(289625, 142, '2015-01-01 00:31:05.000000', 'temperatura', 889.0000, 'ºC'),
	(289626, 142, '2015-01-01 00:31:06.000000', 'temperatura', 1090.0000, 'ºC'),
	(289627, 142, '2015-01-01 00:31:07.000000', 'temperatura', 384.0000, 'ºC'),
	(289628, 142, '2015-01-01 00:31:08.000000', 'temperatura', 1052.0000, 'ºC'),
	(289629, 142, '2015-01-01 00:31:09.000000', 'temperatura', 508.0000, 'ºC'),
	(289630, 142, '2015-01-01 00:31:10.000000', 'temperatura', 586.0000, 'ºC'),
	(289631, 142, '2015-01-01 00:31:11.000000', 'temperatura', 203.0000, 'ºC'),
	(289632, 142, '2015-01-01 00:31:12.000000', 'temperatura', 461.0000, 'ºC'),
	(289633, 142, '2015-01-01 00:31:13.000000', 'temperatura', 495.0000, 'ºC'),
	(289634, 142, '2015-01-01 00:31:14.000000', 'temperatura', 1093.0000, 'ºC'),
	(289635, 142, '2015-01-01 00:31:15.000000', 'temperatura', 379.0000, 'ºC'),
	(289636, 142, '2015-01-01 00:31:16.000000', 'temperatura', 1018.0000, 'ºC'),
	(289637, 142, '2015-01-01 00:31:17.000000', 'temperatura', 354.0000, 'ºC'),
	(289638, 142, '2015-01-01 00:31:18.000000', 'temperatura', 1117.0000, 'ºC'),
	(289639, 142, '2015-01-01 00:31:19.000000', 'temperatura', 925.0000, 'ºC'),
	(289640, 142, '2015-01-01 00:31:20.000000', 'temperatura', 72.0000, 'ºC'),
	(289641, 142, '2015-01-01 00:31:21.000000', 'temperatura', 1185.0000, 'ºC'),
	(289642, 142, '2015-01-01 00:31:22.000000', 'temperatura', 912.0000, 'ºC'),
	(289643, 142, '2015-01-01 00:31:23.000000', 'temperatura', 1003.0000, 'ºC'),
	(289644, 142, '2015-01-01 00:31:24.000000', 'temperatura', 1082.0000, 'ºC'),
	(289645, 142, '2015-01-01 00:31:25.000000', 'temperatura', 1.0000, 'ºC'),
	(289646, 142, '2015-01-01 00:31:26.000000', 'temperatura', 358.0000, 'ºC'),
	(289647, 142, '2015-01-01 00:31:27.000000', 'temperatura', 587.0000, 'ºC'),
	(289648, 142, '2015-01-01 00:31:28.000000', 'temperatura', 662.0000, 'ºC'),
	(289649, 142, '2015-01-01 00:31:29.000000', 'temperatura', 351.0000, 'ºC'),
	(289650, 142, '2015-01-01 00:31:30.000000', 'temperatura', 967.0000, 'ºC'),
	(289651, 142, '2015-01-01 00:31:31.000000', 'temperatura', 184.0000, 'ºC'),
	(289652, 142, '2015-01-01 00:31:32.000000', 'temperatura', 418.0000, 'ºC'),
	(289653, 142, '2015-01-01 00:31:33.000000', 'temperatura', 341.0000, 'ºC'),
	(289654, 142, '2015-01-01 00:31:34.000000', 'temperatura', 450.0000, 'ºC'),
	(289655, 142, '2015-01-01 00:31:35.000000', 'temperatura', 27.0000, 'ºC'),
	(289656, 142, '2015-01-01 00:31:36.000000', 'temperatura', 1187.0000, 'ºC'),
	(289657, 142, '2015-01-01 00:31:37.000000', 'temperatura', 1055.0000, 'ºC'),
	(289658, 142, '2015-01-01 00:31:38.000000', 'temperatura', 512.0000, 'ºC'),
	(289659, 142, '2015-01-01 00:31:39.000000', 'temperatura', 599.0000, 'ºC'),
	(289660, 142, '2015-01-01 00:31:40.000000', 'temperatura', 256.0000, 'ºC'),
	(289661, 142, '2015-01-01 00:31:41.000000', 'temperatura', 685.0000, 'ºC'),
	(289662, 142, '2015-01-01 00:31:42.000000', 'temperatura', 256.0000, 'ºC'),
	(289663, 142, '2015-01-01 00:31:43.000000', 'temperatura', 426.0000, 'ºC'),
	(289664, 142, '2015-01-01 00:31:44.000000', 'temperatura', 161.0000, 'ºC'),
	(289665, 142, '2015-01-01 00:31:45.000000', 'temperatura', 730.0000, 'ºC'),
	(289666, 142, '2015-01-01 00:31:46.000000', 'temperatura', 765.0000, 'ºC'),
	(289667, 142, '2015-01-01 00:31:47.000000', 'temperatura', 435.0000, 'ºC'),
	(289668, 142, '2015-01-01 00:31:48.000000', 'temperatura', 1080.0000, 'ºC'),
	(289669, 142, '2015-01-01 00:31:49.000000', 'temperatura', 498.0000, 'ºC'),
	(289670, 142, '2015-01-01 00:31:50.000000', 'temperatura', 449.0000, 'ºC'),
	(289671, 142, '2015-01-01 00:31:51.000000', 'temperatura', 750.0000, 'ºC'),
	(289672, 142, '2015-01-01 00:31:52.000000', 'temperatura', 5.0000, 'ºC'),
	(289673, 142, '2015-01-01 00:31:53.000000', 'temperatura', 176.0000, 'ºC'),
	(289674, 142, '2015-01-01 00:31:54.000000', 'temperatura', 867.0000, 'ºC'),
	(289675, 142, '2015-01-01 00:31:55.000000', 'temperatura', 205.0000, 'ºC'),
	(289676, 142, '2015-01-01 00:31:56.000000', 'temperatura', 823.0000, 'ºC'),
	(289677, 142, '2015-01-01 00:31:57.000000', 'temperatura', 1104.0000, 'ºC'),
	(289678, 142, '2015-01-01 00:31:58.000000', 'temperatura', 651.0000, 'ºC'),
	(289679, 142, '2015-01-01 00:31:59.000000', 'temperatura', 1143.0000, 'ºC'),
	(289680, 142, '2015-01-01 00:32:00.000000', 'temperatura', 163.0000, 'ºC'),
	(289681, 142, '2015-01-01 00:32:01.000000', 'temperatura', 987.0000, 'ºC'),
	(289682, 142, '2015-01-01 00:32:02.000000', 'temperatura', 845.0000, 'ºC'),
	(289683, 142, '2015-01-01 00:32:03.000000', 'temperatura', 64.0000, 'ºC'),
	(289684, 142, '2015-01-01 00:32:04.000000', 'temperatura', 186.0000, 'ºC'),
	(289685, 142, '2015-01-01 00:32:05.000000', 'temperatura', 738.0000, 'ºC'),
	(289686, 142, '2015-01-01 00:32:06.000000', 'temperatura', 733.0000, 'ºC'),
	(289687, 142, '2015-01-01 00:32:07.000000', 'temperatura', 251.0000, 'ºC'),
	(289688, 142, '2015-01-01 00:32:08.000000', 'temperatura', 259.0000, 'ºC'),
	(289689, 142, '2015-01-01 00:32:09.000000', 'temperatura', 539.0000, 'ºC'),
	(289690, 142, '2015-01-01 00:32:10.000000', 'temperatura', 721.0000, 'ºC'),
	(289691, 142, '2015-01-01 00:32:11.000000', 'temperatura', 786.0000, 'ºC'),
	(289692, 142, '2015-01-01 00:32:12.000000', 'temperatura', 568.0000, 'ºC'),
	(289693, 142, '2015-01-01 00:32:13.000000', 'temperatura', 484.0000, 'ºC'),
	(289694, 142, '2015-01-01 00:32:14.000000', 'temperatura', 714.0000, 'ºC'),
	(289695, 142, '2015-01-01 00:32:15.000000', 'temperatura', 921.0000, 'ºC'),
	(289696, 142, '2015-01-01 00:32:16.000000', 'temperatura', 62.0000, 'ºC'),
	(289697, 142, '2015-01-01 00:32:17.000000', 'temperatura', 1148.0000, 'ºC'),
	(289698, 142, '2015-01-01 00:32:18.000000', 'temperatura', 754.0000, 'ºC'),
	(289699, 142, '2015-01-01 00:32:19.000000', 'temperatura', 329.0000, 'ºC'),
	(289700, 142, '2015-01-01 00:32:20.000000', 'temperatura', 582.0000, 'ºC'),
	(289701, 142, '2015-01-01 00:32:21.000000', 'temperatura', 722.0000, 'ºC'),
	(289702, 142, '2015-01-01 00:32:22.000000', 'temperatura', 667.0000, 'ºC'),
	(289703, 142, '2015-01-01 00:32:23.000000', 'temperatura', 1170.0000, 'ºC'),
	(289704, 142, '2015-01-01 00:32:24.000000', 'temperatura', 249.0000, 'ºC'),
	(289705, 142, '2015-01-01 00:32:25.000000', 'temperatura', 136.0000, 'ºC'),
	(289706, 142, '2015-01-01 00:32:26.000000', 'temperatura', 1132.0000, 'ºC'),
	(289707, 142, '2015-01-01 00:32:27.000000', 'temperatura', 452.0000, 'ºC'),
	(289708, 142, '2015-01-01 00:32:28.000000', 'temperatura', 64.0000, 'ºC'),
	(289709, 142, '2015-01-01 00:32:29.000000', 'temperatura', 167.0000, 'ºC'),
	(289710, 142, '2015-01-01 00:32:30.000000', 'temperatura', 643.0000, 'ºC'),
	(289711, 142, '2015-01-01 00:32:31.000000', 'temperatura', 312.0000, 'ºC'),
	(289712, 142, '2015-01-01 00:32:32.000000', 'temperatura', 834.0000, 'ºC'),
	(289713, 142, '2015-01-01 00:32:33.000000', 'temperatura', 833.0000, 'ºC'),
	(289714, 142, '2015-01-01 00:32:34.000000', 'temperatura', 464.0000, 'ºC'),
	(289715, 142, '2015-01-01 00:32:35.000000', 'temperatura', 1023.0000, 'ºC'),
	(289716, 142, '2015-01-01 00:32:36.000000', 'temperatura', 122.0000, 'ºC'),
	(289717, 142, '2015-01-01 00:32:37.000000', 'temperatura', 1140.0000, 'ºC'),
	(289718, 142, '2015-01-01 00:32:38.000000', 'temperatura', 534.0000, 'ºC'),
	(289719, 142, '2015-01-01 00:32:39.000000', 'temperatura', 454.0000, 'ºC'),
	(289720, 142, '2015-01-01 00:32:40.000000', 'temperatura', 666.0000, 'ºC'),
	(289721, 142, '2015-01-01 00:32:41.000000', 'temperatura', 769.0000, 'ºC'),
	(289722, 142, '2015-01-01 00:32:42.000000', 'temperatura', 647.0000, 'ºC'),
	(289723, 142, '2015-01-01 00:32:43.000000', 'temperatura', 930.0000, 'ºC'),
	(289724, 142, '2015-01-01 00:32:44.000000', 'temperatura', 307.0000, 'ºC'),
	(289725, 142, '2015-01-01 00:32:45.000000', 'temperatura', 1147.0000, 'ºC'),
	(289726, 142, '2015-01-01 00:32:46.000000', 'temperatura', 13.0000, 'ºC'),
	(289727, 142, '2015-01-01 00:32:47.000000', 'temperatura', 227.0000, 'ºC'),
	(289728, 142, '2015-01-01 00:32:48.000000', 'temperatura', 1096.0000, 'ºC'),
	(289729, 142, '2015-01-01 00:32:49.000000', 'temperatura', 1.0000, 'ºC'),
	(289730, 142, '2015-01-01 00:32:50.000000', 'temperatura', 314.0000, 'ºC'),
	(289731, 142, '2015-01-01 00:32:51.000000', 'temperatura', 370.0000, 'ºC'),
	(289732, 142, '2015-01-01 00:32:52.000000', 'temperatura', 906.0000, 'ºC'),
	(289733, 142, '2015-01-01 00:32:53.000000', 'temperatura', 1021.0000, 'ºC'),
	(289734, 142, '2015-01-01 00:32:54.000000', 'temperatura', 1186.0000, 'ºC'),
	(289735, 142, '2015-01-01 00:32:55.000000', 'temperatura', 470.0000, 'ºC'),
	(289736, 142, '2015-01-01 00:32:56.000000', 'temperatura', 1190.0000, 'ºC'),
	(289737, 142, '2015-01-01 00:32:57.000000', 'temperatura', 941.0000, 'ºC'),
	(289738, 142, '2015-01-01 00:32:58.000000', 'temperatura', 1137.0000, 'ºC'),
	(289739, 142, '2015-01-01 00:32:59.000000', 'temperatura', 461.0000, 'ºC'),
	(289740, 142, '2015-01-01 00:33:00.000000', 'temperatura', 96.0000, 'ºC'),
	(289741, 142, '2015-01-01 00:33:01.000000', 'temperatura', 296.0000, 'ºC'),
	(289742, 142, '2015-01-01 00:33:02.000000', 'temperatura', 1195.0000, 'ºC'),
	(289743, 142, '2015-01-01 00:33:03.000000', 'temperatura', 286.0000, 'ºC'),
	(289744, 142, '2015-01-01 00:33:04.000000', 'temperatura', 244.0000, 'ºC'),
	(289745, 142, '2015-01-01 00:33:05.000000', 'temperatura', 365.0000, 'ºC'),
	(289746, 142, '2015-01-01 00:33:06.000000', 'temperatura', 1092.0000, 'ºC'),
	(289747, 142, '2015-01-01 00:33:07.000000', 'temperatura', 768.0000, 'ºC'),
	(289748, 142, '2015-01-01 00:33:08.000000', 'temperatura', 562.0000, 'ºC'),
	(289749, 142, '2015-01-01 00:33:09.000000', 'temperatura', 506.0000, 'ºC'),
	(289750, 142, '2015-01-01 00:33:10.000000', 'temperatura', 847.0000, 'ºC'),
	(289751, 142, '2015-01-01 00:33:11.000000', 'temperatura', 315.0000, 'ºC'),
	(289752, 142, '2015-01-01 00:33:12.000000', 'temperatura', 236.0000, 'ºC'),
	(289753, 142, '2015-01-01 00:33:13.000000', 'temperatura', 233.0000, 'ºC'),
	(289754, 142, '2015-01-01 00:33:14.000000', 'temperatura', 461.0000, 'ºC'),
	(289755, 142, '2015-01-01 00:33:15.000000', 'temperatura', 405.0000, 'ºC'),
	(289756, 142, '2015-01-01 00:33:16.000000', 'temperatura', 640.0000, 'ºC'),
	(289757, 142, '2015-01-01 00:33:17.000000', 'temperatura', 789.0000, 'ºC'),
	(289758, 142, '2015-01-01 00:33:18.000000', 'temperatura', 826.0000, 'ºC'),
	(289759, 142, '2015-01-01 00:33:19.000000', 'temperatura', 560.0000, 'ºC'),
	(289760, 142, '2015-01-01 00:33:20.000000', 'temperatura', 326.0000, 'ºC'),
	(289761, 142, '2015-01-01 00:33:21.000000', 'temperatura', 1148.0000, 'ºC'),
	(289762, 142, '2015-01-01 00:33:22.000000', 'temperatura', 1163.0000, 'ºC'),
	(289763, 142, '2015-01-01 00:33:23.000000', 'temperatura', 1171.0000, 'ºC'),
	(289764, 142, '2015-01-01 00:33:24.000000', 'temperatura', 1168.0000, 'ºC'),
	(289765, 142, '2015-01-01 00:33:25.000000', 'temperatura', 1126.0000, 'ºC'),
	(289766, 142, '2015-01-01 00:33:26.000000', 'temperatura', 928.0000, 'ºC'),
	(289767, 142, '2015-01-01 00:33:27.000000', 'temperatura', 64.0000, 'ºC'),
	(289768, 142, '2015-01-01 00:33:28.000000', 'temperatura', 1134.0000, 'ºC'),
	(289769, 142, '2015-01-01 00:33:29.000000', 'temperatura', 681.0000, 'ºC'),
	(289770, 142, '2015-01-01 00:33:30.000000', 'temperatura', 1.0000, 'ºC'),
	(289771, 142, '2015-01-01 00:33:31.000000', 'temperatura', 363.0000, 'ºC'),
	(289772, 142, '2015-01-01 00:33:32.000000', 'temperatura', 613.0000, 'ºC'),
	(289773, 142, '2015-01-01 00:33:33.000000', 'temperatura', 778.0000, 'ºC'),
	(289774, 142, '2015-01-01 00:33:34.000000', 'temperatura', 850.0000, 'ºC'),
	(289775, 142, '2015-01-01 00:33:35.000000', 'temperatura', 715.0000, 'ºC'),
	(289776, 142, '2015-01-01 00:33:36.000000', 'temperatura', 1028.0000, 'ºC'),
	(289777, 142, '2015-01-01 00:33:37.000000', 'temperatura', 594.0000, 'ºC'),
	(289778, 142, '2015-01-01 00:33:38.000000', 'temperatura', 1089.0000, 'ºC'),
	(289779, 142, '2015-01-01 00:33:39.000000', 'temperatura', 61.0000, 'ºC'),
	(289780, 142, '2015-01-01 00:33:40.000000', 'temperatura', 637.0000, 'ºC'),
	(289781, 142, '2015-01-01 00:33:41.000000', 'temperatura', 605.0000, 'ºC'),
	(289782, 142, '2015-01-01 00:33:42.000000', 'temperatura', 1116.0000, 'ºC'),
	(289783, 142, '2015-01-01 00:33:43.000000', 'temperatura', 162.0000, 'ºC'),
	(289784, 142, '2015-01-01 00:33:44.000000', 'temperatura', 1065.0000, 'ºC'),
	(289785, 142, '2015-01-01 00:33:45.000000', 'temperatura', 39.0000, 'ºC'),
	(289786, 142, '2015-01-01 00:33:46.000000', 'temperatura', 600.0000, 'ºC'),
	(289787, 142, '2015-01-01 00:33:47.000000', 'temperatura', 485.0000, 'ºC'),
	(289788, 142, '2015-01-01 00:33:48.000000', 'temperatura', 623.0000, 'ºC'),
	(289789, 142, '2015-01-01 00:33:49.000000', 'temperatura', 461.0000, 'ºC'),
	(289790, 142, '2015-01-01 00:33:50.000000', 'temperatura', 439.0000, 'ºC'),
	(289791, 142, '2015-01-01 00:33:51.000000', 'temperatura', 809.0000, 'ºC'),
	(289792, 142, '2015-01-01 00:33:52.000000', 'temperatura', 332.0000, 'ºC'),
	(289793, 142, '2015-01-01 00:33:53.000000', 'temperatura', 430.0000, 'ºC'),
	(289794, 142, '2015-01-01 00:33:54.000000', 'temperatura', 1157.0000, 'ºC'),
	(289795, 142, '2015-01-01 00:33:55.000000', 'temperatura', 894.0000, 'ºC'),
	(289796, 142, '2015-01-01 00:33:56.000000', 'temperatura', 1000.0000, 'ºC'),
	(289797, 142, '2015-01-01 00:33:57.000000', 'temperatura', 1118.0000, 'ºC'),
	(289798, 142, '2015-01-01 00:33:58.000000', 'temperatura', 189.0000, 'ºC'),
	(289799, 142, '2015-01-01 00:33:59.000000', 'temperatura', 1192.0000, 'ºC'),
	(289800, 142, '2015-01-01 00:34:00.000000', 'temperatura', 596.0000, 'ºC'),
	(289801, 142, '2015-01-01 00:34:01.000000', 'temperatura', 602.0000, 'ºC'),
	(289802, 142, '2015-01-01 00:34:02.000000', 'temperatura', 25.0000, 'ºC'),
	(289803, 142, '2015-01-01 00:34:03.000000', 'temperatura', 719.0000, 'ºC'),
	(289804, 142, '2015-01-01 00:34:04.000000', 'temperatura', 1122.0000, 'ºC'),
	(289805, 142, '2015-01-01 00:34:05.000000', 'temperatura', 1053.0000, 'ºC'),
	(289806, 142, '2015-01-01 00:34:06.000000', 'temperatura', 698.0000, 'ºC'),
	(289807, 142, '2015-01-01 00:34:07.000000', 'temperatura', 332.0000, 'ºC'),
	(289808, 142, '2015-01-01 00:34:08.000000', 'temperatura', 769.0000, 'ºC'),
	(289809, 142, '2015-01-01 00:34:09.000000', 'temperatura', 446.0000, 'ºC'),
	(289810, 142, '2015-01-01 00:34:10.000000', 'temperatura', 1126.0000, 'ºC'),
	(289811, 142, '2015-01-01 00:34:11.000000', 'temperatura', 691.0000, 'ºC'),
	(289812, 142, '2015-01-01 00:34:12.000000', 'temperatura', 80.0000, 'ºC'),
	(289813, 142, '2015-01-01 00:34:13.000000', 'temperatura', 725.0000, 'ºC'),
	(289814, 142, '2015-01-01 00:34:14.000000', 'temperatura', 988.0000, 'ºC'),
	(289815, 142, '2015-01-01 00:34:15.000000', 'temperatura', 363.0000, 'ºC'),
	(289816, 142, '2015-01-01 00:34:16.000000', 'temperatura', 53.0000, 'ºC'),
	(289817, 142, '2015-01-01 00:34:17.000000', 'temperatura', 377.0000, 'ºC'),
	(289818, 142, '2015-01-01 00:34:18.000000', 'temperatura', 525.0000, 'ºC'),
	(289819, 142, '2015-01-01 00:34:19.000000', 'temperatura', 294.0000, 'ºC'),
	(289820, 142, '2015-01-01 00:34:20.000000', 'temperatura', 1098.0000, 'ºC'),
	(289821, 142, '2015-01-01 00:34:21.000000', 'temperatura', 1009.0000, 'ºC'),
	(289822, 142, '2015-01-01 00:34:22.000000', 'temperatura', 549.0000, 'ºC'),
	(289823, 142, '2015-01-01 00:34:23.000000', 'temperatura', 921.0000, 'ºC'),
	(289824, 142, '2015-01-01 00:34:24.000000', 'temperatura', 556.0000, 'ºC'),
	(289825, 142, '2015-01-01 00:34:25.000000', 'temperatura', 20.0000, 'ºC'),
	(289826, 142, '2015-01-01 00:34:26.000000', 'temperatura', 831.0000, 'ºC'),
	(289827, 142, '2015-01-01 00:34:27.000000', 'temperatura', 497.0000, 'ºC'),
	(289828, 142, '2015-01-01 00:34:28.000000', 'temperatura', 1193.0000, 'ºC'),
	(289829, 142, '2015-01-01 00:34:29.000000', 'temperatura', 871.0000, 'ºC'),
	(289830, 142, '2015-01-01 00:34:30.000000', 'temperatura', 780.0000, 'ºC'),
	(289831, 142, '2015-01-01 00:34:31.000000', 'temperatura', 87.0000, 'ºC'),
	(289832, 142, '2015-01-01 00:34:32.000000', 'temperatura', 497.0000, 'ºC'),
	(289833, 142, '2015-01-01 00:34:33.000000', 'temperatura', 1023.0000, 'ºC'),
	(289834, 142, '2015-01-01 00:34:34.000000', 'temperatura', 26.0000, 'ºC'),
	(289835, 142, '2015-01-01 00:34:35.000000', 'temperatura', 661.0000, 'ºC'),
	(289836, 142, '2015-01-01 00:34:36.000000', 'temperatura', 828.0000, 'ºC'),
	(289837, 142, '2015-01-01 00:34:37.000000', 'temperatura', 957.0000, 'ºC'),
	(289838, 142, '2015-01-01 00:34:38.000000', 'temperatura', 1102.0000, 'ºC'),
	(289839, 142, '2015-01-01 00:34:39.000000', 'temperatura', 240.0000, 'ºC'),
	(289840, 142, '2015-01-01 00:34:40.000000', 'temperatura', 295.0000, 'ºC'),
	(289841, 142, '2015-01-01 00:34:41.000000', 'temperatura', 756.0000, 'ºC'),
	(289842, 142, '2015-01-01 00:34:42.000000', 'temperatura', 496.0000, 'ºC'),
	(289843, 142, '2015-01-01 00:34:43.000000', 'temperatura', 210.0000, 'ºC'),
	(289844, 142, '2015-01-01 00:34:44.000000', 'temperatura', 765.0000, 'ºC'),
	(289845, 142, '2015-01-01 00:34:45.000000', 'temperatura', 796.0000, 'ºC'),
	(289846, 142, '2015-01-01 00:34:46.000000', 'temperatura', 485.0000, 'ºC'),
	(289847, 142, '2015-01-01 00:34:47.000000', 'temperatura', 36.0000, 'ºC'),
	(289848, 142, '2015-01-01 00:34:48.000000', 'temperatura', 1125.0000, 'ºC'),
	(289849, 142, '2015-01-01 00:34:49.000000', 'temperatura', 720.0000, 'ºC'),
	(289850, 142, '2015-01-01 00:34:50.000000', 'temperatura', 225.0000, 'ºC'),
	(289851, 142, '2015-01-01 00:34:51.000000', 'temperatura', 167.0000, 'ºC'),
	(289852, 142, '2015-01-01 00:34:52.000000', 'temperatura', 160.0000, 'ºC'),
	(289853, 142, '2015-01-01 00:34:53.000000', 'temperatura', 297.0000, 'ºC'),
	(289854, 142, '2015-01-01 00:34:54.000000', 'temperatura', 1009.0000, 'ºC'),
	(289855, 142, '2015-01-01 00:34:55.000000', 'temperatura', 552.0000, 'ºC'),
	(289856, 142, '2015-01-01 00:34:56.000000', 'temperatura', 935.0000, 'ºC'),
	(289857, 142, '2015-01-01 00:34:57.000000', 'temperatura', 620.0000, 'ºC'),
	(289858, 142, '2015-01-01 00:34:58.000000', 'temperatura', 295.0000, 'ºC'),
	(289859, 142, '2015-01-01 00:34:59.000000', 'temperatura', 816.0000, 'ºC'),
	(289860, 142, '2015-01-01 00:35:00.000000', 'temperatura', 794.0000, 'ºC'),
	(289861, 142, '2015-01-01 00:35:01.000000', 'temperatura', 322.0000, 'ºC'),
	(289862, 142, '2015-01-01 00:35:02.000000', 'temperatura', 428.0000, 'ºC'),
	(289863, 142, '2015-01-01 00:35:03.000000', 'temperatura', 1176.0000, 'ºC'),
	(289864, 142, '2015-01-01 00:35:04.000000', 'temperatura', 998.0000, 'ºC'),
	(289865, 142, '2015-01-01 00:35:05.000000', 'temperatura', 261.0000, 'ºC'),
	(289866, 142, '2015-01-01 00:35:06.000000', 'temperatura', 712.0000, 'ºC'),
	(289867, 142, '2015-01-01 00:35:07.000000', 'temperatura', 378.0000, 'ºC'),
	(289868, 142, '2015-01-01 00:35:08.000000', 'temperatura', 954.0000, 'ºC'),
	(289869, 142, '2015-01-01 00:35:09.000000', 'temperatura', 36.0000, 'ºC'),
	(289870, 142, '2015-01-01 00:35:10.000000', 'temperatura', 919.0000, 'ºC'),
	(289871, 142, '2015-01-01 00:35:11.000000', 'temperatura', 887.0000, 'ºC'),
	(289872, 142, '2015-01-01 00:35:12.000000', 'temperatura', 480.0000, 'ºC'),
	(289873, 142, '2015-01-01 00:35:13.000000', 'temperatura', 939.0000, 'ºC'),
	(289874, 142, '2015-01-01 00:35:14.000000', 'temperatura', 857.0000, 'ºC'),
	(289875, 142, '2015-01-01 00:35:15.000000', 'temperatura', 265.0000, 'ºC'),
	(289876, 142, '2015-01-01 00:35:16.000000', 'temperatura', 1158.0000, 'ºC'),
	(289877, 142, '2015-01-01 00:35:17.000000', 'temperatura', 192.0000, 'ºC'),
	(289878, 142, '2015-01-01 00:35:18.000000', 'temperatura', 1089.0000, 'ºC'),
	(289879, 142, '2015-01-01 00:35:19.000000', 'temperatura', 67.0000, 'ºC'),
	(289880, 142, '2015-01-01 00:35:20.000000', 'temperatura', 671.0000, 'ºC'),
	(289881, 142, '2015-01-01 00:35:21.000000', 'temperatura', 753.0000, 'ºC'),
	(289882, 142, '2015-01-01 00:35:22.000000', 'temperatura', 555.0000, 'ºC'),
	(289883, 142, '2015-01-01 00:35:23.000000', 'temperatura', 514.0000, 'ºC'),
	(289884, 142, '2015-01-01 00:35:24.000000', 'temperatura', 904.0000, 'ºC'),
	(289885, 142, '2015-01-01 00:35:25.000000', 'temperatura', 582.0000, 'ºC'),
	(289886, 142, '2015-01-01 00:35:26.000000', 'temperatura', 196.0000, 'ºC'),
	(289887, 142, '2015-01-01 00:35:27.000000', 'temperatura', 434.0000, 'ºC'),
	(289888, 142, '2015-01-01 00:35:28.000000', 'temperatura', 382.0000, 'ºC'),
	(289889, 142, '2015-01-01 00:35:29.000000', 'temperatura', 611.0000, 'ºC'),
	(289890, 142, '2015-01-01 00:35:30.000000', 'temperatura', 709.0000, 'ºC'),
	(289891, 142, '2015-01-01 00:35:31.000000', 'temperatura', 513.0000, 'ºC'),
	(289892, 142, '2015-01-01 00:35:32.000000', 'temperatura', 440.0000, 'ºC'),
	(289893, 142, '2015-01-01 00:35:33.000000', 'temperatura', 658.0000, 'ºC'),
	(289894, 142, '2015-01-01 00:35:34.000000', 'temperatura', 772.0000, 'ºC'),
	(289895, 142, '2015-01-01 00:35:35.000000', 'temperatura', 686.0000, 'ºC'),
	(289896, 142, '2015-01-01 00:35:36.000000', 'temperatura', 1115.0000, 'ºC'),
	(289897, 142, '2015-01-01 00:35:37.000000', 'temperatura', 1118.0000, 'ºC'),
	(289898, 142, '2015-01-01 00:35:38.000000', 'temperatura', 1046.0000, 'ºC'),
	(289899, 142, '2015-01-01 00:35:39.000000', 'temperatura', 674.0000, 'ºC'),
	(289900, 142, '2015-01-01 00:35:40.000000', 'temperatura', 233.0000, 'ºC'),
	(289901, 142, '2015-01-01 00:35:41.000000', 'temperatura', 344.0000, 'ºC'),
	(289902, 142, '2015-01-01 00:35:42.000000', 'temperatura', 1023.0000, 'ºC'),
	(289903, 142, '2015-01-01 00:35:43.000000', 'temperatura', 482.0000, 'ºC'),
	(289904, 142, '2015-01-01 00:35:44.000000', 'temperatura', 542.0000, 'ºC'),
	(289905, 142, '2015-01-01 00:35:45.000000', 'temperatura', 63.0000, 'ºC'),
	(289906, 142, '2015-01-01 00:35:46.000000', 'temperatura', 1091.0000, 'ºC'),
	(289907, 142, '2015-01-01 00:35:47.000000', 'temperatura', 466.0000, 'ºC'),
	(289908, 142, '2015-01-01 00:35:48.000000', 'temperatura', 257.0000, 'ºC'),
	(289909, 142, '2015-01-01 00:35:49.000000', 'temperatura', 1088.0000, 'ºC'),
	(289910, 142, '2015-01-01 00:35:50.000000', 'temperatura', 1070.0000, 'ºC'),
	(289911, 142, '2015-01-01 00:35:51.000000', 'temperatura', 887.0000, 'ºC'),
	(289912, 142, '2015-01-01 00:35:52.000000', 'temperatura', 24.0000, 'ºC'),
	(289913, 142, '2015-01-01 00:35:53.000000', 'temperatura', 1059.0000, 'ºC'),
	(289914, 142, '2015-01-01 00:35:54.000000', 'temperatura', 426.0000, 'ºC'),
	(289915, 142, '2015-01-01 00:35:55.000000', 'temperatura', 152.0000, 'ºC'),
	(289916, 142, '2015-01-01 00:35:56.000000', 'temperatura', 684.0000, 'ºC'),
	(289917, 142, '2015-01-01 00:35:57.000000', 'temperatura', 565.0000, 'ºC'),
	(289918, 142, '2015-01-01 00:35:58.000000', 'temperatura', 772.0000, 'ºC'),
	(289919, 142, '2015-01-01 00:35:59.000000', 'temperatura', 967.0000, 'ºC'),
	(289920, 142, '2015-01-01 00:36:00.000000', 'temperatura', 117.0000, 'ºC'),
	(289921, 142, '2015-01-01 00:36:01.000000', 'temperatura', 87.0000, 'ºC'),
	(289922, 142, '2015-01-01 00:36:02.000000', 'temperatura', 85.0000, 'ºC'),
	(289923, 142, '2015-01-01 00:36:03.000000', 'temperatura', 163.0000, 'ºC'),
	(289924, 142, '2015-01-01 00:36:04.000000', 'temperatura', 562.0000, 'ºC'),
	(289925, 142, '2015-01-01 00:36:05.000000', 'temperatura', 1123.0000, 'ºC'),
	(289926, 142, '2015-01-01 00:36:06.000000', 'temperatura', 327.0000, 'ºC'),
	(289927, 142, '2015-01-01 00:36:07.000000', 'temperatura', 666.0000, 'ºC'),
	(289928, 142, '2015-01-01 00:36:08.000000', 'temperatura', 1152.0000, 'ºC'),
	(289929, 142, '2015-01-01 00:36:09.000000', 'temperatura', 159.0000, 'ºC'),
	(289930, 142, '2015-01-01 00:36:10.000000', 'temperatura', 942.0000, 'ºC'),
	(289931, 142, '2015-01-01 00:36:11.000000', 'temperatura', 632.0000, 'ºC'),
	(289932, 142, '2015-01-01 00:36:12.000000', 'temperatura', 335.0000, 'ºC'),
	(289933, 142, '2015-01-01 00:36:13.000000', 'temperatura', 980.0000, 'ºC'),
	(289934, 142, '2015-01-01 00:36:14.000000', 'temperatura', 297.0000, 'ºC'),
	(289935, 142, '2015-01-01 00:36:15.000000', 'temperatura', 945.0000, 'ºC'),
	(289936, 142, '2015-01-01 00:36:16.000000', 'temperatura', 236.0000, 'ºC'),
	(289937, 142, '2015-01-01 00:36:17.000000', 'temperatura', 743.0000, 'ºC'),
	(289938, 142, '2015-01-01 00:36:18.000000', 'temperatura', 607.0000, 'ºC'),
	(289939, 142, '2015-01-01 00:36:19.000000', 'temperatura', 809.0000, 'ºC'),
	(289940, 142, '2015-01-01 00:36:20.000000', 'temperatura', 1025.0000, 'ºC'),
	(289941, 142, '2015-01-01 00:36:21.000000', 'temperatura', 298.0000, 'ºC'),
	(289942, 142, '2015-01-01 00:36:22.000000', 'temperatura', 814.0000, 'ºC'),
	(289943, 142, '2015-01-01 00:36:23.000000', 'temperatura', 778.0000, 'ºC'),
	(289944, 142, '2015-01-01 00:36:24.000000', 'temperatura', 249.0000, 'ºC'),
	(289945, 142, '2015-01-01 00:36:25.000000', 'temperatura', 110.0000, 'ºC'),
	(289946, 142, '2015-01-01 00:36:26.000000', 'temperatura', 1002.0000, 'ºC'),
	(289947, 142, '2015-01-01 00:36:27.000000', 'temperatura', 1082.0000, 'ºC'),
	(289948, 142, '2015-01-01 00:36:28.000000', 'temperatura', 3.0000, 'ºC'),
	(289949, 142, '2015-01-01 00:36:29.000000', 'temperatura', 369.0000, 'ºC'),
	(289950, 142, '2015-01-01 00:36:30.000000', 'temperatura', 636.0000, 'ºC'),
	(289951, 142, '2015-01-01 00:36:31.000000', 'temperatura', 876.0000, 'ºC'),
	(289952, 142, '2015-01-01 00:36:32.000000', 'temperatura', 73.0000, 'ºC'),
	(289953, 142, '2015-01-01 00:36:33.000000', 'temperatura', 136.0000, 'ºC'),
	(289954, 142, '2015-01-01 00:36:34.000000', 'temperatura', 463.0000, 'ºC'),
	(289955, 142, '2015-01-01 00:36:35.000000', 'temperatura', 709.0000, 'ºC'),
	(289956, 142, '2015-01-01 00:36:36.000000', 'temperatura', 953.0000, 'ºC'),
	(289957, 142, '2015-01-01 00:36:37.000000', 'temperatura', 242.0000, 'ºC'),
	(289958, 142, '2015-01-01 00:36:38.000000', 'temperatura', 749.0000, 'ºC'),
	(289959, 142, '2015-01-01 00:36:39.000000', 'temperatura', 619.0000, 'ºC'),
	(289960, 142, '2015-01-01 00:36:40.000000', 'temperatura', 847.0000, 'ºC'),
	(289961, 142, '2015-01-01 00:36:41.000000', 'temperatura', 1181.0000, 'ºC'),
	(289962, 142, '2015-01-01 00:36:42.000000', 'temperatura', 966.0000, 'ºC'),
	(289963, 142, '2015-01-01 00:36:43.000000', 'temperatura', 85.0000, 'ºC'),
	(289964, 142, '2015-01-01 00:36:44.000000', 'temperatura', 1126.0000, 'ºC'),
	(289965, 142, '2015-01-01 00:36:45.000000', 'temperatura', 578.0000, 'ºC'),
	(289966, 142, '2015-01-01 00:36:46.000000', 'temperatura', 711.0000, 'ºC'),
	(289967, 142, '2015-01-01 00:36:47.000000', 'temperatura', 623.0000, 'ºC'),
	(289968, 142, '2015-01-01 00:36:48.000000', 'temperatura', 983.0000, 'ºC'),
	(289969, 142, '2015-01-01 00:36:49.000000', 'temperatura', 648.0000, 'ºC'),
	(289970, 142, '2015-01-01 00:36:50.000000', 'temperatura', 288.0000, 'ºC'),
	(289971, 142, '2015-01-01 00:36:51.000000', 'temperatura', 699.0000, 'ºC'),
	(289972, 142, '2015-01-01 00:36:52.000000', 'temperatura', 229.0000, 'ºC'),
	(289973, 142, '2015-01-01 00:36:53.000000', 'temperatura', 250.0000, 'ºC'),
	(289974, 142, '2015-01-01 00:36:54.000000', 'temperatura', 564.0000, 'ºC'),
	(289975, 142, '2015-01-01 00:36:55.000000', 'temperatura', 869.0000, 'ºC'),
	(289976, 142, '2015-01-01 00:36:56.000000', 'temperatura', 256.0000, 'ºC'),
	(289977, 142, '2015-01-01 00:36:57.000000', 'temperatura', 1070.0000, 'ºC'),
	(289978, 142, '2015-01-01 00:36:58.000000', 'temperatura', 985.0000, 'ºC'),
	(289979, 142, '2015-01-01 00:36:59.000000', 'temperatura', 514.0000, 'ºC'),
	(289980, 142, '2015-01-01 00:37:00.000000', 'temperatura', 816.0000, 'ºC'),
	(289981, 142, '2015-01-01 00:37:01.000000', 'temperatura', 140.0000, 'ºC'),
	(289982, 142, '2015-01-01 00:37:02.000000', 'temperatura', 650.0000, 'ºC'),
	(289983, 142, '2015-01-01 00:37:03.000000', 'temperatura', 432.0000, 'ºC'),
	(289984, 142, '2015-01-01 00:37:04.000000', 'temperatura', 208.0000, 'ºC'),
	(289985, 142, '2015-01-01 00:37:05.000000', 'temperatura', 948.0000, 'ºC'),
	(289986, 142, '2015-01-01 00:37:06.000000', 'temperatura', 515.0000, 'ºC'),
	(289987, 142, '2015-01-01 00:37:07.000000', 'temperatura', 931.0000, 'ºC'),
	(289988, 142, '2015-01-01 00:37:08.000000', 'temperatura', 711.0000, 'ºC'),
	(289989, 142, '2015-01-01 00:37:09.000000', 'temperatura', 762.0000, 'ºC'),
	(289990, 142, '2015-01-01 00:37:10.000000', 'temperatura', 480.0000, 'ºC'),
	(289991, 142, '2015-01-01 00:37:11.000000', 'temperatura', 112.0000, 'ºC'),
	(289992, 142, '2015-01-01 00:37:12.000000', 'temperatura', 320.0000, 'ºC'),
	(289993, 142, '2015-01-01 00:37:13.000000', 'temperatura', 65.0000, 'ºC'),
	(289994, 142, '2015-01-01 00:37:14.000000', 'temperatura', 567.0000, 'ºC'),
	(289995, 142, '2015-01-01 00:37:15.000000', 'temperatura', 240.0000, 'ºC'),
	(289996, 142, '2015-01-01 00:37:16.000000', 'temperatura', 701.0000, 'ºC'),
	(289997, 142, '2015-01-01 00:37:17.000000', 'temperatura', 385.0000, 'ºC'),
	(289998, 142, '2015-01-01 00:37:18.000000', 'temperatura', 1022.0000, 'ºC'),
	(289999, 142, '2015-01-01 00:37:19.000000', 'temperatura', 355.0000, 'ºC'),
	(290000, 142, '2015-01-01 00:37:20.000000', 'temperatura', 1108.0000, 'ºC'),
	(290001, 142, '2015-01-01 00:37:21.000000', 'temperatura', 877.0000, 'ºC'),
	(290002, 142, '2015-01-01 00:37:22.000000', 'temperatura', 1061.0000, 'ºC'),
	(290003, 142, '2015-01-01 00:37:23.000000', 'temperatura', 274.0000, 'ºC'),
	(290004, 142, '2015-01-01 00:37:24.000000', 'temperatura', 588.0000, 'ºC'),
	(290005, 142, '2015-01-01 00:37:25.000000', 'temperatura', 917.0000, 'ºC'),
	(290006, 142, '2015-01-01 00:37:26.000000', 'temperatura', 425.0000, 'ºC'),
	(290007, 142, '2015-01-01 00:37:27.000000', 'temperatura', 571.0000, 'ºC'),
	(290008, 142, '2015-01-01 00:37:28.000000', 'temperatura', 383.0000, 'ºC'),
	(290009, 142, '2015-01-01 00:37:29.000000', 'temperatura', 202.0000, 'ºC'),
	(290010, 142, '2015-01-01 00:37:30.000000', 'temperatura', 1060.0000, 'ºC'),
	(290011, 142, '2015-01-01 00:37:31.000000', 'temperatura', 1097.0000, 'ºC'),
	(290012, 142, '2015-01-01 00:37:32.000000', 'temperatura', 1105.0000, 'ºC'),
	(290013, 142, '2015-01-01 00:37:33.000000', 'temperatura', 1033.0000, 'ºC'),
	(290014, 142, '2015-01-01 00:37:34.000000', 'temperatura', 653.0000, 'ºC'),
	(290015, 142, '2015-01-01 00:37:35.000000', 'temperatura', 166.0000, 'ºC'),
	(290016, 142, '2015-01-01 00:37:36.000000', 'temperatura', 72.0000, 'ºC'),
	(290017, 142, '2015-01-01 00:37:37.000000', 'temperatura', 1064.0000, 'ºC'),
	(290018, 142, '2015-01-01 00:37:38.000000', 'temperatura', 301.0000, 'ºC'),
	(290019, 142, '2015-01-01 00:37:39.000000', 'temperatura', 716.0000, 'ºC'),
	(290020, 142, '2015-01-01 00:37:40.000000', 'temperatura', 278.0000, 'ºC'),
	(290021, 142, '2015-01-01 00:37:41.000000', 'temperatura', 442.0000, 'ºC'),
	(290022, 142, '2015-01-01 00:37:42.000000', 'temperatura', 177.0000, 'ºC'),
	(290023, 142, '2015-01-01 00:37:43.000000', 'temperatura', 760.0000, 'ºC'),
	(290024, 142, '2015-01-01 00:37:44.000000', 'temperatura', 867.0000, 'ºC'),
	(290025, 142, '2015-01-01 00:37:45.000000', 'temperatura', 858.0000, 'ºC'),
	(290026, 142, '2015-01-01 00:37:46.000000', 'temperatura', 489.0000, 'ºC'),
	(290027, 142, '2015-01-01 00:37:47.000000', 'temperatura', 1070.0000, 'ºC'),
	(290028, 142, '2015-01-01 00:37:48.000000', 'temperatura', 284.0000, 'ºC'),
	(290029, 142, '2015-01-01 00:37:49.000000', 'temperatura', 610.0000, 'ºC'),
	(290030, 142, '2015-01-01 00:37:50.000000', 'temperatura', 999.0000, 'ºC'),
	(290031, 142, '2015-01-01 00:37:51.000000', 'temperatura', 767.0000, 'ºC'),
	(290032, 142, '2015-01-01 00:37:52.000000', 'temperatura', 836.0000, 'ºC'),
	(290033, 142, '2015-01-01 00:37:53.000000', 'temperatura', 682.0000, 'ºC'),
	(290034, 142, '2015-01-01 00:37:54.000000', 'temperatura', 903.0000, 'ºC'),
	(290035, 142, '2015-01-01 00:37:55.000000', 'temperatura', 69.0000, 'ºC'),
	(290036, 142, '2015-01-01 00:37:56.000000', 'temperatura', 35.0000, 'ºC'),
	(290037, 142, '2015-01-01 00:37:57.000000', 'temperatura', 1171.0000, 'ºC'),
	(290038, 142, '2015-01-01 00:37:58.000000', 'temperatura', 951.0000, 'ºC'),
	(290039, 142, '2015-01-01 00:37:59.000000', 'temperatura', 41.0000, 'ºC'),
	(290040, 142, '2015-01-01 00:38:00.000000', 'temperatura', 953.0000, 'ºC'),
	(290041, 142, '2015-01-01 00:38:01.000000', 'temperatura', 1040.0000, 'ºC'),
	(290042, 142, '2015-01-01 00:38:02.000000', 'temperatura', 1145.0000, 'ºC'),
	(290043, 142, '2015-01-01 00:38:03.000000', 'temperatura', 205.0000, 'ºC'),
	(290044, 142, '2015-01-01 00:38:04.000000', 'temperatura', 1188.0000, 'ºC'),
	(290045, 142, '2015-01-01 00:38:05.000000', 'temperatura', 527.0000, 'ºC'),
	(290046, 142, '2015-01-01 00:38:06.000000', 'temperatura', 271.0000, 'ºC'),
	(290047, 142, '2015-01-01 00:38:07.000000', 'temperatura', 976.0000, 'ºC'),
	(290048, 142, '2015-01-01 00:38:08.000000', 'temperatura', 467.0000, 'ºC'),
	(290049, 142, '2015-01-01 00:38:09.000000', 'temperatura', 609.0000, 'ºC'),
	(290050, 142, '2015-01-01 00:38:10.000000', 'temperatura', 443.0000, 'ºC'),
	(290051, 142, '2015-01-01 00:38:11.000000', 'temperatura', 390.0000, 'ºC'),
	(290052, 142, '2015-01-01 00:38:12.000000', 'temperatura', 619.0000, 'ºC'),
	(290053, 142, '2015-01-01 00:38:13.000000', 'temperatura', 728.0000, 'ºC'),
	(290054, 142, '2015-01-01 00:38:14.000000', 'temperatura', 584.0000, 'ºC'),
	(290055, 142, '2015-01-01 00:38:15.000000', 'temperatura', 734.0000, 'ºC'),
	(290056, 142, '2015-01-01 00:38:16.000000', 'temperatura', 719.0000, 'ºC'),
	(290057, 142, '2015-01-01 00:38:17.000000', 'temperatura', 193.0000, 'ºC'),
	(290058, 142, '2015-01-01 00:38:18.000000', 'temperatura', 11.0000, 'ºC'),
	(290059, 142, '2015-01-01 00:38:19.000000', 'temperatura', 675.0000, 'ºC'),
	(290060, 142, '2015-01-01 00:38:20.000000', 'temperatura', 941.0000, 'ºC'),
	(290061, 142, '2015-01-01 00:38:21.000000', 'temperatura', 281.0000, 'ºC'),
	(290062, 142, '2015-01-01 00:38:22.000000', 'temperatura', 984.0000, 'ºC'),
	(290063, 142, '2015-01-01 00:38:23.000000', 'temperatura', 477.0000, 'ºC'),
	(290064, 142, '2015-01-01 00:38:24.000000', 'temperatura', 632.0000, 'ºC'),
	(290065, 142, '2015-01-01 00:38:25.000000', 'temperatura', 530.0000, 'ºC'),
	(290066, 142, '2015-01-01 00:38:26.000000', 'temperatura', 755.0000, 'ºC'),
	(290067, 142, '2015-01-01 00:38:27.000000', 'temperatura', 987.0000, 'ºC'),
	(290068, 142, '2015-01-01 00:38:28.000000', 'temperatura', 268.0000, 'ºC'),
	(290069, 142, '2015-01-01 00:38:29.000000', 'temperatura', 781.0000, 'ºC'),
	(290070, 142, '2015-01-01 00:38:30.000000', 'temperatura', 701.0000, 'ºC'),
	(290071, 142, '2015-01-01 00:38:31.000000', 'temperatura', 1162.0000, 'ºC'),
	(290072, 142, '2015-01-01 00:38:32.000000', 'temperatura', 109.0000, 'ºC'),
	(290073, 142, '2015-01-01 00:38:33.000000', 'temperatura', 658.0000, 'ºC'),
	(290074, 142, '2015-01-01 00:38:34.000000', 'temperatura', 566.0000, 'ºC'),
	(290075, 142, '2015-01-01 00:38:35.000000', 'temperatura', 853.0000, 'ºC'),
	(290076, 142, '2015-01-01 00:38:36.000000', 'temperatura', 170.0000, 'ºC'),
	(290077, 142, '2015-01-01 00:38:37.000000', 'temperatura', 693.0000, 'ºC'),
	(290078, 142, '2015-01-01 00:38:38.000000', 'temperatura', 552.0000, 'ºC'),
	(290079, 142, '2015-01-01 00:38:39.000000', 'temperatura', 684.0000, 'ºC'),
	(290080, 142, '2015-01-01 00:38:40.000000', 'temperatura', 565.0000, 'ºC'),
	(290081, 142, '2015-01-01 00:38:41.000000', 'temperatura', 774.0000, 'ºC'),
	(290082, 142, '2015-01-01 00:38:42.000000', 'temperatura', 973.0000, 'ºC'),
	(290083, 142, '2015-01-01 00:38:43.000000', 'temperatura', 146.0000, 'ºC'),
	(290084, 142, '2015-01-01 00:38:44.000000', 'temperatura', 209.0000, 'ºC'),
	(290085, 142, '2015-01-01 00:38:45.000000', 'temperatura', 609.0000, 'ºC'),
	(290086, 142, '2015-01-01 00:38:46.000000', 'temperatura', 18.0000, 'ºC'),
	(290087, 142, '2015-01-01 00:38:47.000000', 'temperatura', 664.0000, 'ºC'),
	(290088, 142, '2015-01-01 00:38:48.000000', 'temperatura', 864.0000, 'ºC'),
	(290089, 142, '2015-01-01 00:38:49.000000', 'temperatura', 1131.0000, 'ºC'),
	(290090, 142, '2015-01-01 00:38:50.000000', 'temperatura', 663.0000, 'ºC'),
	(290091, 142, '2015-01-01 00:38:51.000000', 'temperatura', 1123.0000, 'ºC'),
	(290092, 142, '2015-01-01 00:38:52.000000', 'temperatura', 26.0000, 'ºC'),
	(290093, 142, '2015-01-01 00:38:53.000000', 'temperatura', 363.0000, 'ºC'),
	(290094, 142, '2015-01-01 00:38:54.000000', 'temperatura', 534.0000, 'ºC'),
	(290095, 142, '2015-01-01 00:38:55.000000', 'temperatura', 385.0000, 'ºC'),
	(290096, 142, '2015-01-01 00:38:56.000000', 'temperatura', 323.0000, 'ºC'),
	(290097, 142, '2015-01-01 00:38:57.000000', 'temperatura', 458.0000, 'ºC'),
	(290098, 142, '2015-01-01 00:38:58.000000', 'temperatura', 123.0000, 'ºC'),
	(290099, 142, '2015-01-01 00:38:59.000000', 'temperatura', 442.0000, 'ºC'),
	(290100, 142, '2015-01-01 00:39:00.000000', 'temperatura', 639.0000, 'ºC'),
	(290101, 142, '2015-01-01 00:39:01.000000', 'temperatura', 673.0000, 'ºC'),
	(290102, 142, '2015-01-01 00:39:02.000000', 'temperatura', 245.0000, 'ºC'),
	(290103, 142, '2015-01-01 00:39:03.000000', 'temperatura', 409.0000, 'ºC'),
	(290104, 142, '2015-01-01 00:39:04.000000', 'temperatura', 109.0000, 'ºC'),
	(290105, 142, '2015-01-01 00:39:05.000000', 'temperatura', 519.0000, 'ºC'),
	(290106, 142, '2015-01-01 00:39:06.000000', 'temperatura', 1070.0000, 'ºC'),
	(290107, 142, '2015-01-01 00:39:07.000000', 'temperatura', 193.0000, 'ºC'),
	(290108, 142, '2015-01-01 00:39:08.000000', 'temperatura', 157.0000, 'ºC'),
	(290109, 142, '2015-01-01 00:39:09.000000', 'temperatura', 206.0000, 'ºC'),
	(290110, 142, '2015-01-01 00:39:10.000000', 'temperatura', 558.0000, 'ºC'),
	(290111, 142, '2015-01-01 00:39:11.000000', 'temperatura', 974.0000, 'ºC'),
	(290112, 142, '2015-01-01 00:39:12.000000', 'temperatura', 795.0000, 'ºC'),
	(290113, 142, '2015-01-01 00:39:13.000000', 'temperatura', 1052.0000, 'ºC'),
	(290114, 142, '2015-01-01 00:39:14.000000', 'temperatura', 478.0000, 'ºC'),
	(290115, 142, '2015-01-01 00:39:15.000000', 'temperatura', 432.0000, 'ºC'),
	(290116, 142, '2015-01-01 00:39:16.000000', 'temperatura', 729.0000, 'ºC'),
	(290117, 142, '2015-01-01 00:39:17.000000', 'temperatura', 1149.0000, 'ºC'),
	(290118, 142, '2015-01-01 00:39:18.000000', 'temperatura', 1159.0000, 'ºC'),
	(290119, 142, '2015-01-01 00:39:19.000000', 'temperatura', 1149.0000, 'ºC'),
	(290120, 142, '2015-01-01 00:39:20.000000', 'temperatura', 1067.0000, 'ºC'),
	(290121, 142, '2015-01-01 00:39:21.000000', 'temperatura', 689.0000, 'ºC'),
	(290122, 142, '2015-01-01 00:39:22.000000', 'temperatura', 245.0000, 'ºC'),
	(290123, 142, '2015-01-01 00:39:23.000000', 'temperatura', 360.0000, 'ºC'),
	(290124, 142, '2015-01-01 00:39:24.000000', 'temperatura', 1064.0000, 'ºC'),
	(290125, 142, '2015-01-01 00:39:25.000000', 'temperatura', 641.0000, 'ºC'),
	(290126, 142, '2015-01-01 00:39:26.000000', 'temperatura', 14.0000, 'ºC'),
	(290127, 142, '2015-01-01 00:39:27.000000', 'temperatura', 548.0000, 'ºC'),
	(290128, 142, '2015-01-01 00:39:28.000000', 'temperatura', 299.0000, 'ºC'),
	(290129, 142, '2015-01-01 00:39:29.000000', 'temperatura', 1049.0000, 'ºC'),
	(290130, 142, '2015-01-01 00:39:30.000000', 'temperatura', 749.0000, 'ºC'),
	(290131, 142, '2015-01-01 00:39:31.000000', 'temperatura', 600.0000, 'ºC'),
	(290132, 142, '2015-01-01 00:39:32.000000', 'temperatura', 751.0000, 'ºC'),
	(290133, 142, '2015-01-01 00:39:33.000000', 'temperatura', 755.0000, 'ºC'),
	(290134, 142, '2015-01-01 00:39:34.000000', 'temperatura', 326.0000, 'ºC'),
	(290135, 142, '2015-01-01 00:39:35.000000', 'temperatura', 563.0000, 'ºC'),
	(290136, 142, '2015-01-01 00:39:36.000000', 'temperatura', 639.0000, 'ºC'),
	(290137, 142, '2015-01-01 00:39:37.000000', 'temperatura', 305.0000, 'ºC'),
	(290138, 142, '2015-01-01 00:39:38.000000', 'temperatura', 808.0000, 'ºC'),
	(290139, 142, '2015-01-01 00:39:39.000000', 'temperatura', 725.0000, 'ºC'),
	(290140, 142, '2015-01-01 00:39:40.000000', 'temperatura', 4.0000, 'ºC'),
	(290141, 142, '2015-01-01 00:39:41.000000', 'temperatura', 246.0000, 'ºC'),
	(290142, 142, '2015-01-01 00:39:42.000000', 'temperatura', 15.0000, 'ºC'),
	(290143, 142, '2015-01-01 00:39:43.000000', 'temperatura', 541.0000, 'ºC'),
	(290144, 142, '2015-01-01 00:39:44.000000', 'temperatura', 258.0000, 'ºC'),
	(290145, 142, '2015-01-01 00:39:45.000000', 'temperatura', 869.0000, 'ºC'),
	(290146, 142, '2015-01-01 00:39:46.000000', 'temperatura', 1170.0000, 'ºC'),
	(290147, 142, '2015-01-01 00:39:47.000000', 'temperatura', 844.0000, 'ºC'),
	(290148, 142, '2015-01-01 00:39:48.000000', 'temperatura', 711.0000, 'ºC'),
	(290149, 142, '2015-01-01 00:39:49.000000', 'temperatura', 1022.0000, 'ºC'),
	(290150, 142, '2015-01-01 00:39:50.000000', 'temperatura', 578.0000, 'ºC'),
	(290151, 142, '2015-01-01 00:39:51.000000', 'temperatura', 1025.0000, 'ºC'),
	(290152, 142, '2015-01-01 00:39:52.000000', 'temperatura', 993.0000, 'ºC'),
	(290153, 142, '2015-01-01 00:39:53.000000', 'temperatura', 691.0000, 'ºC'),
	(290154, 142, '2015-01-01 00:39:54.000000', 'temperatura', 473.0000, 'ºC'),
	(290155, 142, '2015-01-01 00:39:55.000000', 'temperatura', 295.0000, 'ºC'),
	(290156, 142, '2015-01-01 00:39:56.000000', 'temperatura', 57.0000, 'ºC'),
	(290157, 142, '2015-01-01 00:39:57.000000', 'temperatura', 598.0000, 'ºC'),
	(290158, 142, '2015-01-01 00:39:58.000000', 'temperatura', 420.0000, 'ºC'),
	(290159, 142, '2015-01-01 00:39:59.000000', 'temperatura', 308.0000, 'ºC'),
	(290160, 142, '2015-01-01 00:40:00.000000', 'temperatura', 279.0000, 'ºC'),
	(290161, 142, '2015-01-01 00:40:01.000000', 'temperatura', 471.0000, 'ºC'),
	(290162, 142, '2015-01-01 00:40:02.000000', 'temperatura', 317.0000, 'ºC'),
	(290163, 142, '2015-01-01 00:40:03.000000', 'temperatura', 176.0000, 'ºC'),
	(290164, 142, '2015-01-01 00:40:04.000000', 'temperatura', 1128.0000, 'ºC'),
	(290165, 142, '2015-01-01 00:40:05.000000', 'temperatura', 312.0000, 'ºC'),
	(290166, 142, '2015-01-01 00:40:06.000000', 'temperatura', 577.0000, 'ºC'),
	(290167, 142, '2015-01-01 00:40:07.000000', 'temperatura', 749.0000, 'ºC'),
	(290168, 142, '2015-01-01 00:40:08.000000', 'temperatura', 815.0000, 'ºC'),
	(290169, 142, '2015-01-01 00:40:09.000000', 'temperatura', 627.0000, 'ºC'),
	(290170, 142, '2015-01-01 00:40:10.000000', 'temperatura', 690.0000, 'ºC'),
	(290171, 142, '2015-01-01 00:40:11.000000', 'temperatura', 371.0000, 'ºC'),
	(290172, 142, '2015-01-01 00:40:12.000000', 'temperatura', 984.0000, 'ºC'),
	(290173, 142, '2015-01-01 00:40:13.000000', 'temperatura', 210.0000, 'ºC'),
	(290174, 142, '2015-01-01 00:40:14.000000', 'temperatura', 496.0000, 'ºC'),
	(290175, 142, '2015-01-01 00:40:15.000000', 'temperatura', 651.0000, 'ºC'),
	(290176, 142, '2015-01-01 00:40:16.000000', 'temperatura', 566.0000, 'ºC'),
	(290177, 142, '2015-01-01 00:40:17.000000', 'temperatura', 880.0000, 'ºC'),
	(290178, 142, '2015-01-01 00:40:18.000000', 'temperatura', 300.0000, 'ºC'),
	(290179, 142, '2015-01-01 00:40:19.000000', 'temperatura', 61.0000, 'ºC'),
	(290180, 142, '2015-01-01 00:40:20.000000', 'temperatura', 605.0000, 'ºC'),
	(290181, 142, '2015-01-01 00:40:21.000000', 'temperatura', 443.0000, 'ºC'),
	(290182, 142, '2015-01-01 00:40:22.000000', 'temperatura', 400.0000, 'ºC'),
	(290183, 142, '2015-01-01 00:40:23.000000', 'temperatura', 671.0000, 'ºC'),
	(290184, 142, '2015-01-01 00:40:24.000000', 'temperatura', 955.0000, 'ºC'),
	(290185, 142, '2015-01-01 00:40:25.000000', 'temperatura', 364.0000, 'ºC'),
	(290186, 142, '2015-01-01 00:40:26.000000', 'temperatura', 155.0000, 'ºC'),
	(290187, 142, '2015-01-01 00:40:27.000000', 'temperatura', 885.0000, 'ºC'),
	(290188, 142, '2015-01-01 00:40:28.000000', 'temperatura', 361.0000, 'ºC'),
	(290189, 142, '2015-01-01 00:40:29.000000', 'temperatura', 348.0000, 'ºC'),
	(290190, 142, '2015-01-01 00:40:30.000000', 'temperatura', 658.0000, 'ºC'),
	(290191, 142, '2015-01-01 00:40:31.000000', 'temperatura', 1047.0000, 'ºC'),
	(290192, 142, '2015-01-01 00:40:32.000000', 'temperatura', 863.0000, 'ºC'),
	(290193, 142, '2015-01-01 00:40:33.000000', 'temperatura', 1171.0000, 'ºC'),
	(290194, 142, '2015-01-01 00:40:34.000000', 'temperatura', 869.0000, 'ºC'),
	(290195, 142, '2015-01-01 00:40:35.000000', 'temperatura', 833.0000, 'ºC'),
	(290196, 142, '2015-01-01 00:40:36.000000', 'temperatura', 356.0000, 'ºC'),
	(290197, 142, '2015-01-01 00:40:37.000000', 'temperatura', 482.0000, 'ºC'),
	(290198, 142, '2015-01-01 00:40:38.000000', 'temperatura', 145.0000, 'ºC'),
	(290199, 142, '2015-01-01 00:40:39.000000', 'temperatura', 477.0000, 'ºC'),
	(290200, 142, '2015-01-01 00:40:40.000000', 'temperatura', 750.0000, 'ºC'),
	(290201, 142, '2015-01-01 00:40:41.000000', 'temperatura', 1119.0000, 'ºC'),
	(290202, 142, '2015-01-01 00:40:42.000000', 'temperatura', 945.0000, 'ºC'),
	(290203, 142, '2015-01-01 00:40:43.000000', 'temperatura', 169.0000, 'ºC'),
	(290204, 142, '2015-01-01 00:40:44.000000', 'temperatura', 409.0000, 'ºC'),
	(290205, 142, '2015-01-01 00:40:45.000000', 'temperatura', 341.0000, 'ºC'),
	(290206, 142, '2015-01-01 00:40:46.000000', 'temperatura', 478.0000, 'ºC'),
	(290207, 142, '2015-01-01 00:40:47.000000', 'temperatura', 166.0000, 'ºC'),
	(290208, 142, '2015-01-01 00:40:48.000000', 'temperatura', 597.0000, 'ºC'),
	(290209, 142, '2015-01-01 00:40:49.000000', 'temperatura', 86.0000, 'ºC'),
	(290210, 142, '2015-01-01 00:40:50.000000', 'temperatura', 1042.0000, 'ºC'),
	(290211, 142, '2015-01-01 00:40:51.000000', 'temperatura', 152.0000, 'ºC'),
	(290212, 142, '2015-01-01 00:40:52.000000', 'temperatura', 33.0000, 'ºC'),
	(290213, 142, '2015-01-01 00:40:53.000000', 'temperatura', 909.0000, 'ºC'),
	(290214, 142, '2015-01-01 00:40:54.000000', 'temperatura', 850.0000, 'ºC'),
	(290215, 142, '2015-01-01 00:40:55.000000', 'temperatura', 320.0000, 'ºC'),
	(290216, 142, '2015-01-01 00:40:56.000000', 'temperatura', 251.0000, 'ºC'),
	(290217, 142, '2015-01-01 00:40:57.000000', 'temperatura', 297.0000, 'ºC'),
	(290218, 142, '2015-01-01 00:40:58.000000', 'temperatura', 733.0000, 'ºC'),
	(290219, 142, '2015-01-01 00:40:59.000000', 'temperatura', 372.0000, 'ºC'),
	(290220, 142, '2015-01-01 00:41:00.000000', 'temperatura', 864.0000, 'ºC'),
	(290221, 142, '2015-01-01 00:41:01.000000', 'temperatura', 804.0000, 'ºC'),
	(290222, 142, '2015-01-01 00:41:02.000000', 'temperatura', 228.0000, 'ºC'),
	(290223, 142, '2015-01-01 00:41:03.000000', 'temperatura', 1129.0000, 'ºC'),
	(290224, 142, '2015-01-01 00:41:04.000000', 'temperatura', 160.0000, 'ºC'),
	(290225, 142, '2015-01-01 00:41:05.000000', 'temperatura', 1013.0000, 'ºC'),
	(290226, 142, '2015-01-01 00:41:06.000000', 'temperatura', 987.0000, 'ºC'),
	(290227, 142, '2015-01-01 00:41:07.000000', 'temperatura', 695.0000, 'ºC'),
	(290228, 142, '2015-01-01 00:41:08.000000', 'temperatura', 515.0000, 'ºC'),
	(290229, 142, '2015-01-01 00:41:09.000000', 'temperatura', 489.0000, 'ºC'),
	(290230, 142, '2015-01-01 00:41:10.000000', 'temperatura', 902.0000, 'ºC'),
	(290231, 142, '2015-01-01 00:41:11.000000', 'temperatura', 645.0000, 'ºC'),
	(290232, 142, '2015-01-01 00:41:12.000000', 'temperatura', 517.0000, 'ºC'),
	(290233, 142, '2015-01-01 00:41:13.000000', 'temperatura', 651.0000, 'ºC'),
	(290234, 142, '2015-01-01 00:41:14.000000', 'temperatura', 505.0000, 'ºC'),
	(290235, 142, '2015-01-01 00:41:15.000000', 'temperatura', 570.0000, 'ºC'),
	(290236, 142, '2015-01-01 00:41:16.000000', 'temperatura', 139.0000, 'ºC'),
	(290237, 142, '2015-01-01 00:41:17.000000', 'temperatura', 185.0000, 'ºC'),
	(290238, 142, '2015-01-01 00:41:18.000000', 'temperatura', 510.0000, 'ºC'),
	(290239, 142, '2015-01-01 00:41:19.000000', 'temperatura', 792.0000, 'ºC'),
	(290240, 142, '2015-01-01 00:41:20.000000', 'temperatura', 32.0000, 'ºC'),
	(290241, 142, '2015-01-01 00:41:21.000000', 'temperatura', 183.0000, 'ºC'),
	(290242, 142, '2015-01-01 00:41:22.000000', 'temperatura', 821.0000, 'ºC'),
	(290243, 142, '2015-01-01 00:41:23.000000', 'temperatura', 1158.0000, 'ºC'),
	(290244, 142, '2015-01-01 00:41:24.000000', 'temperatura', 925.0000, 'ºC'),
	(290245, 142, '2015-01-01 00:41:25.000000', 'temperatura', 1151.0000, 'ºC'),
	(290246, 142, '2015-01-01 00:41:26.000000', 'temperatura', 584.0000, 'ºC'),
	(290247, 142, '2015-01-01 00:41:27.000000', 'temperatura', 664.0000, 'ºC'),
	(290248, 142, '2015-01-01 00:41:28.000000', 'temperatura', 368.0000, 'ºC'),
	(290249, 142, '2015-01-01 00:41:29.000000', 'temperatura', 1050.0000, 'ºC'),
	(290250, 142, '2015-01-01 00:41:30.000000', 'temperatura', 545.0000, 'ºC'),
	(290251, 142, '2015-01-01 00:41:31.000000', 'temperatura', 774.0000, 'ºC'),
	(290252, 142, '2015-01-01 00:41:32.000000', 'temperatura', 1039.0000, 'ºC'),
	(290253, 142, '2015-01-01 00:41:33.000000', 'temperatura', 470.0000, 'ºC'),
	(290254, 142, '2015-01-01 00:41:34.000000', 'temperatura', 437.0000, 'ºC'),
	(290255, 142, '2015-01-01 00:41:35.000000', 'temperatura', 774.0000, 'ºC'),
	(290256, 142, '2015-01-01 00:41:36.000000', 'temperatura', 158.0000, 'ºC'),
	(290257, 142, '2015-01-01 00:41:37.000000', 'temperatura', 870.0000, 'ºC'),
	(290258, 142, '2015-01-01 00:41:38.000000', 'temperatura', 278.0000, 'ºC'),
	(290259, 142, '2015-01-01 00:41:39.000000', 'temperatura', 1180.0000, 'ºC'),
	(290260, 142, '2015-01-01 00:41:40.000000', 'temperatura', 266.0000, 'ºC'),
	(290261, 142, '2015-01-01 00:41:41.000000', 'temperatura', 193.0000, 'ºC'),
	(290262, 142, '2015-01-01 00:41:42.000000', 'temperatura', 164.0000, 'ºC'),
	(290263, 142, '2015-01-01 00:41:43.000000', 'temperatura', 242.0000, 'ºC'),
	(290264, 142, '2015-01-01 00:41:44.000000', 'temperatura', 719.0000, 'ºC'),
	(290265, 142, '2015-01-01 00:41:45.000000', 'temperatura', 469.0000, 'ºC'),
	(290266, 142, '2015-01-01 00:41:46.000000', 'temperatura', 189.0000, 'ºC'),
	(290267, 142, '2015-01-01 00:41:47.000000', 'temperatura', 736.0000, 'ºC'),
	(290268, 142, '2015-01-01 00:41:48.000000', 'temperatura', 717.0000, 'ºC'),
	(290269, 142, '2015-01-01 00:41:49.000000', 'temperatura', 176.0000, 'ºC'),
	(290270, 142, '2015-01-01 00:41:50.000000', 'temperatura', 1130.0000, 'ºC'),
	(290271, 142, '2015-01-01 00:41:51.000000', 'temperatura', 323.0000, 'ºC'),
	(290272, 142, '2015-01-01 00:41:52.000000', 'temperatura', 624.0000, 'ºC'),
	(290273, 142, '2015-01-01 00:41:53.000000', 'temperatura', 954.0000, 'ºC'),
	(290274, 142, '2015-01-01 00:41:54.000000', 'temperatura', 499.0000, 'ºC'),
	(290275, 142, '2015-01-01 00:41:55.000000', 'temperatura', 831.0000, 'ºC'),
	(290276, 142, '2015-01-01 00:41:56.000000', 'temperatura', 258.0000, 'ºC'),
	(290277, 142, '2015-01-01 00:41:57.000000', 'temperatura', 1198.0000, 'ºC'),
	(290278, 142, '2015-01-01 00:41:58.000000', 'temperatura', 418.0000, 'ºC'),
	(290279, 142, '2015-01-01 00:41:59.000000', 'temperatura', 897.0000, 'ºC'),
	(290280, 142, '2015-01-01 00:42:00.000000', 'temperatura', 830.0000, 'ºC'),
	(290281, 142, '2015-01-01 00:42:01.000000', 'temperatura', 261.0000, 'ºC'),
	(290282, 142, '2015-01-01 00:42:02.000000', 'temperatura', 15.0000, 'ºC'),
	(290283, 142, '2015-01-01 00:42:03.000000', 'temperatura', 490.0000, 'ºC'),
	(290284, 142, '2015-01-01 00:42:04.000000', 'temperatura', 9.0000, 'ºC'),
	(290285, 142, '2015-01-01 00:42:05.000000', 'temperatura', 972.0000, 'ºC'),
	(290286, 142, '2015-01-01 00:42:06.000000', 'temperatura', 36.0000, 'ºC'),
	(290287, 142, '2015-01-01 00:42:07.000000', 'temperatura', 865.0000, 'ºC'),
	(290288, 142, '2015-01-01 00:42:08.000000', 'temperatura', 618.0000, 'ºC'),
	(290289, 142, '2015-01-01 00:42:09.000000', 'temperatura', 493.0000, 'ºC'),
	(290290, 142, '2015-01-01 00:42:10.000000', 'temperatura', 611.0000, 'ºC'),
	(290291, 142, '2015-01-01 00:42:11.000000', 'temperatura', 377.0000, 'ºC'),
	(290292, 142, '2015-01-01 00:42:12.000000', 'temperatura', 54.0000, 'ºC'),
	(290293, 142, '2015-01-01 00:42:13.000000', 'temperatura', 337.0000, 'ºC'),
	(290294, 142, '2015-01-01 00:42:14.000000', 'temperatura', 327.0000, 'ºC'),
	(290295, 142, '2015-01-01 00:42:15.000000', 'temperatura', 621.0000, 'ºC'),
	(290296, 142, '2015-01-01 00:42:16.000000', 'temperatura', 926.0000, 'ºC'),
	(290297, 142, '2015-01-01 00:42:17.000000', 'temperatura', 366.0000, 'ºC'),
	(290298, 142, '2015-01-01 00:42:18.000000', 'temperatura', 252.0000, 'ºC'),
	(290299, 142, '2015-01-01 00:42:19.000000', 'temperatura', 165.0000, 'ºC'),
	(290300, 142, '2015-01-01 00:42:20.000000', 'temperatura', 68.0000, 'ºC'),
	(290301, 142, '2015-01-01 00:42:21.000000', 'temperatura', 1047.0000, 'ºC'),
	(290302, 142, '2015-01-01 00:42:22.000000', 'temperatura', 230.0000, 'ºC'),
	(290303, 142, '2015-01-01 00:42:23.000000', 'temperatura', 410.0000, 'ºC'),
	(290304, 142, '2015-01-01 00:42:24.000000', 'temperatura', 159.0000, 'ºC'),
	(290305, 142, '2015-01-01 00:42:25.000000', 'temperatura', 766.0000, 'ºC'),
	(290306, 142, '2015-01-01 00:42:26.000000', 'temperatura', 955.0000, 'ºC'),
	(290307, 142, '2015-01-01 00:42:27.000000', 'temperatura', 76.0000, 'ºC'),
	(290308, 142, '2015-01-01 00:42:28.000000', 'temperatura', 1117.0000, 'ºC'),
	(290309, 142, '2015-01-01 00:42:29.000000', 'temperatura', 555.0000, 'ºC'),
	(290310, 142, '2015-01-01 00:42:30.000000', 'temperatura', 625.0000, 'ºC'),
	(290311, 142, '2015-01-01 00:42:31.000000', 'temperatura', 263.0000, 'ºC'),
	(290312, 142, '2015-01-01 00:42:32.000000', 'temperatura', 639.0000, 'ºC'),
	(290313, 142, '2015-01-01 00:42:33.000000', 'temperatura', 8.0000, 'ºC'),
	(290314, 142, '2015-01-01 00:42:34.000000', 'temperatura', 522.0000, 'ºC'),
	(290315, 142, '2015-01-01 00:42:35.000000', 'temperatura', 186.0000, 'ºC'),
	(290316, 142, '2015-01-01 00:42:36.000000', 'temperatura', 567.0000, 'ºC'),
	(290317, 142, '2015-01-01 00:42:37.000000', 'temperatura', 1075.0000, 'ºC'),
	(290318, 142, '2015-01-01 00:42:38.000000', 'temperatura', 77.0000, 'ºC'),
	(290319, 142, '2015-01-01 00:42:39.000000', 'temperatura', 760.0000, 'ºC'),
	(290320, 142, '2015-01-01 00:42:40.000000', 'temperatura', 1168.0000, 'ºC'),
	(290321, 142, '2015-01-01 00:42:41.000000', 'temperatura', 1161.0000, 'ºC'),
	(290322, 142, '2015-01-01 00:42:42.000000', 'temperatura', 1102.0000, 'ºC'),
	(290323, 142, '2015-01-01 00:42:43.000000', 'temperatura', 829.0000, 'ºC'),
	(290324, 142, '2015-01-01 00:42:44.000000', 'temperatura', 836.0000, 'ºC'),
	(290325, 142, '2015-01-01 00:42:45.000000', 'temperatura', 496.0000, 'ºC'),
	(290326, 142, '2015-01-01 00:42:46.000000', 'temperatura', 1173.0000, 'ºC'),
	(290327, 142, '2015-01-01 00:42:47.000000', 'temperatura', 779.0000, 'ºC'),
	(290328, 142, '2015-01-01 00:42:48.000000', 'temperatura', 373.0000, 'ºC'),
	(290329, 142, '2015-01-01 00:42:49.000000', 'temperatura', 731.0000, 'ºC'),
	(290330, 142, '2015-01-01 00:42:50.000000', 'temperatura', 138.0000, 'ºC'),
	(290331, 142, '2015-01-01 00:42:51.000000', 'temperatura', 895.0000, 'ºC'),
	(290332, 142, '2015-01-01 00:42:52.000000', 'temperatura', 461.0000, 'ºC'),
	(290333, 142, '2015-01-01 00:42:53.000000', 'temperatura', 823.0000, 'ºC'),
	(290334, 142, '2015-01-01 00:42:54.000000', 'temperatura', 329.0000, 'ºC'),
	(290335, 142, '2015-01-01 00:42:55.000000', 'temperatura', 379.0000, 'ºC'),
	(290336, 142, '2015-01-01 00:42:56.000000', 'temperatura', 908.0000, 'ºC'),
	(290337, 142, '2015-01-01 00:42:57.000000', 'temperatura', 1005.0000, 'ºC'),
	(290338, 142, '2015-01-01 00:42:58.000000', 'temperatura', 1100.0000, 'ºC'),
	(290339, 142, '2015-01-01 00:42:59.000000', 'temperatura', 85.0000, 'ºC'),
	(290340, 142, '2015-01-01 00:43:00.000000', 'temperatura', 725.0000, 'ºC'),
	(290341, 142, '2015-01-01 00:43:01.000000', 'temperatura', 973.0000, 'ºC'),
	(290342, 142, '2015-01-01 00:43:02.000000', 'temperatura', 290.0000, 'ºC'),
	(290343, 142, '2015-01-01 00:43:03.000000', 'temperatura', 932.0000, 'ºC'),
	(290344, 142, '2015-01-01 00:43:04.000000', 'temperatura', 188.0000, 'ºC'),
	(290345, 142, '2015-01-01 00:43:05.000000', 'temperatura', 547.0000, 'ºC'),
	(290346, 142, '2015-01-01 00:43:06.000000', 'temperatura', 970.0000, 'ºC'),
	(290347, 142, '2015-01-01 00:43:07.000000', 'temperatura', 811.0000, 'ºC'),
	(290348, 142, '2015-01-01 00:43:08.000000', 'temperatura', 1147.0000, 'ºC'),
	(290349, 142, '2015-01-01 00:43:09.000000', 'temperatura', 901.0000, 'ºC'),
	(290350, 142, '2015-01-01 00:43:10.000000', 'temperatura', 1062.0000, 'ºC'),
	(290351, 142, '2015-01-01 00:43:11.000000', 'temperatura', 211.0000, 'ºC'),
	(290352, 142, '2015-01-01 00:43:12.000000', 'temperatura', 270.0000, 'ºC'),
	(290353, 142, '2015-01-01 00:43:13.000000', 'temperatura', 715.0000, 'ºC'),
	(290354, 142, '2015-01-01 00:43:14.000000', 'temperatura', 367.0000, 'ºC'),
	(290355, 142, '2015-01-01 00:43:15.000000', 'temperatura', 890.0000, 'ºC'),
	(290356, 142, '2015-01-01 00:43:16.000000', 'temperatura', 948.0000, 'ºC'),
	(290357, 142, '2015-01-01 00:43:17.000000', 'temperatura', 872.0000, 'ºC'),
	(290358, 142, '2015-01-01 00:43:18.000000', 'temperatura', 314.0000, 'ºC'),
	(290359, 142, '2015-01-01 00:43:19.000000', 'temperatura', 157.0000, 'ºC'),
	(290360, 142, '2015-01-01 00:43:20.000000', 'temperatura', 1043.0000, 'ºC'),
	(290361, 142, '2015-01-01 00:43:21.000000', 'temperatura', 1144.0000, 'ºC'),
	(290362, 142, '2015-01-01 00:43:22.000000', 'temperatura', 190.0000, 'ºC'),
	(290363, 142, '2015-01-01 00:43:23.000000', 'temperatura', 1121.0000, 'ºC'),
	(290364, 142, '2015-01-01 00:43:24.000000', 'temperatura', 236.0000, 'ºC'),
	(290365, 142, '2015-01-01 00:43:25.000000', 'temperatura', 218.0000, 'ºC'),
	(290366, 142, '2015-01-01 00:43:26.000000', 'temperatura', 383.0000, 'ºC'),
	(290367, 142, '2015-01-01 00:43:27.000000', 'temperatura', 59.0000, 'ºC'),
	(290368, 142, '2015-01-01 00:43:28.000000', 'temperatura', 347.0000, 'ºC'),
	(290369, 142, '2015-01-01 00:43:29.000000', 'temperatura', 360.0000, 'ºC'),
	(290370, 142, '2015-01-01 00:43:30.000000', 'temperatura', 757.0000, 'ºC'),
	(290371, 142, '2015-01-01 00:43:31.000000', 'temperatura', 305.0000, 'ºC'),
	(290372, 142, '2015-01-01 00:43:32.000000', 'temperatura', 457.0000, 'ºC'),
	(290373, 142, '2015-01-01 00:43:33.000000', 'temperatura', 169.0000, 'ºC'),
	(290374, 142, '2015-01-01 00:43:34.000000', 'temperatura', 674.0000, 'ºC'),
	(290375, 142, '2015-01-01 00:43:35.000000', 'temperatura', 466.0000, 'ºC'),
	(290376, 142, '2015-01-01 00:43:36.000000', 'temperatura', 306.0000, 'ºC'),
	(290377, 142, '2015-01-01 00:43:37.000000', 'temperatura', 133.0000, 'ºC'),
	(290378, 142, '2015-01-01 00:43:38.000000', 'temperatura', 948.0000, 'ºC'),
	(290379, 142, '2015-01-01 00:43:39.000000', 'temperatura', 741.0000, 'ºC'),
	(290380, 142, '2015-01-01 00:43:40.000000', 'temperatura', 863.0000, 'ºC'),
	(290381, 142, '2015-01-01 00:43:41.000000', 'temperatura', 892.0000, 'ºC'),
	(290382, 142, '2015-01-01 00:43:42.000000', 'temperatura', 669.0000, 'ºC'),
	(290383, 142, '2015-01-01 00:43:43.000000', 'temperatura', 673.0000, 'ºC'),
	(290384, 142, '2015-01-01 00:43:44.000000', 'temperatura', 157.0000, 'ºC'),
	(290385, 142, '2015-01-01 00:43:45.000000', 'temperatura', 1168.0000, 'ºC'),
	(290386, 142, '2015-01-01 00:43:46.000000', 'temperatura', 569.0000, 'ºC'),
	(290387, 142, '2015-01-01 00:43:47.000000', 'temperatura', 542.0000, 'ºC'),
	(290388, 142, '2015-01-01 00:43:48.000000', 'temperatura', 1004.0000, 'ºC'),
	(290389, 142, '2015-01-01 00:43:49.000000', 'temperatura', 993.0000, 'ºC'),
	(290390, 142, '2015-01-01 00:43:50.000000', 'temperatura', 755.0000, 'ºC'),
	(290391, 142, '2015-01-01 00:43:51.000000', 'temperatura', 797.0000, 'ºC'),
	(290392, 142, '2015-01-01 00:43:52.000000', 'temperatura', 520.0000, 'ºC'),
	(290393, 142, '2015-01-01 00:43:53.000000', 'temperatura', 210.0000, 'ºC'),
	(290394, 142, '2015-01-01 00:43:54.000000', 'temperatura', 691.0000, 'ºC'),
	(290395, 142, '2015-01-01 00:43:55.000000', 'temperatura', 423.0000, 'ºC'),
	(290396, 142, '2015-01-01 00:43:56.000000', 'temperatura', 43.0000, 'ºC'),
	(290397, 142, '2015-01-01 00:43:57.000000', 'temperatura', 147.0000, 'ºC'),
	(290398, 142, '2015-01-01 00:43:58.000000', 'temperatura', 608.0000, 'ºC'),
	(290399, 142, '2015-01-01 00:43:59.000000', 'temperatura', 200.0000, 'ºC'),
	(290400, 142, '2015-01-01 00:44:00.000000', 'temperatura', 377.0000, 'ºC'),
	(290401, 142, '2015-01-01 00:44:01.000000', 'temperatura', 86.0000, 'ºC'),
	(290402, 142, '2015-01-01 00:44:02.000000', 'temperatura', 500.0000, 'ºC'),
	(290403, 142, '2015-01-01 00:44:03.000000', 'temperatura', 1039.0000, 'ºC'),
	(290404, 142, '2015-01-01 00:44:04.000000', 'temperatura', 99.0000, 'ºC'),
	(290405, 142, '2015-01-01 00:44:05.000000', 'temperatura', 977.0000, 'ºC'),
	(290406, 142, '2015-01-01 00:44:06.000000', 'temperatura', 990.0000, 'ºC'),
	(290407, 142, '2015-01-01 00:44:07.000000', 'temperatura', 820.0000, 'ºC'),
	(290408, 142, '2015-01-01 00:44:08.000000', 'temperatura', 1129.0000, 'ºC'),
	(290409, 142, '2015-01-01 00:44:09.000000', 'temperatura', 784.0000, 'ºC'),
	(290410, 142, '2015-01-01 00:44:10.000000', 'temperatura', 536.0000, 'ºC'),
	(290411, 142, '2015-01-01 00:44:11.000000', 'temperatura', 328.0000, 'ºC'),
	(290412, 142, '2015-01-01 00:44:12.000000', 'temperatura', 32.0000, 'ºC'),
	(290413, 142, '2015-01-01 00:44:13.000000', 'temperatura', 378.0000, 'ºC'),
	(290414, 142, '2015-01-01 00:44:14.000000', 'temperatura', 594.0000, 'ºC'),
	(290415, 142, '2015-01-01 00:44:15.000000', 'temperatura', 636.0000, 'ºC'),
	(290416, 142, '2015-01-01 00:44:16.000000', 'temperatura', 200.0000, 'ºC'),
	(290417, 142, '2015-01-01 00:44:17.000000', 'temperatura', 292.0000, 'ºC'),
	(290418, 142, '2015-01-01 00:44:18.000000', 'temperatura', 862.0000, 'ºC'),
	(290419, 142, '2015-01-01 00:44:19.000000', 'temperatura', 1032.0000, 'ºC'),
	(290420, 142, '2015-01-01 00:44:20.000000', 'temperatura', 177.0000, 'ºC'),
	(290421, 142, '2015-01-01 00:44:21.000000', 'temperatura', 188.0000, 'ºC'),
	(290422, 142, '2015-01-01 00:44:22.000000', 'temperatura', 409.0000, 'ºC'),
	(290423, 142, '2015-01-01 00:44:23.000000', 'temperatura', 283.0000, 'ºC'),
	(290424, 142, '2015-01-01 00:44:24.000000', 'temperatura', 187.0000, 'ºC'),
	(290425, 142, '2015-01-01 00:44:25.000000', 'temperatura', 87.0000, 'ºC'),
	(290426, 142, '2015-01-01 00:44:26.000000', 'temperatura', 1075.0000, 'ºC'),
	(290427, 142, '2015-01-01 00:44:27.000000', 'temperatura', 313.0000, 'ºC'),
	(290428, 142, '2015-01-01 00:44:28.000000', 'temperatura', 742.0000, 'ºC'),
	(290429, 142, '2015-01-01 00:44:29.000000', 'temperatura', 372.0000, 'ºC'),
	(290430, 142, '2015-01-01 00:44:30.000000', 'temperatura', 835.0000, 'ºC'),
	(290431, 142, '2015-01-01 00:44:31.000000', 'temperatura', 657.0000, 'ºC'),
	(290432, 142, '2015-01-01 00:44:32.000000', 'temperatura', 782.0000, 'ºC'),
	(290433, 142, '2015-01-01 00:44:33.000000', 'temperatura', 741.0000, 'ºC'),
	(290434, 142, '2015-01-01 00:44:34.000000', 'temperatura', 158.0000, 'ºC'),
	(290435, 142, '2015-01-01 00:44:35.000000', 'temperatura', 968.0000, 'ºC'),
	(290436, 142, '2015-01-01 00:44:36.000000', 'temperatura', 766.0000, 'ºC'),
	(290437, 142, '2015-01-01 00:44:37.000000', 'temperatura', 928.0000, 'ºC'),
	(290438, 142, '2015-01-01 00:44:38.000000', 'temperatura', 1141.0000, 'ºC'),
	(290439, 142, '2015-01-01 00:44:39.000000', 'temperatura', 520.0000, 'ºC'),
	(290440, 142, '2015-01-01 00:44:40.000000', 'temperatura', 380.0000, 'ºC'),
	(290441, 142, '2015-01-01 00:44:41.000000', 'temperatura', 342.0000, 'ºC'),
	(290442, 142, '2015-01-01 00:44:42.000000', 'temperatura', 567.0000, 'ºC'),
	(290443, 142, '2015-01-01 00:44:43.000000', 'temperatura', 610.0000, 'ºC'),
	(290444, 142, '2015-01-01 00:44:44.000000', 'temperatura', 152.0000, 'ºC'),
	(290445, 142, '2015-01-01 00:44:45.000000', 'temperatura', 130.0000, 'ºC'),
	(290446, 142, '2015-01-01 00:44:46.000000', 'temperatura', 194.0000, 'ºC'),
	(290447, 142, '2015-01-01 00:44:47.000000', 'temperatura', 579.0000, 'ºC'),
	(290448, 142, '2015-01-01 00:44:48.000000', 'temperatura', 1114.0000, 'ºC'),
	(290449, 142, '2015-01-01 00:44:49.000000', 'temperatura', 233.0000, 'ºC'),
	(290450, 142, '2015-01-01 00:44:50.000000', 'temperatura', 226.0000, 'ºC'),
	(290451, 142, '2015-01-01 00:44:51.000000', 'temperatura', 431.0000, 'ºC'),
	(290452, 142, '2015-01-01 00:44:52.000000', 'temperatura', 277.0000, 'ºC'),
	(290453, 142, '2015-01-01 00:44:53.000000', 'temperatura', 93.0000, 'ºC'),
	(290454, 142, '2015-01-01 00:44:54.000000', 'temperatura', 835.0000, 'ºC'),
	(290455, 142, '2015-01-01 00:44:55.000000', 'temperatura', 296.0000, 'ºC'),
	(290456, 142, '2015-01-01 00:44:56.000000', 'temperatura', 175.0000, 'ºC'),
	(290457, 142, '2015-01-01 00:44:57.000000', 'temperatura', 1189.0000, 'ºC'),
	(290458, 142, '2015-01-01 00:44:58.000000', 'temperatura', 620.0000, 'ºC'),
	(290459, 142, '2015-01-01 00:44:59.000000', 'temperatura', 735.0000, 'ºC'),
	(290460, 142, '2015-01-01 00:45:00.000000', 'temperatura', 612.0000, 'ºC'),
	(290461, 142, '2015-01-01 00:45:01.000000', 'temperatura', 859.0000, 'ºC'),
	(290462, 142, '2015-01-01 00:45:02.000000', 'temperatura', 57.0000, 'ºC'),
	(290463, 142, '2015-01-01 00:45:03.000000', 'temperatura', 111.0000, 'ºC'),
	(290464, 142, '2015-01-01 00:45:04.000000', 'temperatura', 382.0000, 'ºC'),
	(290465, 142, '2015-01-01 00:45:05.000000', 'temperatura', 378.0000, 'ºC'),
	(290466, 142, '2015-01-01 00:45:06.000000', 'temperatura', 744.0000, 'ºC'),
	(290467, 142, '2015-01-01 00:45:07.000000', 'temperatura', 186.0000, 'ºC'),
	(290468, 142, '2015-01-01 00:45:08.000000', 'temperatura', 1100.0000, 'ºC'),
	(290469, 142, '2015-01-01 00:45:09.000000', 'temperatura', 144.0000, 'ºC'),
	(290470, 142, '2015-01-01 00:45:10.000000', 'temperatura', 1019.0000, 'ºC'),
	(290471, 142, '2015-01-01 00:45:11.000000', 'temperatura', 1066.0000, 'ºC'),
	(290472, 142, '2015-01-01 00:45:12.000000', 'temperatura', 1070.0000, 'ºC'),
	(290473, 142, '2015-01-01 00:45:13.000000', 'temperatura', 954.0000, 'ºC'),
	(290474, 142, '2015-01-01 00:45:14.000000', 'temperatura', 359.0000, 'ºC'),
	(290475, 142, '2015-01-01 00:45:15.000000', 'temperatura', 135.0000, 'ºC'),
	(290476, 142, '2015-01-01 00:45:16.000000', 'temperatura', 798.0000, 'ºC'),
	(290477, 142, '2015-01-01 00:45:17.000000', 'temperatura', 1184.0000, 'ºC'),
	(290478, 142, '2015-01-01 00:45:18.000000', 'temperatura', 1127.0000, 'ºC'),
	(290479, 142, '2015-01-01 00:45:19.000000', 'temperatura', 884.0000, 'ºC'),
	(290480, 142, '2015-01-01 00:45:20.000000', 'temperatura', 1038.0000, 'ºC'),
	(290481, 142, '2015-01-01 00:45:21.000000', 'temperatura', 141.0000, 'ºC'),
	(290482, 142, '2015-01-01 00:45:22.000000', 'temperatura', 1190.0000, 'ºC'),
	(290483, 142, '2015-01-01 00:45:23.000000', 'temperatura', 728.0000, 'ºC'),
	(290484, 142, '2015-01-01 00:45:24.000000', 'temperatura', 72.0000, 'ºC'),
	(290485, 142, '2015-01-01 00:45:25.000000', 'temperatura', 574.0000, 'ºC'),
	(290486, 142, '2015-01-01 00:45:26.000000', 'temperatura', 254.0000, 'ºC'),
	(290487, 142, '2015-01-01 00:45:27.000000', 'temperatura', 749.0000, 'ºC'),
	(290488, 142, '2015-01-01 00:45:28.000000', 'temperatura', 586.0000, 'ºC'),
	(290489, 142, '2015-01-01 00:45:29.000000', 'temperatura', 681.0000, 'ºC'),
	(290490, 142, '2015-01-01 00:45:30.000000', 'temperatura', 450.0000, 'ºC'),
	(290491, 142, '2015-01-01 00:45:31.000000', 'temperatura', 205.0000, 'ºC'),
	(290492, 142, '2015-01-01 00:45:32.000000', 'temperatura', 878.0000, 'ºC'),
	(290493, 142, '2015-01-01 00:45:33.000000', 'temperatura', 174.0000, 'ºC'),
	(290494, 142, '2015-01-01 00:45:34.000000', 'temperatura', 637.0000, 'ºC'),
	(290495, 142, '2015-01-01 00:45:35.000000', 'temperatura', 264.0000, 'ºC'),
	(290496, 142, '2015-01-01 00:45:36.000000', 'temperatura', 610.0000, 'ºC'),
	(290497, 142, '2015-01-01 00:45:37.000000', 'temperatura', 1059.0000, 'ºC'),
	(290498, 142, '2015-01-01 00:45:38.000000', 'temperatura', 1064.0000, 'ºC'),
	(290499, 142, '2015-01-01 00:45:39.000000', 'temperatura', 945.0000, 'ºC'),
	(290500, 142, '2015-01-01 00:45:40.000000', 'temperatura', 335.0000, 'ºC'),
	(290501, 142, '2015-01-01 00:45:41.000000', 'temperatura', 37.0000, 'ºC'),
	(290502, 142, '2015-01-01 00:45:42.000000', 'temperatura', 382.0000, 'ºC'),
	(290503, 142, '2015-01-01 00:45:43.000000', 'temperatura', 598.0000, 'ºC'),
	(290504, 142, '2015-01-01 00:45:44.000000', 'temperatura', 647.0000, 'ºC'),
	(290505, 142, '2015-01-01 00:45:45.000000', 'temperatura', 240.0000, 'ºC'),
	(290506, 142, '2015-01-01 00:45:46.000000', 'temperatura', 459.0000, 'ºC'),
	(290507, 142, '2015-01-01 00:45:47.000000', 'temperatura', 377.0000, 'ºC'),
	(290508, 142, '2015-01-01 00:45:48.000000', 'temperatura', 506.0000, 'ºC'),
	(290509, 142, '2015-01-01 00:45:49.000000', 'temperatura', 201.0000, 'ºC'),
	(290510, 142, '2015-01-01 00:45:50.000000', 'temperatura', 689.0000, 'ºC'),
	(290511, 142, '2015-01-01 00:45:51.000000', 'temperatura', 441.0000, 'ºC'),
	(290512, 142, '2015-01-01 00:45:52.000000', 'temperatura', 137.0000, 'ºC'),
	(290513, 142, '2015-01-01 00:45:53.000000', 'temperatura', 563.0000, 'ºC'),
	(290514, 142, '2015-01-01 00:45:54.000000', 'temperatura', 5.0000, 'ºC'),
	(290515, 142, '2015-01-01 00:45:55.000000', 'temperatura', 738.0000, 'ºC'),
	(290516, 142, '2015-01-01 00:45:56.000000', 'temperatura', 73.0000, 'ºC'),
	(290517, 142, '2015-01-01 00:45:57.000000', 'temperatura', 553.0000, 'ºC'),
	(290518, 142, '2015-01-01 00:45:58.000000', 'temperatura', 145.0000, 'ºC'),
	(290519, 142, '2015-01-01 00:45:59.000000', 'temperatura', 266.0000, 'ºC'),
	(290520, 142, '2015-01-01 00:46:00.000000', 'temperatura', 896.0000, 'ºC'),
	(290521, 142, '2015-01-01 00:46:01.000000', 'temperatura', 85.0000, 'ºC'),
	(290522, 142, '2015-01-01 00:46:02.000000', 'temperatura', 134.0000, 'ºC'),
	(290523, 142, '2015-01-01 00:46:03.000000', 'temperatura', 419.0000, 'ºC'),
	(290524, 142, '2015-01-01 00:46:04.000000', 'temperatura', 491.0000, 'ºC'),
	(290525, 142, '2015-01-01 00:46:05.000000', 'temperatura', 1.0000, 'ºC'),
	(290526, 142, '2015-01-01 00:46:06.000000', 'temperatura', 930.0000, 'ºC'),
	(290527, 142, '2015-01-01 00:46:07.000000', 'temperatura', 1050.0000, 'ºC'),
	(290528, 142, '2015-01-01 00:46:08.000000', 'temperatura', 60.0000, 'ºC'),
	(290529, 142, '2015-01-01 00:46:09.000000', 'temperatura', 748.0000, 'ºC'),
	(290530, 142, '2015-01-01 00:46:10.000000', 'temperatura', 1164.0000, 'ºC'),
	(290531, 142, '2015-01-01 00:46:11.000000', 'temperatura', 1173.0000, 'ºC'),
	(290532, 142, '2015-01-01 00:46:12.000000', 'temperatura', 1177.0000, 'ºC'),
	(290533, 142, '2015-01-01 00:46:13.000000', 'temperatura', 1165.0000, 'ºC'),
	(290534, 142, '2015-01-01 00:46:14.000000', 'temperatura', 1093.0000, 'ºC'),
	(290535, 142, '2015-01-01 00:46:15.000000', 'temperatura', 773.0000, 'ºC'),
	(290536, 142, '2015-01-01 00:46:16.000000', 'temperatura', 584.0000, 'ºC'),
	(290537, 142, '2015-01-01 00:46:17.000000', 'temperatura', 605.0000, 'ºC'),
	(290538, 142, '2015-01-01 00:46:18.000000', 'temperatura', 70.0000, 'ºC'),
	(290539, 142, '2015-01-01 00:46:19.000000', 'temperatura', 938.0000, 'ºC'),
	(290540, 142, '2015-01-01 00:46:20.000000', 'temperatura', 880.0000, 'ºC'),
	(290541, 142, '2015-01-01 00:46:21.000000', 'temperatura', 385.0000, 'ºC'),
	(290542, 142, '2015-01-01 00:46:22.000000', 'temperatura', 487.0000, 'ºC'),
	(290543, 142, '2015-01-01 00:46:23.000000', 'temperatura', 82.0000, 'ºC'),
	(290544, 142, '2015-01-01 00:46:24.000000', 'temperatura', 148.0000, 'ºC'),
	(290545, 142, '2015-01-01 00:46:25.000000', 'temperatura', 496.0000, 'ºC'),
	(290546, 142, '2015-01-01 00:46:26.000000', 'temperatura', 836.0000, 'ºC'),
	(290547, 142, '2015-01-01 00:46:27.000000', 'temperatura', 292.0000, 'ºC'),
	(290548, 142, '2015-01-01 00:46:28.000000', 'temperatura', 151.0000, 'ºC'),
	(290549, 142, '2015-01-01 00:46:29.000000', 'temperatura', 1081.0000, 'ºC'),
	(290550, 142, '2015-01-01 00:46:30.000000', 'temperatura', 150.0000, 'ºC'),
	(290551, 142, '2015-01-01 00:46:31.000000', 'temperatura', 1110.0000, 'ºC'),
	(290552, 142, '2015-01-01 00:46:32.000000', 'temperatura', 302.0000, 'ºC'),
	(290553, 142, '2015-01-01 00:46:33.000000', 'temperatura', 578.0000, 'ºC'),
	(290554, 142, '2015-01-01 00:46:34.000000', 'temperatura', 787.0000, 'ºC'),
	(290555, 142, '2015-01-01 00:46:35.000000', 'temperatura', 1002.0000, 'ºC'),
	(290556, 142, '2015-01-01 00:46:36.000000', 'temperatura', 247.0000, 'ºC'),
	(290557, 142, '2015-01-01 00:46:37.000000', 'temperatura', 629.0000, 'ºC'),
	(290558, 142, '2015-01-01 00:46:38.000000', 'temperatura', 7.0000, 'ºC'),
	(290559, 142, '2015-01-01 00:46:39.000000', 'temperatura', 548.0000, 'ºC'),
	(290560, 142, '2015-01-01 00:46:40.000000', 'temperatura', 317.0000, 'ºC'),
	(290561, 142, '2015-01-01 00:46:41.000000', 'temperatura', 1144.0000, 'ºC'),
	(290562, 142, '2015-01-01 00:46:42.000000', 'temperatura', 1167.0000, 'ºC'),
	(290563, 142, '2015-01-01 00:46:43.000000', 'temperatura', 6.0000, 'ºC'),
	(290564, 142, '2015-01-01 00:46:44.000000', 'temperatura', 129.0000, 'ºC'),
	(290565, 142, '2015-01-01 00:46:45.000000', 'temperatura', 627.0000, 'ºC'),
	(290566, 142, '2015-01-01 00:46:46.000000', 'temperatura', 350.0000, 'ºC'),
	(290567, 142, '2015-01-01 00:46:47.000000', 'temperatura', 1070.0000, 'ºC'),
	(290568, 142, '2015-01-01 00:46:48.000000', 'temperatura', 699.0000, 'ºC'),
	(290569, 142, '2015-01-01 00:46:49.000000', 'temperatura', 287.0000, 'ºC'),
	(290570, 142, '2015-01-01 00:46:50.000000', 'temperatura', 539.0000, 'ºC'),
	(290571, 142, '2015-01-01 00:46:51.000000', 'temperatura', 633.0000, 'ºC'),
	(290572, 142, '2015-01-01 00:46:52.000000', 'temperatura', 351.0000, 'ºC'),
	(290573, 142, '2015-01-01 00:46:53.000000', 'temperatura', 1054.0000, 'ºC'),
	(290574, 142, '2015-01-01 00:46:54.000000', 'temperatura', 616.0000, 'ºC'),
	(290575, 142, '2015-01-01 00:46:55.000000', 'temperatura', 1121.0000, 'ºC'),
	(290576, 142, '2015-01-01 00:46:56.000000', 'temperatura', 158.0000, 'ºC'),
	(290577, 142, '2015-01-01 00:46:57.000000', 'temperatura', 1026.0000, 'ºC'),
	(290578, 142, '2015-01-01 00:46:58.000000', 'temperatura', 1056.0000, 'ºC'),
	(290579, 142, '2015-01-01 00:46:59.000000', 'temperatura', 1002.0000, 'ºC'),
	(290580, 142, '2015-01-01 00:47:00.000000', 'temperatura', 643.0000, 'ºC'),
	(290581, 142, '2015-01-01 00:47:01.000000', 'temperatura', 209.0000, 'ºC'),
	(290582, 142, '2015-01-01 00:47:02.000000', 'temperatura', 317.0000, 'ºC'),
	(290583, 142, '2015-01-01 00:47:03.000000', 'temperatura', 960.0000, 'ºC'),
	(290584, 142, '2015-01-01 00:47:04.000000', 'temperatura', 247.0000, 'ºC'),
	(290585, 142, '2015-01-01 00:47:05.000000', 'temperatura', 758.0000, 'ºC'),
	(290586, 142, '2015-01-01 00:47:06.000000', 'temperatura', 648.0000, 'ºC'),
	(290587, 142, '2015-01-01 00:47:07.000000', 'temperatura', 967.0000, 'ºC'),
	(290588, 142, '2015-01-01 00:47:08.000000', 'temperatura', 493.0000, 'ºC'),
	(290589, 142, '2015-01-01 00:47:09.000000', 'temperatura', 765.0000, 'ºC'),
	(290590, 142, '2015-01-01 00:47:10.000000', 'temperatura', 1146.0000, 'ºC'),
	(290591, 142, '2015-01-01 00:47:11.000000', 'temperatura', 1033.0000, 'ºC'),
	(290592, 142, '2015-01-01 00:47:12.000000', 'temperatura', 530.0000, 'ºC'),
	(290593, 142, '2015-01-01 00:47:13.000000', 'temperatura', 752.0000, 'ºC'),
	(290594, 142, '2015-01-01 00:47:14.000000', 'temperatura', 970.0000, 'ºC'),
	(290595, 142, '2015-01-01 00:47:15.000000', 'temperatura', 195.0000, 'ºC'),
	(290596, 142, '2015-01-01 00:47:16.000000', 'temperatura', 463.0000, 'ºC'),
	(290597, 142, '2015-01-01 00:47:17.000000', 'temperatura', 533.0000, 'ºC'),
	(290598, 142, '2015-01-01 00:47:18.000000', 'temperatura', 75.0000, 'ºC'),
	(290599, 142, '2015-01-01 00:47:19.000000', 'temperatura', 1177.0000, 'ºC'),
	(290600, 142, '2015-01-01 00:47:20.000000', 'temperatura', 859.0000, 'ºC'),
	(290601, 142, '2015-01-01 00:47:21.000000', 'temperatura', 767.0000, 'ºC'),
	(290602, 142, '2015-01-01 00:47:22.000000', 'temperatura', 55.0000, 'ºC'),
	(290603, 142, '2015-01-01 00:47:23.000000', 'temperatura', 378.0000, 'ºC'),
	(290604, 142, '2015-01-01 00:47:24.000000', 'temperatura', 524.0000, 'ºC'),
	(290605, 142, '2015-01-01 00:47:25.000000', 'temperatura', 286.0000, 'ºC'),
	(290606, 142, '2015-01-01 00:47:26.000000', 'temperatura', 1057.0000, 'ºC'),
	(290607, 142, '2015-01-01 00:47:27.000000', 'temperatura', 829.0000, 'ºC'),
	(290608, 142, '2015-01-01 00:47:28.000000', 'temperatura', 975.0000, 'ºC'),
	(290609, 142, '2015-01-01 00:47:29.000000', 'temperatura', 1186.0000, 'ºC'),
	(290610, 142, '2015-01-01 00:47:30.000000', 'temperatura', 609.0000, 'ºC'),
	(290611, 142, '2015-01-01 00:47:31.000000', 'temperatura', 685.0000, 'ºC'),
	(290612, 142, '2015-01-01 00:47:32.000000', 'temperatura', 399.0000, 'ºC'),
	(290613, 142, '2015-01-01 00:47:33.000000', 'temperatura', 1140.0000, 'ºC'),
	(290614, 142, '2015-01-01 00:47:34.000000', 'temperatura', 902.0000, 'ºC'),
	(290615, 142, '2015-01-01 00:47:35.000000', 'temperatura', 1094.0000, 'ºC'),
	(290616, 142, '2015-01-01 00:47:36.000000', 'temperatura', 362.0000, 'ºC'),
	(290617, 142, '2015-01-01 00:47:37.000000', 'temperatura', 931.0000, 'ºC'),
	(290618, 142, '2015-01-01 00:47:38.000000', 'temperatura', 1168.0000, 'ºC'),
	(290619, 142, '2015-01-01 00:47:39.000000', 'temperatura', 647.0000, 'ºC'),
	(290620, 142, '2015-01-01 00:47:40.000000', 'temperatura', 933.0000, 'ºC'),
	(290621, 142, '2015-01-01 00:47:41.000000', 'temperatura', 325.0000, 'ºC'),
	(290622, 142, '2015-01-01 00:47:42.000000', 'temperatura', 25.0000, 'ºC'),
	(290623, 142, '2015-01-01 00:47:43.000000', 'temperatura', 350.0000, 'ºC'),
	(290624, 142, '2015-01-01 00:47:44.000000', 'temperatura', 476.0000, 'ºC'),
	(290625, 142, '2015-01-01 00:47:45.000000', 'temperatura', 128.0000, 'ºC'),
	(290626, 142, '2015-01-01 00:47:46.000000', 'temperatura', 416.0000, 'ºC'),
	(290627, 142, '2015-01-01 00:47:47.000000', 'temperatura', 497.0000, 'ºC'),
	(290628, 142, '2015-01-01 00:47:48.000000', 'temperatura', 35.0000, 'ºC'),
	(290629, 142, '2015-01-01 00:47:49.000000', 'temperatura', 1087.0000, 'ºC'),
	(290630, 142, '2015-01-01 00:47:50.000000', 'temperatura', 531.0000, 'ºC'),
	(290631, 142, '2015-01-01 00:47:51.000000', 'temperatura', 592.0000, 'ºC'),
	(290632, 142, '2015-01-01 00:47:52.000000', 'temperatura', 168.0000, 'ºC'),
	(290633, 142, '2015-01-01 00:47:53.000000', 'temperatura', 266.0000, 'ºC'),
	(290634, 142, '2015-01-01 00:47:54.000000', 'temperatura', 827.0000, 'ºC'),
	(290635, 142, '2015-01-01 00:47:55.000000', 'temperatura', 937.0000, 'ºC'),
	(290636, 142, '2015-01-01 00:47:56.000000', 'temperatura', 1004.0000, 'ºC'),
	(290637, 142, '2015-01-01 00:47:57.000000', 'temperatura', 1010.0000, 'ºC'),
	(290638, 142, '2015-01-01 00:47:58.000000', 'temperatura', 839.0000, 'ºC'),
	(290639, 142, '2015-01-01 00:47:59.000000', 'temperatura', 1164.0000, 'ºC'),
	(290640, 142, '2015-01-01 00:48:00.000000', 'temperatura', 903.0000, 'ºC'),
	(290641, 142, '2015-01-01 00:48:01.000000', 'temperatura', 1026.0000, 'ºC'),
	(290642, 142, '2015-01-01 00:48:02.000000', 'temperatura', 22.0000, 'ºC'),
	(290643, 142, '2015-01-01 00:48:03.000000', 'temperatura', 630.0000, 'ºC'),
	(290644, 142, '2015-01-01 00:48:04.000000', 'temperatura', 686.0000, 'ºC'),
	(290645, 142, '2015-01-01 00:48:05.000000', 'temperatura', 339.0000, 'ºC'),
	(290646, 142, '2015-01-01 00:48:06.000000', 'temperatura', 839.0000, 'ºC'),
	(290647, 142, '2015-01-01 00:48:07.000000', 'temperatura', 778.0000, 'ºC'),
	(290648, 142, '2015-01-01 00:48:08.000000', 'temperatura', 173.0000, 'ºC'),
	(290649, 142, '2015-01-01 00:48:09.000000', 'temperatura', 930.0000, 'ºC'),
	(290650, 142, '2015-01-01 00:48:10.000000', 'temperatura', 534.0000, 'ºC'),
	(290651, 142, '2015-01-01 00:48:11.000000', 'temperatura', 1080.0000, 'ºC'),
	(290652, 142, '2015-01-01 00:48:12.000000', 'temperatura', 199.0000, 'ºC'),
	(290653, 142, '2015-01-01 00:48:13.000000', 'temperatura', 156.0000, 'ºC'),
	(290654, 142, '2015-01-01 00:48:14.000000', 'temperatura', 184.0000, 'ºC'),
	(290655, 142, '2015-01-01 00:48:15.000000', 'temperatura', 453.0000, 'ºC'),
	(290656, 142, '2015-01-01 00:48:16.000000', 'temperatura', 514.0000, 'ºC'),
	(290657, 142, '2015-01-01 00:48:17.000000', 'temperatura', 11.0000, 'ºC'),
	(290658, 142, '2015-01-01 00:48:18.000000', 'temperatura', 914.0000, 'ºC'),
	(290659, 142, '2015-01-01 00:48:19.000000', 'temperatura', 938.0000, 'ºC'),
	(290660, 142, '2015-01-01 00:48:20.000000', 'temperatura', 749.0000, 'ºC'),
	(290661, 142, '2015-01-01 00:48:21.000000', 'temperatura', 931.0000, 'ºC'),
	(290662, 142, '2015-01-01 00:48:22.000000', 'temperatura', 7.0000, 'ºC'),
	(290663, 142, '2015-01-01 00:48:23.000000', 'temperatura', 844.0000, 'ºC'),
	(290664, 142, '2015-01-01 00:48:24.000000', 'temperatura', 598.0000, 'ºC'),
	(290665, 142, '2015-01-01 00:48:25.000000', 'temperatura', 459.0000, 'ºC'),
	(290666, 142, '2015-01-01 00:48:26.000000', 'temperatura', 503.0000, 'ºC'),
	(290667, 142, '2015-01-01 00:48:27.000000', 'temperatura', 1138.0000, 'ºC'),
	(290668, 142, '2015-01-01 00:48:28.000000', 'temperatura', 580.0000, 'ºC'),
	(290669, 142, '2015-01-01 00:48:29.000000', 'temperatura', 688.0000, 'ºC'),
	(290670, 142, '2015-01-01 00:48:30.000000', 'temperatura', 498.0000, 'ºC'),
	(290671, 142, '2015-01-01 00:48:31.000000', 'temperatura', 429.0000, 'ºC'),
	(290672, 142, '2015-01-01 00:48:32.000000', 'temperatura', 649.0000, 'ºC'),
	(290673, 142, '2015-01-01 00:48:33.000000', 'temperatura', 759.0000, 'ºC'),
	(290674, 142, '2015-01-01 00:48:34.000000', 'temperatura', 651.0000, 'ºC'),
	(290675, 142, '2015-01-01 00:48:35.000000', 'temperatura', 977.0000, 'ºC'),
	(290676, 142, '2015-01-01 00:48:36.000000', 'temperatura', 534.0000, 'ºC'),
	(290677, 142, '2015-01-01 00:48:37.000000', 'temperatura', 937.0000, 'ºC'),
	(290678, 142, '2015-01-01 00:48:38.000000', 'temperatura', 685.0000, 'ºC'),
	(290679, 142, '2015-01-01 00:48:39.000000', 'temperatura', 614.0000, 'ºC'),
	(290680, 142, '2015-01-01 00:48:40.000000', 'temperatura', 1015.0000, 'ºC'),
	(290681, 142, '2015-01-01 00:48:41.000000', 'temperatura', 833.0000, 'ºC'),
	(290682, 142, '2015-01-01 00:48:42.000000', 'temperatura', 1122.0000, 'ºC'),
	(290683, 142, '2015-01-01 00:48:43.000000', 'temperatura', 712.0000, 'ºC'),
	(290684, 142, '2015-01-01 00:48:44.000000', 'temperatura', 195.0000, 'ºC'),
	(290685, 142, '2015-01-01 00:48:45.000000', 'temperatura', 37.0000, 'ºC'),
	(290686, 142, '2015-01-01 00:48:46.000000', 'temperatura', 801.0000, 'ºC'),
	(290687, 142, '2015-01-01 00:48:47.000000', 'temperatura', 294.0000, 'ºC'),
	(290688, 142, '2015-01-01 00:48:48.000000', 'temperatura', 270.0000, 'ºC'),
	(290689, 142, '2015-01-01 00:48:49.000000', 'temperatura', 468.0000, 'ºC'),
	(290690, 142, '2015-01-01 00:48:50.000000', 'temperatura', 332.0000, 'ºC'),
	(290691, 142, '2015-01-01 00:48:51.000000', 'temperatura', 254.0000, 'ºC'),
	(290692, 142, '2015-01-01 00:48:52.000000', 'temperatura', 275.0000, 'ºC'),
	(290693, 142, '2015-01-01 00:48:53.000000', 'temperatura', 614.0000, 'ºC'),
	(290694, 142, '2015-01-01 00:48:54.000000', 'temperatura', 1045.0000, 'ºC'),
	(290695, 142, '2015-01-01 00:48:55.000000', 'temperatura', 985.0000, 'ºC'),
	(290696, 142, '2015-01-01 00:48:56.000000', 'temperatura', 588.0000, 'ºC'),
	(290697, 142, '2015-01-01 00:48:57.000000', 'temperatura', 1188.0000, 'ºC'),
	(290698, 142, '2015-01-01 00:48:58.000000', 'temperatura', 577.0000, 'ºC'),
	(290699, 142, '2015-01-01 00:48:59.000000', 'temperatura', 522.0000, 'ºC'),
	(290700, 142, '2015-01-01 00:49:00.000000', 'temperatura', 880.0000, 'ºC'),
	(290701, 142, '2015-01-01 00:49:01.000000', 'temperatura', 434.0000, 'ºC'),
	(290702, 142, '2015-01-01 00:49:02.000000', 'temperatura', 730.0000, 'ºC'),
	(290703, 142, '2015-01-01 00:49:03.000000', 'temperatura', 1149.0000, 'ºC'),
	(290704, 142, '2015-01-01 00:49:04.000000', 'temperatura', 1154.0000, 'ºC'),
	(290705, 142, '2015-01-01 00:49:05.000000', 'temperatura', 1125.0000, 'ºC'),
	(290706, 142, '2015-01-01 00:49:06.000000', 'temperatura', 965.0000, 'ºC'),
	(290707, 142, '2015-01-01 00:49:07.000000', 'temperatura', 247.0000, 'ºC'),
	(290708, 142, '2015-01-01 00:49:08.000000', 'temperatura', 742.0000, 'ºC'),
	(290709, 142, '2015-01-01 00:49:09.000000', 'temperatura', 570.0000, 'ºC'),
	(290710, 142, '2015-01-01 00:49:10.000000', 'temperatura', 622.0000, 'ºC'),
	(290711, 142, '2015-01-01 00:49:11.000000', 'temperatura', 202.0000, 'ºC'),
	(290712, 142, '2015-01-01 00:49:12.000000', 'temperatura', 345.0000, 'ºC'),
	(290713, 142, '2015-01-01 00:49:13.000000', 'temperatura', 1118.0000, 'ºC'),
	(290714, 142, '2015-01-01 00:49:14.000000', 'temperatura', 958.0000, 'ºC'),
	(290715, 142, '2015-01-01 00:49:15.000000', 'temperatura', 236.0000, 'ºC'),
	(290716, 142, '2015-01-01 00:49:16.000000', 'temperatura', 705.0000, 'ºC'),
	(290717, 142, '2015-01-01 00:49:17.000000', 'temperatura', 418.0000, 'ºC'),
	(290718, 142, '2015-01-01 00:49:18.000000', 'temperatura', 1174.0000, 'ºC'),
	(290719, 142, '2015-01-01 00:49:19.000000', 'temperatura', 1017.0000, 'ºC'),
	(290720, 142, '2015-01-01 00:49:20.000000', 'temperatura', 366.0000, 'ºC'),
	(290721, 142, '2015-01-01 00:49:21.000000', 'temperatura', 1177.0000, 'ºC'),
	(290722, 142, '2015-01-01 00:49:22.000000', 'temperatura', 1187.0000, 'ºC'),
	(290723, 142, '2015-01-01 00:49:23.000000', 'temperatura', 7.0000, 'ºC'),
	(290724, 142, '2015-01-01 00:49:24.000000', 'temperatura', 72.0000, 'ºC'),
	(290725, 142, '2015-01-01 00:49:25.000000', 'temperatura', 340.0000, 'ºC'),
	(290726, 142, '2015-01-01 00:49:26.000000', 'temperatura', 283.0000, 'ºC'),
	(290727, 142, '2015-01-01 00:49:27.000000', 'temperatura', 399.0000, 'ºC'),
	(290728, 142, '2015-01-01 00:49:28.000000', 'temperatura', 1144.0000, 'ºC'),
	(290729, 142, '2015-01-01 00:49:29.000000', 'temperatura', 925.0000, 'ºC'),
	(290730, 142, '2015-01-01 00:49:30.000000', 'temperatura', 1195.0000, 'ºC'),
	(290731, 142, '2015-01-01 00:49:31.000000', 'temperatura', 797.0000, 'ºC'),
	(290732, 142, '2015-01-01 00:49:32.000000', 'temperatura', 404.0000, 'ºC'),
	(290733, 142, '2015-01-01 00:49:33.000000', 'temperatura', 828.0000, 'ºC'),
	(290734, 142, '2015-01-01 00:49:34.000000', 'temperatura', 527.0000, 'ºC'),
	(290735, 142, '2015-01-01 00:49:35.000000', 'temperatura', 154.0000, 'ºC'),
	(290736, 142, '2015-01-01 00:49:36.000000', 'temperatura', 388.0000, 'ºC'),
	(290737, 142, '2015-01-01 00:49:37.000000', 'temperatura', 278.0000, 'ºC'),
	(290738, 142, '2015-01-01 00:49:38.000000', 'temperatura', 227.0000, 'ºC'),
	(290739, 142, '2015-01-01 00:49:39.000000', 'temperatura', 302.0000, 'ºC'),
	(290740, 142, '2015-01-01 00:49:40.000000', 'temperatura', 828.0000, 'ºC'),
	(290741, 142, '2015-01-01 00:49:41.000000', 'temperatura', 835.0000, 'ºC'),
	(290742, 142, '2015-01-01 00:49:42.000000', 'temperatura', 494.0000, 'ºC'),
	(290743, 142, '2015-01-01 00:49:43.000000', 'temperatura', 1162.0000, 'ºC'),
	(290744, 142, '2015-01-01 00:49:44.000000', 'temperatura', 729.0000, 'ºC'),
	(290745, 142, '2015-01-01 00:49:45.000000', 'temperatura', 161.0000, 'ºC'),
	(290746, 142, '2015-01-01 00:49:46.000000', 'temperatura', 1019.0000, 'ºC'),
	(290747, 142, '2015-01-01 00:49:47.000000', 'temperatura', 1011.0000, 'ºC'),
	(290748, 142, '2015-01-01 00:49:48.000000', 'temperatura', 799.0000, 'ºC'),
	(290749, 142, '2015-01-01 00:49:49.000000', 'temperatura', 964.0000, 'ºC'),
	(290750, 142, '2015-01-01 00:49:50.000000', 'temperatura', 23.0000, 'ºC'),
	(290751, 142, '2015-01-01 00:49:51.000000', 'temperatura', 822.0000, 'ºC'),
	(290752, 142, '2015-01-01 00:49:52.000000', 'temperatura', 442.0000, 'ºC'),
	(290753, 142, '2015-01-01 00:49:53.000000', 'temperatura', 946.0000, 'ºC'),
	(290754, 142, '2015-01-01 00:49:54.000000', 'temperatura', 1006.0000, 'ºC'),
	(290755, 142, '2015-01-01 00:49:55.000000', 'temperatura', 990.0000, 'ºC'),
	(290756, 142, '2015-01-01 00:49:56.000000', 'temperatura', 731.0000, 'ºC'),
	(290757, 142, '2015-01-01 00:49:57.000000', 'temperatura', 689.0000, 'ºC'),
	(290758, 142, '2015-01-01 00:49:58.000000', 'temperatura', 50.0000, 'ºC'),
	(290759, 142, '2015-01-01 00:49:59.000000', 'temperatura', 585.0000, 'ºC'),
	(290760, 142, '2015-01-01 00:50:00.000000', 'temperatura', 373.0000, 'ºC'),
	(290761, 142, '2015-01-01 00:50:01.000000', 'temperatura', 112.0000, 'ºC'),
	(290762, 142, '2015-01-01 00:50:02.000000', 'temperatura', 640.0000, 'ºC'),
	(290763, 142, '2015-01-01 00:50:03.000000', 'temperatura', 464.0000, 'ºC'),
	(290764, 142, '2015-01-01 00:50:04.000000', 'temperatura', 404.0000, 'ºC'),
	(290765, 142, '2015-01-01 00:50:05.000000', 'temperatura', 625.0000, 'ºC'),
	(290766, 142, '2015-01-01 00:50:06.000000', 'temperatura', 714.0000, 'ºC'),
	(290767, 142, '2015-01-01 00:50:07.000000', 'temperatura', 498.0000, 'ºC'),
	(290768, 142, '2015-01-01 00:50:08.000000', 'temperatura', 346.0000, 'ºC'),
	(290769, 142, '2015-01-01 00:50:09.000000', 'temperatura', 238.0000, 'ºC'),
	(290770, 142, '2015-01-01 00:50:10.000000', 'temperatura', 152.0000, 'ºC'),
	(290771, 142, '2015-01-01 00:50:11.000000', 'temperatura', 47.0000, 'ºC'),
	(290772, 142, '2015-01-01 00:50:12.000000', 'temperatura', 981.0000, 'ºC'),
	(290773, 142, '2015-01-01 00:50:13.000000', 'temperatura', 1161.0000, 'ºC'),
	(290774, 142, '2015-01-01 00:50:14.000000', 'temperatura', 465.0000, 'ºC'),
	(290775, 142, '2015-01-01 00:50:15.000000', 'temperatura', 42.0000, 'ºC'),
	(290776, 142, '2015-01-01 00:50:16.000000', 'temperatura', 14.0000, 'ºC'),
	(290777, 142, '2015-01-01 00:50:17.000000', 'temperatura', 1144.0000, 'ºC'),
	(290778, 142, '2015-01-01 00:50:18.000000', 'temperatura', 880.0000, 'ºC'),
	(290779, 142, '2015-01-01 00:50:19.000000', 'temperatura', 967.0000, 'ºC'),
	(290780, 142, '2015-01-01 00:50:20.000000', 'temperatura', 995.0000, 'ºC'),
	(290781, 142, '2015-01-01 00:50:21.000000', 'temperatura', 874.0000, 'ºC'),
	(290782, 142, '2015-01-01 00:50:22.000000', 'temperatura', 187.0000, 'ºC'),
	(290783, 142, '2015-01-01 00:50:23.000000', 'temperatura', 711.0000, 'ºC'),
	(290784, 142, '2015-01-01 00:50:24.000000', 'temperatura', 596.0000, 'ºC'),
	(290785, 142, '2015-01-01 00:50:25.000000', 'temperatura', 848.0000, 'ºC'),
	(290786, 142, '2015-01-01 00:50:26.000000', 'temperatura', 53.0000, 'ºC'),
	(290787, 142, '2015-01-01 00:50:27.000000', 'temperatura', 120.0000, 'ºC'),
	(290788, 142, '2015-01-01 00:50:28.000000', 'temperatura', 444.0000, 'ºC'),
	(290789, 142, '2015-01-01 00:50:29.000000', 'temperatura', 658.0000, 'ºC'),
	(290790, 142, '2015-01-01 00:50:30.000000', 'temperatura', 760.0000, 'ºC'),
	(290791, 142, '2015-01-01 00:50:31.000000', 'temperatura', 624.0000, 'ºC'),
	(290792, 142, '2015-01-01 00:50:32.000000', 'temperatura', 844.0000, 'ºC'),
	(290793, 142, '2015-01-01 00:50:33.000000', 'temperatura', 1146.0000, 'ºC'),
	(290794, 142, '2015-01-01 00:50:34.000000', 'temperatura', 798.0000, 'ºC'),
	(290795, 142, '2015-01-01 00:50:35.000000', 'temperatura', 554.0000, 'ºC'),
	(290796, 142, '2015-01-01 00:50:36.000000', 'temperatura', 377.0000, 'ºC'),
	(290797, 142, '2015-01-01 00:50:37.000000', 'temperatura', 225.0000, 'ºC'),
	(290798, 142, '2015-01-01 00:50:38.000000', 'temperatura', 1192.0000, 'ºC'),
	(290799, 142, '2015-01-01 00:50:39.000000', 'temperatura', 485.0000, 'ºC'),
	(290800, 142, '2015-01-01 00:50:40.000000', 'temperatura', 52.0000, 'ºC'),
	(290801, 142, '2015-01-01 00:50:41.000000', 'temperatura', 5.0000, 'ºC'),
	(290802, 142, '2015-01-01 00:50:42.000000', 'temperatura', 1068.0000, 'ºC'),
	(290803, 142, '2015-01-01 00:50:43.000000', 'temperatura', 524.0000, 'ºC'),
	(290804, 142, '2015-01-01 00:50:44.000000', 'temperatura', 620.0000, 'ºC'),
	(290805, 142, '2015-01-01 00:50:45.000000', 'temperatura', 325.0000, 'ºC'),
	(290806, 142, '2015-01-01 00:50:46.000000', 'temperatura', 969.0000, 'ºC'),
	(290807, 142, '2015-01-01 00:50:47.000000', 'temperatura', 268.0000, 'ºC'),
	(290808, 142, '2015-01-01 00:50:48.000000', 'temperatura', 836.0000, 'ºC'),
	(290809, 142, '2015-01-01 00:50:49.000000', 'temperatura', 975.0000, 'ºC'),
	(290810, 142, '2015-01-01 00:50:50.000000', 'temperatura', 1169.0000, 'ºC'),
	(290811, 142, '2015-01-01 00:50:51.000000', 'temperatura', 520.0000, 'ºC'),
	(290812, 142, '2015-01-01 00:50:52.000000', 'temperatura', 292.0000, 'ºC'),
	(290813, 142, '2015-01-01 00:50:53.000000', 'temperatura', 1100.0000, 'ºC'),
	(290814, 142, '2015-01-01 00:50:54.000000', 'temperatura', 1026.0000, 'ºC'),
	(290815, 142, '2015-01-01 00:50:55.000000', 'temperatura', 628.0000, 'ºC'),
	(290816, 142, '2015-01-01 00:50:56.000000', 'temperatura', 64.0000, 'ºC'),
	(290817, 142, '2015-01-01 00:50:57.000000', 'temperatura', 837.0000, 'ºC'),
	(290818, 142, '2015-01-01 00:50:58.000000', 'temperatura', 392.0000, 'ºC'),
	(290819, 142, '2015-01-01 00:50:59.000000', 'temperatura', 651.0000, 'ºC'),
	(290820, 142, '2015-01-01 00:51:00.000000', 'temperatura', 880.0000, 'ºC'),
	(290821, 142, '2015-01-01 00:51:01.000000', 'temperatura', 45.0000, 'ºC'),
	(290822, 142, '2015-01-01 00:51:02.000000', 'temperatura', 1188.0000, 'ºC'),
	(290823, 142, '2015-01-01 00:51:03.000000', 'temperatura', 1003.0000, 'ºC'),
	(290824, 142, '2015-01-01 00:51:04.000000', 'temperatura', 255.0000, 'ºC'),
	(290825, 142, '2015-01-01 00:51:05.000000', 'temperatura', 664.0000, 'ºC'),
	(290826, 142, '2015-01-01 00:51:06.000000', 'temperatura', 156.0000, 'ºC'),
	(290827, 142, '2015-01-01 00:51:07.000000', 'temperatura', 1188.0000, 'ºC'),
	(290828, 142, '2015-01-01 00:51:08.000000', 'temperatura', 671.0000, 'ºC'),
	(290829, 142, '2015-01-01 00:51:09.000000', 'temperatura', 994.0000, 'ºC'),
	(290830, 142, '2015-01-01 00:51:10.000000', 'temperatura', 558.0000, 'ºC'),
	(290831, 142, '2015-01-01 00:51:11.000000', 'temperatura', 1009.0000, 'ºC'),
	(290832, 142, '2015-01-01 00:51:12.000000', 'temperatura', 969.0000, 'ºC'),
	(290833, 142, '2015-01-01 00:51:13.000000', 'temperatura', 618.0000, 'ºC'),
	(290834, 142, '2015-01-01 00:51:14.000000', 'temperatura', 183.0000, 'ºC'),
	(290835, 142, '2015-01-01 00:51:15.000000', 'temperatura', 262.0000, 'ºC'),
	(290836, 142, '2015-01-01 00:51:16.000000', 'temperatura', 762.0000, 'ºC'),
	(290837, 142, '2015-01-01 00:51:17.000000', 'temperatura', 625.0000, 'ºC'),
	(290838, 142, '2015-01-01 00:51:18.000000', 'temperatura', 841.0000, 'ºC'),
	(290839, 142, '2015-01-01 00:51:19.000000', 'temperatura', 1128.0000, 'ºC'),
	(290840, 142, '2015-01-01 00:51:20.000000', 'temperatura', 720.0000, 'ºC'),
	(290841, 142, '2015-01-01 00:51:21.000000', 'temperatura', 214.0000, 'ºC'),
	(290842, 142, '2015-01-01 00:51:22.000000', 'temperatura', 111.0000, 'ºC'),
	(290843, 142, '2015-01-01 00:51:23.000000', 'temperatura', 1113.0000, 'ºC'),
	(290844, 142, '2015-01-01 00:51:24.000000', 'temperatura', 434.0000, 'ºC'),
	(290845, 142, '2015-01-01 00:51:25.000000', 'temperatura', 29.0000, 'ºC'),
	(290846, 142, '2015-01-01 00:51:26.000000', 'temperatura', 45.0000, 'ºC'),
	(290847, 142, '2015-01-01 00:51:27.000000', 'temperatura', 138.0000, 'ºC'),
	(290848, 142, '2015-01-01 00:51:28.000000', 'temperatura', 554.0000, 'ºC'),
	(290849, 142, '2015-01-01 00:51:29.000000', 'temperatura', 1157.0000, 'ºC'),
	(290850, 142, '2015-01-01 00:51:30.000000', 'temperatura', 525.0000, 'ºC'),
	(290851, 142, '2015-01-01 00:51:31.000000', 'temperatura', 353.0000, 'ºC'),
	(290852, 142, '2015-01-01 00:51:32.000000', 'temperatura', 189.0000, 'ºC'),
	(290853, 142, '2015-01-01 00:51:33.000000', 'temperatura', 1089.0000, 'ºC'),
	(290854, 142, '2015-01-01 00:51:34.000000', 'temperatura', 77.0000, 'ºC'),
	(290855, 142, '2015-01-01 00:51:35.000000', 'temperatura', 719.0000, 'ºC'),
	(290856, 142, '2015-01-01 00:51:36.000000', 'temperatura', 966.0000, 'ºC'),
	(290857, 142, '2015-01-01 00:51:37.000000', 'temperatura', 274.0000, 'ºC'),
	(290858, 142, '2015-01-01 00:51:38.000000', 'temperatura', 872.0000, 'ºC'),
	(290859, 142, '2015-01-01 00:51:39.000000', 'temperatura', 1138.0000, 'ºC'),
	(290860, 142, '2015-01-01 00:51:40.000000', 'temperatura', 676.0000, 'ºC'),
	(290861, 142, '2015-01-01 00:51:41.000000', 'temperatura', 1165.0000, 'ºC'),
	(290862, 142, '2015-01-01 00:51:42.000000', 'temperatura', 197.0000, 'ºC'),
	(290863, 142, '2015-01-01 00:51:43.000000', 'temperatura', 1089.0000, 'ºC'),
	(290864, 142, '2015-01-01 00:51:44.000000', 'temperatura', 57.0000, 'ºC'),
	(290865, 142, '2015-01-01 00:51:45.000000', 'temperatura', 619.0000, 'ºC'),
	(290866, 142, '2015-01-01 00:51:46.000000', 'temperatura', 523.0000, 'ºC'),
	(290867, 142, '2015-01-01 00:51:47.000000', 'temperatura', 761.0000, 'ºC'),
	(290868, 142, '2015-01-01 00:51:48.000000', 'temperatura', 1034.0000, 'ºC'),
	(290869, 142, '2015-01-01 00:51:49.000000', 'temperatura', 488.0000, 'ºC'),
	(290870, 142, '2015-01-01 00:51:50.000000', 'temperatura', 538.0000, 'ºC'),
	(290871, 142, '2015-01-01 00:51:51.000000', 'temperatura', 28.0000, 'ºC'),
	(290872, 142, '2015-01-01 00:51:52.000000', 'temperatura', 927.0000, 'ºC'),
	(290873, 142, '2015-01-01 00:51:53.000000', 'temperatura', 950.0000, 'ºC'),
	(290874, 142, '2015-01-01 00:51:54.000000', 'temperatura', 771.0000, 'ºC'),
	(290875, 142, '2015-01-01 00:51:55.000000', 'temperatura', 1006.0000, 'ºC'),
	(290876, 142, '2015-01-01 00:51:56.000000', 'temperatura', 315.0000, 'ºC'),
	(290877, 142, '2015-01-01 00:51:57.000000', 'temperatura', 957.0000, 'ºC'),
	(290878, 142, '2015-01-01 00:51:58.000000', 'temperatura', 240.0000, 'ºC'),
	(290879, 142, '2015-01-01 00:51:59.000000', 'temperatura', 732.0000, 'ºC'),
	(290880, 142, '2015-01-01 00:52:00.000000', 'temperatura', 539.0000, 'ºC'),
	(290881, 142, '2015-01-01 00:52:01.000000', 'temperatura', 499.0000, 'ºC'),
	(290882, 142, '2015-01-01 00:52:02.000000', 'temperatura', 878.0000, 'ºC'),
	(290883, 142, '2015-01-01 00:52:03.000000', 'temperatura', 495.0000, 'ºC'),
	(290884, 142, '2015-01-01 00:52:04.000000', 'temperatura', 1040.0000, 'ºC'),
	(290885, 142, '2015-01-01 00:52:05.000000', 'temperatura', 116.0000, 'ºC'),
	(290886, 142, '2015-01-01 00:52:06.000000', 'temperatura', 1060.0000, 'ºC'),
	(290887, 142, '2015-01-01 00:52:07.000000', 'temperatura', 153.0000, 'ºC'),
	(290888, 142, '2015-01-01 00:52:08.000000', 'temperatura', 1185.0000, 'ºC'),
	(290889, 142, '2015-01-01 00:52:09.000000', 'temperatura', 667.0000, 'ºC'),
	(290890, 142, '2015-01-01 00:52:10.000000', 'temperatura', 982.0000, 'ºC'),
	(290891, 142, '2015-01-01 00:52:11.000000', 'temperatura', 507.0000, 'ºC'),
	(290892, 142, '2015-01-01 00:52:12.000000', 'temperatura', 791.0000, 'ºC'),
	(290893, 142, '2015-01-01 00:52:13.000000', 'temperatura', 35.0000, 'ºC'),
	(290894, 142, '2015-01-01 00:52:14.000000', 'temperatura', 204.0000, 'ºC'),
	(290895, 142, '2015-01-01 00:52:15.000000', 'temperatura', 913.0000, 'ºC'),
	(290896, 142, '2015-01-01 00:52:16.000000', 'temperatura', 356.0000, 'ºC'),
	(290897, 142, '2015-01-01 00:52:17.000000', 'temperatura', 239.0000, 'ºC'),
	(290898, 142, '2015-01-01 00:52:18.000000', 'temperatura', 130.0000, 'ºC'),
	(290899, 142, '2015-01-01 00:52:19.000000', 'temperatura', 1134.0000, 'ºC'),
	(290900, 142, '2015-01-01 00:52:20.000000', 'temperatura', 481.0000, 'ºC'),
	(290901, 142, '2015-01-01 00:52:21.000000', 'temperatura', 203.0000, 'ºC'),
	(290902, 142, '2015-01-01 00:52:22.000000', 'temperatura', 774.0000, 'ºC'),
	(290903, 142, '2015-01-01 00:52:23.000000', 'temperatura', 860.0000, 'ºC'),
	(290904, 142, '2015-01-01 00:52:24.000000', 'temperatura', 777.0000, 'ºC'),
	(290905, 142, '2015-01-01 00:52:25.000000', 'temperatura', 107.0000, 'ºC'),
	(290906, 142, '2015-01-01 00:52:26.000000', 'temperatura', 603.0000, 'ºC'),
	(290907, 142, '2015-01-01 00:52:27.000000', 'temperatura', 295.0000, 'ºC'),
	(290908, 142, '2015-01-01 00:52:28.000000', 'temperatura', 869.0000, 'ºC'),
	(290909, 142, '2015-01-01 00:52:29.000000', 'temperatura', 1058.0000, 'ºC'),
	(290910, 142, '2015-01-01 00:52:30.000000', 'temperatura', 285.0000, 'ºC'),
	(290911, 142, '2015-01-01 00:52:31.000000', 'temperatura', 651.0000, 'ºC'),
	(290912, 142, '2015-01-01 00:52:32.000000', 'temperatura', 2.0000, 'ºC'),
	(290913, 142, '2015-01-01 00:52:33.000000', 'temperatura', 458.0000, 'ºC'),
	(290914, 142, '2015-01-01 00:52:34.000000', 'temperatura', 1085.0000, 'ºC'),
	(290915, 142, '2015-01-01 00:52:35.000000', 'temperatura', 451.0000, 'ºC'),
	(290916, 142, '2015-01-01 00:52:36.000000', 'temperatura', 201.0000, 'ºC'),
	(290917, 142, '2015-01-01 00:52:37.000000', 'temperatura', 850.0000, 'ºC'),
	(290918, 142, '2015-01-01 00:52:38.000000', 'temperatura', 51.0000, 'ºC'),
	(290919, 142, '2015-01-01 00:52:39.000000', 'temperatura', 103.0000, 'ºC'),
	(290920, 142, '2015-01-01 00:52:40.000000', 'temperatura', 363.0000, 'ºC'),
	(290921, 142, '2015-01-01 00:52:41.000000', 'temperatura', 307.0000, 'ºC'),
	(290922, 142, '2015-01-01 00:52:42.000000', 'temperatura', 444.0000, 'ºC'),
	(290923, 142, '2015-01-01 00:52:43.000000', 'temperatura', 103.0000, 'ºC'),
	(290924, 142, '2015-01-01 00:52:44.000000', 'temperatura', 381.0000, 'ºC'),
	(290925, 142, '2015-01-01 00:52:45.000000', 'temperatura', 395.0000, 'ºC'),
	(290926, 142, '2015-01-01 00:52:46.000000', 'temperatura', 836.0000, 'ºC'),
	(290927, 142, '2015-01-01 00:52:47.000000', 'temperatura', 594.0000, 'ºC'),
	(290928, 142, '2015-01-01 00:52:48.000000', 'temperatura', 463.0000, 'ºC'),
	(290929, 142, '2015-01-01 00:52:49.000000', 'temperatura', 531.0000, 'ºC'),
	(290930, 142, '2015-01-01 00:52:50.000000', 'temperatura', 69.0000, 'ºC'),
	(290931, 142, '2015-01-01 00:52:51.000000', 'temperatura', 1153.0000, 'ºC'),
	(290932, 142, '2015-01-01 00:52:52.000000', 'temperatura', 756.0000, 'ºC'),
	(290933, 142, '2015-01-01 00:52:53.000000', 'temperatura', 321.0000, 'ºC'),
	(290934, 142, '2015-01-01 00:52:54.000000', 'temperatura', 538.0000, 'ºC'),
	(290935, 142, '2015-01-01 00:52:55.000000', 'temperatura', 527.0000, 'ºC'),
	(290936, 142, '2015-01-01 00:52:56.000000', 'temperatura', 1020.0000, 'ºC'),
	(290937, 142, '2015-01-01 00:52:57.000000', 'temperatura', 1122.0000, 'ºC'),
	(290938, 142, '2015-01-01 00:52:58.000000', 'temperatura', 150.0000, 'ºC'),
	(290939, 142, '2015-01-01 00:52:59.000000', 'temperatura', 986.0000, 'ºC'),
	(290940, 142, '2015-01-01 00:53:00.000000', 'temperatura', 879.0000, 'ºC'),
	(290941, 142, '2015-01-01 00:53:01.000000', 'temperatura', 239.0000, 'ºC'),
	(290942, 142, '2015-01-01 00:53:02.000000', 'temperatura', 958.0000, 'ºC'),
	(290943, 142, '2015-01-01 00:53:03.000000', 'temperatura', 473.0000, 'ºC'),
	(290944, 142, '2015-01-01 00:53:04.000000', 'temperatura', 690.0000, 'ºC'),
	(290945, 142, '2015-01-01 00:53:05.000000', 'temperatura', 833.0000, 'ºC'),
	(290946, 142, '2015-01-01 00:53:06.000000', 'temperatura', 895.0000, 'ºC'),
	(290947, 142, '2015-01-01 00:53:07.000000', 'temperatura', 777.0000, 'ºC'),
	(290948, 142, '2015-01-01 00:53:08.000000', 'temperatura', 1.0000, 'ºC'),
	(290949, 142, '2015-01-01 00:53:09.000000', 'temperatura', 73.0000, 'ºC'),
	(290950, 142, '2015-01-01 00:53:10.000000', 'temperatura', 364.0000, 'ºC'),
	(290951, 142, '2015-01-01 00:53:11.000000', 'temperatura', 401.0000, 'ºC'),
	(290952, 142, '2015-01-01 00:53:12.000000', 'temperatura', 913.0000, 'ºC'),
	(290953, 142, '2015-01-01 00:53:13.000000', 'temperatura', 965.0000, 'ºC'),
	(290954, 142, '2015-01-01 00:53:14.000000', 'temperatura', 883.0000, 'ºC'),
	(290955, 142, '2015-01-01 00:53:15.000000', 'temperatura', 323.0000, 'ºC'),
	(290956, 142, '2015-01-01 00:53:16.000000', 'temperatura', 166.0000, 'ºC'),
	(290957, 142, '2015-01-01 00:53:17.000000', 'temperatura', 1061.0000, 'ºC'),
	(290958, 142, '2015-01-01 00:53:18.000000', 'temperatura', 9.0000, 'ºC'),
	(290959, 142, '2015-01-01 00:53:19.000000', 'temperatura', 461.0000, 'ºC'),
	(290960, 142, '2015-01-01 00:53:20.000000', 'temperatura', 1081.0000, 'ºC'),
	(290961, 142, '2015-01-01 00:53:21.000000', 'temperatura', 420.0000, 'ºC'),
	(290962, 142, '2015-01-01 00:53:22.000000', 'temperatura', 59.0000, 'ºC'),
	(290963, 142, '2015-01-01 00:53:23.000000', 'temperatura', 237.0000, 'ºC'),
	(290964, 142, '2015-01-01 00:53:24.000000', 'temperatura', 1006.0000, 'ºC'),
	(290965, 142, '2015-01-01 00:53:25.000000', 'temperatura', 718.0000, 'ºC'),
	(290966, 142, '2015-01-01 00:53:26.000000', 'temperatura', 576.0000, 'ºC'),
	(290967, 142, '2015-01-01 00:53:27.000000', 'temperatura', 726.0000, 'ºC'),
	(290968, 142, '2015-01-01 00:53:28.000000', 'temperatura', 702.0000, 'ºC'),
	(290969, 142, '2015-01-01 00:53:29.000000', 'temperatura', 134.0000, 'ºC'),
	(290970, 142, '2015-01-01 00:53:30.000000', 'temperatura', 964.0000, 'ºC'),
	(290971, 142, '2015-01-01 00:53:31.000000', 'temperatura', 817.0000, 'ºC'),
	(290972, 142, '2015-01-01 00:53:32.000000', 'temperatura', 1196.0000, 'ºC'),
	(290973, 142, '2015-01-01 00:53:33.000000', 'temperatura', 1128.0000, 'ºC'),
	(290974, 142, '2015-01-01 00:53:34.000000', 'temperatura', 854.0000, 'ºC'),
	(290975, 142, '2015-01-01 00:53:35.000000', 'temperatura', 887.0000, 'ºC'),
	(290976, 142, '2015-01-01 00:53:36.000000', 'temperatura', 674.0000, 'ºC'),
	(290977, 142, '2015-01-01 00:53:37.000000', 'temperatura', 709.0000, 'ºC'),
	(290978, 142, '2015-01-01 00:53:38.000000', 'temperatura', 325.0000, 'ºC'),
	(290979, 142, '2015-01-01 00:53:39.000000', 'temperatura', 698.0000, 'ºC'),
	(290980, 142, '2015-01-01 00:53:40.000000', 'temperatura', 116.0000, 'ºC'),
	(290981, 142, '2015-01-01 00:53:41.000000', 'temperatura', 885.0000, 'ºC'),
	(290982, 142, '2015-01-01 00:53:42.000000', 'temperatura', 476.0000, 'ºC'),
	(290983, 142, '2015-01-01 00:53:43.000000', 'temperatura', 928.0000, 'ºC'),
	(290984, 142, '2015-01-01 00:53:44.000000', 'temperatura', 810.0000, 'ºC'),
	(290985, 142, '2015-01-01 00:53:45.000000', 'temperatura', 67.0000, 'ºC'),
	(290986, 142, '2015-01-01 00:53:46.000000', 'temperatura', 306.0000, 'ºC'),
	(290987, 142, '2015-01-01 00:53:47.000000', 'temperatura', 128.0000, 'ºC'),
	(290988, 142, '2015-01-01 00:53:48.000000', 'temperatura', 925.0000, 'ºC'),
	(290989, 142, '2015-01-01 00:53:49.000000', 'temperatura', 641.0000, 'ºC'),
	(290990, 142, '2015-01-01 00:53:50.000000', 'temperatura', 430.0000, 'ºC'),
	(290991, 142, '2015-01-01 00:53:51.000000', 'temperatura', 227.0000, 'ºC'),
	(290992, 142, '2015-01-01 00:53:52.000000', 'temperatura', 1044.0000, 'ºC'),
	(290993, 142, '2015-01-01 00:53:53.000000', 'temperatura', 942.0000, 'ºC'),
	(290994, 142, '2015-01-01 00:53:54.000000', 'temperatura', 377.0000, 'ºC'),
	(290995, 142, '2015-01-01 00:53:55.000000', 'temperatura', 258.0000, 'ºC'),
	(290996, 142, '2015-01-01 00:53:56.000000', 'temperatura', 160.0000, 'ºC'),
	(290997, 142, '2015-01-01 00:53:57.000000', 'temperatura', 28.0000, 'ºC'),
	(290998, 142, '2015-01-01 00:53:58.000000', 'temperatura', 861.0000, 'ºC'),
	(290999, 142, '2015-01-01 00:53:59.000000', 'temperatura', 621.0000, 'ºC'),
	(291000, 142, '2015-01-01 00:54:00.000000', 'temperatura', 521.0000, 'ºC'),
	(291001, 142, '2015-01-01 00:54:01.000000', 'temperatura', 742.0000, 'ºC'),
	(291002, 142, '2015-01-01 00:54:02.000000', 'temperatura', 950.0000, 'ºC'),
	(291003, 142, '2015-01-01 00:54:03.000000', 'temperatura', 125.0000, 'ºC'),
	(291004, 142, '2015-01-01 00:54:04.000000', 'temperatura', 172.0000, 'ºC'),
	(291005, 142, '2015-01-01 00:54:05.000000', 'temperatura', 489.0000, 'ºC'),
	(291006, 142, '2015-01-01 00:54:06.000000', 'temperatura', 728.0000, 'ºC'),
	(291007, 142, '2015-01-01 00:54:07.000000', 'temperatura', 975.0000, 'ºC'),
	(291008, 142, '2015-01-01 00:54:08.000000', 'temperatura', 289.0000, 'ºC'),
	(291009, 142, '2015-01-01 00:54:09.000000', 'temperatura', 923.0000, 'ºC'),
	(291010, 142, '2015-01-01 00:54:10.000000', 'temperatura', 148.0000, 'ºC'),
	(291011, 142, '2015-01-01 00:54:11.000000', 'temperatura', 369.0000, 'ºC'),
	(291012, 142, '2015-01-01 00:54:12.000000', 'temperatura', 204.0000, 'ºC'),
	(291013, 142, '2015-01-01 00:54:13.000000', 'temperatura', 1112.0000, 'ºC'),
	(291014, 142, '2015-01-01 00:54:14.000000', 'temperatura', 149.0000, 'ºC'),
	(291015, 142, '2015-01-01 00:54:15.000000', 'temperatura', 1011.0000, 'ºC'),
	(291016, 142, '2015-01-01 00:54:16.000000', 'temperatura', 1009.0000, 'ºC'),
	(291017, 142, '2015-01-01 00:54:17.000000', 'temperatura', 813.0000, 'ºC'),
	(291018, 142, '2015-01-01 00:54:18.000000', 'temperatura', 1038.0000, 'ºC'),
	(291019, 142, '2015-01-01 00:54:19.000000', 'temperatura', 352.0000, 'ºC'),
	(291020, 142, '2015-01-01 00:54:20.000000', 'temperatura', 1046.0000, 'ºC'),
	(291021, 142, '2015-01-01 00:54:21.000000', 'temperatura', 572.0000, 'ºC'),
	(291022, 142, '2015-01-01 00:54:22.000000', 'temperatura', 926.0000, 'ºC'),
	(291023, 142, '2015-01-01 00:54:23.000000', 'temperatura', 511.0000, 'ºC'),
	(291024, 142, '2015-01-01 00:54:24.000000', 'temperatura', 981.0000, 'ºC'),
	(291025, 142, '2015-01-01 00:54:25.000000', 'temperatura', 971.0000, 'ºC'),
	(291026, 142, '2015-01-01 00:54:26.000000', 'temperatura', 714.0000, 'ºC'),
	(291027, 142, '2015-01-01 00:54:27.000000', 'temperatura', 657.0000, 'ºC'),
	(291028, 142, '2015-01-01 00:54:28.000000', 'temperatura', 1142.0000, 'ºC'),
	(291029, 142, '2015-01-01 00:54:29.000000', 'temperatura', 140.0000, 'ºC'),
	(291030, 142, '2015-01-01 00:54:30.000000', 'temperatura', 874.0000, 'ºC'),
	(291031, 142, '2015-01-01 00:54:31.000000', 'temperatura', 352.0000, 'ºC'),
	(291032, 142, '2015-01-01 00:54:32.000000', 'temperatura', 340.0000, 'ºC'),
	(291033, 142, '2015-01-01 00:54:33.000000', 'temperatura', 642.0000, 'ºC'),
	(291034, 142, '2015-01-01 00:54:34.000000', 'temperatura', 991.0000, 'ºC'),
	(291035, 142, '2015-01-01 00:54:35.000000', 'temperatura', 629.0000, 'ºC'),
	(291036, 142, '2015-01-01 00:54:36.000000', 'temperatura', 174.0000, 'ºC'),
	(291037, 142, '2015-01-01 00:54:37.000000', 'temperatura', 184.0000, 'ºC'),
	(291038, 142, '2015-01-01 00:54:38.000000', 'temperatura', 399.0000, 'ºC'),
	(291039, 142, '2015-01-01 00:54:39.000000', 'temperatura', 243.0000, 'ºC'),
	(291040, 142, '2015-01-01 00:54:40.000000', 'temperatura', 17.0000, 'ºC'),
	(291041, 142, '2015-01-01 00:54:41.000000', 'temperatura', 558.0000, 'ºC'),
	(291042, 142, '2015-01-01 00:54:42.000000', 'temperatura', 339.0000, 'ºC'),
	(291043, 142, '2015-01-01 00:54:43.000000', 'temperatura', 21.0000, 'ºC'),
	(291044, 142, '2015-01-01 00:54:44.000000', 'temperatura', 290.0000, 'ºC'),
	(291045, 142, '2015-01-01 00:54:45.000000', 'temperatura', 188.0000, 'ºC'),
	(291046, 142, '2015-01-01 00:54:46.000000', 'temperatura', 71.0000, 'ºC'),
	(291047, 142, '2015-01-01 00:54:47.000000', 'temperatura', 992.0000, 'ºC'),
	(291048, 142, '2015-01-01 00:54:48.000000', 'temperatura', 1145.0000, 'ºC'),
	(291049, 142, '2015-01-01 00:54:49.000000', 'temperatura', 350.0000, 'ºC'),
	(291050, 142, '2015-01-01 00:54:50.000000', 'temperatura', 715.0000, 'ºC'),
	(291051, 142, '2015-01-01 00:54:51.000000', 'temperatura', 126.0000, 'ºC'),
	(291052, 142, '2015-01-01 00:54:52.000000', 'temperatura', 885.0000, 'ºC'),
	(291053, 142, '2015-01-01 00:54:53.000000', 'temperatura', 449.0000, 'ºC'),
	(291054, 142, '2015-01-01 00:54:54.000000', 'temperatura', 790.0000, 'ºC'),
	(291055, 142, '2015-01-01 00:54:55.000000', 'temperatura', 205.0000, 'ºC'),
	(291056, 142, '2015-01-01 00:54:56.000000', 'temperatura', 1056.0000, 'ºC'),
	(291057, 142, '2015-01-01 00:54:57.000000', 'temperatura', 1062.0000, 'ºC'),
	(291058, 142, '2015-01-01 00:54:58.000000', 'temperatura', 946.0000, 'ºC'),
	(291059, 142, '2015-01-01 00:54:59.000000', 'temperatura', 342.0000, 'ºC'),
	(291060, 142, '2015-01-01 00:55:00.000000', 'temperatura', 73.0000, 'ºC'),
	(291061, 142, '2015-01-01 00:55:01.000000', 'temperatura', 540.0000, 'ºC'),
	(291062, 142, '2015-01-01 00:55:02.000000', 'temperatura', 83.0000, 'ºC'),
	(291063, 142, '2015-01-01 00:55:03.000000', 'temperatura', 1195.0000, 'ºC'),
	(291064, 142, '2015-01-01 00:55:04.000000', 'temperatura', 927.0000, 'ºC'),
	(291065, 142, '2015-01-01 00:55:05.000000', 'temperatura', 1050.0000, 'ºC'),
	(291066, 142, '2015-01-01 00:55:06.000000', 'temperatura', 71.0000, 'ºC'),
	(291067, 142, '2015-01-01 00:55:07.000000', 'temperatura', 806.0000, 'ºC'),
	(291068, 142, '2015-01-01 00:55:08.000000', 'temperatura', 215.0000, 'ºC'),
	(291069, 142, '2015-01-01 00:55:09.000000', 'temperatura', 1061.0000, 'ºC'),
	(291070, 142, '2015-01-01 00:55:10.000000', 'temperatura', 1057.0000, 'ºC'),
	(291071, 142, '2015-01-01 00:55:11.000000', 'temperatura', 902.0000, 'ºC'),
	(291072, 142, '2015-01-01 00:55:12.000000', 'temperatura', 143.0000, 'ºC'),
	(291073, 142, '2015-01-01 00:55:13.000000', 'temperatura', 407.0000, 'ºC'),
	(291074, 142, '2015-01-01 00:55:14.000000', 'temperatura', 407.0000, 'ºC'),
	(291075, 142, '2015-01-01 00:55:15.000000', 'temperatura', 817.0000, 'ºC'),
	(291076, 142, '2015-01-01 00:55:16.000000', 'temperatura', 461.0000, 'ºC'),
	(291077, 142, '2015-01-01 00:55:17.000000', 'temperatura', 1055.0000, 'ºC'),
	(291078, 142, '2015-01-01 00:55:18.000000', 'temperatura', 293.0000, 'ºC'),
	(291079, 142, '2015-01-01 00:55:19.000000', 'temperatura', 702.0000, 'ºC'),
	(291080, 142, '2015-01-01 00:55:20.000000', 'temperatura', 229.0000, 'ºC'),
	(291081, 142, '2015-01-01 00:55:21.000000', 'temperatura', 242.0000, 'ºC'),
	(291082, 142, '2015-01-01 00:55:22.000000', 'temperatura', 524.0000, 'ºC'),
	(291083, 142, '2015-01-01 00:55:23.000000', 'temperatura', 692.0000, 'ºC'),
	(291084, 142, '2015-01-01 00:55:24.000000', 'temperatura', 689.0000, 'ºC'),
	(291085, 142, '2015-01-01 00:55:25.000000', 'temperatura', 172.0000, 'ºC'),
	(291086, 142, '2015-01-01 00:55:26.000000', 'temperatura', 1190.0000, 'ºC'),
	(291087, 142, '2015-01-01 00:55:27.000000', 'temperatura', 637.0000, 'ºC'),
	(291088, 142, '2015-01-01 00:55:28.000000', 'temperatura', 813.0000, 'ºC'),
	(291089, 142, '2015-01-01 00:55:29.000000', 'temperatura', 955.0000, 'ºC'),
	(291090, 142, '2015-01-01 00:55:30.000000', 'temperatura', 1135.0000, 'ºC'),
	(291091, 142, '2015-01-01 00:55:31.000000', 'temperatura', 413.0000, 'ºC'),
	(291092, 142, '2015-01-01 00:55:32.000000', 'temperatura', 1059.0000, 'ºC'),
	(291093, 142, '2015-01-01 00:55:33.000000', 'temperatura', 459.0000, 'ºC'),
	(291094, 142, '2015-01-01 00:55:34.000000', 'temperatura', 318.0000, 'ºC'),
	(291095, 142, '2015-01-01 00:55:35.000000', 'temperatura', 211.0000, 'ºC'),
	(291096, 142, '2015-01-01 00:55:36.000000', 'temperatura', 104.0000, 'ºC'),
	(291097, 142, '2015-01-01 00:55:37.000000', 'temperatura', 1087.0000, 'ºC'),
	(291098, 142, '2015-01-01 00:55:38.000000', 'temperatura', 324.0000, 'ºC'),
	(291099, 142, '2015-01-01 00:55:39.000000', 'temperatura', 760.0000, 'ºC'),
	(291100, 142, '2015-01-01 00:55:40.000000', 'temperatura', 430.0000, 'ºC'),
	(291101, 142, '2015-01-01 00:55:41.000000', 'temperatura', 1067.0000, 'ºC'),
	(291102, 142, '2015-01-01 00:55:42.000000', 'temperatura', 448.0000, 'ºC'),
	(291103, 142, '2015-01-01 00:55:43.000000', 'temperatura', 238.0000, 'ºC'),
	(291104, 142, '2015-01-01 00:55:44.000000', 'temperatura', 1045.0000, 'ºC'),
	(291105, 142, '2015-01-01 00:55:45.000000', 'temperatura', 913.0000, 'ºC'),
	(291106, 142, '2015-01-01 00:55:46.000000', 'temperatura', 229.0000, 'ºC'),
	(291107, 142, '2015-01-01 00:55:47.000000', 'temperatura', 809.0000, 'ºC'),
	(291108, 142, '2015-01-01 00:55:48.000000', 'temperatura', 958.0000, 'ºC'),
	(291109, 142, '2015-01-01 00:55:49.000000', 'temperatura', 1162.0000, 'ºC'),
	(291110, 142, '2015-01-01 00:55:50.000000', 'temperatura', 538.0000, 'ºC'),
	(291111, 142, '2015-01-01 00:55:51.000000', 'temperatura', 403.0000, 'ºC'),
	(291112, 142, '2015-01-01 00:55:52.000000', 'temperatura', 404.0000, 'ºC'),
	(291113, 142, '2015-01-01 00:55:53.000000', 'temperatura', 811.0000, 'ºC'),
	(291114, 142, '2015-01-01 00:55:54.000000', 'temperatura', 442.0000, 'ºC'),
	(291115, 142, '2015-01-01 00:55:55.000000', 'temperatura', 977.0000, 'ºC'),
	(291116, 142, '2015-01-01 00:55:56.000000', 'temperatura', 1161.0000, 'ºC'),
	(291117, 142, '2015-01-01 00:55:57.000000', 'temperatura', 476.0000, 'ºC'),
	(291118, 142, '2015-01-01 00:55:58.000000', 'temperatura', 95.0000, 'ºC'),
	(291119, 142, '2015-01-01 00:55:59.000000', 'temperatura', 250.0000, 'ºC'),
	(291120, 142, '2015-01-01 00:56:00.000000', 'temperatura', 965.0000, 'ºC'),
	(291121, 142, '2015-01-01 00:56:01.000000', 'temperatura', 474.0000, 'ºC'),
	(291122, 142, '2015-01-01 00:56:02.000000', 'temperatura', 677.0000, 'ºC'),
	(291123, 142, '2015-01-01 00:56:03.000000', 'temperatura', 762.0000, 'ºC'),
	(291124, 142, '2015-01-01 00:56:04.000000', 'temperatura', 578.0000, 'ºC'),
	(291125, 142, '2015-01-01 00:56:05.000000', 'temperatura', 608.0000, 'ºC'),
	(291126, 142, '2015-01-01 00:56:06.000000', 'temperatura', 104.0000, 'ºC'),
	(291127, 142, '2015-01-01 00:56:07.000000', 'temperatura', 1096.0000, 'ºC'),
	(291128, 142, '2015-01-01 00:56:08.000000', 'temperatura', 369.0000, 'ºC'),
	(291129, 142, '2015-01-01 00:56:09.000000', 'temperatura', 956.0000, 'ºC'),
	(291130, 142, '2015-01-01 00:56:10.000000', 'temperatura', 77.0000, 'ºC'),
	(291131, 142, '2015-01-01 00:56:11.000000', 'temperatura', 1114.0000, 'ºC'),
	(291132, 142, '2015-01-01 00:56:12.000000', 'temperatura', 541.0000, 'ºC'),
	(291133, 142, '2015-01-01 00:56:13.000000', 'temperatura', 561.0000, 'ºC'),
	(291134, 142, '2015-01-01 00:56:14.000000', 'temperatura', 1186.0000, 'ºC'),
	(291135, 142, '2015-01-01 00:56:15.000000', 'temperatura', 647.0000, 'ºC'),
	(291136, 142, '2015-01-01 00:56:16.000000', 'temperatura', 876.0000, 'ºC'),
	(291137, 142, '2015-01-01 00:56:17.000000', 'temperatura', 40.0000, 'ºC'),
	(291138, 142, '2015-01-01 00:56:18.000000', 'temperatura', 1172.0000, 'ºC'),
	(291139, 142, '2015-01-01 00:56:19.000000', 'temperatura', 941.0000, 'ºC'),
	(291140, 142, '2015-01-01 00:56:20.000000', 'temperatura', 1191.0000, 'ºC'),
	(291141, 142, '2015-01-01 00:56:21.000000', 'temperatura', 731.0000, 'ºC'),
	(291142, 142, '2015-01-01 00:56:22.000000', 'temperatura', 83.0000, 'ºC'),
	(291143, 142, '2015-01-01 00:56:23.000000', 'temperatura', 624.0000, 'ºC'),
	(291144, 142, '2015-01-01 00:56:24.000000', 'temperatura', 469.0000, 'ºC'),
	(291145, 142, '2015-01-01 00:56:25.000000', 'temperatura', 475.0000, 'ºC'),
	(291146, 142, '2015-01-01 00:56:26.000000', 'temperatura', 968.0000, 'ºC'),
	(291147, 142, '2015-01-01 00:56:27.000000', 'temperatura', 1017.0000, 'ºC'),
	(291148, 142, '2015-01-01 00:56:28.000000', 'temperatura', 981.0000, 'ºC'),
	(291149, 142, '2015-01-01 00:56:29.000000', 'temperatura', 656.0000, 'ºC'),
	(291150, 142, '2015-01-01 00:56:30.000000', 'temperatura', 338.0000, 'ºC'),
	(291151, 142, '2015-01-01 00:56:31.000000', 'temperatura', 919.0000, 'ºC'),
	(291152, 142, '2015-01-01 00:56:32.000000', 'temperatura', 1184.0000, 'ºC'),
	(291153, 142, '2015-01-01 00:56:33.000000', 'temperatura', 763.0000, 'ºC'),
	(291154, 142, '2015-01-01 00:56:34.000000', 'temperatura', 263.0000, 'ºC'),
	(291155, 142, '2015-01-01 00:56:35.000000', 'temperatura', 226.0000, 'ºC'),
	(291156, 142, '2015-01-01 00:56:36.000000', 'temperatura', 344.0000, 'ºC'),
	(291157, 142, '2015-01-01 00:56:37.000000', 'temperatura', 1039.0000, 'ºC'),
	(291158, 142, '2015-01-01 00:56:38.000000', 'temperatura', 566.0000, 'ºC'),
	(291159, 142, '2015-01-01 00:56:39.000000', 'temperatura', 911.0000, 'ºC'),
	(291160, 142, '2015-01-01 00:56:40.000000', 'temperatura', 458.0000, 'ºC'),
	(291161, 142, '2015-01-01 00:56:41.000000', 'temperatura', 759.0000, 'ºC'),
	(291162, 142, '2015-01-01 00:56:42.000000', 'temperatura', 21.0000, 'ºC'),
	(291163, 142, '2015-01-01 00:56:43.000000', 'temperatura', 230.0000, 'ºC'),
	(291164, 142, '2015-01-01 00:56:44.000000', 'temperatura', 1088.0000, 'ºC'),
	(291165, 142, '2015-01-01 00:56:45.000000', 'temperatura', 1148.0000, 'ºC'),
	(291166, 142, '2015-01-01 00:56:46.000000', 'temperatura', 78.0000, 'ºC'),
	(291167, 142, '2015-01-01 00:56:47.000000', 'temperatura', 545.0000, 'ºC'),
	(291168, 142, '2015-01-01 00:56:48.000000', 'temperatura', 94.0000, 'ºC'),
	(291169, 142, '2015-01-01 00:56:49.000000', 'temperatura', 35.0000, 'ºC'),
	(291170, 142, '2015-01-01 00:56:50.000000', 'temperatura', 1093.0000, 'ºC'),
	(291171, 142, '2015-01-01 00:56:51.000000', 'temperatura', 561.0000, 'ºC'),
	(291172, 142, '2015-01-01 00:56:52.000000', 'temperatura', 727.0000, 'ºC'),
	(291173, 142, '2015-01-01 00:56:53.000000', 'temperatura', 753.0000, 'ºC'),
	(291174, 142, '2015-01-01 00:56:54.000000', 'temperatura', 384.0000, 'ºC'),
	(291175, 142, '2015-01-01 00:56:55.000000', 'temperatura', 863.0000, 'ºC'),
	(291176, 142, '2015-01-01 00:56:56.000000', 'temperatura', 762.0000, 'ºC'),
	(291177, 142, '2015-01-01 00:56:57.000000', 'temperatura', 22.0000, 'ºC'),
	(291178, 142, '2015-01-01 00:56:58.000000', 'temperatura', 225.0000, 'ºC'),
	(291179, 142, '2015-01-01 00:56:59.000000', 'temperatura', 1057.0000, 'ºC'),
	(291180, 142, '2015-01-01 00:57:00.000000', 'temperatura', 1013.0000, 'ºC'),
	(291181, 142, '2015-01-01 00:57:01.000000', 'temperatura', 694.0000, 'ºC'),
	(291182, 142, '2015-01-01 00:57:02.000000', 'temperatura', 429.0000, 'ºC'),
	(291183, 142, '2015-01-01 00:57:03.000000', 'temperatura', 66.0000, 'ºC'),
	(291184, 142, '2015-01-01 00:57:04.000000', 'temperatura', 243.0000, 'ºC'),
	(291185, 142, '2015-01-01 00:57:05.000000', 'temperatura', 1018.0000, 'ºC'),
	(291186, 142, '2015-01-01 00:57:06.000000', 'temperatura', 762.0000, 'ºC'),
	(291187, 142, '2015-01-01 00:57:07.000000', 'temperatura', 755.0000, 'ºC'),
	(291188, 142, '2015-01-01 00:57:08.000000', 'temperatura', 291.0000, 'ºC'),
	(291189, 142, '2015-01-01 00:57:09.000000', 'temperatura', 389.0000, 'ºC'),
	(291190, 142, '2015-01-01 00:57:10.000000', 'temperatura', 1073.0000, 'ºC'),
	(291191, 142, '2015-01-01 00:57:11.000000', 'temperatura', 600.0000, 'ºC'),
	(291192, 142, '2015-01-01 00:57:12.000000', 'temperatura', 979.0000, 'ºC'),
	(291193, 142, '2015-01-01 00:57:13.000000', 'temperatura', 696.0000, 'ºC'),
	(291194, 142, '2015-01-01 00:57:14.000000', 'temperatura', 545.0000, 'ºC'),
	(291195, 142, '2015-01-01 00:57:15.000000', 'temperatura', 636.0000, 'ºC'),
	(291196, 142, '2015-01-01 00:57:16.000000', 'temperatura', 347.0000, 'ºC'),
	(291197, 142, '2015-01-01 00:57:17.000000', 'temperatura', 1026.0000, 'ºC'),
	(291198, 142, '2015-01-01 00:57:18.000000', 'temperatura', 492.0000, 'ºC'),
	(291199, 142, '2015-01-01 00:57:19.000000', 'temperatura', 580.0000, 'ºC'),
	(291200, 142, '2015-01-01 00:57:20.000000', 'temperatura', 225.0000, 'ºC'),
	(291201, 142, '2015-01-01 00:57:21.000000', 'temperatura', 584.0000, 'ºC'),
	(291202, 142, '2015-01-01 00:57:22.000000', 'temperatura', 1046.0000, 'ºC'),
	(291203, 142, '2015-01-01 00:57:23.000000', 'temperatura', 1078.0000, 'ºC'),
	(291204, 142, '2015-01-01 00:57:24.000000', 'temperatura', 1051.0000, 'ºC'),
	(291205, 142, '2015-01-01 00:57:25.000000', 'temperatura', 824.0000, 'ºC'),
	(291206, 142, '2015-01-01 00:57:26.000000', 'temperatura', 967.0000, 'ºC'),
	(291207, 142, '2015-01-01 00:57:27.000000', 'temperatura', 1165.0000, 'ºC'),
	(291208, 142, '2015-01-01 00:57:28.000000', 'temperatura', 522.0000, 'ºC'),
	(291209, 142, '2015-01-01 00:57:29.000000', 'temperatura', 318.0000, 'ºC'),
	(291210, 142, '2015-01-01 00:57:30.000000', 'temperatura', 22.0000, 'ºC'),
	(291211, 142, '2015-01-01 00:57:31.000000', 'temperatura', 356.0000, 'ºC'),
	(291212, 142, '2015-01-01 00:57:32.000000', 'temperatura', 515.0000, 'ºC'),
	(291213, 142, '2015-01-01 00:57:33.000000', 'temperatura', 306.0000, 'ºC'),
	(291214, 142, '2015-01-01 00:57:34.000000', 'temperatura', 1187.0000, 'ºC'),
	(291215, 142, '2015-01-01 00:57:35.000000', 'temperatura', 218.0000, 'ºC'),
	(291216, 142, '2015-01-01 00:57:36.000000', 'temperatura', 1130.0000, 'ºC'),
	(291217, 142, '2015-01-01 00:57:37.000000', 'temperatura', 194.0000, 'ºC'),
	(291218, 142, '2015-01-01 00:57:38.000000', 'temperatura', 1182.0000, 'ºC'),
	(291219, 142, '2015-01-01 00:57:39.000000', 'temperatura', 530.0000, 'ºC'),
	(291220, 142, '2015-01-01 00:57:40.000000', 'temperatura', 304.0000, 'ºC'),
	(291221, 142, '2015-01-01 00:57:41.000000', 'temperatura', 1129.0000, 'ºC'),
	(291222, 142, '2015-01-01 00:57:42.000000', 'temperatura', 1134.0000, 'ºC'),
	(291223, 142, '2015-01-01 00:57:43.000000', 'temperatura', 1083.0000, 'ºC'),
	(291224, 142, '2015-01-01 00:57:44.000000', 'temperatura', 816.0000, 'ºC'),
	(291225, 142, '2015-01-01 00:57:45.000000', 'temperatura', 829.0000, 'ºC'),
	(291226, 142, '2015-01-01 00:57:46.000000', 'temperatura', 496.0000, 'ºC'),
	(291227, 142, '2015-01-01 00:57:47.000000', 'temperatura', 1197.0000, 'ºC'),
	(291228, 142, '2015-01-01 00:57:48.000000', 'temperatura', 895.0000, 'ºC'),
	(291229, 142, '2015-01-01 00:57:49.000000', 'temperatura', 883.0000, 'ºC'),
	(291230, 142, '2015-01-01 00:57:50.000000', 'temperatura', 534.0000, 'ºC'),
	(291231, 142, '2015-01-01 00:57:51.000000', 'temperatura', 19.0000, 'ºC'),
	(291232, 142, '2015-01-01 00:57:52.000000', 'temperatura', 892.0000, 'ºC'),
	(291233, 142, '2015-01-01 00:57:53.000000', 'temperatura', 806.0000, 'ºC'),
	(291234, 142, '2015-01-01 00:57:54.000000', 'temperatura', 155.0000, 'ºC'),
	(291235, 142, '2015-01-01 00:57:55.000000', 'temperatura', 757.0000, 'ºC'),
	(291236, 142, '2015-01-01 00:57:56.000000', 'temperatura', 921.0000, 'ºC'),
	(291237, 142, '2015-01-01 00:57:57.000000', 'temperatura', 1134.0000, 'ºC'),
	(291238, 142, '2015-01-01 00:57:58.000000', 'temperatura', 509.0000, 'ºC'),
	(291239, 142, '2015-01-01 00:57:59.000000', 'temperatura', 343.0000, 'ºC'),
	(291240, 142, '2015-01-01 00:58:00.000000', 'temperatura', 187.0000, 'ºC'),
	(291241, 142, '2015-01-01 00:58:01.000000', 'temperatura', 1106.0000, 'ºC'),
	(291242, 142, '2015-01-01 00:58:02.000000', 'temperatura', 169.0000, 'ºC'),
	(291243, 142, '2015-01-01 00:58:03.000000', 'temperatura', 1127.0000, 'ºC'),
	(291244, 142, '2015-01-01 00:58:04.000000', 'temperatura', 329.0000, 'ºC'),
	(291245, 142, '2015-01-01 00:58:05.000000', 'temperatura', 667.0000, 'ºC'),
	(291246, 142, '2015-01-01 00:58:06.000000', 'temperatura', 1147.0000, 'ºC'),
	(291247, 142, '2015-01-01 00:58:07.000000', 'temperatura', 132.0000, 'ºC'),
	(291248, 142, '2015-01-01 00:58:08.000000', 'temperatura', 823.0000, 'ºC'),
	(291249, 142, '2015-01-01 00:58:09.000000', 'temperatura', 118.0000, 'ºC'),
	(291250, 142, '2015-01-01 00:58:10.000000', 'temperatura', 520.0000, 'ºC'),
	(291251, 142, '2015-01-01 00:58:11.000000', 'temperatura', 1048.0000, 'ºC'),
	(291252, 142, '2015-01-01 00:58:12.000000', 'temperatura', 79.0000, 'ºC'),
	(291253, 142, '2015-01-01 00:58:13.000000', 'temperatura', 852.0000, 'ºC'),
	(291254, 142, '2015-01-01 00:58:14.000000', 'temperatura', 424.0000, 'ºC'),
	(291255, 142, '2015-01-01 00:58:15.000000', 'temperatura', 763.0000, 'ºC'),
	(291256, 142, '2015-01-01 00:58:16.000000', 'temperatura', 143.0000, 'ºC'),
	(291257, 142, '2015-01-01 00:58:17.000000', 'temperatura', 828.0000, 'ºC'),
	(291258, 142, '2015-01-01 00:58:18.000000', 'temperatura', 110.0000, 'ºC'),
	(291259, 142, '2015-01-01 00:58:19.000000', 'temperatura', 466.0000, 'ºC'),
	(291260, 142, '2015-01-01 00:58:20.000000', 'temperatura', 802.0000, 'ºC'),
	(291261, 142, '2015-01-01 00:58:21.000000', 'temperatura', 213.0000, 'ºC'),
	(291262, 142, '2015-01-01 00:58:22.000000', 'temperatura', 1059.0000, 'ºC'),
	(291263, 142, '2015-01-01 00:58:23.000000', 'temperatura', 1056.0000, 'ºC'),
	(291264, 142, '2015-01-01 00:58:24.000000', 'temperatura', 904.0000, 'ºC'),
	(291265, 142, '2015-01-01 00:58:25.000000', 'temperatura', 152.0000, 'ºC'),
	(291266, 142, '2015-01-01 00:58:26.000000', 'temperatura', 447.0000, 'ºC'),
	(291267, 142, '2015-01-01 00:58:27.000000', 'temperatura', 582.0000, 'ºC'),
	(291268, 142, '2015-01-01 00:58:28.000000', 'temperatura', 367.0000, 'ºC'),
	(291269, 142, '2015-01-01 00:58:29.000000', 'temperatura', 91.0000, 'ºC'),
	(291270, 142, '2015-01-01 00:58:30.000000', 'temperatura', 554.0000, 'ºC'),
	(291271, 142, '2015-01-01 00:58:31.000000', 'temperatura', 97.0000, 'ºC'),
	(291272, 142, '2015-01-01 00:58:32.000000', 'temperatura', 26.0000, 'ºC'),
	(291273, 142, '2015-01-01 00:58:33.000000', 'temperatura', 1037.0000, 'ºC'),
	(291274, 142, '2015-01-01 00:58:34.000000', 'temperatura', 309.0000, 'ºC'),
	(291275, 142, '2015-01-01 00:58:35.000000', 'temperatura', 834.0000, 'ºC'),
	(291276, 142, '2015-01-01 00:58:36.000000', 'temperatura', 843.0000, 'ºC'),
	(291277, 142, '2015-01-01 00:58:37.000000', 'temperatura', 516.0000, 'ºC'),
	(291278, 142, '2015-01-01 00:58:38.000000', 'temperatura', 50.0000, 'ºC'),
	(291279, 142, '2015-01-01 00:58:39.000000', 'temperatura', 1101.0000, 'ºC'),
	(291280, 142, '2015-01-01 00:58:40.000000', 'temperatura', 555.0000, 'ºC'),
	(291281, 142, '2015-01-01 00:58:41.000000', 'temperatura', 675.0000, 'ºC'),
	(291282, 142, '2015-01-01 00:58:42.000000', 'temperatura', 509.0000, 'ºC'),
	(291283, 142, '2015-01-01 00:58:43.000000', 'temperatura', 520.0000, 'ºC'),
	(291284, 142, '2015-01-01 00:58:44.000000', 'temperatura', 1075.0000, 'ºC'),
	(291285, 142, '2015-01-01 00:58:45.000000', 'temperatura', 214.0000, 'ºC'),
	(291286, 142, '2015-01-01 00:58:46.000000', 'temperatura', 246.0000, 'ºC'),
	(291287, 142, '2015-01-01 00:58:47.000000', 'temperatura', 589.0000, 'ºC'),
	(291288, 142, '2015-01-01 00:58:48.000000', 'temperatura', 1009.0000, 'ºC'),
	(291289, 142, '2015-01-01 00:58:49.000000', 'temperatura', 877.0000, 'ºC'),
	(291290, 142, '2015-01-01 00:58:50.000000', 'temperatura', 159.0000, 'ºC'),
	(291291, 142, '2015-01-01 00:58:51.000000', 'temperatura', 564.0000, 'ºC'),
	(291292, 142, '2015-01-01 00:58:52.000000', 'temperatura', 1143.0000, 'ºC'),
	(291293, 142, '2015-01-01 00:58:53.000000', 'temperatura', 422.0000, 'ºC'),
	(291294, 142, '2015-01-01 00:58:54.000000', 'temperatura', 1084.0000, 'ºC'),
	(291295, 142, '2015-01-01 00:58:55.000000', 'temperatura', 553.0000, 'ºC'),
	(291296, 142, '2015-01-01 00:58:56.000000', 'temperatura', 715.0000, 'ºC'),
	(291297, 142, '2015-01-01 00:58:57.000000', 'temperatura', 718.0000, 'ºC'),
	(291298, 142, '2015-01-01 00:58:58.000000', 'temperatura', 243.0000, 'ºC'),
	(291299, 142, '2015-01-01 00:58:59.000000', 'temperatura', 263.0000, 'ºC'),
	(291300, 142, '2015-01-01 00:59:00.000000', 'temperatura', 587.0000, 'ºC'),
	(291301, 142, '2015-01-01 00:59:01.000000', 'temperatura', 945.0000, 'ºC'),
	(291302, 142, '2015-01-01 00:59:02.000000', 'temperatura', 565.0000, 'ºC'),
	(291303, 142, '2015-01-01 00:59:03.000000', 'temperatura', 1189.0000, 'ºC'),
	(291304, 142, '2015-01-01 00:59:04.000000', 'temperatura', 652.0000, 'ºC'),
	(291305, 142, '2015-01-01 00:59:05.000000', 'temperatura', 895.0000, 'ºC'),
	(291306, 142, '2015-01-01 00:59:06.000000', 'temperatura', 120.0000, 'ºC'),
	(291307, 142, '2015-01-01 00:59:07.000000', 'temperatura', 312.0000, 'ºC'),
	(291308, 142, '2015-01-01 00:59:08.000000', 'temperatura', 4.0000, 'ºC'),
	(291309, 142, '2015-01-01 00:59:09.000000', 'temperatura', 283.0000, 'ºC'),
	(291310, 142, '2015-01-01 00:59:10.000000', 'temperatura', 204.0000, 'ºC'),
	(291311, 142, '2015-01-01 00:59:11.000000', 'temperatura', 173.0000, 'ºC'),
	(291312, 142, '2015-01-01 00:59:12.000000', 'temperatura', 251.0000, 'ºC'),
	(291313, 142, '2015-01-01 00:59:13.000000', 'temperatura', 739.0000, 'ºC'),
	(291314, 142, '2015-01-01 00:59:14.000000', 'temperatura', 541.0000, 'ºC'),
	(291315, 142, '2015-01-01 00:59:15.000000', 'temperatura', 487.0000, 'ºC'),
	(291316, 142, '2015-01-01 00:59:16.000000', 'temperatura', 815.0000, 'ºC'),
	(291317, 142, '2015-01-01 00:59:17.000000', 'temperatura', 215.0000, 'ºC'),
	(291318, 142, '2015-01-01 00:59:18.000000', 'temperatura', 1029.0000, 'ºC'),
	(291319, 142, '2015-01-01 00:59:19.000000', 'temperatura', 901.0000, 'ºC'),
	(291320, 142, '2015-01-01 00:59:20.000000', 'temperatura', 217.0000, 'ºC'),
	(291321, 142, '2015-01-01 00:59:21.000000', 'temperatura', 783.0000, 'ºC'),
	(291322, 142, '2015-01-01 00:59:22.000000', 'temperatura', 866.0000, 'ºC'),
	(291323, 142, '2015-01-01 00:59:23.000000', 'temperatura', 780.0000, 'ºC'),
	(291324, 142, '2015-01-01 00:59:24.000000', 'temperatura', 105.0000, 'ºC'),
	(291325, 142, '2015-01-01 00:59:25.000000', 'temperatura', 583.0000, 'ºC'),
	(291326, 142, '2015-01-01 00:59:26.000000', 'temperatura', 202.0000, 'ºC'),
	(291327, 142, '2015-01-01 00:59:27.000000', 'temperatura', 459.0000, 'ºC'),
	(291328, 142, '2015-01-01 00:59:28.000000', 'temperatura', 491.0000, 'ºC'),
	(291329, 142, '2015-01-01 00:59:29.000000', 'temperatura', 1079.0000, 'ºC'),
	(291330, 142, '2015-01-01 00:59:30.000000', 'temperatura', 320.0000, 'ºC'),
	(291331, 142, '2015-01-01 00:59:31.000000', 'temperatura', 765.0000, 'ºC'),
	(291332, 142, '2015-01-01 00:59:32.000000', 'temperatura', 465.0000, 'ºC'),
	(291333, 142, '2015-01-01 00:59:33.000000', 'temperatura', 30.0000, 'ºC'),
	(291334, 142, '2015-01-01 00:59:34.000000', 'temperatura', 1155.0000, 'ºC'),
	(291335, 142, '2015-01-01 00:59:35.000000', 'temperatura', 885.0000, 'ºC'),
	(291336, 142, '2015-01-01 00:59:36.000000', 'temperatura', 962.0000, 'ºC'),
	(291337, 142, '2015-01-01 00:59:37.000000', 'temperatura', 957.0000, 'ºC'),
	(291338, 142, '2015-01-01 00:59:38.000000', 'temperatura', 698.0000, 'ºC'),
	(291339, 142, '2015-01-01 00:59:39.000000', 'temperatura', 618.0000, 'ºC'),
	(291340, 142, '2015-01-01 00:59:40.000000', 'temperatura', 996.0000, 'ºC'),
	(291341, 142, '2015-01-01 00:59:41.000000', 'temperatura', 729.0000, 'ºC'),
	(291342, 142, '2015-01-01 00:59:42.000000', 'temperatura', 657.0000, 'ºC'),
	(291343, 142, '2015-01-01 00:59:43.000000', 'temperatura', 1096.0000, 'ºC'),
	(291344, 142, '2015-01-01 00:59:44.000000', 'temperatura', 1112.0000, 'ºC'),
	(291345, 142, '2015-01-01 00:59:45.000000', 'temperatura', 1072.0000, 'ºC'),
	(291346, 142, '2015-01-01 00:59:46.000000', 'temperatura', 824.0000, 'ºC'),
	(291347, 142, '2015-01-01 00:59:47.000000', 'temperatura', 906.0000, 'ºC'),
	(291348, 142, '2015-01-01 00:59:48.000000', 'temperatura', 858.0000, 'ºC'),
	(291349, 142, '2015-01-01 00:59:49.000000', 'temperatura', 373.0000, 'ºC'),
	(291350, 142, '2015-01-01 00:59:50.000000', 'temperatura', 492.0000, 'ºC'),
	(291351, 142, '2015-01-01 00:59:51.000000', 'temperatura', 139.0000, 'ºC'),
	(291352, 142, '2015-01-01 00:59:52.000000', 'temperatura', 421.0000, 'ºC'),
	(291353, 142, '2015-01-01 00:59:53.000000', 'temperatura', 487.0000, 'ºC'),
	(291354, 142, '2015-01-01 00:59:54.000000', 'temperatura', 1175.0000, 'ºC'),
	(291355, 142, '2015-01-01 00:59:55.000000', 'temperatura', 813.0000, 'ºC'),
	(291356, 142, '2015-01-01 00:59:56.000000', 'temperatura', 542.0000, 'ºC'),
	(291357, 142, '2015-01-01 00:59:57.000000', 'temperatura', 271.0000, 'ºC'),
	(291358, 142, '2015-01-01 00:59:58.000000', 'temperatura', 930.0000, 'ºC'),
	(291359, 142, '2015-01-01 00:59:59.000000', 'temperatura', 236.0000, 'ºC'),
	(291360, 142, '2015-01-01 01:00:00.000000', 'temperatura', 790.0000, 'ºC'),
	(291361, 142, '2015-01-01 01:00:01.000000', 'temperatura', 841.0000, 'ºC'),
	(291362, 142, '2015-01-01 01:00:02.000000', 'temperatura', 638.0000, 'ºC'),
	(291363, 142, '2015-01-01 01:00:03.000000', 'temperatura', 668.0000, 'ºC'),
	(291364, 142, '2015-01-01 01:00:04.000000', 'temperatura', 227.0000, 'ºC'),
	(291365, 142, '2015-01-01 01:00:05.000000', 'temperatura', 332.0000, 'ºC'),
	(291366, 142, '2015-01-01 01:00:06.000000', 'temperatura', 979.0000, 'ºC'),
	(291367, 142, '2015-01-01 01:00:07.000000', 'temperatura', 299.0000, 'ºC'),
	(291368, 142, '2015-01-01 01:00:08.000000', 'temperatura', 958.0000, 'ºC'),
	(291369, 142, '2015-01-01 01:00:09.000000', 'temperatura', 293.0000, 'ºC'),
	(291370, 142, '2015-01-01 01:00:10.000000', 'temperatura', 990.0000, 'ºC'),
	(291371, 142, '2015-01-01 01:00:11.000000', 'temperatura', 473.0000, 'ºC'),
	(291372, 142, '2015-01-01 01:00:12.000000', 'temperatura', 597.0000, 'ºC'),
	(291373, 142, '2015-01-01 01:00:13.000000', 'temperatura', 367.0000, 'ºC'),
	(291374, 142, '2015-01-01 01:00:14.000000', 'temperatura', 42.0000, 'ºC'),
	(291375, 142, '2015-01-01 01:00:15.000000', 'temperatura', 311.0000, 'ºC'),
	(291376, 142, '2015-01-01 01:00:16.000000', 'temperatura', 230.0000, 'ºC'),
	(291377, 142, '2015-01-01 01:00:17.000000', 'temperatura', 215.0000, 'ºC'),
	(291378, 142, '2015-01-01 01:00:18.000000', 'temperatura', 386.0000, 'ºC'),
	(291379, 142, '2015-01-01 01:00:19.000000', 'temperatura', 85.0000, 'ºC'),
	(291380, 142, '2015-01-01 01:00:20.000000', 'temperatura', 470.0000, 'ºC'),
	(291381, 142, '2015-01-01 01:00:21.000000', 'temperatura', 896.0000, 'ºC'),
	(291382, 142, '2015-01-01 01:00:22.000000', 'temperatura', 668.0000, 'ºC'),
	(291383, 142, '2015-01-01 01:00:23.000000', 'temperatura', 653.0000, 'ºC'),
	(291384, 142, '2015-01-01 01:00:24.000000', 'temperatura', 62.0000, 'ºC'),
	(291385, 142, '2015-01-01 01:00:25.000000', 'temperatura', 752.0000, 'ºC'),
	(291386, 142, '2015-01-01 01:00:26.000000', 'temperatura', 1175.0000, 'ºC'),
	(291387, 142, '2015-01-01 01:00:27.000000', 'temperatura', 20.0000, 'ºC'),
	(291388, 142, '2015-01-01 01:00:28.000000', 'temperatura', 176.0000, 'ºC'),
	(291389, 142, '2015-01-01 01:00:29.000000', 'temperatura', 818.0000, 'ºC'),
	(291390, 142, '2015-01-01 01:00:30.000000', 'temperatura', 1165.0000, 'ºC'),
	(291391, 142, '2015-01-01 01:00:31.000000', 'temperatura', 970.0000, 'ºC'),
	(291392, 142, '2015-01-01 01:00:32.000000', 'temperatura', 157.0000, 'ºC'),
	(291393, 142, '2015-01-01 01:00:33.000000', 'temperatura', 273.0000, 'ºC'),
	(291394, 142, '2015-01-01 01:00:34.000000', 'temperatura', 896.0000, 'ºC'),
	(291395, 142, '2015-01-01 01:00:35.000000', 'temperatura', 61.0000, 'ºC'),
	(291396, 142, '2015-01-01 01:00:36.000000', 'temperatura', 18.0000, 'ºC'),
	(291397, 142, '2015-01-01 01:00:37.000000', 'temperatura', 1106.0000, 'ºC'),
	(291398, 142, '2015-01-01 01:00:38.000000', 'temperatura', 679.0000, 'ºC'),
	(291399, 142, '2015-01-01 01:00:39.000000', 'temperatura', 77.0000, 'ºC'),
	(291400, 142, '2015-01-01 01:00:40.000000', 'temperatura', 746.0000, 'ºC'),
	(291401, 142, '2015-01-01 01:00:41.000000', 'temperatura', 1102.0000, 'ºC'),
	(291402, 142, '2015-01-01 01:00:42.000000', 'temperatura', 871.0000, 'ºC'),
	(291403, 142, '2015-01-01 01:00:43.000000', 'temperatura', 1049.0000, 'ºC'),
	(291404, 142, '2015-01-01 01:00:44.000000', 'temperatura', 231.0000, 'ºC'),
	(291405, 142, '2015-01-01 01:00:45.000000', 'temperatura', 412.0000, 'ºC'),
	(291406, 142, '2015-01-01 01:00:46.000000', 'temperatura', 166.0000, 'ºC'),
	(291407, 142, '2015-01-01 01:00:47.000000', 'temperatura', 794.0000, 'ºC'),
	(291408, 142, '2015-01-01 01:00:48.000000', 'temperatura', 1072.0000, 'ºC'),
	(291409, 142, '2015-01-01 01:00:49.000000', 'temperatura', 579.0000, 'ºC'),
	(291410, 142, '2015-01-01 01:00:50.000000', 'temperatura', 879.0000, 'ºC'),
	(291411, 142, '2015-01-01 01:00:51.000000', 'temperatura', 258.0000, 'ºC'),
	(291412, 142, '2015-01-01 01:00:52.000000', 'temperatura', 1054.0000, 'ºC'),
	(291413, 142, '2015-01-01 01:00:53.000000', 'temperatura', 898.0000, 'ºC'),
	(291414, 142, '2015-01-01 01:00:54.000000', 'temperatura', 128.0000, 'ºC'),
	(291415, 142, '2015-01-01 01:00:55.000000', 'temperatura', 346.0000, 'ºC'),
	(291416, 142, '2015-01-01 01:00:56.000000', 'temperatura', 148.0000, 'ºC'),
	(291417, 142, '2015-01-01 01:00:57.000000', 'temperatura', 901.0000, 'ºC'),
	(291418, 142, '2015-01-01 01:00:58.000000', 'temperatura', 460.0000, 'ºC'),
	(291419, 142, '2015-01-01 01:00:59.000000', 'temperatura', 801.0000, 'ºC'),
	(291420, 142, '2015-01-01 01:01:00.000000', 'temperatura', 224.0000, 'ºC'),
	(291421, 142, '2015-01-01 01:01:01.000000', 'temperatura', 1116.0000, 'ºC'),
	(291422, 142, '2015-01-01 01:01:02.000000', 'temperatura', 111.0000, 'ºC'),
	(291423, 142, '2015-01-01 01:01:03.000000', 'temperatura', 807.0000, 'ºC'),
	(291424, 142, '2015-01-01 01:01:04.000000', 'temperatura', 100.0000, 'ºC'),
	(291425, 142, '2015-01-01 01:01:05.000000', 'temperatura', 482.0000, 'ºC'),
	(291426, 142, '2015-01-01 01:01:06.000000', 'temperatura', 910.0000, 'ºC'),
	(291427, 142, '2015-01-01 01:01:07.000000', 'temperatura', 704.0000, 'ºC'),
	(291428, 142, '2015-01-01 01:01:08.000000', 'temperatura', 792.0000, 'ºC'),
	(291429, 142, '2015-01-01 01:01:09.000000', 'temperatura', 648.0000, 'ºC'),
	(291430, 142, '2015-01-01 01:01:10.000000', 'temperatura', 864.0000, 'ºC'),
	(291431, 142, '2015-01-01 01:01:11.000000', 'temperatura', 1178.0000, 'ºC'),
	(291432, 142, '2015-01-01 01:01:12.000000', 'temperatura', 900.0000, 'ºC'),
	(291433, 142, '2015-01-01 01:01:13.000000', 'temperatura', 963.0000, 'ºC'),
	(291434, 142, '2015-01-01 01:01:14.000000', 'temperatura', 917.0000, 'ºC'),
	(291435, 142, '2015-01-01 01:01:15.000000', 'temperatura', 497.0000, 'ºC'),
	(291436, 142, '2015-01-01 01:01:16.000000', 'temperatura', 933.0000, 'ºC'),
	(291437, 142, '2015-01-01 01:01:17.000000', 'temperatura', 775.0000, 'ºC'),
	(291438, 142, '2015-01-01 01:01:18.000000', 'temperatura', 1079.0000, 'ºC'),
	(291439, 142, '2015-01-01 01:01:19.000000', 'temperatura', 668.0000, 'ºC'),
	(291440, 142, '2015-01-01 01:01:20.000000', 'temperatura', 103.0000, 'ºC'),
	(291441, 142, '2015-01-01 01:01:21.000000', 'temperatura', 911.0000, 'ºC'),
	(291442, 142, '2015-01-01 01:01:22.000000', 'temperatura', 648.0000, 'ºC'),
	(291443, 142, '2015-01-01 01:01:23.000000', 'temperatura', 507.0000, 'ºC'),
	(291444, 142, '2015-01-01 01:01:24.000000', 'temperatura', 593.0000, 'ºC'),
	(291445, 142, '2015-01-01 01:01:25.000000', 'temperatura', 243.0000, 'ºC'),
	(291446, 142, '2015-01-01 01:01:26.000000', 'temperatura', 636.0000, 'ºC'),
	(291447, 142, '2015-01-01 01:01:27.000000', 'temperatura', 54.0000, 'ºC'),
	(291448, 142, '2015-01-01 01:01:28.000000', 'temperatura', 761.0000, 'ºC'),
	(291449, 142, '2015-01-01 01:01:29.000000', 'temperatura', 45.0000, 'ºC'),
	(291450, 142, '2015-01-01 01:01:30.000000', 'temperatura', 342.0000, 'ºC'),
	(291451, 142, '2015-01-01 01:01:31.000000', 'temperatura', 374.0000, 'ºC'),
	(291452, 142, '2015-01-01 01:01:32.000000', 'temperatura', 846.0000, 'ºC'),
	(291453, 142, '2015-01-01 01:01:33.000000', 'temperatura', 709.0000, 'ºC'),
	(291454, 142, '2015-01-01 01:01:34.000000', 'temperatura', 1008.0000, 'ºC'),
	(291455, 142, '2015-01-01 01:01:35.000000', 'temperatura', 511.0000, 'ºC'),
	(291456, 142, '2015-01-01 01:01:36.000000', 'temperatura', 734.0000, 'ºC'),
	(291457, 142, '2015-01-01 01:01:37.000000', 'temperatura', 937.0000, 'ºC'),
	(291458, 142, '2015-01-01 01:01:38.000000', 'temperatura', 82.0000, 'ºC'),
	(291459, 142, '2015-01-01 01:01:39.000000', 'temperatura', 1199.0000, 'ºC'),
	(291460, 142, '2015-01-01 01:01:40.000000', 'temperatura', 952.0000, 'ºC'),
	(291461, 142, '2015-01-01 01:01:41.000000', 'temperatura', 1161.0000, 'ºC'),
	(291462, 142, '2015-01-01 01:01:42.000000', 'temperatura', 552.0000, 'ºC'),
	(291463, 142, '2015-01-01 01:01:43.000000', 'temperatura', 475.0000, 'ºC'),
	(291464, 142, '2015-01-01 01:01:44.000000', 'temperatura', 722.0000, 'ºC'),
	(291465, 142, '2015-01-01 01:01:45.000000', 'temperatura', 985.0000, 'ºC'),
	(291466, 142, '2015-01-01 01:01:46.000000', 'temperatura', 361.0000, 'ºC'),
	(291467, 142, '2015-01-01 01:01:47.000000', 'temperatura', 47.0000, 'ºC'),
	(291468, 142, '2015-01-01 01:01:48.000000', 'temperatura', 355.0000, 'ºC'),
	(291469, 142, '2015-01-01 01:01:49.000000', 'temperatura', 432.0000, 'ºC'),
	(291470, 142, '2015-01-01 01:01:50.000000', 'temperatura', 1096.0000, 'ºC'),
	(291471, 142, '2015-01-01 01:01:51.000000', 'temperatura', 587.0000, 'ºC'),
	(291472, 142, '2015-01-01 01:01:52.000000', 'temperatura', 846.0000, 'ºC'),
	(291473, 142, '2015-01-01 01:01:53.000000', 'temperatura', 69.0000, 'ºC'),
	(291474, 142, '2015-01-01 01:01:54.000000', 'temperatura', 208.0000, 'ºC'),
	(291475, 142, '2015-01-01 01:01:55.000000', 'temperatura', 835.0000, 'ºC'),
	(291476, 142, '2015-01-01 01:01:56.000000', 'temperatura', 1150.0000, 'ºC'),
	(291477, 142, '2015-01-01 01:01:57.000000', 'temperatura', 846.0000, 'ºC'),
	(291478, 142, '2015-01-01 01:01:58.000000', 'temperatura', 780.0000, 'ºC'),
	(291479, 142, '2015-01-01 01:01:59.000000', 'temperatura', 161.0000, 'ºC'),
	(291480, 142, '2015-01-01 01:02:00.000000', 'temperatura', 868.0000, 'ºC'),
	(291481, 142, '2015-01-01 01:02:01.000000', 'temperatura', 255.0000, 'ºC'),
	(291482, 142, '2015-01-01 01:02:02.000000', 'temperatura', 1072.0000, 'ºC'),
	(291483, 142, '2015-01-01 01:02:03.000000', 'temperatura', 996.0000, 'ºC'),
	(291484, 142, '2015-01-01 01:02:04.000000', 'temperatura', 566.0000, 'ºC'),
	(291485, 142, '2015-01-01 01:02:05.000000', 'temperatura', 1041.0000, 'ºC'),
	(291486, 142, '2015-01-01 01:02:06.000000', 'temperatura', 1106.0000, 'ºC'),
	(291487, 142, '2015-01-01 01:02:07.000000', 'temperatura', 10.0000, 'ºC'),
	(291488, 142, '2015-01-01 01:02:08.000000', 'temperatura', 332.0000, 'ºC'),
	(291489, 142, '2015-01-01 01:02:09.000000', 'temperatura', 432.0000, 'ºC'),
	(291490, 142, '2015-01-01 01:02:10.000000', 'temperatura', 1163.0000, 'ºC'),
	(291491, 142, '2015-01-01 01:02:11.000000', 'temperatura', 919.0000, 'ºC'),
	(291492, 142, '2015-01-01 01:02:12.000000', 'temperatura', 1106.0000, 'ºC'),
	(291493, 142, '2015-01-01 01:02:13.000000', 'temperatura', 372.0000, 'ºC'),
	(291494, 142, '2015-01-01 01:02:14.000000', 'temperatura', 946.0000, 'ºC'),
	(291495, 142, '2015-01-01 01:02:15.000000', 'temperatura', 12.0000, 'ºC'),
	(291496, 142, '2015-01-01 01:02:16.000000', 'temperatura', 824.0000, 'ºC'),
	(291497, 142, '2015-01-01 01:02:17.000000', 'temperatura', 483.0000, 'ºC'),
	(291498, 142, '2015-01-01 01:02:18.000000', 'temperatura', 1144.0000, 'ºC'),
	(291499, 142, '2015-01-01 01:02:19.000000', 'temperatura', 670.0000, 'ºC'),
	(291500, 142, '2015-01-01 01:02:20.000000', 'temperatura', 1121.0000, 'ºC'),
	(291501, 142, '2015-01-01 01:02:21.000000', 'temperatura', 1193.0000, 'ºC'),
	(291502, 142, '2015-01-01 01:02:22.000000', 'temperatura', 204.0000, 'ºC'),
	(291503, 142, '2015-01-01 01:02:23.000000', 'temperatura', 1041.0000, 'ºC'),
	(291504, 142, '2015-01-01 01:02:24.000000', 'temperatura', 992.0000, 'ºC'),
	(291505, 142, '2015-01-01 01:02:25.000000', 'temperatura', 639.0000, 'ºC'),
	(291506, 142, '2015-01-01 01:02:26.000000', 'temperatura', 219.0000, 'ºC'),
	(291507, 142, '2015-01-01 01:02:27.000000', 'temperatura', 379.0000, 'ºC'),
	(291508, 142, '2015-01-01 01:02:28.000000', 'temperatura', 38.0000, 'ºC'),
	(291509, 142, '2015-01-01 01:02:29.000000', 'temperatura', 255.0000, 'ºC'),
	(291510, 142, '2015-01-01 01:02:30.000000', 'temperatura', 1161.0000, 'ºC'),
	(291511, 142, '2015-01-01 01:02:31.000000', 'temperatura', 241.0000, 'ºC'),
	(291512, 142, '2015-01-01 01:02:32.000000', 'temperatura', 121.0000, 'ºC'),
	(291513, 142, '2015-01-01 01:02:33.000000', 'temperatura', 1082.0000, 'ºC'),
	(291514, 142, '2015-01-01 01:02:34.000000', 'temperatura', 247.0000, 'ºC'),
	(291515, 142, '2015-01-01 01:02:35.000000', 'temperatura', 389.0000, 'ºC'),
	(291516, 142, '2015-01-01 01:02:36.000000', 'temperatura', 4.0000, 'ºC'),
	(291517, 142, '2015-01-01 01:02:37.000000', 'temperatura', 57.0000, 'ºC'),
	(291518, 142, '2015-01-01 01:02:38.000000', 'temperatura', 270.0000, 'ºC'),
	(291519, 142, '2015-01-01 01:02:39.000000', 'temperatura', 1181.0000, 'ºC'),
	(291520, 142, '2015-01-01 01:02:40.000000', 'temperatura', 297.0000, 'ºC'),
	(291521, 142, '2015-01-01 01:02:41.000000', 'temperatura', 343.0000, 'ºC'),
	(291522, 142, '2015-01-01 01:02:42.000000', 'temperatura', 822.0000, 'ºC'),
	(291523, 142, '2015-01-01 01:02:43.000000', 'temperatura', 682.0000, 'ºC'),
	(291524, 142, '2015-01-01 01:02:44.000000', 'temperatura', 943.0000, 'ºC'),
	(291525, 142, '2015-01-01 01:02:45.000000', 'temperatura', 271.0000, 'ºC'),
	(291526, 142, '2015-01-01 01:02:46.000000', 'temperatura', 924.0000, 'ºC'),
	(291527, 142, '2015-01-01 01:02:47.000000', 'temperatura', 210.0000, 'ºC'),
	(291528, 142, '2015-01-01 01:02:48.000000', 'temperatura', 679.0000, 'ºC'),
	(291529, 142, '2015-01-01 01:02:49.000000', 'temperatura', 363.0000, 'ºC'),
	(291530, 142, '2015-01-01 01:02:50.000000', 'temperatura', 978.0000, 'ºC'),
	(291531, 142, '2015-01-01 01:02:51.000000', 'temperatura', 204.0000, 'ºC'),
	(291532, 142, '2015-01-01 01:02:52.000000', 'temperatura', 484.0000, 'ºC'),
	(291533, 142, '2015-01-01 01:02:53.000000', 'temperatura', 610.0000, 'ºC'),
	(291534, 142, '2015-01-01 01:02:54.000000', 'temperatura', 399.0000, 'ºC'),
	(291535, 142, '2015-01-01 01:02:55.000000', 'temperatura', 166.0000, 'ºC'),
	(291536, 142, '2015-01-01 01:02:56.000000', 'temperatura', 831.0000, 'ºC'),
	(291537, 142, '2015-01-01 01:02:57.000000', 'temperatura', 60.0000, 'ºC'),
	(291538, 142, '2015-01-01 01:02:58.000000', 'temperatura', 204.0000, 'ºC'),
	(291539, 142, '2015-01-01 01:02:59.000000', 'temperatura', 844.0000, 'ºC'),
	(291540, 142, '2015-01-01 01:03:00.000000', 'temperatura', 9.0000, 'ºC'),
	(291541, 142, '2015-01-01 01:03:01.000000', 'temperatura', 1112.0000, 'ºC'),
	(291542, 142, '2015-01-01 01:03:02.000000', 'temperatura', 735.0000, 'ºC'),
	(291543, 142, '2015-01-01 01:03:03.000000', 'temperatura', 340.0000, 'ºC'),
	(291544, 142, '2015-01-01 01:03:04.000000', 'temperatura', 694.0000, 'ºC'),
	(291545, 142, '2015-01-01 01:03:05.000000', 'temperatura', 50.0000, 'ºC'),
	(291546, 142, '2015-01-01 01:03:06.000000', 'temperatura', 571.0000, 'ºC'),
	(291547, 142, '2015-01-01 01:03:07.000000', 'temperatura', 302.0000, 'ºC'),
	(291548, 142, '2015-01-01 01:03:08.000000', 'temperatura', 1000.0000, 'ºC'),
	(291549, 142, '2015-01-01 01:03:09.000000', 'temperatura', 492.0000, 'ºC'),
	(291550, 142, '2015-01-01 01:03:10.000000', 'temperatura', 664.0000, 'ºC'),
	(291551, 142, '2015-01-01 01:03:11.000000', 'temperatura', 641.0000, 'ºC'),
	(291552, 142, '2015-01-01 01:03:12.000000', 'temperatura', 14.0000, 'ºC'),
	(291553, 142, '2015-01-01 01:03:13.000000', 'temperatura', 549.0000, 'ºC'),
	(291554, 142, '2015-01-01 01:03:14.000000', 'temperatura', 304.0000, 'ºC'),
	(291555, 142, '2015-01-01 01:03:15.000000', 'temperatura', 1074.0000, 'ºC'),
	(291556, 142, '2015-01-01 01:03:16.000000', 'temperatura', 857.0000, 'ºC'),
	(291557, 142, '2015-01-01 01:03:17.000000', 'temperatura', 1063.0000, 'ºC'),
	(291558, 142, '2015-01-01 01:03:18.000000', 'temperatura', 347.0000, 'ºC'),
	(291559, 142, '2015-01-01 01:03:19.000000', 'temperatura', 944.0000, 'ºC'),
	(291560, 142, '2015-01-01 01:03:20.000000', 'temperatura', 81.0000, 'ºC'),
	(291561, 142, '2015-01-01 01:03:21.000000', 'temperatura', 1172.0000, 'ºC'),
	(291562, 142, '2015-01-01 01:03:22.000000', 'temperatura', 817.0000, 'ºC'),
	(291563, 142, '2015-01-01 01:03:23.000000', 'temperatura', 569.0000, 'ºC'),
	(291564, 142, '2015-01-01 01:03:24.000000', 'temperatura', 397.0000, 'ºC'),
	(291565, 142, '2015-01-01 01:03:25.000000', 'temperatura', 279.0000, 'ºC'),
	(291566, 142, '2015-01-01 01:03:26.000000', 'temperatura', 201.0000, 'ºC'),
	(291567, 142, '2015-01-01 01:03:27.000000', 'temperatura', 171.0000, 'ºC'),
	(291568, 142, '2015-01-01 01:03:28.000000', 'temperatura', 254.0000, 'ºC'),
	(291569, 142, '2015-01-01 01:03:29.000000', 'temperatura', 756.0000, 'ºC'),
	(291570, 142, '2015-01-01 01:03:30.000000', 'temperatura', 619.0000, 'ºC'),
	(291571, 142, '2015-01-01 01:03:31.000000', 'temperatura', 826.0000, 'ºC'),
	(291572, 142, '2015-01-01 01:03:32.000000', 'temperatura', 1074.0000, 'ºC'),
	(291573, 142, '2015-01-01 01:03:33.000000', 'temperatura', 495.0000, 'ºC'),
	(291574, 142, '2015-01-01 01:03:34.000000', 'temperatura', 451.0000, 'ºC'),
	(291575, 142, '2015-01-01 01:03:35.000000', 'temperatura', 771.0000, 'ºC'),
	(291576, 142, '2015-01-01 01:03:36.000000', 'temperatura', 101.0000, 'ºC'),
	(291577, 142, '2015-01-01 01:03:37.000000', 'temperatura', 595.0000, 'ºC'),
	(291578, 142, '2015-01-01 01:03:38.000000', 'temperatura', 271.0000, 'ºC'),
	(291579, 142, '2015-01-01 01:03:39.000000', 'temperatura', 769.0000, 'ºC'),
	(291580, 142, '2015-01-01 01:03:40.000000', 'temperatura', 635.0000, 'ºC'),
	(291581, 142, '2015-01-01 01:03:41.000000', 'temperatura', 869.0000, 'ºC'),
	(291582, 142, '2015-01-01 01:03:42.000000', 'temperatura', 38.0000, 'ºC'),
	(291583, 142, '2015-01-01 01:03:43.000000', 'temperatura', 1185.0000, 'ºC'),
	(291584, 142, '2015-01-01 01:03:44.000000', 'temperatura', 1012.0000, 'ºC'),
	(291585, 142, '2015-01-01 01:03:45.000000', 'temperatura', 305.0000, 'ºC'),
	(291586, 142, '2015-01-01 01:03:46.000000', 'temperatura', 890.0000, 'ºC'),
	(291587, 142, '2015-01-01 01:03:47.000000', 'temperatura', 1137.0000, 'ºC'),
	(291588, 142, '2015-01-01 01:03:48.000000', 'temperatura', 612.0000, 'ºC'),
	(291589, 142, '2015-01-01 01:03:49.000000', 'temperatura', 852.0000, 'ºC'),
	(291590, 142, '2015-01-01 01:03:50.000000', 'temperatura', 23.0000, 'ºC'),
	(291591, 142, '2015-01-01 01:03:51.000000', 'temperatura', 1162.0000, 'ºC'),
	(291592, 142, '2015-01-01 01:03:52.000000', 'temperatura', 940.0000, 'ºC'),
	(291593, 142, '2015-01-01 01:03:53.000000', 'temperatura', 14.0000, 'ºC'),
	(291594, 142, '2015-01-01 01:03:54.000000', 'temperatura', 850.0000, 'ºC'),
	(291595, 142, '2015-01-01 01:03:55.000000', 'temperatura', 611.0000, 'ºC'),
	(291596, 142, '2015-01-01 01:03:56.000000', 'temperatura', 505.0000, 'ºC'),
	(291597, 142, '2015-01-01 01:03:57.000000', 'temperatura', 692.0000, 'ºC'),
	(291598, 142, '2015-01-01 01:03:58.000000', 'temperatura', 746.0000, 'ºC'),
	(291599, 142, '2015-01-01 01:03:59.000000', 'temperatura', 455.0000, 'ºC'),
	(291600, 142, '2015-01-01 01:04:00.000000', 'temperatura', 38.0000, 'ºC'),
	(291601, 142, '2015-01-01 01:04:01.000000', 'temperatura', 24.0000, 'ºC'),
	(291602, 142, '2015-01-01 01:04:02.000000', 'temperatura', 6.0000, 'ºC'),
	(291603, 142, '2015-01-01 01:04:03.000000', 'temperatura', 1158.0000, 'ºC'),
	(291604, 142, '2015-01-01 01:04:04.000000', 'temperatura', 975.0000, 'ºC'),
	(291605, 142, '2015-01-01 01:04:05.000000', 'temperatura', 201.0000, 'ºC'),
	(291606, 142, '2015-01-01 01:04:06.000000', 'temperatura', 478.0000, 'ºC'),
	(291607, 142, '2015-01-01 01:04:07.000000', 'temperatura', 591.0000, 'ºC'),
	(291608, 142, '2015-01-01 01:04:08.000000', 'temperatura', 319.0000, 'ºC'),
	(291609, 142, '2015-01-01 01:04:09.000000', 'temperatura', 1024.0000, 'ºC'),
	(291610, 142, '2015-01-01 01:04:10.000000', 'temperatura', 563.0000, 'ºC'),
	(291611, 142, '2015-01-01 01:04:11.000000', 'temperatura', 943.0000, 'ºC'),
	(291612, 142, '2015-01-01 01:04:12.000000', 'temperatura', 626.0000, 'ºC'),
	(291613, 142, '2015-01-01 01:04:13.000000', 'temperatura', 303.0000, 'ºC'),
	(291614, 142, '2015-01-01 01:04:14.000000', 'temperatura', 836.0000, 'ºC'),
	(291615, 142, '2015-01-01 01:04:15.000000', 'temperatura', 871.0000, 'ºC'),
	(291616, 142, '2015-01-01 01:04:16.000000', 'temperatura', 650.0000, 'ºC'),
	(291617, 142, '2015-01-01 01:04:17.000000', 'temperatura', 634.0000, 'ºC'),
	(291618, 142, '2015-01-01 01:04:18.000000', 'temperatura', 24.0000, 'ºC'),
	(291619, 142, '2015-01-01 01:04:19.000000', 'temperatura', 617.0000, 'ºC'),
	(291620, 142, '2015-01-01 01:04:20.000000', 'temperatura', 613.0000, 'ºC'),
	(291621, 142, '2015-01-01 01:04:21.000000', 'temperatura', 16.0000, 'ºC'),
	(291622, 142, '2015-01-01 01:04:22.000000', 'temperatura', 643.0000, 'ºC'),
	(291623, 142, '2015-01-01 01:04:23.000000', 'temperatura', 764.0000, 'ºC'),
	(291624, 142, '2015-01-01 01:04:24.000000', 'temperatura', 695.0000, 'ºC'),
	(291625, 142, '2015-01-01 01:04:25.000000', 'temperatura', 1182.0000, 'ºC'),
	(291626, 142, '2015-01-01 01:04:26.000000', 'temperatura', 224.0000, 'ºC'),
	(291627, 142, '2015-01-01 01:04:27.000000', 'temperatura', 1176.0000, 'ºC'),
	(291628, 142, '2015-01-01 01:04:28.000000', 'temperatura', 407.0000, 'ºC'),
	(291629, 142, '2015-01-01 01:04:29.000000', 'temperatura', 907.0000, 'ºC'),
	(291630, 142, '2015-01-01 01:04:30.000000', 'temperatura', 917.0000, 'ºC'),
	(291631, 142, '2015-01-01 01:04:31.000000', 'temperatura', 662.0000, 'ºC'),
	(291632, 142, '2015-01-01 01:04:32.000000', 'temperatura', 559.0000, 'ºC'),
	(291633, 142, '2015-01-01 01:04:33.000000', 'temperatura', 810.0000, 'ºC'),
	(291634, 142, '2015-01-01 01:04:34.000000', 'temperatura', 1173.0000, 'ºC'),
	(291635, 142, '2015-01-01 01:04:35.000000', 'temperatura', 1035.0000, 'ºC'),
	(291636, 142, '2015-01-01 01:04:36.000000', 'temperatura', 456.0000, 'ºC'),
	(291637, 142, '2015-01-01 01:04:37.000000', 'temperatura', 377.0000, 'ºC'),
	(291638, 142, '2015-01-01 01:04:38.000000', 'temperatura', 517.0000, 'ºC'),
	(291639, 142, '2015-01-01 01:04:39.000000', 'temperatura', 253.0000, 'ºC'),
	(291640, 142, '2015-01-01 01:04:40.000000', 'temperatura', 916.0000, 'ºC'),
	(291641, 142, '2015-01-01 01:04:41.000000', 'temperatura', 221.0000, 'ºC'),
	(291642, 142, '2015-01-01 01:04:42.000000', 'temperatura', 757.0000, 'ºC'),
	(291643, 142, '2015-01-01 01:04:43.000000', 'temperatura', 724.0000, 'ºC'),
	(291644, 142, '2015-01-01 01:04:44.000000', 'temperatura', 147.0000, 'ºC'),
	(291645, 142, '2015-01-01 01:04:45.000000', 'temperatura', 966.0000, 'ºC'),
	(291646, 142, '2015-01-01 01:04:46.000000', 'temperatura', 790.0000, 'ºC'),
	(291647, 142, '2015-01-01 01:04:47.000000', 'temperatura', 1051.0000, 'ºC'),
	(291648, 142, '2015-01-01 01:04:48.000000', 'temperatura', 484.0000, 'ºC'),
	(291649, 142, '2015-01-01 01:04:49.000000', 'temperatura', 469.0000, 'ºC'),
	(291650, 142, '2015-01-01 01:04:50.000000', 'temperatura', 894.0000, 'ºC'),
	(291651, 142, '2015-01-01 01:04:51.000000', 'temperatura', 665.0000, 'ºC'),
	(291652, 142, '2015-01-01 01:04:52.000000', 'temperatura', 642.0000, 'ºC'),
	(291653, 142, '2015-01-01 01:04:53.000000', 'temperatura', 17.0000, 'ºC'),
	(291654, 142, '2015-01-01 01:04:54.000000', 'temperatura', 561.0000, 'ºC'),
	(291655, 142, '2015-01-01 01:04:55.000000', 'temperatura', 351.0000, 'ºC'),
	(291656, 142, '2015-01-01 01:04:56.000000', 'temperatura', 74.0000, 'ºC'),
	(291657, 142, '2015-01-01 01:04:57.000000', 'temperatura', 519.0000, 'ºC'),
	(291658, 142, '2015-01-01 01:04:58.000000', 'temperatura', 1171.0000, 'ºC'),
	(291659, 142, '2015-01-01 01:04:59.000000', 'temperatura', 698.0000, 'ºC'),
	(291660, 142, '2015-01-01 01:05:00.000000', 'temperatura', 1177.0000, 'ºC'),
	(291661, 142, '2015-01-01 01:05:01.000000', 'temperatura', 191.0000, 'ºC'),
	(291662, 142, '2015-01-01 01:05:02.000000', 'temperatura', 1025.0000, 'ºC'),
	(291663, 142, '2015-01-01 01:05:03.000000', 'temperatura', 954.0000, 'ºC'),
	(291664, 142, '2015-01-01 01:05:04.000000', 'temperatura', 494.0000, 'ºC'),
	(291665, 142, '2015-01-01 01:05:05.000000', 'temperatura', 811.0000, 'ºC'),
	(291666, 142, '2015-01-01 01:05:06.000000', 'temperatura', 173.0000, 'ºC'),
	(291667, 142, '2015-01-01 01:05:07.000000', 'temperatura', 830.0000, 'ºC'),
	(291668, 142, '2015-01-01 01:05:08.000000', 'temperatura', 33.0000, 'ºC'),
	(291669, 142, '2015-01-01 01:05:09.000000', 'temperatura', 77.0000, 'ºC'),
	(291670, 142, '2015-01-01 01:05:10.000000', 'temperatura', 284.0000, 'ºC'),
	(291671, 142, '2015-01-01 01:05:11.000000', 'temperatura', 1190.0000, 'ºC'),
	(291672, 142, '2015-01-01 01:05:12.000000', 'temperatura', 300.0000, 'ºC'),
	(291673, 142, '2015-01-01 01:05:13.000000', 'temperatura', 329.0000, 'ºC'),
	(291674, 142, '2015-01-01 01:05:14.000000', 'temperatura', 745.0000, 'ºC'),
	(291675, 142, '2015-01-01 01:05:15.000000', 'temperatura', 337.0000, 'ºC'),
	(291676, 142, '2015-01-01 01:05:16.000000', 'temperatura', 652.0000, 'ºC'),
	(291677, 142, '2015-01-01 01:05:17.000000', 'temperatura', 1051.0000, 'ºC'),
	(291678, 142, '2015-01-01 01:05:18.000000', 'temperatura', 898.0000, 'ºC'),
	(291679, 142, '2015-01-01 01:05:19.000000', 'temperatura', 138.0000, 'ºC'),
	(291680, 142, '2015-01-01 01:05:20.000000', 'temperatura', 398.0000, 'ºC'),
	(291681, 142, '2015-01-01 01:05:21.000000', 'temperatura', 373.0000, 'ºC'),
	(291682, 142, '2015-01-01 01:05:22.000000', 'temperatura', 674.0000, 'ºC'),
	(291683, 142, '2015-01-01 01:05:23.000000', 'temperatura', 1052.0000, 'ºC'),
	(291684, 142, '2015-01-01 01:05:24.000000', 'temperatura', 838.0000, 'ºC'),
	(291685, 142, '2015-01-01 01:05:25.000000', 'temperatura', 1036.0000, 'ºC'),
	(291686, 142, '2015-01-01 01:05:26.000000', 'temperatura', 267.0000, 'ºC'),
	(291687, 142, '2015-01-01 01:05:27.000000', 'temperatura', 625.0000, 'ºC'),
	(291688, 142, '2015-01-01 01:05:28.000000', 'temperatura', 1123.0000, 'ºC'),
	(291689, 142, '2015-01-01 01:05:29.000000', 'temperatura', 144.0000, 'ºC'),
	(291690, 142, '2015-01-01 01:05:30.000000', 'temperatura', 950.0000, 'ºC'),
	(291691, 142, '2015-01-01 01:05:31.000000', 'temperatura', 720.0000, 'ºC'),
	(291692, 142, '2015-01-01 01:05:32.000000', 'temperatura', 750.0000, 'ºC'),
	(291693, 142, '2015-01-01 01:05:33.000000', 'temperatura', 391.0000, 'ºC'),
	(291694, 142, '2015-01-01 01:05:34.000000', 'temperatura', 904.0000, 'ºC'),
	(291695, 142, '2015-01-01 01:05:35.000000', 'temperatura', 948.0000, 'ºC'),
	(291696, 142, '2015-01-01 01:05:36.000000', 'temperatura', 828.0000, 'ºC'),
	(291697, 142, '2015-01-01 01:05:37.000000', 'temperatura', 98.0000, 'ºC'),
	(291698, 142, '2015-01-01 01:05:38.000000', 'temperatura', 407.0000, 'ºC'),
	(291699, 142, '2015-01-01 01:05:39.000000', 'temperatura', 543.0000, 'ºC'),
	(291700, 142, '2015-01-01 01:05:40.000000', 'temperatura', 291.0000, 'ºC'),
	(291701, 142, '2015-01-01 01:05:41.000000', 'temperatura', 1029.0000, 'ºC'),
	(291702, 142, '2015-01-01 01:05:42.000000', 'temperatura', 671.0000, 'ºC'),
	(291703, 142, '2015-01-01 01:05:43.000000', 'temperatura', 271.0000, 'ºC'),
	(291704, 142, '2015-01-01 01:05:44.000000', 'temperatura', 541.0000, 'ºC'),
	(291705, 142, '2015-01-01 01:05:45.000000', 'temperatura', 691.0000, 'ºC'),
	(291706, 142, '2015-01-01 01:05:46.000000', 'temperatura', 635.0000, 'ºC'),
	(291707, 142, '2015-01-01 01:05:47.000000', 'temperatura', 1100.0000, 'ºC'),
	(291708, 142, '2015-01-01 01:05:48.000000', 'temperatura', 1197.0000, 'ºC'),
	(291709, 142, '2015-01-01 01:05:49.000000', 'temperatura', 286.0000, 'ºC'),
	(291710, 142, '2015-01-01 01:05:50.000000', 'temperatura', 240.0000, 'ºC'),
	(291711, 142, '2015-01-01 01:05:51.000000', 'temperatura', 342.0000, 'ºC'),
	(291712, 142, '2015-01-01 01:05:52.000000', 'temperatura', 989.0000, 'ºC'),
	(291713, 142, '2015-01-01 01:05:53.000000', 'temperatura', 320.0000, 'ºC'),
	(291714, 142, '2015-01-01 01:05:54.000000', 'temperatura', 1035.0000, 'ºC'),
	(291715, 142, '2015-01-01 01:05:55.000000', 'temperatura', 614.0000, 'ºC'),
	(291716, 142, '2015-01-01 01:05:56.000000', 'temperatura', 1168.0000, 'ºC'),
	(291717, 142, '2015-01-01 01:05:57.000000', 'temperatura', 396.0000, 'ºC'),
	(291718, 142, '2015-01-01 01:05:58.000000', 'temperatura', 876.0000, 'ºC'),
	(291719, 142, '2015-01-01 01:05:59.000000', 'temperatura', 794.0000, 'ºC'),
	(291720, 142, '2015-01-01 01:06:00.000000', 'temperatura', 143.0000, 'ºC'),
	(291721, 142, '2015-01-01 01:06:01.000000', 'temperatura', 735.0000, 'ºC'),
	(291722, 142, '2015-01-01 01:06:02.000000', 'temperatura', 844.0000, 'ºC'),
	(291723, 142, '2015-01-01 01:06:03.000000', 'temperatura', 815.0000, 'ºC'),
	(291724, 142, '2015-01-01 01:06:04.000000', 'temperatura', 346.0000, 'ºC'),
	(291725, 142, '2015-01-01 01:06:05.000000', 'temperatura', 485.0000, 'ºC'),
	(291726, 142, '2015-01-01 01:06:06.000000', 'temperatura', 186.0000, 'ºC'),
	(291727, 142, '2015-01-01 01:06:07.000000', 'temperatura', 678.0000, 'ºC'),
	(291728, 142, '2015-01-01 01:06:08.000000', 'temperatura', 429.0000, 'ºC'),
	(291729, 142, '2015-01-01 01:06:09.000000', 'temperatura', 114.0000, 'ºC'),
	(291730, 142, '2015-01-01 01:06:10.000000', 'temperatura', 484.0000, 'ºC'),
	(291731, 142, '2015-01-01 01:06:11.000000', 'temperatura', 877.0000, 'ºC'),
	(291732, 142, '2015-01-01 01:06:12.000000', 'temperatura', 536.0000, 'ºC'),
	(291733, 142, '2015-01-01 01:06:13.000000', 'temperatura', 48.0000, 'ºC'),
	(291734, 142, '2015-01-01 01:06:14.000000', 'temperatura', 1034.0000, 'ºC'),
	(291735, 142, '2015-01-01 01:06:15.000000', 'temperatura', 227.0000, 'ºC'),
	(291736, 142, '2015-01-01 01:06:16.000000', 'temperatura', 434.0000, 'ºC'),
	(291737, 142, '2015-01-01 01:06:17.000000', 'temperatura', 289.0000, 'ºC'),
	(291738, 142, '2015-01-01 01:06:18.000000', 'temperatura', 145.0000, 'ºC'),
	(291739, 142, '2015-01-01 01:06:19.000000', 'temperatura', 1055.0000, 'ºC'),
	(291740, 142, '2015-01-01 01:06:20.000000', 'temperatura', 42.0000, 'ºC'),
	(291741, 142, '2015-01-01 01:06:21.000000', 'temperatura', 646.0000, 'ºC'),
	(291742, 142, '2015-01-01 01:06:22.000000', 'temperatura', 706.0000, 'ºC'),
	(291743, 142, '2015-01-01 01:06:23.000000', 'temperatura', 391.0000, 'ºC'),
	(291744, 142, '2015-01-01 01:06:24.000000', 'temperatura', 1036.0000, 'ºC'),
	(291745, 142, '2015-01-01 01:06:25.000000', 'temperatura', 410.0000, 'ºC'),
	(291746, 142, '2015-01-01 01:06:26.000000', 'temperatura', 141.0000, 'ºC'),
	(291747, 142, '2015-01-01 01:06:27.000000', 'temperatura', 677.0000, 'ºC'),
	(291748, 142, '2015-01-01 01:06:28.000000', 'temperatura', 560.0000, 'ºC'),
	(291749, 142, '2015-01-01 01:06:29.000000', 'temperatura', 770.0000, 'ºC'),
	(291750, 142, '2015-01-01 01:06:30.000000', 'temperatura', 972.0000, 'ºC'),
	(291751, 142, '2015-01-01 01:06:31.000000', 'temperatura', 148.0000, 'ºC'),
	(291752, 142, '2015-01-01 01:06:32.000000', 'temperatura', 226.0000, 'ºC'),
	(291753, 142, '2015-01-01 01:06:33.000000', 'temperatura', 687.0000, 'ºC'),
	(291754, 142, '2015-01-01 01:06:34.000000', 'temperatura', 355.0000, 'ºC'),
	(291755, 142, '2015-01-01 01:06:35.000000', 'temperatura', 918.0000, 'ºC'),
	(291756, 142, '2015-01-01 01:06:36.000000', 'temperatura', 1122.0000, 'ºC'),
	(291757, 142, '2015-01-01 01:06:37.000000', 'temperatura', 458.0000, 'ºC'),
	(291758, 142, '2015-01-01 01:06:38.000000', 'temperatura', 125.0000, 'ºC'),
	(291759, 142, '2015-01-01 01:06:39.000000', 'temperatura', 450.0000, 'ºC'),
	(291760, 142, '2015-01-01 01:06:40.000000', 'temperatura', 677.0000, 'ºC'),
	(291761, 142, '2015-01-01 01:06:41.000000', 'temperatura', 833.0000, 'ºC'),
	(291762, 142, '2015-01-01 01:06:42.000000', 'temperatura', 936.0000, 'ºC'),
	(291763, 142, '2015-01-01 01:06:43.000000', 'temperatura', 982.0000, 'ºC'),
	(291764, 142, '2015-01-01 01:06:44.000000', 'temperatura', 903.0000, 'ºC'),
	(291765, 142, '2015-01-01 01:06:45.000000', 'temperatura', 369.0000, 'ºC'),
	(291766, 142, '2015-01-01 01:06:46.000000', 'temperatura', 338.0000, 'ºC'),
	(291767, 142, '2015-01-01 01:06:47.000000', 'temperatura', 583.0000, 'ºC'),
	(291768, 142, '2015-01-01 01:06:48.000000', 'temperatura', 702.0000, 'ºC'),
	(291769, 142, '2015-01-01 01:06:49.000000', 'temperatura', 561.0000, 'ºC'),
	(291770, 142, '2015-01-01 01:06:50.000000', 'temperatura', 698.0000, 'ºC'),
	(291771, 142, '2015-01-01 01:06:51.000000', 'temperatura', 611.0000, 'ºC'),
	(291772, 142, '2015-01-01 01:06:52.000000', 'temperatura', 958.0000, 'ºC'),
	(291773, 142, '2015-01-01 01:06:53.000000', 'temperatura', 558.0000, 'ºC'),
	(291774, 142, '2015-01-01 01:06:54.000000', 'temperatura', 1116.0000, 'ºC'),
	(291775, 142, '2015-01-01 01:06:55.000000', 'temperatura', 307.0000, 'ºC'),
	(291776, 142, '2015-01-01 01:06:56.000000', 'temperatura', 587.0000, 'ºC'),
	(291777, 142, '2015-01-01 01:06:57.000000', 'temperatura', 814.0000, 'ºC'),
	(291778, 142, '2015-01-01 01:06:58.000000', 'temperatura', 1110.0000, 'ºC'),
	(291779, 142, '2015-01-01 01:06:59.000000', 'temperatura', 711.0000, 'ºC'),
	(291780, 142, '2015-01-01 01:07:00.000000', 'temperatura', 222.0000, 'ºC'),
	(291781, 142, '2015-01-01 01:07:01.000000', 'temperatura', 179.0000, 'ºC'),
	(291782, 142, '2015-01-01 01:07:02.000000', 'temperatura', 228.0000, 'ºC'),
	(291783, 142, '2015-01-01 01:07:03.000000', 'temperatura', 604.0000, 'ºC'),
	(291784, 142, '2015-01-01 01:07:04.000000', 'temperatura', 1137.0000, 'ºC'),
	(291785, 142, '2015-01-01 01:07:05.000000', 'temperatura', 274.0000, 'ºC'),
	(291786, 142, '2015-01-01 01:07:06.000000', 'temperatura', 361.0000, 'ºC'),
	(291787, 142, '2015-01-01 01:07:07.000000', 'temperatura', 983.0000, 'ºC'),
	(291788, 142, '2015-01-01 01:07:08.000000', 'temperatura', 232.0000, 'ºC'),
	(291789, 142, '2015-01-01 01:07:09.000000', 'temperatura', 612.0000, 'ºC'),
	(291790, 142, '2015-01-01 01:07:10.000000', 'temperatura', 1163.0000, 'ºC'),
	(291791, 142, '2015-01-01 01:07:11.000000', 'temperatura', 380.0000, 'ºC'),
	(291792, 142, '2015-01-01 01:07:12.000000', 'temperatura', 810.0000, 'ºC'),
	(291793, 142, '2015-01-01 01:07:13.000000', 'temperatura', 510.0000, 'ºC'),
	(291794, 142, '2015-01-01 01:07:14.000000', 'temperatura', 121.0000, 'ºC'),
	(291795, 142, '2015-01-01 01:07:15.000000', 'temperatura', 275.0000, 'ºC'),
	(291796, 142, '2015-01-01 01:07:16.000000', 'temperatura', 1012.0000, 'ºC'),
	(291797, 142, '2015-01-01 01:07:17.000000', 'temperatura', 637.0000, 'ºC'),
	(291798, 142, '2015-01-01 01:07:18.000000', 'temperatura', 148.0000, 'ºC'),
	(291799, 142, '2015-01-01 01:07:19.000000', 'temperatura', 29.0000, 'ºC'),
	(291800, 142, '2015-01-01 01:07:20.000000', 'temperatura', 901.0000, 'ºC'),
	(291801, 142, '2015-01-01 01:07:21.000000', 'temperatura', 818.0000, 'ºC'),
	(291802, 142, '2015-01-01 01:07:22.000000', 'temperatura', 189.0000, 'ºC'),
	(291803, 142, '2015-01-01 01:07:23.000000', 'temperatura', 893.0000, 'ºC'),
	(291804, 142, '2015-01-01 01:07:24.000000', 'temperatura', 296.0000, 'ºC'),
	(291805, 142, '2015-01-01 01:07:25.000000', 'temperatura', 1.0000, 'ºC'),
	(291806, 142, '2015-01-01 01:07:26.000000', 'temperatura', 320.0000, 'ºC'),
	(291807, 142, '2015-01-01 01:07:27.000000', 'temperatura', 397.0000, 'ºC'),
	(291808, 142, '2015-01-01 01:07:28.000000', 'temperatura', 1027.0000, 'ºC'),
	(291809, 142, '2015-01-01 01:07:29.000000', 'temperatura', 344.0000, 'ºC'),
	(291810, 142, '2015-01-01 01:07:30.000000', 'temperatura', 1039.0000, 'ºC'),
	(291811, 142, '2015-01-01 01:07:31.000000', 'temperatura', 563.0000, 'ºC'),
	(291812, 142, '2015-01-01 01:07:32.000000', 'temperatura', 897.0000, 'ºC'),
	(291813, 142, '2015-01-01 01:07:33.000000', 'temperatura', 400.0000, 'ºC'),
	(291814, 142, '2015-01-01 01:07:34.000000', 'temperatura', 506.0000, 'ºC'),
	(291815, 142, '2015-01-01 01:07:35.000000', 'temperatura', 131.0000, 'ºC'),
	(291816, 142, '2015-01-01 01:07:36.000000', 'temperatura', 339.0000, 'ºC'),
	(291817, 142, '2015-01-01 01:07:37.000000', 'temperatura', 104.0000, 'ºC'),
	(291818, 142, '2015-01-01 01:07:38.000000', 'temperatura', 701.0000, 'ºC'),
	(291819, 142, '2015-01-01 01:07:39.000000', 'temperatura', 792.0000, 'ºC'),
	(291820, 142, '2015-01-01 01:07:40.000000', 'temperatura', 660.0000, 'ºC'),
	(291821, 142, '2015-01-01 01:07:41.000000', 'temperatura', 922.0000, 'ºC'),
	(291822, 142, '2015-01-01 01:07:42.000000', 'temperatura', 234.0000, 'ºC'),
	(291823, 142, '2015-01-01 01:07:43.000000', 'temperatura', 802.0000, 'ºC'),
	(291824, 142, '2015-01-01 01:07:44.000000', 'temperatura', 908.0000, 'ºC'),
	(291825, 142, '2015-01-01 01:07:45.000000', 'temperatura', 936.0000, 'ºC'),
	(291826, 142, '2015-01-01 01:07:46.000000', 'temperatura', 756.0000, 'ºC'),
	(291827, 142, '2015-01-01 01:07:47.000000', 'temperatura', 974.0000, 'ºC'),
	(291828, 142, '2015-01-01 01:07:48.000000', 'temperatura', 202.0000, 'ºC'),
	(291829, 142, '2015-01-01 01:07:49.000000', 'temperatura', 488.0000, 'ºC'),
	(291830, 142, '2015-01-01 01:07:50.000000', 'temperatura', 635.0000, 'ºC'),
	(291831, 142, '2015-01-01 01:07:51.000000', 'temperatura', 512.0000, 'ºC'),
	(291832, 142, '2015-01-01 01:07:52.000000', 'temperatura', 656.0000, 'ºC'),
	(291833, 142, '2015-01-01 01:07:53.000000', 'temperatura', 545.0000, 'ºC'),
	(291834, 142, '2015-01-01 01:07:54.000000', 'temperatura', 755.0000, 'ºC'),
	(291835, 142, '2015-01-01 01:07:55.000000', 'temperatura', 941.0000, 'ºC'),
	(291836, 142, '2015-01-01 01:07:56.000000', 'temperatura', 40.0000, 'ºC'),
	(291837, 142, '2015-01-01 01:07:57.000000', 'temperatura', 980.0000, 'ºC'),
	(291838, 142, '2015-01-01 01:07:58.000000', 'temperatura', 1179.0000, 'ºC'),
	(291839, 142, '2015-01-01 01:07:59.000000', 'temperatura', 557.0000, 'ºC'),
	(291840, 142, '2015-01-01 01:08:00.000000', 'temperatura', 447.0000, 'ºC'),
	(291841, 142, '2015-01-01 01:08:01.000000', 'temperatura', 566.0000, 'ºC'),
	(291842, 142, '2015-01-01 01:08:02.000000', 'temperatura', 287.0000, 'ºC'),
	(291843, 142, '2015-01-01 01:08:03.000000', 'temperatura', 937.0000, 'ºC'),
	(291844, 142, '2015-01-01 01:08:04.000000', 'temperatura', 226.0000, 'ºC'),
	(291845, 142, '2015-01-01 01:08:05.000000', 'temperatura', 719.0000, 'ºC'),
	(291846, 142, '2015-01-01 01:08:06.000000', 'temperatura', 519.0000, 'ºC'),
	(291847, 142, '2015-01-01 01:08:07.000000', 'temperatura', 436.0000, 'ºC'),
	(291848, 142, '2015-01-01 01:08:08.000000', 'temperatura', 625.0000, 'ºC'),
	(291849, 142, '2015-01-01 01:08:09.000000', 'temperatura', 618.0000, 'ºC'),
	(291850, 142, '2015-01-01 01:08:10.000000', 'temperatura', 15.0000, 'ºC'),
	(291851, 142, '2015-01-01 01:08:11.000000', 'temperatura', 621.0000, 'ºC'),
	(291852, 142, '2015-01-01 01:08:12.000000', 'temperatura', 660.0000, 'ºC'),
	(291853, 142, '2015-01-01 01:08:13.000000', 'temperatura', 239.0000, 'ºC'),
	(291854, 142, '2015-01-01 01:08:14.000000', 'temperatura', 415.0000, 'ºC'),
	(291855, 142, '2015-01-01 01:08:15.000000', 'temperatura', 158.0000, 'ºC'),
	(291856, 142, '2015-01-01 01:08:16.000000', 'temperatura', 747.0000, 'ºC'),
	(291857, 142, '2015-01-01 01:08:17.000000', 'temperatura', 862.0000, 'ºC'),
	(291858, 142, '2015-01-01 01:08:18.000000', 'temperatura', 867.0000, 'ºC'),
	(291859, 142, '2015-01-01 01:08:19.000000', 'temperatura', 550.0000, 'ºC'),
	(291860, 142, '2015-01-01 01:08:20.000000', 'temperatura', 149.0000, 'ºC'),
	(291861, 142, '2015-01-01 01:08:21.000000', 'temperatura', 294.0000, 'ºC'),
	(291862, 142, '2015-01-01 01:08:22.000000', 'temperatura', 1027.0000, 'ºC'),
	(291863, 142, '2015-01-01 01:08:23.000000', 'temperatura', 651.0000, 'ºC'),
	(291864, 142, '2015-01-01 01:08:24.000000', 'temperatura', 176.0000, 'ºC'),
	(291865, 142, '2015-01-01 01:08:25.000000', 'temperatura', 128.0000, 'ºC'),
	(291866, 142, '2015-01-01 01:08:26.000000', 'temperatura', 111.0000, 'ºC'),
	(291867, 142, '2015-01-01 01:08:27.000000', 'temperatura', 170.0000, 'ºC'),
	(291868, 142, '2015-01-01 01:08:28.000000', 'temperatura', 521.0000, 'ºC'),
	(291869, 142, '2015-01-01 01:08:29.000000', 'temperatura', 893.0000, 'ºC'),
	(291870, 142, '2015-01-01 01:08:30.000000', 'temperatura', 505.0000, 'ºC'),
	(291871, 142, '2015-01-01 01:08:31.000000', 'temperatura', 1045.0000, 'ºC'),
	(291872, 142, '2015-01-01 01:08:32.000000', 'temperatura', 112.0000, 'ºC'),
	(291873, 142, '2015-01-01 01:08:33.000000', 'temperatura', 1023.0000, 'ºC'),
	(291874, 142, '2015-01-01 01:08:34.000000', 'temperatura', 1179.0000, 'ºC'),
	(291875, 142, '2015-01-01 01:08:35.000000', 'temperatura', 427.0000, 'ºC'),
	(291876, 142, '2015-01-01 01:08:36.000000', 'temperatura', 1000.0000, 'ºC'),
	(291877, 142, '2015-01-01 01:08:37.000000', 'temperatura', 118.0000, 'ºC'),
	(291878, 142, '2015-01-01 01:08:38.000000', 'temperatura', 1193.0000, 'ºC'),
	(291879, 142, '2015-01-01 01:08:39.000000', 'temperatura', 809.0000, 'ºC'),
	(291880, 142, '2015-01-01 01:08:40.000000', 'temperatura', 467.0000, 'ºC'),
	(291881, 142, '2015-01-01 01:08:41.000000', 'temperatura', 1110.0000, 'ºC'),
	(291882, 142, '2015-01-01 01:08:42.000000', 'temperatura', 548.0000, 'ºC'),
	(291883, 142, '2015-01-01 01:08:43.000000', 'temperatura', 610.0000, 'ºC'),
	(291884, 142, '2015-01-01 01:08:44.000000', 'temperatura', 207.0000, 'ºC'),
	(291885, 142, '2015-01-01 01:08:45.000000', 'temperatura', 407.0000, 'ºC'),
	(291886, 142, '2015-01-01 01:08:46.000000', 'temperatura', 213.0000, 'ºC'),
	(291887, 142, '2015-01-01 01:08:47.000000', 'temperatura', 1046.0000, 'ºC'),
	(291888, 142, '2015-01-01 01:08:48.000000', 'temperatura', 992.0000, 'ºC'),
	(291889, 142, '2015-01-01 01:08:49.000000', 'temperatura', 621.0000, 'ºC'),
	(291890, 142, '2015-01-01 01:08:50.000000', 'temperatura', 130.0000, 'ºC'),
	(291891, 142, '2015-01-01 01:08:51.000000', 'temperatura', 1186.0000, 'ºC'),
	(291892, 142, '2015-01-01 01:08:52.000000', 'temperatura', 740.0000, 'ºC'),
	(291893, 142, '2015-01-01 01:08:53.000000', 'temperatura', 146.0000, 'ºC'),
	(291894, 142, '2015-01-01 01:08:54.000000', 'temperatura', 907.0000, 'ºC'),
	(291895, 142, '2015-01-01 01:08:55.000000', 'temperatura', 497.0000, 'ºC'),
	(291896, 142, '2015-01-01 01:08:56.000000', 'temperatura', 967.0000, 'ºC'),
	(291897, 142, '2015-01-01 01:08:57.000000', 'temperatura', 942.0000, 'ºC'),
	(291898, 142, '2015-01-01 01:08:58.000000', 'temperatura', 611.0000, 'ºC'),
	(291899, 142, '2015-01-01 01:08:59.000000', 'temperatura', 229.0000, 'ºC'),
	(291900, 142, '2015-01-01 01:09:00.000000', 'temperatura', 513.0000, 'ºC'),
	(291901, 142, '2015-01-01 01:09:01.000000', 'temperatura', 680.0000, 'ºC'),
	(291902, 142, '2015-01-01 01:09:02.000000', 'temperatura', 662.0000, 'ºC'),
	(291903, 142, '2015-01-01 01:09:03.000000', 'temperatura', 70.0000, 'ºC'),
	(291904, 142, '2015-01-01 01:09:04.000000', 'temperatura', 762.0000, 'ºC'),
	(291905, 142, '2015-01-01 01:09:05.000000', 'temperatura', 3.0000, 'ºC'),
	(291906, 142, '2015-01-01 01:09:06.000000', 'temperatura', 128.0000, 'ºC'),
	(291907, 142, '2015-01-01 01:09:07.000000', 'temperatura', 634.0000, 'ºC'),
	(291908, 142, '2015-01-01 01:09:08.000000', 'temperatura', 386.0000, 'ºC'),
	(291909, 142, '2015-01-01 01:09:09.000000', 'temperatura', 26.0000, 'ºC'),
	(291910, 142, '2015-01-01 01:09:10.000000', 'temperatura', 176.0000, 'ºC'),
	(291911, 142, '2015-01-01 01:09:11.000000', 'temperatura', 799.0000, 'ºC'),
	(291912, 142, '2015-01-01 01:09:12.000000', 'temperatura', 1068.0000, 'ºC'),
	(291913, 142, '2015-01-01 01:09:13.000000', 'temperatura', 546.0000, 'ºC'),
	(291914, 142, '2015-01-01 01:09:14.000000', 'temperatura', 725.0000, 'ºC'),
	(291915, 142, '2015-01-01 01:09:15.000000', 'temperatura', 787.0000, 'ºC'),
	(291916, 142, '2015-01-01 01:09:16.000000', 'temperatura', 560.0000, 'ºC'),
	(291917, 142, '2015-01-01 01:09:17.000000', 'temperatura', 439.0000, 'ºC'),
	(291918, 142, '2015-01-01 01:09:18.000000', 'temperatura', 517.0000, 'ºC'),
	(291919, 142, '2015-01-01 01:09:19.000000', 'temperatura', 68.0000, 'ºC'),
	(291920, 142, '2015-01-01 01:09:20.000000', 'temperatura', 1190.0000, 'ºC'),
	(291921, 142, '2015-01-01 01:09:21.000000', 'temperatura', 946.0000, 'ºC'),
	(291922, 142, '2015-01-01 01:09:22.000000', 'temperatura', 1160.0000, 'ºC'),
	(291923, 142, '2015-01-01 01:09:23.000000', 'temperatura', 564.0000, 'ºC'),
	(291924, 142, '2015-01-01 01:09:24.000000', 'temperatura', 539.0000, 'ºC'),
	(291925, 142, '2015-01-01 01:09:25.000000', 'temperatura', 1002.0000, 'ºC'),
	(291926, 142, '2015-01-01 01:09:26.000000', 'temperatura', 996.0000, 'ºC'),
	(291927, 142, '2015-01-01 01:09:27.000000', 'temperatura', 774.0000, 'ºC'),
	(291928, 142, '2015-01-01 01:09:28.000000', 'temperatura', 882.0000, 'ºC'),
	(291929, 142, '2015-01-01 01:09:29.000000', 'temperatura', 889.0000, 'ºC'),
	(291930, 142, '2015-01-01 01:09:30.000000', 'temperatura', 599.0000, 'ºC'),
	(291931, 142, '2015-01-01 01:09:31.000000', 'temperatura', 329.0000, 'ºC'),
	(291932, 142, '2015-01-01 01:09:32.000000', 'temperatura', 1047.0000, 'ºC'),
	(291933, 142, '2015-01-01 01:09:33.000000', 'temperatura', 648.0000, 'ºC'),
	(291934, 142, '2015-01-01 01:09:34.000000', 'temperatura', 99.0000, 'ºC'),
	(291935, 142, '2015-01-01 01:09:35.000000', 'temperatura', 954.0000, 'ºC'),
	(291936, 142, '2015-01-01 01:09:36.000000', 'temperatura', 875.0000, 'ºC'),
	(291937, 142, '2015-01-01 01:09:37.000000', 'temperatura', 310.0000, 'ºC'),
	(291938, 142, '2015-01-01 01:09:38.000000', 'temperatura', 126.0000, 'ºC'),
	(291939, 142, '2015-01-01 01:09:39.000000', 'temperatura', 900.0000, 'ºC'),
	(291940, 142, '2015-01-01 01:09:40.000000', 'temperatura', 524.0000, 'ºC'),
	(291941, 142, '2015-01-01 01:09:41.000000', 'temperatura', 1118.0000, 'ºC'),
	(291942, 142, '2015-01-01 01:09:42.000000', 'temperatura', 419.0000, 'ºC'),
	(291943, 142, '2015-01-01 01:09:43.000000', 'temperatura', 1143.0000, 'ºC'),
	(291944, 142, '2015-01-01 01:09:44.000000', 'temperatura', 859.0000, 'ºC'),
	(291945, 142, '2015-01-01 01:09:45.000000', 'temperatura', 864.0000, 'ºC'),
	(291946, 142, '2015-01-01 01:09:46.000000', 'temperatura', 543.0000, 'ºC'),
	(291947, 142, '2015-01-01 01:09:47.000000', 'temperatura', 127.0000, 'ºC'),
	(291948, 142, '2015-01-01 01:09:48.000000', 'temperatura', 203.0000, 'ºC'),
	(291949, 142, '2015-01-01 01:09:49.000000', 'temperatura', 635.0000, 'ºC'),
	(291950, 142, '2015-01-01 01:09:50.000000', 'temperatura', 167.0000, 'ºC'),
	(291951, 142, '2015-01-01 01:09:51.000000', 'temperatura', 129.0000, 'ºC'),
	(291952, 142, '2015-01-01 01:09:52.000000', 'temperatura', 144.0000, 'ºC'),
	(291953, 142, '2015-01-01 01:09:53.000000', 'temperatura', 337.0000, 'ºC'),
	(291954, 142, '2015-01-01 01:09:54.000000', 'temperatura', 50.0000, 'ºC'),
	(291955, 142, '2015-01-01 01:09:55.000000', 'temperatura', 441.0000, 'ºC'),
	(291956, 142, '2015-01-01 01:09:56.000000', 'temperatura', 856.0000, 'ºC'),
	(291957, 142, '2015-01-01 01:09:57.000000', 'temperatura', 558.0000, 'ºC'),
	(291958, 142, '2015-01-01 01:09:58.000000', 'temperatura', 223.0000, 'ºC'),
	(291959, 142, '2015-01-01 01:09:59.000000', 'temperatura', 639.0000, 'ºC'),
	(291960, 142, '2015-01-01 01:10:00.000000', 'temperatura', 128.0000, 'ºC'),
	(291961, 142, '2015-01-01 01:10:01.000000', 'temperatura', 1123.0000, 'ºC'),
	(291962, 142, '2015-01-01 01:10:02.000000', 'temperatura', 433.0000, 'ºC'),
	(291963, 142, '2015-01-01 01:10:03.000000', 'temperatura', 1197.0000, 'ºC'),
	(291964, 142, '2015-01-01 01:10:04.000000', 'temperatura', 1086.0000, 'ºC'),
	(291965, 142, '2015-01-01 01:10:05.000000', 'temperatura', 640.0000, 'ºC'),
	(291966, 142, '2015-01-01 01:10:06.000000', 'temperatura', 1141.0000, 'ºC'),
	(291967, 142, '2015-01-01 01:10:07.000000', 'temperatura', 186.0000, 'ºC'),
	(291968, 142, '2015-01-01 01:10:08.000000', 'temperatura', 1106.0000, 'ºC'),
	(291969, 142, '2015-01-01 01:10:09.000000', 'temperatura', 172.0000, 'ºC'),
	(291970, 142, '2015-01-01 01:10:10.000000', 'temperatura', 1145.0000, 'ºC'),
	(291971, 142, '2015-01-01 01:10:11.000000', 'temperatura', 408.0000, 'ºC'),
	(291972, 142, '2015-01-01 01:10:12.000000', 'temperatura', 1004.0000, 'ºC'),
	(291973, 142, '2015-01-01 01:10:13.000000', 'temperatura', 197.0000, 'ºC'),
	(291974, 142, '2015-01-01 01:10:14.000000', 'temperatura', 373.0000, 'ºC'),
	(291975, 142, '2015-01-01 01:10:15.000000', 'temperatura', 76.0000, 'ºC'),
	(291976, 142, '2015-01-01 01:10:16.000000', 'temperatura', 462.0000, 'ºC'),
	(291977, 142, '2015-01-01 01:10:17.000000', 'temperatura', 884.0000, 'ºC'),
	(291978, 142, '2015-01-01 01:10:18.000000', 'temperatura', 631.0000, 'ºC'),
	(291979, 142, '2015-01-01 01:10:19.000000', 'temperatura', 506.0000, 'ºC'),
	(291980, 142, '2015-01-01 01:10:20.000000', 'temperatura', 638.0000, 'ºC'),
	(291981, 142, '2015-01-01 01:10:21.000000', 'temperatura', 472.0000, 'ºC'),
	(291982, 142, '2015-01-01 01:10:22.000000', 'temperatura', 444.0000, 'ºC'),
	(291983, 142, '2015-01-01 01:10:23.000000', 'temperatura', 807.0000, 'ºC'),
	(291984, 142, '2015-01-01 01:10:24.000000', 'temperatura', 303.0000, 'ºC'),
	(291985, 142, '2015-01-01 01:10:25.000000', 'temperatura', 294.0000, 'ºC'),
	(291986, 142, '2015-01-01 01:10:26.000000', 'temperatura', 563.0000, 'ºC'),
	(291987, 142, '2015-01-01 01:10:27.000000', 'temperatura', 735.0000, 'ºC'),
	(291988, 142, '2015-01-01 01:10:28.000000', 'temperatura', 784.0000, 'ºC'),
	(291989, 142, '2015-01-01 01:10:29.000000', 'temperatura', 514.0000, 'ºC'),
	(291990, 142, '2015-01-01 01:10:30.000000', 'temperatura', 222.0000, 'ºC'),
	(291991, 142, '2015-01-01 01:10:31.000000', 'temperatura', 767.0000, 'ºC'),
	(291992, 142, '2015-01-01 01:10:32.000000', 'temperatura', 768.0000, 'ºC'),
	(291993, 142, '2015-01-01 01:10:33.000000', 'temperatura', 342.0000, 'ºC'),
	(291994, 142, '2015-01-01 01:10:34.000000', 'temperatura', 605.0000, 'ºC'),
	(291995, 142, '2015-01-01 01:10:35.000000', 'temperatura', 800.0000, 'ºC'),
	(291996, 142, '2015-01-01 01:10:36.000000', 'temperatura', 985.0000, 'ºC'),
	(291997, 142, '2015-01-01 01:10:37.000000', 'temperatura', 124.0000, 'ºC'),
	(291998, 142, '2015-01-01 01:10:38.000000', 'temperatura', 66.0000, 'ºC'),
	(291999, 142, '2015-01-01 01:10:39.000000', 'temperatura', 1158.0000, 'ºC'),
	(292000, 142, '2015-01-01 01:10:40.000000', 'temperatura', 792.0000, 'ºC'),
	(292001, 142, '2015-01-01 01:10:41.000000', 'temperatura', 486.0000, 'ºC'),
	(292002, 142, '2015-01-01 01:10:42.000000', 'temperatura', 56.0000, 'ºC'),
	(292003, 142, '2015-01-01 01:10:43.000000', 'temperatura', 22.0000, 'ºC'),
	(292004, 142, '2015-01-01 01:10:44.000000', 'temperatura', 1141.0000, 'ºC'),
	(292005, 142, '2015-01-01 01:10:45.000000', 'temperatura', 839.0000, 'ºC'),
	(292006, 142, '2015-01-01 01:10:46.000000', 'temperatura', 774.0000, 'ºC'),
	(292007, 142, '2015-01-01 01:10:47.000000', 'temperatura', 151.0000, 'ºC'),
	(292008, 142, '2015-01-01 01:10:48.000000', 'temperatura', 836.0000, 'ºC'),
	(292009, 142, '2015-01-01 01:10:49.000000', 'temperatura', 128.0000, 'ºC'),
	(292010, 142, '2015-01-01 01:10:50.000000', 'temperatura', 531.0000, 'ºC'),
	(292011, 142, '2015-01-01 01:10:51.000000', 'temperatura', 1073.0000, 'ºC'),
	(292012, 142, '2015-01-01 01:10:52.000000', 'temperatura', 170.0000, 'ºC'),
	(292013, 142, '2015-01-01 01:10:53.000000', 'temperatura', 33.0000, 'ºC'),
	(292014, 142, '2015-01-01 01:10:54.000000', 'temperatura', 857.0000, 'ºC'),
	(292015, 142, '2015-01-01 01:10:55.000000', 'temperatura', 584.0000, 'ºC'),
	(292016, 142, '2015-01-01 01:10:56.000000', 'temperatura', 351.0000, 'ºC'),
	(292017, 142, '2015-01-01 01:10:57.000000', 'temperatura', 5.0000, 'ºC'),
	(292018, 142, '2015-01-01 01:10:58.000000', 'temperatura', 172.0000, 'ºC'),
	(292019, 142, '2015-01-01 01:10:59.000000', 'temperatura', 844.0000, 'ºC'),
	(292020, 142, '2015-01-01 01:11:00.000000', 'temperatura', 106.0000, 'ºC'),
	(292021, 142, '2015-01-01 01:11:01.000000', 'temperatura', 398.0000, 'ºC'),
	(292022, 142, '2015-01-01 01:11:02.000000', 'temperatura', 471.0000, 'ºC'),
	(292023, 142, '2015-01-01 01:11:03.000000', 'temperatura', 1162.0000, 'ºC'),
	(292024, 142, '2015-01-01 01:11:04.000000', 'temperatura', 798.0000, 'ºC'),
	(292025, 142, '2015-01-01 01:11:05.000000', 'temperatura', 503.0000, 'ºC'),
	(292026, 142, '2015-01-01 01:11:06.000000', 'temperatura', 121.0000, 'ºC'),
	(292027, 142, '2015-01-01 01:11:07.000000', 'temperatura', 295.0000, 'ºC'),
	(292028, 142, '2015-01-01 01:11:08.000000', 'temperatura', 1116.0000, 'ºC'),
	(292029, 142, '2015-01-01 01:11:09.000000', 'temperatura', 1094.0000, 'ºC'),
	(292030, 142, '2015-01-01 01:11:10.000000', 'temperatura', 923.0000, 'ºC'),
	(292031, 142, '2015-01-01 01:11:11.000000', 'temperatura', 131.0000, 'ºC'),
	(292032, 142, '2015-01-01 01:11:12.000000', 'temperatura', 289.0000, 'ºC'),
	(292033, 142, '2015-01-01 01:11:13.000000', 'temperatura', 1051.0000, 'ºC'),
	(292034, 142, '2015-01-01 01:11:14.000000', 'temperatura', 790.0000, 'ºC'),
	(292035, 142, '2015-01-01 01:11:15.000000', 'temperatura', 798.0000, 'ºC'),
	(292036, 142, '2015-01-01 01:11:16.000000', 'temperatura', 420.0000, 'ºC'),
	(292037, 142, '2015-01-01 01:11:17.000000', 'temperatura', 905.0000, 'ºC'),
	(292038, 142, '2015-01-01 01:11:18.000000', 'temperatura', 865.0000, 'ºC'),
	(292039, 142, '2015-01-01 01:11:19.000000', 'temperatura', 413.0000, 'ºC'),
	(292040, 142, '2015-01-01 01:11:20.000000', 'temperatura', 668.0000, 'ºC'),
	(292041, 142, '2015-01-01 01:11:21.000000', 'temperatura', 903.0000, 'ºC'),
	(292042, 142, '2015-01-01 01:11:22.000000', 'temperatura', 110.0000, 'ºC'),
	(292043, 142, '2015-01-01 01:11:23.000000', 'temperatura', 244.0000, 'ºC'),
	(292044, 142, '2015-01-01 01:11:24.000000', 'temperatura', 891.0000, 'ºC'),
	(292045, 142, '2015-01-01 01:11:25.000000', 'temperatura', 121.0000, 'ºC'),
	(292046, 142, '2015-01-01 01:11:26.000000', 'temperatura', 332.0000, 'ºC'),
	(292047, 142, '2015-01-01 01:11:27.000000', 'temperatura', 99.0000, 'ºC'),
	(292048, 142, '2015-01-01 01:11:28.000000', 'temperatura', 699.0000, 'ºC'),
	(292049, 142, '2015-01-01 01:11:29.000000', 'temperatura', 799.0000, 'ºC'),
	(292050, 142, '2015-01-01 01:11:30.000000', 'temperatura', 697.0000, 'ºC'),
	(292051, 142, '2015-01-01 01:11:31.000000', 'temperatura', 1090.0000, 'ºC'),
	(292052, 142, '2015-01-01 01:11:32.000000', 'temperatura', 959.0000, 'ºC'),
	(292053, 142, '2015-01-01 01:11:33.000000', 'temperatura', 326.0000, 'ºC'),
	(292054, 142, '2015-01-01 01:11:34.000000', 'temperatura', 1152.0000, 'ºC'),
	(292055, 142, '2015-01-01 01:11:35.000000', 'temperatura', 1185.0000, 'ºC'),
	(292056, 142, '2015-01-01 01:11:36.000000', 'temperatura', 67.0000, 'ºC'),
	(292057, 142, '2015-01-01 01:11:37.000000', 'temperatura', 381.0000, 'ºC'),
	(292058, 142, '2015-01-01 01:11:38.000000', 'temperatura', 504.0000, 'ºC'),
	(292059, 142, '2015-01-01 01:11:39.000000', 'temperatura', 179.0000, 'ºC'),
	(292060, 142, '2015-01-01 01:11:40.000000', 'temperatura', 584.0000, 'ºC'),
	(292061, 142, '2015-01-01 01:11:41.000000', 'temperatura', 1181.0000, 'ºC'),
	(292062, 142, '2015-01-01 01:11:42.000000', 'temperatura', 553.0000, 'ºC'),
	(292063, 142, '2015-01-01 01:11:43.000000', 'temperatura', 423.0000, 'ºC'),
	(292064, 142, '2015-01-01 01:11:44.000000', 'temperatura', 459.0000, 'ºC'),
	(292065, 142, '2015-01-01 01:11:45.000000', 'temperatura', 1023.0000, 'ºC'),
	(292066, 142, '2015-01-01 01:11:46.000000', 'temperatura', 142.0000, 'ºC'),
	(292067, 142, '2015-01-01 01:11:47.000000', 'temperatura', 39.0000, 'ºC'),
	(292068, 142, '2015-01-01 01:11:48.000000', 'temperatura', 972.0000, 'ºC'),
	(292069, 142, '2015-01-01 01:11:49.000000', 'temperatura', 1141.0000, 'ºC'),
	(292070, 142, '2015-01-01 01:11:50.000000', 'temperatura', 391.0000, 'ºC'),
	(292071, 142, '2015-01-01 01:11:51.000000', 'temperatura', 931.0000, 'ºC'),
	(292072, 142, '2015-01-01 01:11:52.000000', 'temperatura', 1083.0000, 'ºC'),
	(292073, 142, '2015-01-01 01:11:53.000000', 'temperatura', 223.0000, 'ºC'),
	(292074, 142, '2015-01-01 01:11:54.000000', 'temperatura', 267.0000, 'ºC'),
	(292075, 142, '2015-01-01 01:11:55.000000', 'temperatura', 668.0000, 'ºC'),
	(292076, 142, '2015-01-01 01:11:56.000000', 'temperatura', 137.0000, 'ºC'),
	(292077, 142, '2015-01-01 01:11:57.000000', 'temperatura', 1084.0000, 'ºC'),
	(292078, 142, '2015-01-01 01:11:58.000000', 'temperatura', 209.0000, 'ºC'),
	(292079, 142, '2015-01-01 01:11:59.000000', 'temperatura', 194.0000, 'ºC'),
	(292080, 142, '2015-01-01 01:12:00.000000', 'temperatura', 344.0000, 'ºC'),
	(292081, 142, '2015-01-01 01:12:01.000000', 'temperatura', 1136.0000, 'ºC'),
	(292082, 142, '2015-01-01 01:12:02.000000', 'temperatura', 1050.0000, 'ºC'),
	(292083, 142, '2015-01-01 01:12:03.000000', 'temperatura', 644.0000, 'ºC'),
	(292084, 142, '2015-01-01 01:12:04.000000', 'temperatura', 69.0000, 'ºC'),
	(292085, 142, '2015-01-01 01:12:05.000000', 'temperatura', 812.0000, 'ºC'),
	(292086, 142, '2015-01-01 01:12:06.000000', 'temperatura', 253.0000, 'ºC'),
	(292087, 142, '2015-01-01 01:12:07.000000', 'temperatura', 32.0000, 'ºC'),
	(292088, 142, '2015-01-01 01:12:08.000000', 'temperatura', 600.0000, 'ºC'),
	(292089, 142, '2015-01-01 01:12:09.000000', 'temperatura', 504.0000, 'ºC'),
	(292090, 142, '2015-01-01 01:12:10.000000', 'temperatura', 722.0000, 'ºC'),
	(292091, 142, '2015-01-01 01:12:11.000000', 'temperatura', 897.0000, 'ºC'),
	(292092, 142, '2015-01-01 01:12:12.000000', 'temperatura', 1119.0000, 'ºC'),
	(292093, 142, '2015-01-01 01:12:13.000000', 'temperatura', 504.0000, 'ºC'),
	(292094, 142, '2015-01-01 01:12:14.000000', 'temperatura', 363.0000, 'ºC'),
	(292095, 142, '2015-01-01 01:12:15.000000', 'temperatura', 304.0000, 'ºC'),
	(292096, 142, '2015-01-01 01:12:16.000000', 'temperatura', 431.0000, 'ºC'),
	(292097, 142, '2015-01-01 01:12:17.000000', 'temperatura', 45.0000, 'ºC'),
	(292098, 142, '2015-01-01 01:12:18.000000', 'temperatura', 130.0000, 'ºC'),
	(292099, 142, '2015-01-01 01:12:19.000000', 'temperatura', 519.0000, 'ºC'),
	(292100, 142, '2015-01-01 01:12:20.000000', 'temperatura', 1003.0000, 'ºC'),
	(292101, 142, '2015-01-01 01:12:21.000000', 'temperatura', 1061.0000, 'ºC'),
	(292102, 142, '2015-01-01 01:12:22.000000', 'temperatura', 1096.0000, 'ºC'),
	(292103, 142, '2015-01-01 01:12:23.000000', 'temperatura', 1095.0000, 'ºC'),
	(292104, 142, '2015-01-01 01:12:24.000000', 'temperatura', 989.0000, 'ºC'),
	(292105, 142, '2015-01-01 01:12:25.000000', 'temperatura', 461.0000, 'ºC'),
	(292106, 142, '2015-01-01 01:12:26.000000', 'temperatura', 540.0000, 'ºC'),
	(292107, 142, '2015-01-01 01:12:27.000000', 'temperatura', 117.0000, 'ºC'),
	(292108, 142, '2015-01-01 01:12:28.000000', 'temperatura', 166.0000, 'ºC'),
	(292109, 142, '2015-01-01 01:12:29.000000', 'temperatura', 477.0000, 'ºC'),
	(292110, 142, '2015-01-01 01:12:30.000000', 'temperatura', 688.0000, 'ºC'),
	(292111, 142, '2015-01-01 01:12:31.000000', 'temperatura', 811.0000, 'ºC'),
	(292112, 142, '2015-01-01 01:12:32.000000', 'temperatura', 792.0000, 'ºC'),
	(292113, 142, '2015-01-01 01:12:33.000000', 'temperatura', 329.0000, 'ºC'),
	(292114, 142, '2015-01-01 01:12:34.000000', 'temperatura', 467.0000, 'ºC'),
	(292115, 142, '2015-01-01 01:12:35.000000', 'temperatura', 149.0000, 'ºC'),
	(292116, 142, '2015-01-01 01:12:36.000000', 'temperatura', 543.0000, 'ºC'),
	(292117, 142, '2015-01-01 01:12:37.000000', 'temperatura', 1071.0000, 'ºC'),
	(292118, 142, '2015-01-01 01:12:38.000000', 'temperatura', 125.0000, 'ºC'),
	(292119, 142, '2015-01-01 01:12:39.000000', 'temperatura', 1012.0000, 'ºC'),
	(292120, 142, '2015-01-01 01:12:40.000000', 'temperatura', 1087.0000, 'ºC'),
	(292121, 142, '2015-01-01 01:12:41.000000', 'temperatura', 1.0000, 'ºC'),
	(292122, 142, '2015-01-01 01:12:42.000000', 'temperatura', 341.0000, 'ºC'),
	(292123, 142, '2015-01-01 01:12:43.000000', 'temperatura', 505.0000, 'ºC'),
	(292124, 142, '2015-01-01 01:12:44.000000', 'temperatura', 301.0000, 'ºC'),
	(292125, 142, '2015-01-01 01:12:45.000000', 'temperatura', 1190.0000, 'ºC'),
	(292126, 142, '2015-01-01 01:12:46.000000', 'temperatura', 249.0000, 'ºC'),
	(292127, 142, '2015-01-01 01:12:47.000000', 'temperatura', 75.0000, 'ºC'),
	(292128, 142, '2015-01-01 01:12:48.000000', 'temperatura', 828.0000, 'ºC'),
	(292129, 142, '2015-01-01 01:12:49.000000', 'temperatura', 315.0000, 'ºC'),
	(292130, 142, '2015-01-01 01:12:50.000000', 'temperatura', 293.0000, 'ºC'),
	(292131, 142, '2015-01-01 01:12:51.000000', 'temperatura', 520.0000, 'ºC'),
	(292132, 142, '2015-01-01 01:12:52.000000', 'temperatura', 523.0000, 'ºC'),
	(292133, 142, '2015-01-01 01:12:53.000000', 'temperatura', 1056.0000, 'ºC'),
	(292134, 142, '2015-01-01 01:12:54.000000', 'temperatura', 111.0000, 'ºC'),
	(292135, 142, '2015-01-01 01:12:55.000000', 'temperatura', 988.0000, 'ºC'),
	(292136, 142, '2015-01-01 01:12:56.000000', 'temperatura', 1008.0000, 'ºC'),
	(292137, 142, '2015-01-01 01:12:57.000000', 'temperatura', 877.0000, 'ºC'),
	(292138, 142, '2015-01-01 01:12:58.000000', 'temperatura', 161.0000, 'ºC'),
	(292139, 142, '2015-01-01 01:12:59.000000', 'temperatura', 573.0000, 'ºC'),
	(292140, 142, '2015-01-01 01:13:00.000000', 'temperatura', 1185.0000, 'ºC'),
	(292141, 142, '2015-01-01 01:13:01.000000', 'temperatura', 606.0000, 'ºC'),
	(292142, 142, '2015-01-01 01:13:02.000000', 'temperatura', 676.0000, 'ºC'),
	(292143, 142, '2015-01-01 01:13:03.000000', 'temperatura', 363.0000, 'ºC'),
	(292144, 142, '2015-01-01 01:13:04.000000', 'temperatura', 985.0000, 'ºC'),
	(292145, 142, '2015-01-01 01:13:05.000000', 'temperatura', 238.0000, 'ºC'),
	(292146, 142, '2015-01-01 01:13:06.000000', 'temperatura', 634.0000, 'ºC'),
	(292147, 142, '2015-01-01 01:13:07.000000', 'temperatura', 56.0000, 'ºC'),
	(292148, 142, '2015-01-01 01:13:08.000000', 'temperatura', 778.0000, 'ºC'),
	(292149, 142, '2015-01-01 01:13:09.000000', 'temperatura', 124.0000, 'ºC'),
	(292150, 142, '2015-01-01 01:13:10.000000', 'temperatura', 686.0000, 'ºC'),
	(292151, 142, '2015-01-01 01:13:11.000000', 'temperatura', 658.0000, 'ºC'),
	(292152, 142, '2015-01-01 01:13:12.000000', 'temperatura', 33.0000, 'ºC'),
	(292153, 142, '2015-01-01 01:13:13.000000', 'temperatura', 589.0000, 'ºC'),
	(292154, 142, '2015-01-01 01:13:14.000000', 'temperatura', 450.0000, 'ºC'),
	(292155, 142, '2015-01-01 01:13:15.000000', 'temperatura', 481.0000, 'ºC'),
	(292156, 142, '2015-01-01 01:13:16.000000', 'temperatura', 1056.0000, 'ºC'),
	(292157, 142, '2015-01-01 01:13:17.000000', 'temperatura', 237.0000, 'ºC'),
	(292158, 142, '2015-01-01 01:13:18.000000', 'temperatura', 420.0000, 'ºC'),
	(292159, 142, '2015-01-01 01:13:19.000000', 'temperatura', 187.0000, 'ºC'),
	(292160, 142, '2015-01-01 01:13:20.000000', 'temperatura', 876.0000, 'ºC'),
	(292161, 142, '2015-01-01 01:13:21.000000', 'temperatura', 219.0000, 'ºC'),
	(292162, 142, '2015-01-01 01:13:22.000000', 'temperatura', 868.0000, 'ºC'),
	(292163, 142, '2015-01-01 01:13:23.000000', 'temperatura', 82.0000, 'ºC'),
	(292164, 142, '2015-01-01 01:13:24.000000', 'temperatura', 207.0000, 'ºC'),
	(292165, 142, '2015-01-01 01:13:25.000000', 'temperatura', 791.0000, 'ºC'),
	(292166, 142, '2015-01-01 01:13:26.000000', 'temperatura', 934.0000, 'ºC'),
	(292167, 142, '2015-01-01 01:13:27.000000', 'temperatura', 1098.0000, 'ºC'),
	(292168, 142, '2015-01-01 01:13:28.000000', 'temperatura', 288.0000, 'ºC'),
	(292169, 142, '2015-01-01 01:13:29.000000', 'temperatura', 547.0000, 'ºC'),
	(292170, 142, '2015-01-01 01:13:30.000000', 'temperatura', 669.0000, 'ºC'),
	(292171, 142, '2015-01-01 01:13:31.000000', 'temperatura', 507.0000, 'ºC'),
	(292172, 142, '2015-01-01 01:13:32.000000', 'temperatura', 526.0000, 'ºC'),
	(292173, 142, '2015-01-01 01:13:33.000000', 'temperatura', 1110.0000, 'ºC'),
	(292174, 142, '2015-01-01 01:13:34.000000', 'temperatura', 374.0000, 'ºC'),
	(292175, 142, '2015-01-01 01:13:35.000000', 'temperatura', 941.0000, 'ºC'),
	(292176, 142, '2015-01-01 01:13:36.000000', 'temperatura', 1183.0000, 'ºC'),
	(292177, 142, '2015-01-01 01:13:37.000000', 'temperatura', 693.0000, 'ºC'),
	(292178, 142, '2015-01-01 01:13:38.000000', 'temperatura', 1116.0000, 'ºC'),
	(292179, 142, '2015-01-01 01:13:39.000000', 'temperatura', 1102.0000, 'ºC'),
	(292180, 142, '2015-01-01 01:13:40.000000', 'temperatura', 960.0000, 'ºC'),
	(292181, 142, '2015-01-01 01:13:41.000000', 'temperatura', 297.0000, 'ºC'),
	(292182, 142, '2015-01-01 01:13:42.000000', 'temperatura', 1007.0000, 'ºC'),
	(292183, 142, '2015-01-01 01:13:43.000000', 'temperatura', 542.0000, 'ºC'),
	(292184, 142, '2015-01-01 01:13:44.000000', 'temperatura', 891.0000, 'ºC'),
	(292185, 142, '2015-01-01 01:13:45.000000', 'temperatura', 430.0000, 'ºC'),
	(292186, 142, '2015-01-01 01:13:46.000000', 'temperatura', 677.0000, 'ºC'),
	(292187, 142, '2015-01-01 01:13:47.000000', 'temperatura', 894.0000, 'ºC'),
	(292188, 142, '2015-01-01 01:13:48.000000', 'temperatura', 42.0000, 'ºC'),
	(292189, 142, '2015-01-01 01:13:49.000000', 'temperatura', 1128.0000, 'ºC'),
	(292190, 142, '2015-01-01 01:13:50.000000', 'temperatura', 716.0000, 'ºC'),
	(292191, 142, '2015-01-01 01:13:51.000000', 'temperatura', 195.0000, 'ºC'),
	(292192, 142, '2015-01-01 01:13:52.000000', 'temperatura', 29.0000, 'ºC'),
	(292193, 142, '2015-01-01 01:13:53.000000', 'temperatura', 761.0000, 'ºC'),
	(292194, 142, '2015-01-01 01:13:54.000000', 'temperatura', 119.0000, 'ºC'),
	(292195, 142, '2015-01-01 01:13:55.000000', 'temperatura', 712.0000, 'ºC'),
	(292196, 142, '2015-01-01 01:13:56.000000', 'temperatura', 803.0000, 'ºC'),
	(292197, 142, '2015-01-01 01:13:57.000000', 'temperatura', 681.0000, 'ºC'),
	(292198, 142, '2015-01-01 01:13:58.000000', 'temperatura', 995.0000, 'ºC'),
	(292199, 142, '2015-01-01 01:13:59.000000', 'temperatura', 532.0000, 'ºC'),
	(292200, 142, '2015-01-01 01:14:00.000000', 'temperatura', 875.0000, 'ºC'),
	(292201, 142, '2015-01-01 01:14:01.000000', 'temperatura', 381.0000, 'ºC'),
	(292202, 142, '2015-01-01 01:14:02.000000', 'temperatura', 479.0000, 'ºC'),
	(292203, 142, '2015-01-01 01:14:03.000000', 'temperatura', 51.0000, 'ºC'),
	(292204, 142, '2015-01-01 01:14:04.000000', 'temperatura', 21.0000, 'ºC'),
	(292205, 142, '2015-01-01 01:14:05.000000', 'temperatura', 1152.0000, 'ºC'),
	(292206, 142, '2015-01-01 01:14:06.000000', 'temperatura', 895.0000, 'ºC'),
	(292207, 142, '2015-01-01 01:14:07.000000', 'temperatura', 1022.0000, 'ºC'),
	(292208, 142, '2015-01-01 01:14:08.000000', 'temperatura', 26.0000, 'ºC'),
	(292209, 142, '2015-01-01 01:14:09.000000', 'temperatura', 663.0000, 'ºC'),
	(292210, 142, '2015-01-01 01:14:10.000000', 'temperatura', 839.0000, 'ºC'),
	(292211, 142, '2015-01-01 01:14:11.000000', 'temperatura', 1004.0000, 'ºC'),
	(292212, 142, '2015-01-01 01:14:12.000000', 'temperatura', 106.0000, 'ºC'),
	(292213, 142, '2015-01-01 01:14:13.000000', 'temperatura', 1116.0000, 'ºC'),
	(292214, 142, '2015-01-01 01:14:14.000000', 'temperatura', 464.0000, 'ºC'),
	(292215, 142, '2015-01-01 01:14:15.000000', 'temperatura', 171.0000, 'ºC'),
	(292216, 142, '2015-01-01 01:14:16.000000', 'temperatura', 664.0000, 'ºC'),
	(292217, 142, '2015-01-01 01:14:17.000000', 'temperatura', 409.0000, 'ºC'),
	(292218, 142, '2015-01-01 01:14:18.000000', 'temperatura', 54.0000, 'ºC'),
	(292219, 142, '2015-01-01 01:14:19.000000', 'temperatura', 242.0000, 'ºC'),
	(292220, 142, '2015-01-01 01:14:20.000000', 'temperatura', 1047.0000, 'ºC'),
	(292221, 142, '2015-01-01 01:14:21.000000', 'temperatura', 911.0000, 'ºC'),
	(292222, 142, '2015-01-01 01:14:22.000000', 'temperatura', 215.0000, 'ºC'),
	(292223, 142, '2015-01-01 01:14:23.000000', 'temperatura', 743.0000, 'ºC'),
	(292224, 142, '2015-01-01 01:14:24.000000', 'temperatura', 668.0000, 'ºC'),
	(292225, 142, '2015-01-01 01:14:25.000000', 'temperatura', 1112.0000, 'ºC'),
	(292226, 142, '2015-01-01 01:14:26.000000', 'temperatura', 1157.0000, 'ºC'),
	(292227, 142, '2015-01-01 01:14:27.000000', 'temperatura', 49.0000, 'ºC'),
	(292228, 142, '2015-01-01 01:14:28.000000', 'temperatura', 373.0000, 'ºC'),
	(292229, 142, '2015-01-01 01:14:29.000000', 'temperatura', 520.0000, 'ºC'),
	(292230, 142, '2015-01-01 01:14:30.000000', 'temperatura', 283.0000, 'ºC'),
	(292231, 142, '2015-01-01 01:14:31.000000', 'temperatura', 1054.0000, 'ºC'),
	(292232, 142, '2015-01-01 01:14:32.000000', 'temperatura', 820.0000, 'ºC'),
	(292233, 142, '2015-01-01 01:14:33.000000', 'temperatura', 939.0000, 'ºC'),
	(292234, 142, '2015-01-01 01:14:34.000000', 'temperatura', 1035.0000, 'ºC'),
	(292235, 142, '2015-01-01 01:14:35.000000', 'temperatura', 1159.0000, 'ºC'),
	(292236, 142, '2015-01-01 01:14:36.000000', 'temperatura', 289.0000, 'ºC'),
	(292237, 142, '2015-01-01 01:14:37.000000', 'temperatura', 370.0000, 'ºC'),
	(292238, 142, '2015-01-01 01:14:38.000000', 'temperatura', 984.0000, 'ºC'),
	(292239, 142, '2015-01-01 01:14:39.000000', 'temperatura', 211.0000, 'ºC'),
	(292240, 142, '2015-01-01 01:14:40.000000', 'temperatura', 502.0000, 'ºC'),
	(292241, 142, '2015-01-01 01:14:41.000000', 'temperatura', 678.0000, 'ºC'),
	(292242, 142, '2015-01-01 01:14:42.000000', 'temperatura', 682.0000, 'ºC'),
	(292243, 142, '2015-01-01 01:14:43.000000', 'temperatura', 180.0000, 'ºC'),
	(292244, 142, '2015-01-01 01:14:44.000000', 'temperatura', 54.0000, 'ºC'),
	(292245, 142, '2015-01-01 01:14:45.000000', 'temperatura', 929.0000, 'ºC'),
	(292246, 142, '2015-01-01 01:14:46.000000', 'temperatura', 883.0000, 'ºC'),
	(292247, 142, '2015-01-01 01:14:47.000000', 'temperatura', 431.0000, 'ºC'),
	(292248, 142, '2015-01-01 01:14:48.000000', 'temperatura', 704.0000, 'ºC'),
	(292249, 142, '2015-01-01 01:14:49.000000', 'temperatura', 1029.0000, 'ºC'),
	(292250, 142, '2015-01-01 01:14:50.000000', 'temperatura', 634.0000, 'ºC'),
	(292251, 142, '2015-01-01 01:14:51.000000', 'temperatura', 83.0000, 'ºC'),
	(292252, 142, '2015-01-01 01:14:52.000000', 'temperatura', 914.0000, 'ºC'),
	(292253, 142, '2015-01-01 01:14:53.000000', 'temperatura', 720.0000, 'ºC'),
	(292254, 142, '2015-01-01 01:14:54.000000', 'temperatura', 858.0000, 'ºC'),
	(292255, 142, '2015-01-01 01:14:55.000000', 'temperatura', 931.0000, 'ºC'),
	(292256, 142, '2015-01-01 01:14:56.000000', 'temperatura', 880.0000, 'ºC'),
	(292257, 142, '2015-01-01 01:14:57.000000', 'temperatura', 409.0000, 'ºC'),
	(292258, 142, '2015-01-01 01:14:58.000000', 'temperatura', 605.0000, 'ºC'),
	(292259, 142, '2015-01-01 01:14:59.000000', 'temperatura', 597.0000, 'ºC'),
	(292260, 142, '2015-01-01 01:15:00.000000', 'temperatura', 1173.0000, 'ºC'),
	(292261, 142, '2015-01-01 01:15:01.000000', 'temperatura', 476.0000, 'ºC'),
	(292262, 142, '2015-01-01 01:15:02.000000', 'temperatura', 58.0000, 'ºC'),
	(292263, 142, '2015-01-01 01:15:03.000000', 'temperatura', 65.0000, 'ºC'),
	(292264, 142, '2015-01-01 01:15:04.000000', 'temperatura', 149.0000, 'ºC'),
	(292265, 142, '2015-01-01 01:15:05.000000', 'temperatura', 550.0000, 'ºC'),
	(292266, 142, '2015-01-01 01:15:06.000000', 'temperatura', 1105.0000, 'ºC'),
	(292267, 142, '2015-01-01 01:15:07.000000', 'temperatura', 275.0000, 'ºC'),
	(292268, 142, '2015-01-01 01:15:08.000000', 'temperatura', 462.0000, 'ºC'),
	(292269, 142, '2015-01-01 01:15:09.000000', 'temperatura', 284.0000, 'ºC'),
	(292270, 142, '2015-01-01 01:15:10.000000', 'temperatura', 35.0000, 'ºC'),
	(292271, 142, '2015-01-01 01:15:11.000000', 'temperatura', 524.0000, 'ºC'),
	(292272, 142, '2015-01-01 01:15:12.000000', 'temperatura', 116.0000, 'ºC'),
	(292273, 142, '2015-01-01 01:15:13.000000', 'temperatura', 207.0000, 'ºC'),
	(292274, 142, '2015-01-01 01:15:14.000000', 'temperatura', 688.0000, 'ºC'),
	(292275, 142, '2015-01-01 01:15:15.000000', 'temperatura', 419.0000, 'ºC'),
	(292276, 142, '2015-01-01 01:15:16.000000', 'temperatura', 32.0000, 'ºC'),
	(292277, 142, '2015-01-01 01:15:17.000000', 'temperatura', 102.0000, 'ºC'),
	(292278, 142, '2015-01-01 01:15:18.000000', 'temperatura', 415.0000, 'ºC'),
	(292279, 142, '2015-01-01 01:15:19.000000', 'temperatura', 569.0000, 'ºC'),
	(292280, 142, '2015-01-01 01:15:20.000000', 'temperatura', 402.0000, 'ºC'),
	(292281, 142, '2015-01-01 01:15:21.000000', 'temperatura', 304.0000, 'ºC'),
	(292282, 142, '2015-01-01 01:15:22.000000', 'temperatura', 315.0000, 'ºC'),
	(292283, 142, '2015-01-01 01:15:23.000000', 'temperatura', 662.0000, 'ºC'),
	(292284, 142, '2015-01-01 01:15:24.000000', 'temperatura', 1164.0000, 'ºC'),
	(292285, 142, '2015-01-01 01:15:25.000000', 'temperatura', 238.0000, 'ºC'),
	(292286, 142, '2015-01-01 01:15:26.000000', 'temperatura', 97.0000, 'ºC'),
	(292287, 142, '2015-01-01 01:15:27.000000', 'temperatura', 969.0000, 'ºC'),
	(292288, 142, '2015-01-01 01:15:28.000000', 'temperatura', 958.0000, 'ºC'),
	(292289, 142, '2015-01-01 01:15:29.000000', 'temperatura', 682.0000, 'ºC'),
	(292290, 142, '2015-01-01 01:15:30.000000', 'temperatura', 535.0000, 'ºC'),
	(292291, 142, '2015-01-01 01:15:31.000000', 'temperatura', 629.0000, 'ºC'),
	(292292, 142, '2015-01-01 01:15:32.000000', 'temperatura', 343.0000, 'ºC'),
	(292293, 142, '2015-01-01 01:15:33.000000', 'temperatura', 1030.0000, 'ºC'),
	(292294, 142, '2015-01-01 01:15:34.000000', 'temperatura', 518.0000, 'ºC'),
	(292295, 142, '2015-01-01 01:15:35.000000', 'temperatura', 702.0000, 'ºC'),
	(292296, 142, '2015-01-01 01:15:36.000000', 'temperatura', 755.0000, 'ºC'),
	(292297, 142, '2015-01-01 01:15:37.000000', 'temperatura', 471.0000, 'ºC'),
	(292298, 142, '2015-01-01 01:15:38.000000', 'temperatura', 92.0000, 'ºC'),
	(292299, 142, '2015-01-01 01:15:39.000000', 'temperatura', 245.0000, 'ºC'),
	(292300, 142, '2015-01-01 01:15:40.000000', 'temperatura', 950.0000, 'ºC'),
	(292301, 142, '2015-01-01 01:15:41.000000', 'temperatura', 416.0000, 'ºC'),
	(292302, 142, '2015-01-01 01:15:42.000000', 'temperatura', 430.0000, 'ºC'),
	(292303, 142, '2015-01-01 01:15:43.000000', 'temperatura', 901.0000, 'ºC'),
	(292304, 142, '2015-01-01 01:15:44.000000', 'temperatura', 818.0000, 'ºC'),
	(292305, 142, '2015-01-01 01:15:45.000000', 'temperatura', 186.0000, 'ºC'),
	(292306, 142, '2015-01-01 01:15:46.000000', 'temperatura', 876.0000, 'ºC'),
	(292307, 142, '2015-01-01 01:15:47.000000', 'temperatura', 223.0000, 'ºC'),
	(292308, 142, '2015-01-01 01:15:48.000000', 'temperatura', 886.0000, 'ºC'),
	(292309, 142, '2015-01-01 01:15:49.000000', 'temperatura', 163.0000, 'ºC'),
	(292310, 142, '2015-01-01 01:15:50.000000', 'temperatura', 558.0000, 'ºC'),
	(292311, 142, '2015-01-01 01:15:51.000000', 'temperatura', 1103.0000, 'ºC'),
	(292312, 142, '2015-01-01 01:15:52.000000', 'temperatura', 239.0000, 'ºC'),
	(292313, 142, '2015-01-01 01:15:53.000000', 'temperatura', 288.0000, 'ºC'),
	(292314, 142, '2015-01-01 01:15:54.000000', 'temperatura', 724.0000, 'ºC'),
	(292315, 142, '2015-01-01 01:15:55.000000', 'temperatura', 357.0000, 'ºC'),
	(292316, 142, '2015-01-01 01:15:56.000000', 'temperatura', 813.0000, 'ºC'),
	(292317, 142, '2015-01-01 01:15:57.000000', 'temperatura', 593.0000, 'ºC'),
	(292318, 142, '2015-01-01 01:15:58.000000', 'temperatura', 526.0000, 'ºC'),
	(292319, 142, '2015-01-01 01:15:59.000000', 'temperatura', 851.0000, 'ºC'),
	(292320, 142, '2015-01-01 01:16:00.000000', 'temperatura', 279.0000, 'ºC'),
	(292321, 142, '2015-01-01 01:16:01.000000', 'temperatura', 42.0000, 'ºC'),
	(292322, 142, '2015-01-01 01:16:02.000000', 'temperatura', 572.0000, 'ºC'),
	(292323, 142, '2015-01-01 01:16:03.000000', 'temperatura', 338.0000, 'ºC'),
	(292324, 142, '2015-01-01 01:16:04.000000', 'temperatura', 1171.0000, 'ºC'),
	(292325, 142, '2015-01-01 01:16:05.000000', 'temperatura', 44.0000, 'ºC'),
	(292326, 142, '2015-01-01 01:16:06.000000', 'temperatura', 306.0000, 'ºC'),
	(292327, 142, '2015-01-01 01:16:07.000000', 'temperatura', 198.0000, 'ºC'),
	(292328, 142, '2015-01-01 01:16:08.000000', 'temperatura', 74.0000, 'ºC'),
	(292329, 142, '2015-01-01 01:16:09.000000', 'temperatura', 977.0000, 'ºC'),
	(292330, 142, '2015-01-01 01:16:10.000000', 'temperatura', 1063.0000, 'ºC'),
	(292331, 142, '2015-01-01 01:16:11.000000', 'temperatura', 1184.0000, 'ºC'),
	(292332, 142, '2015-01-01 01:16:12.000000', 'temperatura', 330.0000, 'ºC'),
	(292333, 142, '2015-01-01 01:16:13.000000', 'temperatura', 501.0000, 'ºC'),
	(292334, 142, '2015-01-01 01:16:14.000000', 'temperatura', 313.0000, 'ºC'),
	(292335, 142, '2015-01-01 01:16:15.000000', 'temperatura', 65.0000, 'ºC'),
	(292336, 142, '2015-01-01 01:16:16.000000', 'temperatura', 587.0000, 'ºC'),
	(292337, 142, '2015-01-01 01:16:17.000000', 'temperatura', 339.0000, 'ºC'),
	(292338, 142, '2015-01-01 01:16:18.000000', 'temperatura', 1134.0000, 'ºC'),
	(292339, 142, '2015-01-01 01:16:19.000000', 'temperatura', 1053.0000, 'ºC'),
	(292340, 142, '2015-01-01 01:16:20.000000', 'temperatura', 665.0000, 'ºC'),
	(292341, 142, '2015-01-01 01:16:21.000000', 'temperatura', 166.0000, 'ºC'),
	(292342, 142, '2015-01-01 01:16:22.000000', 'temperatura', 37.0000, 'ºC'),
	(292343, 142, '2015-01-01 01:16:23.000000', 'temperatura', 887.0000, 'ºC'),
	(292344, 142, '2015-01-01 01:16:24.000000', 'temperatura', 722.0000, 'ºC'),
	(292345, 142, '2015-01-01 01:16:25.000000', 'temperatura', 951.0000, 'ºC'),
	(292346, 142, '2015-01-01 01:16:26.000000', 'temperatura', 190.0000, 'ºC'),
	(292347, 142, '2015-01-01 01:16:27.000000', 'temperatura', 498.0000, 'ºC'),
	(292348, 142, '2015-01-01 01:16:28.000000', 'temperatura', 718.0000, 'ºC'),
	(292349, 142, '2015-01-01 01:16:29.000000', 'temperatura', 897.0000, 'ºC'),
	(292350, 142, '2015-01-01 01:16:30.000000', 'temperatura', 1132.0000, 'ºC'),
	(292351, 142, '2015-01-01 01:16:31.000000', 'temperatura', 570.0000, 'ºC'),
	(292352, 142, '2015-01-01 01:16:32.000000', 'temperatura', 652.0000, 'ºC'),
	(292353, 142, '2015-01-01 01:16:33.000000', 'temperatura', 353.0000, 'ºC'),
	(292354, 142, '2015-01-01 01:16:34.000000', 'temperatura', 1010.0000, 'ºC'),
	(292355, 142, '2015-01-01 01:16:35.000000', 'temperatura', 390.0000, 'ºC'),
	(292356, 142, '2015-01-01 01:16:36.000000', 'temperatura', 122.0000, 'ºC'),
	(292357, 142, '2015-01-01 01:16:37.000000', 'temperatura', 639.0000, 'ºC'),
	(292358, 142, '2015-01-01 01:16:38.000000', 'temperatura', 429.0000, 'ºC'),
	(292359, 142, '2015-01-01 01:16:39.000000', 'temperatura', 230.0000, 'ºC'),
	(292360, 142, '2015-01-01 01:16:40.000000', 'temperatura', 1063.0000, 'ºC'),
	(292361, 142, '2015-01-01 01:16:41.000000', 'temperatura', 1027.0000, 'ºC'),
	(292362, 142, '2015-01-01 01:16:42.000000', 'temperatura', 746.0000, 'ºC'),
	(292363, 142, '2015-01-01 01:16:43.000000', 'temperatura', 650.0000, 'ºC'),
	(292364, 142, '2015-01-01 01:16:44.000000', 'temperatura', 1011.0000, 'ºC'),
	(292365, 142, '2015-01-01 01:16:45.000000', 'temperatura', 707.0000, 'ºC'),
	(292366, 142, '2015-01-01 01:16:46.000000', 'temperatura', 504.0000, 'ºC'),
	(292367, 142, '2015-01-01 01:16:47.000000', 'temperatura', 396.0000, 'ºC'),
	(292368, 142, '2015-01-01 01:16:48.000000', 'temperatura', 472.0000, 'ºC'),
	(292369, 142, '2015-01-01 01:16:49.000000', 'temperatura', 1169.0000, 'ºC'),
	(292370, 142, '2015-01-01 01:16:50.000000', 'temperatura', 831.0000, 'ºC'),
	(292371, 142, '2015-01-01 01:16:51.000000', 'temperatura', 646.0000, 'ºC'),
	(292372, 142, '2015-01-01 01:16:52.000000', 'temperatura', 741.0000, 'ºC'),
	(292373, 142, '2015-01-01 01:16:53.000000', 'temperatura', 567.0000, 'ºC'),
	(292374, 142, '2015-01-01 01:16:54.000000', 'temperatura', 613.0000, 'ºC'),
	(292375, 142, '2015-01-01 01:16:55.000000', 'temperatura', 164.0000, 'ºC'),
	(292376, 142, '2015-01-01 01:16:56.000000', 'temperatura', 179.0000, 'ºC'),
	(292377, 142, '2015-01-01 01:16:57.000000', 'temperatura', 406.0000, 'ºC'),
	(292378, 142, '2015-01-01 01:16:58.000000', 'temperatura', 294.0000, 'ºC'),
	(292379, 142, '2015-01-01 01:16:59.000000', 'temperatura', 253.0000, 'ºC'),
	(292380, 142, '2015-01-01 01:17:00.000000', 'temperatura', 383.0000, 'ºC'),
	(292381, 142, '2015-01-01 01:17:01.000000', 'temperatura', 1157.0000, 'ºC'),
	(292382, 142, '2015-01-01 01:17:02.000000', 'temperatura', 1038.0000, 'ºC'),
	(292383, 142, '2015-01-01 01:17:03.000000', 'temperatura', 517.0000, 'ºC'),
	(292384, 142, '2015-01-01 01:17:04.000000', 'temperatura', 673.0000, 'ºC'),
	(292385, 142, '2015-01-01 01:17:05.000000', 'temperatura', 615.0000, 'ºC'),
	(292386, 142, '2015-01-01 01:17:06.000000', 'temperatura', 1054.0000, 'ºC'),
	(292387, 142, '2015-01-01 01:17:07.000000', 'temperatura', 1026.0000, 'ºC'),
	(292388, 142, '2015-01-01 01:17:08.000000', 'temperatura', 768.0000, 'ºC'),
	(292389, 142, '2015-01-01 01:17:09.000000', 'temperatura', 762.0000, 'ºC'),
	(292390, 142, '2015-01-01 01:17:10.000000', 'temperatura', 308.0000, 'ºC'),
	(292391, 142, '2015-01-01 01:17:11.000000', 'temperatura', 452.0000, 'ºC'),
	(292392, 142, '2015-01-01 01:17:12.000000', 'temperatura', 138.0000, 'ºC'),
	(292393, 142, '2015-01-01 01:17:13.000000', 'temperatura', 532.0000, 'ºC'),
	(292394, 143, '2015-01-01 00:00:00.000000', 'temperatura', 53.0000, 'ºC'),
	(292395, 143, '2015-01-01 00:00:01.000000', 'temperatura', 716.0000, 'ºC'),
	(292396, 143, '2015-01-01 00:00:02.000000', 'temperatura', 1020.0000, 'ºC'),
	(292397, 143, '2015-01-01 00:00:03.000000', 'temperatura', 554.0000, 'ºC'),
	(292398, 143, '2015-01-01 00:00:04.000000', 'temperatura', 909.0000, 'ºC'),
	(292399, 143, '2015-01-01 00:00:05.000000', 'temperatura', 486.0000, 'ºC'),
	(292400, 143, '2015-01-01 00:00:06.000000', 'temperatura', 904.0000, 'ºC'),
	(292401, 143, '2015-01-01 00:00:07.000000', 'temperatura', 660.0000, 'ºC'),
	(292402, 143, '2015-01-01 00:00:08.000000', 'temperatura', 588.0000, 'ºC'),
	(292403, 143, '2015-01-01 00:00:09.000000', 'temperatura', 961.0000, 'ºC'),
	(292404, 143, '2015-01-01 00:00:10.000000', 'temperatura', 642.0000, 'ºC'),
	(292405, 143, '2015-01-01 00:00:11.000000', 'temperatura', 328.0000, 'ºC'),
	(292406, 143, '2015-01-01 00:00:12.000000', 'temperatura', 914.0000, 'ºC'),
	(292407, 143, '2015-01-01 00:00:13.000000', 'temperatura', 1186.0000, 'ºC'),
	(292408, 143, '2015-01-01 00:00:14.000000', 'temperatura', 789.0000, 'ºC'),
	(292409, 143, '2015-01-01 00:00:15.000000', 'temperatura', 389.0000, 'ºC'),
	(292410, 143, '2015-01-01 00:00:16.000000', 'temperatura', 779.0000, 'ºC'),
	(292411, 143, '2015-01-01 00:00:17.000000', 'temperatura', 326.0000, 'ºC'),
	(292412, 143, '2015-01-01 00:00:18.000000', 'temperatura', 494.0000, 'ºC'),
	(292413, 143, '2015-01-01 00:00:19.000000', 'temperatura', 293.0000, 'ºC'),
	(292414, 143, '2015-01-01 00:00:20.000000', 'temperatura', 1183.0000, 'ºC'),
	(292415, 143, '2015-01-01 00:00:21.000000', 'temperatura', 238.0000, 'ºC'),
	(292416, 143, '2015-01-01 00:00:22.000000', 'temperatura', 39.0000, 'ºC'),
	(292417, 143, '2015-01-01 00:00:23.000000', 'temperatura', 682.0000, 'ºC'),
	(292418, 143, '2015-01-01 00:00:24.000000', 'temperatura', 892.0000, 'ºC'),
	(292419, 143, '2015-01-01 00:00:25.000000', 'temperatura', 16.0000, 'ºC'),
	(292420, 143, '2015-01-01 00:00:26.000000', 'temperatura', 1004.0000, 'ºC'),
	(292421, 143, '2015-01-01 00:00:27.000000', 'temperatura', 175.0000, 'ºC'),
	(292422, 143, '2015-01-01 00:00:28.000000', 'temperatura', 261.0000, 'ºC'),
	(292423, 143, '2015-01-01 00:00:29.000000', 'temperatura', 780.0000, 'ºC'),
	(292424, 143, '2015-01-01 00:00:30.000000', 'temperatura', 717.0000, 'ºC'),
	(292425, 143, '2015-01-01 00:00:31.000000', 'temperatura', 44.0000, 'ºC'),
	(292426, 143, '2015-01-01 00:00:32.000000', 'temperatura', 473.0000, 'ºC'),
	(292427, 143, '2015-01-01 00:00:33.000000', 'temperatura', 1031.0000, 'ºC'),
	(292428, 143, '2015-01-01 00:00:34.000000', 'temperatura', 136.0000, 'ºC'),
	(292429, 143, '2015-01-01 00:00:35.000000', 'temperatura', 1190.0000, 'ºC'),
	(292430, 143, '2015-01-01 00:00:36.000000', 'temperatura', 742.0000, 'ºC'),
	(292431, 143, '2015-01-01 00:00:37.000000', 'temperatura', 140.0000, 'ºC'),
	(292432, 143, '2015-01-01 00:00:38.000000', 'temperatura', 876.0000, 'ºC'),
	(292433, 143, '2015-01-01 00:00:39.000000', 'temperatura', 360.0000, 'ºC'),
	(292434, 143, '2015-01-01 00:00:40.000000', 'temperatura', 374.0000, 'ºC'),
	(292435, 143, '2015-01-01 00:00:41.000000', 'temperatura', 787.0000, 'ºC'),
	(292436, 143, '2015-01-01 00:00:42.000000', 'temperatura', 416.0000, 'ºC'),
	(292437, 143, '2015-01-01 00:00:43.000000', 'temperatura', 918.0000, 'ºC'),
	(292438, 143, '2015-01-01 00:00:44.000000', 'temperatura', 942.0000, 'ºC'),
	(292439, 143, '2015-01-01 00:00:45.000000', 'temperatura', 756.0000, 'ºC'),
	(292440, 143, '2015-01-01 00:00:46.000000', 'temperatura', 956.0000, 'ºC'),
	(292441, 143, '2015-01-01 00:00:47.000000', 'temperatura', 114.0000, 'ºC'),
	(292442, 143, '2015-01-01 00:00:48.000000', 'temperatura', 101.0000, 'ºC'),
	(292443, 143, '2015-01-01 00:00:49.000000', 'temperatura', 162.0000, 'ºC'),
	(292444, 143, '2015-01-01 00:00:50.000000', 'temperatura', 509.0000, 'ºC'),
	(292445, 143, '2015-01-01 00:00:51.000000', 'temperatura', 860.0000, 'ºC'),
	(292446, 143, '2015-01-01 00:00:52.000000', 'temperatura', 373.0000, 'ºC'),
	(292447, 143, '2015-01-01 00:00:53.000000', 'temperatura', 487.0000, 'ºC'),
	(292448, 143, '2015-01-01 00:00:54.000000', 'temperatura', 114.0000, 'ºC'),
	(292449, 143, '2015-01-01 00:00:55.000000', 'temperatura', 310.0000, 'ºC'),
	(292450, 143, '2015-01-01 00:00:56.000000', 'temperatura', 7.0000, 'ºC'),
	(292451, 143, '2015-01-01 00:00:57.000000', 'temperatura', 307.0000, 'ºC'),
	(292452, 143, '2015-01-01 00:00:58.000000', 'temperatura', 314.0000, 'ºC'),
	(292453, 143, '2015-01-01 00:00:59.000000', 'temperatura', 649.0000, 'ºC'),
	(292454, 143, '2015-01-01 00:01:00.000000', 'temperatura', 1106.0000, 'ºC'),
	(292455, 143, '2015-01-01 00:01:01.000000', 'temperatura', 1181.0000, 'ºC'),
	(292456, 143, '2015-01-01 00:01:02.000000', 'temperatura', 188.0000, 'ºC'),
	(292457, 143, '2015-01-01 00:01:03.000000', 'temperatura', 997.0000, 'ºC'),
	(292458, 143, '2015-01-01 00:01:04.000000', 'temperatura', 824.0000, 'ºC'),
	(292459, 143, '2015-01-01 00:01:05.000000', 'temperatura', 1128.0000, 'ºC'),
	(292460, 143, '2015-01-01 00:01:06.000000', 'temperatura', 770.0000, 'ºC'),
	(292461, 143, '2015-01-01 00:01:07.000000', 'temperatura', 466.0000, 'ºC'),
	(292462, 143, '2015-01-01 00:01:08.000000', 'temperatura', 20.0000, 'ºC'),
	(292463, 143, '2015-01-01 00:01:09.000000', 'temperatura', 1104.0000, 'ºC'),
	(292464, 143, '2015-01-01 00:01:10.000000', 'temperatura', 658.0000, 'ºC'),
	(292465, 143, '2015-01-01 00:01:11.000000', 'temperatura', 1180.0000, 'ºC'),
	(292466, 143, '2015-01-01 00:01:12.000000', 'temperatura', 326.0000, 'ºC'),
	(292467, 143, '2015-01-01 00:01:13.000000', 'temperatura', 491.0000, 'ºC'),
	(292468, 143, '2015-01-01 00:01:14.000000', 'temperatura', 277.0000, 'ºC'),
	(292469, 143, '2015-01-01 00:01:15.000000', 'temperatura', 1113.0000, 'ºC'),
	(292470, 143, '2015-01-01 00:01:16.000000', 'temperatura', 1134.0000, 'ºC'),
	(292471, 143, '2015-01-01 00:01:17.000000', 'temperatura', 1130.0000, 'ºC'),
	(292472, 143, '2015-01-01 00:01:18.000000', 'temperatura', 1050.0000, 'ºC'),
	(292473, 143, '2015-01-01 00:01:19.000000', 'temperatura', 662.0000, 'ºC'),
	(292474, 143, '2015-01-01 00:01:20.000000', 'temperatura', 158.0000, 'ºC'),
	(292475, 143, '2015-01-01 00:01:21.000000', 'temperatura', 5.0000, 'ºC'),
	(292476, 143, '2015-01-01 00:01:22.000000', 'temperatura', 751.0000, 'ºC'),
	(292477, 143, '2015-01-01 00:01:23.000000', 'temperatura', 140.0000, 'ºC'),
	(292478, 143, '2015-01-01 00:01:24.000000', 'temperatura', 847.0000, 'ºC'),
	(292479, 143, '2015-01-01 00:01:25.000000', 'temperatura', 217.0000, 'ºC'),
	(292480, 143, '2015-01-01 00:01:26.000000', 'temperatura', 946.0000, 'ºC'),
	(292481, 143, '2015-01-01 00:01:27.000000', 'temperatura', 478.0000, 'ºC'),
	(292482, 143, '2015-01-01 00:01:28.000000', 'temperatura', 753.0000, 'ºC'),
	(292483, 143, '2015-01-01 00:01:29.000000', 'temperatura', 1132.0000, 'ºC'),
	(292484, 143, '2015-01-01 00:01:30.000000', 'temperatura', 999.0000, 'ºC'),
	(292485, 143, '2015-01-01 00:01:31.000000', 'temperatura', 400.0000, 'ºC'),
	(292486, 143, '2015-01-01 00:01:32.000000', 'temperatura', 205.0000, 'ºC'),
	(292487, 143, '2015-01-01 00:01:33.000000', 'temperatura', 1025.0000, 'ºC'),
	(292488, 143, '2015-01-01 00:01:34.000000', 'temperatura', 912.0000, 'ºC'),
	(292489, 143, '2015-01-01 00:01:35.000000', 'temperatura', 285.0000, 'ºC'),
	(292490, 143, '2015-01-01 00:01:36.000000', 'temperatura', 1091.0000, 'ºC'),
	(292491, 143, '2015-01-01 00:01:37.000000', 'temperatura', 1000.0000, 'ºC'),
	(292492, 143, '2015-01-01 00:01:38.000000', 'temperatura', 525.0000, 'ºC'),
	(292493, 143, '2015-01-01 00:01:39.000000', 'temperatura', 827.0000, 'ºC'),
	(292494, 143, '2015-01-01 00:01:40.000000', 'temperatura', 159.0000, 'ºC'),
	(292495, 143, '2015-01-01 00:01:41.000000', 'temperatura', 715.0000, 'ºC'),
	(292496, 143, '2015-01-01 00:01:42.000000', 'temperatura', 700.0000, 'ºC'),
	(292497, 143, '2015-01-01 00:01:43.000000', 'temperatura', 153.0000, 'ºC'),
	(292498, 143, '2015-01-01 00:01:44.000000', 'temperatura', 1065.0000, 'ºC'),
	(292499, 143, '2015-01-01 00:01:45.000000', 'temperatura', 69.0000, 'ºC'),
	(292500, 143, '2015-01-01 00:01:46.000000', 'temperatura', 750.0000, 'ºC'),
	(292501, 143, '2015-01-01 00:01:47.000000', 'temperatura', 1144.0000, 'ºC'),
	(292502, 143, '2015-01-01 00:01:48.000000', 'temperatura', 1070.0000, 'ºC'),
	(292503, 143, '2015-01-01 00:01:49.000000', 'temperatura', 720.0000, 'ºC'),
	(292504, 143, '2015-01-01 00:01:50.000000', 'temperatura', 389.0000, 'ºC'),
	(292505, 143, '2015-01-01 00:01:51.000000', 'temperatura', 985.0000, 'ºC'),
	(292506, 143, '2015-01-01 00:01:52.000000', 'temperatura', 159.0000, 'ºC'),
	(292507, 143, '2015-01-01 00:01:53.000000', 'temperatura', 239.0000, 'ºC'),
	(292508, 143, '2015-01-01 00:01:54.000000', 'temperatura', 717.0000, 'ºC'),
	(292509, 143, '2015-01-01 00:01:55.000000', 'temperatura', 472.0000, 'ºC'),
	(292510, 143, '2015-01-01 00:01:56.000000', 'temperatura', 210.0000, 'ºC'),
	(292511, 143, '2015-01-01 00:01:57.000000', 'temperatura', 832.0000, 'ºC'),
	(292512, 143, '2015-01-01 00:01:58.000000', 'temperatura', 1130.0000, 'ºC'),
	(292513, 143, '2015-01-01 00:01:59.000000', 'temperatura', 757.0000, 'ºC'),
	(292514, 143, '2015-01-01 00:02:00.000000', 'temperatura', 396.0000, 'ºC'),
	(292515, 143, '2015-01-01 00:02:01.000000', 'temperatura', 909.0000, 'ºC'),
	(292516, 143, '2015-01-01 00:02:02.000000', 'temperatura', 956.0000, 'ºC'),
	(292517, 143, '2015-01-01 00:02:03.000000', 'temperatura', 856.0000, 'ºC'),
	(292518, 143, '2015-01-01 00:02:04.000000', 'temperatura', 212.0000, 'ºC'),
	(292519, 143, '2015-01-01 00:02:05.000000', 'temperatura', 893.0000, 'ºC'),
	(292520, 143, '2015-01-01 00:02:06.000000', 'temperatura', 230.0000, 'ºC'),
	(292521, 143, '2015-01-01 00:02:07.000000', 'temperatura', 871.0000, 'ºC'),
	(292522, 143, '2015-01-01 00:02:08.000000', 'temperatura', 67.0000, 'ºC'),
	(292523, 143, '2015-01-01 00:02:09.000000', 'temperatura', 121.0000, 'ºC'),
	(292524, 143, '2015-01-01 00:02:10.000000', 'temperatura', 406.0000, 'ºC'),
	(292525, 143, '2015-01-01 00:02:11.000000', 'temperatura', 467.0000, 'ºC'),
	(292526, 143, '2015-01-01 00:02:12.000000', 'temperatura', 1117.0000, 'ºC'),
	(292527, 143, '2015-01-01 00:02:13.000000', 'temperatura', 584.0000, 'ºC'),
	(292528, 143, '2015-01-01 00:02:14.000000', 'temperatura', 770.0000, 'ºC'),
	(292529, 143, '2015-01-01 00:02:15.000000', 'temperatura', 900.0000, 'ºC'),
	(292530, 143, '2015-01-01 00:02:16.000000', 'temperatura', 988.0000, 'ºC'),
	(292531, 143, '2015-01-01 00:02:17.000000', 'temperatura', 1042.0000, 'ºC'),
	(292532, 143, '2015-01-01 00:02:18.000000', 'temperatura', 1046.0000, 'ºC'),
	(292533, 143, '2015-01-01 00:02:19.000000', 'temperatura', 904.0000, 'ºC'),
	(292534, 143, '2015-01-01 00:02:20.000000', 'temperatura', 182.0000, 'ºC'),
	(292535, 143, '2015-01-01 00:02:21.000000', 'temperatura', 598.0000, 'ºC'),
	(292536, 143, '2015-01-01 00:02:22.000000', 'temperatura', 46.0000, 'ºC'),
	(292537, 143, '2015-01-01 00:02:23.000000', 'temperatura', 836.0000, 'ºC'),
	(292538, 143, '2015-01-01 00:02:24.000000', 'temperatura', 443.0000, 'ºC'),
	(292539, 143, '2015-01-01 00:02:25.000000', 'temperatura', 907.0000, 'ºC'),
	(292540, 143, '2015-01-01 00:02:26.000000', 'temperatura', 805.0000, 'ºC'),
	(292541, 143, '2015-01-01 00:02:27.000000', 'temperatura', 104.0000, 'ºC'),
	(292542, 143, '2015-01-01 00:02:28.000000', 'temperatura', 506.0000, 'ºC'),
	(292543, 143, '2015-01-01 00:02:29.000000', 'temperatura', 1021.0000, 'ºC'),
	(292544, 143, '2015-01-01 00:02:30.000000', 'temperatura', 1185.0000, 'ºC'),
	(292545, 143, '2015-01-01 00:02:31.000000', 'temperatura', 462.0000, 'ºC'),
	(292546, 143, '2015-01-01 00:02:32.000000', 'temperatura', 1158.0000, 'ºC'),
	(292547, 143, '2015-01-01 00:02:33.000000', 'temperatura', 801.0000, 'ºC'),
	(292548, 143, '2015-01-01 00:02:34.000000', 'temperatura', 534.0000, 'ºC'),
	(292549, 143, '2015-01-01 00:02:35.000000', 'temperatura', 269.0000, 'ºC'),
	(292550, 143, '2015-01-01 00:02:36.000000', 'temperatura', 941.0000, 'ºC'),
	(292551, 143, '2015-01-01 00:02:37.000000', 'temperatura', 300.0000, 'ºC'),
	(292552, 143, '2015-01-01 00:02:38.000000', 'temperatura', 1075.0000, 'ºC'),
	(292553, 143, '2015-01-01 00:02:39.000000', 'temperatura', 878.0000, 'ºC'),
	(292554, 143, '2015-01-01 00:02:40.000000', 'temperatura', 1165.0000, 'ºC'),
	(292555, 143, '2015-01-01 00:02:41.000000', 'temperatura', 790.0000, 'ºC'),
	(292556, 143, '2015-01-01 00:02:42.000000', 'temperatura', 458.0000, 'ºC'),
	(292557, 143, '2015-01-01 00:02:43.000000', 'temperatura', 1119.0000, 'ºC'),
	(292558, 143, '2015-01-01 00:02:44.000000', 'temperatura', 620.0000, 'ºC'),
	(292559, 143, '2015-01-01 00:02:45.000000', 'temperatura', 946.0000, 'ºC'),
	(292560, 143, '2015-01-01 00:02:46.000000', 'temperatura', 470.0000, 'ºC'),
	(292561, 143, '2015-01-01 00:02:47.000000', 'temperatura', 710.0000, 'ºC'),
	(292562, 143, '2015-01-01 00:02:48.000000', 'temperatura', 943.0000, 'ºC'),
	(292563, 143, '2015-01-01 00:02:49.000000', 'temperatura', 186.0000, 'ºC'),
	(292564, 143, '2015-01-01 00:02:50.000000', 'temperatura', 501.0000, 'ºC'),
	(292565, 143, '2015-01-01 00:02:51.000000', 'temperatura', 749.0000, 'ºC'),
	(292566, 143, '2015-01-01 00:02:52.000000', 'temperatura', 1040.0000, 'ºC'),
	(292567, 143, '2015-01-01 00:02:53.000000', 'temperatura', 555.0000, 'ºC'),
	(292568, 143, '2015-01-01 00:02:54.000000', 'temperatura', 857.0000, 'ºC'),
	(292569, 143, '2015-01-01 00:02:55.000000', 'temperatura', 220.0000, 'ºC'),
	(292570, 143, '2015-01-01 00:02:56.000000', 'temperatura', 927.0000, 'ºC'),
	(292571, 143, '2015-01-01 00:02:57.000000', 'temperatura', 378.0000, 'ºC'),
	(292572, 143, '2015-01-01 00:02:58.000000', 'temperatura', 311.0000, 'ºC'),
	(292573, 143, '2015-01-01 00:02:59.000000', 'temperatura', 419.0000, 'ºC'),
	(292574, 143, '2015-01-01 00:03:00.000000', 'temperatura', 1162.0000, 'ºC'),
	(292575, 143, '2015-01-01 00:03:01.000000', 'temperatura', 956.0000, 'ºC'),
	(292576, 143, '2015-01-01 00:03:02.000000', 'temperatura', 93.0000, 'ºC'),
	(292577, 143, '2015-01-01 00:03:03.000000', 'temperatura', 1196.0000, 'ºC'),
	(292578, 143, '2015-01-01 00:03:04.000000', 'temperatura', 904.0000, 'ºC'),
	(292579, 143, '2015-01-01 00:03:05.000000', 'temperatura', 931.0000, 'ºC'),
	(292580, 143, '2015-01-01 00:03:06.000000', 'temperatura', 743.0000, 'ºC'),
	(292581, 143, '2015-01-01 00:03:07.000000', 'temperatura', 924.0000, 'ºC'),
	(292582, 143, '2015-01-01 00:03:08.000000', 'temperatura', 1190.0000, 'ºC'),
	(292583, 143, '2015-01-01 00:03:09.000000', 'temperatura', 779.0000, 'ºC'),
	(292584, 143, '2015-01-01 00:03:10.000000', 'temperatura', 326.0000, 'ºC'),
	(292585, 143, '2015-01-01 00:03:11.000000', 'temperatura', 491.0000, 'ºC'),
	(292586, 143, '2015-01-01 00:03:12.000000', 'temperatura', 281.0000, 'ºC'),
	(292587, 143, '2015-01-01 00:03:13.000000', 'temperatura', 1131.0000, 'ºC'),
	(292588, 143, '2015-01-01 00:03:14.000000', 'temperatura', 12.0000, 'ºC'),
	(292589, 143, '2015-01-01 00:03:15.000000', 'temperatura', 269.0000, 'ºC'),
	(292590, 143, '2015-01-01 00:03:16.000000', 'temperatura', 107.0000, 'ºC'),
	(292591, 143, '2015-01-01 00:03:17.000000', 'temperatura', 928.0000, 'ºC'),
	(292592, 143, '2015-01-01 00:03:18.000000', 'temperatura', 721.0000, 'ºC'),
	(292593, 143, '2015-01-01 00:03:19.000000', 'temperatura', 821.0000, 'ºC'),
	(292594, 143, '2015-01-01 00:03:20.000000', 'temperatura', 744.0000, 'ºC'),
	(292595, 143, '2015-01-01 00:03:21.000000', 'temperatura', 57.0000, 'ºC'),
	(292596, 143, '2015-01-01 00:03:22.000000', 'temperatura', 454.0000, 'ºC'),
	(292597, 143, '2015-01-01 00:03:23.000000', 'temperatura', 898.0000, 'ºC'),
	(292598, 143, '2015-01-01 00:03:24.000000', 'temperatura', 730.0000, 'ºC'),
	(292599, 143, '2015-01-01 00:03:25.000000', 'temperatura', 954.0000, 'ºC'),
	(292600, 143, '2015-01-01 00:03:26.000000', 'temperatura', 184.0000, 'ºC'),
	(292601, 143, '2015-01-01 00:03:27.000000', 'temperatura', 456.0000, 'ºC'),
	(292602, 143, '2015-01-01 00:03:28.000000', 'temperatura', 530.0000, 'ºC'),
	(292603, 143, '2015-01-01 00:03:29.000000', 'temperatura', 82.0000, 'ºC'),
	(292604, 143, '2015-01-01 00:03:30.000000', 'temperatura', 22.0000, 'ºC'),
	(292605, 143, '2015-01-01 00:03:31.000000', 'temperatura', 1064.0000, 'ºC'),
	(292606, 143, '2015-01-01 00:03:32.000000', 'temperatura', 456.0000, 'ºC'),
	(292607, 143, '2015-01-01 00:03:33.000000', 'temperatura', 287.0000, 'ºC'),
	(292608, 143, '2015-01-01 00:03:34.000000', 'temperatura', 67.0000, 'ºC'),
	(292609, 143, '2015-01-01 00:03:35.000000', 'temperatura', 673.0000, 'ºC'),
	(292610, 143, '2015-01-01 00:03:36.000000', 'temperatura', 768.0000, 'ºC'),
	(292611, 143, '2015-01-01 00:03:37.000000', 'temperatura', 618.0000, 'ºC'),
	(292612, 143, '2015-01-01 00:03:38.000000', 'temperatura', 790.0000, 'ºC'),
	(292613, 143, '2015-01-01 00:03:39.000000', 'temperatura', 894.0000, 'ºC'),
	(292614, 143, '2015-01-01 00:03:40.000000', 'temperatura', 901.0000, 'ºC'),
	(292615, 143, '2015-01-01 00:03:41.000000', 'temperatura', 623.0000, 'ºC'),
	(292616, 143, '2015-01-01 00:03:42.000000', 'temperatura', 413.0000, 'ºC'),
	(292617, 143, '2015-01-01 00:03:43.000000', 'temperatura', 196.0000, 'ºC'),
	(292618, 143, '2015-01-01 00:03:44.000000', 'temperatura', 941.0000, 'ºC'),
	(292619, 143, '2015-01-01 00:03:45.000000', 'temperatura', 519.0000, 'ºC'),
	(292620, 143, '2015-01-01 00:03:46.000000', 'temperatura', 971.0000, 'ºC'),
	(292621, 143, '2015-01-01 00:03:47.000000', 'temperatura', 899.0000, 'ºC'),
	(292622, 143, '2015-01-01 00:03:48.000000', 'temperatura', 381.0000, 'ºC'),
	(292623, 143, '2015-01-01 00:03:49.000000', 'temperatura', 409.0000, 'ºC'),
	(292624, 143, '2015-01-01 00:03:50.000000', 'temperatura', 902.0000, 'ºC'),
	(292625, 143, '2015-01-01 00:03:51.000000', 'temperatura', 885.0000, 'ºC'),
	(292626, 143, '2015-01-01 00:03:52.000000', 'temperatura', 518.0000, 'ºC'),
	(292627, 143, '2015-01-01 00:03:53.000000', 'temperatura', 1136.0000, 'ºC'),
	(292628, 143, '2015-01-01 00:03:54.000000', 'temperatura', 527.0000, 'ºC'),
	(292629, 143, '2015-01-01 00:03:55.000000', 'temperatura', 429.0000, 'ºC'),
	(292630, 143, '2015-01-01 00:03:56.000000', 'temperatura', 565.0000, 'ºC'),
	(292631, 143, '2015-01-01 00:03:57.000000', 'temperatura', 336.0000, 'ºC'),
	(292632, 143, '2015-01-01 00:03:58.000000', 'temperatura', 1185.0000, 'ºC'),
	(292633, 143, '2015-01-01 00:03:59.000000', 'temperatura', 119.0000, 'ºC'),
	(292634, 143, '2015-01-01 00:04:00.000000', 'temperatura', 642.0000, 'ºC'),
	(292635, 143, '2015-01-01 00:04:01.000000', 'temperatura', 453.0000, 'ºC'),
	(292636, 143, '2015-01-01 00:04:02.000000', 'temperatura', 339.0000, 'ºC'),
	(292637, 143, '2015-01-01 00:04:03.000000', 'temperatura', 338.0000, 'ºC'),
	(292638, 143, '2015-01-01 00:04:04.000000', 'temperatura', 671.0000, 'ºC'),
	(292639, 143, '2015-01-01 00:04:05.000000', 'temperatura', 1141.0000, 'ºC'),
	(292640, 143, '2015-01-01 00:04:06.000000', 'temperatura', 93.0000, 'ºC'),
	(292641, 143, '2015-01-01 00:04:07.000000', 'temperatura', 644.0000, 'ºC'),
	(292642, 143, '2015-01-01 00:04:08.000000', 'temperatura', 542.0000, 'ºC'),
	(292643, 143, '2015-01-01 00:04:09.000000', 'temperatura', 779.0000, 'ºC'),
	(292644, 143, '2015-01-01 00:04:10.000000', 'temperatura', 1067.0000, 'ºC'),
	(292645, 143, '2015-01-01 00:04:11.000000', 'temperatura', 599.0000, 'ºC'),
	(292646, 143, '2015-01-01 00:04:12.000000', 'temperatura', 996.0000, 'ºC'),
	(292647, 143, '2015-01-01 00:04:13.000000', 'temperatura', 783.0000, 'ºC'),
	(292648, 143, '2015-01-01 00:04:14.000000', 'temperatura', 926.0000, 'ºC'),
	(292649, 143, '2015-01-01 00:04:15.000000', 'temperatura', 1081.0000, 'ºC'),
	(292650, 143, '2015-01-01 00:04:16.000000', 'temperatura', 230.0000, 'ºC'),
	(292651, 143, '2015-01-01 00:04:17.000000', 'temperatura', 307.0000, 'ºC'),
	(292652, 143, '2015-01-01 00:04:18.000000', 'temperatura', 845.0000, 'ºC'),
	(292653, 143, '2015-01-01 00:04:19.000000', 'temperatura', 905.0000, 'ºC'),
	(292654, 143, '2015-01-01 00:04:20.000000', 'temperatura', 790.0000, 'ºC'),
	(292655, 143, '2015-01-01 00:04:21.000000', 'temperatura', 36.0000, 'ºC'),
	(292656, 143, '2015-01-01 00:04:22.000000', 'temperatura', 211.0000, 'ºC'),
	(292657, 143, '2015-01-01 00:04:23.000000', 'temperatura', 947.0000, 'ºC'),
	(292658, 143, '2015-01-01 00:04:24.000000', 'temperatura', 503.0000, 'ºC'),
	(292659, 143, '2015-01-01 00:04:25.000000', 'temperatura', 875.0000, 'ºC'),
	(292660, 143, '2015-01-01 00:04:26.000000', 'temperatura', 468.0000, 'ºC'),
	(292661, 143, '2015-01-01 00:04:27.000000', 'temperatura', 914.0000, 'ºC'),
	(292662, 143, '2015-01-01 00:04:28.000000', 'temperatura', 765.0000, 'ºC'),
	(292663, 143, '2015-01-01 00:04:29.000000', 'temperatura', 1083.0000, 'ºC'),
	(292664, 143, '2015-01-01 00:04:30.000000', 'temperatura', 720.0000, 'ºC'),
	(292665, 143, '2015-01-01 00:04:31.000000', 'temperatura', 352.0000, 'ºC'),
	(292666, 143, '2015-01-01 00:04:32.000000', 'temperatura', 800.0000, 'ºC'),
	(292667, 143, '2015-01-01 00:04:33.000000', 'temperatura', 545.0000, 'ºC'),
	(292668, 143, '2015-01-01 00:04:34.000000', 'temperatura', 324.0000, 'ºC'),
	(292669, 143, '2015-01-01 00:04:35.000000', 'temperatura', 1188.0000, 'ºC'),
	(292670, 143, '2015-01-01 00:04:36.000000', 'temperatura', 169.0000, 'ºC'),
	(292671, 143, '2015-01-01 00:04:37.000000', 'temperatura', 882.0000, 'ºC'),
	(292672, 143, '2015-01-01 00:04:38.000000', 'temperatura', 302.0000, 'ºC'),
	(292673, 143, '2015-01-01 00:04:39.000000', 'temperatura', 64.0000, 'ºC'),
	(292674, 143, '2015-01-01 00:04:40.000000', 'temperatura', 615.0000, 'ºC'),
	(292675, 143, '2015-01-01 00:04:41.000000', 'temperatura', 485.0000, 'ºC'),
	(292676, 143, '2015-01-01 00:04:42.000000', 'temperatura', 579.0000, 'ºC'),
	(292677, 143, '2015-01-01 00:04:43.000000', 'temperatura', 241.0000, 'ºC'),
	(292678, 143, '2015-01-01 00:04:44.000000', 'temperatura', 669.0000, 'ºC'),
	(292679, 143, '2015-01-01 00:04:45.000000', 'temperatura', 220.0000, 'ºC'),
	(292680, 143, '2015-01-01 00:04:46.000000', 'temperatura', 295.0000, 'ºC'),
	(292681, 143, '2015-01-01 00:04:47.000000', 'temperatura', 817.0000, 'ºC'),
	(292682, 143, '2015-01-01 00:04:48.000000', 'temperatura', 798.0000, 'ºC'),
	(292683, 143, '2015-01-01 00:04:49.000000', 'temperatura', 339.0000, 'ºC'),
	(292684, 143, '2015-01-01 00:04:50.000000', 'temperatura', 503.0000, 'ºC'),
	(292685, 143, '2015-01-01 00:04:51.000000', 'temperatura', 298.0000, 'ºC'),
	(292686, 143, '2015-01-01 00:04:52.000000', 'temperatura', 1180.0000, 'ºC'),
	(292687, 143, '2015-01-01 00:04:53.000000', 'temperatura', 209.0000, 'ºC'),
	(292688, 143, '2015-01-01 00:04:54.000000', 'temperatura', 1104.0000, 'ºC'),
	(292689, 143, '2015-01-01 00:04:55.000000', 'temperatura', 92.0000, 'ºC'),
	(292690, 143, '2015-01-01 00:04:56.000000', 'temperatura', 750.0000, 'ºC'),
	(292691, 143, '2015-01-01 00:04:57.000000', 'temperatura', 1074.0000, 'ºC'),
	(292692, 143, '2015-01-01 00:04:58.000000', 'temperatura', 723.0000, 'ºC'),
	(292693, 143, '2015-01-01 00:04:59.000000', 'temperatura', 391.0000, 'ºC'),
	(292694, 143, '2015-01-01 00:05:00.000000', 'temperatura', 986.0000, 'ºC'),
	(292695, 143, '2015-01-01 00:05:01.000000', 'temperatura', 159.0000, 'ºC'),
	(292696, 143, '2015-01-01 00:05:02.000000', 'temperatura', 238.0000, 'ºC'),
	(292697, 143, '2015-01-01 00:05:03.000000', 'temperatura', 713.0000, 'ºC'),
	(292698, 143, '2015-01-01 00:05:04.000000', 'temperatura', 451.0000, 'ºC'),
	(292699, 143, '2015-01-01 00:05:05.000000', 'temperatura', 116.0000, 'ºC'),
	(292700, 143, '2015-01-01 00:05:06.000000', 'temperatura', 430.0000, 'ºC'),
	(292701, 143, '2015-01-01 00:05:07.000000', 'temperatura', 601.0000, 'ºC'),
	(292702, 143, '2015-01-01 00:05:08.000000', 'temperatura', 515.0000, 'ºC'),
	(292703, 143, '2015-01-01 00:05:09.000000', 'temperatura', 772.0000, 'ºC'),
	(292704, 143, '2015-01-01 00:05:10.000000', 'temperatura', 1118.0000, 'ºC'),
	(292705, 143, '2015-01-01 00:05:11.000000', 'temperatura', 873.0000, 'ºC'),
	(292706, 143, '2015-01-01 00:05:12.000000', 'temperatura', 1010.0000, 'ºC'),
	(292707, 143, '2015-01-01 00:05:13.000000', 'temperatura', 34.0000, 'ºC'),
	(292708, 143, '2015-01-01 00:05:14.000000', 'temperatura', 741.0000, 'ºC'),
	(292709, 143, '2015-01-01 00:05:15.000000', 'temperatura', 4.0000, 'ºC'),
	(292710, 143, '2015-01-01 00:05:16.000000', 'temperatura', 197.0000, 'ºC'),
	(292711, 143, '2015-01-01 00:05:17.000000', 'temperatura', 975.0000, 'ºC'),
	(292712, 143, '2015-01-01 00:05:18.000000', 'temperatura', 683.0000, 'ºC'),
	(292713, 143, '2015-01-01 00:05:19.000000', 'temperatura', 489.0000, 'ºC'),
	(292714, 143, '2015-01-01 00:05:20.000000', 'temperatura', 399.0000, 'ºC'),
	(292715, 143, '2015-01-01 00:05:21.000000', 'temperatura', 528.0000, 'ºC'),
	(292716, 143, '2015-01-01 00:05:22.000000', 'temperatura', 244.0000, 'ºC'),
	(292717, 143, '2015-01-01 00:05:23.000000', 'temperatura', 834.0000, 'ºC'),
	(292718, 143, '2015-01-01 00:05:24.000000', 'temperatura', 1041.0000, 'ºC'),
	(292719, 143, '2015-01-01 00:05:25.000000', 'temperatura', 301.0000, 'ºC'),
	(292720, 143, '2015-01-01 00:05:26.000000', 'temperatura', 786.0000, 'ºC'),
	(292721, 143, '2015-01-01 00:05:27.000000', 'temperatura', 624.0000, 'ºC'),
	(292722, 143, '2015-01-01 00:05:28.000000', 'temperatura', 765.0000, 'ºC'),
	(292723, 143, '2015-01-01 00:05:29.000000', 'temperatura', 755.0000, 'ºC'),
	(292724, 143, '2015-01-01 00:05:30.000000', 'temperatura', 277.0000, 'ºC'),
	(292725, 143, '2015-01-01 00:05:31.000000', 'temperatura', 323.0000, 'ºC'),
	(292726, 143, '2015-01-01 00:05:32.000000', 'temperatura', 786.0000, 'ºC'),
	(292727, 143, '2015-01-01 00:05:33.000000', 'temperatura', 559.0000, 'ºC'),
	(292728, 143, '2015-01-01 00:05:34.000000', 'temperatura', 436.0000, 'ºC'),
	(292729, 143, '2015-01-01 00:05:35.000000', 'temperatura', 507.0000, 'ºC'),
	(292730, 143, '2015-01-01 00:05:36.000000', 'temperatura', 25.0000, 'ºC'),
	(292731, 143, '2015-01-01 00:05:37.000000', 'temperatura', 1004.0000, 'ºC'),
	(292732, 143, '2015-01-01 00:05:38.000000', 'temperatura', 146.0000, 'ºC'),
	(292733, 143, '2015-01-01 00:05:39.000000', 'temperatura', 118.0000, 'ºC'),
	(292734, 143, '2015-01-01 00:05:40.000000', 'temperatura', 151.0000, 'ºC'),
	(292735, 143, '2015-01-01 00:05:41.000000', 'temperatura', 404.0000, 'ºC'),
	(292736, 143, '2015-01-01 00:05:42.000000', 'temperatura', 367.0000, 'ºC'),
	(292737, 143, '2015-01-01 00:05:43.000000', 'temperatura', 622.0000, 'ºC'),
	(292738, 143, '2015-01-01 00:05:44.000000', 'temperatura', 811.0000, 'ºC'),
	(292739, 143, '2015-01-01 00:05:45.000000', 'temperatura', 988.0000, 'ºC'),
	(292740, 143, '2015-01-01 00:05:46.000000', 'temperatura', 107.0000, 'ºC'),
	(292741, 143, '2015-01-01 00:05:47.000000', 'temperatura', 1173.0000, 'ºC'),
	(292742, 143, '2015-01-01 00:05:48.000000', 'temperatura', 745.0000, 'ºC'),
	(292743, 143, '2015-01-01 00:05:49.000000', 'temperatura', 204.0000, 'ºC'),
	(292744, 143, '2015-01-01 00:05:50.000000', 'temperatura', 1187.0000, 'ºC'),
	(292745, 143, '2015-01-01 00:05:51.000000', 'temperatura', 522.0000, 'ºC'),
	(292746, 143, '2015-01-01 00:05:52.000000', 'temperatura', 249.0000, 'ºC'),
	(292747, 143, '2015-01-01 00:05:53.000000', 'temperatura', 880.0000, 'ºC'),
	(292748, 143, '2015-01-01 00:05:54.000000', 'temperatura', 56.0000, 'ºC'),
	(292749, 143, '2015-01-01 00:05:55.000000', 'temperatura', 38.0000, 'ºC'),
	(292750, 143, '2015-01-01 00:05:56.000000', 'temperatura', 22.0000, 'ºC'),
	(292751, 143, '2015-01-01 00:05:57.000000', 'temperatura', 1197.0000, 'ºC'),
	(292752, 143, '2015-01-01 00:05:58.000000', 'temperatura', 1120.0000, 'ºC'),
	(292753, 143, '2015-01-01 00:05:59.000000', 'temperatura', 809.0000, 'ºC'),
	(292754, 143, '2015-01-01 00:06:00.000000', 'temperatura', 687.0000, 'ºC'),
	(292755, 143, '2015-01-01 00:06:01.000000', 'temperatura', 1009.0000, 'ºC'),
	(292756, 143, '2015-01-01 00:06:02.000000', 'temperatura', 585.0000, 'ºC'),
	(292757, 143, '2015-01-01 00:06:03.000000', 'temperatura', 1098.0000, 'ºC'),
	(292758, 143, '2015-01-01 00:06:04.000000', 'temperatura', 137.0000, 'ºC'),
	(292759, 143, '2015-01-01 00:06:05.000000', 'temperatura', 990.0000, 'ºC'),
	(292760, 143, '2015-01-01 00:06:06.000000', 'temperatura', 941.0000, 'ºC'),
	(292761, 143, '2015-01-01 00:06:07.000000', 'temperatura', 534.0000, 'ºC'),
	(292762, 143, '2015-01-01 00:06:08.000000', 'temperatura', 1048.0000, 'ºC'),
	(292763, 143, '2015-01-01 00:06:09.000000', 'temperatura', 39.0000, 'ºC'),
	(292764, 143, '2015-01-01 00:06:10.000000', 'temperatura', 651.0000, 'ºC'),
	(292765, 143, '2015-01-01 00:06:11.000000', 'temperatura', 736.0000, 'ºC'),
	(292766, 143, '2015-01-01 00:06:12.000000', 'temperatura', 531.0000, 'ºC'),
	(292767, 143, '2015-01-01 00:06:13.000000', 'temperatura', 447.0000, 'ºC'),
	(292768, 143, '2015-01-01 00:06:14.000000', 'temperatura', 643.0000, 'ºC'),
	(292769, 143, '2015-01-01 00:06:15.000000', 'temperatura', 674.0000, 'ºC'),
	(292770, 143, '2015-01-01 00:06:16.000000', 'temperatura', 242.0000, 'ºC'),
	(292771, 143, '2015-01-01 00:06:17.000000', 'temperatura', 389.0000, 'ºC'),
	(292772, 143, '2015-01-01 00:06:18.000000', 'temperatura', 17.0000, 'ºC'),
	(292773, 143, '2015-01-01 00:06:19.000000', 'temperatura', 119.0000, 'ºC'),
	(292774, 143, '2015-01-01 00:06:20.000000', 'temperatura', 544.0000, 'ºC'),
	(292775, 143, '2015-01-01 00:06:21.000000', 'temperatura', 1163.0000, 'ºC'),
	(292776, 143, '2015-01-01 00:06:22.000000', 'temperatura', 583.0000, 'ºC'),
	(292777, 143, '2015-01-01 00:06:23.000000', 'temperatura', 629.0000, 'ºC'),
	(292778, 143, '2015-01-01 00:06:24.000000', 'temperatura', 197.0000, 'ºC'),
	(292779, 143, '2015-01-01 00:06:25.000000', 'temperatura', 296.0000, 'ºC'),
	(292780, 143, '2015-01-01 00:06:26.000000', 'temperatura', 890.0000, 'ºC'),
	(292781, 143, '2015-01-01 00:06:27.000000', 'temperatura', 1163.0000, 'ºC'),
	(292782, 143, '2015-01-01 00:06:28.000000', 'temperatura', 745.0000, 'ºC'),
	(292783, 143, '2015-01-01 00:06:29.000000', 'temperatura', 237.0000, 'ºC'),
	(292784, 143, '2015-01-01 00:06:30.000000', 'temperatura', 149.0000, 'ºC'),
	(292785, 143, '2015-01-01 00:06:31.000000', 'temperatura', 34.0000, 'ºC'),
	(292786, 143, '2015-01-01 00:06:32.000000', 'temperatura', 925.0000, 'ºC'),
	(292787, 143, '2015-01-01 00:06:33.000000', 'temperatura', 924.0000, 'ºC'),
	(292788, 143, '2015-01-01 00:06:34.000000', 'temperatura', 644.0000, 'ºC'),
	(292789, 143, '2015-01-01 00:06:35.000000', 'temperatura', 451.0000, 'ºC'),
	(292790, 143, '2015-01-01 00:06:36.000000', 'temperatura', 322.0000, 'ºC'),
	(292791, 143, '2015-01-01 00:06:37.000000', 'temperatura', 258.0000, 'ºC'),
	(292792, 143, '2015-01-01 00:06:38.000000', 'temperatura', 325.0000, 'ºC'),
	(292793, 143, '2015-01-01 00:06:39.000000', 'temperatura', 850.0000, 'ºC'),
	(292794, 143, '2015-01-01 00:06:40.000000', 'temperatura', 876.0000, 'ºC'),
	(292795, 143, '2015-01-01 00:06:41.000000', 'temperatura', 630.0000, 'ºC'),
	(292796, 143, '2015-01-01 00:06:42.000000', 'temperatura', 521.0000, 'ºC'),
	(292797, 143, '2015-01-01 00:06:43.000000', 'temperatura', 716.0000, 'ºC'),
	(292798, 143, '2015-01-01 00:06:44.000000', 'temperatura', 819.0000, 'ºC'),
	(292799, 143, '2015-01-01 00:06:45.000000', 'temperatura', 748.0000, 'ºC'),
	(292800, 143, '2015-01-01 00:06:46.000000', 'temperatura', 83.0000, 'ºC'),
	(292801, 143, '2015-01-01 00:06:47.000000', 'temperatura', 571.0000, 'ºC'),
	(292802, 143, '2015-01-01 00:06:48.000000', 'temperatura', 207.0000, 'ºC'),
	(292803, 143, '2015-01-01 00:06:49.000000', 'temperatura', 521.0000, 'ºC'),
	(292804, 143, '2015-01-01 00:06:50.000000', 'temperatura', 784.0000, 'ºC'),
	(292805, 143, '2015-01-01 00:06:51.000000', 'temperatura', 1160.0000, 'ºC'),
	(292806, 143, '2015-01-01 00:06:52.000000', 'temperatura', 1047.0000, 'ºC'),
	(292807, 143, '2015-01-01 00:06:53.000000', 'temperatura', 554.0000, 'ºC'),
	(292808, 143, '2015-01-01 00:06:54.000000', 'temperatura', 833.0000, 'ºC'),
	(292809, 143, '2015-01-01 00:06:55.000000', 'temperatura', 100.0000, 'ºC'),
	(292810, 143, '2015-01-01 00:06:56.000000', 'temperatura', 405.0000, 'ºC'),
	(292811, 143, '2015-01-01 00:06:57.000000', 'temperatura', 524.0000, 'ºC'),
	(292812, 143, '2015-01-01 00:06:58.000000', 'temperatura', 205.0000, 'ºC'),
	(292813, 143, '2015-01-01 00:06:59.000000', 'temperatura', 655.0000, 'ºC'),
	(292814, 143, '2015-01-01 00:07:00.000000', 'temperatura', 262.0000, 'ºC'),
	(292815, 143, '2015-01-01 00:07:01.000000', 'temperatura', 542.0000, 'ºC'),
	(292816, 143, '2015-01-01 00:07:02.000000', 'temperatura', 726.0000, 'ºC'),
	(292817, 143, '2015-01-01 00:07:03.000000', 'temperatura', 805.0000, 'ºC'),
	(292818, 143, '2015-01-01 00:07:04.000000', 'temperatura', 646.0000, 'ºC'),
	(292819, 143, '2015-01-01 00:07:05.000000', 'temperatura', 816.0000, 'ºC'),
	(292820, 143, '2015-01-01 00:07:06.000000', 'temperatura', 942.0000, 'ºC'),
	(292821, 143, '2015-01-01 00:07:07.000000', 'temperatura', 1062.0000, 'ºC'),
	(292822, 143, '2015-01-01 00:07:08.000000', 'temperatura', 87.0000, 'ºC'),
	(292823, 143, '2015-01-01 00:07:09.000000', 'temperatura', 848.0000, 'ºC'),
	(292824, 143, '2015-01-01 00:07:10.000000', 'temperatura', 381.0000, 'ºC'),
	(292825, 143, '2015-01-01 00:07:11.000000', 'temperatura', 559.0000, 'ºC'),
	(292826, 143, '2015-01-01 00:07:12.000000', 'temperatura', 452.0000, 'ºC'),
	(292827, 143, '2015-01-01 00:07:13.000000', 'temperatura', 586.0000, 'ºC'),
	(292828, 143, '2015-01-01 00:07:14.000000', 'temperatura', 374.0000, 'ºC'),
	(292829, 143, '2015-01-01 00:07:15.000000', 'temperatura', 111.0000, 'ºC'),
	(292830, 143, '2015-01-01 00:07:16.000000', 'temperatura', 635.0000, 'ºC'),
	(292831, 143, '2015-01-01 00:07:17.000000', 'temperatura', 443.0000, 'ºC'),
	(292832, 143, '2015-01-01 00:07:18.000000', 'temperatura', 310.0000, 'ºC'),
	(292833, 143, '2015-01-01 00:07:19.000000', 'temperatura', 220.0000, 'ºC'),
	(292834, 143, '2015-01-01 00:07:20.000000', 'temperatura', 171.0000, 'ºC'),
	(292835, 143, '2015-01-01 00:07:21.000000', 'temperatura', 196.0000, 'ºC'),
	(292836, 143, '2015-01-01 00:07:22.000000', 'temperatura', 466.0000, 'ºC'),
	(292837, 143, '2015-01-01 00:07:23.000000', 'temperatura', 544.0000, 'ºC'),
	(292838, 143, '2015-01-01 00:07:24.000000', 'temperatura', 124.0000, 'ºC'),
	(292839, 143, '2015-01-01 00:07:25.000000', 'temperatura', 186.0000, 'ºC'),
	(292840, 143, '2015-01-01 00:07:26.000000', 'temperatura', 561.0000, 'ºC'),
	(292841, 143, '2015-01-01 00:07:27.000000', 'temperatura', 1047.0000, 'ºC'),
	(292842, 143, '2015-01-01 00:07:28.000000', 'temperatura', 1152.0000, 'ºC'),
	(292843, 143, '2015-01-01 00:07:29.000000', 'temperatura', 220.0000, 'ºC'),
	(292844, 143, '2015-01-01 00:07:30.000000', 'temperatura', 44.0000, 'ºC'),
	(292845, 143, '2015-01-01 00:07:31.000000', 'temperatura', 762.0000, 'ºC'),
	(292846, 143, '2015-01-01 00:07:32.000000', 'temperatura', 78.0000, 'ºC'),
	(292847, 143, '2015-01-01 00:07:33.000000', 'temperatura', 504.0000, 'ºC'),
	(292848, 143, '2015-01-01 00:07:34.000000', 'temperatura', 1087.0000, 'ºC'),
	(292849, 143, '2015-01-01 00:07:35.000000', 'temperatura', 323.0000, 'ºC'),
	(292850, 143, '2015-01-01 00:07:36.000000', 'temperatura', 755.0000, 'ºC'),
	(292851, 143, '2015-01-01 00:07:37.000000', 'temperatura', 405.0000, 'ºC'),
	(292852, 143, '2015-01-01 00:07:38.000000', 'temperatura', 961.0000, 'ºC'),
	(292853, 143, '2015-01-01 00:07:39.000000', 'temperatura', 1190.0000, 'ºC'),
	(292854, 143, '2015-01-01 00:07:40.000000', 'temperatura', 667.0000, 'ºC'),
	(292855, 143, '2015-01-01 00:07:41.000000', 'temperatura', 965.0000, 'ºC'),
	(292856, 143, '2015-01-01 00:07:42.000000', 'temperatura', 427.0000, 'ºC'),
	(292857, 143, '2015-01-01 00:07:43.000000', 'temperatura', 438.0000, 'ºC'),
	(292858, 143, '2015-01-01 00:07:44.000000', 'temperatura', 912.0000, 'ºC'),
	(292859, 143, '2015-01-01 00:07:45.000000', 'temperatura', 844.0000, 'ºC'),
	(292860, 143, '2015-01-01 00:07:46.000000', 'temperatura', 286.0000, 'ºC'),
	(292861, 143, '2015-01-01 00:07:47.000000', 'temperatura', 98.0000, 'ºC'),
	(292862, 143, '2015-01-01 00:07:48.000000', 'temperatura', 834.0000, 'ºC'),
	(292863, 143, '2015-01-01 00:07:49.000000', 'temperatura', 275.0000, 'ºC'),
	(292864, 143, '2015-01-01 00:07:50.000000', 'temperatura', 75.0000, 'ºC'),
	(292865, 143, '2015-01-01 00:07:51.000000', 'temperatura', 748.0000, 'ºC'),
	(292866, 143, '2015-01-01 00:07:52.000000', 'temperatura', 1116.0000, 'ºC'),
	(292867, 143, '2015-01-01 00:07:53.000000', 'temperatura', 939.0000, 'ºC'),
	(292868, 143, '2015-01-01 00:07:54.000000', 'temperatura', 144.0000, 'ºC'),
	(292869, 143, '2015-01-01 00:07:55.000000', 'temperatura', 306.0000, 'ºC'),
	(292870, 143, '2015-01-01 00:07:56.000000', 'temperatura', 1099.0000, 'ºC'),
	(292871, 143, '2015-01-01 00:07:57.000000', 'temperatura', 976.0000, 'ºC'),
	(292872, 143, '2015-01-01 00:07:58.000000', 'temperatura', 386.0000, 'ºC'),
	(292873, 143, '2015-01-01 00:07:59.000000', 'temperatura', 199.0000, 'ºC'),
	(292874, 143, '2015-01-01 00:08:00.000000', 'temperatura', 1039.0000, 'ºC'),
	(292875, 143, '2015-01-01 00:08:01.000000', 'temperatura', 999.0000, 'ºC'),
	(292876, 143, '2015-01-01 00:08:02.000000', 'temperatura', 678.0000, 'ºC'),
	(292877, 143, '2015-01-01 00:08:03.000000', 'temperatura', 393.0000, 'ºC'),
	(292878, 143, '2015-01-01 00:08:04.000000', 'temperatura', 1132.0000, 'ºC'),
	(292879, 143, '2015-01-01 00:08:05.000000', 'temperatura', 883.0000, 'ºC'),
	(292880, 143, '2015-01-01 00:08:06.000000', 'temperatura', 1019.0000, 'ºC'),
	(292881, 143, '2015-01-01 00:08:07.000000', 'temperatura', 45.0000, 'ºC'),
	(292882, 143, '2015-01-01 00:08:08.000000', 'temperatura', 767.0000, 'ºC'),
	(292883, 143, '2015-01-01 00:08:09.000000', 'temperatura', 104.0000, 'ºC'),
	(292884, 143, '2015-01-01 00:08:10.000000', 'temperatura', 618.0000, 'ºC'),
	(292885, 143, '2015-01-01 00:08:11.000000', 'temperatura', 379.0000, 'ºC'),
	(292886, 143, '2015-01-01 00:08:12.000000', 'temperatura', 43.0000, 'ºC'),
	(292887, 143, '2015-01-01 00:08:13.000000', 'temperatura', 276.0000, 'ºC'),
	(292888, 143, '2015-01-01 00:08:14.000000', 'temperatura', 51.0000, 'ºC'),
	(292889, 143, '2015-01-01 00:08:15.000000', 'temperatura', 627.0000, 'ºC'),
	(292890, 143, '2015-01-01 00:08:16.000000', 'temperatura', 585.0000, 'ºC'),
	(292891, 143, '2015-01-01 00:08:17.000000', 'temperatura', 1045.0000, 'ºC'),
	(292892, 143, '2015-01-01 00:08:18.000000', 'temperatura', 1071.0000, 'ºC'),
	(292893, 143, '2015-01-01 00:08:19.000000', 'temperatura', 1021.0000, 'ºC'),
	(292894, 143, '2015-01-01 00:08:20.000000', 'temperatura', 691.0000, 'ºC'),
	(292895, 143, '2015-01-01 00:08:21.000000', 'temperatura', 391.0000, 'ºC'),
	(292896, 143, '2015-01-01 00:08:22.000000', 'temperatura', 1085.0000, 'ºC'),
	(292897, 143, '2015-01-01 00:08:23.000000', 'temperatura', 651.0000, 'ºC'),
	(292898, 143, '2015-01-01 00:08:24.000000', 'temperatura', 1199.0000, 'ºC'),
	(292899, 143, '2015-01-01 00:08:25.000000', 'temperatura', 446.0000, 'ºC'),
	(292900, 143, '2015-01-01 00:08:26.000000', 'temperatura', 1031.0000, 'ºC'),
	(292901, 143, '2015-01-01 00:08:27.000000', 'temperatura', 216.0000, 'ºC'),
	(292902, 143, '2015-01-01 00:08:28.000000', 'temperatura', 389.0000, 'ºC'),
	(292903, 143, '2015-01-01 00:08:29.000000', 'temperatura', 100.0000, 'ºC'),
	(292904, 143, '2015-01-01 00:08:30.000000', 'temperatura', 530.0000, 'ºC'),
	(292905, 143, '2015-01-01 00:08:31.000000', 'temperatura', 1152.0000, 'ºC'),
	(292906, 143, '2015-01-01 00:08:32.000000', 'temperatura', 571.0000, 'ºC'),
	(292907, 143, '2015-01-01 00:08:33.000000', 'temperatura', 597.0000, 'ºC'),
	(292908, 143, '2015-01-01 00:08:34.000000', 'temperatura', 74.0000, 'ºC'),
	(292909, 143, '2015-01-01 00:08:35.000000', 'temperatura', 982.0000, 'ºC'),
	(292910, 143, '2015-01-01 00:08:36.000000', 'temperatura', 1085.0000, 'ºC'),
	(292911, 143, '2015-01-01 00:08:37.000000', 'temperatura', 80.0000, 'ºC'),
	(292912, 143, '2015-01-01 00:08:38.000000', 'temperatura', 745.0000, 'ºC'),
	(292913, 143, '2015-01-01 00:08:39.000000', 'temperatura', 1084.0000, 'ºC'),
	(292914, 143, '2015-01-01 00:08:40.000000', 'temperatura', 788.0000, 'ºC'),
	(292915, 143, '2015-01-01 00:08:41.000000', 'temperatura', 687.0000, 'ºC'),
	(292916, 143, '2015-01-01 00:08:42.000000', 'temperatura', 1073.0000, 'ºC'),
	(292917, 143, '2015-01-01 00:08:43.000000', 'temperatura', 906.0000, 'ºC'),
	(292918, 143, '2015-01-01 00:08:44.000000', 'temperatura', 109.0000, 'ºC'),
	(292919, 143, '2015-01-01 00:08:45.000000', 'temperatura', 226.0000, 'ºC'),
	(292920, 143, '2015-01-01 00:08:46.000000', 'temperatura', 806.0000, 'ºC'),
	(292921, 143, '2015-01-01 00:08:47.000000', 'temperatura', 953.0000, 'ºC'),
	(292922, 143, '2015-01-01 00:08:48.000000', 'temperatura', 1145.0000, 'ºC'),
	(292923, 143, '2015-01-01 00:08:49.000000', 'temperatura', 469.0000, 'ºC'),
	(292924, 143, '2015-01-01 00:08:50.000000', 'temperatura', 111.0000, 'ºC'),
	(292925, 143, '2015-01-01 00:08:51.000000', 'temperatura', 349.0000, 'ºC'),
	(292926, 143, '2015-01-01 00:08:52.000000', 'temperatura', 212.0000, 'ºC'),
	(292927, 143, '2015-01-01 00:08:53.000000', 'temperatura', 12.0000, 'ºC'),
	(292928, 143, '2015-01-01 00:08:54.000000', 'temperatura', 625.0000, 'ºC'),
	(292929, 143, '2015-01-01 00:08:55.000000', 'temperatura', 692.0000, 'ºC'),
	(292930, 143, '2015-01-01 00:08:56.000000', 'temperatura', 383.0000, 'ºC'),
	(292931, 143, '2015-01-01 00:08:57.000000', 'temperatura', 1040.0000, 'ºC'),
	(292932, 143, '2015-01-01 00:08:58.000000', 'temperatura', 451.0000, 'ºC'),
	(292933, 143, '2015-01-01 00:08:59.000000', 'temperatura', 337.0000, 'ºC'),
	(292934, 143, '2015-01-01 00:09:00.000000', 'temperatura', 330.0000, 'ºC'),
	(292935, 143, '2015-01-01 00:09:01.000000', 'temperatura', 641.0000, 'ºC'),
	(292936, 143, '2015-01-01 00:09:02.000000', 'temperatura', 1016.0000, 'ºC'),
	(292937, 143, '2015-01-01 00:09:03.000000', 'temperatura', 756.0000, 'ºC'),
	(292938, 143, '2015-01-01 00:09:04.000000', 'temperatura', 733.0000, 'ºC'),
	(292939, 143, '2015-01-01 00:09:05.000000', 'temperatura', 197.0000, 'ºC'),
	(292940, 143, '2015-01-01 00:09:06.000000', 'temperatura', 1187.0000, 'ºC'),
	(292941, 143, '2015-01-01 00:09:07.000000', 'temperatura', 544.0000, 'ºC'),
	(292942, 143, '2015-01-01 00:09:08.000000', 'temperatura', 360.0000, 'ºC'),
	(292943, 143, '2015-01-01 00:09:09.000000', 'temperatura', 167.0000, 'ºC'),
	(292944, 143, '2015-01-01 00:09:10.000000', 'temperatura', 958.0000, 'ºC'),
	(292945, 143, '2015-01-01 00:09:11.000000', 'temperatura', 689.0000, 'ºC'),
	(292946, 143, '2015-01-01 00:09:12.000000', 'temperatura', 572.0000, 'ºC'),
	(292947, 143, '2015-01-01 00:09:13.000000', 'temperatura', 793.0000, 'ºC'),
	(292948, 143, '2015-01-01 00:09:14.000000', 'temperatura', 1048.0000, 'ºC'),
	(292949, 143, '2015-01-01 00:09:15.000000', 'temperatura', 461.0000, 'ºC'),
	(292950, 143, '2015-01-01 00:09:16.000000', 'temperatura', 361.0000, 'ºC'),
	(292951, 143, '2015-01-01 00:09:17.000000', 'temperatura', 424.0000, 'ºC'),
	(292952, 143, '2015-01-01 00:09:18.000000', 'temperatura', 1037.0000, 'ºC'),
	(292953, 143, '2015-01-01 00:09:19.000000', 'temperatura', 312.0000, 'ºC'),
	(292954, 143, '2015-01-01 00:09:20.000000', 'temperatura', 853.0000, 'ºC'),
	(292955, 143, '2015-01-01 00:09:21.000000', 'temperatura', 926.0000, 'ºC'),
	(292956, 143, '2015-01-01 00:09:22.000000', 'temperatura', 874.0000, 'ºC'),
	(292957, 143, '2015-01-01 00:09:23.000000', 'temperatura', 390.0000, 'ºC'),
	(292958, 143, '2015-01-01 00:09:24.000000', 'temperatura', 531.0000, 'ºC'),
	(292959, 143, '2015-01-01 00:09:25.000000', 'temperatura', 286.0000, 'ºC'),
	(292960, 143, '2015-01-01 00:09:26.000000', 'temperatura', 1036.0000, 'ºC'),
	(292961, 143, '2015-01-01 00:09:27.000000', 'temperatura', 722.0000, 'ºC'),
	(292962, 143, '2015-01-01 00:09:28.000000', 'temperatura', 505.0000, 'ºC'),
	(292963, 143, '2015-01-01 00:09:29.000000', 'temperatura', 358.0000, 'ºC'),
	(292964, 143, '2015-01-01 00:09:30.000000', 'temperatura', 278.0000, 'ºC'),
	(292965, 143, '2015-01-01 00:09:31.000000', 'temperatura', 313.0000, 'ºC'),
	(292966, 143, '2015-01-01 00:09:32.000000', 'temperatura', 733.0000, 'ºC'),
	(292967, 143, '2015-01-01 00:09:33.000000', 'temperatura', 326.0000, 'ºC'),
	(292968, 143, '2015-01-01 00:09:34.000000', 'temperatura', 631.0000, 'ºC'),
	(292969, 143, '2015-01-01 00:09:35.000000', 'temperatura', 979.0000, 'ºC'),
	(292970, 143, '2015-01-01 00:09:36.000000', 'temperatura', 604.0000, 'ºC'),
	(292971, 143, '2015-01-01 00:09:37.000000', 'temperatura', 80.0000, 'ºC'),
	(292972, 143, '2015-01-01 00:09:38.000000', 'temperatura', 990.0000, 'ºC'),
	(292973, 143, '2015-01-01 00:09:39.000000', 'temperatura', 1109.0000, 'ºC'),
	(292974, 143, '2015-01-01 00:09:40.000000', 'temperatura', 175.0000, 'ºC'),
	(292975, 143, '2015-01-01 00:09:41.000000', 'temperatura', 1149.0000, 'ºC'),
	(292976, 143, '2015-01-01 00:09:42.000000', 'temperatura', 423.0000, 'ºC'),
	(292977, 143, '2015-01-01 00:09:43.000000', 'temperatura', 1067.0000, 'ºC'),
	(292978, 143, '2015-01-01 00:09:44.000000', 'temperatura', 464.0000, 'ºC'),
	(292979, 143, '2015-01-01 00:09:45.000000', 'temperatura', 323.0000, 'ºC'),
	(292980, 143, '2015-01-01 00:09:46.000000', 'temperatura', 224.0000, 'ºC'),
	(292981, 143, '2015-01-01 00:09:47.000000', 'temperatura', 149.0000, 'ºC'),
	(292982, 143, '2015-01-01 00:09:48.000000', 'temperatura', 73.0000, 'ºC'),
	(292983, 143, '2015-01-01 00:09:49.000000', 'temperatura', 1121.0000, 'ºC'),
	(292984, 143, '2015-01-01 00:09:50.000000', 'temperatura', 586.0000, 'ºC'),
	(292985, 143, '2015-01-01 00:09:51.000000', 'temperatura', 767.0000, 'ºC'),
	(292986, 143, '2015-01-01 00:09:52.000000', 'temperatura', 879.0000, 'ºC'),
	(292987, 143, '2015-01-01 00:09:53.000000', 'temperatura', 893.0000, 'ºC'),
	(292988, 143, '2015-01-01 00:09:54.000000', 'temperatura', 629.0000, 'ºC'),
	(292989, 143, '2015-01-01 00:09:55.000000', 'temperatura', 468.0000, 'ºC'),
	(292990, 143, '2015-01-01 00:09:56.000000', 'temperatura', 450.0000, 'ºC'),
	(292991, 143, '2015-01-01 00:09:57.000000', 'temperatura', 849.0000, 'ºC'),
	(292992, 143, '2015-01-01 00:09:58.000000', 'temperatura', 497.0000, 'ºC'),
	(292993, 143, '2015-01-01 00:09:59.000000', 'temperatura', 1135.0000, 'ºC'),
	(292994, 143, '2015-01-01 00:10:00.000000', 'temperatura', 586.0000, 'ºC'),
	(292995, 143, '2015-01-01 00:10:01.000000', 'temperatura', 726.0000, 'ºC'),
	(292996, 143, '2015-01-01 00:10:02.000000', 'temperatura', 672.0000, 'ºC'),
	(292997, 143, '2015-01-01 00:10:03.000000', 'temperatura', 1185.0000, 'ºC'),
	(292998, 143, '2015-01-01 00:10:04.000000', 'temperatura', 307.0000, 'ºC'),
	(292999, 143, '2015-01-01 00:10:05.000000', 'temperatura', 379.0000, 'ºC'),
	(293000, 143, '2015-01-01 00:10:06.000000', 'temperatura', 978.0000, 'ºC'),
	(293001, 143, '2015-01-01 00:10:07.000000', 'temperatura', 150.0000, 'ºC'),
	(293002, 143, '2015-01-01 00:10:08.000000', 'temperatura', 220.0000, 'ºC'),
	(293003, 143, '2015-01-01 00:10:09.000000', 'temperatura', 649.0000, 'ºC'),
	(293004, 143, '2015-01-01 00:10:10.000000', 'temperatura', 185.0000, 'ºC'),
	(293005, 143, '2015-01-01 00:10:11.000000', 'temperatura', 177.0000, 'ºC'),
	(293006, 143, '2015-01-01 00:10:12.000000', 'temperatura', 332.0000, 'ºC'),
	(293007, 143, '2015-01-01 00:10:13.000000', 'temperatura', 1130.0000, 'ºC'),
	(293008, 143, '2015-01-01 00:10:14.000000', 'temperatura', 1055.0000, 'ºC'),
	(293009, 143, '2015-01-01 00:10:15.000000', 'temperatura', 683.0000, 'ºC'),
	(293010, 143, '2015-01-01 00:10:16.000000', 'temperatura', 252.0000, 'ºC'),
	(293011, 143, '2015-01-01 00:10:17.000000', 'temperatura', 410.0000, 'ºC'),
	(293012, 143, '2015-01-01 00:10:18.000000', 'temperatura', 96.0000, 'ºC'),
	(293013, 143, '2015-01-01 00:10:19.000000', 'temperatura', 451.0000, 'ºC'),
	(293014, 143, '2015-01-01 00:10:20.000000', 'temperatura', 766.0000, 'ºC'),
	(293015, 143, '2015-01-01 00:10:21.000000', 'temperatura', 78.0000, 'ºC'),
	(293016, 143, '2015-01-01 00:10:22.000000', 'temperatura', 491.0000, 'ºC'),
	(293017, 143, '2015-01-01 00:10:23.000000', 'temperatura', 1021.0000, 'ºC'),
	(293018, 143, '2015-01-01 00:10:24.000000', 'temperatura', 34.0000, 'ºC'),
	(293019, 143, '2015-01-01 00:10:25.000000', 'temperatura', 709.0000, 'ºC'),
	(293020, 143, '2015-01-01 00:10:26.000000', 'temperatura', 1041.0000, 'ºC'),
	(293021, 143, '2015-01-01 00:10:27.000000', 'temperatura', 681.0000, 'ºC'),
	(293022, 143, '2015-01-01 00:10:28.000000', 'temperatura', 279.0000, 'ºC'),
	(293023, 143, '2015-01-01 00:10:29.000000', 'temperatura', 556.0000, 'ºC'),
	(293024, 143, '2015-01-01 00:10:30.000000', 'temperatura', 742.0000, 'ºC'),
	(293025, 143, '2015-01-01 00:10:31.000000', 'temperatura', 841.0000, 'ºC'),
	(293026, 143, '2015-01-01 00:10:32.000000', 'temperatura', 782.0000, 'ºC'),
	(293027, 143, '2015-01-01 00:10:33.000000', 'temperatura', 187.0000, 'ºC'),
	(293028, 143, '2015-01-01 00:10:34.000000', 'temperatura', 987.0000, 'ºC'),
	(293029, 143, '2015-01-01 00:10:35.000000', 'temperatura', 777.0000, 'ºC'),
	(293030, 143, '2015-01-01 00:10:36.000000', 'temperatura', 923.0000, 'ºC'),
	(293031, 143, '2015-01-01 00:10:37.000000', 'temperatura', 1083.0000, 'ºC'),
	(293032, 143, '2015-01-01 00:10:38.000000', 'temperatura', 249.0000, 'ºC'),
	(293033, 143, '2015-01-01 00:10:39.000000', 'temperatura', 397.0000, 'ºC'),
	(293034, 143, '2015-01-01 00:10:40.000000', 'temperatura', 39.0000, 'ºC'),
	(293035, 143, '2015-01-01 00:10:41.000000', 'temperatura', 204.0000, 'ºC'),
	(293036, 143, '2015-01-01 00:10:42.000000', 'temperatura', 904.0000, 'ºC'),
	(293037, 143, '2015-01-01 00:10:43.000000', 'temperatura', 306.0000, 'ºC'),
	(293038, 143, '2015-01-01 00:10:44.000000', 'temperatura', 20.0000, 'ºC'),
	(293039, 143, '2015-01-01 00:10:45.000000', 'temperatura', 381.0000, 'ºC'),
	(293040, 143, '2015-01-01 00:10:46.000000', 'temperatura', 645.0000, 'ºC'),
	(293041, 143, '2015-01-01 00:10:47.000000', 'temperatura', 882.0000, 'ºC'),
	(293042, 143, '2015-01-01 00:10:48.000000', 'temperatura', 77.0000, 'ºC'),
	(293043, 143, '2015-01-01 00:10:49.000000', 'temperatura', 138.0000, 'ºC'),
	(293044, 143, '2015-01-01 00:10:50.000000', 'temperatura', 458.0000, 'ºC'),
	(293045, 143, '2015-01-01 00:10:51.000000', 'temperatura', 679.0000, 'ºC'),
	(293046, 143, '2015-01-01 00:10:52.000000', 'temperatura', 821.0000, 'ºC'),
	(293047, 143, '2015-01-01 00:10:53.000000', 'temperatura', 868.0000, 'ºC'),
	(293048, 143, '2015-01-01 00:10:54.000000', 'temperatura', 679.0000, 'ºC'),
	(293049, 143, '2015-01-01 00:10:55.000000', 'temperatura', 792.0000, 'ºC'),
	(293050, 143, '2015-01-01 00:10:56.000000', 'temperatura', 722.0000, 'ºC'),
	(293051, 143, '2015-01-01 00:10:57.000000', 'temperatura', 33.0000, 'ºC'),
	(293052, 143, '2015-01-01 00:10:58.000000', 'temperatura', 401.0000, 'ºC'),
	(293053, 143, '2015-01-01 00:10:59.000000', 'temperatura', 707.0000, 'ºC'),
	(293054, 143, '2015-01-01 00:11:00.000000', 'temperatura', 1132.0000, 'ºC'),
	(293055, 143, '2015-01-01 00:11:01.000000', 'temperatura', 1138.0000, 'ºC'),
	(293056, 143, '2015-01-01 00:11:02.000000', 'temperatura', 1096.0000, 'ºC'),
	(293057, 143, '2015-01-01 00:11:03.000000', 'temperatura', 865.0000, 'ºC'),
	(293058, 143, '2015-01-01 00:11:04.000000', 'temperatura', 1039.0000, 'ºC'),
	(293059, 143, '2015-01-01 00:11:05.000000', 'temperatura', 200.0000, 'ºC'),
	(293060, 143, '2015-01-01 00:11:06.000000', 'temperatura', 283.0000, 'ºC'),
	(293061, 143, '2015-01-01 00:11:07.000000', 'temperatura', 814.0000, 'ºC'),
	(293062, 143, '2015-01-01 00:11:08.000000', 'temperatura', 824.0000, 'ºC'),
	(293063, 143, '2015-01-01 00:11:09.000000', 'temperatura', 476.0000, 'ºC'),
	(293064, 143, '2015-01-01 00:11:10.000000', 'temperatura', 1109.0000, 'ºC'),
	(293065, 143, '2015-01-01 00:11:11.000000', 'temperatura', 517.0000, 'ºC'),
	(293066, 143, '2015-01-01 00:11:12.000000', 'temperatura', 461.0000, 'ºC'),
	(293067, 143, '2015-01-01 00:11:13.000000', 'temperatura', 754.0000, 'ºC'),
	(293068, 143, '2015-01-01 00:11:14.000000', 'temperatura', 1185.0000, 'ºC'),
	(293069, 143, '2015-01-01 00:11:15.000000', 'temperatura', 66.0000, 'ºC'),
	(293070, 143, '2015-01-01 00:11:16.000000', 'temperatura', 373.0000, 'ºC'),
	(293071, 143, '2015-01-01 00:11:17.000000', 'temperatura', 467.0000, 'ºC'),
	(293072, 143, '2015-01-01 00:11:18.000000', 'temperatura', 19.0000, 'ºC'),
	(293073, 143, '2015-01-01 00:11:19.000000', 'temperatura', 1093.0000, 'ºC'),
	(293074, 143, '2015-01-01 00:11:20.000000', 'temperatura', 610.0000, 'ºC'),
	(293075, 143, '2015-01-01 00:11:21.000000', 'temperatura', 970.0000, 'ºC'),
	(293076, 143, '2015-01-01 00:11:22.000000', 'temperatura', 620.0000, 'ºC'),
	(293077, 143, '2015-01-01 00:11:23.000000', 'temperatura', 193.0000, 'ºC'),
	(293078, 143, '2015-01-01 00:11:24.000000', 'temperatura', 304.0000, 'ºC'),
	(293079, 143, '2015-01-01 00:11:25.000000', 'temperatura', 942.0000, 'ºC'),
	(293080, 143, '2015-01-01 00:11:26.000000', 'temperatura', 200.0000, 'ºC'),
	(293081, 143, '2015-01-01 00:11:27.000000', 'temperatura', 574.0000, 'ºC'),
	(293082, 143, '2015-01-01 00:11:28.000000', 'temperatura', 1069.0000, 'ºC'),
	(293083, 143, '2015-01-01 00:11:29.000000', 'temperatura', 25.0000, 'ºC'),
	(293084, 143, '2015-01-01 00:11:30.000000', 'temperatura', 518.0000, 'ºC'),
	(293085, 143, '2015-01-01 00:11:31.000000', 'temperatura', 114.0000, 'ºC'),
	(293086, 143, '2015-01-01 00:11:32.000000', 'temperatura', 216.0000, 'ºC'),
	(293087, 143, '2015-01-01 00:11:33.000000', 'temperatura', 740.0000, 'ºC'),
	(293088, 143, '2015-01-01 00:11:34.000000', 'temperatura', 654.0000, 'ºC'),
	(293089, 143, '2015-01-01 00:11:35.000000', 'temperatura', 1048.0000, 'ºC'),
	(293090, 143, '2015-01-01 00:11:36.000000', 'temperatura', 877.0000, 'ºC'),
	(293091, 143, '2015-01-01 00:11:37.000000', 'temperatura', 45.0000, 'ºC'),
	(293092, 143, '2015-01-01 00:11:38.000000', 'temperatura', 1194.0000, 'ºC'),
	(293093, 143, '2015-01-01 00:11:39.000000', 'temperatura', 1034.0000, 'ºC'),
	(293094, 143, '2015-01-01 00:11:40.000000', 'temperatura', 390.0000, 'ºC'),
	(293095, 143, '2015-01-01 00:11:41.000000', 'temperatura', 47.0000, 'ºC'),
	(293096, 143, '2015-01-01 00:11:42.000000', 'temperatura', 265.0000, 'ºC'),
	(293097, 143, '2015-01-01 00:11:43.000000', 'temperatura', 1187.0000, 'ºC'),
	(293098, 143, '2015-01-01 00:11:44.000000', 'temperatura', 339.0000, 'ºC'),
	(293099, 143, '2015-01-01 00:11:45.000000', 'temperatura', 534.0000, 'ºC'),
	(293100, 143, '2015-01-01 00:11:46.000000', 'temperatura', 455.0000, 'ºC'),
	(293101, 143, '2015-01-01 00:11:47.000000', 'temperatura', 671.0000, 'ºC'),
	(293102, 143, '2015-01-01 00:11:48.000000', 'temperatura', 792.0000, 'ºC'),
	(293103, 143, '2015-01-01 00:11:49.000000', 'temperatura', 746.0000, 'ºC'),
	(293104, 143, '2015-01-01 00:11:50.000000', 'temperatura', 154.0000, 'ºC'),
	(293105, 143, '2015-01-01 00:11:51.000000', 'temperatura', 934.0000, 'ºC'),
	(293106, 143, '2015-01-01 00:11:52.000000', 'temperatura', 609.0000, 'ºC'),
	(293107, 143, '2015-01-01 00:11:53.000000', 'temperatura', 244.0000, 'ºC'),
	(293108, 143, '2015-01-01 00:11:54.000000', 'temperatura', 594.0000, 'ºC'),
	(293109, 143, '2015-01-01 00:11:55.000000', 'temperatura', 1036.0000, 'ºC'),
	(293110, 143, '2015-01-01 00:11:56.000000', 'temperatura', 1001.0000, 'ºC'),
	(293111, 143, '2015-01-01 00:11:57.000000', 'temperatura', 697.0000, 'ºC'),
	(293112, 143, '2015-01-01 00:11:58.000000', 'temperatura', 484.0000, 'ºC'),
	(293113, 143, '2015-01-01 00:11:59.000000', 'temperatura', 329.0000, 'ºC'),
	(293114, 143, '2015-01-01 00:12:00.000000', 'temperatura', 191.0000, 'ºC'),
	(293115, 143, '2015-01-01 00:12:01.000000', 'temperatura', 1171.0000, 'ºC'),
	(293116, 143, '2015-01-01 00:12:02.000000', 'temperatura', 482.0000, 'ºC'),
	(293117, 143, '2015-01-01 00:12:03.000000', 'temperatura', 97.0000, 'ºC'),
	(293118, 143, '2015-01-01 00:12:04.000000', 'temperatura', 239.0000, 'ºC'),
	(293119, 143, '2015-01-01 00:12:05.000000', 'temperatura', 904.0000, 'ºC'),
	(293120, 143, '2015-01-01 00:12:06.000000', 'temperatura', 203.0000, 'ºC'),
	(293121, 143, '2015-01-01 00:12:07.000000', 'temperatura', 704.0000, 'ºC'),
	(293122, 143, '2015-01-01 00:12:08.000000', 'temperatura', 513.0000, 'ºC'),
	(293123, 143, '2015-01-01 00:12:09.000000', 'temperatura', 451.0000, 'ºC'),
	(293124, 143, '2015-01-01 00:12:10.000000', 'temperatura', 720.0000, 'ºC'),
	(293125, 143, '2015-01-01 00:12:11.000000', 'temperatura', 1045.0000, 'ºC'),
	(293126, 143, '2015-01-01 00:12:12.000000', 'temperatura', 664.0000, 'ºC'),
	(293127, 143, '2015-01-01 00:12:13.000000', 'temperatura', 188.0000, 'ºC'),
	(293128, 143, '2015-01-01 00:12:14.000000', 'temperatura', 147.0000, 'ºC'),
	(293129, 143, '2015-01-01 00:12:15.000000', 'temperatura', 170.0000, 'ºC'),
	(293130, 143, '2015-01-01 00:12:16.000000', 'temperatura', 412.0000, 'ºC'),
	(293131, 143, '2015-01-01 00:12:17.000000', 'temperatura', 348.0000, 'ºC'),
	(293132, 143, '2015-01-01 00:12:18.000000', 'temperatura', 505.0000, 'ºC'),
	(293133, 143, '2015-01-01 00:12:19.000000', 'temperatura', 282.0000, 'ºC'),
	(293134, 143, '2015-01-01 00:12:20.000000', 'temperatura', 1094.0000, 'ºC'),
	(293135, 143, '2015-01-01 00:12:21.000000', 'temperatura', 1026.0000, 'ºC'),
	(293136, 143, '2015-01-01 00:12:22.000000', 'temperatura', 650.0000, 'ºC'),
	(293137, 143, '2015-01-01 00:12:23.000000', 'temperatura', 171.0000, 'ºC'),
	(293138, 143, '2015-01-01 00:12:24.000000', 'temperatura', 104.0000, 'ºC'),
	(293139, 143, '2015-01-01 00:12:25.000000', 'temperatura', 9.0000, 'ºC'),
	(293140, 143, '2015-01-01 00:12:26.000000', 'temperatura', 934.0000, 'ºC'),
	(293141, 143, '2015-01-01 00:12:27.000000', 'temperatura', 1041.0000, 'ºC'),
	(293142, 143, '2015-01-01 00:12:28.000000', 'temperatura', 6.0000, 'ºC'),
	(293143, 143, '2015-01-01 00:12:29.000000', 'temperatura', 506.0000, 'ºC'),
	(293144, 143, '2015-01-01 00:12:30.000000', 'temperatura', 114.0000, 'ºC'),
	(293145, 143, '2015-01-01 00:12:31.000000', 'temperatura', 254.0000, 'ºC'),
	(293146, 143, '2015-01-01 00:12:32.000000', 'temperatura', 926.0000, 'ºC'),
	(293147, 143, '2015-01-01 00:12:33.000000', 'temperatura', 269.0000, 'ºC'),
	(293148, 143, '2015-01-01 00:12:34.000000', 'temperatura', 968.0000, 'ºC'),
	(293149, 143, '2015-01-01 00:12:35.000000', 'temperatura', 435.0000, 'ºC'),
	(293150, 143, '2015-01-01 00:12:36.000000', 'temperatura', 468.0000, 'ºC'),
	(293151, 143, '2015-01-01 00:12:37.000000', 'temperatura', 1038.0000, 'ºC'),
	(293152, 143, '2015-01-01 00:12:38.000000', 'temperatura', 185.0000, 'ºC'),
	(293153, 143, '2015-01-01 00:12:39.000000', 'temperatura', 210.0000, 'ºC'),
	(293154, 143, '2015-01-01 00:12:40.000000', 'temperatura', 498.0000, 'ºC'),
	(293155, 143, '2015-01-01 00:12:41.000000', 'temperatura', 658.0000, 'ºC'),
	(293156, 143, '2015-01-01 00:12:42.000000', 'temperatura', 597.0000, 'ºC'),
	(293157, 143, '2015-01-01 00:12:43.000000', 'temperatura', 1012.0000, 'ºC'),
	(293158, 143, '2015-01-01 00:12:44.000000', 'temperatura', 869.0000, 'ºC'),
	(293159, 143, '2015-01-01 00:12:45.000000', 'temperatura', 109.0000, 'ºC'),
	(293160, 143, '2015-01-01 00:12:46.000000', 'temperatura', 340.0000, 'ºC'),
	(293161, 143, '2015-01-01 00:12:47.000000', 'temperatura', 171.0000, 'ºC'),
	(293162, 143, '2015-01-01 00:12:48.000000', 'temperatura', 1038.0000, 'ºC'),
	(293163, 143, '2015-01-01 00:12:49.000000', 'temperatura', 1079.0000, 'ºC'),
	(293164, 143, '2015-01-01 00:12:50.000000', 'temperatura', 1079.0000, 'ºC'),
	(293165, 143, '2015-01-01 00:12:51.000000', 'temperatura', 959.0000, 'ºC'),
	(293166, 143, '2015-01-01 00:12:52.000000', 'temperatura', 357.0000, 'ºC'),
	(293167, 143, '2015-01-01 00:12:53.000000', 'temperatura', 109.0000, 'ºC'),
	(293168, 143, '2015-01-01 00:12:54.000000', 'temperatura', 673.0000, 'ºC'),
	(293169, 143, '2015-01-01 00:12:55.000000', 'temperatura', 642.0000, 'ºC'),
	(293170, 143, '2015-01-01 00:12:56.000000', 'temperatura', 1190.0000, 'ºC'),
	(293171, 143, '2015-01-01 00:12:57.000000', 'temperatura', 423.0000, 'ºC'),
	(293172, 143, '2015-01-01 00:12:58.000000', 'temperatura', 948.0000, 'ºC'),
	(293173, 143, '2015-01-01 00:12:59.000000', 'temperatura', 1071.0000, 'ºC'),
	(293174, 143, '2015-01-01 00:13:00.000000', 'temperatura', 112.0000, 'ºC'),
	(293175, 143, '2015-01-01 00:13:01.000000', 'temperatura', 949.0000, 'ºC'),
	(293176, 143, '2015-01-01 00:13:02.000000', 'temperatura', 808.0000, 'ºC'),
	(293177, 143, '2015-01-01 00:13:03.000000', 'temperatura', 1191.0000, 'ºC'),
	(293178, 143, '2015-01-01 00:13:04.000000', 'temperatura', 1135.0000, 'ºC'),
	(293179, 143, '2015-01-01 00:13:05.000000', 'temperatura', 903.0000, 'ºC'),
	(293180, 143, '2015-01-01 00:13:06.000000', 'temperatura', 1109.0000, 'ºC'),
	(293181, 143, '2015-01-01 00:13:07.000000', 'temperatura', 438.0000, 'ºC'),
	(293182, 143, '2015-01-01 00:13:08.000000', 'temperatura', 61.0000, 'ºC'),
	(293183, 143, '2015-01-01 00:13:09.000000', 'temperatura', 193.0000, 'ºC'),
	(293184, 143, '2015-01-01 00:13:10.000000', 'temperatura', 784.0000, 'ºC'),
	(293185, 143, '2015-01-01 00:13:11.000000', 'temperatura', 941.0000, 'ºC'),
	(293186, 143, '2015-01-01 00:13:12.000000', 'temperatura', 1153.0000, 'ºC'),
	(293187, 143, '2015-01-01 00:13:13.000000', 'temperatura', 544.0000, 'ºC'),
	(293188, 143, '2015-01-01 00:13:14.000000', 'temperatura', 460.0000, 'ºC'),
	(293189, 143, '2015-01-01 00:13:15.000000', 'temperatura', 671.0000, 'ºC'),
	(293190, 143, '2015-01-01 00:13:16.000000', 'temperatura', 773.0000, 'ºC'),
	(293191, 143, '2015-01-01 00:13:17.000000', 'temperatura', 651.0000, 'ºC'),
	(293192, 143, '2015-01-01 00:13:18.000000', 'temperatura', 940.0000, 'ºC'),
	(293193, 143, '2015-01-01 00:13:19.000000', 'temperatura', 345.0000, 'ºC'),
	(293194, 143, '2015-01-01 00:13:20.000000', 'temperatura', 106.0000, 'ºC'),
	(293195, 143, '2015-01-01 00:13:21.000000', 'temperatura', 695.0000, 'ºC'),
	(293196, 143, '2015-01-01 00:13:22.000000', 'temperatura', 760.0000, 'ºC'),
	(293197, 143, '2015-01-01 00:13:23.000000', 'temperatura', 514.0000, 'ºC'),
	(293198, 143, '2015-01-01 00:13:24.000000', 'temperatura', 291.0000, 'ºC'),
	(293199, 143, '2015-01-01 00:13:25.000000', 'temperatura', 1112.0000, 'ºC'),
	(293200, 143, '2015-01-01 00:13:26.000000', 'temperatura', 1087.0000, 'ºC'),
	(293201, 143, '2015-01-01 00:13:27.000000', 'temperatura', 900.0000, 'ºC'),
	(293202, 143, '2015-01-01 00:13:28.000000', 'temperatura', 39.0000, 'ºC'),
	(293203, 143, '2015-01-01 00:13:29.000000', 'temperatura', 1097.0000, 'ºC'),
	(293204, 143, '2015-01-01 00:13:30.000000', 'temperatura', 567.0000, 'ºC'),
	(293205, 143, '2015-01-01 00:13:31.000000', 'temperatura', 744.0000, 'ºC'),
	(293206, 143, '2015-01-01 00:13:32.000000', 'temperatura', 822.0000, 'ºC'),
	(293207, 143, '2015-01-01 00:13:33.000000', 'temperatura', 679.0000, 'ºC'),
	(293208, 143, '2015-01-01 00:13:34.000000', 'temperatura', 927.0000, 'ºC'),
	(293209, 143, '2015-01-01 00:13:35.000000', 'temperatura', 199.0000, 'ºC'),
	(293210, 143, '2015-01-01 00:13:36.000000', 'temperatura', 614.0000, 'ºC'),
	(293211, 143, '2015-01-01 00:13:37.000000', 'temperatura', 72.0000, 'ºC'),
	(293212, 143, '2015-01-01 00:13:38.000000', 'temperatura', 922.0000, 'ºC'),
	(293213, 143, '2015-01-01 00:13:39.000000', 'temperatura', 793.0000, 'ºC'),
	(293214, 143, '2015-01-01 00:13:40.000000', 'temperatura', 0.0000, 'ºC'),
	(293215, 143, '2015-01-01 00:13:41.000000', 'temperatura', 21.0000, 'ºC'),
	(293216, 143, '2015-01-01 00:13:42.000000', 'temperatura', 107.0000, 'ºC'),
	(293217, 143, '2015-01-01 00:13:43.000000', 'temperatura', 471.0000, 'ºC'),
	(293218, 143, '2015-01-01 00:13:44.000000', 'temperatura', 835.0000, 'ºC'),
	(293219, 143, '2015-01-01 00:13:45.000000', 'temperatura', 363.0000, 'ºC'),
	(293220, 143, '2015-01-01 00:13:46.000000', 'temperatura', 512.0000, 'ºC'),
	(293221, 143, '2015-01-01 00:13:47.000000', 'temperatura', 271.0000, 'ºC'),
	(293222, 143, '2015-01-01 00:13:48.000000', 'temperatura', 1018.0000, 'ºC'),
	(293223, 143, '2015-01-01 00:13:49.000000', 'temperatura', 678.0000, 'ºC'),
	(293224, 143, '2015-01-01 00:13:50.000000', 'temperatura', 335.0000, 'ºC'),
	(293225, 143, '2015-01-01 00:13:51.000000', 'temperatura', 841.0000, 'ºC'),
	(293226, 143, '2015-01-01 00:13:52.000000', 'temperatura', 803.0000, 'ºC'),
	(293227, 143, '2015-01-01 00:13:53.000000', 'temperatura', 291.0000, 'ºC'),
	(293228, 143, '2015-01-01 00:13:54.000000', 'temperatura', 249.0000, 'ºC'),
	(293229, 143, '2015-01-01 00:13:55.000000', 'temperatura', 370.0000, 'ºC'),
	(293230, 143, '2015-01-01 00:13:56.000000', 'temperatura', 1104.0000, 'ºC'),
	(293231, 143, '2015-01-01 00:13:57.000000', 'temperatura', 812.0000, 'ºC'),
	(293232, 143, '2015-01-01 00:13:58.000000', 'temperatura', 748.0000, 'ºC'),
	(293233, 143, '2015-01-01 00:13:59.000000', 'temperatura', 102.0000, 'ºC'),
	(293234, 143, '2015-01-01 00:14:00.000000', 'temperatura', 669.0000, 'ºC'),
	(293235, 143, '2015-01-01 00:14:01.000000', 'temperatura', 640.0000, 'ºC'),
	(293236, 143, '2015-01-01 00:14:02.000000', 'temperatura', 1191.0000, 'ºC'),
	(293237, 143, '2015-01-01 00:14:03.000000', 'temperatura', 437.0000, 'ºC'),
	(293238, 143, '2015-01-01 00:14:04.000000', 'temperatura', 1011.0000, 'ºC'),
	(293239, 143, '2015-01-01 00:14:05.000000', 'temperatura', 147.0000, 'ºC'),
	(293240, 143, '2015-01-01 00:14:06.000000', 'temperatura', 101.0000, 'ºC'),
	(293241, 143, '2015-01-01 00:14:07.000000', 'temperatura', 66.0000, 'ºC'),
	(293242, 143, '2015-01-01 00:14:08.000000', 'temperatura', 25.0000, 'ºC'),
	(293243, 143, '2015-01-01 00:14:09.000000', 'temperatura', 1129.0000, 'ºC'),
	(293244, 143, '2015-01-01 00:14:10.000000', 'temperatura', 770.0000, 'ºC'),
	(293245, 143, '2015-01-01 00:14:11.000000', 'temperatura', 465.0000, 'ºC'),
	(293246, 143, '2015-01-01 00:14:12.000000', 'temperatura', 15.0000, 'ºC'),
	(293247, 143, '2015-01-01 00:14:13.000000', 'temperatura', 1079.0000, 'ºC'),
	(293248, 143, '2015-01-01 00:14:14.000000', 'temperatura', 550.0000, 'ºC'),
	(293249, 143, '2015-01-01 00:14:15.000000', 'temperatura', 716.0000, 'ºC'),
	(293250, 143, '2015-01-01 00:14:16.000000', 'temperatura', 731.0000, 'ºC'),
	(293251, 143, '2015-01-01 00:14:17.000000', 'temperatura', 304.0000, 'ºC'),
	(293252, 143, '2015-01-01 00:14:18.000000', 'temperatura', 531.0000, 'ºC'),
	(293253, 143, '2015-01-01 00:14:19.000000', 'temperatura', 542.0000, 'ºC'),
	(293254, 143, '2015-01-01 00:14:20.000000', 'temperatura', 1119.0000, 'ºC'),
	(293255, 143, '2015-01-01 00:14:21.000000', 'temperatura', 367.0000, 'ºC'),
	(293256, 143, '2015-01-01 00:14:22.000000', 'temperatura', 881.0000, 'ºC'),
	(293257, 143, '2015-01-01 00:14:23.000000', 'temperatura', 903.0000, 'ºC'),
	(293258, 143, '2015-01-01 00:14:24.000000', 'temperatura', 673.0000, 'ºC'),
	(293259, 143, '2015-01-01 00:14:25.000000', 'temperatura', 657.0000, 'ºC'),
	(293260, 143, '2015-01-01 00:14:26.000000', 'temperatura', 67.0000, 'ºC'),
	(293261, 143, '2015-01-01 00:14:27.000000', 'temperatura', 763.0000, 'ºC'),
	(293262, 143, '2015-01-01 00:14:28.000000', 'temperatura', 17.0000, 'ºC'),
	(293263, 143, '2015-01-01 00:14:29.000000', 'temperatura', 195.0000, 'ºC'),
	(293264, 143, '2015-01-01 00:14:30.000000', 'temperatura', 925.0000, 'ºC'),
	(293265, 143, '2015-01-01 00:14:31.000000', 'temperatura', 440.0000, 'ºC'),
	(293266, 143, '2015-01-01 00:14:32.000000', 'temperatura', 626.0000, 'ºC'),
	(293267, 143, '2015-01-01 00:14:33.000000', 'temperatura', 612.0000, 'ºC'),
	(293268, 143, '2015-01-01 00:14:34.000000', 'temperatura', 1180.0000, 'ºC'),
	(293269, 143, '2015-01-01 00:14:35.000000', 'temperatura', 463.0000, 'ºC'),
	(293270, 143, '2015-01-01 00:14:36.000000', 'temperatura', 1178.0000, 'ºC'),
	(293271, 143, '2015-01-01 00:14:37.000000', 'temperatura', 903.0000, 'ºC'),
	(293272, 143, '2015-01-01 00:14:38.000000', 'temperatura', 980.0000, 'ºC'),
	(293273, 143, '2015-01-01 00:14:39.000000', 'temperatura', 992.0000, 'ºC'),
	(293274, 143, '2015-01-01 00:14:40.000000', 'temperatura', 819.0000, 'ºC'),
	(293275, 143, '2015-01-01 00:14:41.000000', 'temperatura', 1121.0000, 'ºC'),
	(293276, 143, '2015-01-01 00:14:42.000000', 'temperatura', 748.0000, 'ºC'),
	(293277, 143, '2015-01-01 00:14:43.000000', 'temperatura', 378.0000, 'ºC'),
	(293278, 143, '2015-01-01 00:14:44.000000', 'temperatura', 848.0000, 'ºC'),
	(293279, 143, '2015-01-01 00:14:45.000000', 'temperatura', 703.0000, 'ºC'),
	(293280, 143, '2015-01-01 00:14:46.000000', 'temperatura', 974.0000, 'ºC'),
	(293281, 143, '2015-01-01 00:14:47.000000', 'temperatura', 359.0000, 'ºC'),
	(293282, 143, '2015-01-01 00:14:48.000000', 'temperatura', 74.0000, 'ºC'),
	(293283, 143, '2015-01-01 00:14:49.000000', 'temperatura', 496.0000, 'ºC'),
	(293284, 143, '2015-01-01 00:14:50.000000', 'temperatura', 1056.0000, 'ºC'),
	(293285, 143, '2015-01-01 00:14:51.000000', 'temperatura', 191.0000, 'ºC'),
	(293286, 143, '2015-01-01 00:14:52.000000', 'temperatura', 190.0000, 'ºC'),
	(293287, 143, '2015-01-01 00:14:53.000000', 'temperatura', 376.0000, 'ºC'),
	(293288, 143, '2015-01-01 00:14:54.000000', 'temperatura', 112.0000, 'ºC'),
	(293289, 143, '2015-01-01 00:14:55.000000', 'temperatura', 630.0000, 'ºC'),
	(293290, 143, '2015-01-01 00:14:56.000000', 'temperatura', 417.0000, 'ºC'),
	(293291, 143, '2015-01-01 00:14:57.000000', 'temperatura', 195.0000, 'ºC'),
	(293292, 143, '2015-01-01 00:14:58.000000', 'temperatura', 926.0000, 'ºC'),
	(293293, 143, '2015-01-01 00:14:59.000000', 'temperatura', 446.0000, 'ºC'),
	(293294, 143, '2015-01-01 00:15:00.000000', 'temperatura', 650.0000, 'ºC'),
	(293295, 143, '2015-01-01 00:15:01.000000', 'temperatura', 712.0000, 'ºC'),
	(293296, 143, '2015-01-01 00:15:02.000000', 'temperatura', 411.0000, 'ºC'),
	(293297, 143, '2015-01-01 00:15:03.000000', 'temperatura', 1119.0000, 'ºC'),
	(293298, 143, '2015-01-01 00:15:04.000000', 'temperatura', 764.0000, 'ºC'),
	(293299, 143, '2015-01-01 00:15:05.000000', 'temperatura', 461.0000, 'ºC'),
	(293300, 143, '2015-01-01 00:15:06.000000', 'temperatura', 16.0000, 'ºC'),
	(293301, 143, '2015-01-01 00:15:07.000000', 'temperatura', 1096.0000, 'ºC'),
	(293302, 143, '2015-01-01 00:15:08.000000', 'temperatura', 632.0000, 'ºC'),
	(293303, 143, '2015-01-01 00:15:09.000000', 'temperatura', 1071.0000, 'ºC'),
	(293304, 143, '2015-01-01 00:15:10.000000', 'temperatura', 1062.0000, 'ºC'),
	(293305, 143, '2015-01-01 00:15:11.000000', 'temperatura', 898.0000, 'ºC'),
	(293306, 143, '2015-01-01 00:15:12.000000', 'temperatura', 104.0000, 'ºC'),
	(293307, 143, '2015-01-01 00:15:13.000000', 'temperatura', 227.0000, 'ºC'),
	(293308, 143, '2015-01-01 00:15:14.000000', 'temperatura', 823.0000, 'ºC'),
	(293309, 143, '2015-01-01 00:15:15.000000', 'temperatura', 1035.0000, 'ºC'),
	(293310, 143, '2015-01-01 00:15:16.000000', 'temperatura', 305.0000, 'ºC'),
	(293311, 143, '2015-01-01 00:15:17.000000', 'temperatura', 820.0000, 'ºC'),
	(293312, 143, '2015-01-01 00:15:18.000000', 'temperatura', 785.0000, 'ºC'),
	(293313, 143, '2015-01-01 00:15:19.000000', 'temperatura', 266.0000, 'ºC'),
	(293314, 143, '2015-01-01 00:15:20.000000', 'temperatura', 176.0000, 'ºC'),
	(293315, 143, '2015-01-01 00:15:21.000000', 'temperatura', 83.0000, 'ºC'),
	(293316, 143, '2015-01-01 00:15:22.000000', 'temperatura', 1088.0000, 'ºC'),
	(293317, 143, '2015-01-01 00:15:23.000000', 'temperatura', 391.0000, 'ºC'),
	(293318, 143, '2015-01-01 00:15:24.000000', 'temperatura', 1091.0000, 'ºC'),
	(293319, 143, '2015-01-01 00:15:25.000000', 'temperatura', 681.0000, 'ºC'),
	(293320, 143, '2015-01-01 00:15:26.000000', 'temperatura', 134.0000, 'ºC'),
	(293321, 143, '2015-01-01 00:15:27.000000', 'temperatura', 1026.0000, 'ºC'),
	(293322, 143, '2015-01-01 00:15:28.000000', 'temperatura', 1130.0000, 'ºC'),
	(293323, 143, '2015-01-01 00:15:29.000000', 'temperatura', 174.0000, 'ºC'),
	(293324, 143, '2015-01-01 00:15:30.000000', 'temperatura', 1078.0000, 'ºC'),
	(293325, 143, '2015-01-01 00:15:31.000000', 'temperatura', 68.0000, 'ºC'),
	(293326, 143, '2015-01-01 00:15:32.000000', 'temperatura', 707.0000, 'ºC'),
	(293327, 143, '2015-01-01 00:15:33.000000', 'temperatura', 930.0000, 'ºC'),
	(293328, 143, '2015-01-01 00:15:34.000000', 'temperatura', 130.0000, 'ºC'),
	(293329, 143, '2015-01-01 00:15:35.000000', 'temperatura', 263.0000, 'ºC'),
	(293330, 143, '2015-01-01 00:15:36.000000', 'temperatura', 924.0000, 'ºC'),
	(293331, 143, '2015-01-01 00:15:37.000000', 'temperatura', 233.0000, 'ºC'),
	(293332, 143, '2015-01-01 00:15:38.000000', 'temperatura', 792.0000, 'ºC'),
	(293333, 143, '2015-01-01 00:15:39.000000', 'temperatura', 860.0000, 'ºC'),
	(293334, 143, '2015-01-01 00:15:40.000000', 'temperatura', 726.0000, 'ºC'),
	(293335, 143, '2015-01-01 00:15:41.000000', 'temperatura', 1051.0000, 'ºC'),
	(293336, 143, '2015-01-01 00:15:42.000000', 'temperatura', 677.0000, 'ºC'),
	(293337, 143, '2015-01-01 00:15:43.000000', 'temperatura', 235.0000, 'ºC'),
	(293338, 143, '2015-01-01 00:15:44.000000', 'temperatura', 341.0000, 'ºC'),
	(293339, 143, '2015-01-01 00:15:45.000000', 'temperatura', 1001.0000, 'ºC'),
	(293340, 143, '2015-01-01 00:15:46.000000', 'temperatura', 383.0000, 'ºC'),
	(293341, 143, '2015-01-01 00:15:47.000000', 'temperatura', 113.0000, 'ºC'),
	(293342, 143, '2015-01-01 00:15:48.000000', 'temperatura', 617.0000, 'ºC'),
	(293343, 143, '2015-01-01 00:15:49.000000', 'temperatura', 346.0000, 'ºC'),
	(293344, 143, '2015-01-01 00:15:50.000000', 'temperatura', 1078.0000, 'ºC'),
	(293345, 143, '2015-01-01 00:15:51.000000', 'temperatura', 753.0000, 'ºC'),
	(293346, 143, '2015-01-01 00:15:52.000000', 'temperatura', 532.0000, 'ºC'),
	(293347, 143, '2015-01-01 00:15:53.000000', 'temperatura', 402.0000, 'ºC'),
	(293348, 143, '2015-01-01 00:15:54.000000', 'temperatura', 416.0000, 'ºC'),
	(293349, 143, '2015-01-01 00:15:55.000000', 'temperatura', 873.0000, 'ºC'),
	(293350, 143, '2015-01-01 00:15:56.000000', 'temperatura', 717.0000, 'ºC'),
	(293351, 143, '2015-01-01 00:15:57.000000', 'temperatura', 966.0000, 'ºC'),
	(293352, 143, '2015-01-01 00:15:58.000000', 'temperatura', 281.0000, 'ºC'),
	(293353, 143, '2015-01-01 00:15:59.000000', 'temperatura', 908.0000, 'ºC'),
	(293354, 143, '2015-01-01 00:16:00.000000', 'temperatura', 98.0000, 'ºC'),
	(293355, 143, '2015-01-01 00:16:01.000000', 'temperatura', 165.0000, 'ºC'),
	(293356, 143, '2015-01-01 00:16:02.000000', 'temperatura', 532.0000, 'ºC'),
	(293357, 143, '2015-01-01 00:16:03.000000', 'temperatura', 968.0000, 'ºC'),
	(293358, 143, '2015-01-01 00:16:04.000000', 'temperatura', 841.0000, 'ºC'),
	(293359, 143, '2015-01-01 00:16:05.000000', 'temperatura', 102.0000, 'ºC'),
	(293360, 143, '2015-01-01 00:16:06.000000', 'temperatura', 386.0000, 'ºC'),
	(293361, 143, '2015-01-01 00:16:07.000000', 'temperatura', 427.0000, 'ºC'),
	(293362, 143, '2015-01-01 00:16:08.000000', 'temperatura', 976.0000, 'ºC'),
	(293363, 143, '2015-01-01 00:16:09.000000', 'temperatura', 0.0000, 'ºC'),
	(293364, 143, '2015-01-01 00:16:10.000000', 'temperatura', 673.0000, 'ºC'),
	(293365, 143, '2015-01-01 00:16:11.000000', 'temperatura', 964.0000, 'ºC'),
	(293366, 143, '2015-01-01 00:16:12.000000', 'temperatura', 403.0000, 'ºC'),
	(293367, 143, '2015-01-01 00:16:13.000000', 'temperatura', 321.0000, 'ºC'),
	(293368, 143, '2015-01-01 00:16:14.000000', 'temperatura', 398.0000, 'ºC'),
	(293369, 143, '2015-01-01 00:16:15.000000', 'temperatura', 1029.0000, 'ºC'),
	(293370, 143, '2015-01-01 00:16:16.000000', 'temperatura', 350.0000, 'ºC'),
	(293371, 143, '2015-01-01 00:16:17.000000', 'temperatura', 1064.0000, 'ºC'),
	(293372, 143, '2015-01-01 00:16:18.000000', 'temperatura', 672.0000, 'ºC'),
	(293373, 143, '2015-01-01 00:16:19.000000', 'temperatura', 169.0000, 'ºC'),
	(293374, 143, '2015-01-01 00:16:20.000000', 'temperatura', 30.0000, 'ºC'),
	(293375, 143, '2015-01-01 00:16:21.000000', 'temperatura', 842.0000, 'ºC'),
	(293376, 143, '2015-01-01 00:16:22.000000', 'temperatura', 520.0000, 'ºC'),
	(293377, 143, '2015-01-01 00:16:23.000000', 'temperatura', 75.0000, 'ºC'),
	(293378, 143, '2015-01-01 00:16:24.000000', 'temperatura', 17.0000, 'ºC'),
	(293379, 143, '2015-01-01 00:16:25.000000', 'temperatura', 1060.0000, 'ºC'),
	(293380, 143, '2015-01-01 00:16:26.000000', 'temperatura', 449.0000, 'ºC'),
	(293381, 143, '2015-01-01 00:16:27.000000', 'temperatura', 266.0000, 'ºC'),
	(293382, 143, '2015-01-01 00:16:28.000000', 'temperatura', 1182.0000, 'ºC'),
	(293383, 143, '2015-01-01 00:16:29.000000', 'temperatura', 312.0000, 'ºC'),
	(293384, 143, '2015-01-01 00:16:30.000000', 'temperatura', 417.0000, 'ºC'),
	(293385, 143, '2015-01-01 00:16:31.000000', 'temperatura', 1148.0000, 'ºC'),
	(293386, 143, '2015-01-01 00:16:32.000000', 'temperatura', 890.0000, 'ºC'),
	(293387, 143, '2015-01-01 00:16:33.000000', 'temperatura', 1006.0000, 'ºC'),
	(293388, 143, '2015-01-01 00:16:34.000000', 'temperatura', 1160.0000, 'ºC'),
	(293389, 143, '2015-01-01 00:16:35.000000', 'temperatura', 382.0000, 'ºC'),
	(293390, 143, '2015-01-01 00:16:36.000000', 'temperatura', 832.0000, 'ºC'),
	(293391, 143, '2015-01-01 00:16:37.000000', 'temperatura', 614.0000, 'ºC'),
	(293392, 143, '2015-01-01 00:16:38.000000', 'temperatura', 575.0000, 'ºC'),
	(293393, 143, '2015-01-01 00:16:39.000000', 'temperatura', 1034.0000, 'ºC'),
	(293394, 143, '2015-01-01 00:16:40.000000', 'temperatura', 1045.0000, 'ºC'),
	(293395, 143, '2015-01-01 00:16:41.000000', 'temperatura', 924.0000, 'ºC'),
	(293396, 143, '2015-01-01 00:16:42.000000', 'temperatura', 284.0000, 'ºC'),
	(293397, 143, '2015-01-01 00:16:43.000000', 'temperatura', 1048.0000, 'ºC'),
	(293398, 143, '2015-01-01 00:16:44.000000', 'temperatura', 789.0000, 'ºC'),
	(293399, 143, '2015-01-01 00:16:45.000000', 'temperatura', 804.0000, 'ºC'),
	(293400, 143, '2015-01-01 00:16:46.000000', 'temperatura', 451.0000, 'ºC'),
	(293401, 143, '2015-01-01 00:16:47.000000', 'temperatura', 1043.0000, 'ºC'),
	(293402, 143, '2015-01-01 00:16:48.000000', 'temperatura', 263.0000, 'ºC'),
	(293403, 143, '2015-01-01 00:16:49.000000', 'temperatura', 585.0000, 'ºC'),
	(293404, 143, '2015-01-01 00:16:50.000000', 'temperatura', 939.0000, 'ºC'),
	(293405, 143, '2015-01-01 00:16:51.000000', 'temperatura', 538.0000, 'ºC'),
	(293406, 143, '2015-01-01 00:16:52.000000', 'temperatura', 1073.0000, 'ºC'),
	(293407, 143, '2015-01-01 00:16:53.000000', 'temperatura', 153.0000, 'ºC'),
	(293408, 143, '2015-01-01 00:16:54.000000', 'temperatura', 1147.0000, 'ºC'),
	(293409, 143, '2015-01-01 00:16:55.000000', 'temperatura', 474.0000, 'ºC'),
	(293410, 143, '2015-01-01 00:16:56.000000', 'temperatura', 132.0000, 'ºC'),
	(293411, 143, '2015-01-01 00:16:57.000000', 'temperatura', 436.0000, 'ºC'),
	(293412, 143, '2015-01-01 00:16:58.000000', 'temperatura', 587.0000, 'ºC'),
	(293413, 143, '2015-01-01 00:16:59.000000', 'temperatura', 425.0000, 'ºC'),
	(293414, 143, '2015-01-01 00:17:00.000000', 'temperatura', 367.0000, 'ºC'),
	(293415, 143, '2015-01-01 00:17:01.000000', 'temperatura', 560.0000, 'ºC'),
	(293416, 143, '2015-01-01 00:17:02.000000', 'temperatura', 499.0000, 'ºC'),
	(293417, 143, '2015-01-01 00:17:03.000000', 'temperatura', 814.0000, 'ºC'),
	(293418, 143, '2015-01-01 00:17:04.000000', 'temperatura', 175.0000, 'ºC'),
	(293419, 143, '2015-01-01 00:17:05.000000', 'temperatura', 834.0000, 'ºC'),
	(293420, 143, '2015-01-01 00:17:06.000000', 'temperatura', 45.0000, 'ºC'),
	(293421, 143, '2015-01-01 00:17:07.000000', 'temperatura', 123.0000, 'ºC'),
	(293422, 143, '2015-01-01 00:17:08.000000', 'temperatura', 479.0000, 'ºC'),
	(293423, 143, '2015-01-01 00:17:09.000000', 'temperatura', 829.0000, 'ºC'),
	(293424, 143, '2015-01-01 00:17:10.000000', 'temperatura', 308.0000, 'ºC'),
	(293425, 143, '2015-01-01 00:17:11.000000', 'temperatura', 253.0000, 'ºC'),
	(293426, 143, '2015-01-01 00:17:12.000000', 'temperatura', 342.0000, 'ºC'),
	(293427, 143, '2015-01-01 00:17:13.000000', 'temperatura', 952.0000, 'ºC'),
	(293428, 143, '2015-01-01 00:17:14.000000', 'temperatura', 135.0000, 'ºC'),
	(293429, 143, '2015-01-01 00:17:15.000000', 'temperatura', 218.0000, 'ºC'),
	(293430, 143, '2015-01-01 00:17:16.000000', 'temperatura', 684.0000, 'ºC'),
	(293431, 143, '2015-01-01 00:17:17.000000', 'temperatura', 369.0000, 'ºC'),
	(293432, 143, '2015-01-01 00:17:18.000000', 'temperatura', 993.0000, 'ºC'),
	(293433, 143, '2015-01-01 00:17:19.000000', 'temperatura', 257.0000, 'ºC'),
	(293434, 143, '2015-01-01 00:17:20.000000', 'temperatura', 706.0000, 'ºC'),
	(293435, 143, '2015-01-01 00:17:21.000000', 'temperatura', 360.0000, 'ºC'),
	(293436, 143, '2015-01-01 00:17:22.000000', 'temperatura', 882.0000, 'ºC'),
	(293437, 143, '2015-01-01 00:17:23.000000', 'temperatura', 931.0000, 'ºC'),
	(293438, 143, '2015-01-01 00:17:24.000000', 'temperatura', 807.0000, 'ºC'),
	(293439, 143, '2015-01-01 00:17:25.000000', 'temperatura', 46.0000, 'ºC'),
	(293440, 143, '2015-01-01 00:17:26.000000', 'temperatura', 210.0000, 'ºC'),
	(293441, 143, '2015-01-01 00:17:27.000000', 'temperatura', 910.0000, 'ºC'),
	(293442, 143, '2015-01-01 00:17:28.000000', 'temperatura', 321.0000, 'ºC'),
	(293443, 143, '2015-01-01 00:17:29.000000', 'temperatura', 75.0000, 'ºC'),
	(293444, 143, '2015-01-01 00:17:30.000000', 'temperatura', 612.0000, 'ºC'),
	(293445, 143, '2015-01-01 00:17:31.000000', 'temperatura', 434.0000, 'ºC'),
	(293446, 143, '2015-01-01 00:17:32.000000', 'temperatura', 338.0000, 'ºC'),
	(293447, 143, '2015-01-01 00:17:33.000000', 'temperatura', 385.0000, 'ºC'),
	(293448, 143, '2015-01-01 00:17:34.000000', 'temperatura', 915.0000, 'ºC'),
	(293449, 143, '2015-01-01 00:17:35.000000', 'temperatura', 1017.0000, 'ºC'),
	(293450, 143, '2015-01-01 00:17:36.000000', 'temperatura', 1143.0000, 'ºC'),
	(293451, 143, '2015-01-01 00:17:37.000000', 'temperatura', 265.0000, 'ºC'),
	(293452, 143, '2015-01-01 00:17:38.000000', 'temperatura', 294.0000, 'ºC'),
	(293453, 143, '2015-01-01 00:17:39.000000', 'temperatura', 678.0000, 'ºC'),
	(293454, 143, '2015-01-01 00:17:40.000000', 'temperatura', 108.0000, 'ºC'),
	(293455, 143, '2015-01-01 00:17:41.000000', 'temperatura', 907.0000, 'ºC'),
	(293456, 143, '2015-01-01 00:17:42.000000', 'temperatura', 612.0000, 'ºC'),
	(293457, 143, '2015-01-01 00:17:43.000000', 'temperatura', 341.0000, 'ºC'),
	(293458, 143, '2015-01-01 00:17:44.000000', 'temperatura', 1067.0000, 'ºC'),
	(293459, 143, '2015-01-01 00:17:45.000000', 'temperatura', 714.0000, 'ºC'),
	(293460, 143, '2015-01-01 00:17:46.000000', 'temperatura', 369.0000, 'ºC'),
	(293461, 143, '2015-01-01 00:17:47.000000', 'temperatura', 903.0000, 'ºC'),
	(293462, 143, '2015-01-01 00:17:48.000000', 'temperatura', 1008.0000, 'ºC'),
	(293463, 143, '2015-01-01 00:17:49.000000', 'temperatura', 1131.0000, 'ºC'),
	(293464, 143, '2015-01-01 00:17:50.000000', 'temperatura', 234.0000, 'ºC'),
	(293465, 143, '2015-01-01 00:17:51.000000', 'temperatura', 175.0000, 'ºC'),
	(293466, 143, '2015-01-01 00:17:52.000000', 'temperatura', 173.0000, 'ºC'),
	(293467, 143, '2015-01-01 00:17:53.000000', 'temperatura', 340.0000, 'ºC'),
	(293468, 143, '2015-01-01 00:17:54.000000', 'temperatura', 1184.0000, 'ºC'),
	(293469, 143, '2015-01-01 00:17:55.000000', 'temperatura', 100.0000, 'ºC'),
	(293470, 143, '2015-01-01 00:17:56.000000', 'temperatura', 547.0000, 'ºC'),
	(293471, 143, '2015-01-01 00:17:57.000000', 'temperatura', 36.0000, 'ºC'),
	(293472, 143, '2015-01-01 00:17:58.000000', 'temperatura', 941.0000, 'ºC'),
	(293473, 143, '2015-01-01 00:17:59.000000', 'temperatura', 996.0000, 'ºC'),
	(293474, 143, '2015-01-01 00:18:00.000000', 'temperatura', 957.0000, 'ºC'),
	(293475, 143, '2015-01-01 00:18:01.000000', 'temperatura', 596.0000, 'ºC'),
	(293476, 143, '2015-01-01 00:18:02.000000', 'temperatura', 113.0000, 'ºC'),
	(293477, 143, '2015-01-01 00:18:03.000000', 'temperatura', 1177.0000, 'ºC'),
	(293478, 143, '2015-01-01 00:18:04.000000', 'temperatura', 744.0000, 'ºC'),
	(293479, 143, '2015-01-01 00:18:05.000000', 'temperatura', 191.0000, 'ºC'),
	(293480, 143, '2015-01-01 00:18:06.000000', 'temperatura', 1125.0000, 'ºC'),
	(293481, 143, '2015-01-01 00:18:07.000000', 'temperatura', 249.0000, 'ºC'),
	(293482, 143, '2015-01-01 00:18:08.000000', 'temperatura', 273.0000, 'ºC'),
	(293483, 143, '2015-01-01 00:18:09.000000', 'temperatura', 619.0000, 'ºC'),
	(293484, 143, '2015-01-01 00:18:10.000000', 'temperatura', 1076.0000, 'ºC'),
	(293485, 143, '2015-01-01 00:18:11.000000', 'temperatura', 1121.0000, 'ºC'),
	(293486, 143, '2015-01-01 00:18:12.000000', 'temperatura', 1181.0000, 'ºC'),
	(293487, 143, '2015-01-01 00:18:13.000000', 'temperatura', 140.0000, 'ºC'),
	(293488, 143, '2015-01-01 00:18:14.000000', 'temperatura', 757.0000, 'ºC'),
	(293489, 143, '2015-01-01 00:18:15.000000', 'temperatura', 967.0000, 'ºC'),
	(293490, 143, '2015-01-01 00:18:16.000000', 'temperatura', 164.0000, 'ºC'),
	(293491, 143, '2015-01-01 00:18:17.000000', 'temperatura', 318.0000, 'ºC'),
	(293492, 143, '2015-01-01 00:18:18.000000', 'temperatura', 1098.0000, 'ºC'),
	(293493, 143, '2015-01-01 00:18:19.000000', 'temperatura', 936.0000, 'ºC'),
	(293494, 143, '2015-01-01 00:18:20.000000', 'temperatura', 187.0000, 'ºC'),
	(293495, 143, '2015-01-01 00:18:21.000000', 'temperatura', 529.0000, 'ºC'),
	(293496, 143, '2015-01-01 00:18:22.000000', 'temperatura', 885.0000, 'ºC'),
	(293497, 143, '2015-01-01 00:18:23.000000', 'temperatura', 438.0000, 'ºC'),
	(293498, 143, '2015-01-01 00:18:24.000000', 'temperatura', 735.0000, 'ºC'),
	(293499, 143, '2015-01-01 00:18:25.000000', 'temperatura', 1163.0000, 'ºC'),
	(293500, 143, '2015-01-01 00:18:26.000000', 'temperatura', 9.0000, 'ºC'),
	(293501, 143, '2015-01-01 00:18:27.000000', 'temperatura', 158.0000, 'ºC'),
	(293502, 143, '2015-01-01 00:18:28.000000', 'temperatura', 761.0000, 'ºC'),
	(293503, 143, '2015-01-01 00:18:29.000000', 'temperatura', 933.0000, 'ºC'),
	(293504, 143, '2015-01-01 00:18:30.000000', 'temperatura', 1182.0000, 'ºC'),
	(293505, 143, '2015-01-01 00:18:31.000000', 'temperatura', 712.0000, 'ºC'),
	(293506, 143, '2015-01-01 00:18:32.000000', 'temperatura', 12.0000, 'ºC'),
	(293507, 143, '2015-01-01 00:18:33.000000', 'temperatura', 328.0000, 'ºC'),
	(293508, 143, '2015-01-01 00:18:34.000000', 'temperatura', 402.0000, 'ºC'),
	(293509, 143, '2015-01-01 00:18:35.000000', 'temperatura', 1028.0000, 'ºC'),
	(293510, 143, '2015-01-01 00:18:36.000000', 'temperatura', 332.0000, 'ºC'),
	(293511, 143, '2015-01-01 00:18:37.000000', 'temperatura', 980.0000, 'ºC'),
	(293512, 143, '2015-01-01 00:18:38.000000', 'temperatura', 303.0000, 'ºC'),
	(293513, 143, '2015-01-01 00:18:39.000000', 'temperatura', 974.0000, 'ºC'),
	(293514, 143, '2015-01-01 00:18:40.000000', 'temperatura', 361.0000, 'ºC'),
	(293515, 143, '2015-01-01 00:18:41.000000', 'temperatura', 83.0000, 'ºC'),
	(293516, 143, '2015-01-01 00:18:42.000000', 'temperatura', 532.0000, 'ºC'),
	(293517, 143, '2015-01-01 00:18:43.000000', 'temperatura', 11.0000, 'ºC'),
	(293518, 143, '2015-01-01 00:18:44.000000', 'temperatura', 859.0000, 'ºC'),
	(293519, 143, '2015-01-01 00:18:45.000000', 'temperatura', 664.0000, 'ºC'),
	(293520, 143, '2015-01-01 00:18:46.000000', 'temperatura', 743.0000, 'ºC'),
	(293521, 143, '2015-01-01 00:18:47.000000', 'temperatura', 523.0000, 'ºC'),
	(293522, 143, '2015-01-01 00:18:48.000000', 'temperatura', 387.0000, 'ºC'),
	(293523, 143, '2015-01-01 00:18:49.000000', 'temperatura', 364.0000, 'ºC'),
	(293524, 143, '2015-01-01 00:18:50.000000', 'temperatura', 663.0000, 'ºC'),
	(293525, 143, '2015-01-01 00:18:51.000000', 'temperatura', 1023.0000, 'ºC'),
	(293526, 143, '2015-01-01 00:18:52.000000', 'temperatura', 727.0000, 'ºC'),
	(293527, 143, '2015-01-01 00:18:53.000000', 'temperatura', 567.0000, 'ºC'),
	(293528, 143, '2015-01-01 00:18:54.000000', 'temperatura', 652.0000, 'ºC'),
	(293529, 143, '2015-01-01 00:18:55.000000', 'temperatura', 359.0000, 'ºC'),
	(293530, 143, '2015-01-01 00:18:56.000000', 'temperatura', 1040.0000, 'ºC'),
	(293531, 143, '2015-01-01 00:18:57.000000', 'temperatura', 523.0000, 'ºC'),
	(293532, 143, '2015-01-01 00:18:58.000000', 'temperatura', 696.0000, 'ºC'),
	(293533, 143, '2015-01-01 00:18:59.000000', 'temperatura', 713.0000, 'ºC'),
	(293534, 143, '2015-01-01 00:19:00.000000', 'temperatura', 279.0000, 'ºC'),
	(293535, 143, '2015-01-01 00:19:01.000000', 'temperatura', 453.0000, 'ºC'),
	(293536, 143, '2015-01-01 00:19:02.000000', 'temperatura', 231.0000, 'ºC'),
	(293537, 143, '2015-01-01 00:19:03.000000', 'temperatura', 994.0000, 'ºC'),
	(293538, 143, '2015-01-01 00:19:04.000000', 'temperatura', 680.0000, 'ºC'),
	(293539, 143, '2015-01-01 00:19:05.000000', 'temperatura', 417.0000, 'ºC'),
	(293540, 143, '2015-01-01 00:19:06.000000', 'temperatura', 47.0000, 'ºC'),
	(293541, 143, '2015-01-01 00:19:07.000000', 'temperatura', 182.0000, 'ºC'),
	(293542, 143, '2015-01-01 00:19:08.000000', 'temperatura', 771.0000, 'ºC'),
	(293543, 143, '2015-01-01 00:19:09.000000', 'temperatura', 910.0000, 'ºC'),
	(293544, 143, '2015-01-01 00:19:10.000000', 'temperatura', 1036.0000, 'ºC'),
	(293545, 143, '2015-01-01 00:19:11.000000', 'temperatura', 51.0000, 'ºC'),
	(293546, 143, '2015-01-01 00:19:12.000000', 'temperatura', 748.0000, 'ºC'),
	(293547, 143, '2015-01-01 00:19:13.000000', 'temperatura', 1185.0000, 'ºC'),
	(293548, 143, '2015-01-01 00:19:14.000000', 'temperatura', 84.0000, 'ºC'),
	(293549, 143, '2015-01-01 00:19:15.000000', 'temperatura', 464.0000, 'ºC'),
	(293550, 143, '2015-01-01 00:19:16.000000', 'temperatura', 868.0000, 'ºC'),
	(293551, 143, '2015-01-01 00:19:17.000000', 'temperatura', 548.0000, 'ºC'),
	(293552, 143, '2015-01-01 00:19:18.000000', 'temperatura', 139.0000, 'ºC'),
	(293553, 143, '2015-01-01 00:19:19.000000', 'temperatura', 251.0000, 'ºC'),
	(293554, 143, '2015-01-01 00:19:20.000000', 'temperatura', 839.0000, 'ºC'),
	(293555, 143, '2015-01-01 00:19:21.000000', 'temperatura', 1040.0000, 'ºC'),
	(293556, 143, '2015-01-01 00:19:22.000000', 'temperatura', 284.0000, 'ºC'),
	(293557, 143, '2015-01-01 00:19:23.000000', 'temperatura', 703.0000, 'ºC'),
	(293558, 143, '2015-01-01 00:19:24.000000', 'temperatura', 262.0000, 'ºC'),
	(293559, 143, '2015-01-01 00:19:25.000000', 'temperatura', 403.0000, 'ºC'),
	(293560, 143, '2015-01-01 00:19:26.000000', 'temperatura', 30.0000, 'ºC'),
	(293561, 143, '2015-01-01 00:19:27.000000', 'temperatura', 142.0000, 'ºC'),
	(293562, 143, '2015-01-01 00:19:28.000000', 'temperatura', 618.0000, 'ºC'),
	(293563, 143, '2015-01-01 00:19:29.000000', 'temperatura', 264.0000, 'ºC'),
	(293564, 143, '2015-01-01 00:19:30.000000', 'temperatura', 667.0000, 'ºC'),
	(293565, 143, '2015-01-01 00:19:31.000000', 'temperatura', 142.0000, 'ºC'),
	(293566, 143, '2015-01-01 00:19:32.000000', 'temperatura', 1111.0000, 'ºC'),
	(293567, 143, '2015-01-01 00:19:33.000000', 'temperatura', 331.0000, 'ºC'),
	(293568, 143, '2015-01-01 00:19:34.000000', 'temperatura', 720.0000, 'ºC'),
	(293569, 143, '2015-01-01 00:19:35.000000', 'temperatura', 207.0000, 'ºC'),
	(293570, 143, '2015-01-01 00:19:36.000000', 'temperatura', 75.0000, 'ºC'),
	(293571, 143, '2015-01-01 00:19:37.000000', 'temperatura', 957.0000, 'ºC'),
	(293572, 143, '2015-01-01 00:19:38.000000', 'temperatura', 959.0000, 'ºC'),
	(293573, 143, '2015-01-01 00:19:39.000000', 'temperatura', 727.0000, 'ºC'),
	(293574, 143, '2015-01-01 00:19:40.000000', 'temperatura', 755.0000, 'ºC'),
	(293575, 143, '2015-01-01 00:19:41.000000', 'temperatura', 397.0000, 'ºC'),
	(293576, 143, '2015-01-01 00:19:42.000000', 'temperatura', 921.0000, 'ºC'),
	(293577, 143, '2015-01-01 00:19:43.000000', 'temperatura', 1015.0000, 'ºC'),
	(293578, 143, '2015-01-01 00:19:44.000000', 'temperatura', 1113.0000, 'ºC'),
	(293579, 143, '2015-01-01 00:19:45.000000', 'temperatura', 119.0000, 'ºC'),
	(293580, 143, '2015-01-01 00:19:46.000000', 'temperatura', 856.0000, 'ºC'),
	(293581, 143, '2015-01-01 00:19:47.000000', 'temperatura', 323.0000, 'ºC'),
	(293582, 143, '2015-01-01 00:19:48.000000', 'temperatura', 247.0000, 'ºC'),
	(293583, 143, '2015-01-01 00:19:49.000000', 'temperatura', 268.0000, 'ºC'),
	(293584, 143, '2015-01-01 00:19:50.000000', 'temperatura', 598.0000, 'ºC'),
	(293585, 143, '2015-01-01 00:19:51.000000', 'temperatura', 989.0000, 'ºC'),
	(293586, 143, '2015-01-01 00:19:52.000000', 'temperatura', 752.0000, 'ºC'),
	(293587, 143, '2015-01-01 00:19:53.000000', 'temperatura', 791.0000, 'ºC'),
	(293588, 143, '2015-01-01 00:19:54.000000', 'temperatura', 500.0000, 'ºC'),
	(293589, 143, '2015-01-01 00:19:55.000000', 'temperatura', 130.0000, 'ºC'),
	(293590, 143, '2015-01-01 00:19:56.000000', 'temperatura', 347.0000, 'ºC'),
	(293591, 143, '2015-01-01 00:19:57.000000', 'temperatura', 149.0000, 'ºC'),
	(293592, 143, '2015-01-01 00:19:58.000000', 'temperatura', 901.0000, 'ºC'),
	(293593, 143, '2015-01-01 00:19:59.000000', 'temperatura', 461.0000, 'ºC'),
	(293594, 143, '2015-01-01 00:20:00.000000', 'temperatura', 803.0000, 'ºC'),
	(293595, 143, '2015-01-01 00:20:01.000000', 'temperatura', 230.0000, 'ºC'),
	(293596, 143, '2015-01-01 00:20:02.000000', 'temperatura', 1142.0000, 'ºC'),
	(293597, 143, '2015-01-01 00:20:03.000000', 'temperatura', 222.0000, 'ºC'),
	(293598, 143, '2015-01-01 00:20:04.000000', 'temperatura', 86.0000, 'ºC'),
	(293599, 143, '2015-01-01 00:20:05.000000', 'temperatura', 961.0000, 'ºC'),
	(293600, 143, '2015-01-01 00:20:06.000000', 'temperatura', 949.0000, 'ºC'),
	(293601, 143, '2015-01-01 00:20:07.000000', 'temperatura', 661.0000, 'ºC'),
	(293602, 143, '2015-01-01 00:20:08.000000', 'temperatura', 459.0000, 'ºC'),
	(293603, 143, '2015-01-01 00:20:09.000000', 'temperatura', 314.0000, 'ºC'),
	(293604, 143, '2015-01-01 00:20:10.000000', 'temperatura', 194.0000, 'ºC'),
	(293605, 143, '2015-01-01 00:20:11.000000', 'temperatura', 27.0000, 'ºC'),
	(293606, 143, '2015-01-01 00:20:12.000000', 'temperatura', 753.0000, 'ºC'),
	(293607, 143, '2015-01-01 00:20:13.000000', 'temperatura', 87.0000, 'ºC'),
	(293608, 143, '2015-01-01 00:20:14.000000', 'temperatura', 574.0000, 'ºC'),
	(293609, 143, '2015-01-01 00:20:15.000000', 'temperatura', 210.0000, 'ºC'),
	(293610, 143, '2015-01-01 00:20:16.000000', 'temperatura', 529.0000, 'ºC'),
	(293611, 143, '2015-01-01 00:20:17.000000', 'temperatura', 817.0000, 'ºC'),
	(293612, 143, '2015-01-01 00:20:18.000000', 'temperatura', 96.0000, 'ºC'),
	(293613, 143, '2015-01-01 00:20:19.000000', 'temperatura', 431.0000, 'ºC'),
	(293614, 143, '2015-01-01 00:20:20.000000', 'temperatura', 668.0000, 'ºC'),
	(293615, 143, '2015-01-01 00:20:21.000000', 'temperatura', 846.0000, 'ºC'),
	(293616, 143, '2015-01-01 00:20:22.000000', 'temperatura', 1029.0000, 'ºC'),
	(293617, 143, '2015-01-01 00:20:23.000000', 'temperatura', 206.0000, 'ºC'),
	(293618, 143, '2015-01-01 00:20:24.000000', 'temperatura', 343.0000, 'ºC'),
	(293619, 143, '2015-01-01 00:20:25.000000', 'temperatura', 1098.0000, 'ºC'),
	(293620, 143, '2015-01-01 00:20:26.000000', 'temperatura', 860.0000, 'ºC'),
	(293621, 143, '2015-01-01 00:20:27.000000', 'temperatura', 1007.0000, 'ºC'),
	(293622, 143, '2015-01-01 00:20:28.000000', 'temperatura', 55.0000, 'ºC'),
	(293623, 143, '2015-01-01 00:20:29.000000', 'temperatura', 853.0000, 'ºC'),
	(293624, 143, '2015-01-01 00:20:30.000000', 'temperatura', 503.0000, 'ºC'),
	(293625, 143, '2015-01-01 00:20:31.000000', 'temperatura', 1154.0000, 'ºC'),
	(293626, 143, '2015-01-01 00:20:32.000000', 'temperatura', 662.0000, 'ºC'),
	(293627, 143, '2015-01-01 00:20:33.000000', 'temperatura', 1047.0000, 'ºC'),
	(293628, 143, '2015-01-01 00:20:34.000000', 'temperatura', 851.0000, 'ºC'),
	(293629, 143, '2015-01-01 00:20:35.000000', 'temperatura', 1113.0000, 'ºC'),
	(293630, 143, '2015-01-01 00:20:36.000000', 'temperatura', 612.0000, 'ºC'),
	(293631, 143, '2015-01-01 00:20:37.000000', 'temperatura', 922.0000, 'ºC'),
	(293632, 143, '2015-01-01 00:20:38.000000', 'temperatura', 375.0000, 'ºC'),
	(293633, 143, '2015-01-01 00:20:39.000000', 'temperatura', 308.0000, 'ºC'),
	(293634, 143, '2015-01-01 00:20:40.000000', 'temperatura', 415.0000, 'ºC'),
	(293635, 143, '2015-01-01 00:20:41.000000', 'temperatura', 1151.0000, 'ºC'),
	(293636, 143, '2015-01-01 00:20:42.000000', 'temperatura', 913.0000, 'ºC'),
	(293637, 143, '2015-01-01 00:20:43.000000', 'temperatura', 1109.0000, 'ºC'),
	(293638, 143, '2015-01-01 00:20:44.000000', 'temperatura', 410.0000, 'ºC'),
	(293639, 143, '2015-01-01 00:20:45.000000', 'temperatura', 1124.0000, 'ºC'),
	(293640, 143, '2015-01-01 00:20:46.000000', 'temperatura', 789.0000, 'ºC'),
	(293641, 143, '2015-01-01 00:20:47.000000', 'temperatura', 572.0000, 'ºC'),
	(293642, 143, '2015-01-01 00:20:48.000000', 'temperatura', 496.0000, 'ºC'),
	(293643, 143, '2015-01-01 00:20:49.000000', 'temperatura', 762.0000, 'ºC'),
	(293644, 143, '2015-01-01 00:20:50.000000', 'temperatura', 1122.0000, 'ºC'),
	(293645, 143, '2015-01-01 00:20:51.000000', 'temperatura', 927.0000, 'ºC'),
	(293646, 143, '2015-01-01 00:20:52.000000', 'temperatura', 69.0000, 'ºC'),
	(293647, 143, '2015-01-01 00:20:53.000000', 'temperatura', 1166.0000, 'ºC'),
	(293648, 143, '2015-01-01 00:20:54.000000', 'temperatura', 822.0000, 'ºC'),
	(293649, 143, '2015-01-01 00:20:55.000000', 'temperatura', 613.0000, 'ºC'),
	(293650, 143, '2015-01-01 00:20:56.000000', 'temperatura', 598.0000, 'ºC'),
	(293651, 143, '2015-01-01 00:20:57.000000', 'temperatura', 1151.0000, 'ºC'),
	(293652, 143, '2015-01-01 00:20:58.000000', 'temperatura', 363.0000, 'ºC'),
	(293653, 143, '2015-01-01 00:20:59.000000', 'temperatura', 762.0000, 'ºC'),
	(293654, 143, '2015-01-01 00:21:00.000000', 'temperatura', 322.0000, 'ºC'),
	(293655, 143, '2015-01-01 00:21:01.000000', 'temperatura', 523.0000, 'ºC'),
	(293656, 143, '2015-01-01 00:21:02.000000', 'temperatura', 451.0000, 'ºC'),
	(293657, 143, '2015-01-01 00:21:03.000000', 'temperatura', 685.0000, 'ºC'),
	(293658, 143, '2015-01-01 00:21:04.000000', 'temperatura', 873.0000, 'ºC'),
	(293659, 143, '2015-01-01 00:21:05.000000', 'temperatura', 1110.0000, 'ºC'),
	(293660, 143, '2015-01-01 00:21:06.000000', 'temperatura', 533.0000, 'ºC'),
	(293661, 143, '2015-01-01 00:21:07.000000', 'temperatura', 535.0000, 'ºC'),
	(293662, 143, '2015-01-01 00:21:08.000000', 'temperatura', 1078.0000, 'ºC'),
	(293663, 143, '2015-01-01 00:21:09.000000', 'temperatura', 185.0000, 'ºC'),
	(293664, 143, '2015-01-01 00:21:10.000000', 'temperatura', 90.0000, 'ºC'),
	(293665, 143, '2015-01-01 00:21:11.000000', 'temperatura', 1098.0000, 'ºC'),
	(293666, 143, '2015-01-01 00:21:12.000000', 'temperatura', 418.0000, 'ºC'),
	(293667, 143, '2015-01-01 00:21:13.000000', 'temperatura', 1196.0000, 'ºC'),
	(293668, 143, '2015-01-01 00:21:14.000000', 'temperatura', 1126.0000, 'ºC'),
	(293669, 143, '2015-01-01 00:21:15.000000', 'temperatura', 842.0000, 'ºC'),
	(293670, 143, '2015-01-01 00:21:16.000000', 'temperatura', 834.0000, 'ºC'),
	(293671, 143, '2015-01-01 00:21:17.000000', 'temperatura', 444.0000, 'ºC'),
	(293672, 143, '2015-01-01 00:21:18.000000', 'temperatura', 919.0000, 'ºC'),
	(293673, 143, '2015-01-01 00:21:19.000000', 'temperatura', 863.0000, 'ºC'),
	(293674, 143, '2015-01-01 00:21:20.000000', 'temperatura', 357.0000, 'ºC'),
	(293675, 143, '2015-01-01 00:21:21.000000', 'temperatura', 396.0000, 'ºC'),
	(293676, 143, '2015-01-01 00:21:22.000000', 'temperatura', 911.0000, 'ºC'),
	(293677, 143, '2015-01-01 00:21:23.000000', 'temperatura', 965.0000, 'ºC'),
	(293678, 143, '2015-01-01 00:21:24.000000', 'temperatura', 895.0000, 'ºC'),
	(293679, 143, '2015-01-01 00:21:25.000000', 'temperatura', 382.0000, 'ºC'),
	(293680, 143, '2015-01-01 00:21:26.000000', 'temperatura', 423.0000, 'ºC'),
	(293681, 143, '2015-01-01 00:21:27.000000', 'temperatura', 969.0000, 'ºC'),
	(293682, 143, '2015-01-01 00:21:28.000000', 'temperatura', 1179.0000, 'ºC'),
	(293683, 143, '2015-01-01 00:21:29.000000', 'temperatura', 587.0000, 'ºC'),
	(293684, 143, '2015-01-01 00:21:30.000000', 'temperatura', 597.0000, 'ºC'),
	(293685, 143, '2015-01-01 00:21:31.000000', 'temperatura', 26.0000, 'ºC'),
	(293686, 143, '2015-01-01 00:21:32.000000', 'temperatura', 738.0000, 'ºC'),
	(293687, 143, '2015-01-01 00:21:33.000000', 'temperatura', 11.0000, 'ºC'),
	(293688, 143, '2015-01-01 00:21:34.000000', 'temperatura', 245.0000, 'ºC'),
	(293689, 143, '2015-01-01 00:21:35.000000', 'temperatura', 1191.0000, 'ºC'),
	(293690, 143, '2015-01-01 00:21:36.000000', 'temperatura', 422.0000, 'ºC'),
	(293691, 143, '2015-01-01 00:21:37.000000', 'temperatura', 938.0000, 'ºC'),
	(293692, 143, '2015-01-01 00:21:38.000000', 'temperatura', 1025.0000, 'ºC'),
	(293693, 143, '2015-01-01 00:21:39.000000', 'temperatura', 1112.0000, 'ºC'),
	(293694, 143, '2015-01-01 00:21:40.000000', 'temperatura', 84.0000, 'ºC'),
	(293695, 143, '2015-01-01 00:21:41.000000', 'temperatura', 684.0000, 'ºC'),
	(293696, 143, '2015-01-01 00:21:42.000000', 'temperatura', 768.0000, 'ºC'),
	(293697, 143, '2015-01-01 00:21:43.000000', 'temperatura', 591.0000, 'ºC'),
	(293698, 143, '2015-01-01 00:21:44.000000', 'temperatura', 651.0000, 'ºC'),
	(293699, 143, '2015-01-01 00:21:45.000000', 'temperatura', 284.0000, 'ºC'),
	(293700, 143, '2015-01-01 00:21:46.000000', 'temperatura', 666.0000, 'ºC'),
	(293701, 143, '2015-01-01 00:21:47.000000', 'temperatura', 80.0000, 'ºC'),
	(293702, 143, '2015-01-01 00:21:48.000000', 'temperatura', 802.0000, 'ºC'),
	(293703, 143, '2015-01-01 00:21:49.000000', 'temperatura', 171.0000, 'ºC'),
	(293704, 143, '2015-01-01 00:21:50.000000', 'temperatura', 848.0000, 'ºC'),
	(293705, 143, '2015-01-01 00:21:51.000000', 'temperatura', 127.0000, 'ºC'),
	(293706, 143, '2015-01-01 00:21:52.000000', 'temperatura', 492.0000, 'ºC'),
	(293707, 143, '2015-01-01 00:21:53.000000', 'temperatura', 881.0000, 'ºC'),
	(293708, 143, '2015-01-01 00:21:54.000000', 'temperatura', 530.0000, 'ºC'),
	(293709, 143, '2015-01-01 00:21:55.000000', 'temperatura', 7.0000, 'ºC'),
	(293710, 143, '2015-01-01 00:21:56.000000', 'temperatura', 846.0000, 'ºC'),
	(293711, 143, '2015-01-01 00:21:57.000000', 'temperatura', 610.0000, 'ºC'),
	(293712, 143, '2015-01-01 00:21:58.000000', 'temperatura', 511.0000, 'ºC'),
	(293713, 143, '2015-01-01 00:21:59.000000', 'temperatura', 725.0000, 'ºC'),
	(293714, 143, '2015-01-01 00:22:00.000000', 'temperatura', 892.0000, 'ºC'),
	(293715, 143, '2015-01-01 00:22:01.000000', 'temperatura', 1086.0000, 'ºC'),
	(293716, 143, '2015-01-01 00:22:02.000000', 'temperatura', 354.0000, 'ºC'),
	(293717, 143, '2015-01-01 00:22:03.000000', 'temperatura', 913.0000, 'ºC'),
	(293718, 143, '2015-01-01 00:22:04.000000', 'temperatura', 1103.0000, 'ºC'),
	(293719, 143, '2015-01-01 00:22:05.000000', 'temperatura', 375.0000, 'ºC'),
	(293720, 143, '2015-01-01 00:22:06.000000', 'temperatura', 967.0000, 'ºC'),
	(293721, 143, '2015-01-01 00:22:07.000000', 'temperatura', 113.0000, 'ºC'),
	(293722, 143, '2015-01-01 00:22:08.000000', 'temperatura', 62.0000, 'ºC'),
	(293723, 143, '2015-01-01 00:22:09.000000', 'temperatura', 1174.0000, 'ºC'),
	(293724, 143, '2015-01-01 00:22:10.000000', 'temperatura', 884.0000, 'ºC'),
	(293725, 143, '2015-01-01 00:22:11.000000', 'temperatura', 898.0000, 'ºC'),
	(293726, 143, '2015-01-01 00:22:12.000000', 'temperatura', 639.0000, 'ºC'),
	(293727, 143, '2015-01-01 00:22:13.000000', 'temperatura', 499.0000, 'ºC'),
	(293728, 143, '2015-01-01 00:22:14.000000', 'temperatura', 581.0000, 'ºC'),
	(293729, 143, '2015-01-01 00:22:15.000000', 'temperatura', 207.0000, 'ºC'),
	(293730, 143, '2015-01-01 00:22:16.000000', 'temperatura', 492.0000, 'ºC'),
	(293731, 143, '2015-01-01 00:22:17.000000', 'temperatura', 642.0000, 'ºC'),
	(293732, 143, '2015-01-01 00:22:18.000000', 'temperatura', 534.0000, 'ºC'),
	(293733, 143, '2015-01-01 00:22:19.000000', 'temperatura', 744.0000, 'ºC'),
	(293734, 143, '2015-01-01 00:22:20.000000', 'temperatura', 918.0000, 'ºC'),
	(293735, 143, '2015-01-01 00:22:21.000000', 'temperatura', 1160.0000, 'ºC'),
	(293736, 143, '2015-01-01 00:22:22.000000', 'temperatura', 648.0000, 'ºC'),
	(293737, 143, '2015-01-01 00:22:23.000000', 'temperatura', 957.0000, 'ºC'),
	(293738, 143, '2015-01-01 00:22:24.000000', 'temperatura', 445.0000, 'ºC'),
	(293739, 143, '2015-01-01 00:22:25.000000', 'temperatura', 551.0000, 'ºC'),
	(293740, 143, '2015-01-01 00:22:26.000000', 'temperatura', 222.0000, 'ºC'),
	(293741, 143, '2015-01-01 00:22:27.000000', 'temperatura', 655.0000, 'ºC'),
	(293742, 143, '2015-01-01 00:22:28.000000', 'temperatura', 213.0000, 'ºC'),
	(293743, 143, '2015-01-01 00:22:29.000000', 'temperatura', 299.0000, 'ºC'),
	(293744, 143, '2015-01-01 00:22:30.000000', 'temperatura', 856.0000, 'ºC'),
	(293745, 143, '2015-01-01 00:22:31.000000', 'temperatura', 983.0000, 'ºC'),
	(293746, 143, '2015-01-01 00:22:32.000000', 'temperatura', 1149.0000, 'ºC'),
	(293747, 143, '2015-01-01 00:22:33.000000', 'temperatura', 396.0000, 'ºC'),
	(293748, 143, '2015-01-01 00:22:34.000000', 'temperatura', 933.0000, 'ºC'),
	(293749, 143, '2015-01-01 00:22:35.000000', 'temperatura', 1077.0000, 'ºC'),
	(293750, 143, '2015-01-01 00:22:36.000000', 'temperatura', 187.0000, 'ºC'),
	(293751, 143, '2015-01-01 00:22:37.000000', 'temperatura', 106.0000, 'ºC'),
	(293752, 143, '2015-01-01 00:22:38.000000', 'temperatura', 1169.0000, 'ºC'),
	(293753, 143, '2015-01-01 00:22:39.000000', 'temperatura', 726.0000, 'ºC'),
	(293754, 143, '2015-01-01 00:22:40.000000', 'temperatura', 123.0000, 'ºC'),
	(293755, 143, '2015-01-01 00:22:41.000000', 'temperatura', 839.0000, 'ºC'),
	(293756, 143, '2015-01-01 00:22:42.000000', 'temperatura', 225.0000, 'ºC'),
	(293757, 143, '2015-01-01 00:22:43.000000', 'temperatura', 1011.0000, 'ºC'),
	(293758, 143, '2015-01-01 00:22:44.000000', 'temperatura', 780.0000, 'ºC'),
	(293759, 143, '2015-01-01 00:22:45.000000', 'temperatura', 868.0000, 'ºC'),
	(293760, 143, '2015-01-01 00:22:46.000000', 'temperatura', 800.0000, 'ºC'),
	(293761, 143, '2015-01-01 00:22:47.000000', 'temperatura', 198.0000, 'ºC'),
	(293762, 143, '2015-01-01 00:22:48.000000', 'temperatura', 988.0000, 'ºC'),
	(293763, 143, '2015-01-01 00:22:49.000000', 'temperatura', 748.0000, 'ºC'),
	(293764, 143, '2015-01-01 00:22:50.000000', 'temperatura', 778.0000, 'ºC'),
	(293765, 143, '2015-01-01 00:22:51.000000', 'temperatura', 445.0000, 'ºC'),
	(293766, 143, '2015-01-01 00:22:52.000000', 'temperatura', 1093.0000, 'ºC'),
	(293767, 143, '2015-01-01 00:22:53.000000', 'temperatura', 531.0000, 'ºC'),
	(293768, 143, '2015-01-01 00:22:54.000000', 'temperatura', 574.0000, 'ºC'),
	(293769, 143, '2015-01-01 00:22:55.000000', 'temperatura', 81.0000, 'ºC'),
	(293770, 143, '2015-01-01 00:22:56.000000', 'temperatura', 1080.0000, 'ºC'),
	(293771, 143, '2015-01-01 00:22:57.000000', 'temperatura', 360.0000, 'ºC'),
	(293772, 143, '2015-01-01 00:22:58.000000', 'temperatura', 961.0000, 'ºC'),
	(293773, 143, '2015-01-01 00:22:59.000000', 'temperatura', 123.0000, 'ºC'),
	(293774, 143, '2015-01-01 00:23:00.000000', 'temperatura', 133.0000, 'ºC'),
	(293775, 143, '2015-01-01 00:23:01.000000', 'temperatura', 296.0000, 'ºC'),
	(293776, 143, '2015-01-01 00:23:02.000000', 'temperatura', 1082.0000, 'ºC'),
	(293777, 143, '2015-01-01 00:23:03.000000', 'temperatura', 923.0000, 'ºC'),
	(293778, 143, '2015-01-01 00:23:04.000000', 'temperatura', 169.0000, 'ºC'),
	(293779, 143, '2015-01-01 00:23:05.000000', 'temperatura', 477.0000, 'ºC'),
	(293780, 143, '2015-01-01 00:23:06.000000', 'temperatura', 679.0000, 'ºC'),
	(293781, 143, '2015-01-01 00:23:07.000000', 'temperatura', 763.0000, 'ºC'),
	(293782, 143, '2015-01-01 00:23:08.000000', 'temperatura', 577.0000, 'ºC'),
	(293783, 143, '2015-01-01 00:23:09.000000', 'temperatura', 599.0000, 'ºC'),
	(293784, 143, '2015-01-01 00:23:10.000000', 'temperatura', 62.0000, 'ºC'),
	(293785, 143, '2015-01-01 00:23:11.000000', 'temperatura', 916.0000, 'ºC'),
	(293786, 143, '2015-01-01 00:23:12.000000', 'temperatura', 793.0000, 'ºC'),
	(293787, 143, '2015-01-01 00:23:13.000000', 'temperatura', 18.0000, 'ºC'),
	(293788, 143, '2015-01-01 00:23:14.000000', 'temperatura', 113.0000, 'ºC'),
	(293789, 143, '2015-01-01 00:23:15.000000', 'temperatura', 509.0000, 'ºC'),
	(293790, 143, '2015-01-01 00:23:16.000000', 'temperatura', 1006.0000, 'ºC'),
	(293791, 143, '2015-01-01 00:23:17.000000', 'temperatura', 1106.0000, 'ºC'),
	(293792, 143, '2015-01-01 00:23:18.000000', 'temperatura', 111.0000, 'ºC'),
	(293793, 143, '2015-01-01 00:23:19.000000', 'temperatura', 839.0000, 'ºC'),
	(293794, 143, '2015-01-01 00:23:20.000000', 'temperatura', 262.0000, 'ºC'),
	(293795, 143, '2015-01-01 00:23:21.000000', 'temperatura', 1192.0000, 'ºC'),
	(293796, 143, '2015-01-01 00:23:22.000000', 'temperatura', 374.0000, 'ºC'),
	(293797, 143, '2015-01-01 00:23:23.000000', 'temperatura', 696.0000, 'ºC'),
	(293798, 143, '2015-01-01 00:23:24.000000', 'temperatura', 1160.0000, 'ºC'),
	(293799, 143, '2015-01-01 00:23:25.000000', 'temperatura', 111.0000, 'ºC'),
	(293800, 143, '2015-01-01 00:23:26.000000', 'temperatura', 674.0000, 'ºC'),
	(293801, 143, '2015-01-01 00:23:27.000000', 'temperatura', 637.0000, 'ºC'),
	(293802, 143, '2015-01-01 00:23:28.000000', 'temperatura', 1163.0000, 'ºC'),
	(293803, 143, '2015-01-01 00:23:29.000000', 'temperatura', 305.0000, 'ºC'),
	(293804, 143, '2015-01-01 00:23:30.000000', 'temperatura', 437.0000, 'ºC'),
	(293805, 143, '2015-01-01 00:23:31.000000', 'temperatura', 70.0000, 'ºC'),
	(293806, 143, '2015-01-01 00:23:32.000000', 'temperatura', 242.0000, 'ºC'),
	(293807, 143, '2015-01-01 00:23:33.000000', 'temperatura', 997.0000, 'ºC'),
	(293808, 143, '2015-01-01 00:23:34.000000', 'temperatura', 663.0000, 'ºC'),
	(293809, 143, '2015-01-01 00:23:35.000000', 'temperatura', 322.0000, 'ºC'),
	(293810, 143, '2015-01-01 00:23:36.000000', 'temperatura', 824.0000, 'ºC'),
	(293811, 143, '2015-01-01 00:23:37.000000', 'temperatura', 754.0000, 'ºC'),
	(293812, 143, '2015-01-01 00:23:38.000000', 'temperatura', 99.0000, 'ºC'),
	(293813, 143, '2015-01-01 00:23:39.000000', 'temperatura', 635.0000, 'ºC'),
	(293814, 143, '2015-01-01 00:23:40.000000', 'temperatura', 475.0000, 'ºC'),
	(293815, 143, '2015-01-01 00:23:41.000000', 'temperatura', 471.0000, 'ºC'),
	(293816, 143, '2015-01-01 00:23:42.000000', 'temperatura', 933.0000, 'ºC'),
	(293817, 143, '2015-01-01 00:23:43.000000', 'temperatura', 852.0000, 'ºC'),
	(293818, 143, '2015-01-01 00:23:44.000000', 'temperatura', 261.0000, 'ºC'),
	(293819, 143, '2015-01-01 00:23:45.000000', 'temperatura', 1148.0000, 'ºC'),
	(293820, 143, '2015-01-01 00:23:46.000000', 'temperatura', 159.0000, 'ºC'),
	(293821, 143, '2015-01-01 00:23:47.000000', 'temperatura', 951.0000, 'ºC'),
	(293822, 143, '2015-01-01 00:23:48.000000', 'temperatura', 681.0000, 'ºC'),
	(293823, 143, '2015-01-01 00:23:49.000000', 'temperatura', 550.0000, 'ºC'),
	(293824, 143, '2015-01-01 00:23:50.000000', 'temperatura', 707.0000, 'ºC'),
	(293825, 143, '2015-01-01 00:23:51.000000', 'temperatura', 686.0000, 'ºC'),
	(293826, 143, '2015-01-01 00:23:52.000000', 'temperatura', 108.0000, 'ºC'),
	(293827, 143, '2015-01-01 00:23:53.000000', 'temperatura', 883.0000, 'ºC'),
	(293828, 143, '2015-01-01 00:23:54.000000', 'temperatura', 492.0000, 'ºC'),
	(293829, 143, '2015-01-01 00:23:55.000000', 'temperatura', 1011.0000, 'ºC'),
	(293830, 143, '2015-01-01 00:23:56.000000', 'temperatura', 1182.0000, 'ºC'),
	(293831, 143, '2015-01-01 00:23:57.000000', 'temperatura', 474.0000, 'ºC'),
	(293832, 143, '2015-01-01 00:23:58.000000', 'temperatura', 26.0000, 'ºC'),
	(293833, 143, '2015-01-01 00:23:59.000000', 'temperatura', 1107.0000, 'ºC'),
	(293834, 143, '2015-01-01 00:24:00.000000', 'temperatura', 659.0000, 'ºC'),
	(293835, 143, '2015-01-01 00:24:01.000000', 'temperatura', 1173.0000, 'ºC'),
	(293836, 143, '2015-01-01 00:24:02.000000', 'temperatura', 288.0000, 'ºC'),
	(293837, 143, '2015-01-01 00:24:03.000000', 'temperatura', 322.0000, 'ºC'),
	(293838, 143, '2015-01-01 00:24:04.000000', 'temperatura', 749.0000, 'ºC'),
	(293839, 143, '2015-01-01 00:24:05.000000', 'temperatura', 376.0000, 'ºC'),
	(293840, 143, '2015-01-01 00:24:06.000000', 'temperatura', 836.0000, 'ºC'),
	(293841, 143, '2015-01-01 00:24:07.000000', 'temperatura', 652.0000, 'ºC'),
	(293842, 143, '2015-01-01 00:24:08.000000', 'temperatura', 753.0000, 'ºC'),
	(293843, 143, '2015-01-01 00:24:09.000000', 'temperatura', 611.0000, 'ºC'),
	(293844, 143, '2015-01-01 00:24:10.000000', 'temperatura', 795.0000, 'ºC'),
	(293845, 143, '2015-01-01 00:24:11.000000', 'temperatura', 944.0000, 'ºC'),
	(293846, 143, '2015-01-01 00:24:12.000000', 'temperatura', 1134.0000, 'ºC'),
	(293847, 143, '2015-01-01 00:24:13.000000', 'temperatura', 441.0000, 'ºC'),
	(293848, 143, '2015-01-01 00:24:14.000000', 'temperatura', 2.0000, 'ºC'),
	(293849, 143, '2015-01-01 00:24:15.000000', 'temperatura', 1086.0000, 'ºC'),
	(293850, 143, '2015-01-01 00:24:16.000000', 'temperatura', 626.0000, 'ºC'),
	(293851, 143, '2015-01-01 00:24:17.000000', 'temperatura', 1073.0000, 'ºC'),
	(293852, 143, '2015-01-01 00:24:18.000000', 'temperatura', 1088.0000, 'ºC'),
	(293853, 143, '2015-01-01 00:24:19.000000', 'temperatura', 1023.0000, 'ºC'),
	(293854, 143, '2015-01-01 00:24:20.000000', 'temperatura', 649.0000, 'ºC'),
	(293855, 143, '2015-01-01 00:24:21.000000', 'temperatura', 179.0000, 'ºC'),
	(293856, 143, '2015-01-01 00:24:22.000000', 'temperatura', 148.0000, 'ºC'),
	(293857, 143, '2015-01-01 00:24:23.000000', 'temperatura', 203.0000, 'ºC'),
	(293858, 143, '2015-01-01 00:24:24.000000', 'temperatura', 570.0000, 'ºC'),
	(293859, 143, '2015-01-01 00:24:25.000000', 'temperatura', 1043.0000, 'ºC'),
	(293860, 143, '2015-01-01 00:24:26.000000', 'temperatura', 1105.0000, 'ºC'),
	(293861, 143, '2015-01-01 00:24:27.000000', 'temperatura', 1198.0000, 'ºC'),
	(293862, 143, '2015-01-01 00:24:28.000000', 'temperatura', 274.0000, 'ºC'),
	(293863, 143, '2015-01-01 00:24:29.000000', 'temperatura', 176.0000, 'ºC'),
	(293864, 143, '2015-01-01 00:24:30.000000', 'temperatura', 58.0000, 'ºC'),
	(293865, 143, '2015-01-01 00:24:31.000000', 'temperatura', 963.0000, 'ºC'),
	(293866, 143, '2015-01-01 00:24:32.000000', 'temperatura', 1043.0000, 'ºC'),
	(293867, 143, '2015-01-01 00:24:33.000000', 'temperatura', 1124.0000, 'ºC'),
	(293868, 143, '2015-01-01 00:24:34.000000', 'temperatura', 91.0000, 'ºC'),
	(293869, 143, '2015-01-01 00:24:35.000000', 'temperatura', 686.0000, 'ºC'),
	(293870, 143, '2015-01-01 00:24:36.000000', 'temperatura', 755.0000, 'ºC'),
	(293871, 143, '2015-01-01 00:24:37.000000', 'temperatura', 518.0000, 'ºC'),
	(293872, 143, '2015-01-01 00:24:38.000000', 'temperatura', 324.0000, 'ºC'),
	(293873, 143, '2015-01-01 00:24:39.000000', 'temperatura', 67.0000, 'ºC'),
	(293874, 143, '2015-01-01 00:24:40.000000', 'temperatura', 564.0000, 'ºC'),
	(293875, 143, '2015-01-01 00:24:41.000000', 'temperatura', 221.0000, 'ºC'),
	(293876, 143, '2015-01-01 00:24:42.000000', 'temperatura', 614.0000, 'ºC'),
	(293877, 143, '2015-01-01 00:24:43.000000', 'temperatura', 5.0000, 'ºC'),
	(293878, 143, '2015-01-01 00:24:44.000000', 'temperatura', 586.0000, 'ºC'),
	(293879, 143, '2015-01-01 00:24:45.000000', 'temperatura', 516.0000, 'ºC'),
	(293880, 143, '2015-01-01 00:24:46.000000', 'temperatura', 822.0000, 'ºC'),
	(293881, 143, '2015-01-01 00:24:47.000000', 'temperatura', 163.0000, 'ºC'),
	(293882, 143, '2015-01-01 00:24:48.000000', 'temperatura', 751.0000, 'ºC'),
	(293883, 143, '2015-01-01 00:24:49.000000', 'temperatura', 864.0000, 'ºC'),
	(293884, 143, '2015-01-01 00:24:50.000000', 'temperatura', 869.0000, 'ºC'),
	(293885, 143, '2015-01-01 00:24:51.000000', 'temperatura', 554.0000, 'ºC'),
	(293886, 143, '2015-01-01 00:24:52.000000', 'temperatura', 161.0000, 'ºC'),
	(293887, 143, '2015-01-01 00:24:53.000000', 'temperatura', 346.0000, 'ºC'),
	(293888, 143, '2015-01-01 00:24:54.000000', 'temperatura', 46.0000, 'ºC'),
	(293889, 143, '2015-01-01 00:24:55.000000', 'temperatura', 393.0000, 'ºC'),
	(293890, 143, '2015-01-01 00:24:56.000000', 'temperatura', 626.0000, 'ºC'),
	(293891, 143, '2015-01-01 00:24:57.000000', 'temperatura', 754.0000, 'ºC'),
	(293892, 143, '2015-01-01 00:24:58.000000', 'temperatura', 690.0000, 'ºC'),
	(293893, 143, '2015-01-01 00:24:59.000000', 'temperatura', 1189.0000, 'ºC'),
	(293894, 143, '2015-01-01 00:25:00.000000', 'temperatura', 275.0000, 'ºC'),
	(293895, 143, '2015-01-01 00:25:01.000000', 'temperatura', 208.0000, 'ºC'),
	(293896, 143, '2015-01-01 00:25:02.000000', 'temperatura', 215.0000, 'ºC'),
	(293897, 143, '2015-01-01 00:25:03.000000', 'temperatura', 453.0000, 'ºC'),
	(293898, 143, '2015-01-01 00:25:04.000000', 'temperatura', 418.0000, 'ºC'),
	(293899, 143, '2015-01-01 00:25:05.000000', 'temperatura', 734.0000, 'ºC'),
	(293900, 143, '2015-01-01 00:25:06.000000', 'temperatura', 15.0000, 'ºC'),
	(293901, 143, '2015-01-01 00:25:07.000000', 'temperatura', 272.0000, 'ºC'),
	(293902, 143, '2015-01-01 00:25:08.000000', 'temperatura', 119.0000, 'ºC'),
	(293903, 143, '2015-01-01 00:25:09.000000', 'temperatura', 976.0000, 'ºC'),
	(293904, 143, '2015-01-01 00:25:10.000000', 'temperatura', 927.0000, 'ºC'),
	(293905, 143, '2015-01-01 00:25:11.000000', 'temperatura', 505.0000, 'ºC'),
	(293906, 143, '2015-01-01 00:25:12.000000', 'temperatura', 946.0000, 'ºC'),
	(293907, 143, '2015-01-01 00:25:13.000000', 'temperatura', 815.0000, 'ºC'),
	(293908, 143, '2015-01-01 00:25:14.000000', 'temperatura', 38.0000, 'ºC'),
	(293909, 143, '2015-01-01 00:25:15.000000', 'temperatura', 146.0000, 'ºC'),
	(293910, 143, '2015-01-01 00:25:16.000000', 'temperatura', 614.0000, 'ºC'),
	(293911, 143, '2015-01-01 00:25:17.000000', 'temperatura', 233.0000, 'ºC'),
	(293912, 143, '2015-01-01 00:25:18.000000', 'temperatura', 524.0000, 'ºC'),
	(293913, 143, '2015-01-01 00:25:19.000000', 'temperatura', 723.0000, 'ºC'),
	(293914, 143, '2015-01-01 00:25:20.000000', 'temperatura', 841.0000, 'ºC'),
	(293915, 143, '2015-01-01 00:25:21.000000', 'temperatura', 837.0000, 'ºC'),
	(293916, 143, '2015-01-01 00:25:22.000000', 'temperatura', 463.0000, 'ºC'),
	(293917, 143, '2015-01-01 00:25:23.000000', 'temperatura', 1006.0000, 'ºC'),
	(293918, 143, '2015-01-01 00:25:24.000000', 'temperatura', 40.0000, 'ºC'),
	(293919, 143, '2015-01-01 00:25:25.000000', 'temperatura', 784.0000, 'ºC'),
	(293920, 143, '2015-01-01 00:25:26.000000', 'temperatura', 200.0000, 'ºC'),
	(293921, 143, '2015-01-01 00:25:27.000000', 'temperatura', 1047.0000, 'ºC'),
	(293922, 143, '2015-01-01 00:25:28.000000', 'temperatura', 1037.0000, 'ºC'),
	(293923, 143, '2015-01-01 00:25:29.000000', 'temperatura', 846.0000, 'ºC'),
	(293924, 143, '2015-01-01 00:25:30.000000', 'temperatura', 1118.0000, 'ºC'),
	(293925, 143, '2015-01-01 00:25:31.000000', 'temperatura', 655.0000, 'ºC'),
	(293926, 143, '2015-01-01 00:25:32.000000', 'temperatura', 1119.0000, 'ºC'),
	(293927, 143, '2015-01-01 00:25:33.000000', 'temperatura', 30.0000, 'ºC'),
	(293928, 143, '2015-01-01 00:25:34.000000', 'temperatura', 394.0000, 'ºC'),
	(293929, 143, '2015-01-01 00:25:35.000000', 'temperatura', 682.0000, 'ºC'),
	(293930, 143, '2015-01-01 00:25:36.000000', 'temperatura', 1026.0000, 'ºC'),
	(293931, 143, '2015-01-01 00:25:37.000000', 'temperatura', 684.0000, 'ºC'),
	(293932, 143, '2015-01-01 00:25:38.000000', 'temperatura', 345.0000, 'ºC'),
	(293933, 143, '2015-01-01 00:25:39.000000', 'temperatura', 872.0000, 'ºC'),
	(293934, 143, '2015-01-01 00:25:40.000000', 'temperatura', 928.0000, 'ºC'),
	(293935, 143, '2015-01-01 00:25:41.000000', 'temperatura', 821.0000, 'ºC'),
	(293936, 143, '2015-01-01 00:25:42.000000', 'temperatura', 124.0000, 'ºC'),
	(293937, 143, '2015-01-01 00:25:43.000000', 'temperatura', 557.0000, 'ºC'),
	(293938, 143, '2015-01-01 00:25:44.000000', 'temperatura', 15.0000, 'ºC'),
	(293939, 143, '2015-01-01 00:25:45.000000', 'temperatura', 802.0000, 'ºC'),
	(293940, 143, '2015-01-01 00:25:46.000000', 'temperatura', 368.0000, 'ºC'),
	(293941, 143, '2015-01-01 00:25:47.000000', 'temperatura', 634.0000, 'ºC'),
	(293942, 143, '2015-01-01 00:25:48.000000', 'temperatura', 868.0000, 'ºC'),
	(293943, 143, '2015-01-01 00:25:49.000000', 'temperatura', 36.0000, 'ºC'),
	(293944, 143, '2015-01-01 00:25:50.000000', 'temperatura', 1176.0000, 'ºC'),
	(293945, 143, '2015-01-01 00:25:51.000000', 'temperatura', 975.0000, 'ºC'),
	(293946, 143, '2015-01-01 00:25:52.000000', 'temperatura', 147.0000, 'ºC'),
	(293947, 143, '2015-01-01 00:25:53.000000', 'temperatura', 209.0000, 'ºC'),
	(293948, 143, '2015-01-01 00:25:54.000000', 'temperatura', 603.0000, 'ºC'),
	(293949, 143, '2015-01-01 00:25:55.000000', 'temperatura', 1192.0000, 'ºC'),
	(293950, 143, '2015-01-01 00:25:56.000000', 'temperatura', 549.0000, 'ºC'),
	(293951, 143, '2015-01-01 00:25:57.000000', 'temperatura', 371.0000, 'ºC'),
	(293952, 143, '2015-01-01 00:25:58.000000', 'temperatura', 210.0000, 'ºC'),
	(293953, 143, '2015-01-01 00:25:59.000000', 'temperatura', 1136.0000, 'ºC'),
	(293954, 143, '2015-01-01 00:26:00.000000', 'temperatura', 252.0000, 'ºC'),
	(293955, 143, '2015-01-01 00:26:01.000000', 'temperatura', 252.0000, 'ºC'),
	(293956, 143, '2015-01-01 00:26:02.000000', 'temperatura', 505.0000, 'ºC'),
	(293957, 143, '2015-01-01 00:26:03.000000', 'temperatura', 571.0000, 'ºC'),
	(293958, 143, '2015-01-01 00:26:04.000000', 'temperatura', 138.0000, 'ºC'),
	(293959, 143, '2015-01-01 00:26:05.000000', 'temperatura', 177.0000, 'ºC'),
	(293960, 143, '2015-01-01 00:26:06.000000', 'temperatura', 474.0000, 'ºC'),
	(293961, 143, '2015-01-01 00:26:07.000000', 'temperatura', 638.0000, 'ºC'),
	(293962, 143, '2015-01-01 00:26:08.000000', 'temperatura', 570.0000, 'ºC'),
	(293963, 143, '2015-01-01 00:26:09.000000', 'temperatura', 936.0000, 'ºC'),
	(293964, 143, '2015-01-01 00:26:10.000000', 'temperatura', 570.0000, 'ºC'),
	(293965, 143, '2015-01-01 00:26:11.000000', 'temperatura', 41.0000, 'ºC'),
	(293966, 143, '2015-01-01 00:26:12.000000', 'temperatura', 899.0000, 'ºC'),
	(293967, 143, '2015-01-01 00:26:13.000000', 'temperatura', 769.0000, 'ºC'),
	(293968, 143, '2015-01-01 00:26:14.000000', 'temperatura', 1149.0000, 'ºC'),
	(293969, 143, '2015-01-01 00:26:15.000000', 'temperatura', 1039.0000, 'ºC'),
	(293970, 143, '2015-01-01 00:26:16.000000', 'temperatura', 550.0000, 'ºC'),
	(293971, 143, '2015-01-01 00:26:17.000000', 'temperatura', 833.0000, 'ºC'),
	(293972, 143, '2015-01-01 00:26:18.000000', 'temperatura', 114.0000, 'ºC'),
	(293973, 143, '2015-01-01 00:26:19.000000', 'temperatura', 473.0000, 'ºC'),
	(293974, 143, '2015-01-01 00:26:20.000000', 'temperatura', 821.0000, 'ºC'),
	(293975, 143, '2015-01-01 00:26:21.000000', 'temperatura', 288.0000, 'ºC'),
	(293976, 143, '2015-01-01 00:26:22.000000', 'temperatura', 180.0000, 'ºC'),
	(293977, 143, '2015-01-01 00:26:23.000000', 'temperatura', 33.0000, 'ºC'),
	(293978, 143, '2015-01-01 00:26:24.000000', 'temperatura', 826.0000, 'ºC'),
	(293979, 143, '2015-01-01 00:26:25.000000', 'temperatura', 433.0000, 'ºC'),
	(293980, 143, '2015-01-01 00:26:26.000000', 'temperatura', 888.0000, 'ºC'),
	(293981, 143, '2015-01-01 00:26:27.000000', 'temperatura', 740.0000, 'ºC'),
	(293982, 143, '2015-01-01 00:26:28.000000', 'temperatura', 1038.0000, 'ºC'),
	(293983, 143, '2015-01-01 00:26:29.000000', 'temperatura', 571.0000, 'ºC'),
	(293984, 143, '2015-01-01 00:26:30.000000', 'temperatura', 942.0000, 'ºC'),
	(293985, 143, '2015-01-01 00:26:31.000000', 'temperatura', 596.0000, 'ºC'),
	(293986, 143, '2015-01-01 00:26:32.000000', 'temperatura', 155.0000, 'ºC'),
	(293987, 143, '2015-01-01 00:26:33.000000', 'temperatura', 189.0000, 'ºC'),
	(293988, 143, '2015-01-01 00:26:34.000000', 'temperatura', 481.0000, 'ºC'),
	(293989, 143, '2015-01-01 00:26:35.000000', 'temperatura', 637.0000, 'ºC'),
	(293990, 143, '2015-01-01 00:26:36.000000', 'temperatura', 544.0000, 'ºC'),
	(293991, 143, '2015-01-01 00:26:37.000000', 'temperatura', 807.0000, 'ºC'),
	(293992, 143, '2015-01-01 00:26:38.000000', 'temperatura', 3.0000, 'ºC'),
	(293993, 143, '2015-01-01 00:26:39.000000', 'temperatura', 1194.0000, 'ºC'),
	(293994, 143, '2015-01-01 00:26:40.000000', 'temperatura', 1165.0000, 'ºC'),
	(293995, 143, '2015-01-01 00:26:41.000000', 'temperatura', 1040.0000, 'ºC'),
	(293996, 143, '2015-01-01 00:26:42.000000', 'temperatura', 507.0000, 'ºC'),
	(293997, 143, '2015-01-01 00:26:43.000000', 'temperatura', 615.0000, 'ºC'),
	(293998, 143, '2015-01-01 00:26:44.000000', 'temperatura', 355.0000, 'ºC'),
	(293999, 143, '2015-01-01 00:26:45.000000', 'temperatura', 1130.0000, 'ºC'),
	(294000, 143, '2015-01-01 00:26:46.000000', 'temperatura', 987.0000, 'ºC'),
	(294001, 143, '2015-01-01 00:26:47.000000', 'temperatura', 344.0000, 'ºC'),
	(294002, 143, '2015-01-01 00:26:48.000000', 'temperatura', 1160.0000, 'ºC'),
	(294003, 143, '2015-01-01 00:26:49.000000', 'temperatura', 1167.0000, 'ºC'),
	(294004, 143, '2015-01-01 00:26:50.000000', 'temperatura', 1159.0000, 'ºC'),
	(294005, 143, '2015-01-01 00:26:51.000000', 'temperatura', 1091.0000, 'ºC'),
	(294006, 143, '2015-01-01 00:26:52.000000', 'temperatura', 781.0000, 'ºC'),
	(294007, 143, '2015-01-01 00:26:53.000000', 'temperatura', 631.0000, 'ºC'),
	(294008, 143, '2015-01-01 00:26:54.000000', 'temperatura', 813.0000, 'ºC'),
	(294009, 143, '2015-01-01 00:26:55.000000', 'temperatura', 971.0000, 'ºC'),
	(294010, 143, '2015-01-01 00:26:56.000000', 'temperatura', 16.0000, 'ºC'),
	(294011, 143, '2015-01-01 00:26:57.000000', 'temperatura', 767.0000, 'ºC'),
	(294012, 143, '2015-01-01 00:26:58.000000', 'temperatura', 187.0000, 'ºC'),
	(294013, 143, '2015-01-01 00:26:59.000000', 'temperatura', 1035.0000, 'ºC'),
	(294014, 143, '2015-01-01 00:27:00.000000', 'temperatura', 1013.0000, 'ºC'),
	(294015, 143, '2015-01-01 00:27:01.000000', 'temperatura', 761.0000, 'ºC'),
	(294016, 143, '2015-01-01 00:27:02.000000', 'temperatura', 767.0000, 'ºC'),
	(294017, 143, '2015-01-01 00:27:03.000000', 'temperatura', 353.0000, 'ºC'),
	(294018, 143, '2015-01-01 00:27:04.000000', 'temperatura', 664.0000, 'ºC'),
	(294019, 143, '2015-01-01 00:27:05.000000', 'temperatura', 1062.0000, 'ºC'),
	(294020, 143, '2015-01-01 00:27:06.000000', 'temperatura', 916.0000, 'ºC'),
	(294021, 143, '2015-01-01 00:27:07.000000', 'temperatura', 198.0000, 'ºC'),
	(294022, 143, '2015-01-01 00:27:08.000000', 'temperatura', 642.0000, 'ºC'),
	(294023, 143, '2015-01-01 00:27:09.000000', 'temperatura', 216.0000, 'ºC'),
	(294024, 143, '2015-01-01 00:27:10.000000', 'temperatura', 354.0000, 'ºC'),
	(294025, 143, '2015-01-01 00:27:11.000000', 'temperatura', 1124.0000, 'ºC'),
	(294026, 143, '2015-01-01 00:27:12.000000', 'temperatura', 958.0000, 'ºC'),
	(294027, 143, '2015-01-01 00:27:13.000000', 'temperatura', 218.0000, 'ºC'),
	(294028, 143, '2015-01-01 00:27:14.000000', 'temperatura', 618.0000, 'ºC'),
	(294029, 143, '2015-01-01 00:27:15.000000', 'temperatura', 37.0000, 'ºC'),
	(294030, 143, '2015-01-01 00:27:16.000000', 'temperatura', 729.0000, 'ºC'),
	(294031, 143, '2015-01-01 00:27:17.000000', 'temperatura', 1138.0000, 'ºC'),
	(294032, 143, '2015-01-01 00:27:18.000000', 'temperatura', 1100.0000, 'ºC'),
	(294033, 143, '2015-01-01 00:27:19.000000', 'temperatura', 890.0000, 'ºC'),
	(294034, 143, '2015-01-01 00:27:20.000000', 'temperatura', 1148.0000, 'ºC'),
	(294035, 143, '2015-01-01 00:27:21.000000', 'temperatura', 671.0000, 'ºC'),
	(294036, 143, '2015-01-01 00:27:22.000000', 'temperatura', 1114.0000, 'ºC'),
	(294037, 143, '2015-01-01 00:27:23.000000', 'temperatura', 1155.0000, 'ºC'),
	(294038, 143, '2015-01-01 00:27:24.000000', 'temperatura', 33.0000, 'ºC'),
	(294039, 143, '2015-01-01 00:27:25.000000', 'temperatura', 302.0000, 'ºC'),
	(294040, 143, '2015-01-01 00:27:26.000000', 'temperatura', 209.0000, 'ºC'),
	(294041, 143, '2015-01-01 00:27:27.000000', 'temperatura', 141.0000, 'ºC'),
	(294042, 143, '2015-01-01 00:27:28.000000', 'temperatura', 77.0000, 'ºC'),
	(294043, 143, '2015-01-01 00:27:29.000000', 'temperatura', 1164.0000, 'ºC'),
	(294044, 143, '2015-01-01 00:27:30.000000', 'temperatura', 788.0000, 'ºC'),
	(294045, 143, '2015-01-01 00:27:31.000000', 'temperatura', 448.0000, 'ºC'),
	(294046, 143, '2015-01-01 00:27:32.000000', 'temperatura', 1076.0000, 'ºC'),
	(294047, 143, '2015-01-01 00:27:33.000000', 'temperatura', 437.0000, 'ºC'),
	(294048, 143, '2015-01-01 00:27:34.000000', 'temperatura', 158.0000, 'ºC'),
	(294049, 143, '2015-01-01 00:27:35.000000', 'temperatura', 681.0000, 'ºC'),
	(294050, 143, '2015-01-01 00:27:36.000000', 'temperatura', 532.0000, 'ºC'),
	(294051, 143, '2015-01-01 00:27:37.000000', 'temperatura', 615.0000, 'ºC'),
	(294052, 143, '2015-01-01 00:27:38.000000', 'temperatura', 280.0000, 'ºC'),
	(294053, 143, '2015-01-01 00:27:39.000000', 'temperatura', 756.0000, 'ºC'),
	(294054, 143, '2015-01-01 00:27:40.000000', 'temperatura', 540.0000, 'ºC'),
	(294055, 143, '2015-01-01 00:27:41.000000', 'temperatura', 433.0000, 'ºC'),
	(294056, 143, '2015-01-01 00:27:42.000000', 'temperatura', 545.0000, 'ºC'),
	(294057, 143, '2015-01-01 00:27:43.000000', 'temperatura', 225.0000, 'ºC'),
	(294058, 143, '2015-01-01 00:27:44.000000', 'temperatura', 693.0000, 'ºC'),
	(294059, 143, '2015-01-01 00:27:45.000000', 'temperatura', 388.0000, 'ºC'),
	(294060, 143, '2015-01-01 00:27:46.000000', 'temperatura', 1062.0000, 'ºC'),
	(294061, 143, '2015-01-01 00:27:47.000000', 'temperatura', 548.0000, 'ºC'),
	(294062, 143, '2015-01-01 00:27:48.000000', 'temperatura', 756.0000, 'ºC'),
	(294063, 143, '2015-01-01 00:27:49.000000', 'temperatura', 934.0000, 'ºC'),
	(294064, 143, '2015-01-01 00:27:50.000000', 'temperatura', 5.0000, 'ºC'),
	(294065, 143, '2015-01-01 00:27:51.000000', 'temperatura', 823.0000, 'ºC'),
	(294066, 143, '2015-01-01 00:27:52.000000', 'temperatura', 502.0000, 'ºC'),
	(294067, 143, '2015-01-01 00:27:53.000000', 'temperatura', 39.0000, 'ºC'),
	(294068, 143, '2015-01-01 00:27:54.000000', 'temperatura', 1088.0000, 'ºC'),
	(294069, 143, '2015-01-01 00:27:55.000000', 'temperatura', 527.0000, 'ºC'),
	(294070, 143, '2015-01-01 00:27:56.000000', 'temperatura', 569.0000, 'ºC'),
	(294071, 143, '2015-01-01 00:27:57.000000', 'temperatura', 64.0000, 'ºC'),
	(294072, 143, '2015-01-01 00:27:58.000000', 'temperatura', 1014.0000, 'ºC'),
	(294073, 143, '2015-01-01 00:27:59.000000', 'temperatura', 78.0000, 'ºC'),
	(294074, 143, '2015-01-01 00:28:00.000000', 'temperatura', 947.0000, 'ºC'),
	(294075, 143, '2015-01-01 00:28:01.000000', 'temperatura', 905.0000, 'ºC'),
	(294076, 143, '2015-01-01 00:28:02.000000', 'temperatura', 481.0000, 'ºC'),
	(294077, 143, '2015-01-01 00:28:03.000000', 'temperatura', 894.0000, 'ºC'),
	(294078, 143, '2015-01-01 00:28:04.000000', 'temperatura', 624.0000, 'ºC'),
	(294079, 143, '2015-01-01 00:28:05.000000', 'temperatura', 440.0000, 'ºC'),
	(294080, 143, '2015-01-01 00:28:06.000000', 'temperatura', 329.0000, 'ºC'),
	(294081, 143, '2015-01-01 00:28:07.000000', 'temperatura', 326.0000, 'ºC'),
	(294082, 143, '2015-01-01 00:28:08.000000', 'temperatura', 641.0000, 'ºC'),
	(294083, 143, '2015-01-01 00:28:09.000000', 'temperatura', 1028.0000, 'ºC'),
	(294084, 143, '2015-01-01 00:28:10.000000', 'temperatura', 820.0000, 'ºC'),
	(294085, 143, '2015-01-01 00:28:11.000000', 'temperatura', 1014.0000, 'ºC'),
	(294086, 143, '2015-01-01 00:28:12.000000', 'temperatura', 210.0000, 'ºC'),
	(294087, 143, '2015-01-01 00:28:13.000000', 'temperatura', 410.0000, 'ºC'),
	(294088, 143, '2015-01-01 00:28:14.000000', 'temperatura', 222.0000, 'ºC'),
	(294089, 143, '2015-01-01 00:28:15.000000', 'temperatura', 1079.0000, 'ºC'),
	(294090, 143, '2015-01-01 00:28:16.000000', 'temperatura', 1129.0000, 'ºC'),
	(294091, 143, '2015-01-01 00:28:17.000000', 'temperatura', 9.0000, 'ºC'),
	(294092, 143, '2015-01-01 00:28:18.000000', 'temperatura', 257.0000, 'ºC'),
	(294093, 143, '2015-01-01 00:28:19.000000', 'temperatura', 60.0000, 'ºC'),
	(294094, 143, '2015-01-01 00:28:20.000000', 'temperatura', 729.0000, 'ºC'),
	(294095, 143, '2015-01-01 00:28:21.000000', 'temperatura', 1066.0000, 'ºC'),
	(294096, 143, '2015-01-01 00:28:22.000000', 'temperatura', 742.0000, 'ºC'),
	(294097, 143, '2015-01-01 00:28:23.000000', 'temperatura', 515.0000, 'ºC'),
	(294098, 143, '2015-01-01 00:28:24.000000', 'temperatura', 347.0000, 'ºC'),
	(294099, 143, '2015-01-01 00:28:25.000000', 'temperatura', 192.0000, 'ºC'),
	(294100, 143, '2015-01-01 00:28:26.000000', 'temperatura', 1121.0000, 'ºC'),
	(294101, 143, '2015-01-01 00:28:27.000000', 'temperatura', 227.0000, 'ºC'),
	(294102, 143, '2015-01-01 00:28:28.000000', 'temperatura', 172.0000, 'ºC'),
	(294103, 143, '2015-01-01 00:28:29.000000', 'temperatura', 182.0000, 'ºC'),
	(294104, 143, '2015-01-01 00:28:30.000000', 'temperatura', 393.0000, 'ºC'),
	(294105, 143, '2015-01-01 00:28:31.000000', 'temperatura', 221.0000, 'ºC'),
	(294106, 143, '2015-01-01 00:28:32.000000', 'temperatura', 1128.0000, 'ºC'),
	(294107, 143, '2015-01-01 00:28:33.000000', 'temperatura', 175.0000, 'ºC'),
	(294108, 143, '2015-01-01 00:28:34.000000', 'temperatura', 1091.0000, 'ºC'),
	(294109, 143, '2015-01-01 00:28:35.000000', 'temperatura', 130.0000, 'ºC'),
	(294110, 143, '2015-01-01 00:28:36.000000', 'temperatura', 977.0000, 'ºC'),
	(294111, 143, '2015-01-01 00:28:37.000000', 'temperatura', 896.0000, 'ºC'),
	(294112, 143, '2015-01-01 00:28:38.000000', 'temperatura', 349.0000, 'ºC'),
	(294113, 143, '2015-01-01 00:28:39.000000', 'temperatura', 256.0000, 'ºC'),
	(294114, 143, '2015-01-01 00:28:40.000000', 'temperatura', 236.0000, 'ºC'),
	(294115, 143, '2015-01-01 00:28:41.000000', 'temperatura', 410.0000, 'ºC'),
	(294116, 143, '2015-01-01 00:28:42.000000', 'temperatura', 143.0000, 'ºC'),
	(294117, 143, '2015-01-01 00:28:43.000000', 'temperatura', 685.0000, 'ºC'),
	(294118, 143, '2015-01-01 00:28:44.000000', 'temperatura', 596.0000, 'ºC'),
	(294119, 143, '2015-01-01 00:28:45.000000', 'temperatura', 925.0000, 'ºC'),
	(294120, 143, '2015-01-01 00:28:46.000000', 'temperatura', 438.0000, 'ºC'),
	(294121, 143, '2015-01-01 00:28:47.000000', 'temperatura', 617.0000, 'ºC'),
	(294122, 143, '2015-01-01 00:28:48.000000', 'temperatura', 570.0000, 'ºC'),
	(294123, 143, '2015-01-01 00:28:49.000000', 'temperatura', 1002.0000, 'ºC'),
	(294124, 143, '2015-01-01 00:28:50.000000', 'temperatura', 897.0000, 'ºC'),
	(294125, 143, '2015-01-01 00:28:51.000000', 'temperatura', 281.0000, 'ºC'),
	(294126, 143, '2015-01-01 00:28:52.000000', 'temperatura', 1114.0000, 'ºC'),
	(294127, 143, '2015-01-01 00:28:53.000000', 'temperatura', 1126.0000, 'ºC'),
	(294128, 143, '2015-01-01 00:28:54.000000', 'temperatura', 1089.0000, 'ºC'),
	(294129, 143, '2015-01-01 00:28:55.000000', 'temperatura', 867.0000, 'ºC'),
	(294130, 143, '2015-01-01 00:28:56.000000', 'temperatura', 1071.0000, 'ºC'),
	(294131, 143, '2015-01-01 00:28:57.000000', 'temperatura', 355.0000, 'ºC'),
	(294132, 143, '2015-01-01 00:28:58.000000', 'temperatura', 959.0000, 'ºC'),
	(294133, 143, '2015-01-01 00:28:59.000000', 'temperatura', 134.0000, 'ºC'),
	(294134, 143, '2015-01-01 00:29:00.000000', 'temperatura', 192.0000, 'ºC'),
	(294135, 143, '2015-01-01 00:29:01.000000', 'temperatura', 560.0000, 'ºC'),
	(294136, 143, '2015-01-01 00:29:02.000000', 'temperatura', 1024.0000, 'ºC'),
	(294137, 143, '2015-01-01 00:29:03.000000', 'temperatura', 1040.0000, 'ºC'),
	(294138, 143, '2015-01-01 00:29:04.000000', 'temperatura', 927.0000, 'ºC'),
	(294139, 143, '2015-01-01 00:29:05.000000', 'temperatura', 317.0000, 'ºC'),
	(294140, 143, '2015-01-01 00:29:06.000000', 'temperatura', 4.0000, 'ºC'),
	(294141, 143, '2015-01-01 00:29:07.000000', 'temperatura', 269.0000, 'ºC'),
	(294142, 143, '2015-01-01 00:29:08.000000', 'temperatura', 135.0000, 'ºC'),
	(294143, 143, '2015-01-01 00:29:09.000000', 'temperatura', 1067.0000, 'ºC'),
	(294144, 143, '2015-01-01 00:29:10.000000', 'temperatura', 131.0000, 'ºC'),
	(294145, 143, '2015-01-01 00:29:11.000000', 'temperatura', 1056.0000, 'ºC'),
	(294146, 143, '2015-01-01 00:29:12.000000', 'temperatura', 85.0000, 'ºC'),
	(294147, 143, '2015-01-01 00:29:13.000000', 'temperatura', 858.0000, 'ºC'),
	(294148, 143, '2015-01-01 00:29:14.000000', 'temperatura', 438.0000, 'ºC'),
	(294149, 143, '2015-01-01 00:29:15.000000', 'temperatura', 815.0000, 'ºC'),
	(294150, 143, '2015-01-01 00:29:16.000000', 'temperatura', 361.0000, 'ºC'),
	(294151, 143, '2015-01-01 00:29:17.000000', 'temperatura', 562.0000, 'ºC'),
	(294152, 143, '2015-01-01 00:29:18.000000', 'temperatura', 527.0000, 'ºC'),
	(294153, 143, '2015-01-01 00:29:19.000000', 'temperatura', 950.0000, 'ºC'),
	(294154, 143, '2015-01-01 00:29:20.000000', 'temperatura', 767.0000, 'ºC'),
	(294155, 143, '2015-01-01 00:29:21.000000', 'temperatura', 987.0000, 'ºC'),
	(294156, 143, '2015-01-01 00:29:22.000000', 'temperatura', 233.0000, 'ºC'),
	(294157, 143, '2015-01-01 00:29:23.000000', 'temperatura', 605.0000, 'ºC'),
	(294158, 143, '2015-01-01 00:29:24.000000', 'temperatura', 1127.0000, 'ºC'),
	(294159, 143, '2015-01-01 00:29:25.000000', 'temperatura', 222.0000, 'ºC'),
	(294160, 143, '2015-01-01 00:29:26.000000', 'temperatura', 127.0000, 'ºC'),
	(294161, 143, '2015-01-01 00:29:27.000000', 'temperatura', 1172.0000, 'ºC'),
	(294162, 143, '2015-01-01 00:29:28.000000', 'temperatura', 676.0000, 'ºC'),
	(294163, 143, '2015-01-01 00:29:29.000000', 'temperatura', 1068.0000, 'ºC'),
	(294164, 143, '2015-01-01 00:29:30.000000', 'temperatura', 910.0000, 'ºC'),
	(294165, 143, '2015-01-01 00:29:31.000000', 'temperatura', 147.0000, 'ºC'),
	(294166, 143, '2015-01-01 00:29:32.000000', 'temperatura', 404.0000, 'ºC'),
	(294167, 143, '2015-01-01 00:29:33.000000', 'temperatura', 381.0000, 'ºC'),
	(294168, 143, '2015-01-01 00:29:34.000000', 'temperatura', 695.0000, 'ºC'),
	(294169, 143, '2015-01-01 00:29:35.000000', 'temperatura', 1131.0000, 'ºC'),
	(294170, 143, '2015-01-01 00:29:36.000000', 'temperatura', 1171.0000, 'ºC'),
	(294171, 143, '2015-01-01 00:29:37.000000', 'temperatura', 62.0000, 'ºC'),
	(294172, 143, '2015-01-01 00:29:38.000000', 'temperatura', 398.0000, 'ºC'),
	(294173, 143, '2015-01-01 00:29:39.000000', 'temperatura', 606.0000, 'ºC'),
	(294174, 143, '2015-01-01 00:29:40.000000', 'temperatura', 634.0000, 'ºC'),
	(294175, 143, '2015-01-01 00:29:41.000000', 'temperatura', 152.0000, 'ºC'),
	(294176, 143, '2015-01-01 00:29:42.000000', 'temperatura', 58.0000, 'ºC'),
	(294177, 143, '2015-01-01 00:29:43.000000', 'temperatura', 1037.0000, 'ºC'),
	(294178, 143, '2015-01-01 00:29:44.000000', 'temperatura', 209.0000, 'ºC'),
	(294179, 143, '2015-01-01 00:29:45.000000', 'temperatura', 335.0000, 'ºC'),
	(294180, 143, '2015-01-01 00:29:46.000000', 'temperatura', 1048.0000, 'ºC'),
	(294181, 143, '2015-01-01 00:29:47.000000', 'temperatura', 638.0000, 'ºC'),
	(294182, 143, '2015-01-01 00:29:48.000000', 'temperatura', 44.0000, 'ºC'),
	(294183, 143, '2015-01-01 00:29:49.000000', 'temperatura', 706.0000, 'ºC'),
	(294184, 143, '2015-01-01 00:29:50.000000', 'temperatura', 998.0000, 'ºC'),
	(294185, 143, '2015-01-01 00:29:51.000000', 'temperatura', 474.0000, 'ºC'),
	(294186, 143, '2015-01-01 00:29:52.000000', 'temperatura', 576.0000, 'ºC'),
	(294187, 143, '2015-01-01 00:29:53.000000', 'temperatura', 259.0000, 'ºC'),
	(294188, 143, '2015-01-01 00:29:54.000000', 'temperatura', 768.0000, 'ºC'),
	(294189, 143, '2015-01-01 00:29:55.000000', 'temperatura', 663.0000, 'ºC'),
	(294190, 143, '2015-01-01 00:29:56.000000', 'temperatura', 1012.0000, 'ºC'),
	(294191, 143, '2015-01-01 00:29:57.000000', 'temperatura', 673.0000, 'ºC'),
	(294192, 143, '2015-01-01 00:29:58.000000', 'temperatura', 328.0000, 'ºC'),
	(294193, 143, '2015-01-01 00:29:59.000000', 'temperatura', 822.0000, 'ºC'),
	(294194, 143, '2015-01-01 00:30:00.000000', 'temperatura', 727.0000, 'ºC'),
	(294195, 143, '2015-01-01 00:30:01.000000', 'temperatura', 1170.0000, 'ºC'),
	(294196, 143, '2015-01-01 00:30:02.000000', 'temperatura', 69.0000, 'ºC'),
	(294197, 143, '2015-01-01 00:30:03.000000', 'temperatura', 434.0000, 'ºC'),
	(294198, 143, '2015-01-01 00:30:04.000000', 'temperatura', 766.0000, 'ºC'),
	(294199, 143, '2015-01-01 00:30:05.000000', 'temperatura', 129.0000, 'ºC'),
	(294200, 143, '2015-01-01 00:30:06.000000', 'temperatura', 747.0000, 'ºC'),
	(294201, 143, '2015-01-01 00:30:07.000000', 'temperatura', 950.0000, 'ºC'),
	(294202, 143, '2015-01-01 00:30:08.000000', 'temperatura', 108.0000, 'ºC'),
	(294203, 143, '2015-01-01 00:30:09.000000', 'temperatura', 90.0000, 'ºC'),
	(294204, 143, '2015-01-01 00:30:10.000000', 'temperatura', 128.0000, 'ºC'),
	(294205, 143, '2015-01-01 00:30:11.000000', 'temperatura', 370.0000, 'ºC'),
	(294206, 143, '2015-01-01 00:30:12.000000', 'temperatura', 266.0000, 'ºC'),
	(294207, 143, '2015-01-01 00:30:13.000000', 'temperatura', 221.0000, 'ºC'),
	(294208, 143, '2015-01-01 00:30:14.000000', 'temperatura', 308.0000, 'ºC'),
	(294209, 143, '2015-01-01 00:30:15.000000', 'temperatura', 877.0000, 'ºC'),
	(294210, 143, '2015-01-01 00:30:16.000000', 'temperatura', 1059.0000, 'ºC'),
	(294211, 143, '2015-01-01 00:30:17.000000', 'temperatura', 268.0000, 'ºC'),
	(294212, 143, '2015-01-01 00:30:18.000000', 'temperatura', 563.0000, 'ºC'),
	(294213, 143, '2015-01-01 00:30:19.000000', 'temperatura', 813.0000, 'ºC'),
	(294214, 143, '2015-01-01 00:30:20.000000', 'temperatura', 1175.0000, 'ºC'),
	(294215, 143, '2015-01-01 00:30:21.000000', 'temperatura', 1035.0000, 'ºC'),
	(294216, 143, '2015-01-01 00:30:22.000000', 'temperatura', 452.0000, 'ºC'),
	(294217, 143, '2015-01-01 00:30:23.000000', 'temperatura', 357.0000, 'ºC'),
	(294218, 143, '2015-01-01 00:30:24.000000', 'temperatura', 426.0000, 'ºC'),
	(294219, 143, '2015-01-01 00:30:25.000000', 'temperatura', 1063.0000, 'ºC'),
	(294220, 143, '2015-01-01 00:30:26.000000', 'temperatura', 434.0000, 'ºC'),
	(294221, 143, '2015-01-01 00:30:27.000000', 'temperatura', 184.0000, 'ºC'),
	(294222, 143, '2015-01-01 00:30:28.000000', 'temperatura', 818.0000, 'ºC'),
	(294223, 143, '2015-01-01 00:30:29.000000', 'temperatura', 1140.0000, 'ºC'),
	(294224, 143, '2015-01-01 00:30:30.000000', 'temperatura', 846.0000, 'ºC'),
	(294225, 143, '2015-01-01 00:30:31.000000', 'temperatura', 811.0000, 'ºC'),
	(294226, 143, '2015-01-01 00:30:32.000000', 'temperatura', 317.0000, 'ºC'),
	(294227, 143, '2015-01-01 00:30:33.000000', 'temperatura', 352.0000, 'ºC'),
	(294228, 143, '2015-01-01 00:30:34.000000', 'temperatura', 812.0000, 'ºC'),
	(294229, 143, '2015-01-01 00:30:35.000000', 'temperatura', 602.0000, 'ºC'),
	(294230, 143, '2015-01-01 00:30:36.000000', 'temperatura', 576.0000, 'ºC'),
	(294231, 143, '2015-01-01 00:30:37.000000', 'temperatura', 1075.0000, 'ºC'),
	(294232, 143, '2015-01-01 00:30:38.000000', 'temperatura', 46.0000, 'ºC'),
	(294233, 143, '2015-01-01 00:30:39.000000', 'temperatura', 606.0000, 'ºC'),
	(294234, 143, '2015-01-01 00:30:40.000000', 'temperatura', 493.0000, 'ºC'),
	(294235, 143, '2015-01-01 00:30:41.000000', 'temperatura', 647.0000, 'ºC'),
	(294236, 143, '2015-01-01 00:30:42.000000', 'temperatura', 559.0000, 'ºC'),
	(294237, 143, '2015-01-01 00:30:43.000000', 'temperatura', 851.0000, 'ºC'),
	(294238, 143, '2015-01-01 00:30:44.000000', 'temperatura', 182.0000, 'ºC'),
	(294239, 143, '2015-01-01 00:30:45.000000', 'temperatura', 755.0000, 'ºC'),
	(294240, 143, '2015-01-01 00:30:46.000000', 'temperatura', 830.0000, 'ºC'),
	(294241, 143, '2015-01-01 00:30:47.000000', 'temperatura', 685.0000, 'ºC'),
	(294242, 143, '2015-01-01 00:30:48.000000', 'temperatura', 936.0000, 'ºC'),
	(294243, 143, '2015-01-01 00:30:49.000000', 'temperatura', 225.0000, 'ºC'),
	(294244, 143, '2015-01-01 00:30:50.000000', 'temperatura', 718.0000, 'ºC'),
	(294245, 143, '2015-01-01 00:30:51.000000', 'temperatura', 516.0000, 'ºC'),
	(294246, 143, '2015-01-01 00:30:52.000000', 'temperatura', 425.0000, 'ºC'),
	(294247, 143, '2015-01-01 00:30:53.000000', 'temperatura', 578.0000, 'ºC'),
	(294248, 143, '2015-01-01 00:30:54.000000', 'temperatura', 414.0000, 'ºC'),
	(294249, 143, '2015-01-01 00:30:55.000000', 'temperatura', 339.0000, 'ºC'),
	(294250, 143, '2015-01-01 00:30:56.000000', 'temperatura', 454.0000, 'ºC'),
	(294251, 143, '2015-01-01 00:30:57.000000', 'temperatura', 53.0000, 'ºC'),
	(294252, 143, '2015-01-01 00:30:58.000000', 'temperatura', 103.0000, 'ºC'),
	(294253, 143, '2015-01-01 00:30:59.000000', 'temperatura', 355.0000, 'ºC'),
	(294254, 143, '2015-01-01 00:31:00.000000', 'temperatura', 268.0000, 'ºC'),
	(294255, 143, '2015-01-01 00:31:01.000000', 'temperatura', 275.0000, 'ºC'),
	(294256, 143, '2015-01-01 00:31:02.000000', 'temperatura', 573.0000, 'ºC'),
	(294257, 143, '2015-01-01 00:31:03.000000', 'temperatura', 841.0000, 'ºC'),
	(294258, 143, '2015-01-01 00:31:04.000000', 'temperatura', 85.0000, 'ºC'),
	(294259, 143, '2015-01-01 00:31:05.000000', 'temperatura', 305.0000, 'ºC'),
	(294260, 143, '2015-01-01 00:31:06.000000', 'temperatura', 67.0000, 'ºC'),
	(294261, 143, '2015-01-01 00:31:07.000000', 'temperatura', 623.0000, 'ºC'),
	(294262, 143, '2015-01-01 00:31:08.000000', 'temperatura', 515.0000, 'ºC'),
	(294263, 143, '2015-01-01 00:31:09.000000', 'temperatura', 707.0000, 'ºC'),
	(294264, 143, '2015-01-01 00:31:10.000000', 'temperatura', 789.0000, 'ºC'),
	(294265, 143, '2015-01-01 00:31:11.000000', 'temperatura', 626.0000, 'ºC'),
	(294266, 143, '2015-01-01 00:31:12.000000', 'temperatura', 765.0000, 'ºC'),
	(294267, 143, '2015-01-01 00:31:13.000000', 'temperatura', 744.0000, 'ºC'),
	(294268, 143, '2015-01-01 00:31:14.000000', 'temperatura', 229.0000, 'ºC'),
	(294269, 143, '2015-01-01 00:31:15.000000', 'temperatura', 111.0000, 'ºC'),
	(294270, 143, '2015-01-01 00:31:16.000000', 'temperatura', 1069.0000, 'ºC'),
	(294271, 143, '2015-01-01 00:31:17.000000', 'temperatura', 215.0000, 'ºC'),
	(294272, 143, '2015-01-01 00:31:18.000000', 'temperatura', 265.0000, 'ºC'),
	(294273, 143, '2015-01-01 00:31:19.000000', 'temperatura', 682.0000, 'ºC'),
	(294274, 143, '2015-01-01 00:31:20.000000', 'temperatura', 215.0000, 'ºC'),
	(294275, 143, '2015-01-01 00:31:21.000000', 'temperatura', 228.0000, 'ºC'),
	(294276, 143, '2015-01-01 00:31:22.000000', 'temperatura', 499.0000, 'ºC'),
	(294277, 143, '2015-01-01 00:31:23.000000', 'temperatura', 609.0000, 'ºC'),
	(294278, 143, '2015-01-01 00:31:24.000000', 'temperatura', 348.0000, 'ºC'),
	(294279, 143, '2015-01-01 00:31:25.000000', 'temperatura', 1115.0000, 'ºC'),
	(294280, 143, '2015-01-01 00:31:26.000000', 'temperatura', 930.0000, 'ºC'),
	(294281, 143, '2015-01-01 00:31:27.000000', 'temperatura', 108.0000, 'ºC'),
	(294282, 143, '2015-01-01 00:31:28.000000', 'temperatura', 148.0000, 'ºC'),
	(294283, 143, '2015-01-01 00:31:29.000000', 'temperatura', 417.0000, 'ºC'),
	(294284, 143, '2015-01-01 00:31:30.000000', 'temperatura', 441.0000, 'ºC'),
	(294285, 143, '2015-01-01 00:31:31.000000', 'temperatura', 954.0000, 'ºC'),
	(294286, 143, '2015-01-01 00:31:32.000000', 'temperatura', 1048.0000, 'ºC'),
	(294287, 143, '2015-01-01 00:31:33.000000', 'temperatura', 1177.0000, 'ºC'),
	(294288, 143, '2015-01-01 00:31:34.000000', 'temperatura', 344.0000, 'ºC'),
	(294289, 143, '2015-01-01 00:31:35.000000', 'temperatura', 591.0000, 'ºC'),
	(294290, 143, '2015-01-01 00:31:36.000000', 'temperatura', 720.0000, 'ºC'),
	(294291, 143, '2015-01-01 00:31:37.000000', 'temperatura', 628.0000, 'ºC'),
	(294292, 143, '2015-01-01 00:31:38.000000', 'temperatura', 981.0000, 'ºC'),
	(294293, 143, '2015-01-01 00:31:39.000000', 'temperatura', 623.0000, 'ºC'),
	(294294, 143, '2015-01-01 00:31:40.000000', 'temperatura', 171.0000, 'ºC'),
	(294295, 143, '2015-01-01 00:31:41.000000', 'temperatura', 188.0000, 'ºC'),
	(294296, 143, '2015-01-01 00:31:42.000000', 'temperatura', 426.0000, 'ºC'),
	(294297, 143, '2015-01-01 00:31:43.000000', 'temperatura', 368.0000, 'ºC'),
	(294298, 143, '2015-01-01 00:31:44.000000', 'temperatura', 562.0000, 'ºC'),
	(294299, 143, '2015-01-01 00:31:45.000000', 'temperatura', 505.0000, 'ºC'),
	(294300, 143, '2015-01-01 00:31:46.000000', 'temperatura', 841.0000, 'ºC'),
	(294301, 143, '2015-01-01 00:31:47.000000', 'temperatura', 292.0000, 'ºC'),
	(294302, 143, '2015-01-01 00:31:48.000000', 'temperatura', 137.0000, 'ºC'),
	(294303, 143, '2015-01-01 00:31:49.000000', 'temperatura', 1009.0000, 'ºC'),
	(294304, 143, '2015-01-01 00:31:50.000000', 'temperatura', 1036.0000, 'ºC'),
	(294305, 143, '2015-01-01 00:31:51.000000', 'temperatura', 954.0000, 'ºC'),
	(294306, 143, '2015-01-01 00:31:52.000000', 'temperatura', 460.0000, 'ºC'),
	(294307, 143, '2015-01-01 00:31:53.000000', 'temperatura', 638.0000, 'ºC'),
	(294308, 143, '2015-01-01 00:31:54.000000', 'temperatura', 611.0000, 'ºC'),
	(294309, 143, '2015-01-01 00:31:55.000000', 'temperatura', 1142.0000, 'ºC'),
	(294310, 143, '2015-01-01 00:31:56.000000', 'temperatura', 279.0000, 'ºC'),
	(294311, 143, '2015-01-01 00:31:57.000000', 'temperatura', 370.0000, 'ºC'),
	(294312, 143, '2015-01-01 00:31:58.000000', 'temperatura', 1013.0000, 'ºC'),
	(294313, 143, '2015-01-01 00:31:59.000000', 'temperatura', 356.0000, 'ºC'),
	(294314, 143, '2015-01-01 00:32:00.000000', 'temperatura', 1143.0000, 'ºC'),
	(294315, 143, '2015-01-01 00:32:01.000000', 'temperatura', 1046.0000, 'ºC'),
	(294316, 143, '2015-01-01 00:32:02.000000', 'temperatura', 601.0000, 'ºC'),
	(294317, 143, '2015-01-01 00:32:03.000000', 'temperatura', 1066.0000, 'ºC'),
	(294318, 143, '2015-01-01 00:32:04.000000', 'temperatura', 1131.0000, 'ºC'),
	(294319, 143, '2015-01-01 00:32:05.000000', 'temperatura', 54.0000, 'ºC'),
	(294320, 143, '2015-01-01 00:32:06.000000', 'temperatura', 481.0000, 'ºC'),
	(294321, 143, '2015-01-01 00:32:07.000000', 'temperatura', 1041.0000, 'ºC'),
	(294322, 143, '2015-01-01 00:32:08.000000', 'temperatura', 165.0000, 'ºC'),
	(294323, 143, '2015-01-01 00:32:09.000000', 'temperatura', 100.0000, 'ºC'),
	(294324, 143, '2015-01-01 00:32:10.000000', 'temperatura', 4.0000, 'ºC'),
	(294325, 143, '2015-01-01 00:32:11.000000', 'temperatura', 924.0000, 'ºC'),
	(294326, 143, '2015-01-01 00:32:12.000000', 'temperatura', 1005.0000, 'ºC'),
	(294327, 143, '2015-01-01 00:32:13.000000', 'temperatura', 1057.0000, 'ºC'),
	(294328, 143, '2015-01-01 00:32:14.000000', 'temperatura', 1068.0000, 'ºC'),
	(294329, 143, '2015-01-01 00:32:15.000000', 'temperatura', 971.0000, 'ºC'),
	(294330, 143, '2015-01-01 00:32:16.000000', 'temperatura', 450.0000, 'ºC'),
	(294331, 143, '2015-01-01 00:32:17.000000', 'temperatura', 540.0000, 'ºC'),
	(294332, 143, '2015-01-01 00:32:18.000000', 'temperatura', 149.0000, 'ºC'),
	(294333, 143, '2015-01-01 00:32:19.000000', 'temperatura', 327.0000, 'ºC'),
	(294334, 143, '2015-01-01 00:32:20.000000', 'temperatura', 1189.0000, 'ºC'),
	(294335, 143, '2015-01-01 00:32:21.000000', 'temperatura', 165.0000, 'ºC'),
	(294336, 143, '2015-01-01 00:32:22.000000', 'temperatura', 857.0000, 'ºC'),
	(294337, 143, '2015-01-01 00:32:23.000000', 'temperatura', 192.0000, 'ºC'),
	(294338, 143, '2015-01-01 00:32:24.000000', 'temperatura', 787.0000, 'ºC'),
	(294339, 143, '2015-01-01 00:32:25.000000', 'temperatura', 960.0000, 'ºC'),
	(294340, 143, '2015-01-01 00:32:26.000000', 'temperatura', 38.0000, 'ºC'),
	(294341, 143, '2015-01-01 00:32:27.000000', 'temperatura', 913.0000, 'ºC'),
	(294342, 143, '2015-01-01 00:32:28.000000', 'temperatura', 852.0000, 'ºC'),
	(294343, 143, '2015-01-01 00:32:29.000000', 'temperatura', 319.0000, 'ºC'),
	(294344, 143, '2015-01-01 00:32:30.000000', 'temperatura', 243.0000, 'ºC'),
	(294345, 143, '2015-01-01 00:32:31.000000', 'temperatura', 255.0000, 'ºC'),
	(294346, 143, '2015-01-01 00:32:32.000000', 'temperatura', 549.0000, 'ºC'),
	(294347, 143, '2015-01-01 00:32:33.000000', 'temperatura', 781.0000, 'ºC'),
	(294348, 143, '2015-01-01 00:32:34.000000', 'temperatura', 1056.0000, 'ºC'),
	(294349, 143, '2015-01-01 00:32:35.000000', 'temperatura', 538.0000, 'ºC'),
	(294350, 143, '2015-01-01 00:32:36.000000', 'temperatura', 724.0000, 'ºC'),
	(294351, 143, '2015-01-01 00:32:37.000000', 'temperatura', 808.0000, 'ºC'),
	(294352, 143, '2015-01-01 00:32:38.000000', 'temperatura', 665.0000, 'ºC'),
	(294353, 143, '2015-01-01 00:32:39.000000', 'temperatura', 903.0000, 'ºC'),
	(294354, 143, '2015-01-01 00:32:40.000000', 'temperatura', 119.0000, 'ºC'),
	(294355, 143, '2015-01-01 00:32:41.000000', 'temperatura', 287.0000, 'ºC'),
	(294356, 143, '2015-01-01 00:32:42.000000', 'temperatura', 1080.0000, 'ºC'),
	(294357, 143, '2015-01-01 00:32:43.000000', 'temperatura', 937.0000, 'ºC'),
	(294358, 143, '2015-01-01 00:32:44.000000', 'temperatura', 246.0000, 'ºC'),
	(294359, 143, '2015-01-01 00:32:45.000000', 'temperatura', 819.0000, 'ºC'),
	(294360, 143, '2015-01-01 00:32:46.000000', 'temperatura', 959.0000, 'ºC'),
	(294361, 143, '2015-01-01 00:32:47.000000', 'temperatura', 1139.0000, 'ºC'),
	(294362, 143, '2015-01-01 00:32:48.000000', 'temperatura', 419.0000, 'ºC'),
	(294363, 143, '2015-01-01 00:32:49.000000', 'temperatura', 1079.0000, 'ºC'),
	(294364, 143, '2015-01-01 00:32:50.000000', 'temperatura', 536.0000, 'ºC'),
	(294365, 143, '2015-01-01 00:32:51.000000', 'temperatura', 643.0000, 'ºC'),
	(294366, 143, '2015-01-01 00:32:52.000000', 'temperatura', 407.0000, 'ºC'),
	(294367, 143, '2015-01-01 00:32:53.000000', 'temperatura', 108.0000, 'ºC'),
	(294368, 143, '2015-01-01 00:32:54.000000', 'temperatura', 521.0000, 'ºC'),
	(294369, 143, '2015-01-01 00:32:55.000000', 'temperatura', 1079.0000, 'ºC'),
	(294370, 143, '2015-01-01 00:32:56.000000', 'temperatura', 232.0000, 'ºC'),
	(294371, 143, '2015-01-01 00:32:57.000000', 'temperatura', 325.0000, 'ºC'),
	(294372, 143, '2015-01-01 00:32:58.000000', 'temperatura', 931.0000, 'ºC'),
	(294373, 143, '2015-01-01 00:32:59.000000', 'temperatura', 80.0000, 'ºC'),
	(294374, 143, '2015-01-01 00:33:00.000000', 'temperatura', 5.0000, 'ºC'),
	(294375, 143, '2015-01-01 00:33:01.000000', 'temperatura', 988.0000, 'ºC'),
	(294376, 143, '2015-01-01 00:33:02.000000', 'temperatura', 125.0000, 'ºC'),
	(294377, 143, '2015-01-01 00:33:03.000000', 'temperatura', 60.0000, 'ºC'),
	(294378, 143, '2015-01-01 00:33:04.000000', 'temperatura', 1125.0000, 'ºC'),
	(294379, 143, '2015-01-01 00:33:05.000000', 'temperatura', 648.0000, 'ºC'),
	(294380, 143, '2015-01-01 00:33:06.000000', 'temperatura', 1063.0000, 'ºC'),
	(294381, 143, '2015-01-01 00:33:07.000000', 'temperatura', 971.0000, 'ºC'),
	(294382, 143, '2015-01-01 00:33:08.000000', 'temperatura', 467.0000, 'ºC'),
	(294383, 143, '2015-01-01 00:33:09.000000', 'temperatura', 623.0000, 'ºC'),
	(294384, 143, '2015-01-01 00:33:10.000000', 'temperatura', 515.0000, 'ºC'),
	(294385, 143, '2015-01-01 00:33:11.000000', 'temperatura', 706.0000, 'ºC'),
	(294386, 143, '2015-01-01 00:33:12.000000', 'temperatura', 785.0000, 'ºC'),
	(294387, 143, '2015-01-01 00:33:13.000000', 'temperatura', 608.0000, 'ºC'),
	(294388, 143, '2015-01-01 00:33:14.000000', 'temperatura', 686.0000, 'ºC'),
	(294389, 143, '2015-01-01 00:33:15.000000', 'temperatura', 408.0000, 'ºC'),
	(294390, 143, '2015-01-01 00:33:16.000000', 'temperatura', 1181.0000, 'ºC'),
	(294391, 143, '2015-01-01 00:33:17.000000', 'temperatura', 1083.0000, 'ºC'),
	(294392, 143, '2015-01-01 00:33:18.000000', 'temperatura', 670.0000, 'ºC'),
	(294393, 143, '2015-01-01 00:33:19.000000', 'temperatura', 104.0000, 'ºC'),
	(294394, 143, '2015-01-01 00:33:20.000000', 'temperatura', 909.0000, 'ºC'),
	(294395, 143, '2015-01-01 00:33:21.000000', 'temperatura', 632.0000, 'ºC'),
	(294396, 143, '2015-01-01 00:33:22.000000', 'temperatura', 435.0000, 'ºC'),
	(294397, 143, '2015-01-01 00:33:23.000000', 'temperatura', 280.0000, 'ºC'),
	(294398, 143, '2015-01-01 00:33:24.000000', 'temperatura', 95.0000, 'ºC'),
	(294399, 143, '2015-01-01 00:33:25.000000', 'temperatura', 836.0000, 'ºC'),
	(294400, 143, '2015-01-01 00:33:26.000000', 'temperatura', 295.0000, 'ºC'),
	(294401, 143, '2015-01-01 00:33:27.000000', 'temperatura', 167.0000, 'ºC'),
	(294402, 143, '2015-01-01 00:33:28.000000', 'temperatura', 1153.0000, 'ºC'),
	(294403, 143, '2015-01-01 00:33:29.000000', 'temperatura', 463.0000, 'ºC'),
	(294404, 143, '2015-01-01 00:33:30.000000', 'temperatura', 55.0000, 'ºC'),
	(294405, 143, '2015-01-01 00:33:31.000000', 'temperatura', 87.0000, 'ºC'),
	(294406, 143, '2015-01-01 00:33:32.000000', 'temperatura', 270.0000, 'ºC'),
	(294407, 143, '2015-01-01 00:33:33.000000', 'temperatura', 1088.0000, 'ºC'),
	(294408, 143, '2015-01-01 00:33:34.000000', 'temperatura', 1032.0000, 'ºC'),
	(294409, 143, '2015-01-01 00:33:35.000000', 'temperatura', 698.0000, 'ºC'),
	(294410, 143, '2015-01-01 00:33:36.000000', 'temperatura', 392.0000, 'ºC'),
	(294411, 143, '2015-01-01 00:33:37.000000', 'temperatura', 1067.0000, 'ºC'),
	(294412, 143, '2015-01-01 00:33:38.000000', 'temperatura', 561.0000, 'ºC'),
	(294413, 143, '2015-01-01 00:33:39.000000', 'temperatura', 806.0000, 'ºC'),
	(294414, 143, '2015-01-01 00:33:40.000000', 'temperatura', 1144.0000, 'ºC'),
	(294415, 143, '2015-01-01 00:33:41.000000', 'temperatura', 906.0000, 'ºC'),
	(294416, 143, '2015-01-01 00:33:42.000000', 'temperatura', 1095.0000, 'ºC'),
	(294417, 143, '2015-01-01 00:33:43.000000', 'temperatura', 360.0000, 'ºC'),
	(294418, 143, '2015-01-01 00:33:44.000000', 'temperatura', 913.0000, 'ºC'),
	(294419, 143, '2015-01-01 00:33:45.000000', 'temperatura', 1088.0000, 'ºC'),
	(294420, 143, '2015-01-01 00:33:46.000000', 'temperatura', 301.0000, 'ºC'),
	(294421, 143, '2015-01-01 00:33:47.000000', 'temperatura', 641.0000, 'ºC'),
	(294422, 143, '2015-01-01 00:33:48.000000', 'temperatura', 1102.0000, 'ºC'),
	(294423, 143, '2015-01-01 00:33:49.000000', 'temperatura', 1187.0000, 'ºC'),
	(294424, 143, '2015-01-01 00:33:50.000000', 'temperatura', 229.0000, 'ºC'),
	(294425, 143, '2015-01-01 00:33:51.000000', 'temperatura', 1186.0000, 'ºC'),
	(294426, 143, '2015-01-01 00:33:52.000000', 'temperatura', 444.0000, 'ºC'),
	(294427, 143, '2015-01-01 00:33:53.000000', 'temperatura', 1063.0000, 'ºC'),
	(294428, 143, '2015-01-01 00:33:54.000000', 'temperatura', 381.0000, 'ºC'),
	(294429, 143, '2015-01-01 00:33:55.000000', 'temperatura', 1116.0000, 'ºC'),
	(294430, 143, '2015-01-01 00:33:56.000000', 'temperatura', 839.0000, 'ºC'),
	(294431, 143, '2015-01-01 00:33:57.000000', 'temperatura', 848.0000, 'ºC'),
	(294432, 143, '2015-01-01 00:33:58.000000', 'temperatura', 525.0000, 'ºC'),
	(294433, 143, '2015-01-01 00:33:59.000000', 'temperatura', 78.0000, 'ºC'),
	(294434, 143, '2015-01-01 00:34:00.000000', 'temperatura', 18.0000, 'ºC'),
	(294435, 143, '2015-01-01 00:34:01.000000', 'temperatura', 1054.0000, 'ºC'),
	(294436, 143, '2015-01-01 00:34:02.000000', 'temperatura', 417.0000, 'ºC'),
	(294437, 143, '2015-01-01 00:34:03.000000', 'temperatura', 126.0000, 'ºC'),
	(294438, 143, '2015-01-01 00:34:04.000000', 'temperatura', 578.0000, 'ºC'),
	(294439, 143, '2015-01-01 00:34:05.000000', 'temperatura', 114.0000, 'ºC'),
	(294440, 143, '2015-01-01 00:34:06.000000', 'temperatura', 37.0000, 'ºC'),
	(294441, 143, '2015-01-01 00:34:07.000000', 'temperatura', 1043.0000, 'ºC'),
	(294442, 143, '2015-01-01 00:34:08.000000', 'temperatura', 305.0000, 'ºC'),
	(294443, 143, '2015-01-01 00:34:09.000000', 'temperatura', 797.0000, 'ºC'),
	(294444, 143, '2015-01-01 00:34:10.000000', 'temperatura', 670.0000, 'ºC'),
	(294445, 143, '2015-01-01 00:34:11.000000', 'temperatura', 957.0000, 'ºC'),
	(294446, 143, '2015-01-01 00:34:12.000000', 'temperatura', 379.0000, 'ºC'),
	(294447, 143, '2015-01-01 00:34:13.000000', 'temperatura', 222.0000, 'ºC'),
	(294448, 143, '2015-01-01 00:34:14.000000', 'temperatura', 1174.0000, 'ºC'),
	(294449, 143, '2015-01-01 00:34:15.000000', 'temperatura', 406.0000, 'ºC'),
	(294450, 143, '2015-01-01 00:34:16.000000', 'temperatura', 910.0000, 'ºC'),
	(294451, 143, '2015-01-01 00:34:17.000000', 'temperatura', 929.0000, 'ºC'),
	(294452, 143, '2015-01-01 00:34:18.000000', 'temperatura', 718.0000, 'ºC'),
	(294453, 143, '2015-01-01 00:34:19.000000', 'temperatura', 802.0000, 'ºC'),
	(294454, 143, '2015-01-01 00:34:20.000000', 'temperatura', 658.0000, 'ºC'),
	(294455, 143, '2015-01-01 00:34:21.000000', 'temperatura', 886.0000, 'ºC'),
	(294456, 143, '2015-01-01 00:34:22.000000', 'temperatura', 53.0000, 'ºC'),
	(294457, 143, '2015-01-01 00:34:23.000000', 'temperatura', 10.0000, 'ºC'),
	(294458, 143, '2015-01-01 00:34:24.000000', 'temperatura', 1090.0000, 'ºC'),
	(294459, 143, '2015-01-01 00:34:25.000000', 'temperatura', 622.0000, 'ºC'),
	(294460, 143, '2015-01-01 00:34:26.000000', 'temperatura', 1041.0000, 'ºC'),
	(294461, 143, '2015-01-01 00:34:27.000000', 'temperatura', 938.0000, 'ºC'),
	(294462, 143, '2015-01-01 00:34:28.000000', 'temperatura', 366.0000, 'ºC'),
	(294463, 143, '2015-01-01 00:34:29.000000', 'temperatura', 218.0000, 'ºC'),
	(294464, 143, '2015-01-01 00:34:30.000000', 'temperatura', 1192.0000, 'ºC'),
	(294465, 143, '2015-01-01 00:34:31.000000', 'temperatura', 506.0000, 'ºC'),
	(294466, 143, '2015-01-01 00:34:32.000000', 'temperatura', 157.0000, 'ºC'),
	(294467, 143, '2015-01-01 00:34:33.000000', 'temperatura', 465.0000, 'ºC'),
	(294468, 143, '2015-01-01 00:34:34.000000', 'temperatura', 654.0000, 'ºC'),
	(294469, 143, '2015-01-01 00:34:35.000000', 'temperatura', 675.0000, 'ºC'),
	(294470, 143, '2015-01-01 00:34:36.000000', 'temperatura', 216.0000, 'ºC'),
	(294471, 143, '2015-01-01 00:34:37.000000', 'temperatura', 255.0000, 'ºC'),
	(294472, 143, '2015-01-01 00:34:38.000000', 'temperatura', 626.0000, 'ºC'),
	(294473, 143, '2015-01-01 00:34:39.000000', 'temperatura', 1167.0000, 'ºC'),
	(294474, 143, '2015-01-01 00:34:40.000000', 'temperatura', 359.0000, 'ºC'),
	(294475, 143, '2015-01-01 00:34:41.000000', 'temperatura', 693.0000, 'ºC'),
	(294476, 143, '2015-01-01 00:34:42.000000', 'temperatura', 1187.0000, 'ºC'),
	(294477, 143, '2015-01-01 00:34:43.000000', 'temperatura', 259.0000, 'ºC'),
	(294478, 143, '2015-01-01 00:34:44.000000', 'temperatura', 133.0000, 'ºC'),
	(294479, 143, '2015-01-01 00:34:45.000000', 'temperatura', 1091.0000, 'ºC'),
	(294480, 143, '2015-01-01 00:34:46.000000', 'temperatura', 254.0000, 'ºC'),
	(294481, 143, '2015-01-01 00:34:47.000000', 'temperatura', 399.0000, 'ºC'),
	(294482, 143, '2015-01-01 00:34:48.000000', 'temperatura', 35.0000, 'ºC'),
	(294483, 143, '2015-01-01 00:34:49.000000', 'temperatura', 176.0000, 'ºC'),
	(294484, 143, '2015-01-01 00:34:50.000000', 'temperatura', 776.0000, 'ºC'),
	(294485, 143, '2015-01-01 00:34:51.000000', 'temperatura', 954.0000, 'ºC'),
	(294486, 143, '2015-01-01 00:34:52.000000', 'temperatura', 40.0000, 'ºC'),
	(294487, 143, '2015-01-01 00:34:53.000000', 'temperatura', 939.0000, 'ºC'),
	(294488, 143, '2015-01-01 00:34:54.000000', 'temperatura', 978.0000, 'ºC'),
	(294489, 143, '2015-01-01 00:34:55.000000', 'temperatura', 870.0000, 'ºC'),
	(294490, 143, '2015-01-01 00:34:56.000000', 'temperatura', 220.0000, 'ºC'),
	(294491, 143, '2015-01-01 00:34:57.000000', 'temperatura', 889.0000, 'ºC'),
	(294492, 143, '2015-01-01 00:34:58.000000', 'temperatura', 186.0000, 'ºC'),
	(294493, 143, '2015-01-01 00:34:59.000000', 'temperatura', 662.0000, 'ºC'),
	(294494, 143, '2015-01-01 00:35:00.000000', 'temperatura', 354.0000, 'ºC'),
	(294495, 143, '2015-01-01 00:35:01.000000', 'temperatura', 986.0000, 'ºC'),
	(294496, 143, '2015-01-01 00:35:02.000000', 'temperatura', 266.0000, 'ºC'),
	(294497, 143, '2015-01-01 00:35:03.000000', 'temperatura', 774.0000, 'ºC'),
	(294498, 143, '2015-01-01 00:35:04.000000', 'temperatura', 673.0000, 'ºC'),
	(294499, 143, '2015-01-01 00:35:05.000000', 'temperatura', 1043.0000, 'ºC'),
	(294500, 143, '2015-01-01 00:35:06.000000', 'temperatura', 797.0000, 'ºC'),
	(294501, 143, '2015-01-01 00:35:07.000000', 'temperatura', 857.0000, 'ºC'),
	(294502, 143, '2015-01-01 00:35:08.000000', 'temperatura', 695.0000, 'ºC'),
	(294503, 143, '2015-01-01 00:35:09.000000', 'temperatura', 903.0000, 'ºC'),
	(294504, 143, '2015-01-01 00:35:10.000000', 'temperatura', 29.0000, 'ºC'),
	(294505, 143, '2015-01-01 00:35:11.000000', 'temperatura', 1038.0000, 'ºC'),
	(294506, 143, '2015-01-01 00:35:12.000000', 'temperatura', 304.0000, 'ºC'),
	(294507, 143, '2015-01-01 00:35:13.000000', 'temperatura', 806.0000, 'ºC'),
	(294508, 143, '2015-01-01 00:35:14.000000', 'temperatura', 717.0000, 'ºC'),
	(294509, 143, '2015-01-01 00:35:15.000000', 'temperatura', 1167.0000, 'ºC'),
	(294510, 143, '2015-01-01 00:35:16.000000', 'temperatura', 85.0000, 'ºC'),
	(294511, 143, '2015-01-01 00:35:17.000000', 'temperatura', 526.0000, 'ºC'),
	(294512, 143, '2015-01-01 00:35:18.000000', 'temperatura', 1176.0000, 'ºC'),
	(294513, 143, '2015-01-01 00:35:19.000000', 'temperatura', 700.0000, 'ºC'),
	(294514, 143, '2015-01-01 00:35:20.000000', 'temperatura', 1174.0000, 'ºC'),
	(294515, 143, '2015-01-01 00:35:21.000000', 'temperatura', 171.0000, 'ºC'),
	(294516, 143, '2015-01-01 00:35:22.000000', 'temperatura', 932.0000, 'ºC'),
	(294517, 143, '2015-01-01 00:35:23.000000', 'temperatura', 547.0000, 'ºC'),
	(294518, 143, '2015-01-01 00:35:24.000000', 'temperatura', 1140.0000, 'ºC'),
	(294519, 143, '2015-01-01 00:35:25.000000', 'temperatura', 458.0000, 'ºC'),
	(294520, 143, '2015-01-01 00:35:26.000000', 'temperatura', 70.0000, 'ºC'),
	(294521, 143, '2015-01-01 00:35:27.000000', 'temperatura', 179.0000, 'ºC'),
	(294522, 143, '2015-01-01 00:35:28.000000', 'temperatura', 684.0000, 'ºC'),
	(294523, 143, '2015-01-01 00:35:29.000000', 'temperatura', 483.0000, 'ºC'),
	(294524, 143, '2015-01-01 00:35:30.000000', 'temperatura', 362.0000, 'ºC'),
	(294525, 143, '2015-01-01 00:35:31.000000', 'temperatura', 363.0000, 'ºC'),
	(294526, 143, '2015-01-01 00:35:32.000000', 'temperatura', 729.0000, 'ºC'),
	(294527, 143, '2015-01-01 00:35:33.000000', 'temperatura', 158.0000, 'ºC'),
	(294528, 143, '2015-01-01 00:35:34.000000', 'temperatura', 1001.0000, 'ºC'),
	(294529, 143, '2015-01-01 00:35:35.000000', 'temperatura', 931.0000, 'ºC'),
	(294530, 143, '2015-01-01 00:35:36.000000', 'temperatura', 453.0000, 'ºC'),
	(294531, 143, '2015-01-01 00:35:37.000000', 'temperatura', 673.0000, 'ºC'),
	(294532, 143, '2015-01-01 00:35:38.000000', 'temperatura', 808.0000, 'ºC'),
	(294533, 143, '2015-01-01 00:35:39.000000', 'temperatura', 821.0000, 'ºC'),
	(294534, 143, '2015-01-01 00:35:40.000000', 'temperatura', 479.0000, 'ºC'),
	(294535, 143, '2015-01-01 00:35:41.000000', 'temperatura', 1135.0000, 'ºC'),
	(294536, 143, '2015-01-01 00:35:42.000000', 'temperatura', 640.0000, 'ºC'),
	(294537, 143, '2015-01-01 00:35:43.000000', 'temperatura', 992.0000, 'ºC'),
	(294538, 143, '2015-01-01 00:35:44.000000', 'temperatura', 643.0000, 'ºC'),
	(294539, 143, '2015-01-01 00:35:45.000000', 'temperatura', 240.0000, 'ºC'),
	(294540, 143, '2015-01-01 00:35:46.000000', 'temperatura', 470.0000, 'ºC'),
	(294541, 143, '2015-01-01 00:35:47.000000', 'temperatura', 430.0000, 'ºC'),
	(294542, 143, '2015-01-01 00:35:48.000000', 'temperatura', 741.0000, 'ºC'),
	(294543, 143, '2015-01-01 00:35:49.000000', 'temperatura', 16.0000, 'ºC'),
	(294544, 143, '2015-01-01 00:35:50.000000', 'temperatura', 259.0000, 'ºC'),
	(294545, 143, '2015-01-01 00:35:51.000000', 'temperatura', 45.0000, 'ºC'),
	(294546, 143, '2015-01-01 00:35:52.000000', 'temperatura', 649.0000, 'ºC'),
	(294547, 143, '2015-01-01 00:35:53.000000', 'temperatura', 712.0000, 'ºC'),
	(294548, 143, '2015-01-01 00:35:54.000000', 'temperatura', 415.0000, 'ºC'),
	(294549, 143, '2015-01-01 00:35:55.000000', 'temperatura', 1136.0000, 'ºC'),
	(294550, 143, '2015-01-01 00:35:56.000000', 'temperatura', 839.0000, 'ºC'),
	(294551, 143, '2015-01-01 00:35:57.000000', 'temperatura', 785.0000, 'ºC'),
	(294552, 143, '2015-01-01 00:35:58.000000', 'temperatura', 207.0000, 'ºC'),
	(294553, 143, '2015-01-01 00:35:59.000000', 'temperatura', 1084.0000, 'ºC'),
	(294554, 143, '2015-01-01 00:36:00.000000', 'temperatura', 1196.0000, 'ºC'),
	(294555, 143, '2015-01-01 00:36:01.000000', 'temperatura', 332.0000, 'ºC'),
	(294556, 143, '2015-01-01 00:36:02.000000', 'temperatura', 469.0000, 'ºC'),
	(294557, 143, '2015-01-01 00:36:03.000000', 'temperatura', 151.0000, 'ºC'),
	(294558, 143, '2015-01-01 00:36:04.000000', 'temperatura', 548.0000, 'ºC'),
	(294559, 143, '2015-01-01 00:36:05.000000', 'temperatura', 1090.0000, 'ºC'),
	(294560, 143, '2015-01-01 00:36:06.000000', 'temperatura', 203.0000, 'ºC'),
	(294561, 143, '2015-01-01 00:36:07.000000', 'temperatura', 148.0000, 'ºC'),
	(294562, 143, '2015-01-01 00:36:08.000000', 'temperatura', 131.0000, 'ºC'),
	(294563, 143, '2015-01-01 00:36:09.000000', 'temperatura', 210.0000, 'ºC'),
	(294564, 143, '2015-01-01 00:36:10.000000', 'temperatura', 658.0000, 'ºC'),
	(294565, 143, '2015-01-01 00:36:11.000000', 'temperatura', 261.0000, 'ºC'),
	(294566, 143, '2015-01-01 00:36:12.000000', 'temperatura', 530.0000, 'ºC'),
	(294567, 143, '2015-01-01 00:36:13.000000', 'temperatura', 669.0000, 'ºC'),
	(294568, 143, '2015-01-01 00:36:14.000000', 'temperatura', 554.0000, 'ºC'),
	(294569, 143, '2015-01-01 00:36:15.000000', 'temperatura', 763.0000, 'ºC'),
	(294570, 143, '2015-01-01 00:36:16.000000', 'temperatura', 956.0000, 'ºC'),
	(294571, 143, '2015-01-01 00:36:17.000000', 'temperatura', 90.0000, 'ºC'),
	(294572, 143, '2015-01-01 00:36:18.000000', 'temperatura', 1183.0000, 'ºC'),
	(294573, 143, '2015-01-01 00:36:19.000000', 'temperatura', 845.0000, 'ºC'),
	(294574, 143, '2015-01-01 00:36:20.000000', 'temperatura', 678.0000, 'ºC'),
	(294575, 143, '2015-01-01 00:36:21.000000', 'temperatura', 853.0000, 'ºC'),
	(294576, 143, '2015-01-01 00:36:22.000000', 'temperatura', 1034.0000, 'ºC'),
	(294577, 143, '2015-01-01 00:36:23.000000', 'temperatura', 210.0000, 'ºC'),
	(294578, 143, '2015-01-01 00:36:24.000000', 'temperatura', 349.0000, 'ºC'),
	(294579, 143, '2015-01-01 00:36:25.000000', 'temperatura', 1114.0000, 'ºC'),
	(294580, 143, '2015-01-01 00:36:26.000000', 'temperatura', 926.0000, 'ºC'),
	(294581, 143, '2015-01-01 00:36:27.000000', 'temperatura', 86.0000, 'ºC'),
	(294582, 143, '2015-01-01 00:36:28.000000', 'temperatura', 54.0000, 'ºC'),
	(294583, 143, '2015-01-01 00:36:29.000000', 'temperatura', 12.0000, 'ºC'),
	(294584, 143, '2015-01-01 00:36:30.000000', 'temperatura', 1099.0000, 'ºC'),
	(294585, 143, '2015-01-01 00:36:31.000000', 'temperatura', 660.0000, 'ºC'),
	(294586, 143, '2015-01-01 00:36:32.000000', 'temperatura', 1.0000, 'ºC'),
	(294587, 143, '2015-01-01 00:36:33.000000', 'temperatura', 429.0000, 'ºC'),
	(294588, 143, '2015-01-01 00:36:34.000000', 'temperatura', 941.0000, 'ºC'),
	(294589, 143, '2015-01-01 00:36:35.000000', 'temperatura', 1017.0000, 'ºC'),
	(294590, 143, '2015-01-01 00:36:36.000000', 'temperatura', 1065.0000, 'ºC'),
	(294591, 143, '2015-01-01 00:36:37.000000', 'temperatura', 1072.0000, 'ºC'),
	(294592, 143, '2015-01-01 00:36:38.000000', 'temperatura', 966.0000, 'ºC'),
	(294593, 143, '2015-01-01 00:36:39.000000', 'temperatura', 416.0000, 'ºC'),
	(294594, 143, '2015-01-01 00:36:40.000000', 'temperatura', 384.0000, 'ºC'),
	(294595, 143, '2015-01-01 00:36:41.000000', 'temperatura', 670.0000, 'ºC'),
	(294596, 143, '2015-01-01 00:36:42.000000', 'temperatura', 1000.0000, 'ºC'),
	(294597, 143, '2015-01-01 00:36:43.000000', 'temperatura', 589.0000, 'ºC'),
	(294598, 143, '2015-01-01 00:36:44.000000', 'temperatura', 1144.0000, 'ºC'),
	(294599, 143, '2015-01-01 00:36:45.000000', 'temperatura', 356.0000, 'ºC'),
	(294600, 143, '2015-01-01 00:36:46.000000', 'temperatura', 746.0000, 'ºC'),
	(294601, 143, '2015-01-01 00:36:47.000000', 'temperatura', 265.0000, 'ºC'),
	(294602, 143, '2015-01-01 00:36:48.000000', 'temperatura', 287.0000, 'ºC'),
	(294603, 143, '2015-01-01 00:36:49.000000', 'temperatura', 639.0000, 'ºC'),
	(294604, 143, '2015-01-01 00:36:50.000000', 'temperatura', 1136.0000, 'ºC'),
	(294605, 143, '2015-01-01 00:36:51.000000', 'temperatura', 164.0000, 'ºC'),
	(294606, 143, '2015-01-01 00:36:52.000000', 'temperatura', 1011.0000, 'ºC'),
	(294607, 143, '2015-01-01 00:36:53.000000', 'temperatura', 966.0000, 'ºC'),
	(294608, 143, '2015-01-01 00:36:54.000000', 'temperatura', 596.0000, 'ºC'),
	(294609, 143, '2015-01-01 00:36:55.000000', 'temperatura', 82.0000, 'ºC'),
	(294610, 143, '2015-01-01 00:36:56.000000', 'temperatura', 1025.0000, 'ºC'),
	(294611, 143, '2015-01-01 00:36:57.000000', 'temperatura', 76.0000, 'ºC'),
	(294612, 143, '2015-01-01 00:36:58.000000', 'temperatura', 909.0000, 'ºC'),
	(294613, 143, '2015-01-01 00:36:59.000000', 'temperatura', 716.0000, 'ºC'),
	(294614, 143, '2015-01-01 00:37:00.000000', 'temperatura', 855.0000, 'ºC'),
	(294615, 143, '2015-01-01 00:37:01.000000', 'temperatura', 927.0000, 'ºC'),
	(294616, 143, '2015-01-01 00:37:02.000000', 'temperatura', 868.0000, 'ºC'),
	(294617, 143, '2015-01-01 00:37:03.000000', 'temperatura', 363.0000, 'ºC'),
	(294618, 143, '2015-01-01 00:37:04.000000', 'temperatura', 410.0000, 'ºC'),
	(294619, 143, '2015-01-01 00:37:05.000000', 'temperatura', 963.0000, 'ºC'),
	(294620, 143, '2015-01-01 00:37:06.000000', 'temperatura', 1183.0000, 'ºC'),
	(294621, 143, '2015-01-01 00:37:07.000000', 'temperatura', 628.0000, 'ºC'),
	(294622, 143, '2015-01-01 00:37:08.000000', 'temperatura', 791.0000, 'ºC'),
	(294623, 143, '2015-01-01 00:37:09.000000', 'temperatura', 870.0000, 'ºC'),
	(294624, 143, '2015-01-01 00:37:10.000000', 'temperatura', 779.0000, 'ºC'),
	(294625, 143, '2015-01-01 00:37:11.000000', 'temperatura', 84.0000, 'ºC'),
	(294626, 143, '2015-01-01 00:37:12.000000', 'temperatura', 485.0000, 'ºC'),
	(294627, 143, '2015-01-01 00:37:13.000000', 'temperatura', 974.0000, 'ºC'),
	(294628, 143, '2015-01-01 00:37:14.000000', 'temperatura', 1016.0000, 'ºC'),
	(294629, 143, '2015-01-01 00:37:15.000000', 'temperatura', 956.0000, 'ºC'),
	(294630, 143, '2015-01-01 00:37:16.000000', 'temperatura', 535.0000, 'ºC'),
	(294631, 143, '2015-01-01 00:37:17.000000', 'temperatura', 1007.0000, 'ºC'),
	(294632, 143, '2015-01-01 00:37:18.000000', 'temperatura', 1030.0000, 'ºC'),
	(294633, 143, '2015-01-01 00:37:19.000000', 'temperatura', 931.0000, 'ºC'),
	(294634, 143, '2015-01-01 00:37:20.000000', 'temperatura', 363.0000, 'ºC'),
	(294635, 143, '2015-01-01 00:37:21.000000', 'temperatura', 226.0000, 'ºC'),
	(294636, 143, '2015-01-01 00:37:22.000000', 'temperatura', 39.0000, 'ºC'),
	(294637, 143, '2015-01-01 00:37:23.000000', 'temperatura', 716.0000, 'ºC'),
	(294638, 143, '2015-01-01 00:37:24.000000', 'temperatura', 1067.0000, 'ºC'),
	(294639, 143, '2015-01-01 00:37:25.000000', 'temperatura', 786.0000, 'ºC'),
	(294640, 143, '2015-01-01 00:37:26.000000', 'temperatura', 730.0000, 'ºC'),
	(294641, 143, '2015-01-01 00:37:27.000000', 'temperatura', 94.0000, 'ºC'),
	(294642, 143, '2015-01-01 00:37:28.000000', 'temperatura', 677.0000, 'ºC'),
	(294643, 143, '2015-01-01 00:37:29.000000', 'temperatura', 706.0000, 'ºC'),
	(294644, 143, '2015-01-01 00:37:30.000000', 'temperatura', 298.0000, 'ºC'),
	(294645, 143, '2015-01-01 00:37:31.000000', 'temperatura', 572.0000, 'ºC'),
	(294646, 143, '2015-01-01 00:37:32.000000', 'temperatura', 765.0000, 'ºC'),
	(294647, 143, '2015-01-01 00:37:33.000000', 'temperatura', 913.0000, 'ºC'),
	(294648, 143, '2015-01-01 00:37:34.000000', 'temperatura', 1069.0000, 'ºC'),
	(294649, 143, '2015-01-01 00:37:35.000000', 'temperatura', 209.0000, 'ºC'),
	(294650, 143, '2015-01-01 00:37:36.000000', 'temperatura', 235.0000, 'ºC'),
	(294651, 143, '2015-01-01 00:37:37.000000', 'temperatura', 551.0000, 'ºC'),
	(294652, 143, '2015-01-01 00:37:38.000000', 'temperatura', 848.0000, 'ºC'),
	(294653, 143, '2015-01-01 00:37:39.000000', 'temperatura', 190.0000, 'ºC'),
	(294654, 143, '2015-01-01 00:37:40.000000', 'temperatura', 805.0000, 'ºC'),
	(294655, 143, '2015-01-01 00:37:41.000000', 'temperatura', 1054.0000, 'ºC'),
	(294656, 143, '2015-01-01 00:37:42.000000', 'temperatura', 456.0000, 'ºC'),
	(294657, 143, '2015-01-01 00:37:43.000000', 'temperatura', 319.0000, 'ºC'),
	(294658, 143, '2015-01-01 00:37:44.000000', 'temperatura', 227.0000, 'ºC'),
	(294659, 143, '2015-01-01 00:37:45.000000', 'temperatura', 178.0000, 'ºC'),
	(294660, 143, '2015-01-01 00:37:46.000000', 'temperatura', 212.0000, 'ºC'),
	(294661, 143, '2015-01-01 00:37:47.000000', 'temperatura', 526.0000, 'ºC'),
	(294662, 143, '2015-01-01 00:37:48.000000', 'temperatura', 793.0000, 'ºC'),
	(294663, 143, '2015-01-01 00:37:49.000000', 'temperatura', 1188.0000, 'ºC'),
	(294664, 143, '2015-01-01 00:37:50.000000', 'temperatura', 1162.0000, 'ºC'),
	(294665, 143, '2015-01-01 00:37:51.000000', 'temperatura', 1046.0000, 'ºC'),
	(294666, 143, '2015-01-01 00:37:52.000000', 'temperatura', 546.0000, 'ºC'),
	(294667, 143, '2015-01-01 00:37:53.000000', 'temperatura', 790.0000, 'ºC'),
	(294668, 143, '2015-01-01 00:37:54.000000', 'temperatura', 1112.0000, 'ºC'),
	(294669, 143, '2015-01-01 00:37:55.000000', 'temperatura', 793.0000, 'ºC'),
	(294670, 143, '2015-01-01 00:37:56.000000', 'temperatura', 628.0000, 'ºC'),
	(294671, 143, '2015-01-01 00:37:57.000000', 'temperatura', 762.0000, 'ºC'),
	(294672, 143, '2015-01-01 00:37:58.000000', 'temperatura', 725.0000, 'ºC'),
	(294673, 143, '2015-01-01 00:37:59.000000', 'temperatura', 140.0000, 'ºC'),
	(294674, 143, '2015-01-01 00:38:00.000000', 'temperatura', 927.0000, 'ºC'),
	(294675, 143, '2015-01-01 00:38:01.000000', 'temperatura', 614.0000, 'ºC'),
	(294676, 143, '2015-01-01 00:38:02.000000', 'temperatura', 292.0000, 'ºC'),
	(294677, 143, '2015-01-01 00:38:03.000000', 'temperatura', 818.0000, 'ºC'),
	(294678, 143, '2015-01-01 00:38:04.000000', 'temperatura', 812.0000, 'ºC'),
	(294679, 143, '2015-01-01 00:38:05.000000', 'temperatura', 407.0000, 'ºC'),
	(294680, 143, '2015-01-01 00:38:06.000000', 'temperatura', 799.0000, 'ºC'),
	(294681, 143, '2015-01-01 00:38:07.000000', 'temperatura', 375.0000, 'ºC'),
	(294682, 143, '2015-01-01 00:38:08.000000', 'temperatura', 677.0000, 'ºC'),
	(294683, 143, '2015-01-01 00:38:09.000000', 'temperatura', 1063.0000, 'ºC'),
	(294684, 143, '2015-01-01 00:38:10.000000', 'temperatura', 883.0000, 'ºC'),
	(294685, 143, '2015-01-01 00:38:11.000000', 'temperatura', 27.0000, 'ºC'),
	(294686, 143, '2015-01-01 00:38:12.000000', 'temperatura', 1087.0000, 'ºC'),
	(294687, 143, '2015-01-01 00:38:13.000000', 'temperatura', 553.0000, 'ºC'),
	(294688, 143, '2015-01-01 00:38:14.000000', 'temperatura', 703.0000, 'ºC'),
	(294689, 143, '2015-01-01 00:38:15.000000', 'temperatura', 660.0000, 'ºC'),
	(294690, 143, '2015-01-01 00:38:16.000000', 'temperatura', 1190.0000, 'ºC'),
	(294691, 143, '2015-01-01 00:38:17.000000', 'temperatura', 371.0000, 'ºC'),
	(294692, 143, '2015-01-01 00:38:18.000000', 'temperatura', 685.0000, 'ºC'),
	(294693, 143, '2015-01-01 00:38:19.000000', 'temperatura', 1113.0000, 'ºC'),
	(294694, 143, '2015-01-01 00:38:20.000000', 'temperatura', 1110.0000, 'ºC'),
	(294695, 143, '2015-01-01 00:38:21.000000', 'temperatura', 1011.0000, 'ºC'),
	(294696, 143, '2015-01-01 00:38:22.000000', 'temperatura', 527.0000, 'ºC'),
	(294697, 143, '2015-01-01 00:38:23.000000', 'temperatura', 804.0000, 'ºC'),
	(294698, 143, '2015-01-01 00:38:24.000000', 'temperatura', 36.0000, 'ºC'),
	(294699, 143, '2015-01-01 00:38:25.000000', 'temperatura', 170.0000, 'ºC'),
	(294700, 143, '2015-01-01 00:38:26.000000', 'temperatura', 744.0000, 'ºC'),
	(294701, 143, '2015-01-01 00:38:27.000000', 'temperatura', 808.0000, 'ºC'),
	(294702, 143, '2015-01-01 00:38:28.000000', 'temperatura', 610.0000, 'ºC'),
	(294703, 143, '2015-01-01 00:38:29.000000', 'temperatura', 626.0000, 'ºC'),
	(294704, 143, '2015-01-01 00:38:30.000000', 'temperatura', 101.0000, 'ºC'),
	(294705, 143, '2015-01-01 00:38:31.000000', 'temperatura', 1027.0000, 'ºC'),
	(294706, 143, '2015-01-01 00:38:32.000000', 'temperatura', 32.0000, 'ºC'),
	(294707, 143, '2015-01-01 00:38:33.000000', 'temperatura', 679.0000, 'ºC'),
	(294708, 143, '2015-01-01 00:38:34.000000', 'temperatura', 900.0000, 'ºC'),
	(294709, 143, '2015-01-01 00:38:35.000000', 'temperatura', 62.0000, 'ºC'),
	(294710, 143, '2015-01-01 00:38:36.000000', 'temperatura', 10.0000, 'ºC'),
	(294711, 143, '2015-01-01 00:38:37.000000', 'temperatura', 1065.0000, 'ºC'),
	(294712, 143, '2015-01-01 00:38:38.000000', 'temperatura', 495.0000, 'ºC'),
	(294713, 143, '2015-01-01 00:38:39.000000', 'temperatura', 481.0000, 'ºC'),
	(294714, 143, '2015-01-01 00:38:40.000000', 'temperatura', 921.0000, 'ºC'),
	(294715, 143, '2015-01-01 00:38:41.000000', 'temperatura', 761.0000, 'ºC'),
	(294716, 143, '2015-01-01 00:38:42.000000', 'temperatura', 1045.0000, 'ºC'),
	(294717, 143, '2015-01-01 00:38:43.000000', 'temperatura', 542.0000, 'ºC'),
	(294718, 143, '2015-01-01 00:38:44.000000', 'temperatura', 774.0000, 'ºC'),
	(294719, 143, '2015-01-01 00:38:45.000000', 'temperatura', 1044.0000, 'ºC'),
	(294720, 143, '2015-01-01 00:38:46.000000', 'temperatura', 501.0000, 'ºC'),
	(294721, 143, '2015-01-01 00:38:47.000000', 'temperatura', 570.0000, 'ºC'),
	(294722, 143, '2015-01-01 00:38:48.000000', 'temperatura', 151.0000, 'ºC'),
	(294723, 143, '2015-01-01 00:38:49.000000', 'temperatura', 243.0000, 'ºC'),
	(294724, 143, '2015-01-01 00:38:50.000000', 'temperatura', 765.0000, 'ºC'),
	(294725, 143, '2015-01-01 00:38:51.000000', 'temperatura', 694.0000, 'ºC'),
	(294726, 143, '2015-01-01 00:38:52.000000', 'temperatura', 1177.0000, 'ºC'),
	(294727, 143, '2015-01-01 00:38:53.000000', 'temperatura', 203.0000, 'ºC'),
	(294728, 143, '2015-01-01 00:38:54.000000', 'temperatura', 1086.0000, 'ºC'),
	(294729, 143, '2015-01-01 00:38:55.000000', 'temperatura', 21.0000, 'ºC'),
	(294730, 143, '2015-01-01 00:38:56.000000', 'temperatura', 445.0000, 'ºC'),
	(294731, 143, '2015-01-01 00:38:57.000000', 'temperatura', 965.0000, 'ºC'),
	(294732, 143, '2015-01-01 00:38:58.000000', 'temperatura', 1089.0000, 'ºC'),
	(294733, 143, '2015-01-01 00:38:59.000000', 'temperatura', 153.0000, 'ºC'),
	(294734, 143, '2015-01-01 00:39:00.000000', 'temperatura', 1095.0000, 'ºC'),
	(294735, 143, '2015-01-01 00:39:01.000000', 'temperatura', 220.0000, 'ºC'),
	(294736, 143, '2015-01-01 00:39:02.000000', 'temperatura', 214.0000, 'ºC'),
	(294737, 143, '2015-01-01 00:39:03.000000', 'temperatura', 412.0000, 'ºC'),
	(294738, 143, '2015-01-01 00:39:04.000000', 'temperatura', 219.0000, 'ºC'),
	(294739, 143, '2015-01-01 00:39:05.000000', 'temperatura', 1059.0000, 'ºC'),
	(294740, 143, '2015-01-01 00:39:06.000000', 'temperatura', 1040.0000, 'ºC'),
	(294741, 143, '2015-01-01 00:39:07.000000', 'temperatura', 821.0000, 'ºC'),
	(294742, 143, '2015-01-01 00:39:08.000000', 'temperatura', 986.0000, 'ºC'),
	(294743, 143, '2015-01-01 00:39:09.000000', 'temperatura', 66.0000, 'ºC'),
	(294744, 143, '2015-01-01 00:39:10.000000', 'temperatura', 975.0000, 'ºC'),
	(294745, 143, '2015-01-01 00:39:11.000000', 'temperatura', 1076.0000, 'ºC'),
	(294746, 143, '2015-01-01 00:39:12.000000', 'temperatura', 55.0000, 'ºC'),
	(294747, 143, '2015-01-01 00:39:13.000000', 'temperatura', 649.0000, 'ºC'),
	(294748, 143, '2015-01-01 00:39:14.000000', 'temperatura', 679.0000, 'ºC'),
	(294749, 143, '2015-01-01 00:39:15.000000', 'temperatura', 247.0000, 'ºC'),
	(294750, 143, '2015-01-01 00:39:16.000000', 'temperatura', 402.0000, 'ºC'),
	(294751, 143, '2015-01-01 00:39:17.000000', 'temperatura', 67.0000, 'ºC'),
	(294752, 143, '2015-01-01 00:39:18.000000', 'temperatura', 329.0000, 'ºC'),
	(294753, 143, '2015-01-01 00:39:19.000000', 'temperatura', 244.0000, 'ºC'),
	(294754, 143, '2015-01-01 00:39:20.000000', 'temperatura', 233.0000, 'ºC'),
	(294755, 143, '2015-01-01 00:39:21.000000', 'temperatura', 436.0000, 'ºC'),
	(294756, 143, '2015-01-01 00:39:22.000000', 'temperatura', 282.0000, 'ºC'),
	(294757, 143, '2015-01-01 00:39:23.000000', 'temperatura', 100.0000, 'ºC'),
	(294758, 143, '2015-01-01 00:39:24.000000', 'temperatura', 854.0000, 'ºC'),
	(294759, 143, '2015-01-01 00:39:25.000000', 'temperatura', 370.0000, 'ºC'),
	(294760, 143, '2015-01-01 00:39:26.000000', 'temperatura', 488.0000, 'ºC'),
	(294761, 143, '2015-01-01 00:39:27.000000', 'temperatura', 133.0000, 'ºC'),
	(294762, 143, '2015-01-01 00:39:28.000000', 'temperatura', 403.0000, 'ºC'),
	(294763, 143, '2015-01-01 00:39:29.000000', 'temperatura', 413.0000, 'ºC'),
	(294764, 143, '2015-01-01 00:39:30.000000', 'temperatura', 857.0000, 'ºC'),
	(294765, 143, '2015-01-01 00:39:31.000000', 'temperatura', 648.0000, 'ºC'),
	(294766, 143, '2015-01-01 00:39:32.000000', 'temperatura', 667.0000, 'ºC'),
	(294767, 143, '2015-01-01 00:39:33.000000', 'temperatura', 192.0000, 'ºC'),
	(294768, 143, '2015-01-01 00:39:34.000000', 'temperatura', 161.0000, 'ºC'),
	(294769, 143, '2015-01-01 00:39:35.000000', 'temperatura', 231.0000, 'ºC'),
	(294770, 143, '2015-01-01 00:39:36.000000', 'temperatura', 669.0000, 'ºC'),
	(294771, 143, '2015-01-01 00:39:37.000000', 'temperatura', 254.0000, 'ºC'),
	(294772, 143, '2015-01-01 00:39:38.000000', 'temperatura', 461.0000, 'ºC'),
	(294773, 143, '2015-01-01 00:39:39.000000', 'temperatura', 346.0000, 'ºC'),
	(294774, 143, '2015-01-01 00:39:40.000000', 'temperatura', 348.0000, 'ºC'),
	(294775, 143, '2015-01-01 00:39:41.000000', 'temperatura', 704.0000, 'ºC'),
	(294776, 143, '2015-01-01 00:39:42.000000', 'temperatura', 73.0000, 'ºC'),
	(294777, 143, '2015-01-01 00:39:43.000000', 'temperatura', 654.0000, 'ºC'),
	(294778, 143, '2015-01-01 00:39:44.000000', 'temperatura', 652.0000, 'ºC'),
	(294779, 143, '2015-01-01 00:39:45.000000', 'temperatura', 100.0000, 'ºC'),
	(294780, 143, '2015-01-01 00:39:46.000000', 'temperatura', 942.0000, 'ºC'),
	(294781, 143, '2015-01-01 00:39:47.000000', 'temperatura', 812.0000, 'ºC'),
	(294782, 143, '2015-01-01 00:39:48.000000', 'temperatura', 34.0000, 'ºC'),
	(294783, 143, '2015-01-01 00:39:49.000000', 'temperatura', 136.0000, 'ºC'),
	(294784, 143, '2015-01-01 00:39:50.000000', 'temperatura', 577.0000, 'ºC'),
	(294785, 143, '2015-01-01 00:39:51.000000', 'temperatura', 78.0000, 'ºC'),
	(294786, 143, '2015-01-01 00:39:52.000000', 'temperatura', 1060.0000, 'ºC'),
	(294787, 143, '2015-01-01 00:39:53.000000', 'temperatura', 267.0000, 'ºC'),
	(294788, 143, '2015-01-01 00:39:54.000000', 'temperatura', 555.0000, 'ºC'),
	(294789, 143, '2015-01-01 00:39:55.000000', 'temperatura', 776.0000, 'ºC'),
	(294790, 143, '2015-01-01 00:39:56.000000', 'temperatura', 1015.0000, 'ºC'),
	(294791, 143, '2015-01-01 00:39:57.000000', 'temperatura', 346.0000, 'ºC'),
	(294792, 143, '2015-01-01 00:39:58.000000', 'temperatura', 1086.0000, 'ºC'),
	(294793, 143, '2015-01-01 00:39:59.000000', 'temperatura', 793.0000, 'ºC'),
	(294794, 143, '2015-01-01 00:40:00.000000', 'temperatura', 705.0000, 'ºC'),
	(294795, 143, '2015-01-01 00:40:01.000000', 'temperatura', 1149.0000, 'ºC'),
	(294796, 143, '2015-01-01 00:40:02.000000', 'temperatura', 32.0000, 'ºC'),
	(294797, 143, '2015-01-01 00:40:03.000000', 'temperatura', 311.0000, 'ºC'),
	(294798, 143, '2015-01-01 00:40:04.000000', 'temperatura', 260.0000, 'ºC'),
	(294799, 143, '2015-01-01 00:40:05.000000', 'temperatura', 366.0000, 'ºC'),
	(294800, 143, '2015-01-01 00:40:06.000000', 'temperatura', 1051.0000, 'ºC'),
	(294801, 143, '2015-01-01 00:40:07.000000', 'temperatura', 557.0000, 'ºC'),
	(294802, 143, '2015-01-01 00:40:08.000000', 'temperatura', 833.0000, 'ºC'),
	(294803, 143, '2015-01-01 00:40:09.000000', 'temperatura', 97.0000, 'ºC'),
	(294804, 143, '2015-01-01 00:40:10.000000', 'temperatura', 384.0000, 'ºC'),
	(294805, 143, '2015-01-01 00:40:11.000000', 'temperatura', 429.0000, 'ºC'),
	(294806, 143, '2015-01-01 00:40:12.000000', 'temperatura', 995.0000, 'ºC'),
	(294807, 143, '2015-01-01 00:40:13.000000', 'temperatura', 86.0000, 'ºC'),
	(294808, 143, '2015-01-01 00:40:14.000000', 'temperatura', 1047.0000, 'ºC'),
	(294809, 143, '2015-01-01 00:40:15.000000', 'temperatura', 178.0000, 'ºC'),
	(294810, 143, '2015-01-01 00:40:16.000000', 'temperatura', 150.0000, 'ºC'),
	(294811, 143, '2015-01-01 00:40:17.000000', 'temperatura', 216.0000, 'ºC'),
	(294812, 143, '2015-01-01 00:40:18.000000', 'temperatura', 632.0000, 'ºC'),
	(294813, 143, '2015-01-01 00:40:19.000000', 'temperatura', 112.0000, 'ºC'),
	(294814, 143, '2015-01-01 00:40:20.000000', 'temperatura', 1064.0000, 'ºC'),
	(294815, 143, '2015-01-01 00:40:21.000000', 'temperatura', 186.0000, 'ºC'),
	(294816, 143, '2015-01-01 00:40:22.000000', 'temperatura', 137.0000, 'ºC'),
	(294817, 143, '2015-01-01 00:40:23.000000', 'temperatura', 129.0000, 'ºC'),
	(294818, 143, '2015-01-01 00:40:24.000000', 'temperatura', 233.0000, 'ºC'),
	(294819, 143, '2015-01-01 00:40:25.000000', 'temperatura', 779.0000, 'ºC'),
	(294820, 143, '2015-01-01 00:40:26.000000', 'temperatura', 796.0000, 'ºC'),
	(294821, 143, '2015-01-01 00:40:27.000000', 'temperatura', 444.0000, 'ºC'),
	(294822, 143, '2015-01-01 00:40:28.000000', 'temperatura', 1033.0000, 'ºC'),
	(294823, 143, '2015-01-01 00:40:29.000000', 'temperatura', 233.0000, 'ºC'),
	(294824, 143, '2015-01-01 00:40:30.000000', 'temperatura', 465.0000, 'ºC'),
	(294825, 143, '2015-01-01 00:40:31.000000', 'temperatura', 428.0000, 'ºC'),
	(294826, 143, '2015-01-01 00:40:32.000000', 'temperatura', 745.0000, 'ºC'),
	(294827, 143, '2015-01-01 00:40:33.000000', 'temperatura', 43.0000, 'ºC'),
	(294828, 143, '2015-01-01 00:40:34.000000', 'temperatura', 381.0000, 'ºC'),
	(294829, 143, '2015-01-01 00:40:35.000000', 'temperatura', 574.0000, 'ºC'),
	(294830, 143, '2015-01-01 00:40:36.000000', 'temperatura', 528.0000, 'ºC'),
	(294831, 143, '2015-01-01 00:40:37.000000', 'temperatura', 917.0000, 'ºC'),
	(294832, 143, '2015-01-01 00:40:38.000000', 'temperatura', 605.0000, 'ºC'),
	(294833, 143, '2015-01-01 00:40:39.000000', 'temperatura', 273.0000, 'ºC'),
	(294834, 143, '2015-01-01 00:40:40.000000', 'temperatura', 749.0000, 'ºC'),
	(294835, 143, '2015-01-01 00:40:41.000000', 'temperatura', 526.0000, 'ºC'),
	(294836, 143, '2015-01-01 00:40:42.000000', 'temperatura', 382.0000, 'ºC'),
	(294837, 143, '2015-01-01 00:40:43.000000', 'temperatura', 336.0000, 'ºC'),
	(294838, 143, '2015-01-01 00:40:44.000000', 'temperatura', 535.0000, 'ºC'),
	(294839, 143, '2015-01-01 00:40:45.000000', 'temperatura', 466.0000, 'ºC'),
	(294840, 143, '2015-01-01 00:40:46.000000', 'temperatura', 726.0000, 'ºC'),
	(294841, 143, '2015-01-01 00:40:47.000000', 'temperatura', 1033.0000, 'ºC'),
	(294842, 143, '2015-01-01 00:40:48.000000', 'temperatura', 589.0000, 'ºC'),
	(294843, 143, '2015-01-01 00:40:49.000000', 'temperatura', 1044.0000, 'ºC'),
	(294844, 143, '2015-01-01 00:40:50.000000', 'temperatura', 1054.0000, 'ºC'),
	(294845, 143, '2015-01-01 00:40:51.000000', 'temperatura', 939.0000, 'ºC'),
	(294846, 143, '2015-01-01 00:40:52.000000', 'temperatura', 333.0000, 'ºC'),
	(294847, 143, '2015-01-01 00:40:53.000000', 'temperatura', 51.0000, 'ºC'),
	(294848, 143, '2015-01-01 00:40:54.000000', 'temperatura', 454.0000, 'ºC'),
	(294849, 143, '2015-01-01 00:40:55.000000', 'temperatura', 917.0000, 'ºC'),
	(294850, 143, '2015-01-01 00:40:56.000000', 'temperatura', 826.0000, 'ºC'),
	(294851, 143, '2015-01-01 00:40:57.000000', 'temperatura', 177.0000, 'ºC'),
	(294852, 143, '2015-01-01 00:40:58.000000', 'temperatura', 810.0000, 'ºC'),
	(294853, 143, '2015-01-01 00:40:59.000000', 'temperatura', 1118.0000, 'ºC'),
	(294854, 143, '2015-01-01 00:41:00.000000', 'temperatura', 759.0000, 'ºC'),
	(294855, 143, '2015-01-01 00:41:01.000000', 'temperatura', 443.0000, 'ºC'),
	(294856, 143, '2015-01-01 00:41:02.000000', 'temperatura', 1137.0000, 'ºC'),
	(294857, 143, '2015-01-01 00:41:03.000000', 'temperatura', 757.0000, 'ºC'),
	(294858, 143, '2015-01-01 00:41:04.000000', 'temperatura', 376.0000, 'ºC'),
	(294859, 143, '2015-01-01 00:41:05.000000', 'temperatura', 811.0000, 'ºC'),
	(294860, 143, '2015-01-01 00:41:06.000000', 'temperatura', 524.0000, 'ºC'),
	(294861, 143, '2015-01-01 00:41:07.000000', 'temperatura', 188.0000, 'ºC'),
	(294862, 143, '2015-01-01 00:41:08.000000', 'temperatura', 568.0000, 'ºC'),
	(294863, 143, '2015-01-01 00:41:09.000000', 'temperatura', 1079.0000, 'ºC'),
	(294864, 143, '2015-01-01 00:41:10.000000', 'temperatura', 91.0000, 'ºC'),
	(294865, 143, '2015-01-01 00:41:11.000000', 'temperatura', 819.0000, 'ºC'),
	(294866, 143, '2015-01-01 00:41:12.000000', 'temperatura', 221.0000, 'ºC'),
	(294867, 143, '2015-01-01 00:41:13.000000', 'temperatura', 1050.0000, 'ºC'),
	(294868, 143, '2015-01-01 00:41:14.000000', 'temperatura', 989.0000, 'ºC'),
	(294869, 143, '2015-01-01 00:41:15.000000', 'temperatura', 593.0000, 'ºC'),
	(294870, 143, '2015-01-01 00:41:16.000000', 'temperatura', 0.0000, 'ºC'),
	(294871, 143, '2015-01-01 00:41:17.000000', 'temperatura', 620.0000, 'ºC'),
	(294872, 143, '2015-01-01 00:41:18.000000', 'temperatura', 702.0000, 'ºC'),
	(294873, 143, '2015-01-01 00:41:19.000000', 'temperatura', 448.0000, 'ºC'),
	(294874, 143, '2015-01-01 00:41:20.000000', 'temperatura', 138.0000, 'ºC'),
	(294875, 143, '2015-01-01 00:41:21.000000', 'temperatura', 543.0000, 'ºC'),
	(294876, 143, '2015-01-01 00:41:22.000000', 'temperatura', 1105.0000, 'ºC'),
	(294877, 143, '2015-01-01 00:41:23.000000', 'temperatura', 295.0000, 'ºC'),
	(294878, 143, '2015-01-01 00:41:24.000000', 'temperatura', 560.0000, 'ºC'),
	(294879, 143, '2015-01-01 00:41:25.000000', 'temperatura', 715.0000, 'ºC'),
	(294880, 143, '2015-01-01 00:41:26.000000', 'temperatura', 697.0000, 'ºC'),
	(294881, 143, '2015-01-01 00:41:27.000000', 'temperatura', 142.0000, 'ºC'),
	(294882, 143, '2015-01-01 00:41:28.000000', 'temperatura', 1017.0000, 'ºC'),
	(294883, 143, '2015-01-01 00:41:29.000000', 'temperatura', 1061.0000, 'ºC'),
	(294884, 143, '2015-01-01 00:41:30.000000', 'temperatura', 1055.0000, 'ºC'),
	(294885, 143, '2015-01-01 00:41:31.000000', 'temperatura', 893.0000, 'ºC'),
	(294886, 143, '2015-01-01 00:41:32.000000', 'temperatura', 99.0000, 'ºC'),
	(294887, 143, '2015-01-01 00:41:33.000000', 'temperatura', 216.0000, 'ºC'),
	(294888, 143, '2015-01-01 00:41:34.000000', 'temperatura', 782.0000, 'ºC'),
	(294889, 143, '2015-01-01 00:41:35.000000', 'temperatura', 865.0000, 'ºC'),
	(294890, 143, '2015-01-01 00:41:36.000000', 'temperatura', 777.0000, 'ºC'),
	(294891, 143, '2015-01-01 00:41:37.000000', 'temperatura', 93.0000, 'ºC'),
	(294892, 143, '2015-01-01 00:41:38.000000', 'temperatura', 533.0000, 'ºC'),
	(294893, 143, '2015-01-01 00:41:39.000000', 'temperatura', 1185.0000, 'ºC'),
	(294894, 143, '2015-01-01 00:41:40.000000', 'temperatura', 728.0000, 'ºC'),
	(294895, 143, '2015-01-01 00:41:41.000000', 'temperatura', 87.0000, 'ºC'),
	(294896, 143, '2015-01-01 00:41:42.000000', 'temperatura', 650.0000, 'ºC'),
	(294897, 143, '2015-01-01 00:41:43.000000', 'temperatura', 591.0000, 'ºC'),
	(294898, 143, '2015-01-01 00:41:44.000000', 'temperatura', 1006.0000, 'ºC'),
	(294899, 143, '2015-01-01 00:41:45.000000', 'temperatura', 856.0000, 'ºC'),
	(294900, 143, '2015-01-01 00:41:46.000000', 'temperatura', 61.0000, 'ºC'),
	(294901, 143, '2015-01-01 00:41:47.000000', 'temperatura', 140.0000, 'ºC'),
	(294902, 143, '2015-01-01 00:41:48.000000', 'temperatura', 518.0000, 'ºC'),
	(294903, 143, '2015-01-01 00:41:49.000000', 'temperatura', 971.0000, 'ºC'),
	(294904, 143, '2015-01-01 00:41:50.000000', 'temperatura', 900.0000, 'ºC'),
	(294905, 143, '2015-01-01 00:41:51.000000', 'temperatura', 389.0000, 'ºC'),
	(294906, 143, '2015-01-01 00:41:52.000000', 'temperatura', 446.0000, 'ºC'),
	(294907, 143, '2015-01-01 00:41:53.000000', 'temperatura', 1064.0000, 'ºC'),
	(294908, 143, '2015-01-01 00:41:54.000000', 'temperatura', 380.0000, 'ºC'),
	(294909, 143, '2015-01-01 00:41:55.000000', 'temperatura', 1109.0000, 'ºC'),
	(294910, 143, '2015-01-01 00:41:56.000000', 'temperatura', 805.0000, 'ºC'),
	(294911, 143, '2015-01-01 00:41:57.000000', 'temperatura', 700.0000, 'ºC'),
	(294912, 143, '2015-01-01 00:41:58.000000', 'temperatura', 1083.0000, 'ºC'),
	(294913, 143, '2015-01-01 00:41:59.000000', 'temperatura', 918.0000, 'ºC'),
	(294914, 143, '2015-01-01 00:42:00.000000', 'temperatura', 139.0000, 'ºC'),
	(294915, 143, '2015-01-01 00:42:01.000000', 'temperatura', 344.0000, 'ºC'),
	(294916, 143, '2015-01-01 00:42:02.000000', 'temperatura', 102.0000, 'ºC'),
	(294917, 143, '2015-01-01 00:42:03.000000', 'temperatura', 678.0000, 'ºC'),
	(294918, 143, '2015-01-01 00:42:04.000000', 'temperatura', 685.0000, 'ºC'),
	(294919, 143, '2015-01-01 00:42:05.000000', 'temperatura', 191.0000, 'ºC'),
	(294920, 143, '2015-01-01 00:42:06.000000', 'temperatura', 101.0000, 'ºC'),
	(294921, 143, '2015-01-01 00:42:07.000000', 'temperatura', 1131.0000, 'ºC'),
	(294922, 143, '2015-01-01 00:42:08.000000', 'temperatura', 554.0000, 'ºC'),
	(294923, 143, '2015-01-01 00:42:09.000000', 'temperatura', 575.0000, 'ºC'),
	(294924, 143, '2015-01-01 00:42:10.000000', 'temperatura', 17.0000, 'ºC'),
	(294925, 143, '2015-01-01 00:42:11.000000', 'temperatura', 758.0000, 'ºC'),
	(294926, 143, '2015-01-01 00:42:12.000000', 'temperatura', 138.0000, 'ºC'),
	(294927, 143, '2015-01-01 00:42:13.000000', 'temperatura', 820.0000, 'ºC'),
	(294928, 143, '2015-01-01 00:42:14.000000', 'temperatura', 83.0000, 'ºC'),
	(294929, 143, '2015-01-01 00:42:15.000000', 'temperatura', 359.0000, 'ºC'),
	(294930, 143, '2015-01-01 00:42:16.000000', 'temperatura', 343.0000, 'ºC'),
	(294931, 143, '2015-01-01 00:42:17.000000', 'temperatura', 642.0000, 'ºC'),
	(294932, 143, '2015-01-01 00:42:18.000000', 'temperatura', 980.0000, 'ºC'),
	(294933, 143, '2015-01-01 00:42:19.000000', 'temperatura', 576.0000, 'ºC'),
	(294934, 143, '2015-01-01 00:42:20.000000', 'temperatura', 1140.0000, 'ºC'),
	(294935, 143, '2015-01-01 00:42:21.000000', 'temperatura', 374.0000, 'ºC'),
	(294936, 143, '2015-01-01 00:42:22.000000', 'temperatura', 849.0000, 'ºC'),
	(294937, 143, '2015-01-01 00:42:23.000000', 'temperatura', 723.0000, 'ºC'),
	(294938, 143, '2015-01-01 00:42:24.000000', 'temperatura', 1070.0000, 'ºC'),
	(294939, 143, '2015-01-01 00:42:25.000000', 'temperatura', 779.0000, 'ºC'),
	(294940, 143, '2015-01-01 00:42:26.000000', 'temperatura', 687.0000, 'ºC'),
	(294941, 143, '2015-01-01 00:42:27.000000', 'temperatura', 1097.0000, 'ºC'),
	(294942, 143, '2015-01-01 00:42:28.000000', 'temperatura', 1024.0000, 'ºC'),
	(294943, 143, '2015-01-01 00:42:29.000000', 'temperatura', 630.0000, 'ºC'),
	(294944, 143, '2015-01-01 00:42:30.000000', 'temperatura', 77.0000, 'ºC'),
	(294945, 143, '2015-01-01 00:42:31.000000', 'temperatura', 896.0000, 'ºC'),
	(294946, 143, '2015-01-01 00:42:32.000000', 'temperatura', 651.0000, 'ºC'),
	(294947, 143, '2015-01-01 00:42:33.000000', 'temperatura', 565.0000, 'ºC'),
	(294948, 143, '2015-01-01 00:42:34.000000', 'temperatura', 876.0000, 'ºC'),
	(294949, 143, '2015-01-01 00:42:35.000000', 'temperatura', 283.0000, 'ºC'),
	(294950, 143, '2015-01-01 00:42:36.000000', 'temperatura', 1190.0000, 'ºC'),
	(294951, 143, '2015-01-01 00:42:37.000000', 'temperatura', 300.0000, 'ºC'),
	(294952, 143, '2015-01-01 00:42:38.000000', 'temperatura', 331.0000, 'ºC'),
	(294953, 143, '2015-01-01 00:42:39.000000', 'temperatura', 757.0000, 'ºC'),
	(294954, 143, '2015-01-01 00:42:40.000000', 'temperatura', 390.0000, 'ºC'),
	(294955, 143, '2015-01-01 00:42:41.000000', 'temperatura', 878.0000, 'ºC'),
	(294956, 143, '2015-01-01 00:42:42.000000', 'temperatura', 824.0000, 'ºC'),
	(294957, 143, '2015-01-01 00:42:43.000000', 'temperatura', 285.0000, 'ºC'),
	(294958, 143, '2015-01-01 00:42:44.000000', 'temperatura', 153.0000, 'ºC'),
	(294959, 143, '2015-01-01 00:42:45.000000', 'temperatura', 1110.0000, 'ºC'),
	(294960, 143, '2015-01-01 00:42:46.000000', 'temperatura', 291.0000, 'ºC'),
	(294961, 143, '2015-01-01 00:42:47.000000', 'temperatura', 528.0000, 'ºC'),
	(294962, 143, '2015-01-01 00:42:48.000000', 'temperatura', 565.0000, 'ºC'),
	(294963, 143, '2015-01-01 00:42:49.000000', 'temperatura', 43.0000, 'ºC'),
	(294964, 143, '2015-01-01 00:42:50.000000', 'temperatura', 921.0000, 'ºC'),
	(294965, 143, '2015-01-01 00:42:51.000000', 'temperatura', 875.0000, 'ºC'),
	(294966, 143, '2015-01-01 00:42:52.000000', 'temperatura', 412.0000, 'ºC'),
	(294967, 143, '2015-01-01 00:42:53.000000', 'temperatura', 637.0000, 'ºC'),
	(294968, 143, '2015-01-01 00:42:54.000000', 'temperatura', 748.0000, 'ºC'),
	(294969, 143, '2015-01-01 00:42:55.000000', 'temperatura', 629.0000, 'ºC'),
	(294970, 143, '2015-01-01 00:42:56.000000', 'temperatura', 904.0000, 'ºC'),
	(294971, 143, '2015-01-01 00:42:57.000000', 'temperatura', 232.0000, 'ºC'),
	(294972, 143, '2015-01-01 00:42:58.000000', 'temperatura', 847.0000, 'ºC'),
	(294973, 143, '2015-01-01 00:42:59.000000', 'temperatura', 1141.0000, 'ºC'),
	(294974, 143, '2015-01-01 00:43:00.000000', 'temperatura', 763.0000, 'ºC'),
	(294975, 143, '2015-01-01 00:43:01.000000', 'temperatura', 395.0000, 'ºC'),
	(294976, 143, '2015-01-01 00:43:02.000000', 'temperatura', 886.0000, 'ºC'),
	(294977, 143, '2015-01-01 00:43:03.000000', 'temperatura', 847.0000, 'ºC'),
	(294978, 143, '2015-01-01 00:43:04.000000', 'temperatura', 374.0000, 'ºC'),
	(294979, 143, '2015-01-01 00:43:05.000000', 'temperatura', 532.0000, 'ºC'),
	(294980, 143, '2015-01-01 00:43:06.000000', 'temperatura', 338.0000, 'ºC'),
	(294981, 143, '2015-01-01 00:43:07.000000', 'temperatura', 95.0000, 'ºC'),
	(294982, 143, '2015-01-01 00:43:08.000000', 'temperatura', 660.0000, 'ºC'),
	(294983, 143, '2015-01-01 00:43:09.000000', 'temperatura', 618.0000, 'ºC'),
	(294984, 143, '2015-01-01 00:43:10.000000', 'temperatura', 1111.0000, 'ºC'),
	(294985, 143, '2015-01-01 00:43:11.000000', 'temperatura', 98.0000, 'ºC'),
	(294986, 143, '2015-01-01 00:43:12.000000', 'temperatura', 760.0000, 'ºC'),
	(294987, 143, '2015-01-01 00:43:13.000000', 'temperatura', 1106.0000, 'ºC'),
	(294988, 143, '2015-01-01 00:43:14.000000', 'temperatura', 849.0000, 'ºC'),
	(294989, 143, '2015-01-01 00:43:15.000000', 'temperatura', 928.0000, 'ºC'),
	(294990, 143, '2015-01-01 00:43:16.000000', 'temperatura', 894.0000, 'ºC'),
	(294991, 143, '2015-01-01 00:43:17.000000', 'temperatura', 487.0000, 'ºC'),
	(294992, 143, '2015-01-01 00:43:18.000000', 'temperatura', 954.0000, 'ºC'),
	(294993, 143, '2015-01-01 00:43:19.000000', 'temperatura', 907.0000, 'ºC'),
	(294994, 143, '2015-01-01 00:43:20.000000', 'temperatura', 477.0000, 'ºC'),
	(294995, 143, '2015-01-01 00:43:21.000000', 'temperatura', 863.0000, 'ºC'),
	(294996, 143, '2015-01-01 00:43:22.000000', 'temperatura', 483.0000, 'ºC'),
	(294997, 143, '2015-01-01 00:43:23.000000', 'temperatura', 1028.0000, 'ºC'),
	(294998, 143, '2015-01-01 00:43:24.000000', 'temperatura', 89.0000, 'ºC'),
	(294999, 143, '2015-01-01 00:43:25.000000', 'temperatura', 964.0000, 'ºC'),
	(295000, 143, '2015-01-01 00:43:26.000000', 'temperatura', 954.0000, 'ºC'),
	(295001, 143, '2015-01-01 00:43:27.000000', 'temperatura', 678.0000, 'ºC'),
	(295002, 143, '2015-01-01 00:43:28.000000', 'temperatura', 527.0000, 'ºC'),
	(295003, 143, '2015-01-01 00:43:29.000000', 'temperatura', 602.0000, 'ºC'),
	(295004, 143, '2015-01-01 00:43:30.000000', 'temperatura', 230.0000, 'ºC'),
	(295005, 143, '2015-01-01 00:43:31.000000', 'temperatura', 546.0000, 'ºC'),
	(295006, 143, '2015-01-01 00:43:32.000000', 'temperatura', 839.0000, 'ºC'),
	(295007, 143, '2015-01-01 00:43:33.000000', 'temperatura', 160.0000, 'ºC'),
	(295008, 143, '2015-01-01 00:43:34.000000', 'temperatura', 680.0000, 'ºC'),
	(295009, 143, '2015-01-01 00:43:35.000000', 'temperatura', 523.0000, 'ºC'),
	(295010, 143, '2015-01-01 00:43:36.000000', 'temperatura', 573.0000, 'ºC'),
	(295011, 143, '2015-01-01 00:43:37.000000', 'temperatura', 98.0000, 'ºC'),
	(295012, 143, '2015-01-01 00:43:38.000000', 'temperatura', 1173.0000, 'ºC'),
	(295013, 143, '2015-01-01 00:43:39.000000', 'temperatura', 771.0000, 'ºC'),
	(295014, 143, '2015-01-01 00:43:40.000000', 'temperatura', 334.0000, 'ºC'),
	(295015, 143, '2015-01-01 00:43:41.000000', 'temperatura', 560.0000, 'ºC'),
	(295016, 143, '2015-01-01 00:43:42.000000', 'temperatura', 597.0000, 'ºC'),
	(295017, 143, '2015-01-01 00:43:43.000000', 'temperatura', 108.0000, 'ºC'),
	(295018, 143, '2015-01-01 00:43:44.000000', 'temperatura', 1147.0000, 'ºC'),
	(295019, 143, '2015-01-01 00:43:45.000000', 'temperatura', 612.0000, 'ºC'),
	(295020, 143, '2015-01-01 00:43:46.000000', 'temperatura', 818.0000, 'ºC'),
	(295021, 143, '2015-01-01 00:43:47.000000', 'temperatura', 1058.0000, 'ºC'),
	(295022, 143, '2015-01-01 00:43:48.000000', 'temperatura', 433.0000, 'ºC'),
	(295023, 143, '2015-01-01 00:43:49.000000', 'temperatura', 192.0000, 'ºC'),
	(295024, 143, '2015-01-01 00:43:50.000000', 'temperatura', 864.0000, 'ºC'),
	(295025, 143, '2015-01-01 00:43:51.000000', 'temperatura', 142.0000, 'ºC'),
	(295026, 143, '2015-01-01 00:43:52.000000', 'temperatura', 520.0000, 'ºC'),
	(295027, 143, '2015-01-01 00:43:53.000000', 'temperatura', 974.0000, 'ºC'),
	(295028, 143, '2015-01-01 00:43:54.000000', 'temperatura', 910.0000, 'ºC'),
	(295029, 143, '2015-01-01 00:43:55.000000', 'temperatura', 431.0000, 'ºC'),
	(295030, 143, '2015-01-01 00:43:56.000000', 'temperatura', 623.0000, 'ºC'),
	(295031, 143, '2015-01-01 00:43:57.000000', 'temperatura', 623.0000, 'ºC'),
	(295032, 143, '2015-01-01 00:43:58.000000', 'temperatura', 45.0000, 'ºC'),
	(295033, 143, '2015-01-01 00:43:59.000000', 'temperatura', 758.0000, 'ºC'),
	(295034, 143, '2015-01-01 00:44:00.000000', 'temperatura', 57.0000, 'ºC'),
	(295035, 143, '2015-01-01 00:44:01.000000', 'temperatura', 408.0000, 'ºC'),
	(295036, 143, '2015-01-01 00:44:02.000000', 'temperatura', 672.0000, 'ºC'),
	(295037, 143, '2015-01-01 00:44:03.000000', 'temperatura', 937.0000, 'ºC'),
	(295038, 143, '2015-01-01 00:44:04.000000', 'temperatura', 268.0000, 'ºC'),
	(295039, 143, '2015-01-01 00:44:05.000000', 'temperatura', 932.0000, 'ºC'),
	(295040, 143, '2015-01-01 00:44:06.000000', 'temperatura', 253.0000, 'ºC'),
	(295041, 143, '2015-01-01 00:44:07.000000', 'temperatura', 871.0000, 'ºC'),
	(295042, 143, '2015-01-01 00:44:08.000000', 'temperatura', 1197.0000, 'ºC'),
	(295043, 143, '2015-01-01 00:44:09.000000', 'temperatura', 972.0000, 'ºC'),
	(295044, 143, '2015-01-01 00:44:10.000000', 'temperatura', 70.0000, 'ºC'),
	(295045, 143, '2015-01-01 00:44:11.000000', 'temperatura', 1035.0000, 'ºC'),
	(295046, 143, '2015-01-01 00:44:12.000000', 'temperatura', 164.0000, 'ºC'),
	(295047, 143, '2015-01-01 00:44:13.000000', 'temperatura', 114.0000, 'ºC'),
	(295048, 143, '2015-01-01 00:44:14.000000', 'temperatura', 82.0000, 'ºC'),
	(295049, 143, '2015-01-01 00:44:15.000000', 'temperatura', 68.0000, 'ºC'),
	(295050, 143, '2015-01-01 00:44:16.000000', 'temperatura', 92.0000, 'ºC'),
	(295051, 143, '2015-01-01 00:44:17.000000', 'temperatura', 259.0000, 'ºC'),
	(295052, 143, '2015-01-01 00:44:18.000000', 'temperatura', 1019.0000, 'ºC'),
	(295053, 143, '2015-01-01 00:44:19.000000', 'temperatura', 717.0000, 'ºC'),
	(295054, 143, '2015-01-01 00:44:20.000000', 'temperatura', 529.0000, 'ºC'),
	(295055, 143, '2015-01-01 00:44:21.000000', 'temperatura', 496.0000, 'ºC'),
	(295056, 143, '2015-01-01 00:44:22.000000', 'temperatura', 893.0000, 'ºC'),
	(295057, 143, '2015-01-01 00:44:23.000000', 'temperatura', 578.0000, 'ºC'),
	(295058, 143, '2015-01-01 00:44:24.000000', 'temperatura', 209.0000, 'ºC'),
	(295059, 143, '2015-01-01 00:44:25.000000', 'temperatura', 513.0000, 'ºC'),
	(295060, 143, '2015-01-01 00:44:26.000000', 'temperatura', 740.0000, 'ºC'),
	(295061, 143, '2015-01-01 00:44:27.000000', 'temperatura', 960.0000, 'ºC'),
	(295062, 143, '2015-01-01 00:44:28.000000', 'temperatura', 182.0000, 'ºC'),
	(295063, 143, '2015-01-01 00:44:29.000000', 'temperatura', 430.0000, 'ºC'),
	(295064, 143, '2015-01-01 00:44:30.000000', 'temperatura', 406.0000, 'ºC'),
	(295065, 143, '2015-01-01 00:44:31.000000', 'temperatura', 740.0000, 'ºC'),
	(295066, 143, '2015-01-01 00:44:32.000000', 'temperatura', 82.0000, 'ºC'),
	(295067, 143, '2015-01-01 00:44:33.000000', 'temperatura', 591.0000, 'ºC'),
	(295068, 143, '2015-01-01 00:44:34.000000', 'temperatura', 307.0000, 'ºC'),
	(295069, 143, '2015-01-01 00:44:35.000000', 'temperatura', 966.0000, 'ºC'),
	(295070, 143, '2015-01-01 00:44:36.000000', 'temperatura', 309.0000, 'ºC'),
	(295071, 143, '2015-01-01 00:44:37.000000', 'temperatura', 1045.0000, 'ºC'),
	(295072, 143, '2015-01-01 00:44:38.000000', 'temperatura', 700.0000, 'ºC'),
	(295073, 143, '2015-01-01 00:44:39.000000', 'temperatura', 368.0000, 'ºC'),
	(295074, 143, '2015-01-01 00:44:40.000000', 'temperatura', 937.0000, 'ºC'),
	(295075, 143, '2015-01-01 00:44:41.000000', 'temperatura', 1181.0000, 'ºC'),
	(295076, 143, '2015-01-01 00:44:42.000000', 'temperatura', 695.0000, 'ºC'),
	(295077, 143, '2015-01-01 00:44:43.000000', 'temperatura', 1133.0000, 'ºC'),
	(295078, 143, '2015-01-01 00:44:44.000000', 'temperatura', 1179.0000, 'ºC'),
	(295079, 143, '2015-01-01 00:44:45.000000', 'temperatura', 98.0000, 'ºC'),
	(295080, 143, '2015-01-01 00:44:46.000000', 'temperatura', 555.0000, 'ºC'),
	(295081, 143, '2015-01-01 00:44:47.000000', 'temperatura', 79.0000, 'ºC'),
	(295082, 143, '2015-01-01 00:44:48.000000', 'temperatura', 1133.0000, 'ºC'),
	(295083, 143, '2015-01-01 00:44:49.000000', 'temperatura', 625.0000, 'ºC'),
	(295084, 143, '2015-01-01 00:44:50.000000', 'temperatura', 929.0000, 'ºC'),
	(295085, 143, '2015-01-01 00:44:51.000000', 'temperatura', 371.0000, 'ºC'),
	(295086, 143, '2015-01-01 00:44:52.000000', 'temperatura', 266.0000, 'ºC'),
	(295087, 143, '2015-01-01 00:44:53.000000', 'temperatura', 218.0000, 'ºC'),
	(295088, 143, '2015-01-01 00:44:54.000000', 'temperatura', 294.0000, 'ºC'),
	(295089, 143, '2015-01-01 00:44:55.000000', 'temperatura', 817.0000, 'ºC'),
	(295090, 143, '2015-01-01 00:44:56.000000', 'temperatura', 804.0000, 'ºC'),
	(295091, 143, '2015-01-01 00:44:57.000000', 'temperatura', 369.0000, 'ºC'),
	(295092, 143, '2015-01-01 00:44:58.000000', 'temperatura', 635.0000, 'ºC'),
	(295093, 143, '2015-01-01 00:44:59.000000', 'temperatura', 866.0000, 'ºC'),
	(295094, 143, '2015-01-01 00:45:00.000000', 'temperatura', 25.0000, 'ºC'),
	(295095, 143, '2015-01-01 00:45:01.000000', 'temperatura', 1130.0000, 'ºC'),
	(295096, 143, '2015-01-01 00:45:02.000000', 'temperatura', 774.0000, 'ºC'),
	(295097, 143, '2015-01-01 00:45:03.000000', 'temperatura', 482.0000, 'ºC'),
	(295098, 143, '2015-01-01 00:45:04.000000', 'temperatura', 89.0000, 'ºC'),
	(295099, 143, '2015-01-01 00:45:05.000000', 'temperatura', 198.0000, 'ºC'),
	(295100, 143, '2015-01-01 00:45:06.000000', 'temperatura', 725.0000, 'ºC'),
	(295101, 143, '2015-01-01 00:45:07.000000', 'temperatura', 629.0000, 'ºC'),
	(295102, 143, '2015-01-01 00:45:08.000000', 'temperatura', 972.0000, 'ºC'),
	(295103, 143, '2015-01-01 00:45:09.000000', 'temperatura', 574.0000, 'ºC'),
	(295104, 143, '2015-01-01 00:45:10.000000', 'temperatura', 1153.0000, 'ºC'),
	(295105, 143, '2015-01-01 00:45:11.000000', 'temperatura', 445.0000, 'ºC'),
	(295106, 143, '2015-01-01 00:45:12.000000', 'temperatura', 1168.0000, 'ºC'),
	(295107, 143, '2015-01-01 00:45:13.000000', 'temperatura', 903.0000, 'ºC'),
	(295108, 143, '2015-01-01 00:45:14.000000', 'temperatura', 1012.0000, 'ºC'),
	(295109, 143, '2015-01-01 00:45:15.000000', 'temperatura', 1151.0000, 'ºC'),
	(295110, 143, '2015-01-01 00:45:16.000000', 'temperatura', 320.0000, 'ºC'),
	(295111, 143, '2015-01-01 00:45:17.000000', 'temperatura', 548.0000, 'ºC'),
	(295112, 143, '2015-01-01 00:45:18.000000', 'temperatura', 579.0000, 'ºC'),
	(295113, 143, '2015-01-01 00:45:19.000000', 'temperatura', 54.0000, 'ºC'),
	(295114, 143, '2015-01-01 00:45:20.000000', 'temperatura', 934.0000, 'ºC'),
	(295115, 143, '2015-01-01 00:45:21.000000', 'temperatura', 905.0000, 'ºC'),
	(295116, 143, '2015-01-01 00:45:22.000000', 'temperatura', 527.0000, 'ºC'),
	(295117, 143, '2015-01-01 00:45:23.000000', 'temperatura', 1119.0000, 'ºC'),
	(295118, 143, '2015-01-01 00:45:24.000000', 'temperatura', 416.0000, 'ºC'),
	(295119, 143, '2015-01-01 00:45:25.000000', 'temperatura', 1124.0000, 'ºC'),
	(295120, 143, '2015-01-01 00:45:26.000000', 'temperatura', 770.0000, 'ºC'),
	(295121, 143, '2015-01-01 00:45:27.000000', 'temperatura', 481.0000, 'ºC'),
	(295122, 143, '2015-01-01 00:45:28.000000', 'temperatura', 96.0000, 'ºC'),
	(295123, 143, '2015-01-01 00:45:29.000000', 'temperatura', 239.0000, 'ºC'),
	(295124, 143, '2015-01-01 00:45:30.000000', 'temperatura', 904.0000, 'ºC'),
	(295125, 143, '2015-01-01 00:45:31.000000', 'temperatura', 204.0000, 'ºC'),
	(295126, 143, '2015-01-01 00:45:32.000000', 'temperatura', 711.0000, 'ºC'),
	(295127, 143, '2015-01-01 00:45:33.000000', 'temperatura', 542.0000, 'ºC'),
	(295128, 143, '2015-01-01 00:45:34.000000', 'temperatura', 578.0000, 'ºC'),
	(295129, 143, '2015-01-01 00:45:35.000000', 'temperatura', 63.0000, 'ºC'),
	(295130, 143, '2015-01-01 00:45:36.000000', 'temperatura', 983.0000, 'ºC'),
	(295131, 143, '2015-01-01 00:45:37.000000', 'temperatura', 1127.0000, 'ºC'),
	(295132, 143, '2015-01-01 00:45:38.000000', 'temperatura', 287.0000, 'ºC'),
	(295133, 143, '2015-01-01 00:45:39.000000', 'temperatura', 455.0000, 'ºC'),
	(295134, 143, '2015-01-01 00:45:40.000000', 'temperatura', 214.0000, 'ºC'),
	(295135, 143, '2015-01-01 00:45:41.000000', 'temperatura', 906.0000, 'ºC'),
	(295136, 143, '2015-01-01 00:45:42.000000', 'temperatura', 286.0000, 'ºC'),
	(295137, 143, '2015-01-01 00:45:43.000000', 'temperatura', 1113.0000, 'ºC'),
	(295138, 143, '2015-01-01 00:45:44.000000', 'temperatura', 1108.0000, 'ºC'),
	(295139, 143, '2015-01-01 00:45:45.000000', 'temperatura', 1003.0000, 'ºC'),
	(295140, 143, '2015-01-01 00:45:46.000000', 'temperatura', 489.0000, 'ºC'),
	(295141, 143, '2015-01-01 00:45:47.000000', 'temperatura', 640.0000, 'ºC'),
	(295142, 143, '2015-01-01 00:45:48.000000', 'temperatura', 530.0000, 'ºC'),
	(295143, 143, '2015-01-01 00:45:49.000000', 'temperatura', 733.0000, 'ºC'),
	(295144, 143, '2015-01-01 00:45:50.000000', 'temperatura', 877.0000, 'ºC'),
	(295145, 143, '2015-01-01 00:45:51.000000', 'temperatura', 984.0000, 'ºC'),
	(295146, 143, '2015-01-01 00:45:52.000000', 'temperatura', 1090.0000, 'ºC'),
	(295147, 143, '2015-01-01 00:45:53.000000', 'temperatura', 97.0000, 'ºC'),
	(295148, 143, '2015-01-01 00:45:54.000000', 'temperatura', 815.0000, 'ºC'),
	(295149, 143, '2015-01-01 00:45:55.000000', 'temperatura', 187.0000, 'ºC'),
	(295150, 143, '2015-01-01 00:45:56.000000', 'temperatura', 891.0000, 'ºC'),
	(295151, 143, '2015-01-01 00:45:57.000000', 'temperatura', 294.0000, 'ºC'),
	(295152, 143, '2015-01-01 00:45:58.000000', 'temperatura', 1197.0000, 'ºC'),
	(295153, 143, '2015-01-01 00:45:59.000000', 'temperatura', 302.0000, 'ºC'),
	(295154, 143, '2015-01-01 00:46:00.000000', 'temperatura', 319.0000, 'ºC'),
	(295155, 143, '2015-01-01 00:46:01.000000', 'temperatura', 689.0000, 'ºC'),
	(295156, 143, '2015-01-01 00:46:02.000000', 'temperatura', 90.0000, 'ºC'),
	(295157, 143, '2015-01-01 00:46:03.000000', 'temperatura', 784.0000, 'ºC'),
	(295158, 143, '2015-01-01 00:46:04.000000', 'temperatura', 50.0000, 'ºC'),
	(295159, 143, '2015-01-01 00:46:05.000000', 'temperatura', 297.0000, 'ºC'),
	(295160, 143, '2015-01-01 00:46:06.000000', 'temperatura', 137.0000, 'ºC'),
	(295161, 143, '2015-01-01 00:46:07.000000', 'temperatura', 996.0000, 'ºC'),
	(295162, 143, '2015-01-01 00:46:08.000000', 'temperatura', 968.0000, 'ºC'),
	(295163, 143, '2015-01-01 00:46:09.000000', 'temperatura', 654.0000, 'ºC'),
	(295164, 143, '2015-01-01 00:46:10.000000', 'temperatura', 367.0000, 'ºC'),
	(295165, 143, '2015-01-01 00:46:11.000000', 'temperatura', 1074.0000, 'ºC'),
	(295166, 143, '2015-01-01 00:46:12.000000', 'temperatura', 667.0000, 'ºC'),
	(295167, 143, '2015-01-01 00:46:13.000000', 'temperatura', 117.0000, 'ºC'),
	(295168, 143, '2015-01-01 00:46:14.000000', 'temperatura', 981.0000, 'ºC'),
	(295169, 143, '2015-01-01 00:46:15.000000', 'temperatura', 955.0000, 'ºC'),
	(295170, 143, '2015-01-01 00:46:16.000000', 'temperatura', 635.0000, 'ºC'),
	(295171, 143, '2015-01-01 00:46:17.000000', 'temperatura', 309.0000, 'ºC'),
	(295172, 143, '2015-01-01 00:46:18.000000', 'temperatura', 839.0000, 'ºC'),
	(295173, 143, '2015-01-01 00:46:19.000000', 'temperatura', 872.0000, 'ºC'),
	(295174, 143, '2015-01-01 00:46:20.000000', 'temperatura', 641.0000, 'ºC'),
	(295175, 143, '2015-01-01 00:46:21.000000', 'temperatura', 589.0000, 'ºC'),
	(295176, 143, '2015-01-01 00:46:22.000000', 'temperatura', 1023.0000, 'ºC'),
	(295177, 143, '2015-01-01 00:46:23.000000', 'temperatura', 949.0000, 'ºC'),
	(295178, 143, '2015-01-01 00:46:24.000000', 'temperatura', 474.0000, 'ºC'),
	(295179, 143, '2015-01-01 00:46:25.000000', 'temperatura', 726.0000, 'ºC'),
	(295180, 143, '2015-01-01 00:46:26.000000', 'temperatura', 1006.0000, 'ºC'),
	(295181, 143, '2015-01-01 00:46:27.000000', 'temperatura', 455.0000, 'ºC'),
	(295182, 143, '2015-01-01 00:46:28.000000', 'temperatura', 455.0000, 'ºC'),
	(295183, 143, '2015-01-01 00:46:29.000000', 'temperatura', 913.0000, 'ºC'),
	(295184, 143, '2015-01-01 00:46:30.000000', 'temperatura', 801.0000, 'ºC'),
	(295185, 143, '2015-01-01 00:46:31.000000', 'temperatura', 65.0000, 'ºC'),
	(295186, 143, '2015-01-01 00:46:32.000000', 'temperatura', 324.0000, 'ºC'),
	(295187, 143, '2015-01-01 00:46:33.000000', 'temperatura', 223.0000, 'ºC'),
	(295188, 143, '2015-01-01 00:46:34.000000', 'temperatura', 145.0000, 'ºC'),
	(295189, 143, '2015-01-01 00:46:35.000000', 'temperatura', 54.0000, 'ºC'),
	(295190, 143, '2015-01-01 00:46:36.000000', 'temperatura', 1039.0000, 'ºC'),
	(295191, 143, '2015-01-01 00:46:37.000000', 'temperatura', 232.0000, 'ºC'),
	(295192, 143, '2015-01-01 00:46:38.000000', 'temperatura', 445.0000, 'ºC'),
	(295193, 143, '2015-01-01 00:46:39.000000', 'temperatura', 329.0000, 'ºC'),
	(295194, 143, '2015-01-01 00:46:40.000000', 'temperatura', 309.0000, 'ºC'),
	(295195, 143, '2015-01-01 00:46:41.000000', 'temperatura', 558.0000, 'ºC'),
	(295196, 143, '2015-01-01 00:46:42.000000', 'temperatura', 666.0000, 'ºC'),
	(295197, 143, '2015-01-01 00:46:43.000000', 'temperatura', 457.0000, 'ºC'),
	(295198, 143, '2015-01-01 00:46:44.000000', 'temperatura', 288.0000, 'ºC'),
	(295199, 143, '2015-01-01 00:46:45.000000', 'temperatura', 70.0000, 'ºC'),
	(295200, 143, '2015-01-01 00:46:46.000000', 'temperatura', 686.0000, 'ºC'),
	(295201, 143, '2015-01-01 00:46:47.000000', 'temperatura', 820.0000, 'ºC'),
	(295202, 143, '2015-01-01 00:46:48.000000', 'temperatura', 842.0000, 'ºC'),
	(295203, 143, '2015-01-01 00:46:49.000000', 'temperatura', 552.0000, 'ºC'),
	(295204, 143, '2015-01-01 00:46:50.000000', 'temperatura', 233.0000, 'ºC'),
	(295205, 143, '2015-01-01 00:46:51.000000', 'temperatura', 710.0000, 'ºC'),
	(295206, 143, '2015-01-01 00:46:52.000000', 'temperatura', 453.0000, 'ºC'),
	(295207, 143, '2015-01-01 00:46:53.000000', 'temperatura', 134.0000, 'ºC'),
	(295208, 143, '2015-01-01 00:46:54.000000', 'temperatura', 511.0000, 'ºC'),
	(295209, 143, '2015-01-01 00:46:55.000000', 'temperatura', 956.0000, 'ºC'),
	(295210, 143, '2015-01-01 00:46:56.000000', 'temperatura', 845.0000, 'ºC'),
	(295211, 143, '2015-01-01 00:46:57.000000', 'temperatura', 157.0000, 'ºC'),
	(295212, 143, '2015-01-01 00:46:58.000000', 'temperatura', 650.0000, 'ºC'),
	(295213, 143, '2015-01-01 00:46:59.000000', 'temperatura', 381.0000, 'ºC'),
	(295214, 143, '2015-01-01 00:47:00.000000', 'temperatura', 1153.0000, 'ºC'),
	(295215, 143, '2015-01-01 00:47:01.000000', 'temperatura', 1024.0000, 'ºC'),
	(295216, 143, '2015-01-01 00:47:02.000000', 'temperatura', 463.0000, 'ºC'),
	(295217, 143, '2015-01-01 00:47:03.000000', 'temperatura', 442.0000, 'ºC'),
	(295218, 143, '2015-01-01 00:47:04.000000', 'temperatura', 824.0000, 'ºC'),
	(295219, 143, '2015-01-01 00:47:05.000000', 'temperatura', 392.0000, 'ºC'),
	(295220, 143, '2015-01-01 00:47:06.000000', 'temperatura', 691.0000, 'ºC'),
	(295221, 143, '2015-01-01 00:47:07.000000', 'temperatura', 1077.0000, 'ºC'),
	(295222, 143, '2015-01-01 00:47:08.000000', 'temperatura', 914.0000, 'ºC'),
	(295223, 143, '2015-01-01 00:47:09.000000', 'temperatura', 140.0000, 'ºC'),
	(295224, 143, '2015-01-01 00:47:10.000000', 'temperatura', 359.0000, 'ºC'),
	(295225, 143, '2015-01-01 00:47:11.000000', 'temperatura', 174.0000, 'ºC'),
	(295226, 143, '2015-01-01 00:47:12.000000', 'temperatura', 993.0000, 'ºC'),
	(295227, 143, '2015-01-01 00:47:13.000000', 'temperatura', 846.0000, 'ºC'),
	(295228, 143, '2015-01-01 00:47:14.000000', 'temperatura', 51.0000, 'ºC'),
	(295229, 143, '2015-01-01 00:47:15.000000', 'temperatura', 117.0000, 'ºC'),
	(295230, 143, '2015-01-01 00:47:16.000000', 'temperatura', 435.0000, 'ºC'),
	(295231, 143, '2015-01-01 00:47:17.000000', 'temperatura', 621.0000, 'ºC'),
	(295232, 143, '2015-01-01 00:47:18.000000', 'temperatura', 600.0000, 'ºC'),
	(295233, 143, '2015-01-01 00:47:19.000000', 'temperatura', 1139.0000, 'ºC'),
	(295234, 143, '2015-01-01 00:47:20.000000', 'temperatura', 295.0000, 'ºC'),
	(295235, 143, '2015-01-01 00:47:21.000000', 'temperatura', 459.0000, 'ºC'),
	(295236, 143, '2015-01-01 00:47:22.000000', 'temperatura', 211.0000, 'ºC'),
	(295237, 143, '2015-01-01 00:47:23.000000', 'temperatura', 878.0000, 'ºC'),
	(295238, 143, '2015-01-01 00:47:24.000000', 'temperatura', 158.0000, 'ºC'),
	(295239, 143, '2015-01-01 00:47:25.000000', 'temperatura', 557.0000, 'ºC'),
	(295240, 143, '2015-01-01 00:47:26.000000', 'temperatura', 1110.0000, 'ºC'),
	(295241, 143, '2015-01-01 00:47:27.000000', 'temperatura', 280.0000, 'ºC'),
	(295242, 143, '2015-01-01 00:47:28.000000', 'temperatura', 470.0000, 'ºC'),
	(295243, 143, '2015-01-01 00:47:29.000000', 'temperatura', 312.0000, 'ºC'),
	(295244, 143, '2015-01-01 00:47:30.000000', 'temperatura', 152.0000, 'ºC'),
	(295245, 143, '2015-01-01 00:47:31.000000', 'temperatura', 1021.0000, 'ºC'),
	(295246, 143, '2015-01-01 00:47:32.000000', 'temperatura', 1051.0000, 'ºC'),
	(295247, 143, '2015-01-01 00:47:33.000000', 'temperatura', 991.0000, 'ºC'),
	(295248, 143, '2015-01-01 00:47:34.000000', 'temperatura', 604.0000, 'ºC'),
	(295249, 143, '2015-01-01 00:47:35.000000', 'temperatura', 46.0000, 'ºC'),
	(295250, 143, '2015-01-01 00:47:36.000000', 'temperatura', 819.0000, 'ºC'),
	(295251, 143, '2015-01-01 00:47:37.000000', 'temperatura', 359.0000, 'ºC'),
	(295252, 143, '2015-01-01 00:47:38.000000', 'temperatura', 537.0000, 'ºC'),
	(295253, 143, '2015-01-01 00:47:39.000000', 'temperatura', 408.0000, 'ºC'),
	(295254, 143, '2015-01-01 00:47:40.000000', 'temperatura', 432.0000, 'ºC'),
	(295255, 143, '2015-01-01 00:47:41.000000', 'temperatura', 934.0000, 'ºC'),
	(295256, 143, '2015-01-01 00:47:42.000000', 'temperatura', 976.0000, 'ºC'),
	(295257, 143, '2015-01-01 00:47:43.000000', 'temperatura', 879.0000, 'ºC'),
	(295258, 143, '2015-01-01 00:47:44.000000', 'temperatura', 268.0000, 'ºC'),
	(295259, 143, '2015-01-01 00:47:45.000000', 'temperatura', 1103.0000, 'ºC'),
	(295260, 143, '2015-01-01 00:47:46.000000', 'temperatura', 1109.0000, 'ºC'),
	(295261, 143, '2015-01-01 00:47:47.000000', 'temperatura', 1039.0000, 'ºC'),
	(295262, 143, '2015-01-01 00:47:48.000000', 'temperatura', 670.0000, 'ºC'),
	(295263, 143, '2015-01-01 00:47:49.000000', 'temperatura', 231.0000, 'ºC'),
	(295264, 143, '2015-01-01 00:47:50.000000', 'temperatura', 345.0000, 'ºC'),
	(295265, 143, '2015-01-01 00:47:51.000000', 'temperatura', 1034.0000, 'ºC'),
	(295266, 143, '2015-01-01 00:47:52.000000', 'temperatura', 535.0000, 'ºC'),
	(295267, 143, '2015-01-01 00:47:53.000000', 'temperatura', 775.0000, 'ºC'),
	(295268, 143, '2015-01-01 00:47:54.000000', 'temperatura', 1069.0000, 'ºC'),
	(295269, 143, '2015-01-01 00:47:55.000000', 'temperatura', 622.0000, 'ºC'),
	(295270, 143, '2015-01-01 00:47:56.000000', 'temperatura', 1105.0000, 'ºC'),
	(295271, 143, '2015-01-01 00:47:57.000000', 'temperatura', 56.0000, 'ºC'),
	(295272, 143, '2015-01-01 00:47:58.000000', 'temperatura', 568.0000, 'ºC'),
	(295273, 143, '2015-01-01 00:47:59.000000', 'temperatura', 273.0000, 'ºC'),
	(295274, 143, '2015-01-01 00:48:00.000000', 'temperatura', 861.0000, 'ºC'),
	(295275, 143, '2015-01-01 00:48:01.000000', 'temperatura', 1085.0000, 'ºC'),
	(295276, 143, '2015-01-01 00:48:02.000000', 'temperatura', 445.0000, 'ºC'),
	(295277, 143, '2015-01-01 00:48:03.000000', 'temperatura', 170.0000, 'ºC'),
	(295278, 143, '2015-01-01 00:48:04.000000', 'temperatura', 717.0000, 'ºC'),
	(295279, 143, '2015-01-01 00:48:05.000000', 'temperatura', 674.0000, 'ºC'),
	(295280, 143, '2015-01-01 00:48:06.000000', 'temperatura', 21.0000, 'ºC'),
	(295281, 143, '2015-01-01 00:48:07.000000', 'temperatura', 481.0000, 'ºC'),
	(295282, 143, '2015-01-01 00:48:08.000000', 'temperatura', 1142.0000, 'ºC'),
	(295283, 143, '2015-01-01 00:48:09.000000', 'temperatura', 670.0000, 'ºC'),
	(295284, 143, '2015-01-01 00:48:10.000000', 'temperatura', 1125.0000, 'ºC'),
	(295285, 143, '2015-01-01 00:48:11.000000', 'temperatura', 15.0000, 'ºC'),
	(295286, 143, '2015-01-01 00:48:12.000000', 'temperatura', 301.0000, 'ºC'),
	(295287, 143, '2015-01-01 00:48:13.000000', 'temperatura', 262.0000, 'ºC'),
	(295288, 143, '2015-01-01 00:48:14.000000', 'temperatura', 406.0000, 'ºC'),
	(295289, 143, '2015-01-01 00:48:15.000000', 'temperatura', 44.0000, 'ºC'),
	(295290, 143, '2015-01-01 00:48:16.000000', 'temperatura', 201.0000, 'ºC'),
	(295291, 143, '2015-01-01 00:48:17.000000', 'temperatura', 876.0000, 'ºC'),
	(295292, 143, '2015-01-01 00:48:18.000000', 'temperatura', 177.0000, 'ºC'),
	(295293, 143, '2015-01-01 00:48:19.000000', 'temperatura', 656.0000, 'ºC'),
	(295294, 143, '2015-01-01 00:48:20.000000', 'temperatura', 351.0000, 'ºC'),
	(295295, 143, '2015-01-01 00:48:21.000000', 'temperatura', 988.0000, 'ºC'),
	(295296, 143, '2015-01-01 00:48:22.000000', 'temperatura', 286.0000, 'ºC'),
	(295297, 143, '2015-01-01 00:48:23.000000', 'temperatura', 869.0000, 'ºC'),
	(295298, 143, '2015-01-01 00:48:24.000000', 'temperatura', 1087.0000, 'ºC'),
	(295299, 143, '2015-01-01 00:48:25.000000', 'temperatura', 429.0000, 'ºC'),
	(295300, 143, '2015-01-01 00:48:26.000000', 'temperatura', 82.0000, 'ºC'),
	(295301, 143, '2015-01-01 00:48:27.000000', 'temperatura', 327.0000, 'ºC'),
	(295302, 143, '2015-01-01 00:48:28.000000', 'temperatura', 187.0000, 'ºC'),
	(295303, 143, '2015-01-01 00:48:29.000000', 'temperatura', 1154.0000, 'ºC'),
	(295304, 143, '2015-01-01 00:48:30.000000', 'temperatura', 412.0000, 'ºC'),
	(295305, 143, '2015-01-01 00:48:31.000000', 'temperatura', 995.0000, 'ºC'),
	(295306, 143, '2015-01-01 00:48:32.000000', 'temperatura', 143.0000, 'ºC'),
	(295307, 143, '2015-01-01 00:48:33.000000', 'temperatura', 128.0000, 'ºC'),
	(295308, 143, '2015-01-01 00:48:34.000000', 'temperatura', 214.0000, 'ºC'),
	(295309, 143, '2015-01-01 00:48:35.000000', 'temperatura', 684.0000, 'ºC'),
	(295310, 143, '2015-01-01 00:48:36.000000', 'temperatura', 380.0000, 'ºC'),
	(295311, 143, '2015-01-01 00:48:37.000000', 'temperatura', 1047.0000, 'ºC'),
	(295312, 143, '2015-01-01 00:48:38.000000', 'temperatura', 495.0000, 'ºC'),
	(295313, 143, '2015-01-01 00:48:39.000000', 'temperatura', 537.0000, 'ºC'),
	(295314, 143, '2015-01-01 00:48:40.000000', 'temperatura', 1199.0000, 'ºC'),
	(295315, 143, '2015-01-01 00:48:41.000000', 'temperatura', 787.0000, 'ºC'),
	(295316, 143, '2015-01-01 00:48:42.000000', 'temperatura', 336.0000, 'ºC'),
	(295317, 143, '2015-01-01 00:48:43.000000', 'temperatura', 521.0000, 'ºC'),
	(295318, 143, '2015-01-01 00:48:44.000000', 'temperatura', 399.0000, 'ºC'),
	(295319, 143, '2015-01-01 00:48:45.000000', 'temperatura', 429.0000, 'ºC'),
	(295320, 143, '2015-01-01 00:48:46.000000', 'temperatura', 952.0000, 'ºC'),
	(295321, 143, '2015-01-01 00:48:47.000000', 'temperatura', 1072.0000, 'ºC'),
	(295322, 143, '2015-01-01 00:48:48.000000', 'temperatura', 103.0000, 'ºC'),
	(295323, 143, '2015-01-01 00:48:49.000000', 'temperatura', 899.0000, 'ºC'),
	(295324, 143, '2015-01-01 00:48:50.000000', 'temperatura', 588.0000, 'ºC'),
	(295325, 143, '2015-01-01 00:48:51.000000', 'temperatura', 243.0000, 'ºC'),
	(295326, 143, '2015-01-01 00:48:52.000000', 'temperatura', 651.0000, 'ºC'),
	(295327, 143, '2015-01-01 00:48:53.000000', 'temperatura', 126.0000, 'ºC'),
	(295328, 143, '2015-01-01 00:48:54.000000', 'temperatura', 1076.0000, 'ºC'),
	(295329, 143, '2015-01-01 00:48:55.000000', 'temperatura', 204.0000, 'ºC'),
	(295330, 143, '2015-01-01 00:48:56.000000', 'temperatura', 194.0000, 'ºC'),
	(295331, 143, '2015-01-01 00:48:57.000000', 'temperatura', 359.0000, 'ºC'),
	(295332, 143, '2015-01-01 00:48:58.000000', 'temperatura', 11.0000, 'ºC'),
	(295333, 143, '2015-01-01 00:48:59.000000', 'temperatura', 181.0000, 'ºC'),
	(295334, 143, '2015-01-01 00:49:00.000000', 'temperatura', 870.0000, 'ºC'),
	(295335, 143, '2015-01-01 00:49:01.000000', 'temperatura', 209.0000, 'ºC'),
	(295336, 143, '2015-01-01 00:49:02.000000', 'temperatura', 837.0000, 'ºC'),
	(295337, 143, '2015-01-01 00:49:03.000000', 'temperatura', 1157.0000, 'ºC'),
	(295338, 143, '2015-01-01 00:49:04.000000', 'temperatura', 877.0000, 'ºC'),
	(295339, 143, '2015-01-01 00:49:05.000000', 'temperatura', 912.0000, 'ºC'),
	(295340, 143, '2015-01-01 00:49:06.000000', 'temperatura', 729.0000, 'ºC'),
	(295341, 143, '2015-01-01 00:49:07.000000', 'temperatura', 908.0000, 'ºC'),
	(295342, 143, '2015-01-01 00:49:08.000000', 'temperatura', 1156.0000, 'ºC'),
	(295343, 143, '2015-01-01 00:49:09.000000', 'temperatura', 655.0000, 'ºC'),
	(295344, 143, '2015-01-01 00:49:10.000000', 'temperatura', 1009.0000, 'ºC'),
	(295345, 143, '2015-01-01 00:49:11.000000', 'temperatura', 678.0000, 'ºC'),
	(295346, 143, '2015-01-01 00:49:12.000000', 'temperatura', 366.0000, 'ºC'),
	(295347, 143, '2015-01-01 00:49:13.000000', 'temperatura', 997.0000, 'ºC'),
	(295348, 143, '2015-01-01 00:49:14.000000', 'temperatura', 288.0000, 'ºC'),
	(295349, 143, '2015-01-01 00:49:15.000000', 'temperatura', 850.0000, 'ºC'),
	(295350, 143, '2015-01-01 00:49:16.000000', 'temperatura', 986.0000, 'ºC'),
	(295351, 143, '2015-01-01 00:49:17.000000', 'temperatura', 1182.0000, 'ºC'),
	(295352, 143, '2015-01-01 00:49:18.000000', 'temperatura', 550.0000, 'ºC'),
	(295353, 143, '2015-01-01 00:49:19.000000', 'temperatura', 407.0000, 'ºC'),
	(295354, 143, '2015-01-01 00:49:20.000000', 'temperatura', 385.0000, 'ºC'),
	(295355, 143, '2015-01-01 00:49:21.000000', 'temperatura', 702.0000, 'ºC'),
	(295356, 143, '2015-01-01 00:49:22.000000', 'temperatura', 1159.0000, 'ºC'),
	(295357, 143, '2015-01-01 00:49:23.000000', 'temperatura', 88.0000, 'ºC'),
	(295358, 143, '2015-01-01 00:49:24.000000', 'temperatura', 563.0000, 'ºC'),
	(295359, 143, '2015-01-01 00:49:25.000000', 'temperatura', 153.0000, 'ºC'),
	(295360, 143, '2015-01-01 00:49:26.000000', 'temperatura', 278.0000, 'ºC'),
	(295361, 143, '2015-01-01 00:49:27.000000', 'temperatura', 929.0000, 'ºC'),
	(295362, 143, '2015-01-01 00:49:28.000000', 'temperatura', 211.0000, 'ºC'),
	(295363, 143, '2015-01-01 00:49:29.000000', 'temperatura', 669.0000, 'ºC'),
	(295364, 143, '2015-01-01 00:49:30.000000', 'temperatura', 312.0000, 'ºC'),
	(295365, 143, '2015-01-01 00:49:31.000000', 'temperatura', 754.0000, 'ºC'),
	(295366, 143, '2015-01-01 00:49:32.000000', 'temperatura', 434.0000, 'ºC'),
	(295367, 143, '2015-01-01 00:49:33.000000', 'temperatura', 1109.0000, 'ºC'),
	(295368, 143, '2015-01-01 00:49:34.000000', 'temperatura', 643.0000, 'ºC'),
	(295369, 143, '2015-01-01 00:49:35.000000', 'temperatura', 1090.0000, 'ºC'),
	(295370, 143, '2015-01-01 00:49:36.000000', 'temperatura', 1121.0000, 'ºC'),
	(295371, 143, '2015-01-01 00:49:37.000000', 'temperatura', 1135.0000, 'ºC'),
	(295372, 143, '2015-01-01 00:49:38.000000', 'temperatura', 1112.0000, 'ºC'),
	(295373, 143, '2015-01-01 00:49:39.000000', 'temperatura', 956.0000, 'ºC'),
	(295374, 143, '2015-01-01 00:49:40.000000', 'temperatura', 246.0000, 'ºC'),
	(295375, 143, '2015-01-01 00:49:41.000000', 'temperatura', 761.0000, 'ºC'),
	(295376, 143, '2015-01-01 00:49:42.000000', 'temperatura', 666.0000, 'ºC'),
	(295377, 143, '2015-01-01 00:49:43.000000', 'temperatura', 1050.0000, 'ºC'),
	(295378, 143, '2015-01-01 00:49:44.000000', 'temperatura', 853.0000, 'ºC'),
	(295379, 143, '2015-01-01 00:49:45.000000', 'temperatura', 1114.0000, 'ºC'),
	(295380, 143, '2015-01-01 00:49:46.000000', 'temperatura', 613.0000, 'ºC'),
	(295381, 143, '2015-01-01 00:49:47.000000', 'temperatura', 921.0000, 'ºC'),
	(295382, 143, '2015-01-01 00:49:48.000000', 'temperatura', 368.0000, 'ºC'),
	(295383, 143, '2015-01-01 00:49:49.000000', 'temperatura', 277.0000, 'ºC'),
	(295384, 143, '2015-01-01 00:49:50.000000', 'temperatura', 281.0000, 'ºC'),
	(295385, 143, '2015-01-01 00:49:51.000000', 'temperatura', 575.0000, 'ºC'),
	(295386, 143, '2015-01-01 00:49:52.000000', 'temperatura', 830.0000, 'ºC'),
	(295387, 143, '2015-01-01 00:49:53.000000', 'temperatura', 29.0000, 'ºC'),
	(295388, 143, '2015-01-01 00:49:54.000000', 'temperatura', 54.0000, 'ºC'),
	(295389, 143, '2015-01-01 00:49:55.000000', 'temperatura', 184.0000, 'ºC'),
	(295390, 143, '2015-01-01 00:49:56.000000', 'temperatura', 759.0000, 'ºC'),
	(295391, 143, '2015-01-01 00:49:57.000000', 'temperatura', 842.0000, 'ºC'),
	(295392, 143, '2015-01-01 00:49:58.000000', 'temperatura', 733.0000, 'ºC'),
	(295393, 143, '2015-01-01 00:49:59.000000', 'temperatura', 1142.0000, 'ºC'),
	(295394, 143, '2015-01-01 00:50:00.000000', 'temperatura', 1112.0000, 'ºC'),
	(295395, 143, '2015-01-01 00:50:01.000000', 'temperatura', 933.0000, 'ºC'),
	(295396, 143, '2015-01-01 00:50:02.000000', 'temperatura', 130.0000, 'ºC'),
	(295397, 143, '2015-01-01 00:50:03.000000', 'temperatura', 251.0000, 'ºC'),
	(295398, 143, '2015-01-01 00:50:04.000000', 'temperatura', 867.0000, 'ºC'),
	(295399, 143, '2015-01-01 00:50:05.000000', 'temperatura', 1179.0000, 'ºC'),
	(295400, 143, '2015-01-01 00:50:06.000000', 'temperatura', 898.0000, 'ºC'),
	(295401, 143, '2015-01-01 00:50:07.000000', 'temperatura', 954.0000, 'ºC'),
	(295402, 143, '2015-01-01 00:50:08.000000', 'temperatura', 875.0000, 'ºC'),
	(295403, 143, '2015-01-01 00:50:09.000000', 'temperatura', 316.0000, 'ºC'),
	(295404, 143, '2015-01-01 00:50:10.000000', 'temperatura', 152.0000, 'ºC'),
	(295405, 143, '2015-01-01 00:50:11.000000', 'temperatura', 1013.0000, 'ºC'),
	(295406, 143, '2015-01-01 00:50:12.000000', 'temperatura', 1012.0000, 'ºC'),
	(295407, 143, '2015-01-01 00:50:13.000000', 'temperatura', 819.0000, 'ºC'),
	(295408, 143, '2015-01-01 00:50:14.000000', 'temperatura', 1059.0000, 'ºC'),
	(295409, 143, '2015-01-01 00:50:15.000000', 'temperatura', 439.0000, 'ºC'),
	(295410, 143, '2015-01-01 00:50:16.000000', 'temperatura', 220.0000, 'ºC'),
	(295411, 143, '2015-01-01 00:50:17.000000', 'temperatura', 985.0000, 'ºC'),
	(295412, 143, '2015-01-01 00:50:18.000000', 'temperatura', 662.0000, 'ºC'),
	(295413, 143, '2015-01-01 00:50:19.000000', 'temperatura', 358.0000, 'ºC'),
	(295414, 143, '2015-01-01 00:50:20.000000', 'temperatura', 1002.0000, 'ºC'),
	(295415, 143, '2015-01-01 00:50:21.000000', 'temperatura', 337.0000, 'ºC'),
	(295416, 143, '2015-01-01 00:50:22.000000', 'temperatura', 1080.0000, 'ºC'),
	(295417, 143, '2015-01-01 00:50:23.000000', 'temperatura', 788.0000, 'ºC'),
	(295418, 143, '2015-01-01 00:50:24.000000', 'temperatura', 701.0000, 'ºC'),
	(295419, 143, '2015-01-01 00:50:25.000000', 'temperatura', 1142.0000, 'ºC'),
	(295420, 143, '2015-01-01 00:50:26.000000', 'temperatura', 8.0000, 'ºC'),
	(295421, 143, '2015-01-01 00:50:27.000000', 'temperatura', 215.0000, 'ºC'),
	(295422, 143, '2015-01-01 00:50:28.000000', 'temperatura', 1051.0000, 'ºC'),
	(295423, 143, '2015-01-01 00:50:29.000000', 'temperatura', 1009.0000, 'ºC'),
	(295424, 143, '2015-01-01 00:50:30.000000', 'temperatura', 694.0000, 'ºC'),
	(295425, 143, '2015-01-01 00:50:31.000000', 'temperatura', 445.0000, 'ºC'),
	(295426, 143, '2015-01-01 00:50:32.000000', 'temperatura', 140.0000, 'ºC'),
	(295427, 143, '2015-01-01 00:50:33.000000', 'temperatura', 569.0000, 'ºC'),
	(295428, 143, '2015-01-01 00:50:34.000000', 'temperatura', 24.0000, 'ºC'),
	(295429, 143, '2015-01-01 00:50:35.000000', 'temperatura', 815.0000, 'ºC'),
	(295430, 143, '2015-01-01 00:50:36.000000', 'temperatura', 404.0000, 'ºC'),
	(295431, 143, '2015-01-01 00:50:37.000000', 'temperatura', 773.0000, 'ºC'),
	(295432, 143, '2015-01-01 00:50:38.000000', 'temperatura', 253.0000, 'ºC'),
	(295433, 143, '2015-01-01 00:50:39.000000', 'temperatura', 149.0000, 'ºC'),
	(295434, 143, '2015-01-01 00:50:40.000000', 'temperatura', 1186.0000, 'ºC'),
	(295435, 143, '2015-01-01 00:50:41.000000', 'temperatura', 683.0000, 'ºC'),
	(295436, 143, '2015-01-01 00:50:42.000000', 'temperatura', 1059.0000, 'ºC'),
	(295437, 143, '2015-01-01 00:50:43.000000', 'temperatura', 844.0000, 'ºC'),
	(295438, 143, '2015-01-01 00:50:44.000000', 'temperatura', 1045.0000, 'ºC'),
	(295439, 143, '2015-01-01 00:50:45.000000', 'temperatura', 294.0000, 'ºC'),
	(295440, 143, '2015-01-01 00:50:46.000000', 'temperatura', 736.0000, 'ºC'),
	(295441, 143, '2015-01-01 00:50:47.000000', 'temperatura', 398.0000, 'ºC'),
	(295442, 143, '2015-01-01 00:50:48.000000', 'temperatura', 984.0000, 'ºC'),
	(295443, 143, '2015-01-01 00:50:49.000000', 'temperatura', 125.0000, 'ºC'),
	(295444, 143, '2015-01-01 00:50:50.000000', 'temperatura', 75.0000, 'ºC'),
	(295445, 143, '2015-01-01 00:50:51.000000', 'temperatura', 0.0000, 'ºC'),
	(295446, 143, '2015-01-01 00:50:52.000000', 'temperatura', 977.0000, 'ºC'),
	(295447, 143, '2015-01-01 00:50:53.000000', 'temperatura', 84.0000, 'ºC'),
	(295448, 143, '2015-01-01 00:50:54.000000', 'temperatura', 1089.0000, 'ºC'),
	(295449, 143, '2015-01-01 00:50:55.000000', 'temperatura', 395.0000, 'ºC'),
	(295450, 143, '2015-01-01 00:50:56.000000', 'temperatura', 1107.0000, 'ºC'),
	(295451, 143, '2015-01-01 00:50:57.000000', 'temperatura', 750.0000, 'ºC'),
	(295452, 143, '2015-01-01 00:50:58.000000', 'temperatura', 431.0000, 'ºC'),
	(295453, 143, '2015-01-01 00:50:59.000000', 'temperatura', 1103.0000, 'ºC'),
	(295454, 143, '2015-01-01 00:51:00.000000', 'temperatura', 625.0000, 'ºC'),
	(295455, 143, '2015-01-01 00:51:01.000000', 'temperatura', 1018.0000, 'ºC'),
	(295456, 143, '2015-01-01 00:51:02.000000', 'temperatura', 813.0000, 'ºC'),
	(295457, 143, '2015-01-01 00:51:03.000000', 'temperatura', 1011.0000, 'ºC'),
	(295458, 143, '2015-01-01 00:51:04.000000', 'temperatura', 219.0000, 'ºC'),
	(295459, 143, '2015-01-01 00:51:05.000000', 'temperatura', 460.0000, 'ºC'),
	(295460, 143, '2015-01-01 00:51:06.000000', 'temperatura', 446.0000, 'ºC'),
	(295461, 143, '2015-01-01 00:51:07.000000', 'temperatura', 848.0000, 'ºC'),
	(295462, 143, '2015-01-01 00:51:08.000000', 'temperatura', 505.0000, 'ºC'),
	(295463, 143, '2015-01-01 00:51:09.000000', 'temperatura', 1182.0000, 'ºC'),
	(295464, 143, '2015-01-01 00:51:10.000000', 'temperatura', 793.0000, 'ºC'),
	(295465, 143, '2015-01-01 00:51:11.000000', 'temperatura', 420.0000, 'ºC'),
	(295466, 143, '2015-01-01 00:51:12.000000', 'temperatura', 921.0000, 'ºC'),
	(295467, 143, '2015-01-01 00:51:13.000000', 'temperatura', 945.0000, 'ºC'),
	(295468, 143, '2015-01-01 00:51:14.000000', 'temperatura', 764.0000, 'ºC'),
	(295469, 143, '2015-01-01 00:51:15.000000', 'temperatura', 983.0000, 'ºC'),
	(295470, 143, '2015-01-01 00:51:16.000000', 'temperatura', 225.0000, 'ºC'),
	(295471, 143, '2015-01-01 00:51:17.000000', 'temperatura', 575.0000, 'ºC'),
	(295472, 143, '2015-01-01 00:51:18.000000', 'temperatura', 1001.0000, 'ºC'),
	(295473, 143, '2015-01-01 00:51:19.000000', 'temperatura', 881.0000, 'ºC'),
	(295474, 143, '2015-01-01 00:51:20.000000', 'temperatura', 203.0000, 'ºC'),
	(295475, 143, '2015-01-01 00:51:21.000000', 'temperatura', 771.0000, 'ºC'),
	(295476, 143, '2015-01-01 00:51:22.000000', 'temperatura', 846.0000, 'ºC'),
	(295477, 143, '2015-01-01 00:51:23.000000', 'temperatura', 718.0000, 'ºC'),
	(295478, 143, '2015-01-01 00:51:24.000000', 'temperatura', 1051.0000, 'ºC'),
	(295479, 143, '2015-01-01 00:51:25.000000', 'temperatura', 701.0000, 'ºC'),
	(295480, 143, '2015-01-01 00:51:26.000000', 'temperatura', 355.0000, 'ºC'),
	(295481, 143, '2015-01-01 00:51:27.000000', 'temperatura', 873.0000, 'ºC'),
	(295482, 143, '2015-01-01 00:51:28.000000', 'temperatura', 900.0000, 'ºC'),
	(295483, 143, '2015-01-01 00:51:29.000000', 'temperatura', 680.0000, 'ºC'),
	(295484, 143, '2015-01-01 00:51:30.000000', 'temperatura', 702.0000, 'ºC'),
	(295485, 143, '2015-01-01 00:51:31.000000', 'temperatura', 271.0000, 'ºC'),
	(295486, 143, '2015-01-01 00:51:32.000000', 'temperatura', 449.0000, 'ºC'),
	(295487, 143, '2015-01-01 00:51:33.000000', 'temperatura', 233.0000, 'ºC'),
	(295488, 143, '2015-01-01 00:51:34.000000', 'temperatura', 1017.0000, 'ºC'),
	(295489, 143, '2015-01-01 00:51:35.000000', 'temperatura', 787.0000, 'ºC'),
	(295490, 143, '2015-01-01 00:51:36.000000', 'temperatura', 886.0000, 'ºC'),
	(295491, 143, '2015-01-01 00:51:37.000000', 'temperatura', 867.0000, 'ºC'),
	(295492, 143, '2015-01-01 00:51:38.000000', 'temperatura', 480.0000, 'ºC'),
	(295493, 143, '2015-01-01 00:51:39.000000', 'temperatura', 999.0000, 'ºC'),
	(295494, 143, '2015-01-01 00:51:40.000000', 'temperatura', 1154.0000, 'ºC'),
	(295495, 143, '2015-01-01 00:51:41.000000', 'temperatura', 372.0000, 'ºC'),
	(295496, 143, '2015-01-01 00:51:42.000000', 'temperatura', 801.0000, 'ºC'),
	(295497, 143, '2015-01-01 00:51:43.000000', 'temperatura', 489.0000, 'ºC'),
	(295498, 143, '2015-01-01 00:51:44.000000', 'temperatura', 43.0000, 'ºC'),
	(295499, 143, '2015-01-01 00:51:45.000000', 'temperatura', 1150.0000, 'ºC'),
	(295500, 143, '2015-01-01 00:51:46.000000', 'temperatura', 820.0000, 'ºC'),
	(295501, 143, '2015-01-01 00:51:47.000000', 'temperatura', 651.0000, 'ºC'),
	(295502, 143, '2015-01-01 00:51:48.000000', 'temperatura', 795.0000, 'ºC'),
	(295503, 143, '2015-01-01 00:51:49.000000', 'temperatura', 821.0000, 'ºC'),
	(295504, 143, '2015-01-01 00:51:50.000000', 'temperatura', 523.0000, 'ºC'),
	(295505, 143, '2015-01-01 00:51:51.000000', 'temperatura', 150.0000, 'ºC'),
	(295506, 143, '2015-01-01 00:51:52.000000', 'temperatura', 383.0000, 'ºC'),
	(295507, 143, '2015-01-01 00:51:53.000000', 'temperatura', 264.0000, 'ºC'),
	(295508, 143, '2015-01-01 00:51:54.000000', 'temperatura', 172.0000, 'ºC'),
	(295509, 143, '2015-01-01 00:51:55.000000', 'temperatura', 67.0000, 'ºC'),
	(295510, 143, '2015-01-01 00:51:56.000000', 'temperatura', 1022.0000, 'ºC'),
	(295511, 143, '2015-01-01 00:51:57.000000', 'temperatura', 108.0000, 'ºC'),
	(295512, 143, '2015-01-01 00:51:58.000000', 'temperatura', 1073.0000, 'ºC'),
	(295513, 143, '2015-01-01 00:51:59.000000', 'temperatura', 242.0000, 'ºC'),
	(295514, 143, '2015-01-01 00:52:00.000000', 'temperatura', 393.0000, 'ºC'),
	(295515, 143, '2015-01-01 00:52:01.000000', 'temperatura', 40.0000, 'ºC'),
	(295516, 143, '2015-01-01 00:52:02.000000', 'temperatura', 222.0000, 'ºC'),
	(295517, 143, '2015-01-01 00:52:03.000000', 'temperatura', 989.0000, 'ºC'),
	(295518, 143, '2015-01-01 00:52:04.000000', 'temperatura', 679.0000, 'ºC'),
	(295519, 143, '2015-01-01 00:52:05.000000', 'temperatura', 431.0000, 'ºC'),
	(295520, 143, '2015-01-01 00:52:06.000000', 'temperatura', 117.0000, 'ºC'),
	(295521, 143, '2015-01-01 00:52:07.000000', 'temperatura', 491.0000, 'ºC'),
	(295522, 143, '2015-01-01 00:52:08.000000', 'temperatura', 907.0000, 'ºC'),
	(295523, 143, '2015-01-01 00:52:09.000000', 'temperatura', 663.0000, 'ºC'),
	(295524, 143, '2015-01-01 00:52:10.000000', 'temperatura', 591.0000, 'ºC'),
	(295525, 143, '2015-01-01 00:52:11.000000', 'temperatura', 970.0000, 'ºC'),
	(295526, 143, '2015-01-01 00:52:12.000000', 'temperatura', 677.0000, 'ºC'),
	(295527, 143, '2015-01-01 00:52:13.000000', 'temperatura', 473.0000, 'ºC'),
	(295528, 143, '2015-01-01 00:52:14.000000', 'temperatura', 337.0000, 'ºC'),
	(295529, 143, '2015-01-01 00:52:15.000000', 'temperatura', 265.0000, 'ºC'),
	(295530, 143, '2015-01-01 00:52:16.000000', 'temperatura', 314.0000, 'ºC'),
	(295531, 143, '2015-01-01 00:52:17.000000', 'temperatura', 777.0000, 'ºC'),
	(295532, 143, '2015-01-01 00:52:18.000000', 'temperatura', 545.0000, 'ºC'),
	(295533, 143, '2015-01-01 00:52:19.000000', 'temperatura', 392.0000, 'ºC'),
	(295534, 143, '2015-01-01 00:52:20.000000', 'temperatura', 325.0000, 'ºC'),
	(295535, 143, '2015-01-01 00:52:21.000000', 'temperatura', 451.0000, 'ºC'),
	(295536, 143, '2015-01-01 00:52:22.000000', 'temperatura', 80.0000, 'ºC'),
	(295537, 143, '2015-01-01 00:52:23.000000', 'temperatura', 245.0000, 'ºC'),
	(295538, 143, '2015-01-01 00:52:24.000000', 'temperatura', 989.0000, 'ºC'),
	(295539, 143, '2015-01-01 00:52:25.000000', 'temperatura', 609.0000, 'ºC'),
	(295540, 143, '2015-01-01 00:52:26.000000', 'temperatura', 80.0000, 'ºC'),
	(295541, 143, '2015-01-01 00:52:27.000000', 'temperatura', 973.0000, 'ºC'),
	(295542, 143, '2015-01-01 00:52:28.000000', 'temperatura', 1027.0000, 'ºC'),
	(295543, 143, '2015-01-01 00:52:29.000000', 'temperatura', 1015.0000, 'ºC'),
	(295544, 143, '2015-01-01 00:52:30.000000', 'temperatura', 794.0000, 'ºC'),
	(295545, 143, '2015-01-01 00:52:31.000000', 'temperatura', 927.0000, 'ºC'),
	(295546, 143, '2015-01-01 00:52:32.000000', 'temperatura', 1051.0000, 'ºC'),
	(295547, 143, '2015-01-01 00:52:33.000000', 'temperatura', 77.0000, 'ºC'),
	(295548, 143, '2015-01-01 00:52:34.000000', 'temperatura', 832.0000, 'ºC'),
	(295549, 143, '2015-01-01 00:52:35.000000', 'temperatura', 330.0000, 'ºC'),
	(295550, 143, '2015-01-01 00:52:36.000000', 'temperatura', 355.0000, 'ºC'),
	(295551, 143, '2015-01-01 00:52:37.000000', 'temperatura', 787.0000, 'ºC'),
	(295552, 143, '2015-01-01 00:52:38.000000', 'temperatura', 468.0000, 'ºC'),
	(295553, 143, '2015-01-01 00:52:39.000000', 'temperatura', 1182.0000, 'ºC'),
	(295554, 143, '2015-01-01 00:52:40.000000', 'temperatura', 905.0000, 'ºC'),
	(295555, 143, '2015-01-01 00:52:41.000000', 'temperatura', 981.0000, 'ºC'),
	(295556, 143, '2015-01-01 00:52:42.000000', 'temperatura', 987.0000, 'ºC'),
	(295557, 143, '2015-01-01 00:52:43.000000', 'temperatura', 796.0000, 'ºC'),
	(295558, 143, '2015-01-01 00:52:44.000000', 'temperatura', 1020.0000, 'ºC'),
	(295559, 143, '2015-01-01 00:52:45.000000', 'temperatura', 311.0000, 'ºC'),
	(295560, 143, '2015-01-01 00:52:46.000000', 'temperatura', 897.0000, 'ºC'),
	(295561, 143, '2015-01-01 00:52:47.000000', 'temperatura', 1150.0000, 'ºC'),
	(295562, 143, '2015-01-01 00:52:48.000000', 'temperatura', 663.0000, 'ºC'),
	(295563, 143, '2015-01-01 00:52:49.000000', 'temperatura', 1063.0000, 'ºC'),
	(295564, 143, '2015-01-01 00:52:50.000000', 'temperatura', 925.0000, 'ºC'),
	(295565, 143, '2015-01-01 00:52:51.000000', 'temperatura', 240.0000, 'ºC'),
	(295566, 143, '2015-01-01 00:52:52.000000', 'temperatura', 824.0000, 'ºC'),
	(295567, 143, '2015-01-01 00:52:53.000000', 'temperatura', 998.0000, 'ºC'),
	(295568, 143, '2015-01-01 00:52:54.000000', 'temperatura', 122.0000, 'ºC'),
	(295569, 143, '2015-01-01 00:52:55.000000', 'temperatura', 16.0000, 'ºC'),
	(295570, 143, '2015-01-01 00:52:56.000000', 'temperatura', 916.0000, 'ºC'),
	(295571, 143, '2015-01-01 00:52:57.000000', 'temperatura', 929.0000, 'ºC'),
	(295572, 143, '2015-01-01 00:52:58.000000', 'temperatura', 701.0000, 'ºC'),
	(295573, 143, '2015-01-01 00:52:59.000000', 'temperatura', 717.0000, 'ºC'),
	(295574, 143, '2015-01-01 00:53:00.000000', 'temperatura', 281.0000, 'ºC'),
	(295575, 143, '2015-01-01 00:53:01.000000', 'temperatura', 455.0000, 'ºC'),
	(295576, 143, '2015-01-01 00:53:02.000000', 'temperatura', 231.0000, 'ºC'),
	(295577, 143, '2015-01-01 00:53:03.000000', 'temperatura', 993.0000, 'ºC'),
	(295578, 143, '2015-01-01 00:53:04.000000', 'temperatura', 673.0000, 'ºC'),
	(295579, 143, '2015-01-01 00:53:05.000000', 'temperatura', 388.0000, 'ºC'),
	(295580, 143, '2015-01-01 00:53:06.000000', 'temperatura', 1119.0000, 'ºC'),
	(295581, 143, '2015-01-01 00:53:07.000000', 'temperatura', 830.0000, 'ºC'),
	(295582, 143, '2015-01-01 00:53:08.000000', 'temperatura', 795.0000, 'ºC'),
	(295583, 143, '2015-01-01 00:53:09.000000', 'temperatura', 285.0000, 'ºC'),
	(295584, 143, '2015-01-01 00:53:10.000000', 'temperatura', 240.0000, 'ºC'),
	(295585, 143, '2015-01-01 00:53:11.000000', 'temperatura', 346.0000, 'ºC'),
	(295586, 143, '2015-01-01 00:53:12.000000', 'temperatura', 1013.0000, 'ºC'),
	(295587, 143, '2015-01-01 00:53:13.000000', 'temperatura', 424.0000, 'ºC'),
	(295588, 143, '2015-01-01 00:53:14.000000', 'temperatura', 282.0000, 'ºC'),
	(295589, 143, '2015-01-01 00:53:15.000000', 'temperatura', 138.0000, 'ºC'),
	(295590, 143, '2015-01-01 00:53:16.000000', 'temperatura', 1045.0000, 'ºC'),
	(295591, 143, '2015-01-01 00:53:17.000000', 'temperatura', 10.0000, 'ºC'),
	(295592, 143, '2015-01-01 00:53:18.000000', 'temperatura', 515.0000, 'ºC'),
	(295593, 143, '2015-01-01 00:53:19.000000', 'temperatura', 145.0000, 'ºC'),
	(295594, 143, '2015-01-01 00:53:20.000000', 'temperatura', 380.0000, 'ºC'),
	(295595, 143, '2015-01-01 00:53:21.000000', 'temperatura', 266.0000, 'ºC'),
	(295596, 143, '2015-01-01 00:53:22.000000', 'temperatura', 190.0000, 'ºC'),
	(295597, 143, '2015-01-01 00:53:23.000000', 'temperatura', 155.0000, 'ºC'),
	(295598, 143, '2015-01-01 00:53:24.000000', 'temperatura', 205.0000, 'ºC'),
	(295599, 143, '2015-01-01 00:53:25.000000', 'temperatura', 562.0000, 'ºC'),
	(295600, 143, '2015-01-01 00:53:26.000000', 'temperatura', 992.0000, 'ºC'),
	(295601, 143, '2015-01-01 00:53:27.000000', 'temperatura', 878.0000, 'ºC'),
	(295602, 143, '2015-01-01 00:53:28.000000', 'temperatura', 212.0000, 'ºC'),
	(295603, 143, '2015-01-01 00:53:29.000000', 'temperatura', 829.0000, 'ºC'),
	(295604, 143, '2015-01-01 00:53:30.000000', 'temperatura', 1108.0000, 'ºC'),
	(295605, 143, '2015-01-01 00:53:31.000000', 'temperatura', 655.0000, 'ºC'),
	(295606, 143, '2015-01-01 00:53:32.000000', 'temperatura', 1151.0000, 'ºC'),
	(295607, 143, '2015-01-01 00:53:33.000000', 'temperatura', 190.0000, 'ºC'),
	(295608, 143, '2015-01-01 00:53:34.000000', 'temperatura', 1096.0000, 'ºC'),
	(295609, 143, '2015-01-01 00:53:35.000000', 'temperatura', 111.0000, 'ºC'),
	(295610, 143, '2015-01-01 00:53:36.000000', 'temperatura', 870.0000, 'ºC'),
	(295611, 143, '2015-01-01 00:53:37.000000', 'temperatura', 415.0000, 'ºC'),
	(295612, 143, '2015-01-01 00:53:38.000000', 'temperatura', 667.0000, 'ºC'),
	(295613, 143, '2015-01-01 00:53:39.000000', 'temperatura', 892.0000, 'ºC'),
	(295614, 143, '2015-01-01 00:53:40.000000', 'temperatura', 59.0000, 'ºC'),
	(295615, 143, '2015-01-01 00:53:41.000000', 'temperatura', 17.0000, 'ºC'),
	(295616, 143, '2015-01-01 00:53:42.000000', 'temperatura', 1109.0000, 'ºC'),
	(295617, 143, '2015-01-01 00:53:43.000000', 'temperatura', 693.0000, 'ºC'),
	(295618, 143, '2015-01-01 00:53:44.000000', 'temperatura', 142.0000, 'ºC'),
	(295619, 143, '2015-01-01 00:53:45.000000', 'temperatura', 1028.0000, 'ºC'),
	(295620, 143, '2015-01-01 00:53:46.000000', 'temperatura', 1118.0000, 'ºC'),
	(295621, 143, '2015-01-01 00:53:47.000000', 'temperatura', 104.0000, 'ºC'),
	(295622, 143, '2015-01-01 00:53:48.000000', 'temperatura', 769.0000, 'ºC'),
	(295623, 143, '2015-01-01 00:53:49.000000', 'temperatura', 1131.0000, 'ºC'),
	(295624, 143, '2015-01-01 00:53:50.000000', 'temperatura', 950.0000, 'ºC'),
	(295625, 143, '2015-01-01 00:53:51.000000', 'temperatura', 157.0000, 'ºC'),
	(295626, 143, '2015-01-01 00:53:52.000000', 'temperatura', 336.0000, 'ºC'),
	(295627, 143, '2015-01-01 00:53:53.000000', 'temperatura', 8.0000, 'ºC'),
	(295628, 143, '2015-01-01 00:53:54.000000', 'temperatura', 235.0000, 'ºC'),
	(295629, 143, '2015-01-01 00:53:55.000000', 'temperatura', 1149.0000, 'ºC'),
	(295630, 143, '2015-01-01 00:53:56.000000', 'temperatura', 242.0000, 'ºC'),
	(295631, 143, '2015-01-01 00:53:57.000000', 'temperatura', 162.0000, 'ºC'),
	(295632, 143, '2015-01-01 00:53:58.000000', 'temperatura', 87.0000, 'ºC'),
	(295633, 143, '2015-01-01 00:53:59.000000', 'temperatura', 1146.0000, 'ºC'),
	(295634, 143, '2015-01-01 00:54:00.000000', 'temperatura', 673.0000, 'ºC'),
	(295635, 143, '2015-01-01 00:54:01.000000', 'temperatura', 1124.0000, 'ºC'),
	(295636, 143, '2015-01-01 00:54:02.000000', 'temperatura', 4.0000, 'ºC'),
	(295637, 143, '2015-01-01 00:54:03.000000', 'temperatura', 248.0000, 'ºC'),
	(295638, 143, '2015-01-01 00:54:04.000000', 'temperatura', 30.0000, 'ºC'),
	(295639, 143, '2015-01-01 00:54:05.000000', 'temperatura', 603.0000, 'ºC'),
	(295640, 143, '2015-01-01 00:54:06.000000', 'temperatura', 529.0000, 'ºC'),
	(295641, 143, '2015-01-01 00:54:07.000000', 'temperatura', 836.0000, 'ºC'),
	(295642, 143, '2015-01-01 00:54:08.000000', 'temperatura', 191.0000, 'ºC'),
	(295643, 143, '2015-01-01 00:54:09.000000', 'temperatura', 851.0000, 'ºC'),
	(295644, 143, '2015-01-01 00:54:10.000000', 'temperatura', 80.0000, 'ºC'),
	(295645, 143, '2015-01-01 00:54:11.000000', 'temperatura', 249.0000, 'ºC'),
	(295646, 143, '2015-01-01 00:54:12.000000', 'temperatura', 1006.0000, 'ºC'),
	(295647, 143, '2015-01-01 00:54:13.000000', 'temperatura', 685.0000, 'ºC'),
	(295648, 143, '2015-01-01 00:54:14.000000', 'temperatura', 405.0000, 'ºC'),
	(295649, 143, '2015-01-01 00:54:15.000000', 'temperatura', 1170.0000, 'ºC'),
	(295650, 143, '2015-01-01 00:54:16.000000', 'temperatura', 1037.0000, 'ºC'),
	(295651, 143, '2015-01-01 00:54:17.000000', 'temperatura', 473.0000, 'ºC'),
	(295652, 143, '2015-01-01 00:54:18.000000', 'temperatura', 456.0000, 'ºC'),
	(295653, 143, '2015-01-01 00:54:19.000000', 'temperatura', 862.0000, 'ºC'),
	(295654, 143, '2015-01-01 00:54:20.000000', 'temperatura', 542.0000, 'ºC'),
	(295655, 143, '2015-01-01 00:54:21.000000', 'temperatura', 123.0000, 'ºC'),
	(295656, 143, '2015-01-01 00:54:22.000000', 'temperatura', 192.0000, 'ºC'),
	(295657, 143, '2015-01-01 00:54:23.000000', 'temperatura', 589.0000, 'ºC'),
	(295658, 143, '2015-01-01 00:54:24.000000', 'temperatura', 1172.0000, 'ºC'),
	(295659, 143, '2015-01-01 00:54:25.000000', 'temperatura', 492.0000, 'ºC'),
	(295660, 143, '2015-01-01 00:54:26.000000', 'temperatura', 145.0000, 'ºC'),
	(295661, 143, '2015-01-01 00:54:27.000000', 'temperatura', 450.0000, 'ºC'),
	(295662, 143, '2015-01-01 00:54:28.000000', 'temperatura', 615.0000, 'ºC'),
	(295663, 143, '2015-01-01 00:54:29.000000', 'temperatura', 527.0000, 'ºC'),
	(295664, 143, '2015-01-01 00:54:30.000000', 'temperatura', 790.0000, 'ºC'),
	(295665, 143, '2015-01-01 00:54:31.000000', 'temperatura', 1171.0000, 'ºC'),
	(295666, 143, '2015-01-01 00:54:32.000000', 'temperatura', 1085.0000, 'ºC'),
	(295667, 143, '2015-01-01 00:54:33.000000', 'temperatura', 711.0000, 'ºC'),
	(295668, 143, '2015-01-01 00:54:34.000000', 'temperatura', 303.0000, 'ºC'),
	(295669, 143, '2015-01-01 00:54:35.000000', 'temperatura', 581.0000, 'ºC'),
	(295670, 143, '2015-01-01 00:54:36.000000', 'temperatura', 798.0000, 'ºC'),
	(295671, 143, '2015-01-01 00:54:37.000000', 'temperatura', 1046.0000, 'ºC'),
	(295672, 143, '2015-01-01 00:54:38.000000', 'temperatura', 438.0000, 'ºC'),
	(295673, 143, '2015-01-01 00:54:39.000000', 'temperatura', 253.0000, 'ºC'),
	(295674, 143, '2015-01-01 00:54:40.000000', 'temperatura', 1151.0000, 'ºC'),
	(295675, 143, '2015-01-01 00:54:41.000000', 'temperatura', 198.0000, 'ºC'),
	(295676, 143, '2015-01-01 00:54:42.000000', 'temperatura', 1135.0000, 'ºC'),
	(295677, 143, '2015-01-01 00:54:43.000000', 'temperatura', 284.0000, 'ºC'),
	(295678, 143, '2015-01-01 00:54:44.000000', 'temperatura', 416.0000, 'ºC'),
	(295679, 143, '2015-01-01 00:54:45.000000', 'temperatura', 26.0000, 'ºC'),
	(295680, 143, '2015-01-01 00:54:46.000000', 'temperatura', 85.0000, 'ºC'),
	(295681, 143, '2015-01-01 00:54:47.000000', 'temperatura', 347.0000, 'ºC'),
	(295682, 143, '2015-01-01 00:54:48.000000', 'temperatura', 281.0000, 'ºC'),
	(295683, 143, '2015-01-01 00:54:49.000000', 'temperatura', 366.0000, 'ºC'),
	(295684, 143, '2015-01-01 00:54:50.000000', 'temperatura', 985.0000, 'ºC'),
	(295685, 143, '2015-01-01 00:54:51.000000', 'temperatura', 229.0000, 'ºC'),
	(295686, 143, '2015-01-01 00:54:52.000000', 'temperatura', 591.0000, 'ºC'),
	(295687, 143, '2015-01-01 00:54:53.000000', 'temperatura', 1066.0000, 'ºC'),
	(295688, 143, '2015-01-01 00:54:54.000000', 'temperatura', 1159.0000, 'ºC'),
	(295689, 143, '2015-01-01 00:54:55.000000', 'temperatura', 199.0000, 'ºC'),
	(295690, 143, '2015-01-01 00:54:56.000000', 'temperatura', 1119.0000, 'ºC'),
	(295691, 143, '2015-01-01 00:54:57.000000', 'temperatura', 197.0000, 'ºC'),
	(295692, 143, '2015-01-01 00:54:58.000000', 'temperatura', 28.0000, 'ºC'),
	(295693, 143, '2015-01-01 00:54:59.000000', 'temperatura', 752.0000, 'ºC'),
	(295694, 143, '2015-01-01 00:55:00.000000', 'temperatura', 73.0000, 'ºC'),
	(295695, 143, '2015-01-01 00:55:01.000000', 'temperatura', 513.0000, 'ºC'),
	(295696, 143, '2015-01-01 00:55:02.000000', 'temperatura', 1145.0000, 'ºC'),
	(295697, 143, '2015-01-01 00:55:03.000000', 'temperatura', 586.0000, 'ºC'),
	(295698, 143, '2015-01-01 00:55:04.000000', 'temperatura', 697.0000, 'ºC'),
	(295699, 143, '2015-01-01 00:55:05.000000', 'temperatura', 526.0000, 'ºC'),
	(295700, 143, '2015-01-01 00:55:06.000000', 'temperatura', 540.0000, 'ºC'),
	(295701, 143, '2015-01-01 00:55:07.000000', 'temperatura', 1124.0000, 'ºC'),
	(295702, 143, '2015-01-01 00:55:08.000000', 'temperatura', 399.0000, 'ºC'),
	(295703, 143, '2015-01-01 00:55:09.000000', 'temperatura', 1024.0000, 'ºC'),
	(295704, 143, '2015-01-01 00:55:10.000000', 'temperatura', 322.0000, 'ºC'),
	(295705, 143, '2015-01-01 00:55:11.000000', 'temperatura', 940.0000, 'ºC'),
	(295706, 143, '2015-01-01 00:55:12.000000', 'temperatura', 133.0000, 'ºC'),
	(295707, 143, '2015-01-01 00:55:13.000000', 'temperatura', 246.0000, 'ºC'),
	(295708, 143, '2015-01-01 00:55:14.000000', 'temperatura', 831.0000, 'ºC'),
	(295709, 143, '2015-01-01 00:55:15.000000', 'temperatura', 1016.0000, 'ºC'),
	(295710, 143, '2015-01-01 00:55:16.000000', 'temperatura', 189.0000, 'ºC'),
	(295711, 143, '2015-01-01 00:55:17.000000', 'temperatura', 296.0000, 'ºC'),
	(295712, 143, '2015-01-01 00:55:18.000000', 'temperatura', 914.0000, 'ºC'),
	(295713, 143, '2015-01-01 00:55:19.000000', 'temperatura', 83.0000, 'ºC'),
	(295714, 143, '2015-01-01 00:55:20.000000', 'temperatura', 74.0000, 'ºC'),
	(295715, 143, '2015-01-01 00:55:21.000000', 'temperatura', 122.0000, 'ºC'),
	(295716, 143, '2015-01-01 00:55:22.000000', 'temperatura', 389.0000, 'ºC'),
	(295717, 143, '2015-01-01 00:55:23.000000', 'temperatura', 378.0000, 'ºC'),
	(295718, 143, '2015-01-01 00:55:24.000000', 'temperatura', 725.0000, 'ºC'),
	(295719, 143, '2015-01-01 00:55:25.000000', 'temperatura', 90.0000, 'ºC'),
	(295720, 143, '2015-01-01 00:55:26.000000', 'temperatura', 677.0000, 'ºC'),
	(295721, 143, '2015-01-01 00:55:27.000000', 'temperatura', 715.0000, 'ºC'),
	(295722, 143, '2015-01-01 00:55:28.000000', 'temperatura', 344.0000, 'ºC'),
	(295723, 143, '2015-01-01 00:55:29.000000', 'temperatura', 775.0000, 'ºC'),
	(295724, 143, '2015-01-01 00:55:30.000000', 'temperatura', 443.0000, 'ºC'),
	(295725, 143, '2015-01-01 00:55:31.000000', 'temperatura', 1091.0000, 'ºC'),
	(295726, 143, '2015-01-01 00:55:32.000000', 'temperatura', 525.0000, 'ºC'),
	(295727, 143, '2015-01-01 00:55:33.000000', 'temperatura', 553.0000, 'ºC'),
	(295728, 143, '2015-01-01 00:55:34.000000', 'temperatura', 1190.0000, 'ºC'),
	(295729, 143, '2015-01-01 00:55:35.000000', 'temperatura', 693.0000, 'ºC'),
	(295730, 143, '2015-01-01 00:55:36.000000', 'temperatura', 1096.0000, 'ºC'),
	(295731, 143, '2015-01-01 00:55:37.000000', 'temperatura', 1001.0000, 'ºC'),
	(295732, 143, '2015-01-01 00:55:38.000000', 'temperatura', 518.0000, 'ºC'),
	(295733, 143, '2015-01-01 00:55:39.000000', 'temperatura', 786.0000, 'ºC'),
	(295734, 143, '2015-01-01 00:55:40.000000', 'temperatura', 1177.0000, 'ºC'),
	(295735, 143, '2015-01-01 00:55:41.000000', 'temperatura', 1127.0000, 'ºC'),
	(295736, 143, '2015-01-01 00:55:42.000000', 'temperatura', 904.0000, 'ºC'),
	(295737, 143, '2015-01-01 00:55:43.000000', 'temperatura', 1140.0000, 'ºC'),
	(295738, 143, '2015-01-01 00:55:44.000000', 'temperatura', 588.0000, 'ºC'),
	(295739, 143, '2015-01-01 00:55:45.000000', 'temperatura', 721.0000, 'ºC'),
	(295740, 143, '2015-01-01 00:55:46.000000', 'temperatura', 644.0000, 'ºC'),
	(295741, 143, '2015-01-01 00:55:47.000000', 'temperatura', 1054.0000, 'ºC'),
	(295742, 143, '2015-01-01 00:55:48.000000', 'temperatura', 939.0000, 'ºC'),
	(295743, 143, '2015-01-01 00:55:49.000000', 'temperatura', 334.0000, 'ºC'),
	(295744, 143, '2015-01-01 00:55:50.000000', 'temperatura', 52.0000, 'ºC'),
	(295745, 143, '2015-01-01 00:55:51.000000', 'temperatura', 460.0000, 'ºC'),
	(295746, 143, '2015-01-01 00:55:52.000000', 'temperatura', 946.0000, 'ºC'),
	(295747, 143, '2015-01-01 00:55:53.000000', 'temperatura', 950.0000, 'ºC'),
	(295748, 143, '2015-01-01 00:55:54.000000', 'temperatura', 710.0000, 'ºC'),
	(295749, 143, '2015-01-01 00:55:55.000000', 'temperatura', 702.0000, 'ºC'),
	(295750, 143, '2015-01-01 00:55:56.000000', 'temperatura', 181.0000, 'ºC'),
	(295751, 143, '2015-01-01 00:55:57.000000', 'temperatura', 1199.0000, 'ºC'),
	(295752, 143, '2015-01-01 00:55:58.000000', 'temperatura', 651.0000, 'ºC'),
	(295753, 143, '2015-01-01 00:55:59.000000', 'temperatura', 858.0000, 'ºC'),
	(295754, 143, '2015-01-01 00:56:00.000000', 'temperatura', 1138.0000, 'ºC'),
	(295755, 143, '2015-01-01 00:56:01.000000', 'temperatura', 718.0000, 'ºC'),
	(295756, 143, '2015-01-01 00:56:02.000000', 'temperatura', 176.0000, 'ºC'),
	(295757, 143, '2015-01-01 00:56:03.000000', 'temperatura', 1127.0000, 'ºC'),
	(295758, 143, '2015-01-01 00:56:04.000000', 'temperatura', 306.0000, 'ºC'),
	(295759, 143, '2015-01-01 00:56:05.000000', 'temperatura', 552.0000, 'ºC'),
	(295760, 143, '2015-01-01 00:56:06.000000', 'temperatura', 641.0000, 'ºC'),
	(295761, 143, '2015-01-01 00:56:07.000000', 'temperatura', 349.0000, 'ºC'),
	(295762, 143, '2015-01-01 00:56:08.000000', 'temperatura', 1023.0000, 'ºC'),
	(295763, 143, '2015-01-01 00:56:09.000000', 'temperatura', 466.0000, 'ºC'),
	(295764, 143, '2015-01-01 00:56:10.000000', 'temperatura', 465.0000, 'ºC'),
	(295765, 143, '2015-01-01 00:56:11.000000', 'temperatura', 926.0000, 'ºC'),
	(295766, 143, '2015-01-01 00:56:12.000000', 'temperatura', 837.0000, 'ºC'),
	(295767, 143, '2015-01-01 00:56:13.000000', 'temperatura', 209.0000, 'ºC'),
	(295768, 143, '2015-01-01 00:56:14.000000', 'temperatura', 931.0000, 'ºC'),
	(295769, 143, '2015-01-01 00:56:15.000000', 'temperatura', 432.0000, 'ºC'),
	(295770, 143, '2015-01-01 00:56:16.000000', 'temperatura', 565.0000, 'ºC'),
	(295771, 143, '2015-01-01 00:56:17.000000', 'temperatura', 330.0000, 'ºC'),
	(295772, 143, '2015-01-01 00:56:18.000000', 'temperatura', 1156.0000, 'ºC'),
	(295773, 143, '2015-01-01 00:56:19.000000', 'temperatura', 1190.0000, 'ºC'),
	(295774, 143, '2015-01-01 00:56:20.000000', 'temperatura', 82.0000, 'ºC'),
	(295775, 143, '2015-01-01 00:56:21.000000', 'temperatura', 439.0000, 'ºC'),
	(295776, 143, '2015-01-01 00:56:22.000000', 'temperatura', 752.0000, 'ºC'),
	(295777, 143, '2015-01-01 00:56:23.000000', 'temperatura', 43.0000, 'ºC'),
	(295778, 143, '2015-01-01 00:56:24.000000', 'temperatura', 358.0000, 'ºC'),
	(295779, 143, '2015-01-01 00:56:25.000000', 'temperatura', 461.0000, 'ºC'),
	(295780, 143, '2015-01-01 00:56:26.000000', 'temperatura', 34.0000, 'ºC'),
	(295781, 143, '2015-01-01 00:56:27.000000', 'temperatura', 1187.0000, 'ºC'),
	(295782, 143, '2015-01-01 00:56:28.000000', 'temperatura', 1031.0000, 'ºC'),
	(295783, 143, '2015-01-01 00:56:29.000000', 'temperatura', 396.0000, 'ºC'),
	(295784, 143, '2015-01-01 00:56:30.000000', 'temperatura', 87.0000, 'ºC'),
	(295785, 143, '2015-01-01 00:56:31.000000', 'temperatura', 448.0000, 'ºC'),
	(295786, 143, '2015-01-01 00:56:32.000000', 'temperatura', 780.0000, 'ºC'),
	(295787, 143, '2015-01-01 00:56:33.000000', 'temperatura', 155.0000, 'ºC'),
	(295788, 143, '2015-01-01 00:56:34.000000', 'temperatura', 836.0000, 'ºC'),
	(295789, 143, '2015-01-01 00:56:35.000000', 'temperatura', 117.0000, 'ºC'),
	(295790, 143, '2015-01-01 00:56:36.000000', 'temperatura', 476.0000, 'ºC'),
	(295791, 143, '2015-01-01 00:56:37.000000', 'temperatura', 830.0000, 'ºC'),
	(295792, 143, '2015-01-01 00:56:38.000000', 'temperatura', 321.0000, 'ºC'),
	(295793, 143, '2015-01-01 00:56:39.000000', 'temperatura', 318.0000, 'ºC'),
	(295794, 143, '2015-01-01 00:56:40.000000', 'temperatura', 625.0000, 'ºC'),
	(295795, 143, '2015-01-01 00:56:41.000000', 'temperatura', 973.0000, 'ºC'),
	(295796, 143, '2015-01-01 00:56:42.000000', 'temperatura', 592.0000, 'ºC'),
	(295797, 143, '2015-01-01 00:56:43.000000', 'temperatura', 39.0000, 'ºC'),
	(295798, 143, '2015-01-01 00:56:44.000000', 'temperatura', 820.0000, 'ºC'),
	(295799, 143, '2015-01-01 00:56:45.000000', 'temperatura', 384.0000, 'ºC'),
	(295800, 143, '2015-01-01 00:56:46.000000', 'temperatura', 660.0000, 'ºC'),
	(295801, 143, '2015-01-01 00:56:47.000000', 'temperatura', 950.0000, 'ºC'),
	(295802, 143, '2015-01-01 00:56:48.000000', 'temperatura', 371.0000, 'ºC'),
	(295803, 143, '2015-01-01 00:56:49.000000', 'temperatura', 205.0000, 'ºC'),
	(295804, 143, '2015-01-01 00:56:50.000000', 'temperatura', 1110.0000, 'ºC'),
	(295805, 143, '2015-01-01 00:56:51.000000', 'temperatura', 139.0000, 'ºC'),
	(295806, 143, '2015-01-01 00:56:52.000000', 'temperatura', 964.0000, 'ºC'),
	(295807, 143, '2015-01-01 00:56:53.000000', 'temperatura', 802.0000, 'ºC'),
	(295808, 143, '2015-01-01 00:56:54.000000', 'temperatura', 1118.0000, 'ºC'),
	(295809, 143, '2015-01-01 00:56:55.000000', 'temperatura', 786.0000, 'ºC'),
	(295810, 143, '2015-01-01 00:56:56.000000', 'temperatura', 575.0000, 'ºC'),
	(295811, 143, '2015-01-01 00:56:57.000000', 'temperatura', 519.0000, 'ºC'),
	(295812, 143, '2015-01-01 00:56:58.000000', 'temperatura', 870.0000, 'ºC'),
	(295813, 143, '2015-01-01 00:56:59.000000', 'temperatura', 395.0000, 'ºC'),
	(295814, 143, '2015-01-01 00:57:00.000000', 'temperatura', 565.0000, 'ºC'),
	(295815, 143, '2015-01-01 00:57:01.000000', 'temperatura', 440.0000, 'ºC'),
	(295816, 143, '2015-01-01 00:57:02.000000', 'temperatura', 505.0000, 'ºC'),
	(295817, 143, '2015-01-01 00:57:03.000000', 'temperatura', 5.0000, 'ºC'),
	(295818, 143, '2015-01-01 00:57:04.000000', 'temperatura', 911.0000, 'ºC'),
	(295819, 143, '2015-01-01 00:57:05.000000', 'temperatura', 941.0000, 'ºC'),
	(295820, 143, '2015-01-01 00:57:06.000000', 'temperatura', 772.0000, 'ºC'),
	(295821, 143, '2015-01-01 00:57:07.000000', 'temperatura', 1036.0000, 'ºC'),
	(295822, 143, '2015-01-01 00:57:08.000000', 'temperatura', 468.0000, 'ºC'),
	(295823, 143, '2015-01-01 00:57:09.000000', 'temperatura', 429.0000, 'ºC'),
	(295824, 143, '2015-01-01 00:57:10.000000', 'temperatura', 744.0000, 'ºC'),
	(295825, 143, '2015-01-01 00:57:11.000000', 'temperatura', 34.0000, 'ºC'),
	(295826, 143, '2015-01-01 00:57:12.000000', 'temperatura', 337.0000, 'ºC'),
	(295827, 143, '2015-01-01 00:57:13.000000', 'temperatura', 382.0000, 'ºC'),
	(295828, 143, '2015-01-01 00:57:14.000000', 'temperatura', 901.0000, 'ºC'),
	(295829, 143, '2015-01-01 00:57:15.000000', 'temperatura', 959.0000, 'ºC'),
	(295830, 143, '2015-01-01 00:57:16.000000', 'temperatura', 894.0000, 'ºC'),
	(295831, 143, '2015-01-01 00:57:17.000000', 'temperatura', 394.0000, 'ºC'),
	(295832, 143, '2015-01-01 00:57:18.000000', 'temperatura', 489.0000, 'ºC'),
	(295833, 143, '2015-01-01 00:57:19.000000', 'temperatura', 62.0000, 'ºC'),
	(295834, 143, '2015-01-01 00:57:20.000000', 'temperatura', 44.0000, 'ºC'),
	(295835, 143, '2015-01-01 00:57:21.000000', 'temperatura', 34.0000, 'ºC'),
	(295836, 143, '2015-01-01 00:57:22.000000', 'temperatura', 37.0000, 'ºC'),
	(295837, 143, '2015-01-01 00:57:23.000000', 'temperatura', 85.0000, 'ºC'),
	(295838, 143, '2015-01-01 00:57:24.000000', 'temperatura', 316.0000, 'ºC'),
	(295839, 143, '2015-01-01 00:57:25.000000', 'temperatura', 124.0000, 'ºC'),
	(295840, 143, '2015-01-01 00:57:26.000000', 'temperatura', 874.0000, 'ºC'),
	(295841, 143, '2015-01-01 00:57:27.000000', 'temperatura', 399.0000, 'ºC'),
	(295842, 143, '2015-01-01 00:57:28.000000', 'temperatura', 573.0000, 'ºC'),
	(295843, 143, '2015-01-01 00:57:29.000000', 'temperatura', 469.0000, 'ºC'),
	(295844, 143, '2015-01-01 00:57:30.000000', 'temperatura', 624.0000, 'ºC'),
	(295845, 143, '2015-01-01 00:57:31.000000', 'temperatura', 515.0000, 'ºC'),
	(295846, 143, '2015-01-01 00:57:32.000000', 'temperatura', 701.0000, 'ºC'),
	(295847, 143, '2015-01-01 00:57:33.000000', 'temperatura', 764.0000, 'ºC'),
	(295848, 143, '2015-01-01 00:57:34.000000', 'temperatura', 517.0000, 'ºC'),
	(295849, 143, '2015-01-01 00:57:35.000000', 'temperatura', 295.0000, 'ºC'),
	(295850, 143, '2015-01-01 00:57:36.000000', 'temperatura', 1123.0000, 'ºC'),
	(295851, 143, '2015-01-01 00:57:37.000000', 'temperatura', 1129.0000, 'ºC'),
	(295852, 143, '2015-01-01 00:57:38.000000', 'temperatura', 1076.0000, 'ºC'),
	(295853, 143, '2015-01-01 00:57:39.000000', 'temperatura', 793.0000, 'ºC'),
	(295854, 143, '2015-01-01 00:57:40.000000', 'temperatura', 737.0000, 'ºC'),
	(295855, 143, '2015-01-01 00:57:41.000000', 'temperatura', 110.0000, 'ºC'),
	(295856, 143, '2015-01-01 00:57:42.000000', 'temperatura', 737.0000, 'ºC'),
	(295857, 143, '2015-01-01 00:57:43.000000', 'temperatura', 955.0000, 'ºC'),
	(295858, 143, '2015-01-01 00:57:44.000000', 'temperatura', 166.0000, 'ºC'),
	(295859, 143, '2015-01-01 00:57:45.000000', 'temperatura', 365.0000, 'ºC'),
	(295860, 143, '2015-01-01 00:57:46.000000', 'temperatura', 126.0000, 'ºC'),
	(295861, 143, '2015-01-01 00:57:47.000000', 'temperatura', 735.0000, 'ºC'),
	(295862, 143, '2015-01-01 00:57:48.000000', 'temperatura', 898.0000, 'ºC'),
	(295863, 143, '2015-01-01 00:57:49.000000', 'temperatura', 1086.0000, 'ºC'),
	(295864, 143, '2015-01-01 00:57:50.000000', 'temperatura', 336.0000, 'ºC'),
	(295865, 143, '2015-01-01 00:57:51.000000', 'temperatura', 825.0000, 'ºC'),
	(295866, 143, '2015-01-01 00:57:52.000000', 'temperatura', 716.0000, 'ºC'),
	(295867, 143, '2015-01-01 00:57:53.000000', 'temperatura', 1104.0000, 'ºC'),
	(295868, 143, '2015-01-01 00:57:54.000000', 'temperatura', 974.0000, 'ºC'),
	(295869, 143, '2015-01-01 00:57:55.000000', 'temperatura', 357.0000, 'ºC'),
	(295870, 143, '2015-01-01 00:57:56.000000', 'temperatura', 64.0000, 'ºC'),
	(295871, 143, '2015-01-01 00:57:57.000000', 'temperatura', 448.0000, 'ºC'),
	(295872, 143, '2015-01-01 00:57:58.000000', 'temperatura', 851.0000, 'ºC'),
	(295873, 143, '2015-01-01 00:57:59.000000', 'temperatura', 512.0000, 'ºC'),
	(295874, 143, '2015-01-01 00:58:00.000000', 'temperatura', 6.0000, 'ºC'),
	(295875, 143, '2015-01-01 00:58:01.000000', 'temperatura', 896.0000, 'ºC'),
	(295876, 143, '2015-01-01 00:58:02.000000', 'temperatura', 864.0000, 'ºC'),
	(295877, 143, '2015-01-01 00:58:03.000000', 'temperatura', 430.0000, 'ºC'),
	(295878, 143, '2015-01-01 00:58:04.000000', 'temperatura', 759.0000, 'ºC'),
	(295879, 143, '2015-01-01 00:58:05.000000', 'temperatura', 105.0000, 'ºC'),
	(295880, 143, '2015-01-01 00:58:06.000000', 'temperatura', 649.0000, 'ºC'),
	(295881, 143, '2015-01-01 00:58:07.000000', 'temperatura', 533.0000, 'ºC'),
	(295882, 143, '2015-01-01 00:58:08.000000', 'temperatura', 715.0000, 'ºC'),
	(295883, 143, '2015-01-01 00:58:09.000000', 'temperatura', 777.0000, 'ºC'),
	(295884, 143, '2015-01-01 00:58:10.000000', 'temperatura', 541.0000, 'ºC'),
	(295885, 143, '2015-01-01 00:58:11.000000', 'temperatura', 376.0000, 'ºC'),
	(295886, 143, '2015-01-01 00:58:12.000000', 'temperatura', 256.0000, 'ºC'),
	(295887, 143, '2015-01-01 00:58:13.000000', 'temperatura', 153.0000, 'ºC'),
	(295888, 143, '2015-01-01 00:58:14.000000', 'temperatura', 1199.0000, 'ºC'),
	(295889, 143, '2015-01-01 00:58:15.000000', 'temperatura', 736.0000, 'ºC'),
	(295890, 143, '2015-01-01 00:58:16.000000', 'temperatura', 82.0000, 'ºC'),
	(295891, 143, '2015-01-01 00:58:17.000000', 'temperatura', 604.0000, 'ºC'),
	(295892, 143, '2015-01-01 00:58:18.000000', 'temperatura', 375.0000, 'ºC'),
	(295893, 143, '2015-01-01 00:58:19.000000', 'temperatura', 62.0000, 'ºC'),
	(295894, 143, '2015-01-01 00:58:20.000000', 'temperatura', 385.0000, 'ºC'),
	(295895, 143, '2015-01-01 00:58:21.000000', 'temperatura', 540.0000, 'ºC'),
	(295896, 143, '2015-01-01 00:58:22.000000', 'temperatura', 344.0000, 'ºC'),
	(295897, 143, '2015-01-01 00:58:23.000000', 'temperatura', 101.0000, 'ºC'),
	(295898, 143, '2015-01-01 00:58:24.000000', 'temperatura', 673.0000, 'ºC'),
	(295899, 143, '2015-01-01 00:58:25.000000', 'temperatura', 662.0000, 'ºC'),
	(295900, 143, '2015-01-01 00:58:26.000000', 'temperatura', 92.0000, 'ºC'),
	(295901, 143, '2015-01-01 00:58:27.000000', 'temperatura', 875.0000, 'ºC'),
	(295902, 143, '2015-01-01 00:58:28.000000', 'temperatura', 498.0000, 'ºC'),
	(295903, 143, '2015-01-01 00:58:29.000000', 'temperatura', 1067.0000, 'ºC'),
	(295904, 143, '2015-01-01 00:58:30.000000', 'temperatura', 239.0000, 'ºC'),
	(295905, 143, '2015-01-01 00:58:31.000000', 'temperatura', 396.0000, 'ºC'),
	(295906, 143, '2015-01-01 00:58:32.000000', 'temperatura', 64.0000, 'ºC'),
	(295907, 143, '2015-01-01 00:58:33.000000', 'temperatura', 334.0000, 'ºC'),
	(295908, 143, '2015-01-01 00:58:34.000000', 'temperatura', 276.0000, 'ºC'),
	(295909, 143, '2015-01-01 00:58:35.000000', 'temperatura', 379.0000, 'ºC'),
	(295910, 143, '2015-01-01 00:58:36.000000', 'temperatura', 1066.0000, 'ºC'),
	(295911, 143, '2015-01-01 00:58:37.000000', 'temperatura', 594.0000, 'ºC'),
	(295912, 143, '2015-01-01 00:58:38.000000', 'temperatura', 972.0000, 'ºC'),
	(295913, 143, '2015-01-01 00:58:39.000000', 'temperatura', 679.0000, 'ºC'),
	(295914, 143, '2015-01-01 00:58:40.000000', 'temperatura', 482.0000, 'ºC'),
	(295915, 143, '2015-01-01 00:58:41.000000', 'temperatura', 370.0000, 'ºC'),
	(295916, 143, '2015-01-01 00:58:42.000000', 'temperatura', 408.0000, 'ºC'),
	(295917, 143, '2015-01-01 00:58:43.000000', 'temperatura', 928.0000, 'ºC'),
	(295918, 143, '2015-01-01 00:58:44.000000', 'temperatura', 1019.0000, 'ºC'),
	(295919, 143, '2015-01-01 00:58:45.000000', 'temperatura', 1111.0000, 'ºC'),
	(295920, 143, '2015-01-01 00:58:46.000000', 'temperatura', 100.0000, 'ºC'),
	(295921, 143, '2015-01-01 00:58:47.000000', 'temperatura', 766.0000, 'ºC'),
	(295922, 143, '2015-01-01 00:58:48.000000', 'temperatura', 1132.0000, 'ºC'),
	(295923, 143, '2015-01-01 00:58:49.000000', 'temperatura', 961.0000, 'ºC'),
	(295924, 143, '2015-01-01 00:58:50.000000', 'temperatura', 208.0000, 'ºC'),
	(295925, 143, '2015-01-01 00:58:51.000000', 'temperatura', 559.0000, 'ºC'),
	(295926, 143, '2015-01-01 00:58:52.000000', 'temperatura', 970.0000, 'ºC'),
	(295927, 143, '2015-01-01 00:58:53.000000', 'temperatura', 773.0000, 'ºC'),
	(295928, 143, '2015-01-01 00:58:54.000000', 'temperatura', 957.0000, 'ºC'),
	(295929, 143, '2015-01-01 00:58:55.000000', 'temperatura', 66.0000, 'ºC'),
	(295930, 143, '2015-01-01 00:58:56.000000', 'temperatura', 1061.0000, 'ºC'),
	(295931, 143, '2015-01-01 00:58:57.000000', 'temperatura', 305.0000, 'ºC'),
	(295932, 143, '2015-01-01 00:58:58.000000', 'temperatura', 743.0000, 'ºC'),
	(295933, 143, '2015-01-01 00:58:59.000000', 'temperatura', 402.0000, 'ºC'),
	(295934, 143, '2015-01-01 00:59:00.000000', 'temperatura', 982.0000, 'ºC'),
	(295935, 143, '2015-01-01 00:59:01.000000', 'temperatura', 105.0000, 'ºC'),
	(295936, 143, '2015-01-01 00:59:02.000000', 'temperatura', 1181.0000, 'ºC'),
	(295937, 143, '2015-01-01 00:59:03.000000', 'temperatura', 787.0000, 'ºC'),
	(295938, 143, '2015-01-01 00:59:04.000000', 'temperatura', 394.0000, 'ºC'),
	(295939, 143, '2015-01-01 00:59:05.000000', 'temperatura', 809.0000, 'ºC'),
	(295940, 143, '2015-01-01 00:59:06.000000', 'temperatura', 465.0000, 'ºC'),
	(295941, 143, '2015-01-01 00:59:07.000000', 'temperatura', 1099.0000, 'ºC'),
	(295942, 143, '2015-01-01 00:59:08.000000', 'temperatura', 498.0000, 'ºC'),
	(295943, 143, '2015-01-01 00:59:09.000000', 'temperatura', 395.0000, 'ºC'),
	(295944, 143, '2015-01-01 00:59:10.000000', 'temperatura', 481.0000, 'ºC'),
	(295945, 143, '2015-01-01 00:59:11.000000', 'temperatura', 20.0000, 'ºC'),
	(295946, 143, '2015-01-01 00:59:12.000000', 'temperatura', 1057.0000, 'ºC'),
	(295947, 143, '2015-01-01 00:59:13.000000', 'temperatura', 426.0000, 'ºC'),
	(295948, 143, '2015-01-01 00:59:14.000000', 'temperatura', 161.0000, 'ºC'),
	(295949, 143, '2015-01-01 00:59:15.000000', 'temperatura', 725.0000, 'ºC'),
	(295950, 143, '2015-01-01 00:59:16.000000', 'temperatura', 742.0000, 'ºC'),
	(295951, 143, '2015-01-01 00:59:17.000000', 'temperatura', 335.0000, 'ºC'),
	(295952, 143, '2015-01-01 00:59:18.000000', 'temperatura', 651.0000, 'ºC'),
	(295953, 143, '2015-01-01 00:59:19.000000', 'temperatura', 1050.0000, 'ºC'),
	(295954, 143, '2015-01-01 00:59:20.000000', 'temperatura', 897.0000, 'ºC'),
	(295955, 143, '2015-01-01 00:59:21.000000', 'temperatura', 136.0000, 'ºC'),
	(295956, 143, '2015-01-01 00:59:22.000000', 'temperatura', 387.0000, 'ºC'),
	(295957, 143, '2015-01-01 00:59:23.000000', 'temperatura', 331.0000, 'ºC'),
	(295958, 143, '2015-01-01 00:59:24.000000', 'temperatura', 493.0000, 'ºC'),
	(295959, 143, '2015-01-01 00:59:25.000000', 'temperatura', 273.0000, 'ºC'),
	(295960, 143, '2015-01-01 00:59:26.000000', 'temperatura', 1087.0000, 'ºC'),
	(295961, 143, '2015-01-01 00:59:27.000000', 'temperatura', 1015.0000, 'ºC'),
	(295962, 143, '2015-01-01 00:59:28.000000', 'temperatura', 616.0000, 'ºC'),
	(295963, 143, '2015-01-01 00:59:29.000000', 'temperatura', 36.0000, 'ºC'),
	(295964, 143, '2015-01-01 00:59:30.000000', 'temperatura', 731.0000, 'ºC'),
	(295965, 143, '2015-01-01 00:59:31.000000', 'temperatura', 1148.0000, 'ºC'),
	(295966, 143, '2015-01-01 00:59:32.000000', 'temperatura', 1149.0000, 'ºC'),
	(295967, 143, '2015-01-01 00:59:33.000000', 'temperatura', 1101.0000, 'ºC'),
	(295968, 143, '2015-01-01 00:59:34.000000', 'temperatura', 857.0000, 'ºC'),
	(295969, 143, '2015-01-01 00:59:35.000000', 'temperatura', 984.0000, 'ºC'),
	(295970, 143, '2015-01-01 00:59:36.000000', 'temperatura', 1151.0000, 'ºC'),
	(295971, 143, '2015-01-01 00:59:37.000000', 'temperatura', 403.0000, 'ºC'),
	(295972, 143, '2015-01-01 00:59:38.000000', 'temperatura', 960.0000, 'ºC'),
	(295973, 143, '2015-01-01 00:59:39.000000', 'temperatura', 1192.0000, 'ºC'),
	(295974, 143, '2015-01-01 00:59:40.000000', 'temperatura', 681.0000, 'ºC'),
	(295975, 143, '2015-01-01 00:59:41.000000', 'temperatura', 1028.0000, 'ºC'),
	(295976, 143, '2015-01-01 00:59:42.000000', 'temperatura', 700.0000, 'ºC'),
	(295977, 143, '2015-01-01 00:59:43.000000', 'temperatura', 417.0000, 'ºC'),
	(295978, 143, '2015-01-01 00:59:44.000000', 'temperatura', 1184.0000, 'ºC'),
	(295979, 143, '2015-01-01 00:59:45.000000', 'temperatura', 1072.0000, 'ºC'),
	(295980, 143, '2015-01-01 00:59:46.000000', 'temperatura', 606.0000, 'ºC'),
	(295981, 143, '2015-01-01 00:59:47.000000', 'temperatura', 1014.0000, 'ºC'),
	(295982, 143, '2015-01-01 00:59:48.000000', 'temperatura', 854.0000, 'ºC'),
	(295983, 143, '2015-01-01 00:59:49.000000', 'temperatura', 30.0000, 'ºC'),
	(295984, 143, '2015-01-01 00:59:50.000000', 'temperatura', 1186.0000, 'ºC'),
	(295985, 143, '2015-01-01 00:59:51.000000', 'temperatura', 1042.0000, 'ºC'),
	(295986, 143, '2015-01-01 00:59:52.000000', 'temperatura', 452.0000, 'ºC'),
	(295987, 143, '2015-01-01 00:59:53.000000', 'temperatura', 336.0000, 'ºC'),
	(295988, 143, '2015-01-01 00:59:54.000000', 'temperatura', 325.0000, 'ºC'),
	(295989, 143, '2015-01-01 00:59:55.000000', 'temperatura', 614.0000, 'ºC'),
	(295990, 143, '2015-01-01 00:59:56.000000', 'temperatura', 899.0000, 'ºC'),
	(295991, 143, '2015-01-01 00:59:57.000000', 'temperatura', 253.0000, 'ºC'),
	(295992, 143, '2015-01-01 00:59:58.000000', 'temperatura', 967.0000, 'ºC'),
	(295993, 143, '2015-01-01 00:59:59.000000', 'temperatura', 479.0000, 'ºC'),
	(295994, 143, '2015-01-01 01:00:00.000000', 'temperatura', 693.0000, 'ºC'),
	(295995, 143, '2015-01-01 01:00:01.000000', 'temperatura', 827.0000, 'ºC'),
	(295996, 143, '2015-01-01 01:00:02.000000', 'temperatura', 857.0000, 'ºC'),
	(295997, 143, '2015-01-01 01:00:03.000000', 'temperatura', 607.0000, 'ºC'),
	(295998, 143, '2015-01-01 01:00:04.000000', 'temperatura', 464.0000, 'ºC'),
	(295999, 143, '2015-01-01 01:00:05.000000', 'temperatura', 497.0000, 'ºC'),
	(296000, 143, '2015-01-01 01:00:06.000000', 'temperatura', 1094.0000, 'ºC'),
	(296001, 143, '2015-01-01 01:00:07.000000', 'temperatura', 380.0000, 'ºC'),
	(296002, 143, '2015-01-01 01:00:08.000000', 'temperatura', 1018.0000, 'ºC'),
	(296003, 143, '2015-01-01 01:00:09.000000', 'temperatura', 353.0000, 'ºC'),
	(296004, 143, '2015-01-01 01:00:10.000000', 'temperatura', 1108.0000, 'ºC'),
	(296005, 143, '2015-01-01 01:00:11.000000', 'temperatura', 884.0000, 'ºC'),
	(296006, 143, '2015-01-01 01:00:12.000000', 'temperatura', 1094.0000, 'ºC'),
	(296007, 143, '2015-01-01 01:00:13.000000', 'temperatura', 418.0000, 'ºC'),
	(296008, 143, '2015-01-01 01:00:14.000000', 'temperatura', 12.0000, 'ºC'),
	(296009, 143, '2015-01-01 01:00:15.000000', 'temperatura', 3.0000, 'ºC'),
	(296010, 143, '2015-01-01 01:00:16.000000', 'temperatura', 1180.0000, 'ºC'),
	(296011, 143, '2015-01-01 01:00:17.000000', 'temperatura', 1091.0000, 'ºC'),
	(296012, 143, '2015-01-01 01:00:18.000000', 'temperatura', 718.0000, 'ºC'),
	(296013, 143, '2015-01-01 01:00:19.000000', 'temperatura', 318.0000, 'ºC'),
	(296014, 143, '2015-01-01 01:00:20.000000', 'temperatura', 635.0000, 'ºC'),
	(296015, 143, '2015-01-01 01:00:21.000000', 'temperatura', 1023.0000, 'ºC'),
	(296016, 143, '2015-01-01 01:00:22.000000', 'temperatura', 808.0000, 'ºC'),
	(296017, 143, '2015-01-01 01:00:23.000000', 'temperatura', 971.0000, 'ºC'),
	(296018, 143, '2015-01-01 01:00:24.000000', 'temperatura', 31.0000, 'ºC'),
	(296019, 143, '2015-01-01 01:00:25.000000', 'temperatura', 845.0000, 'ºC'),
	(296020, 143, '2015-01-01 01:00:26.000000', 'temperatura', 531.0000, 'ºC'),
	(296021, 143, '2015-01-01 01:00:27.000000', 'temperatura', 122.0000, 'ºC'),
	(296022, 143, '2015-01-01 01:00:28.000000', 'temperatura', 217.0000, 'ºC'),
	(296023, 143, '2015-01-01 01:00:29.000000', 'temperatura', 717.0000, 'ºC'),
	(296024, 143, '2015-01-01 01:00:30.000000', 'temperatura', 537.0000, 'ºC'),
	(296025, 143, '2015-01-01 01:00:31.000000', 'temperatura', 534.0000, 'ºC'),
	(296026, 143, '2015-01-01 01:00:32.000000', 'temperatura', 1061.0000, 'ºC'),
	(296027, 143, '2015-01-01 01:00:33.000000', 'temperatura', 102.0000, 'ºC'),
	(296028, 143, '2015-01-01 01:00:34.000000', 'temperatura', 929.0000, 'ºC'),
	(296029, 143, '2015-01-01 01:00:35.000000', 'temperatura', 741.0000, 'ºC'),
	(296030, 143, '2015-01-01 01:00:36.000000', 'temperatura', 915.0000, 'ºC'),
	(296031, 143, '2015-01-01 01:00:37.000000', 'temperatura', 1154.0000, 'ºC'),
	(296032, 143, '2015-01-01 01:00:38.000000', 'temperatura', 625.0000, 'ºC'),
	(296033, 143, '2015-01-01 01:00:39.000000', 'temperatura', 863.0000, 'ºC'),
	(296034, 143, '2015-01-01 01:00:40.000000', 'temperatura', 43.0000, 'ºC'),
	(296035, 143, '2015-01-01 01:00:41.000000', 'temperatura', 24.0000, 'ºC'),
	(296036, 143, '2015-01-01 01:00:42.000000', 'temperatura', 1192.0000, 'ºC'),
	(296037, 143, '2015-01-01 01:00:43.000000', 'temperatura', 1090.0000, 'ºC'),
	(296038, 143, '2015-01-01 01:00:44.000000', 'temperatura', 673.0000, 'ºC'),
	(296039, 143, '2015-01-01 01:00:45.000000', 'temperatura', 97.0000, 'ºC'),
	(296040, 143, '2015-01-01 01:00:46.000000', 'temperatura', 868.0000, 'ºC'),
	(296041, 143, '2015-01-01 01:00:47.000000', 'temperatura', 446.0000, 'ºC'),
	(296042, 143, '2015-01-01 01:00:48.000000', 'temperatura', 827.0000, 'ºC'),
	(296043, 143, '2015-01-01 01:00:49.000000', 'temperatura', 399.0000, 'ºC'),
	(296044, 143, '2015-01-01 01:00:50.000000', 'temperatura', 715.0000, 'ºC'),
	(296045, 143, '2015-01-01 01:00:51.000000', 'temperatura', 1176.0000, 'ºC'),
	(296046, 143, '2015-01-01 01:00:52.000000', 'temperatura', 138.0000, 'ºC'),
	(296047, 143, '2015-01-01 01:00:53.000000', 'temperatura', 762.0000, 'ºC'),
	(296048, 143, '2015-01-01 01:00:54.000000', 'temperatura', 998.0000, 'ºC'),
	(296049, 143, '2015-01-01 01:00:55.000000', 'temperatura', 302.0000, 'ºC'),
	(296050, 143, '2015-01-01 01:00:56.000000', 'temperatura', 919.0000, 'ºC'),
	(296051, 143, '2015-01-01 01:00:57.000000', 'temperatura', 87.0000, 'ºC'),
	(296052, 143, '2015-01-01 01:00:58.000000', 'temperatura', 80.0000, 'ºC'),
	(296053, 143, '2015-01-01 01:00:59.000000', 'temperatura', 138.0000, 'ºC'),
	(296054, 143, '2015-01-01 01:01:00.000000', 'temperatura', 453.0000, 'ºC'),
	(296055, 143, '2015-01-01 01:01:01.000000', 'temperatura', 650.0000, 'ºC'),
	(296056, 143, '2015-01-01 01:01:02.000000', 'temperatura', 692.0000, 'ºC'),
	(296057, 143, '2015-01-01 01:01:03.000000', 'temperatura', 309.0000, 'ºC'),
	(296058, 143, '2015-01-01 01:01:04.000000', 'temperatura', 672.0000, 'ºC'),
	(296059, 143, '2015-01-01 01:01:05.000000', 'temperatura', 32.0000, 'ºC'),
	(296060, 143, '2015-01-01 01:01:06.000000', 'temperatura', 545.0000, 'ºC'),
	(296061, 143, '2015-01-01 01:01:07.000000', 'temperatura', 229.0000, 'ºC'),
	(296062, 143, '2015-01-01 01:01:08.000000', 'temperatura', 712.0000, 'ºC'),
	(296063, 143, '2015-01-01 01:01:09.000000', 'temperatura', 472.0000, 'ºC'),
	(296064, 143, '2015-01-01 01:01:10.000000', 'temperatura', 226.0000, 'ºC'),
	(296065, 143, '2015-01-01 01:01:11.000000', 'temperatura', 914.0000, 'ºC'),
	(296066, 143, '2015-01-01 01:01:12.000000', 'temperatura', 291.0000, 'ºC'),
	(296067, 143, '2015-01-01 01:01:13.000000', 'temperatura', 1116.0000, 'ºC'),
	(296068, 143, '2015-01-01 01:01:14.000000', 'temperatura', 1105.0000, 'ºC'),
	(296069, 143, '2015-01-01 01:01:15.000000', 'temperatura', 979.0000, 'ºC'),
	(296070, 143, '2015-01-01 01:01:16.000000', 'temperatura', 382.0000, 'ºC'),
	(296071, 143, '2015-01-01 01:01:17.000000', 'temperatura', 172.0000, 'ºC'),
	(296072, 143, '2015-01-01 01:01:18.000000', 'temperatura', 916.0000, 'ºC'),
	(296073, 143, '2015-01-01 01:01:19.000000', 'temperatura', 462.0000, 'ºC'),
	(296074, 143, '2015-01-01 01:01:20.000000', 'temperatura', 763.0000, 'ºC'),
	(296075, 143, '2015-01-01 01:01:21.000000', 'temperatura', 29.0000, 'ºC'),
	(296076, 143, '2015-01-01 01:01:22.000000', 'temperatura', 256.0000, 'ºC'),
	(296077, 143, '2015-01-01 01:01:23.000000', 'temperatura', 1193.0000, 'ºC'),
	(296078, 143, '2015-01-01 01:01:24.000000', 'temperatura', 400.0000, 'ºC'),
	(296079, 143, '2015-01-01 01:01:25.000000', 'temperatura', 819.0000, 'ºC'),
	(296080, 143, '2015-01-01 01:01:26.000000', 'temperatura', 495.0000, 'ºC'),
	(296081, 143, '2015-01-01 01:01:27.000000', 'temperatura', 21.0000, 'ºC'),
	(296082, 143, '2015-01-01 01:01:28.000000', 'temperatura', 1020.0000, 'ºC'),
	(296083, 143, '2015-01-01 01:01:29.000000', 'temperatura', 237.0000, 'ºC'),
	(296084, 143, '2015-01-01 01:01:30.000000', 'temperatura', 528.0000, 'ºC'),
	(296085, 143, '2015-01-01 01:01:31.000000', 'temperatura', 726.0000, 'ºC'),
	(296086, 143, '2015-01-01 01:01:32.000000', 'temperatura', 850.0000, 'ºC'),
	(296087, 143, '2015-01-01 01:01:33.000000', 'temperatura', 869.0000, 'ºC'),
	(296088, 143, '2015-01-01 01:01:34.000000', 'temperatura', 598.0000, 'ºC'),
	(296089, 143, '2015-01-01 01:01:35.000000', 'temperatura', 381.0000, 'ºC'),
	(296090, 143, '2015-01-01 01:01:36.000000', 'temperatura', 114.0000, 'ºC'),
	(296091, 143, '2015-01-01 01:01:37.000000', 'temperatura', 629.0000, 'ºC'),
	(296092, 143, '2015-01-01 01:01:38.000000', 'temperatura', 400.0000, 'ºC'),
	(296093, 143, '2015-01-01 01:01:39.000000', 'temperatura', 117.0000, 'ºC'),
	(296094, 143, '2015-01-01 01:01:40.000000', 'temperatura', 582.0000, 'ºC'),
	(296095, 143, '2015-01-01 01:01:41.000000', 'temperatura', 163.0000, 'ºC'),
	(296096, 143, '2015-01-01 01:01:42.000000', 'temperatura', 267.0000, 'ºC'),
	(296097, 143, '2015-01-01 01:01:43.000000', 'temperatura', 849.0000, 'ºC'),
	(296098, 143, '2015-01-01 01:01:44.000000', 'temperatura', 1042.0000, 'ºC'),
	(296099, 143, '2015-01-01 01:01:45.000000', 'temperatura', 266.0000, 'ºC'),
	(296100, 143, '2015-01-01 01:01:46.000000', 'temperatura', 603.0000, 'ºC'),
	(296101, 143, '2015-01-01 01:01:47.000000', 'temperatura', 1019.0000, 'ºC'),
	(296102, 143, '2015-01-01 01:01:48.000000', 'temperatura', 885.0000, 'ºC'),
	(296103, 143, '2015-01-01 01:01:49.000000', 'temperatura', 169.0000, 'ºC'),
	(296104, 143, '2015-01-01 01:01:50.000000', 'temperatura', 588.0000, 'ºC'),
	(296105, 143, '2015-01-01 01:01:51.000000', 'temperatura', 37.0000, 'ºC'),
	(296106, 143, '2015-01-01 01:01:52.000000', 'temperatura', 820.0000, 'ºC'),
	(296107, 143, '2015-01-01 01:01:53.000000', 'temperatura', 388.0000, 'ºC'),
	(296108, 143, '2015-01-01 01:01:54.000000', 'temperatura', 681.0000, 'ºC'),
	(296109, 143, '2015-01-01 01:01:55.000000', 'temperatura', 1041.0000, 'ºC'),
	(296110, 143, '2015-01-01 01:01:56.000000', 'temperatura', 765.0000, 'ºC'),
	(296111, 143, '2015-01-01 01:01:57.000000', 'temperatura', 700.0000, 'ºC'),
	(296112, 143, '2015-01-01 01:01:58.000000', 'temperatura', 7.0000, 'ºC'),
	(296113, 143, '2015-01-01 01:01:59.000000', 'temperatura', 335.0000, 'ºC'),
	(296114, 143, '2015-01-01 01:02:00.000000', 'temperatura', 456.0000, 'ºC'),
	(296115, 143, '2015-01-01 01:02:01.000000', 'temperatura', 74.0000, 'ºC'),
	(296116, 143, '2015-01-01 01:02:02.000000', 'temperatura', 204.0000, 'ºC'),
	(296117, 143, '2015-01-01 01:02:03.000000', 'temperatura', 796.0000, 'ºC'),
	(296118, 143, '2015-01-01 01:02:04.000000', 'temperatura', 971.0000, 'ºC'),
	(296119, 143, '2015-01-01 01:02:05.000000', 'temperatura', 68.0000, 'ºC'),
	(296120, 143, '2015-01-01 01:02:06.000000', 'temperatura', 1028.0000, 'ºC'),
	(296121, 143, '2015-01-01 01:02:07.000000', 'temperatura', 134.0000, 'ºC'),
	(296122, 143, '2015-01-01 01:02:08.000000', 'temperatura', 1187.0000, 'ºC'),
	(296123, 143, '2015-01-01 01:02:09.000000', 'temperatura', 733.0000, 'ºC'),
	(296124, 143, '2015-01-01 01:02:10.000000', 'temperatura', 105.0000, 'ºC'),
	(296125, 143, '2015-01-01 01:02:11.000000', 'temperatura', 724.0000, 'ºC'),
	(296126, 143, '2015-01-01 01:02:12.000000', 'temperatura', 909.0000, 'ºC'),
	(296127, 143, '2015-01-01 01:02:13.000000', 'temperatura', 1174.0000, 'ºC'),
	(296128, 143, '2015-01-01 01:02:14.000000', 'temperatura', 742.0000, 'ºC'),
	(296129, 143, '2015-01-01 01:02:15.000000', 'temperatura', 190.0000, 'ºC'),
	(296130, 143, '2015-01-01 01:02:16.000000', 'temperatura', 1125.0000, 'ºC'),
	(296131, 143, '2015-01-01 01:02:17.000000', 'temperatura', 253.0000, 'ºC'),
	(296132, 143, '2015-01-01 01:02:18.000000', 'temperatura', 292.0000, 'ºC'),
	(296133, 143, '2015-01-01 01:02:19.000000', 'temperatura', 702.0000, 'ºC'),
	(296134, 143, '2015-01-01 01:02:20.000000', 'temperatura', 234.0000, 'ºC'),
	(296135, 143, '2015-01-01 01:02:21.000000', 'temperatura', 264.0000, 'ºC'),
	(296136, 143, '2015-01-01 01:02:22.000000', 'temperatura', 620.0000, 'ºC'),
	(296137, 143, '2015-01-01 01:02:23.000000', 'temperatura', 1107.0000, 'ºC'),
	(296138, 143, '2015-01-01 01:02:24.000000', 'temperatura', 76.0000, 'ºC'),
	(296139, 143, '2015-01-01 01:02:25.000000', 'temperatura', 658.0000, 'ºC'),
	(296140, 143, '2015-01-01 01:02:26.000000', 'temperatura', 662.0000, 'ºC'),
	(296141, 143, '2015-01-01 01:02:27.000000', 'temperatura', 139.0000, 'ºC'),
	(296142, 143, '2015-01-01 01:02:28.000000', 'temperatura', 1110.0000, 'ºC'),
	(296143, 143, '2015-01-01 01:02:29.000000', 'temperatura', 333.0000, 'ºC'),
	(296144, 143, '2015-01-01 01:02:30.000000', 'temperatura', 736.0000, 'ºC'),
	(296145, 143, '2015-01-01 01:02:31.000000', 'temperatura', 282.0000, 'ºC'),
	(296146, 143, '2015-01-01 01:02:32.000000', 'temperatura', 401.0000, 'ºC'),
	(296147, 143, '2015-01-01 01:02:33.000000', 'temperatura', 1160.0000, 'ºC'),
	(296148, 143, '2015-01-01 01:02:34.000000', 'temperatura', 998.0000, 'ºC'),
	(296149, 143, '2015-01-01 01:02:35.000000', 'temperatura', 309.0000, 'ºC'),
	(296150, 143, '2015-01-01 01:02:36.000000', 'temperatura', 950.0000, 'ºC'),
	(296151, 143, '2015-01-01 01:02:37.000000', 'temperatura', 226.0000, 'ºC'),
	(296152, 143, '2015-01-01 01:02:38.000000', 'temperatura', 680.0000, 'ºC'),
	(296153, 143, '2015-01-01 01:02:39.000000', 'temperatura', 323.0000, 'ºC'),
	(296154, 143, '2015-01-01 01:02:40.000000', 'temperatura', 777.0000, 'ºC'),
	(296155, 143, '2015-01-01 01:02:41.000000', 'temperatura', 516.0000, 'ºC'),
	(296156, 143, '2015-01-01 01:02:42.000000', 'temperatura', 249.0000, 'ºC'),
	(296157, 143, '2015-01-01 01:02:43.000000', 'temperatura', 899.0000, 'ºC'),
	(296158, 143, '2015-01-01 01:02:44.000000', 'temperatura', 149.0000, 'ºC'),
	(296159, 143, '2015-01-01 01:02:45.000000', 'temperatura', 449.0000, 'ºC'),
	(296160, 143, '2015-01-01 01:02:46.000000', 'temperatura', 597.0000, 'ºC'),
	(296161, 143, '2015-01-01 01:02:47.000000', 'temperatura', 440.0000, 'ºC'),
	(296162, 143, '2015-01-01 01:02:48.000000', 'temperatura', 411.0000, 'ºC'),
	(296163, 143, '2015-01-01 01:02:49.000000', 'temperatura', 733.0000, 'ºC'),
	(296164, 143, '2015-01-01 01:02:50.000000', 'temperatura', 32.0000, 'ºC'),
	(296165, 143, '2015-01-01 01:02:51.000000', 'temperatura', 362.0000, 'ºC'),
	(296166, 143, '2015-01-01 01:02:52.000000', 'temperatura', 513.0000, 'ºC'),
	(296167, 143, '2015-01-01 01:02:53.000000', 'temperatura', 281.0000, 'ºC'),
	(296168, 143, '2015-01-01 01:02:54.000000', 'temperatura', 1067.0000, 'ºC'),
	(296169, 143, '2015-01-01 01:02:55.000000', 'temperatura', 892.0000, 'ºC'),
	(296170, 143, '2015-01-01 01:02:56.000000', 'temperatura', 57.0000, 'ºC'),
	(296171, 143, '2015-01-01 01:02:57.000000', 'temperatura', 13.0000, 'ºC'),
	(296172, 143, '2015-01-01 01:02:58.000000', 'temperatura', 1093.0000, 'ºC'),
	(296173, 143, '2015-01-01 01:02:59.000000', 'temperatura', 628.0000, 'ºC'),
	(296174, 143, '2015-01-01 01:03:00.000000', 'temperatura', 1060.0000, 'ºC'),
	(296175, 143, '2015-01-01 01:03:01.000000', 'temperatura', 1018.0000, 'ºC'),
	(296176, 143, '2015-01-01 01:03:02.000000', 'temperatura', 711.0000, 'ºC'),
	(296177, 143, '2015-01-01 01:03:03.000000', 'temperatura', 500.0000, 'ºC'),
	(296178, 143, '2015-01-01 01:03:04.000000', 'temperatura', 367.0000, 'ºC'),
	(296179, 143, '2015-01-01 01:03:05.000000', 'temperatura', 338.0000, 'ºC'),
	(296180, 143, '2015-01-01 01:03:06.000000', 'temperatura', 588.0000, 'ºC'),
	(296181, 143, '2015-01-01 01:03:07.000000', 'temperatura', 727.0000, 'ºC'),
	(296182, 143, '2015-01-01 01:03:08.000000', 'temperatura', 671.0000, 'ºC'),
	(296183, 143, '2015-01-01 01:03:09.000000', 'temperatura', 1173.0000, 'ºC'),
	(296184, 143, '2015-01-01 01:03:10.000000', 'temperatura', 255.0000, 'ºC'),
	(296185, 143, '2015-01-01 01:03:11.000000', 'temperatura', 157.0000, 'ºC'),
	(296186, 143, '2015-01-01 01:03:12.000000', 'temperatura', 20.0000, 'ºC'),
	(296187, 143, '2015-01-01 01:03:13.000000', 'temperatura', 827.0000, 'ºC'),
	(296188, 143, '2015-01-01 01:03:14.000000', 'temperatura', 477.0000, 'ºC'),
	(296189, 143, '2015-01-01 01:03:15.000000', 'temperatura', 1106.0000, 'ºC'),
	(296190, 143, '2015-01-01 01:03:16.000000', 'temperatura', 498.0000, 'ºC'),
	(296191, 143, '2015-01-01 01:03:17.000000', 'temperatura', 371.0000, 'ºC'),
	(296192, 143, '2015-01-01 01:03:18.000000', 'temperatura', 364.0000, 'ºC'),
	(296193, 143, '2015-01-01 01:03:19.000000', 'temperatura', 705.0000, 'ºC'),
	(296194, 143, '2015-01-01 01:03:20.000000', 'temperatura', 36.0000, 'ºC'),
	(296195, 143, '2015-01-01 01:03:21.000000', 'temperatura', 463.0000, 'ºC'),
	(296196, 143, '2015-01-01 01:03:22.000000', 'temperatura', 1007.0000, 'ºC'),
	(296197, 143, '2015-01-01 01:03:23.000000', 'temperatura', 47.0000, 'ºC'),
	(296198, 143, '2015-01-01 01:03:24.000000', 'temperatura', 815.0000, 'ºC'),
	(296199, 143, '2015-01-01 01:03:25.000000', 'temperatura', 336.0000, 'ºC'),
	(296200, 143, '2015-01-01 01:03:26.000000', 'temperatura', 436.0000, 'ºC'),
	(296201, 143, '2015-01-01 01:03:27.000000', 'temperatura', 1171.0000, 'ºC'),
	(296202, 143, '2015-01-01 01:03:28.000000', 'temperatura', 948.0000, 'ºC'),
	(296203, 143, '2015-01-01 01:03:29.000000', 'temperatura', 28.0000, 'ºC'),
	(296204, 143, '2015-01-01 01:03:30.000000', 'temperatura', 894.0000, 'ºC'),
	(296205, 143, '2015-01-01 01:03:31.000000', 'temperatura', 789.0000, 'ºC'),
	(296206, 143, '2015-01-01 01:03:32.000000', 'temperatura', 64.0000, 'ºC'),
	(296207, 143, '2015-01-01 01:03:33.000000', 'temperatura', 352.0000, 'ºC'),
	(296208, 143, '2015-01-01 01:03:34.000000', 'temperatura', 371.0000, 'ºC'),
	(296209, 143, '2015-01-01 01:03:35.000000', 'temperatura', 796.0000, 'ºC'),
	(296210, 143, '2015-01-01 01:03:36.000000', 'temperatura', 469.0000, 'ºC'),
	(296211, 143, '2015-01-01 01:03:37.000000', 'temperatura', 1158.0000, 'ºC'),
	(296212, 143, '2015-01-01 01:03:38.000000', 'temperatura', 785.0000, 'ºC'),
	(296213, 143, '2015-01-01 01:03:39.000000', 'temperatura', 449.0000, 'ºC'),
	(296214, 143, '2015-01-01 01:03:40.000000', 'temperatura', 1090.0000, 'ºC'),
	(296215, 143, '2015-01-01 01:03:41.000000', 'temperatura', 506.0000, 'ºC'),
	(296216, 143, '2015-01-01 01:03:42.000000', 'temperatura', 460.0000, 'ºC'),
	(296217, 143, '2015-01-01 01:03:43.000000', 'temperatura', 783.0000, 'ºC'),
	(296218, 143, '2015-01-01 01:03:44.000000', 'temperatura', 137.0000, 'ºC'),
	(296219, 143, '2015-01-01 01:03:45.000000', 'temperatura', 733.0000, 'ºC'),
	(296220, 143, '2015-01-01 01:03:46.000000', 'temperatura', 856.0000, 'ºC'),
	(296221, 143, '2015-01-01 01:03:47.000000', 'temperatura', 884.0000, 'ºC'),
	(296222, 143, '2015-01-01 01:03:48.000000', 'temperatura', 649.0000, 'ºC'),
	(296223, 143, '2015-01-01 01:03:49.000000', 'temperatura', 594.0000, 'ºC'),
	(296224, 143, '2015-01-01 01:03:50.000000', 'temperatura', 1024.0000, 'ºC'),
	(296225, 143, '2015-01-01 01:03:51.000000', 'temperatura', 937.0000, 'ºC'),
	(296226, 143, '2015-01-01 01:03:52.000000', 'temperatura', 414.0000, 'ºC'),
	(296227, 143, '2015-01-01 01:03:53.000000', 'temperatura', 461.0000, 'ºC'),
	(296228, 143, '2015-01-01 01:03:54.000000', 'temperatura', 1064.0000, 'ºC'),
	(296229, 143, '2015-01-01 01:03:55.000000', 'temperatura', 337.0000, 'ºC'),
	(296230, 143, '2015-01-01 01:03:56.000000', 'temperatura', 892.0000, 'ºC'),
	(296231, 143, '2015-01-01 01:03:57.000000', 'temperatura', 1048.0000, 'ºC'),
	(296232, 143, '2015-01-01 01:03:58.000000', 'temperatura', 167.0000, 'ºC'),
	(296233, 143, '2015-01-01 01:03:59.000000', 'temperatura', 92.0000, 'ºC'),
	(296234, 143, '2015-01-01 01:04:00.000000', 'temperatura', 1159.0000, 'ºC'),
	(296235, 143, '2015-01-01 01:04:01.000000', 'temperatura', 720.0000, 'ºC'),
	(296236, 143, '2015-01-01 01:04:02.000000', 'temperatura', 121.0000, 'ºC'),
	(296237, 143, '2015-01-01 01:04:03.000000', 'temperatura', 848.0000, 'ºC'),
	(296238, 143, '2015-01-01 01:04:04.000000', 'temperatura', 277.0000, 'ºC'),
	(296239, 143, '2015-01-01 01:04:05.000000', 'temperatura', 42.0000, 'ºC'),
	(296240, 143, '2015-01-01 01:04:06.000000', 'temperatura', 581.0000, 'ºC'),
	(296241, 143, '2015-01-01 01:04:07.000000', 'temperatura', 377.0000, 'ºC'),
	(296242, 143, '2015-01-01 01:04:08.000000', 'temperatura', 142.0000, 'ºC'),
	(296243, 143, '2015-01-01 01:04:09.000000', 'temperatura', 780.0000, 'ºC'),
	(296244, 143, '2015-01-01 01:04:10.000000', 'temperatura', 1077.0000, 'ºC'),
	(296245, 143, '2015-01-01 01:04:11.000000', 'temperatura', 642.0000, 'ºC'),
	(296246, 143, '2015-01-01 01:04:12.000000', 'temperatura', 1182.0000, 'ºC'),
	(296247, 143, '2015-01-01 01:04:13.000000', 'temperatura', 383.0000, 'ºC'),
	(296248, 143, '2015-01-01 01:04:14.000000', 'temperatura', 771.0000, 'ºC'),
	(296249, 143, '2015-01-01 01:04:15.000000', 'temperatura', 306.0000, 'ºC'),
	(296250, 143, '2015-01-01 01:04:16.000000', 'temperatura', 417.0000, 'ºC'),
	(296251, 143, '2015-01-01 01:04:17.000000', 'temperatura', 1167.0000, 'ºC'),
	(296252, 143, '2015-01-01 01:04:18.000000', 'temperatura', 986.0000, 'ºC'),
	(296253, 143, '2015-01-01 01:04:19.000000', 'temperatura', 227.0000, 'ºC'),
	(296254, 143, '2015-01-01 01:04:20.000000', 'temperatura', 581.0000, 'ºC'),
	(296255, 143, '2015-01-01 01:04:21.000000', 'temperatura', 1022.0000, 'ºC'),
	(296256, 143, '2015-01-01 01:04:22.000000', 'temperatura', 969.0000, 'ºC'),
	(296257, 143, '2015-01-01 01:04:23.000000', 'temperatura', 580.0000, 'ºC'),
	(296258, 143, '2015-01-01 01:04:24.000000', 'temperatura', 1194.0000, 'ºC'),
	(296259, 143, '2015-01-01 01:04:25.000000', 'temperatura', 631.0000, 'ºC'),
	(296260, 143, '2015-01-01 01:04:26.000000', 'temperatura', 774.0000, 'ºC'),
	(296261, 143, '2015-01-01 01:04:27.000000', 'temperatura', 775.0000, 'ºC'),
	(296262, 143, '2015-01-01 01:04:28.000000', 'temperatura', 355.0000, 'ºC'),
	(296263, 143, '2015-01-01 01:04:29.000000', 'temperatura', 651.0000, 'ºC'),
	(296264, 143, '2015-01-01 01:04:30.000000', 'temperatura', 991.0000, 'ºC'),
	(296265, 143, '2015-01-01 01:04:31.000000', 'temperatura', 600.0000, 'ºC'),
	(296266, 143, '2015-01-01 01:04:32.000000', 'temperatura', 29.0000, 'ºC'),
	(296267, 143, '2015-01-01 01:04:33.000000', 'temperatura', 745.0000, 'ºC'),
	(296268, 143, '2015-01-01 01:04:34.000000', 'temperatura', 40.0000, 'ºC'),
	(296269, 143, '2015-01-01 01:04:35.000000', 'temperatura', 363.0000, 'ºC'),
	(296270, 143, '2015-01-01 01:04:36.000000', 'temperatura', 495.0000, 'ºC'),
	(296271, 143, '2015-01-01 01:04:37.000000', 'temperatura', 186.0000, 'ºC'),
	(296272, 143, '2015-01-01 01:04:38.000000', 'temperatura', 646.0000, 'ºC'),
	(296273, 143, '2015-01-01 01:04:39.000000', 'temperatura', 274.0000, 'ºC'),
	(296274, 143, '2015-01-01 01:04:40.000000', 'temperatura', 633.0000, 'ºC'),
	(296275, 143, '2015-01-01 01:04:41.000000', 'temperatura', 1142.0000, 'ºC'),
	(296276, 143, '2015-01-01 01:04:42.000000', 'temperatura', 211.0000, 'ºC'),
	(296277, 143, '2015-01-01 01:04:43.000000', 'temperatura', 32.0000, 'ºC'),
	(296278, 143, '2015-01-01 01:04:44.000000', 'temperatura', 726.0000, 'ºC'),
	(296279, 143, '2015-01-01 01:04:45.000000', 'temperatura', 1133.0000, 'ºC'),
	(296280, 143, '2015-01-01 01:04:46.000000', 'temperatura', 1088.0000, 'ºC'),
	(296281, 143, '2015-01-01 01:04:47.000000', 'temperatura', 842.0000, 'ºC'),
	(296282, 143, '2015-01-01 01:04:48.000000', 'temperatura', 948.0000, 'ºC'),
	(296283, 143, '2015-01-01 01:04:49.000000', 'temperatura', 1015.0000, 'ºC'),
	(296284, 143, '2015-01-01 01:04:50.000000', 'temperatura', 1031.0000, 'ºC'),
	(296285, 143, '2015-01-01 01:04:51.000000', 'temperatura', 908.0000, 'ºC'),
	(296286, 143, '2015-01-01 01:04:52.000000', 'temperatura', 250.0000, 'ºC'),
	(296287, 143, '2015-01-01 01:04:53.000000', 'temperatura', 924.0000, 'ºC'),
	(296288, 143, '2015-01-01 01:04:54.000000', 'temperatura', 273.0000, 'ºC'),
	(296289, 143, '2015-01-01 01:04:55.000000', 'temperatura', 991.0000, 'ºC'),
	(296290, 143, '2015-01-01 01:04:56.000000', 'temperatura', 539.0000, 'ºC'),
	(296291, 143, '2015-01-01 01:04:57.000000', 'temperatura', 924.0000, 'ºC'),
	(296292, 143, '2015-01-01 01:04:58.000000', 'temperatura', 600.0000, 'ºC'),
	(296293, 143, '2015-01-01 01:04:59.000000', 'temperatura', 232.0000, 'ºC'),
	(296294, 143, '2015-01-01 01:05:00.000000', 'temperatura', 558.0000, 'ºC'),
	(296295, 143, '2015-01-01 01:05:01.000000', 'temperatura', 895.0000, 'ºC'),
	(296296, 143, '2015-01-01 01:05:02.000000', 'temperatura', 400.0000, 'ºC'),
	(296297, 143, '2015-01-01 01:05:03.000000', 'temperatura', 517.0000, 'ºC'),
	(296298, 143, '2015-01-01 01:05:04.000000', 'temperatura', 184.0000, 'ºC'),
	(296299, 143, '2015-01-01 01:05:05.000000', 'temperatura', 572.0000, 'ºC'),
	(296300, 143, '2015-01-01 01:05:06.000000', 'temperatura', 1109.0000, 'ºC'),
	(296301, 143, '2015-01-01 01:05:07.000000', 'temperatura', 227.0000, 'ºC'),
	(296302, 143, '2015-01-01 01:05:08.000000', 'temperatura', 211.0000, 'ºC'),
	(296303, 143, '2015-01-01 01:05:09.000000', 'temperatura', 375.0000, 'ºC'),
	(296304, 143, '2015-01-01 01:05:10.000000', 'temperatura', 43.0000, 'ºC'),
	(296305, 143, '2015-01-01 01:05:11.000000', 'temperatura', 289.0000, 'ºC'),
	(296306, 143, '2015-01-01 01:05:12.000000', 'temperatura', 118.0000, 'ºC'),
	(296307, 143, '2015-01-01 01:05:13.000000', 'temperatura', 925.0000, 'ºC'),
	(296308, 143, '2015-01-01 01:05:14.000000', 'temperatura', 669.0000, 'ºC'),
	(296309, 143, '2015-01-01 01:05:15.000000', 'temperatura', 570.0000, 'ºC'),
	(296310, 143, '2015-01-01 01:05:16.000000', 'temperatura', 845.0000, 'ºC'),
	(296311, 143, '2015-01-01 01:05:17.000000', 'temperatura', 114.0000, 'ºC'),
	(296312, 143, '2015-01-01 01:05:18.000000', 'temperatura', 437.0000, 'ºC'),
	(296313, 143, '2015-01-01 01:05:19.000000', 'temperatura', 643.0000, 'ºC'),
	(296314, 143, '2015-01-01 01:05:20.000000', 'temperatura', 703.0000, 'ºC'),
	(296315, 143, '2015-01-01 01:05:21.000000', 'temperatura', 389.0000, 'ºC'),
	(296316, 143, '2015-01-01 01:05:22.000000', 'temperatura', 1037.0000, 'ºC'),
	(296317, 143, '2015-01-01 01:05:23.000000', 'temperatura', 420.0000, 'ºC'),
	(296318, 143, '2015-01-01 01:05:24.000000', 'temperatura', 186.0000, 'ºC'),
	(296319, 143, '2015-01-01 01:05:25.000000', 'temperatura', 871.0000, 'ºC'),
	(296320, 143, '2015-01-01 01:05:26.000000', 'temperatura', 197.0000, 'ºC'),
	(296321, 143, '2015-01-01 01:05:27.000000', 'temperatura', 773.0000, 'ºC'),
	(296322, 143, '2015-01-01 01:05:28.000000', 'temperatura', 873.0000, 'ºC'),
	(296323, 143, '2015-01-01 01:05:29.000000', 'temperatura', 847.0000, 'ºC'),
	(296324, 143, '2015-01-01 01:05:30.000000', 'temperatura', 416.0000, 'ºC'),
	(296325, 143, '2015-01-01 01:05:31.000000', 'temperatura', 742.0000, 'ºC'),
	(296326, 143, '2015-01-01 01:05:32.000000', 'temperatura', 61.0000, 'ºC'),
	(296327, 143, '2015-01-01 01:05:33.000000', 'temperatura', 482.0000, 'ºC'),
	(296328, 143, '2015-01-01 01:05:34.000000', 'temperatura', 1024.0000, 'ºC'),
	(296329, 143, '2015-01-01 01:05:35.000000', 'temperatura', 77.0000, 'ºC'),
	(296330, 143, '2015-01-01 01:05:36.000000', 'temperatura', 912.0000, 'ºC'),
	(296331, 143, '2015-01-01 01:05:37.000000', 'temperatura', 729.0000, 'ºC'),
	(296332, 143, '2015-01-01 01:05:38.000000', 'temperatura', 909.0000, 'ºC'),
	(296333, 143, '2015-01-01 01:05:39.000000', 'temperatura', 1160.0000, 'ºC'),
	(296334, 143, '2015-01-01 01:05:40.000000', 'temperatura', 672.0000, 'ºC'),
	(296335, 143, '2015-01-01 01:05:41.000000', 'temperatura', 1079.0000, 'ºC'),
	(296336, 143, '2015-01-01 01:05:42.000000', 'temperatura', 983.0000, 'ºC'),
	(296337, 143, '2015-01-01 01:05:43.000000', 'temperatura', 478.0000, 'ºC'),
	(296338, 143, '2015-01-01 01:05:44.000000', 'temperatura', 639.0000, 'ºC'),
	(296339, 143, '2015-01-01 01:05:45.000000', 'temperatura', 564.0000, 'ºC'),
	(296340, 143, '2015-01-01 01:05:46.000000', 'temperatura', 901.0000, 'ºC'),
	(296341, 143, '2015-01-01 01:05:47.000000', 'temperatura', 417.0000, 'ºC'),
	(296342, 143, '2015-01-01 01:05:48.000000', 'temperatura', 579.0000, 'ºC'),
	(296343, 143, '2015-01-01 01:05:49.000000', 'temperatura', 446.0000, 'ºC'),
	(296344, 143, '2015-01-01 01:05:50.000000', 'temperatura', 493.0000, 'ºC'),
	(296345, 143, '2015-01-01 01:05:51.000000', 'temperatura', 1126.0000, 'ºC'),
	(296346, 143, '2015-01-01 01:05:52.000000', 'temperatura', 552.0000, 'ºC'),
	(296347, 143, '2015-01-01 01:05:53.000000', 'temperatura', 583.0000, 'ºC'),
	(296348, 143, '2015-01-01 01:05:54.000000', 'temperatura', 60.0000, 'ºC'),
	(296349, 143, '2015-01-01 01:05:55.000000', 'temperatura', 950.0000, 'ºC'),
	(296350, 143, '2015-01-01 01:05:56.000000', 'temperatura', 972.0000, 'ºC'),
	(296351, 143, '2015-01-01 01:05:57.000000', 'temperatura', 811.0000, 'ºC'),
	(296352, 143, '2015-01-01 01:05:58.000000', 'temperatura', 1140.0000, 'ºC'),
	(296353, 143, '2015-01-01 01:05:59.000000', 'temperatura', 868.0000, 'ºC'),
	(296354, 143, '2015-01-01 01:06:00.000000', 'temperatura', 921.0000, 'ºC'),
	(296355, 143, '2015-01-01 01:06:01.000000', 'temperatura', 800.0000, 'ºC'),
	(296356, 143, '2015-01-01 01:06:02.000000', 'temperatura', 38.0000, 'ºC'),
	(296357, 143, '2015-01-01 01:06:03.000000', 'temperatura', 191.0000, 'ºC'),
	(296358, 143, '2015-01-01 01:06:04.000000', 'temperatura', 839.0000, 'ºC'),
	(296359, 143, '2015-01-01 01:06:05.000000', 'temperatura', 25.0000, 'ºC'),
	(296360, 143, '2015-01-01 01:06:06.000000', 'temperatura', 7.0000, 'ºC'),
	(296361, 143, '2015-01-01 01:06:07.000000', 'temperatura', 1160.0000, 'ºC'),
	(296362, 143, '2015-01-01 01:06:08.000000', 'temperatura', 978.0000, 'ºC'),
	(296363, 143, '2015-01-01 01:06:09.000000', 'temperatura', 213.0000, 'ºC'),
	(296364, 143, '2015-01-01 01:06:10.000000', 'temperatura', 529.0000, 'ºC'),
	(296365, 143, '2015-01-01 01:06:11.000000', 'temperatura', 808.0000, 'ºC'),
	(296366, 143, '2015-01-01 01:06:12.000000', 'temperatura', 55.0000, 'ºC'),
	(296367, 143, '2015-01-01 01:06:13.000000', 'temperatura', 249.0000, 'ºC'),
	(296368, 143, '2015-01-01 01:06:14.000000', 'temperatura', 1081.0000, 'ºC'),
	(296369, 143, '2015-01-01 01:06:15.000000', 'temperatura', 1058.0000, 'ºC'),
	(296370, 143, '2015-01-01 01:06:16.000000', 'temperatura', 849.0000, 'ºC'),
	(296371, 143, '2015-01-01 01:06:17.000000', 'temperatura', 1069.0000, 'ºC'),
	(296372, 143, '2015-01-01 01:06:18.000000', 'temperatura', 400.0000, 'ºC'),
	(296373, 143, '2015-01-01 01:06:19.000000', 'temperatura', 1195.0000, 'ºC'),
	(296374, 143, '2015-01-01 01:06:20.000000', 'temperatura', 1175.0000, 'ºC'),
	(296375, 143, '2015-01-01 01:06:21.000000', 'temperatura', 1089.0000, 'ºC'),
	(296376, 143, '2015-01-01 01:06:22.000000', 'temperatura', 722.0000, 'ºC'),
	(296377, 143, '2015-01-01 01:06:23.000000', 'temperatura', 344.0000, 'ºC'),
	(296378, 143, '2015-01-01 01:06:24.000000', 'temperatura', 755.0000, 'ºC'),
	(296379, 143, '2015-01-01 01:06:25.000000', 'temperatura', 343.0000, 'ºC'),
	(296380, 143, '2015-01-01 01:06:26.000000', 'temperatura', 648.0000, 'ºC'),
	(296381, 143, '2015-01-01 01:06:27.000000', 'temperatura', 1014.0000, 'ºC'),
	(296382, 143, '2015-01-01 01:06:28.000000', 'temperatura', 727.0000, 'ºC'),
	(296383, 143, '2015-01-01 01:06:29.000000', 'temperatura', 592.0000, 'ºC'),
	(296384, 143, '2015-01-01 01:06:30.000000', 'temperatura', 778.0000, 'ºC'),
	(296385, 143, '2015-01-01 01:06:31.000000', 'temperatura', 917.0000, 'ºC'),
	(296386, 143, '2015-01-01 01:06:32.000000', 'temperatura', 1050.0000, 'ºC'),
	(296387, 143, '2015-01-01 01:06:33.000000', 'temperatura', 99.0000, 'ºC'),
	(296388, 143, '2015-01-01 01:06:34.000000', 'temperatura', 945.0000, 'ºC'),
	(296389, 143, '2015-01-01 01:06:35.000000', 'temperatura', 829.0000, 'ºC'),
	(296390, 143, '2015-01-01 01:06:36.000000', 'temperatura', 110.0000, 'ºC'),
	(296391, 143, '2015-01-01 01:06:37.000000', 'temperatura', 465.0000, 'ºC'),
	(296392, 143, '2015-01-01 01:06:38.000000', 'temperatura', 795.0000, 'ºC'),
	(296393, 143, '2015-01-01 01:06:39.000000', 'temperatura', 181.0000, 'ºC'),
	(296394, 143, '2015-01-01 01:06:40.000000', 'temperatura', 922.0000, 'ºC'),
	(296395, 143, '2015-01-01 01:06:41.000000', 'temperatura', 466.0000, 'ºC'),
	(296396, 143, '2015-01-01 01:06:42.000000', 'temperatura', 764.0000, 'ºC'),
	(296397, 143, '2015-01-01 01:06:43.000000', 'temperatura', 24.0000, 'ºC'),
	(296398, 143, '2015-01-01 01:06:44.000000', 'temperatura', 228.0000, 'ºC'),
	(296399, 143, '2015-01-01 01:06:45.000000', 'temperatura', 1068.0000, 'ºC'),
	(296400, 143, '2015-01-01 01:06:46.000000', 'temperatura', 1056.0000, 'ºC'),
	(296401, 143, '2015-01-01 01:06:47.000000', 'temperatura', 877.0000, 'ºC'),
	(296402, 143, '2015-01-01 01:06:48.000000', 'temperatura', 17.0000, 'ºC'),
	(296403, 143, '2015-01-01 01:06:49.000000', 'temperatura', 1057.0000, 'ºC'),
	(296404, 143, '2015-01-01 01:06:50.000000', 'temperatura', 432.0000, 'ºC'),
	(296405, 143, '2015-01-01 01:06:51.000000', 'temperatura', 190.0000, 'ºC'),
	(296406, 143, '2015-01-01 01:06:52.000000', 'temperatura', 854.0000, 'ºC'),
	(296407, 143, '2015-01-01 01:06:53.000000', 'temperatura', 100.0000, 'ºC'),
	(296408, 143, '2015-01-01 01:06:54.000000', 'temperatura', 339.0000, 'ºC'),
	(296409, 143, '2015-01-01 01:06:55.000000', 'temperatura', 195.0000, 'ºC'),
	(296410, 143, '2015-01-01 01:06:56.000000', 'temperatura', 1160.0000, 'ºC'),
	(296411, 143, '2015-01-01 01:06:57.000000', 'temperatura', 415.0000, 'ºC'),
	(296412, 143, '2015-01-01 01:06:58.000000', 'temperatura', 996.0000, 'ºC'),
	(296413, 143, '2015-01-01 01:06:59.000000', 'temperatura', 136.0000, 'ºC'),
	(296414, 143, '2015-01-01 01:07:00.000000', 'temperatura', 90.0000, 'ºC'),
	(296415, 143, '2015-01-01 01:07:01.000000', 'temperatura', 45.0000, 'ºC'),
	(296416, 143, '2015-01-01 01:07:02.000000', 'temperatura', 1154.0000, 'ºC'),
	(296417, 143, '2015-01-01 01:07:03.000000', 'temperatura', 837.0000, 'ºC'),
	(296418, 143, '2015-01-01 01:07:04.000000', 'temperatura', 722.0000, 'ºC'),
	(296419, 143, '2015-01-01 01:07:05.000000', 'temperatura', 1100.0000, 'ºC'),
	(296420, 143, '2015-01-01 01:07:06.000000', 'temperatura', 935.0000, 'ºC'),
	(296421, 143, '2015-01-01 01:07:07.000000', 'temperatura', 174.0000, 'ºC'),
	(296422, 143, '2015-01-01 01:07:08.000000', 'temperatura', 466.0000, 'ºC'),
	(296423, 143, '2015-01-01 01:07:09.000000', 'temperatura', 607.0000, 'ºC'),
	(296424, 143, '2015-01-01 01:07:10.000000', 'temperatura', 441.0000, 'ºC'),
	(296425, 143, '2015-01-01 01:07:11.000000', 'temperatura', 382.0000, 'ºC'),
	(296426, 143, '2015-01-01 01:07:12.000000', 'temperatura', 588.0000, 'ºC'),
	(296427, 143, '2015-01-01 01:07:13.000000', 'temperatura', 593.0000, 'ºC'),
	(296428, 143, '2015-01-01 01:07:14.000000', 'temperatura', 1.0000, 'ºC'),
	(296429, 143, '2015-01-01 01:07:15.000000', 'temperatura', 627.0000, 'ºC'),
	(296430, 143, '2015-01-01 01:07:16.000000', 'temperatura', 734.0000, 'ºC'),
	(296431, 143, '2015-01-01 01:07:17.000000', 'temperatura', 590.0000, 'ºC'),
	(296432, 143, '2015-01-01 01:07:18.000000', 'temperatura', 746.0000, 'ºC'),
	(296433, 143, '2015-01-01 01:07:19.000000', 'temperatura', 763.0000, 'ºC'),
	(296434, 143, '2015-01-01 01:07:20.000000', 'temperatura', 376.0000, 'ºC'),
	(296435, 143, '2015-01-01 01:07:21.000000', 'temperatura', 792.0000, 'ºC'),
	(296436, 143, '2015-01-01 01:07:22.000000', 'temperatura', 434.0000, 'ºC'),
	(296437, 143, '2015-01-01 01:07:23.000000', 'temperatura', 992.0000, 'ºC'),
	(296438, 143, '2015-01-01 01:07:24.000000', 'temperatura', 58.0000, 'ºC'),
	(296439, 143, '2015-01-01 01:07:25.000000', 'temperatura', 915.0000, 'ºC'),
	(296440, 143, '2015-01-01 01:07:26.000000', 'temperatura', 802.0000, 'ºC'),
	(296441, 143, '2015-01-01 01:07:27.000000', 'temperatura', 66.0000, 'ºC'),
	(296442, 143, '2015-01-01 01:07:28.000000', 'temperatura', 322.0000, 'ºC'),
	(296443, 143, '2015-01-01 01:07:29.000000', 'temperatura', 214.0000, 'ºC'),
	(296444, 143, '2015-01-01 01:07:30.000000', 'temperatura', 106.0000, 'ºC'),
	(296445, 143, '2015-01-01 01:07:31.000000', 'temperatura', 1088.0000, 'ºC'),
	(296446, 143, '2015-01-01 01:07:32.000000', 'temperatura', 321.0000, 'ºC'),
	(296447, 143, '2015-01-01 01:07:33.000000', 'temperatura', 740.0000, 'ºC'),
	(296448, 143, '2015-01-01 01:07:34.000000', 'temperatura', 340.0000, 'ºC'),
	(296449, 143, '2015-01-01 01:07:35.000000', 'temperatura', 682.0000, 'ºC'),
	(296450, 143, '2015-01-01 01:07:36.000000', 'temperatura', 1187.0000, 'ºC'),
	(296451, 143, '2015-01-01 01:07:37.000000', 'temperatura', 292.0000, 'ºC'),
	(296452, 143, '2015-01-01 01:07:38.000000', 'temperatura', 298.0000, 'ºC'),
	(296453, 143, '2015-01-01 01:07:39.000000', 'temperatura', 613.0000, 'ºC'),
	(296454, 143, '2015-01-01 01:07:40.000000', 'temperatura', 974.0000, 'ºC'),
	(296455, 143, '2015-01-01 01:07:41.000000', 'temperatura', 631.0000, 'ºC'),
	(296456, 143, '2015-01-01 01:07:42.000000', 'temperatura', 235.0000, 'ºC'),
	(296457, 143, '2015-01-01 01:07:43.000000', 'temperatura', 482.0000, 'ºC'),
	(296458, 143, '2015-01-01 01:07:44.000000', 'temperatura', 507.0000, 'ºC'),
	(296459, 143, '2015-01-01 01:07:45.000000', 'temperatura', 1088.0000, 'ºC'),
	(296460, 143, '2015-01-01 01:07:46.000000', 'temperatura', 319.0000, 'ºC'),
	(296461, 143, '2015-01-01 01:07:47.000000', 'temperatura', 731.0000, 'ºC'),
	(296462, 143, '2015-01-01 01:07:48.000000', 'temperatura', 301.0000, 'ºC'),
	(296463, 143, '2015-01-01 01:07:49.000000', 'temperatura', 511.0000, 'ºC'),
	(296464, 143, '2015-01-01 01:07:50.000000', 'temperatura', 454.0000, 'ºC'),
	(296465, 143, '2015-01-01 01:07:51.000000', 'temperatura', 737.0000, 'ºC'),
	(296466, 143, '2015-01-01 01:07:52.000000', 'temperatura', 1125.0000, 'ºC'),
	(296467, 143, '2015-01-01 01:07:53.000000', 'temperatura', 1014.0000, 'ºC'),
	(296468, 143, '2015-01-01 01:07:54.000000', 'temperatura', 496.0000, 'ºC'),
	(296469, 143, '2015-01-01 01:07:55.000000', 'temperatura', 638.0000, 'ºC'),
	(296470, 143, '2015-01-01 01:07:56.000000', 'temperatura', 502.0000, 'ºC'),
	(296471, 143, '2015-01-01 01:07:57.000000', 'temperatura', 595.0000, 'ºC'),
	(296472, 143, '2015-01-01 01:07:58.000000', 'temperatura', 272.0000, 'ºC'),
	(296473, 143, '2015-01-01 01:07:59.000000', 'temperatura', 774.0000, 'ºC'),
	(296474, 143, '2015-01-01 01:08:00.000000', 'temperatura', 657.0000, 'ºC'),
	(296475, 143, '2015-01-01 01:08:01.000000', 'temperatura', 962.0000, 'ºC'),
	(296476, 143, '2015-01-01 01:08:02.000000', 'temperatura', 441.0000, 'ºC'),
	(296477, 143, '2015-01-01 01:08:03.000000', 'temperatura', 518.0000, 'ºC'),
	(296478, 143, '2015-01-01 01:08:04.000000', 'temperatura', 69.0000, 'ºC'),
	(296479, 143, '2015-01-01 01:08:05.000000', 'temperatura', 1192.0000, 'ºC'),
	(296480, 143, '2015-01-01 01:08:06.000000', 'temperatura', 951.0000, 'ºC'),
	(296481, 143, '2015-01-01 01:08:07.000000', 'temperatura', 1182.0000, 'ºC'),
	(296482, 143, '2015-01-01 01:08:08.000000', 'temperatura', 657.0000, 'ºC'),
	(296483, 143, '2015-01-01 01:08:09.000000', 'temperatura', 938.0000, 'ºC'),
	(296484, 143, '2015-01-01 01:08:10.000000', 'temperatura', 320.0000, 'ºC'),
	(296485, 143, '2015-01-01 01:08:11.000000', 'temperatura', 1185.0000, 'ºC'),
	(296486, 143, '2015-01-01 01:08:12.000000', 'temperatura', 167.0000, 'ºC'),
	(296487, 143, '2015-01-01 01:08:13.000000', 'temperatura', 879.0000, 'ºC'),
	(296488, 143, '2015-01-01 01:08:14.000000', 'temperatura', 294.0000, 'ºC'),
	(296489, 143, '2015-01-01 01:08:15.000000', 'temperatura', 33.0000, 'ºC'),
	(296490, 143, '2015-01-01 01:08:16.000000', 'temperatura', 485.0000, 'ºC'),
	(296491, 143, '2015-01-01 01:08:17.000000', 'temperatura', 1127.0000, 'ºC'),
	(296492, 143, '2015-01-01 01:08:18.000000', 'temperatura', 581.0000, 'ºC'),
	(296493, 143, '2015-01-01 01:08:19.000000', 'temperatura', 724.0000, 'ºC'),
	(296494, 143, '2015-01-01 01:08:20.000000', 'temperatura', 676.0000, 'ºC'),
	(296495, 143, '2015-01-01 01:08:21.000000', 'temperatura', 8.0000, 'ºC'),
	(296496, 143, '2015-01-01 01:08:22.000000', 'temperatura', 414.0000, 'ºC'),
	(296497, 143, '2015-01-01 01:08:23.000000', 'temperatura', 844.0000, 'ºC'),
	(296498, 143, '2015-01-01 01:08:24.000000', 'temperatura', 582.0000, 'ºC'),
	(296499, 143, '2015-01-01 01:08:25.000000', 'temperatura', 376.0000, 'ºC'),
	(296500, 143, '2015-01-01 01:08:26.000000', 'temperatura', 134.0000, 'ºC'),
	(296501, 143, '2015-01-01 01:08:27.000000', 'temperatura', 741.0000, 'ºC'),
	(296502, 143, '2015-01-01 01:08:28.000000', 'temperatura', 906.0000, 'ºC'),
	(296503, 143, '2015-01-01 01:08:29.000000', 'temperatura', 1108.0000, 'ºC'),
	(296504, 143, '2015-01-01 01:08:30.000000', 'temperatura', 423.0000, 'ºC'),
	(296505, 143, '2015-01-01 01:08:31.000000', 'temperatura', 1192.0000, 'ºC'),
	(296506, 143, '2015-01-01 01:08:32.000000', 'temperatura', 1091.0000, 'ºC'),
	(296507, 143, '2015-01-01 01:08:33.000000', 'temperatura', 679.0000, 'ºC'),
	(296508, 143, '2015-01-01 01:08:34.000000', 'temperatura', 121.0000, 'ºC'),
	(296509, 143, '2015-01-01 01:08:35.000000', 'temperatura', 971.0000, 'ºC'),
	(296510, 143, '2015-01-01 01:08:36.000000', 'temperatura', 893.0000, 'ºC'),
	(296511, 143, '2015-01-01 01:08:37.000000', 'temperatura', 353.0000, 'ºC'),
	(296512, 143, '2015-01-01 01:08:38.000000', 'temperatura', 287.0000, 'ºC'),
	(296513, 143, '2015-01-01 01:08:39.000000', 'temperatura', 377.0000, 'ºC'),
	(296514, 143, '2015-01-01 01:08:40.000000', 'temperatura', 1025.0000, 'ºC'),
	(296515, 143, '2015-01-01 01:08:41.000000', 'temperatura', 393.0000, 'ºC'),
	(296516, 143, '2015-01-01 01:08:42.000000', 'temperatura', 89.0000, 'ºC'),
	(296517, 143, '2015-01-01 01:08:43.000000', 'temperatura', 468.0000, 'ºC'),
	(296518, 143, '2015-01-01 01:08:44.000000', 'temperatura', 872.0000, 'ºC'),
	(296519, 143, '2015-01-01 01:08:45.000000', 'temperatura', 556.0000, 'ºC'),
	(296520, 143, '2015-01-01 01:08:46.000000', 'temperatura', 165.0000, 'ºC'),
	(296521, 143, '2015-01-01 01:08:47.000000', 'temperatura', 357.0000, 'ºC'),
	(296522, 143, '2015-01-01 01:08:48.000000', 'temperatura', 89.0000, 'ºC'),
	(296523, 143, '2015-01-01 01:08:49.000000', 'temperatura', 577.0000, 'ºC'),
	(296524, 143, '2015-01-01 01:08:50.000000', 'temperatura', 216.0000, 'ºC'),
	(296525, 143, '2015-01-01 01:08:51.000000', 'temperatura', 552.0000, 'ºC'),
	(296526, 143, '2015-01-01 01:08:52.000000', 'temperatura', 911.0000, 'ºC'),
	(296527, 143, '2015-01-01 01:08:53.000000', 'temperatura', 500.0000, 'ºC'),
	(296528, 143, '2015-01-01 01:08:54.000000', 'temperatura', 968.0000, 'ºC'),
	(296529, 143, '2015-01-01 01:08:55.000000', 'temperatura', 941.0000, 'ºC'),
	(296530, 143, '2015-01-01 01:08:56.000000', 'temperatura', 599.0000, 'ºC'),
	(296531, 143, '2015-01-01 01:08:57.000000', 'temperatura', 173.0000, 'ºC'),
	(296532, 143, '2015-01-01 01:08:58.000000', 'temperatura', 268.0000, 'ºC'),
	(296533, 143, '2015-01-01 01:08:59.000000', 'temperatura', 823.0000, 'ºC'),
	(296534, 143, '2015-01-01 01:09:00.000000', 'temperatura', 911.0000, 'ºC'),
	(296535, 143, '2015-01-01 01:09:01.000000', 'temperatura', 888.0000, 'ºC'),
	(296536, 143, '2015-01-01 01:09:02.000000', 'temperatura', 505.0000, 'ºC'),
	(296537, 143, '2015-01-01 01:09:03.000000', 'temperatura', 1061.0000, 'ºC'),
	(296538, 143, '2015-01-01 01:09:04.000000', 'temperatura', 193.0000, 'ºC'),
	(296539, 143, '2015-01-01 01:09:05.000000', 'temperatura', 180.0000, 'ºC'),
	(296540, 143, '2015-01-01 01:09:06.000000', 'temperatura', 324.0000, 'ºC'),
	(296541, 143, '2015-01-01 01:09:07.000000', 'temperatura', 1078.0000, 'ºC'),
	(296542, 143, '2015-01-01 01:09:08.000000', 'temperatura', 818.0000, 'ºC'),
	(296543, 143, '2015-01-01 01:09:09.000000', 'temperatura', 856.0000, 'ºC'),
	(296544, 143, '2015-01-01 01:09:10.000000', 'temperatura', 626.0000, 'ºC'),
	(296545, 143, '2015-01-01 01:09:11.000000', 'temperatura', 563.0000, 'ºC'),
	(296546, 143, '2015-01-01 01:09:12.000000', 'temperatura', 938.0000, 'ºC'),
	(296547, 143, '2015-01-01 01:09:13.000000', 'temperatura', 602.0000, 'ºC'),
	(296548, 143, '2015-01-01 01:09:14.000000', 'temperatura', 196.0000, 'ºC'),
	(296549, 143, '2015-01-01 01:09:15.000000', 'temperatura', 375.0000, 'ºC'),
	(296550, 143, '2015-01-01 01:09:16.000000', 'temperatura', 86.0000, 'ºC'),
	(296551, 143, '2015-01-01 01:09:17.000000', 'temperatura', 507.0000, 'ºC'),
	(296552, 143, '2015-01-01 01:09:18.000000', 'temperatura', 1075.0000, 'ºC'),
	(296553, 143, '2015-01-01 01:09:19.000000', 'temperatura', 257.0000, 'ºC'),
	(296554, 143, '2015-01-01 01:09:20.000000', 'temperatura', 460.0000, 'ºC'),
	(296555, 143, '2015-01-01 01:09:21.000000', 'temperatura', 330.0000, 'ºC'),
	(296556, 143, '2015-01-01 01:09:22.000000', 'temperatura', 271.0000, 'ºC'),
	(296557, 143, '2015-01-01 01:09:23.000000', 'temperatura', 365.0000, 'ºC'),
	(296558, 143, '2015-01-01 01:09:24.000000', 'temperatura', 1011.0000, 'ºC'),
	(296559, 143, '2015-01-01 01:09:25.000000', 'temperatura', 360.0000, 'ºC'),
	(296560, 143, '2015-01-01 01:09:26.000000', 'temperatura', 1167.0000, 'ºC'),
	(296561, 143, '2015-01-01 01:09:27.000000', 'temperatura', 1157.0000, 'ºC'),
	(296562, 143, '2015-01-01 01:09:28.000000', 'temperatura', 1083.0000, 'ºC'),
	(296563, 143, '2015-01-01 01:09:29.000000', 'temperatura', 745.0000, 'ºC'),
	(296564, 143, '2015-01-01 01:09:30.000000', 'temperatura', 477.0000, 'ºC'),
	(296565, 143, '2015-01-01 01:09:31.000000', 'temperatura', 152.0000, 'ºC'),
	(296566, 143, '2015-01-01 01:09:32.000000', 'temperatura', 528.0000, 'ºC'),
	(296567, 143, '2015-01-01 01:09:33.000000', 'temperatura', 983.0000, 'ºC'),
	(296568, 143, '2015-01-01 01:09:34.000000', 'temperatura', 935.0000, 'ºC'),
	(296569, 143, '2015-01-01 01:09:35.000000', 'temperatura', 523.0000, 'ºC'),
	(296570, 143, '2015-01-01 01:09:36.000000', 'temperatura', 1013.0000, 'ºC'),
	(296571, 143, '2015-01-01 01:09:37.000000', 'temperatura', 1095.0000, 'ºC'),
	(296572, 143, '2015-01-01 01:09:38.000000', 'temperatura', 35.0000, 'ºC'),
	(296573, 143, '2015-01-01 01:09:39.000000', 'temperatura', 493.0000, 'ºC'),
	(296574, 143, '2015-01-01 01:09:40.000000', 'temperatura', 1158.0000, 'ºC'),
	(296575, 143, '2015-01-01 01:09:41.000000', 'temperatura', 712.0000, 'ºC'),
	(296576, 143, '2015-01-01 01:09:42.000000', 'temperatura', 89.0000, 'ºC'),
	(296577, 143, '2015-01-01 01:09:43.000000', 'temperatura', 707.0000, 'ºC'),
	(296578, 143, '2015-01-01 01:09:44.000000', 'temperatura', 868.0000, 'ºC'),
	(296579, 143, '2015-01-01 01:09:45.000000', 'temperatura', 1019.0000, 'ºC'),
	(296580, 143, '2015-01-01 01:09:46.000000', 'temperatura', 92.0000, 'ºC'),
	(296581, 143, '2015-01-01 01:09:47.000000', 'temperatura', 1002.0000, 'ºC'),
	(296582, 143, '2015-01-01 01:09:48.000000', 'temperatura', 1137.0000, 'ºC'),
	(296583, 143, '2015-01-01 01:09:49.000000', 'temperatura', 280.0000, 'ºC'),
	(296584, 143, '2015-01-01 01:09:50.000000', 'temperatura', 389.0000, 'ºC'),
	(296585, 143, '2015-01-01 01:09:51.000000', 'temperatura', 1104.0000, 'ºC'),
	(296586, 143, '2015-01-01 01:09:52.000000', 'temperatura', 755.0000, 'ºC'),
	(296587, 143, '2015-01-01 01:09:53.000000', 'temperatura', 461.0000, 'ºC'),
	(296588, 143, '2015-01-01 01:09:54.000000', 'temperatura', 42.0000, 'ºC'),
	(296589, 143, '2015-01-01 01:09:55.000000', 'temperatura', 28.0000, 'ºC'),
	(296590, 143, '2015-01-01 01:09:56.000000', 'temperatura', 15.0000, 'ºC'),
	(296591, 143, '2015-01-01 01:09:57.000000', 'temperatura', 1191.0000, 'ºC'),
	(296592, 143, '2015-01-01 01:09:58.000000', 'temperatura', 1111.0000, 'ºC'),
	(296593, 143, '2015-01-01 01:09:59.000000', 'temperatura', 783.0000, 'ºC'),
	(296594, 143, '2015-01-01 01:10:00.000000', 'temperatura', 582.0000, 'ºC'),
	(296595, 143, '2015-01-01 01:10:01.000000', 'temperatura', 561.0000, 'ºC'),
	(296596, 143, '2015-01-01 01:10:02.000000', 'temperatura', 1058.0000, 'ºC'),
	(296597, 143, '2015-01-01 01:10:03.000000', 'temperatura', 8.0000, 'ºC'),
	(296598, 143, '2015-01-01 01:10:04.000000', 'temperatura', 467.0000, 'ºC'),
	(296599, 143, '2015-01-01 01:10:05.000000', 'temperatura', 1111.0000, 'ºC'),
	(296600, 143, '2015-01-01 01:10:06.000000', 'temperatura', 555.0000, 'ºC'),
	(296601, 143, '2015-01-01 01:10:07.000000', 'temperatura', 642.0000, 'ºC'),
	(296602, 143, '2015-01-01 01:10:08.000000', 'temperatura', 345.0000, 'ºC'),
	(296603, 143, '2015-01-01 01:10:09.000000', 'temperatura', 1002.0000, 'ºC'),
	(296604, 143, '2015-01-01 01:10:10.000000', 'temperatura', 374.0000, 'ºC'),
	(296605, 143, '2015-01-01 01:10:11.000000', 'temperatura', 65.0000, 'ºC'),
	(296606, 143, '2015-01-01 01:10:12.000000', 'temperatura', 403.0000, 'ºC'),
	(296607, 143, '2015-01-01 01:10:13.000000', 'temperatura', 621.0000, 'ºC'),
	(296608, 143, '2015-01-01 01:10:14.000000', 'temperatura', 698.0000, 'ºC'),
	(296609, 143, '2015-01-01 01:10:15.000000', 'temperatura', 425.0000, 'ºC'),
	(296610, 143, '2015-01-01 01:10:16.000000', 'temperatura', 31.0000, 'ºC'),
	(296611, 143, '2015-01-01 01:10:17.000000', 'temperatura', 80.0000, 'ºC'),
	(296612, 143, '2015-01-01 01:10:18.000000', 'temperatura', 309.0000, 'ºC'),
	(296613, 143, '2015-01-01 01:10:19.000000', 'temperatura', 103.0000, 'ºC'),
	(296614, 143, '2015-01-01 01:10:20.000000', 'temperatura', 790.0000, 'ºC'),
	(296615, 143, '2015-01-01 01:10:21.000000', 'temperatura', 42.0000, 'ºC'),
	(296616, 143, '2015-01-01 01:10:22.000000', 'temperatura', 240.0000, 'ºC'),
	(296617, 143, '2015-01-01 01:10:23.000000', 'temperatura', 1076.0000, 'ºC'),
	(296618, 143, '2015-01-01 01:10:24.000000', 'temperatura', 1058.0000, 'ºC'),
	(296619, 143, '2015-01-01 01:10:25.000000', 'temperatura', 862.0000, 'ºC'),
	(296620, 143, '2015-01-01 01:10:26.000000', 'temperatura', 1136.0000, 'ºC'),
	(296621, 143, '2015-01-01 01:10:27.000000', 'temperatura', 697.0000, 'ºC'),
	(296622, 143, '2015-01-01 01:10:28.000000', 'temperatura', 77.0000, 'ºC'),
	(296623, 143, '2015-01-01 01:10:29.000000', 'temperatura', 696.0000, 'ºC'),
	(296624, 143, '2015-01-01 01:10:30.000000', 'temperatura', 849.0000, 'ºC'),
	(296625, 143, '2015-01-01 01:10:31.000000', 'temperatura', 959.0000, 'ºC'),
	(296626, 143, '2015-01-01 01:10:32.000000', 'temperatura', 1046.0000, 'ºC'),
	(296627, 143, '2015-01-01 01:10:33.000000', 'temperatura', 1154.0000, 'ºC'),
	(296628, 143, '2015-01-01 01:10:34.000000', 'temperatura', 232.0000, 'ºC'),
	(296629, 143, '2015-01-01 01:10:35.000000', 'temperatura', 98.0000, 'ºC'),
	(296630, 143, '2015-01-01 01:10:36.000000', 'temperatura', 994.0000, 'ºC'),
	(296631, 143, '2015-01-01 01:10:37.000000', 'temperatura', 1077.0000, 'ºC'),
	(296632, 143, '2015-01-01 01:10:38.000000', 'temperatura', 6.0000, 'ºC'),
	(296633, 143, '2015-01-01 01:10:39.000000', 'temperatura', 396.0000, 'ºC'),
	(296634, 143, '2015-01-01 01:10:40.000000', 'temperatura', 766.0000, 'ºC'),
	(296635, 143, '2015-01-01 01:10:41.000000', 'temperatura', 241.0000, 'ºC'),
	(296636, 143, '2015-01-01 01:10:42.000000', 'temperatura', 106.0000, 'ºC'),
	(296637, 143, '2015-01-01 01:10:43.000000', 'temperatura', 1009.0000, 'ºC'),
	(296638, 143, '2015-01-01 01:10:44.000000', 'temperatura', 1126.0000, 'ºC'),
	(296639, 143, '2015-01-01 01:10:45.000000', 'temperatura', 206.0000, 'ºC'),
	(296640, 143, '2015-01-01 01:10:46.000000', 'temperatura', 50.0000, 'ºC'),
	(296641, 143, '2015-01-01 01:10:47.000000', 'temperatura', 834.0000, 'ºC'),
	(296642, 143, '2015-01-01 01:10:48.000000', 'temperatura', 421.0000, 'ºC'),
	(296643, 143, '2015-01-01 01:10:49.000000', 'temperatura', 803.0000, 'ºC'),
	(296644, 143, '2015-01-01 01:10:50.000000', 'temperatura', 351.0000, 'ºC'),
	(296645, 143, '2015-01-01 01:10:51.000000', 'temperatura', 547.0000, 'ºC'),
	(296646, 143, '2015-01-01 01:10:52.000000', 'temperatura', 482.0000, 'ºC'),
	(296647, 143, '2015-01-01 01:10:53.000000', 'temperatura', 771.0000, 'ºC'),
	(296648, 143, '2015-01-01 01:10:54.000000', 'temperatura', 8.0000, 'ºC'),
	(296649, 143, '2015-01-01 01:10:55.000000', 'temperatura', 129.0000, 'ºC'),
	(296650, 143, '2015-01-01 01:10:56.000000', 'temperatura', 622.0000, 'ºC'),
	(296651, 143, '2015-01-01 01:10:57.000000', 'temperatura', 322.0000, 'ºC'),
	(296652, 143, '2015-01-01 01:10:58.000000', 'temperatura', 946.0000, 'ºC'),
	(296653, 143, '2015-01-01 01:10:59.000000', 'temperatura', 164.0000, 'ºC'),
	(296654, 143, '2015-01-01 01:11:00.000000', 'temperatura', 382.0000, 'ºC'),
	(296655, 143, '2015-01-01 01:11:01.000000', 'temperatura', 221.0000, 'ºC'),
	(296656, 143, '2015-01-01 01:11:02.000000', 'temperatura', 1156.0000, 'ºC'),
	(296657, 143, '2015-01-01 01:11:03.000000', 'temperatura', 320.0000, 'ºC'),
	(296658, 143, '2015-01-01 01:11:04.000000', 'temperatura', 533.0000, 'ºC'),
	(296659, 143, '2015-01-01 01:11:05.000000', 'temperatura', 504.0000, 'ºC'),
	(296660, 143, '2015-01-01 01:11:06.000000', 'temperatura', 920.0000, 'ºC'),
	(296661, 143, '2015-01-01 01:11:07.000000', 'temperatura', 691.0000, 'ºC'),
	(296662, 143, '2015-01-01 01:11:08.000000', 'temperatura', 693.0000, 'ºC'),
	(296663, 143, '2015-01-01 01:11:09.000000', 'temperatura', 195.0000, 'ºC'),
	(296664, 143, '2015-01-01 01:11:10.000000', 'temperatura', 95.0000, 'ºC'),
	(296665, 143, '2015-01-01 01:11:11.000000', 'temperatura', 1089.0000, 'ºC'),
	(296666, 143, '2015-01-01 01:11:12.000000', 'temperatura', 361.0000, 'ºC'),
	(296667, 143, '2015-01-01 01:11:13.000000', 'temperatura', 940.0000, 'ºC'),
	(296668, 143, '2015-01-01 01:11:14.000000', 'temperatura', 17.0000, 'ºC'),
	(296669, 143, '2015-01-01 01:11:15.000000', 'temperatura', 863.0000, 'ºC'),
	(296670, 143, '2015-01-01 01:11:16.000000', 'temperatura', 668.0000, 'ºC'),
	(296671, 143, '2015-01-01 01:11:17.000000', 'temperatura', 750.0000, 'ºC'),
	(296672, 143, '2015-01-01 01:11:18.000000', 'temperatura', 549.0000, 'ºC'),
	(296673, 143, '2015-01-01 01:11:19.000000', 'temperatura', 493.0000, 'ºC'),
	(296674, 143, '2015-01-01 01:11:20.000000', 'temperatura', 819.0000, 'ºC'),
	(296675, 143, '2015-01-01 01:11:21.000000', 'temperatura', 216.0000, 'ºC'),
	(296676, 143, '2015-01-01 01:11:22.000000', 'temperatura', 1024.0000, 'ºC'),
	(296677, 143, '2015-01-01 01:11:23.000000', 'temperatura', 872.0000, 'ºC'),
	(296678, 143, '2015-01-01 01:11:24.000000', 'temperatura', 88.0000, 'ºC'),
	(296679, 143, '2015-01-01 01:11:25.000000', 'temperatura', 227.0000, 'ºC'),
	(296680, 143, '2015-01-01 01:11:26.000000', 'temperatura', 869.0000, 'ºC'),
	(296681, 143, '2015-01-01 01:11:27.000000', 'temperatura', 65.0000, 'ºC'),
	(296682, 143, '2015-01-01 01:11:28.000000', 'temperatura', 118.0000, 'ºC'),
	(296683, 143, '2015-01-01 01:11:29.000000', 'temperatura', 397.0000, 'ºC'),
	(296684, 143, '2015-01-01 01:11:30.000000', 'temperatura', 432.0000, 'ºC'),
	(296685, 143, '2015-01-01 01:11:31.000000', 'temperatura', 968.0000, 'ºC'),
	(296686, 143, '2015-01-01 01:11:32.000000', 'temperatura', 1144.0000, 'ºC'),
	(296687, 143, '2015-01-01 01:11:33.000000', 'temperatura', 416.0000, 'ºC'),
	(296688, 143, '2015-01-01 01:11:34.000000', 'temperatura', 1050.0000, 'ºC'),
	(296689, 143, '2015-01-01 01:11:35.000000', 'temperatura', 400.0000, 'ºC'),
	(296690, 143, '2015-01-01 01:11:36.000000', 'temperatura', 53.0000, 'ºC'),
	(296691, 143, '2015-01-01 01:11:37.000000', 'temperatura', 263.0000, 'ºC'),
	(296692, 143, '2015-01-01 01:11:38.000000', 'temperatura', 1156.0000, 'ºC'),
	(296693, 143, '2015-01-01 01:11:39.000000', 'temperatura', 194.0000, 'ºC'),
	(296694, 143, '2015-01-01 01:11:40.000000', 'temperatura', 1103.0000, 'ºC'),
	(296695, 143, '2015-01-01 01:11:41.000000', 'temperatura', 135.0000, 'ºC'),
	(296696, 143, '2015-01-01 01:11:42.000000', 'temperatura', 963.0000, 'ºC'),
	(296697, 143, '2015-01-01 01:11:43.000000', 'temperatura', 811.0000, 'ºC'),
	(296698, 143, '2015-01-01 01:11:44.000000', 'temperatura', 1166.0000, 'ºC'),
	(296699, 143, '2015-01-01 01:11:45.000000', 'temperatura', 999.0000, 'ºC'),
	(296700, 143, '2015-01-01 01:11:46.000000', 'temperatura', 296.0000, 'ºC'),
	(296701, 143, '2015-01-01 01:11:47.000000', 'temperatura', 884.0000, 'ºC'),
	(296702, 143, '2015-01-01 01:11:48.000000', 'temperatura', 1131.0000, 'ºC'),
	(296703, 143, '2015-01-01 01:11:49.000000', 'temperatura', 603.0000, 'ºC'),
	(296704, 143, '2015-01-01 01:11:50.000000', 'temperatura', 825.0000, 'ºC'),
	(296705, 143, '2015-01-01 01:11:51.000000', 'temperatura', 1113.0000, 'ºC'),
	(296706, 143, '2015-01-01 01:11:52.000000', 'temperatura', 694.0000, 'ºC'),
	(296707, 143, '2015-01-01 01:11:53.000000', 'temperatura', 131.0000, 'ºC'),
	(296708, 143, '2015-01-01 01:11:54.000000', 'temperatura', 973.0000, 'ºC'),
	(296709, 143, '2015-01-01 01:11:55.000000', 'temperatura', 873.0000, 'ºC'),
	(296710, 143, '2015-01-01 01:11:56.000000', 'temperatura', 247.0000, 'ºC'),
	(296711, 143, '2015-01-01 01:11:57.000000', 'temperatura', 1017.0000, 'ºC'),
	(296712, 143, '2015-01-01 01:11:58.000000', 'temperatura', 743.0000, 'ºC'),
	(296713, 143, '2015-01-01 01:11:59.000000', 'temperatura', 665.0000, 'ºC'),
	(296714, 143, '2015-01-01 01:12:00.000000', 'temperatura', 1096.0000, 'ºC'),
	(296715, 143, '2015-01-01 01:12:01.000000', 'temperatura', 1086.0000, 'ºC'),
	(296716, 143, '2015-01-01 01:12:02.000000', 'temperatura', 944.0000, 'ºC'),
	(296717, 143, '2015-01-01 01:12:03.000000', 'temperatura', 263.0000, 'ºC'),
	(296718, 143, '2015-01-01 01:12:04.000000', 'temperatura', 880.0000, 'ºC'),
	(296719, 143, '2015-01-01 01:12:05.000000', 'temperatura', 15.0000, 'ºC'),
	(296720, 143, '2015-01-01 01:12:06.000000', 'temperatura', 1034.0000, 'ºC'),
	(296721, 143, '2015-01-01 01:12:07.000000', 'temperatura', 326.0000, 'ºC'),
	(296722, 143, '2015-01-01 01:12:08.000000', 'temperatura', 929.0000, 'ºC'),
	(296723, 143, '2015-01-01 01:12:09.000000', 'temperatura', 68.0000, 'ºC'),
	(296724, 143, '2015-01-01 01:12:10.000000', 'temperatura', 1153.0000, 'ºC'),
	(296725, 143, '2015-01-01 01:12:11.000000', 'temperatura', 761.0000, 'ºC'),
	(296726, 143, '2015-01-01 01:12:12.000000', 'temperatura', 347.0000, 'ºC'),
	(296727, 143, '2015-01-01 01:12:13.000000', 'temperatura', 653.0000, 'ºC'),
	(296728, 143, '2015-01-01 01:12:14.000000', 'temperatura', 1026.0000, 'ºC'),
	(296729, 143, '2015-01-01 01:12:15.000000', 'temperatura', 769.0000, 'ºC'),
	(296730, 143, '2015-01-01 01:12:16.000000', 'temperatura', 767.0000, 'ºC'),
	(296731, 143, '2015-01-01 01:12:17.000000', 'temperatura', 330.0000, 'ºC'),
	(296732, 143, '2015-01-01 01:12:18.000000', 'temperatura', 550.0000, 'ºC'),
	(296733, 143, '2015-01-01 01:12:19.000000', 'temperatura', 559.0000, 'ºC'),
	(296734, 143, '2015-01-01 01:12:20.000000', 'temperatura', 1147.0000, 'ºC'),
	(296735, 143, '2015-01-01 01:12:21.000000', 'temperatura', 460.0000, 'ºC'),
	(296736, 143, '2015-01-01 01:12:22.000000', 'temperatura', 58.0000, 'ºC'),
	(296737, 143, '2015-01-01 01:12:23.000000', 'temperatura', 110.0000, 'ºC'),
	(296738, 143, '2015-01-01 01:12:24.000000', 'temperatura', 378.0000, 'ºC'),
	(296739, 143, '2015-01-01 01:12:25.000000', 'temperatura', 359.0000, 'ºC'),
	(296740, 143, '2015-01-01 01:12:26.000000', 'temperatura', 660.0000, 'ºC'),
	(296741, 143, '2015-01-01 01:12:27.000000', 'temperatura', 1025.0000, 'ºC'),
	(296742, 143, '2015-01-01 01:12:28.000000', 'temperatura', 746.0000, 'ºC'),
	(296743, 143, '2015-01-01 01:12:29.000000', 'temperatura', 655.0000, 'ºC'),
	(296744, 143, '2015-01-01 01:12:30.000000', 'temperatura', 1037.0000, 'ºC'),
	(296745, 143, '2015-01-01 01:12:31.000000', 'temperatura', 819.0000, 'ºC'),
	(296746, 143, '2015-01-01 01:12:32.000000', 'temperatura', 986.0000, 'ºC'),
	(296747, 143, '2015-01-01 01:12:33.000000', 'temperatura', 74.0000, 'ºC'),
	(296748, 143, '2015-01-01 01:12:34.000000', 'temperatura', 1010.0000, 'ºC'),
	(296749, 143, '2015-01-01 01:12:35.000000', 'temperatura', 30.0000, 'ºC'),
	(296750, 143, '2015-01-01 01:12:36.000000', 'temperatura', 722.0000, 'ºC'),
	(296751, 143, '2015-01-01 01:12:37.000000', 'temperatura', 1120.0000, 'ºC'),
	(296752, 143, '2015-01-01 01:12:38.000000', 'temperatura', 1033.0000, 'ºC'),
	(296753, 143, '2015-01-01 01:12:39.000000', 'temperatura', 607.0000, 'ºC'),
	(296754, 143, '2015-01-01 01:12:40.000000', 'temperatura', 1134.0000, 'ºC'),
	(296755, 143, '2015-01-01 01:12:41.000000', 'temperatura', 252.0000, 'ºC'),
	(296756, 143, '2015-01-01 01:12:42.000000', 'temperatura', 259.0000, 'ºC'),
	(296757, 143, '2015-01-01 01:12:43.000000', 'temperatura', 537.0000, 'ºC'),
	(296758, 143, '2015-01-01 01:12:44.000000', 'temperatura', 710.0000, 'ºC'),
	(296759, 143, '2015-01-01 01:12:45.000000', 'temperatura', 741.0000, 'ºC'),
	(296760, 143, '2015-01-01 01:12:46.000000', 'temperatura', 375.0000, 'ºC'),
	(296761, 143, '2015-01-01 01:12:47.000000', 'temperatura', 853.0000, 'ºC'),
	(296762, 143, '2015-01-01 01:12:48.000000', 'temperatura', 739.0000, 'ºC'),
	(296763, 143, '2015-01-01 01:12:49.000000', 'temperatura', 1139.0000, 'ºC'),
	(296764, 143, '2015-01-01 01:12:50.000000', 'temperatura', 1077.0000, 'ºC'),
	(296765, 143, '2015-01-01 01:12:51.000000', 'temperatura', 770.0000, 'ºC'),
	(296766, 143, '2015-01-01 01:12:52.000000', 'temperatura', 618.0000, 'ºC'),
	(296767, 143, '2015-01-01 01:12:53.000000', 'temperatura', 779.0000, 'ºC'),
	(296768, 143, '2015-01-01 01:12:54.000000', 'temperatura', 843.0000, 'ºC'),
	(296769, 143, '2015-01-01 01:12:55.000000', 'temperatura', 678.0000, 'ºC'),
	(296770, 143, '2015-01-01 01:12:56.000000', 'temperatura', 863.0000, 'ºC'),
	(296771, 143, '2015-01-01 01:12:57.000000', 'temperatura', 1081.0000, 'ºC'),
	(296772, 143, '2015-01-01 01:12:58.000000', 'temperatura', 414.0000, 'ºC'),
	(296773, 143, '2015-01-01 01:12:59.000000', 'temperatura', 31.0000, 'ºC'),
	(296774, 143, '2015-01-01 01:13:00.000000', 'temperatura', 111.0000, 'ºC'),
	(296775, 143, '2015-01-01 01:13:01.000000', 'temperatura', 465.0000, 'ºC'),
	(296776, 143, '2015-01-01 01:13:02.000000', 'temperatura', 790.0000, 'ºC'),
	(296777, 143, '2015-01-01 01:13:03.000000', 'temperatura', 158.0000, 'ºC'),
	(296778, 143, '2015-01-01 01:13:04.000000', 'temperatura', 819.0000, 'ºC'),
	(296779, 143, '2015-01-01 01:13:05.000000', 'temperatura', 24.0000, 'ºC'),
	(296780, 143, '2015-01-01 01:13:06.000000', 'temperatura', 61.0000, 'ºC'),
	(296781, 143, '2015-01-01 01:13:07.000000', 'temperatura', 235.0000, 'ºC'),
	(296782, 143, '2015-01-01 01:13:08.000000', 'temperatura', 991.0000, 'ºC'),
	(296783, 143, '2015-01-01 01:13:09.000000', 'temperatura', 650.0000, 'ºC'),
	(296784, 143, '2015-01-01 01:13:10.000000', 'temperatura', 276.0000, 'ºC'),
	(296785, 143, '2015-01-01 01:13:11.000000', 'temperatura', 634.0000, 'ºC'),
	(296786, 143, '2015-01-01 01:13:12.000000', 'temperatura', 1142.0000, 'ºC'),
	(296787, 143, '2015-01-01 01:13:13.000000', 'temperatura', 206.0000, 'ºC'),
	(296788, 143, '2015-01-01 01:13:14.000000', 'temperatura', 6.0000, 'ºC'),
	(296789, 143, '2015-01-01 01:13:15.000000', 'temperatura', 613.0000, 'ºC'),
	(296790, 143, '2015-01-01 01:13:16.000000', 'temperatura', 648.0000, 'ºC'),
	(296791, 143, '2015-01-01 01:13:17.000000', 'temperatura', 200.0000, 'ºC'),
	(296792, 143, '2015-01-01 01:13:18.000000', 'temperatura', 257.0000, 'ºC'),
	(296793, 143, '2015-01-01 01:13:19.000000', 'temperatura', 685.0000, 'ºC'),
	(296794, 143, '2015-01-01 01:13:20.000000', 'temperatura', 256.0000, 'ºC'),
	(296795, 143, '2015-01-01 01:13:21.000000', 'temperatura', 423.0000, 'ºC'),
	(296796, 143, '2015-01-01 01:13:22.000000', 'temperatura', 150.0000, 'ºC'),
	(296797, 143, '2015-01-01 01:13:23.000000', 'temperatura', 680.0000, 'ºC'),
	(296798, 143, '2015-01-01 01:13:24.000000', 'temperatura', 549.0000, 'ºC'),
	(296799, 143, '2015-01-01 01:13:25.000000', 'temperatura', 707.0000, 'ºC'),
	(296800, 143, '2015-01-01 01:13:26.000000', 'temperatura', 687.0000, 'ºC'),
	(296801, 143, '2015-01-01 01:13:27.000000', 'temperatura', 116.0000, 'ºC'),
	(296802, 143, '2015-01-01 01:13:28.000000', 'temperatura', 920.0000, 'ºC'),
	(296803, 143, '2015-01-01 01:13:29.000000', 'temperatura', 652.0000, 'ºC'),
	(296804, 143, '2015-01-01 01:13:30.000000', 'temperatura', 502.0000, 'ºC'),
	(296805, 143, '2015-01-01 01:13:31.000000', 'temperatura', 554.0000, 'ºC'),
	(296806, 143, '2015-01-01 01:13:32.000000', 'temperatura', 62.0000, 'ºC'),
	(296807, 143, '2015-01-01 01:13:33.000000', 'temperatura', 1051.0000, 'ºC'),
	(296808, 143, '2015-01-01 01:13:34.000000', 'temperatura', 269.0000, 'ºC'),
	(296809, 143, '2015-01-01 01:13:35.000000', 'temperatura', 592.0000, 'ºC'),
	(296810, 143, '2015-01-01 01:13:36.000000', 'temperatura', 953.0000, 'ºC'),
	(296811, 143, '2015-01-01 01:13:37.000000', 'temperatura', 590.0000, 'ºC'),
	(296812, 143, '2015-01-01 01:13:38.000000', 'temperatura', 91.0000, 'ºC'),
	(296813, 143, '2015-01-01 01:13:39.000000', 'temperatura', 1085.0000, 'ºC'),
	(296814, 143, '2015-01-01 01:13:40.000000', 'temperatura', 351.0000, 'ºC'),
	(296815, 143, '2015-01-01 01:13:41.000000', 'temperatura', 904.0000, 'ºC'),
	(296816, 143, '2015-01-01 01:13:42.000000', 'temperatura', 1066.0000, 'ºC'),
	(296817, 143, '2015-01-01 01:13:43.000000', 'temperatura', 217.0000, 'ºC'),
	(296818, 143, '2015-01-01 01:13:44.000000', 'temperatura', 289.0000, 'ºC'),
	(296819, 143, '2015-01-01 01:13:45.000000', 'temperatura', 794.0000, 'ºC'),
	(296820, 143, '2015-01-01 01:13:46.000000', 'temperatura', 704.0000, 'ºC'),
	(296821, 143, '2015-01-01 01:13:47.000000', 'temperatura', 1137.0000, 'ºC'),
	(296822, 143, '2015-01-01 01:13:48.000000', 'temperatura', 1173.0000, 'ºC'),
	(296823, 143, '2015-01-01 01:13:49.000000', 'temperatura', 53.0000, 'ºC'),
	(296824, 143, '2015-01-01 01:13:50.000000', 'temperatura', 350.0000, 'ºC'),
	(296825, 143, '2015-01-01 01:13:51.000000', 'temperatura', 390.0000, 'ºC'),
	(296826, 143, '2015-01-01 01:13:52.000000', 'temperatura', 901.0000, 'ºC'),
	(296827, 143, '2015-01-01 01:13:53.000000', 'temperatura', 936.0000, 'ºC'),
	(296828, 143, '2015-01-01 01:13:54.000000', 'temperatura', 776.0000, 'ºC'),
	(296829, 143, '2015-01-01 01:13:55.000000', 'temperatura', 1073.0000, 'ºC'),
	(296830, 143, '2015-01-01 01:13:56.000000', 'temperatura', 638.0000, 'ºC'),
	(296831, 143, '2015-01-01 01:13:57.000000', 'temperatura', 1170.0000, 'ºC'),
	(296832, 143, '2015-01-01 01:13:58.000000', 'temperatura', 336.0000, 'ºC'),
	(296833, 143, '2015-01-01 01:13:59.000000', 'temperatura', 571.0000, 'ºC'),
	(296834, 143, '2015-01-01 01:14:00.000000', 'temperatura', 646.0000, 'ºC'),
	(296835, 143, '2015-01-01 01:14:01.000000', 'temperatura', 319.0000, 'ºC'),
	(296836, 143, '2015-01-01 01:14:02.000000', 'temperatura', 856.0000, 'ºC'),
	(296837, 143, '2015-01-01 01:14:03.000000', 'temperatura', 924.0000, 'ºC'),
	(296838, 143, '2015-01-01 01:14:04.000000', 'temperatura', 854.0000, 'ºC'),
	(296839, 143, '2015-01-01 01:14:05.000000', 'temperatura', 297.0000, 'ºC'),
	(296840, 143, '2015-01-01 01:14:06.000000', 'temperatura', 122.0000, 'ºC'),
	(296841, 143, '2015-01-01 01:14:07.000000', 'temperatura', 922.0000, 'ºC'),
	(296842, 143, '2015-01-01 01:14:08.000000', 'temperatura', 644.0000, 'ºC'),
	(296843, 143, '2015-01-01 01:14:09.000000', 'temperatura', 454.0000, 'ºC'),
	(296844, 143, '2015-01-01 01:14:10.000000', 'temperatura', 340.0000, 'ºC'),
	(296845, 143, '2015-01-01 01:14:11.000000', 'temperatura', 338.0000, 'ºC'),
	(296846, 143, '2015-01-01 01:14:12.000000', 'temperatura', 671.0000, 'ºC'),
	(296847, 143, '2015-01-01 01:14:13.000000', 'temperatura', 1139.0000, 'ºC'),
	(296848, 143, '2015-01-01 01:14:14.000000', 'temperatura', 85.0000, 'ºC'),
	(296849, 143, '2015-01-01 01:14:15.000000', 'temperatura', 608.0000, 'ºC'),
	(296850, 143, '2015-01-01 01:14:16.000000', 'temperatura', 384.0000, 'ºC'),
	(296851, 143, '2015-01-01 01:14:17.000000', 'temperatura', 98.0000, 'ºC'),
	(296852, 143, '2015-01-01 01:14:18.000000', 'temperatura', 539.0000, 'ºC'),
	(296853, 143, '2015-01-01 01:14:19.000000', 'temperatura', 0.0000, 'ºC'),
	(296854, 143, '2015-01-01 01:14:20.000000', 'temperatura', 786.0000, 'ºC'),
	(296855, 143, '2015-01-01 01:14:21.000000', 'temperatura', 329.0000, 'ºC'),
	(296856, 143, '2015-01-01 01:14:22.000000', 'temperatura', 489.0000, 'ºC'),
	(296857, 143, '2015-01-01 01:14:23.000000', 'temperatura', 258.0000, 'ºC'),
	(296858, 143, '2015-01-01 01:14:24.000000', 'temperatura', 1023.0000, 'ºC'),
	(296859, 143, '2015-01-01 01:14:25.000000', 'temperatura', 741.0000, 'ºC'),
	(296860, 143, '2015-01-01 01:14:26.000000', 'temperatura', 635.0000, 'ºC'),
	(296861, 143, '2015-01-01 01:14:27.000000', 'temperatura', 953.0000, 'ºC'),
	(296862, 143, '2015-01-01 01:14:28.000000', 'temperatura', 461.0000, 'ºC'),
	(296863, 143, '2015-01-01 01:14:29.000000', 'temperatura', 648.0000, 'ºC'),
	(296864, 143, '2015-01-01 01:14:30.000000', 'temperatura', 658.0000, 'ºC'),
	(296865, 143, '2015-01-01 01:14:31.000000', 'temperatura', 143.0000, 'ºC'),
	(296866, 143, '2015-01-01 01:14:32.000000', 'temperatura', 1145.0000, 'ºC'),
	(296867, 143, '2015-01-01 01:14:33.000000', 'temperatura', 496.0000, 'ºC'),
	(296868, 143, '2015-01-01 01:14:34.000000', 'temperatura', 246.0000, 'ºC'),
	(296869, 143, '2015-01-01 01:14:35.000000', 'temperatura', 940.0000, 'ºC'),
	(296870, 143, '2015-01-01 01:14:36.000000', 'temperatura', 363.0000, 'ºC'),
	(296871, 143, '2015-01-01 01:14:37.000000', 'temperatura', 194.0000, 'ºC'),
	(296872, 143, '2015-01-01 01:14:38.000000', 'temperatura', 1083.0000, 'ºC'),
	(296873, 143, '2015-01-01 01:14:39.000000', 'temperatura', 31.0000, 'ºC'),
	(296874, 143, '2015-01-01 01:14:40.000000', 'temperatura', 510.0000, 'ºC'),
	(296875, 143, '2015-01-01 01:14:41.000000', 'temperatura', 56.0000, 'ºC'),
	(296876, 143, '2015-01-01 01:14:42.000000', 'temperatura', 1152.0000, 'ºC'),
	(296877, 143, '2015-01-01 01:14:43.000000', 'temperatura', 791.0000, 'ºC'),
	(296878, 143, '2015-01-01 01:14:44.000000', 'temperatura', 502.0000, 'ºC'),
	(296879, 143, '2015-01-01 01:14:45.000000', 'temperatura', 136.0000, 'ºC'),
	(296880, 143, '2015-01-01 01:14:46.000000', 'temperatura', 375.0000, 'ºC'),
	(296881, 143, '2015-01-01 01:14:47.000000', 'temperatura', 269.0000, 'ºC'),
	(296882, 143, '2015-01-01 01:14:48.000000', 'temperatura', 219.0000, 'ºC'),
	(296883, 143, '2015-01-01 01:14:49.000000', 'temperatura', 290.0000, 'ºC'),
	(296884, 143, '2015-01-01 01:14:50.000000', 'temperatura', 794.0000, 'ºC'),
	(296885, 143, '2015-01-01 01:14:51.000000', 'temperatura', 698.0000, 'ºC'),
	(296886, 143, '2015-01-01 01:14:52.000000', 'temperatura', 1108.0000, 'ºC'),
	(296887, 143, '2015-01-01 01:14:53.000000', 'temperatura', 1046.0000, 'ºC'),
	(296888, 143, '2015-01-01 01:14:54.000000', 'temperatura', 706.0000, 'ºC'),
	(296889, 143, '2015-01-01 01:14:55.000000', 'temperatura', 392.0000, 'ºC'),
	(296890, 143, '2015-01-01 01:14:56.000000', 'temperatura', 1044.0000, 'ºC'),
	(296891, 143, '2015-01-01 01:14:57.000000', 'temperatura', 446.0000, 'ºC'),
	(296892, 143, '2015-01-01 01:14:58.000000', 'temperatura', 298.0000, 'ºC'),
	(296893, 143, '2015-01-01 01:14:59.000000', 'temperatura', 150.0000, 'ºC'),
	(296894, 143, '2015-01-01 01:15:00.000000', 'temperatura', 1059.0000, 'ºC'),
	(296895, 143, '2015-01-01 01:15:01.000000', 'temperatura', 45.0000, 'ºC'),
	(296896, 143, '2015-01-01 01:15:02.000000', 'temperatura', 647.0000, 'ºC'),
	(296897, 143, '2015-01-01 01:15:03.000000', 'temperatura', 700.0000, 'ºC'),
	(296898, 143, '2015-01-01 01:15:04.000000', 'temperatura', 360.0000, 'ºC'),
	(296899, 143, '2015-01-01 01:15:05.000000', 'temperatura', 902.0000, 'ºC'),
	(296900, 143, '2015-01-01 01:15:06.000000', 'temperatura', 1030.0000, 'ºC'),
	(296901, 143, '2015-01-01 01:15:07.000000', 'temperatura', 45.0000, 'ºC'),
	(296902, 143, '2015-01-01 01:15:08.000000', 'temperatura', 736.0000, 'ºC'),
	(296903, 143, '2015-01-01 01:15:09.000000', 'temperatura', 1145.0000, 'ºC'),
	(296904, 143, '2015-01-01 01:15:10.000000', 'temperatura', 1119.0000, 'ºC'),
	(296905, 143, '2015-01-01 01:15:11.000000', 'temperatura', 959.0000, 'ºC'),
	(296906, 143, '2015-01-01 01:15:12.000000', 'temperatura', 239.0000, 'ºC'),
	(296907, 143, '2015-01-01 01:15:13.000000', 'temperatura', 717.0000, 'ºC'),
	(296908, 143, '2015-01-01 01:15:14.000000', 'temperatura', 470.0000, 'ºC'),
	(296909, 143, '2015-01-01 01:15:15.000000', 'temperatura', 200.0000, 'ºC'),
	(296910, 143, '2015-01-01 01:15:16.000000', 'temperatura', 790.0000, 'ºC'),
	(296911, 143, '2015-01-01 01:15:17.000000', 'temperatura', 950.0000, 'ºC'),
	(296912, 143, '2015-01-01 01:15:18.000000', 'temperatura', 1180.0000, 'ºC'),
	(296913, 143, '2015-01-01 01:15:19.000000', 'temperatura', 652.0000, 'ºC'),
	(296914, 143, '2015-01-01 01:15:20.000000', 'temperatura', 922.0000, 'ºC'),
	(296915, 143, '2015-01-01 01:15:21.000000', 'temperatura', 252.0000, 'ºC'),
	(296916, 143, '2015-01-01 01:15:22.000000', 'temperatura', 897.0000, 'ºC'),
	(296917, 143, '2015-01-01 01:15:23.000000', 'temperatura', 128.0000, 'ºC'),
	(296918, 143, '2015-01-01 01:15:24.000000', 'temperatura', 351.0000, 'ºC'),
	(296919, 143, '2015-01-01 01:15:25.000000', 'temperatura', 169.0000, 'ºC'),
	(296920, 143, '2015-01-01 01:15:26.000000', 'temperatura', 994.0000, 'ºC'),
	(296921, 143, '2015-01-01 01:15:27.000000', 'temperatura', 863.0000, 'ºC'),
	(296922, 143, '2015-01-01 01:15:28.000000', 'temperatura', 135.0000, 'ºC'),
	(296923, 143, '2015-01-01 01:15:29.000000', 'temperatura', 484.0000, 'ºC'),
	(296924, 143, '2015-01-01 01:15:30.000000', 'temperatura', 817.0000, 'ºC'),
	(296925, 143, '2015-01-01 01:15:31.000000', 'temperatura', 233.0000, 'ºC'),
	(296926, 143, '2015-01-01 01:15:32.000000', 'temperatura', 1115.0000, 'ºC'),
	(296927, 143, '2015-01-01 01:15:33.000000', 'temperatura', 77.0000, 'ºC'),
	(296928, 143, '2015-01-01 01:15:34.000000', 'temperatura', 641.0000, 'ºC'),
	(296929, 143, '2015-01-01 01:15:35.000000', 'temperatura', 573.0000, 'ºC'),
	(296930, 143, '2015-01-01 01:15:36.000000', 'temperatura', 945.0000, 'ºC'),
	(296931, 143, '2015-01-01 01:15:37.000000', 'temperatura', 606.0000, 'ºC'),
	(296932, 143, '2015-01-01 01:15:38.000000', 'temperatura', 195.0000, 'ºC'),
	(296933, 143, '2015-01-01 01:15:39.000000', 'temperatura', 356.0000, 'ºC'),
	(296934, 143, '2015-01-01 01:15:40.000000', 'temperatura', 1198.0000, 'ºC'),
	(296935, 143, '2015-01-01 01:15:41.000000', 'temperatura', 123.0000, 'ºC'),
	(296936, 143, '2015-01-01 01:15:42.000000', 'temperatura', 620.0000, 'ºC'),
	(296937, 143, '2015-01-01 01:15:43.000000', 'temperatura', 333.0000, 'ºC'),
	(296938, 143, '2015-01-01 01:15:44.000000', 'temperatura', 1004.0000, 'ºC'),
	(296939, 143, '2015-01-01 01:15:45.000000', 'temperatura', 421.0000, 'ºC'),
	(296940, 143, '2015-01-01 01:15:46.000000', 'temperatura', 292.0000, 'ºC'),
	(296941, 143, '2015-01-01 01:15:47.000000', 'temperatura', 200.0000, 'ºC'),
	(296942, 143, '2015-01-01 01:15:48.000000', 'temperatura', 125.0000, 'ºC'),
	(296943, 143, '2015-01-01 01:15:49.000000', 'temperatura', 27.0000, 'ºC'),
	(296944, 143, '2015-01-01 01:15:50.000000', 'temperatura', 958.0000, 'ºC'),
	(296945, 143, '2015-01-01 01:15:51.000000', 'temperatura', 1110.0000, 'ºC'),
	(296946, 143, '2015-01-01 01:15:52.000000', 'temperatura', 276.0000, 'ºC'),
	(296947, 143, '2015-01-01 01:15:53.000000', 'temperatura', 450.0000, 'ºC'),
	(296948, 143, '2015-01-01 01:15:54.000000', 'temperatura', 224.0000, 'ºC'),
	(296949, 143, '2015-01-01 01:15:55.000000', 'temperatura', 969.0000, 'ºC'),
	(296950, 143, '2015-01-01 01:15:56.000000', 'temperatura', 572.0000, 'ºC'),
	(296951, 143, '2015-01-01 01:15:57.000000', 'temperatura', 1155.0000, 'ºC'),
	(296952, 143, '2015-01-01 01:15:58.000000', 'temperatura', 460.0000, 'ºC'),
	(296953, 143, '2015-01-01 01:15:59.000000', 'temperatura', 36.0000, 'ºC'),
	(296954, 143, '2015-01-01 01:16:00.000000', 'temperatura', 1.0000, 'ºC'),
	(296955, 143, '2015-01-01 01:16:01.000000', 'temperatura', 1096.0000, 'ºC'),
	(296956, 143, '2015-01-01 01:16:02.000000', 'temperatura', 677.0000, 'ºC'),
	(296957, 143, '2015-01-01 01:16:03.000000', 'temperatura', 97.0000, 'ºC'),
	(296958, 143, '2015-01-01 01:16:04.000000', 'temperatura', 855.0000, 'ºC'),
	(296959, 143, '2015-01-01 01:16:05.000000', 'temperatura', 385.0000, 'ºC'),
	(296960, 143, '2015-01-01 01:16:06.000000', 'temperatura', 562.0000, 'ºC'),
	(296961, 143, '2015-01-01 01:16:07.000000', 'temperatura', 455.0000, 'ºC'),
	(296962, 143, '2015-01-01 01:16:08.000000', 'temperatura', 589.0000, 'ºC'),
	(296963, 143, '2015-01-01 01:16:09.000000', 'temperatura', 382.0000, 'ºC'),
	(296964, 143, '2015-01-01 01:16:10.000000', 'temperatura', 144.0000, 'ºC'),
	(296965, 143, '2015-01-01 01:16:11.000000', 'temperatura', 773.0000, 'ºC'),
	(296966, 143, '2015-01-01 01:16:12.000000', 'temperatura', 1034.0000, 'ºC'),
	(296967, 143, '2015-01-01 01:16:13.000000', 'temperatura', 452.0000, 'ºC'),
	(296968, 143, '2015-01-01 01:16:14.000000', 'temperatura', 356.0000, 'ºC'),
	(296969, 143, '2015-01-01 01:16:15.000000', 'temperatura', 428.0000, 'ºC'),
	(296970, 143, '2015-01-01 01:16:16.000000', 'temperatura', 1070.0000, 'ºC'),
	(296971, 143, '2015-01-01 01:16:17.000000', 'temperatura', 469.0000, 'ºC'),
	(296972, 143, '2015-01-01 01:16:18.000000', 'temperatura', 335.0000, 'ºC'),
	(296973, 143, '2015-01-01 01:16:19.000000', 'temperatura', 269.0000, 'ºC'),
	(296974, 143, '2015-01-01 01:16:20.000000', 'temperatura', 338.0000, 'ºC'),
	(296975, 143, '2015-01-01 01:16:21.000000', 'temperatura', 887.0000, 'ºC'),
	(296976, 143, '2015-01-01 01:16:22.000000', 'temperatura', 1018.0000, 'ºC'),
	(296977, 143, '2015-01-01 01:16:23.000000', 'temperatura', 32.0000, 'ºC'),
	(296978, 143, '2015-01-01 01:16:24.000000', 'temperatura', 707.0000, 'ºC'),
	(296979, 143, '2015-01-01 01:16:25.000000', 'temperatura', 1040.0000, 'ºC'),
	(296980, 143, '2015-01-01 01:16:26.000000', 'temperatura', 678.0000, 'ºC'),
	(296981, 143, '2015-01-01 01:16:27.000000', 'temperatura', 269.0000, 'ºC'),
	(296982, 143, '2015-01-01 01:16:28.000000', 'temperatura', 514.0000, 'ºC'),
	(296983, 143, '2015-01-01 01:16:29.000000', 'temperatura', 561.0000, 'ºC'),
	(296984, 143, '2015-01-01 01:16:30.000000', 'temperatura', 64.0000, 'ºC'),
	(296985, 143, '2015-01-01 01:16:31.000000', 'temperatura', 1036.0000, 'ºC'),
	(296986, 143, '2015-01-01 01:16:32.000000', 'temperatura', 192.0000, 'ºC'),
	(296987, 143, '2015-01-01 01:16:33.000000', 'temperatura', 251.0000, 'ºC'),
	(296988, 143, '2015-01-01 01:16:34.000000', 'temperatura', 678.0000, 'ºC'),
	(296989, 143, '2015-01-01 01:16:35.000000', 'temperatura', 237.0000, 'ºC'),
	(296990, 143, '2015-01-01 01:16:36.000000', 'temperatura', 351.0000, 'ºC'),
	(296991, 143, '2015-01-01 01:16:37.000000', 'temperatura', 1047.0000, 'ºC'),
	(296992, 143, '2015-01-01 01:16:38.000000', 'temperatura', 580.0000, 'ºC'),
	(296993, 143, '2015-01-01 01:16:39.000000', 'temperatura', 962.0000, 'ºC'),
	(296994, 143, '2015-01-01 01:16:40.000000', 'temperatura', 671.0000, 'ºC'),
	(296995, 143, '2015-01-01 01:16:41.000000', 'temperatura', 470.0000, 'ºC'),
	(296996, 143, '2015-01-01 01:16:42.000000', 'temperatura', 335.0000, 'ºC'),
	(296997, 143, '2015-01-01 01:16:43.000000', 'temperatura', 266.0000, 'ºC'),
	(296998, 143, '2015-01-01 01:16:44.000000', 'temperatura', 325.0000, 'ºC'),
	(296999, 143, '2015-01-01 01:16:45.000000', 'temperatura', 829.0000, 'ºC'),
	(297000, 143, '2015-01-01 01:16:46.000000', 'temperatura', 770.0000, 'ºC'),
	(297001, 143, '2015-01-01 01:16:47.000000', 'temperatura', 163.0000, 'ºC'),
	(297002, 143, '2015-01-01 01:16:48.000000', 'temperatura', 907.0000, 'ºC'),
	(297003, 143, '2015-01-01 01:16:49.000000', 'temperatura', 444.0000, 'ºC'),
	(297004, 143, '2015-01-01 01:16:50.000000', 'temperatura', 700.0000, 'ºC'),
	(297005, 143, '2015-01-01 01:16:51.000000', 'temperatura', 967.0000, 'ºC'),
	(297006, 143, '2015-01-01 01:16:52.000000', 'temperatura', 338.0000, 'ºC'),
	(297007, 143, '2015-01-01 01:16:53.000000', 'temperatura', 1187.0000, 'ºC'),
	(297008, 143, '2015-01-01 01:16:54.000000', 'temperatura', 121.0000, 'ºC'),
	(297009, 143, '2015-01-01 01:16:55.000000', 'temperatura', 647.0000, 'ºC'),
	(297010, 143, '2015-01-01 01:16:56.000000', 'temperatura', 472.0000, 'ºC'),
	(297011, 143, '2015-01-01 01:16:57.000000', 'temperatura', 417.0000, 'ºC'),
	(297012, 143, '2015-01-01 01:16:58.000000', 'temperatura', 671.0000, 'ºC'),
	(297013, 143, '2015-01-01 01:16:59.000000', 'temperatura', 906.0000, 'ºC'),
	(297014, 143, '2015-01-01 01:17:00.000000', 'temperatura', 118.0000, 'ºC'),
	(297015, 143, '2015-01-01 01:17:01.000000', 'temperatura', 272.0000, 'ºC'),
	(297016, 143, '2015-01-01 01:17:02.000000', 'temperatura', 1008.0000, 'ºC'),
	(297017, 143, '2015-01-01 01:17:03.000000', 'temperatura', 624.0000, 'ºC'),
	(297018, 143, '2015-01-01 01:17:04.000000', 'temperatura', 97.0000, 'ºC'),
	(297019, 143, '2015-01-01 01:17:05.000000', 'temperatura', 1012.0000, 'ºC'),
	(297020, 143, '2015-01-01 01:17:06.000000', 'temperatura', 1172.0000, 'ºC'),
	(297021, 143, '2015-01-01 01:17:07.000000', 'temperatura', 423.0000, 'ºC'),
	(297022, 143, '2015-01-01 01:17:08.000000', 'temperatura', 998.0000, 'ºC'),
	(297023, 143, '2015-01-01 01:17:09.000000', 'temperatura', 125.0000, 'ºC'),
	(297024, 143, '2015-01-01 01:17:10.000000', 'temperatura', 28.0000, 'ºC'),
	(297025, 143, '2015-01-01 01:17:11.000000', 'temperatura', 967.0000, 'ºC'),
	(297026, 143, '2015-01-01 01:17:12.000000', 'temperatura', 1152.0000, 'ºC'),
	(297027, 143, '2015-01-01 01:17:13.000000', 'temperatura', 460.0000, 'ºC'),
	(297028, 143, '2015-01-01 01:17:14.000000', 'temperatura', 42.0000, 'ºC'),
	(297029, 143, '2015-01-01 01:17:15.000000', 'temperatura', 32.0000, 'ºC'),
	(297030, 143, '2015-01-01 01:17:16.000000', 'temperatura', 34.0000, 'ºC'),
	(297031, 143, '2015-01-01 01:17:17.000000', 'temperatura', 74.0000, 'ºC'),
	(297032, 143, '2015-01-01 01:17:18.000000', 'temperatura', 270.0000, 'ºC'),
	(297033, 143, '2015-01-01 01:17:19.000000', 'temperatura', 1127.0000, 'ºC'),
	(297034, 143, '2015-01-01 01:17:20.000000', 'temperatura', 27.0000, 'ºC'),
	(297035, 143, '2015-01-01 01:17:21.000000', 'temperatura', 352.0000, 'ºC'),
	(297036, 143, '2015-01-01 01:17:22.000000', 'temperatura', 483.0000, 'ºC'),
	(297037, 143, '2015-01-01 01:17:23.000000', 'temperatura', 156.0000, 'ºC'),
	(297038, 143, '2015-01-01 01:17:24.000000', 'temperatura', 534.0000, 'ºC'),
	(297039, 143, '2015-01-01 01:17:25.000000', 'temperatura', 1002.0000, 'ºC'),
	(297040, 143, '2015-01-01 01:17:26.000000', 'temperatura', 1007.0000, 'ºC'),
	(297041, 143, '2015-01-01 01:17:27.000000', 'temperatura', 829.0000, 'ºC'),
	(297042, 143, '2015-01-01 01:17:28.000000', 'temperatura', 1124.0000, 'ºC'),
	(297043, 143, '2015-01-01 01:17:29.000000', 'temperatura', 733.0000, 'ºC'),
	(297044, 143, '2015-01-01 01:17:30.000000', 'temperatura', 296.0000, 'ºC'),
	(297045, 143, '2015-01-01 01:17:31.000000', 'temperatura', 481.0000, 'ºC'),
	(297046, 143, '2015-01-01 01:17:32.000000', 'temperatura', 318.0000, 'ºC'),
	(297047, 143, '2015-01-01 01:17:33.000000', 'temperatura', 146.0000, 'ºC'),
	(297048, 143, '2015-01-01 01:17:34.000000', 'temperatura', 979.0000, 'ºC'),
	(297049, 143, '2015-01-01 01:17:35.000000', 'temperatura', 856.0000, 'ºC'),
	(297050, 143, '2015-01-01 01:17:36.000000', 'temperatura', 144.0000, 'ºC'),
	(297051, 143, '2015-01-01 01:17:37.000000', 'temperatura', 552.0000, 'ºC'),
	(297052, 143, '2015-01-01 01:17:38.000000', 'temperatura', 1127.0000, 'ºC'),
	(297053, 143, '2015-01-01 01:17:39.000000', 'temperatura', 382.0000, 'ºC'),
	(297054, 143, '2015-01-01 01:17:40.000000', 'temperatura', 930.0000, 'ºC'),
	(297055, 143, '2015-01-01 01:17:41.000000', 'temperatura', 1105.0000, 'ºC'),
	(297056, 143, '2015-01-01 01:17:42.000000', 'temperatura', 336.0000, 'ºC'),
	(297057, 143, '2015-01-01 01:17:43.000000', 'temperatura', 766.0000, 'ºC'),
	(297058, 143, '2015-01-01 01:17:44.000000', 'temperatura', 422.0000, 'ºC'),
	(297059, 143, '2015-01-01 01:17:45.000000', 'temperatura', 1012.0000, 'ºC'),
	(297060, 143, '2015-01-01 01:17:46.000000', 'temperatura', 194.0000, 'ºC'),
	(297061, 143, '2015-01-01 01:17:47.000000', 'temperatura', 337.0000, 'ºC'),
	(297062, 143, '2015-01-01 01:17:48.000000', 'temperatura', 1102.0000, 'ºC'),
	(297063, 143, '2015-01-01 01:17:49.000000', 'temperatura', 900.0000, 'ºC'),
	(297064, 143, '2015-01-01 01:17:50.000000', 'temperatura', 1194.0000, 'ºC'),
	(297065, 143, '2015-01-01 01:17:51.000000', 'temperatura', 871.0000, 'ºC'),
	(297066, 143, '2015-01-01 01:17:52.000000', 'temperatura', 775.0000, 'ºC'),
	(297067, 143, '2015-01-01 01:17:53.000000', 'temperatura', 61.0000, 'ºC'),
	(297068, 143, '2015-01-01 01:17:54.000000', 'temperatura', 379.0000, 'ºC'),
	(297069, 143, '2015-01-01 01:17:55.000000', 'temperatura', 513.0000, 'ºC'),
	(297070, 143, '2015-01-01 01:17:56.000000', 'temperatura', 229.0000, 'ºC'),
	(297071, 143, '2015-01-01 01:17:57.000000', 'temperatura', 805.0000, 'ºC'),
	(297072, 143, '2015-01-01 01:17:58.000000', 'temperatura', 939.0000, 'ºC'),
	(297073, 143, '2015-01-01 01:17:59.000000', 'temperatura', 1083.0000, 'ºC'),
	(297074, 143, '2015-01-01 01:18:00.000000', 'temperatura', 197.0000, 'ºC'),
	(297075, 143, '2015-01-01 01:18:01.000000', 'temperatura', 136.0000, 'ºC'),
	(297076, 143, '2015-01-01 01:18:02.000000', 'temperatura', 88.0000, 'ºC'),
	(297077, 143, '2015-01-01 01:18:03.000000', 'temperatura', 34.0000, 'ºC'),
	(297078, 143, '2015-01-01 01:18:04.000000', 'temperatura', 1105.0000, 'ºC'),
	(297079, 143, '2015-01-01 01:18:05.000000', 'temperatura', 627.0000, 'ºC'),
	(297080, 143, '2015-01-01 01:18:06.000000', 'temperatura', 1017.0000, 'ºC'),
	(297081, 143, '2015-01-01 01:18:07.000000', 'temperatura', 804.0000, 'ºC'),
	(297082, 143, '2015-01-01 01:18:08.000000', 'temperatura', 971.0000, 'ºC'),
	(297083, 143, '2015-01-01 01:18:09.000000', 'temperatura', 45.0000, 'ºC'),
	(297084, 143, '2015-01-01 01:18:10.000000', 'temperatura', 913.0000, 'ºC'),
	(297085, 143, '2015-01-01 01:18:11.000000', 'temperatura', 828.0000, 'ºC'),
	(297086, 143, '2015-01-01 01:18:12.000000', 'temperatura', 204.0000, 'ºC'),
	(297087, 143, '2015-01-01 01:18:13.000000', 'temperatura', 934.0000, 'ºC'),
	(297088, 143, '2015-01-01 01:18:14.000000', 'temperatura', 458.0000, 'ºC'),
	(297089, 143, '2015-01-01 01:18:15.000000', 'temperatura', 692.0000, 'ºC'),
	(297090, 143, '2015-01-01 01:18:16.000000', 'temperatura', 883.0000, 'ºC'),
	(297091, 143, '2015-01-01 01:18:17.000000', 'temperatura', 1142.0000, 'ºC'),
	(297092, 143, '2015-01-01 01:18:18.000000', 'temperatura', 661.0000, 'ºC'),
	(297093, 143, '2015-01-01 01:18:19.000000', 'temperatura', 1077.0000, 'ºC'),
	(297094, 143, '2015-01-01 01:18:20.000000', 'temperatura', 1006.0000, 'ºC'),
	(297095, 143, '2015-01-01 01:18:21.000000', 'temperatura', 596.0000, 'ºC'),
	(297096, 143, '2015-01-01 01:18:22.000000', 'temperatura', 1164.0000, 'ºC'),
	(297097, 143, '2015-01-01 01:18:23.000000', 'temperatura', 433.0000, 'ºC'),
	(297098, 143, '2015-01-01 01:18:24.000000', 'temperatura', 1072.0000, 'ºC'),
	(297099, 143, '2015-01-01 01:18:25.000000', 'temperatura', 463.0000, 'ºC'),
	(297100, 143, '2015-01-01 01:18:26.000000', 'temperatura', 298.0000, 'ºC'),
	(297101, 143, '2015-01-01 01:18:27.000000', 'temperatura', 103.0000, 'ºC'),
	(297102, 143, '2015-01-01 01:18:28.000000', 'temperatura', 821.0000, 'ºC'),
	(297103, 143, '2015-01-01 01:18:29.000000', 'temperatura', 198.0000, 'ºC'),
	(297104, 143, '2015-01-01 01:18:30.000000', 'temperatura', 926.0000, 'ºC'),
	(297105, 143, '2015-01-01 01:18:31.000000', 'temperatura', 437.0000, 'ºC'),
	(297106, 143, '2015-01-01 01:18:32.000000', 'temperatura', 606.0000, 'ºC'),
	(297107, 143, '2015-01-01 01:18:33.000000', 'temperatura', 520.0000, 'ºC'),
	(297108, 143, '2015-01-01 01:18:34.000000', 'temperatura', 782.0000, 'ºC'),
	(297109, 143, '2015-01-01 01:18:35.000000', 'temperatura', 1149.0000, 'ºC'),
	(297110, 143, '2015-01-01 01:18:36.000000', 'temperatura', 1001.0000, 'ºC'),
	(297111, 143, '2015-01-01 01:18:37.000000', 'temperatura', 360.0000, 'ºC'),
	(297112, 143, '2015-01-01 01:18:38.000000', 'temperatura', 1195.0000, 'ºC'),
	(297113, 143, '2015-01-01 01:18:39.000000', 'temperatura', 96.0000, 'ºC'),
	(297114, 143, '2015-01-01 01:18:40.000000', 'temperatura', 495.0000, 'ºC'),
	(297115, 143, '2015-01-01 01:18:41.000000', 'temperatura', 986.0000, 'ºC'),
	(297116, 143, '2015-01-01 01:18:42.000000', 'temperatura', 1047.0000, 'ºC'),
	(297117, 143, '2015-01-01 01:18:43.000000', 'temperatura', 1079.0000, 'ºC'),
	(297118, 143, '2015-01-01 01:18:44.000000', 'temperatura', 1054.0000, 'ºC'),
	(297119, 143, '2015-01-01 01:18:45.000000', 'temperatura', 835.0000, 'ºC'),
	(297120, 143, '2015-01-01 01:18:46.000000', 'temperatura', 1012.0000, 'ºC'),
	(297121, 143, '2015-01-01 01:18:47.000000', 'temperatura', 157.0000, 'ºC'),
	(297122, 143, '2015-01-01 01:18:48.000000', 'temperatura', 148.0000, 'ºC'),
	(297123, 143, '2015-01-01 01:18:49.000000', 'temperatura', 269.0000, 'ºC'),
	(297124, 143, '2015-01-01 01:18:50.000000', 'temperatura', 901.0000, 'ºC'),
	(297125, 143, '2015-01-01 01:18:51.000000', 'temperatura', 101.0000, 'ºC'),
	(297126, 143, '2015-01-01 01:18:52.000000', 'temperatura', 203.0000, 'ºC'),
	(297127, 143, '2015-01-01 01:18:53.000000', 'temperatura', 711.0000, 'ºC'),
	(297128, 143, '2015-01-01 01:18:54.000000', 'temperatura', 546.0000, 'ºC'),
	(297129, 143, '2015-01-01 01:18:55.000000', 'temperatura', 600.0000, 'ºC'),
	(297130, 143, '2015-01-01 01:18:56.000000', 'temperatura', 160.0000, 'ºC'),
	(297131, 143, '2015-01-01 01:18:57.000000', 'temperatura', 202.0000, 'ºC'),
	(297132, 143, '2015-01-01 01:18:58.000000', 'temperatura', 532.0000, 'ºC'),
	(297133, 143, '2015-01-01 01:18:59.000000', 'temperatura', 852.0000, 'ºC'),
	(297134, 143, '2015-01-01 01:19:00.000000', 'temperatura', 266.0000, 'ºC'),
	(297135, 143, '2015-01-01 01:19:01.000000', 'temperatura', 1172.0000, 'ºC'),
	(297136, 143, '2015-01-01 01:19:02.000000', 'temperatura', 266.0000, 'ºC'),
	(297137, 143, '2015-01-01 01:19:03.000000', 'temperatura', 212.0000, 'ºC'),
	(297138, 143, '2015-01-01 01:19:04.000000', 'temperatura', 262.0000, 'ºC'),
	(297139, 143, '2015-01-01 01:19:05.000000', 'temperatura', 674.0000, 'ºC'),
	(297140, 143, '2015-01-01 01:19:06.000000', 'temperatura', 184.0000, 'ºC'),
	(297141, 143, '2015-01-01 01:19:07.000000', 'temperatura', 100.0000, 'ºC'),
	(297142, 143, '2015-01-01 01:19:08.000000', 'temperatura', 1147.0000, 'ºC'),
	(297143, 143, '2015-01-01 01:19:09.000000', 'temperatura', 638.0000, 'ºC'),
	(297144, 143, '2015-01-01 01:19:10.000000', 'temperatura', 948.0000, 'ºC'),
	(297145, 143, '2015-01-01 01:19:11.000000', 'temperatura', 429.0000, 'ºC'),
	(297146, 143, '2015-01-01 01:19:12.000000', 'temperatura', 498.0000, 'ºC'),
	(297147, 143, '2015-01-01 01:19:13.000000', 'temperatura', 7.0000, 'ºC'),
	(297148, 143, '2015-01-01 01:19:14.000000', 'temperatura', 939.0000, 'ºC'),
	(297149, 143, '2015-01-01 01:19:15.000000', 'temperatura', 1077.0000, 'ºC'),
	(297150, 143, '2015-01-01 01:19:16.000000', 'temperatura', 167.0000, 'ºC'),
	(297151, 143, '2015-01-01 01:19:17.000000', 'temperatura', 7.0000, 'ºC'),
	(297152, 143, '2015-01-01 01:19:18.000000', 'temperatura', 731.0000, 'ºC'),
	(297153, 143, '2015-01-01 01:19:19.000000', 'temperatura', 35.0000, 'ºC'),
	(297154, 143, '2015-01-01 01:19:20.000000', 'temperatura', 382.0000, 'ºC'),
	(297155, 143, '2015-01-01 01:19:21.000000', 'temperatura', 607.0000, 'ºC'),
	(297156, 143, '2015-01-01 01:19:22.000000', 'temperatura', 690.0000, 'ºC'),
	(297157, 143, '2015-01-01 01:19:23.000000', 'temperatura', 427.0000, 'ºC'),
	(297158, 143, '2015-01-01 01:19:24.000000', 'temperatura', 68.0000, 'ºC'),
	(297159, 143, '2015-01-01 01:19:25.000000', 'temperatura', 261.0000, 'ºC'),
	(297160, 143, '2015-01-01 01:19:26.000000', 'temperatura', 1098.0000, 'ºC'),
	(297161, 143, '2015-01-01 01:19:27.000000', 'temperatura', 1110.0000, 'ºC'),
	(297162, 143, '2015-01-01 01:19:28.000000', 'temperatura', 1057.0000, 'ºC'),
	(297163, 143, '2015-01-01 01:19:29.000000', 'temperatura', 753.0000, 'ºC'),
	(297164, 143, '2015-01-01 01:19:30.000000', 'temperatura', 595.0000, 'ºC'),
	(297165, 143, '2015-01-01 01:19:31.000000', 'temperatura', 719.0000, 'ºC'),
	(297166, 143, '2015-01-01 01:19:32.000000', 'temperatura', 608.0000, 'ºC'),
	(297167, 143, '2015-01-01 01:19:33.000000', 'temperatura', 884.0000, 'ºC'),
	(297168, 143, '2015-01-01 01:19:34.000000', 'temperatura', 196.0000, 'ºC'),
	(297169, 143, '2015-01-01 01:19:35.000000', 'temperatura', 729.0000, 'ºC'),
	(297170, 143, '2015-01-01 01:19:36.000000', 'temperatura', 658.0000, 'ºC'),
	(297171, 143, '2015-01-01 01:19:37.000000', 'temperatura', 1105.0000, 'ºC'),
	(297172, 143, '2015-01-01 01:19:38.000000', 'temperatura', 1150.0000, 'ºC'),
	(297173, 143, '2015-01-01 01:19:39.000000', 'temperatura', 36.0000, 'ºC'),
	(297174, 143, '2015-01-01 01:19:40.000000', 'temperatura', 330.0000, 'ºC'),
	(297175, 143, '2015-01-01 01:19:41.000000', 'temperatura', 341.0000, 'ºC'),
	(297176, 143, '2015-01-01 01:19:42.000000', 'temperatura', 715.0000, 'ºC'),
	(297177, 143, '2015-01-01 01:19:43.000000', 'temperatura', 153.0000, 'ºC'),
	(297178, 143, '2015-01-01 01:19:44.000000', 'temperatura', 1022.0000, 'ºC'),
	(297179, 143, '2015-01-01 01:19:45.000000', 'temperatura', 1052.0000, 'ºC'),
	(297180, 143, '2015-01-01 01:19:46.000000', 'temperatura', 995.0000, 'ºC'),
	(297181, 143, '2015-01-01 01:19:47.000000', 'temperatura', 619.0000, 'ºC'),
	(297182, 143, '2015-01-01 01:19:48.000000', 'temperatura', 108.0000, 'ºC'),
	(297183, 143, '2015-01-01 01:19:49.000000', 'temperatura', 1087.0000, 'ºC'),
	(297184, 143, '2015-01-01 01:19:50.000000', 'temperatura', 308.0000, 'ºC'),
	(297185, 143, '2015-01-01 01:19:51.000000', 'temperatura', 682.0000, 'ºC'),
	(297186, 143, '2015-01-01 01:19:52.000000', 'temperatura', 84.0000, 'ºC'),
	(297187, 143, '2015-01-01 01:19:53.000000', 'temperatura', 776.0000, 'ºC'),
	(297188, 143, '2015-01-01 01:19:54.000000', 'temperatura', 30.0000, 'ºC'),
	(297189, 143, '2015-01-01 01:19:55.000000', 'temperatura', 220.0000, 'ºC'),
	(297190, 143, '2015-01-01 01:19:56.000000', 'temperatura', 1012.0000, 'ºC'),
	(297191, 143, '2015-01-01 01:19:57.000000', 'temperatura', 799.0000, 'ºC'),
	(297192, 143, '2015-01-01 01:19:58.000000', 'temperatura', 961.0000, 'ºC'),
	(297193, 143, '2015-01-01 01:19:59.000000', 'temperatura', 9.0000, 'ºC'),
	(297194, 143, '2015-01-01 01:20:00.000000', 'temperatura', 763.0000, 'ºC'),
	(297195, 143, '2015-01-01 01:20:01.000000', 'temperatura', 188.0000, 'ºC'),
	(297196, 143, '2015-01-01 01:20:02.000000', 'temperatura', 1051.0000, 'ºC'),
	(297197, 143, '2015-01-01 01:20:03.000000', 'temperatura', 1091.0000, 'ºC'),
	(297198, 143, '2015-01-01 01:20:04.000000', 'temperatura', 1104.0000, 'ºC'),
	(297199, 143, '2015-01-01 01:20:05.000000', 'temperatura', 1046.0000, 'ºC'),
	(297200, 143, '2015-01-01 01:20:06.000000', 'temperatura', 720.0000, 'ºC'),
	(297201, 143, '2015-01-01 01:20:07.000000', 'temperatura', 463.0000, 'ºC'),
	(297202, 143, '2015-01-01 01:20:08.000000', 'temperatura', 154.0000, 'ºC'),
	(297203, 143, '2015-01-01 01:20:09.000000', 'temperatura', 582.0000, 'ºC'),
	(297204, 143, '2015-01-01 01:20:10.000000', 'temperatura', 49.0000, 'ºC'),
	(297205, 143, '2015-01-01 01:20:11.000000', 'temperatura', 899.0000, 'ºC'),
	(297206, 143, '2015-01-01 01:20:12.000000', 'temperatura', 750.0000, 'ºC'),
	(297207, 143, '2015-01-01 01:20:13.000000', 'temperatura', 1054.0000, 'ºC'),
	(297208, 143, '2015-01-01 01:20:14.000000', 'temperatura', 619.0000, 'ºC'),
	(297209, 143, '2015-01-01 01:20:15.000000', 'temperatura', 1135.0000, 'ºC'),
	(297210, 143, '2015-01-01 01:20:16.000000', 'temperatura', 216.0000, 'ºC'),
	(297211, 143, '2015-01-01 01:20:17.000000', 'temperatura', 77.0000, 'ºC'),
	(297212, 143, '2015-01-01 01:20:18.000000', 'temperatura', 938.0000, 'ºC'),
	(297213, 143, '2015-01-01 01:20:19.000000', 'temperatura', 858.0000, 'ºC'),
	(297214, 143, '2015-01-01 01:20:20.000000', 'temperatura', 275.0000, 'ºC'),
	(297215, 143, '2015-01-01 01:20:21.000000', 'temperatura', 5.0000, 'ºC'),
	(297216, 143, '2015-01-01 01:20:22.000000', 'temperatura', 398.0000, 'ºC'),
	(297217, 143, '2015-01-01 01:20:23.000000', 'temperatura', 775.0000, 'ºC'),
	(297218, 143, '2015-01-01 01:20:24.000000', 'temperatura', 281.0000, 'ºC'),
	(297219, 143, '2015-01-01 01:20:25.000000', 'temperatura', 280.0000, 'ºC'),
	(297220, 143, '2015-01-01 01:20:26.000000', 'temperatura', 560.0000, 'ºC'),
	(297221, 143, '2015-01-01 01:20:27.000000', 'temperatura', 760.0000, 'ºC'),
	(297222, 143, '2015-01-01 01:20:28.000000', 'temperatura', 919.0000, 'ºC'),
	(297223, 143, '2015-01-01 01:20:29.000000', 'temperatura', 1114.0000, 'ºC'),
	(297224, 143, '2015-01-01 01:20:30.000000', 'temperatura', 416.0000, 'ºC'),
	(297225, 143, '2015-01-01 01:20:31.000000', 'temperatura', 1139.0000, 'ºC'),
	(297226, 143, '2015-01-01 01:20:32.000000', 'temperatura', 847.0000, 'ºC'),
	(297227, 143, '2015-01-01 01:20:33.000000', 'temperatura', 817.0000, 'ºC'),
	(297228, 143, '2015-01-01 01:20:34.000000', 'temperatura', 345.0000, 'ºC'),
	(297229, 143, '2015-01-01 01:20:35.000000', 'temperatura', 475.0000, 'ºC'),
	(297230, 143, '2015-01-01 01:20:36.000000', 'temperatura', 139.0000, 'ºC'),
	(297231, 143, '2015-01-01 01:20:37.000000', 'temperatura', 472.0000, 'ºC'),
	(297232, 143, '2015-01-01 01:20:38.000000', 'temperatura', 744.0000, 'ºC'),
	(297233, 143, '2015-01-01 01:20:39.000000', 'temperatura', 1103.0000, 'ºC'),
	(297234, 143, '2015-01-01 01:20:40.000000', 'temperatura', 886.0000, 'ºC'),
	(297235, 143, '2015-01-01 01:20:41.000000', 'temperatura', 1120.0000, 'ºC'),
	(297236, 143, '2015-01-01 01:20:42.000000', 'temperatura', 544.0000, 'ºC'),
	(297237, 143, '2015-01-01 01:20:43.000000', 'temperatura', 561.0000, 'ºC'),
	(297238, 143, '2015-01-01 01:20:44.000000', 'temperatura', 1171.0000, 'ºC'),
	(297239, 143, '2015-01-01 01:20:45.000000', 'temperatura', 575.0000, 'ºC'),
	(297240, 143, '2015-01-01 01:20:46.000000', 'temperatura', 563.0000, 'ºC'),
	(297241, 143, '2015-01-01 01:20:47.000000', 'temperatura', 1089.0000, 'ºC'),
	(297242, 143, '2015-01-01 01:20:48.000000', 'temperatura', 155.0000, 'ºC'),
	(297243, 143, '2015-01-01 01:20:49.000000', 'temperatura', 1111.0000, 'ºC'),
	(297244, 143, '2015-01-01 01:20:50.000000', 'temperatura', 290.0000, 'ºC'),
	(297245, 143, '2015-01-01 01:20:51.000000', 'temperatura', 519.0000, 'ºC'),
	(297246, 143, '2015-01-01 01:20:52.000000', 'temperatura', 523.0000, 'ºC'),
	(297247, 143, '2015-01-01 01:20:53.000000', 'temperatura', 1060.0000, 'ºC'),
	(297248, 143, '2015-01-01 01:20:54.000000', 'temperatura', 133.0000, 'ºC'),
	(297249, 143, '2015-01-01 01:20:55.000000', 'temperatura', 1083.0000, 'ºC'),
	(297250, 143, '2015-01-01 01:20:56.000000', 'temperatura', 215.0000, 'ºC'),
	(297251, 143, '2015-01-01 01:20:57.000000', 'temperatura', 230.0000, 'ºC'),
	(297252, 143, '2015-01-01 01:20:58.000000', 'temperatura', 505.0000, 'ºC'),
	(297253, 143, '2015-01-01 01:20:59.000000', 'temperatura', 634.0000, 'ºC'),
	(297254, 143, '2015-01-01 01:21:00.000000', 'temperatura', 456.0000, 'ºC'),
	(297255, 143, '2015-01-01 01:21:01.000000', 'temperatura', 380.0000, 'ºC'),
	(297256, 143, '2015-01-01 01:21:02.000000', 'temperatura', 531.0000, 'ºC'),
	(297257, 143, '2015-01-01 01:21:03.000000', 'temperatura', 314.0000, 'ºC'),
	(297258, 143, '2015-01-01 01:21:04.000000', 'temperatura', 1180.0000, 'ºC'),
	(297259, 143, '2015-01-01 01:21:05.000000', 'temperatura', 156.0000, 'ºC'),
	(297260, 143, '2015-01-01 01:21:06.000000', 'temperatura', 841.0000, 'ºC'),
	(297261, 143, '2015-01-01 01:21:07.000000', 'temperatura', 139.0000, 'ºC'),
	(297262, 143, '2015-01-01 01:21:08.000000', 'temperatura', 571.0000, 'ºC'),
	(297263, 143, '2015-01-01 01:21:09.000000', 'temperatura', 40.0000, 'ºC'),
	(297264, 143, '2015-01-01 01:21:10.000000', 'temperatura', 887.0000, 'ºC'),
	(297265, 143, '2015-01-01 01:21:11.000000', 'temperatura', 715.0000, 'ºC'),
	(297266, 143, '2015-01-01 01:21:12.000000', 'temperatura', 916.0000, 'ºC'),
	(297267, 143, '2015-01-01 01:21:13.000000', 'temperatura', 36.0000, 'ºC'),
	(297268, 143, '2015-01-01 01:21:14.000000', 'temperatura', 1032.0000, 'ºC'),
	(297269, 143, '2015-01-01 01:21:15.000000', 'temperatura', 254.0000, 'ºC'),
	(297270, 143, '2015-01-01 01:21:16.000000', 'temperatura', 573.0000, 'ºC'),
	(297271, 143, '2015-01-01 01:21:17.000000', 'temperatura', 902.0000, 'ºC'),
	(297272, 143, '2015-01-01 01:21:18.000000', 'temperatura', 395.0000, 'ºC'),
	(297273, 143, '2015-01-01 01:21:19.000000', 'temperatura', 466.0000, 'ºC'),
	(297274, 143, '2015-01-01 01:21:20.000000', 'temperatura', 1147.0000, 'ºC'),
	(297275, 143, '2015-01-01 01:21:21.000000', 'temperatura', 738.0000, 'ºC'),
	(297276, 143, '2015-01-01 01:21:22.000000', 'temperatura', 249.0000, 'ºC'),
	(297277, 143, '2015-01-01 01:21:23.000000', 'temperatura', 233.0000, 'ºC'),
	(297278, 143, '2015-01-01 01:21:24.000000', 'temperatura', 419.0000, 'ºC'),
	(297279, 143, '2015-01-01 01:21:25.000000', 'temperatura', 195.0000, 'ºC'),
	(297280, 143, '2015-01-01 01:21:26.000000', 'temperatura', 919.0000, 'ºC'),
	(297281, 143, '2015-01-01 01:21:27.000000', 'temperatura', 412.0000, 'ºC'),
	(297282, 143, '2015-01-01 01:21:28.000000', 'temperatura', 503.0000, 'ºC'),
	(297283, 143, '2015-01-01 01:21:29.000000', 'temperatura', 81.0000, 'ºC'),
	(297284, 143, '2015-01-01 01:21:30.000000', 'temperatura', 95.0000, 'ºC'),
	(297285, 143, '2015-01-01 01:21:31.000000', 'temperatura', 233.0000, 'ºC'),
	(297286, 143, '2015-01-01 01:21:32.000000', 'temperatura', 879.0000, 'ºC'),
	(297287, 143, '2015-01-01 01:21:33.000000', 'temperatura', 96.0000, 'ºC'),
	(297288, 143, '2015-01-01 01:21:34.000000', 'temperatura', 243.0000, 'ºC'),
	(297289, 143, '2015-01-01 01:21:35.000000', 'temperatura', 930.0000, 'ºC'),
	(297290, 143, '2015-01-01 01:21:36.000000', 'temperatura', 322.0000, 'ºC'),
	(297291, 143, '2015-01-01 01:21:37.000000', 'temperatura', 21.0000, 'ºC'),
	(297292, 143, '2015-01-01 01:21:38.000000', 'temperatura', 339.0000, 'ºC'),
	(297293, 143, '2015-01-01 01:21:39.000000', 'temperatura', 431.0000, 'ºC'),
	(297294, 143, '2015-01-01 01:21:40.000000', 'temperatura', 1141.0000, 'ºC'),
	(297295, 143, '2015-01-01 01:21:41.000000', 'temperatura', 811.0000, 'ºC'),
	(297296, 143, '2015-01-01 01:21:42.000000', 'temperatura', 633.0000, 'ºC'),
	(297297, 143, '2015-01-01 01:21:43.000000', 'temperatura', 734.0000, 'ºC'),
	(297298, 143, '2015-01-01 01:21:44.000000', 'temperatura', 572.0000, 'ºC'),
	(297299, 143, '2015-01-01 01:21:45.000000', 'temperatura', 655.0000, 'ºC'),
	(297300, 143, '2015-01-01 01:21:46.000000', 'temperatura', 363.0000, 'ºC'),
	(297301, 143, '2015-01-01 01:21:47.000000', 'temperatura', 1048.0000, 'ºC'),
	(297302, 143, '2015-01-01 01:21:48.000000', 'temperatura', 553.0000, 'ºC'),
	(297303, 143, '2015-01-01 01:21:49.000000', 'temperatura', 820.0000, 'ºC'),
	(297304, 143, '2015-01-01 01:21:50.000000', 'temperatura', 42.0000, 'ºC'),
	(297305, 143, '2015-01-01 01:21:51.000000', 'temperatura', 151.0000, 'ºC'),
	(297306, 143, '2015-01-01 01:21:52.000000', 'temperatura', 631.0000, 'ºC'),
	(297307, 143, '2015-01-01 01:21:53.000000', 'temperatura', 303.0000, 'ºC'),
	(297308, 143, '2015-01-01 01:21:54.000000', 'temperatura', 819.0000, 'ºC'),
	(297309, 143, '2015-01-01 01:21:55.000000', 'temperatura', 790.0000, 'ºC'),
	(297310, 143, '2015-01-01 01:21:56.000000', 'temperatura', 290.0000, 'ºC'),
	(297311, 143, '2015-01-01 01:21:57.000000', 'temperatura', 283.0000, 'ºC'),
	(297312, 143, '2015-01-01 01:21:58.000000', 'temperatura', 546.0000, 'ºC'),
	(297313, 143, '2015-01-01 01:21:59.000000', 'temperatura', 682.0000, 'ºC'),
	(297314, 143, '2015-01-01 01:22:00.000000', 'temperatura', 572.0000, 'ºC'),
	(297315, 143, '2015-01-01 01:22:01.000000', 'temperatura', 815.0000, 'ºC'),
	(297316, 143, '2015-01-01 01:22:02.000000', 'temperatura', 1161.0000, 'ºC'),
	(297317, 143, '2015-01-01 01:22:03.000000', 'temperatura', 958.0000, 'ºC'),
	(297318, 143, '2015-01-01 01:22:04.000000', 'temperatura', 107.0000, 'ºC'),
	(297319, 143, '2015-01-01 01:22:05.000000', 'temperatura', 64.0000, 'ºC'),
	(297320, 143, '2015-01-01 01:22:06.000000', 'temperatura', 1198.0000, 'ºC'),
	(297321, 143, '2015-01-01 01:22:07.000000', 'temperatura', 999.0000, 'ºC'),
	(297322, 143, '2015-01-01 01:22:08.000000', 'temperatura', 201.0000, 'ºC'),
	(297323, 143, '2015-01-01 01:22:09.000000', 'temperatura', 408.0000, 'ºC'),
	(297324, 143, '2015-01-01 01:22:10.000000', 'temperatura', 237.0000, 'ºC'),
	(297325, 143, '2015-01-01 01:22:11.000000', 'temperatura', 1161.0000, 'ºC'),
	(297326, 143, '2015-01-01 01:22:12.000000', 'temperatura', 295.0000, 'ºC'),
	(297327, 143, '2015-01-01 01:22:13.000000', 'temperatura', 394.0000, 'ºC'),
	(297328, 143, '2015-01-01 01:22:14.000000', 'temperatura', 1083.0000, 'ºC'),
	(297329, 143, '2015-01-01 01:22:15.000000', 'temperatura', 636.0000, 'ºC'),
	(297330, 143, '2015-01-01 01:22:16.000000', 'temperatura', 1131.0000, 'ºC'),
	(297331, 143, '2015-01-01 01:22:17.000000', 'temperatura', 149.0000, 'ºC'),
	(297332, 143, '2015-01-01 01:22:18.000000', 'temperatura', 950.0000, 'ºC'),
	(297333, 143, '2015-01-01 01:22:19.000000', 'temperatura', 705.0000, 'ºC'),
	(297334, 143, '2015-01-01 01:22:20.000000', 'temperatura', 674.0000, 'ºC'),
	(297335, 143, '2015-01-01 01:22:21.000000', 'temperatura', 55.0000, 'ºC'),
	(297336, 143, '2015-01-01 01:22:22.000000', 'temperatura', 653.0000, 'ºC'),
	(297337, 143, '2015-01-01 01:22:23.000000', 'temperatura', 702.0000, 'ºC'),
	(297338, 143, '2015-01-01 01:22:24.000000', 'temperatura', 352.0000, 'ºC'),
	(297339, 143, '2015-01-01 01:22:25.000000', 'temperatura', 853.0000, 'ºC'),
	(297340, 143, '2015-01-01 01:22:26.000000', 'temperatura', 808.0000, 'ºC'),
	(297341, 143, '2015-01-01 01:22:27.000000', 'temperatura', 284.0000, 'ºC'),
	(297342, 143, '2015-01-01 01:22:28.000000', 'temperatura', 196.0000, 'ºC'),
	(297343, 143, '2015-01-01 01:22:29.000000', 'temperatura', 127.0000, 'ºC'),
	(297344, 143, '2015-01-01 01:22:30.000000', 'temperatura', 50.0000, 'ºC'),
	(297345, 143, '2015-01-01 01:22:31.000000', 'temperatura', 1067.0000, 'ºC'),
	(297346, 143, '2015-01-01 01:22:32.000000', 'temperatura', 387.0000, 'ºC'),
	(297347, 143, '2015-01-01 01:22:33.000000', 'temperatura', 1136.0000, 'ºC'),
	(297348, 143, '2015-01-01 01:22:34.000000', 'temperatura', 917.0000, 'ºC'),
	(297349, 143, '2015-01-01 01:22:35.000000', 'temperatura', 1178.0000, 'ºC'),
	(297350, 143, '2015-01-01 01:22:36.000000', 'temperatura', 738.0000, 'ºC'),
	(297351, 143, '2015-01-01 01:22:37.000000', 'temperatura', 156.0000, 'ºC'),
	(297352, 143, '2015-01-01 01:22:38.000000', 'temperatura', 967.0000, 'ºC'),
	(297353, 143, '2015-01-01 01:22:39.000000', 'temperatura', 770.0000, 'ºC'),
	(297354, 143, '2015-01-01 01:22:40.000000', 'temperatura', 947.0000, 'ºC'),
	(297355, 143, '2015-01-01 01:22:41.000000', 'temperatura', 27.0000, 'ºC'),
	(297356, 143, '2015-01-01 01:22:42.000000', 'temperatura', 894.0000, 'ºC'),
	(297357, 143, '2015-01-01 01:22:43.000000', 'temperatura', 788.0000, 'ºC'),
	(297358, 143, '2015-01-01 01:22:44.000000', 'temperatura', 61.0000, 'ºC'),
	(297359, 143, '2015-01-01 01:22:45.000000', 'temperatura', 339.0000, 'ºC'),
	(297360, 143, '2015-01-01 01:22:46.000000', 'temperatura', 314.0000, 'ºC'),
	(297361, 143, '2015-01-01 01:22:47.000000', 'temperatura', 554.0000, 'ºC'),
	(297362, 143, '2015-01-01 01:22:48.000000', 'temperatura', 626.0000, 'ºC'),
	(297363, 143, '2015-01-01 01:22:49.000000', 'temperatura', 270.0000, 'ºC'),
	(297364, 143, '2015-01-01 01:22:50.000000', 'temperatura', 672.0000, 'ºC'),
	(297365, 143, '2015-01-01 01:22:51.000000', 'temperatura', 151.0000, 'ºC'),
	(297366, 143, '2015-01-01 01:22:52.000000', 'temperatura', 1141.0000, 'ºC'),
	(297367, 143, '2015-01-01 01:22:53.000000', 'temperatura', 451.0000, 'ºC'),
	(297368, 143, '2015-01-01 01:22:54.000000', 'temperatura', 34.0000, 'ºC'),
	(297369, 143, '2015-01-01 01:22:55.000000', 'temperatura', 17.0000, 'ºC'),
	(297370, 143, '2015-01-01 01:22:56.000000', 'temperatura', 1182.0000, 'ºC'),
	(297371, 143, '2015-01-01 01:22:57.000000', 'temperatura', 1059.0000, 'ºC'),
	(297372, 143, '2015-01-01 01:22:58.000000', 'temperatura', 551.0000, 'ºC'),
	(297373, 143, '2015-01-01 01:22:59.000000', 'temperatura', 778.0000, 'ºC'),
	(297374, 143, '2015-01-01 01:23:00.000000', 'temperatura', 1037.0000, 'ºC'),
	(297375, 143, '2015-01-01 01:23:01.000000', 'temperatura', 452.0000, 'ºC'),
	(297376, 143, '2015-01-01 01:23:02.000000', 'temperatura', 348.0000, 'ºC'),
	(297377, 143, '2015-01-01 01:23:03.000000', 'temperatura', 387.0000, 'ºC'),
	(297378, 143, '2015-01-01 01:23:04.000000', 'temperatura', 891.0000, 'ºC'),
	(297379, 143, '2015-01-01 01:23:05.000000', 'temperatura', 895.0000, 'ºC'),
	(297380, 143, '2015-01-01 01:23:06.000000', 'temperatura', 600.0000, 'ºC'),
	(297381, 143, '2015-01-01 01:23:07.000000', 'temperatura', 318.0000, 'ºC'),
	(297382, 143, '2015-01-01 01:23:08.000000', 'temperatura', 991.0000, 'ºC'),
	(297383, 143, '2015-01-01 01:23:09.000000', 'temperatura', 400.0000, 'ºC'),
	(297384, 143, '2015-01-01 01:23:10.000000', 'temperatura', 230.0000, 'ºC'),
	(297385, 143, '2015-01-01 01:23:11.000000', 'temperatura', 1147.0000, 'ºC'),
	(297386, 143, '2015-01-01 01:23:12.000000', 'temperatura', 249.0000, 'ºC'),
	(297387, 143, '2015-01-01 01:23:13.000000', 'temperatura', 202.0000, 'ºC'),
	(297388, 143, '2015-01-01 01:23:14.000000', 'temperatura', 264.0000, 'ºC'),
	(297389, 143, '2015-01-01 01:23:15.000000', 'temperatura', 713.0000, 'ºC'),
	(297390, 143, '2015-01-01 01:23:16.000000', 'temperatura', 375.0000, 'ºC'),
	(297391, 143, '2015-01-01 01:23:17.000000', 'temperatura', 936.0000, 'ºC'),
	(297392, 143, '2015-01-01 01:23:18.000000', 'temperatura', 1157.0000, 'ºC'),
	(297393, 143, '2015-01-01 01:23:19.000000', 'temperatura', 577.0000, 'ºC'),
	(297394, 143, '2015-01-01 01:23:20.000000', 'temperatura', 614.0000, 'ºC'),
	(297395, 143, '2015-01-01 01:23:21.000000', 'temperatura', 142.0000, 'ºC'),
	(297396, 143, '2015-01-01 01:23:22.000000', 'temperatura', 66.0000, 'ºC'),
	(297397, 143, '2015-01-01 01:23:23.000000', 'temperatura', 1103.0000, 'ºC'),
	(297398, 143, '2015-01-01 01:23:24.000000', 'temperatura', 520.0000, 'ºC'),
	(297399, 143, '2015-01-01 01:23:25.000000', 'temperatura', 490.0000, 'ºC'),
	(297400, 143, '2015-01-01 01:23:26.000000', 'temperatura', 889.0000, 'ºC'),
	(297401, 143, '2015-01-01 01:23:27.000000', 'temperatura', 578.0000, 'ºC'),
	(297402, 143, '2015-01-01 01:23:28.000000', 'temperatura', 224.0000, 'ºC'),
	(297403, 143, '2015-01-01 01:23:29.000000', 'temperatura', 584.0000, 'ºC'),
	(297404, 143, '2015-01-01 01:23:30.000000', 'temperatura', 1052.0000, 'ºC'),
	(297405, 143, '2015-01-01 01:23:31.000000', 'temperatura', 1105.0000, 'ºC'),
	(297406, 143, '2015-01-01 01:23:32.000000', 'temperatura', 1172.0000, 'ºC'),
	(297407, 143, '2015-01-01 01:23:33.000000', 'temperatura', 146.0000, 'ºC'),
	(297408, 143, '2015-01-01 01:23:34.000000', 'temperatura', 812.0000, 'ºC'),
	(297409, 143, '2015-01-01 01:23:35.000000', 'temperatura', 23.0000, 'ºC'),
	(297410, 143, '2015-01-01 01:23:36.000000', 'temperatura', 80.0000, 'ºC'),
	(297411, 143, '2015-01-01 01:23:37.000000', 'temperatura', 329.0000, 'ºC'),
	(297412, 143, '2015-01-01 01:23:38.000000', 'temperatura', 209.0000, 'ºC'),
	(297413, 143, '2015-01-01 01:23:39.000000', 'temperatura', 57.0000, 'ºC'),
	(297414, 143, '2015-01-01 01:23:40.000000', 'temperatura', 861.0000, 'ºC'),
	(297415, 143, '2015-01-01 01:23:41.000000', 'temperatura', 532.0000, 'ºC'),
	(297416, 143, '2015-01-01 01:23:42.000000', 'temperatura', 77.0000, 'ºC'),
	(297417, 143, '2015-01-01 01:23:43.000000', 'temperatura', 1191.0000, 'ºC'),
	(297418, 143, '2015-01-01 01:23:44.000000', 'temperatura', 925.0000, 'ºC'),
	(297419, 143, '2015-01-01 01:23:45.000000', 'temperatura', 1051.0000, 'ºC'),
	(297420, 143, '2015-01-01 01:23:46.000000', 'temperatura', 79.0000, 'ºC'),
	(297421, 143, '2015-01-01 01:23:47.000000', 'temperatura', 845.0000, 'ºC'),
	(297422, 143, '2015-01-01 01:23:48.000000', 'temperatura', 387.0000, 'ºC'),
	(297423, 143, '2015-01-01 01:23:49.000000', 'temperatura', 603.0000, 'ºC'),
	(297424, 143, '2015-01-01 01:23:50.000000', 'temperatura', 653.0000, 'ºC'),
	(297425, 143, '2015-01-01 01:23:51.000000', 'temperatura', 258.0000, 'ºC'),
	(297426, 143, '2015-01-01 01:23:52.000000', 'temperatura', 531.0000, 'ºC'),
	(297427, 143, '2015-01-01 01:23:53.000000', 'temperatura', 682.0000, 'ºC'),
	(297428, 143, '2015-01-01 01:23:54.000000', 'temperatura', 619.0000, 'ºC'),
	(297429, 143, '2015-01-01 01:23:55.000000', 'temperatura', 1047.0000, 'ºC'),
	(297430, 143, '2015-01-01 01:23:56.000000', 'temperatura', 980.0000, 'ºC'),
	(297431, 143, '2015-01-01 01:23:57.000000', 'temperatura', 559.0000, 'ºC'),
	(297432, 143, '2015-01-01 01:23:58.000000', 'temperatura', 1055.0000, 'ºC'),
	(297433, 143, '2015-01-01 01:23:59.000000', 'temperatura', 1198.0000, 'ºC'),
	(297434, 143, '2015-01-01 01:24:00.000000', 'temperatura', 426.0000, 'ºC'),
	(297435, 143, '2015-01-01 01:24:01.000000', 'temperatura', 938.0000, 'ºC'),
	(297436, 143, '2015-01-01 01:24:02.000000', 'temperatura', 1010.0000, 'ºC'),
	(297437, 143, '2015-01-01 01:24:03.000000', 'temperatura', 1038.0000, 'ºC'),
	(297438, 143, '2015-01-01 01:24:04.000000', 'temperatura', 962.0000, 'ºC'),
	(297439, 143, '2015-01-01 01:24:05.000000', 'temperatura', 495.0000, 'ºC'),
	(297440, 143, '2015-01-01 01:24:06.000000', 'temperatura', 788.0000, 'ºC'),
	(297441, 143, '2015-01-01 01:24:07.000000', 'temperatura', 56.0000, 'ºC'),
	(297442, 143, '2015-01-01 01:24:08.000000', 'temperatura', 317.0000, 'ºC'),
	(297443, 143, '2015-01-01 01:24:09.000000', 'temperatura', 218.0000, 'ºC'),
	(297444, 143, '2015-01-01 01:24:10.000000', 'temperatura', 139.0000, 'ºC'),
	(297445, 143, '2015-01-01 01:24:11.000000', 'temperatura', 41.0000, 'ºC'),
	(297446, 143, '2015-01-01 01:24:12.000000', 'temperatura', 987.0000, 'ºC'),
	(297447, 143, '2015-01-01 01:24:13.000000', 'temperatura', 16.0000, 'ºC'),
	(297448, 143, '2015-01-01 01:24:14.000000', 'temperatura', 717.0000, 'ºC'),
	(297449, 143, '2015-01-01 01:24:15.000000', 'temperatura', 1137.0000, 'ºC'),
	(297450, 143, '2015-01-01 01:24:16.000000', 'temperatura', 1134.0000, 'ºC'),
	(297451, 143, '2015-01-01 01:24:17.000000', 'temperatura', 1061.0000, 'ºC'),
	(297452, 143, '2015-01-01 01:24:18.000000', 'temperatura', 705.0000, 'ºC'),
	(297453, 143, '2015-01-01 01:24:19.000000', 'temperatura', 341.0000, 'ºC'),
	(297454, 143, '2015-01-01 01:24:20.000000', 'temperatura', 793.0000, 'ºC'),
	(297455, 143, '2015-01-01 01:24:21.000000', 'temperatura', 540.0000, 'ºC'),
	(297456, 143, '2015-01-01 01:24:22.000000', 'temperatura', 321.0000, 'ºC'),
	(297457, 143, '2015-01-01 01:24:23.000000', 'temperatura', 1184.0000, 'ºC'),
	(297458, 143, '2015-01-01 01:24:24.000000', 'temperatura', 160.0000, 'ºC'),
	(297459, 143, '2015-01-01 01:24:25.000000', 'temperatura', 846.0000, 'ºC'),
	(297460, 143, '2015-01-01 01:24:26.000000', 'temperatura', 154.0000, 'ºC'),
	(297461, 143, '2015-01-01 01:24:27.000000', 'temperatura', 629.0000, 'ºC'),
	(297462, 143, '2015-01-01 01:24:28.000000', 'temperatura', 285.0000, 'ºC'),
	(297463, 143, '2015-01-01 01:24:29.000000', 'temperatura', 739.0000, 'ºC'),
	(297464, 143, '2015-01-01 01:24:30.000000', 'temperatura', 439.0000, 'ºC'),
	(297465, 143, '2015-01-01 01:24:31.000000', 'temperatura', 1181.0000, 'ºC'),
	(297466, 143, '2015-01-01 01:24:32.000000', 'temperatura', 988.0000, 'ºC'),
	(297467, 143, '2015-01-01 01:24:33.000000', 'temperatura', 196.0000, 'ºC'),
	(297468, 143, '2015-01-01 01:24:34.000000', 'temperatura', 415.0000, 'ºC'),
	(297469, 143, '2015-01-01 01:24:35.000000', 'temperatura', 289.0000, 'ºC'),
	(297470, 143, '2015-01-01 01:24:36.000000', 'temperatura', 203.0000, 'ºC'),
	(297471, 143, '2015-01-01 01:24:37.000000', 'temperatura', 145.0000, 'ºC'),
	(297472, 143, '2015-01-01 01:24:38.000000', 'temperatura', 117.0000, 'ºC'),
	(297473, 143, '2015-01-01 01:24:39.000000', 'temperatura', 149.0000, 'ºC'),
	(297474, 143, '2015-01-01 01:24:40.000000', 'temperatura', 397.0000, 'ºC'),
	(297475, 143, '2015-01-01 01:24:41.000000', 'temperatura', 336.0000, 'ºC'),
	(297476, 143, '2015-01-01 01:24:42.000000', 'temperatura', 492.0000, 'ºC'),
	(297477, 143, '2015-01-01 01:24:43.000000', 'temperatura', 249.0000, 'ºC'),
	(297478, 143, '2015-01-01 01:24:44.000000', 'temperatura', 973.0000, 'ºC'),
	(297479, 143, '2015-01-01 01:24:45.000000', 'temperatura', 519.0000, 'ºC'),
	(297480, 143, '2015-01-01 01:24:46.000000', 'temperatura', 876.0000, 'ºC'),
	(297481, 143, '2015-01-01 01:24:47.000000', 'temperatura', 421.0000, 'ºC'),
	(297482, 143, '2015-01-01 01:24:48.000000', 'temperatura', 680.0000, 'ºC'),
	(297483, 143, '2015-01-01 01:24:49.000000', 'temperatura', 937.0000, 'ºC'),
	(297484, 143, '2015-01-01 01:24:50.000000', 'temperatura', 245.0000, 'ºC'),
	(297485, 143, '2015-01-01 01:24:51.000000', 'temperatura', 813.0000, 'ºC'),
	(297486, 143, '2015-01-01 01:24:52.000000', 'temperatura', 934.0000, 'ºC'),
	(297487, 143, '2015-01-01 01:24:53.000000', 'temperatura', 1029.0000, 'ºC'),
	(297488, 143, '2015-01-01 01:24:54.000000', 'temperatura', 1145.0000, 'ºC'),
	(297489, 143, '2015-01-01 01:24:55.000000', 'temperatura', 238.0000, 'ºC'),
	(297490, 143, '2015-01-01 01:24:56.000000', 'temperatura', 154.0000, 'ºC'),
	(297491, 143, '2015-01-01 01:24:57.000000', 'temperatura', 57.0000, 'ºC'),
	(297492, 143, '2015-01-01 01:24:58.000000', 'temperatura', 1024.0000, 'ºC'),
	(297493, 143, '2015-01-01 01:24:59.000000', 'temperatura', 148.0000, 'ºC'),
	(297494, 143, '2015-01-01 01:25:00.000000', 'temperatura', 69.0000, 'ºC'),
	(297495, 143, '2015-01-01 01:25:01.000000', 'temperatura', 1101.0000, 'ºC'),
	(297496, 143, '2015-01-01 01:25:02.000000', 'temperatura', 498.0000, 'ºC'),
	(297497, 143, '2015-01-01 01:25:03.000000', 'temperatura', 389.0000, 'ºC'),
	(297498, 143, '2015-01-01 01:25:04.000000', 'temperatura', 450.0000, 'ºC'),
	(297499, 143, '2015-01-01 01:25:05.000000', 'temperatura', 1083.0000, 'ºC'),
	(297500, 143, '2015-01-01 01:25:06.000000', 'temperatura', 468.0000, 'ºC'),
	(297501, 143, '2015-01-01 01:25:07.000000', 'temperatura', 289.0000, 'ºC'),
	(297502, 143, '2015-01-01 01:25:08.000000', 'temperatura', 42.0000, 'ºC'),
	(297503, 143, '2015-01-01 01:25:09.000000', 'temperatura', 544.0000, 'ºC'),
	(297504, 143, '2015-01-01 01:25:10.000000', 'temperatura', 196.0000, 'ºC'),
	(297505, 143, '2015-01-01 01:25:11.000000', 'temperatura', 548.0000, 'ºC'),
	(297506, 143, '2015-01-01 01:25:12.000000', 'temperatura', 952.0000, 'ºC'),
	(297507, 143, '2015-01-01 01:25:13.000000', 'temperatura', 717.0000, 'ºC'),
	(297508, 143, '2015-01-01 01:25:14.000000', 'temperatura', 729.0000, 'ºC'),
	(297509, 143, '2015-01-01 01:25:15.000000', 'temperatura', 296.0000, 'ºC'),
	(297510, 143, '2015-01-01 01:25:16.000000', 'temperatura', 494.0000, 'ºC'),
	(297511, 143, '2015-01-01 01:25:17.000000', 'temperatura', 383.0000, 'ºC'),
	(297512, 143, '2015-01-01 01:25:18.000000', 'temperatura', 434.0000, 'ºC'),
	(297513, 143, '2015-01-01 01:25:19.000000', 'temperatura', 1020.0000, 'ºC'),
	(297514, 143, '2015-01-01 01:25:20.000000', 'temperatura', 198.0000, 'ºC'),
	(297515, 143, '2015-01-01 01:25:21.000000', 'temperatura', 330.0000, 'ºC'),
	(297516, 143, '2015-01-01 01:25:22.000000', 'temperatura', 1057.0000, 'ºC'),
	(297517, 143, '2015-01-01 01:25:23.000000', 'temperatura', 695.0000, 'ºC'),
	(297518, 143, '2015-01-01 01:25:24.000000', 'temperatura', 306.0000, 'ºC'),
	(297519, 143, '2015-01-01 01:25:25.000000', 'temperatura', 645.0000, 'ºC'),
	(297520, 143, '2015-01-01 01:25:26.000000', 'temperatura', 1108.0000, 'ºC'),
	(297521, 143, '2015-01-01 01:25:27.000000', 'temperatura', 5.0000, 'ºC'),
	(297522, 143, '2015-01-01 01:25:28.000000', 'temperatura', 299.0000, 'ºC'),
	(297523, 143, '2015-01-01 01:25:29.000000', 'temperatura', 284.0000, 'ºC'),
	(297524, 143, '2015-01-01 01:25:30.000000', 'temperatura', 523.0000, 'ºC'),
	(297525, 143, '2015-01-01 01:25:31.000000', 'temperatura', 563.0000, 'ºC'),
	(297526, 143, '2015-01-01 01:25:32.000000', 'temperatura', 47.0000, 'ºC'),
	(297527, 143, '2015-01-01 01:25:33.000000', 'temperatura', 946.0000, 'ºC'),
	(297528, 143, '2015-01-01 01:25:34.000000', 'temperatura', 990.0000, 'ºC'),
	(297529, 143, '2015-01-01 01:25:35.000000', 'temperatura', 911.0000, 'ºC'),
	(297530, 143, '2015-01-01 01:25:36.000000', 'temperatura', 385.0000, 'ºC'),
	(297531, 143, '2015-01-01 01:25:37.000000', 'temperatura', 395.0000, 'ºC'),
	(297532, 143, '2015-01-01 01:25:38.000000', 'temperatura', 819.0000, 'ºC'),
	(297533, 143, '2015-01-01 01:25:39.000000', 'temperatura', 513.0000, 'ºC'),
	(297534, 143, '2015-01-01 01:25:40.000000', 'temperatura', 105.0000, 'ºC'),
	(297535, 143, '2015-01-01 01:25:41.000000', 'temperatura', 189.0000, 'ºC'),
	(297536, 143, '2015-01-01 01:25:42.000000', 'temperatura', 630.0000, 'ºC'),
	(297537, 143, '2015-01-01 01:25:43.000000', 'temperatura', 183.0000, 'ºC'),
	(297538, 143, '2015-01-01 01:25:44.000000', 'temperatura', 225.0000, 'ºC'),
	(297539, 143, '2015-01-01 01:25:45.000000', 'temperatura', 575.0000, 'ºC'),
	(297540, 143, '2015-01-01 01:25:46.000000', 'temperatura', 1003.0000, 'ºC'),
	(297541, 143, '2015-01-01 01:25:47.000000', 'temperatura', 890.0000, 'ºC'),
	(297542, 143, '2015-01-01 01:25:48.000000', 'temperatura', 241.0000, 'ºC'),
	(297543, 143, '2015-01-01 01:25:49.000000', 'temperatura', 936.0000, 'ºC'),
	(297544, 143, '2015-01-01 01:25:50.000000', 'temperatura', 356.0000, 'ºC'),
	(297545, 143, '2015-01-01 01:25:51.000000', 'temperatura', 173.0000, 'ºC'),
	(297546, 143, '2015-01-01 01:25:52.000000', 'temperatura', 998.0000, 'ºC'),
	(297547, 143, '2015-01-01 01:25:53.000000', 'temperatura', 873.0000, 'ºC'),
	(297548, 143, '2015-01-01 01:25:54.000000', 'temperatura', 171.0000, 'ºC'),
	(297549, 143, '2015-01-01 01:25:55.000000', 'temperatura', 635.0000, 'ºC'),
	(297550, 143, '2015-01-01 01:25:56.000000', 'temperatura', 262.0000, 'ºC'),
	(297551, 143, '2015-01-01 01:25:57.000000', 'temperatura', 607.0000, 'ºC'),
	(297552, 143, '2015-01-01 01:25:58.000000', 'temperatura', 1050.0000, 'ºC'),
	(297553, 143, '2015-01-01 01:25:59.000000', 'temperatura', 1030.0000, 'ºC'),
	(297554, 143, '2015-01-01 01:26:00.000000', 'temperatura', 802.0000, 'ºC'),
	(297555, 143, '2015-01-01 01:26:01.000000', 'temperatura', 917.0000, 'ºC'),
	(297556, 143, '2015-01-01 01:26:02.000000', 'temperatura', 980.0000, 'ºC'),
	(297557, 143, '2015-01-01 01:26:03.000000', 'temperatura', 949.0000, 'ºC'),
	(297558, 143, '2015-01-01 01:26:04.000000', 'temperatura', 607.0000, 'ºC'),
	(297559, 143, '2015-01-01 01:26:05.000000', 'temperatura', 190.0000, 'ºC'),
	(297560, 143, '2015-01-01 01:26:06.000000', 'temperatura', 327.0000, 'ºC'),
	(297561, 143, '2015-01-01 01:26:07.000000', 'temperatura', 1066.0000, 'ºC'),
	(297562, 143, '2015-01-01 01:26:08.000000', 'temperatura', 749.0000, 'ºC'),
	(297563, 143, '2015-01-01 01:26:09.000000', 'temperatura', 550.0000, 'ºC'),
	(297564, 143, '2015-01-01 01:26:10.000000', 'temperatura', 500.0000, 'ºC'),
	(297565, 143, '2015-01-01 01:26:11.000000', 'temperatura', 852.0000, 'ºC'),
	(297566, 143, '2015-01-01 01:26:12.000000', 'temperatura', 360.0000, 'ºC'),
	(297567, 143, '2015-01-01 01:26:13.000000', 'temperatura', 446.0000, 'ºC'),
	(297568, 143, '2015-01-01 01:26:14.000000', 'temperatura', 1148.0000, 'ºC'),
	(297569, 143, '2015-01-01 01:26:15.000000', 'temperatura', 803.0000, 'ºC'),
	(297570, 143, '2015-01-01 01:26:16.000000', 'temperatura', 573.0000, 'ºC'),
	(297571, 143, '2015-01-01 01:26:17.000000', 'temperatura', 458.0000, 'ºC'),
	(297572, 143, '2015-01-01 01:26:18.000000', 'temperatura', 568.0000, 'ºC'),
	(297573, 143, '2015-01-01 01:26:19.000000', 'temperatura', 269.0000, 'ºC'),
	(297574, 143, '2015-01-01 01:26:20.000000', 'temperatura', 843.0000, 'ºC'),
	(297575, 143, '2015-01-01 01:26:21.000000', 'temperatura', 1006.0000, 'ºC'),
	(297576, 143, '2015-01-01 01:26:22.000000', 'temperatura', 102.0000, 'ºC'),
	(297577, 143, '2015-01-01 01:26:23.000000', 'temperatura', 1091.0000, 'ºC'),
	(297578, 143, '2015-01-01 01:26:24.000000', 'temperatura', 352.0000, 'ºC'),
	(297579, 143, '2015-01-01 01:26:25.000000', 'temperatura', 889.0000, 'ºC'),
	(297580, 143, '2015-01-01 01:26:26.000000', 'temperatura', 986.0000, 'ºC'),
	(297581, 143, '2015-01-01 01:26:27.000000', 'temperatura', 1066.0000, 'ºC'),
	(297582, 143, '2015-01-01 01:26:28.000000', 'temperatura', 1172.0000, 'ºC'),
	(297583, 143, '2015-01-01 01:26:29.000000', 'temperatura', 261.0000, 'ºC'),
	(297584, 143, '2015-01-01 01:26:30.000000', 'temperatura', 189.0000, 'ºC'),
	(297585, 143, '2015-01-01 01:26:31.000000', 'temperatura', 163.0000, 'ºC'),
	(297586, 143, '2015-01-01 01:26:32.000000', 'temperatura', 248.0000, 'ºC'),
	(297587, 143, '2015-01-01 01:26:33.000000', 'temperatura', 754.0000, 'ºC'),
	(297588, 143, '2015-01-01 01:26:34.000000', 'temperatura', 623.0000, 'ºC'),
	(297589, 143, '2015-01-01 01:26:35.000000', 'temperatura', 857.0000, 'ºC'),
	(297590, 143, '2015-01-01 01:26:36.000000', 'temperatura', 14.0000, 'ºC'),
	(297591, 143, '2015-01-01 01:26:37.000000', 'temperatura', 1100.0000, 'ºC'),
	(297592, 143, '2015-01-01 01:26:38.000000', 'temperatura', 657.0000, 'ºC'),
	(297593, 143, '2015-01-01 01:26:39.000000', 'temperatura', 1188.0000, 'ºC'),
	(297594, 143, '2015-01-01 01:26:40.000000', 'temperatura', 367.0000, 'ºC'),
	(297595, 143, '2015-01-01 01:26:41.000000', 'temperatura', 673.0000, 'ºC'),
	(297596, 143, '2015-01-01 01:26:42.000000', 'temperatura', 1065.0000, 'ºC'),
	(297597, 143, '2015-01-01 01:26:43.000000', 'temperatura', 904.0000, 'ºC'),
	(297598, 143, '2015-01-01 01:26:44.000000', 'temperatura', 127.0000, 'ºC'),
	(297599, 143, '2015-01-01 01:26:45.000000', 'temperatura', 322.0000, 'ºC'),
	(297600, 143, '2015-01-01 01:26:46.000000', 'temperatura', 28.0000, 'ºC'),
	(297601, 143, '2015-01-01 01:26:47.000000', 'temperatura', 378.0000, 'ºC'),
	(297602, 143, '2015-01-01 01:26:48.000000', 'temperatura', 606.0000, 'ºC'),
	(297603, 143, '2015-01-01 01:26:49.000000', 'temperatura', 696.0000, 'ºC'),
	(297604, 143, '2015-01-01 01:26:50.000000', 'temperatura', 462.0000, 'ºC'),
	(297605, 143, '2015-01-01 01:26:51.000000', 'temperatura', 223.0000, 'ºC'),
	(297606, 143, '2015-01-01 01:26:52.000000', 'temperatura', 931.0000, 'ºC'),
	(297607, 143, '2015-01-01 01:26:53.000000', 'temperatura', 386.0000, 'ºC'),
	(297608, 143, '2015-01-01 01:26:54.000000', 'temperatura', 338.0000, 'ºC'),
	(297609, 143, '2015-01-01 01:26:55.000000', 'temperatura', 532.0000, 'ºC'),
	(297610, 143, '2015-01-01 01:26:56.000000', 'temperatura', 447.0000, 'ºC'),
	(297611, 143, '2015-01-01 01:26:57.000000', 'temperatura', 640.0000, 'ºC'),
	(297612, 143, '2015-01-01 01:26:58.000000', 'temperatura', 658.0000, 'ºC'),
	(297613, 143, '2015-01-01 01:26:59.000000', 'temperatura', 172.0000, 'ºC'),
	(297614, 143, '2015-01-01 01:27:00.000000', 'temperatura', 85.0000, 'ºC'),
	(297615, 143, '2015-01-01 01:27:01.000000', 'temperatura', 1110.0000, 'ºC'),
	(297616, 143, '2015-01-01 01:27:02.000000', 'temperatura', 494.0000, 'ºC'),
	(297617, 143, '2015-01-01 01:27:03.000000', 'temperatura', 342.0000, 'ºC'),
	(297618, 143, '2015-01-01 01:27:04.000000', 'temperatura', 227.0000, 'ºC'),
	(297619, 143, '2015-01-01 01:27:05.000000', 'temperatura', 109.0000, 'ºC'),
	(297620, 143, '2015-01-01 01:27:06.000000', 'temperatura', 1065.0000, 'ºC'),
	(297621, 143, '2015-01-01 01:27:07.000000', 'temperatura', 200.0000, 'ºC'),
	(297622, 143, '2015-01-01 01:27:08.000000', 'temperatura', 205.0000, 'ºC'),
	(297623, 143, '2015-01-01 01:27:09.000000', 'temperatura', 424.0000, 'ºC'),
	(297624, 143, '2015-01-01 01:27:10.000000', 'temperatura', 307.0000, 'ºC'),
	(297625, 143, '2015-01-01 01:27:11.000000', 'temperatura', 263.0000, 'ºC'),
	(297626, 143, '2015-01-01 01:27:12.000000', 'temperatura', 394.0000, 'ºC'),
	(297627, 143, '2015-01-01 01:27:13.000000', 'temperatura', 1184.0000, 'ºC'),
	(297628, 143, '2015-01-01 01:27:14.000000', 'temperatura', 1137.0000, 'ºC'),
	(297629, 143, '2015-01-01 01:27:15.000000', 'temperatura', 934.0000, 'ºC'),
	(297630, 143, '2015-01-01 01:27:16.000000', 'temperatura', 60.0000, 'ºC'),
	(297631, 143, '2015-01-01 01:27:17.000000', 'temperatura', 1097.0000, 'ºC'),
	(297632, 143, '2015-01-01 01:27:18.000000', 'temperatura', 506.0000, 'ºC'),
	(297633, 143, '2015-01-01 01:27:19.000000', 'temperatura', 441.0000, 'ºC'),
	(297634, 143, '2015-01-01 01:27:20.000000', 'temperatura', 685.0000, 'ºC'),
	(297635, 143, '2015-01-01 01:27:21.000000', 'temperatura', 901.0000, 'ºC'),
	(297636, 143, '2015-01-01 01:27:22.000000', 'temperatura', 54.0000, 'ºC'),
	(297637, 143, '2015-01-01 01:27:23.000000', 'temperatura', 1167.0000, 'ºC'),
	(297638, 143, '2015-01-01 01:27:24.000000', 'temperatura', 875.0000, 'ºC'),
	(297639, 143, '2015-01-01 01:27:25.000000', 'temperatura', 871.0000, 'ºC'),
	(297640, 143, '2015-01-01 01:27:26.000000', 'temperatura', 533.0000, 'ºC'),
	(297641, 143, '2015-01-01 01:27:27.000000', 'temperatura', 52.0000, 'ºC'),
	(297642, 143, '2015-01-01 01:27:28.000000', 'temperatura', 1060.0000, 'ºC'),
	(297643, 143, '2015-01-01 01:27:29.000000', 'temperatura', 347.0000, 'ºC'),
	(297644, 143, '2015-01-01 01:27:30.000000', 'temperatura', 954.0000, 'ºC'),
	(297645, 143, '2015-01-01 01:27:31.000000', 'temperatura', 131.0000, 'ºC'),
	(297646, 143, '2015-01-01 01:27:32.000000', 'temperatura', 193.0000, 'ºC'),
	(297647, 143, '2015-01-01 01:27:33.000000', 'temperatura', 573.0000, 'ºC'),
	(297648, 143, '2015-01-01 01:27:34.000000', 'temperatura', 1088.0000, 'ºC'),
	(297649, 143, '2015-01-01 01:27:35.000000', 'temperatura', 119.0000, 'ºC'),
	(297650, 143, '2015-01-01 01:27:36.000000', 'temperatura', 933.0000, 'ºC'),
	(297651, 143, '2015-01-01 01:27:37.000000', 'temperatura', 706.0000, 'ºC'),
	(297652, 143, '2015-01-01 01:27:38.000000', 'temperatura', 733.0000, 'ºC'),
	(297653, 143, '2015-01-01 01:27:39.000000', 'temperatura', 348.0000, 'ºC'),
	(297654, 143, '2015-01-01 01:27:40.000000', 'temperatura', 742.0000, 'ºC'),
	(297655, 143, '2015-01-01 01:27:41.000000', 'temperatura', 267.0000, 'ºC'),
	(297656, 143, '2015-01-01 01:27:42.000000', 'temperatura', 308.0000, 'ºC'),
	(297657, 143, '2015-01-01 01:27:43.000000', 'temperatura', 740.0000, 'ºC'),
	(297658, 143, '2015-01-01 01:27:44.000000', 'temperatura', 378.0000, 'ºC'),
	(297659, 143, '2015-01-01 01:27:45.000000', 'temperatura', 869.0000, 'ºC'),
	(297660, 143, '2015-01-01 01:27:46.000000', 'temperatura', 812.0000, 'ºC'),
	(297661, 143, '2015-01-01 01:27:47.000000', 'temperatura', 254.0000, 'ºC'),
	(297662, 143, '2015-01-01 01:27:48.000000', 'temperatura', 32.0000, 'ºC'),
	(297663, 143, '2015-01-01 01:27:49.000000', 'temperatura', 600.0000, 'ºC'),
	(297664, 143, '2015-01-01 01:27:50.000000', 'temperatura', 503.0000, 'ºC'),
	(297665, 143, '2015-01-01 01:27:51.000000', 'temperatura', 715.0000, 'ºC'),
	(297666, 143, '2015-01-01 01:27:52.000000', 'temperatura', 867.0000, 'ºC'),
	(297667, 143, '2015-01-01 01:27:53.000000', 'temperatura', 993.0000, 'ºC'),
	(297668, 143, '2015-01-01 01:27:54.000000', 'temperatura', 1163.0000, 'ºC'),
	(297669, 143, '2015-01-01 01:27:55.000000', 'temperatura', 437.0000, 'ºC'),
	(297670, 143, '2015-01-01 01:27:56.000000', 'temperatura', 1096.0000, 'ºC'),
	(297671, 143, '2015-01-01 01:27:57.000000', 'temperatura', 568.0000, 'ºC'),
	(297672, 143, '2015-01-01 01:27:58.000000', 'temperatura', 754.0000, 'ºC'),
	(297673, 143, '2015-01-01 01:27:59.000000', 'temperatura', 866.0000, 'ºC'),
	(297674, 143, '2015-01-01 01:28:00.000000', 'temperatura', 870.0000, 'ºC'),
	(297675, 143, '2015-01-01 01:28:01.000000', 'temperatura', 552.0000, 'ºC'),
	(297676, 143, '2015-01-01 01:28:02.000000', 'temperatura', 150.0000, 'ºC'),
	(297677, 143, '2015-01-01 01:28:03.000000', 'temperatura', 293.0000, 'ºC'),
	(297678, 143, '2015-01-01 01:28:04.000000', 'temperatura', 1015.0000, 'ºC'),
	(297679, 143, '2015-01-01 01:28:05.000000', 'temperatura', 599.0000, 'ºC'),
	(297680, 143, '2015-01-01 01:28:06.000000', 'temperatura', 1149.0000, 'ºC'),
	(297681, 143, '2015-01-01 01:28:07.000000', 'temperatura', 347.0000, 'ºC'),
	(297682, 143, '2015-01-01 01:28:08.000000', 'temperatura', 689.0000, 'ºC'),
	(297683, 143, '2015-01-01 01:28:09.000000', 'temperatura', 7.0000, 'ºC'),
	(297684, 143, '2015-01-01 01:28:10.000000', 'temperatura', 366.0000, 'ºC'),
	(297685, 143, '2015-01-01 01:28:11.000000', 'temperatura', 611.0000, 'ºC'),
	(297686, 143, '2015-01-01 01:28:12.000000', 'temperatura', 757.0000, 'ºC'),
	(297687, 143, '2015-01-01 01:28:13.000000', 'temperatura', 751.0000, 'ºC'),
	(297688, 143, '2015-01-01 01:28:14.000000', 'temperatura', 286.0000, 'ºC'),
	(297689, 143, '2015-01-01 01:28:15.000000', 'temperatura', 375.0000, 'ºC'),
	(297690, 143, '2015-01-01 01:28:16.000000', 'temperatura', 1021.0000, 'ºC'),
	(297691, 143, '2015-01-01 01:28:17.000000', 'temperatura', 377.0000, 'ºC'),
	(297692, 143, '2015-01-01 01:28:18.000000', 'temperatura', 25.0000, 'ºC'),
	(297693, 143, '2015-01-01 01:28:19.000000', 'temperatura', 193.0000, 'ºC'),
	(297694, 143, '2015-01-01 01:28:20.000000', 'temperatura', 891.0000, 'ºC'),
	(297695, 143, '2015-01-01 01:28:21.000000', 'temperatura', 277.0000, 'ºC'),
	(297696, 143, '2015-01-01 01:28:22.000000', 'temperatura', 1112.0000, 'ºC'),
	(297697, 143, '2015-01-01 01:28:23.000000', 'temperatura', 1131.0000, 'ºC'),
	(297698, 143, '2015-01-01 01:28:24.000000', 'temperatura', 1120.0000, 'ºC'),
	(297699, 143, '2015-01-01 01:28:25.000000', 'temperatura', 1007.0000, 'ºC'),
	(297700, 143, '2015-01-01 01:28:26.000000', 'temperatura', 476.0000, 'ºC'),
	(297701, 143, '2015-01-01 01:28:27.000000', 'temperatura', 561.0000, 'ºC'),
	(297702, 143, '2015-01-01 01:28:28.000000', 'temperatura', 175.0000, 'ºC'),
	(297703, 143, '2015-01-01 01:28:29.000000', 'temperatura', 393.0000, 'ºC'),
	(297704, 143, '2015-01-01 01:28:30.000000', 'temperatura', 241.0000, 'ºC'),
	(297705, 143, '2015-01-01 01:28:31.000000', 'temperatura', 28.0000, 'ºC'),
	(297706, 143, '2015-01-01 01:28:32.000000', 'temperatura', 616.0000, 'ºC'),
	(297707, 143, '2015-01-01 01:28:33.000000', 'temperatura', 595.0000, 'ºC'),
	(297708, 143, '2015-01-01 01:28:34.000000', 'temperatura', 1128.0000, 'ºC'),
	(297709, 143, '2015-01-01 01:28:35.000000', 'temperatura', 255.0000, 'ºC'),
	(297710, 143, '2015-01-01 01:28:36.000000', 'temperatura', 292.0000, 'ºC'),
	(297711, 143, '2015-01-01 01:28:37.000000', 'temperatura', 694.0000, 'ºC'),
	(297712, 143, '2015-01-01 01:28:38.000000', 'temperatura', 197.0000, 'ºC'),
	(297713, 143, '2015-01-01 01:28:39.000000', 'temperatura', 102.0000, 'ºC'),
	(297714, 143, '2015-01-01 01:28:40.000000', 'temperatura', 1121.0000, 'ºC'),
	(297715, 143, '2015-01-01 01:28:41.000000', 'temperatura', 497.0000, 'ºC'),
	(297716, 143, '2015-01-01 01:28:42.000000', 'temperatura', 325.0000, 'ºC'),
	(297717, 143, '2015-01-01 01:28:43.000000', 'temperatura', 132.0000, 'ºC'),
	(297718, 143, '2015-01-01 01:28:44.000000', 'temperatura', 886.0000, 'ºC'),
	(297719, 143, '2015-01-01 01:28:45.000000', 'temperatura', 435.0000, 'ºC'),
	(297720, 143, '2015-01-01 01:28:46.000000', 'temperatura', 718.0000, 'ºC'),
	(297721, 143, '2015-01-01 01:28:47.000000', 'temperatura', 1086.0000, 'ºC'),
	(297722, 143, '2015-01-01 01:28:48.000000', 'temperatura', 878.0000, 'ºC'),
	(297723, 143, '2015-01-01 01:28:49.000000', 'temperatura', 1130.0000, 'ºC'),
	(297724, 143, '2015-01-01 01:28:50.000000', 'temperatura', 617.0000, 'ºC'),
	(297725, 143, '2015-01-01 01:28:51.000000', 'temperatura', 896.0000, 'ºC'),
	(297726, 143, '2015-01-01 01:28:52.000000', 'temperatura', 228.0000, 'ºC'),
	(297727, 143, '2015-01-01 01:28:53.000000', 'temperatura', 854.0000, 'ºC'),
	(297728, 143, '2015-01-01 01:28:54.000000', 'temperatura', 1185.0000, 'ºC'),
	(297729, 143, '2015-01-01 01:28:55.000000', 'temperatura', 965.0000, 'ºC'),
	(297730, 143, '2015-01-01 01:28:56.000000', 'temperatura', 71.0000, 'ºC'),
	(297731, 143, '2015-01-01 01:28:57.000000', 'temperatura', 1060.0000, 'ºC'),
	(297732, 143, '2015-01-01 01:28:58.000000', 'temperatura', 287.0000, 'ºC'),
	(297733, 143, '2015-01-01 01:28:59.000000', 'temperatura', 655.0000, 'ºC'),
	(297734, 143, '2015-01-01 01:29:00.000000', 'temperatura', 15.0000, 'ºC'),
	(297735, 143, '2015-01-01 01:29:01.000000', 'temperatura', 510.0000, 'ºC'),
	(297736, 143, '2015-01-01 01:29:02.000000', 'temperatura', 107.0000, 'ºC'),
	(297737, 143, '2015-01-01 01:29:03.000000', 'temperatura', 203.0000, 'ºC'),
	(297738, 143, '2015-01-01 01:29:04.000000', 'temperatura', 696.0000, 'ºC'),
	(297739, 143, '2015-01-01 01:29:05.000000', 'temperatura', 473.0000, 'ºC'),
	(297740, 143, '2015-01-01 01:29:06.000000', 'temperatura', 275.0000, 'ºC'),
	(297741, 143, '2015-01-01 01:29:07.000000', 'temperatura', 1159.0000, 'ºC'),
	(297742, 143, '2015-01-01 01:29:08.000000', 'temperatura', 171.0000, 'ºC'),
	(297743, 143, '2015-01-01 01:29:09.000000', 'temperatura', 977.0000, 'ºC'),
	(297744, 143, '2015-01-01 01:29:10.000000', 'temperatura', 774.0000, 'ºC'),
	(297745, 143, '2015-01-01 01:29:11.000000', 'temperatura', 938.0000, 'ºC'),
	(297746, 143, '2015-01-01 01:29:12.000000', 'temperatura', 1167.0000, 'ºC'),
	(297747, 143, '2015-01-01 01:29:13.000000', 'temperatura', 622.0000, 'ºC'),
	(297748, 143, '2015-01-01 01:29:14.000000', 'temperatura', 811.0000, 'ºC'),
	(297749, 143, '2015-01-01 01:29:15.000000', 'temperatura', 991.0000, 'ºC'),
	(297750, 143, '2015-01-01 01:29:16.000000', 'temperatura', 121.0000, 'ºC'),
	(297751, 143, '2015-01-01 01:29:17.000000', 'temperatura', 33.0000, 'ºC'),
	(297752, 143, '2015-01-01 01:29:18.000000', 'temperatura', 1000.0000, 'ºC'),
	(297753, 143, '2015-01-01 01:29:19.000000', 'temperatura', 104.0000, 'ºC'),
	(297754, 143, '2015-01-01 01:29:20.000000', 'temperatura', 1119.0000, 'ºC'),
	(297755, 143, '2015-01-01 01:29:21.000000', 'temperatura', 484.0000, 'ºC'),
	(297756, 143, '2015-01-01 01:29:22.000000', 'temperatura', 262.0000, 'ºC'),
	(297757, 143, '2015-01-01 01:29:23.000000', 'temperatura', 1062.0000, 'ºC'),
	(297758, 143, '2015-01-01 01:29:24.000000', 'temperatura', 921.0000, 'ºC'),
	(297759, 143, '2015-01-01 01:29:25.000000', 'temperatura', 220.0000, 'ºC'),
	(297760, 143, '2015-01-01 01:29:26.000000', 'temperatura', 738.0000, 'ºC'),
	(297761, 143, '2015-01-01 01:29:27.000000', 'temperatura', 629.0000, 'ºC'),
	(297762, 143, '2015-01-01 01:29:28.000000', 'temperatura', 933.0000, 'ºC'),
	(297763, 143, '2015-01-01 01:29:29.000000', 'temperatura', 376.0000, 'ºC'),
	(297764, 143, '2015-01-01 01:29:30.000000', 'temperatura', 284.0000, 'ºC'),
	(297765, 143, '2015-01-01 01:29:31.000000', 'temperatura', 290.0000, 'ºC'),
	(297766, 143, '2015-01-01 01:29:32.000000', 'temperatura', 602.0000, 'ºC'),
	(297767, 143, '2015-01-01 01:29:33.000000', 'temperatura', 937.0000, 'ºC'),
	(297768, 143, '2015-01-01 01:29:34.000000', 'temperatura', 483.0000, 'ºC'),
	(297769, 143, '2015-01-01 01:29:35.000000', 'temperatura', 801.0000, 'ºC'),
	(297770, 143, '2015-01-01 01:29:36.000000', 'temperatura', 158.0000, 'ºC'),
	(297771, 143, '2015-01-01 01:29:37.000000', 'temperatura', 787.0000, 'ºC'),
	(297772, 143, '2015-01-01 01:29:38.000000', 'temperatura', 1063.0000, 'ºC'),
	(297773, 143, '2015-01-01 01:29:39.000000', 'temperatura', 552.0000, 'ºC'),
	(297774, 143, '2015-01-01 01:29:40.000000', 'temperatura', 771.0000, 'ºC'),
	(297775, 143, '2015-01-01 01:29:41.000000', 'temperatura', 1001.0000, 'ºC'),
	(297776, 143, '2015-01-01 01:29:42.000000', 'temperatura', 293.0000, 'ºC'),
	(297777, 143, '2015-01-01 01:29:43.000000', 'temperatura', 861.0000, 'ºC'),
	(297778, 143, '2015-01-01 01:29:44.000000', 'temperatura', 1027.0000, 'ºC'),
	(297779, 143, '2015-01-01 01:29:45.000000', 'temperatura', 152.0000, 'ºC'),
	(297780, 143, '2015-01-01 01:29:46.000000', 'temperatura', 81.0000, 'ºC'),
	(297781, 143, '2015-01-01 01:29:47.000000', 'temperatura', 1149.0000, 'ºC'),
	(297782, 143, '2015-01-01 01:29:48.000000', 'temperatura', 704.0000, 'ºC'),
	(297783, 143, '2015-01-01 01:29:49.000000', 'temperatura', 71.0000, 'ºC'),
	(297784, 143, '2015-01-01 01:29:50.000000', 'temperatura', 643.0000, 'ºC'),
	(297785, 143, '2015-01-01 01:29:51.000000', 'temperatura', 603.0000, 'ºC'),
	(297786, 143, '2015-01-01 01:29:52.000000', 'temperatura', 1085.0000, 'ºC'),
	(297787, 143, '2015-01-01 01:29:53.000000', 'temperatura', 19.0000, 'ºC'),
	(297788, 143, '2015-01-01 01:29:54.000000', 'temperatura', 441.0000, 'ºC'),
	(297789, 143, '2015-01-01 01:29:55.000000', 'temperatura', 948.0000, 'ºC'),
	(297790, 143, '2015-01-01 01:29:56.000000', 'temperatura', 1017.0000, 'ºC'),
	(297791, 143, '2015-01-01 01:29:57.000000', 'temperatura', 1040.0000, 'ºC'),
	(297792, 143, '2015-01-01 01:29:58.000000', 'temperatura', 952.0000, 'ºC'),
	(297793, 143, '2015-01-01 01:29:59.000000', 'temperatura', 441.0000, 'ºC'),
	(297794, 143, '2015-01-01 01:30:00.000000', 'temperatura', 547.0000, 'ºC'),
	(297795, 143, '2015-01-01 01:30:01.000000', 'temperatura', 211.0000, 'ºC'),
	(297796, 143, '2015-01-01 01:30:02.000000', 'temperatura', 618.0000, 'ºC'),
	(297797, 143, '2015-01-01 01:30:03.000000', 'temperatura', 57.0000, 'ºC'),
	(297798, 143, '2015-01-01 01:30:04.000000', 'temperatura', 830.0000, 'ºC'),
	(297799, 143, '2015-01-01 01:30:05.000000', 'temperatura', 381.0000, 'ºC'),
	(297800, 143, '2015-01-01 01:30:06.000000', 'temperatura', 614.0000, 'ºC'),
	(297801, 143, '2015-01-01 01:30:07.000000', 'temperatura', 728.0000, 'ºC'),
	(297802, 143, '2015-01-01 01:30:08.000000', 'temperatura', 598.0000, 'ºC'),
	(297803, 143, '2015-01-01 01:30:09.000000', 'temperatura', 806.0000, 'ºC'),
	(297804, 143, '2015-01-01 01:30:10.000000', 'temperatura', 1035.0000, 'ºC'),
	(297805, 143, '2015-01-01 01:30:11.000000', 'temperatura', 361.0000, 'ºC'),
	(297806, 143, '2015-01-01 01:30:12.000000', 'temperatura', 1099.0000, 'ºC'),
	(297807, 143, '2015-01-01 01:30:13.000000', 'temperatura', 811.0000, 'ºC'),
	(297808, 143, '2015-01-01 01:30:14.000000', 'temperatura', 760.0000, 'ºC'),
	(297809, 143, '2015-01-01 01:30:15.000000', 'temperatura', 168.0000, 'ºC'),
	(297810, 143, '2015-01-01 01:30:16.000000', 'temperatura', 960.0000, 'ºC'),
	(297811, 143, '2015-01-01 01:30:17.000000', 'temperatura', 695.0000, 'ºC'),
	(297812, 143, '2015-01-01 01:30:18.000000', 'temperatura', 597.0000, 'ºC'),
	(297813, 143, '2015-01-01 01:30:19.000000', 'temperatura', 902.0000, 'ºC'),
	(297814, 143, '2015-01-01 01:30:20.000000', 'temperatura', 318.0000, 'ºC'),
	(297815, 143, '2015-01-01 01:30:21.000000', 'temperatura', 83.0000, 'ºC'),
	(297816, 143, '2015-01-01 01:30:22.000000', 'temperatura', 662.0000, 'ºC'),
	(297817, 143, '2015-01-01 01:30:23.000000', 'temperatura', 661.0000, 'ºC'),
	(297818, 143, '2015-01-01 01:30:24.000000', 'temperatura', 122.0000, 'ºC'),
	(297819, 143, '2015-01-01 01:30:25.000000', 'temperatura', 1024.0000, 'ºC'),
	(297820, 143, '2015-01-01 01:30:26.000000', 'temperatura', 1157.0000, 'ºC'),
	(297821, 143, '2015-01-01 01:30:27.000000', 'temperatura', 315.0000, 'ºC'),
	(297822, 143, '2015-01-01 01:30:28.000000', 'temperatura', 502.0000, 'ºC'),
	(297823, 143, '2015-01-01 01:30:29.000000', 'temperatura', 364.0000, 'ºC'),
	(297824, 143, '2015-01-01 01:30:30.000000', 'temperatura', 317.0000, 'ºC'),
	(297825, 143, '2015-01-01 01:30:31.000000', 'temperatura', 494.0000, 'ºC'),
	(297826, 143, '2015-01-01 01:30:32.000000', 'temperatura', 318.0000, 'ºC'),
	(297827, 143, '2015-01-01 01:30:33.000000', 'temperatura', 110.0000, 'ºC'),
	(297828, 143, '2015-01-01 01:30:34.000000', 'temperatura', 798.0000, 'ºC'),
	(297829, 143, '2015-01-01 01:30:35.000000', 'temperatura', 59.0000, 'ºC'),
	(297830, 143, '2015-01-01 01:30:36.000000', 'temperatura', 299.0000, 'ºC'),
	(297831, 143, '2015-01-01 01:30:37.000000', 'temperatura', 122.0000, 'ºC'),
	(297832, 143, '2015-01-01 01:30:38.000000', 'temperatura', 911.0000, 'ºC'),
	(297833, 143, '2015-01-01 01:30:39.000000', 'temperatura', 590.0000, 'ºC'),
	(297834, 143, '2015-01-01 01:30:40.000000', 'temperatura', 218.0000, 'ºC'),
	(297835, 143, '2015-01-01 01:30:41.000000', 'temperatura', 521.0000, 'ºC'),
	(297836, 143, '2015-01-01 01:30:42.000000', 'temperatura', 753.0000, 'ºC'),
	(297837, 143, '2015-01-01 01:30:43.000000', 'temperatura', 1001.0000, 'ºC'),
	(297838, 143, '2015-01-01 01:30:44.000000', 'temperatura', 345.0000, 'ºC'),
	(297839, 143, '2015-01-01 01:30:45.000000', 'temperatura', 1125.0000, 'ºC'),
	(297840, 143, '2015-01-01 01:30:46.000000', 'temperatura', 990.0000, 'ºC'),
	(297841, 143, '2015-01-01 01:30:47.000000', 'temperatura', 376.0000, 'ºC'),
	(297842, 143, '2015-01-01 01:30:48.000000', 'temperatura', 109.0000, 'ºC'),
	(297843, 143, '2015-01-01 01:30:49.000000', 'temperatura', 620.0000, 'ºC'),
	(297844, 143, '2015-01-01 01:30:50.000000', 'temperatura', 371.0000, 'ºC'),
	(297845, 143, '2015-01-01 01:30:51.000000', 'temperatura', 1197.0000, 'ºC'),
	(297846, 143, '2015-01-01 01:30:52.000000', 'temperatura', 74.0000, 'ºC'),
	(297847, 143, '2015-01-01 01:30:53.000000', 'temperatura', 377.0000, 'ºC'),
	(297848, 143, '2015-01-01 01:30:54.000000', 'temperatura', 465.0000, 'ºC'),
	(297849, 143, '2015-01-01 01:30:55.000000', 'temperatura', 1193.0000, 'ºC'),
	(297850, 143, '2015-01-01 01:30:56.000000', 'temperatura', 973.0000, 'ºC'),
	(297851, 143, '2015-01-01 01:30:57.000000', 'temperatura', 87.0000, 'ºC'),
	(297852, 143, '2015-01-01 01:30:58.000000', 'temperatura', 1113.0000, 'ºC'),
	(297853, 143, '2015-01-01 01:30:59.000000', 'temperatura', 508.0000, 'ºC'),
	(297854, 143, '2015-01-01 01:31:00.000000', 'temperatura', 401.0000, 'ºC'),
	(297855, 143, '2015-01-01 01:31:01.000000', 'temperatura', 482.0000, 'ºC'),
	(297856, 143, '2015-01-01 01:31:02.000000', 'temperatura', 5.0000, 'ºC'),
	(297857, 143, '2015-01-01 01:31:03.000000', 'temperatura', 980.0000, 'ºC'),
	(297858, 143, '2015-01-01 01:31:04.000000', 'temperatura', 86.0000, 'ºC'),
	(297859, 143, '2015-01-01 01:31:05.000000', 'temperatura', 1092.0000, 'ºC'),
	(297860, 143, '2015-01-01 01:31:06.000000', 'temperatura', 401.0000, 'ºC'),
	(297861, 143, '2015-01-01 01:31:07.000000', 'temperatura', 1128.0000, 'ºC'),
	(297862, 143, '2015-01-01 01:31:08.000000', 'temperatura', 841.0000, 'ºC'),
	(297863, 143, '2015-01-01 01:31:09.000000', 'temperatura', 819.0000, 'ºC'),
	(297864, 143, '2015-01-01 01:31:10.000000', 'temperatura', 372.0000, 'ºC'),
	(297865, 143, '2015-01-01 01:31:11.000000', 'temperatura', 606.0000, 'ºC'),
	(297866, 143, '2015-01-01 01:31:12.000000', 'temperatura', 713.0000, 'ºC'),
	(297867, 143, '2015-01-01 01:31:13.000000', 'temperatura', 546.0000, 'ºC'),
	(297868, 143, '2015-01-01 01:31:14.000000', 'temperatura', 592.0000, 'ºC'),
	(297869, 143, '2015-01-01 01:31:15.000000', 'temperatura', 122.0000, 'ºC'),
	(297870, 143, '2015-01-01 01:31:16.000000', 'temperatura', 37.0000, 'ºC'),
	(297871, 143, '2015-01-01 01:31:17.000000', 'temperatura', 1018.0000, 'ºC'),
	(297872, 143, '2015-01-01 01:31:18.000000', 'temperatura', 179.0000, 'ºC'),
	(297873, 143, '2015-01-01 01:31:19.000000', 'temperatura', 244.0000, 'ºC'),
	(297874, 143, '2015-01-01 01:31:20.000000', 'temperatura', 681.0000, 'ºC'),
	(297875, 143, '2015-01-01 01:31:21.000000', 'temperatura', 272.0000, 'ºC'),
	(297876, 143, '2015-01-01 01:31:22.000000', 'temperatura', 520.0000, 'ºC'),
	(297877, 143, '2015-01-01 01:31:23.000000', 'temperatura', 586.0000, 'ºC'),
	(297878, 143, '2015-01-01 01:31:24.000000', 'temperatura', 168.0000, 'ºC'),
	(297879, 143, '2015-01-01 01:31:25.000000', 'temperatura', 285.0000, 'ºC'),
	(297880, 143, '2015-01-01 01:31:26.000000', 'temperatura', 919.0000, 'ºC'),
	(297881, 143, '2015-01-01 01:31:27.000000', 'temperatura', 140.0000, 'ºC'),
	(297882, 143, '2015-01-01 01:31:28.000000', 'temperatura', 344.0000, 'ºC'),
	(297883, 143, '2015-01-01 01:31:29.000000', 'temperatura', 99.0000, 'ºC'),
	(297884, 143, '2015-01-01 01:31:30.000000', 'temperatura', 666.0000, 'ºC'),
	(297885, 143, '2015-01-01 01:31:31.000000', 'temperatura', 634.0000, 'ºC'),
	(297886, 143, '2015-01-01 01:31:32.000000', 'temperatura', 1170.0000, 'ºC'),
	(297887, 143, '2015-01-01 01:31:33.000000', 'temperatura', 351.0000, 'ºC'),
	(297888, 143, '2015-01-01 01:31:34.000000', 'temperatura', 645.0000, 'ºC'),
	(297889, 143, '2015-01-01 01:31:35.000000', 'temperatura', 974.0000, 'ºC'),
	(297890, 143, '2015-01-01 01:31:36.000000', 'temperatura', 532.0000, 'ºC'),
	(297891, 143, '2015-01-01 01:31:37.000000', 'temperatura', 941.0000, 'ºC'),
	(297892, 143, '2015-01-01 01:31:38.000000', 'temperatura', 711.0000, 'ºC'),
	(297893, 143, '2015-01-01 01:31:39.000000', 'temperatura', 730.0000, 'ºC'),
	(297894, 143, '2015-01-01 01:31:40.000000', 'temperatura', 320.0000, 'ºC'),
	(297895, 143, '2015-01-01 01:31:41.000000', 'temperatura', 609.0000, 'ºC'),
	(297896, 143, '2015-01-01 01:31:42.000000', 'temperatura', 887.0000, 'ºC'),
	(297897, 143, '2015-01-01 01:31:43.000000', 'temperatura', 206.0000, 'ºC'),
	(297898, 143, '2015-01-01 01:31:44.000000', 'temperatura', 771.0000, 'ºC'),
	(297899, 143, '2015-01-01 01:31:45.000000', 'temperatura', 839.0000, 'ºC'),
	(297900, 143, '2015-01-01 01:31:46.000000', 'temperatura', 682.0000, 'ºC'),
	(297901, 143, '2015-01-01 01:31:47.000000', 'temperatura', 892.0000, 'ºC'),
	(297902, 143, '2015-01-01 01:31:48.000000', 'temperatura', 13.0000, 'ºC'),
	(297903, 143, '2015-01-01 01:31:49.000000', 'temperatura', 993.0000, 'ºC'),
	(297904, 143, '2015-01-01 01:31:50.000000', 'temperatura', 124.0000, 'ºC'),
	(297905, 143, '2015-01-01 01:31:51.000000', 'temperatura', 44.0000, 'ºC'),
	(297906, 143, '2015-01-01 01:31:52.000000', 'temperatura', 1046.0000, 'ºC'),
	(297907, 143, '2015-01-01 01:31:53.000000', 'temperatura', 298.0000, 'ºC'),
	(297908, 143, '2015-01-01 01:31:54.000000', 'temperatura', 754.0000, 'ºC'),
	(297909, 143, '2015-01-01 01:31:55.000000', 'temperatura', 476.0000, 'ºC'),
	(297910, 143, '2015-01-01 01:31:56.000000', 'temperatura', 118.0000, 'ºC'),
	(297911, 143, '2015-01-01 01:31:57.000000', 'temperatura', 362.0000, 'ºC'),
	(297912, 143, '2015-01-01 01:31:58.000000', 'temperatura', 256.0000, 'ºC'),
	(297913, 143, '2015-01-01 01:31:59.000000', 'temperatura', 197.0000, 'ºC'),
	(297914, 143, '2015-01-01 01:32:00.000000', 'temperatura', 216.0000, 'ºC'),
	(297915, 143, '2015-01-01 01:32:01.000000', 'temperatura', 488.0000, 'ºC'),
	(297916, 143, '2015-01-01 01:32:02.000000', 'temperatura', 594.0000, 'ºC'),
	(297917, 143, '2015-01-01 01:32:03.000000', 'temperatura', 308.0000, 'ºC'),
	(297918, 143, '2015-01-01 01:32:04.000000', 'temperatura', 958.0000, 'ºC'),
	(297919, 143, '2015-01-01 01:32:05.000000', 'temperatura', 266.0000, 'ºC'),
	(297920, 143, '2015-01-01 01:32:06.000000', 'temperatura', 855.0000, 'ºC'),
	(297921, 143, '2015-01-01 01:32:07.000000', 'temperatura', 1079.0000, 'ºC'),
	(297922, 143, '2015-01-01 01:32:08.000000', 'temperatura', 430.0000, 'ºC'),
	(297923, 143, '2015-01-01 01:32:09.000000', 'temperatura', 115.0000, 'ºC'),
	(297924, 143, '2015-01-01 01:32:10.000000', 'temperatura', 485.0000, 'ºC'),
	(297925, 143, '2015-01-01 01:32:11.000000', 'temperatura', 882.0000, 'ºC'),
	(297926, 143, '2015-01-01 01:32:12.000000', 'temperatura', 553.0000, 'ºC'),
	(297927, 143, '2015-01-01 01:32:13.000000', 'temperatura', 120.0000, 'ºC'),
	(297928, 143, '2015-01-01 01:32:14.000000', 'temperatura', 140.0000, 'ºC'),
	(297929, 143, '2015-01-01 01:32:15.000000', 'temperatura', 344.0000, 'ºC'),
	(297930, 143, '2015-01-01 01:32:16.000000', 'temperatura', 98.0000, 'ºC'),
	(297931, 143, '2015-01-01 01:32:17.000000', 'temperatura', 658.0000, 'ºC'),
	(297932, 143, '2015-01-01 01:32:18.000000', 'temperatura', 596.0000, 'ºC'),
	(297933, 143, '2015-01-01 01:32:19.000000', 'temperatura', 1007.0000, 'ºC'),
	(297934, 143, '2015-01-01 01:32:20.000000', 'temperatura', 846.0000, 'ºC'),
	(297935, 143, '2015-01-01 01:32:21.000000', 'temperatura', 10.0000, 'ºC'),
	(297936, 143, '2015-01-01 01:32:22.000000', 'temperatura', 1114.0000, 'ºC'),
	(297937, 143, '2015-01-01 01:32:23.000000', 'temperatura', 739.0000, 'ºC'),
	(297938, 143, '2015-01-01 01:32:24.000000', 'temperatura', 354.0000, 'ºC'),
	(297939, 143, '2015-01-01 01:32:25.000000', 'temperatura', 752.0000, 'ºC'),
	(297940, 143, '2015-01-01 01:32:26.000000', 'temperatura', 300.0000, 'ºC'),
	(297941, 143, '2015-01-01 01:32:27.000000', 'temperatura', 445.0000, 'ºC'),
	(297942, 143, '2015-01-01 01:32:28.000000', 'temperatura', 125.0000, 'ºC'),
	(297943, 143, '2015-01-01 01:32:29.000000', 'temperatura', 488.0000, 'ºC'),
	(297944, 143, '2015-01-01 01:32:30.000000', 'temperatura', 869.0000, 'ºC'),
	(297945, 143, '2015-01-01 01:32:31.000000', 'temperatura', 480.0000, 'ºC'),
	(297946, 143, '2015-01-01 01:32:32.000000', 'temperatura', 992.0000, 'ºC'),
	(297947, 143, '2015-01-01 01:32:33.000000', 'temperatura', 1122.0000, 'ºC'),
	(297948, 143, '2015-01-01 01:32:34.000000', 'temperatura', 232.0000, 'ºC'),
	(297949, 143, '2015-01-01 01:32:35.000000', 'temperatura', 198.0000, 'ºC'),
	(297950, 143, '2015-01-01 01:32:36.000000', 'temperatura', 291.0000, 'ºC'),
	(297951, 143, '2015-01-01 01:32:37.000000', 'temperatura', 864.0000, 'ºC'),
	(297952, 143, '2015-01-01 01:32:38.000000', 'temperatura', 1047.0000, 'ºC'),
	(297953, 143, '2015-01-01 01:32:39.000000', 'temperatura', 245.0000, 'ºC'),
	(297954, 143, '2015-01-01 01:32:40.000000', 'temperatura', 485.0000, 'ºC'),
	(297955, 143, '2015-01-01 01:32:41.000000', 'temperatura', 490.0000, 'ºC'),
	(297956, 143, '2015-01-01 01:32:42.000000', 'temperatura', 996.0000, 'ºC'),
	(297957, 143, '2015-01-01 01:32:43.000000', 'temperatura', 1110.0000, 'ºC'),
	(297958, 143, '2015-01-01 01:32:44.000000', 'temperatura', 163.0000, 'ºC'),
	(297959, 143, '2015-01-01 01:32:45.000000', 'temperatura', 1085.0000, 'ºC'),
	(297960, 143, '2015-01-01 01:32:46.000000', 'temperatura', 134.0000, 'ºC'),
	(297961, 143, '2015-01-01 01:32:47.000000', 'temperatura', 1019.0000, 'ºC'),
	(297962, 143, '2015-01-01 01:32:48.000000', 'temperatura', 1092.0000, 'ºC'),
	(297963, 143, '2015-01-01 01:32:49.000000', 'temperatura', 5.0000, 'ºC'),
	(297964, 143, '2015-01-01 01:32:50.000000', 'temperatura', 349.0000, 'ºC'),
	(297965, 143, '2015-01-01 01:32:51.000000', 'temperatura', 532.0000, 'ºC'),
	(297966, 143, '2015-01-01 01:32:52.000000', 'temperatura', 411.0000, 'ºC'),
	(297967, 143, '2015-01-01 01:32:53.000000', 'temperatura', 462.0000, 'ºC'),
	(297968, 143, '2015-01-01 01:32:54.000000', 'temperatura', 1075.0000, 'ºC'),
	(297969, 143, '2015-01-01 01:32:55.000000', 'temperatura', 389.0000, 'ºC'),
	(297970, 143, '2015-01-01 01:32:56.000000', 'temperatura', 1121.0000, 'ºC'),
	(297971, 143, '2015-01-01 01:32:57.000000', 'temperatura', 841.0000, 'ºC'),
	(297972, 143, '2015-01-01 01:32:58.000000', 'temperatura', 840.0000, 'ºC'),
	(297973, 143, '2015-01-01 01:32:59.000000', 'temperatura', 478.0000, 'ºC'),
	(297974, 143, '2015-01-01 01:33:00.000000', 'temperatura', 1069.0000, 'ºC'),
	(297975, 143, '2015-01-01 01:33:01.000000', 'temperatura', 312.0000, 'ºC'),
	(297976, 143, '2015-01-01 01:33:02.000000', 'temperatura', 756.0000, 'ºC'),
	(297977, 143, '2015-01-01 01:33:03.000000', 'temperatura', 443.0000, 'ºC'),
	(297978, 143, '2015-01-01 01:33:04.000000', 'temperatura', 1147.0000, 'ºC'),
	(297979, 143, '2015-01-01 01:33:05.000000', 'temperatura', 809.0000, 'ºC'),
	(297980, 143, '2015-01-01 01:33:06.000000', 'temperatura', 603.0000, 'ºC'),
	(297981, 143, '2015-01-01 01:33:07.000000', 'temperatura', 589.0000, 'ºC'),
	(297982, 143, '2015-01-01 01:33:08.000000', 'temperatura', 1135.0000, 'ºC'),
	(297983, 143, '2015-01-01 01:33:09.000000', 'temperatura', 310.0000, 'ºC'),
	(297984, 143, '2015-01-01 01:33:10.000000', 'temperatura', 547.0000, 'ºC'),
	(297985, 143, '2015-01-01 01:33:11.000000', 'temperatura', 602.0000, 'ºC'),
	(297986, 143, '2015-01-01 01:33:12.000000', 'temperatura', 172.0000, 'ºC'),
	(297987, 143, '2015-01-01 01:33:13.000000', 'temperatura', 253.0000, 'ºC'),
	(297988, 143, '2015-01-01 01:33:14.000000', 'temperatura', 748.0000, 'ºC'),
	(297989, 143, '2015-01-01 01:33:15.000000', 'temperatura', 583.0000, 'ºC'),
	(297990, 143, '2015-01-01 01:33:16.000000', 'temperatura', 673.0000, 'ºC'),
	(297991, 143, '2015-01-01 01:33:17.000000', 'temperatura', 416.0000, 'ºC'),
	(297992, 143, '2015-01-01 01:33:18.000000', 'temperatura', 62.0000, 'ºC'),
	(297993, 143, '2015-01-01 01:33:19.000000', 'temperatura', 262.0000, 'ºC'),
	(297994, 143, '2015-01-01 01:33:20.000000', 'temperatura', 1125.0000, 'ºC'),
	(297995, 143, '2015-01-01 01:33:21.000000', 'temperatura', 40.0000, 'ºC'),
	(297996, 143, '2015-01-01 01:33:22.000000', 'temperatura', 423.0000, 'ºC'),
	(297997, 143, '2015-01-01 01:33:23.000000', 'temperatura', 797.0000, 'ºC'),
	(297998, 143, '2015-01-01 01:33:24.000000', 'temperatura', 315.0000, 'ºC'),
	(297999, 143, '2015-01-01 01:33:25.000000', 'temperatura', 385.0000, 'ºC'),
	(298000, 143, '2015-01-01 01:33:26.000000', 'temperatura', 980.0000, 'ºC'),
	(298001, 143, '2015-01-01 01:33:27.000000', 'temperatura', 147.0000, 'ºC'),
	(298002, 143, '2015-01-01 01:33:28.000000', 'temperatura', 196.0000, 'ºC'),
	(298003, 143, '2015-01-01 01:33:29.000000', 'temperatura', 539.0000, 'ºC'),
	(298004, 143, '2015-01-01 01:33:30.000000', 'temperatura', 909.0000, 'ºC'),
	(298005, 143, '2015-01-01 01:33:31.000000', 'temperatura', 529.0000, 'ºC'),
	(298006, 143, '2015-01-01 01:33:32.000000', 'temperatura', 1118.0000, 'ºC'),
	(298007, 143, '2015-01-01 01:33:33.000000', 'temperatura', 402.0000, 'ºC'),
	(298008, 143, '2015-01-01 01:33:34.000000', 'temperatura', 1058.0000, 'ºC'),
	(298009, 143, '2015-01-01 01:33:35.000000', 'temperatura', 486.0000, 'ºC'),
	(298010, 143, '2015-01-01 01:33:36.000000', 'temperatura', 453.0000, 'ºC'),
	(298011, 143, '2015-01-01 01:33:37.000000', 'temperatura', 809.0000, 'ºC'),
	(298012, 143, '2015-01-01 01:33:38.000000', 'temperatura', 287.0000, 'ºC'),
	(298013, 143, '2015-01-01 01:33:39.000000', 'temperatura', 206.0000, 'ºC'),
	(298014, 143, '2015-01-01 01:33:40.000000', 'temperatura', 171.0000, 'ºC'),
	(298015, 143, '2015-01-01 01:33:41.000000', 'temperatura', 238.0000, 'ºC'),
	(298016, 143, '2015-01-01 01:33:42.000000', 'temperatura', 678.0000, 'ºC'),
	(298017, 143, '2015-01-01 01:33:43.000000', 'temperatura', 276.0000, 'ºC'),
	(298018, 143, '2015-01-01 01:33:44.000000', 'temperatura', 546.0000, 'ºC'),
	(298019, 143, '2015-01-01 01:33:45.000000', 'temperatura', 701.0000, 'ºC'),
	(298020, 144, '2015-01-01 00:00:00.000000', 'temperatura', 39.0000, 'ºC'),
	(298021, 144, '2015-01-01 00:00:01.000000', 'temperatura', 591.0000, 'ºC'),
	(298022, 144, '2015-01-01 00:00:02.000000', 'temperatura', 437.0000, 'ºC'),
	(298023, 144, '2015-01-01 00:00:03.000000', 'temperatura', 414.0000, 'ºC'),
	(298024, 144, '2015-01-01 00:00:04.000000', 'temperatura', 758.0000, 'ºC'),
	(298025, 144, '2015-01-01 00:00:05.000000', 'temperatura', 149.0000, 'ºC'),
	(298026, 144, '2015-01-01 00:00:06.000000', 'temperatura', 871.0000, 'ºC'),
	(298027, 144, '2015-01-01 00:00:07.000000', 'temperatura', 308.0000, 'ºC'),
	(298028, 144, '2015-01-01 00:00:08.000000', 'temperatura', 127.0000, 'ºC'),
	(298029, 144, '2015-01-01 00:00:09.000000', 'temperatura', 914.0000, 'ºC'),
	(298030, 144, '2015-01-01 00:00:10.000000', 'temperatura', 590.0000, 'ºC'),
	(298031, 144, '2015-01-01 00:00:11.000000', 'temperatura', 206.0000, 'ºC'),
	(298032, 144, '2015-01-01 00:00:12.000000', 'temperatura', 461.0000, 'ºC'),
	(298033, 144, '2015-01-01 00:00:13.000000', 'temperatura', 487.0000, 'ºC'),
	(298034, 144, '2015-01-01 00:00:14.000000', 'temperatura', 1051.0000, 'ºC'),
	(298035, 144, '2015-01-01 00:00:15.000000', 'temperatura', 198.0000, 'ºC'),
	(298036, 144, '2015-01-01 00:00:16.000000', 'temperatura', 235.0000, 'ºC'),
	(298037, 144, '2015-01-01 00:00:17.000000', 'temperatura', 582.0000, 'ºC'),
	(298038, 144, '2015-01-01 00:00:18.000000', 'temperatura', 1006.0000, 'ºC'),
	(298039, 144, '2015-01-01 00:00:19.000000', 'temperatura', 885.0000, 'ºC'),
	(298040, 144, '2015-01-01 00:00:20.000000', 'temperatura', 206.0000, 'ºC'),
	(298041, 144, '2015-01-01 00:00:21.000000', 'temperatura', 777.0000, 'ºC'),
	(298042, 144, '2015-01-01 00:00:22.000000', 'temperatura', 867.0000, 'ºC'),
	(298043, 144, '2015-01-01 00:00:23.000000', 'temperatura', 804.0000, 'ºC'),
	(298044, 144, '2015-01-01 00:00:24.000000', 'temperatura', 221.0000, 'ºC'),
	(298045, 144, '2015-01-01 00:00:25.000000', 'temperatura', 1092.0000, 'ºC'),
	(298046, 144, '2015-01-01 00:00:26.000000', 'temperatura', 0.0000, 'ºC'),
	(298047, 144, '2015-01-01 00:00:27.000000', 'temperatura', 323.0000, 'ºC'),
	(298048, 144, '2015-01-01 00:00:28.000000', 'temperatura', 413.0000, 'ºC'),
	(298049, 144, '2015-01-01 00:00:29.000000', 'temperatura', 1100.0000, 'ºC'),
	(298050, 144, '2015-01-01 00:00:30.000000', 'temperatura', 661.0000, 'ºC'),
	(298051, 144, '2015-01-01 00:00:31.000000', 'temperatura', 5.0000, 'ºC'),
	(298052, 144, '2015-01-01 00:00:32.000000', 'temperatura', 443.0000, 'ºC'),
	(298053, 144, '2015-01-01 00:00:33.000000', 'temperatura', 999.0000, 'ºC'),
	(298054, 144, '2015-01-01 00:00:34.000000', 'temperatura', 68.0000, 'ºC'),
	(298055, 144, '2015-01-01 00:00:35.000000', 'temperatura', 944.0000, 'ºC'),
	(298056, 144, '2015-01-01 00:00:36.000000', 'temperatura', 914.0000, 'ºC'),
	(298057, 144, '2015-01-01 00:00:37.000000', 'temperatura', 539.0000, 'ºC'),
	(298058, 144, '2015-01-01 00:00:38.000000', 'temperatura', 1156.0000, 'ºC'),
	(298059, 144, '2015-01-01 00:00:39.000000', 'temperatura', 562.0000, 'ºC'),
	(298060, 144, '2015-01-01 00:00:40.000000', 'temperatura', 543.0000, 'ºC'),
	(298061, 144, '2015-01-01 00:00:41.000000', 'temperatura', 1028.0000, 'ºC'),
	(298062, 144, '2015-01-01 00:00:42.000000', 'temperatura', 1113.0000, 'ºC'),
	(298063, 144, '2015-01-01 00:00:43.000000', 'temperatura', 82.0000, 'ºC'),
	(298064, 144, '2015-01-01 00:00:44.000000', 'temperatura', 672.0000, 'ºC'),
	(298065, 144, '2015-01-01 00:00:45.000000', 'temperatura', 714.0000, 'ºC'),
	(298066, 144, '2015-01-01 00:00:46.000000', 'temperatura', 354.0000, 'ºC'),
	(298067, 144, '2015-01-01 00:00:47.000000', 'temperatura', 828.0000, 'ºC'),
	(298068, 144, '2015-01-01 00:00:48.000000', 'temperatura', 681.0000, 'ºC'),
	(298069, 144, '2015-01-01 00:00:49.000000', 'temperatura', 918.0000, 'ºC'),
	(298070, 144, '2015-01-01 00:00:50.000000', 'temperatura', 149.0000, 'ºC'),
	(298071, 144, '2015-01-01 00:00:51.000000', 'temperatura', 391.0000, 'ºC'),
	(298072, 144, '2015-01-01 00:00:52.000000', 'temperatura', 311.0000, 'ºC'),
	(298073, 144, '2015-01-01 00:00:53.000000', 'temperatura', 380.0000, 'ºC'),
	(298074, 144, '2015-01-01 00:00:54.000000', 'temperatura', 968.0000, 'ºC'),
	(298075, 144, '2015-01-01 00:00:55.000000', 'temperatura', 100.0000, 'ºC'),
	(298076, 144, '2015-01-01 00:00:56.000000', 'temperatura', 1195.0000, 'ºC'),
	(298077, 144, '2015-01-01 00:00:57.000000', 'temperatura', 876.0000, 'ºC'),
	(298078, 144, '2015-01-01 00:00:58.000000', 'temperatura', 796.0000, 'ºC'),
	(298079, 144, '2015-01-01 00:00:59.000000', 'temperatura', 154.0000, 'ºC'),
	(298080, 144, '2015-01-01 00:01:00.000000', 'temperatura', 782.0000, 'ºC'),
	(298081, 144, '2015-01-01 00:01:01.000000', 'temperatura', 1047.0000, 'ºC'),
	(298082, 144, '2015-01-01 00:01:02.000000', 'temperatura', 490.0000, 'ºC'),
	(298083, 144, '2015-01-01 00:01:03.000000', 'temperatura', 509.0000, 'ºC'),
	(298084, 144, '2015-01-01 00:01:04.000000', 'temperatura', 1075.0000, 'ºC'),
	(298085, 144, '2015-01-01 00:01:05.000000', 'temperatura', 250.0000, 'ºC'),
	(298086, 144, '2015-01-01 00:01:06.000000', 'temperatura', 424.0000, 'ºC'),
	(298087, 144, '2015-01-01 00:01:07.000000', 'temperatura', 169.0000, 'ºC'),
	(298088, 144, '2015-01-01 00:01:08.000000', 'temperatura', 776.0000, 'ºC'),
	(298089, 144, '2015-01-01 00:01:09.000000', 'temperatura', 974.0000, 'ºC'),
	(298090, 144, '2015-01-01 00:01:10.000000', 'temperatura', 141.0000, 'ºC'),
	(298091, 144, '2015-01-01 00:01:11.000000', 'temperatura', 183.0000, 'ºC'),
	(298092, 144, '2015-01-01 00:01:12.000000', 'temperatura', 491.0000, 'ºC'),
	(298093, 144, '2015-01-01 00:01:13.000000', 'temperatura', 708.0000, 'ºC'),
	(298094, 144, '2015-01-01 00:01:14.000000', 'temperatura', 868.0000, 'ºC'),
	(298095, 144, '2015-01-01 00:01:15.000000', 'temperatura', 1017.0000, 'ºC'),
	(298096, 144, '2015-01-01 00:01:16.000000', 'temperatura', 82.0000, 'ºC'),
	(298097, 144, '2015-01-01 00:01:17.000000', 'temperatura', 958.0000, 'ºC'),
	(298098, 144, '2015-01-01 00:01:18.000000', 'temperatura', 945.0000, 'ºC'),
	(298099, 144, '2015-01-01 00:01:19.000000', 'temperatura', 650.0000, 'ºC'),
	(298100, 144, '2015-01-01 00:01:20.000000', 'temperatura', 417.0000, 'ºC'),
	(298101, 144, '2015-01-01 00:01:21.000000', 'temperatura', 137.0000, 'ºC'),
	(298102, 144, '2015-01-01 00:01:22.000000', 'temperatura', 634.0000, 'ºC'),
	(298103, 144, '2015-01-01 00:01:23.000000', 'temperatura', 359.0000, 'ºC'),
	(298104, 144, '2015-01-01 00:01:24.000000', 'temperatura', 1095.0000, 'ºC'),
	(298105, 144, '2015-01-01 00:01:25.000000', 'temperatura', 796.0000, 'ºC'),
	(298106, 144, '2015-01-01 00:01:26.000000', 'temperatura', 696.0000, 'ºC'),
	(298107, 144, '2015-01-01 00:01:27.000000', 'temperatura', 1092.0000, 'ºC'),
	(298108, 144, '2015-01-01 00:01:28.000000', 'temperatura', 974.0000, 'ºC'),
	(298109, 144, '2015-01-01 00:01:29.000000', 'temperatura', 395.0000, 'ºC'),
	(298110, 144, '2015-01-01 00:01:30.000000', 'temperatura', 251.0000, 'ºC'),
	(298111, 144, '2015-01-01 00:01:31.000000', 'temperatura', 71.0000, 'ºC'),
	(298112, 144, '2015-01-01 00:01:32.000000', 'temperatura', 804.0000, 'ºC'),
	(298113, 144, '2015-01-01 00:01:33.000000', 'temperatura', 207.0000, 'ºC'),
	(298114, 144, '2015-01-01 00:01:34.000000', 'temperatura', 1024.0000, 'ºC'),
	(298115, 144, '2015-01-01 00:01:35.000000', 'temperatura', 901.0000, 'ºC'),
	(298116, 144, '2015-01-01 00:01:36.000000', 'temperatura', 231.0000, 'ºC'),
	(298117, 144, '2015-01-01 00:01:37.000000', 'temperatura', 852.0000, 'ºC'),
	(298118, 144, '2015-01-01 00:01:38.000000', 'temperatura', 1167.0000, 'ºC'),
	(298119, 144, '2015-01-01 00:01:39.000000', 'temperatura', 880.0000, 'ºC'),
	(298120, 144, '2015-01-01 00:01:40.000000', 'temperatura', 902.0000, 'ºC'),
	(298121, 144, '2015-01-01 00:01:41.000000', 'temperatura', 668.0000, 'ºC'),
	(298122, 144, '2015-01-01 00:01:42.000000', 'temperatura', 635.0000, 'ºC'),
	(298123, 144, '2015-01-01 00:01:43.000000', 'temperatura', 1173.0000, 'ºC'),
	(298124, 144, '2015-01-01 00:01:44.000000', 'temperatura', 360.0000, 'ºC'),
	(298125, 144, '2015-01-01 00:01:45.000000', 'temperatura', 683.0000, 'ºC'),
	(298126, 144, '2015-01-01 00:01:46.000000', 'temperatura', 1134.0000, 'ºC'),
	(298127, 144, '2015-01-01 00:01:47.000000', 'temperatura', 23.0000, 'ºC'),
	(298128, 144, '2015-01-01 00:01:48.000000', 'temperatura', 312.0000, 'ºC'),
	(298129, 144, '2015-01-01 00:01:49.000000', 'temperatura', 294.0000, 'ºC'),
	(298130, 144, '2015-01-01 00:01:50.000000', 'temperatura', 531.0000, 'ºC'),
	(298131, 144, '2015-01-01 00:01:51.000000', 'temperatura', 575.0000, 'ºC'),
	(298132, 144, '2015-01-01 00:01:52.000000', 'temperatura', 81.0000, 'ºC'),
	(298133, 144, '2015-01-01 00:01:53.000000', 'temperatura', 1081.0000, 'ºC'),
	(298134, 144, '2015-01-01 00:01:54.000000', 'temperatura', 361.0000, 'ºC'),
	(298135, 144, '2015-01-01 00:01:55.000000', 'temperatura', 965.0000, 'ºC'),
	(298136, 144, '2015-01-01 00:01:56.000000', 'temperatura', 142.0000, 'ºC'),
	(298137, 144, '2015-01-01 00:01:57.000000', 'temperatura', 216.0000, 'ºC'),
	(298138, 144, '2015-01-01 00:01:58.000000', 'temperatura', 656.0000, 'ºC'),
	(298139, 144, '2015-01-01 00:01:59.000000', 'temperatura', 231.0000, 'ºC'),
	(298140, 144, '2015-01-01 00:02:00.000000', 'temperatura', 388.0000, 'ºC'),
	(298141, 144, '2015-01-01 00:02:01.000000', 'temperatura', 47.0000, 'ºC'),
	(298142, 144, '2015-01-01 00:02:02.000000', 'temperatura', 271.0000, 'ºC'),
	(298143, 144, '2015-01-01 00:02:03.000000', 'temperatura', 15.0000, 'ºC'),
	(298144, 144, '2015-01-01 00:02:04.000000', 'temperatura', 461.0000, 'ºC'),
	(298145, 144, '2015-01-01 00:02:05.000000', 'temperatura', 1063.0000, 'ºC'),
	(298146, 144, '2015-01-01 00:02:06.000000', 'temperatura', 331.0000, 'ºC'),
	(298147, 144, '2015-01-01 00:02:07.000000', 'temperatura', 866.0000, 'ºC'),
	(298148, 144, '2015-01-01 00:02:08.000000', 'temperatura', 938.0000, 'ºC'),
	(298149, 144, '2015-01-01 00:02:09.000000', 'temperatura', 891.0000, 'ºC'),
	(298150, 144, '2015-01-01 00:02:10.000000', 'temperatura', 443.0000, 'ºC'),
	(298151, 144, '2015-01-01 00:02:11.000000', 'temperatura', 741.0000, 'ºC'),
	(298152, 144, '2015-01-01 00:02:12.000000', 'temperatura', 1178.0000, 'ºC'),
	(298153, 144, '2015-01-01 00:02:13.000000', 'temperatura', 65.0000, 'ºC'),
	(298154, 144, '2015-01-01 00:02:14.000000', 'temperatura', 393.0000, 'ºC'),
	(298155, 144, '2015-01-01 00:02:15.000000', 'temperatura', 570.0000, 'ºC'),
	(298156, 144, '2015-01-01 00:02:16.000000', 'temperatura', 474.0000, 'ºC'),
	(298157, 144, '2015-01-01 00:02:17.000000', 'temperatura', 658.0000, 'ºC'),
	(298158, 144, '2015-01-01 00:02:18.000000', 'temperatura', 668.0000, 'ºC'),
	(298159, 144, '2015-01-01 00:02:19.000000', 'temperatura', 168.0000, 'ºC'),
	(298160, 144, '2015-01-01 00:02:20.000000', 'temperatura', 36.0000, 'ºC'),
	(298161, 144, '2015-01-01 00:02:21.000000', 'temperatura', 878.0000, 'ºC'),
	(298162, 144, '2015-01-01 00:02:22.000000', 'temperatura', 683.0000, 'ºC'),
	(298163, 144, '2015-01-01 00:02:23.000000', 'temperatura', 782.0000, 'ºC'),
	(298164, 144, '2015-01-01 00:02:24.000000', 'temperatura', 660.0000, 'ºC'),
	(298165, 144, '2015-01-01 00:02:25.000000', 'temperatura', 956.0000, 'ºC'),
	(298166, 144, '2015-01-01 00:02:26.000000', 'temperatura', 399.0000, 'ºC'),
	(298167, 144, '2015-01-01 00:02:27.000000', 'temperatura', 328.0000, 'ºC'),
	(298168, 144, '2015-01-01 00:02:28.000000', 'temperatura', 443.0000, 'ºC'),
	(298169, 144, '2015-01-01 00:02:29.000000', 'temperatura', 32.0000, 'ºC'),
	(298170, 144, '2015-01-01 00:02:30.000000', 'temperatura', 32.0000, 'ºC'),
	(298171, 144, '2015-01-01 00:02:31.000000', 'temperatura', 64.0000, 'ºC'),
	(298172, 144, '2015-01-01 00:02:32.000000', 'temperatura', 224.0000, 'ºC'),
	(298173, 144, '2015-01-01 00:02:33.000000', 'temperatura', 931.0000, 'ºC'),
	(298174, 144, '2015-01-01 00:02:34.000000', 'temperatura', 381.0000, 'ºC'),
	(298175, 144, '2015-01-01 00:02:35.000000', 'temperatura', 315.0000, 'ºC'),
	(298176, 144, '2015-01-01 00:02:36.000000', 'temperatura', 431.0000, 'ºC'),
	(298177, 144, '2015-01-01 00:02:37.000000', 'temperatura', 9.0000, 'ºC'),
	(298178, 144, '2015-01-01 00:02:38.000000', 'temperatura', 1152.0000, 'ºC'),
	(298179, 144, '2015-01-01 00:02:39.000000', 'temperatura', 934.0000, 'ºC'),
	(298180, 144, '2015-01-01 00:02:40.000000', 'temperatura', 17.0000, 'ºC'),
	(298181, 144, '2015-01-01 00:02:41.000000', 'temperatura', 880.0000, 'ºC'),
	(298182, 144, '2015-01-01 00:02:42.000000', 'temperatura', 751.0000, 'ºC'),
	(298183, 144, '2015-01-01 00:02:43.000000', 'temperatura', 1116.0000, 'ºC'),
	(298184, 144, '2015-01-01 00:02:44.000000', 'temperatura', 926.0000, 'ºC'),
	(298185, 144, '2015-01-01 00:02:45.000000', 'temperatura', 81.0000, 'ºC'),
	(298186, 144, '2015-01-01 00:02:46.000000', 'temperatura', 30.0000, 'ºC'),
	(298187, 144, '2015-01-01 00:02:47.000000', 'temperatura', 1106.0000, 'ºC'),
	(298188, 144, '2015-01-01 00:02:48.000000', 'temperatura', 640.0000, 'ºC'),
	(298189, 144, '2015-01-01 00:02:49.000000', 'temperatura', 1081.0000, 'ºC'),
	(298190, 144, '2015-01-01 00:02:50.000000', 'temperatura', 1089.0000, 'ºC'),
	(298191, 144, '2015-01-01 00:02:51.000000', 'temperatura', 1001.0000, 'ºC'),
	(298192, 144, '2015-01-01 00:02:52.000000', 'temperatura', 538.0000, 'ºC'),
	(298193, 144, '2015-01-01 00:02:53.000000', 'temperatura', 890.0000, 'ºC'),
	(298194, 144, '2015-01-01 00:02:54.000000', 'temperatura', 435.0000, 'ºC'),
	(298195, 144, '2015-01-01 00:02:55.000000', 'temperatura', 705.0000, 'ºC'),
	(298196, 144, '2015-01-01 00:02:56.000000', 'temperatura', 1019.0000, 'ºC'),
	(298197, 144, '2015-01-01 00:02:57.000000', 'temperatura', 582.0000, 'ºC'),
	(298198, 144, '2015-01-01 00:02:58.000000', 'temperatura', 1055.0000, 'ºC'),
	(298199, 144, '2015-01-01 00:02:59.000000', 'temperatura', 1126.0000, 'ºC'),
	(298200, 144, '2015-01-01 00:03:00.000000', 'temperatura', 69.0000, 'ºC'),
	(298201, 144, '2015-01-01 00:03:01.000000', 'temperatura', 567.0000, 'ºC'),
	(298202, 144, '2015-01-01 00:03:02.000000', 'temperatura', 227.0000, 'ºC'),
	(298203, 144, '2015-01-01 00:03:03.000000', 'temperatura', 633.0000, 'ºC'),
	(298204, 144, '2015-01-01 00:03:04.000000', 'temperatura', 87.0000, 'ºC'),
	(298205, 144, '2015-01-01 00:03:05.000000', 'temperatura', 936.0000, 'ºC'),
	(298206, 144, '2015-01-01 00:03:06.000000', 'temperatura', 818.0000, 'ºC'),
	(298207, 144, '2015-01-01 00:03:07.000000', 'temperatura', 84.0000, 'ºC'),
	(298208, 144, '2015-01-01 00:03:08.000000', 'temperatura', 365.0000, 'ºC'),
	(298209, 144, '2015-01-01 00:03:09.000000', 'temperatura', 376.0000, 'ºC'),
	(298210, 144, '2015-01-01 00:03:10.000000', 'temperatura', 783.0000, 'ºC'),
	(298211, 144, '2015-01-01 00:03:11.000000', 'temperatura', 390.0000, 'ºC'),
	(298212, 144, '2015-01-01 00:03:12.000000', 'temperatura', 800.0000, 'ºC'),
	(298213, 144, '2015-01-01 00:03:13.000000', 'temperatura', 432.0000, 'ºC'),
	(298214, 144, '2015-01-01 00:03:14.000000', 'temperatura', 958.0000, 'ºC'),
	(298215, 144, '2015-01-01 00:03:15.000000', 'temperatura', 1096.0000, 'ºC'),
	(298216, 144, '2015-01-01 00:03:16.000000', 'temperatura', 205.0000, 'ºC'),
	(298217, 144, '2015-01-01 00:03:17.000000', 'temperatura', 137.0000, 'ºC'),
	(298218, 144, '2015-01-01 00:03:18.000000', 'temperatura', 72.0000, 'ºC'),
	(298219, 144, '2015-01-01 00:03:19.000000', 'temperatura', 1148.0000, 'ºC'),
	(298220, 144, '2015-01-01 00:03:20.000000', 'temperatura', 727.0000, 'ºC'),
	(298221, 144, '2015-01-01 00:03:21.000000', 'temperatura', 191.0000, 'ºC'),
	(298222, 144, '2015-01-01 00:03:22.000000', 'temperatura', 1174.0000, 'ºC'),
	(298223, 144, '2015-01-01 00:03:23.000000', 'temperatura', 496.0000, 'ºC'),
	(298224, 144, '2015-01-01 00:03:24.000000', 'temperatura', 161.0000, 'ºC'),
	(298225, 144, '2015-01-01 00:03:25.000000', 'temperatura', 514.0000, 'ºC'),
	(298226, 144, '2015-01-01 00:03:26.000000', 'temperatura', 891.0000, 'ºC'),
	(298227, 144, '2015-01-01 00:03:27.000000', 'temperatura', 513.0000, 'ºC'),
	(298228, 144, '2015-01-01 00:03:28.000000', 'temperatura', 1090.0000, 'ºC'),
	(298229, 144, '2015-01-01 00:03:29.000000', 'temperatura', 313.0000, 'ºC'),
	(298230, 144, '2015-01-01 00:03:30.000000', 'temperatura', 696.0000, 'ºC'),
	(298231, 144, '2015-01-01 00:03:31.000000', 'temperatura', 140.0000, 'ºC'),
	(298232, 144, '2015-01-01 00:03:32.000000', 'temperatura', 1014.0000, 'ºC'),
	(298233, 144, '2015-01-01 00:03:33.000000', 'temperatura', 1049.0000, 'ºC'),
	(298234, 144, '2015-01-01 00:03:34.000000', 'temperatura', 1006.0000, 'ºC'),
	(298235, 144, '2015-01-01 00:03:35.000000', 'temperatura', 681.0000, 'ºC'),
	(298236, 144, '2015-01-01 00:03:36.000000', 'temperatura', 388.0000, 'ºC'),
	(298237, 144, '2015-01-01 00:03:37.000000', 'temperatura', 1099.0000, 'ºC'),
	(298238, 144, '2015-01-01 00:03:38.000000', 'temperatura', 732.0000, 'ºC'),
	(298239, 144, '2015-01-01 00:03:39.000000', 'temperatura', 364.0000, 'ºC'),
	(298240, 144, '2015-01-01 00:03:40.000000', 'temperatura', 825.0000, 'ºC'),
	(298241, 144, '2015-01-01 00:03:41.000000', 'temperatura', 635.0000, 'ºC'),
	(298242, 144, '2015-01-01 00:03:42.000000', 'temperatura', 697.0000, 'ºC'),
	(298243, 144, '2015-01-01 00:03:43.000000', 'temperatura', 381.0000, 'ºC'),
	(298244, 144, '2015-01-01 00:03:44.000000', 'temperatura', 1017.0000, 'ºC'),
	(298245, 144, '2015-01-01 00:03:45.000000', 'temperatura', 339.0000, 'ºC'),
	(298246, 144, '2015-01-01 00:03:46.000000', 'temperatura', 1047.0000, 'ºC'),
	(298247, 144, '2015-01-01 00:03:47.000000', 'temperatura', 616.0000, 'ºC'),
	(298248, 144, '2015-01-01 00:03:48.000000', 'temperatura', 1143.0000, 'ºC'),
	(298249, 144, '2015-01-01 00:03:49.000000', 'temperatura', 265.0000, 'ºC'),
	(298250, 144, '2015-01-01 00:03:50.000000', 'temperatura', 298.0000, 'ºC'),
	(298251, 144, '2015-01-01 00:03:51.000000', 'temperatura', 693.0000, 'ºC'),
	(298252, 144, '2015-01-01 00:03:52.000000', 'temperatura', 173.0000, 'ºC'),
	(298253, 144, '2015-01-01 00:03:53.000000', 'temperatura', 1188.0000, 'ºC'),
	(298254, 144, '2015-01-01 00:03:54.000000', 'temperatura', 622.0000, 'ºC'),
	(298255, 144, '2015-01-01 00:03:55.000000', 'temperatura', 744.0000, 'ºC'),
	(298256, 144, '2015-01-01 00:03:56.000000', 'temperatura', 655.0000, 'ºC'),
	(298257, 144, '2015-01-01 00:03:57.000000', 'temperatura', 1043.0000, 'ºC'),
	(298258, 144, '2015-01-01 00:03:58.000000', 'temperatura', 852.0000, 'ºC'),
	(298259, 144, '2015-01-01 00:03:59.000000', 'temperatura', 1129.0000, 'ºC'),
	(298260, 144, '2015-01-01 00:04:00.000000', 'temperatura', 692.0000, 'ºC'),
	(298261, 144, '2015-01-01 00:04:01.000000', 'temperatura', 74.0000, 'ºC'),
	(298262, 144, '2015-01-01 00:04:02.000000', 'temperatura', 694.0000, 'ºC'),
	(298263, 144, '2015-01-01 00:04:03.000000', 'temperatura', 848.0000, 'ºC'),
	(298264, 144, '2015-01-01 00:04:04.000000', 'temperatura', 958.0000, 'ºC'),
	(298265, 144, '2015-01-01 00:04:05.000000', 'temperatura', 1049.0000, 'ºC'),
	(298266, 144, '2015-01-01 00:04:06.000000', 'temperatura', 1170.0000, 'ºC'),
	(298267, 144, '2015-01-01 00:04:07.000000', 'temperatura', 303.0000, 'ºC'),
	(298268, 144, '2015-01-01 00:04:08.000000', 'temperatura', 406.0000, 'ºC'),
	(298269, 144, '2015-01-01 00:04:09.000000', 'temperatura', 1121.0000, 'ºC'),
	(298270, 144, '2015-01-01 00:04:10.000000', 'temperatura', 787.0000, 'ºC'),
	(298271, 144, '2015-01-01 00:04:11.000000', 'temperatura', 574.0000, 'ºC'),
	(298272, 144, '2015-01-01 00:04:12.000000', 'temperatura', 510.0000, 'ºC'),
	(298273, 144, '2015-01-01 00:04:13.000000', 'temperatura', 828.0000, 'ºC'),
	(298274, 144, '2015-01-01 00:04:14.000000', 'temperatura', 209.0000, 'ºC'),
	(298275, 144, '2015-01-01 00:04:15.000000', 'temperatura', 962.0000, 'ºC'),
	(298276, 144, '2015-01-01 00:04:16.000000', 'temperatura', 583.0000, 'ºC'),
	(298277, 144, '2015-01-01 00:04:17.000000', 'temperatura', 28.0000, 'ºC'),
	(298278, 144, '2015-01-01 00:04:18.000000', 'temperatura', 793.0000, 'ºC'),
	(298279, 144, '2015-01-01 00:04:19.000000', 'temperatura', 284.0000, 'ºC'),
	(298280, 144, '2015-01-01 00:04:20.000000', 'temperatura', 238.0000, 'ºC'),
	(298281, 144, '2015-01-01 00:04:21.000000', 'temperatura', 339.0000, 'ºC'),
	(298282, 144, '2015-01-01 00:04:22.000000', 'temperatura', 980.0000, 'ºC'),
	(298283, 144, '2015-01-01 00:04:23.000000', 'temperatura', 287.0000, 'ºC'),
	(298284, 144, '2015-01-01 00:04:24.000000', 'temperatura', 893.0000, 'ºC'),
	(298285, 144, '2015-01-01 00:04:25.000000', 'temperatura', 7.0000, 'ºC'),
	(298286, 144, '2015-01-01 00:04:26.000000', 'temperatura', 956.0000, 'ºC'),
	(298287, 144, '2015-01-01 00:04:27.000000', 'temperatura', 1160.0000, 'ºC'),
	(298288, 144, '2015-01-01 00:04:28.000000', 'temperatura', 531.0000, 'ºC'),
	(298289, 144, '2015-01-01 00:04:29.000000', 'temperatura', 374.0000, 'ºC'),
	(298290, 144, '2015-01-01 00:04:30.000000', 'temperatura', 279.0000, 'ºC'),
	(298291, 144, '2015-01-01 00:04:31.000000', 'temperatura', 275.0000, 'ºC'),
	(298292, 144, '2015-01-01 00:04:32.000000', 'temperatura', 538.0000, 'ºC'),
	(298293, 144, '2015-01-01 00:04:33.000000', 'temperatura', 667.0000, 'ºC'),
	(298294, 144, '2015-01-01 00:04:34.000000', 'temperatura', 519.0000, 'ºC'),
	(298295, 144, '2015-01-01 00:04:35.000000', 'temperatura', 596.0000, 'ºC'),
	(298296, 144, '2015-01-01 00:04:36.000000', 'temperatura', 222.0000, 'ºC'),
	(298297, 144, '2015-01-01 00:04:37.000000', 'temperatura', 525.0000, 'ºC'),
	(298298, 144, '2015-01-01 00:04:38.000000', 'temperatura', 759.0000, 'ºC'),
	(298299, 144, '2015-01-01 00:04:39.000000', 'temperatura', 1022.0000, 'ºC'),
	(298300, 144, '2015-01-01 00:04:40.000000', 'temperatura', 432.0000, 'ºC'),
	(298301, 144, '2015-01-01 00:04:41.000000', 'temperatura', 294.0000, 'ºC'),
	(298302, 144, '2015-01-01 00:04:42.000000', 'temperatura', 174.0000, 'ºC'),
	(298303, 144, '2015-01-01 00:04:43.000000', 'temperatura', 1191.0000, 'ºC'),
	(298304, 144, '2015-01-01 00:04:44.000000', 'temperatura', 631.0000, 'ºC'),
	(298305, 144, '2015-01-01 00:04:45.000000', 'temperatura', 784.0000, 'ºC'),
	(298306, 144, '2015-01-01 00:04:46.000000', 'temperatura', 826.0000, 'ºC'),
	(298307, 144, '2015-01-01 00:04:47.000000', 'temperatura', 581.0000, 'ºC'),
	(298308, 144, '2015-01-01 00:04:48.000000', 'temperatura', 427.0000, 'ºC'),
	(298309, 144, '2015-01-01 00:04:49.000000', 'temperatura', 393.0000, 'ºC'),
	(298310, 144, '2015-01-01 00:04:50.000000', 'temperatura', 682.0000, 'ºC'),
	(298311, 144, '2015-01-01 00:04:51.000000', 'temperatura', 1033.0000, 'ºC'),
	(298312, 144, '2015-01-01 00:04:52.000000', 'temperatura', 720.0000, 'ºC'),
	(298313, 144, '2015-01-01 00:04:53.000000', 'temperatura', 499.0000, 'ºC'),
	(298314, 144, '2015-01-01 00:04:54.000000', 'temperatura', 338.0000, 'ºC'),
	(298315, 144, '2015-01-01 00:04:55.000000', 'temperatura', 192.0000, 'ºC'),
	(298316, 144, '2015-01-01 00:04:56.000000', 'temperatura', 1148.0000, 'ºC'),
	(298317, 144, '2015-01-01 00:04:57.000000', 'temperatura', 362.0000, 'ºC'),
	(298318, 144, '2015-01-01 00:04:58.000000', 'temperatura', 767.0000, 'ºC'),
	(298319, 144, '2015-01-01 00:04:59.000000', 'temperatura', 350.0000, 'ºC'),
	(298320, 144, '2015-01-01 00:05:00.000000', 'temperatura', 650.0000, 'ºC'),
	(298321, 144, '2015-01-01 00:05:01.000000', 'temperatura', 1002.0000, 'ºC'),
	(298322, 144, '2015-01-01 00:05:02.000000', 'temperatura', 660.0000, 'ºC'),
	(298323, 144, '2015-01-01 00:05:03.000000', 'temperatura', 295.0000, 'ºC'),
	(298324, 144, '2015-01-01 00:05:04.000000', 'temperatura', 696.0000, 'ºC'),
	(298325, 144, '2015-01-01 00:05:05.000000', 'temperatura', 193.0000, 'ºC'),
	(298326, 144, '2015-01-01 00:05:06.000000', 'temperatura', 77.0000, 'ºC'),
	(298327, 144, '2015-01-01 00:05:07.000000', 'temperatura', 1007.0000, 'ºC'),
	(298328, 144, '2015-01-01 00:05:08.000000', 'temperatura', 7.0000, 'ºC'),
	(298329, 144, '2015-01-01 00:05:09.000000', 'temperatura', 612.0000, 'ºC'),
	(298330, 144, '2015-01-01 00:05:10.000000', 'temperatura', 639.0000, 'ºC'),
	(298331, 144, '2015-01-01 00:05:11.000000', 'temperatura', 162.0000, 'ºC'),
	(298332, 144, '2015-01-01 00:05:12.000000', 'temperatura', 93.0000, 'ºC'),
	(298333, 144, '2015-01-01 00:05:13.000000', 'temperatura', 1179.0000, 'ºC'),
	(298334, 144, '2015-01-01 00:05:14.000000', 'temperatura', 816.0000, 'ºC'),
	(298335, 144, '2015-01-01 00:05:15.000000', 'temperatura', 543.0000, 'ºC'),
	(298336, 144, '2015-01-01 00:05:16.000000', 'temperatura', 269.0000, 'ºC'),
	(298337, 144, '2015-01-01 00:05:17.000000', 'temperatura', 915.0000, 'ºC'),
	(298338, 144, '2015-01-01 00:05:18.000000', 'temperatura', 168.0000, 'ºC'),
	(298339, 144, '2015-01-01 00:05:19.000000', 'temperatura', 497.0000, 'ºC'),
	(298340, 144, '2015-01-01 00:05:20.000000', 'temperatura', 780.0000, 'ºC'),
	(298341, 144, '2015-01-01 00:05:21.000000', 'temperatura', 11.0000, 'ºC'),
	(298342, 144, '2015-01-01 00:05:22.000000', 'temperatura', 115.0000, 'ºC'),
	(298343, 144, '2015-01-01 00:05:23.000000', 'temperatura', 544.0000, 'ºC'),
	(298344, 144, '2015-01-01 00:05:24.000000', 'temperatura', 1175.0000, 'ºC'),
	(298345, 144, '2015-01-01 00:05:25.000000', 'temperatura', 641.0000, 'ºC'),
	(298346, 144, '2015-01-01 00:05:26.000000', 'temperatura', 882.0000, 'ºC'),
	(298347, 144, '2015-01-01 00:05:27.000000', 'temperatura', 88.0000, 'ºC'),
	(298348, 144, '2015-01-01 00:05:28.000000', 'temperatura', 196.0000, 'ºC'),
	(298349, 144, '2015-01-01 00:05:29.000000', 'temperatura', 714.0000, 'ºC'),
	(298350, 144, '2015-01-01 00:05:30.000000', 'temperatura', 583.0000, 'ºC'),
	(298351, 144, '2015-01-01 00:05:31.000000', 'temperatura', 774.0000, 'ºC'),
	(298352, 144, '2015-01-01 00:05:32.000000', 'temperatura', 923.0000, 'ºC'),
	(298353, 144, '2015-01-01 00:05:33.000000', 'temperatura', 1091.0000, 'ºC'),
	(298354, 144, '2015-01-01 00:05:34.000000', 'temperatura', 287.0000, 'ºC'),
	(298355, 144, '2015-01-01 00:05:35.000000', 'temperatura', 561.0000, 'ºC'),
	(298356, 144, '2015-01-01 00:05:36.000000', 'temperatura', 747.0000, 'ºC'),
	(298357, 144, '2015-01-01 00:05:37.000000', 'temperatura', 851.0000, 'ºC'),
	(298358, 144, '2015-01-01 00:05:38.000000', 'temperatura', 814.0000, 'ºC'),
	(298359, 144, '2015-01-01 00:05:39.000000', 'temperatura', 319.0000, 'ºC'),
	(298360, 144, '2015-01-01 00:05:40.000000', 'temperatura', 352.0000, 'ºC'),
	(298361, 144, '2015-01-01 00:05:41.000000', 'temperatura', 803.0000, 'ºC'),
	(298362, 144, '2015-01-01 00:05:42.000000', 'temperatura', 558.0000, 'ºC'),
	(298363, 144, '2015-01-01 00:05:43.000000', 'temperatura', 384.0000, 'ºC'),
	(298364, 144, '2015-01-01 00:05:44.000000', 'temperatura', 248.0000, 'ºC'),
	(298365, 144, '2015-01-01 00:05:45.000000', 'temperatura', 87.0000, 'ºC'),
	(298366, 144, '2015-01-01 00:05:46.000000', 'temperatura', 891.0000, 'ºC'),
	(298367, 144, '2015-01-01 00:05:47.000000', 'temperatura', 593.0000, 'ºC'),
	(298368, 144, '2015-01-01 00:05:48.000000', 'temperatura', 293.0000, 'ºC'),
	(298369, 144, '2015-01-01 00:05:49.000000', 'temperatura', 886.0000, 'ºC'),
	(298370, 144, '2015-01-01 00:05:50.000000', 'temperatura', 1150.0000, 'ºC'),
	(298371, 144, '2015-01-01 00:05:51.000000', 'temperatura', 696.0000, 'ºC'),
	(298372, 144, '2015-01-01 00:05:52.000000', 'temperatura', 28.0000, 'ºC'),
	(298373, 144, '2015-01-01 00:05:53.000000', 'temperatura', 452.0000, 'ºC'),
	(298374, 144, '2015-01-01 00:05:54.000000', 'temperatura', 978.0000, 'ºC'),
	(298375, 144, '2015-01-01 00:05:55.000000', 'temperatura', 1134.0000, 'ºC'),
	(298376, 144, '2015-01-01 00:05:56.000000', 'temperatura', 339.0000, 'ºC'),
	(298377, 144, '2015-01-01 00:05:57.000000', 'temperatura', 691.0000, 'ºC'),
	(298378, 144, '2015-01-01 00:05:58.000000', 'temperatura', 37.0000, 'ºC'),
	(298379, 144, '2015-01-01 00:05:59.000000', 'temperatura', 514.0000, 'ºC'),
	(298380, 144, '2015-01-01 00:06:00.000000', 'temperatura', 58.0000, 'ºC'),
	(298381, 144, '2015-01-01 00:06:01.000000', 'temperatura', 1149.0000, 'ºC'),
	(298382, 144, '2015-01-01 00:06:02.000000', 'temperatura', 773.0000, 'ºC'),
	(298383, 144, '2015-01-01 00:06:03.000000', 'temperatura', 419.0000, 'ºC'),
	(298384, 144, '2015-01-01 00:06:04.000000', 'temperatura', 977.0000, 'ºC'),
	(298385, 144, '2015-01-01 00:06:05.000000', 'temperatura', 28.0000, 'ºC'),
	(298386, 144, '2015-01-01 00:06:06.000000', 'temperatura', 807.0000, 'ºC'),
	(298387, 144, '2015-01-01 00:06:07.000000', 'temperatura', 355.0000, 'ºC'),
	(298388, 144, '2015-01-01 00:06:08.000000', 'temperatura', 552.0000, 'ºC'),
	(298389, 144, '2015-01-01 00:06:09.000000', 'temperatura', 495.0000, 'ºC'),
	(298390, 144, '2015-01-01 00:06:10.000000', 'temperatura', 818.0000, 'ºC'),
	(298391, 144, '2015-01-01 00:06:11.000000', 'temperatura', 209.0000, 'ºC'),
	(298392, 144, '2015-01-01 00:06:12.000000', 'temperatura', 991.0000, 'ºC'),
	(298393, 144, '2015-01-01 00:06:13.000000', 'temperatura', 729.0000, 'ºC'),
	(298394, 144, '2015-01-01 00:06:14.000000', 'temperatura', 672.0000, 'ºC'),
	(298395, 144, '2015-01-01 00:06:15.000000', 'temperatura', 1173.0000, 'ºC'),
	(298396, 144, '2015-01-01 00:06:16.000000', 'temperatura', 251.0000, 'ºC'),
	(298397, 144, '2015-01-01 00:06:17.000000', 'temperatura', 134.0000, 'ºC'),
	(298398, 144, '2015-01-01 00:06:18.000000', 'temperatura', 1118.0000, 'ºC'),
	(298399, 144, '2015-01-01 00:06:19.000000', 'temperatura', 388.0000, 'ºC'),
	(298400, 144, '2015-01-01 00:06:20.000000', 'temperatura', 987.0000, 'ºC'),
	(298401, 144, '2015-01-01 00:06:21.000000', 'temperatura', 171.0000, 'ºC'),
	(298402, 144, '2015-01-01 00:06:22.000000', 'temperatura', 293.0000, 'ºC'),
	(298403, 144, '2015-01-01 00:06:23.000000', 'temperatura', 955.0000, 'ºC'),
	(298404, 144, '2015-01-01 00:06:24.000000', 'temperatura', 296.0000, 'ºC'),
	(298405, 144, '2015-01-01 00:06:25.000000', 'temperatura', 1017.0000, 'ºC'),
	(298406, 144, '2015-01-01 00:06:26.000000', 'temperatura', 596.0000, 'ºC'),
	(298407, 144, '2015-01-01 00:06:27.000000', 'temperatura', 1131.0000, 'ºC'),
	(298408, 144, '2015-01-01 00:06:28.000000', 'temperatura', 268.0000, 'ºC'),
	(298409, 144, '2015-01-01 00:06:29.000000', 'temperatura', 345.0000, 'ºC'),
	(298410, 144, '2015-01-01 00:06:30.000000', 'temperatura', 922.0000, 'ºC'),
	(298411, 144, '2015-01-01 00:06:31.000000', 'temperatura', 1174.0000, 'ºC'),
	(298412, 144, '2015-01-01 00:06:32.000000', 'temperatura', 706.0000, 'ºC'),
	(298413, 144, '2015-01-01 00:06:33.000000', 'temperatura', 9.0000, 'ºC'),
	(298414, 144, '2015-01-01 00:06:34.000000', 'temperatura', 328.0000, 'ºC'),
	(298415, 144, '2015-01-01 00:06:35.000000', 'temperatura', 414.0000, 'ºC'),
	(298416, 144, '2015-01-01 00:06:36.000000', 'temperatura', 1085.0000, 'ºC'),
	(298417, 144, '2015-01-01 00:06:37.000000', 'temperatura', 586.0000, 'ºC'),
	(298418, 144, '2015-01-01 00:06:38.000000', 'temperatura', 874.0000, 'ºC'),
	(298419, 144, '2015-01-01 00:06:39.000000', 'temperatura', 214.0000, 'ºC'),
	(298420, 144, '2015-01-01 00:06:40.000000', 'temperatura', 848.0000, 'ºC'),
	(298421, 144, '2015-01-01 00:06:41.000000', 'temperatura', 0.0000, 'ºC'),
	(298422, 144, '2015-01-01 00:06:42.000000', 'temperatura', 1054.0000, 'ºC'),
	(298423, 144, '2015-01-01 00:06:43.000000', 'temperatura', 472.0000, 'ºC'),
	(298424, 144, '2015-01-01 00:06:44.000000', 'temperatura', 400.0000, 'ºC'),
	(298425, 144, '2015-01-01 00:06:45.000000', 'temperatura', 583.0000, 'ºC'),
	(298426, 144, '2015-01-01 00:06:46.000000', 'temperatura', 515.0000, 'ºC'),
	(298427, 144, '2015-01-01 00:06:47.000000', 'temperatura', 826.0000, 'ºC'),
	(298428, 144, '2015-01-01 00:06:48.000000', 'temperatura', 186.0000, 'ºC'),
	(298429, 144, '2015-01-01 00:06:49.000000', 'temperatura', 853.0000, 'ºC'),
	(298430, 144, '2015-01-01 00:06:50.000000', 'temperatura', 107.0000, 'ºC'),
	(298431, 144, '2015-01-01 00:06:51.000000', 'temperatura', 379.0000, 'ºC'),
	(298432, 144, '2015-01-01 00:06:52.000000', 'temperatura', 371.0000, 'ºC'),
	(298433, 144, '2015-01-01 00:06:53.000000', 'temperatura', 720.0000, 'ºC'),
	(298434, 144, '2015-01-01 00:06:54.000000', 'temperatura', 86.0000, 'ºC'),
	(298435, 144, '2015-01-01 00:06:55.000000', 'temperatura', 671.0000, 'ºC'),
	(298436, 144, '2015-01-01 00:06:56.000000', 'temperatura', 698.0000, 'ºC'),
	(298437, 144, '2015-01-01 00:06:57.000000', 'temperatura', 276.0000, 'ºC'),
	(298438, 144, '2015-01-01 00:06:58.000000', 'temperatura', 488.0000, 'ºC'),
	(298439, 144, '2015-01-01 00:06:59.000000', 'temperatura', 412.0000, 'ºC'),
	(298440, 144, '2015-01-01 00:07:00.000000', 'temperatura', 597.0000, 'ºC'),
	(298441, 144, '2015-01-01 00:07:01.000000', 'temperatura', 551.0000, 'ºC'),
	(298442, 144, '2015-01-01 00:07:02.000000', 'temperatura', 963.0000, 'ºC'),
	(298443, 144, '2015-01-01 00:07:03.000000', 'temperatura', 762.0000, 'ºC'),
	(298444, 144, '2015-01-01 00:07:04.000000', 'temperatura', 920.0000, 'ºC'),
	(298445, 144, '2015-01-01 00:07:05.000000', 'temperatura', 1116.0000, 'ºC'),
	(298446, 144, '2015-01-01 00:07:06.000000', 'temperatura', 421.0000, 'ºC'),
	(298447, 144, '2015-01-01 00:07:07.000000', 'temperatura', 1158.0000, 'ºC'),
	(298448, 144, '2015-01-01 00:07:08.000000', 'temperatura', 927.0000, 'ºC'),
	(298449, 144, '2015-01-01 00:07:09.000000', 'temperatura', 1160.0000, 'ºC'),
	(298450, 144, '2015-01-01 00:07:10.000000', 'temperatura', 622.0000, 'ºC'),
	(298451, 144, '2015-01-01 00:07:11.000000', 'temperatura', 831.0000, 'ºC'),
	(298452, 144, '2015-01-01 00:07:12.000000', 'temperatura', 1088.0000, 'ºC'),
	(298453, 144, '2015-01-01 00:07:13.000000', 'temperatura', 548.0000, 'ºC'),
	(298454, 144, '2015-01-01 00:07:14.000000', 'temperatura', 676.0000, 'ºC'),
	(298455, 144, '2015-01-01 00:07:15.000000', 'temperatura', 539.0000, 'ºC'),
	(298456, 144, '2015-01-01 00:07:16.000000', 'temperatura', 665.0000, 'ºC'),
	(298457, 144, '2015-01-01 00:07:17.000000', 'temperatura', 508.0000, 'ºC'),
	(298458, 144, '2015-01-01 00:07:18.000000', 'temperatura', 547.0000, 'ºC'),
	(298459, 144, '2015-01-01 00:07:19.000000', 'temperatura', 12.0000, 'ºC'),
	(298460, 144, '2015-01-01 00:07:20.000000', 'temperatura', 819.0000, 'ºC'),
	(298461, 144, '2015-01-01 00:07:21.000000', 'temperatura', 457.0000, 'ºC'),
	(298462, 144, '2015-01-01 00:07:22.000000', 'temperatura', 1032.0000, 'ºC'),
	(298463, 144, '2015-01-01 00:07:23.000000', 'temperatura', 186.0000, 'ºC'),
	(298464, 144, '2015-01-01 00:07:24.000000', 'temperatura', 238.0000, 'ºC'),
	(298465, 144, '2015-01-01 00:07:25.000000', 'temperatura', 631.0000, 'ºC'),
	(298466, 144, '2015-01-01 00:07:26.000000', 'temperatura', 40.0000, 'ºC'),
	(298467, 144, '2015-01-01 00:07:27.000000', 'temperatura', 709.0000, 'ºC'),
	(298468, 144, '2015-01-01 00:07:28.000000', 'temperatura', 1026.0000, 'ºC'),
	(298469, 144, '2015-01-01 00:07:29.000000', 'temperatura', 604.0000, 'ºC'),
	(298470, 144, '2015-01-01 00:07:30.000000', 'temperatura', 1141.0000, 'ºC'),
	(298471, 144, '2015-01-01 00:07:31.000000', 'temperatura', 296.0000, 'ºC'),
	(298472, 144, '2015-01-01 00:07:32.000000', 'temperatura', 455.0000, 'ºC'),
	(298473, 144, '2015-01-01 00:07:33.000000', 'temperatura', 188.0000, 'ºC'),
	(298474, 144, '2015-01-01 00:07:34.000000', 'temperatura', 776.0000, 'ºC'),
	(298475, 144, '2015-01-01 00:07:35.000000', 'temperatura', 916.0000, 'ºC'),
	(298476, 144, '2015-01-01 00:07:36.000000', 'temperatura', 1052.0000, 'ºC'),
	(298477, 144, '2015-01-01 00:07:37.000000', 'temperatura', 111.0000, 'ºC'),
	(298478, 144, '2015-01-01 00:07:38.000000', 'temperatura', 1001.0000, 'ºC'),
	(298479, 144, '2015-01-01 00:07:39.000000', 'temperatura', 1073.0000, 'ºC'),
	(298480, 144, '2015-01-01 00:07:40.000000', 'temperatura', 1164.0000, 'ºC'),
	(298481, 144, '2015-01-01 00:07:41.000000', 'temperatura', 199.0000, 'ºC'),
	(298482, 144, '2015-01-01 00:07:42.000000', 'temperatura', 1106.0000, 'ºC'),
	(298483, 144, '2015-01-01 00:07:43.000000', 'temperatura', 132.0000, 'ºC'),
	(298484, 144, '2015-01-01 00:07:44.000000', 'temperatura', 945.0000, 'ºC'),
	(298485, 144, '2015-01-01 00:07:45.000000', 'temperatura', 726.0000, 'ºC'),
	(298486, 144, '2015-01-01 00:07:46.000000', 'temperatura', 798.0000, 'ºC'),
	(298487, 144, '2015-01-01 00:07:47.000000', 'temperatura', 613.0000, 'ºC'),
	(298488, 144, '2015-01-01 00:07:48.000000', 'temperatura', 672.0000, 'ºC'),
	(298489, 144, '2015-01-01 00:07:49.000000', 'temperatura', 319.0000, 'ºC'),
	(298490, 144, '2015-01-01 00:07:50.000000', 'temperatura', 779.0000, 'ºC'),
	(298491, 144, '2015-01-01 00:07:51.000000', 'temperatura', 538.0000, 'ºC'),
	(298492, 144, '2015-01-01 00:07:52.000000', 'temperatura', 354.0000, 'ºC'),
	(298493, 144, '2015-01-01 00:07:53.000000', 'temperatura', 157.0000, 'ºC'),
	(298494, 144, '2015-01-01 00:07:54.000000', 'temperatura', 922.0000, 'ºC'),
	(298495, 144, '2015-01-01 00:07:55.000000', 'temperatura', 540.0000, 'ºC'),
	(298496, 144, '2015-01-01 00:07:56.000000', 'temperatura', 1134.0000, 'ºC'),
	(298497, 144, '2015-01-01 00:07:57.000000', 'temperatura', 452.0000, 'ºC'),
	(298498, 144, '2015-01-01 00:07:58.000000', 'temperatura', 57.0000, 'ºC'),
	(298499, 144, '2015-01-01 00:07:59.000000', 'temperatura', 129.0000, 'ºC'),
	(298500, 144, '2015-01-01 00:08:00.000000', 'temperatura', 476.0000, 'ºC'),
	(298501, 144, '2015-01-01 00:08:01.000000', 'temperatura', 794.0000, 'ºC'),
	(298502, 144, '2015-01-01 00:08:02.000000', 'temperatura', 141.0000, 'ºC'),
	(298503, 144, '2015-01-01 00:08:03.000000', 'temperatura', 723.0000, 'ºC'),
	(298504, 144, '2015-01-01 00:08:04.000000', 'temperatura', 793.0000, 'ºC'),
	(298505, 144, '2015-01-01 00:08:05.000000', 'temperatura', 597.0000, 'ºC'),
	(298506, 144, '2015-01-01 00:08:06.000000', 'temperatura', 605.0000, 'ºC'),
	(298507, 144, '2015-01-01 00:08:07.000000', 'temperatura', 34.0000, 'ºC'),
	(298508, 144, '2015-01-01 00:08:08.000000', 'temperatura', 755.0000, 'ºC'),
	(298509, 144, '2015-01-01 00:08:09.000000', 'temperatura', 74.0000, 'ºC'),
	(298510, 144, '2015-01-01 00:08:10.000000', 'temperatura', 504.0000, 'ºC'),
	(298511, 144, '2015-01-01 00:08:11.000000', 'temperatura', 1100.0000, 'ºC'),
	(298512, 144, '2015-01-01 00:08:12.000000', 'temperatura', 391.0000, 'ºC'),
	(298513, 144, '2015-01-01 00:08:13.000000', 'temperatura', 1052.0000, 'ºC'),
	(298514, 144, '2015-01-01 00:08:14.000000', 'temperatura', 487.0000, 'ºC'),
	(298515, 144, '2015-01-01 00:08:15.000000', 'temperatura', 479.0000, 'ºC'),
	(298516, 144, '2015-01-01 00:08:16.000000', 'temperatura', 937.0000, 'ºC'),
	(298517, 144, '2015-01-01 00:08:17.000000', 'temperatura', 846.0000, 'ºC'),
	(298518, 144, '2015-01-01 00:08:18.000000', 'temperatura', 220.0000, 'ºC'),
	(298519, 144, '2015-01-01 00:08:19.000000', 'temperatura', 964.0000, 'ºC'),
	(298520, 144, '2015-01-01 00:08:20.000000', 'temperatura', 559.0000, 'ºC'),
	(298521, 144, '2015-01-01 00:08:21.000000', 'temperatura', 1105.0000, 'ºC'),
	(298522, 144, '2015-01-01 00:08:22.000000', 'temperatura', 246.0000, 'ºC'),
	(298523, 144, '2015-01-01 00:08:23.000000', 'temperatura', 318.0000, 'ºC'),
	(298524, 144, '2015-01-01 00:08:24.000000', 'temperatura', 850.0000, 'ºC'),
	(298525, 144, '2015-01-01 00:08:25.000000', 'temperatura', 896.0000, 'ºC'),
	(298526, 144, '2015-01-01 00:08:26.000000', 'temperatura', 733.0000, 'ºC'),
	(298527, 144, '2015-01-01 00:08:27.000000', 'temperatura', 977.0000, 'ºC'),
	(298528, 144, '2015-01-01 00:08:28.000000', 'temperatura', 287.0000, 'ºC'),
	(298529, 144, '2015-01-01 00:08:29.000000', 'temperatura', 904.0000, 'ºC'),
	(298530, 144, '2015-01-01 00:08:30.000000', 'temperatura', 60.0000, 'ºC'),
	(298531, 144, '2015-01-01 00:08:31.000000', 'temperatura', 1186.0000, 'ºC'),
	(298532, 144, '2015-01-01 00:08:32.000000', 'temperatura', 954.0000, 'ºC'),
	(298533, 144, '2015-01-01 00:08:33.000000', 'temperatura', 11.0000, 'ºC'),
	(298534, 144, '2015-01-01 00:08:34.000000', 'temperatura', 792.0000, 'ºC'),
	(298535, 144, '2015-01-01 00:08:35.000000', 'temperatura', 328.0000, 'ºC'),
	(298536, 144, '2015-01-01 00:08:36.000000', 'temperatura', 464.0000, 'ºC'),
	(298537, 144, '2015-01-01 00:08:37.000000', 'temperatura', 136.0000, 'ºC'),
	(298538, 144, '2015-01-01 00:08:38.000000', 'temperatura', 488.0000, 'ºC'),
	(298539, 144, '2015-01-01 00:08:39.000000', 'temperatura', 832.0000, 'ºC'),
	(298540, 144, '2015-01-01 00:08:40.000000', 'temperatura', 297.0000, 'ºC'),
	(298541, 144, '2015-01-01 00:08:41.000000', 'temperatura', 190.0000, 'ºC'),
	(298542, 144, '2015-01-01 00:08:42.000000', 'temperatura', 61.0000, 'ºC'),
	(298543, 144, '2015-01-01 00:08:43.000000', 'temperatura', 933.0000, 'ºC'),
	(298544, 144, '2015-01-01 00:08:44.000000', 'temperatura', 884.0000, 'ºC'),
	(298545, 144, '2015-01-01 00:08:45.000000', 'temperatura', 421.0000, 'ºC'),
	(298546, 144, '2015-01-01 00:08:46.000000', 'temperatura', 652.0000, 'ºC'),
	(298547, 144, '2015-01-01 00:08:47.000000', 'temperatura', 801.0000, 'ºC'),
	(298548, 144, '2015-01-01 00:08:48.000000', 'temperatura', 846.0000, 'ºC'),
	(298549, 144, '2015-01-01 00:08:49.000000', 'temperatura', 629.0000, 'ºC'),
	(298550, 144, '2015-01-01 00:08:50.000000', 'temperatura', 609.0000, 'ºC'),
	(298551, 144, '2015-01-01 00:08:51.000000', 'temperatura', 1158.0000, 'ºC'),
	(298552, 144, '2015-01-01 00:08:52.000000', 'temperatura', 362.0000, 'ºC'),
	(298553, 144, '2015-01-01 00:08:53.000000', 'temperatura', 736.0000, 'ºC'),
	(298554, 144, '2015-01-01 00:08:54.000000', 'temperatura', 196.0000, 'ºC'),
	(298555, 144, '2015-01-01 00:08:55.000000', 'temperatura', 1172.0000, 'ºC'),
	(298556, 144, '2015-01-01 00:08:56.000000', 'temperatura', 471.0000, 'ºC'),
	(298557, 144, '2015-01-01 00:08:57.000000', 'temperatura', 41.0000, 'ºC'),
	(298558, 144, '2015-01-01 00:08:58.000000', 'temperatura', 1193.0000, 'ºC'),
	(298559, 144, '2015-01-01 00:08:59.000000', 'temperatura', 1044.0000, 'ºC'),
	(298560, 144, '2015-01-01 00:09:00.000000', 'temperatura', 439.0000, 'ºC'),
	(298561, 144, '2015-01-01 00:09:01.000000', 'temperatura', 264.0000, 'ºC'),
	(298562, 144, '2015-01-01 00:09:02.000000', 'temperatura', 4.0000, 'ºC'),
	(298563, 144, '2015-01-01 00:09:03.000000', 'temperatura', 430.0000, 'ºC'),
	(298564, 144, '2015-01-01 00:09:04.000000', 'temperatura', 937.0000, 'ºC'),
	(298565, 144, '2015-01-01 00:09:05.000000', 'temperatura', 995.0000, 'ºC'),
	(298566, 144, '2015-01-01 00:09:06.000000', 'temperatura', 967.0000, 'ºC'),
	(298567, 144, '2015-01-01 00:09:07.000000', 'temperatura', 647.0000, 'ºC'),
	(298568, 144, '2015-01-01 00:09:08.000000', 'temperatura', 338.0000, 'ºC'),
	(298569, 144, '2015-01-01 00:09:09.000000', 'temperatura', 947.0000, 'ºC'),
	(298570, 144, '2015-01-01 00:09:10.000000', 'temperatura', 122.0000, 'ºC'),
	(298571, 144, '2015-01-01 00:09:11.000000', 'temperatura', 169.0000, 'ºC'),
	(298572, 144, '2015-01-01 00:09:12.000000', 'temperatura', 482.0000, 'ºC'),
	(298573, 144, '2015-01-01 00:09:13.000000', 'temperatura', 701.0000, 'ºC'),
	(298574, 144, '2015-01-01 00:09:14.000000', 'temperatura', 859.0000, 'ºC'),
	(298575, 144, '2015-01-01 00:09:15.000000', 'temperatura', 995.0000, 'ºC'),
	(298576, 144, '2015-01-01 00:09:16.000000', 'temperatura', 1199.0000, 'ºC'),
	(298577, 144, '2015-01-01 00:09:17.000000', 'temperatura', 611.0000, 'ºC'),
	(298578, 144, '2015-01-01 00:09:18.000000', 'temperatura', 657.0000, 'ºC'),
	(298579, 144, '2015-01-01 00:09:19.000000', 'temperatura', 253.0000, 'ºC'),
	(298580, 144, '2015-01-01 00:09:20.000000', 'temperatura', 495.0000, 'ºC'),
	(298581, 144, '2015-01-01 00:09:21.000000', 'temperatura', 518.0000, 'ºC'),
	(298582, 144, '2015-01-01 00:09:22.000000', 'temperatura', 1103.0000, 'ºC'),
	(298583, 144, '2015-01-01 00:09:23.000000', 'temperatura', 361.0000, 'ºC'),
	(298584, 144, '2015-01-01 00:09:24.000000', 'temperatura', 896.0000, 'ºC'),
	(298585, 144, '2015-01-01 00:09:25.000000', 'temperatura', 997.0000, 'ºC'),
	(298586, 144, '2015-01-01 00:09:26.000000', 'temperatura', 1100.0000, 'ºC'),
	(298587, 144, '2015-01-01 00:09:27.000000', 'temperatura', 109.0000, 'ºC'),
	(298588, 144, '2015-01-01 00:09:28.000000', 'temperatura', 847.0000, 'ºC'),
	(298589, 144, '2015-01-01 00:09:29.000000', 'temperatura', 306.0000, 'ºC'),
	(298590, 144, '2015-01-01 00:09:30.000000', 'temperatura', 192.0000, 'ºC'),
	(298591, 144, '2015-01-01 00:09:31.000000', 'temperatura', 40.0000, 'ºC'),
	(298592, 144, '2015-01-01 00:09:32.000000', 'temperatura', 828.0000, 'ºC'),
	(298593, 144, '2015-01-01 00:09:33.000000', 'temperatura', 417.0000, 'ºC'),
	(298594, 144, '2015-01-01 00:09:34.000000', 'temperatura', 801.0000, 'ºC'),
	(298595, 144, '2015-01-01 00:09:35.000000', 'temperatura', 358.0000, 'ºC'),
	(298596, 144, '2015-01-01 00:09:36.000000', 'temperatura', 584.0000, 'ºC'),
	(298597, 144, '2015-01-01 00:09:37.000000', 'temperatura', 649.0000, 'ºC'),
	(298598, 144, '2015-01-01 00:09:38.000000', 'temperatura', 294.0000, 'ºC'),
	(298599, 144, '2015-01-01 00:09:39.000000', 'temperatura', 724.0000, 'ºC'),
	(298600, 144, '2015-01-01 00:09:40.000000', 'temperatura', 339.0000, 'ºC'),
	(298601, 144, '2015-01-01 00:09:41.000000', 'temperatura', 723.0000, 'ºC'),
	(298602, 144, '2015-01-01 00:09:42.000000', 'temperatura', 198.0000, 'ºC'),
	(298603, 144, '2015-01-01 00:09:43.000000', 'temperatura', 21.0000, 'ºC'),
	(298604, 144, '2015-01-01 00:09:44.000000', 'temperatura', 711.0000, 'ºC'),
	(298605, 144, '2015-01-01 00:09:45.000000', 'temperatura', 1095.0000, 'ºC'),
	(298606, 144, '2015-01-01 00:09:46.000000', 'temperatura', 939.0000, 'ºC'),
	(298607, 144, '2015-01-01 00:09:47.000000', 'temperatura', 213.0000, 'ºC'),
	(298608, 144, '2015-01-01 00:09:48.000000', 'temperatura', 646.0000, 'ºC'),
	(298609, 144, '2015-01-01 00:09:49.000000', 'temperatura', 194.0000, 'ºC'),
	(298610, 144, '2015-01-01 00:09:50.000000', 'temperatura', 233.0000, 'ºC'),
	(298611, 144, '2015-01-01 00:09:51.000000', 'temperatura', 580.0000, 'ºC'),
	(298612, 144, '2015-01-01 00:09:52.000000', 'temperatura', 1005.0000, 'ºC'),
	(298613, 144, '2015-01-01 00:09:53.000000', 'temperatura', 886.0000, 'ºC'),
	(298614, 144, '2015-01-01 00:09:54.000000', 'temperatura', 213.0000, 'ºC'),
	(298615, 144, '2015-01-01 00:09:55.000000', 'temperatura', 808.0000, 'ºC'),
	(298616, 144, '2015-01-01 00:09:56.000000', 'temperatura', 1003.0000, 'ºC'),
	(298617, 144, '2015-01-01 00:09:57.000000', 'temperatura', 189.0000, 'ºC'),
	(298618, 144, '2015-01-01 00:09:58.000000', 'temperatura', 339.0000, 'ºC'),
	(298619, 144, '2015-01-01 00:09:59.000000', 'temperatura', 1128.0000, 'ºC'),
	(298620, 144, '2015-01-01 00:10:00.000000', 'temperatura', 1025.0000, 'ºC'),
	(298621, 144, '2015-01-01 00:10:01.000000', 'temperatura', 542.0000, 'ºC'),
	(298622, 144, '2015-01-01 00:10:02.000000', 'temperatura', 833.0000, 'ºC'),
	(298623, 144, '2015-01-01 00:10:03.000000', 'temperatura', 139.0000, 'ºC'),
	(298624, 144, '2015-01-01 00:10:04.000000', 'temperatura', 598.0000, 'ºC'),
	(298625, 144, '2015-01-01 00:10:05.000000', 'temperatura', 171.0000, 'ºC'),
	(298626, 144, '2015-01-01 00:10:06.000000', 'temperatura', 264.0000, 'ºC'),
	(298627, 144, '2015-01-01 00:10:07.000000', 'temperatura', 808.0000, 'ºC'),
	(298628, 144, '2015-01-01 00:10:08.000000', 'temperatura', 850.0000, 'ºC'),
	(298629, 144, '2015-01-01 00:10:09.000000', 'temperatura', 623.0000, 'ºC'),
	(298630, 144, '2015-01-01 00:10:10.000000', 'temperatura', 567.0000, 'ºC'),
	(298631, 144, '2015-01-01 00:10:11.000000', 'temperatura', 966.0000, 'ºC'),
	(298632, 144, '2015-01-01 00:10:12.000000', 'temperatura', 730.0000, 'ºC'),
	(298633, 144, '2015-01-01 00:10:13.000000', 'temperatura', 751.0000, 'ºC'),
	(298634, 144, '2015-01-01 00:10:14.000000', 'temperatura', 367.0000, 'ºC'),
	(298635, 144, '2015-01-01 00:10:15.000000', 'temperatura', 783.0000, 'ºC'),
	(298636, 144, '2015-01-01 00:10:16.000000', 'temperatura', 415.0000, 'ºC'),
	(298637, 144, '2015-01-01 00:10:17.000000', 'temperatura', 925.0000, 'ºC'),
	(298638, 144, '2015-01-01 00:10:18.000000', 'temperatura', 982.0000, 'ºC'),
	(298639, 144, '2015-01-01 00:10:19.000000', 'temperatura', 936.0000, 'ºC'),
	(298640, 144, '2015-01-01 00:10:20.000000', 'temperatura', 536.0000, 'ºC'),
	(298641, 144, '2015-01-01 00:10:21.000000', 'temperatura', 1069.0000, 'ºC'),
	(298642, 144, '2015-01-01 00:10:22.000000', 'temperatura', 139.0000, 'ºC'),
	(298643, 144, '2015-01-01 00:10:23.000000', 'temperatura', 1088.0000, 'ºC'),
	(298644, 144, '2015-01-01 00:10:24.000000', 'temperatura', 222.0000, 'ºC'),
	(298645, 144, '2015-01-01 00:10:25.000000', 'temperatura', 247.0000, 'ºC'),
	(298646, 144, '2015-01-01 00:10:26.000000', 'temperatura', 571.0000, 'ºC'),
	(298647, 144, '2015-01-01 00:10:27.000000', 'temperatura', 915.0000, 'ºC'),
	(298648, 144, '2015-01-01 00:10:28.000000', 'temperatura', 460.0000, 'ºC'),
	(298649, 144, '2015-01-01 00:10:29.000000', 'temperatura', 756.0000, 'ºC'),
	(298650, 144, '2015-01-01 00:10:30.000000', 'temperatura', 0.0000, 'ºC'),
	(298651, 144, '2015-01-01 00:10:31.000000', 'temperatura', 133.0000, 'ºC'),
	(298652, 144, '2015-01-01 00:10:32.000000', 'temperatura', 667.0000, 'ºC'),
	(298653, 144, '2015-01-01 00:10:33.000000', 'temperatura', 534.0000, 'ºC'),
	(298654, 144, '2015-01-01 00:10:34.000000', 'temperatura', 669.0000, 'ºC'),
	(298655, 144, '2015-01-01 00:10:35.000000', 'temperatura', 546.0000, 'ºC'),
	(298656, 144, '2015-01-01 00:10:36.000000', 'temperatura', 721.0000, 'ºC'),
	(298657, 144, '2015-01-01 00:10:37.000000', 'temperatura', 770.0000, 'ºC'),
	(298658, 144, '2015-01-01 00:10:38.000000', 'temperatura', 488.0000, 'ºC'),
	(298659, 144, '2015-01-01 00:10:39.000000', 'temperatura', 130.0000, 'ºC'),
	(298660, 144, '2015-01-01 00:10:40.000000', 'temperatura', 388.0000, 'ºC'),
	(298661, 144, '2015-01-01 00:10:41.000000', 'temperatura', 349.0000, 'ºC'),
	(298662, 144, '2015-01-01 00:10:42.000000', 'temperatura', 580.0000, 'ºC'),
	(298663, 144, '2015-01-01 00:10:43.000000', 'temperatura', 656.0000, 'ºC'),
	(298664, 144, '2015-01-01 00:10:44.000000', 'temperatura', 341.0000, 'ºC'),
	(298665, 144, '2015-01-01 00:10:45.000000', 'temperatura', 938.0000, 'ºC'),
	(298666, 144, '2015-01-01 00:10:46.000000', 'temperatura', 66.0000, 'ºC'),
	(298667, 144, '2015-01-01 00:10:47.000000', 'temperatura', 1116.0000, 'ºC'),
	(298668, 144, '2015-01-01 00:10:48.000000', 'temperatura', 583.0000, 'ºC'),
	(298669, 144, '2015-01-01 00:10:49.000000', 'temperatura', 768.0000, 'ºC'),
	(298670, 144, '2015-01-01 00:10:50.000000', 'temperatura', 891.0000, 'ºC'),
	(298671, 144, '2015-01-01 00:10:51.000000', 'temperatura', 951.0000, 'ºC'),
	(298672, 144, '2015-01-01 00:10:52.000000', 'temperatura', 884.0000, 'ºC'),
	(298673, 144, '2015-01-01 00:10:53.000000', 'temperatura', 366.0000, 'ºC'),
	(298674, 144, '2015-01-01 00:10:54.000000', 'temperatura', 381.0000, 'ºC'),
	(298675, 144, '2015-01-01 00:10:55.000000', 'temperatura', 807.0000, 'ºC'),
	(298676, 144, '2015-01-01 00:10:56.000000', 'temperatura', 491.0000, 'ºC'),
	(298677, 144, '2015-01-01 00:10:57.000000', 'temperatura', 37.0000, 'ºC'),
	(298678, 144, '2015-01-01 00:10:58.000000', 'temperatura', 1109.0000, 'ºC'),
	(298679, 144, '2015-01-01 00:10:59.000000', 'temperatura', 638.0000, 'ºC'),
	(298680, 144, '2015-01-01 00:11:00.000000', 'temperatura', 1060.0000, 'ºC'),
	(298681, 144, '2015-01-01 00:11:01.000000', 'temperatura', 989.0000, 'ºC'),
	(298682, 144, '2015-01-01 00:11:02.000000', 'temperatura', 563.0000, 'ºC'),
	(298683, 144, '2015-01-01 00:11:03.000000', 'temperatura', 1050.0000, 'ºC'),
	(298684, 144, '2015-01-01 00:11:04.000000', 'temperatura', 1162.0000, 'ºC'),
	(298685, 144, '2015-01-01 00:11:05.000000', 'temperatura', 258.0000, 'ºC'),
	(298686, 144, '2015-01-01 00:11:06.000000', 'temperatura', 208.0000, 'ºC'),
	(298687, 144, '2015-01-01 00:11:07.000000', 'temperatura', 264.0000, 'ºC'),
	(298688, 144, '2015-01-01 00:11:08.000000', 'temperatura', 699.0000, 'ºC'),
	(298689, 144, '2015-01-01 00:11:09.000000', 'temperatura', 301.0000, 'ºC'),
	(298690, 144, '2015-01-01 00:11:10.000000', 'temperatura', 611.0000, 'ºC'),
	(298691, 144, '2015-01-01 00:11:11.000000', 'temperatura', 951.0000, 'ºC'),
	(298692, 144, '2015-01-01 00:11:12.000000', 'temperatura', 524.0000, 'ºC'),
	(298693, 144, '2015-01-01 00:11:13.000000', 'temperatura', 965.0000, 'ºC'),
	(298694, 144, '2015-01-01 00:11:14.000000', 'temperatura', 853.0000, 'ºC'),
	(298695, 144, '2015-01-01 00:11:15.000000', 'temperatura', 171.0000, 'ºC'),
	(298696, 144, '2015-01-01 00:11:16.000000', 'temperatura', 699.0000, 'ºC'),
	(298697, 144, '2015-01-01 00:11:17.000000', 'temperatura', 579.0000, 'ºC'),
	(298698, 144, '2015-01-01 00:11:18.000000', 'temperatura', 800.0000, 'ºC'),
	(298699, 144, '2015-01-01 00:11:19.000000', 'temperatura', 1064.0000, 'ºC'),
	(298700, 144, '2015-01-01 00:11:20.000000', 'temperatura', 522.0000, 'ºC'),
	(298701, 144, '2015-01-01 00:11:21.000000', 'temperatura', 618.0000, 'ºC'),
	(298702, 144, '2015-01-01 00:11:22.000000', 'temperatura', 325.0000, 'ºC'),
	(298703, 144, '2015-01-01 00:11:23.000000', 'temperatura', 970.0000, 'ºC'),
	(298704, 144, '2015-01-01 00:11:24.000000', 'temperatura', 276.0000, 'ºC'),
	(298705, 144, '2015-01-01 00:11:25.000000', 'temperatura', 871.0000, 'ºC'),
	(298706, 144, '2015-01-01 00:11:26.000000', 'temperatura', 1127.0000, 'ºC'),
	(298707, 144, '2015-01-01 00:11:27.000000', 'temperatura', 622.0000, 'ºC'),
	(298708, 144, '2015-01-01 00:11:28.000000', 'temperatura', 929.0000, 'ºC'),
	(298709, 144, '2015-01-01 00:11:29.000000', 'temperatura', 380.0000, 'ºC'),
	(298710, 144, '2015-01-01 00:11:30.000000', 'temperatura', 313.0000, 'ºC'),
	(298711, 144, '2015-01-01 00:11:31.000000', 'temperatura', 428.0000, 'ºC'),
	(298712, 144, '2015-01-01 00:11:32.000000', 'temperatura', 0.0000, 'ºC'),
	(298713, 144, '2015-01-01 00:11:33.000000', 'temperatura', 1116.0000, 'ºC'),
	(298714, 144, '2015-01-01 00:11:34.000000', 'temperatura', 780.0000, 'ºC'),
	(298715, 144, '2015-01-01 00:11:35.000000', 'temperatura', 554.0000, 'ºC'),
	(298716, 144, '2015-01-01 00:11:36.000000', 'temperatura', 429.0000, 'ºC'),
	(298717, 144, '2015-01-01 00:11:37.000000', 'temperatura', 483.0000, 'ºC'),
	(298718, 144, '2015-01-01 00:11:38.000000', 'temperatura', 1127.0000, 'ºC'),
	(298719, 144, '2015-01-01 00:11:39.000000', 'temperatura', 589.0000, 'ºC'),
	(298720, 144, '2015-01-01 00:11:40.000000', 'temperatura', 763.0000, 'ºC'),
	(298721, 144, '2015-01-01 00:11:41.000000', 'temperatura', 851.0000, 'ºC'),
	(298722, 144, '2015-01-01 00:11:42.000000', 'temperatura', 766.0000, 'ºC'),
	(298723, 144, '2015-01-01 00:11:43.000000', 'temperatura', 75.0000, 'ºC'),
	(298724, 144, '2015-01-01 00:11:44.000000', 'temperatura', 481.0000, 'ºC'),
	(298725, 144, '2015-01-01 00:11:45.000000', 'temperatura', 978.0000, 'ºC'),
	(298726, 144, '2015-01-01 00:11:46.000000', 'temperatura', 1046.0000, 'ºC'),
	(298727, 144, '2015-01-01 00:11:47.000000', 'temperatura', 1099.0000, 'ºC'),
	(298728, 144, '2015-01-01 00:11:48.000000', 'temperatura', 1155.0000, 'ºC'),
	(298729, 144, '2015-01-01 00:11:49.000000', 'temperatura', 82.0000, 'ºC'),
	(298730, 144, '2015-01-01 00:11:50.000000', 'temperatura', 543.0000, 'ºC'),
	(298731, 144, '2015-01-01 00:11:51.000000', 'temperatura', 69.0000, 'ºC'),
	(298732, 144, '2015-01-01 00:11:52.000000', 'temperatura', 1119.0000, 'ºC'),
	(298733, 144, '2015-01-01 00:11:53.000000', 'temperatura', 586.0000, 'ºC'),
	(298734, 144, '2015-01-01 00:11:54.000000', 'temperatura', 774.0000, 'ºC'),
	(298735, 144, '2015-01-01 00:11:55.000000', 'temperatura', 914.0000, 'ºC'),
	(298736, 144, '2015-01-01 00:11:56.000000', 'temperatura', 1048.0000, 'ºC'),
	(298737, 144, '2015-01-01 00:11:57.000000', 'temperatura', 98.0000, 'ºC'),
	(298738, 144, '2015-01-01 00:11:58.000000', 'temperatura', 949.0000, 'ºC'),
	(298739, 144, '2015-01-01 00:11:59.000000', 'temperatura', 848.0000, 'ºC'),
	(298740, 144, '2015-01-01 00:12:00.000000', 'temperatura', 195.0000, 'ºC'),
	(298741, 144, '2015-01-01 00:12:01.000000', 'temperatura', 831.0000, 'ºC'),
	(298742, 144, '2015-01-01 00:12:02.000000', 'temperatura', 1169.0000, 'ºC'),
	(298743, 144, '2015-01-01 00:12:03.000000', 'temperatura', 953.0000, 'ºC'),
	(298744, 144, '2015-01-01 00:12:04.000000', 'temperatura', 60.0000, 'ºC'),
	(298745, 144, '2015-01-01 00:12:05.000000', 'temperatura', 1040.0000, 'ºC'),
	(298746, 144, '2015-01-01 00:12:06.000000', 'temperatura', 220.0000, 'ºC'),
	(298747, 144, '2015-01-01 00:12:07.000000', 'temperatura', 380.0000, 'ºC'),
	(298748, 144, '2015-01-01 00:12:08.000000', 'temperatura', 40.0000, 'ºC'),
	(298749, 144, '2015-01-01 00:12:09.000000', 'temperatura', 261.0000, 'ºC'),
	(298750, 144, '2015-01-01 00:12:10.000000', 'temperatura', 1188.0000, 'ºC'),
	(298751, 144, '2015-01-01 00:12:11.000000', 'temperatura', 355.0000, 'ºC'),
	(298752, 144, '2015-01-01 00:12:12.000000', 'temperatura', 614.0000, 'ºC'),
	(298753, 144, '2015-01-01 00:12:13.000000', 'temperatura', 803.0000, 'ºC'),
	(298754, 144, '2015-01-01 00:12:14.000000', 'temperatura', 975.0000, 'ºC'),
	(298755, 144, '2015-01-01 00:12:15.000000', 'temperatura', 65.0000, 'ºC'),
	(298756, 144, '2015-01-01 00:12:16.000000', 'temperatura', 1003.0000, 'ºC'),
	(298757, 144, '2015-01-01 00:12:17.000000', 'temperatura', 21.0000, 'ºC'),
	(298758, 144, '2015-01-01 00:12:18.000000', 'temperatura', 695.0000, 'ºC'),
	(298759, 144, '2015-01-01 00:12:19.000000', 'temperatura', 1012.0000, 'ºC'),
	(298760, 144, '2015-01-01 00:12:20.000000', 'temperatura', 577.0000, 'ºC'),
	(298761, 144, '2015-01-01 00:12:21.000000', 'temperatura', 1047.0000, 'ºC'),
	(298762, 144, '2015-01-01 00:12:22.000000', 'temperatura', 1107.0000, 'ºC'),
	(298763, 144, '2015-01-01 00:12:23.000000', 'temperatura', 1194.0000, 'ºC'),
	(298764, 144, '2015-01-01 00:12:24.000000', 'temperatura', 247.0000, 'ºC'),
	(298765, 144, '2015-01-01 00:12:25.000000', 'temperatura', 57.0000, 'ºC'),
	(298766, 144, '2015-01-01 00:12:26.000000', 'temperatura', 744.0000, 'ºC'),
	(298767, 144, '2015-01-01 00:12:27.000000', 'temperatura', 1148.0000, 'ºC'),
	(298768, 144, '2015-01-01 00:12:28.000000', 'temperatura', 1107.0000, 'ºC'),
	(298769, 144, '2015-01-01 00:12:29.000000', 'temperatura', 894.0000, 'ºC'),
	(298770, 144, '2015-01-01 00:12:30.000000', 'temperatura', 1150.0000, 'ºC'),
	(298771, 144, '2015-01-01 00:12:31.000000', 'temperatura', 669.0000, 'ºC'),
	(298772, 144, '2015-01-01 00:12:32.000000', 'temperatura', 1096.0000, 'ºC'),
	(298773, 144, '2015-01-01 00:12:33.000000', 'temperatura', 1075.0000, 'ºC'),
	(298774, 144, '2015-01-01 00:12:34.000000', 'temperatura', 884.0000, 'ºC'),
	(298775, 144, '2015-01-01 00:12:35.000000', 'temperatura', 1195.0000, 'ºC'),
	(298776, 144, '2015-01-01 00:12:36.000000', 'temperatura', 925.0000, 'ºC'),
	(298777, 144, '2015-01-01 00:12:37.000000', 'temperatura', 1042.0000, 'ºC'),
	(298778, 144, '2015-01-01 00:12:38.000000', 'temperatura', 35.0000, 'ºC'),
	(298779, 144, '2015-01-01 00:12:39.000000', 'temperatura', 648.0000, 'ºC'),
	(298780, 144, '2015-01-01 00:12:40.000000', 'temperatura', 737.0000, 'ºC'),
	(298781, 144, '2015-01-01 00:12:41.000000', 'temperatura', 541.0000, 'ºC'),
	(298782, 144, '2015-01-01 00:12:42.000000', 'temperatura', 495.0000, 'ºC'),
	(298783, 144, '2015-01-01 00:12:43.000000', 'temperatura', 852.0000, 'ºC'),
	(298784, 144, '2015-01-01 00:12:44.000000', 'temperatura', 374.0000, 'ºC'),
	(298785, 144, '2015-01-01 00:12:45.000000', 'temperatura', 516.0000, 'ºC'),
	(298786, 144, '2015-01-01 00:12:46.000000', 'temperatura', 260.0000, 'ºC'),
	(298787, 144, '2015-01-01 00:12:47.000000', 'temperatura', 952.0000, 'ºC'),
	(298788, 144, '2015-01-01 00:12:48.000000', 'temperatura', 378.0000, 'ºC'),
	(298789, 144, '2015-01-01 00:12:49.000000', 'temperatura', 236.0000, 'ºC'),
	(298790, 144, '2015-01-01 00:12:50.000000', 'temperatura', 47.0000, 'ºC'),
	(298791, 144, '2015-01-01 00:12:51.000000', 'temperatura', 728.0000, 'ºC'),
	(298792, 144, '2015-01-01 00:12:52.000000', 'temperatura', 1098.0000, 'ºC'),
	(298793, 144, '2015-01-01 00:12:53.000000', 'temperatura', 908.0000, 'ºC'),
	(298794, 144, '2015-01-01 00:12:54.000000', 'temperatura', 44.0000, 'ºC'),
	(298795, 144, '2015-01-01 00:12:55.000000', 'temperatura', 1097.0000, 'ºC'),
	(298796, 144, '2015-01-01 00:12:56.000000', 'temperatura', 555.0000, 'ºC'),
	(298797, 144, '2015-01-01 00:12:57.000000', 'temperatura', 684.0000, 'ºC'),
	(298798, 144, '2015-01-01 00:12:58.000000', 'temperatura', 557.0000, 'ºC'),
	(298799, 144, '2015-01-01 00:12:59.000000', 'temperatura', 731.0000, 'ºC'),
	(298800, 144, '2015-01-01 00:13:00.000000', 'temperatura', 785.0000, 'ºC'),
	(298801, 144, '2015-01-01 00:13:01.000000', 'temperatura', 533.0000, 'ºC'),
	(298802, 144, '2015-01-01 00:13:02.000000', 'temperatura', 311.0000, 'ºC'),
	(298803, 144, '2015-01-01 00:13:03.000000', 'temperatura', 1157.0000, 'ºC'),
	(298804, 144, '2015-01-01 00:13:04.000000', 'temperatura', 51.0000, 'ºC'),
	(298805, 144, '2015-01-01 00:13:05.000000', 'temperatura', 386.0000, 'ºC'),
	(298806, 144, '2015-01-01 00:13:06.000000', 'temperatura', 579.0000, 'ºC'),
	(298807, 144, '2015-01-01 00:13:07.000000', 'temperatura', 534.0000, 'ºC'),
	(298808, 144, '2015-01-01 00:13:08.000000', 'temperatura', 935.0000, 'ºC'),
	(298809, 144, '2015-01-01 00:13:09.000000', 'temperatura', 674.0000, 'ºC'),
	(298810, 144, '2015-01-01 00:13:10.000000', 'temperatura', 567.0000, 'ºC'),
	(298811, 144, '2015-01-01 00:13:11.000000', 'temperatura', 811.0000, 'ºC'),
	(298812, 144, '2015-01-01 00:13:12.000000', 'temperatura', 1157.0000, 'ºC'),
	(298813, 144, '2015-01-01 00:13:13.000000', 'temperatura', 951.0000, 'ºC'),
	(298814, 144, '2015-01-01 00:13:14.000000', 'temperatura', 86.0000, 'ºC'),
	(298815, 144, '2015-01-01 00:13:15.000000', 'temperatura', 1177.0000, 'ºC'),
	(298816, 144, '2015-01-01 00:13:16.000000', 'temperatura', 829.0000, 'ºC'),
	(298817, 144, '2015-01-01 00:13:17.000000', 'temperatura', 615.0000, 'ºC'),
	(298818, 144, '2015-01-01 00:13:18.000000', 'temperatura', 585.0000, 'ºC'),
	(298819, 144, '2015-01-01 00:13:19.000000', 'temperatura', 1083.0000, 'ºC'),
	(298820, 144, '2015-01-01 00:13:20.000000', 'temperatura', 61.0000, 'ºC'),
	(298821, 144, '2015-01-01 00:13:21.000000', 'temperatura', 656.0000, 'ºC'),
	(298822, 144, '2015-01-01 00:13:22.000000', 'temperatura', 698.0000, 'ºC'),
	(298823, 144, '2015-01-01 00:13:23.000000', 'temperatura', 322.0000, 'ºC'),
	(298824, 144, '2015-01-01 00:13:24.000000', 'temperatura', 718.0000, 'ºC'),
	(298825, 144, '2015-01-01 00:13:25.000000', 'temperatura', 223.0000, 'ºC'),
	(298826, 144, '2015-01-01 00:13:26.000000', 'temperatura', 161.0000, 'ºC'),
	(298827, 144, '2015-01-01 00:13:27.000000', 'temperatura', 139.0000, 'ºC'),
	(298828, 144, '2015-01-01 00:13:28.000000', 'temperatura', 211.0000, 'ºC'),
	(298829, 144, '2015-01-01 00:13:29.000000', 'temperatura', 639.0000, 'ºC'),
	(298830, 144, '2015-01-01 00:13:30.000000', 'temperatura', 162.0000, 'ºC'),
	(298831, 144, '2015-01-01 00:13:31.000000', 'temperatura', 93.0000, 'ºC'),
	(298832, 144, '2015-01-01 00:13:32.000000', 'temperatura', 1180.0000, 'ºC'),
	(298833, 144, '2015-01-01 00:13:33.000000', 'temperatura', 821.0000, 'ºC'),
	(298834, 144, '2015-01-01 00:13:34.000000', 'temperatura', 566.0000, 'ºC'),
	(298835, 144, '2015-01-01 00:13:35.000000', 'temperatura', 366.0000, 'ºC'),
	(298836, 144, '2015-01-01 00:13:36.000000', 'temperatura', 133.0000, 'ºC'),
	(298837, 144, '2015-01-01 00:13:37.000000', 'temperatura', 767.0000, 'ºC'),
	(298838, 144, '2015-01-01 00:13:38.000000', 'temperatura', 1037.0000, 'ºC'),
	(298839, 144, '2015-01-01 00:13:39.000000', 'temperatura', 484.0000, 'ºC'),
	(298840, 144, '2015-01-01 00:13:40.000000', 'temperatura', 508.0000, 'ºC'),
	(298841, 144, '2015-01-01 00:13:41.000000', 'temperatura', 1089.0000, 'ºC'),
	(298842, 144, '2015-01-01 00:13:42.000000', 'temperatura', 322.0000, 'ºC'),
	(298843, 144, '2015-01-01 00:13:43.000000', 'temperatura', 745.0000, 'ºC'),
	(298844, 144, '2015-01-01 00:13:44.000000', 'temperatura', 359.0000, 'ºC'),
	(298845, 144, '2015-01-01 00:13:45.000000', 'temperatura', 760.0000, 'ºC'),
	(298846, 144, '2015-01-01 00:13:46.000000', 'temperatura', 324.0000, 'ºC'),
	(298847, 144, '2015-01-01 00:13:47.000000', 'temperatura', 542.0000, 'ºC'),
	(298848, 144, '2015-01-01 00:13:48.000000', 'temperatura', 538.0000, 'ºC'),
	(298849, 144, '2015-01-01 00:13:49.000000', 'temperatura', 1065.0000, 'ºC'),
	(298850, 144, '2015-01-01 00:13:50.000000', 'temperatura', 111.0000, 'ºC'),
	(298851, 144, '2015-01-01 00:13:51.000000', 'temperatura', 961.0000, 'ºC'),
	(298852, 144, '2015-01-01 00:13:52.000000', 'temperatura', 871.0000, 'ºC'),
	(298853, 144, '2015-01-01 00:13:53.000000', 'temperatura', 273.0000, 'ºC'),
	(298854, 144, '2015-01-01 00:13:54.000000', 'temperatura', 1154.0000, 'ºC'),
	(298855, 144, '2015-01-01 00:13:55.000000', 'temperatura', 149.0000, 'ºC'),
	(298856, 144, '2015-01-01 00:13:56.000000', 'temperatura', 883.0000, 'ºC'),
	(298857, 144, '2015-01-01 00:13:57.000000', 'temperatura', 369.0000, 'ºC'),
	(298858, 144, '2015-01-01 00:13:58.000000', 'temperatura', 398.0000, 'ºC'),
	(298859, 144, '2015-01-01 00:13:59.000000', 'temperatura', 885.0000, 'ºC'),
	(298860, 144, '2015-01-01 00:14:00.000000', 'temperatura', 829.0000, 'ºC'),
	(298861, 144, '2015-01-01 00:14:01.000000', 'temperatura', 290.0000, 'ºC'),
	(298862, 144, '2015-01-01 00:14:02.000000', 'temperatura', 164.0000, 'ºC'),
	(298863, 144, '2015-01-01 00:14:03.000000', 'temperatura', 1152.0000, 'ºC'),
	(298864, 144, '2015-01-01 00:14:04.000000', 'temperatura', 468.0000, 'ºC'),
	(298865, 144, '2015-01-01 00:14:05.000000', 'temperatura', 83.0000, 'ºC'),
	(298866, 144, '2015-01-01 00:14:06.000000', 'temperatura', 212.0000, 'ºC'),
	(298867, 144, '2015-01-01 00:14:07.000000', 'temperatura', 812.0000, 'ºC'),
	(298868, 144, '2015-01-01 00:14:08.000000', 'temperatura', 1024.0000, 'ºC'),
	(298869, 144, '2015-01-01 00:14:09.000000', 'temperatura', 286.0000, 'ºC'),
	(298870, 144, '2015-01-01 00:14:10.000000', 'temperatura', 756.0000, 'ºC'),
	(298871, 144, '2015-01-01 00:14:11.000000', 'temperatura', 524.0000, 'ºC'),
	(298872, 144, '2015-01-01 00:14:12.000000', 'temperatura', 354.0000, 'ºC'),
	(298873, 144, '2015-01-01 00:14:13.000000', 'temperatura', 196.0000, 'ºC'),
	(298874, 144, '2015-01-01 00:14:14.000000', 'temperatura', 1120.0000, 'ºC'),
	(298875, 144, '2015-01-01 00:14:15.000000', 'temperatura', 213.0000, 'ºC'),
	(298876, 144, '2015-01-01 00:14:16.000000', 'temperatura', 103.0000, 'ºC'),
	(298877, 144, '2015-01-01 00:14:17.000000', 'temperatura', 1078.0000, 'ºC'),
	(298878, 144, '2015-01-01 00:14:18.000000', 'temperatura', 280.0000, 'ºC'),
	(298879, 144, '2015-01-01 00:14:19.000000', 'temperatura', 568.0000, 'ºC'),
	(298880, 144, '2015-01-01 00:14:20.000000', 'temperatura', 801.0000, 'ºC'),
	(298881, 144, '2015-01-01 00:14:21.000000', 'temperatura', 1101.0000, 'ºC'),
	(298882, 144, '2015-01-01 00:14:22.000000', 'temperatura', 702.0000, 'ºC'),
	(298883, 144, '2015-01-01 00:14:23.000000', 'temperatura', 207.0000, 'ºC'),
	(298884, 144, '2015-01-01 00:14:24.000000', 'temperatura', 128.0000, 'ºC'),
	(298885, 144, '2015-01-01 00:14:25.000000', 'temperatura', 23.0000, 'ºC'),
	(298886, 144, '2015-01-01 00:14:26.000000', 'temperatura', 929.0000, 'ºC'),
	(298887, 144, '2015-01-01 00:14:27.000000', 'temperatura', 978.0000, 'ºC'),
	(298888, 144, '2015-01-01 00:14:28.000000', 'temperatura', 905.0000, 'ºC'),
	(298889, 144, '2015-01-01 00:14:29.000000', 'temperatura', 390.0000, 'ºC'),
	(298890, 144, '2015-01-01 00:14:30.000000', 'temperatura', 436.0000, 'ºC'),
	(298891, 144, '2015-01-01 00:14:31.000000', 'temperatura', 1011.0000, 'ºC'),
	(298892, 144, '2015-01-01 00:14:32.000000', 'temperatura', 148.0000, 'ºC'),
	(298893, 144, '2015-01-01 00:14:33.000000', 'temperatura', 107.0000, 'ºC'),
	(298894, 144, '2015-01-01 00:14:34.000000', 'temperatura', 89.0000, 'ºC'),
	(298895, 144, '2015-01-01 00:14:35.000000', 'temperatura', 127.0000, 'ºC'),
	(298896, 144, '2015-01-01 00:14:36.000000', 'temperatura', 368.0000, 'ºC'),
	(298897, 144, '2015-01-01 00:14:37.000000', 'temperatura', 260.0000, 'ºC'),
	(298898, 144, '2015-01-01 00:14:38.000000', 'temperatura', 197.0000, 'ºC'),
	(298899, 144, '2015-01-01 00:14:39.000000', 'temperatura', 203.0000, 'ºC'),
	(298900, 144, '2015-01-01 00:14:40.000000', 'temperatura', 426.0000, 'ºC'),
	(298901, 144, '2015-01-01 00:14:41.000000', 'temperatura', 320.0000, 'ºC'),
	(298902, 144, '2015-01-01 00:14:42.000000', 'temperatura', 325.0000, 'ºC'),
	(298903, 144, '2015-01-01 00:14:43.000000', 'temperatura', 666.0000, 'ºC'),
	(298904, 144, '2015-01-01 00:14:44.000000', 'temperatura', 1155.0000, 'ºC'),
	(298905, 144, '2015-01-01 00:14:45.000000', 'temperatura', 178.0000, 'ºC'),
	(298906, 144, '2015-01-01 00:14:46.000000', 'temperatura', 1023.0000, 'ºC'),
	(298907, 144, '2015-01-01 00:14:47.000000', 'temperatura', 982.0000, 'ºC'),
	(298908, 144, '2015-01-01 00:14:48.000000', 'temperatura', 641.0000, 'ºC'),
	(298909, 144, '2015-01-01 00:14:49.000000', 'temperatura', 260.0000, 'ºC'),
	(298910, 144, '2015-01-01 00:14:50.000000', 'temperatura', 577.0000, 'ºC'),
	(298911, 144, '2015-01-01 00:14:51.000000', 'temperatura', 908.0000, 'ºC'),
	(298912, 144, '2015-01-01 00:14:52.000000', 'temperatura', 408.0000, 'ºC'),
	(298913, 144, '2015-01-01 00:14:53.000000', 'temperatura', 518.0000, 'ºC'),
	(298914, 144, '2015-01-01 00:14:54.000000', 'temperatura', 165.0000, 'ºC'),
	(298915, 144, '2015-01-01 00:14:55.000000', 'temperatura', 474.0000, 'ºC'),
	(298916, 144, '2015-01-01 00:14:56.000000', 'temperatura', 672.0000, 'ºC'),
	(298917, 144, '2015-01-01 00:14:57.000000', 'temperatura', 740.0000, 'ºC'),
	(298918, 144, '2015-01-01 00:14:58.000000', 'temperatura', 483.0000, 'ºC'),
	(298919, 144, '2015-01-01 00:14:59.000000', 'temperatura', 198.0000, 'ºC'),
	(298920, 144, '2015-01-01 00:15:00.000000', 'temperatura', 741.0000, 'ºC'),
	(298921, 144, '2015-01-01 00:15:01.000000', 'temperatura', 711.0000, 'ºC'),
	(298922, 144, '2015-01-01 00:15:02.000000', 'temperatura', 135.0000, 'ºC'),
	(298923, 144, '2015-01-01 00:15:03.000000', 'temperatura', 939.0000, 'ºC'),
	(298924, 144, '2015-01-01 00:15:04.000000', 'temperatura', 691.0000, 'ºC'),
	(298925, 144, '2015-01-01 00:15:05.000000', 'temperatura', 641.0000, 'ºC'),
	(298926, 144, '2015-01-01 00:15:06.000000', 'temperatura', 1131.0000, 'ºC'),
	(298927, 144, '2015-01-01 00:15:07.000000', 'temperatura', 133.0000, 'ºC'),
	(298928, 144, '2015-01-01 00:15:08.000000', 'temperatura', 873.0000, 'ºC'),
	(298929, 144, '2015-01-01 00:15:09.000000', 'temperatura', 366.0000, 'ºC'),
	(298930, 144, '2015-01-01 00:15:10.000000', 'temperatura', 414.0000, 'ºC'),
	(298931, 144, '2015-01-01 00:15:11.000000', 'temperatura', 969.0000, 'ºC'),
	(298932, 144, '2015-01-01 00:15:12.000000', 'temperatura', 5.0000, 'ºC'),
	(298933, 144, '2015-01-01 00:15:13.000000', 'temperatura', 716.0000, 'ºC'),
	(298934, 144, '2015-01-01 00:15:14.000000', 'temperatura', 1168.0000, 'ºC'),
	(298935, 144, '2015-01-01 00:15:15.000000', 'temperatura', 93.0000, 'ºC'),
	(298936, 144, '2015-01-01 00:15:16.000000', 'temperatura', 562.0000, 'ºC'),
	(298937, 144, '2015-01-01 00:15:17.000000', 'temperatura', 132.0000, 'ºC'),
	(298938, 144, '2015-01-01 00:15:18.000000', 'temperatura', 174.0000, 'ºC'),
	(298939, 144, '2015-01-01 00:15:19.000000', 'temperatura', 473.0000, 'ºC'),
	(298940, 144, '2015-01-01 00:15:20.000000', 'temperatura', 645.0000, 'ºC'),
	(298941, 144, '2015-01-01 00:15:21.000000', 'temperatura', 605.0000, 'ºC'),
	(298942, 144, '2015-01-01 00:15:22.000000', 'temperatura', 1091.0000, 'ºC'),
	(298943, 144, '2015-01-01 00:15:23.000000', 'temperatura', 41.0000, 'ºC'),
	(298944, 144, '2015-01-01 00:15:24.000000', 'temperatura', 531.0000, 'ºC'),
	(298945, 144, '2015-01-01 00:15:25.000000', 'temperatura', 133.0000, 'ºC'),
	(298946, 144, '2015-01-01 00:15:26.000000', 'temperatura', 274.0000, 'ºC'),
	(298947, 144, '2015-01-01 00:15:27.000000', 'temperatura', 969.0000, 'ºC'),
	(298948, 144, '2015-01-01 00:15:28.000000', 'temperatura', 425.0000, 'ºC'),
	(298949, 144, '2015-01-01 00:15:29.000000', 'temperatura', 417.0000, 'ºC'),
	(298950, 144, '2015-01-01 00:15:30.000000', 'temperatura', 813.0000, 'ºC'),
	(298951, 144, '2015-01-01 00:15:31.000000', 'temperatura', 415.0000, 'ºC'),
	(298952, 144, '2015-01-01 00:15:32.000000', 'temperatura', 837.0000, 'ºC'),
	(298953, 144, '2015-01-01 00:15:33.000000', 'temperatura', 540.0000, 'ºC'),
	(298954, 144, '2015-01-01 00:15:34.000000', 'temperatura', 191.0000, 'ºC'),
	(298955, 144, '2015-01-01 00:15:35.000000', 'temperatura', 532.0000, 'ºC'),
	(298956, 144, '2015-01-01 00:15:36.000000', 'temperatura', 889.0000, 'ºC'),
	(298957, 144, '2015-01-01 00:15:37.000000', 'temperatura', 452.0000, 'ºC'),
	(298958, 144, '2015-01-01 00:15:38.000000', 'temperatura', 790.0000, 'ºC'),
	(298959, 144, '2015-01-01 00:15:39.000000', 'temperatura', 195.0000, 'ºC'),
	(298960, 144, '2015-01-01 00:15:40.000000', 'temperatura', 1004.0000, 'ºC'),
	(298961, 144, '2015-01-01 00:15:41.000000', 'temperatura', 837.0000, 'ºC'),
	(298962, 144, '2015-01-01 00:15:42.000000', 'temperatura', 1172.0000, 'ºC'),
	(298963, 144, '2015-01-01 00:15:43.000000', 'temperatura', 949.0000, 'ºC'),
	(298964, 144, '2015-01-01 00:15:44.000000', 'temperatura', 32.0000, 'ºC'),
	(298965, 144, '2015-01-01 00:15:45.000000', 'temperatura', 912.0000, 'ºC'),
	(298966, 144, '2015-01-01 00:15:46.000000', 'temperatura', 866.0000, 'ºC'),
	(298967, 144, '2015-01-01 00:15:47.000000', 'temperatura', 393.0000, 'ºC'),
	(298968, 144, '2015-01-01 00:15:48.000000', 'temperatura', 566.0000, 'ºC'),
	(298969, 144, '2015-01-01 00:15:49.000000', 'temperatura', 453.0000, 'ºC'),
	(298970, 144, '2015-01-01 00:15:50.000000', 'temperatura', 569.0000, 'ºC'),
	(298971, 144, '2015-01-01 00:15:51.000000', 'temperatura', 286.0000, 'ºC'),
	(298972, 144, '2015-01-01 00:15:52.000000', 'temperatura', 923.0000, 'ºC'),
	(298973, 144, '2015-01-01 00:15:53.000000', 'temperatura', 158.0000, 'ºC'),
	(298974, 144, '2015-01-01 00:15:54.000000', 'temperatura', 420.0000, 'ºC'),
	(298975, 144, '2015-01-01 00:15:55.000000', 'temperatura', 426.0000, 'ºC'),
	(298976, 144, '2015-01-01 00:15:56.000000', 'temperatura', 873.0000, 'ºC'),
	(298977, 144, '2015-01-01 00:15:57.000000', 'temperatura', 686.0000, 'ºC'),
	(298978, 144, '2015-01-01 00:15:58.000000', 'temperatura', 813.0000, 'ºC'),
	(298979, 144, '2015-01-01 00:15:59.000000', 'temperatura', 807.0000, 'ºC'),
	(298980, 144, '2015-01-01 00:16:00.000000', 'temperatura', 396.0000, 'ºC'),
	(298981, 144, '2015-01-01 00:16:01.000000', 'temperatura', 758.0000, 'ºC'),
	(298982, 144, '2015-01-01 00:16:02.000000', 'temperatura', 204.0000, 'ºC'),
	(298983, 144, '2015-01-01 00:16:03.000000', 'temperatura', 1144.0000, 'ºC'),
	(298984, 144, '2015-01-01 00:16:04.000000', 'temperatura', 311.0000, 'ºC'),
	(298985, 144, '2015-01-01 00:16:05.000000', 'temperatura', 523.0000, 'ºC'),
	(298986, 144, '2015-01-01 00:16:06.000000', 'temperatura', 482.0000, 'ºC'),
	(298987, 144, '2015-01-01 00:16:07.000000', 'temperatura', 841.0000, 'ºC'),
	(298988, 144, '2015-01-01 00:16:08.000000', 'temperatura', 360.0000, 'ºC'),
	(298989, 144, '2015-01-01 00:16:09.000000', 'temperatura', 477.0000, 'ºC'),
	(298990, 144, '2015-01-01 00:16:10.000000', 'temperatura', 105.0000, 'ºC'),
	(298991, 144, '2015-01-01 00:16:11.000000', 'temperatura', 296.0000, 'ºC'),
	(298992, 144, '2015-01-01 00:16:12.000000', 'temperatura', 1166.0000, 'ºC'),
	(298993, 144, '2015-01-01 00:16:13.000000', 'temperatura', 142.0000, 'ºC'),
	(298994, 144, '2015-01-01 00:16:14.000000', 'temperatura', 811.0000, 'ºC'),
	(298995, 144, '2015-01-01 00:16:15.000000', 'temperatura', 28.0000, 'ºC'),
	(298996, 144, '2015-01-01 00:16:16.000000', 'temperatura', 111.0000, 'ºC'),
	(298997, 144, '2015-01-01 00:16:17.000000', 'temperatura', 468.0000, 'ºC'),
	(298998, 144, '2015-01-01 00:16:18.000000', 'temperatura', 810.0000, 'ºC'),
	(298999, 144, '2015-01-01 00:16:19.000000', 'temperatura', 246.0000, 'ºC'),
	(299000, 144, '2015-01-01 00:16:20.000000', 'temperatura', 1199.0000, 'ºC'),
	(299001, 144, '2015-01-01 00:16:21.000000', 'temperatura', 457.0000, 'ºC'),
	(299002, 144, '2015-01-01 00:16:22.000000', 'temperatura', 1091.0000, 'ºC'),
	(299003, 144, '2015-01-01 00:16:23.000000', 'temperatura', 484.0000, 'ºC'),
	(299004, 144, '2015-01-01 00:16:24.000000', 'temperatura', 349.0000, 'ºC'),
	(299005, 144, '2015-01-01 00:16:25.000000', 'temperatura', 292.0000, 'ºC'),
	(299006, 144, '2015-01-01 00:16:26.000000', 'temperatura', 415.0000, 'ºC'),
	(299007, 144, '2015-01-01 00:16:27.000000', 'temperatura', 1197.0000, 'ºC'),
	(299008, 144, '2015-01-01 00:16:28.000000', 'temperatura', 1142.0000, 'ºC'),
	(299009, 144, '2015-01-01 00:16:29.000000', 'temperatura', 920.0000, 'ºC'),
	(299010, 144, '2015-01-01 00:16:30.000000', 'temperatura', 1174.0000, 'ºC'),
	(299011, 144, '2015-01-01 00:16:31.000000', 'temperatura', 708.0000, 'ºC'),
	(299012, 144, '2015-01-01 00:16:32.000000', 'temperatura', 22.0000, 'ºC'),
	(299013, 144, '2015-01-01 00:16:33.000000', 'temperatura', 386.0000, 'ºC'),
	(299014, 144, '2015-01-01 00:16:34.000000', 'temperatura', 664.0000, 'ºC'),
	(299015, 144, '2015-01-01 00:16:35.000000', 'temperatura', 963.0000, 'ºC'),
	(299016, 144, '2015-01-01 00:16:36.000000', 'temperatura', 424.0000, 'ºC'),
	(299017, 144, '2015-01-01 00:16:37.000000', 'temperatura', 432.0000, 'ºC'),
	(299018, 144, '2015-01-01 00:16:38.000000', 'temperatura', 887.0000, 'ºC'),
	(299019, 144, '2015-01-01 00:16:39.000000', 'temperatura', 740.0000, 'ºC'),
	(299020, 144, '2015-01-01 00:16:40.000000', 'temperatura', 1039.0000, 'ºC'),
	(299021, 144, '2015-01-01 00:16:41.000000', 'temperatura', 575.0000, 'ºC'),
	(299022, 144, '2015-01-01 00:16:42.000000', 'temperatura', 959.0000, 'ºC'),
	(299023, 144, '2015-01-01 00:16:43.000000', 'temperatura', 669.0000, 'ºC'),
	(299024, 144, '2015-01-01 00:16:44.000000', 'temperatura', 468.0000, 'ºC'),
	(299025, 144, '2015-01-01 00:16:45.000000', 'temperatura', 336.0000, 'ºC'),
	(299026, 144, '2015-01-01 00:16:46.000000', 'temperatura', 278.0000, 'ºC'),
	(299027, 144, '2015-01-01 00:16:47.000000', 'temperatura', 379.0000, 'ºC'),
	(299028, 144, '2015-01-01 00:16:48.000000', 'temperatura', 1062.0000, 'ºC'),
	(299029, 144, '2015-01-01 00:16:49.000000', 'temperatura', 574.0000, 'ºC'),
	(299030, 144, '2015-01-01 00:16:50.000000', 'temperatura', 885.0000, 'ºC'),
	(299031, 144, '2015-01-01 00:16:51.000000', 'temperatura', 303.0000, 'ºC'),
	(299032, 144, '2015-01-01 00:16:52.000000', 'temperatura', 60.0000, 'ºC'),
	(299033, 144, '2015-01-01 00:16:53.000000', 'temperatura', 593.0000, 'ºC'),
	(299034, 144, '2015-01-01 00:16:54.000000', 'temperatura', 385.0000, 'ºC'),
	(299035, 144, '2015-01-01 00:16:55.000000', 'temperatura', 148.0000, 'ºC'),
	(299036, 144, '2015-01-01 00:16:56.000000', 'temperatura', 784.0000, 'ºC'),
	(299037, 144, '2015-01-01 00:16:57.000000', 'temperatura', 1077.0000, 'ºC'),
	(299038, 144, '2015-01-01 00:16:58.000000', 'temperatura', 633.0000, 'ºC'),
	(299039, 144, '2015-01-01 00:16:59.000000', 'temperatura', 1135.0000, 'ºC'),
	(299040, 144, '2015-01-01 00:17:00.000000', 'temperatura', 174.0000, 'ºC'),
	(299041, 144, '2015-01-01 00:17:01.000000', 'temperatura', 1069.0000, 'ºC'),
	(299042, 144, '2015-01-01 00:17:02.000000', 'temperatura', 21.0000, 'ºC'),
	(299043, 144, '2015-01-01 00:17:03.000000', 'temperatura', 501.0000, 'ºC'),
	(299044, 144, '2015-01-01 00:17:04.000000', 'temperatura', 40.0000, 'ºC'),
	(299045, 144, '2015-01-01 00:17:05.000000', 'temperatura', 1099.0000, 'ºC'),
	(299046, 144, '2015-01-01 00:17:06.000000', 'temperatura', 574.0000, 'ºC'),
	(299047, 144, '2015-01-01 00:17:07.000000', 'temperatura', 773.0000, 'ºC'),
	(299048, 144, '2015-01-01 00:17:08.000000', 'temperatura', 944.0000, 'ºC'),
	(299049, 144, '2015-01-01 00:17:09.000000', 'temperatura', 1.0000, 'ºC'),
	(299050, 144, '2015-01-01 00:17:10.000000', 'temperatura', 772.0000, 'ºC'),
	(299051, 144, '2015-01-01 00:17:11.000000', 'temperatura', 261.0000, 'ºC'),
	(299052, 144, '2015-01-01 00:17:12.000000', 'temperatura', 187.0000, 'ºC'),
	(299053, 144, '2015-01-01 00:17:13.000000', 'temperatura', 154.0000, 'ºC'),
	(299054, 144, '2015-01-01 00:17:14.000000', 'temperatura', 209.0000, 'ºC'),
	(299055, 144, '2015-01-01 00:17:15.000000', 'temperatura', 583.0000, 'ºC'),
	(299056, 144, '2015-01-01 00:17:16.000000', 'temperatura', 1090.0000, 'ºC'),
	(299057, 144, '2015-01-01 00:17:17.000000', 'temperatura', 99.0000, 'ºC'),
	(299058, 144, '2015-01-01 00:17:18.000000', 'temperatura', 826.0000, 'ºC'),
	(299059, 144, '2015-01-01 00:17:19.000000', 'temperatura', 234.0000, 'ºC'),
	(299060, 144, '2015-01-01 00:17:20.000000', 'temperatura', 1091.0000, 'ºC'),
	(299061, 144, '2015-01-01 00:17:21.000000', 'temperatura', 1156.0000, 'ºC'),
	(299062, 144, '2015-01-01 00:17:22.000000', 'temperatura', 108.0000, 'ºC'),
	(299063, 144, '2015-01-01 00:17:23.000000', 'temperatura', 670.0000, 'ºC'),
	(299064, 144, '2015-01-01 00:17:24.000000', 'temperatura', 626.0000, 'ºC'),
	(299065, 144, '2015-01-01 00:17:25.000000', 'temperatura', 1123.0000, 'ºC'),
	(299066, 144, '2015-01-01 00:17:26.000000', 'temperatura', 135.0000, 'ºC'),
	(299067, 144, '2015-01-01 00:17:27.000000', 'temperatura', 906.0000, 'ºC'),
	(299068, 144, '2015-01-01 00:17:28.000000', 'temperatura', 526.0000, 'ºC'),
	(299069, 144, '2015-01-01 00:17:29.000000', 'temperatura', 1114.0000, 'ºC'),
	(299070, 144, '2015-01-01 00:17:30.000000', 'temperatura', 391.0000, 'ºC'),
	(299071, 144, '2015-01-01 00:17:31.000000', 'temperatura', 1013.0000, 'ºC'),
	(299072, 144, '2015-01-01 00:17:32.000000', 'temperatura', 293.0000, 'ºC'),
	(299073, 144, '2015-01-01 00:17:33.000000', 'temperatura', 827.0000, 'ºC'),
	(299074, 144, '2015-01-01 00:17:34.000000', 'temperatura', 854.0000, 'ºC'),
	(299075, 144, '2015-01-01 00:17:35.000000', 'temperatura', 592.0000, 'ºC'),
	(299076, 144, '2015-01-01 00:17:36.000000', 'temperatura', 398.0000, 'ºC'),
	(299077, 144, '2015-01-01 00:17:37.000000', 'temperatura', 214.0000, 'ºC'),
	(299078, 144, '2015-01-01 00:17:38.000000', 'temperatura', 1077.0000, 'ºC'),
	(299079, 144, '2015-01-01 00:17:39.000000', 'temperatura', 1141.0000, 'ºC'),
	(299080, 144, '2015-01-01 00:17:40.000000', 'temperatura', 77.0000, 'ºC'),
	(299081, 144, '2015-01-01 00:17:41.000000', 'temperatura', 564.0000, 'ºC'),
	(299082, 144, '2015-01-01 00:17:42.000000', 'temperatura', 188.0000, 'ºC'),
	(299083, 144, '2015-01-01 00:17:43.000000', 'temperatura', 448.0000, 'ºC'),
	(299084, 144, '2015-01-01 00:17:44.000000', 'temperatura', 475.0000, 'ºC'),
	(299085, 144, '2015-01-01 00:17:45.000000', 'temperatura', 1032.0000, 'ºC'),
	(299086, 144, '2015-01-01 00:17:46.000000', 'temperatura', 135.0000, 'ºC'),
	(299087, 144, '2015-01-01 00:17:47.000000', 'temperatura', 1178.0000, 'ºC'),
	(299088, 144, '2015-01-01 00:17:48.000000', 'temperatura', 689.0000, 'ºC'),
	(299089, 144, '2015-01-01 00:17:49.000000', 'temperatura', 1108.0000, 'ºC'),
	(299090, 144, '2015-01-01 00:17:50.000000', 'temperatura', 1076.0000, 'ºC'),
	(299091, 144, '2015-01-01 00:17:51.000000', 'temperatura', 855.0000, 'ºC'),
	(299092, 144, '2015-01-01 00:17:52.000000', 'temperatura', 1050.0000, 'ºC'),
	(299093, 144, '2015-01-01 00:17:53.000000', 'temperatura', 284.0000, 'ºC'),
	(299094, 144, '2015-01-01 00:17:54.000000', 'temperatura', 669.0000, 'ºC'),
	(299095, 144, '2015-01-01 00:17:55.000000', 'temperatura', 97.0000, 'ºC'),
	(299096, 144, '2015-01-01 00:17:56.000000', 'temperatura', 875.0000, 'ºC'),
	(299097, 144, '2015-01-01 00:17:57.000000', 'temperatura', 485.0000, 'ºC'),
	(299098, 144, '2015-01-01 00:17:58.000000', 'temperatura', 1002.0000, 'ºC'),
	(299099, 144, '2015-01-01 00:17:59.000000', 'temperatura', 1155.0000, 'ºC'),
	(299100, 144, '2015-01-01 00:18:00.000000', 'temperatura', 369.0000, 'ºC'),
	(299101, 144, '2015-01-01 00:18:01.000000', 'temperatura', 781.0000, 'ºC'),
	(299102, 144, '2015-01-01 00:18:02.000000', 'temperatura', 397.0000, 'ºC'),
	(299103, 144, '2015-01-01 00:18:03.000000', 'temperatura', 843.0000, 'ºC'),
	(299104, 144, '2015-01-01 00:18:04.000000', 'temperatura', 624.0000, 'ºC'),
	(299105, 144, '2015-01-01 00:18:05.000000', 'temperatura', 592.0000, 'ºC'),
	(299106, 144, '2015-01-01 00:18:06.000000', 'temperatura', 1088.0000, 'ºC'),
	(299107, 144, '2015-01-01 00:18:07.000000', 'temperatura', 66.0000, 'ºC'),
	(299108, 144, '2015-01-01 00:18:08.000000', 'temperatura', 665.0000, 'ºC'),
	(299109, 144, '2015-01-01 00:18:09.000000', 'temperatura', 728.0000, 'ºC'),
	(299110, 144, '2015-01-01 00:18:10.000000', 'temperatura', 446.0000, 'ºC'),
	(299111, 144, '2015-01-01 00:18:11.000000', 'temperatura', 48.0000, 'ºC'),
	(299112, 144, '2015-01-01 00:18:12.000000', 'temperatura', 100.0000, 'ºC'),
	(299113, 144, '2015-01-01 00:18:13.000000', 'temperatura', 358.0000, 'ºC'),
	(299114, 144, '2015-01-01 00:18:14.000000', 'temperatura', 292.0000, 'ºC'),
	(299115, 144, '2015-01-01 00:18:15.000000', 'temperatura', 386.0000, 'ºC'),
	(299116, 144, '2015-01-01 00:18:16.000000', 'temperatura', 1052.0000, 'ºC'),
	(299117, 144, '2015-01-01 00:18:17.000000', 'temperatura', 505.0000, 'ºC'),
	(299118, 144, '2015-01-01 00:18:18.000000', 'temperatura', 569.0000, 'ºC'),
	(299119, 144, '2015-01-01 00:18:19.000000', 'temperatura', 128.0000, 'ºC'),
	(299120, 144, '2015-01-01 00:18:20.000000', 'temperatura', 137.0000, 'ºC'),
	(299121, 144, '2015-01-01 00:18:21.000000', 'temperatura', 300.0000, 'ºC'),
	(299122, 144, '2015-01-01 00:18:22.000000', 'temperatura', 1088.0000, 'ºC'),
	(299123, 144, '2015-01-01 00:18:23.000000', 'temperatura', 940.0000, 'ºC'),
	(299124, 144, '2015-01-01 00:18:24.000000', 'temperatura', 237.0000, 'ºC'),
	(299125, 144, '2015-01-01 00:18:25.000000', 'temperatura', 767.0000, 'ºC'),
	(299126, 144, '2015-01-01 00:18:26.000000', 'temperatura', 723.0000, 'ºC'),
	(299127, 144, '2015-01-01 00:18:27.000000', 'temperatura', 113.0000, 'ºC'),
	(299128, 144, '2015-01-01 00:18:28.000000', 'temperatura', 799.0000, 'ºC'),
	(299129, 144, '2015-01-01 00:18:29.000000', 'temperatura', 56.0000, 'ºC'),
	(299130, 144, '2015-01-01 00:18:30.000000', 'temperatura', 281.0000, 'ºC'),
	(299131, 144, '2015-01-01 00:18:31.000000', 'temperatura', 41.0000, 'ºC'),
	(299132, 144, '2015-01-01 00:18:32.000000', 'temperatura', 562.0000, 'ºC'),
	(299133, 144, '2015-01-01 00:18:33.000000', 'temperatura', 287.0000, 'ºC'),
	(299134, 144, '2015-01-01 00:18:34.000000', 'temperatura', 950.0000, 'ºC'),
	(299135, 144, '2015-01-01 00:18:35.000000', 'temperatura', 288.0000, 'ºC'),
	(299136, 144, '2015-01-01 00:18:36.000000', 'temperatura', 990.0000, 'ºC'),
	(299137, 144, '2015-01-01 00:18:37.000000', 'temperatura', 486.0000, 'ºC'),
	(299138, 144, '2015-01-01 00:18:38.000000', 'temperatura', 659.0000, 'ºC'),
	(299139, 144, '2015-01-01 00:18:39.000000', 'temperatura', 641.0000, 'ºC'),
	(299140, 144, '2015-01-01 00:18:40.000000', 'temperatura', 28.0000, 'ºC'),
	(299141, 144, '2015-01-01 00:18:41.000000', 'temperatura', 619.0000, 'ºC'),
	(299142, 144, '2015-01-01 00:18:42.000000', 'temperatura', 610.0000, 'ºC'),
	(299143, 144, '2015-01-01 00:18:43.000000', 'temperatura', 1195.0000, 'ºC'),
	(299144, 144, '2015-01-01 00:18:44.000000', 'temperatura', 543.0000, 'ºC'),
	(299145, 144, '2015-01-01 00:18:45.000000', 'temperatura', 333.0000, 'ºC'),
	(299146, 144, '2015-01-01 00:18:46.000000', 'temperatura', 36.0000, 'ºC'),
	(299147, 144, '2015-01-01 00:18:47.000000', 'temperatura', 380.0000, 'ºC'),
	(299148, 144, '2015-01-01 00:18:48.000000', 'temperatura', 593.0000, 'ºC'),
	(299149, 144, '2015-01-01 00:18:49.000000', 'temperatura', 624.0000, 'ºC'),
	(299150, 144, '2015-01-01 00:18:50.000000', 'temperatura', 142.0000, 'ºC'),
	(299151, 144, '2015-01-01 00:18:51.000000', 'temperatura', 37.0000, 'ºC'),
	(299152, 144, '2015-01-01 00:18:52.000000', 'temperatura', 960.0000, 'ºC'),
	(299153, 144, '2015-01-01 00:18:53.000000', 'temperatura', 1091.0000, 'ºC'),
	(299154, 144, '2015-01-01 00:18:54.000000', 'temperatura', 176.0000, 'ºC'),
	(299155, 144, '2015-01-01 00:18:55.000000', 'temperatura', 6.0000, 'ºC'),
	(299156, 144, '2015-01-01 00:18:56.000000', 'temperatura', 704.0000, 'ºC'),
	(299157, 144, '2015-01-01 00:18:57.000000', 'temperatura', 1100.0000, 'ºC'),
	(299158, 144, '2015-01-01 00:18:58.000000', 'temperatura', 990.0000, 'ºC'),
	(299159, 144, '2015-01-01 00:18:59.000000', 'temperatura', 451.0000, 'ºC'),
	(299160, 144, '2015-01-01 00:19:00.000000', 'temperatura', 486.0000, 'ºC'),
	(299161, 144, '2015-01-01 00:19:01.000000', 'temperatura', 1077.0000, 'ºC'),
	(299162, 144, '2015-01-01 00:19:02.000000', 'temperatura', 328.0000, 'ºC'),
	(299163, 144, '2015-01-01 00:19:03.000000', 'temperatura', 811.0000, 'ºC'),
	(299164, 144, '2015-01-01 00:19:04.000000', 'temperatura', 671.0000, 'ºC'),
	(299165, 144, '2015-01-01 00:19:05.000000', 'temperatura', 920.0000, 'ºC'),
	(299166, 144, '2015-01-01 00:19:06.000000', 'temperatura', 188.0000, 'ºC'),
	(299167, 144, '2015-01-01 00:19:07.000000', 'temperatura', 582.0000, 'ºC'),
	(299168, 144, '2015-01-01 00:19:08.000000', 'temperatura', 1144.0000, 'ºC'),
	(299169, 144, '2015-01-01 00:19:09.000000', 'temperatura', 376.0000, 'ºC'),
	(299170, 144, '2015-01-01 00:19:10.000000', 'temperatura', 846.0000, 'ºC'),
	(299171, 144, '2015-01-01 00:19:11.000000', 'temperatura', 706.0000, 'ºC'),
	(299172, 144, '2015-01-01 00:19:12.000000', 'temperatura', 990.0000, 'ºC'),
	(299173, 144, '2015-01-01 00:19:13.000000', 'temperatura', 435.0000, 'ºC'),
	(299174, 144, '2015-01-01 00:19:14.000000', 'temperatura', 403.0000, 'ºC'),
	(299175, 144, '2015-01-01 00:19:15.000000', 'temperatura', 712.0000, 'ºC'),
	(299176, 144, '2015-01-01 00:19:16.000000', 'temperatura', 1153.0000, 'ºC'),
	(299177, 144, '2015-01-01 00:19:17.000000', 'temperatura', 27.0000, 'ºC'),
	(299178, 144, '2015-01-01 00:19:18.000000', 'temperatura', 278.0000, 'ºC'),
	(299179, 144, '2015-01-01 00:19:19.000000', 'temperatura', 108.0000, 'ºC'),
	(299180, 144, '2015-01-01 00:19:20.000000', 'temperatura', 907.0000, 'ºC'),
	(299181, 144, '2015-01-01 00:19:21.000000', 'temperatura', 613.0000, 'ºC'),
	(299182, 144, '2015-01-01 00:19:22.000000', 'temperatura', 343.0000, 'ºC'),
	(299183, 144, '2015-01-01 00:19:23.000000', 'temperatura', 1079.0000, 'ºC'),
	(299184, 144, '2015-01-01 00:19:24.000000', 'temperatura', 765.0000, 'ºC'),
	(299185, 144, '2015-01-01 00:19:25.000000', 'temperatura', 589.0000, 'ºC'),
	(299186, 144, '2015-01-01 00:19:26.000000', 'temperatura', 649.0000, 'ºC'),
	(299187, 144, '2015-01-01 00:19:27.000000', 'temperatura', 277.0000, 'ºC'),
	(299188, 144, '2015-01-01 00:19:28.000000', 'temperatura', 641.0000, 'ºC'),
	(299189, 144, '2015-01-01 00:19:29.000000', 'temperatura', 1173.0000, 'ºC'),
	(299190, 144, '2015-01-01 00:19:30.000000', 'temperatura', 343.0000, 'ºC'),
	(299191, 144, '2015-01-01 00:19:31.000000', 'temperatura', 598.0000, 'ºC'),
	(299192, 144, '2015-01-01 00:19:32.000000', 'temperatura', 762.0000, 'ºC'),
	(299193, 144, '2015-01-01 00:19:33.000000', 'temperatura', 814.0000, 'ºC'),
	(299194, 144, '2015-01-01 00:19:34.000000', 'temperatura', 586.0000, 'ºC'),
	(299195, 144, '2015-01-01 00:19:35.000000', 'temperatura', 490.0000, 'ºC'),
	(299196, 144, '2015-01-01 00:19:36.000000', 'temperatura', 691.0000, 'ºC'),
	(299197, 144, '2015-01-01 00:19:37.000000', 'temperatura', 786.0000, 'ºC'),
	(299198, 144, '2015-01-01 00:19:38.000000', 'temperatura', 657.0000, 'ºC'),
	(299199, 144, '2015-01-01 00:19:39.000000', 'temperatura', 928.0000, 'ºC'),
	(299200, 144, '2015-01-01 00:19:40.000000', 'temperatura', 269.0000, 'ºC'),
	(299201, 144, '2015-01-01 00:19:41.000000', 'temperatura', 964.0000, 'ºC'),
	(299202, 144, '2015-01-01 00:19:42.000000', 'temperatura', 410.0000, 'ºC'),
	(299203, 144, '2015-01-01 00:19:43.000000', 'temperatura', 359.0000, 'ºC'),
	(299204, 144, '2015-01-01 00:19:44.000000', 'temperatura', 565.0000, 'ºC'),
	(299205, 144, '2015-01-01 00:19:45.000000', 'temperatura', 551.0000, 'ºC'),
	(299206, 144, '2015-01-01 00:19:46.000000', 'temperatura', 1059.0000, 'ºC'),
	(299207, 144, '2015-01-01 00:19:47.000000', 'temperatura', 43.0000, 'ºC'),
	(299208, 144, '2015-01-01 00:19:48.000000', 'temperatura', 639.0000, 'ºC'),
	(299209, 144, '2015-01-01 00:19:49.000000', 'temperatura', 664.0000, 'ºC'),
	(299210, 144, '2015-01-01 00:19:50.000000', 'temperatura', 206.0000, 'ºC'),
	(299211, 144, '2015-01-01 00:19:51.000000', 'temperatura', 238.0000, 'ºC'),
	(299212, 144, '2015-01-01 00:19:52.000000', 'temperatura', 571.0000, 'ºC'),
	(299213, 144, '2015-01-01 00:19:53.000000', 'temperatura', 943.0000, 'ºC'),
	(299214, 144, '2015-01-01 00:19:54.000000', 'temperatura', 601.0000, 'ºC'),
	(299215, 144, '2015-01-01 00:19:55.000000', 'temperatura', 178.0000, 'ºC'),
	(299216, 144, '2015-01-01 00:19:56.000000', 'temperatura', 287.0000, 'ºC'),
	(299217, 144, '2015-01-01 00:19:57.000000', 'temperatura', 899.0000, 'ºC'),
	(299218, 144, '2015-01-01 00:19:58.000000', 'temperatura', 38.0000, 'ºC'),
	(299219, 144, '2015-01-01 00:19:59.000000', 'temperatura', 1092.0000, 'ºC'),
	(299220, 144, '2015-01-01 00:20:00.000000', 'temperatura', 548.0000, 'ºC'),
	(299221, 144, '2015-01-01 00:20:01.000000', 'temperatura', 666.0000, 'ºC'),
	(299222, 144, '2015-01-01 00:20:02.000000', 'temperatura', 483.0000, 'ºC'),
	(299223, 144, '2015-01-01 00:20:03.000000', 'temperatura', 417.0000, 'ºC'),
	(299224, 144, '2015-01-01 00:20:04.000000', 'temperatura', 640.0000, 'ºC'),
	(299225, 144, '2015-01-01 00:20:05.000000', 'temperatura', 746.0000, 'ºC'),
	(299226, 144, '2015-01-01 00:20:06.000000', 'temperatura', 612.0000, 'ºC'),
	(299227, 144, '2015-01-01 00:20:07.000000', 'temperatura', 824.0000, 'ºC'),
	(299228, 144, '2015-01-01 00:20:08.000000', 'temperatura', 1082.0000, 'ºC'),
	(299229, 144, '2015-01-01 00:20:09.000000', 'temperatura', 538.0000, 'ºC'),
	(299230, 144, '2015-01-01 00:20:10.000000', 'temperatura', 646.0000, 'ºC'),
	(299231, 144, '2015-01-01 00:20:11.000000', 'temperatura', 418.0000, 'ºC'),
	(299232, 144, '2015-01-01 00:20:12.000000', 'temperatura', 151.0000, 'ºC'),
	(299233, 144, '2015-01-01 00:20:13.000000', 'temperatura', 700.0000, 'ºC'),
	(299234, 144, '2015-01-01 00:20:14.000000', 'temperatura', 650.0000, 'ºC'),
	(299235, 144, '2015-01-01 00:20:15.000000', 'temperatura', 1148.0000, 'ºC'),
	(299236, 144, '2015-01-01 00:20:16.000000', 'temperatura', 193.0000, 'ºC'),
	(299237, 144, '2015-01-01 00:20:17.000000', 'temperatura', 1121.0000, 'ºC'),
	(299238, 144, '2015-01-01 00:20:18.000000', 'temperatura', 227.0000, 'ºC'),
	(299239, 144, '2015-01-01 00:20:19.000000', 'temperatura', 171.0000, 'ºC'),
	(299240, 144, '2015-01-01 00:20:20.000000', 'temperatura', 177.0000, 'ºC'),
	(299241, 144, '2015-01-01 00:20:21.000000', 'temperatura', 372.0000, 'ºC'),
	(299242, 144, '2015-01-01 00:20:22.000000', 'temperatura', 128.0000, 'ºC'),
	(299243, 144, '2015-01-01 00:20:23.000000', 'temperatura', 727.0000, 'ºC'),
	(299244, 144, '2015-01-01 00:20:24.000000', 'temperatura', 850.0000, 'ºC'),
	(299245, 144, '2015-01-01 00:20:25.000000', 'temperatura', 868.0000, 'ºC'),
	(299246, 144, '2015-01-01 00:20:26.000000', 'temperatura', 594.0000, 'ºC'),
	(299247, 144, '2015-01-01 00:20:27.000000', 'temperatura', 363.0000, 'ºC'),
	(299248, 144, '2015-01-01 00:20:28.000000', 'temperatura', 35.0000, 'ºC'),
	(299249, 144, '2015-01-01 00:20:29.000000', 'temperatura', 285.0000, 'ºC'),
	(299250, 144, '2015-01-01 00:20:30.000000', 'temperatura', 121.0000, 'ºC'),
	(299251, 144, '2015-01-01 00:20:31.000000', 'temperatura', 951.0000, 'ºC'),
	(299252, 144, '2015-01-01 00:20:32.000000', 'temperatura', 793.0000, 'ºC'),
	(299253, 144, '2015-01-01 00:20:33.000000', 'temperatura', 1114.0000, 'ºC'),
	(299254, 144, '2015-01-01 00:20:34.000000', 'temperatura', 788.0000, 'ºC'),
	(299255, 144, '2015-01-01 00:20:35.000000', 'temperatura', 600.0000, 'ºC'),
	(299256, 144, '2015-01-01 00:20:36.000000', 'temperatura', 638.0000, 'ºC'),
	(299257, 144, '2015-01-01 00:20:37.000000', 'temperatura', 189.0000, 'ºC'),
	(299258, 144, '2015-01-01 00:20:38.000000', 'temperatura', 233.0000, 'ºC'),
	(299259, 144, '2015-01-01 00:20:39.000000', 'temperatura', 598.0000, 'ºC'),
	(299260, 144, '2015-01-01 00:20:40.000000', 'temperatura', 1090.0000, 'ºC'),
	(299261, 144, '2015-01-01 00:20:41.000000', 'temperatura', 56.0000, 'ºC'),
	(299262, 144, '2015-01-01 00:20:42.000000', 'temperatura', 609.0000, 'ºC'),
	(299263, 144, '2015-01-01 00:20:43.000000', 'temperatura', 481.0000, 'ºC'),
	(299264, 144, '2015-01-01 00:20:44.000000', 'temperatura', 579.0000, 'ºC'),
	(299265, 144, '2015-01-01 00:20:45.000000', 'temperatura', 250.0000, 'ºC'),
	(299266, 144, '2015-01-01 00:20:46.000000', 'temperatura', 716.0000, 'ºC'),
	(299267, 144, '2015-01-01 00:20:47.000000', 'temperatura', 429.0000, 'ºC'),
	(299268, 144, '2015-01-01 00:20:48.000000', 'temperatura', 1198.0000, 'ºC'),
	(299269, 144, '2015-01-01 00:20:49.000000', 'temperatura', 1105.0000, 'ºC'),
	(299270, 144, '2015-01-01 00:20:50.000000', 'temperatura', 731.0000, 'ºC'),
	(299271, 144, '2015-01-01 00:20:51.000000', 'temperatura', 341.0000, 'ºC'),
	(299272, 144, '2015-01-01 00:20:52.000000', 'temperatura', 713.0000, 'ºC'),
	(299273, 144, '2015-01-01 00:20:53.000000', 'temperatura', 140.0000, 'ºC'),
	(299274, 144, '2015-01-01 00:20:54.000000', 'temperatura', 963.0000, 'ºC'),
	(299275, 144, '2015-01-01 00:20:55.000000', 'temperatura', 796.0000, 'ºC'),
	(299276, 144, '2015-01-01 00:20:56.000000', 'temperatura', 1093.0000, 'ºC'),
	(299277, 144, '2015-01-01 00:20:57.000000', 'temperatura', 675.0000, 'ºC'),
	(299278, 144, '2015-01-01 00:20:58.000000', 'temperatura', 99.0000, 'ºC'),
	(299279, 144, '2015-01-01 00:20:59.000000', 'temperatura', 870.0000, 'ºC'),
	(299280, 144, '2015-01-01 00:21:00.000000', 'temperatura', 453.0000, 'ºC'),
	(299281, 144, '2015-01-01 00:21:01.000000', 'temperatura', 855.0000, 'ºC'),
	(299282, 144, '2015-01-01 00:21:02.000000', 'temperatura', 517.0000, 'ºC'),
	(299283, 144, '2015-01-01 00:21:03.000000', 'temperatura', 20.0000, 'ºC'),
	(299284, 144, '2015-01-01 00:21:04.000000', 'temperatura', 951.0000, 'ºC'),
	(299285, 144, '2015-01-01 00:21:05.000000', 'temperatura', 1093.0000, 'ºC'),
	(299286, 144, '2015-01-01 00:21:06.000000', 'temperatura', 212.0000, 'ºC'),
	(299287, 144, '2015-01-01 00:21:07.000000', 'temperatura', 183.0000, 'ºC'),
	(299288, 144, '2015-01-01 00:21:08.000000', 'temperatura', 277.0000, 'ºC'),
	(299289, 144, '2015-01-01 00:21:09.000000', 'temperatura', 839.0000, 'ºC'),
	(299290, 144, '2015-01-01 00:21:10.000000', 'temperatura', 964.0000, 'ºC'),
	(299291, 144, '2015-01-01 00:21:11.000000', 'temperatura', 1103.0000, 'ºC'),
	(299292, 144, '2015-01-01 00:21:12.000000', 'temperatura', 223.0000, 'ºC'),
	(299293, 144, '2015-01-01 00:21:13.000000', 'temperatura', 207.0000, 'ºC'),
	(299294, 144, '2015-01-01 00:21:14.000000', 'temperatura', 368.0000, 'ºC'),
	(299295, 144, '2015-01-01 00:21:15.000000', 'temperatura', 19.0000, 'ºC'),
	(299296, 144, '2015-01-01 00:21:16.000000', 'temperatura', 192.0000, 'ºC'),
	(299297, 144, '2015-01-01 00:21:17.000000', 'temperatura', 902.0000, 'ºC'),
	(299298, 144, '2015-01-01 00:21:18.000000', 'temperatura', 335.0000, 'ºC'),
	(299299, 144, '2015-01-01 00:21:19.000000', 'temperatura', 168.0000, 'ºC'),
	(299300, 144, '2015-01-01 00:21:20.000000', 'temperatura', 1038.0000, 'ºC'),
	(299301, 144, '2015-01-01 00:21:21.000000', 'temperatura', 1085.0000, 'ºC'),
	(299302, 144, '2015-01-01 00:21:22.000000', 'temperatura', 1112.0000, 'ºC'),
	(299303, 144, '2015-01-01 00:21:23.000000', 'temperatura', 1107.0000, 'ºC'),
	(299304, 144, '2015-01-01 00:21:24.000000', 'temperatura', 997.0000, 'ºC'),
	(299305, 144, '2015-01-01 00:21:25.000000', 'temperatura', 465.0000, 'ºC'),
	(299306, 144, '2015-01-01 00:21:26.000000', 'temperatura', 537.0000, 'ºC'),
	(299307, 144, '2015-01-01 00:21:27.000000', 'temperatura', 88.0000, 'ºC'),
	(299308, 144, '2015-01-01 00:21:28.000000', 'temperatura', 32.0000, 'ºC'),
	(299309, 144, '2015-01-01 00:21:29.000000', 'temperatura', 1096.0000, 'ºC'),
	(299310, 144, '2015-01-01 00:21:30.000000', 'temperatura', 586.0000, 'ºC'),
	(299311, 144, '2015-01-01 00:21:31.000000', 'temperatura', 841.0000, 'ºC'),
	(299312, 144, '2015-01-01 00:21:32.000000', 'temperatura', 46.0000, 'ºC'),
	(299313, 144, '2015-01-01 00:21:33.000000', 'temperatura', 107.0000, 'ºC'),
	(299314, 144, '2015-01-01 00:21:34.000000', 'temperatura', 397.0000, 'ºC'),
	(299315, 144, '2015-01-01 00:21:35.000000', 'temperatura', 464.0000, 'ºC'),
	(299316, 144, '2015-01-01 00:21:36.000000', 'temperatura', 1131.0000, 'ºC'),
	(299317, 144, '2015-01-01 00:21:37.000000', 'temperatura', 662.0000, 'ºC'),
	(299318, 144, '2015-01-01 00:21:38.000000', 'temperatura', 1118.0000, 'ºC'),
	(299319, 144, '2015-01-01 00:21:39.000000', 'temperatura', 3.0000, 'ºC'),
	(299320, 144, '2015-01-01 00:21:40.000000', 'temperatura', 262.0000, 'ºC'),
	(299321, 144, '2015-01-01 00:21:41.000000', 'temperatura', 102.0000, 'ºC'),
	(299322, 144, '2015-01-01 00:21:42.000000', 'temperatura', 925.0000, 'ºC'),
	(299323, 144, '2015-01-01 00:21:43.000000', 'temperatura', 719.0000, 'ºC'),
	(299324, 144, '2015-01-01 00:21:44.000000', 'temperatura', 822.0000, 'ºC'),
	(299325, 144, '2015-01-01 00:21:45.000000', 'temperatura', 752.0000, 'ºC'),
	(299326, 144, '2015-01-01 00:21:46.000000', 'temperatura', 96.0000, 'ºC'),
	(299327, 144, '2015-01-01 00:21:47.000000', 'temperatura', 625.0000, 'ºC'),
	(299328, 144, '2015-01-01 00:21:48.000000', 'temperatura', 436.0000, 'ºC'),
	(299329, 144, '2015-01-01 00:21:49.000000', 'temperatura', 305.0000, 'ºC'),
	(299330, 144, '2015-01-01 00:21:50.000000', 'temperatura', 220.0000, 'ºC'),
	(299331, 144, '2015-01-01 00:21:51.000000', 'temperatura', 185.0000, 'ºC'),
	(299332, 144, '2015-01-01 00:21:52.000000', 'temperatura', 264.0000, 'ºC'),
	(299333, 144, '2015-01-01 00:21:53.000000', 'temperatura', 765.0000, 'ºC'),
	(299334, 144, '2015-01-01 00:21:54.000000', 'temperatura', 634.0000, 'ºC'),
	(299335, 144, '2015-01-01 00:21:55.000000', 'temperatura', 874.0000, 'ºC'),
	(299336, 144, '2015-01-01 00:21:56.000000', 'temperatura', 71.0000, 'ºC'),
	(299337, 144, '2015-01-01 00:21:57.000000', 'temperatura', 134.0000, 'ºC'),
	(299338, 144, '2015-01-01 00:21:58.000000', 'temperatura', 455.0000, 'ºC'),
	(299339, 144, '2015-01-01 00:21:59.000000', 'temperatura', 674.0000, 'ºC'),
	(299340, 144, '2015-01-01 00:22:00.000000', 'temperatura', 806.0000, 'ºC'),
	(299341, 144, '2015-01-01 00:22:01.000000', 'temperatura', 807.0000, 'ºC'),
	(299342, 144, '2015-01-01 00:22:02.000000', 'temperatura', 420.0000, 'ºC'),
	(299343, 144, '2015-01-01 00:22:03.000000', 'temperatura', 877.0000, 'ºC'),
	(299344, 144, '2015-01-01 00:22:04.000000', 'temperatura', 725.0000, 'ºC'),
	(299345, 144, '2015-01-01 00:22:05.000000', 'temperatura', 993.0000, 'ºC'),
	(299346, 144, '2015-01-01 00:22:06.000000', 'temperatura', 394.0000, 'ºC'),
	(299347, 144, '2015-01-01 00:22:07.000000', 'temperatura', 191.0000, 'ºC'),
	(299348, 144, '2015-01-01 00:22:08.000000', 'temperatura', 974.0000, 'ºC'),
	(299349, 144, '2015-01-01 00:22:09.000000', 'temperatura', 696.0000, 'ºC'),
	(299350, 144, '2015-01-01 00:22:10.000000', 'temperatura', 560.0000, 'ºC'),
	(299351, 144, '2015-01-01 00:22:11.000000', 'temperatura', 711.0000, 'ºC'),
	(299352, 144, '2015-01-01 00:22:12.000000', 'temperatura', 675.0000, 'ºC'),
	(299353, 144, '2015-01-01 00:22:13.000000', 'temperatura', 45.0000, 'ºC'),
	(299354, 144, '2015-01-01 00:22:14.000000', 'temperatura', 597.0000, 'ºC'),
	(299355, 144, '2015-01-01 00:22:15.000000', 'temperatura', 453.0000, 'ºC'),
	(299356, 144, '2015-01-01 00:22:16.000000', 'temperatura', 474.0000, 'ºC'),
	(299357, 144, '2015-01-01 00:22:17.000000', 'temperatura', 1012.0000, 'ºC'),
	(299358, 144, '2015-01-01 00:22:18.000000', 'temperatura', 38.0000, 'ºC'),
	(299359, 144, '2015-01-01 00:22:19.000000', 'temperatura', 756.0000, 'ºC'),
	(299360, 144, '2015-01-01 00:22:20.000000', 'temperatura', 65.0000, 'ºC'),
	(299361, 144, '2015-01-01 00:22:21.000000', 'temperatura', 458.0000, 'ºC'),
	(299362, 144, '2015-01-01 00:22:22.000000', 'temperatura', 896.0000, 'ºC'),
	(299363, 144, '2015-01-01 00:22:23.000000', 'temperatura', 705.0000, 'ºC'),
	(299364, 144, '2015-01-01 00:22:24.000000', 'temperatura', 840.0000, 'ºC'),
	(299365, 144, '2015-01-01 00:22:25.000000', 'temperatura', 886.0000, 'ºC'),
	(299366, 144, '2015-01-01 00:22:26.000000', 'temperatura', 709.0000, 'ºC'),
	(299367, 144, '2015-01-01 00:22:27.000000', 'temperatura', 887.0000, 'ºC'),
	(299368, 144, '2015-01-01 00:22:28.000000', 'temperatura', 1109.0000, 'ºC'),
	(299369, 144, '2015-01-01 00:22:29.000000', 'temperatura', 486.0000, 'ºC'),
	(299370, 144, '2015-01-01 00:22:30.000000', 'temperatura', 304.0000, 'ºC'),
	(299371, 144, '2015-01-01 00:22:31.000000', 'temperatura', 63.0000, 'ºC'),
	(299372, 144, '2015-01-01 00:22:32.000000', 'temperatura', 601.0000, 'ºC'),
	(299373, 144, '2015-01-01 00:22:33.000000', 'temperatura', 417.0000, 'ºC'),
	(299374, 144, '2015-01-01 00:22:34.000000', 'temperatura', 282.0000, 'ºC'),
	(299375, 144, '2015-01-01 00:22:35.000000', 'temperatura', 159.0000, 'ºC'),
	(299376, 144, '2015-01-01 00:22:36.000000', 'temperatura', 1151.0000, 'ºC'),
	(299377, 144, '2015-01-01 00:22:37.000000', 'temperatura', 479.0000, 'ºC'),
	(299378, 144, '2015-01-01 00:22:38.000000', 'temperatura', 141.0000, 'ºC'),
	(299379, 144, '2015-01-01 00:22:39.000000', 'temperatura', 467.0000, 'ºC'),
	(299380, 144, '2015-01-01 00:22:40.000000', 'temperatura', 715.0000, 'ºC'),
	(299381, 144, '2015-01-01 00:22:41.000000', 'temperatura', 974.0000, 'ºC'),
	(299382, 144, '2015-01-01 00:22:42.000000', 'temperatura', 327.0000, 'ºC'),
	(299383, 144, '2015-01-01 00:22:43.000000', 'temperatura', 1113.0000, 'ºC'),
	(299384, 144, '2015-01-01 00:22:44.000000', 'temperatura', 982.0000, 'ºC'),
	(299385, 144, '2015-01-01 00:22:45.000000', 'temperatura', 375.0000, 'ºC'),
	(299386, 144, '2015-01-01 00:22:46.000000', 'temperatura', 126.0000, 'ºC'),
	(299387, 144, '2015-01-01 00:22:47.000000', 'temperatura', 708.0000, 'ºC'),
	(299388, 144, '2015-01-01 00:22:48.000000', 'temperatura', 762.0000, 'ºC'),
	(299389, 144, '2015-01-01 00:22:49.000000', 'temperatura', 485.0000, 'ºC'),
	(299390, 144, '2015-01-01 00:22:50.000000', 'temperatura', 141.0000, 'ºC'),
	(299391, 144, '2015-01-01 00:22:51.000000', 'temperatura', 448.0000, 'ºC'),
	(299392, 144, '2015-01-01 00:22:52.000000', 'temperatura', 621.0000, 'ºC'),
	(299393, 144, '2015-01-01 00:22:53.000000', 'temperatura', 558.0000, 'ºC'),
	(299394, 144, '2015-01-01 00:22:54.000000', 'temperatura', 930.0000, 'ºC'),
	(299395, 144, '2015-01-01 00:22:55.000000', 'temperatura', 577.0000, 'ºC'),
	(299396, 144, '2015-01-01 00:22:56.000000', 'temperatura', 95.0000, 'ºC'),
	(299397, 144, '2015-01-01 00:22:57.000000', 'temperatura', 1145.0000, 'ºC'),
	(299398, 144, '2015-01-01 00:22:58.000000', 'temperatura', 640.0000, 'ºC'),
	(299399, 144, '2015-01-01 00:22:59.000000', 'temperatura', 966.0000, 'ºC'),
	(299400, 144, '2015-01-01 00:23:00.000000', 'temperatura', 509.0000, 'ºC'),
	(299401, 144, '2015-01-01 00:23:01.000000', 'temperatura', 849.0000, 'ºC'),
	(299402, 144, '2015-01-01 00:23:02.000000', 'temperatura', 317.0000, 'ºC'),
	(299403, 144, '2015-01-01 00:23:03.000000', 'temperatura', 241.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(299404, 144, '2015-01-01 00:23:04.000000', 'temperatura', 253.0000, 'ºC'),
	(299405, 144, '2015-01-01 00:23:05.000000', 'temperatura', 542.0000, 'ºC'),
	(299406, 144, '2015-01-01 00:23:06.000000', 'temperatura', 753.0000, 'ºC'),
	(299407, 144, '2015-01-01 00:23:07.000000', 'temperatura', 939.0000, 'ºC'),
	(299408, 144, '2015-01-01 00:23:08.000000', 'temperatura', 38.0000, 'ºC'),
	(299409, 144, '2015-01-01 00:23:09.000000', 'temperatura', 972.0000, 'ºC'),
	(299410, 144, '2015-01-01 00:23:10.000000', 'temperatura', 1146.0000, 'ºC'),
	(299411, 144, '2015-01-01 00:23:11.000000', 'temperatura', 413.0000, 'ºC'),
	(299412, 144, '2015-01-01 00:23:12.000000', 'temperatura', 1031.0000, 'ºC'),
	(299413, 144, '2015-01-01 00:23:13.000000', 'temperatura', 315.0000, 'ºC'),
	(299414, 144, '2015-01-01 00:23:14.000000', 'temperatura', 883.0000, 'ºC'),
	(299415, 144, '2015-01-01 00:23:15.000000', 'temperatura', 1072.0000, 'ºC'),
	(299416, 144, '2015-01-01 00:23:16.000000', 'temperatura', 308.0000, 'ºC'),
	(299417, 144, '2015-01-01 00:23:17.000000', 'temperatura', 728.0000, 'ºC'),
	(299418, 144, '2015-01-01 00:23:18.000000', 'temperatura', 314.0000, 'ºC'),
	(299419, 144, '2015-01-01 00:23:19.000000', 'temperatura', 585.0000, 'ºC'),
	(299420, 144, '2015-01-01 00:23:20.000000', 'temperatura', 787.0000, 'ºC'),
	(299421, 144, '2015-01-01 00:23:21.000000', 'temperatura', 978.0000, 'ºC'),
	(299422, 144, '2015-01-01 00:23:22.000000', 'temperatura', 131.0000, 'ºC'),
	(299423, 144, '2015-01-01 00:23:23.000000', 'temperatura', 123.0000, 'ºC'),
	(299424, 144, '2015-01-01 00:23:24.000000', 'temperatura', 221.0000, 'ºC'),
	(299425, 144, '2015-01-01 00:23:25.000000', 'temperatura', 735.0000, 'ºC'),
	(299426, 144, '2015-01-01 00:23:26.000000', 'temperatura', 615.0000, 'ºC'),
	(299427, 144, '2015-01-01 00:23:27.000000', 'temperatura', 869.0000, 'ºC'),
	(299428, 144, '2015-01-01 00:23:28.000000', 'temperatura', 101.0000, 'ºC'),
	(299429, 144, '2015-01-01 00:23:29.000000', 'temperatura', 298.0000, 'ºC'),
	(299430, 144, '2015-01-01 00:23:30.000000', 'temperatura', 1186.0000, 'ºC'),
	(299431, 144, '2015-01-01 00:23:31.000000', 'temperatura', 238.0000, 'ºC'),
	(299432, 144, '2015-01-01 00:23:32.000000', 'temperatura', 33.0000, 'ºC'),
	(299433, 144, '2015-01-01 00:23:33.000000', 'temperatura', 649.0000, 'ºC'),
	(299434, 144, '2015-01-01 00:23:34.000000', 'temperatura', 748.0000, 'ºC'),
	(299435, 144, '2015-01-01 00:23:35.000000', 'temperatura', 595.0000, 'ºC'),
	(299436, 144, '2015-01-01 00:23:36.000000', 'temperatura', 729.0000, 'ºC'),
	(299437, 144, '2015-01-01 00:23:37.000000', 'temperatura', 661.0000, 'ºC'),
	(299438, 144, '2015-01-01 00:23:38.000000', 'temperatura', 1120.0000, 'ºC'),
	(299439, 144, '2015-01-01 00:23:39.000000', 'temperatura', 16.0000, 'ºC'),
	(299440, 144, '2015-01-01 00:23:40.000000', 'temperatura', 322.0000, 'ºC'),
	(299441, 144, '2015-01-01 00:23:41.000000', 'temperatura', 363.0000, 'ºC'),
	(299442, 144, '2015-01-01 00:23:42.000000', 'temperatura', 847.0000, 'ºC'),
	(299443, 144, '2015-01-01 00:23:43.000000', 'temperatura', 747.0000, 'ºC'),
	(299444, 144, '2015-01-01 00:23:44.000000', 'temperatura', 1194.0000, 'ºC'),
	(299445, 144, '2015-01-01 00:23:45.000000', 'temperatura', 129.0000, 'ºC'),
	(299446, 144, '2015-01-01 00:23:46.000000', 'temperatura', 663.0000, 'ºC'),
	(299447, 144, '2015-01-01 00:23:47.000000', 'temperatura', 528.0000, 'ºC'),
	(299448, 144, '2015-01-01 00:23:48.000000', 'temperatura', 651.0000, 'ºC'),
	(299449, 144, '2015-01-01 00:23:49.000000', 'temperatura', 472.0000, 'ºC'),
	(299450, 144, '2015-01-01 00:23:50.000000', 'temperatura', 408.0000, 'ºC'),
	(299451, 144, '2015-01-01 00:23:51.000000', 'temperatura', 625.0000, 'ºC'),
	(299452, 144, '2015-01-01 00:23:52.000000', 'temperatura', 703.0000, 'ºC'),
	(299453, 144, '2015-01-01 00:23:53.000000', 'temperatura', 438.0000, 'ºC'),
	(299454, 144, '2015-01-01 00:23:54.000000', 'temperatura', 84.0000, 'ºC'),
	(299455, 144, '2015-01-01 00:23:55.000000', 'temperatura', 306.0000, 'ºC'),
	(299456, 144, '2015-01-01 00:23:56.000000', 'temperatura', 80.0000, 'ºC'),
	(299457, 144, '2015-01-01 00:23:57.000000', 'temperatura', 679.0000, 'ºC'),
	(299458, 144, '2015-01-01 00:23:58.000000', 'temperatura', 757.0000, 'ºC'),
	(299459, 144, '2015-01-01 00:23:59.000000', 'temperatura', 550.0000, 'ºC'),
	(299460, 144, '2015-01-01 00:24:00.000000', 'temperatura', 479.0000, 'ºC'),
	(299461, 144, '2015-01-01 00:24:01.000000', 'temperatura', 745.0000, 'ºC'),
	(299462, 144, '2015-01-01 00:24:02.000000', 'temperatura', 1088.0000, 'ºC'),
	(299463, 144, '2015-01-01 00:24:03.000000', 'temperatura', 806.0000, 'ºC'),
	(299464, 144, '2015-01-01 00:24:04.000000', 'temperatura', 765.0000, 'ºC'),
	(299465, 144, '2015-01-01 00:24:05.000000', 'temperatura', 207.0000, 'ºC'),
	(299466, 144, '2015-01-01 00:24:06.000000', 'temperatura', 1141.0000, 'ºC'),
	(299467, 144, '2015-01-01 00:24:07.000000', 'temperatura', 286.0000, 'ºC'),
	(299468, 144, '2015-01-01 00:24:08.000000', 'temperatura', 405.0000, 'ºC'),
	(299469, 144, '2015-01-01 00:24:09.000000', 'temperatura', 1171.0000, 'ºC'),
	(299470, 144, '2015-01-01 00:24:10.000000', 'temperatura', 1037.0000, 'ºC'),
	(299471, 144, '2015-01-01 00:24:11.000000', 'temperatura', 476.0000, 'ºC'),
	(299472, 144, '2015-01-01 00:24:12.000000', 'temperatura', 466.0000, 'ºC'),
	(299473, 144, '2015-01-01 00:24:13.000000', 'temperatura', 904.0000, 'ºC'),
	(299474, 144, '2015-01-01 00:24:14.000000', 'temperatura', 724.0000, 'ºC'),
	(299475, 144, '2015-01-01 00:24:15.000000', 'temperatura', 907.0000, 'ºC'),
	(299476, 144, '2015-01-01 00:24:16.000000', 'temperatura', 1165.0000, 'ºC'),
	(299477, 144, '2015-01-01 00:24:17.000000', 'temperatura', 704.0000, 'ºC'),
	(299478, 144, '2015-01-01 00:24:18.000000', 'temperatura', 24.0000, 'ºC'),
	(299479, 144, '2015-01-01 00:24:19.000000', 'temperatura', 408.0000, 'ºC'),
	(299480, 144, '2015-01-01 00:24:20.000000', 'temperatura', 768.0000, 'ºC'),
	(299481, 144, '2015-01-01 00:24:21.000000', 'temperatura', 216.0000, 'ºC'),
	(299482, 144, '2015-01-01 00:24:22.000000', 'temperatura', 1179.0000, 'ºC'),
	(299483, 144, '2015-01-01 00:24:23.000000', 'temperatura', 445.0000, 'ºC'),
	(299484, 144, '2015-01-01 00:24:24.000000', 'temperatura', 1090.0000, 'ºC'),
	(299485, 144, '2015-01-01 00:24:25.000000', 'temperatura', 515.0000, 'ºC'),
	(299486, 144, '2015-01-01 00:24:26.000000', 'temperatura', 505.0000, 'ºC'),
	(299487, 144, '2015-01-01 00:24:27.000000', 'temperatura', 980.0000, 'ºC'),
	(299488, 144, '2015-01-01 00:24:28.000000', 'temperatura', 986.0000, 'ºC'),
	(299489, 144, '2015-01-01 00:24:29.000000', 'temperatura', 789.0000, 'ºC'),
	(299490, 144, '2015-01-01 00:24:30.000000', 'temperatura', 987.0000, 'ºC'),
	(299491, 144, '2015-01-01 00:24:31.000000', 'temperatura', 170.0000, 'ºC'),
	(299492, 144, '2015-01-01 00:24:32.000000', 'temperatura', 290.0000, 'ºC'),
	(299493, 144, '2015-01-01 00:24:33.000000', 'temperatura', 938.0000, 'ºC'),
	(299494, 144, '2015-01-01 00:24:34.000000', 'temperatura', 223.0000, 'ºC'),
	(299495, 144, '2015-01-01 00:24:35.000000', 'temperatura', 702.0000, 'ºC'),
	(299496, 144, '2015-01-01 00:24:36.000000', 'temperatura', 442.0000, 'ºC'),
	(299497, 144, '2015-01-01 00:24:37.000000', 'temperatura', 104.0000, 'ºC'),
	(299498, 144, '2015-01-01 00:24:38.000000', 'temperatura', 394.0000, 'ºC'),
	(299499, 144, '2015-01-01 00:24:39.000000', 'temperatura', 458.0000, 'ºC'),
	(299500, 144, '2015-01-01 00:24:40.000000', 'temperatura', 1107.0000, 'ºC'),
	(299501, 144, '2015-01-01 00:24:41.000000', 'temperatura', 563.0000, 'ºC'),
	(299502, 144, '2015-01-01 00:24:42.000000', 'temperatura', 695.0000, 'ºC'),
	(299503, 144, '2015-01-01 00:24:43.000000', 'temperatura', 585.0000, 'ºC'),
	(299504, 144, '2015-01-01 00:24:44.000000', 'temperatura', 842.0000, 'ºC'),
	(299505, 144, '2015-01-01 00:24:45.000000', 'temperatura', 57.0000, 'ºC'),
	(299506, 144, '2015-01-01 00:24:46.000000', 'temperatura', 156.0000, 'ºC'),
	(299507, 144, '2015-01-01 00:24:47.000000', 'temperatura', 612.0000, 'ºC'),
	(299508, 144, '2015-01-01 00:24:48.000000', 'temperatura', 194.0000, 'ºC'),
	(299509, 144, '2015-01-01 00:24:49.000000', 'temperatura', 331.0000, 'ºC'),
	(299510, 144, '2015-01-01 00:24:50.000000', 'temperatura', 1076.0000, 'ºC'),
	(299511, 144, '2015-01-01 00:24:51.000000', 'temperatura', 786.0000, 'ºC'),
	(299512, 144, '2015-01-01 00:24:52.000000', 'temperatura', 704.0000, 'ºC'),
	(299513, 144, '2015-01-01 00:24:53.000000', 'temperatura', 1160.0000, 'ºC'),
	(299514, 144, '2015-01-01 00:24:54.000000', 'temperatura', 89.0000, 'ºC'),
	(299515, 144, '2015-01-01 00:24:55.000000', 'temperatura', 568.0000, 'ºC'),
	(299516, 144, '2015-01-01 00:24:56.000000', 'temperatura', 171.0000, 'ºC'),
	(299517, 144, '2015-01-01 00:24:57.000000', 'temperatura', 351.0000, 'ºC'),
	(299518, 144, '2015-01-01 00:24:58.000000', 'temperatura', 45.0000, 'ºC'),
	(299519, 144, '2015-01-01 00:24:59.000000', 'temperatura', 369.0000, 'ºC'),
	(299520, 144, '2015-01-01 00:25:00.000000', 'temperatura', 514.0000, 'ºC'),
	(299521, 144, '2015-01-01 00:25:01.000000', 'temperatura', 261.0000, 'ºC'),
	(299522, 144, '2015-01-01 00:25:02.000000', 'temperatura', 966.0000, 'ºC'),
	(299523, 144, '2015-01-01 00:25:03.000000', 'temperatura', 445.0000, 'ºC'),
	(299524, 144, '2015-01-01 00:25:04.000000', 'temperatura', 530.0000, 'ºC'),
	(299525, 144, '2015-01-01 00:25:05.000000', 'temperatura', 115.0000, 'ºC'),
	(299526, 144, '2015-01-01 00:25:06.000000', 'temperatura', 186.0000, 'ºC'),
	(299527, 144, '2015-01-01 00:25:07.000000', 'temperatura', 583.0000, 'ºC'),
	(299528, 144, '2015-01-01 00:25:08.000000', 'temperatura', 1158.0000, 'ºC'),
	(299529, 144, '2015-01-01 00:25:09.000000', 'temperatura', 444.0000, 'ºC'),
	(299530, 144, '2015-01-01 00:25:10.000000', 'temperatura', 1144.0000, 'ºC'),
	(299531, 144, '2015-01-01 00:25:11.000000', 'temperatura', 787.0000, 'ºC'),
	(299532, 144, '2015-01-01 00:25:12.000000', 'temperatura', 506.0000, 'ºC'),
	(299533, 144, '2015-01-01 00:25:13.000000', 'temperatura', 170.0000, 'ºC'),
	(299534, 144, '2015-01-01 00:25:14.000000', 'temperatura', 530.0000, 'ºC'),
	(299535, 144, '2015-01-01 00:25:15.000000', 'temperatura', 944.0000, 'ºC'),
	(299536, 144, '2015-01-01 00:25:16.000000', 'temperatura', 728.0000, 'ºC'),
	(299537, 144, '2015-01-01 00:25:17.000000', 'temperatura', 809.0000, 'ºC'),
	(299538, 144, '2015-01-01 00:25:18.000000', 'temperatura', 662.0000, 'ºC'),
	(299539, 144, '2015-01-01 00:25:19.000000', 'temperatura', 885.0000, 'ºC'),
	(299540, 144, '2015-01-01 00:25:20.000000', 'temperatura', 40.0000, 'ºC'),
	(299541, 144, '2015-01-01 00:25:21.000000', 'temperatura', 1143.0000, 'ºC'),
	(299542, 144, '2015-01-01 00:25:22.000000', 'temperatura', 796.0000, 'ºC'),
	(299543, 144, '2015-01-01 00:25:23.000000', 'temperatura', 552.0000, 'ºC'),
	(299544, 144, '2015-01-01 00:25:24.000000', 'temperatura', 372.0000, 'ºC'),
	(299545, 144, '2015-01-01 00:25:25.000000', 'temperatura', 205.0000, 'ºC'),
	(299546, 144, '2015-01-01 00:25:26.000000', 'temperatura', 1110.0000, 'ºC'),
	(299547, 144, '2015-01-01 00:25:27.000000', 'temperatura', 136.0000, 'ºC'),
	(299548, 144, '2015-01-01 00:25:28.000000', 'temperatura', 950.0000, 'ºC'),
	(299549, 144, '2015-01-01 00:25:29.000000', 'temperatura', 741.0000, 'ºC'),
	(299550, 144, '2015-01-01 00:25:30.000000', 'temperatura', 858.0000, 'ºC'),
	(299551, 144, '2015-01-01 00:25:31.000000', 'temperatura', 867.0000, 'ºC'),
	(299552, 144, '2015-01-01 00:25:32.000000', 'temperatura', 563.0000, 'ºC'),
	(299553, 144, '2015-01-01 00:25:33.000000', 'temperatura', 212.0000, 'ºC'),
	(299554, 144, '2015-01-01 00:25:34.000000', 'temperatura', 573.0000, 'ºC'),
	(299555, 144, '2015-01-01 00:25:35.000000', 'temperatura', 1029.0000, 'ºC'),
	(299556, 144, '2015-01-01 00:25:36.000000', 'temperatura', 1026.0000, 'ºC'),
	(299557, 144, '2015-01-01 00:25:37.000000', 'temperatura', 845.0000, 'ºC'),
	(299558, 144, '2015-01-01 00:25:38.000000', 'temperatura', 1149.0000, 'ºC'),
	(299559, 144, '2015-01-01 00:25:39.000000', 'temperatura', 808.0000, 'ºC'),
	(299560, 144, '2015-01-01 00:25:40.000000', 'temperatura', 594.0000, 'ºC'),
	(299561, 144, '2015-01-01 00:25:41.000000', 'temperatura', 548.0000, 'ºC'),
	(299562, 144, '2015-01-01 00:25:42.000000', 'temperatura', 959.0000, 'ºC'),
	(299563, 144, '2015-01-01 00:25:43.000000', 'temperatura', 752.0000, 'ºC'),
	(299564, 144, '2015-01-01 00:25:44.000000', 'temperatura', 881.0000, 'ºC'),
	(299565, 144, '2015-01-01 00:25:45.000000', 'temperatura', 951.0000, 'ºC'),
	(299566, 144, '2015-01-01 00:25:46.000000', 'temperatura', 911.0000, 'ºC'),
	(299567, 144, '2015-01-01 00:25:47.000000', 'temperatura', 502.0000, 'ºC'),
	(299568, 144, '2015-01-01 00:25:48.000000', 'temperatura', 980.0000, 'ºC'),
	(299569, 144, '2015-01-01 00:25:49.000000', 'temperatura', 994.0000, 'ºC'),
	(299570, 144, '2015-01-01 00:25:50.000000', 'temperatura', 829.0000, 'ºC'),
	(299571, 144, '2015-01-01 00:25:51.000000', 'temperatura', 1166.0000, 'ºC'),
	(299572, 144, '2015-01-01 00:25:52.000000', 'temperatura', 943.0000, 'ºC'),
	(299573, 144, '2015-01-01 00:25:53.000000', 'temperatura', 16.0000, 'ºC'),
	(299574, 144, '2015-01-01 00:25:54.000000', 'temperatura', 851.0000, 'ºC'),
	(299575, 144, '2015-01-01 00:25:55.000000', 'temperatura', 610.0000, 'ºC'),
	(299576, 144, '2015-01-01 00:25:56.000000', 'temperatura', 498.0000, 'ºC'),
	(299577, 144, '2015-01-01 00:25:57.000000', 'temperatura', 659.0000, 'ºC'),
	(299578, 144, '2015-01-01 00:25:58.000000', 'temperatura', 602.0000, 'ºC'),
	(299579, 144, '2015-01-01 00:25:59.000000', 'temperatura', 1035.0000, 'ºC'),
	(299580, 144, '2015-01-01 00:26:00.000000', 'temperatura', 968.0000, 'ºC'),
	(299581, 144, '2015-01-01 00:26:01.000000', 'temperatura', 536.0000, 'ºC'),
	(299582, 144, '2015-01-01 00:26:02.000000', 'temperatura', 978.0000, 'ºC'),
	(299583, 144, '2015-01-01 00:26:03.000000', 'temperatura', 880.0000, 'ºC'),
	(299584, 144, '2015-01-01 00:26:04.000000', 'temperatura', 266.0000, 'ºC'),
	(299585, 144, '2015-01-01 00:26:05.000000', 'temperatura', 1090.0000, 'ºC'),
	(299586, 144, '2015-01-01 00:26:06.000000', 'temperatura', 1055.0000, 'ºC'),
	(299587, 144, '2015-01-01 00:26:07.000000', 'temperatura', 806.0000, 'ºC'),
	(299588, 144, '2015-01-01 00:26:08.000000', 'temperatura', 864.0000, 'ºC'),
	(299589, 144, '2015-01-01 00:26:09.000000', 'temperatura', 704.0000, 'ºC'),
	(299590, 144, '2015-01-01 00:26:10.000000', 'temperatura', 927.0000, 'ºC'),
	(299591, 144, '2015-01-01 00:26:11.000000', 'temperatura', 122.0000, 'ºC'),
	(299592, 144, '2015-01-01 00:26:12.000000', 'temperatura', 231.0000, 'ºC'),
	(299593, 144, '2015-01-01 00:26:13.000000', 'temperatura', 791.0000, 'ºC'),
	(299594, 144, '2015-01-01 00:26:14.000000', 'temperatura', 862.0000, 'ºC'),
	(299595, 144, '2015-01-01 00:26:15.000000', 'temperatura', 737.0000, 'ºC'),
	(299596, 144, '2015-01-01 00:26:16.000000', 'temperatura', 1100.0000, 'ºC'),
	(299597, 144, '2015-01-01 00:26:17.000000', 'temperatura', 890.0000, 'ºC'),
	(299598, 144, '2015-01-01 00:26:18.000000', 'temperatura', 1152.0000, 'ºC'),
	(299599, 144, '2015-01-01 00:26:19.000000', 'temperatura', 687.0000, 'ºC'),
	(299600, 144, '2015-01-01 00:26:20.000000', 'temperatura', 1181.0000, 'ºC'),
	(299601, 144, '2015-01-01 00:26:21.000000', 'temperatura', 243.0000, 'ºC'),
	(299602, 144, '2015-01-01 00:26:22.000000', 'temperatura', 72.0000, 'ºC'),
	(299603, 144, '2015-01-01 00:26:23.000000', 'temperatura', 832.0000, 'ºC'),
	(299604, 144, '2015-01-01 00:26:24.000000', 'temperatura', 344.0000, 'ºC'),
	(299605, 144, '2015-01-01 00:26:25.000000', 'temperatura', 426.0000, 'ºC'),
	(299606, 144, '2015-01-01 00:26:26.000000', 'temperatura', 1096.0000, 'ºC'),
	(299607, 144, '2015-01-01 00:26:27.000000', 'temperatura', 606.0000, 'ºC'),
	(299608, 144, '2015-01-01 00:26:28.000000', 'temperatura', 939.0000, 'ºC'),
	(299609, 144, '2015-01-01 00:26:29.000000', 'temperatura', 481.0000, 'ºC'),
	(299610, 144, '2015-01-01 00:26:30.000000', 'temperatura', 786.0000, 'ºC'),
	(299611, 144, '2015-01-01 00:26:31.000000', 'temperatura', 87.0000, 'ºC'),
	(299612, 144, '2015-01-01 00:26:32.000000', 'temperatura', 479.0000, 'ºC'),
	(299613, 144, '2015-01-01 00:26:33.000000', 'temperatura', 934.0000, 'ºC'),
	(299614, 144, '2015-01-01 00:26:34.000000', 'temperatura', 835.0000, 'ºC'),
	(299615, 144, '2015-01-01 00:26:35.000000', 'temperatura', 174.0000, 'ºC'),
	(299616, 144, '2015-01-01 00:26:36.000000', 'temperatura', 763.0000, 'ºC'),
	(299617, 144, '2015-01-01 00:26:37.000000', 'temperatura', 896.0000, 'ºC'),
	(299618, 144, '2015-01-01 00:26:38.000000', 'temperatura', 989.0000, 'ºC'),
	(299619, 144, '2015-01-01 00:26:39.000000', 'temperatura', 1057.0000, 'ºC'),
	(299620, 144, '2015-01-01 00:26:40.000000', 'temperatura', 1120.0000, 'ºC'),
	(299621, 144, '2015-01-01 00:26:41.000000', 'temperatura', 29.0000, 'ºC'),
	(299622, 144, '2015-01-01 00:26:42.000000', 'temperatura', 386.0000, 'ºC'),
	(299623, 144, '2015-01-01 00:26:43.000000', 'temperatura', 641.0000, 'ºC'),
	(299624, 144, '2015-01-01 00:26:44.000000', 'temperatura', 851.0000, 'ºC'),
	(299625, 144, '2015-01-01 00:26:45.000000', 'temperatura', 1131.0000, 'ºC'),
	(299626, 144, '2015-01-01 00:26:46.000000', 'temperatura', 702.0000, 'ºC'),
	(299627, 144, '2015-01-01 00:26:47.000000', 'temperatura', 116.0000, 'ºC'),
	(299628, 144, '2015-01-01 00:26:48.000000', 'temperatura', 877.0000, 'ºC'),
	(299629, 144, '2015-01-01 00:26:49.000000', 'temperatura', 435.0000, 'ºC'),
	(299630, 144, '2015-01-01 00:26:50.000000', 'temperatura', 747.0000, 'ºC'),
	(299631, 144, '2015-01-01 00:26:51.000000', 'temperatura', 29.0000, 'ºC'),
	(299632, 144, '2015-01-01 00:26:52.000000', 'temperatura', 306.0000, 'ºC'),
	(299633, 144, '2015-01-01 00:26:53.000000', 'temperatura', 243.0000, 'ºC'),
	(299634, 144, '2015-01-01 00:26:54.000000', 'temperatura', 296.0000, 'ºC'),
	(299635, 144, '2015-01-01 00:26:55.000000', 'temperatura', 754.0000, 'ºC'),
	(299636, 144, '2015-01-01 00:26:56.000000', 'temperatura', 483.0000, 'ºC'),
	(299637, 144, '2015-01-01 00:26:57.000000', 'temperatura', 154.0000, 'ºC'),
	(299638, 144, '2015-01-01 00:26:58.000000', 'temperatura', 518.0000, 'ºC'),
	(299639, 144, '2015-01-01 00:26:59.000000', 'temperatura', 932.0000, 'ºC'),
	(299640, 144, '2015-01-01 00:27:00.000000', 'temperatura', 705.0000, 'ºC'),
	(299641, 144, '2015-01-01 00:27:01.000000', 'temperatura', 729.0000, 'ºC'),
	(299642, 144, '2015-01-01 00:27:02.000000', 'temperatura', 333.0000, 'ºC'),
	(299643, 144, '2015-01-01 00:27:03.000000', 'temperatura', 677.0000, 'ºC'),
	(299644, 144, '2015-01-01 00:27:04.000000', 'temperatura', 1185.0000, 'ºC'),
	(299645, 144, '2015-01-01 00:27:05.000000', 'temperatura', 294.0000, 'ºC'),
	(299646, 144, '2015-01-01 00:27:06.000000', 'temperatura', 315.0000, 'ºC'),
	(299647, 144, '2015-01-01 00:27:07.000000', 'temperatura', 696.0000, 'ºC'),
	(299648, 144, '2015-01-01 00:27:08.000000', 'temperatura', 134.0000, 'ºC'),
	(299649, 144, '2015-01-01 00:27:09.000000', 'temperatura', 982.0000, 'ºC'),
	(299650, 144, '2015-01-01 00:27:10.000000', 'temperatura', 909.0000, 'ºC'),
	(299651, 144, '2015-01-01 00:27:11.000000', 'temperatura', 401.0000, 'ºC'),
	(299652, 144, '2015-01-01 00:27:12.000000', 'temperatura', 477.0000, 'ºC'),
	(299653, 144, '2015-01-01 00:27:13.000000', 'temperatura', 1184.0000, 'ºC'),
	(299654, 144, '2015-01-01 00:27:14.000000', 'temperatura', 888.0000, 'ºC'),
	(299655, 144, '2015-01-01 00:27:15.000000', 'temperatura', 890.0000, 'ºC'),
	(299656, 144, '2015-01-01 00:27:16.000000', 'temperatura', 585.0000, 'ºC'),
	(299657, 144, '2015-01-01 00:27:17.000000', 'temperatura', 255.0000, 'ºC'),
	(299658, 144, '2015-01-01 00:27:18.000000', 'temperatura', 722.0000, 'ºC'),
	(299659, 144, '2015-01-01 00:27:19.000000', 'temperatura', 446.0000, 'ºC'),
	(299660, 144, '2015-01-01 00:27:20.000000', 'temperatura', 62.0000, 'ºC'),
	(299661, 144, '2015-01-01 00:27:21.000000', 'temperatura', 173.0000, 'ºC'),
	(299662, 144, '2015-01-01 00:27:22.000000', 'temperatura', 681.0000, 'ºC'),
	(299663, 144, '2015-01-01 00:27:23.000000', 'temperatura', 486.0000, 'ºC'),
	(299664, 144, '2015-01-01 00:27:24.000000', 'temperatura', 388.0000, 'ºC'),
	(299665, 144, '2015-01-01 00:27:25.000000', 'temperatura', 482.0000, 'ºC'),
	(299666, 144, '2015-01-01 00:27:26.000000', 'temperatura', 46.0000, 'ºC'),
	(299667, 144, '2015-01-01 00:27:27.000000', 'temperatura', 1184.0000, 'ºC'),
	(299668, 144, '2015-01-01 00:27:28.000000', 'temperatura', 985.0000, 'ºC'),
	(299669, 144, '2015-01-01 00:27:29.000000', 'temperatura', 172.0000, 'ºC'),
	(299670, 144, '2015-01-01 00:27:30.000000', 'temperatura', 304.0000, 'ºC'),
	(299671, 144, '2015-01-01 00:27:31.000000', 'temperatura', 1004.0000, 'ºC'),
	(299672, 144, '2015-01-01 00:27:32.000000', 'temperatura', 511.0000, 'ºC'),
	(299673, 144, '2015-01-01 00:27:33.000000', 'temperatura', 741.0000, 'ºC'),
	(299674, 144, '2015-01-01 00:27:34.000000', 'temperatura', 974.0000, 'ºC'),
	(299675, 144, '2015-01-01 00:27:35.000000', 'temperatura', 249.0000, 'ºC'),
	(299676, 144, '2015-01-01 00:27:36.000000', 'temperatura', 720.0000, 'ºC'),
	(299677, 144, '2015-01-01 00:27:37.000000', 'temperatura', 456.0000, 'ºC'),
	(299678, 144, '2015-01-01 00:27:38.000000', 'temperatura', 118.0000, 'ºC'),
	(299679, 144, '2015-01-01 00:27:39.000000', 'temperatura', 424.0000, 'ºC'),
	(299680, 144, '2015-01-01 00:27:40.000000', 'temperatura', 568.0000, 'ºC'),
	(299681, 144, '2015-01-01 00:27:41.000000', 'temperatura', 367.0000, 'ºC'),
	(299682, 144, '2015-01-01 00:27:42.000000', 'temperatura', 133.0000, 'ºC'),
	(299683, 144, '2015-01-01 00:27:43.000000', 'temperatura', 762.0000, 'ºC'),
	(299684, 144, '2015-01-01 00:27:44.000000', 'temperatura', 1011.0000, 'ºC'),
	(299685, 144, '2015-01-01 00:27:45.000000', 'temperatura', 370.0000, 'ºC'),
	(299686, 144, '2015-01-01 00:27:46.000000', 'temperatura', 19.0000, 'ºC'),
	(299687, 144, '2015-01-01 00:27:47.000000', 'temperatura', 186.0000, 'ºC'),
	(299688, 144, '2015-01-01 00:27:48.000000', 'temperatura', 873.0000, 'ºC'),
	(299689, 144, '2015-01-01 00:27:49.000000', 'temperatura', 205.0000, 'ºC'),
	(299690, 144, '2015-01-01 00:27:50.000000', 'temperatura', 809.0000, 'ºC'),
	(299691, 144, '2015-01-01 00:27:51.000000', 'temperatura', 1030.0000, 'ºC'),
	(299692, 144, '2015-01-01 00:27:52.000000', 'temperatura', 324.0000, 'ºC'),
	(299693, 144, '2015-01-01 00:27:53.000000', 'temperatura', 932.0000, 'ºC'),
	(299694, 144, '2015-01-01 00:27:54.000000', 'temperatura', 87.0000, 'ºC'),
	(299695, 144, '2015-01-01 00:27:55.000000', 'temperatura', 38.0000, 'ºC'),
	(299696, 144, '2015-01-01 00:27:56.000000', 'temperatura', 1130.0000, 'ºC'),
	(299697, 144, '2015-01-01 00:27:57.000000', 'temperatura', 738.0000, 'ºC'),
	(299698, 144, '2015-01-01 00:27:58.000000', 'temperatura', 301.0000, 'ºC'),
	(299699, 144, '2015-01-01 00:27:59.000000', 'temperatura', 489.0000, 'ºC'),
	(299700, 144, '2015-01-01 00:28:00.000000', 'temperatura', 344.0000, 'ºC'),
	(299701, 144, '2015-01-01 00:28:01.000000', 'temperatura', 254.0000, 'ºC'),
	(299702, 144, '2015-01-01 00:28:02.000000', 'temperatura', 239.0000, 'ºC'),
	(299703, 144, '2015-01-01 00:28:03.000000', 'temperatura', 432.0000, 'ºC'),
	(299704, 144, '2015-01-01 00:28:04.000000', 'temperatura', 244.0000, 'ºC'),
	(299705, 144, '2015-01-01 00:28:05.000000', 'temperatura', 1126.0000, 'ºC'),
	(299706, 144, '2015-01-01 00:28:06.000000', 'temperatura', 96.0000, 'ºC'),
	(299707, 144, '2015-01-01 00:28:07.000000', 'temperatura', 704.0000, 'ºC'),
	(299708, 144, '2015-01-01 00:28:08.000000', 'temperatura', 833.0000, 'ºC'),
	(299709, 144, '2015-01-01 00:28:09.000000', 'temperatura', 853.0000, 'ºC'),
	(299710, 144, '2015-01-01 00:28:10.000000', 'temperatura', 568.0000, 'ºC'),
	(299711, 144, '2015-01-01 00:28:11.000000', 'temperatura', 280.0000, 'ºC'),
	(299712, 144, '2015-01-01 00:28:12.000000', 'temperatura', 898.0000, 'ºC'),
	(299713, 144, '2015-01-01 00:28:13.000000', 'temperatura', 48.0000, 'ºC'),
	(299714, 144, '2015-01-01 00:28:14.000000', 'temperatura', 1146.0000, 'ºC'),
	(299715, 144, '2015-01-01 00:28:15.000000', 'temperatura', 786.0000, 'ºC'),
	(299716, 144, '2015-01-01 00:28:16.000000', 'temperatura', 494.0000, 'ºC'),
	(299717, 144, '2015-01-01 00:28:17.000000', 'temperatura', 111.0000, 'ºC'),
	(299718, 144, '2015-01-01 00:28:18.000000', 'temperatura', 276.0000, 'ºC'),
	(299719, 144, '2015-01-01 00:28:19.000000', 'temperatura', 1048.0000, 'ºC'),
	(299720, 144, '2015-01-01 00:28:20.000000', 'temperatura', 809.0000, 'ºC'),
	(299721, 144, '2015-01-01 00:28:21.000000', 'temperatura', 905.0000, 'ºC'),
	(299722, 144, '2015-01-01 00:28:22.000000', 'temperatura', 897.0000, 'ºC'),
	(299723, 144, '2015-01-01 00:28:23.000000', 'temperatura', 569.0000, 'ºC'),
	(299724, 144, '2015-01-01 00:28:24.000000', 'temperatura', 154.0000, 'ºC'),
	(299725, 144, '2015-01-01 00:28:25.000000', 'temperatura', 264.0000, 'ºC'),
	(299726, 144, '2015-01-01 00:28:26.000000', 'temperatura', 861.0000, 'ºC'),
	(299727, 144, '2015-01-01 00:28:27.000000', 'temperatura', 1112.0000, 'ºC'),
	(299728, 144, '2015-01-01 00:28:28.000000', 'temperatura', 579.0000, 'ºC'),
	(299729, 144, '2015-01-01 00:28:29.000000', 'temperatura', 759.0000, 'ºC'),
	(299730, 144, '2015-01-01 00:28:30.000000', 'temperatura', 860.0000, 'ºC'),
	(299731, 144, '2015-01-01 00:28:31.000000', 'temperatura', 820.0000, 'ºC'),
	(299732, 144, '2015-01-01 00:28:32.000000', 'temperatura', 323.0000, 'ºC'),
	(299733, 144, '2015-01-01 00:28:33.000000', 'temperatura', 355.0000, 'ºC'),
	(299734, 144, '2015-01-01 00:28:34.000000', 'temperatura', 807.0000, 'ºC'),
	(299735, 144, '2015-01-01 00:28:35.000000', 'temperatura', 571.0000, 'ºC'),
	(299736, 144, '2015-01-01 00:28:36.000000', 'temperatura', 434.0000, 'ºC'),
	(299737, 144, '2015-01-01 00:28:37.000000', 'temperatura', 457.0000, 'ºC'),
	(299738, 144, '2015-01-01 00:28:38.000000', 'temperatura', 983.0000, 'ºC'),
	(299739, 144, '2015-01-01 00:28:39.000000', 'temperatura', 1145.0000, 'ºC'),
	(299740, 144, '2015-01-01 00:28:40.000000', 'temperatura', 375.0000, 'ºC'),
	(299741, 144, '2015-01-01 00:28:41.000000', 'temperatura', 841.0000, 'ºC'),
	(299742, 144, '2015-01-01 00:28:42.000000', 'temperatura', 682.0000, 'ºC'),
	(299743, 144, '2015-01-01 00:28:43.000000', 'temperatura', 887.0000, 'ºC'),
	(299744, 144, '2015-01-01 00:28:44.000000', 'temperatura', 1189.0000, 'ºC'),
	(299745, 144, '2015-01-01 00:28:45.000000', 'temperatura', 883.0000, 'ºC'),
	(299746, 144, '2015-01-01 00:28:46.000000', 'temperatura', 849.0000, 'ºC'),
	(299747, 144, '2015-01-01 00:28:47.000000', 'temperatura', 396.0000, 'ºC'),
	(299748, 144, '2015-01-01 00:28:48.000000', 'temperatura', 636.0000, 'ºC'),
	(299749, 144, '2015-01-01 00:28:49.000000', 'temperatura', 791.0000, 'ºC'),
	(299750, 144, '2015-01-01 00:28:50.000000', 'temperatura', 848.0000, 'ºC'),
	(299751, 144, '2015-01-01 00:28:51.000000', 'temperatura', 668.0000, 'ºC'),
	(299752, 144, '2015-01-01 00:28:52.000000', 'temperatura', 796.0000, 'ºC'),
	(299753, 144, '2015-01-01 00:28:53.000000', 'temperatura', 778.0000, 'ºC'),
	(299754, 144, '2015-01-01 00:28:54.000000', 'temperatura', 300.0000, 'ºC'),
	(299755, 144, '2015-01-01 00:28:55.000000', 'temperatura', 366.0000, 'ºC'),
	(299756, 144, '2015-01-01 00:28:56.000000', 'temperatura', 933.0000, 'ºC'),
	(299757, 144, '2015-01-01 00:28:57.000000', 'temperatura', 1165.0000, 'ºC'),
	(299758, 144, '2015-01-01 00:28:58.000000', 'temperatura', 628.0000, 'ºC'),
	(299759, 144, '2015-01-01 00:28:59.000000', 'temperatura', 845.0000, 'ºC'),
	(299760, 144, '2015-01-01 00:29:00.000000', 'temperatura', 1140.0000, 'ºC'),
	(299761, 144, '2015-01-01 00:29:01.000000', 'temperatura', 767.0000, 'ºC'),
	(299762, 144, '2015-01-01 00:29:02.000000', 'temperatura', 413.0000, 'ºC'),
	(299763, 144, '2015-01-01 00:29:03.000000', 'temperatura', 968.0000, 'ºC'),
	(299764, 144, '2015-01-01 00:29:04.000000', 'temperatura', 0.0000, 'ºC'),
	(299765, 144, '2015-01-01 00:29:05.000000', 'temperatura', 697.0000, 'ºC'),
	(299766, 144, '2015-01-01 00:29:06.000000', 'temperatura', 1084.0000, 'ºC'),
	(299767, 144, '2015-01-01 00:29:07.000000', 'temperatura', 930.0000, 'ºC'),
	(299768, 144, '2015-01-01 00:29:08.000000', 'temperatura', 198.0000, 'ºC'),
	(299769, 144, '2015-01-01 00:29:09.000000', 'temperatura', 600.0000, 'ºC'),
	(299770, 144, '2015-01-01 00:29:10.000000', 'temperatura', 9.0000, 'ºC'),
	(299771, 144, '2015-01-01 00:29:11.000000', 'temperatura', 644.0000, 'ºC'),
	(299772, 144, '2015-01-01 00:29:12.000000', 'temperatura', 794.0000, 'ºC'),
	(299773, 144, '2015-01-01 00:29:13.000000', 'temperatura', 837.0000, 'ºC'),
	(299774, 144, '2015-01-01 00:29:14.000000', 'temperatura', 604.0000, 'ºC'),
	(299775, 144, '2015-01-01 00:29:15.000000', 'temperatura', 509.0000, 'ºC'),
	(299776, 144, '2015-01-01 00:29:16.000000', 'temperatura', 734.0000, 'ºC'),
	(299777, 144, '2015-01-01 00:29:17.000000', 'temperatura', 943.0000, 'ºC'),
	(299778, 144, '2015-01-01 00:29:18.000000', 'temperatura', 114.0000, 'ºC'),
	(299779, 144, '2015-01-01 00:29:19.000000', 'temperatura', 143.0000, 'ºC'),
	(299780, 144, '2015-01-01 00:29:20.000000', 'temperatura', 373.0000, 'ºC'),
	(299781, 144, '2015-01-01 00:29:21.000000', 'temperatura', 235.0000, 'ºC'),
	(299782, 144, '2015-01-01 00:29:22.000000', 'temperatura', 56.0000, 'ºC'),
	(299783, 144, '2015-01-01 00:29:23.000000', 'temperatura', 776.0000, 'ºC'),
	(299784, 144, '2015-01-01 00:29:24.000000', 'temperatura', 112.0000, 'ºC'),
	(299785, 144, '2015-01-01 00:29:25.000000', 'temperatura', 631.0000, 'ºC'),
	(299786, 144, '2015-01-01 00:29:26.000000', 'temperatura', 422.0000, 'ºC'),
	(299787, 144, '2015-01-01 00:29:27.000000', 'temperatura', 217.0000, 'ºC'),
	(299788, 144, '2015-01-01 00:29:28.000000', 'temperatura', 1021.0000, 'ºC'),
	(299789, 144, '2015-01-01 00:29:29.000000', 'temperatura', 852.0000, 'ºC'),
	(299790, 144, '2015-01-01 00:29:30.000000', 'temperatura', 1199.0000, 'ºC'),
	(299791, 144, '2015-01-01 00:29:31.000000', 'temperatura', 1038.0000, 'ºC'),
	(299792, 144, '2015-01-01 00:29:32.000000', 'temperatura', 393.0000, 'ºC'),
	(299793, 144, '2015-01-01 00:29:33.000000', 'temperatura', 54.0000, 'ºC'),
	(299794, 144, '2015-01-01 00:29:34.000000', 'temperatura', 292.0000, 'ºC'),
	(299795, 144, '2015-01-01 00:29:35.000000', 'temperatura', 97.0000, 'ºC'),
	(299796, 144, '2015-01-01 00:29:36.000000', 'temperatura', 811.0000, 'ºC'),
	(299797, 144, '2015-01-01 00:29:37.000000', 'temperatura', 162.0000, 'ºC'),
	(299798, 144, '2015-01-01 00:29:38.000000', 'temperatura', 779.0000, 'ºC'),
	(299799, 144, '2015-01-01 00:29:39.000000', 'temperatura', 1009.0000, 'ºC'),
	(299800, 144, '2015-01-01 00:29:40.000000', 'temperatura', 310.0000, 'ºC'),
	(299801, 144, '2015-01-01 00:29:41.000000', 'temperatura', 923.0000, 'ºC'),
	(299802, 144, '2015-01-01 00:29:42.000000', 'temperatura', 86.0000, 'ºC'),
	(299803, 144, '2015-01-01 00:29:43.000000', 'temperatura', 62.0000, 'ºC'),
	(299804, 144, '2015-01-01 00:29:44.000000', 'temperatura', 53.0000, 'ºC'),
	(299805, 144, '2015-01-01 00:29:45.000000', 'temperatura', 80.0000, 'ºC'),
	(299806, 144, '2015-01-01 00:29:46.000000', 'temperatura', 242.0000, 'ºC'),
	(299807, 144, '2015-01-01 00:29:47.000000', 'temperatura', 968.0000, 'ºC'),
	(299808, 144, '2015-01-01 00:29:48.000000', 'temperatura', 516.0000, 'ºC'),
	(299809, 144, '2015-01-01 00:29:49.000000', 'temperatura', 877.0000, 'ºC'),
	(299810, 144, '2015-01-01 00:29:50.000000', 'temperatura', 435.0000, 'ºC'),
	(299811, 144, '2015-01-01 00:29:51.000000', 'temperatura', 746.0000, 'ºC'),
	(299812, 144, '2015-01-01 00:29:52.000000', 'temperatura', 26.0000, 'ºC'),
	(299813, 144, '2015-01-01 00:29:53.000000', 'temperatura', 294.0000, 'ºC'),
	(299814, 144, '2015-01-01 00:29:54.000000', 'temperatura', 192.0000, 'ºC'),
	(299815, 144, '2015-01-01 00:29:55.000000', 'temperatura', 78.0000, 'ºC'),
	(299816, 144, '2015-01-01 00:29:56.000000', 'temperatura', 1015.0000, 'ºC'),
	(299817, 144, '2015-01-01 00:29:57.000000', 'temperatura', 43.0000, 'ºC'),
	(299818, 144, '2015-01-01 00:29:58.000000', 'temperatura', 770.0000, 'ºC'),
	(299819, 144, '2015-01-01 00:29:59.000000', 'temperatura', 122.0000, 'ºC'),
	(299820, 144, '2015-01-01 00:30:00.000000', 'temperatura', 699.0000, 'ºC'),
	(299821, 144, '2015-01-01 00:30:01.000000', 'temperatura', 731.0000, 'ºC'),
	(299822, 144, '2015-01-01 00:30:02.000000', 'temperatura', 356.0000, 'ºC'),
	(299823, 144, '2015-01-01 00:30:03.000000', 'temperatura', 789.0000, 'ºC'),
	(299824, 144, '2015-01-01 00:30:04.000000', 'temperatura', 478.0000, 'ºC'),
	(299825, 144, '2015-01-01 00:30:05.000000', 'temperatura', 21.0000, 'ºC'),
	(299826, 144, '2015-01-01 00:30:06.000000', 'temperatura', 1074.0000, 'ºC'),
	(299827, 144, '2015-01-01 00:30:07.000000', 'temperatura', 505.0000, 'ºC'),
	(299828, 144, '2015-01-01 00:30:08.000000', 'temperatura', 507.0000, 'ºC'),
	(299829, 144, '2015-01-01 00:30:09.000000', 'temperatura', 1017.0000, 'ºC'),
	(299830, 144, '2015-01-01 00:30:10.000000', 'temperatura', 1166.0000, 'ºC'),
	(299831, 144, '2015-01-01 00:30:11.000000', 'temperatura', 379.0000, 'ºC'),
	(299832, 144, '2015-01-01 00:30:12.000000', 'temperatura', 797.0000, 'ºC'),
	(299833, 144, '2015-01-01 00:30:13.000000', 'temperatura', 448.0000, 'ºC'),
	(299834, 144, '2015-01-01 00:30:14.000000', 'temperatura', 1052.0000, 'ºC'),
	(299835, 144, '2015-01-01 00:30:15.000000', 'temperatura', 313.0000, 'ºC'),
	(299836, 144, '2015-01-01 00:30:16.000000', 'temperatura', 813.0000, 'ºC'),
	(299837, 144, '2015-01-01 00:30:17.000000', 'temperatura', 724.0000, 'ºC'),
	(299838, 144, '2015-01-01 00:30:18.000000', 'temperatura', 1184.0000, 'ºC'),
	(299839, 144, '2015-01-01 00:30:19.000000', 'temperatura', 147.0000, 'ºC'),
	(299840, 144, '2015-01-01 00:30:20.000000', 'temperatura', 782.0000, 'ºC'),
	(299841, 144, '2015-01-01 00:30:21.000000', 'temperatura', 1073.0000, 'ºC'),
	(299842, 144, '2015-01-01 00:30:22.000000', 'temperatura', 616.0000, 'ºC'),
	(299843, 144, '2015-01-01 00:30:23.000000', 'temperatura', 1063.0000, 'ºC'),
	(299844, 144, '2015-01-01 00:30:24.000000', 'temperatura', 1066.0000, 'ºC'),
	(299845, 144, '2015-01-01 00:30:25.000000', 'temperatura', 945.0000, 'ºC'),
	(299846, 144, '2015-01-01 00:30:26.000000', 'temperatura', 324.0000, 'ºC'),
	(299847, 144, '2015-01-01 00:30:27.000000', 'temperatura', 1185.0000, 'ºC'),
	(299848, 144, '2015-01-01 00:30:28.000000', 'temperatura', 155.0000, 'ºC'),
	(299849, 144, '2015-01-01 00:30:29.000000', 'temperatura', 819.0000, 'ºC'),
	(299850, 144, '2015-01-01 00:30:30.000000', 'temperatura', 33.0000, 'ºC'),
	(299851, 144, '2015-01-01 00:30:31.000000', 'temperatura', 109.0000, 'ºC'),
	(299852, 144, '2015-01-01 00:30:32.000000', 'temperatura', 444.0000, 'ºC'),
	(299853, 144, '2015-01-01 00:30:33.000000', 'temperatura', 694.0000, 'ºC'),
	(299854, 144, '2015-01-01 00:30:34.000000', 'temperatura', 939.0000, 'ºC'),
	(299855, 144, '2015-01-01 00:30:35.000000', 'temperatura', 213.0000, 'ºC'),
	(299856, 144, '2015-01-01 00:30:36.000000', 'temperatura', 650.0000, 'ºC'),
	(299857, 144, '2015-01-01 00:30:37.000000', 'temperatura', 210.0000, 'ºC'),
	(299858, 144, '2015-01-01 00:30:38.000000', 'temperatura', 301.0000, 'ºC'),
	(299859, 144, '2015-01-01 00:30:39.000000', 'temperatura', 876.0000, 'ºC'),
	(299860, 144, '2015-01-01 00:30:40.000000', 'temperatura', 1076.0000, 'ºC'),
	(299861, 144, '2015-01-01 00:30:41.000000', 'temperatura', 352.0000, 'ºC'),
	(299862, 144, '2015-01-01 00:30:42.000000', 'temperatura', 935.0000, 'ºC'),
	(299863, 144, '2015-01-01 00:30:43.000000', 'temperatura', 16.0000, 'ºC'),
	(299864, 144, '2015-01-01 00:30:44.000000', 'temperatura', 879.0000, 'ºC'),
	(299865, 144, '2015-01-01 00:30:45.000000', 'temperatura', 746.0000, 'ºC'),
	(299866, 144, '2015-01-01 00:30:46.000000', 'temperatura', 1093.0000, 'ºC'),
	(299867, 144, '2015-01-01 00:30:47.000000', 'temperatura', 827.0000, 'ºC'),
	(299868, 144, '2015-01-01 00:30:48.000000', 'temperatura', 856.0000, 'ºC'),
	(299869, 144, '2015-01-01 00:30:49.000000', 'temperatura', 600.0000, 'ºC'),
	(299870, 144, '2015-01-01 00:30:50.000000', 'temperatura', 435.0000, 'ºC'),
	(299871, 144, '2015-01-01 00:30:51.000000', 'temperatura', 373.0000, 'ºC'),
	(299872, 144, '2015-01-01 00:30:52.000000', 'temperatura', 559.0000, 'ºC'),
	(299873, 144, '2015-01-01 00:30:53.000000', 'temperatura', 479.0000, 'ºC'),
	(299874, 144, '2015-01-01 00:30:54.000000', 'temperatura', 716.0000, 'ºC'),
	(299875, 144, '2015-01-01 00:30:55.000000', 'temperatura', 944.0000, 'ºC'),
	(299876, 144, '2015-01-01 00:30:56.000000', 'temperatura', 174.0000, 'ºC'),
	(299877, 144, '2015-01-01 00:30:57.000000', 'temperatura', 437.0000, 'ºC'),
	(299878, 144, '2015-01-01 00:30:58.000000', 'temperatura', 466.0000, 'ºC'),
	(299879, 144, '2015-01-01 00:30:59.000000', 'temperatura', 1017.0000, 'ºC'),
	(299880, 144, '2015-01-01 00:31:00.000000', 'temperatura', 88.0000, 'ºC'),
	(299881, 144, '2015-01-01 00:31:01.000000', 'temperatura', 992.0000, 'ºC'),
	(299882, 144, '2015-01-01 00:31:02.000000', 'temperatura', 1093.0000, 'ºC'),
	(299883, 144, '2015-01-01 00:31:03.000000', 'temperatura', 90.0000, 'ºC'),
	(299884, 144, '2015-01-01 00:31:04.000000', 'temperatura', 771.0000, 'ºC'),
	(299885, 144, '2015-01-01 00:31:05.000000', 'temperatura', 1188.0000, 'ºC'),
	(299886, 144, '2015-01-01 00:31:06.000000', 'temperatura', 25.0000, 'ºC'),
	(299887, 144, '2015-01-01 00:31:07.000000', 'temperatura', 160.0000, 'ºC'),
	(299888, 144, '2015-01-01 00:31:08.000000', 'temperatura', 729.0000, 'ºC'),
	(299889, 144, '2015-01-01 00:31:09.000000', 'temperatura', 764.0000, 'ºC'),
	(299890, 144, '2015-01-01 00:31:10.000000', 'temperatura', 434.0000, 'ºC'),
	(299891, 144, '2015-01-01 00:31:11.000000', 'temperatura', 1077.0000, 'ºC'),
	(299892, 144, '2015-01-01 00:31:12.000000', 'temperatura', 484.0000, 'ºC'),
	(299893, 144, '2015-01-01 00:31:13.000000', 'temperatura', 391.0000, 'ºC'),
	(299894, 144, '2015-01-01 00:31:14.000000', 'temperatura', 504.0000, 'ºC'),
	(299895, 144, '2015-01-01 00:31:15.000000', 'temperatura', 148.0000, 'ºC'),
	(299896, 144, '2015-01-01 00:31:16.000000', 'temperatura', 428.0000, 'ºC'),
	(299897, 144, '2015-01-01 00:31:17.000000', 'temperatura', 495.0000, 'ºC'),
	(299898, 144, '2015-01-01 00:31:18.000000', 'temperatura', 1193.0000, 'ºC'),
	(299899, 144, '2015-01-01 00:31:19.000000', 'temperatura', 881.0000, 'ºC'),
	(299900, 144, '2015-01-01 00:31:20.000000', 'temperatura', 828.0000, 'ºC'),
	(299901, 144, '2015-01-01 00:31:21.000000', 'temperatura', 294.0000, 'ºC'),
	(299902, 144, '2015-01-01 00:31:22.000000', 'temperatura', 188.0000, 'ºC'),
	(299903, 144, '2015-01-01 00:31:23.000000', 'temperatura', 57.0000, 'ºC'),
	(299904, 144, '2015-01-01 00:31:24.000000', 'temperatura', 923.0000, 'ºC'),
	(299905, 144, '2015-01-01 00:31:25.000000', 'temperatura', 846.0000, 'ºC'),
	(299906, 144, '2015-01-01 00:31:26.000000', 'temperatura', 258.0000, 'ºC'),
	(299907, 144, '2015-01-01 00:31:27.000000', 'temperatura', 1154.0000, 'ºC'),
	(299908, 144, '2015-01-01 00:31:28.000000', 'temperatura', 198.0000, 'ºC'),
	(299909, 144, '2015-01-01 00:31:29.000000', 'temperatura', 1128.0000, 'ºC'),
	(299910, 144, '2015-01-01 00:31:30.000000', 'temperatura', 244.0000, 'ºC'),
	(299911, 144, '2015-01-01 00:31:31.000000', 'temperatura', 238.0000, 'ºC'),
	(299912, 144, '2015-01-01 00:31:32.000000', 'temperatura', 459.0000, 'ºC'),
	(299913, 144, '2015-01-01 00:31:33.000000', 'temperatura', 381.0000, 'ºC'),
	(299914, 144, '2015-01-01 00:31:34.000000', 'temperatura', 530.0000, 'ºC'),
	(299915, 144, '2015-01-01 00:31:35.000000', 'temperatura', 306.0000, 'ºC'),
	(299916, 144, '2015-01-01 00:31:36.000000', 'temperatura', 1142.0000, 'ºC'),
	(299917, 144, '2015-01-01 00:31:37.000000', 'temperatura', 1190.0000, 'ºC'),
	(299918, 144, '2015-01-01 00:31:38.000000', 'temperatura', 127.0000, 'ºC'),
	(299919, 144, '2015-01-01 00:31:39.000000', 'temperatura', 664.0000, 'ºC'),
	(299920, 144, '2015-01-01 00:31:40.000000', 'temperatura', 539.0000, 'ºC'),
	(299921, 144, '2015-01-01 00:31:41.000000', 'temperatura', 705.0000, 'ºC'),
	(299922, 144, '2015-01-01 00:31:42.000000', 'temperatura', 709.0000, 'ºC'),
	(299923, 144, '2015-01-01 00:31:43.000000', 'temperatura', 230.0000, 'ºC'),
	(299924, 144, '2015-01-01 00:31:44.000000', 'temperatura', 222.0000, 'ºC'),
	(299925, 144, '2015-01-01 00:31:45.000000', 'temperatura', 420.0000, 'ºC'),
	(299926, 144, '2015-01-01 00:31:46.000000', 'temperatura', 236.0000, 'ºC'),
	(299927, 144, '2015-01-01 00:31:47.000000', 'temperatura', 1121.0000, 'ºC'),
	(299928, 144, '2015-01-01 00:31:48.000000', 'temperatura', 95.0000, 'ºC'),
	(299929, 144, '2015-01-01 00:31:49.000000', 'temperatura', 714.0000, 'ºC'),
	(299930, 144, '2015-01-01 00:31:50.000000', 'temperatura', 886.0000, 'ºC'),
	(299931, 144, '2015-01-01 00:31:51.000000', 'temperatura', 1087.0000, 'ºC'),
	(299932, 144, '2015-01-01 00:31:52.000000', 'temperatura', 379.0000, 'ºC'),
	(299933, 144, '2015-01-01 00:31:53.000000', 'temperatura', 1032.0000, 'ºC'),
	(299934, 144, '2015-01-01 00:31:54.000000', 'temperatura', 425.0000, 'ºC'),
	(299935, 144, '2015-01-01 00:31:55.000000', 'temperatura', 231.0000, 'ºC'),
	(299936, 144, '2015-01-01 00:31:56.000000', 'temperatura', 1081.0000, 'ºC'),
	(299937, 144, '2015-01-01 00:31:57.000000', 'temperatura', 1110.0000, 'ºC'),
	(299938, 144, '2015-01-01 00:31:58.000000', 'temperatura', 1109.0000, 'ºC'),
	(299939, 144, '2015-01-01 00:31:59.000000', 'temperatura', 1016.0000, 'ºC'),
	(299940, 144, '2015-01-01 00:32:00.000000', 'temperatura', 555.0000, 'ºC'),
	(299941, 144, '2015-01-01 00:32:01.000000', 'temperatura', 926.0000, 'ºC'),
	(299942, 144, '2015-01-01 00:32:02.000000', 'temperatura', 566.0000, 'ºC'),
	(299943, 144, '2015-01-01 00:32:03.000000', 'temperatura', 52.0000, 'ºC'),
	(299944, 144, '2015-01-01 00:32:04.000000', 'temperatura', 964.0000, 'ºC'),
	(299945, 144, '2015-01-01 00:32:05.000000', 'temperatura', 1065.0000, 'ºC'),
	(299946, 144, '2015-01-01 00:32:06.000000', 'temperatura', 34.0000, 'ºC'),
	(299947, 144, '2015-01-01 00:32:07.000000', 'temperatura', 575.0000, 'ºC'),
	(299948, 144, '2015-01-01 00:32:08.000000', 'temperatura', 374.0000, 'ºC'),
	(299949, 144, '2015-01-01 00:32:09.000000', 'temperatura', 145.0000, 'ºC'),
	(299950, 144, '2015-01-01 00:32:10.000000', 'temperatura', 804.0000, 'ºC'),
	(299951, 144, '2015-01-01 00:32:11.000000', 'temperatura', 1185.0000, 'ºC'),
	(299952, 144, '2015-01-01 00:32:12.000000', 'temperatura', 1113.0000, 'ºC'),
	(299953, 144, '2015-01-01 00:32:13.000000', 'temperatura', 812.0000, 'ºC'),
	(299954, 144, '2015-01-01 00:32:14.000000', 'temperatura', 719.0000, 'ºC'),
	(299955, 144, '2015-01-01 00:32:15.000000', 'temperatura', 1160.0000, 'ºC'),
	(299956, 144, '2015-01-01 00:32:16.000000', 'temperatura', 42.0000, 'ºC'),
	(299957, 144, '2015-01-01 00:32:17.000000', 'temperatura', 332.0000, 'ºC'),
	(299958, 144, '2015-01-01 00:32:18.000000', 'temperatura', 333.0000, 'ºC'),
	(299959, 144, '2015-01-01 00:32:19.000000', 'temperatura', 671.0000, 'ºC'),
	(299960, 144, '2015-01-01 00:32:20.000000', 'temperatura', 1158.0000, 'ºC'),
	(299961, 144, '2015-01-01 00:32:21.000000', 'temperatura', 175.0000, 'ºC'),
	(299962, 144, '2015-01-01 00:32:22.000000', 'temperatura', 1001.0000, 'ºC'),
	(299963, 144, '2015-01-01 00:32:23.000000', 'temperatura', 881.0000, 'ºC'),
	(299964, 144, '2015-01-01 00:32:24.000000', 'temperatura', 205.0000, 'ºC'),
	(299965, 144, '2015-01-01 00:32:25.000000', 'temperatura', 779.0000, 'ºC'),
	(299966, 144, '2015-01-01 00:32:26.000000', 'temperatura', 884.0000, 'ºC'),
	(299967, 144, '2015-01-01 00:32:27.000000', 'temperatura', 881.0000, 'ºC'),
	(299968, 144, '2015-01-01 00:32:28.000000', 'temperatura', 554.0000, 'ºC'),
	(299969, 144, '2015-01-01 00:32:29.000000', 'temperatura', 126.0000, 'ºC'),
	(299970, 144, '2015-01-01 00:32:30.000000', 'temperatura', 172.0000, 'ºC'),
	(299971, 144, '2015-01-01 00:32:31.000000', 'temperatura', 479.0000, 'ºC'),
	(299972, 144, '2015-01-01 00:32:32.000000', 'temperatura', 681.0000, 'ºC'),
	(299973, 144, '2015-01-01 00:32:33.000000', 'temperatura', 769.0000, 'ºC'),
	(299974, 144, '2015-01-01 00:32:34.000000', 'temperatura', 601.0000, 'ºC'),
	(299975, 144, '2015-01-01 00:32:35.000000', 'temperatura', 701.0000, 'ºC'),
	(299976, 144, '2015-01-01 00:32:36.000000', 'temperatura', 501.0000, 'ºC'),
	(299977, 144, '2015-01-01 00:32:37.000000', 'temperatura', 402.0000, 'ºC'),
	(299978, 144, '2015-01-01 00:32:38.000000', 'temperatura', 510.0000, 'ºC'),
	(299979, 144, '2015-01-01 00:32:39.000000', 'temperatura', 143.0000, 'ºC'),
	(299980, 144, '2015-01-01 00:32:40.000000', 'temperatura', 385.0000, 'ºC'),
	(299981, 144, '2015-01-01 00:32:41.000000', 'temperatura', 296.0000, 'ºC'),
	(299982, 144, '2015-01-01 00:32:42.000000', 'temperatura', 328.0000, 'ºC'),
	(299983, 144, '2015-01-01 00:32:43.000000', 'temperatura', 750.0000, 'ºC'),
	(299984, 144, '2015-01-01 00:32:44.000000', 'temperatura', 369.0000, 'ºC'),
	(299985, 144, '2015-01-01 00:32:45.000000', 'temperatura', 796.0000, 'ºC'),
	(299986, 144, '2015-01-01 00:32:46.000000', 'temperatura', 471.0000, 'ºC'),
	(299987, 144, '2015-01-01 00:32:47.000000', 'temperatura', 1167.0000, 'ºC'),
	(299988, 144, '2015-01-01 00:32:48.000000', 'temperatura', 824.0000, 'ºC'),
	(299989, 144, '2015-01-01 00:32:49.000000', 'temperatura', 620.0000, 'ºC'),
	(299990, 144, '2015-01-01 00:32:50.000000', 'temperatura', 627.0000, 'ºC'),
	(299991, 144, '2015-01-01 00:32:51.000000', 'temperatura', 75.0000, 'ºC'),
	(299992, 144, '2015-01-01 00:32:52.000000', 'temperatura', 896.0000, 'ºC'),
	(299993, 144, '2015-01-01 00:32:53.000000', 'temperatura', 657.0000, 'ºC'),
	(299994, 144, '2015-01-01 00:32:54.000000', 'temperatura', 596.0000, 'ºC'),
	(299995, 144, '2015-01-01 00:32:55.000000', 'temperatura', 1009.0000, 'ºC'),
	(299996, 144, '2015-01-01 00:32:56.000000', 'temperatura', 857.0000, 'ºC'),
	(299997, 144, '2015-01-01 00:32:57.000000', 'temperatura', 61.0000, 'ºC'),
	(299998, 144, '2015-01-01 00:32:58.000000', 'temperatura', 132.0000, 'ºC'),
	(299999, 144, '2015-01-01 00:32:59.000000', 'temperatura', 478.0000, 'ºC'),
	(300000, 144, '2015-01-01 00:33:00.000000', 'temperatura', 795.0000, 'ºC'),
	(300001, 144, '2015-01-01 00:33:01.000000', 'temperatura', 142.0000, 'ºC'),
	(300002, 144, '2015-01-01 00:33:02.000000', 'temperatura', 723.0000, 'ºC'),
	(300003, 144, '2015-01-01 00:33:03.000000', 'temperatura', 791.0000, 'ºC'),
	(300004, 144, '2015-01-01 00:33:04.000000', 'temperatura', 587.0000, 'ºC'),
	(300005, 144, '2015-01-01 00:33:05.000000', 'temperatura', 563.0000, 'ºC'),
	(300006, 144, '2015-01-01 00:33:06.000000', 'temperatura', 1053.0000, 'ºC'),
	(300007, 144, '2015-01-01 00:33:07.000000', 'temperatura', 1176.0000, 'ºC'),
	(300008, 144, '2015-01-01 00:33:08.000000', 'temperatura', 324.0000, 'ºC'),
	(300009, 144, '2015-01-01 00:33:09.000000', 'temperatura', 492.0000, 'ºC'),
	(300010, 144, '2015-01-01 00:33:10.000000', 'temperatura', 288.0000, 'ºC'),
	(300011, 144, '2015-01-01 00:33:11.000000', 'temperatura', 1166.0000, 'ºC'),
	(300012, 144, '2015-01-01 00:33:12.000000', 'temperatura', 165.0000, 'ºC'),
	(300013, 144, '2015-01-01 00:33:13.000000', 'temperatura', 927.0000, 'ºC'),
	(300014, 144, '2015-01-01 00:33:14.000000', 'temperatura', 543.0000, 'ºC'),
	(300015, 144, '2015-01-01 00:33:15.000000', 'temperatura', 1132.0000, 'ºC'),
	(300016, 144, '2015-01-01 00:33:16.000000', 'temperatura', 431.0000, 'ºC'),
	(300017, 144, '2015-01-01 00:33:17.000000', 'temperatura', 1162.0000, 'ºC'),
	(300018, 144, '2015-01-01 00:33:18.000000', 'temperatura', 916.0000, 'ºC'),
	(300019, 144, '2015-01-01 00:33:19.000000', 'temperatura', 1096.0000, 'ºC'),
	(300020, 144, '2015-01-01 00:33:20.000000', 'temperatura', 330.0000, 'ºC'),
	(300021, 144, '2015-01-01 00:33:21.000000', 'temperatura', 764.0000, 'ºC'),
	(300022, 144, '2015-01-01 00:33:22.000000', 'temperatura', 430.0000, 'ºC'),
	(300023, 144, '2015-01-01 00:33:23.000000', 'temperatura', 1057.0000, 'ºC'),
	(300024, 144, '2015-01-01 00:33:24.000000', 'temperatura', 397.0000, 'ºC'),
	(300025, 144, '2015-01-01 00:33:25.000000', 'temperatura', 15.0000, 'ºC'),
	(300026, 144, '2015-01-01 00:33:26.000000', 'temperatura', 82.0000, 'ºC'),
	(300027, 144, '2015-01-01 00:33:27.000000', 'temperatura', 367.0000, 'ºC'),
	(300028, 144, '2015-01-01 00:33:28.000000', 'temperatura', 392.0000, 'ºC'),
	(300029, 144, '2015-01-01 00:33:29.000000', 'temperatura', 856.0000, 'ºC'),
	(300030, 144, '2015-01-01 00:33:30.000000', 'temperatura', 704.0000, 'ºC'),
	(300031, 144, '2015-01-01 00:33:31.000000', 'temperatura', 954.0000, 'ºC'),
	(300032, 144, '2015-01-01 00:33:32.000000', 'temperatura', 256.0000, 'ºC'),
	(300033, 144, '2015-01-01 00:33:33.000000', 'temperatura', 822.0000, 'ºC'),
	(300034, 144, '2015-01-01 00:33:34.000000', 'temperatura', 941.0000, 'ºC'),
	(300035, 144, '2015-01-01 00:33:35.000000', 'temperatura', 1039.0000, 'ºC'),
	(300036, 144, '2015-01-01 00:33:36.000000', 'temperatura', 1174.0000, 'ºC'),
	(300037, 144, '2015-01-01 00:33:37.000000', 'temperatura', 353.0000, 'ºC'),
	(300038, 144, '2015-01-01 00:33:38.000000', 'temperatura', 643.0000, 'ºC'),
	(300039, 144, '2015-01-01 00:33:39.000000', 'temperatura', 955.0000, 'ºC'),
	(300040, 144, '2015-01-01 00:33:40.000000', 'temperatura', 446.0000, 'ºC'),
	(300041, 144, '2015-01-01 00:33:41.000000', 'temperatura', 567.0000, 'ºC'),
	(300042, 144, '2015-01-01 00:33:42.000000', 'temperatura', 299.0000, 'ºC'),
	(300043, 144, '2015-01-01 00:33:43.000000', 'temperatura', 993.0000, 'ºC'),
	(300044, 144, '2015-01-01 00:33:44.000000', 'temperatura', 468.0000, 'ºC'),
	(300045, 144, '2015-01-01 00:33:45.000000', 'temperatura', 561.0000, 'ºC'),
	(300046, 144, '2015-01-01 00:33:46.000000', 'temperatura', 202.0000, 'ºC'),
	(300047, 144, '2015-01-01 00:33:47.000000', 'temperatura', 527.0000, 'ºC'),
	(300048, 144, '2015-01-01 00:33:48.000000', 'temperatura', 829.0000, 'ºC'),
	(300049, 144, '2015-01-01 00:33:49.000000', 'temperatura', 164.0000, 'ºC'),
	(300050, 144, '2015-01-01 00:33:50.000000', 'temperatura', 734.0000, 'ºC'),
	(300051, 144, '2015-01-01 00:33:51.000000', 'temperatura', 779.0000, 'ºC'),
	(300052, 144, '2015-01-01 00:33:52.000000', 'temperatura', 493.0000, 'ºC'),
	(300053, 144, '2015-01-01 00:33:53.000000', 'temperatura', 127.0000, 'ºC'),
	(300054, 144, '2015-01-01 00:33:54.000000', 'temperatura', 356.0000, 'ºC'),
	(300055, 144, '2015-01-01 00:33:55.000000', 'temperatura', 200.0000, 'ºC'),
	(300056, 144, '2015-01-01 00:33:56.000000', 'temperatura', 1135.0000, 'ºC'),
	(300057, 144, '2015-01-01 00:33:57.000000', 'temperatura', 273.0000, 'ºC'),
	(300058, 144, '2015-01-01 00:33:58.000000', 'temperatura', 361.0000, 'ºC'),
	(300059, 144, '2015-01-01 00:33:59.000000', 'temperatura', 986.0000, 'ºC'),
	(300060, 144, '2015-01-01 00:34:00.000000', 'temperatura', 247.0000, 'ºC'),
	(300061, 144, '2015-01-01 00:34:01.000000', 'temperatura', 677.0000, 'ºC'),
	(300062, 144, '2015-01-01 00:34:02.000000', 'temperatura', 247.0000, 'ºC'),
	(300063, 144, '2015-01-01 00:34:03.000000', 'temperatura', 405.0000, 'ºC'),
	(300064, 144, '2015-01-01 00:34:04.000000', 'temperatura', 84.0000, 'ºC'),
	(300065, 144, '2015-01-01 00:34:05.000000', 'temperatura', 405.0000, 'ºC'),
	(300066, 144, '2015-01-01 00:34:06.000000', 'temperatura', 573.0000, 'ºC'),
	(300067, 144, '2015-01-01 00:34:07.000000', 'temperatura', 450.0000, 'ºC'),
	(300068, 144, '2015-01-01 00:34:08.000000', 'temperatura', 533.0000, 'ºC'),
	(300069, 144, '2015-01-01 00:34:09.000000', 'temperatura', 117.0000, 'ºC'),
	(300070, 144, '2015-01-01 00:34:10.000000', 'temperatura', 183.0000, 'ºC'),
	(300071, 144, '2015-01-01 00:34:11.000000', 'temperatura', 568.0000, 'ºC'),
	(300072, 144, '2015-01-01 00:34:12.000000', 'temperatura', 1088.0000, 'ºC'),
	(300073, 144, '2015-01-01 00:34:13.000000', 'temperatura', 138.0000, 'ºC'),
	(300074, 144, '2015-01-01 00:34:14.000000', 'temperatura', 1028.0000, 'ºC'),
	(300075, 144, '2015-01-01 00:34:15.000000', 'temperatura', 1127.0000, 'ºC'),
	(300076, 144, '2015-01-01 00:34:16.000000', 'temperatura', 150.0000, 'ºC'),
	(300077, 144, '2015-01-01 00:34:17.000000', 'temperatura', 968.0000, 'ºC'),
	(300078, 144, '2015-01-01 00:34:18.000000', 'temperatura', 793.0000, 'ºC'),
	(300079, 144, '2015-01-01 00:34:19.000000', 'temperatura', 1062.0000, 'ºC'),
	(300080, 144, '2015-01-01 00:34:20.000000', 'temperatura', 529.0000, 'ºC'),
	(300081, 144, '2015-01-01 00:34:21.000000', 'temperatura', 661.0000, 'ºC'),
	(300082, 144, '2015-01-01 00:34:22.000000', 'temperatura', 518.0000, 'ºC'),
	(300083, 144, '2015-01-01 00:34:23.000000', 'temperatura', 610.0000, 'ºC'),
	(300084, 144, '2015-01-01 00:34:24.000000', 'temperatura', 293.0000, 'ºC'),
	(300085, 144, '2015-01-01 00:34:25.000000', 'temperatura', 838.0000, 'ºC'),
	(300086, 144, '2015-01-01 00:34:26.000000', 'temperatura', 910.0000, 'ºC'),
	(300087, 144, '2015-01-01 00:34:27.000000', 'temperatura', 837.0000, 'ºC'),
	(300088, 144, '2015-01-01 00:34:28.000000', 'temperatura', 255.0000, 'ºC'),
	(300089, 144, '2015-01-01 00:34:29.000000', 'temperatura', 1164.0000, 'ºC'),
	(300090, 144, '2015-01-01 00:34:30.000000', 'temperatura', 257.0000, 'ºC'),
	(300091, 144, '2015-01-01 00:34:31.000000', 'temperatura', 192.0000, 'ºC'),
	(300092, 144, '2015-01-01 00:34:32.000000', 'temperatura', 188.0000, 'ºC'),
	(300093, 144, '2015-01-01 00:34:33.000000', 'temperatura', 367.0000, 'ºC'),
	(300094, 144, '2015-01-01 00:34:34.000000', 'temperatura', 72.0000, 'ºC'),
	(300095, 144, '2015-01-01 00:34:35.000000', 'temperatura', 460.0000, 'ºC'),
	(300096, 144, '2015-01-01 00:34:36.000000', 'temperatura', 883.0000, 'ºC'),
	(300097, 144, '2015-01-01 00:34:37.000000', 'temperatura', 638.0000, 'ºC'),
	(300098, 144, '2015-01-01 00:34:38.000000', 'temperatura', 538.0000, 'ºC'),
	(300099, 144, '2015-01-01 00:34:39.000000', 'temperatura', 779.0000, 'ºC'),
	(300100, 144, '2015-01-01 00:34:40.000000', 'temperatura', 1083.0000, 'ºC'),
	(300101, 144, '2015-01-01 00:34:41.000000', 'temperatura', 675.0000, 'ºC'),
	(300102, 144, '2015-01-01 00:34:42.000000', 'temperatura', 129.0000, 'ºC'),
	(300103, 144, '2015-01-01 00:34:43.000000', 'temperatura', 1018.0000, 'ºC'),
	(300104, 144, '2015-01-01 00:34:44.000000', 'temperatura', 1106.0000, 'ºC'),
	(300105, 144, '2015-01-01 00:34:45.000000', 'temperatura', 77.0000, 'ºC'),
	(300106, 144, '2015-01-01 00:34:46.000000', 'temperatura', 667.0000, 'ºC'),
	(300107, 144, '2015-01-01 00:34:47.000000', 'temperatura', 703.0000, 'ºC'),
	(300108, 144, '2015-01-01 00:34:48.000000', 'temperatura', 314.0000, 'ºC'),
	(300109, 144, '2015-01-01 00:34:49.000000', 'temperatura', 664.0000, 'ºC'),
	(300110, 144, '2015-01-01 00:34:50.000000', 'temperatura', 1177.0000, 'ºC'),
	(300111, 144, '2015-01-01 00:34:51.000000', 'temperatura', 292.0000, 'ºC'),
	(300112, 144, '2015-01-01 00:34:52.000000', 'temperatura', 329.0000, 'ºC'),
	(300113, 144, '2015-01-01 00:34:53.000000', 'temperatura', 772.0000, 'ºC'),
	(300114, 144, '2015-01-01 00:34:54.000000', 'temperatura', 474.0000, 'ºC'),
	(300115, 144, '2015-01-01 00:34:55.000000', 'temperatura', 55.0000, 'ºC'),
	(300116, 144, '2015-01-01 00:34:56.000000', 'temperatura', 53.0000, 'ºC'),
	(300117, 144, '2015-01-01 00:34:57.000000', 'temperatura', 100.0000, 'ºC'),
	(300118, 144, '2015-01-01 00:34:58.000000', 'temperatura', 342.0000, 'ºC'),
	(300119, 144, '2015-01-01 00:34:59.000000', 'temperatura', 209.0000, 'ºC'),
	(300120, 144, '2015-01-01 00:35:00.000000', 'temperatura', 22.0000, 'ºC'),
	(300121, 144, '2015-01-01 00:35:01.000000', 'temperatura', 684.0000, 'ºC'),
	(300122, 144, '2015-01-01 00:35:02.000000', 'temperatura', 952.0000, 'ºC'),
	(300123, 144, '2015-01-01 00:35:03.000000', 'temperatura', 308.0000, 'ºC'),
	(300124, 144, '2015-01-01 00:35:04.000000', 'temperatura', 1085.0000, 'ºC'),
	(300125, 144, '2015-01-01 00:35:05.000000', 'temperatura', 901.0000, 'ºC'),
	(300126, 144, '2015-01-01 00:35:06.000000', 'temperatura', 51.0000, 'ºC'),
	(300127, 144, '2015-01-01 00:35:07.000000', 'temperatura', 1150.0000, 'ºC'),
	(300128, 144, '2015-01-01 00:35:08.000000', 'temperatura', 801.0000, 'ºC'),
	(300129, 144, '2015-01-01 00:35:09.000000', 'temperatura', 556.0000, 'ºC'),
	(300130, 144, '2015-01-01 00:35:10.000000', 'temperatura', 375.0000, 'ºC'),
	(300131, 144, '2015-01-01 00:35:11.000000', 'temperatura', 209.0000, 'ºC'),
	(300132, 144, '2015-01-01 00:35:12.000000', 'temperatura', 1121.0000, 'ºC'),
	(300133, 144, '2015-01-01 00:35:13.000000', 'temperatura', 176.0000, 'ºC'),
	(300134, 144, '2015-01-01 00:35:14.000000', 'temperatura', 1118.0000, 'ºC'),
	(300135, 144, '2015-01-01 00:35:15.000000', 'temperatura', 261.0000, 'ºC'),
	(300136, 144, '2015-01-01 00:35:16.000000', 'temperatura', 355.0000, 'ºC'),
	(300137, 144, '2015-01-01 00:35:17.000000', 'temperatura', 991.0000, 'ºC'),
	(300138, 144, '2015-01-01 00:35:18.000000', 'temperatura', 292.0000, 'ºC'),
	(300139, 144, '2015-01-01 00:35:19.000000', 'temperatura', 885.0000, 'ºC'),
	(300140, 144, '2015-01-01 00:35:20.000000', 'temperatura', 1151.0000, 'ºC'),
	(300141, 144, '2015-01-01 00:35:21.000000', 'temperatura', 699.0000, 'ºC'),
	(300142, 144, '2015-01-01 00:35:22.000000', 'temperatura', 44.0000, 'ºC'),
	(300143, 144, '2015-01-01 00:35:23.000000', 'temperatura', 523.0000, 'ºC'),
	(300144, 144, '2015-01-01 00:35:24.000000', 'temperatura', 83.0000, 'ºC'),
	(300145, 144, '2015-01-01 00:35:25.000000', 'temperatura', 48.0000, 'ºC'),
	(300146, 144, '2015-01-01 00:35:26.000000', 'temperatura', 1189.0000, 'ºC'),
	(300147, 144, '2015-01-01 00:35:27.000000', 'temperatura', 1004.0000, 'ºC'),
	(300148, 144, '2015-01-01 00:35:28.000000', 'temperatura', 252.0000, 'ºC'),
	(300149, 144, '2015-01-01 00:35:29.000000', 'temperatura', 648.0000, 'ºC'),
	(300150, 144, '2015-01-01 00:35:30.000000', 'temperatura', 84.0000, 'ºC'),
	(300151, 144, '2015-01-01 00:35:31.000000', 'temperatura', 877.0000, 'ºC'),
	(300152, 144, '2015-01-01 00:35:32.000000', 'temperatura', 532.0000, 'ºC'),
	(300153, 144, '2015-01-01 00:35:33.000000', 'temperatura', 30.0000, 'ºC'),
	(300154, 144, '2015-01-01 00:35:34.000000', 'temperatura', 955.0000, 'ºC'),
	(300155, 144, '2015-01-01 00:35:35.000000', 'temperatura', 1086.0000, 'ºC'),
	(300156, 144, '2015-01-01 00:35:36.000000', 'temperatura', 164.0000, 'ºC'),
	(300157, 144, '2015-01-01 00:35:37.000000', 'temperatura', 1165.0000, 'ºC'),
	(300158, 144, '2015-01-01 00:35:38.000000', 'temperatura', 532.0000, 'ºC'),
	(300159, 144, '2015-01-01 00:35:39.000000', 'temperatura', 366.0000, 'ºC'),
	(300160, 144, '2015-01-01 00:35:40.000000', 'temperatura', 234.0000, 'ºC'),
	(300161, 144, '2015-01-01 00:35:41.000000', 'temperatura', 74.0000, 'ºC'),
	(300162, 144, '2015-01-01 00:35:42.000000', 'temperatura', 868.0000, 'ºC'),
	(300163, 144, '2015-01-01 00:35:43.000000', 'temperatura', 518.0000, 'ºC'),
	(300164, 144, '2015-01-01 00:35:44.000000', 'temperatura', 1187.0000, 'ºC'),
	(300165, 144, '2015-01-01 00:35:45.000000', 'temperatura', 783.0000, 'ºC'),
	(300166, 144, '2015-01-01 00:35:46.000000', 'temperatura', 353.0000, 'ºC'),
	(300167, 144, '2015-01-01 00:35:47.000000', 'temperatura', 616.0000, 'ºC'),
	(300168, 144, '2015-01-01 00:35:48.000000', 'temperatura', 821.0000, 'ºC'),
	(300169, 144, '2015-01-01 00:35:49.000000', 'temperatura', 1058.0000, 'ºC'),
	(300170, 144, '2015-01-01 00:35:50.000000', 'temperatura', 430.0000, 'ºC'),
	(300171, 144, '2015-01-01 00:35:51.000000', 'temperatura', 173.0000, 'ºC'),
	(300172, 144, '2015-01-01 00:35:52.000000', 'temperatura', 778.0000, 'ºC'),
	(300173, 144, '2015-01-01 00:35:53.000000', 'temperatura', 969.0000, 'ºC'),
	(300174, 144, '2015-01-01 00:35:54.000000', 'temperatura', 113.0000, 'ºC'),
	(300175, 144, '2015-01-01 00:35:55.000000', 'temperatura', 60.0000, 'ºC'),
	(300176, 144, '2015-01-01 00:35:56.000000', 'temperatura', 1162.0000, 'ºC'),
	(300177, 144, '2015-01-01 00:35:57.000000', 'temperatura', 827.0000, 'ºC'),
	(300178, 144, '2015-01-01 00:35:58.000000', 'temperatura', 653.0000, 'ºC'),
	(300179, 144, '2015-01-01 00:35:59.000000', 'temperatura', 782.0000, 'ºC'),
	(300180, 144, '2015-01-01 00:36:00.000000', 'temperatura', 753.0000, 'ºC'),
	(300181, 144, '2015-01-01 00:36:01.000000', 'temperatura', 221.0000, 'ºC'),
	(300182, 144, '2015-01-01 00:36:02.000000', 'temperatura', 45.0000, 'ºC'),
	(300183, 144, '2015-01-01 00:36:03.000000', 'temperatura', 761.0000, 'ºC'),
	(300184, 144, '2015-01-01 00:36:04.000000', 'temperatura', 73.0000, 'ºC'),
	(300185, 144, '2015-01-01 00:36:05.000000', 'temperatura', 482.0000, 'ºC'),
	(300186, 144, '2015-01-01 00:36:06.000000', 'temperatura', 992.0000, 'ºC'),
	(300187, 144, '2015-01-01 00:36:07.000000', 'temperatura', 1114.0000, 'ºC'),
	(300188, 144, '2015-01-01 00:36:08.000000', 'temperatura', 194.0000, 'ºC'),
	(300189, 144, '2015-01-01 00:36:09.000000', 'temperatura', 30.0000, 'ºC'),
	(300190, 144, '2015-01-01 00:36:10.000000', 'temperatura', 769.0000, 'ºC'),
	(300191, 144, '2015-01-01 00:36:11.000000', 'temperatura', 155.0000, 'ºC'),
	(300192, 144, '2015-01-01 00:36:12.000000', 'temperatura', 869.0000, 'ºC'),
	(300193, 144, '2015-01-01 00:36:13.000000', 'temperatura', 279.0000, 'ºC'),
	(300194, 144, '2015-01-01 00:36:14.000000', 'temperatura', 1190.0000, 'ºC'),
	(300195, 144, '2015-01-01 00:36:15.000000', 'temperatura', 312.0000, 'ºC'),
	(300196, 144, '2015-01-01 00:36:16.000000', 'temperatura', 390.0000, 'ºC'),
	(300197, 144, '2015-01-01 00:36:17.000000', 'temperatura', 1014.0000, 'ºC'),
	(300198, 144, '2015-01-01 00:36:18.000000', 'temperatura', 302.0000, 'ºC'),
	(300199, 144, '2015-01-01 00:36:19.000000', 'temperatura', 867.0000, 'ºC'),
	(300200, 144, '2015-01-01 00:36:20.000000', 'temperatura', 1029.0000, 'ºC'),
	(300201, 144, '2015-01-01 00:36:21.000000', 'temperatura', 146.0000, 'ºC'),
	(300202, 144, '2015-01-01 00:36:22.000000', 'temperatura', 42.0000, 'ºC'),
	(300203, 144, '2015-01-01 00:36:23.000000', 'temperatura', 972.0000, 'ºC'),
	(300204, 144, '2015-01-01 00:36:24.000000', 'temperatura', 1135.0000, 'ºC'),
	(300205, 144, '2015-01-01 00:36:25.000000', 'temperatura', 361.0000, 'ºC'),
	(300206, 144, '2015-01-01 00:36:26.000000', 'temperatura', 799.0000, 'ºC'),
	(300207, 144, '2015-01-01 00:36:27.000000', 'temperatura', 511.0000, 'ºC'),
	(300208, 144, '2015-01-01 00:36:28.000000', 'temperatura', 162.0000, 'ºC'),
	(300209, 144, '2015-01-01 00:36:29.000000', 'temperatura', 474.0000, 'ºC'),
	(300210, 144, '2015-01-01 00:36:30.000000', 'temperatura', 688.0000, 'ºC'),
	(300211, 144, '2015-01-01 00:36:31.000000', 'temperatura', 817.0000, 'ºC'),
	(300212, 144, '2015-01-01 00:36:32.000000', 'temperatura', 822.0000, 'ºC'),
	(300213, 144, '2015-01-01 00:36:33.000000', 'temperatura', 460.0000, 'ºC'),
	(300214, 144, '2015-01-01 00:36:34.000000', 'temperatura', 1032.0000, 'ºC'),
	(300215, 144, '2015-01-01 00:36:35.000000', 'temperatura', 183.0000, 'ºC'),
	(300216, 144, '2015-01-01 00:36:36.000000', 'temperatura', 218.0000, 'ºC'),
	(300217, 144, '2015-01-01 00:36:37.000000', 'temperatura', 542.0000, 'ºC'),
	(300218, 144, '2015-01-01 00:36:38.000000', 'temperatura', 855.0000, 'ºC'),
	(300219, 144, '2015-01-01 00:36:39.000000', 'temperatura', 250.0000, 'ºC'),
	(300220, 144, '2015-01-01 00:36:40.000000', 'temperatura', 1086.0000, 'ºC'),
	(300221, 144, '2015-01-01 00:36:41.000000', 'temperatura', 1081.0000, 'ºC'),
	(300222, 144, '2015-01-01 00:36:42.000000', 'temperatura', 948.0000, 'ºC'),
	(300223, 144, '2015-01-01 00:36:43.000000', 'temperatura', 297.0000, 'ºC'),
	(300224, 144, '2015-01-01 00:36:44.000000', 'temperatura', 1041.0000, 'ºC'),
	(300225, 144, '2015-01-01 00:36:45.000000', 'temperatura', 714.0000, 'ºC'),
	(300226, 144, '2015-01-01 00:36:46.000000', 'temperatura', 448.0000, 'ºC'),
	(300227, 144, '2015-01-01 00:36:47.000000', 'temperatura', 101.0000, 'ºC'),
	(300228, 144, '2015-01-01 00:36:48.000000', 'temperatura', 358.0000, 'ºC'),
	(300229, 144, '2015-01-01 00:36:49.000000', 'temperatura', 287.0000, 'ºC'),
	(300230, 144, '2015-01-01 00:36:50.000000', 'temperatura', 365.0000, 'ºC'),
	(300231, 144, '2015-01-01 00:36:51.000000', 'temperatura', 962.0000, 'ºC'),
	(300232, 144, '2015-01-01 00:36:52.000000', 'temperatura', 117.0000, 'ºC'),
	(300233, 144, '2015-01-01 00:36:53.000000', 'temperatura', 97.0000, 'ºC'),
	(300234, 144, '2015-01-01 00:36:54.000000', 'temperatura', 137.0000, 'ºC'),
	(300235, 144, '2015-01-01 00:36:55.000000', 'temperatura', 393.0000, 'ºC'),
	(300236, 144, '2015-01-01 00:36:56.000000', 'temperatura', 355.0000, 'ºC'),
	(300237, 144, '2015-01-01 00:36:57.000000', 'temperatura', 595.0000, 'ºC'),
	(300238, 144, '2015-01-01 00:36:58.000000', 'temperatura', 712.0000, 'ºC'),
	(300239, 144, '2015-01-01 00:36:59.000000', 'temperatura', 576.0000, 'ºC'),
	(300240, 144, '2015-01-01 00:37:00.000000', 'temperatura', 742.0000, 'ºC'),
	(300241, 144, '2015-01-01 00:37:01.000000', 'temperatura', 784.0000, 'ºC'),
	(300242, 144, '2015-01-01 00:37:02.000000', 'temperatura', 493.0000, 'ºC'),
	(300243, 144, '2015-01-01 00:37:03.000000', 'temperatura', 116.0000, 'ºC'),
	(300244, 144, '2015-01-01 00:37:04.000000', 'temperatura', 301.0000, 'ºC'),
	(300245, 144, '2015-01-01 00:37:05.000000', 'temperatura', 1156.0000, 'ºC'),
	(300246, 144, '2015-01-01 00:37:06.000000', 'temperatura', 78.0000, 'ºC'),
	(300247, 144, '2015-01-01 00:37:07.000000', 'temperatura', 522.0000, 'ºC'),
	(300248, 144, '2015-01-01 00:37:08.000000', 'temperatura', 1177.0000, 'ºC'),
	(300249, 144, '2015-01-01 00:37:09.000000', 'temperatura', 719.0000, 'ºC'),
	(300250, 144, '2015-01-01 00:37:10.000000', 'temperatura', 64.0000, 'ºC'),
	(300251, 144, '2015-01-01 00:37:11.000000', 'temperatura', 564.0000, 'ºC'),
	(300252, 144, '2015-01-01 00:37:12.000000', 'temperatura', 228.0000, 'ºC'),
	(300253, 144, '2015-01-01 00:37:13.000000', 'temperatura', 648.0000, 'ºC'),
	(300254, 144, '2015-01-01 00:37:14.000000', 'temperatura', 156.0000, 'ºC'),
	(300255, 144, '2015-01-01 00:37:15.000000', 'temperatura', 38.0000, 'ºC'),
	(300256, 144, '2015-01-01 00:37:16.000000', 'temperatura', 920.0000, 'ºC'),
	(300257, 144, '2015-01-01 00:37:17.000000', 'temperatura', 888.0000, 'ºC'),
	(300258, 144, '2015-01-01 00:37:18.000000', 'temperatura', 480.0000, 'ºC'),
	(300259, 144, '2015-01-01 00:37:19.000000', 'temperatura', 938.0000, 'ºC'),
	(300260, 144, '2015-01-01 00:37:20.000000', 'temperatura', 849.0000, 'ºC'),
	(300261, 144, '2015-01-01 00:37:21.000000', 'temperatura', 230.0000, 'ºC'),
	(300262, 144, '2015-01-01 00:37:22.000000', 'temperatura', 1005.0000, 'ºC'),
	(300263, 144, '2015-01-01 00:37:23.000000', 'temperatura', 736.0000, 'ºC'),
	(300264, 144, '2015-01-01 00:37:24.000000', 'temperatura', 667.0000, 'ºC'),
	(300265, 144, '2015-01-01 00:37:25.000000', 'temperatura', 1126.0000, 'ºC'),
	(300266, 144, '2015-01-01 00:37:26.000000', 'temperatura', 29.0000, 'ºC'),
	(300267, 144, '2015-01-01 00:37:27.000000', 'temperatura', 370.0000, 'ºC'),
	(300268, 144, '2015-01-01 00:37:28.000000', 'temperatura', 560.0000, 'ºC'),
	(300269, 144, '2015-01-01 00:37:29.000000', 'temperatura', 493.0000, 'ºC'),
	(300270, 144, '2015-01-01 00:37:30.000000', 'temperatura', 783.0000, 'ºC'),
	(300271, 144, '2015-01-01 00:37:31.000000', 'temperatura', 39.0000, 'ºC'),
	(300272, 144, '2015-01-01 00:37:32.000000', 'temperatura', 246.0000, 'ºC'),
	(300273, 144, '2015-01-01 00:37:33.000000', 'temperatura', 1112.0000, 'ºC'),
	(300274, 144, '2015-01-01 00:37:34.000000', 'temperatura', 22.0000, 'ºC'),
	(300275, 144, '2015-01-01 00:37:35.000000', 'temperatura', 375.0000, 'ºC'),
	(300276, 144, '2015-01-01 00:37:36.000000', 'temperatura', 611.0000, 'ºC'),
	(300277, 144, '2015-01-01 00:37:37.000000', 'temperatura', 732.0000, 'ºC'),
	(300278, 144, '2015-01-01 00:37:38.000000', 'temperatura', 625.0000, 'ºC'),
	(300279, 144, '2015-01-01 00:37:39.000000', 'temperatura', 930.0000, 'ºC'),
	(300280, 144, '2015-01-01 00:37:40.000000', 'temperatura', 376.0000, 'ºC'),
	(300281, 144, '2015-01-01 00:37:41.000000', 'temperatura', 291.0000, 'ºC'),
	(300282, 144, '2015-01-01 00:37:42.000000', 'temperatura', 327.0000, 'ºC'),
	(300283, 144, '2015-01-01 00:37:43.000000', 'temperatura', 763.0000, 'ºC'),
	(300284, 144, '2015-01-01 00:37:44.000000', 'temperatura', 433.0000, 'ºC'),
	(300285, 144, '2015-01-01 00:37:45.000000', 'temperatura', 1077.0000, 'ºC'),
	(300286, 144, '2015-01-01 00:37:46.000000', 'temperatura', 488.0000, 'ºC'),
	(300287, 144, '2015-01-01 00:37:47.000000', 'temperatura', 411.0000, 'ºC'),
	(300288, 144, '2015-01-01 00:37:48.000000', 'temperatura', 588.0000, 'ºC'),
	(300289, 144, '2015-01-01 00:37:49.000000', 'temperatura', 508.0000, 'ºC'),
	(300290, 144, '2015-01-01 00:37:50.000000', 'temperatura', 777.0000, 'ºC'),
	(300291, 144, '2015-01-01 00:37:51.000000', 'temperatura', 1160.0000, 'ºC'),
	(300292, 144, '2015-01-01 00:37:52.000000', 'temperatura', 1070.0000, 'ºC'),
	(300293, 144, '2015-01-01 00:37:53.000000', 'temperatura', 672.0000, 'ºC'),
	(300294, 144, '2015-01-01 00:37:54.000000', 'temperatura', 148.0000, 'ºC'),
	(300295, 144, '2015-01-01 00:37:55.000000', 'temperatura', 1128.0000, 'ºC'),
	(300296, 144, '2015-01-01 00:37:56.000000', 'temperatura', 393.0000, 'ºC'),
	(300297, 144, '2015-01-01 00:37:57.000000', 'temperatura', 983.0000, 'ºC'),
	(300298, 144, '2015-01-01 00:37:58.000000', 'temperatura', 138.0000, 'ºC'),
	(300299, 144, '2015-01-01 00:37:59.000000', 'temperatura', 138.0000, 'ºC'),
	(300300, 144, '2015-01-01 00:38:00.000000', 'temperatura', 280.0000, 'ºC'),
	(300301, 144, '2015-01-01 00:38:01.000000', 'temperatura', 986.0000, 'ºC'),
	(300302, 144, '2015-01-01 00:38:02.000000', 'temperatura', 489.0000, 'ºC'),
	(300303, 144, '2015-01-01 00:38:03.000000', 'temperatura', 689.0000, 'ºC'),
	(300304, 144, '2015-01-01 00:38:04.000000', 'temperatura', 778.0000, 'ºC'),
	(300305, 144, '2015-01-01 00:38:05.000000', 'temperatura', 624.0000, 'ºC'),
	(300306, 144, '2015-01-01 00:38:06.000000', 'temperatura', 786.0000, 'ºC'),
	(300307, 144, '2015-01-01 00:38:07.000000', 'temperatura', 859.0000, 'ºC'),
	(300308, 144, '2015-01-01 00:38:08.000000', 'temperatura', 735.0000, 'ºC'),
	(300309, 144, '2015-01-01 00:38:09.000000', 'temperatura', 1101.0000, 'ºC'),
	(300310, 144, '2015-01-01 00:38:10.000000', 'temperatura', 899.0000, 'ºC'),
	(300311, 144, '2015-01-01 00:38:11.000000', 'temperatura', 1193.0000, 'ºC'),
	(300312, 144, '2015-01-01 00:38:12.000000', 'temperatura', 867.0000, 'ºC'),
	(300313, 144, '2015-01-01 00:38:13.000000', 'temperatura', 759.0000, 'ºC'),
	(300314, 144, '2015-01-01 00:38:14.000000', 'temperatura', 1192.0000, 'ºC'),
	(300315, 144, '2015-01-01 00:38:15.000000', 'temperatura', 86.0000, 'ºC'),
	(300316, 144, '2015-01-01 00:38:16.000000', 'temperatura', 455.0000, 'ºC'),
	(300317, 144, '2015-01-01 00:38:17.000000', 'temperatura', 816.0000, 'ºC'),
	(300318, 144, '2015-01-01 00:38:18.000000', 'temperatura', 316.0000, 'ºC'),
	(300319, 144, '2015-01-01 00:38:19.000000', 'temperatura', 331.0000, 'ºC'),
	(300320, 144, '2015-01-01 00:38:20.000000', 'temperatura', 710.0000, 'ºC'),
	(300321, 144, '2015-01-01 00:38:21.000000', 'temperatura', 158.0000, 'ºC'),
	(300322, 144, '2015-01-01 00:38:22.000000', 'temperatura', 1059.0000, 'ºC'),
	(300323, 144, '2015-01-01 00:38:23.000000', 'temperatura', 23.0000, 'ºC'),
	(300324, 144, '2015-01-01 00:38:24.000000', 'temperatura', 536.0000, 'ºC'),
	(300325, 144, '2015-01-01 00:38:25.000000', 'temperatura', 211.0000, 'ºC'),
	(300326, 144, '2015-01-01 00:38:26.000000', 'temperatura', 649.0000, 'ºC'),
	(300327, 144, '2015-01-01 00:38:27.000000', 'temperatura', 212.0000, 'ºC'),
	(300328, 144, '2015-01-01 00:38:28.000000', 'temperatura', 312.0000, 'ºC'),
	(300329, 144, '2015-01-01 00:38:29.000000', 'temperatura', 927.0000, 'ºC'),
	(300330, 144, '2015-01-01 00:38:30.000000', 'temperatura', 97.0000, 'ºC'),
	(300331, 144, '2015-01-01 00:38:31.000000', 'temperatura', 104.0000, 'ºC'),
	(300332, 144, '2015-01-01 00:38:32.000000', 'temperatura', 230.0000, 'ºC'),
	(300333, 144, '2015-01-01 00:38:33.000000', 'temperatura', 838.0000, 'ºC'),
	(300334, 144, '2015-01-01 00:38:34.000000', 'temperatura', 1100.0000, 'ºC'),
	(300335, 144, '2015-01-01 00:38:35.000000', 'temperatura', 586.0000, 'ºC'),
	(300336, 144, '2015-01-01 00:38:36.000000', 'temperatura', 830.0000, 'ºC'),
	(300337, 144, '2015-01-01 00:38:37.000000', 'temperatura', 1192.0000, 'ºC'),
	(300338, 144, '2015-01-01 00:38:38.000000', 'temperatura', 1070.0000, 'ºC'),
	(300339, 144, '2015-01-01 00:38:39.000000', 'temperatura', 573.0000, 'ºC'),
	(300340, 144, '2015-01-01 00:38:40.000000', 'temperatura', 859.0000, 'ºC'),
	(300341, 144, '2015-01-01 00:38:41.000000', 'temperatura', 176.0000, 'ºC'),
	(300342, 144, '2015-01-01 00:38:42.000000', 'temperatura', 703.0000, 'ºC'),
	(300343, 144, '2015-01-01 00:38:43.000000', 'temperatura', 585.0000, 'ºC'),
	(300344, 144, '2015-01-01 00:38:44.000000', 'temperatura', 820.0000, 'ºC'),
	(300345, 144, '2015-01-01 00:38:45.000000', 'temperatura', 1145.0000, 'ºC'),
	(300346, 144, '2015-01-01 00:38:46.000000', 'temperatura', 865.0000, 'ºC'),
	(300347, 144, '2015-01-01 00:38:47.000000', 'temperatura', 892.0000, 'ºC'),
	(300348, 144, '2015-01-01 00:38:48.000000', 'temperatura', 663.0000, 'ºC'),
	(300349, 144, '2015-01-01 00:38:49.000000', 'temperatura', 639.0000, 'ºC'),
	(300350, 144, '2015-01-01 00:38:50.000000', 'temperatura', 6.0000, 'ºC'),
	(300351, 144, '2015-01-01 00:38:51.000000', 'temperatura', 515.0000, 'ºC'),
	(300352, 144, '2015-01-01 00:38:52.000000', 'temperatura', 156.0000, 'ºC'),
	(300353, 144, '2015-01-01 00:38:53.000000', 'temperatura', 438.0000, 'ºC'),
	(300354, 144, '2015-01-01 00:38:54.000000', 'temperatura', 522.0000, 'ºC'),
	(300355, 144, '2015-01-01 00:38:55.000000', 'temperatura', 94.0000, 'ºC'),
	(300356, 144, '2015-01-01 00:38:56.000000', 'temperatura', 107.0000, 'ºC'),
	(300357, 144, '2015-01-01 00:38:57.000000', 'temperatura', 253.0000, 'ºC'),
	(300358, 144, '2015-01-01 00:38:58.000000', 'temperatura', 944.0000, 'ºC'),
	(300359, 144, '2015-01-01 00:38:59.000000', 'temperatura', 360.0000, 'ºC'),
	(300360, 144, '2015-01-01 00:39:00.000000', 'temperatura', 169.0000, 'ºC'),
	(300361, 144, '2015-01-01 00:39:01.000000', 'temperatura', 964.0000, 'ºC'),
	(300362, 144, '2015-01-01 00:39:02.000000', 'temperatura', 717.0000, 'ºC'),
	(300363, 144, '2015-01-01 00:39:03.000000', 'temperatura', 691.0000, 'ºC'),
	(300364, 144, '2015-01-01 00:39:04.000000', 'temperatura', 104.0000, 'ºC'),
	(300365, 144, '2015-01-01 00:39:05.000000', 'temperatura', 846.0000, 'ºC'),
	(300366, 144, '2015-01-01 00:39:06.000000', 'temperatura', 322.0000, 'ºC'),
	(300367, 144, '2015-01-01 00:39:07.000000', 'temperatura', 270.0000, 'ºC'),
	(300368, 144, '2015-01-01 00:39:08.000000', 'temperatura', 387.0000, 'ºC'),
	(300369, 144, '2015-01-01 00:39:09.000000', 'temperatura', 1126.0000, 'ºC'),
	(300370, 144, '2015-01-01 00:39:10.000000', 'temperatura', 869.0000, 'ºC'),
	(300371, 144, '2015-01-01 00:39:11.000000', 'temperatura', 966.0000, 'ºC'),
	(300372, 144, '2015-01-01 00:39:12.000000', 'temperatura', 1025.0000, 'ºC'),
	(300373, 144, '2015-01-01 00:39:13.000000', 'temperatura', 1025.0000, 'ºC'),
	(300374, 144, '2015-01-01 00:39:14.000000', 'temperatura', 851.0000, 'ºC'),
	(300375, 144, '2015-01-01 00:39:15.000000', 'temperatura', 1182.0000, 'ºC'),
	(300376, 144, '2015-01-01 00:39:16.000000', 'temperatura', 955.0000, 'ºC'),
	(300377, 144, '2015-01-01 00:39:17.000000', 'temperatura', 31.0000, 'ºC'),
	(300378, 144, '2015-01-01 00:39:18.000000', 'temperatura', 889.0000, 'ºC'),
	(300379, 144, '2015-01-01 00:39:19.000000', 'temperatura', 752.0000, 'ºC'),
	(300380, 144, '2015-01-01 00:39:20.000000', 'temperatura', 1096.0000, 'ºC'),
	(300381, 144, '2015-01-01 00:39:21.000000', 'temperatura', 824.0000, 'ºC'),
	(300382, 144, '2015-01-01 00:39:22.000000', 'temperatura', 830.0000, 'ºC'),
	(300383, 144, '2015-01-01 00:39:23.000000', 'temperatura', 481.0000, 'ºC'),
	(300384, 144, '2015-01-01 00:39:24.000000', 'temperatura', 1115.0000, 'ºC'),
	(300385, 144, '2015-01-01 00:39:25.000000', 'temperatura', 534.0000, 'ºC'),
	(300386, 144, '2015-01-01 00:39:26.000000', 'temperatura', 525.0000, 'ºC'),
	(300387, 144, '2015-01-01 00:39:27.000000', 'temperatura', 1022.0000, 'ºC'),
	(300388, 144, '2015-01-01 00:39:28.000000', 'temperatura', 1135.0000, 'ºC'),
	(300389, 144, '2015-01-01 00:39:29.000000', 'temperatura', 209.0000, 'ºC'),
	(300390, 144, '2015-01-01 00:39:30.000000', 'temperatura', 41.0000, 'ºC'),
	(300391, 144, '2015-01-01 00:39:31.000000', 'temperatura', 780.0000, 'ºC'),
	(300392, 144, '2015-01-01 00:39:32.000000', 'temperatura', 175.0000, 'ºC'),
	(300393, 144, '2015-01-01 00:39:33.000000', 'temperatura', 936.0000, 'ºC'),
	(300394, 144, '2015-01-01 00:39:34.000000', 'temperatura', 554.0000, 'ºC'),
	(300395, 144, '2015-01-01 00:39:35.000000', 'temperatura', 1165.0000, 'ºC'),
	(300396, 144, '2015-01-01 00:39:36.000000', 'temperatura', 563.0000, 'ºC'),
	(300397, 144, '2015-01-01 00:39:37.000000', 'temperatura', 521.0000, 'ºC'),
	(300398, 144, '2015-01-01 00:39:38.000000', 'temperatura', 917.0000, 'ºC'),
	(300399, 144, '2015-01-01 00:39:39.000000', 'temperatura', 621.0000, 'ºC'),
	(300400, 144, '2015-01-01 00:39:40.000000', 'temperatura', 356.0000, 'ºC'),
	(300401, 144, '2015-01-01 00:39:41.000000', 'temperatura', 1119.0000, 'ºC'),
	(300402, 144, '2015-01-01 00:39:42.000000', 'temperatura', 924.0000, 'ºC'),
	(300403, 144, '2015-01-01 00:39:43.000000', 'temperatura', 65.0000, 'ºC'),
	(300404, 144, '2015-01-01 00:39:44.000000', 'temperatura', 1153.0000, 'ºC'),
	(300405, 144, '2015-01-01 00:39:45.000000', 'temperatura', 772.0000, 'ºC'),
	(300406, 144, '2015-01-01 00:39:46.000000', 'temperatura', 400.0000, 'ºC'),
	(300407, 144, '2015-01-01 00:39:47.000000', 'temperatura', 884.0000, 'ºC'),
	(300408, 144, '2015-01-01 00:39:48.000000', 'temperatura', 820.0000, 'ºC'),
	(300409, 144, '2015-01-01 00:39:49.000000', 'temperatura', 249.0000, 'ºC'),
	(300410, 144, '2015-01-01 00:39:50.000000', 'temperatura', 1186.0000, 'ºC'),
	(300411, 144, '2015-01-01 00:39:51.000000', 'temperatura', 381.0000, 'ºC'),
	(300412, 144, '2015-01-01 00:39:52.000000', 'temperatura', 751.0000, 'ºC'),
	(300413, 144, '2015-01-01 00:39:53.000000', 'temperatura', 212.0000, 'ºC'),
	(300414, 144, '2015-01-01 00:39:54.000000', 'temperatura', 6.0000, 'ºC'),
	(300415, 144, '2015-01-01 00:39:55.000000', 'temperatura', 595.0000, 'ºC'),
	(300416, 144, '2015-01-01 00:39:56.000000', 'temperatura', 558.0000, 'ºC'),
	(300417, 144, '2015-01-01 00:39:57.000000', 'temperatura', 1004.0000, 'ºC'),
	(300418, 144, '2015-01-01 00:39:58.000000', 'temperatura', 946.0000, 'ºC'),
	(300419, 144, '2015-01-01 00:39:59.000000', 'temperatura', 520.0000, 'ºC'),
	(300420, 144, '2015-01-01 00:40:00.000000', 'temperatura', 960.0000, 'ºC'),
	(300421, 144, '2015-01-01 00:40:01.000000', 'temperatura', 844.0000, 'ºC'),
	(300422, 144, '2015-01-01 00:40:02.000000', 'temperatura', 139.0000, 'ºC'),
	(300423, 144, '2015-01-01 00:40:03.000000', 'temperatura', 565.0000, 'ºC'),
	(300424, 144, '2015-01-01 00:40:04.000000', 'temperatura', 9.0000, 'ºC'),
	(300425, 144, '2015-01-01 00:40:05.000000', 'temperatura', 750.0000, 'ºC'),
	(300426, 144, '2015-01-01 00:40:06.000000', 'temperatura', 122.0000, 'ºC'),
	(300427, 144, '2015-01-01 00:40:07.000000', 'temperatura', 763.0000, 'ºC'),
	(300428, 144, '2015-01-01 00:40:08.000000', 'temperatura', 1049.0000, 'ºC'),
	(300429, 144, '2015-01-01 00:40:09.000000', 'temperatura', 554.0000, 'ºC'),
	(300430, 144, '2015-01-01 00:40:10.000000', 'temperatura', 825.0000, 'ºC'),
	(300431, 144, '2015-01-01 00:40:11.000000', 'temperatura', 64.0000, 'ºC'),
	(300432, 144, '2015-01-01 00:40:12.000000', 'temperatura', 243.0000, 'ºC'),
	(300433, 144, '2015-01-01 00:40:13.000000', 'temperatura', 1025.0000, 'ºC'),
	(300434, 144, '2015-01-01 00:40:14.000000', 'temperatura', 797.0000, 'ºC'),
	(300435, 144, '2015-01-01 00:40:15.000000', 'temperatura', 911.0000, 'ºC'),
	(300436, 144, '2015-01-01 00:40:16.000000', 'temperatura', 963.0000, 'ºC'),
	(300437, 144, '2015-01-01 00:40:17.000000', 'temperatura', 881.0000, 'ºC'),
	(300438, 144, '2015-01-01 00:40:18.000000', 'temperatura', 319.0000, 'ºC'),
	(300439, 144, '2015-01-01 00:40:19.000000', 'temperatura', 153.0000, 'ºC'),
	(300440, 144, '2015-01-01 00:40:20.000000', 'temperatura', 1006.0000, 'ºC'),
	(300441, 144, '2015-01-01 00:40:21.000000', 'temperatura', 972.0000, 'ºC'),
	(300442, 144, '2015-01-01 00:40:22.000000', 'temperatura', 644.0000, 'ºC'),
	(300443, 144, '2015-01-01 00:40:23.000000', 'temperatura', 304.0000, 'ºC'),
	(300444, 144, '2015-01-01 00:40:24.000000', 'temperatura', 787.0000, 'ºC'),
	(300445, 144, '2015-01-01 00:40:25.000000', 'temperatura', 623.0000, 'ºC'),
	(300446, 144, '2015-01-01 00:40:26.000000', 'temperatura', 757.0000, 'ºC'),
	(300447, 144, '2015-01-01 00:40:27.000000', 'temperatura', 714.0000, 'ºC'),
	(300448, 144, '2015-01-01 00:40:28.000000', 'temperatura', 99.0000, 'ºC'),
	(300449, 144, '2015-01-01 00:40:29.000000', 'temperatura', 753.0000, 'ºC'),
	(300450, 144, '2015-01-01 00:40:30.000000', 'temperatura', 1068.0000, 'ºC'),
	(300451, 144, '2015-01-01 00:40:31.000000', 'temperatura', 684.0000, 'ºC'),
	(300452, 144, '2015-01-01 00:40:32.000000', 'temperatura', 217.0000, 'ºC'),
	(300453, 144, '2015-01-01 00:40:33.000000', 'temperatura', 234.0000, 'ºC'),
	(300454, 144, '2015-01-01 00:40:34.000000', 'temperatura', 519.0000, 'ºC'),
	(300455, 144, '2015-01-01 00:40:35.000000', 'temperatura', 695.0000, 'ºC'),
	(300456, 144, '2015-01-01 00:40:36.000000', 'temperatura', 715.0000, 'ºC'),
	(300457, 144, '2015-01-01 00:40:37.000000', 'temperatura', 293.0000, 'ºC'),
	(300458, 144, '2015-01-01 00:40:38.000000', 'temperatura', 521.0000, 'ºC'),
	(300459, 144, '2015-01-01 00:40:39.000000', 'temperatura', 527.0000, 'ºC'),
	(300460, 144, '2015-01-01 00:40:40.000000', 'temperatura', 1073.0000, 'ºC'),
	(300461, 144, '2015-01-01 00:40:41.000000', 'temperatura', 182.0000, 'ºC'),
	(300462, 144, '2015-01-01 00:40:42.000000', 'temperatura', 92.0000, 'ºC'),
	(300463, 144, '2015-01-01 00:40:43.000000', 'temperatura', 1114.0000, 'ºC'),
	(300464, 144, '2015-01-01 00:40:44.000000', 'temperatura', 494.0000, 'ºC'),
	(300465, 144, '2015-01-01 00:40:45.000000', 'temperatura', 329.0000, 'ºC'),
	(300466, 144, '2015-01-01 00:40:46.000000', 'temperatura', 162.0000, 'ºC'),
	(300467, 144, '2015-01-01 00:40:47.000000', 'temperatura', 1024.0000, 'ºC'),
	(300468, 144, '2015-01-01 00:40:48.000000', 'temperatura', 1035.0000, 'ºC'),
	(300469, 144, '2015-01-01 00:40:49.000000', 'temperatura', 903.0000, 'ºC'),
	(300470, 144, '2015-01-01 00:40:50.000000', 'temperatura', 212.0000, 'ºC'),
	(300471, 144, '2015-01-01 00:40:51.000000', 'temperatura', 749.0000, 'ºC'),
	(300472, 144, '2015-01-01 00:40:52.000000', 'temperatura', 711.0000, 'ºC'),
	(300473, 144, '2015-01-01 00:40:53.000000', 'temperatura', 107.0000, 'ºC'),
	(300474, 144, '2015-01-01 00:40:54.000000', 'temperatura', 804.0000, 'ºC'),
	(300475, 144, '2015-01-01 00:40:55.000000', 'temperatura', 99.0000, 'ºC'),
	(300476, 144, '2015-01-01 00:40:56.000000', 'temperatura', 486.0000, 'ºC'),
	(300477, 144, '2015-01-01 00:40:57.000000', 'temperatura', 930.0000, 'ºC'),
	(300478, 144, '2015-01-01 00:40:58.000000', 'temperatura', 793.0000, 'ºC'),
	(300479, 144, '2015-01-01 00:40:59.000000', 'temperatura', 1174.0000, 'ºC'),
	(300480, 144, '2015-01-01 00:41:00.000000', 'temperatura', 1095.0000, 'ºC'),
	(300481, 144, '2015-01-01 00:41:01.000000', 'temperatura', 751.0000, 'ºC'),
	(300482, 144, '2015-01-01 00:41:02.000000', 'temperatura', 473.0000, 'ºC'),
	(300483, 144, '2015-01-01 00:41:03.000000', 'temperatura', 112.0000, 'ºC'),
	(300484, 144, '2015-01-01 00:41:04.000000', 'temperatura', 341.0000, 'ºC'),
	(300485, 144, '2015-01-01 00:41:05.000000', 'temperatura', 170.0000, 'ºC'),
	(300486, 144, '2015-01-01 00:41:06.000000', 'temperatura', 1029.0000, 'ºC'),
	(300487, 144, '2015-01-01 00:41:07.000000', 'temperatura', 1035.0000, 'ºC'),
	(300488, 144, '2015-01-01 00:41:08.000000', 'temperatura', 890.0000, 'ºC'),
	(300489, 144, '2015-01-01 00:41:09.000000', 'temperatura', 142.0000, 'ºC'),
	(300490, 144, '2015-01-01 00:41:10.000000', 'temperatura', 443.0000, 'ºC'),
	(300491, 144, '2015-01-01 00:41:11.000000', 'temperatura', 587.0000, 'ºC'),
	(300492, 144, '2015-01-01 00:41:12.000000', 'temperatura', 409.0000, 'ºC'),
	(300493, 144, '2015-01-01 00:41:13.000000', 'temperatura', 283.0000, 'ºC'),
	(300494, 144, '2015-01-01 00:41:14.000000', 'temperatura', 189.0000, 'ºC'),
	(300495, 144, '2015-01-01 00:41:15.000000', 'temperatura', 95.0000, 'ºC'),
	(300496, 144, '2015-01-01 00:41:16.000000', 'temperatura', 1108.0000, 'ºC'),
	(300497, 144, '2015-01-01 00:41:17.000000', 'temperatura', 456.0000, 'ºC'),
	(300498, 144, '2015-01-01 00:41:18.000000', 'temperatura', 157.0000, 'ºC'),
	(300499, 144, '2015-01-01 00:41:19.000000', 'temperatura', 617.0000, 'ºC'),
	(300500, 144, '2015-01-01 00:41:20.000000', 'temperatura', 214.0000, 'ºC'),
	(300501, 144, '2015-01-01 00:41:21.000000', 'temperatura', 418.0000, 'ºC'),
	(300502, 144, '2015-01-01 00:41:22.000000', 'temperatura', 251.0000, 'ºC'),
	(300503, 144, '2015-01-01 00:41:23.000000', 'temperatura', 1.0000, 'ºC'),
	(300504, 144, '2015-01-01 00:41:24.000000', 'temperatura', 451.0000, 'ºC'),
	(300505, 144, '2015-01-01 00:41:25.000000', 'temperatura', 1055.0000, 'ºC'),
	(300506, 144, '2015-01-01 00:41:26.000000', 'temperatura', 323.0000, 'ºC'),
	(300507, 144, '2015-01-01 00:41:27.000000', 'temperatura', 848.0000, 'ºC'),
	(300508, 144, '2015-01-01 00:41:28.000000', 'temperatura', 873.0000, 'ºC'),
	(300509, 144, '2015-01-01 00:41:29.000000', 'temperatura', 621.0000, 'ºC'),
	(300510, 144, '2015-01-01 00:41:30.000000', 'temperatura', 485.0000, 'ºC'),
	(300511, 144, '2015-01-01 00:41:31.000000', 'temperatura', 565.0000, 'ºC'),
	(300512, 144, '2015-01-01 00:41:32.000000', 'temperatura', 168.0000, 'ºC'),
	(300513, 144, '2015-01-01 00:41:33.000000', 'temperatura', 349.0000, 'ºC'),
	(300514, 144, '2015-01-01 00:41:34.000000', 'temperatura', 38.0000, 'ºC'),
	(300515, 144, '2015-01-01 00:41:35.000000', 'temperatura', 344.0000, 'ºC'),
	(300516, 144, '2015-01-01 00:41:36.000000', 'temperatura', 408.0000, 'ºC'),
	(300517, 144, '2015-01-01 00:41:37.000000', 'temperatura', 1007.0000, 'ºC'),
	(300518, 144, '2015-01-01 00:41:38.000000', 'temperatura', 214.0000, 'ºC'),
	(300519, 144, '2015-01-01 00:41:39.000000', 'temperatura', 447.0000, 'ºC'),
	(300520, 144, '2015-01-01 00:41:40.000000', 'temperatura', 396.0000, 'ºC'),
	(300521, 144, '2015-01-01 00:41:41.000000', 'temperatura', 638.0000, 'ºC'),
	(300522, 144, '2015-01-01 00:41:42.000000', 'temperatura', 803.0000, 'ºC'),
	(300523, 144, '2015-01-01 00:41:43.000000', 'temperatura', 901.0000, 'ºC'),
	(300524, 144, '2015-01-01 00:41:44.000000', 'temperatura', 898.0000, 'ºC'),
	(300525, 144, '2015-01-01 00:41:45.000000', 'temperatura', 585.0000, 'ºC'),
	(300526, 144, '2015-01-01 00:41:46.000000', 'temperatura', 234.0000, 'ºC'),
	(300527, 144, '2015-01-01 00:41:47.000000', 'temperatura', 615.0000, 'ºC'),
	(300528, 144, '2015-01-01 00:41:48.000000', 'temperatura', 1172.0000, 'ºC'),
	(300529, 144, '2015-01-01 00:41:49.000000', 'temperatura', 418.0000, 'ºC'),
	(300530, 144, '2015-01-01 00:41:50.000000', 'temperatura', 974.0000, 'ºC'),
	(300531, 144, '2015-01-01 00:41:51.000000', 'temperatura', 17.0000, 'ºC'),
	(300532, 144, '2015-01-01 00:41:52.000000', 'temperatura', 765.0000, 'ºC'),
	(300533, 144, '2015-01-01 00:41:53.000000', 'temperatura', 172.0000, 'ºC'),
	(300534, 144, '2015-01-01 00:41:54.000000', 'temperatura', 965.0000, 'ºC'),
	(300535, 144, '2015-01-01 00:41:55.000000', 'temperatura', 710.0000, 'ºC'),
	(300536, 144, '2015-01-01 00:41:56.000000', 'temperatura', 655.0000, 'ºC'),
	(300537, 144, '2015-01-01 00:41:57.000000', 'temperatura', 1147.0000, 'ºC'),
	(300538, 144, '2015-01-01 00:41:58.000000', 'temperatura', 169.0000, 'ºC'),
	(300539, 144, '2015-01-01 00:41:59.000000', 'temperatura', 1003.0000, 'ºC'),
	(300540, 144, '2015-01-01 00:42:00.000000', 'temperatura', 912.0000, 'ºC'),
	(300541, 144, '2015-01-01 00:42:01.000000', 'temperatura', 350.0000, 'ºC'),
	(300542, 144, '2015-01-01 00:42:02.000000', 'temperatura', 215.0000, 'ºC'),
	(300543, 144, '2015-01-01 00:42:03.000000', 'temperatura', 24.0000, 'ºC'),
	(300544, 144, '2015-01-01 00:42:04.000000', 'temperatura', 678.0000, 'ºC'),
	(300545, 144, '2015-01-01 00:42:05.000000', 'temperatura', 917.0000, 'ºC'),
	(300546, 144, '2015-01-01 00:42:06.000000', 'temperatura', 151.0000, 'ºC'),
	(300547, 144, '2015-01-01 00:42:07.000000', 'temperatura', 404.0000, 'ºC'),
	(300548, 144, '2015-01-01 00:42:08.000000', 'temperatura', 367.0000, 'ºC'),
	(300549, 144, '2015-01-01 00:42:09.000000', 'temperatura', 624.0000, 'ºC'),
	(300550, 144, '2015-01-01 00:42:10.000000', 'temperatura', 821.0000, 'ºC'),
	(300551, 144, '2015-01-01 00:42:11.000000', 'temperatura', 1034.0000, 'ºC'),
	(300552, 144, '2015-01-01 00:42:12.000000', 'temperatura', 309.0000, 'ºC'),
	(300553, 144, '2015-01-01 00:42:13.000000', 'temperatura', 840.0000, 'ºC'),
	(300554, 144, '2015-01-01 00:42:14.000000', 'temperatura', 876.0000, 'ºC'),
	(300555, 144, '2015-01-01 00:42:15.000000', 'temperatura', 661.0000, 'ºC'),
	(300556, 144, '2015-01-01 00:42:16.000000', 'temperatura', 675.0000, 'ºC'),
	(300557, 144, '2015-01-01 00:42:17.000000', 'temperatura', 192.0000, 'ºC'),
	(300558, 144, '2015-01-01 00:42:18.000000', 'temperatura', 134.0000, 'ºC'),
	(300559, 144, '2015-01-01 00:42:19.000000', 'temperatura', 98.0000, 'ºC'),
	(300560, 144, '2015-01-01 00:42:20.000000', 'temperatura', 89.0000, 'ºC'),
	(300561, 144, '2015-01-01 00:42:21.000000', 'temperatura', 150.0000, 'ºC'),
	(300562, 144, '2015-01-01 00:42:22.000000', 'temperatura', 482.0000, 'ºC'),
	(300563, 144, '2015-01-01 00:42:23.000000', 'temperatura', 763.0000, 'ºC'),
	(300564, 144, '2015-01-01 00:42:24.000000', 'temperatura', 1171.0000, 'ºC'),
	(300565, 144, '2015-01-01 00:42:25.000000', 'temperatura', 1163.0000, 'ºC'),
	(300566, 144, '2015-01-01 00:42:26.000000', 'temperatura', 1105.0000, 'ºC'),
	(300567, 144, '2015-01-01 00:42:27.000000', 'temperatura', 834.0000, 'ºC'),
	(300568, 144, '2015-01-01 00:42:28.000000', 'temperatura', 855.0000, 'ºC'),
	(300569, 144, '2015-01-01 00:42:29.000000', 'temperatura', 574.0000, 'ºC'),
	(300570, 144, '2015-01-01 00:42:30.000000', 'temperatura', 304.0000, 'ºC'),
	(300571, 144, '2015-01-01 00:42:31.000000', 'temperatura', 1000.0000, 'ºC'),
	(300572, 144, '2015-01-01 00:42:32.000000', 'temperatura', 488.0000, 'ºC'),
	(300573, 144, '2015-01-01 00:42:33.000000', 'temperatura', 641.0000, 'ºC'),
	(300574, 144, '2015-01-01 00:42:34.000000', 'temperatura', 542.0000, 'ºC'),
	(300575, 144, '2015-01-01 00:42:35.000000', 'temperatura', 787.0000, 'ºC'),
	(300576, 144, '2015-01-01 00:42:36.000000', 'temperatura', 1111.0000, 'ºC'),
	(300577, 144, '2015-01-01 00:42:37.000000', 'temperatura', 791.0000, 'ºC'),
	(300578, 144, '2015-01-01 00:42:38.000000', 'temperatura', 626.0000, 'ºC'),
	(300579, 144, '2015-01-01 00:42:39.000000', 'temperatura', 756.0000, 'ºC'),
	(300580, 144, '2015-01-01 00:42:40.000000', 'temperatura', 704.0000, 'ºC'),
	(300581, 144, '2015-01-01 00:42:41.000000', 'temperatura', 50.0000, 'ºC'),
	(300582, 144, '2015-01-01 00:42:42.000000', 'temperatura', 539.0000, 'ºC'),
	(300583, 144, '2015-01-01 00:42:43.000000', 'temperatura', 145.0000, 'ºC'),
	(300584, 144, '2015-01-01 00:42:44.000000', 'temperatura', 309.0000, 'ºC'),
	(300585, 144, '2015-01-01 00:42:45.000000', 'temperatura', 1109.0000, 'ºC'),
	(300586, 144, '2015-01-01 00:42:46.000000', 'temperatura', 1019.0000, 'ºC'),
	(300587, 144, '2015-01-01 00:42:47.000000', 'temperatura', 569.0000, 'ºC'),
	(300588, 144, '2015-01-01 00:42:48.000000', 'temperatura', 987.0000, 'ºC'),
	(300589, 144, '2015-01-01 00:42:49.000000', 'temperatura', 831.0000, 'ºC'),
	(300590, 144, '2015-01-01 00:42:50.000000', 'temperatura', 1191.0000, 'ºC'),
	(300591, 144, '2015-01-01 00:42:51.000000', 'temperatura', 1066.0000, 'ºC'),
	(300592, 144, '2015-01-01 00:42:52.000000', 'temperatura', 557.0000, 'ºC'),
	(300593, 144, '2015-01-01 00:42:53.000000', 'temperatura', 785.0000, 'ºC'),
	(300594, 144, '2015-01-01 00:42:54.000000', 'temperatura', 1056.0000, 'ºC'),
	(300595, 144, '2015-01-01 00:42:55.000000', 'temperatura', 526.0000, 'ºC'),
	(300596, 144, '2015-01-01 00:42:56.000000', 'temperatura', 661.0000, 'ºC'),
	(300597, 144, '2015-01-01 00:42:57.000000', 'temperatura', 530.0000, 'ºC'),
	(300598, 144, '2015-01-01 00:42:58.000000', 'temperatura', 665.0000, 'ºC'),
	(300599, 144, '2015-01-01 00:42:59.000000', 'temperatura', 535.0000, 'ºC'),
	(300600, 144, '2015-01-01 00:43:00.000000', 'temperatura', 683.0000, 'ºC'),
	(300601, 144, '2015-01-01 00:43:01.000000', 'temperatura', 611.0000, 'ºC'),
	(300602, 144, '2015-01-01 00:43:02.000000', 'temperatura', 1005.0000, 'ºC'),
	(300603, 144, '2015-01-01 00:43:03.000000', 'temperatura', 791.0000, 'ºC'),
	(300604, 144, '2015-01-01 00:43:04.000000', 'temperatura', 943.0000, 'ºC'),
	(300605, 144, '2015-01-01 00:43:05.000000', 'temperatura', 1140.0000, 'ºC'),
	(300606, 144, '2015-01-01 00:43:06.000000', 'temperatura', 471.0000, 'ºC'),
	(300607, 144, '2015-01-01 00:43:07.000000', 'temperatura', 136.0000, 'ºC'),
	(300608, 144, '2015-01-01 00:43:08.000000', 'temperatura', 468.0000, 'ºC'),
	(300609, 144, '2015-01-01 00:43:09.000000', 'temperatura', 731.0000, 'ºC'),
	(300610, 144, '2015-01-01 00:43:10.000000', 'temperatura', 1053.0000, 'ºC'),
	(300611, 144, '2015-01-01 00:43:11.000000', 'temperatura', 672.0000, 'ºC'),
	(300612, 144, '2015-01-01 00:43:12.000000', 'temperatura', 200.0000, 'ºC'),
	(300613, 144, '2015-01-01 00:43:13.000000', 'temperatura', 185.0000, 'ºC'),
	(300614, 144, '2015-01-01 00:43:14.000000', 'temperatura', 326.0000, 'ºC'),
	(300615, 144, '2015-01-01 00:43:15.000000', 'temperatura', 1076.0000, 'ºC'),
	(300616, 144, '2015-01-01 00:43:16.000000', 'temperatura', 801.0000, 'ºC'),
	(300617, 144, '2015-01-01 00:43:17.000000', 'temperatura', 777.0000, 'ºC'),
	(300618, 144, '2015-01-01 00:43:18.000000', 'temperatura', 285.0000, 'ºC'),
	(300619, 144, '2015-01-01 00:43:19.000000', 'temperatura', 295.0000, 'ºC'),
	(300620, 144, '2015-01-01 00:43:20.000000', 'temperatura', 621.0000, 'ºC'),
	(300621, 144, '2015-01-01 00:43:21.000000', 'temperatura', 1019.0000, 'ºC'),
	(300622, 144, '2015-01-01 00:43:22.000000', 'temperatura', 833.0000, 'ºC'),
	(300623, 144, '2015-01-01 00:43:23.000000', 'temperatura', 1107.0000, 'ºC'),
	(300624, 144, '2015-01-01 00:43:24.000000', 'temperatura', 638.0000, 'ºC'),
	(300625, 144, '2015-01-01 00:43:25.000000', 'temperatura', 1069.0000, 'ºC'),
	(300626, 144, '2015-01-01 00:43:26.000000', 'temperatura', 1030.0000, 'ºC'),
	(300627, 144, '2015-01-01 00:43:27.000000', 'temperatura', 744.0000, 'ºC'),
	(300628, 144, '2015-01-01 00:43:28.000000', 'temperatura', 631.0000, 'ºC'),
	(300629, 144, '2015-01-01 00:43:29.000000', 'temperatura', 924.0000, 'ºC'),
	(300630, 144, '2015-01-01 00:43:30.000000', 'temperatura', 329.0000, 'ºC'),
	(300631, 144, '2015-01-01 00:43:31.000000', 'temperatura', 73.0000, 'ºC'),
	(300632, 144, '2015-01-01 00:43:32.000000', 'temperatura', 579.0000, 'ºC'),
	(300633, 144, '2015-01-01 00:43:33.000000', 'temperatura', 276.0000, 'ºC'),
	(300634, 144, '2015-01-01 00:43:34.000000', 'temperatura', 842.0000, 'ºC'),
	(300635, 144, '2015-01-01 00:43:35.000000', 'temperatura', 981.0000, 'ºC'),
	(300636, 144, '2015-01-01 00:43:36.000000', 'temperatura', 1183.0000, 'ºC'),
	(300637, 144, '2015-01-01 00:43:37.000000', 'temperatura', 571.0000, 'ºC'),
	(300638, 144, '2015-01-01 00:43:38.000000', 'temperatura', 507.0000, 'ºC'),
	(300639, 144, '2015-01-01 00:43:39.000000', 'temperatura', 821.0000, 'ºC'),
	(300640, 144, '2015-01-01 00:43:40.000000', 'temperatura', 186.0000, 'ºC'),
	(300641, 144, '2015-01-01 00:43:41.000000', 'temperatura', 866.0000, 'ºC'),
	(300642, 144, '2015-01-01 00:43:42.000000', 'temperatura', 173.0000, 'ºC'),
	(300643, 144, '2015-01-01 00:43:43.000000', 'temperatura', 666.0000, 'ºC'),
	(300644, 144, '2015-01-01 00:43:44.000000', 'temperatura', 411.0000, 'ºC'),
	(300645, 144, '2015-01-01 00:43:45.000000', 'temperatura', 57.0000, 'ºC'),
	(300646, 144, '2015-01-01 00:43:46.000000', 'temperatura', 255.0000, 'ºC'),
	(300647, 144, '2015-01-01 00:43:47.000000', 'temperatura', 1104.0000, 'ºC'),
	(300648, 144, '2015-01-01 00:43:48.000000', 'temperatura', 1156.0000, 'ºC'),
	(300649, 144, '2015-01-01 00:43:49.000000', 'temperatura', 70.0000, 'ºC'),
	(300650, 144, '2015-01-01 00:43:50.000000', 'temperatura', 481.0000, 'ºC'),
	(300651, 144, '2015-01-01 00:43:51.000000', 'temperatura', 997.0000, 'ºC'),
	(300652, 144, '2015-01-01 00:43:52.000000', 'temperatura', 1140.0000, 'ºC'),
	(300653, 144, '2015-01-01 00:43:53.000000', 'temperatura', 310.0000, 'ºC'),
	(300654, 144, '2015-01-01 00:43:54.000000', 'temperatura', 529.0000, 'ºC'),
	(300655, 144, '2015-01-01 00:43:55.000000', 'temperatura', 516.0000, 'ºC'),
	(300656, 144, '2015-01-01 00:43:56.000000', 'temperatura', 995.0000, 'ºC'),
	(300657, 144, '2015-01-01 00:43:57.000000', 'temperatura', 1026.0000, 'ºC'),
	(300658, 144, '2015-01-01 00:43:58.000000', 'temperatura', 947.0000, 'ºC'),
	(300659, 144, '2015-01-01 00:43:59.000000', 'temperatura', 457.0000, 'ºC'),
	(300660, 144, '2015-01-01 00:44:00.000000', 'temperatura', 647.0000, 'ºC'),
	(300661, 144, '2015-01-01 00:44:01.000000', 'temperatura', 661.0000, 'ºC'),
	(300662, 144, '2015-01-01 00:44:02.000000', 'temperatura', 164.0000, 'ºC'),
	(300663, 144, '2015-01-01 00:44:03.000000', 'temperatura', 39.0000, 'ºC'),
	(300664, 144, '2015-01-01 00:44:04.000000', 'temperatura', 903.0000, 'ºC'),
	(300665, 144, '2015-01-01 00:44:05.000000', 'temperatura', 799.0000, 'ºC'),
	(300666, 144, '2015-01-01 00:44:06.000000', 'temperatura', 86.0000, 'ºC'),
	(300667, 144, '2015-01-01 00:44:07.000000', 'temperatura', 434.0000, 'ºC'),
	(300668, 144, '2015-01-01 00:44:08.000000', 'temperatura', 711.0000, 'ºC'),
	(300669, 144, '2015-01-01 00:44:09.000000', 'temperatura', 1053.0000, 'ºC'),
	(300670, 144, '2015-01-01 00:44:10.000000', 'temperatura', 732.0000, 'ºC'),
	(300671, 144, '2015-01-01 00:44:11.000000', 'temperatura', 503.0000, 'ºC'),
	(300672, 144, '2015-01-01 00:44:12.000000', 'temperatura', 320.0000, 'ºC'),
	(300673, 144, '2015-01-01 00:44:13.000000', 'temperatura', 92.0000, 'ºC'),
	(300674, 144, '2015-01-01 00:44:14.000000', 'temperatura', 698.0000, 'ºC'),
	(300675, 144, '2015-01-01 00:44:15.000000', 'temperatura', 818.0000, 'ºC'),
	(300676, 144, '2015-01-01 00:44:16.000000', 'temperatura', 794.0000, 'ºC'),
	(300677, 144, '2015-01-01 00:44:17.000000', 'temperatura', 317.0000, 'ºC'),
	(300678, 144, '2015-01-01 00:44:18.000000', 'temperatura', 403.0000, 'ºC'),
	(300679, 144, '2015-01-01 00:44:19.000000', 'temperatura', 1066.0000, 'ºC'),
	(300680, 144, '2015-01-01 00:44:20.000000', 'temperatura', 520.0000, 'ºC'),
	(300681, 144, '2015-01-01 00:44:21.000000', 'temperatura', 603.0000, 'ºC'),
	(300682, 144, '2015-01-01 00:44:22.000000', 'temperatura', 254.0000, 'ºC'),
	(300683, 144, '2015-01-01 00:44:23.000000', 'temperatura', 665.0000, 'ºC'),
	(300684, 144, '2015-01-01 00:44:24.000000', 'temperatura', 160.0000, 'ºC'),
	(300685, 144, '2015-01-01 00:44:25.000000', 'temperatura', 7.0000, 'ºC'),
	(300686, 144, '2015-01-01 00:44:26.000000', 'temperatura', 755.0000, 'ºC'),
	(300687, 144, '2015-01-01 00:44:27.000000', 'temperatura', 156.0000, 'ºC'),
	(300688, 144, '2015-01-01 00:44:28.000000', 'temperatura', 917.0000, 'ºC'),
	(300689, 144, '2015-01-01 00:44:29.000000', 'temperatura', 515.0000, 'ºC'),
	(300690, 144, '2015-01-01 00:44:30.000000', 'temperatura', 1023.0000, 'ºC'),
	(300691, 144, '2015-01-01 00:44:31.000000', 'temperatura', 1172.0000, 'ºC'),
	(300692, 144, '2015-01-01 00:44:32.000000', 'temperatura', 390.0000, 'ºC'),
	(300693, 144, '2015-01-01 00:44:33.000000', 'temperatura', 837.0000, 'ºC'),
	(300694, 144, '2015-01-01 00:44:34.000000', 'temperatura', 614.0000, 'ºC'),
	(300695, 144, '2015-01-01 00:44:35.000000', 'temperatura', 561.0000, 'ºC'),
	(300696, 144, '2015-01-01 00:44:36.000000', 'temperatura', 963.0000, 'ºC'),
	(300697, 144, '2015-01-01 00:44:37.000000', 'temperatura', 733.0000, 'ºC'),
	(300698, 144, '2015-01-01 00:44:38.000000', 'temperatura', 778.0000, 'ºC'),
	(300699, 144, '2015-01-01 00:44:39.000000', 'temperatura', 489.0000, 'ºC'),
	(300700, 144, '2015-01-01 00:44:40.000000', 'temperatura', 112.0000, 'ºC'),
	(300701, 144, '2015-01-01 00:44:41.000000', 'temperatura', 295.0000, 'ºC'),
	(300702, 144, '2015-01-01 00:44:42.000000', 'temperatura', 1139.0000, 'ºC'),
	(300703, 144, '2015-01-01 00:44:43.000000', 'temperatura', 9.0000, 'ºC'),
	(300704, 144, '2015-01-01 00:44:44.000000', 'temperatura', 231.0000, 'ºC'),
	(300705, 144, '2015-01-01 00:44:45.000000', 'temperatura', 1128.0000, 'ºC'),
	(300706, 144, '2015-01-01 00:44:46.000000', 'temperatura', 148.0000, 'ºC'),
	(300707, 144, '2015-01-01 00:44:47.000000', 'temperatura', 957.0000, 'ºC'),
	(300708, 144, '2015-01-01 00:44:48.000000', 'temperatura', 740.0000, 'ºC'),
	(300709, 144, '2015-01-01 00:44:49.000000', 'temperatura', 830.0000, 'ºC'),
	(300710, 144, '2015-01-01 00:44:50.000000', 'temperatura', 730.0000, 'ºC'),
	(300711, 144, '2015-01-01 00:44:51.000000', 'temperatura', 1161.0000, 'ºC'),
	(300712, 144, '2015-01-01 00:44:52.000000', 'temperatura', 15.0000, 'ºC'),
	(300713, 144, '2015-01-01 00:44:53.000000', 'temperatura', 194.0000, 'ºC'),
	(300714, 144, '2015-01-01 00:44:54.000000', 'temperatura', 926.0000, 'ºC'),
	(300715, 144, '2015-01-01 00:44:55.000000', 'temperatura', 448.0000, 'ºC'),
	(300716, 144, '2015-01-01 00:44:56.000000', 'temperatura', 660.0000, 'ºC'),
	(300717, 144, '2015-01-01 00:44:57.000000', 'temperatura', 760.0000, 'ºC'),
	(300718, 144, '2015-01-01 00:44:58.000000', 'temperatura', 620.0000, 'ºC'),
	(300719, 144, '2015-01-01 00:44:59.000000', 'temperatura', 818.0000, 'ºC'),
	(300720, 144, '2015-01-01 00:45:00.000000', 'temperatura', 1031.0000, 'ºC'),
	(300721, 144, '2015-01-01 00:45:01.000000', 'temperatura', 302.0000, 'ºC'),
	(300722, 144, '2015-01-01 00:45:02.000000', 'temperatura', 817.0000, 'ºC'),
	(300723, 144, '2015-01-01 00:45:03.000000', 'temperatura', 781.0000, 'ºC'),
	(300724, 144, '2015-01-01 00:45:04.000000', 'temperatura', 252.0000, 'ºC'),
	(300725, 144, '2015-01-01 00:45:05.000000', 'temperatura', 118.0000, 'ºC'),
	(300726, 144, '2015-01-01 00:45:06.000000', 'temperatura', 1034.0000, 'ºC'),
	(300727, 144, '2015-01-01 00:45:07.000000', 'temperatura', 19.0000, 'ºC'),
	(300728, 144, '2015-01-01 00:45:08.000000', 'temperatura', 591.0000, 'ºC'),
	(300729, 144, '2015-01-01 00:45:09.000000', 'temperatura', 498.0000, 'ºC'),
	(300730, 144, '2015-01-01 00:45:10.000000', 'temperatura', 719.0000, 'ºC'),
	(300731, 144, '2015-01-01 00:45:11.000000', 'temperatura', 901.0000, 'ºC'),
	(300732, 144, '2015-01-01 00:45:12.000000', 'temperatura', 1151.0000, 'ºC'),
	(300733, 144, '2015-01-01 00:45:13.000000', 'temperatura', 649.0000, 'ºC'),
	(300734, 144, '2015-01-01 00:45:14.000000', 'temperatura', 994.0000, 'ºC'),
	(300735, 144, '2015-01-01 00:45:15.000000', 'temperatura', 625.0000, 'ºC'),
	(300736, 144, '2015-01-01 00:45:16.000000', 'temperatura', 144.0000, 'ºC'),
	(300737, 144, '2015-01-01 00:45:17.000000', 'temperatura', 44.0000, 'ºC'),
	(300738, 144, '2015-01-01 00:45:18.000000', 'temperatura', 987.0000, 'ºC'),
	(300739, 144, '2015-01-01 00:45:19.000000', 'temperatura', 3.0000, 'ºC'),
	(300740, 144, '2015-01-01 00:45:20.000000', 'temperatura', 657.0000, 'ºC'),
	(300741, 144, '2015-01-01 00:45:21.000000', 'temperatura', 877.0000, 'ºC'),
	(300742, 144, '2015-01-01 00:45:22.000000', 'temperatura', 12.0000, 'ºC'),
	(300743, 144, '2015-01-01 00:45:23.000000', 'temperatura', 1029.0000, 'ºC'),
	(300744, 144, '2015-01-01 00:45:24.000000', 'temperatura', 312.0000, 'ºC'),
	(300745, 144, '2015-01-01 00:45:25.000000', 'temperatura', 873.0000, 'ºC'),
	(300746, 144, '2015-01-01 00:45:26.000000', 'temperatura', 1030.0000, 'ºC'),
	(300747, 144, '2015-01-01 00:45:27.000000', 'temperatura', 130.0000, 'ºC'),
	(300748, 144, '2015-01-01 00:45:28.000000', 'temperatura', 1160.0000, 'ºC'),
	(300749, 144, '2015-01-01 00:45:29.000000', 'temperatura', 610.0000, 'ºC'),
	(300750, 144, '2015-01-01 00:45:30.000000', 'temperatura', 771.0000, 'ºC'),
	(300751, 144, '2015-01-01 00:45:31.000000', 'temperatura', 827.0000, 'ºC'),
	(300752, 144, '2015-01-01 00:45:32.000000', 'temperatura', 622.0000, 'ºC'),
	(300753, 144, '2015-01-01 00:45:33.000000', 'temperatura', 630.0000, 'ºC'),
	(300754, 144, '2015-01-01 00:45:34.000000', 'temperatura', 85.0000, 'ºC'),
	(300755, 144, '2015-01-01 00:45:35.000000', 'temperatura', 934.0000, 'ºC'),
	(300756, 144, '2015-01-01 00:45:36.000000', 'temperatura', 817.0000, 'ºC'),
	(300757, 144, '2015-01-01 00:45:37.000000', 'temperatura', 82.0000, 'ºC'),
	(300758, 144, '2015-01-01 00:45:38.000000', 'temperatura', 361.0000, 'ºC'),
	(300759, 144, '2015-01-01 00:45:39.000000', 'temperatura', 359.0000, 'ºC'),
	(300760, 144, '2015-01-01 00:45:40.000000', 'temperatura', 714.0000, 'ºC'),
	(300761, 144, '2015-01-01 00:45:41.000000', 'temperatura', 91.0000, 'ºC'),
	(300762, 144, '2015-01-01 00:45:42.000000', 'temperatura', 713.0000, 'ºC'),
	(300763, 144, '2015-01-01 00:45:43.000000', 'temperatura', 892.0000, 'ºC'),
	(300764, 144, '2015-01-01 00:45:44.000000', 'temperatura', 1125.0000, 'ºC'),
	(300765, 144, '2015-01-01 00:45:45.000000', 'temperatura', 546.0000, 'ºC'),
	(300766, 144, '2015-01-01 00:45:46.000000', 'temperatura', 557.0000, 'ºC'),
	(300767, 144, '2015-01-01 00:45:47.000000', 'temperatura', 1145.0000, 'ºC'),
	(300768, 144, '2015-01-01 00:45:48.000000', 'temperatura', 457.0000, 'ºC'),
	(300769, 144, '2015-01-01 00:45:49.000000', 'temperatura', 51.0000, 'ºC'),
	(300770, 144, '2015-01-01 00:45:50.000000', 'temperatura', 82.0000, 'ºC'),
	(300771, 144, '2015-01-01 00:45:51.000000', 'temperatura', 259.0000, 'ºC'),
	(300772, 144, '2015-01-01 00:45:52.000000', 'temperatura', 1051.0000, 'ºC'),
	(300773, 144, '2015-01-01 00:45:53.000000', 'temperatura', 877.0000, 'ºC'),
	(300774, 144, '2015-01-01 00:45:54.000000', 'temperatura', 34.0000, 'ºC'),
	(300775, 144, '2015-01-01 00:45:55.000000', 'temperatura', 1140.0000, 'ºC'),
	(300776, 144, '2015-01-01 00:45:56.000000', 'temperatura', 797.0000, 'ºC'),
	(300777, 144, '2015-01-01 00:45:57.000000', 'temperatura', 567.0000, 'ºC'),
	(300778, 144, '2015-01-01 00:45:58.000000', 'temperatura', 445.0000, 'ºC'),
	(300779, 144, '2015-01-01 00:45:59.000000', 'temperatura', 523.0000, 'ºC'),
	(300780, 144, '2015-01-01 00:46:00.000000', 'temperatura', 81.0000, 'ºC'),
	(300781, 144, '2015-01-01 00:46:01.000000', 'temperatura', 35.0000, 'ºC'),
	(300782, 144, '2015-01-01 00:46:02.000000', 'temperatura', 1132.0000, 'ºC'),
	(300783, 144, '2015-01-01 00:46:03.000000', 'temperatura', 759.0000, 'ºC'),
	(300784, 144, '2015-01-01 00:46:04.000000', 'temperatura', 396.0000, 'ºC'),
	(300785, 144, '2015-01-01 00:46:05.000000', 'temperatura', 905.0000, 'ºC'),
	(300786, 144, '2015-01-01 00:46:06.000000', 'temperatura', 936.0000, 'ºC'),
	(300787, 144, '2015-01-01 00:46:07.000000', 'temperatura', 768.0000, 'ºC'),
	(300788, 144, '2015-01-01 00:46:08.000000', 'temperatura', 1032.0000, 'ºC'),
	(300789, 144, '2015-01-01 00:46:09.000000', 'temperatura', 457.0000, 'ºC'),
	(300790, 144, '2015-01-01 00:46:10.000000', 'temperatura', 388.0000, 'ºC'),
	(300791, 144, '2015-01-01 00:46:11.000000', 'temperatura', 572.0000, 'ºC'),
	(300792, 144, '2015-01-01 00:46:12.000000', 'temperatura', 495.0000, 'ºC'),
	(300793, 144, '2015-01-01 00:46:13.000000', 'temperatura', 759.0000, 'ºC'),
	(300794, 144, '2015-01-01 00:46:14.000000', 'temperatura', 1110.0000, 'ºC'),
	(300795, 144, '2015-01-01 00:46:15.000000', 'temperatura', 874.0000, 'ºC'),
	(300796, 144, '2015-01-01 00:46:16.000000', 'temperatura', 1039.0000, 'ºC'),
	(300797, 144, '2015-01-01 00:46:17.000000', 'temperatura', 173.0000, 'ºC'),
	(300798, 144, '2015-01-01 00:46:18.000000', 'temperatura', 151.0000, 'ºC'),
	(300799, 144, '2015-01-01 00:46:19.000000', 'temperatura', 237.0000, 'ºC'),
	(300800, 144, '2015-01-01 00:46:20.000000', 'temperatura', 732.0000, 'ºC'),
	(300801, 144, '2015-01-01 00:46:21.000000', 'temperatura', 547.0000, 'ºC'),
	(300802, 144, '2015-01-01 00:46:22.000000', 'temperatura', 542.0000, 'ºC'),
	(300803, 144, '2015-01-01 00:46:23.000000', 'temperatura', 1071.0000, 'ºC'),
	(300804, 144, '2015-01-01 00:46:24.000000', 'temperatura', 126.0000, 'ºC'),
	(300805, 144, '2015-01-01 00:46:25.000000', 'temperatura', 1021.0000, 'ºC'),
	(300806, 144, '2015-01-01 00:46:26.000000', 'temperatura', 1125.0000, 'ºC'),
	(300807, 144, '2015-01-01 00:46:27.000000', 'temperatura', 162.0000, 'ºC'),
	(300808, 144, '2015-01-01 00:46:28.000000', 'temperatura', 1036.0000, 'ºC'),
	(300809, 144, '2015-01-01 00:46:29.000000', 'temperatura', 1093.0000, 'ºC'),
	(300810, 144, '2015-01-01 00:46:30.000000', 'temperatura', 1157.0000, 'ºC'),
	(300811, 144, '2015-01-01 00:46:31.000000', 'temperatura', 108.0000, 'ºC'),
	(300812, 144, '2015-01-01 00:46:32.000000', 'temperatura', 669.0000, 'ºC'),
	(300813, 144, '2015-01-01 00:46:33.000000', 'temperatura', 623.0000, 'ºC'),
	(300814, 144, '2015-01-01 00:46:34.000000', 'temperatura', 1106.0000, 'ºC'),
	(300815, 144, '2015-01-01 00:46:35.000000', 'temperatura', 64.0000, 'ºC'),
	(300816, 144, '2015-01-01 00:46:36.000000', 'temperatura', 600.0000, 'ºC'),
	(300817, 144, '2015-01-01 00:46:37.000000', 'temperatura', 408.0000, 'ºC'),
	(300818, 144, '2015-01-01 00:46:38.000000', 'temperatura', 242.0000, 'ºC'),
	(300819, 144, '2015-01-01 00:46:39.000000', 'temperatura', 1184.0000, 'ºC'),
	(300820, 144, '2015-01-01 00:46:40.000000', 'temperatura', 396.0000, 'ºC'),
	(300821, 144, '2015-01-01 00:46:41.000000', 'temperatura', 831.0000, 'ºC'),
	(300822, 144, '2015-01-01 00:46:42.000000', 'temperatura', 564.0000, 'ºC'),
	(300823, 144, '2015-01-01 00:46:43.000000', 'temperatura', 330.0000, 'ºC'),
	(300824, 144, '2015-01-01 00:46:44.000000', 'temperatura', 1159.0000, 'ºC'),
	(300825, 144, '2015-01-01 00:46:45.000000', 'temperatura', 5.0000, 'ºC'),
	(300826, 144, '2015-01-01 00:46:46.000000', 'temperatura', 146.0000, 'ºC'),
	(300827, 144, '2015-01-01 00:46:47.000000', 'temperatura', 719.0000, 'ºC'),
	(300828, 144, '2015-01-01 00:46:48.000000', 'temperatura', 756.0000, 'ºC'),
	(300829, 144, '2015-01-01 00:46:49.000000', 'temperatura', 423.0000, 'ºC'),
	(300830, 144, '2015-01-01 00:46:50.000000', 'temperatura', 1048.0000, 'ºC'),
	(300831, 144, '2015-01-01 00:46:51.000000', 'temperatura', 369.0000, 'ºC'),
	(300832, 144, '2015-01-01 00:46:52.000000', 'temperatura', 1105.0000, 'ºC'),
	(300833, 144, '2015-01-01 00:46:53.000000', 'temperatura', 816.0000, 'ºC'),
	(300834, 144, '2015-01-01 00:46:54.000000', 'temperatura', 766.0000, 'ºC'),
	(300835, 144, '2015-01-01 00:46:55.000000', 'temperatura', 181.0000, 'ºC'),
	(300836, 144, '2015-01-01 00:46:56.000000', 'temperatura', 1008.0000, 'ºC'),
	(300837, 144, '2015-01-01 00:46:57.000000', 'temperatura', 898.0000, 'ºC'),
	(300838, 144, '2015-01-01 00:46:58.000000', 'temperatura', 265.0000, 'ºC'),
	(300839, 144, '2015-01-01 00:46:59.000000', 'temperatura', 1032.0000, 'ºC'),
	(300840, 144, '2015-01-01 00:47:00.000000', 'temperatura', 764.0000, 'ºC'),
	(300841, 144, '2015-01-01 00:47:01.000000', 'temperatura', 725.0000, 'ºC'),
	(300842, 144, '2015-01-01 00:47:02.000000', 'temperatura', 133.0000, 'ºC'),
	(300843, 144, '2015-01-01 00:47:03.000000', 'temperatura', 891.0000, 'ºC'),
	(300844, 144, '2015-01-01 00:47:04.000000', 'temperatura', 455.0000, 'ºC'),
	(300845, 144, '2015-01-01 00:47:05.000000', 'temperatura', 802.0000, 'ºC'),
	(300846, 144, '2015-01-01 00:47:06.000000', 'temperatura', 247.0000, 'ºC'),
	(300847, 144, '2015-01-01 00:47:07.000000', 'temperatura', 29.0000, 'ºC'),
	(300848, 144, '2015-01-01 00:47:08.000000', 'temperatura', 606.0000, 'ºC'),
	(300849, 144, '2015-01-01 00:47:09.000000', 'temperatura', 542.0000, 'ºC'),
	(300850, 144, '2015-01-01 00:47:10.000000', 'temperatura', 895.0000, 'ºC'),
	(300851, 144, '2015-01-01 00:47:11.000000', 'temperatura', 448.0000, 'ºC'),
	(300852, 144, '2015-01-01 00:47:12.000000', 'temperatura', 755.0000, 'ºC'),
	(300853, 144, '2015-01-01 00:47:13.000000', 'temperatura', 33.0000, 'ºC'),
	(300854, 144, '2015-01-01 00:47:14.000000', 'temperatura', 298.0000, 'ºC'),
	(300855, 144, '2015-01-01 00:47:15.000000', 'temperatura', 191.0000, 'ºC'),
	(300856, 144, '2015-01-01 00:47:16.000000', 'temperatura', 65.0000, 'ºC'),
	(300857, 144, '2015-01-01 00:47:17.000000', 'temperatura', 949.0000, 'ºC'),
	(300858, 144, '2015-01-01 00:47:18.000000', 'temperatura', 951.0000, 'ºC'),
	(300859, 144, '2015-01-01 00:47:19.000000', 'temperatura', 710.0000, 'ºC'),
	(300860, 144, '2015-01-01 00:47:20.000000', 'temperatura', 697.0000, 'ºC'),
	(300861, 144, '2015-01-01 00:47:21.000000', 'temperatura', 157.0000, 'ºC'),
	(300862, 144, '2015-01-01 00:47:22.000000', 'temperatura', 1091.0000, 'ºC'),
	(300863, 144, '2015-01-01 00:47:23.000000', 'temperatura', 187.0000, 'ºC'),
	(300864, 144, '2015-01-01 00:47:24.000000', 'temperatura', 63.0000, 'ºC'),
	(300865, 144, '2015-01-01 00:47:25.000000', 'temperatura', 955.0000, 'ºC'),
	(300866, 144, '2015-01-01 00:47:26.000000', 'temperatura', 988.0000, 'ºC'),
	(300867, 144, '2015-01-01 00:47:27.000000', 'temperatura', 873.0000, 'ºC'),
	(300868, 144, '2015-01-01 00:47:28.000000', 'temperatura', 201.0000, 'ºC'),
	(300869, 144, '2015-01-01 00:47:29.000000', 'temperatura', 786.0000, 'ºC'),
	(300870, 144, '2015-01-01 00:47:30.000000', 'temperatura', 930.0000, 'ºC'),
	(300871, 144, '2015-01-01 00:47:31.000000', 'temperatura', 1089.0000, 'ºC'),
	(300872, 144, '2015-01-01 00:47:32.000000', 'temperatura', 259.0000, 'ºC'),
	(300873, 144, '2015-01-01 00:47:33.000000', 'temperatura', 427.0000, 'ºC'),
	(300874, 144, '2015-01-01 00:47:34.000000', 'temperatura', 157.0000, 'ºC'),
	(300875, 144, '2015-01-01 00:47:35.000000', 'temperatura', 705.0000, 'ºC'),
	(300876, 144, '2015-01-01 00:47:36.000000', 'temperatura', 654.0000, 'ºC'),
	(300877, 144, '2015-01-01 00:47:37.000000', 'temperatura', 1154.0000, 'ºC'),
	(300878, 144, '2015-01-01 00:47:38.000000', 'temperatura', 210.0000, 'ºC'),
	(300879, 144, '2015-01-01 00:47:39.000000', 'temperatura', 1190.0000, 'ºC'),
	(300880, 144, '2015-01-01 00:47:40.000000', 'temperatura', 518.0000, 'ºC'),
	(300881, 144, '2015-01-01 00:47:41.000000', 'temperatura', 221.0000, 'ºC'),
	(300882, 144, '2015-01-01 00:47:42.000000', 'temperatura', 751.0000, 'ºC'),
	(300883, 144, '2015-01-01 00:47:43.000000', 'temperatura', 694.0000, 'ºC'),
	(300884, 144, '2015-01-01 00:47:44.000000', 'temperatura', 16.0000, 'ºC'),
	(300885, 144, '2015-01-01 00:47:45.000000', 'temperatura', 401.0000, 'ºC'),
	(300886, 144, '2015-01-01 00:47:46.000000', 'temperatura', 755.0000, 'ºC'),
	(300887, 144, '2015-01-01 00:47:47.000000', 'temperatura', 175.0000, 'ºC'),
	(300888, 144, '2015-01-01 00:47:48.000000', 'temperatura', 1011.0000, 'ºC'),
	(300889, 144, '2015-01-01 00:47:49.000000', 'temperatura', 930.0000, 'ºC'),
	(300890, 144, '2015-01-01 00:47:50.000000', 'temperatura', 417.0000, 'ºC'),
	(300891, 144, '2015-01-01 00:47:51.000000', 'temperatura', 498.0000, 'ºC'),
	(300892, 144, '2015-01-01 00:47:52.000000', 'temperatura', 36.0000, 'ºC'),
	(300893, 144, '2015-01-01 00:47:53.000000', 'temperatura', 1087.0000, 'ºC'),
	(300894, 144, '2015-01-01 00:47:54.000000', 'temperatura', 529.0000, 'ºC'),
	(300895, 144, '2015-01-01 00:47:55.000000', 'temperatura', 583.0000, 'ºC'),
	(300896, 144, '2015-01-01 00:47:56.000000', 'temperatura', 127.0000, 'ºC'),
	(300897, 144, '2015-01-01 00:47:57.000000', 'temperatura', 88.0000, 'ºC'),
	(300898, 144, '2015-01-01 00:47:58.000000', 'temperatura', 61.0000, 'ºC'),
	(300899, 144, '2015-01-01 00:47:59.000000', 'temperatura', 39.0000, 'ºC'),
	(300900, 144, '2015-01-01 00:48:00.000000', 'temperatura', 15.0000, 'ºC'),
	(300901, 144, '2015-01-01 00:48:01.000000', 'temperatura', 1157.0000, 'ºC'),
	(300902, 144, '2015-01-01 00:48:02.000000', 'temperatura', 941.0000, 'ºC'),
	(300903, 144, '2015-01-01 00:48:03.000000', 'temperatura', 33.0000, 'ºC'),
	(300904, 144, '2015-01-01 00:48:04.000000', 'temperatura', 944.0000, 'ºC'),
	(300905, 144, '2015-01-01 00:48:05.000000', 'temperatura', 1020.0000, 'ºC'),
	(300906, 144, '2015-01-01 00:48:06.000000', 'temperatura', 1070.0000, 'ºC'),
	(300907, 144, '2015-01-01 00:48:07.000000', 'temperatura', 1089.0000, 'ºC'),
	(300908, 144, '2015-01-01 00:48:08.000000', 'temperatura', 1034.0000, 'ºC'),
	(300909, 144, '2015-01-01 00:48:09.000000', 'temperatura', 707.0000, 'ºC'),
	(300910, 144, '2015-01-01 00:48:10.000000', 'temperatura', 431.0000, 'ºC'),
	(300911, 144, '2015-01-01 00:48:11.000000', 'temperatura', 36.0000, 'ºC'),
	(300912, 144, '2015-01-01 00:48:12.000000', 'temperatura', 87.0000, 'ºC'),
	(300913, 144, '2015-01-01 00:48:13.000000', 'temperatura', 326.0000, 'ºC'),
	(300914, 144, '2015-01-01 00:48:14.000000', 'temperatura', 169.0000, 'ºC'),
	(300915, 144, '2015-01-01 00:48:15.000000', 'temperatura', 1069.0000, 'ºC'),
	(300916, 144, '2015-01-01 00:48:16.000000', 'temperatura', 36.0000, 'ºC'),
	(300917, 144, '2015-01-01 00:48:17.000000', 'temperatura', 576.0000, 'ºC'),
	(300918, 144, '2015-01-01 00:48:18.000000', 'temperatura', 371.0000, 'ºC'),
	(300919, 144, '2015-01-01 00:48:19.000000', 'temperatura', 130.0000, 'ºC'),
	(300920, 144, '2015-01-01 00:48:20.000000', 'temperatura', 734.0000, 'ºC'),
	(300921, 144, '2015-01-01 00:48:21.000000', 'temperatura', 884.0000, 'ºC'),
	(300922, 144, '2015-01-01 00:48:22.000000', 'temperatura', 1015.0000, 'ºC'),
	(300923, 144, '2015-01-01 00:48:23.000000', 'temperatura', 26.0000, 'ºC'),
	(300924, 144, '2015-01-01 00:48:24.000000', 'temperatura', 686.0000, 'ºC'),
	(300925, 144, '2015-01-01 00:48:25.000000', 'temperatura', 952.0000, 'ºC'),
	(300926, 144, '2015-01-01 00:48:26.000000', 'temperatura', 302.0000, 'ºC'),
	(300927, 144, '2015-01-01 00:48:27.000000', 'temperatura', 1053.0000, 'ºC'),
	(300928, 144, '2015-01-01 00:48:28.000000', 'temperatura', 762.0000, 'ºC'),
	(300929, 144, '2015-01-01 00:48:29.000000', 'temperatura', 651.0000, 'ºC'),
	(300930, 144, '2015-01-01 00:48:30.000000', 'temperatura', 968.0000, 'ºC'),
	(300931, 144, '2015-01-01 00:48:31.000000', 'temperatura', 490.0000, 'ºC'),
	(300932, 144, '2015-01-01 00:48:32.000000', 'temperatura', 743.0000, 'ºC'),
	(300933, 144, '2015-01-01 00:48:33.000000', 'temperatura', 1049.0000, 'ºC'),
	(300934, 144, '2015-01-01 00:48:34.000000', 'temperatura', 614.0000, 'ºC'),
	(300935, 144, '2015-01-01 00:48:35.000000', 'temperatura', 1124.0000, 'ºC'),
	(300936, 144, '2015-01-01 00:48:36.000000', 'temperatura', 180.0000, 'ºC'),
	(300937, 144, '2015-01-01 00:48:37.000000', 'temperatura', 1128.0000, 'ºC'),
	(300938, 144, '2015-01-01 00:48:38.000000', 'temperatura', 301.0000, 'ºC'),
	(300939, 144, '2015-01-01 00:48:39.000000', 'temperatura', 521.0000, 'ºC'),
	(300940, 144, '2015-01-01 00:48:40.000000', 'temperatura', 504.0000, 'ºC'),
	(300941, 144, '2015-01-01 00:48:41.000000', 'temperatura', 958.0000, 'ºC'),
	(300942, 144, '2015-01-01 00:48:42.000000', 'temperatura', 878.0000, 'ºC'),
	(300943, 144, '2015-01-01 00:48:43.000000', 'temperatura', 315.0000, 'ºC'),
	(300944, 144, '2015-01-01 00:48:44.000000', 'temperatura', 141.0000, 'ºC'),
	(300945, 144, '2015-01-01 00:48:45.000000', 'temperatura', 962.0000, 'ºC'),
	(300946, 144, '2015-01-01 00:48:46.000000', 'temperatura', 787.0000, 'ºC'),
	(300947, 144, '2015-01-01 00:48:47.000000', 'temperatura', 1049.0000, 'ºC'),
	(300948, 144, '2015-01-01 00:48:48.000000', 'temperatura', 487.0000, 'ºC'),
	(300949, 144, '2015-01-01 00:48:49.000000', 'temperatura', 486.0000, 'ºC'),
	(300950, 144, '2015-01-01 00:48:50.000000', 'temperatura', 970.0000, 'ºC'),
	(300951, 144, '2015-01-01 00:48:51.000000', 'temperatura', 992.0000, 'ºC'),
	(300952, 144, '2015-01-01 00:48:52.000000', 'temperatura', 849.0000, 'ºC'),
	(300953, 144, '2015-01-01 00:48:53.000000', 'temperatura', 71.0000, 'ºC'),
	(300954, 144, '2015-01-01 00:48:54.000000', 'temperatura', 208.0000, 'ºC'),
	(300955, 144, '2015-01-01 00:48:55.000000', 'temperatura', 829.0000, 'ºC'),
	(300956, 144, '2015-01-01 00:48:56.000000', 'temperatura', 1122.0000, 'ºC'),
	(300957, 144, '2015-01-01 00:48:57.000000', 'temperatura', 724.0000, 'ºC'),
	(300958, 144, '2015-01-01 00:48:58.000000', 'temperatura', 255.0000, 'ºC'),
	(300959, 144, '2015-01-01 00:48:59.000000', 'temperatura', 301.0000, 'ºC'),
	(300960, 144, '2015-01-01 00:49:00.000000', 'temperatura', 744.0000, 'ºC'),
	(300961, 144, '2015-01-01 00:49:01.000000', 'temperatura', 414.0000, 'ºC'),
	(300962, 144, '2015-01-01 00:49:02.000000', 'temperatura', 1038.0000, 'ºC'),
	(300963, 144, '2015-01-01 00:49:03.000000', 'temperatura', 350.0000, 'ºC'),
	(300964, 144, '2015-01-01 00:49:04.000000', 'temperatura', 1038.0000, 'ºC'),
	(300965, 144, '2015-01-01 00:49:05.000000', 'temperatura', 541.0000, 'ºC'),
	(300966, 144, '2015-01-01 00:49:06.000000', 'temperatura', 790.0000, 'ºC'),
	(300967, 144, '2015-01-01 00:49:07.000000', 'temperatura', 1126.0000, 'ºC'),
	(300968, 144, '2015-01-01 00:49:08.000000', 'temperatura', 862.0000, 'ºC'),
	(300969, 144, '2015-01-01 00:49:09.000000', 'temperatura', 934.0000, 'ºC'),
	(300970, 144, '2015-01-01 00:49:10.000000', 'temperatura', 882.0000, 'ºC'),
	(300971, 144, '2015-01-01 00:49:11.000000', 'temperatura', 409.0000, 'ºC'),
	(300972, 144, '2015-01-01 00:49:12.000000', 'temperatura', 600.0000, 'ºC'),
	(300973, 144, '2015-01-01 00:49:13.000000', 'temperatura', 572.0000, 'ºC'),
	(300974, 144, '2015-01-01 00:49:14.000000', 'temperatura', 1060.0000, 'ºC'),
	(300975, 144, '2015-01-01 00:49:15.000000', 'temperatura', 1185.0000, 'ºC'),
	(300976, 144, '2015-01-01 00:49:16.000000', 'temperatura', 347.0000, 'ºC'),
	(300977, 144, '2015-01-01 00:49:17.000000', 'temperatura', 581.0000, 'ºC'),
	(300978, 144, '2015-01-01 00:49:18.000000', 'temperatura', 662.0000, 'ºC'),
	(300979, 144, '2015-01-01 00:49:19.000000', 'temperatura', 370.0000, 'ºC'),
	(300980, 144, '2015-01-01 00:49:20.000000', 'temperatura', 1063.0000, 'ºC'),
	(300981, 144, '2015-01-01 00:49:21.000000', 'temperatura', 605.0000, 'ºC'),
	(300982, 144, '2015-01-01 00:49:22.000000', 'temperatura', 1036.0000, 'ºC'),
	(300983, 144, '2015-01-01 00:49:23.000000', 'temperatura', 964.0000, 'ºC'),
	(300984, 144, '2015-01-01 00:49:24.000000', 'temperatura', 515.0000, 'ºC'),
	(300985, 144, '2015-01-01 00:49:25.000000', 'temperatura', 881.0000, 'ºC'),
	(300986, 144, '2015-01-01 00:49:26.000000', 'temperatura', 463.0000, 'ºC'),
	(300987, 144, '2015-01-01 00:49:27.000000', 'temperatura', 872.0000, 'ºC'),
	(300988, 144, '2015-01-01 00:49:28.000000', 'temperatura', 573.0000, 'ºC'),
	(300989, 144, '2015-01-01 00:49:29.000000', 'temperatura', 250.0000, 'ºC'),
	(300990, 144, '2015-01-01 00:49:30.000000', 'temperatura', 728.0000, 'ºC'),
	(300991, 144, '2015-01-01 00:49:31.000000', 'temperatura', 493.0000, 'ºC'),
	(300992, 144, '2015-01-01 00:49:32.000000', 'temperatura', 281.0000, 'ºC'),
	(300993, 144, '2015-01-01 00:49:33.000000', 'temperatura', 1127.0000, 'ºC'),
	(300994, 144, '2015-01-01 00:49:34.000000', 'temperatura', 1193.0000, 'ºC'),
	(300995, 144, '2015-01-01 00:49:35.000000', 'temperatura', 186.0000, 'ºC'),
	(300996, 144, '2015-01-01 00:49:36.000000', 'temperatura', 949.0000, 'ºC'),
	(300997, 144, '2015-01-01 00:49:37.000000', 'temperatura', 588.0000, 'ºC'),
	(300998, 144, '2015-01-01 00:49:38.000000', 'temperatura', 95.0000, 'ºC'),
	(300999, 144, '2015-01-01 00:49:39.000000', 'temperatura', 1112.0000, 'ºC'),
	(301000, 144, '2015-01-01 00:49:40.000000', 'temperatura', 476.0000, 'ºC'),
	(301001, 144, '2015-01-01 00:49:41.000000', 'temperatura', 244.0000, 'ºC'),
	(301002, 144, '2015-01-01 00:49:42.000000', 'temperatura', 990.0000, 'ºC'),
	(301003, 144, '2015-01-01 00:49:43.000000', 'temperatura', 621.0000, 'ºC'),
	(301004, 144, '2015-01-01 00:49:44.000000', 'temperatura', 134.0000, 'ºC'),
	(301005, 144, '2015-01-01 00:49:45.000000', 'temperatura', 10.0000, 'ºC'),
	(301006, 144, '2015-01-01 00:49:46.000000', 'temperatura', 847.0000, 'ºC'),
	(301007, 144, '2015-01-01 00:49:47.000000', 'temperatura', 606.0000, 'ºC'),
	(301008, 144, '2015-01-01 00:49:48.000000', 'temperatura', 489.0000, 'ºC'),
	(301009, 144, '2015-01-01 00:49:49.000000', 'temperatura', 629.0000, 'ºC'),
	(301010, 144, '2015-01-01 00:49:50.000000', 'temperatura', 479.0000, 'ºC'),
	(301011, 144, '2015-01-01 00:49:51.000000', 'temperatura', 508.0000, 'ºC'),
	(301012, 144, '2015-01-01 00:49:52.000000', 'temperatura', 1102.0000, 'ºC'),
	(301013, 144, '2015-01-01 00:49:53.000000', 'temperatura', 389.0000, 'ºC'),
	(301014, 144, '2015-01-01 00:49:54.000000', 'temperatura', 1036.0000, 'ºC'),
	(301015, 144, '2015-01-01 00:49:55.000000', 'temperatura', 417.0000, 'ºC'),
	(301016, 144, '2015-01-01 00:49:56.000000', 'temperatura', 176.0000, 'ºC'),
	(301017, 144, '2015-01-01 00:49:57.000000', 'temperatura', 828.0000, 'ºC'),
	(301018, 144, '2015-01-01 00:49:58.000000', 'temperatura', 12.0000, 'ºC'),
	(301019, 144, '2015-01-01 00:49:59.000000', 'temperatura', 1178.0000, 'ºC'),
	(301020, 144, '2015-01-01 00:50:00.000000', 'temperatura', 1053.0000, 'ºC'),
	(301021, 144, '2015-01-01 00:50:01.000000', 'temperatura', 531.0000, 'ºC'),
	(301022, 144, '2015-01-01 00:50:02.000000', 'temperatura', 698.0000, 'ºC'),
	(301023, 144, '2015-01-01 00:50:03.000000', 'temperatura', 697.0000, 'ºC'),
	(301024, 144, '2015-01-01 00:50:04.000000', 'temperatura', 190.0000, 'ºC'),
	(301025, 144, '2015-01-01 00:50:05.000000', 'temperatura', 62.0000, 'ºC'),
	(301026, 144, '2015-01-01 00:50:06.000000', 'temperatura', 940.0000, 'ºC'),
	(301027, 144, '2015-01-01 00:50:07.000000', 'temperatura', 913.0000, 'ºC'),
	(301028, 144, '2015-01-01 00:50:08.000000', 'temperatura', 548.0000, 'ºC'),
	(301029, 144, '2015-01-01 00:50:09.000000', 'temperatura', 1.0000, 'ºC'),
	(301030, 144, '2015-01-01 00:50:10.000000', 'temperatura', 760.0000, 'ºC'),
	(301031, 144, '2015-01-01 00:50:11.000000', 'temperatura', 198.0000, 'ºC'),
	(301032, 144, '2015-01-01 00:50:12.000000', 'temperatura', 1111.0000, 'ºC'),
	(301033, 144, '2015-01-01 00:50:13.000000', 'temperatura', 161.0000, 'ºC'),
	(301034, 144, '2015-01-01 00:50:14.000000', 'temperatura', 1072.0000, 'ºC'),
	(301035, 144, '2015-01-01 00:50:15.000000', 'temperatura', 76.0000, 'ºC'),
	(301036, 144, '2015-01-01 00:50:16.000000', 'temperatura', 766.0000, 'ºC'),
	(301037, 144, '2015-01-01 00:50:17.000000', 'temperatura', 4.0000, 'ºC'),
	(301038, 144, '2015-01-01 00:50:18.000000', 'temperatura', 122.0000, 'ºC'),
	(301039, 144, '2015-01-01 00:50:19.000000', 'temperatura', 597.0000, 'ºC'),
	(301040, 144, '2015-01-01 00:50:20.000000', 'temperatura', 221.0000, 'ºC'),
	(301041, 144, '2015-01-01 00:50:21.000000', 'temperatura', 515.0000, 'ºC'),
	(301042, 144, '2015-01-01 00:50:22.000000', 'temperatura', 712.0000, 'ºC'),
	(301043, 144, '2015-01-01 00:50:23.000000', 'temperatura', 817.0000, 'ºC'),
	(301044, 144, '2015-01-01 00:50:24.000000', 'temperatura', 748.0000, 'ºC'),
	(301045, 144, '2015-01-01 00:50:25.000000', 'temperatura', 89.0000, 'ºC'),
	(301046, 144, '2015-01-01 00:50:26.000000', 'temperatura', 603.0000, 'ºC'),
	(301047, 144, '2015-01-01 00:50:27.000000', 'temperatura', 350.0000, 'ºC'),
	(301048, 144, '2015-01-01 00:50:28.000000', 'temperatura', 1139.0000, 'ºC'),
	(301049, 144, '2015-01-01 00:50:29.000000', 'temperatura', 1046.0000, 'ºC'),
	(301050, 144, '2015-01-01 00:50:30.000000', 'temperatura', 613.0000, 'ºC'),
	(301051, 144, '2015-01-01 00:50:31.000000', 'temperatura', 1128.0000, 'ºC'),
	(301052, 144, '2015-01-01 00:50:32.000000', 'temperatura', 203.0000, 'ºC'),
	(301053, 144, '2015-01-01 00:50:33.000000', 'temperatura', 30.0000, 'ºC'),
	(301054, 144, '2015-01-01 00:50:34.000000', 'temperatura', 743.0000, 'ºC'),
	(301055, 144, '2015-01-01 00:50:35.000000', 'temperatura', 25.0000, 'ºC'),
	(301056, 144, '2015-01-01 00:50:36.000000', 'temperatura', 296.0000, 'ºC'),
	(301057, 144, '2015-01-01 00:50:37.000000', 'temperatura', 204.0000, 'ºC'),
	(301058, 144, '2015-01-01 00:50:38.000000', 'temperatura', 135.0000, 'ºC'),
	(301059, 144, '2015-01-01 00:50:39.000000', 'temperatura', 65.0000, 'ºC'),
	(301060, 144, '2015-01-01 00:50:40.000000', 'temperatura', 1117.0000, 'ºC'),
	(301061, 144, '2015-01-01 00:50:41.000000', 'temperatura', 591.0000, 'ºC'),
	(301062, 144, '2015-01-01 00:50:42.000000', 'temperatura', 805.0000, 'ºC'),
	(301063, 144, '2015-01-01 00:50:43.000000', 'temperatura', 1052.0000, 'ºC'),
	(301064, 144, '2015-01-01 00:50:44.000000', 'temperatura', 445.0000, 'ºC'),
	(301065, 144, '2015-01-01 00:50:45.000000', 'temperatura', 269.0000, 'ºC'),
	(301066, 144, '2015-01-01 00:50:46.000000', 'temperatura', 11.0000, 'ºC'),
	(301067, 144, '2015-01-01 00:50:47.000000', 'temperatura', 448.0000, 'ºC'),
	(301068, 144, '2015-01-01 00:50:48.000000', 'temperatura', 1008.0000, 'ºC'),
	(301069, 144, '2015-01-01 00:50:49.000000', 'temperatura', 95.0000, 'ºC'),
	(301070, 144, '2015-01-01 00:50:50.000000', 'temperatura', 1052.0000, 'ºC'),
	(301071, 144, '2015-01-01 00:50:51.000000', 'temperatura', 175.0000, 'ºC'),
	(301072, 144, '2015-01-01 00:50:52.000000', 'temperatura', 118.0000, 'ºC'),
	(301073, 144, '2015-01-01 00:50:53.000000', 'temperatura', 68.0000, 'ºC'),
	(301074, 144, '2015-01-01 00:50:54.000000', 'temperatura', 1184.0000, 'ºC'),
	(301075, 144, '2015-01-01 00:50:55.000000', 'temperatura', 919.0000, 'ºC'),
	(301076, 144, '2015-01-01 00:50:56.000000', 'temperatura', 1044.0000, 'ºC'),
	(301077, 144, '2015-01-01 00:50:57.000000', 'temperatura', 63.0000, 'ºC'),
	(301078, 144, '2015-01-01 00:50:58.000000', 'temperatura', 782.0000, 'ºC'),
	(301079, 144, '2015-01-01 00:50:59.000000', 'temperatura', 121.0000, 'ºC'),
	(301080, 144, '2015-01-01 00:51:00.000000', 'temperatura', 662.0000, 'ºC'),
	(301081, 144, '2015-01-01 00:51:01.000000', 'temperatura', 545.0000, 'ºC'),
	(301082, 144, '2015-01-01 00:51:02.000000', 'temperatura', 742.0000, 'ºC'),
	(301083, 144, '2015-01-01 00:51:03.000000', 'temperatura', 876.0000, 'ºC'),
	(301084, 144, '2015-01-01 00:51:04.000000', 'temperatura', 953.0000, 'ºC'),
	(301085, 144, '2015-01-01 00:51:05.000000', 'temperatura', 936.0000, 'ºC'),
	(301086, 144, '2015-01-01 00:51:06.000000', 'temperatura', 621.0000, 'ºC'),
	(301087, 144, '2015-01-01 00:51:07.000000', 'temperatura', 300.0000, 'ºC'),
	(301088, 144, '2015-01-01 00:51:08.000000', 'temperatura', 836.0000, 'ºC'),
	(301089, 144, '2015-01-01 00:51:09.000000', 'temperatura', 880.0000, 'ºC'),
	(301090, 144, '2015-01-01 00:51:10.000000', 'temperatura', 695.0000, 'ºC'),
	(301091, 144, '2015-01-01 00:51:11.000000', 'temperatura', 834.0000, 'ºC'),
	(301092, 144, '2015-01-01 00:51:12.000000', 'temperatura', 884.0000, 'ºC'),
	(301093, 144, '2015-01-01 00:51:13.000000', 'temperatura', 721.0000, 'ºC'),
	(301094, 144, '2015-01-01 00:51:14.000000', 'temperatura', 955.0000, 'ºC'),
	(301095, 144, '2015-01-01 00:51:15.000000', 'temperatura', 209.0000, 'ºC'),
	(301096, 144, '2015-01-01 00:51:16.000000', 'temperatura', 581.0000, 'ºC'),
	(301097, 144, '2015-01-01 00:51:17.000000', 'temperatura', 1077.0000, 'ºC'),
	(301098, 144, '2015-01-01 00:51:18.000000', 'temperatura', 44.0000, 'ºC'),
	(301099, 144, '2015-01-01 00:51:19.000000', 'temperatura', 590.0000, 'ºC'),
	(301100, 144, '2015-01-01 00:51:20.000000', 'temperatura', 418.0000, 'ºC'),
	(301101, 144, '2015-01-01 00:51:21.000000', 'temperatura', 319.0000, 'ºC'),
	(301102, 144, '2015-01-01 00:51:22.000000', 'temperatura', 344.0000, 'ºC'),
	(301103, 144, '2015-01-01 00:51:23.000000', 'temperatura', 763.0000, 'ºC'),
	(301104, 144, '2015-01-01 00:51:24.000000', 'temperatura', 383.0000, 'ºC'),
	(301105, 144, '2015-01-01 00:51:25.000000', 'temperatura', 828.0000, 'ºC'),
	(301106, 144, '2015-01-01 00:51:26.000000', 'temperatura', 589.0000, 'ºC'),
	(301107, 144, '2015-01-01 00:51:27.000000', 'temperatura', 462.0000, 'ºC'),
	(301108, 144, '2015-01-01 00:51:28.000000', 'temperatura', 543.0000, 'ºC'),
	(301109, 144, '2015-01-01 00:51:29.000000', 'temperatura', 130.0000, 'ºC'),
	(301110, 144, '2015-01-01 00:51:30.000000', 'temperatura', 220.0000, 'ºC'),
	(301111, 144, '2015-01-01 00:51:31.000000', 'temperatura', 713.0000, 'ºC'),
	(301112, 144, '2015-01-01 00:51:32.000000', 'temperatura', 504.0000, 'ºC'),
	(301113, 144, '2015-01-01 00:51:33.000000', 'temperatura', 382.0000, 'ºC'),
	(301114, 144, '2015-01-01 00:51:34.000000', 'temperatura', 400.0000, 'ºC'),
	(301115, 144, '2015-01-01 00:51:35.000000', 'temperatura', 851.0000, 'ºC'),
	(301116, 144, '2015-01-01 00:51:36.000000', 'temperatura', 659.0000, 'ºC'),
	(301117, 144, '2015-01-01 00:51:37.000000', 'temperatura', 740.0000, 'ºC'),
	(301118, 144, '2015-01-01 00:51:38.000000', 'temperatura', 526.0000, 'ºC'),
	(301119, 144, '2015-01-01 00:51:39.000000', 'temperatura', 407.0000, 'ºC'),
	(301120, 144, '2015-01-01 00:51:40.000000', 'temperatura', 460.0000, 'ºC'),
	(301121, 144, '2015-01-01 00:51:41.000000', 'temperatura', 1080.0000, 'ºC'),
	(301122, 144, '2015-01-01 00:51:42.000000', 'temperatura', 419.0000, 'ºC'),
	(301123, 144, '2015-01-01 00:51:43.000000', 'temperatura', 56.0000, 'ºC'),
	(301124, 144, '2015-01-01 00:51:44.000000', 'temperatura', 226.0000, 'ºC'),
	(301125, 144, '2015-01-01 00:51:45.000000', 'temperatura', 959.0000, 'ºC'),
	(301126, 144, '2015-01-01 00:51:46.000000', 'temperatura', 520.0000, 'ºC'),
	(301127, 144, '2015-01-01 00:51:47.000000', 'temperatura', 921.0000, 'ºC'),
	(301128, 144, '2015-01-01 00:51:48.000000', 'temperatura', 648.0000, 'ºC'),
	(301129, 144, '2015-01-01 00:51:49.000000', 'temperatura', 478.0000, 'ºC'),
	(301130, 144, '2015-01-01 00:51:50.000000', 'temperatura', 447.0000, 'ºC'),
	(301131, 144, '2015-01-01 00:51:51.000000', 'temperatura', 802.0000, 'ºC'),
	(301132, 144, '2015-01-01 00:51:52.000000', 'temperatura', 267.0000, 'ºC'),
	(301133, 144, '2015-01-01 00:51:53.000000', 'temperatura', 133.0000, 'ºC'),
	(301134, 144, '2015-01-01 00:51:54.000000', 'temperatura', 1061.0000, 'ºC'),
	(301135, 144, '2015-01-01 00:51:55.000000', 'temperatura', 108.0000, 'ºC'),
	(301136, 144, '2015-01-01 00:51:56.000000', 'temperatura', 956.0000, 'ºC'),
	(301137, 144, '2015-01-01 00:51:57.000000', 'temperatura', 857.0000, 'ºC'),
	(301138, 144, '2015-01-01 00:51:58.000000', 'temperatura', 219.0000, 'ºC'),
	(301139, 144, '2015-01-01 00:51:59.000000', 'temperatura', 923.0000, 'ºC'),
	(301140, 144, '2015-01-01 00:52:00.000000', 'temperatura', 360.0000, 'ºC'),
	(301141, 144, '2015-01-01 00:52:01.000000', 'temperatura', 230.0000, 'ºC'),
	(301142, 144, '2015-01-01 00:52:02.000000', 'temperatura', 70.0000, 'ºC'),
	(301143, 144, '2015-01-01 00:52:03.000000', 'temperatura', 863.0000, 'ºC'),
	(301144, 144, '2015-01-01 00:52:04.000000', 'temperatura', 503.0000, 'ºC'),
	(301145, 144, '2015-01-01 00:52:05.000000', 'temperatura', 1126.0000, 'ºC'),
	(301146, 144, '2015-01-01 00:52:06.000000', 'temperatura', 524.0000, 'ºC'),
	(301147, 144, '2015-01-01 00:52:07.000000', 'temperatura', 442.0000, 'ºC'),
	(301148, 144, '2015-01-01 00:52:08.000000', 'temperatura', 640.0000, 'ºC'),
	(301149, 144, '2015-01-01 00:52:09.000000', 'temperatura', 672.0000, 'ºC'),
	(301150, 144, '2015-01-01 00:52:10.000000', 'temperatura', 241.0000, 'ºC'),
	(301151, 144, '2015-01-01 00:52:11.000000', 'temperatura', 389.0000, 'ºC'),
	(301152, 144, '2015-01-01 00:52:12.000000', 'temperatura', 23.0000, 'ºC'),
	(301153, 144, '2015-01-01 00:52:13.000000', 'temperatura', 149.0000, 'ºC'),
	(301154, 144, '2015-01-01 00:52:14.000000', 'temperatura', 675.0000, 'ºC'),
	(301155, 144, '2015-01-01 00:52:15.000000', 'temperatura', 530.0000, 'ºC'),
	(301156, 144, '2015-01-01 00:52:16.000000', 'temperatura', 626.0000, 'ºC'),
	(301157, 144, '2015-01-01 00:52:17.000000', 'temperatura', 340.0000, 'ºC'),
	(301158, 144, '2015-01-01 00:52:18.000000', 'temperatura', 1023.0000, 'ºC'),
	(301159, 144, '2015-01-01 00:52:19.000000', 'temperatura', 496.0000, 'ºC'),
	(301160, 144, '2015-01-01 00:52:20.000000', 'temperatura', 609.0000, 'ºC'),
	(301161, 144, '2015-01-01 00:52:21.000000', 'temperatura', 360.0000, 'ºC'),
	(301162, 144, '2015-01-01 00:52:22.000000', 'temperatura', 1173.0000, 'ºC'),
	(301163, 144, '2015-01-01 00:52:23.000000', 'temperatura', 1185.0000, 'ºC'),
	(301164, 144, '2015-01-01 00:52:24.000000', 'temperatura', 6.0000, 'ºC'),
	(301165, 144, '2015-01-01 00:52:25.000000', 'temperatura', 77.0000, 'ºC'),
	(301166, 144, '2015-01-01 00:52:26.000000', 'temperatura', 368.0000, 'ºC'),
	(301167, 144, '2015-01-01 00:52:27.000000', 'temperatura', 407.0000, 'ºC'),
	(301168, 144, '2015-01-01 00:52:28.000000', 'temperatura', 931.0000, 'ºC'),
	(301169, 144, '2015-01-01 00:52:29.000000', 'temperatura', 1037.0000, 'ºC'),
	(301170, 144, '2015-01-01 00:52:30.000000', 'temperatura', 1190.0000, 'ºC'),
	(301171, 144, '2015-01-01 00:52:31.000000', 'temperatura', 439.0000, 'ºC'),
	(301172, 144, '2015-01-01 00:52:32.000000', 'temperatura', 1028.0000, 'ºC'),
	(301173, 144, '2015-01-01 00:52:33.000000', 'temperatura', 223.0000, 'ºC'),
	(301174, 144, '2015-01-01 00:52:34.000000', 'temperatura', 433.0000, 'ºC'),
	(301175, 144, '2015-01-01 00:52:35.000000', 'temperatura', 296.0000, 'ºC'),
	(301176, 144, '2015-01-01 00:52:36.000000', 'temperatura', 182.0000, 'ºC'),
	(301177, 144, '2015-01-01 00:52:37.000000', 'temperatura', 21.0000, 'ºC'),
	(301178, 144, '2015-01-01 00:52:38.000000', 'temperatura', 759.0000, 'ºC'),
	(301179, 144, '2015-01-01 00:52:39.000000', 'temperatura', 135.0000, 'ºC'),
	(301180, 144, '2015-01-01 00:52:40.000000', 'temperatura', 797.0000, 'ºC'),
	(301181, 144, '2015-01-01 00:52:41.000000', 'temperatura', 1180.0000, 'ºC'),
	(301182, 144, '2015-01-01 00:52:42.000000', 'temperatura', 1108.0000, 'ºC'),
	(301183, 144, '2015-01-01 00:52:43.000000', 'temperatura', 802.0000, 'ºC'),
	(301184, 144, '2015-01-01 00:52:44.000000', 'temperatura', 685.0000, 'ºC'),
	(301185, 144, '2015-01-01 00:52:45.000000', 'temperatura', 1020.0000, 'ºC'),
	(301186, 144, '2015-01-01 00:52:46.000000', 'temperatura', 647.0000, 'ºC'),
	(301187, 144, '2015-01-01 00:52:47.000000', 'temperatura', 175.0000, 'ºC'),
	(301188, 144, '2015-01-01 00:52:48.000000', 'temperatura', 134.0000, 'ºC'),
	(301189, 144, '2015-01-01 00:52:49.000000', 'temperatura', 146.0000, 'ºC'),
	(301190, 144, '2015-01-01 00:52:50.000000', 'temperatura', 330.0000, 'ºC'),
	(301191, 144, '2015-01-01 00:52:51.000000', 'temperatura', 11.0000, 'ºC'),
	(301192, 144, '2015-01-01 00:52:52.000000', 'temperatura', 266.0000, 'ºC'),
	(301193, 144, '2015-01-01 00:52:53.000000', 'temperatura', 98.0000, 'ºC'),
	(301194, 144, '2015-01-01 00:52:54.000000', 'temperatura', 893.0000, 'ºC'),
	(301195, 144, '2015-01-01 00:52:55.000000', 'temperatura', 569.0000, 'ºC'),
	(301196, 144, '2015-01-01 00:52:56.000000', 'temperatura', 167.0000, 'ºC'),
	(301197, 144, '2015-01-01 00:52:57.000000', 'temperatura', 329.0000, 'ºC'),
	(301198, 144, '2015-01-01 00:52:58.000000', 'temperatura', 1145.0000, 'ºC'),
	(301199, 144, '2015-01-01 00:52:59.000000', 'temperatura', 1137.0000, 'ºC'),
	(301200, 144, '2015-01-01 00:53:00.000000', 'temperatura', 1052.0000, 'ºC'),
	(301201, 144, '2015-01-01 00:53:01.000000', 'temperatura', 650.0000, 'ºC'),
	(301202, 144, '2015-01-01 00:53:02.000000', 'temperatura', 94.0000, 'ºC'),
	(301203, 144, '2015-01-01 00:53:03.000000', 'temperatura', 922.0000, 'ºC'),
	(301204, 144, '2015-01-01 00:53:04.000000', 'temperatura', 725.0000, 'ºC'),
	(301205, 144, '2015-01-01 00:53:05.000000', 'temperatura', 863.0000, 'ºC'),
	(301206, 144, '2015-01-01 00:53:06.000000', 'temperatura', 937.0000, 'ºC'),
	(301207, 144, '2015-01-01 00:53:07.000000', 'temperatura', 899.0000, 'ºC'),
	(301208, 144, '2015-01-01 00:53:08.000000', 'temperatura', 483.0000, 'ºC'),
	(301209, 144, '2015-01-01 00:53:09.000000', 'temperatura', 920.0000, 'ºC'),
	(301210, 144, '2015-01-01 00:53:10.000000', 'temperatura', 751.0000, 'ºC'),
	(301211, 144, '2015-01-01 00:53:11.000000', 'temperatura', 997.0000, 'ºC'),
	(301212, 144, '2015-01-01 00:53:12.000000', 'temperatura', 330.0000, 'ºC'),
	(301213, 144, '2015-01-01 00:53:13.000000', 'temperatura', 1062.0000, 'ºC'),
	(301214, 144, '2015-01-01 00:53:14.000000', 'temperatura', 720.0000, 'ºC'),
	(301215, 144, '2015-01-01 00:53:15.000000', 'temperatura', 413.0000, 'ºC'),
	(301216, 144, '2015-01-01 00:53:16.000000', 'temperatura', 1107.0000, 'ºC'),
	(301217, 144, '2015-01-01 00:53:17.000000', 'temperatura', 695.0000, 'ºC'),
	(301218, 144, '2015-01-01 00:53:18.000000', 'temperatura', 155.0000, 'ºC'),
	(301219, 144, '2015-01-01 00:53:19.000000', 'temperatura', 1090.0000, 'ºC'),
	(301220, 144, '2015-01-01 00:53:20.000000', 'temperatura', 188.0000, 'ºC'),
	(301221, 144, '2015-01-01 00:53:21.000000', 'temperatura', 68.0000, 'ºC'),
	(301222, 144, '2015-01-01 00:53:22.000000', 'temperatura', 975.0000, 'ºC'),
	(301223, 144, '2015-01-01 00:53:23.000000', 'temperatura', 1074.0000, 'ºC'),
	(301224, 144, '2015-01-01 00:53:24.000000', 'temperatura', 44.0000, 'ºC'),
	(301225, 144, '2015-01-01 00:53:25.000000', 'temperatura', 600.0000, 'ºC'),
	(301226, 144, '2015-01-01 00:53:26.000000', 'temperatura', 466.0000, 'ºC'),
	(301227, 144, '2015-01-01 00:53:27.000000', 'temperatura', 533.0000, 'ºC'),
	(301228, 144, '2015-01-01 00:53:28.000000', 'temperatura', 67.0000, 'ºC'),
	(301229, 144, '2015-01-01 00:53:29.000000', 'temperatura', 1138.0000, 'ºC'),
	(301230, 144, '2015-01-01 00:53:30.000000', 'temperatura', 689.0000, 'ºC'),
	(301231, 144, '2015-01-01 00:53:31.000000', 'temperatura', 32.0000, 'ºC'),
	(301232, 144, '2015-01-01 00:53:32.000000', 'temperatura', 493.0000, 'ºC'),
	(301233, 144, '2015-01-01 00:53:33.000000', 'temperatura', 1168.0000, 'ºC'),
	(301234, 144, '2015-01-01 00:53:34.000000', 'temperatura', 764.0000, 'ºC'),
	(301235, 144, '2015-01-01 00:53:35.000000', 'temperatura', 317.0000, 'ºC'),
	(301236, 144, '2015-01-01 00:53:36.000000', 'temperatura', 494.0000, 'ºC'),
	(301237, 144, '2015-01-01 00:53:37.000000', 'temperatura', 318.0000, 'ºC'),
	(301238, 144, '2015-01-01 00:53:38.000000', 'temperatura', 108.0000, 'ºC'),
	(301239, 144, '2015-01-01 00:53:39.000000', 'temperatura', 785.0000, 'ºC'),
	(301240, 144, '2015-01-01 00:53:40.000000', 'temperatura', 5.0000, 'ºC'),
	(301241, 144, '2015-01-01 00:53:41.000000', 'temperatura', 69.0000, 'ºC'),
	(301242, 144, '2015-01-01 00:53:42.000000', 'temperatura', 329.0000, 'ºC'),
	(301243, 144, '2015-01-01 00:53:43.000000', 'temperatura', 240.0000, 'ºC'),
	(301244, 144, '2015-01-01 00:53:44.000000', 'temperatura', 214.0000, 'ºC'),
	(301245, 144, '2015-01-01 00:53:45.000000', 'temperatura', 351.0000, 'ºC'),
	(301246, 144, '2015-01-01 00:53:46.000000', 'temperatura', 1112.0000, 'ºC'),
	(301247, 144, '2015-01-01 00:53:47.000000', 'temperatura', 908.0000, 'ºC'),
	(301248, 144, '2015-01-01 00:53:48.000000', 'temperatura', 6.0000, 'ºC'),
	(301249, 144, '2015-01-01 00:53:49.000000', 'temperatura', 907.0000, 'ºC'),
	(301250, 144, '2015-01-01 00:53:50.000000', 'temperatura', 915.0000, 'ºC'),
	(301251, 144, '2015-01-01 00:53:51.000000', 'temperatura', 655.0000, 'ºC'),
	(301252, 144, '2015-01-01 00:53:52.000000', 'temperatura', 531.0000, 'ºC'),
	(301253, 144, '2015-01-01 00:53:53.000000', 'temperatura', 692.0000, 'ºC'),
	(301254, 144, '2015-01-01 00:53:54.000000', 'temperatura', 668.0000, 'ºC'),
	(301255, 144, '2015-01-01 00:53:55.000000', 'temperatura', 64.0000, 'ºC'),
	(301256, 144, '2015-01-01 00:53:56.000000', 'temperatura', 717.0000, 'ºC'),
	(301257, 144, '2015-01-01 00:53:57.000000', 'temperatura', 992.0000, 'ºC'),
	(301258, 144, '2015-01-01 00:53:58.000000', 'temperatura', 410.0000, 'ºC'),
	(301259, 144, '2015-01-01 00:53:59.000000', 'temperatura', 274.0000, 'ºC'),
	(301260, 144, '2015-01-01 00:54:00.000000', 'temperatura', 142.0000, 'ºC'),
	(301261, 144, '2015-01-01 00:54:01.000000', 'temperatura', 1089.0000, 'ºC'),
	(301262, 144, '2015-01-01 00:54:02.000000', 'temperatura', 217.0000, 'ºC'),
	(301263, 144, '2015-01-01 00:54:03.000000', 'temperatura', 220.0000, 'ºC'),
	(301264, 144, '2015-01-01 00:54:04.000000', 'temperatura', 448.0000, 'ºC'),
	(301265, 144, '2015-01-01 00:54:05.000000', 'temperatura', 383.0000, 'ºC'),
	(301266, 144, '2015-01-01 00:54:06.000000', 'temperatura', 569.0000, 'ºC'),
	(301267, 144, '2015-01-01 00:54:07.000000', 'temperatura', 500.0000, 'ºC'),
	(301268, 144, '2015-01-01 00:54:08.000000', 'temperatura', 790.0000, 'ºC'),
	(301269, 144, '2015-01-01 00:54:09.000000', 'temperatura', 52.0000, 'ºC'),
	(301270, 144, '2015-01-01 00:54:10.000000', 'temperatura', 288.0000, 'ºC'),
	(301271, 144, '2015-01-01 00:54:11.000000', 'temperatura', 87.0000, 'ºC'),
	(301272, 144, '2015-01-01 00:54:12.000000', 'temperatura', 773.0000, 'ºC'),
	(301273, 144, '2015-01-01 00:54:13.000000', 'temperatura', 2.0000, 'ºC'),
	(301274, 144, '2015-01-01 00:54:14.000000', 'temperatura', 92.0000, 'ºC'),
	(301275, 144, '2015-01-01 00:54:15.000000', 'temperatura', 456.0000, 'ºC'),
	(301276, 144, '2015-01-01 00:54:16.000000', 'temperatura', 804.0000, 'ºC'),
	(301277, 144, '2015-01-01 00:54:17.000000', 'temperatura', 250.0000, 'ºC'),
	(301278, 144, '2015-01-01 00:54:18.000000', 'temperatura', 41.0000, 'ºC'),
	(301279, 144, '2015-01-01 00:54:19.000000', 'temperatura', 654.0000, 'ºC'),
	(301280, 144, '2015-01-01 00:54:20.000000', 'temperatura', 747.0000, 'ºC'),
	(301281, 144, '2015-01-01 00:54:21.000000', 'temperatura', 575.0000, 'ºC'),
	(301282, 144, '2015-01-01 00:54:22.000000', 'temperatura', 634.0000, 'ºC'),
	(301283, 144, '2015-01-01 00:54:23.000000', 'temperatura', 244.0000, 'ºC'),
	(301284, 144, '2015-01-01 00:54:24.000000', 'temperatura', 521.0000, 'ºC'),
	(301285, 144, '2015-01-01 00:54:25.000000', 'temperatura', 670.0000, 'ºC'),
	(301286, 144, '2015-01-01 00:54:26.000000', 'temperatura', 591.0000, 'ºC'),
	(301287, 144, '2015-01-01 00:54:27.000000', 'temperatura', 945.0000, 'ºC'),
	(301288, 144, '2015-01-01 00:54:28.000000', 'temperatura', 551.0000, 'ºC'),
	(301289, 144, '2015-01-01 00:54:29.000000', 'temperatura', 1121.0000, 'ºC'),
	(301290, 144, '2015-01-01 00:54:30.000000', 'temperatura', 354.0000, 'ºC'),
	(301291, 144, '2015-01-01 00:54:31.000000', 'temperatura', 806.0000, 'ºC'),
	(301292, 144, '2015-01-01 00:54:32.000000', 'temperatura', 568.0000, 'ºC'),
	(301293, 144, '2015-01-01 00:54:33.000000', 'temperatura', 422.0000, 'ºC'),
	(301294, 144, '2015-01-01 00:54:34.000000', 'temperatura', 408.0000, 'ºC'),
	(301295, 144, '2015-01-01 00:54:35.000000', 'temperatura', 773.0000, 'ºC'),
	(301296, 144, '2015-01-01 00:54:36.000000', 'temperatura', 244.0000, 'ºC'),
	(301297, 144, '2015-01-01 00:54:37.000000', 'temperatura', 101.0000, 'ºC'),
	(301298, 144, '2015-01-01 00:54:38.000000', 'temperatura', 971.0000, 'ºC'),
	(301299, 144, '2015-01-01 00:54:39.000000', 'temperatura', 955.0000, 'ºC'),
	(301300, 144, '2015-01-01 00:54:40.000000', 'temperatura', 662.0000, 'ºC'),
	(301301, 144, '2015-01-01 00:54:41.000000', 'temperatura', 444.0000, 'ºC'),
	(301302, 144, '2015-01-01 00:54:42.000000', 'temperatura', 234.0000, 'ºC'),
	(301303, 144, '2015-01-01 00:54:43.000000', 'temperatura', 1041.0000, 'ºC'),
	(301304, 144, '2015-01-01 00:54:44.000000', 'temperatura', 900.0000, 'ºC'),
	(301305, 144, '2015-01-01 00:54:45.000000', 'temperatura', 181.0000, 'ºC'),
	(301306, 144, '2015-01-01 00:54:46.000000', 'temperatura', 605.0000, 'ºC'),
	(301307, 144, '2015-01-01 00:54:47.000000', 'temperatura', 83.0000, 'ºC'),
	(301308, 144, '2015-01-01 00:54:48.000000', 'temperatura', 998.0000, 'ºC'),
	(301309, 144, '2015-01-01 00:54:49.000000', 'temperatura', 1144.0000, 'ºC'),
	(301310, 144, '2015-01-01 00:54:50.000000', 'temperatura', 325.0000, 'ºC'),
	(301311, 144, '2015-01-01 00:54:51.000000', 'temperatura', 594.0000, 'ºC'),
	(301312, 144, '2015-01-01 00:54:52.000000', 'temperatura', 797.0000, 'ºC'),
	(301313, 144, '2015-01-01 00:54:53.000000', 'temperatura', 1001.0000, 'ºC'),
	(301314, 144, '2015-01-01 00:54:54.000000', 'temperatura', 217.0000, 'ºC'),
	(301315, 144, '2015-01-01 00:54:55.000000', 'temperatura', 483.0000, 'ºC'),
	(301316, 144, '2015-01-01 00:54:56.000000', 'temperatura', 563.0000, 'ºC'),
	(301317, 144, '2015-01-01 00:54:57.000000', 'temperatura', 167.0000, 'ºC'),
	(301318, 144, '2015-01-01 00:54:58.000000', 'temperatura', 346.0000, 'ºC'),
	(301319, 144, '2015-01-01 00:54:59.000000', 'temperatura', 31.0000, 'ºC'),
	(301320, 144, '2015-01-01 00:55:00.000000', 'temperatura', 317.0000, 'ºC'),
	(301321, 144, '2015-01-01 00:55:01.000000', 'temperatura', 291.0000, 'ºC'),
	(301322, 144, '2015-01-01 00:55:02.000000', 'temperatura', 503.0000, 'ºC'),
	(301323, 144, '2015-01-01 00:55:03.000000', 'temperatura', 446.0000, 'ºC'),
	(301324, 144, '2015-01-01 00:55:04.000000', 'temperatura', 718.0000, 'ºC'),
	(301325, 144, '2015-01-01 00:55:05.000000', 'temperatura', 1055.0000, 'ºC'),
	(301326, 144, '2015-01-01 00:55:06.000000', 'temperatura', 722.0000, 'ºC'),
	(301327, 144, '2015-01-01 00:55:07.000000', 'temperatura', 444.0000, 'ºC'),
	(301328, 144, '2015-01-01 00:55:08.000000', 'temperatura', 54.0000, 'ºC'),
	(301329, 144, '2015-01-01 00:55:09.000000', 'temperatura', 140.0000, 'ºC'),
	(301330, 144, '2015-01-01 00:55:10.000000', 'temperatura', 539.0000, 'ºC'),
	(301331, 144, '2015-01-01 00:55:11.000000', 'temperatura', 1074.0000, 'ºC'),
	(301332, 144, '2015-01-01 00:55:12.000000', 'temperatura', 153.0000, 'ºC'),
	(301333, 144, '2015-01-01 00:55:13.000000', 'temperatura', 1142.0000, 'ºC'),
	(301334, 144, '2015-01-01 00:55:14.000000', 'temperatura', 454.0000, 'ºC'),
	(301335, 144, '2015-01-01 00:55:15.000000', 'temperatura', 42.0000, 'ºC'),
	(301336, 144, '2015-01-01 00:55:16.000000', 'temperatura', 50.0000, 'ºC'),
	(301337, 144, '2015-01-01 00:55:17.000000', 'temperatura', 126.0000, 'ºC'),
	(301338, 144, '2015-01-01 00:55:18.000000', 'temperatura', 480.0000, 'ºC'),
	(301339, 144, '2015-01-01 00:55:19.000000', 'temperatura', 823.0000, 'ºC'),
	(301340, 144, '2015-01-01 00:55:20.000000', 'temperatura', 277.0000, 'ºC'),
	(301341, 144, '2015-01-01 00:55:21.000000', 'temperatura', 114.0000, 'ºC'),
	(301342, 144, '2015-01-01 00:55:22.000000', 'temperatura', 940.0000, 'ºC'),
	(301343, 144, '2015-01-01 00:55:23.000000', 'temperatura', 757.0000, 'ºC'),
	(301344, 144, '2015-01-01 00:55:24.000000', 'temperatura', 966.0000, 'ºC'),
	(301345, 144, '2015-01-01 00:55:25.000000', 'temperatura', 160.0000, 'ºC'),
	(301346, 144, '2015-01-01 00:55:26.000000', 'temperatura', 301.0000, 'ºC'),
	(301347, 144, '2015-01-01 00:55:27.000000', 'temperatura', 1027.0000, 'ºC'),
	(301348, 144, '2015-01-01 00:55:28.000000', 'temperatura', 633.0000, 'ºC'),
	(301349, 144, '2015-01-01 00:55:29.000000', 'temperatura', 85.0000, 'ºC'),
	(301350, 144, '2015-01-01 00:55:30.000000', 'temperatura', 926.0000, 'ºC'),
	(301351, 144, '2015-01-01 00:55:31.000000', 'temperatura', 775.0000, 'ºC'),
	(301352, 144, '2015-01-01 00:55:32.000000', 'temperatura', 1098.0000, 'ºC'),
	(301353, 144, '2015-01-01 00:55:33.000000', 'temperatura', 767.0000, 'ºC'),
	(301354, 144, '2015-01-01 00:55:34.000000', 'temperatura', 539.0000, 'ºC'),
	(301355, 144, '2015-01-01 00:55:35.000000', 'temperatura', 395.0000, 'ºC'),
	(301356, 144, '2015-01-01 00:55:36.000000', 'temperatura', 358.0000, 'ºC'),
	(301357, 144, '2015-01-01 00:55:37.000000', 'temperatura', 605.0000, 'ºC'),
	(301358, 144, '2015-01-01 00:55:38.000000', 'temperatura', 754.0000, 'ºC'),
	(301359, 144, '2015-01-01 00:55:39.000000', 'temperatura', 755.0000, 'ºC'),
	(301360, 144, '2015-01-01 00:55:40.000000', 'temperatura', 313.0000, 'ºC'),
	(301361, 144, '2015-01-01 00:55:41.000000', 'temperatura', 501.0000, 'ºC'),
	(301362, 144, '2015-01-01 00:55:42.000000', 'temperatura', 365.0000, 'ºC'),
	(301363, 144, '2015-01-01 00:55:43.000000', 'temperatura', 323.0000, 'ºC'),
	(301364, 144, '2015-01-01 00:55:44.000000', 'temperatura', 522.0000, 'ºC'),
	(301365, 144, '2015-01-01 00:55:45.000000', 'temperatura', 441.0000, 'ºC'),
	(301366, 144, '2015-01-01 00:55:46.000000', 'temperatura', 641.0000, 'ºC'),
	(301367, 144, '2015-01-01 00:55:47.000000', 'temperatura', 680.0000, 'ºC'),
	(301368, 144, '2015-01-01 00:55:48.000000', 'temperatura', 278.0000, 'ºC'),
	(301369, 144, '2015-01-01 00:55:49.000000', 'temperatura', 551.0000, 'ºC'),
	(301370, 144, '2015-01-01 00:55:50.000000', 'temperatura', 721.0000, 'ºC'),
	(301371, 144, '2015-01-01 00:55:51.000000', 'temperatura', 752.0000, 'ºC'),
	(301372, 144, '2015-01-01 00:55:52.000000', 'temperatura', 400.0000, 'ºC'),
	(301373, 144, '2015-01-01 00:55:53.000000', 'temperatura', 942.0000, 'ºC'),
	(301374, 144, '2015-01-01 00:55:54.000000', 'temperatura', 1112.0000, 'ºC'),
	(301375, 144, '2015-01-01 00:55:55.000000', 'temperatura', 335.0000, 'ºC'),
	(301376, 144, '2015-01-01 00:55:56.000000', 'temperatura', 738.0000, 'ºC'),
	(301377, 144, '2015-01-01 00:55:57.000000', 'temperatura', 284.0000, 'ºC'),
	(301378, 144, '2015-01-01 00:55:58.000000', 'temperatura', 408.0000, 'ºC'),
	(301379, 144, '2015-01-01 00:55:59.000000', 'temperatura', 1188.0000, 'ºC'),
	(301380, 144, '2015-01-01 00:56:00.000000', 'temperatura', 1117.0000, 'ºC'),
	(301381, 144, '2015-01-01 00:56:01.000000', 'temperatura', 823.0000, 'ºC'),
	(301382, 144, '2015-01-01 00:56:02.000000', 'temperatura', 764.0000, 'ºC'),
	(301383, 144, '2015-01-01 00:56:03.000000', 'temperatura', 149.0000, 'ºC'),
	(301384, 144, '2015-01-01 00:56:04.000000', 'temperatura', 856.0000, 'ºC'),
	(301385, 144, '2015-01-01 00:56:05.000000', 'temperatura', 231.0000, 'ºC'),
	(301386, 144, '2015-01-01 00:56:06.000000', 'temperatura', 990.0000, 'ºC'),
	(301387, 144, '2015-01-01 00:56:07.000000', 'temperatura', 658.0000, 'ºC'),
	(301388, 144, '2015-01-01 00:56:08.000000', 'temperatura', 319.0000, 'ºC'),
	(301389, 144, '2015-01-01 00:56:09.000000', 'temperatura', 820.0000, 'ºC'),
	(301390, 144, '2015-01-01 00:56:10.000000', 'temperatura', 745.0000, 'ºC'),
	(301391, 144, '2015-01-01 00:56:11.000000', 'temperatura', 65.0000, 'ºC'),
	(301392, 144, '2015-01-01 00:56:12.000000', 'temperatura', 489.0000, 'ºC'),
	(301393, 144, '2015-01-01 00:56:13.000000', 'temperatura', 1051.0000, 'ºC'),
	(301394, 144, '2015-01-01 00:56:14.000000', 'temperatura', 187.0000, 'ºC'),
	(301395, 144, '2015-01-01 00:56:15.000000', 'temperatura', 184.0000, 'ºC'),
	(301396, 144, '2015-01-01 00:56:16.000000', 'temperatura', 360.0000, 'ºC'),
	(301397, 144, '2015-01-01 00:56:17.000000', 'temperatura', 50.0000, 'ºC'),
	(301398, 144, '2015-01-01 00:56:18.000000', 'temperatura', 370.0000, 'ºC'),
	(301399, 144, '2015-01-01 00:56:19.000000', 'temperatura', 501.0000, 'ºC'),
	(301400, 144, '2015-01-01 00:56:20.000000', 'temperatura', 193.0000, 'ºC'),
	(301401, 144, '2015-01-01 00:56:21.000000', 'temperatura', 664.0000, 'ºC'),
	(301402, 144, '2015-01-01 00:56:22.000000', 'temperatura', 341.0000, 'ºC'),
	(301403, 144, '2015-01-01 00:56:23.000000', 'temperatura', 914.0000, 'ºC'),
	(301404, 144, '2015-01-01 00:56:24.000000', 'temperatura', 1146.0000, 'ºC'),
	(301405, 144, '2015-01-01 00:56:25.000000', 'temperatura', 591.0000, 'ºC'),
	(301406, 144, '2015-01-01 00:56:26.000000', 'temperatura', 717.0000, 'ºC'),
	(301407, 144, '2015-01-01 00:56:27.000000', 'temperatura', 612.0000, 'ºC'),
	(301408, 144, '2015-01-01 00:56:28.000000', 'temperatura', 910.0000, 'ºC'),
	(301409, 144, '2015-01-01 00:56:29.000000', 'temperatura', 315.0000, 'ºC'),
	(301410, 144, '2015-01-01 00:56:30.000000', 'temperatura', 44.0000, 'ºC'),
	(301411, 144, '2015-01-01 00:56:31.000000', 'temperatura', 476.0000, 'ºC'),
	(301412, 144, '2015-01-01 00:56:32.000000', 'temperatura', 1047.0000, 'ºC'),
	(301413, 144, '2015-01-01 00:56:33.000000', 'temperatura', 209.0000, 'ºC'),
	(301414, 144, '2015-01-01 00:56:34.000000', 'temperatura', 305.0000, 'ºC'),
	(301415, 144, '2015-01-01 00:56:35.000000', 'temperatura', 896.0000, 'ºC'),
	(301416, 144, '2015-01-01 00:56:36.000000', 'temperatura', 1169.0000, 'ºC'),
	(301417, 144, '2015-01-01 00:56:37.000000', 'temperatura', 755.0000, 'ºC'),
	(301418, 144, '2015-01-01 00:56:38.000000', 'temperatura', 271.0000, 'ºC'),
	(301419, 144, '2015-01-01 00:56:39.000000', 'temperatura', 288.0000, 'ºC'),
	(301420, 144, '2015-01-01 00:56:40.000000', 'temperatura', 628.0000, 'ºC'),
	(301421, 144, '2015-01-01 00:56:41.000000', 'temperatura', 1076.0000, 'ºC'),
	(301422, 144, '2015-01-01 00:56:42.000000', 'temperatura', 1099.0000, 'ºC'),
	(301423, 144, '2015-01-01 00:56:43.000000', 'temperatura', 1064.0000, 'ºC'),
	(301424, 144, '2015-01-01 00:56:44.000000', 'temperatura', 827.0000, 'ºC'),
	(301425, 144, '2015-01-01 00:56:45.000000', 'temperatura', 941.0000, 'ºC'),
	(301426, 144, '2015-01-01 00:56:46.000000', 'temperatura', 1023.0000, 'ºC'),
	(301427, 144, '2015-01-01 00:56:47.000000', 'temperatura', 1096.0000, 'ºC'),
	(301428, 144, '2015-01-01 00:56:48.000000', 'temperatura', 11.0000, 'ºC'),
	(301429, 144, '2015-01-01 00:56:49.000000', 'temperatura', 366.0000, 'ºC'),
	(301430, 144, '2015-01-01 00:56:50.000000', 'temperatura', 597.0000, 'ºC'),
	(301431, 144, '2015-01-01 00:56:51.000000', 'temperatura', 690.0000, 'ºC'),
	(301432, 144, '2015-01-01 00:56:52.000000', 'temperatura', 459.0000, 'ºC'),
	(301433, 144, '2015-01-01 00:56:53.000000', 'temperatura', 223.0000, 'ºC'),
	(301434, 144, '2015-01-01 00:56:54.000000', 'temperatura', 942.0000, 'ºC'),
	(301435, 144, '2015-01-01 00:56:55.000000', 'temperatura', 438.0000, 'ºC'),
	(301436, 144, '2015-01-01 00:56:56.000000', 'temperatura', 567.0000, 'ºC'),
	(301437, 144, '2015-01-01 00:56:57.000000', 'temperatura', 321.0000, 'ºC'),
	(301438, 144, '2015-01-01 00:56:58.000000', 'temperatura', 1105.0000, 'ºC'),
	(301439, 144, '2015-01-01 00:56:59.000000', 'temperatura', 963.0000, 'ºC'),
	(301440, 144, '2015-01-01 00:57:00.000000', 'temperatura', 300.0000, 'ºC'),
	(301441, 144, '2015-01-01 00:57:01.000000', 'temperatura', 1009.0000, 'ºC'),
	(301442, 144, '2015-01-01 00:57:02.000000', 'temperatura', 549.0000, 'ºC'),
	(301443, 144, '2015-01-01 00:57:03.000000', 'temperatura', 916.0000, 'ºC'),
	(301444, 144, '2015-01-01 00:57:04.000000', 'temperatura', 536.0000, 'ºC'),
	(301445, 144, '2015-01-01 00:57:05.000000', 'temperatura', 1132.0000, 'ºC'),
	(301446, 144, '2015-01-01 00:57:06.000000', 'temperatura', 451.0000, 'ºC'),
	(301447, 144, '2015-01-01 00:57:07.000000', 'temperatura', 62.0000, 'ºC'),
	(301448, 144, '2015-01-01 00:57:08.000000', 'temperatura', 156.0000, 'ºC'),
	(301449, 144, '2015-01-01 00:57:09.000000', 'temperatura', 593.0000, 'ºC'),
	(301450, 144, '2015-01-01 00:57:10.000000', 'temperatura', 97.0000, 'ºC'),
	(301451, 144, '2015-01-01 00:57:11.000000', 'temperatura', 1108.0000, 'ºC'),
	(301452, 144, '2015-01-01 00:57:12.000000', 'temperatura', 451.0000, 'ºC'),
	(301453, 144, '2015-01-01 00:57:13.000000', 'temperatura', 129.0000, 'ºC'),
	(301454, 144, '2015-01-01 00:57:14.000000', 'temperatura', 495.0000, 'ºC'),
	(301455, 144, '2015-01-01 00:57:15.000000', 'temperatura', 887.0000, 'ºC'),
	(301456, 144, '2015-01-01 00:57:16.000000', 'temperatura', 551.0000, 'ºC'),
	(301457, 144, '2015-01-01 00:57:17.000000', 'temperatura', 95.0000, 'ºC'),
	(301458, 144, '2015-01-01 00:57:18.000000', 'temperatura', 22.0000, 'ºC'),
	(301459, 144, '2015-01-01 00:57:19.000000', 'temperatura', 1025.0000, 'ºC'),
	(301460, 144, '2015-01-01 00:57:20.000000', 'temperatura', 260.0000, 'ºC'),
	(301461, 144, '2015-01-01 00:57:21.000000', 'temperatura', 625.0000, 'ºC'),
	(301462, 144, '2015-01-01 00:57:22.000000', 'temperatura', 1146.0000, 'ºC'),
	(301463, 144, '2015-01-01 00:57:23.000000', 'temperatura', 257.0000, 'ºC'),
	(301464, 144, '2015-01-01 00:57:24.000000', 'temperatura', 248.0000, 'ºC'),
	(301465, 144, '2015-01-01 00:57:25.000000', 'temperatura', 469.0000, 'ºC'),
	(301466, 144, '2015-01-01 00:57:26.000000', 'temperatura', 400.0000, 'ºC'),
	(301467, 144, '2015-01-01 00:57:27.000000', 'temperatura', 593.0000, 'ºC'),
	(301468, 144, '2015-01-01 00:57:28.000000', 'temperatura', 566.0000, 'ºC'),
	(301469, 144, '2015-01-01 00:57:29.000000', 'temperatura', 1052.0000, 'ºC'),
	(301470, 144, '2015-01-01 00:57:30.000000', 'temperatura', 1162.0000, 'ºC'),
	(301471, 144, '2015-01-01 00:57:31.000000', 'temperatura', 256.0000, 'ºC'),
	(301472, 144, '2015-01-01 00:57:32.000000', 'temperatura', 195.0000, 'ºC'),
	(301473, 144, '2015-01-01 00:57:33.000000', 'temperatura', 208.0000, 'ºC'),
	(301474, 144, '2015-01-01 00:57:34.000000', 'temperatura', 456.0000, 'ºC'),
	(301475, 144, '2015-01-01 00:57:35.000000', 'temperatura', 457.0000, 'ºC'),
	(301476, 144, '2015-01-01 00:57:36.000000', 'temperatura', 918.0000, 'ºC'),
	(301477, 144, '2015-01-01 00:57:37.000000', 'temperatura', 818.0000, 'ºC'),
	(301478, 144, '2015-01-01 00:57:38.000000', 'temperatura', 138.0000, 'ºC'),
	(301479, 144, '2015-01-01 00:57:39.000000', 'temperatura', 634.0000, 'ºC'),
	(301480, 144, '2015-01-01 00:57:40.000000', 'temperatura', 357.0000, 'ºC'),
	(301481, 144, '2015-01-01 00:57:41.000000', 'temperatura', 1085.0000, 'ºC'),
	(301482, 144, '2015-01-01 00:57:42.000000', 'temperatura', 752.0000, 'ºC'),
	(301483, 144, '2015-01-01 00:57:43.000000', 'temperatura', 506.0000, 'ºC'),
	(301484, 144, '2015-01-01 00:57:44.000000', 'temperatura', 276.0000, 'ºC'),
	(301485, 144, '2015-01-01 00:57:45.000000', 'temperatura', 1061.0000, 'ºC'),
	(301486, 144, '2015-01-01 00:57:46.000000', 'temperatura', 876.0000, 'ºC'),
	(301487, 144, '2015-01-01 00:57:47.000000', 'temperatura', 1199.0000, 'ºC'),
	(301488, 144, '2015-01-01 00:57:48.000000', 'temperatura', 968.0000, 'ºC'),
	(301489, 144, '2015-01-01 00:57:49.000000', 'temperatura', 42.0000, 'ºC'),
	(301490, 144, '2015-01-01 00:57:50.000000', 'temperatura', 906.0000, 'ºC'),
	(301491, 144, '2015-01-01 00:57:51.000000', 'temperatura', 804.0000, 'ºC'),
	(301492, 144, '2015-01-01 00:57:52.000000', 'temperatura', 101.0000, 'ºC'),
	(301493, 144, '2015-01-01 00:57:53.000000', 'temperatura', 497.0000, 'ºC'),
	(301494, 144, '2015-01-01 00:57:54.000000', 'temperatura', 981.0000, 'ºC'),
	(301495, 144, '2015-01-01 00:57:55.000000', 'temperatura', 1015.0000, 'ºC'),
	(301496, 144, '2015-01-01 00:57:56.000000', 'temperatura', 932.0000, 'ºC'),
	(301497, 144, '2015-01-01 00:57:57.000000', 'temperatura', 415.0000, 'ºC'),
	(301498, 144, '2015-01-01 00:57:58.000000', 'temperatura', 481.0000, 'ºC'),
	(301499, 144, '2015-01-01 00:57:59.000000', 'temperatura', 1158.0000, 'ºC'),
	(301500, 144, '2015-01-01 00:58:00.000000', 'temperatura', 749.0000, 'ºC'),
	(301501, 144, '2015-01-01 00:58:01.000000', 'temperatura', 272.0000, 'ºC'),
	(301502, 144, '2015-01-01 00:58:02.000000', 'temperatura', 313.0000, 'ºC'),
	(301503, 144, '2015-01-01 00:58:03.000000', 'temperatura', 751.0000, 'ºC'),
	(301504, 144, '2015-01-01 00:58:04.000000', 'temperatura', 414.0000, 'ºC'),
	(301505, 144, '2015-01-01 00:58:05.000000', 'temperatura', 1019.0000, 'ºC'),
	(301506, 144, '2015-01-01 00:58:06.000000', 'temperatura', 253.0000, 'ºC'),
	(301507, 144, '2015-01-01 00:58:07.000000', 'temperatura', 609.0000, 'ºC'),
	(301508, 144, '2015-01-01 00:58:08.000000', 'temperatura', 1085.0000, 'ºC'),
	(301509, 144, '2015-01-01 00:58:09.000000', 'temperatura', 0.0000, 'ºC'),
	(301510, 144, '2015-01-01 00:58:10.000000', 'temperatura', 344.0000, 'ºC'),
	(301511, 144, '2015-01-01 00:58:11.000000', 'temperatura', 522.0000, 'ºC'),
	(301512, 144, '2015-01-01 00:58:12.000000', 'temperatura', 378.0000, 'ºC'),
	(301513, 144, '2015-01-01 00:58:13.000000', 'temperatura', 325.0000, 'ºC'),
	(301514, 144, '2015-01-01 00:58:14.000000', 'temperatura', 490.0000, 'ºC'),
	(301515, 144, '2015-01-01 00:58:15.000000', 'temperatura', 276.0000, 'ºC'),
	(301516, 144, '2015-01-01 00:58:16.000000', 'temperatura', 1109.0000, 'ºC'),
	(301517, 144, '2015-01-01 00:58:17.000000', 'temperatura', 1118.0000, 'ºC'),
	(301518, 144, '2015-01-01 00:58:18.000000', 'temperatura', 1064.0000, 'ºC'),
	(301519, 144, '2015-01-01 00:58:19.000000', 'temperatura', 767.0000, 'ºC'),
	(301520, 144, '2015-01-01 00:58:20.000000', 'temperatura', 642.0000, 'ºC'),
	(301521, 144, '2015-01-01 00:58:21.000000', 'temperatura', 910.0000, 'ºC'),
	(301522, 144, '2015-01-01 00:58:22.000000', 'temperatura', 227.0000, 'ºC'),
	(301523, 144, '2015-01-01 00:58:23.000000', 'temperatura', 803.0000, 'ºC'),
	(301524, 144, '2015-01-01 00:58:24.000000', 'temperatura', 936.0000, 'ºC'),
	(301525, 144, '2015-01-01 00:58:25.000000', 'temperatura', 1070.0000, 'ºC'),
	(301526, 144, '2015-01-01 00:58:26.000000', 'temperatura', 145.0000, 'ºC'),
	(301527, 144, '2015-01-01 00:58:27.000000', 'temperatura', 1115.0000, 'ºC'),
	(301528, 144, '2015-01-01 00:58:28.000000', 'temperatura', 339.0000, 'ºC'),
	(301529, 144, '2015-01-01 00:58:29.000000', 'temperatura', 753.0000, 'ºC'),
	(301530, 144, '2015-01-01 00:58:30.000000', 'temperatura', 346.0000, 'ºC'),
	(301531, 144, '2015-01-01 00:58:31.000000', 'temperatura', 674.0000, 'ºC'),
	(301532, 144, '2015-01-01 00:58:32.000000', 'temperatura', 1133.0000, 'ºC'),
	(301533, 144, '2015-01-01 00:58:33.000000', 'temperatura', 42.0000, 'ºC'),
	(301534, 144, '2015-01-01 00:58:34.000000', 'temperatura', 410.0000, 'ºC'),
	(301535, 144, '2015-01-01 00:58:35.000000', 'temperatura', 724.0000, 'ºC'),
	(301536, 144, '2015-01-01 00:58:36.000000', 'temperatura', 1192.0000, 'ºC'),
	(301537, 144, '2015-01-01 00:58:37.000000', 'temperatura', 189.0000, 'ºC'),
	(301538, 144, '2015-01-01 00:58:38.000000', 'temperatura', 971.0000, 'ºC'),
	(301539, 144, '2015-01-01 00:58:39.000000', 'temperatura', 687.0000, 'ºC'),
	(301540, 144, '2015-01-01 00:58:40.000000', 'temperatura', 522.0000, 'ºC'),
	(301541, 144, '2015-01-01 00:58:41.000000', 'temperatura', 550.0000, 'ºC'),
	(301542, 144, '2015-01-01 00:58:42.000000', 'temperatura', 1186.0000, 'ºC'),
	(301543, 144, '2015-01-01 00:58:43.000000', 'temperatura', 681.0000, 'ºC'),
	(301544, 144, '2015-01-01 00:58:44.000000', 'temperatura', 1046.0000, 'ºC'),
	(301545, 144, '2015-01-01 00:58:45.000000', 'temperatura', 786.0000, 'ºC'),
	(301546, 144, '2015-01-01 00:58:46.000000', 'temperatura', 795.0000, 'ºC'),
	(301547, 144, '2015-01-01 00:58:47.000000', 'temperatura', 416.0000, 'ºC'),
	(301548, 144, '2015-01-01 00:58:48.000000', 'temperatura', 896.0000, 'ºC'),
	(301549, 144, '2015-01-01 00:58:49.000000', 'temperatura', 832.0000, 'ºC'),
	(301550, 144, '2015-01-01 00:58:50.000000', 'temperatura', 271.0000, 'ºC'),
	(301551, 144, '2015-01-01 00:58:51.000000', 'temperatura', 62.0000, 'ºC'),
	(301552, 144, '2015-01-01 00:58:52.000000', 'temperatura', 696.0000, 'ºC'),
	(301553, 144, '2015-01-01 00:58:53.000000', 'temperatura', 893.0000, 'ºC'),
	(301554, 144, '2015-01-01 00:58:54.000000', 'temperatura', 1180.0000, 'ºC'),
	(301555, 144, '2015-01-01 00:58:55.000000', 'temperatura', 823.0000, 'ºC'),
	(301556, 144, '2015-01-01 00:58:56.000000', 'temperatura', 573.0000, 'ºC'),
	(301557, 144, '2015-01-01 00:58:57.000000', 'temperatura', 397.0000, 'ºC'),
	(301558, 144, '2015-01-01 00:58:58.000000', 'temperatura', 267.0000, 'ºC'),
	(301559, 144, '2015-01-01 00:58:59.000000', 'temperatura', 144.0000, 'ºC'),
	(301560, 144, '2015-01-01 00:59:00.000000', 'temperatura', 1120.0000, 'ºC'),
	(301561, 144, '2015-01-01 00:59:01.000000', 'temperatura', 370.0000, 'ºC'),
	(301562, 144, '2015-01-01 00:59:02.000000', 'temperatura', 889.0000, 'ºC'),
	(301563, 144, '2015-01-01 00:59:03.000000', 'temperatura', 937.0000, 'ºC'),
	(301564, 144, '2015-01-01 00:59:04.000000', 'temperatura', 818.0000, 'ºC'),
	(301565, 144, '2015-01-01 00:59:05.000000', 'temperatura', 78.0000, 'ºC'),
	(301566, 144, '2015-01-01 00:59:06.000000', 'temperatura', 338.0000, 'ºC'),
	(301567, 144, '2015-01-01 00:59:07.000000', 'temperatura', 256.0000, 'ºC'),
	(301568, 144, '2015-01-01 00:59:08.000000', 'temperatura', 266.0000, 'ºC'),
	(301569, 144, '2015-01-01 00:59:09.000000', 'temperatura', 562.0000, 'ºC'),
	(301570, 144, '2015-01-01 00:59:10.000000', 'temperatura', 812.0000, 'ºC'),
	(301571, 144, '2015-01-01 00:59:11.000000', 'temperatura', 1175.0000, 'ºC'),
	(301572, 144, '2015-01-01 00:59:12.000000', 'temperatura', 1041.0000, 'ºC'),
	(301573, 144, '2015-01-01 00:59:13.000000', 'temperatura', 480.0000, 'ºC'),
	(301574, 144, '2015-01-01 00:59:14.000000', 'temperatura', 475.0000, 'ºC'),
	(301575, 144, '2015-01-01 00:59:15.000000', 'temperatura', 939.0000, 'ºC'),
	(301576, 144, '2015-01-01 00:59:16.000000', 'temperatura', 868.0000, 'ºC'),
	(301577, 144, '2015-01-01 00:59:17.000000', 'temperatura', 322.0000, 'ºC'),
	(301578, 144, '2015-01-01 00:59:18.000000', 'temperatura', 209.0000, 'ºC'),
	(301579, 144, '2015-01-01 00:59:19.000000', 'temperatura', 80.0000, 'ºC'),
	(301580, 144, '2015-01-01 00:59:20.000000', 'temperatura', 974.0000, 'ºC'),
	(301581, 144, '2015-01-01 00:59:21.000000', 'temperatura', 1031.0000, 'ºC'),
	(301582, 144, '2015-01-01 00:59:22.000000', 'temperatura', 1033.0000, 'ºC'),
	(301583, 144, '2015-01-01 00:59:23.000000', 'temperatura', 872.0000, 'ºC'),
	(301584, 144, '2015-01-01 00:59:24.000000', 'temperatura', 63.0000, 'ºC'),
	(301585, 144, '2015-01-01 00:59:25.000000', 'temperatura', 98.0000, 'ºC'),
	(301586, 144, '2015-01-01 00:59:26.000000', 'temperatura', 300.0000, 'ºC'),
	(301587, 144, '2015-01-01 00:59:27.000000', 'temperatura', 9.0000, 'ºC'),
	(301588, 144, '2015-01-01 00:59:28.000000', 'temperatura', 347.0000, 'ºC'),
	(301589, 144, '2015-01-01 00:59:29.000000', 'temperatura', 506.0000, 'ºC'),
	(301590, 144, '2015-01-01 00:59:30.000000', 'temperatura', 288.0000, 'ºC'),
	(301591, 144, '2015-01-01 00:59:31.000000', 'temperatura', 1124.0000, 'ºC'),
	(301592, 144, '2015-01-01 00:59:32.000000', 'temperatura', 1159.0000, 'ºC'),
	(301593, 144, '2015-01-01 00:59:33.000000', 'temperatura', 20.0000, 'ºC'),
	(301594, 144, '2015-01-01 00:59:34.000000', 'temperatura', 224.0000, 'ºC'),
	(301595, 144, '2015-01-01 00:59:35.000000', 'temperatura', 1060.0000, 'ºC'),
	(301596, 144, '2015-01-01 00:59:36.000000', 'temperatura', 1028.0000, 'ºC'),
	(301597, 144, '2015-01-01 00:59:37.000000', 'temperatura', 761.0000, 'ºC'),
	(301598, 144, '2015-01-01 00:59:38.000000', 'temperatura', 723.0000, 'ºC'),
	(301599, 144, '2015-01-01 00:59:39.000000', 'temperatura', 134.0000, 'ºC'),
	(301600, 144, '2015-01-01 00:59:40.000000', 'temperatura', 898.0000, 'ºC'),
	(301601, 144, '2015-01-01 00:59:41.000000', 'temperatura', 492.0000, 'ºC'),
	(301602, 144, '2015-01-01 00:59:42.000000', 'temperatura', 963.0000, 'ºC'),
	(301603, 144, '2015-01-01 00:59:43.000000', 'temperatura', 942.0000, 'ºC'),
	(301604, 144, '2015-01-01 00:59:44.000000', 'temperatura', 620.0000, 'ºC'),
	(301605, 144, '2015-01-01 00:59:45.000000', 'temperatura', 275.0000, 'ºC'),
	(301606, 144, '2015-01-01 00:59:46.000000', 'temperatura', 714.0000, 'ºC'),
	(301607, 144, '2015-01-01 00:59:47.000000', 'temperatura', 346.0000, 'ºC'),
	(301608, 144, '2015-01-01 00:59:48.000000', 'temperatura', 788.0000, 'ºC'),
	(301609, 144, '2015-01-01 00:59:49.000000', 'temperatura', 502.0000, 'ºC'),
	(301610, 144, '2015-01-01 00:59:50.000000', 'temperatura', 149.0000, 'ºC'),
	(301611, 144, '2015-01-01 00:59:51.000000', 'temperatura', 438.0000, 'ºC'),
	(301612, 144, '2015-01-01 00:59:52.000000', 'temperatura', 543.0000, 'ºC'),
	(301613, 144, '2015-01-01 00:59:53.000000', 'temperatura', 202.0000, 'ºC'),
	(301614, 144, '2015-01-01 00:59:54.000000', 'temperatura', 580.0000, 'ºC'),
	(301615, 144, '2015-01-01 00:59:55.000000', 'temperatura', 1094.0000, 'ºC'),
	(301616, 144, '2015-01-01 00:59:56.000000', 'temperatura', 131.0000, 'ºC'),
	(301617, 144, '2015-01-01 00:59:57.000000', 'temperatura', 974.0000, 'ºC'),
	(301618, 144, '2015-01-01 00:59:58.000000', 'temperatura', 877.0000, 'ºC'),
	(301619, 144, '2015-01-01 00:59:59.000000', 'temperatura', 265.0000, 'ºC'),
	(301620, 144, '2015-01-01 01:00:00.000000', 'temperatura', 1093.0000, 'ºC'),
	(301621, 144, '2015-01-01 01:00:01.000000', 'temperatura', 1070.0000, 'ºC'),
	(301622, 144, '2015-01-01 01:00:02.000000', 'temperatura', 872.0000, 'ºC'),
	(301623, 144, '2015-01-01 01:00:03.000000', 'temperatura', 1151.0000, 'ºC'),
	(301624, 144, '2015-01-01 01:00:04.000000', 'temperatura', 741.0000, 'ºC'),
	(301625, 144, '2015-01-01 01:00:05.000000', 'temperatura', 252.0000, 'ºC'),
	(301626, 144, '2015-01-01 01:00:06.000000', 'temperatura', 236.0000, 'ºC'),
	(301627, 144, '2015-01-01 01:00:07.000000', 'temperatura', 425.0000, 'ºC'),
	(301628, 144, '2015-01-01 01:00:08.000000', 'temperatura', 218.0000, 'ºC'),
	(301629, 144, '2015-01-01 01:00:09.000000', 'temperatura', 1014.0000, 'ºC'),
	(301630, 144, '2015-01-01 01:00:10.000000', 'temperatura', 819.0000, 'ºC'),
	(301631, 144, '2015-01-01 01:00:11.000000', 'temperatura', 1052.0000, 'ºC'),
	(301632, 144, '2015-01-01 01:00:12.000000', 'temperatura', 403.0000, 'ºC'),
	(301633, 144, '2015-01-01 01:00:13.000000', 'temperatura', 61.0000, 'ºC'),
	(301634, 144, '2015-01-01 01:00:14.000000', 'temperatura', 295.0000, 'ºC'),
	(301635, 144, '2015-01-01 01:00:15.000000', 'temperatura', 93.0000, 'ºC'),
	(301636, 144, '2015-01-01 01:00:16.000000', 'temperatura', 781.0000, 'ºC'),
	(301637, 144, '2015-01-01 01:00:17.000000', 'temperatura', 24.0000, 'ºC'),
	(301638, 144, '2015-01-01 01:00:18.000000', 'temperatura', 179.0000, 'ºC'),
	(301639, 144, '2015-01-01 01:00:19.000000', 'temperatura', 824.0000, 'ºC'),
	(301640, 144, '2015-01-01 01:00:20.000000', 'temperatura', 1185.0000, 'ºC'),
	(301641, 144, '2015-01-01 01:00:21.000000', 'temperatura', 1054.0000, 'ºC'),
	(301642, 144, '2015-01-01 01:00:22.000000', 'temperatura', 512.0000, 'ºC'),
	(301643, 144, '2015-01-01 01:00:23.000000', 'temperatura', 601.0000, 'ºC'),
	(301644, 144, '2015-01-01 01:00:24.000000', 'temperatura', 269.0000, 'ºC'),
	(301645, 144, '2015-01-01 01:00:25.000000', 'temperatura', 743.0000, 'ºC'),
	(301646, 144, '2015-01-01 01:00:26.000000', 'temperatura', 510.0000, 'ºC'),
	(301647, 144, '2015-01-01 01:00:27.000000', 'temperatura', 321.0000, 'ºC'),
	(301648, 144, '2015-01-01 01:00:28.000000', 'temperatura', 76.0000, 'ºC'),
	(301649, 144, '2015-01-01 01:00:29.000000', 'temperatura', 615.0000, 'ºC'),
	(301650, 144, '2015-01-01 01:00:30.000000', 'temperatura', 447.0000, 'ºC'),
	(301651, 144, '2015-01-01 01:00:31.000000', 'temperatura', 392.0000, 'ºC'),
	(301652, 144, '2015-01-01 01:00:32.000000', 'temperatura', 620.0000, 'ºC'),
	(301653, 144, '2015-01-01 01:00:33.000000', 'temperatura', 723.0000, 'ºC'),
	(301654, 144, '2015-01-01 01:00:34.000000', 'temperatura', 554.0000, 'ºC'),
	(301655, 144, '2015-01-01 01:00:35.000000', 'temperatura', 605.0000, 'ºC'),
	(301656, 144, '2015-01-01 01:00:36.000000', 'temperatura', 161.0000, 'ºC'),
	(301657, 144, '2015-01-01 01:00:37.000000', 'temperatura', 192.0000, 'ºC'),
	(301658, 144, '2015-01-01 01:00:38.000000', 'temperatura', 476.0000, 'ºC'),
	(301659, 144, '2015-01-01 01:00:39.000000', 'temperatura', 604.0000, 'ºC'),
	(301660, 144, '2015-01-01 01:00:40.000000', 'temperatura', 392.0000, 'ºC'),
	(301661, 144, '2015-01-01 01:00:41.000000', 'temperatura', 151.0000, 'ºC'),
	(301662, 144, '2015-01-01 01:00:42.000000', 'temperatura', 777.0000, 'ºC'),
	(301663, 144, '2015-01-01 01:00:43.000000', 'temperatura', 1032.0000, 'ºC'),
	(301664, 144, '2015-01-01 01:00:44.000000', 'temperatura', 428.0000, 'ºC'),
	(301665, 144, '2015-01-01 01:00:45.000000', 'temperatura', 248.0000, 'ºC'),
	(301666, 144, '2015-01-01 01:00:46.000000', 'temperatura', 1157.0000, 'ºC'),
	(301667, 144, '2015-01-01 01:00:47.000000', 'temperatura', 241.0000, 'ºC'),
	(301668, 144, '2015-01-01 01:00:48.000000', 'temperatura', 132.0000, 'ºC'),
	(301669, 144, '2015-01-01 01:00:49.000000', 'temperatura', 1141.0000, 'ºC'),
	(301670, 144, '2015-01-01 01:00:50.000000', 'temperatura', 506.0000, 'ºC'),
	(301671, 144, '2015-01-01 01:00:51.000000', 'temperatura', 309.0000, 'ºC'),
	(301672, 144, '2015-01-01 01:00:52.000000', 'temperatura', 29.0000, 'ºC'),
	(301673, 144, '2015-01-01 01:00:53.000000', 'temperatura', 418.0000, 'ºC'),
	(301674, 144, '2015-01-01 01:00:54.000000', 'temperatura', 801.0000, 'ºC'),
	(301675, 144, '2015-01-01 01:00:55.000000', 'temperatura', 353.0000, 'ºC'),
	(301676, 144, '2015-01-01 01:00:56.000000', 'temperatura', 562.0000, 'ºC'),
	(301677, 144, '2015-01-01 01:00:57.000000', 'temperatura', 551.0000, 'ºC'),
	(301678, 144, '2015-01-01 01:00:58.000000', 'temperatura', 1070.0000, 'ºC'),
	(301679, 144, '2015-01-01 01:00:59.000000', 'temperatura', 96.0000, 'ºC'),
	(301680, 144, '2015-01-01 01:01:00.000000', 'temperatura', 870.0000, 'ºC'),
	(301681, 144, '2015-01-01 01:01:01.000000', 'temperatura', 463.0000, 'ºC'),
	(301682, 144, '2015-01-01 01:01:02.000000', 'temperatura', 905.0000, 'ºC'),
	(301683, 144, '2015-01-01 01:01:03.000000', 'temperatura', 736.0000, 'ºC'),
	(301684, 144, '2015-01-01 01:01:04.000000', 'temperatura', 964.0000, 'ºC'),
	(301685, 144, '2015-01-01 01:01:05.000000', 'temperatura', 215.0000, 'ºC'),
	(301686, 144, '2015-01-01 01:01:06.000000', 'temperatura', 583.0000, 'ºC'),
	(301687, 144, '2015-01-01 01:01:07.000000', 'temperatura', 1069.0000, 'ºC'),
	(301688, 144, '2015-01-01 01:01:08.000000', 'temperatura', 1199.0000, 'ºC'),
	(301689, 144, '2015-01-01 01:01:09.000000', 'temperatura', 385.0000, 'ºC'),
	(301690, 144, '2015-01-01 01:01:10.000000', 'temperatura', 732.0000, 'ºC'),
	(301691, 144, '2015-01-01 01:01:11.000000', 'temperatura', 103.0000, 'ºC'),
	(301692, 144, '2015-01-01 01:01:12.000000', 'temperatura', 719.0000, 'ºC'),
	(301693, 144, '2015-01-01 01:01:13.000000', 'temperatura', 886.0000, 'ºC'),
	(301694, 144, '2015-01-01 01:01:14.000000', 'temperatura', 1074.0000, 'ºC'),
	(301695, 144, '2015-01-01 01:01:15.000000', 'temperatura', 312.0000, 'ºC'),
	(301696, 144, '2015-01-01 01:01:16.000000', 'temperatura', 738.0000, 'ºC'),
	(301697, 144, '2015-01-01 01:01:17.000000', 'temperatura', 356.0000, 'ºC'),
	(301698, 144, '2015-01-01 01:01:18.000000', 'temperatura', 764.0000, 'ºC'),
	(301699, 144, '2015-01-01 01:01:19.000000', 'temperatura', 354.0000, 'ºC'),
	(301700, 144, '2015-01-01 01:01:20.000000', 'temperatura', 677.0000, 'ºC'),
	(301701, 144, '2015-01-01 01:01:21.000000', 'temperatura', 1123.0000, 'ºC'),
	(301702, 144, '2015-01-01 01:01:22.000000', 'temperatura', 1185.0000, 'ºC'),
	(301703, 144, '2015-01-01 01:01:23.000000', 'temperatura', 155.0000, 'ºC'),
	(301704, 144, '2015-01-01 01:01:24.000000', 'temperatura', 824.0000, 'ºC'),
	(301705, 144, '2015-01-01 01:01:25.000000', 'temperatura', 52.0000, 'ºC'),
	(301706, 144, '2015-01-01 01:01:26.000000', 'temperatura', 192.0000, 'ºC'),
	(301707, 144, '2015-01-01 01:01:27.000000', 'temperatura', 803.0000, 'ºC'),
	(301708, 144, '2015-01-01 01:01:28.000000', 'temperatura', 1040.0000, 'ºC'),
	(301709, 144, '2015-01-01 01:01:29.000000', 'temperatura', 390.0000, 'ºC'),
	(301710, 144, '2015-01-01 01:01:30.000000', 'temperatura', 31.0000, 'ºC'),
	(301711, 144, '2015-01-01 01:01:31.000000', 'temperatura', 186.0000, 'ºC'),
	(301712, 144, '2015-01-01 01:01:32.000000', 'temperatura', 839.0000, 'ºC'),
	(301713, 144, '2015-01-01 01:01:33.000000', 'temperatura', 35.0000, 'ºC'),
	(301714, 144, '2015-01-01 01:01:34.000000', 'temperatura', 58.0000, 'ºC'),
	(301715, 144, '2015-01-01 01:01:35.000000', 'temperatura', 186.0000, 'ºC'),
	(301716, 144, '2015-01-01 01:01:36.000000', 'temperatura', 758.0000, 'ºC'),
	(301717, 144, '2015-01-01 01:01:37.000000', 'temperatura', 831.0000, 'ºC'),
	(301718, 144, '2015-01-01 01:01:38.000000', 'temperatura', 684.0000, 'ºC'),
	(301719, 144, '2015-01-01 01:01:39.000000', 'temperatura', 926.0000, 'ºC'),
	(301720, 144, '2015-01-01 01:01:40.000000', 'temperatura', 177.0000, 'ºC'),
	(301721, 144, '2015-01-01 01:01:41.000000', 'temperatura', 507.0000, 'ºC'),
	(301722, 144, '2015-01-01 01:01:42.000000', 'temperatura', 806.0000, 'ºC'),
	(301723, 144, '2015-01-01 01:01:43.000000', 'temperatura', 109.0000, 'ºC'),
	(301724, 144, '2015-01-01 01:01:44.000000', 'temperatura', 527.0000, 'ºC'),
	(301725, 144, '2015-01-01 01:01:45.000000', 'temperatura', 1107.0000, 'ºC'),
	(301726, 144, '2015-01-01 01:01:46.000000', 'temperatura', 356.0000, 'ºC'),
	(301727, 144, '2015-01-01 01:01:47.000000', 'temperatura', 857.0000, 'ºC'),
	(301728, 144, '2015-01-01 01:01:48.000000', 'temperatura', 820.0000, 'ºC'),
	(301729, 144, '2015-01-01 01:01:49.000000', 'temperatura', 331.0000, 'ºC'),
	(301730, 144, '2015-01-01 01:01:50.000000', 'temperatura', 394.0000, 'ºC'),
	(301731, 144, '2015-01-01 01:01:51.000000', 'temperatura', 978.0000, 'ºC'),
	(301732, 144, '2015-01-01 01:01:52.000000', 'temperatura', 106.0000, 'ºC'),
	(301733, 144, '2015-01-01 01:01:53.000000', 'temperatura', 0.0000, 'ºC'),
	(301734, 144, '2015-01-01 01:01:54.000000', 'temperatura', 882.0000, 'ºC'),
	(301735, 144, '2015-01-01 01:01:55.000000', 'temperatura', 809.0000, 'ºC'),
	(301736, 144, '2015-01-01 01:01:56.000000', 'temperatura', 200.0000, 'ºC'),
	(301737, 144, '2015-01-01 01:01:57.000000', 'temperatura', 972.0000, 'ºC'),
	(301738, 144, '2015-01-01 01:01:58.000000', 'temperatura', 660.0000, 'ºC'),
	(301739, 144, '2015-01-01 01:01:59.000000', 'temperatura', 386.0000, 'ºC'),
	(301740, 144, '2015-01-01 01:02:00.000000', 'temperatura', 1148.0000, 'ºC'),
	(301741, 144, '2015-01-01 01:02:01.000000', 'temperatura', 986.0000, 'ºC'),
	(301742, 144, '2015-01-01 01:02:02.000000', 'temperatura', 284.0000, 'ºC'),
	(301743, 144, '2015-01-01 01:02:03.000000', 'temperatura', 863.0000, 'ºC'),
	(301744, 144, '2015-01-01 01:02:04.000000', 'temperatura', 1065.0000, 'ºC'),
	(301745, 144, '2015-01-01 01:02:05.000000', 'temperatura', 337.0000, 'ºC'),
	(301746, 144, '2015-01-01 01:02:06.000000', 'temperatura', 888.0000, 'ºC'),
	(301747, 144, '2015-01-01 01:02:07.000000', 'temperatura', 1032.0000, 'ºC'),
	(301748, 144, '2015-01-01 01:02:08.000000', 'temperatura', 96.0000, 'ºC'),
	(301749, 144, '2015-01-01 01:02:09.000000', 'temperatura', 985.0000, 'ºC'),
	(301750, 144, '2015-01-01 01:02:10.000000', 'temperatura', 1035.0000, 'ºC'),
	(301751, 144, '2015-01-01 01:02:11.000000', 'temperatura', 1022.0000, 'ºC'),
	(301752, 144, '2015-01-01 01:02:12.000000', 'temperatura', 806.0000, 'ºC'),
	(301753, 144, '2015-01-01 01:02:13.000000', 'temperatura', 963.0000, 'ºC'),
	(301754, 144, '2015-01-01 01:02:14.000000', 'temperatura', 1198.0000, 'ºC'),
	(301755, 144, '2015-01-01 01:02:15.000000', 'temperatura', 702.0000, 'ºC'),
	(301756, 144, '2015-01-01 01:02:16.000000', 'temperatura', 1115.0000, 'ºC'),
	(301757, 144, '2015-01-01 01:02:17.000000', 'temperatura', 1072.0000, 'ºC'),
	(301758, 144, '2015-01-01 01:02:18.000000', 'temperatura', 813.0000, 'ºC'),
	(301759, 144, '2015-01-01 01:02:19.000000', 'temperatura', 851.0000, 'ºC'),
	(301760, 144, '2015-01-01 01:02:20.000000', 'temperatura', 615.0000, 'ºC'),
	(301761, 144, '2015-01-01 01:02:21.000000', 'temperatura', 525.0000, 'ºC'),
	(301762, 144, '2015-01-01 01:02:22.000000', 'temperatura', 778.0000, 'ºC'),
	(301763, 144, '2015-01-01 01:02:23.000000', 'temperatura', 1116.0000, 'ºC'),
	(301764, 144, '2015-01-01 01:02:24.000000', 'temperatura', 848.0000, 'ºC'),
	(301765, 144, '2015-01-01 01:02:25.000000', 'temperatura', 893.0000, 'ºC'),
	(301766, 144, '2015-01-01 01:02:26.000000', 'temperatura', 719.0000, 'ºC'),
	(301767, 144, '2015-01-01 01:02:27.000000', 'temperatura', 916.0000, 'ºC'),
	(301768, 144, '2015-01-01 01:02:28.000000', 'temperatura', 25.0000, 'ºC'),
	(301769, 144, '2015-01-01 01:02:29.000000', 'temperatura', 976.0000, 'ºC'),
	(301770, 144, '2015-01-01 01:02:30.000000', 'temperatura', 5.0000, 'ºC'),
	(301771, 144, '2015-01-01 01:02:31.000000', 'temperatura', 697.0000, 'ºC'),
	(301772, 144, '2015-01-01 01:02:32.000000', 'temperatura', 1073.0000, 'ºC'),
	(301773, 144, '2015-01-01 01:02:33.000000', 'temperatura', 872.0000, 'ºC'),
	(301774, 144, '2015-01-01 01:02:34.000000', 'temperatura', 1142.0000, 'ºC'),
	(301775, 144, '2015-01-01 01:02:35.000000', 'temperatura', 696.0000, 'ºC'),
	(301776, 144, '2015-01-01 01:02:36.000000', 'temperatura', 56.0000, 'ºC'),
	(301777, 144, '2015-01-01 01:02:37.000000', 'temperatura', 590.0000, 'ºC'),
	(301778, 144, '2015-01-01 01:02:38.000000', 'temperatura', 383.0000, 'ºC'),
	(301779, 144, '2015-01-01 01:02:39.000000', 'temperatura', 147.0000, 'ºC'),
	(301780, 144, '2015-01-01 01:02:40.000000', 'temperatura', 785.0000, 'ºC'),
	(301781, 144, '2015-01-01 01:02:41.000000', 'temperatura', 1085.0000, 'ºC'),
	(301782, 144, '2015-01-01 01:02:42.000000', 'temperatura', 672.0000, 'ºC'),
	(301783, 144, '2015-01-01 01:02:43.000000', 'temperatura', 106.0000, 'ºC'),
	(301784, 144, '2015-01-01 01:02:44.000000', 'temperatura', 911.0000, 'ºC'),
	(301785, 144, '2015-01-01 01:02:45.000000', 'temperatura', 641.0000, 'ºC'),
	(301786, 144, '2015-01-01 01:02:46.000000', 'temperatura', 469.0000, 'ºC'),
	(301787, 144, '2015-01-01 01:02:47.000000', 'temperatura', 426.0000, 'ºC'),
	(301788, 144, '2015-01-01 01:02:48.000000', 'temperatura', 723.0000, 'ºC'),
	(301789, 144, '2015-01-01 01:02:49.000000', 'temperatura', 1136.0000, 'ºC'),
	(301790, 144, '2015-01-01 01:02:50.000000', 'temperatura', 1112.0000, 'ºC'),
	(301791, 144, '2015-01-01 01:02:51.000000', 'temperatura', 951.0000, 'ºC'),
	(301792, 144, '2015-01-01 01:02:52.000000', 'temperatura', 219.0000, 'ºC'),
	(301793, 144, '2015-01-01 01:02:53.000000', 'temperatura', 642.0000, 'ºC'),
	(301794, 144, '2015-01-01 01:02:54.000000', 'temperatura', 154.0000, 'ºC'),
	(301795, 144, '2015-01-01 01:02:55.000000', 'temperatura', 45.0000, 'ºC'),
	(301796, 144, '2015-01-01 01:02:56.000000', 'temperatura', 962.0000, 'ºC'),
	(301797, 144, '2015-01-01 01:02:57.000000', 'temperatura', 1077.0000, 'ºC'),
	(301798, 144, '2015-01-01 01:02:58.000000', 'temperatura', 98.0000, 'ºC'),
	(301799, 144, '2015-01-01 01:02:59.000000', 'temperatura', 862.0000, 'ºC'),
	(301800, 144, '2015-01-01 01:03:00.000000', 'temperatura', 415.0000, 'ºC'),
	(301801, 144, '2015-01-01 01:03:01.000000', 'temperatura', 692.0000, 'ºC'),
	(301802, 144, '2015-01-01 01:03:02.000000', 'temperatura', 1012.0000, 'ºC'),
	(301803, 144, '2015-01-01 01:03:03.000000', 'temperatura', 585.0000, 'ºC'),
	(301804, 144, '2015-01-01 01:03:04.000000', 'temperatura', 1092.0000, 'ºC'),
	(301805, 144, '2015-01-01 01:03:05.000000', 'temperatura', 104.0000, 'ºC'),
	(301806, 144, '2015-01-01 01:03:06.000000', 'temperatura', 843.0000, 'ºC'),
	(301807, 144, '2015-01-01 01:03:07.000000', 'temperatura', 305.0000, 'ºC'),
	(301808, 144, '2015-01-01 01:03:08.000000', 'temperatura', 197.0000, 'ºC'),
	(301809, 144, '2015-01-01 01:03:09.000000', 'temperatura', 70.0000, 'ºC'),
	(301810, 144, '2015-01-01 01:03:10.000000', 'temperatura', 960.0000, 'ºC'),
	(301811, 144, '2015-01-01 01:03:11.000000', 'temperatura', 992.0000, 'ºC'),
	(301812, 144, '2015-01-01 01:03:12.000000', 'temperatura', 877.0000, 'ºC'),
	(301813, 144, '2015-01-01 01:03:13.000000', 'temperatura', 212.0000, 'ºC'),
	(301814, 144, '2015-01-01 01:03:14.000000', 'temperatura', 828.0000, 'ºC'),
	(301815, 144, '2015-01-01 01:03:15.000000', 'temperatura', 1104.0000, 'ºC'),
	(301816, 144, '2015-01-01 01:03:16.000000', 'temperatura', 638.0000, 'ºC'),
	(301817, 144, '2015-01-01 01:03:17.000000', 'temperatura', 1079.0000, 'ºC'),
	(301818, 144, '2015-01-01 01:03:18.000000', 'temperatura', 1081.0000, 'ºC'),
	(301819, 144, '2015-01-01 01:03:19.000000', 'temperatura', 969.0000, 'ºC'),
	(301820, 144, '2015-01-01 01:03:20.000000', 'temperatura', 401.0000, 'ºC'),
	(301821, 144, '2015-01-01 01:03:21.000000', 'temperatura', 298.0000, 'ºC'),
	(301822, 144, '2015-01-01 01:03:22.000000', 'temperatura', 289.0000, 'ºC'),
	(301823, 144, '2015-01-01 01:03:23.000000', 'temperatura', 551.0000, 'ºC'),
	(301824, 144, '2015-01-01 01:03:24.000000', 'temperatura', 688.0000, 'ºC'),
	(301825, 144, '2015-01-01 01:03:25.000000', 'temperatura', 588.0000, 'ºC'),
	(301826, 144, '2015-01-01 01:03:26.000000', 'temperatura', 877.0000, 'ºC'),
	(301827, 144, '2015-01-01 01:03:27.000000', 'temperatura', 222.0000, 'ºC'),
	(301828, 144, '2015-01-01 01:03:28.000000', 'temperatura', 880.0000, 'ºC'),
	(301829, 144, '2015-01-01 01:03:29.000000', 'temperatura', 133.0000, 'ºC'),
	(301830, 144, '2015-01-01 01:03:30.000000', 'temperatura', 427.0000, 'ºC'),
	(301831, 144, '2015-01-01 01:03:31.000000', 'temperatura', 536.0000, 'ºC'),
	(301832, 144, '2015-01-01 01:03:32.000000', 'temperatura', 199.0000, 'ºC'),
	(301833, 144, '2015-01-01 01:03:33.000000', 'temperatura', 590.0000, 'ºC'),
	(301834, 144, '2015-01-01 01:03:34.000000', 'temperatura', 1151.0000, 'ºC'),
	(301835, 144, '2015-01-01 01:03:35.000000', 'temperatura', 388.0000, 'ºC'),
	(301836, 144, '2015-01-01 01:03:36.000000', 'temperatura', 887.0000, 'ºC'),
	(301837, 144, '2015-01-01 01:03:37.000000', 'temperatura', 873.0000, 'ºC'),
	(301838, 144, '2015-01-01 01:03:38.000000', 'temperatura', 501.0000, 'ºC'),
	(301839, 144, '2015-01-01 01:03:39.000000', 'temperatura', 1089.0000, 'ºC'),
	(301840, 144, '2015-01-01 01:03:40.000000', 'temperatura', 344.0000, 'ºC'),
	(301841, 144, '2015-01-01 01:03:41.000000', 'temperatura', 850.0000, 'ºC'),
	(301842, 144, '2015-01-01 01:03:42.000000', 'temperatura', 821.0000, 'ºC'),
	(301843, 144, '2015-01-01 01:03:43.000000', 'temperatura', 356.0000, 'ºC'),
	(301844, 144, '2015-01-01 01:03:44.000000', 'temperatura', 519.0000, 'ºC'),
	(301845, 144, '2015-01-01 01:03:45.000000', 'temperatura', 324.0000, 'ºC'),
	(301846, 144, '2015-01-01 01:03:46.000000', 'temperatura', 65.0000, 'ºC'),
	(301847, 144, '2015-01-01 01:03:47.000000', 'temperatura', 554.0000, 'ºC'),
	(301848, 144, '2015-01-01 01:03:48.000000', 'temperatura', 176.0000, 'ºC'),
	(301849, 144, '2015-01-01 01:03:49.000000', 'temperatura', 420.0000, 'ºC'),
	(301850, 144, '2015-01-01 01:03:50.000000', 'temperatura', 369.0000, 'ºC'),
	(301851, 144, '2015-01-01 01:03:51.000000', 'temperatura', 587.0000, 'ºC'),
	(301852, 144, '2015-01-01 01:03:52.000000', 'temperatura', 631.0000, 'ºC'),
	(301853, 144, '2015-01-01 01:03:53.000000', 'temperatura', 191.0000, 'ºC'),
	(301854, 144, '2015-01-01 01:03:54.000000', 'temperatura', 263.0000, 'ºC'),
	(301855, 144, '2015-01-01 01:03:55.000000', 'temperatura', 741.0000, 'ºC'),
	(301856, 144, '2015-01-01 01:03:56.000000', 'temperatura', 520.0000, 'ºC'),
	(301857, 144, '2015-01-01 01:03:57.000000', 'temperatura', 374.0000, 'ºC'),
	(301858, 144, '2015-01-01 01:03:58.000000', 'temperatura', 314.0000, 'ºC'),
	(301859, 144, '2015-01-01 01:03:59.000000', 'temperatura', 446.0000, 'ºC'),
	(301860, 144, '2015-01-01 01:04:00.000000', 'temperatura', 90.0000, 'ºC'),
	(301861, 144, '2015-01-01 01:04:01.000000', 'temperatura', 312.0000, 'ºC'),
	(301862, 144, '2015-01-01 01:04:02.000000', 'temperatura', 91.0000, 'ºC'),
	(301863, 144, '2015-01-01 01:04:03.000000', 'temperatura', 717.0000, 'ºC'),
	(301864, 144, '2015-01-01 01:04:04.000000', 'temperatura', 915.0000, 'ºC'),
	(301865, 144, '2015-01-01 01:04:05.000000', 'temperatura', 24.0000, 'ºC'),
	(301866, 144, '2015-01-01 01:04:06.000000', 'temperatura', 974.0000, 'ºC'),
	(301867, 144, '2015-01-01 01:04:07.000000', 'temperatura', 1.0000, 'ºC'),
	(301868, 144, '2015-01-01 01:04:08.000000', 'temperatura', 684.0000, 'ºC'),
	(301869, 144, '2015-01-01 01:04:09.000000', 'temperatura', 1015.0000, 'ºC'),
	(301870, 144, '2015-01-01 01:04:10.000000', 'temperatura', 624.0000, 'ºC'),
	(301871, 144, '2015-01-01 01:04:11.000000', 'temperatura', 74.0000, 'ºC'),
	(301872, 144, '2015-01-01 01:04:12.000000', 'temperatura', 901.0000, 'ºC'),
	(301873, 144, '2015-01-01 01:04:13.000000', 'temperatura', 683.0000, 'ºC'),
	(301874, 144, '2015-01-01 01:04:14.000000', 'temperatura', 713.0000, 'ºC'),
	(301875, 144, '2015-01-01 01:04:15.000000', 'temperatura', 316.0000, 'ºC'),
	(301876, 144, '2015-01-01 01:04:16.000000', 'temperatura', 642.0000, 'ºC'),
	(301877, 144, '2015-01-01 01:04:17.000000', 'temperatura', 1062.0000, 'ºC'),
	(301878, 144, '2015-01-01 01:04:18.000000', 'temperatura', 986.0000, 'ºC'),
	(301879, 144, '2015-01-01 01:04:19.000000', 'temperatura', 546.0000, 'ºC'),
	(301880, 144, '2015-01-01 01:04:20.000000', 'temperatura', 969.0000, 'ºC'),
	(301881, 144, '2015-01-01 01:04:21.000000', 'temperatura', 807.0000, 'ºC'),
	(301882, 144, '2015-01-01 01:04:22.000000', 'temperatura', 1132.0000, 'ºC'),
	(301883, 144, '2015-01-01 01:04:23.000000', 'temperatura', 836.0000, 'ºC'),
	(301884, 144, '2015-01-01 01:04:24.000000', 'temperatura', 785.0000, 'ºC'),
	(301885, 144, '2015-01-01 01:04:25.000000', 'temperatura', 220.0000, 'ºC'),
	(301886, 144, '2015-01-01 01:04:26.000000', 'temperatura', 1144.0000, 'ºC'),
	(301887, 144, '2015-01-01 01:04:27.000000', 'temperatura', 259.0000, 'ºC'),
	(301888, 144, '2015-01-01 01:04:28.000000', 'temperatura', 267.0000, 'ºC'),
	(301889, 144, '2015-01-01 01:04:29.000000', 'temperatura', 555.0000, 'ºC'),
	(301890, 144, '2015-01-01 01:04:30.000000', 'temperatura', 776.0000, 'ºC'),
	(301891, 144, '2015-01-01 01:04:31.000000', 'temperatura', 1016.0000, 'ºC'),
	(301892, 144, '2015-01-01 01:04:32.000000', 'temperatura', 354.0000, 'ºC'),
	(301893, 144, '2015-01-01 01:04:33.000000', 'temperatura', 1121.0000, 'ºC'),
	(301894, 144, '2015-01-01 01:04:34.000000', 'temperatura', 944.0000, 'ºC'),
	(301895, 144, '2015-01-01 01:04:35.000000', 'temperatura', 155.0000, 'ºC'),
	(301896, 144, '2015-01-01 01:04:36.000000', 'temperatura', 346.0000, 'ºC'),
	(301897, 144, '2015-01-01 01:04:37.000000', 'temperatura', 66.0000, 'ºC'),
	(301898, 144, '2015-01-01 01:04:38.000000', 'temperatura', 491.0000, 'ºC'),
	(301899, 144, '2015-01-01 01:04:39.000000', 'temperatura', 1056.0000, 'ºC'),
	(301900, 144, '2015-01-01 01:04:40.000000', 'temperatura', 208.0000, 'ºC'),
	(301901, 144, '2015-01-01 01:04:41.000000', 'temperatura', 275.0000, 'ºC'),
	(301902, 144, '2015-01-01 01:04:42.000000', 'temperatura', 751.0000, 'ºC'),
	(301903, 144, '2015-01-01 01:04:43.000000', 'temperatura', 531.0000, 'ºC'),
	(301904, 144, '2015-01-01 01:04:44.000000', 'temperatura', 400.0000, 'ºC'),
	(301905, 144, '2015-01-01 01:04:45.000000', 'temperatura', 407.0000, 'ºC'),
	(301906, 144, '2015-01-01 01:04:46.000000', 'temperatura', 838.0000, 'ºC'),
	(301907, 144, '2015-01-01 01:04:47.000000', 'temperatura', 567.0000, 'ºC'),
	(301908, 144, '2015-01-01 01:04:48.000000', 'temperatura', 321.0000, 'ºC'),
	(301909, 144, '2015-01-01 01:04:49.000000', 'temperatura', 1107.0000, 'ºC'),
	(301910, 144, '2015-01-01 01:04:50.000000', 'temperatura', 972.0000, 'ºC'),
	(301911, 144, '2015-01-01 01:04:51.000000', 'temperatura', 339.0000, 'ºC'),
	(301912, 144, '2015-01-01 01:04:52.000000', 'temperatura', 1178.0000, 'ºC'),
	(301913, 144, '2015-01-01 01:04:53.000000', 'temperatura', 76.0000, 'ºC'),
	(301914, 144, '2015-01-01 01:04:54.000000', 'temperatura', 444.0000, 'ºC'),
	(301915, 144, '2015-01-01 01:04:55.000000', 'temperatura', 792.0000, 'ºC'),
	(301916, 144, '2015-01-01 01:04:56.000000', 'temperatura', 232.0000, 'ºC'),
	(301917, 144, '2015-01-01 01:04:57.000000', 'temperatura', 1181.0000, 'ºC'),
	(301918, 144, '2015-01-01 01:04:58.000000', 'temperatura', 411.0000, 'ºC'),
	(301919, 144, '2015-01-01 01:04:59.000000', 'temperatura', 911.0000, 'ºC'),
	(301920, 144, '2015-01-01 01:05:00.000000', 'temperatura', 923.0000, 'ºC'),
	(301921, 144, '2015-01-01 01:05:01.000000', 'temperatura', 683.0000, 'ºC'),
	(301922, 144, '2015-01-01 01:05:02.000000', 'temperatura', 645.0000, 'ºC'),
	(301923, 144, '2015-01-01 01:05:03.000000', 'temperatura', 1176.0000, 'ºC'),
	(301924, 144, '2015-01-01 01:05:04.000000', 'temperatura', 345.0000, 'ºC'),
	(301925, 144, '2015-01-01 01:05:05.000000', 'temperatura', 600.0000, 'ºC'),
	(301926, 144, '2015-01-01 01:05:06.000000', 'temperatura', 764.0000, 'ºC'),
	(301927, 144, '2015-01-01 01:05:07.000000', 'temperatura', 821.0000, 'ºC'),
	(301928, 144, '2015-01-01 01:05:08.000000', 'temperatura', 612.0000, 'ºC'),
	(301929, 144, '2015-01-01 01:05:09.000000', 'temperatura', 599.0000, 'ºC'),
	(301930, 144, '2015-01-01 01:05:10.000000', 'temperatura', 1159.0000, 'ºC'),
	(301931, 144, '2015-01-01 01:05:11.000000', 'temperatura', 397.0000, 'ºC'),
	(301932, 144, '2015-01-01 01:05:12.000000', 'temperatura', 910.0000, 'ºC'),
	(301933, 144, '2015-01-01 01:05:13.000000', 'temperatura', 959.0000, 'ºC'),
	(301934, 144, '2015-01-01 01:05:14.000000', 'temperatura', 865.0000, 'ºC'),
	(301935, 144, '2015-01-01 01:05:15.000000', 'temperatura', 250.0000, 'ºC'),
	(301936, 144, '2015-01-01 01:05:16.000000', 'temperatura', 1054.0000, 'ºC'),
	(301937, 144, '2015-01-01 01:05:17.000000', 'temperatura', 923.0000, 'ºC'),
	(301938, 144, '2015-01-01 01:05:18.000000', 'temperatura', 250.0000, 'ºC'),
	(301939, 144, '2015-01-01 01:05:19.000000', 'temperatura', 884.0000, 'ºC'),
	(301940, 144, '2015-01-01 01:05:20.000000', 'temperatura', 68.0000, 'ºC'),
	(301941, 144, '2015-01-01 01:05:21.000000', 'temperatura', 90.0000, 'ºC'),
	(301942, 144, '2015-01-01 01:05:22.000000', 'temperatura', 245.0000, 'ºC'),
	(301943, 144, '2015-01-01 01:05:23.000000', 'temperatura', 957.0000, 'ºC'),
	(301944, 144, '2015-01-01 01:05:24.000000', 'temperatura', 449.0000, 'ºC'),
	(301945, 144, '2015-01-01 01:05:25.000000', 'temperatura', 573.0000, 'ºC'),
	(301946, 144, '2015-01-01 01:05:26.000000', 'temperatura', 321.0000, 'ºC'),
	(301947, 144, '2015-01-01 01:05:27.000000', 'temperatura', 1088.0000, 'ºC'),
	(301948, 144, '2015-01-01 01:05:28.000000', 'temperatura', 874.0000, 'ºC'),
	(301949, 144, '2015-01-01 01:05:29.000000', 'temperatura', 1110.0000, 'ºC'),
	(301950, 144, '2015-01-01 01:05:30.000000', 'temperatura', 526.0000, 'ºC'),
	(301951, 144, '2015-01-01 01:05:31.000000', 'temperatura', 503.0000, 'ºC'),
	(301952, 144, '2015-01-01 01:05:32.000000', 'temperatura', 937.0000, 'ºC'),
	(301953, 144, '2015-01-01 01:05:33.000000', 'temperatura', 774.0000, 'ºC'),
	(301954, 144, '2015-01-01 01:05:34.000000', 'temperatura', 1061.0000, 'ºC'),
	(301955, 144, '2015-01-01 01:05:35.000000', 'temperatura', 583.0000, 'ºC'),
	(301956, 144, '2015-01-01 01:05:36.000000', 'temperatura', 932.0000, 'ºC'),
	(301957, 144, '2015-01-01 01:05:37.000000', 'temperatura', 512.0000, 'ºC'),
	(301958, 144, '2015-01-01 01:05:38.000000', 'temperatura', 967.0000, 'ºC'),
	(301959, 144, '2015-01-01 01:05:39.000000', 'temperatura', 896.0000, 'ºC'),
	(301960, 144, '2015-01-01 01:05:40.000000', 'temperatura', 380.0000, 'ºC'),
	(301961, 144, '2015-01-01 01:05:41.000000', 'temperatura', 415.0000, 'ºC'),
	(301962, 144, '2015-01-01 01:05:42.000000', 'temperatura', 933.0000, 'ºC'),
	(301963, 144, '2015-01-01 01:05:43.000000', 'temperatura', 1019.0000, 'ºC'),
	(301964, 144, '2015-01-01 01:05:44.000000', 'temperatura', 1099.0000, 'ºC'),
	(301965, 144, '2015-01-01 01:05:45.000000', 'temperatura', 36.0000, 'ºC'),
	(301966, 144, '2015-01-01 01:05:46.000000', 'temperatura', 487.0000, 'ºC'),
	(301967, 144, '2015-01-01 01:05:47.000000', 'temperatura', 1126.0000, 'ºC'),
	(301968, 144, '2015-01-01 01:05:48.000000', 'temperatura', 568.0000, 'ºC'),
	(301969, 144, '2015-01-01 01:05:49.000000', 'temperatura', 665.0000, 'ºC'),
	(301970, 144, '2015-01-01 01:05:50.000000', 'temperatura', 419.0000, 'ºC'),
	(301971, 144, '2015-01-01 01:05:51.000000', 'temperatura', 102.0000, 'ºC'),
	(301972, 144, '2015-01-01 01:05:52.000000', 'temperatura', 452.0000, 'ºC'),
	(301973, 144, '2015-01-01 01:05:53.000000', 'temperatura', 755.0000, 'ºC'),
	(301974, 144, '2015-01-01 01:05:54.000000', 'temperatura', 22.0000, 'ºC'),
	(301975, 144, '2015-01-01 01:05:55.000000', 'temperatura', 242.0000, 'ºC'),
	(301976, 144, '2015-01-01 01:05:56.000000', 'temperatura', 1147.0000, 'ºC'),
	(301977, 144, '2015-01-01 01:05:57.000000', 'temperatura', 208.0000, 'ºC'),
	(301978, 144, '2015-01-01 01:05:58.000000', 'temperatura', 0.0000, 'ºC'),
	(301979, 144, '2015-01-01 01:05:59.000000', 'temperatura', 575.0000, 'ºC'),
	(301980, 144, '2015-01-01 01:06:00.000000', 'temperatura', 476.0000, 'ºC'),
	(301981, 144, '2015-01-01 01:06:01.000000', 'temperatura', 657.0000, 'ºC'),
	(301982, 144, '2015-01-01 01:06:02.000000', 'temperatura', 655.0000, 'ºC'),
	(301983, 144, '2015-01-01 01:06:03.000000', 'temperatura', 106.0000, 'ºC'),
	(301984, 144, '2015-01-01 01:06:04.000000', 'temperatura', 966.0000, 'ºC'),
	(301985, 144, '2015-01-01 01:06:05.000000', 'temperatura', 911.0000, 'ºC'),
	(301986, 144, '2015-01-01 01:06:06.000000', 'temperatura', 458.0000, 'ºC'),
	(301987, 144, '2015-01-01 01:06:07.000000', 'temperatura', 758.0000, 'ºC'),
	(301988, 144, '2015-01-01 01:06:08.000000', 'temperatura', 17.0000, 'ºC'),
	(301989, 144, '2015-01-01 01:06:09.000000', 'temperatura', 211.0000, 'ºC'),
	(301990, 144, '2015-01-01 01:06:10.000000', 'temperatura', 1006.0000, 'ºC'),
	(301991, 144, '2015-01-01 01:06:11.000000', 'temperatura', 797.0000, 'ºC'),
	(301992, 144, '2015-01-01 01:06:12.000000', 'temperatura', 965.0000, 'ºC'),
	(301993, 144, '2015-01-01 01:06:13.000000', 'temperatura', 37.0000, 'ºC'),
	(301994, 144, '2015-01-01 01:06:14.000000', 'temperatura', 891.0000, 'ºC'),
	(301995, 144, '2015-01-01 01:06:15.000000', 'temperatura', 742.0000, 'ºC'),
	(301996, 144, '2015-01-01 01:06:16.000000', 'temperatura', 1040.0000, 'ºC'),
	(301997, 144, '2015-01-01 01:06:17.000000', 'temperatura', 575.0000, 'ºC'),
	(301998, 144, '2015-01-01 01:06:18.000000', 'temperatura', 955.0000, 'ºC'),
	(301999, 144, '2015-01-01 01:06:19.000000', 'temperatura', 650.0000, 'ºC'),
	(302000, 144, '2015-01-01 01:06:20.000000', 'temperatura', 385.0000, 'ºC'),
	(302001, 144, '2015-01-01 01:06:21.000000', 'temperatura', 1177.0000, 'ºC'),
	(302002, 144, '2015-01-01 01:06:22.000000', 'temperatura', 1129.0000, 'ºC'),
	(302003, 144, '2015-01-01 01:06:23.000000', 'temperatura', 916.0000, 'ºC'),
	(302004, 144, '2015-01-01 01:06:24.000000', 'temperatura', 1194.0000, 'ºC'),
	(302005, 144, '2015-01-01 01:06:25.000000', 'temperatura', 822.0000, 'ºC'),
	(302006, 144, '2015-01-01 01:06:26.000000', 'temperatura', 530.0000, 'ºC'),
	(302007, 144, '2015-01-01 01:06:27.000000', 'temperatura', 185.0000, 'ºC'),
	(302008, 144, '2015-01-01 01:06:28.000000', 'temperatura', 533.0000, 'ºC'),
	(302009, 144, '2015-01-01 01:06:29.000000', 'temperatura', 911.0000, 'ºC'),
	(302010, 144, '2015-01-01 01:06:30.000000', 'temperatura', 557.0000, 'ºC'),
	(302011, 144, '2015-01-01 01:06:31.000000', 'temperatura', 50.0000, 'ºC'),
	(302012, 144, '2015-01-01 01:06:32.000000', 'temperatura', 983.0000, 'ºC'),
	(302013, 144, '2015-01-01 01:06:33.000000', 'temperatura', 1164.0000, 'ºC'),
	(302014, 144, '2015-01-01 01:06:34.000000', 'temperatura', 473.0000, 'ºC'),
	(302015, 144, '2015-01-01 01:06:35.000000', 'temperatura', 73.0000, 'ºC'),
	(302016, 144, '2015-01-01 01:06:36.000000', 'temperatura', 144.0000, 'ºC'),
	(302017, 144, '2015-01-01 01:06:37.000000', 'temperatura', 504.0000, 'ºC'),
	(302018, 144, '2015-01-01 01:06:38.000000', 'temperatura', 887.0000, 'ºC'),
	(302019, 144, '2015-01-01 01:06:39.000000', 'temperatura', 522.0000, 'ºC'),
	(302020, 144, '2015-01-01 01:06:40.000000', 'temperatura', 1152.0000, 'ºC'),
	(302021, 144, '2015-01-01 01:06:41.000000', 'temperatura', 594.0000, 'ºC'),
	(302022, 144, '2015-01-01 01:06:42.000000', 'temperatura', 715.0000, 'ºC'),
	(302023, 144, '2015-01-01 01:06:43.000000', 'temperatura', 594.0000, 'ºC'),
	(302024, 144, '2015-01-01 01:06:44.000000', 'temperatura', 826.0000, 'ºC'),
	(302025, 144, '2015-01-01 01:06:45.000000', 'temperatura', 1146.0000, 'ºC'),
	(302026, 144, '2015-01-01 01:06:46.000000', 'temperatura', 853.0000, 'ºC'),
	(302027, 144, '2015-01-01 01:06:47.000000', 'temperatura', 826.0000, 'ºC'),
	(302028, 144, '2015-01-01 01:06:48.000000', 'temperatura', 374.0000, 'ºC'),
	(302029, 144, '2015-01-01 01:06:49.000000', 'temperatura', 594.0000, 'ºC'),
	(302030, 144, '2015-01-01 01:06:50.000000', 'temperatura', 646.0000, 'ºC'),
	(302031, 144, '2015-01-01 01:06:51.000000', 'temperatura', 248.0000, 'ºC'),
	(302032, 144, '2015-01-01 01:06:52.000000', 'temperatura', 502.0000, 'ºC'),
	(302033, 144, '2015-01-01 01:06:53.000000', 'temperatura', 568.0000, 'ºC'),
	(302034, 144, '2015-01-01 01:06:54.000000', 'temperatura', 134.0000, 'ºC'),
	(302035, 144, '2015-01-01 01:06:55.000000', 'temperatura', 165.0000, 'ºC'),
	(302036, 144, '2015-01-01 01:06:56.000000', 'temperatura', 425.0000, 'ºC'),
	(302037, 144, '2015-01-01 01:06:57.000000', 'temperatura', 430.0000, 'ºC'),
	(302038, 144, '2015-01-01 01:06:58.000000', 'temperatura', 875.0000, 'ºC'),
	(302039, 144, '2015-01-01 01:06:59.000000', 'temperatura', 687.0000, 'ºC'),
	(302040, 144, '2015-01-01 01:07:00.000000', 'temperatura', 810.0000, 'ºC'),
	(302041, 144, '2015-01-01 01:07:01.000000', 'temperatura', 791.0000, 'ºC'),
	(302042, 144, '2015-01-01 01:07:02.000000', 'temperatura', 326.0000, 'ºC'),
	(302043, 144, '2015-01-01 01:07:03.000000', 'temperatura', 455.0000, 'ºC'),
	(302044, 144, '2015-01-01 01:07:04.000000', 'temperatura', 100.0000, 'ºC'),
	(302045, 144, '2015-01-01 01:07:05.000000', 'temperatura', 333.0000, 'ºC'),
	(302046, 144, '2015-01-01 01:07:06.000000', 'temperatura', 167.0000, 'ºC'),
	(302047, 144, '2015-01-01 01:07:07.000000', 'temperatura', 1036.0000, 'ºC'),
	(302048, 144, '2015-01-01 01:07:08.000000', 'temperatura', 1080.0000, 'ºC'),
	(302049, 144, '2015-01-01 01:07:09.000000', 'temperatura', 1094.0000, 'ºC'),
	(302050, 144, '2015-01-01 01:07:10.000000', 'temperatura', 1027.0000, 'ºC'),
	(302051, 144, '2015-01-01 01:07:11.000000', 'temperatura', 657.0000, 'ºC'),
	(302052, 144, '2015-01-01 01:07:12.000000', 'temperatura', 203.0000, 'ºC'),
	(302053, 144, '2015-01-01 01:07:13.000000', 'temperatura', 246.0000, 'ºC'),
	(302054, 144, '2015-01-01 01:07:14.000000', 'temperatura', 622.0000, 'ºC'),
	(302055, 144, '2015-01-01 01:07:15.000000', 'temperatura', 1171.0000, 'ºC'),
	(302056, 144, '2015-01-01 01:07:16.000000', 'temperatura', 392.0000, 'ºC'),
	(302057, 144, '2015-01-01 01:07:17.000000', 'temperatura', 845.0000, 'ºC'),
	(302058, 144, '2015-01-01 01:07:18.000000', 'temperatura', 649.0000, 'ºC'),
	(302059, 144, '2015-01-01 01:07:19.000000', 'temperatura', 712.0000, 'ºC'),
	(302060, 144, '2015-01-01 01:07:20.000000', 'temperatura', 411.0000, 'ºC'),
	(302061, 144, '2015-01-01 01:07:21.000000', 'temperatura', 1121.0000, 'ºC'),
	(302062, 144, '2015-01-01 01:07:22.000000', 'temperatura', 771.0000, 'ºC'),
	(302063, 144, '2015-01-01 01:07:23.000000', 'temperatura', 494.0000, 'ºC'),
	(302064, 144, '2015-01-01 01:07:24.000000', 'temperatura', 156.0000, 'ºC'),
	(302065, 144, '2015-01-01 01:07:25.000000', 'temperatura', 501.0000, 'ºC'),
	(302066, 144, '2015-01-01 01:07:26.000000', 'temperatura', 834.0000, 'ºC'),
	(302067, 144, '2015-01-01 01:07:27.000000', 'temperatura', 271.0000, 'ºC'),
	(302068, 144, '2015-01-01 01:07:28.000000', 'temperatura', 53.0000, 'ºC'),
	(302069, 144, '2015-01-01 01:07:29.000000', 'temperatura', 651.0000, 'ºC'),
	(302070, 144, '2015-01-01 01:07:30.000000', 'temperatura', 699.0000, 'ºC'),
	(302071, 144, '2015-01-01 01:07:31.000000', 'temperatura', 341.0000, 'ºC'),
	(302072, 144, '2015-01-01 01:07:32.000000', 'temperatura', 807.0000, 'ºC'),
	(302073, 144, '2015-01-01 01:07:33.000000', 'temperatura', 613.0000, 'ºC'),
	(302074, 144, '2015-01-01 01:07:34.000000', 'temperatura', 644.0000, 'ºC'),
	(302075, 144, '2015-01-01 01:07:35.000000', 'temperatura', 180.0000, 'ºC'),
	(302076, 144, '2015-01-01 01:07:36.000000', 'temperatura', 171.0000, 'ºC'),
	(302077, 144, '2015-01-01 01:07:37.000000', 'temperatura', 316.0000, 'ºC'),
	(302078, 144, '2015-01-01 01:07:38.000000', 'temperatura', 1065.0000, 'ºC'),
	(302079, 144, '2015-01-01 01:07:39.000000', 'temperatura', 778.0000, 'ºC'),
	(302080, 144, '2015-01-01 01:07:40.000000', 'temperatura', 696.0000, 'ºC'),
	(302081, 144, '2015-01-01 01:07:41.000000', 'temperatura', 1145.0000, 'ºC'),
	(302082, 144, '2015-01-01 01:07:42.000000', 'temperatura', 38.0000, 'ºC'),
	(302083, 144, '2015-01-01 01:07:43.000000', 'temperatura', 358.0000, 'ºC'),
	(302084, 144, '2015-01-01 01:07:44.000000', 'temperatura', 475.0000, 'ºC'),
	(302085, 144, '2015-01-01 01:07:45.000000', 'temperatura', 102.0000, 'ºC'),
	(302086, 144, '2015-01-01 01:07:46.000000', 'temperatura', 284.0000, 'ºC'),
	(302087, 144, '2015-01-01 01:07:47.000000', 'temperatura', 1113.0000, 'ºC'),
	(302088, 144, '2015-01-01 01:07:48.000000', 'temperatura', 1117.0000, 'ºC'),
	(302089, 144, '2015-01-01 01:07:49.000000', 'temperatura', 1044.0000, 'ºC'),
	(302090, 144, '2015-01-01 01:07:50.000000', 'temperatura', 668.0000, 'ºC'),
	(302091, 144, '2015-01-01 01:07:51.000000', 'temperatura', 211.0000, 'ºC'),
	(302092, 144, '2015-01-01 01:07:52.000000', 'temperatura', 253.0000, 'ºC'),
	(302093, 144, '2015-01-01 01:07:53.000000', 'temperatura', 629.0000, 'ºC'),
	(302094, 144, '2015-01-01 01:07:54.000000', 'temperatura', 1188.0000, 'ºC'),
	(302095, 144, '2015-01-01 01:07:55.000000', 'temperatura', 451.0000, 'ºC'),
	(302096, 144, '2015-01-01 01:07:56.000000', 'temperatura', 1095.0000, 'ºC'),
	(302097, 144, '2015-01-01 01:07:57.000000', 'temperatura', 521.0000, 'ºC'),
	(302098, 144, '2015-01-01 01:07:58.000000', 'temperatura', 519.0000, 'ºC'),
	(302099, 144, '2015-01-01 01:07:59.000000', 'temperatura', 1032.0000, 'ºC'),
	(302100, 144, '2015-01-01 01:08:00.000000', 'temperatura', 5.0000, 'ºC'),
	(302101, 144, '2015-01-01 01:08:01.000000', 'temperatura', 531.0000, 'ºC'),
	(302102, 144, '2015-01-01 01:08:02.000000', 'temperatura', 237.0000, 'ºC'),
	(302103, 144, '2015-01-01 01:08:03.000000', 'temperatura', 795.0000, 'ºC'),
	(302104, 144, '2015-01-01 01:08:04.000000', 'temperatura', 863.0000, 'ºC'),
	(302105, 144, '2015-01-01 01:08:05.000000', 'temperatura', 730.0000, 'ºC'),
	(302106, 144, '2015-01-01 01:08:06.000000', 'temperatura', 1062.0000, 'ºC'),
	(302107, 144, '2015-01-01 01:08:07.000000', 'temperatura', 720.0000, 'ºC'),
	(302108, 144, '2015-01-01 01:08:08.000000', 'temperatura', 415.0000, 'ºC'),
	(302109, 144, '2015-01-01 01:08:09.000000', 'temperatura', 1115.0000, 'ºC'),
	(302110, 144, '2015-01-01 01:08:10.000000', 'temperatura', 730.0000, 'ºC'),
	(302111, 144, '2015-01-01 01:08:11.000000', 'temperatura', 305.0000, 'ºC'),
	(302112, 144, '2015-01-01 01:08:12.000000', 'temperatura', 537.0000, 'ºC'),
	(302113, 144, '2015-01-01 01:08:13.000000', 'temperatura', 571.0000, 'ºC'),
	(302114, 144, '2015-01-01 01:08:14.000000', 'temperatura', 45.0000, 'ºC'),
	(302115, 144, '2015-01-01 01:08:15.000000', 'temperatura', 913.0000, 'ºC'),
	(302116, 144, '2015-01-01 01:08:16.000000', 'temperatura', 829.0000, 'ºC'),
	(302117, 144, '2015-01-01 01:08:17.000000', 'temperatura', 206.0000, 'ºC'),
	(302118, 144, '2015-01-01 01:08:18.000000', 'temperatura', 943.0000, 'ºC'),
	(302119, 144, '2015-01-01 01:08:19.000000', 'temperatura', 499.0000, 'ºC'),
	(302120, 144, '2015-01-01 01:08:20.000000', 'temperatura', 868.0000, 'ºC'),
	(302121, 144, '2015-01-01 01:08:21.000000', 'temperatura', 441.0000, 'ºC'),
	(302122, 144, '2015-01-01 01:08:22.000000', 'temperatura', 801.0000, 'ºC'),
	(302123, 144, '2015-01-01 01:08:23.000000', 'temperatura', 282.0000, 'ºC'),
	(302124, 144, '2015-01-01 01:08:24.000000', 'temperatura', 209.0000, 'ºC'),
	(302125, 144, '2015-01-01 01:08:25.000000', 'temperatura', 199.0000, 'ºC'),
	(302126, 144, '2015-01-01 01:08:26.000000', 'temperatura', 368.0000, 'ºC'),
	(302127, 144, '2015-01-01 01:08:27.000000', 'temperatura', 46.0000, 'ºC'),
	(302128, 144, '2015-01-01 01:08:28.000000', 'temperatura', 325.0000, 'ºC'),
	(302129, 144, '2015-01-01 01:08:29.000000', 'temperatura', 287.0000, 'ºC'),
	(302130, 144, '2015-01-01 01:08:30.000000', 'temperatura', 460.0000, 'ºC'),
	(302131, 144, '2015-01-01 01:08:31.000000', 'temperatura', 241.0000, 'ºC'),
	(302132, 144, '2015-01-01 01:08:32.000000', 'temperatura', 1024.0000, 'ºC'),
	(302133, 144, '2015-01-01 01:08:33.000000', 'temperatura', 799.0000, 'ºC'),
	(302134, 144, '2015-01-01 01:08:34.000000', 'temperatura', 925.0000, 'ºC'),
	(302135, 144, '2015-01-01 01:08:35.000000', 'temperatura', 1026.0000, 'ºC'),
	(302136, 144, '2015-01-01 01:08:36.000000', 'temperatura', 1156.0000, 'ºC'),
	(302137, 144, '2015-01-01 01:08:37.000000', 'temperatura', 302.0000, 'ºC'),
	(302138, 144, '2015-01-01 01:08:38.000000', 'temperatura', 442.0000, 'ºC'),
	(302139, 144, '2015-01-01 01:08:39.000000', 'temperatura', 104.0000, 'ºC'),
	(302140, 144, '2015-01-01 01:08:40.000000', 'temperatura', 396.0000, 'ºC'),
	(302141, 144, '2015-01-01 01:08:41.000000', 'temperatura', 470.0000, 'ºC'),
	(302142, 144, '2015-01-01 01:08:42.000000', 'temperatura', 1161.0000, 'ºC'),
	(302143, 144, '2015-01-01 01:08:43.000000', 'temperatura', 795.0000, 'ºC'),
	(302144, 144, '2015-01-01 01:08:44.000000', 'temperatura', 495.0000, 'ºC'),
	(302145, 144, '2015-01-01 01:08:45.000000', 'temperatura', 88.0000, 'ºC'),
	(302146, 144, '2015-01-01 01:08:46.000000', 'temperatura', 155.0000, 'ºC'),
	(302147, 144, '2015-01-01 01:08:47.000000', 'temperatura', 513.0000, 'ºC'),
	(302148, 144, '2015-01-01 01:08:48.000000', 'temperatura', 902.0000, 'ºC'),
	(302149, 144, '2015-01-01 01:08:49.000000', 'temperatura', 569.0000, 'ºC'),
	(302150, 144, '2015-01-01 01:08:50.000000', 'temperatura', 139.0000, 'ºC'),
	(302151, 144, '2015-01-01 01:08:51.000000', 'temperatura', 191.0000, 'ºC'),
	(302152, 144, '2015-01-01 01:08:52.000000', 'temperatura', 537.0000, 'ºC'),
	(302153, 144, '2015-01-01 01:08:53.000000', 'temperatura', 912.0000, 'ºC'),
	(302154, 144, '2015-01-01 01:08:54.000000', 'temperatura', 552.0000, 'ºC'),
	(302155, 144, '2015-01-01 01:08:55.000000', 'temperatura', 22.0000, 'ºC'),
	(302156, 144, '2015-01-01 01:08:56.000000', 'temperatura', 857.0000, 'ºC'),
	(302157, 144, '2015-01-01 01:08:57.000000', 'temperatura', 618.0000, 'ºC'),
	(302158, 144, '2015-01-01 01:08:58.000000', 'temperatura', 519.0000, 'ºC'),
	(302159, 144, '2015-01-01 01:08:59.000000', 'temperatura', 743.0000, 'ºC'),
	(302160, 144, '2015-01-01 01:09:00.000000', 'temperatura', 960.0000, 'ºC'),
	(302161, 144, '2015-01-01 01:09:01.000000', 'temperatura', 169.0000, 'ºC'),
	(302162, 144, '2015-01-01 01:09:02.000000', 'temperatura', 367.0000, 'ºC'),
	(302163, 144, '2015-01-01 01:09:03.000000', 'temperatura', 128.0000, 'ºC'),
	(302164, 144, '2015-01-01 01:09:04.000000', 'temperatura', 738.0000, 'ºC'),
	(302165, 144, '2015-01-01 01:09:05.000000', 'temperatura', 907.0000, 'ºC'),
	(302166, 144, '2015-01-01 01:09:06.000000', 'temperatura', 1124.0000, 'ºC'),
	(302167, 144, '2015-01-01 01:09:07.000000', 'temperatura', 498.0000, 'ºC'),
	(302168, 144, '2015-01-01 01:09:08.000000', 'temperatura', 319.0000, 'ºC'),
	(302169, 144, '2015-01-01 01:09:09.000000', 'temperatura', 100.0000, 'ºC'),
	(302170, 144, '2015-01-01 01:09:10.000000', 'temperatura', 742.0000, 'ºC'),
	(302171, 144, '2015-01-01 01:09:11.000000', 'temperatura', 1014.0000, 'ºC'),
	(302172, 144, '2015-01-01 01:09:12.000000', 'temperatura', 444.0000, 'ºC'),
	(302173, 144, '2015-01-01 01:09:13.000000', 'temperatura', 376.0000, 'ºC'),
	(302174, 144, '2015-01-01 01:09:14.000000', 'temperatura', 549.0000, 'ºC'),
	(302175, 144, '2015-01-01 01:09:15.000000', 'temperatura', 418.0000, 'ºC'),
	(302176, 144, '2015-01-01 01:09:16.000000', 'temperatura', 444.0000, 'ºC'),
	(302177, 144, '2015-01-01 01:09:17.000000', 'temperatura', 965.0000, 'ºC'),
	(302178, 144, '2015-01-01 01:09:18.000000', 'temperatura', 1096.0000, 'ºC'),
	(302179, 144, '2015-01-01 01:09:19.000000', 'temperatura', 185.0000, 'ºC'),
	(302180, 144, '2015-01-01 01:09:20.000000', 'temperatura', 36.0000, 'ºC'),
	(302181, 144, '2015-01-01 01:09:21.000000', 'temperatura', 825.0000, 'ºC'),
	(302182, 144, '2015-01-01 01:09:22.000000', 'temperatura', 417.0000, 'ºC'),
	(302183, 144, '2015-01-01 01:09:23.000000', 'temperatura', 811.0000, 'ºC'),
	(302184, 144, '2015-01-01 01:09:24.000000', 'temperatura', 406.0000, 'ºC'),
	(302185, 144, '2015-01-01 01:09:25.000000', 'temperatura', 795.0000, 'ºC'),
	(302186, 144, '2015-01-01 01:09:26.000000', 'temperatura', 360.0000, 'ºC'),
	(302187, 144, '2015-01-01 01:09:27.000000', 'temperatura', 612.0000, 'ºC'),
	(302188, 144, '2015-01-01 01:09:28.000000', 'temperatura', 784.0000, 'ºC'),
	(302189, 144, '2015-01-01 01:09:29.000000', 'temperatura', 884.0000, 'ºC'),
	(302190, 144, '2015-01-01 01:09:30.000000', 'temperatura', 868.0000, 'ºC'),
	(302191, 144, '2015-01-01 01:09:31.000000', 'temperatura', 490.0000, 'ºC'),
	(302192, 144, '2015-01-01 01:09:32.000000', 'temperatura', 1044.0000, 'ºC'),
	(302193, 144, '2015-01-01 01:09:33.000000', 'temperatura', 151.0000, 'ºC'),
	(302194, 144, '2015-01-01 01:09:34.000000', 'temperatura', 26.0000, 'ºC'),
	(302195, 144, '2015-01-01 01:09:35.000000', 'temperatura', 876.0000, 'ºC'),
	(302196, 144, '2015-01-01 01:09:36.000000', 'temperatura', 702.0000, 'ºC'),
	(302197, 144, '2015-01-01 01:09:37.000000', 'temperatura', 881.0000, 'ºC'),
	(302198, 144, '2015-01-01 01:09:38.000000', 'temperatura', 1101.0000, 'ºC'),
	(302199, 144, '2015-01-01 01:09:39.000000', 'temperatura', 464.0000, 'ºC'),
	(302200, 144, '2015-01-01 01:09:40.000000', 'temperatura', 216.0000, 'ºC'),
	(302201, 144, '2015-01-01 01:09:41.000000', 'temperatura', 889.0000, 'ºC'),
	(302202, 144, '2015-01-01 01:09:42.000000', 'temperatura', 199.0000, 'ºC'),
	(302203, 144, '2015-01-01 01:09:43.000000', 'temperatura', 729.0000, 'ºC'),
	(302204, 144, '2015-01-01 01:09:44.000000', 'temperatura', 647.0000, 'ºC'),
	(302205, 144, '2015-01-01 01:09:45.000000', 'temperatura', 1050.0000, 'ºC'),
	(302206, 144, '2015-01-01 01:09:46.000000', 'temperatura', 908.0000, 'ºC'),
	(302207, 144, '2015-01-01 01:09:47.000000', 'temperatura', 193.0000, 'ºC'),
	(302208, 144, '2015-01-01 01:09:48.000000', 'temperatura', 640.0000, 'ºC'),
	(302209, 144, '2015-01-01 01:09:49.000000', 'temperatura', 221.0000, 'ºC'),
	(302210, 144, '2015-01-01 01:09:50.000000', 'temperatura', 384.0000, 'ºC'),
	(302211, 144, '2015-01-01 01:09:51.000000', 'temperatura', 59.0000, 'ºC'),
	(302212, 144, '2015-01-01 01:09:52.000000', 'temperatura', 344.0000, 'ºC'),
	(302213, 144, '2015-01-01 01:09:53.000000', 'temperatura', 345.0000, 'ºC'),
	(302214, 144, '2015-01-01 01:09:54.000000', 'temperatura', 691.0000, 'ºC'),
	(302215, 144, '2015-01-01 01:09:55.000000', 'temperatura', 21.0000, 'ºC'),
	(302216, 144, '2015-01-01 01:09:56.000000', 'temperatura', 435.0000, 'ºC'),
	(302217, 144, '2015-01-01 01:09:57.000000', 'temperatura', 910.0000, 'ºC'),
	(302218, 144, '2015-01-01 01:09:58.000000', 'temperatura', 846.0000, 'ºC'),
	(302219, 144, '2015-01-01 01:09:59.000000', 'temperatura', 301.0000, 'ºC'),
	(302220, 144, '2015-01-01 01:10:00.000000', 'temperatura', 166.0000, 'ºC'),
	(302221, 144, '2015-01-01 01:10:01.000000', 'temperatura', 1127.0000, 'ºC'),
	(302222, 144, '2015-01-01 01:10:02.000000', 'temperatura', 340.0000, 'ºC'),
	(302223, 144, '2015-01-01 01:10:03.000000', 'temperatura', 720.0000, 'ºC'),
	(302224, 144, '2015-01-01 01:10:04.000000', 'temperatura', 178.0000, 'ºC'),
	(302225, 144, '2015-01-01 01:10:05.000000', 'temperatura', 1132.0000, 'ºC'),
	(302226, 144, '2015-01-01 01:10:06.000000', 'temperatura', 326.0000, 'ºC'),
	(302227, 144, '2015-01-01 01:10:07.000000', 'temperatura', 636.0000, 'ºC'),
	(302228, 144, '2015-01-01 01:10:08.000000', 'temperatura', 1002.0000, 'ºC'),
	(302229, 144, '2015-01-01 01:10:09.000000', 'temperatura', 703.0000, 'ºC'),
	(302230, 144, '2015-01-01 01:10:10.000000', 'temperatura', 507.0000, 'ºC'),
	(302231, 144, '2015-01-01 01:10:11.000000', 'temperatura', 427.0000, 'ºC'),
	(302232, 144, '2015-01-01 01:10:12.000000', 'temperatura', 616.0000, 'ºC'),
	(302233, 144, '2015-01-01 01:10:13.000000', 'temperatura', 600.0000, 'ºC'),
	(302234, 144, '2015-01-01 01:10:14.000000', 'temperatura', 1151.0000, 'ºC'),
	(302235, 144, '2015-01-01 01:10:15.000000', 'temperatura', 356.0000, 'ºC'),
	(302236, 144, '2015-01-01 01:10:16.000000', 'temperatura', 729.0000, 'ºC'),
	(302237, 144, '2015-01-01 01:10:17.000000', 'temperatura', 175.0000, 'ºC'),
	(302238, 144, '2015-01-01 01:10:18.000000', 'temperatura', 1091.0000, 'ºC'),
	(302239, 144, '2015-01-01 01:10:19.000000', 'temperatura', 127.0000, 'ºC'),
	(302240, 144, '2015-01-01 01:10:20.000000', 'temperatura', 966.0000, 'ºC'),
	(302241, 144, '2015-01-01 01:10:21.000000', 'temperatura', 849.0000, 'ºC'),
	(302242, 144, '2015-01-01 01:10:22.000000', 'temperatura', 147.0000, 'ºC'),
	(302243, 144, '2015-01-01 01:10:23.000000', 'temperatura', 590.0000, 'ºC'),
	(302244, 144, '2015-01-01 01:10:24.000000', 'temperatura', 109.0000, 'ºC'),
	(302245, 144, '2015-01-01 01:10:25.000000', 'temperatura', 1177.0000, 'ºC'),
	(302246, 144, '2015-01-01 01:10:26.000000', 'temperatura', 757.0000, 'ºC'),
	(302247, 144, '2015-01-01 01:10:27.000000', 'temperatura', 254.0000, 'ºC'),
	(302248, 144, '2015-01-01 01:10:28.000000', 'temperatura', 199.0000, 'ºC'),
	(302249, 144, '2015-01-01 01:10:29.000000', 'temperatura', 234.0000, 'ºC'),
	(302250, 144, '2015-01-01 01:10:30.000000', 'temperatura', 575.0000, 'ºC'),
	(302251, 144, '2015-01-01 01:10:31.000000', 'temperatura', 973.0000, 'ºC'),
	(302252, 144, '2015-01-01 01:10:32.000000', 'temperatura', 741.0000, 'ºC'),
	(302253, 144, '2015-01-01 01:10:33.000000', 'temperatura', 784.0000, 'ºC'),
	(302254, 144, '2015-01-01 01:10:34.000000', 'temperatura', 499.0000, 'ºC'),
	(302255, 144, '2015-01-01 01:10:35.000000', 'temperatura', 142.0000, 'ºC'),
	(302256, 144, '2015-01-01 01:10:36.000000', 'temperatura', 414.0000, 'ºC'),
	(302257, 144, '2015-01-01 01:10:37.000000', 'temperatura', 445.0000, 'ºC'),
	(302258, 144, '2015-01-01 01:10:38.000000', 'temperatura', 982.0000, 'ºC'),
	(302259, 144, '2015-01-01 01:10:39.000000', 'temperatura', 1175.0000, 'ºC'),
	(302260, 144, '2015-01-01 01:10:40.000000', 'temperatura', 531.0000, 'ºC'),
	(302261, 144, '2015-01-01 01:10:41.000000', 'temperatura', 329.0000, 'ºC'),
	(302262, 144, '2015-01-01 01:10:42.000000', 'temperatura', 55.0000, 'ºC'),
	(302263, 144, '2015-01-01 01:10:43.000000', 'temperatura', 488.0000, 'ºC'),
	(302264, 144, '2015-01-01 01:10:44.000000', 'temperatura', 1076.0000, 'ºC'),
	(302265, 144, '2015-01-01 01:10:45.000000', 'temperatura', 318.0000, 'ºC'),
	(302266, 144, '2015-01-01 01:10:46.000000', 'temperatura', 760.0000, 'ºC'),
	(302267, 144, '2015-01-01 01:10:47.000000', 'temperatura', 447.0000, 'ºC'),
	(302268, 144, '2015-01-01 01:10:48.000000', 'temperatura', 1157.0000, 'ºC'),
	(302269, 144, '2015-01-01 01:10:49.000000', 'temperatura', 842.0000, 'ºC'),
	(302270, 144, '2015-01-01 01:10:50.000000', 'temperatura', 742.0000, 'ºC'),
	(302271, 144, '2015-01-01 01:10:51.000000', 'temperatura', 1182.0000, 'ºC'),
	(302272, 144, '2015-01-01 01:10:52.000000', 'temperatura', 85.0000, 'ºC'),
	(302273, 144, '2015-01-01 01:10:53.000000', 'temperatura', 482.0000, 'ºC'),
	(302274, 144, '2015-01-01 01:10:54.000000', 'temperatura', 953.0000, 'ºC'),
	(302275, 144, '2015-01-01 01:10:55.000000', 'temperatura', 921.0000, 'ºC'),
	(302276, 144, '2015-01-01 01:10:56.000000', 'temperatura', 548.0000, 'ºC'),
	(302277, 144, '2015-01-01 01:10:57.000000', 'temperatura', 1174.0000, 'ºC'),
	(302278, 144, '2015-01-01 01:10:58.000000', 'temperatura', 628.0000, 'ºC'),
	(302279, 144, '2015-01-01 01:10:59.000000', 'temperatura', 820.0000, 'ºC'),
	(302280, 144, '2015-01-01 01:11:00.000000', 'temperatura', 1013.0000, 'ºC'),
	(302281, 144, '2015-01-01 01:11:01.000000', 'temperatura', 209.0000, 'ºC'),
	(302282, 144, '2015-01-01 01:11:02.000000', 'temperatura', 407.0000, 'ºC'),
	(302283, 144, '2015-01-01 01:11:03.000000', 'temperatura', 205.0000, 'ºC'),
	(302284, 144, '2015-01-01 01:11:04.000000', 'temperatura', 1007.0000, 'ºC'),
	(302285, 144, '2015-01-01 01:11:05.000000', 'temperatura', 822.0000, 'ºC'),
	(302286, 144, '2015-01-01 01:11:06.000000', 'temperatura', 1087.0000, 'ºC'),
	(302287, 144, '2015-01-01 01:11:07.000000', 'temperatura', 570.0000, 'ºC'),
	(302288, 144, '2015-01-01 01:11:08.000000', 'temperatura', 790.0000, 'ºC'),
	(302289, 144, '2015-01-01 01:11:09.000000', 'temperatura', 1041.0000, 'ºC'),
	(302290, 144, '2015-01-01 01:11:10.000000', 'temperatura', 434.0000, 'ºC'),
	(302291, 144, '2015-01-01 01:11:11.000000', 'temperatura', 249.0000, 'ºC'),
	(302292, 144, '2015-01-01 01:11:12.000000', 'temperatura', 1145.0000, 'ºC'),
	(302293, 144, '2015-01-01 01:11:13.000000', 'temperatura', 177.0000, 'ºC'),
	(302294, 144, '2015-01-01 01:11:14.000000', 'temperatura', 1051.0000, 'ºC'),
	(302295, 144, '2015-01-01 01:11:15.000000', 'temperatura', 1126.0000, 'ºC'),
	(302296, 144, '2015-01-01 01:11:16.000000', 'temperatura', 74.0000, 'ºC'),
	(302297, 144, '2015-01-01 01:11:17.000000', 'temperatura', 595.0000, 'ºC'),
	(302298, 144, '2015-01-01 01:11:18.000000', 'temperatura', 353.0000, 'ºC'),
	(302299, 144, '2015-01-01 01:11:19.000000', 'temperatura', 1182.0000, 'ºC'),
	(302300, 144, '2015-01-01 01:11:20.000000', 'temperatura', 52.0000, 'ºC'),
	(302301, 144, '2015-01-01 01:11:21.000000', 'temperatura', 315.0000, 'ºC'),
	(302302, 144, '2015-01-01 01:11:22.000000', 'temperatura', 219.0000, 'ºC'),
	(302303, 144, '2015-01-01 01:11:23.000000', 'temperatura', 151.0000, 'ºC'),
	(302304, 144, '2015-01-01 01:11:24.000000', 'temperatura', 96.0000, 'ºC'),
	(302305, 144, '2015-01-01 01:11:25.000000', 'temperatura', 29.0000, 'ºC'),
	(302306, 144, '2015-01-01 01:11:26.000000', 'temperatura', 1055.0000, 'ºC'),
	(302307, 144, '2015-01-01 01:11:27.000000', 'temperatura', 392.0000, 'ºC'),
	(302308, 144, '2015-01-01 01:11:28.000000', 'temperatura', 1195.0000, 'ºC'),
	(302309, 144, '2015-01-01 01:11:29.000000', 'temperatura', 1198.0000, 'ºC'),
	(302310, 144, '2015-01-01 01:11:30.000000', 'temperatura', 7.0000, 'ºC'),
	(302311, 144, '2015-01-01 01:11:31.000000', 'temperatura', 40.0000, 'ºC'),
	(302312, 144, '2015-01-01 01:11:32.000000', 'temperatura', 179.0000, 'ºC'),
	(302313, 144, '2015-01-01 01:11:33.000000', 'temperatura', 778.0000, 'ºC'),
	(302314, 144, '2015-01-01 01:11:34.000000', 'temperatura', 951.0000, 'ºC'),
	(302315, 144, '2015-01-01 01:11:35.000000', 'temperatura', 22.0000, 'ºC'),
	(302316, 144, '2015-01-01 01:11:36.000000', 'temperatura', 856.0000, 'ºC'),
	(302317, 144, '2015-01-01 01:11:37.000000', 'temperatura', 617.0000, 'ºC'),
	(302318, 144, '2015-01-01 01:11:38.000000', 'temperatura', 517.0000, 'ºC'),
	(302319, 144, '2015-01-01 01:11:39.000000', 'temperatura', 734.0000, 'ºC'),
	(302320, 144, '2015-01-01 01:11:40.000000', 'temperatura', 921.0000, 'ºC'),
	(302321, 144, '2015-01-01 01:11:41.000000', 'temperatura', 4.0000, 'ºC'),
	(302322, 144, '2015-01-01 01:11:42.000000', 'temperatura', 857.0000, 'ºC'),
	(302323, 144, '2015-01-01 01:11:43.000000', 'temperatura', 673.0000, 'ºC'),
	(302324, 144, '2015-01-01 01:11:44.000000', 'temperatura', 793.0000, 'ºC'),
	(302325, 144, '2015-01-01 01:11:45.000000', 'temperatura', 746.0000, 'ºC'),
	(302326, 144, '2015-01-01 01:11:46.000000', 'temperatura', 154.0000, 'ºC'),
	(302327, 144, '2015-01-01 01:11:47.000000', 'temperatura', 930.0000, 'ºC'),
	(302328, 144, '2015-01-01 01:11:48.000000', 'temperatura', 591.0000, 'ºC'),
	(302329, 144, '2015-01-01 01:11:49.000000', 'temperatura', 166.0000, 'ºC'),
	(302330, 144, '2015-01-01 01:11:50.000000', 'temperatura', 256.0000, 'ºC'),
	(302331, 144, '2015-01-01 01:11:51.000000', 'temperatura', 783.0000, 'ºC'),
	(302332, 144, '2015-01-01 01:11:52.000000', 'temperatura', 749.0000, 'ºC'),
	(302333, 144, '2015-01-01 01:11:53.000000', 'temperatura', 194.0000, 'ºC'),
	(302334, 144, '2015-01-01 01:11:54.000000', 'temperatura', 1123.0000, 'ºC'),
	(302335, 144, '2015-01-01 01:11:55.000000', 'temperatura', 236.0000, 'ºC'),
	(302336, 144, '2015-01-01 01:11:56.000000', 'temperatura', 209.0000, 'ºC'),
	(302337, 144, '2015-01-01 01:11:57.000000', 'temperatura', 338.0000, 'ºC'),
	(302338, 144, '2015-01-01 01:11:58.000000', 'temperatura', 1063.0000, 'ºC'),
	(302339, 144, '2015-01-01 01:11:59.000000', 'temperatura', 701.0000, 'ºC'),
	(302340, 144, '2015-01-01 01:12:00.000000', 'temperatura', 316.0000, 'ºC'),
	(302341, 144, '2015-01-01 01:12:01.000000', 'temperatura', 681.0000, 'ºC'),
	(302342, 144, '2015-01-01 01:12:02.000000', 'temperatura', 54.0000, 'ºC'),
	(302343, 144, '2015-01-01 01:12:03.000000', 'temperatura', 627.0000, 'ºC'),
	(302344, 144, '2015-01-01 01:12:04.000000', 'temperatura', 573.0000, 'ºC'),
	(302345, 144, '2015-01-01 01:12:05.000000', 'temperatura', 987.0000, 'ºC'),
	(302346, 144, '2015-01-01 01:12:06.000000', 'temperatura', 816.0000, 'ºC'),
	(302347, 144, '2015-01-01 01:12:07.000000', 'temperatura', 1119.0000, 'ºC'),
	(302348, 144, '2015-01-01 01:12:08.000000', 'temperatura', 746.0000, 'ºC'),
	(302349, 144, '2015-01-01 01:12:09.000000', 'temperatura', 375.0000, 'ºC'),
	(302350, 144, '2015-01-01 01:12:10.000000', 'temperatura', 837.0000, 'ºC'),
	(302351, 144, '2015-01-01 01:12:11.000000', 'temperatura', 659.0000, 'ºC'),
	(302352, 144, '2015-01-01 01:12:12.000000', 'temperatura', 785.0000, 'ºC'),
	(302353, 144, '2015-01-01 01:12:13.000000', 'temperatura', 750.0000, 'ºC'),
	(302354, 144, '2015-01-01 01:12:14.000000', 'temperatura', 197.0000, 'ºC'),
	(302355, 144, '2015-01-01 01:12:15.000000', 'temperatura', 1132.0000, 'ºC'),
	(302356, 144, '2015-01-01 01:12:16.000000', 'temperatura', 271.0000, 'ºC'),
	(302357, 144, '2015-01-01 01:12:17.000000', 'temperatura', 360.0000, 'ºC'),
	(302358, 144, '2015-01-01 01:12:18.000000', 'temperatura', 988.0000, 'ºC'),
	(302359, 144, '2015-01-01 01:12:19.000000', 'temperatura', 261.0000, 'ºC'),
	(302360, 144, '2015-01-01 01:12:20.000000', 'temperatura', 741.0000, 'ºC'),
	(302361, 144, '2015-01-01 01:12:21.000000', 'temperatura', 524.0000, 'ºC'),
	(302362, 144, '2015-01-01 01:12:22.000000', 'temperatura', 394.0000, 'ºC'),
	(302363, 144, '2015-01-01 01:12:23.000000', 'temperatura', 402.0000, 'ºC'),
	(302364, 144, '2015-01-01 01:12:24.000000', 'temperatura', 828.0000, 'ºC'),
	(302365, 144, '2015-01-01 01:12:25.000000', 'temperatura', 534.0000, 'ºC'),
	(302366, 144, '2015-01-01 01:12:26.000000', 'temperatura', 187.0000, 'ºC'),
	(302367, 144, '2015-01-01 01:12:27.000000', 'temperatura', 535.0000, 'ºC'),
	(302368, 144, '2015-01-01 01:12:28.000000', 'temperatura', 912.0000, 'ºC'),
	(302369, 144, '2015-01-01 01:12:29.000000', 'temperatura', 558.0000, 'ºC'),
	(302370, 144, '2015-01-01 01:12:30.000000', 'temperatura', 54.0000, 'ºC'),
	(302371, 144, '2015-01-01 01:12:31.000000', 'temperatura', 997.0000, 'ºC'),
	(302372, 144, '2015-01-01 01:12:32.000000', 'temperatura', 23.0000, 'ºC'),
	(302373, 144, '2015-01-01 01:12:33.000000', 'temperatura', 724.0000, 'ºC'),
	(302374, 144, '2015-01-01 01:12:34.000000', 'temperatura', 1153.0000, 'ºC'),
	(302375, 144, '2015-01-01 01:12:35.000000', 'temperatura', 1193.0000, 'ºC'),
	(302376, 144, '2015-01-01 01:12:36.000000', 'temperatura', 104.0000, 'ºC'),
	(302377, 144, '2015-01-01 01:12:37.000000', 'temperatura', 545.0000, 'ºC'),
	(302378, 144, '2015-01-01 01:12:38.000000', 'temperatura', 13.0000, 'ºC'),
	(302379, 144, '2015-01-01 01:12:39.000000', 'temperatura', 828.0000, 'ºC'),
	(302380, 144, '2015-01-01 01:12:40.000000', 'temperatura', 503.0000, 'ºC'),
	(302381, 144, '2015-01-01 01:12:41.000000', 'temperatura', 31.0000, 'ºC'),
	(302382, 144, '2015-01-01 01:12:42.000000', 'temperatura', 1047.0000, 'ºC'),
	(302383, 144, '2015-01-01 01:12:43.000000', 'temperatura', 344.0000, 'ºC'),
	(302384, 144, '2015-01-01 01:12:44.000000', 'temperatura', 977.0000, 'ºC'),
	(302385, 144, '2015-01-01 01:12:45.000000', 'temperatura', 254.0000, 'ºC'),
	(302386, 144, '2015-01-01 01:12:46.000000', 'temperatura', 741.0000, 'ºC'),
	(302387, 144, '2015-01-01 01:12:47.000000', 'temperatura', 543.0000, 'ºC'),
	(302388, 144, '2015-01-01 01:12:48.000000', 'temperatura', 493.0000, 'ºC'),
	(302389, 144, '2015-01-01 01:12:49.000000', 'temperatura', 837.0000, 'ºC'),
	(302390, 144, '2015-01-01 01:12:50.000000', 'temperatura', 306.0000, 'ºC'),
	(302391, 144, '2015-01-01 01:12:51.000000', 'temperatura', 220.0000, 'ºC'),
	(302392, 144, '2015-01-01 01:12:52.000000', 'temperatura', 184.0000, 'ºC'),
	(302393, 144, '2015-01-01 01:12:53.000000', 'temperatura', 259.0000, 'ºC'),
	(302394, 144, '2015-01-01 01:12:54.000000', 'temperatura', 744.0000, 'ºC'),
	(302395, 144, '2015-01-01 01:12:55.000000', 'temperatura', 545.0000, 'ºC'),
	(302396, 144, '2015-01-01 01:12:56.000000', 'temperatura', 490.0000, 'ºC'),
	(302397, 144, '2015-01-01 01:12:57.000000', 'temperatura', 818.0000, 'ºC'),
	(302398, 144, '2015-01-01 01:12:58.000000', 'temperatura', 221.0000, 'ºC'),
	(302399, 144, '2015-01-01 01:12:59.000000', 'temperatura', 1051.0000, 'ºC'),
	(302400, 144, '2015-01-01 01:13:00.000000', 'temperatura', 991.0000, 'ºC'),
	(302401, 144, '2015-01-01 01:13:01.000000', 'temperatura', 604.0000, 'ºC'),
	(302402, 144, '2015-01-01 01:13:02.000000', 'temperatura', 45.0000, 'ºC'),
	(302403, 144, '2015-01-01 01:13:03.000000', 'temperatura', 817.0000, 'ºC'),
	(302404, 144, '2015-01-01 01:13:04.000000', 'temperatura', 347.0000, 'ºC'),
	(302405, 144, '2015-01-01 01:13:05.000000', 'temperatura', 488.0000, 'ºC'),
	(302406, 144, '2015-01-01 01:13:06.000000', 'temperatura', 198.0000, 'ºC'),
	(302407, 144, '2015-01-01 01:13:07.000000', 'temperatura', 727.0000, 'ºC'),
	(302408, 144, '2015-01-01 01:13:08.000000', 'temperatura', 640.0000, 'ºC'),
	(302409, 144, '2015-01-01 01:13:09.000000', 'temperatura', 1019.0000, 'ºC'),
	(302410, 144, '2015-01-01 01:13:10.000000', 'temperatura', 777.0000, 'ºC'),
	(302411, 144, '2015-01-01 01:13:11.000000', 'temperatura', 830.0000, 'ºC'),
	(302412, 144, '2015-01-01 01:13:12.000000', 'temperatura', 617.0000, 'ºC'),
	(302413, 144, '2015-01-01 01:13:13.000000', 'temperatura', 595.0000, 'ºC'),
	(302414, 144, '2015-01-01 01:13:14.000000', 'temperatura', 1125.0000, 'ºC'),
	(302415, 144, '2015-01-01 01:13:15.000000', 'temperatura', 242.0000, 'ºC'),
	(302416, 144, '2015-01-01 01:13:16.000000', 'temperatura', 234.0000, 'ºC'),
	(302417, 144, '2015-01-01 01:13:17.000000', 'temperatura', 447.0000, 'ºC'),
	(302418, 144, '2015-01-01 01:13:18.000000', 'temperatura', 331.0000, 'ºC'),
	(302419, 144, '2015-01-01 01:13:19.000000', 'temperatura', 313.0000, 'ºC'),
	(302420, 144, '2015-01-01 01:13:20.000000', 'temperatura', 576.0000, 'ºC'),
	(302421, 144, '2015-01-01 01:13:21.000000', 'temperatura', 739.0000, 'ºC'),
	(302422, 144, '2015-01-01 01:13:22.000000', 'temperatura', 768.0000, 'ºC'),
	(302423, 144, '2015-01-01 01:13:23.000000', 'temperatura', 425.0000, 'ºC'),
	(302424, 144, '2015-01-01 01:13:24.000000', 'temperatura', 1022.0000, 'ºC'),
	(302425, 144, '2015-01-01 01:13:25.000000', 'temperatura', 233.0000, 'ºC'),
	(302426, 144, '2015-01-01 01:13:26.000000', 'temperatura', 501.0000, 'ºC'),
	(302427, 144, '2015-01-01 01:13:27.000000', 'temperatura', 607.0000, 'ºC'),
	(302428, 144, '2015-01-01 01:13:28.000000', 'temperatura', 331.0000, 'ºC'),
	(302429, 144, '2015-01-01 01:13:29.000000', 'temperatura', 1035.0000, 'ºC'),
	(302430, 144, '2015-01-01 01:13:30.000000', 'temperatura', 584.0000, 'ºC'),
	(302431, 144, '2015-01-01 01:13:31.000000', 'temperatura', 1012.0000, 'ºC'),
	(302432, 144, '2015-01-01 01:13:32.000000', 'temperatura', 912.0000, 'ºC'),
	(302433, 144, '2015-01-01 01:13:33.000000', 'temperatura', 324.0000, 'ºC'),
	(302434, 144, '2015-01-01 01:13:34.000000', 'temperatura', 83.0000, 'ºC'),
	(302435, 144, '2015-01-01 01:13:35.000000', 'temperatura', 643.0000, 'ºC'),
	(302436, 144, '2015-01-01 01:13:36.000000', 'temperatura', 567.0000, 'ºC'),
	(302437, 144, '2015-01-01 01:13:37.000000', 'temperatura', 908.0000, 'ºC'),
	(302438, 144, '2015-01-01 01:13:38.000000', 'temperatura', 439.0000, 'ºC'),
	(302439, 144, '2015-01-01 01:13:39.000000', 'temperatura', 672.0000, 'ºC'),
	(302440, 144, '2015-01-01 01:13:40.000000', 'temperatura', 843.0000, 'ºC'),
	(302441, 144, '2015-01-01 01:13:41.000000', 'temperatura', 999.0000, 'ºC'),
	(302442, 144, '2015-01-01 01:13:42.000000', 'temperatura', 65.0000, 'ºC'),
	(302443, 144, '2015-01-01 01:13:43.000000', 'temperatura', 930.0000, 'ºC'),
	(302444, 144, '2015-01-01 01:13:44.000000', 'temperatura', 857.0000, 'ºC'),
	(302445, 144, '2015-01-01 01:13:45.000000', 'temperatura', 294.0000, 'ºC'),
	(302446, 144, '2015-01-01 01:13:46.000000', 'temperatura', 99.0000, 'ºC'),
	(302447, 144, '2015-01-01 01:13:47.000000', 'temperatura', 813.0000, 'ºC'),
	(302448, 144, '2015-01-01 01:13:48.000000', 'temperatura', 169.0000, 'ºC'),
	(302449, 144, '2015-01-01 01:13:49.000000', 'temperatura', 807.0000, 'ºC'),
	(302450, 144, '2015-01-01 01:13:50.000000', 'temperatura', 1127.0000, 'ºC'),
	(302451, 144, '2015-01-01 01:13:51.000000', 'temperatura', 815.0000, 'ºC'),
	(302452, 144, '2015-01-01 01:13:52.000000', 'temperatura', 694.0000, 'ºC'),
	(302453, 144, '2015-01-01 01:13:53.000000', 'temperatura', 1025.0000, 'ºC'),
	(302454, 144, '2015-01-01 01:13:54.000000', 'temperatura', 643.0000, 'ºC'),
	(302455, 144, '2015-01-01 01:13:55.000000', 'temperatura', 142.0000, 'ºC'),
	(302456, 144, '2015-01-01 01:13:56.000000', 'temperatura', 1182.0000, 'ºC'),
	(302457, 144, '2015-01-01 01:13:57.000000', 'temperatura', 685.0000, 'ºC'),
	(302458, 144, '2015-01-01 01:13:58.000000', 'temperatura', 1079.0000, 'ºC'),
	(302459, 144, '2015-01-01 01:13:59.000000', 'temperatura', 942.0000, 'ºC'),
	(302460, 144, '2015-01-01 01:14:00.000000', 'temperatura', 273.0000, 'ºC'),
	(302461, 144, '2015-01-01 01:14:01.000000', 'temperatura', 939.0000, 'ºC'),
	(302462, 144, '2015-01-01 01:14:02.000000', 'temperatura', 278.0000, 'ºC'),
	(302463, 144, '2015-01-01 01:14:03.000000', 'temperatura', 974.0000, 'ºC'),
	(302464, 144, '2015-01-01 01:14:04.000000', 'temperatura', 434.0000, 'ºC'),
	(302465, 144, '2015-01-01 01:14:05.000000', 'temperatura', 450.0000, 'ºC'),
	(302466, 144, '2015-01-01 01:14:06.000000', 'temperatura', 949.0000, 'ºC'),
	(302467, 144, '2015-01-01 01:14:07.000000', 'temperatura', 994.0000, 'ºC'),
	(302468, 144, '2015-01-01 01:14:08.000000', 'temperatura', 924.0000, 'ºC'),
	(302469, 144, '2015-01-01 01:14:09.000000', 'temperatura', 437.0000, 'ºC'),
	(302470, 144, '2015-01-01 01:14:10.000000', 'temperatura', 615.0000, 'ºC'),
	(302471, 144, '2015-01-01 01:14:11.000000', 'temperatura', 565.0000, 'ºC'),
	(302472, 144, '2015-01-01 01:14:12.000000', 'temperatura', 981.0000, 'ºC'),
	(302473, 144, '2015-01-01 01:14:13.000000', 'temperatura', 811.0000, 'ºC'),
	(302474, 144, '2015-01-01 01:14:14.000000', 'temperatura', 1110.0000, 'ºC'),
	(302475, 144, '2015-01-01 01:14:15.000000', 'temperatura', 718.0000, 'ºC'),
	(302476, 144, '2015-01-01 01:14:16.000000', 'temperatura', 260.0000, 'ºC'),
	(302477, 144, '2015-01-01 01:14:17.000000', 'temperatura', 347.0000, 'ºC'),
	(302478, 144, '2015-01-01 01:14:18.000000', 'temperatura', 955.0000, 'ºC'),
	(302479, 144, '2015-01-01 01:14:19.000000', 'temperatura', 137.0000, 'ºC'),
	(302480, 144, '2015-01-01 01:14:20.000000', 'temperatura', 219.0000, 'ºC'),
	(302481, 144, '2015-01-01 01:14:21.000000', 'temperatura', 684.0000, 'ºC'),
	(302482, 144, '2015-01-01 01:14:22.000000', 'temperatura', 362.0000, 'ºC'),
	(302483, 144, '2015-01-01 01:14:23.000000', 'temperatura', 961.0000, 'ºC'),
	(302484, 144, '2015-01-01 01:14:24.000000', 'temperatura', 119.0000, 'ºC'),
	(302485, 144, '2015-01-01 01:14:25.000000', 'temperatura', 112.0000, 'ºC'),
	(302486, 144, '2015-01-01 01:14:26.000000', 'temperatura', 204.0000, 'ºC'),
	(302487, 144, '2015-01-01 01:14:27.000000', 'temperatura', 683.0000, 'ºC'),
	(302488, 144, '2015-01-01 01:14:28.000000', 'temperatura', 406.0000, 'ºC'),
	(302489, 144, '2015-01-01 01:14:29.000000', 'temperatura', 1182.0000, 'ºC'),
	(302490, 144, '2015-01-01 01:14:30.000000', 'temperatura', 1093.0000, 'ºC'),
	(302491, 144, '2015-01-01 01:14:31.000000', 'temperatura', 717.0000, 'ºC'),
	(302492, 144, '2015-01-01 01:14:32.000000', 'temperatura', 307.0000, 'ºC'),
	(302493, 144, '2015-01-01 01:14:33.000000', 'temperatura', 585.0000, 'ºC'),
	(302494, 144, '2015-01-01 01:14:34.000000', 'temperatura', 806.0000, 'ºC'),
	(302495, 144, '2015-01-01 01:14:35.000000', 'temperatura', 1076.0000, 'ºC'),
	(302496, 144, '2015-01-01 01:14:36.000000', 'temperatura', 563.0000, 'ºC'),
	(302497, 144, '2015-01-01 01:14:37.000000', 'temperatura', 785.0000, 'ºC'),
	(302498, 144, '2015-01-01 01:14:38.000000', 'temperatura', 1039.0000, 'ºC'),
	(302499, 144, '2015-01-01 01:14:39.000000', 'temperatura', 438.0000, 'ºC'),
	(302500, 144, '2015-01-01 01:14:40.000000', 'temperatura', 275.0000, 'ºC'),
	(302501, 144, '2015-01-01 01:14:41.000000', 'temperatura', 60.0000, 'ºC'),
	(302502, 144, '2015-01-01 01:14:42.000000', 'temperatura', 675.0000, 'ºC'),
	(302503, 144, '2015-01-01 01:14:43.000000', 'temperatura', 796.0000, 'ºC'),
	(302504, 144, '2015-01-01 01:14:44.000000', 'temperatura', 757.0000, 'ºC'),
	(302505, 144, '2015-01-01 01:14:45.000000', 'temperatura', 198.0000, 'ºC'),
	(302506, 144, '2015-01-01 01:14:46.000000', 'temperatura', 1117.0000, 'ºC'),
	(302507, 144, '2015-01-01 01:14:47.000000', 'temperatura', 192.0000, 'ºC'),
	(302508, 144, '2015-01-01 01:14:48.000000', 'temperatura', 12.0000, 'ºC'),
	(302509, 144, '2015-01-01 01:14:49.000000', 'temperatura', 681.0000, 'ºC'),
	(302510, 144, '2015-01-01 01:14:50.000000', 'temperatura', 973.0000, 'ºC'),
	(302511, 144, '2015-01-01 01:14:51.000000', 'temperatura', 420.0000, 'ºC'),
	(302512, 144, '2015-01-01 01:14:52.000000', 'temperatura', 383.0000, 'ºC'),
	(302513, 144, '2015-01-01 01:14:53.000000', 'temperatura', 654.0000, 'ºC'),
	(302514, 144, '2015-01-01 01:14:54.000000', 'temperatura', 920.0000, 'ºC'),
	(302515, 144, '2015-01-01 01:14:55.000000', 'temperatura', 242.0000, 'ºC'),
	(302516, 144, '2015-01-01 01:14:56.000000', 'temperatura', 847.0000, 'ºC'),
	(302517, 144, '2015-01-01 01:14:57.000000', 'temperatura', 1111.0000, 'ºC'),
	(302518, 144, '2015-01-01 01:14:58.000000', 'temperatura', 614.0000, 'ºC'),
	(302519, 144, '2015-01-01 01:14:59.000000', 'temperatura', 938.0000, 'ºC'),
	(302520, 144, '2015-01-01 01:15:00.000000', 'temperatura', 449.0000, 'ºC'),
	(302521, 144, '2015-01-01 01:15:01.000000', 'temperatura', 633.0000, 'ºC'),
	(302522, 144, '2015-01-01 01:15:02.000000', 'temperatura', 616.0000, 'ºC'),
	(302523, 144, '2015-01-01 01:15:03.000000', 'temperatura', 1182.0000, 'ºC'),
	(302524, 144, '2015-01-01 01:15:04.000000', 'temperatura', 461.0000, 'ºC'),
	(302525, 144, '2015-01-01 01:15:05.000000', 'temperatura', 1160.0000, 'ºC'),
	(302526, 144, '2015-01-01 01:15:06.000000', 'temperatura', 816.0000, 'ºC'),
	(302527, 144, '2015-01-01 01:15:07.000000', 'temperatura', 604.0000, 'ºC'),
	(302528, 144, '2015-01-01 01:15:08.000000', 'temperatura', 571.0000, 'ºC'),
	(302529, 144, '2015-01-01 01:15:09.000000', 'temperatura', 1044.0000, 'ºC'),
	(302530, 144, '2015-01-01 01:15:10.000000', 'temperatura', 1107.0000, 'ºC'),
	(302531, 144, '2015-01-01 01:15:11.000000', 'temperatura', 4.0000, 'ºC'),
	(302532, 144, '2015-01-01 01:15:12.000000', 'temperatura', 300.0000, 'ºC'),
	(302533, 144, '2015-01-01 01:15:13.000000', 'temperatura', 288.0000, 'ºC'),
	(302534, 144, '2015-01-01 01:15:14.000000', 'temperatura', 539.0000, 'ºC'),
	(302535, 144, '2015-01-01 01:15:15.000000', 'temperatura', 633.0000, 'ºC'),
	(302536, 144, '2015-01-01 01:15:16.000000', 'temperatura', 347.0000, 'ºC'),
	(302537, 144, '2015-01-01 01:15:17.000000', 'temperatura', 1037.0000, 'ºC'),
	(302538, 144, '2015-01-01 01:15:18.000000', 'temperatura', 544.0000, 'ºC'),
	(302539, 144, '2015-01-01 01:15:19.000000', 'temperatura', 811.0000, 'ºC'),
	(302540, 144, '2015-01-01 01:15:20.000000', 'temperatura', 22.0000, 'ºC'),
	(302541, 144, '2015-01-01 01:15:21.000000', 'temperatura', 78.0000, 'ºC'),
	(302542, 144, '2015-01-01 01:15:22.000000', 'temperatura', 323.0000, 'ºC'),
	(302543, 144, '2015-01-01 01:15:23.000000', 'temperatura', 181.0000, 'ºC'),
	(302544, 144, '2015-01-01 01:15:24.000000', 'temperatura', 1139.0000, 'ºC'),
	(302545, 144, '2015-01-01 01:15:25.000000', 'temperatura', 350.0000, 'ºC'),
	(302546, 144, '2015-01-01 01:15:26.000000', 'temperatura', 735.0000, 'ºC'),
	(302547, 144, '2015-01-01 01:15:27.000000', 'temperatura', 223.0000, 'ºC'),
	(302548, 144, '2015-01-01 01:15:28.000000', 'temperatura', 113.0000, 'ºC'),
	(302549, 144, '2015-01-01 01:15:29.000000', 'temperatura', 1094.0000, 'ºC'),
	(302550, 144, '2015-01-01 01:15:30.000000', 'temperatura', 333.0000, 'ºC'),
	(302551, 144, '2015-01-01 01:15:31.000000', 'temperatura', 782.0000, 'ºC'),
	(302552, 144, '2015-01-01 01:15:32.000000', 'temperatura', 514.0000, 'ºC'),
	(302553, 144, '2015-01-01 01:15:33.000000', 'temperatura', 224.0000, 'ºC'),
	(302554, 144, '2015-01-01 01:15:34.000000', 'temperatura', 776.0000, 'ºC'),
	(302555, 144, '2015-01-01 01:15:35.000000', 'temperatura', 811.0000, 'ºC'),
	(302556, 144, '2015-01-01 01:15:36.000000', 'temperatura', 527.0000, 'ºC'),
	(302557, 144, '2015-01-01 01:15:37.000000', 'temperatura', 204.0000, 'ºC'),
	(302558, 144, '2015-01-01 01:15:38.000000', 'temperatura', 638.0000, 'ºC'),
	(302559, 144, '2015-01-01 01:15:39.000000', 'temperatura', 178.0000, 'ºC'),
	(302560, 144, '2015-01-01 01:15:40.000000', 'temperatura', 176.0000, 'ºC'),
	(302561, 144, '2015-01-01 01:15:41.000000', 'temperatura', 347.0000, 'ºC'),
	(302562, 144, '2015-01-01 01:15:42.000000', 'temperatura', 6.0000, 'ºC'),
	(302563, 144, '2015-01-01 01:15:43.000000', 'temperatura', 189.0000, 'ºC'),
	(302564, 144, '2015-01-01 01:15:44.000000', 'temperatura', 929.0000, 'ºC'),
	(302565, 144, '2015-01-01 01:15:45.000000', 'temperatura', 479.0000, 'ºC'),
	(302566, 144, '2015-01-01 01:15:46.000000', 'temperatura', 807.0000, 'ºC'),
	(302567, 144, '2015-01-01 01:15:47.000000', 'temperatura', 198.0000, 'ºC'),
	(302568, 144, '2015-01-01 01:15:48.000000', 'temperatura', 969.0000, 'ºC'),
	(302569, 144, '2015-01-01 01:15:49.000000', 'temperatura', 651.0000, 'ºC'),
	(302570, 144, '2015-01-01 01:15:50.000000', 'temperatura', 350.0000, 'ºC'),
	(302571, 144, '2015-01-01 01:15:51.000000', 'temperatura', 997.0000, 'ºC'),
	(302572, 144, '2015-01-01 01:15:52.000000', 'temperatura', 334.0000, 'ºC'),
	(302573, 144, '2015-01-01 01:15:53.000000', 'temperatura', 1080.0000, 'ºC'),
	(302574, 144, '2015-01-01 01:15:54.000000', 'temperatura', 798.0000, 'ºC'),
	(302575, 144, '2015-01-01 01:15:55.000000', 'temperatura', 749.0000, 'ºC'),
	(302576, 144, '2015-01-01 01:15:56.000000', 'temperatura', 153.0000, 'ºC'),
	(302577, 144, '2015-01-01 01:15:57.000000', 'temperatura', 920.0000, 'ºC'),
	(302578, 144, '2015-01-01 01:15:58.000000', 'temperatura', 540.0000, 'ºC'),
	(302579, 144, '2015-01-01 01:15:59.000000', 'temperatura', 1140.0000, 'ºC'),
	(302580, 144, '2015-01-01 01:16:00.000000', 'temperatura', 482.0000, 'ºC'),
	(302581, 144, '2015-01-01 01:16:01.000000', 'temperatura', 189.0000, 'ºC'),
	(302582, 144, '2015-01-01 01:16:02.000000', 'temperatura', 702.0000, 'ºC'),
	(302583, 144, '2015-01-01 01:16:03.000000', 'temperatura', 541.0000, 'ºC'),
	(302584, 144, '2015-01-01 01:16:04.000000', 'temperatura', 600.0000, 'ºC'),
	(302585, 144, '2015-01-01 01:16:05.000000', 'temperatura', 177.0000, 'ºC'),
	(302586, 144, '2015-01-01 01:16:06.000000', 'temperatura', 286.0000, 'ºC'),
	(302587, 144, '2015-01-01 01:16:07.000000', 'temperatura', 899.0000, 'ºC'),
	(302588, 144, '2015-01-01 01:16:08.000000', 'temperatura', 36.0000, 'ºC'),
	(302589, 144, '2015-01-01 01:16:09.000000', 'temperatura', 1085.0000, 'ºC'),
	(302590, 144, '2015-01-01 01:16:10.000000', 'temperatura', 516.0000, 'ºC'),
	(302591, 144, '2015-01-01 01:16:11.000000', 'temperatura', 528.0000, 'ºC'),
	(302592, 144, '2015-01-01 01:16:12.000000', 'temperatura', 1092.0000, 'ºC'),
	(302593, 144, '2015-01-01 01:16:13.000000', 'temperatura', 274.0000, 'ºC'),
	(302594, 144, '2015-01-01 01:16:14.000000', 'temperatura', 497.0000, 'ºC'),
	(302595, 144, '2015-01-01 01:16:15.000000', 'temperatura', 463.0000, 'ºC'),
	(302596, 144, '2015-01-01 01:16:16.000000', 'temperatura', 824.0000, 'ºC'),
	(302597, 144, '2015-01-01 01:16:17.000000', 'temperatura', 330.0000, 'ºC'),
	(302598, 144, '2015-01-01 01:16:18.000000', 'temperatura', 382.0000, 'ºC'),
	(302599, 144, '2015-01-01 01:16:19.000000', 'temperatura', 917.0000, 'ºC'),
	(302600, 144, '2015-01-01 01:16:20.000000', 'temperatura', 1041.0000, 'ºC'),
	(302601, 144, '2015-01-01 01:16:21.000000', 'temperatura', 53.0000, 'ºC'),
	(302602, 144, '2015-01-01 01:16:22.000000', 'temperatura', 745.0000, 'ºC'),
	(302603, 144, '2015-01-01 01:16:23.000000', 'temperatura', 1164.0000, 'ºC'),
	(302604, 144, '2015-01-01 01:16:24.000000', 'temperatura', 1187.0000, 'ºC'),
	(302605, 144, '2015-01-01 01:16:25.000000', 'temperatura', 43.0000, 'ºC'),
	(302606, 144, '2015-01-01 01:16:26.000000', 'temperatura', 254.0000, 'ºC'),
	(302607, 144, '2015-01-01 01:16:27.000000', 'temperatura', 1144.0000, 'ºC'),
	(302608, 144, '2015-01-01 01:16:28.000000', 'temperatura', 156.0000, 'ºC'),
	(302609, 144, '2015-01-01 01:16:29.000000', 'temperatura', 950.0000, 'ºC'),
	(302610, 144, '2015-01-01 01:16:30.000000', 'temperatura', 681.0000, 'ºC'),
	(302611, 144, '2015-01-01 01:16:31.000000', 'temperatura', 556.0000, 'ºC'),
	(302612, 144, '2015-01-01 01:16:32.000000', 'temperatura', 739.0000, 'ºC'),
	(302613, 144, '2015-01-01 01:16:33.000000', 'temperatura', 829.0000, 'ºC'),
	(302614, 144, '2015-01-01 01:16:34.000000', 'temperatura', 725.0000, 'ºC'),
	(302615, 144, '2015-01-01 01:16:35.000000', 'temperatura', 1140.0000, 'ºC'),
	(302616, 144, '2015-01-01 01:16:36.000000', 'temperatura', 1124.0000, 'ºC'),
	(302617, 144, '2015-01-01 01:16:37.000000', 'temperatura', 1001.0000, 'ºC'),
	(302618, 144, '2015-01-01 01:16:38.000000', 'temperatura', 435.0000, 'ºC'),
	(302619, 144, '2015-01-01 01:16:39.000000', 'temperatura', 371.0000, 'ºC'),
	(302620, 144, '2015-01-01 01:16:40.000000', 'temperatura', 550.0000, 'ºC'),
	(302621, 144, '2015-01-01 01:16:41.000000', 'temperatura', 437.0000, 'ºC'),
	(302622, 144, '2015-01-01 01:16:42.000000', 'temperatura', 535.0000, 'ºC'),
	(302623, 144, '2015-01-01 01:16:43.000000', 'temperatura', 164.0000, 'ºC'),
	(302624, 144, '2015-01-01 01:16:44.000000', 'temperatura', 418.0000, 'ºC'),
	(302625, 144, '2015-01-01 01:16:45.000000', 'temperatura', 397.0000, 'ºC'),
	(302626, 144, '2015-01-01 01:16:46.000000', 'temperatura', 733.0000, 'ºC'),
	(302627, 144, '2015-01-01 01:16:47.000000', 'temperatura', 74.0000, 'ºC'),
	(302628, 144, '2015-01-01 01:16:48.000000', 'temperatura', 569.0000, 'ºC'),
	(302629, 144, '2015-01-01 01:16:49.000000', 'temperatura', 227.0000, 'ºC'),
	(302630, 144, '2015-01-01 01:16:50.000000', 'temperatura', 626.0000, 'ºC'),
	(302631, 144, '2015-01-01 01:16:51.000000', 'temperatura', 51.0000, 'ºC'),
	(302632, 144, '2015-01-01 01:16:52.000000', 'temperatura', 779.0000, 'ºC'),
	(302633, 144, '2015-01-01 01:16:53.000000', 'temperatura', 139.0000, 'ºC'),
	(302634, 144, '2015-01-01 01:16:54.000000', 'temperatura', 761.0000, 'ºC'),
	(302635, 144, '2015-01-01 01:16:55.000000', 'temperatura', 990.0000, 'ºC'),
	(302636, 144, '2015-01-01 01:16:56.000000', 'temperatura', 264.0000, 'ºC'),
	(302637, 144, '2015-01-01 01:16:57.000000', 'temperatura', 753.0000, 'ºC'),
	(302638, 144, '2015-01-01 01:16:58.000000', 'temperatura', 575.0000, 'ºC'),
	(302639, 144, '2015-01-01 01:16:59.000000', 'temperatura', 614.0000, 'ºC'),
	(302640, 144, '2015-01-01 01:17:00.000000', 'temperatura', 146.0000, 'ºC'),
	(302641, 144, '2015-01-01 01:17:01.000000', 'temperatura', 91.0000, 'ºC'),
	(302642, 144, '2015-01-01 01:17:02.000000', 'temperatura', 15.0000, 'ºC'),
	(302643, 144, '2015-01-01 01:17:03.000000', 'temperatura', 1001.0000, 'ºC'),
	(302644, 144, '2015-01-01 01:17:04.000000', 'temperatura', 162.0000, 'ºC'),
	(302645, 144, '2015-01-01 01:17:05.000000', 'temperatura', 208.0000, 'ºC'),
	(302646, 144, '2015-01-01 01:17:06.000000', 'temperatura', 555.0000, 'ºC'),
	(302647, 144, '2015-01-01 01:17:07.000000', 'temperatura', 951.0000, 'ºC'),
	(302648, 144, '2015-01-01 01:17:08.000000', 'temperatura', 691.0000, 'ºC'),
	(302649, 144, '2015-01-01 01:17:09.000000', 'temperatura', 603.0000, 'ºC'),
	(302650, 144, '2015-01-01 01:17:10.000000', 'temperatura', 942.0000, 'ºC'),
	(302651, 144, '2015-01-01 01:17:11.000000', 'temperatura', 502.0000, 'ºC'),
	(302652, 144, '2015-01-01 01:17:12.000000', 'temperatura', 883.0000, 'ºC'),
	(302653, 144, '2015-01-01 01:17:13.000000', 'temperatura', 508.0000, 'ºC'),
	(302654, 144, '2015-01-01 01:17:14.000000', 'temperatura', 1095.0000, 'ºC'),
	(302655, 144, '2015-01-01 01:17:15.000000', 'temperatura', 350.0000, 'ºC'),
	(302656, 144, '2015-01-01 01:17:16.000000', 'temperatura', 866.0000, 'ºC'),
	(302657, 144, '2015-01-01 01:17:17.000000', 'temperatura', 881.0000, 'ºC'),
	(302658, 144, '2015-01-01 01:17:18.000000', 'temperatura', 606.0000, 'ºC'),
	(302659, 144, '2015-01-01 01:17:19.000000', 'temperatura', 390.0000, 'ºC'),
	(302660, 144, '2015-01-01 01:17:20.000000', 'temperatura', 130.0000, 'ºC'),
	(302661, 144, '2015-01-01 01:17:21.000000', 'temperatura', 683.0000, 'ºC'),
	(302662, 144, '2015-01-01 01:17:22.000000', 'temperatura', 625.0000, 'ºC'),
	(302663, 144, '2015-01-01 01:17:23.000000', 'temperatura', 1075.0000, 'ºC'),
	(302664, 144, '2015-01-01 01:17:24.000000', 'temperatura', 1099.0000, 'ºC'),
	(302665, 144, '2015-01-01 01:17:25.000000', 'temperatura', 1073.0000, 'ºC'),
	(302666, 144, '2015-01-01 01:17:26.000000', 'temperatura', 869.0000, 'ºC'),
	(302667, 144, '2015-01-01 01:17:27.000000', 'temperatura', 1126.0000, 'ºC'),
	(302668, 144, '2015-01-01 01:17:28.000000', 'temperatura', 622.0000, 'ºC'),
	(302669, 144, '2015-01-01 01:17:29.000000', 'temperatura', 933.0000, 'ºC'),
	(302670, 144, '2015-01-01 01:17:30.000000', 'temperatura', 398.0000, 'ºC'),
	(302671, 144, '2015-01-01 01:17:31.000000', 'temperatura', 393.0000, 'ºC'),
	(302672, 144, '2015-01-01 01:17:32.000000', 'temperatura', 772.0000, 'ºC'),
	(302673, 144, '2015-01-01 01:17:33.000000', 'temperatura', 283.0000, 'ºC'),
	(302674, 144, '2015-01-01 01:17:34.000000', 'temperatura', 296.0000, 'ºC'),
	(302675, 144, '2015-01-01 01:17:35.000000', 'temperatura', 633.0000, 'ºC'),
	(302676, 144, '2015-01-01 01:17:36.000000', 'temperatura', 1079.0000, 'ºC'),
	(302677, 144, '2015-01-01 01:17:37.000000', 'temperatura', 1096.0000, 'ºC'),
	(302678, 144, '2015-01-01 01:17:38.000000', 'temperatura', 1043.0000, 'ºC'),
	(302679, 144, '2015-01-01 01:17:39.000000', 'temperatura', 727.0000, 'ºC'),
	(302680, 144, '2015-01-01 01:17:40.000000', 'temperatura', 505.0000, 'ºC'),
	(302681, 144, '2015-01-01 01:17:41.000000', 'temperatura', 348.0000, 'ºC'),
	(302682, 144, '2015-01-01 01:17:42.000000', 'temperatura', 223.0000, 'ºC'),
	(302683, 144, '2015-01-01 01:17:43.000000', 'temperatura', 72.0000, 'ºC'),
	(302684, 144, '2015-01-01 01:17:44.000000', 'temperatura', 892.0000, 'ºC'),
	(302685, 144, '2015-01-01 01:17:45.000000', 'temperatura', 644.0000, 'ºC'),
	(302686, 144, '2015-01-01 01:17:46.000000', 'temperatura', 543.0000, 'ºC'),
	(302687, 144, '2015-01-01 01:17:47.000000', 'temperatura', 784.0000, 'ºC'),
	(302688, 144, '2015-01-01 01:17:48.000000', 'temperatura', 1093.0000, 'ºC'),
	(302689, 144, '2015-01-01 01:17:49.000000', 'temperatura', 713.0000, 'ºC'),
	(302690, 144, '2015-01-01 01:17:50.000000', 'temperatura', 286.0000, 'ºC'),
	(302691, 145, '2015-01-01 00:00:00.000000', 'temperatura', 392.0000, 'ºC'),
	(302692, 145, '2015-01-01 00:00:01.000000', 'temperatura', 493.0000, 'ºC'),
	(302693, 145, '2015-01-01 00:00:02.000000', 'temperatura', 89.0000, 'ºC'),
	(302694, 145, '2015-01-01 00:00:03.000000', 'temperatura', 164.0000, 'ºC'),
	(302695, 145, '2015-01-01 00:00:04.000000', 'temperatura', 556.0000, 'ºC'),
	(302696, 145, '2015-01-01 00:00:05.000000', 'temperatura', 1087.0000, 'ºC'),
	(302697, 145, '2015-01-01 00:00:06.000000', 'temperatura', 168.0000, 'ºC'),
	(302698, 145, '2015-01-01 00:00:07.000000', 'temperatura', 1179.0000, 'ºC'),
	(302699, 145, '2015-01-01 00:00:08.000000', 'temperatura', 591.0000, 'ºC'),
	(302700, 145, '2015-01-01 00:00:09.000000', 'temperatura', 619.0000, 'ºC'),
	(302701, 145, '2015-01-01 00:00:10.000000', 'temperatura', 124.0000, 'ºC'),
	(302702, 145, '2015-01-01 00:00:11.000000', 'temperatura', 1164.0000, 'ºC'),
	(302703, 145, '2015-01-01 00:00:12.000000', 'temperatura', 647.0000, 'ºC'),
	(302704, 145, '2015-01-01 00:00:13.000000', 'temperatura', 945.0000, 'ºC'),
	(302705, 145, '2015-01-01 00:00:14.000000', 'temperatura', 382.0000, 'ºC'),
	(302706, 145, '2015-01-01 00:00:15.000000', 'temperatura', 275.0000, 'ºC'),
	(302707, 145, '2015-01-01 00:00:16.000000', 'temperatura', 233.0000, 'ºC'),
	(302708, 145, '2015-01-01 00:00:17.000000', 'temperatura', 338.0000, 'ºC'),
	(302709, 145, '2015-01-01 00:00:18.000000', 'temperatura', 992.0000, 'ºC'),
	(302710, 145, '2015-01-01 00:00:19.000000', 'temperatura', 346.0000, 'ºC'),
	(302711, 145, '2015-01-01 00:00:20.000000', 'temperatura', 1154.0000, 'ºC'),
	(302712, 145, '2015-01-01 00:00:21.000000', 'temperatura', 1133.0000, 'ºC'),
	(302713, 145, '2015-01-01 00:00:22.000000', 'temperatura', 1004.0000, 'ºC'),
	(302714, 145, '2015-01-01 00:00:23.000000', 'temperatura', 423.0000, 'ºC'),
	(302715, 145, '2015-01-01 00:00:24.000000', 'temperatura', 303.0000, 'ºC'),
	(302716, 145, '2015-01-01 00:00:25.000000', 'temperatura', 245.0000, 'ºC'),
	(302717, 145, '2015-01-01 00:00:26.000000', 'temperatura', 316.0000, 'ºC'),
	(302718, 145, '2015-01-01 00:00:27.000000', 'temperatura', 845.0000, 'ºC'),
	(302719, 145, '2015-01-01 00:00:28.000000', 'temperatura', 879.0000, 'ºC'),
	(302720, 145, '2015-01-01 00:00:29.000000', 'temperatura', 659.0000, 'ºC'),
	(302721, 145, '2015-01-01 00:00:30.000000', 'temperatura', 659.0000, 'ºC'),
	(302722, 145, '2015-01-01 00:00:31.000000', 'temperatura', 121.0000, 'ºC'),
	(302723, 145, '2015-01-01 00:00:32.000000', 'temperatura', 1026.0000, 'ºC'),
	(302724, 145, '2015-01-01 00:00:33.000000', 'temperatura', 1167.0000, 'ºC'),
	(302725, 145, '2015-01-01 00:00:34.000000', 'temperatura', 357.0000, 'ºC'),
	(302726, 145, '2015-01-01 00:00:35.000000', 'temperatura', 686.0000, 'ºC'),
	(302727, 145, '2015-01-01 00:00:36.000000', 'temperatura', 1161.0000, 'ºC'),
	(302728, 145, '2015-01-01 00:00:37.000000', 'temperatura', 146.0000, 'ºC'),
	(302729, 145, '2015-01-01 00:00:38.000000', 'temperatura', 849.0000, 'ºC'),
	(302730, 145, '2015-01-01 00:00:39.000000', 'temperatura', 206.0000, 'ºC'),
	(302731, 145, '2015-01-01 00:00:40.000000', 'temperatura', 882.0000, 'ºC'),
	(302732, 145, '2015-01-01 00:00:41.000000', 'temperatura', 195.0000, 'ºC'),
	(302733, 145, '2015-01-01 00:00:42.000000', 'temperatura', 729.0000, 'ºC'),
	(302734, 145, '2015-01-01 00:00:43.000000', 'temperatura', 659.0000, 'ºC'),
	(302735, 145, '2015-01-01 00:00:44.000000', 'temperatura', 1111.0000, 'ºC'),
	(302736, 145, '2015-01-01 00:00:45.000000', 'temperatura', 1178.0000, 'ºC'),
	(302737, 145, '2015-01-01 00:00:46.000000', 'temperatura', 156.0000, 'ºC'),
	(302738, 145, '2015-01-01 00:00:47.000000', 'temperatura', 846.0000, 'ºC'),
	(302739, 145, '2015-01-01 00:00:48.000000', 'temperatura', 164.0000, 'ºC'),
	(302740, 145, '2015-01-01 00:00:49.000000', 'temperatura', 680.0000, 'ºC'),
	(302741, 145, '2015-01-01 00:00:50.000000', 'temperatura', 512.0000, 'ºC'),
	(302742, 145, '2015-01-01 00:00:51.000000', 'temperatura', 517.0000, 'ºC'),
	(302743, 145, '2015-01-01 00:00:52.000000', 'temperatura', 1051.0000, 'ºC'),
	(302744, 145, '2015-01-01 00:00:53.000000', 'temperatura', 106.0000, 'ºC'),
	(302745, 145, '2015-01-01 00:00:54.000000', 'temperatura', 978.0000, 'ºC'),
	(302746, 145, '2015-01-01 00:00:55.000000', 'temperatura', 970.0000, 'ºC'),
	(302747, 145, '2015-01-01 00:00:56.000000', 'temperatura', 718.0000, 'ºC'),
	(302748, 145, '2015-01-01 00:00:57.000000', 'temperatura', 681.0000, 'ºC'),
	(302749, 145, '2015-01-01 00:00:58.000000', 'temperatura', 51.0000, 'ºC'),
	(302750, 145, '2015-01-01 00:00:59.000000', 'temperatura', 612.0000, 'ºC'),
	(302751, 145, '2015-01-01 00:01:00.000000', 'temperatura', 506.0000, 'ºC'),
	(302752, 145, '2015-01-01 00:01:01.000000', 'temperatura', 697.0000, 'ºC'),
	(302753, 145, '2015-01-01 00:01:02.000000', 'temperatura', 768.0000, 'ºC'),
	(302754, 145, '2015-01-01 00:01:03.000000', 'temperatura', 548.0000, 'ºC'),
	(302755, 145, '2015-01-01 00:01:04.000000', 'temperatura', 438.0000, 'ºC'),
	(302756, 145, '2015-01-01 00:01:05.000000', 'temperatura', 545.0000, 'ºC'),
	(302757, 145, '2015-01-01 00:01:06.000000', 'temperatura', 212.0000, 'ºC'),
	(302758, 145, '2015-01-01 00:01:07.000000', 'temperatura', 625.0000, 'ºC'),
	(302759, 145, '2015-01-01 00:01:08.000000', 'temperatura', 92.0000, 'ºC'),
	(302760, 145, '2015-01-01 00:01:09.000000', 'temperatura', 983.0000, 'ºC'),
	(302761, 145, '2015-01-01 00:01:10.000000', 'temperatura', 1039.0000, 'ºC'),
	(302762, 145, '2015-01-01 00:01:11.000000', 'temperatura', 1049.0000, 'ºC'),
	(302763, 145, '2015-01-01 00:01:12.000000', 'temperatura', 929.0000, 'ºC'),
	(302764, 145, '2015-01-01 00:01:13.000000', 'temperatura', 298.0000, 'ºC'),
	(302765, 145, '2015-01-01 00:01:14.000000', 'temperatura', 1105.0000, 'ºC'),
	(302766, 145, '2015-01-01 00:01:15.000000', 'temperatura', 1029.0000, 'ºC'),
	(302767, 145, '2015-01-01 00:01:16.000000', 'temperatura', 631.0000, 'ºC'),
	(302768, 145, '2015-01-01 00:01:17.000000', 'temperatura', 70.0000, 'ºC'),
	(302769, 145, '2015-01-01 00:01:18.000000', 'temperatura', 856.0000, 'ºC'),
	(302770, 145, '2015-01-01 00:01:19.000000', 'temperatura', 470.0000, 'ºC'),
	(302771, 145, '2015-01-01 00:01:20.000000', 'temperatura', 983.0000, 'ºC'),
	(302772, 145, '2015-01-01 00:01:21.000000', 'temperatura', 1106.0000, 'ºC'),
	(302773, 145, '2015-01-01 00:01:22.000000', 'temperatura', 182.0000, 'ºC'),
	(302774, 145, '2015-01-01 00:01:23.000000', 'temperatura', 1193.0000, 'ºC'),
	(302775, 145, '2015-01-01 00:01:24.000000', 'temperatura', 618.0000, 'ºC'),
	(302776, 145, '2015-01-01 00:01:25.000000', 'temperatura', 710.0000, 'ºC'),
	(302777, 145, '2015-01-01 00:01:26.000000', 'temperatura', 498.0000, 'ºC'),
	(302778, 145, '2015-01-01 00:01:27.000000', 'temperatura', 359.0000, 'ºC'),
	(302779, 145, '2015-01-01 00:01:28.000000', 'temperatura', 302.0000, 'ºC'),
	(302780, 145, '2015-01-01 00:01:29.000000', 'temperatura', 432.0000, 'ºC'),
	(302781, 145, '2015-01-01 00:01:30.000000', 'temperatura', 55.0000, 'ºC'),
	(302782, 145, '2015-01-01 00:01:31.000000', 'temperatura', 179.0000, 'ºC'),
	(302783, 145, '2015-01-01 00:01:32.000000', 'temperatura', 733.0000, 'ºC'),
	(302784, 145, '2015-01-01 00:01:33.000000', 'temperatura', 725.0000, 'ºC'),
	(302785, 145, '2015-01-01 00:01:34.000000', 'temperatura', 229.0000, 'ºC'),
	(302786, 145, '2015-01-01 00:01:35.000000', 'temperatura', 171.0000, 'ºC'),
	(302787, 145, '2015-01-01 00:01:36.000000', 'temperatura', 169.0000, 'ºC'),
	(302788, 145, '2015-01-01 00:01:37.000000', 'temperatura', 331.0000, 'ºC'),
	(302789, 145, '2015-01-01 00:01:38.000000', 'temperatura', 1151.0000, 'ºC'),
	(302790, 145, '2015-01-01 00:01:39.000000', 'temperatura', 1160.0000, 'ºC'),
	(302791, 145, '2015-01-01 00:01:40.000000', 'temperatura', 1147.0000, 'ºC'),
	(302792, 145, '2015-01-01 00:01:41.000000', 'temperatura', 1058.0000, 'ºC'),
	(302793, 145, '2015-01-01 00:01:42.000000', 'temperatura', 649.0000, 'ºC'),
	(302794, 145, '2015-01-01 00:01:43.000000', 'temperatura', 72.0000, 'ºC'),
	(302795, 145, '2015-01-01 00:01:44.000000', 'temperatura', 812.0000, 'ºC'),
	(302796, 145, '2015-01-01 00:01:45.000000', 'temperatura', 247.0000, 'ºC'),
	(302797, 145, '2015-01-01 00:01:46.000000', 'temperatura', 1198.0000, 'ºC'),
	(302798, 145, '2015-01-01 00:01:47.000000', 'temperatura', 449.0000, 'ºC'),
	(302799, 145, '2015-01-01 00:01:48.000000', 'temperatura', 1051.0000, 'ºC'),
	(302800, 145, '2015-01-01 00:01:49.000000', 'temperatura', 311.0000, 'ºC'),
	(302801, 145, '2015-01-01 00:01:50.000000', 'temperatura', 800.0000, 'ºC'),
	(302802, 145, '2015-01-01 00:01:51.000000', 'temperatura', 669.0000, 'ºC'),
	(302803, 145, '2015-01-01 00:01:52.000000', 'temperatura', 945.0000, 'ºC'),
	(302804, 145, '2015-01-01 00:01:53.000000', 'temperatura', 319.0000, 'ºC'),
	(302805, 145, '2015-01-01 00:01:54.000000', 'temperatura', 1162.0000, 'ºC'),
	(302806, 145, '2015-01-01 00:01:55.000000', 'temperatura', 53.0000, 'ºC'),
	(302807, 145, '2015-01-01 00:01:56.000000', 'temperatura', 379.0000, 'ºC'),
	(302808, 145, '2015-01-01 00:01:57.000000', 'temperatura', 538.0000, 'ºC'),
	(302809, 145, '2015-01-01 00:01:58.000000', 'temperatura', 353.0000, 'ºC'),
	(302810, 145, '2015-01-01 00:01:59.000000', 'temperatura', 152.0000, 'ºC'),
	(302811, 145, '2015-01-01 00:02:00.000000', 'temperatura', 902.0000, 'ºC'),
	(302812, 145, '2015-01-01 00:02:01.000000', 'temperatura', 456.0000, 'ºC'),
	(302813, 145, '2015-01-01 00:02:02.000000', 'temperatura', 772.0000, 'ºC'),
	(302814, 145, '2015-01-01 00:02:03.000000', 'temperatura', 95.0000, 'ºC'),
	(302815, 145, '2015-01-01 00:02:04.000000', 'temperatura', 556.0000, 'ºC'),
	(302816, 145, '2015-01-01 00:02:05.000000', 'temperatura', 98.0000, 'ºC'),
	(302817, 145, '2015-01-01 00:02:06.000000', 'temperatura', 21.0000, 'ºC'),
	(302818, 145, '2015-01-01 00:02:07.000000', 'temperatura', 1012.0000, 'ºC'),
	(302819, 145, '2015-01-01 00:02:08.000000', 'temperatura', 196.0000, 'ºC'),
	(302820, 145, '2015-01-01 00:02:09.000000', 'temperatura', 345.0000, 'ºC'),
	(302821, 145, '2015-01-01 00:02:10.000000', 'temperatura', 1137.0000, 'ºC'),
	(302822, 145, '2015-01-01 00:02:11.000000', 'temperatura', 1052.0000, 'ºC'),
	(302823, 145, '2015-01-01 00:02:12.000000', 'temperatura', 647.0000, 'ºC'),
	(302824, 145, '2015-01-01 00:02:13.000000', 'temperatura', 82.0000, 'ºC'),
	(302825, 145, '2015-01-01 00:02:14.000000', 'temperatura', 870.0000, 'ºC'),
	(302826, 145, '2015-01-01 00:02:15.000000', 'temperatura', 502.0000, 'ºC'),
	(302827, 145, '2015-01-01 00:02:16.000000', 'temperatura', 1100.0000, 'ºC'),
	(302828, 145, '2015-01-01 00:02:17.000000', 'temperatura', 394.0000, 'ºC'),
	(302829, 145, '2015-01-01 00:02:18.000000', 'temperatura', 1073.0000, 'ºC'),
	(302830, 145, '2015-01-01 00:02:19.000000', 'temperatura', 583.0000, 'ºC'),
	(302831, 145, '2015-01-01 00:02:20.000000', 'temperatura', 898.0000, 'ºC'),
	(302832, 145, '2015-01-01 00:02:21.000000', 'temperatura', 339.0000, 'ºC'),
	(302833, 145, '2015-01-01 00:02:22.000000', 'temperatura', 204.0000, 'ºC'),
	(302834, 145, '2015-01-01 00:02:23.000000', 'temperatura', 3.0000, 'ºC'),
	(302835, 145, '2015-01-01 00:02:24.000000', 'temperatura', 603.0000, 'ºC'),
	(302836, 145, '2015-01-01 00:02:25.000000', 'temperatura', 608.0000, 'ºC'),
	(302837, 145, '2015-01-01 00:02:26.000000', 'temperatura', 30.0000, 'ºC'),
	(302838, 145, '2015-01-01 00:02:27.000000', 'temperatura', 725.0000, 'ºC'),
	(302839, 145, '2015-01-01 00:02:28.000000', 'temperatura', 1137.0000, 'ºC'),
	(302840, 145, '2015-01-01 00:02:29.000000', 'temperatura', 1112.0000, 'ºC'),
	(302841, 145, '2015-01-01 00:02:30.000000', 'temperatura', 947.0000, 'ºC'),
	(302842, 145, '2015-01-01 00:02:31.000000', 'temperatura', 202.0000, 'ºC'),
	(302843, 145, '2015-01-01 00:02:32.000000', 'temperatura', 570.0000, 'ºC'),
	(302844, 145, '2015-01-01 00:02:33.000000', 'temperatura', 1042.0000, 'ºC'),
	(302845, 145, '2015-01-01 00:02:34.000000', 'temperatura', 1102.0000, 'ºC'),
	(302846, 145, '2015-01-01 00:02:35.000000', 'temperatura', 1186.0000, 'ºC'),
	(302847, 145, '2015-01-01 00:02:36.000000', 'temperatura', 222.0000, 'ºC'),
	(302848, 145, '2015-01-01 00:02:37.000000', 'temperatura', 1155.0000, 'ºC'),
	(302849, 145, '2015-01-01 00:02:38.000000', 'temperatura', 308.0000, 'ºC'),
	(302850, 145, '2015-01-01 00:02:39.000000', 'temperatura', 474.0000, 'ºC'),
	(302851, 145, '2015-01-01 00:02:40.000000', 'temperatura', 248.0000, 'ºC'),
	(302852, 145, '2015-01-01 00:02:41.000000', 'temperatura', 1019.0000, 'ºC'),
	(302853, 145, '2015-01-01 00:02:42.000000', 'temperatura', 751.0000, 'ºC'),
	(302854, 145, '2015-01-01 00:02:43.000000', 'temperatura', 698.0000, 'ºC'),
	(302855, 145, '2015-01-01 00:02:44.000000', 'temperatura', 38.0000, 'ºC'),
	(302856, 145, '2015-01-01 00:02:45.000000', 'temperatura', 497.0000, 'ºC'),
	(302857, 145, '2015-01-01 00:02:46.000000', 'temperatura', 1171.0000, 'ºC'),
	(302858, 145, '2015-01-01 00:02:47.000000', 'temperatura', 765.0000, 'ºC'),
	(302859, 145, '2015-01-01 00:02:48.000000', 'temperatura', 314.0000, 'ºC'),
	(302860, 145, '2015-01-01 00:02:49.000000', 'temperatura', 474.0000, 'ºC'),
	(302861, 145, '2015-01-01 00:02:50.000000', 'temperatura', 230.0000, 'ºC'),
	(302862, 145, '2015-01-01 00:02:51.000000', 'temperatura', 927.0000, 'ºC'),
	(302863, 145, '2015-01-01 00:02:52.000000', 'temperatura', 346.0000, 'ºC'),
	(302864, 145, '2015-01-01 00:02:53.000000', 'temperatura', 149.0000, 'ºC'),
	(302865, 145, '2015-01-01 00:02:54.000000', 'temperatura', 909.0000, 'ºC'),
	(302866, 145, '2015-01-01 00:02:55.000000', 'temperatura', 499.0000, 'ºC'),
	(302867, 145, '2015-01-01 00:02:56.000000', 'temperatura', 969.0000, 'ºC'),
	(302868, 145, '2015-01-01 00:02:57.000000', 'temperatura', 946.0000, 'ºC'),
	(302869, 145, '2015-01-01 00:02:58.000000', 'temperatura', 625.0000, 'ºC'),
	(302870, 145, '2015-01-01 00:02:59.000000', 'temperatura', 289.0000, 'ºC'),
	(302871, 145, '2015-01-01 00:03:00.000000', 'temperatura', 769.0000, 'ºC'),
	(302872, 145, '2015-01-01 00:03:01.000000', 'temperatura', 577.0000, 'ºC'),
	(302873, 145, '2015-01-01 00:03:02.000000', 'temperatura', 578.0000, 'ºC'),
	(302874, 145, '2015-01-01 00:03:03.000000', 'temperatura', 1159.0000, 'ºC'),
	(302875, 145, '2015-01-01 00:03:04.000000', 'temperatura', 463.0000, 'ºC'),
	(302876, 145, '2015-01-01 00:03:05.000000', 'temperatura', 39.0000, 'ºC'),
	(302877, 145, '2015-01-01 00:03:06.000000', 'temperatura', 4.0000, 'ºC'),
	(302878, 145, '2015-01-01 00:03:07.000000', 'temperatura', 1107.0000, 'ºC'),
	(302879, 145, '2015-01-01 00:03:08.000000', 'temperatura', 721.0000, 'ºC'),
	(302880, 145, '2015-01-01 00:03:09.000000', 'temperatura', 286.0000, 'ºC'),
	(302881, 145, '2015-01-01 00:03:10.000000', 'temperatura', 469.0000, 'ºC'),
	(302882, 145, '2015-01-01 00:03:11.000000', 'temperatura', 285.0000, 'ºC'),
	(302883, 145, '2015-01-01 00:03:12.000000', 'temperatura', 17.0000, 'ºC'),
	(302884, 145, '2015-01-01 00:03:13.000000', 'temperatura', 433.0000, 'ºC'),
	(302885, 145, '2015-01-01 00:03:14.000000', 'temperatura', 912.0000, 'ºC'),
	(302886, 145, '2015-01-01 00:03:15.000000', 'temperatura', 862.0000, 'ºC'),
	(302887, 145, '2015-01-01 00:03:16.000000', 'temperatura', 374.0000, 'ºC'),
	(302888, 145, '2015-01-01 00:03:17.000000', 'temperatura', 484.0000, 'ºC'),
	(302889, 145, '2015-01-01 00:03:18.000000', 'temperatura', 99.0000, 'ºC'),
	(302890, 145, '2015-01-01 00:03:19.000000', 'temperatura', 243.0000, 'ºC'),
	(302891, 145, '2015-01-01 00:03:20.000000', 'temperatura', 920.0000, 'ºC'),
	(302892, 145, '2015-01-01 00:03:21.000000', 'temperatura', 269.0000, 'ºC'),
	(302893, 145, '2015-01-01 00:03:22.000000', 'temperatura', 989.0000, 'ºC'),
	(302894, 145, '2015-01-01 00:03:23.000000', 'temperatura', 535.0000, 'ºC'),
	(302895, 145, '2015-01-01 00:03:24.000000', 'temperatura', 909.0000, 'ºC'),
	(302896, 145, '2015-01-01 00:03:25.000000', 'temperatura', 541.0000, 'ºC'),
	(302897, 145, '2015-01-01 00:03:26.000000', 'temperatura', 1180.0000, 'ºC'),
	(302898, 145, '2015-01-01 00:03:27.000000', 'temperatura', 678.0000, 'ºC'),
	(302899, 145, '2015-01-01 00:03:28.000000', 'temperatura', 1048.0000, 'ºC'),
	(302900, 145, '2015-01-01 00:03:29.000000', 'temperatura', 806.0000, 'ºC'),
	(302901, 145, '2015-01-01 00:03:30.000000', 'temperatura', 888.0000, 'ºC'),
	(302902, 145, '2015-01-01 00:03:31.000000', 'temperatura', 821.0000, 'ºC'),
	(302903, 145, '2015-01-01 00:03:32.000000', 'temperatura', 242.0000, 'ºC'),
	(302904, 145, '2015-01-01 00:03:33.000000', 'temperatura', 1149.0000, 'ºC'),
	(302905, 145, '2015-01-01 00:03:34.000000', 'temperatura', 220.0000, 'ºC'),
	(302906, 145, '2015-01-01 00:03:35.000000', 'temperatura', 53.0000, 'ºC'),
	(302907, 145, '2015-01-01 00:03:36.000000', 'temperatura', 806.0000, 'ºC'),
	(302908, 145, '2015-01-01 00:03:37.000000', 'temperatura', 272.0000, 'ºC'),
	(302909, 145, '2015-01-01 00:03:38.000000', 'temperatura', 142.0000, 'ºC'),
	(302910, 145, '2015-01-01 00:03:39.000000', 'temperatura', 1095.0000, 'ºC'),
	(302911, 145, '2015-01-01 00:03:40.000000', 'temperatura', 248.0000, 'ºC'),
	(302912, 145, '2015-01-01 00:03:41.000000', 'temperatura', 357.0000, 'ºC'),
	(302913, 145, '2015-01-01 00:03:42.000000', 'temperatura', 1042.0000, 'ºC'),
	(302914, 145, '2015-01-01 00:03:43.000000', 'temperatura', 539.0000, 'ºC'),
	(302915, 145, '2015-01-01 00:03:44.000000', 'temperatura', 770.0000, 'ºC'),
	(302916, 145, '2015-01-01 00:03:45.000000', 'temperatura', 1035.0000, 'ºC'),
	(302917, 145, '2015-01-01 00:03:46.000000', 'temperatura', 464.0000, 'ºC'),
	(302918, 145, '2015-01-01 00:03:47.000000', 'temperatura', 417.0000, 'ºC'),
	(302919, 145, '2015-01-01 00:03:48.000000', 'temperatura', 693.0000, 'ºC'),
	(302920, 145, '2015-01-01 00:03:49.000000', 'temperatura', 1015.0000, 'ºC'),
	(302921, 145, '2015-01-01 00:03:50.000000', 'temperatura', 597.0000, 'ºC'),
	(302922, 145, '2015-01-01 00:03:51.000000', 'temperatura', 1140.0000, 'ºC'),
	(302923, 145, '2015-01-01 00:03:52.000000', 'temperatura', 311.0000, 'ºC'),
	(302924, 145, '2015-01-01 00:03:53.000000', 'temperatura', 534.0000, 'ºC'),
	(302925, 145, '2015-01-01 00:03:54.000000', 'temperatura', 537.0000, 'ºC'),
	(302926, 145, '2015-01-01 00:03:55.000000', 'temperatura', 1083.0000, 'ºC'),
	(302927, 145, '2015-01-01 00:03:56.000000', 'temperatura', 205.0000, 'ºC'),
	(302928, 145, '2015-01-01 00:03:57.000000', 'temperatura', 177.0000, 'ºC'),
	(302929, 145, '2015-01-01 00:03:58.000000', 'temperatura', 271.0000, 'ºC'),
	(302930, 145, '2015-01-01 00:03:59.000000', 'temperatura', 824.0000, 'ºC'),
	(302931, 145, '2015-01-01 00:04:00.000000', 'temperatura', 908.0000, 'ºC'),
	(302932, 145, '2015-01-01 00:04:01.000000', 'temperatura', 870.0000, 'ºC'),
	(302933, 145, '2015-01-01 00:04:02.000000', 'temperatura', 425.0000, 'ºC'),
	(302934, 145, '2015-01-01 00:04:03.000000', 'temperatura', 715.0000, 'ºC'),
	(302935, 145, '2015-01-01 00:04:04.000000', 'temperatura', 1103.0000, 'ºC'),
	(302936, 145, '2015-01-01 00:04:05.000000', 'temperatura', 967.0000, 'ºC'),
	(302937, 145, '2015-01-01 00:04:06.000000', 'temperatura', 329.0000, 'ºC'),
	(302938, 145, '2015-01-01 00:04:07.000000', 'temperatura', 1144.0000, 'ºC'),
	(302939, 145, '2015-01-01 00:04:08.000000', 'temperatura', 1131.0000, 'ºC'),
	(302940, 145, '2015-01-01 00:04:09.000000', 'temperatura', 1026.0000, 'ºC'),
	(302941, 145, '2015-01-01 00:04:10.000000', 'temperatura', 538.0000, 'ºC'),
	(302942, 145, '2015-01-01 00:04:11.000000', 'temperatura', 814.0000, 'ºC'),
	(302943, 145, '2015-01-01 00:04:12.000000', 'temperatura', 54.0000, 'ºC'),
	(302944, 145, '2015-01-01 00:04:13.000000', 'temperatura', 228.0000, 'ºC'),
	(302945, 145, '2015-01-01 00:04:14.000000', 'temperatura', 978.0000, 'ºC'),
	(302946, 145, '2015-01-01 00:04:15.000000', 'temperatura', 607.0000, 'ºC'),
	(302947, 145, '2015-01-01 00:04:16.000000', 'temperatura', 100.0000, 'ºC'),
	(302948, 145, '2015-01-01 00:04:17.000000', 'temperatura', 1082.0000, 'ºC'),
	(302949, 145, '2015-01-01 00:04:18.000000', 'temperatura', 311.0000, 'ºC'),
	(302950, 145, '2015-01-01 00:04:19.000000', 'temperatura', 709.0000, 'ºC'),
	(302951, 145, '2015-01-01 00:04:20.000000', 'temperatura', 214.0000, 'ºC'),
	(302952, 145, '2015-01-01 00:04:21.000000', 'temperatura', 140.0000, 'ºC'),
	(302953, 145, '2015-01-01 00:04:22.000000', 'temperatura', 62.0000, 'ºC'),
	(302954, 145, '2015-01-01 00:04:23.000000', 'temperatura', 1089.0000, 'ºC'),
	(302955, 145, '2015-01-01 00:04:24.000000', 'temperatura', 460.0000, 'ºC'),
	(302956, 145, '2015-01-01 00:04:25.000000', 'temperatura', 235.0000, 'ºC'),
	(302957, 145, '2015-01-01 00:04:26.000000', 'temperatura', 994.0000, 'ºC'),
	(302958, 145, '2015-01-01 00:04:27.000000', 'temperatura', 665.0000, 'ºC'),
	(302959, 145, '2015-01-01 00:04:28.000000', 'temperatura', 345.0000, 'ºC'),
	(302960, 145, '2015-01-01 00:04:29.000000', 'temperatura', 931.0000, 'ºC'),
	(302961, 145, '2015-01-01 00:04:30.000000', 'temperatura', 20.0000, 'ºC'),
	(302962, 145, '2015-01-01 00:04:31.000000', 'temperatura', 905.0000, 'ºC'),
	(302963, 145, '2015-01-01 00:04:32.000000', 'temperatura', 868.0000, 'ºC'),
	(302964, 145, '2015-01-01 00:04:33.000000', 'temperatura', 425.0000, 'ºC'),
	(302965, 145, '2015-01-01 00:04:34.000000', 'temperatura', 722.0000, 'ºC'),
	(302966, 145, '2015-01-01 00:04:35.000000', 'temperatura', 1133.0000, 'ºC'),
	(302967, 145, '2015-01-01 00:04:36.000000', 'temperatura', 1103.0000, 'ºC'),
	(302968, 145, '2015-01-01 00:04:37.000000', 'temperatura', 915.0000, 'ºC'),
	(302969, 145, '2015-01-01 00:04:38.000000', 'temperatura', 66.0000, 'ºC'),
	(302970, 145, '2015-01-01 00:04:39.000000', 'temperatura', 1185.0000, 'ºC'),
	(302971, 145, '2015-01-01 00:04:40.000000', 'temperatura', 927.0000, 'ºC'),
	(302972, 145, '2015-01-01 00:04:41.000000', 'temperatura', 1081.0000, 'ºC'),
	(302973, 145, '2015-01-01 00:04:42.000000', 'temperatura', 227.0000, 'ºC'),
	(302974, 145, '2015-01-01 00:04:43.000000', 'temperatura', 289.0000, 'ºC'),
	(302975, 145, '2015-01-01 00:04:44.000000', 'temperatura', 766.0000, 'ºC'),
	(302976, 145, '2015-01-01 00:04:45.000000', 'temperatura', 563.0000, 'ºC'),
	(302977, 145, '2015-01-01 00:04:46.000000', 'temperatura', 518.0000, 'ºC'),
	(302978, 145, '2015-01-01 00:04:47.000000', 'temperatura', 899.0000, 'ºC'),
	(302979, 145, '2015-01-01 00:04:48.000000', 'temperatura', 544.0000, 'ºC'),
	(302980, 145, '2015-01-01 00:04:49.000000', 'temperatura', 24.0000, 'ºC'),
	(302981, 145, '2015-01-01 00:04:50.000000', 'temperatura', 886.0000, 'ºC'),
	(302982, 145, '2015-01-01 00:04:51.000000', 'temperatura', 758.0000, 'ºC'),
	(302983, 145, '2015-01-01 00:04:52.000000', 'temperatura', 1135.0000, 'ºC'),
	(302984, 145, '2015-01-01 00:04:53.000000', 'temperatura', 999.0000, 'ºC'),
	(302985, 145, '2015-01-01 00:04:54.000000', 'temperatura', 392.0000, 'ºC'),
	(302986, 145, '2015-01-01 00:04:55.000000', 'temperatura', 163.0000, 'ºC'),
	(302987, 145, '2015-01-01 00:04:56.000000', 'temperatura', 838.0000, 'ºC'),
	(302988, 145, '2015-01-01 00:04:57.000000', 'temperatura', 104.0000, 'ºC'),
	(302989, 145, '2015-01-01 00:04:58.000000', 'temperatura', 403.0000, 'ºC'),
	(302990, 145, '2015-01-01 00:04:59.000000', 'temperatura', 507.0000, 'ºC'),
	(302991, 145, '2015-01-01 00:05:00.000000', 'temperatura', 127.0000, 'ºC'),
	(302992, 145, '2015-01-01 00:05:01.000000', 'temperatura', 314.0000, 'ºC'),
	(302993, 145, '2015-01-01 00:05:02.000000', 'temperatura', 1187.0000, 'ºC'),
	(302994, 145, '2015-01-01 00:05:03.000000', 'temperatura', 197.0000, 'ºC'),
	(302995, 145, '2015-01-01 00:05:04.000000', 'temperatura', 1021.0000, 'ºC'),
	(302996, 145, '2015-01-01 00:05:05.000000', 'temperatura', 917.0000, 'ºC'),
	(302997, 145, '2015-01-01 00:05:06.000000', 'temperatura', 323.0000, 'ºC'),
	(302998, 145, '2015-01-01 00:05:07.000000', 'temperatura', 66.0000, 'ºC'),
	(302999, 145, '2015-01-01 00:05:08.000000', 'temperatura', 558.0000, 'ºC'),
	(303000, 145, '2015-01-01 00:05:09.000000', 'temperatura', 194.0000, 'ºC'),
	(303001, 145, '2015-01-01 00:05:10.000000', 'temperatura', 497.0000, 'ºC'),
	(303002, 145, '2015-01-01 00:05:11.000000', 'temperatura', 703.0000, 'ºC'),
	(303003, 145, '2015-01-01 00:05:12.000000', 'temperatura', 823.0000, 'ºC'),
	(303004, 145, '2015-01-01 00:05:13.000000', 'temperatura', 807.0000, 'ºC'),
	(303005, 145, '2015-01-01 00:05:14.000000', 'temperatura', 365.0000, 'ºC'),
	(303006, 145, '2015-01-01 00:05:15.000000', 'temperatura', 605.0000, 'ºC'),
	(303007, 145, '2015-01-01 00:05:16.000000', 'temperatura', 733.0000, 'ºC'),
	(303008, 145, '2015-01-01 00:05:17.000000', 'temperatura', 647.0000, 'ºC'),
	(303009, 145, '2015-01-01 00:05:18.000000', 'temperatura', 1039.0000, 'ºC'),
	(303010, 145, '2015-01-01 00:05:19.000000', 'temperatura', 855.0000, 'ºC'),
	(303011, 145, '2015-01-01 00:05:20.000000', 'temperatura', 1158.0000, 'ºC'),
	(303012, 145, '2015-01-01 00:05:21.000000', 'temperatura', 825.0000, 'ºC'),
	(303013, 145, '2015-01-01 00:05:22.000000', 'temperatura', 653.0000, 'ºC'),
	(303014, 145, '2015-01-01 00:05:23.000000', 'temperatura', 791.0000, 'ºC'),
	(303015, 145, '2015-01-01 00:05:24.000000', 'temperatura', 796.0000, 'ºC'),
	(303016, 145, '2015-01-01 00:05:25.000000', 'temperatura', 408.0000, 'ºC'),
	(303017, 145, '2015-01-01 00:05:26.000000', 'temperatura', 854.0000, 'ºC'),
	(303018, 145, '2015-01-01 00:05:27.000000', 'temperatura', 643.0000, 'ºC'),
	(303019, 145, '2015-01-01 00:05:28.000000', 'temperatura', 656.0000, 'ºC'),
	(303020, 145, '2015-01-01 00:05:29.000000', 'temperatura', 152.0000, 'ºC'),
	(303021, 145, '2015-01-01 00:05:30.000000', 'temperatura', 1193.0000, 'ºC'),
	(303022, 145, '2015-01-01 00:05:31.000000', 'temperatura', 707.0000, 'ºC'),
	(303023, 145, '2015-01-01 00:05:32.000000', 'temperatura', 1157.0000, 'ºC'),
	(303024, 145, '2015-01-01 00:05:33.000000', 'temperatura', 64.0000, 'ºC'),
	(303025, 145, '2015-01-01 00:05:34.000000', 'temperatura', 449.0000, 'ºC'),
	(303026, 145, '2015-01-01 00:05:35.000000', 'temperatura', 856.0000, 'ºC'),
	(303027, 145, '2015-01-01 00:05:36.000000', 'temperatura', 534.0000, 'ºC'),
	(303028, 145, '2015-01-01 00:05:37.000000', 'temperatura', 99.0000, 'ºC'),
	(303029, 145, '2015-01-01 00:05:38.000000', 'temperatura', 97.0000, 'ºC'),
	(303030, 145, '2015-01-01 00:05:39.000000', 'temperatura', 185.0000, 'ºC'),
	(303031, 145, '2015-01-01 00:05:40.000000', 'temperatura', 637.0000, 'ºC'),
	(303032, 145, '2015-01-01 00:05:41.000000', 'temperatura', 229.0000, 'ºC'),
	(303033, 145, '2015-01-01 00:05:42.000000', 'temperatura', 435.0000, 'ºC'),
	(303034, 145, '2015-01-01 00:05:43.000000', 'temperatura', 287.0000, 'ºC'),
	(303035, 145, '2015-01-01 00:05:44.000000', 'temperatura', 133.0000, 'ºC'),
	(303036, 145, '2015-01-01 00:05:45.000000', 'temperatura', 1003.0000, 'ºC'),
	(303037, 145, '2015-01-01 00:05:46.000000', 'temperatura', 1015.0000, 'ºC'),
	(303038, 145, '2015-01-01 00:05:47.000000', 'temperatura', 868.0000, 'ºC'),
	(303039, 145, '2015-01-01 00:05:48.000000', 'temperatura', 96.0000, 'ºC'),
	(303040, 145, '2015-01-01 00:05:49.000000', 'temperatura', 278.0000, 'ºC'),
	(303041, 145, '2015-01-01 00:05:50.000000', 'temperatura', 1101.0000, 'ºC'),
	(303042, 145, '2015-01-01 00:05:51.000000', 'temperatura', 1071.0000, 'ºC'),
	(303043, 145, '2015-01-01 00:05:52.000000', 'temperatura', 852.0000, 'ºC'),
	(303044, 145, '2015-01-01 00:05:53.000000', 'temperatura', 1049.0000, 'ºC'),
	(303045, 145, '2015-01-01 00:05:54.000000', 'temperatura', 291.0000, 'ºC'),
	(303046, 145, '2015-01-01 00:05:55.000000', 'temperatura', 706.0000, 'ºC'),
	(303047, 145, '2015-01-01 00:05:56.000000', 'temperatura', 260.0000, 'ºC'),
	(303048, 145, '2015-01-01 00:05:57.000000', 'temperatura', 382.0000, 'ºC'),
	(303049, 145, '2015-01-01 00:05:58.000000', 'temperatura', 1131.0000, 'ºC'),
	(303050, 145, '2015-01-01 00:05:59.000000', 'temperatura', 909.0000, 'ºC'),
	(303051, 145, '2015-01-01 00:06:00.000000', 'temperatura', 1154.0000, 'ºC'),
	(303052, 145, '2015-01-01 00:06:01.000000', 'temperatura', 643.0000, 'ºC'),
	(303053, 145, '2015-01-01 00:06:02.000000', 'temperatura', 951.0000, 'ºC'),
	(303054, 145, '2015-01-01 00:06:03.000000', 'temperatura', 429.0000, 'ºC'),
	(303055, 145, '2015-01-01 00:06:04.000000', 'temperatura', 491.0000, 'ºC'),
	(303056, 145, '2015-01-01 00:06:05.000000', 'temperatura', 1168.0000, 'ºC'),
	(303057, 145, '2015-01-01 00:06:06.000000', 'temperatura', 770.0000, 'ºC'),
	(303058, 145, '2015-01-01 00:06:07.000000', 'temperatura', 343.0000, 'ºC'),
	(303059, 145, '2015-01-01 00:06:08.000000', 'temperatura', 609.0000, 'ºC'),
	(303060, 145, '2015-01-01 00:06:09.000000', 'temperatura', 816.0000, 'ºC'),
	(303061, 145, '2015-01-01 00:06:10.000000', 'temperatura', 1053.0000, 'ºC'),
	(303062, 145, '2015-01-01 00:06:11.000000', 'temperatura', 417.0000, 'ºC'),
	(303063, 145, '2015-01-01 00:06:12.000000', 'temperatura', 125.0000, 'ºC'),
	(303064, 145, '2015-01-01 00:06:13.000000', 'temperatura', 575.0000, 'ºC'),
	(303065, 145, '2015-01-01 00:06:14.000000', 'temperatura', 99.0000, 'ºC'),
	(303066, 145, '2015-01-01 00:06:15.000000', 'temperatura', 1173.0000, 'ºC'),
	(303067, 145, '2015-01-01 00:06:16.000000', 'temperatura', 767.0000, 'ºC'),
	(303068, 145, '2015-01-01 00:06:17.000000', 'temperatura', 319.0000, 'ºC'),
	(303069, 145, '2015-01-01 00:06:18.000000', 'temperatura', 492.0000, 'ºC'),
	(303070, 145, '2015-01-01 00:06:19.000000', 'temperatura', 305.0000, 'ºC'),
	(303071, 145, '2015-01-01 00:06:20.000000', 'temperatura', 48.0000, 'ºC'),
	(303072, 145, '2015-01-01 00:06:21.000000', 'temperatura', 524.0000, 'ºC'),
	(303073, 145, '2015-01-01 00:06:22.000000', 'temperatura', 80.0000, 'ºC'),
	(303074, 145, '2015-01-01 00:06:23.000000', 'temperatura', 26.0000, 'ºC'),
	(303075, 145, '2015-01-01 00:06:24.000000', 'temperatura', 1090.0000, 'ºC'),
	(303076, 145, '2015-01-01 00:06:25.000000', 'temperatura', 574.0000, 'ºC'),
	(303077, 145, '2015-01-01 00:06:26.000000', 'temperatura', 799.0000, 'ºC'),
	(303078, 145, '2015-01-01 00:06:27.000000', 'temperatura', 1075.0000, 'ºC'),
	(303079, 145, '2015-01-01 00:06:28.000000', 'temperatura', 576.0000, 'ºC'),
	(303080, 145, '2015-01-01 00:06:29.000000', 'temperatura', 856.0000, 'ºC'),
	(303081, 145, '2015-01-01 00:06:30.000000', 'temperatura', 154.0000, 'ºC'),
	(303082, 145, '2015-01-01 00:06:31.000000', 'temperatura', 601.0000, 'ºC'),
	(303083, 145, '2015-01-01 00:06:32.000000', 'temperatura', 142.0000, 'ºC'),
	(303084, 145, '2015-01-01 00:06:33.000000', 'temperatura', 111.0000, 'ºC'),
	(303085, 145, '2015-01-01 00:06:34.000000', 'temperatura', 128.0000, 'ºC'),
	(303086, 145, '2015-01-01 00:06:35.000000', 'temperatura', 309.0000, 'ºC'),
	(303087, 145, '2015-01-01 00:06:36.000000', 'temperatura', 1160.0000, 'ºC'),
	(303088, 145, '2015-01-01 00:06:37.000000', 'temperatura', 74.0000, 'ºC'),
	(303089, 145, '2015-01-01 00:06:38.000000', 'temperatura', 491.0000, 'ºC'),
	(303090, 145, '2015-01-01 00:06:39.000000', 'temperatura', 1033.0000, 'ºC'),
	(303091, 145, '2015-01-01 00:06:40.000000', 'temperatura', 93.0000, 'ºC'),
	(303092, 145, '2015-01-01 00:06:41.000000', 'temperatura', 966.0000, 'ºC'),
	(303093, 145, '2015-01-01 00:06:42.000000', 'temperatura', 952.0000, 'ºC'),
	(303094, 145, '2015-01-01 00:06:43.000000', 'temperatura', 662.0000, 'ºC'),
	(303095, 145, '2015-01-01 00:06:44.000000', 'temperatura', 453.0000, 'ºC'),
	(303096, 145, '2015-01-01 00:06:45.000000', 'temperatura', 282.0000, 'ºC'),
	(303097, 145, '2015-01-01 00:06:46.000000', 'temperatura', 50.0000, 'ºC'),
	(303098, 145, '2015-01-01 00:06:47.000000', 'temperatura', 607.0000, 'ºC'),
	(303099, 145, '2015-01-01 00:06:48.000000', 'temperatura', 483.0000, 'ºC'),
	(303100, 145, '2015-01-01 00:06:49.000000', 'temperatura', 596.0000, 'ºC'),
	(303101, 145, '2015-01-01 00:06:50.000000', 'temperatura', 331.0000, 'ºC'),
	(303102, 145, '2015-01-01 00:06:51.000000', 'temperatura', 1067.0000, 'ºC'),
	(303103, 145, '2015-01-01 00:06:52.000000', 'temperatura', 741.0000, 'ºC'),
	(303104, 145, '2015-01-01 00:06:53.000000', 'temperatura', 506.0000, 'ºC'),
	(303105, 145, '2015-01-01 00:06:54.000000', 'temperatura', 308.0000, 'ºC'),
	(303106, 145, '2015-01-01 00:06:55.000000', 'temperatura', 24.0000, 'ºC'),
	(303107, 145, '2015-01-01 00:06:56.000000', 'temperatura', 394.0000, 'ºC'),
	(303108, 145, '2015-01-01 00:06:57.000000', 'temperatura', 701.0000, 'ºC'),
	(303109, 145, '2015-01-01 00:06:58.000000', 'temperatura', 1123.0000, 'ºC'),
	(303110, 145, '2015-01-01 00:06:59.000000', 'temperatura', 1111.0000, 'ºC'),
	(303111, 145, '2015-01-01 00:07:00.000000', 'temperatura', 986.0000, 'ºC'),
	(303112, 145, '2015-01-01 00:07:01.000000', 'temperatura', 399.0000, 'ºC'),
	(303113, 145, '2015-01-01 00:07:02.000000', 'temperatura', 239.0000, 'ºC'),
	(303114, 145, '2015-01-01 00:07:03.000000', 'temperatura', 1196.0000, 'ºC'),
	(303115, 145, '2015-01-01 00:07:04.000000', 'temperatura', 466.0000, 'ºC'),
	(303116, 145, '2015-01-01 00:07:05.000000', 'temperatura', 1140.0000, 'ºC'),
	(303117, 145, '2015-01-01 00:07:06.000000', 'temperatura', 705.0000, 'ºC'),
	(303118, 145, '2015-01-01 00:07:07.000000', 'temperatura', 106.0000, 'ºC'),
	(303119, 145, '2015-01-01 00:07:08.000000', 'temperatura', 814.0000, 'ºC'),
	(303120, 145, '2015-01-01 00:07:09.000000', 'temperatura', 152.0000, 'ºC'),
	(303121, 145, '2015-01-01 00:07:10.000000', 'temperatura', 718.0000, 'ºC'),
	(303122, 145, '2015-01-01 00:07:11.000000', 'temperatura', 735.0000, 'ºC'),
	(303123, 145, '2015-01-01 00:07:12.000000', 'temperatura', 324.0000, 'ºC'),
	(303124, 145, '2015-01-01 00:07:13.000000', 'temperatura', 612.0000, 'ºC'),
	(303125, 145, '2015-01-01 00:07:14.000000', 'temperatura', 889.0000, 'ºC'),
	(303126, 145, '2015-01-01 00:07:15.000000', 'temperatura', 209.0000, 'ºC'),
	(303127, 145, '2015-01-01 00:07:16.000000', 'temperatura', 777.0000, 'ºC'),
	(303128, 145, '2015-01-01 00:07:17.000000', 'temperatura', 861.0000, 'ºC'),
	(303129, 145, '2015-01-01 00:07:18.000000', 'temperatura', 774.0000, 'ºC'),
	(303130, 145, '2015-01-01 00:07:19.000000', 'temperatura', 86.0000, 'ºC'),
	(303131, 145, '2015-01-01 00:07:20.000000', 'temperatura', 508.0000, 'ºC'),
	(303132, 145, '2015-01-01 00:07:21.000000', 'temperatura', 1085.0000, 'ºC'),
	(303133, 145, '2015-01-01 00:07:22.000000', 'temperatura', 302.0000, 'ºC'),
	(303134, 145, '2015-01-01 00:07:23.000000', 'temperatura', 656.0000, 'ºC'),
	(303135, 145, '2015-01-01 00:07:24.000000', 'temperatura', 1175.0000, 'ºC'),
	(303136, 145, '2015-01-01 00:07:25.000000', 'temperatura', 308.0000, 'ºC'),
	(303137, 145, '2015-01-01 00:07:26.000000', 'temperatura', 413.0000, 'ºC'),
	(303138, 145, '2015-01-01 00:07:27.000000', 'temperatura', 1145.0000, 'ºC'),
	(303139, 145, '2015-01-01 00:07:28.000000', 'temperatura', 883.0000, 'ºC'),
	(303140, 145, '2015-01-01 00:07:29.000000', 'temperatura', 982.0000, 'ºC'),
	(303141, 145, '2015-01-01 00:07:30.000000', 'temperatura', 1061.0000, 'ºC'),
	(303142, 145, '2015-01-01 00:07:31.000000', 'temperatura', 1159.0000, 'ºC'),
	(303143, 145, '2015-01-01 00:07:32.000000', 'temperatura', 212.0000, 'ºC'),
	(303144, 145, '2015-01-01 00:07:33.000000', 'temperatura', 1185.0000, 'ºC'),
	(303145, 145, '2015-01-01 00:07:34.000000', 'temperatura', 490.0000, 'ºC'),
	(303146, 145, '2015-01-01 00:07:35.000000', 'temperatura', 94.0000, 'ºC'),
	(303147, 145, '2015-01-01 00:07:36.000000', 'temperatura', 202.0000, 'ºC'),
	(303148, 145, '2015-01-01 00:07:37.000000', 'temperatura', 730.0000, 'ºC'),
	(303149, 145, '2015-01-01 00:07:38.000000', 'temperatura', 641.0000, 'ºC'),
	(303150, 145, '2015-01-01 00:07:39.000000', 'temperatura', 1018.0000, 'ºC'),
	(303151, 145, '2015-01-01 00:07:40.000000', 'temperatura', 765.0000, 'ºC'),
	(303152, 145, '2015-01-01 00:07:41.000000', 'temperatura', 774.0000, 'ºC'),
	(303153, 145, '2015-01-01 00:07:42.000000', 'temperatura', 376.0000, 'ºC'),
	(303154, 145, '2015-01-01 00:07:43.000000', 'temperatura', 758.0000, 'ºC'),
	(303155, 145, '2015-01-01 00:07:44.000000', 'temperatura', 264.0000, 'ºC'),
	(303156, 145, '2015-01-01 00:07:45.000000', 'temperatura', 246.0000, 'ºC'),
	(303157, 145, '2015-01-01 00:07:46.000000', 'temperatura', 437.0000, 'ºC'),
	(303158, 145, '2015-01-01 00:07:47.000000', 'temperatura', 248.0000, 'ºC'),
	(303159, 145, '2015-01-01 00:07:48.000000', 'temperatura', 1131.0000, 'ºC'),
	(303160, 145, '2015-01-01 00:07:49.000000', 'temperatura', 109.0000, 'ºC'),
	(303161, 145, '2015-01-01 00:07:50.000000', 'temperatura', 753.0000, 'ºC'),
	(303162, 145, '2015-01-01 00:07:51.000000', 'temperatura', 1040.0000, 'ºC'),
	(303163, 145, '2015-01-01 00:07:52.000000', 'temperatura', 542.0000, 'ºC'),
	(303164, 145, '2015-01-01 00:07:53.000000', 'temperatura', 790.0000, 'ºC'),
	(303165, 145, '2015-01-01 00:07:54.000000', 'temperatura', 1122.0000, 'ºC'),
	(303166, 145, '2015-01-01 00:07:55.000000', 'temperatura', 843.0000, 'ºC'),
	(303167, 145, '2015-01-01 00:07:56.000000', 'temperatura', 849.0000, 'ºC'),
	(303168, 145, '2015-01-01 00:07:57.000000', 'temperatura', 518.0000, 'ºC'),
	(303169, 145, '2015-01-01 00:07:58.000000', 'temperatura', 41.0000, 'ºC'),
	(303170, 145, '2015-01-01 00:07:59.000000', 'temperatura', 1051.0000, 'ºC'),
	(303171, 145, '2015-01-01 00:08:00.000000', 'temperatura', 334.0000, 'ºC'),
	(303172, 145, '2015-01-01 00:08:01.000000', 'temperatura', 916.0000, 'ºC'),
	(303173, 145, '2015-01-01 00:08:02.000000', 'temperatura', 1180.0000, 'ºC'),
	(303174, 145, '2015-01-01 00:08:03.000000', 'temperatura', 751.0000, 'ºC'),
	(303175, 145, '2015-01-01 00:08:04.000000', 'temperatura', 217.0000, 'ºC'),
	(303176, 145, '2015-01-01 00:08:05.000000', 'temperatura', 31.0000, 'ºC'),
	(303177, 145, '2015-01-01 00:08:06.000000', 'temperatura', 706.0000, 'ºC'),
	(303178, 145, '2015-01-01 00:08:07.000000', 'temperatura', 1037.0000, 'ºC'),
	(303179, 145, '2015-01-01 00:08:08.000000', 'temperatura', 669.0000, 'ºC'),
	(303180, 145, '2015-01-01 00:08:09.000000', 'temperatura', 233.0000, 'ºC'),
	(303181, 145, '2015-01-01 00:08:10.000000', 'temperatura', 357.0000, 'ºC'),
	(303182, 145, '2015-01-01 00:08:11.000000', 'temperatura', 1087.0000, 'ºC'),
	(303183, 145, '2015-01-01 00:08:12.000000', 'temperatura', 767.0000, 'ºC'),
	(303184, 145, '2015-01-01 00:08:13.000000', 'temperatura', 572.0000, 'ºC'),
	(303185, 145, '2015-01-01 00:08:14.000000', 'temperatura', 559.0000, 'ºC'),
	(303186, 145, '2015-01-01 00:08:15.000000', 'temperatura', 1080.0000, 'ºC'),
	(303187, 145, '2015-01-01 00:08:16.000000', 'temperatura', 126.0000, 'ºC'),
	(303188, 145, '2015-01-01 00:08:17.000000', 'temperatura', 987.0000, 'ºC'),
	(303189, 145, '2015-01-01 00:08:18.000000', 'temperatura', 960.0000, 'ºC'),
	(303190, 145, '2015-01-01 00:08:19.000000', 'temperatura', 637.0000, 'ºC'),
	(303191, 145, '2015-01-01 00:08:20.000000', 'temperatura', 305.0000, 'ºC'),
	(303192, 145, '2015-01-01 00:08:21.000000', 'temperatura', 816.0000, 'ºC'),
	(303193, 145, '2015-01-01 00:08:22.000000', 'temperatura', 763.0000, 'ºC'),
	(303194, 145, '2015-01-01 00:08:23.000000', 'temperatura', 171.0000, 'ºC'),
	(303195, 145, '2015-01-01 00:08:24.000000', 'temperatura', 965.0000, 'ºC'),
	(303196, 145, '2015-01-01 00:08:25.000000', 'temperatura', 713.0000, 'ºC'),
	(303197, 145, '2015-01-01 00:08:26.000000', 'temperatura', 670.0000, 'ºC'),
	(303198, 145, '2015-01-01 00:08:27.000000', 'temperatura', 13.0000, 'ºC'),
	(303199, 145, '2015-01-01 00:08:28.000000', 'temperatura', 453.0000, 'ºC'),
	(303200, 145, '2015-01-01 00:08:29.000000', 'temperatura', 1026.0000, 'ºC'),
	(303201, 145, '2015-01-01 00:08:30.000000', 'temperatura', 173.0000, 'ºC'),
	(303202, 145, '2015-01-01 00:08:31.000000', 'temperatura', 186.0000, 'ºC'),
	(303203, 145, '2015-01-01 00:08:32.000000', 'temperatura', 414.0000, 'ºC'),
	(303204, 145, '2015-01-01 00:08:33.000000', 'temperatura', 312.0000, 'ºC'),
	(303205, 145, '2015-01-01 00:08:34.000000', 'temperatura', 316.0000, 'ºC'),
	(303206, 145, '2015-01-01 00:08:35.000000', 'temperatura', 646.0000, 'ºC'),
	(303207, 145, '2015-01-01 00:08:36.000000', 'temperatura', 1084.0000, 'ºC'),
	(303208, 145, '2015-01-01 00:08:37.000000', 'temperatura', 1083.0000, 'ºC'),
	(303209, 145, '2015-01-01 00:08:38.000000', 'temperatura', 962.0000, 'ºC'),
	(303210, 145, '2015-01-01 00:08:39.000000', 'temperatura', 361.0000, 'ºC'),
	(303211, 145, '2015-01-01 00:08:40.000000', 'temperatura', 120.0000, 'ºC'),
	(303212, 145, '2015-01-01 00:08:41.000000', 'temperatura', 716.0000, 'ºC'),
	(303213, 145, '2015-01-01 00:08:42.000000', 'temperatura', 821.0000, 'ºC'),
	(303214, 145, '2015-01-01 00:08:43.000000', 'temperatura', 758.0000, 'ºC'),
	(303215, 145, '2015-01-01 00:08:44.000000', 'temperatura', 129.0000, 'ºC'),
	(303216, 145, '2015-01-01 00:08:45.000000', 'temperatura', 769.0000, 'ºC'),
	(303217, 145, '2015-01-01 00:08:46.000000', 'temperatura', 1059.0000, 'ºC'),
	(303218, 145, '2015-01-01 00:08:47.000000', 'temperatura', 591.0000, 'ºC'),
	(303219, 145, '2015-01-01 00:08:48.000000', 'temperatura', 976.0000, 'ºC'),
	(303220, 145, '2015-01-01 00:08:49.000000', 'temperatura', 708.0000, 'ºC'),
	(303221, 145, '2015-01-01 00:08:50.000000', 'temperatura', 611.0000, 'ºC'),
	(303222, 145, '2015-01-01 00:08:51.000000', 'temperatura', 933.0000, 'ºC'),
	(303223, 145, '2015-01-01 00:08:52.000000', 'temperatura', 430.0000, 'ºC'),
	(303224, 145, '2015-01-01 00:08:53.000000', 'temperatura', 554.0000, 'ºC'),
	(303225, 145, '2015-01-01 00:08:54.000000', 'temperatura', 280.0000, 'ºC'),
	(303226, 145, '2015-01-01 00:08:55.000000', 'temperatura', 936.0000, 'ºC'),
	(303227, 145, '2015-01-01 00:08:56.000000', 'temperatura', 244.0000, 'ºC'),
	(303228, 145, '2015-01-01 00:08:57.000000', 'temperatura', 811.0000, 'ºC'),
	(303229, 145, '2015-01-01 00:08:58.000000', 'temperatura', 925.0000, 'ºC'),
	(303230, 145, '2015-01-01 00:08:59.000000', 'temperatura', 993.0000, 'ºC'),
	(303231, 145, '2015-01-01 00:09:00.000000', 'temperatura', 990.0000, 'ºC'),
	(303232, 145, '2015-01-01 00:09:01.000000', 'temperatura', 771.0000, 'ºC'),
	(303233, 145, '2015-01-01 00:09:02.000000', 'temperatura', 887.0000, 'ºC'),
	(303234, 145, '2015-01-01 00:09:03.000000', 'temperatura', 920.0000, 'ºC'),
	(303235, 145, '2015-01-01 00:09:04.000000', 'temperatura', 740.0000, 'ºC'),
	(303236, 145, '2015-01-01 00:09:05.000000', 'temperatura', 939.0000, 'ºC'),
	(303237, 145, '2015-01-01 00:09:06.000000', 'temperatura', 78.0000, 'ºC'),
	(303238, 145, '2015-01-01 00:09:07.000000', 'temperatura', 1173.0000, 'ºC'),
	(303239, 145, '2015-01-01 00:09:08.000000', 'temperatura', 833.0000, 'ºC'),
	(303240, 145, '2015-01-01 00:09:09.000000', 'temperatura', 644.0000, 'ºC'),
	(303241, 145, '2015-01-01 00:09:10.000000', 'temperatura', 724.0000, 'ºC'),
	(303242, 145, '2015-01-01 00:09:11.000000', 'temperatura', 487.0000, 'ºC'),
	(303243, 145, '2015-01-01 00:09:12.000000', 'temperatura', 262.0000, 'ºC'),
	(303244, 145, '2015-01-01 00:09:13.000000', 'temperatura', 1050.0000, 'ºC'),
	(303245, 145, '2015-01-01 00:09:14.000000', 'temperatura', 864.0000, 'ºC'),
	(303246, 145, '2015-01-01 00:09:15.000000', 'temperatura', 1171.0000, 'ºC'),
	(303247, 145, '2015-01-01 00:09:16.000000', 'temperatura', 862.0000, 'ºC'),
	(303248, 145, '2015-01-01 00:09:17.000000', 'temperatura', 797.0000, 'ºC'),
	(303249, 145, '2015-01-01 00:09:18.000000', 'temperatura', 199.0000, 'ºC'),
	(303250, 145, '2015-01-01 00:09:19.000000', 'temperatura', 1007.0000, 'ºC'),
	(303251, 145, '2015-01-01 00:09:20.000000', 'temperatura', 836.0000, 'ºC'),
	(303252, 145, '2015-01-01 00:09:21.000000', 'temperatura', 1161.0000, 'ºC'),
	(303253, 145, '2015-01-01 00:09:22.000000', 'temperatura', 896.0000, 'ºC'),
	(303254, 145, '2015-01-01 00:09:23.000000', 'temperatura', 996.0000, 'ºC'),
	(303255, 145, '2015-01-01 00:09:24.000000', 'temperatura', 1096.0000, 'ºC'),
	(303256, 145, '2015-01-01 00:09:25.000000', 'temperatura', 92.0000, 'ºC'),
	(303257, 145, '2015-01-01 00:09:26.000000', 'temperatura', 773.0000, 'ºC'),
	(303258, 145, '2015-01-01 00:09:27.000000', 'temperatura', 1189.0000, 'ºC'),
	(303259, 145, '2015-01-01 00:09:28.000000', 'temperatura', 28.0000, 'ºC'),
	(303260, 145, '2015-01-01 00:09:29.000000', 'temperatura', 172.0000, 'ºC'),
	(303261, 145, '2015-01-01 00:09:30.000000', 'temperatura', 776.0000, 'ºC'),
	(303262, 145, '2015-01-01 00:09:31.000000', 'temperatura', 967.0000, 'ºC'),
	(303263, 145, '2015-01-01 00:09:32.000000', 'temperatura', 106.0000, 'ºC'),
	(303264, 145, '2015-01-01 00:09:33.000000', 'temperatura', 30.0000, 'ºC'),
	(303265, 145, '2015-01-01 00:09:34.000000', 'temperatura', 1034.0000, 'ºC'),
	(303266, 145, '2015-01-01 00:09:35.000000', 'temperatura', 278.0000, 'ºC'),
	(303267, 145, '2015-01-01 00:09:36.000000', 'temperatura', 689.0000, 'ºC'),
	(303268, 145, '2015-01-01 00:09:37.000000', 'temperatura', 210.0000, 'ºC'),
	(303269, 145, '2015-01-01 00:09:38.000000', 'temperatura', 184.0000, 'ºC'),
	(303270, 145, '2015-01-01 00:09:39.000000', 'temperatura', 291.0000, 'ºC'),
	(303271, 145, '2015-01-01 00:09:40.000000', 'temperatura', 905.0000, 'ºC'),
	(303272, 145, '2015-01-01 00:09:41.000000', 'temperatura', 51.0000, 'ºC'),
	(303273, 145, '2015-01-01 00:09:42.000000', 'temperatura', 1141.0000, 'ºC'),
	(303274, 145, '2015-01-01 00:09:43.000000', 'temperatura', 754.0000, 'ºC'),
	(303275, 145, '2015-01-01 00:09:44.000000', 'temperatura', 345.0000, 'ºC'),
	(303276, 145, '2015-01-01 00:09:45.000000', 'temperatura', 665.0000, 'ºC'),
	(303277, 145, '2015-01-01 00:09:46.000000', 'temperatura', 1091.0000, 'ºC'),
	(303278, 145, '2015-01-01 00:09:47.000000', 'temperatura', 1059.0000, 'ºC'),
	(303279, 145, '2015-01-01 00:09:48.000000', 'temperatura', 822.0000, 'ºC'),
	(303280, 145, '2015-01-01 00:09:49.000000', 'temperatura', 932.0000, 'ºC'),
	(303281, 145, '2015-01-01 00:09:50.000000', 'temperatura', 997.0000, 'ºC'),
	(303282, 145, '2015-01-01 00:09:51.000000', 'temperatura', 991.0000, 'ºC'),
	(303283, 145, '2015-01-01 00:09:52.000000', 'temperatura', 763.0000, 'ºC'),
	(303284, 145, '2015-01-01 00:09:53.000000', 'temperatura', 841.0000, 'ºC'),
	(303285, 145, '2015-01-01 00:09:54.000000', 'temperatura', 719.0000, 'ºC'),
	(303286, 145, '2015-01-01 00:09:55.000000', 'temperatura', 1073.0000, 'ºC'),
	(303287, 145, '2015-01-01 00:09:56.000000', 'temperatura', 806.0000, 'ºC'),
	(303288, 145, '2015-01-01 00:09:57.000000', 'temperatura', 814.0000, 'ºC'),
	(303289, 145, '2015-01-01 00:09:58.000000', 'temperatura', 452.0000, 'ºC'),
	(303290, 145, '2015-01-01 00:09:59.000000', 'temperatura', 1020.0000, 'ºC'),
	(303291, 145, '2015-01-01 00:10:00.000000', 'temperatura', 144.0000, 'ºC'),
	(303292, 145, '2015-01-01 00:10:01.000000', 'temperatura', 60.0000, 'ºC'),
	(303293, 145, '2015-01-01 00:10:02.000000', 'temperatura', 1068.0000, 'ºC'),
	(303294, 145, '2015-01-01 00:10:03.000000', 'temperatura', 361.0000, 'ºC'),
	(303295, 145, '2015-01-01 00:10:04.000000', 'temperatura', 1003.0000, 'ºC'),
	(303296, 145, '2015-01-01 00:10:05.000000', 'temperatura', 330.0000, 'ºC'),
	(303297, 145, '2015-01-01 00:10:06.000000', 'temperatura', 1041.0000, 'ºC'),
	(303298, 145, '2015-01-01 00:10:07.000000', 'temperatura', 615.0000, 'ºC'),
	(303299, 145, '2015-01-01 00:10:08.000000', 'temperatura', 1152.0000, 'ºC'),
	(303300, 145, '2015-01-01 00:10:09.000000', 'temperatura', 319.0000, 'ºC'),
	(303301, 145, '2015-01-01 00:10:10.000000', 'temperatura', 536.0000, 'ºC'),
	(303302, 145, '2015-01-01 00:10:11.000000', 'temperatura', 525.0000, 'ºC'),
	(303303, 145, '2015-01-01 00:10:12.000000', 'temperatura', 1017.0000, 'ºC'),
	(303304, 145, '2015-01-01 00:10:13.000000', 'temperatura', 1112.0000, 'ºC'),
	(303305, 145, '2015-01-01 00:10:14.000000', 'temperatura', 108.0000, 'ºC'),
	(303306, 145, '2015-01-01 00:10:15.000000', 'temperatura', 807.0000, 'ºC'),
	(303307, 145, '2015-01-01 00:10:16.000000', 'temperatura', 108.0000, 'ºC'),
	(303308, 145, '2015-01-01 00:10:17.000000', 'temperatura', 521.0000, 'ºC'),
	(303309, 145, '2015-01-01 00:10:18.000000', 'temperatura', 1080.0000, 'ºC'),
	(303310, 145, '2015-01-01 00:10:19.000000', 'temperatura', 240.0000, 'ºC'),
	(303311, 145, '2015-01-01 00:10:20.000000', 'temperatura', 360.0000, 'ºC'),
	(303312, 145, '2015-01-01 00:10:21.000000', 'temperatura', 1081.0000, 'ºC'),
	(303313, 145, '2015-01-01 00:10:22.000000', 'temperatura', 724.0000, 'ºC'),
	(303314, 145, '2015-01-01 00:10:23.000000', 'temperatura', 377.0000, 'ºC'),
	(303315, 145, '2015-01-01 00:10:24.000000', 'temperatura', 912.0000, 'ºC'),
	(303316, 145, '2015-01-01 00:10:25.000000', 'temperatura', 1033.0000, 'ºC'),
	(303317, 145, '2015-01-01 00:10:26.000000', 'temperatura', 27.0000, 'ºC'),
	(303318, 145, '2015-01-01 00:10:27.000000', 'temperatura', 638.0000, 'ºC'),
	(303319, 145, '2015-01-01 00:10:28.000000', 'temperatura', 710.0000, 'ºC'),
	(303320, 145, '2015-01-01 00:10:29.000000', 'temperatura', 436.0000, 'ºC'),
	(303321, 145, '2015-01-01 00:10:30.000000', 'temperatura', 49.0000, 'ºC'),
	(303322, 145, '2015-01-01 00:10:31.000000', 'temperatura', 140.0000, 'ºC'),
	(303323, 145, '2015-01-01 00:10:32.000000', 'temperatura', 553.0000, 'ºC'),
	(303324, 145, '2015-01-01 00:10:33.000000', 'temperatura', 1146.0000, 'ºC'),
	(303325, 145, '2015-01-01 00:10:34.000000', 'temperatura', 472.0000, 'ºC'),
	(303326, 145, '2015-01-01 00:10:35.000000', 'temperatura', 121.0000, 'ºC'),
	(303327, 145, '2015-01-01 00:10:36.000000', 'temperatura', 389.0000, 'ºC'),
	(303328, 145, '2015-01-01 00:10:37.000000', 'temperatura', 384.0000, 'ºC'),
	(303329, 145, '2015-01-01 00:10:38.000000', 'temperatura', 751.0000, 'ºC'),
	(303330, 145, '2015-01-01 00:10:39.000000', 'temperatura', 205.0000, 'ºC'),
	(303331, 145, '2015-01-01 00:10:40.000000', 'temperatura', 1173.0000, 'ºC'),
	(303332, 145, '2015-01-01 00:10:41.000000', 'temperatura', 451.0000, 'ºC'),
	(303333, 145, '2015-01-01 00:10:42.000000', 'temperatura', 1134.0000, 'ºC'),
	(303334, 145, '2015-01-01 00:10:43.000000', 'temperatura', 719.0000, 'ºC'),
	(303335, 145, '2015-01-01 00:10:44.000000', 'temperatura', 192.0000, 'ºC'),
	(303336, 145, '2015-01-01 00:10:45.000000', 'temperatura', 2.0000, 'ºC'),
	(303337, 145, '2015-01-01 00:10:46.000000', 'temperatura', 638.0000, 'ºC'),
	(303338, 145, '2015-01-01 00:10:47.000000', 'temperatura', 783.0000, 'ºC'),
	(303339, 145, '2015-01-01 00:10:48.000000', 'temperatura', 803.0000, 'ºC'),
	(303340, 145, '2015-01-01 00:10:49.000000', 'temperatura', 464.0000, 'ºC'),
	(303341, 145, '2015-01-01 00:10:50.000000', 'temperatura', 1115.0000, 'ºC'),
	(303342, 145, '2015-01-01 00:10:51.000000', 'temperatura', 580.0000, 'ºC'),
	(303343, 145, '2015-01-01 00:10:52.000000', 'temperatura', 757.0000, 'ºC'),
	(303344, 145, '2015-01-01 00:10:53.000000', 'temperatura', 847.0000, 'ºC'),
	(303345, 145, '2015-01-01 00:10:54.000000', 'temperatura', 764.0000, 'ºC'),
	(303346, 145, '2015-01-01 00:10:55.000000', 'temperatura', 78.0000, 'ºC'),
	(303347, 145, '2015-01-01 00:10:56.000000', 'temperatura', 499.0000, 'ºC'),
	(303348, 145, '2015-01-01 00:10:57.000000', 'temperatura', 1062.0000, 'ºC'),
	(303349, 145, '2015-01-01 00:10:58.000000', 'temperatura', 213.0000, 'ºC'),
	(303350, 145, '2015-01-01 00:10:59.000000', 'temperatura', 278.0000, 'ºC'),
	(303351, 145, '2015-01-01 00:11:00.000000', 'temperatura', 753.0000, 'ºC'),
	(303352, 145, '2015-01-01 00:11:01.000000', 'temperatura', 533.0000, 'ºC'),
	(303353, 145, '2015-01-01 00:11:02.000000', 'temperatura', 404.0000, 'ºC'),
	(303354, 145, '2015-01-01 00:11:03.000000', 'temperatura', 421.0000, 'ºC'),
	(303355, 145, '2015-01-01 00:11:04.000000', 'temperatura', 893.0000, 'ºC'),
	(303356, 145, '2015-01-01 00:11:05.000000', 'temperatura', 803.0000, 'ºC'),
	(303357, 145, '2015-01-01 00:11:06.000000', 'temperatura', 139.0000, 'ºC'),
	(303358, 145, '2015-01-01 00:11:07.000000', 'temperatura', 684.0000, 'ºC'),
	(303359, 145, '2015-01-01 00:11:08.000000', 'temperatura', 605.0000, 'ºC'),
	(303360, 145, '2015-01-01 00:11:09.000000', 'temperatura', 974.0000, 'ºC'),
	(303361, 145, '2015-01-01 00:11:10.000000', 'temperatura', 654.0000, 'ºC'),
	(303362, 145, '2015-01-01 00:11:11.000000', 'temperatura', 350.0000, 'ºC'),
	(303363, 145, '2015-01-01 00:11:12.000000', 'temperatura', 990.0000, 'ºC'),
	(303364, 145, '2015-01-01 00:11:13.000000', 'temperatura', 298.0000, 'ºC'),
	(303365, 145, '2015-01-01 00:11:14.000000', 'temperatura', 922.0000, 'ºC'),
	(303366, 145, '2015-01-01 00:11:15.000000', 'temperatura', 118.0000, 'ºC'),
	(303367, 145, '2015-01-01 00:11:16.000000', 'temperatura', 223.0000, 'ºC'),
	(303368, 145, '2015-01-01 00:11:17.000000', 'temperatura', 760.0000, 'ºC'),
	(303369, 145, '2015-01-01 00:11:18.000000', 'temperatura', 732.0000, 'ºC'),
	(303370, 145, '2015-01-01 00:11:19.000000', 'temperatura', 179.0000, 'ºC'),
	(303371, 145, '2015-01-01 00:11:20.000000', 'temperatura', 1100.0000, 'ºC'),
	(303372, 145, '2015-01-01 00:11:21.000000', 'temperatura', 163.0000, 'ºC'),
	(303373, 145, '2015-01-01 00:11:22.000000', 'temperatura', 1118.0000, 'ºC'),
	(303374, 145, '2015-01-01 00:11:23.000000', 'temperatura', 298.0000, 'ºC'),
	(303375, 145, '2015-01-01 00:11:24.000000', 'temperatura', 540.0000, 'ºC'),
	(303376, 145, '2015-01-01 00:11:25.000000', 'temperatura', 604.0000, 'ºC'),
	(303377, 145, '2015-01-01 00:11:26.000000', 'temperatura', 202.0000, 'ºC'),
	(303378, 145, '2015-01-01 00:11:27.000000', 'temperatura', 396.0000, 'ºC'),
	(303379, 145, '2015-01-01 00:11:28.000000', 'temperatura', 176.0000, 'ºC'),
	(303380, 145, '2015-01-01 00:11:29.000000', 'temperatura', 893.0000, 'ºC'),
	(303381, 145, '2015-01-01 00:11:30.000000', 'temperatura', 337.0000, 'ºC'),
	(303382, 145, '2015-01-01 00:11:31.000000', 'temperatura', 207.0000, 'ºC'),
	(303383, 145, '2015-01-01 00:11:32.000000', 'temperatura', 23.0000, 'ºC'),
	(303384, 145, '2015-01-01 00:11:33.000000', 'temperatura', 695.0000, 'ºC'),
	(303385, 145, '2015-01-01 00:11:34.000000', 'temperatura', 1008.0000, 'ºC'),
	(303386, 145, '2015-01-01 00:11:35.000000', 'temperatura', 555.0000, 'ºC'),
	(303387, 145, '2015-01-01 00:11:36.000000', 'temperatura', 951.0000, 'ºC'),
	(303388, 145, '2015-01-01 00:11:37.000000', 'temperatura', 690.0000, 'ºC'),
	(303389, 145, '2015-01-01 00:11:38.000000', 'temperatura', 597.0000, 'ºC'),
	(303390, 145, '2015-01-01 00:11:39.000000', 'temperatura', 917.0000, 'ºC'),
	(303391, 145, '2015-01-01 00:11:40.000000', 'temperatura', 395.0000, 'ºC'),
	(303392, 145, '2015-01-01 00:11:41.000000', 'temperatura', 425.0000, 'ºC'),
	(303393, 145, '2015-01-01 00:11:42.000000', 'temperatura', 940.0000, 'ºC'),
	(303394, 145, '2015-01-01 00:11:43.000000', 'temperatura', 1026.0000, 'ºC'),
	(303395, 145, '2015-01-01 00:11:44.000000', 'temperatura', 1111.0000, 'ºC'),
	(303396, 145, '2015-01-01 00:11:45.000000', 'temperatura', 77.0000, 'ºC'),
	(303397, 145, '2015-01-01 00:11:46.000000', 'temperatura', 651.0000, 'ºC'),
	(303398, 145, '2015-01-01 00:11:47.000000', 'temperatura', 624.0000, 'ºC'),
	(303399, 145, '2015-01-01 00:11:48.000000', 'temperatura', 1169.0000, 'ºC'),
	(303400, 145, '2015-01-01 00:11:49.000000', 'temperatura', 375.0000, 'ºC'),
	(303401, 145, '2015-01-01 00:11:50.000000', 'temperatura', 767.0000, 'ºC'),
	(303402, 145, '2015-01-01 00:11:51.000000', 'temperatura', 309.0000, 'ºC'),
	(303403, 145, '2015-01-01 00:11:52.000000', 'temperatura', 445.0000, 'ºC'),
	(303404, 145, '2015-01-01 00:11:53.000000', 'temperatura', 97.0000, 'ºC'),
	(303405, 145, '2015-01-01 00:11:54.000000', 'temperatura', 353.0000, 'ºC'),
	(303406, 145, '2015-01-01 00:11:55.000000', 'temperatura', 274.0000, 'ºC'),
	(303407, 145, '2015-01-01 00:11:56.000000', 'temperatura', 309.0000, 'ºC'),
	(303408, 145, '2015-01-01 00:11:57.000000', 'temperatura', 726.0000, 'ºC'),
	(303409, 145, '2015-01-01 00:11:58.000000', 'temperatura', 305.0000, 'ºC'),
	(303410, 145, '2015-01-01 00:11:59.000000', 'temperatura', 545.0000, 'ºC'),
	(303411, 145, '2015-01-01 00:12:00.000000', 'temperatura', 613.0000, 'ºC'),
	(303412, 145, '2015-01-01 00:12:01.000000', 'temperatura', 229.0000, 'ºC'),
	(303413, 145, '2015-01-01 00:12:02.000000', 'temperatura', 506.0000, 'ºC'),
	(303414, 145, '2015-01-01 00:12:03.000000', 'temperatura', 645.0000, 'ºC'),
	(303415, 145, '2015-01-01 00:12:04.000000', 'temperatura', 506.0000, 'ºC'),
	(303416, 145, '2015-01-01 00:12:05.000000', 'temperatura', 596.0000, 'ºC'),
	(303417, 145, '2015-01-01 00:12:06.000000', 'temperatura', 264.0000, 'ºC'),
	(303418, 145, '2015-01-01 00:12:07.000000', 'temperatura', 730.0000, 'ºC'),
	(303419, 145, '2015-01-01 00:12:08.000000', 'temperatura', 458.0000, 'ºC'),
	(303420, 145, '2015-01-01 00:12:09.000000', 'temperatura', 103.0000, 'ºC'),
	(303421, 145, '2015-01-01 00:12:10.000000', 'temperatura', 339.0000, 'ºC'),
	(303422, 145, '2015-01-01 00:12:11.000000', 'temperatura', 187.0000, 'ºC'),
	(303423, 145, '2015-01-01 00:12:12.000000', 'temperatura', 1121.0000, 'ºC'),
	(303424, 145, '2015-01-01 00:12:13.000000', 'temperatura', 243.0000, 'ºC'),
	(303425, 145, '2015-01-01 00:12:14.000000', 'temperatura', 251.0000, 'ºC'),
	(303426, 145, '2015-01-01 00:12:15.000000', 'temperatura', 529.0000, 'ºC'),
	(303427, 145, '2015-01-01 00:12:16.000000', 'temperatura', 692.0000, 'ºC'),
	(303428, 145, '2015-01-01 00:12:17.000000', 'temperatura', 672.0000, 'ºC'),
	(303429, 145, '2015-01-01 00:12:18.000000', 'temperatura', 85.0000, 'ºC'),
	(303430, 145, '2015-01-01 00:12:19.000000', 'temperatura', 809.0000, 'ºC'),
	(303431, 145, '2015-01-01 00:12:20.000000', 'temperatura', 192.0000, 'ºC'),
	(303432, 145, '2015-01-01 00:12:21.000000', 'temperatura', 934.0000, 'ºC'),
	(303433, 145, '2015-01-01 00:12:22.000000', 'temperatura', 495.0000, 'ºC'),
	(303434, 145, '2015-01-01 00:12:23.000000', 'temperatura', 872.0000, 'ºC'),
	(303435, 145, '2015-01-01 00:12:24.000000', 'temperatura', 475.0000, 'ºC'),
	(303436, 145, '2015-01-01 00:12:25.000000', 'temperatura', 959.0000, 'ºC'),
	(303437, 145, '2015-01-01 00:12:26.000000', 'temperatura', 970.0000, 'ºC'),
	(303438, 145, '2015-01-01 00:12:27.000000', 'temperatura', 774.0000, 'ºC'),
	(303439, 145, '2015-01-01 00:12:28.000000', 'temperatura', 962.0000, 'ºC'),
	(303440, 145, '2015-01-01 00:12:29.000000', 'temperatura', 87.0000, 'ºC'),
	(303441, 145, '2015-01-01 00:12:30.000000', 'temperatura', 1151.0000, 'ºC'),
	(303442, 145, '2015-01-01 00:12:31.000000', 'temperatura', 693.0000, 'ºC'),
	(303443, 145, '2015-01-01 00:12:32.000000', 'temperatura', 13.0000, 'ºC'),
	(303444, 145, '2015-01-01 00:12:33.000000', 'temperatura', 385.0000, 'ºC'),
	(303445, 145, '2015-01-01 00:12:34.000000', 'temperatura', 687.0000, 'ºC'),
	(303446, 145, '2015-01-01 00:12:35.000000', 'temperatura', 1082.0000, 'ºC'),
	(303447, 145, '2015-01-01 00:12:36.000000', 'temperatura', 950.0000, 'ºC'),
	(303448, 145, '2015-01-01 00:12:37.000000', 'temperatura', 302.0000, 'ºC'),
	(303449, 145, '2015-01-01 00:12:38.000000', 'temperatura', 1063.0000, 'ºC'),
	(303450, 145, '2015-01-01 00:12:39.000000', 'temperatura', 807.0000, 'ºC'),
	(303451, 145, '2015-01-01 00:12:40.000000', 'temperatura', 846.0000, 'ºC'),
	(303452, 145, '2015-01-01 00:12:41.000000', 'temperatura', 613.0000, 'ºC'),
	(303453, 145, '2015-01-01 00:12:42.000000', 'temperatura', 525.0000, 'ºC'),
	(303454, 145, '2015-01-01 00:12:43.000000', 'temperatura', 786.0000, 'ºC'),
	(303455, 145, '2015-01-01 00:12:44.000000', 'temperatura', 1155.0000, 'ºC'),
	(303456, 145, '2015-01-01 00:12:45.000000', 'temperatura', 1019.0000, 'ºC'),
	(303457, 145, '2015-01-01 00:12:46.000000', 'temperatura', 428.0000, 'ºC'),
	(303458, 145, '2015-01-01 00:12:47.000000', 'temperatura', 285.0000, 'ºC'),
	(303459, 145, '2015-01-01 00:12:48.000000', 'temperatura', 140.0000, 'ºC'),
	(303460, 145, '2015-01-01 00:12:49.000000', 'temperatura', 1048.0000, 'ºC'),
	(303461, 145, '2015-01-01 00:12:50.000000', 'temperatura', 21.0000, 'ºC'),
	(303462, 145, '2015-01-01 00:12:51.000000', 'temperatura', 562.0000, 'ºC'),
	(303463, 145, '2015-01-01 00:12:52.000000', 'temperatura', 348.0000, 'ºC'),
	(303464, 145, '2015-01-01 00:12:53.000000', 'temperatura', 54.0000, 'ºC'),
	(303465, 145, '2015-01-01 00:12:54.000000', 'temperatura', 425.0000, 'ºC'),
	(303466, 145, '2015-01-01 00:12:55.000000', 'temperatura', 765.0000, 'ºC'),
	(303467, 145, '2015-01-01 00:12:56.000000', 'temperatura', 148.0000, 'ºC'),
	(303468, 145, '2015-01-01 00:12:57.000000', 'temperatura', 846.0000, 'ºC'),
	(303469, 145, '2015-01-01 00:12:58.000000', 'temperatura', 189.0000, 'ºC'),
	(303470, 145, '2015-01-01 00:12:59.000000', 'temperatura', 805.0000, 'ºC'),
	(303471, 145, '2015-01-01 00:13:00.000000', 'temperatura', 1057.0000, 'ºC'),
	(303472, 145, '2015-01-01 00:13:01.000000', 'temperatura', 474.0000, 'ºC'),
	(303473, 145, '2015-01-01 00:13:02.000000', 'temperatura', 396.0000, 'ºC'),
	(303474, 145, '2015-01-01 00:13:03.000000', 'temperatura', 561.0000, 'ºC'),
	(303475, 145, '2015-01-01 00:13:04.000000', 'temperatura', 418.0000, 'ºC'),
	(303476, 145, '2015-01-01 00:13:05.000000', 'temperatura', 405.0000, 'ºC'),
	(303477, 145, '2015-01-01 00:13:06.000000', 'temperatura', 775.0000, 'ºC'),
	(303478, 145, '2015-01-01 00:13:07.000000', 'temperatura', 258.0000, 'ºC'),
	(303479, 145, '2015-01-01 00:13:08.000000', 'temperatura', 166.0000, 'ºC'),
	(303480, 145, '2015-01-01 00:13:09.000000', 'temperatura', 58.0000, 'ºC'),
	(303481, 145, '2015-01-01 00:13:10.000000', 'temperatura', 992.0000, 'ºC'),
	(303482, 145, '2015-01-01 00:13:11.000000', 'temperatura', 1184.0000, 'ºC'),
	(303483, 145, '2015-01-01 00:13:12.000000', 'temperatura', 547.0000, 'ºC'),
	(303484, 145, '2015-01-01 00:13:13.000000', 'temperatura', 382.0000, 'ºC'),
	(303485, 145, '2015-01-01 00:13:14.000000', 'temperatura', 270.0000, 'ºC'),
	(303486, 145, '2015-01-01 00:13:15.000000', 'temperatura', 204.0000, 'ºC'),
	(303487, 145, '2015-01-01 00:13:16.000000', 'temperatura', 212.0000, 'ºC'),
	(303488, 145, '2015-01-01 00:13:17.000000', 'temperatura', 449.0000, 'ºC'),
	(303489, 145, '2015-01-01 00:13:18.000000', 'temperatura', 409.0000, 'ºC'),
	(303490, 145, '2015-01-01 00:13:19.000000', 'temperatura', 700.0000, 'ºC'),
	(303491, 145, '2015-01-01 00:13:20.000000', 'temperatura', 1072.0000, 'ºC'),
	(303492, 145, '2015-01-01 00:13:21.000000', 'temperatura', 863.0000, 'ºC'),
	(303493, 145, '2015-01-01 00:13:22.000000', 'temperatura', 1096.0000, 'ºC'),
	(303494, 145, '2015-01-01 00:13:23.000000', 'temperatura', 494.0000, 'ºC'),
	(303495, 145, '2015-01-01 00:13:24.000000', 'temperatura', 381.0000, 'ºC'),
	(303496, 145, '2015-01-01 00:13:25.000000', 'temperatura', 422.0000, 'ºC'),
	(303497, 145, '2015-01-01 00:13:26.000000', 'temperatura', 971.0000, 'ºC'),
	(303498, 145, '2015-01-01 00:13:27.000000', 'temperatura', 1188.0000, 'ºC'),
	(303499, 145, '2015-01-01 00:13:28.000000', 'temperatura', 627.0000, 'ºC'),
	(303500, 145, '2015-01-01 00:13:29.000000', 'temperatura', 770.0000, 'ºC'),
	(303501, 145, '2015-01-01 00:13:30.000000', 'temperatura', 771.0000, 'ºC'),
	(303502, 145, '2015-01-01 00:13:31.000000', 'temperatura', 343.0000, 'ºC'),
	(303503, 145, '2015-01-01 00:13:32.000000', 'temperatura', 606.0000, 'ºC'),
	(303504, 145, '2015-01-01 00:13:33.000000', 'temperatura', 801.0000, 'ºC'),
	(303505, 145, '2015-01-01 00:13:34.000000', 'temperatura', 985.0000, 'ºC'),
	(303506, 145, '2015-01-01 00:13:35.000000', 'temperatura', 123.0000, 'ºC'),
	(303507, 145, '2015-01-01 00:13:36.000000', 'temperatura', 63.0000, 'ºC'),
	(303508, 145, '2015-01-01 00:13:37.000000', 'temperatura', 1144.0000, 'ºC'),
	(303509, 145, '2015-01-01 00:13:38.000000', 'temperatura', 732.0000, 'ºC'),
	(303510, 145, '2015-01-01 00:13:39.000000', 'temperatura', 227.0000, 'ºC'),
	(303511, 145, '2015-01-01 00:13:40.000000', 'temperatura', 140.0000, 'ºC'),
	(303512, 145, '2015-01-01 00:13:41.000000', 'temperatura', 18.0000, 'ºC'),
	(303513, 145, '2015-01-01 00:13:42.000000', 'temperatura', 874.0000, 'ºC'),
	(303514, 145, '2015-01-01 00:13:43.000000', 'temperatura', 714.0000, 'ºC'),
	(303515, 145, '2015-01-01 00:13:44.000000', 'temperatura', 950.0000, 'ºC'),
	(303516, 145, '2015-01-01 00:13:45.000000', 'temperatura', 208.0000, 'ºC'),
	(303517, 145, '2015-01-01 00:13:46.000000', 'temperatura', 589.0000, 'ºC'),
	(303518, 145, '2015-01-01 00:13:47.000000', 'temperatura', 1121.0000, 'ºC'),
	(303519, 145, '2015-01-01 00:13:48.000000', 'temperatura', 240.0000, 'ºC'),
	(303520, 145, '2015-01-01 00:13:49.000000', 'temperatura', 239.0000, 'ºC'),
	(303521, 145, '2015-01-01 00:13:50.000000', 'temperatura', 474.0000, 'ºC'),
	(303522, 145, '2015-01-01 00:13:51.000000', 'temperatura', 452.0000, 'ºC'),
	(303523, 145, '2015-01-01 00:13:52.000000', 'temperatura', 838.0000, 'ºC'),
	(303524, 145, '2015-01-01 00:13:53.000000', 'temperatura', 434.0000, 'ºC'),
	(303525, 145, '2015-01-01 00:13:54.000000', 'temperatura', 860.0000, 'ºC'),
	(303526, 145, '2015-01-01 00:13:55.000000', 'temperatura', 595.0000, 'ºC'),
	(303527, 145, '2015-01-01 00:13:56.000000', 'temperatura', 398.0000, 'ºC'),
	(303528, 145, '2015-01-01 00:13:57.000000', 'temperatura', 206.0000, 'ºC'),
	(303529, 145, '2015-01-01 00:13:58.000000', 'temperatura', 1036.0000, 'ºC'),
	(303530, 145, '2015-01-01 00:13:59.000000', 'temperatura', 962.0000, 'ºC'),
	(303531, 145, '2015-01-01 00:14:00.000000', 'temperatura', 502.0000, 'ºC'),
	(303532, 145, '2015-01-01 00:14:01.000000', 'temperatura', 824.0000, 'ºC'),
	(303533, 145, '2015-01-01 00:14:02.000000', 'temperatura', 214.0000, 'ºC'),
	(303534, 145, '2015-01-01 00:14:03.000000', 'temperatura', 1000.0000, 'ºC'),
	(303535, 145, '2015-01-01 00:14:04.000000', 'temperatura', 757.0000, 'ºC'),
	(303536, 145, '2015-01-01 00:14:05.000000', 'temperatura', 787.0000, 'ºC'),
	(303537, 145, '2015-01-01 00:14:06.000000', 'temperatura', 465.0000, 'ºC'),
	(303538, 145, '2015-01-01 00:14:07.000000', 'temperatura', 1166.0000, 'ºC'),
	(303539, 145, '2015-01-01 00:14:08.000000', 'temperatura', 833.0000, 'ºC'),
	(303540, 145, '2015-01-01 00:14:09.000000', 'temperatura', 669.0000, 'ºC'),
	(303541, 145, '2015-01-01 00:14:10.000000', 'temperatura', 844.0000, 'ºC'),
	(303542, 145, '2015-01-01 00:14:11.000000', 'temperatura', 1017.0000, 'ºC'),
	(303543, 145, '2015-01-01 00:14:12.000000', 'temperatura', 152.0000, 'ºC'),
	(303544, 145, '2015-01-01 00:14:13.000000', 'temperatura', 108.0000, 'ºC'),
	(303545, 145, '2015-01-01 00:14:14.000000', 'temperatura', 85.0000, 'ºC'),
	(303546, 145, '2015-01-01 00:14:15.000000', 'temperatura', 101.0000, 'ºC'),
	(303547, 145, '2015-01-01 00:14:16.000000', 'temperatura', 253.0000, 'ºC'),
	(303548, 145, '2015-01-01 00:14:17.000000', 'temperatura', 961.0000, 'ºC'),
	(303549, 145, '2015-01-01 00:14:18.000000', 'temperatura', 448.0000, 'ºC'),
	(303550, 145, '2015-01-01 00:14:19.000000', 'temperatura', 555.0000, 'ºC'),
	(303551, 145, '2015-01-01 00:14:20.000000', 'temperatura', 233.0000, 'ºC'),
	(303552, 145, '2015-01-01 00:14:21.000000', 'temperatura', 701.0000, 'ºC'),
	(303553, 145, '2015-01-01 00:14:22.000000', 'temperatura', 408.0000, 'ºC'),
	(303554, 145, '2015-01-01 00:14:23.000000', 'temperatura', 1136.0000, 'ºC'),
	(303555, 145, '2015-01-01 00:14:24.000000', 'temperatura', 856.0000, 'ºC'),
	(303556, 145, '2015-01-01 00:14:25.000000', 'temperatura', 872.0000, 'ºC'),
	(303557, 145, '2015-01-01 00:14:26.000000', 'temperatura', 593.0000, 'ºC'),
	(303558, 145, '2015-01-01 00:14:27.000000', 'temperatura', 350.0000, 'ºC'),
	(303559, 145, '2015-01-01 00:14:28.000000', 'temperatura', 1172.0000, 'ºC'),
	(303560, 145, '2015-01-01 00:14:29.000000', 'temperatura', 8.0000, 'ºC'),
	(303561, 145, '2015-01-01 00:14:30.000000', 'temperatura', 128.0000, 'ºC'),
	(303562, 145, '2015-01-01 00:14:31.000000', 'temperatura', 613.0000, 'ºC'),
	(303563, 145, '2015-01-01 00:14:32.000000', 'temperatura', 285.0000, 'ºC'),
	(303564, 145, '2015-01-01 00:14:33.000000', 'temperatura', 784.0000, 'ºC'),
	(303565, 145, '2015-01-01 00:14:34.000000', 'temperatura', 666.0000, 'ºC'),
	(303566, 145, '2015-01-01 00:14:35.000000', 'temperatura', 980.0000, 'ºC'),
	(303567, 145, '2015-01-01 00:14:36.000000', 'temperatura', 502.0000, 'ºC'),
	(303568, 145, '2015-01-01 00:14:37.000000', 'temperatura', 770.0000, 'ºC'),
	(303569, 145, '2015-01-01 00:14:38.000000', 'temperatura', 1145.0000, 'ºC'),
	(303570, 145, '2015-01-01 00:14:39.000000', 'temperatura', 1014.0000, 'ºC'),
	(303571, 145, '2015-01-01 00:14:40.000000', 'temperatura', 436.0000, 'ºC'),
	(303572, 145, '2015-01-01 00:14:41.000000', 'temperatura', 338.0000, 'ºC'),
	(303573, 145, '2015-01-01 00:14:42.000000', 'temperatura', 381.0000, 'ºC'),
	(303574, 145, '2015-01-01 00:14:43.000000', 'temperatura', 895.0000, 'ºC'),
	(303575, 145, '2015-01-01 00:14:44.000000', 'temperatura', 929.0000, 'ºC'),
	(303576, 145, '2015-01-01 00:14:45.000000', 'temperatura', 763.0000, 'ºC'),
	(303577, 145, '2015-01-01 00:14:46.000000', 'temperatura', 1029.0000, 'ºC'),
	(303578, 145, '2015-01-01 00:14:47.000000', 'temperatura', 455.0000, 'ºC'),
	(303579, 145, '2015-01-01 00:14:48.000000', 'temperatura', 390.0000, 'ºC'),
	(303580, 145, '2015-01-01 00:14:49.000000', 'temperatura', 586.0000, 'ºC'),
	(303581, 145, '2015-01-01 00:14:50.000000', 'temperatura', 561.0000, 'ºC'),
	(303582, 145, '2015-01-01 00:14:51.000000', 'temperatura', 1045.0000, 'ºC'),
	(303583, 145, '2015-01-01 00:14:52.000000', 'temperatura', 1144.0000, 'ºC'),
	(303584, 145, '2015-01-01 00:14:53.000000', 'temperatura', 185.0000, 'ºC'),
	(303585, 145, '2015-01-01 00:14:54.000000', 'temperatura', 1092.0000, 'ºC'),
	(303586, 145, '2015-01-01 00:14:55.000000', 'temperatura', 108.0000, 'ºC'),
	(303587, 145, '2015-01-01 00:14:56.000000', 'temperatura', 862.0000, 'ºC'),
	(303588, 145, '2015-01-01 00:14:57.000000', 'temperatura', 387.0000, 'ºC'),
	(303589, 145, '2015-01-01 00:14:58.000000', 'temperatura', 550.0000, 'ºC'),
	(303590, 145, '2015-01-01 00:14:59.000000', 'temperatura', 390.0000, 'ºC'),
	(303591, 145, '2015-01-01 00:15:00.000000', 'temperatura', 300.0000, 'ºC'),
	(303592, 145, '2015-01-01 00:15:01.000000', 'temperatura', 329.0000, 'ºC'),
	(303593, 145, '2015-01-01 00:15:02.000000', 'temperatura', 749.0000, 'ºC'),
	(303594, 145, '2015-01-01 00:15:03.000000', 'temperatura', 356.0000, 'ºC'),
	(303595, 145, '2015-01-01 00:15:04.000000', 'temperatura', 732.0000, 'ºC'),
	(303596, 145, '2015-01-01 00:15:05.000000', 'temperatura', 195.0000, 'ºC'),
	(303597, 145, '2015-01-01 00:15:06.000000', 'temperatura', 1177.0000, 'ºC'),
	(303598, 145, '2015-01-01 00:15:07.000000', 'temperatura', 502.0000, 'ºC'),
	(303599, 145, '2015-01-01 00:15:08.000000', 'temperatura', 177.0000, 'ºC'),
	(303600, 145, '2015-01-01 00:15:09.000000', 'temperatura', 583.0000, 'ºC'),
	(303601, 145, '2015-01-01 00:15:10.000000', 'temperatura', 1182.0000, 'ºC'),
	(303602, 145, '2015-01-01 00:15:11.000000', 'temperatura', 564.0000, 'ºC'),
	(303603, 145, '2015-01-01 00:15:12.000000', 'temperatura', 471.0000, 'ºC'),
	(303604, 145, '2015-01-01 00:15:13.000000', 'temperatura', 667.0000, 'ºC'),
	(303605, 145, '2015-01-01 00:15:14.000000', 'temperatura', 721.0000, 'ºC'),
	(303606, 145, '2015-01-01 00:15:15.000000', 'temperatura', 406.0000, 'ºC'),
	(303607, 145, '2015-01-01 00:15:16.000000', 'temperatura', 1065.0000, 'ºC'),
	(303608, 145, '2015-01-01 00:15:17.000000', 'temperatura', 509.0000, 'ºC'),
	(303609, 145, '2015-01-01 00:15:18.000000', 'temperatura', 549.0000, 'ºC'),
	(303610, 145, '2015-01-01 00:15:19.000000', 'temperatura', 20.0000, 'ºC'),
	(303611, 145, '2015-01-01 00:15:20.000000', 'temperatura', 853.0000, 'ºC'),
	(303612, 145, '2015-01-01 00:15:21.000000', 'temperatura', 607.0000, 'ºC'),
	(303613, 145, '2015-01-01 00:15:22.000000', 'temperatura', 476.0000, 'ºC'),
	(303614, 145, '2015-01-01 00:15:23.000000', 'temperatura', 558.0000, 'ºC'),
	(303615, 145, '2015-01-01 00:15:24.000000', 'temperatura', 164.0000, 'ºC'),
	(303616, 145, '2015-01-01 00:15:25.000000', 'temperatura', 348.0000, 'ºC'),
	(303617, 145, '2015-01-01 00:15:26.000000', 'temperatura', 46.0000, 'ºC'),
	(303618, 145, '2015-01-01 00:15:27.000000', 'temperatura', 388.0000, 'ºC'),
	(303619, 145, '2015-01-01 00:15:28.000000', 'temperatura', 601.0000, 'ºC'),
	(303620, 145, '2015-01-01 00:15:29.000000', 'temperatura', 641.0000, 'ºC'),
	(303621, 145, '2015-01-01 00:15:30.000000', 'temperatura', 204.0000, 'ºC'),
	(303622, 145, '2015-01-01 00:15:31.000000', 'temperatura', 299.0000, 'ºC'),
	(303623, 145, '2015-01-01 00:15:32.000000', 'temperatura', 883.0000, 'ºC'),
	(303624, 145, '2015-01-01 00:15:33.000000', 'temperatura', 1117.0000, 'ºC'),
	(303625, 145, '2015-01-01 00:15:34.000000', 'temperatura', 537.0000, 'ºC'),
	(303626, 145, '2015-01-01 00:15:35.000000', 'temperatura', 533.0000, 'ºC'),
	(303627, 145, '2015-01-01 00:15:36.000000', 'temperatura', 1056.0000, 'ºC'),
	(303628, 145, '2015-01-01 00:15:37.000000', 'temperatura', 82.0000, 'ºC'),
	(303629, 145, '2015-01-01 00:15:38.000000', 'temperatura', 840.0000, 'ºC'),
	(303630, 145, '2015-01-01 00:15:39.000000', 'temperatura', 358.0000, 'ºC'),
	(303631, 145, '2015-01-01 00:15:40.000000', 'temperatura', 467.0000, 'ºC'),
	(303632, 145, '2015-01-01 00:15:41.000000', 'temperatura', 63.0000, 'ºC'),
	(303633, 145, '2015-01-01 00:15:42.000000', 'temperatura', 114.0000, 'ºC'),
	(303634, 145, '2015-01-01 00:15:43.000000', 'temperatura', 384.0000, 'ºC'),
	(303635, 145, '2015-01-01 00:15:44.000000', 'temperatura', 377.0000, 'ºC'),
	(303636, 145, '2015-01-01 00:15:45.000000', 'temperatura', 731.0000, 'ºC'),
	(303637, 145, '2015-01-01 00:15:46.000000', 'temperatura', 128.0000, 'ºC'),
	(303638, 145, '2015-01-01 00:15:47.000000', 'temperatura', 847.0000, 'ºC'),
	(303639, 145, '2015-01-01 00:15:48.000000', 'temperatura', 252.0000, 'ºC'),
	(303640, 145, '2015-01-01 00:15:49.000000', 'temperatura', 1119.0000, 'ºC'),
	(303641, 145, '2015-01-01 00:15:50.000000', 'temperatura', 40.0000, 'ºC'),
	(303642, 145, '2015-01-01 00:15:51.000000', 'temperatura', 445.0000, 'ºC'),
	(303643, 145, '2015-01-01 00:15:52.000000', 'temperatura', 904.0000, 'ºC'),
	(303644, 145, '2015-01-01 00:15:53.000000', 'temperatura', 784.0000, 'ºC'),
	(303645, 145, '2015-01-01 00:15:54.000000', 'temperatura', 10.0000, 'ºC'),
	(303646, 145, '2015-01-01 00:15:55.000000', 'temperatura', 99.0000, 'ºC'),
	(303647, 145, '2015-01-01 00:15:56.000000', 'temperatura', 466.0000, 'ºC'),
	(303648, 145, '2015-01-01 00:15:57.000000', 'temperatura', 831.0000, 'ºC'),
	(303649, 145, '2015-01-01 00:15:58.000000', 'temperatura', 359.0000, 'ºC'),
	(303650, 145, '2015-01-01 00:15:59.000000', 'temperatura', 500.0000, 'ºC'),
	(303651, 145, '2015-01-01 00:16:00.000000', 'temperatura', 227.0000, 'ºC'),
	(303652, 145, '2015-01-01 00:16:01.000000', 'temperatura', 834.0000, 'ºC'),
	(303653, 145, '2015-01-01 00:16:02.000000', 'temperatura', 1088.0000, 'ºC'),
	(303654, 145, '2015-01-01 00:16:03.000000', 'temperatura', 538.0000, 'ºC'),
	(303655, 145, '2015-01-01 00:16:04.000000', 'temperatura', 629.0000, 'ºC'),
	(303656, 145, '2015-01-01 00:16:05.000000', 'temperatura', 332.0000, 'ºC'),
	(303657, 145, '2015-01-01 00:16:06.000000', 'temperatura', 973.0000, 'ºC'),
	(303658, 145, '2015-01-01 00:16:07.000000', 'temperatura', 270.0000, 'ºC'),
	(303659, 145, '2015-01-01 00:16:08.000000', 'temperatura', 833.0000, 'ºC'),
	(303660, 145, '2015-01-01 00:16:09.000000', 'temperatura', 954.0000, 'ºC'),
	(303661, 145, '2015-01-01 00:16:10.000000', 'temperatura', 1070.0000, 'ºC'),
	(303662, 145, '2015-01-01 00:16:11.000000', 'temperatura', 92.0000, 'ºC'),
	(303663, 145, '2015-01-01 00:16:12.000000', 'temperatura', 847.0000, 'ºC'),
	(303664, 145, '2015-01-01 00:16:13.000000', 'temperatura', 362.0000, 'ºC'),
	(303665, 145, '2015-01-01 00:16:14.000000', 'temperatura', 468.0000, 'ºC'),
	(303666, 145, '2015-01-01 00:16:15.000000', 'temperatura', 53.0000, 'ºC'),
	(303667, 145, '2015-01-01 00:16:16.000000', 'temperatura', 65.0000, 'ºC'),
	(303668, 145, '2015-01-01 00:16:17.000000', 'temperatura', 164.0000, 'ºC'),
	(303669, 145, '2015-01-01 00:16:18.000000', 'temperatura', 627.0000, 'ºC'),
	(303670, 145, '2015-01-01 00:16:19.000000', 'temperatura', 243.0000, 'ºC'),
	(303671, 145, '2015-01-01 00:16:20.000000', 'temperatura', 536.0000, 'ºC'),
	(303672, 145, '2015-01-01 00:16:21.000000', 'temperatura', 748.0000, 'ºC'),
	(303673, 145, '2015-01-01 00:16:22.000000', 'temperatura', 936.0000, 'ºC'),
	(303674, 145, '2015-01-01 00:16:23.000000', 'temperatura', 36.0000, 'ºC'),
	(303675, 145, '2015-01-01 00:16:24.000000', 'temperatura', 971.0000, 'ºC'),
	(303676, 145, '2015-01-01 00:16:25.000000', 'temperatura', 1149.0000, 'ºC'),
	(303677, 145, '2015-01-01 00:16:26.000000', 'temperatura', 431.0000, 'ºC'),
	(303678, 145, '2015-01-01 00:16:27.000000', 'temperatura', 1110.0000, 'ºC'),
	(303679, 145, '2015-01-01 00:16:28.000000', 'temperatura', 658.0000, 'ºC'),
	(303680, 145, '2015-01-01 00:16:29.000000', 'temperatura', 1158.0000, 'ºC'),
	(303681, 145, '2015-01-01 00:16:30.000000', 'temperatura', 220.0000, 'ºC'),
	(303682, 145, '2015-01-01 00:16:31.000000', 'temperatura', 24.0000, 'ºC'),
	(303683, 145, '2015-01-01 00:16:32.000000', 'temperatura', 659.0000, 'ºC'),
	(303684, 145, '2015-01-01 00:16:33.000000', 'temperatura', 827.0000, 'ºC'),
	(303685, 145, '2015-01-01 00:16:34.000000', 'temperatura', 956.0000, 'ºC'),
	(303686, 145, '2015-01-01 00:16:35.000000', 'temperatura', 1102.0000, 'ºC'),
	(303687, 145, '2015-01-01 00:16:36.000000', 'temperatura', 239.0000, 'ºC'),
	(303688, 145, '2015-01-01 00:16:37.000000', 'temperatura', 293.0000, 'ºC'),
	(303689, 145, '2015-01-01 00:16:38.000000', 'temperatura', 745.0000, 'ºC'),
	(303690, 145, '2015-01-01 00:16:39.000000', 'temperatura', 449.0000, 'ºC'),
	(303691, 145, '2015-01-01 00:16:40.000000', 'temperatura', 11.0000, 'ºC'),
	(303692, 145, '2015-01-01 00:16:41.000000', 'temperatura', 1107.0000, 'ºC'),
	(303693, 145, '2015-01-01 00:16:42.000000', 'temperatura', 704.0000, 'ºC'),
	(303694, 145, '2015-01-01 00:16:43.000000', 'temperatura', 199.0000, 'ºC'),
	(303695, 145, '2015-01-01 00:16:44.000000', 'temperatura', 82.0000, 'ºC'),
	(303696, 145, '2015-01-01 00:16:45.000000', 'temperatura', 1014.0000, 'ºC'),
	(303697, 145, '2015-01-01 00:16:46.000000', 'temperatura', 24.0000, 'ºC'),
	(303698, 145, '2015-01-01 00:16:47.000000', 'temperatura', 681.0000, 'ºC'),
	(303699, 145, '2015-01-01 00:16:48.000000', 'temperatura', 931.0000, 'ºC'),
	(303700, 145, '2015-01-01 00:16:49.000000', 'temperatura', 212.0000, 'ºC'),
	(303701, 145, '2015-01-01 00:16:50.000000', 'temperatura', 668.0000, 'ºC'),
	(303702, 145, '2015-01-01 00:16:51.000000', 'temperatura', 305.0000, 'ºC'),
	(303703, 145, '2015-01-01 00:16:52.000000', 'temperatura', 721.0000, 'ºC'),
	(303704, 145, '2015-01-01 00:16:53.000000', 'temperatura', 289.0000, 'ºC'),
	(303705, 145, '2015-01-01 00:16:54.000000', 'temperatura', 486.0000, 'ºC'),
	(303706, 145, '2015-01-01 00:16:55.000000', 'temperatura', 361.0000, 'ºC'),
	(303707, 145, '2015-01-01 00:16:56.000000', 'temperatura', 347.0000, 'ºC'),
	(303708, 145, '2015-01-01 00:16:57.000000', 'temperatura', 653.0000, 'ºC'),
	(303709, 145, '2015-01-01 00:16:58.000000', 'temperatura', 1023.0000, 'ºC'),
	(303710, 145, '2015-01-01 00:16:59.000000', 'temperatura', 756.0000, 'ºC'),
	(303711, 145, '2015-01-01 00:17:00.000000', 'temperatura', 714.0000, 'ºC'),
	(303712, 145, '2015-01-01 00:17:01.000000', 'temperatura', 102.0000, 'ºC'),
	(303713, 145, '2015-01-01 00:17:02.000000', 'temperatura', 769.0000, 'ºC'),
	(303714, 145, '2015-01-01 00:17:03.000000', 'temperatura', 1140.0000, 'ºC'),
	(303715, 145, '2015-01-01 00:17:04.000000', 'temperatura', 994.0000, 'ºC'),
	(303716, 145, '2015-01-01 00:17:05.000000', 'temperatura', 350.0000, 'ºC'),
	(303717, 145, '2015-01-01 00:17:06.000000', 'temperatura', 1169.0000, 'ºC'),
	(303718, 145, '2015-01-01 00:17:07.000000', 'temperatura', 1193.0000, 'ºC'),
	(303719, 145, '2015-01-01 00:17:08.000000', 'temperatura', 60.0000, 'ºC'),
	(303720, 145, '2015-01-01 00:17:09.000000', 'temperatura', 320.0000, 'ºC'),
	(303721, 145, '2015-01-01 00:17:10.000000', 'temperatura', 222.0000, 'ºC'),
	(303722, 145, '2015-01-01 00:17:11.000000', 'temperatura', 152.0000, 'ºC'),
	(303723, 145, '2015-01-01 00:17:12.000000', 'temperatura', 94.0000, 'ºC'),
	(303724, 145, '2015-01-01 00:17:13.000000', 'temperatura', 15.0000, 'ºC'),
	(303725, 145, '2015-01-01 00:17:14.000000', 'temperatura', 991.0000, 'ºC'),
	(303726, 145, '2015-01-01 00:17:15.000000', 'temperatura', 112.0000, 'ºC'),
	(303727, 145, '2015-01-01 00:17:16.000000', 'temperatura', 1189.0000, 'ºC'),
	(303728, 145, '2015-01-01 00:17:17.000000', 'temperatura', 810.0000, 'ºC'),
	(303729, 145, '2015-01-01 00:17:18.000000', 'temperatura', 481.0000, 'ºC'),
	(303730, 145, '2015-01-01 00:17:19.000000', 'temperatura', 1177.0000, 'ºC'),
	(303731, 145, '2015-01-01 00:17:20.000000', 'temperatura', 842.0000, 'ºC'),
	(303732, 145, '2015-01-01 00:17:21.000000', 'temperatura', 681.0000, 'ºC'),
	(303733, 145, '2015-01-01 00:17:22.000000', 'temperatura', 880.0000, 'ºC'),
	(303734, 145, '2015-01-01 00:17:23.000000', 'temperatura', 1156.0000, 'ºC'),
	(303735, 145, '2015-01-01 00:17:24.000000', 'temperatura', 740.0000, 'ºC'),
	(303736, 145, '2015-01-01 00:17:25.000000', 'temperatura', 232.0000, 'ºC'),
	(303737, 145, '2015-01-01 00:17:26.000000', 'temperatura', 140.0000, 'ºC'),
	(303738, 145, '2015-01-01 00:17:27.000000', 'temperatura', 4.0000, 'ºC'),
	(303739, 145, '2015-01-01 00:17:28.000000', 'temperatura', 802.0000, 'ºC'),
	(303740, 145, '2015-01-01 00:17:29.000000', 'temperatura', 398.0000, 'ºC'),
	(303741, 145, '2015-01-01 00:17:30.000000', 'temperatura', 784.0000, 'ºC'),
	(303742, 145, '2015-01-01 00:17:31.000000', 'temperatura', 325.0000, 'ºC'),
	(303743, 145, '2015-01-01 00:17:32.000000', 'temperatura', 474.0000, 'ºC'),
	(303744, 145, '2015-01-01 00:17:33.000000', 'temperatura', 197.0000, 'ºC'),
	(303745, 145, '2015-01-01 00:17:34.000000', 'temperatura', 764.0000, 'ºC'),
	(303746, 145, '2015-01-01 00:17:35.000000', 'temperatura', 829.0000, 'ºC'),
	(303747, 145, '2015-01-01 00:17:36.000000', 'temperatura', 651.0000, 'ºC'),
	(303748, 145, '2015-01-01 00:17:37.000000', 'temperatura', 772.0000, 'ºC'),
	(303749, 145, '2015-01-01 00:17:38.000000', 'temperatura', 706.0000, 'ºC'),
	(303750, 145, '2015-01-01 00:17:39.000000', 'temperatura', 14.0000, 'ºC'),
	(303751, 145, '2015-01-01 00:17:40.000000', 'temperatura', 352.0000, 'ºC'),
	(303752, 145, '2015-01-01 00:17:41.000000', 'temperatura', 519.0000, 'ºC'),
	(303753, 145, '2015-01-01 00:17:42.000000', 'temperatura', 339.0000, 'ºC'),
	(303754, 145, '2015-01-01 00:17:43.000000', 'temperatura', 137.0000, 'ºC'),
	(303755, 145, '2015-01-01 00:17:44.000000', 'temperatura', 870.0000, 'ºC'),
	(303756, 145, '2015-01-01 00:17:45.000000', 'temperatura', 340.0000, 'ºC'),
	(303757, 145, '2015-01-01 00:17:46.000000', 'temperatura', 290.0000, 'ºC'),
	(303758, 145, '2015-01-01 00:17:47.000000', 'temperatura', 429.0000, 'ºC'),
	(303759, 145, '2015-01-01 00:17:48.000000', 'temperatura', 77.0000, 'ºC'),
	(303760, 145, '2015-01-01 00:17:49.000000', 'temperatura', 300.0000, 'ºC'),
	(303761, 145, '2015-01-01 00:17:50.000000', 'temperatura', 67.0000, 'ºC'),
	(303762, 145, '2015-01-01 00:17:51.000000', 'temperatura', 638.0000, 'ºC'),
	(303763, 145, '2015-01-01 00:17:52.000000', 'temperatura', 589.0000, 'ºC'),
	(303764, 145, '2015-01-01 00:17:53.000000', 'temperatura', 1032.0000, 'ºC'),
	(303765, 145, '2015-01-01 00:17:54.000000', 'temperatura', 994.0000, 'ºC'),
	(303766, 145, '2015-01-01 00:17:55.000000', 'temperatura', 674.0000, 'ºC'),
	(303767, 145, '2015-01-01 00:17:56.000000', 'temperatura', 388.0000, 'ºC'),
	(303768, 145, '2015-01-01 00:17:57.000000', 'temperatura', 1118.0000, 'ºC'),
	(303769, 145, '2015-01-01 00:17:58.000000', 'temperatura', 826.0000, 'ºC'),
	(303770, 145, '2015-01-01 00:17:59.000000', 'temperatura', 777.0000, 'ºC'),
	(303771, 145, '2015-01-01 00:18:00.000000', 'temperatura', 207.0000, 'ºC'),
	(303772, 145, '2015-01-01 00:18:01.000000', 'temperatura', 1106.0000, 'ºC'),
	(303773, 145, '2015-01-01 00:18:02.000000', 'temperatura', 110.0000, 'ºC'),
	(303774, 145, '2015-01-01 00:18:03.000000', 'temperatura', 832.0000, 'ºC'),
	(303775, 145, '2015-01-01 00:18:04.000000', 'temperatura', 229.0000, 'ºC'),
	(303776, 145, '2015-01-01 00:18:05.000000', 'temperatura', 1052.0000, 'ºC'),
	(303777, 145, '2015-01-01 00:18:06.000000', 'temperatura', 971.0000, 'ºC'),
	(303778, 145, '2015-01-01 00:18:07.000000', 'temperatura', 499.0000, 'ºC'),
	(303779, 145, '2015-01-01 00:18:08.000000', 'temperatura', 784.0000, 'ºC'),
	(303780, 145, '2015-01-01 00:18:09.000000', 'temperatura', 25.0000, 'ºC'),
	(303781, 145, '2015-01-01 00:18:10.000000', 'temperatura', 173.0000, 'ºC'),
	(303782, 145, '2015-01-01 00:18:11.000000', 'temperatura', 789.0000, 'ºC'),
	(303783, 145, '2015-01-01 00:18:12.000000', 'temperatura', 1026.0000, 'ºC'),
	(303784, 145, '2015-01-01 00:18:13.000000', 'temperatura', 363.0000, 'ºC'),
	(303785, 145, '2015-01-01 00:18:14.000000', 'temperatura', 1137.0000, 'ºC'),
	(303786, 145, '2015-01-01 00:18:15.000000', 'temperatura', 997.0000, 'ºC'),
	(303787, 145, '2015-01-01 00:18:16.000000', 'temperatura', 373.0000, 'ºC'),
	(303788, 145, '2015-01-01 00:18:17.000000', 'temperatura', 77.0000, 'ºC'),
	(303789, 145, '2015-01-01 00:18:18.000000', 'temperatura', 465.0000, 'ºC'),
	(303790, 145, '2015-01-01 00:18:19.000000', 'temperatura', 894.0000, 'ºC'),
	(303791, 145, '2015-01-01 00:18:20.000000', 'temperatura', 678.0000, 'ºC'),
	(303792, 145, '2015-01-01 00:18:21.000000', 'temperatura', 707.0000, 'ºC'),
	(303793, 145, '2015-01-01 00:18:22.000000', 'temperatura', 302.0000, 'ºC'),
	(303794, 145, '2015-01-01 00:18:23.000000', 'temperatura', 589.0000, 'ºC'),
	(303795, 145, '2015-01-01 00:18:24.000000', 'temperatura', 838.0000, 'ºC'),
	(303796, 145, '2015-01-01 00:18:25.000000', 'temperatura', 25.0000, 'ºC'),
	(303797, 145, '2015-01-01 00:18:26.000000', 'temperatura', 12.0000, 'ºC'),
	(303798, 145, '2015-01-01 00:18:27.000000', 'temperatura', 1186.0000, 'ºC'),
	(303799, 145, '2015-01-01 00:18:28.000000', 'temperatura', 1093.0000, 'ºC'),
	(303800, 145, '2015-01-01 00:18:29.000000', 'temperatura', 709.0000, 'ºC'),
	(303801, 145, '2015-01-01 00:18:30.000000', 'temperatura', 264.0000, 'ºC'),
	(303802, 145, '2015-01-01 00:18:31.000000', 'temperatura', 394.0000, 'ºC'),
	(303803, 145, '2015-01-01 00:18:32.000000', 'temperatura', 1179.0000, 'ºC'),
	(303804, 145, '2015-01-01 00:18:33.000000', 'temperatura', 1114.0000, 'ºC'),
	(303805, 145, '2015-01-01 00:18:34.000000', 'temperatura', 833.0000, 'ºC'),
	(303806, 145, '2015-01-01 00:18:35.000000', 'temperatura', 826.0000, 'ºC'),
	(303807, 145, '2015-01-01 00:18:36.000000', 'temperatura', 429.0000, 'ºC'),
	(303808, 145, '2015-01-01 00:18:37.000000', 'temperatura', 866.0000, 'ºC'),
	(303809, 145, '2015-01-01 00:18:38.000000', 'temperatura', 647.0000, 'ºC'),
	(303810, 145, '2015-01-01 00:18:39.000000', 'temperatura', 635.0000, 'ºC'),
	(303811, 145, '2015-01-01 00:18:40.000000', 'temperatura', 35.0000, 'ºC'),
	(303812, 145, '2015-01-01 00:18:41.000000', 'temperatura', 670.0000, 'ºC'),
	(303813, 145, '2015-01-01 00:18:42.000000', 'temperatura', 845.0000, 'ºC'),
	(303814, 145, '2015-01-01 00:18:43.000000', 'temperatura', 1016.0000, 'ºC'),
	(303815, 145, '2015-01-01 00:18:44.000000', 'temperatura', 145.0000, 'ºC'),
	(303816, 145, '2015-01-01 00:18:45.000000', 'temperatura', 79.0000, 'ºC'),
	(303817, 145, '2015-01-01 00:18:46.000000', 'temperatura', 1161.0000, 'ºC'),
	(303818, 145, '2015-01-01 00:18:47.000000', 'temperatura', 766.0000, 'ºC'),
	(303819, 145, '2015-01-01 00:18:48.000000', 'temperatura', 350.0000, 'ºC'),
	(303820, 145, '2015-01-01 00:18:49.000000', 'temperatura', 653.0000, 'ºC'),
	(303821, 145, '2015-01-01 00:18:50.000000', 'temperatura', 1014.0000, 'ºC'),
	(303822, 145, '2015-01-01 00:18:51.000000', 'temperatura', 710.0000, 'ºC'),
	(303823, 145, '2015-01-01 00:18:52.000000', 'temperatura', 510.0000, 'ºC'),
	(303824, 145, '2015-01-01 00:18:53.000000', 'temperatura', 420.0000, 'ºC'),
	(303825, 145, '2015-01-01 00:18:54.000000', 'temperatura', 570.0000, 'ºC'),
	(303826, 145, '2015-01-01 00:18:55.000000', 'temperatura', 392.0000, 'ºC'),
	(303827, 145, '2015-01-01 00:18:56.000000', 'temperatura', 251.0000, 'ºC'),
	(303828, 145, '2015-01-01 00:18:57.000000', 'temperatura', 80.0000, 'ºC'),
	(303829, 145, '2015-01-01 00:18:58.000000', 'temperatura', 849.0000, 'ºC'),
	(303830, 145, '2015-01-01 00:18:59.000000', 'temperatura', 403.0000, 'ºC'),
	(303831, 145, '2015-01-01 00:19:00.000000', 'temperatura', 667.0000, 'ºC'),
	(303832, 145, '2015-01-01 00:19:01.000000', 'temperatura', 929.0000, 'ºC'),
	(303833, 145, '2015-01-01 00:19:02.000000', 'temperatura', 244.0000, 'ºC'),
	(303834, 145, '2015-01-01 00:19:03.000000', 'temperatura', 835.0000, 'ºC'),
	(303835, 145, '2015-01-01 00:19:04.000000', 'temperatura', 1043.0000, 'ºC'),
	(303836, 145, '2015-01-01 00:19:05.000000', 'temperatura', 309.0000, 'ºC'),
	(303837, 145, '2015-01-01 00:19:06.000000', 'temperatura', 819.0000, 'ºC'),
	(303838, 145, '2015-01-01 00:19:07.000000', 'temperatura', 768.0000, 'ºC'),
	(303839, 145, '2015-01-01 00:19:08.000000', 'temperatura', 182.0000, 'ºC'),
	(303840, 145, '2015-01-01 00:19:09.000000', 'temperatura', 1008.0000, 'ºC'),
	(303841, 145, '2015-01-01 00:19:10.000000', 'temperatura', 894.0000, 'ºC'),
	(303842, 145, '2015-01-01 00:19:11.000000', 'temperatura', 247.0000, 'ºC'),
	(303843, 145, '2015-01-01 00:19:12.000000', 'temperatura', 952.0000, 'ºC'),
	(303844, 145, '2015-01-01 00:19:13.000000', 'temperatura', 421.0000, 'ºC'),
	(303845, 145, '2015-01-01 00:19:14.000000', 'temperatura', 449.0000, 'ºC'),
	(303846, 145, '2015-01-01 00:19:15.000000', 'temperatura', 984.0000, 'ºC'),
	(303847, 145, '2015-01-01 00:19:16.000000', 'temperatura', 1172.0000, 'ºC'),
	(303848, 145, '2015-01-01 00:19:17.000000', 'temperatura', 511.0000, 'ºC'),
	(303849, 145, '2015-01-01 00:19:18.000000', 'temperatura', 238.0000, 'ºC'),
	(303850, 145, '2015-01-01 00:19:19.000000', 'temperatura', 856.0000, 'ºC'),
	(303851, 145, '2015-01-01 00:19:20.000000', 'temperatura', 1169.0000, 'ºC'),
	(303852, 145, '2015-01-01 00:19:21.000000', 'temperatura', 876.0000, 'ºC'),
	(303853, 145, '2015-01-01 00:19:22.000000', 'temperatura', 874.0000, 'ºC'),
	(303854, 145, '2015-01-01 00:19:23.000000', 'temperatura', 543.0000, 'ºC'),
	(303855, 145, '2015-01-01 00:19:24.000000', 'temperatura', 95.0000, 'ºC'),
	(303856, 145, '2015-01-01 00:19:25.000000', 'temperatura', 43.0000, 'ºC'),
	(303857, 145, '2015-01-01 00:19:26.000000', 'temperatura', 1133.0000, 'ºC'),
	(303858, 145, '2015-01-01 00:19:27.000000', 'temperatura', 734.0000, 'ºC'),
	(303859, 145, '2015-01-01 00:19:28.000000', 'temperatura', 274.0000, 'ºC'),
	(303860, 145, '2015-01-01 00:19:29.000000', 'temperatura', 369.0000, 'ºC'),
	(303861, 145, '2015-01-01 00:19:30.000000', 'temperatura', 1023.0000, 'ºC'),
	(303862, 145, '2015-01-01 00:19:31.000000', 'temperatura', 407.0000, 'ºC'),
	(303863, 145, '2015-01-01 00:19:32.000000', 'temperatura', 166.0000, 'ºC'),
	(303864, 145, '2015-01-01 00:19:33.000000', 'temperatura', 811.0000, 'ºC'),
	(303865, 145, '2015-01-01 00:19:34.000000', 'temperatura', 1156.0000, 'ºC'),
	(303866, 145, '2015-01-01 00:19:35.000000', 'temperatura', 949.0000, 'ºC'),
	(303867, 145, '2015-01-01 00:19:36.000000', 'temperatura', 75.0000, 'ºC'),
	(303868, 145, '2015-01-01 00:19:37.000000', 'temperatura', 1130.0000, 'ºC'),
	(303869, 145, '2015-01-01 00:19:38.000000', 'temperatura', 626.0000, 'ºC'),
	(303870, 145, '2015-01-01 00:19:39.000000', 'temperatura', 941.0000, 'ºC'),
	(303871, 145, '2015-01-01 00:19:40.000000', 'temperatura', 428.0000, 'ºC'),
	(303872, 145, '2015-01-01 00:19:41.000000', 'temperatura', 516.0000, 'ºC'),
	(303873, 145, '2015-01-01 00:19:42.000000', 'temperatura', 96.0000, 'ºC'),
	(303874, 145, '2015-01-01 00:19:43.000000', 'temperatura', 132.0000, 'ºC'),
	(303875, 145, '2015-01-01 00:19:44.000000', 'temperatura', 372.0000, 'ºC'),
	(303876, 145, '2015-01-01 00:19:45.000000', 'temperatura', 264.0000, 'ºC'),
	(303877, 145, '2015-01-01 00:19:46.000000', 'temperatura', 203.0000, 'ºC'),
	(303878, 145, '2015-01-01 00:19:47.000000', 'temperatura', 227.0000, 'ºC'),
	(303879, 145, '2015-01-01 00:19:48.000000', 'temperatura', 526.0000, 'ºC'),
	(303880, 145, '2015-01-01 00:19:49.000000', 'temperatura', 748.0000, 'ºC'),
	(303881, 145, '2015-01-01 00:19:50.000000', 'temperatura', 963.0000, 'ºC'),
	(303882, 145, '2015-01-01 00:19:51.000000', 'temperatura', 173.0000, 'ºC'),
	(303883, 145, '2015-01-01 00:19:52.000000', 'temperatura', 374.0000, 'ºC'),
	(303884, 145, '2015-01-01 00:19:53.000000', 'temperatura', 155.0000, 'ºC'),
	(303885, 145, '2015-01-01 00:19:54.000000', 'temperatura', 850.0000, 'ºC'),
	(303886, 145, '2015-01-01 00:19:55.000000', 'temperatura', 185.0000, 'ºC'),
	(303887, 145, '2015-01-01 00:19:56.000000', 'temperatura', 778.0000, 'ºC'),
	(303888, 145, '2015-01-01 00:19:57.000000', 'temperatura', 936.0000, 'ºC'),
	(303889, 145, '2015-01-01 00:19:58.000000', 'temperatura', 1144.0000, 'ºC'),
	(303890, 145, '2015-01-01 00:19:59.000000', 'temperatura', 514.0000, 'ºC'),
	(303891, 145, '2015-01-01 00:20:00.000000', 'temperatura', 340.0000, 'ºC'),
	(303892, 145, '2015-01-01 00:20:01.000000', 'temperatura', 155.0000, 'ºC'),
	(303893, 145, '2015-01-01 00:20:02.000000', 'temperatura', 958.0000, 'ºC'),
	(303894, 145, '2015-01-01 00:20:03.000000', 'temperatura', 724.0000, 'ºC'),
	(303895, 145, '2015-01-01 00:20:04.000000', 'temperatura', 748.0000, 'ºC'),
	(303896, 145, '2015-01-01 00:20:05.000000', 'temperatura', 369.0000, 'ºC'),
	(303897, 145, '2015-01-01 00:20:06.000000', 'temperatura', 802.0000, 'ºC'),
	(303898, 145, '2015-01-01 00:20:07.000000', 'temperatura', 501.0000, 'ºC'),
	(303899, 145, '2015-01-01 00:20:08.000000', 'temperatura', 103.0000, 'ºC'),
	(303900, 145, '2015-01-01 00:20:09.000000', 'temperatura', 209.0000, 'ºC'),
	(303901, 145, '2015-01-01 00:20:10.000000', 'temperatura', 737.0000, 'ºC'),
	(303902, 145, '2015-01-01 00:20:11.000000', 'temperatura', 660.0000, 'ºC'),
	(303903, 145, '2015-01-01 00:20:12.000000', 'temperatura', 1089.0000, 'ºC'),
	(303904, 145, '2015-01-01 00:20:13.000000', 'temperatura', 1067.0000, 'ºC'),
	(303905, 145, '2015-01-01 00:20:14.000000', 'temperatura', 869.0000, 'ºC'),
	(303906, 145, '2015-01-01 00:20:15.000000', 'temperatura', 1143.0000, 'ºC'),
	(303907, 145, '2015-01-01 00:20:16.000000', 'temperatura', 709.0000, 'ºC'),
	(303908, 145, '2015-01-01 00:20:17.000000', 'temperatura', 114.0000, 'ºC'),
	(303909, 145, '2015-01-01 00:20:18.000000', 'temperatura', 846.0000, 'ºC'),
	(303910, 145, '2015-01-01 00:20:19.000000', 'temperatura', 288.0000, 'ºC'),
	(303911, 145, '2015-01-01 00:20:20.000000', 'temperatura', 101.0000, 'ºC'),
	(303912, 145, '2015-01-01 00:20:21.000000', 'temperatura', 844.0000, 'ºC'),
	(303913, 145, '2015-01-01 00:20:22.000000', 'temperatura', 315.0000, 'ºC'),
	(303914, 145, '2015-01-01 00:20:23.000000', 'temperatura', 243.0000, 'ºC'),
	(303915, 145, '2015-01-01 00:20:24.000000', 'temperatura', 270.0000, 'ºC'),
	(303916, 145, '2015-01-01 00:20:25.000000', 'temperatura', 622.0000, 'ºC'),
	(303917, 145, '2015-01-01 00:20:26.000000', 'temperatura', 1102.0000, 'ºC'),
	(303918, 145, '2015-01-01 00:20:27.000000', 'temperatura', 44.0000, 'ºC'),
	(303919, 145, '2015-01-01 00:20:28.000000', 'temperatura', 515.0000, 'ºC'),
	(303920, 145, '2015-01-01 00:20:29.000000', 'temperatura', 45.0000, 'ºC'),
	(303921, 145, '2015-01-01 00:20:30.000000', 'temperatura', 1079.0000, 'ºC'),
	(303922, 145, '2015-01-01 00:20:31.000000', 'temperatura', 459.0000, 'ºC'),
	(303923, 145, '2015-01-01 00:20:32.000000', 'temperatura', 258.0000, 'ºC'),
	(303924, 145, '2015-01-01 00:20:33.000000', 'temperatura', 1115.0000, 'ºC'),
	(303925, 145, '2015-01-01 00:20:34.000000', 'temperatura', 0.0000, 'ºC'),
	(303926, 145, '2015-01-01 00:20:35.000000', 'temperatura', 256.0000, 'ºC'),
	(303927, 145, '2015-01-01 00:20:36.000000', 'temperatura', 82.0000, 'ºC'),
	(303928, 145, '2015-01-01 00:20:37.000000', 'temperatura', 843.0000, 'ºC'),
	(303929, 145, '2015-01-01 00:20:38.000000', 'temperatura', 370.0000, 'ºC'),
	(303930, 145, '2015-01-01 00:20:39.000000', 'temperatura', 521.0000, 'ºC'),
	(303931, 145, '2015-01-01 00:20:40.000000', 'temperatura', 297.0000, 'ºC'),
	(303932, 145, '2015-01-01 00:20:41.000000', 'temperatura', 1119.0000, 'ºC'),
	(303933, 145, '2015-01-01 00:20:42.000000', 'temperatura', 1107.0000, 'ºC'),
	(303934, 145, '2015-01-01 00:20:43.000000', 'temperatura', 979.0000, 'ºC'),
	(303935, 145, '2015-01-01 00:20:44.000000', 'temperatura', 374.0000, 'ºC'),
	(303936, 145, '2015-01-01 00:20:45.000000', 'temperatura', 135.0000, 'ºC'),
	(303937, 145, '2015-01-01 00:20:46.000000', 'temperatura', 754.0000, 'ºC'),
	(303938, 145, '2015-01-01 00:20:47.000000', 'temperatura', 963.0000, 'ºC'),
	(303939, 145, '2015-01-01 00:20:48.000000', 'temperatura', 156.0000, 'ºC'),
	(303940, 145, '2015-01-01 00:20:49.000000', 'temperatura', 289.0000, 'ºC'),
	(303941, 145, '2015-01-01 00:20:50.000000', 'temperatura', 979.0000, 'ºC'),
	(303942, 145, '2015-01-01 00:20:51.000000', 'temperatura', 426.0000, 'ºC'),
	(303943, 145, '2015-01-01 00:20:52.000000', 'temperatura', 395.0000, 'ºC'),
	(303944, 145, '2015-01-01 00:20:53.000000', 'temperatura', 699.0000, 'ºC'),
	(303945, 145, '2015-01-01 00:20:54.000000', 'temperatura', 1109.0000, 'ºC'),
	(303946, 145, '2015-01-01 00:20:55.000000', 'temperatura', 1049.0000, 'ºC'),
	(303947, 145, '2015-01-01 00:20:56.000000', 'temperatura', 720.0000, 'ºC'),
	(303948, 145, '2015-01-01 00:20:57.000000', 'temperatura', 451.0000, 'ºC'),
	(303949, 145, '2015-01-01 00:20:58.000000', 'temperatura', 97.0000, 'ºC'),
	(303950, 145, '2015-01-01 00:20:59.000000', 'temperatura', 334.0000, 'ºC'),
	(303951, 145, '2015-01-01 00:21:00.000000', 'temperatura', 179.0000, 'ºC'),
	(303952, 145, '2015-01-01 00:21:01.000000', 'temperatura', 1094.0000, 'ºC'),
	(303953, 145, '2015-01-01 00:21:02.000000', 'temperatura', 134.0000, 'ºC'),
	(303954, 145, '2015-01-01 00:21:03.000000', 'temperatura', 986.0000, 'ºC'),
	(303955, 145, '2015-01-01 00:21:04.000000', 'temperatura', 928.0000, 'ºC'),
	(303956, 145, '2015-01-01 00:21:05.000000', 'temperatura', 484.0000, 'ºC'),
	(303957, 145, '2015-01-01 00:21:06.000000', 'temperatura', 836.0000, 'ºC'),
	(303958, 145, '2015-01-01 00:21:07.000000', 'temperatura', 330.0000, 'ºC'),
	(303959, 145, '2015-01-01 00:21:08.000000', 'temperatura', 343.0000, 'ºC'),
	(303960, 145, '2015-01-01 00:21:09.000000', 'temperatura', 725.0000, 'ºC'),
	(303961, 145, '2015-01-01 00:21:10.000000', 'temperatura', 195.0000, 'ºC'),
	(303962, 145, '2015-01-01 00:21:11.000000', 'temperatura', 1199.0000, 'ºC'),
	(303963, 145, '2015-01-01 00:21:12.000000', 'temperatura', 614.0000, 'ºC'),
	(303964, 145, '2015-01-01 00:21:13.000000', 'temperatura', 672.0000, 'ºC'),
	(303965, 145, '2015-01-01 00:21:14.000000', 'temperatura', 321.0000, 'ºC'),
	(303966, 145, '2015-01-01 00:21:15.000000', 'temperatura', 787.0000, 'ºC'),
	(303967, 145, '2015-01-01 00:21:16.000000', 'temperatura', 572.0000, 'ºC'),
	(303968, 145, '2015-01-01 00:21:17.000000', 'temperatura', 500.0000, 'ºC'),
	(303969, 145, '2015-01-01 00:21:18.000000', 'temperatura', 783.0000, 'ºC'),
	(303970, 145, '2015-01-01 00:21:19.000000', 'temperatura', 17.0000, 'ºC'),
	(303971, 145, '2015-01-01 00:21:20.000000', 'temperatura', 136.0000, 'ºC'),
	(303972, 145, '2015-01-01 00:21:21.000000', 'temperatura', 629.0000, 'ºC'),
	(303973, 145, '2015-01-01 00:21:22.000000', 'temperatura', 336.0000, 'ºC'),
	(303974, 145, '2015-01-01 00:21:23.000000', 'temperatura', 996.0000, 'ºC'),
	(303975, 145, '2015-01-01 00:21:24.000000', 'temperatura', 371.0000, 'ºC'),
	(303976, 145, '2015-01-01 00:21:25.000000', 'temperatura', 67.0000, 'ºC'),
	(303977, 145, '2015-01-01 00:21:26.000000', 'temperatura', 424.0000, 'ºC'),
	(303978, 145, '2015-01-01 00:21:27.000000', 'temperatura', 718.0000, 'ºC'),
	(303979, 145, '2015-01-01 00:21:28.000000', 'temperatura', 1118.0000, 'ºC'),
	(303980, 145, '2015-01-01 00:21:29.000000', 'temperatura', 1039.0000, 'ºC'),
	(303981, 145, '2015-01-01 00:21:30.000000', 'temperatura', 641.0000, 'ºC'),
	(303982, 145, '2015-01-01 00:21:31.000000', 'temperatura', 87.0000, 'ºC'),
	(303983, 145, '2015-01-01 00:21:32.000000', 'temperatura', 915.0000, 'ºC'),
	(303984, 145, '2015-01-01 00:21:33.000000', 'temperatura', 712.0000, 'ºC'),
	(303985, 145, '2015-01-01 00:21:34.000000', 'temperatura', 817.0000, 'ºC'),
	(303986, 145, '2015-01-01 00:21:35.000000', 'temperatura', 747.0000, 'ºC'),
	(303987, 145, '2015-01-01 00:21:36.000000', 'temperatura', 87.0000, 'ºC'),
	(303988, 145, '2015-01-01 00:21:37.000000', 'temperatura', 593.0000, 'ºC'),
	(303989, 145, '2015-01-01 00:21:38.000000', 'temperatura', 304.0000, 'ºC'),
	(303990, 145, '2015-01-01 00:21:39.000000', 'temperatura', 941.0000, 'ºC'),
	(303991, 145, '2015-01-01 00:21:40.000000', 'temperatura', 194.0000, 'ºC'),
	(303992, 145, '2015-01-01 00:21:41.000000', 'temperatura', 549.0000, 'ºC'),
	(303993, 145, '2015-01-01 00:21:42.000000', 'temperatura', 961.0000, 'ºC'),
	(303994, 145, '2015-01-01 00:21:43.000000', 'temperatura', 758.0000, 'ºC'),
	(303995, 145, '2015-01-01 00:21:44.000000', 'temperatura', 908.0000, 'ºC'),
	(303996, 145, '2015-01-01 00:21:45.000000', 'temperatura', 1066.0000, 'ºC'),
	(303997, 145, '2015-01-01 00:21:46.000000', 'temperatura', 208.0000, 'ºC'),
	(303998, 145, '2015-01-01 00:21:47.000000', 'temperatura', 242.0000, 'ºC'),
	(303999, 145, '2015-01-01 00:21:48.000000', 'temperatura', 586.0000, 'ºC'),
	(304000, 145, '2015-01-01 00:21:49.000000', 'temperatura', 1004.0000, 'ºC'),
	(304001, 145, '2015-01-01 00:21:50.000000', 'temperatura', 865.0000, 'ºC'),
	(304002, 145, '2015-01-01 00:21:51.000000', 'temperatura', 112.0000, 'ºC'),
	(304003, 145, '2015-01-01 00:21:52.000000', 'temperatura', 364.0000, 'ºC'),
	(304004, 145, '2015-01-01 00:21:53.000000', 'temperatura', 285.0000, 'ºC'),
	(304005, 145, '2015-01-01 00:21:54.000000', 'temperatura', 332.0000, 'ºC'),
	(304006, 145, '2015-01-01 00:21:55.000000', 'temperatura', 808.0000, 'ºC'),
	(304007, 145, '2015-01-01 00:21:56.000000', 'temperatura', 644.0000, 'ºC'),
	(304008, 145, '2015-01-01 00:21:57.000000', 'temperatura', 798.0000, 'ºC'),
	(304009, 145, '2015-01-01 00:21:58.000000', 'temperatura', 858.0000, 'ºC'),
	(304010, 145, '2015-01-01 00:21:59.000000', 'temperatura', 695.0000, 'ºC'),
	(304011, 145, '2015-01-01 00:22:00.000000', 'temperatura', 904.0000, 'ºC'),
	(304012, 145, '2015-01-01 00:22:01.000000', 'temperatura', 35.0000, 'ºC'),
	(304013, 145, '2015-01-01 00:22:02.000000', 'temperatura', 1062.0000, 'ºC'),
	(304014, 145, '2015-01-01 00:22:03.000000', 'temperatura', 408.0000, 'ºC'),
	(304015, 145, '2015-01-01 00:22:04.000000', 'temperatura', 52.0000, 'ºC'),
	(304016, 145, '2015-01-01 00:22:05.000000', 'temperatura', 236.0000, 'ºC'),
	(304017, 145, '2015-01-01 00:22:06.000000', 'temperatura', 1025.0000, 'ºC'),
	(304018, 145, '2015-01-01 00:22:07.000000', 'temperatura', 818.0000, 'ºC'),
	(304019, 145, '2015-01-01 00:22:08.000000', 'temperatura', 1015.0000, 'ºC'),
	(304020, 145, '2015-01-01 00:22:09.000000', 'temperatura', 222.0000, 'ºC'),
	(304021, 145, '2015-01-01 00:22:10.000000', 'temperatura', 464.0000, 'ºC'),
	(304022, 145, '2015-01-01 00:22:11.000000', 'temperatura', 456.0000, 'ºC'),
	(304023, 145, '2015-01-01 00:22:12.000000', 'temperatura', 888.0000, 'ºC'),
	(304024, 145, '2015-01-01 00:22:13.000000', 'temperatura', 673.0000, 'ºC'),
	(304025, 145, '2015-01-01 00:22:14.000000', 'temperatura', 700.0000, 'ºC'),
	(304026, 145, '2015-01-01 00:22:15.000000', 'temperatura', 283.0000, 'ºC'),
	(304027, 145, '2015-01-01 00:22:16.000000', 'temperatura', 517.0000, 'ºC'),
	(304028, 145, '2015-01-01 00:22:17.000000', 'temperatura', 535.0000, 'ºC'),
	(304029, 145, '2015-01-01 00:22:18.000000', 'temperatura', 1123.0000, 'ºC'),
	(304030, 145, '2015-01-01 00:22:19.000000', 'temperatura', 412.0000, 'ºC'),
	(304031, 145, '2015-01-01 00:22:20.000000', 'temperatura', 1093.0000, 'ºC'),
	(304032, 145, '2015-01-01 00:22:21.000000', 'temperatura', 629.0000, 'ºC'),
	(304033, 145, '2015-01-01 00:22:22.000000', 'temperatura', 1066.0000, 'ºC'),
	(304034, 145, '2015-01-01 00:22:23.000000', 'temperatura', 1042.0000, 'ºC'),
	(304035, 145, '2015-01-01 00:22:24.000000', 'temperatura', 813.0000, 'ºC'),
	(304036, 145, '2015-01-01 00:22:25.000000', 'temperatura', 940.0000, 'ºC'),
	(304037, 145, '2015-01-01 00:22:26.000000', 'temperatura', 1063.0000, 'ºC'),
	(304038, 145, '2015-01-01 00:22:27.000000', 'temperatura', 96.0000, 'ºC'),
	(304039, 145, '2015-01-01 00:22:28.000000', 'temperatura', 892.0000, 'ºC'),
	(304040, 145, '2015-01-01 00:22:29.000000', 'temperatura', 572.0000, 'ºC'),
	(304041, 145, '2015-01-01 00:22:30.000000', 'temperatura', 185.0000, 'ºC'),
	(304042, 145, '2015-01-01 00:22:31.000000', 'temperatura', 407.0000, 'ºC'),
	(304043, 145, '2015-01-01 00:22:32.000000', 'temperatura', 281.0000, 'ºC'),
	(304044, 145, '2015-01-01 00:22:33.000000', 'temperatura', 186.0000, 'ºC'),
	(304045, 145, '2015-01-01 00:22:34.000000', 'temperatura', 85.0000, 'ºC'),
	(304046, 145, '2015-01-01 00:22:35.000000', 'temperatura', 1068.0000, 'ºC'),
	(304047, 145, '2015-01-01 00:22:36.000000', 'temperatura', 286.0000, 'ºC'),
	(304048, 145, '2015-01-01 00:22:37.000000', 'temperatura', 626.0000, 'ºC'),
	(304049, 145, '2015-01-01 00:22:38.000000', 'temperatura', 1072.0000, 'ºC'),
	(304050, 145, '2015-01-01 00:22:39.000000', 'temperatura', 1083.0000, 'ºC'),
	(304051, 145, '2015-01-01 00:22:40.000000', 'temperatura', 998.0000, 'ºC'),
	(304052, 145, '2015-01-01 00:22:41.000000', 'temperatura', 544.0000, 'ºC'),
	(304053, 145, '2015-01-01 00:22:42.000000', 'temperatura', 925.0000, 'ºC'),
	(304054, 145, '2015-01-01 00:22:43.000000', 'temperatura', 593.0000, 'ºC'),
	(304055, 145, '2015-01-01 00:22:44.000000', 'temperatura', 189.0000, 'ºC'),
	(304056, 145, '2015-01-01 00:22:45.000000', 'temperatura', 368.0000, 'ºC'),
	(304057, 145, '2015-01-01 00:22:46.000000', 'temperatura', 75.0000, 'ºC'),
	(304058, 145, '2015-01-01 00:22:47.000000', 'temperatura', 472.0000, 'ºC'),
	(304059, 145, '2015-01-01 00:22:48.000000', 'temperatura', 934.0000, 'ºC'),
	(304060, 145, '2015-01-01 00:22:49.000000', 'temperatura', 853.0000, 'ºC'),
	(304061, 145, '2015-01-01 00:22:50.000000', 'temperatura', 264.0000, 'ºC'),
	(304062, 145, '2015-01-01 00:22:51.000000', 'temperatura', 1161.0000, 'ºC'),
	(304063, 145, '2015-01-01 00:22:52.000000', 'temperatura', 216.0000, 'ºC'),
	(304064, 145, '2015-01-01 00:22:53.000000', 'temperatura', 1194.0000, 'ºC'),
	(304065, 145, '2015-01-01 00:22:54.000000', 'temperatura', 526.0000, 'ºC'),
	(304066, 145, '2015-01-01 00:22:55.000000', 'temperatura', 247.0000, 'ºC'),
	(304067, 145, '2015-01-01 00:22:56.000000', 'temperatura', 856.0000, 'ºC'),
	(304068, 145, '2015-01-01 00:22:57.000000', 'temperatura', 1142.0000, 'ºC'),
	(304069, 145, '2015-01-01 00:22:58.000000', 'temperatura', 740.0000, 'ºC'),
	(304070, 145, '2015-01-01 00:22:59.000000', 'temperatura', 277.0000, 'ºC'),
	(304071, 145, '2015-01-01 00:23:00.000000', 'temperatura', 366.0000, 'ºC'),
	(304072, 145, '2015-01-01 00:23:01.000000', 'temperatura', 997.0000, 'ºC'),
	(304073, 145, '2015-01-01 00:23:02.000000', 'temperatura', 287.0000, 'ºC'),
	(304074, 145, '2015-01-01 00:23:03.000000', 'temperatura', 846.0000, 'ºC'),
	(304075, 145, '2015-01-01 00:23:04.000000', 'temperatura', 970.0000, 'ºC'),
	(304076, 145, '2015-01-01 00:23:05.000000', 'temperatura', 1114.0000, 'ºC'),
	(304077, 145, '2015-01-01 00:23:06.000000', 'temperatura', 259.0000, 'ºC'),
	(304078, 145, '2015-01-01 00:23:07.000000', 'temperatura', 353.0000, 'ºC'),
	(304079, 145, '2015-01-01 00:23:08.000000', 'temperatura', 990.0000, 'ºC'),
	(304080, 145, '2015-01-01 00:23:09.000000', 'temperatura', 289.0000, 'ºC'),
	(304081, 145, '2015-01-01 00:23:10.000000', 'temperatura', 877.0000, 'ºC'),
	(304082, 145, '2015-01-01 00:23:11.000000', 'temperatura', 1120.0000, 'ºC'),
	(304083, 145, '2015-01-01 00:23:12.000000', 'temperatura', 567.0000, 'ºC'),
	(304084, 145, '2015-01-01 00:23:13.000000', 'temperatura', 678.0000, 'ºC'),
	(304085, 145, '2015-01-01 00:23:14.000000', 'temperatura', 489.0000, 'ºC'),
	(304086, 145, '2015-01-01 00:23:15.000000', 'temperatura', 412.0000, 'ºC'),
	(304087, 145, '2015-01-01 00:23:16.000000', 'temperatura', 593.0000, 'ºC'),
	(304088, 145, '2015-01-01 00:23:17.000000', 'temperatura', 528.0000, 'ºC'),
	(304089, 145, '2015-01-01 00:23:18.000000', 'temperatura', 862.0000, 'ºC'),
	(304090, 145, '2015-01-01 00:23:19.000000', 'temperatura', 329.0000, 'ºC'),
	(304091, 145, '2015-01-01 00:23:20.000000', 'temperatura', 257.0000, 'ºC'),
	(304092, 145, '2015-01-01 00:23:21.000000', 'temperatura', 298.0000, 'ºC'),
	(304093, 145, '2015-01-01 00:23:22.000000', 'temperatura', 719.0000, 'ºC'),
	(304094, 145, '2015-01-01 00:23:23.000000', 'temperatura', 302.0000, 'ºC'),
	(304095, 145, '2015-01-01 00:23:24.000000', 'temperatura', 553.0000, 'ºC'),
	(304096, 145, '2015-01-01 00:23:25.000000', 'temperatura', 658.0000, 'ºC'),
	(304097, 145, '2015-01-01 00:23:26.000000', 'temperatura', 434.0000, 'ºC'),
	(304098, 145, '2015-01-01 00:23:27.000000', 'temperatura', 194.0000, 'ºC'),
	(304099, 145, '2015-01-01 00:23:28.000000', 'temperatura', 868.0000, 'ºC'),
	(304100, 145, '2015-01-01 00:23:29.000000', 'temperatura', 162.0000, 'ºC'),
	(304101, 145, '2015-01-01 00:23:30.000000', 'temperatura', 603.0000, 'ºC'),
	(304102, 145, '2015-01-01 00:23:31.000000', 'temperatura', 132.0000, 'ºC'),
	(304103, 145, '2015-01-01 00:23:32.000000', 'temperatura', 50.0000, 'ºC'),
	(304104, 145, '2015-01-01 00:23:33.000000', 'temperatura', 1054.0000, 'ºC'),
	(304105, 145, '2015-01-01 00:23:34.000000', 'temperatura', 323.0000, 'ºC'),
	(304106, 145, '2015-01-01 00:23:35.000000', 'temperatura', 852.0000, 'ºC'),
	(304107, 145, '2015-01-01 00:23:36.000000', 'temperatura', 891.0000, 'ºC'),
	(304108, 145, '2015-01-01 00:23:37.000000', 'temperatura', 698.0000, 'ºC'),
	(304109, 145, '2015-01-01 00:23:38.000000', 'temperatura', 820.0000, 'ºC'),
	(304110, 145, '2015-01-01 00:23:39.000000', 'temperatura', 808.0000, 'ºC'),
	(304111, 145, '2015-01-01 00:23:40.000000', 'temperatura', 378.0000, 'ºC'),
	(304112, 145, '2015-01-01 00:23:41.000000', 'temperatura', 666.0000, 'ºC'),
	(304113, 145, '2015-01-01 00:23:42.000000', 'temperatura', 996.0000, 'ºC'),
	(304114, 145, '2015-01-01 00:23:43.000000', 'temperatura', 581.0000, 'ºC'),
	(304115, 145, '2015-01-01 00:23:44.000000', 'temperatura', 1121.0000, 'ºC'),
	(304116, 145, '2015-01-01 00:23:45.000000', 'temperatura', 261.0000, 'ºC'),
	(304117, 145, '2015-01-01 00:23:46.000000', 'temperatura', 341.0000, 'ºC'),
	(304118, 145, '2015-01-01 00:23:47.000000', 'temperatura', 923.0000, 'ºC'),
	(304119, 145, '2015-01-01 00:23:48.000000', 'temperatura', 1192.0000, 'ºC'),
	(304120, 145, '2015-01-01 00:23:49.000000', 'temperatura', 793.0000, 'ºC'),
	(304121, 145, '2015-01-01 00:23:50.000000', 'temperatura', 391.0000, 'ºC'),
	(304122, 145, '2015-01-01 00:23:51.000000', 'temperatura', 773.0000, 'ºC'),
	(304123, 145, '2015-01-01 00:23:52.000000', 'temperatura', 296.0000, 'ºC'),
	(304124, 145, '2015-01-01 00:23:53.000000', 'temperatura', 359.0000, 'ºC'),
	(304125, 145, '2015-01-01 00:23:54.000000', 'temperatura', 907.0000, 'ºC'),
	(304126, 145, '2015-01-01 00:23:55.000000', 'temperatura', 1058.0000, 'ºC'),
	(304127, 145, '2015-01-01 00:23:56.000000', 'temperatura', 171.0000, 'ºC'),
	(304128, 145, '2015-01-01 00:23:57.000000', 'temperatura', 81.0000, 'ºC'),
	(304129, 145, '2015-01-01 00:23:58.000000', 'temperatura', 1093.0000, 'ºC'),
	(304130, 145, '2015-01-01 00:23:59.000000', 'temperatura', 423.0000, 'ºC'),
	(304131, 145, '2015-01-01 00:24:00.000000', 'temperatura', 34.0000, 'ºC'),
	(304132, 145, '2015-01-01 00:24:01.000000', 'temperatura', 104.0000, 'ºC'),
	(304133, 145, '2015-01-01 00:24:02.000000', 'temperatura', 416.0000, 'ºC'),
	(304134, 145, '2015-01-01 00:24:03.000000', 'temperatura', 571.0000, 'ºC'),
	(304135, 145, '2015-01-01 00:24:04.000000', 'temperatura', 408.0000, 'ºC'),
	(304136, 145, '2015-01-01 00:24:05.000000', 'temperatura', 326.0000, 'ºC'),
	(304137, 145, '2015-01-01 00:24:06.000000', 'temperatura', 408.0000, 'ºC'),
	(304138, 145, '2015-01-01 00:24:07.000000', 'temperatura', 1062.0000, 'ºC'),
	(304139, 145, '2015-01-01 00:24:08.000000', 'temperatura', 485.0000, 'ºC'),
	(304140, 145, '2015-01-01 00:24:09.000000', 'temperatura', 440.0000, 'ºC'),
	(304141, 145, '2015-01-01 00:24:10.000000', 'temperatura', 746.0000, 'ºC'),
	(304142, 145, '2015-01-01 00:24:11.000000', 'temperatura', 12.0000, 'ºC'),
	(304143, 145, '2015-01-01 00:24:12.000000', 'temperatura', 222.0000, 'ºC'),
	(304144, 145, '2015-01-01 00:24:13.000000', 'temperatura', 1074.0000, 'ºC'),
	(304145, 145, '2015-01-01 00:24:14.000000', 'temperatura', 1103.0000, 'ºC'),
	(304146, 145, '2015-01-01 00:24:15.000000', 'temperatura', 1096.0000, 'ºC'),
	(304147, 145, '2015-01-01 00:24:16.000000', 'temperatura', 972.0000, 'ºC'),
	(304148, 145, '2015-01-01 00:24:17.000000', 'temperatura', 369.0000, 'ºC'),
	(304149, 145, '2015-01-01 00:24:18.000000', 'temperatura', 133.0000, 'ºC'),
	(304150, 145, '2015-01-01 00:24:19.000000', 'temperatura', 759.0000, 'ºC'),
	(304151, 145, '2015-01-01 00:24:20.000000', 'temperatura', 994.0000, 'ºC'),
	(304152, 145, '2015-01-01 00:24:21.000000', 'temperatura', 294.0000, 'ºC'),
	(304153, 145, '2015-01-01 00:24:22.000000', 'temperatura', 889.0000, 'ºC'),
	(304154, 145, '2015-01-01 00:24:23.000000', 'temperatura', 1165.0000, 'ºC'),
	(304155, 145, '2015-01-01 00:24:24.000000', 'temperatura', 757.0000, 'ºC'),
	(304156, 145, '2015-01-01 00:24:25.000000', 'temperatura', 293.0000, 'ºC'),
	(304157, 145, '2015-01-01 00:24:26.000000', 'temperatura', 392.0000, 'ºC'),
	(304158, 145, '2015-01-01 00:24:27.000000', 'temperatura', 1083.0000, 'ºC'),
	(304159, 145, '2015-01-01 00:24:28.000000', 'temperatura', 637.0000, 'ºC'),
	(304160, 145, '2015-01-01 00:24:29.000000', 'temperatura', 1139.0000, 'ºC'),
	(304161, 145, '2015-01-01 00:24:30.000000', 'temperatura', 183.0000, 'ºC'),
	(304162, 145, '2015-01-01 00:24:31.000000', 'temperatura', 1100.0000, 'ºC'),
	(304163, 145, '2015-01-01 00:24:32.000000', 'temperatura', 150.0000, 'ºC'),
	(304164, 145, '2015-01-01 00:24:33.000000', 'temperatura', 1052.0000, 'ºC'),
	(304165, 145, '2015-01-01 00:24:34.000000', 'temperatura', 8.0000, 'ºC'),
	(304166, 145, '2015-01-01 00:24:35.000000', 'temperatura', 485.0000, 'ºC'),
	(304167, 145, '2015-01-01 00:24:36.000000', 'temperatura', 2.0000, 'ºC'),
	(304168, 145, '2015-01-01 00:24:37.000000', 'temperatura', 958.0000, 'ºC'),
	(304169, 145, '2015-01-01 00:24:38.000000', 'temperatura', 1181.0000, 'ºC'),
	(304170, 145, '2015-01-01 00:24:39.000000', 'temperatura', 631.0000, 'ºC'),
	(304171, 145, '2015-01-01 00:24:40.000000', 'temperatura', 815.0000, 'ºC'),
	(304172, 145, '2015-01-01 00:24:41.000000', 'temperatura', 981.0000, 'ºC'),
	(304173, 145, '2015-01-01 00:24:42.000000', 'temperatura', 63.0000, 'ºC'),
	(304174, 145, '2015-01-01 00:24:43.000000', 'temperatura', 971.0000, 'ºC'),
	(304175, 145, '2015-01-01 00:24:44.000000', 'temperatura', 1066.0000, 'ºC'),
	(304176, 145, '2015-01-01 00:24:45.000000', 'temperatura', 19.0000, 'ºC'),
	(304177, 145, '2015-01-01 00:24:46.000000', 'temperatura', 499.0000, 'ºC'),
	(304178, 145, '2015-01-01 00:24:47.000000', 'temperatura', 36.0000, 'ºC'),
	(304179, 145, '2015-01-01 00:24:48.000000', 'temperatura', 1084.0000, 'ºC'),
	(304180, 145, '2015-01-01 00:24:49.000000', 'temperatura', 511.0000, 'ºC'),
	(304181, 145, '2015-01-01 00:24:50.000000', 'temperatura', 503.0000, 'ºC'),
	(304182, 145, '2015-01-01 00:24:51.000000', 'temperatura', 984.0000, 'ºC'),
	(304183, 145, '2015-01-01 00:24:52.000000', 'temperatura', 1011.0000, 'ºC'),
	(304184, 145, '2015-01-01 00:24:53.000000', 'temperatura', 904.0000, 'ºC'),
	(304185, 145, '2015-01-01 00:24:54.000000', 'temperatura', 286.0000, 'ºC'),
	(304186, 145, '2015-01-01 00:24:55.000000', 'temperatura', 1121.0000, 'ºC'),
	(304187, 145, '2015-01-01 00:24:56.000000', 'temperatura', 1146.0000, 'ºC'),
	(304188, 145, '2015-01-01 00:24:57.000000', 'temperatura', 1168.0000, 'ºC'),
	(304189, 145, '2015-01-01 00:24:58.000000', 'temperatura', 4.0000, 'ºC'),
	(304190, 145, '2015-01-01 00:24:59.000000', 'temperatura', 114.0000, 'ºC'),
	(304191, 145, '2015-01-01 00:25:00.000000', 'temperatura', 561.0000, 'ºC'),
	(304192, 145, '2015-01-01 00:25:01.000000', 'temperatura', 64.0000, 'ºC'),
	(304193, 145, '2015-01-01 00:25:02.000000', 'temperatura', 1037.0000, 'ºC'),
	(304194, 145, '2015-01-01 00:25:03.000000', 'temperatura', 193.0000, 'ºC'),
	(304195, 145, '2015-01-01 00:25:04.000000', 'temperatura', 256.0000, 'ºC'),
	(304196, 145, '2015-01-01 00:25:05.000000', 'temperatura', 702.0000, 'ºC'),
	(304197, 145, '2015-01-01 00:25:06.000000', 'temperatura', 343.0000, 'ºC'),
	(304198, 145, '2015-01-01 00:25:07.000000', 'temperatura', 808.0000, 'ºC'),
	(304199, 145, '2015-01-01 00:25:08.000000', 'temperatura', 610.0000, 'ºC'),
	(304200, 145, '2015-01-01 00:25:09.000000', 'temperatura', 628.0000, 'ºC'),
	(304201, 145, '2015-01-01 00:25:10.000000', 'temperatura', 110.0000, 'ºC'),
	(304202, 145, '2015-01-01 00:25:11.000000', 'temperatura', 1067.0000, 'ºC'),
	(304203, 145, '2015-01-01 00:25:12.000000', 'temperatura', 204.0000, 'ºC'),
	(304204, 145, '2015-01-01 00:25:13.000000', 'temperatura', 222.0000, 'ºC'),
	(304205, 145, '2015-01-01 00:25:14.000000', 'temperatura', 496.0000, 'ºC'),
	(304206, 145, '2015-01-01 00:25:15.000000', 'temperatura', 615.0000, 'ºC'),
	(304207, 145, '2015-01-01 00:25:16.000000', 'temperatura', 388.0000, 'ºC'),
	(304208, 145, '2015-01-01 00:25:17.000000', 'temperatura', 95.0000, 'ºC'),
	(304209, 145, '2015-01-01 00:25:18.000000', 'temperatura', 513.0000, 'ºC'),
	(304210, 145, '2015-01-01 00:25:19.000000', 'temperatura', 1080.0000, 'ºC'),
	(304211, 145, '2015-01-01 00:25:20.000000', 'temperatura', 262.0000, 'ºC'),
	(304212, 145, '2015-01-01 00:25:21.000000', 'temperatura', 470.0000, 'ºC'),
	(304213, 145, '2015-01-01 00:25:22.000000', 'temperatura', 365.0000, 'ºC'),
	(304214, 145, '2015-01-01 00:25:23.000000', 'temperatura', 414.0000, 'ºC'),
	(304215, 145, '2015-01-01 00:25:24.000000', 'temperatura', 977.0000, 'ºC'),
	(304216, 145, '2015-01-01 00:25:25.000000', 'temperatura', 43.0000, 'ºC'),
	(304217, 145, '2015-01-01 00:25:26.000000', 'temperatura', 885.0000, 'ºC'),
	(304218, 145, '2015-01-01 00:25:27.000000', 'temperatura', 698.0000, 'ºC'),
	(304219, 145, '2015-01-01 00:25:28.000000', 'temperatura', 833.0000, 'ºC'),
	(304220, 145, '2015-01-01 00:25:29.000000', 'temperatura', 874.0000, 'ºC'),
	(304221, 145, '2015-01-01 00:25:30.000000', 'temperatura', 670.0000, 'ºC'),
	(304222, 145, '2015-01-01 00:25:31.000000', 'temperatura', 729.0000, 'ºC'),
	(304223, 145, '2015-01-01 00:25:32.000000', 'temperatura', 434.0000, 'ºC'),
	(304224, 145, '2015-01-01 00:25:33.000000', 'temperatura', 1184.0000, 'ºC'),
	(304225, 145, '2015-01-01 00:25:34.000000', 'temperatura', 1019.0000, 'ºC'),
	(304226, 145, '2015-01-01 00:25:35.000000', 'temperatura', 344.0000, 'ºC'),
	(304227, 145, '2015-01-01 00:25:36.000000', 'temperatura', 1064.0000, 'ºC'),
	(304228, 145, '2015-01-01 00:25:37.000000', 'temperatura', 689.0000, 'ºC'),
	(304229, 145, '2015-01-01 00:25:38.000000', 'temperatura', 251.0000, 'ºC'),
	(304230, 145, '2015-01-01 00:25:39.000000', 'temperatura', 392.0000, 'ºC'),
	(304231, 145, '2015-01-01 00:25:40.000000', 'temperatura', 4.0000, 'ºC'),
	(304232, 145, '2015-01-01 00:25:41.000000', 'temperatura', 46.0000, 'ºC'),
	(304233, 145, '2015-01-01 00:25:42.000000', 'temperatura', 220.0000, 'ºC'),
	(304234, 145, '2015-01-01 00:25:43.000000', 'temperatura', 961.0000, 'ºC'),
	(304235, 145, '2015-01-01 00:25:44.000000', 'temperatura', 544.0000, 'ºC'),
	(304236, 145, '2015-01-01 00:25:45.000000', 'temperatura', 1039.0000, 'ºC'),
	(304237, 145, '2015-01-01 00:25:46.000000', 'temperatura', 1161.0000, 'ºC'),
	(304238, 145, '2015-01-01 00:25:47.000000', 'temperatura', 291.0000, 'ºC'),
	(304239, 145, '2015-01-01 00:25:48.000000', 'temperatura', 373.0000, 'ºC'),
	(304240, 145, '2015-01-01 00:25:49.000000', 'temperatura', 992.0000, 'ºC'),
	(304241, 145, '2015-01-01 00:25:50.000000', 'temperatura', 242.0000, 'ºC'),
	(304242, 145, '2015-01-01 00:25:51.000000', 'temperatura', 632.0000, 'ºC'),
	(304243, 145, '2015-01-01 00:25:52.000000', 'temperatura', 36.0000, 'ºC'),
	(304244, 145, '2015-01-01 00:25:53.000000', 'temperatura', 686.0000, 'ºC'),
	(304245, 145, '2015-01-01 00:25:54.000000', 'temperatura', 921.0000, 'ºC'),
	(304246, 145, '2015-01-01 00:25:55.000000', 'temperatura', 146.0000, 'ºC'),
	(304247, 145, '2015-01-01 00:25:56.000000', 'temperatura', 370.0000, 'ºC'),
	(304248, 145, '2015-01-01 00:25:57.000000', 'temperatura', 212.0000, 'ºC'),
	(304249, 145, '2015-01-01 00:25:58.000000', 'temperatura', 1151.0000, 'ºC'),
	(304250, 145, '2015-01-01 00:25:59.000000', 'temperatura', 317.0000, 'ºC'),
	(304251, 145, '2015-01-01 00:26:00.000000', 'temperatura', 535.0000, 'ºC'),
	(304252, 145, '2015-01-01 00:26:01.000000', 'temperatura', 525.0000, 'ºC'),
	(304253, 145, '2015-01-01 00:26:02.000000', 'temperatura', 1019.0000, 'ºC'),
	(304254, 145, '2015-01-01 00:26:03.000000', 'temperatura', 1120.0000, 'ºC'),
	(304255, 145, '2015-01-01 00:26:04.000000', 'temperatura', 142.0000, 'ºC'),
	(304256, 145, '2015-01-01 00:26:05.000000', 'temperatura', 952.0000, 'ºC'),
	(304257, 145, '2015-01-01 00:26:06.000000', 'temperatura', 735.0000, 'ºC'),
	(304258, 145, '2015-01-01 00:26:07.000000', 'temperatura', 821.0000, 'ºC'),
	(304259, 145, '2015-01-01 00:26:08.000000', 'temperatura', 697.0000, 'ºC'),
	(304260, 145, '2015-01-01 00:26:09.000000', 'temperatura', 1026.0000, 'ºC'),
	(304261, 145, '2015-01-01 00:26:10.000000', 'temperatura', 639.0000, 'ºC'),
	(304262, 145, '2015-01-01 00:26:11.000000', 'temperatura', 116.0000, 'ºC'),
	(304263, 145, '2015-01-01 00:26:12.000000', 'temperatura', 1065.0000, 'ºC'),
	(304264, 145, '2015-01-01 00:26:13.000000', 'temperatura', 177.0000, 'ºC'),
	(304265, 145, '2015-01-01 00:26:14.000000', 'temperatura', 88.0000, 'ºC'),
	(304266, 145, '2015-01-01 00:26:15.000000', 'temperatura', 1113.0000, 'ºC'),
	(304267, 145, '2015-01-01 00:26:16.000000', 'temperatura', 499.0000, 'ºC'),
	(304268, 145, '2015-01-01 00:26:17.000000', 'temperatura', 358.0000, 'ºC'),
	(304269, 145, '2015-01-01 00:26:18.000000', 'temperatura', 295.0000, 'ºC'),
	(304270, 145, '2015-01-01 00:26:19.000000', 'temperatura', 401.0000, 'ºC'),
	(304271, 145, '2015-01-01 00:26:20.000000', 'temperatura', 1118.0000, 'ºC'),
	(304272, 145, '2015-01-01 00:26:21.000000', 'temperatura', 788.0000, 'ºC'),
	(304273, 145, '2015-01-01 00:26:22.000000', 'temperatura', 589.0000, 'ºC'),
	(304274, 145, '2015-01-01 00:26:23.000000', 'temperatura', 580.0000, 'ºC'),
	(304275, 145, '2015-01-01 00:26:24.000000', 'temperatura', 1134.0000, 'ºC'),
	(304276, 145, '2015-01-01 00:26:25.000000', 'temperatura', 331.0000, 'ºC'),
	(304277, 145, '2015-01-01 00:26:26.000000', 'temperatura', 653.0000, 'ºC'),
	(304278, 145, '2015-01-01 00:26:27.000000', 'temperatura', 1073.0000, 'ºC'),
	(304279, 145, '2015-01-01 00:26:28.000000', 'temperatura', 1006.0000, 'ºC'),
	(304280, 145, '2015-01-01 00:26:29.000000', 'temperatura', 613.0000, 'ºC'),
	(304281, 145, '2015-01-01 00:26:30.000000', 'temperatura', 45.0000, 'ºC'),
	(304282, 145, '2015-01-01 00:26:31.000000', 'temperatura', 789.0000, 'ºC'),
	(304283, 145, '2015-01-01 00:26:32.000000', 'temperatura', 209.0000, 'ºC'),
	(304284, 145, '2015-01-01 00:26:33.000000', 'temperatura', 1080.0000, 'ºC'),
	(304285, 145, '2015-01-01 00:26:34.000000', 'temperatura', 1172.0000, 'ºC'),
	(304286, 145, '2015-01-01 00:26:35.000000', 'temperatura', 223.0000, 'ºC'),
	(304287, 145, '2015-01-01 00:26:36.000000', 'temperatura', 1198.0000, 'ºC'),
	(304288, 145, '2015-01-01 00:26:37.000000', 'temperatura', 522.0000, 'ºC'),
	(304289, 145, '2015-01-01 00:26:38.000000', 'temperatura', 216.0000, 'ºC'),
	(304290, 145, '2015-01-01 00:26:39.000000', 'temperatura', 713.0000, 'ºC'),
	(304291, 145, '2015-01-01 00:26:40.000000', 'temperatura', 520.0000, 'ºC'),
	(304292, 145, '2015-01-01 00:26:41.000000', 'temperatura', 461.0000, 'ºC'),
	(304293, 145, '2015-01-01 00:26:42.000000', 'temperatura', 744.0000, 'ºC'),
	(304294, 145, '2015-01-01 00:26:43.000000', 'temperatura', 1136.0000, 'ºC'),
	(304295, 145, '2015-01-01 00:26:44.000000', 'temperatura', 1052.0000, 'ºC'),
	(304296, 145, '2015-01-01 00:26:45.000000', 'temperatura', 649.0000, 'ºC'),
	(304297, 145, '2015-01-01 00:26:46.000000', 'temperatura', 92.0000, 'ºC'),
	(304298, 145, '2015-01-01 00:26:47.000000', 'temperatura', 914.0000, 'ºC'),
	(304299, 145, '2015-01-01 00:26:48.000000', 'temperatura', 694.0000, 'ºC'),
	(304300, 145, '2015-01-01 00:26:49.000000', 'temperatura', 729.0000, 'ºC'),
	(304301, 145, '2015-01-01 00:26:50.000000', 'temperatura', 362.0000, 'ºC'),
	(304302, 145, '2015-01-01 00:26:51.000000', 'temperatura', 823.0000, 'ºC'),
	(304303, 145, '2015-01-01 00:26:52.000000', 'temperatura', 631.0000, 'ºC'),
	(304304, 145, '2015-01-01 00:26:53.000000', 'temperatura', 686.0000, 'ºC'),
	(304305, 145, '2015-01-01 00:26:54.000000', 'temperatura', 337.0000, 'ºC'),
	(304306, 145, '2015-01-01 00:26:55.000000', 'temperatura', 827.0000, 'ºC'),
	(304307, 145, '2015-01-01 00:26:56.000000', 'temperatura', 725.0000, 'ºC'),
	(304308, 145, '2015-01-01 00:26:57.000000', 'temperatura', 1143.0000, 'ºC'),
	(304309, 145, '2015-01-01 00:26:58.000000', 'temperatura', 1140.0000, 'ºC'),
	(304310, 145, '2015-01-01 00:26:59.000000', 'temperatura', 1074.0000, 'ºC'),
	(304311, 145, '2015-01-01 00:27:00.000000', 'temperatura', 749.0000, 'ºC'),
	(304312, 145, '2015-01-01 00:27:01.000000', 'temperatura', 523.0000, 'ºC'),
	(304313, 145, '2015-01-01 00:27:02.000000', 'temperatura', 370.0000, 'ºC'),
	(304314, 145, '2015-01-01 00:27:03.000000', 'temperatura', 279.0000, 'ºC'),
	(304315, 145, '2015-01-01 00:27:04.000000', 'temperatura', 286.0000, 'ºC'),
	(304316, 145, '2015-01-01 00:27:05.000000', 'temperatura', 594.0000, 'ºC'),
	(304317, 145, '2015-01-01 00:27:06.000000', 'temperatura', 914.0000, 'ºC'),
	(304318, 145, '2015-01-01 00:27:07.000000', 'temperatura', 389.0000, 'ºC'),
	(304319, 145, '2015-01-01 00:27:08.000000', 'temperatura', 401.0000, 'ºC'),
	(304320, 145, '2015-01-01 00:27:09.000000', 'temperatura', 841.0000, 'ºC'),
	(304321, 145, '2015-01-01 00:27:10.000000', 'temperatura', 600.0000, 'ºC'),
	(304322, 145, '2015-01-01 00:27:11.000000', 'temperatura', 480.0000, 'ºC'),
	(304323, 145, '2015-01-01 00:27:12.000000', 'temperatura', 600.0000, 'ºC'),
	(304324, 145, '2015-01-01 00:27:13.000000', 'temperatura', 359.0000, 'ºC'),
	(304325, 145, '2015-01-01 00:27:14.000000', 'temperatura', 1197.0000, 'ºC'),
	(304326, 145, '2015-01-01 00:27:15.000000', 'temperatura', 107.0000, 'ºC'),
	(304327, 145, '2015-01-01 00:27:16.000000', 'temperatura', 545.0000, 'ºC'),
	(304328, 145, '2015-01-01 00:27:17.000000', 'temperatura', 5.0000, 'ºC'),
	(304329, 145, '2015-01-01 00:27:18.000000', 'temperatura', 790.0000, 'ºC'),
	(304330, 145, '2015-01-01 00:27:19.000000', 'temperatura', 334.0000, 'ºC'),
	(304331, 145, '2015-01-01 00:27:20.000000', 'temperatura', 502.0000, 'ºC'),
	(304332, 145, '2015-01-01 00:27:21.000000', 'temperatura', 308.0000, 'ºC'),
	(304333, 145, '2015-01-01 00:27:22.000000', 'temperatura', 36.0000, 'ºC'),
	(304334, 145, '2015-01-01 00:27:23.000000', 'temperatura', 456.0000, 'ºC'),
	(304335, 145, '2015-01-01 00:27:24.000000', 'temperatura', 973.0000, 'ºC'),
	(304336, 145, '2015-01-01 00:27:25.000000', 'temperatura', 1099.0000, 'ºC'),
	(304337, 145, '2015-01-01 00:27:26.000000', 'temperatura', 175.0000, 'ºC'),
	(304338, 145, '2015-01-01 00:27:27.000000', 'temperatura', 1178.0000, 'ºC'),
	(304339, 145, '2015-01-01 00:27:28.000000', 'temperatura', 566.0000, 'ºC'),
	(304340, 145, '2015-01-01 00:27:29.000000', 'temperatura', 496.0000, 'ºC'),
	(304341, 145, '2015-01-01 00:27:30.000000', 'temperatura', 781.0000, 'ºC'),
	(304342, 145, '2015-01-01 00:27:31.000000', 'temperatura', 18.0000, 'ºC'),
	(304343, 145, '2015-01-01 00:27:32.000000', 'temperatura', 147.0000, 'ºC'),
	(304344, 145, '2015-01-01 00:27:33.000000', 'temperatura', 684.0000, 'ºC'),
	(304345, 145, '2015-01-01 00:27:34.000000', 'temperatura', 579.0000, 'ºC'),
	(304346, 145, '2015-01-01 00:27:35.000000', 'temperatura', 841.0000, 'ºC'),
	(304347, 145, '2015-01-01 00:27:36.000000', 'temperatura', 70.0000, 'ºC'),
	(304348, 145, '2015-01-01 00:27:37.000000', 'temperatura', 229.0000, 'ºC'),
	(304349, 145, '2015-01-01 00:27:38.000000', 'temperatura', 934.0000, 'ºC'),
	(304350, 145, '2015-01-01 00:27:39.000000', 'temperatura', 386.0000, 'ºC'),
	(304351, 145, '2015-01-01 00:27:40.000000', 'temperatura', 325.0000, 'ºC'),
	(304352, 145, '2015-01-01 00:27:41.000000', 'temperatura', 470.0000, 'ºC'),
	(304353, 145, '2015-01-01 00:27:42.000000', 'temperatura', 176.0000, 'ºC'),
	(304354, 145, '2015-01-01 00:27:43.000000', 'temperatura', 668.0000, 'ºC'),
	(304355, 145, '2015-01-01 00:27:44.000000', 'temperatura', 413.0000, 'ºC'),
	(304356, 145, '2015-01-01 00:27:45.000000', 'temperatura', 61.0000, 'ºC'),
	(304357, 145, '2015-01-01 00:27:46.000000', 'temperatura', 268.0000, 'ºC'),
	(304358, 145, '2015-01-01 00:27:47.000000', 'temperatura', 1158.0000, 'ºC'),
	(304359, 145, '2015-01-01 00:27:48.000000', 'temperatura', 187.0000, 'ºC'),
	(304360, 145, '2015-01-01 00:27:49.000000', 'temperatura', 1062.0000, 'ºC'),
	(304361, 145, '2015-01-01 00:27:50.000000', 'temperatura', 1150.0000, 'ºC'),
	(304362, 145, '2015-01-01 00:27:51.000000', 'temperatura', 163.0000, 'ºC'),
	(304363, 145, '2015-01-01 00:27:52.000000', 'temperatura', 967.0000, 'ºC'),
	(304364, 145, '2015-01-01 00:27:53.000000', 'temperatura', 745.0000, 'ºC'),
	(304365, 145, '2015-01-01 00:27:54.000000', 'temperatura', 823.0000, 'ºC'),
	(304366, 145, '2015-01-01 00:27:55.000000', 'temperatura', 684.0000, 'ºC'),
	(304367, 145, '2015-01-01 00:27:56.000000', 'temperatura', 949.0000, 'ºC'),
	(304368, 145, '2015-01-01 00:27:57.000000', 'temperatura', 293.0000, 'ºC'),
	(304369, 145, '2015-01-01 00:27:58.000000', 'temperatura', 1019.0000, 'ºC'),
	(304370, 145, '2015-01-01 00:27:59.000000', 'temperatura', 615.0000, 'ºC'),
	(304371, 145, '2015-01-01 00:28:00.000000', 'temperatura', 20.0000, 'ºC'),
	(304372, 145, '2015-01-01 00:28:01.000000', 'temperatura', 656.0000, 'ºC'),
	(304373, 145, '2015-01-01 00:28:02.000000', 'temperatura', 821.0000, 'ºC'),
	(304374, 145, '2015-01-01 00:28:03.000000', 'temperatura', 938.0000, 'ºC'),
	(304375, 145, '2015-01-01 00:28:04.000000', 'temperatura', 1025.0000, 'ºC'),
	(304376, 145, '2015-01-01 00:28:05.000000', 'temperatura', 1114.0000, 'ºC'),
	(304377, 145, '2015-01-01 00:28:06.000000', 'temperatura', 93.0000, 'ºC'),
	(304378, 145, '2015-01-01 00:28:07.000000', 'temperatura', 726.0000, 'ºC'),
	(304379, 145, '2015-01-01 00:28:08.000000', 'temperatura', 951.0000, 'ºC'),
	(304380, 145, '2015-01-01 00:28:09.000000', 'temperatura', 176.0000, 'ºC'),
	(304381, 145, '2015-01-01 00:28:10.000000', 'temperatura', 429.0000, 'ºC'),
	(304382, 145, '2015-01-01 00:28:11.000000', 'temperatura', 416.0000, 'ºC'),
	(304383, 145, '2015-01-01 00:28:12.000000', 'temperatura', 793.0000, 'ºC'),
	(304384, 145, '2015-01-01 00:28:13.000000', 'temperatura', 319.0000, 'ºC'),
	(304385, 145, '2015-01-01 00:28:14.000000', 'temperatura', 416.0000, 'ºC'),
	(304386, 145, '2015-01-01 00:28:15.000000', 'temperatura', 1124.0000, 'ºC'),
	(304387, 145, '2015-01-01 00:28:16.000000', 'temperatura', 773.0000, 'ºC'),
	(304388, 145, '2015-01-01 00:28:17.000000', 'temperatura', 494.0000, 'ºC'),
	(304389, 145, '2015-01-01 00:28:18.000000', 'temperatura', 152.0000, 'ºC'),
	(304390, 145, '2015-01-01 00:28:19.000000', 'temperatura', 476.0000, 'ºC'),
	(304391, 145, '2015-01-01 00:28:20.000000', 'temperatura', 725.0000, 'ºC'),
	(304392, 145, '2015-01-01 00:28:21.000000', 'temperatura', 997.0000, 'ºC'),
	(304393, 145, '2015-01-01 00:28:22.000000', 'temperatura', 413.0000, 'ºC'),
	(304394, 145, '2015-01-01 00:28:23.000000', 'temperatura', 274.0000, 'ºC'),
	(304395, 145, '2015-01-01 00:28:24.000000', 'temperatura', 130.0000, 'ºC'),
	(304396, 145, '2015-01-01 00:28:25.000000', 'temperatura', 1029.0000, 'ºC'),
	(304397, 145, '2015-01-01 00:28:26.000000', 'temperatura', 1154.0000, 'ºC'),
	(304398, 145, '2015-01-01 00:28:27.000000', 'temperatura', 283.0000, 'ºC'),
	(304399, 145, '2015-01-01 00:28:28.000000', 'temperatura', 353.0000, 'ºC'),
	(304400, 145, '2015-01-01 00:28:29.000000', 'temperatura', 916.0000, 'ºC'),
	(304401, 145, '2015-01-01 00:28:30.000000', 'temperatura', 1124.0000, 'ºC'),
	(304402, 145, '2015-01-01 00:28:31.000000', 'temperatura', 473.0000, 'ºC'),
	(304403, 145, '2015-01-01 00:28:32.000000', 'temperatura', 193.0000, 'ºC'),
	(304404, 145, '2015-01-01 00:28:33.000000', 'temperatura', 746.0000, 'ºC'),
	(304405, 145, '2015-01-01 00:28:34.000000', 'temperatura', 753.0000, 'ºC'),
	(304406, 145, '2015-01-01 00:28:35.000000', 'temperatura', 326.0000, 'ºC'),
	(304407, 145, '2015-01-01 00:28:36.000000', 'temperatura', 572.0000, 'ºC'),
	(304408, 145, '2015-01-01 00:28:37.000000', 'temperatura', 684.0000, 'ºC'),
	(304409, 145, '2015-01-01 00:28:38.000000', 'temperatura', 502.0000, 'ºC'),
	(304410, 145, '2015-01-01 00:28:39.000000', 'temperatura', 460.0000, 'ºC'),
	(304411, 145, '2015-01-01 00:28:40.000000', 'temperatura', 794.0000, 'ºC'),
	(304412, 145, '2015-01-01 00:28:41.000000', 'temperatura', 190.0000, 'ºC'),
	(304413, 145, '2015-01-01 00:28:42.000000', 'temperatura', 971.0000, 'ºC'),
	(304414, 145, '2015-01-01 00:28:43.000000', 'temperatura', 683.0000, 'ºC'),
	(304415, 145, '2015-01-01 00:28:44.000000', 'temperatura', 504.0000, 'ºC'),
	(304416, 145, '2015-01-01 00:28:45.000000', 'temperatura', 471.0000, 'ºC'),
	(304417, 145, '2015-01-01 00:28:46.000000', 'temperatura', 843.0000, 'ºC'),
	(304418, 145, '2015-01-01 00:28:47.000000', 'temperatura', 402.0000, 'ºC'),
	(304419, 145, '2015-01-01 00:28:48.000000', 'temperatura', 684.0000, 'ºC'),
	(304420, 145, '2015-01-01 00:28:49.000000', 'temperatura', 1011.0000, 'ºC'),
	(304421, 145, '2015-01-01 00:28:50.000000', 'temperatura', 606.0000, 'ºC'),
	(304422, 145, '2015-01-01 00:28:51.000000', 'temperatura', 1196.0000, 'ºC'),
	(304423, 145, '2015-01-01 00:28:52.000000', 'temperatura', 562.0000, 'ºC'),
	(304424, 145, '2015-01-01 00:28:53.000000', 'temperatura', 424.0000, 'ºC'),
	(304425, 145, '2015-01-01 00:28:54.000000', 'temperatura', 434.0000, 'ºC'),
	(304426, 145, '2015-01-01 00:28:55.000000', 'temperatura', 900.0000, 'ºC'),
	(304427, 145, '2015-01-01 00:28:56.000000', 'temperatura', 799.0000, 'ºC'),
	(304428, 145, '2015-01-01 00:28:57.000000', 'temperatura', 93.0000, 'ºC'),
	(304429, 145, '2015-01-01 00:28:58.000000', 'temperatura', 471.0000, 'ºC'),
	(304430, 145, '2015-01-01 00:28:59.000000', 'temperatura', 876.0000, 'ºC'),
	(304431, 145, '2015-01-01 00:29:00.000000', 'temperatura', 569.0000, 'ºC'),
	(304432, 145, '2015-01-01 00:29:01.000000', 'temperatura', 214.0000, 'ºC'),
	(304433, 145, '2015-01-01 00:29:02.000000', 'temperatura', 565.0000, 'ºC'),
	(304434, 145, '2015-01-01 00:29:03.000000', 'temperatura', 985.0000, 'ºC'),
	(304435, 145, '2015-01-01 00:29:04.000000', 'temperatura', 829.0000, 'ºC'),
	(304436, 145, '2015-01-01 00:29:05.000000', 'temperatura', 1189.0000, 'ºC'),
	(304437, 145, '2015-01-01 00:29:06.000000', 'temperatura', 1061.0000, 'ºC'),
	(304438, 145, '2015-01-01 00:29:07.000000', 'temperatura', 536.0000, 'ºC'),
	(304439, 145, '2015-01-01 00:29:08.000000', 'temperatura', 697.0000, 'ºC'),
	(304440, 145, '2015-01-01 00:29:09.000000', 'temperatura', 680.0000, 'ºC'),
	(304441, 145, '2015-01-01 00:29:10.000000', 'temperatura', 107.0000, 'ºC'),
	(304442, 145, '2015-01-01 00:29:11.000000', 'temperatura', 896.0000, 'ºC'),
	(304443, 145, '2015-01-01 00:29:12.000000', 'temperatura', 560.0000, 'ºC'),
	(304444, 145, '2015-01-01 00:29:13.000000', 'temperatura', 111.0000, 'ºC'),
	(304445, 145, '2015-01-01 00:29:14.000000', 'temperatura', 78.0000, 'ºC'),
	(304446, 145, '2015-01-01 00:29:15.000000', 'temperatura', 55.0000, 'ºC'),
	(304447, 145, '2015-01-01 00:29:16.000000', 'temperatura', 41.0000, 'ºC'),
	(304448, 145, '2015-01-01 00:29:17.000000', 'temperatura', 41.0000, 'ºC'),
	(304449, 145, '2015-01-01 00:29:18.000000', 'temperatura', 81.0000, 'ºC'),
	(304450, 145, '2015-01-01 00:29:19.000000', 'temperatura', 284.0000, 'ºC'),
	(304451, 145, '2015-01-01 00:29:20.000000', 'temperatura', 1178.0000, 'ºC'),
	(304452, 145, '2015-01-01 00:29:21.000000', 'temperatura', 238.0000, 'ºC'),
	(304453, 145, '2015-01-01 00:29:22.000000', 'temperatura', 56.0000, 'ºC'),
	(304454, 145, '2015-01-01 00:29:23.000000', 'temperatura', 766.0000, 'ºC'),
	(304455, 145, '2015-01-01 00:29:24.000000', 'temperatura', 63.0000, 'ºC'),
	(304456, 145, '2015-01-01 00:29:25.000000', 'temperatura', 417.0000, 'ºC'),
	(304457, 145, '2015-01-01 00:29:26.000000', 'temperatura', 698.0000, 'ºC'),
	(304458, 145, '2015-01-01 00:29:27.000000', 'temperatura', 1038.0000, 'ºC'),
	(304459, 145, '2015-01-01 00:29:28.000000', 'temperatura', 698.0000, 'ºC'),
	(304460, 145, '2015-01-01 00:29:29.000000', 'temperatura', 374.0000, 'ºC'),
	(304461, 145, '2015-01-01 00:29:30.000000', 'temperatura', 979.0000, 'ºC'),
	(304462, 145, '2015-01-01 00:29:31.000000', 'temperatura', 175.0000, 'ºC'),
	(304463, 145, '2015-01-01 00:29:32.000000', 'temperatura', 335.0000, 'ºC'),
	(304464, 145, '2015-01-01 00:29:33.000000', 'temperatura', 1153.0000, 'ºC'),
	(304465, 145, '2015-01-01 00:29:34.000000', 'temperatura', 1158.0000, 'ºC'),
	(304466, 145, '2015-01-01 00:29:35.000000', 'temperatura', 1134.0000, 'ºC'),
	(304467, 145, '2015-01-01 00:29:36.000000', 'temperatura', 994.0000, 'ºC'),
	(304468, 145, '2015-01-01 00:29:37.000000', 'temperatura', 368.0000, 'ºC'),
	(304469, 145, '2015-01-01 00:29:38.000000', 'temperatura', 60.0000, 'ºC'),
	(304470, 145, '2015-01-01 00:29:39.000000', 'temperatura', 395.0000, 'ºC'),
	(304471, 145, '2015-01-01 00:29:40.000000', 'temperatura', 597.0000, 'ºC'),
	(304472, 145, '2015-01-01 00:29:41.000000', 'temperatura', 601.0000, 'ºC'),
	(304473, 145, '2015-01-01 00:29:42.000000', 'temperatura', 16.0000, 'ºC'),
	(304474, 145, '2015-01-01 00:29:43.000000', 'temperatura', 675.0000, 'ºC'),
	(304475, 145, '2015-01-01 00:29:44.000000', 'temperatura', 929.0000, 'ºC'),
	(304476, 145, '2015-01-01 00:29:45.000000', 'temperatura', 220.0000, 'ºC'),
	(304477, 145, '2015-01-01 00:29:46.000000', 'temperatura', 712.0000, 'ºC'),
	(304478, 145, '2015-01-01 00:29:47.000000', 'temperatura', 501.0000, 'ºC'),
	(304479, 145, '2015-01-01 00:29:48.000000', 'temperatura', 370.0000, 'ºC'),
	(304480, 145, '2015-01-01 00:29:49.000000', 'temperatura', 349.0000, 'ºC'),
	(304481, 145, '2015-01-01 00:29:50.000000', 'temperatura', 633.0000, 'ºC'),
	(304482, 145, '2015-01-01 00:29:51.000000', 'temperatura', 921.0000, 'ºC'),
	(304483, 145, '2015-01-01 00:29:52.000000', 'temperatura', 306.0000, 'ºC'),
	(304484, 145, '2015-01-01 00:29:53.000000', 'temperatura', 1167.0000, 'ºC'),
	(304485, 145, '2015-01-01 00:29:54.000000', 'temperatura', 117.0000, 'ºC'),
	(304486, 145, '2015-01-01 00:29:55.000000', 'temperatura', 685.0000, 'ºC'),
	(304487, 145, '2015-01-01 00:29:56.000000', 'temperatura', 674.0000, 'ºC'),
	(304488, 145, '2015-01-01 00:29:57.000000', 'temperatura', 114.0000, 'ºC'),
	(304489, 145, '2015-01-01 00:29:58.000000', 'temperatura', 949.0000, 'ºC'),
	(304490, 145, '2015-01-01 00:29:59.000000', 'temperatura', 802.0000, 'ºC'),
	(304491, 145, '2015-01-01 00:30:00.000000', 'temperatura', 1167.0000, 'ºC'),
	(304492, 145, '2015-01-01 00:30:01.000000', 'temperatura', 1027.0000, 'ºC'),
	(304493, 145, '2015-01-01 00:30:02.000000', 'temperatura', 436.0000, 'ºC'),
	(304494, 145, '2015-01-01 00:30:03.000000', 'temperatura', 299.0000, 'ºC'),
	(304495, 145, '2015-01-01 00:30:04.000000', 'temperatura', 188.0000, 'ºC'),
	(304496, 145, '2015-01-01 00:30:05.000000', 'temperatura', 43.0000, 'ºC'),
	(304497, 145, '2015-01-01 00:30:06.000000', 'temperatura', 852.0000, 'ºC'),
	(304498, 145, '2015-01-01 00:30:07.000000', 'temperatura', 531.0000, 'ºC'),
	(304499, 145, '2015-01-01 00:30:08.000000', 'temperatura', 99.0000, 'ºC'),
	(304500, 145, '2015-01-01 00:30:09.000000', 'temperatura', 102.0000, 'ºC'),
	(304501, 145, '2015-01-01 00:30:10.000000', 'temperatura', 214.0000, 'ºC'),
	(304502, 145, '2015-01-01 00:30:11.000000', 'temperatura', 763.0000, 'ºC'),
	(304503, 145, '2015-01-01 00:30:12.000000', 'temperatura', 775.0000, 'ºC'),
	(304504, 145, '2015-01-01 00:30:13.000000', 'temperatura', 388.0000, 'ºC'),
	(304505, 145, '2015-01-01 00:30:14.000000', 'temperatura', 815.0000, 'ºC'),
	(304506, 145, '2015-01-01 00:30:15.000000', 'temperatura', 509.0000, 'ºC'),
	(304507, 145, '2015-01-01 00:30:16.000000', 'temperatura', 102.0000, 'ºC'),
	(304508, 145, '2015-01-01 00:30:17.000000', 'temperatura', 183.0000, 'ºC'),
	(304509, 145, '2015-01-01 00:30:18.000000', 'temperatura', 609.0000, 'ºC'),
	(304510, 145, '2015-01-01 00:30:19.000000', 'temperatura', 98.0000, 'ºC'),
	(304511, 145, '2015-01-01 00:30:20.000000', 'temperatura', 1065.0000, 'ºC'),
	(304512, 145, '2015-01-01 00:30:21.000000', 'temperatura', 230.0000, 'ºC'),
	(304513, 145, '2015-01-01 00:30:22.000000', 'temperatura', 354.0000, 'ºC'),
	(304514, 145, '2015-01-01 00:30:23.000000', 'temperatura', 1083.0000, 'ºC'),
	(304515, 145, '2015-01-01 00:30:24.000000', 'temperatura', 755.0000, 'ºC'),
	(304516, 145, '2015-01-01 00:30:25.000000', 'temperatura', 523.0000, 'ºC'),
	(304517, 145, '2015-01-01 00:30:26.000000', 'temperatura', 351.0000, 'ºC'),
	(304518, 145, '2015-01-01 00:30:27.000000', 'temperatura', 188.0000, 'ºC'),
	(304519, 145, '2015-01-01 00:30:28.000000', 'temperatura', 1089.0000, 'ºC'),
	(304520, 145, '2015-01-01 00:30:29.000000', 'temperatura', 78.0000, 'ºC'),
	(304521, 145, '2015-01-01 00:30:30.000000', 'temperatura', 725.0000, 'ºC'),
	(304522, 145, '2015-01-01 00:30:31.000000', 'temperatura', 989.0000, 'ºC'),
	(304523, 145, '2015-01-01 00:30:32.000000', 'temperatura', 374.0000, 'ºC'),
	(304524, 145, '2015-01-01 00:30:33.000000', 'temperatura', 101.0000, 'ºC'),
	(304525, 145, '2015-01-01 00:30:34.000000', 'temperatura', 585.0000, 'ºC'),
	(304526, 145, '2015-01-01 00:30:35.000000', 'temperatura', 224.0000, 'ºC'),
	(304527, 145, '2015-01-01 00:30:36.000000', 'temperatura', 562.0000, 'ºC'),
	(304528, 145, '2015-01-01 00:30:37.000000', 'temperatura', 941.0000, 'ºC'),
	(304529, 145, '2015-01-01 00:30:38.000000', 'temperatura', 619.0000, 'ºC'),
	(304530, 145, '2015-01-01 00:30:39.000000', 'temperatura', 274.0000, 'ºC'),
	(304531, 145, '2015-01-01 00:30:40.000000', 'temperatura', 713.0000, 'ºC'),
	(304532, 145, '2015-01-01 00:30:41.000000', 'temperatura', 344.0000, 'ºC'),
	(304533, 145, '2015-01-01 00:30:42.000000', 'temperatura', 781.0000, 'ºC'),
	(304534, 145, '2015-01-01 00:30:43.000000', 'temperatura', 474.0000, 'ºC'),
	(304535, 145, '2015-01-01 00:30:44.000000', 'temperatura', 26.0000, 'ºC'),
	(304536, 145, '2015-01-01 00:30:45.000000', 'temperatura', 1108.0000, 'ºC'),
	(304537, 145, '2015-01-01 00:30:46.000000', 'temperatura', 664.0000, 'ºC'),
	(304538, 145, '2015-01-01 00:30:47.000000', 'temperatura', 1197.0000, 'ºC'),
	(304539, 145, '2015-01-01 00:30:48.000000', 'temperatura', 392.0000, 'ºC'),
	(304540, 145, '2015-01-01 00:30:49.000000', 'temperatura', 771.0000, 'ºC'),
	(304541, 145, '2015-01-01 00:30:50.000000', 'temperatura', 279.0000, 'ºC'),
	(304542, 145, '2015-01-01 00:30:51.000000', 'temperatura', 280.0000, 'ºC'),
	(304543, 145, '2015-01-01 00:30:52.000000', 'temperatura', 566.0000, 'ºC'),
	(304544, 145, '2015-01-01 00:30:53.000000', 'temperatura', 791.0000, 'ºC'),
	(304545, 145, '2015-01-01 00:30:54.000000', 'temperatura', 1057.0000, 'ºC'),
	(304546, 145, '2015-01-01 00:30:55.000000', 'temperatura', 514.0000, 'ºC'),
	(304547, 145, '2015-01-01 00:30:56.000000', 'temperatura', 600.0000, 'ºC'),
	(304548, 145, '2015-01-01 00:30:57.000000', 'temperatura', 256.0000, 'ºC'),
	(304549, 145, '2015-01-01 00:30:58.000000', 'temperatura', 680.0000, 'ºC'),
	(304550, 145, '2015-01-01 00:30:59.000000', 'temperatura', 234.0000, 'ºC'),
	(304551, 145, '2015-01-01 00:31:00.000000', 'temperatura', 332.0000, 'ºC'),
	(304552, 145, '2015-01-01 00:31:01.000000', 'temperatura', 957.0000, 'ºC'),
	(304553, 145, '2015-01-01 00:31:02.000000', 'temperatura', 191.0000, 'ºC'),
	(304554, 145, '2015-01-01 00:31:03.000000', 'temperatura', 483.0000, 'ºC'),
	(304555, 145, '2015-01-01 00:31:04.000000', 'temperatura', 643.0000, 'ºC'),
	(304556, 145, '2015-01-01 00:31:05.000000', 'temperatura', 564.0000, 'ºC'),
	(304557, 145, '2015-01-01 00:31:06.000000', 'temperatura', 895.0000, 'ºC'),
	(304558, 145, '2015-01-01 00:31:07.000000', 'temperatura', 383.0000, 'ºC'),
	(304559, 145, '2015-01-01 00:31:08.000000', 'temperatura', 430.0000, 'ºC'),
	(304560, 145, '2015-01-01 00:31:09.000000', 'temperatura', 1002.0000, 'ºC'),
	(304561, 145, '2015-01-01 00:31:10.000000', 'temperatura', 121.0000, 'ºC'),
	(304562, 145, '2015-01-01 00:31:11.000000', 'temperatura', 1198.0000, 'ºC'),
	(304563, 145, '2015-01-01 00:31:12.000000', 'temperatura', 829.0000, 'ºC'),
	(304564, 145, '2015-01-01 00:31:13.000000', 'temperatura', 549.0000, 'ºC'),
	(304565, 145, '2015-01-01 00:31:14.000000', 'temperatura', 261.0000, 'ºC'),
	(304566, 145, '2015-01-01 00:31:15.000000', 'temperatura', 859.0000, 'ºC'),
	(304567, 145, '2015-01-01 00:31:16.000000', 'temperatura', 1113.0000, 'ºC'),
	(304568, 145, '2015-01-01 00:31:17.000000', 'temperatura', 588.0000, 'ºC'),
	(304569, 145, '2015-01-01 00:31:18.000000', 'temperatura', 801.0000, 'ºC'),
	(304570, 145, '2015-01-01 00:31:19.000000', 'temperatura', 1040.0000, 'ºC'),
	(304571, 145, '2015-01-01 00:31:20.000000', 'temperatura', 398.0000, 'ºC'),
	(304572, 145, '2015-01-01 00:31:21.000000', 'temperatura', 71.0000, 'ºC'),
	(304573, 145, '2015-01-01 00:31:22.000000', 'temperatura', 362.0000, 'ºC'),
	(304574, 145, '2015-01-01 00:31:23.000000', 'temperatura', 396.0000, 'ºC'),
	(304575, 145, '2015-01-01 00:31:24.000000', 'temperatura', 894.0000, 'ºC'),
	(304576, 145, '2015-01-01 00:31:25.000000', 'temperatura', 882.0000, 'ºC'),
	(304577, 145, '2015-01-01 00:31:26.000000', 'temperatura', 531.0000, 'ºC'),
	(304578, 145, '2015-01-01 00:31:27.000000', 'temperatura', 8.0000, 'ºC'),
	(304579, 145, '2015-01-01 00:31:28.000000', 'temperatura', 850.0000, 'ºC'),
	(304580, 145, '2015-01-01 00:31:29.000000', 'temperatura', 623.0000, 'ºC'),
	(304581, 145, '2015-01-01 00:31:30.000000', 'temperatura', 566.0000, 'ºC'),
	(304582, 145, '2015-01-01 00:31:31.000000', 'temperatura', 964.0000, 'ºC'),
	(304583, 145, '2015-01-01 00:31:32.000000', 'temperatura', 721.0000, 'ºC'),
	(304584, 145, '2015-01-01 00:31:33.000000', 'temperatura', 715.0000, 'ºC'),
	(304585, 145, '2015-01-01 00:31:34.000000', 'temperatura', 214.0000, 'ºC'),
	(304586, 145, '2015-01-01 00:31:35.000000', 'temperatura', 122.0000, 'ºC'),
	(304587, 145, '2015-01-01 00:31:36.000000', 'temperatura', 1169.0000, 'ºC'),
	(304588, 145, '2015-01-01 00:31:37.000000', 'temperatura', 678.0000, 'ºC'),
	(304589, 145, '2015-01-01 00:31:38.000000', 'temperatura', 1085.0000, 'ºC'),
	(304590, 145, '2015-01-01 00:31:39.000000', 'temperatura', 991.0000, 'ºC'),
	(304591, 145, '2015-01-01 00:31:40.000000', 'temperatura', 501.0000, 'ºC'),
	(304592, 145, '2015-01-01 00:31:41.000000', 'temperatura', 731.0000, 'ºC'),
	(304593, 145, '2015-01-01 00:31:42.000000', 'temperatura', 955.0000, 'ºC'),
	(304594, 145, '2015-01-01 00:31:43.000000', 'temperatura', 183.0000, 'ºC'),
	(304595, 145, '2015-01-01 00:31:44.000000', 'temperatura', 448.0000, 'ºC'),
	(304596, 145, '2015-01-01 00:31:45.000000', 'temperatura', 492.0000, 'ºC'),
	(304597, 145, '2015-01-01 00:31:46.000000', 'temperatura', 1117.0000, 'ºC'),
	(304598, 145, '2015-01-01 00:31:47.000000', 'temperatura', 510.0000, 'ºC'),
	(304599, 145, '2015-01-01 00:31:48.000000', 'temperatura', 401.0000, 'ºC'),
	(304600, 145, '2015-01-01 00:31:49.000000', 'temperatura', 473.0000, 'ºC'),
	(304601, 145, '2015-01-01 00:31:50.000000', 'temperatura', 1165.0000, 'ºC'),
	(304602, 145, '2015-01-01 00:31:51.000000', 'temperatura', 807.0000, 'ºC'),
	(304603, 145, '2015-01-01 00:31:52.000000', 'temperatura', 539.0000, 'ºC'),
	(304604, 145, '2015-01-01 00:31:53.000000', 'temperatura', 273.0000, 'ºC'),
	(304605, 145, '2015-01-01 00:31:54.000000', 'temperatura', 949.0000, 'ºC'),
	(304606, 145, '2015-01-01 00:31:55.000000', 'temperatura', 328.0000, 'ºC'),
	(304607, 145, '2015-01-01 00:31:56.000000', 'temperatura', 1195.0000, 'ºC'),
	(304608, 145, '2015-01-01 00:31:57.000000', 'temperatura', 188.0000, 'ºC'),
	(304609, 145, '2015-01-01 00:31:58.000000', 'temperatura', 957.0000, 'ºC'),
	(304610, 145, '2015-01-01 00:31:59.000000', 'temperatura', 621.0000, 'ºC'),
	(304611, 145, '2015-01-01 00:32:00.000000', 'temperatura', 234.0000, 'ºC'),
	(304612, 145, '2015-01-01 00:32:01.000000', 'temperatura', 506.0000, 'ºC'),
	(304613, 145, '2015-01-01 00:32:02.000000', 'temperatura', 630.0000, 'ºC'),
	(304614, 145, '2015-01-01 00:32:03.000000', 'temperatura', 434.0000, 'ºC'),
	(304615, 145, '2015-01-01 00:32:04.000000', 'temperatura', 281.0000, 'ºC'),
	(304616, 145, '2015-01-01 00:32:05.000000', 'temperatura', 102.0000, 'ºC'),
	(304617, 145, '2015-01-01 00:32:06.000000', 'temperatura', 866.0000, 'ºC'),
	(304618, 145, '2015-01-01 00:32:07.000000', 'temperatura', 426.0000, 'ºC'),
	(304619, 145, '2015-01-01 00:32:08.000000', 'temperatura', 733.0000, 'ºC'),
	(304620, 145, '2015-01-01 00:32:09.000000', 'temperatura', 1186.0000, 'ºC'),
	(304621, 145, '2015-01-01 00:32:10.000000', 'temperatura', 132.0000, 'ºC'),
	(304622, 145, '2015-01-01 00:32:11.000000', 'temperatura', 702.0000, 'ºC'),
	(304623, 145, '2015-01-01 00:32:12.000000', 'temperatura', 716.0000, 'ºC'),
	(304624, 145, '2015-01-01 00:32:13.000000', 'temperatura', 273.0000, 'ºC'),
	(304625, 145, '2015-01-01 00:32:14.000000', 'temperatura', 417.0000, 'ºC'),
	(304626, 145, '2015-01-01 00:32:15.000000', 'temperatura', 67.0000, 'ºC'),
	(304627, 145, '2015-01-01 00:32:16.000000', 'temperatura', 285.0000, 'ºC'),
	(304628, 145, '2015-01-01 00:32:17.000000', 'temperatura', 23.0000, 'ºC'),
	(304629, 145, '2015-01-01 00:32:18.000000', 'temperatura', 460.0000, 'ºC'),
	(304630, 145, '2015-01-01 00:32:19.000000', 'temperatura', 1033.0000, 'ºC'),
	(304631, 145, '2015-01-01 00:32:20.000000', 'temperatura', 186.0000, 'ºC'),
	(304632, 145, '2015-01-01 00:32:21.000000', 'temperatura', 230.0000, 'ºC'),
	(304633, 145, '2015-01-01 00:32:22.000000', 'temperatura', 593.0000, 'ºC'),
	(304634, 145, '2015-01-01 00:32:23.000000', 'temperatura', 1075.0000, 'ºC'),
	(304635, 145, '2015-01-01 00:32:24.000000', 'temperatura', 1196.0000, 'ºC'),
	(304636, 145, '2015-01-01 00:32:25.000000', 'temperatura', 355.0000, 'ºC'),
	(304637, 145, '2015-01-01 00:32:26.000000', 'temperatura', 589.0000, 'ºC'),
	(304638, 145, '2015-01-01 00:32:27.000000', 'temperatura', 679.0000, 'ºC'),
	(304639, 145, '2015-01-01 00:32:28.000000', 'temperatura', 428.0000, 'ºC'),
	(304640, 145, '2015-01-01 00:32:29.000000', 'temperatura', 106.0000, 'ºC'),
	(304641, 145, '2015-01-01 00:32:30.000000', 'temperatura', 444.0000, 'ºC'),
	(304642, 145, '2015-01-01 00:32:31.000000', 'temperatura', 702.0000, 'ºC'),
	(304643, 145, '2015-01-01 00:32:32.000000', 'temperatura', 980.0000, 'ºC'),
	(304644, 145, '2015-01-01 00:32:33.000000', 'temperatura', 393.0000, 'ºC'),
	(304645, 145, '2015-01-01 00:32:34.000000', 'temperatura', 226.0000, 'ºC'),
	(304646, 145, '2015-01-01 00:32:35.000000', 'temperatura', 1153.0000, 'ºC'),
	(304647, 145, '2015-01-01 00:32:36.000000', 'temperatura', 286.0000, 'ºC'),
	(304648, 145, '2015-01-01 00:32:37.000000', 'temperatura', 373.0000, 'ºC'),
	(304649, 145, '2015-01-01 00:32:38.000000', 'temperatura', 1005.0000, 'ºC'),
	(304650, 145, '2015-01-01 00:32:39.000000', 'temperatura', 310.0000, 'ºC'),
	(304651, 145, '2015-01-01 00:32:40.000000', 'temperatura', 933.0000, 'ºC'),
	(304652, 145, '2015-01-01 00:32:41.000000', 'temperatura', 136.0000, 'ºC'),
	(304653, 145, '2015-01-01 00:32:42.000000', 'temperatura', 280.0000, 'ºC'),
	(304654, 145, '2015-01-01 00:32:43.000000', 'temperatura', 993.0000, 'ºC'),
	(304655, 145, '2015-01-01 00:32:44.000000', 'temperatura', 525.0000, 'ºC'),
	(304656, 145, '2015-01-01 00:32:45.000000', 'temperatura', 847.0000, 'ºC'),
	(304657, 145, '2015-01-01 00:32:46.000000', 'temperatura', 259.0000, 'ºC'),
	(304658, 145, '2015-01-01 00:32:47.000000', 'temperatura', 1156.0000, 'ºC'),
	(304659, 145, '2015-01-01 00:32:48.000000', 'temperatura', 205.0000, 'ºC'),
	(304660, 145, '2015-01-01 00:32:49.000000', 'temperatura', 1158.0000, 'ºC'),
	(304661, 145, '2015-01-01 00:32:50.000000', 'temperatura', 374.0000, 'ºC'),
	(304662, 145, '2015-01-01 00:32:51.000000', 'temperatura', 795.0000, 'ºC'),
	(304663, 145, '2015-01-01 00:32:52.000000', 'temperatura', 453.0000, 'ºC'),
	(304664, 145, '2015-01-01 00:32:53.000000', 'temperatura', 1082.0000, 'ºC'),
	(304665, 145, '2015-01-01 00:32:54.000000', 'temperatura', 452.0000, 'ºC'),
	(304666, 145, '2015-01-01 00:32:55.000000', 'temperatura', 215.0000, 'ºC'),
	(304667, 145, '2015-01-01 00:32:56.000000', 'temperatura', 917.0000, 'ºC'),
	(304668, 145, '2015-01-01 00:32:57.000000', 'temperatura', 341.0000, 'ºC'),
	(304669, 145, '2015-01-01 00:32:58.000000', 'temperatura', 156.0000, 'ºC'),
	(304670, 145, '2015-01-01 00:32:59.000000', 'temperatura', 956.0000, 'ºC'),
	(304671, 145, '2015-01-01 00:33:00.000000', 'temperatura', 715.0000, 'ºC'),
	(304672, 145, '2015-01-01 00:33:01.000000', 'temperatura', 706.0000, 'ºC'),
	(304673, 145, '2015-01-01 00:33:02.000000', 'temperatura', 185.0000, 'ºC'),
	(304674, 145, '2015-01-01 00:33:03.000000', 'temperatura', 10.0000, 'ºC'),
	(304675, 145, '2015-01-01 00:33:04.000000', 'temperatura', 692.0000, 'ºC'),
	(304676, 145, '2015-01-01 00:33:05.000000', 'temperatura', 1032.0000, 'ºC'),
	(304677, 145, '2015-01-01 00:33:06.000000', 'temperatura', 683.0000, 'ºC'),
	(304678, 145, '2015-01-01 00:33:07.000000', 'temperatura', 319.0000, 'ºC'),
	(304679, 145, '2015-01-01 00:33:08.000000', 'temperatura', 748.0000, 'ºC'),
	(304680, 145, '2015-01-01 00:33:09.000000', 'temperatura', 384.0000, 'ºC'),
	(304681, 145, '2015-01-01 00:33:10.000000', 'temperatura', 876.0000, 'ºC'),
	(304682, 145, '2015-01-01 00:33:11.000000', 'temperatura', 830.0000, 'ºC'),
	(304683, 145, '2015-01-01 00:33:12.000000', 'temperatura', 321.0000, 'ºC'),
	(304684, 145, '2015-01-01 00:33:13.000000', 'temperatura', 317.0000, 'ºC'),
	(304685, 145, '2015-01-01 00:33:14.000000', 'temperatura', 620.0000, 'ºC'),
	(304686, 145, '2015-01-01 00:33:15.000000', 'temperatura', 952.0000, 'ºC'),
	(304687, 145, '2015-01-01 00:33:16.000000', 'temperatura', 502.0000, 'ºC'),
	(304688, 145, '2015-01-01 00:33:17.000000', 'temperatura', 851.0000, 'ºC'),
	(304689, 145, '2015-01-01 00:33:18.000000', 'temperatura', 351.0000, 'ºC'),
	(304690, 145, '2015-01-01 00:33:19.000000', 'temperatura', 403.0000, 'ºC'),
	(304691, 145, '2015-01-01 00:33:20.000000', 'temperatura', 964.0000, 'ºC'),
	(304692, 145, '2015-01-01 00:33:21.000000', 'temperatura', 10.0000, 'ºC'),
	(304693, 145, '2015-01-01 00:33:22.000000', 'temperatura', 758.0000, 'ºC'),
	(304694, 145, '2015-01-01 00:33:23.000000', 'temperatura', 163.0000, 'ºC'),
	(304695, 145, '2015-01-01 00:33:24.000000', 'temperatura', 939.0000, 'ºC'),
	(304696, 145, '2015-01-01 00:33:25.000000', 'temperatura', 608.0000, 'ºC'),
	(304697, 145, '2015-01-01 00:33:26.000000', 'temperatura', 224.0000, 'ºC'),
	(304698, 145, '2015-01-01 00:33:27.000000', 'temperatura', 495.0000, 'ºC'),
	(304699, 145, '2015-01-01 00:33:28.000000', 'temperatura', 606.0000, 'ºC'),
	(304700, 145, '2015-01-01 00:33:29.000000', 'temperatura', 345.0000, 'ºC'),
	(304701, 145, '2015-01-01 00:33:30.000000', 'temperatura', 1105.0000, 'ºC'),
	(304702, 145, '2015-01-01 00:33:31.000000', 'temperatura', 892.0000, 'ºC'),
	(304703, 145, '2015-01-01 00:33:32.000000', 'temperatura', 1144.0000, 'ºC'),
	(304704, 145, '2015-01-01 00:33:33.000000', 'temperatura', 645.0000, 'ºC'),
	(304705, 145, '2015-01-01 00:33:34.000000', 'temperatura', 994.0000, 'ºC'),
	(304706, 145, '2015-01-01 00:33:35.000000', 'temperatura', 634.0000, 'ºC'),
	(304707, 145, '2015-01-01 00:33:36.000000', 'temperatura', 190.0000, 'ºC'),
	(304708, 145, '2015-01-01 00:33:37.000000', 'temperatura', 250.0000, 'ºC'),
	(304709, 145, '2015-01-01 00:33:38.000000', 'temperatura', 680.0000, 'ºC'),
	(304710, 145, '2015-01-01 00:33:39.000000', 'temperatura', 249.0000, 'ºC'),
	(304711, 145, '2015-01-01 00:33:40.000000', 'temperatura', 407.0000, 'ºC'),
	(304712, 145, '2015-01-01 00:33:41.000000', 'temperatura', 87.0000, 'ºC'),
	(304713, 145, '2015-01-01 00:33:42.000000', 'temperatura', 417.0000, 'ºC'),
	(304714, 145, '2015-01-01 00:33:43.000000', 'temperatura', 623.0000, 'ºC'),
	(304715, 145, '2015-01-01 00:33:44.000000', 'temperatura', 666.0000, 'ºC'),
	(304716, 145, '2015-01-01 00:33:45.000000', 'temperatura', 259.0000, 'ºC'),
	(304717, 145, '2015-01-01 00:33:46.000000', 'temperatura', 498.0000, 'ºC'),
	(304718, 145, '2015-01-01 00:33:47.000000', 'temperatura', 514.0000, 'ºC'),
	(304719, 145, '2015-01-01 00:33:48.000000', 'temperatura', 1077.0000, 'ºC'),
	(304720, 145, '2015-01-01 00:33:49.000000', 'temperatura', 243.0000, 'ºC'),
	(304721, 145, '2015-01-01 00:33:50.000000', 'temperatura', 387.0000, 'ºC'),
	(304722, 145, '2015-01-01 00:33:51.000000', 'temperatura', 3.0000, 'ºC'),
	(304723, 145, '2015-01-01 00:33:52.000000', 'temperatura', 57.0000, 'ºC'),
	(304724, 145, '2015-01-01 00:33:53.000000', 'temperatura', 276.0000, 'ºC'),
	(304725, 145, '2015-01-01 00:33:54.000000', 'temperatura', 10.0000, 'ºC'),
	(304726, 145, '2015-01-01 00:33:55.000000', 'temperatura', 422.0000, 'ºC'),
	(304727, 145, '2015-01-01 00:33:56.000000', 'temperatura', 879.0000, 'ºC'),
	(304728, 145, '2015-01-01 00:33:57.000000', 'temperatura', 731.0000, 'ºC'),
	(304729, 145, '2015-01-01 00:33:58.000000', 'temperatura', 1019.0000, 'ºC'),
	(304730, 145, '2015-01-01 00:33:59.000000', 'temperatura', 502.0000, 'ºC'),
	(304731, 145, '2015-01-01 00:34:00.000000', 'temperatura', 653.0000, 'ºC'),
	(304732, 145, '2015-01-01 00:34:01.000000', 'temperatura', 558.0000, 'ºC'),
	(304733, 145, '2015-01-01 00:34:02.000000', 'temperatura', 833.0000, 'ºC'),
	(304734, 145, '2015-01-01 00:34:03.000000', 'temperatura', 93.0000, 'ºC'),
	(304735, 145, '2015-01-01 00:34:04.000000', 'temperatura', 365.0000, 'ºC'),
	(304736, 145, '2015-01-01 00:34:05.000000', 'temperatura', 348.0000, 'ºC'),
	(304737, 145, '2015-01-01 00:34:06.000000', 'temperatura', 643.0000, 'ºC'),
	(304738, 145, '2015-01-01 00:34:07.000000', 'temperatura', 973.0000, 'ºC'),
	(304739, 145, '2015-01-01 00:34:08.000000', 'temperatura', 534.0000, 'ºC'),
	(304740, 145, '2015-01-01 00:34:09.000000', 'temperatura', 955.0000, 'ºC'),
	(304741, 145, '2015-01-01 00:34:10.000000', 'temperatura', 772.0000, 'ºC'),
	(304742, 145, '2015-01-01 00:34:11.000000', 'temperatura', 996.0000, 'ºC'),
	(304743, 145, '2015-01-01 00:34:12.000000', 'temperatura', 264.0000, 'ºC'),
	(304744, 145, '2015-01-01 00:34:13.000000', 'temperatura', 733.0000, 'ºC'),
	(304745, 145, '2015-01-01 00:34:14.000000', 'temperatura', 472.0000, 'ºC'),
	(304746, 145, '2015-01-01 00:34:15.000000', 'temperatura', 164.0000, 'ºC'),
	(304747, 145, '2015-01-01 00:34:16.000000', 'temperatura', 606.0000, 'ºC'),
	(304748, 145, '2015-01-01 00:34:17.000000', 'temperatura', 135.0000, 'ºC'),
	(304749, 145, '2015-01-01 00:34:18.000000', 'temperatura', 57.0000, 'ºC'),
	(304750, 145, '2015-01-01 00:34:19.000000', 'temperatura', 1080.0000, 'ºC'),
	(304751, 145, '2015-01-01 00:34:20.000000', 'temperatura', 432.0000, 'ºC'),
	(304752, 145, '2015-01-01 00:34:21.000000', 'temperatura', 118.0000, 'ºC'),
	(304753, 145, '2015-01-01 00:34:22.000000', 'temperatura', 497.0000, 'ºC'),
	(304754, 145, '2015-01-01 00:34:23.000000', 'temperatura', 931.0000, 'ºC'),
	(304755, 145, '2015-01-01 00:34:24.000000', 'temperatura', 765.0000, 'ºC'),
	(304756, 145, '2015-01-01 00:34:25.000000', 'temperatura', 1033.0000, 'ºC'),
	(304757, 145, '2015-01-01 00:34:26.000000', 'temperatura', 469.0000, 'ºC'),
	(304758, 145, '2015-01-01 00:34:27.000000', 'temperatura', 449.0000, 'ºC'),
	(304759, 145, '2015-01-01 00:34:28.000000', 'temperatura', 837.0000, 'ºC'),
	(304760, 145, '2015-01-01 00:34:29.000000', 'temperatura', 436.0000, 'ºC'),
	(304761, 145, '2015-01-01 00:34:30.000000', 'temperatura', 873.0000, 'ºC'),
	(304762, 145, '2015-01-01 00:34:31.000000', 'temperatura', 657.0000, 'ºC'),
	(304763, 145, '2015-01-01 00:34:32.000000', 'temperatura', 666.0000, 'ºC'),
	(304764, 145, '2015-01-01 00:34:33.000000', 'temperatura', 161.0000, 'ºC'),
	(304765, 145, '2015-01-01 00:34:34.000000', 'temperatura', 5.0000, 'ºC'),
	(304766, 145, '2015-01-01 00:34:35.000000', 'temperatura', 745.0000, 'ºC'),
	(304767, 145, '2015-01-01 00:34:36.000000', 'temperatura', 112.0000, 'ºC'),
	(304768, 145, '2015-01-01 00:34:37.000000', 'temperatura', 722.0000, 'ºC'),
	(304769, 145, '2015-01-01 00:34:38.000000', 'temperatura', 876.0000, 'ºC'),
	(304770, 145, '2015-01-01 00:34:39.000000', 'temperatura', 1015.0000, 'ºC'),
	(304771, 145, '2015-01-01 00:34:40.000000', 'temperatura', 46.0000, 'ºC'),
	(304772, 145, '2015-01-01 00:34:41.000000', 'temperatura', 786.0000, 'ºC'),
	(304773, 145, '2015-01-01 00:34:42.000000', 'temperatura', 194.0000, 'ºC'),
	(304774, 145, '2015-01-01 00:34:43.000000', 'temperatura', 1010.0000, 'ºC'),
	(304775, 145, '2015-01-01 00:34:44.000000', 'temperatura', 867.0000, 'ºC'),
	(304776, 145, '2015-01-01 00:34:45.000000', 'temperatura', 109.0000, 'ºC'),
	(304777, 145, '2015-01-01 00:34:46.000000', 'temperatura', 345.0000, 'ºC'),
	(304778, 145, '2015-01-01 00:34:47.000000', 'temperatura', 198.0000, 'ºC'),
	(304779, 145, '2015-01-01 00:34:48.000000', 'temperatura', 1155.0000, 'ºC'),
	(304780, 145, '2015-01-01 00:34:49.000000', 'temperatura', 381.0000, 'ºC'),
	(304781, 145, '2015-01-01 00:34:50.000000', 'temperatura', 839.0000, 'ºC'),
	(304782, 145, '2015-01-01 00:34:51.000000', 'temperatura', 654.0000, 'ºC'),
	(304783, 145, '2015-01-01 00:34:52.000000', 'temperatura', 755.0000, 'ºC'),
	(304784, 145, '2015-01-01 00:34:53.000000', 'temperatura', 612.0000, 'ºC'),
	(304785, 145, '2015-01-01 00:34:54.000000', 'temperatura', 795.0000, 'ºC'),
	(304786, 145, '2015-01-01 00:34:55.000000', 'temperatura', 939.0000, 'ºC'),
	(304787, 145, '2015-01-01 00:34:56.000000', 'temperatura', 1110.0000, 'ºC'),
	(304788, 145, '2015-01-01 00:34:57.000000', 'temperatura', 335.0000, 'ºC'),
	(304789, 145, '2015-01-01 00:34:58.000000', 'temperatura', 745.0000, 'ºC'),
	(304790, 145, '2015-01-01 00:34:59.000000', 'temperatura', 319.0000, 'ºC'),
	(304791, 145, '2015-01-01 00:35:00.000000', 'temperatura', 563.0000, 'ºC'),
	(304792, 145, '2015-01-01 00:35:01.000000', 'temperatura', 656.0000, 'ºC'),
	(304793, 145, '2015-01-01 00:35:02.000000', 'temperatura', 394.0000, 'ºC'),
	(304794, 145, '2015-01-01 00:35:03.000000', 'temperatura', 3.0000, 'ºC'),
	(304795, 145, '2015-01-01 00:35:04.000000', 'temperatura', 32.0000, 'ºC'),
	(304796, 145, '2015-01-01 00:35:05.000000', 'temperatura', 150.0000, 'ºC'),
	(304797, 145, '2015-01-01 00:35:06.000000', 'temperatura', 656.0000, 'ºC'),
	(304798, 145, '2015-01-01 00:35:07.000000', 'temperatura', 429.0000, 'ºC'),
	(304799, 145, '2015-01-01 00:35:08.000000', 'temperatura', 178.0000, 'ºC'),
	(304800, 145, '2015-01-01 00:35:09.000000', 'temperatura', 803.0000, 'ºC'),
	(304801, 145, '2015-01-01 00:35:10.000000', 'temperatura', 1080.0000, 'ºC'),
	(304802, 145, '2015-01-01 00:35:11.000000', 'temperatura', 593.0000, 'ºC'),
	(304803, 145, '2015-01-01 00:35:12.000000', 'temperatura', 927.0000, 'ºC'),
	(304804, 145, '2015-01-01 00:35:13.000000', 'temperatura', 454.0000, 'ºC'),
	(304805, 145, '2015-01-01 00:35:14.000000', 'temperatura', 689.0000, 'ºC'),
	(304806, 145, '2015-01-01 00:35:15.000000', 'temperatura', 883.0000, 'ºC'),
	(304807, 145, '2015-01-01 00:35:16.000000', 'temperatura', 1149.0000, 'ºC'),
	(304808, 145, '2015-01-01 00:35:17.000000', 'temperatura', 698.0000, 'ºC'),
	(304809, 145, '2015-01-01 00:35:18.000000', 'temperatura', 43.0000, 'ºC'),
	(304810, 145, '2015-01-01 00:35:19.000000', 'temperatura', 522.0000, 'ºC'),
	(304811, 145, '2015-01-01 00:35:20.000000', 'temperatura', 81.0000, 'ºC'),
	(304812, 145, '2015-01-01 00:35:21.000000', 'temperatura', 38.0000, 'ºC'),
	(304813, 145, '2015-01-01 00:35:22.000000', 'temperatura', 1147.0000, 'ºC'),
	(304814, 145, '2015-01-01 00:35:23.000000', 'temperatura', 824.0000, 'ºC'),
	(304815, 145, '2015-01-01 00:35:24.000000', 'temperatura', 677.0000, 'ºC'),
	(304816, 145, '2015-01-01 00:35:25.000000', 'temperatura', 913.0000, 'ºC'),
	(304817, 145, '2015-01-01 00:35:26.000000', 'temperatura', 136.0000, 'ºC'),
	(304818, 145, '2015-01-01 00:35:27.000000', 'temperatura', 343.0000, 'ºC'),
	(304819, 145, '2015-01-01 00:35:28.000000', 'temperatura', 107.0000, 'ºC'),
	(304820, 145, '2015-01-01 00:35:29.000000', 'temperatura', 704.0000, 'ºC'),
	(304821, 145, '2015-01-01 00:35:30.000000', 'temperatura', 801.0000, 'ºC'),
	(304822, 145, '2015-01-01 00:35:31.000000', 'temperatura', 692.0000, 'ºC'),
	(304823, 145, '2015-01-01 00:35:32.000000', 'temperatura', 1057.0000, 'ºC'),
	(304824, 145, '2015-01-01 00:35:33.000000', 'temperatura', 809.0000, 'ºC'),
	(304825, 145, '2015-01-01 00:35:34.000000', 'temperatura', 876.0000, 'ºC'),
	(304826, 145, '2015-01-01 00:35:35.000000', 'temperatura', 754.0000, 'ºC'),
	(304827, 145, '2015-01-01 00:35:36.000000', 'temperatura', 1141.0000, 'ºC'),
	(304828, 145, '2015-01-01 00:35:37.000000', 'temperatura', 1043.0000, 'ºC'),
	(304829, 145, '2015-01-01 00:35:38.000000', 'temperatura', 593.0000, 'ºC'),
	(304830, 145, '2015-01-01 00:35:39.000000', 'temperatura', 1039.0000, 'ºC'),
	(304831, 145, '2015-01-01 00:35:40.000000', 'temperatura', 1014.0000, 'ºC'),
	(304832, 145, '2015-01-01 00:35:41.000000', 'temperatura', 754.0000, 'ºC'),
	(304833, 145, '2015-01-01 00:35:42.000000', 'temperatura', 730.0000, 'ºC'),
	(304834, 145, '2015-01-01 00:35:43.000000', 'temperatura', 189.0000, 'ºC'),
	(304835, 145, '2015-01-01 00:35:44.000000', 'temperatura', 1154.0000, 'ºC'),
	(304836, 145, '2015-01-01 00:35:45.000000', 'temperatura', 405.0000, 'ºC'),
	(304837, 145, '2015-01-01 00:35:46.000000', 'temperatura', 962.0000, 'ºC'),
	(304838, 145, '2015-01-01 00:35:47.000000', 'temperatura', 1195.0000, 'ºC'),
	(304839, 145, '2015-01-01 00:35:48.000000', 'temperatura', 692.0000, 'ºC'),
	(304840, 145, '2015-01-01 00:35:49.000000', 'temperatura', 1075.0000, 'ºC'),
	(304841, 145, '2015-01-01 00:35:50.000000', 'temperatura', 900.0000, 'ºC'),
	(304842, 145, '2015-01-01 00:35:51.000000', 'temperatura', 74.0000, 'ºC'),
	(304843, 145, '2015-01-01 00:35:52.000000', 'temperatura', 72.0000, 'ºC'),
	(304844, 145, '2015-01-01 00:35:53.000000', 'temperatura', 138.0000, 'ºC'),
	(304845, 145, '2015-01-01 00:35:54.000000', 'temperatura', 475.0000, 'ºC'),
	(304846, 145, '2015-01-01 00:35:55.000000', 'temperatura', 759.0000, 'ºC'),
	(304847, 145, '2015-01-01 00:35:56.000000', 'temperatura', 1174.0000, 'ºC'),
	(304848, 145, '2015-01-01 00:35:57.000000', 'temperatura', 1192.0000, 'ºC'),
	(304849, 145, '2015-01-01 00:35:58.000000', 'temperatura', 37.0000, 'ºC'),
	(304850, 145, '2015-01-01 00:35:59.000000', 'temperatura', 212.0000, 'ºC'),
	(304851, 145, '2015-01-01 00:36:00.000000', 'temperatura', 948.0000, 'ºC'),
	(304852, 145, '2015-01-01 00:36:01.000000', 'temperatura', 507.0000, 'ºC'),
	(304853, 145, '2015-01-01 00:36:02.000000', 'temperatura', 889.0000, 'ºC'),
	(304854, 145, '2015-01-01 00:36:03.000000', 'temperatura', 525.0000, 'ºC'),
	(304855, 145, '2015-01-01 00:36:04.000000', 'temperatura', 1158.0000, 'ºC'),
	(304856, 145, '2015-01-01 00:36:05.000000', 'temperatura', 618.0000, 'ºC'),
	(304857, 145, '2015-01-01 00:36:06.000000', 'temperatura', 813.0000, 'ºC'),
	(304858, 145, '2015-01-01 00:36:07.000000', 'temperatura', 1013.0000, 'ºC'),
	(304859, 145, '2015-01-01 00:36:08.000000', 'temperatura', 228.0000, 'ºC'),
	(304860, 145, '2015-01-01 00:36:09.000000', 'temperatura', 500.0000, 'ºC'),
	(304861, 145, '2015-01-01 00:36:10.000000', 'temperatura', 616.0000, 'ºC'),
	(304862, 145, '2015-01-01 00:36:11.000000', 'temperatura', 380.0000, 'ºC'),
	(304863, 145, '2015-01-01 00:36:12.000000', 'temperatura', 54.0000, 'ºC'),
	(304864, 145, '2015-01-01 00:36:13.000000', 'temperatura', 332.0000, 'ºC'),
	(304865, 145, '2015-01-01 00:36:14.000000', 'temperatura', 296.0000, 'ºC'),
	(304866, 145, '2015-01-01 00:36:15.000000', 'temperatura', 484.0000, 'ºC'),
	(304867, 145, '2015-01-01 00:36:16.000000', 'temperatura', 334.0000, 'ºC'),
	(304868, 145, '2015-01-01 00:36:17.000000', 'temperatura', 219.0000, 'ºC'),
	(304869, 145, '2015-01-01 00:36:18.000000', 'temperatura', 93.0000, 'ºC'),
	(304870, 145, '2015-01-01 00:36:19.000000', 'temperatura', 1010.0000, 'ºC'),
	(304871, 145, '2015-01-01 00:36:20.000000', 'temperatura', 1172.0000, 'ºC'),
	(304872, 145, '2015-01-01 00:36:21.000000', 'temperatura', 428.0000, 'ºC'),
	(304873, 145, '2015-01-01 00:36:22.000000', 'temperatura', 1026.0000, 'ºC'),
	(304874, 145, '2015-01-01 00:36:23.000000', 'temperatura', 245.0000, 'ºC'),
	(304875, 145, '2015-01-01 00:36:24.000000', 'temperatura', 548.0000, 'ºC'),
	(304876, 145, '2015-01-01 00:36:25.000000', 'temperatura', 805.0000, 'ºC'),
	(304877, 145, '2015-01-01 00:36:26.000000', 'temperatura', 1181.0000, 'ºC'),
	(304878, 145, '2015-01-01 00:36:27.000000', 'temperatura', 1089.0000, 'ºC'),
	(304879, 145, '2015-01-01 00:36:28.000000', 'temperatura', 706.0000, 'ºC'),
	(304880, 145, '2015-01-01 00:36:29.000000', 'temperatura', 263.0000, 'ºC'),
	(304881, 145, '2015-01-01 00:36:30.000000', 'temperatura', 396.0000, 'ºC'),
	(304882, 145, '2015-01-01 00:36:31.000000', 'temperatura', 1192.0000, 'ºC'),
	(304883, 145, '2015-01-01 00:36:32.000000', 'temperatura', 1173.0000, 'ºC'),
	(304884, 145, '2015-01-01 00:36:33.000000', 'temperatura', 1091.0000, 'ºC'),
	(304885, 145, '2015-01-01 00:36:34.000000', 'temperatura', 734.0000, 'ºC'),
	(304886, 145, '2015-01-01 00:36:35.000000', 'temperatura', 400.0000, 'ºC'),
	(304887, 145, '2015-01-01 00:36:36.000000', 'temperatura', 998.0000, 'ºC'),
	(304888, 145, '2015-01-01 00:36:37.000000', 'temperatura', 189.0000, 'ºC'),
	(304889, 145, '2015-01-01 00:36:38.000000', 'temperatura', 351.0000, 'ºC'),
	(304890, 145, '2015-01-01 00:36:39.000000', 'temperatura', 1191.0000, 'ºC'),
	(304891, 145, '2015-01-01 00:36:40.000000', 'temperatura', 101.0000, 'ºC'),
	(304892, 145, '2015-01-01 00:36:41.000000', 'temperatura', 534.0000, 'ºC'),
	(304893, 145, '2015-01-01 00:36:42.000000', 'temperatura', 1165.0000, 'ºC'),
	(304894, 145, '2015-01-01 00:36:43.000000', 'temperatura', 626.0000, 'ºC'),
	(304895, 145, '2015-01-01 00:36:44.000000', 'temperatura', 834.0000, 'ºC'),
	(304896, 145, '2015-01-01 00:36:45.000000', 'temperatura', 1094.0000, 'ºC'),
	(304897, 145, '2015-01-01 00:36:46.000000', 'temperatura', 566.0000, 'ºC'),
	(304898, 145, '2015-01-01 00:36:47.000000', 'temperatura', 751.0000, 'ºC'),
	(304899, 145, '2015-01-01 00:36:48.000000', 'temperatura', 856.0000, 'ºC'),
	(304900, 145, '2015-01-01 00:36:49.000000', 'temperatura', 828.0000, 'ºC'),
	(304901, 145, '2015-01-01 00:36:50.000000', 'temperatura', 374.0000, 'ºC'),
	(304902, 145, '2015-01-01 00:36:51.000000', 'temperatura', 585.0000, 'ºC'),
	(304903, 145, '2015-01-01 00:36:52.000000', 'temperatura', 603.0000, 'ºC'),
	(304904, 145, '2015-01-01 00:36:53.000000', 'temperatura', 60.0000, 'ºC'),
	(304905, 145, '2015-01-01 00:36:54.000000', 'temperatura', 894.0000, 'ºC'),
	(304906, 145, '2015-01-01 00:36:55.000000', 'temperatura', 689.0000, 'ºC'),
	(304907, 145, '2015-01-01 00:36:56.000000', 'temperatura', 762.0000, 'ºC'),
	(304908, 145, '2015-01-01 00:36:57.000000', 'temperatura', 545.0000, 'ºC'),
	(304909, 145, '2015-01-01 00:36:58.000000', 'temperatura', 440.0000, 'ºC'),
	(304910, 145, '2015-01-01 00:36:59.000000', 'temperatura', 563.0000, 'ºC'),
	(304911, 145, '2015-01-01 00:37:00.000000', 'temperatura', 298.0000, 'ºC'),
	(304912, 145, '2015-01-01 00:37:01.000000', 'temperatura', 999.0000, 'ºC'),
	(304913, 145, '2015-01-01 00:37:02.000000', 'temperatura', 504.0000, 'ºC'),
	(304914, 145, '2015-01-01 00:37:03.000000', 'temperatura', 723.0000, 'ºC'),
	(304915, 145, '2015-01-01 00:37:04.000000', 'temperatura', 905.0000, 'ºC'),
	(304916, 145, '2015-01-01 00:37:05.000000', 'temperatura', 1155.0000, 'ºC'),
	(304917, 145, '2015-01-01 00:37:06.000000', 'temperatura', 662.0000, 'ºC'),
	(304918, 145, '2015-01-01 00:37:07.000000', 'temperatura', 1043.0000, 'ºC'),
	(304919, 145, '2015-01-01 00:37:08.000000', 'temperatura', 831.0000, 'ºC'),
	(304920, 145, '2015-01-01 00:37:09.000000', 'temperatura', 1028.0000, 'ºC'),
	(304921, 145, '2015-01-01 00:37:10.000000', 'temperatura', 245.0000, 'ºC'),
	(304922, 145, '2015-01-01 00:37:11.000000', 'temperatura', 541.0000, 'ºC'),
	(304923, 145, '2015-01-01 00:37:12.000000', 'temperatura', 771.0000, 'ºC'),
	(304924, 145, '2015-01-01 00:37:13.000000', 'temperatura', 1033.0000, 'ºC'),
	(304925, 145, '2015-01-01 00:37:14.000000', 'temperatura', 451.0000, 'ºC'),
	(304926, 145, '2015-01-01 00:37:15.000000', 'temperatura', 358.0000, 'ºC'),
	(304927, 145, '2015-01-01 00:37:16.000000', 'temperatura', 436.0000, 'ºC'),
	(304928, 145, '2015-01-01 00:37:17.000000', 'temperatura', 1109.0000, 'ºC'),
	(304929, 145, '2015-01-01 00:37:18.000000', 'temperatura', 635.0000, 'ºC'),
	(304930, 145, '2015-01-01 00:37:19.000000', 'temperatura', 1049.0000, 'ºC'),
	(304931, 145, '2015-01-01 00:37:20.000000', 'temperatura', 940.0000, 'ºC'),
	(304932, 145, '2015-01-01 00:37:21.000000', 'temperatura', 352.0000, 'ºC'),
	(304933, 145, '2015-01-01 00:37:22.000000', 'temperatura', 143.0000, 'ºC'),
	(304934, 145, '2015-01-01 00:37:23.000000', 'temperatura', 858.0000, 'ºC'),
	(304935, 145, '2015-01-01 00:37:24.000000', 'temperatura', 261.0000, 'ºC'),
	(304936, 145, '2015-01-01 00:37:25.000000', 'temperatura', 1132.0000, 'ºC'),
	(304937, 145, '2015-01-01 00:37:26.000000', 'temperatura', 78.0000, 'ºC'),
	(304938, 145, '2015-01-01 00:37:27.000000', 'temperatura', 595.0000, 'ºC'),
	(304939, 145, '2015-01-01 00:37:28.000000', 'temperatura', 341.0000, 'ºC'),
	(304940, 145, '2015-01-01 00:37:29.000000', 'temperatura', 1121.0000, 'ºC'),
	(304941, 145, '2015-01-01 00:37:30.000000', 'temperatura', 981.0000, 'ºC'),
	(304942, 145, '2015-01-01 00:37:31.000000', 'temperatura', 345.0000, 'ºC'),
	(304943, 145, '2015-01-01 00:37:32.000000', 'temperatura', 1181.0000, 'ºC'),
	(304944, 145, '2015-01-01 00:37:33.000000', 'temperatura', 71.0000, 'ºC'),
	(304945, 145, '2015-01-01 00:37:34.000000', 'temperatura', 414.0000, 'ºC'),
	(304946, 145, '2015-01-01 00:37:35.000000', 'temperatura', 657.0000, 'ºC'),
	(304947, 145, '2015-01-01 00:37:36.000000', 'temperatura', 845.0000, 'ºC'),
	(304948, 145, '2015-01-01 00:37:37.000000', 'temperatura', 1053.0000, 'ºC'),
	(304949, 145, '2015-01-01 00:37:38.000000', 'temperatura', 332.0000, 'ºC'),
	(304950, 145, '2015-01-01 00:37:39.000000', 'temperatura', 899.0000, 'ºC'),
	(304951, 145, '2015-01-01 00:37:40.000000', 'temperatura', 1102.0000, 'ºC'),
	(304952, 145, '2015-01-01 00:37:41.000000', 'temperatura', 411.0000, 'ºC'),
	(304953, 145, '2015-01-01 00:37:42.000000', 'temperatura', 1149.0000, 'ºC'),
	(304954, 145, '2015-01-01 00:37:43.000000', 'temperatura', 913.0000, 'ºC'),
	(304955, 145, '2015-01-01 00:37:44.000000', 'temperatura', 1117.0000, 'ºC'),
	(304956, 145, '2015-01-01 00:37:45.000000', 'temperatura', 449.0000, 'ºC'),
	(304957, 145, '2015-01-01 00:37:46.000000', 'temperatura', 96.0000, 'ºC'),
	(304958, 145, '2015-01-01 00:37:47.000000', 'temperatura', 330.0000, 'ºC'),
	(304959, 145, '2015-01-01 00:37:48.000000', 'temperatura', 165.0000, 'ºC'),
	(304960, 145, '2015-01-01 00:37:49.000000', 'temperatura', 1033.0000, 'ºC'),
	(304961, 145, '2015-01-01 00:37:50.000000', 'temperatura', 1071.0000, 'ºC'),
	(304962, 145, '2015-01-01 00:37:51.000000', 'temperatura', 1059.0000, 'ºC'),
	(304963, 145, '2015-01-01 00:37:52.000000', 'temperatura', 880.0000, 'ºC'),
	(304964, 145, '2015-01-01 00:37:53.000000', 'temperatura', 24.0000, 'ºC'),
	(304965, 145, '2015-01-01 00:37:54.000000', 'temperatura', 1082.0000, 'ºC'),
	(304966, 145, '2015-01-01 00:37:55.000000', 'temperatura', 540.0000, 'ºC'),
	(304967, 145, '2015-01-01 00:37:56.000000', 'temperatura', 651.0000, 'ºC'),
	(304968, 145, '2015-01-01 00:37:57.000000', 'temperatura', 435.0000, 'ºC'),
	(304969, 145, '2015-01-01 00:37:58.000000', 'temperatura', 226.0000, 'ºC'),
	(304970, 145, '2015-01-01 00:37:59.000000', 'temperatura', 1022.0000, 'ºC'),
	(304971, 145, '2015-01-01 00:38:00.000000', 'temperatura', 836.0000, 'ºC'),
	(304972, 145, '2015-01-01 00:38:01.000000', 'temperatura', 1112.0000, 'ºC'),
	(304973, 145, '2015-01-01 00:38:02.000000', 'temperatura', 653.0000, 'ºC'),
	(304974, 145, '2015-01-01 00:38:03.000000', 'temperatura', 1132.0000, 'ºC'),
	(304975, 145, '2015-01-01 00:38:04.000000', 'temperatura', 99.0000, 'ºC'),
	(304976, 145, '2015-01-01 00:38:05.000000', 'temperatura', 699.0000, 'ºC'),
	(304977, 145, '2015-01-01 00:38:06.000000', 'temperatura', 798.0000, 'ºC'),
	(304978, 145, '2015-01-01 00:38:07.000000', 'temperatura', 694.0000, 'ºC'),
	(304979, 145, '2015-01-01 00:38:08.000000', 'temperatura', 1076.0000, 'ºC'),
	(304980, 145, '2015-01-01 00:38:09.000000', 'temperatura', 899.0000, 'ºC'),
	(304981, 145, '2015-01-01 00:38:10.000000', 'temperatura', 69.0000, 'ºC'),
	(304982, 145, '2015-01-01 00:38:11.000000', 'temperatura', 45.0000, 'ºC'),
	(304983, 145, '2015-01-01 00:38:12.000000', 'temperatura', 22.0000, 'ºC'),
	(304984, 145, '2015-01-01 00:38:13.000000', 'temperatura', 1175.0000, 'ºC'),
	(304985, 145, '2015-01-01 00:38:14.000000', 'temperatura', 1009.0000, 'ºC'),
	(304986, 145, '2015-01-01 00:38:15.000000', 'temperatura', 321.0000, 'ºC'),
	(304987, 145, '2015-01-01 00:38:16.000000', 'temperatura', 980.0000, 'ºC'),
	(304988, 145, '2015-01-01 00:38:17.000000', 'temperatura', 335.0000, 'ºC'),
	(304989, 145, '2015-01-01 00:38:18.000000', 'temperatura', 1136.0000, 'ºC'),
	(304990, 145, '2015-01-01 00:38:19.000000', 'temperatura', 1077.0000, 'ºC'),
	(304991, 145, '2015-01-01 00:38:20.000000', 'temperatura', 777.0000, 'ºC'),
	(304992, 145, '2015-01-01 00:38:21.000000', 'temperatura', 653.0000, 'ºC'),
	(304993, 145, '2015-01-01 00:38:22.000000', 'temperatura', 937.0000, 'ºC'),
	(304994, 145, '2015-01-01 00:38:23.000000', 'temperatura', 326.0000, 'ºC'),
	(304995, 145, '2015-01-01 00:38:24.000000', 'temperatura', 18.0000, 'ºC'),
	(304996, 145, '2015-01-01 00:38:25.000000', 'temperatura', 315.0000, 'ºC'),
	(304997, 145, '2015-01-01 00:38:26.000000', 'temperatura', 319.0000, 'ºC'),
	(304998, 145, '2015-01-01 00:38:27.000000', 'temperatura', 651.0000, 'ºC'),
	(304999, 145, '2015-01-01 00:38:28.000000', 'temperatura', 1100.0000, 'ºC'),
	(305000, 145, '2015-01-01 00:38:29.000000', 'temperatura', 1148.0000, 'ºC'),
	(305001, 145, '2015-01-01 00:38:30.000000', 'temperatura', 40.0000, 'ºC'),
	(305002, 145, '2015-01-01 00:38:31.000000', 'temperatura', 355.0000, 'ºC'),
	(305003, 145, '2015-01-01 00:38:32.000000', 'temperatura', 458.0000, 'ºC'),
	(305004, 145, '2015-01-01 00:38:33.000000', 'temperatura', 26.0000, 'ºC'),
	(305005, 145, '2015-01-01 00:38:34.000000', 'temperatura', 1154.0000, 'ºC'),
	(305006, 145, '2015-01-01 00:38:35.000000', 'temperatura', 894.0000, 'ºC'),
	(305007, 145, '2015-01-01 00:38:36.000000', 'temperatura', 1008.0000, 'ºC'),
	(305008, 145, '2015-01-01 00:38:37.000000', 'temperatura', 1160.0000, 'ºC'),
	(305009, 145, '2015-01-01 00:38:38.000000', 'temperatura', 377.0000, 'ºC'),
	(305010, 145, '2015-01-01 00:38:39.000000', 'temperatura', 806.0000, 'ºC'),
	(305011, 145, '2015-01-01 00:38:40.000000', 'temperatura', 497.0000, 'ºC'),
	(305012, 145, '2015-01-01 00:38:41.000000', 'temperatura', 68.0000, 'ºC'),
	(305013, 145, '2015-01-01 00:38:42.000000', 'temperatura', 49.0000, 'ºC'),
	(305014, 145, '2015-01-01 00:38:43.000000', 'temperatura', 43.0000, 'ºC'),
	(305015, 145, '2015-01-01 00:38:44.000000', 'temperatura', 68.0000, 'ºC'),
	(305016, 145, '2015-01-01 00:38:45.000000', 'temperatura', 210.0000, 'ºC'),
	(305017, 145, '2015-01-01 00:38:46.000000', 'temperatura', 847.0000, 'ºC'),
	(305018, 145, '2015-01-01 00:38:47.000000', 'temperatura', 4.0000, 'ºC'),
	(305019, 145, '2015-01-01 00:38:48.000000', 'temperatura', 1080.0000, 'ºC'),
	(305020, 145, '2015-01-01 00:38:49.000000', 'temperatura', 588.0000, 'ºC'),
	(305021, 145, '2015-01-01 00:38:50.000000', 'temperatura', 899.0000, 'ºC'),
	(305022, 145, '2015-01-01 00:38:51.000000', 'temperatura', 334.0000, 'ºC'),
	(305023, 145, '2015-01-01 00:38:52.000000', 'temperatura', 175.0000, 'ºC'),
	(305024, 145, '2015-01-01 00:38:53.000000', 'temperatura', 1072.0000, 'ºC'),
	(305025, 145, '2015-01-01 00:38:54.000000', 'temperatura', 35.0000, 'ºC'),
	(305026, 145, '2015-01-01 00:38:55.000000', 'temperatura', 558.0000, 'ºC'),
	(305027, 145, '2015-01-01 00:38:56.000000', 'temperatura', 287.0000, 'ºC'),
	(305028, 145, '2015-01-01 00:38:57.000000', 'temperatura', 960.0000, 'ºC'),
	(305029, 145, '2015-01-01 00:38:58.000000', 'temperatura', 341.0000, 'ºC'),
	(305030, 145, '2015-01-01 00:38:59.000000', 'temperatura', 27.0000, 'ºC'),
	(305031, 145, '2015-01-01 00:39:00.000000', 'temperatura', 311.0000, 'ºC'),
	(305032, 145, '2015-01-01 00:39:01.000000', 'temperatura', 273.0000, 'ºC'),
	(305033, 145, '2015-01-01 00:39:02.000000', 'temperatura', 433.0000, 'ºC'),
	(305034, 145, '2015-01-01 00:39:03.000000', 'temperatura', 147.0000, 'ºC'),
	(305035, 145, '2015-01-01 00:39:04.000000', 'temperatura', 635.0000, 'ºC'),
	(305036, 145, '2015-01-01 00:39:05.000000', 'temperatura', 335.0000, 'ºC'),
	(305037, 145, '2015-01-01 00:39:06.000000', 'temperatura', 972.0000, 'ºC'),
	(305038, 145, '2015-01-01 00:39:07.000000', 'temperatura', 255.0000, 'ºC'),
	(305039, 145, '2015-01-01 00:39:08.000000', 'temperatura', 759.0000, 'ºC'),
	(305040, 145, '2015-01-01 00:39:09.000000', 'temperatura', 631.0000, 'ºC'),
	(305041, 145, '2015-01-01 00:39:10.000000', 'temperatura', 879.0000, 'ºC'),
	(305042, 145, '2015-01-01 00:39:11.000000', 'temperatura', 102.0000, 'ºC'),
	(305043, 145, '2015-01-01 00:39:12.000000', 'temperatura', 271.0000, 'ºC'),
	(305044, 145, '2015-01-01 00:39:13.000000', 'temperatura', 1053.0000, 'ºC'),
	(305045, 145, '2015-01-01 00:39:14.000000', 'temperatura', 852.0000, 'ºC'),
	(305046, 145, '2015-01-01 00:39:15.000000', 'temperatura', 1100.0000, 'ºC'),
	(305047, 145, '2015-01-01 00:39:16.000000', 'temperatura', 543.0000, 'ºC'),
	(305048, 145, '2015-01-01 00:39:17.000000', 'temperatura', 619.0000, 'ºC'),
	(305049, 145, '2015-01-01 00:39:18.000000', 'temperatura', 264.0000, 'ºC'),
	(305050, 145, '2015-01-01 00:39:19.000000', 'temperatura', 663.0000, 'ºC'),
	(305051, 145, '2015-01-01 00:39:20.000000', 'temperatura', 125.0000, 'ºC'),
	(305052, 145, '2015-01-01 00:39:21.000000', 'temperatura', 1035.0000, 'ºC'),
	(305053, 145, '2015-01-01 00:39:22.000000', 'temperatura', 0.0000, 'ºC'),
	(305054, 145, '2015-01-01 00:39:23.000000', 'temperatura', 495.0000, 'ºC'),
	(305055, 145, '2015-01-01 00:39:24.000000', 'temperatura', 77.0000, 'ºC'),
	(305056, 145, '2015-01-01 00:39:25.000000', 'temperatura', 98.0000, 'ºC'),
	(305057, 145, '2015-01-01 00:39:26.000000', 'temperatura', 263.0000, 'ºC'),
	(305058, 145, '2015-01-01 00:39:27.000000', 'temperatura', 1019.0000, 'ºC'),
	(305059, 145, '2015-01-01 00:39:28.000000', 'temperatura', 705.0000, 'ºC'),
	(305060, 145, '2015-01-01 00:39:29.000000', 'temperatura', 472.0000, 'ºC'),
	(305061, 145, '2015-01-01 00:39:30.000000', 'temperatura', 245.0000, 'ºC'),
	(305062, 145, '2015-01-01 00:39:31.000000', 'temperatura', 1007.0000, 'ºC'),
	(305063, 145, '2015-01-01 00:39:32.000000', 'temperatura', 702.0000, 'ºC'),
	(305064, 145, '2015-01-01 00:39:33.000000', 'temperatura', 491.0000, 'ºC'),
	(305065, 145, '2015-01-01 00:39:34.000000', 'temperatura', 347.0000, 'ºC'),
	(305066, 145, '2015-01-01 00:39:35.000000', 'temperatura', 264.0000, 'ºC'),
	(305067, 145, '2015-01-01 00:39:36.000000', 'temperatura', 281.0000, 'ºC'),
	(305068, 145, '2015-01-01 00:39:37.000000', 'temperatura', 613.0000, 'ºC'),
	(305069, 145, '2015-01-01 00:39:38.000000', 'temperatura', 1021.0000, 'ºC'),
	(305070, 145, '2015-01-01 00:39:39.000000', 'temperatura', 869.0000, 'ºC'),
	(305071, 145, '2015-01-01 00:39:40.000000', 'temperatura', 81.0000, 'ºC'),
	(305072, 145, '2015-01-01 00:39:41.000000', 'temperatura', 197.0000, 'ºC'),
	(305073, 145, '2015-01-01 00:39:42.000000', 'temperatura', 743.0000, 'ºC'),
	(305074, 145, '2015-01-01 00:39:43.000000', 'temperatura', 727.0000, 'ºC'),
	(305075, 145, '2015-01-01 00:39:44.000000', 'temperatura', 203.0000, 'ºC'),
	(305076, 145, '2015-01-01 00:39:45.000000', 'temperatura', 36.0000, 'ºC'),
	(305077, 145, '2015-01-01 00:39:46.000000', 'temperatura', 772.0000, 'ºC'),
	(305078, 145, '2015-01-01 00:39:47.000000', 'temperatura', 151.0000, 'ºC'),
	(305079, 145, '2015-01-01 00:39:48.000000', 'temperatura', 840.0000, 'ºC'),
	(305080, 145, '2015-01-01 00:39:49.000000', 'temperatura', 148.0000, 'ºC'),
	(305081, 145, '2015-01-01 00:39:50.000000', 'temperatura', 620.0000, 'ºC'),
	(305082, 145, '2015-01-01 00:39:51.000000', 'temperatura', 258.0000, 'ºC'),
	(305083, 145, '2015-01-01 00:39:52.000000', 'temperatura', 630.0000, 'ºC'),
	(305084, 145, '2015-01-01 00:39:53.000000', 'temperatura', 1175.0000, 'ºC'),
	(305085, 145, '2015-01-01 00:39:54.000000', 'temperatura', 388.0000, 'ºC'),
	(305086, 145, '2015-01-01 00:39:55.000000', 'temperatura', 814.0000, 'ºC'),
	(305087, 145, '2015-01-01 00:39:56.000000', 'temperatura', 509.0000, 'ºC'),
	(305088, 145, '2015-01-01 00:39:57.000000', 'temperatura', 100.0000, 'ºC'),
	(305089, 145, '2015-01-01 00:39:58.000000', 'temperatura', 176.0000, 'ºC'),
	(305090, 145, '2015-01-01 00:39:59.000000', 'temperatura', 580.0000, 'ºC'),
	(305091, 145, '2015-01-01 00:40:00.000000', 'temperatura', 1172.0000, 'ºC'),
	(305092, 145, '2015-01-01 00:40:01.000000', 'temperatura', 519.0000, 'ºC'),
	(305093, 145, '2015-01-01 00:40:02.000000', 'temperatura', 282.0000, 'ºC'),
	(305094, 145, '2015-01-01 00:40:03.000000', 'temperatura', 1051.0000, 'ºC'),
	(305095, 145, '2015-01-01 00:40:04.000000', 'temperatura', 809.0000, 'ºC'),
	(305096, 145, '2015-01-01 00:40:05.000000', 'temperatura', 892.0000, 'ºC'),
	(305097, 145, '2015-01-01 00:40:06.000000', 'temperatura', 833.0000, 'ºC'),
	(305098, 145, '2015-01-01 00:40:07.000000', 'temperatura', 289.0000, 'ºC'),
	(305099, 145, '2015-01-01 00:40:08.000000', 'temperatura', 146.0000, 'ºC'),
	(305100, 145, '2015-01-01 00:40:09.000000', 'temperatura', 1064.0000, 'ºC'),
	(305101, 145, '2015-01-01 00:40:10.000000', 'temperatura', 84.0000, 'ºC'),
	(305102, 145, '2015-01-01 00:40:11.000000', 'temperatura', 826.0000, 'ºC'),
	(305103, 145, '2015-01-01 00:40:12.000000', 'temperatura', 279.0000, 'ºC'),
	(305104, 145, '2015-01-01 00:40:13.000000', 'temperatura', 120.0000, 'ºC'),
	(305105, 145, '2015-01-01 00:40:14.000000', 'temperatura', 961.0000, 'ºC'),
	(305106, 145, '2015-01-01 00:40:15.000000', 'temperatura', 847.0000, 'ºC'),
	(305107, 145, '2015-01-01 00:40:16.000000', 'temperatura', 150.0000, 'ºC'),
	(305108, 145, '2015-01-01 00:40:17.000000', 'temperatura', 611.0000, 'ºC'),
	(305109, 145, '2015-01-01 00:40:18.000000', 'temperatura', 206.0000, 'ºC'),
	(305110, 145, '2015-01-01 00:40:19.000000', 'temperatura', 396.0000, 'ºC'),
	(305111, 145, '2015-01-01 00:40:20.000000', 'temperatura', 165.0000, 'ºC'),
	(305112, 145, '2015-01-01 00:40:21.000000', 'temperatura', 837.0000, 'ºC'),
	(305113, 145, '2015-01-01 00:40:22.000000', 'temperatura', 88.0000, 'ºC'),
	(305114, 145, '2015-01-01 00:40:23.000000', 'temperatura', 330.0000, 'ºC'),
	(305115, 145, '2015-01-01 00:40:24.000000', 'temperatura', 189.0000, 'ºC'),
	(305116, 145, '2015-01-01 00:40:25.000000', 'temperatura', 1154.0000, 'ºC'),
	(305117, 145, '2015-01-01 00:40:26.000000', 'temperatura', 406.0000, 'ºC'),
	(305118, 145, '2015-01-01 00:40:27.000000', 'temperatura', 965.0000, 'ºC'),
	(305119, 145, '2015-01-01 00:40:28.000000', 'temperatura', 11.0000, 'ºC'),
	(305120, 145, '2015-01-01 00:40:29.000000', 'temperatura', 758.0000, 'ºC'),
	(305121, 145, '2015-01-01 00:40:30.000000', 'temperatura', 157.0000, 'ºC'),
	(305122, 145, '2015-01-01 00:40:31.000000', 'temperatura', 913.0000, 'ºC'),
	(305123, 145, '2015-01-01 00:40:32.000000', 'temperatura', 496.0000, 'ºC'),
	(305124, 145, '2015-01-01 00:40:33.000000', 'temperatura', 941.0000, 'ºC'),
	(305125, 145, '2015-01-01 00:40:34.000000', 'temperatura', 815.0000, 'ºC'),
	(305126, 145, '2015-01-01 00:40:35.000000', 'temperatura', 54.0000, 'ºC'),
	(305127, 145, '2015-01-01 00:40:36.000000', 'temperatura', 227.0000, 'ºC'),
	(305128, 145, '2015-01-01 00:40:37.000000', 'temperatura', 972.0000, 'ºC'),
	(305129, 145, '2015-01-01 00:40:38.000000', 'temperatura', 579.0000, 'ºC'),
	(305130, 145, '2015-01-01 00:40:39.000000', 'temperatura', 1180.0000, 'ºC'),
	(305131, 145, '2015-01-01 00:40:40.000000', 'temperatura', 563.0000, 'ºC'),
	(305132, 145, '2015-01-01 00:40:41.000000', 'temperatura', 476.0000, 'ºC'),
	(305133, 145, '2015-01-01 00:40:42.000000', 'temperatura', 692.0000, 'ºC'),
	(305134, 145, '2015-01-01 00:40:43.000000', 'temperatura', 834.0000, 'ºC'),
	(305135, 145, '2015-01-01 00:40:44.000000', 'temperatura', 894.0000, 'ºC'),
	(305136, 145, '2015-01-01 00:40:45.000000', 'temperatura', 769.0000, 'ºC'),
	(305137, 145, '2015-01-01 00:40:46.000000', 'temperatura', 1161.0000, 'ºC'),
	(305138, 145, '2015-01-01 00:40:47.000000', 'temperatura', 1100.0000, 'ºC'),
	(305139, 145, '2015-01-01 00:40:48.000000', 'temperatura', 815.0000, 'ºC'),
	(305140, 145, '2015-01-01 00:40:49.000000', 'temperatura', 778.0000, 'ºC'),
	(305141, 145, '2015-01-01 00:40:50.000000', 'temperatura', 245.0000, 'ºC'),
	(305142, 145, '2015-01-01 00:40:51.000000', 'temperatura', 92.0000, 'ºC'),
	(305143, 145, '2015-01-01 00:40:52.000000', 'temperatura', 925.0000, 'ºC'),
	(305144, 145, '2015-01-01 00:40:53.000000', 'temperatura', 749.0000, 'ºC'),
	(305145, 145, '2015-01-01 00:40:54.000000', 'temperatura', 970.0000, 'ºC'),
	(305146, 145, '2015-01-01 00:40:55.000000', 'temperatura', 205.0000, 'ºC'),
	(305147, 145, '2015-01-01 00:40:56.000000', 'temperatura', 516.0000, 'ºC'),
	(305148, 145, '2015-01-01 00:40:57.000000', 'temperatura', 767.0000, 'ºC'),
	(305149, 145, '2015-01-01 00:40:58.000000', 'temperatura', 1084.0000, 'ºC'),
	(305150, 145, '2015-01-01 00:40:59.000000', 'temperatura', 721.0000, 'ºC'),
	(305151, 145, '2015-01-01 00:41:00.000000', 'temperatura', 352.0000, 'ºC'),
	(305152, 145, '2015-01-01 00:41:01.000000', 'temperatura', 799.0000, 'ºC'),
	(305153, 145, '2015-01-01 00:41:02.000000', 'temperatura', 538.0000, 'ºC'),
	(305154, 145, '2015-01-01 00:41:03.000000', 'temperatura', 293.0000, 'ºC'),
	(305155, 145, '2015-01-01 00:41:04.000000', 'temperatura', 1053.0000, 'ºC'),
	(305156, 145, '2015-01-01 00:41:05.000000', 'temperatura', 785.0000, 'ºC'),
	(305157, 145, '2015-01-01 00:41:06.000000', 'temperatura', 767.0000, 'ºC'),
	(305158, 145, '2015-01-01 00:41:07.000000', 'temperatura', 279.0000, 'ºC'),
	(305159, 145, '2015-01-01 00:41:08.000000', 'temperatura', 294.0000, 'ºC'),
	(305160, 145, '2015-01-01 00:41:09.000000', 'temperatura', 637.0000, 'ºC'),
	(305161, 145, '2015-01-01 00:41:10.000000', 'temperatura', 1100.0000, 'ºC'),
	(305162, 145, '2015-01-01 00:41:11.000000', 'temperatura', 1193.0000, 'ºC'),
	(305163, 145, '2015-01-01 00:41:12.000000', 'temperatura', 263.0000, 'ºC'),
	(305164, 145, '2015-01-01 00:41:13.000000', 'temperatura', 135.0000, 'ºC'),
	(305165, 145, '2015-01-01 00:41:14.000000', 'temperatura', 1089.0000, 'ºC'),
	(305166, 145, '2015-01-01 00:41:15.000000', 'temperatura', 239.0000, 'ºC'),
	(305167, 145, '2015-01-01 00:41:16.000000', 'temperatura', 328.0000, 'ºC'),
	(305168, 145, '2015-01-01 00:41:17.000000', 'temperatura', 924.0000, 'ºC'),
	(305169, 145, '2015-01-01 00:41:18.000000', 'temperatura', 39.0000, 'ºC'),
	(305170, 145, '2015-01-01 00:41:19.000000', 'temperatura', 1021.0000, 'ºC'),
	(305171, 145, '2015-01-01 00:41:20.000000', 'temperatura', 189.0000, 'ºC'),
	(305172, 145, '2015-01-01 00:41:21.000000', 'temperatura', 283.0000, 'ºC'),
	(305173, 145, '2015-01-01 00:41:22.000000', 'temperatura', 850.0000, 'ºC'),
	(305174, 145, '2015-01-01 00:41:23.000000', 'temperatura', 1001.0000, 'ºC'),
	(305175, 145, '2015-01-01 00:41:24.000000', 'temperatura', 54.0000, 'ºC'),
	(305176, 145, '2015-01-01 00:41:25.000000', 'temperatura', 868.0000, 'ºC'),
	(305177, 145, '2015-01-01 00:41:26.000000', 'temperatura', 579.0000, 'ºC'),
	(305178, 145, '2015-01-01 00:41:27.000000', 'temperatura', 290.0000, 'ºC'),
	(305179, 145, '2015-01-01 00:41:28.000000', 'temperatura', 916.0000, 'ºC'),
	(305180, 145, '2015-01-01 00:41:29.000000', 'temperatura', 108.0000, 'ºC'),
	(305181, 145, '2015-01-01 00:41:30.000000', 'temperatura', 194.0000, 'ºC'),
	(305182, 145, '2015-01-01 00:41:31.000000', 'temperatura', 648.0000, 'ºC'),
	(305183, 145, '2015-01-01 00:41:32.000000', 'temperatura', 258.0000, 'ºC'),
	(305184, 145, '2015-01-01 00:41:33.000000', 'temperatura', 546.0000, 'ºC'),
	(305185, 145, '2015-01-01 00:41:34.000000', 'temperatura', 757.0000, 'ºC'),
	(305186, 145, '2015-01-01 00:41:35.000000', 'temperatura', 946.0000, 'ºC'),
	(305187, 145, '2015-01-01 00:41:36.000000', 'temperatura', 61.0000, 'ºC'),
	(305188, 145, '2015-01-01 00:41:37.000000', 'temperatura', 1068.0000, 'ºC'),
	(305189, 145, '2015-01-01 00:41:38.000000', 'temperatura', 357.0000, 'ºC'),
	(305190, 145, '2015-01-01 00:41:39.000000', 'temperatura', 982.0000, 'ºC'),
	(305191, 145, '2015-01-01 00:41:40.000000', 'temperatura', 237.0000, 'ºC'),
	(305192, 145, '2015-01-01 00:41:41.000000', 'temperatura', 641.0000, 'ºC'),
	(305193, 145, '2015-01-01 00:41:42.000000', 'temperatura', 94.0000, 'ºC'),
	(305194, 145, '2015-01-01 00:41:43.000000', 'temperatura', 947.0000, 'ºC'),
	(305195, 145, '2015-01-01 00:41:44.000000', 'temperatura', 856.0000, 'ºC'),
	(305196, 145, '2015-01-01 00:41:45.000000', 'temperatura', 238.0000, 'ºC'),
	(305197, 145, '2015-01-01 00:41:46.000000', 'temperatura', 1023.0000, 'ºC'),
	(305198, 145, '2015-01-01 00:41:47.000000', 'temperatura', 802.0000, 'ºC'),
	(305199, 145, '2015-01-01 00:41:48.000000', 'temperatura', 943.0000, 'ºC'),
	(305200, 145, '2015-01-01 00:41:49.000000', 'temperatura', 1108.0000, 'ºC'),
	(305201, 145, '2015-01-01 00:41:50.000000', 'temperatura', 312.0000, 'ºC'),
	(305202, 145, '2015-01-01 00:41:51.000000', 'temperatura', 638.0000, 'ºC'),
	(305203, 145, '2015-01-01 00:41:52.000000', 'temperatura', 1054.0000, 'ºC'),
	(305204, 145, '2015-01-01 00:41:53.000000', 'temperatura', 957.0000, 'ºC'),
	(305205, 145, '2015-01-01 00:41:54.000000', 'temperatura', 424.0000, 'ºC'),
	(305206, 145, '2015-01-01 00:41:55.000000', 'temperatura', 447.0000, 'ºC'),
	(305207, 145, '2015-01-01 00:41:56.000000', 'temperatura', 965.0000, 'ºC'),
	(305208, 145, '2015-01-01 00:41:57.000000', 'temperatura', 1085.0000, 'ºC'),
	(305209, 145, '2015-01-01 00:41:58.000000', 'temperatura', 130.0000, 'ºC'),
	(305210, 145, '2015-01-01 00:41:59.000000', 'temperatura', 997.0000, 'ºC'),
	(305211, 145, '2015-01-01 00:42:00.000000', 'temperatura', 996.0000, 'ºC'),
	(305212, 145, '2015-01-01 00:42:01.000000', 'temperatura', 789.0000, 'ºC'),
	(305213, 145, '2015-01-01 00:42:02.000000', 'temperatura', 958.0000, 'ºC'),
	(305214, 145, '2015-01-01 00:42:03.000000', 'temperatura', 22.0000, 'ºC'),
	(305215, 145, '2015-01-01 00:42:04.000000', 'temperatura', 838.0000, 'ºC'),
	(305216, 145, '2015-01-01 00:42:05.000000', 'temperatura', 523.0000, 'ºC'),
	(305217, 145, '2015-01-01 00:42:06.000000', 'temperatura', 101.0000, 'ºC'),
	(305218, 145, '2015-01-01 00:42:07.000000', 'temperatura', 139.0000, 'ºC'),
	(305219, 145, '2015-01-01 00:42:08.000000', 'temperatura', 392.0000, 'ºC'),
	(305220, 145, '2015-01-01 00:42:09.000000', 'temperatura', 342.0000, 'ºC'),
	(305221, 145, '2015-01-01 00:42:10.000000', 'temperatura', 535.0000, 'ºC'),
	(305222, 145, '2015-01-01 00:42:11.000000', 'temperatura', 448.0000, 'ºC'),
	(305223, 145, '2015-01-01 00:42:12.000000', 'temperatura', 638.0000, 'ºC'),
	(305224, 145, '2015-01-01 00:42:13.000000', 'temperatura', 645.0000, 'ºC'),
	(305225, 145, '2015-01-01 00:42:14.000000', 'temperatura', 111.0000, 'ºC'),
	(305226, 145, '2015-01-01 00:42:15.000000', 'temperatura', 1022.0000, 'ºC'),
	(305227, 145, '2015-01-01 00:42:16.000000', 'temperatura', 1179.0000, 'ºC'),
	(305228, 145, '2015-01-01 00:42:17.000000', 'temperatura', 428.0000, 'ºC'),
	(305229, 145, '2015-01-01 00:42:18.000000', 'temperatura', 1004.0000, 'ºC'),
	(305230, 145, '2015-01-01 00:42:19.000000', 'temperatura', 137.0000, 'ºC'),
	(305231, 145, '2015-01-01 00:42:20.000000', 'temperatura', 72.0000, 'ºC'),
	(305232, 145, '2015-01-01 00:42:21.000000', 'temperatura', 1151.0000, 'ºC'),
	(305233, 145, '2015-01-01 00:42:22.000000', 'temperatura', 738.0000, 'ºC'),
	(305234, 145, '2015-01-01 00:42:23.000000', 'temperatura', 238.0000, 'ºC'),
	(305235, 145, '2015-01-01 00:42:24.000000', 'temperatura', 175.0000, 'ºC'),
	(305236, 145, '2015-01-01 00:42:25.000000', 'temperatura', 164.0000, 'ºC'),
	(305237, 145, '2015-01-01 00:42:26.000000', 'temperatura', 293.0000, 'ºC'),
	(305238, 145, '2015-01-01 00:42:27.000000', 'temperatura', 976.0000, 'ºC'),
	(305239, 145, '2015-01-01 00:42:28.000000', 'temperatura', 402.0000, 'ºC'),
	(305240, 145, '2015-01-01 00:42:29.000000', 'temperatura', 282.0000, 'ºC'),
	(305241, 145, '2015-01-01 00:42:30.000000', 'temperatura', 205.0000, 'ºC'),
	(305242, 145, '2015-01-01 00:42:31.000000', 'temperatura', 180.0000, 'ºC'),
	(305243, 145, '2015-01-01 00:42:32.000000', 'temperatura', 286.0000, 'ºC'),
	(305244, 145, '2015-01-01 00:42:33.000000', 'temperatura', 891.0000, 'ºC'),
	(305245, 145, '2015-01-01 00:42:34.000000', 'temperatura', 1196.0000, 'ºC'),
	(305246, 145, '2015-01-01 00:42:35.000000', 'temperatura', 907.0000, 'ºC'),
	(305247, 145, '2015-01-01 00:42:36.000000', 'temperatura', 946.0000, 'ºC'),
	(305248, 145, '2015-01-01 00:42:37.000000', 'temperatura', 811.0000, 'ºC'),
	(305249, 145, '2015-01-01 00:42:38.000000', 'temperatura', 17.0000, 'ºC'),
	(305250, 145, '2015-01-01 00:42:39.000000', 'temperatura', 54.0000, 'ºC'),
	(305251, 145, '2015-01-01 00:42:40.000000', 'temperatura', 221.0000, 'ºC'),
	(305252, 145, '2015-01-01 00:42:41.000000', 'temperatura', 940.0000, 'ºC'),
	(305253, 145, '2015-01-01 00:42:42.000000', 'temperatura', 441.0000, 'ºC'),
	(305254, 145, '2015-01-01 00:42:43.000000', 'temperatura', 583.0000, 'ºC'),
	(305255, 145, '2015-01-01 00:42:44.000000', 'temperatura', 394.0000, 'ºC'),
	(305256, 145, '2015-01-01 00:42:45.000000', 'temperatura', 220.0000, 'ºC'),
	(305257, 145, '2015-01-01 00:42:46.000000', 'temperatura', 1119.0000, 'ºC'),
	(305258, 145, '2015-01-01 00:42:47.000000', 'temperatura', 136.0000, 'ºC'),
	(305259, 145, '2015-01-01 00:42:48.000000', 'temperatura', 923.0000, 'ºC'),
	(305260, 145, '2015-01-01 00:42:49.000000', 'temperatura', 609.0000, 'ºC'),
	(305261, 145, '2015-01-01 00:42:50.000000', 'temperatura', 275.0000, 'ºC'),
	(305262, 145, '2015-01-01 00:42:51.000000', 'temperatura', 748.0000, 'ºC'),
	(305263, 145, '2015-01-01 00:42:52.000000', 'temperatura', 515.0000, 'ºC'),
	(305264, 145, '2015-01-01 00:42:53.000000', 'temperatura', 333.0000, 'ºC'),
	(305265, 145, '2015-01-01 00:42:54.000000', 'temperatura', 122.0000, 'ºC'),
	(305266, 145, '2015-01-01 00:42:55.000000', 'temperatura', 810.0000, 'ºC'),
	(305267, 145, '2015-01-01 00:42:56.000000', 'temperatura', 85.0000, 'ºC'),
	(305268, 145, '2015-01-01 00:42:57.000000', 'temperatura', 396.0000, 'ºC'),
	(305269, 145, '2015-01-01 00:42:58.000000', 'temperatura', 525.0000, 'ºC'),
	(305270, 145, '2015-01-01 00:42:59.000000', 'temperatura', 237.0000, 'ºC'),
	(305271, 145, '2015-01-01 00:43:00.000000', 'temperatura', 809.0000, 'ºC'),
	(305272, 145, '2015-01-01 00:43:01.000000', 'temperatura', 935.0000, 'ºC'),
	(305273, 145, '2015-01-01 00:43:02.000000', 'temperatura', 1049.0000, 'ºC'),
	(305274, 145, '2015-01-01 00:43:03.000000', 'temperatura', 42.0000, 'ºC'),
	(305275, 145, '2015-01-01 00:43:04.000000', 'temperatura', 664.0000, 'ºC'),
	(305276, 145, '2015-01-01 00:43:05.000000', 'temperatura', 794.0000, 'ºC'),
	(305277, 145, '2015-01-01 00:43:06.000000', 'temperatura', 780.0000, 'ºC'),
	(305278, 145, '2015-01-01 00:43:07.000000', 'temperatura', 318.0000, 'ºC'),
	(305279, 145, '2015-01-01 00:43:08.000000', 'temperatura', 451.0000, 'ºC'),
	(305280, 145, '2015-01-01 00:43:09.000000', 'temperatura', 101.0000, 'ºC'),
	(305281, 145, '2015-01-01 00:43:10.000000', 'temperatura', 351.0000, 'ºC'),
	(305282, 145, '2015-01-01 00:43:11.000000', 'temperatura', 252.0000, 'ºC'),
	(305283, 145, '2015-01-01 00:43:12.000000', 'temperatura', 207.0000, 'ºC'),
	(305284, 145, '2015-01-01 00:43:13.000000', 'temperatura', 279.0000, 'ºC'),
	(305285, 145, '2015-01-01 00:43:14.000000', 'temperatura', 776.0000, 'ºC'),
	(305286, 145, '2015-01-01 00:43:15.000000', 'temperatura', 643.0000, 'ºC'),
	(305287, 145, '2015-01-01 00:43:16.000000', 'temperatura', 888.0000, 'ºC'),
	(305288, 145, '2015-01-01 00:43:17.000000', 'temperatura', 110.0000, 'ºC'),
	(305289, 145, '2015-01-01 00:43:18.000000', 'temperatura', 286.0000, 'ºC'),
	(305290, 145, '2015-01-01 00:43:19.000000', 'temperatura', 1100.0000, 'ºC'),
	(305291, 145, '2015-01-01 00:43:20.000000', 'temperatura', 1042.0000, 'ºC'),
	(305292, 145, '2015-01-01 00:43:21.000000', 'temperatura', 712.0000, 'ºC'),
	(305293, 145, '2015-01-01 00:43:22.000000', 'temperatura', 433.0000, 'ºC'),
	(305294, 145, '2015-01-01 00:43:23.000000', 'temperatura', 32.0000, 'ºC'),
	(305295, 145, '2015-01-01 00:43:24.000000', 'temperatura', 59.0000, 'ºC'),
	(305296, 145, '2015-01-01 00:43:25.000000', 'temperatura', 199.0000, 'ºC'),
	(305297, 145, '2015-01-01 00:43:26.000000', 'temperatura', 820.0000, 'ºC'),
	(305298, 145, '2015-01-01 00:43:27.000000', 'temperatura', 1103.0000, 'ºC'),
	(305299, 145, '2015-01-01 00:43:28.000000', 'temperatura', 656.0000, 'ºC'),
	(305300, 145, '2015-01-01 00:43:29.000000', 'temperatura', 1172.0000, 'ºC'),
	(305301, 145, '2015-01-01 00:43:30.000000', 'temperatura', 291.0000, 'ºC'),
	(305302, 145, '2015-01-01 00:43:31.000000', 'temperatura', 339.0000, 'ºC'),
	(305303, 145, '2015-01-01 00:43:32.000000', 'temperatura', 824.0000, 'ºC'),
	(305304, 145, '2015-01-01 00:43:33.000000', 'temperatura', 705.0000, 'ºC'),
	(305305, 145, '2015-01-01 00:43:34.000000', 'temperatura', 1053.0000, 'ºC'),
	(305306, 145, '2015-01-01 00:43:35.000000', 'temperatura', 748.0000, 'ºC'),
	(305307, 145, '2015-01-01 00:43:36.000000', 'temperatura', 585.0000, 'ºC'),
	(305308, 145, '2015-01-01 00:43:37.000000', 'temperatura', 680.0000, 'ºC'),
	(305309, 145, '2015-01-01 00:43:38.000000', 'temperatura', 444.0000, 'ºC'),
	(305310, 145, '2015-01-01 00:43:39.000000', 'temperatura', 180.0000, 'ºC'),
	(305311, 145, '2015-01-01 00:43:40.000000', 'temperatura', 771.0000, 'ºC'),
	(305312, 145, '2015-01-01 00:43:41.000000', 'temperatura', 913.0000, 'ºC'),
	(305313, 145, '2015-01-01 00:43:42.000000', 'temperatura', 1055.0000, 'ºC'),
	(305314, 145, '2015-01-01 00:43:43.000000', 'temperatura', 136.0000, 'ºC'),
	(305315, 145, '2015-01-01 00:43:44.000000', 'temperatura', 1113.0000, 'ºC'),
	(305316, 145, '2015-01-01 00:43:45.000000', 'temperatura', 360.0000, 'ºC'),
	(305317, 145, '2015-01-01 00:43:46.000000', 'temperatura', 861.0000, 'ºC'),
	(305318, 145, '2015-01-01 00:43:47.000000', 'temperatura', 827.0000, 'ºC'),
	(305319, 145, '2015-01-01 00:43:48.000000', 'temperatura', 352.0000, 'ºC'),
	(305320, 145, '2015-01-01 00:43:49.000000', 'temperatura', 479.0000, 'ºC'),
	(305321, 145, '2015-01-01 00:43:50.000000', 'temperatura', 140.0000, 'ºC'),
	(305322, 145, '2015-01-01 00:43:51.000000', 'temperatura', 464.0000, 'ºC'),
	(305323, 145, '2015-01-01 00:43:52.000000', 'temperatura', 701.0000, 'ºC'),
	(305324, 145, '2015-01-01 00:43:53.000000', 'temperatura', 913.0000, 'ºC'),
	(305325, 145, '2015-01-01 00:43:54.000000', 'temperatura', 64.0000, 'ºC'),
	(305326, 145, '2015-01-01 00:43:55.000000', 'temperatura', 1182.0000, 'ºC'),
	(305327, 145, '2015-01-01 00:43:56.000000', 'temperatura', 917.0000, 'ºC'),
	(305328, 145, '2015-01-01 00:43:57.000000', 'temperatura', 1038.0000, 'ºC'),
	(305329, 145, '2015-01-01 00:43:58.000000', 'temperatura', 41.0000, 'ºC'),
	(305330, 145, '2015-01-01 00:43:59.000000', 'temperatura', 691.0000, 'ºC'),
	(305331, 145, '2015-01-01 00:44:00.000000', 'temperatura', 931.0000, 'ºC'),
	(305332, 145, '2015-01-01 00:44:01.000000', 'temperatura', 183.0000, 'ºC'),
	(305333, 145, '2015-01-01 00:44:02.000000', 'temperatura', 522.0000, 'ºC'),
	(305334, 145, '2015-01-01 00:44:03.000000', 'temperatura', 863.0000, 'ºC'),
	(305335, 145, '2015-01-01 00:44:04.000000', 'temperatura', 349.0000, 'ºC'),
	(305336, 145, '2015-01-01 00:44:05.000000', 'temperatura', 356.0000, 'ºC'),
	(305337, 145, '2015-01-01 00:44:06.000000', 'temperatura', 734.0000, 'ºC'),
	(305338, 145, '2015-01-01 00:44:07.000000', 'temperatura', 204.0000, 'ºC'),
	(305339, 145, '2015-01-01 00:44:08.000000', 'temperatura', 19.0000, 'ºC'),
	(305340, 145, '2015-01-01 00:44:09.000000', 'temperatura', 683.0000, 'ºC'),
	(305341, 145, '2015-01-01 00:44:10.000000', 'temperatura', 959.0000, 'ºC'),
	(305342, 145, '2015-01-01 00:44:11.000000', 'temperatura', 347.0000, 'ºC'),
	(305343, 145, '2015-01-01 00:44:12.000000', 'temperatura', 60.0000, 'ºC'),
	(305344, 145, '2015-01-01 00:44:13.000000', 'temperatura', 457.0000, 'ºC'),
	(305345, 145, '2015-01-01 00:44:14.000000', 'temperatura', 905.0000, 'ºC'),
	(305346, 145, '2015-01-01 00:44:15.000000', 'temperatura', 755.0000, 'ºC'),
	(305347, 145, '2015-01-01 00:44:16.000000', 'temperatura', 1060.0000, 'ºC'),
	(305348, 145, '2015-01-01 00:44:17.000000', 'temperatura', 638.0000, 'ºC'),
	(305349, 145, '2015-01-01 00:44:18.000000', 'temperatura', 10.0000, 'ºC'),
	(305350, 145, '2015-01-01 00:44:19.000000', 'temperatura', 534.0000, 'ºC'),
	(305351, 145, '2015-01-01 00:44:20.000000', 'temperatura', 241.0000, 'ºC'),
	(305352, 145, '2015-01-01 00:44:21.000000', 'temperatura', 806.0000, 'ºC'),
	(305353, 145, '2015-01-01 00:44:22.000000', 'temperatura', 905.0000, 'ºC'),
	(305354, 145, '2015-01-01 00:44:23.000000', 'temperatura', 908.0000, 'ºC'),
	(305355, 145, '2015-01-01 00:44:24.000000', 'temperatura', 628.0000, 'ºC'),
	(305356, 145, '2015-01-01 00:44:25.000000', 'temperatura', 414.0000, 'ºC'),
	(305357, 145, '2015-01-01 00:44:26.000000', 'temperatura', 188.0000, 'ºC'),
	(305358, 145, '2015-01-01 00:44:27.000000', 'temperatura', 899.0000, 'ºC'),
	(305359, 145, '2015-01-01 00:44:28.000000', 'temperatura', 329.0000, 'ºC'),
	(305360, 145, '2015-01-01 00:44:29.000000', 'temperatura', 149.0000, 'ºC'),
	(305361, 145, '2015-01-01 00:44:30.000000', 'temperatura', 961.0000, 'ºC'),
	(305362, 145, '2015-01-01 00:44:31.000000', 'temperatura', 755.0000, 'ºC'),
	(305363, 145, '2015-01-01 00:44:32.000000', 'temperatura', 894.0000, 'ºC'),
	(305364, 145, '2015-01-01 00:44:33.000000', 'temperatura', 1007.0000, 'ºC'),
	(305365, 145, '2015-01-01 00:44:34.000000', 'temperatura', 1150.0000, 'ºC'),
	(305366, 145, '2015-01-01 00:44:35.000000', 'temperatura', 333.0000, 'ºC'),
	(305367, 145, '2015-01-01 00:44:36.000000', 'temperatura', 615.0000, 'ºC'),
	(305368, 145, '2015-01-01 00:44:37.000000', 'temperatura', 875.0000, 'ºC'),
	(305369, 145, '2015-01-01 00:44:38.000000', 'temperatura', 130.0000, 'ºC'),
	(305370, 145, '2015-01-01 00:44:39.000000', 'temperatura', 428.0000, 'ºC'),
	(305371, 145, '2015-01-01 00:44:40.000000', 'temperatura', 547.0000, 'ºC'),
	(305372, 145, '2015-01-01 00:44:41.000000', 'temperatura', 255.0000, 'ºC'),
	(305373, 145, '2015-01-01 00:44:42.000000', 'temperatura', 832.0000, 'ºC'),
	(305374, 145, '2015-01-01 00:44:43.000000', 'temperatura', 998.0000, 'ºC'),
	(305375, 145, '2015-01-01 00:44:44.000000', 'temperatura', 93.0000, 'ºC'),
	(305376, 145, '2015-01-01 00:44:45.000000', 'temperatura', 1071.0000, 'ºC'),
	(305377, 145, '2015-01-01 00:44:46.000000', 'temperatura', 277.0000, 'ºC'),
	(305378, 145, '2015-01-01 00:44:47.000000', 'temperatura', 574.0000, 'ºC'),
	(305379, 145, '2015-01-01 00:44:48.000000', 'temperatura', 838.0000, 'ºC'),
	(305380, 145, '2015-01-01 00:44:49.000000', 'temperatura', 67.0000, 'ºC'),
	(305381, 145, '2015-01-01 00:44:50.000000', 'temperatura', 224.0000, 'ºC'),
	(305382, 145, '2015-01-01 00:44:51.000000', 'temperatura', 919.0000, 'ºC'),
	(305383, 145, '2015-01-01 00:44:52.000000', 'temperatura', 325.0000, 'ºC'),
	(305384, 145, '2015-01-01 00:44:53.000000', 'temperatura', 68.0000, 'ºC'),
	(305385, 145, '2015-01-01 00:44:54.000000', 'temperatura', 566.0000, 'ºC'),
	(305386, 145, '2015-01-01 00:44:55.000000', 'temperatura', 225.0000, 'ºC'),
	(305387, 145, '2015-01-01 00:44:56.000000', 'temperatura', 627.0000, 'ºC'),
	(305388, 145, '2015-01-01 00:44:57.000000', 'temperatura', 59.0000, 'ºC'),
	(305389, 145, '2015-01-01 00:44:58.000000', 'temperatura', 817.0000, 'ºC'),
	(305390, 145, '2015-01-01 00:44:59.000000', 'temperatura', 307.0000, 'ºC'),
	(305391, 145, '2015-01-01 00:45:00.000000', 'temperatura', 286.0000, 'ºC'),
	(305392, 145, '2015-01-01 00:45:01.000000', 'temperatura', 510.0000, 'ºC'),
	(305393, 145, '2015-01-01 00:45:02.000000', 'temperatura', 491.0000, 'ºC'),
	(305394, 145, '2015-01-01 00:45:03.000000', 'temperatura', 925.0000, 'ºC'),
	(305395, 145, '2015-01-01 00:45:04.000000', 'temperatura', 752.0000, 'ºC'),
	(305396, 145, '2015-01-01 00:45:05.000000', 'temperatura', 984.0000, 'ºC'),
	(305397, 145, '2015-01-01 00:45:06.000000', 'temperatura', 267.0000, 'ºC'),
	(305398, 145, '2015-01-01 00:45:07.000000', 'temperatura', 784.0000, 'ºC'),
	(305399, 145, '2015-01-01 00:45:08.000000', 'temperatura', 720.0000, 'ºC'),
	(305400, 145, '2015-01-01 00:45:09.000000', 'temperatura', 50.0000, 'ºC'),
	(305401, 145, '2015-01-01 00:45:10.000000', 'temperatura', 487.0000, 'ºC'),
	(305402, 145, '2015-01-01 00:45:11.000000', 'temperatura', 1087.0000, 'ºC'),
	(305403, 145, '2015-01-01 00:45:12.000000', 'temperatura', 376.0000, 'ºC'),
	(305404, 145, '2015-01-01 00:45:13.000000', 'temperatura', 1018.0000, 'ºC'),
	(305405, 145, '2015-01-01 00:45:14.000000', 'temperatura', 362.0000, 'ºC'),
	(305406, 145, '2015-01-01 00:45:15.000000', 'temperatura', 1158.0000, 'ºC'),
	(305407, 145, '2015-01-01 00:45:16.000000', 'temperatura', 1102.0000, 'ºC'),
	(305408, 145, '2015-01-01 00:45:17.000000', 'temperatura', 837.0000, 'ºC'),
	(305409, 145, '2015-01-01 00:45:18.000000', 'temperatura', 881.0000, 'ºC'),
	(305410, 145, '2015-01-01 00:45:19.000000', 'temperatura', 694.0000, 'ºC'),
	(305411, 145, '2015-01-01 00:45:20.000000', 'temperatura', 829.0000, 'ºC'),
	(305412, 145, '2015-01-01 00:45:21.000000', 'temperatura', 861.0000, 'ºC'),
	(305413, 145, '2015-01-01 00:45:22.000000', 'temperatura', 618.0000, 'ºC'),
	(305414, 145, '2015-01-01 00:45:23.000000', 'temperatura', 507.0000, 'ºC'),
	(305415, 145, '2015-01-01 00:45:24.000000', 'temperatura', 684.0000, 'ºC'),
	(305416, 145, '2015-01-01 00:45:25.000000', 'temperatura', 698.0000, 'ºC'),
	(305417, 145, '2015-01-01 00:45:26.000000', 'temperatura', 238.0000, 'ºC'),
	(305418, 145, '2015-01-01 00:45:27.000000', 'temperatura', 299.0000, 'ºC'),
	(305419, 145, '2015-01-01 00:45:28.000000', 'temperatura', 781.0000, 'ºC'),
	(305420, 145, '2015-01-01 00:45:29.000000', 'temperatura', 607.0000, 'ºC'),
	(305421, 145, '2015-01-01 00:45:30.000000', 'temperatura', 692.0000, 'ºC'),
	(305422, 145, '2015-01-01 00:45:31.000000', 'temperatura', 440.0000, 'ºC'),
	(305423, 145, '2015-01-01 00:45:32.000000', 'temperatura', 124.0000, 'ºC'),
	(305424, 145, '2015-01-01 00:45:33.000000', 'temperatura', 500.0000, 'ºC'),
	(305425, 145, '2015-01-01 00:45:34.000000', 'temperatura', 928.0000, 'ºC'),
	(305426, 145, '2015-01-01 00:45:35.000000', 'temperatura', 743.0000, 'ºC'),
	(305427, 145, '2015-01-01 00:45:36.000000', 'temperatura', 932.0000, 'ºC'),
	(305428, 145, '2015-01-01 00:45:37.000000', 'temperatura', 29.0000, 'ºC'),
	(305429, 145, '2015-01-01 00:45:38.000000', 'temperatura', 952.0000, 'ºC'),
	(305430, 145, '2015-01-01 00:45:39.000000', 'temperatura', 1072.0000, 'ºC'),
	(305431, 145, '2015-01-01 00:45:40.000000', 'temperatura', 105.0000, 'ºC'),
	(305432, 145, '2015-01-01 00:45:41.000000', 'temperatura', 908.0000, 'ºC'),
	(305433, 145, '2015-01-01 00:45:42.000000', 'temperatura', 626.0000, 'ºC'),
	(305434, 145, '2015-01-01 00:45:43.000000', 'temperatura', 407.0000, 'ºC'),
	(305435, 145, '2015-01-01 00:45:44.000000', 'temperatura', 156.0000, 'ºC'),
	(305436, 145, '2015-01-01 00:45:45.000000', 'temperatura', 759.0000, 'ºC'),
	(305437, 145, '2015-01-01 00:45:46.000000', 'temperatura', 929.0000, 'ºC'),
	(305438, 145, '2015-01-01 00:45:47.000000', 'temperatura', 1167.0000, 'ºC'),
	(305439, 145, '2015-01-01 00:45:48.000000', 'temperatura', 648.0000, 'ºC'),
	(305440, 145, '2015-01-01 00:45:49.000000', 'temperatura', 938.0000, 'ºC'),
	(305441, 145, '2015-01-01 00:45:50.000000', 'temperatura', 350.0000, 'ºC'),
	(305442, 145, '2015-01-01 00:45:51.000000', 'temperatura', 136.0000, 'ºC'),
	(305443, 145, '2015-01-01 00:45:52.000000', 'temperatura', 831.0000, 'ºC'),
	(305444, 145, '2015-01-01 00:45:53.000000', 'temperatura', 148.0000, 'ºC'),
	(305445, 145, '2015-01-01 00:45:54.000000', 'temperatura', 645.0000, 'ºC'),
	(305446, 145, '2015-01-01 00:45:55.000000', 'temperatura', 382.0000, 'ºC'),
	(305447, 145, '2015-01-01 00:45:56.000000', 'temperatura', 1178.0000, 'ºC'),
	(305448, 145, '2015-01-01 00:45:57.000000', 'temperatura', 1141.0000, 'ºC'),
	(305449, 145, '2015-01-01 00:45:58.000000', 'temperatura', 973.0000, 'ºC'),
	(305450, 145, '2015-01-01 00:45:59.000000', 'temperatura', 244.0000, 'ºC'),
	(305451, 145, '2015-01-01 00:46:00.000000', 'temperatura', 702.0000, 'ºC'),
	(305452, 145, '2015-01-01 00:46:01.000000', 'temperatura', 377.0000, 'ºC'),
	(305453, 145, '2015-01-01 00:46:02.000000', 'temperatura', 978.0000, 'ºC'),
	(305454, 145, '2015-01-01 00:46:03.000000', 'temperatura', 161.0000, 'ºC'),
	(305455, 145, '2015-01-01 00:46:04.000000', 'temperatura', 272.0000, 'ºC'),
	(305456, 145, '2015-01-01 00:46:05.000000', 'temperatura', 878.0000, 'ºC'),
	(305457, 145, '2015-01-01 00:46:06.000000', 'temperatura', 1176.0000, 'ºC'),
	(305458, 145, '2015-01-01 00:46:07.000000', 'temperatura', 844.0000, 'ºC'),
	(305459, 145, '2015-01-01 00:46:08.000000', 'temperatura', 693.0000, 'ºC'),
	(305460, 145, '2015-01-01 00:46:09.000000', 'temperatura', 932.0000, 'ºC'),
	(305461, 145, '2015-01-01 00:46:10.000000', 'temperatura', 181.0000, 'ºC'),
	(305462, 145, '2015-01-01 00:46:11.000000', 'temperatura', 510.0000, 'ºC'),
	(305463, 145, '2015-01-01 00:46:12.000000', 'temperatura', 807.0000, 'ºC'),
	(305464, 145, '2015-01-01 00:46:13.000000', 'temperatura', 104.0000, 'ºC'),
	(305465, 145, '2015-01-01 00:46:14.000000', 'temperatura', 502.0000, 'ºC'),
	(305466, 145, '2015-01-01 00:46:15.000000', 'temperatura', 997.0000, 'ºC'),
	(305467, 145, '2015-01-01 00:46:16.000000', 'temperatura', 1079.0000, 'ºC'),
	(305468, 145, '2015-01-01 00:46:17.000000', 'temperatura', 6.0000, 'ºC'),
	(305469, 145, '2015-01-01 00:46:18.000000', 'temperatura', 395.0000, 'ºC'),
	(305470, 145, '2015-01-01 00:46:19.000000', 'temperatura', 754.0000, 'ºC'),
	(305471, 145, '2015-01-01 00:46:20.000000', 'temperatura', 188.0000, 'ºC'),
	(305472, 145, '2015-01-01 00:46:21.000000', 'temperatura', 1080.0000, 'ºC'),
	(305473, 145, '2015-01-01 00:46:22.000000', 'temperatura', 34.0000, 'ºC'),
	(305474, 145, '2015-01-01 00:46:23.000000', 'temperatura', 529.0000, 'ºC'),
	(305475, 145, '2015-01-01 00:46:24.000000', 'temperatura', 146.0000, 'ºC'),
	(305476, 145, '2015-01-01 00:46:25.000000', 'temperatura', 344.0000, 'ºC'),
	(305477, 145, '2015-01-01 00:46:26.000000', 'temperatura', 83.0000, 'ºC'),
	(305478, 145, '2015-01-01 00:46:27.000000', 'temperatura', 581.0000, 'ºC'),
	(305479, 145, '2015-01-01 00:46:28.000000', 'temperatura', 256.0000, 'ºC'),
	(305480, 145, '2015-01-01 00:46:29.000000', 'temperatura', 740.0000, 'ºC'),
	(305481, 145, '2015-01-01 00:46:30.000000', 'temperatura', 532.0000, 'ºC'),
	(305482, 145, '2015-01-01 00:46:31.000000', 'temperatura', 440.0000, 'ºC'),
	(305483, 145, '2015-01-01 00:46:32.000000', 'temperatura', 604.0000, 'ºC'),
	(305484, 145, '2015-01-01 00:46:33.000000', 'temperatura', 501.0000, 'ºC'),
	(305485, 145, '2015-01-01 00:46:34.000000', 'temperatura', 693.0000, 'ºC'),
	(305486, 145, '2015-01-01 00:46:35.000000', 'temperatura', 761.0000, 'ºC'),
	(305487, 145, '2015-01-01 00:46:36.000000', 'temperatura', 527.0000, 'ºC'),
	(305488, 145, '2015-01-01 00:46:37.000000', 'temperatura', 354.0000, 'ºC'),
	(305489, 145, '2015-01-01 00:46:38.000000', 'temperatura', 190.0000, 'ºC'),
	(305490, 145, '2015-01-01 00:46:39.000000', 'temperatura', 1088.0000, 'ºC'),
	(305491, 145, '2015-01-01 00:46:40.000000', 'temperatura', 68.0000, 'ºC'),
	(305492, 145, '2015-01-01 00:46:41.000000', 'temperatura', 680.0000, 'ºC'),
	(305493, 145, '2015-01-01 00:46:42.000000', 'temperatura', 796.0000, 'ºC'),
	(305494, 145, '2015-01-01 00:46:43.000000', 'temperatura', 740.0000, 'ºC'),
	(305495, 145, '2015-01-01 00:46:44.000000', 'temperatura', 113.0000, 'ºC'),
	(305496, 145, '2015-01-01 00:46:45.000000', 'temperatura', 745.0000, 'ºC'),
	(305497, 145, '2015-01-01 00:46:46.000000', 'temperatura', 988.0000, 'ºC'),
	(305498, 145, '2015-01-01 00:46:47.000000', 'temperatura', 306.0000, 'ºC'),
	(305499, 145, '2015-01-01 00:46:48.000000', 'temperatura', 967.0000, 'ºC'),
	(305500, 145, '2015-01-01 00:46:49.000000', 'temperatura', 318.0000, 'ºC'),
	(305501, 145, '2015-01-01 00:46:50.000000', 'temperatura', 1089.0000, 'ºC'),
	(305502, 145, '2015-01-01 00:46:51.000000', 'temperatura', 890.0000, 'ºC'),
	(305503, 145, '2015-01-01 00:46:52.000000', 'temperatura', 1182.0000, 'ºC'),
	(305504, 145, '2015-01-01 00:46:53.000000', 'temperatura', 843.0000, 'ºC'),
	(305505, 145, '2015-01-01 00:46:54.000000', 'temperatura', 670.0000, 'ºC'),
	(305506, 145, '2015-01-01 00:46:55.000000', 'temperatura', 820.0000, 'ºC'),
	(305507, 145, '2015-01-01 00:46:56.000000', 'temperatura', 890.0000, 'ºC'),
	(305508, 145, '2015-01-01 00:46:57.000000', 'temperatura', 791.0000, 'ºC'),
	(305509, 145, '2015-01-01 00:46:58.000000', 'temperatura', 86.0000, 'ºC'),
	(305510, 145, '2015-01-01 00:46:59.000000', 'temperatura', 458.0000, 'ºC'),
	(305511, 145, '2015-01-01 00:47:00.000000', 'temperatura', 833.0000, 'ºC'),
	(305512, 145, '2015-01-01 00:47:01.000000', 'temperatura', 393.0000, 'ºC'),
	(305513, 145, '2015-01-01 00:47:02.000000', 'temperatura', 664.0000, 'ºC'),
	(305514, 145, '2015-01-01 00:47:03.000000', 'temperatura', 941.0000, 'ºC'),
	(305515, 145, '2015-01-01 00:47:04.000000', 'temperatura', 314.0000, 'ºC'),
	(305516, 145, '2015-01-01 00:47:05.000000', 'temperatura', 1146.0000, 'ºC'),
	(305517, 145, '2015-01-01 00:47:06.000000', 'temperatura', 1189.0000, 'ºC'),
	(305518, 145, '2015-01-01 00:47:07.000000', 'temperatura', 107.0000, 'ºC'),
	(305519, 145, '2015-01-01 00:47:08.000000', 'temperatura', 568.0000, 'ºC'),
	(305520, 145, '2015-01-01 00:47:09.000000', 'temperatura', 122.0000, 'ºC'),
	(305521, 145, '2015-01-01 00:47:10.000000', 'temperatura', 104.0000, 'ºC'),
	(305522, 145, '2015-01-01 00:47:11.000000', 'temperatura', 155.0000, 'ºC'),
	(305523, 145, '2015-01-01 00:47:12.000000', 'temperatura', 462.0000, 'ºC'),
	(305524, 145, '2015-01-01 00:47:13.000000', 'temperatura', 648.0000, 'ºC'),
	(305525, 145, '2015-01-01 00:47:14.000000', 'temperatura', 655.0000, 'ºC'),
	(305526, 145, '2015-01-01 00:47:15.000000', 'temperatura', 129.0000, 'ºC'),
	(305527, 145, '2015-01-01 00:47:16.000000', 'temperatura', 1080.0000, 'ºC'),
	(305528, 145, '2015-01-01 00:47:17.000000', 'temperatura', 213.0000, 'ºC'),
	(305529, 145, '2015-01-01 00:47:18.000000', 'temperatura', 228.0000, 'ºC'),
	(305530, 145, '2015-01-01 00:47:19.000000', 'temperatura', 499.0000, 'ºC'),
	(305531, 145, '2015-01-01 00:47:20.000000', 'temperatura', 614.0000, 'ºC'),
	(305532, 145, '2015-01-01 00:47:21.000000', 'temperatura', 372.0000, 'ºC'),
	(305533, 145, '2015-01-01 00:47:22.000000', 'temperatura', 18.0000, 'ºC'),
	(305534, 145, '2015-01-01 00:47:23.000000', 'temperatura', 176.0000, 'ºC'),
	(305535, 145, '2015-01-01 00:47:24.000000', 'temperatura', 824.0000, 'ºC'),
	(305536, 145, '2015-01-01 00:47:25.000000', 'temperatura', 1196.0000, 'ºC'),
	(305537, 145, '2015-01-01 00:47:26.000000', 'temperatura', 1106.0000, 'ºC'),
	(305538, 145, '2015-01-01 00:47:27.000000', 'temperatura', 744.0000, 'ºC'),
	(305539, 145, '2015-01-01 00:47:28.000000', 'temperatura', 402.0000, 'ºC'),
	(305540, 145, '2015-01-01 00:47:29.000000', 'temperatura', 977.0000, 'ºC'),
	(305541, 145, '2015-01-01 00:47:30.000000', 'temperatura', 81.0000, 'ºC'),
	(305542, 145, '2015-01-01 00:47:31.000000', 'temperatura', 1073.0000, 'ºC'),
	(305543, 145, '2015-01-01 00:47:32.000000', 'temperatura', 324.0000, 'ºC'),
	(305544, 145, '2015-01-01 00:47:33.000000', 'temperatura', 801.0000, 'ºC'),
	(305545, 145, '2015-01-01 00:47:34.000000', 'temperatura', 635.0000, 'ºC'),
	(305546, 145, '2015-01-01 00:47:35.000000', 'temperatura', 771.0000, 'ºC'),
	(305547, 145, '2015-01-01 00:47:36.000000', 'temperatura', 752.0000, 'ºC'),
	(305548, 145, '2015-01-01 00:47:37.000000', 'temperatura', 248.0000, 'ºC'),
	(305549, 145, '2015-01-01 00:47:38.000000', 'temperatura', 184.0000, 'ºC'),
	(305550, 145, '2015-01-01 00:47:39.000000', 'temperatura', 178.0000, 'ºC'),
	(305551, 145, '2015-01-01 00:47:40.000000', 'temperatura', 338.0000, 'ºC'),
	(305552, 145, '2015-01-01 00:47:41.000000', 'temperatura', 1158.0000, 'ºC'),
	(305553, 145, '2015-01-01 00:47:42.000000', 'temperatura', 1175.0000, 'ºC'),
	(305554, 145, '2015-01-01 00:47:43.000000', 'temperatura', 3.0000, 'ºC'),
	(305555, 145, '2015-01-01 00:47:44.000000', 'temperatura', 89.0000, 'ºC'),
	(305556, 145, '2015-01-01 00:47:45.000000', 'temperatura', 435.0000, 'ºC'),
	(305557, 145, '2015-01-01 00:47:46.000000', 'temperatura', 709.0000, 'ºC'),
	(305558, 145, '2015-01-01 00:47:47.000000', 'temperatura', 1042.0000, 'ºC'),
	(305559, 145, '2015-01-01 00:47:48.000000', 'temperatura', 684.0000, 'ºC'),
	(305560, 145, '2015-01-01 00:47:49.000000', 'temperatura', 293.0000, 'ºC'),
	(305561, 145, '2015-01-01 00:47:50.000000', 'temperatura', 614.0000, 'ºC'),
	(305562, 145, '2015-01-01 00:47:51.000000', 'temperatura', 993.0000, 'ºC'),
	(305563, 145, '2015-01-01 00:47:52.000000', 'temperatura', 723.0000, 'ºC'),
	(305564, 145, '2015-01-01 00:47:53.000000', 'temperatura', 637.0000, 'ºC'),
	(305565, 145, '2015-01-01 00:47:54.000000', 'temperatura', 1015.0000, 'ºC'),
	(305566, 145, '2015-01-01 00:47:55.000000', 'temperatura', 763.0000, 'ºC'),
	(305567, 145, '2015-01-01 00:47:56.000000', 'temperatura', 773.0000, 'ºC'),
	(305568, 145, '2015-01-01 00:47:57.000000', 'temperatura', 377.0000, 'ºC'),
	(305569, 145, '2015-01-01 00:47:58.000000', 'temperatura', 768.0000, 'ºC'),
	(305570, 145, '2015-01-01 00:47:59.000000', 'temperatura', 307.0000, 'ºC'),
	(305571, 145, '2015-01-01 00:48:00.000000', 'temperatura', 432.0000, 'ºC'),
	(305572, 145, '2015-01-01 00:48:01.000000', 'temperatura', 39.0000, 'ºC'),
	(305573, 145, '2015-01-01 00:48:02.000000', 'temperatura', 101.0000, 'ºC'),
	(305574, 145, '2015-01-01 00:48:03.000000', 'temperatura', 389.0000, 'ºC'),
	(305575, 145, '2015-01-01 00:48:04.000000', 'temperatura', 440.0000, 'ºC'),
	(305576, 145, '2015-01-01 00:48:05.000000', 'temperatura', 1036.0000, 'ºC'),
	(305577, 145, '2015-01-01 00:48:06.000000', 'temperatura', 260.0000, 'ºC'),
	(305578, 145, '2015-01-01 00:48:07.000000', 'temperatura', 593.0000, 'ºC'),
	(305579, 145, '2015-01-01 00:48:08.000000', 'temperatura', 986.0000, 'ºC'),
	(305580, 145, '2015-01-01 00:48:09.000000', 'temperatura', 750.0000, 'ºC'),
	(305581, 145, '2015-01-01 00:48:10.000000', 'temperatura', 793.0000, 'ºC'),
	(305582, 145, '2015-01-01 00:48:11.000000', 'temperatura', 514.0000, 'ºC'),
	(305583, 145, '2015-01-01 00:48:12.000000', 'temperatura', 191.0000, 'ºC'),
	(305584, 145, '2015-01-01 00:48:13.000000', 'temperatura', 616.0000, 'ºC'),
	(305585, 145, '2015-01-01 00:48:14.000000', 'temperatura', 105.0000, 'ºC'),
	(305586, 145, '2015-01-01 00:48:15.000000', 'temperatura', 1078.0000, 'ºC'),
	(305587, 145, '2015-01-01 00:48:16.000000', 'temperatura', 274.0000, 'ºC'),
	(305588, 145, '2015-01-01 00:48:17.000000', 'temperatura', 539.0000, 'ºC'),
	(305589, 145, '2015-01-01 00:48:18.000000', 'temperatura', 672.0000, 'ºC'),
	(305590, 145, '2015-01-01 00:48:19.000000', 'temperatura', 543.0000, 'ºC'),
	(305591, 145, '2015-01-01 00:48:20.000000', 'temperatura', 698.0000, 'ºC'),
	(305592, 145, '2015-01-01 00:48:21.000000', 'temperatura', 665.0000, 'ºC'),
	(305593, 145, '2015-01-01 00:48:22.000000', 'temperatura', 30.0000, 'ºC'),
	(305594, 145, '2015-01-01 00:48:23.000000', 'temperatura', 555.0000, 'ºC'),
	(305595, 145, '2015-01-01 00:48:24.000000', 'temperatura', 284.0000, 'ºC'),
	(305596, 145, '2015-01-01 00:48:25.000000', 'temperatura', 959.0000, 'ºC'),
	(305597, 145, '2015-01-01 00:48:26.000000', 'temperatura', 342.0000, 'ºC'),
	(305598, 145, '2015-01-01 00:48:27.000000', 'temperatura', 33.0000, 'ºC'),
	(305599, 145, '2015-01-01 00:48:28.000000', 'temperatura', 338.0000, 'ºC'),
	(305600, 145, '2015-01-01 00:48:29.000000', 'temperatura', 393.0000, 'ºC'),
	(305601, 145, '2015-01-01 00:48:30.000000', 'temperatura', 950.0000, 'ºC'),
	(305602, 145, '2015-01-01 00:48:31.000000', 'temperatura', 1170.0000, 'ºC'),
	(305603, 145, '2015-01-01 00:48:32.000000', 'temperatura', 604.0000, 'ºC'),
	(305604, 145, '2015-01-01 00:48:33.000000', 'temperatura', 707.0000, 'ºC'),
	(305605, 145, '2015-01-01 00:48:34.000000', 'temperatura', 526.0000, 'ºC'),
	(305606, 145, '2015-01-01 00:48:35.000000', 'temperatura', 507.0000, 'ºC'),
	(305607, 145, '2015-01-01 00:48:36.000000', 'temperatura', 960.0000, 'ºC'),
	(305608, 145, '2015-01-01 00:48:37.000000', 'temperatura', 878.0000, 'ºC'),
	(305609, 145, '2015-01-01 00:48:38.000000', 'temperatura', 309.0000, 'ºC'),
	(305610, 145, '2015-01-01 00:48:39.000000', 'temperatura', 114.0000, 'ºC'),
	(305611, 145, '2015-01-01 00:48:40.000000', 'temperatura', 843.0000, 'ºC'),
	(305612, 145, '2015-01-01 00:48:41.000000', 'temperatura', 275.0000, 'ºC'),
	(305613, 145, '2015-01-01 00:48:42.000000', 'temperatura', 47.0000, 'ºC'),
	(305614, 145, '2015-01-01 00:48:43.000000', 'temperatura', 609.0000, 'ºC'),
	(305615, 145, '2015-01-01 00:48:44.000000', 'temperatura', 506.0000, 'ºC'),
	(305616, 145, '2015-01-01 00:48:45.000000', 'temperatura', 702.0000, 'ºC'),
	(305617, 145, '2015-01-01 00:48:46.000000', 'temperatura', 793.0000, 'ºC'),
	(305618, 145, '2015-01-01 00:48:47.000000', 'temperatura', 659.0000, 'ºC'),
	(305619, 145, '2015-01-01 00:48:48.000000', 'temperatura', 915.0000, 'ºC'),
	(305620, 145, '2015-01-01 00:48:49.000000', 'temperatura', 200.0000, 'ºC'),
	(305621, 145, '2015-01-01 00:48:50.000000', 'temperatura', 657.0000, 'ºC'),
	(305622, 145, '2015-01-01 00:48:51.000000', 'temperatura', 286.0000, 'ºC'),
	(305623, 145, '2015-01-01 00:48:52.000000', 'temperatura', 659.0000, 'ºC'),
	(305624, 145, '2015-01-01 00:48:53.000000', 'temperatura', 36.0000, 'ºC'),
	(305625, 145, '2015-01-01 00:48:54.000000', 'temperatura', 602.0000, 'ºC'),
	(305626, 145, '2015-01-01 00:48:55.000000', 'temperatura', 506.0000, 'ºC'),
	(305627, 145, '2015-01-01 00:48:56.000000', 'temperatura', 724.0000, 'ºC'),
	(305628, 145, '2015-01-01 00:48:57.000000', 'temperatura', 900.0000, 'ºC'),
	(305629, 145, '2015-01-01 00:48:58.000000', 'temperatura', 1130.0000, 'ºC'),
	(305630, 145, '2015-01-01 00:48:59.000000', 'temperatura', 549.0000, 'ºC'),
	(305631, 145, '2015-01-01 00:49:00.000000', 'temperatura', 557.0000, 'ºC'),
	(305632, 145, '2015-01-01 00:49:01.000000', 'temperatura', 1137.0000, 'ºC'),
	(305633, 145, '2015-01-01 00:49:02.000000', 'temperatura', 416.0000, 'ºC'),
	(305634, 145, '2015-01-01 00:49:03.000000', 'temperatura', 1069.0000, 'ºC'),
	(305635, 145, '2015-01-01 00:49:04.000000', 'temperatura', 498.0000, 'ºC'),
	(305636, 145, '2015-01-01 00:49:05.000000', 'temperatura', 483.0000, 'ºC'),
	(305637, 145, '2015-01-01 00:49:06.000000', 'temperatura', 921.0000, 'ºC'),
	(305638, 145, '2015-01-01 00:49:07.000000', 'temperatura', 757.0000, 'ºC'),
	(305639, 145, '2015-01-01 00:49:08.000000', 'temperatura', 1020.0000, 'ºC'),
	(305640, 145, '2015-01-01 00:49:09.000000', 'temperatura', 433.0000, 'ºC'),
	(305641, 145, '2015-01-01 00:49:10.000000', 'temperatura', 302.0000, 'ºC'),
	(305642, 145, '2015-01-01 00:49:11.000000', 'temperatura', 214.0000, 'ºC'),
	(305643, 145, '2015-01-01 00:49:12.000000', 'temperatura', 163.0000, 'ºC'),
	(305644, 145, '2015-01-01 00:49:13.000000', 'temperatura', 176.0000, 'ºC'),
	(305645, 145, '2015-01-01 00:49:14.000000', 'temperatura', 390.0000, 'ºC'),
	(305646, 145, '2015-01-01 00:49:15.000000', 'temperatura', 222.0000, 'ºC'),
	(305647, 145, '2015-01-01 00:49:16.000000', 'temperatura', 1141.0000, 'ºC'),
	(305648, 145, '2015-01-01 00:49:17.000000', 'temperatura', 238.0000, 'ºC'),
	(305649, 145, '2015-01-01 00:49:18.000000', 'temperatura', 168.0000, 'ºC'),
	(305650, 145, '2015-01-01 00:49:19.000000', 'temperatura', 125.0000, 'ºC'),
	(305651, 145, '2015-01-01 00:49:20.000000', 'temperatura', 123.0000, 'ºC'),
	(305652, 145, '2015-01-01 00:49:21.000000', 'temperatura', 239.0000, 'ºC'),
	(305653, 145, '2015-01-01 00:49:22.000000', 'temperatura', 829.0000, 'ºC'),
	(305654, 145, '2015-01-01 00:49:23.000000', 'temperatura', 1026.0000, 'ºC'),
	(305655, 145, '2015-01-01 00:49:24.000000', 'temperatura', 246.0000, 'ºC'),
	(305656, 145, '2015-01-01 00:49:25.000000', 'temperatura', 550.0000, 'ºC'),
	(305657, 145, '2015-01-01 00:49:26.000000', 'temperatura', 816.0000, 'ºC'),
	(305658, 145, '2015-01-01 00:49:27.000000', 'temperatura', 27.0000, 'ºC'),
	(305659, 145, '2015-01-01 00:49:28.000000', 'temperatura', 89.0000, 'ºC'),
	(305660, 145, '2015-01-01 00:49:29.000000', 'temperatura', 363.0000, 'ºC'),
	(305661, 145, '2015-01-01 00:49:30.000000', 'temperatura', 349.0000, 'ºC'),
	(305662, 145, '2015-01-01 00:49:31.000000', 'temperatura', 657.0000, 'ºC'),
	(305663, 145, '2015-01-01 00:49:32.000000', 'temperatura', 1039.0000, 'ºC'),
	(305664, 145, '2015-01-01 00:49:33.000000', 'temperatura', 822.0000, 'ºC'),
	(305665, 145, '2015-01-01 00:49:34.000000', 'temperatura', 995.0000, 'ºC'),
	(305666, 145, '2015-01-01 00:49:35.000000', 'temperatura', 108.0000, 'ºC'),
	(305667, 145, '2015-01-01 00:49:36.000000', 'temperatura', 1158.0000, 'ºC'),
	(305668, 145, '2015-01-01 00:49:37.000000', 'temperatura', 664.0000, 'ºC'),
	(305669, 145, '2015-01-01 00:49:38.000000', 'temperatura', 1046.0000, 'ºC'),
	(305670, 145, '2015-01-01 00:49:39.000000', 'temperatura', 838.0000, 'ºC'),
	(305671, 145, '2015-01-01 00:49:40.000000', 'temperatura', 1053.0000, 'ºC'),
	(305672, 145, '2015-01-01 00:49:41.000000', 'temperatura', 353.0000, 'ºC'),
	(305673, 145, '2015-01-01 00:49:42.000000', 'temperatura', 1008.0000, 'ºC'),
	(305674, 145, '2015-01-01 00:49:43.000000', 'temperatura', 379.0000, 'ºC'),
	(305675, 145, '2015-01-01 00:49:44.000000', 'temperatura', 71.0000, 'ºC'),
	(305676, 145, '2015-01-01 00:49:45.000000', 'temperatura', 418.0000, 'ºC'),
	(305677, 145, '2015-01-01 00:49:46.000000', 'temperatura', 677.0000, 'ºC'),
	(305678, 145, '2015-01-01 00:49:47.000000', 'temperatura', 932.0000, 'ºC'),
	(305679, 145, '2015-01-01 00:49:48.000000', 'temperatura', 230.0000, 'ºC'),
	(305680, 145, '2015-01-01 00:49:49.000000', 'temperatura', 755.0000, 'ºC'),
	(305681, 145, '2015-01-01 00:49:50.000000', 'temperatura', 684.0000, 'ºC'),
	(305682, 145, '2015-01-01 00:49:51.000000', 'temperatura', 1155.0000, 'ºC'),
	(305683, 145, '2015-01-01 00:49:52.000000', 'temperatura', 125.0000, 'ºC'),
	(305684, 145, '2015-01-01 00:49:53.000000', 'temperatura', 758.0000, 'ºC'),
	(305685, 145, '2015-01-01 00:49:54.000000', 'temperatura', 1017.0000, 'ºC'),
	(305686, 145, '2015-01-01 00:49:55.000000', 'temperatura', 411.0000, 'ºC'),
	(305687, 145, '2015-01-01 00:49:56.000000', 'temperatura', 204.0000, 'ºC'),
	(305688, 145, '2015-01-01 00:49:57.000000', 'temperatura', 986.0000, 'ºC'),
	(305689, 145, '2015-01-01 00:49:58.000000', 'temperatura', 722.0000, 'ºC'),
	(305690, 145, '2015-01-01 00:49:59.000000', 'temperatura', 649.0000, 'ºC'),
	(305691, 145, '2015-01-01 00:50:00.000000', 'temperatura', 1082.0000, 'ºC'),
	(305692, 145, '2015-01-01 00:50:01.000000', 'temperatura', 1062.0000, 'ºC'),
	(305693, 145, '2015-01-01 00:50:02.000000', 'temperatura', 866.0000, 'ºC'),
	(305694, 145, '2015-01-01 00:50:03.000000', 'temperatura', 1145.0000, 'ºC'),
	(305695, 145, '2015-01-01 00:50:04.000000', 'temperatura', 728.0000, 'ºC'),
	(305696, 145, '2015-01-01 00:50:05.000000', 'temperatura', 206.0000, 'ºC'),
	(305697, 145, '2015-01-01 00:50:06.000000', 'temperatura', 48.0000, 'ºC'),
	(305698, 145, '2015-01-01 00:50:07.000000', 'temperatura', 819.0000, 'ºC'),
	(305699, 145, '2015-01-01 00:50:08.000000', 'temperatura', 352.0000, 'ºC'),
	(305700, 145, '2015-01-01 00:50:09.000000', 'temperatura', 503.0000, 'ºC'),
	(305701, 145, '2015-01-01 00:50:10.000000', 'temperatura', 261.0000, 'ºC'),
	(305702, 145, '2015-01-01 00:50:11.000000', 'temperatura', 994.0000, 'ºC'),
	(305703, 145, '2015-01-01 00:50:12.000000', 'temperatura', 589.0000, 'ºC'),
	(305704, 145, '2015-01-01 00:50:13.000000', 'temperatura', 1164.0000, 'ºC'),
	(305705, 145, '2015-01-01 00:50:14.000000', 'temperatura', 455.0000, 'ºC'),
	(305706, 145, '2015-01-01 00:50:15.000000', 'temperatura', 1180.0000, 'ºC'),
	(305707, 145, '2015-01-01 00:50:16.000000', 'temperatura', 938.0000, 'ºC'),
	(305708, 145, '2015-01-01 00:50:17.000000', 'temperatura', 1148.0000, 'ºC'),
	(305709, 145, '2015-01-01 00:50:18.000000', 'temperatura', 529.0000, 'ºC'),
	(305710, 145, '2015-01-01 00:50:19.000000', 'temperatura', 403.0000, 'ºC'),
	(305711, 145, '2015-01-01 00:50:20.000000', 'temperatura', 425.0000, 'ºC'),
	(305712, 145, '2015-01-01 00:50:21.000000', 'temperatura', 919.0000, 'ºC'),
	(305713, 145, '2015-01-01 00:50:22.000000', 'temperatura', 918.0000, 'ºC'),
	(305714, 145, '2015-01-01 00:50:23.000000', 'temperatura', 635.0000, 'ºC'),
	(305715, 145, '2015-01-01 00:50:24.000000', 'temperatura', 420.0000, 'ºC'),
	(305716, 145, '2015-01-01 00:50:25.000000', 'temperatura', 196.0000, 'ºC'),
	(305717, 145, '2015-01-01 00:50:26.000000', 'temperatura', 919.0000, 'ºC'),
	(305718, 145, '2015-01-01 00:50:27.000000', 'temperatura', 409.0000, 'ºC'),
	(305719, 145, '2015-01-01 00:50:28.000000', 'temperatura', 487.0000, 'ºC'),
	(305720, 145, '2015-01-01 00:50:29.000000', 'temperatura', 8.0000, 'ºC'),
	(305721, 145, '2015-01-01 00:50:30.000000', 'temperatura', 980.0000, 'ºC'),
	(305722, 145, '2015-01-01 00:50:31.000000', 'temperatura', 78.0000, 'ºC'),
	(305723, 145, '2015-01-01 00:50:32.000000', 'temperatura', 1051.0000, 'ºC'),
	(305724, 145, '2015-01-01 00:50:33.000000', 'temperatura', 221.0000, 'ºC'),
	(305725, 145, '2015-01-01 00:50:34.000000', 'temperatura', 354.0000, 'ºC'),
	(305726, 145, '2015-01-01 00:50:35.000000', 'temperatura', 1105.0000, 'ºC'),
	(305727, 145, '2015-01-01 00:50:36.000000', 'temperatura', 866.0000, 'ºC'),
	(305728, 145, '2015-01-01 00:50:37.000000', 'temperatura', 1013.0000, 'ºC'),
	(305729, 145, '2015-01-01 00:50:38.000000', 'temperatura', 70.0000, 'ºC'),
	(305730, 145, '2015-01-01 00:50:39.000000', 'temperatura', 911.0000, 'ºC'),
	(305731, 145, '2015-01-01 00:50:40.000000', 'temperatura', 744.0000, 'ºC'),
	(305732, 145, '2015-01-01 00:50:41.000000', 'temperatura', 986.0000, 'ºC'),
	(305733, 145, '2015-01-01 00:50:42.000000', 'temperatura', 301.0000, 'ºC'),
	(305734, 145, '2015-01-01 00:50:43.000000', 'temperatura', 948.0000, 'ºC'),
	(305735, 145, '2015-01-01 00:50:44.000000', 'temperatura', 237.0000, 'ºC'),
	(305736, 145, '2015-01-01 00:50:45.000000', 'temperatura', 739.0000, 'ºC'),
	(305737, 145, '2015-01-01 00:50:46.000000', 'temperatura', 587.0000, 'ºC'),
	(305738, 145, '2015-01-01 00:50:47.000000', 'temperatura', 717.0000, 'ºC'),
	(305739, 145, '2015-01-01 00:50:48.000000', 'temperatura', 627.0000, 'ºC'),
	(305740, 145, '2015-01-01 00:50:49.000000', 'temperatura', 983.0000, 'ºC'),
	(305741, 145, '2015-01-01 00:50:50.000000', 'temperatura', 633.0000, 'ºC'),
	(305742, 145, '2015-01-01 00:50:51.000000', 'temperatura', 216.0000, 'ºC'),
	(305743, 145, '2015-01-01 00:50:52.000000', 'temperatura', 382.0000, 'ºC'),
	(305744, 145, '2015-01-01 00:50:53.000000', 'temperatura', 64.0000, 'ºC'),
	(305745, 145, '2015-01-01 00:50:54.000000', 'temperatura', 375.0000, 'ºC'),
	(305746, 145, '2015-01-01 00:50:55.000000', 'temperatura', 481.0000, 'ºC'),
	(305747, 145, '2015-01-01 00:50:56.000000', 'temperatura', 80.0000, 'ºC'),
	(305748, 145, '2015-01-01 00:50:57.000000', 'temperatura', 160.0000, 'ºC'),
	(305749, 145, '2015-01-01 00:50:58.000000', 'temperatura', 559.0000, 'ºC'),
	(305750, 145, '2015-01-01 00:50:59.000000', 'temperatura', 1114.0000, 'ºC'),
	(305751, 145, '2015-01-01 00:51:00.000000', 'temperatura', 295.0000, 'ºC'),
	(305752, 145, '2015-01-01 00:51:01.000000', 'temperatura', 535.0000, 'ºC'),
	(305753, 145, '2015-01-01 00:51:02.000000', 'temperatura', 589.0000, 'ºC'),
	(305754, 145, '2015-01-01 00:51:03.000000', 'temperatura', 139.0000, 'ºC'),
	(305755, 145, '2015-01-01 00:51:04.000000', 'temperatura', 128.0000, 'ºC'),
	(305756, 145, '2015-01-01 00:51:05.000000', 'temperatura', 226.0000, 'ºC'),
	(305757, 145, '2015-01-01 00:51:06.000000', 'temperatura', 745.0000, 'ºC'),
	(305758, 145, '2015-01-01 00:51:07.000000', 'temperatura', 649.0000, 'ºC'),
	(305759, 145, '2015-01-01 00:51:08.000000', 'temperatura', 1009.0000, 'ºC'),
	(305760, 145, '2015-01-01 00:51:09.000000', 'temperatura', 700.0000, 'ºC'),
	(305761, 145, '2015-01-01 00:51:10.000000', 'temperatura', 474.0000, 'ºC'),
	(305762, 145, '2015-01-01 00:51:11.000000', 'temperatura', 271.0000, 'ºC'),
	(305763, 145, '2015-01-01 00:51:12.000000', 'temperatura', 1133.0000, 'ºC'),
	(305764, 145, '2015-01-01 00:51:13.000000', 'temperatura', 54.0000, 'ºC'),
	(305765, 145, '2015-01-01 00:51:14.000000', 'temperatura', 469.0000, 'ºC'),
	(305766, 145, '2015-01-01 00:51:15.000000', 'temperatura', 983.0000, 'ºC'),
	(305767, 145, '2015-01-01 00:51:16.000000', 'temperatura', 1110.0000, 'ºC'),
	(305768, 145, '2015-01-01 00:51:17.000000', 'temperatura', 202.0000, 'ºC'),
	(305769, 145, '2015-01-01 00:51:18.000000', 'temperatura', 81.0000, 'ºC'),
	(305770, 145, '2015-01-01 00:51:19.000000', 'temperatura', 1000.0000, 'ºC'),
	(305771, 145, '2015-01-01 00:51:20.000000', 'temperatura', 1159.0000, 'ºC'),
	(305772, 145, '2015-01-01 00:51:21.000000', 'temperatura', 392.0000, 'ºC'),
	(305773, 145, '2015-01-01 00:51:22.000000', 'temperatura', 886.0000, 'ºC'),
	(305774, 145, '2015-01-01 00:51:23.000000', 'temperatura', 853.0000, 'ºC'),
	(305775, 145, '2015-01-01 00:51:24.000000', 'temperatura', 409.0000, 'ºC'),
	(305776, 145, '2015-01-01 00:51:25.000000', 'temperatura', 685.0000, 'ºC'),
	(305777, 145, '2015-01-01 00:51:26.000000', 'temperatura', 997.0000, 'ºC'),
	(305778, 145, '2015-01-01 00:51:27.000000', 'temperatura', 532.0000, 'ºC'),
	(305779, 145, '2015-01-01 00:51:28.000000', 'temperatura', 872.0000, 'ºC'),
	(305780, 145, '2015-01-01 00:51:29.000000', 'temperatura', 361.0000, 'ºC'),
	(305781, 145, '2015-01-01 00:51:30.000000', 'temperatura', 390.0000, 'ºC'),
	(305782, 145, '2015-01-01 00:51:31.000000', 'temperatura', 869.0000, 'ºC'),
	(305783, 145, '2015-01-01 00:51:32.000000', 'temperatura', 774.0000, 'ºC'),
	(305784, 145, '2015-01-01 00:51:33.000000', 'temperatura', 65.0000, 'ºC'),
	(305785, 145, '2015-01-01 00:51:34.000000', 'temperatura', 404.0000, 'ºC'),
	(305786, 145, '2015-01-01 00:51:35.000000', 'temperatura', 626.0000, 'ºC'),
	(305787, 145, '2015-01-01 00:51:36.000000', 'temperatura', 718.0000, 'ºC'),
	(305788, 145, '2015-01-01 00:51:37.000000', 'temperatura', 513.0000, 'ºC'),
	(305789, 145, '2015-01-01 00:51:38.000000', 'temperatura', 413.0000, 'ºC'),
	(305790, 145, '2015-01-01 00:51:39.000000', 'temperatura', 524.0000, 'ºC'),
	(305791, 145, '2015-01-01 00:51:40.000000', 'temperatura', 181.0000, 'ºC'),
	(305792, 145, '2015-01-01 00:51:41.000000', 'temperatura', 534.0000, 'ºC'),
	(305793, 145, '2015-01-01 00:51:42.000000', 'temperatura', 926.0000, 'ºC'),
	(305794, 145, '2015-01-01 00:51:43.000000', 'temperatura', 628.0000, 'ºC'),
	(305795, 145, '2015-01-01 00:51:44.000000', 'temperatura', 365.0000, 'ºC'),
	(305796, 145, '2015-01-01 00:51:45.000000', 'temperatura', 1143.0000, 'ºC'),
	(305797, 145, '2015-01-01 00:51:46.000000', 'temperatura', 1017.0000, 'ºC'),
	(305798, 145, '2015-01-01 00:51:47.000000', 'temperatura', 458.0000, 'ºC'),
	(305799, 145, '2015-01-01 00:51:48.000000', 'temperatura', 438.0000, 'ºC'),
	(305800, 145, '2015-01-01 00:51:49.000000', 'temperatura', 816.0000, 'ºC'),
	(305801, 145, '2015-01-01 00:51:50.000000', 'temperatura', 367.0000, 'ºC'),
	(305802, 145, '2015-01-01 00:51:51.000000', 'temperatura', 588.0000, 'ºC'),
	(305803, 145, '2015-01-01 00:51:52.000000', 'temperatura', 637.0000, 'ºC'),
	(305804, 145, '2015-01-01 00:51:53.000000', 'temperatura', 224.0000, 'ºC'),
	(305805, 145, '2015-01-01 00:51:54.000000', 'temperatura', 410.0000, 'ºC'),
	(305806, 145, '2015-01-01 00:51:55.000000', 'temperatura', 178.0000, 'ºC'),
	(305807, 145, '2015-01-01 00:51:56.000000', 'temperatura', 859.0000, 'ºC'),
	(305808, 145, '2015-01-01 00:51:57.000000', 'temperatura', 163.0000, 'ºC'),
	(305809, 145, '2015-01-01 00:51:58.000000', 'temperatura', 638.0000, 'ºC'),
	(305810, 145, '2015-01-01 00:51:59.000000', 'temperatura', 300.0000, 'ºC'),
	(305811, 145, '2015-01-01 00:52:00.000000', 'temperatura', 788.0000, 'ºC'),
	(305812, 145, '2015-01-01 00:52:01.000000', 'temperatura', 642.0000, 'ºC'),
	(305813, 145, '2015-01-01 00:52:02.000000', 'temperatura', 844.0000, 'ºC'),
	(305814, 145, '2015-01-01 00:52:03.000000', 'temperatura', 1094.0000, 'ºC'),
	(305815, 145, '2015-01-01 00:52:04.000000', 'temperatura', 538.0000, 'ºC'),
	(305816, 145, '2015-01-01 00:52:05.000000', 'temperatura', 608.0000, 'ºC'),
	(305817, 145, '2015-01-01 00:52:06.000000', 'temperatura', 229.0000, 'ºC'),
	(305818, 145, '2015-01-01 00:52:07.000000', 'temperatura', 519.0000, 'ºC'),
	(305819, 145, '2015-01-01 00:52:08.000000', 'temperatura', 711.0000, 'ºC'),
	(305820, 145, '2015-01-01 00:52:09.000000', 'temperatura', 797.0000, 'ºC'),
	(305821, 145, '2015-01-01 00:52:10.000000', 'temperatura', 655.0000, 'ºC'),
	(305822, 145, '2015-01-01 00:52:11.000000', 'temperatura', 881.0000, 'ºC'),
	(305823, 145, '2015-01-01 00:52:12.000000', 'temperatura', 43.0000, 'ºC'),
	(305824, 145, '2015-01-01 00:52:13.000000', 'temperatura', 1173.0000, 'ºC'),
	(305825, 145, '2015-01-01 00:52:14.000000', 'temperatura', 937.0000, 'ºC'),
	(305826, 145, '2015-01-01 00:52:15.000000', 'temperatura', 1164.0000, 'ºC'),
	(305827, 145, '2015-01-01 00:52:16.000000', 'temperatura', 612.0000, 'ºC'),
	(305828, 145, '2015-01-01 00:52:17.000000', 'temperatura', 768.0000, 'ºC'),
	(305829, 145, '2015-01-01 00:52:18.000000', 'temperatura', 804.0000, 'ºC'),
	(305830, 145, '2015-01-01 00:52:19.000000', 'temperatura', 517.0000, 'ºC'),
	(305831, 145, '2015-01-01 00:52:20.000000', 'temperatura', 171.0000, 'ºC'),
	(305832, 145, '2015-01-01 00:52:21.000000', 'temperatura', 508.0000, 'ºC'),
	(305833, 145, '2015-01-01 00:52:22.000000', 'temperatura', 826.0000, 'ºC'),
	(305834, 145, '2015-01-01 00:52:23.000000', 'temperatura', 205.0000, 'ºC'),
	(305835, 145, '2015-01-01 00:52:24.000000', 'temperatura', 949.0000, 'ºC'),
	(305836, 145, '2015-01-01 00:52:25.000000', 'temperatura', 532.0000, 'ºC'),
	(305837, 145, '2015-01-01 00:52:26.000000', 'temperatura', 1011.0000, 'ºC'),
	(305838, 145, '2015-01-01 00:52:27.000000', 'temperatura', 1060.0000, 'ºC'),
	(305839, 145, '2015-01-01 00:52:28.000000', 'temperatura', 1069.0000, 'ºC'),
	(305840, 145, '2015-01-01 00:52:29.000000', 'temperatura', 963.0000, 'ºC'),
	(305841, 145, '2015-01-01 00:52:30.000000', 'temperatura', 410.0000, 'ºC'),
	(305842, 145, '2015-01-01 00:52:31.000000', 'temperatura', 362.0000, 'ºC'),
	(305843, 145, '2015-01-01 00:52:32.000000', 'temperatura', 580.0000, 'ºC'),
	(305844, 145, '2015-01-01 00:52:33.000000', 'temperatura', 613.0000, 'ºC'),
	(305845, 145, '2015-01-01 00:52:34.000000', 'temperatura', 126.0000, 'ºC'),
	(305846, 145, '2015-01-01 00:52:35.000000', 'temperatura', 1194.0000, 'ºC'),
	(305847, 145, '2015-01-01 00:52:36.000000', 'temperatura', 790.0000, 'ºC'),
	(305848, 145, '2015-01-01 00:52:37.000000', 'temperatura', 367.0000, 'ºC'),
	(305849, 145, '2015-01-01 00:52:38.000000', 'temperatura', 668.0000, 'ºC'),
	(305850, 145, '2015-01-01 00:52:39.000000', 'temperatura', 1038.0000, 'ºC'),
	(305851, 145, '2015-01-01 00:52:40.000000', 'temperatura', 786.0000, 'ºC'),
	(305852, 145, '2015-01-01 00:52:41.000000', 'temperatura', 817.0000, 'ºC'),
	(305853, 145, '2015-01-01 00:52:42.000000', 'temperatura', 526.0000, 'ºC'),
	(305854, 145, '2015-01-01 00:52:43.000000', 'temperatura', 182.0000, 'ºC'),
	(305855, 145, '2015-01-01 00:52:44.000000', 'temperatura', 530.0000, 'ºC'),
	(305856, 145, '2015-01-01 00:52:45.000000', 'temperatura', 905.0000, 'ºC'),
	(305857, 145, '2015-01-01 00:52:46.000000', 'temperatura', 538.0000, 'ºC'),
	(305858, 145, '2015-01-01 00:52:47.000000', 'temperatura', 1173.0000, 'ºC'),
	(305859, 145, '2015-01-01 00:52:48.000000', 'temperatura', 653.0000, 'ºC'),
	(305860, 145, '2015-01-01 00:52:49.000000', 'temperatura', 944.0000, 'ºC'),
	(305861, 145, '2015-01-01 00:52:50.000000', 'temperatura', 364.0000, 'ºC'),
	(305862, 145, '2015-01-01 00:52:51.000000', 'temperatura', 187.0000, 'ºC'),
	(305863, 145, '2015-01-01 00:52:52.000000', 'temperatura', 1044.0000, 'ºC'),
	(305864, 145, '2015-01-01 00:52:53.000000', 'temperatura', 1058.0000, 'ºC'),
	(305865, 145, '2015-01-01 00:52:54.000000', 'temperatura', 960.0000, 'ºC'),
	(305866, 145, '2015-01-01 00:52:55.000000', 'temperatura', 426.0000, 'ºC'),
	(305867, 145, '2015-01-01 00:52:56.000000', 'temperatura', 451.0000, 'ºC'),
	(305868, 145, '2015-01-01 00:52:57.000000', 'temperatura', 977.0000, 'ºC'),
	(305869, 145, '2015-01-01 00:52:58.000000', 'temperatura', 1132.0000, 'ºC'),
	(305870, 145, '2015-01-01 00:52:59.000000', 'temperatura', 330.0000, 'ºC'),
	(305871, 145, '2015-01-01 00:53:00.000000', 'temperatura', 655.0000, 'ºC'),
	(305872, 145, '2015-01-01 00:53:01.000000', 'temperatura', 1084.0000, 'ºC'),
	(305873, 145, '2015-01-01 00:53:02.000000', 'temperatura', 1058.0000, 'ºC'),
	(305874, 145, '2015-01-01 00:53:03.000000', 'temperatura', 836.0000, 'ºC'),
	(305875, 145, '2015-01-01 00:53:04.000000', 'temperatura', 1008.0000, 'ºC'),
	(305876, 145, '2015-01-01 00:53:05.000000', 'temperatura', 133.0000, 'ºC'),
	(305877, 145, '2015-01-01 00:53:06.000000', 'temperatura', 43.0000, 'ºC'),
	(305878, 145, '2015-01-01 00:53:07.000000', 'temperatura', 1013.0000, 'ºC'),
	(305879, 145, '2015-01-01 00:53:08.000000', 'temperatura', 139.0000, 'ºC'),
	(305880, 145, '2015-01-01 00:53:09.000000', 'temperatura', 56.0000, 'ºC'),
	(305881, 145, '2015-01-01 00:53:10.000000', 'temperatura', 1064.0000, 'ºC'),
	(305882, 145, '2015-01-01 00:53:11.000000', 'temperatura', 352.0000, 'ºC'),
	(305883, 145, '2015-01-01 00:53:12.000000', 'temperatura', 968.0000, 'ºC'),
	(305884, 145, '2015-01-01 00:53:13.000000', 'temperatura', 183.0000, 'ºC'),
	(305885, 145, '2015-01-01 00:53:14.000000', 'temperatura', 412.0000, 'ºC'),
	(305886, 145, '2015-01-01 00:53:15.000000', 'temperatura', 311.0000, 'ºC'),
	(305887, 145, '2015-01-01 00:53:16.000000', 'temperatura', 320.0000, 'ºC'),
	(305888, 145, '2015-01-01 00:53:17.000000', 'temperatura', 667.0000, 'ºC'),
	(305889, 145, '2015-01-01 00:53:18.000000', 'temperatura', 1175.0000, 'ºC'),
	(305890, 145, '2015-01-01 00:53:19.000000', 'temperatura', 276.0000, 'ºC'),
	(305891, 145, '2015-01-01 00:53:20.000000', 'temperatura', 255.0000, 'ºC'),
	(305892, 145, '2015-01-01 00:53:21.000000', 'temperatura', 447.0000, 'ºC'),
	(305893, 145, '2015-01-01 00:53:22.000000', 'temperatura', 270.0000, 'ºC'),
	(305894, 145, '2015-01-01 00:53:23.000000', 'temperatura', 10.0000, 'ºC'),
	(305895, 145, '2015-01-01 00:53:24.000000', 'temperatura', 441.0000, 'ºC'),
	(305896, 145, '2015-01-01 00:53:25.000000', 'temperatura', 976.0000, 'ºC'),
	(305897, 145, '2015-01-01 00:53:26.000000', 'temperatura', 1156.0000, 'ºC'),
	(305898, 145, '2015-01-01 00:53:27.000000', 'temperatura', 453.0000, 'ºC'),
	(305899, 145, '2015-01-01 00:53:28.000000', 'temperatura', 0.0000, 'ºC'),
	(305900, 145, '2015-01-01 00:53:29.000000', 'temperatura', 1038.0000, 'ºC'),
	(305901, 145, '2015-01-01 00:53:30.000000', 'temperatura', 390.0000, 'ºC'),
	(305902, 145, '2015-01-01 00:53:31.000000', 'temperatura', 39.0000, 'ºC'),
	(305903, 145, '2015-01-01 00:53:32.000000', 'temperatura', 227.0000, 'ºC'),
	(305904, 145, '2015-01-01 00:53:33.000000', 'temperatura', 1015.0000, 'ºC'),
	(305905, 145, '2015-01-01 00:53:34.000000', 'temperatura', 798.0000, 'ºC'),
	(305906, 145, '2015-01-01 00:53:35.000000', 'temperatura', 942.0000, 'ºC'),
	(305907, 145, '2015-01-01 00:53:36.000000', 'temperatura', 1117.0000, 'ºC'),
	(305908, 145, '2015-01-01 00:53:37.000000', 'temperatura', 360.0000, 'ºC'),
	(305909, 145, '2015-01-01 00:53:38.000000', 'temperatura', 851.0000, 'ºC'),
	(305910, 145, '2015-01-01 00:53:39.000000', 'temperatura', 773.0000, 'ºC'),
	(305911, 145, '2015-01-01 00:53:40.000000', 'temperatura', 112.0000, 'ºC'),
	(305912, 145, '2015-01-01 00:53:41.000000', 'temperatura', 644.0000, 'ºC'),
	(305913, 145, '2015-01-01 00:53:42.000000', 'temperatura', 484.0000, 'ºC'),
	(305914, 145, '2015-01-01 00:53:43.000000', 'temperatura', 490.0000, 'ºC'),
	(305915, 145, '2015-01-01 00:53:44.000000', 'temperatura', 998.0000, 'ºC'),
	(305916, 145, '2015-01-01 00:53:45.000000', 'temperatura', 1120.0000, 'ºC'),
	(305917, 145, '2015-01-01 00:53:46.000000', 'temperatura', 208.0000, 'ºC'),
	(305918, 145, '2015-01-01 00:53:47.000000', 'temperatura', 80.0000, 'ºC'),
	(305919, 145, '2015-01-01 00:53:48.000000', 'temperatura', 976.0000, 'ºC'),
	(305920, 145, '2015-01-01 00:53:49.000000', 'temperatura', 1039.0000, 'ºC'),
	(305921, 145, '2015-01-01 00:53:50.000000', 'temperatura', 1070.0000, 'ºC'),
	(305922, 145, '2015-01-01 00:53:51.000000', 'temperatura', 1033.0000, 'ºC'),
	(305923, 145, '2015-01-01 00:53:52.000000', 'temperatura', 757.0000, 'ºC'),
	(305924, 145, '2015-01-01 00:53:53.000000', 'temperatura', 686.0000, 'ºC'),
	(305925, 145, '2015-01-01 00:53:54.000000', 'temperatura', 1158.0000, 'ºC'),
	(305926, 145, '2015-01-01 00:53:55.000000', 'temperatura', 132.0000, 'ºC'),
	(305927, 145, '2015-01-01 00:53:56.000000', 'temperatura', 786.0000, 'ºC'),
	(305928, 145, '2015-01-01 00:53:57.000000', 'temperatura', 1134.0000, 'ºC'),
	(305929, 145, '2015-01-01 00:53:58.000000', 'temperatura', 915.0000, 'ºC'),
	(305930, 145, '2015-01-01 00:53:59.000000', 'temperatura', 1174.0000, 'ºC'),
	(305931, 145, '2015-01-01 00:54:00.000000', 'temperatura', 724.0000, 'ºC'),
	(305932, 145, '2015-01-01 00:54:01.000000', 'temperatura', 97.0000, 'ºC'),
	(305933, 145, '2015-01-01 00:54:02.000000', 'temperatura', 717.0000, 'ºC'),
	(305934, 145, '2015-01-01 00:54:03.000000', 'temperatura', 891.0000, 'ºC'),
	(305935, 145, '2015-01-01 00:54:04.000000', 'temperatura', 1108.0000, 'ºC'),
	(305936, 145, '2015-01-01 00:54:05.000000', 'temperatura', 465.0000, 'ºC'),
	(305937, 145, '2015-01-01 00:54:06.000000', 'temperatura', 202.0000, 'ºC'),
	(305938, 145, '2015-01-01 00:54:07.000000', 'temperatura', 815.0000, 'ºC'),
	(305939, 145, '2015-01-01 00:54:08.000000', 'temperatura', 1070.0000, 'ºC'),
	(305940, 145, '2015-01-01 00:54:09.000000', 'temperatura', 507.0000, 'ºC'),
	(305941, 145, '2015-01-01 00:54:10.000000', 'temperatura', 523.0000, 'ºC'),
	(305942, 145, '2015-01-01 00:54:11.000000', 'temperatura', 1096.0000, 'ºC'),
	(305943, 145, '2015-01-01 00:54:12.000000', 'temperatura', 310.0000, 'ºC'),
	(305944, 145, '2015-01-01 00:54:13.000000', 'temperatura', 665.0000, 'ºC'),
	(305945, 145, '2015-01-01 00:54:14.000000', 'temperatura', 1193.0000, 'ºC'),
	(305946, 145, '2015-01-01 00:54:15.000000', 'temperatura', 371.0000, 'ºC'),
	(305947, 145, '2015-01-01 00:54:16.000000', 'temperatura', 676.0000, 'ºC'),
	(305948, 145, '2015-01-01 00:54:17.000000', 'temperatura', 1069.0000, 'ºC'),
	(305949, 145, '2015-01-01 00:54:18.000000', 'temperatura', 917.0000, 'ºC'),
	(305950, 145, '2015-01-01 00:54:19.000000', 'temperatura', 179.0000, 'ºC'),
	(305951, 145, '2015-01-01 00:54:20.000000', 'temperatura', 546.0000, 'ºC'),
	(305952, 145, '2015-01-01 00:54:21.000000', 'temperatura', 992.0000, 'ºC'),
	(305953, 145, '2015-01-01 00:54:22.000000', 'temperatura', 923.0000, 'ºC'),
	(305954, 145, '2015-01-01 00:54:23.000000', 'temperatura', 437.0000, 'ºC'),
	(305955, 145, '2015-01-01 00:54:24.000000', 'temperatura', 619.0000, 'ºC'),
	(305956, 145, '2015-01-01 00:54:25.000000', 'temperatura', 584.0000, 'ºC'),
	(305957, 145, '2015-01-01 00:54:26.000000', 'temperatura', 1064.0000, 'ºC'),
	(305958, 145, '2015-01-01 00:54:27.000000', 'temperatura', 1168.0000, 'ºC'),
	(305959, 145, '2015-01-01 00:54:28.000000', 'temperatura', 250.0000, 'ºC'),
	(305960, 145, '2015-01-01 00:54:29.000000', 'temperatura', 146.0000, 'ºC'),
	(305961, 145, '2015-01-01 00:54:30.000000', 'temperatura', 1181.0000, 'ºC'),
	(305962, 145, '2015-01-01 00:54:31.000000', 'temperatura', 667.0000, 'ºC'),
	(305963, 145, '2015-01-01 00:54:32.000000', 'temperatura', 993.0000, 'ºC'),
	(305964, 145, '2015-01-01 00:54:33.000000', 'temperatura', 564.0000, 'ºC'),
	(305965, 145, '2015-01-01 00:54:34.000000', 'temperatura', 1043.0000, 'ºC'),
	(305966, 145, '2015-01-01 00:54:35.000000', 'temperatura', 1125.0000, 'ºC'),
	(305967, 145, '2015-01-01 00:54:36.000000', 'temperatura', 93.0000, 'ºC'),
	(305968, 145, '2015-01-01 00:54:37.000000', 'temperatura', 690.0000, 'ºC'),
	(305969, 145, '2015-01-01 00:54:38.000000', 'temperatura', 774.0000, 'ºC'),
	(305970, 145, '2015-01-01 00:54:39.000000', 'temperatura', 600.0000, 'ºC'),
	(305971, 145, '2015-01-01 00:54:40.000000', 'temperatura', 677.0000, 'ºC'),
	(305972, 145, '2015-01-01 00:54:41.000000', 'temperatura', 388.0000, 'ºC'),
	(305973, 145, '2015-01-01 00:54:42.000000', 'temperatura', 1108.0000, 'ºC'),
	(305974, 145, '2015-01-01 00:54:43.000000', 'temperatura', 778.0000, 'ºC'),
	(305975, 145, '2015-01-01 00:54:44.000000', 'temperatura', 564.0000, 'ºC'),
	(305976, 145, '2015-01-01 00:54:45.000000', 'temperatura', 487.0000, 'ºC'),
	(305977, 145, '2015-01-01 00:54:46.000000', 'temperatura', 743.0000, 'ºC'),
	(305978, 145, '2015-01-01 00:54:47.000000', 'temperatura', 1054.0000, 'ºC'),
	(305979, 145, '2015-01-01 00:54:48.000000', 'temperatura', 644.0000, 'ºC'),
	(305980, 145, '2015-01-01 00:54:49.000000', 'temperatura', 59.0000, 'ºC'),
	(305981, 145, '2015-01-01 00:54:50.000000', 'temperatura', 761.0000, 'ºC'),
	(305982, 145, '2015-01-01 00:54:51.000000', 'temperatura', 32.0000, 'ºC'),
	(305983, 145, '2015-01-01 00:54:52.000000', 'temperatura', 274.0000, 'ºC'),
	(305984, 145, '2015-01-01 00:54:53.000000', 'temperatura', 75.0000, 'ºC'),
	(305985, 145, '2015-01-01 00:54:54.000000', 'temperatura', 754.0000, 'ºC'),
	(305986, 145, '2015-01-01 00:54:55.000000', 'temperatura', 1146.0000, 'ºC'),
	(305987, 145, '2015-01-01 00:54:56.000000', 'temperatura', 1067.0000, 'ºC'),
	(305988, 145, '2015-01-01 00:54:57.000000', 'temperatura', 700.0000, 'ºC'),
	(305989, 145, '2015-01-01 00:54:58.000000', 'temperatura', 297.0000, 'ºC'),
	(305990, 145, '2015-01-01 00:54:59.000000', 'temperatura', 584.0000, 'ºC'),
	(305991, 145, '2015-01-01 00:55:00.000000', 'temperatura', 832.0000, 'ºC'),
	(305992, 145, '2015-01-01 00:55:01.000000', 'temperatura', 10.0000, 'ºC'),
	(305993, 145, '2015-01-01 00:55:02.000000', 'temperatura', 1153.0000, 'ºC'),
	(305994, 145, '2015-01-01 00:55:03.000000', 'temperatura', 937.0000, 'ºC'),
	(305995, 145, '2015-01-01 00:55:04.000000', 'temperatura', 25.0000, 'ºC'),
	(305996, 145, '2015-01-01 00:55:05.000000', 'temperatura', 914.0000, 'ºC'),
	(305997, 145, '2015-01-01 00:55:06.000000', 'temperatura', 896.0000, 'ºC'),
	(305998, 145, '2015-01-01 00:55:07.000000', 'temperatura', 537.0000, 'ºC'),
	(305999, 145, '2015-01-01 00:55:08.000000', 'temperatura', 1197.0000, 'ºC'),
	(306000, 145, '2015-01-01 00:55:09.000000', 'temperatura', 775.0000, 'ºC'),
	(306001, 145, '2015-01-01 00:55:10.000000', 'temperatura', 284.0000, 'ºC'),
	(306002, 145, '2015-01-01 00:55:11.000000', 'temperatura', 294.0000, 'ºC'),
	(306003, 145, '2015-01-01 00:55:12.000000', 'temperatura', 621.0000, 'ºC'),
	(306004, 145, '2015-01-01 00:55:13.000000', 'temperatura', 1025.0000, 'ºC'),
	(306005, 145, '2015-01-01 00:55:14.000000', 'temperatura', 860.0000, 'ºC'),
	(306006, 145, '2015-01-01 00:55:15.000000', 'temperatura', 24.0000, 'ºC'),
	(306007, 145, '2015-01-01 00:55:16.000000', 'temperatura', 1143.0000, 'ºC'),
	(306008, 145, '2015-01-01 00:55:17.000000', 'temperatura', 841.0000, 'ºC'),
	(306009, 145, '2015-01-01 00:55:18.000000', 'temperatura', 776.0000, 'ºC'),
	(306010, 145, '2015-01-01 00:55:19.000000', 'temperatura', 160.0000, 'ºC'),
	(306011, 145, '2015-01-01 00:55:20.000000', 'temperatura', 874.0000, 'ºC'),
	(306012, 145, '2015-01-01 00:55:21.000000', 'temperatura', 287.0000, 'ºC'),
	(306013, 145, '2015-01-01 00:55:22.000000', 'temperatura', 17.0000, 'ºC'),
	(306014, 145, '2015-01-01 00:55:23.000000', 'temperatura', 422.0000, 'ºC'),
	(306015, 145, '2015-01-01 00:55:24.000000', 'temperatura', 859.0000, 'ºC'),
	(306016, 145, '2015-01-01 00:55:25.000000', 'temperatura', 630.0000, 'ºC'),
	(306017, 145, '2015-01-01 00:55:26.000000', 'temperatura', 573.0000, 'ºC'),
	(306018, 145, '2015-01-01 00:55:27.000000', 'temperatura', 978.0000, 'ºC'),
	(306019, 145, '2015-01-01 00:55:28.000000', 'temperatura', 769.0000, 'ºC'),
	(306020, 145, '2015-01-01 00:55:29.000000', 'temperatura', 912.0000, 'ºC'),
	(306021, 145, '2015-01-01 00:55:30.000000', 'temperatura', 1053.0000, 'ºC'),
	(306022, 145, '2015-01-01 00:55:31.000000', 'temperatura', 130.0000, 'ºC'),
	(306023, 145, '2015-01-01 00:55:32.000000', 'temperatura', 1092.0000, 'ºC'),
	(306024, 145, '2015-01-01 00:55:33.000000', 'temperatura', 271.0000, 'ºC'),
	(306025, 145, '2015-01-01 00:55:34.000000', 'temperatura', 478.0000, 'ºC'),
	(306026, 145, '2015-01-01 00:55:35.000000', 'temperatura', 378.0000, 'ºC'),
	(306027, 145, '2015-01-01 00:55:36.000000', 'temperatura', 457.0000, 'ºC'),
	(306028, 145, '2015-01-01 00:55:37.000000', 'temperatura', 1151.0000, 'ºC'),
	(306029, 145, '2015-01-01 00:55:38.000000', 'temperatura', 785.0000, 'ºC'),
	(306030, 145, '2015-01-01 00:55:39.000000', 'temperatura', 471.0000, 'ºC'),
	(306031, 145, '2015-01-01 00:55:40.000000', 'temperatura', 1.0000, 'ºC'),
	(306032, 145, '2015-01-01 00:55:41.000000', 'temperatura', 995.0000, 'ºC'),
	(306033, 145, '2015-01-01 00:55:42.000000', 'temperatura', 170.0000, 'ºC'),
	(306034, 145, '2015-01-01 00:55:43.000000', 'temperatura', 268.0000, 'ºC'),
	(306035, 145, '2015-01-01 00:55:44.000000', 'temperatura', 829.0000, 'ºC'),
	(306036, 145, '2015-01-01 00:55:45.000000', 'temperatura', 941.0000, 'ºC'),
	(306037, 145, '2015-01-01 00:55:46.000000', 'temperatura', 1020.0000, 'ºC'),
	(306038, 145, '2015-01-01 00:55:47.000000', 'temperatura', 1076.0000, 'ºC'),
	(306039, 145, '2015-01-01 00:55:48.000000', 'temperatura', 1121.0000, 'ºC'),
	(306040, 145, '2015-01-01 00:55:49.000000', 'temperatura', 1179.0000, 'ºC'),
	(306041, 145, '2015-01-01 00:55:50.000000', 'temperatura', 131.0000, 'ºC'),
	(306042, 145, '2015-01-01 00:55:51.000000', 'temperatura', 721.0000, 'ºC'),
	(306043, 145, '2015-01-01 00:55:52.000000', 'temperatura', 809.0000, 'ºC'),
	(306044, 145, '2015-01-01 00:55:53.000000', 'temperatura', 683.0000, 'ºC'),
	(306045, 145, '2015-01-01 00:55:54.000000', 'temperatura', 991.0000, 'ºC'),
	(306046, 145, '2015-01-01 00:55:55.000000', 'temperatura', 505.0000, 'ºC'),
	(306047, 145, '2015-01-01 00:55:56.000000', 'temperatura', 752.0000, 'ºC'),
	(306048, 145, '2015-01-01 00:55:57.000000', 'temperatura', 1045.0000, 'ºC'),
	(306049, 145, '2015-01-01 00:55:58.000000', 'temperatura', 571.0000, 'ºC'),
	(306050, 145, '2015-01-01 00:55:59.000000', 'temperatura', 920.0000, 'ºC'),
	(306051, 145, '2015-01-01 00:56:00.000000', 'temperatura', 488.0000, 'ºC'),
	(306052, 145, '2015-01-01 00:56:01.000000', 'temperatura', 879.0000, 'ºC'),
	(306053, 145, '2015-01-01 00:56:02.000000', 'temperatura', 532.0000, 'ºC'),
	(306054, 145, '2015-01-01 00:56:03.000000', 'temperatura', 22.0000, 'ºC'),
	(306055, 145, '2015-01-01 00:56:04.000000', 'temperatura', 914.0000, 'ºC'),
	(306056, 145, '2015-01-01 00:56:05.000000', 'temperatura', 906.0000, 'ºC'),
	(306057, 145, '2015-01-01 00:56:06.000000', 'temperatura', 590.0000, 'ºC'),
	(306058, 145, '2015-01-01 00:56:07.000000', 'temperatura', 232.0000, 'ºC'),
	(306059, 145, '2015-01-01 00:56:08.000000', 'temperatura', 588.0000, 'ºC'),
	(306060, 145, '2015-01-01 00:56:09.000000', 'temperatura', 1048.0000, 'ºC'),
	(306061, 145, '2015-01-01 00:56:10.000000', 'temperatura', 1075.0000, 'ºC'),
	(306062, 145, '2015-01-01 00:56:11.000000', 'temperatura', 1030.0000, 'ºC'),
	(306063, 145, '2015-01-01 00:56:12.000000', 'temperatura', 727.0000, 'ºC'),
	(306064, 145, '2015-01-01 00:56:13.000000', 'temperatura', 545.0000, 'ºC'),
	(306065, 145, '2015-01-01 00:56:14.000000', 'temperatura', 545.0000, 'ºC'),
	(306066, 145, '2015-01-01 00:56:15.000000', 'temperatura', 1091.0000, 'ºC'),
	(306067, 145, '2015-01-01 00:56:16.000000', 'temperatura', 220.0000, 'ºC'),
	(306068, 145, '2015-01-01 00:56:17.000000', 'temperatura', 228.0000, 'ºC'),
	(306069, 145, '2015-01-01 00:56:18.000000', 'temperatura', 478.0000, 'ºC'),
	(306070, 145, '2015-01-01 00:56:19.000000', 'temperatura', 508.0000, 'ºC'),
	(306071, 145, '2015-01-01 00:56:20.000000', 'temperatura', 1108.0000, 'ºC'),
	(306072, 145, '2015-01-01 00:56:21.000000', 'temperatura', 417.0000, 'ºC'),
	(306073, 145, '2015-01-01 00:56:22.000000', 'temperatura', 1161.0000, 'ºC'),
	(306074, 145, '2015-01-01 00:56:23.000000', 'temperatura', 954.0000, 'ºC'),
	(306075, 145, '2015-01-01 00:56:24.000000', 'temperatura', 89.0000, 'ºC'),
	(306076, 145, '2015-01-01 00:56:25.000000', 'temperatura', 1181.0000, 'ºC'),
	(306077, 145, '2015-01-01 00:56:26.000000', 'temperatura', 838.0000, 'ºC'),
	(306078, 145, '2015-01-01 00:56:27.000000', 'temperatura', 648.0000, 'ºC'),
	(306079, 145, '2015-01-01 00:56:28.000000', 'temperatura', 728.0000, 'ºC'),
	(306080, 145, '2015-01-01 00:56:29.000000', 'temperatura', 495.0000, 'ºC'),
	(306081, 145, '2015-01-01 00:56:30.000000', 'temperatura', 290.0000, 'ºC'),
	(306082, 145, '2015-01-01 00:56:31.000000', 'temperatura', 1168.0000, 'ºC'),
	(306083, 145, '2015-01-01 00:56:32.000000', 'temperatura', 171.0000, 'ºC'),
	(306084, 145, '2015-01-01 00:56:33.000000', 'temperatura', 949.0000, 'ºC'),
	(306085, 145, '2015-01-01 00:56:34.000000', 'temperatura', 635.0000, 'ºC'),
	(306086, 145, '2015-01-01 00:56:35.000000', 'temperatura', 327.0000, 'ºC'),
	(306087, 145, '2015-01-01 00:56:36.000000', 'temperatura', 930.0000, 'ºC'),
	(306088, 145, '2015-01-01 00:56:37.000000', 'temperatura', 71.0000, 'ºC'),
	(306089, 145, '2015-01-01 00:56:38.000000', 'temperatura', 1166.0000, 'ºC'),
	(306090, 145, '2015-01-01 00:56:39.000000', 'temperatura', 815.0000, 'ºC'),
	(306091, 145, '2015-01-01 00:56:40.000000', 'temperatura', 578.0000, 'ºC'),
	(306092, 145, '2015-01-01 00:56:41.000000', 'temperatura', 448.0000, 'ºC'),
	(306093, 145, '2015-01-01 00:56:42.000000', 'temperatura', 504.0000, 'ºC'),
	(306094, 145, '2015-01-01 00:56:43.000000', 'temperatura', 1179.0000, 'ºC'),
	(306095, 145, '2015-01-01 00:56:44.000000', 'temperatura', 783.0000, 'ºC'),
	(306096, 145, '2015-01-01 00:56:45.000000', 'temperatura', 379.0000, 'ºC'),
	(306097, 145, '2015-01-01 00:56:46.000000', 'temperatura', 748.0000, 'ºC'),
	(306098, 145, '2015-01-01 00:56:47.000000', 'temperatura', 200.0000, 'ºC'),
	(306099, 145, '2015-01-01 00:56:48.000000', 'temperatura', 1159.0000, 'ºC'),
	(306100, 145, '2015-01-01 00:56:49.000000', 'temperatura', 395.0000, 'ºC'),
	(306101, 145, '2015-01-01 00:56:50.000000', 'temperatura', 900.0000, 'ºC'),
	(306102, 145, '2015-01-01 00:56:51.000000', 'temperatura', 916.0000, 'ºC'),
	(306103, 145, '2015-01-01 00:56:52.000000', 'temperatura', 678.0000, 'ºC'),
	(306104, 145, '2015-01-01 00:56:53.000000', 'temperatura', 644.0000, 'ºC'),
	(306105, 145, '2015-01-01 00:56:54.000000', 'temperatura', 1188.0000, 'ºC'),
	(306106, 145, '2015-01-01 00:56:55.000000', 'temperatura', 405.0000, 'ºC'),
	(306107, 145, '2015-01-01 00:56:56.000000', 'temperatura', 865.0000, 'ºC'),
	(306108, 145, '2015-01-01 00:56:57.000000', 'temperatura', 708.0000, 'ºC'),
	(306109, 145, '2015-01-01 00:56:58.000000', 'temperatura', 948.0000, 'ºC'),
	(306110, 145, '2015-01-01 00:56:59.000000', 'temperatura', 216.0000, 'ºC'),
	(306111, 145, '2015-01-01 00:57:00.000000', 'temperatura', 637.0000, 'ºC'),
	(306112, 145, '2015-01-01 00:57:01.000000', 'temperatura', 135.0000, 'ºC'),
	(306113, 145, '2015-01-01 00:57:02.000000', 'temperatura', 1166.0000, 'ºC'),
	(306114, 145, '2015-01-01 00:57:03.000000', 'temperatura', 626.0000, 'ºC'),
	(306115, 145, '2015-01-01 00:57:04.000000', 'temperatura', 833.0000, 'ºC'),
	(306116, 145, '2015-01-01 00:57:05.000000', 'temperatura', 1089.0000, 'ºC'),
	(306117, 145, '2015-01-01 00:57:06.000000', 'temperatura', 543.0000, 'ºC'),
	(306118, 145, '2015-01-01 00:57:07.000000', 'temperatura', 651.0000, 'ºC'),
	(306119, 145, '2015-01-01 00:57:08.000000', 'temperatura', 426.0000, 'ºC'),
	(306120, 145, '2015-01-01 00:57:09.000000', 'temperatura', 176.0000, 'ºC'),
	(306121, 145, '2015-01-01 00:57:10.000000', 'temperatura', 804.0000, 'ºC'),
	(306122, 145, '2015-01-01 00:57:11.000000', 'temperatura', 1094.0000, 'ºC'),
	(306123, 145, '2015-01-01 00:57:12.000000', 'temperatura', 655.0000, 'ºC'),
	(306124, 145, '2015-01-01 00:57:13.000000', 'temperatura', 1197.0000, 'ºC'),
	(306125, 145, '2015-01-01 00:57:14.000000', 'temperatura', 419.0000, 'ºC'),
	(306126, 145, '2015-01-01 00:57:15.000000', 'temperatura', 905.0000, 'ºC'),
	(306127, 145, '2015-01-01 00:57:16.000000', 'temperatura', 870.0000, 'ºC'),
	(306128, 145, '2015-01-01 00:57:17.000000', 'temperatura', 436.0000, 'ºC'),
	(306129, 145, '2015-01-01 00:57:18.000000', 'temperatura', 768.0000, 'ºC'),
	(306130, 145, '2015-01-01 00:57:19.000000', 'temperatura', 135.0000, 'ºC'),
	(306131, 145, '2015-01-01 00:57:20.000000', 'temperatura', 768.0000, 'ºC'),
	(306132, 145, '2015-01-01 00:57:21.000000', 'temperatura', 1039.0000, 'ºC'),
	(306133, 145, '2015-01-01 00:57:22.000000', 'temperatura', 491.0000, 'ºC'),
	(306134, 145, '2015-01-01 00:57:23.000000', 'temperatura', 538.0000, 'ºC'),
	(306135, 145, '2015-01-01 00:57:24.000000', 'temperatura', 17.0000, 'ºC'),
	(306136, 145, '2015-01-01 00:57:25.000000', 'temperatura', 872.0000, 'ºC'),
	(306137, 145, '2015-01-01 00:57:26.000000', 'temperatura', 711.0000, 'ºC'),
	(306138, 145, '2015-01-01 00:57:27.000000', 'temperatura', 937.0000, 'ºC'),
	(306139, 145, '2015-01-01 00:57:28.000000', 'temperatura', 154.0000, 'ºC'),
	(306140, 145, '2015-01-01 00:57:29.000000', 'temperatura', 360.0000, 'ºC'),
	(306141, 145, '2015-01-01 00:57:30.000000', 'temperatura', 136.0000, 'ºC'),
	(306142, 145, '2015-01-01 00:57:31.000000', 'temperatura', 801.0000, 'ºC'),
	(306143, 145, '2015-01-01 00:57:32.000000', 'temperatura', 0.0000, 'ºC'),
	(306144, 145, '2015-01-01 00:57:33.000000', 'temperatura', 1197.0000, 'ºC'),
	(306145, 145, '2015-01-01 00:57:34.000000', 'temperatura', 1185.0000, 'ºC'),
	(306146, 145, '2015-01-01 00:57:35.000000', 'temperatura', 1134.0000, 'ºC'),
	(306147, 145, '2015-01-01 00:57:36.000000', 'temperatura', 917.0000, 'ºC'),
	(306148, 145, '2015-01-01 00:57:37.000000', 'temperatura', 1183.0000, 'ºC'),
	(306149, 145, '2015-01-01 00:57:38.000000', 'temperatura', 766.0000, 'ºC'),
	(306150, 145, '2015-01-01 00:57:39.000000', 'temperatura', 278.0000, 'ºC'),
	(306151, 145, '2015-01-01 00:57:40.000000', 'temperatura', 296.0000, 'ºC'),
	(306152, 145, '2015-01-01 00:57:41.000000', 'temperatura', 644.0000, 'ºC'),
	(306153, 145, '2015-01-01 00:57:42.000000', 'temperatura', 1132.0000, 'ºC'),
	(306154, 145, '2015-01-01 00:57:43.000000', 'temperatura', 130.0000, 'ºC'),
	(306155, 145, '2015-01-01 00:57:44.000000', 'temperatura', 855.0000, 'ºC'),
	(306156, 145, '2015-01-01 00:57:45.000000', 'temperatura', 283.0000, 'ºC'),
	(306157, 145, '2015-01-01 00:57:46.000000', 'temperatura', 53.0000, 'ºC'),
	(306158, 145, '2015-01-01 00:57:47.000000', 'temperatura', 618.0000, 'ºC'),
	(306159, 145, '2015-01-01 00:57:48.000000', 'temperatura', 529.0000, 'ºC'),
	(306160, 145, '2015-01-01 00:57:49.000000', 'temperatura', 792.0000, 'ºC'),
	(306161, 145, '2015-01-01 00:57:50.000000', 'temperatura', 1173.0000, 'ºC'),
	(306162, 145, '2015-01-01 00:57:51.000000', 'temperatura', 1088.0000, 'ºC'),
	(306163, 145, '2015-01-01 00:57:52.000000', 'temperatura', 724.0000, 'ºC'),
	(306164, 145, '2015-01-01 00:57:53.000000', 'temperatura', 354.0000, 'ºC'),
	(306165, 145, '2015-01-01 00:57:54.000000', 'temperatura', 801.0000, 'ºC'),
	(306166, 145, '2015-01-01 00:57:55.000000', 'temperatura', 543.0000, 'ºC'),
	(306167, 145, '2015-01-01 00:57:56.000000', 'temperatura', 310.0000, 'ºC'),
	(306168, 145, '2015-01-01 00:57:57.000000', 'temperatura', 1124.0000, 'ºC'),
	(306169, 145, '2015-01-01 00:57:58.000000', 'temperatura', 1092.0000, 'ºC'),
	(306170, 145, '2015-01-01 00:57:59.000000', 'temperatura', 886.0000, 'ºC'),
	(306171, 145, '2015-01-01 00:58:00.000000', 'temperatura', 1154.0000, 'ºC'),
	(306172, 145, '2015-01-01 00:58:01.000000', 'temperatura', 713.0000, 'ºC'),
	(306173, 145, '2015-01-01 00:58:02.000000', 'temperatura', 102.0000, 'ºC'),
	(306174, 145, '2015-01-01 00:58:03.000000', 'temperatura', 774.0000, 'ºC'),
	(306175, 145, '2015-01-01 00:58:04.000000', 'temperatura', 1163.0000, 'ºC'),
	(306176, 145, '2015-01-01 00:58:05.000000', 'temperatura', 1092.0000, 'ºC'),
	(306177, 145, '2015-01-01 00:58:06.000000', 'temperatura', 773.0000, 'ºC'),
	(306178, 145, '2015-01-01 00:58:07.000000', 'temperatura', 589.0000, 'ºC'),
	(306179, 145, '2015-01-01 00:58:08.000000', 'temperatura', 625.0000, 'ºC'),
	(306180, 145, '2015-01-01 00:58:09.000000', 'temperatura', 162.0000, 'ºC'),
	(306181, 145, '2015-01-01 00:58:10.000000', 'temperatura', 133.0000, 'ºC'),
	(306182, 145, '2015-01-01 00:58:11.000000', 'temperatura', 179.0000, 'ºC'),
	(306183, 145, '2015-01-01 00:58:12.000000', 'temperatura', 498.0000, 'ºC'),
	(306184, 145, '2015-01-01 00:58:13.000000', 'temperatura', 755.0000, 'ºC'),
	(306185, 145, '2015-01-01 00:58:14.000000', 'temperatura', 1079.0000, 'ºC'),
	(306186, 145, '2015-01-01 00:58:15.000000', 'temperatura', 731.0000, 'ºC'),
	(306187, 145, '2015-01-01 00:58:16.000000', 'temperatura', 417.0000, 'ºC'),
	(306188, 145, '2015-01-01 00:58:17.000000', 'temperatura', 1095.0000, 'ºC'),
	(306189, 145, '2015-01-01 00:58:18.000000', 'temperatura', 625.0000, 'ºC'),
	(306190, 145, '2015-01-01 00:58:19.000000', 'temperatura', 1038.0000, 'ºC'),
	(306191, 145, '2015-01-01 00:58:20.000000', 'temperatura', 916.0000, 'ºC'),
	(306192, 145, '2015-01-01 00:58:21.000000', 'temperatura', 267.0000, 'ºC'),
	(306193, 145, '2015-01-01 00:58:22.000000', 'temperatura', 986.0000, 'ºC'),
	(306194, 145, '2015-01-01 00:58:23.000000', 'temperatura', 530.0000, 'ºC'),
	(306195, 145, '2015-01-01 00:58:24.000000', 'temperatura', 894.0000, 'ºC'),
	(306196, 145, '2015-01-01 00:58:25.000000', 'temperatura', 479.0000, 'ºC'),
	(306197, 145, '2015-01-01 00:58:26.000000', 'temperatura', 913.0000, 'ºC'),
	(306198, 145, '2015-01-01 00:58:27.000000', 'temperatura', 729.0000, 'ºC'),
	(306199, 145, '2015-01-01 00:58:28.000000', 'temperatura', 907.0000, 'ºC'),
	(306200, 145, '2015-01-01 00:58:29.000000', 'temperatura', 1148.0000, 'ºC'),
	(306201, 145, '2015-01-01 00:58:30.000000', 'temperatura', 622.0000, 'ºC'),
	(306202, 145, '2015-01-01 00:58:31.000000', 'temperatura', 864.0000, 'ºC'),
	(306203, 145, '2015-01-01 00:58:32.000000', 'temperatura', 54.0000, 'ºC'),
	(306204, 145, '2015-01-01 00:58:33.000000', 'temperatura', 81.0000, 'ºC'),
	(306205, 145, '2015-01-01 00:58:34.000000', 'temperatura', 242.0000, 'ºC'),
	(306206, 145, '2015-01-01 00:58:35.000000', 'temperatura', 967.0000, 'ºC'),
	(306207, 145, '2015-01-01 00:58:36.000000', 'temperatura', 509.0000, 'ºC'),
	(306208, 145, '2015-01-01 00:58:37.000000', 'temperatura', 845.0000, 'ºC'),
	(306209, 145, '2015-01-01 00:58:38.000000', 'temperatura', 298.0000, 'ºC'),
	(306210, 145, '2015-01-01 00:58:39.000000', 'temperatura', 156.0000, 'ºC'),
	(306211, 145, '2015-01-01 00:58:40.000000', 'temperatura', 1084.0000, 'ºC'),
	(306212, 145, '2015-01-01 00:58:41.000000', 'temperatura', 156.0000, 'ºC'),
	(306213, 145, '2015-01-01 00:58:42.000000', 'temperatura', 1126.0000, 'ºC'),
	(306214, 145, '2015-01-01 00:58:43.000000', 'temperatura', 365.0000, 'ºC'),
	(306215, 145, '2015-01-01 00:58:44.000000', 'temperatura', 848.0000, 'ºC'),
	(306216, 145, '2015-01-01 00:58:45.000000', 'temperatura', 746.0000, 'ºC'),
	(306217, 145, '2015-01-01 00:58:46.000000', 'temperatura', 1184.0000, 'ºC'),
	(306218, 145, '2015-01-01 00:58:47.000000', 'temperatura', 83.0000, 'ºC'),
	(306219, 145, '2015-01-01 00:58:48.000000', 'temperatura', 462.0000, 'ºC'),
	(306220, 145, '2015-01-01 00:58:49.000000', 'temperatura', 865.0000, 'ºC'),
	(306221, 145, '2015-01-01 00:58:50.000000', 'temperatura', 537.0000, 'ºC'),
	(306222, 145, '2015-01-01 00:58:51.000000', 'temperatura', 91.0000, 'ºC'),
	(306223, 145, '2015-01-01 00:58:52.000000', 'temperatura', 43.0000, 'ºC'),
	(306224, 145, '2015-01-01 00:58:53.000000', 'temperatura', 1142.0000, 'ºC'),
	(306225, 145, '2015-01-01 00:58:54.000000', 'temperatura', 782.0000, 'ºC'),
	(306226, 145, '2015-01-01 00:58:55.000000', 'temperatura', 485.0000, 'ºC'),
	(306227, 145, '2015-01-01 00:58:56.000000', 'temperatura', 77.0000, 'ºC'),
	(306228, 145, '2015-01-01 00:58:57.000000', 'temperatura', 134.0000, 'ºC'),
	(306229, 145, '2015-01-01 00:58:58.000000', 'temperatura', 437.0000, 'ºC'),
	(306230, 145, '2015-01-01 00:58:59.000000', 'temperatura', 583.0000, 'ºC'),
	(306231, 145, '2015-01-01 00:59:00.000000', 'temperatura', 404.0000, 'ºC'),
	(306232, 145, '2015-01-01 00:59:01.000000', 'temperatura', 272.0000, 'ºC'),
	(306233, 145, '2015-01-01 00:59:02.000000', 'temperatura', 151.0000, 'ºC'),
	(306234, 145, '2015-01-01 00:59:03.000000', 'temperatura', 1137.0000, 'ºC'),
	(306235, 145, '2015-01-01 00:59:04.000000', 'temperatura', 431.0000, 'ºC'),
	(306236, 145, '2015-01-01 00:59:05.000000', 'temperatura', 1147.0000, 'ºC'),
	(306237, 145, '2015-01-01 00:59:06.000000', 'temperatura', 841.0000, 'ºC'),
	(306238, 145, '2015-01-01 00:59:07.000000', 'temperatura', 766.0000, 'ºC'),
	(306239, 145, '2015-01-01 00:59:08.000000', 'temperatura', 107.0000, 'ºC'),
	(306240, 145, '2015-01-01 00:59:09.000000', 'temperatura', 636.0000, 'ºC'),
	(306241, 145, '2015-01-01 00:59:10.000000', 'temperatura', 461.0000, 'ºC'),
	(306242, 145, '2015-01-01 00:59:11.000000', 'temperatura', 397.0000, 'ºC'),
	(306243, 145, '2015-01-01 00:59:12.000000', 'temperatura', 601.0000, 'ºC'),
	(306244, 145, '2015-01-01 00:59:13.000000', 'temperatura', 614.0000, 'ºC'),
	(306245, 145, '2015-01-01 00:59:14.000000', 'temperatura', 70.0000, 'ºC'),
	(306246, 145, '2015-01-01 00:59:15.000000', 'temperatura', 909.0000, 'ºC'),
	(306247, 145, '2015-01-01 00:59:16.000000', 'temperatura', 736.0000, 'ºC'),
	(306248, 145, '2015-01-01 00:59:17.000000', 'temperatura', 954.0000, 'ºC'),
	(306249, 145, '2015-01-01 00:59:18.000000', 'temperatura', 162.0000, 'ºC'),
	(306250, 145, '2015-01-01 00:59:19.000000', 'temperatura', 349.0000, 'ºC'),
	(306251, 145, '2015-01-01 00:59:20.000000', 'temperatura', 58.0000, 'ºC'),
	(306252, 145, '2015-01-01 00:59:21.000000', 'temperatura', 445.0000, 'ºC'),
	(306253, 145, '2015-01-01 00:59:22.000000', 'temperatura', 851.0000, 'ºC'),
	(306254, 145, '2015-01-01 00:59:23.000000', 'temperatura', 520.0000, 'ºC'),
	(306255, 145, '2015-01-01 00:59:24.000000', 'temperatura', 48.0000, 'ºC'),
	(306256, 145, '2015-01-01 00:59:25.000000', 'temperatura', 1078.0000, 'ºC'),
	(306257, 145, '2015-01-01 00:59:26.000000', 'temperatura', 450.0000, 'ºC'),
	(306258, 145, '2015-01-01 00:59:27.000000', 'temperatura', 213.0000, 'ºC'),
	(306259, 145, '2015-01-01 00:59:28.000000', 'temperatura', 918.0000, 'ºC'),
	(306260, 145, '2015-01-01 00:59:29.000000', 'temperatura', 352.0000, 'ºC'),
	(306261, 145, '2015-01-01 00:59:30.000000', 'temperatura', 206.0000, 'ºC'),
	(306262, 145, '2015-01-01 00:59:31.000000', 'temperatura', 1175.0000, 'ºC'),
	(306263, 145, '2015-01-01 00:59:32.000000', 'temperatura', 456.0000, 'ºC'),
	(306264, 145, '2015-01-01 00:59:33.000000', 'temperatura', 1158.0000, 'ºC'),
	(306265, 145, '2015-01-01 00:59:34.000000', 'temperatura', 821.0000, 'ºC'),
	(306266, 145, '2015-01-01 00:59:35.000000', 'temperatura', 632.0000, 'ºC'),
	(306267, 145, '2015-01-01 00:59:36.000000', 'temperatura', 696.0000, 'ºC'),
	(306268, 145, '2015-01-01 00:59:37.000000', 'temperatura', 384.0000, 'ºC'),
	(306269, 145, '2015-01-01 00:59:38.000000', 'temperatura', 1032.0000, 'ºC'),
	(306270, 145, '2015-01-01 00:59:39.000000', 'temperatura', 409.0000, 'ºC'),
	(306271, 145, '2015-01-01 00:59:40.000000', 'temperatura', 149.0000, 'ºC'),
	(306272, 145, '2015-01-01 00:59:41.000000', 'temperatura', 721.0000, 'ºC'),
	(306273, 145, '2015-01-01 00:59:42.000000', 'temperatura', 758.0000, 'ºC'),
	(306274, 145, '2015-01-01 00:59:43.000000', 'temperatura', 426.0000, 'ºC'),
	(306275, 145, '2015-01-01 00:59:44.000000', 'temperatura', 1056.0000, 'ºC'),
	(306276, 145, '2015-01-01 00:59:45.000000', 'temperatura', 402.0000, 'ºC'),
	(306277, 145, '2015-01-01 00:59:46.000000', 'temperatura', 46.0000, 'ºC'),
	(306278, 145, '2015-01-01 00:59:47.000000', 'temperatura', 221.0000, 'ºC'),
	(306279, 145, '2015-01-01 00:59:48.000000', 'temperatura', 967.0000, 'ºC'),
	(306280, 145, '2015-01-01 00:59:49.000000', 'temperatura', 576.0000, 'ºC'),
	(306281, 145, '2015-01-01 00:59:50.000000', 'temperatura', 1176.0000, 'ºC'),
	(306282, 145, '2015-01-01 00:59:51.000000', 'temperatura', 553.0000, 'ºC'),
	(306283, 145, '2015-01-01 00:59:52.000000', 'temperatura', 438.0000, 'ºC'),
	(306284, 145, '2015-01-01 00:59:53.000000', 'temperatura', 531.0000, 'ºC'),
	(306285, 145, '2015-01-01 00:59:54.000000', 'temperatura', 140.0000, 'ºC'),
	(306286, 145, '2015-01-01 00:59:55.000000', 'temperatura', 308.0000, 'ºC'),
	(306287, 145, '2015-01-01 00:59:56.000000', 'temperatura', 1121.0000, 'ºC'),
	(306288, 145, '2015-01-01 00:59:57.000000', 'temperatura', 1083.0000, 'ºC'),
	(306289, 145, '2015-01-01 00:59:58.000000', 'temperatura', 854.0000, 'ºC'),
	(306290, 145, '2015-01-01 00:59:59.000000', 'temperatura', 1018.0000, 'ºC'),
	(306291, 145, '2015-01-01 01:00:00.000000', 'temperatura', 129.0000, 'ºC'),
	(306292, 145, '2015-01-01 01:00:01.000000', 'temperatura', 1191.0000, 'ºC'),
	(306293, 145, '2015-01-01 01:00:02.000000', 'temperatura', 767.0000, 'ºC'),
	(306294, 145, '2015-01-01 01:00:03.000000', 'temperatura', 264.0000, 'ºC'),
	(306295, 145, '2015-01-01 01:00:04.000000', 'temperatura', 221.0000, 'ºC'),
	(306296, 145, '2015-01-01 01:00:05.000000', 'temperatura', 311.0000, 'ºC'),
	(306297, 145, '2015-01-01 01:00:06.000000', 'temperatura', 895.0000, 'ºC'),
	(306298, 145, '2015-01-01 01:00:07.000000', 'temperatura', 1142.0000, 'ºC'),
	(306299, 145, '2015-01-01 01:00:08.000000', 'temperatura', 626.0000, 'ºC'),
	(306300, 145, '2015-01-01 01:00:09.000000', 'temperatura', 902.0000, 'ºC'),
	(306301, 145, '2015-01-01 01:00:10.000000', 'temperatura', 234.0000, 'ºC'),
	(306302, 145, '2015-01-01 01:00:11.000000', 'temperatura', 866.0000, 'ºC'),
	(306303, 145, '2015-01-01 01:00:12.000000', 'temperatura', 29.0000, 'ºC'),
	(306304, 145, '2015-01-01 01:00:13.000000', 'temperatura', 1147.0000, 'ºC'),
	(306305, 145, '2015-01-01 01:00:14.000000', 'temperatura', 847.0000, 'ºC'),
	(306306, 145, '2015-01-01 01:00:15.000000', 'temperatura', 797.0000, 'ºC'),
	(306307, 145, '2015-01-01 01:00:16.000000', 'temperatura', 244.0000, 'ºC'),
	(306308, 145, '2015-01-01 01:00:17.000000', 'temperatura', 31.0000, 'ºC'),
	(306309, 145, '2015-01-01 01:00:18.000000', 'temperatura', 620.0000, 'ºC'),
	(306310, 145, '2015-01-01 01:00:19.000000', 'temperatura', 611.0000, 'ºC'),
	(306311, 145, '2015-01-01 01:00:20.000000', 'temperatura', 1192.0000, 'ºC'),
	(306312, 145, '2015-01-01 01:00:21.000000', 'temperatura', 531.0000, 'ºC'),
	(306313, 145, '2015-01-01 01:00:22.000000', 'temperatura', 277.0000, 'ºC'),
	(306314, 145, '2015-01-01 01:00:23.000000', 'temperatura', 993.0000, 'ºC'),
	(306315, 145, '2015-01-01 01:00:24.000000', 'temperatura', 535.0000, 'ºC'),
	(306316, 145, '2015-01-01 01:00:25.000000', 'temperatura', 897.0000, 'ºC'),
	(306317, 145, '2015-01-01 01:00:26.000000', 'temperatura', 479.0000, 'ºC'),
	(306318, 145, '2015-01-01 01:00:27.000000', 'temperatura', 906.0000, 'ºC'),
	(306319, 145, '2015-01-01 01:00:28.000000', 'temperatura', 692.0000, 'ºC'),
	(306320, 145, '2015-01-01 01:00:29.000000', 'temperatura', 742.0000, 'ºC'),
	(306321, 145, '2015-01-01 01:00:30.000000', 'temperatura', 436.0000, 'ºC'),
	(306322, 145, '2015-01-01 01:00:31.000000', 'temperatura', 1156.0000, 'ºC'),
	(306323, 145, '2015-01-01 01:00:32.000000', 'temperatura', 871.0000, 'ºC'),
	(306324, 145, '2015-01-01 01:00:33.000000', 'temperatura', 886.0000, 'ºC'),
	(306325, 145, '2015-01-01 01:00:34.000000', 'temperatura', 618.0000, 'ºC'),
	(306326, 145, '2015-01-01 01:00:35.000000', 'temperatura', 431.0000, 'ºC'),
	(306327, 145, '2015-01-01 01:00:36.000000', 'temperatura', 302.0000, 'ºC'),
	(306328, 145, '2015-01-01 01:00:37.000000', 'temperatura', 219.0000, 'ºC'),
	(306329, 145, '2015-01-01 01:00:38.000000', 'temperatura', 187.0000, 'ºC'),
	(306330, 145, '2015-01-01 01:00:39.000000', 'temperatura', 279.0000, 'ºC'),
	(306331, 145, '2015-01-01 01:00:40.000000', 'temperatura', 835.0000, 'ºC'),
	(306332, 145, '2015-01-01 01:00:41.000000', 'temperatura', 940.0000, 'ºC'),
	(306333, 145, '2015-01-01 01:00:42.000000', 'temperatura', 993.0000, 'ºC'),
	(306334, 145, '2015-01-01 01:00:43.000000', 'temperatura', 949.0000, 'ºC'),
	(306335, 145, '2015-01-01 01:00:44.000000', 'temperatura', 563.0000, 'ºC'),
	(306336, 145, '2015-01-01 01:00:45.000000', 'temperatura', 1169.0000, 'ºC'),
	(306337, 145, '2015-01-01 01:00:46.000000', 'temperatura', 555.0000, 'ºC'),
	(306338, 145, '2015-01-01 01:00:47.000000', 'temperatura', 471.0000, 'ºC'),
	(306339, 145, '2015-01-01 01:00:48.000000', 'temperatura', 688.0000, 'ºC'),
	(306340, 145, '2015-01-01 01:00:49.000000', 'temperatura', 829.0000, 'ºC'),
	(306341, 145, '2015-01-01 01:00:50.000000', 'temperatura', 880.0000, 'ºC'),
	(306342, 145, '2015-01-01 01:00:51.000000', 'temperatura', 715.0000, 'ºC'),
	(306343, 145, '2015-01-01 01:00:52.000000', 'temperatura', 935.0000, 'ºC'),
	(306344, 145, '2015-01-01 01:00:53.000000', 'temperatura', 131.0000, 'ºC'),
	(306345, 145, '2015-01-01 01:00:54.000000', 'temperatura', 251.0000, 'ºC'),
	(306346, 145, '2015-01-01 01:00:55.000000', 'temperatura', 863.0000, 'ºC'),
	(306347, 145, '2015-01-01 01:00:56.000000', 'temperatura', 1162.0000, 'ºC'),
	(306348, 145, '2015-01-01 01:00:57.000000', 'temperatura', 819.0000, 'ºC'),
	(306349, 145, '2015-01-01 01:00:58.000000', 'temperatura', 613.0000, 'ºC'),
	(306350, 145, '2015-01-01 01:00:59.000000', 'temperatura', 606.0000, 'ºC'),
	(306351, 145, '2015-01-01 01:01:00.000000', 'temperatura', 1192.0000, 'ºC'),
	(306352, 145, '2015-01-01 01:01:01.000000', 'temperatura', 542.0000, 'ºC'),
	(306353, 145, '2015-01-01 01:01:02.000000', 'temperatura', 333.0000, 'ºC'),
	(306354, 145, '2015-01-01 01:01:03.000000', 'temperatura', 42.0000, 'ºC'),
	(306355, 145, '2015-01-01 01:01:04.000000', 'temperatura', 411.0000, 'ºC'),
	(306356, 145, '2015-01-01 01:01:05.000000', 'temperatura', 730.0000, 'ºC'),
	(306357, 145, '2015-01-01 01:01:06.000000', 'temperatura', 16.0000, 'ºC'),
	(306358, 145, '2015-01-01 01:01:07.000000', 'temperatura', 291.0000, 'ºC'),
	(306359, 145, '2015-01-01 01:01:08.000000', 'temperatura', 207.0000, 'ºC'),
	(306360, 145, '2015-01-01 01:01:09.000000', 'temperatura', 162.0000, 'ºC'),
	(306361, 145, '2015-01-01 01:01:10.000000', 'temperatura', 190.0000, 'ºC'),
	(306362, 145, '2015-01-01 01:01:11.000000', 'temperatura', 466.0000, 'ºC'),
	(306363, 145, '2015-01-01 01:01:12.000000', 'temperatura', 560.0000, 'ºC'),
	(306364, 145, '2015-01-01 01:01:13.000000', 'temperatura', 201.0000, 'ºC'),
	(306365, 145, '2015-01-01 01:01:14.000000', 'temperatura', 527.0000, 'ºC'),
	(306366, 145, '2015-01-01 01:01:15.000000', 'temperatura', 831.0000, 'ºC'),
	(306367, 145, '2015-01-01 01:01:16.000000', 'temperatura', 174.0000, 'ºC'),
	(306368, 145, '2015-01-01 01:01:17.000000', 'temperatura', 779.0000, 'ºC'),
	(306369, 145, '2015-01-01 01:01:18.000000', 'temperatura', 974.0000, 'ºC'),
	(306370, 145, '2015-01-01 01:01:19.000000', 'temperatura', 132.0000, 'ºC'),
	(306371, 145, '2015-01-01 01:01:20.000000', 'temperatura', 139.0000, 'ºC'),
	(306372, 145, '2015-01-01 01:01:21.000000', 'temperatura', 298.0000, 'ºC'),
	(306373, 145, '2015-01-01 01:01:22.000000', 'temperatura', 1074.0000, 'ºC'),
	(306374, 145, '2015-01-01 01:01:23.000000', 'temperatura', 877.0000, 'ºC'),
	(306375, 145, '2015-01-01 01:01:24.000000', 'temperatura', 1165.0000, 'ºC'),
	(306376, 145, '2015-01-01 01:01:25.000000', 'temperatura', 796.0000, 'ºC'),
	(306377, 145, '2015-01-01 01:01:26.000000', 'temperatura', 482.0000, 'ºC'),
	(306378, 145, '2015-01-01 01:01:27.000000', 'temperatura', 22.0000, 'ºC'),
	(306379, 145, '2015-01-01 01:01:28.000000', 'temperatura', 1065.0000, 'ºC'),
	(306380, 145, '2015-01-01 01:01:29.000000', 'temperatura', 461.0000, 'ºC'),
	(306381, 145, '2015-01-01 01:01:30.000000', 'temperatura', 311.0000, 'ºC'),
	(306382, 145, '2015-01-01 01:01:31.000000', 'temperatura', 173.0000, 'ºC'),
	(306383, 145, '2015-01-01 01:01:32.000000', 'temperatura', 1131.0000, 'ºC'),
	(306384, 145, '2015-01-01 01:01:33.000000', 'temperatura', 339.0000, 'ºC'),
	(306385, 145, '2015-01-01 01:01:34.000000', 'temperatura', 701.0000, 'ºC'),
	(306386, 145, '2015-01-01 01:01:35.000000', 'temperatura', 89.0000, 'ºC'),
	(306387, 145, '2015-01-01 01:01:36.000000', 'temperatura', 740.0000, 'ºC'),
	(306388, 145, '2015-01-01 01:01:37.000000', 'temperatura', 1036.0000, 'ºC'),
	(306389, 145, '2015-01-01 01:01:38.000000', 'temperatura', 558.0000, 'ºC'),
	(306390, 145, '2015-01-01 01:01:39.000000', 'temperatura', 885.0000, 'ºC'),
	(306391, 145, '2015-01-01 01:01:40.000000', 'temperatura', 352.0000, 'ºC'),
	(306392, 145, '2015-01-01 01:01:41.000000', 'temperatura', 303.0000, 'ºC'),
	(306393, 145, '2015-01-01 01:01:42.000000', 'temperatura', 460.0000, 'ºC'),
	(306394, 145, '2015-01-01 01:01:43.000000', 'temperatura', 193.0000, 'ºC'),
	(306395, 145, '2015-01-01 01:01:44.000000', 'temperatura', 783.0000, 'ºC'),
	(306396, 145, '2015-01-01 01:01:45.000000', 'temperatura', 938.0000, 'ºC'),
	(306397, 145, '2015-01-01 01:01:46.000000', 'temperatura', 1143.0000, 'ºC'),
	(306398, 145, '2015-01-01 01:01:47.000000', 'temperatura', 501.0000, 'ºC'),
	(306399, 145, '2015-01-01 01:01:48.000000', 'temperatura', 277.0000, 'ºC'),
	(306400, 145, '2015-01-01 01:01:49.000000', 'temperatura', 1083.0000, 'ºC'),
	(306401, 145, '2015-01-01 01:01:50.000000', 'temperatura', 984.0000, 'ºC'),
	(306402, 145, '2015-01-01 01:01:51.000000', 'temperatura', 472.0000, 'ºC'),
	(306403, 145, '2015-01-01 01:01:52.000000', 'temperatura', 610.0000, 'ºC'),
	(306404, 145, '2015-01-01 01:01:53.000000', 'temperatura', 431.0000, 'ºC'),
	(306405, 145, '2015-01-01 01:01:54.000000', 'temperatura', 328.0000, 'ºC'),
	(306406, 145, '2015-01-01 01:01:55.000000', 'temperatura', 346.0000, 'ºC'),
	(306407, 145, '2015-01-01 01:01:56.000000', 'temperatura', 749.0000, 'ºC'),
	(306408, 145, '2015-01-01 01:01:57.000000', 'temperatura', 306.0000, 'ºC'),
	(306409, 145, '2015-01-01 01:01:58.000000', 'temperatura', 482.0000, 'ºC'),
	(306410, 145, '2015-01-01 01:01:59.000000', 'temperatura', 294.0000, 'ºC'),
	(306411, 145, '2015-01-01 01:02:00.000000', 'temperatura', 24.0000, 'ºC'),
	(306412, 145, '2015-01-01 01:02:01.000000', 'temperatura', 437.0000, 'ºC'),
	(306413, 145, '2015-01-01 01:02:02.000000', 'temperatura', 916.0000, 'ºC'),
	(306414, 145, '2015-01-01 01:02:03.000000', 'temperatura', 870.0000, 'ºC'),
	(306415, 145, '2015-01-01 01:02:04.000000', 'temperatura', 401.0000, 'ºC'),
	(306416, 145, '2015-01-01 01:02:05.000000', 'temperatura', 595.0000, 'ºC'),
	(306417, 145, '2015-01-01 01:02:06.000000', 'temperatura', 571.0000, 'ºC'),
	(306418, 145, '2015-01-01 01:02:07.000000', 'temperatura', 1073.0000, 'ºC'),
	(306419, 145, '2015-01-01 01:02:08.000000', 'temperatura', 53.0000, 'ºC'),
	(306420, 145, '2015-01-01 01:02:09.000000', 'temperatura', 645.0000, 'ºC'),
	(306421, 145, '2015-01-01 01:02:10.000000', 'temperatura', 669.0000, 'ºC'),
	(306422, 145, '2015-01-01 01:02:11.000000', 'temperatura', 209.0000, 'ºC'),
	(306423, 145, '2015-01-01 01:02:12.000000', 'temperatura', 241.0000, 'ºC'),
	(306424, 145, '2015-01-01 01:02:13.000000', 'temperatura', 575.0000, 'ºC'),
	(306425, 145, '2015-01-01 01:02:14.000000', 'temperatura', 955.0000, 'ºC'),
	(306426, 145, '2015-01-01 01:02:15.000000', 'temperatura', 649.0000, 'ºC'),
	(306427, 145, '2015-01-01 01:02:16.000000', 'temperatura', 381.0000, 'ºC'),
	(306428, 145, '2015-01-01 01:02:17.000000', 'temperatura', 1159.0000, 'ºC'),
	(306429, 145, '2015-01-01 01:02:18.000000', 'temperatura', 1054.0000, 'ºC'),
	(306430, 145, '2015-01-01 01:02:19.000000', 'temperatura', 592.0000, 'ºC'),
	(306431, 145, '2015-01-01 01:02:20.000000', 'temperatura', 998.0000, 'ºC'),
	(306432, 145, '2015-01-01 01:02:21.000000', 'temperatura', 814.0000, 'ºC'),
	(306433, 145, '2015-01-01 01:02:22.000000', 'temperatura', 1077.0000, 'ºC'),
	(306434, 145, '2015-01-01 01:02:23.000000', 'temperatura', 545.0000, 'ºC'),
	(306435, 145, '2015-01-01 01:02:24.000000', 'temperatura', 694.0000, 'ºC'),
	(306436, 145, '2015-01-01 01:02:25.000000', 'temperatura', 635.0000, 'ºC'),
	(306437, 145, '2015-01-01 01:02:26.000000', 'temperatura', 1092.0000, 'ºC'),
	(306438, 145, '2015-01-01 01:02:27.000000', 'temperatura', 1157.0000, 'ºC'),
	(306439, 145, '2015-01-01 01:02:28.000000', 'temperatura', 110.0000, 'ºC'),
	(306440, 145, '2015-01-01 01:02:29.000000', 'temperatura', 677.0000, 'ºC'),
	(306441, 145, '2015-01-01 01:02:30.000000', 'temperatura', 657.0000, 'ºC'),
	(306442, 145, '2015-01-01 01:02:31.000000', 'temperatura', 55.0000, 'ºC'),
	(306443, 145, '2015-01-01 01:02:32.000000', 'temperatura', 703.0000, 'ºC'),
	(306444, 145, '2015-01-01 01:02:33.000000', 'temperatura', 950.0000, 'ºC'),
	(306445, 145, '2015-01-01 01:02:34.000000', 'temperatura', 242.0000, 'ºC'),
	(306446, 145, '2015-01-01 01:02:35.000000', 'temperatura', 759.0000, 'ºC'),
	(306447, 145, '2015-01-01 01:02:36.000000', 'temperatura', 672.0000, 'ºC'),
	(306448, 145, '2015-01-01 01:02:37.000000', 'temperatura', 1083.0000, 'ºC'),
	(306449, 145, '2015-01-01 01:02:38.000000', 'temperatura', 998.0000, 'ºC'),
	(306450, 145, '2015-01-01 01:02:39.000000', 'temperatura', 544.0000, 'ºC'),
	(306451, 145, '2015-01-01 01:02:40.000000', 'temperatura', 923.0000, 'ºC'),
	(306452, 145, '2015-01-01 01:02:41.000000', 'temperatura', 586.0000, 'ºC'),
	(306453, 145, '2015-01-01 01:02:42.000000', 'temperatura', 162.0000, 'ºC'),
	(306454, 145, '2015-01-01 01:02:43.000000', 'temperatura', 252.0000, 'ºC'),
	(306455, 145, '2015-01-01 01:02:44.000000', 'temperatura', 775.0000, 'ºC'),
	(306456, 145, '2015-01-01 01:02:45.000000', 'temperatura', 720.0000, 'ºC'),
	(306457, 145, '2015-01-01 01:02:46.000000', 'temperatura', 77.0000, 'ºC'),
	(306458, 145, '2015-01-01 01:02:47.000000', 'temperatura', 622.0000, 'ºC'),
	(306459, 145, '2015-01-01 01:02:48.000000', 'temperatura', 480.0000, 'ºC'),
	(306460, 145, '2015-01-01 01:02:49.000000', 'temperatura', 537.0000, 'ºC'),
	(306461, 145, '2015-01-01 01:02:50.000000', 'temperatura', 43.0000, 'ºC'),
	(306462, 145, '2015-01-01 01:02:51.000000', 'temperatura', 1004.0000, 'ºC'),
	(306463, 145, '2015-01-01 01:02:52.000000', 'temperatura', 91.0000, 'ºC'),
	(306464, 145, '2015-01-01 01:02:53.000000', 'temperatura', 1044.0000, 'ºC'),
	(306465, 145, '2015-01-01 01:02:54.000000', 'temperatura', 149.0000, 'ºC'),
	(306466, 145, '2015-01-01 01:02:55.000000', 'temperatura', 11.0000, 'ºC'),
	(306467, 145, '2015-01-01 01:02:56.000000', 'temperatura', 811.0000, 'ºC'),
	(306468, 145, '2015-01-01 01:02:57.000000', 'temperatura', 423.0000, 'ºC'),
	(306469, 145, '2015-01-01 01:02:58.000000', 'temperatura', 879.0000, 'ºC'),
	(306470, 145, '2015-01-01 01:02:59.000000', 'temperatura', 730.0000, 'ºC'),
	(306471, 145, '2015-01-01 01:03:00.000000', 'temperatura', 1012.0000, 'ºC'),
	(306472, 145, '2015-01-01 01:03:01.000000', 'temperatura', 471.0000, 'ºC'),
	(306473, 145, '2015-01-01 01:03:02.000000', 'temperatura', 520.0000, 'ºC'),
	(306474, 145, '2015-01-01 01:03:03.000000', 'temperatura', 1186.0000, 'ºC'),
	(306475, 145, '2015-01-01 01:03:04.000000', 'temperatura', 772.0000, 'ºC'),
	(306476, 145, '2015-01-01 01:03:05.000000', 'temperatura', 301.0000, 'ºC'),
	(306477, 145, '2015-01-01 01:03:06.000000', 'temperatura', 391.0000, 'ºC'),
	(306478, 145, '2015-01-01 01:03:07.000000', 'temperatura', 1053.0000, 'ºC'),
	(306479, 145, '2015-01-01 01:03:08.000000', 'temperatura', 490.0000, 'ºC'),
	(306480, 145, '2015-01-01 01:03:09.000000', 'temperatura', 491.0000, 'ºC'),
	(306481, 145, '2015-01-01 01:03:10.000000', 'temperatura', 988.0000, 'ºC'),
	(306482, 145, '2015-01-01 01:03:11.000000', 'temperatura', 1065.0000, 'ºC'),
	(306483, 145, '2015-01-01 01:03:12.000000', 'temperatura', 1163.0000, 'ºC'),
	(306484, 145, '2015-01-01 01:03:13.000000', 'temperatura', 220.0000, 'ºC'),
	(306485, 145, '2015-01-01 01:03:14.000000', 'temperatura', 10.0000, 'ºC'),
	(306486, 145, '2015-01-01 01:03:15.000000', 'temperatura', 593.0000, 'ºC'),
	(306487, 145, '2015-01-01 01:03:16.000000', 'temperatura', 535.0000, 'ºC'),
	(306488, 145, '2015-01-01 01:03:17.000000', 'temperatura', 897.0000, 'ºC'),
	(306489, 145, '2015-01-01 01:03:18.000000', 'temperatura', 481.0000, 'ºC'),
	(306490, 145, '2015-01-01 01:03:19.000000', 'temperatura', 915.0000, 'ºC'),
	(306491, 145, '2015-01-01 01:03:20.000000', 'temperatura', 730.0000, 'ºC'),
	(306492, 145, '2015-01-01 01:03:21.000000', 'temperatura', 909.0000, 'ºC'),
	(306493, 145, '2015-01-01 01:03:22.000000', 'temperatura', 1152.0000, 'ºC'),
	(306494, 145, '2015-01-01 01:03:23.000000', 'temperatura', 635.0000, 'ºC'),
	(306495, 145, '2015-01-01 01:03:24.000000', 'temperatura', 921.0000, 'ºC'),
	(306496, 145, '2015-01-01 01:03:25.000000', 'temperatura', 301.0000, 'ºC'),
	(306497, 145, '2015-01-01 01:03:26.000000', 'temperatura', 1142.0000, 'ºC'),
	(306498, 145, '2015-01-01 01:03:27.000000', 'temperatura', 5.0000, 'ºC'),
	(306499, 145, '2015-01-01 01:03:28.000000', 'temperatura', 201.0000, 'ºC'),
	(306500, 145, '2015-01-01 01:03:29.000000', 'temperatura', 992.0000, 'ºC'),
	(306501, 145, '2015-01-01 01:03:30.000000', 'temperatura', 755.0000, 'ºC'),
	(306502, 145, '2015-01-01 01:03:31.000000', 'temperatura', 802.0000, 'ºC'),
	(306503, 145, '2015-01-01 01:03:32.000000', 'temperatura', 543.0000, 'ºC'),
	(306504, 145, '2015-01-01 01:03:33.000000', 'temperatura', 310.0000, 'ºC'),
	(306505, 145, '2015-01-01 01:03:34.000000', 'temperatura', 1120.0000, 'ºC'),
	(306506, 145, '2015-01-01 01:03:35.000000', 'temperatura', 1071.0000, 'ºC'),
	(306507, 145, '2015-01-01 01:03:36.000000', 'temperatura', 797.0000, 'ºC'),
	(306508, 145, '2015-01-01 01:03:37.000000', 'temperatura', 772.0000, 'ºC'),
	(306509, 145, '2015-01-01 01:03:38.000000', 'temperatura', 268.0000, 'ºC'),
	(306510, 145, '2015-01-01 01:03:39.000000', 'temperatura', 224.0000, 'ºC'),
	(306511, 145, '2015-01-01 01:03:40.000000', 'temperatura', 316.0000, 'ºC'),
	(306512, 145, '2015-01-01 01:03:41.000000', 'temperatura', 912.0000, 'ºC'),
	(306513, 145, '2015-01-01 01:03:42.000000', 'temperatura', 9.0000, 'ºC'),
	(306514, 145, '2015-01-01 01:03:43.000000', 'temperatura', 912.0000, 'ºC'),
	(306515, 145, '2015-01-01 01:03:44.000000', 'temperatura', 934.0000, 'ºC'),
	(306516, 145, '2015-01-01 01:03:45.000000', 'temperatura', 733.0000, 'ºC'),
	(306517, 145, '2015-01-01 01:03:46.000000', 'temperatura', 862.0000, 'ºC'),
	(306518, 145, '2015-01-01 01:03:47.000000', 'temperatura', 914.0000, 'ºC'),
	(306519, 145, '2015-01-01 01:03:48.000000', 'temperatura', 783.0000, 'ºC'),
	(306520, 145, '2015-01-01 01:03:49.000000', 'temperatura', 1174.0000, 'ºC'),
	(306521, 145, '2015-01-01 01:03:50.000000', 'temperatura', 1121.0000, 'ºC'),
	(306522, 145, '2015-01-01 01:03:51.000000', 'temperatura', 883.0000, 'ºC'),
	(306523, 145, '2015-01-01 01:03:52.000000', 'temperatura', 1053.0000, 'ºC'),
	(306524, 145, '2015-01-01 01:03:53.000000', 'temperatura', 217.0000, 'ºC'),
	(306525, 145, '2015-01-01 01:03:54.000000', 'temperatura', 328.0000, 'ºC'),
	(306526, 145, '2015-01-01 01:03:55.000000', 'temperatura', 989.0000, 'ºC'),
	(306527, 145, '2015-01-01 01:03:56.000000', 'temperatura', 362.0000, 'ºC'),
	(306528, 145, '2015-01-01 01:03:57.000000', 'temperatura', 43.0000, 'ºC'),
	(306529, 145, '2015-01-01 01:03:58.000000', 'temperatura', 330.0000, 'ºC'),
	(306530, 145, '2015-01-01 01:03:59.000000', 'temperatura', 320.0000, 'ºC'),
	(306531, 145, '2015-01-01 01:04:00.000000', 'temperatura', 611.0000, 'ºC'),
	(306532, 145, '2015-01-01 01:04:01.000000', 'temperatura', 898.0000, 'ºC'),
	(306533, 145, '2015-01-01 01:04:02.000000', 'temperatura', 254.0000, 'ºC'),
	(306534, 145, '2015-01-01 01:04:03.000000', 'temperatura', 977.0000, 'ºC'),
	(306535, 145, '2015-01-01 01:04:04.000000', 'temperatura', 523.0000, 'ºC'),
	(306536, 145, '2015-01-01 01:04:05.000000', 'temperatura', 887.0000, 'ºC'),
	(306537, 145, '2015-01-01 01:04:06.000000', 'temperatura', 466.0000, 'ºC'),
	(306538, 145, '2015-01-01 01:04:07.000000', 'temperatura', 869.0000, 'ºC'),
	(306539, 145, '2015-01-01 01:04:08.000000', 'temperatura', 549.0000, 'ºC'),
	(306540, 145, '2015-01-01 01:04:09.000000', 'temperatura', 136.0000, 'ºC'),
	(306541, 145, '2015-01-01 01:04:10.000000', 'temperatura', 235.0000, 'ºC'),
	(306542, 145, '2015-01-01 01:04:11.000000', 'temperatura', 769.0000, 'ºC'),
	(306543, 145, '2015-01-01 01:04:12.000000', 'temperatura', 740.0000, 'ºC'),
	(306544, 145, '2015-01-01 01:04:13.000000', 'temperatura', 193.0000, 'ºC'),
	(306545, 145, '2015-01-01 01:04:14.000000', 'temperatura', 1145.0000, 'ºC'),
	(306546, 145, '2015-01-01 01:04:15.000000', 'temperatura', 345.0000, 'ºC'),
	(306547, 145, '2015-01-01 01:04:16.000000', 'temperatura', 692.0000, 'ºC'),
	(306548, 145, '2015-01-01 01:04:17.000000', 'temperatura', 26.0000, 'ºC'),
	(306549, 145, '2015-01-01 01:04:18.000000', 'temperatura', 453.0000, 'ºC'),
	(306550, 145, '2015-01-01 01:04:19.000000', 'temperatura', 987.0000, 'ºC'),
	(306551, 145, '2015-01-01 01:04:20.000000', 'temperatura', 1176.0000, 'ºC'),
	(306552, 145, '2015-01-01 01:04:21.000000', 'temperatura', 519.0000, 'ºC'),
	(306553, 145, '2015-01-01 01:04:22.000000', 'temperatura', 268.0000, 'ºC'),
	(306554, 145, '2015-01-01 01:04:23.000000', 'temperatura', 983.0000, 'ºC'),
	(306555, 145, '2015-01-01 01:04:24.000000', 'temperatura', 511.0000, 'ºC'),
	(306556, 145, '2015-01-01 01:04:25.000000', 'temperatura', 809.0000, 'ºC'),
	(306557, 145, '2015-01-01 01:04:26.000000', 'temperatura', 112.0000, 'ºC'),
	(306558, 145, '2015-01-01 01:04:27.000000', 'temperatura', 534.0000, 'ºC'),
	(306559, 145, '2015-01-01 01:04:28.000000', 'temperatura', 1133.0000, 'ºC'),
	(306560, 145, '2015-01-01 01:04:29.000000', 'temperatura', 464.0000, 'ºC'),
	(306561, 145, '2015-01-01 01:04:30.000000', 'temperatura', 121.0000, 'ºC'),
	(306562, 145, '2015-01-01 01:04:31.000000', 'temperatura', 413.0000, 'ºC'),
	(306563, 145, '2015-01-01 01:04:32.000000', 'temperatura', 501.0000, 'ºC'),
	(306564, 145, '2015-01-01 01:04:33.000000', 'temperatura', 70.0000, 'ºC'),
	(306565, 145, '2015-01-01 01:04:34.000000', 'temperatura', 46.0000, 'ºC'),
	(306566, 145, '2015-01-01 01:04:35.000000', 'temperatura', 23.0000, 'ºC'),
	(306567, 145, '2015-01-01 01:04:36.000000', 'temperatura', 1174.0000, 'ºC'),
	(306568, 145, '2015-01-01 01:04:37.000000', 'temperatura', 1005.0000, 'ºC'),
	(306569, 145, '2015-01-01 01:04:38.000000', 'temperatura', 301.0000, 'ºC'),
	(306570, 145, '2015-01-01 01:04:39.000000', 'temperatura', 893.0000, 'ºC'),
	(306571, 145, '2015-01-01 01:04:40.000000', 'temperatura', 1162.0000, 'ºC'),
	(306572, 145, '2015-01-01 01:04:41.000000', 'temperatura', 730.0000, 'ºC'),
	(306573, 145, '2015-01-01 01:04:42.000000', 'temperatura', 163.0000, 'ºC'),
	(306574, 145, '2015-01-01 01:04:43.000000', 'temperatura', 1028.0000, 'ºC'),
	(306575, 145, '2015-01-01 01:04:44.000000', 'temperatura', 1052.0000, 'ºC'),
	(306576, 145, '2015-01-01 01:04:45.000000', 'temperatura', 977.0000, 'ºC'),
	(306577, 145, '2015-01-01 01:04:46.000000', 'temperatura', 528.0000, 'ºC'),
	(306578, 145, '2015-01-01 01:04:47.000000', 'temperatura', 910.0000, 'ºC'),
	(306579, 145, '2015-01-01 01:04:48.000000', 'temperatura', 565.0000, 'ºC'),
	(306580, 145, '2015-01-01 01:04:49.000000', 'temperatura', 96.0000, 'ºC'),
	(306581, 145, '2015-01-01 01:04:50.000000', 'temperatura', 1185.0000, 'ºC'),
	(306582, 145, '2015-01-01 01:04:51.000000', 'temperatura', 839.0000, 'ºC'),
	(306583, 145, '2015-01-01 01:04:52.000000', 'temperatura', 640.0000, 'ºC'),
	(306584, 145, '2015-01-01 01:04:53.000000', 'temperatura', 682.0000, 'ºC'),
	(306585, 145, '2015-01-01 01:04:54.000000', 'temperatura', 290.0000, 'ºC'),
	(306586, 145, '2015-01-01 01:04:55.000000', 'temperatura', 604.0000, 'ºC'),
	(306587, 145, '2015-01-01 01:04:56.000000', 'temperatura', 952.0000, 'ºC'),
	(306588, 145, '2015-01-01 01:04:57.000000', 'temperatura', 550.0000, 'ºC'),
	(306589, 145, '2015-01-01 01:04:58.000000', 'temperatura', 1091.0000, 'ºC'),
	(306590, 145, '2015-01-01 01:04:59.000000', 'temperatura', 208.0000, 'ºC'),
	(306591, 145, '2015-01-01 01:05:00.000000', 'temperatura', 167.0000, 'ºC'),
	(306592, 145, '2015-01-01 01:05:01.000000', 'temperatura', 212.0000, 'ºC'),
	(306593, 145, '2015-01-01 01:05:02.000000', 'temperatura', 559.0000, 'ºC'),
	(306594, 145, '2015-01-01 01:05:03.000000', 'temperatura', 961.0000, 'ºC'),
	(306595, 145, '2015-01-01 01:05:04.000000', 'temperatura', 729.0000, 'ºC'),
	(306596, 145, '2015-01-01 01:05:05.000000', 'temperatura', 760.0000, 'ºC'),
	(306597, 145, '2015-01-01 01:05:06.000000', 'temperatura', 417.0000, 'ºC'),
	(306598, 145, '2015-01-01 01:05:07.000000', 'temperatura', 1002.0000, 'ºC'),
	(306599, 145, '2015-01-01 01:05:08.000000', 'temperatura', 160.0000, 'ºC'),
	(306600, 145, '2015-01-01 01:05:09.000000', 'temperatura', 196.0000, 'ºC'),
	(306601, 145, '2015-01-01 01:05:10.000000', 'temperatura', 501.0000, 'ºC'),
	(306602, 145, '2015-01-01 01:05:11.000000', 'temperatura', 717.0000, 'ºC'),
	(306603, 145, '2015-01-01 01:05:12.000000', 'temperatura', 882.0000, 'ºC'),
	(306604, 145, '2015-01-01 01:05:13.000000', 'temperatura', 1062.0000, 'ºC'),
	(306605, 145, '2015-01-01 01:05:14.000000', 'temperatura', 261.0000, 'ºC'),
	(306606, 145, '2015-01-01 01:05:15.000000', 'temperatura', 520.0000, 'ºC'),
	(306607, 145, '2015-01-01 01:05:16.000000', 'temperatura', 619.0000, 'ºC'),
	(306608, 145, '2015-01-01 01:05:17.000000', 'temperatura', 333.0000, 'ºC'),
	(306609, 145, '2015-01-01 01:05:18.000000', 'temperatura', 1010.0000, 'ºC'),
	(306610, 145, '2015-01-01 01:05:19.000000', 'temperatura', 451.0000, 'ºC'),
	(306611, 145, '2015-01-01 01:05:20.000000', 'temperatura', 427.0000, 'ºC'),
	(306612, 145, '2015-01-01 01:05:21.000000', 'temperatura', 783.0000, 'ºC'),
	(306613, 145, '2015-01-01 01:05:22.000000', 'temperatura', 232.0000, 'ºC'),
	(306614, 145, '2015-01-01 01:05:23.000000', 'temperatura', 13.0000, 'ºC'),
	(306615, 145, '2015-01-01 01:05:24.000000', 'temperatura', 568.0000, 'ºC'),
	(306616, 145, '2015-01-01 01:05:25.000000', 'temperatura', 403.0000, 'ºC'),
	(306617, 145, '2015-01-01 01:05:26.000000', 'temperatura', 311.0000, 'ºC'),
	(306618, 145, '2015-01-01 01:05:27.000000', 'temperatura', 346.0000, 'ºC'),
	(306619, 145, '2015-01-01 01:05:28.000000', 'temperatura', 799.0000, 'ºC'),
	(306620, 145, '2015-01-01 01:05:29.000000', 'temperatura', 555.0000, 'ºC'),
	(306621, 145, '2015-01-01 01:05:30.000000', 'temperatura', 379.0000, 'ºC'),
	(306622, 145, '2015-01-01 01:05:31.000000', 'temperatura', 232.0000, 'ºC'),
	(306623, 145, '2015-01-01 01:05:32.000000', 'temperatura', 23.0000, 'ºC'),
	(306624, 145, '2015-01-01 01:05:33.000000', 'temperatura', 619.0000, 'ºC'),
	(306625, 145, '2015-01-01 01:05:34.000000', 'temperatura', 625.0000, 'ºC'),
	(306626, 145, '2015-01-01 01:05:35.000000', 'temperatura', 68.0000, 'ºC'),
	(306627, 145, '2015-01-01 01:05:36.000000', 'temperatura', 868.0000, 'ºC'),
	(306628, 145, '2015-01-01 01:05:37.000000', 'temperatura', 537.0000, 'ºC'),
	(306629, 145, '2015-01-01 01:05:38.000000', 'temperatura', 81.0000, 'ºC'),
	(306630, 145, '2015-01-01 01:05:39.000000', 'temperatura', 1195.0000, 'ºC'),
	(306631, 145, '2015-01-01 01:05:40.000000', 'temperatura', 933.0000, 'ºC'),
	(306632, 145, '2015-01-01 01:05:41.000000', 'temperatura', 1082.0000, 'ºC'),
	(306633, 145, '2015-01-01 01:05:42.000000', 'temperatura', 208.0000, 'ºC'),
	(306634, 145, '2015-01-01 01:05:43.000000', 'temperatura', 195.0000, 'ºC'),
	(306635, 145, '2015-01-01 01:05:44.000000', 'temperatura', 352.0000, 'ºC'),
	(306636, 145, '2015-01-01 01:05:45.000000', 'temperatura', 1177.0000, 'ºC'),
	(306637, 145, '2015-01-01 01:05:46.000000', 'temperatura', 28.0000, 'ºC'),
	(306638, 145, '2015-01-01 01:05:47.000000', 'temperatura', 209.0000, 'ºC'),
	(306639, 145, '2015-01-01 01:05:48.000000', 'temperatura', 961.0000, 'ºC'),
	(306640, 145, '2015-01-01 01:05:49.000000', 'temperatura', 577.0000, 'ºC'),
	(306641, 145, '2015-01-01 01:05:50.000000', 'temperatura', 5.0000, 'ºC'),
	(306642, 145, '2015-01-01 01:05:51.000000', 'temperatura', 694.0000, 'ºC'),
	(306643, 145, '2015-01-01 01:05:52.000000', 'temperatura', 1054.0000, 'ºC'),
	(306644, 145, '2015-01-01 01:05:53.000000', 'temperatura', 791.0000, 'ºC'),
	(306645, 145, '2015-01-01 01:05:54.000000', 'temperatura', 794.0000, 'ºC'),
	(306646, 145, '2015-01-01 01:05:55.000000', 'temperatura', 394.0000, 'ºC'),
	(306647, 145, '2015-01-01 01:05:56.000000', 'temperatura', 792.0000, 'ºC'),
	(306648, 145, '2015-01-01 01:05:57.000000', 'temperatura', 376.0000, 'ºC'),
	(306649, 145, '2015-01-01 01:05:58.000000', 'temperatura', 704.0000, 'ºC'),
	(306650, 145, '2015-01-01 01:05:59.000000', 'temperatura', 1195.0000, 'ºC'),
	(306651, 145, '2015-01-01 01:06:00.000000', 'temperatura', 263.0000, 'ºC'),
	(306652, 145, '2015-01-01 01:06:01.000000', 'temperatura', 131.0000, 'ºC'),
	(306653, 145, '2015-01-01 01:06:02.000000', 'temperatura', 1066.0000, 'ºC'),
	(306654, 145, '2015-01-01 01:06:03.000000', 'temperatura', 139.0000, 'ºC'),
	(306655, 145, '2015-01-01 01:06:04.000000', 'temperatura', 1095.0000, 'ºC'),
	(306656, 145, '2015-01-01 01:06:05.000000', 'temperatura', 257.0000, 'ºC'),
	(306657, 145, '2015-01-01 01:06:06.000000', 'temperatura', 404.0000, 'ºC'),
	(306658, 145, '2015-01-01 01:06:07.000000', 'temperatura', 47.0000, 'ºC'),
	(306659, 145, '2015-01-01 01:06:08.000000', 'temperatura', 225.0000, 'ºC'),
	(306660, 145, '2015-01-01 01:06:09.000000', 'temperatura', 982.0000, 'ºC'),
	(306661, 145, '2015-01-01 01:06:10.000000', 'temperatura', 637.0000, 'ºC'),
	(306662, 145, '2015-01-01 01:06:11.000000', 'temperatura', 239.0000, 'ºC'),
	(306663, 145, '2015-01-01 01:06:12.000000', 'temperatura', 483.0000, 'ºC'),
	(306664, 145, '2015-01-01 01:06:13.000000', 'temperatura', 501.0000, 'ºC'),
	(306665, 145, '2015-01-01 01:06:14.000000', 'temperatura', 1057.0000, 'ºC'),
	(306666, 145, '2015-01-01 01:06:15.000000', 'temperatura', 182.0000, 'ºC'),
	(306667, 145, '2015-01-01 01:06:16.000000', 'temperatura', 138.0000, 'ºC'),
	(306668, 145, '2015-01-01 01:06:17.000000', 'temperatura', 146.0000, 'ºC'),
	(306669, 145, '2015-01-01 01:06:18.000000', 'temperatura', 314.0000, 'ºC'),
	(306670, 145, '2015-01-01 01:06:19.000000', 'temperatura', 1134.0000, 'ºC'),
	(306671, 145, '2015-01-01 01:06:20.000000', 'temperatura', 1129.0000, 'ºC'),
	(306672, 145, '2015-01-01 01:06:21.000000', 'temperatura', 1041.0000, 'ºC'),
	(306673, 145, '2015-01-01 01:06:22.000000', 'temperatura', 621.0000, 'ºC'),
	(306674, 145, '2015-01-01 01:06:23.000000', 'temperatura', 1182.0000, 'ºC'),
	(306675, 145, '2015-01-01 01:06:24.000000', 'temperatura', 446.0000, 'ºC'),
	(306676, 145, '2015-01-01 01:06:25.000000', 'temperatura', 1084.0000, 'ºC'),
	(306677, 145, '2015-01-01 01:06:26.000000', 'temperatura', 484.0000, 'ºC'),
	(306678, 145, '2015-01-01 01:06:27.000000', 'temperatura', 369.0000, 'ºC'),
	(306679, 145, '2015-01-01 01:06:28.000000', 'temperatura', 391.0000, 'ºC'),
	(306680, 145, '2015-01-01 01:06:29.000000', 'temperatura', 850.0000, 'ºC'),
	(306681, 145, '2015-01-01 01:06:30.000000', 'temperatura', 678.0000, 'ºC'),
	(306682, 145, '2015-01-01 01:06:31.000000', 'temperatura', 839.0000, 'ºC'),
	(306683, 145, '2015-01-01 01:06:32.000000', 'temperatura', 962.0000, 'ºC'),
	(306684, 145, '2015-01-01 01:06:33.000000', 'temperatura', 1096.0000, 'ºC'),
	(306685, 145, '2015-01-01 01:06:34.000000', 'temperatura', 192.0000, 'ºC'),
	(306686, 145, '2015-01-01 01:06:35.000000', 'temperatura', 71.0000, 'ºC'),
	(306687, 145, '2015-01-01 01:06:36.000000', 'temperatura', 981.0000, 'ºC'),
	(306688, 145, '2015-01-01 01:06:37.000000', 'temperatura', 1092.0000, 'ºC'),
	(306689, 145, '2015-01-01 01:06:38.000000', 'temperatura', 118.0000, 'ºC'),
	(306690, 145, '2015-01-01 01:06:39.000000', 'temperatura', 916.0000, 'ºC'),
	(306691, 145, '2015-01-01 01:06:40.000000', 'temperatura', 625.0000, 'ºC'),
	(306692, 145, '2015-01-01 01:06:41.000000', 'temperatura', 378.0000, 'ºC'),
	(306693, 145, '2015-01-01 01:06:42.000000', 'temperatura', 15.0000, 'ºC'),
	(306694, 145, '2015-01-01 01:06:43.000000', 'temperatura', 141.0000, 'ºC'),
	(306695, 145, '2015-01-01 01:06:44.000000', 'temperatura', 661.0000, 'ºC'),
	(306696, 145, '2015-01-01 01:06:45.000000', 'temperatura', 482.0000, 'ºC'),
	(306697, 145, '2015-01-01 01:06:46.000000', 'temperatura', 429.0000, 'ºC'),
	(306698, 145, '2015-01-01 01:06:47.000000', 'temperatura', 699.0000, 'ºC'),
	(306699, 145, '2015-01-01 01:06:48.000000', 'temperatura', 1007.0000, 'ºC'),
	(306700, 145, '2015-01-01 01:06:49.000000', 'temperatura', 538.0000, 'ºC'),
	(306701, 145, '2015-01-01 01:06:50.000000', 'temperatura', 871.0000, 'ºC'),
	(306702, 145, '2015-01-01 01:06:51.000000', 'temperatura', 341.0000, 'ºC'),
	(306703, 145, '2015-01-01 01:06:52.000000', 'temperatura', 291.0000, 'ºC'),
	(306704, 145, '2015-01-01 01:06:53.000000', 'temperatura', 434.0000, 'ºC'),
	(306705, 145, '2015-01-01 01:06:54.000000', 'temperatura', 99.0000, 'ºC'),
	(306706, 145, '2015-01-01 01:06:55.000000', 'temperatura', 391.0000, 'ºC'),
	(306707, 145, '2015-01-01 01:06:56.000000', 'temperatura', 460.0000, 'ºC'),
	(306708, 145, '2015-01-01 01:06:57.000000', 'temperatura', 1128.0000, 'ºC'),
	(306709, 145, '2015-01-01 01:06:58.000000', 'temperatura', 660.0000, 'ºC'),
	(306710, 145, '2015-01-01 01:06:59.000000', 'temperatura', 1117.0000, 'ºC'),
	(306711, 145, '2015-01-01 01:07:00.000000', 'temperatura', 5.0000, 'ºC'),
	(306712, 145, '2015-01-01 01:07:01.000000', 'temperatura', 274.0000, 'ºC'),
	(306713, 145, '2015-01-01 01:07:02.000000', 'temperatura', 154.0000, 'ºC'),
	(306714, 145, '2015-01-01 01:07:03.000000', 'temperatura', 1150.0000, 'ºC'),
	(306715, 145, '2015-01-01 01:07:04.000000', 'temperatura', 489.0000, 'ºC'),
	(306716, 145, '2015-01-01 01:07:05.000000', 'temperatura', 196.0000, 'ºC'),
	(306717, 145, '2015-01-01 01:07:06.000000', 'temperatura', 714.0000, 'ºC'),
	(306718, 145, '2015-01-01 01:07:07.000000', 'temperatura', 584.0000, 'ºC'),
	(306719, 145, '2015-01-01 01:07:08.000000', 'temperatura', 776.0000, 'ºC'),
	(306720, 145, '2015-01-01 01:07:09.000000', 'temperatura', 930.0000, 'ºC'),
	(306721, 145, '2015-01-01 01:07:10.000000', 'temperatura', 1121.0000, 'ºC'),
	(306722, 145, '2015-01-01 01:07:11.000000', 'temperatura', 418.0000, 'ºC'),
	(306723, 145, '2015-01-01 01:07:12.000000', 'temperatura', 1127.0000, 'ºC'),
	(306724, 145, '2015-01-01 01:07:13.000000', 'temperatura', 782.0000, 'ºC'),
	(306725, 145, '2015-01-01 01:07:14.000000', 'temperatura', 528.0000, 'ºC'),
	(306726, 145, '2015-01-01 01:07:15.000000', 'temperatura', 294.0000, 'ºC'),
	(306727, 145, '2015-01-01 01:07:16.000000', 'temperatura', 1086.0000, 'ºC'),
	(306728, 145, '2015-01-01 01:07:17.000000', 'temperatura', 947.0000, 'ºC'),
	(306729, 145, '2015-01-01 01:07:18.000000', 'temperatura', 280.0000, 'ºC'),
	(306730, 145, '2015-01-01 01:07:19.000000', 'temperatura', 960.0000, 'ºC'),
	(306731, 145, '2015-01-01 01:07:20.000000', 'temperatura', 358.0000, 'ºC'),
	(306732, 145, '2015-01-01 01:07:21.000000', 'temperatura', 111.0000, 'ºC'),
	(306733, 145, '2015-01-01 01:07:22.000000', 'temperatura', 682.0000, 'ºC'),
	(306734, 145, '2015-01-01 01:07:23.000000', 'temperatura', 677.0000, 'ºC'),
	(306735, 145, '2015-01-01 01:07:24.000000', 'temperatura', 141.0000, 'ºC'),
	(306736, 145, '2015-01-01 01:07:25.000000', 'temperatura', 1074.0000, 'ºC'),
	(306737, 145, '2015-01-01 01:07:26.000000', 'temperatura', 149.0000, 'ºC'),
	(306738, 145, '2015-01-01 01:07:27.000000', 'temperatura', 1124.0000, 'ºC'),
	(306739, 145, '2015-01-01 01:07:28.000000', 'temperatura', 372.0000, 'ºC'),
	(306740, 145, '2015-01-01 01:07:29.000000', 'temperatura', 890.0000, 'ºC'),
	(306741, 145, '2015-01-01 01:07:30.000000', 'temperatura', 935.0000, 'ºC'),
	(306742, 145, '2015-01-01 01:07:31.000000', 'temperatura', 803.0000, 'ºC'),
	(306743, 145, '2015-01-01 01:07:32.000000', 'temperatura', 11.0000, 'ºC'),
	(306744, 145, '2015-01-01 01:07:33.000000', 'temperatura', 49.0000, 'ºC'),
	(306745, 145, '2015-01-01 01:07:34.000000', 'temperatura', 211.0000, 'ºC'),
	(306746, 145, '2015-01-01 01:07:35.000000', 'temperatura', 908.0000, 'ºC'),
	(306747, 145, '2015-01-01 01:07:36.000000', 'temperatura', 309.0000, 'ºC'),
	(306748, 145, '2015-01-01 01:07:37.000000', 'temperatura', 19.0000, 'ºC'),
	(306749, 145, '2015-01-01 01:07:38.000000', 'temperatura', 372.0000, 'ºC'),
	(306750, 145, '2015-01-01 01:07:39.000000', 'temperatura', 600.0000, 'ºC'),
	(306751, 145, '2015-01-01 01:07:40.000000', 'temperatura', 686.0000, 'ºC'),
	(306752, 145, '2015-01-01 01:07:41.000000', 'temperatura', 430.0000, 'ºC'),
	(306753, 145, '2015-01-01 01:07:42.000000', 'temperatura', 94.0000, 'ºC'),
	(306754, 145, '2015-01-01 01:07:43.000000', 'temperatura', 380.0000, 'ºC'),
	(306755, 145, '2015-01-01 01:07:44.000000', 'temperatura', 416.0000, 'ºC'),
	(306756, 145, '2015-01-01 01:07:45.000000', 'temperatura', 943.0000, 'ºC'),
	(306757, 145, '2015-01-01 01:07:46.000000', 'temperatura', 1065.0000, 'ºC'),
	(306758, 145, '2015-01-01 01:07:47.000000', 'temperatura', 98.0000, 'ºC'),
	(306759, 145, '2015-01-01 01:07:48.000000', 'temperatura', 895.0000, 'ºC'),
	(306760, 145, '2015-01-01 01:07:49.000000', 'temperatura', 580.0000, 'ºC'),
	(306761, 145, '2015-01-01 01:07:50.000000', 'temperatura', 215.0000, 'ºC'),
	(306762, 145, '2015-01-01 01:07:51.000000', 'temperatura', 537.0000, 'ºC'),
	(306763, 145, '2015-01-01 01:07:52.000000', 'temperatura', 840.0000, 'ºC'),
	(306764, 145, '2015-01-01 01:07:53.000000', 'temperatura', 190.0000, 'ºC'),
	(306765, 145, '2015-01-01 01:07:54.000000', 'temperatura', 831.0000, 'ºC'),
	(306766, 145, '2015-01-01 01:07:55.000000', 'temperatura', 1187.0000, 'ºC'),
	(306767, 145, '2015-01-01 01:07:56.000000', 'temperatura', 1040.0000, 'ºC'),
	(306768, 145, '2015-01-01 01:07:57.000000', 'temperatura', 438.0000, 'ºC'),
	(306769, 145, '2015-01-01 01:07:58.000000', 'temperatura', 273.0000, 'ºC'),
	(306770, 145, '2015-01-01 01:07:59.000000', 'temperatura', 50.0000, 'ºC'),
	(306771, 145, '2015-01-01 01:08:00.000000', 'temperatura', 634.0000, 'ºC'),
	(306772, 145, '2015-01-01 01:08:01.000000', 'temperatura', 619.0000, 'ºC'),
	(306773, 145, '2015-01-01 01:08:02.000000', 'temperatura', 1195.0000, 'ºC'),
	(306774, 145, '2015-01-01 01:08:03.000000', 'temperatura', 518.0000, 'ºC'),
	(306775, 145, '2015-01-01 01:08:04.000000', 'temperatura', 206.0000, 'ºC'),
	(306776, 145, '2015-01-01 01:08:05.000000', 'temperatura', 676.0000, 'ºC'),
	(306777, 145, '2015-01-01 01:08:06.000000', 'temperatura', 362.0000, 'ºC'),
	(306778, 145, '2015-01-01 01:08:07.000000', 'temperatura', 983.0000, 'ºC'),
	(306779, 145, '2015-01-01 01:08:08.000000', 'temperatura', 231.0000, 'ºC'),
	(306780, 145, '2015-01-01 01:08:09.000000', 'temperatura', 607.0000, 'ºC'),
	(306781, 145, '2015-01-01 01:08:10.000000', 'temperatura', 1140.0000, 'ºC'),
	(306782, 145, '2015-01-01 01:08:11.000000', 'temperatura', 282.0000, 'ºC'),
	(306783, 145, '2015-01-01 01:08:12.000000', 'temperatura', 390.0000, 'ºC'),
	(306784, 145, '2015-01-01 01:08:13.000000', 'temperatura', 1106.0000, 'ºC'),
	(306785, 145, '2015-01-01 01:08:14.000000', 'temperatura', 759.0000, 'ºC'),
	(306786, 145, '2015-01-01 01:08:15.000000', 'temperatura', 479.0000, 'ºC'),
	(306787, 145, '2015-01-01 01:08:16.000000', 'temperatura', 119.0000, 'ºC'),
	(306788, 145, '2015-01-01 01:08:17.000000', 'temperatura', 359.0000, 'ºC'),
	(306789, 145, '2015-01-01 01:08:18.000000', 'temperatura', 238.0000, 'ºC'),
	(306790, 145, '2015-01-01 01:08:19.000000', 'temperatura', 112.0000, 'ºC'),
	(306791, 145, '2015-01-01 01:08:20.000000', 'temperatura', 1047.0000, 'ºC'),
	(306792, 145, '2015-01-01 01:08:21.000000', 'temperatura', 99.0000, 'ºC'),
	(306793, 145, '2015-01-01 01:08:22.000000', 'temperatura', 954.0000, 'ºC'),
	(306794, 145, '2015-01-01 01:08:23.000000', 'temperatura', 873.0000, 'ºC'),
	(306795, 145, '2015-01-01 01:08:24.000000', 'temperatura', 306.0000, 'ºC'),
	(306796, 145, '2015-01-01 01:08:25.000000', 'temperatura', 109.0000, 'ºC'),
	(306797, 145, '2015-01-01 01:08:26.000000', 'temperatura', 830.0000, 'ºC'),
	(306798, 145, '2015-01-01 01:08:27.000000', 'temperatura', 224.0000, 'ºC'),
	(306799, 145, '2015-01-01 01:08:28.000000', 'temperatura', 1031.0000, 'ºC'),
	(306800, 145, '2015-01-01 01:08:29.000000', 'temperatura', 882.0000, 'ºC'),
	(306801, 145, '2015-01-01 01:08:30.000000', 'temperatura', 119.0000, 'ºC'),
	(306802, 145, '2015-01-01 01:08:31.000000', 'temperatura', 350.0000, 'ºC'),
	(306803, 145, '2015-01-01 01:08:32.000000', 'temperatura', 194.0000, 'ºC'),
	(306804, 145, '2015-01-01 01:08:33.000000', 'temperatura', 1118.0000, 'ºC'),
	(306805, 145, '2015-01-01 01:08:34.000000', 'temperatura', 211.0000, 'ºC'),
	(306806, 145, '2015-01-01 01:08:35.000000', 'temperatura', 102.0000, 'ºC'),
	(306807, 145, '2015-01-01 01:08:36.000000', 'temperatura', 1076.0000, 'ºC'),
	(306808, 145, '2015-01-01 01:08:37.000000', 'temperatura', 273.0000, 'ºC'),
	(306809, 145, '2015-01-01 01:08:38.000000', 'temperatura', 540.0000, 'ºC'),
	(306810, 145, '2015-01-01 01:08:39.000000', 'temperatura', 680.0000, 'ºC'),
	(306811, 145, '2015-01-01 01:08:40.000000', 'temperatura', 582.0000, 'ºC'),
	(306812, 145, '2015-01-01 01:08:41.000000', 'temperatura', 868.0000, 'ºC'),
	(306813, 145, '2015-01-01 01:08:42.000000', 'temperatura', 198.0000, 'ºC'),
	(306814, 145, '2015-01-01 01:08:43.000000', 'temperatura', 783.0000, 'ºC'),
	(306815, 145, '2015-01-01 01:08:44.000000', 'temperatura', 923.0000, 'ºC'),
	(306816, 145, '2015-01-01 01:08:45.000000', 'temperatura', 1066.0000, 'ºC'),
	(306817, 145, '2015-01-01 01:08:46.000000', 'temperatura', 163.0000, 'ºC'),
	(306818, 145, '2015-01-01 01:08:47.000000', 'temperatura', 16.0000, 'ºC'),
	(306819, 145, '2015-01-01 01:08:48.000000', 'temperatura', 791.0000, 'ºC'),
	(306820, 145, '2015-01-01 01:08:49.000000', 'temperatura', 310.0000, 'ºC'),
	(306821, 145, '2015-01-01 01:08:50.000000', 'temperatura', 377.0000, 'ºC'),
	(306822, 145, '2015-01-01 01:08:51.000000', 'temperatura', 956.0000, 'ºC'),
	(306823, 145, '2015-01-01 01:08:52.000000', 'temperatura', 50.0000, 'ºC'),
	(306824, 145, '2015-01-01 01:08:53.000000', 'temperatura', 984.0000, 'ºC'),
	(306825, 145, '2015-01-01 01:08:54.000000', 'temperatura', 1167.0000, 'ºC'),
	(306826, 145, '2015-01-01 01:08:55.000000', 'temperatura', 486.0000, 'ºC'),
	(306827, 145, '2015-01-01 01:08:56.000000', 'temperatura', 130.0000, 'ºC'),
	(306828, 145, '2015-01-01 01:08:57.000000', 'temperatura', 391.0000, 'ºC'),
	(306829, 145, '2015-01-01 01:08:58.000000', 'temperatura', 364.0000, 'ºC'),
	(306830, 145, '2015-01-01 01:08:59.000000', 'temperatura', 649.0000, 'ºC'),
	(306831, 145, '2015-01-01 01:09:00.000000', 'temperatura', 952.0000, 'ºC'),
	(306832, 145, '2015-01-01 01:09:01.000000', 'temperatura', 413.0000, 'ºC'),
	(306833, 145, '2015-01-01 01:09:02.000000', 'temperatura', 411.0000, 'ºC'),
	(306834, 145, '2015-01-01 01:09:03.000000', 'temperatura', 816.0000, 'ºC'),
	(306835, 145, '2015-01-01 01:09:04.000000', 'temperatura', 449.0000, 'ºC'),
	(306836, 145, '2015-01-01 01:09:05.000000', 'temperatura', 994.0000, 'ºC'),
	(306837, 145, '2015-01-01 01:09:06.000000', 'temperatura', 27.0000, 'ºC'),
	(306838, 145, '2015-01-01 01:09:07.000000', 'temperatura', 753.0000, 'ºC'),
	(306839, 145, '2015-01-01 01:09:08.000000', 'temperatura', 82.0000, 'ºC'),
	(306840, 145, '2015-01-01 01:09:09.000000', 'temperatura', 553.0000, 'ºC'),
	(306841, 145, '2015-01-01 01:09:10.000000', 'temperatura', 121.0000, 'ºC'),
	(306842, 145, '2015-01-01 01:09:11.000000', 'temperatura', 146.0000, 'ºC'),
	(306843, 145, '2015-01-01 01:09:12.000000', 'temperatura', 369.0000, 'ºC'),
	(306844, 145, '2015-01-01 01:09:13.000000', 'temperatura', 207.0000, 'ºC'),
	(306845, 145, '2015-01-01 01:09:14.000000', 'temperatura', 1126.0000, 'ºC'),
	(306846, 145, '2015-01-01 01:09:15.000000', 'temperatura', 210.0000, 'ºC'),
	(306847, 145, '2015-01-01 01:09:16.000000', 'temperatura', 74.0000, 'ºC'),
	(306848, 145, '2015-01-01 01:09:17.000000', 'temperatura', 940.0000, 'ºC'),
	(306849, 145, '2015-01-01 01:09:18.000000', 'temperatura', 879.0000, 'ºC'),
	(306850, 145, '2015-01-01 01:09:19.000000', 'temperatura', 376.0000, 'ºC'),
	(306851, 145, '2015-01-01 01:09:20.000000', 'temperatura', 441.0000, 'ºC'),
	(306852, 145, '2015-01-01 01:09:21.000000', 'temperatura', 1078.0000, 'ºC'),
	(306853, 145, '2015-01-01 01:09:22.000000', 'temperatura', 470.0000, 'ºC'),
	(306854, 145, '2015-01-01 01:09:23.000000', 'temperatura', 316.0000, 'ºC'),
	(306855, 145, '2015-01-01 01:09:24.000000', 'temperatura', 168.0000, 'ºC'),
	(306856, 145, '2015-01-01 01:09:25.000000', 'temperatura', 1093.0000, 'ºC'),
	(306857, 145, '2015-01-01 01:09:26.000000', 'temperatura', 162.0000, 'ºC'),
	(306858, 145, '2015-01-01 01:09:27.000000', 'temperatura', 1131.0000, 'ºC'),
	(306859, 145, '2015-01-01 01:09:28.000000', 'temperatura', 371.0000, 'ºC'),
	(306860, 145, '2015-01-01 01:09:29.000000', 'temperatura', 861.0000, 'ºC'),
	(306861, 145, '2015-01-01 01:09:30.000000', 'temperatura', 793.0000, 'ºC'),
	(306862, 145, '2015-01-01 01:09:31.000000', 'temperatura', 182.0000, 'ºC'),
	(306863, 145, '2015-01-01 01:09:32.000000', 'temperatura', 932.0000, 'ºC'),
	(306864, 145, '2015-01-01 01:09:33.000000', 'temperatura', 515.0000, 'ºC'),
	(306865, 145, '2015-01-01 01:09:34.000000', 'temperatura', 977.0000, 'ºC'),
	(306866, 145, '2015-01-01 01:09:35.000000', 'temperatura', 942.0000, 'ºC'),
	(306867, 145, '2015-01-01 01:09:36.000000', 'temperatura', 580.0000, 'ºC'),
	(306868, 145, '2015-01-01 01:09:37.000000', 'temperatura', 72.0000, 'ºC'),
	(306869, 145, '2015-01-01 01:09:38.000000', 'temperatura', 1023.0000, 'ºC'),
	(306870, 145, '2015-01-01 01:09:39.000000', 'temperatura', 99.0000, 'ºC'),
	(306871, 145, '2015-01-01 01:09:40.000000', 'temperatura', 1026.0000, 'ºC'),
	(306872, 145, '2015-01-01 01:09:41.000000', 'temperatura', 35.0000, 'ºC'),
	(306873, 145, '2015-01-01 01:09:42.000000', 'temperatura', 697.0000, 'ºC'),
	(306874, 145, '2015-01-01 01:09:43.000000', 'temperatura', 979.0000, 'ºC'),
	(306875, 145, '2015-01-01 01:09:44.000000', 'temperatura', 403.0000, 'ºC'),
	(306876, 145, '2015-01-01 01:09:45.000000', 'temperatura', 281.0000, 'ºC'),
	(306877, 145, '2015-01-01 01:09:46.000000', 'temperatura', 196.0000, 'ºC'),
	(306878, 145, '2015-01-01 01:09:47.000000', 'temperatura', 139.0000, 'ºC'),
	(306879, 145, '2015-01-01 01:09:48.000000', 'temperatura', 107.0000, 'ºC'),
	(306880, 145, '2015-01-01 01:09:49.000000', 'temperatura', 120.0000, 'ºC'),
	(306881, 145, '2015-01-01 01:09:50.000000', 'temperatura', 278.0000, 'ºC'),
	(306882, 145, '2015-01-01 01:09:51.000000', 'temperatura', 1030.0000, 'ºC'),
	(306883, 145, '2015-01-01 01:09:52.000000', 'temperatura', 718.0000, 'ºC'),
	(306884, 145, '2015-01-01 01:09:53.000000', 'temperatura', 502.0000, 'ºC'),
	(306885, 145, '2015-01-01 01:09:54.000000', 'temperatura', 354.0000, 'ºC'),
	(306886, 145, '2015-01-01 01:09:55.000000', 'temperatura', 264.0000, 'ºC'),
	(306887, 145, '2015-01-01 01:09:56.000000', 'temperatura', 259.0000, 'ºC'),
	(306888, 145, '2015-01-01 01:09:57.000000', 'temperatura', 502.0000, 'ºC'),
	(306889, 145, '2015-01-01 01:09:58.000000', 'temperatura', 536.0000, 'ºC'),
	(306890, 145, '2015-01-01 01:09:59.000000', 'temperatura', 1176.0000, 'ºC'),
	(306891, 145, '2015-01-01 01:10:00.000000', 'temperatura', 669.0000, 'ºC'),
	(306892, 145, '2015-01-01 01:10:01.000000', 'temperatura', 1018.0000, 'ºC'),
	(306893, 145, '2015-01-01 01:10:02.000000', 'temperatura', 686.0000, 'ºC'),
	(306894, 145, '2015-01-01 01:10:03.000000', 'temperatura', 375.0000, 'ºC'),
	(306895, 145, '2015-01-01 01:10:04.000000', 'temperatura', 1016.0000, 'ºC'),
	(306896, 145, '2015-01-01 01:10:05.000000', 'temperatura', 358.0000, 'ºC'),
	(306897, 145, '2015-01-01 01:10:06.000000', 'temperatura', 1141.0000, 'ºC'),
	(306898, 145, '2015-01-01 01:10:07.000000', 'temperatura', 1030.0000, 'ºC'),
	(306899, 145, '2015-01-01 01:10:08.000000', 'temperatura', 530.0000, 'ºC'),
	(306900, 145, '2015-01-01 01:10:09.000000', 'temperatura', 761.0000, 'ºC'),
	(306901, 145, '2015-01-01 01:10:10.000000', 'temperatura', 1016.0000, 'ºC'),
	(306902, 145, '2015-01-01 01:10:11.000000', 'temperatura', 397.0000, 'ºC'),
	(306903, 145, '2015-01-01 01:10:12.000000', 'temperatura', 136.0000, 'ºC'),
	(306904, 145, '2015-01-01 01:10:13.000000', 'temperatura', 692.0000, 'ºC'),
	(306905, 145, '2015-01-01 01:10:14.000000', 'temperatura', 652.0000, 'ºC'),
	(306906, 145, '2015-01-01 01:10:15.000000', 'temperatura', 1183.0000, 'ºC'),
	(306907, 145, '2015-01-01 01:10:16.000000', 'temperatura', 361.0000, 'ºC'),
	(306908, 145, '2015-01-01 01:10:17.000000', 'temperatura', 654.0000, 'ºC'),
	(306909, 145, '2015-01-01 01:10:18.000000', 'temperatura', 989.0000, 'ºC'),
	(306910, 145, '2015-01-01 01:10:19.000000', 'temperatura', 583.0000, 'ºC'),
	(306911, 145, '2015-01-01 01:10:20.000000', 'temperatura', 1148.0000, 'ºC'),
	(306912, 145, '2015-01-01 01:10:21.000000', 'temperatura', 392.0000, 'ºC'),
	(306913, 145, '2015-01-01 01:10:22.000000', 'temperatura', 917.0000, 'ºC'),
	(306914, 145, '2015-01-01 01:10:23.000000', 'temperatura', 1007.0000, 'ºC'),
	(306915, 145, '2015-01-01 01:10:24.000000', 'temperatura', 1086.0000, 'ºC'),
	(306916, 146, '2015-01-01 00:00:00.000000', 'temperatura', 396.0000, 'ºC'),
	(306917, 146, '2015-01-01 00:00:01.000000', 'temperatura', 747.0000, 'ºC'),
	(306918, 146, '2015-01-01 00:00:02.000000', 'temperatura', 150.0000, 'ºC'),
	(306919, 146, '2015-01-01 00:00:03.000000', 'temperatura', 907.0000, 'ºC'),
	(306920, 146, '2015-01-01 00:00:04.000000', 'temperatura', 486.0000, 'ºC'),
	(306921, 146, '2015-01-01 00:00:05.000000', 'temperatura', 908.0000, 'ºC'),
	(306922, 146, '2015-01-01 00:00:06.000000', 'temperatura', 682.0000, 'ºC'),
	(306923, 146, '2015-01-01 00:00:07.000000', 'temperatura', 690.0000, 'ºC'),
	(306924, 146, '2015-01-01 00:00:08.000000', 'temperatura', 202.0000, 'ºC'),
	(306925, 146, '2015-01-01 00:00:09.000000', 'temperatura', 142.0000, 'ºC'),
	(306926, 146, '2015-01-01 00:00:10.000000', 'temperatura', 102.0000, 'ºC'),
	(306927, 146, '2015-01-01 00:00:11.000000', 'temperatura', 85.0000, 'ºC'),
	(306928, 146, '2015-01-01 00:00:12.000000', 'temperatura', 119.0000, 'ºC'),
	(306929, 146, '2015-01-01 00:00:13.000000', 'temperatura', 343.0000, 'ºC'),
	(306930, 146, '2015-01-01 00:00:14.000000', 'temperatura', 156.0000, 'ºC'),
	(306931, 146, '2015-01-01 00:00:15.000000', 'temperatura', 951.0000, 'ºC'),
	(306932, 146, '2015-01-01 00:00:16.000000', 'temperatura', 688.0000, 'ºC'),
	(306933, 146, '2015-01-01 00:00:17.000000', 'temperatura', 586.0000, 'ºC'),
	(306934, 146, '2015-01-01 00:00:18.000000', 'temperatura', 869.0000, 'ºC'),
	(306935, 146, '2015-01-01 00:00:19.000000', 'temperatura', 187.0000, 'ºC'),
	(306936, 146, '2015-01-01 00:00:20.000000', 'temperatura', 729.0000, 'ºC'),
	(306937, 146, '2015-01-01 00:00:21.000000', 'temperatura', 685.0000, 'ºC'),
	(306938, 146, '2015-01-01 00:00:22.000000', 'temperatura', 40.0000, 'ºC'),
	(306939, 146, '2015-01-01 00:00:23.000000', 'temperatura', 543.0000, 'ºC'),
	(306940, 146, '2015-01-01 00:00:24.000000', 'temperatura', 197.0000, 'ºC'),
	(306941, 146, '2015-01-01 00:00:25.000000', 'temperatura', 558.0000, 'ºC'),
	(306942, 146, '2015-01-01 00:00:26.000000', 'temperatura', 997.0000, 'ºC'),
	(306943, 146, '2015-01-01 00:00:27.000000', 'temperatura', 910.0000, 'ºC'),
	(306944, 146, '2015-01-01 00:00:28.000000', 'temperatura', 363.0000, 'ºC'),
	(306945, 146, '2015-01-01 00:00:29.000000', 'temperatura', 283.0000, 'ºC'),
	(306946, 146, '2015-01-01 00:00:30.000000', 'temperatura', 326.0000, 'ºC'),
	(306947, 146, '2015-01-01 00:00:31.000000', 'temperatura', 782.0000, 'ºC'),
	(306948, 146, '2015-01-01 00:00:32.000000', 'temperatura', 531.0000, 'ºC'),
	(306949, 146, '2015-01-01 00:00:33.000000', 'temperatura', 310.0000, 'ºC'),
	(306950, 146, '2015-01-01 00:00:34.000000', 'temperatura', 1158.0000, 'ºC'),
	(306951, 146, '2015-01-01 00:00:35.000000', 'temperatura', 61.0000, 'ºC'),
	(306952, 146, '2015-01-01 00:00:36.000000', 'temperatura', 433.0000, 'ºC'),
	(306953, 146, '2015-01-01 00:00:37.000000', 'temperatura', 782.0000, 'ºC'),
	(306954, 146, '2015-01-01 00:00:38.000000', 'temperatura', 212.0000, 'ºC'),
	(306955, 146, '2015-01-01 00:00:39.000000', 'temperatura', 1114.0000, 'ºC'),
	(306956, 146, '2015-01-01 00:00:40.000000', 'temperatura', 135.0000, 'ºC'),
	(306957, 146, '2015-01-01 00:00:41.000000', 'temperatura', 934.0000, 'ºC'),
	(306958, 146, '2015-01-01 00:00:42.000000', 'temperatura', 663.0000, 'ºC'),
	(306959, 146, '2015-01-01 00:00:43.000000', 'temperatura', 515.0000, 'ºC'),
	(306960, 146, '2015-01-01 00:00:44.000000', 'temperatura', 585.0000, 'ºC'),
	(306961, 146, '2015-01-01 00:00:45.000000', 'temperatura', 182.0000, 'ºC'),
	(306962, 146, '2015-01-01 00:00:46.000000', 'temperatura', 357.0000, 'ºC'),
	(306963, 146, '2015-01-01 00:00:47.000000', 'temperatura', 38.0000, 'ºC'),
	(306964, 146, '2015-01-01 00:00:48.000000', 'temperatura', 319.0000, 'ºC'),
	(306965, 146, '2015-01-01 00:00:49.000000', 'temperatura', 284.0000, 'ºC'),
	(306966, 146, '2015-01-01 00:00:50.000000', 'temperatura', 462.0000, 'ºC'),
	(306967, 146, '2015-01-01 00:00:51.000000', 'temperatura', 257.0000, 'ºC'),
	(306968, 146, '2015-01-01 00:00:52.000000', 'temperatura', 1102.0000, 'ºC'),
	(306969, 146, '2015-01-01 00:00:53.000000', 'temperatura', 1137.0000, 'ºC'),
	(306970, 146, '2015-01-01 00:00:54.000000', 'temperatura', 1182.0000, 'ºC'),
	(306971, 146, '2015-01-01 00:00:55.000000', 'temperatura', 97.0000, 'ºC'),
	(306972, 146, '2015-01-01 00:00:56.000000', 'temperatura', 539.0000, 'ºC'),
	(306973, 146, '2015-01-01 00:00:57.000000', 'temperatura', 7.0000, 'ºC'),
	(306974, 146, '2015-01-01 00:00:58.000000', 'temperatura', 819.0000, 'ºC'),
	(306975, 146, '2015-01-01 00:00:59.000000', 'temperatura', 475.0000, 'ºC'),
	(306976, 146, '2015-01-01 00:01:00.000000', 'temperatura', 1119.0000, 'ºC'),
	(306977, 146, '2015-01-01 00:01:01.000000', 'temperatura', 571.0000, 'ºC'),
	(306978, 146, '2015-01-01 00:01:02.000000', 'temperatura', 697.0000, 'ºC'),
	(306979, 146, '2015-01-01 00:01:03.000000', 'temperatura', 574.0000, 'ºC'),
	(306980, 146, '2015-01-01 00:01:04.000000', 'temperatura', 779.0000, 'ºC'),
	(306981, 146, '2015-01-01 00:01:05.000000', 'temperatura', 973.0000, 'ºC'),
	(306982, 146, '2015-01-01 00:01:06.000000', 'temperatura', 130.0000, 'ºC'),
	(306983, 146, '2015-01-01 00:01:07.000000', 'temperatura', 131.0000, 'ºC'),
	(306984, 146, '2015-01-01 00:01:08.000000', 'temperatura', 267.0000, 'ºC'),
	(306985, 146, '2015-01-01 00:01:09.000000', 'temperatura', 942.0000, 'ºC'),
	(306986, 146, '2015-01-01 00:01:10.000000', 'temperatura', 307.0000, 'ºC'),
	(306987, 146, '2015-01-01 00:01:11.000000', 'temperatura', 1113.0000, 'ºC'),
	(306988, 146, '2015-01-01 00:01:12.000000', 'temperatura', 1043.0000, 'ºC'),
	(306989, 146, '2015-01-01 00:01:13.000000', 'temperatura', 675.0000, 'ºC'),
	(306990, 146, '2015-01-01 00:01:14.000000', 'temperatura', 247.0000, 'ºC'),
	(306991, 146, '2015-01-01 00:01:15.000000', 'temperatura', 413.0000, 'ºC'),
	(306992, 146, '2015-01-01 00:01:16.000000', 'temperatura', 123.0000, 'ºC'),
	(306993, 146, '2015-01-01 00:01:17.000000', 'temperatura', 576.0000, 'ºC'),
	(306994, 146, '2015-01-01 00:01:18.000000', 'temperatura', 114.0000, 'ºC'),
	(306995, 146, '2015-01-01 00:01:19.000000', 'temperatura', 41.0000, 'ºC'),
	(306996, 146, '2015-01-01 00:01:20.000000', 'temperatura', 1063.0000, 'ºC'),
	(306997, 146, '2015-01-01 00:01:21.000000', 'temperatura', 393.0000, 'ºC'),
	(306998, 146, '2015-01-01 00:01:22.000000', 'temperatura', 1178.0000, 'ºC'),
	(306999, 146, '2015-01-01 00:01:23.000000', 'temperatura', 1111.0000, 'ºC'),
	(307000, 146, '2015-01-01 00:01:24.000000', 'temperatura', 820.0000, 'ºC'),
	(307001, 146, '2015-01-01 00:01:25.000000', 'temperatura', 769.0000, 'ºC'),
	(307002, 146, '2015-01-01 00:01:26.000000', 'temperatura', 185.0000, 'ºC'),
	(307003, 146, '2015-01-01 00:01:27.000000', 'temperatura', 1019.0000, 'ºC'),
	(307004, 146, '2015-01-01 00:01:28.000000', 'temperatura', 942.0000, 'ºC'),
	(307005, 146, '2015-01-01 00:01:29.000000', 'temperatura', 453.0000, 'ºC'),
	(307006, 146, '2015-01-01 00:01:30.000000', 'temperatura', 639.0000, 'ºC'),
	(307007, 146, '2015-01-01 00:01:31.000000', 'temperatura', 635.0000, 'ºC'),
	(307008, 146, '2015-01-01 00:01:32.000000', 'temperatura', 61.0000, 'ºC'),
	(307009, 146, '2015-01-01 00:01:33.000000', 'temperatura', 800.0000, 'ºC'),
	(307010, 146, '2015-01-01 00:01:34.000000', 'temperatura', 217.0000, 'ºC'),
	(307011, 146, '2015-01-01 00:01:35.000000', 'temperatura', 1085.0000, 'ºC'),
	(307012, 146, '2015-01-01 00:01:36.000000', 'temperatura', 1173.0000, 'ºC'),
	(307013, 146, '2015-01-01 00:01:37.000000', 'temperatura', 214.0000, 'ºC'),
	(307014, 146, '2015-01-01 00:01:38.000000', 'temperatura', 1149.0000, 'ºC'),
	(307015, 146, '2015-01-01 00:01:39.000000', 'temperatura', 303.0000, 'ºC'),
	(307016, 146, '2015-01-01 00:01:40.000000', 'temperatura', 469.0000, 'ºC'),
	(307017, 146, '2015-01-01 00:01:41.000000', 'temperatura', 236.0000, 'ºC'),
	(307018, 146, '2015-01-01 00:01:42.000000', 'temperatura', 974.0000, 'ºC'),
	(307019, 146, '2015-01-01 00:01:43.000000', 'temperatura', 561.0000, 'ºC'),
	(307020, 146, '2015-01-01 00:01:44.000000', 'temperatura', 1084.0000, 'ºC'),
	(307021, 146, '2015-01-01 00:01:45.000000', 'temperatura', 140.0000, 'ºC'),
	(307022, 146, '2015-01-01 00:01:46.000000', 'temperatura', 1047.0000, 'ºC'),
	(307023, 146, '2015-01-01 00:01:47.000000', 'temperatura', 15.0000, 'ºC'),
	(307024, 146, '2015-01-01 00:01:48.000000', 'temperatura', 536.0000, 'ºC'),
	(307025, 146, '2015-01-01 00:01:49.000000', 'temperatura', 236.0000, 'ºC'),
	(307026, 146, '2015-01-01 00:01:50.000000', 'temperatura', 770.0000, 'ºC'),
	(307027, 146, '2015-01-01 00:01:51.000000', 'temperatura', 744.0000, 'ºC'),
	(307028, 146, '2015-01-01 00:01:52.000000', 'temperatura', 211.0000, 'ºC'),
	(307029, 146, '2015-01-01 00:01:53.000000', 'temperatura', 23.0000, 'ºC'),
	(307030, 146, '2015-01-01 00:01:54.000000', 'temperatura', 682.0000, 'ºC'),
	(307031, 146, '2015-01-01 00:01:55.000000', 'temperatura', 943.0000, 'ºC'),
	(307032, 146, '2015-01-01 00:01:56.000000', 'temperatura', 271.0000, 'ºC'),
	(307033, 146, '2015-01-01 00:01:57.000000', 'temperatura', 923.0000, 'ºC'),
	(307034, 146, '2015-01-01 00:01:58.000000', 'temperatura', 205.0000, 'ºC'),
	(307035, 146, '2015-01-01 00:01:59.000000', 'temperatura', 654.0000, 'ºC'),
	(307036, 146, '2015-01-01 00:02:00.000000', 'temperatura', 257.0000, 'ºC'),
	(307037, 146, '2015-01-01 00:02:01.000000', 'temperatura', 523.0000, 'ºC'),
	(307038, 146, '2015-01-01 00:02:02.000000', 'temperatura', 644.0000, 'ºC'),
	(307039, 146, '2015-01-01 00:02:03.000000', 'temperatura', 451.0000, 'ºC'),
	(307040, 146, '2015-01-01 00:02:04.000000', 'temperatura', 325.0000, 'ºC'),
	(307041, 146, '2015-01-01 00:02:05.000000', 'temperatura', 271.0000, 'ºC'),
	(307042, 146, '2015-01-01 00:02:06.000000', 'temperatura', 380.0000, 'ºC'),
	(307043, 146, '2015-01-01 00:02:07.000000', 'temperatura', 1087.0000, 'ºC'),
	(307044, 146, '2015-01-01 00:02:08.000000', 'temperatura', 698.0000, 'ºC'),
	(307045, 146, '2015-01-01 00:02:09.000000', 'temperatura', 230.0000, 'ºC'),
	(307046, 146, '2015-01-01 00:02:10.000000', 'temperatura', 257.0000, 'ºC'),
	(307047, 146, '2015-01-01 00:02:11.000000', 'temperatura', 594.0000, 'ºC'),
	(307048, 146, '2015-01-01 00:02:12.000000', 'temperatura', 1002.0000, 'ºC'),
	(307049, 146, '2015-01-01 00:02:13.000000', 'temperatura', 826.0000, 'ºC'),
	(307050, 146, '2015-01-01 00:02:14.000000', 'temperatura', 1127.0000, 'ºC'),
	(307051, 146, '2015-01-01 00:02:15.000000', 'temperatura', 755.0000, 'ºC'),
	(307052, 146, '2015-01-01 00:02:16.000000', 'temperatura', 396.0000, 'ºC'),
	(307053, 146, '2015-01-01 00:02:17.000000', 'temperatura', 913.0000, 'ºC'),
	(307054, 146, '2015-01-01 00:02:18.000000', 'temperatura', 979.0000, 'ºC'),
	(307055, 146, '2015-01-01 00:02:19.000000', 'temperatura', 958.0000, 'ºC'),
	(307056, 146, '2015-01-01 00:02:20.000000', 'temperatura', 654.0000, 'ºC'),
	(307057, 146, '2015-01-01 00:02:21.000000', 'temperatura', 396.0000, 'ºC'),
	(307058, 146, '2015-01-01 00:02:22.000000', 'temperatura', 20.0000, 'ºC'),
	(307059, 146, '2015-01-01 00:02:23.000000', 'temperatura', 111.0000, 'ºC'),
	(307060, 146, '2015-01-01 00:02:24.000000', 'temperatura', 495.0000, 'ºC'),
	(307061, 146, '2015-01-01 00:02:25.000000', 'temperatura', 944.0000, 'ºC'),
	(307062, 146, '2015-01-01 00:02:26.000000', 'temperatura', 835.0000, 'ºC'),
	(307063, 146, '2015-01-01 00:02:27.000000', 'temperatura', 142.0000, 'ºC'),
	(307064, 146, '2015-01-01 00:02:28.000000', 'temperatura', 608.0000, 'ºC'),
	(307065, 146, '2015-01-01 00:02:29.000000', 'temperatura', 212.0000, 'ºC'),
	(307066, 146, '2015-01-01 00:02:30.000000', 'temperatura', 436.0000, 'ºC'),
	(307067, 146, '2015-01-01 00:02:31.000000', 'temperatura', 344.0000, 'ºC'),
	(307068, 146, '2015-01-01 00:02:32.000000', 'temperatura', 416.0000, 'ºC'),
	(307069, 146, '2015-01-01 00:02:33.000000', 'temperatura', 1045.0000, 'ºC'),
	(307070, 146, '2015-01-01 00:02:34.000000', 'temperatura', 379.0000, 'ºC'),
	(307071, 146, '2015-01-01 00:02:35.000000', 'temperatura', 1159.0000, 'ºC'),
	(307072, 146, '2015-01-01 00:02:36.000000', 'temperatura', 1059.0000, 'ºC'),
	(307073, 146, '2015-01-01 00:02:37.000000', 'temperatura', 619.0000, 'ºC'),
	(307074, 146, '2015-01-01 00:02:38.000000', 'temperatura', 1120.0000, 'ºC'),
	(307075, 146, '2015-01-01 00:02:39.000000', 'temperatura', 141.0000, 'ºC'),
	(307076, 146, '2015-01-01 00:02:40.000000', 'temperatura', 948.0000, 'ºC'),
	(307077, 146, '2015-01-01 00:02:41.000000', 'temperatura', 718.0000, 'ºC'),
	(307078, 146, '2015-01-01 00:02:42.000000', 'temperatura', 747.0000, 'ºC'),
	(307079, 146, '2015-01-01 00:02:43.000000', 'temperatura', 379.0000, 'ºC'),
	(307080, 146, '2015-01-01 00:02:44.000000', 'temperatura', 856.0000, 'ºC'),
	(307081, 146, '2015-01-01 00:02:45.000000', 'temperatura', 743.0000, 'ºC'),
	(307082, 146, '2015-01-01 00:02:46.000000', 'temperatura', 1146.0000, 'ºC'),
	(307083, 146, '2015-01-01 00:02:47.000000', 'temperatura', 1102.0000, 'ºC'),
	(307084, 146, '2015-01-01 00:02:48.000000', 'temperatura', 872.0000, 'ºC'),
	(307085, 146, '2015-01-01 00:02:49.000000', 'temperatura', 1057.0000, 'ºC'),
	(307086, 146, '2015-01-01 00:02:50.000000', 'temperatura', 267.0000, 'ºC'),
	(307087, 146, '2015-01-01 00:02:51.000000', 'temperatura', 567.0000, 'ºC'),
	(307088, 146, '2015-01-01 00:02:52.000000', 'temperatura', 833.0000, 'ºC'),
	(307089, 146, '2015-01-01 00:02:53.000000', 'temperatura', 64.0000, 'ºC'),
	(307090, 146, '2015-01-01 00:02:54.000000', 'temperatura', 224.0000, 'ºC'),
	(307091, 146, '2015-01-01 00:02:55.000000', 'temperatura', 926.0000, 'ºC'),
	(307092, 146, '2015-01-01 00:02:56.000000', 'temperatura', 361.0000, 'ºC'),
	(307093, 146, '2015-01-01 00:02:57.000000', 'temperatura', 227.0000, 'ºC'),
	(307094, 146, '2015-01-01 00:02:58.000000', 'temperatura', 54.0000, 'ºC'),
	(307095, 146, '2015-01-01 00:02:59.000000', 'temperatura', 786.0000, 'ºC'),
	(307096, 146, '2015-01-01 00:03:00.000000', 'temperatura', 171.0000, 'ºC'),
	(307097, 146, '2015-01-01 00:03:01.000000', 'temperatura', 896.0000, 'ºC'),
	(307098, 146, '2015-01-01 00:03:02.000000', 'temperatura', 369.0000, 'ºC'),
	(307099, 146, '2015-01-01 00:03:03.000000', 'temperatura', 359.0000, 'ºC'),
	(307100, 146, '2015-01-01 00:03:04.000000', 'temperatura', 687.0000, 'ºC'),
	(307101, 146, '2015-01-01 00:03:05.000000', 'temperatura', 1157.0000, 'ºC'),
	(307102, 146, '2015-01-01 00:03:06.000000', 'temperatura', 125.0000, 'ºC'),
	(307103, 146, '2015-01-01 00:03:07.000000', 'temperatura', 757.0000, 'ºC'),
	(307104, 146, '2015-01-01 00:03:08.000000', 'temperatura', 1008.0000, 'ºC'),
	(307105, 146, '2015-01-01 00:03:09.000000', 'temperatura', 370.0000, 'ºC'),
	(307106, 146, '2015-01-01 00:03:10.000000', 'temperatura', 25.0000, 'ºC'),
	(307107, 146, '2015-01-01 00:03:11.000000', 'temperatura', 218.0000, 'ºC'),
	(307108, 146, '2015-01-01 00:03:12.000000', 'temperatura', 1015.0000, 'ºC'),
	(307109, 146, '2015-01-01 00:03:13.000000', 'temperatura', 820.0000, 'ºC'),
	(307110, 146, '2015-01-01 00:03:14.000000', 'temperatura', 1058.0000, 'ºC'),
	(307111, 146, '2015-01-01 00:03:15.000000', 'temperatura', 429.0000, 'ºC'),
	(307112, 146, '2015-01-01 00:03:16.000000', 'temperatura', 174.0000, 'ºC'),
	(307113, 146, '2015-01-01 00:03:17.000000', 'temperatura', 781.0000, 'ºC'),
	(307114, 146, '2015-01-01 00:03:18.000000', 'temperatura', 982.0000, 'ºC'),
	(307115, 146, '2015-01-01 00:03:19.000000', 'temperatura', 169.0000, 'ºC'),
	(307116, 146, '2015-01-01 00:03:20.000000', 'temperatura', 300.0000, 'ºC'),
	(307117, 146, '2015-01-01 00:03:21.000000', 'temperatura', 995.0000, 'ºC'),
	(307118, 146, '2015-01-01 00:03:22.000000', 'temperatura', 473.0000, 'ºC'),
	(307119, 146, '2015-01-01 00:03:23.000000', 'temperatura', 582.0000, 'ºC'),
	(307120, 146, '2015-01-01 00:03:24.000000', 'temperatura', 292.0000, 'ºC'),
	(307121, 146, '2015-01-01 00:03:25.000000', 'temperatura', 915.0000, 'ºC'),
	(307122, 146, '2015-01-01 00:03:26.000000', 'temperatura', 99.0000, 'ºC'),
	(307123, 146, '2015-01-01 00:03:27.000000', 'temperatura', 152.0000, 'ºC'),
	(307124, 146, '2015-01-01 00:03:28.000000', 'temperatura', 462.0000, 'ºC'),
	(307125, 146, '2015-01-01 00:03:29.000000', 'temperatura', 656.0000, 'ºC'),
	(307126, 146, '2015-01-01 00:03:30.000000', 'temperatura', 692.0000, 'ºC'),
	(307127, 146, '2015-01-01 00:03:31.000000', 'temperatura', 295.0000, 'ºC'),
	(307128, 146, '2015-01-01 00:03:32.000000', 'temperatura', 598.0000, 'ºC'),
	(307129, 146, '2015-01-01 00:03:33.000000', 'temperatura', 905.0000, 'ºC'),
	(307130, 146, '2015-01-01 00:03:34.000000', 'temperatura', 334.0000, 'ºC'),
	(307131, 146, '2015-01-01 00:03:35.000000', 'temperatura', 153.0000, 'ºC'),
	(307132, 146, '2015-01-01 00:03:36.000000', 'temperatura', 962.0000, 'ºC'),
	(307133, 146, '2015-01-01 00:03:37.000000', 'temperatura', 755.0000, 'ºC'),
	(307134, 146, '2015-01-01 00:03:38.000000', 'temperatura', 887.0000, 'ºC'),
	(307135, 146, '2015-01-01 00:03:39.000000', 'temperatura', 971.0000, 'ºC'),
	(307136, 146, '2015-01-01 00:03:40.000000', 'temperatura', 996.0000, 'ºC'),
	(307137, 146, '2015-01-01 00:03:41.000000', 'temperatura', 865.0000, 'ºC'),
	(307138, 146, '2015-01-01 00:03:42.000000', 'temperatura', 141.0000, 'ºC'),
	(307139, 146, '2015-01-01 00:03:43.000000', 'temperatura', 508.0000, 'ºC'),
	(307140, 146, '2015-01-01 00:03:44.000000', 'temperatura', 917.0000, 'ºC'),
	(307141, 146, '2015-01-01 00:03:45.000000', 'temperatura', 664.0000, 'ºC'),
	(307142, 146, '2015-01-01 00:03:46.000000', 'temperatura', 569.0000, 'ºC'),
	(307143, 146, '2015-01-01 00:03:47.000000', 'temperatura', 854.0000, 'ºC'),
	(307144, 146, '2015-01-01 00:03:48.000000', 'temperatura', 164.0000, 'ºC'),
	(307145, 146, '2015-01-01 00:03:49.000000', 'temperatura', 659.0000, 'ºC'),
	(307146, 146, '2015-01-01 00:03:50.000000', 'temperatura', 404.0000, 'ºC'),
	(307147, 146, '2015-01-01 00:03:51.000000', 'temperatura', 44.0000, 'ºC'),
	(307148, 146, '2015-01-01 00:03:52.000000', 'temperatura', 207.0000, 'ºC'),
	(307149, 146, '2015-01-01 00:03:53.000000', 'temperatura', 904.0000, 'ºC'),
	(307150, 146, '2015-01-01 00:03:54.000000', 'temperatura', 300.0000, 'ºC'),
	(307151, 146, '2015-01-01 00:03:55.000000', 'temperatura', 1186.0000, 'ºC'),
	(307152, 146, '2015-01-01 00:03:56.000000', 'temperatura', 232.0000, 'ºC'),
	(307153, 146, '2015-01-01 00:03:57.000000', 'temperatura', 2.0000, 'ºC'),
	(307154, 146, '2015-01-01 00:03:58.000000', 'temperatura', 513.0000, 'ºC'),
	(307155, 146, '2015-01-01 00:03:59.000000', 'temperatura', 160.0000, 'ºC'),
	(307156, 146, '2015-01-01 00:04:00.000000', 'temperatura', 462.0000, 'ºC'),
	(307157, 146, '2015-01-01 00:04:01.000000', 'temperatura', 632.0000, 'ºC'),
	(307158, 146, '2015-01-01 00:04:02.000000', 'temperatura', 571.0000, 'ºC'),
	(307159, 146, '2015-01-01 00:04:03.000000', 'temperatura', 963.0000, 'ºC'),
	(307160, 146, '2015-01-01 00:04:04.000000', 'temperatura', 702.0000, 'ºC'),
	(307161, 146, '2015-01-01 00:04:05.000000', 'temperatura', 619.0000, 'ºC'),
	(307162, 146, '2015-01-01 00:04:06.000000', 'temperatura', 993.0000, 'ºC'),
	(307163, 146, '2015-01-01 00:04:07.000000', 'temperatura', 706.0000, 'ºC'),
	(307164, 146, '2015-01-01 00:04:08.000000', 'temperatura', 551.0000, 'ºC'),
	(307165, 146, '2015-01-01 00:04:09.000000', 'temperatura', 637.0000, 'ºC'),
	(307166, 146, '2015-01-01 00:04:10.000000', 'temperatura', 332.0000, 'ºC'),
	(307167, 146, '2015-01-01 00:04:11.000000', 'temperatura', 948.0000, 'ºC'),
	(307168, 146, '2015-01-01 00:04:12.000000', 'temperatura', 148.0000, 'ºC'),
	(307169, 146, '2015-01-01 00:04:13.000000', 'temperatura', 295.0000, 'ºC'),
	(307170, 146, '2015-01-01 00:04:14.000000', 'temperatura', 1033.0000, 'ºC'),
	(307171, 146, '2015-01-01 00:04:15.000000', 'temperatura', 678.0000, 'ºC'),
	(307172, 146, '2015-01-01 00:04:16.000000', 'temperatura', 293.0000, 'ºC'),
	(307173, 146, '2015-01-01 00:04:17.000000', 'temperatura', 632.0000, 'ºC'),
	(307174, 146, '2015-01-01 00:04:18.000000', 'temperatura', 1080.0000, 'ºC'),
	(307175, 146, '2015-01-01 00:04:19.000000', 'temperatura', 1103.0000, 'ºC'),
	(307176, 146, '2015-01-01 00:04:20.000000', 'temperatura', 1077.0000, 'ºC'),
	(307177, 146, '2015-01-01 00:04:21.000000', 'temperatura', 877.0000, 'ºC'),
	(307178, 146, '2015-01-01 00:04:22.000000', 'temperatura', 1156.0000, 'ºC'),
	(307179, 146, '2015-01-01 00:04:23.000000', 'temperatura', 747.0000, 'ºC'),
	(307180, 146, '2015-01-01 00:04:24.000000', 'temperatura', 268.0000, 'ºC'),
	(307181, 146, '2015-01-01 00:04:25.000000', 'temperatura', 302.0000, 'ºC'),
	(307182, 146, '2015-01-01 00:04:26.000000', 'temperatura', 704.0000, 'ºC'),
	(307183, 146, '2015-01-01 00:04:27.000000', 'temperatura', 216.0000, 'ºC'),
	(307184, 146, '2015-01-01 00:04:28.000000', 'temperatura', 166.0000, 'ºC'),
	(307185, 146, '2015-01-01 00:04:29.000000', 'temperatura', 185.0000, 'ºC'),
	(307186, 146, '2015-01-01 00:04:30.000000', 'temperatura', 426.0000, 'ºC'),
	(307187, 146, '2015-01-01 00:04:31.000000', 'temperatura', 374.0000, 'ºC'),
	(307188, 146, '2015-01-01 00:04:32.000000', 'temperatura', 593.0000, 'ºC'),
	(307189, 146, '2015-01-01 00:04:33.000000', 'temperatura', 645.0000, 'ºC'),
	(307190, 146, '2015-01-01 00:04:34.000000', 'temperatura', 246.0000, 'ºC'),
	(307191, 146, '2015-01-01 00:04:35.000000', 'temperatura', 497.0000, 'ºC'),
	(307192, 146, '2015-01-01 00:04:36.000000', 'temperatura', 548.0000, 'ºC'),
	(307193, 146, '2015-01-01 00:04:37.000000', 'temperatura', 46.0000, 'ºC'),
	(307194, 146, '2015-01-01 00:04:38.000000', 'temperatura', 990.0000, 'ºC'),
	(307195, 146, '2015-01-01 00:04:39.000000', 'temperatura', 10.0000, 'ºC'),
	(307196, 146, '2015-01-01 00:04:40.000000', 'temperatura', 680.0000, 'ºC'),
	(307197, 146, '2015-01-01 00:04:41.000000', 'temperatura', 973.0000, 'ºC'),
	(307198, 146, '2015-01-01 00:04:42.000000', 'temperatura', 425.0000, 'ºC'),
	(307199, 146, '2015-01-01 00:04:43.000000', 'temperatura', 408.0000, 'ºC'),
	(307200, 146, '2015-01-01 00:04:44.000000', 'temperatura', 764.0000, 'ºC'),
	(307201, 146, '2015-01-01 00:04:45.000000', 'temperatura', 195.0000, 'ºC'),
	(307202, 146, '2015-01-01 00:04:46.000000', 'temperatura', 1085.0000, 'ºC'),
	(307203, 146, '2015-01-01 00:04:47.000000', 'temperatura', 42.0000, 'ºC'),
	(307204, 146, '2015-01-01 00:04:48.000000', 'temperatura', 556.0000, 'ºC'),
	(307205, 146, '2015-01-01 00:04:49.000000', 'temperatura', 252.0000, 'ºC'),
	(307206, 146, '2015-01-01 00:04:50.000000', 'temperatura', 795.0000, 'ºC'),
	(307207, 146, '2015-01-01 00:04:51.000000', 'temperatura', 820.0000, 'ºC'),
	(307208, 146, '2015-01-01 00:04:52.000000', 'temperatura', 517.0000, 'ºC'),
	(307209, 146, '2015-01-01 00:04:53.000000', 'temperatura', 122.0000, 'ºC'),
	(307210, 146, '2015-01-01 00:04:54.000000', 'temperatura', 259.0000, 'ºC'),
	(307211, 146, '2015-01-01 00:04:55.000000', 'temperatura', 929.0000, 'ºC'),
	(307212, 146, '2015-01-01 00:04:56.000000', 'temperatura', 270.0000, 'ºC'),
	(307213, 146, '2015-01-01 00:04:57.000000', 'temperatura', 964.0000, 'ºC'),
	(307214, 146, '2015-01-01 00:04:58.000000', 'temperatura', 408.0000, 'ºC'),
	(307215, 146, '2015-01-01 00:04:59.000000', 'temperatura', 352.0000, 'ºC'),
	(307216, 146, '2015-01-01 00:05:00.000000', 'temperatura', 533.0000, 'ºC'),
	(307217, 146, '2015-01-01 00:05:01.000000', 'temperatura', 411.0000, 'ºC'),
	(307218, 146, '2015-01-01 00:05:02.000000', 'temperatura', 458.0000, 'ºC'),
	(307219, 146, '2015-01-01 00:05:03.000000', 'temperatura', 1055.0000, 'ºC'),
	(307220, 146, '2015-01-01 00:05:04.000000', 'temperatura', 301.0000, 'ºC'),
	(307221, 146, '2015-01-01 00:05:05.000000', 'temperatura', 743.0000, 'ºC'),
	(307222, 146, '2015-01-01 00:05:06.000000', 'temperatura', 411.0000, 'ºC'),
	(307223, 146, '2015-01-01 00:05:07.000000', 'temperatura', 1028.0000, 'ºC'),
	(307224, 146, '2015-01-01 00:05:08.000000', 'temperatura', 308.0000, 'ºC'),
	(307225, 146, '2015-01-01 00:05:09.000000', 'temperatura', 854.0000, 'ºC'),
	(307226, 146, '2015-01-01 00:05:10.000000', 'temperatura', 946.0000, 'ºC'),
	(307227, 146, '2015-01-01 00:05:11.000000', 'temperatura', 968.0000, 'ºC'),
	(307228, 146, '2015-01-01 00:05:12.000000', 'temperatura', 804.0000, 'ºC'),
	(307229, 146, '2015-01-01 00:05:13.000000', 'temperatura', 1118.0000, 'ºC'),
	(307230, 146, '2015-01-01 00:05:14.000000', 'temperatura', 779.0000, 'ºC'),
	(307231, 146, '2015-01-01 00:05:15.000000', 'temperatura', 539.0000, 'ºC'),
	(307232, 146, '2015-01-01 00:05:16.000000', 'temperatura', 361.0000, 'ºC'),
	(307233, 146, '2015-01-01 00:05:17.000000', 'temperatura', 188.0000, 'ºC'),
	(307234, 146, '2015-01-01 00:05:18.000000', 'temperatura', 1059.0000, 'ºC'),
	(307235, 146, '2015-01-01 00:05:19.000000', 'temperatura', 1129.0000, 'ºC'),
	(307236, 146, '2015-01-01 00:05:20.000000', 'temperatura', 67.0000, 'ºC'),
	(307237, 146, '2015-01-01 00:05:21.000000', 'temperatura', 551.0000, 'ºC'),
	(307238, 146, '2015-01-01 00:05:22.000000', 'temperatura', 155.0000, 'ºC'),
	(307239, 146, '2015-01-01 00:05:23.000000', 'temperatura', 324.0000, 'ºC'),
	(307240, 146, '2015-01-01 00:05:24.000000', 'temperatura', 1152.0000, 'ºC'),
	(307241, 146, '2015-01-01 00:05:25.000000', 'temperatura', 1191.0000, 'ºC'),
	(307242, 146, '2015-01-01 00:05:26.000000', 'temperatura', 98.0000, 'ºC'),
	(307243, 146, '2015-01-01 00:05:27.000000', 'temperatura', 519.0000, 'ºC'),
	(307244, 146, '2015-01-01 00:05:28.000000', 'temperatura', 1099.0000, 'ºC'),
	(307245, 146, '2015-01-01 00:05:29.000000', 'temperatura', 341.0000, 'ºC'),
	(307246, 146, '2015-01-01 00:05:30.000000', 'temperatura', 807.0000, 'ºC'),
	(307247, 146, '2015-01-01 00:05:31.000000', 'temperatura', 611.0000, 'ºC'),
	(307248, 146, '2015-01-01 00:05:32.000000', 'temperatura', 637.0000, 'ºC'),
	(307249, 146, '2015-01-01 00:05:33.000000', 'temperatura', 152.0000, 'ºC'),
	(307250, 146, '2015-01-01 00:05:34.000000', 'temperatura', 50.0000, 'ºC'),
	(307251, 146, '2015-01-01 00:05:35.000000', 'temperatura', 993.0000, 'ºC'),
	(307252, 146, '2015-01-01 00:05:36.000000', 'temperatura', 16.0000, 'ºC'),
	(307253, 146, '2015-01-01 00:05:37.000000', 'temperatura', 700.0000, 'ºC'),
	(307254, 146, '2015-01-01 00:05:38.000000', 'temperatura', 1053.0000, 'ºC'),
	(307255, 146, '2015-01-01 00:05:39.000000', 'temperatura', 767.0000, 'ºC'),
	(307256, 146, '2015-01-01 00:05:40.000000', 'temperatura', 676.0000, 'ºC'),
	(307257, 146, '2015-01-01 00:05:41.000000', 'temperatura', 1078.0000, 'ºC'),
	(307258, 146, '2015-01-01 00:05:42.000000', 'temperatura', 963.0000, 'ºC'),
	(307259, 146, '2015-01-01 00:05:43.000000', 'temperatura', 381.0000, 'ºC'),
	(307260, 146, '2015-01-01 00:05:44.000000', 'temperatura', 217.0000, 'ºC'),
	(307261, 146, '2015-01-01 00:05:45.000000', 'temperatura', 1144.0000, 'ºC'),
	(307262, 146, '2015-01-01 00:05:46.000000', 'temperatura', 268.0000, 'ºC'),
	(307263, 146, '2015-01-01 00:05:47.000000', 'temperatura', 308.0000, 'ºC'),
	(307264, 146, '2015-01-01 00:05:48.000000', 'temperatura', 738.0000, 'ºC'),
	(307265, 146, '2015-01-01 00:05:49.000000', 'temperatura', 367.0000, 'ºC'),
	(307266, 146, '2015-01-01 00:05:50.000000', 'temperatura', 819.0000, 'ºC'),
	(307267, 146, '2015-01-01 00:05:51.000000', 'temperatura', 594.0000, 'ºC'),
	(307268, 146, '2015-01-01 00:05:52.000000', 'temperatura', 516.0000, 'ºC'),
	(307269, 146, '2015-01-01 00:05:53.000000', 'temperatura', 799.0000, 'ºC'),
	(307270, 146, '2015-01-01 00:05:54.000000', 'temperatura', 46.0000, 'ºC'),
	(307271, 146, '2015-01-01 00:05:55.000000', 'temperatura', 236.0000, 'ºC'),
	(307272, 146, '2015-01-01 00:05:56.000000', 'temperatura', 1040.0000, 'ºC'),
	(307273, 146, '2015-01-01 00:05:57.000000', 'temperatura', 895.0000, 'ºC'),
	(307274, 146, '2015-01-01 00:05:58.000000', 'temperatura', 152.0000, 'ºC'),
	(307275, 146, '2015-01-01 00:05:59.000000', 'temperatura', 478.0000, 'ºC'),
	(307276, 146, '2015-01-01 00:06:00.000000', 'temperatura', 735.0000, 'ºC'),
	(307277, 146, '2015-01-01 00:06:01.000000', 'temperatura', 1042.0000, 'ºC'),
	(307278, 146, '2015-01-01 00:06:02.000000', 'temperatura', 605.0000, 'ºC'),
	(307279, 146, '2015-01-01 00:06:03.000000', 'temperatura', 1099.0000, 'ºC'),
	(307280, 146, '2015-01-01 00:06:04.000000', 'temperatura', 82.0000, 'ºC'),
	(307281, 146, '2015-01-01 00:06:05.000000', 'temperatura', 715.0000, 'ºC'),
	(307282, 146, '2015-01-01 00:06:06.000000', 'temperatura', 926.0000, 'ºC'),
	(307283, 146, '2015-01-01 00:06:07.000000', 'temperatura', 86.0000, 'ºC'),
	(307284, 146, '2015-01-01 00:06:08.000000', 'temperatura', 55.0000, 'ºC'),
	(307285, 146, '2015-01-01 00:06:09.000000', 'temperatura', 15.0000, 'ºC'),
	(307286, 146, '2015-01-01 00:06:10.000000', 'temperatura', 1110.0000, 'ºC'),
	(307287, 146, '2015-01-01 00:06:11.000000', 'temperatura', 708.0000, 'ºC'),
	(307288, 146, '2015-01-01 00:06:12.000000', 'temperatura', 210.0000, 'ºC'),
	(307289, 146, '2015-01-01 00:06:13.000000', 'temperatura', 127.0000, 'ºC'),
	(307290, 146, '2015-01-01 00:06:14.000000', 'temperatura', 5.0000, 'ºC'),
	(307291, 146, '2015-01-01 00:06:15.000000', 'temperatura', 843.0000, 'ºC'),
	(307292, 146, '2015-01-01 00:06:16.000000', 'temperatura', 603.0000, 'ºC'),
	(307293, 146, '2015-01-01 00:06:17.000000', 'temperatura', 486.0000, 'ºC'),
	(307294, 146, '2015-01-01 00:06:18.000000', 'temperatura', 620.0000, 'ºC'),
	(307295, 146, '2015-01-01 00:06:19.000000', 'temperatura', 442.0000, 'ºC'),
	(307296, 146, '2015-01-01 00:06:20.000000', 'temperatura', 350.0000, 'ºC'),
	(307297, 146, '2015-01-01 00:06:21.000000', 'temperatura', 424.0000, 'ºC'),
	(307298, 146, '2015-01-01 00:06:22.000000', 'temperatura', 1069.0000, 'ºC'),
	(307299, 146, '2015-01-01 00:06:23.000000', 'temperatura', 477.0000, 'ºC'),
	(307300, 146, '2015-01-01 00:06:24.000000', 'temperatura', 378.0000, 'ºC'),
	(307301, 146, '2015-01-01 00:06:25.000000', 'temperatura', 459.0000, 'ºC'),
	(307302, 146, '2015-01-01 00:06:26.000000', 'temperatura', 1160.0000, 'ºC'),
	(307303, 146, '2015-01-01 00:06:27.000000', 'temperatura', 823.0000, 'ºC'),
	(307304, 146, '2015-01-01 00:06:28.000000', 'temperatura', 635.0000, 'ºC'),
	(307305, 146, '2015-01-01 00:06:29.000000', 'temperatura', 709.0000, 'ºC'),
	(307306, 146, '2015-01-01 00:06:30.000000', 'temperatura', 439.0000, 'ºC'),
	(307307, 146, '2015-01-01 00:06:31.000000', 'temperatura', 70.0000, 'ºC'),
	(307308, 146, '2015-01-01 00:06:32.000000', 'temperatura', 232.0000, 'ºC'),
	(307309, 146, '2015-01-01 00:06:33.000000', 'temperatura', 951.0000, 'ºC'),
	(307310, 146, '2015-01-01 00:06:34.000000', 'temperatura', 460.0000, 'ºC'),
	(307311, 146, '2015-01-01 00:06:35.000000', 'temperatura', 649.0000, 'ºC'),
	(307312, 146, '2015-01-01 00:06:36.000000', 'temperatura', 664.0000, 'ºC'),
	(307313, 146, '2015-01-01 00:06:37.000000', 'temperatura', 172.0000, 'ºC'),
	(307314, 146, '2015-01-01 00:06:38.000000', 'temperatura', 68.0000, 'ºC'),
	(307315, 146, '2015-01-01 00:06:39.000000', 'temperatura', 1027.0000, 'ºC'),
	(307316, 146, '2015-01-01 00:06:40.000000', 'temperatura', 130.0000, 'ºC'),
	(307317, 146, '2015-01-01 00:06:41.000000', 'temperatura', 1171.0000, 'ºC'),
	(307318, 146, '2015-01-01 00:06:42.000000', 'temperatura', 664.0000, 'ºC'),
	(307319, 146, '2015-01-01 00:06:43.000000', 'temperatura', 1009.0000, 'ºC'),
	(307320, 146, '2015-01-01 00:06:44.000000', 'temperatura', 654.0000, 'ºC'),
	(307321, 146, '2015-01-01 00:06:45.000000', 'temperatura', 243.0000, 'ºC'),
	(307322, 146, '2015-01-01 00:06:46.000000', 'temperatura', 455.0000, 'ºC'),
	(307323, 146, '2015-01-01 00:06:47.000000', 'temperatura', 347.0000, 'ºC'),
	(307324, 146, '2015-01-01 00:06:48.000000', 'temperatura', 369.0000, 'ºC'),
	(307325, 146, '2015-01-01 00:06:49.000000', 'temperatura', 803.0000, 'ºC'),
	(307326, 146, '2015-01-01 00:06:50.000000', 'temperatura', 509.0000, 'ºC'),
	(307327, 146, '2015-01-01 00:06:51.000000', 'temperatura', 137.0000, 'ºC'),
	(307328, 146, '2015-01-01 00:06:52.000000', 'temperatura', 357.0000, 'ºC'),
	(307329, 146, '2015-01-01 00:06:53.000000', 'temperatura', 174.0000, 'ºC'),
	(307330, 146, '2015-01-01 00:06:54.000000', 'temperatura', 1000.0000, 'ºC'),
	(307331, 146, '2015-01-01 00:06:55.000000', 'temperatura', 880.0000, 'ºC'),
	(307332, 146, '2015-01-01 00:06:56.000000', 'temperatura', 200.0000, 'ºC'),
	(307333, 146, '2015-01-01 00:06:57.000000', 'temperatura', 761.0000, 'ºC'),
	(307334, 146, '2015-01-01 00:06:58.000000', 'temperatura', 804.0000, 'ºC'),
	(307335, 146, '2015-01-01 00:06:59.000000', 'temperatura', 540.0000, 'ºC'),
	(307336, 146, '2015-01-01 00:07:00.000000', 'temperatura', 288.0000, 'ºC'),
	(307337, 146, '2015-01-01 00:07:01.000000', 'temperatura', 1019.0000, 'ºC'),
	(307338, 146, '2015-01-01 00:07:02.000000', 'temperatura', 631.0000, 'ºC'),
	(307339, 146, '2015-01-01 00:07:03.000000', 'temperatura', 98.0000, 'ºC'),
	(307340, 146, '2015-01-01 00:07:04.000000', 'temperatura', 999.0000, 'ºC'),
	(307341, 146, '2015-01-01 00:07:05.000000', 'temperatura', 1100.0000, 'ºC'),
	(307342, 146, '2015-01-01 00:07:06.000000', 'temperatura', 104.0000, 'ºC'),
	(307343, 146, '2015-01-01 00:07:07.000000', 'temperatura', 821.0000, 'ºC'),
	(307344, 146, '2015-01-01 00:07:08.000000', 'temperatura', 195.0000, 'ºC'),
	(307345, 146, '2015-01-01 00:07:09.000000', 'temperatura', 911.0000, 'ºC'),
	(307346, 146, '2015-01-01 00:07:10.000000', 'temperatura', 371.0000, 'ºC'),
	(307347, 146, '2015-01-01 00:07:11.000000', 'temperatura', 322.0000, 'ºC'),
	(307348, 146, '2015-01-01 00:07:12.000000', 'temperatura', 497.0000, 'ºC'),
	(307349, 146, '2015-01-01 00:07:13.000000', 'temperatura', 318.0000, 'ºC'),
	(307350, 146, '2015-01-01 00:07:14.000000', 'temperatura', 101.0000, 'ºC'),
	(307351, 146, '2015-01-01 00:07:15.000000', 'temperatura', 749.0000, 'ºC'),
	(307352, 146, '2015-01-01 00:07:16.000000', 'temperatura', 1046.0000, 'ºC'),
	(307353, 146, '2015-01-01 00:07:17.000000', 'temperatura', 582.0000, 'ºC'),
	(307354, 146, '2015-01-01 00:07:18.000000', 'temperatura', 972.0000, 'ºC'),
	(307355, 146, '2015-01-01 00:07:19.000000', 'temperatura', 716.0000, 'ºC'),
	(307356, 146, '2015-01-01 00:07:20.000000', 'temperatura', 663.0000, 'ºC'),
	(307357, 146, '2015-01-01 00:07:21.000000', 'temperatura', 1170.0000, 'ºC'),
	(307358, 146, '2015-01-01 00:07:22.000000', 'temperatura', 259.0000, 'ºC'),
	(307359, 146, '2015-01-01 00:07:23.000000', 'temperatura', 185.0000, 'ºC'),
	(307360, 146, '2015-01-01 00:07:24.000000', 'temperatura', 151.0000, 'ºC'),
	(307361, 146, '2015-01-01 00:07:25.000000', 'temperatura', 200.0000, 'ºC'),
	(307362, 146, '2015-01-01 00:07:26.000000', 'temperatura', 547.0000, 'ºC'),
	(307363, 146, '2015-01-01 00:07:27.000000', 'temperatura', 937.0000, 'ºC'),
	(307364, 146, '2015-01-01 00:07:28.000000', 'temperatura', 645.0000, 'ºC'),
	(307365, 146, '2015-01-01 00:07:29.000000', 'temperatura', 412.0000, 'ºC'),
	(307366, 146, '2015-01-01 00:07:30.000000', 'temperatura', 128.0000, 'ºC'),
	(307367, 146, '2015-01-01 00:07:31.000000', 'temperatura', 601.0000, 'ºC'),
	(307368, 146, '2015-01-01 00:07:32.000000', 'temperatura', 225.0000, 'ºC'),
	(307369, 146, '2015-01-01 00:07:33.000000', 'temperatura', 522.0000, 'ºC'),
	(307370, 146, '2015-01-01 00:07:34.000000', 'temperatura', 733.0000, 'ºC'),
	(307371, 146, '2015-01-01 00:07:35.000000', 'temperatura', 903.0000, 'ºC'),
	(307372, 146, '2015-01-01 00:07:36.000000', 'temperatura', 1115.0000, 'ºC'),
	(307373, 146, '2015-01-01 00:07:37.000000', 'temperatura', 466.0000, 'ºC'),
	(307374, 146, '2015-01-01 00:07:38.000000', 'temperatura', 186.0000, 'ºC'),
	(307375, 146, '2015-01-01 00:07:39.000000', 'temperatura', 731.0000, 'ºC'),
	(307376, 146, '2015-01-01 00:07:40.000000', 'temperatura', 699.0000, 'ºC'),
	(307377, 146, '2015-01-01 00:07:41.000000', 'temperatura', 100.0000, 'ºC'),
	(307378, 146, '2015-01-01 00:07:42.000000', 'temperatura', 807.0000, 'ºC'),
	(307379, 146, '2015-01-01 00:07:43.000000', 'temperatura', 133.0000, 'ºC'),
	(307380, 146, '2015-01-01 00:07:44.000000', 'temperatura', 647.0000, 'ºC'),
	(307381, 146, '2015-01-01 00:07:45.000000', 'temperatura', 435.0000, 'ºC'),
	(307382, 146, '2015-01-01 00:07:46.000000', 'temperatura', 233.0000, 'ºC'),
	(307383, 146, '2015-01-01 00:07:47.000000', 'temperatura', 1060.0000, 'ºC'),
	(307384, 146, '2015-01-01 00:07:48.000000', 'temperatura', 1002.0000, 'ºC'),
	(307385, 146, '2015-01-01 00:07:49.000000', 'temperatura', 630.0000, 'ºC'),
	(307386, 146, '2015-01-01 00:07:50.000000', 'temperatura', 143.0000, 'ºC'),
	(307387, 146, '2015-01-01 00:07:51.000000', 'temperatura', 28.0000, 'ºC'),
	(307388, 146, '2015-01-01 00:07:52.000000', 'temperatura', 909.0000, 'ºC'),
	(307389, 146, '2015-01-01 00:07:53.000000', 'temperatura', 862.0000, 'ºC'),
	(307390, 146, '2015-01-01 00:07:54.000000', 'temperatura', 385.0000, 'ºC'),
	(307391, 146, '2015-01-01 00:07:55.000000', 'temperatura', 541.0000, 'ºC'),
	(307392, 146, '2015-01-01 00:07:56.000000', 'temperatura', 347.0000, 'ºC'),
	(307393, 146, '2015-01-01 00:07:57.000000', 'temperatura', 113.0000, 'ºC'),
	(307394, 146, '2015-01-01 00:07:58.000000', 'temperatura', 726.0000, 'ºC'),
	(307395, 146, '2015-01-01 00:07:59.000000', 'temperatura', 893.0000, 'ºC'),
	(307396, 146, '2015-01-01 00:08:00.000000', 'temperatura', 1085.0000, 'ºC'),
	(307397, 146, '2015-01-01 00:08:01.000000', 'temperatura', 345.0000, 'ºC'),
	(307398, 146, '2015-01-01 00:08:02.000000', 'temperatura', 873.0000, 'ºC'),
	(307399, 146, '2015-01-01 00:08:03.000000', 'temperatura', 928.0000, 'ºC'),
	(307400, 146, '2015-01-01 00:08:04.000000', 'temperatura', 823.0000, 'ºC'),
	(307401, 146, '2015-01-01 00:08:05.000000', 'temperatura', 133.0000, 'ºC'),
	(307402, 146, '2015-01-01 00:08:06.000000', 'temperatura', 596.0000, 'ºC'),
	(307403, 146, '2015-01-01 00:08:07.000000', 'temperatura', 183.0000, 'ºC'),
	(307404, 146, '2015-01-01 00:08:08.000000', 'temperatura', 326.0000, 'ºC'),
	(307405, 146, '2015-01-01 00:08:09.000000', 'temperatura', 1080.0000, 'ºC'),
	(307406, 146, '2015-01-01 00:08:10.000000', 'temperatura', 824.0000, 'ºC'),
	(307407, 146, '2015-01-01 00:08:11.000000', 'temperatura', 880.0000, 'ºC'),
	(307408, 146, '2015-01-01 00:08:12.000000', 'temperatura', 728.0000, 'ºC'),
	(307409, 146, '2015-01-01 00:08:13.000000', 'temperatura', 1000.0000, 'ºC'),
	(307410, 146, '2015-01-01 00:08:14.000000', 'temperatura', 416.0000, 'ºC'),
	(307411, 146, '2015-01-01 00:08:15.000000', 'temperatura', 281.0000, 'ºC'),
	(307412, 146, '2015-01-01 00:08:16.000000', 'temperatura', 158.0000, 'ºC'),
	(307413, 146, '2015-01-01 00:08:17.000000', 'temperatura', 1146.0000, 'ºC'),
	(307414, 146, '2015-01-01 00:08:18.000000', 'temperatura', 458.0000, 'ºC'),
	(307415, 146, '2015-01-01 00:08:19.000000', 'temperatura', 53.0000, 'ºC'),
	(307416, 146, '2015-01-01 00:08:20.000000', 'temperatura', 93.0000, 'ºC'),
	(307417, 146, '2015-01-01 00:08:21.000000', 'temperatura', 305.0000, 'ºC'),
	(307418, 146, '2015-01-01 00:08:22.000000', 'temperatura', 46.0000, 'ºC'),
	(307419, 146, '2015-01-01 00:08:23.000000', 'temperatura', 517.0000, 'ºC'),
	(307420, 146, '2015-01-01 00:08:24.000000', 'temperatura', 46.0000, 'ºC'),
	(307421, 146, '2015-01-01 00:08:25.000000', 'temperatura', 1079.0000, 'ºC'),
	(307422, 146, '2015-01-01 00:08:26.000000', 'temperatura', 460.0000, 'ºC'),
	(307423, 146, '2015-01-01 00:08:27.000000', 'temperatura', 261.0000, 'ºC'),
	(307424, 146, '2015-01-01 00:08:28.000000', 'temperatura', 1126.0000, 'ºC'),
	(307425, 146, '2015-01-01 00:08:29.000000', 'temperatura', 49.0000, 'ºC'),
	(307426, 146, '2015-01-01 00:08:30.000000', 'temperatura', 468.0000, 'ºC'),
	(307427, 146, '2015-01-01 00:08:31.000000', 'temperatura', 991.0000, 'ºC'),
	(307428, 146, '2015-01-01 00:08:32.000000', 'temperatura', 1151.0000, 'ºC'),
	(307429, 146, '2015-01-01 00:08:33.000000', 'temperatura', 385.0000, 'ºC'),
	(307430, 146, '2015-01-01 00:08:34.000000', 'temperatura', 872.0000, 'ºC'),
	(307431, 146, '2015-01-01 00:08:35.000000', 'temperatura', 803.0000, 'ºC'),
	(307432, 146, '2015-01-01 00:08:36.000000', 'temperatura', 201.0000, 'ºC'),
	(307433, 146, '2015-01-01 00:08:37.000000', 'temperatura', 997.0000, 'ºC'),
	(307434, 146, '2015-01-01 00:08:38.000000', 'temperatura', 782.0000, 'ºC'),
	(307435, 146, '2015-01-01 00:08:39.000000', 'temperatura', 919.0000, 'ºC'),
	(307436, 146, '2015-01-01 00:08:40.000000', 'temperatura', 1052.0000, 'ºC'),
	(307437, 146, '2015-01-01 00:08:41.000000', 'temperatura', 102.0000, 'ºC'),
	(307438, 146, '2015-01-01 00:08:42.000000', 'temperatura', 953.0000, 'ºC'),
	(307439, 146, '2015-01-01 00:08:43.000000', 'temperatura', 862.0000, 'ºC'),
	(307440, 146, '2015-01-01 00:08:44.000000', 'temperatura', 249.0000, 'ºC'),
	(307441, 146, '2015-01-01 00:08:45.000000', 'temperatura', 1062.0000, 'ºC'),
	(307442, 146, '2015-01-01 00:08:46.000000', 'temperatura', 963.0000, 'ºC'),
	(307443, 146, '2015-01-01 00:08:47.000000', 'temperatura', 427.0000, 'ºC'),
	(307444, 146, '2015-01-01 00:08:48.000000', 'temperatura', 449.0000, 'ºC'),
	(307445, 146, '2015-01-01 00:08:49.000000', 'temperatura', 963.0000, 'ºC'),
	(307446, 146, '2015-01-01 00:08:50.000000', 'temperatura', 1068.0000, 'ºC'),
	(307447, 146, '2015-01-01 00:08:51.000000', 'temperatura', 54.0000, 'ºC'),
	(307448, 146, '2015-01-01 00:08:52.000000', 'temperatura', 666.0000, 'ºC'),
	(307449, 146, '2015-01-01 00:08:53.000000', 'temperatura', 766.0000, 'ºC'),
	(307450, 146, '2015-01-01 00:08:54.000000', 'temperatura', 635.0000, 'ºC'),
	(307451, 146, '2015-01-01 00:08:55.000000', 'temperatura', 876.0000, 'ºC'),
	(307452, 146, '2015-01-01 00:08:56.000000', 'temperatura', 77.0000, 'ºC'),
	(307453, 146, '2015-01-01 00:08:57.000000', 'temperatura', 156.0000, 'ºC'),
	(307454, 146, '2015-01-01 00:08:58.000000', 'temperatura', 551.0000, 'ºC'),
	(307455, 146, '2015-01-01 00:08:59.000000', 'temperatura', 1085.0000, 'ºC'),
	(307456, 146, '2015-01-01 00:09:00.000000', 'temperatura', 173.0000, 'ºC'),
	(307457, 146, '2015-01-01 00:09:01.000000', 'temperatura', 11.0000, 'ºC'),
	(307458, 146, '2015-01-01 00:09:02.000000', 'temperatura', 735.0000, 'ºC'),
	(307459, 146, '2015-01-01 00:09:03.000000', 'temperatura', 45.0000, 'ºC'),
	(307460, 146, '2015-01-01 00:09:04.000000', 'temperatura', 418.0000, 'ºC'),
	(307461, 146, '2015-01-01 00:09:05.000000', 'temperatura', 757.0000, 'ºC'),
	(307462, 146, '2015-01-01 00:09:06.000000', 'temperatura', 132.0000, 'ºC'),
	(307463, 146, '2015-01-01 00:09:07.000000', 'temperatura', 791.0000, 'ºC'),
	(307464, 146, '2015-01-01 00:09:08.000000', 'temperatura', 1157.0000, 'ºC'),
	(307465, 146, '2015-01-01 00:09:09.000000', 'temperatura', 1014.0000, 'ºC'),
	(307466, 146, '2015-01-01 00:09:10.000000', 'temperatura', 399.0000, 'ºC'),
	(307467, 146, '2015-01-01 00:09:11.000000', 'temperatura', 155.0000, 'ºC'),
	(307468, 146, '2015-01-01 00:09:12.000000', 'temperatura', 777.0000, 'ºC'),
	(307469, 146, '2015-01-01 00:09:13.000000', 'temperatura', 1022.0000, 'ºC'),
	(307470, 146, '2015-01-01 00:09:14.000000', 'temperatura', 380.0000, 'ºC'),
	(307471, 146, '2015-01-01 00:09:15.000000', 'temperatura', 35.0000, 'ºC'),
	(307472, 146, '2015-01-01 00:09:16.000000', 'temperatura', 234.0000, 'ºC'),
	(307473, 146, '2015-01-01 00:09:17.000000', 'temperatura', 1064.0000, 'ºC'),
	(307474, 146, '2015-01-01 00:09:18.000000', 'temperatura', 1019.0000, 'ºC'),
	(307475, 146, '2015-01-01 00:09:19.000000', 'temperatura', 706.0000, 'ºC'),
	(307476, 146, '2015-01-01 00:09:20.000000', 'temperatura', 471.0000, 'ºC'),
	(307477, 146, '2015-01-01 00:09:21.000000', 'temperatura', 239.0000, 'ºC'),
	(307478, 146, '2015-01-01 00:09:22.000000', 'temperatura', 982.0000, 'ºC'),
	(307479, 146, '2015-01-01 00:09:23.000000', 'temperatura', 595.0000, 'ºC'),
	(307480, 146, '2015-01-01 00:09:24.000000', 'temperatura', 27.0000, 'ºC'),
	(307481, 146, '2015-01-01 00:09:25.000000', 'temperatura', 752.0000, 'ºC'),
	(307482, 146, '2015-01-01 00:09:26.000000', 'temperatura', 78.0000, 'ºC'),
	(307483, 146, '2015-01-01 00:09:27.000000', 'temperatura', 536.0000, 'ºC'),
	(307484, 146, '2015-01-01 00:09:28.000000', 'temperatura', 45.0000, 'ºC'),
	(307485, 146, '2015-01-01 00:09:29.000000', 'temperatura', 1016.0000, 'ºC'),
	(307486, 146, '2015-01-01 00:09:30.000000', 'temperatura', 149.0000, 'ºC'),
	(307487, 146, '2015-01-01 00:09:31.000000', 'temperatura', 96.0000, 'ºC'),
	(307488, 146, '2015-01-01 00:09:32.000000', 'temperatura', 34.0000, 'ºC'),
	(307489, 146, '2015-01-01 00:09:33.000000', 'temperatura', 1084.0000, 'ºC'),
	(307490, 146, '2015-01-01 00:09:34.000000', 'temperatura', 518.0000, 'ºC'),
	(307491, 146, '2015-01-01 00:09:35.000000', 'temperatura', 540.0000, 'ºC'),
	(307492, 146, '2015-01-01 00:09:36.000000', 'temperatura', 1145.0000, 'ºC'),
	(307493, 146, '2015-01-01 00:09:37.000000', 'temperatura', 506.0000, 'ºC'),
	(307494, 146, '2015-01-01 00:09:38.000000', 'temperatura', 295.0000, 'ºC'),
	(307495, 146, '2015-01-01 00:09:39.000000', 'temperatura', 1156.0000, 'ºC'),
	(307496, 146, '2015-01-01 00:09:40.000000', 'temperatura', 97.0000, 'ºC'),
	(307497, 146, '2015-01-01 00:09:41.000000', 'temperatura', 618.0000, 'ºC'),
	(307498, 146, '2015-01-01 00:09:42.000000', 'temperatura', 398.0000, 'ºC'),
	(307499, 146, '2015-01-01 00:09:43.000000', 'temperatura', 137.0000, 'ºC'),
	(307500, 146, '2015-01-01 00:09:44.000000', 'temperatura', 692.0000, 'ºC'),
	(307501, 146, '2015-01-01 00:09:45.000000', 'temperatura', 648.0000, 'ºC'),
	(307502, 146, '2015-01-01 00:09:46.000000', 'temperatura', 1165.0000, 'ºC'),
	(307503, 146, '2015-01-01 00:09:47.000000', 'temperatura', 282.0000, 'ºC'),
	(307504, 146, '2015-01-01 00:09:48.000000', 'temperatura', 313.0000, 'ºC'),
	(307505, 146, '2015-01-01 00:09:49.000000', 'temperatura', 723.0000, 'ºC'),
	(307506, 146, '2015-01-01 00:09:50.000000', 'temperatura', 273.0000, 'ºC'),
	(307507, 146, '2015-01-01 00:09:51.000000', 'temperatura', 399.0000, 'ºC'),
	(307508, 146, '2015-01-01 00:09:52.000000', 'temperatura', 1174.0000, 'ºC'),
	(307509, 146, '2015-01-01 00:09:53.000000', 'temperatura', 1074.0000, 'ºC'),
	(307510, 146, '2015-01-01 00:09:54.000000', 'temperatura', 649.0000, 'ºC'),
	(307511, 146, '2015-01-01 00:09:55.000000', 'temperatura', 23.0000, 'ºC'),
	(307512, 146, '2015-01-01 00:09:56.000000', 'temperatura', 567.0000, 'ºC'),
	(307513, 146, '2015-01-01 00:09:57.000000', 'temperatura', 369.0000, 'ºC'),
	(307514, 146, '2015-01-01 00:09:58.000000', 'temperatura', 144.0000, 'ºC'),
	(307515, 146, '2015-01-01 00:09:59.000000', 'temperatura', 812.0000, 'ºC'),
	(307516, 146, '2015-01-01 00:10:00.000000', 'temperatura', 29.0000, 'ºC'),
	(307517, 146, '2015-01-01 00:10:01.000000', 'temperatura', 111.0000, 'ºC'),
	(307518, 146, '2015-01-01 00:10:02.000000', 'temperatura', 469.0000, 'ºC'),
	(307519, 146, '2015-01-01 00:10:03.000000', 'temperatura', 811.0000, 'ºC'),
	(307520, 146, '2015-01-01 00:10:04.000000', 'temperatura', 249.0000, 'ºC'),
	(307521, 146, '2015-01-01 00:10:05.000000', 'temperatura', 12.0000, 'ºC'),
	(307522, 146, '2015-01-01 00:10:06.000000', 'temperatura', 514.0000, 'ºC'),
	(307523, 146, '2015-01-01 00:10:07.000000', 'temperatura', 133.0000, 'ºC'),
	(307524, 146, '2015-01-01 00:10:08.000000', 'temperatura', 323.0000, 'ºC'),
	(307525, 146, '2015-01-01 00:10:09.000000', 'temperatura', 18.0000, 'ºC'),
	(307526, 146, '2015-01-01 00:10:10.000000', 'temperatura', 323.0000, 'ºC'),
	(307527, 146, '2015-01-01 00:10:11.000000', 'temperatura', 359.0000, 'ºC'),
	(307528, 146, '2015-01-01 00:10:12.000000', 'temperatura', 828.0000, 'ºC'),
	(307529, 146, '2015-01-01 00:10:13.000000', 'temperatura', 665.0000, 'ºC'),
	(307530, 146, '2015-01-01 00:10:14.000000', 'temperatura', 838.0000, 'ºC'),
	(307531, 146, '2015-01-01 00:10:15.000000', 'temperatura', 999.0000, 'ºC'),
	(307532, 146, '2015-01-01 00:10:16.000000', 'temperatura', 78.0000, 'ºC'),
	(307533, 146, '2015-01-01 00:10:17.000000', 'temperatura', 996.0000, 'ºC'),
	(307534, 146, '2015-01-01 00:10:18.000000', 'temperatura', 1148.0000, 'ºC'),
	(307535, 146, '2015-01-01 00:10:19.000000', 'temperatura', 349.0000, 'ºC'),
	(307536, 146, '2015-01-01 00:10:20.000000', 'temperatura', 705.0000, 'ºC'),
	(307537, 146, '2015-01-01 00:10:21.000000', 'temperatura', 75.0000, 'ºC'),
	(307538, 146, '2015-01-01 00:10:22.000000', 'temperatura', 663.0000, 'ºC'),
	(307539, 146, '2015-01-01 00:10:23.000000', 'temperatura', 688.0000, 'ºC'),
	(307540, 146, '2015-01-01 00:10:24.000000', 'temperatura', 253.0000, 'ºC'),
	(307541, 146, '2015-01-01 00:10:25.000000', 'temperatura', 403.0000, 'ºC'),
	(307542, 146, '2015-01-01 00:10:26.000000', 'temperatura', 57.0000, 'ºC'),
	(307543, 146, '2015-01-01 00:10:27.000000', 'temperatura', 274.0000, 'ºC'),
	(307544, 146, '2015-01-01 00:10:28.000000', 'temperatura', 2.0000, 'ºC'),
	(307545, 146, '2015-01-01 00:10:29.000000', 'temperatura', 386.0000, 'ºC'),
	(307546, 146, '2015-01-01 00:10:30.000000', 'temperatura', 724.0000, 'ºC'),
	(307547, 146, '2015-01-01 00:10:31.000000', 'temperatura', 62.0000, 'ºC'),
	(307548, 146, '2015-01-01 00:10:32.000000', 'temperatura', 539.0000, 'ºC'),
	(307549, 146, '2015-01-01 00:10:33.000000', 'temperatura', 111.0000, 'ºC'),
	(307550, 146, '2015-01-01 00:10:34.000000', 'temperatura', 136.0000, 'ºC'),
	(307551, 146, '2015-01-01 00:10:35.000000', 'temperatura', 349.0000, 'ºC'),
	(307552, 146, '2015-01-01 00:10:36.000000', 'temperatura', 138.0000, 'ºC'),
	(307553, 146, '2015-01-01 00:10:37.000000', 'temperatura', 842.0000, 'ºC'),
	(307554, 146, '2015-01-01 00:10:38.000000', 'temperatura', 196.0000, 'ºC'),
	(307555, 146, '2015-01-01 00:10:39.000000', 'temperatura', 856.0000, 'ºC'),
	(307556, 146, '2015-01-01 00:10:40.000000', 'temperatura', 92.0000, 'ºC'),
	(307557, 146, '2015-01-01 00:10:41.000000', 'temperatura', 293.0000, 'ºC'),
	(307558, 146, '2015-01-01 00:10:42.000000', 'temperatura', 1189.0000, 'ºC'),
	(307559, 146, '2015-01-01 00:10:43.000000', 'temperatura', 265.0000, 'ºC'),
	(307560, 146, '2015-01-01 00:10:44.000000', 'temperatura', 161.0000, 'ºC'),
	(307561, 146, '2015-01-01 00:10:45.000000', 'temperatura', 8.0000, 'ºC'),
	(307562, 146, '2015-01-01 00:10:46.000000', 'temperatura', 760.0000, 'ºC'),
	(307563, 146, '2015-01-01 00:10:47.000000', 'temperatura', 175.0000, 'ºC'),
	(307564, 146, '2015-01-01 00:10:48.000000', 'temperatura', 995.0000, 'ºC'),
	(307565, 146, '2015-01-01 00:10:49.000000', 'temperatura', 849.0000, 'ºC'),
	(307566, 146, '2015-01-01 00:10:50.000000', 'temperatura', 63.0000, 'ºC'),
	(307567, 146, '2015-01-01 00:10:51.000000', 'temperatura', 167.0000, 'ºC'),
	(307568, 146, '2015-01-01 00:10:52.000000', 'temperatura', 646.0000, 'ºC'),
	(307569, 146, '2015-01-01 00:10:53.000000', 'temperatura', 331.0000, 'ºC'),
	(307570, 146, '2015-01-01 00:10:54.000000', 'temperatura', 916.0000, 'ºC'),
	(307571, 146, '2015-01-01 00:10:55.000000', 'temperatura', 1187.0000, 'ºC'),
	(307572, 146, '2015-01-01 00:10:56.000000', 'temperatura', 789.0000, 'ºC'),
	(307573, 146, '2015-01-01 00:10:57.000000', 'temperatura', 385.0000, 'ºC'),
	(307574, 146, '2015-01-01 00:10:58.000000', 'temperatura', 757.0000, 'ºC'),
	(307575, 146, '2015-01-01 00:10:59.000000', 'temperatura', 232.0000, 'ºC'),
	(307576, 146, '2015-01-01 00:11:00.000000', 'temperatura', 90.0000, 'ºC'),
	(307577, 146, '2015-01-01 00:11:01.000000', 'temperatura', 953.0000, 'ºC'),
	(307578, 146, '2015-01-01 00:11:02.000000', 'temperatura', 895.0000, 'ºC'),
	(307579, 146, '2015-01-01 00:11:03.000000', 'temperatura', 418.0000, 'ºC'),
	(307580, 146, '2015-01-01 00:11:04.000000', 'temperatura', 604.0000, 'ºC'),
	(307581, 146, '2015-01-01 00:11:05.000000', 'temperatura', 568.0000, 'ºC'),
	(307582, 146, '2015-01-01 00:11:06.000000', 'temperatura', 1026.0000, 'ºC'),
	(307583, 146, '2015-01-01 00:11:07.000000', 'temperatura', 1027.0000, 'ºC'),
	(307584, 146, '2015-01-01 00:11:08.000000', 'temperatura', 858.0000, 'ºC'),
	(307585, 146, '2015-01-01 00:11:09.000000', 'temperatura', 8.0000, 'ºC'),
	(307586, 146, '2015-01-01 00:11:10.000000', 'temperatura', 1069.0000, 'ºC'),
	(307587, 146, '2015-01-01 00:11:11.000000', 'temperatura', 521.0000, 'ºC'),
	(307588, 146, '2015-01-01 00:11:12.000000', 'temperatura', 599.0000, 'ºC'),
	(307589, 146, '2015-01-01 00:11:13.000000', 'temperatura', 232.0000, 'ºC'),
	(307590, 146, '2015-01-01 00:11:14.000000', 'temperatura', 562.0000, 'ºC'),
	(307591, 146, '2015-01-01 00:11:15.000000', 'temperatura', 917.0000, 'ºC'),
	(307592, 146, '2015-01-01 00:11:16.000000', 'temperatura', 498.0000, 'ºC'),
	(307593, 146, '2015-01-01 00:11:17.000000', 'temperatura', 940.0000, 'ºC'),
	(307594, 146, '2015-01-01 00:11:18.000000', 'temperatura', 806.0000, 'ºC'),
	(307595, 146, '2015-01-01 00:11:19.000000', 'temperatura', 12.0000, 'ºC'),
	(307596, 146, '2015-01-01 00:11:20.000000', 'temperatura', 41.0000, 'ºC'),
	(307597, 146, '2015-01-01 00:11:21.000000', 'temperatura', 172.0000, 'ºC'),
	(307598, 146, '2015-01-01 00:11:22.000000', 'temperatura', 736.0000, 'ºC'),
	(307599, 146, '2015-01-01 00:11:23.000000', 'temperatura', 767.0000, 'ºC'),
	(307600, 146, '2015-01-01 00:11:24.000000', 'temperatura', 424.0000, 'ºC'),
	(307601, 146, '2015-01-01 00:11:25.000000', 'temperatura', 1020.0000, 'ºC'),
	(307602, 146, '2015-01-01 00:11:26.000000', 'temperatura', 231.0000, 'ºC'),
	(307603, 146, '2015-01-01 00:11:27.000000', 'temperatura', 495.0000, 'ºC'),
	(307604, 146, '2015-01-01 00:11:28.000000', 'temperatura', 580.0000, 'ºC'),
	(307605, 146, '2015-01-01 00:11:29.000000', 'temperatura', 218.0000, 'ºC'),
	(307606, 146, '2015-01-01 00:11:30.000000', 'temperatura', 549.0000, 'ºC'),
	(307607, 146, '2015-01-01 00:11:31.000000', 'temperatura', 893.0000, 'ºC'),
	(307608, 146, '2015-01-01 00:11:32.000000', 'temperatura', 416.0000, 'ºC'),
	(307609, 146, '2015-01-01 00:11:33.000000', 'temperatura', 603.0000, 'ºC'),
	(307610, 146, '2015-01-01 00:11:34.000000', 'temperatura', 567.0000, 'ºC'),
	(307611, 146, '2015-01-01 00:11:35.000000', 'temperatura', 1028.0000, 'ºC'),
	(307612, 146, '2015-01-01 00:11:36.000000', 'temperatura', 1037.0000, 'ºC'),
	(307613, 146, '2015-01-01 00:11:37.000000', 'temperatura', 905.0000, 'ºC'),
	(307614, 146, '2015-01-01 00:11:38.000000', 'temperatura', 212.0000, 'ºC'),
	(307615, 146, '2015-01-01 00:11:39.000000', 'temperatura', 744.0000, 'ºC'),
	(307616, 146, '2015-01-01 00:11:40.000000', 'temperatura', 686.0000, 'ºC'),
	(307617, 146, '2015-01-01 00:11:41.000000', 'temperatura', 1199.0000, 'ºC'),
	(307618, 146, '2015-01-01 00:11:42.000000', 'temperatura', 337.0000, 'ºC'),
	(307619, 146, '2015-01-01 00:11:43.000000', 'temperatura', 488.0000, 'ºC'),
	(307620, 146, '2015-01-01 00:11:44.000000', 'temperatura', 230.0000, 'ºC'),
	(307621, 146, '2015-01-01 00:11:45.000000', 'temperatura', 887.0000, 'ºC'),
	(307622, 146, '2015-01-01 00:11:46.000000', 'temperatura', 145.0000, 'ºC'),
	(307623, 146, '2015-01-01 00:11:47.000000', 'temperatura', 466.0000, 'ºC'),
	(307624, 146, '2015-01-01 00:11:48.000000', 'temperatura', 696.0000, 'ºC'),
	(307625, 146, '2015-01-01 00:11:49.000000', 'temperatura', 883.0000, 'ºC'),
	(307626, 146, '2015-01-01 00:11:50.000000', 'temperatura', 1127.0000, 'ºC'),
	(307627, 146, '2015-01-01 00:11:51.000000', 'temperatura', 587.0000, 'ºC'),
	(307628, 146, '2015-01-01 00:11:52.000000', 'temperatura', 754.0000, 'ºC'),
	(307629, 146, '2015-01-01 00:11:53.000000', 'temperatura', 810.0000, 'ºC'),
	(307630, 146, '2015-01-01 00:11:54.000000', 'temperatura', 588.0000, 'ºC'),
	(307631, 146, '2015-01-01 00:11:55.000000', 'temperatura', 511.0000, 'ºC'),
	(307632, 146, '2015-01-01 00:11:56.000000', 'temperatura', 791.0000, 'ºC'),
	(307633, 146, '2015-01-01 00:11:57.000000', 'temperatura', 23.0000, 'ºC'),
	(307634, 146, '2015-01-01 00:11:58.000000', 'temperatura', 141.0000, 'ºC'),
	(307635, 146, '2015-01-01 00:11:59.000000', 'temperatura', 639.0000, 'ºC'),
	(307636, 146, '2015-01-01 00:12:00.000000', 'temperatura', 373.0000, 'ºC'),
	(307637, 146, '2015-01-01 00:12:01.000000', 'temperatura', 1146.0000, 'ºC'),
	(307638, 146, '2015-01-01 00:12:02.000000', 'temperatura', 1014.0000, 'ºC'),
	(307639, 146, '2015-01-01 00:12:03.000000', 'temperatura', 429.0000, 'ºC'),
	(307640, 146, '2015-01-01 00:12:04.000000', 'temperatura', 307.0000, 'ºC'),
	(307641, 146, '2015-01-01 00:12:05.000000', 'temperatura', 246.0000, 'ºC'),
	(307642, 146, '2015-01-01 00:12:06.000000', 'temperatura', 310.0000, 'ºC'),
	(307643, 146, '2015-01-01 00:12:07.000000', 'temperatura', 813.0000, 'ºC'),
	(307644, 146, '2015-01-01 00:12:08.000000', 'temperatura', 737.0000, 'ºC'),
	(307645, 146, '2015-01-01 00:12:09.000000', 'temperatura', 47.0000, 'ºC'),
	(307646, 146, '2015-01-01 00:12:10.000000', 'temperatura', 421.0000, 'ºC'),
	(307647, 146, '2015-01-01 00:12:11.000000', 'temperatura', 768.0000, 'ºC'),
	(307648, 146, '2015-01-01 00:12:12.000000', 'temperatura', 175.0000, 'ºC'),
	(307649, 146, '2015-01-01 00:12:13.000000', 'temperatura', 973.0000, 'ºC'),
	(307650, 146, '2015-01-01 00:12:14.000000', 'temperatura', 742.0000, 'ºC'),
	(307651, 146, '2015-01-01 00:12:15.000000', 'temperatura', 790.0000, 'ºC'),
	(307652, 146, '2015-01-01 00:12:16.000000', 'temperatura', 524.0000, 'ºC'),
	(307653, 146, '2015-01-01 00:12:17.000000', 'temperatura', 252.0000, 'ºC'),
	(307654, 146, '2015-01-01 00:12:18.000000', 'temperatura', 888.0000, 'ºC'),
	(307655, 146, '2015-01-01 00:12:19.000000', 'temperatura', 85.0000, 'ºC'),
	(307656, 146, '2015-01-01 00:12:20.000000', 'temperatura', 161.0000, 'ºC'),
	(307657, 146, '2015-01-01 00:12:21.000000', 'temperatura', 551.0000, 'ºC'),
	(307658, 146, '2015-01-01 00:12:22.000000', 'temperatura', 1073.0000, 'ºC'),
	(307659, 146, '2015-01-01 00:12:23.000000', 'temperatura', 112.0000, 'ºC'),
	(307660, 146, '2015-01-01 00:12:24.000000', 'temperatura', 943.0000, 'ºC'),
	(307661, 146, '2015-01-01 00:12:25.000000', 'temperatura', 777.0000, 'ºC'),
	(307662, 146, '2015-01-01 00:12:26.000000', 'temperatura', 1056.0000, 'ºC'),
	(307663, 146, '2015-01-01 00:12:27.000000', 'temperatura', 552.0000, 'ºC'),
	(307664, 146, '2015-01-01 00:12:28.000000', 'temperatura', 791.0000, 'ºC'),
	(307665, 146, '2015-01-01 00:12:29.000000', 'temperatura', 1098.0000, 'ºC'),
	(307666, 146, '2015-01-01 00:12:30.000000', 'temperatura', 720.0000, 'ºC'),
	(307667, 146, '2015-01-01 00:12:31.000000', 'temperatura', 306.0000, 'ºC'),
	(307668, 146, '2015-01-01 00:12:32.000000', 'temperatura', 571.0000, 'ºC'),
	(307669, 146, '2015-01-01 00:12:33.000000', 'temperatura', 738.0000, 'ºC'),
	(307670, 146, '2015-01-01 00:12:34.000000', 'temperatura', 775.0000, 'ºC'),
	(307671, 146, '2015-01-01 00:12:35.000000', 'temperatura', 463.0000, 'ºC'),
	(307672, 146, '2015-01-01 00:12:36.000000', 'temperatura', 1191.0000, 'ºC'),
	(307673, 146, '2015-01-01 00:12:37.000000', 'temperatura', 967.0000, 'ºC'),
	(307674, 146, '2015-01-01 00:12:38.000000', 'temperatura', 62.0000, 'ºC'),
	(307675, 146, '2015-01-01 00:12:39.000000', 'temperatura', 1008.0000, 'ºC'),
	(307676, 146, '2015-01-01 00:12:40.000000', 'temperatura', 55.0000, 'ºC'),
	(307677, 146, '2015-01-01 00:12:41.000000', 'temperatura', 850.0000, 'ºC'),
	(307678, 146, '2015-01-01 00:12:42.000000', 'temperatura', 487.0000, 'ºC'),
	(307679, 146, '2015-01-01 00:12:43.000000', 'temperatura', 1085.0000, 'ºC'),
	(307680, 146, '2015-01-01 00:12:44.000000', 'temperatura', 364.0000, 'ºC'),
	(307681, 146, '2015-01-01 00:12:45.000000', 'temperatura', 965.0000, 'ºC'),
	(307682, 146, '2015-01-01 00:12:46.000000', 'temperatura', 136.0000, 'ºC'),
	(307683, 146, '2015-01-01 00:12:47.000000', 'temperatura', 182.0000, 'ºC'),
	(307684, 146, '2015-01-01 00:12:48.000000', 'temperatura', 505.0000, 'ºC'),
	(307685, 146, '2015-01-01 00:12:49.000000', 'temperatura', 778.0000, 'ºC'),
	(307686, 146, '2015-01-01 00:12:50.000000', 'temperatura', 1176.0000, 'ºC'),
	(307687, 146, '2015-01-01 00:12:51.000000', 'temperatura', 1146.0000, 'ºC'),
	(307688, 146, '2015-01-01 00:12:52.000000', 'temperatura', 1002.0000, 'ºC'),
	(307689, 146, '2015-01-01 00:12:53.000000', 'temperatura', 374.0000, 'ºC'),
	(307690, 146, '2015-01-01 00:12:54.000000', 'temperatura', 64.0000, 'ºC'),
	(307691, 146, '2015-01-01 00:12:55.000000', 'temperatura', 398.0000, 'ºC'),
	(307692, 146, '2015-01-01 00:12:56.000000', 'temperatura', 599.0000, 'ºC'),
	(307693, 146, '2015-01-01 00:12:57.000000', 'temperatura', 600.0000, 'ºC'),
	(307694, 146, '2015-01-01 00:12:58.000000', 'temperatura', 2.0000, 'ºC'),
	(307695, 146, '2015-01-01 00:12:59.000000', 'temperatura', 614.0000, 'ºC'),
	(307696, 146, '2015-01-01 00:13:00.000000', 'temperatura', 663.0000, 'ºC'),
	(307697, 146, '2015-01-01 00:13:01.000000', 'temperatura', 272.0000, 'ºC'),
	(307698, 146, '2015-01-01 00:13:02.000000', 'temperatura', 575.0000, 'ºC'),
	(307699, 146, '2015-01-01 00:13:03.000000', 'temperatura', 856.0000, 'ºC'),
	(307700, 146, '2015-01-01 00:13:04.000000', 'temperatura', 156.0000, 'ºC'),
	(307701, 146, '2015-01-01 00:13:05.000000', 'temperatura', 612.0000, 'ºC'),
	(307702, 146, '2015-01-01 00:13:06.000000', 'temperatura', 194.0000, 'ºC'),
	(307703, 146, '2015-01-01 00:13:07.000000', 'temperatura', 333.0000, 'ºC'),
	(307704, 146, '2015-01-01 00:13:08.000000', 'temperatura', 1085.0000, 'ºC'),
	(307705, 146, '2015-01-01 00:13:09.000000', 'temperatura', 825.0000, 'ºC'),
	(307706, 146, '2015-01-01 00:13:10.000000', 'temperatura', 872.0000, 'ºC'),
	(307707, 146, '2015-01-01 00:13:11.000000', 'temperatura', 683.0000, 'ºC'),
	(307708, 146, '2015-01-01 00:13:12.000000', 'temperatura', 801.0000, 'ºC'),
	(307709, 146, '2015-01-01 00:13:13.000000', 'temperatura', 757.0000, 'ºC'),
	(307710, 146, '2015-01-01 00:13:14.000000', 'temperatura', 182.0000, 'ºC'),
	(307711, 146, '2015-01-01 00:13:15.000000', 'temperatura', 1040.0000, 'ºC'),
	(307712, 146, '2015-01-01 00:13:16.000000', 'temperatura', 1052.0000, 'ºC'),
	(307713, 146, '2015-01-01 00:13:17.000000', 'temperatura', 943.0000, 'ºC'),
	(307714, 146, '2015-01-01 00:13:18.000000', 'temperatura', 360.0000, 'ºC'),
	(307715, 146, '2015-01-01 00:13:19.000000', 'temperatura', 171.0000, 'ºC'),
	(307716, 146, '2015-01-01 00:13:20.000000', 'temperatura', 975.0000, 'ºC'),
	(307717, 146, '2015-01-01 00:13:21.000000', 'temperatura', 762.0000, 'ºC'),
	(307718, 146, '2015-01-01 00:13:22.000000', 'temperatura', 887.0000, 'ºC'),
	(307719, 146, '2015-01-01 00:13:23.000000', 'temperatura', 951.0000, 'ºC'),
	(307720, 146, '2015-01-01 00:13:24.000000', 'temperatura', 893.0000, 'ºC'),
	(307721, 146, '2015-01-01 00:13:25.000000', 'temperatura', 411.0000, 'ºC'),
	(307722, 146, '2015-01-01 00:13:26.000000', 'temperatura', 576.0000, 'ºC'),
	(307723, 146, '2015-01-01 00:13:27.000000', 'temperatura', 450.0000, 'ºC'),
	(307724, 146, '2015-01-01 00:13:28.000000', 'temperatura', 523.0000, 'ºC'),
	(307725, 146, '2015-01-01 00:13:29.000000', 'temperatura', 66.0000, 'ºC'),
	(307726, 146, '2015-01-01 00:13:30.000000', 'temperatura', 1161.0000, 'ºC'),
	(307727, 146, '2015-01-01 00:13:31.000000', 'temperatura', 807.0000, 'ºC'),
	(307728, 146, '2015-01-01 00:13:32.000000', 'temperatura', 552.0000, 'ºC'),
	(307729, 146, '2015-01-01 00:13:33.000000', 'temperatura', 340.0000, 'ºC'),
	(307730, 146, '2015-01-01 00:13:34.000000', 'temperatura', 46.0000, 'ºC'),
	(307731, 146, '2015-01-01 00:13:35.000000', 'temperatura', 411.0000, 'ºC'),
	(307732, 146, '2015-01-01 00:13:36.000000', 'temperatura', 717.0000, 'ºC'),
	(307733, 146, '2015-01-01 00:13:37.000000', 'temperatura', 1151.0000, 'ºC'),
	(307734, 146, '2015-01-01 00:13:38.000000', 'temperatura', 6.0000, 'ºC'),
	(307735, 146, '2015-01-01 00:13:39.000000', 'temperatura', 179.0000, 'ºC'),
	(307736, 146, '2015-01-01 00:13:40.000000', 'temperatura', 876.0000, 'ºC'),
	(307737, 146, '2015-01-01 00:13:41.000000', 'temperatura', 245.0000, 'ºC'),
	(307738, 146, '2015-01-01 00:13:42.000000', 'temperatura', 997.0000, 'ºC'),
	(307739, 146, '2015-01-01 00:13:43.000000', 'temperatura', 649.0000, 'ºC'),
	(307740, 146, '2015-01-01 00:13:44.000000', 'temperatura', 257.0000, 'ºC'),
	(307741, 146, '2015-01-01 00:13:45.000000', 'temperatura', 538.0000, 'ºC'),
	(307742, 146, '2015-01-01 00:13:46.000000', 'temperatura', 720.0000, 'ºC'),
	(307743, 146, '2015-01-01 00:13:47.000000', 'temperatura', 786.0000, 'ºC'),
	(307744, 146, '2015-01-01 00:13:48.000000', 'temperatura', 571.0000, 'ºC'),
	(307745, 146, '2015-01-01 00:13:49.000000', 'temperatura', 499.0000, 'ºC'),
	(307746, 146, '2015-01-01 00:13:50.000000', 'temperatura', 782.0000, 'ºC'),
	(307747, 146, '2015-01-01 00:13:51.000000', 'temperatura', 11.0000, 'ºC'),
	(307748, 146, '2015-01-01 00:13:52.000000', 'temperatura', 112.0000, 'ºC'),
	(307749, 146, '2015-01-01 00:13:53.000000', 'temperatura', 528.0000, 'ºC'),
	(307750, 146, '2015-01-01 00:13:54.000000', 'temperatura', 1103.0000, 'ºC'),
	(307751, 146, '2015-01-01 00:13:55.000000', 'temperatura', 333.0000, 'ºC'),
	(307752, 146, '2015-01-01 00:13:56.000000', 'temperatura', 757.0000, 'ºC'),
	(307753, 146, '2015-01-01 00:13:57.000000', 'temperatura', 385.0000, 'ºC'),
	(307754, 146, '2015-01-01 00:13:58.000000', 'temperatura', 856.0000, 'ºC'),
	(307755, 146, '2015-01-01 00:13:59.000000', 'temperatura', 724.0000, 'ºC'),
	(307756, 146, '2015-01-01 00:14:00.000000', 'temperatura', 1053.0000, 'ºC'),
	(307757, 146, '2015-01-01 00:14:01.000000', 'temperatura', 696.0000, 'ºC'),
	(307758, 146, '2015-01-01 00:14:02.000000', 'temperatura', 318.0000, 'ºC'),
	(307759, 146, '2015-01-01 00:14:03.000000', 'temperatura', 704.0000, 'ºC'),
	(307760, 146, '2015-01-01 00:14:04.000000', 'temperatura', 164.0000, 'ºC'),
	(307761, 146, '2015-01-01 00:14:05.000000', 'temperatura', 1111.0000, 'ºC'),
	(307762, 146, '2015-01-01 00:14:06.000000', 'temperatura', 265.0000, 'ºC'),
	(307763, 146, '2015-01-01 00:14:07.000000', 'temperatura', 390.0000, 'ºC'),
	(307764, 146, '2015-01-01 00:14:08.000000', 'temperatura', 1155.0000, 'ºC'),
	(307765, 146, '2015-01-01 00:14:09.000000', 'temperatura', 1004.0000, 'ºC'),
	(307766, 146, '2015-01-01 00:14:10.000000', 'temperatura', 359.0000, 'ºC'),
	(307767, 146, '2015-01-01 00:14:11.000000', 'temperatura', 1182.0000, 'ºC'),
	(307768, 146, '2015-01-01 00:14:12.000000', 'temperatura', 35.0000, 'ºC'),
	(307769, 146, '2015-01-01 00:14:13.000000', 'temperatura', 228.0000, 'ºC'),
	(307770, 146, '2015-01-01 00:14:14.000000', 'temperatura', 1035.0000, 'ºC'),
	(307771, 146, '2015-01-01 00:14:15.000000', 'temperatura', 891.0000, 'ºC'),
	(307772, 146, '2015-01-01 00:14:16.000000', 'temperatura', 152.0000, 'ºC'),
	(307773, 146, '2015-01-01 00:14:17.000000', 'temperatura', 488.0000, 'ºC'),
	(307774, 146, '2015-01-01 00:14:18.000000', 'temperatura', 783.0000, 'ºC'),
	(307775, 146, '2015-01-01 00:14:19.000000', 'temperatura', 52.0000, 'ºC'),
	(307776, 146, '2015-01-01 00:14:20.000000', 'temperatura', 310.0000, 'ºC'),
	(307777, 146, '2015-01-01 00:14:21.000000', 'temperatura', 195.0000, 'ºC'),
	(307778, 146, '2015-01-01 00:14:22.000000', 'temperatura', 47.0000, 'ºC'),
	(307779, 146, '2015-01-01 00:14:23.000000', 'temperatura', 848.0000, 'ºC'),
	(307780, 146, '2015-01-01 00:14:24.000000', 'temperatura', 501.0000, 'ºC'),
	(307781, 146, '2015-01-01 00:14:25.000000', 'temperatura', 1163.0000, 'ºC'),
	(307782, 146, '2015-01-01 00:14:26.000000', 'temperatura', 709.0000, 'ºC'),
	(307783, 146, '2015-01-01 00:14:27.000000', 'temperatura', 60.0000, 'ºC'),
	(307784, 146, '2015-01-01 00:14:28.000000', 'temperatura', 572.0000, 'ºC'),
	(307785, 146, '2015-01-01 00:14:29.000000', 'temperatura', 280.0000, 'ºC'),
	(307786, 146, '2015-01-01 00:14:30.000000', 'temperatura', 885.0000, 'ºC'),
	(307787, 146, '2015-01-01 00:14:31.000000', 'temperatura', 1184.0000, 'ºC'),
	(307788, 146, '2015-01-01 00:14:32.000000', 'temperatura', 867.0000, 'ºC'),
	(307789, 146, '2015-01-01 00:14:33.000000', 'temperatura', 785.0000, 'ºC'),
	(307790, 146, '2015-01-01 00:14:34.000000', 'temperatura', 122.0000, 'ºC'),
	(307791, 146, '2015-01-01 00:14:35.000000', 'temperatura', 655.0000, 'ºC'),
	(307792, 146, '2015-01-01 00:14:36.000000', 'temperatura', 512.0000, 'ºC'),
	(307793, 146, '2015-01-01 00:14:37.000000', 'temperatura', 596.0000, 'ºC'),
	(307794, 146, '2015-01-01 00:14:38.000000', 'temperatura', 243.0000, 'ºC'),
	(307795, 146, '2015-01-01 00:14:39.000000', 'temperatura', 626.0000, 'ºC'),
	(307796, 146, '2015-01-01 00:14:40.000000', 'temperatura', 4.0000, 'ºC'),
	(307797, 146, '2015-01-01 00:14:41.000000', 'temperatura', 541.0000, 'ºC'),
	(307798, 146, '2015-01-01 00:14:42.000000', 'temperatura', 296.0000, 'ºC'),
	(307799, 146, '2015-01-01 00:14:43.000000', 'temperatura', 1056.0000, 'ºC'),
	(307800, 146, '2015-01-01 00:14:44.000000', 'temperatura', 792.0000, 'ºC'),
	(307801, 146, '2015-01-01 00:14:45.000000', 'temperatura', 794.0000, 'ºC'),
	(307802, 146, '2015-01-01 00:14:46.000000', 'temperatura', 394.0000, 'ºC'),
	(307803, 146, '2015-01-01 00:14:47.000000', 'temperatura', 786.0000, 'ºC'),
	(307804, 146, '2015-01-01 00:14:48.000000', 'temperatura', 352.0000, 'ºC'),
	(307805, 146, '2015-01-01 00:14:49.000000', 'temperatura', 602.0000, 'ºC'),
	(307806, 146, '2015-01-01 00:14:50.000000', 'temperatura', 752.0000, 'ºC'),
	(307807, 146, '2015-01-01 00:14:51.000000', 'temperatura', 756.0000, 'ºC'),
	(307808, 146, '2015-01-01 00:14:52.000000', 'temperatura', 326.0000, 'ºC'),
	(307809, 146, '2015-01-01 00:14:53.000000', 'temperatura', 560.0000, 'ºC'),
	(307810, 146, '2015-01-01 00:14:54.000000', 'temperatura', 626.0000, 'ºC'),
	(307811, 146, '2015-01-01 00:14:55.000000', 'temperatura', 247.0000, 'ºC'),
	(307812, 146, '2015-01-01 00:14:56.000000', 'temperatura', 558.0000, 'ºC'),
	(307813, 146, '2015-01-01 00:14:57.000000', 'temperatura', 851.0000, 'ºC'),
	(307814, 146, '2015-01-01 00:14:58.000000', 'temperatura', 183.0000, 'ºC'),
	(307815, 146, '2015-01-01 00:14:59.000000', 'temperatura', 760.0000, 'ºC'),
	(307816, 146, '2015-01-01 00:15:00.000000', 'temperatura', 853.0000, 'ºC'),
	(307817, 146, '2015-01-01 00:15:01.000000', 'temperatura', 784.0000, 'ºC'),
	(307818, 146, '2015-01-01 00:15:02.000000', 'temperatura', 161.0000, 'ºC'),
	(307819, 146, '2015-01-01 00:15:03.000000', 'temperatura', 853.0000, 'ºC'),
	(307820, 146, '2015-01-01 00:15:04.000000', 'temperatura', 185.0000, 'ºC'),
	(307821, 146, '2015-01-01 00:15:05.000000', 'temperatura', 766.0000, 'ºC'),
	(307822, 146, '2015-01-01 00:15:06.000000', 'temperatura', 876.0000, 'ºC'),
	(307823, 146, '2015-01-01 00:15:07.000000', 'temperatura', 880.0000, 'ºC'),
	(307824, 146, '2015-01-01 00:15:08.000000', 'temperatura', 575.0000, 'ºC'),
	(307825, 146, '2015-01-01 00:15:09.000000', 'temperatura', 236.0000, 'ºC'),
	(307826, 146, '2015-01-01 00:15:10.000000', 'temperatura', 656.0000, 'ºC'),
	(307827, 146, '2015-01-01 00:15:11.000000', 'temperatura', 172.0000, 'ºC'),
	(307828, 146, '2015-01-01 00:15:12.000000', 'temperatura', 91.0000, 'ºC'),
	(307829, 146, '2015-01-01 00:15:13.000000', 'temperatura', 1140.0000, 'ºC'),
	(307830, 146, '2015-01-01 00:15:14.000000', 'temperatura', 630.0000, 'ºC'),
	(307831, 146, '2015-01-01 00:15:15.000000', 'temperatura', 927.0000, 'ºC'),
	(307832, 146, '2015-01-01 00:15:16.000000', 'temperatura', 349.0000, 'ºC'),
	(307833, 146, '2015-01-01 00:15:17.000000', 'temperatura', 162.0000, 'ºC'),
	(307834, 146, '2015-01-01 00:15:18.000000', 'temperatura', 963.0000, 'ºC'),
	(307835, 146, '2015-01-01 00:15:19.000000', 'temperatura', 730.0000, 'ºC'),
	(307836, 146, '2015-01-01 00:15:20.000000', 'temperatura', 762.0000, 'ºC'),
	(307837, 146, '2015-01-01 00:15:21.000000', 'temperatura', 421.0000, 'ºC'),
	(307838, 146, '2015-01-01 00:15:22.000000', 'temperatura', 1020.0000, 'ºC'),
	(307839, 146, '2015-01-01 00:15:23.000000', 'temperatura', 237.0000, 'ºC'),
	(307840, 146, '2015-01-01 00:15:24.000000', 'temperatura', 526.0000, 'ºC'),
	(307841, 146, '2015-01-01 00:15:25.000000', 'temperatura', 720.0000, 'ºC'),
	(307842, 146, '2015-01-01 00:15:26.000000', 'temperatura', 823.0000, 'ºC'),
	(307843, 146, '2015-01-01 00:15:27.000000', 'temperatura', 754.0000, 'ºC'),
	(307844, 146, '2015-01-01 00:15:28.000000', 'temperatura', 100.0000, 'ºC'),
	(307845, 146, '2015-01-01 00:15:29.000000', 'temperatura', 640.0000, 'ºC'),
	(307846, 146, '2015-01-01 00:15:30.000000', 'temperatura', 499.0000, 'ºC'),
	(307847, 146, '2015-01-01 00:15:31.000000', 'temperatura', 574.0000, 'ºC'),
	(307848, 146, '2015-01-01 00:15:32.000000', 'temperatura', 177.0000, 'ºC'),
	(307849, 146, '2015-01-01 00:15:33.000000', 'temperatura', 361.0000, 'ºC'),
	(307850, 146, '2015-01-01 00:15:34.000000', 'temperatura', 75.0000, 'ºC'),
	(307851, 146, '2015-01-01 00:15:35.000000', 'temperatura', 494.0000, 'ºC'),
	(307852, 146, '2015-01-01 00:15:36.000000', 'temperatura', 1047.0000, 'ºC'),
	(307853, 146, '2015-01-01 00:15:37.000000', 'temperatura', 150.0000, 'ºC'),
	(307854, 146, '2015-01-01 00:15:38.000000', 'temperatura', 12.0000, 'ºC'),
	(307855, 146, '2015-01-01 00:15:39.000000', 'temperatura', 808.0000, 'ºC'),
	(307856, 146, '2015-01-01 00:15:40.000000', 'temperatura', 405.0000, 'ºC'),
	(307857, 146, '2015-01-01 00:15:41.000000', 'temperatura', 803.0000, 'ºC'),
	(307858, 146, '2015-01-01 00:15:42.000000', 'temperatura', 399.0000, 'ºC'),
	(307859, 146, '2015-01-01 00:15:43.000000', 'temperatura', 787.0000, 'ºC'),
	(307860, 146, '2015-01-01 00:15:44.000000', 'temperatura', 340.0000, 'ºC'),
	(307861, 146, '2015-01-01 00:15:45.000000', 'temperatura', 538.0000, 'ºC'),
	(307862, 146, '2015-01-01 00:15:46.000000', 'temperatura', 470.0000, 'ºC'),
	(307863, 146, '2015-01-01 00:15:47.000000', 'temperatura', 736.0000, 'ºC'),
	(307864, 146, '2015-01-01 00:15:48.000000', 'temperatura', 1072.0000, 'ºC'),
	(307865, 146, '2015-01-01 00:15:49.000000', 'temperatura', 754.0000, 'ºC'),
	(307866, 146, '2015-01-01 00:15:50.000000', 'temperatura', 551.0000, 'ºC'),
	(307867, 146, '2015-01-01 00:15:51.000000', 'temperatura', 496.0000, 'ºC'),
	(307868, 146, '2015-01-01 00:15:52.000000', 'temperatura', 827.0000, 'ºC'),
	(307869, 146, '2015-01-01 00:15:53.000000', 'temperatura', 249.0000, 'ºC'),
	(307870, 146, '2015-01-01 00:15:54.000000', 'temperatura', 1163.0000, 'ºC'),
	(307871, 146, '2015-01-01 00:15:55.000000', 'temperatura', 270.0000, 'ºC'),
	(307872, 146, '2015-01-01 00:15:56.000000', 'temperatura', 259.0000, 'ºC'),
	(307873, 146, '2015-01-01 00:15:57.000000', 'temperatura', 487.0000, 'ºC'),
	(307874, 146, '2015-01-01 00:15:58.000000', 'temperatura', 458.0000, 'ºC'),
	(307875, 146, '2015-01-01 00:15:59.000000', 'temperatura', 831.0000, 'ºC'),
	(307876, 146, '2015-01-01 00:16:00.000000', 'temperatura', 382.0000, 'ºC'),
	(307877, 146, '2015-01-01 00:16:01.000000', 'temperatura', 616.0000, 'ºC'),
	(307878, 146, '2015-01-01 00:16:02.000000', 'temperatura', 735.0000, 'ºC'),
	(307879, 146, '2015-01-01 00:16:03.000000', 'temperatura', 628.0000, 'ºC'),
	(307880, 146, '2015-01-01 00:16:04.000000', 'temperatura', 935.0000, 'ºC'),
	(307881, 146, '2015-01-01 00:16:05.000000', 'temperatura', 393.0000, 'ºC'),
	(307882, 146, '2015-01-01 00:16:06.000000', 'temperatura', 359.0000, 'ºC'),
	(307883, 146, '2015-01-01 00:16:07.000000', 'temperatura', 616.0000, 'ºC'),
	(307884, 146, '2015-01-01 00:16:08.000000', 'temperatura', 805.0000, 'ºC'),
	(307885, 146, '2015-01-01 00:16:09.000000', 'temperatura', 975.0000, 'ºC'),
	(307886, 146, '2015-01-01 00:16:10.000000', 'temperatura', 62.0000, 'ºC'),
	(307887, 146, '2015-01-01 00:16:11.000000', 'temperatura', 983.0000, 'ºC'),
	(307888, 146, '2015-01-01 00:16:12.000000', 'temperatura', 1133.0000, 'ºC'),
	(307889, 146, '2015-01-01 00:16:13.000000', 'temperatura', 314.0000, 'ºC'),
	(307890, 146, '2015-01-01 00:16:14.000000', 'temperatura', 571.0000, 'ºC'),
	(307891, 146, '2015-01-01 00:16:15.000000', 'temperatura', 713.0000, 'ºC'),
	(307892, 146, '2015-01-01 00:16:16.000000', 'temperatura', 652.0000, 'ºC'),
	(307893, 146, '2015-01-01 00:16:17.000000', 'temperatura', 1122.0000, 'ºC'),
	(307894, 146, '2015-01-01 00:16:18.000000', 'temperatura', 56.0000, 'ºC'),
	(307895, 146, '2015-01-01 00:16:19.000000', 'temperatura', 515.0000, 'ºC'),
	(307896, 146, '2015-01-01 00:16:20.000000', 'temperatura', 6.0000, 'ºC'),
	(307897, 146, '2015-01-01 00:16:21.000000', 'temperatura', 886.0000, 'ºC'),
	(307898, 146, '2015-01-01 00:16:22.000000', 'temperatura', 812.0000, 'ºC'),
	(307899, 146, '2015-01-01 00:16:23.000000', 'temperatura', 203.0000, 'ºC'),
	(307900, 146, '2015-01-01 00:16:24.000000', 'temperatura', 981.0000, 'ºC'),
	(307901, 146, '2015-01-01 00:16:25.000000', 'temperatura', 696.0000, 'ºC'),
	(307902, 146, '2015-01-01 00:16:26.000000', 'temperatura', 539.0000, 'ºC'),
	(307903, 146, '2015-01-01 00:16:27.000000', 'temperatura', 606.0000, 'ºC'),
	(307904, 146, '2015-01-01 00:16:28.000000', 'temperatura', 214.0000, 'ºC'),
	(307905, 146, '2015-01-01 00:16:29.000000', 'temperatura', 453.0000, 'ºC'),
	(307906, 146, '2015-01-01 00:16:30.000000', 'temperatura', 424.0000, 'ºC'),
	(307907, 146, '2015-01-01 00:16:31.000000', 'temperatura', 762.0000, 'ºC'),
	(307908, 146, '2015-01-01 00:16:32.000000', 'temperatura', 138.0000, 'ºC'),
	(307909, 146, '2015-01-01 00:16:33.000000', 'temperatura', 803.0000, 'ºC'),
	(307910, 146, '2015-01-01 00:16:34.000000', 'temperatura', 2.0000, 'ºC'),
	(307911, 146, '2015-01-01 00:16:35.000000', 'temperatura', 0.0000, 'ºC'),
	(307912, 146, '2015-01-01 00:16:36.000000', 'temperatura', 1195.0000, 'ºC'),
	(307913, 146, '2015-01-01 00:16:37.000000', 'temperatura', 1177.0000, 'ºC'),
	(307914, 146, '2015-01-01 00:16:38.000000', 'temperatura', 1099.0000, 'ºC'),
	(307915, 146, '2015-01-01 00:16:39.000000', 'temperatura', 766.0000, 'ºC'),
	(307916, 146, '2015-01-01 00:16:40.000000', 'temperatura', 532.0000, 'ºC'),
	(307917, 146, '2015-01-01 00:16:41.000000', 'temperatura', 364.0000, 'ºC'),
	(307918, 146, '2015-01-01 00:16:42.000000', 'temperatura', 224.0000, 'ºC'),
	(307919, 146, '2015-01-01 00:16:43.000000', 'temperatura', 30.0000, 'ºC'),
	(307920, 146, '2015-01-01 00:16:44.000000', 'temperatura', 676.0000, 'ºC'),
	(307921, 146, '2015-01-01 00:16:45.000000', 'temperatura', 892.0000, 'ºC'),
	(307922, 146, '2015-01-01 00:16:46.000000', 'temperatura', 30.0000, 'ºC'),
	(307923, 146, '2015-01-01 00:16:47.000000', 'temperatura', 1078.0000, 'ºC'),
	(307924, 146, '2015-01-01 00:16:48.000000', 'temperatura', 499.0000, 'ºC'),
	(307925, 146, '2015-01-01 00:16:49.000000', 'temperatura', 460.0000, 'ºC'),
	(307926, 146, '2015-01-01 00:16:50.000000', 'temperatura', 806.0000, 'ºC'),
	(307927, 146, '2015-01-01 00:16:51.000000', 'temperatura', 251.0000, 'ºC'),
	(307928, 146, '2015-01-01 00:16:52.000000', 'temperatura', 38.0000, 'ºC'),
	(307929, 146, '2015-01-01 00:16:53.000000', 'temperatura', 638.0000, 'ºC'),
	(307930, 146, '2015-01-01 00:16:54.000000', 'temperatura', 676.0000, 'ºC'),
	(307931, 146, '2015-01-01 00:16:55.000000', 'temperatura', 267.0000, 'ºC'),
	(307932, 146, '2015-01-01 00:16:56.000000', 'temperatura', 509.0000, 'ºC'),
	(307933, 146, '2015-01-01 00:16:57.000000', 'temperatura', 543.0000, 'ºC'),
	(307934, 146, '2015-01-01 00:16:58.000000', 'temperatura', 1187.0000, 'ºC'),
	(307935, 146, '2015-01-01 00:16:59.000000', 'temperatura', 706.0000, 'ºC'),
	(307936, 146, '2015-01-01 00:17:00.000000', 'temperatura', 1171.0000, 'ºC'),
	(307937, 146, '2015-01-01 00:17:01.000000', 'temperatura', 137.0000, 'ºC'),
	(307938, 146, '2015-01-01 00:17:02.000000', 'temperatura', 772.0000, 'ºC'),
	(307939, 146, '2015-01-01 00:17:03.000000', 'temperatura', 1052.0000, 'ºC'),
	(307940, 146, '2015-01-01 00:17:04.000000', 'temperatura', 542.0000, 'ºC'),
	(307941, 146, '2015-01-01 00:17:05.000000', 'temperatura', 754.0000, 'ºC'),
	(307942, 146, '2015-01-01 00:17:06.000000', 'temperatura', 947.0000, 'ºC'),
	(307943, 146, '2015-01-01 00:17:07.000000', 'temperatura', 72.0000, 'ºC'),
	(307944, 146, '2015-01-01 00:17:08.000000', 'temperatura', 1118.0000, 'ºC'),
	(307945, 146, '2015-01-01 00:17:09.000000', 'temperatura', 578.0000, 'ºC'),
	(307946, 146, '2015-01-01 00:17:10.000000', 'temperatura', 734.0000, 'ºC'),
	(307947, 146, '2015-01-01 00:17:11.000000', 'temperatura', 737.0000, 'ºC'),
	(307948, 146, '2015-01-01 00:17:12.000000', 'temperatura', 285.0000, 'ºC'),
	(307949, 146, '2015-01-01 00:17:13.000000', 'temperatura', 412.0000, 'ºC'),
	(307950, 146, '2015-01-01 00:17:14.000000', 'temperatura', 4.0000, 'ºC'),
	(307951, 146, '2015-01-01 00:17:15.000000', 'temperatura', 1188.0000, 'ºC'),
	(307952, 146, '2015-01-01 00:17:16.000000', 'temperatura', 1128.0000, 'ºC'),
	(307953, 146, '2015-01-01 00:17:17.000000', 'temperatura', 877.0000, 'ºC'),
	(307954, 146, '2015-01-01 00:17:18.000000', 'temperatura', 1000.0000, 'ºC'),
	(307955, 146, '2015-01-01 00:17:19.000000', 'temperatura', 1168.0000, 'ºC'),
	(307956, 146, '2015-01-01 00:17:20.000000', 'temperatura', 442.0000, 'ºC'),
	(307957, 146, '2015-01-01 00:17:21.000000', 'temperatura', 1107.0000, 'ºC'),
	(307958, 146, '2015-01-01 00:17:22.000000', 'temperatura', 609.0000, 'ºC'),
	(307959, 146, '2015-01-01 00:17:23.000000', 'temperatura', 925.0000, 'ºC'),
	(307960, 146, '2015-01-01 00:17:24.000000', 'temperatura', 400.0000, 'ºC'),
	(307961, 146, '2015-01-01 00:17:25.000000', 'temperatura', 425.0000, 'ºC'),
	(307962, 146, '2015-01-01 00:17:26.000000', 'temperatura', 924.0000, 'ºC'),
	(307963, 146, '2015-01-01 00:17:27.000000', 'temperatura', 947.0000, 'ºC'),
	(307964, 146, '2015-01-01 00:17:28.000000', 'temperatura', 761.0000, 'ºC'),
	(307965, 146, '2015-01-01 00:17:29.000000', 'temperatura', 966.0000, 'ºC'),
	(307966, 146, '2015-01-01 00:17:30.000000', 'temperatura', 147.0000, 'ºC'),
	(307967, 146, '2015-01-01 00:17:31.000000', 'temperatura', 239.0000, 'ºC'),
	(307968, 146, '2015-01-01 00:17:32.000000', 'temperatura', 752.0000, 'ºC'),
	(307969, 146, '2015-01-01 00:17:33.000000', 'temperatura', 646.0000, 'ºC'),
	(307970, 146, '2015-01-01 00:17:34.000000', 'temperatura', 972.0000, 'ºC'),
	(307971, 146, '2015-01-01 00:17:35.000000', 'temperatura', 522.0000, 'ºC'),
	(307972, 146, '2015-01-01 00:17:36.000000', 'temperatura', 895.0000, 'ºC'),
	(307973, 146, '2015-01-01 00:17:37.000000', 'temperatura', 509.0000, 'ºC'),
	(307974, 146, '2015-01-01 00:17:38.000000', 'temperatura', 1059.0000, 'ºC'),
	(307975, 146, '2015-01-01 00:17:39.000000', 'temperatura', 171.0000, 'ºC'),
	(307976, 146, '2015-01-01 00:17:40.000000', 'temperatura', 80.0000, 'ºC'),
	(307977, 146, '2015-01-01 00:17:41.000000', 'temperatura', 1084.0000, 'ºC'),
	(307978, 146, '2015-01-01 00:17:42.000000', 'temperatura', 384.0000, 'ºC'),
	(307979, 146, '2015-01-01 00:17:43.000000', 'temperatura', 1066.0000, 'ºC'),
	(307980, 146, '2015-01-01 00:17:44.000000', 'temperatura', 580.0000, 'ºC'),
	(307981, 146, '2015-01-01 00:17:45.000000', 'temperatura', 901.0000, 'ºC'),
	(307982, 146, '2015-01-01 00:17:46.000000', 'temperatura', 365.0000, 'ºC'),
	(307983, 146, '2015-01-01 00:17:47.000000', 'temperatura', 322.0000, 'ºC'),
	(307984, 146, '2015-01-01 00:17:48.000000', 'temperatura', 515.0000, 'ºC'),
	(307985, 146, '2015-01-01 00:17:49.000000', 'temperatura', 410.0000, 'ºC'),
	(307986, 146, '2015-01-01 00:17:50.000000', 'temperatura', 506.0000, 'ºC'),
	(307987, 146, '2015-01-01 00:17:51.000000', 'temperatura', 101.0000, 'ºC'),
	(307988, 146, '2015-01-01 00:17:52.000000', 'temperatura', 186.0000, 'ºC'),
	(307989, 146, '2015-01-01 00:17:53.000000', 'temperatura', 630.0000, 'ºC'),
	(307990, 146, '2015-01-01 00:17:54.000000', 'temperatura', 190.0000, 'ºC'),
	(307991, 146, '2015-01-01 00:17:55.000000', 'temperatura', 262.0000, 'ºC'),
	(307992, 146, '2015-01-01 00:17:56.000000', 'temperatura', 740.0000, 'ºC'),
	(307993, 146, '2015-01-01 00:17:57.000000', 'temperatura', 515.0000, 'ºC'),
	(307994, 146, '2015-01-01 00:17:58.000000', 'temperatura', 354.0000, 'ºC'),
	(307995, 146, '2015-01-01 00:17:59.000000', 'temperatura', 228.0000, 'ºC'),
	(307996, 146, '2015-01-01 00:18:00.000000', 'temperatura', 76.0000, 'ºC'),
	(307997, 146, '2015-01-01 00:18:01.000000', 'temperatura', 896.0000, 'ºC'),
	(307998, 146, '2015-01-01 00:18:02.000000', 'temperatura', 653.0000, 'ºC'),
	(307999, 146, '2015-01-01 00:18:03.000000', 'temperatura', 576.0000, 'ºC'),
	(308000, 146, '2015-01-01 00:18:04.000000', 'temperatura', 924.0000, 'ºC'),
	(308001, 146, '2015-01-01 00:18:05.000000', 'temperatura', 492.0000, 'ºC'),
	(308002, 146, '2015-01-01 00:18:06.000000', 'temperatura', 887.0000, 'ºC'),
	(308003, 146, '2015-01-01 00:18:07.000000', 'temperatura', 560.0000, 'ºC'),
	(308004, 146, '2015-01-01 00:18:08.000000', 'temperatura', 138.0000, 'ºC'),
	(308005, 146, '2015-01-01 00:18:09.000000', 'temperatura', 213.0000, 'ºC'),
	(308006, 146, '2015-01-01 00:18:10.000000', 'temperatura', 651.0000, 'ºC'),
	(308007, 146, '2015-01-01 00:18:11.000000', 'temperatura', 215.0000, 'ºC'),
	(308008, 146, '2015-01-01 00:18:12.000000', 'temperatura', 325.0000, 'ºC'),
	(308009, 146, '2015-01-01 00:18:13.000000', 'temperatura', 981.0000, 'ºC'),
	(308010, 146, '2015-01-01 00:18:14.000000', 'temperatura', 330.0000, 'ºC'),
	(308011, 146, '2015-01-01 00:18:15.000000', 'temperatura', 1108.0000, 'ºC'),
	(308012, 146, '2015-01-01 00:18:16.000000', 'temperatura', 952.0000, 'ºC'),
	(308013, 146, '2015-01-01 00:18:17.000000', 'temperatura', 234.0000, 'ºC'),
	(308014, 146, '2015-01-01 00:18:18.000000', 'temperatura', 714.0000, 'ºC'),
	(308015, 146, '2015-01-01 00:18:19.000000', 'temperatura', 471.0000, 'ºC'),
	(308016, 146, '2015-01-01 00:18:20.000000', 'temperatura', 212.0000, 'ºC'),
	(308017, 146, '2015-01-01 00:18:21.000000', 'temperatura', 848.0000, 'ºC'),
	(308018, 146, '2015-01-01 00:18:22.000000', 'temperatura', 5.0000, 'ºC'),
	(308019, 146, '2015-01-01 00:18:23.000000', 'temperatura', 1080.0000, 'ºC'),
	(308020, 146, '2015-01-01 00:18:24.000000', 'temperatura', 587.0000, 'ºC'),
	(308021, 146, '2015-01-01 00:18:25.000000', 'temperatura', 896.0000, 'ºC'),
	(308022, 146, '2015-01-01 00:18:26.000000', 'temperatura', 318.0000, 'ºC'),
	(308023, 146, '2015-01-01 00:18:27.000000', 'temperatura', 105.0000, 'ºC'),
	(308024, 146, '2015-01-01 00:18:28.000000', 'temperatura', 771.0000, 'ºC'),
	(308025, 146, '2015-01-01 00:18:29.000000', 'temperatura', 1138.0000, 'ºC'),
	(308026, 146, '2015-01-01 00:18:30.000000', 'temperatura', 981.0000, 'ºC'),
	(308027, 146, '2015-01-01 00:18:31.000000', 'temperatura', 290.0000, 'ºC'),
	(308028, 146, '2015-01-01 00:18:32.000000', 'temperatura', 907.0000, 'ºC'),
	(308029, 146, '2015-01-01 00:18:33.000000', 'temperatura', 64.0000, 'ºC'),
	(308030, 146, '2015-01-01 00:18:34.000000', 'temperatura', 0.0000, 'ºC'),
	(308031, 146, '2015-01-01 00:18:35.000000', 'temperatura', 1008.0000, 'ºC'),
	(308032, 146, '2015-01-01 00:18:36.000000', 'temperatura', 240.0000, 'ºC'),
	(308033, 146, '2015-01-01 00:18:37.000000', 'temperatura', 579.0000, 'ºC'),
	(308034, 146, '2015-01-01 00:18:38.000000', 'temperatura', 975.0000, 'ºC'),
	(308035, 146, '2015-01-01 00:18:39.000000', 'temperatura', 740.0000, 'ºC'),
	(308036, 146, '2015-01-01 00:18:40.000000', 'temperatura', 773.0000, 'ºC'),
	(308037, 146, '2015-01-01 00:18:41.000000', 'temperatura', 445.0000, 'ºC'),
	(308038, 146, '2015-01-01 00:18:42.000000', 'temperatura', 1108.0000, 'ºC'),
	(308039, 146, '2015-01-01 00:18:43.000000', 'temperatura', 606.0000, 'ºC'),
	(308040, 146, '2015-01-01 00:18:44.000000', 'temperatura', 905.0000, 'ºC'),
	(308041, 146, '2015-01-01 00:18:45.000000', 'temperatura', 307.0000, 'ºC'),
	(308042, 146, '2015-01-01 00:18:46.000000', 'temperatura', 23.0000, 'ºC'),
	(308043, 146, '2015-01-01 00:18:47.000000', 'temperatura', 395.0000, 'ºC'),
	(308044, 146, '2015-01-01 00:18:48.000000', 'temperatura', 704.0000, 'ºC'),
	(308045, 146, '2015-01-01 00:18:49.000000', 'temperatura', 1135.0000, 'ºC'),
	(308046, 146, '2015-01-01 00:18:50.000000', 'temperatura', 1164.0000, 'ºC'),
	(308047, 146, '2015-01-01 00:18:51.000000', 'temperatura', 16.0000, 'ºC'),
	(308048, 146, '2015-01-01 00:18:52.000000', 'temperatura', 189.0000, 'ºC'),
	(308049, 146, '2015-01-01 00:18:53.000000', 'temperatura', 898.0000, 'ºC'),
	(308050, 146, '2015-01-01 00:18:54.000000', 'temperatura', 322.0000, 'ºC'),
	(308051, 146, '2015-01-01 00:18:55.000000', 'temperatura', 117.0000, 'ºC'),
	(308052, 146, '2015-01-01 00:18:56.000000', 'temperatura', 820.0000, 'ºC'),
	(308053, 146, '2015-01-01 00:18:57.000000', 'temperatura', 151.0000, 'ºC'),
	(308054, 146, '2015-01-01 00:18:58.000000', 'temperatura', 693.0000, 'ºC'),
	(308055, 146, '2015-01-01 00:18:59.000000', 'temperatura', 613.0000, 'ºC'),
	(308056, 146, '2015-01-01 00:19:00.000000', 'temperatura', 987.0000, 'ºC'),
	(308057, 146, '2015-01-01 00:19:01.000000', 'temperatura', 698.0000, 'ºC'),
	(308058, 146, '2015-01-01 00:19:02.000000', 'temperatura', 527.0000, 'ºC'),
	(308059, 146, '2015-01-01 00:19:03.000000', 'temperatura', 543.0000, 'ºC'),
	(308060, 146, '2015-01-01 00:19:04.000000', 'temperatura', 1135.0000, 'ºC'),
	(308061, 146, '2015-01-01 00:19:05.000000', 'temperatura', 446.0000, 'ºC'),
	(308062, 146, '2015-01-01 00:19:06.000000', 'temperatura', 23.0000, 'ºC'),
	(308063, 146, '2015-01-01 00:19:07.000000', 'temperatura', 1181.0000, 'ºC'),
	(308064, 146, '2015-01-01 00:19:08.000000', 'temperatura', 1035.0000, 'ºC'),
	(308065, 146, '2015-01-01 00:19:09.000000', 'temperatura', 433.0000, 'ºC'),
	(308066, 146, '2015-01-01 00:19:10.000000', 'temperatura', 261.0000, 'ºC'),
	(308067, 146, '2015-01-01 00:19:11.000000', 'temperatura', 7.0000, 'ºC'),
	(308068, 146, '2015-01-01 00:19:12.000000', 'temperatura', 451.0000, 'ºC'),
	(308069, 146, '2015-01-01 00:19:13.000000', 'temperatura', 1037.0000, 'ºC'),
	(308070, 146, '2015-01-01 00:19:14.000000', 'temperatura', 231.0000, 'ºC'),
	(308071, 146, '2015-01-01 00:19:15.000000', 'temperatura', 446.0000, 'ºC'),
	(308072, 146, '2015-01-01 00:19:16.000000', 'temperatura', 337.0000, 'ºC'),
	(308073, 146, '2015-01-01 00:19:17.000000', 'temperatura', 349.0000, 'ºC'),
	(308074, 146, '2015-01-01 00:19:18.000000', 'temperatura', 731.0000, 'ºC'),
	(308075, 146, '2015-01-01 00:19:19.000000', 'temperatura', 211.0000, 'ºC'),
	(308076, 146, '2015-01-01 00:19:20.000000', 'temperatura', 62.0000, 'ºC'),
	(308077, 146, '2015-01-01 00:19:21.000000', 'temperatura', 879.0000, 'ºC'),
	(308078, 146, '2015-01-01 00:19:22.000000', 'temperatura', 608.0000, 'ºC'),
	(308079, 146, '2015-01-01 00:19:23.000000', 'temperatura', 405.0000, 'ºC'),
	(308080, 146, '2015-01-01 00:19:24.000000', 'temperatura', 202.0000, 'ºC'),
	(308081, 146, '2015-01-01 00:19:25.000000', 'temperatura', 995.0000, 'ºC'),
	(308082, 146, '2015-01-01 00:19:26.000000', 'temperatura', 770.0000, 'ºC'),
	(308083, 146, '2015-01-01 00:19:27.000000', 'temperatura', 864.0000, 'ºC'),
	(308084, 146, '2015-01-01 00:19:28.000000', 'temperatura', 809.0000, 'ºC'),
	(308085, 146, '2015-01-01 00:19:29.000000', 'temperatura', 256.0000, 'ºC'),
	(308086, 146, '2015-01-01 00:19:30.000000', 'temperatura', 54.0000, 'ºC'),
	(308087, 146, '2015-01-01 00:19:31.000000', 'temperatura', 700.0000, 'ºC'),
	(308088, 146, '2015-01-01 00:19:32.000000', 'temperatura', 941.0000, 'ºC'),
	(308089, 146, '2015-01-01 00:19:33.000000', 'temperatura', 205.0000, 'ºC'),
	(308090, 146, '2015-01-01 00:19:34.000000', 'temperatura', 602.0000, 'ºC'),
	(308091, 146, '2015-01-01 00:19:35.000000', 'temperatura', 1197.0000, 'ºC'),
	(308092, 146, '2015-01-01 00:19:36.000000', 'temperatura', 581.0000, 'ºC'),
	(308093, 146, '2015-01-01 00:19:37.000000', 'temperatura', 511.0000, 'ºC'),
	(308094, 146, '2015-01-01 00:19:38.000000', 'temperatura', 814.0000, 'ºC'),
	(308095, 146, '2015-01-01 00:19:39.000000', 'temperatura', 136.0000, 'ºC'),
	(308096, 146, '2015-01-01 00:19:40.000000', 'temperatura', 639.0000, 'ºC'),
	(308097, 146, '2015-01-01 00:19:41.000000', 'temperatura', 387.0000, 'ºC'),
	(308098, 146, '2015-01-01 00:19:42.000000', 'temperatura', 17.0000, 'ºC'),
	(308099, 146, '2015-01-01 00:19:43.000000', 'temperatura', 128.0000, 'ºC'),
	(308100, 146, '2015-01-01 00:19:44.000000', 'temperatura', 586.0000, 'ºC'),
	(308101, 146, '2015-01-01 00:19:45.000000', 'temperatura', 149.0000, 'ºC'),
	(308102, 146, '2015-01-01 00:19:46.000000', 'temperatura', 188.0000, 'ºC'),
	(308103, 146, '2015-01-01 00:19:47.000000', 'temperatura', 494.0000, 'ºC'),
	(308104, 146, '2015-01-01 00:19:48.000000', 'temperatura', 704.0000, 'ºC'),
	(308105, 146, '2015-01-01 00:19:49.000000', 'temperatura', 839.0000, 'ºC'),
	(308106, 146, '2015-01-01 00:19:50.000000', 'temperatura', 882.0000, 'ºC'),
	(308107, 146, '2015-01-01 00:19:51.000000', 'temperatura', 695.0000, 'ºC'),
	(308108, 146, '2015-01-01 00:19:52.000000', 'temperatura', 831.0000, 'ºC'),
	(308109, 146, '2015-01-01 00:19:53.000000', 'temperatura', 870.0000, 'ºC'),
	(308110, 146, '2015-01-01 00:19:54.000000', 'temperatura', 656.0000, 'ºC'),
	(308111, 146, '2015-01-01 00:19:55.000000', 'temperatura', 670.0000, 'ºC'),
	(308112, 146, '2015-01-01 00:19:56.000000', 'temperatura', 182.0000, 'ºC'),
	(308113, 146, '2015-01-01 00:19:57.000000', 'temperatura', 103.0000, 'ºC'),
	(308114, 146, '2015-01-01 00:19:58.000000', 'temperatura', 1170.0000, 'ºC'),
	(308115, 146, '2015-01-01 00:19:59.000000', 'temperatura', 743.0000, 'ºC'),
	(308116, 146, '2015-01-01 00:20:00.000000', 'temperatura', 202.0000, 'ºC'),
	(308117, 146, '2015-01-01 00:20:01.000000', 'temperatura', 1181.0000, 'ºC'),
	(308118, 146, '2015-01-01 00:20:02.000000', 'temperatura', 500.0000, 'ºC'),
	(308119, 146, '2015-01-01 00:20:03.000000', 'temperatura', 157.0000, 'ºC'),
	(308120, 146, '2015-01-01 00:20:04.000000', 'temperatura', 487.0000, 'ºC'),
	(308121, 146, '2015-01-01 00:20:05.000000', 'temperatura', 765.0000, 'ºC'),
	(308122, 146, '2015-01-01 00:20:06.000000', 'temperatura', 1165.0000, 'ºC'),
	(308123, 146, '2015-01-01 00:20:07.000000', 'temperatura', 1131.0000, 'ºC'),
	(308124, 146, '2015-01-01 00:20:08.000000', 'temperatura', 958.0000, 'ºC'),
	(308125, 146, '2015-01-01 00:20:09.000000', 'temperatura', 198.0000, 'ºC'),
	(308126, 146, '2015-01-01 00:20:10.000000', 'temperatura', 517.0000, 'ºC'),
	(308127, 146, '2015-01-01 00:20:11.000000', 'temperatura', 790.0000, 'ºC'),
	(308128, 146, '2015-01-01 00:20:12.000000', 'temperatura', 1199.0000, 'ºC'),
	(308129, 146, '2015-01-01 00:20:13.000000', 'temperatura', 28.0000, 'ºC'),
	(308130, 146, '2015-01-01 00:20:14.000000', 'temperatura', 140.0000, 'ºC'),
	(308131, 146, '2015-01-01 00:20:15.000000', 'temperatura', 620.0000, 'ºC'),
	(308132, 146, '2015-01-01 00:20:16.000000', 'temperatura', 280.0000, 'ºC'),
	(308133, 146, '2015-01-01 00:20:17.000000', 'temperatura', 738.0000, 'ºC'),
	(308134, 146, '2015-01-01 00:20:18.000000', 'temperatura', 454.0000, 'ºC'),
	(308135, 146, '2015-01-01 00:20:19.000000', 'temperatura', 53.0000, 'ºC'),
	(308136, 146, '2015-01-01 00:20:20.000000', 'temperatura', 107.0000, 'ºC'),
	(308137, 146, '2015-01-01 00:20:21.000000', 'temperatura', 375.0000, 'ºC'),
	(308138, 146, '2015-01-01 00:20:22.000000', 'temperatura', 353.0000, 'ºC'),
	(308139, 146, '2015-01-01 00:20:23.000000', 'temperatura', 641.0000, 'ºC'),
	(308140, 146, '2015-01-01 00:20:24.000000', 'temperatura', 945.0000, 'ºC'),
	(308141, 146, '2015-01-01 00:20:25.000000', 'temperatura', 404.0000, 'ºC'),
	(308142, 146, '2015-01-01 00:20:26.000000', 'temperatura', 384.0000, 'ºC'),
	(308143, 146, '2015-01-01 00:20:27.000000', 'temperatura', 709.0000, 'ºC'),
	(308144, 146, '2015-01-01 00:20:28.000000', 'temperatura', 1194.0000, 'ºC'),
	(308145, 146, '2015-01-01 00:20:29.000000', 'temperatura', 243.0000, 'ºC'),
	(308146, 146, '2015-01-01 00:20:30.000000', 'temperatura', 33.0000, 'ºC'),
	(308147, 146, '2015-01-01 00:20:31.000000', 'temperatura', 639.0000, 'ºC'),
	(308148, 146, '2015-01-01 00:20:32.000000', 'temperatura', 695.0000, 'ºC'),
	(308149, 146, '2015-01-01 00:20:33.000000', 'temperatura', 357.0000, 'ºC'),
	(308150, 146, '2015-01-01 00:20:34.000000', 'temperatura', 904.0000, 'ºC'),
	(308151, 146, '2015-01-01 00:20:35.000000', 'temperatura', 1047.0000, 'ºC'),
	(308152, 146, '2015-01-01 00:20:36.000000', 'temperatura', 123.0000, 'ºC'),
	(308153, 146, '2015-01-01 00:20:37.000000', 'temperatura', 1075.0000, 'ºC'),
	(308154, 146, '2015-01-01 00:20:38.000000', 'temperatura', 209.0000, 'ºC'),
	(308155, 146, '2015-01-01 00:20:39.000000', 'temperatura', 217.0000, 'ºC'),
	(308156, 146, '2015-01-01 00:20:40.000000', 'temperatura', 461.0000, 'ºC'),
	(308157, 146, '2015-01-01 00:20:41.000000', 'temperatura', 454.0000, 'ºC'),
	(308158, 146, '2015-01-01 00:20:42.000000', 'temperatura', 885.0000, 'ºC'),
	(308159, 146, '2015-01-01 00:20:43.000000', 'temperatura', 667.0000, 'ºC'),
	(308160, 146, '2015-01-01 00:20:44.000000', 'temperatura', 678.0000, 'ºC'),
	(308161, 146, '2015-01-01 00:20:45.000000', 'temperatura', 188.0000, 'ºC'),
	(308162, 146, '2015-01-01 00:20:46.000000', 'temperatura', 110.0000, 'ºC'),
	(308163, 146, '2015-01-01 00:20:47.000000', 'temperatura', 1186.0000, 'ºC'),
	(308164, 146, '2015-01-01 00:20:48.000000', 'temperatura', 800.0000, 'ºC'),
	(308165, 146, '2015-01-01 00:20:49.000000', 'temperatura', 441.0000, 'ºC'),
	(308166, 146, '2015-01-01 00:20:50.000000', 'temperatura', 1004.0000, 'ºC'),
	(308167, 146, '2015-01-01 00:20:51.000000', 'temperatura', 101.0000, 'ºC'),
	(308168, 146, '2015-01-01 00:20:52.000000', 'temperatura', 1093.0000, 'ºC'),
	(308169, 146, '2015-01-01 00:20:53.000000', 'temperatura', 364.0000, 'ºC'),
	(308170, 146, '2015-01-01 00:20:54.000000', 'temperatura', 938.0000, 'ºC'),
	(308171, 146, '2015-01-01 00:20:55.000000', 'temperatura', 1.0000, 'ºC'),
	(308172, 146, '2015-01-01 00:20:56.000000', 'temperatura', 793.0000, 'ºC'),
	(308173, 146, '2015-01-01 00:20:57.000000', 'temperatura', 359.0000, 'ºC'),
	(308174, 146, '2015-01-01 00:20:58.000000', 'temperatura', 618.0000, 'ºC'),
	(308175, 146, '2015-01-01 00:20:59.000000', 'temperatura', 813.0000, 'ºC'),
	(308176, 146, '2015-01-01 00:21:00.000000', 'temperatura', 1011.0000, 'ºC'),
	(308177, 146, '2015-01-01 00:21:01.000000', 'temperatura', 219.0000, 'ºC'),
	(308178, 146, '2015-01-01 00:21:02.000000', 'temperatura', 462.0000, 'ºC'),
	(308179, 146, '2015-01-01 00:21:03.000000', 'temperatura', 452.0000, 'ºC'),
	(308180, 146, '2015-01-01 00:21:04.000000', 'temperatura', 875.0000, 'ºC'),
	(308181, 146, '2015-01-01 00:21:05.000000', 'temperatura', 620.0000, 'ºC'),
	(308182, 146, '2015-01-01 00:21:06.000000', 'temperatura', 474.0000, 'ºC'),
	(308183, 146, '2015-01-01 00:21:07.000000', 'temperatura', 513.0000, 'ºC'),
	(308184, 146, '2015-01-01 00:21:08.000000', 'temperatura', 1143.0000, 'ºC'),
	(308185, 146, '2015-01-01 00:21:09.000000', 'temperatura', 577.0000, 'ºC'),
	(308186, 146, '2015-01-01 00:21:10.000000', 'temperatura', 657.0000, 'ºC'),
	(308187, 146, '2015-01-01 00:21:11.000000', 'temperatura', 356.0000, 'ºC'),
	(308188, 146, '2015-01-01 00:21:12.000000', 'temperatura', 1006.0000, 'ºC'),
	(308189, 146, '2015-01-01 00:21:13.000000', 'temperatura', 364.0000, 'ºC'),
	(308190, 146, '2015-01-01 00:21:14.000000', 'temperatura', 3.0000, 'ºC'),
	(308191, 146, '2015-01-01 00:21:15.000000', 'temperatura', 125.0000, 'ºC'),
	(308192, 146, '2015-01-01 00:21:16.000000', 'temperatura', 613.0000, 'ºC'),
	(308193, 146, '2015-01-01 00:21:17.000000', 'temperatura', 293.0000, 'ºC'),
	(308194, 146, '2015-01-01 00:21:18.000000', 'temperatura', 827.0000, 'ºC'),
	(308195, 146, '2015-01-01 00:21:19.000000', 'temperatura', 856.0000, 'ºC'),
	(308196, 146, '2015-01-01 00:21:20.000000', 'temperatura', 598.0000, 'ºC'),
	(308197, 146, '2015-01-01 00:21:21.000000', 'temperatura', 423.0000, 'ºC'),
	(308198, 146, '2015-01-01 00:21:22.000000', 'temperatura', 322.0000, 'ºC'),
	(308199, 146, '2015-01-01 00:21:23.000000', 'temperatura', 343.0000, 'ºC'),
	(308200, 146, '2015-01-01 00:21:24.000000', 'temperatura', 747.0000, 'ºC'),
	(308201, 146, '2015-01-01 00:21:25.000000', 'temperatura', 309.0000, 'ºC'),
	(308202, 146, '2015-01-01 00:21:26.000000', 'temperatura', 501.0000, 'ºC'),
	(308203, 146, '2015-01-01 00:21:27.000000', 'temperatura', 382.0000, 'ºC'),
	(308204, 146, '2015-01-01 00:21:28.000000', 'temperatura', 406.0000, 'ºC'),
	(308205, 146, '2015-01-01 00:21:29.000000', 'temperatura', 887.0000, 'ºC'),
	(308206, 146, '2015-01-01 00:21:30.000000', 'temperatura', 814.0000, 'ºC'),
	(308207, 146, '2015-01-01 00:21:31.000000', 'temperatura', 212.0000, 'ºC'),
	(308208, 146, '2015-01-01 00:21:32.000000', 'temperatura', 1016.0000, 'ºC'),
	(308209, 146, '2015-01-01 00:21:33.000000', 'temperatura', 847.0000, 'ºC'),
	(308210, 146, '2015-01-01 00:21:34.000000', 'temperatura', 1186.0000, 'ºC'),
	(308211, 146, '2015-01-01 00:21:35.000000', 'temperatura', 991.0000, 'ºC'),
	(308212, 146, '2015-01-01 00:21:36.000000', 'temperatura', 197.0000, 'ºC'),
	(308213, 146, '2015-01-01 00:21:37.000000', 'temperatura', 411.0000, 'ºC'),
	(308214, 146, '2015-01-01 00:21:38.000000', 'temperatura', 265.0000, 'ºC'),
	(308215, 146, '2015-01-01 00:21:39.000000', 'temperatura', 93.0000, 'ºC'),
	(308216, 146, '2015-01-01 00:21:40.000000', 'temperatura', 870.0000, 'ºC'),
	(308217, 146, '2015-01-01 00:21:41.000000', 'temperatura', 471.0000, 'ºC'),
	(308218, 146, '2015-01-01 00:21:42.000000', 'temperatura', 945.0000, 'ºC'),
	(308219, 146, '2015-01-01 00:21:43.000000', 'temperatura', 915.0000, 'ºC'),
	(308220, 146, '2015-01-01 00:21:44.000000', 'temperatura', 539.0000, 'ºC'),
	(308221, 146, '2015-01-01 00:21:45.000000', 'temperatura', 1152.0000, 'ºC'),
	(308222, 146, '2015-01-01 00:21:46.000000', 'temperatura', 543.0000, 'ºC'),
	(308223, 146, '2015-01-01 00:21:47.000000', 'temperatura', 460.0000, 'ºC'),
	(308224, 146, '2015-01-01 00:21:48.000000', 'temperatura', 671.0000, 'ºC'),
	(308225, 146, '2015-01-01 00:21:49.000000', 'temperatura', 775.0000, 'ºC'),
	(308226, 146, '2015-01-01 00:21:50.000000', 'temperatura', 661.0000, 'ºC'),
	(308227, 146, '2015-01-01 00:21:51.000000', 'temperatura', 981.0000, 'ºC'),
	(308228, 146, '2015-01-01 00:21:52.000000', 'temperatura', 524.0000, 'ºC'),
	(308229, 146, '2015-01-01 00:21:53.000000', 'temperatura', 876.0000, 'ºC'),
	(308230, 146, '2015-01-01 00:21:54.000000', 'temperatura', 408.0000, 'ºC'),
	(308231, 146, '2015-01-01 00:21:55.000000', 'temperatura', 615.0000, 'ºC'),
	(308232, 146, '2015-01-01 00:21:56.000000', 'temperatura', 650.0000, 'ºC'),
	(308233, 146, '2015-01-01 00:21:57.000000', 'temperatura', 206.0000, 'ºC'),
	(308234, 146, '2015-01-01 00:21:58.000000', 'temperatura', 282.0000, 'ºC'),
	(308235, 146, '2015-01-01 00:21:59.000000', 'temperatura', 790.0000, 'ºC'),
	(308236, 146, '2015-01-01 00:22:00.000000', 'temperatura', 703.0000, 'ºC'),
	(308237, 146, '2015-01-01 00:22:01.000000', 'temperatura', 1149.0000, 'ºC'),
	(308238, 146, '2015-01-01 00:22:02.000000', 'temperatura', 34.0000, 'ºC'),
	(308239, 146, '2015-01-01 00:22:03.000000', 'temperatura', 326.0000, 'ºC'),
	(308240, 146, '2015-01-01 00:22:04.000000', 'temperatura', 325.0000, 'ºC'),
	(308241, 146, '2015-01-01 00:22:05.000000', 'temperatura', 651.0000, 'ºC'),
	(308242, 146, '2015-01-01 00:22:06.000000', 'temperatura', 1080.0000, 'ºC'),
	(308243, 146, '2015-01-01 00:22:07.000000', 'temperatura', 1046.0000, 'ºC'),
	(308244, 146, '2015-01-01 00:22:08.000000', 'temperatura', 791.0000, 'ºC'),
	(308245, 146, '2015-01-01 00:22:09.000000', 'temperatura', 817.0000, 'ºC'),
	(308246, 146, '2015-01-01 00:22:10.000000', 'temperatura', 513.0000, 'ºC'),
	(308247, 146, '2015-01-01 00:22:11.000000', 'temperatura', 116.0000, 'ºC'),
	(308248, 146, '2015-01-01 00:22:12.000000', 'temperatura', 241.0000, 'ºC'),
	(308249, 146, '2015-01-01 00:22:13.000000', 'temperatura', 858.0000, 'ºC'),
	(308250, 146, '2015-01-01 00:22:14.000000', 'temperatura', 1168.0000, 'ºC'),
	(308251, 146, '2015-01-01 00:22:15.000000', 'temperatura', 866.0000, 'ºC'),
	(308252, 146, '2015-01-01 00:22:16.000000', 'temperatura', 828.0000, 'ºC'),
	(308253, 146, '2015-01-01 00:22:17.000000', 'temperatura', 340.0000, 'ºC'),
	(308254, 146, '2015-01-01 00:22:18.000000', 'temperatura', 419.0000, 'ºC'),
	(308255, 146, '2015-01-01 00:22:19.000000', 'temperatura', 1074.0000, 'ºC'),
	(308256, 146, '2015-01-01 00:22:20.000000', 'temperatura', 514.0000, 'ºC'),
	(308257, 146, '2015-01-01 00:22:21.000000', 'temperatura', 548.0000, 'ºC'),
	(308258, 146, '2015-01-01 00:22:22.000000', 'temperatura', 1198.0000, 'ºC'),
	(308259, 146, '2015-01-01 00:22:23.000000', 'temperatura', 746.0000, 'ºC'),
	(308260, 146, '2015-01-01 00:22:24.000000', 'temperatura', 136.0000, 'ºC'),
	(308261, 146, '2015-01-01 00:22:25.000000', 'temperatura', 845.0000, 'ºC'),
	(308262, 146, '2015-01-01 00:22:26.000000', 'temperatura', 216.0000, 'ºC'),
	(308263, 146, '2015-01-01 00:22:27.000000', 'temperatura', 945.0000, 'ºC'),
	(308264, 146, '2015-01-01 00:22:28.000000', 'temperatura', 480.0000, 'ºC'),
	(308265, 146, '2015-01-01 00:22:29.000000', 'temperatura', 765.0000, 'ºC'),
	(308266, 146, '2015-01-01 00:22:30.000000', 'temperatura', 1183.0000, 'ºC'),
	(308267, 146, '2015-01-01 00:22:31.000000', 'temperatura', 23.0000, 'ºC'),
	(308268, 146, '2015-01-01 00:22:32.000000', 'temperatura', 164.0000, 'ºC'),
	(308269, 146, '2015-01-01 00:22:33.000000', 'temperatura', 754.0000, 'ºC'),
	(308270, 146, '2015-01-01 00:22:34.000000', 'temperatura', 876.0000, 'ºC'),
	(308271, 146, '2015-01-01 00:22:35.000000', 'temperatura', 921.0000, 'ºC'),
	(308272, 146, '2015-01-01 00:22:36.000000', 'temperatura', 778.0000, 'ºC'),
	(308273, 146, '2015-01-01 00:22:37.000000', 'temperatura', 1128.0000, 'ºC'),
	(308274, 146, '2015-01-01 00:22:38.000000', 'temperatura', 905.0000, 'ºC'),
	(308275, 146, '2015-01-01 00:22:39.000000', 'temperatura', 1142.0000, 'ºC'),
	(308276, 146, '2015-01-01 00:22:40.000000', 'temperatura', 594.0000, 'ºC'),
	(308277, 146, '2015-01-01 00:22:41.000000', 'temperatura', 747.0000, 'ºC'),
	(308278, 146, '2015-01-01 00:22:42.000000', 'temperatura', 752.0000, 'ºC'),
	(308279, 146, '2015-01-01 00:22:43.000000', 'temperatura', 319.0000, 'ºC'),
	(308280, 146, '2015-01-01 00:22:44.000000', 'temperatura', 541.0000, 'ºC'),
	(308281, 146, '2015-01-01 00:22:45.000000', 'temperatura', 550.0000, 'ºC'),
	(308282, 146, '2015-01-01 00:22:46.000000', 'temperatura', 1125.0000, 'ºC'),
	(308283, 146, '2015-01-01 00:22:47.000000', 'temperatura', 376.0000, 'ºC'),
	(308284, 146, '2015-01-01 00:22:48.000000', 'temperatura', 905.0000, 'ºC'),
	(308285, 146, '2015-01-01 00:22:49.000000', 'temperatura', 996.0000, 'ºC'),
	(308286, 146, '2015-01-01 00:22:50.000000', 'temperatura', 1068.0000, 'ºC'),
	(308287, 146, '2015-01-01 00:22:51.000000', 'temperatura', 1150.0000, 'ºC'),
	(308288, 146, '2015-01-01 00:22:52.000000', 'temperatura', 147.0000, 'ºC'),
	(308289, 146, '2015-01-01 00:22:53.000000', 'temperatura', 884.0000, 'ºC'),
	(308290, 146, '2015-01-01 00:22:54.000000', 'temperatura', 382.0000, 'ºC'),
	(308291, 146, '2015-01-01 00:22:55.000000', 'temperatura', 459.0000, 'ºC'),
	(308292, 146, '2015-01-01 00:22:56.000000', 'temperatura', 1149.0000, 'ºC'),
	(308293, 146, '2015-01-01 00:22:57.000000', 'temperatura', 769.0000, 'ºC'),
	(308294, 146, '2015-01-01 00:22:58.000000', 'temperatura', 398.0000, 'ºC'),
	(308295, 146, '2015-01-01 00:22:59.000000', 'temperatura', 886.0000, 'ºC'),
	(308296, 146, '2015-01-01 00:23:00.000000', 'temperatura', 833.0000, 'ºC'),
	(308297, 146, '2015-01-01 00:23:01.000000', 'temperatura', 309.0000, 'ºC'),
	(308298, 146, '2015-01-01 00:23:02.000000', 'temperatura', 245.0000, 'ºC'),
	(308299, 146, '2015-01-01 00:23:03.000000', 'temperatura', 299.0000, 'ºC'),
	(308300, 146, '2015-01-01 00:23:04.000000', 'temperatura', 759.0000, 'ºC'),
	(308301, 146, '2015-01-01 00:23:05.000000', 'temperatura', 502.0000, 'ºC'),
	(308302, 146, '2015-01-01 00:23:06.000000', 'temperatura', 231.0000, 'ºC'),
	(308303, 146, '2015-01-01 00:23:07.000000', 'temperatura', 849.0000, 'ºC'),
	(308304, 146, '2015-01-01 00:23:08.000000', 'temperatura', 1155.0000, 'ºC'),
	(308305, 146, '2015-01-01 00:23:09.000000', 'temperatura', 826.0000, 'ºC'),
	(308306, 146, '2015-01-01 00:23:10.000000', 'temperatura', 667.0000, 'ºC'),
	(308307, 146, '2015-01-01 00:23:11.000000', 'temperatura', 857.0000, 'ºC'),
	(308308, 146, '2015-01-01 00:23:12.000000', 'temperatura', 1085.0000, 'ºC'),
	(308309, 146, '2015-01-01 00:23:13.000000', 'temperatura', 456.0000, 'ºC'),
	(308310, 146, '2015-01-01 00:23:14.000000', 'temperatura', 222.0000, 'ºC'),
	(308311, 146, '2015-01-01 00:23:15.000000', 'temperatura', 946.0000, 'ºC'),
	(308312, 146, '2015-01-01 00:23:16.000000', 'temperatura', 461.0000, 'ºC'),
	(308313, 146, '2015-01-01 00:23:17.000000', 'temperatura', 670.0000, 'ºC'),
	(308314, 146, '2015-01-01 00:23:18.000000', 'temperatura', 769.0000, 'ºC'),
	(308315, 146, '2015-01-01 00:23:19.000000', 'temperatura', 634.0000, 'ºC'),
	(308316, 146, '2015-01-01 00:23:20.000000', 'temperatura', 862.0000, 'ºC'),
	(308317, 146, '2015-01-01 00:23:21.000000', 'temperatura', 8.0000, 'ºC'),
	(308318, 146, '2015-01-01 00:23:22.000000', 'temperatura', 1056.0000, 'ºC'),
	(308319, 146, '2015-01-01 00:23:23.000000', 'temperatura', 457.0000, 'ºC'),
	(308320, 146, '2015-01-01 00:23:24.000000', 'temperatura', 316.0000, 'ºC'),
	(308321, 146, '2015-01-01 00:23:25.000000', 'temperatura', 208.0000, 'ºC'),
	(308322, 146, '2015-01-01 00:23:26.000000', 'temperatura', 96.0000, 'ºC'),
	(308323, 146, '2015-01-01 00:23:27.000000', 'temperatura', 1055.0000, 'ºC'),
	(308324, 146, '2015-01-01 00:23:28.000000', 'temperatura', 186.0000, 'ºC'),
	(308325, 146, '2015-01-01 00:23:29.000000', 'temperatura', 165.0000, 'ºC'),
	(308326, 146, '2015-01-01 00:23:30.000000', 'temperatura', 267.0000, 'ºC'),
	(308327, 146, '2015-01-01 00:23:31.000000', 'temperatura', 840.0000, 'ºC'),
	(308328, 146, '2015-01-01 00:23:32.000000', 'temperatura', 1000.0000, 'ºC'),
	(308329, 146, '2015-01-01 00:23:33.000000', 'temperatura', 83.0000, 'ºC'),
	(308330, 146, '2015-01-01 00:23:34.000000', 'temperatura', 1014.0000, 'ºC'),
	(308331, 146, '2015-01-01 00:23:35.000000', 'temperatura', 23.0000, 'ºC'),
	(308332, 146, '2015-01-01 00:23:36.000000', 'temperatura', 672.0000, 'ºC'),
	(308333, 146, '2015-01-01 00:23:37.000000', 'temperatura', 890.0000, 'ºC'),
	(308334, 146, '2015-01-01 00:23:38.000000', 'temperatura', 38.0000, 'ºC'),
	(308335, 146, '2015-01-01 00:23:39.000000', 'temperatura', 1118.0000, 'ºC'),
	(308336, 146, '2015-01-01 00:23:40.000000', 'temperatura', 679.0000, 'ºC'),
	(308337, 146, '2015-01-01 00:23:41.000000', 'temperatura', 40.0000, 'ºC'),
	(308338, 146, '2015-01-01 00:23:42.000000', 'temperatura', 566.0000, 'ºC'),
	(308339, 146, '2015-01-01 00:23:43.000000', 'temperatura', 308.0000, 'ºC'),
	(308340, 146, '2015-01-01 00:23:44.000000', 'temperatura', 1041.0000, 'ºC'),
	(308341, 146, '2015-01-01 00:23:45.000000', 'temperatura', 685.0000, 'ºC'),
	(308342, 146, '2015-01-01 00:23:46.000000', 'temperatura', 299.0000, 'ºC'),
	(308343, 146, '2015-01-01 00:23:47.000000', 'temperatura', 642.0000, 'ºC'),
	(308344, 146, '2015-01-01 00:23:48.000000', 'temperatura', 1113.0000, 'ºC'),
	(308345, 146, '2015-01-01 00:23:49.000000', 'temperatura', 38.0000, 'ºC'),
	(308346, 146, '2015-01-01 00:23:50.000000', 'temperatura', 453.0000, 'ºC'),
	(308347, 146, '2015-01-01 00:23:51.000000', 'temperatura', 949.0000, 'ºC'),
	(308348, 146, '2015-01-01 00:23:52.000000', 'temperatura', 989.0000, 'ºC'),
	(308349, 146, '2015-01-01 00:23:53.000000', 'temperatura', 898.0000, 'ºC'),
	(308350, 146, '2015-01-01 00:23:54.000000', 'temperatura', 324.0000, 'ºC'),
	(308351, 146, '2015-01-01 00:23:55.000000', 'temperatura', 127.0000, 'ºC'),
	(308352, 146, '2015-01-01 00:23:56.000000', 'temperatura', 861.0000, 'ºC'),
	(308353, 146, '2015-01-01 00:23:57.000000', 'temperatura', 327.0000, 'ºC'),
	(308354, 146, '2015-01-01 00:23:58.000000', 'temperatura', 250.0000, 'ºC'),
	(308355, 146, '2015-01-01 00:23:59.000000', 'temperatura', 273.0000, 'ºC'),
	(308356, 146, '2015-01-01 00:24:00.000000', 'temperatura', 612.0000, 'ºC'),
	(308357, 146, '2015-01-01 00:24:01.000000', 'temperatura', 1044.0000, 'ºC'),
	(308358, 146, '2015-01-01 00:24:02.000000', 'temperatura', 982.0000, 'ºC'),
	(308359, 146, '2015-01-01 00:24:03.000000', 'temperatura', 581.0000, 'ºC'),
	(308360, 146, '2015-01-01 00:24:04.000000', 'temperatura', 1160.0000, 'ºC'),
	(308361, 146, '2015-01-01 00:24:05.000000', 'temperatura', 456.0000, 'ºC'),
	(308362, 146, '2015-01-01 00:24:06.000000', 'temperatura', 0.0000, 'ºC'),
	(308363, 146, '2015-01-01 00:24:07.000000', 'temperatura', 1033.0000, 'ºC'),
	(308364, 146, '2015-01-01 00:24:08.000000', 'temperatura', 365.0000, 'ºC'),
	(308365, 146, '2015-01-01 00:24:09.000000', 'temperatura', 1127.0000, 'ºC'),
	(308366, 146, '2015-01-01 00:24:10.000000', 'temperatura', 939.0000, 'ºC'),
	(308367, 146, '2015-01-01 00:24:11.000000', 'temperatura', 115.0000, 'ºC'),
	(308368, 146, '2015-01-01 00:24:12.000000', 'temperatura', 161.0000, 'ºC'),
	(308369, 146, '2015-01-01 00:24:13.000000', 'temperatura', 458.0000, 'ºC'),
	(308370, 146, '2015-01-01 00:24:14.000000', 'temperatura', 610.0000, 'ºC'),
	(308371, 146, '2015-01-01 00:24:15.000000', 'temperatura', 476.0000, 'ºC'),
	(308372, 146, '2015-01-01 00:24:16.000000', 'temperatura', 551.0000, 'ºC'),
	(308373, 146, '2015-01-01 00:24:17.000000', 'temperatura', 127.0000, 'ºC'),
	(308374, 146, '2015-01-01 00:24:18.000000', 'temperatura', 182.0000, 'ºC'),
	(308375, 146, '2015-01-01 00:24:19.000000', 'temperatura', 530.0000, 'ºC'),
	(308376, 146, '2015-01-01 00:24:20.000000', 'temperatura', 906.0000, 'ºC'),
	(308377, 146, '2015-01-01 00:24:21.000000', 'temperatura', 539.0000, 'ºC'),
	(308378, 146, '2015-01-01 00:24:22.000000', 'temperatura', 1179.0000, 'ºC'),
	(308379, 146, '2015-01-01 00:24:23.000000', 'temperatura', 677.0000, 'ºC'),
	(308380, 146, '2015-01-01 00:24:24.000000', 'temperatura', 1047.0000, 'ºC'),
	(308381, 146, '2015-01-01 00:24:25.000000', 'temperatura', 806.0000, 'ºC'),
	(308382, 146, '2015-01-01 00:24:26.000000', 'temperatura', 889.0000, 'ºC'),
	(308383, 146, '2015-01-01 00:24:27.000000', 'temperatura', 829.0000, 'ºC'),
	(308384, 146, '2015-01-01 00:24:28.000000', 'temperatura', 278.0000, 'ºC'),
	(308385, 146, '2015-01-01 00:24:29.000000', 'temperatura', 105.0000, 'ºC'),
	(308386, 146, '2015-01-01 00:24:30.000000', 'temperatura', 892.0000, 'ºC'),
	(308387, 146, '2015-01-01 00:24:31.000000', 'temperatura', 543.0000, 'ºC'),
	(308388, 146, '2015-01-01 00:24:32.000000', 'temperatura', 40.0000, 'ºC'),
	(308389, 146, '2015-01-01 00:24:33.000000', 'temperatura', 973.0000, 'ºC'),
	(308390, 146, '2015-01-01 00:24:34.000000', 'temperatura', 1146.0000, 'ºC'),
	(308391, 146, '2015-01-01 00:24:35.000000', 'temperatura', 410.0000, 'ºC'),
	(308392, 146, '2015-01-01 00:24:36.000000', 'temperatura', 1013.0000, 'ºC'),
	(308393, 146, '2015-01-01 00:24:37.000000', 'temperatura', 237.0000, 'ºC'),
	(308394, 146, '2015-01-01 00:24:38.000000', 'temperatura', 547.0000, 'ºC'),
	(308395, 146, '2015-01-01 00:24:39.000000', 'temperatura', 825.0000, 'ºC'),
	(308396, 146, '2015-01-01 00:24:40.000000', 'temperatura', 85.0000, 'ºC'),
	(308397, 146, '2015-01-01 00:24:41.000000', 'temperatura', 348.0000, 'ºC'),
	(308398, 146, '2015-01-01 00:24:42.000000', 'temperatura', 286.0000, 'ºC'),
	(308399, 146, '2015-01-01 00:24:43.000000', 'temperatura', 387.0000, 'ºC'),
	(308400, 146, '2015-01-01 00:24:44.000000', 'temperatura', 1078.0000, 'ºC'),
	(308401, 146, '2015-01-01 00:24:45.000000', 'temperatura', 631.0000, 'ºC'),
	(308402, 146, '2015-01-01 00:24:46.000000', 'temperatura', 1121.0000, 'ºC'),
	(308403, 146, '2015-01-01 00:24:47.000000', 'temperatura', 112.0000, 'ºC'),
	(308404, 146, '2015-01-01 00:24:48.000000', 'temperatura', 797.0000, 'ºC'),
	(308405, 146, '2015-01-01 00:24:49.000000', 'temperatura', 48.0000, 'ºC'),
	(308406, 146, '2015-01-01 00:24:50.000000', 'temperatura', 252.0000, 'ºC'),
	(308407, 146, '2015-01-01 00:24:51.000000', 'temperatura', 1118.0000, 'ºC'),
	(308408, 146, '2015-01-01 00:24:52.000000', 'temperatura', 31.0000, 'ºC'),
	(308409, 146, '2015-01-01 00:24:53.000000', 'temperatura', 403.0000, 'ºC'),
	(308410, 146, '2015-01-01 00:24:54.000000', 'temperatura', 722.0000, 'ºC'),
	(308411, 146, '2015-01-01 00:24:55.000000', 'temperatura', 4.0000, 'ºC'),
	(308412, 146, '2015-01-01 00:24:56.000000', 'temperatura', 251.0000, 'ºC'),
	(308413, 146, '2015-01-01 00:24:57.000000', 'temperatura', 46.0000, 'ºC'),
	(308414, 146, '2015-01-01 00:24:58.000000', 'temperatura', 678.0000, 'ºC'),
	(308415, 146, '2015-01-01 00:24:59.000000', 'temperatura', 851.0000, 'ºC'),
	(308416, 146, '2015-01-01 00:25:00.000000', 'temperatura', 1023.0000, 'ºC'),
	(308417, 146, '2015-01-01 00:25:01.000000', 'temperatura', 163.0000, 'ºC'),
	(308418, 146, '2015-01-01 00:25:02.000000', 'temperatura', 147.0000, 'ºC'),
	(308419, 146, '2015-01-01 00:25:03.000000', 'temperatura', 244.0000, 'ºC'),
	(308420, 146, '2015-01-01 00:25:04.000000', 'temperatura', 780.0000, 'ºC'),
	(308421, 146, '2015-01-01 00:25:05.000000', 'temperatura', 770.0000, 'ºC'),
	(308422, 146, '2015-01-01 00:25:06.000000', 'temperatura', 311.0000, 'ºC'),
	(308423, 146, '2015-01-01 00:25:07.000000', 'temperatura', 445.0000, 'ºC'),
	(308424, 146, '2015-01-01 00:25:08.000000', 'temperatura', 91.0000, 'ºC'),
	(308425, 146, '2015-01-01 00:25:09.000000', 'temperatura', 323.0000, 'ºC'),
	(308426, 146, '2015-01-01 00:25:10.000000', 'temperatura', 140.0000, 'ºC'),
	(308427, 146, '2015-01-01 00:25:11.000000', 'temperatura', 931.0000, 'ºC'),
	(308428, 146, '2015-01-01 00:25:12.000000', 'temperatura', 636.0000, 'ºC'),
	(308429, 146, '2015-01-01 00:25:13.000000', 'temperatura', 388.0000, 'ºC'),
	(308430, 146, '2015-01-01 00:25:14.000000', 'temperatura', 34.0000, 'ºC'),
	(308431, 146, '2015-01-01 00:25:15.000000', 'temperatura', 205.0000, 'ºC'),
	(308432, 146, '2015-01-01 00:25:16.000000', 'temperatura', 925.0000, 'ºC'),
	(308433, 146, '2015-01-01 00:25:17.000000', 'temperatura', 409.0000, 'ºC'),
	(308434, 146, '2015-01-01 00:25:18.000000', 'temperatura', 472.0000, 'ºC'),
	(308435, 146, '2015-01-01 00:25:19.000000', 'temperatura', 1133.0000, 'ºC'),
	(308436, 146, '2015-01-01 00:25:20.000000', 'temperatura', 651.0000, 'ºC'),
	(308437, 146, '2015-01-01 00:25:21.000000', 'temperatura', 1055.0000, 'ºC'),
	(308438, 146, '2015-01-01 00:25:22.000000', 'temperatura', 922.0000, 'ºC'),
	(308439, 146, '2015-01-01 00:25:23.000000', 'temperatura', 245.0000, 'ºC'),
	(308440, 146, '2015-01-01 00:25:24.000000', 'temperatura', 858.0000, 'ºC'),
	(308441, 146, '2015-01-01 00:25:25.000000', 'temperatura', 1157.0000, 'ºC'),
	(308442, 146, '2015-01-01 00:25:26.000000', 'temperatura', 813.0000, 'ºC'),
	(308443, 146, '2015-01-01 00:25:27.000000', 'temperatura', 592.0000, 'ºC'),
	(308444, 146, '2015-01-01 00:25:28.000000', 'temperatura', 524.0000, 'ºC'),
	(308445, 146, '2015-01-01 00:25:29.000000', 'temperatura', 845.0000, 'ºC'),
	(308446, 146, '2015-01-01 00:25:30.000000', 'temperatura', 254.0000, 'ºC'),
	(308447, 146, '2015-01-01 00:25:31.000000', 'temperatura', 1136.0000, 'ºC'),
	(308448, 146, '2015-01-01 00:25:32.000000', 'temperatura', 119.0000, 'ºC'),
	(308449, 146, '2015-01-01 00:25:33.000000', 'temperatura', 785.0000, 'ºC'),
	(308450, 146, '2015-01-01 00:25:34.000000', 'temperatura', 1170.0000, 'ºC'),
	(308451, 146, '2015-01-01 00:25:35.000000', 'temperatura', 1095.0000, 'ºC'),
	(308452, 146, '2015-01-01 00:25:36.000000', 'temperatura', 764.0000, 'ºC'),
	(308453, 146, '2015-01-01 00:25:37.000000', 'temperatura', 538.0000, 'ºC'),
	(308454, 146, '2015-01-01 00:25:38.000000', 'temperatura', 399.0000, 'ºC'),
	(308455, 146, '2015-01-01 00:25:39.000000', 'temperatura', 381.0000, 'ºC'),
	(308456, 146, '2015-01-01 00:25:40.000000', 'temperatura', 707.0000, 'ºC'),
	(308457, 146, '2015-01-01 00:25:41.000000', 'temperatura', 1193.0000, 'ºC'),
	(308458, 146, '2015-01-01 00:25:42.000000', 'temperatura', 246.0000, 'ºC'),
	(308459, 146, '2015-01-01 00:25:43.000000', 'temperatura', 50.0000, 'ºC'),
	(308460, 146, '2015-01-01 00:25:44.000000', 'temperatura', 714.0000, 'ºC'),
	(308461, 146, '2015-01-01 00:25:45.000000', 'temperatura', 1021.0000, 'ºC'),
	(308462, 146, '2015-01-01 00:25:46.000000', 'temperatura', 562.0000, 'ºC'),
	(308463, 146, '2015-01-01 00:25:47.000000', 'temperatura', 950.0000, 'ºC'),
	(308464, 146, '2015-01-01 00:25:48.000000', 'temperatura', 662.0000, 'ºC'),
	(308465, 146, '2015-01-01 00:25:49.000000', 'temperatura', 463.0000, 'ºC'),
	(308466, 146, '2015-01-01 00:25:50.000000', 'temperatura', 327.0000, 'ºC'),
	(308467, 146, '2015-01-01 00:25:51.000000', 'temperatura', 246.0000, 'ºC'),
	(308468, 146, '2015-01-01 00:25:52.000000', 'temperatura', 250.0000, 'ºC'),
	(308469, 146, '2015-01-01 00:25:53.000000', 'temperatura', 511.0000, 'ºC'),
	(308470, 146, '2015-01-01 00:25:54.000000', 'temperatura', 608.0000, 'ºC'),
	(308471, 146, '2015-01-01 00:25:55.000000', 'temperatura', 307.0000, 'ºC'),
	(308472, 146, '2015-01-01 00:25:56.000000', 'temperatura', 912.0000, 'ºC'),
	(308473, 146, '2015-01-01 00:25:57.000000', 'temperatura', 39.0000, 'ºC'),
	(308474, 146, '2015-01-01 00:25:58.000000', 'temperatura', 1059.0000, 'ºC'),
	(308475, 146, '2015-01-01 00:25:59.000000', 'temperatura', 377.0000, 'ºC'),
	(308476, 146, '2015-01-01 00:26:00.000000', 'temperatura', 1110.0000, 'ºC'),
	(308477, 146, '2015-01-01 00:26:01.000000', 'temperatura', 818.0000, 'ºC'),
	(308478, 146, '2015-01-01 00:26:02.000000', 'temperatura', 763.0000, 'ºC'),
	(308479, 146, '2015-01-01 00:26:03.000000', 'temperatura', 160.0000, 'ºC'),
	(308480, 146, '2015-01-01 00:26:04.000000', 'temperatura', 911.0000, 'ºC'),
	(308481, 146, '2015-01-01 00:26:05.000000', 'temperatura', 476.0000, 'ºC'),
	(308482, 146, '2015-01-01 00:26:06.000000', 'temperatura', 848.0000, 'ºC'),
	(308483, 146, '2015-01-01 00:26:07.000000', 'temperatura', 414.0000, 'ºC'),
	(308484, 146, '2015-01-01 00:26:08.000000', 'temperatura', 727.0000, 'ºC'),
	(308485, 146, '2015-01-01 00:26:09.000000', 'temperatura', 1190.0000, 'ºC'),
	(308486, 146, '2015-01-01 00:26:10.000000', 'temperatura', 173.0000, 'ºC'),
	(308487, 146, '2015-01-01 00:26:11.000000', 'temperatura', 894.0000, 'ºC'),
	(308488, 146, '2015-01-01 00:26:12.000000', 'temperatura', 353.0000, 'ºC'),
	(308489, 146, '2015-01-01 00:26:13.000000', 'temperatura', 282.0000, 'ºC'),
	(308490, 146, '2015-01-01 00:26:14.000000', 'temperatura', 351.0000, 'ºC'),
	(308491, 146, '2015-01-01 00:26:15.000000', 'temperatura', 909.0000, 'ºC'),
	(308492, 146, '2015-01-01 00:26:16.000000', 'temperatura', 1092.0000, 'ºC'),
	(308493, 146, '2015-01-01 00:26:17.000000', 'temperatura', 333.0000, 'ºC'),
	(308494, 146, '2015-01-01 00:26:18.000000', 'temperatura', 789.0000, 'ºC'),
	(308495, 146, '2015-01-01 00:26:19.000000', 'temperatura', 546.0000, 'ºC'),
	(308496, 146, '2015-01-01 00:26:20.000000', 'temperatura', 363.0000, 'ºC'),
	(308497, 146, '2015-01-01 00:26:21.000000', 'temperatura', 178.0000, 'ºC'),
	(308498, 146, '2015-01-01 00:26:22.000000', 'temperatura', 1003.0000, 'ºC'),
	(308499, 146, '2015-01-01 00:26:23.000000', 'temperatura', 883.0000, 'ºC'),
	(308500, 146, '2015-01-01 00:26:24.000000', 'temperatura', 204.0000, 'ºC'),
	(308501, 146, '2015-01-01 00:26:25.000000', 'temperatura', 772.0000, 'ºC'),
	(308502, 146, '2015-01-01 00:26:26.000000', 'temperatura', 848.0000, 'ºC'),
	(308503, 146, '2015-01-01 00:26:27.000000', 'temperatura', 726.0000, 'ºC'),
	(308504, 146, '2015-01-01 00:26:28.000000', 'temperatura', 1084.0000, 'ºC'),
	(308505, 146, '2015-01-01 00:26:29.000000', 'temperatura', 845.0000, 'ºC'),
	(308506, 146, '2015-01-01 00:26:30.000000', 'temperatura', 971.0000, 'ºC'),
	(308507, 146, '2015-01-01 00:26:31.000000', 'temperatura', 1120.0000, 'ºC'),
	(308508, 146, '2015-01-01 00:26:32.000000', 'temperatura', 290.0000, 'ºC'),
	(308509, 146, '2015-01-01 00:26:33.000000', 'temperatura', 488.0000, 'ºC'),
	(308510, 146, '2015-01-01 00:26:34.000000', 'temperatura', 371.0000, 'ºC'),
	(308511, 146, '2015-01-01 00:26:35.000000', 'temperatura', 393.0000, 'ºC'),
	(308512, 146, '2015-01-01 00:26:36.000000', 'temperatura', 850.0000, 'ºC'),
	(308513, 146, '2015-01-01 00:26:37.000000', 'temperatura', 671.0000, 'ºC'),
	(308514, 146, '2015-01-01 00:26:38.000000', 'temperatura', 807.0000, 'ºC'),
	(308515, 146, '2015-01-01 00:26:39.000000', 'temperatura', 821.0000, 'ºC'),
	(308516, 146, '2015-01-01 00:26:40.000000', 'temperatura', 486.0000, 'ºC'),
	(308517, 146, '2015-01-01 00:26:41.000000', 'temperatura', 1165.0000, 'ºC'),
	(308518, 146, '2015-01-01 00:26:42.000000', 'temperatura', 769.0000, 'ºC'),
	(308519, 146, '2015-01-01 00:26:43.000000', 'temperatura', 351.0000, 'ºC'),
	(308520, 146, '2015-01-01 00:26:44.000000', 'temperatura', 646.0000, 'ºC'),
	(308521, 146, '2015-01-01 00:26:45.000000', 'temperatura', 980.0000, 'ºC'),
	(308522, 146, '2015-01-01 00:26:46.000000', 'temperatura', 563.0000, 'ºC'),
	(308523, 146, '2015-01-01 00:26:47.000000', 'temperatura', 1076.0000, 'ºC'),
	(308524, 146, '2015-01-01 00:26:48.000000', 'temperatura', 90.0000, 'ºC'),
	(308525, 146, '2015-01-01 00:26:49.000000', 'temperatura', 822.0000, 'ºC'),
	(308526, 146, '2015-01-01 00:26:50.000000', 'temperatura', 242.0000, 'ºC'),
	(308527, 146, '2015-01-01 00:26:51.000000', 'temperatura', 1144.0000, 'ºC'),
	(308528, 146, '2015-01-01 00:26:52.000000', 'temperatura', 196.0000, 'ºC'),
	(308529, 146, '2015-01-01 00:26:53.000000', 'temperatura', 1146.0000, 'ºC'),
	(308530, 146, '2015-01-01 00:26:54.000000', 'temperatura', 344.0000, 'ºC'),
	(308531, 146, '2015-01-01 00:26:55.000000', 'temperatura', 680.0000, 'ºC'),
	(308532, 146, '2015-01-01 00:26:56.000000', 'temperatura', 1172.0000, 'ºC'),
	(308533, 146, '2015-01-01 00:26:57.000000', 'temperatura', 217.0000, 'ºC'),
	(308534, 146, '2015-01-01 00:26:58.000000', 'temperatura', 1172.0000, 'ºC'),
	(308535, 146, '2015-01-01 00:26:59.000000', 'temperatura', 411.0000, 'ºC'),
	(308536, 146, '2015-01-01 00:27:00.000000', 'temperatura', 936.0000, 'ºC'),
	(308537, 146, '2015-01-01 00:27:01.000000', 'temperatura', 1049.0000, 'ºC'),
	(308538, 146, '2015-01-01 00:27:02.000000', 'temperatura', 36.0000, 'ºC'),
	(308539, 146, '2015-01-01 00:27:03.000000', 'temperatura', 634.0000, 'ºC'),
	(308540, 146, '2015-01-01 00:27:04.000000', 'temperatura', 661.0000, 'ºC'),
	(308541, 146, '2015-01-01 00:27:05.000000', 'temperatura', 204.0000, 'ºC'),
	(308542, 146, '2015-01-01 00:27:06.000000', 'temperatura', 239.0000, 'ºC'),
	(308543, 146, '2015-01-01 00:27:07.000000', 'temperatura', 584.0000, 'ºC'),
	(308544, 146, '2015-01-01 00:27:08.000000', 'temperatura', 1004.0000, 'ºC'),
	(308545, 146, '2015-01-01 00:27:09.000000', 'temperatura', 866.0000, 'ºC'),
	(308546, 146, '2015-01-01 00:27:10.000000', 'temperatura', 119.0000, 'ºC'),
	(308547, 146, '2015-01-01 00:27:11.000000', 'temperatura', 398.0000, 'ºC'),
	(308548, 146, '2015-01-01 00:27:12.000000', 'temperatura', 434.0000, 'ºC'),
	(308549, 146, '2015-01-01 00:27:13.000000', 'temperatura', 978.0000, 'ºC'),
	(308550, 146, '2015-01-01 00:27:14.000000', 'temperatura', 1186.0000, 'ºC'),
	(308551, 146, '2015-01-01 00:27:15.000000', 'temperatura', 596.0000, 'ºC'),
	(308552, 146, '2015-01-01 00:27:16.000000', 'temperatura', 622.0000, 'ºC'),
	(308553, 146, '2015-01-01 00:27:17.000000', 'temperatura', 122.0000, 'ºC'),
	(308554, 146, '2015-01-01 00:27:18.000000', 'temperatura', 1147.0000, 'ºC'),
	(308555, 146, '2015-01-01 00:27:19.000000', 'temperatura', 570.0000, 'ºC'),
	(308556, 146, '2015-01-01 00:27:20.000000', 'temperatura', 610.0000, 'ºC'),
	(308557, 146, '2015-01-01 00:27:21.000000', 'temperatura', 140.0000, 'ºC'),
	(308558, 146, '2015-01-01 00:27:22.000000', 'temperatura', 72.0000, 'ºC'),
	(308559, 146, '2015-01-01 00:27:23.000000', 'temperatura', 1140.0000, 'ºC'),
	(308560, 146, '2015-01-01 00:27:24.000000', 'temperatura', 685.0000, 'ºC'),
	(308561, 146, '2015-01-01 00:27:25.000000', 'temperatura', 3.0000, 'ºC'),
	(308562, 146, '2015-01-01 00:27:26.000000', 'temperatura', 363.0000, 'ºC'),
	(308563, 146, '2015-01-01 00:27:27.000000', 'temperatura', 607.0000, 'ºC'),
	(308564, 146, '2015-01-01 00:27:28.000000', 'temperatura', 745.0000, 'ºC'),
	(308565, 146, '2015-01-01 00:27:29.000000', 'temperatura', 704.0000, 'ºC'),
	(308566, 146, '2015-01-01 00:27:30.000000', 'temperatura', 87.0000, 'ºC'),
	(308567, 146, '2015-01-01 00:27:31.000000', 'temperatura', 722.0000, 'ºC'),
	(308568, 146, '2015-01-01 00:27:32.000000', 'temperatura', 948.0000, 'ºC'),
	(308569, 146, '2015-01-01 00:27:33.000000', 'temperatura', 176.0000, 'ºC'),
	(308570, 146, '2015-01-01 00:27:34.000000', 'temperatura', 436.0000, 'ºC'),
	(308571, 146, '2015-01-01 00:27:35.000000', 'temperatura', 454.0000, 'ºC'),
	(308572, 146, '2015-01-01 00:27:36.000000', 'temperatura', 964.0000, 'ºC'),
	(308573, 146, '2015-01-01 00:27:37.000000', 'temperatura', 1056.0000, 'ºC'),
	(308574, 146, '2015-01-01 00:27:38.000000', 'temperatura', 1190.0000, 'ºC'),
	(308575, 146, '2015-01-01 00:27:39.000000', 'temperatura', 380.0000, 'ºC'),
	(308576, 146, '2015-01-01 00:27:40.000000', 'temperatura', 733.0000, 'ºC'),
	(308577, 146, '2015-01-01 00:27:41.000000', 'temperatura', 125.0000, 'ºC'),
	(308578, 146, '2015-01-01 00:27:42.000000', 'temperatura', 827.0000, 'ºC'),
	(308579, 146, '2015-01-01 00:27:43.000000', 'temperatura', 158.0000, 'ºC'),
	(308580, 146, '2015-01-01 00:27:44.000000', 'temperatura', 713.0000, 'ºC'),
	(308581, 146, '2015-01-01 00:27:45.000000', 'temperatura', 689.0000, 'ºC'),
	(308582, 146, '2015-01-01 00:27:46.000000', 'temperatura', 107.0000, 'ºC'),
	(308583, 146, '2015-01-01 00:27:47.000000', 'temperatura', 869.0000, 'ºC'),
	(308584, 146, '2015-01-01 00:27:48.000000', 'temperatura', 425.0000, 'ºC'),
	(308585, 146, '2015-01-01 00:27:49.000000', 'temperatura', 717.0000, 'ºC'),
	(308586, 146, '2015-01-01 00:27:50.000000', 'temperatura', 1113.0000, 'ºC'),
	(308587, 146, '2015-01-01 00:27:51.000000', 'temperatura', 1014.0000, 'ºC'),
	(308588, 146, '2015-01-01 00:27:52.000000', 'temperatura', 532.0000, 'ºC'),
	(308589, 146, '2015-01-01 00:27:53.000000', 'temperatura', 817.0000, 'ºC'),
	(308590, 146, '2015-01-01 00:27:54.000000', 'temperatura', 91.0000, 'ºC'),
	(308591, 146, '2015-01-01 00:27:55.000000', 'temperatura', 403.0000, 'ºC'),
	(308592, 146, '2015-01-01 00:27:56.000000', 'temperatura', 543.0000, 'ºC'),
	(308593, 146, '2015-01-01 00:27:57.000000', 'temperatura', 308.0000, 'ºC'),
	(308594, 146, '2015-01-01 00:27:58.000000', 'temperatura', 1109.0000, 'ºC'),
	(308595, 146, '2015-01-01 00:27:59.000000', 'temperatura', 1024.0000, 'ºC'),
	(308596, 146, '2015-01-01 00:28:00.000000', 'temperatura', 591.0000, 'ºC'),
	(308597, 146, '2015-01-01 00:28:01.000000', 'temperatura', 1083.0000, 'ºC'),
	(308598, 146, '2015-01-01 00:28:02.000000', 'temperatura', 43.0000, 'ºC'),
	(308599, 146, '2015-01-01 00:28:03.000000', 'temperatura', 566.0000, 'ºC'),
	(308600, 146, '2015-01-01 00:28:04.000000', 'temperatura', 302.0000, 'ºC'),
	(308601, 146, '2015-01-01 00:28:05.000000', 'temperatura', 1012.0000, 'ºC'),
	(308602, 146, '2015-01-01 00:28:06.000000', 'temperatura', 557.0000, 'ºC'),
	(308603, 146, '2015-01-01 00:28:07.000000', 'temperatura', 948.0000, 'ºC'),
	(308604, 146, '2015-01-01 00:28:08.000000', 'temperatura', 668.0000, 'ºC'),
	(308605, 146, '2015-01-01 00:28:09.000000', 'temperatura', 499.0000, 'ºC'),
	(308606, 146, '2015-01-01 00:28:10.000000', 'temperatura', 492.0000, 'ºC'),
	(308607, 146, '2015-01-01 00:28:11.000000', 'temperatura', 961.0000, 'ºC'),
	(308608, 146, '2015-01-01 00:28:12.000000', 'temperatura', 932.0000, 'ºC'),
	(308609, 146, '2015-01-01 00:28:13.000000', 'temperatura', 576.0000, 'ºC'),
	(308610, 146, '2015-01-01 00:28:14.000000', 'temperatura', 83.0000, 'ºC'),
	(308611, 146, '2015-01-01 00:28:15.000000', 'temperatura', 1088.0000, 'ºC'),
	(308612, 146, '2015-01-01 00:28:16.000000', 'temperatura', 393.0000, 'ºC'),
	(308613, 146, '2015-01-01 00:28:17.000000', 'temperatura', 1099.0000, 'ºC'),
	(308614, 146, '2015-01-01 00:28:18.000000', 'temperatura', 719.0000, 'ºC'),
	(308615, 146, '2015-01-01 00:28:19.000000', 'temperatura', 299.0000, 'ºC'),
	(308616, 146, '2015-01-01 00:28:20.000000', 'temperatura', 537.0000, 'ºC'),
	(308617, 146, '2015-01-01 00:28:21.000000', 'temperatura', 591.0000, 'ºC'),
	(308618, 146, '2015-01-01 00:28:22.000000', 'temperatura', 142.0000, 'ºC'),
	(308619, 146, '2015-01-01 00:28:23.000000', 'temperatura', 140.0000, 'ºC'),
	(308620, 146, '2015-01-01 00:28:24.000000', 'temperatura', 273.0000, 'ºC'),
	(308621, 146, '2015-01-01 00:28:25.000000', 'temperatura', 945.0000, 'ºC'),
	(308622, 146, '2015-01-01 00:28:26.000000', 'temperatura', 307.0000, 'ºC'),
	(308623, 146, '2015-01-01 00:28:27.000000', 'temperatura', 1101.0000, 'ºC'),
	(308624, 146, '2015-01-01 00:28:28.000000', 'temperatura', 984.0000, 'ºC'),
	(308625, 146, '2015-01-01 00:28:29.000000', 'temperatura', 416.0000, 'ºC'),
	(308626, 146, '2015-01-01 00:28:30.000000', 'temperatura', 329.0000, 'ºC'),
	(308627, 146, '2015-01-01 00:28:31.000000', 'temperatura', 397.0000, 'ºC'),
	(308628, 146, '2015-01-01 00:28:32.000000', 'temperatura', 999.0000, 'ºC'),
	(308629, 146, '2015-01-01 00:28:33.000000', 'temperatura', 205.0000, 'ºC'),
	(308630, 146, '2015-01-01 00:28:34.000000', 'temperatura', 428.0000, 'ºC'),
	(308631, 146, '2015-01-01 00:28:35.000000', 'temperatura', 326.0000, 'ºC'),
	(308632, 146, '2015-01-01 00:28:36.000000', 'temperatura', 346.0000, 'ºC'),
	(308633, 146, '2015-01-01 00:28:37.000000', 'temperatura', 754.0000, 'ºC'),
	(308634, 146, '2015-01-01 00:28:38.000000', 'temperatura', 330.0000, 'ºC'),
	(308635, 146, '2015-01-01 00:28:39.000000', 'temperatura', 591.0000, 'ºC'),
	(308636, 146, '2015-01-01 00:28:40.000000', 'temperatura', 764.0000, 'ºC'),
	(308637, 146, '2015-01-01 00:28:41.000000', 'temperatura', 850.0000, 'ºC'),
	(308638, 146, '2015-01-01 00:28:42.000000', 'temperatura', 755.0000, 'ºC'),
	(308639, 146, '2015-01-01 00:28:43.000000', 'temperatura', 29.0000, 'ºC'),
	(308640, 146, '2015-01-01 00:28:44.000000', 'temperatura', 279.0000, 'ºC'),
	(308641, 146, '2015-01-01 00:28:45.000000', 'temperatura', 107.0000, 'ºC'),
	(308642, 146, '2015-01-01 00:28:46.000000', 'temperatura', 898.0000, 'ºC'),
	(308643, 146, '2015-01-01 00:28:47.000000', 'temperatura', 572.0000, 'ºC'),
	(308644, 146, '2015-01-01 00:28:48.000000', 'temperatura', 166.0000, 'ºC'),
	(308645, 146, '2015-01-01 00:28:49.000000', 'temperatura', 313.0000, 'ºC'),
	(308646, 146, '2015-01-01 00:28:50.000000', 'temperatura', 1067.0000, 'ºC'),
	(308647, 146, '2015-01-01 00:28:51.000000', 'temperatura', 796.0000, 'ºC'),
	(308648, 146, '2015-01-01 00:28:52.000000', 'temperatura', 779.0000, 'ºC'),
	(308649, 146, '2015-01-01 00:28:53.000000', 'temperatura', 307.0000, 'ºC'),
	(308650, 146, '2015-01-01 00:28:54.000000', 'temperatura', 398.0000, 'ºC'),
	(308651, 146, '2015-01-01 00:28:55.000000', 'temperatura', 1069.0000, 'ºC'),
	(308652, 146, '2015-01-01 00:28:56.000000', 'temperatura', 551.0000, 'ºC'),
	(308653, 146, '2015-01-01 00:28:57.000000', 'temperatura', 752.0000, 'ºC'),
	(308654, 146, '2015-01-01 00:28:58.000000', 'temperatura', 905.0000, 'ºC'),
	(308655, 146, '2015-01-01 00:28:59.000000', 'temperatura', 1069.0000, 'ºC'),
	(308656, 146, '2015-01-01 00:29:00.000000', 'temperatura', 231.0000, 'ºC'),
	(308657, 146, '2015-01-01 00:29:01.000000', 'temperatura', 348.0000, 'ºC'),
	(308658, 146, '2015-01-01 00:29:02.000000', 'temperatura', 1047.0000, 'ºC'),
	(308659, 146, '2015-01-01 00:29:03.000000', 'temperatura', 594.0000, 'ºC'),
	(308660, 146, '2015-01-01 00:29:04.000000', 'temperatura', 1028.0000, 'ºC'),
	(308661, 146, '2015-01-01 00:29:05.000000', 'temperatura', 957.0000, 'ºC'),
	(308662, 146, '2015-01-01 00:29:06.000000', 'temperatura', 504.0000, 'ºC'),
	(308663, 146, '2015-01-01 00:29:07.000000', 'temperatura', 848.0000, 'ºC'),
	(308664, 146, '2015-01-01 00:29:08.000000', 'temperatura', 327.0000, 'ºC'),
	(308665, 146, '2015-01-01 00:29:09.000000', 'temperatura', 295.0000, 'ºC'),
	(308666, 146, '2015-01-01 00:29:10.000000', 'temperatura', 492.0000, 'ºC'),
	(308667, 146, '2015-01-01 00:29:11.000000', 'temperatura', 375.0000, 'ºC'),
	(308668, 146, '2015-01-01 00:29:12.000000', 'temperatura', 401.0000, 'ºC'),
	(308669, 146, '2015-01-01 00:29:13.000000', 'temperatura', 879.0000, 'ºC'),
	(308670, 146, '2015-01-01 00:29:14.000000', 'temperatura', 794.0000, 'ºC'),
	(308671, 146, '2015-01-01 00:29:15.000000', 'temperatura', 132.0000, 'ºC'),
	(308672, 146, '2015-01-01 00:29:16.000000', 'temperatura', 678.0000, 'ºC'),
	(308673, 146, '2015-01-01 00:29:17.000000', 'temperatura', 597.0000, 'ºC'),
	(308674, 146, '2015-01-01 00:29:18.000000', 'temperatura', 949.0000, 'ºC'),
	(308675, 146, '2015-01-01 00:29:19.000000', 'temperatura', 554.0000, 'ºC'),
	(308676, 146, '2015-01-01 00:29:20.000000', 'temperatura', 1125.0000, 'ºC'),
	(308677, 146, '2015-01-01 00:29:21.000000', 'temperatura', 362.0000, 'ºC'),
	(308678, 146, '2015-01-01 00:29:22.000000', 'temperatura', 838.0000, 'ºC'),
	(308679, 146, '2015-01-01 00:29:23.000000', 'temperatura', 704.0000, 'ºC'),
	(308680, 146, '2015-01-01 00:29:24.000000', 'temperatura', 1006.0000, 'ºC'),
	(308681, 146, '2015-01-01 00:29:25.000000', 'temperatura', 518.0000, 'ºC'),
	(308682, 146, '2015-01-01 00:29:26.000000', 'temperatura', 774.0000, 'ºC'),
	(308683, 146, '2015-01-01 00:29:27.000000', 'temperatura', 1116.0000, 'ºC'),
	(308684, 146, '2015-01-01 00:29:28.000000', 'temperatura', 858.0000, 'ºC'),
	(308685, 146, '2015-01-01 00:29:29.000000', 'temperatura', 945.0000, 'ºC'),
	(308686, 146, '2015-01-01 00:29:30.000000', 'temperatura', 949.0000, 'ºC'),
	(308687, 146, '2015-01-01 00:29:31.000000', 'temperatura', 711.0000, 'ºC'),
	(308688, 146, '2015-01-01 00:29:32.000000', 'temperatura', 709.0000, 'ºC'),
	(308689, 146, '2015-01-01 00:29:33.000000', 'temperatura', 211.0000, 'ºC'),
	(308690, 146, '2015-01-01 00:29:34.000000', 'temperatura', 129.0000, 'ºC'),
	(308691, 146, '2015-01-01 00:29:35.000000', 'temperatura', 14.0000, 'ºC'),
	(308692, 146, '2015-01-01 00:29:36.000000', 'temperatura', 884.0000, 'ºC'),
	(308693, 146, '2015-01-01 00:29:37.000000', 'temperatura', 776.0000, 'ºC'),
	(308694, 146, '2015-01-01 00:29:38.000000', 'temperatura', 29.0000, 'ºC'),
	(308695, 146, '2015-01-01 00:29:39.000000', 'temperatura', 218.0000, 'ºC'),
	(308696, 146, '2015-01-01 00:29:40.000000', 'temperatura', 1002.0000, 'ºC'),
	(308697, 146, '2015-01-01 00:29:41.000000', 'temperatura', 758.0000, 'ºC'),
	(308698, 146, '2015-01-01 00:29:42.000000', 'temperatura', 786.0000, 'ºC'),
	(308699, 146, '2015-01-01 00:29:43.000000', 'temperatura', 455.0000, 'ºC'),
	(308700, 146, '2015-01-01 00:29:44.000000', 'temperatura', 1116.0000, 'ºC'),
	(308701, 146, '2015-01-01 00:29:45.000000', 'temperatura', 615.0000, 'ºC'),
	(308702, 146, '2015-01-01 00:29:46.000000', 'temperatura', 930.0000, 'ºC'),
	(308703, 146, '2015-01-01 00:29:47.000000', 'temperatura', 402.0000, 'ºC'),
	(308704, 146, '2015-01-01 00:29:48.000000', 'temperatura', 424.0000, 'ºC'),
	(308705, 146, '2015-01-01 00:29:49.000000', 'temperatura', 914.0000, 'ºC'),
	(308706, 146, '2015-01-01 00:29:50.000000', 'temperatura', 899.0000, 'ºC'),
	(308707, 146, '2015-01-01 00:29:51.000000', 'temperatura', 552.0000, 'ºC'),
	(308708, 146, '2015-01-01 00:29:52.000000', 'temperatura', 64.0000, 'ºC'),
	(308709, 146, '2015-01-01 00:29:53.000000', 'temperatura', 1064.0000, 'ºC'),
	(308710, 146, '2015-01-01 00:29:54.000000', 'temperatura', 329.0000, 'ºC'),
	(308711, 146, '2015-01-01 00:29:55.000000', 'temperatura', 852.0000, 'ºC'),
	(308712, 146, '2015-01-01 00:29:56.000000', 'temperatura', 876.0000, 'ºC'),
	(308713, 146, '2015-01-01 00:29:57.000000', 'temperatura', 622.0000, 'ºC'),
	(308714, 146, '2015-01-01 00:29:58.000000', 'temperatura', 484.0000, 'ºC'),
	(308715, 146, '2015-01-01 00:29:59.000000', 'temperatura', 553.0000, 'ºC'),
	(308716, 146, '2015-01-01 00:30:00.000000', 'temperatura', 115.0000, 'ºC'),
	(308717, 146, '2015-01-01 00:30:01.000000', 'temperatura', 117.0000, 'ºC'),
	(308718, 146, '2015-01-01 00:30:02.000000', 'temperatura', 239.0000, 'ºC'),
	(308719, 146, '2015-01-01 00:30:03.000000', 'temperatura', 846.0000, 'ºC'),
	(308720, 146, '2015-01-01 00:30:04.000000', 'temperatura', 1115.0000, 'ºC'),
	(308721, 146, '2015-01-01 00:30:05.000000', 'temperatura', 635.0000, 'ºC'),
	(308722, 146, '2015-01-01 00:30:06.000000', 'temperatura', 1032.0000, 'ºC'),
	(308723, 146, '2015-01-01 00:30:07.000000', 'temperatura', 856.0000, 'ºC'),
	(308724, 146, '2015-01-01 00:30:08.000000', 'temperatura', 1184.0000, 'ºC'),
	(308725, 146, '2015-01-01 00:30:09.000000', 'temperatura', 951.0000, 'ºC'),
	(308726, 146, '2015-01-01 00:30:10.000000', 'temperatura', 5.0000, 'ºC'),
	(308727, 146, '2015-01-01 00:30:11.000000', 'temperatura', 773.0000, 'ºC'),
	(308728, 146, '2015-01-01 00:30:12.000000', 'temperatura', 248.0000, 'ºC'),
	(308729, 146, '2015-01-01 00:30:13.000000', 'temperatura', 124.0000, 'ºC'),
	(308730, 146, '2015-01-01 00:30:14.000000', 'temperatura', 1076.0000, 'ºC'),
	(308731, 146, '2015-01-01 00:30:15.000000', 'temperatura', 207.0000, 'ºC'),
	(308732, 146, '2015-01-01 00:30:16.000000', 'temperatura', 208.0000, 'ºC'),
	(308733, 146, '2015-01-01 00:30:17.000000', 'temperatura', 419.0000, 'ºC'),
	(308734, 146, '2015-01-01 00:30:18.000000', 'temperatura', 273.0000, 'ºC'),
	(308735, 146, '2015-01-01 00:30:19.000000', 'temperatura', 107.0000, 'ºC'),
	(308736, 146, '2015-01-01 00:30:20.000000', 'temperatura', 916.0000, 'ºC'),
	(308737, 146, '2015-01-01 00:30:21.000000', 'temperatura', 662.0000, 'ºC'),
	(308738, 146, '2015-01-01 00:30:22.000000', 'temperatura', 563.0000, 'ºC'),
	(308739, 146, '2015-01-01 00:30:23.000000', 'temperatura', 828.0000, 'ºC'),
	(308740, 146, '2015-01-01 00:30:24.000000', 'temperatura', 52.0000, 'ºC'),
	(308741, 146, '2015-01-01 00:30:25.000000', 'temperatura', 176.0000, 'ºC'),
	(308742, 146, '2015-01-01 00:30:26.000000', 'temperatura', 726.0000, 'ºC'),
	(308743, 146, '2015-01-01 00:30:27.000000', 'temperatura', 701.0000, 'ºC'),
	(308744, 146, '2015-01-01 00:30:28.000000', 'temperatura', 126.0000, 'ºC'),
	(308745, 146, '2015-01-01 00:30:29.000000', 'temperatura', 928.0000, 'ºC'),
	(308746, 146, '2015-01-01 00:30:30.000000', 'temperatura', 663.0000, 'ºC'),
	(308747, 146, '2015-01-01 00:30:31.000000', 'temperatura', 531.0000, 'ºC'),
	(308748, 146, '2015-01-01 00:30:32.000000', 'temperatura', 669.0000, 'ºC'),
	(308749, 146, '2015-01-01 00:30:33.000000', 'temperatura', 551.0000, 'ºC'),
	(308750, 146, '2015-01-01 00:30:34.000000', 'temperatura', 748.0000, 'ºC'),
	(308751, 146, '2015-01-01 00:30:35.000000', 'temperatura', 888.0000, 'ºC'),
	(308752, 146, '2015-01-01 00:30:36.000000', 'temperatura', 995.0000, 'ºC'),
	(308753, 146, '2015-01-01 00:30:37.000000', 'temperatura', 1112.0000, 'ºC'),
	(308754, 146, '2015-01-01 00:30:38.000000', 'temperatura', 174.0000, 'ºC'),
	(308755, 146, '2015-01-01 00:30:39.000000', 'temperatura', 1138.0000, 'ºC'),
	(308756, 146, '2015-01-01 00:30:40.000000', 'temperatura', 367.0000, 'ºC'),
	(308757, 146, '2015-01-01 00:30:41.000000', 'temperatura', 819.0000, 'ºC'),
	(308758, 146, '2015-01-01 00:30:42.000000', 'temperatura', 598.0000, 'ºC'),
	(308759, 146, '2015-01-01 00:30:43.000000', 'temperatura', 531.0000, 'ºC'),
	(308760, 146, '2015-01-01 00:30:44.000000', 'temperatura', 861.0000, 'ºC'),
	(308761, 146, '2015-01-01 00:30:45.000000', 'temperatura', 314.0000, 'ºC'),
	(308762, 146, '2015-01-01 00:30:46.000000', 'temperatura', 189.0000, 'ºC'),
	(308763, 146, '2015-01-01 00:30:47.000000', 'temperatura', 3.0000, 'ºC'),
	(308764, 146, '2015-01-01 00:30:48.000000', 'temperatura', 646.0000, 'ºC'),
	(308765, 146, '2015-01-01 00:30:49.000000', 'temperatura', 823.0000, 'ºC'),
	(308766, 146, '2015-01-01 00:30:50.000000', 'temperatura', 978.0000, 'ºC'),
	(308767, 146, '2015-01-01 00:30:51.000000', 'temperatura', 21.0000, 'ºC'),
	(308768, 146, '2015-01-01 00:30:52.000000', 'temperatura', 769.0000, 'ºC'),
	(308769, 146, '2015-01-01 00:30:53.000000', 'temperatura', 186.0000, 'ºC'),
	(308770, 146, '2015-01-01 00:30:54.000000', 'temperatura', 1024.0000, 'ºC'),
	(308771, 146, '2015-01-01 00:30:55.000000', 'temperatura', 961.0000, 'ºC'),
	(308772, 146, '2015-01-01 00:30:56.000000', 'temperatura', 532.0000, 'ºC'),
	(308773, 146, '2015-01-01 00:30:57.000000', 'temperatura', 979.0000, 'ºC'),
	(308774, 146, '2015-01-01 00:30:58.000000', 'temperatura', 901.0000, 'ºC'),
	(308775, 146, '2015-01-01 00:30:59.000000', 'temperatura', 366.0000, 'ºC'),
	(308776, 146, '2015-01-01 00:31:00.000000', 'temperatura', 329.0000, 'ºC'),
	(308777, 146, '2015-01-01 00:31:01.000000', 'temperatura', 549.0000, 'ºC'),
	(308778, 146, '2015-01-01 00:31:02.000000', 'temperatura', 557.0000, 'ºC'),
	(308779, 146, '2015-01-01 00:31:03.000000', 'temperatura', 1137.0000, 'ºC'),
	(308780, 146, '2015-01-01 00:31:04.000000', 'temperatura', 414.0000, 'ºC'),
	(308781, 146, '2015-01-01 00:31:05.000000', 'temperatura', 1061.0000, 'ºC'),
	(308782, 146, '2015-01-01 00:31:06.000000', 'temperatura', 462.0000, 'ºC'),
	(308783, 146, '2015-01-01 00:31:07.000000', 'temperatura', 327.0000, 'ºC'),
	(308784, 146, '2015-01-01 00:31:08.000000', 'temperatura', 252.0000, 'ºC'),
	(308785, 146, '2015-01-01 00:31:09.000000', 'temperatura', 278.0000, 'ºC'),
	(308786, 146, '2015-01-01 00:31:10.000000', 'temperatura', 636.0000, 'ºC'),
	(308787, 146, '2015-01-01 00:31:11.000000', 'temperatura', 1144.0000, 'ºC'),
	(308788, 146, '2015-01-01 00:31:12.000000', 'temperatura', 212.0000, 'ºC'),
	(308789, 146, '2015-01-01 00:31:13.000000', 'temperatura', 30.0000, 'ºC'),
	(308790, 146, '2015-01-01 00:31:14.000000', 'temperatura', 714.0000, 'ºC'),
	(308791, 146, '2015-01-01 00:31:15.000000', 'temperatura', 1081.0000, 'ºC'),
	(308792, 146, '2015-01-01 00:31:16.000000', 'temperatura', 862.0000, 'ºC'),
	(308793, 146, '2015-01-01 00:31:17.000000', 'temperatura', 1066.0000, 'ºC'),
	(308794, 146, '2015-01-01 00:31:18.000000', 'temperatura', 347.0000, 'ºC'),
	(308795, 146, '2015-01-01 00:31:19.000000', 'temperatura', 939.0000, 'ºC'),
	(308796, 146, '2015-01-01 00:31:20.000000', 'temperatura', 53.0000, 'ºC'),
	(308797, 146, '2015-01-01 00:31:21.000000', 'temperatura', 1048.0000, 'ºC'),
	(308798, 146, '2015-01-01 00:31:22.000000', 'temperatura', 283.0000, 'ºC'),
	(308799, 146, '2015-01-01 00:31:23.000000', 'temperatura', 669.0000, 'ºC'),
	(308800, 146, '2015-01-01 00:31:24.000000', 'temperatura', 98.0000, 'ºC'),
	(308801, 146, '2015-01-01 00:31:25.000000', 'temperatura', 884.0000, 'ºC'),
	(308802, 146, '2015-01-01 00:31:26.000000', 'temperatura', 526.0000, 'ºC'),
	(308803, 146, '2015-01-01 00:31:27.000000', 'temperatura', 1178.0000, 'ºC'),
	(308804, 146, '2015-01-01 00:31:28.000000', 'temperatura', 713.0000, 'ºC'),
	(308805, 146, '2015-01-01 00:31:29.000000', 'temperatura', 30.0000, 'ºC'),
	(308806, 146, '2015-01-01 00:31:30.000000', 'temperatura', 414.0000, 'ºC'),
	(308807, 146, '2015-01-01 00:31:31.000000', 'temperatura', 779.0000, 'ºC'),
	(308808, 146, '2015-01-01 00:31:32.000000', 'temperatura', 255.0000, 'ºC'),
	(308809, 146, '2015-01-01 00:31:33.000000', 'temperatura', 138.0000, 'ºC'),
	(308810, 146, '2015-01-01 00:31:34.000000', 'temperatura', 1124.0000, 'ºC'),
	(308811, 146, '2015-01-01 00:31:35.000000', 'temperatura', 408.0000, 'ºC'),
	(308812, 146, '2015-01-01 00:31:36.000000', 'temperatura', 1070.0000, 'ºC'),
	(308813, 146, '2015-01-01 00:31:37.000000', 'temperatura', 526.0000, 'ºC'),
	(308814, 146, '2015-01-01 00:31:38.000000', 'temperatura', 619.0000, 'ºC'),
	(308815, 146, '2015-01-01 00:31:39.000000', 'temperatura', 318.0000, 'ºC'),
	(308816, 146, '2015-01-01 00:31:40.000000', 'temperatura', 932.0000, 'ºC'),
	(308817, 146, '2015-01-01 00:31:41.000000', 'temperatura', 107.0000, 'ºC'),
	(308818, 146, '2015-01-01 00:31:42.000000', 'temperatura', 141.0000, 'ºC'),
	(308819, 146, '2015-01-01 00:31:43.000000', 'temperatura', 382.0000, 'ºC'),
	(308820, 146, '2015-01-01 00:31:44.000000', 'temperatura', 288.0000, 'ºC'),
	(308821, 146, '2015-01-01 00:31:45.000000', 'temperatura', 295.0000, 'ºC'),
	(308822, 146, '2015-01-01 00:31:46.000000', 'temperatura', 612.0000, 'ºC'),
	(308823, 146, '2015-01-01 00:31:47.000000', 'temperatura', 975.0000, 'ºC'),
	(308824, 146, '2015-01-01 00:31:48.000000', 'temperatura', 639.0000, 'ºC'),
	(308825, 146, '2015-01-01 00:31:49.000000', 'temperatura', 272.0000, 'ºC'),
	(308826, 146, '2015-01-01 00:31:50.000000', 'temperatura', 642.0000, 'ºC'),
	(308827, 146, '2015-01-01 00:31:51.000000', 'temperatura', 1196.0000, 'ºC'),
	(308828, 146, '2015-01-01 00:31:52.000000', 'temperatura', 454.0000, 'ºC'),
	(308829, 146, '2015-01-01 00:31:53.000000', 'temperatura', 1083.0000, 'ºC'),
	(308830, 146, '2015-01-01 00:31:54.000000', 'temperatura', 453.0000, 'ºC'),
	(308831, 146, '2015-01-01 00:31:55.000000', 'temperatura', 218.0000, 'ºC'),
	(308832, 146, '2015-01-01 00:31:56.000000', 'temperatura', 929.0000, 'ºC'),
	(308833, 146, '2015-01-01 00:31:57.000000', 'temperatura', 393.0000, 'ºC'),
	(308834, 146, '2015-01-01 00:31:58.000000', 'temperatura', 377.0000, 'ºC'),
	(308835, 146, '2015-01-01 00:31:59.000000', 'temperatura', 707.0000, 'ºC'),
	(308836, 146, '2015-01-01 00:32:00.000000', 'temperatura', 6.0000, 'ºC'),
	(308837, 146, '2015-01-01 00:32:01.000000', 'temperatura', 308.0000, 'ºC'),
	(308838, 146, '2015-01-01 00:32:02.000000', 'temperatura', 324.0000, 'ºC'),
	(308839, 146, '2015-01-01 00:32:03.000000', 'temperatura', 696.0000, 'ºC'),
	(308840, 146, '2015-01-01 00:32:04.000000', 'temperatura', 107.0000, 'ºC'),
	(308841, 146, '2015-01-01 00:32:05.000000', 'temperatura', 849.0000, 'ºC'),
	(308842, 146, '2015-01-01 00:32:06.000000', 'temperatura', 325.0000, 'ºC'),
	(308843, 146, '2015-01-01 00:32:07.000000', 'temperatura', 277.0000, 'ºC'),
	(308844, 146, '2015-01-01 00:32:08.000000', 'temperatura', 413.0000, 'ºC'),
	(308845, 146, '2015-01-01 00:32:09.000000', 'temperatura', 34.0000, 'ºC'),
	(308846, 146, '2015-01-01 00:32:10.000000', 'temperatura', 129.0000, 'ºC'),
	(308847, 146, '2015-01-01 00:32:11.000000', 'temperatura', 545.0000, 'ºC'),
	(308848, 146, '2015-01-01 00:32:12.000000', 'temperatura', 1137.0000, 'ºC'),
	(308849, 146, '2015-01-01 00:32:13.000000', 'temperatura', 451.0000, 'ºC'),
	(308850, 146, '2015-01-01 00:32:14.000000', 'temperatura', 43.0000, 'ºC'),
	(308851, 146, '2015-01-01 00:32:15.000000', 'temperatura', 63.0000, 'ºC'),
	(308852, 146, '2015-01-01 00:32:16.000000', 'temperatura', 186.0000, 'ºC'),
	(308853, 146, '2015-01-01 00:32:17.000000', 'temperatura', 740.0000, 'ºC'),
	(308854, 146, '2015-01-01 00:32:18.000000', 'temperatura', 746.0000, 'ºC'),
	(308855, 146, '2015-01-01 00:32:19.000000', 'temperatura', 310.0000, 'ºC'),
	(308856, 146, '2015-01-01 00:32:20.000000', 'temperatura', 510.0000, 'ºC'),
	(308857, 146, '2015-01-01 00:32:21.000000', 'temperatura', 424.0000, 'ºC'),
	(308858, 146, '2015-01-01 00:32:22.000000', 'temperatura', 587.0000, 'ºC'),
	(308859, 146, '2015-01-01 00:32:23.000000', 'temperatura', 466.0000, 'ºC'),
	(308860, 146, '2015-01-01 00:32:24.000000', 'temperatura', 568.0000, 'ºC'),
	(308861, 146, '2015-01-01 00:32:25.000000', 'temperatura', 242.0000, 'ºC'),
	(308862, 146, '2015-01-01 00:32:26.000000', 'temperatura', 706.0000, 'ºC'),
	(308863, 146, '2015-01-01 00:32:27.000000', 'temperatura', 405.0000, 'ºC'),
	(308864, 146, '2015-01-01 00:32:28.000000', 'temperatura', 1107.0000, 'ºC'),
	(308865, 146, '2015-01-01 00:32:29.000000', 'temperatura', 722.0000, 'ºC'),
	(308866, 146, '2015-01-01 00:32:30.000000', 'temperatura', 287.0000, 'ºC'),
	(308867, 146, '2015-01-01 00:32:31.000000', 'temperatura', 470.0000, 'ºC'),
	(308868, 146, '2015-01-01 00:32:32.000000', 'temperatura', 292.0000, 'ºC'),
	(308869, 146, '2015-01-01 00:32:33.000000', 'temperatura', 49.0000, 'ºC'),
	(308870, 146, '2015-01-01 00:32:34.000000', 'temperatura', 571.0000, 'ºC'),
	(308871, 146, '2015-01-01 00:32:35.000000', 'temperatura', 305.0000, 'ºC'),
	(308872, 146, '2015-01-01 00:32:36.000000', 'temperatura', 1016.0000, 'ºC'),
	(308873, 146, '2015-01-01 00:32:37.000000', 'temperatura', 564.0000, 'ºC'),
	(308874, 146, '2015-01-01 00:32:38.000000', 'temperatura', 973.0000, 'ºC'),
	(308875, 146, '2015-01-01 00:32:39.000000', 'temperatura', 773.0000, 'ºC'),
	(308876, 146, '2015-01-01 00:32:40.000000', 'temperatura', 946.0000, 'ºC'),
	(308877, 146, '2015-01-01 00:32:41.000000', 'temperatura', 12.0000, 'ºC'),
	(308878, 146, '2015-01-01 00:32:42.000000', 'temperatura', 823.0000, 'ºC'),
	(308879, 146, '2015-01-01 00:32:43.000000', 'temperatura', 479.0000, 'ºC'),
	(308880, 146, '2015-01-01 00:32:44.000000', 'temperatura', 1128.0000, 'ºC'),
	(308881, 146, '2015-01-01 00:32:45.000000', 'temperatura', 602.0000, 'ºC'),
	(308882, 146, '2015-01-01 00:32:46.000000', 'temperatura', 827.0000, 'ºC'),
	(308883, 146, '2015-01-01 00:32:47.000000', 'temperatura', 1131.0000, 'ºC'),
	(308884, 146, '2015-01-01 00:32:48.000000', 'temperatura', 775.0000, 'ºC'),
	(308885, 146, '2015-01-01 00:32:49.000000', 'temperatura', 479.0000, 'ºC'),
	(308886, 146, '2015-01-01 00:32:50.000000', 'temperatura', 74.0000, 'ºC'),
	(308887, 146, '2015-01-01 00:32:51.000000', 'temperatura', 131.0000, 'ºC'),
	(308888, 146, '2015-01-01 00:32:52.000000', 'temperatura', 433.0000, 'ºC'),
	(308889, 146, '2015-01-01 00:32:53.000000', 'temperatura', 575.0000, 'ºC'),
	(308890, 146, '2015-01-01 00:32:54.000000', 'temperatura', 376.0000, 'ºC'),
	(308891, 146, '2015-01-01 00:32:55.000000', 'temperatura', 157.0000, 'ºC'),
	(308892, 146, '2015-01-01 00:32:56.000000', 'temperatura', 854.0000, 'ºC'),
	(308893, 146, '2015-01-01 00:32:57.000000', 'temperatura', 201.0000, 'ºC'),
	(308894, 146, '2015-01-01 00:32:58.000000', 'temperatura', 844.0000, 'ºC'),
	(308895, 146, '2015-01-01 00:32:59.000000', 'temperatura', 18.0000, 'ºC'),
	(308896, 146, '2015-01-01 00:33:00.000000', 'temperatura', 1156.0000, 'ºC'),
	(308897, 146, '2015-01-01 00:33:01.000000', 'temperatura', 928.0000, 'ºC'),
	(308898, 146, '2015-01-01 00:33:02.000000', 'temperatura', 1173.0000, 'ºC'),
	(308899, 146, '2015-01-01 00:33:03.000000', 'temperatura', 681.0000, 'ºC'),
	(308900, 146, '2015-01-01 00:33:04.000000', 'temperatura', 1089.0000, 'ºC'),
	(308901, 146, '2015-01-01 00:33:05.000000', 'temperatura', 999.0000, 'ºC'),
	(308902, 146, '2015-01-01 00:33:06.000000', 'temperatura', 530.0000, 'ºC'),
	(308903, 146, '2015-01-01 00:33:07.000000', 'temperatura', 855.0000, 'ºC'),
	(308904, 146, '2015-01-01 00:33:08.000000', 'temperatura', 286.0000, 'ºC'),
	(308905, 146, '2015-01-01 00:33:09.000000', 'temperatura', 63.0000, 'ºC'),
	(308906, 146, '2015-01-01 00:33:10.000000', 'temperatura', 656.0000, 'ºC'),
	(308907, 146, '2015-01-01 00:33:11.000000', 'temperatura', 695.0000, 'ºC'),
	(308908, 146, '2015-01-01 00:33:12.000000', 'temperatura', 306.0000, 'ºC'),
	(308909, 146, '2015-01-01 00:33:13.000000', 'temperatura', 647.0000, 'ºC'),
	(308910, 146, '2015-01-01 00:33:14.000000', 'temperatura', 1116.0000, 'ºC'),
	(308911, 146, '2015-01-01 00:33:15.000000', 'temperatura', 40.0000, 'ºC'),
	(308912, 146, '2015-01-01 00:33:16.000000', 'temperatura', 454.0000, 'ºC'),
	(308913, 146, '2015-01-01 00:33:17.000000', 'temperatura', 950.0000, 'ºC'),
	(308914, 146, '2015-01-01 00:33:18.000000', 'temperatura', 988.0000, 'ºC'),
	(308915, 146, '2015-01-01 00:33:19.000000', 'temperatura', 890.0000, 'ºC'),
	(308916, 146, '2015-01-01 00:33:20.000000', 'temperatura', 287.0000, 'ºC'),
	(308917, 146, '2015-01-01 00:33:21.000000', 'temperatura', 1166.0000, 'ºC'),
	(308918, 146, '2015-01-01 00:33:22.000000', 'temperatura', 170.0000, 'ºC'),
	(308919, 146, '2015-01-01 00:33:23.000000', 'temperatura', 951.0000, 'ºC'),
	(308920, 146, '2015-01-01 00:33:24.000000', 'temperatura', 647.0000, 'ºC'),
	(308921, 146, '2015-01-01 00:33:25.000000', 'temperatura', 383.0000, 'ºC'),
	(308922, 146, '2015-01-01 00:33:26.000000', 'temperatura', 1173.0000, 'ºC'),
	(308923, 146, '2015-01-01 00:33:27.000000', 'temperatura', 1116.0000, 'ºC'),
	(308924, 146, '2015-01-01 00:33:28.000000', 'temperatura', 860.0000, 'ºC'),
	(308925, 146, '2015-01-01 00:33:29.000000', 'temperatura', 954.0000, 'ºC'),
	(308926, 146, '2015-01-01 00:33:30.000000', 'temperatura', 992.0000, 'ºC'),
	(308927, 146, '2015-01-01 00:33:31.000000', 'temperatura', 899.0000, 'ºC'),
	(308928, 146, '2015-01-01 00:33:32.000000', 'temperatura', 317.0000, 'ºC'),
	(308929, 146, '2015-01-01 00:33:33.000000', 'temperatura', 90.0000, 'ºC'),
	(308930, 146, '2015-01-01 00:33:34.000000', 'temperatura', 698.0000, 'ºC'),
	(308931, 146, '2015-01-01 00:33:35.000000', 'temperatura', 820.0000, 'ºC'),
	(308932, 146, '2015-01-01 00:33:36.000000', 'temperatura', 809.0000, 'ºC'),
	(308933, 146, '2015-01-01 00:33:37.000000', 'temperatura', 384.0000, 'ºC'),
	(308934, 146, '2015-01-01 00:33:38.000000', 'temperatura', 695.0000, 'ºC'),
	(308935, 146, '2015-01-01 00:33:39.000000', 'temperatura', 1123.0000, 'ºC'),
	(308936, 146, '2015-01-01 00:33:40.000000', 'temperatura', 1129.0000, 'ºC'),
	(308937, 146, '2015-01-01 00:33:41.000000', 'temperatura', 1076.0000, 'ºC'),
	(308938, 146, '2015-01-01 00:33:42.000000', 'temperatura', 794.0000, 'ºC'),
	(308939, 146, '2015-01-01 00:33:43.000000', 'temperatura', 741.0000, 'ºC'),
	(308940, 146, '2015-01-01 00:33:44.000000', 'temperatura', 123.0000, 'ºC'),
	(308941, 146, '2015-01-01 00:33:45.000000', 'temperatura', 796.0000, 'ºC'),
	(308942, 146, '2015-01-01 00:33:46.000000', 'temperatura', 9.0000, 'ºC'),
	(308943, 146, '2015-01-01 00:33:47.000000', 'temperatura', 56.0000, 'ºC'),
	(308944, 146, '2015-01-01 00:33:48.000000', 'temperatura', 255.0000, 'ºC'),
	(308945, 146, '2015-01-01 00:33:49.000000', 'temperatura', 1108.0000, 'ºC'),
	(308946, 146, '2015-01-01 00:33:50.000000', 'temperatura', 1176.0000, 'ºC'),
	(308947, 146, '2015-01-01 00:33:51.000000', 'temperatura', 155.0000, 'ºC'),
	(308948, 146, '2015-01-01 00:33:52.000000', 'temperatura', 846.0000, 'ºC'),
	(308949, 146, '2015-01-01 00:33:53.000000', 'temperatura', 169.0000, 'ºC'),
	(308950, 146, '2015-01-01 00:33:54.000000', 'temperatura', 704.0000, 'ºC'),
	(308951, 146, '2015-01-01 00:33:55.000000', 'temperatura', 615.0000, 'ºC'),
	(308952, 146, '2015-01-01 00:33:56.000000', 'temperatura', 964.0000, 'ºC'),
	(308953, 146, '2015-01-01 00:33:57.000000', 'temperatura', 575.0000, 'ºC'),
	(308954, 146, '2015-01-01 00:33:58.000000', 'temperatura', 1182.0000, 'ºC'),
	(308955, 146, '2015-01-01 00:33:59.000000', 'temperatura', 587.0000, 'ºC'),
	(308956, 146, '2015-01-01 00:34:00.000000', 'temperatura', 591.0000, 'ºC'),
	(308957, 146, '2015-01-01 00:34:01.000000', 'temperatura', 1193.0000, 'ºC'),
	(308958, 146, '2015-01-01 00:34:02.000000', 'temperatura', 591.0000, 'ºC'),
	(308959, 146, '2015-01-01 00:34:03.000000', 'temperatura', 578.0000, 'ºC'),
	(308960, 146, '2015-01-01 00:34:04.000000', 'temperatura', 1119.0000, 'ºC'),
	(308961, 146, '2015-01-01 00:34:05.000000', 'temperatura', 261.0000, 'ºC'),
	(308962, 146, '2015-01-01 00:34:06.000000', 'temperatura', 346.0000, 'ºC'),
	(308963, 146, '2015-01-01 00:34:07.000000', 'temperatura', 951.0000, 'ºC'),
	(308964, 146, '2015-01-01 00:34:08.000000', 'temperatura', 115.0000, 'ºC'),
	(308965, 146, '2015-01-01 00:34:09.000000', 'temperatura', 122.0000, 'ºC'),
	(308966, 146, '2015-01-01 00:34:10.000000', 'temperatura', 265.0000, 'ºC'),
	(308967, 146, '2015-01-01 00:34:11.000000', 'temperatura', 960.0000, 'ºC'),
	(308968, 146, '2015-01-01 00:34:12.000000', 'temperatura', 405.0000, 'ºC'),
	(308969, 146, '2015-01-01 00:34:13.000000', 'temperatura', 344.0000, 'ºC'),
	(308970, 146, '2015-01-01 00:34:14.000000', 'temperatura', 508.0000, 'ºC'),
	(308971, 146, '2015-01-01 00:34:15.000000', 'temperatura', 309.0000, 'ºC'),
	(308972, 146, '2015-01-01 00:34:16.000000', 'temperatura', 20.0000, 'ºC'),
	(308973, 146, '2015-01-01 00:34:17.000000', 'temperatura', 376.0000, 'ºC'),
	(308974, 146, '2015-01-01 00:34:18.000000', 'temperatura', 619.0000, 'ºC'),
	(308975, 146, '2015-01-01 00:34:19.000000', 'temperatura', 766.0000, 'ºC'),
	(308976, 146, '2015-01-01 00:34:20.000000', 'temperatura', 776.0000, 'ºC'),
	(308977, 146, '2015-01-01 00:34:21.000000', 'temperatura', 382.0000, 'ºC'),
	(308978, 146, '2015-01-01 00:34:22.000000', 'temperatura', 782.0000, 'ºC'),
	(308979, 146, '2015-01-01 00:34:23.000000', 'temperatura', 363.0000, 'ºC'),
	(308980, 146, '2015-01-01 00:34:24.000000', 'temperatura', 671.0000, 'ºC'),
	(308981, 146, '2015-01-01 00:34:25.000000', 'temperatura', 1067.0000, 'ºC'),
	(308982, 146, '2015-01-01 00:34:26.000000', 'temperatura', 922.0000, 'ºC'),
	(308983, 146, '2015-01-01 00:34:27.000000', 'temperatura', 210.0000, 'ºC'),
	(308984, 146, '2015-01-01 00:34:28.000000', 'temperatura', 685.0000, 'ºC'),
	(308985, 146, '2015-01-01 00:34:29.000000', 'temperatura', 395.0000, 'ºC'),
	(308986, 146, '2015-01-01 00:34:30.000000', 'temperatura', 1121.0000, 'ºC'),
	(308987, 146, '2015-01-01 00:34:31.000000', 'temperatura', 820.0000, 'ºC'),
	(308988, 146, '2015-01-01 00:34:32.000000', 'temperatura', 739.0000, 'ºC'),
	(308989, 146, '2015-01-01 00:34:33.000000', 'temperatura', 36.0000, 'ºC'),
	(308990, 146, '2015-01-01 00:34:34.000000', 'temperatura', 361.0000, 'ºC'),
	(308991, 146, '2015-01-01 00:34:35.000000', 'temperatura', 500.0000, 'ºC'),
	(308992, 146, '2015-01-01 00:34:36.000000', 'temperatura', 218.0000, 'ºC'),
	(308993, 146, '2015-01-01 00:34:37.000000', 'temperatura', 788.0000, 'ºC'),
	(308994, 146, '2015-01-01 00:34:38.000000', 'temperatura', 888.0000, 'ºC'),
	(308995, 146, '2015-01-01 00:34:39.000000', 'temperatura', 877.0000, 'ºC'),
	(308996, 146, '2015-01-01 00:34:40.000000', 'temperatura', 519.0000, 'ºC'),
	(308997, 146, '2015-01-01 00:34:41.000000', 'temperatura', 1167.0000, 'ºC'),
	(308998, 146, '2015-01-01 00:34:42.000000', 'temperatura', 676.0000, 'ºC'),
	(308999, 146, '2015-01-01 00:34:43.000000', 'temperatura', 1081.0000, 'ºC'),
	(309000, 146, '2015-01-01 00:34:44.000000', 'temperatura', 975.0000, 'ºC'),
	(309001, 146, '2015-01-01 00:34:45.000000', 'temperatura', 435.0000, 'ºC'),
	(309002, 146, '2015-01-01 00:34:46.000000', 'temperatura', 452.0000, 'ºC'),
	(309003, 146, '2015-01-01 00:34:47.000000', 'temperatura', 953.0000, 'ºC'),
	(309004, 146, '2015-01-01 00:34:48.000000', 'temperatura', 1012.0000, 'ºC'),
	(309005, 146, '2015-01-01 00:34:49.000000', 'temperatura', 1001.0000, 'ºC'),
	(309006, 146, '2015-01-01 00:34:50.000000', 'temperatura', 768.0000, 'ºC'),
	(309007, 146, '2015-01-01 00:34:51.000000', 'temperatura', 840.0000, 'ºC'),
	(309008, 146, '2015-01-01 00:34:52.000000', 'temperatura', 695.0000, 'ºC'),
	(309009, 146, '2015-01-01 00:34:53.000000', 'temperatura', 954.0000, 'ºC'),
	(309010, 146, '2015-01-01 00:34:54.000000', 'temperatura', 285.0000, 'ºC'),
	(309011, 146, '2015-01-01 00:34:55.000000', 'temperatura', 966.0000, 'ºC'),
	(309012, 146, '2015-01-01 00:34:56.000000', 'temperatura', 374.0000, 'ºC'),
	(309013, 146, '2015-01-01 00:34:57.000000', 'temperatura', 171.0000, 'ºC'),
	(309014, 146, '2015-01-01 00:34:58.000000', 'temperatura', 936.0000, 'ºC'),
	(309015, 146, '2015-01-01 00:34:59.000000', 'temperatura', 568.0000, 'ºC'),
	(309016, 146, '2015-01-01 00:35:00.000000', 'temperatura', 30.0000, 'ºC'),
	(309017, 146, '2015-01-01 00:35:01.000000', 'temperatura', 846.0000, 'ºC'),
	(309018, 146, '2015-01-01 00:35:02.000000', 'temperatura', 543.0000, 'ºC'),
	(309019, 146, '2015-01-01 00:35:03.000000', 'temperatura', 176.0000, 'ºC'),
	(309020, 146, '2015-01-01 00:35:04.000000', 'temperatura', 452.0000, 'ºC'),
	(309021, 146, '2015-01-01 00:35:05.000000', 'temperatura', 534.0000, 'ºC'),
	(309022, 146, '2015-01-01 00:35:06.000000', 'temperatura', 113.0000, 'ºC'),
	(309023, 146, '2015-01-01 00:35:07.000000', 'temperatura', 165.0000, 'ºC'),
	(309024, 146, '2015-01-01 00:35:08.000000', 'temperatura', 486.0000, 'ºC'),
	(309025, 146, '2015-01-01 00:35:09.000000', 'temperatura', 737.0000, 'ºC'),
	(309026, 146, '2015-01-01 00:35:10.000000', 'temperatura', 1028.0000, 'ºC'),
	(309027, 146, '2015-01-01 00:35:11.000000', 'temperatura', 528.0000, 'ºC'),
	(309028, 146, '2015-01-01 00:35:12.000000', 'temperatura', 758.0000, 'ºC'),
	(309029, 146, '2015-01-01 00:35:13.000000', 'temperatura', 1003.0000, 'ºC'),
	(309030, 146, '2015-01-01 00:35:14.000000', 'temperatura', 345.0000, 'ºC'),
	(309031, 146, '2015-01-01 00:35:15.000000', 'temperatura', 1117.0000, 'ºC'),
	(309032, 146, '2015-01-01 00:35:16.000000', 'temperatura', 950.0000, 'ºC'),
	(309033, 146, '2015-01-01 00:35:17.000000', 'temperatura', 198.0000, 'ºC'),
	(309034, 146, '2015-01-01 00:35:18.000000', 'temperatura', 541.0000, 'ºC'),
	(309035, 146, '2015-01-01 00:35:19.000000', 'temperatura', 911.0000, 'ºC'),
	(309036, 146, '2015-01-01 00:35:20.000000', 'temperatura', 534.0000, 'ºC'),
	(309037, 146, '2015-01-01 00:35:21.000000', 'temperatura', 1139.0000, 'ºC'),
	(309038, 146, '2015-01-01 00:35:22.000000', 'temperatura', 491.0000, 'ºC'),
	(309039, 146, '2015-01-01 00:35:23.000000', 'temperatura', 239.0000, 'ºC'),
	(309040, 146, '2015-01-01 00:35:24.000000', 'temperatura', 923.0000, 'ºC'),
	(309041, 146, '2015-01-01 00:35:25.000000', 'temperatura', 299.0000, 'ºC'),
	(309042, 146, '2015-01-01 00:35:26.000000', 'temperatura', 1124.0000, 'ºC'),
	(309043, 146, '2015-01-01 00:35:27.000000', 'temperatura', 1125.0000, 'ºC'),
	(309044, 146, '2015-01-01 00:35:28.000000', 'temperatura', 1054.0000, 'ºC'),
	(309045, 146, '2015-01-01 00:35:29.000000', 'temperatura', 697.0000, 'ºC'),
	(309046, 146, '2015-01-01 00:35:30.000000', 'temperatura', 320.0000, 'ºC'),
	(309047, 146, '2015-01-01 00:35:31.000000', 'temperatura', 712.0000, 'ºC'),
	(309048, 146, '2015-01-01 00:35:32.000000', 'temperatura', 200.0000, 'ºC'),
	(309049, 146, '2015-01-01 00:35:33.000000', 'temperatura', 66.0000, 'ºC'),
	(309050, 146, '2015-01-01 00:35:34.000000', 'temperatura', 931.0000, 'ºC'),
	(309051, 146, '2015-01-01 00:35:35.000000', 'temperatura', 855.0000, 'ºC'),
	(309052, 146, '2015-01-01 00:35:36.000000', 'temperatura', 285.0000, 'ºC'),
	(309053, 146, '2015-01-01 00:35:37.000000', 'temperatura', 60.0000, 'ºC'),
	(309054, 146, '2015-01-01 00:35:38.000000', 'temperatura', 645.0000, 'ºC'),
	(309055, 146, '2015-01-01 00:35:39.000000', 'temperatura', 645.0000, 'ºC'),
	(309056, 146, '2015-01-01 00:35:40.000000', 'temperatura', 90.0000, 'ºC'),
	(309057, 146, '2015-01-01 00:35:41.000000', 'temperatura', 918.0000, 'ºC'),
	(309058, 146, '2015-01-01 00:35:42.000000', 'temperatura', 720.0000, 'ºC'),
	(309059, 146, '2015-01-01 00:35:43.000000', 'temperatura', 846.0000, 'ºC'),
	(309060, 146, '2015-01-01 00:35:44.000000', 'temperatura', 869.0000, 'ºC'),
	(309061, 146, '2015-01-01 00:35:45.000000', 'temperatura', 609.0000, 'ºC'),
	(309062, 146, '2015-01-01 00:35:46.000000', 'temperatura', 438.0000, 'ºC'),
	(309063, 146, '2015-01-01 00:35:47.000000', 'temperatura', 364.0000, 'ºC'),
	(309064, 146, '2015-01-01 00:35:48.000000', 'temperatura', 505.0000, 'ºC'),
	(309065, 146, '2015-01-01 00:35:49.000000', 'temperatura', 235.0000, 'ºC'),
	(309066, 146, '2015-01-01 00:35:50.000000', 'temperatura', 862.0000, 'ºC'),
	(309067, 146, '2015-01-01 00:35:51.000000', 'temperatura', 3.0000, 'ºC'),
	(309068, 146, '2015-01-01 00:35:52.000000', 'temperatura', 1030.0000, 'ºC'),
	(309069, 146, '2015-01-01 00:35:53.000000', 'temperatura', 340.0000, 'ºC'),
	(309070, 146, '2015-01-01 00:35:54.000000', 'temperatura', 1013.0000, 'ºC'),
	(309071, 146, '2015-01-01 00:35:55.000000', 'temperatura', 443.0000, 'ºC'),
	(309072, 146, '2015-01-01 00:35:56.000000', 'temperatura', 376.0000, 'ºC'),
	(309073, 146, '2015-01-01 00:35:57.000000', 'temperatura', 554.0000, 'ºC'),
	(309074, 146, '2015-01-01 00:35:58.000000', 'temperatura', 441.0000, 'ºC'),
	(309075, 146, '2015-01-01 00:35:59.000000', 'temperatura', 542.0000, 'ºC'),
	(309076, 146, '2015-01-01 00:36:00.000000', 'temperatura', 191.0000, 'ºC'),
	(309077, 146, '2015-01-01 00:36:01.000000', 'temperatura', 526.0000, 'ºC'),
	(309078, 146, '2015-01-01 00:36:02.000000', 'temperatura', 860.0000, 'ºC'),
	(309079, 146, '2015-01-01 00:36:03.000000', 'temperatura', 321.0000, 'ºC'),
	(309080, 146, '2015-01-01 00:36:04.000000', 'temperatura', 226.0000, 'ºC'),
	(309081, 146, '2015-01-01 00:36:05.000000', 'temperatura', 167.0000, 'ºC'),
	(309082, 146, '2015-01-01 00:36:06.000000', 'temperatura', 159.0000, 'ºC'),
	(309083, 146, '2015-01-01 00:36:07.000000', 'temperatura', 293.0000, 'ºC'),
	(309084, 146, '2015-01-01 00:36:08.000000', 'temperatura', 991.0000, 'ºC'),
	(309085, 146, '2015-01-01 00:36:09.000000', 'temperatura', 474.0000, 'ºC'),
	(309086, 146, '2015-01-01 00:36:10.000000', 'temperatura', 598.0000, 'ºC'),
	(309087, 146, '2015-01-01 00:36:11.000000', 'temperatura', 370.0000, 'ºC'),
	(309088, 146, '2015-01-01 00:36:12.000000', 'temperatura', 54.0000, 'ºC'),
	(309089, 146, '2015-01-01 00:36:13.000000', 'temperatura', 360.0000, 'ºC'),
	(309090, 146, '2015-01-01 00:36:14.000000', 'temperatura', 441.0000, 'ºC'),
	(309091, 146, '2015-01-01 00:36:15.000000', 'temperatura', 1127.0000, 'ºC'),
	(309092, 146, '2015-01-01 00:36:16.000000', 'temperatura', 709.0000, 'ºC'),
	(309093, 146, '2015-01-01 00:36:17.000000', 'temperatura', 166.0000, 'ºC'),
	(309094, 146, '2015-01-01 00:36:18.000000', 'temperatura', 1104.0000, 'ºC'),
	(309095, 146, '2015-01-01 00:36:19.000000', 'temperatura', 221.0000, 'ºC'),
	(309096, 146, '2015-01-01 00:36:20.000000', 'temperatura', 194.0000, 'ºC'),
	(309097, 146, '2015-01-01 00:36:21.000000', 'temperatura', 308.0000, 'ºC'),
	(309098, 146, '2015-01-01 00:36:22.000000', 'temperatura', 959.0000, 'ºC'),
	(309099, 146, '2015-01-01 00:36:23.000000', 'temperatura', 269.0000, 'ºC'),
	(309100, 146, '2015-01-01 00:36:24.000000', 'temperatura', 869.0000, 'ºC'),
	(309101, 146, '2015-01-01 00:36:25.000000', 'temperatura', 1141.0000, 'ºC'),
	(309102, 146, '2015-01-01 00:36:26.000000', 'temperatura', 697.0000, 'ºC'),
	(309103, 146, '2015-01-01 00:36:27.000000', 'temperatura', 61.0000, 'ºC'),
	(309104, 146, '2015-01-01 00:36:28.000000', 'temperatura', 615.0000, 'ºC'),
	(309105, 146, '2015-01-01 00:36:29.000000', 'temperatura', 491.0000, 'ºC'),
	(309106, 146, '2015-01-01 00:36:30.000000', 'temperatura', 614.0000, 'ºC'),
	(309107, 146, '2015-01-01 00:36:31.000000', 'temperatura', 395.0000, 'ºC'),
	(309108, 146, '2015-01-01 00:36:32.000000', 'temperatura', 134.0000, 'ºC'),
	(309109, 146, '2015-01-01 00:36:33.000000', 'temperatura', 686.0000, 'ºC'),
	(309110, 146, '2015-01-01 00:36:34.000000', 'temperatura', 629.0000, 'ºC'),
	(309111, 146, '2015-01-01 00:36:35.000000', 'temperatura', 1086.0000, 'ºC'),
	(309112, 146, '2015-01-01 00:36:36.000000', 'temperatura', 1143.0000, 'ºC'),
	(309113, 146, '2015-01-01 00:36:37.000000', 'temperatura', 60.0000, 'ºC'),
	(309114, 146, '2015-01-01 00:36:38.000000', 'temperatura', 469.0000, 'ºC'),
	(309115, 146, '2015-01-01 00:36:39.000000', 'temperatura', 966.0000, 'ºC'),
	(309116, 146, '2015-01-01 00:36:40.000000', 'temperatura', 1024.0000, 'ºC'),
	(309117, 146, '2015-01-01 00:36:41.000000', 'temperatura', 1024.0000, 'ºC'),
	(309118, 146, '2015-01-01 00:36:42.000000', 'temperatura', 848.0000, 'ºC'),
	(309119, 146, '2015-01-01 00:36:43.000000', 'temperatura', 1166.0000, 'ºC'),
	(309120, 146, '2015-01-01 00:36:44.000000', 'temperatura', 890.0000, 'ºC'),
	(309121, 146, '2015-01-01 00:36:45.000000', 'temperatura', 950.0000, 'ºC'),
	(309122, 146, '2015-01-01 00:36:46.000000', 'temperatura', 880.0000, 'ºC'),
	(309123, 146, '2015-01-01 00:36:47.000000', 'temperatura', 350.0000, 'ºC'),
	(309124, 146, '2015-01-01 00:36:48.000000', 'temperatura', 311.0000, 'ºC'),
	(309125, 146, '2015-01-01 00:36:49.000000', 'temperatura', 508.0000, 'ºC'),
	(309126, 146, '2015-01-01 00:36:50.000000', 'temperatura', 406.0000, 'ºC'),
	(309127, 146, '2015-01-01 00:36:51.000000', 'temperatura', 505.0000, 'ºC'),
	(309128, 146, '2015-01-01 00:36:52.000000', 'temperatura', 110.0000, 'ºC'),
	(309129, 146, '2015-01-01 00:36:53.000000', 'temperatura', 234.0000, 'ºC'),
	(309130, 146, '2015-01-01 00:36:54.000000', 'temperatura', 840.0000, 'ºC'),
	(309131, 146, '2015-01-01 00:36:55.000000', 'temperatura', 1098.0000, 'ºC'),
	(309132, 146, '2015-01-01 00:36:56.000000', 'temperatura', 573.0000, 'ºC'),
	(309133, 146, '2015-01-01 00:36:57.000000', 'temperatura', 771.0000, 'ºC'),
	(309134, 146, '2015-01-01 00:36:58.000000', 'temperatura', 935.0000, 'ºC'),
	(309135, 146, '2015-01-01 00:36:59.000000', 'temperatura', 1164.0000, 'ºC'),
	(309136, 146, '2015-01-01 00:37:00.000000', 'temperatura', 617.0000, 'ºC'),
	(309137, 146, '2015-01-01 00:37:01.000000', 'temperatura', 792.0000, 'ºC'),
	(309138, 146, '2015-01-01 00:37:02.000000', 'temperatura', 908.0000, 'ºC'),
	(309139, 146, '2015-01-01 00:37:03.000000', 'temperatura', 963.0000, 'ºC'),
	(309140, 146, '2015-01-01 00:37:04.000000', 'temperatura', 895.0000, 'ºC'),
	(309141, 146, '2015-01-01 00:37:05.000000', 'temperatura', 387.0000, 'ºC'),
	(309142, 146, '2015-01-01 00:37:06.000000', 'temperatura', 450.0000, 'ºC'),
	(309143, 146, '2015-01-01 00:37:07.000000', 'temperatura', 1090.0000, 'ºC'),
	(309144, 146, '2015-01-01 00:37:08.000000', 'temperatura', 499.0000, 'ºC'),
	(309145, 146, '2015-01-01 00:37:09.000000', 'temperatura', 425.0000, 'ºC'),
	(309146, 146, '2015-01-01 00:37:10.000000', 'temperatura', 628.0000, 'ºC'),
	(309147, 146, '2015-01-01 00:37:11.000000', 'temperatura', 665.0000, 'ºC'),
	(309148, 146, '2015-01-01 00:37:12.000000', 'temperatura', 242.0000, 'ºC'),
	(309149, 146, '2015-01-01 00:37:13.000000', 'temperatura', 415.0000, 'ºC'),
	(309150, 146, '2015-01-01 00:37:14.000000', 'temperatura', 150.0000, 'ºC'),
	(309151, 146, '2015-01-01 00:37:15.000000', 'temperatura', 704.0000, 'ºC'),
	(309152, 146, '2015-01-01 00:37:16.000000', 'temperatura', 672.0000, 'ºC'),
	(309153, 146, '2015-01-01 00:37:17.000000', 'temperatura', 50.0000, 'ºC'),
	(309154, 146, '2015-01-01 00:37:18.000000', 'temperatura', 634.0000, 'ºC'),
	(309155, 146, '2015-01-01 00:37:19.000000', 'temperatura', 618.0000, 'ºC'),
	(309156, 146, '2015-01-01 00:37:20.000000', 'temperatura', 1190.0000, 'ºC'),
	(309157, 146, '2015-01-01 00:37:21.000000', 'temperatura', 496.0000, 'ºC'),
	(309158, 146, '2015-01-01 00:37:22.000000', 'temperatura', 110.0000, 'ºC'),
	(309159, 146, '2015-01-01 00:37:23.000000', 'temperatura', 265.0000, 'ºC'),
	(309160, 146, '2015-01-01 00:37:24.000000', 'temperatura', 994.0000, 'ºC'),
	(309161, 146, '2015-01-01 00:37:25.000000', 'temperatura', 578.0000, 'ºC'),
	(309162, 146, '2015-01-01 00:37:26.000000', 'temperatura', 1105.0000, 'ºC'),
	(309163, 146, '2015-01-01 00:37:27.000000', 'temperatura', 194.0000, 'ºC'),
	(309164, 146, '2015-01-01 00:37:28.000000', 'temperatura', 56.0000, 'ºC'),
	(309165, 146, '2015-01-01 00:37:29.000000', 'temperatura', 898.0000, 'ºC'),
	(309166, 146, '2015-01-01 00:37:30.000000', 'temperatura', 721.0000, 'ºC'),
	(309167, 146, '2015-01-01 00:37:31.000000', 'temperatura', 912.0000, 'ºC'),
	(309168, 146, '2015-01-01 00:37:32.000000', 'temperatura', 0.0000, 'ºC'),
	(309169, 146, '2015-01-01 00:37:33.000000', 'temperatura', 861.0000, 'ºC'),
	(309170, 146, '2015-01-01 00:37:34.000000', 'temperatura', 708.0000, 'ºC'),
	(309171, 146, '2015-01-01 00:37:35.000000', 'temperatura', 956.0000, 'ºC'),
	(309172, 146, '2015-01-01 00:37:36.000000', 'temperatura', 255.0000, 'ºC'),
	(309173, 146, '2015-01-01 00:37:37.000000', 'temperatura', 810.0000, 'ºC'),
	(309174, 146, '2015-01-01 00:37:38.000000', 'temperatura', 886.0000, 'ºC'),
	(309175, 146, '2015-01-01 00:37:39.000000', 'temperatura', 801.0000, 'ºC'),
	(309176, 146, '2015-01-01 00:37:40.000000', 'temperatura', 148.0000, 'ºC'),
	(309177, 146, '2015-01-01 00:37:41.000000', 'temperatura', 738.0000, 'ºC'),
	(309178, 146, '2015-01-01 00:37:42.000000', 'temperatura', 846.0000, 'ºC'),
	(309179, 146, '2015-01-01 00:37:43.000000', 'temperatura', 815.0000, 'ºC'),
	(309180, 146, '2015-01-01 00:37:44.000000', 'temperatura', 337.0000, 'ºC'),
	(309181, 146, '2015-01-01 00:37:45.000000', 'temperatura', 442.0000, 'ºC'),
	(309182, 146, '2015-01-01 00:37:46.000000', 'temperatura', 1.0000, 'ºC'),
	(309183, 146, '2015-01-01 00:37:47.000000', 'temperatura', 1077.0000, 'ºC'),
	(309184, 146, '2015-01-01 00:37:48.000000', 'temperatura', 583.0000, 'ºC'),
	(309185, 146, '2015-01-01 00:37:49.000000', 'temperatura', 885.0000, 'ºC'),
	(309186, 146, '2015-01-01 00:37:50.000000', 'temperatura', 275.0000, 'ºC'),
	(309187, 146, '2015-01-01 00:37:51.000000', 'temperatura', 1121.0000, 'ºC'),
	(309188, 146, '2015-01-01 00:37:52.000000', 'temperatura', 1179.0000, 'ºC'),
	(309189, 146, '2015-01-01 00:37:53.000000', 'temperatura', 133.0000, 'ºC'),
	(309190, 146, '2015-01-01 00:37:54.000000', 'temperatura', 727.0000, 'ºC'),
	(309191, 146, '2015-01-01 00:37:55.000000', 'temperatura', 838.0000, 'ºC'),
	(309192, 146, '2015-01-01 00:37:56.000000', 'temperatura', 808.0000, 'ºC'),
	(309193, 146, '2015-01-01 00:37:57.000000', 'temperatura', 328.0000, 'ºC'),
	(309194, 146, '2015-01-01 00:37:58.000000', 'temperatura', 417.0000, 'ºC'),
	(309195, 146, '2015-01-01 00:37:59.000000', 'temperatura', 1100.0000, 'ºC'),
	(309196, 146, '2015-01-01 00:38:00.000000', 'temperatura', 648.0000, 'ºC'),
	(309197, 146, '2015-01-01 00:38:01.000000', 'temperatura', 1143.0000, 'ºC'),
	(309198, 146, '2015-01-01 00:38:02.000000', 'temperatura', 171.0000, 'ºC'),
	(309199, 146, '2015-01-01 00:38:03.000000', 'temperatura', 1024.0000, 'ºC'),
	(309200, 146, '2015-01-01 00:38:04.000000', 'temperatura', 1011.0000, 'ºC'),
	(309201, 146, '2015-01-01 00:38:05.000000', 'temperatura', 782.0000, 'ºC'),
	(309202, 146, '2015-01-01 00:38:06.000000', 'temperatura', 879.0000, 'ºC'),
	(309203, 146, '2015-01-01 00:38:07.000000', 'temperatura', 850.0000, 'ºC'),
	(309204, 146, '2015-01-01 00:38:08.000000', 'temperatura', 412.0000, 'ºC'),
	(309205, 146, '2015-01-01 00:38:09.000000', 'temperatura', 711.0000, 'ºC'),
	(309206, 146, '2015-01-01 00:38:10.000000', 'temperatura', 1120.0000, 'ºC'),
	(309207, 146, '2015-01-01 00:38:11.000000', 'temperatura', 1067.0000, 'ºC'),
	(309208, 146, '2015-01-01 00:38:12.000000', 'temperatura', 775.0000, 'ºC'),
	(309209, 146, '2015-01-01 00:38:13.000000', 'temperatura', 677.0000, 'ºC'),
	(309210, 146, '2015-01-01 00:38:14.000000', 'temperatura', 1057.0000, 'ºC'),
	(309211, 146, '2015-01-01 00:38:15.000000', 'temperatura', 856.0000, 'ºC'),
	(309212, 146, '2015-01-01 00:38:16.000000', 'temperatura', 1111.0000, 'ºC'),
	(309213, 146, '2015-01-01 00:38:17.000000', 'temperatura', 584.0000, 'ºC'),
	(309214, 146, '2015-01-01 00:38:18.000000', 'temperatura', 791.0000, 'ºC'),
	(309215, 146, '2015-01-01 00:38:19.000000', 'temperatura', 1004.0000, 'ºC'),
	(309216, 146, '2015-01-01 00:38:20.000000', 'temperatura', 245.0000, 'ºC'),
	(309217, 146, '2015-01-01 00:38:21.000000', 'temperatura', 612.0000, 'ºC'),
	(309218, 146, '2015-01-01 00:38:22.000000', 'temperatura', 1129.0000, 'ºC'),
	(309219, 146, '2015-01-01 00:38:23.000000', 'temperatura', 209.0000, 'ºC'),
	(309220, 146, '2015-01-01 00:38:24.000000', 'temperatura', 58.0000, 'ºC'),
	(309221, 146, '2015-01-01 00:38:25.000000', 'temperatura', 863.0000, 'ºC'),
	(309222, 146, '2015-01-01 00:38:26.000000', 'temperatura', 540.0000, 'ºC'),
	(309223, 146, '2015-01-01 00:38:27.000000', 'temperatura', 112.0000, 'ºC'),
	(309224, 146, '2015-01-01 00:38:28.000000', 'temperatura', 141.0000, 'ºC'),
	(309225, 146, '2015-01-01 00:38:29.000000', 'temperatura', 368.0000, 'ºC'),
	(309226, 146, '2015-01-01 00:38:30.000000', 'temperatura', 219.0000, 'ºC'),
	(309227, 146, '2015-01-01 00:38:31.000000', 'temperatura', 1192.0000, 'ºC'),
	(309228, 146, '2015-01-01 00:38:32.000000', 'temperatura', 501.0000, 'ºC'),
	(309229, 146, '2015-01-01 00:38:33.000000', 'temperatura', 131.0000, 'ºC'),
	(309230, 146, '2015-01-01 00:38:34.000000', 'temperatura', 354.0000, 'ºC'),
	(309231, 146, '2015-01-01 00:38:35.000000', 'temperatura', 176.0000, 'ºC'),
	(309232, 146, '2015-01-01 00:38:36.000000', 'temperatura', 1020.0000, 'ºC'),
	(309233, 146, '2015-01-01 00:38:37.000000', 'temperatura', 972.0000, 'ºC'),
	(309234, 146, '2015-01-01 00:38:38.000000', 'temperatura', 602.0000, 'ºC'),
	(309235, 146, '2015-01-01 00:38:39.000000', 'temperatura', 91.0000, 'ºC'),
	(309236, 146, '2015-01-01 00:38:40.000000', 'temperatura', 1052.0000, 'ºC'),
	(309237, 146, '2015-01-01 00:38:41.000000', 'temperatura', 187.0000, 'ºC'),
	(309238, 146, '2015-01-01 00:38:42.000000', 'temperatura', 177.0000, 'ºC'),
	(309239, 146, '2015-01-01 00:38:43.000000', 'temperatura', 328.0000, 'ºC'),
	(309240, 146, '2015-01-01 00:38:44.000000', 'temperatura', 1107.0000, 'ºC'),
	(309241, 146, '2015-01-01 00:38:45.000000', 'temperatura', 954.0000, 'ºC'),
	(309242, 146, '2015-01-01 00:38:46.000000', 'temperatura', 248.0000, 'ºC'),
	(309243, 146, '2015-01-01 00:38:47.000000', 'temperatura', 779.0000, 'ºC'),
	(309244, 146, '2015-01-01 00:38:48.000000', 'temperatura', 750.0000, 'ºC'),
	(309245, 146, '2015-01-01 00:38:49.000000', 'temperatura', 215.0000, 'ºC'),
	(309246, 146, '2015-01-01 00:38:50.000000', 'temperatura', 23.0000, 'ºC'),
	(309247, 146, '2015-01-01 00:38:51.000000', 'temperatura', 673.0000, 'ºC'),
	(309248, 146, '2015-01-01 00:38:52.000000', 'temperatura', 898.0000, 'ºC'),
	(309249, 146, '2015-01-01 00:38:53.000000', 'temperatura', 68.0000, 'ºC'),
	(309250, 146, '2015-01-01 00:38:54.000000', 'temperatura', 50.0000, 'ºC'),
	(309251, 146, '2015-01-01 00:38:55.000000', 'temperatura', 44.0000, 'ºC'),
	(309252, 146, '2015-01-01 00:38:56.000000', 'temperatura', 71.0000, 'ºC'),
	(309253, 146, '2015-01-01 00:38:57.000000', 'temperatura', 222.0000, 'ºC'),
	(309254, 146, '2015-01-01 00:38:58.000000', 'temperatura', 898.0000, 'ºC'),
	(309255, 146, '2015-01-01 00:38:59.000000', 'temperatura', 224.0000, 'ºC'),
	(309256, 146, '2015-01-01 00:39:00.000000', 'temperatura', 828.0000, 'ºC'),
	(309257, 146, '2015-01-01 00:39:01.000000', 'temperatura', 1069.0000, 'ºC'),
	(309258, 146, '2015-01-01 00:39:02.000000', 'temperatura', 460.0000, 'ºC'),
	(309259, 146, '2015-01-01 00:39:03.000000', 'temperatura', 292.0000, 'ºC'),
	(309260, 146, '2015-01-01 00:39:04.000000', 'temperatura', 82.0000, 'ºC'),
	(309261, 146, '2015-01-01 00:39:05.000000', 'temperatura', 734.0000, 'ºC'),
	(309262, 146, '2015-01-01 00:39:06.000000', 'temperatura', 1023.0000, 'ºC'),
	(309263, 146, '2015-01-01 00:39:07.000000', 'temperatura', 513.0000, 'ºC'),
	(309264, 146, '2015-01-01 00:39:08.000000', 'temperatura', 699.0000, 'ºC'),
	(309265, 146, '2015-01-01 00:39:09.000000', 'temperatura', 755.0000, 'ºC'),
	(309266, 146, '2015-01-01 00:39:10.000000', 'temperatura', 480.0000, 'ºC'),
	(309267, 146, '2015-01-01 00:39:11.000000', 'temperatura', 135.0000, 'ºC'),
	(309268, 146, '2015-01-01 00:39:12.000000', 'temperatura', 434.0000, 'ºC'),
	(309269, 146, '2015-01-01 00:39:13.000000', 'temperatura', 565.0000, 'ºC'),
	(309270, 146, '2015-01-01 00:39:14.000000', 'temperatura', 323.0000, 'ºC'),
	(309271, 146, '2015-01-01 00:39:15.000000', 'temperatura', 1122.0000, 'ºC'),
	(309272, 146, '2015-01-01 00:39:16.000000', 'temperatura', 1040.0000, 'ºC'),
	(309273, 146, '2015-01-01 00:39:17.000000', 'temperatura', 634.0000, 'ºC'),
	(309274, 146, '2015-01-01 00:39:18.000000', 'temperatura', 50.0000, 'ºC'),
	(309275, 146, '2015-01-01 00:39:19.000000', 'temperatura', 751.0000, 'ºC'),
	(309276, 146, '2015-01-01 00:39:20.000000', 'temperatura', 3.0000, 'ºC'),
	(309277, 146, '2015-01-01 00:39:21.000000', 'temperatura', 163.0000, 'ºC'),
	(309278, 146, '2015-01-01 00:39:22.000000', 'temperatura', 808.0000, 'ºC'),
	(309279, 146, '2015-01-01 00:39:23.000000', 'temperatura', 1150.0000, 'ºC'),
	(309280, 146, '2015-01-01 00:39:24.000000', 'temperatura', 929.0000, 'ºC'),
	(309281, 146, '2015-01-01 00:39:25.000000', 'temperatura', 1193.0000, 'ºC'),
	(309282, 146, '2015-01-01 00:39:26.000000', 'temperatura', 779.0000, 'ºC'),
	(309283, 146, '2015-01-01 00:39:27.000000', 'temperatura', 318.0000, 'ºC'),
	(309284, 146, '2015-01-01 00:39:28.000000', 'temperatura', 452.0000, 'ºC'),
	(309285, 146, '2015-01-01 00:39:29.000000', 'temperatura', 106.0000, 'ºC'),
	(309286, 146, '2015-01-01 00:39:30.000000', 'temperatura', 374.0000, 'ºC'),
	(309287, 146, '2015-01-01 00:39:31.000000', 'temperatura', 354.0000, 'ºC'),
	(309288, 146, '2015-01-01 00:39:32.000000', 'temperatura', 647.0000, 'ºC'),
	(309289, 146, '2015-01-01 00:39:33.000000', 'temperatura', 974.0000, 'ºC'),
	(309290, 146, '2015-01-01 00:39:34.000000', 'temperatura', 528.0000, 'ºC'),
	(309291, 146, '2015-01-01 00:39:35.000000', 'temperatura', 919.0000, 'ºC'),
	(309292, 146, '2015-01-01 00:39:36.000000', 'temperatura', 613.0000, 'ºC'),
	(309293, 146, '2015-01-01 00:39:37.000000', 'temperatura', 309.0000, 'ºC'),
	(309294, 146, '2015-01-01 00:39:38.000000', 'temperatura', 904.0000, 'ºC'),
	(309295, 146, '2015-01-01 00:39:39.000000', 'temperatura', 1195.0000, 'ºC'),
	(309296, 146, '2015-01-01 00:39:40.000000', 'temperatura', 862.0000, 'ºC'),
	(309297, 146, '2015-01-01 00:39:41.000000', 'temperatura', 728.0000, 'ºC'),
	(309298, 146, '2015-01-01 00:39:42.000000', 'temperatura', 1053.0000, 'ºC'),
	(309299, 146, '2015-01-01 00:39:43.000000', 'temperatura', 681.0000, 'ºC'),
	(309300, 146, '2015-01-01 00:39:44.000000', 'temperatura', 246.0000, 'ºC'),
	(309301, 146, '2015-01-01 00:39:45.000000', 'temperatura', 387.0000, 'ºC'),
	(309302, 146, '2015-01-01 00:39:46.000000', 'temperatura', 1198.0000, 'ºC'),
	(309303, 146, '2015-01-01 00:39:47.000000', 'temperatura', 31.0000, 'ºC'),
	(309304, 146, '2015-01-01 00:39:48.000000', 'temperatura', 162.0000, 'ºC'),
	(309305, 146, '2015-01-01 00:39:49.000000', 'temperatura', 719.0000, 'ºC'),
	(309306, 146, '2015-01-01 00:39:50.000000', 'temperatura', 706.0000, 'ºC'),
	(309307, 146, '2015-01-01 00:39:51.000000', 'temperatura', 175.0000, 'ºC'),
	(309308, 146, '2015-01-01 00:39:52.000000', 'temperatura', 1155.0000, 'ºC'),
	(309309, 146, '2015-01-01 00:39:53.000000', 'temperatura', 453.0000, 'ºC'),
	(309310, 146, '2015-01-01 00:39:54.000000', 'temperatura', 0.0000, 'ºC'),
	(309311, 146, '2015-01-01 00:39:55.000000', 'temperatura', 1043.0000, 'ºC'),
	(309312, 146, '2015-01-01 00:39:56.000000', 'temperatura', 414.0000, 'ºC'),
	(309313, 146, '2015-01-01 00:39:57.000000', 'temperatura', 141.0000, 'ºC'),
	(309314, 146, '2015-01-01 00:39:58.000000', 'temperatura', 663.0000, 'ºC'),
	(309315, 146, '2015-01-01 00:39:59.000000', 'temperatura', 493.0000, 'ºC'),
	(309316, 146, '2015-01-01 00:40:00.000000', 'temperatura', 475.0000, 'ºC'),
	(309317, 146, '2015-01-01 00:40:01.000000', 'temperatura', 896.0000, 'ºC'),
	(309318, 146, '2015-01-01 00:40:02.000000', 'temperatura', 656.0000, 'ºC'),
	(309319, 146, '2015-01-01 00:40:03.000000', 'temperatura', 592.0000, 'ºC'),
	(309320, 146, '2015-01-01 00:40:04.000000', 'temperatura', 992.0000, 'ºC'),
	(309321, 146, '2015-01-01 00:40:05.000000', 'temperatura', 785.0000, 'ºC'),
	(309322, 146, '2015-01-01 00:40:06.000000', 'temperatura', 950.0000, 'ºC'),
	(309323, 146, '2015-01-01 00:40:07.000000', 'temperatura', 1195.0000, 'ºC'),
	(309324, 146, '2015-01-01 00:40:08.000000', 'temperatura', 726.0000, 'ºC'),
	(309325, 146, '2015-01-01 00:40:09.000000', 'temperatura', 45.0000, 'ºC'),
	(309326, 146, '2015-01-01 00:40:10.000000', 'temperatura', 447.0000, 'ºC'),
	(309327, 146, '2015-01-01 00:40:11.000000', 'temperatura', 900.0000, 'ºC'),
	(309328, 146, '2015-01-01 00:40:12.000000', 'temperatura', 759.0000, 'ºC'),
	(309329, 146, '2015-01-01 00:40:13.000000', 'temperatura', 1097.0000, 'ºC'),
	(309330, 146, '2015-01-01 00:40:14.000000', 'temperatura', 808.0000, 'ºC'),
	(309331, 146, '2015-01-01 00:40:15.000000', 'temperatura', 748.0000, 'ºC'),
	(309332, 146, '2015-01-01 00:40:16.000000', 'temperatura', 119.0000, 'ºC'),
	(309333, 146, '2015-01-01 00:40:17.000000', 'temperatura', 749.0000, 'ºC'),
	(309334, 146, '2015-01-01 00:40:18.000000', 'temperatura', 991.0000, 'ºC'),
	(309335, 146, '2015-01-01 00:40:19.000000', 'temperatura', 308.0000, 'ºC'),
	(309336, 146, '2015-01-01 00:40:20.000000', 'temperatura', 965.0000, 'ºC'),
	(309337, 146, '2015-01-01 00:40:21.000000', 'temperatura', 304.0000, 'ºC'),
	(309338, 146, '2015-01-01 00:40:22.000000', 'temperatura', 1025.0000, 'ºC'),
	(309339, 146, '2015-01-01 00:40:23.000000', 'temperatura', 612.0000, 'ºC'),
	(309340, 146, '2015-01-01 00:40:24.000000', 'temperatura', 1188.0000, 'ºC'),
	(309341, 146, '2015-01-01 00:40:25.000000', 'temperatura', 505.0000, 'ºC'),
	(309342, 146, '2015-01-01 00:40:26.000000', 'temperatura', 159.0000, 'ºC'),
	(309343, 146, '2015-01-01 00:40:27.000000', 'temperatura', 482.0000, 'ºC'),
	(309344, 146, '2015-01-01 00:40:28.000000', 'temperatura', 734.0000, 'ºC'),
	(309345, 146, '2015-01-01 00:40:29.000000', 'temperatura', 1025.0000, 'ºC'),
	(309346, 146, '2015-01-01 00:40:30.000000', 'temperatura', 525.0000, 'ºC'),
	(309347, 146, '2015-01-01 00:40:31.000000', 'temperatura', 748.0000, 'ºC'),
	(309348, 146, '2015-01-01 00:40:32.000000', 'temperatura', 966.0000, 'ºC'),
	(309349, 146, '2015-01-01 00:40:33.000000', 'temperatura', 187.0000, 'ºC'),
	(309350, 146, '2015-01-01 00:40:34.000000', 'temperatura', 438.0000, 'ºC'),
	(309351, 146, '2015-01-01 00:40:35.000000', 'temperatura', 429.0000, 'ºC'),
	(309352, 146, '2015-01-01 00:40:36.000000', 'temperatura', 833.0000, 'ºC'),
	(309353, 146, '2015-01-01 00:40:37.000000', 'temperatura', 479.0000, 'ºC'),
	(309354, 146, '2015-01-01 00:40:38.000000', 'temperatura', 1095.0000, 'ºC'),
	(309355, 146, '2015-01-01 00:40:39.000000', 'temperatura', 440.0000, 'ºC'),
	(309356, 146, '2015-01-01 00:40:40.000000', 'temperatura', 116.0000, 'ºC'),
	(309357, 146, '2015-01-01 00:40:41.000000', 'temperatura', 458.0000, 'ºC'),
	(309358, 146, '2015-01-01 00:40:42.000000', 'temperatura', 743.0000, 'ºC'),
	(309359, 146, '2015-01-01 00:40:43.000000', 'temperatura', 1140.0000, 'ºC'),
	(309360, 146, '2015-01-01 00:40:44.000000', 'temperatura', 1075.0000, 'ºC'),
	(309361, 146, '2015-01-01 00:40:45.000000', 'temperatura', 753.0000, 'ºC'),
	(309362, 146, '2015-01-01 00:40:46.000000', 'temperatura', 541.0000, 'ºC'),
	(309363, 146, '2015-01-01 00:40:47.000000', 'temperatura', 448.0000, 'ºC'),
	(309364, 146, '2015-01-01 00:40:48.000000', 'temperatura', 615.0000, 'ºC'),
	(309365, 146, '2015-01-01 00:40:49.000000', 'temperatura', 534.0000, 'ºC'),
	(309366, 146, '2015-01-01 00:40:50.000000', 'temperatura', 826.0000, 'ºC'),
	(309367, 146, '2015-01-01 00:40:51.000000', 'temperatura', 127.0000, 'ºC'),
	(309368, 146, '2015-01-01 00:40:52.000000', 'temperatura', 557.0000, 'ºC'),
	(309369, 146, '2015-01-01 00:40:53.000000', 'temperatura', 6.0000, 'ºC'),
	(309370, 146, '2015-01-01 00:40:54.000000', 'temperatura', 760.0000, 'ºC'),
	(309371, 146, '2015-01-01 00:40:55.000000', 'temperatura', 180.0000, 'ºC'),
	(309372, 146, '2015-01-01 00:40:56.000000', 'temperatura', 1023.0000, 'ºC'),
	(309373, 146, '2015-01-01 00:40:57.000000', 'temperatura', 976.0000, 'ºC'),
	(309374, 146, '2015-01-01 00:40:58.000000', 'temperatura', 613.0000, 'ºC'),
	(309375, 146, '2015-01-01 00:40:59.000000', 'temperatura', 134.0000, 'ºC'),
	(309376, 146, '2015-01-01 00:41:00.000000', 'temperatura', 34.0000, 'ºC'),
	(309377, 146, '2015-01-01 00:41:01.000000', 'temperatura', 968.0000, 'ºC'),
	(309378, 146, '2015-01-01 00:41:02.000000', 'temperatura', 1137.0000, 'ºC'),
	(309379, 146, '2015-01-01 00:41:03.000000', 'temperatura', 383.0000, 'ºC'),
	(309380, 146, '2015-01-01 00:41:04.000000', 'temperatura', 903.0000, 'ºC'),
	(309381, 146, '2015-01-01 00:41:05.000000', 'temperatura', 966.0000, 'ºC'),
	(309382, 146, '2015-01-01 00:41:06.000000', 'temperatura', 923.0000, 'ºC'),
	(309383, 146, '2015-01-01 00:41:07.000000', 'temperatura', 515.0000, 'ºC'),
	(309384, 146, '2015-01-01 00:41:08.000000', 'temperatura', 1009.0000, 'ºC'),
	(309385, 146, '2015-01-01 00:41:09.000000', 'temperatura', 1099.0000, 'ºC'),
	(309386, 146, '2015-01-01 00:41:10.000000', 'temperatura', 70.0000, 'ºC'),
	(309387, 146, '2015-01-01 00:41:11.000000', 'temperatura', 654.0000, 'ºC'),
	(309388, 146, '2015-01-01 00:41:12.000000', 'temperatura', 660.0000, 'ºC'),
	(309389, 146, '2015-01-01 00:41:13.000000', 'temperatura', 139.0000, 'ºC'),
	(309390, 146, '2015-01-01 00:41:14.000000', 'temperatura', 1116.0000, 'ºC'),
	(309391, 146, '2015-01-01 00:41:15.000000', 'temperatura', 365.0000, 'ºC'),
	(309392, 146, '2015-01-01 00:41:16.000000', 'temperatura', 875.0000, 'ºC'),
	(309393, 146, '2015-01-01 00:41:17.000000', 'temperatura', 882.0000, 'ºC'),
	(309394, 146, '2015-01-01 00:41:18.000000', 'temperatura', 586.0000, 'ºC'),
	(309395, 146, '2015-01-01 00:41:19.000000', 'temperatura', 283.0000, 'ºC'),
	(309396, 146, '2015-01-01 00:41:20.000000', 'temperatura', 858.0000, 'ºC'),
	(309397, 146, '2015-01-01 00:41:21.000000', 'temperatura', 1041.0000, 'ºC'),
	(309398, 146, '2015-01-01 00:41:22.000000', 'temperatura', 233.0000, 'ºC'),
	(309399, 146, '2015-01-01 00:41:23.000000', 'temperatura', 440.0000, 'ºC'),
	(309400, 146, '2015-01-01 00:41:24.000000', 'temperatura', 301.0000, 'ºC'),
	(309401, 146, '2015-01-01 00:41:25.000000', 'temperatura', 189.0000, 'ºC'),
	(309402, 146, '2015-01-01 00:41:26.000000', 'temperatura', 40.0000, 'ºC'),
	(309403, 146, '2015-01-01 00:41:27.000000', 'temperatura', 833.0000, 'ºC'),
	(309404, 146, '2015-01-01 00:41:28.000000', 'temperatura', 446.0000, 'ºC'),
	(309405, 146, '2015-01-01 00:41:29.000000', 'temperatura', 933.0000, 'ºC'),
	(309406, 146, '2015-01-01 00:41:30.000000', 'temperatura', 926.0000, 'ºC'),
	(309407, 146, '2015-01-01 00:41:31.000000', 'temperatura', 631.0000, 'ºC'),
	(309408, 146, '2015-01-01 00:41:32.000000', 'temperatura', 380.0000, 'ºC'),
	(309409, 146, '2015-01-01 00:41:33.000000', 'temperatura', 5.0000, 'ºC'),
	(309410, 146, '2015-01-01 00:41:34.000000', 'temperatura', 88.0000, 'ºC'),
	(309411, 146, '2015-01-01 00:41:35.000000', 'temperatura', 426.0000, 'ºC'),
	(309412, 146, '2015-01-01 00:41:36.000000', 'temperatura', 664.0000, 'ºC'),
	(309413, 146, '2015-01-01 00:41:37.000000', 'temperatura', 842.0000, 'ºC'),
	(309414, 146, '2015-01-01 00:41:38.000000', 'temperatura', 1020.0000, 'ºC'),
	(309415, 146, '2015-01-01 00:41:39.000000', 'temperatura', 174.0000, 'ºC'),
	(309416, 146, '2015-01-01 00:41:40.000000', 'temperatura', 210.0000, 'ºC'),
	(309417, 146, '2015-01-01 00:41:41.000000', 'temperatura', 527.0000, 'ºC'),
	(309418, 146, '2015-01-01 00:41:42.000000', 'temperatura', 809.0000, 'ºC'),
	(309419, 146, '2015-01-01 00:41:43.000000', 'temperatura', 61.0000, 'ºC'),
	(309420, 146, '2015-01-01 00:41:44.000000', 'temperatura', 282.0000, 'ºC'),
	(309421, 146, '2015-01-01 00:41:45.000000', 'temperatura', 25.0000, 'ºC'),
	(309422, 146, '2015-01-01 00:41:46.000000', 'temperatura', 480.0000, 'ºC'),
	(309423, 146, '2015-01-01 00:41:47.000000', 'temperatura', 1126.0000, 'ºC'),
	(309424, 146, '2015-01-01 00:41:48.000000', 'temperatura', 592.0000, 'ºC'),
	(309425, 146, '2015-01-01 00:41:49.000000', 'temperatura', 780.0000, 'ºC'),
	(309426, 146, '2015-01-01 00:41:50.000000', 'temperatura', 926.0000, 'ºC'),
	(309427, 146, '2015-01-01 00:41:51.000000', 'temperatura', 1090.0000, 'ºC'),
	(309428, 146, '2015-01-01 00:41:52.000000', 'temperatura', 273.0000, 'ºC'),
	(309429, 146, '2015-01-01 00:41:53.000000', 'temperatura', 495.0000, 'ºC'),
	(309430, 146, '2015-01-01 00:41:54.000000', 'temperatura', 455.0000, 'ºC'),
	(309431, 146, '2015-01-01 00:41:55.000000', 'temperatura', 790.0000, 'ºC'),
	(309432, 146, '2015-01-01 00:41:56.000000', 'temperatura', 185.0000, 'ºC'),
	(309433, 146, '2015-01-01 00:41:57.000000', 'temperatura', 955.0000, 'ºC'),
	(309434, 146, '2015-01-01 00:41:58.000000', 'temperatura', 622.0000, 'ºC'),
	(309435, 146, '2015-01-01 00:41:59.000000', 'temperatura', 244.0000, 'ºC'),
	(309436, 146, '2015-01-01 00:42:00.000000', 'temperatura', 556.0000, 'ºC'),
	(309437, 146, '2015-01-01 00:42:01.000000', 'temperatura', 849.0000, 'ºC'),
	(309438, 146, '2015-01-01 00:42:02.000000', 'temperatura', 175.0000, 'ºC'),
	(309439, 146, '2015-01-01 00:42:03.000000', 'temperatura', 731.0000, 'ºC'),
	(309440, 146, '2015-01-01 00:42:04.000000', 'temperatura', 731.0000, 'ºC'),
	(309441, 146, '2015-01-01 00:42:05.000000', 'temperatura', 262.0000, 'ºC'),
	(309442, 146, '2015-01-01 00:42:06.000000', 'temperatura', 317.0000, 'ºC'),
	(309443, 146, '2015-01-01 00:42:07.000000', 'temperatura', 802.0000, 'ºC'),
	(309444, 146, '2015-01-01 00:42:08.000000', 'temperatura', 656.0000, 'ºC'),
	(309445, 146, '2015-01-01 00:42:09.000000', 'temperatura', 877.0000, 'ºC'),
	(309446, 146, '2015-01-01 00:42:10.000000', 'temperatura', 16.0000, 'ºC'),
	(309447, 146, '2015-01-01 00:42:11.000000', 'temperatura', 1051.0000, 'ºC'),
	(309448, 146, '2015-01-01 00:42:12.000000', 'temperatura', 406.0000, 'ºC'),
	(309449, 146, '2015-01-01 00:42:13.000000', 'temperatura', 78.0000, 'ºC'),
	(309450, 146, '2015-01-01 00:42:14.000000', 'temperatura', 373.0000, 'ºC'),
	(309451, 146, '2015-01-01 00:42:15.000000', 'temperatura', 429.0000, 'ºC'),
	(309452, 146, '2015-01-01 00:42:16.000000', 'temperatura', 1029.0000, 'ºC'),
	(309453, 146, '2015-01-01 00:42:17.000000', 'temperatura', 256.0000, 'ºC'),
	(309454, 146, '2015-01-01 00:42:18.000000', 'temperatura', 594.0000, 'ºC'),
	(309455, 146, '2015-01-01 00:42:19.000000', 'temperatura', 1002.0000, 'ºC'),
	(309456, 146, '2015-01-01 00:42:20.000000', 'temperatura', 830.0000, 'ºC'),
	(309457, 146, '2015-01-01 00:42:21.000000', 'temperatura', 1144.0000, 'ºC'),
	(309458, 146, '2015-01-01 00:42:22.000000', 'temperatura', 828.0000, 'ºC'),
	(309459, 146, '2015-01-01 00:42:23.000000', 'temperatura', 712.0000, 'ºC'),
	(309460, 146, '2015-01-01 00:42:24.000000', 'temperatura', 1076.0000, 'ºC'),
	(309461, 146, '2015-01-01 00:42:25.000000', 'temperatura', 843.0000, 'ºC'),
	(309462, 146, '2015-01-01 00:42:26.000000', 'temperatura', 990.0000, 'ºC'),
	(309463, 146, '2015-01-01 00:42:27.000000', 'temperatura', 19.0000, 'ºC'),
	(309464, 146, '2015-01-01 00:42:28.000000', 'temperatura', 728.0000, 'ºC'),
	(309465, 146, '2015-01-01 00:42:29.000000', 'temperatura', 1182.0000, 'ºC'),
	(309466, 146, '2015-01-01 00:42:30.000000', 'temperatura', 127.0000, 'ºC'),
	(309467, 146, '2015-01-01 00:42:31.000000', 'temperatura', 689.0000, 'ºC'),
	(309468, 146, '2015-01-01 00:42:32.000000', 'temperatura', 663.0000, 'ºC'),
	(309469, 146, '2015-01-01 00:42:33.000000', 'temperatura', 51.0000, 'ºC'),
	(309470, 146, '2015-01-01 00:42:34.000000', 'temperatura', 667.0000, 'ºC'),
	(309471, 146, '2015-01-01 00:42:35.000000', 'temperatura', 783.0000, 'ºC'),
	(309472, 146, '2015-01-01 00:42:36.000000', 'temperatura', 712.0000, 'ºC'),
	(309473, 146, '2015-01-01 00:42:37.000000', 'temperatura', 13.0000, 'ºC'),
	(309474, 146, '2015-01-01 00:42:38.000000', 'temperatura', 329.0000, 'ºC'),
	(309475, 146, '2015-01-01 00:42:39.000000', 'temperatura', 405.0000, 'ºC'),
	(309476, 146, '2015-01-01 00:42:40.000000', 'temperatura', 1039.0000, 'ºC'),
	(309477, 146, '2015-01-01 00:42:41.000000', 'temperatura', 381.0000, 'ºC'),
	(309478, 146, '2015-01-01 00:42:42.000000', 'temperatura', 1188.0000, 'ºC'),
	(309479, 146, '2015-01-01 00:42:43.000000', 'temperatura', 1199.0000, 'ºC'),
	(309480, 146, '2015-01-01 00:42:44.000000', 'temperatura', 30.0000, 'ºC'),
	(309481, 146, '2015-01-01 00:42:45.000000', 'temperatura', 155.0000, 'ºC'),
	(309482, 146, '2015-01-01 00:42:46.000000', 'temperatura', 684.0000, 'ºC'),
	(309483, 146, '2015-01-01 00:42:47.000000', 'temperatura', 558.0000, 'ºC'),
	(309484, 146, '2015-01-01 00:42:48.000000', 'temperatura', 736.0000, 'ºC'),
	(309485, 146, '2015-01-01 00:42:49.000000', 'temperatura', 808.0000, 'ºC'),
	(309486, 146, '2015-01-01 00:42:50.000000', 'temperatura', 631.0000, 'ºC'),
	(309487, 146, '2015-01-01 00:42:51.000000', 'temperatura', 733.0000, 'ºC'),
	(309488, 146, '2015-01-01 00:42:52.000000', 'temperatura', 573.0000, 'ºC'),
	(309489, 146, '2015-01-01 00:42:53.000000', 'temperatura', 665.0000, 'ºC'),
	(309490, 146, '2015-01-01 00:42:54.000000', 'temperatura', 407.0000, 'ºC'),
	(309491, 146, '2015-01-01 00:42:55.000000', 'temperatura', 42.0000, 'ºC'),
	(309492, 146, '2015-01-01 00:42:56.000000', 'temperatura', 189.0000, 'ºC'),
	(309493, 146, '2015-01-01 00:42:57.000000', 'temperatura', 818.0000, 'ºC'),
	(309494, 146, '2015-01-01 00:42:58.000000', 'temperatura', 1125.0000, 'ºC'),
	(309495, 146, '2015-01-01 00:42:59.000000', 'temperatura', 769.0000, 'ºC'),
	(309496, 146, '2015-01-01 00:43:00.000000', 'temperatura', 473.0000, 'ºC'),
	(309497, 146, '2015-01-01 00:43:01.000000', 'temperatura', 57.0000, 'ºC'),
	(309498, 146, '2015-01-01 00:43:02.000000', 'temperatura', 66.0000, 'ºC'),
	(309499, 146, '2015-01-01 00:43:03.000000', 'temperatura', 161.0000, 'ºC'),
	(309500, 146, '2015-01-01 00:43:04.000000', 'temperatura', 607.0000, 'ºC'),
	(309501, 146, '2015-01-01 00:43:05.000000', 'temperatura', 152.0000, 'ºC'),
	(309502, 146, '2015-01-01 00:43:06.000000', 'temperatura', 139.0000, 'ºC'),
	(309503, 146, '2015-01-01 00:43:07.000000', 'temperatura', 240.0000, 'ºC'),
	(309504, 146, '2015-01-01 00:43:08.000000', 'temperatura', 782.0000, 'ºC'),
	(309505, 146, '2015-01-01 00:43:09.000000', 'temperatura', 793.0000, 'ºC'),
	(309506, 146, '2015-01-01 00:43:10.000000', 'temperatura', 418.0000, 'ºC'),
	(309507, 146, '2015-01-01 00:43:11.000000', 'temperatura', 911.0000, 'ºC'),
	(309508, 146, '2015-01-01 00:43:12.000000', 'temperatura', 901.0000, 'ºC'),
	(309509, 146, '2015-01-01 00:43:13.000000', 'temperatura', 571.0000, 'ºC'),
	(309510, 146, '2015-01-01 00:43:14.000000', 'temperatura', 155.0000, 'ºC'),
	(309511, 146, '2015-01-01 00:43:15.000000', 'temperatura', 263.0000, 'ºC'),
	(309512, 146, '2015-01-01 00:43:16.000000', 'temperatura', 850.0000, 'ºC'),
	(309513, 146, '2015-01-01 00:43:17.000000', 'temperatura', 1061.0000, 'ºC'),
	(309514, 146, '2015-01-01 00:43:18.000000', 'temperatura', 355.0000, 'ºC'),
	(309515, 146, '2015-01-01 00:43:19.000000', 'temperatura', 991.0000, 'ºC'),
	(309516, 146, '2015-01-01 00:43:20.000000', 'temperatura', 291.0000, 'ºC'),
	(309517, 146, '2015-01-01 00:43:21.000000', 'temperatura', 884.0000, 'ºC'),
	(309518, 146, '2015-01-01 00:43:22.000000', 'temperatura', 1147.0000, 'ºC'),
	(309519, 146, '2015-01-01 00:43:23.000000', 'temperatura', 684.0000, 'ºC'),
	(309520, 146, '2015-01-01 00:43:24.000000', 'temperatura', 1179.0000, 'ºC'),
	(309521, 146, '2015-01-01 00:43:25.000000', 'temperatura', 245.0000, 'ºC'),
	(309522, 146, '2015-01-01 00:43:26.000000', 'temperatura', 87.0000, 'ºC'),
	(309523, 146, '2015-01-01 00:43:27.000000', 'temperatura', 902.0000, 'ºC'),
	(309524, 146, '2015-01-01 00:43:28.000000', 'temperatura', 647.0000, 'ºC'),
	(309525, 146, '2015-01-01 00:43:29.000000', 'temperatura', 529.0000, 'ºC'),
	(309526, 146, '2015-01-01 00:43:30.000000', 'temperatura', 707.0000, 'ºC'),
	(309527, 146, '2015-01-01 00:43:31.000000', 'temperatura', 746.0000, 'ºC'),
	(309528, 146, '2015-01-01 00:43:32.000000', 'temperatura', 409.0000, 'ºC'),
	(309529, 146, '2015-01-01 00:43:33.000000', 'temperatura', 1009.0000, 'ºC'),
	(309530, 146, '2015-01-01 00:43:34.000000', 'temperatura', 217.0000, 'ºC'),
	(309531, 146, '2015-01-01 00:43:35.000000', 'temperatura', 461.0000, 'ºC'),
	(309532, 146, '2015-01-01 00:43:36.000000', 'temperatura', 454.0000, 'ºC'),
	(309533, 146, '2015-01-01 00:43:37.000000', 'temperatura', 886.0000, 'ºC'),
	(309534, 146, '2015-01-01 00:43:38.000000', 'temperatura', 668.0000, 'ºC'),
	(309535, 146, '2015-01-01 00:43:39.000000', 'temperatura', 682.0000, 'ºC'),
	(309536, 146, '2015-01-01 00:43:40.000000', 'temperatura', 209.0000, 'ºC'),
	(309537, 146, '2015-01-01 00:43:41.000000', 'temperatura', 197.0000, 'ºC'),
	(309538, 146, '2015-01-01 00:43:42.000000', 'temperatura', 358.0000, 'ºC'),
	(309539, 146, '2015-01-01 00:43:43.000000', 'temperatura', 1199.0000, 'ºC'),
	(309540, 146, '2015-01-01 00:43:44.000000', 'temperatura', 122.0000, 'ºC'),
	(309541, 146, '2015-01-01 00:43:45.000000', 'temperatura', 613.0000, 'ºC'),
	(309542, 146, '2015-01-01 00:43:46.000000', 'temperatura', 298.0000, 'ºC'),
	(309543, 146, '2015-01-01 00:43:47.000000', 'temperatura', 855.0000, 'ºC'),
	(309544, 146, '2015-01-01 00:43:48.000000', 'temperatura', 979.0000, 'ºC'),
	(309545, 146, '2015-01-01 00:43:49.000000', 'temperatura', 1132.0000, 'ºC'),
	(309546, 146, '2015-01-01 00:43:50.000000', 'temperatura', 323.0000, 'ºC'),
	(309547, 146, '2015-01-01 00:43:51.000000', 'temperatura', 620.0000, 'ºC'),
	(309548, 146, '2015-01-01 00:43:52.000000', 'temperatura', 932.0000, 'ºC'),
	(309549, 146, '2015-01-01 00:43:53.000000', 'temperatura', 399.0000, 'ºC'),
	(309550, 146, '2015-01-01 00:43:54.000000', 'temperatura', 402.0000, 'ºC'),
	(309551, 146, '2015-01-01 00:43:55.000000', 'temperatura', 811.0000, 'ºC'),
	(309552, 146, '2015-01-01 00:43:56.000000', 'temperatura', 451.0000, 'ºC'),
	(309553, 146, '2015-01-01 00:43:57.000000', 'temperatura', 1020.0000, 'ºC'),
	(309554, 146, '2015-01-01 00:43:58.000000', 'temperatura', 150.0000, 'ºC'),
	(309555, 146, '2015-01-01 00:43:59.000000', 'temperatura', 88.0000, 'ºC'),
	(309556, 146, '2015-01-01 00:44:00.000000', 'temperatura', 1193.0000, 'ºC'),
	(309557, 146, '2015-01-01 00:44:01.000000', 'temperatura', 903.0000, 'ºC'),
	(309558, 146, '2015-01-01 00:44:02.000000', 'temperatura', 933.0000, 'ºC'),
	(309559, 146, '2015-01-01 00:44:03.000000', 'temperatura', 759.0000, 'ºC'),
	(309560, 146, '2015-01-01 00:44:04.000000', 'temperatura', 995.0000, 'ºC'),
	(309561, 146, '2015-01-01 00:44:05.000000', 'temperatura', 298.0000, 'ºC'),
	(309562, 146, '2015-01-01 00:44:06.000000', 'temperatura', 905.0000, 'ºC'),
	(309563, 146, '2015-01-01 00:44:07.000000', 'temperatura', 32.0000, 'ºC'),
	(309564, 146, '2015-01-01 00:44:08.000000', 'temperatura', 1044.0000, 'ºC'),
	(309565, 146, '2015-01-01 00:44:09.000000', 'temperatura', 327.0000, 'ºC'),
	(309566, 146, '2015-01-01 00:44:10.000000', 'temperatura', 901.0000, 'ºC'),
	(309567, 146, '2015-01-01 00:44:11.000000', 'temperatura', 1124.0000, 'ºC'),
	(309568, 146, '2015-01-01 00:44:12.000000', 'temperatura', 516.0000, 'ºC'),
	(309569, 146, '2015-01-01 00:44:13.000000', 'temperatura', 412.0000, 'ºC'),
	(309570, 146, '2015-01-01 00:44:14.000000', 'temperatura', 513.0000, 'ºC'),
	(309571, 146, '2015-01-01 00:44:15.000000', 'temperatura', 128.0000, 'ºC'),
	(309572, 146, '2015-01-01 00:44:16.000000', 'temperatura', 302.0000, 'ºC'),
	(309573, 146, '2015-01-01 00:44:17.000000', 'temperatura', 1128.0000, 'ºC'),
	(309574, 146, '2015-01-01 00:44:18.000000', 'temperatura', 1132.0000, 'ºC'),
	(309575, 146, '2015-01-01 00:44:19.000000', 'temperatura', 1079.0000, 'ºC'),
	(309576, 146, '2015-01-01 00:44:20.000000', 'temperatura', 797.0000, 'ºC'),
	(309577, 146, '2015-01-01 00:44:21.000000', 'temperatura', 749.0000, 'ºC'),
	(309578, 146, '2015-01-01 00:44:22.000000', 'temperatura', 157.0000, 'ºC'),
	(309579, 146, '2015-01-01 00:44:23.000000', 'temperatura', 936.0000, 'ºC'),
	(309580, 146, '2015-01-01 00:44:24.000000', 'temperatura', 611.0000, 'ºC'),
	(309581, 146, '2015-01-01 00:44:25.000000', 'temperatura', 246.0000, 'ºC'),
	(309582, 146, '2015-01-01 00:44:26.000000', 'temperatura', 597.0000, 'ºC'),
	(309583, 146, '2015-01-01 00:44:27.000000', 'temperatura', 1047.0000, 'ºC'),
	(309584, 146, '2015-01-01 00:44:28.000000', 'temperatura', 1046.0000, 'ºC'),
	(309585, 146, '2015-01-01 00:44:29.000000', 'temperatura', 888.0000, 'ºC'),
	(309586, 146, '2015-01-01 00:44:30.000000', 'temperatura', 102.0000, 'ºC'),
	(309587, 146, '2015-01-01 00:44:31.000000', 'temperatura', 249.0000, 'ºC'),
	(309588, 146, '2015-01-01 00:44:32.000000', 'temperatura', 937.0000, 'ºC'),
	(309589, 146, '2015-01-01 00:44:33.000000', 'temperatura', 339.0000, 'ºC'),
	(309590, 146, '2015-01-01 00:44:34.000000', 'temperatura', 87.0000, 'ºC'),
	(309591, 146, '2015-01-01 00:44:35.000000', 'temperatura', 616.0000, 'ºC'),
	(309592, 146, '2015-01-01 00:44:36.000000', 'temperatura', 419.0000, 'ºC'),
	(309593, 146, '2015-01-01 00:44:37.000000', 'temperatura', 249.0000, 'ºC'),
	(309594, 146, '2015-01-01 00:44:38.000000', 'temperatura', 1188.0000, 'ºC'),
	(309595, 146, '2015-01-01 00:44:39.000000', 'temperatura', 393.0000, 'ºC'),
	(309596, 146, '2015-01-01 00:44:40.000000', 'temperatura', 804.0000, 'ºC'),
	(309597, 146, '2015-01-01 00:44:41.000000', 'temperatura', 438.0000, 'ºC'),
	(309598, 146, '2015-01-01 00:44:42.000000', 'temperatura', 981.0000, 'ºC'),
	(309599, 146, '2015-01-01 00:44:43.000000', 'temperatura', 1191.0000, 'ºC'),
	(309600, 146, '2015-01-01 00:44:44.000000', 'temperatura', 612.0000, 'ºC'),
	(309601, 146, '2015-01-01 00:44:45.000000', 'temperatura', 688.0000, 'ºC'),
	(309602, 146, '2015-01-01 00:44:46.000000', 'temperatura', 406.0000, 'ºC'),
	(309603, 146, '2015-01-01 00:44:47.000000', 'temperatura', 1164.0000, 'ºC'),
	(309604, 146, '2015-01-01 00:44:48.000000', 'temperatura', 1002.0000, 'ºC'),
	(309605, 146, '2015-01-01 00:44:49.000000', 'temperatura', 322.0000, 'ºC'),
	(309606, 146, '2015-01-01 00:44:50.000000', 'temperatura', 1001.0000, 'ºC'),
	(309607, 146, '2015-01-01 00:44:51.000000', 'temperatura', 439.0000, 'ºC'),
	(309608, 146, '2015-01-01 00:44:52.000000', 'temperatura', 396.0000, 'ºC'),
	(309609, 146, '2015-01-01 00:44:53.000000', 'temperatura', 661.0000, 'ºC'),
	(309610, 146, '2015-01-01 00:44:54.000000', 'temperatura', 917.0000, 'ºC'),
	(309611, 146, '2015-01-01 00:44:55.000000', 'temperatura', 202.0000, 'ºC'),
	(309612, 146, '2015-01-01 00:44:56.000000', 'temperatura', 658.0000, 'ºC'),
	(309613, 146, '2015-01-01 00:44:57.000000', 'temperatura', 288.0000, 'ºC'),
	(309614, 146, '2015-01-01 00:44:58.000000', 'temperatura', 666.0000, 'ºC'),
	(309615, 146, '2015-01-01 00:44:59.000000', 'temperatura', 67.0000, 'ºC'),
	(309616, 146, '2015-01-01 00:45:00.000000', 'temperatura', 735.0000, 'ºC'),
	(309617, 146, '2015-01-01 00:45:01.000000', 'temperatura', 1078.0000, 'ºC'),
	(309618, 146, '2015-01-01 00:45:02.000000', 'temperatura', 782.0000, 'ºC'),
	(309619, 146, '2015-01-01 00:45:03.000000', 'temperatura', 677.0000, 'ºC'),
	(309620, 146, '2015-01-01 00:45:04.000000', 'temperatura', 1040.0000, 'ºC'),
	(309621, 146, '2015-01-01 00:45:05.000000', 'temperatura', 768.0000, 'ºC'),
	(309622, 146, '2015-01-01 00:45:06.000000', 'temperatura', 721.0000, 'ºC'),
	(309623, 146, '2015-01-01 00:45:07.000000', 'temperatura', 104.0000, 'ºC'),
	(309624, 146, '2015-01-01 00:45:08.000000', 'temperatura', 756.0000, 'ºC'),
	(309625, 146, '2015-01-01 00:45:09.000000', 'temperatura', 1068.0000, 'ºC'),
	(309626, 146, '2015-01-01 00:45:10.000000', 'temperatura', 674.0000, 'ºC'),
	(309627, 146, '2015-01-01 00:45:11.000000', 'temperatura', 167.0000, 'ºC'),
	(309628, 146, '2015-01-01 00:45:12.000000', 'temperatura', 13.0000, 'ºC'),
	(309629, 146, '2015-01-01 00:45:13.000000', 'temperatura', 764.0000, 'ºC'),
	(309630, 146, '2015-01-01 00:45:14.000000', 'temperatura', 181.0000, 'ºC'),
	(309631, 146, '2015-01-01 00:45:15.000000', 'temperatura', 1013.0000, 'ºC'),
	(309632, 146, '2015-01-01 00:45:16.000000', 'temperatura', 922.0000, 'ºC'),
	(309633, 146, '2015-01-01 00:45:17.000000', 'temperatura', 372.0000, 'ºC'),
	(309634, 146, '2015-01-01 00:45:18.000000', 'temperatura', 293.0000, 'ºC'),
	(309635, 146, '2015-01-01 00:45:19.000000', 'temperatura', 352.0000, 'ºC'),
	(309636, 146, '2015-01-01 00:45:20.000000', 'temperatura', 881.0000, 'ºC'),
	(309637, 146, '2015-01-01 00:45:21.000000', 'temperatura', 950.0000, 'ºC'),
	(309638, 146, '2015-01-01 00:45:22.000000', 'temperatura', 907.0000, 'ºC'),
	(309639, 146, '2015-01-01 00:45:23.000000', 'temperatura', 486.0000, 'ºC'),
	(309640, 146, '2015-01-01 00:45:24.000000', 'temperatura', 908.0000, 'ºC'),
	(309641, 146, '2015-01-01 00:45:25.000000', 'temperatura', 685.0000, 'ºC'),
	(309642, 146, '2015-01-01 00:45:26.000000', 'temperatura', 701.0000, 'ºC'),
	(309643, 146, '2015-01-01 00:45:27.000000', 'temperatura', 249.0000, 'ºC'),
	(309644, 146, '2015-01-01 00:45:28.000000', 'temperatura', 343.0000, 'ºC'),
	(309645, 146, '2015-01-01 00:45:29.000000', 'temperatura', 967.0000, 'ºC'),
	(309646, 146, '2015-01-01 00:45:30.000000', 'temperatura', 207.0000, 'ºC'),
	(309647, 146, '2015-01-01 00:45:31.000000', 'temperatura', 536.0000, 'ºC'),
	(309648, 146, '2015-01-01 00:45:32.000000', 'temperatura', 860.0000, 'ºC'),
	(309649, 146, '2015-01-01 00:45:33.000000', 'temperatura', 292.0000, 'ºC'),
	(309650, 146, '2015-01-01 00:45:34.000000', 'temperatura', 79.0000, 'ºC'),
	(309651, 146, '2015-01-01 00:45:35.000000', 'temperatura', 721.0000, 'ºC'),
	(309652, 146, '2015-01-01 00:45:36.000000', 'temperatura', 968.0000, 'ºC'),
	(309653, 146, '2015-01-01 00:45:37.000000', 'temperatura', 278.0000, 'ºC'),
	(309654, 146, '2015-01-01 00:45:38.000000', 'temperatura', 884.0000, 'ºC'),
	(309655, 146, '2015-01-01 00:45:39.000000', 'temperatura', 1189.0000, 'ºC'),
	(309656, 146, '2015-01-01 00:45:40.000000', 'temperatura', 893.0000, 'ºC'),
	(309657, 146, '2015-01-01 00:45:41.000000', 'temperatura', 898.0000, 'ºC'),
	(309658, 146, '2015-01-01 00:45:42.000000', 'temperatura', 612.0000, 'ºC'),
	(309659, 146, '2015-01-01 00:45:43.000000', 'temperatura', 368.0000, 'ºC'),
	(309660, 146, '2015-01-01 00:45:44.000000', 'temperatura', 2.0000, 'ºC'),
	(309661, 146, '2015-01-01 00:45:45.000000', 'temperatura', 107.0000, 'ºC'),
	(309662, 146, '2015-01-01 00:45:46.000000', 'temperatura', 529.0000, 'ºC'),
	(309663, 146, '2015-01-01 00:45:47.000000', 'temperatura', 1123.0000, 'ºC'),
	(309664, 146, '2015-01-01 00:45:48.000000', 'temperatura', 431.0000, 'ºC'),
	(309665, 146, '2015-01-01 00:45:49.000000', 'temperatura', 1184.0000, 'ºC'),
	(309666, 146, '2015-01-01 00:45:50.000000', 'temperatura', 1029.0000, 'ºC'),
	(309667, 146, '2015-01-01 00:45:51.000000', 'temperatura', 392.0000, 'ºC'),
	(309668, 146, '2015-01-01 00:45:52.000000', 'temperatura', 75.0000, 'ºC'),
	(309669, 146, '2015-01-01 00:45:53.000000', 'temperatura', 398.0000, 'ºC'),
	(309670, 146, '2015-01-01 00:45:54.000000', 'temperatura', 566.0000, 'ºC'),
	(309671, 146, '2015-01-01 00:45:55.000000', 'temperatura', 437.0000, 'ºC'),
	(309672, 146, '2015-01-01 00:45:56.000000', 'temperatura', 489.0000, 'ºC'),
	(309673, 146, '2015-01-01 00:45:57.000000', 'temperatura', 1133.0000, 'ºC'),
	(309674, 146, '2015-01-01 00:45:58.000000', 'temperatura', 598.0000, 'ºC'),
	(309675, 146, '2015-01-01 00:45:59.000000', 'temperatura', 792.0000, 'ºC'),
	(309676, 146, '2015-01-01 00:46:00.000000', 'temperatura', 966.0000, 'ºC'),
	(309677, 146, '2015-01-01 00:46:01.000000', 'temperatura', 56.0000, 'ºC'),
	(309678, 146, '2015-01-01 00:46:02.000000', 'temperatura', 982.0000, 'ºC'),
	(309679, 146, '2015-01-01 00:46:03.000000', 'temperatura', 1144.0000, 'ºC'),
	(309680, 146, '2015-01-01 00:46:04.000000', 'temperatura', 372.0000, 'ºC'),
	(309681, 146, '2015-01-01 00:46:05.000000', 'temperatura', 828.0000, 'ºC'),
	(309682, 146, '2015-01-01 00:46:06.000000', 'temperatura', 625.0000, 'ºC'),
	(309683, 146, '2015-01-01 00:46:07.000000', 'temperatura', 644.0000, 'ºC'),
	(309684, 146, '2015-01-01 00:46:08.000000', 'temperatura', 143.0000, 'ºC'),
	(309685, 146, '2015-01-01 00:46:09.000000', 'temperatura', 1183.0000, 'ºC'),
	(309686, 146, '2015-01-01 00:46:10.000000', 'temperatura', 687.0000, 'ºC'),
	(309687, 146, '2015-01-01 00:46:11.000000', 'temperatura', 1088.0000, 'ºC'),
	(309688, 146, '2015-01-01 00:46:12.000000', 'temperatura', 977.0000, 'ºC'),
	(309689, 146, '2015-01-01 00:46:13.000000', 'temperatura', 422.0000, 'ºC'),
	(309690, 146, '2015-01-01 00:46:14.000000', 'temperatura', 379.0000, 'ºC'),
	(309691, 146, '2015-01-01 00:46:15.000000', 'temperatura', 631.0000, 'ºC'),
	(309692, 146, '2015-01-01 00:46:16.000000', 'temperatura', 817.0000, 'ºC'),
	(309693, 146, '2015-01-01 00:46:17.000000', 'temperatura', 991.0000, 'ºC'),
	(309694, 146, '2015-01-01 00:46:18.000000', 'temperatura', 107.0000, 'ºC'),
	(309695, 146, '2015-01-01 00:46:19.000000', 'temperatura', 1162.0000, 'ºC'),
	(309696, 146, '2015-01-01 00:46:20.000000', 'temperatura', 691.0000, 'ºC'),
	(309697, 146, '2015-01-01 00:46:21.000000', 'temperatura', 1167.0000, 'ºC'),
	(309698, 146, '2015-01-01 00:46:22.000000', 'temperatura', 161.0000, 'ºC'),
	(309699, 146, '2015-01-01 00:46:23.000000', 'temperatura', 908.0000, 'ºC'),
	(309700, 146, '2015-01-01 00:46:24.000000', 'temperatura', 454.0000, 'ºC'),
	(309701, 146, '2015-01-01 00:46:25.000000', 'temperatura', 750.0000, 'ºC'),
	(309702, 146, '2015-01-01 00:46:26.000000', 'temperatura', 1187.0000, 'ºC'),
	(309703, 146, '2015-01-01 00:46:27.000000', 'temperatura', 86.0000, 'ºC'),
	(309704, 146, '2015-01-01 00:46:28.000000', 'temperatura', 471.0000, 'ºC'),
	(309705, 146, '2015-01-01 00:46:29.000000', 'temperatura', 897.0000, 'ºC'),
	(309706, 146, '2015-01-01 00:46:30.000000', 'temperatura', 674.0000, 'ºC'),
	(309707, 146, '2015-01-01 00:46:31.000000', 'temperatura', 677.0000, 'ºC'),
	(309708, 146, '2015-01-01 00:46:32.000000', 'temperatura', 165.0000, 'ºC'),
	(309709, 146, '2015-01-01 00:46:33.000000', 'temperatura', 1192.0000, 'ºC'),
	(309710, 146, '2015-01-01 00:46:34.000000', 'temperatura', 668.0000, 'ºC'),
	(309711, 146, '2015-01-01 00:46:35.000000', 'temperatura', 962.0000, 'ºC'),
	(309712, 146, '2015-01-01 00:46:36.000000', 'temperatura', 408.0000, 'ºC'),
	(309713, 146, '2015-01-01 00:46:37.000000', 'temperatura', 356.0000, 'ºC'),
	(309714, 146, '2015-01-01 00:46:38.000000', 'temperatura', 555.0000, 'ºC'),
	(309715, 146, '2015-01-01 00:46:39.000000', 'temperatura', 507.0000, 'ºC'),
	(309716, 146, '2015-01-01 00:46:40.000000', 'temperatura', 870.0000, 'ºC'),
	(309717, 146, '2015-01-01 00:46:41.000000', 'temperatura', 432.0000, 'ºC'),
	(309718, 146, '2015-01-01 00:46:42.000000', 'temperatura', 747.0000, 'ºC'),
	(309719, 146, '2015-01-01 00:46:43.000000', 'temperatura', 42.0000, 'ºC'),
	(309720, 146, '2015-01-01 00:46:44.000000', 'temperatura', 369.0000, 'ºC'),
	(309721, 146, '2015-01-01 00:46:45.000000', 'temperatura', 521.0000, 'ºC'),
	(309722, 146, '2015-01-01 00:46:46.000000', 'temperatura', 298.0000, 'ºC'),
	(309723, 146, '2015-01-01 00:46:47.000000', 'temperatura', 1125.0000, 'ºC'),
	(309724, 146, '2015-01-01 00:46:48.000000', 'temperatura', 1133.0000, 'ºC'),
	(309725, 146, '2015-01-01 00:46:49.000000', 'temperatura', 1090.0000, 'ºC'),
	(309726, 146, '2015-01-01 00:46:50.000000', 'temperatura', 850.0000, 'ºC'),
	(309727, 146, '2015-01-01 00:46:51.000000', 'temperatura', 982.0000, 'ºC'),
	(309728, 146, '2015-01-01 00:46:52.000000', 'temperatura', 1160.0000, 'ºC'),
	(309729, 146, '2015-01-01 00:46:53.000000', 'temperatura', 456.0000, 'ºC'),
	(309730, 146, '2015-01-01 00:46:54.000000', 'temperatura', 1198.0000, 'ºC'),
	(309731, 146, '2015-01-01 00:46:55.000000', 'temperatura', 1022.0000, 'ºC'),
	(309732, 146, '2015-01-01 00:46:56.000000', 'temperatura', 317.0000, 'ºC'),
	(309733, 146, '2015-01-01 00:46:57.000000', 'temperatura', 919.0000, 'ºC'),
	(309734, 146, '2015-01-01 00:46:58.000000', 'temperatura', 44.0000, 'ºC'),
	(309735, 146, '2015-01-01 00:46:59.000000', 'temperatura', 1064.0000, 'ºC'),
	(309736, 146, '2015-01-01 00:47:00.000000', 'temperatura', 389.0000, 'ºC'),
	(309737, 146, '2015-01-01 00:47:01.000000', 'temperatura', 1153.0000, 'ºC'),
	(309738, 146, '2015-01-01 00:47:02.000000', 'temperatura', 997.0000, 'ºC'),
	(309739, 146, '2015-01-01 00:47:03.000000', 'temperatura', 329.0000, 'ºC'),
	(309740, 146, '2015-01-01 00:47:04.000000', 'temperatura', 1054.0000, 'ºC'),
	(309741, 146, '2015-01-01 00:47:05.000000', 'temperatura', 685.0000, 'ºC'),
	(309742, 146, '2015-01-01 00:47:06.000000', 'temperatura', 261.0000, 'ºC'),
	(309743, 146, '2015-01-01 00:47:07.000000', 'temperatura', 450.0000, 'ºC'),
	(309744, 146, '2015-01-01 00:47:08.000000', 'temperatura', 268.0000, 'ºC'),
	(309745, 146, '2015-01-01 00:47:09.000000', 'temperatura', 1189.0000, 'ºC'),
	(309746, 146, '2015-01-01 00:47:10.000000', 'temperatura', 344.0000, 'ºC'),
	(309747, 146, '2015-01-01 00:47:11.000000', 'temperatura', 555.0000, 'ºC'),
	(309748, 146, '2015-01-01 00:47:12.000000', 'temperatura', 540.0000, 'ºC'),
	(309749, 146, '2015-01-01 00:47:13.000000', 'temperatura', 1036.0000, 'ºC'),
	(309750, 146, '2015-01-01 00:47:14.000000', 'temperatura', 1162.0000, 'ºC'),
	(309751, 146, '2015-01-01 00:47:15.000000', 'temperatura', 303.0000, 'ºC'),
	(309752, 146, '2015-01-01 00:47:16.000000', 'temperatura', 430.0000, 'ºC'),
	(309753, 146, '2015-01-01 00:47:17.000000', 'temperatura', 41.0000, 'ºC'),
	(309754, 146, '2015-01-01 00:47:18.000000', 'temperatura', 117.0000, 'ºC'),
	(309755, 146, '2015-01-01 00:47:19.000000', 'temperatura', 459.0000, 'ºC'),
	(309756, 146, '2015-01-01 00:47:20.000000', 'temperatura', 747.0000, 'ºC'),
	(309757, 146, '2015-01-01 00:47:21.000000', 'temperatura', 1158.0000, 'ºC'),
	(309758, 146, '2015-01-01 00:47:22.000000', 'temperatura', 1151.0000, 'ºC'),
	(309759, 146, '2015-01-01 00:47:23.000000', 'temperatura', 1080.0000, 'ºC'),
	(309760, 146, '2015-01-01 00:47:24.000000', 'temperatura', 748.0000, 'ºC'),
	(309761, 146, '2015-01-01 00:47:25.000000', 'temperatura', 500.0000, 'ºC'),
	(309762, 146, '2015-01-01 00:47:26.000000', 'temperatura', 256.0000, 'ºC'),
	(309763, 146, '2015-01-01 00:47:27.000000', 'temperatura', 980.0000, 'ºC'),
	(309764, 146, '2015-01-01 00:47:28.000000', 'temperatura', 533.0000, 'ºC'),
	(309765, 146, '2015-01-01 00:47:29.000000', 'temperatura', 927.0000, 'ºC'),
	(309766, 146, '2015-01-01 00:47:30.000000', 'temperatura', 637.0000, 'ºC'),
	(309767, 146, '2015-01-01 00:47:31.000000', 'temperatura', 405.0000, 'ºC'),
	(309768, 146, '2015-01-01 00:47:32.000000', 'temperatura', 112.0000, 'ºC'),
	(309769, 146, '2015-01-01 00:47:33.000000', 'temperatura', 547.0000, 'ºC'),
	(309770, 146, '2015-01-01 00:47:34.000000', 'temperatura', 1198.0000, 'ºC'),
	(309771, 146, '2015-01-01 00:47:35.000000', 'temperatura', 748.0000, 'ºC'),
	(309772, 146, '2015-01-01 00:47:36.000000', 'temperatura', 149.0000, 'ºC'),
	(309773, 146, '2015-01-01 00:47:37.000000', 'temperatura', 900.0000, 'ºC'),
	(309774, 146, '2015-01-01 00:47:38.000000', 'temperatura', 456.0000, 'ºC'),
	(309775, 146, '2015-01-01 00:47:39.000000', 'temperatura', 780.0000, 'ºC'),
	(309776, 146, '2015-01-01 00:47:40.000000', 'temperatura', 133.0000, 'ºC'),
	(309777, 146, '2015-01-01 00:47:41.000000', 'temperatura', 724.0000, 'ºC'),
	(309778, 146, '2015-01-01 00:47:42.000000', 'temperatura', 822.0000, 'ºC'),
	(309779, 146, '2015-01-01 00:47:43.000000', 'temperatura', 740.0000, 'ºC'),
	(309780, 146, '2015-01-01 00:47:44.000000', 'temperatura', 34.0000, 'ºC'),
	(309781, 146, '2015-01-01 00:47:45.000000', 'temperatura', 352.0000, 'ºC'),
	(309782, 146, '2015-01-01 00:47:46.000000', 'temperatura', 455.0000, 'ºC'),
	(309783, 146, '2015-01-01 00:47:47.000000', 'temperatura', 21.0000, 'ºC'),
	(309784, 146, '2015-01-01 00:47:48.000000', 'temperatura', 1141.0000, 'ºC'),
	(309785, 146, '2015-01-01 00:47:49.000000', 'temperatura', 844.0000, 'ºC'),
	(309786, 146, '2015-01-01 00:47:50.000000', 'temperatura', 797.0000, 'ºC'),
	(309787, 146, '2015-01-01 00:47:51.000000', 'temperatura', 253.0000, 'ºC'),
	(309788, 146, '2015-01-01 00:47:52.000000', 'temperatura', 75.0000, 'ºC'),
	(309789, 146, '2015-01-01 00:47:53.000000', 'temperatura', 816.0000, 'ºC'),
	(309790, 146, '2015-01-01 00:47:54.000000', 'temperatura', 254.0000, 'ºC'),
	(309791, 146, '2015-01-01 00:47:55.000000', 'temperatura', 24.0000, 'ºC'),
	(309792, 146, '2015-01-01 00:47:56.000000', 'temperatura', 557.0000, 'ºC'),
	(309793, 146, '2015-01-01 00:47:57.000000', 'temperatura', 313.0000, 'ºC'),
	(309794, 146, '2015-01-01 00:47:58.000000', 'temperatura', 1096.0000, 'ºC'),
	(309795, 146, '2015-01-01 00:47:59.000000', 'temperatura', 941.0000, 'ºC'),
	(309796, 146, '2015-01-01 00:48:00.000000', 'temperatura', 217.0000, 'ºC'),
	(309797, 146, '2015-01-01 00:48:01.000000', 'temperatura', 661.0000, 'ºC'),
	(309798, 146, '2015-01-01 00:48:02.000000', 'temperatura', 256.0000, 'ºC'),
	(309799, 146, '2015-01-01 00:48:03.000000', 'temperatura', 498.0000, 'ºC'),
	(309800, 146, '2015-01-01 00:48:04.000000', 'temperatura', 521.0000, 'ºC'),
	(309801, 146, '2015-01-01 00:48:05.000000', 'temperatura', 1113.0000, 'ºC'),
	(309802, 146, '2015-01-01 00:48:06.000000', 'temperatura', 403.0000, 'ºC'),
	(309803, 146, '2015-01-01 00:48:07.000000', 'temperatura', 1074.0000, 'ºC'),
	(309804, 146, '2015-01-01 00:48:08.000000', 'temperatura', 565.0000, 'ºC'),
	(309805, 146, '2015-01-01 00:48:09.000000', 'temperatura', 801.0000, 'ºC'),
	(309806, 146, '2015-01-01 00:48:10.000000', 'temperatura', 1110.0000, 'ºC'),
	(309807, 146, '2015-01-01 00:48:11.000000', 'temperatura', 750.0000, 'ºC'),
	(309808, 146, '2015-01-01 00:48:12.000000', 'temperatura', 421.0000, 'ºC'),
	(309809, 146, '2015-01-01 00:48:13.000000', 'temperatura', 1055.0000, 'ºC'),
	(309810, 146, '2015-01-01 00:48:14.000000', 'temperatura', 410.0000, 'ºC'),
	(309811, 146, '2015-01-01 00:48:15.000000', 'temperatura', 88.0000, 'ºC'),
	(309812, 146, '2015-01-01 00:48:16.000000', 'temperatura', 411.0000, 'ºC'),
	(309813, 146, '2015-01-01 00:48:17.000000', 'temperatura', 593.0000, 'ºC'),
	(309814, 146, '2015-01-01 00:48:18.000000', 'temperatura', 529.0000, 'ºC'),
	(309815, 146, '2015-01-01 00:48:19.000000', 'temperatura', 869.0000, 'ºC'),
	(309816, 146, '2015-01-01 00:48:20.000000', 'temperatura', 359.0000, 'ºC'),
	(309817, 146, '2015-01-01 00:48:21.000000', 'temperatura', 388.0000, 'ºC'),
	(309818, 146, '2015-01-01 00:48:22.000000', 'temperatura', 865.0000, 'ºC'),
	(309819, 146, '2015-01-01 00:48:23.000000', 'temperatura', 758.0000, 'ºC'),
	(309820, 146, '2015-01-01 00:48:24.000000', 'temperatura', 1199.0000, 'ºC'),
	(309821, 146, '2015-01-01 00:48:25.000000', 'temperatura', 118.0000, 'ºC'),
	(309822, 146, '2015-01-01 00:48:26.000000', 'temperatura', 595.0000, 'ºC'),
	(309823, 146, '2015-01-01 00:48:27.000000', 'temperatura', 222.0000, 'ºC'),
	(309824, 146, '2015-01-01 00:48:28.000000', 'temperatura', 527.0000, 'ºC'),
	(309825, 146, '2015-01-01 00:48:29.000000', 'temperatura', 767.0000, 'ºC'),
	(309826, 146, '2015-01-01 00:48:30.000000', 'temperatura', 1057.0000, 'ºC'),
	(309827, 146, '2015-01-01 00:48:31.000000', 'temperatura', 585.0000, 'ºC'),
	(309828, 146, '2015-01-01 00:48:32.000000', 'temperatura', 953.0000, 'ºC'),
	(309829, 146, '2015-01-01 00:48:33.000000', 'temperatura', 610.0000, 'ºC'),
	(309830, 146, '2015-01-01 00:48:34.000000', 'temperatura', 193.0000, 'ºC'),
	(309831, 146, '2015-01-01 00:48:35.000000', 'temperatura', 334.0000, 'ºC'),
	(309832, 146, '2015-01-01 00:48:36.000000', 'temperatura', 1092.0000, 'ºC'),
	(309833, 146, '2015-01-01 00:48:37.000000', 'temperatura', 860.0000, 'ºC'),
	(309834, 146, '2015-01-01 00:48:38.000000', 'temperatura', 1021.0000, 'ºC'),
	(309835, 146, '2015-01-01 00:48:39.000000', 'temperatura', 129.0000, 'ºC'),
	(309836, 146, '2015-01-01 00:48:40.000000', 'temperatura', 1180.0000, 'ºC'),
	(309837, 146, '2015-01-01 00:48:41.000000', 'temperatura', 715.0000, 'ºC'),
	(309838, 146, '2015-01-01 00:48:42.000000', 'temperatura', 34.0000, 'ºC'),
	(309839, 146, '2015-01-01 00:48:43.000000', 'temperatura', 427.0000, 'ºC'),
	(309840, 146, '2015-01-01 00:48:44.000000', 'temperatura', 834.0000, 'ºC'),
	(309841, 146, '2015-01-01 00:48:45.000000', 'temperatura', 488.0000, 'ºC'),
	(309842, 146, '2015-01-01 00:48:46.000000', 'temperatura', 1138.0000, 'ºC'),
	(309843, 146, '2015-01-01 00:48:47.000000', 'temperatura', 626.0000, 'ºC'),
	(309844, 146, '2015-01-01 00:48:48.000000', 'temperatura', 918.0000, 'ºC'),
	(309845, 146, '2015-01-01 00:48:49.000000', 'temperatura', 314.0000, 'ºC'),
	(309846, 146, '2015-01-01 00:48:50.000000', 'temperatura', 15.0000, 'ºC'),
	(309847, 146, '2015-01-01 00:48:51.000000', 'temperatura', 335.0000, 'ºC'),
	(309848, 146, '2015-01-01 00:48:52.000000', 'temperatura', 430.0000, 'ºC'),
	(309849, 146, '2015-01-01 00:48:53.000000', 'temperatura', 1145.0000, 'ºC'),
	(309850, 146, '2015-01-01 00:48:54.000000', 'temperatura', 836.0000, 'ºC'),
	(309851, 146, '2015-01-01 00:48:55.000000', 'temperatura', 743.0000, 'ºC'),
	(309852, 146, '2015-01-01 00:48:56.000000', 'temperatura', 9.0000, 'ºC'),
	(309853, 146, '2015-01-01 00:48:57.000000', 'temperatura', 219.0000, 'ºC'),
	(309854, 146, '2015-01-01 00:48:58.000000', 'temperatura', 1065.0000, 'ºC'),
	(309855, 146, '2015-01-01 00:48:59.000000', 'temperatura', 1069.0000, 'ºC'),
	(309856, 146, '2015-01-01 00:49:00.000000', 'temperatura', 949.0000, 'ºC'),
	(309857, 146, '2015-01-01 00:49:01.000000', 'temperatura', 340.0000, 'ºC'),
	(309858, 146, '2015-01-01 00:49:02.000000', 'temperatura', 53.0000, 'ºC'),
	(309859, 146, '2015-01-01 00:49:03.000000', 'temperatura', 444.0000, 'ºC'),
	(309860, 146, '2015-01-01 00:49:04.000000', 'temperatura', 862.0000, 'ºC'),
	(309861, 146, '2015-01-01 00:49:05.000000', 'temperatura', 581.0000, 'ºC'),
	(309862, 146, '2015-01-01 00:49:06.000000', 'temperatura', 319.0000, 'ºC'),
	(309863, 146, '2015-01-01 00:49:07.000000', 'temperatura', 1050.0000, 'ºC'),
	(309864, 146, '2015-01-01 00:49:08.000000', 'temperatura', 694.0000, 'ºC'),
	(309865, 146, '2015-01-01 00:49:09.000000', 'temperatura', 322.0000, 'ºC'),
	(309866, 146, '2015-01-01 00:49:10.000000', 'temperatura', 728.0000, 'ºC'),
	(309867, 146, '2015-01-01 00:49:11.000000', 'temperatura', 274.0000, 'ºC'),
	(309868, 146, '2015-01-01 00:49:12.000000', 'temperatura', 386.0000, 'ºC'),
	(309869, 146, '2015-01-01 00:49:13.000000', 'temperatura', 1108.0000, 'ºC'),
	(309870, 146, '2015-01-01 00:49:14.000000', 'temperatura', 782.0000, 'ºC'),
	(309871, 146, '2015-01-01 00:49:15.000000', 'temperatura', 587.0000, 'ºC'),
	(309872, 146, '2015-01-01 00:49:16.000000', 'temperatura', 588.0000, 'ºC'),
	(309873, 146, '2015-01-01 00:49:17.000000', 'temperatura', 1182.0000, 'ºC'),
	(309874, 146, '2015-01-01 00:49:18.000000', 'temperatura', 545.0000, 'ºC'),
	(309875, 146, '2015-01-01 00:49:19.000000', 'temperatura', 378.0000, 'ºC'),
	(309876, 146, '2015-01-01 00:49:20.000000', 'temperatura', 257.0000, 'ºC'),
	(309877, 146, '2015-01-01 00:49:21.000000', 'temperatura', 153.0000, 'ºC'),
	(309878, 146, '2015-01-01 00:49:22.000000', 'temperatura', 1193.0000, 'ºC'),
	(309879, 146, '2015-01-01 00:49:23.000000', 'temperatura', 707.0000, 'ºC'),
	(309880, 146, '2015-01-01 00:49:24.000000', 'temperatura', 1156.0000, 'ºC'),
	(309881, 146, '2015-01-01 00:49:25.000000', 'temperatura', 59.0000, 'ºC'),
	(309882, 146, '2015-01-01 00:49:26.000000', 'temperatura', 429.0000, 'ºC'),
	(309883, 146, '2015-01-01 00:49:27.000000', 'temperatura', 766.0000, 'ºC'),
	(309884, 146, '2015-01-01 00:49:28.000000', 'temperatura', 145.0000, 'ºC'),
	(309885, 146, '2015-01-01 00:49:29.000000', 'temperatura', 827.0000, 'ºC'),
	(309886, 146, '2015-01-01 00:49:30.000000', 'temperatura', 100.0000, 'ºC'),
	(309887, 146, '2015-01-01 00:49:31.000000', 'temperatura', 422.0000, 'ºC'),
	(309888, 146, '2015-01-01 00:49:32.000000', 'temperatura', 608.0000, 'ºC'),
	(309889, 146, '2015-01-01 00:49:33.000000', 'temperatura', 574.0000, 'ºC'),
	(309890, 146, '2015-01-01 00:49:34.000000', 'temperatura', 1049.0000, 'ºC'),
	(309891, 146, '2015-01-01 00:49:35.000000', 'temperatura', 1121.0000, 'ºC'),
	(309892, 146, '2015-01-01 00:49:36.000000', 'temperatura', 58.0000, 'ºC'),
	(309893, 146, '2015-01-01 00:49:37.000000', 'temperatura', 529.0000, 'ºC'),
	(309894, 146, '2015-01-01 00:49:38.000000', 'temperatura', 70.0000, 'ºC'),
	(309895, 146, '2015-01-01 00:49:39.000000', 'temperatura', 1164.0000, 'ºC'),
	(309896, 146, '2015-01-01 00:49:40.000000', 'temperatura', 810.0000, 'ºC'),
	(309897, 146, '2015-01-01 00:49:41.000000', 'temperatura', 557.0000, 'ºC'),
	(309898, 146, '2015-01-01 00:49:42.000000', 'temperatura', 359.0000, 'ºC'),
	(309899, 146, '2015-01-01 00:49:43.000000', 'temperatura', 123.0000, 'ºC'),
	(309900, 146, '2015-01-01 00:49:44.000000', 'temperatura', 737.0000, 'ºC'),
	(309901, 146, '2015-01-01 00:49:45.000000', 'temperatura', 918.0000, 'ºC'),
	(309902, 146, '2015-01-01 00:49:46.000000', 'temperatura', 1180.0000, 'ºC'),
	(309903, 146, '2015-01-01 00:49:47.000000', 'temperatura', 744.0000, 'ºC'),
	(309904, 146, '2015-01-01 00:49:48.000000', 'temperatura', 183.0000, 'ºC'),
	(309905, 146, '2015-01-01 00:49:49.000000', 'temperatura', 1082.0000, 'ºC'),
	(309906, 146, '2015-01-01 00:49:50.000000', 'temperatura', 62.0000, 'ºC'),
	(309907, 146, '2015-01-01 00:49:51.000000', 'temperatura', 666.0000, 'ºC'),
	(309908, 146, '2015-01-01 00:49:52.000000', 'temperatura', 743.0000, 'ºC'),
	(309909, 146, '2015-01-01 00:49:53.000000', 'temperatura', 517.0000, 'ºC'),
	(309910, 146, '2015-01-01 00:49:54.000000', 'temperatura', 358.0000, 'ºC'),
	(309911, 146, '2015-01-01 00:49:55.000000', 'temperatura', 238.0000, 'ºC'),
	(309912, 146, '2015-01-01 00:49:56.000000', 'temperatura', 118.0000, 'ºC'),
	(309913, 146, '2015-01-01 00:49:57.000000', 'temperatura', 1075.0000, 'ºC'),
	(309914, 146, '2015-01-01 00:49:58.000000', 'temperatura', 223.0000, 'ºC'),
	(309915, 146, '2015-01-01 00:49:59.000000', 'temperatura', 291.0000, 'ºC'),
	(309916, 146, '2015-01-01 00:50:00.000000', 'temperatura', 785.0000, 'ºC'),
	(309917, 146, '2015-01-01 00:50:01.000000', 'temperatura', 654.0000, 'ºC'),
	(309918, 146, '2015-01-01 00:50:02.000000', 'temperatura', 913.0000, 'ºC'),
	(309919, 146, '2015-01-01 00:50:03.000000', 'temperatura', 205.0000, 'ºC'),
	(309920, 146, '2015-01-01 00:50:04.000000', 'temperatura', 686.0000, 'ºC'),
	(309921, 146, '2015-01-01 00:50:05.000000', 'temperatura', 418.0000, 'ºC'),
	(309922, 146, '2015-01-01 00:50:06.000000', 'temperatura', 30.0000, 'ºC'),
	(309923, 146, '2015-01-01 00:50:07.000000', 'temperatura', 95.0000, 'ºC'),
	(309924, 146, '2015-01-01 00:50:08.000000', 'temperatura', 389.0000, 'ºC'),
	(309925, 146, '2015-01-01 00:50:09.000000', 'temperatura', 459.0000, 'ºC'),
	(309926, 146, '2015-01-01 00:50:10.000000', 'temperatura', 1129.0000, 'ºC'),
	(309927, 146, '2015-01-01 00:50:11.000000', 'temperatura', 669.0000, 'ºC'),
	(309928, 146, '2015-01-01 00:50:12.000000', 'temperatura', 1158.0000, 'ºC'),
	(309929, 146, '2015-01-01 00:50:13.000000', 'temperatura', 183.0000, 'ºC'),
	(309930, 146, '2015-01-01 00:50:14.000000', 'temperatura', 1042.0000, 'ºC'),
	(309931, 146, '2015-01-01 00:50:15.000000', 'temperatura', 1061.0000, 'ºC'),
	(309932, 146, '2015-01-01 00:50:16.000000', 'temperatura', 981.0000, 'ºC'),
	(309933, 146, '2015-01-01 00:50:17.000000', 'temperatura', 523.0000, 'ºC'),
	(309934, 146, '2015-01-01 00:50:18.000000', 'temperatura', 873.0000, 'ºC'),
	(309935, 146, '2015-01-01 00:50:19.000000', 'temperatura', 396.0000, 'ºC'),
	(309936, 146, '2015-01-01 00:50:20.000000', 'temperatura', 561.0000, 'ºC'),
	(309937, 146, '2015-01-01 00:50:21.000000', 'temperatura', 417.0000, 'ºC'),
	(309938, 146, '2015-01-01 00:50:22.000000', 'temperatura', 401.0000, 'ºC'),
	(309939, 146, '2015-01-01 00:50:23.000000', 'temperatura', 757.0000, 'ºC'),
	(309940, 146, '2015-01-01 00:50:24.000000', 'temperatura', 182.0000, 'ºC'),
	(309941, 146, '2015-01-01 00:50:25.000000', 'temperatura', 1041.0000, 'ºC'),
	(309942, 146, '2015-01-01 00:50:26.000000', 'temperatura', 1057.0000, 'ºC'),
	(309943, 146, '2015-01-01 00:50:27.000000', 'temperatura', 962.0000, 'ºC'),
	(309944, 142, '2015-01-15 00:00:00.000000', 'temperatura', 522.0000, 'ºC'),
	(309945, 142, '2015-01-15 00:00:01.000000', 'temperatura', 88.0000, 'ºC'),
	(309946, 142, '2015-01-15 00:00:02.000000', 'temperatura', 71.0000, 'ºC'),
	(309947, 142, '2015-01-15 00:00:03.000000', 'temperatura', 92.0000, 'ºC'),
	(309948, 142, '2015-01-15 00:00:04.000000', 'temperatura', 246.0000, 'ºC'),
	(309949, 142, '2015-01-15 00:00:05.000000', 'temperatura', 955.0000, 'ºC'),
	(309950, 142, '2015-01-15 00:00:06.000000', 'temperatura', 439.0000, 'ºC'),
	(309951, 142, '2015-01-15 00:00:07.000000', 'temperatura', 532.0000, 'ºC'),
	(309952, 142, '2015-01-15 00:00:08.000000', 'temperatura', 141.0000, 'ºC'),
	(309953, 142, '2015-01-15 00:00:09.000000', 'temperatura', 309.0000, 'ºC'),
	(309954, 142, '2015-01-15 00:00:10.000000', 'temperatura', 1125.0000, 'ºC'),
	(309955, 142, '2015-01-15 00:00:11.000000', 'temperatura', 1097.0000, 'ºC'),
	(309956, 142, '2015-01-15 00:00:12.000000', 'temperatura', 913.0000, 'ºC'),
	(309957, 142, '2015-01-15 00:00:13.000000', 'temperatura', 71.0000, 'ºC'),
	(309958, 142, '2015-01-15 00:00:14.000000', 'temperatura', 19.0000, 'ºC'),
	(309959, 142, '2015-01-15 00:00:15.000000', 'temperatura', 1083.0000, 'ºC'),
	(309960, 142, '2015-01-15 00:00:16.000000', 'temperatura', 558.0000, 'ºC'),
	(309961, 142, '2015-01-15 00:00:17.000000', 'temperatura', 743.0000, 'ºC'),
	(309962, 142, '2015-01-15 00:00:18.000000', 'temperatura', 839.0000, 'ºC'),
	(309963, 142, '2015-01-15 00:00:19.000000', 'temperatura', 765.0000, 'ºC'),
	(309964, 142, '2015-01-15 00:00:20.000000', 'temperatura', 111.0000, 'ºC'),
	(309965, 142, '2015-01-15 00:00:21.000000', 'temperatura', 662.0000, 'ºC'),
	(309966, 142, '2015-01-15 00:00:22.000000', 'temperatura', 576.0000, 'ºC'),
	(309967, 142, '2015-01-15 00:00:23.000000', 'temperatura', 893.0000, 'ºC'),
	(309968, 142, '2015-01-15 00:00:24.000000', 'temperatura', 340.0000, 'ºC'),
	(309969, 142, '2015-01-15 00:00:25.000000', 'temperatura', 222.0000, 'ºC'),
	(309970, 142, '2015-01-15 00:00:26.000000', 'temperatura', 89.0000, 'ºC'),
	(309971, 142, '2015-01-15 00:00:27.000000', 'temperatura', 979.0000, 'ºC'),
	(309972, 142, '2015-01-15 00:00:28.000000', 'temperatura', 1029.0000, 'ºC'),
	(309973, 142, '2015-01-15 00:00:29.000000', 'temperatura', 1010.0000, 'ºC'),
	(309974, 142, '2015-01-15 00:00:30.000000', 'temperatura', 763.0000, 'ºC'),
	(309975, 142, '2015-01-15 00:00:31.000000', 'temperatura', 787.0000, 'ºC'),
	(309976, 142, '2015-01-15 00:00:32.000000', 'temperatura', 444.0000, 'ºC'),
	(309977, 142, '2015-01-15 00:00:33.000000', 'temperatura', 1060.0000, 'ºC'),
	(309978, 142, '2015-01-15 00:00:34.000000', 'temperatura', 367.0000, 'ºC'),
	(309979, 142, '2015-01-15 00:00:35.000000', 'temperatura', 1057.0000, 'ºC'),
	(309980, 142, '2015-01-15 00:00:36.000000', 'temperatura', 585.0000, 'ºC'),
	(309981, 142, '2015-01-15 00:00:37.000000', 'temperatura', 956.0000, 'ºC'),
	(309982, 142, '2015-01-15 00:00:38.000000', 'temperatura', 625.0000, 'ºC'),
	(309983, 142, '2015-01-15 00:00:39.000000', 'temperatura', 255.0000, 'ºC'),
	(309984, 142, '2015-01-15 00:00:40.000000', 'temperatura', 601.0000, 'ºC'),
	(309985, 142, '2015-01-15 00:00:41.000000', 'temperatura', 1043.0000, 'ºC'),
	(309986, 142, '2015-01-15 00:00:42.000000', 'temperatura', 1010.0000, 'ºC'),
	(309987, 142, '2015-01-15 00:00:43.000000', 'temperatura', 724.0000, 'ºC'),
	(309988, 142, '2015-01-15 00:00:44.000000', 'temperatura', 588.0000, 'ºC'),
	(309989, 142, '2015-01-15 00:00:45.000000', 'temperatura', 770.0000, 'ºC'),
	(309990, 142, '2015-01-15 00:00:46.000000', 'temperatura', 888.0000, 'ºC'),
	(309991, 142, '2015-01-15 00:00:47.000000', 'temperatura', 930.0000, 'ºC'),
	(309992, 142, '2015-01-15 00:00:48.000000', 'temperatura', 786.0000, 'ºC'),
	(309993, 142, '2015-01-15 00:00:49.000000', 'temperatura', 1142.0000, 'ºC'),
	(309994, 142, '2015-01-15 00:00:50.000000', 'temperatura', 952.0000, 'ºC'),
	(309995, 142, '2015-01-15 00:00:51.000000', 'temperatura', 132.0000, 'ºC'),
	(309996, 142, '2015-01-15 00:00:52.000000', 'temperatura', 208.0000, 'ºC'),
	(309997, 142, '2015-01-15 00:00:53.000000', 'temperatura', 642.0000, 'ºC'),
	(309998, 142, '2015-01-15 00:00:54.000000', 'temperatura', 189.0000, 'ºC'),
	(309999, 142, '2015-01-15 00:00:55.000000', 'temperatura', 217.0000, 'ºC'),
	(310000, 142, '2015-01-15 00:00:56.000000', 'temperatura', 518.0000, 'ºC'),
	(310001, 142, '2015-01-15 00:00:57.000000', 'temperatura', 740.0000, 'ºC'),
	(310002, 142, '2015-01-15 00:00:58.000000', 'temperatura', 945.0000, 'ºC'),
	(310003, 142, '2015-01-15 00:00:59.000000', 'temperatura', 109.0000, 'ºC'),
	(310004, 142, '2015-01-15 00:01:00.000000', 'temperatura', 107.0000, 'ºC'),
	(310005, 142, '2015-01-15 00:01:01.000000', 'temperatura', 210.0000, 'ºC'),
	(310006, 142, '2015-01-15 00:01:02.000000', 'temperatura', 729.0000, 'ºC'),
	(310007, 142, '2015-01-15 00:01:03.000000', 'temperatura', 616.0000, 'ºC'),
	(310008, 142, '2015-01-15 00:01:04.000000', 'temperatura', 893.0000, 'ºC'),
	(310009, 142, '2015-01-15 00:01:05.000000', 'temperatura', 219.0000, 'ºC'),
	(310010, 142, '2015-01-15 00:01:06.000000', 'temperatura', 817.0000, 'ºC'),
	(310011, 142, '2015-01-15 00:01:07.000000', 'temperatura', 1028.0000, 'ºC'),
	(310012, 142, '2015-01-15 00:01:08.000000', 'temperatura', 289.0000, 'ºC'),
	(310013, 142, '2015-01-15 00:01:09.000000', 'temperatura', 760.0000, 'ºC'),
	(310014, 142, '2015-01-15 00:01:10.000000', 'temperatura', 533.0000, 'ºC'),
	(310015, 142, '2015-01-15 00:01:11.000000', 'temperatura', 385.0000, 'ºC'),
	(310016, 142, '2015-01-15 00:01:12.000000', 'temperatura', 326.0000, 'ºC'),
	(310017, 142, '2015-01-15 00:01:13.000000', 'temperatura', 477.0000, 'ºC'),
	(310018, 142, '2015-01-15 00:01:14.000000', 'temperatura', 209.0000, 'ºC'),
	(310019, 142, '2015-01-15 00:01:15.000000', 'temperatura', 814.0000, 'ºC'),
	(310020, 142, '2015-01-15 00:01:16.000000', 'temperatura', 1041.0000, 'ºC'),
	(310021, 142, '2015-01-15 00:01:17.000000', 'temperatura', 367.0000, 'ºC'),
	(310022, 142, '2015-01-15 00:01:18.000000', 'temperatura', 1111.0000, 'ºC'),
	(310023, 142, '2015-01-15 00:01:19.000000', 'temperatura', 853.0000, 'ºC'),
	(310024, 142, '2015-01-15 00:01:20.000000', 'temperatura', 934.0000, 'ºC'),
	(310025, 142, '2015-01-15 00:01:21.000000', 'temperatura', 913.0000, 'ºC'),
	(310026, 142, '2015-01-15 00:01:22.000000', 'temperatura', 562.0000, 'ºC'),
	(310027, 142, '2015-01-15 00:01:23.000000', 'temperatura', 74.0000, 'ºC'),
	(310028, 142, '2015-01-15 00:01:24.000000', 'temperatura', 1082.0000, 'ºC'),
	(310029, 142, '2015-01-15 00:01:25.000000', 'temperatura', 388.0000, 'ºC'),
	(310030, 142, '2015-01-15 00:01:26.000000', 'temperatura', 1094.0000, 'ºC'),
	(310031, 142, '2015-01-15 00:01:27.000000', 'temperatura', 709.0000, 'ºC'),
	(310032, 142, '2015-01-15 00:01:28.000000', 'temperatura', 265.0000, 'ºC'),
	(310033, 142, '2015-01-15 00:01:29.000000', 'temperatura', 395.0000, 'ºC'),
	(310034, 142, '2015-01-15 00:01:30.000000', 'temperatura', 1180.0000, 'ºC'),
	(310035, 142, '2015-01-15 00:01:31.000000', 'temperatura', 1116.0000, 'ºC'),
	(310036, 142, '2015-01-15 00:01:32.000000', 'temperatura', 840.0000, 'ºC'),
	(310037, 142, '2015-01-15 00:01:33.000000', 'temperatura', 852.0000, 'ºC'),
	(310038, 142, '2015-01-15 00:01:34.000000', 'temperatura', 543.0000, 'ºC'),
	(310039, 142, '2015-01-15 00:01:35.000000', 'temperatura', 159.0000, 'ºC'),
	(310040, 142, '2015-01-15 00:01:36.000000', 'temperatura', 367.0000, 'ºC'),
	(310041, 142, '2015-01-15 00:01:37.000000', 'temperatura', 156.0000, 'ºC'),
	(310042, 142, '2015-01-15 00:01:38.000000', 'temperatura', 883.0000, 'ºC'),
	(310043, 142, '2015-01-15 00:01:39.000000', 'temperatura', 344.0000, 'ºC'),
	(310044, 142, '2015-01-15 00:01:40.000000', 'temperatura', 273.0000, 'ºC'),
	(310045, 142, '2015-01-15 00:01:41.000000', 'temperatura', 332.0000, 'ºC'),
	(310046, 142, '2015-01-15 00:01:42.000000', 'temperatura', 845.0000, 'ºC'),
	(310047, 142, '2015-01-15 00:01:43.000000', 'temperatura', 826.0000, 'ºC'),
	(310048, 142, '2015-01-15 00:01:44.000000', 'temperatura', 397.0000, 'ºC'),
	(310049, 142, '2015-01-15 00:01:45.000000', 'temperatura', 708.0000, 'ºC'),
	(310050, 142, '2015-01-15 00:01:46.000000', 'temperatura', 1147.0000, 'ºC'),
	(310051, 142, '2015-01-15 00:01:47.000000', 'temperatura', 12.0000, 'ºC'),
	(310052, 142, '2015-01-15 00:01:48.000000', 'temperatura', 222.0000, 'ºC'),
	(310053, 142, '2015-01-15 00:01:49.000000', 'temperatura', 1071.0000, 'ºC'),
	(310054, 142, '2015-01-15 00:01:50.000000', 'temperatura', 1093.0000, 'ºC'),
	(310055, 142, '2015-01-15 00:01:51.000000', 'temperatura', 1050.0000, 'ºC'),
	(310056, 142, '2015-01-15 00:01:52.000000', 'temperatura', 774.0000, 'ºC'),
	(310057, 142, '2015-01-15 00:01:53.000000', 'temperatura', 718.0000, 'ºC'),
	(310058, 142, '2015-01-15 00:01:54.000000', 'temperatura', 70.0000, 'ºC'),
	(310059, 142, '2015-01-15 00:01:55.000000', 'temperatura', 595.0000, 'ºC'),
	(310060, 142, '2015-01-15 00:01:56.000000', 'temperatura', 367.0000, 'ºC'),
	(310061, 142, '2015-01-15 00:01:57.000000', 'temperatura', 50.0000, 'ºC'),
	(310062, 142, '2015-01-15 00:01:58.000000', 'temperatura', 348.0000, 'ºC'),
	(310063, 142, '2015-01-15 00:01:59.000000', 'temperatura', 390.0000, 'ºC'),
	(310064, 142, '2015-01-15 00:02:00.000000', 'temperatura', 906.0000, 'ºC'),
	(310065, 142, '2015-01-15 00:02:01.000000', 'temperatura', 960.0000, 'ºC'),
	(310066, 142, '2015-01-15 00:02:02.000000', 'temperatura', 883.0000, 'ºC'),
	(310067, 142, '2015-01-15 00:02:03.000000', 'temperatura', 336.0000, 'ºC'),
	(310068, 142, '2015-01-15 00:02:04.000000', 'temperatura', 233.0000, 'ºC'),
	(310069, 142, '2015-01-15 00:02:05.000000', 'temperatura', 155.0000, 'ºC'),
	(310070, 142, '2015-01-15 00:02:06.000000', 'temperatura', 78.0000, 'ºC'),
	(310071, 142, '2015-01-15 00:02:07.000000', 'temperatura', 1125.0000, 'ºC'),
	(310072, 142, '2015-01-15 00:02:08.000000', 'temperatura', 593.0000, 'ºC'),
	(310073, 142, '2015-01-15 00:02:09.000000', 'temperatura', 787.0000, 'ºC'),
	(310074, 142, '2015-01-15 00:02:10.000000', 'temperatura', 960.0000, 'ºC'),
	(310075, 142, '2015-01-15 00:02:11.000000', 'temperatura', 38.0000, 'ºC'),
	(310076, 142, '2015-01-15 00:02:12.000000', 'temperatura', 913.0000, 'ºC'),
	(310077, 142, '2015-01-15 00:02:13.000000', 'temperatura', 849.0000, 'ºC'),
	(310078, 142, '2015-01-15 00:02:14.000000', 'temperatura', 305.0000, 'ºC'),
	(310079, 142, '2015-01-15 00:02:15.000000', 'temperatura', 180.0000, 'ºC'),
	(310080, 142, '2015-01-15 00:02:16.000000', 'temperatura', 1187.0000, 'ºC'),
	(310081, 142, '2015-01-15 00:02:17.000000', 'temperatura', 596.0000, 'ºC'),
	(310082, 142, '2015-01-15 00:02:18.000000', 'temperatura', 617.0000, 'ºC'),
	(310083, 142, '2015-01-15 00:02:19.000000', 'temperatura', 98.0000, 'ºC'),
	(310084, 142, '2015-01-15 00:02:20.000000', 'temperatura', 1041.0000, 'ºC'),
	(310085, 142, '2015-01-15 00:02:21.000000', 'temperatura', 110.0000, 'ºC'),
	(310086, 142, '2015-01-15 00:02:22.000000', 'temperatura', 1029.0000, 'ºC'),
	(310087, 142, '2015-01-15 00:02:23.000000', 'temperatura', 15.0000, 'ºC'),
	(310088, 142, '2015-01-15 00:02:24.000000', 'temperatura', 588.0000, 'ºC'),
	(310089, 142, '2015-01-15 00:02:25.000000', 'temperatura', 496.0000, 'ºC'),
	(310090, 142, '2015-01-15 00:02:26.000000', 'temperatura', 718.0000, 'ºC'),
	(310091, 142, '2015-01-15 00:02:27.000000', 'temperatura', 901.0000, 'ºC'),
	(310092, 142, '2015-01-15 00:02:28.000000', 'temperatura', 1152.0000, 'ºC'),
	(310093, 142, '2015-01-15 00:02:29.000000', 'temperatura', 657.0000, 'ºC'),
	(310094, 142, '2015-01-15 00:02:30.000000', 'temperatura', 1032.0000, 'ºC'),
	(310095, 142, '2015-01-15 00:02:31.000000', 'temperatura', 786.0000, 'ºC'),
	(310096, 142, '2015-01-15 00:02:32.000000', 'temperatura', 836.0000, 'ºC'),
	(310097, 142, '2015-01-15 00:02:33.000000', 'temperatura', 624.0000, 'ºC'),
	(310098, 142, '2015-01-15 00:02:34.000000', 'temperatura', 611.0000, 'ºC'),
	(310099, 142, '2015-01-15 00:02:35.000000', 'temperatura', 1182.0000, 'ºC'),
	(310100, 142, '2015-01-15 00:02:36.000000', 'temperatura', 477.0000, 'ºC'),
	(310101, 142, '2015-01-15 00:02:37.000000', 'temperatura', 42.0000, 'ºC'),
	(310102, 142, '2015-01-15 00:02:38.000000', 'temperatura', 1179.0000, 'ºC'),
	(310103, 142, '2015-01-15 00:02:39.000000', 'temperatura', 969.0000, 'ºC'),
	(310104, 142, '2015-01-15 00:02:40.000000', 'temperatura', 110.0000, 'ºC'),
	(310105, 142, '2015-01-15 00:02:41.000000', 'temperatura', 44.0000, 'ºC'),
	(310106, 142, '2015-01-15 00:02:42.000000', 'temperatura', 1091.0000, 'ºC'),
	(310107, 142, '2015-01-15 00:02:43.000000', 'temperatura', 523.0000, 'ºC'),
	(310108, 142, '2015-01-15 00:02:44.000000', 'temperatura', 541.0000, 'ºC'),
	(310109, 142, '2015-01-15 00:02:45.000000', 'temperatura', 1138.0000, 'ºC'),
	(310110, 142, '2015-01-15 00:02:46.000000', 'temperatura', 468.0000, 'ºC'),
	(310111, 142, '2015-01-15 00:02:47.000000', 'temperatura', 126.0000, 'ºC'),
	(310112, 142, '2015-01-15 00:02:48.000000', 'temperatura', 426.0000, 'ºC'),
	(310113, 142, '2015-01-15 00:02:49.000000', 'temperatura', 552.0000, 'ºC'),
	(310114, 142, '2015-01-15 00:02:50.000000', 'temperatura', 284.0000, 'ºC'),
	(310115, 142, '2015-01-15 00:02:51.000000', 'temperatura', 964.0000, 'ºC'),
	(310116, 142, '2015-01-15 00:02:52.000000', 'temperatura', 369.0000, 'ºC'),
	(310117, 142, '2015-01-15 00:02:53.000000', 'temperatura', 154.0000, 'ºC'),
	(310118, 142, '2015-01-15 00:02:54.000000', 'temperatura', 861.0000, 'ºC'),
	(310119, 142, '2015-01-15 00:02:55.000000', 'temperatura', 246.0000, 'ºC'),
	(310120, 142, '2015-01-15 00:02:56.000000', 'temperatura', 1047.0000, 'ºC'),
	(310121, 142, '2015-01-15 00:02:57.000000', 'temperatura', 897.0000, 'ºC'),
	(310122, 142, '2015-01-15 00:02:58.000000', 'temperatura', 145.0000, 'ºC'),
	(310123, 142, '2015-01-15 00:02:59.000000', 'temperatura', 433.0000, 'ºC'),
	(310124, 142, '2015-01-15 00:03:00.000000', 'temperatura', 532.0000, 'ºC'),
	(310125, 142, '2015-01-15 00:03:01.000000', 'temperatura', 160.0000, 'ºC'),
	(310126, 142, '2015-01-15 00:03:02.000000', 'temperatura', 405.0000, 'ºC'),
	(310127, 142, '2015-01-15 00:03:03.000000', 'temperatura', 345.0000, 'ºC'),
	(310128, 142, '2015-01-15 00:03:04.000000', 'temperatura', 513.0000, 'ºC'),
	(310129, 142, '2015-01-15 00:03:05.000000', 'temperatura', 329.0000, 'ºC'),
	(310130, 142, '2015-01-15 00:03:06.000000', 'temperatura', 108.0000, 'ºC'),
	(310131, 142, '2015-01-15 00:03:07.000000', 'temperatura', 750.0000, 'ºC'),
	(310132, 142, '2015-01-15 00:03:08.000000', 'temperatura', 1030.0000, 'ºC'),
	(310133, 142, '2015-01-15 00:03:09.000000', 'temperatura', 500.0000, 'ºC'),
	(310134, 142, '2015-01-15 00:03:10.000000', 'temperatura', 610.0000, 'ºC'),
	(310135, 142, '2015-01-15 00:03:11.000000', 'temperatura', 349.0000, 'ºC'),
	(310136, 142, '2015-01-15 00:03:12.000000', 'temperatura', 1117.0000, 'ºC'),
	(310137, 142, '2015-01-15 00:03:13.000000', 'temperatura', 937.0000, 'ºC'),
	(310138, 142, '2015-01-15 00:03:14.000000', 'temperatura', 137.0000, 'ºC'),
	(310139, 142, '2015-01-15 00:03:15.000000', 'temperatura', 272.0000, 'ºC'),
	(310140, 142, '2015-01-15 00:03:16.000000', 'temperatura', 951.0000, 'ºC'),
	(310141, 142, '2015-01-15 00:03:17.000000', 'temperatura', 341.0000, 'ºC'),
	(310142, 142, '2015-01-15 00:03:18.000000', 'temperatura', 50.0000, 'ºC'),
	(310143, 142, '2015-01-15 00:03:19.000000', 'temperatura', 426.0000, 'ºC'),
	(310144, 142, '2015-01-15 00:03:20.000000', 'temperatura', 783.0000, 'ºC'),
	(310145, 142, '2015-01-15 00:03:21.000000', 'temperatura', 236.0000, 'ºC'),
	(310146, 142, '2015-01-15 00:03:22.000000', 'temperatura', 34.0000, 'ºC'),
	(310147, 142, '2015-01-15 00:03:23.000000', 'temperatura', 661.0000, 'ºC'),
	(310148, 142, '2015-01-15 00:03:24.000000', 'temperatura', 806.0000, 'ºC'),
	(310149, 142, '2015-01-15 00:03:25.000000', 'temperatura', 844.0000, 'ºC'),
	(310150, 142, '2015-01-15 00:03:26.000000', 'temperatura', 603.0000, 'ºC'),
	(310151, 142, '2015-01-15 00:03:27.000000', 'temperatura', 483.0000, 'ºC'),
	(310152, 142, '2015-01-15 00:03:28.000000', 'temperatura', 609.0000, 'ºC'),
	(310153, 142, '2015-01-15 00:03:29.000000', 'temperatura', 395.0000, 'ºC'),
	(310154, 142, '2015-01-15 00:03:30.000000', 'temperatura', 147.0000, 'ºC'),
	(310155, 142, '2015-01-15 00:03:31.000000', 'temperatura', 751.0000, 'ºC'),
	(310156, 142, '2015-01-15 00:03:32.000000', 'temperatura', 915.0000, 'ºC'),
	(310157, 142, '2015-01-15 00:03:33.000000', 'temperatura', 1123.0000, 'ºC'),
	(310158, 142, '2015-01-15 00:03:34.000000', 'temperatura', 470.0000, 'ºC'),
	(310159, 142, '2015-01-15 00:03:35.000000', 'temperatura', 180.0000, 'ºC'),
	(310160, 142, '2015-01-15 00:03:36.000000', 'temperatura', 693.0000, 'ºC'),
	(310161, 142, '2015-01-15 00:03:37.000000', 'temperatura', 525.0000, 'ºC'),
	(310162, 142, '2015-01-15 00:03:38.000000', 'temperatura', 546.0000, 'ºC'),
	(310163, 142, '2015-01-15 00:03:39.000000', 'temperatura', 1157.0000, 'ºC'),
	(310164, 142, '2015-01-15 00:03:40.000000', 'temperatura', 548.0000, 'ºC'),
	(310165, 142, '2015-01-15 00:03:41.000000', 'temperatura', 471.0000, 'ºC'),
	(310166, 142, '2015-01-15 00:03:42.000000', 'temperatura', 708.0000, 'ºC'),
	(310167, 142, '2015-01-15 00:03:43.000000', 'temperatura', 929.0000, 'ºC'),
	(310168, 142, '2015-01-15 00:03:44.000000', 'temperatura', 122.0000, 'ºC'),
	(310169, 142, '2015-01-15 00:03:45.000000', 'temperatura', 224.0000, 'ºC'),
	(310170, 142, '2015-01-15 00:03:46.000000', 'temperatura', 756.0000, 'ºC'),
	(310171, 142, '2015-01-15 00:03:47.000000', 'temperatura', 705.0000, 'ºC'),
	(310172, 142, '2015-01-15 00:03:48.000000', 'temperatura', 58.0000, 'ºC'),
	(310173, 142, '2015-01-15 00:03:49.000000', 'temperatura', 578.0000, 'ºC'),
	(310174, 142, '2015-01-15 00:03:50.000000', 'temperatura', 315.0000, 'ºC'),
	(310175, 142, '2015-01-15 00:03:51.000000', 'temperatura', 1042.0000, 'ºC'),
	(310176, 142, '2015-01-15 00:03:52.000000', 'temperatura', 665.0000, 'ºC'),
	(310177, 142, '2015-01-15 00:03:53.000000', 'temperatura', 199.0000, 'ºC'),
	(310178, 142, '2015-01-15 00:03:54.000000', 'temperatura', 202.0000, 'ºC'),
	(310179, 142, '2015-01-15 00:03:55.000000', 'temperatura', 413.0000, 'ºC'),
	(310180, 142, '2015-01-15 00:03:56.000000', 'temperatura', 259.0000, 'ºC'),
	(310181, 142, '2015-01-15 00:03:57.000000', 'temperatura', 58.0000, 'ºC'),
	(310182, 142, '2015-01-15 00:03:58.000000', 'temperatura', 711.0000, 'ºC'),
	(310183, 142, '2015-01-15 00:03:59.000000', 'temperatura', 984.0000, 'ºC'),
	(310184, 142, '2015-01-15 00:04:00.000000', 'temperatura', 388.0000, 'ºC'),
	(310185, 142, '2015-01-15 00:04:01.000000', 'temperatura', 190.0000, 'ºC'),
	(310186, 142, '2015-01-15 00:04:02.000000', 'temperatura', 983.0000, 'ºC'),
	(310187, 142, '2015-01-15 00:04:03.000000', 'temperatura', 746.0000, 'ºC'),
	(310188, 142, '2015-01-15 00:04:04.000000', 'temperatura', 782.0000, 'ºC'),
	(310189, 142, '2015-01-15 00:04:05.000000', 'temperatura', 473.0000, 'ºC'),
	(310190, 142, '2015-01-15 00:04:06.000000', 'temperatura', 20.0000, 'ºC'),
	(310191, 142, '2015-01-15 00:04:07.000000', 'temperatura', 1081.0000, 'ºC'),
	(310192, 142, '2015-01-15 00:04:08.000000', 'temperatura', 545.0000, 'ºC'),
	(310193, 142, '2015-01-15 00:04:09.000000', 'temperatura', 681.0000, 'ºC'),
	(310194, 142, '2015-01-15 00:04:10.000000', 'temperatura', 572.0000, 'ºC'),
	(310195, 142, '2015-01-15 00:04:11.000000', 'temperatura', 816.0000, 'ºC'),
	(310196, 142, '2015-01-15 00:04:12.000000', 'temperatura', 1164.0000, 'ºC'),
	(310197, 142, '2015-01-15 00:04:13.000000', 'temperatura', 972.0000, 'ºC'),
	(310198, 142, '2015-01-15 00:04:14.000000', 'temperatura', 169.0000, 'ºC'),
	(310199, 142, '2015-01-15 00:04:15.000000', 'temperatura', 328.0000, 'ºC'),
	(310200, 142, '2015-01-15 00:04:16.000000', 'temperatura', 1136.0000, 'ºC'),
	(310201, 142, '2015-01-15 00:04:17.000000', 'temperatura', 1097.0000, 'ºC'),
	(310202, 142, '2015-01-15 00:04:18.000000', 'temperatura', 876.0000, 'ºC'),
	(310203, 142, '2015-01-15 00:04:19.000000', 'temperatura', 1089.0000, 'ºC'),
	(310204, 142, '2015-01-15 00:04:20.000000', 'temperatura', 417.0000, 'ºC'),
	(310205, 142, '2015-01-15 00:04:21.000000', 'temperatura', 21.0000, 'ºC'),
	(310206, 142, '2015-01-15 00:04:22.000000', 'temperatura', 52.0000, 'ºC'),
	(310207, 142, '2015-01-15 00:04:23.000000', 'temperatura', 196.0000, 'ºC'),
	(310208, 142, '2015-01-15 00:04:24.000000', 'temperatura', 827.0000, 'ºC'),
	(310209, 142, '2015-01-15 00:04:25.000000', 'temperatura', 1148.0000, 'ºC'),
	(310210, 142, '2015-01-15 00:04:26.000000', 'temperatura', 860.0000, 'ºC'),
	(310211, 142, '2015-01-15 00:04:27.000000', 'temperatura', 857.0000, 'ºC'),
	(310212, 142, '2015-01-15 00:04:28.000000', 'temperatura', 507.0000, 'ºC'),
	(310213, 142, '2015-01-15 00:04:29.000000', 'temperatura', 1161.0000, 'ºC'),
	(310214, 142, '2015-01-15 00:04:30.000000', 'temperatura', 686.0000, 'ºC'),
	(310215, 142, '2015-01-15 00:04:31.000000', 'temperatura', 1146.0000, 'ºC'),
	(310216, 142, '2015-01-15 00:04:32.000000', 'temperatura', 74.0000, 'ºC'),
	(310217, 142, '2015-01-15 00:04:33.000000', 'temperatura', 534.0000, 'ºC'),
	(310218, 142, '2015-01-15 00:04:34.000000', 'temperatura', 45.0000, 'ºC'),
	(310219, 142, '2015-01-15 00:04:35.000000', 'temperatura', 1025.0000, 'ºC'),
	(310220, 142, '2015-01-15 00:04:36.000000', 'temperatura', 193.0000, 'ºC'),
	(310221, 142, '2015-01-15 00:04:37.000000', 'temperatura', 287.0000, 'ºC'),
	(310222, 142, '2015-01-15 00:04:38.000000', 'temperatura', 858.0000, 'ºC'),
	(310223, 142, '2015-01-15 00:04:39.000000', 'temperatura', 1029.0000, 'ºC'),
	(310224, 142, '2015-01-15 00:04:40.000000', 'temperatura', 171.0000, 'ºC'),
	(310225, 142, '2015-01-15 00:04:41.000000', 'temperatura', 170.0000, 'ºC'),
	(310226, 142, '2015-01-15 00:04:42.000000', 'temperatura', 337.0000, 'ºC'),
	(310227, 142, '2015-01-15 00:04:43.000000', 'temperatura', 1177.0000, 'ºC'),
	(310228, 142, '2015-01-15 00:04:44.000000', 'temperatura', 75.0000, 'ºC'),
	(310229, 142, '2015-01-15 00:04:45.000000', 'temperatura', 442.0000, 'ºC'),
	(310230, 142, '2015-01-15 00:04:46.000000', 'temperatura', 785.0000, 'ºC'),
	(310231, 142, '2015-01-15 00:04:47.000000', 'temperatura', 203.0000, 'ºC'),
	(310232, 142, '2015-01-15 00:04:48.000000', 'temperatura', 1057.0000, 'ºC'),
	(310233, 142, '2015-01-15 00:04:49.000000', 'temperatura', 1076.0000, 'ºC'),
	(310234, 142, '2015-01-15 00:04:50.000000', 'temperatura', 1011.0000, 'ºC'),
	(310235, 142, '2015-01-15 00:04:51.000000', 'temperatura', 628.0000, 'ºC'),
	(310236, 142, '2015-01-15 00:04:52.000000', 'temperatura', 109.0000, 'ºC'),
	(310237, 142, '2015-01-15 00:04:53.000000', 'temperatura', 1060.0000, 'ºC'),
	(310238, 142, '2015-01-15 00:04:54.000000', 'temperatura', 173.0000, 'ºC'),
	(310239, 142, '2015-01-15 00:04:55.000000', 'temperatura', 86.0000, 'ºC'),
	(310240, 142, '2015-01-15 00:04:56.000000', 'temperatura', 1111.0000, 'ºC'),
	(310241, 142, '2015-01-15 00:04:57.000000', 'temperatura', 496.0000, 'ºC'),
	(310242, 142, '2015-01-15 00:04:58.000000', 'temperatura', 347.0000, 'ºC'),
	(310243, 142, '2015-01-15 00:04:59.000000', 'temperatura', 250.0000, 'ºC'),
	(310244, 142, '2015-01-15 00:05:00.000000', 'temperatura', 209.0000, 'ºC'),
	(310245, 142, '2015-01-15 00:05:01.000000', 'temperatura', 295.0000, 'ºC'),
	(310246, 142, '2015-01-15 00:05:02.000000', 'temperatura', 847.0000, 'ºC'),
	(310247, 142, '2015-01-15 00:05:03.000000', 'temperatura', 952.0000, 'ºC'),
	(310248, 142, '2015-01-15 00:05:04.000000', 'temperatura', 1017.0000, 'ºC'),
	(310249, 142, '2015-01-15 00:05:05.000000', 'temperatura', 1033.0000, 'ºC'),
	(310250, 142, '2015-01-15 00:05:06.000000', 'temperatura', 912.0000, 'ºC'),
	(310251, 142, '2015-01-15 00:05:07.000000', 'temperatura', 261.0000, 'ºC'),
	(310252, 142, '2015-01-15 00:05:08.000000', 'temperatura', 971.0000, 'ºC'),
	(310253, 142, '2015-01-15 00:05:09.000000', 'temperatura', 470.0000, 'ºC'),
	(310254, 142, '2015-01-15 00:05:10.000000', 'temperatura', 640.0000, 'ºC'),
	(310255, 142, '2015-01-15 00:05:11.000000', 'temperatura', 589.0000, 'ºC'),
	(310256, 142, '2015-01-15 00:05:12.000000', 'temperatura', 1025.0000, 'ºC'),
	(310257, 142, '2015-01-15 00:05:13.000000', 'temperatura', 960.0000, 'ºC'),
	(310258, 142, '2015-01-15 00:05:14.000000', 'temperatura', 524.0000, 'ºC'),
	(310259, 142, '2015-01-15 00:05:15.000000', 'temperatura', 940.0000, 'ºC'),
	(310260, 142, '2015-01-15 00:05:16.000000', 'temperatura', 730.0000, 'ºC'),
	(310261, 142, '2015-01-15 00:05:17.000000', 'temperatura', 829.0000, 'ºC'),
	(310262, 142, '2015-01-15 00:05:18.000000', 'temperatura', 755.0000, 'ºC'),
	(310263, 142, '2015-01-15 00:05:19.000000', 'temperatura', 89.0000, 'ºC'),
	(310264, 142, '2015-01-15 00:05:20.000000', 'temperatura', 581.0000, 'ºC'),
	(310265, 142, '2015-01-15 00:05:21.000000', 'temperatura', 237.0000, 'ºC'),
	(310266, 142, '2015-01-15 00:05:22.000000', 'temperatura', 645.0000, 'ºC'),
	(310267, 142, '2015-01-15 00:05:23.000000', 'temperatura', 112.0000, 'ºC'),
	(310268, 142, '2015-01-15 00:05:24.000000', 'temperatura', 1026.0000, 'ºC'),
	(310269, 142, '2015-01-15 00:05:25.000000', 'temperatura', 1196.0000, 'ºC'),
	(310270, 142, '2015-01-15 00:05:26.000000', 'temperatura', 500.0000, 'ºC'),
	(310271, 142, '2015-01-15 00:05:27.000000', 'temperatura', 115.0000, 'ºC'),
	(310272, 142, '2015-01-15 00:05:28.000000', 'temperatura', 276.0000, 'ºC'),
	(310273, 142, '2015-01-15 00:05:29.000000', 'temperatura', 1035.0000, 'ºC'),
	(310274, 142, '2015-01-15 00:05:30.000000', 'temperatura', 746.0000, 'ºC'),
	(310275, 142, '2015-01-15 00:05:31.000000', 'temperatura', 627.0000, 'ºC'),
	(310276, 142, '2015-01-15 00:05:32.000000', 'temperatura', 896.0000, 'ºC'),
	(310277, 142, '2015-01-15 00:05:33.000000', 'temperatura', 201.0000, 'ºC'),
	(310278, 142, '2015-01-15 00:05:34.000000', 'temperatura', 719.0000, 'ºC'),
	(310279, 142, '2015-01-15 00:05:35.000000', 'temperatura', 590.0000, 'ºC'),
	(310280, 142, '2015-01-15 00:05:36.000000', 'temperatura', 795.0000, 'ºC'),
	(310281, 142, '2015-01-15 00:05:37.000000', 'temperatura', 1007.0000, 'ºC'),
	(310282, 142, '2015-01-15 00:05:38.000000', 'temperatura', 250.0000, 'ºC'),
	(310283, 142, '2015-01-15 00:05:39.000000', 'temperatura', 627.0000, 'ºC'),
	(310284, 142, '2015-01-15 00:05:40.000000', 'temperatura', 1186.0000, 'ºC'),
	(310285, 142, '2015-01-15 00:05:41.000000', 'temperatura', 451.0000, 'ºC'),
	(310286, 142, '2015-01-15 00:05:42.000000', 'temperatura', 1097.0000, 'ºC'),
	(310287, 142, '2015-01-15 00:05:43.000000', 'temperatura', 531.0000, 'ºC'),
	(310288, 142, '2015-01-15 00:05:44.000000', 'temperatura', 565.0000, 'ºC'),
	(310289, 142, '2015-01-15 00:05:45.000000', 'temperatura', 35.0000, 'ºC'),
	(310290, 142, '2015-01-15 00:05:46.000000', 'temperatura', 879.0000, 'ºC'),
	(310291, 142, '2015-01-15 00:05:47.000000', 'temperatura', 689.0000, 'ºC'),
	(310292, 142, '2015-01-15 00:05:48.000000', 'temperatura', 808.0000, 'ºC'),
	(310293, 142, '2015-01-15 00:05:49.000000', 'temperatura', 774.0000, 'ºC'),
	(310294, 142, '2015-01-15 00:05:50.000000', 'temperatura', 249.0000, 'ºC'),
	(310295, 142, '2015-01-15 00:05:51.000000', 'temperatura', 121.0000, 'ºC'),
	(310296, 142, '2015-01-15 00:05:52.000000', 'temperatura', 1061.0000, 'ºC'),
	(310297, 142, '2015-01-15 00:05:53.000000', 'temperatura', 141.0000, 'ºC'),
	(310298, 142, '2015-01-15 00:05:54.000000', 'temperatura', 1123.0000, 'ºC'),
	(310299, 142, '2015-01-15 00:05:55.000000', 'temperatura', 394.0000, 'ºC'),
	(310300, 142, '2015-01-15 00:05:56.000000', 'temperatura', 1001.0000, 'ºC'),
	(310301, 142, '2015-01-15 00:05:57.000000', 'temperatura', 223.0000, 'ºC'),
	(310302, 142, '2015-01-15 00:05:58.000000', 'temperatura', 514.0000, 'ºC'),
	(310303, 142, '2015-01-15 00:05:59.000000', 'temperatura', 699.0000, 'ºC'),
	(310304, 142, '2015-01-15 00:06:00.000000', 'temperatura', 755.0000, 'ºC'),
	(310305, 142, '2015-01-15 00:06:01.000000', 'temperatura', 477.0000, 'ºC'),
	(310306, 142, '2015-01-15 00:06:02.000000', 'temperatura', 119.0000, 'ºC'),
	(310307, 142, '2015-01-15 00:06:03.000000', 'temperatura', 368.0000, 'ºC'),
	(310308, 142, '2015-01-15 00:06:04.000000', 'temperatura', 283.0000, 'ºC'),
	(310309, 142, '2015-01-15 00:06:05.000000', 'temperatura', 311.0000, 'ºC'),
	(310310, 142, '2015-01-15 00:06:06.000000', 'temperatura', 708.0000, 'ºC'),
	(310311, 142, '2015-01-15 00:06:07.000000', 'temperatura', 208.0000, 'ºC'),
	(310312, 142, '2015-01-15 00:06:08.000000', 'temperatura', 117.0000, 'ºC'),
	(310313, 142, '2015-01-15 00:06:09.000000', 'temperatura', 1160.0000, 'ºC'),
	(310314, 142, '2015-01-15 00:06:10.000000', 'temperatura', 650.0000, 'ºC'),
	(310315, 142, '2015-01-15 00:06:11.000000', 'temperatura', 970.0000, 'ºC'),
	(310316, 142, '2015-01-15 00:06:12.000000', 'temperatura', 503.0000, 'ºC'),
	(310317, 142, '2015-01-15 00:06:13.000000', 'temperatura', 803.0000, 'ºC'),
	(310318, 142, '2015-01-15 00:06:14.000000', 'temperatura', 107.0000, 'ºC'),
	(310319, 142, '2015-01-15 00:06:15.000000', 'temperatura', 528.0000, 'ºC'),
	(310320, 142, '2015-01-15 00:06:16.000000', 'temperatura', 1121.0000, 'ºC'),
	(310321, 142, '2015-01-15 00:06:17.000000', 'temperatura', 418.0000, 'ºC'),
	(310322, 142, '2015-01-15 00:06:18.000000', 'temperatura', 1128.0000, 'ºC'),
	(310323, 142, '2015-01-15 00:06:19.000000', 'temperatura', 787.0000, 'ºC'),
	(310324, 142, '2015-01-15 00:06:20.000000', 'temperatura', 551.0000, 'ºC'),
	(310325, 142, '2015-01-15 00:06:21.000000', 'temperatura', 396.0000, 'ºC'),
	(310326, 142, '2015-01-15 00:06:22.000000', 'temperatura', 327.0000, 'ºC'),
	(310327, 142, '2015-01-15 00:06:23.000000', 'temperatura', 448.0000, 'ºC'),
	(310328, 142, '2015-01-15 00:06:24.000000', 'temperatura', 58.0000, 'ºC'),
	(310329, 142, '2015-01-15 00:06:25.000000', 'temperatura', 149.0000, 'ºC'),
	(310330, 142, '2015-01-15 00:06:26.000000', 'temperatura', 569.0000, 'ºC'),
	(310331, 142, '2015-01-15 00:06:27.000000', 'temperatura', 1.0000, 'ºC'),
	(310332, 142, '2015-01-15 00:06:28.000000', 'temperatura', 697.0000, 'ºC'),
	(310333, 142, '2015-01-15 00:06:29.000000', 'temperatura', 1081.0000, 'ºC'),
	(310334, 142, '2015-01-15 00:06:30.000000', 'temperatura', 914.0000, 'ºC'),
	(310335, 142, '2015-01-15 00:06:31.000000', 'temperatura', 129.0000, 'ºC'),
	(310336, 142, '2015-01-15 00:06:32.000000', 'temperatura', 304.0000, 'ºC'),
	(310337, 142, '2015-01-15 00:06:33.000000', 'temperatura', 1132.0000, 'ºC'),
	(310338, 142, '2015-01-15 00:06:34.000000', 'temperatura', 1149.0000, 'ºC'),
	(310339, 142, '2015-01-15 00:06:35.000000', 'temperatura', 1148.0000, 'ºC'),
	(310340, 142, '2015-01-15 00:06:36.000000', 'temperatura', 1095.0000, 'ºC'),
	(310341, 142, '2015-01-15 00:06:37.000000', 'temperatura', 831.0000, 'ºC'),
	(310342, 142, '2015-01-15 00:06:38.000000', 'temperatura', 869.0000, 'ºC'),
	(310343, 142, '2015-01-15 00:06:39.000000', 'temperatura', 654.0000, 'ºC'),
	(310344, 142, '2015-01-15 00:06:40.000000', 'temperatura', 664.0000, 'ºC'),
	(310345, 142, '2015-01-15 00:06:41.000000', 'temperatura', 160.0000, 'ºC'),
	(310346, 142, '2015-01-15 00:06:42.000000', 'temperatura', 7.0000, 'ºC'),
	(310347, 142, '2015-01-15 00:06:43.000000', 'temperatura', 756.0000, 'ºC'),
	(310348, 142, '2015-01-15 00:06:44.000000', 'temperatura', 159.0000, 'ºC'),
	(310349, 142, '2015-01-15 00:06:45.000000', 'temperatura', 929.0000, 'ºC'),
	(310350, 142, '2015-01-15 00:06:46.000000', 'temperatura', 569.0000, 'ºC'),
	(310351, 142, '2015-01-15 00:06:47.000000', 'temperatura', 57.0000, 'ºC'),
	(310352, 142, '2015-01-15 00:06:48.000000', 'temperatura', 980.0000, 'ºC'),
	(310353, 142, '2015-01-15 00:06:49.000000', 'temperatura', 1127.0000, 'ºC'),
	(310354, 142, '2015-01-15 00:06:50.000000', 'temperatura', 299.0000, 'ºC'),
	(310355, 142, '2015-01-15 00:06:51.000000', 'temperatura', 511.0000, 'ºC'),
	(310356, 142, '2015-01-15 00:06:52.000000', 'temperatura', 460.0000, 'ºC'),
	(310357, 142, '2015-01-15 00:06:53.000000', 'temperatura', 768.0000, 'ºC'),
	(310358, 142, '2015-01-15 00:06:54.000000', 'temperatura', 60.0000, 'ºC'),
	(310359, 142, '2015-01-15 00:06:55.000000', 'temperatura', 398.0000, 'ºC'),
	(310360, 142, '2015-01-15 00:06:56.000000', 'temperatura', 609.0000, 'ºC'),
	(310361, 142, '2015-01-15 00:06:57.000000', 'temperatura', 653.0000, 'ºC'),
	(310362, 142, '2015-01-15 00:06:58.000000', 'temperatura', 237.0000, 'ºC'),
	(310363, 142, '2015-01-15 00:06:59.000000', 'temperatura', 429.0000, 'ºC'),
	(310364, 142, '2015-01-15 00:07:00.000000', 'temperatura', 232.0000, 'ºC'),
	(310365, 142, '2015-01-15 00:07:01.000000', 'temperatura', 1074.0000, 'ºC'),
	(310366, 142, '2015-01-15 00:07:02.000000', 'temperatura', 1073.0000, 'ºC'),
	(310367, 142, '2015-01-15 00:07:03.000000', 'temperatura', 946.0000, 'ºC'),
	(310368, 142, '2015-01-15 00:07:04.000000', 'temperatura', 311.0000, 'ºC'),
	(310369, 142, '2015-01-15 00:07:05.000000', 'temperatura', 1115.0000, 'ºC'),
	(310370, 142, '2015-01-15 00:07:06.000000', 'temperatura', 1045.0000, 'ºC'),
	(310371, 142, '2015-01-15 00:07:07.000000', 'temperatura', 678.0000, 'ºC'),
	(310372, 142, '2015-01-15 00:07:08.000000', 'temperatura', 256.0000, 'ºC'),
	(310373, 142, '2015-01-15 00:07:09.000000', 'temperatura', 448.0000, 'ºC'),
	(310374, 142, '2015-01-15 00:07:10.000000', 'temperatura', 272.0000, 'ºC'),
	(310375, 142, '2015-01-15 00:07:11.000000', 'temperatura', 18.0000, 'ºC'),
	(310376, 142, '2015-01-15 00:07:12.000000', 'temperatura', 472.0000, 'ºC'),
	(310377, 142, '2015-01-15 00:07:13.000000', 'temperatura', 1108.0000, 'ºC'),
	(310378, 142, '2015-01-15 00:07:14.000000', 'temperatura', 525.0000, 'ºC'),
	(310379, 142, '2015-01-15 00:07:15.000000', 'temperatura', 501.0000, 'ºC'),
	(310380, 142, '2015-01-15 00:07:16.000000', 'temperatura', 930.0000, 'ºC'),
	(310381, 142, '2015-01-15 00:07:17.000000', 'temperatura', 746.0000, 'ºC'),
	(310382, 142, '2015-01-15 00:07:18.000000', 'temperatura', 941.0000, 'ºC'),
	(310383, 142, '2015-01-15 00:07:19.000000', 'temperatura', 67.0000, 'ºC'),
	(310384, 142, '2015-01-15 00:07:20.000000', 'temperatura', 1113.0000, 'ºC'),
	(310385, 142, '2015-01-15 00:07:21.000000', 'temperatura', 567.0000, 'ºC'),
	(310386, 142, '2015-01-15 00:07:22.000000', 'temperatura', 694.0000, 'ºC'),
	(310387, 142, '2015-01-15 00:07:23.000000', 'temperatura', 569.0000, 'ºC'),
	(310388, 142, '2015-01-15 00:07:24.000000', 'temperatura', 763.0000, 'ºC'),
	(310389, 142, '2015-01-15 00:07:25.000000', 'temperatura', 909.0000, 'ºC'),
	(310390, 142, '2015-01-15 00:07:26.000000', 'temperatura', 1058.0000, 'ºC'),
	(310391, 142, '2015-01-15 00:07:27.000000', 'temperatura', 165.0000, 'ºC'),
	(310392, 142, '2015-01-15 00:07:28.000000', 'temperatura', 48.0000, 'ºC'),
	(310393, 142, '2015-01-15 00:07:29.000000', 'temperatura', 946.0000, 'ºC'),
	(310394, 142, '2015-01-15 00:07:30.000000', 'temperatura', 985.0000, 'ºC'),
	(310395, 142, '2015-01-15 00:07:31.000000', 'temperatura', 890.0000, 'ºC'),
	(310396, 142, '2015-01-15 00:07:32.000000', 'temperatura', 295.0000, 'ºC'),
	(310397, 142, '2015-01-15 00:07:33.000000', 'temperatura', 6.0000, 'ºC'),
	(310398, 142, '2015-01-15 00:07:34.000000', 'temperatura', 344.0000, 'ºC'),
	(310399, 142, '2015-01-15 00:07:35.000000', 'temperatura', 503.0000, 'ºC'),
	(310400, 142, '2015-01-15 00:07:36.000000', 'temperatura', 285.0000, 'ºC'),
	(310401, 142, '2015-01-15 00:07:37.000000', 'temperatura', 1114.0000, 'ºC'),
	(310402, 142, '2015-01-15 00:07:38.000000', 'temperatura', 1116.0000, 'ºC'),
	(310403, 142, '2015-01-15 00:07:39.000000', 'temperatura', 1039.0000, 'ºC'),
	(310404, 142, '2015-01-15 00:07:40.000000', 'temperatura', 648.0000, 'ºC'),
	(310405, 142, '2015-01-15 00:07:41.000000', 'temperatura', 121.0000, 'ºC'),
	(310406, 142, '2015-01-15 00:07:42.000000', 'temperatura', 1064.0000, 'ºC'),
	(310407, 142, '2015-01-15 00:07:43.000000', 'temperatura', 158.0000, 'ºC'),
	(310408, 142, '2015-01-15 00:07:44.000000', 'temperatura', 1198.0000, 'ºC'),
	(310409, 142, '2015-01-15 00:07:45.000000', 'temperatura', 717.0000, 'ºC'),
	(310410, 142, '2015-01-15 00:07:46.000000', 'temperatura', 1191.0000, 'ºC'),
	(310411, 142, '2015-01-15 00:07:47.000000', 'temperatura', 204.0000, 'ºC'),
	(310412, 142, '2015-01-15 00:07:48.000000', 'temperatura', 1048.0000, 'ºC'),
	(310413, 142, '2015-01-15 00:07:49.000000', 'temperatura', 1029.0000, 'ºC'),
	(310414, 142, '2015-01-15 00:07:50.000000', 'temperatura', 802.0000, 'ºC'),
	(310415, 142, '2015-01-15 00:07:51.000000', 'temperatura', 921.0000, 'ºC'),
	(310416, 142, '2015-01-15 00:07:52.000000', 'temperatura', 1002.0000, 'ºC'),
	(310417, 142, '2015-01-15 00:07:53.000000', 'temperatura', 1047.0000, 'ºC'),
	(310418, 142, '2015-01-15 00:07:54.000000', 'temperatura', 1028.0000, 'ºC'),
	(310419, 142, '2015-01-15 00:07:55.000000', 'temperatura', 799.0000, 'ºC'),
	(310420, 142, '2015-01-15 00:07:56.000000', 'temperatura', 913.0000, 'ºC'),
	(310421, 142, '2015-01-15 00:07:57.000000', 'temperatura', 969.0000, 'ºC'),
	(310422, 142, '2015-01-15 00:07:58.000000', 'temperatura', 904.0000, 'ºC'),
	(310423, 142, '2015-01-15 00:07:59.000000', 'temperatura', 416.0000, 'ºC'),
	(310424, 142, '2015-01-15 00:08:00.000000', 'temperatura', 569.0000, 'ºC'),
	(310425, 142, '2015-01-15 00:08:01.000000', 'temperatura', 398.0000, 'ºC'),
	(310426, 142, '2015-01-15 00:08:02.000000', 'temperatura', 282.0000, 'ºC'),
	(310427, 142, '2015-01-15 00:08:03.000000', 'temperatura', 217.0000, 'ºC'),
	(310428, 142, '2015-01-15 00:08:04.000000', 'temperatura', 241.0000, 'ºC'),
	(310429, 142, '2015-01-15 00:08:05.000000', 'temperatura', 555.0000, 'ºC'),
	(310430, 142, '2015-01-15 00:08:06.000000', 'temperatura', 852.0000, 'ºC'),
	(310431, 142, '2015-01-15 00:08:07.000000', 'temperatura', 196.0000, 'ºC'),
	(310432, 142, '2015-01-15 00:08:08.000000', 'temperatura', 824.0000, 'ºC'),
	(310433, 142, '2015-01-15 00:08:09.000000', 'temperatura', 1131.0000, 'ºC'),
	(310434, 142, '2015-01-15 00:08:10.000000', 'temperatura', 784.0000, 'ºC'),
	(310435, 142, '2015-01-15 00:08:11.000000', 'temperatura', 528.0000, 'ºC'),
	(310436, 142, '2015-01-15 00:08:12.000000', 'temperatura', 289.0000, 'ºC'),
	(310437, 142, '2015-01-15 00:08:13.000000', 'temperatura', 1060.0000, 'ºC'),
	(310438, 142, '2015-01-15 00:08:14.000000', 'temperatura', 833.0000, 'ºC'),
	(310439, 142, '2015-01-15 00:08:15.000000', 'temperatura', 984.0000, 'ºC'),
	(310440, 142, '2015-01-15 00:08:16.000000', 'temperatura', 25.0000, 'ºC'),
	(310441, 142, '2015-01-15 00:08:17.000000', 'temperatura', 773.0000, 'ºC'),
	(310442, 142, '2015-01-15 00:08:18.000000', 'temperatura', 191.0000, 'ºC'),
	(310443, 142, '2015-01-15 00:08:19.000000', 'temperatura', 1036.0000, 'ºC'),
	(310444, 142, '2015-01-15 00:08:20.000000', 'temperatura', 1005.0000, 'ºC'),
	(310445, 142, '2015-01-15 00:08:21.000000', 'temperatura', 721.0000, 'ºC'),
	(310446, 142, '2015-01-15 00:08:22.000000', 'temperatura', 590.0000, 'ºC'),
	(310447, 142, '2015-01-15 00:08:23.000000', 'temperatura', 786.0000, 'ºC'),
	(310448, 142, '2015-01-15 00:08:24.000000', 'temperatura', 960.0000, 'ºC'),
	(310449, 142, '2015-01-15 00:08:25.000000', 'temperatura', 44.0000, 'ºC'),
	(310450, 142, '2015-01-15 00:08:26.000000', 'temperatura', 941.0000, 'ºC'),
	(310451, 142, '2015-01-15 00:08:27.000000', 'temperatura', 971.0000, 'ºC'),
	(310452, 142, '2015-01-15 00:08:28.000000', 'temperatura', 835.0000, 'ºC'),
	(310453, 142, '2015-01-15 00:08:29.000000', 'temperatura', 62.0000, 'ºC'),
	(310454, 142, '2015-01-15 00:08:30.000000', 'temperatura', 207.0000, 'ºC'),
	(310455, 142, '2015-01-15 00:08:31.000000', 'temperatura', 849.0000, 'ºC'),
	(310456, 142, '2015-01-15 00:08:32.000000', 'temperatura', 24.0000, 'ºC'),
	(310457, 142, '2015-01-15 00:08:33.000000', 'temperatura', 1172.0000, 'ºC'),
	(310458, 142, '2015-01-15 00:08:34.000000', 'temperatura', 991.0000, 'ºC'),
	(310459, 142, '2015-01-15 00:08:35.000000', 'temperatura', 238.0000, 'ºC'),
	(310460, 142, '2015-01-15 00:08:36.000000', 'temperatura', 617.0000, 'ºC'),
	(310461, 142, '2015-01-15 00:08:37.000000', 'temperatura', 1173.0000, 'ºC'),
	(310462, 142, '2015-01-15 00:08:38.000000', 'temperatura', 413.0000, 'ºC'),
	(310463, 142, '2015-01-15 00:08:39.000000', 'temperatura', 948.0000, 'ºC'),
	(310464, 142, '2015-01-15 00:08:40.000000', 'temperatura', 1102.0000, 'ºC'),
	(310465, 142, '2015-01-15 00:08:41.000000', 'temperatura', 267.0000, 'ºC'),
	(310466, 142, '2015-01-15 00:08:42.000000', 'temperatura', 431.0000, 'ºC'),
	(310467, 142, '2015-01-15 00:08:43.000000', 'temperatura', 152.0000, 'ºC'),
	(310468, 142, '2015-01-15 00:08:44.000000', 'temperatura', 666.0000, 'ºC'),
	(310469, 142, '2015-01-15 00:08:45.000000', 'temperatura', 478.0000, 'ºC'),
	(310470, 142, '2015-01-15 00:08:46.000000', 'temperatura', 391.0000, 'ºC'),
	(310471, 142, '2015-01-15 00:08:47.000000', 'temperatura', 520.0000, 'ºC'),
	(310472, 142, '2015-01-15 00:08:48.000000', 'temperatura', 227.0000, 'ºC'),
	(310473, 142, '2015-01-15 00:08:49.000000', 'temperatura', 778.0000, 'ºC'),
	(310474, 142, '2015-01-15 00:08:50.000000', 'temperatura', 809.0000, 'ºC'),
	(310475, 142, '2015-01-15 00:08:51.000000', 'temperatura', 512.0000, 'ºC'),
	(310476, 142, '2015-01-15 00:08:52.000000', 'temperatura', 134.0000, 'ºC'),
	(310477, 142, '2015-01-15 00:08:53.000000', 'temperatura', 333.0000, 'ºC'),
	(310478, 142, '2015-01-15 00:08:54.000000', 'temperatura', 63.0000, 'ºC'),
	(310479, 142, '2015-01-15 00:08:55.000000', 'temperatura', 518.0000, 'ºC'),
	(310480, 142, '2015-01-15 00:08:56.000000', 'temperatura', 1199.0000, 'ºC'),
	(310481, 142, '2015-01-15 00:08:57.000000', 'temperatura', 843.0000, 'ºC'),
	(310482, 142, '2015-01-15 00:08:58.000000', 'temperatura', 618.0000, 'ºC'),
	(310483, 142, '2015-01-15 00:08:59.000000', 'temperatura', 562.0000, 'ºC'),
	(310484, 142, '2015-01-15 00:09:00.000000', 'temperatura', 958.0000, 'ºC'),
	(310485, 142, '2015-01-15 00:09:01.000000', 'temperatura', 704.0000, 'ºC'),
	(310486, 142, '2015-01-15 00:09:02.000000', 'temperatura', 645.0000, 'ºC'),
	(310487, 142, '2015-01-15 00:09:03.000000', 'temperatura', 1115.0000, 'ºC'),
	(310488, 142, '2015-01-15 00:09:04.000000', 'temperatura', 39.0000, 'ºC'),
	(310489, 142, '2015-01-15 00:09:05.000000', 'temperatura', 452.0000, 'ºC'),
	(310490, 142, '2015-01-15 00:09:06.000000', 'temperatura', 943.0000, 'ºC'),
	(310491, 142, '2015-01-15 00:09:07.000000', 'temperatura', 958.0000, 'ºC'),
	(310492, 142, '2015-01-15 00:09:08.000000', 'temperatura', 761.0000, 'ºC'),
	(310493, 142, '2015-01-15 00:09:09.000000', 'temperatura', 932.0000, 'ºC'),
	(310494, 142, '2015-01-15 00:09:10.000000', 'temperatura', 1178.0000, 'ºC'),
	(310495, 142, '2015-01-15 00:09:11.000000', 'temperatura', 696.0000, 'ºC'),
	(310496, 142, '2015-01-15 00:09:12.000000', 'temperatura', 1147.0000, 'ºC'),
	(310497, 142, '2015-01-15 00:09:13.000000', 'temperatura', 47.0000, 'ºC'),
	(310498, 142, '2015-01-15 00:09:14.000000', 'temperatura', 392.0000, 'ºC'),
	(310499, 142, '2015-01-15 00:09:15.000000', 'temperatura', 623.0000, 'ºC'),
	(310500, 142, '2015-01-15 00:09:16.000000', 'temperatura', 738.0000, 'ºC'),
	(310501, 142, '2015-01-15 00:09:17.000000', 'temperatura', 622.0000, 'ºC'),
	(310502, 142, '2015-01-15 00:09:18.000000', 'temperatura', 894.0000, 'ºC'),
	(310503, 142, '2015-01-15 00:09:19.000000', 'temperatura', 207.0000, 'ºC'),
	(310504, 142, '2015-01-15 00:09:20.000000', 'temperatura', 754.0000, 'ºC'),
	(310505, 142, '2015-01-15 00:09:21.000000', 'temperatura', 748.0000, 'ºC'),
	(310506, 142, '2015-01-15 00:09:22.000000', 'temperatura', 279.0000, 'ºC'),
	(310507, 142, '2015-01-15 00:09:23.000000', 'temperatura', 352.0000, 'ºC'),
	(310508, 142, '2015-01-15 00:09:24.000000', 'temperatura', 922.0000, 'ºC'),
	(310509, 142, '2015-01-15 00:09:25.000000', 'temperatura', 1156.0000, 'ºC'),
	(310510, 142, '2015-01-15 00:09:26.000000', 'temperatura', 615.0000, 'ºC'),
	(310511, 142, '2015-01-15 00:09:27.000000', 'temperatura', 809.0000, 'ºC'),
	(310512, 142, '2015-01-15 00:09:28.000000', 'temperatura', 998.0000, 'ºC'),
	(310513, 142, '2015-01-15 00:09:29.000000', 'temperatura', 166.0000, 'ºC'),
	(310514, 142, '2015-01-15 00:09:30.000000', 'temperatura', 234.0000, 'ºC'),
	(310515, 142, '2015-01-15 00:09:31.000000', 'temperatura', 673.0000, 'ºC'),
	(310516, 142, '2015-01-15 00:09:32.000000', 'temperatura', 264.0000, 'ºC'),
	(310517, 142, '2015-01-15 00:09:33.000000', 'temperatura', 503.0000, 'ºC'),
	(310518, 142, '2015-01-15 00:09:34.000000', 'temperatura', 522.0000, 'ºC'),
	(310519, 142, '2015-01-15 00:09:35.000000', 'temperatura', 1102.0000, 'ºC'),
	(310520, 142, '2015-01-15 00:09:36.000000', 'temperatura', 343.0000, 'ºC'),
	(310521, 142, '2015-01-15 00:09:37.000000', 'temperatura', 809.0000, 'ºC'),
	(310522, 142, '2015-01-15 00:09:38.000000', 'temperatura', 620.0000, 'ºC'),
	(310523, 142, '2015-01-15 00:09:39.000000', 'temperatura', 670.0000, 'ºC'),
	(310524, 142, '2015-01-15 00:09:40.000000', 'temperatura', 291.0000, 'ºC'),
	(310525, 142, '2015-01-15 00:09:41.000000', 'temperatura', 646.0000, 'ºC'),
	(310526, 142, '2015-01-15 00:09:42.000000', 'temperatura', 1158.0000, 'ºC'),
	(310527, 142, '2015-01-15 00:09:43.000000', 'temperatura', 252.0000, 'ºC'),
	(310528, 142, '2015-01-15 00:09:44.000000', 'temperatura', 189.0000, 'ºC'),
	(310529, 142, '2015-01-15 00:09:45.000000', 'temperatura', 186.0000, 'ºC'),
	(310530, 142, '2015-01-15 00:09:46.000000', 'temperatura', 366.0000, 'ºC'),
	(310531, 142, '2015-01-15 00:09:47.000000', 'temperatura', 71.0000, 'ºC'),
	(310532, 142, '2015-01-15 00:09:48.000000', 'temperatura', 459.0000, 'ºC'),
	(310533, 142, '2015-01-15 00:09:49.000000', 'temperatura', 881.0000, 'ºC'),
	(310534, 142, '2015-01-15 00:09:50.000000', 'temperatura', 631.0000, 'ºC'),
	(310535, 142, '2015-01-15 00:09:51.000000', 'temperatura', 510.0000, 'ºC'),
	(310536, 142, '2015-01-15 00:09:52.000000', 'temperatura', 658.0000, 'ºC'),
	(310537, 142, '2015-01-15 00:09:53.000000', 'temperatura', 562.0000, 'ºC'),
	(310538, 142, '2015-01-15 00:09:54.000000', 'temperatura', 835.0000, 'ºC'),
	(310539, 142, '2015-01-15 00:09:55.000000', 'temperatura', 88.0000, 'ºC'),
	(310540, 142, '2015-01-15 00:09:56.000000', 'temperatura', 337.0000, 'ºC'),
	(310541, 142, '2015-01-15 00:09:57.000000', 'temperatura', 221.0000, 'ºC'),
	(310542, 142, '2015-01-15 00:09:58.000000', 'temperatura', 95.0000, 'ºC'),
	(310543, 142, '2015-01-15 00:09:59.000000', 'temperatura', 1014.0000, 'ºC'),
	(310544, 142, '2015-01-15 00:10:00.000000', 'temperatura', 1186.0000, 'ºC'),
	(310545, 142, '2015-01-15 00:10:01.000000', 'temperatura', 486.0000, 'ºC'),
	(310546, 142, '2015-01-15 00:10:02.000000', 'temperatura', 76.0000, 'ºC'),
	(310547, 142, '2015-01-15 00:10:03.000000', 'temperatura', 119.0000, 'ºC'),
	(310548, 142, '2015-01-15 00:10:04.000000', 'temperatura', 368.0000, 'ºC'),
	(310549, 142, '2015-01-15 00:10:05.000000', 'temperatura', 285.0000, 'ºC'),
	(310550, 142, '2015-01-15 00:10:06.000000', 'temperatura', 320.0000, 'ºC'),
	(310551, 142, '2015-01-15 00:10:07.000000', 'temperatura', 747.0000, 'ºC'),
	(310552, 142, '2015-01-15 00:10:08.000000', 'temperatura', 375.0000, 'ºC'),
	(310553, 142, '2015-01-15 00:10:09.000000', 'temperatura', 833.0000, 'ºC'),
	(310554, 142, '2015-01-15 00:10:10.000000', 'temperatura', 641.0000, 'ºC'),
	(310555, 142, '2015-01-15 00:10:11.000000', 'temperatura', 705.0000, 'ºC'),
	(310556, 142, '2015-01-15 00:10:12.000000', 'temperatura', 403.0000, 'ºC'),
	(310557, 142, '2015-01-15 00:10:13.000000', 'temperatura', 1101.0000, 'ºC'),
	(310558, 142, '2015-01-15 00:10:14.000000', 'temperatura', 695.0000, 'ºC'),
	(310559, 142, '2015-01-15 00:10:15.000000', 'temperatura', 173.0000, 'ºC'),
	(310560, 142, '2015-01-15 00:10:16.000000', 'temperatura', 1181.0000, 'ºC'),
	(310561, 142, '2015-01-15 00:10:17.000000', 'temperatura', 587.0000, 'ºC'),
	(310562, 142, '2015-01-15 00:10:18.000000', 'temperatura', 592.0000, 'ºC'),
	(310563, 142, '2015-01-15 00:10:19.000000', 'temperatura', 1.0000, 'ºC'),
	(310564, 142, '2015-01-15 00:10:20.000000', 'temperatura', 629.0000, 'ºC'),
	(310565, 142, '2015-01-15 00:10:21.000000', 'temperatura', 741.0000, 'ºC'),
	(310566, 142, '2015-01-15 00:10:22.000000', 'temperatura', 617.0000, 'ºC'),
	(310567, 142, '2015-01-15 00:10:23.000000', 'temperatura', 866.0000, 'ºC'),
	(310568, 142, '2015-01-15 00:10:24.000000', 'temperatura', 77.0000, 'ºC'),
	(310569, 142, '2015-01-15 00:10:25.000000', 'temperatura', 186.0000, 'ºC'),
	(310570, 142, '2015-01-15 00:10:26.000000', 'temperatura', 702.0000, 'ºC'),
	(310571, 142, '2015-01-15 00:10:27.000000', 'temperatura', 553.0000, 'ºC'),
	(310572, 142, '2015-01-15 00:10:28.000000', 'temperatura', 661.0000, 'ºC'),
	(310573, 142, '2015-01-15 00:10:29.000000', 'temperatura', 443.0000, 'ºC'),
	(310574, 142, '2015-01-15 00:10:30.000000', 'temperatura', 235.0000, 'ºC'),
	(310575, 142, '2015-01-15 00:10:31.000000', 'temperatura', 1044.0000, 'ºC'),
	(310576, 142, '2015-01-15 00:10:32.000000', 'temperatura', 918.0000, 'ºC'),
	(310577, 142, '2015-01-15 00:10:33.000000', 'temperatura', 257.0000, 'ºC'),
	(310578, 142, '2015-01-15 00:10:34.000000', 'temperatura', 933.0000, 'ºC'),
	(310579, 142, '2015-01-15 00:10:35.000000', 'temperatura', 293.0000, 'ºC'),
	(310580, 142, '2015-01-15 00:10:36.000000', 'temperatura', 1066.0000, 'ºC'),
	(310581, 142, '2015-01-15 00:10:37.000000', 'temperatura', 853.0000, 'ºC'),
	(310582, 142, '2015-01-15 00:10:38.000000', 'temperatura', 1067.0000, 'ºC'),
	(310583, 142, '2015-01-15 00:10:39.000000', 'temperatura', 375.0000, 'ºC'),
	(310584, 142, '2015-01-15 00:10:40.000000', 'temperatura', 1075.0000, 'ºC'),
	(310585, 142, '2015-01-15 00:10:41.000000', 'temperatura', 652.0000, 'ºC'),
	(310586, 142, '2015-01-15 00:10:42.000000', 'temperatura', 36.0000, 'ºC'),
	(310587, 142, '2015-01-15 00:10:43.000000', 'temperatura', 623.0000, 'ºC'),
	(310588, 142, '2015-01-15 00:10:44.000000', 'temperatura', 607.0000, 'ºC'),
	(310589, 142, '2015-01-15 00:10:45.000000', 'temperatura', 1165.0000, 'ºC'),
	(310590, 142, '2015-01-15 00:10:46.000000', 'temperatura', 407.0000, 'ºC'),
	(310591, 142, '2015-01-15 00:10:47.000000', 'temperatura', 939.0000, 'ºC'),
	(310592, 142, '2015-01-15 00:10:48.000000', 'temperatura', 1074.0000, 'ºC'),
	(310593, 142, '2015-01-15 00:10:49.000000', 'temperatura', 154.0000, 'ºC'),
	(310594, 142, '2015-01-15 00:10:50.000000', 'temperatura', 1148.0000, 'ºC'),
	(310595, 142, '2015-01-15 00:10:51.000000', 'temperatura', 478.0000, 'ºC'),
	(310596, 142, '2015-01-15 00:10:52.000000', 'temperatura', 147.0000, 'ºC'),
	(310597, 142, '2015-01-15 00:10:53.000000', 'temperatura', 502.0000, 'ºC'),
	(310598, 142, '2015-01-15 00:10:54.000000', 'temperatura', 871.0000, 'ºC'),
	(310599, 142, '2015-01-15 00:10:55.000000', 'temperatura', 449.0000, 'ºC'),
	(310600, 142, '2015-01-15 00:10:56.000000', 'temperatura', 831.0000, 'ºC'),
	(310601, 142, '2015-01-15 00:10:57.000000', 'temperatura', 409.0000, 'ºC'),
	(310602, 142, '2015-01-15 00:10:58.000000', 'temperatura', 751.0000, 'ºC'),
	(310603, 142, '2015-01-15 00:10:59.000000', 'temperatura', 131.0000, 'ºC'),
	(310604, 142, '2015-01-15 00:11:00.000000', 'temperatura', 801.0000, 'ºC'),
	(310605, 142, '2015-01-15 00:11:01.000000', 'temperatura', 12.0000, 'ºC'),
	(310606, 142, '2015-01-15 00:11:02.000000', 'temperatura', 57.0000, 'ºC'),
	(310607, 142, '2015-01-15 00:11:03.000000', 'temperatura', 252.0000, 'ºC'),
	(310608, 142, '2015-01-15 00:11:04.000000', 'temperatura', 1088.0000, 'ºC'),
	(310609, 142, '2015-01-15 00:11:05.000000', 'temperatura', 1085.0000, 'ºC'),
	(310610, 142, '2015-01-15 00:11:06.000000', 'temperatura', 959.0000, 'ºC'),
	(310611, 142, '2015-01-15 00:11:07.000000', 'temperatura', 343.0000, 'ºC'),
	(310612, 142, '2015-01-15 00:11:08.000000', 'temperatura', 39.0000, 'ºC'),
	(310613, 142, '2015-01-15 00:11:09.000000', 'temperatura', 364.0000, 'ºC'),
	(310614, 142, '2015-01-15 00:11:10.000000', 'temperatura', 506.0000, 'ºC'),
	(310615, 142, '2015-01-15 00:11:11.000000', 'temperatura', 238.0000, 'ºC'),
	(310616, 142, '2015-01-15 00:11:12.000000', 'temperatura', 873.0000, 'ºC'),
	(310617, 142, '2015-01-15 00:11:13.000000', 'temperatura', 53.0000, 'ºC'),
	(310618, 142, '2015-01-15 00:11:14.000000', 'temperatura', 45.0000, 'ºC'),
	(310619, 142, '2015-01-15 00:11:15.000000', 'temperatura', 64.0000, 'ºC'),
	(310620, 142, '2015-01-15 00:11:16.000000', 'temperatura', 189.0000, 'ºC'),
	(310621, 142, '2015-01-15 00:11:17.000000', 'temperatura', 753.0000, 'ºC'),
	(310622, 142, '2015-01-15 00:11:18.000000', 'temperatura', 799.0000, 'ºC'),
	(310623, 142, '2015-01-15 00:11:19.000000', 'temperatura', 535.0000, 'ºC'),
	(310624, 142, '2015-01-15 00:11:20.000000', 'temperatura', 279.0000, 'ºC'),
	(310625, 142, '2015-01-15 00:11:21.000000', 'temperatura', 991.0000, 'ºC'),
	(310626, 142, '2015-01-15 00:11:22.000000', 'temperatura', 518.0000, 'ºC'),
	(310627, 142, '2015-01-15 00:11:23.000000', 'temperatura', 817.0000, 'ºC'),
	(310628, 142, '2015-01-15 00:11:24.000000', 'temperatura', 134.0000, 'ºC'),
	(310629, 142, '2015-01-15 00:11:25.000000', 'temperatura', 617.0000, 'ºC'),
	(310630, 142, '2015-01-15 00:11:26.000000', 'temperatura', 286.0000, 'ºC'),
	(310631, 142, '2015-01-15 00:11:27.000000', 'temperatura', 777.0000, 'ºC'),
	(310632, 142, '2015-01-15 00:11:28.000000', 'temperatura', 627.0000, 'ºC'),
	(310633, 142, '2015-01-15 00:11:29.000000', 'temperatura', 806.0000, 'ºC'),
	(310634, 142, '2015-01-15 00:11:30.000000', 'temperatura', 950.0000, 'ºC'),
	(310635, 142, '2015-01-15 00:11:31.000000', 'temperatura', 1130.0000, 'ºC'),
	(310636, 142, '2015-01-15 00:11:32.000000', 'temperatura', 404.0000, 'ºC'),
	(310637, 142, '2015-01-15 00:11:33.000000', 'temperatura', 1028.0000, 'ºC'),
	(310638, 142, '2015-01-15 00:11:34.000000', 'temperatura', 331.0000, 'ºC'),
	(310639, 142, '2015-01-15 00:11:35.000000', 'temperatura', 970.0000, 'ºC'),
	(310640, 142, '2015-01-15 00:11:36.000000', 'temperatura', 257.0000, 'ºC'),
	(310641, 142, '2015-01-15 00:11:37.000000', 'temperatura', 778.0000, 'ºC'),
	(310642, 142, '2015-01-15 00:11:38.000000', 'temperatura', 718.0000, 'ºC'),
	(310643, 142, '2015-01-15 00:11:39.000000', 'temperatura', 56.0000, 'ºC'),
	(310644, 142, '2015-01-15 00:11:40.000000', 'temperatura', 526.0000, 'ºC'),
	(310645, 142, '2015-01-15 00:11:41.000000', 'temperatura', 63.0000, 'ºC'),
	(310646, 142, '2015-01-15 00:11:42.000000', 'temperatura', 1137.0000, 'ºC'),
	(310647, 142, '2015-01-15 00:11:43.000000', 'temperatura', 696.0000, 'ºC'),
	(310648, 142, '2015-01-15 00:11:44.000000', 'temperatura', 72.0000, 'ºC'),
	(310649, 142, '2015-01-15 00:11:45.000000', 'temperatura', 672.0000, 'ºC'),
	(310650, 142, '2015-01-15 00:11:46.000000', 'temperatura', 742.0000, 'ºC'),
	(310651, 142, '2015-01-15 00:11:47.000000', 'temperatura', 497.0000, 'ºC'),
	(310652, 142, '2015-01-15 00:11:48.000000', 'temperatura', 258.0000, 'ºC'),
	(310653, 142, '2015-01-15 00:11:49.000000', 'temperatura', 1000.0000, 'ºC'),
	(310654, 142, '2015-01-15 00:11:50.000000', 'temperatura', 628.0000, 'ºC'),
	(310655, 142, '2015-01-15 00:11:51.000000', 'temperatura', 140.0000, 'ºC'),
	(310656, 142, '2015-01-15 00:11:52.000000', 'temperatura', 17.0000, 'ºC'),
	(310657, 142, '2015-01-15 00:11:53.000000', 'temperatura', 867.0000, 'ºC'),
	(310658, 142, '2015-01-15 00:11:54.000000', 'temperatura', 682.0000, 'ºC'),
	(310659, 142, '2015-01-15 00:11:55.000000', 'temperatura', 810.0000, 'ºC'),
	(310660, 142, '2015-01-15 00:11:56.000000', 'temperatura', 803.0000, 'ºC'),
	(310661, 142, '2015-01-15 00:11:57.000000', 'temperatura', 388.0000, 'ºC'),
	(310662, 142, '2015-01-15 00:11:58.000000', 'temperatura', 729.0000, 'ºC'),
	(310663, 142, '2015-01-15 00:11:59.000000', 'temperatura', 81.0000, 'ºC'),
	(310664, 142, '2015-01-15 00:12:00.000000', 'temperatura', 622.0000, 'ºC'),
	(310665, 142, '2015-01-15 00:12:01.000000', 'temperatura', 464.0000, 'ºC'),
	(310666, 142, '2015-01-15 00:12:02.000000', 'temperatura', 458.0000, 'ºC'),
	(310667, 142, '2015-01-15 00:12:03.000000', 'temperatura', 895.0000, 'ºC'),
	(310668, 142, '2015-01-15 00:12:04.000000', 'temperatura', 702.0000, 'ºC'),
	(310669, 142, '2015-01-15 00:12:05.000000', 'temperatura', 827.0000, 'ºC'),
	(310670, 142, '2015-01-15 00:12:06.000000', 'temperatura', 828.0000, 'ºC'),
	(310671, 142, '2015-01-15 00:12:07.000000', 'temperatura', 461.0000, 'ºC'),
	(310672, 142, '2015-01-15 00:12:08.000000', 'temperatura', 1020.0000, 'ºC'),
	(310673, 142, '2015-01-15 00:12:09.000000', 'temperatura', 120.0000, 'ºC'),
	(310674, 142, '2015-01-15 00:12:10.000000', 'temperatura', 1139.0000, 'ºC'),
	(310675, 142, '2015-01-15 00:12:11.000000', 'temperatura', 538.0000, 'ºC'),
	(310676, 142, '2015-01-15 00:12:12.000000', 'temperatura', 470.0000, 'ºC'),
	(310677, 142, '2015-01-15 00:12:13.000000', 'temperatura', 738.0000, 'ºC'),
	(310678, 142, '2015-01-15 00:12:14.000000', 'temperatura', 1081.0000, 'ºC'),
	(310679, 142, '2015-01-15 00:12:15.000000', 'temperatura', 792.0000, 'ºC'),
	(310680, 142, '2015-01-15 00:12:16.000000', 'temperatura', 716.0000, 'ºC'),
	(310681, 142, '2015-01-15 00:12:17.000000', 'temperatura', 6.0000, 'ºC'),
	(310682, 142, '2015-01-15 00:12:18.000000', 'temperatura', 283.0000, 'ºC'),
	(310683, 142, '2015-01-15 00:12:19.000000', 'temperatura', 197.0000, 'ºC'),
	(310684, 142, '2015-01-15 00:12:20.000000', 'temperatura', 134.0000, 'ºC'),
	(310685, 142, '2015-01-15 00:12:21.000000', 'temperatura', 83.0000, 'ºC'),
	(310686, 142, '2015-01-15 00:12:22.000000', 'temperatura', 12.0000, 'ºC'),
	(310687, 142, '2015-01-15 00:12:23.000000', 'temperatura', 1010.0000, 'ºC'),
	(310688, 142, '2015-01-15 00:12:24.000000', 'temperatura', 215.0000, 'ºC'),
	(310689, 142, '2015-01-15 00:12:25.000000', 'temperatura', 444.0000, 'ºC'),
	(310690, 142, '2015-01-15 00:12:26.000000', 'temperatura', 376.0000, 'ºC'),
	(310691, 142, '2015-01-15 00:12:27.000000', 'temperatura', 550.0000, 'ºC'),
	(310692, 142, '2015-01-15 00:12:28.000000', 'temperatura', 424.0000, 'ºC'),
	(310693, 142, '2015-01-15 00:12:29.000000', 'temperatura', 469.0000, 'ºC'),
	(310694, 142, '2015-01-15 00:12:30.000000', 'temperatura', 1073.0000, 'ºC'),
	(310695, 142, '2015-01-15 00:12:31.000000', 'temperatura', 360.0000, 'ºC'),
	(310696, 142, '2015-01-15 00:12:32.000000', 'temperatura', 981.0000, 'ºC'),
	(310697, 142, '2015-01-15 00:12:33.000000', 'temperatura', 225.0000, 'ºC'),
	(310698, 142, '2015-01-15 00:12:34.000000', 'temperatura', 582.0000, 'ºC'),
	(310699, 142, '2015-01-15 00:12:35.000000', 'temperatura', 1036.0000, 'ºC'),
	(310700, 142, '2015-01-15 00:12:36.000000', 'temperatura', 1036.0000, 'ºC'),
	(310701, 142, '2015-01-15 00:12:37.000000', 'temperatura', 870.0000, 'ºC'),
	(310702, 142, '2015-01-15 00:12:38.000000', 'temperatura', 42.0000, 'ºC'),
	(310703, 142, '2015-01-15 00:12:39.000000', 'temperatura', 0.0000, 'ºC'),
	(310704, 142, '2015-01-15 00:12:40.000000', 'temperatura', 1077.0000, 'ºC'),
	(310705, 142, '2015-01-15 00:12:41.000000', 'temperatura', 584.0000, 'ºC'),
	(310706, 142, '2015-01-15 00:12:42.000000', 'temperatura', 890.0000, 'ºC'),
	(310707, 142, '2015-01-15 00:12:43.000000', 'temperatura', 298.0000, 'ºC'),
	(310708, 142, '2015-01-15 00:12:44.000000', 'temperatura', 20.0000, 'ºC'),
	(310709, 142, '2015-01-15 00:12:45.000000', 'temperatura', 408.0000, 'ºC'),
	(310710, 142, '2015-01-15 00:12:46.000000', 'temperatura', 780.0000, 'ºC'),
	(310711, 142, '2015-01-15 00:12:47.000000', 'temperatura', 277.0000, 'ºC'),
	(310712, 142, '2015-01-15 00:12:48.000000', 'temperatura', 244.0000, 'ºC'),
	(310713, 142, '2015-01-15 00:12:49.000000', 'temperatura', 389.0000, 'ºC'),
	(310714, 142, '2015-01-15 00:12:50.000000', 'temperatura', 14.0000, 'ºC'),
	(310715, 142, '2015-01-15 00:12:51.000000', 'temperatura', 103.0000, 'ºC'),
	(310716, 142, '2015-01-15 00:12:52.000000', 'temperatura', 474.0000, 'ºC'),
	(310717, 142, '2015-01-15 00:12:53.000000', 'temperatura', 860.0000, 'ºC'),
	(310718, 142, '2015-01-15 00:12:54.000000', 'temperatura', 479.0000, 'ºC'),
	(310719, 142, '2015-01-15 00:12:55.000000', 'temperatura', 1016.0000, 'ºC'),
	(310720, 142, '2015-01-15 00:12:56.000000', 'temperatura', 42.0000, 'ºC'),
	(310721, 142, '2015-01-15 00:12:57.000000', 'temperatura', 762.0000, 'ºC'),
	(310722, 142, '2015-01-15 00:12:58.000000', 'temperatura', 86.0000, 'ºC'),
	(310723, 142, '2015-01-15 00:12:59.000000', 'temperatura', 545.0000, 'ºC'),
	(310724, 142, '2015-01-15 00:13:00.000000', 'temperatura', 65.0000, 'ºC'),
	(310725, 142, '2015-01-15 00:13:01.000000', 'temperatura', 1092.0000, 'ºC'),
	(310726, 142, '2015-01-15 00:13:02.000000', 'temperatura', 466.0000, 'ºC'),
	(310727, 142, '2015-01-15 00:13:03.000000', 'temperatura', 256.0000, 'ºC'),
	(310728, 142, '2015-01-15 00:13:04.000000', 'temperatura', 1079.0000, 'ºC'),
	(310729, 142, '2015-01-15 00:13:05.000000', 'temperatura', 1030.0000, 'ºC'),
	(310730, 142, '2015-01-15 00:13:06.000000', 'temperatura', 715.0000, 'ºC'),
	(310731, 142, '2015-01-15 00:13:07.000000', 'temperatura', 482.0000, 'ºC'),
	(310732, 142, '2015-01-15 00:13:08.000000', 'temperatura', 269.0000, 'ºC'),
	(310733, 142, '2015-01-15 00:13:09.000000', 'temperatura', 1097.0000, 'ºC'),
	(310734, 142, '2015-01-15 00:13:10.000000', 'temperatura', 1080.0000, 'ºC'),
	(310735, 142, '2015-01-15 00:13:11.000000', 'temperatura', 908.0000, 'ºC'),
	(310736, 142, '2015-01-15 00:13:12.000000', 'temperatura', 100.0000, 'ºC'),
	(310737, 142, '2015-01-15 00:13:13.000000', 'temperatura', 176.0000, 'ºC'),
	(310738, 142, '2015-01-15 00:13:14.000000', 'temperatura', 582.0000, 'ºC'),
	(310739, 142, '2015-01-15 00:13:15.000000', 'temperatura', 1182.0000, 'ºC'),
	(310740, 142, '2015-01-15 00:13:16.000000', 'temperatura', 565.0000, 'ºC'),
	(310741, 142, '2015-01-15 00:13:17.000000', 'temperatura', 479.0000, 'ºC'),
	(310742, 142, '2015-01-15 00:13:18.000000', 'temperatura', 701.0000, 'ºC'),
	(310743, 142, '2015-01-15 00:13:19.000000', 'temperatura', 869.0000, 'ºC'),
	(310744, 142, '2015-01-15 00:13:20.000000', 'temperatura', 1044.0000, 'ºC'),
	(310745, 142, '2015-01-15 00:13:21.000000', 'temperatura', 212.0000, 'ºC'),
	(310746, 142, '2015-01-15 00:13:22.000000', 'temperatura', 327.0000, 'ºC'),
	(310747, 142, '2015-01-15 00:13:23.000000', 'temperatura', 1001.0000, 'ºC'),
	(310748, 142, '2015-01-15 00:13:24.000000', 'temperatura', 423.0000, 'ºC'),
	(310749, 142, '2015-01-15 00:13:25.000000', 'temperatura', 313.0000, 'ºC'),
	(310750, 142, '2015-01-15 00:13:26.000000', 'temperatura', 295.0000, 'ºC'),
	(310751, 142, '2015-01-15 00:13:27.000000', 'temperatura', 537.0000, 'ºC'),
	(310752, 142, '2015-01-15 00:13:28.000000', 'temperatura', 602.0000, 'ºC'),
	(310753, 142, '2015-01-15 00:13:29.000000', 'temperatura', 198.0000, 'ºC'),
	(310754, 142, '2015-01-15 00:13:30.000000', 'temperatura', 385.0000, 'ºC'),
	(310755, 142, '2015-01-15 00:13:31.000000', 'temperatura', 132.0000, 'ºC'),
	(310756, 142, '2015-01-15 00:13:32.000000', 'temperatura', 706.0000, 'ºC'),
	(310757, 142, '2015-01-15 00:13:33.000000', 'temperatura', 736.0000, 'ºC'),
	(310758, 142, '2015-01-15 00:13:34.000000', 'temperatura', 359.0000, 'ºC'),
	(310759, 142, '2015-01-15 00:13:35.000000', 'temperatura', 789.0000, 'ºC'),
	(310760, 142, '2015-01-15 00:13:36.000000', 'temperatura', 467.0000, 'ºC'),
	(310761, 142, '2015-01-15 00:13:37.000000', 'temperatura', 1171.0000, 'ºC'),
	(310762, 142, '2015-01-15 00:13:38.000000', 'temperatura', 854.0000, 'ºC'),
	(310763, 142, '2015-01-15 00:13:39.000000', 'temperatura', 757.0000, 'ºC'),
	(310764, 142, '2015-01-15 00:13:40.000000', 'temperatura', 23.0000, 'ºC'),
	(310765, 142, '2015-01-15 00:13:41.000000', 'temperatura', 243.0000, 'ºC'),
	(310766, 142, '2015-01-15 00:13:42.000000', 'temperatura', 1149.0000, 'ºC'),
	(310767, 142, '2015-01-15 00:13:43.000000', 'temperatura', 215.0000, 'ºC'),
	(310768, 142, '2015-01-15 00:13:44.000000', 'temperatura', 31.0000, 'ºC'),
	(310769, 142, '2015-01-15 00:13:45.000000', 'temperatura', 708.0000, 'ºC'),
	(310770, 142, '2015-01-15 00:13:46.000000', 'temperatura', 1048.0000, 'ºC'),
	(310771, 142, '2015-01-15 00:13:47.000000', 'temperatura', 715.0000, 'ºC'),
	(310772, 142, '2015-01-15 00:13:48.000000', 'temperatura', 434.0000, 'ºC'),
	(310773, 142, '2015-01-15 00:13:49.000000', 'temperatura', 25.0000, 'ºC'),
	(310774, 142, '2015-01-15 00:13:50.000000', 'temperatura', 23.0000, 'ºC'),
	(310775, 142, '2015-01-15 00:13:51.000000', 'temperatura', 42.0000, 'ºC'),
	(310776, 142, '2015-01-15 00:13:52.000000', 'temperatura', 139.0000, 'ºC'),
	(310777, 142, '2015-01-15 00:13:53.000000', 'temperatura', 570.0000, 'ºC'),
	(310778, 142, '2015-01-15 00:13:54.000000', 'temperatura', 34.0000, 'ºC'),
	(310779, 142, '2015-01-15 00:13:55.000000', 'temperatura', 860.0000, 'ºC'),
	(310780, 142, '2015-01-15 00:13:56.000000', 'temperatura', 598.0000, 'ºC'),
	(310781, 142, '2015-01-15 00:13:57.000000', 'temperatura', 412.0000, 'ºC'),
	(310782, 142, '2015-01-15 00:13:58.000000', 'temperatura', 264.0000, 'ºC'),
	(310783, 142, '2015-01-15 00:13:59.000000', 'temperatura', 85.0000, 'ºC'),
	(310784, 142, '2015-01-15 00:14:00.000000', 'temperatura', 835.0000, 'ºC'),
	(310785, 142, '2015-01-15 00:14:01.000000', 'temperatura', 319.0000, 'ºC'),
	(310786, 142, '2015-01-15 00:14:02.000000', 'temperatura', 289.0000, 'ºC'),
	(310787, 142, '2015-01-15 00:14:03.000000', 'temperatura', 492.0000, 'ºC'),
	(310788, 142, '2015-01-15 00:14:04.000000', 'temperatura', 392.0000, 'ºC'),
	(310789, 142, '2015-01-15 00:14:05.000000', 'temperatura', 483.0000, 'ºC'),
	(310790, 142, '2015-01-15 00:14:06.000000', 'temperatura', 42.0000, 'ºC'),
	(310791, 142, '2015-01-15 00:14:07.000000', 'temperatura', 1161.0000, 'ºC'),
	(310792, 142, '2015-01-15 00:14:08.000000', 'temperatura', 881.0000, 'ºC'),
	(310793, 142, '2015-01-15 00:14:09.000000', 'temperatura', 921.0000, 'ºC'),
	(310794, 142, '2015-01-15 00:14:10.000000', 'temperatura', 761.0000, 'ºC'),
	(310795, 142, '2015-01-15 00:14:11.000000', 'temperatura', 1043.0000, 'ºC'),
	(310796, 142, '2015-01-15 00:14:12.000000', 'temperatura', 531.0000, 'ºC'),
	(310797, 142, '2015-01-15 00:14:13.000000', 'temperatura', 728.0000, 'ºC'),
	(310798, 142, '2015-01-15 00:14:14.000000', 'temperatura', 847.0000, 'ºC'),
	(310799, 142, '2015-01-15 00:14:15.000000', 'temperatura', 852.0000, 'ºC'),
	(310800, 142, '2015-01-15 00:14:16.000000', 'temperatura', 519.0000, 'ºC'),
	(310801, 142, '2015-01-15 00:14:17.000000', 'temperatura', 39.0000, 'ºC'),
	(310802, 142, '2015-01-15 00:14:18.000000', 'temperatura', 1041.0000, 'ºC'),
	(310803, 142, '2015-01-15 00:14:19.000000', 'temperatura', 286.0000, 'ºC'),
	(310804, 142, '2015-01-15 00:14:20.000000', 'temperatura', 707.0000, 'ºC'),
	(310805, 142, '2015-01-15 00:14:21.000000', 'temperatura', 277.0000, 'ºC'),
	(310806, 142, '2015-01-15 00:14:22.000000', 'temperatura', 466.0000, 'ºC'),
	(310807, 142, '2015-01-15 00:14:23.000000', 'temperatura', 298.0000, 'ºC'),
	(310808, 142, '2015-01-15 00:14:24.000000', 'temperatura', 94.0000, 'ºC'),
	(310809, 142, '2015-01-15 00:14:25.000000', 'temperatura', 777.0000, 'ºC'),
	(310810, 142, '2015-01-15 00:14:26.000000', 'temperatura', 1.0000, 'ºC'),
	(310811, 142, '2015-01-15 00:14:27.000000', 'temperatura', 75.0000, 'ºC'),
	(310812, 142, '2015-01-15 00:14:28.000000', 'temperatura', 371.0000, 'ºC'),
	(310813, 142, '2015-01-15 00:14:29.000000', 'temperatura', 431.0000, 'ºC'),
	(310814, 142, '2015-01-15 00:14:30.000000', 'temperatura', 1045.0000, 'ºC'),
	(310815, 142, '2015-01-15 00:14:31.000000', 'temperatura', 331.0000, 'ºC'),
	(310816, 142, '2015-01-15 00:14:32.000000', 'temperatura', 919.0000, 'ºC'),
	(310817, 142, '2015-01-15 00:14:33.000000', 'temperatura', 5.0000, 'ºC'),
	(310818, 142, '2015-01-15 00:14:34.000000', 'temperatura', 866.0000, 'ºC'),
	(310819, 142, '2015-01-15 00:14:35.000000', 'temperatura', 715.0000, 'ºC'),
	(310820, 142, '2015-01-15 00:14:36.000000', 'temperatura', 978.0000, 'ºC'),
	(310821, 142, '2015-01-15 00:14:37.000000', 'temperatura', 347.0000, 'ºC'),
	(310822, 142, '2015-01-15 00:14:38.000000', 'temperatura', 1199.0000, 'ºC'),
	(310823, 142, '2015-01-15 00:14:39.000000', 'temperatura', 156.0000, 'ºC'),
	(310824, 142, '2015-01-15 00:14:40.000000', 'temperatura', 782.0000, 'ºC'),
	(310825, 142, '2015-01-15 00:14:41.000000', 'temperatura', 1044.0000, 'ºC'),
	(310826, 142, '2015-01-15 00:14:42.000000', 'temperatura', 475.0000, 'ºC'),
	(310827, 142, '2015-01-15 00:14:43.000000', 'temperatura', 443.0000, 'ºC'),
	(310828, 142, '2015-01-15 00:14:44.000000', 'temperatura', 788.0000, 'ºC'),
	(310829, 142, '2015-01-15 00:14:45.000000', 'temperatura', 215.0000, 'ºC'),
	(310830, 142, '2015-01-15 00:14:46.000000', 'temperatura', 1108.0000, 'ºC'),
	(310831, 142, '2015-01-15 00:14:47.000000', 'temperatura', 97.0000, 'ºC'),
	(310832, 142, '2015-01-15 00:14:48.000000', 'temperatura', 763.0000, 'ºC'),
	(310833, 142, '2015-01-15 00:14:49.000000', 'temperatura', 1125.0000, 'ºC'),
	(310834, 142, '2015-01-15 00:14:50.000000', 'temperatura', 934.0000, 'ºC'),
	(310835, 142, '2015-01-15 00:14:51.000000', 'temperatura', 95.0000, 'ºC'),
	(310836, 142, '2015-01-15 00:14:52.000000', 'temperatura', 75.0000, 'ºC'),
	(310837, 142, '2015-01-15 00:14:53.000000', 'temperatura', 91.0000, 'ºC'),
	(310838, 142, '2015-01-15 00:14:54.000000', 'temperatura', 232.0000, 'ºC'),
	(310839, 142, '2015-01-15 00:14:55.000000', 'temperatura', 886.0000, 'ºC'),
	(310840, 142, '2015-01-15 00:14:56.000000', 'temperatura', 134.0000, 'ºC'),
	(310841, 142, '2015-01-15 00:14:57.000000', 'temperatura', 412.0000, 'ºC'),
	(310842, 142, '2015-01-15 00:14:58.000000', 'temperatura', 457.0000, 'ºC'),
	(310843, 142, '2015-01-15 00:14:59.000000', 'temperatura', 1053.0000, 'ºC'),
	(310844, 142, '2015-01-15 00:15:00.000000', 'temperatura', 293.0000, 'ºC'),
	(310845, 142, '2015-01-15 00:15:01.000000', 'temperatura', 705.0000, 'ºC'),
	(310846, 142, '2015-01-15 00:15:02.000000', 'temperatura', 246.0000, 'ºC'),
	(310847, 142, '2015-01-15 00:15:03.000000', 'temperatura', 318.0000, 'ºC'),
	(310848, 142, '2015-01-15 00:15:04.000000', 'temperatura', 853.0000, 'ºC'),
	(310849, 142, '2015-01-15 00:15:05.000000', 'temperatura', 910.0000, 'ºC'),
	(310850, 142, '2015-01-15 00:15:06.000000', 'temperatura', 792.0000, 'ºC'),
	(310851, 142, '2015-01-15 00:15:07.000000', 'temperatura', 29.0000, 'ºC'),
	(310852, 142, '2015-01-15 00:15:08.000000', 'temperatura', 171.0000, 'ºC'),
	(310853, 142, '2015-01-15 00:15:09.000000', 'temperatura', 769.0000, 'ºC'),
	(310854, 142, '2015-01-15 00:15:10.000000', 'temperatura', 933.0000, 'ºC'),
	(310855, 142, '2015-01-15 00:15:11.000000', 'temperatura', 1157.0000, 'ºC'),
	(310856, 142, '2015-01-15 00:15:12.000000', 'temperatura', 586.0000, 'ºC'),
	(310857, 142, '2015-01-15 00:15:13.000000', 'temperatura', 661.0000, 'ºC'),
	(310858, 142, '2015-01-15 00:15:14.000000', 'temperatura', 346.0000, 'ºC'),
	(310859, 142, '2015-01-15 00:15:15.000000', 'temperatura', 946.0000, 'ºC'),
	(310860, 142, '2015-01-15 00:15:16.000000', 'temperatura', 96.0000, 'ºC'),
	(310861, 142, '2015-01-15 00:15:17.000000', 'temperatura', 41.0000, 'ºC'),
	(310862, 142, '2015-01-15 00:15:18.000000', 'temperatura', 1116.0000, 'ºC'),
	(310863, 142, '2015-01-15 00:15:19.000000', 'temperatura', 658.0000, 'ºC'),
	(310864, 142, '2015-01-15 00:15:20.000000', 'temperatura', 1142.0000, 'ºC'),
	(310865, 142, '2015-01-15 00:15:21.000000', 'temperatura', 136.0000, 'ºC'),
	(310866, 142, '2015-01-15 00:15:22.000000', 'temperatura', 856.0000, 'ºC'),
	(310867, 142, '2015-01-15 00:15:23.000000', 'temperatura', 271.0000, 'ºC'),
	(310868, 142, '2015-01-15 00:15:24.000000', 'temperatura', 1189.0000, 'ºC'),
	(310869, 142, '2015-01-15 00:15:25.000000', 'temperatura', 333.0000, 'ºC'),
	(310870, 142, '2015-01-15 00:15:26.000000', 'temperatura', 498.0000, 'ºC'),
	(310871, 142, '2015-01-15 00:15:27.000000', 'temperatura', 290.0000, 'ºC'),
	(310872, 142, '2015-01-15 00:15:28.000000', 'temperatura', 1158.0000, 'ºC'),
	(310873, 142, '2015-01-15 00:15:29.000000', 'temperatura', 122.0000, 'ºC'),
	(310874, 142, '2015-01-15 00:15:30.000000', 'temperatura', 734.0000, 'ºC'),
	(310875, 142, '2015-01-15 00:15:31.000000', 'temperatura', 906.0000, 'ºC'),
	(310876, 142, '2015-01-15 00:15:32.000000', 'temperatura', 1126.0000, 'ºC'),
	(310877, 142, '2015-01-15 00:15:33.000000', 'temperatura', 516.0000, 'ºC'),
	(310878, 142, '2015-01-15 00:15:34.000000', 'temperatura', 401.0000, 'ºC'),
	(310879, 142, '2015-01-15 00:15:35.000000', 'temperatura', 457.0000, 'ºC'),
	(310880, 142, '2015-01-15 00:15:36.000000', 'temperatura', 1084.0000, 'ºC'),
	(310881, 142, '2015-01-15 00:15:37.000000', 'temperatura', 449.0000, 'ºC'),
	(310882, 142, '2015-01-15 00:15:38.000000', 'temperatura', 194.0000, 'ºC'),
	(310883, 142, '2015-01-15 00:15:39.000000', 'temperatura', 824.0000, 'ºC'),
	(310884, 142, '2015-01-15 00:15:40.000000', 'temperatura', 1138.0000, 'ºC'),
	(310885, 142, '2015-01-15 00:15:41.000000', 'temperatura', 819.0000, 'ºC'),
	(310886, 142, '2015-01-15 00:15:42.000000', 'temperatura', 679.0000, 'ºC'),
	(310887, 142, '2015-01-15 00:15:43.000000', 'temperatura', 941.0000, 'ºC'),
	(310888, 142, '2015-01-15 00:15:44.000000', 'temperatura', 268.0000, 'ºC'),
	(310889, 142, '2015-01-15 00:15:45.000000', 'temperatura', 916.0000, 'ºC'),
	(310890, 142, '2015-01-15 00:15:46.000000', 'temperatura', 177.0000, 'ºC'),
	(310891, 142, '2015-01-15 00:15:47.000000', 'temperatura', 538.0000, 'ºC'),
	(310892, 142, '2015-01-15 00:15:48.000000', 'temperatura', 961.0000, 'ºC'),
	(310893, 142, '2015-01-15 00:15:49.000000', 'temperatura', 790.0000, 'ºC'),
	(310894, 142, '2015-01-15 00:15:50.000000', 'temperatura', 1066.0000, 'ºC'),
	(310895, 142, '2015-01-15 00:15:51.000000', 'temperatura', 560.0000, 'ºC'),
	(310896, 142, '2015-01-15 00:15:52.000000', 'temperatura', 805.0000, 'ºC'),
	(310897, 142, '2015-01-15 00:15:53.000000', 'temperatura', 1147.0000, 'ºC'),
	(310898, 142, '2015-01-15 00:15:54.000000', 'temperatura', 917.0000, 'ºC'),
	(310899, 142, '2015-01-15 00:15:55.000000', 'temperatura', 1147.0000, 'ºC'),
	(310900, 142, '2015-01-15 00:15:56.000000', 'temperatura', 584.0000, 'ºC'),
	(310901, 142, '2015-01-15 00:15:57.000000', 'temperatura', 678.0000, 'ºC'),
	(310902, 142, '2015-01-15 00:15:58.000000', 'temperatura', 438.0000, 'ºC'),
	(310903, 142, '2015-01-15 00:15:59.000000', 'temperatura', 158.0000, 'ºC'),
	(310904, 142, '2015-01-15 00:16:00.000000', 'temperatura', 678.0000, 'ºC'),
	(310905, 142, '2015-01-15 00:16:01.000000', 'temperatura', 515.0000, 'ºC'),
	(310906, 142, '2015-01-15 00:16:02.000000', 'temperatura', 543.0000, 'ºC'),
	(310907, 142, '2015-01-15 00:16:03.000000', 'temperatura', 1169.0000, 'ºC'),
	(310908, 142, '2015-01-15 00:16:04.000000', 'temperatura', 617.0000, 'ºC'),
	(310909, 142, '2015-01-15 00:16:05.000000', 'temperatura', 780.0000, 'ºC'),
	(310910, 142, '2015-01-15 00:16:06.000000', 'temperatura', 849.0000, 'ºC'),
	(310911, 142, '2015-01-15 00:16:07.000000', 'temperatura', 707.0000, 'ºC'),
	(310912, 142, '2015-01-15 00:16:08.000000', 'temperatura', 988.0000, 'ºC'),
	(310913, 142, '2015-01-15 00:16:09.000000', 'temperatura', 418.0000, 'ºC'),
	(310914, 142, '2015-01-15 00:16:10.000000', 'temperatura', 326.0000, 'ºC'),
	(310915, 142, '2015-01-15 00:16:11.000000', 'temperatura', 376.0000, 'ºC'),
	(310916, 142, '2015-01-15 00:16:12.000000', 'temperatura', 902.0000, 'ºC'),
	(310917, 142, '2015-01-15 00:16:13.000000', 'temperatura', 983.0000, 'ºC'),
	(310918, 142, '2015-01-15 00:16:14.000000', 'temperatura', 1008.0000, 'ºC'),
	(310919, 142, '2015-01-15 00:16:15.000000', 'temperatura', 894.0000, 'ºC'),
	(310920, 142, '2015-01-15 00:16:16.000000', 'temperatura', 246.0000, 'ºC'),
	(310921, 142, '2015-01-15 00:16:17.000000', 'temperatura', 946.0000, 'ºC'),
	(310922, 142, '2015-01-15 00:16:18.000000', 'temperatura', 396.0000, 'ºC'),
	(310923, 142, '2015-01-15 00:16:19.000000', 'temperatura', 339.0000, 'ºC'),
	(310924, 142, '2015-01-15 00:16:20.000000', 'temperatura', 510.0000, 'ºC'),
	(310925, 142, '2015-01-15 00:16:21.000000', 'temperatura', 331.0000, 'ºC'),
	(310926, 142, '2015-01-15 00:16:22.000000', 'temperatura', 126.0000, 'ºC'),
	(310927, 142, '2015-01-15 00:16:23.000000', 'temperatura', 836.0000, 'ºC'),
	(310928, 142, '2015-01-15 00:16:24.000000', 'temperatura', 205.0000, 'ºC'),
	(310929, 142, '2015-01-15 00:16:25.000000', 'temperatura', 915.0000, 'ºC'),
	(310930, 142, '2015-01-15 00:16:26.000000', 'temperatura', 363.0000, 'ºC'),
	(310931, 142, '2015-01-15 00:16:27.000000', 'temperatura', 268.0000, 'ºC'),
	(310932, 142, '2015-01-15 00:16:28.000000', 'temperatura', 251.0000, 'ºC'),
	(310933, 142, '2015-01-15 00:16:29.000000', 'temperatura', 452.0000, 'ºC'),
	(310934, 142, '2015-01-15 00:16:30.000000', 'temperatura', 308.0000, 'ºC'),
	(310935, 142, '2015-01-15 00:16:31.000000', 'temperatura', 183.0000, 'ºC'),
	(310936, 142, '2015-01-15 00:16:32.000000', 'temperatura', 1193.0000, 'ºC'),
	(310937, 142, '2015-01-15 00:16:33.000000', 'temperatura', 616.0000, 'ºC'),
	(310938, 142, '2015-01-15 00:16:34.000000', 'temperatura', 703.0000, 'ºC'),
	(310939, 142, '2015-01-15 00:16:35.000000', 'temperatura', 465.0000, 'ºC'),
	(310940, 142, '2015-01-15 00:16:36.000000', 'temperatura', 217.0000, 'ºC'),
	(310941, 142, '2015-01-15 00:16:37.000000', 'temperatura', 889.0000, 'ºC'),
	(310942, 142, '2015-01-15 00:16:38.000000', 'temperatura', 195.0000, 'ºC'),
	(310943, 142, '2015-01-15 00:16:39.000000', 'temperatura', 709.0000, 'ºC'),
	(310944, 142, '2015-01-15 00:16:40.000000', 'temperatura', 560.0000, 'ºC'),
	(310945, 142, '2015-01-15 00:16:41.000000', 'temperatura', 675.0000, 'ºC'),
	(310946, 142, '2015-01-15 00:16:42.000000', 'temperatura', 496.0000, 'ºC'),
	(310947, 142, '2015-01-15 00:16:43.000000', 'temperatura', 452.0000, 'ºC'),
	(310948, 142, '2015-01-15 00:16:44.000000', 'temperatura', 776.0000, 'ºC'),
	(310949, 142, '2015-01-15 00:16:45.000000', 'temperatura', 125.0000, 'ºC'),
	(310950, 142, '2015-01-15 00:16:46.000000', 'temperatura', 698.0000, 'ºC'),
	(310951, 142, '2015-01-15 00:16:47.000000', 'temperatura', 713.0000, 'ºC'),
	(310952, 142, '2015-01-15 00:16:48.000000', 'temperatura', 271.0000, 'ºC'),
	(310953, 142, '2015-01-15 00:16:49.000000', 'temperatura', 417.0000, 'ºC'),
	(310954, 142, '2015-01-15 00:16:50.000000', 'temperatura', 74.0000, 'ºC'),
	(310955, 142, '2015-01-15 00:16:51.000000', 'temperatura', 319.0000, 'ºC'),
	(310956, 142, '2015-01-15 00:16:52.000000', 'temperatura', 171.0000, 'ºC'),
	(310957, 142, '2015-01-15 00:16:53.000000', 'temperatura', 1101.0000, 'ºC'),
	(310958, 142, '2015-01-15 00:16:54.000000', 'temperatura', 193.0000, 'ºC'),
	(310959, 142, '2015-01-15 00:16:55.000000', 'temperatura', 61.0000, 'ºC'),
	(310960, 142, '2015-01-15 00:16:56.000000', 'temperatura', 925.0000, 'ºC'),
	(310961, 142, '2015-01-15 00:16:57.000000', 'temperatura', 845.0000, 'ºC'),
	(310962, 142, '2015-01-15 00:16:58.000000', 'temperatura', 252.0000, 'ºC'),
	(310963, 142, '2015-01-15 00:16:59.000000', 'temperatura', 1123.0000, 'ºC'),
	(310964, 142, '2015-01-15 00:17:00.000000', 'temperatura', 60.0000, 'ºC'),
	(310965, 142, '2015-01-15 00:17:01.000000', 'temperatura', 532.0000, 'ºC'),
	(310966, 142, '2015-01-15 00:17:02.000000', 'temperatura', 82.0000, 'ºC'),
	(310967, 142, '2015-01-15 00:17:03.000000', 'temperatura', 12.0000, 'ºC'),
	(310968, 142, '2015-01-15 00:17:04.000000', 'temperatura', 1015.0000, 'ºC'),
	(310969, 142, '2015-01-15 00:17:05.000000', 'temperatura', 238.0000, 'ºC'),
	(310970, 142, '2015-01-15 00:17:06.000000', 'temperatura', 549.0000, 'ºC'),
	(310971, 142, '2015-01-15 00:17:07.000000', 'temperatura', 828.0000, 'ºC'),
	(310972, 142, '2015-01-15 00:17:08.000000', 'temperatura', 95.0000, 'ºC'),
	(310973, 142, '2015-01-15 00:17:09.000000', 'temperatura', 391.0000, 'ºC'),
	(310974, 142, '2015-01-15 00:17:10.000000', 'temperatura', 469.0000, 'ºC'),
	(310975, 142, '2015-01-15 00:17:11.000000', 'temperatura', 1173.0000, 'ºC'),
	(310976, 142, '2015-01-15 00:17:12.000000', 'temperatura', 858.0000, 'ºC'),
	(310977, 142, '2015-01-15 00:17:13.000000', 'temperatura', 774.0000, 'ºC'),
	(310978, 142, '2015-01-15 00:17:14.000000', 'temperatura', 95.0000, 'ºC'),
	(310979, 142, '2015-01-15 00:17:15.000000', 'temperatura', 553.0000, 'ºC'),
	(310980, 142, '2015-01-15 00:17:16.000000', 'temperatura', 80.0000, 'ºC'),
	(310981, 142, '2015-01-15 00:17:17.000000', 'temperatura', 1141.0000, 'ºC'),
	(310982, 142, '2015-01-15 00:17:18.000000', 'temperatura', 667.0000, 'ºC'),
	(310983, 142, '2015-01-15 00:17:19.000000', 'temperatura', 1110.0000, 'ºC'),
	(310984, 142, '2015-01-15 00:17:20.000000', 'temperatura', 1151.0000, 'ºC'),
	(310985, 142, '2015-01-15 00:17:21.000000', 'temperatura', 25.0000, 'ºC'),
	(310986, 142, '2015-01-15 00:17:22.000000', 'temperatura', 271.0000, 'ºC'),
	(310987, 142, '2015-01-15 00:17:23.000000', 'temperatura', 84.0000, 'ºC'),
	(310988, 142, '2015-01-15 00:17:24.000000', 'temperatura', 805.0000, 'ºC'),
	(310989, 142, '2015-01-15 00:17:25.000000', 'temperatura', 176.0000, 'ºC'),
	(310990, 142, '2015-01-15 00:17:26.000000', 'temperatura', 862.0000, 'ºC'),
	(310991, 142, '2015-01-15 00:17:27.000000', 'temperatura', 186.0000, 'ºC'),
	(310992, 142, '2015-01-15 00:17:28.000000', 'temperatura', 742.0000, 'ºC'),
	(310993, 142, '2015-01-15 00:17:29.000000', 'temperatura', 753.0000, 'ºC'),
	(310994, 142, '2015-01-15 00:17:30.000000', 'temperatura', 341.0000, 'ºC'),
	(310995, 142, '2015-01-15 00:17:31.000000', 'temperatura', 646.0000, 'ºC'),
	(310996, 142, '2015-01-15 00:17:32.000000', 'temperatura', 1006.0000, 'ºC'),
	(310997, 142, '2015-01-15 00:17:33.000000', 'temperatura', 693.0000, 'ºC'),
	(310998, 142, '2015-01-15 00:17:34.000000', 'temperatura', 449.0000, 'ºC'),
	(310999, 142, '2015-01-15 00:17:35.000000', 'temperatura', 165.0000, 'ºC'),
	(311000, 142, '2015-01-15 00:17:36.000000', 'temperatura', 677.0000, 'ºC'),
	(311001, 142, '2015-01-15 00:17:37.000000', 'temperatura', 491.0000, 'ºC'),
	(311002, 142, '2015-01-15 00:17:38.000000', 'temperatura', 425.0000, 'ºC'),
	(311003, 142, '2015-01-15 00:17:39.000000', 'temperatura', 653.0000, 'ºC'),
	(311004, 142, '2015-01-15 00:17:40.000000', 'temperatura', 788.0000, 'ºC'),
	(311005, 142, '2015-01-15 00:17:41.000000', 'temperatura', 785.0000, 'ºC'),
	(311006, 142, '2015-01-15 00:17:42.000000', 'temperatura', 358.0000, 'ºC'),
	(311007, 142, '2015-01-15 00:17:43.000000', 'temperatura', 639.0000, 'ºC'),
	(311008, 142, '2015-01-15 00:17:44.000000', 'temperatura', 918.0000, 'ºC'),
	(311009, 142, '2015-01-15 00:17:45.000000', 'temperatura', 275.0000, 'ºC'),
	(311010, 142, '2015-01-15 00:17:46.000000', 'temperatura', 1022.0000, 'ºC'),
	(311011, 142, '2015-01-15 00:17:47.000000', 'temperatura', 684.0000, 'ºC'),
	(311012, 142, '2015-01-15 00:17:48.000000', 'temperatura', 354.0000, 'ºC'),
	(311013, 142, '2015-01-15 00:17:49.000000', 'temperatura', 921.0000, 'ºC'),
	(311014, 142, '2015-01-15 00:17:50.000000', 'temperatura', 1142.0000, 'ºC'),
	(311015, 142, '2015-01-15 00:17:51.000000', 'temperatura', 546.0000, 'ºC'),
	(311016, 142, '2015-01-15 00:17:52.000000', 'temperatura', 507.0000, 'ºC'),
	(311017, 142, '2015-01-15 00:17:53.000000', 'temperatura', 896.0000, 'ºC'),
	(311018, 142, '2015-01-15 00:17:54.000000', 'temperatura', 560.0000, 'ºC'),
	(311019, 142, '2015-01-15 00:17:55.000000', 'temperatura', 112.0000, 'ºC'),
	(311020, 142, '2015-01-15 00:17:56.000000', 'temperatura', 81.0000, 'ºC'),
	(311021, 142, '2015-01-15 00:17:57.000000', 'temperatura', 69.0000, 'ºC'),
	(311022, 142, '2015-01-15 00:17:58.000000', 'temperatura', 104.0000, 'ºC'),
	(311023, 142, '2015-01-15 00:17:59.000000', 'temperatura', 312.0000, 'ºC'),
	(311024, 142, '2015-01-15 00:18:00.000000', 'temperatura', 49.0000, 'ºC'),
	(311025, 142, '2015-01-15 00:18:01.000000', 'temperatura', 510.0000, 'ºC'),
	(311026, 142, '2015-01-15 00:18:02.000000', 'temperatura', 5.0000, 'ºC'),
	(311027, 142, '2015-01-15 00:18:03.000000', 'temperatura', 894.0000, 'ºC'),
	(311028, 142, '2015-01-15 00:18:04.000000', 'temperatura', 854.0000, 'ºC'),
	(311029, 142, '2015-01-15 00:18:05.000000', 'temperatura', 389.0000, 'ºC'),
	(311030, 142, '2015-01-15 00:18:06.000000', 'temperatura', 582.0000, 'ºC'),
	(311031, 142, '2015-01-15 00:18:07.000000', 'temperatura', 546.0000, 'ºC'),
	(311032, 142, '2015-01-15 00:18:08.000000', 'temperatura', 986.0000, 'ºC'),
	(311033, 142, '2015-01-15 00:18:09.000000', 'temperatura', 890.0000, 'ºC'),
	(311034, 142, '2015-01-15 00:18:10.000000', 'temperatura', 292.0000, 'ºC'),
	(311035, 142, '2015-01-15 00:18:11.000000', 'temperatura', 1191.0000, 'ºC'),
	(311036, 142, '2015-01-15 00:18:12.000000', 'temperatura', 281.0000, 'ºC'),
	(311037, 142, '2015-01-15 00:18:13.000000', 'temperatura', 232.0000, 'ºC'),
	(311038, 142, '2015-01-15 00:18:14.000000', 'temperatura', 318.0000, 'ºC'),
	(311039, 142, '2015-01-15 00:18:15.000000', 'temperatura', 893.0000, 'ºC'),
	(311040, 142, '2015-01-15 00:18:16.000000', 'temperatura', 1111.0000, 'ºC'),
	(311041, 142, '2015-01-15 00:18:17.000000', 'temperatura', 478.0000, 'ºC'),
	(311042, 142, '2015-01-15 00:18:18.000000', 'temperatura', 259.0000, 'ºC'),
	(311043, 142, '2015-01-15 00:18:19.000000', 'temperatura', 1060.0000, 'ºC'),
	(311044, 142, '2015-01-15 00:18:20.000000', 'temperatura', 925.0000, 'ºC'),
	(311045, 142, '2015-01-15 00:18:21.000000', 'temperatura', 244.0000, 'ºC'),
	(311046, 142, '2015-01-15 00:18:22.000000', 'temperatura', 845.0000, 'ºC'),
	(311047, 142, '2015-01-15 00:18:23.000000', 'temperatura', 1094.0000, 'ºC'),
	(311048, 142, '2015-01-15 00:18:24.000000', 'temperatura', 537.0000, 'ºC'),
	(311049, 142, '2015-01-15 00:18:25.000000', 'temperatura', 601.0000, 'ºC'),
	(311050, 142, '2015-01-15 00:18:26.000000', 'temperatura', 194.0000, 'ºC'),
	(311051, 142, '2015-01-15 00:18:27.000000', 'temperatura', 369.0000, 'ºC'),
	(311052, 142, '2015-01-15 00:18:28.000000', 'temperatura', 64.0000, 'ºC'),
	(311053, 142, '2015-01-15 00:18:29.000000', 'temperatura', 412.0000, 'ºC'),
	(311054, 142, '2015-01-15 00:18:30.000000', 'temperatura', 670.0000, 'ºC'),
	(311055, 142, '2015-01-15 00:18:31.000000', 'temperatura', 915.0000, 'ºC'),
	(311056, 142, '2015-01-15 00:18:32.000000', 'temperatura', 165.0000, 'ºC'),
	(311057, 142, '2015-01-15 00:18:33.000000', 'temperatura', 479.0000, 'ºC'),
	(311058, 142, '2015-01-15 00:18:34.000000', 'temperatura', 700.0000, 'ºC'),
	(311059, 142, '2015-01-15 00:18:35.000000', 'temperatura', 865.0000, 'ºC'),
	(311060, 142, '2015-01-15 00:18:36.000000', 'temperatura', 1026.0000, 'ºC'),
	(311061, 142, '2015-01-15 00:18:37.000000', 'temperatura', 137.0000, 'ºC'),
	(311062, 142, '2015-01-15 00:18:38.000000', 'temperatura', 6.0000, 'ºC'),
	(311063, 142, '2015-01-15 00:18:39.000000', 'temperatura', 818.0000, 'ºC'),
	(311064, 142, '2015-01-15 00:18:40.000000', 'temperatura', 472.0000, 'ºC'),
	(311065, 142, '2015-01-15 00:18:41.000000', 'temperatura', 1109.0000, 'ºC'),
	(311066, 142, '2015-01-15 00:18:42.000000', 'temperatura', 527.0000, 'ºC'),
	(311067, 142, '2015-01-15 00:18:43.000000', 'temperatura', 511.0000, 'ºC'),
	(311068, 142, '2015-01-15 00:18:44.000000', 'temperatura', 973.0000, 'ºC'),
	(311069, 142, '2015-01-15 00:18:45.000000', 'temperatura', 932.0000, 'ºC'),
	(311070, 142, '2015-01-15 00:18:46.000000', 'temperatura', 542.0000, 'ºC'),
	(311071, 142, '2015-01-15 00:18:47.000000', 'temperatura', 1114.0000, 'ºC'),
	(311072, 142, '2015-01-15 00:18:48.000000', 'temperatura', 343.0000, 'ºC'),
	(311073, 142, '2015-01-15 00:18:49.000000', 'temperatura', 776.0000, 'ºC'),
	(311074, 142, '2015-01-15 00:18:50.000000', 'temperatura', 449.0000, 'ºC'),
	(311075, 142, '2015-01-15 00:18:51.000000', 'temperatura', 1118.0000, 'ºC'),
	(311076, 142, '2015-01-15 00:18:52.000000', 'temperatura', 642.0000, 'ºC'),
	(311077, 142, '2015-01-15 00:18:53.000000', 'temperatura', 1060.0000, 'ºC'),
	(311078, 142, '2015-01-15 00:18:54.000000', 'temperatura', 972.0000, 'ºC'),
	(311079, 142, '2015-01-15 00:18:55.000000', 'temperatura', 480.0000, 'ºC'),
	(311080, 142, '2015-01-15 00:18:56.000000', 'temperatura', 687.0000, 'ºC'),
	(311081, 142, '2015-01-15 00:18:57.000000', 'temperatura', 795.0000, 'ºC'),
	(311082, 142, '2015-01-15 00:18:58.000000', 'temperatura', 712.0000, 'ºC'),
	(311083, 142, '2015-01-15 00:18:59.000000', 'temperatura', 1177.0000, 'ºC'),
	(311084, 142, '2015-01-15 00:19:00.000000', 'temperatura', 150.0000, 'ºC'),
	(311085, 142, '2015-01-15 00:19:01.000000', 'temperatura', 820.0000, 'ºC'),
	(311086, 142, '2015-01-15 00:19:02.000000', 'temperatura', 49.0000, 'ºC'),
	(311087, 142, '2015-01-15 00:19:03.000000', 'temperatura', 188.0000, 'ºC'),
	(311088, 142, '2015-01-15 00:19:04.000000', 'temperatura', 792.0000, 'ºC'),
	(311089, 142, '2015-01-15 00:19:05.000000', 'temperatura', 997.0000, 'ºC'),
	(311090, 142, '2015-01-15 00:19:06.000000', 'temperatura', 208.0000, 'ºC'),
	(311091, 142, '2015-01-15 00:19:07.000000', 'temperatura', 448.0000, 'ºC'),
	(311092, 142, '2015-01-15 00:19:08.000000', 'temperatura', 420.0000, 'ºC'),
	(311093, 142, '2015-01-15 00:19:09.000000', 'temperatura', 755.0000, 'ºC'),
	(311094, 142, '2015-01-15 00:19:10.000000', 'temperatura', 115.0000, 'ºC'),
	(311095, 142, '2015-01-15 00:19:11.000000', 'temperatura', 711.0000, 'ºC'),
	(311096, 142, '2015-01-15 00:19:12.000000', 'temperatura', 809.0000, 'ºC'),
	(311097, 142, '2015-01-15 00:19:13.000000', 'temperatura', 712.0000, 'ºC'),
	(311098, 142, '2015-01-15 00:19:14.000000', 'temperatura', 1134.0000, 'ºC'),
	(311099, 142, '2015-01-15 00:19:15.000000', 'temperatura', 1133.0000, 'ºC'),
	(311100, 142, '2015-01-15 00:19:16.000000', 'temperatura', 1066.0000, 'ºC'),
	(311101, 142, '2015-01-15 00:19:17.000000', 'temperatura', 733.0000, 'ºC'),
	(311102, 142, '2015-01-15 00:19:18.000000', 'temperatura', 464.0000, 'ºC'),
	(311103, 142, '2015-01-15 00:19:19.000000', 'temperatura', 122.0000, 'ºC'),
	(311104, 142, '2015-01-15 00:19:20.000000', 'temperatura', 418.0000, 'ºC'),
	(311105, 142, '2015-01-15 00:19:21.000000', 'temperatura', 527.0000, 'ºC'),
	(311106, 142, '2015-01-15 00:19:22.000000', 'temperatura', 182.0000, 'ºC'),
	(311107, 142, '2015-01-15 00:19:23.000000', 'temperatura', 527.0000, 'ºC'),
	(311108, 142, '2015-01-15 00:19:24.000000', 'temperatura', 892.0000, 'ºC'),
	(311109, 142, '2015-01-15 00:19:25.000000', 'temperatura', 477.0000, 'ºC'),
	(311110, 142, '2015-01-15 00:19:26.000000', 'temperatura', 909.0000, 'ºC'),
	(311111, 142, '2015-01-15 00:19:27.000000', 'temperatura', 715.0000, 'ºC'),
	(311112, 142, '2015-01-15 00:19:28.000000', 'temperatura', 849.0000, 'ºC'),
	(311113, 142, '2015-01-15 00:19:29.000000', 'temperatura', 901.0000, 'ºC'),
	(311114, 142, '2015-01-15 00:19:30.000000', 'temperatura', 756.0000, 'ºC'),
	(311115, 142, '2015-01-15 00:19:31.000000', 'temperatura', 1079.0000, 'ºC'),
	(311116, 142, '2015-01-15 00:19:32.000000', 'temperatura', 727.0000, 'ºC'),
	(311117, 142, '2015-01-15 00:19:33.000000', 'temperatura', 401.0000, 'ºC'),
	(311118, 142, '2015-01-15 00:19:34.000000', 'temperatura', 1022.0000, 'ºC'),
	(311119, 142, '2015-01-15 00:19:35.000000', 'temperatura', 307.0000, 'ºC'),
	(311120, 142, '2015-01-15 00:19:36.000000', 'temperatura', 872.0000, 'ºC'),
	(311121, 142, '2015-01-15 00:19:37.000000', 'temperatura', 1039.0000, 'ºC'),
	(311122, 142, '2015-01-15 00:19:38.000000', 'temperatura', 180.0000, 'ºC'),
	(311123, 142, '2015-01-15 00:19:39.000000', 'temperatura', 181.0000, 'ºC'),
	(311124, 142, '2015-01-15 00:19:40.000000', 'temperatura', 366.0000, 'ºC'),
	(311125, 142, '2015-01-15 00:19:41.000000', 'temperatura', 89.0000, 'ºC'),
	(311126, 142, '2015-01-15 00:19:42.000000', 'temperatura', 546.0000, 'ºC'),
	(311127, 142, '2015-01-15 00:19:43.000000', 'temperatura', 64.0000, 'ºC'),
	(311128, 142, '2015-01-15 00:19:44.000000', 'temperatura', 1081.0000, 'ºC'),
	(311129, 142, '2015-01-15 00:19:45.000000', 'temperatura', 414.0000, 'ºC'),
	(311130, 142, '2015-01-15 00:19:46.000000', 'temperatura', 28.0000, 'ºC'),
	(311131, 142, '2015-01-15 00:19:47.000000', 'temperatura', 100.0000, 'ºC'),
	(311132, 142, '2015-01-15 00:19:48.000000', 'temperatura', 414.0000, 'ºC'),
	(311133, 142, '2015-01-15 00:19:49.000000', 'temperatura', 573.0000, 'ºC'),
	(311134, 142, '2015-01-15 00:19:50.000000', 'temperatura', 422.0000, 'ºC'),
	(311135, 142, '2015-01-15 00:19:51.000000', 'temperatura', 391.0000, 'ºC'),
	(311136, 142, '2015-01-15 00:19:52.000000', 'temperatura', 691.0000, 'ºC'),
	(311137, 142, '2015-01-15 00:19:53.000000', 'temperatura', 1080.0000, 'ºC'),
	(311138, 142, '2015-01-15 00:19:54.000000', 'temperatura', 928.0000, 'ºC'),
	(311139, 142, '2015-01-15 00:19:55.000000', 'temperatura', 200.0000, 'ºC'),
	(311140, 142, '2015-01-15 00:19:56.000000', 'temperatura', 619.0000, 'ºC'),
	(311141, 142, '2015-01-15 00:19:57.000000', 'temperatura', 95.0000, 'ºC'),
	(311142, 142, '2015-01-15 00:19:58.000000', 'temperatura', 1019.0000, 'ºC'),
	(311143, 142, '2015-01-15 00:19:59.000000', 'temperatura', 11.0000, 'ºC'),
	(311144, 142, '2015-01-15 00:20:00.000000', 'temperatura', 599.0000, 'ºC'),
	(311145, 142, '2015-01-15 00:20:01.000000', 'temperatura', 562.0000, 'ºC'),
	(311146, 142, '2015-01-15 00:20:02.000000', 'temperatura', 1015.0000, 'ºC'),
	(311147, 142, '2015-01-15 00:20:03.000000', 'temperatura', 989.0000, 'ºC'),
	(311148, 142, '2015-01-15 00:20:04.000000', 'temperatura', 701.0000, 'ºC'),
	(311149, 142, '2015-01-15 00:20:05.000000', 'temperatura', 536.0000, 'ºC'),
	(311150, 142, '2015-01-15 00:20:06.000000', 'temperatura', 578.0000, 'ºC'),
	(311151, 142, '2015-01-15 00:20:07.000000', 'temperatura', 82.0000, 'ºC'),
	(311152, 142, '2015-01-15 00:20:08.000000', 'temperatura', 1076.0000, 'ºC'),
	(311153, 142, '2015-01-15 00:20:09.000000', 'temperatura', 336.0000, 'ºC'),
	(311154, 142, '2015-01-15 00:20:10.000000', 'temperatura', 852.0000, 'ºC'),
	(311155, 142, '2015-01-15 00:20:11.000000', 'temperatura', 853.0000, 'ºC'),
	(311156, 142, '2015-01-15 00:20:12.000000', 'temperatura', 510.0000, 'ºC'),
	(311157, 142, '2015-01-15 00:20:13.000000', 'temperatura', 1190.0000, 'ºC'),
	(311158, 142, '2015-01-15 00:20:14.000000', 'temperatura', 820.0000, 'ºC'),
	(311159, 142, '2015-01-15 00:20:15.000000', 'temperatura', 531.0000, 'ºC'),
	(311160, 142, '2015-01-15 00:20:16.000000', 'temperatura', 194.0000, 'ºC'),
	(311161, 142, '2015-01-15 00:20:17.000000', 'temperatura', 579.0000, 'ºC'),
	(311162, 142, '2015-01-15 00:20:18.000000', 'temperatura', 1113.0000, 'ºC'),
	(311163, 142, '2015-01-15 00:20:19.000000', 'temperatura', 228.0000, 'ºC'),
	(311164, 142, '2015-01-15 00:20:20.000000', 'temperatura', 203.0000, 'ºC'),
	(311165, 142, '2015-01-15 00:20:21.000000', 'temperatura', 330.0000, 'ºC'),
	(311166, 142, '2015-01-15 00:20:22.000000', 'temperatura', 1043.0000, 'ºC'),
	(311167, 142, '2015-01-15 00:20:23.000000', 'temperatura', 624.0000, 'ºC'),
	(311168, 142, '2015-01-15 00:20:24.000000', 'temperatura', 1191.0000, 'ºC'),
	(311169, 142, '2015-01-15 00:20:25.000000', 'temperatura', 482.0000, 'ºC'),
	(311170, 142, '2015-01-15 00:20:26.000000', 'temperatura', 40.0000, 'ºC'),
	(311171, 142, '2015-01-15 00:20:27.000000', 'temperatura', 1152.0000, 'ºC'),
	(311172, 142, '2015-01-15 00:20:28.000000', 'temperatura', 842.0000, 'ºC'),
	(311173, 142, '2015-01-15 00:20:29.000000', 'temperatura', 752.0000, 'ºC'),
	(311174, 142, '2015-01-15 00:20:30.000000', 'temperatura', 38.0000, 'ºC'),
	(311175, 142, '2015-01-15 00:20:31.000000', 'temperatura', 334.0000, 'ºC'),
	(311176, 142, '2015-01-15 00:20:32.000000', 'temperatura', 355.0000, 'ºC'),
	(311177, 142, '2015-01-15 00:20:33.000000', 'temperatura', 773.0000, 'ºC'),
	(311178, 142, '2015-01-15 00:20:34.000000', 'temperatura', 401.0000, 'ºC'),
	(311179, 142, '2015-01-15 00:20:35.000000', 'temperatura', 888.0000, 'ºC'),
	(311180, 142, '2015-01-15 00:20:36.000000', 'temperatura', 838.0000, 'ºC'),
	(311181, 142, '2015-01-15 00:20:37.000000', 'temperatura', 324.0000, 'ºC'),
	(311182, 142, '2015-01-15 00:20:38.000000', 'temperatura', 308.0000, 'ºC'),
	(311183, 142, '2015-01-15 00:20:39.000000', 'temperatura', 569.0000, 'ºC'),
	(311184, 142, '2015-01-15 00:20:40.000000', 'temperatura', 720.0000, 'ºC'),
	(311185, 142, '2015-01-15 00:20:41.000000', 'temperatura', 695.0000, 'ºC'),
	(311186, 142, '2015-01-15 00:20:42.000000', 'temperatura', 113.0000, 'ºC'),
	(311187, 142, '2015-01-15 00:20:43.000000', 'temperatura', 884.0000, 'ºC'),
	(311188, 142, '2015-01-15 00:20:44.000000', 'temperatura', 478.0000, 'ºC'),
	(311189, 142, '2015-01-15 00:20:45.000000', 'temperatura', 942.0000, 'ºC'),
	(311190, 142, '2015-01-15 00:20:46.000000', 'temperatura', 874.0000, 'ºC'),
	(311191, 142, '2015-01-15 00:20:47.000000', 'temperatura', 346.0000, 'ºC'),
	(311192, 142, '2015-01-15 00:20:48.000000', 'temperatura', 307.0000, 'ºC'),
	(311193, 142, '2015-01-15 00:20:49.000000', 'temperatura', 496.0000, 'ºC'),
	(311194, 142, '2015-01-15 00:20:50.000000', 'temperatura', 362.0000, 'ºC'),
	(311195, 142, '2015-01-15 00:20:51.000000', 'temperatura', 321.0000, 'ºC'),
	(311196, 142, '2015-01-15 00:20:52.000000', 'temperatura', 518.0000, 'ºC'),
	(311197, 142, '2015-01-15 00:20:53.000000', 'temperatura', 431.0000, 'ºC'),
	(311198, 142, '2015-01-15 00:20:54.000000', 'temperatura', 600.0000, 'ºC'),
	(311199, 142, '2015-01-15 00:20:55.000000', 'temperatura', 507.0000, 'ºC'),
	(311200, 142, '2015-01-15 00:20:56.000000', 'temperatura', 735.0000, 'ºC'),
	(311201, 142, '2015-01-15 00:20:57.000000', 'temperatura', 954.0000, 'ºC'),
	(311202, 142, '2015-01-15 00:20:58.000000', 'temperatura', 164.0000, 'ºC'),
	(311203, 142, '2015-01-15 00:20:59.000000', 'temperatura', 362.0000, 'ºC'),
	(311204, 142, '2015-01-15 00:21:00.000000', 'temperatura', 116.0000, 'ºC'),
	(311205, 142, '2015-01-15 00:21:01.000000', 'temperatura', 697.0000, 'ºC'),
	(311206, 142, '2015-01-15 00:21:02.000000', 'temperatura', 738.0000, 'ºC'),
	(311207, 142, '2015-01-15 00:21:03.000000', 'temperatura', 399.0000, 'ºC'),
	(311208, 142, '2015-01-15 00:21:04.000000', 'temperatura', 982.0000, 'ºC'),
	(311209, 142, '2015-01-15 00:21:05.000000', 'temperatura', 112.0000, 'ºC'),
	(311210, 142, '2015-01-15 00:21:06.000000', 'temperatura', 13.0000, 'ºC'),
	(311211, 142, '2015-01-15 00:21:07.000000', 'temperatura', 932.0000, 'ºC'),
	(311212, 142, '2015-01-15 00:21:08.000000', 'temperatura', 1023.0000, 'ºC'),
	(311213, 142, '2015-01-15 00:21:09.000000', 'temperatura', 1117.0000, 'ºC'),
	(311214, 142, '2015-01-15 00:21:10.000000', 'temperatura', 118.0000, 'ºC'),
	(311215, 142, '2015-01-15 00:21:11.000000', 'temperatura', 837.0000, 'ºC'),
	(311216, 142, '2015-01-15 00:21:12.000000', 'temperatura', 233.0000, 'ºC'),
	(311217, 142, '2015-01-15 00:21:13.000000', 'temperatura', 1053.0000, 'ºC'),
	(311218, 142, '2015-01-15 00:21:14.000000', 'temperatura', 968.0000, 'ºC'),
	(311219, 142, '2015-01-15 00:21:15.000000', 'temperatura', 480.0000, 'ºC'),
	(311220, 142, '2015-01-15 00:21:16.000000', 'temperatura', 697.0000, 'ºC'),
	(311221, 142, '2015-01-15 00:21:17.000000', 'temperatura', 848.0000, 'ºC'),
	(311222, 142, '2015-01-15 00:21:18.000000', 'temperatura', 947.0000, 'ºC'),
	(311223, 142, '2015-01-15 00:21:19.000000', 'temperatura', 993.0000, 'ºC'),
	(311224, 142, '2015-01-15 00:21:20.000000', 'temperatura', 924.0000, 'ºC'),
	(311225, 142, '2015-01-15 00:21:21.000000', 'temperatura', 440.0000, 'ºC'),
	(311226, 142, '2015-01-15 00:21:22.000000', 'temperatura', 628.0000, 'ºC'),
	(311227, 142, '2015-01-15 00:21:23.000000', 'temperatura', 619.0000, 'ºC'),
	(311228, 142, '2015-01-15 00:21:24.000000', 'temperatura', 15.0000, 'ºC'),
	(311229, 142, '2015-01-15 00:21:25.000000', 'temperatura', 618.0000, 'ºC'),
	(311230, 142, '2015-01-15 00:21:26.000000', 'temperatura', 647.0000, 'ºC'),
	(311231, 142, '2015-01-15 00:21:27.000000', 'temperatura', 180.0000, 'ºC'),
	(311232, 142, '2015-01-15 00:21:28.000000', 'temperatura', 161.0000, 'ºC'),
	(311233, 142, '2015-01-15 00:21:29.000000', 'temperatura', 263.0000, 'ºC'),
	(311234, 142, '2015-01-15 00:21:30.000000', 'temperatura', 835.0000, 'ºC'),
	(311235, 142, '2015-01-15 00:21:31.000000', 'temperatura', 985.0000, 'ºC'),
	(311236, 142, '2015-01-15 00:21:32.000000', 'temperatura', 20.0000, 'ºC'),
	(311237, 142, '2015-01-15 00:21:33.000000', 'temperatura', 746.0000, 'ºC'),
	(311238, 142, '2015-01-15 00:21:34.000000', 'temperatura', 69.0000, 'ºC'),
	(311239, 142, '2015-01-15 00:21:35.000000', 'temperatura', 509.0000, 'ºC'),
	(311240, 142, '2015-01-15 00:21:36.000000', 'temperatura', 1139.0000, 'ºC'),
	(311241, 142, '2015-01-15 00:21:37.000000', 'temperatura', 569.0000, 'ºC'),
	(311242, 142, '2015-01-15 00:21:38.000000', 'temperatura', 629.0000, 'ºC'),
	(311243, 142, '2015-01-15 00:21:39.000000', 'temperatura', 239.0000, 'ºC'),
	(311244, 142, '2015-01-15 00:21:40.000000', 'temperatura', 508.0000, 'ºC'),
	(311245, 142, '2015-01-15 00:21:41.000000', 'temperatura', 625.0000, 'ºC'),
	(311246, 142, '2015-01-15 00:21:42.000000', 'temperatura', 399.0000, 'ºC'),
	(311247, 142, '2015-01-15 00:21:43.000000', 'temperatura', 122.0000, 'ºC'),
	(311248, 142, '2015-01-15 00:21:44.000000', 'temperatura', 612.0000, 'ºC'),
	(311249, 142, '2015-01-15 00:21:45.000000', 'temperatura', 297.0000, 'ºC'),
	(311250, 142, '2015-01-15 00:21:46.000000', 'temperatura', 849.0000, 'ºC'),
	(311251, 142, '2015-01-15 00:21:47.000000', 'temperatura', 955.0000, 'ºC'),
	(311252, 142, '2015-01-15 00:21:48.000000', 'temperatura', 1030.0000, 'ºC'),
	(311253, 142, '2015-01-15 00:21:49.000000', 'temperatura', 1084.0000, 'ºC'),
	(311254, 142, '2015-01-15 00:21:50.000000', 'temperatura', 1129.0000, 'ºC'),
	(311255, 142, '2015-01-15 00:21:51.000000', 'temperatura', 1195.0000, 'ºC'),
	(311256, 142, '2015-01-15 00:21:52.000000', 'temperatura', 189.0000, 'ºC'),
	(311257, 142, '2015-01-15 00:21:53.000000', 'temperatura', 959.0000, 'ºC'),
	(311258, 142, '2015-01-15 00:21:54.000000', 'temperatura', 631.0000, 'ºC'),
	(311259, 142, '2015-01-15 00:21:55.000000', 'temperatura', 278.0000, 'ºC'),
	(311260, 142, '2015-01-15 00:21:56.000000', 'temperatura', 697.0000, 'ºC'),
	(311261, 142, '2015-01-15 00:21:57.000000', 'temperatura', 253.0000, 'ºC'),
	(311262, 142, '2015-01-15 00:21:58.000000', 'temperatura', 373.0000, 'ºC'),
	(311263, 142, '2015-01-15 00:21:59.000000', 'temperatura', 1108.0000, 'ºC'),
	(311264, 142, '2015-01-15 00:22:00.000000', 'temperatura', 819.0000, 'ºC'),
	(311265, 142, '2015-01-15 00:22:01.000000', 'temperatura', 773.0000, 'ºC'),
	(311266, 142, '2015-01-15 00:22:02.000000', 'temperatura', 207.0000, 'ºC'),
	(311267, 142, '2015-01-15 00:22:03.000000', 'temperatura', 1116.0000, 'ºC'),
	(311268, 142, '2015-01-15 00:22:04.000000', 'temperatura', 162.0000, 'ºC'),
	(311269, 142, '2015-01-15 00:22:05.000000', 'temperatura', 1063.0000, 'ºC'),
	(311270, 142, '2015-01-15 00:22:06.000000', 'temperatura', 30.0000, 'ºC'),
	(311271, 142, '2015-01-15 00:22:07.000000', 'temperatura', 561.0000, 'ºC'),
	(311272, 142, '2015-01-15 00:22:08.000000', 'temperatura', 313.0000, 'ºC'),
	(311273, 142, '2015-01-15 00:22:09.000000', 'temperatura', 1085.0000, 'ºC'),
	(311274, 142, '2015-01-15 00:22:10.000000', 'temperatura', 887.0000, 'ºC'),
	(311275, 142, '2015-01-15 00:22:11.000000', 'temperatura', 1180.0000, 'ºC'),
	(311276, 142, '2015-01-15 00:22:12.000000', 'temperatura', 840.0000, 'ºC'),
	(311277, 142, '2015-01-15 00:22:13.000000', 'temperatura', 662.0000, 'ºC'),
	(311278, 142, '2015-01-15 00:22:14.000000', 'temperatura', 788.0000, 'ºC'),
	(311279, 142, '2015-01-15 00:22:15.000000', 'temperatura', 756.0000, 'ºC'),
	(311280, 142, '2015-01-15 00:22:16.000000', 'temperatura', 215.0000, 'ºC'),
	(311281, 142, '2015-01-15 00:22:17.000000', 'temperatura', 8.0000, 'ºC'),
	(311282, 142, '2015-01-15 00:22:18.000000', 'temperatura', 596.0000, 'ºC'),
	(311283, 142, '2015-01-15 00:22:19.000000', 'temperatura', 556.0000, 'ºC'),
	(311284, 142, '2015-01-15 00:22:20.000000', 'temperatura', 992.0000, 'ºC'),
	(311285, 142, '2015-01-15 00:22:21.000000', 'temperatura', 892.0000, 'ºC'),
	(311286, 142, '2015-01-15 00:22:22.000000', 'temperatura', 285.0000, 'ºC'),
	(311287, 142, '2015-01-15 00:22:23.000000', 'temperatura', 1149.0000, 'ºC'),
	(311288, 142, '2015-01-15 00:22:24.000000', 'temperatura', 92.0000, 'ºC'),
	(311289, 142, '2015-01-15 00:22:25.000000', 'temperatura', 612.0000, 'ºC'),
	(311290, 142, '2015-01-15 00:22:26.000000', 'temperatura', 383.0000, 'ºC'),
	(311291, 142, '2015-01-15 00:22:27.000000', 'temperatura', 81.0000, 'ºC'),
	(311292, 142, '2015-01-15 00:22:28.000000', 'temperatura', 457.0000, 'ºC'),
	(311293, 142, '2015-01-15 00:22:29.000000', 'temperatura', 842.0000, 'ºC'),
	(311294, 142, '2015-01-15 00:22:30.000000', 'temperatura', 439.0000, 'ºC'),
	(311295, 142, '2015-01-15 00:22:31.000000', 'temperatura', 868.0000, 'ºC'),
	(311296, 142, '2015-01-15 00:22:32.000000', 'temperatura', 624.0000, 'ºC'),
	(311297, 142, '2015-01-15 00:22:33.000000', 'temperatura', 518.0000, 'ºC'),
	(311298, 142, '2015-01-15 00:22:34.000000', 'temperatura', 716.0000, 'ºC'),
	(311299, 142, '2015-01-15 00:22:35.000000', 'temperatura', 830.0000, 'ºC'),
	(311300, 142, '2015-01-15 00:22:36.000000', 'temperatura', 799.0000, 'ºC'),
	(311301, 142, '2015-01-15 00:22:37.000000', 'temperatura', 308.0000, 'ºC'),
	(311302, 142, '2015-01-15 00:22:38.000000', 'temperatura', 342.0000, 'ºC'),
	(311303, 142, '2015-01-15 00:22:39.000000', 'temperatura', 786.0000, 'ºC'),
	(311304, 142, '2015-01-15 00:22:40.000000', 'temperatura', 505.0000, 'ºC'),
	(311305, 142, '2015-01-15 00:22:41.000000', 'temperatura', 166.0000, 'ºC'),
	(311306, 142, '2015-01-15 00:22:42.000000', 'temperatura', 515.0000, 'ºC'),
	(311307, 142, '2015-01-15 00:22:43.000000', 'temperatura', 880.0000, 'ºC'),
	(311308, 142, '2015-01-15 00:22:44.000000', 'temperatura', 453.0000, 'ºC'),
	(311309, 142, '2015-01-15 00:22:45.000000', 'temperatura', 825.0000, 'ºC'),
	(311310, 142, '2015-01-15 00:22:46.000000', 'temperatura', 369.0000, 'ºC'),
	(311311, 142, '2015-01-15 00:22:47.000000', 'temperatura', 570.0000, 'ºC'),
	(311312, 142, '2015-01-15 00:22:48.000000', 'temperatura', 542.0000, 'ºC'),
	(311313, 142, '2015-01-15 00:22:49.000000', 'temperatura', 1002.0000, 'ºC'),
	(311314, 142, '2015-01-15 00:22:50.000000', 'temperatura', 985.0000, 'ºC'),
	(311315, 142, '2015-01-15 00:22:51.000000', 'temperatura', 717.0000, 'ºC'),
	(311316, 142, '2015-01-15 00:22:52.000000', 'temperatura', 633.0000, 'ºC'),
	(311317, 142, '2015-01-15 00:22:53.000000', 'temperatura', 1012.0000, 'ºC'),
	(311318, 142, '2015-01-15 00:22:54.000000', 'temperatura', 761.0000, 'ºC'),
	(311319, 142, '2015-01-15 00:22:55.000000', 'temperatura', 770.0000, 'ºC'),
	(311320, 142, '2015-01-15 00:22:56.000000', 'temperatura', 368.0000, 'ºC'),
	(311321, 142, '2015-01-15 00:22:57.000000', 'temperatura', 731.0000, 'ºC'),
	(311322, 142, '2015-01-15 00:22:58.000000', 'temperatura', 153.0000, 'ºC'),
	(311323, 142, '2015-01-15 00:22:59.000000', 'temperatura', 971.0000, 'ºC'),
	(311324, 142, '2015-01-15 00:23:00.000000', 'temperatura', 798.0000, 'ºC'),
	(311325, 142, '2015-01-15 00:23:01.000000', 'temperatura', 1077.0000, 'ºC'),
	(311326, 142, '2015-01-15 00:23:02.000000', 'temperatura', 591.0000, 'ºC'),
	(311327, 142, '2015-01-15 00:23:03.000000', 'temperatura', 927.0000, 'ºC'),
	(311328, 142, '2015-01-15 00:23:04.000000', 'temperatura', 459.0000, 'ºC'),
	(311329, 142, '2015-01-15 00:23:05.000000', 'temperatura', 717.0000, 'ºC'),
	(311330, 142, '2015-01-15 00:23:06.000000', 'temperatura', 1008.0000, 'ºC'),
	(311331, 142, '2015-01-15 00:23:07.000000', 'temperatura', 487.0000, 'ºC'),
	(311332, 142, '2015-01-15 00:23:08.000000', 'temperatura', 614.0000, 'ºC'),
	(311333, 142, '2015-01-15 00:23:09.000000', 'temperatura', 411.0000, 'ºC'),
	(311334, 142, '2015-01-15 00:23:10.000000', 'temperatura', 211.0000, 'ºC'),
	(311335, 142, '2015-01-15 00:23:11.000000', 'temperatura', 1023.0000, 'ºC'),
	(311336, 142, '2015-01-15 00:23:12.000000', 'temperatura', 882.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(311337, 142, '2015-01-15 00:23:13.000000', 'temperatura', 144.0000, 'ºC'),
	(311338, 142, '2015-01-15 00:23:14.000000', 'temperatura', 473.0000, 'ºC'),
	(311339, 142, '2015-01-15 00:23:15.000000', 'temperatura', 733.0000, 'ºC'),
	(311340, 142, '2015-01-15 00:23:16.000000', 'temperatura', 1046.0000, 'ºC'),
	(311341, 142, '2015-01-15 00:23:17.000000', 'temperatura', 633.0000, 'ºC'),
	(311342, 142, '2015-01-15 00:23:18.000000', 'temperatura', 25.0000, 'ºC'),
	(311343, 142, '2015-01-15 00:23:19.000000', 'temperatura', 627.0000, 'ºC'),
	(311344, 142, '2015-01-15 00:23:20.000000', 'temperatura', 661.0000, 'ºC'),
	(311345, 142, '2015-01-15 00:23:21.000000', 'temperatura', 226.0000, 'ºC'),
	(311346, 142, '2015-01-15 00:23:22.000000', 'temperatura', 347.0000, 'ºC'),
	(311347, 142, '2015-01-15 00:23:23.000000', 'temperatura', 1059.0000, 'ºC'),
	(311348, 142, '2015-01-15 00:23:24.000000', 'temperatura', 654.0000, 'ºC'),
	(311349, 142, '2015-01-15 00:23:25.000000', 'temperatura', 92.0000, 'ºC'),
	(311350, 142, '2015-01-15 00:23:26.000000', 'temperatura', 900.0000, 'ºC'),
	(311351, 142, '2015-01-15 00:23:27.000000', 'temperatura', 622.0000, 'ºC'),
	(311352, 142, '2015-01-15 00:23:28.000000', 'temperatura', 414.0000, 'ºC'),
	(311353, 142, '2015-01-15 00:23:29.000000', 'temperatura', 202.0000, 'ºC'),
	(311354, 142, '2015-01-15 00:23:30.000000', 'temperatura', 969.0000, 'ºC'),
	(311355, 142, '2015-01-15 00:23:31.000000', 'temperatura', 642.0000, 'ºC'),
	(311356, 142, '2015-01-15 00:23:32.000000', 'temperatura', 301.0000, 'ºC'),
	(311357, 142, '2015-01-15 00:23:33.000000', 'temperatura', 779.0000, 'ºC'),
	(311358, 142, '2015-01-15 00:23:34.000000', 'temperatura', 594.0000, 'ºC'),
	(311359, 142, '2015-01-15 00:23:35.000000', 'temperatura', 633.0000, 'ºC'),
	(311360, 142, '2015-01-15 00:23:36.000000', 'temperatura', 185.0000, 'ºC'),
	(311361, 142, '2015-01-15 00:23:37.000000', 'temperatura', 225.0000, 'ºC'),
	(311362, 142, '2015-01-15 00:23:38.000000', 'temperatura', 571.0000, 'ºC'),
	(311363, 142, '2015-01-15 00:23:39.000000', 'temperatura', 980.0000, 'ºC'),
	(311364, 142, '2015-01-15 00:23:40.000000', 'temperatura', 786.0000, 'ºC'),
	(311365, 142, '2015-01-15 00:23:41.000000', 'temperatura', 993.0000, 'ºC'),
	(311366, 142, '2015-01-15 00:23:42.000000', 'temperatura', 205.0000, 'ºC'),
	(311367, 142, '2015-01-15 00:23:43.000000', 'temperatura', 446.0000, 'ºC'),
	(311368, 142, '2015-01-15 00:23:44.000000', 'temperatura', 416.0000, 'ºC'),
	(311369, 142, '2015-01-15 00:23:45.000000', 'temperatura', 743.0000, 'ºC'),
	(311370, 142, '2015-01-15 00:23:46.000000', 'temperatura', 69.0000, 'ºC'),
	(311371, 142, '2015-01-15 00:23:47.000000', 'temperatura', 513.0000, 'ºC'),
	(311372, 142, '2015-01-15 00:23:48.000000', 'temperatura', 1162.0000, 'ºC'),
	(311373, 142, '2015-01-15 00:23:49.000000', 'temperatura', 670.0000, 'ºC'),
	(311374, 142, '2015-01-15 00:23:50.000000', 'temperatura', 1063.0000, 'ºC'),
	(311375, 142, '2015-01-15 00:23:51.000000', 'temperatura', 907.0000, 'ºC'),
	(311376, 142, '2015-01-15 00:23:52.000000', 'temperatura', 145.0000, 'ºC'),
	(311377, 142, '2015-01-15 00:23:53.000000', 'temperatura', 406.0000, 'ºC'),
	(311378, 142, '2015-01-15 00:23:54.000000', 'temperatura', 396.0000, 'ºC'),
	(311379, 142, '2015-01-15 00:23:55.000000', 'temperatura', 763.0000, 'ºC'),
	(311380, 142, '2015-01-15 00:23:56.000000', 'temperatura', 226.0000, 'ºC'),
	(311381, 142, '2015-01-15 00:23:57.000000', 'temperatura', 42.0000, 'ºC'),
	(311382, 142, '2015-01-15 00:23:58.000000', 'temperatura', 732.0000, 'ºC'),
	(311383, 142, '2015-01-15 00:23:59.000000', 'temperatura', 1133.0000, 'ºC'),
	(311384, 142, '2015-01-15 00:24:00.000000', 'temperatura', 1072.0000, 'ºC'),
	(311385, 142, '2015-01-15 00:24:01.000000', 'temperatura', 759.0000, 'ºC'),
	(311386, 142, '2015-01-15 00:24:02.000000', 'temperatura', 581.0000, 'ºC'),
	(311387, 142, '2015-01-15 00:24:03.000000', 'temperatura', 628.0000, 'ºC'),
	(311388, 142, '2015-01-15 00:24:04.000000', 'temperatura', 197.0000, 'ºC'),
	(311389, 142, '2015-01-15 00:24:05.000000', 'temperatura', 303.0000, 'ºC'),
	(311390, 142, '2015-01-15 00:24:06.000000', 'temperatura', 923.0000, 'ºC'),
	(311391, 142, '2015-01-15 00:24:07.000000', 'temperatura', 105.0000, 'ºC'),
	(311392, 142, '2015-01-15 00:24:08.000000', 'temperatura', 158.0000, 'ºC'),
	(311393, 142, '2015-01-15 00:24:09.000000', 'temperatura', 478.0000, 'ºC'),
	(311394, 142, '2015-01-15 00:24:10.000000', 'temperatura', 713.0000, 'ºC'),
	(311395, 142, '2015-01-15 00:24:11.000000', 'temperatura', 931.0000, 'ºC'),
	(311396, 142, '2015-01-15 00:24:12.000000', 'temperatura', 119.0000, 'ºC'),
	(311397, 142, '2015-01-15 00:24:13.000000', 'temperatura', 200.0000, 'ºC'),
	(311398, 142, '2015-01-15 00:24:14.000000', 'temperatura', 643.0000, 'ºC'),
	(311399, 142, '2015-01-15 00:24:15.000000', 'temperatura', 217.0000, 'ºC'),
	(311400, 142, '2015-01-15 00:24:16.000000', 'temperatura', 358.0000, 'ºC'),
	(311401, 142, '2015-01-15 00:24:17.000000', 'temperatura', 1140.0000, 'ºC'),
	(311402, 142, '2015-01-15 00:24:18.000000', 'temperatura', 1024.0000, 'ºC'),
	(311403, 142, '2015-01-15 00:24:19.000000', 'temperatura', 502.0000, 'ºC'),
	(311404, 142, '2015-01-15 00:24:20.000000', 'temperatura', 638.0000, 'ºC'),
	(311405, 142, '2015-01-15 00:24:21.000000', 'temperatura', 485.0000, 'ºC'),
	(311406, 142, '2015-01-15 00:24:22.000000', 'temperatura', 512.0000, 'ºC'),
	(311407, 142, '2015-01-15 00:24:23.000000', 'temperatura', 1103.0000, 'ºC'),
	(311408, 142, '2015-01-15 00:24:24.000000', 'temperatura', 381.0000, 'ºC'),
	(311409, 142, '2015-01-15 00:24:25.000000', 'temperatura', 998.0000, 'ºC'),
	(311410, 142, '2015-01-15 00:24:26.000000', 'temperatura', 247.0000, 'ºC'),
	(311411, 142, '2015-01-15 00:24:27.000000', 'temperatura', 641.0000, 'ºC'),
	(311412, 142, '2015-01-15 00:24:28.000000', 'temperatura', 65.0000, 'ºC'),
	(311413, 142, '2015-01-15 00:24:29.000000', 'temperatura', 804.0000, 'ºC'),
	(311414, 142, '2015-01-15 00:24:30.000000', 'temperatura', 224.0000, 'ºC'),
	(311415, 142, '2015-01-15 00:24:31.000000', 'temperatura', 1110.0000, 'ºC'),
	(311416, 142, '2015-01-15 00:24:32.000000', 'temperatura', 79.0000, 'ºC'),
	(311417, 142, '2015-01-15 00:24:33.000000', 'temperatura', 665.0000, 'ºC'),
	(311418, 142, '2015-01-15 00:24:34.000000', 'temperatura', 687.0000, 'ºC'),
	(311419, 142, '2015-01-15 00:24:35.000000', 'temperatura', 242.0000, 'ºC'),
	(311420, 142, '2015-01-15 00:24:36.000000', 'temperatura', 349.0000, 'ºC'),
	(311421, 142, '2015-01-15 00:24:37.000000', 'temperatura', 1021.0000, 'ºC'),
	(311422, 142, '2015-01-15 00:24:38.000000', 'temperatura', 459.0000, 'ºC'),
	(311423, 142, '2015-01-15 00:24:39.000000', 'temperatura', 432.0000, 'ºC'),
	(311424, 142, '2015-01-15 00:24:40.000000', 'temperatura', 782.0000, 'ºC'),
	(311425, 142, '2015-01-15 00:24:41.000000', 'temperatura', 214.0000, 'ºC'),
	(311426, 142, '2015-01-15 00:24:42.000000', 'temperatura', 1124.0000, 'ºC'),
	(311427, 142, '2015-01-15 00:24:43.000000', 'temperatura', 179.0000, 'ºC'),
	(311428, 142, '2015-01-15 00:24:44.000000', 'temperatura', 1125.0000, 'ºC'),
	(311429, 142, '2015-01-15 00:24:45.000000', 'temperatura', 286.0000, 'ºC'),
	(311430, 142, '2015-01-15 00:24:46.000000', 'temperatura', 457.0000, 'ºC'),
	(311431, 142, '2015-01-15 00:24:47.000000', 'temperatura', 226.0000, 'ºC'),
	(311432, 142, '2015-01-15 00:24:48.000000', 'temperatura', 962.0000, 'ºC'),
	(311433, 142, '2015-01-15 00:24:49.000000', 'temperatura', 531.0000, 'ºC'),
	(311434, 142, '2015-01-15 00:24:50.000000', 'temperatura', 971.0000, 'ºC'),
	(311435, 142, '2015-01-15 00:24:51.000000', 'temperatura', 863.0000, 'ºC'),
	(311436, 142, '2015-01-15 00:24:52.000000', 'temperatura', 201.0000, 'ºC'),
	(311437, 142, '2015-01-15 00:24:53.000000', 'temperatura', 816.0000, 'ºC'),
	(311438, 142, '2015-01-15 00:24:54.000000', 'temperatura', 1078.0000, 'ºC'),
	(311439, 142, '2015-01-15 00:24:55.000000', 'temperatura', 544.0000, 'ºC'),
	(311440, 142, '2015-01-15 00:24:56.000000', 'temperatura', 686.0000, 'ºC'),
	(311441, 142, '2015-01-15 00:24:57.000000', 'temperatura', 600.0000, 'ºC'),
	(311442, 142, '2015-01-15 00:24:58.000000', 'temperatura', 940.0000, 'ºC'),
	(311443, 142, '2015-01-15 00:24:59.000000', 'temperatura', 502.0000, 'ºC'),
	(311444, 142, '2015-01-15 00:25:00.000000', 'temperatura', 892.0000, 'ºC'),
	(311445, 142, '2015-01-15 00:25:01.000000', 'temperatura', 553.0000, 'ºC'),
	(311446, 142, '2015-01-15 00:25:02.000000', 'temperatura', 89.0000, 'ºC'),
	(311447, 142, '2015-01-15 00:25:03.000000', 'temperatura', 1185.0000, 'ºC'),
	(311448, 142, '2015-01-15 00:25:04.000000', 'temperatura', 859.0000, 'ºC'),
	(311449, 142, '2015-01-15 00:25:05.000000', 'temperatura', 741.0000, 'ºC'),
	(311450, 142, '2015-01-15 00:25:06.000000', 'temperatura', 1129.0000, 'ºC'),
	(311451, 142, '2015-01-15 00:25:07.000000', 'temperatura', 1021.0000, 'ºC'),
	(311452, 142, '2015-01-15 00:25:08.000000', 'temperatura', 519.0000, 'ºC'),
	(311453, 142, '2015-01-15 00:25:09.000000', 'temperatura', 734.0000, 'ºC'),
	(311454, 142, '2015-01-15 00:25:10.000000', 'temperatura', 912.0000, 'ºC'),
	(311455, 142, '2015-01-15 00:25:11.000000', 'temperatura', 1160.0000, 'ºC'),
	(311456, 142, '2015-01-15 00:25:12.000000', 'temperatura', 664.0000, 'ºC'),
	(311457, 142, '2015-01-15 00:25:13.000000', 'temperatura', 1039.0000, 'ºC'),
	(311458, 142, '2015-01-15 00:25:14.000000', 'temperatura', 804.0000, 'ºC'),
	(311459, 142, '2015-01-15 00:25:15.000000', 'temperatura', 903.0000, 'ºC'),
	(311460, 142, '2015-01-15 00:25:16.000000', 'temperatura', 904.0000, 'ºC'),
	(311461, 142, '2015-01-15 00:25:17.000000', 'temperatura', 611.0000, 'ºC'),
	(311462, 142, '2015-01-15 00:25:18.000000', 'temperatura', 342.0000, 'ºC'),
	(311463, 142, '2015-01-15 00:25:19.000000', 'temperatura', 1078.0000, 'ºC'),
	(311464, 142, '2015-01-15 00:25:20.000000', 'temperatura', 765.0000, 'ºC'),
	(311465, 142, '2015-01-15 00:25:21.000000', 'temperatura', 590.0000, 'ºC'),
	(311466, 142, '2015-01-15 00:25:22.000000', 'temperatura', 655.0000, 'ºC'),
	(311467, 142, '2015-01-15 00:25:23.000000', 'temperatura', 307.0000, 'ºC'),
	(311468, 142, '2015-01-15 00:25:24.000000', 'temperatura', 769.0000, 'ºC'),
	(311469, 142, '2015-01-15 00:25:25.000000', 'temperatura', 524.0000, 'ºC'),
	(311470, 142, '2015-01-15 00:25:26.000000', 'temperatura', 313.0000, 'ºC'),
	(311471, 142, '2015-01-15 00:25:27.000000', 'temperatura', 1197.0000, 'ºC'),
	(311472, 142, '2015-01-15 00:25:28.000000', 'temperatura', 243.0000, 'ºC'),
	(311473, 142, '2015-01-15 00:25:29.000000', 'temperatura', 24.0000, 'ºC'),
	(311474, 142, '2015-01-15 00:25:30.000000', 'temperatura', 594.0000, 'ºC'),
	(311475, 142, '2015-01-15 00:25:31.000000', 'temperatura', 496.0000, 'ºC'),
	(311476, 142, '2015-01-15 00:25:32.000000', 'temperatura', 698.0000, 'ºC'),
	(311477, 142, '2015-01-15 00:25:33.000000', 'temperatura', 803.0000, 'ºC'),
	(311478, 142, '2015-01-15 00:25:34.000000', 'temperatura', 722.0000, 'ºC'),
	(311479, 142, '2015-01-15 00:25:35.000000', 'temperatura', 3.0000, 'ºC'),
	(311480, 142, '2015-01-15 00:25:36.000000', 'temperatura', 249.0000, 'ºC'),
	(311481, 142, '2015-01-15 00:25:37.000000', 'temperatura', 36.0000, 'ºC'),
	(311482, 142, '2015-01-15 00:25:38.000000', 'temperatura', 632.0000, 'ºC'),
	(311483, 142, '2015-01-15 00:25:39.000000', 'temperatura', 653.0000, 'ºC'),
	(311484, 142, '2015-01-15 00:25:40.000000', 'temperatura', 169.0000, 'ºC'),
	(311485, 142, '2015-01-15 00:25:41.000000', 'temperatura', 88.0000, 'ºC'),
	(311486, 142, '2015-01-15 00:25:42.000000', 'temperatura', 1133.0000, 'ºC'),
	(311487, 142, '2015-01-15 00:25:43.000000', 'temperatura', 604.0000, 'ºC'),
	(311488, 142, '2015-01-15 00:25:44.000000', 'temperatura', 818.0000, 'ºC'),
	(311489, 142, '2015-01-15 00:25:45.000000', 'temperatura', 1078.0000, 'ºC'),
	(311490, 142, '2015-01-15 00:25:46.000000', 'temperatura', 539.0000, 'ºC'),
	(311491, 142, '2015-01-15 00:25:47.000000', 'temperatura', 662.0000, 'ºC'),
	(311492, 142, '2015-01-15 00:25:48.000000', 'temperatura', 493.0000, 'ºC'),
	(311493, 142, '2015-01-15 00:25:49.000000', 'temperatura', 480.0000, 'ºC'),
	(311494, 142, '2015-01-15 00:25:50.000000', 'temperatura', 921.0000, 'ºC'),
	(311495, 142, '2015-01-15 00:25:51.000000', 'temperatura', 765.0000, 'ºC'),
	(311496, 142, '2015-01-15 00:25:52.000000', 'temperatura', 1064.0000, 'ºC'),
	(311497, 142, '2015-01-15 00:25:53.000000', 'temperatura', 624.0000, 'ºC'),
	(311498, 142, '2015-01-15 00:25:54.000000', 'temperatura', 1130.0000, 'ºC'),
	(311499, 142, '2015-01-15 00:25:55.000000', 'temperatura', 178.0000, 'ºC'),
	(311500, 142, '2015-01-15 00:25:56.000000', 'temperatura', 1101.0000, 'ºC'),
	(311501, 142, '2015-01-15 00:25:57.000000', 'temperatura', 169.0000, 'ºC'),
	(311502, 142, '2015-01-15 00:25:58.000000', 'temperatura', 1145.0000, 'ºC'),
	(311503, 142, '2015-01-15 00:25:59.000000', 'temperatura', 420.0000, 'ºC'),
	(311504, 142, '2015-01-15 00:26:00.000000', 'temperatura', 1062.0000, 'ºC'),
	(311505, 142, '2015-01-15 00:26:01.000000', 'temperatura', 453.0000, 'ºC'),
	(311506, 142, '2015-01-15 00:26:02.000000', 'temperatura', 278.0000, 'ºC'),
	(311507, 142, '2015-01-15 00:26:03.000000', 'temperatura', 34.0000, 'ºC'),
	(311508, 142, '2015-01-15 00:26:04.000000', 'temperatura', 534.0000, 'ºC'),
	(311509, 142, '2015-01-15 00:26:05.000000', 'temperatura', 169.0000, 'ºC'),
	(311510, 142, '2015-01-15 00:26:06.000000', 'temperatura', 443.0000, 'ºC'),
	(311511, 142, '2015-01-15 00:26:07.000000', 'temperatura', 510.0000, 'ºC'),
	(311512, 142, '2015-01-15 00:26:08.000000', 'temperatura', 21.0000, 'ºC'),
	(311513, 142, '2015-01-15 00:26:09.000000', 'temperatura', 976.0000, 'ºC'),
	(311514, 142, '2015-01-15 00:26:10.000000', 'temperatura', 16.0000, 'ºC'),
	(311515, 142, '2015-01-15 00:26:11.000000', 'temperatura', 755.0000, 'ºC'),
	(311516, 142, '2015-01-15 00:26:12.000000', 'temperatura', 126.0000, 'ºC'),
	(311517, 142, '2015-01-15 00:26:13.000000', 'temperatura', 767.0000, 'ºC'),
	(311518, 142, '2015-01-15 00:26:14.000000', 'temperatura', 1056.0000, 'ºC'),
	(311519, 142, '2015-01-15 00:26:15.000000', 'temperatura', 580.0000, 'ºC'),
	(311520, 142, '2015-01-15 00:26:16.000000', 'temperatura', 930.0000, 'ºC'),
	(311521, 142, '2015-01-15 00:26:17.000000', 'temperatura', 514.0000, 'ºC'),
	(311522, 142, '2015-01-15 00:26:18.000000', 'temperatura', 977.0000, 'ºC'),
	(311523, 142, '2015-01-15 00:26:19.000000', 'temperatura', 947.0000, 'ºC'),
	(311524, 142, '2015-01-15 00:26:20.000000', 'temperatura', 604.0000, 'ºC'),
	(311525, 142, '2015-01-15 00:26:21.000000', 'temperatura', 177.0000, 'ºC'),
	(311526, 142, '2015-01-15 00:26:22.000000', 'temperatura', 274.0000, 'ºC'),
	(311527, 142, '2015-01-15 00:26:23.000000', 'temperatura', 840.0000, 'ºC'),
	(311528, 142, '2015-01-15 00:26:24.000000', 'temperatura', 979.0000, 'ºC'),
	(311529, 142, '2015-01-15 00:26:25.000000', 'temperatura', 1176.0000, 'ºC'),
	(311530, 142, '2015-01-15 00:26:26.000000', 'temperatura', 544.0000, 'ºC'),
	(311531, 142, '2015-01-15 00:26:27.000000', 'temperatura', 394.0000, 'ºC'),
	(311532, 142, '2015-01-15 00:26:28.000000', 'temperatura', 336.0000, 'ºC'),
	(311533, 142, '2015-01-15 00:26:29.000000', 'temperatura', 498.0000, 'ºC'),
	(311534, 142, '2015-01-15 00:26:30.000000', 'temperatura', 282.0000, 'ºC'),
	(311535, 142, '2015-01-15 00:26:31.000000', 'temperatura', 1117.0000, 'ºC'),
	(311536, 142, '2015-01-15 00:26:32.000000', 'temperatura', 1141.0000, 'ºC'),
	(311537, 142, '2015-01-15 00:26:33.000000', 'temperatura', 1156.0000, 'ºC'),
	(311538, 142, '2015-01-15 00:26:34.000000', 'temperatura', 1155.0000, 'ºC'),
	(311539, 142, '2015-01-15 00:26:35.000000', 'temperatura', 1107.0000, 'ºC'),
	(311540, 142, '2015-01-15 00:26:36.000000', 'temperatura', 872.0000, 'ºC'),
	(311541, 142, '2015-01-15 00:26:37.000000', 'temperatura', 1038.0000, 'ºC'),
	(311542, 142, '2015-01-15 00:26:38.000000', 'temperatura', 176.0000, 'ºC'),
	(311543, 142, '2015-01-15 00:26:39.000000', 'temperatura', 164.0000, 'ºC'),
	(311544, 142, '2015-01-15 00:26:40.000000', 'temperatura', 294.0000, 'ºC'),
	(311545, 142, '2015-01-15 00:26:41.000000', 'temperatura', 980.0000, 'ºC'),
	(311546, 142, '2015-01-15 00:26:42.000000', 'temperatura', 416.0000, 'ºC'),
	(311547, 142, '2015-01-15 00:26:43.000000', 'temperatura', 342.0000, 'ºC'),
	(311548, 142, '2015-01-15 00:26:44.000000', 'temperatura', 462.0000, 'ºC'),
	(311549, 142, '2015-01-15 00:26:45.000000', 'temperatura', 86.0000, 'ºC'),
	(311550, 142, '2015-01-15 00:26:46.000000', 'temperatura', 245.0000, 'ºC'),
	(311551, 142, '2015-01-15 00:26:47.000000', 'temperatura', 965.0000, 'ºC'),
	(311552, 142, '2015-01-15 00:26:48.000000', 'temperatura', 493.0000, 'ºC'),
	(311553, 142, '2015-01-15 00:26:49.000000', 'temperatura', 767.0000, 'ºC'),
	(311554, 142, '2015-01-15 00:26:50.000000', 'temperatura', 1160.0000, 'ºC'),
	(311555, 142, '2015-01-15 00:26:51.000000', 'temperatura', 1100.0000, 'ºC'),
	(311556, 142, '2015-01-15 00:26:52.000000', 'temperatura', 818.0000, 'ºC'),
	(311557, 142, '2015-01-15 00:26:53.000000', 'temperatura', 791.0000, 'ºC'),
	(311558, 142, '2015-01-15 00:26:54.000000', 'temperatura', 303.0000, 'ºC'),
	(311559, 142, '2015-01-15 00:26:55.000000', 'temperatura', 342.0000, 'ºC'),
	(311560, 142, '2015-01-15 00:26:56.000000', 'temperatura', 802.0000, 'ºC'),
	(311561, 142, '2015-01-15 00:26:57.000000', 'temperatura', 584.0000, 'ºC'),
	(311562, 142, '2015-01-15 00:26:58.000000', 'temperatura', 516.0000, 'ºC'),
	(311563, 142, '2015-01-15 00:26:59.000000', 'temperatura', 826.0000, 'ºC'),
	(311564, 142, '2015-01-15 00:27:00.000000', 'temperatura', 185.0000, 'ºC'),
	(311565, 142, '2015-01-15 00:27:01.000000', 'temperatura', 844.0000, 'ºC'),
	(311566, 142, '2015-01-15 00:27:02.000000', 'temperatura', 69.0000, 'ºC'),
	(311567, 142, '2015-01-15 00:27:03.000000', 'temperatura', 213.0000, 'ºC'),
	(311568, 142, '2015-01-15 00:27:04.000000', 'temperatura', 859.0000, 'ºC'),
	(311569, 142, '2015-01-15 00:27:05.000000', 'temperatura', 55.0000, 'ºC'),
	(311570, 142, '2015-01-15 00:27:06.000000', 'temperatura', 99.0000, 'ºC'),
	(311571, 142, '2015-01-15 00:27:07.000000', 'temperatura', 331.0000, 'ºC'),
	(311572, 142, '2015-01-15 00:27:08.000000', 'temperatura', 156.0000, 'ºC'),
	(311573, 142, '2015-01-15 00:27:09.000000', 'temperatura', 990.0000, 'ºC'),
	(311574, 142, '2015-01-15 00:27:10.000000', 'temperatura', 883.0000, 'ºC'),
	(311575, 142, '2015-01-15 00:27:11.000000', 'temperatura', 243.0000, 'ºC'),
	(311576, 142, '2015-01-15 00:27:12.000000', 'temperatura', 970.0000, 'ºC'),
	(311577, 142, '2015-01-15 00:27:13.000000', 'temperatura', 519.0000, 'ºC'),
	(311578, 142, '2015-01-15 00:27:14.000000', 'temperatura', 884.0000, 'ºC'),
	(311579, 142, '2015-01-15 00:27:15.000000', 'temperatura', 466.0000, 'ºC'),
	(311580, 142, '2015-01-15 00:27:16.000000', 'temperatura', 879.0000, 'ºC'),
	(311581, 142, '2015-01-15 00:27:17.000000', 'temperatura', 595.0000, 'ºC'),
	(311582, 142, '2015-01-15 00:27:18.000000', 'temperatura', 338.0000, 'ºC'),
	(311583, 142, '2015-01-15 00:27:19.000000', 'temperatura', 1105.0000, 'ºC'),
	(311584, 142, '2015-01-15 00:27:20.000000', 'temperatura', 913.0000, 'ºC'),
	(311585, 142, '2015-01-15 00:27:21.000000', 'temperatura', 51.0000, 'ºC'),
	(311586, 142, '2015-01-15 00:27:22.000000', 'temperatura', 1116.0000, 'ºC'),
	(311587, 142, '2015-01-15 00:27:23.000000', 'temperatura', 629.0000, 'ºC'),
	(311588, 142, '2015-01-15 00:27:24.000000', 'temperatura', 998.0000, 'ºC'),
	(311589, 142, '2015-01-15 00:27:25.000000', 'temperatura', 704.0000, 'ºC'),
	(311590, 142, '2015-01-15 00:27:26.000000', 'temperatura', 525.0000, 'ºC'),
	(311591, 142, '2015-01-15 00:27:27.000000', 'temperatura', 516.0000, 'ºC'),
	(311592, 142, '2015-01-15 00:27:28.000000', 'temperatura', 1003.0000, 'ºC'),
	(311593, 142, '2015-01-15 00:27:29.000000', 'temperatura', 1070.0000, 'ºC'),
	(311594, 142, '2015-01-15 00:27:30.000000', 'temperatura', 1140.0000, 'ºC'),
	(311595, 142, '2015-01-15 00:27:31.000000', 'temperatura', 91.0000, 'ºC'),
	(311596, 142, '2015-01-15 00:27:32.000000', 'temperatura', 637.0000, 'ºC'),
	(311597, 142, '2015-01-15 00:27:33.000000', 'temperatura', 510.0000, 'ºC'),
	(311598, 142, '2015-01-15 00:27:34.000000', 'temperatura', 641.0000, 'ºC'),
	(311599, 142, '2015-01-15 00:27:35.000000', 'temperatura', 473.0000, 'ºC'),
	(311600, 142, '2015-01-15 00:27:36.000000', 'temperatura', 444.0000, 'ºC'),
	(311601, 142, '2015-01-15 00:27:37.000000', 'temperatura', 801.0000, 'ºC'),
	(311602, 142, '2015-01-15 00:27:38.000000', 'temperatura', 272.0000, 'ºC'),
	(311603, 142, '2015-01-15 00:27:39.000000', 'temperatura', 159.0000, 'ºC'),
	(311604, 142, '2015-01-15 00:27:40.000000', 'temperatura', 1179.0000, 'ºC'),
	(311605, 142, '2015-01-15 00:27:41.000000', 'temperatura', 617.0000, 'ºC'),
	(311606, 142, '2015-01-15 00:27:42.000000', 'temperatura', 752.0000, 'ºC'),
	(311607, 142, '2015-01-15 00:27:43.000000', 'temperatura', 706.0000, 'ºC'),
	(311608, 142, '2015-01-15 00:27:44.000000', 'temperatura', 76.0000, 'ºC'),
	(311609, 142, '2015-01-15 00:27:45.000000', 'temperatura', 661.0000, 'ºC'),
	(311610, 142, '2015-01-15 00:27:46.000000', 'temperatura', 678.0000, 'ºC'),
	(311611, 142, '2015-01-15 00:27:47.000000', 'temperatura', 209.0000, 'ºC'),
	(311612, 142, '2015-01-15 00:27:48.000000', 'temperatura', 212.0000, 'ºC'),
	(311613, 142, '2015-01-15 00:27:49.000000', 'temperatura', 431.0000, 'ºC'),
	(311614, 142, '2015-01-15 00:27:50.000000', 'temperatura', 319.0000, 'ºC'),
	(311615, 142, '2015-01-15 00:27:51.000000', 'temperatura', 305.0000, 'ºC'),
	(311616, 142, '2015-01-15 00:27:52.000000', 'temperatura', 568.0000, 'ºC'),
	(311617, 142, '2015-01-15 00:27:53.000000', 'temperatura', 725.0000, 'ºC'),
	(311618, 142, '2015-01-15 00:27:54.000000', 'temperatura', 722.0000, 'ºC'),
	(311619, 142, '2015-01-15 00:27:55.000000', 'temperatura', 236.0000, 'ºC'),
	(311620, 142, '2015-01-15 00:27:56.000000', 'temperatura', 212.0000, 'ºC'),
	(311621, 142, '2015-01-15 00:27:57.000000', 'temperatura', 353.0000, 'ºC'),
	(311622, 142, '2015-01-15 00:27:58.000000', 'temperatura', 1131.0000, 'ºC'),
	(311623, 142, '2015-01-15 00:27:59.000000', 'temperatura', 998.0000, 'ºC'),
	(311624, 142, '2015-01-15 00:28:00.000000', 'temperatura', 396.0000, 'ºC'),
	(311625, 142, '2015-01-15 00:28:01.000000', 'temperatura', 185.0000, 'ºC'),
	(311626, 142, '2015-01-15 00:28:02.000000', 'temperatura', 938.0000, 'ºC'),
	(311627, 142, '2015-01-15 00:28:03.000000', 'temperatura', 536.0000, 'ºC'),
	(311628, 142, '2015-01-15 00:28:04.000000', 'temperatura', 1067.0000, 'ºC'),
	(311629, 142, '2015-01-15 00:28:05.000000', 'temperatura', 129.0000, 'ºC'),
	(311630, 142, '2015-01-15 00:28:06.000000', 'temperatura', 1041.0000, 'ºC'),
	(311631, 142, '2015-01-15 00:28:07.000000', 'temperatura', 22.0000, 'ºC'),
	(311632, 142, '2015-01-15 00:28:08.000000', 'temperatura', 586.0000, 'ºC'),
	(311633, 142, '2015-01-15 00:28:09.000000', 'temperatura', 467.0000, 'ºC'),
	(311634, 142, '2015-01-15 00:28:10.000000', 'temperatura', 574.0000, 'ºC'),
	(311635, 142, '2015-01-15 00:28:11.000000', 'temperatura', 273.0000, 'ºC'),
	(311636, 142, '2015-01-15 00:28:12.000000', 'temperatura', 841.0000, 'ºC'),
	(311637, 142, '2015-01-15 00:28:13.000000', 'temperatura', 986.0000, 'ºC'),
	(311638, 142, '2015-01-15 00:28:14.000000', 'temperatura', 7.0000, 'ºC'),
	(311639, 142, '2015-01-15 00:28:15.000000', 'temperatura', 678.0000, 'ºC'),
	(311640, 142, '2015-01-15 00:28:16.000000', 'temperatura', 968.0000, 'ºC'),
	(311641, 142, '2015-01-15 00:28:17.000000', 'temperatura', 410.0000, 'ºC'),
	(311642, 142, '2015-01-15 00:28:18.000000', 'temperatura', 343.0000, 'ºC'),
	(311643, 142, '2015-01-15 00:28:19.000000', 'temperatura', 487.0000, 'ºC'),
	(311644, 142, '2015-01-15 00:28:20.000000', 'temperatura', 205.0000, 'ºC'),
	(311645, 142, '2015-01-15 00:28:21.000000', 'temperatura', 764.0000, 'ºC'),
	(311646, 142, '2015-01-15 00:28:22.000000', 'temperatura', 806.0000, 'ºC'),
	(311647, 142, '2015-01-15 00:28:23.000000', 'temperatura', 539.0000, 'ºC'),
	(311648, 142, '2015-01-15 00:28:24.000000', 'temperatura', 279.0000, 'ºC'),
	(311649, 142, '2015-01-15 00:28:25.000000', 'temperatura', 976.0000, 'ºC'),
	(311650, 142, '2015-01-15 00:28:26.000000', 'temperatura', 444.0000, 'ºC'),
	(311651, 142, '2015-01-15 00:28:27.000000', 'temperatura', 491.0000, 'ºC'),
	(311652, 142, '2015-01-15 00:28:28.000000', 'temperatura', 1123.0000, 'ºC'),
	(311653, 142, '2015-01-15 00:28:29.000000', 'temperatura', 546.0000, 'ºC'),
	(311654, 142, '2015-01-15 00:28:30.000000', 'temperatura', 558.0000, 'ºC'),
	(311655, 142, '2015-01-15 00:28:31.000000', 'temperatura', 1153.0000, 'ºC'),
	(311656, 142, '2015-01-15 00:28:32.000000', 'temperatura', 494.0000, 'ºC'),
	(311657, 142, '2015-01-15 00:28:33.000000', 'temperatura', 211.0000, 'ºC'),
	(311658, 142, '2015-01-15 00:28:34.000000', 'temperatura', 774.0000, 'ºC'),
	(311659, 142, '2015-01-15 00:28:35.000000', 'temperatura', 835.0000, 'ºC'),
	(311660, 142, '2015-01-15 00:28:36.000000', 'temperatura', 655.0000, 'ºC'),
	(311661, 142, '2015-01-15 00:28:37.000000', 'temperatura', 772.0000, 'ºC'),
	(311662, 142, '2015-01-15 00:28:38.000000', 'temperatura', 694.0000, 'ºC'),
	(311663, 142, '2015-01-15 00:28:39.000000', 'temperatura', 1153.0000, 'ºC'),
	(311664, 142, '2015-01-15 00:28:40.000000', 'temperatura', 85.0000, 'ºC'),
	(311665, 142, '2015-01-15 00:28:41.000000', 'temperatura', 567.0000, 'ºC'),
	(311666, 142, '2015-01-15 00:28:42.000000', 'temperatura', 181.0000, 'ºC'),
	(311667, 142, '2015-01-15 00:28:43.000000', 'temperatura', 405.0000, 'ºC'),
	(311668, 142, '2015-01-15 00:28:44.000000', 'temperatura', 282.0000, 'ºC'),
	(311669, 142, '2015-01-15 00:28:45.000000', 'temperatura', 193.0000, 'ºC'),
	(311670, 142, '2015-01-15 00:28:46.000000', 'temperatura', 123.0000, 'ºC'),
	(311671, 142, '2015-01-15 00:28:47.000000', 'temperatura', 35.0000, 'ºC'),
	(311672, 142, '2015-01-15 00:28:48.000000', 'temperatura', 1007.0000, 'ºC'),
	(311673, 142, '2015-01-15 00:28:49.000000', 'temperatura', 129.0000, 'ºC'),
	(311674, 142, '2015-01-15 00:28:50.000000', 'temperatura', 24.0000, 'ºC'),
	(311675, 142, '2015-01-15 00:28:51.000000', 'temperatura', 933.0000, 'ºC'),
	(311676, 142, '2015-01-15 00:28:52.000000', 'temperatura', 993.0000, 'ºC'),
	(311677, 142, '2015-01-15 00:28:53.000000', 'temperatura', 967.0000, 'ºC'),
	(311678, 142, '2015-01-15 00:28:54.000000', 'temperatura', 656.0000, 'ºC'),
	(311679, 142, '2015-01-15 00:28:55.000000', 'temperatura', 381.0000, 'ºC'),
	(311680, 142, '2015-01-15 00:28:56.000000', 'temperatura', 1137.0000, 'ºC'),
	(311681, 142, '2015-01-15 00:28:57.000000', 'temperatura', 941.0000, 'ºC'),
	(311682, 142, '2015-01-15 00:28:58.000000', 'temperatura', 95.0000, 'ºC'),
	(311683, 142, '2015-01-15 00:28:59.000000', 'temperatura', 51.0000, 'ºC'),
	(311684, 142, '2015-01-15 00:29:00.000000', 'temperatura', 1171.0000, 'ºC'),
	(311685, 142, '2015-01-15 00:29:01.000000', 'temperatura', 904.0000, 'ºC'),
	(311686, 142, '2015-01-15 00:29:02.000000', 'temperatura', 1007.0000, 'ºC'),
	(311687, 142, '2015-01-15 00:29:03.000000', 'temperatura', 1124.0000, 'ºC'),
	(311688, 142, '2015-01-15 00:29:04.000000', 'temperatura', 198.0000, 'ºC'),
	(311689, 142, '2015-01-15 00:29:05.000000', 'temperatura', 21.0000, 'ºC'),
	(311690, 142, '2015-01-15 00:29:06.000000', 'temperatura', 710.0000, 'ºC'),
	(311691, 142, '2015-01-15 00:29:07.000000', 'temperatura', 1087.0000, 'ºC'),
	(311692, 142, '2015-01-15 00:29:08.000000', 'temperatura', 907.0000, 'ºC'),
	(311693, 142, '2015-01-15 00:29:09.000000', 'temperatura', 76.0000, 'ºC'),
	(311694, 142, '2015-01-15 00:29:10.000000', 'temperatura', 56.0000, 'ºC'),
	(311695, 142, '2015-01-15 00:29:11.000000', 'temperatura', 54.0000, 'ºC'),
	(311696, 142, '2015-01-15 00:29:12.000000', 'temperatura', 102.0000, 'ºC'),
	(311697, 142, '2015-01-15 00:29:13.000000', 'temperatura', 350.0000, 'ºC'),
	(311698, 142, '2015-01-15 00:29:14.000000', 'temperatura', 244.0000, 'ºC'),
	(311699, 142, '2015-01-15 00:29:15.000000', 'temperatura', 170.0000, 'ºC'),
	(311700, 142, '2015-01-15 00:29:16.000000', 'temperatura', 118.0000, 'ºC'),
	(311701, 142, '2015-01-15 00:29:17.000000', 'temperatura', 81.0000, 'ºC'),
	(311702, 142, '2015-01-15 00:29:18.000000', 'temperatura', 52.0000, 'ºC'),
	(311703, 142, '2015-01-15 00:29:19.000000', 'temperatura', 17.0000, 'ºC'),
	(311704, 142, '2015-01-15 00:29:20.000000', 'temperatura', 1131.0000, 'ºC'),
	(311705, 142, '2015-01-15 00:29:21.000000', 'temperatura', 802.0000, 'ºC'),
	(311706, 142, '2015-01-15 00:29:22.000000', 'temperatura', 618.0000, 'ºC'),
	(311707, 142, '2015-01-15 00:29:23.000000', 'temperatura', 687.0000, 'ºC'),
	(311708, 142, '2015-01-15 00:29:24.000000', 'temperatura', 380.0000, 'ºC'),
	(311709, 142, '2015-01-15 00:29:25.000000', 'temperatura', 1038.0000, 'ºC'),
	(311710, 142, '2015-01-15 00:29:26.000000', 'temperatura', 451.0000, 'ºC'),
	(311711, 142, '2015-01-15 00:29:27.000000', 'temperatura', 341.0000, 'ºC'),
	(311712, 142, '2015-01-15 00:29:28.000000', 'temperatura', 352.0000, 'ºC'),
	(311713, 142, '2015-01-15 00:29:29.000000', 'temperatura', 739.0000, 'ºC'),
	(311714, 142, '2015-01-15 00:29:30.000000', 'temperatura', 240.0000, 'ºC'),
	(311715, 142, '2015-01-15 00:29:31.000000', 'temperatura', 185.0000, 'ºC'),
	(311716, 142, '2015-01-15 00:29:32.000000', 'temperatura', 203.0000, 'ºC'),
	(311717, 142, '2015-01-15 00:29:33.000000', 'temperatura', 460.0000, 'ºC'),
	(311718, 142, '2015-01-15 00:29:34.000000', 'temperatura', 492.0000, 'ºC'),
	(311719, 142, '2015-01-15 00:29:35.000000', 'temperatura', 1082.0000, 'ºC'),
	(311720, 142, '2015-01-15 00:29:36.000000', 'temperatura', 335.0000, 'ºC'),
	(311721, 142, '2015-01-15 00:29:37.000000', 'temperatura', 827.0000, 'ºC'),
	(311722, 142, '2015-01-15 00:29:38.000000', 'temperatura', 731.0000, 'ºC'),
	(311723, 142, '2015-01-15 00:29:39.000000', 'temperatura', 1176.0000, 'ºC'),
	(311724, 142, '2015-01-15 00:29:40.000000', 'temperatura', 85.0000, 'ºC'),
	(311725, 142, '2015-01-15 00:29:41.000000', 'temperatura', 500.0000, 'ºC'),
	(311726, 142, '2015-01-15 00:29:42.000000', 'temperatura', 1046.0000, 'ºC'),
	(311727, 142, '2015-01-15 00:29:43.000000', 'temperatura', 129.0000, 'ºC'),
	(311728, 142, '2015-01-15 00:29:44.000000', 'temperatura', 1110.0000, 'ºC'),
	(311729, 142, '2015-01-15 00:29:45.000000', 'temperatura', 361.0000, 'ºC'),
	(311730, 142, '2015-01-15 00:29:46.000000', 'temperatura', 877.0000, 'ºC'),
	(311731, 142, '2015-01-15 00:29:47.000000', 'temperatura', 902.0000, 'ºC'),
	(311732, 142, '2015-01-15 00:29:48.000000', 'temperatura', 678.0000, 'ºC'),
	(311733, 142, '2015-01-15 00:29:49.000000', 'temperatura', 687.0000, 'ºC'),
	(311734, 142, '2015-01-15 00:29:50.000000', 'temperatura', 202.0000, 'ºC'),
	(311735, 142, '2015-01-15 00:29:51.000000', 'temperatura', 150.0000, 'ºC'),
	(311736, 142, '2015-01-15 00:29:52.000000', 'temperatura', 141.0000, 'ºC'),
	(311737, 142, '2015-01-15 00:29:53.000000', 'temperatura', 259.0000, 'ºC'),
	(311738, 142, '2015-01-15 00:29:54.000000', 'temperatura', 872.0000, 'ºC'),
	(311739, 142, '2015-01-15 00:29:55.000000', 'temperatura', 1184.0000, 'ºC'),
	(311740, 142, '2015-01-15 00:29:56.000000', 'temperatura', 904.0000, 'ºC'),
	(311741, 142, '2015-01-15 00:29:57.000000', 'temperatura', 969.0000, 'ºC'),
	(311742, 142, '2015-01-15 00:29:58.000000', 'temperatura', 933.0000, 'ºC'),
	(311743, 142, '2015-01-15 00:29:59.000000', 'temperatura', 557.0000, 'ºC'),
	(311744, 142, '2015-01-15 00:30:00.000000', 'temperatura', 1188.0000, 'ºC'),
	(311745, 142, '2015-01-15 00:30:01.000000', 'temperatura', 668.0000, 'ºC'),
	(311746, 142, '2015-01-15 00:30:02.000000', 'temperatura', 977.0000, 'ºC'),
	(311747, 142, '2015-01-15 00:30:03.000000', 'temperatura', 481.0000, 'ºC'),
	(311748, 142, '2015-01-15 00:30:04.000000', 'temperatura', 677.0000, 'ºC'),
	(311749, 142, '2015-01-15 00:30:05.000000', 'temperatura', 741.0000, 'ºC'),
	(311750, 142, '2015-01-15 00:30:06.000000', 'temperatura', 474.0000, 'ºC'),
	(311751, 142, '2015-01-15 00:30:07.000000', 'temperatura', 149.0000, 'ºC'),
	(311752, 142, '2015-01-15 00:30:08.000000', 'temperatura', 523.0000, 'ºC'),
	(311753, 142, '2015-01-15 00:30:09.000000', 'temperatura', 967.0000, 'ºC'),
	(311754, 142, '2015-01-15 00:30:10.000000', 'temperatura', 866.0000, 'ºC'),
	(311755, 142, '2015-01-15 00:30:11.000000', 'temperatura', 232.0000, 'ºC'),
	(311756, 142, '2015-01-15 00:30:12.000000', 'temperatura', 959.0000, 'ºC'),
	(311757, 142, '2015-01-15 00:30:13.000000', 'temperatura', 503.0000, 'ºC'),
	(311758, 142, '2015-01-15 00:30:14.000000', 'temperatura', 837.0000, 'ºC'),
	(311759, 142, '2015-01-15 00:30:15.000000', 'temperatura', 275.0000, 'ºC'),
	(311760, 142, '2015-01-15 00:30:16.000000', 'temperatura', 66.0000, 'ºC'),
	(311761, 142, '2015-01-15 00:30:17.000000', 'temperatura', 704.0000, 'ºC'),
	(311762, 142, '2015-01-15 00:30:18.000000', 'temperatura', 921.0000, 'ºC'),
	(311763, 142, '2015-01-15 00:30:19.000000', 'temperatura', 97.0000, 'ºC'),
	(311764, 142, '2015-01-15 00:30:20.000000', 'temperatura', 121.0000, 'ºC'),
	(311765, 142, '2015-01-15 00:30:21.000000', 'temperatura', 315.0000, 'ºC'),
	(311766, 142, '2015-01-15 00:30:22.000000', 'temperatura', 14.0000, 'ºC'),
	(311767, 142, '2015-01-15 00:30:23.000000', 'temperatura', 325.0000, 'ºC'),
	(311768, 142, '2015-01-15 00:30:24.000000', 'temperatura', 383.0000, 'ºC'),
	(311769, 142, '2015-01-15 00:30:25.000000', 'temperatura', 939.0000, 'ºC'),
	(311770, 142, '2015-01-15 00:30:26.000000', 'temperatura', 1147.0000, 'ºC'),
	(311771, 142, '2015-01-15 00:30:27.000000', 'temperatura', 520.0000, 'ºC'),
	(311772, 142, '2015-01-15 00:30:28.000000', 'temperatura', 359.0000, 'ºC'),
	(311773, 142, '2015-01-15 00:30:29.000000', 'temperatura', 234.0000, 'ºC'),
	(311774, 142, '2015-01-15 00:30:30.000000', 'temperatura', 96.0000, 'ºC'),
	(311775, 142, '2015-01-15 00:30:31.000000', 'temperatura', 977.0000, 'ºC'),
	(311776, 142, '2015-01-15 00:30:32.000000', 'temperatura', 999.0000, 'ºC'),
	(311777, 142, '2015-01-15 00:30:33.000000', 'temperatura', 863.0000, 'ºC'),
	(311778, 142, '2015-01-15 00:30:34.000000', 'temperatura', 118.0000, 'ºC'),
	(311779, 142, '2015-01-15 00:30:35.000000', 'temperatura', 400.0000, 'ºC'),
	(311780, 142, '2015-01-15 00:30:36.000000', 'temperatura', 450.0000, 'ºC'),
	(311781, 142, '2015-01-15 00:30:37.000000', 'temperatura', 1047.0000, 'ºC'),
	(311782, 142, '2015-01-15 00:30:38.000000', 'temperatura', 287.0000, 'ºC'),
	(311783, 142, '2015-01-15 00:30:39.000000', 'temperatura', 695.0000, 'ºC'),
	(311784, 142, '2015-01-15 00:30:40.000000', 'temperatura', 216.0000, 'ºC'),
	(311785, 142, '2015-01-15 00:30:41.000000', 'temperatura', 195.0000, 'ºC'),
	(311786, 142, '2015-01-15 00:30:42.000000', 'temperatura', 328.0000, 'ºC'),
	(311787, 142, '2015-01-15 00:30:43.000000', 'temperatura', 1054.0000, 'ºC'),
	(311788, 142, '2015-01-15 00:30:44.000000', 'temperatura', 689.0000, 'ºC'),
	(311789, 142, '2015-01-15 00:30:45.000000', 'temperatura', 283.0000, 'ºC'),
	(311790, 142, '2015-01-15 00:30:46.000000', 'temperatura', 546.0000, 'ºC'),
	(311791, 142, '2015-01-15 00:30:47.000000', 'temperatura', 683.0000, 'ºC'),
	(311792, 142, '2015-01-15 00:30:48.000000', 'temperatura', 577.0000, 'ºC'),
	(311793, 142, '2015-01-15 00:30:49.000000', 'temperatura', 837.0000, 'ºC'),
	(311794, 142, '2015-01-15 00:30:50.000000', 'temperatura', 55.0000, 'ºC'),
	(311795, 142, '2015-01-15 00:30:51.000000', 'temperatura', 164.0000, 'ºC'),
	(311796, 142, '2015-01-15 00:30:52.000000', 'temperatura', 656.0000, 'ºC'),
	(311797, 142, '2015-01-15 00:30:53.000000', 'temperatura', 387.0000, 'ºC'),
	(311798, 142, '2015-01-15 00:30:54.000000', 'temperatura', 1169.0000, 'ºC'),
	(311799, 142, '2015-01-15 00:30:55.000000', 'temperatura', 1084.0000, 'ºC'),
	(311800, 142, '2015-01-15 00:30:56.000000', 'temperatura', 714.0000, 'ºC'),
	(311801, 142, '2015-01-15 00:30:57.000000', 'temperatura', 318.0000, 'ºC'),
	(311802, 142, '2015-01-15 00:30:58.000000', 'temperatura', 648.0000, 'ºC'),
	(311803, 142, '2015-01-15 00:30:59.000000', 'temperatura', 1087.0000, 'ºC'),
	(311804, 142, '2015-01-15 00:31:00.000000', 'temperatura', 1093.0000, 'ºC'),
	(311805, 142, '2015-01-15 00:31:01.000000', 'temperatura', 1003.0000, 'ºC'),
	(311806, 142, '2015-01-15 00:31:02.000000', 'temperatura', 538.0000, 'ºC'),
	(311807, 142, '2015-01-15 00:31:03.000000', 'temperatura', 882.0000, 'ºC'),
	(311808, 142, '2015-01-15 00:31:04.000000', 'temperatura', 397.0000, 'ºC'),
	(311809, 142, '2015-01-15 00:31:05.000000', 'temperatura', 539.0000, 'ºC'),
	(311810, 142, '2015-01-15 00:31:06.000000', 'temperatura', 304.0000, 'ºC'),
	(311811, 142, '2015-01-15 00:31:07.000000', 'temperatura', 1104.0000, 'ºC'),
	(311812, 142, '2015-01-15 00:31:08.000000', 'temperatura', 1010.0000, 'ºC'),
	(311813, 142, '2015-01-15 00:31:09.000000', 'temperatura', 538.0000, 'ºC'),
	(311814, 142, '2015-01-15 00:31:10.000000', 'temperatura', 858.0000, 'ºC'),
	(311815, 142, '2015-01-15 00:31:11.000000', 'temperatura', 279.0000, 'ºC'),
	(311816, 142, '2015-01-15 00:31:12.000000', 'temperatura', 22.0000, 'ºC'),
	(311817, 142, '2015-01-15 00:31:13.000000', 'temperatura', 473.0000, 'ºC'),
	(311818, 142, '2015-01-15 00:31:14.000000', 'temperatura', 1098.0000, 'ºC'),
	(311819, 142, '2015-01-15 00:31:15.000000', 'temperatura', 474.0000, 'ºC'),
	(311820, 142, '2015-01-15 00:31:16.000000', 'temperatura', 274.0000, 'ºC'),
	(311821, 142, '2015-01-15 00:31:17.000000', 'temperatura', 1151.0000, 'ºC'),
	(311822, 142, '2015-01-15 00:31:18.000000', 'temperatura', 134.0000, 'ºC'),
	(311823, 142, '2015-01-15 00:31:19.000000', 'temperatura', 817.0000, 'ºC'),
	(311824, 142, '2015-01-15 00:31:20.000000', 'temperatura', 84.0000, 'ºC'),
	(311825, 142, '2015-01-15 00:31:21.000000', 'temperatura', 370.0000, 'ºC'),
	(311826, 142, '2015-01-15 00:31:22.000000', 'temperatura', 399.0000, 'ºC'),
	(311827, 142, '2015-01-15 00:31:23.000000', 'temperatura', 886.0000, 'ºC'),
	(311828, 142, '2015-01-15 00:31:24.000000', 'temperatura', 833.0000, 'ºC'),
	(311829, 142, '2015-01-15 00:31:25.000000', 'temperatura', 306.0000, 'ºC'),
	(311830, 142, '2015-01-15 00:31:26.000000', 'temperatura', 232.0000, 'ºC'),
	(311831, 142, '2015-01-15 00:31:27.000000', 'temperatura', 242.0000, 'ºC'),
	(311832, 142, '2015-01-15 00:31:28.000000', 'temperatura', 517.0000, 'ºC'),
	(311833, 142, '2015-01-15 00:31:29.000000', 'temperatura', 658.0000, 'ºC'),
	(311834, 142, '2015-01-15 00:31:30.000000', 'temperatura', 538.0000, 'ºC'),
	(311835, 142, '2015-01-15 00:31:31.000000', 'temperatura', 719.0000, 'ºC'),
	(311836, 142, '2015-01-15 00:31:32.000000', 'temperatura', 780.0000, 'ºC'),
	(311837, 142, '2015-01-15 00:31:33.000000', 'temperatura', 542.0000, 'ºC'),
	(311838, 142, '2015-01-15 00:31:34.000000', 'temperatura', 374.0000, 'ºC'),
	(311839, 142, '2015-01-15 00:31:35.000000', 'temperatura', 242.0000, 'ºC'),
	(311840, 142, '2015-01-15 00:31:36.000000', 'temperatura', 87.0000, 'ºC'),
	(311841, 142, '2015-01-15 00:31:37.000000', 'temperatura', 912.0000, 'ºC'),
	(311842, 142, '2015-01-15 00:31:38.000000', 'temperatura', 698.0000, 'ºC'),
	(311843, 142, '2015-01-15 00:31:39.000000', 'temperatura', 757.0000, 'ºC'),
	(311844, 142, '2015-01-15 00:31:40.000000', 'temperatura', 491.0000, 'ºC'),
	(311845, 142, '2015-01-15 00:31:41.000000', 'temperatura', 183.0000, 'ºC'),
	(311846, 142, '2015-01-15 00:31:42.000000', 'temperatura', 643.0000, 'ºC'),
	(311847, 142, '2015-01-15 00:31:43.000000', 'temperatura', 265.0000, 'ºC'),
	(311848, 142, '2015-01-15 00:31:44.000000', 'temperatura', 598.0000, 'ºC'),
	(311849, 142, '2015-01-15 00:31:45.000000', 'temperatura', 995.0000, 'ºC'),
	(311850, 142, '2015-01-15 00:31:46.000000', 'temperatura', 783.0000, 'ºC'),
	(311851, 142, '2015-01-15 00:31:47.000000', 'temperatura', 931.0000, 'ºC'),
	(311852, 142, '2015-01-15 00:31:48.000000', 'temperatura', 1106.0000, 'ºC'),
	(311853, 142, '2015-01-15 00:31:49.000000', 'temperatura', 339.0000, 'ºC'),
	(311854, 142, '2015-01-15 00:31:50.000000', 'temperatura', 775.0000, 'ºC'),
	(311855, 142, '2015-01-15 00:31:51.000000', 'temperatura', 458.0000, 'ºC'),
	(311856, 142, '2015-01-15 00:31:52.000000', 'temperatura', 1167.0000, 'ºC'),
	(311857, 142, '2015-01-15 00:31:53.000000', 'temperatura', 862.0000, 'ºC'),
	(311858, 142, '2015-01-15 00:31:54.000000', 'temperatura', 809.0000, 'ºC'),
	(311859, 142, '2015-01-15 00:31:55.000000', 'temperatura', 260.0000, 'ºC'),
	(311860, 142, '2015-01-15 00:31:56.000000', 'temperatura', 73.0000, 'ºC'),
	(311861, 142, '2015-01-15 00:31:57.000000', 'temperatura', 787.0000, 'ºC'),
	(311862, 142, '2015-01-15 00:31:58.000000', 'temperatura', 115.0000, 'ºC'),
	(311863, 142, '2015-01-15 00:31:59.000000', 'temperatura', 617.0000, 'ºC'),
	(311864, 142, '2015-01-15 00:32:00.000000', 'temperatura', 339.0000, 'ºC'),
	(311865, 142, '2015-01-15 00:32:01.000000', 'temperatura', 1044.0000, 'ºC'),
	(311866, 142, '2015-01-15 00:32:02.000000', 'temperatura', 605.0000, 'ºC'),
	(311867, 142, '2015-01-15 00:32:03.000000', 'temperatura', 1094.0000, 'ºC'),
	(311868, 142, '2015-01-15 00:32:04.000000', 'temperatura', 56.0000, 'ºC'),
	(311869, 142, '2015-01-15 00:32:05.000000', 'temperatura', 599.0000, 'ºC'),
	(311870, 142, '2015-01-15 00:32:06.000000', 'temperatura', 427.0000, 'ºC'),
	(311871, 142, '2015-01-15 00:32:07.000000', 'temperatura', 337.0000, 'ºC'),
	(311872, 142, '2015-01-15 00:32:08.000000', 'temperatura', 405.0000, 'ºC'),
	(311873, 142, '2015-01-15 00:32:09.000000', 'temperatura', 1013.0000, 'ºC'),
	(311874, 142, '2015-01-15 00:32:10.000000', 'temperatura', 251.0000, 'ºC'),
	(311875, 142, '2015-01-15 00:32:11.000000', 'temperatura', 617.0000, 'ºC'),
	(311876, 142, '2015-01-15 00:32:12.000000', 'temperatura', 1134.0000, 'ºC'),
	(311877, 142, '2015-01-15 00:32:13.000000', 'temperatura', 217.0000, 'ºC'),
	(311878, 142, '2015-01-15 00:32:14.000000', 'temperatura', 83.0000, 'ºC'),
	(311879, 142, '2015-01-15 00:32:15.000000', 'temperatura', 966.0000, 'ºC'),
	(311880, 142, '2015-01-15 00:32:16.000000', 'temperatura', 981.0000, 'ºC'),
	(311881, 142, '2015-01-15 00:32:17.000000', 'temperatura', 809.0000, 'ºC'),
	(311882, 142, '2015-01-15 00:32:18.000000', 'temperatura', 1101.0000, 'ºC'),
	(311883, 142, '2015-01-15 00:32:19.000000', 'temperatura', 681.0000, 'ºC'),
	(311884, 142, '2015-01-15 00:32:20.000000', 'temperatura', 101.0000, 'ºC'),
	(311885, 142, '2015-01-15 00:32:21.000000', 'temperatura', 861.0000, 'ºC'),
	(311886, 142, '2015-01-15 00:32:22.000000', 'temperatura', 402.0000, 'ºC'),
	(311887, 142, '2015-01-15 00:32:23.000000', 'temperatura', 627.0000, 'ºC'),
	(311888, 142, '2015-01-15 00:32:24.000000', 'temperatura', 731.0000, 'ºC'),
	(311889, 142, '2015-01-15 00:32:25.000000', 'temperatura', 574.0000, 'ºC'),
	(311890, 142, '2015-01-15 00:32:26.000000', 'temperatura', 677.0000, 'ºC'),
	(311891, 142, '2015-01-15 00:32:27.000000', 'temperatura', 464.0000, 'ºC'),
	(311892, 142, '2015-01-15 00:32:28.000000', 'temperatura', 292.0000, 'ºC'),
	(311893, 142, '2015-01-15 00:32:29.000000', 'temperatura', 65.0000, 'ºC'),
	(311894, 142, '2015-01-15 00:32:30.000000', 'temperatura', 650.0000, 'ºC'),
	(311895, 142, '2015-01-15 00:32:31.000000', 'temperatura', 656.0000, 'ºC'),
	(311896, 142, '2015-01-15 00:32:32.000000', 'temperatura', 131.0000, 'ºC'),
	(311897, 142, '2015-01-15 00:32:33.000000', 'temperatura', 1088.0000, 'ºC'),
	(311898, 142, '2015-01-15 00:32:34.000000', 'temperatura', 245.0000, 'ºC'),
	(311899, 142, '2015-01-15 00:32:35.000000', 'temperatura', 364.0000, 'ºC'),
	(311900, 142, '2015-01-15 00:32:36.000000', 'temperatura', 1087.0000, 'ºC'),
	(311901, 142, '2015-01-15 00:32:37.000000', 'temperatura', 741.0000, 'ºC'),
	(311902, 142, '2015-01-15 00:32:38.000000', 'temperatura', 443.0000, 'ºC'),
	(311903, 142, '2015-01-15 00:32:39.000000', 'temperatura', 1196.0000, 'ºC'),
	(311904, 142, '2015-01-15 00:32:40.000000', 'temperatura', 1048.0000, 'ºC'),
	(311905, 142, '2015-01-15 00:32:41.000000', 'temperatura', 455.0000, 'ºC'),
	(311906, 142, '2015-01-15 00:32:42.000000', 'temperatura', 330.0000, 'ºC'),
	(311907, 142, '2015-01-15 00:32:43.000000', 'temperatura', 285.0000, 'ºC'),
	(311908, 142, '2015-01-15 00:32:44.000000', 'temperatura', 437.0000, 'ºC'),
	(311909, 142, '2015-01-15 00:32:45.000000', 'temperatura', 132.0000, 'ºC'),
	(311910, 142, '2015-01-15 00:32:46.000000', 'temperatura', 547.0000, 'ºC'),
	(311911, 142, '2015-01-15 00:32:47.000000', 'temperatura', 1139.0000, 'ºC'),
	(311912, 142, '2015-01-15 00:32:48.000000', 'temperatura', 455.0000, 'ºC'),
	(311913, 142, '2015-01-15 00:32:49.000000', 'temperatura', 61.0000, 'ºC'),
	(311914, 142, '2015-01-15 00:32:50.000000', 'temperatura', 137.0000, 'ºC'),
	(311915, 142, '2015-01-15 00:32:51.000000', 'temperatura', 503.0000, 'ºC'),
	(311916, 142, '2015-01-15 00:32:52.000000', 'temperatura', 905.0000, 'ºC'),
	(311917, 142, '2015-01-15 00:32:53.000000', 'temperatura', 618.0000, 'ºC'),
	(311918, 142, '2015-01-15 00:32:54.000000', 'temperatura', 375.0000, 'ºC'),
	(311919, 142, '2015-01-15 00:32:55.000000', 'temperatura', 21.0000, 'ºC'),
	(311920, 142, '2015-01-15 00:32:56.000000', 'temperatura', 181.0000, 'ºC'),
	(311921, 142, '2015-01-15 00:32:57.000000', 'temperatura', 843.0000, 'ºC'),
	(311922, 142, '2015-01-15 00:32:58.000000', 'temperatura', 73.0000, 'ºC'),
	(311923, 142, '2015-01-15 00:32:59.000000', 'temperatura', 237.0000, 'ºC'),
	(311924, 142, '2015-01-15 00:33:00.000000', 'temperatura', 966.0000, 'ºC'),
	(311925, 142, '2015-01-15 00:33:01.000000', 'temperatura', 521.0000, 'ºC'),
	(311926, 142, '2015-01-15 00:33:02.000000', 'temperatura', 907.0000, 'ºC'),
	(311927, 142, '2015-01-15 00:33:03.000000', 'temperatura', 574.0000, 'ºC'),
	(311928, 142, '2015-01-15 00:33:04.000000', 'temperatura', 148.0000, 'ºC'),
	(311929, 142, '2015-01-15 00:33:05.000000', 'temperatura', 217.0000, 'ºC'),
	(311930, 142, '2015-01-15 00:33:06.000000', 'temperatura', 643.0000, 'ºC'),
	(311931, 142, '2015-01-15 00:33:07.000000', 'temperatura', 164.0000, 'ºC'),
	(311932, 142, '2015-01-15 00:33:08.000000', 'temperatura', 90.0000, 'ºC'),
	(311933, 142, '2015-01-15 00:33:09.000000', 'temperatura', 1158.0000, 'ºC'),
	(311934, 142, '2015-01-15 00:33:10.000000', 'temperatura', 721.0000, 'ºC'),
	(311935, 142, '2015-01-15 00:33:11.000000', 'temperatura', 131.0000, 'ºC'),
	(311936, 142, '2015-01-15 00:33:12.000000', 'temperatura', 893.0000, 'ºC'),
	(311937, 142, '2015-01-15 00:33:13.000000', 'temperatura', 475.0000, 'ºC'),
	(311938, 142, '2015-01-15 00:33:14.000000', 'temperatura', 894.0000, 'ºC'),
	(311939, 142, '2015-01-15 00:33:15.000000', 'temperatura', 645.0000, 'ºC'),
	(311940, 142, '2015-01-15 00:33:16.000000', 'temperatura', 543.0000, 'ºC'),
	(311941, 142, '2015-01-15 00:33:17.000000', 'temperatura', 783.0000, 'ºC'),
	(311942, 142, '2015-01-15 00:33:18.000000', 'temperatura', 1087.0000, 'ºC'),
	(311943, 142, '2015-01-15 00:33:19.000000', 'temperatura', 684.0000, 'ºC'),
	(311944, 142, '2015-01-15 00:33:20.000000', 'temperatura', 161.0000, 'ºC'),
	(311945, 142, '2015-01-15 00:33:21.000000', 'temperatura', 1153.0000, 'ºC'),
	(311946, 142, '2015-01-15 00:33:22.000000', 'temperatura', 481.0000, 'ºC'),
	(311947, 142, '2015-01-15 00:33:23.000000', 'temperatura', 149.0000, 'ºC'),
	(311948, 142, '2015-01-15 00:33:24.000000', 'temperatura', 502.0000, 'ºC'),
	(311949, 142, '2015-01-15 00:33:25.000000', 'temperatura', 863.0000, 'ºC'),
	(311950, 142, '2015-01-15 00:33:26.000000', 'temperatura', 411.0000, 'ºC'),
	(311951, 142, '2015-01-15 00:33:27.000000', 'temperatura', 665.0000, 'ºC'),
	(311952, 142, '2015-01-15 00:33:28.000000', 'temperatura', 891.0000, 'ºC'),
	(311953, 142, '2015-01-15 00:33:29.000000', 'temperatura', 62.0000, 'ºC'),
	(311954, 142, '2015-01-15 00:33:30.000000', 'temperatura', 39.0000, 'ºC'),
	(311955, 142, '2015-01-15 00:33:31.000000', 'temperatura', 10.0000, 'ºC'),
	(311956, 142, '2015-01-15 00:33:32.000000', 'temperatura', 1130.0000, 'ºC'),
	(311957, 142, '2015-01-15 00:33:33.000000', 'temperatura', 824.0000, 'ºC'),
	(311958, 142, '2015-01-15 00:33:34.000000', 'temperatura', 730.0000, 'ºC'),
	(311959, 142, '2015-01-15 00:33:35.000000', 'temperatura', 1179.0000, 'ºC'),
	(311960, 142, '2015-01-15 00:33:36.000000', 'temperatura', 103.0000, 'ºC'),
	(311961, 142, '2015-01-15 00:33:37.000000', 'temperatura', 582.0000, 'ºC'),
	(311962, 142, '2015-01-15 00:33:38.000000', 'temperatura', 199.0000, 'ºC'),
	(311963, 142, '2015-01-15 00:33:39.000000', 'temperatura', 449.0000, 'ºC'),
	(311964, 142, '2015-01-15 00:33:40.000000', 'temperatura', 448.0000, 'ºC'),
	(311965, 142, '2015-01-15 00:33:41.000000', 'temperatura', 895.0000, 'ºC'),
	(311966, 142, '2015-01-15 00:33:42.000000', 'temperatura', 730.0000, 'ºC'),
	(311967, 142, '2015-01-15 00:33:43.000000', 'temperatura', 964.0000, 'ºC'),
	(311968, 142, '2015-01-15 00:33:44.000000', 'temperatura', 234.0000, 'ºC'),
	(311969, 142, '2015-01-15 00:33:45.000000', 'temperatura', 676.0000, 'ºC'),
	(311970, 142, '2015-01-15 00:33:46.000000', 'temperatura', 278.0000, 'ºC'),
	(311971, 142, '2015-01-15 00:33:47.000000', 'temperatura', 564.0000, 'ºC'),
	(311972, 142, '2015-01-15 00:33:48.000000', 'temperatura', 785.0000, 'ºC'),
	(311973, 142, '2015-01-15 00:33:49.000000', 'temperatura', 1034.0000, 'ºC'),
	(311974, 142, '2015-01-15 00:33:50.000000', 'temperatura', 416.0000, 'ºC'),
	(311975, 142, '2015-01-15 00:33:51.000000', 'temperatura', 177.0000, 'ºC'),
	(311976, 142, '2015-01-15 00:33:52.000000', 'temperatura', 837.0000, 'ºC'),
	(311977, 142, '2015-01-15 00:33:53.000000', 'temperatura', 54.0000, 'ºC'),
	(311978, 142, '2015-01-15 00:33:54.000000', 'temperatura', 162.0000, 'ºC'),
	(311979, 142, '2015-01-15 00:33:55.000000', 'temperatura', 648.0000, 'ºC'),
	(311980, 142, '2015-01-15 00:33:56.000000', 'temperatura', 353.0000, 'ºC'),
	(311981, 142, '2015-01-15 00:33:57.000000', 'temperatura', 1021.0000, 'ºC'),
	(311982, 142, '2015-01-15 00:33:58.000000', 'temperatura', 448.0000, 'ºC'),
	(311983, 142, '2015-01-15 00:33:59.000000', 'temperatura', 379.0000, 'ºC'),
	(311984, 142, '2015-01-15 00:34:00.000000', 'temperatura', 550.0000, 'ºC'),
	(311985, 142, '2015-01-15 00:34:01.000000', 'temperatura', 414.0000, 'ºC'),
	(311986, 142, '2015-01-15 00:34:02.000000', 'temperatura', 422.0000, 'ºC'),
	(311987, 142, '2015-01-15 00:34:03.000000', 'temperatura', 866.0000, 'ºC'),
	(311988, 142, '2015-01-15 00:34:04.000000', 'temperatura', 665.0000, 'ºC'),
	(311989, 142, '2015-01-15 00:34:05.000000', 'temperatura', 729.0000, 'ºC'),
	(311990, 142, '2015-01-15 00:34:06.000000', 'temperatura', 450.0000, 'ºC'),
	(311991, 142, '2015-01-15 00:34:07.000000', 'temperatura', 62.0000, 'ºC'),
	(311992, 142, '2015-01-15 00:34:08.000000', 'temperatura', 163.0000, 'ºC'),
	(311993, 142, '2015-01-15 00:34:09.000000', 'temperatura', 628.0000, 'ºC'),
	(311994, 142, '2015-01-15 00:34:10.000000', 'temperatura', 253.0000, 'ºC'),
	(311995, 142, '2015-01-15 00:34:11.000000', 'temperatura', 581.0000, 'ºC'),
	(311996, 142, '2015-01-15 00:34:12.000000', 'temperatura', 946.0000, 'ºC'),
	(311997, 142, '2015-01-15 00:34:13.000000', 'temperatura', 587.0000, 'ºC'),
	(311998, 142, '2015-01-15 00:34:14.000000', 'temperatura', 99.0000, 'ºC'),
	(311999, 142, '2015-01-15 00:34:15.000000', 'temperatura', 1135.0000, 'ºC'),
	(312000, 142, '2015-01-15 00:34:16.000000', 'temperatura', 576.0000, 'ºC'),
	(312001, 142, '2015-01-15 00:34:17.000000', 'temperatura', 677.0000, 'ºC'),
	(312002, 142, '2015-01-15 00:34:18.000000', 'temperatura', 457.0000, 'ºC'),
	(312003, 142, '2015-01-15 00:34:19.000000', 'temperatura', 256.0000, 'ºC'),
	(312004, 142, '2015-01-15 00:34:20.000000', 'temperatura', 1108.0000, 'ºC'),
	(312005, 142, '2015-01-15 00:34:21.000000', 'temperatura', 1172.0000, 'ºC'),
	(312006, 142, '2015-01-15 00:34:22.000000', 'temperatura', 135.0000, 'ºC'),
	(312007, 142, '2015-01-15 00:34:23.000000', 'temperatura', 762.0000, 'ºC'),
	(312008, 142, '2015-01-15 00:34:24.000000', 'temperatura', 1005.0000, 'ºC'),
	(312009, 142, '2015-01-15 00:34:25.000000', 'temperatura', 341.0000, 'ºC'),
	(312010, 142, '2015-01-15 00:34:26.000000', 'temperatura', 1091.0000, 'ºC'),
	(312011, 142, '2015-01-15 00:34:27.000000', 'temperatura', 833.0000, 'ºC'),
	(312012, 142, '2015-01-15 00:34:28.000000', 'temperatura', 893.0000, 'ºC'),
	(312013, 142, '2015-01-15 00:34:29.000000', 'temperatura', 765.0000, 'ºC'),
	(312014, 142, '2015-01-15 00:34:30.000000', 'temperatura', 1149.0000, 'ºC'),
	(312015, 142, '2015-01-15 00:34:31.000000', 'temperatura', 1047.0000, 'ºC'),
	(312016, 142, '2015-01-15 00:34:32.000000', 'temperatura', 590.0000, 'ºC'),
	(312017, 142, '2015-01-15 00:34:33.000000', 'temperatura', 1011.0000, 'ºC'),
	(312018, 142, '2015-01-15 00:34:34.000000', 'temperatura', 884.0000, 'ºC'),
	(312019, 142, '2015-01-15 00:34:35.000000', 'temperatura', 188.0000, 'ºC'),
	(312020, 142, '2015-01-15 00:34:36.000000', 'temperatura', 688.0000, 'ºC'),
	(312021, 142, '2015-01-15 00:34:37.000000', 'temperatura', 478.0000, 'ºC'),
	(312022, 142, '2015-01-15 00:34:38.000000', 'temperatura', 325.0000, 'ºC'),
	(312023, 142, '2015-01-15 00:34:39.000000', 'temperatura', 193.0000, 'ºC'),
	(312024, 142, '2015-01-15 00:34:40.000000', 'temperatura', 1188.0000, 'ºC'),
	(312025, 142, '2015-01-15 00:34:41.000000', 'temperatura', 563.0000, 'ºC'),
	(312026, 142, '2015-01-15 00:34:42.000000', 'temperatura', 452.0000, 'ºC'),
	(312027, 142, '2015-01-15 00:34:43.000000', 'temperatura', 572.0000, 'ºC'),
	(312028, 142, '2015-01-15 00:34:44.000000', 'temperatura', 305.0000, 'ºC'),
	(312029, 142, '2015-01-15 00:34:45.000000', 'temperatura', 1009.0000, 'ºC'),
	(312030, 142, '2015-01-15 00:34:46.000000', 'temperatura', 529.0000, 'ºC'),
	(312031, 142, '2015-01-15 00:34:47.000000', 'temperatura', 819.0000, 'ºC'),
	(312032, 142, '2015-01-15 00:34:48.000000', 'temperatura', 107.0000, 'ºC'),
	(312033, 142, '2015-01-15 00:34:49.000000', 'temperatura', 479.0000, 'ºC'),
	(312034, 142, '2015-01-15 00:34:50.000000', 'temperatura', 877.0000, 'ºC'),
	(312035, 142, '2015-01-15 00:34:51.000000', 'temperatura', 548.0000, 'ºC'),
	(312036, 142, '2015-01-15 00:34:52.000000', 'temperatura', 108.0000, 'ºC'),
	(312037, 142, '2015-01-15 00:34:53.000000', 'temperatura', 97.0000, 'ºC'),
	(312038, 142, '2015-01-15 00:34:54.000000', 'temperatura', 161.0000, 'ºC'),
	(312039, 142, '2015-01-15 00:34:55.000000', 'temperatura', 517.0000, 'ºC'),
	(312040, 142, '2015-01-15 00:34:56.000000', 'temperatura', 899.0000, 'ºC'),
	(312041, 142, '2015-01-15 00:34:57.000000', 'temperatura', 546.0000, 'ºC'),
	(312042, 142, '2015-01-15 00:34:58.000000', 'temperatura', 35.0000, 'ºC'),
	(312043, 142, '2015-01-15 00:34:59.000000', 'temperatura', 938.0000, 'ºC'),
	(312044, 142, '2015-01-15 00:35:00.000000', 'temperatura', 983.0000, 'ºC'),
	(312045, 142, '2015-01-15 00:35:01.000000', 'temperatura', 902.0000, 'ºC'),
	(312046, 142, '2015-01-15 00:35:02.000000', 'temperatura', 362.0000, 'ºC'),
	(312047, 142, '2015-01-15 00:35:03.000000', 'temperatura', 306.0000, 'ºC'),
	(312048, 142, '2015-01-15 00:35:04.000000', 'temperatura', 441.0000, 'ºC'),
	(312049, 142, '2015-01-15 00:35:05.000000', 'temperatura', 91.0000, 'ºC'),
	(312050, 142, '2015-01-15 00:35:06.000000', 'temperatura', 330.0000, 'ºC'),
	(312051, 142, '2015-01-15 00:35:07.000000', 'temperatura', 177.0000, 'ºC'),
	(312052, 142, '2015-01-15 00:35:08.000000', 'temperatura', 1095.0000, 'ºC'),
	(312053, 142, '2015-01-15 00:35:09.000000', 'temperatura', 143.0000, 'ºC'),
	(312054, 142, '2015-01-15 00:35:10.000000', 'temperatura', 1034.0000, 'ºC'),
	(312055, 142, '2015-01-15 00:35:11.000000', 'temperatura', 1141.0000, 'ºC'),
	(312056, 142, '2015-01-15 00:35:12.000000', 'temperatura', 202.0000, 'ºC'),
	(312057, 142, '2015-01-15 00:35:13.000000', 'temperatura', 1189.0000, 'ºC'),
	(312058, 142, '2015-01-15 00:35:14.000000', 'temperatura', 539.0000, 'ºC'),
	(312059, 142, '2015-01-15 00:35:15.000000', 'temperatura', 327.0000, 'ºC'),
	(312060, 142, '2015-01-15 00:35:16.000000', 'temperatura', 20.0000, 'ºC'),
	(312061, 142, '2015-01-15 00:35:17.000000', 'temperatura', 320.0000, 'ºC'),
	(312062, 142, '2015-01-15 00:35:18.000000', 'temperatura', 341.0000, 'ºC'),
	(312063, 142, '2015-01-15 00:35:19.000000', 'temperatura', 745.0000, 'ºC'),
	(312064, 142, '2015-01-15 00:35:20.000000', 'temperatura', 301.0000, 'ºC'),
	(312065, 142, '2015-01-15 00:35:21.000000', 'temperatura', 472.0000, 'ºC'),
	(312066, 142, '2015-01-15 00:35:22.000000', 'temperatura', 258.0000, 'ºC'),
	(312067, 142, '2015-01-15 00:35:23.000000', 'temperatura', 1074.0000, 'ºC'),
	(312068, 142, '2015-01-15 00:35:24.000000', 'temperatura', 995.0000, 'ºC'),
	(312069, 142, '2015-01-15 00:35:25.000000', 'temperatura', 554.0000, 'ºC'),
	(312070, 142, '2015-01-15 00:35:26.000000', 'temperatura', 984.0000, 'ºC'),
	(312071, 142, '2015-01-15 00:35:27.000000', 'temperatura', 861.0000, 'ºC'),
	(312072, 142, '2015-01-15 00:35:28.000000', 'temperatura', 154.0000, 'ºC'),
	(312073, 142, '2015-01-15 00:35:29.000000', 'temperatura', 586.0000, 'ºC'),
	(312074, 142, '2015-01-15 00:35:30.000000', 'temperatura', 68.0000, 'ºC'),
	(312075, 142, '2015-01-15 00:35:31.000000', 'temperatura', 985.0000, 'ºC'),
	(312076, 142, '2015-01-15 00:35:32.000000', 'temperatura', 1119.0000, 'ºC'),
	(312077, 142, '2015-01-15 00:35:33.000000', 'temperatura', 241.0000, 'ºC'),
	(312078, 142, '2015-01-15 00:35:34.000000', 'temperatura', 247.0000, 'ºC'),
	(312079, 142, '2015-01-15 00:35:35.000000', 'temperatura', 514.0000, 'ºC'),
	(312080, 142, '2015-01-15 00:35:36.000000', 'temperatura', 631.0000, 'ºC'),
	(312081, 142, '2015-01-15 00:35:37.000000', 'temperatura', 413.0000, 'ºC'),
	(312082, 142, '2015-01-15 00:35:38.000000', 'temperatura', 172.0000, 'ºC'),
	(312083, 142, '2015-01-15 00:35:39.000000', 'temperatura', 823.0000, 'ºC'),
	(312084, 142, '2015-01-15 00:35:40.000000', 'temperatura', 1199.0000, 'ºC'),
	(312085, 142, '2015-01-15 00:35:41.000000', 'temperatura', 1125.0000, 'ºC'),
	(312086, 142, '2015-01-15 00:35:42.000000', 'temperatura', 831.0000, 'ºC'),
	(312087, 142, '2015-01-15 00:35:43.000000', 'temperatura', 778.0000, 'ºC'),
	(312088, 142, '2015-01-15 00:35:44.000000', 'temperatura', 196.0000, 'ºC'),
	(312089, 142, '2015-01-15 00:35:45.000000', 'temperatura', 1050.0000, 'ºC'),
	(312090, 142, '2015-01-15 00:35:46.000000', 'temperatura', 1062.0000, 'ºC'),
	(312091, 142, '2015-01-15 00:35:47.000000', 'temperatura', 960.0000, 'ºC'),
	(312092, 142, '2015-01-15 00:35:48.000000', 'temperatura', 413.0000, 'ºC'),
	(312093, 142, '2015-01-15 00:35:49.000000', 'temperatura', 388.0000, 'ºC'),
	(312094, 142, '2015-01-15 00:35:50.000000', 'temperatura', 700.0000, 'ºC'),
	(312095, 142, '2015-01-15 00:35:51.000000', 'temperatura', 1136.0000, 'ºC'),
	(312096, 142, '2015-01-15 00:35:52.000000', 'temperatura', 1183.0000, 'ºC'),
	(312097, 142, '2015-01-15 00:35:53.000000', 'temperatura', 106.0000, 'ºC'),
	(312098, 142, '2015-01-15 00:35:54.000000', 'temperatura', 582.0000, 'ºC'),
	(312099, 142, '2015-01-15 00:35:55.000000', 'temperatura', 193.0000, 'ºC'),
	(312100, 142, '2015-01-15 00:35:56.000000', 'temperatura', 420.0000, 'ºC'),
	(312101, 142, '2015-01-15 00:35:57.000000', 'temperatura', 320.0000, 'ºC'),
	(312102, 142, '2015-01-15 00:35:58.000000', 'temperatura', 342.0000, 'ºC'),
	(312103, 142, '2015-01-15 00:35:59.000000', 'temperatura', 752.0000, 'ºC'),
	(312104, 142, '2015-01-15 00:36:00.000000', 'temperatura', 332.0000, 'ºC'),
	(312105, 142, '2015-01-15 00:36:01.000000', 'temperatura', 607.0000, 'ºC'),
	(312106, 142, '2015-01-15 00:36:02.000000', 'temperatura', 839.0000, 'ºC'),
	(312107, 142, '2015-01-15 00:36:03.000000', 'temperatura', 1173.0000, 'ºC'),
	(312108, 142, '2015-01-15 00:36:04.000000', 'temperatura', 947.0000, 'ºC'),
	(312109, 142, '2015-01-15 00:36:05.000000', 'temperatura', 19.0000, 'ºC'),
	(312110, 142, '2015-01-15 00:36:06.000000', 'temperatura', 853.0000, 'ºC'),
	(312111, 142, '2015-01-15 00:36:07.000000', 'temperatura', 608.0000, 'ºC'),
	(312112, 142, '2015-01-15 00:36:08.000000', 'temperatura', 484.0000, 'ºC'),
	(312113, 142, '2015-01-15 00:36:09.000000', 'temperatura', 594.0000, 'ºC'),
	(312114, 142, '2015-01-15 00:36:10.000000', 'temperatura', 318.0000, 'ºC'),
	(312115, 142, '2015-01-15 00:36:11.000000', 'temperatura', 1010.0000, 'ºC'),
	(312116, 142, '2015-01-15 00:36:12.000000', 'temperatura', 497.0000, 'ºC'),
	(312117, 142, '2015-01-15 00:36:13.000000', 'temperatura', 653.0000, 'ºC'),
	(312118, 142, '2015-01-15 00:36:14.000000', 'temperatura', 578.0000, 'ºC'),
	(312119, 142, '2015-01-15 00:36:15.000000', 'temperatura', 928.0000, 'ºC'),
	(312120, 142, '2015-01-15 00:36:16.000000', 'temperatura', 508.0000, 'ºC'),
	(312121, 142, '2015-01-15 00:36:17.000000', 'temperatura', 958.0000, 'ºC'),
	(312122, 142, '2015-01-15 00:36:18.000000', 'temperatura', 865.0000, 'ºC'),
	(312123, 142, '2015-01-15 00:36:19.000000', 'temperatura', 252.0000, 'ºC'),
	(312124, 142, '2015-01-15 00:36:20.000000', 'temperatura', 1067.0000, 'ºC'),
	(312125, 142, '2015-01-15 00:36:21.000000', 'temperatura', 978.0000, 'ºC'),
	(312126, 142, '2015-01-15 00:36:22.000000', 'temperatura', 489.0000, 'ºC'),
	(312127, 142, '2015-01-15 00:36:23.000000', 'temperatura', 711.0000, 'ºC'),
	(312128, 142, '2015-01-15 00:36:24.000000', 'temperatura', 890.0000, 'ºC'),
	(312129, 142, '2015-01-15 00:36:25.000000', 'temperatura', 1115.0000, 'ºC'),
	(312130, 142, '2015-01-15 00:36:26.000000', 'temperatura', 506.0000, 'ºC'),
	(312131, 142, '2015-01-15 00:36:27.000000', 'temperatura', 388.0000, 'ºC'),
	(312132, 142, '2015-01-15 00:36:28.000000', 'temperatura', 421.0000, 'ºC'),
	(312133, 142, '2015-01-15 00:36:29.000000', 'temperatura', 940.0000, 'ºC'),
	(312134, 142, '2015-01-15 00:36:30.000000', 'temperatura', 1039.0000, 'ºC'),
	(312135, 142, '2015-01-15 00:36:31.000000', 'temperatura', 1176.0000, 'ºC'),
	(312136, 142, '2015-01-15 00:36:32.000000', 'temperatura', 364.0000, 'ºC'),
	(312137, 142, '2015-01-15 00:36:33.000000', 'temperatura', 691.0000, 'ºC'),
	(312138, 142, '2015-01-15 00:36:34.000000', 'temperatura', 1166.0000, 'ºC'),
	(312139, 142, '2015-01-15 00:36:35.000000', 'temperatura', 157.0000, 'ºC'),
	(312140, 142, '2015-01-15 00:36:36.000000', 'temperatura', 885.0000, 'ºC'),
	(312141, 142, '2015-01-15 00:36:37.000000', 'temperatura', 356.0000, 'ºC'),
	(312142, 142, '2015-01-15 00:36:38.000000', 'temperatura', 324.0000, 'ºC'),
	(312143, 142, '2015-01-15 00:36:39.000000', 'temperatura', 552.0000, 'ºC'),
	(312144, 142, '2015-01-15 00:36:40.000000', 'temperatura', 590.0000, 'ºC'),
	(312145, 142, '2015-01-15 00:36:41.000000', 'temperatura', 95.0000, 'ºC'),
	(312146, 142, '2015-01-15 00:36:42.000000', 'temperatura', 1106.0000, 'ºC'),
	(312147, 142, '2015-01-15 00:36:43.000000', 'temperatura', 445.0000, 'ºC'),
	(312148, 142, '2015-01-15 00:36:44.000000', 'temperatura', 105.0000, 'ºC'),
	(312149, 142, '2015-01-15 00:36:45.000000', 'temperatura', 394.0000, 'ºC'),
	(312150, 142, '2015-01-15 00:36:46.000000', 'temperatura', 454.0000, 'ºC'),
	(312151, 142, '2015-01-15 00:36:47.000000', 'temperatura', 1089.0000, 'ºC'),
	(312152, 142, '2015-01-15 00:36:48.000000', 'temperatura', 485.0000, 'ºC'),
	(312153, 142, '2015-01-15 00:36:49.000000', 'temperatura', 356.0000, 'ºC'),
	(312154, 142, '2015-01-15 00:36:50.000000', 'temperatura', 326.0000, 'ºC'),
	(312155, 142, '2015-01-15 00:36:51.000000', 'temperatura', 561.0000, 'ºC'),
	(312156, 142, '2015-01-15 00:36:52.000000', 'temperatura', 628.0000, 'ºC'),
	(312157, 142, '2015-01-15 00:36:53.000000', 'temperatura', 260.0000, 'ºC'),
	(312158, 142, '2015-01-15 00:36:54.000000', 'temperatura', 613.0000, 'ºC'),
	(312159, 142, '2015-01-15 00:36:55.000000', 'temperatura', 1088.0000, 'ºC'),
	(312160, 142, '2015-01-15 00:36:56.000000', 'temperatura', 1199.0000, 'ºC'),
	(312161, 142, '2015-01-15 00:36:57.000000', 'temperatura', 332.0000, 'ºC'),
	(312162, 142, '2015-01-15 00:36:58.000000', 'temperatura', 464.0000, 'ºC'),
	(312163, 142, '2015-01-15 00:36:59.000000', 'temperatura', 123.0000, 'ºC'),
	(312164, 142, '2015-01-15 00:37:00.000000', 'temperatura', 425.0000, 'ºC'),
	(312165, 142, '2015-01-15 00:37:01.000000', 'temperatura', 557.0000, 'ºC'),
	(312166, 142, '2015-01-15 00:37:02.000000', 'temperatura', 310.0000, 'ºC'),
	(312167, 142, '2015-01-15 00:37:03.000000', 'temperatura', 1078.0000, 'ºC'),
	(312168, 142, '2015-01-15 00:37:04.000000', 'temperatura', 863.0000, 'ºC'),
	(312169, 142, '2015-01-15 00:37:05.000000', 'temperatura', 1081.0000, 'ºC'),
	(312170, 142, '2015-01-15 00:37:06.000000', 'temperatura', 416.0000, 'ºC'),
	(312171, 142, '2015-01-15 00:37:07.000000', 'temperatura', 39.0000, 'ºC'),
	(312172, 142, '2015-01-15 00:37:08.000000', 'temperatura', 146.0000, 'ºC'),
	(312173, 142, '2015-01-15 00:37:09.000000', 'temperatura', 614.0000, 'ºC'),
	(312174, 142, '2015-01-15 00:37:10.000000', 'temperatura', 232.0000, 'ºC'),
	(312175, 142, '2015-01-15 00:37:11.000000', 'temperatura', 517.0000, 'ºC'),
	(312176, 142, '2015-01-15 00:37:12.000000', 'temperatura', 691.0000, 'ºC'),
	(312177, 142, '2015-01-15 00:37:13.000000', 'temperatura', 704.0000, 'ºC'),
	(312178, 142, '2015-01-15 00:37:14.000000', 'temperatura', 246.0000, 'ºC'),
	(312179, 142, '2015-01-15 00:37:15.000000', 'temperatura', 320.0000, 'ºC'),
	(312180, 142, '2015-01-15 00:37:16.000000', 'temperatura', 862.0000, 'ºC'),
	(312181, 142, '2015-01-15 00:37:17.000000', 'temperatura', 951.0000, 'ºC'),
	(312182, 142, '2015-01-15 00:37:18.000000', 'temperatura', 970.0000, 'ºC'),
	(312183, 142, '2015-01-15 00:37:19.000000', 'temperatura', 797.0000, 'ºC'),
	(312184, 142, '2015-01-15 00:37:20.000000', 'temperatura', 1074.0000, 'ºC'),
	(312185, 142, '2015-01-15 00:37:21.000000', 'temperatura', 581.0000, 'ºC'),
	(312186, 142, '2015-01-15 00:37:22.000000', 'temperatura', 883.0000, 'ºC'),
	(312187, 142, '2015-01-15 00:37:23.000000', 'temperatura', 273.0000, 'ºC'),
	(312188, 142, '2015-01-15 00:37:24.000000', 'temperatura', 1116.0000, 'ºC'),
	(312189, 142, '2015-01-15 00:37:25.000000', 'temperatura', 1163.0000, 'ºC'),
	(312190, 142, '2015-01-15 00:37:26.000000', 'temperatura', 68.0000, 'ºC'),
	(312191, 142, '2015-01-15 00:37:27.000000', 'temperatura', 452.0000, 'ºC'),
	(312192, 142, '2015-01-15 00:37:28.000000', 'temperatura', 855.0000, 'ºC'),
	(312193, 142, '2015-01-15 00:37:29.000000', 'temperatura', 520.0000, 'ºC'),
	(312194, 142, '2015-01-15 00:37:30.000000', 'temperatura', 34.0000, 'ºC'),
	(312195, 142, '2015-01-15 00:37:31.000000', 'temperatura', 1009.0000, 'ºC'),
	(312196, 142, '2015-01-15 00:37:32.000000', 'temperatura', 147.0000, 'ºC'),
	(312197, 142, '2015-01-15 00:37:33.000000', 'temperatura', 108.0000, 'ºC'),
	(312198, 142, '2015-01-15 00:37:34.000000', 'temperatura', 98.0000, 'ºC'),
	(312199, 142, '2015-01-15 00:37:35.000000', 'temperatura', 166.0000, 'ºC'),
	(312200, 142, '2015-01-15 00:37:36.000000', 'temperatura', 537.0000, 'ºC'),
	(312201, 142, '2015-01-15 00:37:37.000000', 'temperatura', 987.0000, 'ºC'),
	(312202, 142, '2015-01-15 00:37:38.000000', 'temperatura', 927.0000, 'ºC'),
	(312203, 142, '2015-01-15 00:37:39.000000', 'temperatura', 471.0000, 'ºC'),
	(312204, 142, '2015-01-15 00:37:40.000000', 'temperatura', 778.0000, 'ºC'),
	(312205, 142, '2015-01-15 00:37:41.000000', 'temperatura', 74.0000, 'ºC'),
	(312206, 142, '2015-01-15 00:37:42.000000', 'temperatura', 438.0000, 'ºC'),
	(312207, 142, '2015-01-15 00:37:43.000000', 'temperatura', 767.0000, 'ºC'),
	(312208, 142, '2015-01-15 00:37:44.000000', 'temperatura', 124.0000, 'ºC'),
	(312209, 142, '2015-01-15 00:37:45.000000', 'temperatura', 717.0000, 'ºC'),
	(312210, 142, '2015-01-15 00:37:46.000000', 'temperatura', 816.0000, 'ºC'),
	(312211, 142, '2015-01-15 00:37:47.000000', 'temperatura', 727.0000, 'ºC'),
	(312212, 142, '2015-01-15 00:37:48.000000', 'temperatura', 1187.0000, 'ºC'),
	(312213, 142, '2015-01-15 00:37:49.000000', 'temperatura', 155.0000, 'ºC'),
	(312214, 142, '2015-01-15 00:37:50.000000', 'temperatura', 815.0000, 'ºC'),
	(312215, 142, '2015-01-15 00:37:51.000000', 'temperatura', 11.0000, 'ºC'),
	(312216, 142, '2015-01-15 00:37:52.000000', 'temperatura', 11.0000, 'ºC'),
	(312217, 142, '2015-01-15 00:37:53.000000', 'temperatura', 22.0000, 'ºC'),
	(312218, 142, '2015-01-15 00:37:54.000000', 'temperatura', 77.0000, 'ºC'),
	(312219, 142, '2015-01-15 00:37:55.000000', 'temperatura', 318.0000, 'ºC'),
	(312220, 142, '2015-01-15 00:37:56.000000', 'temperatura', 162.0000, 'ºC'),
	(312221, 142, '2015-01-15 00:37:57.000000', 'temperatura', 1057.0000, 'ºC'),
	(312222, 142, '2015-01-15 00:37:58.000000', 'temperatura', 1198.0000, 'ºC'),
	(312223, 142, '2015-01-15 00:37:59.000000', 'temperatura', 419.0000, 'ºC'),
	(312224, 142, '2015-01-15 00:38:00.000000', 'temperatura', 901.0000, 'ºC'),
	(312225, 142, '2015-01-15 00:38:01.000000', 'temperatura', 851.0000, 'ºC'),
	(312226, 142, '2015-01-15 00:38:02.000000', 'temperatura', 352.0000, 'ºC'),
	(312227, 142, '2015-01-15 00:38:03.000000', 'temperatura', 406.0000, 'ºC'),
	(312228, 142, '2015-01-15 00:38:04.000000', 'temperatura', 974.0000, 'ºC'),
	(312229, 142, '2015-01-15 00:38:05.000000', 'temperatura', 54.0000, 'ºC'),
	(312230, 142, '2015-01-15 00:38:06.000000', 'temperatura', 947.0000, 'ºC'),
	(312231, 142, '2015-01-15 00:38:07.000000', 'temperatura', 975.0000, 'ºC'),
	(312232, 142, '2015-01-15 00:38:08.000000', 'temperatura', 834.0000, 'ºC'),
	(312233, 142, '2015-01-15 00:38:09.000000', 'temperatura', 45.0000, 'ºC'),
	(312234, 142, '2015-01-15 00:38:10.000000', 'temperatura', 122.0000, 'ºC'),
	(312235, 142, '2015-01-15 00:38:11.000000', 'temperatura', 479.0000, 'ºC'),
	(312236, 142, '2015-01-15 00:38:12.000000', 'temperatura', 826.0000, 'ºC'),
	(312237, 142, '2015-01-15 00:38:13.000000', 'temperatura', 295.0000, 'ºC'),
	(312238, 142, '2015-01-15 00:38:14.000000', 'temperatura', 196.0000, 'ºC'),
	(312239, 142, '2015-01-15 00:38:15.000000', 'temperatura', 95.0000, 'ºC'),
	(312240, 142, '2015-01-15 00:38:16.000000', 'temperatura', 1089.0000, 'ºC'),
	(312241, 142, '2015-01-15 00:38:17.000000', 'temperatura', 361.0000, 'ºC'),
	(312242, 142, '2015-01-15 00:38:18.000000', 'temperatura', 938.0000, 'ºC'),
	(312243, 142, '2015-01-15 00:38:19.000000', 'temperatura', 7.0000, 'ºC'),
	(312244, 142, '2015-01-15 00:38:20.000000', 'temperatura', 822.0000, 'ºC'),
	(312245, 142, '2015-01-15 00:38:21.000000', 'temperatura', 489.0000, 'ºC'),
	(312246, 142, '2015-01-15 00:38:22.000000', 'temperatura', 1181.0000, 'ºC'),
	(312247, 142, '2015-01-15 00:38:23.000000', 'temperatura', 837.0000, 'ºC'),
	(312248, 142, '2015-01-15 00:38:24.000000', 'temperatura', 641.0000, 'ºC'),
	(312249, 142, '2015-01-15 00:38:25.000000', 'temperatura', 696.0000, 'ºC'),
	(312250, 142, '2015-01-15 00:38:26.000000', 'temperatura', 358.0000, 'ºC'),
	(312251, 142, '2015-01-15 00:38:27.000000', 'temperatura', 900.0000, 'ºC'),
	(312252, 142, '2015-01-15 00:38:28.000000', 'temperatura', 1030.0000, 'ºC'),
	(312253, 142, '2015-01-15 00:38:29.000000', 'temperatura', 49.0000, 'ºC'),
	(312254, 142, '2015-01-15 00:38:30.000000', 'temperatura', 753.0000, 'ºC'),
	(312255, 142, '2015-01-15 00:38:31.000000', 'temperatura', 22.0000, 'ºC'),
	(312256, 142, '2015-01-15 00:38:32.000000', 'temperatura', 252.0000, 'ºC'),
	(312257, 142, '2015-01-15 00:38:33.000000', 'temperatura', 1192.0000, 'ºC'),
	(312258, 142, '2015-01-15 00:38:34.000000', 'temperatura', 404.0000, 'ºC'),
	(312259, 142, '2015-01-15 00:38:35.000000', 'temperatura', 847.0000, 'ºC'),
	(312260, 142, '2015-01-15 00:38:36.000000', 'temperatura', 622.0000, 'ºC'),
	(312261, 142, '2015-01-15 00:38:37.000000', 'temperatura', 569.0000, 'ºC'),
	(312262, 142, '2015-01-15 00:38:38.000000', 'temperatura', 982.0000, 'ºC'),
	(312263, 142, '2015-01-15 00:38:39.000000', 'temperatura', 803.0000, 'ºC'),
	(312264, 142, '2015-01-15 00:38:40.000000', 'temperatura', 1069.0000, 'ºC'),
	(312265, 142, '2015-01-15 00:38:41.000000', 'temperatura', 536.0000, 'ºC'),
	(312266, 142, '2015-01-15 00:38:42.000000', 'temperatura', 675.0000, 'ºC'),
	(312267, 142, '2015-01-15 00:38:43.000000', 'temperatura', 567.0000, 'ºC'),
	(312268, 142, '2015-01-15 00:38:44.000000', 'temperatura', 812.0000, 'ºC'),
	(312269, 142, '2015-01-15 00:38:45.000000', 'temperatura', 1160.0000, 'ºC'),
	(312270, 142, '2015-01-15 00:38:46.000000', 'temperatura', 962.0000, 'ºC'),
	(312271, 142, '2015-01-15 00:38:47.000000', 'temperatura', 131.0000, 'ºC'),
	(312272, 142, '2015-01-15 00:38:48.000000', 'temperatura', 169.0000, 'ºC'),
	(312273, 142, '2015-01-15 00:38:49.000000', 'temperatura', 453.0000, 'ºC'),
	(312274, 142, '2015-01-15 00:38:50.000000', 'temperatura', 560.0000, 'ºC'),
	(312275, 142, '2015-01-15 00:38:51.000000', 'temperatura', 242.0000, 'ºC'),
	(312276, 142, '2015-01-15 00:38:52.000000', 'temperatura', 730.0000, 'ºC'),
	(312277, 142, '2015-01-15 00:38:53.000000', 'temperatura', 525.0000, 'ºC'),
	(312278, 142, '2015-01-15 00:38:54.000000', 'temperatura', 437.0000, 'ºC'),
	(312279, 142, '2015-01-15 00:38:55.000000', 'temperatura', 608.0000, 'ºC'),
	(312280, 142, '2015-01-15 00:38:56.000000', 'temperatura', 531.0000, 'ºC'),
	(312281, 142, '2015-01-15 00:38:57.000000', 'temperatura', 832.0000, 'ºC'),
	(312282, 142, '2015-01-15 00:38:58.000000', 'temperatura', 165.0000, 'ºC'),
	(312283, 142, '2015-01-15 00:38:59.000000', 'temperatura', 731.0000, 'ºC'),
	(312284, 142, '2015-01-15 00:39:00.000000', 'temperatura', 761.0000, 'ºC'),
	(312285, 142, '2015-01-15 00:39:01.000000', 'temperatura', 411.0000, 'ºC'),
	(312286, 142, '2015-01-15 00:39:02.000000', 'temperatura', 974.0000, 'ºC'),
	(312287, 142, '2015-01-15 00:39:03.000000', 'temperatura', 35.0000, 'ºC'),
	(312288, 142, '2015-01-15 00:39:04.000000', 'temperatura', 857.0000, 'ºC'),
	(312289, 142, '2015-01-15 00:39:05.000000', 'temperatura', 578.0000, 'ºC'),
	(312290, 142, '2015-01-15 00:39:06.000000', 'temperatura', 318.0000, 'ºC'),
	(312291, 142, '2015-01-15 00:39:07.000000', 'temperatura', 1058.0000, 'ºC'),
	(312292, 142, '2015-01-15 00:39:08.000000', 'temperatura', 738.0000, 'ºC'),
	(312293, 142, '2015-01-15 00:39:09.000000', 'temperatura', 516.0000, 'ºC'),
	(312294, 142, '2015-01-15 00:39:10.000000', 'temperatura', 366.0000, 'ºC'),
	(312295, 142, '2015-01-15 00:39:11.000000', 'temperatura', 284.0000, 'ºC'),
	(312296, 142, '2015-01-15 00:39:12.000000', 'temperatura', 322.0000, 'ºC'),
	(312297, 142, '2015-01-15 00:39:13.000000', 'temperatura', 760.0000, 'ºC'),
	(312298, 142, '2015-01-15 00:39:14.000000', 'temperatura', 434.0000, 'ºC'),
	(312299, 142, '2015-01-15 00:39:15.000000', 'temperatura', 1091.0000, 'ºC'),
	(312300, 142, '2015-01-15 00:39:16.000000', 'temperatura', 551.0000, 'ºC'),
	(312301, 142, '2015-01-15 00:39:17.000000', 'temperatura', 682.0000, 'ºC'),
	(312302, 142, '2015-01-15 00:39:18.000000', 'temperatura', 560.0000, 'ºC'),
	(312303, 142, '2015-01-15 00:39:19.000000', 'temperatura', 752.0000, 'ºC'),
	(312304, 142, '2015-01-15 00:39:20.000000', 'temperatura', 880.0000, 'ºC'),
	(312305, 142, '2015-01-15 00:39:21.000000', 'temperatura', 947.0000, 'ºC'),
	(312306, 142, '2015-01-15 00:39:22.000000', 'temperatura', 895.0000, 'ºC'),
	(312307, 142, '2015-01-15 00:39:23.000000', 'temperatura', 435.0000, 'ºC'),
	(312308, 142, '2015-01-15 00:39:24.000000', 'temperatura', 690.0000, 'ºC'),
	(312309, 142, '2015-01-15 00:39:25.000000', 'temperatura', 945.0000, 'ºC'),
	(312310, 142, '2015-01-15 00:39:26.000000', 'temperatura', 254.0000, 'ºC'),
	(312311, 142, '2015-01-15 00:39:27.000000', 'temperatura', 839.0000, 'ºC'),
	(312312, 142, '2015-01-15 00:39:28.000000', 'temperatura', 1030.0000, 'ºC'),
	(312313, 142, '2015-01-15 00:39:29.000000', 'temperatura', 237.0000, 'ºC'),
	(312314, 142, '2015-01-15 00:39:30.000000', 'temperatura', 493.0000, 'ºC'),
	(312315, 142, '2015-01-15 00:39:31.000000', 'temperatura', 556.0000, 'ºC'),
	(312316, 142, '2015-01-15 00:39:32.000000', 'temperatura', 103.0000, 'ºC'),
	(312317, 142, '2015-01-15 00:39:33.000000', 'temperatura', 46.0000, 'ºC'),
	(312318, 142, '2015-01-15 00:39:34.000000', 'temperatura', 1121.0000, 'ºC'),
	(312319, 142, '2015-01-15 00:39:35.000000', 'temperatura', 670.0000, 'ºC'),
	(312320, 142, '2015-01-15 00:39:36.000000', 'temperatura', 1185.0000, 'ºC'),
	(312321, 142, '2015-01-15 00:39:37.000000', 'temperatura', 316.0000, 'ºC'),
	(312322, 142, '2015-01-15 00:39:38.000000', 'temperatura', 427.0000, 'ºC'),
	(312323, 142, '2015-01-15 00:39:39.000000', 'temperatura', 1188.0000, 'ºC'),
	(312324, 142, '2015-01-15 00:39:40.000000', 'temperatura', 1060.0000, 'ºC'),
	(312325, 142, '2015-01-15 00:39:41.000000', 'temperatura', 534.0000, 'ºC'),
	(312326, 142, '2015-01-15 00:39:42.000000', 'temperatura', 692.0000, 'ºC'),
	(312327, 142, '2015-01-15 00:39:43.000000', 'temperatura', 657.0000, 'ºC'),
	(312328, 142, '2015-01-15 00:39:44.000000', 'temperatura', 10.0000, 'ºC'),
	(312329, 142, '2015-01-15 00:39:45.000000', 'temperatura', 482.0000, 'ºC'),
	(312330, 142, '2015-01-15 00:39:46.000000', 'temperatura', 1177.0000, 'ºC'),
	(312331, 142, '2015-01-15 00:39:47.000000', 'temperatura', 842.0000, 'ºC'),
	(312332, 142, '2015-01-15 00:39:48.000000', 'temperatura', 677.0000, 'ºC'),
	(312333, 142, '2015-01-15 00:39:49.000000', 'temperatura', 860.0000, 'ºC'),
	(312334, 142, '2015-01-15 00:39:50.000000', 'temperatura', 1070.0000, 'ºC'),
	(312335, 142, '2015-01-15 00:39:51.000000', 'temperatura', 369.0000, 'ºC'),
	(312336, 142, '2015-01-15 00:39:52.000000', 'temperatura', 1035.0000, 'ºC'),
	(312337, 142, '2015-01-15 00:39:53.000000', 'temperatura', 472.0000, 'ºC'),
	(312338, 142, '2015-01-15 00:39:54.000000', 'temperatura', 452.0000, 'ºC'),
	(312339, 142, '2015-01-15 00:39:55.000000', 'temperatura', 847.0000, 'ºC'),
	(312340, 142, '2015-01-15 00:39:56.000000', 'temperatura', 480.0000, 'ºC'),
	(312341, 142, '2015-01-15 00:39:57.000000', 'temperatura', 1060.0000, 'ºC'),
	(312342, 142, '2015-01-15 00:39:58.000000', 'temperatura', 261.0000, 'ºC'),
	(312343, 142, '2015-01-15 00:39:59.000000', 'temperatura', 523.0000, 'ºC'),
	(312344, 142, '2015-01-15 00:40:00.000000', 'temperatura', 635.0000, 'ºC'),
	(312345, 142, '2015-01-15 00:40:01.000000', 'temperatura', 404.0000, 'ºC'),
	(312346, 142, '2015-01-15 00:40:02.000000', 'temperatura', 117.0000, 'ºC'),
	(312347, 142, '2015-01-15 00:40:03.000000', 'temperatura', 571.0000, 'ºC'),
	(312348, 142, '2015-01-15 00:40:04.000000', 'temperatura', 107.0000, 'ºC'),
	(312349, 142, '2015-01-15 00:40:05.000000', 'temperatura', 24.0000, 'ºC'),
	(312350, 142, '2015-01-15 00:40:06.000000', 'temperatura', 997.0000, 'ºC'),
	(312351, 142, '2015-01-15 00:40:07.000000', 'temperatura', 116.0000, 'ºC'),
	(312352, 142, '2015-01-15 00:40:08.000000', 'temperatura', 1186.0000, 'ºC'),
	(312353, 142, '2015-01-15 00:40:09.000000', 'temperatura', 785.0000, 'ºC'),
	(312354, 142, '2015-01-15 00:40:10.000000', 'temperatura', 368.0000, 'ºC'),
	(312355, 142, '2015-01-15 00:40:11.000000', 'temperatura', 685.0000, 'ºC'),
	(312356, 142, '2015-01-15 00:40:12.000000', 'temperatura', 1122.0000, 'ºC'),
	(312357, 142, '2015-01-15 00:40:13.000000', 'temperatura', 1154.0000, 'ºC'),
	(312358, 142, '2015-01-15 00:40:14.000000', 'temperatura', 5.0000, 'ºC'),
	(312359, 142, '2015-01-15 00:40:15.000000', 'temperatura', 163.0000, 'ºC'),
	(312360, 142, '2015-01-15 00:40:16.000000', 'temperatura', 803.0000, 'ºC'),
	(312361, 142, '2015-01-15 00:40:17.000000', 'temperatura', 1124.0000, 'ºC'),
	(312362, 142, '2015-01-15 00:40:18.000000', 'temperatura', 810.0000, 'ºC'),
	(312363, 142, '2015-01-15 00:40:19.000000', 'temperatura', 682.0000, 'ºC'),
	(312364, 142, '2015-01-15 00:40:20.000000', 'temperatura', 978.0000, 'ºC'),
	(312365, 142, '2015-01-15 00:40:21.000000', 'temperatura', 447.0000, 'ºC'),
	(312366, 142, '2015-01-15 00:40:22.000000', 'temperatura', 501.0000, 'ºC'),
	(312367, 142, '2015-01-15 00:40:23.000000', 'temperatura', 1166.0000, 'ºC'),
	(312368, 142, '2015-01-15 00:40:24.000000', 'temperatura', 725.0000, 'ºC'),
	(312369, 142, '2015-01-15 00:40:25.000000', 'temperatura', 128.0000, 'ºC'),
	(312370, 142, '2015-01-15 00:40:26.000000', 'temperatura', 867.0000, 'ºC'),
	(312371, 142, '2015-01-15 00:40:27.000000', 'temperatura', 352.0000, 'ºC'),
	(312372, 142, '2015-01-15 00:40:28.000000', 'temperatura', 360.0000, 'ºC'),
	(312373, 142, '2015-01-15 00:40:29.000000', 'temperatura', 743.0000, 'ºC'),
	(312374, 142, '2015-01-15 00:40:30.000000', 'temperatura', 236.0000, 'ºC'),
	(312375, 142, '2015-01-15 00:40:31.000000', 'temperatura', 153.0000, 'ºC'),
	(312376, 142, '2015-01-15 00:40:32.000000', 'temperatura', 58.0000, 'ºC'),
	(312377, 142, '2015-01-15 00:40:33.000000', 'temperatura', 1031.0000, 'ºC'),
	(312378, 142, '2015-01-15 00:40:34.000000', 'temperatura', 179.0000, 'ºC'),
	(312379, 142, '2015-01-15 00:40:35.000000', 'temperatura', 205.0000, 'ºC'),
	(312380, 142, '2015-01-15 00:40:36.000000', 'temperatura', 490.0000, 'ºC'),
	(312381, 142, '2015-01-15 00:40:37.000000', 'temperatura', 632.0000, 'ºC'),
	(312382, 142, '2015-01-15 00:40:38.000000', 'temperatura', 491.0000, 'ºC'),
	(312383, 142, '2015-01-15 00:40:39.000000', 'temperatura', 562.0000, 'ºC'),
	(312384, 142, '2015-01-15 00:40:40.000000', 'temperatura', 135.0000, 'ºC'),
	(312385, 142, '2015-01-15 00:40:41.000000', 'temperatura', 191.0000, 'ºC'),
	(312386, 142, '2015-01-15 00:40:42.000000', 'temperatura', 552.0000, 'ºC'),
	(312387, 142, '2015-01-15 00:40:43.000000', 'temperatura', 985.0000, 'ºC'),
	(312388, 142, '2015-01-15 00:40:44.000000', 'temperatura', 871.0000, 'ºC'),
	(312389, 142, '2015-01-15 00:40:45.000000', 'temperatura', 200.0000, 'ºC'),
	(312390, 142, '2015-01-15 00:40:46.000000', 'temperatura', 786.0000, 'ºC'),
	(312391, 142, '2015-01-15 00:40:47.000000', 'temperatura', 931.0000, 'ºC'),
	(312392, 142, '2015-01-15 00:40:48.000000', 'temperatura', 1098.0000, 'ºC'),
	(312393, 142, '2015-01-15 00:40:49.000000', 'temperatura', 296.0000, 'ºC'),
	(312394, 142, '2015-01-15 00:40:50.000000', 'temperatura', 587.0000, 'ºC'),
	(312395, 142, '2015-01-15 00:40:51.000000', 'temperatura', 848.0000, 'ºC'),
	(312396, 142, '2015-01-15 00:40:52.000000', 'temperatura', 79.0000, 'ºC'),
	(312397, 142, '2015-01-15 00:40:53.000000', 'temperatura', 253.0000, 'ºC'),
	(312398, 142, '2015-01-15 00:40:54.000000', 'temperatura', 1029.0000, 'ºC'),
	(312399, 142, '2015-01-15 00:40:55.000000', 'temperatura', 785.0000, 'ºC'),
	(312400, 142, '2015-01-15 00:40:56.000000', 'temperatura', 837.0000, 'ºC'),
	(312401, 142, '2015-01-15 00:40:57.000000', 'temperatura', 632.0000, 'ºC'),
	(312402, 142, '2015-01-15 00:40:58.000000', 'temperatura', 650.0000, 'ºC'),
	(312403, 142, '2015-01-15 00:40:59.000000', 'temperatura', 154.0000, 'ºC'),
	(312404, 142, '2015-01-15 00:41:00.000000', 'temperatura', 22.0000, 'ºC'),
	(312405, 142, '2015-01-15 00:41:01.000000', 'temperatura', 849.0000, 'ºC'),
	(312406, 142, '2015-01-15 00:41:02.000000', 'temperatura', 577.0000, 'ºC'),
	(312407, 142, '2015-01-15 00:41:03.000000', 'temperatura', 338.0000, 'ºC'),
	(312408, 142, '2015-01-15 00:41:04.000000', 'temperatura', 1159.0000, 'ºC'),
	(312409, 142, '2015-01-15 00:41:05.000000', 'temperatura', 1183.0000, 'ºC'),
	(312410, 142, '2015-01-15 00:41:06.000000', 'temperatura', 37.0000, 'ºC'),
	(312411, 142, '2015-01-15 00:41:07.000000', 'temperatura', 235.0000, 'ºC'),
	(312412, 142, '2015-01-15 00:41:08.000000', 'temperatura', 1068.0000, 'ºC'),
	(312413, 142, '2015-01-15 00:41:09.000000', 'temperatura', 1033.0000, 'ºC'),
	(312414, 142, '2015-01-15 00:41:10.000000', 'temperatura', 764.0000, 'ºC'),
	(312415, 142, '2015-01-15 00:41:11.000000', 'temperatura', 718.0000, 'ºC'),
	(312416, 142, '2015-01-15 00:41:12.000000', 'temperatura', 102.0000, 'ºC'),
	(312417, 142, '2015-01-15 00:41:13.000000', 'temperatura', 755.0000, 'ºC'),
	(312418, 142, '2015-01-15 00:41:14.000000', 'temperatura', 1070.0000, 'ºC'),
	(312419, 142, '2015-01-15 00:41:15.000000', 'temperatura', 684.0000, 'ºC'),
	(312420, 142, '2015-01-15 00:41:16.000000', 'temperatura', 213.0000, 'ºC'),
	(312421, 142, '2015-01-15 00:41:17.000000', 'temperatura', 214.0000, 'ºC'),
	(312422, 142, '2015-01-15 00:41:18.000000', 'temperatura', 431.0000, 'ºC'),
	(312423, 142, '2015-01-15 00:41:19.000000', 'temperatura', 312.0000, 'ºC'),
	(312424, 142, '2015-01-15 00:41:20.000000', 'temperatura', 269.0000, 'ºC'),
	(312425, 142, '2015-01-15 00:41:21.000000', 'temperatura', 408.0000, 'ºC'),
	(312426, 142, '2015-01-15 00:41:22.000000', 'temperatura', 35.0000, 'ºC'),
	(312427, 142, '2015-01-15 00:41:23.000000', 'temperatura', 151.0000, 'ºC'),
	(312428, 142, '2015-01-15 00:41:24.000000', 'temperatura', 649.0000, 'ºC'),
	(312429, 142, '2015-01-15 00:41:25.000000', 'temperatura', 392.0000, 'ºC'),
	(312430, 142, '2015-01-15 00:41:26.000000', 'temperatura', 16.0000, 'ºC'),
	(312431, 142, '2015-01-15 00:41:27.000000', 'temperatura', 102.0000, 'ºC'),
	(312432, 142, '2015-01-15 00:41:28.000000', 'temperatura', 463.0000, 'ºC'),
	(312433, 142, '2015-01-15 00:41:29.000000', 'temperatura', 810.0000, 'ºC'),
	(312434, 142, '2015-01-15 00:41:30.000000', 'temperatura', 264.0000, 'ºC'),
	(312435, 142, '2015-01-15 00:41:31.000000', 'temperatura', 87.0000, 'ºC'),
	(312436, 142, '2015-01-15 00:41:32.000000', 'temperatura', 843.0000, 'ºC'),
	(312437, 142, '2015-01-15 00:41:33.000000', 'temperatura', 357.0000, 'ºC'),
	(312438, 142, '2015-01-15 00:41:34.000000', 'temperatura', 455.0000, 'ºC'),
	(312439, 142, '2015-01-15 00:41:35.000000', 'temperatura', 5.0000, 'ºC'),
	(312440, 142, '2015-01-15 00:41:36.000000', 'temperatura', 1060.0000, 'ºC'),
	(312441, 142, '2015-01-15 00:41:37.000000', 'temperatura', 487.0000, 'ºC'),
	(312442, 142, '2015-01-15 00:41:38.000000', 'temperatura', 456.0000, 'ºC'),
	(312443, 142, '2015-01-15 00:41:39.000000', 'temperatura', 818.0000, 'ºC'),
	(312444, 142, '2015-01-15 00:41:40.000000', 'temperatura', 323.0000, 'ºC'),
	(312445, 142, '2015-01-15 00:41:41.000000', 'temperatura', 361.0000, 'ºC'),
	(312446, 142, '2015-01-15 00:41:42.000000', 'temperatura', 835.0000, 'ºC'),
	(312447, 142, '2015-01-15 00:41:43.000000', 'temperatura', 693.0000, 'ºC'),
	(312448, 142, '2015-01-15 00:41:44.000000', 'temperatura', 961.0000, 'ºC'),
	(312449, 142, '2015-01-15 00:41:45.000000', 'temperatura', 328.0000, 'ºC'),
	(312450, 142, '2015-01-15 00:41:46.000000', 'temperatura', 1156.0000, 'ºC'),
	(312451, 142, '2015-01-15 00:41:47.000000', 'temperatura', 1195.0000, 'ºC'),
	(312452, 142, '2015-01-15 00:41:48.000000', 'temperatura', 109.0000, 'ºC'),
	(312453, 142, '2015-01-15 00:41:49.000000', 'temperatura', 560.0000, 'ºC'),
	(312454, 142, '2015-01-15 00:41:50.000000', 'temperatura', 74.0000, 'ºC'),
	(312455, 142, '2015-01-15 00:41:51.000000', 'temperatura', 1092.0000, 'ºC'),
	(312456, 142, '2015-01-15 00:41:52.000000', 'temperatura', 437.0000, 'ºC'),
	(312457, 142, '2015-01-15 00:41:53.000000', 'temperatura', 111.0000, 'ºC'),
	(312458, 142, '2015-01-15 00:41:54.000000', 'temperatura', 446.0000, 'ºC'),
	(312459, 142, '2015-01-15 00:41:55.000000', 'temperatura', 695.0000, 'ºC'),
	(312460, 142, '2015-01-15 00:41:56.000000', 'temperatura', 937.0000, 'ºC'),
	(312461, 142, '2015-01-15 00:41:57.000000', 'temperatura', 200.0000, 'ºC'),
	(312462, 142, '2015-01-15 00:41:58.000000', 'temperatura', 591.0000, 'ºC'),
	(312463, 142, '2015-01-15 00:41:59.000000', 'temperatura', 1155.0000, 'ºC'),
	(312464, 142, '2015-01-15 00:42:00.000000', 'temperatura', 404.0000, 'ºC'),
	(312465, 142, '2015-01-15 00:42:01.000000', 'temperatura', 952.0000, 'ºC'),
	(312466, 142, '2015-01-15 00:42:02.000000', 'temperatura', 1152.0000, 'ºC'),
	(312467, 142, '2015-01-15 00:42:03.000000', 'temperatura', 503.0000, 'ºC'),
	(312468, 142, '2015-01-15 00:42:04.000000', 'temperatura', 260.0000, 'ºC'),
	(312469, 142, '2015-01-15 00:42:05.000000', 'temperatura', 989.0000, 'ºC'),
	(312470, 142, '2015-01-15 00:42:06.000000', 'temperatura', 568.0000, 'ºC'),
	(312471, 142, '2015-01-15 00:42:07.000000', 'temperatura', 1073.0000, 'ºC'),
	(312472, 142, '2015-01-15 00:42:08.000000', 'temperatura', 60.0000, 'ºC'),
	(312473, 142, '2015-01-15 00:42:09.000000', 'temperatura', 681.0000, 'ºC'),
	(312474, 142, '2015-01-15 00:42:10.000000', 'temperatura', 826.0000, 'ºC'),
	(312475, 142, '2015-01-15 00:42:11.000000', 'temperatura', 888.0000, 'ºC'),
	(312476, 142, '2015-01-15 00:42:12.000000', 'temperatura', 762.0000, 'ºC'),
	(312477, 142, '2015-01-15 00:42:13.000000', 'temperatura', 1146.0000, 'ºC'),
	(312478, 142, '2015-01-15 00:42:14.000000', 'temperatura', 1045.0000, 'ºC'),
	(312479, 142, '2015-01-15 00:42:15.000000', 'temperatura', 589.0000, 'ºC'),
	(312480, 142, '2015-01-15 00:42:16.000000', 'temperatura', 1011.0000, 'ºC'),
	(312481, 142, '2015-01-15 00:42:17.000000', 'temperatura', 889.0000, 'ºC'),
	(312482, 142, '2015-01-15 00:42:18.000000', 'temperatura', 210.0000, 'ºC'),
	(312483, 142, '2015-01-15 00:42:19.000000', 'temperatura', 786.0000, 'ºC'),
	(312484, 142, '2015-01-15 00:42:20.000000', 'temperatura', 899.0000, 'ºC'),
	(312485, 142, '2015-01-15 00:42:21.000000', 'temperatura', 940.0000, 'ºC'),
	(312486, 142, '2015-01-15 00:42:22.000000', 'temperatura', 801.0000, 'ºC'),
	(312487, 142, '2015-01-15 00:42:23.000000', 'temperatura', 1188.0000, 'ºC'),
	(312488, 142, '2015-01-15 00:42:24.000000', 'temperatura', 1134.0000, 'ºC'),
	(312489, 142, '2015-01-15 00:42:25.000000', 'temperatura', 909.0000, 'ºC'),
	(312490, 142, '2015-01-15 00:42:26.000000', 'temperatura', 1141.0000, 'ºC'),
	(312491, 142, '2015-01-15 00:42:27.000000', 'temperatura', 579.0000, 'ºC'),
	(312492, 142, '2015-01-15 00:42:28.000000', 'temperatura', 671.0000, 'ºC'),
	(312493, 142, '2015-01-15 00:42:29.000000', 'temperatura', 421.0000, 'ºC'),
	(312494, 142, '2015-01-15 00:42:30.000000', 'temperatura', 91.0000, 'ºC'),
	(312495, 142, '2015-01-15 00:42:31.000000', 'temperatura', 393.0000, 'ºC'),
	(312496, 142, '2015-01-15 00:42:32.000000', 'temperatura', 494.0000, 'ºC'),
	(312497, 142, '2015-01-15 00:42:33.000000', 'temperatura', 91.0000, 'ºC'),
	(312498, 142, '2015-01-15 00:42:34.000000', 'temperatura', 171.0000, 'ºC'),
	(312499, 142, '2015-01-15 00:42:35.000000', 'temperatura', 586.0000, 'ºC'),
	(312500, 142, '2015-01-15 00:42:36.000000', 'temperatura', 15.0000, 'ºC'),
	(312501, 142, '2015-01-15 00:42:37.000000', 'temperatura', 720.0000, 'ºC'),
	(312502, 142, '2015-01-15 00:42:38.000000', 'temperatura', 1154.0000, 'ºC'),
	(312503, 142, '2015-01-15 00:42:39.000000', 'temperatura', 10.0000, 'ºC'),
	(312504, 142, '2015-01-15 00:42:40.000000', 'temperatura', 191.0000, 'ºC'),
	(312505, 142, '2015-01-15 00:42:41.000000', 'temperatura', 924.0000, 'ºC'),
	(312506, 142, '2015-01-15 00:42:42.000000', 'temperatura', 448.0000, 'ºC'),
	(312507, 142, '2015-01-15 00:42:43.000000', 'temperatura', 670.0000, 'ºC'),
	(312508, 142, '2015-01-15 00:42:44.000000', 'temperatura', 804.0000, 'ºC'),
	(312509, 142, '2015-01-15 00:42:45.000000', 'temperatura', 810.0000, 'ºC'),
	(312510, 142, '2015-01-15 00:42:46.000000', 'temperatura', 440.0000, 'ºC'),
	(312511, 142, '2015-01-15 00:42:47.000000', 'temperatura', 970.0000, 'ºC'),
	(312512, 142, '2015-01-15 00:42:48.000000', 'temperatura', 1129.0000, 'ºC'),
	(312513, 142, '2015-01-15 00:42:49.000000', 'temperatura', 338.0000, 'ºC'),
	(312514, 142, '2015-01-15 00:42:50.000000', 'temperatura', 704.0000, 'ºC'),
	(312515, 142, '2015-01-15 00:42:51.000000', 'temperatura', 106.0000, 'ºC'),
	(312516, 142, '2015-01-15 00:42:52.000000', 'temperatura', 817.0000, 'ºC'),
	(312517, 142, '2015-01-15 00:42:53.000000', 'temperatura', 167.0000, 'ºC'),
	(312518, 142, '2015-01-15 00:42:54.000000', 'temperatura', 784.0000, 'ºC'),
	(312519, 142, '2015-01-15 00:42:55.000000', 'temperatura', 1019.0000, 'ºC'),
	(312520, 142, '2015-01-15 00:42:56.000000', 'temperatura', 347.0000, 'ºC'),
	(312521, 142, '2015-01-15 00:42:57.000000', 'temperatura', 1075.0000, 'ºC'),
	(312522, 142, '2015-01-15 00:42:58.000000', 'temperatura', 735.0000, 'ºC'),
	(312523, 142, '2015-01-15 00:42:59.000000', 'temperatura', 449.0000, 'ºC'),
	(312524, 142, '2015-01-15 00:43:00.000000', 'temperatura', 42.0000, 'ºC'),
	(312525, 142, '2015-01-15 00:43:01.000000', 'temperatura', 64.0000, 'ºC'),
	(312526, 142, '2015-01-15 00:43:02.000000', 'temperatura', 192.0000, 'ºC'),
	(312527, 142, '2015-01-15 00:43:03.000000', 'temperatura', 772.0000, 'ºC'),
	(312528, 142, '2015-01-15 00:43:04.000000', 'temperatura', 883.0000, 'ºC'),
	(312529, 142, '2015-01-15 00:43:05.000000', 'temperatura', 899.0000, 'ºC'),
	(312530, 142, '2015-01-15 00:43:06.000000', 'temperatura', 646.0000, 'ºC'),
	(312531, 142, '2015-01-15 00:43:07.000000', 'temperatura', 532.0000, 'ºC'),
	(312532, 142, '2015-01-15 00:43:08.000000', 'temperatura', 725.0000, 'ºC'),
	(312533, 142, '2015-01-15 00:43:09.000000', 'temperatura', 830.0000, 'ºC'),
	(312534, 142, '2015-01-15 00:43:10.000000', 'temperatura', 773.0000, 'ºC'),
	(312535, 142, '2015-01-15 00:43:11.000000', 'temperatura', 177.0000, 'ºC'),
	(312536, 142, '2015-01-15 00:43:12.000000', 'temperatura', 967.0000, 'ºC'),
	(312537, 142, '2015-01-15 00:43:13.000000', 'temperatura', 702.0000, 'ºC'),
	(312538, 142, '2015-01-15 00:43:14.000000', 'temperatura', 611.0000, 'ºC'),
	(312539, 142, '2015-01-15 00:43:15.000000', 'temperatura', 948.0000, 'ºC'),
	(312540, 142, '2015-01-15 00:43:16.000000', 'temperatura', 509.0000, 'ºC'),
	(312541, 142, '2015-01-15 00:43:17.000000', 'temperatura', 901.0000, 'ºC'),
	(312542, 142, '2015-01-15 00:43:18.000000', 'temperatura', 578.0000, 'ºC'),
	(312543, 142, '2015-01-15 00:43:19.000000', 'temperatura', 188.0000, 'ºC'),
	(312544, 142, '2015-01-15 00:43:20.000000', 'temperatura', 407.0000, 'ºC'),
	(312545, 142, '2015-01-15 00:43:21.000000', 'temperatura', 269.0000, 'ºC'),
	(312546, 142, '2015-01-15 00:43:22.000000', 'temperatura', 127.0000, 'ºC'),
	(312547, 142, '2015-01-15 00:43:23.000000', 'temperatura', 1027.0000, 'ºC'),
	(312548, 142, '2015-01-15 00:43:24.000000', 'temperatura', 1156.0000, 'ºC'),
	(312549, 142, '2015-01-15 00:43:25.000000', 'temperatura', 299.0000, 'ºC'),
	(312550, 142, '2015-01-15 00:43:26.000000', 'temperatura', 427.0000, 'ºC'),
	(312551, 142, '2015-01-15 00:43:27.000000', 'temperatura', 41.0000, 'ºC'),
	(312552, 142, '2015-01-15 00:43:28.000000', 'temperatura', 121.0000, 'ºC'),
	(312553, 142, '2015-01-15 00:43:29.000000', 'temperatura', 486.0000, 'ºC'),
	(312554, 142, '2015-01-15 00:43:30.000000', 'temperatura', 864.0000, 'ºC'),
	(312555, 142, '2015-01-15 00:43:31.000000', 'temperatura', 465.0000, 'ºC'),
	(312556, 142, '2015-01-15 00:43:32.000000', 'temperatura', 932.0000, 'ºC'),
	(312557, 142, '2015-01-15 00:43:33.000000', 'temperatura', 865.0000, 'ºC'),
	(312558, 142, '2015-01-15 00:43:34.000000', 'temperatura', 328.0000, 'ºC'),
	(312559, 142, '2015-01-15 00:43:35.000000', 'temperatura', 248.0000, 'ºC'),
	(312560, 142, '2015-01-15 00:43:36.000000', 'temperatura', 256.0000, 'ºC'),
	(312561, 142, '2015-01-15 00:43:37.000000', 'temperatura', 537.0000, 'ºC'),
	(312562, 142, '2015-01-15 00:43:38.000000', 'temperatura', 719.0000, 'ºC'),
	(312563, 142, '2015-01-15 00:43:39.000000', 'temperatura', 782.0000, 'ºC'),
	(312564, 142, '2015-01-15 00:43:40.000000', 'temperatura', 555.0000, 'ºC'),
	(312565, 142, '2015-01-15 00:43:41.000000', 'temperatura', 428.0000, 'ºC'),
	(312566, 142, '2015-01-15 00:43:42.000000', 'temperatura', 476.0000, 'ºC'),
	(312567, 142, '2015-01-15 00:43:43.000000', 'temperatura', 1096.0000, 'ºC'),
	(312568, 142, '2015-01-15 00:43:44.000000', 'temperatura', 453.0000, 'ºC'),
	(312569, 142, '2015-01-15 00:43:45.000000', 'temperatura', 179.0000, 'ºC'),
	(312570, 142, '2015-01-15 00:43:46.000000', 'temperatura', 737.0000, 'ºC'),
	(312571, 142, '2015-01-15 00:43:47.000000', 'temperatura', 747.0000, 'ºC'),
	(312572, 142, '2015-01-15 00:43:48.000000', 'temperatura', 323.0000, 'ºC'),
	(312573, 142, '2015-01-15 00:43:49.000000', 'temperatura', 576.0000, 'ºC'),
	(312574, 142, '2015-01-15 00:43:50.000000', 'temperatura', 710.0000, 'ºC'),
	(312575, 142, '2015-01-15 00:43:51.000000', 'temperatura', 622.0000, 'ºC'),
	(312576, 142, '2015-01-15 00:43:52.000000', 'temperatura', 980.0000, 'ºC'),
	(312577, 142, '2015-01-15 00:43:53.000000', 'temperatura', 638.0000, 'ºC'),
	(312578, 142, '2015-01-15 00:43:54.000000', 'temperatura', 247.0000, 'ºC'),
	(312579, 142, '2015-01-15 00:43:55.000000', 'temperatura', 521.0000, 'ºC'),
	(312580, 142, '2015-01-15 00:43:56.000000', 'temperatura', 668.0000, 'ºC'),
	(312581, 142, '2015-01-15 00:43:57.000000', 'temperatura', 575.0000, 'ºC'),
	(312582, 142, '2015-01-15 00:43:58.000000', 'temperatura', 872.0000, 'ºC'),
	(312583, 142, '2015-01-15 00:43:59.000000', 'temperatura', 237.0000, 'ºC'),
	(312584, 142, '2015-01-15 00:44:00.000000', 'temperatura', 970.0000, 'ºC'),
	(312585, 142, '2015-01-15 00:44:01.000000', 'temperatura', 539.0000, 'ºC'),
	(312586, 142, '2015-01-15 00:44:02.000000', 'temperatura', 985.0000, 'ºC'),
	(312587, 142, '2015-01-15 00:44:03.000000', 'temperatura', 908.0000, 'ºC'),
	(312588, 142, '2015-01-15 00:44:04.000000', 'temperatura', 387.0000, 'ºC'),
	(312589, 142, '2015-01-15 00:44:05.000000', 'temperatura', 410.0000, 'ºC'),
	(312590, 142, '2015-01-15 00:44:06.000000', 'temperatura', 892.0000, 'ºC'),
	(312591, 142, '2015-01-15 00:44:07.000000', 'temperatura', 829.0000, 'ºC'),
	(312592, 142, '2015-01-15 00:44:08.000000', 'temperatura', 269.0000, 'ºC'),
	(312593, 142, '2015-01-15 00:44:09.000000', 'temperatura', 60.0000, 'ºC'),
	(312594, 142, '2015-01-15 00:44:10.000000', 'temperatura', 692.0000, 'ºC'),
	(312595, 142, '2015-01-15 00:44:11.000000', 'temperatura', 880.0000, 'ºC'),
	(312596, 142, '2015-01-15 00:44:12.000000', 'temperatura', 1127.0000, 'ºC'),
	(312597, 142, '2015-01-15 00:44:13.000000', 'temperatura', 596.0000, 'ºC'),
	(312598, 142, '2015-01-15 00:44:14.000000', 'temperatura', 797.0000, 'ºC'),
	(312599, 142, '2015-01-15 00:44:15.000000', 'temperatura', 997.0000, 'ºC'),
	(312600, 142, '2015-01-15 00:44:16.000000', 'temperatura', 196.0000, 'ºC'),
	(312601, 142, '2015-01-15 00:44:17.000000', 'temperatura', 387.0000, 'ºC'),
	(312602, 142, '2015-01-15 00:44:18.000000', 'temperatura', 151.0000, 'ºC'),
	(312603, 142, '2015-01-15 00:44:19.000000', 'temperatura', 791.0000, 'ºC'),
	(312604, 142, '2015-01-15 00:44:20.000000', 'temperatura', 1104.0000, 'ºC'),
	(312605, 142, '2015-01-15 00:44:21.000000', 'temperatura', 747.0000, 'ºC'),
	(312606, 142, '2015-01-15 00:44:22.000000', 'temperatura', 424.0000, 'ºC'),
	(312607, 142, '2015-01-15 00:44:23.000000', 'temperatura', 1077.0000, 'ºC'),
	(312608, 142, '2015-01-15 00:44:24.000000', 'temperatura', 516.0000, 'ºC'),
	(312609, 142, '2015-01-15 00:44:25.000000', 'temperatura', 550.0000, 'ºC'),
	(312610, 142, '2015-01-15 00:44:26.000000', 'temperatura', 4.0000, 'ºC'),
	(312611, 142, '2015-01-15 00:44:27.000000', 'temperatura', 768.0000, 'ºC'),
	(312612, 142, '2015-01-15 00:44:28.000000', 'temperatura', 229.0000, 'ºC'),
	(312613, 142, '2015-01-15 00:44:29.000000', 'temperatura', 43.0000, 'ºC'),
	(312614, 142, '2015-01-15 00:44:30.000000', 'temperatura', 729.0000, 'ºC'),
	(312615, 142, '2015-01-15 00:44:31.000000', 'temperatura', 1116.0000, 'ºC'),
	(312616, 142, '2015-01-15 00:44:32.000000', 'temperatura', 994.0000, 'ºC'),
	(312617, 142, '2015-01-15 00:44:33.000000', 'temperatura', 423.0000, 'ºC'),
	(312618, 142, '2015-01-15 00:44:34.000000', 'temperatura', 331.0000, 'ºC'),
	(312619, 142, '2015-01-15 00:44:35.000000', 'temperatura', 387.0000, 'ºC'),
	(312620, 142, '2015-01-15 00:44:36.000000', 'temperatura', 942.0000, 'ºC'),
	(312621, 142, '2015-01-15 00:44:37.000000', 'temperatura', 1148.0000, 'ºC'),
	(312622, 142, '2015-01-15 00:44:38.000000', 'temperatura', 517.0000, 'ºC'),
	(312623, 142, '2015-01-15 00:44:39.000000', 'temperatura', 339.0000, 'ºC'),
	(312624, 142, '2015-01-15 00:44:40.000000', 'temperatura', 146.0000, 'ºC'),
	(312625, 142, '2015-01-15 00:44:41.000000', 'temperatura', 915.0000, 'ºC'),
	(312626, 142, '2015-01-15 00:44:42.000000', 'temperatura', 536.0000, 'ºC'),
	(312627, 142, '2015-01-15 00:44:43.000000', 'temperatura', 1137.0000, 'ºC'),
	(312628, 142, '2015-01-15 00:44:44.000000', 'temperatura', 477.0000, 'ºC'),
	(312629, 142, '2015-01-15 00:44:45.000000', 'temperatura', 175.0000, 'ºC'),
	(312630, 142, '2015-01-15 00:44:46.000000', 'temperatura', 643.0000, 'ºC'),
	(312631, 142, '2015-01-15 00:44:47.000000', 'temperatura', 290.0000, 'ºC'),
	(312632, 142, '2015-01-15 00:44:48.000000', 'temperatura', 720.0000, 'ºC'),
	(312633, 142, '2015-01-15 00:44:49.000000', 'temperatura', 333.0000, 'ºC'),
	(312634, 142, '2015-01-15 00:44:50.000000', 'temperatura', 706.0000, 'ºC'),
	(312635, 142, '2015-01-15 00:44:51.000000', 'temperatura', 130.0000, 'ºC'),
	(312636, 142, '2015-01-15 00:44:52.000000', 'temperatura', 934.0000, 'ºC'),
	(312637, 142, '2015-01-15 00:44:53.000000', 'temperatura', 682.0000, 'ºC'),
	(312638, 142, '2015-01-15 00:44:54.000000', 'temperatura', 607.0000, 'ºC'),
	(312639, 142, '2015-01-15 00:44:55.000000', 'temperatura', 988.0000, 'ºC'),
	(312640, 142, '2015-01-15 00:44:56.000000', 'temperatura', 720.0000, 'ºC'),
	(312641, 142, '2015-01-15 00:44:57.000000', 'temperatura', 638.0000, 'ºC'),
	(312642, 142, '2015-01-15 00:44:58.000000', 'temperatura', 1028.0000, 'ºC'),
	(312643, 142, '2015-01-15 00:44:59.000000', 'temperatura', 827.0000, 'ºC'),
	(312644, 142, '2015-01-15 00:45:00.000000', 'temperatura', 1050.0000, 'ºC'),
	(312645, 142, '2015-01-15 00:45:01.000000', 'temperatura', 373.0000, 'ºC'),
	(312646, 142, '2015-01-15 00:45:02.000000', 'temperatura', 1112.0000, 'ºC'),
	(312647, 142, '2015-01-15 00:45:03.000000', 'temperatura', 844.0000, 'ºC'),
	(312648, 142, '2015-01-15 00:45:04.000000', 'temperatura', 884.0000, 'ºC'),
	(312649, 142, '2015-01-15 00:45:05.000000', 'temperatura', 690.0000, 'ºC'),
	(312650, 142, '2015-01-15 00:45:06.000000', 'temperatura', 798.0000, 'ºC'),
	(312651, 142, '2015-01-15 00:45:07.000000', 'temperatura', 720.0000, 'ºC'),
	(312652, 142, '2015-01-15 00:45:08.000000', 'temperatura', 6.0000, 'ºC'),
	(312653, 142, '2015-01-15 00:45:09.000000', 'temperatura', 270.0000, 'ºC'),
	(312654, 142, '2015-01-15 00:45:10.000000', 'temperatura', 134.0000, 'ºC'),
	(312655, 142, '2015-01-15 00:45:11.000000', 'temperatura', 1061.0000, 'ºC'),
	(312656, 142, '2015-01-15 00:45:12.000000', 'temperatura', 104.0000, 'ºC'),
	(312657, 142, '2015-01-15 00:45:13.000000', 'temperatura', 938.0000, 'ºC'),
	(312658, 142, '2015-01-15 00:45:14.000000', 'temperatura', 776.0000, 'ºC'),
	(312659, 142, '2015-01-15 00:45:15.000000', 'temperatura', 1066.0000, 'ºC'),
	(312660, 142, '2015-01-15 00:45:16.000000', 'temperatura', 602.0000, 'ºC'),
	(312661, 142, '2015-01-15 00:45:17.000000', 'temperatura', 1013.0000, 'ºC'),
	(312662, 142, '2015-01-15 00:45:18.000000', 'temperatura', 859.0000, 'ºC'),
	(312663, 142, '2015-01-15 00:45:19.000000', 'temperatura', 56.0000, 'ºC'),
	(312664, 142, '2015-01-15 00:45:20.000000', 'temperatura', 105.0000, 'ºC'),
	(312665, 142, '2015-01-15 00:45:21.000000', 'temperatura', 356.0000, 'ºC'),
	(312666, 142, '2015-01-15 00:45:22.000000', 'temperatura', 265.0000, 'ºC'),
	(312667, 142, '2015-01-15 00:45:23.000000', 'temperatura', 257.0000, 'ºC'),
	(312668, 142, '2015-01-15 00:45:24.000000', 'temperatura', 492.0000, 'ºC'),
	(312669, 142, '2015-01-15 00:45:25.000000', 'temperatura', 487.0000, 'ºC'),
	(312670, 142, '2015-01-15 00:45:26.000000', 'temperatura', 961.0000, 'ºC'),
	(312671, 142, '2015-01-15 00:45:27.000000', 'temperatura', 944.0000, 'ºC'),
	(312672, 142, '2015-01-15 00:45:28.000000', 'temperatura', 639.0000, 'ºC'),
	(312673, 142, '2015-01-15 00:45:29.000000', 'temperatura', 362.0000, 'ºC'),
	(312674, 142, '2015-01-15 00:45:30.000000', 'temperatura', 1093.0000, 'ºC'),
	(312675, 142, '2015-01-15 00:45:31.000000', 'temperatura', 779.0000, 'ºC'),
	(312676, 142, '2015-01-15 00:45:32.000000', 'temperatura', 616.0000, 'ºC'),
	(312677, 142, '2015-01-15 00:45:33.000000', 'temperatura', 746.0000, 'ºC'),
	(312678, 142, '2015-01-15 00:45:34.000000', 'temperatura', 681.0000, 'ºC'),
	(312679, 142, '2015-01-15 00:45:35.000000', 'temperatura', 1167.0000, 'ºC'),
	(312680, 142, '2015-01-15 00:45:36.000000', 'temperatura', 193.0000, 'ºC'),
	(312681, 142, '2015-01-15 00:45:37.000000', 'temperatura', 1063.0000, 'ºC'),
	(312682, 142, '2015-01-15 00:45:38.000000', 'temperatura', 1138.0000, 'ºC'),
	(312683, 142, '2015-01-15 00:45:39.000000', 'temperatura', 102.0000, 'ºC'),
	(312684, 142, '2015-01-15 00:45:40.000000', 'temperatura', 697.0000, 'ºC'),
	(312685, 142, '2015-01-15 00:45:41.000000', 'temperatura', 780.0000, 'ºC'),
	(312686, 142, '2015-01-15 00:45:42.000000', 'temperatura', 608.0000, 'ºC'),
	(312687, 142, '2015-01-15 00:45:43.000000', 'temperatura', 702.0000, 'ºC'),
	(312688, 142, '2015-01-15 00:45:44.000000', 'temperatura', 488.0000, 'ºC'),
	(312689, 142, '2015-01-15 00:45:45.000000', 'temperatura', 331.0000, 'ºC'),
	(312690, 142, '2015-01-15 00:45:46.000000', 'temperatura', 194.0000, 'ºC'),
	(312691, 142, '2015-01-15 00:45:47.000000', 'temperatura', 1177.0000, 'ºC'),
	(312692, 142, '2015-01-15 00:45:48.000000', 'temperatura', 501.0000, 'ºC'),
	(312693, 142, '2015-01-15 00:45:49.000000', 'temperatura', 178.0000, 'ºC'),
	(312694, 142, '2015-01-15 00:45:50.000000', 'temperatura', 586.0000, 'ºC'),
	(312695, 142, '2015-01-15 00:45:51.000000', 'temperatura', 1198.0000, 'ºC'),
	(312696, 142, '2015-01-15 00:45:52.000000', 'temperatura', 630.0000, 'ºC'),
	(312697, 142, '2015-01-15 00:45:53.000000', 'temperatura', 758.0000, 'ºC'),
	(312698, 142, '2015-01-15 00:45:54.000000', 'temperatura', 699.0000, 'ºC'),
	(312699, 142, '2015-01-15 00:45:55.000000', 'temperatura', 21.0000, 'ºC'),
	(312700, 142, '2015-01-15 00:45:56.000000', 'temperatura', 409.0000, 'ºC'),
	(312701, 142, '2015-01-15 00:45:57.000000', 'temperatura', 783.0000, 'ºC'),
	(312702, 142, '2015-01-15 00:45:58.000000', 'temperatura', 290.0000, 'ºC'),
	(312703, 142, '2015-01-15 00:45:59.000000', 'temperatura', 302.0000, 'ºC'),
	(312704, 142, '2015-01-15 00:46:00.000000', 'temperatura', 641.0000, 'ºC'),
	(312705, 142, '2015-01-15 00:46:01.000000', 'temperatura', 1097.0000, 'ºC'),
	(312706, 142, '2015-01-15 00:46:02.000000', 'temperatura', 1164.0000, 'ºC'),
	(312707, 142, '2015-01-15 00:46:03.000000', 'temperatura', 130.0000, 'ºC'),
	(312708, 142, '2015-01-15 00:46:04.000000', 'temperatura', 757.0000, 'ºC'),
	(312709, 142, '2015-01-15 00:46:05.000000', 'temperatura', 996.0000, 'ºC'),
	(312710, 142, '2015-01-15 00:46:06.000000', 'temperatura', 310.0000, 'ºC'),
	(312711, 142, '2015-01-15 00:46:07.000000', 'temperatura', 961.0000, 'ºC'),
	(312712, 142, '2015-01-15 00:46:08.000000', 'temperatura', 275.0000, 'ºC'),
	(312713, 142, '2015-01-15 00:46:09.000000', 'temperatura', 895.0000, 'ºC'),
	(312714, 142, '2015-01-15 00:46:10.000000', 'temperatura', 49.0000, 'ºC'),
	(312715, 142, '2015-01-15 00:46:11.000000', 'temperatura', 1162.0000, 'ºC'),
	(312716, 142, '2015-01-15 00:46:12.000000', 'temperatura', 864.0000, 'ºC'),
	(312717, 142, '2015-01-15 00:46:13.000000', 'temperatura', 833.0000, 'ºC'),
	(312718, 142, '2015-01-15 00:46:14.000000', 'temperatura', 376.0000, 'ºC'),
	(312719, 142, '2015-01-15 00:46:15.000000', 'temperatura', 579.0000, 'ºC'),
	(312720, 142, '2015-01-15 00:46:16.000000', 'temperatura', 568.0000, 'ºC'),
	(312721, 142, '2015-01-15 00:46:17.000000', 'temperatura', 1104.0000, 'ºC'),
	(312722, 142, '2015-01-15 00:46:18.000000', 'temperatura', 216.0000, 'ºC'),
	(312723, 142, '2015-01-15 00:46:19.000000', 'temperatura', 168.0000, 'ºC'),
	(312724, 142, '2015-01-15 00:46:20.000000', 'temperatura', 194.0000, 'ºC'),
	(312725, 142, '2015-01-15 00:46:21.000000', 'temperatura', 467.0000, 'ºC'),
	(312726, 142, '2015-01-15 00:46:22.000000', 'temperatura', 554.0000, 'ºC'),
	(312727, 142, '2015-01-15 00:46:23.000000', 'temperatura', 169.0000, 'ºC'),
	(312728, 142, '2015-01-15 00:46:24.000000', 'temperatura', 384.0000, 'ºC'),
	(312729, 142, '2015-01-15 00:46:25.000000', 'temperatura', 212.0000, 'ºC'),
	(312730, 142, '2015-01-15 00:46:26.000000', 'temperatura', 1110.0000, 'ºC'),
	(312731, 142, '2015-01-15 00:46:27.000000', 'temperatura', 113.0000, 'ºC'),
	(312732, 142, '2015-01-15 00:46:28.000000', 'temperatura', 835.0000, 'ºC'),
	(312733, 142, '2015-01-15 00:46:29.000000', 'temperatura', 236.0000, 'ºC'),
	(312734, 142, '2015-01-15 00:46:30.000000', 'temperatura', 1077.0000, 'ºC'),
	(312735, 142, '2015-01-15 00:46:31.000000', 'temperatura', 1077.0000, 'ºC'),
	(312736, 142, '2015-01-15 00:46:32.000000', 'temperatura', 957.0000, 'ºC'),
	(312737, 142, '2015-01-15 00:46:33.000000', 'temperatura', 351.0000, 'ºC'),
	(312738, 142, '2015-01-15 00:46:34.000000', 'temperatura', 88.0000, 'ºC'),
	(312739, 142, '2015-01-15 00:46:35.000000', 'temperatura', 585.0000, 'ºC'),
	(312740, 142, '2015-01-15 00:46:36.000000', 'temperatura', 261.0000, 'ºC'),
	(312741, 142, '2015-01-15 00:46:37.000000', 'temperatura', 751.0000, 'ºC'),
	(312742, 142, '2015-01-15 00:46:38.000000', 'temperatura', 571.0000, 'ºC'),
	(312743, 142, '2015-01-15 00:46:39.000000', 'temperatura', 604.0000, 'ºC'),
	(312744, 142, '2015-01-15 00:46:40.000000', 'temperatura', 105.0000, 'ºC'),
	(312745, 142, '2015-01-15 00:46:41.000000', 'temperatura', 1117.0000, 'ºC'),
	(312746, 142, '2015-01-15 00:46:42.000000', 'temperatura', 470.0000, 'ºC'),
	(312747, 142, '2015-01-15 00:46:43.000000', 'temperatura', 199.0000, 'ºC'),
	(312748, 142, '2015-01-15 00:46:44.000000', 'temperatura', 784.0000, 'ºC'),
	(312749, 142, '2015-01-15 00:46:45.000000', 'temperatura', 925.0000, 'ºC'),
	(312750, 142, '2015-01-15 00:46:46.000000', 'temperatura', 1074.0000, 'ºC'),
	(312751, 142, '2015-01-15 00:46:47.000000', 'temperatura', 194.0000, 'ºC'),
	(312752, 142, '2015-01-15 00:46:48.000000', 'temperatura', 151.0000, 'ºC'),
	(312753, 142, '2015-01-15 00:46:49.000000', 'temperatura', 172.0000, 'ºC'),
	(312754, 142, '2015-01-15 00:46:50.000000', 'temperatura', 409.0000, 'ºC'),
	(312755, 142, '2015-01-15 00:46:51.000000', 'temperatura', 330.0000, 'ºC'),
	(312756, 142, '2015-01-15 00:46:52.000000', 'temperatura', 424.0000, 'ºC'),
	(312757, 142, '2015-01-15 00:46:53.000000', 'temperatura', 1130.0000, 'ºC'),
	(312758, 142, '2015-01-15 00:46:54.000000', 'temperatura', 779.0000, 'ºC'),
	(312759, 142, '2015-01-15 00:46:55.000000', 'temperatura', 505.0000, 'ºC'),
	(312760, 142, '2015-01-15 00:46:56.000000', 'temperatura', 187.0000, 'ºC'),
	(312761, 142, '2015-01-15 00:46:57.000000', 'temperatura', 623.0000, 'ºC'),
	(312762, 142, '2015-01-15 00:46:58.000000', 'temperatura', 152.0000, 'ºC'),
	(312763, 142, '2015-01-15 00:46:59.000000', 'temperatura', 92.0000, 'ºC'),
	(312764, 142, '2015-01-15 00:47:00.000000', 'temperatura', 6.0000, 'ºC'),
	(312765, 142, '2015-01-15 00:47:01.000000', 'temperatura', 954.0000, 'ºC'),
	(312766, 142, '2015-01-15 00:47:02.000000', 'temperatura', 1154.0000, 'ºC'),
	(312767, 142, '2015-01-15 00:47:03.000000', 'temperatura', 506.0000, 'ºC'),
	(312768, 142, '2015-01-15 00:47:04.000000', 'temperatura', 269.0000, 'ºC'),
	(312769, 142, '2015-01-15 00:47:05.000000', 'temperatura', 1028.0000, 'ºC'),
	(312770, 142, '2015-01-15 00:47:06.000000', 'temperatura', 734.0000, 'ºC'),
	(312771, 142, '2015-01-15 00:47:07.000000', 'temperatura', 586.0000, 'ºC'),
	(312772, 142, '2015-01-15 00:47:08.000000', 'temperatura', 727.0000, 'ºC'),
	(312773, 142, '2015-01-15 00:47:09.000000', 'temperatura', 677.0000, 'ºC'),
	(312774, 142, '2015-01-15 00:47:10.000000', 'temperatura', 5.0000, 'ºC'),
	(312775, 142, '2015-01-15 00:47:11.000000', 'temperatura', 393.0000, 'ºC'),
	(312776, 142, '2015-01-15 00:47:12.000000', 'temperatura', 753.0000, 'ºC'),
	(312777, 142, '2015-01-15 00:47:13.000000', 'temperatura', 185.0000, 'ºC'),
	(312778, 142, '2015-01-15 00:47:14.000000', 'temperatura', 1069.0000, 'ºC'),
	(312779, 142, '2015-01-15 00:47:15.000000', 'temperatura', 1187.0000, 'ºC'),
	(312780, 142, '2015-01-15 00:47:16.000000', 'temperatura', 332.0000, 'ºC'),
	(312781, 142, '2015-01-15 00:47:17.000000', 'temperatura', 497.0000, 'ºC'),
	(312782, 142, '2015-01-15 00:47:18.000000', 'temperatura', 290.0000, 'ºC'),
	(312783, 142, '2015-01-15 00:47:19.000000', 'temperatura', 1160.0000, 'ºC'),
	(312784, 142, '2015-01-15 00:47:20.000000', 'temperatura', 132.0000, 'ºC'),
	(312785, 142, '2015-01-15 00:47:21.000000', 'temperatura', 778.0000, 'ºC'),
	(312786, 142, '2015-01-15 00:47:22.000000', 'temperatura', 1094.0000, 'ºC'),
	(312787, 142, '2015-01-15 00:47:23.000000', 'temperatura', 738.0000, 'ºC'),
	(312788, 142, '2015-01-15 00:47:24.000000', 'temperatura', 408.0000, 'ºC'),
	(312789, 142, '2015-01-15 00:47:25.000000', 'temperatura', 1025.0000, 'ºC'),
	(312790, 142, '2015-01-15 00:47:26.000000', 'temperatura', 301.0000, 'ºC'),
	(312791, 142, '2015-01-15 00:47:27.000000', 'temperatura', 831.0000, 'ºC'),
	(312792, 142, '2015-01-15 00:47:28.000000', 'temperatura', 852.0000, 'ºC'),
	(312793, 142, '2015-01-15 00:47:29.000000', 'temperatura', 567.0000, 'ºC'),
	(312794, 142, '2015-01-15 00:47:30.000000', 'temperatura', 282.0000, 'ºC'),
	(312795, 142, '2015-01-15 00:47:31.000000', 'temperatura', 907.0000, 'ºC'),
	(312796, 142, '2015-01-15 00:47:32.000000', 'temperatura', 91.0000, 'ºC'),
	(312797, 142, '2015-01-15 00:47:33.000000', 'temperatura', 134.0000, 'ºC'),
	(312798, 142, '2015-01-15 00:47:34.000000', 'temperatura', 396.0000, 'ºC'),
	(312799, 142, '2015-01-15 00:47:35.000000', 'temperatura', 378.0000, 'ºC'),
	(312800, 142, '2015-01-15 00:47:36.000000', 'temperatura', 702.0000, 'ºC'),
	(312801, 142, '2015-01-15 00:47:37.000000', 'temperatura', 1179.0000, 'ºC'),
	(312802, 142, '2015-01-15 00:47:38.000000', 'temperatura', 190.0000, 'ºC'),
	(312803, 142, '2015-01-15 00:47:39.000000', 'temperatura', 1014.0000, 'ºC'),
	(312804, 142, '2015-01-15 00:47:40.000000', 'temperatura', 900.0000, 'ºC'),
	(312805, 142, '2015-01-15 00:47:41.000000', 'temperatura', 260.0000, 'ºC'),
	(312806, 142, '2015-01-15 00:47:42.000000', 'temperatura', 997.0000, 'ºC'),
	(312807, 142, '2015-01-15 00:47:43.000000', 'temperatura', 608.0000, 'ºC'),
	(312808, 142, '2015-01-15 00:47:44.000000', 'temperatura', 49.0000, 'ºC'),
	(312809, 142, '2015-01-15 00:47:45.000000', 'temperatura', 822.0000, 'ºC'),
	(312810, 142, '2015-01-15 00:47:46.000000', 'temperatura', 363.0000, 'ºC'),
	(312811, 142, '2015-01-15 00:47:47.000000', 'temperatura', 548.0000, 'ºC'),
	(312812, 142, '2015-01-15 00:47:48.000000', 'temperatura', 451.0000, 'ºC'),
	(312813, 142, '2015-01-15 00:47:49.000000', 'temperatura', 614.0000, 'ºC'),
	(312814, 142, '2015-01-15 00:47:50.000000', 'temperatura', 516.0000, 'ºC'),
	(312815, 142, '2015-01-15 00:47:51.000000', 'temperatura', 738.0000, 'ºC'),
	(312816, 142, '2015-01-15 00:47:52.000000', 'temperatura', 943.0000, 'ºC'),
	(312817, 142, '2015-01-15 00:47:53.000000', 'temperatura', 100.0000, 'ºC'),
	(312818, 142, '2015-01-15 00:47:54.000000', 'temperatura', 70.0000, 'ºC'),
	(312819, 142, '2015-01-15 00:47:55.000000', 'temperatura', 54.0000, 'ºC'),
	(312820, 142, '2015-01-15 00:47:56.000000', 'temperatura', 61.0000, 'ºC'),
	(312821, 142, '2015-01-15 00:47:57.000000', 'temperatura', 142.0000, 'ºC'),
	(312822, 142, '2015-01-15 00:47:58.000000', 'temperatura', 529.0000, 'ºC'),
	(312823, 142, '2015-01-15 00:47:59.000000', 'temperatura', 1021.0000, 'ºC'),
	(312824, 142, '2015-01-15 00:48:00.000000', 'temperatura', 1115.0000, 'ºC'),
	(312825, 142, '2015-01-15 00:48:01.000000', 'temperatura', 114.0000, 'ºC'),
	(312826, 142, '2015-01-15 00:48:02.000000', 'temperatura', 827.0000, 'ºC'),
	(312827, 142, '2015-01-15 00:48:03.000000', 'temperatura', 194.0000, 'ºC'),
	(312828, 142, '2015-01-15 00:48:04.000000', 'temperatura', 888.0000, 'ºC'),
	(312829, 142, '2015-01-15 00:48:05.000000', 'temperatura', 257.0000, 'ºC'),
	(312830, 142, '2015-01-15 00:48:06.000000', 'temperatura', 1021.0000, 'ºC'),
	(312831, 142, '2015-01-15 00:48:07.000000', 'temperatura', 736.0000, 'ºC'),
	(312832, 142, '2015-01-15 00:48:08.000000', 'temperatura', 617.0000, 'ºC'),
	(312833, 142, '2015-01-15 00:48:09.000000', 'temperatura', 877.0000, 'ºC'),
	(312834, 142, '2015-01-15 00:48:10.000000', 'temperatura', 135.0000, 'ºC'),
	(312835, 142, '2015-01-15 00:48:11.000000', 'temperatura', 442.0000, 'ºC'),
	(312836, 142, '2015-01-15 00:48:12.000000', 'temperatura', 609.0000, 'ºC'),
	(312837, 142, '2015-01-15 00:48:13.000000', 'temperatura', 519.0000, 'ºC'),
	(312838, 142, '2015-01-15 00:48:14.000000', 'temperatura', 768.0000, 'ºC'),
	(312839, 142, '2015-01-15 00:48:15.000000', 'temperatura', 1083.0000, 'ºC'),
	(312840, 142, '2015-01-15 00:48:16.000000', 'temperatura', 710.0000, 'ºC'),
	(312841, 142, '2015-01-15 00:48:17.000000', 'temperatura', 302.0000, 'ºC'),
	(312842, 142, '2015-01-15 00:48:18.000000', 'temperatura', 582.0000, 'ºC'),
	(312843, 142, '2015-01-15 00:48:19.000000', 'temperatura', 806.0000, 'ºC'),
	(312844, 142, '2015-01-15 00:48:20.000000', 'temperatura', 1081.0000, 'ºC'),
	(312845, 142, '2015-01-15 00:48:21.000000', 'temperatura', 590.0000, 'ºC'),
	(312846, 142, '2015-01-15 00:48:22.000000', 'temperatura', 908.0000, 'ºC'),
	(312847, 142, '2015-01-15 00:48:23.000000', 'temperatura', 371.0000, 'ºC'),
	(312848, 142, '2015-01-15 00:48:24.000000', 'temperatura', 329.0000, 'ºC'),
	(312849, 142, '2015-01-15 00:48:25.000000', 'temperatura', 536.0000, 'ºC'),
	(312850, 142, '2015-01-15 00:48:26.000000', 'temperatura', 490.0000, 'ºC'),
	(312851, 142, '2015-01-15 00:48:27.000000', 'temperatura', 843.0000, 'ºC'),
	(312852, 142, '2015-01-15 00:48:28.000000', 'temperatura', 347.0000, 'ºC'),
	(312853, 142, '2015-01-15 00:48:29.000000', 'temperatura', 408.0000, 'ºC'),
	(312854, 142, '2015-01-15 00:48:30.000000', 'temperatura', 997.0000, 'ºC'),
	(312855, 142, '2015-01-15 00:48:31.000000', 'temperatura', 160.0000, 'ºC'),
	(312856, 142, '2015-01-15 00:48:32.000000', 'temperatura', 212.0000, 'ºC'),
	(312857, 142, '2015-01-15 00:48:33.000000', 'temperatura', 581.0000, 'ºC'),
	(312858, 142, '2015-01-15 00:48:34.000000', 'temperatura', 1068.0000, 'ºC'),
	(312859, 142, '2015-01-15 00:48:35.000000', 'temperatura', 1198.0000, 'ºC'),
	(312860, 142, '2015-01-15 00:48:36.000000', 'temperatura', 388.0000, 'ºC'),
	(312861, 142, '2015-01-15 00:48:37.000000', 'temperatura', 745.0000, 'ºC'),
	(312862, 142, '2015-01-15 00:48:38.000000', 'temperatura', 160.0000, 'ºC'),
	(312863, 142, '2015-01-15 00:48:39.000000', 'temperatura', 966.0000, 'ºC'),
	(312864, 142, '2015-01-15 00:48:40.000000', 'temperatura', 752.0000, 'ºC'),
	(312865, 142, '2015-01-15 00:48:41.000000', 'temperatura', 863.0000, 'ºC'),
	(312866, 142, '2015-01-15 00:48:42.000000', 'temperatura', 859.0000, 'ºC'),
	(312867, 142, '2015-01-15 00:48:43.000000', 'temperatura', 507.0000, 'ºC'),
	(312868, 142, '2015-01-15 00:48:44.000000', 'temperatura', 1159.0000, 'ºC'),
	(312869, 142, '2015-01-15 00:48:45.000000', 'temperatura', 674.0000, 'ºC'),
	(312870, 142, '2015-01-15 00:48:46.000000', 'temperatura', 1093.0000, 'ºC'),
	(312871, 142, '2015-01-15 00:48:47.000000', 'temperatura', 1043.0000, 'ºC'),
	(312872, 142, '2015-01-15 00:48:48.000000', 'temperatura', 737.0000, 'ºC'),
	(312873, 142, '2015-01-15 00:48:49.000000', 'temperatura', 558.0000, 'ºC'),
	(312874, 142, '2015-01-15 00:48:50.000000', 'temperatura', 580.0000, 'ºC'),
	(312875, 142, '2015-01-15 00:48:51.000000', 'temperatura', 25.0000, 'ºC'),
	(312876, 142, '2015-01-15 00:48:52.000000', 'temperatura', 784.0000, 'ºC'),
	(312877, 142, '2015-01-15 00:48:53.000000', 'temperatura', 247.0000, 'ºC'),
	(312878, 142, '2015-01-15 00:48:54.000000', 'temperatura', 84.0000, 'ºC'),
	(312879, 142, '2015-01-15 00:48:55.000000', 'temperatura', 881.0000, 'ºC'),
	(312880, 142, '2015-01-15 00:48:56.000000', 'temperatura', 551.0000, 'ºC'),
	(312881, 142, '2015-01-15 00:48:57.000000', 'temperatura', 113.0000, 'ºC'),
	(312882, 142, '2015-01-15 00:48:58.000000', 'temperatura', 113.0000, 'ºC'),
	(312883, 142, '2015-01-15 00:48:59.000000', 'temperatura', 226.0000, 'ºC'),
	(312884, 142, '2015-01-15 00:49:00.000000', 'temperatura', 792.0000, 'ºC'),
	(312885, 142, '2015-01-15 00:49:01.000000', 'temperatura', 882.0000, 'ºC'),
	(312886, 142, '2015-01-15 00:49:02.000000', 'temperatura', 835.0000, 'ºC'),
	(312887, 142, '2015-01-15 00:49:03.000000', 'temperatura', 327.0000, 'ºC'),
	(312888, 142, '2015-01-15 00:49:04.000000', 'temperatura', 333.0000, 'ºC'),
	(312889, 142, '2015-01-15 00:49:05.000000', 'temperatura', 685.0000, 'ºC'),
	(312890, 142, '2015-01-15 00:49:06.000000', 'temperatura', 24.0000, 'ºC'),
	(312891, 142, '2015-01-15 00:49:07.000000', 'temperatura', 466.0000, 'ºC'),
	(312892, 142, '2015-01-15 00:49:08.000000', 'temperatura', 1061.0000, 'ºC'),
	(312893, 142, '2015-01-15 00:49:09.000000', 'temperatura', 305.0000, 'ºC'),
	(312894, 142, '2015-01-15 00:49:10.000000', 'temperatura', 742.0000, 'ºC'),
	(312895, 142, '2015-01-15 00:49:11.000000', 'temperatura', 396.0000, 'ºC'),
	(312896, 142, '2015-01-15 00:49:12.000000', 'temperatura', 953.0000, 'ºC'),
	(312897, 142, '2015-01-15 00:49:13.000000', 'temperatura', 1178.0000, 'ºC'),
	(312898, 142, '2015-01-15 00:49:14.000000', 'temperatura', 631.0000, 'ºC'),
	(312899, 142, '2015-01-15 00:49:15.000000', 'temperatura', 822.0000, 'ºC'),
	(312900, 142, '2015-01-15 00:49:16.000000', 'temperatura', 1017.0000, 'ºC'),
	(312901, 142, '2015-01-15 00:49:17.000000', 'temperatura', 220.0000, 'ºC'),
	(312902, 142, '2015-01-15 00:49:18.000000', 'temperatura', 452.0000, 'ºC'),
	(312903, 142, '2015-01-15 00:49:19.000000', 'temperatura', 397.0000, 'ºC'),
	(312904, 142, '2015-01-15 00:49:20.000000', 'temperatura', 630.0000, 'ºC'),
	(312905, 142, '2015-01-15 00:49:21.000000', 'temperatura', 761.0000, 'ºC'),
	(312906, 142, '2015-01-15 00:49:22.000000', 'temperatura', 714.0000, 'ºC'),
	(312907, 142, '2015-01-15 00:49:23.000000', 'temperatura', 90.0000, 'ºC'),
	(312908, 142, '2015-01-15 00:49:24.000000', 'temperatura', 706.0000, 'ºC'),
	(312909, 142, '2015-01-15 00:49:25.000000', 'temperatura', 863.0000, 'ºC'),
	(312910, 142, '2015-01-15 00:49:26.000000', 'temperatura', 995.0000, 'ºC'),
	(312911, 142, '2015-01-15 00:49:27.000000', 'temperatura', 1189.0000, 'ºC'),
	(312912, 142, '2015-01-15 00:49:28.000000', 'temperatura', 558.0000, 'ºC'),
	(312913, 142, '2015-01-15 00:49:29.000000', 'temperatura', 426.0000, 'ºC'),
	(312914, 142, '2015-01-15 00:49:30.000000', 'temperatura', 454.0000, 'ºC'),
	(312915, 142, '2015-01-15 00:49:31.000000', 'temperatura', 994.0000, 'ºC'),
	(312916, 142, '2015-01-15 00:49:32.000000', 'temperatura', 9.0000, 'ºC'),
	(312917, 142, '2015-01-15 00:49:33.000000', 'temperatura', 663.0000, 'ºC'),
	(312918, 142, '2015-01-15 00:49:34.000000', 'temperatura', 887.0000, 'ºC'),
	(312919, 142, '2015-01-15 00:49:35.000000', 'temperatura', 46.0000, 'ºC'),
	(312920, 142, '2015-01-15 00:49:36.000000', 'temperatura', 1169.0000, 'ºC'),
	(312921, 142, '2015-01-15 00:49:37.000000', 'temperatura', 911.0000, 'ºC'),
	(312922, 142, '2015-01-15 00:49:38.000000', 'temperatura', 1045.0000, 'ºC'),
	(312923, 142, '2015-01-15 00:49:39.000000', 'temperatura', 96.0000, 'ºC'),
	(312924, 142, '2015-01-15 00:49:40.000000', 'temperatura', 943.0000, 'ºC'),
	(312925, 142, '2015-01-15 00:49:41.000000', 'temperatura', 826.0000, 'ºC'),
	(312926, 142, '2015-01-15 00:49:42.000000', 'temperatura', 104.0000, 'ºC'),
	(312927, 142, '2015-01-15 00:49:43.000000', 'temperatura', 443.0000, 'ºC'),
	(312928, 142, '2015-01-15 00:49:44.000000', 'temperatura', 704.0000, 'ºC'),
	(312929, 142, '2015-01-15 00:49:45.000000', 'temperatura', 992.0000, 'ºC'),
	(312930, 142, '2015-01-15 00:49:46.000000', 'temperatura', 446.0000, 'ºC'),
	(312931, 142, '2015-01-15 00:49:47.000000', 'temperatura', 457.0000, 'ºC'),
	(312932, 142, '2015-01-15 00:49:48.000000', 'temperatura', 946.0000, 'ºC'),
	(312933, 142, '2015-01-15 00:49:49.000000', 'temperatura', 959.0000, 'ºC'),
	(312934, 142, '2015-01-15 00:49:50.000000', 'temperatura', 760.0000, 'ºC'),
	(312935, 142, '2015-01-15 00:49:51.000000', 'temperatura', 923.0000, 'ºC'),
	(312936, 142, '2015-01-15 00:49:52.000000', 'temperatura', 1134.0000, 'ºC'),
	(312937, 142, '2015-01-15 00:49:53.000000', 'temperatura', 504.0000, 'ºC'),
	(312938, 142, '2015-01-15 00:49:54.000000', 'temperatura', 318.0000, 'ºC'),
	(312939, 142, '2015-01-15 00:49:55.000000', 'temperatura', 76.0000, 'ºC'),
	(312940, 142, '2015-01-15 00:49:56.000000', 'temperatura', 629.0000, 'ºC'),
	(312941, 142, '2015-01-15 00:49:57.000000', 'temperatura', 516.0000, 'ºC'),
	(312942, 142, '2015-01-15 00:49:58.000000', 'temperatura', 695.0000, 'ºC'),
	(312943, 142, '2015-01-15 00:49:59.000000', 'temperatura', 726.0000, 'ºC'),
	(312944, 142, '2015-01-15 00:50:00.000000', 'temperatura', 348.0000, 'ºC'),
	(312945, 142, '2015-01-15 00:50:01.000000', 'temperatura', 760.0000, 'ºC'),
	(312946, 142, '2015-01-15 00:50:02.000000', 'temperatura', 355.0000, 'ºC'),
	(312947, 142, '2015-01-15 00:50:03.000000', 'temperatura', 699.0000, 'ºC'),
	(312948, 142, '2015-01-15 00:50:04.000000', 'temperatura', 27.0000, 'ºC'),
	(312949, 142, '2015-01-15 00:50:05.000000', 'temperatura', 441.0000, 'ºC'),
	(312950, 142, '2015-01-15 00:50:06.000000', 'temperatura', 925.0000, 'ºC'),
	(312951, 142, '2015-01-15 00:50:07.000000', 'temperatura', 902.0000, 'ºC'),
	(312952, 142, '2015-01-15 00:50:08.000000', 'temperatura', 537.0000, 'ºC'),
	(312953, 142, '2015-01-15 00:50:09.000000', 'temperatura', 1177.0000, 'ºC'),
	(312954, 142, '2015-01-15 00:50:10.000000', 'temperatura', 676.0000, 'ºC'),
	(312955, 142, '2015-01-15 00:50:11.000000', 'temperatura', 1048.0000, 'ºC'),
	(312956, 142, '2015-01-15 00:50:12.000000', 'temperatura', 811.0000, 'ºC'),
	(312957, 142, '2015-01-15 00:50:13.000000', 'temperatura', 915.0000, 'ºC'),
	(312958, 142, '2015-01-15 00:50:14.000000', 'temperatura', 942.0000, 'ºC'),
	(312959, 142, '2015-01-15 00:50:15.000000', 'temperatura', 764.0000, 'ºC'),
	(312960, 142, '2015-01-15 00:50:16.000000', 'temperatura', 996.0000, 'ºC'),
	(312961, 142, '2015-01-15 00:50:17.000000', 'temperatura', 287.0000, 'ºC'),
	(312962, 142, '2015-01-15 00:50:18.000000', 'temperatura', 848.0000, 'ºC'),
	(312963, 142, '2015-01-15 00:50:19.000000', 'temperatura', 980.0000, 'ºC'),
	(312964, 142, '2015-01-15 00:50:20.000000', 'temperatura', 1155.0000, 'ºC'),
	(312965, 142, '2015-01-15 00:50:21.000000', 'temperatura', 435.0000, 'ºC'),
	(312966, 142, '2015-01-15 00:50:22.000000', 'temperatura', 1109.0000, 'ºC'),
	(312967, 142, '2015-01-15 00:50:23.000000', 'temperatura', 644.0000, 'ºC'),
	(312968, 142, '2015-01-15 00:50:24.000000', 'temperatura', 1093.0000, 'ºC'),
	(312969, 142, '2015-01-15 00:50:25.000000', 'temperatura', 1132.0000, 'ºC'),
	(312970, 142, '2015-01-15 00:50:26.000000', 'temperatura', 1181.0000, 'ºC'),
	(312971, 142, '2015-01-15 00:50:27.000000', 'temperatura', 111.0000, 'ºC'),
	(312972, 142, '2015-01-15 00:50:28.000000', 'temperatura', 613.0000, 'ºC'),
	(312973, 142, '2015-01-15 00:50:29.000000', 'temperatura', 333.0000, 'ºC'),
	(312974, 142, '2015-01-15 00:50:30.000000', 'temperatura', 1024.0000, 'ºC'),
	(312975, 142, '2015-01-15 00:50:31.000000', 'temperatura', 521.0000, 'ºC'),
	(312976, 142, '2015-01-15 00:50:32.000000', 'temperatura', 736.0000, 'ºC'),
	(312977, 142, '2015-01-15 00:50:33.000000', 'temperatura', 919.0000, 'ºC'),
	(312978, 142, '2015-01-15 00:50:34.000000', 'temperatura', 1184.0000, 'ºC'),
	(312979, 142, '2015-01-15 00:50:35.000000', 'temperatura', 764.0000, 'ºC'),
	(312980, 142, '2015-01-15 00:50:36.000000', 'temperatura', 267.0000, 'ºC'),
	(312981, 142, '2015-01-15 00:50:37.000000', 'temperatura', 245.0000, 'ºC'),
	(312982, 142, '2015-01-15 00:50:38.000000', 'temperatura', 422.0000, 'ºC'),
	(312983, 142, '2015-01-15 00:50:39.000000', 'temperatura', 179.0000, 'ºC'),
	(312984, 142, '2015-01-15 00:50:40.000000', 'temperatura', 828.0000, 'ºC'),
	(312985, 142, '2015-01-15 00:50:41.000000', 'temperatura', 3.0000, 'ºC'),
	(312986, 142, '2015-01-15 00:50:42.000000', 'temperatura', 1132.0000, 'ºC'),
	(312987, 142, '2015-01-15 00:50:43.000000', 'temperatura', 853.0000, 'ºC'),
	(312988, 142, '2015-01-15 00:50:44.000000', 'temperatura', 867.0000, 'ºC'),
	(312989, 142, '2015-01-15 00:50:45.000000', 'temperatura', 578.0000, 'ºC'),
	(312990, 142, '2015-01-15 00:50:46.000000', 'temperatura', 288.0000, 'ºC'),
	(312991, 142, '2015-01-15 00:50:47.000000', 'temperatura', 907.0000, 'ºC'),
	(312992, 142, '2015-01-15 00:50:48.000000', 'temperatura', 72.0000, 'ºC'),
	(312993, 142, '2015-01-15 00:50:49.000000', 'temperatura', 40.0000, 'ºC'),
	(312994, 142, '2015-01-15 00:50:50.000000', 'temperatura', 1183.0000, 'ºC'),
	(312995, 142, '2015-01-15 00:50:51.000000', 'temperatura', 998.0000, 'ºC'),
	(312996, 142, '2015-01-15 00:50:52.000000', 'temperatura', 241.0000, 'ºC'),
	(312997, 142, '2015-01-15 00:50:53.000000', 'temperatura', 610.0000, 'ºC'),
	(312998, 142, '2015-01-15 00:50:54.000000', 'temperatura', 1127.0000, 'ºC'),
	(312999, 142, '2015-01-15 00:50:55.000000', 'temperatura', 204.0000, 'ºC'),
	(313000, 142, '2015-01-15 00:50:56.000000', 'temperatura', 43.0000, 'ºC'),
	(313001, 142, '2015-01-15 00:50:57.000000', 'temperatura', 801.0000, 'ºC'),
	(313002, 142, '2015-01-15 00:50:58.000000', 'temperatura', 278.0000, 'ºC'),
	(313003, 142, '2015-01-15 00:50:59.000000', 'temperatura', 189.0000, 'ºC'),
	(313004, 142, '2015-01-15 00:51:00.000000', 'temperatura', 110.0000, 'ºC'),
	(313005, 142, '2015-01-15 00:51:01.000000', 'temperatura', 1184.0000, 'ºC'),
	(313006, 142, '2015-01-15 00:51:02.000000', 'temperatura', 789.0000, 'ºC'),
	(313007, 142, '2015-01-15 00:51:03.000000', 'temperatura', 395.0000, 'ºC'),
	(313008, 142, '2015-01-15 00:51:04.000000', 'temperatura', 808.0000, 'ºC'),
	(313009, 142, '2015-01-15 00:51:05.000000', 'temperatura', 455.0000, 'ºC'),
	(313010, 142, '2015-01-15 00:51:06.000000', 'temperatura', 1054.0000, 'ºC'),
	(313011, 142, '2015-01-15 00:51:07.000000', 'temperatura', 303.0000, 'ºC'),
	(313012, 142, '2015-01-15 00:51:08.000000', 'temperatura', 756.0000, 'ºC'),
	(313013, 142, '2015-01-15 00:51:09.000000', 'temperatura', 471.0000, 'ºC'),
	(313014, 142, '2015-01-15 00:51:10.000000', 'temperatura', 86.0000, 'ºC'),
	(313015, 142, '2015-01-15 00:51:11.000000', 'temperatura', 217.0000, 'ºC'),
	(313016, 142, '2015-01-15 00:51:12.000000', 'temperatura', 830.0000, 'ºC'),
	(313017, 142, '2015-01-15 00:51:13.000000', 'temperatura', 1098.0000, 'ºC'),
	(313018, 142, '2015-01-15 00:51:14.000000', 'temperatura', 601.0000, 'ºC'),
	(313019, 142, '2015-01-15 00:51:15.000000', 'temperatura', 910.0000, 'ºC'),
	(313020, 142, '2015-01-15 00:51:16.000000', 'temperatura', 347.0000, 'ºC'),
	(313021, 142, '2015-01-15 00:51:17.000000', 'temperatura', 207.0000, 'ºC'),
	(313022, 142, '2015-01-15 00:51:18.000000', 'temperatura', 1193.0000, 'ºC'),
	(313023, 142, '2015-01-15 00:51:19.000000', 'temperatura', 544.0000, 'ºC'),
	(313024, 142, '2015-01-15 00:51:20.000000', 'temperatura', 342.0000, 'ºC'),
	(313025, 142, '2015-01-15 00:51:21.000000', 'temperatura', 80.0000, 'ºC'),
	(313026, 142, '2015-01-15 00:51:22.000000', 'temperatura', 575.0000, 'ºC'),
	(313027, 142, '2015-01-15 00:51:23.000000', 'temperatura', 236.0000, 'ºC'),
	(313028, 142, '2015-01-15 00:51:24.000000', 'temperatura', 656.0000, 'ºC'),
	(313029, 142, '2015-01-15 00:51:25.000000', 'temperatura', 173.0000, 'ºC'),
	(313030, 142, '2015-01-15 00:51:26.000000', 'temperatura', 98.0000, 'ºC'),
	(313031, 142, '2015-01-15 00:51:27.000000', 'temperatura', 1171.0000, 'ºC'),
	(313032, 142, '2015-01-15 00:51:28.000000', 'temperatura', 759.0000, 'ºC'),
	(313033, 142, '2015-01-15 00:51:29.000000', 'temperatura', 284.0000, 'ºC'),
	(313034, 142, '2015-01-15 00:51:30.000000', 'temperatura', 343.0000, 'ºC'),
	(313035, 142, '2015-01-15 00:51:31.000000', 'temperatura', 864.0000, 'ºC'),
	(313036, 142, '2015-01-15 00:51:32.000000', 'temperatura', 892.0000, 'ºC'),
	(313037, 142, '2015-01-15 00:51:33.000000', 'temperatura', 670.0000, 'ºC'),
	(313038, 142, '2015-01-15 00:51:34.000000', 'temperatura', 674.0000, 'ºC'),
	(313039, 142, '2015-01-15 00:51:35.000000', 'temperatura', 159.0000, 'ºC'),
	(313040, 142, '2015-01-15 00:51:36.000000', 'temperatura', 1173.0000, 'ºC'),
	(313041, 142, '2015-01-15 00:51:37.000000', 'temperatura', 590.0000, 'ºC'),
	(313042, 142, '2015-01-15 00:51:38.000000', 'temperatura', 632.0000, 'ºC'),
	(313043, 142, '2015-01-15 00:51:39.000000', 'temperatura', 191.0000, 'ºC'),
	(313044, 142, '2015-01-15 00:51:40.000000', 'temperatura', 258.0000, 'ºC'),
	(313045, 142, '2015-01-15 00:51:41.000000', 'temperatura', 719.0000, 'ºC'),
	(313046, 142, '2015-01-15 00:51:42.000000', 'temperatura', 422.0000, 'ºC'),
	(313047, 142, '2015-01-15 00:51:43.000000', 'temperatura', 1154.0000, 'ºC'),
	(313048, 142, '2015-01-15 00:51:44.000000', 'temperatura', 904.0000, 'ºC'),
	(313049, 142, '2015-01-15 00:51:45.000000', 'temperatura', 1056.0000, 'ºC'),
	(313050, 142, '2015-01-15 00:51:46.000000', 'temperatura', 172.0000, 'ºC'),
	(313051, 142, '2015-01-15 00:51:47.000000', 'temperatura', 92.0000, 'ºC'),
	(313052, 142, '2015-01-15 00:51:48.000000', 'temperatura', 1142.0000, 'ºC'),
	(313053, 142, '2015-01-15 00:51:49.000000', 'temperatura', 635.0000, 'ºC'),
	(313054, 142, '2015-01-15 00:51:50.000000', 'temperatura', 952.0000, 'ºC'),
	(313055, 142, '2015-01-15 00:51:51.000000', 'temperatura', 452.0000, 'ºC'),
	(313056, 142, '2015-01-15 00:51:52.000000', 'temperatura', 608.0000, 'ºC'),
	(313057, 142, '2015-01-15 00:51:53.000000', 'temperatura', 482.0000, 'ºC'),
	(313058, 142, '2015-01-15 00:51:54.000000', 'temperatura', 589.0000, 'ºC'),
	(313059, 142, '2015-01-15 00:51:55.000000', 'temperatura', 298.0000, 'ºC'),
	(313060, 142, '2015-01-15 00:51:56.000000', 'temperatura', 924.0000, 'ºC'),
	(313061, 142, '2015-01-15 00:51:57.000000', 'temperatura', 127.0000, 'ºC'),
	(313062, 142, '2015-01-15 00:51:58.000000', 'temperatura', 262.0000, 'ºC'),
	(313063, 142, '2015-01-15 00:51:59.000000', 'temperatura', 929.0000, 'ºC'),
	(313064, 142, '2015-01-15 00:52:00.000000', 'temperatura', 258.0000, 'ºC'),
	(313065, 142, '2015-01-15 00:52:01.000000', 'temperatura', 907.0000, 'ºC'),
	(313066, 142, '2015-01-15 00:52:02.000000', 'temperatura', 158.0000, 'ºC'),
	(313067, 142, '2015-01-15 00:52:03.000000', 'temperatura', 472.0000, 'ºC'),
	(313068, 142, '2015-01-15 00:52:04.000000', 'temperatura', 686.0000, 'ºC'),
	(313069, 142, '2015-01-15 00:52:05.000000', 'temperatura', 814.0000, 'ºC'),
	(313070, 142, '2015-01-15 00:52:06.000000', 'temperatura', 811.0000, 'ºC'),
	(313071, 142, '2015-01-15 00:52:07.000000', 'temperatura', 414.0000, 'ºC'),
	(313072, 142, '2015-01-15 00:52:08.000000', 'temperatura', 839.0000, 'ºC'),
	(313073, 142, '2015-01-15 00:52:09.000000', 'temperatura', 555.0000, 'ºC'),
	(313074, 142, '2015-01-15 00:52:10.000000', 'temperatura', 255.0000, 'ºC'),
	(313075, 142, '2015-01-15 00:52:11.000000', 'temperatura', 814.0000, 'ºC'),
	(313076, 142, '2015-01-15 00:52:12.000000', 'temperatura', 903.0000, 'ºC'),
	(313077, 142, '2015-01-15 00:52:13.000000', 'temperatura', 876.0000, 'ºC'),
	(313078, 142, '2015-01-15 00:52:14.000000', 'temperatura', 471.0000, 'ºC'),
	(313079, 142, '2015-01-15 00:52:15.000000', 'temperatura', 928.0000, 'ºC'),
	(313080, 142, '2015-01-15 00:52:16.000000', 'temperatura', 825.0000, 'ºC'),
	(313081, 142, '2015-01-15 00:52:17.000000', 'temperatura', 144.0000, 'ºC'),
	(313082, 142, '2015-01-15 00:52:18.000000', 'temperatura', 645.0000, 'ºC'),
	(313083, 142, '2015-01-15 00:52:19.000000', 'temperatura', 392.0000, 'ºC'),
	(313084, 142, '2015-01-15 00:52:20.000000', 'temperatura', 27.0000, 'ºC'),
	(313085, 142, '2015-01-15 00:52:21.000000', 'temperatura', 160.0000, 'ºC'),
	(313086, 142, '2015-01-15 00:52:22.000000', 'temperatura', 718.0000, 'ºC'),
	(313087, 142, '2015-01-15 00:52:23.000000', 'temperatura', 709.0000, 'ºC'),
	(313088, 142, '2015-01-15 00:52:24.000000', 'temperatura', 195.0000, 'ºC'),
	(313089, 142, '2015-01-15 00:52:25.000000', 'temperatura', 46.0000, 'ºC'),
	(313090, 142, '2015-01-15 00:52:26.000000', 'temperatura', 846.0000, 'ºC'),
	(313091, 142, '2015-01-15 00:52:27.000000', 'temperatura', 493.0000, 'ºC'),
	(313092, 142, '2015-01-15 00:52:28.000000', 'temperatura', 1129.0000, 'ºC'),
	(313093, 142, '2015-01-15 00:52:29.000000', 'temperatura', 567.0000, 'ºC'),
	(313094, 142, '2015-01-15 00:52:30.000000', 'temperatura', 647.0000, 'ºC'),
	(313095, 142, '2015-01-15 00:52:31.000000', 'temperatura', 337.0000, 'ºC'),
	(313096, 142, '2015-01-15 00:52:32.000000', 'temperatura', 942.0000, 'ºC'),
	(313097, 142, '2015-01-15 00:52:33.000000', 'temperatura', 99.0000, 'ºC'),
	(313098, 142, '2015-01-15 00:52:34.000000', 'temperatura', 72.0000, 'ºC'),
	(313099, 142, '2015-01-15 00:52:35.000000', 'temperatura', 60.0000, 'ºC'),
	(313100, 142, '2015-01-15 00:52:36.000000', 'temperatura', 88.0000, 'ºC'),
	(313101, 142, '2015-01-15 00:52:37.000000', 'temperatura', 257.0000, 'ºC'),
	(313102, 142, '2015-01-15 00:52:38.000000', 'temperatura', 1025.0000, 'ºC'),
	(313103, 142, '2015-01-15 00:52:39.000000', 'temperatura', 752.0000, 'ºC'),
	(313104, 142, '2015-01-15 00:52:40.000000', 'temperatura', 685.0000, 'ºC'),
	(313105, 142, '2015-01-15 00:52:41.000000', 'temperatura', 1172.0000, 'ºC'),
	(313106, 142, '2015-01-15 00:52:42.000000', 'temperatura', 206.0000, 'ºC'),
	(313107, 142, '2015-01-15 00:52:43.000000', 'temperatura', 1112.0000, 'ºC'),
	(313108, 142, '2015-01-15 00:52:44.000000', 'temperatura', 144.0000, 'ºC'),
	(313109, 142, '2015-01-15 00:52:45.000000', 'temperatura', 986.0000, 'ºC'),
	(313110, 142, '2015-01-15 00:52:46.000000', 'temperatura', 897.0000, 'ºC'),
	(313111, 142, '2015-01-15 00:52:47.000000', 'temperatura', 330.0000, 'ºC'),
	(313112, 142, '2015-01-15 00:52:48.000000', 'temperatura', 156.0000, 'ºC'),
	(313113, 142, '2015-01-15 00:52:49.000000', 'temperatura', 991.0000, 'ºC'),
	(313114, 142, '2015-01-15 00:52:50.000000', 'temperatura', 889.0000, 'ºC'),
	(313115, 142, '2015-01-15 00:52:51.000000', 'temperatura', 271.0000, 'ºC'),
	(313116, 142, '2015-01-15 00:52:52.000000', 'temperatura', 1088.0000, 'ºC'),
	(313117, 142, '2015-01-15 00:52:53.000000', 'temperatura', 1029.0000, 'ºC'),
	(313118, 142, '2015-01-15 00:52:54.000000', 'temperatura', 679.0000, 'ºC'),
	(313119, 142, '2015-01-15 00:52:55.000000', 'temperatura', 309.0000, 'ºC'),
	(313120, 142, '2015-01-15 00:52:56.000000', 'temperatura', 710.0000, 'ºC'),
	(313121, 142, '2015-01-15 00:52:57.000000', 'temperatura', 223.0000, 'ºC'),
	(313122, 142, '2015-01-15 00:52:58.000000', 'temperatura', 185.0000, 'ºC'),
	(313123, 142, '2015-01-15 00:52:59.000000', 'temperatura', 259.0000, 'ºC'),
	(313124, 142, '2015-01-15 00:53:00.000000', 'temperatura', 738.0000, 'ºC'),
	(313125, 142, '2015-01-15 00:53:01.000000', 'temperatura', 516.0000, 'ºC'),
	(313126, 142, '2015-01-15 00:53:02.000000', 'temperatura', 367.0000, 'ºC'),
	(313127, 142, '2015-01-15 00:53:03.000000', 'temperatura', 284.0000, 'ºC'),
	(313128, 142, '2015-01-15 00:53:04.000000', 'temperatura', 323.0000, 'ºC'),
	(313129, 142, '2015-01-15 00:53:05.000000', 'temperatura', 760.0000, 'ºC'),
	(313130, 142, '2015-01-15 00:53:06.000000', 'temperatura', 434.0000, 'ºC'),
	(313131, 142, '2015-01-15 00:53:07.000000', 'temperatura', 1091.0000, 'ºC'),
	(313132, 142, '2015-01-15 00:53:08.000000', 'temperatura', 553.0000, 'ºC'),
	(313133, 142, '2015-01-15 00:53:09.000000', 'temperatura', 693.0000, 'ºC'),
	(313134, 142, '2015-01-15 00:53:10.000000', 'temperatura', 607.0000, 'ºC'),
	(313135, 142, '2015-01-15 00:53:11.000000', 'temperatura', 954.0000, 'ºC'),
	(313136, 142, '2015-01-15 00:53:12.000000', 'temperatura', 553.0000, 'ºC'),
	(313137, 142, '2015-01-15 00:53:13.000000', 'temperatura', 1100.0000, 'ºC'),
	(313138, 142, '2015-01-15 00:53:14.000000', 'temperatura', 245.0000, 'ºC'),
	(313139, 142, '2015-01-15 00:53:15.000000', 'temperatura', 324.0000, 'ºC'),
	(313140, 142, '2015-01-15 00:53:16.000000', 'temperatura', 884.0000, 'ºC'),
	(313141, 142, '2015-01-15 00:53:17.000000', 'temperatura', 1050.0000, 'ºC'),
	(313142, 142, '2015-01-15 00:53:18.000000', 'temperatura', 200.0000, 'ºC'),
	(313143, 142, '2015-01-15 00:53:19.000000', 'temperatura', 250.0000, 'ºC'),
	(313144, 142, '2015-01-15 00:53:20.000000', 'temperatura', 651.0000, 'ºC'),
	(313145, 142, '2015-01-15 00:53:21.000000', 'temperatura', 103.0000, 'ºC'),
	(313146, 142, '2015-01-15 00:53:22.000000', 'temperatura', 964.0000, 'ºC'),
	(313147, 142, '2015-01-15 00:53:23.000000', 'temperatura', 913.0000, 'ºC'),
	(313148, 142, '2015-01-15 00:53:24.000000', 'temperatura', 474.0000, 'ºC'),
	(313149, 142, '2015-01-15 00:53:25.000000', 'temperatura', 831.0000, 'ºC'),
	(313150, 142, '2015-01-15 00:53:26.000000', 'temperatura', 332.0000, 'ºC'),
	(313151, 142, '2015-01-15 00:53:27.000000', 'temperatura', 367.0000, 'ºC'),
	(313152, 142, '2015-01-15 00:53:28.000000', 'temperatura', 842.0000, 'ºC'),
	(313153, 142, '2015-01-15 00:53:29.000000', 'temperatura', 708.0000, 'ºC'),
	(313154, 142, '2015-01-15 00:53:30.000000', 'temperatura', 1013.0000, 'ºC'),
	(313155, 142, '2015-01-15 00:53:31.000000', 'temperatura', 543.0000, 'ºC'),
	(313156, 142, '2015-01-15 00:53:32.000000', 'temperatura', 878.0000, 'ºC'),
	(313157, 142, '2015-01-15 00:53:33.000000', 'temperatura', 362.0000, 'ºC'),
	(313158, 142, '2015-01-15 00:53:34.000000', 'temperatura', 374.0000, 'ºC'),
	(313159, 142, '2015-01-15 00:53:35.000000', 'temperatura', 786.0000, 'ºC'),
	(313160, 142, '2015-01-15 00:53:36.000000', 'temperatura', 408.0000, 'ºC'),
	(313161, 142, '2015-01-15 00:53:37.000000', 'temperatura', 882.0000, 'ºC'),
	(313162, 142, '2015-01-15 00:53:38.000000', 'temperatura', 786.0000, 'ºC'),
	(313163, 142, '2015-01-15 00:53:39.000000', 'temperatura', 87.0000, 'ºC'),
	(313164, 142, '2015-01-15 00:53:40.000000', 'temperatura', 476.0000, 'ºC'),
	(313165, 142, '2015-01-15 00:53:41.000000', 'temperatura', 922.0000, 'ºC'),
	(313166, 142, '2015-01-15 00:53:42.000000', 'temperatura', 779.0000, 'ºC'),
	(313167, 142, '2015-01-15 00:53:43.000000', 'temperatura', 1133.0000, 'ºC'),
	(313168, 142, '2015-01-15 00:53:44.000000', 'temperatura', 927.0000, 'ºC'),
	(313169, 142, '2015-01-15 00:53:45.000000', 'temperatura', 35.0000, 'ºC'),
	(313170, 142, '2015-01-15 00:53:46.000000', 'temperatura', 994.0000, 'ºC'),
	(313171, 142, '2015-01-15 00:53:47.000000', 'temperatura', 67.0000, 'ºC'),
	(313172, 142, '2015-01-15 00:53:48.000000', 'temperatura', 953.0000, 'ºC'),
	(313173, 142, '2015-01-15 00:53:49.000000', 'temperatura', 964.0000, 'ºC'),
	(313174, 142, '2015-01-15 00:53:50.000000', 'temperatura', 760.0000, 'ºC'),
	(313175, 142, '2015-01-15 00:53:51.000000', 'temperatura', 910.0000, 'ºC'),
	(313176, 142, '2015-01-15 00:53:52.000000', 'temperatura', 1070.0000, 'ºC'),
	(313177, 142, '2015-01-15 00:53:53.000000', 'temperatura', 221.0000, 'ºC'),
	(313178, 142, '2015-01-15 00:53:54.000000', 'temperatura', 293.0000, 'ºC'),
	(313179, 142, '2015-01-15 00:53:55.000000', 'temperatura', 805.0000, 'ºC'),
	(313180, 142, '2015-01-15 00:53:56.000000', 'temperatura', 746.0000, 'ºC'),
	(313181, 142, '2015-01-15 00:53:57.000000', 'temperatura', 115.0000, 'ºC'),
	(313182, 142, '2015-01-15 00:53:58.000000', 'temperatura', 739.0000, 'ºC'),
	(313183, 142, '2015-01-15 00:53:59.000000', 'temperatura', 951.0000, 'ºC'),
	(313184, 142, '2015-01-15 00:54:00.000000', 'temperatura', 139.0000, 'ºC'),
	(313185, 142, '2015-01-15 00:54:01.000000', 'temperatura', 242.0000, 'ºC'),
	(313186, 142, '2015-01-15 00:54:02.000000', 'temperatura', 795.0000, 'ºC'),
	(313187, 142, '2015-01-15 00:54:03.000000', 'temperatura', 849.0000, 'ºC'),
	(313188, 142, '2015-01-15 00:54:04.000000', 'temperatura', 661.0000, 'ºC'),
	(313189, 142, '2015-01-15 00:54:05.000000', 'temperatura', 759.0000, 'ºC'),
	(313190, 142, '2015-01-15 00:54:06.000000', 'temperatura', 610.0000, 'ºC'),
	(313191, 142, '2015-01-15 00:54:07.000000', 'temperatura', 774.0000, 'ºC'),
	(313192, 142, '2015-01-15 00:54:08.000000', 'temperatura', 843.0000, 'ºC'),
	(313193, 142, '2015-01-15 00:54:09.000000', 'temperatura', 692.0000, 'ºC'),
	(313194, 142, '2015-01-15 00:54:10.000000', 'temperatura', 933.0000, 'ºC'),
	(313195, 142, '2015-01-15 00:54:11.000000', 'temperatura', 188.0000, 'ºC'),
	(313196, 142, '2015-01-15 00:54:12.000000', 'temperatura', 542.0000, 'ºC'),
	(313197, 142, '2015-01-15 00:54:13.000000', 'temperatura', 947.0000, 'ºC'),
	(313198, 142, '2015-01-15 00:54:14.000000', 'temperatura', 711.0000, 'ºC'),
	(313199, 142, '2015-01-15 00:54:15.000000', 'temperatura', 713.0000, 'ºC'),
	(313200, 142, '2015-01-15 00:54:16.000000', 'temperatura', 234.0000, 'ºC'),
	(313201, 142, '2015-01-15 00:54:17.000000', 'temperatura', 231.0000, 'ºC'),
	(313202, 142, '2015-01-15 00:54:18.000000', 'temperatura', 454.0000, 'ºC'),
	(313203, 142, '2015-01-15 00:54:19.000000', 'temperatura', 379.0000, 'ºC'),
	(313204, 142, '2015-01-15 00:54:20.000000', 'temperatura', 532.0000, 'ºC'),
	(313205, 142, '2015-01-15 00:54:21.000000', 'temperatura', 322.0000, 'ºC'),
	(313206, 142, '2015-01-15 00:54:22.000000', 'temperatura', 14.0000, 'ºC'),
	(313207, 142, '2015-01-15 00:54:23.000000', 'temperatura', 307.0000, 'ºC'),
	(313208, 142, '2015-01-15 00:54:24.000000', 'temperatura', 293.0000, 'ºC'),
	(313209, 142, '2015-01-15 00:54:25.000000', 'temperatura', 545.0000, 'ºC'),
	(313210, 142, '2015-01-15 00:54:26.000000', 'temperatura', 646.0000, 'ºC'),
	(313211, 142, '2015-01-15 00:54:27.000000', 'temperatura', 396.0000, 'ºC'),
	(313212, 142, '2015-01-15 00:54:28.000000', 'temperatura', 41.0000, 'ºC'),
	(313213, 142, '2015-01-15 00:54:29.000000', 'temperatura', 218.0000, 'ºC'),
	(313214, 142, '2015-01-15 00:54:30.000000', 'temperatura', 968.0000, 'ºC'),
	(313215, 142, '2015-01-15 00:54:31.000000', 'temperatura', 585.0000, 'ºC'),
	(313216, 142, '2015-01-15 00:54:32.000000', 'temperatura', 22.0000, 'ºC'),
	(313217, 142, '2015-01-15 00:54:33.000000', 'temperatura', 756.0000, 'ºC'),
	(313218, 142, '2015-01-15 00:54:34.000000', 'temperatura', 114.0000, 'ºC'),
	(313219, 142, '2015-01-15 00:54:35.000000', 'temperatura', 703.0000, 'ºC'),
	(313220, 142, '2015-01-15 00:54:36.000000', 'temperatura', 773.0000, 'ºC'),
	(313221, 142, '2015-01-15 00:54:37.000000', 'temperatura', 558.0000, 'ºC'),
	(313222, 142, '2015-01-15 00:54:38.000000', 'temperatura', 469.0000, 'ºC'),
	(313223, 142, '2015-01-15 00:54:39.000000', 'temperatura', 671.0000, 'ºC'),
	(313224, 142, '2015-01-15 00:54:40.000000', 'temperatura', 748.0000, 'ºC'),
	(313225, 142, '2015-01-15 00:54:41.000000', 'temperatura', 528.0000, 'ºC'),
	(313226, 142, '2015-01-15 00:54:42.000000', 'temperatura', 396.0000, 'ºC'),
	(313227, 142, '2015-01-15 00:54:43.000000', 'temperatura', 399.0000, 'ºC'),
	(313228, 142, '2015-01-15 00:54:44.000000', 'temperatura', 807.0000, 'ºC'),
	(313229, 142, '2015-01-15 00:54:45.000000', 'temperatura', 440.0000, 'ºC'),
	(313230, 142, '2015-01-15 00:54:46.000000', 'temperatura', 976.0000, 'ºC'),
	(313231, 142, '2015-01-15 00:54:47.000000', 'temperatura', 1163.0000, 'ºC'),
	(313232, 142, '2015-01-15 00:54:48.000000', 'temperatura', 485.0000, 'ºC'),
	(313233, 142, '2015-01-15 00:54:49.000000', 'temperatura', 140.0000, 'ºC'),
	(313234, 142, '2015-01-15 00:54:50.000000', 'temperatura', 443.0000, 'ºC'),
	(313235, 142, '2015-01-15 00:54:51.000000', 'temperatura', 596.0000, 'ºC'),
	(313236, 142, '2015-01-15 00:54:52.000000', 'temperatura', 453.0000, 'ºC'),
	(313237, 142, '2015-01-15 00:54:53.000000', 'temperatura', 479.0000, 'ºC'),
	(313238, 142, '2015-01-15 00:54:54.000000', 'temperatura', 1033.0000, 'ºC'),
	(313239, 142, '2015-01-15 00:54:55.000000', 'temperatura', 128.0000, 'ºC'),
	(313240, 142, '2015-01-15 00:54:56.000000', 'temperatura', 1144.0000, 'ºC'),
	(313241, 142, '2015-01-15 00:54:57.000000', 'temperatura', 536.0000, 'ºC'),
	(313242, 142, '2015-01-15 00:54:58.000000', 'temperatura', 448.0000, 'ºC'),
	(313243, 142, '2015-01-15 00:54:59.000000', 'temperatura', 635.0000, 'ºC'),
	(313244, 142, '2015-01-15 00:55:00.000000', 'temperatura', 628.0000, 'ºC'),
	(313245, 142, '2015-01-15 00:55:01.000000', 'temperatura', 39.0000, 'ºC'),
	(313246, 142, '2015-01-15 00:55:02.000000', 'temperatura', 708.0000, 'ºC'),
	(313247, 142, '2015-01-15 00:55:03.000000', 'temperatura', 1026.0000, 'ºC'),
	(313248, 142, '2015-01-15 00:55:04.000000', 'temperatura', 607.0000, 'ºC'),
	(313249, 142, '2015-01-15 00:55:05.000000', 'temperatura', 1157.0000, 'ºC'),
	(313250, 142, '2015-01-15 00:55:06.000000', 'temperatura', 366.0000, 'ºC'),
	(313251, 142, '2015-01-15 00:55:07.000000', 'temperatura', 759.0000, 'ºC'),
	(313252, 142, '2015-01-15 00:55:08.000000', 'temperatura', 296.0000, 'ºC'),
	(313253, 142, '2015-01-15 00:55:09.000000', 'temperatura', 406.0000, 'ºC'),
	(313254, 142, '2015-01-15 00:55:10.000000', 'temperatura', 1142.0000, 'ºC'),
	(313255, 142, '2015-01-15 00:55:11.000000', 'temperatura', 894.0000, 'ºC'),
	(313256, 142, '2015-01-15 00:55:12.000000', 'temperatura', 1043.0000, 'ºC'),
	(313257, 142, '2015-01-15 00:55:13.000000', 'temperatura', 134.0000, 'ºC'),
	(313258, 142, '2015-01-15 00:55:14.000000', 'temperatura', 1141.0000, 'ºC'),
	(313259, 142, '2015-01-15 00:55:15.000000', 'temperatura', 505.0000, 'ºC'),
	(313260, 142, '2015-01-15 00:55:16.000000', 'temperatura', 302.0000, 'ºC'),
	(313261, 142, '2015-01-15 00:55:17.000000', 'temperatura', 1193.0000, 'ºC'),
	(313262, 142, '2015-01-15 00:55:18.000000', 'temperatura', 262.0000, 'ºC'),
	(313263, 142, '2015-01-15 00:55:19.000000', 'temperatura', 129.0000, 'ºC'),
	(313264, 142, '2015-01-15 00:55:20.000000', 'temperatura', 1061.0000, 'ºC'),
	(313265, 142, '2015-01-15 00:55:21.000000', 'temperatura', 120.0000, 'ºC'),
	(313266, 142, '2015-01-15 00:55:22.000000', 'temperatura', 1015.0000, 'ºC'),
	(313267, 142, '2015-01-15 00:55:23.000000', 'temperatura', 1116.0000, 'ºC'),
	(313268, 142, '2015-01-15 00:55:24.000000', 'temperatura', 137.0000, 'ºC'),
	(313269, 142, '2015-01-15 00:55:25.000000', 'temperatura', 935.0000, 'ºC'),
	(313270, 142, '2015-01-15 00:55:26.000000', 'temperatura', 665.0000, 'ºC'),
	(313271, 142, '2015-01-15 00:55:27.000000', 'temperatura', 523.0000, 'ºC'),
	(313272, 142, '2015-01-15 00:55:28.000000', 'temperatura', 619.0000, 'ºC'),
	(313273, 142, '2015-01-15 00:55:29.000000', 'temperatura', 327.0000, 'ºC'),
	(313274, 142, '2015-01-15 00:55:30.000000', 'temperatura', 978.0000, 'ºC'),
	(313275, 142, '2015-01-15 00:55:31.000000', 'temperatura', 311.0000, 'ºC'),
	(313276, 142, '2015-01-15 00:55:32.000000', 'temperatura', 1021.0000, 'ºC'),
	(313277, 142, '2015-01-15 00:55:33.000000', 'temperatura', 573.0000, 'ºC'),
	(313278, 142, '2015-01-15 00:55:34.000000', 'temperatura', 1002.0000, 'ºC'),
	(313279, 142, '2015-01-15 00:55:35.000000', 'temperatura', 891.0000, 'ºC'),
	(313280, 142, '2015-01-15 00:55:36.000000', 'temperatura', 249.0000, 'ºC'),
	(313281, 142, '2015-01-15 00:55:37.000000', 'temperatura', 971.0000, 'ºC'),
	(313282, 142, '2015-01-15 00:55:38.000000', 'temperatura', 510.0000, 'ºC'),
	(313283, 142, '2015-01-15 00:55:39.000000', 'temperatura', 839.0000, 'ºC'),
	(313284, 142, '2015-01-15 00:55:40.000000', 'temperatura', 266.0000, 'ºC'),
	(313285, 142, '2015-01-15 00:55:41.000000', 'temperatura', 11.0000, 'ºC'),
	(313286, 142, '2015-01-15 00:55:42.000000', 'temperatura', 458.0000, 'ºC'),
	(313287, 142, '2015-01-15 00:55:43.000000', 'temperatura', 1056.0000, 'ºC'),
	(313288, 142, '2015-01-15 00:55:44.000000', 'temperatura', 306.0000, 'ºC'),
	(313289, 142, '2015-01-15 00:55:45.000000', 'temperatura', 766.0000, 'ºC'),
	(313290, 142, '2015-01-15 00:55:46.000000', 'temperatura', 510.0000, 'ºC'),
	(313291, 142, '2015-01-15 00:55:47.000000', 'temperatura', 255.0000, 'ºC'),
	(313292, 142, '2015-01-15 00:55:48.000000', 'temperatura', 943.0000, 'ºC'),
	(313293, 142, '2015-01-15 00:55:49.000000', 'temperatura', 349.0000, 'ºC'),
	(313294, 142, '2015-01-15 00:55:50.000000', 'temperatura', 120.0000, 'ºC'),
	(313295, 142, '2015-01-15 00:55:51.000000', 'temperatura', 752.0000, 'ºC'),
	(313296, 142, '2015-01-15 00:55:52.000000', 'temperatura', 1001.0000, 'ºC'),
	(313297, 142, '2015-01-15 00:55:53.000000', 'temperatura', 351.0000, 'ºC'),
	(313298, 142, '2015-01-15 00:55:54.000000', 'temperatura', 1150.0000, 'ºC'),
	(313299, 142, '2015-01-15 00:55:55.000000', 'temperatura', 1097.0000, 'ºC'),
	(313300, 142, '2015-01-15 00:55:56.000000', 'temperatura', 837.0000, 'ºC'),
	(313301, 142, '2015-01-15 00:55:57.000000', 'temperatura', 896.0000, 'ºC'),
	(313302, 142, '2015-01-15 00:55:58.000000', 'temperatura', 768.0000, 'ºC'),
	(313303, 142, '2015-01-15 00:55:59.000000', 'temperatura', 1154.0000, 'ºC'),
	(313304, 142, '2015-01-15 00:56:00.000000', 'temperatura', 1067.0000, 'ºC'),
	(313305, 142, '2015-01-15 00:56:01.000000', 'temperatura', 671.0000, 'ºC'),
	(313306, 142, '2015-01-15 00:56:02.000000', 'temperatura', 155.0000, 'ºC'),
	(313307, 142, '2015-01-15 00:56:03.000000', 'temperatura', 1164.0000, 'ºC'),
	(313308, 142, '2015-01-15 00:56:04.000000', 'temperatura', 554.0000, 'ºC'),
	(313309, 142, '2015-01-15 00:56:05.000000', 'temperatura', 478.0000, 'ºC'),
	(313310, 142, '2015-01-15 00:56:06.000000', 'temperatura', 728.0000, 'ºC'),
	(313311, 142, '2015-01-15 00:56:07.000000', 'temperatura', 1008.0000, 'ºC'),
	(313312, 142, '2015-01-15 00:56:08.000000', 'temperatura', 455.0000, 'ºC'),
	(313313, 142, '2015-01-15 00:56:09.000000', 'temperatura', 451.0000, 'ºC'),
	(313314, 142, '2015-01-15 00:56:10.000000', 'temperatura', 890.0000, 'ºC'),
	(313315, 142, '2015-01-15 00:56:11.000000', 'temperatura', 700.0000, 'ºC'),
	(313316, 142, '2015-01-15 00:56:12.000000', 'temperatura', 828.0000, 'ºC'),
	(313317, 142, '2015-01-15 00:56:13.000000', 'temperatura', 840.0000, 'ºC'),
	(313318, 142, '2015-01-15 00:56:14.000000', 'temperatura', 519.0000, 'ºC'),
	(313319, 142, '2015-01-15 00:56:15.000000', 'temperatura', 75.0000, 'ºC'),
	(313320, 142, '2015-01-15 00:56:16.000000', 'temperatura', 17.0000, 'ºC'),
	(313321, 142, '2015-01-15 00:56:17.000000', 'temperatura', 1063.0000, 'ºC'),
	(313322, 142, '2015-01-15 00:56:18.000000', 'temperatura', 461.0000, 'ºC'),
	(313323, 142, '2015-01-15 00:56:19.000000', 'temperatura', 320.0000, 'ºC'),
	(313324, 142, '2015-01-15 00:56:20.000000', 'temperatura', 214.0000, 'ºC'),
	(313325, 142, '2015-01-15 00:56:21.000000', 'temperatura', 114.0000, 'ºC'),
	(313326, 142, '2015-01-15 00:56:22.000000', 'temperatura', 1126.0000, 'ºC'),
	(313327, 142, '2015-01-15 00:56:23.000000', 'temperatura', 490.0000, 'ºC'),
	(313328, 142, '2015-01-15 00:56:24.000000', 'temperatura', 273.0000, 'ºC'),
	(313329, 142, '2015-01-15 00:56:25.000000', 'temperatura', 1094.0000, 'ºC'),
	(313330, 142, '2015-01-15 00:56:26.000000', 'temperatura', 1053.0000, 'ºC'),
	(313331, 142, '2015-01-15 00:56:27.000000', 'temperatura', 783.0000, 'ºC'),
	(313332, 142, '2015-01-15 00:56:28.000000', 'temperatura', 755.0000, 'ºC'),
	(313333, 142, '2015-01-15 00:56:29.000000', 'temperatura', 228.0000, 'ºC'),
	(313334, 142, '2015-01-15 00:56:30.000000', 'temperatura', 76.0000, 'ºC'),
	(313335, 142, '2015-01-15 00:56:31.000000', 'temperatura', 895.0000, 'ºC'),
	(313336, 142, '2015-01-15 00:56:32.000000', 'temperatura', 650.0000, 'ºC'),
	(313337, 142, '2015-01-15 00:56:33.000000', 'temperatura', 564.0000, 'ºC'),
	(313338, 142, '2015-01-15 00:56:34.000000', 'temperatura', 872.0000, 'ºC'),
	(313339, 142, '2015-01-15 00:56:35.000000', 'temperatura', 267.0000, 'ºC'),
	(313340, 142, '2015-01-15 00:56:36.000000', 'temperatura', 1121.0000, 'ºC'),
	(313341, 142, '2015-01-15 00:56:37.000000', 'temperatura', 2.0000, 'ºC'),
	(313342, 142, '2015-01-15 00:56:38.000000', 'temperatura', 248.0000, 'ºC'),
	(313343, 142, '2015-01-15 00:56:39.000000', 'temperatura', 36.0000, 'ºC'),
	(313344, 142, '2015-01-15 00:56:40.000000', 'temperatura', 638.0000, 'ºC'),
	(313345, 142, '2015-01-15 00:56:41.000000', 'temperatura', 681.0000, 'ºC'),
	(313346, 142, '2015-01-15 00:56:42.000000', 'temperatura', 290.0000, 'ºC'),
	(313347, 142, '2015-01-15 00:56:43.000000', 'temperatura', 607.0000, 'ºC'),
	(313348, 142, '2015-01-15 00:56:44.000000', 'temperatura', 966.0000, 'ºC'),
	(313349, 142, '2015-01-15 00:56:45.000000', 'temperatura', 610.0000, 'ºC'),
	(313350, 142, '2015-01-15 00:56:46.000000', 'temperatura', 153.0000, 'ºC'),
	(313351, 142, '2015-01-15 00:56:47.000000', 'temperatura', 135.0000, 'ºC'),
	(313352, 142, '2015-01-15 00:56:48.000000', 'temperatura', 218.0000, 'ºC'),
	(313353, 142, '2015-01-15 00:56:49.000000', 'temperatura', 686.0000, 'ºC'),
	(313354, 142, '2015-01-15 00:56:50.000000', 'temperatura', 377.0000, 'ºC'),
	(313355, 142, '2015-01-15 00:56:51.000000', 'temperatura', 1025.0000, 'ºC'),
	(313356, 142, '2015-01-15 00:56:52.000000', 'temperatura', 394.0000, 'ºC'),
	(313357, 142, '2015-01-15 00:56:53.000000', 'temperatura', 95.0000, 'ºC'),
	(313358, 142, '2015-01-15 00:56:54.000000', 'temperatura', 495.0000, 'ºC'),
	(313359, 142, '2015-01-15 00:56:55.000000', 'temperatura', 991.0000, 'ºC'),
	(313360, 142, '2015-01-15 00:56:56.000000', 'temperatura', 1070.0000, 'ºC'),
	(313361, 142, '2015-01-15 00:56:57.000000', 'temperatura', 1176.0000, 'ºC'),
	(313362, 142, '2015-01-15 00:56:58.000000', 'temperatura', 272.0000, 'ºC'),
	(313363, 142, '2015-01-15 00:56:59.000000', 'temperatura', 232.0000, 'ºC'),
	(313364, 142, '2015-01-15 00:57:00.000000', 'temperatura', 344.0000, 'ºC'),
	(313365, 142, '2015-01-15 00:57:01.000000', 'temperatura', 1023.0000, 'ºC'),
	(313366, 142, '2015-01-15 00:57:02.000000', 'temperatura', 487.0000, 'ºC'),
	(313367, 142, '2015-01-15 00:57:03.000000', 'temperatura', 564.0000, 'ºC'),
	(313368, 142, '2015-01-15 00:57:04.000000', 'temperatura', 162.0000, 'ºC'),
	(313369, 142, '2015-01-15 00:57:05.000000', 'temperatura', 317.0000, 'ºC'),
	(313370, 142, '2015-01-15 00:57:06.000000', 'temperatura', 1102.0000, 'ºC'),
	(313371, 142, '2015-01-15 00:57:07.000000', 'temperatura', 957.0000, 'ºC'),
	(313372, 142, '2015-01-15 00:57:08.000000', 'temperatura', 278.0000, 'ºC'),
	(313373, 142, '2015-01-15 00:57:09.000000', 'temperatura', 921.0000, 'ºC'),
	(313374, 142, '2015-01-15 00:57:10.000000', 'temperatura', 172.0000, 'ºC'),
	(313375, 142, '2015-01-15 00:57:11.000000', 'temperatura', 499.0000, 'ºC'),
	(313376, 142, '2015-01-15 00:57:12.000000', 'temperatura', 777.0000, 'ºC'),
	(313377, 142, '2015-01-15 00:57:13.000000', 'temperatura', 1190.0000, 'ºC'),
	(313378, 142, '2015-01-15 00:57:14.000000', 'temperatura', 20.0000, 'ºC'),
	(313379, 142, '2015-01-15 00:57:15.000000', 'temperatura', 129.0000, 'ºC'),
	(313380, 142, '2015-01-15 00:57:16.000000', 'temperatura', 586.0000, 'ºC'),
	(313381, 142, '2015-01-15 00:57:17.000000', 'temperatura', 146.0000, 'ºC'),
	(313382, 142, '2015-01-15 00:57:18.000000', 'temperatura', 169.0000, 'ºC'),
	(313383, 142, '2015-01-15 00:57:19.000000', 'temperatura', 410.0000, 'ºC'),
	(313384, 142, '2015-01-15 00:57:20.000000', 'temperatura', 341.0000, 'ºC'),
	(313385, 142, '2015-01-15 00:57:21.000000', 'temperatura', 475.0000, 'ºC'),
	(313386, 142, '2015-01-15 00:57:22.000000', 'temperatura', 154.0000, 'ºC'),
	(313387, 142, '2015-01-15 00:57:23.000000', 'temperatura', 546.0000, 'ºC'),
	(313388, 142, '2015-01-15 00:57:24.000000', 'temperatura', 1069.0000, 'ºC'),
	(313389, 142, '2015-01-15 00:57:25.000000', 'temperatura', 106.0000, 'ºC'),
	(313390, 142, '2015-01-15 00:57:26.000000', 'temperatura', 926.0000, 'ºC'),
	(313391, 142, '2015-01-15 00:57:27.000000', 'temperatura', 711.0000, 'ºC'),
	(313392, 142, '2015-01-15 00:57:28.000000', 'temperatura', 776.0000, 'ºC'),
	(313393, 142, '2015-01-15 00:57:29.000000', 'temperatura', 547.0000, 'ºC'),
	(313394, 142, '2015-01-15 00:57:30.000000', 'temperatura', 410.0000, 'ºC'),
	(313395, 142, '2015-01-15 00:57:31.000000', 'temperatura', 410.0000, 'ºC'),
	(313396, 142, '2015-01-15 00:57:32.000000', 'temperatura', 820.0000, 'ºC'),
	(313397, 142, '2015-01-15 00:57:33.000000', 'temperatura', 468.0000, 'ºC'),
	(313398, 142, '2015-01-15 00:57:34.000000', 'temperatura', 1084.0000, 'ºC'),
	(313399, 142, '2015-01-15 00:57:35.000000', 'temperatura', 415.0000, 'ºC'),
	(313400, 142, '2015-01-15 00:57:36.000000', 'temperatura', 22.0000, 'ºC'),
	(313401, 142, '2015-01-15 00:57:37.000000', 'temperatura', 66.0000, 'ºC'),
	(313402, 142, '2015-01-15 00:57:38.000000', 'temperatura', 267.0000, 'ºC'),
	(313403, 142, '2015-01-15 00:57:39.000000', 'temperatura', 1134.0000, 'ºC'),
	(313404, 142, '2015-01-15 00:57:40.000000', 'temperatura', 71.0000, 'ºC'),
	(313405, 142, '2015-01-15 00:57:41.000000', 'temperatura', 553.0000, 'ºC'),
	(313406, 142, '2015-01-15 00:57:42.000000', 'temperatura', 154.0000, 'ºC'),
	(313407, 142, '2015-01-15 00:57:43.000000', 'temperatura', 311.0000, 'ºC'),
	(313408, 142, '2015-01-15 00:57:44.000000', 'temperatura', 1093.0000, 'ºC'),
	(313409, 142, '2015-01-15 00:57:45.000000', 'temperatura', 933.0000, 'ºC'),
	(313410, 142, '2015-01-15 00:57:46.000000', 'temperatura', 185.0000, 'ºC'),
	(313411, 142, '2015-01-15 00:57:47.000000', 'temperatura', 526.0000, 'ºC'),
	(313412, 142, '2015-01-15 00:57:48.000000', 'temperatura', 877.0000, 'ºC'),
	(313413, 142, '2015-01-15 00:57:49.000000', 'temperatura', 407.0000, 'ºC'),
	(313414, 142, '2015-01-15 00:57:50.000000', 'temperatura', 605.0000, 'ºC'),
	(313415, 142, '2015-01-15 00:57:51.000000', 'temperatura', 606.0000, 'ºC'),
	(313416, 142, '2015-01-15 00:57:52.000000', 'temperatura', 12.0000, 'ºC'),
	(313417, 142, '2015-01-15 00:57:53.000000', 'temperatura', 645.0000, 'ºC'),
	(313418, 142, '2015-01-15 00:57:54.000000', 'temperatura', 791.0000, 'ºC'),
	(313419, 142, '2015-01-15 00:57:55.000000', 'temperatura', 817.0000, 'ºC'),
	(313420, 142, '2015-01-15 00:57:56.000000', 'temperatura', 513.0000, 'ºC'),
	(313421, 142, '2015-01-15 00:57:57.000000', 'temperatura', 117.0000, 'ºC'),
	(313422, 142, '2015-01-15 00:57:58.000000', 'temperatura', 243.0000, 'ºC'),
	(313423, 142, '2015-01-15 00:57:59.000000', 'temperatura', 868.0000, 'ºC'),
	(313424, 142, '2015-01-15 00:58:00.000000', 'temperatura', 11.0000, 'ºC'),
	(313425, 142, '2015-01-15 00:58:01.000000', 'temperatura', 1049.0000, 'ºC'),
	(313426, 142, '2015-01-15 00:58:02.000000', 'temperatura', 414.0000, 'ºC'),
	(313427, 142, '2015-01-15 00:58:03.000000', 'temperatura', 122.0000, 'ºC'),
	(313428, 142, '2015-01-15 00:58:04.000000', 'temperatura', 571.0000, 'ºC'),
	(313429, 142, '2015-01-15 00:58:05.000000', 'temperatura', 87.0000, 'ºC'),
	(313430, 142, '2015-01-15 00:58:06.000000', 'temperatura', 1123.0000, 'ºC'),
	(313431, 142, '2015-01-15 00:58:07.000000', 'temperatura', 554.0000, 'ºC'),
	(313432, 142, '2015-01-15 00:58:08.000000', 'temperatura', 600.0000, 'ºC'),
	(313433, 142, '2015-01-15 00:58:09.000000', 'temperatura', 140.0000, 'ºC'),
	(313434, 142, '2015-01-15 00:58:10.000000', 'temperatura', 100.0000, 'ºC'),
	(313435, 142, '2015-01-15 00:58:11.000000', 'temperatura', 80.0000, 'ºC'),
	(313436, 142, '2015-01-15 00:58:12.000000', 'temperatura', 102.0000, 'ºC'),
	(313437, 142, '2015-01-15 00:58:13.000000', 'temperatura', 269.0000, 'ºC'),
	(313438, 142, '2015-01-15 00:58:14.000000', 'temperatura', 1039.0000, 'ºC'),
	(313439, 142, '2015-01-15 00:58:15.000000', 'temperatura', 788.0000, 'ºC'),
	(313440, 142, '2015-01-15 00:58:16.000000', 'temperatura', 826.0000, 'ºC'),
	(313441, 142, '2015-01-15 00:58:17.000000', 'temperatura', 567.0000, 'ºC'),
	(313442, 142, '2015-01-15 00:58:18.000000', 'temperatura', 356.0000, 'ºC'),
	(313443, 142, '2015-01-15 00:58:19.000000', 'temperatura', 80.0000, 'ºC'),
	(313444, 142, '2015-01-15 00:58:20.000000', 'temperatura', 533.0000, 'ºC'),
	(313445, 142, '2015-01-15 00:58:21.000000', 'temperatura', 25.0000, 'ºC'),
	(313446, 142, '2015-01-15 00:58:22.000000', 'temperatura', 925.0000, 'ºC'),
	(313447, 142, '2015-01-15 00:58:23.000000', 'temperatura', 953.0000, 'ºC'),
	(313448, 142, '2015-01-15 00:58:24.000000', 'temperatura', 789.0000, 'ºC'),
	(313449, 142, '2015-01-15 00:58:25.000000', 'temperatura', 1086.0000, 'ºC'),
	(313450, 142, '2015-01-15 00:58:26.000000', 'temperatura', 662.0000, 'ºC'),
	(313451, 142, '2015-01-15 00:58:27.000000', 'temperatura', 56.0000, 'ºC'),
	(313452, 142, '2015-01-15 00:58:28.000000', 'temperatura', 691.0000, 'ºC'),
	(313453, 142, '2015-01-15 00:58:29.000000', 'temperatura', 889.0000, 'ºC'),
	(313454, 142, '2015-01-15 00:58:30.000000', 'temperatura', 1172.0000, 'ºC'),
	(313455, 142, '2015-01-15 00:58:31.000000', 'temperatura', 793.0000, 'ºC'),
	(313456, 142, '2015-01-15 00:58:32.000000', 'temperatura', 449.0000, 'ºC'),
	(313457, 142, '2015-01-15 00:58:33.000000', 'temperatura', 1065.0000, 'ºC'),
	(313458, 142, '2015-01-15 00:58:34.000000', 'temperatura', 382.0000, 'ºC'),
	(313459, 142, '2015-01-15 00:58:35.000000', 'temperatura', 1112.0000, 'ºC'),
	(313460, 142, '2015-01-15 00:58:36.000000', 'temperatura', 818.0000, 'ºC'),
	(313461, 142, '2015-01-15 00:58:37.000000', 'temperatura', 751.0000, 'ºC'),
	(313462, 142, '2015-01-15 00:58:38.000000', 'temperatura', 103.0000, 'ºC'),
	(313463, 142, '2015-01-15 00:58:39.000000', 'temperatura', 664.0000, 'ºC'),
	(313464, 142, '2015-01-15 00:58:40.000000', 'temperatura', 610.0000, 'ºC'),
	(313465, 142, '2015-01-15 00:58:41.000000', 'temperatura', 1059.0000, 'ºC'),
	(313466, 142, '2015-01-15 00:58:42.000000', 'temperatura', 1065.0000, 'ºC'),
	(313467, 142, '2015-01-15 00:58:43.000000', 'temperatura', 949.0000, 'ºC'),
	(313468, 142, '2015-01-15 00:58:44.000000', 'temperatura', 349.0000, 'ºC'),
	(313469, 142, '2015-01-15 00:58:45.000000', 'temperatura', 101.0000, 'ºC'),
	(313470, 142, '2015-01-15 00:58:46.000000', 'temperatura', 659.0000, 'ºC'),
	(313471, 142, '2015-01-15 00:58:47.000000', 'temperatura', 592.0000, 'ºC'),
	(313472, 142, '2015-01-15 00:58:48.000000', 'temperatura', 981.0000, 'ºC'),
	(313473, 142, '2015-01-15 00:58:49.000000', 'temperatura', 732.0000, 'ºC'),
	(313474, 142, '2015-01-15 00:58:50.000000', 'temperatura', 715.0000, 'ºC'),
	(313475, 142, '2015-01-15 00:58:51.000000', 'temperatura', 183.0000, 'ºC'),
	(313476, 142, '2015-01-15 00:58:52.000000', 'temperatura', 1167.0000, 'ºC'),
	(313477, 142, '2015-01-15 00:58:53.000000', 'temperatura', 489.0000, 'ºC'),
	(313478, 142, '2015-01-15 00:58:54.000000', 'temperatura', 146.0000, 'ºC'),
	(313479, 142, '2015-01-15 00:58:55.000000', 'temperatura', 461.0000, 'ºC'),
	(313480, 142, '2015-01-15 00:58:56.000000', 'temperatura', 669.0000, 'ºC'),
	(313481, 142, '2015-01-15 00:58:57.000000', 'temperatura', 760.0000, 'ºC'),
	(313482, 142, '2015-01-15 00:58:58.000000', 'temperatura', 595.0000, 'ºC'),
	(313483, 142, '2015-01-15 00:58:59.000000', 'temperatura', 696.0000, 'ºC'),
	(313484, 142, '2015-01-15 00:59:00.000000', 'temperatura', 495.0000, 'ºC'),
	(313485, 142, '2015-01-15 00:59:01.000000', 'temperatura', 389.0000, 'ºC'),
	(313486, 142, '2015-01-15 00:59:02.000000', 'temperatura', 461.0000, 'ºC'),
	(313487, 142, '2015-01-15 00:59:03.000000', 'temperatura', 1138.0000, 'ºC'),
	(313488, 142, '2015-01-15 00:59:04.000000', 'temperatura', 708.0000, 'ºC'),
	(313489, 142, '2015-01-15 00:59:05.000000', 'temperatura', 127.0000, 'ºC'),
	(313490, 142, '2015-01-15 00:59:06.000000', 'temperatura', 911.0000, 'ºC'),
	(313491, 142, '2015-01-15 00:59:07.000000', 'temperatura', 573.0000, 'ºC'),
	(313492, 142, '2015-01-15 00:59:08.000000', 'temperatura', 131.0000, 'ºC'),
	(313493, 142, '2015-01-15 00:59:09.000000', 'temperatura', 140.0000, 'ºC'),
	(313494, 142, '2015-01-15 00:59:10.000000', 'temperatura', 305.0000, 'ºC'),
	(313495, 142, '2015-01-15 00:59:11.000000', 'temperatura', 1106.0000, 'ºC'),
	(313496, 142, '2015-01-15 00:59:12.000000', 'temperatura', 1017.0000, 'ºC'),
	(313497, 142, '2015-01-15 00:59:13.000000', 'temperatura', 567.0000, 'ºC'),
	(313498, 142, '2015-01-15 00:59:14.000000', 'temperatura', 984.0000, 'ºC'),
	(313499, 142, '2015-01-15 00:59:15.000000', 'temperatura', 821.0000, 'ºC'),
	(313500, 142, '2015-01-15 00:59:16.000000', 'temperatura', 1153.0000, 'ºC'),
	(313501, 142, '2015-01-15 00:59:17.000000', 'temperatura', 903.0000, 'ºC'),
	(313502, 142, '2015-01-15 00:59:18.000000', 'temperatura', 1058.0000, 'ºC'),
	(313503, 142, '2015-01-15 00:59:19.000000', 'temperatura', 180.0000, 'ºC'),
	(313504, 142, '2015-01-15 00:59:20.000000', 'temperatura', 125.0000, 'ºC'),
	(313505, 142, '2015-01-15 00:59:21.000000', 'temperatura', 88.0000, 'ºC'),
	(313506, 142, '2015-01-15 00:59:22.000000', 'temperatura', 65.0000, 'ºC'),
	(313507, 142, '2015-01-15 00:59:23.000000', 'temperatura', 60.0000, 'ºC'),
	(313508, 142, '2015-01-15 00:59:24.000000', 'temperatura', 105.0000, 'ºC'),
	(313509, 142, '2015-01-15 00:59:25.000000', 'temperatura', 347.0000, 'ºC'),
	(313510, 142, '2015-01-15 00:59:26.000000', 'temperatura', 219.0000, 'ºC'),
	(313511, 142, '2015-01-15 00:59:27.000000', 'temperatura', 54.0000, 'ºC'),
	(313512, 142, '2015-01-15 00:59:28.000000', 'temperatura', 816.0000, 'ºC'),
	(313513, 142, '2015-01-15 00:59:29.000000', 'temperatura', 316.0000, 'ºC'),
	(313514, 142, '2015-01-15 00:59:30.000000', 'temperatura', 332.0000, 'ºC'),
	(313515, 142, '2015-01-15 00:59:31.000000', 'temperatura', 711.0000, 'ºC'),
	(313516, 142, '2015-01-15 00:59:32.000000', 'temperatura', 163.0000, 'ºC'),
	(313517, 142, '2015-01-15 00:59:33.000000', 'temperatura', 1081.0000, 'ºC'),
	(313518, 142, '2015-01-15 00:59:34.000000', 'temperatura', 117.0000, 'ºC'),
	(313519, 142, '2015-01-15 00:59:35.000000', 'temperatura', 943.0000, 'ºC'),
	(313520, 142, '2015-01-15 00:59:36.000000', 'temperatura', 764.0000, 'ºC'),
	(313521, 142, '2015-01-15 00:59:37.000000', 'temperatura', 991.0000, 'ºC'),
	(313522, 142, '2015-01-15 00:59:38.000000', 'temperatura', 263.0000, 'ºC'),
	(313523, 142, '2015-01-15 00:59:39.000000', 'temperatura', 745.0000, 'ºC'),
	(313524, 142, '2015-01-15 00:59:40.000000', 'temperatura', 535.0000, 'ºC'),
	(313525, 142, '2015-01-15 00:59:41.000000', 'temperatura', 440.0000, 'ºC'),
	(313526, 142, '2015-01-15 00:59:42.000000', 'temperatura', 595.0000, 'ºC'),
	(313527, 142, '2015-01-15 00:59:43.000000', 'temperatura', 455.0000, 'ºC'),
	(313528, 142, '2015-01-15 00:59:44.000000', 'temperatura', 492.0000, 'ºC'),
	(313529, 142, '2015-01-15 00:59:45.000000', 'temperatura', 1097.0000, 'ºC'),
	(313530, 142, '2015-01-15 00:59:46.000000', 'temperatura', 407.0000, 'ºC'),
	(313531, 142, '2015-01-15 00:59:47.000000', 'temperatura', 1147.0000, 'ºC'),
	(313532, 142, '2015-01-15 00:59:48.000000', 'temperatura', 913.0000, 'ºC'),
	(313533, 142, '2015-01-15 00:59:49.000000', 'temperatura', 1124.0000, 'ºC'),
	(313534, 142, '2015-01-15 00:59:50.000000', 'temperatura', 483.0000, 'ºC'),
	(313535, 142, '2015-01-15 00:59:51.000000', 'temperatura', 243.0000, 'ºC'),
	(313536, 142, '2015-01-15 00:59:52.000000', 'temperatura', 968.0000, 'ºC'),
	(313537, 142, '2015-01-15 00:59:53.000000', 'temperatura', 508.0000, 'ºC'),
	(313538, 142, '2015-01-15 00:59:54.000000', 'temperatura', 840.0000, 'ºC'),
	(313539, 142, '2015-01-15 00:59:55.000000', 'temperatura', 276.0000, 'ºC'),
	(313540, 142, '2015-01-15 00:59:56.000000', 'temperatura', 61.0000, 'ºC'),
	(313541, 142, '2015-01-15 00:59:57.000000', 'temperatura', 678.0000, 'ºC'),
	(313542, 142, '2015-01-15 00:59:58.000000', 'temperatura', 808.0000, 'ºC'),
	(313543, 142, '2015-01-15 00:59:59.000000', 'temperatura', 805.0000, 'ºC'),
	(313544, 142, '2015-01-15 01:00:00.000000', 'temperatura', 403.0000, 'ºC'),
	(313545, 142, '2015-01-15 01:00:01.000000', 'temperatura', 801.0000, 'ºC'),
	(313546, 142, '2015-01-15 01:00:02.000000', 'temperatura', 396.0000, 'ºC'),
	(313547, 142, '2015-01-15 01:00:03.000000', 'temperatura', 776.0000, 'ºC'),
	(313548, 142, '2015-01-15 01:00:04.000000', 'temperatura', 294.0000, 'ºC'),
	(313549, 142, '2015-01-15 01:00:05.000000', 'temperatura', 343.0000, 'ºC'),
	(313550, 142, '2015-01-15 01:00:06.000000', 'temperatura', 832.0000, 'ºC'),
	(313551, 142, '2015-01-15 01:00:07.000000', 'temperatura', 731.0000, 'ºC'),
	(313552, 142, '2015-01-15 01:00:08.000000', 'temperatura', 1160.0000, 'ºC'),
	(313553, 142, '2015-01-15 01:00:09.000000', 'temperatura', 8.0000, 'ºC'),
	(313554, 142, '2015-01-15 01:00:10.000000', 'temperatura', 160.0000, 'ºC'),
	(313555, 142, '2015-01-15 01:00:11.000000', 'temperatura', 777.0000, 'ºC'),
	(313556, 142, '2015-01-15 01:00:12.000000', 'temperatura', 1006.0000, 'ºC'),
	(313557, 142, '2015-01-15 01:00:13.000000', 'temperatura', 300.0000, 'ºC'),
	(313558, 142, '2015-01-15 01:00:14.000000', 'temperatura', 882.0000, 'ºC'),
	(313559, 142, '2015-01-15 01:00:15.000000', 'temperatura', 1112.0000, 'ºC'),
	(313560, 142, '2015-01-15 01:00:16.000000', 'temperatura', 515.0000, 'ºC'),
	(313561, 142, '2015-01-15 01:00:17.000000', 'temperatura', 436.0000, 'ºC'),
	(313562, 142, '2015-01-15 01:00:18.000000', 'temperatura', 638.0000, 'ºC'),
	(313563, 142, '2015-01-15 01:00:19.000000', 'temperatura', 684.0000, 'ºC'),
	(313564, 142, '2015-01-15 01:00:20.000000', 'temperatura', 305.0000, 'ºC'),
	(313565, 142, '2015-01-15 01:00:21.000000', 'temperatura', 672.0000, 'ºC'),
	(313566, 142, '2015-01-15 01:00:22.000000', 'temperatura', 48.0000, 'ºC'),
	(313567, 142, '2015-01-15 01:00:23.000000', 'temperatura', 622.0000, 'ºC'),
	(313568, 142, '2015-01-15 01:00:24.000000', 'temperatura', 568.0000, 'ºC'),
	(313569, 142, '2015-01-15 01:00:25.000000', 'temperatura', 974.0000, 'ºC'),
	(313570, 142, '2015-01-15 01:00:26.000000', 'temperatura', 766.0000, 'ºC'),
	(313571, 142, '2015-01-15 01:00:27.000000', 'temperatura', 910.0000, 'ºC'),
	(313572, 142, '2015-01-15 01:00:28.000000', 'temperatura', 1051.0000, 'ºC'),
	(313573, 142, '2015-01-15 01:00:29.000000', 'temperatura', 126.0000, 'ºC'),
	(313574, 142, '2015-01-15 01:00:30.000000', 'temperatura', 1079.0000, 'ºC'),
	(313575, 142, '2015-01-15 01:00:31.000000', 'temperatura', 215.0000, 'ºC'),
	(313576, 142, '2015-01-15 01:00:32.000000', 'temperatura', 239.0000, 'ºC'),
	(313577, 142, '2015-01-15 01:00:33.000000', 'temperatura', 553.0000, 'ºC'),
	(313578, 142, '2015-01-15 01:00:34.000000', 'temperatura', 846.0000, 'ºC'),
	(313579, 142, '2015-01-15 01:00:35.000000', 'temperatura', 173.0000, 'ºC'),
	(313580, 142, '2015-01-15 01:00:36.000000', 'temperatura', 726.0000, 'ºC'),
	(313581, 142, '2015-01-15 01:00:37.000000', 'temperatura', 710.0000, 'ºC'),
	(313582, 142, '2015-01-15 01:00:38.000000', 'temperatura', 176.0000, 'ºC'),
	(313583, 142, '2015-01-15 01:00:39.000000', 'temperatura', 1149.0000, 'ºC'),
	(313584, 142, '2015-01-15 01:00:40.000000', 'temperatura', 419.0000, 'ºC'),
	(313585, 142, '2015-01-15 01:00:41.000000', 'temperatura', 1047.0000, 'ºC'),
	(313586, 142, '2015-01-15 01:00:42.000000', 'temperatura', 377.0000, 'ºC'),
	(313587, 142, '2015-01-15 01:00:43.000000', 'temperatura', 1147.0000, 'ºC'),
	(313588, 142, '2015-01-15 01:00:44.000000', 'temperatura', 1002.0000, 'ºC'),
	(313589, 142, '2015-01-15 01:00:45.000000', 'temperatura', 370.0000, 'ºC'),
	(313590, 142, '2015-01-15 01:00:46.000000', 'temperatura', 46.0000, 'ºC'),
	(313591, 142, '2015-01-15 01:00:47.000000', 'temperatura', 321.0000, 'ºC'),
	(313592, 142, '2015-01-15 01:00:48.000000', 'temperatura', 267.0000, 'ºC'),
	(313593, 142, '2015-01-15 01:00:49.000000', 'temperatura', 372.0000, 'ºC'),
	(313594, 142, '2015-01-15 01:00:50.000000', 'temperatura', 1060.0000, 'ºC'),
	(313595, 142, '2015-01-15 01:00:51.000000', 'temperatura', 583.0000, 'ºC'),
	(313596, 142, '2015-01-15 01:00:52.000000', 'temperatura', 937.0000, 'ºC'),
	(313597, 142, '2015-01-15 01:00:53.000000', 'temperatura', 536.0000, 'ºC'),
	(313598, 142, '2015-01-15 01:00:54.000000', 'temperatura', 1069.0000, 'ºC'),
	(313599, 142, '2015-01-15 01:00:55.000000', 'temperatura', 139.0000, 'ºC'),
	(313600, 142, '2015-01-15 01:00:56.000000', 'temperatura', 1087.0000, 'ºC'),
	(313601, 142, '2015-01-15 01:00:57.000000', 'temperatura', 219.0000, 'ºC'),
	(313602, 142, '2015-01-15 01:00:58.000000', 'temperatura', 234.0000, 'ºC'),
	(313603, 142, '2015-01-15 01:00:59.000000', 'temperatura', 515.0000, 'ºC'),
	(313604, 142, '2015-01-15 01:01:00.000000', 'temperatura', 675.0000, 'ºC'),
	(313605, 142, '2015-01-15 01:01:01.000000', 'temperatura', 627.0000, 'ºC'),
	(313606, 142, '2015-01-15 01:01:02.000000', 'temperatura', 1113.0000, 'ºC'),
	(313607, 142, '2015-01-15 01:01:03.000000', 'temperatura', 84.0000, 'ºC'),
	(313608, 142, '2015-01-15 01:01:04.000000', 'temperatura', 683.0000, 'ºC'),
	(313609, 142, '2015-01-15 01:01:05.000000', 'temperatura', 761.0000, 'ºC'),
	(313610, 142, '2015-01-15 01:01:06.000000', 'temperatura', 558.0000, 'ºC'),
	(313611, 142, '2015-01-15 01:01:07.000000', 'temperatura', 508.0000, 'ºC'),
	(313612, 142, '2015-01-15 01:01:08.000000', 'temperatura', 868.0000, 'ºC'),
	(313613, 142, '2015-01-15 01:01:09.000000', 'temperatura', 415.0000, 'ºC'),
	(313614, 142, '2015-01-15 01:01:10.000000', 'temperatura', 670.0000, 'ºC'),
	(313615, 142, '2015-01-15 01:01:11.000000', 'temperatura', 904.0000, 'ºC'),
	(313616, 142, '2015-01-15 01:01:12.000000', 'temperatura', 114.0000, 'ºC'),
	(313617, 142, '2015-01-15 01:01:13.000000', 'temperatura', 258.0000, 'ºC'),
	(313618, 142, '2015-01-15 01:01:14.000000', 'temperatura', 947.0000, 'ºC'),
	(313619, 142, '2015-01-15 01:01:15.000000', 'temperatura', 362.0000, 'ºC'),
	(313620, 142, '2015-01-15 01:01:16.000000', 'temperatura', 171.0000, 'ºC'),
	(313621, 142, '2015-01-15 01:01:17.000000', 'temperatura', 968.0000, 'ºC'),
	(313622, 142, '2015-01-15 01:01:18.000000', 'temperatura', 726.0000, 'ºC'),
	(313623, 142, '2015-01-15 01:01:19.000000', 'temperatura', 727.0000, 'ºC'),
	(313624, 142, '2015-01-15 01:01:20.000000', 'temperatura', 258.0000, 'ºC'),
	(313625, 142, '2015-01-15 01:01:21.000000', 'temperatura', 310.0000, 'ºC'),
	(313626, 142, '2015-01-15 01:01:22.000000', 'temperatura', 777.0000, 'ºC'),
	(313627, 142, '2015-01-15 01:01:23.000000', 'temperatura', 557.0000, 'ºC'),
	(313628, 142, '2015-01-15 01:01:24.000000', 'temperatura', 453.0000, 'ºC'),
	(313629, 142, '2015-01-15 01:01:25.000000', 'temperatura', 593.0000, 'ºC'),
	(313630, 142, '2015-01-15 01:01:26.000000', 'temperatura', 407.0000, 'ºC'),
	(313631, 142, '2015-01-15 01:01:27.000000', 'temperatura', 255.0000, 'ºC'),
	(313632, 142, '2015-01-15 01:01:28.000000', 'temperatura', 57.0000, 'ºC'),
	(313633, 142, '2015-01-15 01:01:29.000000', 'temperatura', 719.0000, 'ºC'),
	(313634, 142, '2015-01-15 01:01:30.000000', 'temperatura', 1026.0000, 'ºC'),
	(313635, 142, '2015-01-15 01:01:31.000000', 'temperatura', 574.0000, 'ºC'),
	(313636, 142, '2015-01-15 01:01:32.000000', 'temperatura', 990.0000, 'ºC'),
	(313637, 142, '2015-01-15 01:01:33.000000', 'temperatura', 831.0000, 'ºC'),
	(313638, 142, '2015-01-15 01:01:34.000000', 'temperatura', 1186.0000, 'ºC'),
	(313639, 142, '2015-01-15 01:01:35.000000', 'temperatura', 1037.0000, 'ºC'),
	(313640, 142, '2015-01-15 01:01:36.000000', 'temperatura', 427.0000, 'ºC'),
	(313641, 142, '2015-01-15 01:01:37.000000', 'temperatura', 224.0000, 'ºC'),
	(313642, 142, '2015-01-15 01:01:38.000000', 'temperatura', 1038.0000, 'ºC'),
	(313643, 142, '2015-01-15 01:01:39.000000', 'temperatura', 919.0000, 'ºC'),
	(313644, 142, '2015-01-15 01:01:40.000000', 'temperatura', 283.0000, 'ºC'),
	(313645, 142, '2015-01-15 01:01:41.000000', 'temperatura', 1056.0000, 'ºC'),
	(313646, 142, '2015-01-15 01:01:42.000000', 'temperatura', 832.0000, 'ºC'),
	(313647, 142, '2015-01-15 01:01:43.000000', 'temperatura', 992.0000, 'ºC'),
	(313648, 142, '2015-01-15 01:01:44.000000', 'temperatura', 66.0000, 'ºC'),
	(313649, 142, '2015-01-15 01:01:45.000000', 'temperatura', 956.0000, 'ºC'),
	(313650, 142, '2015-01-15 01:01:46.000000', 'temperatura', 981.0000, 'ºC'),
	(313651, 142, '2015-01-15 01:01:47.000000', 'temperatura', 839.0000, 'ºC'),
	(313652, 142, '2015-01-15 01:01:48.000000', 'temperatura', 53.0000, 'ºC'),
	(313653, 142, '2015-01-15 01:01:49.000000', 'temperatura', 146.0000, 'ºC'),
	(313654, 142, '2015-01-15 01:01:50.000000', 'temperatura', 572.0000, 'ºC'),
	(313655, 142, '2015-01-15 01:01:51.000000', 'temperatura', 23.0000, 'ºC'),
	(313656, 142, '2015-01-15 01:01:52.000000', 'temperatura', 801.0000, 'ºC'),
	(313657, 142, '2015-01-15 01:01:53.000000', 'temperatura', 337.0000, 'ºC'),
	(313658, 142, '2015-01-15 01:01:54.000000', 'temperatura', 483.0000, 'ºC'),
	(313659, 142, '2015-01-15 01:01:55.000000', 'temperatura', 204.0000, 'ºC'),
	(313660, 142, '2015-01-15 01:01:56.000000', 'temperatura', 769.0000, 'ºC'),
	(313661, 142, '2015-01-15 01:01:57.000000', 'temperatura', 836.0000, 'ºC'),
	(313662, 142, '2015-01-15 01:01:58.000000', 'temperatura', 672.0000, 'ºC'),
	(313663, 142, '2015-01-15 01:01:59.000000', 'temperatura', 854.0000, 'ºC'),
	(313664, 142, '2015-01-15 01:02:00.000000', 'temperatura', 1056.0000, 'ºC'),
	(313665, 142, '2015-01-15 01:02:01.000000', 'temperatura', 315.0000, 'ºC'),
	(313666, 142, '2015-01-15 01:02:02.000000', 'temperatura', 810.0000, 'ºC'),
	(313667, 142, '2015-01-15 01:02:03.000000', 'temperatura', 703.0000, 'ºC'),
	(313668, 142, '2015-01-15 01:02:04.000000', 'temperatura', 1087.0000, 'ºC'),
	(313669, 142, '2015-01-15 01:02:05.000000', 'temperatura', 924.0000, 'ºC'),
	(313670, 142, '2015-01-15 01:02:06.000000', 'temperatura', 162.0000, 'ºC'),
	(313671, 142, '2015-01-15 01:02:07.000000', 'temperatura', 439.0000, 'ºC'),
	(313672, 142, '2015-01-15 01:02:08.000000', 'temperatura', 508.0000, 'ºC'),
	(313673, 142, '2015-01-15 01:02:09.000000', 'temperatura', 22.0000, 'ºC'),
	(313674, 142, '2015-01-15 01:02:10.000000', 'temperatura', 989.0000, 'ºC'),
	(313675, 142, '2015-01-15 01:02:11.000000', 'temperatura', 79.0000, 'ºC'),
	(313676, 142, '2015-01-15 01:02:12.000000', 'temperatura', 1029.0000, 'ºC'),
	(313677, 142, '2015-01-15 01:02:13.000000', 'temperatura', 108.0000, 'ºC'),
	(313678, 142, '2015-01-15 01:02:14.000000', 'temperatura', 1052.0000, 'ºC'),
	(313679, 142, '2015-01-15 01:02:15.000000', 'temperatura', 136.0000, 'ºC'),
	(313680, 142, '2015-01-15 01:02:16.000000', 'temperatura', 1124.0000, 'ºC'),
	(313681, 142, '2015-01-15 01:02:17.000000', 'temperatura', 412.0000, 'ºC'),
	(313682, 142, '2015-01-15 01:02:18.000000', 'temperatura', 1091.0000, 'ºC'),
	(313683, 142, '2015-01-15 01:02:19.000000', 'temperatura', 619.0000, 'ºC'),
	(313684, 142, '2015-01-15 01:02:20.000000', 'temperatura', 1022.0000, 'ºC'),
	(313685, 142, '2015-01-15 01:02:21.000000', 'temperatura', 852.0000, 'ºC'),
	(313686, 142, '2015-01-15 01:02:22.000000', 'temperatura', 1194.0000, 'ºC'),
	(313687, 142, '2015-01-15 01:02:23.000000', 'temperatura', 1017.0000, 'ºC'),
	(313688, 142, '2015-01-15 01:02:24.000000', 'temperatura', 302.0000, 'ºC'),
	(313689, 142, '2015-01-15 01:02:25.000000', 'temperatura', 858.0000, 'ºC'),
	(313690, 142, '2015-01-15 01:02:26.000000', 'temperatura', 987.0000, 'ºC'),
	(313691, 142, '2015-01-15 01:02:27.000000', 'temperatura', 1161.0000, 'ºC'),
	(313692, 142, '2015-01-15 01:02:28.000000', 'temperatura', 444.0000, 'ºC'),
	(313693, 142, '2015-01-15 01:02:29.000000', 'temperatura', 1137.0000, 'ºC'),
	(313694, 142, '2015-01-15 01:02:30.000000', 'temperatura', 753.0000, 'ºC'),
	(313695, 142, '2015-01-15 01:02:31.000000', 'temperatura', 356.0000, 'ºC'),
	(313696, 142, '2015-01-15 01:02:32.000000', 'temperatura', 721.0000, 'ºC'),
	(313697, 142, '2015-01-15 01:02:33.000000', 'temperatura', 137.0000, 'ºC'),
	(313698, 142, '2015-01-15 01:02:34.000000', 'temperatura', 923.0000, 'ºC'),
	(313699, 142, '2015-01-15 01:02:35.000000', 'temperatura', 605.0000, 'ºC'),
	(313700, 142, '2015-01-15 01:02:36.000000', 'temperatura', 258.0000, 'ºC'),
	(313701, 142, '2015-01-15 01:02:37.000000', 'temperatura', 674.0000, 'ºC'),
	(313702, 142, '2015-01-15 01:02:38.000000', 'temperatura', 198.0000, 'ºC'),
	(313703, 142, '2015-01-15 01:02:39.000000', 'temperatura', 168.0000, 'ºC'),
	(313704, 142, '2015-01-15 01:02:40.000000', 'temperatura', 248.0000, 'ºC'),
	(313705, 142, '2015-01-15 01:02:41.000000', 'temperatura', 733.0000, 'ºC'),
	(313706, 142, '2015-01-15 01:02:42.000000', 'temperatura', 524.0000, 'ºC'),
	(313707, 142, '2015-01-15 01:02:43.000000', 'temperatura', 422.0000, 'ºC'),
	(313708, 142, '2015-01-15 01:02:44.000000', 'temperatura', 537.0000, 'ºC'),
	(313709, 142, '2015-01-15 01:02:45.000000', 'temperatura', 220.0000, 'ºC'),
	(313710, 142, '2015-01-15 01:02:46.000000', 'temperatura', 689.0000, 'ºC'),
	(313711, 142, '2015-01-15 01:02:47.000000', 'temperatura', 388.0000, 'ºC'),
	(313712, 142, '2015-01-15 01:02:48.000000', 'temperatura', 1072.0000, 'ºC'),
	(313713, 142, '2015-01-15 01:02:49.000000', 'temperatura', 595.0000, 'ºC'),
	(313714, 142, '2015-01-15 01:02:50.000000', 'temperatura', 960.0000, 'ºC'),
	(313715, 142, '2015-01-15 01:02:51.000000', 'temperatura', 615.0000, 'ºC'),
	(313716, 142, '2015-01-15 01:02:52.000000', 'temperatura', 195.0000, 'ºC'),
	(313717, 142, '2015-01-15 01:02:53.000000', 'temperatura', 330.0000, 'ºC'),
	(313718, 142, '2015-01-15 01:02:54.000000', 'temperatura', 1065.0000, 'ºC'),
	(313719, 142, '2015-01-15 01:02:55.000000', 'temperatura', 738.0000, 'ºC'),
	(313720, 142, '2015-01-15 01:02:56.000000', 'temperatura', 494.0000, 'ºC'),
	(313721, 142, '2015-01-15 01:02:57.000000', 'temperatura', 258.0000, 'ºC'),
	(313722, 142, '2015-01-15 01:02:58.000000', 'temperatura', 1007.0000, 'ºC'),
	(313723, 142, '2015-01-15 01:02:59.000000', 'temperatura', 663.0000, 'ºC'),
	(313724, 142, '2015-01-15 01:03:00.000000', 'temperatura', 292.0000, 'ºC'),
	(313725, 142, '2015-01-15 01:03:01.000000', 'temperatura', 674.0000, 'ºC'),
	(313726, 142, '2015-01-15 01:03:02.000000', 'temperatura', 92.0000, 'ºC'),
	(313727, 142, '2015-01-15 01:03:03.000000', 'temperatura', 840.0000, 'ºC'),
	(313728, 142, '2015-01-15 01:03:04.000000', 'temperatura', 325.0000, 'ºC'),
	(313729, 142, '2015-01-15 01:03:05.000000', 'temperatura', 306.0000, 'ºC'),
	(313730, 142, '2015-01-15 01:03:06.000000', 'temperatura', 554.0000, 'ºC'),
	(313731, 142, '2015-01-15 01:03:07.000000', 'temperatura', 654.0000, 'ºC'),
	(313732, 142, '2015-01-15 01:03:08.000000', 'temperatura', 409.0000, 'ºC'),
	(313733, 142, '2015-01-15 01:03:09.000000', 'temperatura', 82.0000, 'ºC'),
	(313734, 142, '2015-01-15 01:03:10.000000', 'temperatura', 382.0000, 'ºC'),
	(313735, 142, '2015-01-15 01:03:11.000000', 'temperatura', 467.0000, 'ºC'),
	(313736, 142, '2015-01-15 01:03:12.000000', 'temperatura', 1189.0000, 'ºC'),
	(313737, 142, '2015-01-15 01:03:13.000000', 'temperatura', 946.0000, 'ºC'),
	(313738, 142, '2015-01-15 01:03:14.000000', 'temperatura', 1164.0000, 'ºC'),
	(313739, 142, '2015-01-15 01:03:15.000000', 'temperatura', 581.0000, 'ºC'),
	(313740, 142, '2015-01-15 01:03:16.000000', 'temperatura', 616.0000, 'ºC'),
	(313741, 142, '2015-01-15 01:03:17.000000', 'temperatura', 134.0000, 'ºC'),
	(313742, 142, '2015-01-15 01:03:18.000000', 'temperatura', 24.0000, 'ºC'),
	(313743, 142, '2015-01-15 01:03:19.000000', 'temperatura', 918.0000, 'ºC'),
	(313744, 142, '2015-01-15 01:03:20.000000', 'temperatura', 918.0000, 'ºC'),
	(313745, 142, '2015-01-15 01:03:21.000000', 'temperatura', 637.0000, 'ºC'),
	(313746, 142, '2015-01-15 01:03:22.000000', 'temperatura', 430.0000, 'ºC'),
	(313747, 142, '2015-01-15 01:03:23.000000', 'temperatura', 240.0000, 'ºC'),
	(313748, 142, '2015-01-15 01:03:24.000000', 'temperatura', 1111.0000, 'ºC'),
	(313749, 142, '2015-01-15 01:03:25.000000', 'temperatura', 36.0000, 'ºC'),
	(313750, 142, '2015-01-15 01:03:26.000000', 'temperatura', 445.0000, 'ºC'),
	(313751, 142, '2015-01-15 01:03:27.000000', 'temperatura', 919.0000, 'ºC'),
	(313752, 142, '2015-01-15 01:03:28.000000', 'temperatura', 861.0000, 'ºC'),
	(313753, 142, '2015-01-15 01:03:29.000000', 'temperatura', 348.0000, 'ºC'),
	(313754, 142, '2015-01-15 01:03:30.000000', 'temperatura', 360.0000, 'ºC'),
	(313755, 142, '2015-01-15 01:03:31.000000', 'temperatura', 753.0000, 'ºC'),
	(313756, 142, '2015-01-15 01:03:32.000000', 'temperatura', 287.0000, 'ºC'),
	(313757, 142, '2015-01-15 01:03:33.000000', 'temperatura', 376.0000, 'ºC'),
	(313758, 142, '2015-01-15 01:03:34.000000', 'temperatura', 1018.0000, 'ºC'),
	(313759, 142, '2015-01-15 01:03:35.000000', 'temperatura', 364.0000, 'ºC'),
	(313760, 142, '2015-01-15 01:03:36.000000', 'temperatura', 1167.0000, 'ºC'),
	(313761, 142, '2015-01-15 01:03:37.000000', 'temperatura', 1142.0000, 'ºC'),
	(313762, 142, '2015-01-15 01:03:38.000000', 'temperatura', 1012.0000, 'ºC'),
	(313763, 142, '2015-01-15 01:03:39.000000', 'temperatura', 434.0000, 'ºC'),
	(313764, 142, '2015-01-15 01:03:40.000000', 'temperatura', 336.0000, 'ºC'),
	(313765, 142, '2015-01-15 01:03:41.000000', 'temperatura', 377.0000, 'ºC'),
	(313766, 142, '2015-01-15 01:03:42.000000', 'temperatura', 877.0000, 'ºC'),
	(313767, 142, '2015-01-15 01:03:43.000000', 'temperatura', 855.0000, 'ºC'),
	(313768, 142, '2015-01-15 01:03:44.000000', 'temperatura', 445.0000, 'ºC'),
	(313769, 142, '2015-01-15 01:03:45.000000', 'temperatura', 860.0000, 'ºC'),
	(313770, 142, '2015-01-15 01:03:46.000000', 'temperatura', 565.0000, 'ºC'),
	(313771, 142, '2015-01-15 01:03:47.000000', 'temperatura', 247.0000, 'ºC'),
	(313772, 142, '2015-01-15 01:03:48.000000', 'temperatura', 739.0000, 'ºC'),
	(313773, 142, '2015-01-15 01:03:49.000000', 'temperatura', 554.0000, 'ºC'),
	(313774, 142, '2015-01-15 01:03:50.000000', 'temperatura', 556.0000, 'ºC'),
	(313775, 142, '2015-01-15 01:03:51.000000', 'temperatura', 1116.0000, 'ºC'),
	(313776, 142, '2015-01-15 01:03:52.000000', 'temperatura', 312.0000, 'ºC'),
	(313777, 142, '2015-01-15 01:03:53.000000', 'temperatura', 612.0000, 'ºC'),
	(313778, 142, '2015-01-15 01:03:54.000000', 'temperatura', 927.0000, 'ºC'),
	(313779, 142, '2015-01-15 01:03:55.000000', 'temperatura', 399.0000, 'ºC'),
	(313780, 142, '2015-01-15 01:03:56.000000', 'temperatura', 416.0000, 'ºC'),
	(313781, 142, '2015-01-15 01:03:57.000000', 'temperatura', 880.0000, 'ºC'),
	(313782, 142, '2015-01-15 01:03:58.000000', 'temperatura', 755.0000, 'ºC'),
	(313783, 142, '2015-01-15 01:03:59.000000', 'temperatura', 1136.0000, 'ºC'),
	(313784, 142, '2015-01-15 01:04:00.000000', 'temperatura', 1015.0000, 'ºC'),
	(313785, 142, '2015-01-15 01:04:01.000000', 'temperatura', 469.0000, 'ºC'),
	(313786, 142, '2015-01-15 01:04:02.000000', 'temperatura', 501.0000, 'ºC'),
	(313787, 142, '2015-01-15 01:04:03.000000', 'temperatura', 1098.0000, 'ºC'),
	(313788, 142, '2015-01-15 01:04:04.000000', 'temperatura', 386.0000, 'ºC'),
	(313789, 142, '2015-01-15 01:04:05.000000', 'temperatura', 1035.0000, 'ºC'),
	(313790, 142, '2015-01-15 01:04:06.000000', 'temperatura', 420.0000, 'ºC'),
	(313791, 142, '2015-01-15 01:04:07.000000', 'temperatura', 194.0000, 'ºC'),
	(313792, 142, '2015-01-15 01:04:08.000000', 'temperatura', 909.0000, 'ºC'),
	(313793, 142, '2015-01-15 01:04:09.000000', 'temperatura', 366.0000, 'ºC'),
	(313794, 142, '2015-01-15 01:04:10.000000', 'temperatura', 305.0000, 'ºC'),
	(313795, 142, '2015-01-15 01:04:11.000000', 'temperatura', 424.0000, 'ºC'),
	(313796, 142, '2015-01-15 01:04:12.000000', 'temperatura', 7.0000, 'ºC'),
	(313797, 142, '2015-01-15 01:04:13.000000', 'temperatura', 1162.0000, 'ºC'),
	(313798, 142, '2015-01-15 01:04:14.000000', 'temperatura', 989.0000, 'ºC'),
	(313799, 142, '2015-01-15 01:04:15.000000', 'temperatura', 259.0000, 'ºC'),
	(313800, 142, '2015-01-15 01:04:16.000000', 'temperatura', 730.0000, 'ºC'),
	(313801, 142, '2015-01-15 01:04:17.000000', 'temperatura', 473.0000, 'ºC'),
	(313802, 142, '2015-01-15 01:04:18.000000', 'temperatura', 175.0000, 'ºC'),
	(313803, 142, '2015-01-15 01:04:19.000000', 'temperatura', 657.0000, 'ºC'),
	(313804, 142, '2015-01-15 01:04:20.000000', 'temperatura', 358.0000, 'ºC'),
	(313805, 142, '2015-01-15 01:04:21.000000', 'temperatura', 1023.0000, 'ºC'),
	(313806, 142, '2015-01-15 01:04:22.000000', 'temperatura', 442.0000, 'ºC'),
	(313807, 142, '2015-01-15 01:04:23.000000', 'temperatura', 339.0000, 'ºC'),
	(313808, 142, '2015-01-15 01:04:24.000000', 'temperatura', 373.0000, 'ºC'),
	(313809, 142, '2015-01-15 01:04:25.000000', 'temperatura', 845.0000, 'ºC'),
	(313810, 142, '2015-01-15 01:04:26.000000', 'temperatura', 706.0000, 'ºC'),
	(313811, 142, '2015-01-15 01:04:27.000000', 'temperatura', 996.0000, 'ºC'),
	(313812, 142, '2015-01-15 01:04:28.000000', 'temperatura', 463.0000, 'ºC'),
	(313813, 142, '2015-01-15 01:04:29.000000', 'temperatura', 529.0000, 'ºC'),
	(313814, 142, '2015-01-15 01:04:30.000000', 'temperatura', 54.0000, 'ºC'),
	(313815, 142, '2015-01-15 01:04:31.000000', 'temperatura', 1084.0000, 'ºC'),
	(313816, 142, '2015-01-15 01:04:32.000000', 'temperatura', 460.0000, 'ºC'),
	(313817, 142, '2015-01-15 01:04:33.000000', 'temperatura', 247.0000, 'ºC'),
	(313818, 142, '2015-01-15 01:04:34.000000', 'temperatura', 1056.0000, 'ºC'),
	(313819, 142, '2015-01-15 01:04:35.000000', 'temperatura', 938.0000, 'ºC'),
	(313820, 142, '2015-01-15 01:04:36.000000', 'temperatura', 325.0000, 'ºC'),
	(313821, 142, '2015-01-15 01:04:37.000000', 'temperatura', 11.0000, 'ºC'),
	(313822, 142, '2015-01-15 01:04:38.000000', 'temperatura', 279.0000, 'ºC'),
	(313823, 142, '2015-01-15 01:04:39.000000', 'temperatura', 165.0000, 'ºC'),
	(313824, 142, '2015-01-15 01:04:40.000000', 'temperatura', 1188.0000, 'ºC'),
	(313825, 142, '2015-01-15 01:04:41.000000', 'temperatura', 645.0000, 'ºC'),
	(313826, 142, '2015-01-15 01:04:42.000000', 'temperatura', 862.0000, 'ºC'),
	(313827, 142, '2015-01-15 01:04:43.000000', 'temperatura', 1173.0000, 'ºC'),
	(313828, 142, '2015-01-15 01:04:44.000000', 'temperatura', 882.0000, 'ºC'),
	(313829, 142, '2015-01-15 01:04:45.000000', 'temperatura', 889.0000, 'ºC'),
	(313830, 142, '2015-01-15 01:04:46.000000', 'temperatura', 601.0000, 'ºC'),
	(313831, 142, '2015-01-15 01:04:47.000000', 'temperatura', 336.0000, 'ºC'),
	(313832, 142, '2015-01-15 01:04:48.000000', 'temperatura', 1081.0000, 'ºC'),
	(313833, 142, '2015-01-15 01:04:49.000000', 'temperatura', 797.0000, 'ºC'),
	(313834, 142, '2015-01-15 01:04:50.000000', 'temperatura', 740.0000, 'ºC'),
	(313835, 142, '2015-01-15 01:04:51.000000', 'temperatura', 111.0000, 'ºC'),
	(313836, 142, '2015-01-15 01:04:52.000000', 'temperatura', 735.0000, 'ºC'),
	(313837, 142, '2015-01-15 01:04:53.000000', 'temperatura', 943.0000, 'ºC'),
	(313838, 142, '2015-01-15 01:04:54.000000', 'temperatura', 112.0000, 'ºC'),
	(313839, 142, '2015-01-15 01:04:55.000000', 'temperatura', 132.0000, 'ºC'),
	(313840, 142, '2015-01-15 01:04:56.000000', 'temperatura', 323.0000, 'ºC'),
	(313841, 142, '2015-01-15 01:04:57.000000', 'temperatura', 18.0000, 'ºC'),
	(313842, 142, '2015-01-15 01:04:58.000000', 'temperatura', 321.0000, 'ºC'),
	(313843, 142, '2015-01-15 01:04:59.000000', 'temperatura', 354.0000, 'ºC'),
	(313844, 142, '2015-01-15 01:05:00.000000', 'temperatura', 808.0000, 'ºC'),
	(313845, 142, '2015-01-15 01:05:01.000000', 'temperatura', 578.0000, 'ºC'),
	(313846, 142, '2015-01-15 01:05:02.000000', 'temperatura', 468.0000, 'ºC'),
	(313847, 142, '2015-01-15 01:05:03.000000', 'temperatura', 606.0000, 'ºC'),
	(313848, 142, '2015-01-15 01:05:04.000000', 'temperatura', 427.0000, 'ºC'),
	(313849, 142, '2015-01-15 01:05:05.000000', 'temperatura', 317.0000, 'ºC'),
	(313850, 142, '2015-01-15 01:05:06.000000', 'temperatura', 305.0000, 'ºC'),
	(313851, 142, '2015-01-15 01:05:07.000000', 'temperatura', 572.0000, 'ºC'),
	(313852, 142, '2015-01-15 01:05:08.000000', 'temperatura', 748.0000, 'ºC'),
	(313853, 142, '2015-01-15 01:05:09.000000', 'temperatura', 823.0000, 'ºC'),
	(313854, 142, '2015-01-15 01:05:10.000000', 'temperatura', 671.0000, 'ºC'),
	(313855, 142, '2015-01-15 01:05:11.000000', 'temperatura', 888.0000, 'ºC'),
	(313856, 142, '2015-01-15 01:05:12.000000', 'temperatura', 27.0000, 'ºC'),
	(313857, 142, '2015-01-15 01:05:13.000000', 'temperatura', 1070.0000, 'ºC'),
	(313858, 142, '2015-01-15 01:05:14.000000', 'temperatura', 471.0000, 'ºC'),
	(313859, 142, '2015-01-15 01:05:15.000000', 'temperatura', 346.0000, 'ºC'),
	(313860, 142, '2015-01-15 01:05:16.000000', 'temperatura', 316.0000, 'ºC'),
	(313861, 142, '2015-01-15 01:05:17.000000', 'temperatura', 541.0000, 'ºC'),
	(313862, 142, '2015-01-15 01:05:18.000000', 'temperatura', 560.0000, 'ºC'),
	(313863, 142, '2015-01-15 01:05:19.000000', 'temperatura', 1177.0000, 'ºC'),
	(313864, 142, '2015-01-15 01:05:20.000000', 'temperatura', 604.0000, 'ºC'),
	(313865, 142, '2015-01-15 01:05:21.000000', 'temperatura', 690.0000, 'ºC'),
	(313866, 142, '2015-01-15 01:05:22.000000', 'temperatura', 440.0000, 'ºC'),
	(313867, 142, '2015-01-15 01:05:23.000000', 'temperatura', 131.0000, 'ºC'),
	(313868, 142, '2015-01-15 01:05:24.000000', 'temperatura', 533.0000, 'ºC'),
	(313869, 142, '2015-01-15 01:05:25.000000', 'temperatura', 1072.0000, 'ºC'),
	(313870, 142, '2015-01-15 01:05:26.000000', 'temperatura', 161.0000, 'ºC'),
	(313871, 142, '2015-01-15 01:05:27.000000', 'temperatura', 1192.0000, 'ºC'),
	(313872, 142, '2015-01-15 01:05:28.000000', 'temperatura', 678.0000, 'ºC'),
	(313873, 142, '2015-01-15 01:05:29.000000', 'temperatura', 1014.0000, 'ºC'),
	(313874, 142, '2015-01-15 01:05:30.000000', 'temperatura', 634.0000, 'ºC'),
	(313875, 142, '2015-01-15 01:05:31.000000', 'temperatura', 131.0000, 'ºC'),
	(313876, 142, '2015-01-15 01:05:32.000000', 'temperatura', 1154.0000, 'ºC'),
	(313877, 142, '2015-01-15 01:05:33.000000', 'temperatura', 575.0000, 'ºC'),
	(313878, 142, '2015-01-15 01:05:34.000000', 'temperatura', 613.0000, 'ºC'),
	(313879, 142, '2015-01-15 01:05:35.000000', 'temperatura', 142.0000, 'ºC'),
	(313880, 142, '2015-01-15 01:05:36.000000', 'temperatura', 73.0000, 'ºC'),
	(313881, 142, '2015-01-15 01:05:37.000000', 'temperatura', 1137.0000, 'ºC'),
	(313882, 142, '2015-01-15 01:05:38.000000', 'temperatura', 666.0000, 'ºC'),
	(313883, 142, '2015-01-15 01:05:39.000000', 'temperatura', 1121.0000, 'ºC'),
	(313884, 142, '2015-01-15 01:05:40.000000', 'temperatura', 7.0000, 'ºC'),
	(313885, 142, '2015-01-15 01:05:41.000000', 'temperatura', 273.0000, 'ºC'),
	(313886, 142, '2015-01-15 01:05:42.000000', 'temperatura', 146.0000, 'ºC'),
	(313887, 142, '2015-01-15 01:05:43.000000', 'temperatura', 1111.0000, 'ºC'),
	(313888, 142, '2015-01-15 01:05:44.000000', 'temperatura', 317.0000, 'ºC'),
	(313889, 142, '2015-01-15 01:05:45.000000', 'temperatura', 654.0000, 'ºC'),
	(313890, 142, '2015-01-15 01:05:46.000000', 'temperatura', 1117.0000, 'ºC'),
	(313891, 142, '2015-01-15 01:05:47.000000', 'temperatura', 24.0000, 'ºC'),
	(313892, 142, '2015-01-15 01:05:48.000000', 'temperatura', 369.0000, 'ºC'),
	(313893, 142, '2015-01-15 01:05:49.000000', 'temperatura', 574.0000, 'ºC'),
	(313894, 142, '2015-01-15 01:05:50.000000', 'temperatura', 563.0000, 'ºC'),
	(313895, 142, '2015-01-15 01:05:51.000000', 'temperatura', 1094.0000, 'ºC'),
	(313896, 142, '2015-01-15 01:05:52.000000', 'temperatura', 183.0000, 'ºC'),
	(313897, 142, '2015-01-15 01:05:53.000000', 'temperatura', 34.0000, 'ºC'),
	(313898, 142, '2015-01-15 01:05:54.000000', 'temperatura', 819.0000, 'ºC'),
	(313899, 142, '2015-01-15 01:05:55.000000', 'temperatura', 395.0000, 'ºC'),
	(313900, 142, '2015-01-15 01:05:56.000000', 'temperatura', 720.0000, 'ºC'),
	(313901, 142, '2015-01-15 01:05:57.000000', 'temperatura', 14.0000, 'ºC'),
	(313902, 142, '2015-01-15 01:05:58.000000', 'temperatura', 312.0000, 'ºC'),
	(313903, 142, '2015-01-15 01:05:59.000000', 'temperatura', 317.0000, 'ºC'),
	(313904, 142, '2015-01-15 01:06:00.000000', 'temperatura', 651.0000, 'ºC'),
	(313905, 142, '2015-01-15 01:06:01.000000', 'temperatura', 1104.0000, 'ºC'),
	(313906, 142, '2015-01-15 01:06:02.000000', 'temperatura', 1165.0000, 'ºC'),
	(313907, 142, '2015-01-15 01:06:03.000000', 'temperatura', 117.0000, 'ºC'),
	(313908, 142, '2015-01-15 01:06:04.000000', 'temperatura', 688.0000, 'ºC'),
	(313909, 142, '2015-01-15 01:06:05.000000', 'temperatura', 689.0000, 'ºC'),
	(313910, 142, '2015-01-15 01:06:06.000000', 'temperatura', 182.0000, 'ºC'),
	(313911, 142, '2015-01-15 01:06:07.000000', 'temperatura', 46.0000, 'ºC'),
	(313912, 142, '2015-01-15 01:06:08.000000', 'temperatura', 882.0000, 'ºC'),
	(313913, 142, '2015-01-15 01:06:09.000000', 'temperatura', 675.0000, 'ºC'),
	(313914, 142, '2015-01-15 01:06:10.000000', 'temperatura', 727.0000, 'ºC'),
	(313915, 142, '2015-01-15 01:06:11.000000', 'temperatura', 410.0000, 'ºC'),
	(313916, 142, '2015-01-15 01:06:12.000000', 'temperatura', 1072.0000, 'ºC'),
	(313917, 142, '2015-01-15 01:06:13.000000', 'temperatura', 531.0000, 'ºC'),
	(313918, 142, '2015-01-15 01:06:14.000000', 'temperatura', 639.0000, 'ºC'),
	(313919, 142, '2015-01-15 01:06:15.000000', 'temperatura', 403.0000, 'ºC'),
	(313920, 142, '2015-01-15 01:06:16.000000', 'temperatura', 99.0000, 'ºC'),
	(313921, 142, '2015-01-15 01:06:17.000000', 'temperatura', 484.0000, 'ºC'),
	(313922, 142, '2015-01-15 01:06:18.000000', 'temperatura', 927.0000, 'ºC'),
	(313923, 142, '2015-01-15 01:06:19.000000', 'temperatura', 780.0000, 'ºC'),
	(313924, 142, '2015-01-15 01:06:20.000000', 'temperatura', 1122.0000, 'ºC'),
	(313925, 142, '2015-01-15 01:06:21.000000', 'temperatura', 869.0000, 'ºC'),
	(313926, 142, '2015-01-15 01:06:22.000000', 'temperatura', 979.0000, 'ºC'),
	(313927, 142, '2015-01-15 01:06:23.000000', 'temperatura', 1089.0000, 'ºC'),
	(313928, 142, '2015-01-15 01:06:24.000000', 'temperatura', 107.0000, 'ºC'),
	(313929, 142, '2015-01-15 01:06:25.000000', 'temperatura', 869.0000, 'ºC'),
	(313930, 142, '2015-01-15 01:06:26.000000', 'temperatura', 423.0000, 'ºC'),
	(313931, 142, '2015-01-15 01:06:27.000000', 'temperatura', 711.0000, 'ºC'),
	(313932, 142, '2015-01-15 01:06:28.000000', 'temperatura', 1086.0000, 'ºC'),
	(313933, 142, '2015-01-15 01:06:29.000000', 'temperatura', 897.0000, 'ºC'),
	(313934, 142, '2015-01-15 01:06:30.000000', 'temperatura', 26.0000, 'ºC'),
	(313935, 142, '2015-01-15 01:06:31.000000', 'temperatura', 1042.0000, 'ºC'),
	(313936, 142, '2015-01-15 01:06:32.000000', 'temperatura', 332.0000, 'ºC'),
	(313937, 142, '2015-01-15 01:06:33.000000', 'temperatura', 936.0000, 'ºC'),
	(313938, 142, '2015-01-15 01:06:34.000000', 'temperatura', 82.0000, 'ºC'),
	(313939, 142, '2015-01-15 01:06:35.000000', 'temperatura', 2.0000, 'ºC'),
	(313940, 142, '2015-01-15 01:06:36.000000', 'temperatura', 965.0000, 'ºC'),
	(313941, 142, '2015-01-15 01:06:37.000000', 'temperatura', 21.0000, 'ºC'),
	(313942, 142, '2015-01-15 01:06:38.000000', 'temperatura', 808.0000, 'ºC'),
	(313943, 142, '2015-01-15 01:06:39.000000', 'temperatura', 379.0000, 'ºC'),
	(313944, 142, '2015-01-15 01:06:40.000000', 'temperatura', 672.0000, 'ºC'),
	(313945, 142, '2015-01-15 01:06:41.000000', 'temperatura', 1024.0000, 'ºC'),
	(313946, 142, '2015-01-15 01:06:42.000000', 'temperatura', 703.0000, 'ºC'),
	(313947, 142, '2015-01-15 01:06:43.000000', 'temperatura', 445.0000, 'ºC'),
	(313948, 142, '2015-01-15 01:06:44.000000', 'temperatura', 118.0000, 'ºC'),
	(313949, 142, '2015-01-15 01:06:45.000000', 'temperatura', 454.0000, 'ºC'),
	(313950, 142, '2015-01-15 01:06:46.000000', 'temperatura', 715.0000, 'ºC'),
	(313951, 142, '2015-01-15 01:06:47.000000', 'temperatura', 1014.0000, 'ºC'),
	(313952, 142, '2015-01-15 01:06:48.000000', 'temperatura', 527.0000, 'ºC'),
	(313953, 142, '2015-01-15 01:06:49.000000', 'temperatura', 794.0000, 'ºC'),
	(313954, 142, '2015-01-15 01:06:50.000000', 'temperatura', 1190.0000, 'ºC'),
	(313955, 142, '2015-01-15 01:06:51.000000', 'temperatura', 1167.0000, 'ºC'),
	(313956, 142, '2015-01-15 01:06:52.000000', 'temperatura', 1067.0000, 'ºC'),
	(313957, 142, '2015-01-15 01:06:53.000000', 'temperatura', 633.0000, 'ºC'),
	(313958, 142, '2015-01-15 01:06:54.000000', 'temperatura', 1163.0000, 'ºC'),
	(313959, 142, '2015-01-15 01:06:55.000000', 'temperatura', 317.0000, 'ºC'),
	(313960, 142, '2015-01-15 01:06:56.000000', 'temperatura', 498.0000, 'ºC'),
	(313961, 142, '2015-01-15 01:06:57.000000', 'temperatura', 340.0000, 'ºC'),
	(313962, 142, '2015-01-15 01:06:58.000000', 'temperatura', 205.0000, 'ºC'),
	(313963, 142, '2015-01-15 01:06:59.000000', 'temperatura', 6.0000, 'ºC'),
	(313964, 142, '2015-01-15 01:07:00.000000', 'temperatura', 613.0000, 'ºC'),
	(313965, 142, '2015-01-15 01:07:01.000000', 'temperatura', 651.0000, 'ºC'),
	(313966, 142, '2015-01-15 01:07:02.000000', 'temperatura', 216.0000, 'ºC'),
	(313967, 142, '2015-01-15 01:07:03.000000', 'temperatura', 328.0000, 'ºC'),
	(313968, 142, '2015-01-15 01:07:04.000000', 'temperatura', 992.0000, 'ºC'),
	(313969, 142, '2015-01-15 01:07:05.000000', 'temperatura', 378.0000, 'ºC'),
	(313970, 142, '2015-01-15 01:07:06.000000', 'temperatura', 114.0000, 'ºC'),
	(313971, 142, '2015-01-15 01:07:07.000000', 'temperatura', 637.0000, 'ºC'),
	(313972, 142, '2015-01-15 01:07:08.000000', 'temperatura', 441.0000, 'ºC'),
	(313973, 142, '2015-01-15 01:07:09.000000', 'temperatura', 296.0000, 'ºC'),
	(313974, 142, '2015-01-15 01:07:10.000000', 'temperatura', 158.0000, 'ºC'),
	(313975, 142, '2015-01-15 01:07:11.000000', 'temperatura', 1102.0000, 'ºC'),
	(313976, 142, '2015-01-15 01:07:12.000000', 'temperatura', 237.0000, 'ºC'),
	(313977, 142, '2015-01-15 01:07:13.000000', 'temperatura', 280.0000, 'ºC'),
	(313978, 142, '2015-01-15 01:07:14.000000', 'temperatura', 691.0000, 'ºC'),
	(313979, 142, '2015-01-15 01:07:15.000000', 'temperatura', 214.0000, 'ºC'),
	(313980, 142, '2015-01-15 01:07:16.000000', 'temperatura', 196.0000, 'ºC'),
	(313981, 142, '2015-01-15 01:07:17.000000', 'temperatura', 341.0000, 'ºC'),
	(313982, 142, '2015-01-15 01:07:18.000000', 'temperatura', 1115.0000, 'ºC'),
	(313983, 142, '2015-01-15 01:07:19.000000', 'temperatura', 955.0000, 'ºC'),
	(313984, 142, '2015-01-15 01:07:20.000000', 'temperatura', 228.0000, 'ºC'),
	(313985, 142, '2015-01-15 01:07:21.000000', 'temperatura', 676.0000, 'ºC'),
	(313986, 142, '2015-01-15 01:07:22.000000', 'temperatura', 295.0000, 'ºC'),
	(313987, 142, '2015-01-15 01:07:23.000000', 'temperatura', 648.0000, 'ºC'),
	(313988, 142, '2015-01-15 01:07:24.000000', 'temperatura', 1155.0000, 'ºC'),
	(313989, 142, '2015-01-15 01:07:25.000000', 'temperatura', 232.0000, 'ºC'),
	(313990, 142, '2015-01-15 01:07:26.000000', 'temperatura', 95.0000, 'ºC'),
	(313991, 142, '2015-01-15 01:07:27.000000', 'temperatura', 979.0000, 'ºC'),
	(313992, 142, '2015-01-15 01:07:28.000000', 'temperatura', 1013.0000, 'ºC'),
	(313993, 142, '2015-01-15 01:07:29.000000', 'temperatura', 926.0000, 'ºC'),
	(313994, 142, '2015-01-15 01:07:30.000000', 'temperatura', 392.0000, 'ºC'),
	(313995, 142, '2015-01-15 01:07:31.000000', 'temperatura', 383.0000, 'ºC'),
	(313996, 142, '2015-01-15 01:07:32.000000', 'temperatura', 738.0000, 'ºC'),
	(313997, 142, '2015-01-15 01:07:33.000000', 'temperatura', 144.0000, 'ºC'),
	(313998, 142, '2015-01-15 01:07:34.000000', 'temperatura', 905.0000, 'ºC'),
	(313999, 142, '2015-01-15 01:07:35.000000', 'temperatura', 496.0000, 'ºC'),
	(314000, 142, '2015-01-15 01:07:36.000000', 'temperatura', 962.0000, 'ºC'),
	(314001, 142, '2015-01-15 01:07:37.000000', 'temperatura', 923.0000, 'ºC'),
	(314002, 142, '2015-01-15 01:07:38.000000', 'temperatura', 532.0000, 'ºC'),
	(314003, 142, '2015-01-15 01:07:39.000000', 'temperatura', 1088.0000, 'ºC'),
	(314004, 142, '2015-01-15 01:07:40.000000', 'temperatura', 248.0000, 'ºC'),
	(314005, 142, '2015-01-15 01:07:41.000000', 'temperatura', 374.0000, 'ºC'),
	(314006, 142, '2015-01-15 01:07:42.000000', 'temperatura', 1128.0000, 'ºC'),
	(314007, 142, '2015-01-15 01:07:43.000000', 'temperatura', 916.0000, 'ºC'),
	(314008, 142, '2015-01-15 01:07:44.000000', 'temperatura', 0.0000, 'ºC'),
	(314009, 142, '2015-01-15 01:07:45.000000', 'temperatura', 850.0000, 'ºC'),
	(314010, 142, '2015-01-15 01:07:46.000000', 'temperatura', 650.0000, 'ºC'),
	(314011, 142, '2015-01-15 01:07:47.000000', 'temperatura', 700.0000, 'ºC'),
	(314012, 142, '2015-01-15 01:07:48.000000', 'temperatura', 353.0000, 'ºC'),
	(314013, 142, '2015-01-15 01:07:49.000000', 'temperatura', 865.0000, 'ºC'),
	(314014, 142, '2015-01-15 01:07:50.000000', 'temperatura', 867.0000, 'ºC'),
	(314015, 142, '2015-01-15 01:07:51.000000', 'temperatura', 540.0000, 'ºC'),
	(314016, 142, '2015-01-15 01:07:52.000000', 'temperatura', 101.0000, 'ºC'),
	(314017, 142, '2015-01-15 01:07:53.000000', 'temperatura', 86.0000, 'ºC'),
	(314018, 142, '2015-01-15 01:07:54.000000', 'temperatura', 125.0000, 'ºC'),
	(314019, 142, '2015-01-15 01:07:55.000000', 'temperatura', 369.0000, 'ºC'),
	(314020, 142, '2015-01-15 01:07:56.000000', 'temperatura', 272.0000, 'ºC'),
	(314021, 142, '2015-01-15 01:07:57.000000', 'temperatura', 253.0000, 'ºC'),
	(314022, 142, '2015-01-15 01:07:58.000000', 'temperatura', 450.0000, 'ºC'),
	(314023, 142, '2015-01-15 01:07:59.000000', 'temperatura', 290.0000, 'ºC'),
	(314024, 142, '2015-01-15 01:08:00.000000', 'temperatura', 103.0000, 'ºC'),
	(314025, 142, '2015-01-15 01:08:01.000000', 'temperatura', 843.0000, 'ºC'),
	(314026, 142, '2015-01-15 01:08:02.000000', 'temperatura', 307.0000, 'ºC'),
	(314027, 142, '2015-01-15 01:08:03.000000', 'temperatura', 207.0000, 'ºC'),
	(314028, 142, '2015-01-15 01:08:04.000000', 'temperatura', 114.0000, 'ºC'),
	(314029, 142, '2015-01-15 01:08:05.000000', 'temperatura', 1148.0000, 'ºC'),
	(314030, 142, '2015-01-15 01:08:06.000000', 'temperatura', 600.0000, 'ºC'),
	(314031, 142, '2015-01-15 01:08:07.000000', 'temperatura', 755.0000, 'ºC'),
	(314032, 142, '2015-01-15 01:08:08.000000', 'temperatura', 775.0000, 'ºC'),
	(314033, 142, '2015-01-15 01:08:09.000000', 'temperatura', 413.0000, 'ºC'),
	(314034, 142, '2015-01-15 01:08:10.000000', 'temperatura', 941.0000, 'ºC'),
	(314035, 142, '2015-01-15 01:08:11.000000', 'temperatura', 1066.0000, 'ºC'),
	(314036, 142, '2015-01-15 01:08:12.000000', 'temperatura', 106.0000, 'ºC'),
	(314037, 142, '2015-01-15 01:08:13.000000', 'temperatura', 932.0000, 'ºC'),
	(314038, 142, '2015-01-15 01:08:14.000000', 'temperatura', 745.0000, 'ºC'),
	(314039, 142, '2015-01-15 01:08:15.000000', 'temperatura', 930.0000, 'ºC'),
	(314040, 142, '2015-01-15 01:08:16.000000', 'temperatura', 12.0000, 'ºC'),
	(314041, 142, '2015-01-15 01:08:17.000000', 'temperatura', 874.0000, 'ºC'),
	(314042, 142, '2015-01-15 01:08:18.000000', 'temperatura', 731.0000, 'ºC'),
	(314043, 142, '2015-01-15 01:08:19.000000', 'temperatura', 1036.0000, 'ºC'),
	(314044, 142, '2015-01-15 01:08:20.000000', 'temperatura', 588.0000, 'ºC'),
	(314045, 142, '2015-01-15 01:08:21.000000', 'temperatura', 1030.0000, 'ºC'),
	(314046, 142, '2015-01-15 01:08:22.000000', 'temperatura', 986.0000, 'ºC'),
	(314047, 142, '2015-01-15 01:08:23.000000', 'temperatura', 640.0000, 'ºC'),
	(314048, 142, '2015-01-15 01:08:24.000000', 'temperatura', 245.0000, 'ºC'),
	(314049, 143, '2015-01-15 00:00:00.000000', 'temperatura', 593.0000, 'ºC'),
	(314050, 143, '2015-01-15 00:00:01.000000', 'temperatura', 247.0000, 'ºC'),
	(314051, 143, '2015-01-15 00:00:02.000000', 'temperatura', 660.0000, 'ºC'),
	(314052, 143, '2015-01-15 00:00:03.000000', 'temperatura', 156.0000, 'ºC'),
	(314053, 143, '2015-01-15 00:00:04.000000', 'temperatura', 2.0000, 'ºC'),
	(314054, 143, '2015-01-15 00:00:05.000000', 'temperatura', 744.0000, 'ºC'),
	(314055, 143, '2015-01-15 00:00:06.000000', 'temperatura', 115.0000, 'ºC'),
	(314056, 143, '2015-01-15 00:00:07.000000', 'temperatura', 743.0000, 'ºC'),
	(314057, 143, '2015-01-15 00:00:08.000000', 'temperatura', 972.0000, 'ºC'),
	(314058, 143, '2015-01-15 00:00:09.000000', 'temperatura', 229.0000, 'ºC'),
	(314059, 143, '2015-01-15 00:00:10.000000', 'temperatura', 629.0000, 'ºC'),
	(314060, 143, '2015-01-15 00:00:11.000000', 'temperatura', 62.0000, 'ºC'),
	(314061, 143, '2015-01-15 00:00:12.000000', 'temperatura', 820.0000, 'ºC'),
	(314062, 143, '2015-01-15 00:00:13.000000', 'temperatura', 314.0000, 'ºC'),
	(314063, 143, '2015-01-15 00:00:14.000000', 'temperatura', 312.0000, 'ºC'),
	(314064, 143, '2015-01-15 00:00:15.000000', 'temperatura', 619.0000, 'ºC'),
	(314065, 143, '2015-01-15 00:00:16.000000', 'temperatura', 957.0000, 'ºC'),
	(314066, 143, '2015-01-15 00:00:17.000000', 'temperatura', 531.0000, 'ºC'),
	(314067, 143, '2015-01-15 00:00:18.000000', 'temperatura', 985.0000, 'ºC'),
	(314068, 143, '2015-01-15 00:00:19.000000', 'temperatura', 933.0000, 'ºC'),
	(314069, 143, '2015-01-15 00:00:20.000000', 'temperatura', 508.0000, 'ºC'),
	(314070, 143, '2015-01-15 00:00:21.000000', 'temperatura', 943.0000, 'ºC'),
	(314071, 143, '2015-01-15 00:00:22.000000', 'temperatura', 793.0000, 'ºC'),
	(314072, 143, '2015-01-15 00:00:23.000000', 'temperatura', 1134.0000, 'ºC'),
	(314073, 143, '2015-01-15 00:00:24.000000', 'temperatura', 893.0000, 'ºC'),
	(314074, 143, '2015-01-15 00:00:25.000000', 'temperatura', 1061.0000, 'ºC'),
	(314075, 143, '2015-01-15 00:00:26.000000', 'temperatura', 228.0000, 'ºC'),
	(314076, 143, '2015-01-15 00:00:27.000000', 'temperatura', 359.0000, 'ºC'),
	(314077, 143, '2015-01-15 00:00:28.000000', 'temperatura', 1110.0000, 'ºC'),
	(314078, 143, '2015-01-15 00:00:29.000000', 'temperatura', 874.0000, 'ºC'),
	(314079, 143, '2015-01-15 00:00:30.000000', 'temperatura', 1040.0000, 'ºC'),
	(314080, 143, '2015-01-15 00:00:31.000000', 'temperatura', 180.0000, 'ºC'),
	(314081, 143, '2015-01-15 00:00:32.000000', 'temperatura', 181.0000, 'ºC'),
	(314082, 143, '2015-01-15 00:00:33.000000', 'temperatura', 365.0000, 'ºC'),
	(314083, 143, '2015-01-15 00:00:34.000000', 'temperatura', 83.0000, 'ºC'),
	(314084, 143, '2015-01-15 00:00:35.000000', 'temperatura', 519.0000, 'ºC'),
	(314085, 143, '2015-01-15 00:00:36.000000', 'temperatura', 1148.0000, 'ºC'),
	(314086, 143, '2015-01-15 00:00:37.000000', 'temperatura', 585.0000, 'ºC'),
	(314087, 143, '2015-01-15 00:00:38.000000', 'temperatura', 680.0000, 'ºC'),
	(314088, 143, '2015-01-15 00:00:39.000000', 'temperatura', 445.0000, 'ºC'),
	(314089, 143, '2015-01-15 00:00:40.000000', 'temperatura', 188.0000, 'ºC'),
	(314090, 143, '2015-01-15 00:00:41.000000', 'temperatura', 804.0000, 'ºC'),
	(314091, 143, '2015-01-15 00:00:42.000000', 'temperatura', 1057.0000, 'ºC'),
	(314092, 143, '2015-01-15 00:00:43.000000', 'temperatura', 471.0000, 'ºC'),
	(314093, 143, '2015-01-15 00:00:44.000000', 'temperatura', 386.0000, 'ºC'),
	(314094, 143, '2015-01-15 00:00:45.000000', 'temperatura', 519.0000, 'ºC'),
	(314095, 143, '2015-01-15 00:00:46.000000', 'temperatura', 234.0000, 'ºC'),
	(314096, 143, '2015-01-15 00:00:47.000000', 'temperatura', 817.0000, 'ºC'),
	(314097, 143, '2015-01-15 00:00:48.000000', 'temperatura', 981.0000, 'ºC'),
	(314098, 143, '2015-01-15 00:00:49.000000', 'temperatura', 56.0000, 'ºC'),
	(314099, 143, '2015-01-15 00:00:50.000000', 'temperatura', 935.0000, 'ºC'),
	(314100, 143, '2015-01-15 00:00:51.000000', 'temperatura', 910.0000, 'ºC'),
	(314101, 143, '2015-01-15 00:00:52.000000', 'temperatura', 546.0000, 'ºC'),
	(314102, 143, '2015-01-15 00:00:53.000000', 'temperatura', 1199.0000, 'ºC'),
	(314103, 143, '2015-01-15 00:00:54.000000', 'temperatura', 758.0000, 'ºC'),
	(314104, 143, '2015-01-15 00:00:55.000000', 'temperatura', 195.0000, 'ºC'),
	(314105, 143, '2015-01-15 00:00:56.000000', 'temperatura', 1100.0000, 'ºC'),
	(314106, 143, '2015-01-15 00:00:57.000000', 'temperatura', 116.0000, 'ºC'),
	(314107, 143, '2015-01-15 00:00:58.000000', 'temperatura', 878.0000, 'ºC'),
	(314108, 143, '2015-01-15 00:00:59.000000', 'temperatura', 446.0000, 'ºC'),
	(314109, 143, '2015-01-15 00:01:00.000000', 'temperatura', 796.0000, 'ºC'),
	(314110, 143, '2015-01-15 00:01:01.000000', 'temperatura', 242.0000, 'ºC'),
	(314111, 143, '2015-01-15 00:01:02.000000', 'temperatura', 22.0000, 'ºC'),
	(314112, 143, '2015-01-15 00:01:03.000000', 'temperatura', 585.0000, 'ºC'),
	(314113, 143, '2015-01-15 00:01:04.000000', 'temperatura', 459.0000, 'ºC'),
	(314114, 143, '2015-01-15 00:01:05.000000', 'temperatura', 541.0000, 'ºC'),
	(314115, 143, '2015-01-15 00:01:06.000000', 'temperatura', 126.0000, 'ºC'),
	(314116, 143, '2015-01-15 00:01:07.000000', 'temperatura', 211.0000, 'ºC'),
	(314117, 143, '2015-01-15 00:01:08.000000', 'temperatura', 675.0000, 'ºC'),
	(314118, 143, '2015-01-15 00:01:09.000000', 'temperatura', 343.0000, 'ºC'),
	(314119, 143, '2015-01-15 00:01:10.000000', 'temperatura', 889.0000, 'ºC'),
	(314120, 143, '2015-01-15 00:01:11.000000', 'temperatura', 1016.0000, 'ºC'),
	(314121, 143, '2015-01-15 00:01:12.000000', 'temperatura', 16.0000, 'ºC'),
	(314122, 143, '2015-01-15 00:01:13.000000', 'temperatura', 630.0000, 'ºC'),
	(314123, 143, '2015-01-15 00:01:14.000000', 'temperatura', 702.0000, 'ºC'),
	(314124, 143, '2015-01-15 00:01:15.000000', 'temperatura', 423.0000, 'ºC'),
	(314125, 143, '2015-01-15 00:01:16.000000', 'temperatura', 10.0000, 'ºC'),
	(314126, 143, '2015-01-15 00:01:17.000000', 'temperatura', 1181.0000, 'ºC'),
	(314127, 143, '2015-01-15 00:01:18.000000', 'temperatura', 1074.0000, 'ºC'),
	(314128, 143, '2015-01-15 00:01:19.000000', 'temperatura', 627.0000, 'ºC'),
	(314129, 143, '2015-01-15 00:01:20.000000', 'temperatura', 1116.0000, 'ºC'),
	(314130, 143, '2015-01-15 00:01:21.000000', 'temperatura', 100.0000, 'ºC'),
	(314131, 143, '2015-01-15 00:01:22.000000', 'temperatura', 751.0000, 'ºC'),
	(314132, 143, '2015-01-15 00:01:23.000000', 'temperatura', 1054.0000, 'ºC'),
	(314133, 143, '2015-01-15 00:01:24.000000', 'temperatura', 618.0000, 'ºC'),
	(314134, 143, '2015-01-15 00:01:25.000000', 'temperatura', 1130.0000, 'ºC'),
	(314135, 143, '2015-01-15 00:01:26.000000', 'temperatura', 197.0000, 'ºC'),
	(314136, 143, '2015-01-15 00:01:27.000000', 'temperatura', 1194.0000, 'ºC'),
	(314137, 143, '2015-01-15 00:01:28.000000', 'temperatura', 579.0000, 'ºC'),
	(314138, 143, '2015-01-15 00:01:29.000000', 'temperatura', 513.0000, 'ºC'),
	(314139, 143, '2015-01-15 00:01:30.000000', 'temperatura', 827.0000, 'ºC'),
	(314140, 143, '2015-01-15 00:01:31.000000', 'temperatura', 200.0000, 'ºC'),
	(314141, 143, '2015-01-15 00:01:32.000000', 'temperatura', 918.0000, 'ºC'),
	(314142, 143, '2015-01-15 00:01:33.000000', 'temperatura', 392.0000, 'ºC'),
	(314143, 143, '2015-01-15 00:01:34.000000', 'temperatura', 407.0000, 'ºC'),
	(314144, 143, '2015-01-15 00:01:35.000000', 'temperatura', 860.0000, 'ºC'),
	(314145, 143, '2015-01-15 00:01:36.000000', 'temperatura', 677.0000, 'ºC'),
	(314146, 143, '2015-01-15 00:01:37.000000', 'temperatura', 808.0000, 'ºC'),
	(314147, 143, '2015-01-15 00:01:38.000000', 'temperatura', 808.0000, 'ºC'),
	(314148, 143, '2015-01-15 00:01:39.000000', 'temperatura', 416.0000, 'ºC'),
	(314149, 143, '2015-01-15 00:01:40.000000', 'temperatura', 859.0000, 'ºC'),
	(314150, 143, '2015-01-15 00:01:41.000000', 'temperatura', 646.0000, 'ºC'),
	(314151, 143, '2015-01-15 00:01:42.000000', 'temperatura', 655.0000, 'ºC'),
	(314152, 143, '2015-01-15 00:01:43.000000', 'temperatura', 136.0000, 'ºC'),
	(314153, 143, '2015-01-15 00:01:44.000000', 'temperatura', 1117.0000, 'ºC'),
	(314154, 143, '2015-01-15 00:01:45.000000', 'temperatura', 375.0000, 'ºC'),
	(314155, 143, '2015-01-15 00:01:46.000000', 'temperatura', 927.0000, 'ºC'),
	(314156, 143, '2015-01-15 00:01:47.000000', 'temperatura', 1112.0000, 'ºC'),
	(314157, 143, '2015-01-15 00:01:48.000000', 'temperatura', 376.0000, 'ºC'),
	(314158, 143, '2015-01-15 00:01:49.000000', 'temperatura', 947.0000, 'ºC'),
	(314159, 143, '2015-01-15 00:01:50.000000', 'temperatura', 6.0000, 'ºC'),
	(314160, 143, '2015-01-15 00:01:51.000000', 'temperatura', 789.0000, 'ºC'),
	(314161, 143, '2015-01-15 00:01:52.000000', 'temperatura', 329.0000, 'ºC'),
	(314162, 143, '2015-01-15 00:01:53.000000', 'temperatura', 476.0000, 'ºC'),
	(314163, 143, '2015-01-15 00:01:54.000000', 'temperatura', 196.0000, 'ºC'),
	(314164, 143, '2015-01-15 00:01:55.000000', 'temperatura', 750.0000, 'ºC'),
	(314165, 143, '2015-01-15 00:01:56.000000', 'temperatura', 765.0000, 'ºC'),
	(314166, 143, '2015-01-15 00:01:57.000000', 'temperatura', 375.0000, 'ºC'),
	(314167, 143, '2015-01-15 00:01:58.000000', 'temperatura', 782.0000, 'ºC'),
	(314168, 143, '2015-01-15 00:01:59.000000', 'temperatura', 385.0000, 'ºC'),
	(314169, 143, '2015-01-15 00:02:00.000000', 'temperatura', 778.0000, 'ºC'),
	(314170, 143, '2015-01-15 00:02:01.000000', 'temperatura', 334.0000, 'ºC'),
	(314171, 143, '2015-01-15 00:02:02.000000', 'temperatura', 540.0000, 'ºC'),
	(314172, 143, '2015-01-15 00:02:03.000000', 'temperatura', 496.0000, 'ºC'),
	(314173, 143, '2015-01-15 00:02:04.000000', 'temperatura', 862.0000, 'ºC'),
	(314174, 143, '2015-01-15 00:02:05.000000', 'temperatura', 422.0000, 'ºC'),
	(314175, 143, '2015-01-15 00:02:06.000000', 'temperatura', 723.0000, 'ºC'),
	(314176, 143, '2015-01-15 00:02:07.000000', 'temperatura', 1149.0000, 'ºC'),
	(314177, 143, '2015-01-15 00:02:08.000000', 'temperatura', 1177.0000, 'ºC'),
	(314178, 143, '2015-01-15 00:02:09.000000', 'temperatura', 38.0000, 'ºC'),
	(314179, 143, '2015-01-15 00:02:10.000000', 'temperatura', 260.0000, 'ºC'),
	(314180, 143, '2015-01-15 00:02:11.000000', 'temperatura', 1187.0000, 'ºC'),
	(314181, 143, '2015-01-15 00:02:12.000000', 'temperatura', 357.0000, 'ºC'),
	(314182, 143, '2015-01-15 00:02:13.000000', 'temperatura', 622.0000, 'ºC'),
	(314183, 143, '2015-01-15 00:02:14.000000', 'temperatura', 842.0000, 'ºC'),
	(314184, 143, '2015-01-15 00:02:15.000000', 'temperatura', 1145.0000, 'ºC'),
	(314185, 143, '2015-01-15 00:02:16.000000', 'temperatura', 797.0000, 'ºC'),
	(314186, 143, '2015-01-15 00:02:17.000000', 'temperatura', 549.0000, 'ºC'),
	(314187, 143, '2015-01-15 00:02:18.000000', 'temperatura', 358.0000, 'ºC'),
	(314188, 143, '2015-01-15 00:02:19.000000', 'temperatura', 141.0000, 'ºC'),
	(314189, 143, '2015-01-15 00:02:20.000000', 'temperatura', 831.0000, 'ºC'),
	(314190, 143, '2015-01-15 00:02:21.000000', 'temperatura', 131.0000, 'ºC'),
	(314191, 143, '2015-01-15 00:02:22.000000', 'temperatura', 566.0000, 'ºC'),
	(314192, 143, '2015-01-15 00:02:23.000000', 'temperatura', 37.0000, 'ºC'),
	(314193, 143, '2015-01-15 00:02:24.000000', 'temperatura', 887.0000, 'ºC'),
	(314194, 143, '2015-01-15 00:02:25.000000', 'temperatura', 727.0000, 'ºC'),
	(314195, 143, '2015-01-15 00:02:26.000000', 'temperatura', 971.0000, 'ºC'),
	(314196, 143, '2015-01-15 00:02:27.000000', 'temperatura', 275.0000, 'ºC'),
	(314197, 143, '2015-01-15 00:02:28.000000', 'temperatura', 862.0000, 'ºC'),
	(314198, 143, '2015-01-15 00:02:29.000000', 'temperatura', 1085.0000, 'ºC'),
	(314199, 143, '2015-01-15 00:02:30.000000', 'temperatura', 440.0000, 'ºC'),
	(314200, 143, '2015-01-15 00:02:31.000000', 'temperatura', 146.0000, 'ºC'),
	(314201, 143, '2015-01-15 00:02:32.000000', 'temperatura', 609.0000, 'ºC'),
	(314202, 143, '2015-01-15 00:02:33.000000', 'temperatura', 208.0000, 'ºC'),
	(314203, 143, '2015-01-15 00:02:34.000000', 'temperatura', 415.0000, 'ºC'),
	(314204, 143, '2015-01-15 00:02:35.000000', 'temperatura', 253.0000, 'ºC'),
	(314205, 143, '2015-01-15 00:02:36.000000', 'temperatura', 17.0000, 'ºC'),
	(314206, 143, '2015-01-15 00:02:37.000000', 'temperatura', 527.0000, 'ºC'),
	(314207, 143, '2015-01-15 00:02:38.000000', 'temperatura', 187.0000, 'ºC'),
	(314208, 143, '2015-01-15 00:02:39.000000', 'temperatura', 552.0000, 'ºC'),
	(314209, 143, '2015-01-15 00:02:40.000000', 'temperatura', 1000.0000, 'ºC'),
	(314210, 143, '2015-01-15 00:02:41.000000', 'temperatura', 945.0000, 'ºC'),
	(314211, 143, '2015-01-15 00:02:42.000000', 'temperatura', 526.0000, 'ºC'),
	(314212, 143, '2015-01-15 00:02:43.000000', 'temperatura', 997.0000, 'ºC'),
	(314213, 143, '2015-01-15 00:02:44.000000', 'temperatura', 1006.0000, 'ºC'),
	(314214, 143, '2015-01-15 00:02:45.000000', 'temperatura', 839.0000, 'ºC'),
	(314215, 143, '2015-01-15 00:02:46.000000', 'temperatura', 1177.0000, 'ºC'),
	(314216, 143, '2015-01-15 00:02:47.000000', 'temperatura', 971.0000, 'ºC'),
	(314217, 143, '2015-01-15 00:02:48.000000', 'temperatura', 122.0000, 'ºC'),
	(314218, 143, '2015-01-15 00:02:49.000000', 'temperatura', 100.0000, 'ºC'),
	(314219, 143, '2015-01-15 00:02:50.000000', 'temperatura', 134.0000, 'ºC'),
	(314220, 143, '2015-01-15 00:02:51.000000', 'temperatura', 370.0000, 'ºC'),
	(314221, 143, '2015-01-15 00:02:52.000000', 'temperatura', 247.0000, 'ºC'),
	(314222, 143, '2015-01-15 00:02:53.000000', 'temperatura', 125.0000, 'ºC'),
	(314223, 143, '2015-01-15 00:02:54.000000', 'temperatura', 1087.0000, 'ºC'),
	(314224, 143, '2015-01-15 00:02:55.000000', 'temperatura', 258.0000, 'ºC'),
	(314225, 143, '2015-01-15 00:02:56.000000', 'temperatura', 432.0000, 'ºC'),
	(314226, 143, '2015-01-15 00:02:57.000000', 'temperatura', 184.0000, 'ºC'),
	(314227, 143, '2015-01-15 00:02:58.000000', 'temperatura', 828.0000, 'ºC'),
	(314228, 143, '2015-01-15 00:02:59.000000', 'temperatura', 1185.0000, 'ºC'),
	(314229, 143, '2015-01-15 00:03:00.000000', 'temperatura', 1042.0000, 'ºC'),
	(314230, 143, '2015-01-15 00:03:01.000000', 'temperatura', 455.0000, 'ºC'),
	(314231, 143, '2015-01-15 00:03:02.000000', 'temperatura', 352.0000, 'ºC'),
	(314232, 143, '2015-01-15 00:03:03.000000', 'temperatura', 395.0000, 'ºC'),
	(314233, 143, '2015-01-15 00:03:04.000000', 'temperatura', 918.0000, 'ºC'),
	(314234, 143, '2015-01-15 00:03:05.000000', 'temperatura', 1007.0000, 'ºC'),
	(314235, 143, '2015-01-15 00:03:06.000000', 'temperatura', 1081.0000, 'ºC'),
	(314236, 143, '2015-01-15 00:03:07.000000', 'temperatura', 1184.0000, 'ºC'),
	(314237, 143, '2015-01-15 00:03:08.000000', 'temperatura', 277.0000, 'ºC'),
	(314238, 143, '2015-01-15 00:03:09.000000', 'temperatura', 234.0000, 'ºC'),
	(314239, 143, '2015-01-15 00:03:10.000000', 'temperatura', 338.0000, 'ºC'),
	(314240, 143, '2015-01-15 00:03:11.000000', 'temperatura', 991.0000, 'ºC'),
	(314241, 143, '2015-01-15 00:03:12.000000', 'temperatura', 341.0000, 'ºC'),
	(314242, 143, '2015-01-15 00:03:13.000000', 'temperatura', 1131.0000, 'ºC'),
	(314243, 143, '2015-01-15 00:03:14.000000', 'temperatura', 1032.0000, 'ºC'),
	(314244, 143, '2015-01-15 00:03:15.000000', 'temperatura', 570.0000, 'ºC'),
	(314245, 143, '2015-01-15 00:03:16.000000', 'temperatura', 953.0000, 'ºC'),
	(314246, 143, '2015-01-15 00:03:17.000000', 'temperatura', 654.0000, 'ºC'),
	(314247, 143, '2015-01-15 00:03:18.000000', 'temperatura', 414.0000, 'ºC'),
	(314248, 143, '2015-01-15 00:03:19.000000', 'temperatura', 107.0000, 'ºC'),
	(314249, 143, '2015-01-15 00:03:20.000000', 'temperatura', 493.0000, 'ºC'),
	(314250, 143, '2015-01-15 00:03:21.000000', 'temperatura', 944.0000, 'ºC'),
	(314251, 143, '2015-01-15 00:03:22.000000', 'temperatura', 842.0000, 'ºC'),
	(314252, 143, '2015-01-15 00:03:23.000000', 'temperatura', 179.0000, 'ºC'),
	(314253, 143, '2015-01-15 00:03:24.000000', 'temperatura', 769.0000, 'ºC'),
	(314254, 143, '2015-01-15 00:03:25.000000', 'temperatura', 909.0000, 'ºC'),
	(314255, 143, '2015-01-15 00:03:26.000000', 'temperatura', 1038.0000, 'ºC'),
	(314256, 143, '2015-01-15 00:03:27.000000', 'temperatura', 64.0000, 'ºC'),
	(314257, 143, '2015-01-15 00:03:28.000000', 'temperatura', 806.0000, 'ºC'),
	(314258, 143, '2015-01-15 00:03:29.000000', 'temperatura', 237.0000, 'ºC'),
	(314259, 143, '2015-01-15 00:03:30.000000', 'temperatura', 1170.0000, 'ºC'),
	(314260, 143, '2015-01-15 00:03:31.000000', 'temperatura', 337.0000, 'ºC'),
	(314261, 143, '2015-01-15 00:03:32.000000', 'temperatura', 577.0000, 'ºC'),
	(314262, 143, '2015-01-15 00:03:33.000000', 'temperatura', 673.0000, 'ºC'),
	(314263, 143, '2015-01-15 00:03:34.000000', 'temperatura', 434.0000, 'ºC'),
	(314264, 143, '2015-01-15 00:03:35.000000', 'temperatura', 154.0000, 'ºC'),
	(314265, 143, '2015-01-15 00:03:36.000000', 'temperatura', 668.0000, 'ºC'),
	(314266, 143, '2015-01-15 00:03:37.000000', 'temperatura', 477.0000, 'ºC'),
	(314267, 143, '2015-01-15 00:03:38.000000', 'temperatura', 382.0000, 'ºC'),
	(314268, 143, '2015-01-15 00:03:39.000000', 'temperatura', 481.0000, 'ºC'),
	(314269, 143, '2015-01-15 00:03:40.000000', 'temperatura', 60.0000, 'ºC'),
	(314270, 143, '2015-01-15 00:03:41.000000', 'temperatura', 58.0000, 'ºC'),
	(314271, 143, '2015-01-15 00:03:42.000000', 'temperatura', 110.0000, 'ºC'),
	(314272, 143, '2015-01-15 00:03:43.000000', 'temperatura', 375.0000, 'ºC'),
	(314273, 143, '2015-01-15 00:03:44.000000', 'temperatura', 347.0000, 'ºC'),
	(314274, 143, '2015-01-15 00:03:45.000000', 'temperatura', 609.0000, 'ºC'),
	(314275, 143, '2015-01-15 00:03:46.000000', 'temperatura', 806.0000, 'ºC'),
	(314276, 143, '2015-01-15 00:03:47.000000', 'temperatura', 1002.0000, 'ºC'),
	(314277, 143, '2015-01-15 00:03:48.000000', 'temperatura', 194.0000, 'ºC'),
	(314278, 143, '2015-01-15 00:03:49.000000', 'temperatura', 363.0000, 'ºC'),
	(314279, 143, '2015-01-15 00:03:50.000000', 'temperatura', 35.0000, 'ºC'),
	(314280, 143, '2015-01-15 00:03:51.000000', 'temperatura', 285.0000, 'ºC'),
	(314281, 143, '2015-01-15 00:03:52.000000', 'temperatura', 121.0000, 'ºC'),
	(314282, 143, '2015-01-15 00:03:53.000000', 'temperatura', 951.0000, 'ºC'),
	(314283, 143, '2015-01-15 00:03:54.000000', 'temperatura', 793.0000, 'ºC'),
	(314284, 143, '2015-01-15 00:03:55.000000', 'temperatura', 1114.0000, 'ºC'),
	(314285, 143, '2015-01-15 00:03:56.000000', 'temperatura', 788.0000, 'ºC'),
	(314286, 143, '2015-01-15 00:03:57.000000', 'temperatura', 600.0000, 'ºC'),
	(314287, 143, '2015-01-15 00:03:58.000000', 'temperatura', 637.0000, 'ºC'),
	(314288, 143, '2015-01-15 00:03:59.000000', 'temperatura', 185.0000, 'ºC'),
	(314289, 143, '2015-01-15 00:04:00.000000', 'temperatura', 216.0000, 'ºC'),
	(314290, 143, '2015-01-15 00:04:01.000000', 'temperatura', 525.0000, 'ºC'),
	(314291, 143, '2015-01-15 00:04:02.000000', 'temperatura', 778.0000, 'ºC'),
	(314292, 143, '2015-01-15 00:04:03.000000', 'temperatura', 1117.0000, 'ºC'),
	(314293, 143, '2015-01-15 00:04:04.000000', 'temperatura', 849.0000, 'ºC'),
	(314294, 143, '2015-01-15 00:04:05.000000', 'temperatura', 893.0000, 'ºC'),
	(314295, 143, '2015-01-15 00:04:06.000000', 'temperatura', 722.0000, 'ºC'),
	(314296, 143, '2015-01-15 00:04:07.000000', 'temperatura', 930.0000, 'ºC'),
	(314297, 143, '2015-01-15 00:04:08.000000', 'temperatura', 83.0000, 'ºC'),
	(314298, 143, '2015-01-15 00:04:09.000000', 'temperatura', 27.0000, 'ºC'),
	(314299, 143, '2015-01-15 00:04:10.000000', 'temperatura', 1086.0000, 'ºC'),
	(314300, 143, '2015-01-15 00:04:11.000000', 'temperatura', 549.0000, 'ºC'),
	(314301, 143, '2015-01-15 00:04:12.000000', 'temperatura', 687.0000, 'ºC'),
	(314302, 143, '2015-01-15 00:04:13.000000', 'temperatura', 591.0000, 'ºC'),
	(314303, 143, '2015-01-15 00:04:14.000000', 'temperatura', 893.0000, 'ºC'),
	(314304, 143, '2015-01-15 00:04:15.000000', 'temperatura', 292.0000, 'ºC'),
	(314305, 143, '2015-01-15 00:04:16.000000', 'temperatura', 1182.0000, 'ºC'),
	(314306, 143, '2015-01-15 00:04:17.000000', 'temperatura', 233.0000, 'ºC'),
	(314307, 143, '2015-01-15 00:04:18.000000', 'temperatura', 23.0000, 'ºC'),
	(314308, 143, '2015-01-15 00:04:19.000000', 'temperatura', 613.0000, 'ºC'),
	(314309, 143, '2015-01-15 00:04:20.000000', 'temperatura', 599.0000, 'ºC'),
	(314310, 143, '2015-01-15 00:04:21.000000', 'temperatura', 1155.0000, 'ºC'),
	(314311, 143, '2015-01-15 00:04:22.000000', 'temperatura', 378.0000, 'ºC'),
	(314312, 143, '2015-01-15 00:04:23.000000', 'temperatura', 826.0000, 'ºC'),
	(314313, 143, '2015-01-15 00:04:24.000000', 'temperatura', 597.0000, 'ºC'),
	(314314, 143, '2015-01-15 00:04:25.000000', 'temperatura', 508.0000, 'ºC'),
	(314315, 143, '2015-01-15 00:04:26.000000', 'temperatura', 749.0000, 'ºC'),
	(314316, 143, '2015-01-15 00:04:27.000000', 'temperatura', 1022.0000, 'ºC'),
	(314317, 143, '2015-01-15 00:04:28.000000', 'temperatura', 464.0000, 'ºC'),
	(314318, 143, '2015-01-15 00:04:29.000000', 'temperatura', 453.0000, 'ºC'),
	(314319, 143, '2015-01-15 00:04:30.000000', 'temperatura', 872.0000, 'ºC'),
	(314320, 143, '2015-01-15 00:04:31.000000', 'temperatura', 604.0000, 'ºC'),
	(314321, 143, '2015-01-15 00:04:32.000000', 'temperatura', 405.0000, 'ºC'),
	(314322, 143, '2015-01-15 00:04:33.000000', 'temperatura', 215.0000, 'ºC'),
	(314323, 143, '2015-01-15 00:04:34.000000', 'temperatura', 1057.0000, 'ºC'),
	(314324, 143, '2015-01-15 00:04:35.000000', 'temperatura', 1042.0000, 'ºC'),
	(314325, 143, '2015-01-15 00:04:36.000000', 'temperatura', 840.0000, 'ºC'),
	(314326, 143, '2015-01-15 00:04:37.000000', 'temperatura', 1075.0000, 'ºC'),
	(314327, 143, '2015-01-15 00:04:38.000000', 'temperatura', 455.0000, 'ºC'),
	(314328, 143, '2015-01-15 00:04:39.000000', 'temperatura', 249.0000, 'ºC'),
	(314329, 143, '2015-01-15 00:04:40.000000', 'temperatura', 1081.0000, 'ºC'),
	(314330, 143, '2015-01-15 00:04:41.000000', 'temperatura', 1061.0000, 'ºC'),
	(314331, 143, '2015-01-15 00:04:42.000000', 'temperatura', 860.0000, 'ºC'),
	(314332, 143, '2015-01-15 00:04:43.000000', 'temperatura', 1118.0000, 'ºC'),
	(314333, 143, '2015-01-15 00:04:44.000000', 'temperatura', 609.0000, 'ºC'),
	(314334, 143, '2015-01-15 00:04:45.000000', 'temperatura', 895.0000, 'ºC'),
	(314335, 143, '2015-01-15 00:04:46.000000', 'temperatura', 245.0000, 'ºC'),
	(314336, 143, '2015-01-15 00:04:47.000000', 'temperatura', 941.0000, 'ºC'),
	(314337, 143, '2015-01-15 00:04:48.000000', 'temperatura', 372.0000, 'ºC'),
	(314338, 143, '2015-01-15 00:04:49.000000', 'temperatura', 235.0000, 'ºC'),
	(314339, 143, '2015-01-15 00:04:50.000000', 'temperatura', 60.0000, 'ºC'),
	(314340, 143, '2015-01-15 00:04:51.000000', 'temperatura', 797.0000, 'ºC'),
	(314341, 143, '2015-01-15 00:04:52.000000', 'temperatura', 204.0000, 'ºC'),
	(314342, 143, '2015-01-15 00:04:53.000000', 'temperatura', 1028.0000, 'ºC'),
	(314343, 143, '2015-01-15 00:04:54.000000', 'temperatura', 931.0000, 'ºC'),
	(314344, 143, '2015-01-15 00:04:55.000000', 'temperatura', 370.0000, 'ºC'),
	(314345, 143, '2015-01-15 00:04:56.000000', 'temperatura', 258.0000, 'ºC'),
	(314346, 143, '2015-01-15 00:04:57.000000', 'temperatura', 182.0000, 'ºC'),
	(314347, 143, '2015-01-15 00:04:58.000000', 'temperatura', 137.0000, 'ºC'),
	(314348, 143, '2015-01-15 00:04:59.000000', 'temperatura', 140.0000, 'ºC'),
	(314349, 143, '2015-01-15 00:05:00.000000', 'temperatura', 290.0000, 'ºC'),
	(314350, 143, '2015-01-15 00:05:01.000000', 'temperatura', 1028.0000, 'ºC'),
	(314351, 143, '2015-01-15 00:05:02.000000', 'temperatura', 672.0000, 'ºC'),
	(314352, 143, '2015-01-15 00:05:03.000000', 'temperatura', 275.0000, 'ºC'),
	(314353, 143, '2015-01-15 00:05:04.000000', 'temperatura', 562.0000, 'ºC'),
	(314354, 143, '2015-01-15 00:05:05.000000', 'temperatura', 784.0000, 'ºC'),
	(314355, 143, '2015-01-15 00:05:06.000000', 'temperatura', 1036.0000, 'ºC'),
	(314356, 143, '2015-01-15 00:05:07.000000', 'temperatura', 429.0000, 'ºC'),
	(314357, 143, '2015-01-15 00:05:08.000000', 'temperatura', 235.0000, 'ºC'),
	(314358, 143, '2015-01-15 00:05:09.000000', 'temperatura', 1089.0000, 'ºC'),
	(314359, 143, '2015-01-15 00:05:10.000000', 'temperatura', 1142.0000, 'ºC'),
	(314360, 143, '2015-01-15 00:05:11.000000', 'temperatura', 44.0000, 'ºC'),
	(314361, 143, '2015-01-15 00:05:12.000000', 'temperatura', 396.0000, 'ºC'),
	(314362, 143, '2015-01-15 00:05:13.000000', 'temperatura', 645.0000, 'ºC'),
	(314363, 143, '2015-01-15 00:05:14.000000', 'temperatura', 841.0000, 'ºC'),
	(314364, 143, '2015-01-15 00:05:15.000000', 'temperatura', 1067.0000, 'ºC'),
	(314365, 143, '2015-01-15 00:05:16.000000', 'temperatura', 415.0000, 'ºC'),
	(314366, 143, '2015-01-15 00:05:17.000000', 'temperatura', 73.0000, 'ºC'),
	(314367, 143, '2015-01-15 00:05:18.000000', 'temperatura', 321.0000, 'ºC'),
	(314368, 143, '2015-01-15 00:05:19.000000', 'temperatura', 187.0000, 'ºC'),
	(314369, 143, '2015-01-15 00:05:20.000000', 'temperatura', 1174.0000, 'ºC'),
	(314370, 143, '2015-01-15 00:05:21.000000', 'temperatura', 508.0000, 'ºC'),
	(314371, 143, '2015-01-15 00:05:22.000000', 'temperatura', 218.0000, 'ºC'),
	(314372, 143, '2015-01-15 00:05:23.000000', 'temperatura', 768.0000, 'ºC'),
	(314373, 143, '2015-01-15 00:05:24.000000', 'temperatura', 785.0000, 'ºC'),
	(314374, 143, '2015-01-15 00:05:25.000000', 'temperatura', 424.0000, 'ºC'),
	(314375, 143, '2015-01-15 00:05:26.000000', 'temperatura', 962.0000, 'ºC'),
	(314376, 143, '2015-01-15 00:05:27.000000', 'temperatura', 1141.0000, 'ºC'),
	(314377, 143, '2015-01-15 00:05:28.000000', 'temperatura', 419.0000, 'ºC'),
	(314378, 143, '2015-01-15 00:05:29.000000', 'temperatura', 1071.0000, 'ºC'),
	(314379, 143, '2015-01-15 00:05:30.000000', 'temperatura', 498.0000, 'ºC'),
	(314380, 143, '2015-01-15 00:05:31.000000', 'temperatura', 478.0000, 'ºC'),
	(314381, 143, '2015-01-15 00:05:32.000000', 'temperatura', 898.0000, 'ºC'),
	(314382, 143, '2015-01-15 00:05:33.000000', 'temperatura', 655.0000, 'ºC'),
	(314383, 143, '2015-01-15 00:05:34.000000', 'temperatura', 580.0000, 'ºC'),
	(314384, 143, '2015-01-15 00:05:35.000000', 'temperatura', 937.0000, 'ºC'),
	(314385, 143, '2015-01-15 00:05:36.000000', 'temperatura', 545.0000, 'ºC'),
	(314386, 143, '2015-01-15 00:05:37.000000', 'temperatura', 1115.0000, 'ºC'),
	(314387, 143, '2015-01-15 00:05:38.000000', 'temperatura', 340.0000, 'ºC'),
	(314388, 143, '2015-01-15 00:05:39.000000', 'temperatura', 756.0000, 'ºC'),
	(314389, 143, '2015-01-15 00:05:40.000000', 'temperatura', 358.0000, 'ºC'),
	(314390, 143, '2015-01-15 00:05:41.000000', 'temperatura', 725.0000, 'ºC'),
	(314391, 143, '2015-01-15 00:05:42.000000', 'temperatura', 152.0000, 'ºC'),
	(314392, 143, '2015-01-15 00:05:43.000000', 'temperatura', 983.0000, 'ºC'),
	(314393, 143, '2015-01-15 00:05:44.000000', 'temperatura', 859.0000, 'ºC'),
	(314394, 143, '2015-01-15 00:05:45.000000', 'temperatura', 150.0000, 'ºC'),
	(314395, 143, '2015-01-15 00:05:46.000000', 'temperatura', 571.0000, 'ºC'),
	(314396, 143, '2015-01-15 00:05:47.000000', 'temperatura', 6.0000, 'ºC'),
	(314397, 143, '2015-01-15 00:05:48.000000', 'temperatura', 719.0000, 'ºC'),
	(314398, 143, '2015-01-15 00:05:49.000000', 'temperatura', 1176.0000, 'ºC'),
	(314399, 143, '2015-01-15 00:05:50.000000', 'temperatura', 122.0000, 'ºC'),
	(314400, 143, '2015-01-15 00:05:51.000000', 'temperatura', 685.0000, 'ºC'),
	(314401, 143, '2015-01-15 00:05:52.000000', 'temperatura', 659.0000, 'ºC'),
	(314402, 143, '2015-01-15 00:05:53.000000', 'temperatura', 38.0000, 'ºC'),
	(314403, 143, '2015-01-15 00:05:54.000000', 'temperatura', 616.0000, 'ºC'),
	(314404, 143, '2015-01-15 00:05:55.000000', 'temperatura', 565.0000, 'ºC'),
	(314405, 143, '2015-01-15 00:05:56.000000', 'temperatura', 976.0000, 'ºC'),
	(314406, 143, '2015-01-15 00:05:57.000000', 'temperatura', 789.0000, 'ºC'),
	(314407, 143, '2015-01-15 00:05:58.000000', 'temperatura', 1015.0000, 'ºC'),
	(314408, 143, '2015-01-15 00:05:59.000000', 'temperatura', 309.0000, 'ºC'),
	(314409, 143, '2015-01-15 00:06:00.000000', 'temperatura', 899.0000, 'ºC'),
	(314410, 143, '2015-01-15 00:06:01.000000', 'temperatura', 1170.0000, 'ºC'),
	(314411, 143, '2015-01-15 00:06:02.000000', 'temperatura', 752.0000, 'ºC'),
	(314412, 143, '2015-01-15 00:06:03.000000', 'temperatura', 252.0000, 'ºC'),
	(314413, 143, '2015-01-15 00:06:04.000000', 'temperatura', 205.0000, 'ºC'),
	(314414, 143, '2015-01-15 00:06:05.000000', 'temperatura', 269.0000, 'ºC'),
	(314415, 143, '2015-01-15 00:06:06.000000', 'temperatura', 731.0000, 'ºC'),
	(314416, 143, '2015-01-15 00:06:07.000000', 'temperatura', 447.0000, 'ºC'),
	(314417, 143, '2015-01-15 00:06:08.000000', 'temperatura', 41.0000, 'ºC'),
	(314418, 143, '2015-01-15 00:06:09.000000', 'temperatura', 67.0000, 'ºC'),
	(314419, 143, '2015-01-15 00:06:10.000000', 'temperatura', 213.0000, 'ºC'),
	(314420, 143, '2015-01-15 00:06:11.000000', 'temperatura', 864.0000, 'ºC'),
	(314421, 143, '2015-01-15 00:06:12.000000', 'temperatura', 80.0000, 'ºC'),
	(314422, 143, '2015-01-15 00:06:13.000000', 'temperatura', 208.0000, 'ºC'),
	(314423, 143, '2015-01-15 00:06:14.000000', 'temperatura', 801.0000, 'ºC'),
	(314424, 143, '2015-01-15 00:06:15.000000', 'temperatura', 981.0000, 'ºC'),
	(314425, 143, '2015-01-15 00:06:16.000000', 'temperatura', 102.0000, 'ºC'),
	(314426, 143, '2015-01-15 00:06:17.000000', 'temperatura', 1167.0000, 'ºC'),
	(314427, 143, '2015-01-15 00:06:18.000000', 'temperatura', 730.0000, 'ºC'),
	(314428, 143, '2015-01-15 00:06:19.000000', 'temperatura', 148.0000, 'ºC'),
	(314429, 143, '2015-01-15 00:06:20.000000', 'temperatura', 952.0000, 'ºC'),
	(314430, 143, '2015-01-15 00:06:21.000000', 'temperatura', 717.0000, 'ºC'),
	(314431, 143, '2015-01-15 00:06:22.000000', 'temperatura', 729.0000, 'ºC'),
	(314432, 143, '2015-01-15 00:06:23.000000', 'temperatura', 295.0000, 'ºC'),
	(314433, 143, '2015-01-15 00:06:24.000000', 'temperatura', 489.0000, 'ºC'),
	(314434, 143, '2015-01-15 00:06:25.000000', 'temperatura', 359.0000, 'ºC'),
	(314435, 143, '2015-01-15 00:06:26.000000', 'temperatura', 330.0000, 'ºC'),
	(314436, 143, '2015-01-15 00:06:27.000000', 'temperatura', 574.0000, 'ºC'),
	(314437, 143, '2015-01-15 00:06:28.000000', 'temperatura', 679.0000, 'ºC'),
	(314438, 143, '2015-01-15 00:06:29.000000', 'temperatura', 476.0000, 'ºC'),
	(314439, 143, '2015-01-15 00:06:30.000000', 'temperatura', 340.0000, 'ºC'),
	(314440, 143, '2015-01-15 00:06:31.000000', 'temperatura', 274.0000, 'ºC'),
	(314441, 143, '2015-01-15 00:06:32.000000', 'temperatura', 351.0000, 'ºC'),
	(314442, 143, '2015-01-15 00:06:33.000000', 'temperatura', 932.0000, 'ºC'),
	(314443, 143, '2015-01-15 00:06:34.000000', 'temperatura', 7.0000, 'ºC'),
	(314444, 143, '2015-01-15 00:06:35.000000', 'temperatura', 840.0000, 'ºC'),
	(314445, 143, '2015-01-15 00:06:36.000000', 'temperatura', 579.0000, 'ºC'),
	(314446, 143, '2015-01-15 00:06:37.000000', 'temperatura', 375.0000, 'ºC'),
	(314447, 143, '2015-01-15 00:06:38.000000', 'temperatura', 137.0000, 'ºC'),
	(314448, 143, '2015-01-15 00:06:39.000000', 'temperatura', 763.0000, 'ºC'),
	(314449, 143, '2015-01-15 00:06:40.000000', 'temperatura', 1002.0000, 'ºC'),
	(314450, 143, '2015-01-15 00:06:41.000000', 'temperatura', 323.0000, 'ºC'),
	(314451, 143, '2015-01-15 00:06:42.000000', 'temperatura', 1010.0000, 'ºC'),
	(314452, 143, '2015-01-15 00:06:43.000000', 'temperatura', 479.0000, 'ºC'),
	(314453, 143, '2015-01-15 00:06:44.000000', 'temperatura', 567.0000, 'ºC'),
	(314454, 143, '2015-01-15 00:06:45.000000', 'temperatura', 199.0000, 'ºC'),
	(314455, 143, '2015-01-15 00:06:46.000000', 'temperatura', 495.0000, 'ºC'),
	(314456, 143, '2015-01-15 00:06:47.000000', 'temperatura', 677.0000, 'ºC'),
	(314457, 143, '2015-01-15 00:06:48.000000', 'temperatura', 703.0000, 'ºC'),
	(314458, 143, '2015-01-15 00:06:49.000000', 'temperatura', 281.0000, 'ºC'),
	(314459, 143, '2015-01-15 00:06:50.000000', 'temperatura', 498.0000, 'ºC'),
	(314460, 143, '2015-01-15 00:06:51.000000', 'temperatura', 449.0000, 'ºC'),
	(314461, 143, '2015-01-15 00:06:52.000000', 'temperatura', 749.0000, 'ºC'),
	(314462, 143, '2015-01-15 00:06:53.000000', 'temperatura', 0.0000, 'ºC'),
	(314463, 143, '2015-01-15 00:06:54.000000', 'temperatura', 155.0000, 'ºC'),
	(314464, 143, '2015-01-15 00:06:55.000000', 'temperatura', 772.0000, 'ºC'),
	(314465, 143, '2015-01-15 00:06:56.000000', 'temperatura', 998.0000, 'ºC'),
	(314466, 143, '2015-01-15 00:06:57.000000', 'temperatura', 276.0000, 'ºC'),
	(314467, 143, '2015-01-15 00:06:58.000000', 'temperatura', 784.0000, 'ºC'),
	(314468, 143, '2015-01-15 00:06:59.000000', 'temperatura', 691.0000, 'ºC'),
	(314469, 143, '2015-01-15 00:07:00.000000', 'temperatura', 1107.0000, 'ºC'),
	(314470, 143, '2015-01-15 00:07:01.000000', 'temperatura', 1060.0000, 'ºC'),
	(314471, 143, '2015-01-15 00:07:02.000000', 'temperatura', 782.0000, 'ºC'),
	(314472, 143, '2015-01-15 00:07:03.000000', 'temperatura', 729.0000, 'ºC'),
	(314473, 143, '2015-01-15 00:07:04.000000', 'temperatura', 98.0000, 'ºC'),
	(314474, 143, '2015-01-15 00:07:05.000000', 'temperatura', 703.0000, 'ºC'),
	(314475, 143, '2015-01-15 00:07:06.000000', 'temperatura', 824.0000, 'ºC'),
	(314476, 143, '2015-01-15 00:07:07.000000', 'temperatura', 811.0000, 'ºC'),
	(314477, 143, '2015-01-15 00:07:08.000000', 'temperatura', 383.0000, 'ºC'),
	(314478, 143, '2015-01-15 00:07:09.000000', 'temperatura', 684.0000, 'ºC'),
	(314479, 143, '2015-01-15 00:07:10.000000', 'temperatura', 1069.0000, 'ºC'),
	(314480, 143, '2015-01-15 00:07:11.000000', 'temperatura', 894.0000, 'ºC'),
	(314481, 143, '2015-01-15 00:07:12.000000', 'temperatura', 65.0000, 'ºC'),
	(314482, 143, '2015-01-15 00:07:13.000000', 'temperatura', 42.0000, 'ºC'),
	(314483, 143, '2015-01-15 00:07:14.000000', 'temperatura', 18.0000, 'ºC'),
	(314484, 143, '2015-01-15 00:07:15.000000', 'temperatura', 1163.0000, 'ºC'),
	(314485, 143, '2015-01-15 00:07:16.000000', 'temperatura', 963.0000, 'ºC'),
	(314486, 143, '2015-01-15 00:07:17.000000', 'temperatura', 127.0000, 'ºC'),
	(314487, 143, '2015-01-15 00:07:18.000000', 'temperatura', 146.0000, 'ºC'),
	(314488, 143, '2015-01-15 00:07:19.000000', 'temperatura', 350.0000, 'ºC'),
	(314489, 143, '2015-01-15 00:07:20.000000', 'temperatura', 110.0000, 'ºC'),
	(314490, 143, '2015-01-15 00:07:21.000000', 'temperatura', 703.0000, 'ºC'),
	(314491, 143, '2015-01-15 00:07:22.000000', 'temperatura', 784.0000, 'ºC'),
	(314492, 143, '2015-01-15 00:07:23.000000', 'temperatura', 612.0000, 'ºC'),
	(314493, 143, '2015-01-15 00:07:24.000000', 'temperatura', 710.0000, 'ºC'),
	(314494, 143, '2015-01-15 00:07:25.000000', 'temperatura', 511.0000, 'ºC'),
	(314495, 143, '2015-01-15 00:07:26.000000', 'temperatura', 429.0000, 'ºC'),
	(314496, 143, '2015-01-15 00:07:27.000000', 'temperatura', 610.0000, 'ºC'),
	(314497, 143, '2015-01-15 00:07:28.000000', 'temperatura', 566.0000, 'ºC'),
	(314498, 143, '2015-01-15 00:07:29.000000', 'temperatura', 998.0000, 'ºC'),
	(314499, 143, '2015-01-15 00:07:30.000000', 'temperatura', 892.0000, 'ºC'),
	(314500, 143, '2015-01-15 00:07:31.000000', 'temperatura', 269.0000, 'ºC'),
	(314501, 143, '2015-01-15 00:07:32.000000', 'temperatura', 1067.0000, 'ºC'),
	(314502, 143, '2015-01-15 00:07:33.000000', 'temperatura', 931.0000, 'ºC'),
	(314503, 143, '2015-01-15 00:07:34.000000', 'temperatura', 255.0000, 'ºC'),
	(314504, 143, '2015-01-15 00:07:35.000000', 'temperatura', 881.0000, 'ºC'),
	(314505, 143, '2015-01-15 00:07:36.000000', 'temperatura', 39.0000, 'ºC'),
	(314506, 143, '2015-01-15 00:07:37.000000', 'temperatura', 1152.0000, 'ºC'),
	(314507, 143, '2015-01-15 00:07:38.000000', 'temperatura', 846.0000, 'ºC'),
	(314508, 143, '2015-01-15 00:07:39.000000', 'temperatura', 774.0000, 'ºC'),
	(314509, 143, '2015-01-15 00:07:40.000000', 'temperatura', 134.0000, 'ºC'),
	(314510, 143, '2015-01-15 00:07:41.000000', 'temperatura', 747.0000, 'ºC'),
	(314511, 143, '2015-01-15 00:07:42.000000', 'temperatura', 932.0000, 'ºC'),
	(314512, 143, '2015-01-15 00:07:43.000000', 'temperatura', 22.0000, 'ºC'),
	(314513, 143, '2015-01-15 00:07:44.000000', 'temperatura', 914.0000, 'ºC'),
	(314514, 143, '2015-01-15 00:07:45.000000', 'temperatura', 903.0000, 'ºC'),
	(314515, 143, '2015-01-15 00:07:46.000000', 'temperatura', 574.0000, 'ºC'),
	(314516, 143, '2015-01-15 00:07:47.000000', 'temperatura', 163.0000, 'ºC'),
	(314517, 143, '2015-01-15 00:07:48.000000', 'temperatura', 294.0000, 'ºC'),
	(314518, 143, '2015-01-15 00:07:49.000000', 'temperatura', 982.0000, 'ºC'),
	(314519, 143, '2015-01-15 00:07:50.000000', 'temperatura', 429.0000, 'ºC'),
	(314520, 143, '2015-01-15 00:07:51.000000', 'temperatura', 398.0000, 'ºC'),
	(314521, 143, '2015-01-15 00:07:52.000000', 'temperatura', 702.0000, 'ºC'),
	(314522, 143, '2015-01-15 00:07:53.000000', 'temperatura', 1119.0000, 'ºC'),
	(314523, 143, '2015-01-15 00:07:54.000000', 'temperatura', 1087.0000, 'ºC'),
	(314524, 143, '2015-01-15 00:07:55.000000', 'temperatura', 881.0000, 'ºC'),
	(314525, 143, '2015-01-15 00:07:56.000000', 'temperatura', 1142.0000, 'ºC'),
	(314526, 143, '2015-01-15 00:07:57.000000', 'temperatura', 671.0000, 'ºC'),
	(314527, 143, '2015-01-15 00:07:58.000000', 'temperatura', 1126.0000, 'ºC'),
	(314528, 143, '2015-01-15 00:07:59.000000', 'temperatura', 21.0000, 'ºC'),
	(314529, 143, '2015-01-15 00:08:00.000000', 'temperatura', 325.0000, 'ºC'),
	(314530, 143, '2015-01-15 00:08:01.000000', 'temperatura', 362.0000, 'ºC'),
	(314531, 143, '2015-01-15 00:08:02.000000', 'temperatura', 838.0000, 'ºC'),
	(314532, 143, '2015-01-15 00:08:03.000000', 'temperatura', 704.0000, 'ºC'),
	(314533, 143, '2015-01-15 00:08:04.000000', 'temperatura', 1004.0000, 'ºC'),
	(314534, 143, '2015-01-15 00:08:05.000000', 'temperatura', 510.0000, 'ºC'),
	(314535, 143, '2015-01-15 00:08:06.000000', 'temperatura', 737.0000, 'ºC'),
	(314536, 143, '2015-01-15 00:08:07.000000', 'temperatura', 956.0000, 'ºC'),
	(314537, 143, '2015-01-15 00:08:08.000000', 'temperatura', 170.0000, 'ºC'),
	(314538, 143, '2015-01-15 00:08:09.000000', 'temperatura', 384.0000, 'ºC'),
	(314539, 143, '2015-01-15 00:08:10.000000', 'temperatura', 211.0000, 'ºC'),
	(314540, 143, '2015-01-15 00:08:11.000000', 'temperatura', 1103.0000, 'ºC'),
	(314541, 143, '2015-01-15 00:08:12.000000', 'temperatura', 83.0000, 'ºC'),
	(314542, 143, '2015-01-15 00:08:13.000000', 'temperatura', 707.0000, 'ºC'),
	(314543, 143, '2015-01-15 00:08:14.000000', 'temperatura', 886.0000, 'ºC'),
	(314544, 143, '2015-01-15 00:08:15.000000', 'temperatura', 1110.0000, 'ºC'),
	(314545, 143, '2015-01-15 00:08:16.000000', 'temperatura', 492.0000, 'ºC'),
	(314546, 143, '2015-01-15 00:08:17.000000', 'temperatura', 330.0000, 'ºC'),
	(314547, 143, '2015-01-15 00:08:18.000000', 'temperatura', 173.0000, 'ºC'),
	(314548, 143, '2015-01-15 00:08:19.000000', 'temperatura', 1077.0000, 'ºC'),
	(314549, 143, '2015-01-15 00:08:20.000000', 'temperatura', 65.0000, 'ºC'),
	(314550, 143, '2015-01-15 00:08:21.000000', 'temperatura', 696.0000, 'ºC'),
	(314551, 143, '2015-01-15 00:08:22.000000', 'temperatura', 885.0000, 'ºC'),
	(314552, 143, '2015-01-15 00:08:23.000000', 'temperatura', 1136.0000, 'ºC'),
	(314553, 143, '2015-01-15 00:08:24.000000', 'temperatura', 626.0000, 'ºC'),
	(314554, 143, '2015-01-15 00:08:25.000000', 'temperatura', 921.0000, 'ºC'),
	(314555, 143, '2015-01-15 00:08:26.000000', 'temperatura', 330.0000, 'ºC'),
	(314556, 143, '2015-01-15 00:08:27.000000', 'temperatura', 86.0000, 'ºC'),
	(314557, 143, '2015-01-15 00:08:28.000000', 'temperatura', 639.0000, 'ºC'),
	(314558, 143, '2015-01-15 00:08:29.000000', 'temperatura', 538.0000, 'ºC'),
	(314559, 143, '2015-01-15 00:08:30.000000', 'temperatura', 776.0000, 'ºC'),
	(314560, 143, '2015-01-15 00:08:31.000000', 'temperatura', 1064.0000, 'ºC'),
	(314561, 143, '2015-01-15 00:08:32.000000', 'temperatura', 593.0000, 'ºC'),
	(314562, 143, '2015-01-15 00:08:33.000000', 'temperatura', 972.0000, 'ºC'),
	(314563, 143, '2015-01-15 00:08:34.000000', 'temperatura', 684.0000, 'ºC'),
	(314564, 143, '2015-01-15 00:08:35.000000', 'temperatura', 505.0000, 'ºC'),
	(314565, 143, '2015-01-15 00:08:36.000000', 'temperatura', 472.0000, 'ºC'),
	(314566, 143, '2015-01-15 00:08:37.000000', 'temperatura', 845.0000, 'ºC'),
	(314567, 143, '2015-01-15 00:08:38.000000', 'temperatura', 409.0000, 'ºC'),
	(314568, 143, '2015-01-15 00:08:39.000000', 'temperatura', 710.0000, 'ºC'),
	(314569, 143, '2015-01-15 00:08:40.000000', 'temperatura', 1125.0000, 'ºC'),
	(314570, 143, '2015-01-15 00:08:41.000000', 'temperatura', 1096.0000, 'ºC'),
	(314571, 143, '2015-01-15 00:08:42.000000', 'temperatura', 907.0000, 'ºC'),
	(314572, 143, '2015-01-15 00:08:43.000000', 'temperatura', 45.0000, 'ºC'),
	(314573, 143, '2015-01-15 00:08:44.000000', 'temperatura', 1106.0000, 'ºC'),
	(314574, 143, '2015-01-15 00:08:45.000000', 'temperatura', 595.0000, 'ºC'),
	(314575, 143, '2015-01-15 00:08:46.000000', 'temperatura', 857.0000, 'ºC'),
	(314576, 143, '2015-01-15 00:08:47.000000', 'temperatura', 99.0000, 'ºC'),
	(314577, 143, '2015-01-15 00:08:48.000000', 'temperatura', 326.0000, 'ºC'),
	(314578, 143, '2015-01-15 00:08:49.000000', 'temperatura', 135.0000, 'ºC'),
	(314579, 143, '2015-01-15 00:08:50.000000', 'temperatura', 898.0000, 'ºC'),
	(314580, 143, '2015-01-15 00:08:51.000000', 'temperatura', 484.0000, 'ºC'),
	(314581, 143, '2015-01-15 00:08:52.000000', 'temperatura', 927.0000, 'ºC'),
	(314582, 143, '2015-01-15 00:08:53.000000', 'temperatura', 784.0000, 'ºC'),
	(314583, 143, '2015-01-15 00:08:54.000000', 'temperatura', 1141.0000, 'ºC'),
	(314584, 143, '2015-01-15 00:08:55.000000', 'temperatura', 951.0000, 'ºC'),
	(314585, 143, '2015-01-15 00:08:56.000000', 'temperatura', 134.0000, 'ºC'),
	(314586, 143, '2015-01-15 00:08:57.000000', 'temperatura', 217.0000, 'ºC'),
	(314587, 143, '2015-01-15 00:08:58.000000', 'temperatura', 682.0000, 'ºC'),
	(314588, 143, '2015-01-15 00:08:59.000000', 'temperatura', 360.0000, 'ºC'),
	(314589, 143, '2015-01-15 00:09:00.000000', 'temperatura', 956.0000, 'ºC'),
	(314590, 143, '2015-01-15 00:09:01.000000', 'temperatura', 99.0000, 'ºC'),
	(314591, 143, '2015-01-15 00:09:02.000000', 'temperatura', 28.0000, 'ºC'),
	(314592, 143, '2015-01-15 00:09:03.000000', 'temperatura', 1045.0000, 'ºC'),
	(314593, 143, '2015-01-15 00:09:04.000000', 'temperatura', 340.0000, 'ºC'),
	(314594, 143, '2015-01-15 00:09:05.000000', 'temperatura', 965.0000, 'ºC'),
	(314595, 143, '2015-01-15 00:09:06.000000', 'temperatura', 206.0000, 'ºC'),
	(314596, 143, '2015-01-15 00:09:07.000000', 'temperatura', 536.0000, 'ºC'),
	(314597, 143, '2015-01-15 00:09:08.000000', 'temperatura', 864.0000, 'ºC'),
	(314598, 143, '2015-01-15 00:09:09.000000', 'temperatura', 312.0000, 'ºC'),
	(314599, 143, '2015-01-15 00:09:10.000000', 'temperatura', 167.0000, 'ºC'),
	(314600, 143, '2015-01-15 00:09:11.000000', 'temperatura', 1101.0000, 'ºC'),
	(314601, 143, '2015-01-15 00:09:12.000000', 'temperatura', 203.0000, 'ºC'),
	(314602, 143, '2015-01-15 00:09:13.000000', 'temperatura', 113.0000, 'ºC'),
	(314603, 143, '2015-01-15 00:09:14.000000', 'temperatura', 1155.0000, 'ºC'),
	(314604, 143, '2015-01-15 00:09:15.000000', 'temperatura', 638.0000, 'ºC'),
	(314605, 143, '2015-01-15 00:09:16.000000', 'temperatura', 926.0000, 'ºC'),
	(314606, 143, '2015-01-15 00:09:17.000000', 'temperatura', 316.0000, 'ºC'),
	(314607, 143, '2015-01-15 00:09:18.000000', 'temperatura', 1.0000, 'ºC'),
	(314608, 143, '2015-01-15 00:09:19.000000', 'temperatura', 257.0000, 'ºC'),
	(314609, 143, '2015-01-15 00:09:20.000000', 'temperatura', 85.0000, 'ºC'),
	(314610, 143, '2015-01-15 00:09:21.000000', 'temperatura', 854.0000, 'ºC'),
	(314611, 143, '2015-01-15 00:09:22.000000', 'temperatura', 415.0000, 'ºC'),
	(314612, 143, '2015-01-15 00:09:23.000000', 'temperatura', 714.0000, 'ºC'),
	(314613, 143, '2015-01-15 00:09:24.000000', 'temperatura', 1125.0000, 'ºC'),
	(314614, 143, '2015-01-15 00:09:25.000000', 'temperatura', 1084.0000, 'ºC'),
	(314615, 143, '2015-01-15 00:09:26.000000', 'temperatura', 846.0000, 'ºC'),
	(314616, 143, '2015-01-15 00:09:27.000000', 'temperatura', 976.0000, 'ºC'),
	(314617, 143, '2015-01-15 00:09:28.000000', 'temperatura', 1145.0000, 'ºC'),
	(314618, 143, '2015-01-15 00:09:29.000000', 'temperatura', 398.0000, 'ºC'),
	(314619, 143, '2015-01-15 00:09:30.000000', 'temperatura', 956.0000, 'ºC'),
	(314620, 143, '2015-01-15 00:09:31.000000', 'temperatura', 1185.0000, 'ºC'),
	(314621, 143, '2015-01-15 00:09:32.000000', 'temperatura', 657.0000, 'ºC'),
	(314622, 143, '2015-01-15 00:09:33.000000', 'temperatura', 932.0000, 'ºC'),
	(314623, 143, '2015-01-15 00:09:34.000000', 'temperatura', 291.0000, 'ºC'),
	(314624, 143, '2015-01-15 00:09:35.000000', 'temperatura', 1057.0000, 'ºC'),
	(314625, 143, '2015-01-15 00:09:36.000000', 'temperatura', 815.0000, 'ºC'),
	(314626, 143, '2015-01-15 00:09:37.000000', 'temperatura', 904.0000, 'ºC'),
	(314627, 143, '2015-01-15 00:09:38.000000', 'temperatura', 873.0000, 'ºC'),
	(314628, 143, '2015-01-15 00:09:39.000000', 'temperatura', 455.0000, 'ºC'),
	(314629, 143, '2015-01-15 00:09:40.000000', 'temperatura', 855.0000, 'ºC'),
	(314630, 143, '2015-01-15 00:09:41.000000', 'temperatura', 513.0000, 'ºC'),
	(314631, 143, '2015-01-15 00:09:42.000000', 'temperatura', 1198.0000, 'ºC'),
	(314632, 143, '2015-01-15 00:09:43.000000', 'temperatura', 853.0000, 'ºC'),
	(314633, 143, '2015-01-15 00:09:44.000000', 'temperatura', 669.0000, 'ºC'),
	(314634, 143, '2015-01-15 00:09:45.000000', 'temperatura', 789.0000, 'ºC'),
	(314635, 143, '2015-01-15 00:09:46.000000', 'temperatura', 737.0000, 'ºC'),
	(314636, 143, '2015-01-15 00:09:47.000000', 'temperatura', 118.0000, 'ºC'),
	(314637, 143, '2015-01-15 00:09:48.000000', 'temperatura', 780.0000, 'ºC'),
	(314638, 143, '2015-01-15 00:09:49.000000', 'temperatura', 1145.0000, 'ºC'),
	(314639, 143, '2015-01-15 00:09:50.000000', 'temperatura', 988.0000, 'ºC'),
	(314640, 143, '2015-01-15 00:09:51.000000', 'temperatura', 302.0000, 'ºC'),
	(314641, 143, '2015-01-15 00:09:52.000000', 'temperatura', 950.0000, 'ºC'),
	(314642, 143, '2015-01-15 00:09:53.000000', 'temperatura', 244.0000, 'ºC'),
	(314643, 143, '2015-01-15 00:09:54.000000', 'temperatura', 769.0000, 'ºC'),
	(314644, 143, '2015-01-15 00:09:55.000000', 'temperatura', 715.0000, 'ºC'),
	(314645, 143, '2015-01-15 00:09:56.000000', 'temperatura', 68.0000, 'ºC'),
	(314646, 143, '2015-01-15 00:09:57.000000', 'temperatura', 596.0000, 'ºC'),
	(314647, 143, '2015-01-15 00:09:58.000000', 'temperatura', 375.0000, 'ºC'),
	(314648, 143, '2015-01-15 00:09:59.000000', 'temperatura', 87.0000, 'ºC'),
	(314649, 143, '2015-01-15 00:10:00.000000', 'temperatura', 511.0000, 'ºC'),
	(314650, 143, '2015-01-15 00:10:01.000000', 'temperatura', 1095.0000, 'ºC'),
	(314651, 143, '2015-01-15 00:10:02.000000', 'temperatura', 344.0000, 'ºC'),
	(314652, 143, '2015-01-15 00:10:03.000000', 'temperatura', 836.0000, 'ºC'),
	(314653, 143, '2015-01-15 00:10:04.000000', 'temperatura', 749.0000, 'ºC'),
	(314654, 143, '2015-01-15 00:10:05.000000', 'temperatura', 34.0000, 'ºC'),
	(314655, 143, '2015-01-15 00:10:06.000000', 'temperatura', 326.0000, 'ºC'),
	(314656, 143, '2015-01-15 00:10:07.000000', 'temperatura', 328.0000, 'ºC'),
	(314657, 143, '2015-01-15 00:10:08.000000', 'temperatura', 664.0000, 'ºC'),
	(314658, 143, '2015-01-15 00:10:09.000000', 'temperatura', 1136.0000, 'ºC'),
	(314659, 143, '2015-01-15 00:10:10.000000', 'temperatura', 87.0000, 'ºC'),
	(314660, 143, '2015-01-15 00:10:11.000000', 'temperatura', 628.0000, 'ºC'),
	(314661, 143, '2015-01-15 00:10:12.000000', 'temperatura', 479.0000, 'ºC'),
	(314662, 143, '2015-01-15 00:10:13.000000', 'temperatura', 513.0000, 'ºC'),
	(314663, 143, '2015-01-15 00:10:14.000000', 'temperatura', 1127.0000, 'ºC'),
	(314664, 143, '2015-01-15 00:10:15.000000', 'temperatura', 496.0000, 'ºC'),
	(314665, 143, '2015-01-15 00:10:16.000000', 'temperatura', 302.0000, 'ºC'),
	(314666, 143, '2015-01-15 00:10:17.000000', 'temperatura', 20.0000, 'ºC'),
	(314667, 143, '2015-01-15 00:10:18.000000', 'temperatura', 394.0000, 'ºC'),
	(314668, 143, '2015-01-15 00:10:19.000000', 'temperatura', 713.0000, 'ºC'),
	(314669, 143, '2015-01-15 00:10:20.000000', 'temperatura', 1180.0000, 'ºC'),
	(314670, 143, '2015-01-15 00:10:21.000000', 'temperatura', 165.0000, 'ºC'),
	(314671, 143, '2015-01-15 00:10:22.000000', 'temperatura', 883.0000, 'ºC'),
	(314672, 143, '2015-01-15 00:10:23.000000', 'temperatura', 323.0000, 'ºC'),
	(314673, 143, '2015-01-15 00:10:24.000000', 'temperatura', 165.0000, 'ºC'),
	(314674, 143, '2015-01-15 00:10:25.000000', 'temperatura', 1056.0000, 'ºC'),
	(314675, 143, '2015-01-15 00:10:26.000000', 'temperatura', 1186.0000, 'ºC'),
	(314676, 143, '2015-01-15 00:10:27.000000', 'temperatura', 364.0000, 'ºC'),
	(314677, 143, '2015-01-15 00:10:28.000000', 'temperatura', 663.0000, 'ºC'),
	(314678, 143, '2015-01-15 00:10:29.000000', 'temperatura', 1022.0000, 'ºC'),
	(314679, 143, '2015-01-15 00:10:30.000000', 'temperatura', 720.0000, 'ºC'),
	(314680, 143, '2015-01-15 00:10:31.000000', 'temperatura', 534.0000, 'ºC'),
	(314681, 143, '2015-01-15 00:10:32.000000', 'temperatura', 513.0000, 'ºC'),
	(314682, 143, '2015-01-15 00:10:33.000000', 'temperatura', 964.0000, 'ºC'),
	(314683, 143, '2015-01-15 00:10:34.000000', 'temperatura', 879.0000, 'ºC'),
	(314684, 143, '2015-01-15 00:10:35.000000', 'temperatura', 303.0000, 'ºC'),
	(314685, 143, '2015-01-15 00:10:36.000000', 'temperatura', 78.0000, 'ºC'),
	(314686, 143, '2015-01-15 00:10:37.000000', 'temperatura', 684.0000, 'ºC'),
	(314687, 143, '2015-01-15 00:10:38.000000', 'temperatura', 784.0000, 'ºC'),
	(314688, 143, '2015-01-15 00:10:39.000000', 'temperatura', 671.0000, 'ºC'),
	(314689, 143, '2015-01-15 00:10:40.000000', 'temperatura', 1003.0000, 'ºC'),
	(314690, 143, '2015-01-15 00:10:41.000000', 'temperatura', 604.0000, 'ºC'),
	(314691, 143, '2015-01-15 00:10:42.000000', 'temperatura', 11.0000, 'ºC'),
	(314692, 143, '2015-01-15 00:10:43.000000', 'temperatura', 644.0000, 'ºC'),
	(314693, 143, '2015-01-15 00:10:44.000000', 'temperatura', 786.0000, 'ºC'),
	(314694, 143, '2015-01-15 00:10:45.000000', 'temperatura', 797.0000, 'ºC'),
	(314695, 143, '2015-01-15 00:10:46.000000', 'temperatura', 431.0000, 'ºC'),
	(314696, 143, '2015-01-15 00:10:47.000000', 'temperatura', 962.0000, 'ºC'),
	(314697, 143, '2015-01-15 00:10:48.000000', 'temperatura', 1120.0000, 'ºC'),
	(314698, 143, '2015-01-15 00:10:49.000000', 'temperatura', 313.0000, 'ºC'),
	(314699, 143, '2015-01-15 00:10:50.000000', 'temperatura', 605.0000, 'ºC'),
	(314700, 143, '2015-01-15 00:10:51.000000', 'temperatura', 886.0000, 'ºC'),
	(314701, 143, '2015-01-15 00:10:52.000000', 'temperatura', 218.0000, 'ºC'),
	(314702, 143, '2015-01-15 00:10:53.000000', 'temperatura', 831.0000, 'ºC'),
	(314703, 143, '2015-01-15 00:10:54.000000', 'temperatura', 1103.0000, 'ºC'),
	(314704, 143, '2015-01-15 00:10:55.000000', 'temperatura', 622.0000, 'ºC'),
	(314705, 143, '2015-01-15 00:10:56.000000', 'temperatura', 1002.0000, 'ºC'),
	(314706, 143, '2015-01-15 00:10:57.000000', 'temperatura', 743.0000, 'ºC'),
	(314707, 143, '2015-01-15 00:10:58.000000', 'temperatura', 710.0000, 'ºC'),
	(314708, 143, '2015-01-15 00:10:59.000000', 'temperatura', 124.0000, 'ºC'),
	(314709, 143, '2015-01-15 00:11:00.000000', 'temperatura', 887.0000, 'ºC'),
	(314710, 143, '2015-01-15 00:11:01.000000', 'temperatura', 465.0000, 'ºC'),
	(314711, 143, '2015-01-15 00:11:02.000000', 'temperatura', 863.0000, 'ºC'),
	(314712, 143, '2015-01-15 00:11:03.000000', 'temperatura', 519.0000, 'ºC'),
	(314713, 143, '2015-01-15 00:11:04.000000', 'temperatura', 10.0000, 'ºC'),
	(314714, 143, '2015-01-15 00:11:05.000000', 'temperatura', 891.0000, 'ºC'),
	(314715, 143, '2015-01-15 00:11:06.000000', 'temperatura', 827.0000, 'ºC'),
	(314716, 143, '2015-01-15 00:11:07.000000', 'temperatura', 262.0000, 'ºC'),
	(314717, 143, '2015-01-15 00:11:08.000000', 'temperatura', 29.0000, 'ºC'),
	(314718, 143, '2015-01-15 00:11:09.000000', 'temperatura', 561.0000, 'ºC'),
	(314719, 143, '2015-01-15 00:11:10.000000', 'temperatura', 316.0000, 'ºC'),
	(314720, 143, '2015-01-15 00:11:11.000000', 'temperatura', 1098.0000, 'ºC'),
	(314721, 143, '2015-01-15 00:11:12.000000', 'temperatura', 944.0000, 'ºC'),
	(314722, 143, '2015-01-15 00:11:13.000000', 'temperatura', 226.0000, 'ºC'),
	(314723, 143, '2015-01-15 00:11:14.000000', 'temperatura', 699.0000, 'ºC'),
	(314724, 143, '2015-01-15 00:11:15.000000', 'temperatura', 418.0000, 'ºC'),
	(314725, 143, '2015-01-15 00:11:16.000000', 'temperatura', 1193.0000, 'ºC'),
	(314726, 143, '2015-01-15 00:11:17.000000', 'temperatura', 1112.0000, 'ºC'),
	(314727, 143, '2015-01-15 00:11:18.000000', 'temperatura', 780.0000, 'ºC'),
	(314728, 143, '2015-01-15 00:11:19.000000', 'temperatura', 565.0000, 'ºC'),
	(314729, 143, '2015-01-15 00:11:20.000000', 'temperatura', 487.0000, 'ºC'),
	(314730, 143, '2015-01-15 00:11:21.000000', 'temperatura', 741.0000, 'ºC'),
	(314731, 143, '2015-01-15 00:11:22.000000', 'temperatura', 1042.0000, 'ºC'),
	(314732, 143, '2015-01-15 00:11:23.000000', 'temperatura', 591.0000, 'ºC'),
	(314733, 143, '2015-01-15 00:11:24.000000', 'temperatura', 1026.0000, 'ºC'),
	(314734, 143, '2015-01-15 00:11:25.000000', 'temperatura', 958.0000, 'ºC'),
	(314735, 143, '2015-01-15 00:11:26.000000', 'temperatura', 512.0000, 'ºC'),
	(314736, 143, '2015-01-15 00:11:27.000000', 'temperatura', 889.0000, 'ºC'),
	(314737, 143, '2015-01-15 00:11:28.000000', 'temperatura', 508.0000, 'ºC'),
	(314738, 143, '2015-01-15 00:11:29.000000', 'temperatura', 1075.0000, 'ºC'),
	(314739, 143, '2015-01-15 00:11:30.000000', 'temperatura', 252.0000, 'ºC'),
	(314740, 143, '2015-01-15 00:11:31.000000', 'temperatura', 433.0000, 'ºC'),
	(314741, 143, '2015-01-15 00:11:32.000000', 'temperatura', 210.0000, 'ºC'),
	(314742, 143, '2015-01-15 00:11:33.000000', 'temperatura', 950.0000, 'ºC'),
	(314743, 143, '2015-01-15 00:11:34.000000', 'temperatura', 524.0000, 'ºC'),
	(314744, 143, '2015-01-15 00:11:35.000000', 'temperatura', 968.0000, 'ºC'),
	(314745, 143, '2015-01-15 00:11:36.000000', 'temperatura', 867.0000, 'ºC'),
	(314746, 143, '2015-01-15 00:11:37.000000', 'temperatura', 234.0000, 'ºC'),
	(314747, 143, '2015-01-15 00:11:38.000000', 'temperatura', 970.0000, 'ºC'),
	(314748, 143, '2015-01-15 00:11:39.000000', 'temperatura', 546.0000, 'ºC'),
	(314749, 143, '2015-01-15 00:11:40.000000', 'temperatura', 1020.0000, 'ºC'),
	(314750, 143, '2015-01-15 00:11:41.000000', 'temperatura', 1064.0000, 'ºC'),
	(314751, 143, '2015-01-15 00:11:42.000000', 'temperatura', 1059.0000, 'ºC'),
	(314752, 143, '2015-01-15 00:11:43.000000', 'temperatura', 903.0000, 'ºC'),
	(314753, 143, '2015-01-15 00:11:44.000000', 'temperatura', 138.0000, 'ºC'),
	(314754, 143, '2015-01-15 00:11:45.000000', 'temperatura', 383.0000, 'ºC'),
	(314755, 143, '2015-01-15 00:11:46.000000', 'temperatura', 301.0000, 'ºC'),
	(314756, 143, '2015-01-15 00:11:47.000000', 'temperatura', 355.0000, 'ºC'),
	(314757, 143, '2015-01-15 00:11:48.000000', 'temperatura', 872.0000, 'ºC'),
	(314758, 143, '2015-01-15 00:11:49.000000', 'temperatura', 897.0000, 'ºC'),
	(314759, 143, '2015-01-15 00:11:50.000000', 'temperatura', 670.0000, 'ºC'),
	(314760, 143, '2015-01-15 00:11:51.000000', 'temperatura', 661.0000, 'ºC'),
	(314761, 143, '2015-01-15 00:11:52.000000', 'temperatura', 93.0000, 'ºC'),
	(314762, 143, '2015-01-15 00:11:53.000000', 'temperatura', 882.0000, 'ºC'),
	(314763, 143, '2015-01-15 00:11:54.000000', 'temperatura', 532.0000, 'ºC'),
	(314764, 143, '2015-01-15 00:11:55.000000', 'temperatura', 16.0000, 'ºC'),
	(314765, 143, '2015-01-15 00:11:56.000000', 'temperatura', 883.0000, 'ºC'),
	(314766, 143, '2015-01-15 00:11:57.000000', 'temperatura', 766.0000, 'ºC'),
	(314767, 143, '2015-01-15 00:11:58.000000', 'temperatura', 1183.0000, 'ºC'),
	(314768, 143, '2015-01-15 00:11:59.000000', 'temperatura', 17.0000, 'ºC'),
	(314769, 143, '2015-01-15 00:12:00.000000', 'temperatura', 137.0000, 'ºC'),
	(314770, 143, '2015-01-15 00:12:01.000000', 'temperatura', 634.0000, 'ºC'),
	(314771, 143, '2015-01-15 00:12:02.000000', 'temperatura', 360.0000, 'ºC'),
	(314772, 143, '2015-01-15 00:12:03.000000', 'temperatura', 1097.0000, 'ºC'),
	(314773, 143, '2015-01-15 00:12:04.000000', 'temperatura', 807.0000, 'ºC'),
	(314774, 143, '2015-01-15 00:12:05.000000', 'temperatura', 742.0000, 'ºC'),
	(314775, 143, '2015-01-15 00:12:06.000000', 'temperatura', 91.0000, 'ºC'),
	(314776, 143, '2015-01-15 00:12:07.000000', 'temperatura', 628.0000, 'ºC'),
	(314777, 143, '2015-01-15 00:12:08.000000', 'temperatura', 470.0000, 'ºC'),
	(314778, 143, '2015-01-15 00:12:09.000000', 'temperatura', 467.0000, 'ºC'),
	(314779, 143, '2015-01-15 00:12:10.000000', 'temperatura', 924.0000, 'ºC'),
	(314780, 143, '2015-01-15 00:12:11.000000', 'temperatura', 821.0000, 'ºC'),
	(314781, 143, '2015-01-15 00:12:12.000000', 'temperatura', 133.0000, 'ºC'),
	(314782, 143, '2015-01-15 00:12:13.000000', 'temperatura', 601.0000, 'ºC'),
	(314783, 143, '2015-01-15 00:12:14.000000', 'temperatura', 207.0000, 'ºC'),
	(314784, 143, '2015-01-15 00:12:15.000000', 'temperatura', 431.0000, 'ºC'),
	(314785, 143, '2015-01-15 00:12:16.000000', 'temperatura', 337.0000, 'ºC'),
	(314786, 143, '2015-01-15 00:12:17.000000', 'temperatura', 391.0000, 'ºC'),
	(314787, 143, '2015-01-15 00:12:18.000000', 'temperatura', 944.0000, 'ºC'),
	(314788, 143, '2015-01-15 00:12:19.000000', 'temperatura', 1148.0000, 'ºC'),
	(314789, 143, '2015-01-15 00:12:20.000000', 'temperatura', 510.0000, 'ºC'),
	(314790, 143, '2015-01-15 00:12:21.000000', 'temperatura', 306.0000, 'ºC'),
	(314791, 143, '2015-01-15 00:12:22.000000', 'temperatura', 1198.0000, 'ºC'),
	(314792, 143, '2015-01-15 00:12:23.000000', 'temperatura', 275.0000, 'ºC'),
	(314793, 143, '2015-01-15 00:12:24.000000', 'temperatura', 179.0000, 'ºC'),
	(314794, 143, '2015-01-15 00:12:25.000000', 'temperatura', 73.0000, 'ºC'),
	(314795, 143, '2015-01-15 00:12:26.000000', 'temperatura', 1029.0000, 'ºC'),
	(314796, 143, '2015-01-15 00:12:27.000000', 'temperatura', 127.0000, 'ºC'),
	(314797, 143, '2015-01-15 00:12:28.000000', 'temperatura', 1149.0000, 'ºC'),
	(314798, 143, '2015-01-15 00:12:29.000000', 'temperatura', 565.0000, 'ºC'),
	(314799, 143, '2015-01-15 00:12:30.000000', 'temperatura', 578.0000, 'ºC'),
	(314800, 143, '2015-01-15 00:12:31.000000', 'temperatura', 1195.0000, 'ºC'),
	(314801, 143, '2015-01-15 00:12:32.000000', 'temperatura', 641.0000, 'ºC'),
	(314802, 143, '2015-01-15 00:12:33.000000', 'temperatura', 822.0000, 'ºC'),
	(314803, 143, '2015-01-15 00:12:34.000000', 'temperatura', 985.0000, 'ºC'),
	(314804, 143, '2015-01-15 00:12:35.000000', 'temperatura', 61.0000, 'ºC'),
	(314805, 143, '2015-01-15 00:12:36.000000', 'temperatura', 951.0000, 'ºC'),
	(314806, 143, '2015-01-15 00:12:37.000000', 'temperatura', 971.0000, 'ºC'),
	(314807, 143, '2015-01-15 00:12:38.000000', 'temperatura', 805.0000, 'ºC'),
	(314808, 143, '2015-01-15 00:12:39.000000', 'temperatura', 1112.0000, 'ºC'),
	(314809, 143, '2015-01-15 00:12:40.000000', 'temperatura', 745.0000, 'ºC'),
	(314810, 143, '2015-01-15 00:12:41.000000', 'temperatura', 390.0000, 'ºC'),
	(314811, 143, '2015-01-15 00:12:42.000000', 'temperatura', 916.0000, 'ºC'),
	(314812, 143, '2015-01-15 00:12:43.000000', 'temperatura', 1010.0000, 'ºC'),
	(314813, 143, '2015-01-15 00:12:44.000000', 'temperatura', 1101.0000, 'ºC'),
	(314814, 143, '2015-01-15 00:12:45.000000', 'temperatura', 76.0000, 'ºC'),
	(314815, 143, '2015-01-15 00:12:46.000000', 'temperatura', 678.0000, 'ºC'),
	(314816, 143, '2015-01-15 00:12:47.000000', 'temperatura', 762.0000, 'ºC'),
	(314817, 143, '2015-01-15 00:12:48.000000', 'temperatura', 576.0000, 'ºC'),
	(314818, 143, '2015-01-15 00:12:49.000000', 'temperatura', 593.0000, 'ºC'),
	(314819, 143, '2015-01-15 00:12:50.000000', 'temperatura', 40.0000, 'ºC'),
	(314820, 143, '2015-01-15 00:12:51.000000', 'temperatura', 819.0000, 'ºC'),
	(314821, 143, '2015-01-15 00:12:52.000000', 'temperatura', 376.0000, 'ºC'),
	(314822, 143, '2015-01-15 00:12:53.000000', 'temperatura', 623.0000, 'ºC'),
	(314823, 143, '2015-01-15 00:12:54.000000', 'temperatura', 790.0000, 'ºC'),
	(314824, 143, '2015-01-15 00:12:55.000000', 'temperatura', 879.0000, 'ºC'),
	(314825, 143, '2015-01-15 00:12:56.000000', 'temperatura', 825.0000, 'ºC'),
	(314826, 143, '2015-01-15 00:12:57.000000', 'temperatura', 291.0000, 'ºC'),
	(314827, 143, '2015-01-15 00:12:58.000000', 'temperatura', 180.0000, 'ºC'),
	(314828, 143, '2015-01-15 00:12:59.000000', 'temperatura', 26.0000, 'ºC'),
	(314829, 143, '2015-01-15 00:13:00.000000', 'temperatura', 792.0000, 'ºC'),
	(314830, 143, '2015-01-15 00:13:01.000000', 'temperatura', 281.0000, 'ºC'),
	(314831, 143, '2015-01-15 00:13:02.000000', 'temperatura', 230.0000, 'ºC'),
	(314832, 143, '2015-01-15 00:13:03.000000', 'temperatura', 309.0000, 'ºC'),
	(314833, 143, '2015-01-15 00:13:04.000000', 'temperatura', 856.0000, 'ºC'),
	(314834, 143, '2015-01-15 00:13:05.000000', 'temperatura', 954.0000, 'ºC'),
	(314835, 143, '2015-01-15 00:13:06.000000', 'temperatura', 1002.0000, 'ºC'),
	(314836, 143, '2015-01-15 00:13:07.000000', 'temperatura', 948.0000, 'ºC'),
	(314837, 143, '2015-01-15 00:13:08.000000', 'temperatura', 535.0000, 'ºC'),
	(314838, 143, '2015-01-15 00:13:09.000000', 'temperatura', 1032.0000, 'ºC'),
	(314839, 143, '2015-01-15 00:13:10.000000', 'temperatura', 1157.0000, 'ºC'),
	(314840, 143, '2015-01-15 00:13:11.000000', 'temperatura', 286.0000, 'ºC'),
	(314841, 143, '2015-01-15 00:13:12.000000', 'temperatura', 361.0000, 'ºC'),
	(314842, 143, '2015-01-15 00:13:13.000000', 'temperatura', 946.0000, 'ºC'),
	(314843, 143, '2015-01-15 00:13:14.000000', 'temperatura', 47.0000, 'ºC'),
	(314844, 143, '2015-01-15 00:13:15.000000', 'temperatura', 999.0000, 'ºC'),
	(314845, 143, '2015-01-15 00:13:16.000000', 'temperatura', 55.0000, 'ºC'),
	(314846, 143, '2015-01-15 00:13:17.000000', 'temperatura', 876.0000, 'ºC'),
	(314847, 143, '2015-01-15 00:13:18.000000', 'temperatura', 619.0000, 'ºC'),
	(314848, 143, '2015-01-15 00:13:19.000000', 'temperatura', 466.0000, 'ºC'),
	(314849, 143, '2015-01-15 00:13:20.000000', 'temperatura', 473.0000, 'ºC'),
	(314850, 143, '2015-01-15 00:13:21.000000', 'temperatura', 969.0000, 'ºC'),
	(314851, 143, '2015-01-15 00:13:22.000000', 'temperatura', 1026.0000, 'ºC'),
	(314852, 143, '2015-01-15 00:13:23.000000', 'temperatura', 1022.0000, 'ºC'),
	(314853, 143, '2015-01-15 00:13:24.000000', 'temperatura', 834.0000, 'ºC'),
	(314854, 143, '2015-01-15 00:13:25.000000', 'temperatura', 1103.0000, 'ºC'),
	(314855, 143, '2015-01-15 00:13:26.000000', 'temperatura', 616.0000, 'ºC'),
	(314856, 143, '2015-01-15 00:13:27.000000', 'temperatura', 969.0000, 'ºC'),
	(314857, 143, '2015-01-15 00:13:28.000000', 'temperatura', 599.0000, 'ºC'),
	(314858, 143, '2015-01-15 00:13:29.000000', 'temperatura', 88.0000, 'ºC'),
	(314859, 143, '2015-01-15 00:13:30.000000', 'temperatura', 1045.0000, 'ºC'),
	(314860, 143, '2015-01-15 00:13:31.000000', 'temperatura', 159.0000, 'ºC'),
	(314861, 143, '2015-01-15 00:13:32.000000', 'temperatura', 61.0000, 'ºC'),
	(314862, 143, '2015-01-15 00:13:33.000000', 'temperatura', 1027.0000, 'ºC'),
	(314863, 143, '2015-01-15 00:13:34.000000', 'temperatura', 155.0000, 'ºC'),
	(314864, 143, '2015-01-15 00:13:35.000000', 'temperatura', 94.0000, 'ºC'),
	(314865, 143, '2015-01-15 00:13:36.000000', 'temperatura', 3.0000, 'ºC'),
	(314866, 143, '2015-01-15 00:13:37.000000', 'temperatura', 937.0000, 'ºC'),
	(314867, 143, '2015-01-15 00:13:38.000000', 'temperatura', 1075.0000, 'ºC'),
	(314868, 143, '2015-01-15 00:13:39.000000', 'temperatura', 167.0000, 'ºC'),
	(314869, 143, '2015-01-15 00:13:40.000000', 'temperatura', 7.0000, 'ºC'),
	(314870, 143, '2015-01-15 00:13:41.000000', 'temperatura', 737.0000, 'ºC'),
	(314871, 143, '2015-01-15 00:13:42.000000', 'temperatura', 62.0000, 'ºC'),
	(314872, 143, '2015-01-15 00:13:43.000000', 'temperatura', 502.0000, 'ºC'),
	(314873, 143, '2015-01-15 00:13:44.000000', 'temperatura', 1124.0000, 'ºC'),
	(314874, 143, '2015-01-15 00:13:45.000000', 'temperatura', 514.0000, 'ºC'),
	(314875, 143, '2015-01-15 00:13:46.000000', 'temperatura', 400.0000, 'ºC'),
	(314876, 143, '2015-01-15 00:13:47.000000', 'temperatura', 459.0000, 'ºC'),
	(314877, 143, '2015-01-15 00:13:48.000000', 'temperatura', 1094.0000, 'ºC'),
	(314878, 143, '2015-01-15 00:13:49.000000', 'temperatura', 495.0000, 'ºC'),
	(314879, 143, '2015-01-15 00:13:50.000000', 'temperatura', 393.0000, 'ºC'),
	(314880, 143, '2015-01-15 00:13:51.000000', 'temperatura', 482.0000, 'ºC'),
	(314881, 143, '2015-01-15 00:13:52.000000', 'temperatura', 29.0000, 'ºC'),
	(314882, 143, '2015-01-15 00:13:53.000000', 'temperatura', 1102.0000, 'ºC'),
	(314883, 143, '2015-01-15 00:13:54.000000', 'temperatura', 622.0000, 'ºC'),
	(314884, 143, '2015-01-15 00:13:55.000000', 'temperatura', 1006.0000, 'ºC'),
	(314885, 143, '2015-01-15 00:13:56.000000', 'temperatura', 765.0000, 'ºC'),
	(314886, 143, '2015-01-15 00:13:57.000000', 'temperatura', 807.0000, 'ºC'),
	(314887, 143, '2015-01-15 00:13:58.000000', 'temperatura', 542.0000, 'ºC'),
	(314888, 143, '2015-01-15 00:13:59.000000', 'temperatura', 288.0000, 'ºC'),
	(314889, 143, '2015-01-15 00:14:00.000000', 'temperatura', 1016.0000, 'ºC'),
	(314890, 143, '2015-01-15 00:14:01.000000', 'temperatura', 614.0000, 'ºC'),
	(314891, 143, '2015-01-15 00:14:02.000000', 'temperatura', 25.0000, 'ºC'),
	(314892, 143, '2015-01-15 00:14:03.000000', 'temperatura', 682.0000, 'ºC'),
	(314893, 143, '2015-01-15 00:14:04.000000', 'temperatura', 934.0000, 'ºC'),
	(314894, 143, '2015-01-15 00:14:05.000000', 'temperatura', 227.0000, 'ºC'),
	(314895, 143, '2015-01-15 00:14:06.000000', 'temperatura', 735.0000, 'ºC'),
	(314896, 143, '2015-01-15 00:14:07.000000', 'temperatura', 592.0000, 'ºC'),
	(314897, 143, '2015-01-15 00:14:08.000000', 'temperatura', 756.0000, 'ºC'),
	(314898, 143, '2015-01-15 00:14:09.000000', 'temperatura', 805.0000, 'ºC'),
	(314899, 143, '2015-01-15 00:14:10.000000', 'temperatura', 556.0000, 'ºC'),
	(314900, 143, '2015-01-15 00:14:11.000000', 'temperatura', 368.0000, 'ºC'),
	(314901, 143, '2015-01-15 00:14:12.000000', 'temperatura', 173.0000, 'ºC'),
	(314902, 143, '2015-01-15 00:14:13.000000', 'temperatura', 959.0000, 'ºC'),
	(314903, 143, '2015-01-15 00:14:14.000000', 'temperatura', 678.0000, 'ºC'),
	(314904, 143, '2015-01-15 00:14:15.000000', 'temperatura', 512.0000, 'ºC'),
	(314905, 143, '2015-01-15 00:14:16.000000', 'temperatura', 527.0000, 'ºC'),
	(314906, 143, '2015-01-15 00:14:17.000000', 'temperatura', 1098.0000, 'ºC'),
	(314907, 143, '2015-01-15 00:14:18.000000', 'temperatura', 311.0000, 'ºC'),
	(314908, 143, '2015-01-15 00:14:19.000000', 'temperatura', 661.0000, 'ºC'),
	(314909, 143, '2015-01-15 00:14:20.000000', 'temperatura', 1174.0000, 'ºC'),
	(314910, 143, '2015-01-15 00:14:21.000000', 'temperatura', 286.0000, 'ºC'),
	(314911, 143, '2015-01-15 00:14:22.000000', 'temperatura', 309.0000, 'ºC'),
	(314912, 143, '2015-01-15 00:14:23.000000', 'temperatura', 687.0000, 'ºC'),
	(314913, 143, '2015-01-15 00:14:24.000000', 'temperatura', 109.0000, 'ºC'),
	(314914, 143, '2015-01-15 00:14:25.000000', 'temperatura', 886.0000, 'ºC'),
	(314915, 143, '2015-01-15 00:14:26.000000', 'temperatura', 504.0000, 'ºC'),
	(314916, 143, '2015-01-15 00:14:27.000000', 'temperatura', 1061.0000, 'ºC'),
	(314917, 143, '2015-01-15 00:14:28.000000', 'temperatura', 194.0000, 'ºC'),
	(314918, 143, '2015-01-15 00:14:29.000000', 'temperatura', 187.0000, 'ºC'),
	(314919, 143, '2015-01-15 00:14:30.000000', 'temperatura', 352.0000, 'ºC'),
	(314920, 143, '2015-01-15 00:14:31.000000', 'temperatura', 0.0000, 'ºC'),
	(314921, 143, '2015-01-15 00:14:32.000000', 'temperatura', 144.0000, 'ºC'),
	(314922, 143, '2015-01-15 00:14:33.000000', 'temperatura', 721.0000, 'ºC'),
	(314923, 143, '2015-01-15 00:14:34.000000', 'temperatura', 774.0000, 'ºC'),
	(314924, 143, '2015-01-15 00:14:35.000000', 'temperatura', 507.0000, 'ºC'),
	(314925, 143, '2015-01-15 00:14:36.000000', 'temperatura', 215.0000, 'ºC'),
	(314926, 143, '2015-01-15 00:14:37.000000', 'temperatura', 755.0000, 'ºC'),
	(314927, 143, '2015-01-15 00:14:38.000000', 'temperatura', 730.0000, 'ºC'),
	(314928, 143, '2015-01-15 00:14:39.000000', 'temperatura', 185.0000, 'ºC'),
	(314929, 143, '2015-01-15 00:14:40.000000', 'temperatura', 1135.0000, 'ºC'),
	(314930, 143, '2015-01-15 00:14:41.000000', 'temperatura', 321.0000, 'ºC'),
	(314931, 143, '2015-01-15 00:14:42.000000', 'temperatura', 600.0000, 'ºC'),
	(314932, 143, '2015-01-15 00:14:43.000000', 'temperatura', 838.0000, 'ºC'),
	(314933, 143, '2015-01-15 00:14:44.000000', 'temperatura', 1190.0000, 'ºC'),
	(314934, 143, '2015-01-15 00:14:45.000000', 'temperatura', 1035.0000, 'ºC'),
	(314935, 143, '2015-01-15 00:14:46.000000', 'temperatura', 407.0000, 'ºC'),
	(314936, 143, '2015-01-15 00:14:47.000000', 'temperatura', 132.0000, 'ºC'),
	(314937, 143, '2015-01-15 00:14:48.000000', 'temperatura', 639.0000, 'ºC'),
	(314938, 143, '2015-01-15 00:14:49.000000', 'temperatura', 401.0000, 'ºC'),
	(314939, 143, '2015-01-15 00:14:50.000000', 'temperatura', 86.0000, 'ºC'),
	(314940, 143, '2015-01-15 00:14:51.000000', 'temperatura', 430.0000, 'ºC'),
	(314941, 143, '2015-01-15 00:14:52.000000', 'temperatura', 691.0000, 'ºC'),
	(314942, 143, '2015-01-15 00:14:53.000000', 'temperatura', 967.0000, 'ºC'),
	(314943, 143, '2015-01-15 00:14:54.000000', 'temperatura', 361.0000, 'ºC'),
	(314944, 143, '2015-01-15 00:14:55.000000', 'temperatura', 107.0000, 'ºC'),
	(314945, 143, '2015-01-15 00:14:56.000000', 'temperatura', 650.0000, 'ºC'),
	(314946, 143, '2015-01-15 00:14:57.000000', 'temperatura', 532.0000, 'ºC'),
	(314947, 143, '2015-01-15 00:14:58.000000', 'temperatura', 707.0000, 'ºC'),
	(314948, 143, '2015-01-15 00:14:59.000000', 'temperatura', 742.0000, 'ºC'),
	(314949, 143, '2015-01-15 00:15:00.000000', 'temperatura', 389.0000, 'ºC'),
	(314950, 143, '2015-01-15 00:15:01.000000', 'temperatura', 920.0000, 'ºC'),
	(314951, 143, '2015-01-15 00:15:02.000000', 'temperatura', 1032.0000, 'ºC'),
	(314952, 143, '2015-01-15 00:15:03.000000', 'temperatura', 2.0000, 'ºC'),
	(314953, 143, '2015-01-15 00:15:04.000000', 'temperatura', 514.0000, 'ºC'),
	(314954, 143, '2015-01-15 00:15:05.000000', 'temperatura', 164.0000, 'ºC'),
	(314955, 143, '2015-01-15 00:15:06.000000', 'temperatura', 479.0000, 'ºC'),
	(314956, 143, '2015-01-15 00:15:07.000000', 'temperatura', 702.0000, 'ºC'),
	(314957, 143, '2015-01-15 00:15:08.000000', 'temperatura', 874.0000, 'ºC'),
	(314958, 143, '2015-01-15 00:15:09.000000', 'temperatura', 1065.0000, 'ºC'),
	(314959, 143, '2015-01-15 00:15:10.000000', 'temperatura', 305.0000, 'ºC'),
	(314960, 143, '2015-01-15 00:15:11.000000', 'temperatura', 731.0000, 'ºC'),
	(314961, 143, '2015-01-15 00:15:12.000000', 'temperatura', 338.0000, 'ºC'),
	(314962, 143, '2015-01-15 00:15:13.000000', 'temperatura', 698.0000, 'ºC'),
	(314963, 143, '2015-01-15 00:15:14.000000', 'temperatura', 78.0000, 'ºC'),
	(314964, 143, '2015-01-15 00:15:15.000000', 'temperatura', 695.0000, 'ºC'),
	(314965, 143, '2015-01-15 00:15:16.000000', 'temperatura', 843.0000, 'ºC'),
	(314966, 143, '2015-01-15 00:15:17.000000', 'temperatura', 931.0000, 'ºC'),
	(314967, 143, '2015-01-15 00:15:18.000000', 'temperatura', 927.0000, 'ºC'),
	(314968, 143, '2015-01-15 00:15:19.000000', 'temperatura', 642.0000, 'ºC'),
	(314969, 143, '2015-01-15 00:15:20.000000', 'temperatura', 430.0000, 'ºC'),
	(314970, 143, '2015-01-15 00:15:21.000000', 'temperatura', 225.0000, 'ºC'),
	(314971, 143, '2015-01-15 00:15:22.000000', 'temperatura', 1033.0000, 'ºC'),
	(314972, 143, '2015-01-15 00:15:23.000000', 'temperatura', 893.0000, 'ºC'),
	(314973, 143, '2015-01-15 00:15:24.000000', 'temperatura', 166.0000, 'ºC'),
	(314974, 143, '2015-01-15 00:15:25.000000', 'temperatura', 552.0000, 'ºC'),
	(314975, 143, '2015-01-15 00:15:26.000000', 'temperatura', 1061.0000, 'ºC'),
	(314976, 143, '2015-01-15 00:15:27.000000', 'temperatura', 49.0000, 'ºC'),
	(314977, 143, '2015-01-15 00:15:28.000000', 'temperatura', 664.0000, 'ºC'),
	(314978, 143, '2015-01-15 00:15:29.000000', 'temperatura', 775.0000, 'ºC'),
	(314979, 143, '2015-01-15 00:15:30.000000', 'temperatura', 682.0000, 'ºC'),
	(314980, 143, '2015-01-15 00:15:31.000000', 'temperatura', 1086.0000, 'ºC'),
	(314981, 143, '2015-01-15 00:15:32.000000', 'temperatura', 985.0000, 'ºC'),
	(314982, 143, '2015-01-15 00:15:33.000000', 'temperatura', 468.0000, 'ºC'),
	(314983, 143, '2015-01-15 00:15:34.000000', 'temperatura', 583.0000, 'ºC'),
	(314984, 143, '2015-01-15 00:15:35.000000', 'temperatura', 315.0000, 'ºC'),
	(314985, 143, '2015-01-15 00:15:36.000000', 'temperatura', 1024.0000, 'ºC'),
	(314986, 143, '2015-01-15 00:15:37.000000', 'temperatura', 577.0000, 'ºC'),
	(314987, 143, '2015-01-15 00:15:38.000000', 'temperatura', 1011.0000, 'ºC'),
	(314988, 143, '2015-01-15 00:15:39.000000', 'temperatura', 927.0000, 'ºC'),
	(314989, 143, '2015-01-15 00:15:40.000000', 'temperatura', 402.0000, 'ºC'),
	(314990, 143, '2015-01-15 00:15:41.000000', 'temperatura', 430.0000, 'ºC'),
	(314991, 143, '2015-01-15 00:15:42.000000', 'temperatura', 945.0000, 'ºC'),
	(314992, 143, '2015-01-15 00:15:43.000000', 'temperatura', 1037.0000, 'ºC'),
	(314993, 143, '2015-01-15 00:15:44.000000', 'temperatura', 1148.0000, 'ºC'),
	(314994, 143, '2015-01-15 00:15:45.000000', 'temperatura', 232.0000, 'ºC'),
	(314995, 143, '2015-01-15 00:15:46.000000', 'temperatura', 113.0000, 'ºC'),
	(314996, 143, '2015-01-15 00:15:47.000000', 'temperatura', 1072.0000, 'ºC'),
	(314997, 143, '2015-01-15 00:15:48.000000', 'temperatura', 221.0000, 'ºC'),
	(314998, 143, '2015-01-15 00:15:49.000000', 'temperatura', 287.0000, 'ºC'),
	(314999, 143, '2015-01-15 00:15:50.000000', 'temperatura', 776.0000, 'ºC'),
	(315000, 143, '2015-01-15 00:15:51.000000', 'temperatura', 619.0000, 'ºC'),
	(315001, 143, '2015-01-15 00:15:52.000000', 'temperatura', 766.0000, 'ºC'),
	(315002, 143, '2015-01-15 00:15:53.000000', 'temperatura', 772.0000, 'ºC'),
	(315003, 143, '2015-01-15 00:15:54.000000', 'temperatura', 364.0000, 'ºC'),
	(315004, 143, '2015-01-15 00:15:55.000000', 'temperatura', 706.0000, 'ºC'),
	(315005, 143, '2015-01-15 00:15:56.000000', 'temperatura', 39.0000, 'ºC'),
	(315006, 143, '2015-01-15 00:15:57.000000', 'temperatura', 479.0000, 'ºC'),
	(315007, 143, '2015-01-15 00:15:58.000000', 'temperatura', 1075.0000, 'ºC'),
	(315008, 143, '2015-01-15 00:15:59.000000', 'temperatura', 339.0000, 'ºC'),
	(315009, 143, '2015-01-15 00:16:00.000000', 'temperatura', 871.0000, 'ºC'),
	(315010, 143, '2015-01-15 00:16:01.000000', 'temperatura', 939.0000, 'ºC'),
	(315011, 143, '2015-01-15 00:16:02.000000', 'temperatura', 883.0000, 'ºC'),
	(315012, 143, '2015-01-15 00:16:03.000000', 'temperatura', 397.0000, 'ºC'),
	(315013, 143, '2015-01-15 00:16:04.000000', 'temperatura', 539.0000, 'ºC'),
	(315014, 143, '2015-01-15 00:16:05.000000', 'temperatura', 304.0000, 'ºC'),
	(315015, 143, '2015-01-15 00:16:06.000000', 'temperatura', 1103.0000, 'ºC'),
	(315016, 143, '2015-01-15 00:16:07.000000', 'temperatura', 1005.0000, 'ºC'),
	(315017, 143, '2015-01-15 00:16:08.000000', 'temperatura', 517.0000, 'ºC'),
	(315018, 143, '2015-01-15 00:16:09.000000', 'temperatura', 769.0000, 'ºC'),
	(315019, 143, '2015-01-15 00:16:10.000000', 'temperatura', 1093.0000, 'ºC'),
	(315020, 143, '2015-01-15 00:16:11.000000', 'temperatura', 760.0000, 'ºC'),
	(315021, 143, '2015-01-15 00:16:12.000000', 'temperatura', 522.0000, 'ºC'),
	(315022, 143, '2015-01-15 00:16:13.000000', 'temperatura', 331.0000, 'ºC'),
	(315023, 143, '2015-01-15 00:16:14.000000', 'temperatura', 89.0000, 'ºC'),
	(315024, 143, '2015-01-15 00:16:15.000000', 'temperatura', 652.0000, 'ºC'),
	(315025, 143, '2015-01-15 00:16:16.000000', 'temperatura', 594.0000, 'ºC'),
	(315026, 143, '2015-01-15 00:16:17.000000', 'temperatura', 1014.0000, 'ºC'),
	(315027, 143, '2015-01-15 00:16:18.000000', 'temperatura', 887.0000, 'ºC'),
	(315028, 143, '2015-01-15 00:16:19.000000', 'temperatura', 194.0000, 'ºC'),
	(315029, 143, '2015-01-15 00:16:20.000000', 'temperatura', 710.0000, 'ºC'),
	(315030, 143, '2015-01-15 00:16:21.000000', 'temperatura', 567.0000, 'ºC'),
	(315031, 143, '2015-01-15 00:16:22.000000', 'temperatura', 705.0000, 'ºC'),
	(315032, 143, '2015-01-15 00:16:23.000000', 'temperatura', 626.0000, 'ºC'),
	(315033, 143, '2015-01-15 00:16:24.000000', 'temperatura', 1014.0000, 'ºC'),
	(315034, 143, '2015-01-15 00:16:25.000000', 'temperatura', 794.0000, 'ºC'),
	(315035, 143, '2015-01-15 00:16:26.000000', 'temperatura', 927.0000, 'ºC'),
	(315036, 143, '2015-01-15 00:16:27.000000', 'temperatura', 1055.0000, 'ºC'),
	(315037, 143, '2015-01-15 00:16:28.000000', 'temperatura', 92.0000, 'ºC'),
	(315038, 143, '2015-01-15 00:16:29.000000', 'temperatura', 897.0000, 'ºC'),
	(315039, 143, '2015-01-15 00:16:30.000000', 'temperatura', 610.0000, 'ºC'),
	(315040, 143, '2015-01-15 00:16:31.000000', 'temperatura', 357.0000, 'ºC'),
	(315041, 143, '2015-01-15 00:16:32.000000', 'temperatura', 1157.0000, 'ºC'),
	(315042, 143, '2015-01-15 00:16:33.000000', 'temperatura', 1115.0000, 'ºC'),
	(315043, 143, '2015-01-15 00:16:34.000000', 'temperatura', 906.0000, 'ºC'),
	(315044, 143, '2015-01-15 00:16:35.000000', 'temperatura', 1183.0000, 'ºC'),
	(315045, 143, '2015-01-15 00:16:36.000000', 'temperatura', 798.0000, 'ºC'),
	(315046, 143, '2015-01-15 00:16:37.000000', 'temperatura', 443.0000, 'ºC'),
	(315047, 143, '2015-01-15 00:16:38.000000', 'temperatura', 1021.0000, 'ºC'),
	(315048, 143, '2015-01-15 00:16:39.000000', 'temperatura', 176.0000, 'ºC'),
	(315049, 143, '2015-01-15 00:16:40.000000', 'temperatura', 217.0000, 'ºC'),
	(315050, 143, '2015-01-15 00:16:41.000000', 'temperatura', 559.0000, 'ºC'),
	(315051, 143, '2015-01-15 00:16:42.000000', 'temperatura', 943.0000, 'ºC'),
	(315052, 143, '2015-01-15 00:16:43.000000', 'temperatura', 640.0000, 'ºC'),
	(315053, 143, '2015-01-15 00:16:44.000000', 'temperatura', 372.0000, 'ºC'),
	(315054, 143, '2015-01-15 00:16:45.000000', 'temperatura', 1141.0000, 'ºC'),
	(315055, 143, '2015-01-15 00:16:46.000000', 'temperatura', 990.0000, 'ºC'),
	(315056, 143, '2015-01-15 00:16:47.000000', 'temperatura', 328.0000, 'ºC'),
	(315057, 143, '2015-01-15 00:16:48.000000', 'temperatura', 1071.0000, 'ºC'),
	(315058, 143, '2015-01-15 00:16:49.000000', 'temperatura', 770.0000, 'ºC'),
	(315059, 143, '2015-01-15 00:16:50.000000', 'temperatura', 637.0000, 'ºC'),
	(315060, 143, '2015-01-15 00:16:51.000000', 'temperatura', 877.0000, 'ºC'),
	(315061, 143, '2015-01-15 00:16:52.000000', 'temperatura', 74.0000, 'ºC'),
	(315062, 143, '2015-01-15 00:16:53.000000', 'temperatura', 138.0000, 'ºC'),
	(315063, 143, '2015-01-15 00:16:54.000000', 'temperatura', 469.0000, 'ºC'),
	(315064, 143, '2015-01-15 00:16:55.000000', 'temperatura', 733.0000, 'ºC'),
	(315065, 143, '2015-01-15 00:16:56.000000', 'temperatura', 1056.0000, 'ºC'),
	(315066, 143, '2015-01-15 00:16:57.000000', 'temperatura', 683.0000, 'ºC'),
	(315067, 143, '2015-01-15 00:16:58.000000', 'temperatura', 249.0000, 'ºC'),
	(315068, 143, '2015-01-15 00:16:59.000000', 'temperatura', 394.0000, 'ºC'),
	(315069, 143, '2015-01-15 00:17:00.000000', 'temperatura', 24.0000, 'ºC'),
	(315070, 143, '2015-01-15 00:17:01.000000', 'temperatura', 140.0000, 'ºC'),
	(315071, 143, '2015-01-15 00:17:02.000000', 'temperatura', 627.0000, 'ºC'),
	(315072, 143, '2015-01-15 00:17:03.000000', 'temperatura', 315.0000, 'ºC'),
	(315073, 143, '2015-01-15 00:17:04.000000', 'temperatura', 896.0000, 'ºC'),
	(315074, 143, '2015-01-15 00:17:05.000000', 'temperatura', 1136.0000, 'ºC'),
	(315075, 143, '2015-01-15 00:17:06.000000', 'temperatura', 590.0000, 'ºC'),
	(315076, 143, '2015-01-15 00:17:07.000000', 'temperatura', 744.0000, 'ºC'),
	(315077, 143, '2015-01-15 00:17:08.000000', 'temperatura', 748.0000, 'ºC'),
	(315078, 143, '2015-01-15 00:17:09.000000', 'temperatura', 311.0000, 'ºC'),
	(315079, 143, '2015-01-15 00:17:10.000000', 'temperatura', 511.0000, 'ºC'),
	(315080, 143, '2015-01-15 00:17:11.000000', 'temperatura', 422.0000, 'ºC'),
	(315081, 143, '2015-01-15 00:17:12.000000', 'temperatura', 577.0000, 'ºC'),
	(315082, 143, '2015-01-15 00:17:13.000000', 'temperatura', 419.0000, 'ºC'),
	(315083, 143, '2015-01-15 00:17:14.000000', 'temperatura', 363.0000, 'ºC'),
	(315084, 143, '2015-01-15 00:17:15.000000', 'temperatura', 562.0000, 'ºC'),
	(315085, 143, '2015-01-15 00:17:16.000000', 'temperatura', 520.0000, 'ºC'),
	(315086, 143, '2015-01-15 00:17:17.000000', 'temperatura', 914.0000, 'ºC'),
	(315087, 143, '2015-01-15 00:17:18.000000', 'temperatura', 613.0000, 'ºC'),
	(315088, 143, '2015-01-15 00:17:19.000000', 'temperatura', 321.0000, 'ºC'),
	(315089, 143, '2015-01-15 00:17:20.000000', 'temperatura', 965.0000, 'ºC'),
	(315090, 143, '2015-01-15 00:17:21.000000', 'temperatura', 266.0000, 'ºC'),
	(315091, 143, '2015-01-15 00:17:22.000000', 'temperatura', 834.0000, 'ºC'),
	(315092, 143, '2015-01-15 00:17:23.000000', 'temperatura', 974.0000, 'ºC'),
	(315093, 143, '2015-01-15 00:17:24.000000', 'temperatura', 1166.0000, 'ºC'),
	(315094, 143, '2015-01-15 00:17:25.000000', 'temperatura', 511.0000, 'ºC'),
	(315095, 143, '2015-01-15 00:17:26.000000', 'temperatura', 257.0000, 'ºC'),
	(315096, 143, '2015-01-15 00:17:27.000000', 'temperatura', 952.0000, 'ºC'),
	(315097, 143, '2015-01-15 00:17:28.000000', 'temperatura', 391.0000, 'ºC'),
	(315098, 143, '2015-01-15 00:17:29.000000', 'temperatura', 298.0000, 'ºC'),
	(315099, 143, '2015-01-15 00:17:30.000000', 'temperatura', 318.0000, 'ºC'),
	(315100, 143, '2015-01-15 00:17:31.000000', 'temperatura', 698.0000, 'ºC'),
	(315101, 143, '2015-01-15 00:17:32.000000', 'temperatura', 133.0000, 'ºC'),
	(315102, 143, '2015-01-15 00:17:33.000000', 'temperatura', 975.0000, 'ºC'),
	(315103, 143, '2015-01-15 00:17:34.000000', 'temperatura', 875.0000, 'ºC'),
	(315104, 143, '2015-01-15 00:17:35.000000', 'temperatura', 252.0000, 'ºC'),
	(315105, 143, '2015-01-15 00:17:36.000000', 'temperatura', 1036.0000, 'ºC'),
	(315106, 143, '2015-01-15 00:17:37.000000', 'temperatura', 822.0000, 'ºC'),
	(315107, 143, '2015-01-15 00:17:38.000000', 'temperatura', 1004.0000, 'ºC'),
	(315108, 143, '2015-01-15 00:17:39.000000', 'temperatura', 154.0000, 'ºC'),
	(315109, 143, '2015-01-15 00:17:40.000000', 'temperatura', 160.0000, 'ºC'),
	(315110, 143, '2015-01-15 00:17:41.000000', 'temperatura', 337.0000, 'ºC'),
	(315111, 143, '2015-01-15 00:17:42.000000', 'temperatura', 5.0000, 'ºC'),
	(315112, 143, '2015-01-15 00:17:43.000000', 'temperatura', 214.0000, 'ºC'),
	(315113, 143, '2015-01-15 00:17:44.000000', 'temperatura', 1058.0000, 'ºC'),
	(315114, 143, '2015-01-15 00:17:45.000000', 'temperatura', 1047.0000, 'ºC'),
	(315115, 143, '2015-01-15 00:17:46.000000', 'temperatura', 860.0000, 'ºC'),
	(315116, 143, '2015-01-15 00:17:47.000000', 'temperatura', 1162.0000, 'ºC'),
	(315117, 143, '2015-01-15 00:17:48.000000', 'temperatura', 829.0000, 'ºC'),
	(315118, 143, '2015-01-15 00:17:49.000000', 'temperatura', 658.0000, 'ºC'),
	(315119, 143, '2015-01-15 00:17:50.000000', 'temperatura', 805.0000, 'ºC'),
	(315120, 143, '2015-01-15 00:17:51.000000', 'temperatura', 852.0000, 'ºC'),
	(315121, 143, '2015-01-15 00:17:52.000000', 'temperatura', 645.0000, 'ºC'),
	(315122, 143, '2015-01-15 00:17:53.000000', 'temperatura', 670.0000, 'ºC'),
	(315123, 143, '2015-01-15 00:17:54.000000', 'temperatura', 213.0000, 'ºC'),
	(315124, 143, '2015-01-15 00:17:55.000000', 'temperatura', 258.0000, 'ºC'),
	(315125, 143, '2015-01-15 00:17:56.000000', 'temperatura', 649.0000, 'ºC'),
	(315126, 143, '2015-01-15 00:17:57.000000', 'temperatura', 72.0000, 'ºC'),
	(315127, 143, '2015-01-15 00:17:58.000000', 'temperatura', 815.0000, 'ºC'),
	(315128, 143, '2015-01-15 00:17:59.000000', 'temperatura', 257.0000, 'ºC'),
	(315129, 143, '2015-01-15 00:18:00.000000', 'temperatura', 42.0000, 'ºC'),
	(315130, 143, '2015-01-15 00:18:01.000000', 'temperatura', 641.0000, 'ºC'),
	(315131, 143, '2015-01-15 00:18:02.000000', 'temperatura', 678.0000, 'ºC'),
	(315132, 143, '2015-01-15 00:18:03.000000', 'temperatura', 269.0000, 'ºC'),
	(315133, 143, '2015-01-15 00:18:04.000000', 'temperatura', 510.0000, 'ºC'),
	(315134, 143, '2015-01-15 00:18:05.000000', 'temperatura', 544.0000, 'ºC'),
	(315135, 143, '2015-01-15 00:18:06.000000', 'temperatura', 1190.0000, 'ºC'),
	(315136, 143, '2015-01-15 00:18:07.000000', 'temperatura', 717.0000, 'ºC'),
	(315137, 143, '2015-01-15 00:18:08.000000', 'temperatura', 18.0000, 'ºC'),
	(315138, 143, '2015-01-15 00:18:09.000000', 'temperatura', 339.0000, 'ºC'),
	(315139, 143, '2015-01-15 00:18:10.000000', 'temperatura', 441.0000, 'ºC'),
	(315140, 143, '2015-01-15 00:18:11.000000', 'temperatura', 1188.0000, 'ºC'),
	(315141, 143, '2015-01-15 00:18:12.000000', 'temperatura', 1019.0000, 'ºC'),
	(315142, 143, '2015-01-15 00:18:13.000000', 'temperatura', 331.0000, 'ºC'),
	(315143, 143, '2015-01-15 00:18:14.000000', 'temperatura', 997.0000, 'ºC'),
	(315144, 143, '2015-01-15 00:18:15.000000', 'temperatura', 394.0000, 'ºC'),
	(315145, 143, '2015-01-15 00:18:16.000000', 'temperatura', 178.0000, 'ºC'),
	(315146, 143, '2015-01-15 00:18:17.000000', 'temperatura', 911.0000, 'ºC'),
	(315147, 143, '2015-01-15 00:18:18.000000', 'temperatura', 420.0000, 'ºC'),
	(315148, 143, '2015-01-15 00:18:19.000000', 'temperatura', 566.0000, 'ºC'),
	(315149, 143, '2015-01-15 00:18:20.000000', 'temperatura', 373.0000, 'ºC'),
	(315150, 143, '2015-01-15 00:18:21.000000', 'temperatura', 167.0000, 'ºC'),
	(315151, 143, '2015-01-15 00:18:22.000000', 'temperatura', 914.0000, 'ºC'),
	(315152, 143, '2015-01-15 00:18:23.000000', 'temperatura', 472.0000, 'ºC'),
	(315153, 143, '2015-01-15 00:18:24.000000', 'temperatura', 820.0000, 'ºC'),
	(315154, 143, '2015-01-15 00:18:25.000000', 'temperatura', 282.0000, 'ºC'),
	(315155, 143, '2015-01-15 00:18:26.000000', 'temperatura', 153.0000, 'ºC'),
	(315156, 143, '2015-01-15 00:18:27.000000', 'temperatura', 1118.0000, 'ºC'),
	(315157, 143, '2015-01-15 00:18:28.000000', 'temperatura', 332.0000, 'ºC'),
	(315158, 143, '2015-01-15 00:18:29.000000', 'temperatura', 708.0000, 'ºC'),
	(315159, 143, '2015-01-15 00:18:30.000000', 'temperatura', 145.0000, 'ºC'),
	(315160, 143, '2015-01-15 00:18:31.000000', 'temperatura', 998.0000, 'ºC'),
	(315161, 143, '2015-01-15 00:18:32.000000', 'temperatura', 958.0000, 'ºC'),
	(315162, 143, '2015-01-15 00:18:33.000000', 'temperatura', 598.0000, 'ºC'),
	(315163, 143, '2015-01-15 00:18:34.000000', 'temperatura', 114.0000, 'ºC'),
	(315164, 143, '2015-01-15 00:18:35.000000', 'temperatura', 1176.0000, 'ºC'),
	(315165, 143, '2015-01-15 00:18:36.000000', 'temperatura', 739.0000, 'ºC'),
	(315166, 143, '2015-01-15 00:18:37.000000', 'temperatura', 167.0000, 'ºC'),
	(315167, 143, '2015-01-15 00:18:38.000000', 'temperatura', 1020.0000, 'ºC'),
	(315168, 143, '2015-01-15 00:18:39.000000', 'temperatura', 997.0000, 'ºC'),
	(315169, 143, '2015-01-15 00:18:40.000000', 'temperatura', 727.0000, 'ºC'),
	(315170, 143, '2015-01-15 00:18:41.000000', 'temperatura', 643.0000, 'ºC'),
	(315171, 143, '2015-01-15 00:18:42.000000', 'temperatura', 1036.0000, 'ºC'),
	(315172, 143, '2015-01-15 00:18:43.000000', 'temperatura', 853.0000, 'ºC'),
	(315173, 143, '2015-01-15 00:18:44.000000', 'temperatura', 1154.0000, 'ºC'),
	(315174, 143, '2015-01-15 00:18:45.000000', 'temperatura', 814.0000, 'ºC'),
	(315175, 143, '2015-01-15 00:18:46.000000', 'temperatura', 606.0000, 'ºC'),
	(315176, 143, '2015-01-15 00:18:47.000000', 'temperatura', 589.0000, 'ºC'),
	(315177, 143, '2015-01-15 00:18:48.000000', 'temperatura', 1127.0000, 'ºC'),
	(315178, 143, '2015-01-15 00:18:49.000000', 'temperatura', 271.0000, 'ºC'),
	(315179, 143, '2015-01-15 00:18:50.000000', 'temperatura', 372.0000, 'ºC'),
	(315180, 143, '2015-01-15 00:18:51.000000', 'temperatura', 1046.0000, 'ºC'),
	(315181, 143, '2015-01-15 00:18:52.000000', 'temperatura', 517.0000, 'ºC'),
	(315182, 143, '2015-01-15 00:18:53.000000', 'temperatura', 648.0000, 'ºC'),
	(315183, 143, '2015-01-15 00:18:54.000000', 'temperatura', 490.0000, 'ºC'),
	(315184, 143, '2015-01-15 00:18:55.000000', 'temperatura', 506.0000, 'ºC'),
	(315185, 143, '2015-01-15 00:18:56.000000', 'temperatura', 1061.0000, 'ºC'),
	(315186, 143, '2015-01-15 00:18:57.000000', 'temperatura', 187.0000, 'ºC'),
	(315187, 143, '2015-01-15 00:18:58.000000', 'temperatura', 154.0000, 'ºC'),
	(315188, 143, '2015-01-15 00:18:59.000000', 'temperatura', 208.0000, 'ºC'),
	(315189, 143, '2015-01-15 00:19:00.000000', 'temperatura', 580.0000, 'ºC'),
	(315190, 143, '2015-01-15 00:19:01.000000', 'temperatura', 1076.0000, 'ºC'),
	(315191, 143, '2015-01-15 00:19:02.000000', 'temperatura', 38.0000, 'ºC'),
	(315192, 143, '2015-01-15 00:19:03.000000', 'temperatura', 566.0000, 'ºC'),
	(315193, 143, '2015-01-15 00:19:04.000000', 'temperatura', 315.0000, 'ºC'),
	(315194, 143, '2015-01-15 00:19:05.000000', 'temperatura', 1079.0000, 'ºC'),
	(315195, 143, '2015-01-15 00:19:06.000000', 'temperatura', 849.0000, 'ºC'),
	(315196, 143, '2015-01-15 00:19:07.000000', 'temperatura', 1007.0000, 'ºC'),
	(315197, 143, '2015-01-15 00:19:08.000000', 'temperatura', 89.0000, 'ºC'),
	(315198, 143, '2015-01-15 00:19:09.000000', 'temperatura', 1026.0000, 'ºC'),
	(315199, 143, '2015-01-15 00:19:10.000000', 'temperatura', 63.0000, 'ºC'),
	(315200, 143, '2015-01-15 00:19:11.000000', 'temperatura', 838.0000, 'ºC'),
	(315201, 143, '2015-01-15 00:19:12.000000', 'temperatura', 403.0000, 'ºC'),
	(315202, 143, '2015-01-15 00:19:13.000000', 'temperatura', 700.0000, 'ºC'),
	(315203, 143, '2015-01-15 00:19:14.000000', 'temperatura', 1092.0000, 'ºC'),
	(315204, 143, '2015-01-15 00:19:15.000000', 'temperatura', 958.0000, 'ºC'),
	(315205, 143, '2015-01-15 00:19:16.000000', 'temperatura', 317.0000, 'ºC'),
	(315206, 143, '2015-01-15 00:19:17.000000', 'temperatura', 1109.0000, 'ºC'),
	(315207, 143, '2015-01-15 00:19:18.000000', 'temperatura', 996.0000, 'ºC'),
	(315208, 143, '2015-01-15 00:19:19.000000', 'temperatura', 454.0000, 'ºC'),
	(315209, 143, '2015-01-15 00:19:20.000000', 'temperatura', 483.0000, 'ºC'),
	(315210, 143, '2015-01-15 00:19:21.000000', 'temperatura', 1053.0000, 'ºC'),
	(315211, 143, '2015-01-15 00:19:22.000000', 'temperatura', 216.0000, 'ºC'),
	(315212, 143, '2015-01-15 00:19:23.000000', 'temperatura', 322.0000, 'ºC'),
	(315213, 143, '2015-01-15 00:19:24.000000', 'temperatura', 962.0000, 'ºC'),
	(315214, 143, '2015-01-15 00:19:25.000000', 'temperatura', 245.0000, 'ºC'),
	(315215, 143, '2015-01-15 00:19:26.000000', 'temperatura', 740.0000, 'ºC'),
	(315216, 143, '2015-01-15 00:19:27.000000', 'temperatura', 564.0000, 'ºC'),
	(315217, 143, '2015-01-15 00:19:28.000000', 'temperatura', 602.0000, 'ºC'),
	(315218, 143, '2015-01-15 00:19:29.000000', 'temperatura', 117.0000, 'ºC'),
	(315219, 143, '2015-01-15 00:19:30.000000', 'temperatura', 1180.0000, 'ºC'),
	(315220, 143, '2015-01-15 00:19:31.000000', 'temperatura', 750.0000, 'ºC'),
	(315221, 143, '2015-01-15 00:19:32.000000', 'temperatura', 208.0000, 'ºC'),
	(315222, 143, '2015-01-15 00:19:33.000000', 'temperatura', 1193.0000, 'ºC'),
	(315223, 143, '2015-01-15 00:19:34.000000', 'temperatura', 541.0000, 'ºC'),
	(315224, 143, '2015-01-15 00:19:35.000000', 'temperatura', 328.0000, 'ºC'),
	(315225, 143, '2015-01-15 00:19:36.000000', 'temperatura', 14.0000, 'ºC'),
	(315226, 143, '2015-01-15 00:19:37.000000', 'temperatura', 290.0000, 'ºC'),
	(315227, 143, '2015-01-15 00:19:38.000000', 'temperatura', 207.0000, 'ºC'),
	(315228, 143, '2015-01-15 00:19:39.000000', 'temperatura', 166.0000, 'ºC'),
	(315229, 143, '2015-01-15 00:19:40.000000', 'temperatura', 208.0000, 'ºC'),
	(315230, 143, '2015-01-15 00:19:41.000000', 'temperatura', 544.0000, 'ºC'),
	(315231, 143, '2015-01-15 00:19:42.000000', 'temperatura', 894.0000, 'ºC'),
	(315232, 143, '2015-01-15 00:19:43.000000', 'temperatura', 441.0000, 'ºC'),
	(315233, 143, '2015-01-15 00:19:44.000000', 'temperatura', 721.0000, 'ºC'),
	(315234, 143, '2015-01-15 00:19:45.000000', 'temperatura', 1085.0000, 'ºC'),
	(315235, 143, '2015-01-15 00:19:46.000000', 'temperatura', 862.0000, 'ºC'),
	(315236, 143, '2015-01-15 00:19:47.000000', 'temperatura', 1055.0000, 'ºC'),
	(315237, 143, '2015-01-15 00:19:48.000000', 'temperatura', 292.0000, 'ºC'),
	(315238, 143, '2015-01-15 00:19:49.000000', 'temperatura', 692.0000, 'ºC'),
	(315239, 143, '2015-01-15 00:19:50.000000', 'temperatura', 185.0000, 'ºC'),
	(315240, 143, '2015-01-15 00:19:51.000000', 'temperatura', 50.0000, 'ºC'),
	(315241, 143, '2015-01-15 00:19:52.000000', 'temperatura', 894.0000, 'ºC'),
	(315242, 143, '2015-01-15 00:19:53.000000', 'temperatura', 721.0000, 'ºC'),
	(315243, 143, '2015-01-15 00:19:54.000000', 'temperatura', 925.0000, 'ºC'),
	(315244, 143, '2015-01-15 00:19:55.000000', 'temperatura', 61.0000, 'ºC'),
	(315245, 143, '2015-01-15 00:19:56.000000', 'temperatura', 1131.0000, 'ºC'),
	(315246, 143, '2015-01-15 00:19:57.000000', 'temperatura', 672.0000, 'ºC'),
	(315247, 143, '2015-01-15 00:19:58.000000', 'temperatura', 1166.0000, 'ºC'),
	(315248, 143, '2015-01-15 00:19:59.000000', 'temperatura', 215.0000, 'ºC'),
	(315249, 143, '2015-01-15 00:20:00.000000', 'temperatura', 1179.0000, 'ºC'),
	(315250, 143, '2015-01-15 00:20:01.000000', 'temperatura', 451.0000, 'ºC'),
	(315251, 143, '2015-01-15 00:20:02.000000', 'temperatura', 1118.0000, 'ºC'),
	(315252, 143, '2015-01-15 00:20:03.000000', 'temperatura', 637.0000, 'ºC'),
	(315253, 143, '2015-01-15 00:20:04.000000', 'temperatura', 1031.0000, 'ºC'),
	(315254, 143, '2015-01-15 00:20:05.000000', 'temperatura', 847.0000, 'ºC'),
	(315255, 143, '2015-01-15 00:20:06.000000', 'temperatura', 1140.0000, 'ºC'),
	(315256, 143, '2015-01-15 00:20:07.000000', 'temperatura', 760.0000, 'ºC'),
	(315257, 143, '2015-01-15 00:20:08.000000', 'temperatura', 382.0000, 'ºC'),
	(315258, 143, '2015-01-15 00:20:09.000000', 'temperatura', 831.0000, 'ºC'),
	(315259, 143, '2015-01-15 00:20:10.000000', 'temperatura', 608.0000, 'ºC'),
	(315260, 143, '2015-01-15 00:20:11.000000', 'temperatura', 549.0000, 'ºC'),
	(315261, 143, '2015-01-15 00:20:12.000000', 'temperatura', 921.0000, 'ºC'),
	(315262, 143, '2015-01-15 00:20:13.000000', 'temperatura', 558.0000, 'ºC'),
	(315263, 143, '2015-01-15 00:20:14.000000', 'temperatura', 27.0000, 'ºC'),
	(315264, 143, '2015-01-15 00:20:15.000000', 'temperatura', 860.0000, 'ºC'),
	(315265, 143, '2015-01-15 00:20:16.000000', 'temperatura', 621.0000, 'ºC'),
	(315266, 143, '2015-01-15 00:20:17.000000', 'temperatura', 525.0000, 'ºC'),
	(315267, 143, '2015-01-15 00:20:18.000000', 'temperatura', 764.0000, 'ºC'),
	(315268, 143, '2015-01-15 00:20:19.000000', 'temperatura', 1043.0000, 'ºC'),
	(315269, 143, '2015-01-15 00:20:20.000000', 'temperatura', 524.0000, 'ºC'),
	(315270, 143, '2015-01-15 00:20:21.000000', 'temperatura', 691.0000, 'ºC'),
	(315271, 143, '2015-01-15 00:20:22.000000', 'temperatura', 684.0000, 'ºC'),
	(315272, 143, '2015-01-15 00:20:23.000000', 'temperatura', 148.0000, 'ºC'),
	(315273, 143, '2015-01-15 00:20:24.000000', 'temperatura', 1090.0000, 'ºC'),
	(315274, 143, '2015-01-15 00:20:25.000000', 'temperatura', 203.0000, 'ºC'),
	(315275, 143, '2015-01-15 00:20:26.000000', 'temperatura', 149.0000, 'ºC'),
	(315276, 143, '2015-01-15 00:20:27.000000', 'temperatura', 135.0000, 'ºC'),
	(315277, 143, '2015-01-15 00:20:28.000000', 'temperatura', 227.0000, 'ºC'),
	(315278, 143, '2015-01-15 00:20:29.000000', 'temperatura', 732.0000, 'ºC'),
	(315279, 143, '2015-01-15 00:20:30.000000', 'temperatura', 578.0000, 'ºC'),
	(315280, 143, '2015-01-15 00:20:31.000000', 'temperatura', 697.0000, 'ºC'),
	(315281, 143, '2015-01-15 00:20:32.000000', 'temperatura', 549.0000, 'ºC'),
	(315282, 143, '2015-01-15 00:20:33.000000', 'temperatura', 656.0000, 'ºC'),
	(315283, 143, '2015-01-15 00:20:34.000000', 'temperatura', 432.0000, 'ºC'),
	(315284, 143, '2015-01-15 00:20:35.000000', 'temperatura', 194.0000, 'ºC'),
	(315285, 143, '2015-01-15 00:20:36.000000', 'temperatura', 872.0000, 'ºC'),
	(315286, 143, '2015-01-15 00:20:37.000000', 'temperatura', 180.0000, 'ºC'),
	(315287, 143, '2015-01-15 00:20:38.000000', 'temperatura', 685.0000, 'ºC'),
	(315288, 143, '2015-01-15 00:20:39.000000', 'temperatura', 484.0000, 'ºC'),
	(315289, 143, '2015-01-15 00:20:40.000000', 'temperatura', 368.0000, 'ºC'),
	(315290, 143, '2015-01-15 00:20:41.000000', 'temperatura', 386.0000, 'ºC'),
	(315291, 143, '2015-01-15 00:20:42.000000', 'temperatura', 829.0000, 'ºC'),
	(315292, 143, '2015-01-15 00:20:43.000000', 'temperatura', 587.0000, 'ºC'),
	(315293, 143, '2015-01-15 00:20:44.000000', 'temperatura', 450.0000, 'ºC'),
	(315294, 143, '2015-01-15 00:20:45.000000', 'temperatura', 487.0000, 'ºC'),
	(315295, 143, '2015-01-15 00:20:46.000000', 'temperatura', 1086.0000, 'ºC'),
	(315296, 143, '2015-01-15 00:20:47.000000', 'temperatura', 371.0000, 'ºC'),
	(315297, 143, '2015-01-15 00:20:48.000000', 'temperatura', 997.0000, 'ºC'),
	(315298, 143, '2015-01-15 00:20:49.000000', 'temperatura', 272.0000, 'ºC'),
	(315299, 143, '2015-01-15 00:20:50.000000', 'temperatura', 768.0000, 'ºC'),
	(315300, 143, '2015-01-15 00:20:51.000000', 'temperatura', 627.0000, 'ºC'),
	(315301, 143, '2015-01-15 00:20:52.000000', 'temperatura', 832.0000, 'ºC'),
	(315302, 143, '2015-01-15 00:20:53.000000', 'temperatura', 1079.0000, 'ºC'),
	(315303, 143, '2015-01-15 00:20:54.000000', 'temperatura', 500.0000, 'ºC'),
	(315304, 143, '2015-01-15 00:20:55.000000', 'temperatura', 462.0000, 'ºC'),
	(315305, 143, '2015-01-15 00:20:56.000000', 'temperatura', 810.0000, 'ºC'),
	(315306, 143, '2015-01-15 00:20:57.000000', 'temperatura', 264.0000, 'ºC'),
	(315307, 143, '2015-01-15 00:20:58.000000', 'temperatura', 91.0000, 'ºC'),
	(315308, 143, '2015-01-15 00:20:59.000000', 'temperatura', 865.0000, 'ºC'),
	(315309, 143, '2015-01-15 00:21:00.000000', 'temperatura', 453.0000, 'ºC'),
	(315310, 143, '2015-01-15 00:21:01.000000', 'temperatura', 870.0000, 'ºC'),
	(315311, 143, '2015-01-15 00:21:02.000000', 'temperatura', 590.0000, 'ºC'),
	(315312, 143, '2015-01-15 00:21:03.000000', 'temperatura', 343.0000, 'ºC'),
	(315313, 143, '2015-01-15 00:21:04.000000', 'temperatura', 1143.0000, 'ºC'),
	(315314, 143, '2015-01-15 00:21:05.000000', 'temperatura', 1086.0000, 'ºC'),
	(315315, 143, '2015-01-15 00:21:06.000000', 'temperatura', 802.0000, 'ºC'),
	(315316, 143, '2015-01-15 00:21:07.000000', 'temperatura', 752.0000, 'ºC'),
	(315317, 143, '2015-01-15 00:21:08.000000', 'temperatura', 153.0000, 'ºC'),
	(315318, 143, '2015-01-15 00:21:09.000000', 'temperatura', 911.0000, 'ºC'),
	(315319, 143, '2015-01-15 00:21:10.000000', 'temperatura', 498.0000, 'ºC'),
	(315320, 143, '2015-01-15 00:21:11.000000', 'temperatura', 955.0000, 'ºC'),
	(315321, 143, '2015-01-15 00:21:12.000000', 'temperatura', 884.0000, 'ºC'),
	(315322, 143, '2015-01-15 00:21:13.000000', 'temperatura', 356.0000, 'ºC'),
	(315323, 143, '2015-01-15 00:21:14.000000', 'temperatura', 326.0000, 'ºC'),
	(315324, 143, '2015-01-15 00:21:15.000000', 'temperatura', 561.0000, 'ºC'),
	(315325, 143, '2015-01-15 00:21:16.000000', 'temperatura', 631.0000, 'ºC'),
	(315326, 143, '2015-01-15 00:21:17.000000', 'temperatura', 273.0000, 'ºC'),
	(315327, 143, '2015-01-15 00:21:18.000000', 'temperatura', 669.0000, 'ºC'),
	(315328, 143, '2015-01-15 00:21:19.000000', 'temperatura', 129.0000, 'ºC'),
	(315329, 143, '2015-01-15 00:21:20.000000', 'temperatura', 1038.0000, 'ºC'),
	(315330, 143, '2015-01-15 00:21:21.000000', 'temperatura', 4.0000, 'ºC'),
	(315331, 143, '2015-01-15 00:21:22.000000', 'temperatura', 507.0000, 'ºC'),
	(315332, 143, '2015-01-15 00:21:23.000000', 'temperatura', 122.0000, 'ºC'),
	(315333, 143, '2015-01-15 00:21:24.000000', 'temperatura', 292.0000, 'ºC'),
	(315334, 143, '2015-01-15 00:21:25.000000', 'temperatura', 1094.0000, 'ºC'),
	(315335, 143, '2015-01-15 00:21:26.000000', 'temperatura', 992.0000, 'ºC'),
	(315336, 143, '2015-01-15 00:21:27.000000', 'temperatura', 482.0000, 'ºC'),
	(315337, 143, '2015-01-15 00:21:28.000000', 'temperatura', 632.0000, 'ºC'),
	(315338, 143, '2015-01-15 00:21:29.000000', 'temperatura', 514.0000, 'ºC'),
	(315339, 143, '2015-01-15 00:21:30.000000', 'temperatura', 674.0000, 'ºC'),
	(315340, 143, '2015-01-15 00:21:31.000000', 'temperatura', 630.0000, 'ºC'),
	(315341, 143, '2015-01-15 00:21:32.000000', 'temperatura', 1129.0000, 'ºC'),
	(315342, 143, '2015-01-15 00:21:33.000000', 'temperatura', 155.0000, 'ºC'),
	(315343, 143, '2015-01-15 00:21:34.000000', 'temperatura', 988.0000, 'ºC'),
	(315344, 143, '2015-01-15 00:21:35.000000', 'temperatura', 874.0000, 'ºC'),
	(315345, 143, '2015-01-15 00:21:36.000000', 'temperatura', 208.0000, 'ºC'),
	(315346, 143, '2015-01-15 00:21:37.000000', 'temperatura', 819.0000, 'ºC'),
	(315347, 143, '2015-01-15 00:21:38.000000', 'temperatura', 1071.0000, 'ºC'),
	(315348, 143, '2015-01-15 00:21:39.000000', 'temperatura', 500.0000, 'ºC'),
	(315349, 143, '2015-01-15 00:21:40.000000', 'temperatura', 488.0000, 'ºC'),
	(315350, 143, '2015-01-15 00:21:41.000000', 'temperatura', 938.0000, 'ºC'),
	(315351, 143, '2015-01-15 00:21:42.000000', 'temperatura', 827.0000, 'ºC'),
	(315352, 143, '2015-01-15 00:21:43.000000', 'temperatura', 122.0000, 'ºC'),
	(315353, 143, '2015-01-15 00:21:44.000000', 'temperatura', 532.0000, 'ºC'),
	(315354, 143, '2015-01-15 00:21:45.000000', 'temperatura', 1091.0000, 'ºC'),
	(315355, 143, '2015-01-15 00:21:46.000000', 'temperatura', 259.0000, 'ºC'),
	(315356, 143, '2015-01-15 00:21:47.000000', 'temperatura', 424.0000, 'ºC'),
	(315357, 143, '2015-01-15 00:21:48.000000', 'temperatura', 145.0000, 'ºC'),
	(315358, 143, '2015-01-15 00:21:49.000000', 'temperatura', 651.0000, 'ºC'),
	(315359, 143, '2015-01-15 00:21:50.000000', 'temperatura', 423.0000, 'ºC'),
	(315360, 143, '2015-01-15 00:21:51.000000', 'temperatura', 161.0000, 'ºC'),
	(315361, 143, '2015-01-15 00:21:52.000000', 'temperatura', 738.0000, 'ºC'),
	(315362, 143, '2015-01-15 00:21:53.000000', 'temperatura', 807.0000, 'ºC'),
	(315363, 143, '2015-01-15 00:21:54.000000', 'temperatura', 623.0000, 'ºC'),
	(315364, 143, '2015-01-15 00:21:55.000000', 'temperatura', 693.0000, 'ºC'),
	(315365, 143, '2015-01-15 00:21:56.000000', 'temperatura', 395.0000, 'ºC'),
	(315366, 143, '2015-01-15 00:21:57.000000', 'temperatura', 1099.0000, 'ºC'),
	(315367, 143, '2015-01-15 00:21:58.000000', 'temperatura', 711.0000, 'ºC'),
	(315368, 143, '2015-01-15 00:21:59.000000', 'temperatura', 258.0000, 'ºC'),
	(315369, 143, '2015-01-15 00:22:00.000000', 'temperatura', 356.0000, 'ºC'),
	(315370, 143, '2015-01-15 00:22:01.000000', 'temperatura', 1008.0000, 'ºC'),
	(315371, 143, '2015-01-15 00:22:02.000000', 'temperatura', 374.0000, 'ºC'),
	(315372, 143, '2015-01-15 00:22:03.000000', 'temperatura', 43.0000, 'ºC'),
	(315373, 143, '2015-01-15 00:22:04.000000', 'temperatura', 296.0000, 'ºC'),
	(315374, 143, '2015-01-15 00:22:05.000000', 'temperatura', 151.0000, 'ºC'),
	(315375, 143, '2015-01-15 00:22:06.000000', 'temperatura', 1069.0000, 'ºC'),
	(315376, 143, '2015-01-15 00:22:07.000000', 'temperatura', 93.0000, 'ºC'),
	(315377, 143, '2015-01-15 00:22:08.000000', 'temperatura', 858.0000, 'ºC'),
	(315378, 143, '2015-01-15 00:22:09.000000', 'temperatura', 412.0000, 'ºC'),
	(315379, 143, '2015-01-15 00:22:10.000000', 'temperatura', 687.0000, 'ºC'),
	(315380, 143, '2015-01-15 00:22:11.000000', 'temperatura', 1001.0000, 'ºC'),
	(315381, 143, '2015-01-15 00:22:12.000000', 'temperatura', 541.0000, 'ºC'),
	(315382, 143, '2015-01-15 00:22:13.000000', 'temperatura', 903.0000, 'ºC'),
	(315383, 143, '2015-01-15 00:22:14.000000', 'temperatura', 493.0000, 'ºC'),
	(315384, 143, '2015-01-15 00:22:15.000000', 'temperatura', 956.0000, 'ºC'),
	(315385, 143, '2015-01-15 00:22:16.000000', 'temperatura', 903.0000, 'ºC'),
	(315386, 143, '2015-01-15 00:22:17.000000', 'temperatura', 445.0000, 'ºC'),
	(315387, 143, '2015-01-15 00:22:18.000000', 'temperatura', 717.0000, 'ºC'),
	(315388, 143, '2015-01-15 00:22:19.000000', 'temperatura', 1051.0000, 'ºC'),
	(315389, 143, '2015-01-15 00:22:20.000000', 'temperatura', 705.0000, 'ºC'),
	(315390, 143, '2015-01-15 00:22:21.000000', 'temperatura', 372.0000, 'ºC'),
	(315391, 143, '2015-01-15 00:22:22.000000', 'temperatura', 947.0000, 'ºC'),
	(315392, 143, '2015-01-15 00:22:23.000000', 'temperatura', 20.0000, 'ºC'),
	(315393, 143, '2015-01-15 00:22:24.000000', 'temperatura', 860.0000, 'ºC'),
	(315394, 143, '2015-01-15 00:22:25.000000', 'temperatura', 641.0000, 'ºC'),
	(315395, 143, '2015-01-15 00:22:26.000000', 'temperatura', 623.0000, 'ºC'),
	(315396, 143, '2015-01-15 00:22:27.000000', 'temperatura', 1194.0000, 'ºC'),
	(315397, 143, '2015-01-15 00:22:28.000000', 'temperatura', 500.0000, 'ºC'),
	(315398, 143, '2015-01-15 00:22:29.000000', 'temperatura', 121.0000, 'ºC'),
	(315399, 143, '2015-01-15 00:22:30.000000', 'temperatura', 302.0000, 'ºC'),
	(315400, 143, '2015-01-15 00:22:31.000000', 'temperatura', 1150.0000, 'ºC'),
	(315401, 143, '2015-01-15 00:22:32.000000', 'temperatura', 46.0000, 'ºC'),
	(315402, 143, '2015-01-15 00:22:33.000000', 'temperatura', 379.0000, 'ºC'),
	(315403, 143, '2015-01-15 00:22:34.000000', 'temperatura', 558.0000, 'ºC'),
	(315404, 143, '2015-01-15 00:22:35.000000', 'temperatura', 452.0000, 'ºC'),
	(315405, 143, '2015-01-15 00:22:36.000000', 'temperatura', 587.0000, 'ºC'),
	(315406, 143, '2015-01-15 00:22:37.000000', 'temperatura', 380.0000, 'ºC'),
	(315407, 143, '2015-01-15 00:22:38.000000', 'temperatura', 137.0000, 'ºC'),
	(315408, 143, '2015-01-15 00:22:39.000000', 'temperatura', 748.0000, 'ºC'),
	(315409, 143, '2015-01-15 00:22:40.000000', 'temperatura', 928.0000, 'ºC'),
	(315410, 143, '2015-01-15 00:22:41.000000', 'temperatura', 1198.0000, 'ºC'),
	(315411, 143, '2015-01-15 00:22:42.000000', 'temperatura', 806.0000, 'ºC'),
	(315412, 143, '2015-01-15 00:22:43.000000', 'temperatura', 436.0000, 'ºC'),
	(315413, 143, '2015-01-15 00:22:44.000000', 'temperatura', 963.0000, 'ºC'),
	(315414, 143, '2015-01-15 00:22:45.000000', 'temperatura', 1107.0000, 'ºC'),
	(315415, 143, '2015-01-15 00:22:46.000000', 'temperatura', 249.0000, 'ºC'),
	(315416, 143, '2015-01-15 00:22:47.000000', 'temperatura', 322.0000, 'ºC'),
	(315417, 143, '2015-01-15 00:22:48.000000', 'temperatura', 865.0000, 'ºC'),
	(315418, 143, '2015-01-15 00:22:49.000000', 'temperatura', 960.0000, 'ºC'),
	(315419, 143, '2015-01-15 00:22:50.000000', 'temperatura', 1006.0000, 'ºC'),
	(315420, 143, '2015-01-15 00:22:51.000000', 'temperatura', 951.0000, 'ºC'),
	(315421, 143, '2015-01-15 00:22:52.000000', 'temperatura', 535.0000, 'ºC'),
	(315422, 143, '2015-01-15 00:22:53.000000', 'temperatura', 1023.0000, 'ºC'),
	(315423, 143, '2015-01-15 00:22:54.000000', 'temperatura', 1113.0000, 'ºC'),
	(315424, 143, '2015-01-15 00:22:55.000000', 'temperatura', 95.0000, 'ºC'),
	(315425, 143, '2015-01-15 00:22:56.000000', 'temperatura', 735.0000, 'ºC'),
	(315426, 143, '2015-01-15 00:22:57.000000', 'temperatura', 993.0000, 'ºC'),
	(315427, 143, '2015-01-15 00:22:58.000000', 'temperatura', 360.0000, 'ºC'),
	(315428, 143, '2015-01-15 00:22:59.000000', 'temperatura', 23.0000, 'ºC'),
	(315429, 143, '2015-01-15 00:23:00.000000', 'temperatura', 234.0000, 'ºC'),
	(315430, 143, '2015-01-15 00:23:01.000000', 'temperatura', 1100.0000, 'ºC'),
	(315431, 143, '2015-01-15 00:23:02.000000', 'temperatura', 1.0000, 'ºC'),
	(315432, 143, '2015-01-15 00:23:03.000000', 'temperatura', 306.0000, 'ºC'),
	(315433, 143, '2015-01-15 00:23:04.000000', 'temperatura', 326.0000, 'ºC'),
	(315434, 143, '2015-01-15 00:23:05.000000', 'temperatura', 711.0000, 'ºC'),
	(315435, 143, '2015-01-15 00:23:06.000000', 'temperatura', 178.0000, 'ºC'),
	(315436, 143, '2015-01-15 00:23:07.000000', 'temperatura', 1158.0000, 'ºC'),
	(315437, 143, '2015-01-15 00:23:08.000000', 'temperatura', 457.0000, 'ºC'),
	(315438, 143, '2015-01-15 00:23:09.000000', 'temperatura', 11.0000, 'ºC'),
	(315439, 143, '2015-01-15 00:23:10.000000', 'temperatura', 1085.0000, 'ºC'),
	(315440, 143, '2015-01-15 00:23:11.000000', 'temperatura', 592.0000, 'ºC'),
	(315441, 143, '2015-01-15 00:23:12.000000', 'temperatura', 908.0000, 'ºC'),
	(315442, 143, '2015-01-15 00:23:13.000000', 'temperatura', 362.0000, 'ºC'),
	(315443, 143, '2015-01-15 00:23:14.000000', 'temperatura', 285.0000, 'ºC'),
	(315444, 143, '2015-01-15 00:23:15.000000', 'temperatura', 341.0000, 'ºC'),
	(315445, 143, '2015-01-15 00:23:16.000000', 'temperatura', 850.0000, 'ºC'),
	(315446, 143, '2015-01-15 00:23:17.000000', 'temperatura', 830.0000, 'ºC'),
	(315447, 143, '2015-01-15 00:23:18.000000', 'temperatura', 397.0000, 'ºC'),
	(315448, 143, '2015-01-15 00:23:19.000000', 'temperatura', 699.0000, 'ºC'),
	(315449, 143, '2015-01-15 00:23:20.000000', 'temperatura', 1102.0000, 'ºC'),
	(315450, 143, '2015-01-15 00:23:21.000000', 'temperatura', 1013.0000, 'ºC'),
	(315451, 143, '2015-01-15 00:23:22.000000', 'temperatura', 560.0000, 'ºC'),
	(315452, 143, '2015-01-15 00:23:23.000000', 'temperatura', 960.0000, 'ºC'),
	(315453, 143, '2015-01-15 00:23:24.000000', 'temperatura', 721.0000, 'ºC'),
	(315454, 143, '2015-01-15 00:23:25.000000', 'temperatura', 726.0000, 'ºC'),
	(315455, 143, '2015-01-15 00:23:26.000000', 'temperatura', 267.0000, 'ºC'),
	(315456, 143, '2015-01-15 00:23:27.000000', 'temperatura', 356.0000, 'ºC'),
	(315457, 143, '2015-01-15 00:23:28.000000', 'temperatura', 979.0000, 'ºC'),
	(315458, 143, '2015-01-15 00:23:29.000000', 'temperatura', 231.0000, 'ºC'),
	(315459, 143, '2015-01-15 00:23:30.000000', 'temperatura', 616.0000, 'ºC'),
	(315460, 143, '2015-01-15 00:23:31.000000', 'temperatura', 1189.0000, 'ºC'),
	(315461, 143, '2015-01-15 00:23:32.000000', 'temperatura', 499.0000, 'ºC'),
	(315462, 143, '2015-01-15 00:23:33.000000', 'temperatura', 127.0000, 'ºC'),
	(315463, 143, '2015-01-15 00:23:34.000000', 'temperatura', 336.0000, 'ºC'),
	(315464, 143, '2015-01-15 00:23:35.000000', 'temperatura', 103.0000, 'ºC'),
	(315465, 143, '2015-01-15 00:23:36.000000', 'temperatura', 707.0000, 'ºC'),
	(315466, 143, '2015-01-15 00:23:37.000000', 'temperatura', 828.0000, 'ºC'),
	(315467, 143, '2015-01-15 00:23:38.000000', 'temperatura', 817.0000, 'ºC'),
	(315468, 143, '2015-01-15 00:23:39.000000', 'temperatura', 402.0000, 'ºC'),
	(315469, 143, '2015-01-15 00:23:40.000000', 'temperatura', 758.0000, 'ºC'),
	(315470, 143, '2015-01-15 00:23:41.000000', 'temperatura', 187.0000, 'ºC'),
	(315471, 143, '2015-01-15 00:23:42.000000', 'temperatura', 1061.0000, 'ºC'),
	(315472, 143, '2015-01-15 00:23:43.000000', 'temperatura', 1145.0000, 'ºC'),
	(315473, 143, '2015-01-15 00:23:44.000000', 'temperatura', 143.0000, 'ºC'),
	(315474, 143, '2015-01-15 00:23:45.000000', 'temperatura', 878.0000, 'ºC'),
	(315475, 143, '2015-01-15 00:23:46.000000', 'temperatura', 363.0000, 'ºC'),
	(315476, 143, '2015-01-15 00:23:47.000000', 'temperatura', 383.0000, 'ºC'),
	(315477, 143, '2015-01-15 00:23:48.000000', 'temperatura', 824.0000, 'ºC'),
	(315478, 143, '2015-01-15 00:23:49.000000', 'temperatura', 573.0000, 'ºC'),
	(315479, 143, '2015-01-15 00:23:50.000000', 'temperatura', 392.0000, 'ºC'),
	(315480, 143, '2015-01-15 00:23:51.000000', 'temperatura', 244.0000, 'ºC'),
	(315481, 143, '2015-01-15 00:23:52.000000', 'temperatura', 45.0000, 'ºC'),
	(315482, 143, '2015-01-15 00:23:53.000000', 'temperatura', 692.0000, 'ºC'),
	(315483, 143, '2015-01-15 00:23:54.000000', 'temperatura', 924.0000, 'ºC'),
	(315484, 143, '2015-01-15 00:23:55.000000', 'temperatura', 144.0000, 'ºC'),
	(315485, 143, '2015-01-15 00:23:56.000000', 'temperatura', 352.0000, 'ºC'),
	(315486, 143, '2015-01-15 00:23:57.000000', 'temperatura', 125.0000, 'ºC'),
	(315487, 143, '2015-01-15 00:23:58.000000', 'temperatura', 771.0000, 'ºC'),
	(315488, 143, '2015-01-15 00:23:59.000000', 'temperatura', 1081.0000, 'ºC'),
	(315489, 143, '2015-01-15 00:24:00.000000', 'temperatura', 692.0000, 'ºC'),
	(315490, 143, '2015-01-15 00:24:01.000000', 'temperatura', 218.0000, 'ºC'),
	(315491, 143, '2015-01-15 00:24:02.000000', 'temperatura', 214.0000, 'ºC'),
	(315492, 143, '2015-01-15 00:24:03.000000', 'temperatura', 416.0000, 'ºC'),
	(315493, 143, '2015-01-15 00:24:04.000000', 'temperatura', 240.0000, 'ºC'),
	(315494, 143, '2015-01-15 00:24:05.000000', 'temperatura', 1153.0000, 'ºC'),
	(315495, 143, '2015-01-15 00:24:06.000000', 'temperatura', 245.0000, 'ºC'),
	(315496, 143, '2015-01-15 00:24:07.000000', 'temperatura', 166.0000, 'ºC'),
	(315497, 143, '2015-01-15 00:24:08.000000', 'temperatura', 95.0000, 'ºC'),
	(315498, 143, '2015-01-15 00:24:09.000000', 'temperatura', 1179.0000, 'ºC'),
	(315499, 143, '2015-01-15 00:24:10.000000', 'temperatura', 810.0000, 'ºC'),
	(315500, 143, '2015-01-15 00:24:11.000000', 'temperatura', 515.0000, 'ºC'),
	(315501, 143, '2015-01-15 00:24:12.000000', 'temperatura', 145.0000, 'ºC'),
	(315502, 143, '2015-01-15 00:24:13.000000', 'temperatura', 381.0000, 'ºC'),
	(315503, 143, '2015-01-15 00:24:14.000000', 'temperatura', 270.0000, 'ºC'),
	(315504, 143, '2015-01-15 00:24:15.000000', 'temperatura', 208.0000, 'ºC'),
	(315505, 143, '2015-01-15 00:24:16.000000', 'temperatura', 229.0000, 'ºC'),
	(315506, 143, '2015-01-15 00:24:17.000000', 'temperatura', 524.0000, 'ºC'),
	(315507, 143, '2015-01-15 00:24:18.000000', 'temperatura', 731.0000, 'ºC'),
	(315508, 143, '2015-01-15 00:24:19.000000', 'temperatura', 884.0000, 'ºC'),
	(315509, 143, '2015-01-15 00:24:20.000000', 'temperatura', 1029.0000, 'ºC'),
	(315510, 143, '2015-01-15 00:24:21.000000', 'temperatura', 95.0000, 'ºC'),
	(315511, 143, '2015-01-15 00:24:22.000000', 'temperatura', 986.0000, 'ºC'),
	(315512, 143, '2015-01-15 00:24:23.000000', 'temperatura', 1044.0000, 'ºC'),
	(315513, 143, '2015-01-15 00:24:24.000000', 'temperatura', 1064.0000, 'ºC'),
	(315514, 143, '2015-01-15 00:24:25.000000', 'temperatura', 988.0000, 'ºC'),
	(315515, 143, '2015-01-15 00:24:26.000000', 'temperatura', 551.0000, 'ºC'),
	(315516, 143, '2015-01-15 00:24:27.000000', 'temperatura', 988.0000, 'ºC'),
	(315517, 143, '2015-01-15 00:24:28.000000', 'temperatura', 890.0000, 'ºC'),
	(315518, 143, '2015-01-15 00:24:29.000000', 'temperatura', 285.0000, 'ºC'),
	(315519, 143, '2015-01-15 00:24:30.000000', 'temperatura', 1155.0000, 'ºC'),
	(315520, 143, '2015-01-15 00:24:31.000000', 'temperatura', 121.0000, 'ºC'),
	(315521, 143, '2015-01-15 00:24:32.000000', 'temperatura', 741.0000, 'ºC'),
	(315522, 143, '2015-01-15 00:24:33.000000', 'temperatura', 941.0000, 'ºC'),
	(315523, 143, '2015-01-15 00:24:34.000000', 'temperatura', 85.0000, 'ºC'),
	(315524, 143, '2015-01-15 00:24:35.000000', 'temperatura', 1.0000, 'ºC'),
	(315525, 143, '2015-01-15 00:24:36.000000', 'temperatura', 952.0000, 'ºC'),
	(315526, 143, '2015-01-15 00:24:37.000000', 'temperatura', 1155.0000, 'ºC'),
	(315527, 143, '2015-01-15 00:24:38.000000', 'temperatura', 522.0000, 'ºC'),
	(315528, 143, '2015-01-15 00:24:39.000000', 'temperatura', 346.0000, 'ºC'),
	(315529, 143, '2015-01-15 00:24:40.000000', 'temperatura', 165.0000, 'ºC'),
	(315530, 143, '2015-01-15 00:24:41.000000', 'temperatura', 986.0000, 'ºC'),
	(315531, 143, '2015-01-15 00:24:42.000000', 'temperatura', 836.0000, 'ºC'),
	(315532, 143, '2015-01-15 00:24:43.000000', 'temperatura', 24.0000, 'ºC'),
	(315533, 143, '2015-01-15 00:24:44.000000', 'temperatura', 13.0000, 'ºC'),
	(315534, 143, '2015-01-15 00:24:45.000000', 'temperatura', 1194.0000, 'ºC'),
	(315535, 143, '2015-01-15 00:24:46.000000', 'temperatura', 1130.0000, 'ºC'),
	(315536, 143, '2015-01-15 00:24:47.000000', 'temperatura', 867.0000, 'ºC'),
	(315537, 143, '2015-01-15 00:24:48.000000', 'temperatura', 945.0000, 'ºC'),
	(315538, 143, '2015-01-15 00:24:49.000000', 'temperatura', 928.0000, 'ºC'),
	(315539, 143, '2015-01-15 00:24:50.000000', 'temperatura', 603.0000, 'ºC'),
	(315540, 143, '2015-01-15 00:24:51.000000', 'temperatura', 231.0000, 'ºC'),
	(315541, 143, '2015-01-15 00:24:52.000000', 'temperatura', 548.0000, 'ºC'),
	(315542, 143, '2015-01-15 00:24:53.000000', 'temperatura', 849.0000, 'ºC'),
	(315543, 143, '2015-01-15 00:24:54.000000', 'temperatura', 200.0000, 'ºC'),
	(315544, 143, '2015-01-15 00:24:55.000000', 'temperatura', 856.0000, 'ºC'),
	(315545, 143, '2015-01-15 00:24:56.000000', 'temperatura', 77.0000, 'ºC'),
	(315546, 143, '2015-01-15 00:24:57.000000', 'temperatura', 220.0000, 'ºC'),
	(315547, 143, '2015-01-15 00:24:58.000000', 'temperatura', 868.0000, 'ºC'),
	(315548, 143, '2015-01-15 00:24:59.000000', 'temperatura', 81.0000, 'ºC'),
	(315549, 143, '2015-01-15 00:25:00.000000', 'temperatura', 201.0000, 'ºC'),
	(315550, 143, '2015-01-15 00:25:01.000000', 'temperatura', 763.0000, 'ºC'),
	(315551, 143, '2015-01-15 00:25:02.000000', 'temperatura', 814.0000, 'ºC'),
	(315552, 143, '2015-01-15 00:25:03.000000', 'temperatura', 582.0000, 'ºC'),
	(315553, 143, '2015-01-15 00:25:04.000000', 'temperatura', 466.0000, 'ºC'),
	(315554, 143, '2015-01-15 00:25:05.000000', 'temperatura', 587.0000, 'ºC'),
	(315555, 143, '2015-01-15 00:25:06.000000', 'temperatura', 336.0000, 'ºC'),
	(315556, 143, '2015-01-15 00:25:07.000000', 'temperatura', 1120.0000, 'ºC'),
	(315557, 143, '2015-01-15 00:25:08.000000', 'temperatura', 994.0000, 'ºC'),
	(315558, 143, '2015-01-15 00:25:09.000000', 'temperatura', 410.0000, 'ºC'),
	(315559, 143, '2015-01-15 00:25:10.000000', 'temperatura', 269.0000, 'ºC'),
	(315560, 143, '2015-01-15 00:25:11.000000', 'temperatura', 114.0000, 'ºC'),
	(315561, 143, '2015-01-15 00:25:12.000000', 'temperatura', 964.0000, 'ºC'),
	(315562, 143, '2015-01-15 00:25:13.000000', 'temperatura', 878.0000, 'ºC'),
	(315563, 143, '2015-01-15 00:25:14.000000', 'temperatura', 298.0000, 'ºC'),
	(315564, 143, '2015-01-15 00:25:15.000000', 'temperatura', 56.0000, 'ºC'),
	(315565, 143, '2015-01-15 00:25:16.000000', 'temperatura', 587.0000, 'ºC'),
	(315566, 143, '2015-01-15 00:25:17.000000', 'temperatura', 369.0000, 'ºC'),
	(315567, 143, '2015-01-15 00:25:18.000000', 'temperatura', 82.0000, 'ºC'),
	(315568, 143, '2015-01-15 00:25:19.000000', 'temperatura', 505.0000, 'ºC'),
	(315569, 143, '2015-01-15 00:25:20.000000', 'temperatura', 1078.0000, 'ºC'),
	(315570, 143, '2015-01-15 00:25:21.000000', 'temperatura', 274.0000, 'ºC'),
	(315571, 143, '2015-01-15 00:25:22.000000', 'temperatura', 540.0000, 'ºC'),
	(315572, 143, '2015-01-15 00:25:23.000000', 'temperatura', 675.0000, 'ºC'),
	(315573, 143, '2015-01-15 00:25:24.000000', 'temperatura', 559.0000, 'ºC'),
	(315574, 143, '2015-01-15 00:25:25.000000', 'temperatura', 767.0000, 'ºC'),
	(315575, 143, '2015-01-15 00:25:26.000000', 'temperatura', 962.0000, 'ºC'),
	(315576, 143, '2015-01-15 00:25:27.000000', 'temperatura', 107.0000, 'ºC'),
	(315577, 143, '2015-01-15 00:25:28.000000', 'temperatura', 52.0000, 'ºC'),
	(315578, 143, '2015-01-15 00:25:29.000000', 'temperatura', 1137.0000, 'ºC'),
	(315579, 143, '2015-01-15 00:25:30.000000', 'temperatura', 730.0000, 'ºC'),
	(315580, 143, '2015-01-15 00:25:31.000000', 'temperatura', 242.0000, 'ºC'),
	(315581, 143, '2015-01-15 00:25:32.000000', 'temperatura', 217.0000, 'ºC'),
	(315582, 143, '2015-01-15 00:25:33.000000', 'temperatura', 360.0000, 'ºC'),
	(315583, 143, '2015-01-15 00:25:34.000000', 'temperatura', 1150.0000, 'ºC'),
	(315584, 143, '2015-01-15 00:25:35.000000', 'temperatura', 1073.0000, 'ºC'),
	(315585, 143, '2015-01-15 00:25:36.000000', 'temperatura', 712.0000, 'ºC'),
	(315586, 143, '2015-01-15 00:25:37.000000', 'temperatura', 342.0000, 'ºC'),
	(315587, 143, '2015-01-15 00:25:38.000000', 'temperatura', 776.0000, 'ºC'),
	(315588, 143, '2015-01-15 00:25:39.000000', 'temperatura', 456.0000, 'ºC'),
	(315589, 143, '2015-01-15 00:25:40.000000', 'temperatura', 1149.0000, 'ºC'),
	(315590, 143, '2015-01-15 00:25:41.000000', 'temperatura', 779.0000, 'ºC'),
	(315591, 143, '2015-01-15 00:25:42.000000', 'temperatura', 449.0000, 'ºC'),
	(315592, 143, '2015-01-15 00:25:43.000000', 'temperatura', 1107.0000, 'ºC'),
	(315593, 143, '2015-01-15 00:25:44.000000', 'temperatura', 591.0000, 'ºC'),
	(315594, 143, '2015-01-15 00:25:45.000000', 'temperatura', 832.0000, 'ºC'),
	(315595, 143, '2015-01-15 00:25:46.000000', 'temperatura', 1189.0000, 'ºC'),
	(315596, 143, '2015-01-15 00:25:47.000000', 'temperatura', 1051.0000, 'ºC'),
	(315597, 143, '2015-01-15 00:25:48.000000', 'temperatura', 488.0000, 'ºC'),
	(315598, 143, '2015-01-15 00:25:49.000000', 'temperatura', 486.0000, 'ºC'),
	(315599, 143, '2015-01-15 00:25:50.000000', 'temperatura', 969.0000, 'ºC'),
	(315600, 143, '2015-01-15 00:25:51.000000', 'temperatura', 987.0000, 'ºC'),
	(315601, 143, '2015-01-15 00:25:52.000000', 'temperatura', 828.0000, 'ºC'),
	(315602, 143, '2015-01-15 00:25:53.000000', 'temperatura', 1181.0000, 'ºC'),
	(315603, 143, '2015-01-15 00:25:54.000000', 'temperatura', 1020.0000, 'ºC'),
	(315604, 143, '2015-01-15 00:25:55.000000', 'temperatura', 358.0000, 'ºC'),
	(315605, 143, '2015-01-15 00:25:56.000000', 'temperatura', 1132.0000, 'ºC'),
	(315606, 143, '2015-01-15 00:25:57.000000', 'temperatura', 985.0000, 'ºC'),
	(315607, 143, '2015-01-15 00:25:58.000000', 'temperatura', 330.0000, 'ºC'),
	(315608, 143, '2015-01-15 00:25:59.000000', 'temperatura', 1096.0000, 'ºC'),
	(315609, 143, '2015-01-15 00:26:00.000000', 'temperatura', 890.0000, 'ºC'),
	(315610, 143, '2015-01-15 00:26:01.000000', 'temperatura', 1162.0000, 'ºC'),
	(315611, 143, '2015-01-15 00:26:02.000000', 'temperatura', 742.0000, 'ºC'),
	(315612, 143, '2015-01-15 00:26:03.000000', 'temperatura', 223.0000, 'ºC'),
	(315613, 143, '2015-01-15 00:26:04.000000', 'temperatura', 91.0000, 'ºC'),
	(315614, 143, '2015-01-15 00:26:05.000000', 'temperatura', 984.0000, 'ºC'),
	(315615, 143, '2015-01-15 00:26:06.000000', 'temperatura', 1050.0000, 'ºC'),
	(315616, 143, '2015-01-15 00:26:07.000000', 'temperatura', 1096.0000, 'ºC'),
	(315617, 143, '2015-01-15 00:26:08.000000', 'temperatura', 1133.0000, 'ºC'),
	(315618, 143, '2015-01-15 00:26:09.000000', 'temperatura', 1177.0000, 'ºC'),
	(315619, 143, '2015-01-15 00:26:10.000000', 'temperatura', 86.0000, 'ºC'),
	(315620, 143, '2015-01-15 00:26:11.000000', 'temperatura', 500.0000, 'ºC'),
	(315621, 143, '2015-01-15 00:26:12.000000', 'temperatura', 1040.0000, 'ºC'),
	(315622, 143, '2015-01-15 00:26:13.000000', 'temperatura', 103.0000, 'ºC'),
	(315623, 143, '2015-01-15 00:26:14.000000', 'temperatura', 995.0000, 'ºC'),
	(315624, 143, '2015-01-15 00:26:15.000000', 'temperatura', 1067.0000, 'ºC'),
	(315625, 143, '2015-01-15 00:26:16.000000', 'temperatura', 1150.0000, 'ºC'),
	(315626, 143, '2015-01-15 00:26:17.000000', 'temperatura', 148.0000, 'ºC'),
	(315627, 143, '2015-01-15 00:26:18.000000', 'temperatura', 892.0000, 'ºC'),
	(315628, 143, '2015-01-15 00:26:19.000000', 'temperatura', 417.0000, 'ºC'),
	(315629, 143, '2015-01-15 00:26:20.000000', 'temperatura', 609.0000, 'ºC'),
	(315630, 143, '2015-01-15 00:26:21.000000', 'temperatura', 593.0000, 'ºC'),
	(315631, 143, '2015-01-15 00:26:22.000000', 'temperatura', 1141.0000, 'ºC'),
	(315632, 143, '2015-01-15 00:26:23.000000', 'temperatura', 323.0000, 'ºC'),
	(315633, 143, '2015-01-15 00:26:24.000000', 'temperatura', 596.0000, 'ºC'),
	(315634, 143, '2015-01-15 00:26:25.000000', 'temperatura', 812.0000, 'ºC'),
	(315635, 143, '2015-01-15 00:26:26.000000', 'temperatura', 1069.0000, 'ºC'),
	(315636, 143, '2015-01-15 00:26:27.000000', 'temperatura', 512.0000, 'ºC'),
	(315637, 143, '2015-01-15 00:26:28.000000', 'temperatura', 552.0000, 'ºC'),
	(315638, 143, '2015-01-15 00:26:29.000000', 'temperatura', 26.0000, 'ºC'),
	(315639, 143, '2015-01-15 00:26:30.000000', 'temperatura', 875.0000, 'ºC'),
	(315640, 143, '2015-01-15 00:26:31.000000', 'temperatura', 699.0000, 'ºC'),
	(315641, 143, '2015-01-15 00:26:32.000000', 'temperatura', 868.0000, 'ºC'),
	(315642, 143, '2015-01-15 00:26:33.000000', 'temperatura', 1045.0000, 'ºC'),
	(315643, 143, '2015-01-15 00:26:34.000000', 'temperatura', 221.0000, 'ºC'),
	(315644, 143, '2015-01-15 00:26:35.000000', 'temperatura', 369.0000, 'ºC'),
	(315645, 143, '2015-01-15 00:26:36.000000', 'temperatura', 1184.0000, 'ºC'),
	(315646, 143, '2015-01-15 00:26:37.000000', 'temperatura', 15.0000, 'ºC'),
	(315647, 143, '2015-01-15 00:26:38.000000', 'temperatura', 120.0000, 'ºC'),
	(315648, 143, '2015-01-15 00:26:39.000000', 'temperatura', 559.0000, 'ºC'),
	(315649, 143, '2015-01-15 00:26:40.000000', 'temperatura', 35.0000, 'ºC'),
	(315650, 143, '2015-01-15 00:26:41.000000', 'temperatura', 897.0000, 'ºC'),
	(315651, 143, '2015-01-15 00:26:42.000000', 'temperatura', 779.0000, 'ºC'),
	(315652, 143, '2015-01-15 00:26:43.000000', 'temperatura', 7.0000, 'ºC'),
	(315653, 143, '2015-01-15 00:26:44.000000', 'temperatura', 98.0000, 'ºC'),
	(315654, 143, '2015-01-15 00:26:45.000000', 'temperatura', 468.0000, 'ºC'),
	(315655, 143, '2015-01-15 00:26:46.000000', 'temperatura', 849.0000, 'ºC'),
	(315656, 143, '2015-01-15 00:26:47.000000', 'temperatura', 439.0000, 'ºC'),
	(315657, 143, '2015-01-15 00:26:48.000000', 'temperatura', 847.0000, 'ºC'),
	(315658, 143, '2015-01-15 00:26:49.000000', 'temperatura', 522.0000, 'ºC'),
	(315659, 143, '2015-01-15 00:26:50.000000', 'temperatura', 67.0000, 'ºC'),
	(315660, 143, '2015-01-15 00:26:51.000000', 'temperatura', 1172.0000, 'ºC'),
	(315661, 143, '2015-01-15 00:26:52.000000', 'temperatura', 860.0000, 'ºC'),
	(315662, 143, '2015-01-15 00:26:53.000000', 'temperatura', 782.0000, 'ºC'),
	(315663, 143, '2015-01-15 00:26:54.000000', 'temperatura', 133.0000, 'ºC'),
	(315664, 143, '2015-01-15 00:26:55.000000', 'temperatura', 720.0000, 'ºC'),
	(315665, 143, '2015-01-15 00:26:56.000000', 'temperatura', 802.0000, 'ºC'),
	(315666, 143, '2015-01-15 00:26:57.000000', 'temperatura', 647.0000, 'ºC'),
	(315667, 143, '2015-01-15 00:26:58.000000', 'temperatura', 833.0000, 'ºC'),
	(315668, 143, '2015-01-15 00:26:59.000000', 'temperatura', 1023.0000, 'ºC'),
	(315669, 143, '2015-01-15 00:27:00.000000', 'temperatura', 215.0000, 'ºC'),
	(315670, 143, '2015-01-15 00:27:01.000000', 'temperatura', 407.0000, 'ºC'),
	(315671, 143, '2015-01-15 00:27:02.000000', 'temperatura', 191.0000, 'ºC'),
	(315672, 143, '2015-01-15 00:27:03.000000', 'temperatura', 936.0000, 'ºC'),
	(315673, 143, '2015-01-15 00:27:04.000000', 'temperatura', 505.0000, 'ºC'),
	(315674, 143, '2015-01-15 00:27:05.000000', 'temperatura', 918.0000, 'ºC'),
	(315675, 143, '2015-01-15 00:27:06.000000', 'temperatura', 675.0000, 'ºC'),
	(315676, 143, '2015-01-15 00:27:07.000000', 'temperatura', 622.0000, 'ºC'),
	(315677, 143, '2015-01-15 00:27:08.000000', 'temperatura', 1085.0000, 'ºC'),
	(315678, 143, '2015-01-15 00:27:09.000000', 'temperatura', 1159.0000, 'ºC'),
	(315679, 143, '2015-01-15 00:27:10.000000', 'temperatura', 142.0000, 'ºC'),
	(315680, 143, '2015-01-15 00:27:11.000000', 'temperatura', 833.0000, 'ºC'),
	(315681, 143, '2015-01-15 00:27:12.000000', 'temperatura', 140.0000, 'ºC'),
	(315682, 143, '2015-01-15 00:27:13.000000', 'temperatura', 602.0000, 'ºC'),
	(315683, 143, '2015-01-15 00:27:14.000000', 'temperatura', 191.0000, 'ºC'),
	(315684, 143, '2015-01-15 00:27:15.000000', 'temperatura', 349.0000, 'ºC'),
	(315685, 143, '2015-01-15 00:27:16.000000', 'temperatura', 1171.0000, 'ºC'),
	(315686, 143, '2015-01-15 00:27:17.000000', 'temperatura', 8.0000, 'ºC'),
	(315687, 143, '2015-01-15 00:27:18.000000', 'temperatura', 130.0000, 'ºC'),
	(315688, 143, '2015-01-15 00:27:19.000000', 'temperatura', 628.0000, 'ºC'),
	(315689, 143, '2015-01-15 00:27:20.000000', 'temperatura', 347.0000, 'ºC'),
	(315690, 143, '2015-01-15 00:27:21.000000', 'temperatura', 1051.0000, 'ºC'),
	(315691, 143, '2015-01-15 00:27:22.000000', 'temperatura', 617.0000, 'ºC'),
	(315692, 143, '2015-01-15 00:27:23.000000', 'temperatura', 1134.0000, 'ºC'),
	(315693, 143, '2015-01-15 00:27:24.000000', 'temperatura', 216.0000, 'ºC'),
	(315694, 143, '2015-01-15 00:27:25.000000', 'temperatura', 79.0000, 'ºC'),
	(315695, 143, '2015-01-15 00:27:26.000000', 'temperatura', 947.0000, 'ºC'),
	(315696, 143, '2015-01-15 00:27:27.000000', 'temperatura', 900.0000, 'ºC'),
	(315697, 143, '2015-01-15 00:27:28.000000', 'temperatura', 458.0000, 'ºC'),
	(315698, 143, '2015-01-15 00:27:29.000000', 'temperatura', 791.0000, 'ºC'),
	(315699, 143, '2015-01-15 00:27:30.000000', 'temperatura', 183.0000, 'ºC'),
	(315700, 143, '2015-01-15 00:27:31.000000', 'temperatura', 940.0000, 'ºC'),
	(315701, 143, '2015-01-15 00:27:32.000000', 'temperatura', 552.0000, 'ºC'),
	(315702, 143, '2015-01-15 00:27:33.000000', 'temperatura', 1142.0000, 'ºC'),
	(315703, 143, '2015-01-15 00:27:34.000000', 'temperatura', 453.0000, 'ºC'),
	(315704, 143, '2015-01-15 00:27:35.000000', 'temperatura', 39.0000, 'ºC'),
	(315705, 143, '2015-01-15 00:27:36.000000', 'temperatura', 36.0000, 'ºC'),
	(315706, 143, '2015-01-15 00:27:37.000000', 'temperatura', 64.0000, 'ºC'),
	(315707, 143, '2015-01-15 00:27:38.000000', 'temperatura', 214.0000, 'ºC'),
	(315708, 143, '2015-01-15 00:27:39.000000', 'temperatura', 876.0000, 'ºC'),
	(315709, 143, '2015-01-15 00:27:40.000000', 'temperatura', 141.0000, 'ºC'),
	(315710, 143, '2015-01-15 00:27:41.000000', 'temperatura', 478.0000, 'ºC'),
	(315711, 143, '2015-01-15 00:27:42.000000', 'temperatura', 765.0000, 'ºC'),
	(315712, 143, '2015-01-15 00:27:43.000000', 'temperatura', 1194.0000, 'ºC'),
	(315713, 143, '2015-01-15 00:27:44.000000', 'temperatura', 75.0000, 'ºC'),
	(315714, 143, '2015-01-15 00:27:45.000000', 'temperatura', 394.0000, 'ºC'),
	(315715, 143, '2015-01-15 00:27:46.000000', 'temperatura', 545.0000, 'ºC'),
	(315716, 143, '2015-01-15 00:27:47.000000', 'temperatura', 345.0000, 'ºC'),
	(315717, 143, '2015-01-15 00:27:48.000000', 'temperatura', 88.0000, 'ºC'),
	(315718, 143, '2015-01-15 00:27:49.000000', 'temperatura', 607.0000, 'ºC'),
	(315719, 143, '2015-01-15 00:27:50.000000', 'temperatura', 370.0000, 'ºC'),
	(315720, 143, '2015-01-15 00:27:51.000000', 'temperatura', 32.0000, 'ºC'),
	(315721, 143, '2015-01-15 00:27:52.000000', 'temperatura', 249.0000, 'ºC'),
	(315722, 143, '2015-01-15 00:27:53.000000', 'temperatura', 1151.0000, 'ºC'),
	(315723, 143, '2015-01-15 00:27:54.000000', 'temperatura', 210.0000, 'ºC'),
	(315724, 143, '2015-01-15 00:27:55.000000', 'temperatura', 1194.0000, 'ºC'),
	(315725, 143, '2015-01-15 00:27:56.000000', 'temperatura', 543.0000, 'ºC'),
	(315726, 143, '2015-01-15 00:27:57.000000', 'temperatura', 331.0000, 'ºC'),
	(315727, 143, '2015-01-15 00:27:58.000000', 'temperatura', 27.0000, 'ºC'),
	(315728, 143, '2015-01-15 00:27:59.000000', 'temperatura', 343.0000, 'ºC'),
	(315729, 143, '2015-01-15 00:28:00.000000', 'temperatura', 434.0000, 'ºC'),
	(315730, 143, '2015-01-15 00:28:01.000000', 'temperatura', 1143.0000, 'ºC'),
	(315731, 143, '2015-01-15 00:28:02.000000', 'temperatura', 811.0000, 'ºC'),
	(315732, 143, '2015-01-15 00:28:03.000000', 'temperatura', 627.0000, 'ºC'),
	(315733, 143, '2015-01-15 00:28:04.000000', 'temperatura', 703.0000, 'ºC'),
	(315734, 143, '2015-01-15 00:28:05.000000', 'temperatura', 435.0000, 'ºC'),
	(315735, 143, '2015-01-15 00:28:06.000000', 'temperatura', 67.0000, 'ºC'),
	(315736, 143, '2015-01-15 00:28:07.000000', 'temperatura', 228.0000, 'ºC'),
	(315737, 143, '2015-01-15 00:28:08.000000', 'temperatura', 940.0000, 'ºC'),
	(315738, 143, '2015-01-15 00:28:09.000000', 'temperatura', 418.0000, 'ºC'),
	(315739, 143, '2015-01-15 00:28:10.000000', 'temperatura', 471.0000, 'ºC'),
	(315740, 143, '2015-01-15 00:28:11.000000', 'temperatura', 1103.0000, 'ºC'),
	(315741, 143, '2015-01-15 00:28:12.000000', 'temperatura', 499.0000, 'ºC'),
	(315742, 143, '2015-01-15 00:28:13.000000', 'temperatura', 389.0000, 'ºC'),
	(315743, 143, '2015-01-15 00:28:14.000000', 'temperatura', 446.0000, 'ºC'),
	(315744, 143, '2015-01-15 00:28:15.000000', 'temperatura', 1065.0000, 'ºC'),
	(315745, 143, '2015-01-15 00:28:16.000000', 'temperatura', 388.0000, 'ºC'),
	(315746, 143, '2015-01-15 00:28:17.000000', 'temperatura', 1145.0000, 'ºC'),
	(315747, 143, '2015-01-15 00:28:18.000000', 'temperatura', 961.0000, 'ºC'),
	(315748, 143, '2015-01-15 00:28:19.000000', 'temperatura', 171.0000, 'ºC'),
	(315749, 143, '2015-01-15 00:28:20.000000', 'temperatura', 371.0000, 'ºC'),
	(315750, 143, '2015-01-15 00:28:21.000000', 'temperatura', 142.0000, 'ºC'),
	(315751, 143, '2015-01-15 00:28:22.000000', 'temperatura', 799.0000, 'ºC'),
	(315752, 143, '2015-01-15 00:28:23.000000', 'temperatura', 1169.0000, 'ºC'),
	(315753, 143, '2015-01-15 00:28:24.000000', 'temperatura', 1047.0000, 'ºC'),
	(315754, 143, '2015-01-15 00:28:25.000000', 'temperatura', 528.0000, 'ºC'),
	(315755, 143, '2015-01-15 00:28:26.000000', 'temperatura', 702.0000, 'ºC'),
	(315756, 143, '2015-01-15 00:28:27.000000', 'temperatura', 725.0000, 'ºC'),
	(315757, 143, '2015-01-15 00:28:28.000000', 'temperatura', 321.0000, 'ºC'),
	(315758, 143, '2015-01-15 00:28:29.000000', 'temperatura', 628.0000, 'ºC'),
	(315759, 143, '2015-01-15 00:28:30.000000', 'temperatura', 977.0000, 'ºC'),
	(315760, 143, '2015-01-15 00:28:31.000000', 'temperatura', 604.0000, 'ºC'),
	(315761, 143, '2015-01-15 00:28:32.000000', 'temperatura', 88.0000, 'ºC'),
	(315762, 143, '2015-01-15 00:28:33.000000', 'temperatura', 1029.0000, 'ºC'),
	(315763, 143, '2015-01-15 00:28:34.000000', 'temperatura', 82.0000, 'ºC'),
	(315764, 143, '2015-01-15 00:28:35.000000', 'temperatura', 923.0000, 'ºC'),
	(315765, 143, '2015-01-15 00:28:36.000000', 'temperatura', 768.0000, 'ºC'),
	(315766, 143, '2015-01-15 00:28:37.000000', 'temperatura', 1073.0000, 'ºC'),
	(315767, 143, '2015-01-15 00:28:38.000000', 'temperatura', 663.0000, 'ºC'),
	(315768, 143, '2015-01-15 00:28:39.000000', 'temperatura', 95.0000, 'ºC'),
	(315769, 143, '2015-01-15 00:28:40.000000', 'temperatura', 887.0000, 'ºC'),
	(315770, 143, '2015-01-15 00:28:41.000000', 'temperatura', 550.0000, 'ºC'),
	(315771, 143, '2015-01-15 00:28:42.000000', 'temperatura', 90.0000, 'ºC'),
	(315772, 143, '2015-01-15 00:28:43.000000', 'temperatura', 1.0000, 'ºC'),
	(315773, 143, '2015-01-15 00:28:44.000000', 'temperatura', 935.0000, 'ºC'),
	(315774, 143, '2015-01-15 00:28:45.000000', 'temperatura', 1073.0000, 'ºC'),
	(315775, 143, '2015-01-15 00:28:46.000000', 'temperatura', 159.0000, 'ºC'),
	(315776, 143, '2015-01-15 00:28:47.000000', 'temperatura', 1179.0000, 'ºC'),
	(315777, 143, '2015-01-15 00:28:48.000000', 'temperatura', 618.0000, 'ºC'),
	(315778, 143, '2015-01-15 00:28:49.000000', 'temperatura', 754.0000, 'ºC'),
	(315779, 143, '2015-01-15 00:28:50.000000', 'temperatura', 714.0000, 'ºC'),
	(315780, 143, '2015-01-15 00:28:51.000000', 'temperatura', 110.0000, 'ºC'),
	(315781, 143, '2015-01-15 00:28:52.000000', 'temperatura', 807.0000, 'ºC'),
	(315782, 143, '2015-01-15 00:28:53.000000', 'temperatura', 107.0000, 'ºC'),
	(315783, 143, '2015-01-15 00:28:54.000000', 'temperatura', 513.0000, 'ºC'),
	(315784, 143, '2015-01-15 00:28:55.000000', 'temperatura', 1047.0000, 'ºC'),
	(315785, 143, '2015-01-15 00:28:56.000000', 'temperatura', 97.0000, 'ºC'),
	(315786, 143, '2015-01-15 00:28:57.000000', 'temperatura', 942.0000, 'ºC'),
	(315787, 143, '2015-01-15 00:28:58.000000', 'temperatura', 821.0000, 'ºC'),
	(315788, 143, '2015-01-15 00:28:59.000000', 'temperatura', 81.0000, 'ºC'),
	(315789, 143, '2015-01-15 00:29:00.000000', 'temperatura', 341.0000, 'ºC'),
	(315790, 143, '2015-01-15 00:29:01.000000', 'temperatura', 261.0000, 'ºC'),
	(315791, 143, '2015-01-15 00:29:02.000000', 'temperatura', 285.0000, 'ºC'),
	(315792, 143, '2015-01-15 00:29:03.000000', 'temperatura', 640.0000, 'ºC'),
	(315793, 143, '2015-01-15 00:29:04.000000', 'temperatura', 1145.0000, 'ºC'),
	(315794, 143, '2015-01-15 00:29:05.000000', 'temperatura', 209.0000, 'ºC'),
	(315795, 143, '2015-01-15 00:29:06.000000', 'temperatura', 7.0000, 'ºC'),
	(315796, 143, '2015-01-15 00:29:07.000000', 'temperatura', 611.0000, 'ºC'),
	(315797, 143, '2015-01-15 00:29:08.000000', 'temperatura', 634.0000, 'ºC'),
	(315798, 143, '2015-01-15 00:29:09.000000', 'temperatura', 138.0000, 'ºC'),
	(315799, 143, '2015-01-15 00:29:10.000000', 'temperatura', 1188.0000, 'ºC'),
	(315800, 143, '2015-01-15 00:29:11.000000', 'temperatura', 725.0000, 'ºC'),
	(315801, 143, '2015-01-15 00:29:12.000000', 'temperatura', 64.0000, 'ºC'),
	(315802, 143, '2015-01-15 00:29:13.000000', 'temperatura', 547.0000, 'ºC'),
	(315803, 143, '2015-01-15 00:29:14.000000', 'temperatura', 140.0000, 'ºC'),
	(315804, 143, '2015-01-15 00:29:15.000000', 'temperatura', 260.0000, 'ºC'),
	(315805, 143, '2015-01-15 00:29:16.000000', 'temperatura', 880.0000, 'ºC'),
	(315806, 143, '2015-01-15 00:29:17.000000', 'temperatura', 23.0000, 'ºC'),
	(315807, 143, '2015-01-15 00:29:18.000000', 'temperatura', 1075.0000, 'ºC'),
	(315808, 143, '2015-01-15 00:29:19.000000', 'temperatura', 504.0000, 'ºC'),
	(315809, 143, '2015-01-15 00:29:20.000000', 'temperatura', 497.0000, 'ºC'),
	(315810, 143, '2015-01-15 00:29:21.000000', 'temperatura', 972.0000, 'ºC'),
	(315811, 143, '2015-01-15 00:29:22.000000', 'temperatura', 972.0000, 'ºC'),
	(315812, 143, '2015-01-15 00:29:23.000000', 'temperatura', 745.0000, 'ºC'),
	(315813, 143, '2015-01-15 00:29:24.000000', 'temperatura', 809.0000, 'ºC'),
	(315814, 143, '2015-01-15 00:29:25.000000', 'temperatura', 609.0000, 'ºC'),
	(315815, 143, '2015-01-15 00:29:26.000000', 'temperatura', 618.0000, 'ºC'),
	(315816, 143, '2015-01-15 00:29:27.000000', 'temperatura', 64.0000, 'ºC'),
	(315817, 143, '2015-01-15 00:29:28.000000', 'temperatura', 865.0000, 'ºC'),
	(315818, 143, '2015-01-15 00:29:29.000000', 'temperatura', 534.0000, 'ºC'),
	(315819, 143, '2015-01-15 00:29:30.000000', 'temperatura', 74.0000, 'ºC'),
	(315820, 143, '2015-01-15 00:29:31.000000', 'temperatura', 1170.0000, 'ºC'),
	(315821, 143, '2015-01-15 00:29:32.000000', 'temperatura', 829.0000, 'ºC'),
	(315822, 143, '2015-01-15 00:29:33.000000', 'temperatura', 634.0000, 'ºC'),
	(315823, 143, '2015-01-15 00:29:34.000000', 'temperatura', 683.0000, 'ºC'),
	(315824, 143, '2015-01-15 00:29:35.000000', 'temperatura', 313.0000, 'ºC'),
	(315825, 143, '2015-01-15 00:29:36.000000', 'temperatura', 717.0000, 'ºC'),
	(315826, 143, '2015-01-15 00:29:37.000000', 'temperatura', 245.0000, 'ºC'),
	(315827, 143, '2015-01-15 00:29:38.000000', 'temperatura', 275.0000, 'ºC'),
	(315828, 143, '2015-01-15 00:29:39.000000', 'temperatura', 641.0000, 'ºC'),
	(315829, 143, '2015-01-15 00:29:40.000000', 'temperatura', 1180.0000, 'ºC'),
	(315830, 143, '2015-01-15 00:29:41.000000', 'temperatura', 379.0000, 'ºC'),
	(315831, 143, '2015-01-15 00:29:42.000000', 'temperatura', 755.0000, 'ºC'),
	(315832, 143, '2015-01-15 00:29:43.000000', 'temperatura', 240.0000, 'ºC'),
	(315833, 143, '2015-01-15 00:29:44.000000', 'temperatura', 134.0000, 'ºC'),
	(315834, 143, '2015-01-15 00:29:45.000000', 'temperatura', 1150.0000, 'ºC'),
	(315835, 143, '2015-01-15 00:29:46.000000', 'temperatura', 547.0000, 'ºC'),
	(315836, 143, '2015-01-15 00:29:47.000000', 'temperatura', 486.0000, 'ºC'),
	(315837, 143, '2015-01-15 00:29:48.000000', 'temperatura', 792.0000, 'ºC'),
	(315838, 143, '2015-01-15 00:29:49.000000', 'temperatura', 100.0000, 'ºC'),
	(315839, 143, '2015-01-15 00:29:50.000000', 'temperatura', 526.0000, 'ºC'),
	(315840, 143, '2015-01-15 00:29:51.000000', 'temperatura', 1129.0000, 'ºC'),
	(315841, 143, '2015-01-15 00:29:52.000000', 'temperatura', 467.0000, 'ºC'),
	(315842, 143, '2015-01-15 00:29:53.000000', 'temperatura', 149.0000, 'ºC'),
	(315843, 143, '2015-01-15 00:29:54.000000', 'temperatura', 544.0000, 'ºC'),
	(315844, 143, '2015-01-15 00:29:55.000000', 'temperatura', 1073.0000, 'ºC'),
	(315845, 143, '2015-01-15 00:29:56.000000', 'temperatura', 133.0000, 'ºC'),
	(315846, 143, '2015-01-15 00:29:57.000000', 'temperatura', 1049.0000, 'ºC'),
	(315847, 143, '2015-01-15 00:29:58.000000', 'temperatura', 44.0000, 'ºC'),
	(315848, 143, '2015-01-15 00:29:59.000000', 'temperatura', 676.0000, 'ºC'),
	(315849, 143, '2015-01-15 00:30:00.000000', 'temperatura', 847.0000, 'ºC'),
	(315850, 143, '2015-01-15 00:30:01.000000', 'temperatura', 1006.0000, 'ºC'),
	(315851, 143, '2015-01-15 00:30:02.000000', 'temperatura', 90.0000, 'ºC'),
	(315852, 143, '2015-01-15 00:30:03.000000', 'temperatura', 1032.0000, 'ºC'),
	(315853, 143, '2015-01-15 00:30:04.000000', 'temperatura', 91.0000, 'ºC'),
	(315854, 143, '2015-01-15 00:30:05.000000', 'temperatura', 961.0000, 'ºC'),
	(315855, 143, '2015-01-15 00:30:06.000000', 'temperatura', 932.0000, 'ºC'),
	(315856, 143, '2015-01-15 00:30:07.000000', 'temperatura', 575.0000, 'ºC'),
	(315857, 143, '2015-01-15 00:30:08.000000', 'temperatura', 82.0000, 'ºC'),
	(315858, 143, '2015-01-15 00:30:09.000000', 'temperatura', 1085.0000, 'ºC'),
	(315859, 143, '2015-01-15 00:30:10.000000', 'temperatura', 381.0000, 'ºC'),
	(315860, 143, '2015-01-15 00:30:11.000000', 'temperatura', 1049.0000, 'ºC'),
	(315861, 143, '2015-01-15 00:30:12.000000', 'temperatura', 502.0000, 'ºC'),
	(315862, 143, '2015-01-15 00:30:13.000000', 'temperatura', 565.0000, 'ºC'),
	(315863, 143, '2015-01-15 00:30:14.000000', 'temperatura', 117.0000, 'ºC'),
	(315864, 143, '2015-01-15 00:30:15.000000', 'temperatura', 92.0000, 'ºC'),
	(315865, 143, '2015-01-15 00:30:16.000000', 'temperatura', 110.0000, 'ºC'),
	(315866, 143, '2015-01-15 00:30:17.000000', 'temperatura', 273.0000, 'ºC'),
	(315867, 143, '2015-01-15 00:30:18.000000', 'temperatura', 1034.0000, 'ºC'),
	(315868, 143, '2015-01-15 00:30:19.000000', 'temperatura', 755.0000, 'ºC'),
	(315869, 143, '2015-01-15 00:30:20.000000', 'temperatura', 671.0000, 'ºC'),
	(315870, 143, '2015-01-15 00:30:21.000000', 'temperatura', 1090.0000, 'ºC'),
	(315871, 143, '2015-01-15 00:30:22.000000', 'temperatura', 1037.0000, 'ºC'),
	(315872, 143, '2015-01-15 00:30:23.000000', 'temperatura', 715.0000, 'ºC'),
	(315873, 143, '2015-01-15 00:30:24.000000', 'temperatura', 467.0000, 'ºC'),
	(315874, 143, '2015-01-15 00:30:25.000000', 'temperatura', 190.0000, 'ºC'),
	(315875, 143, '2015-01-15 00:30:26.000000', 'temperatura', 751.0000, 'ºC'),
	(315876, 143, '2015-01-15 00:30:27.000000', 'temperatura', 782.0000, 'ºC'),
	(315877, 143, '2015-01-15 00:30:28.000000', 'temperatura', 461.0000, 'ºC'),
	(315878, 143, '2015-01-15 00:30:29.000000', 'temperatura', 1158.0000, 'ºC'),
	(315879, 143, '2015-01-15 00:30:30.000000', 'temperatura', 807.0000, 'ºC'),
	(315880, 143, '2015-01-15 00:30:31.000000', 'temperatura', 561.0000, 'ºC'),
	(315881, 143, '2015-01-15 00:30:32.000000', 'temperatura', 383.0000, 'ºC'),
	(315882, 143, '2015-01-15 00:30:33.000000', 'temperatura', 235.0000, 'ºC'),
	(315883, 143, '2015-01-15 00:30:34.000000', 'temperatura', 25.0000, 'ºC'),
	(315884, 143, '2015-01-15 00:30:35.000000', 'temperatura', 620.0000, 'ºC'),
	(315885, 143, '2015-01-15 00:30:36.000000', 'temperatura', 627.0000, 'ºC'),
	(315886, 143, '2015-01-15 00:30:37.000000', 'temperatura', 74.0000, 'ºC'),
	(315887, 143, '2015-01-15 00:30:38.000000', 'temperatura', 889.0000, 'ºC'),
	(315888, 143, '2015-01-15 00:30:39.000000', 'temperatura', 626.0000, 'ºC'),
	(315889, 143, '2015-01-15 00:30:40.000000', 'temperatura', 460.0000, 'ºC'),
	(315890, 143, '2015-01-15 00:30:41.000000', 'temperatura', 425.0000, 'ºC'),
	(315891, 143, '2015-01-15 00:30:42.000000', 'temperatura', 746.0000, 'ºC'),
	(315892, 143, '2015-01-15 00:30:43.000000', 'temperatura', 55.0000, 'ºC'),
	(315893, 143, '2015-01-15 00:30:44.000000', 'temperatura', 437.0000, 'ºC'),
	(315894, 143, '2015-01-15 00:30:45.000000', 'temperatura', 819.0000, 'ºC'),
	(315895, 143, '2015-01-15 00:30:46.000000', 'temperatura', 386.0000, 'ºC'),
	(315896, 143, '2015-01-15 00:30:47.000000', 'temperatura', 674.0000, 'ºC'),
	(315897, 143, '2015-01-15 00:30:48.000000', 'temperatura', 1014.0000, 'ºC'),
	(315898, 143, '2015-01-15 00:30:49.000000', 'temperatura', 647.0000, 'ºC'),
	(315899, 143, '2015-01-15 00:30:50.000000', 'temperatura', 195.0000, 'ºC'),
	(315900, 143, '2015-01-15 00:30:51.000000', 'temperatura', 234.0000, 'ºC'),
	(315901, 143, '2015-01-15 00:30:52.000000', 'temperatura', 585.0000, 'ºC'),
	(315902, 143, '2015-01-15 00:30:53.000000', 'temperatura', 1024.0000, 'ºC'),
	(315903, 143, '2015-01-15 00:30:54.000000', 'temperatura', 965.0000, 'ºC'),
	(315904, 143, '2015-01-15 00:30:55.000000', 'temperatura', 555.0000, 'ºC'),
	(315905, 143, '2015-01-15 00:30:56.000000', 'temperatura', 1081.0000, 'ºC'),
	(315906, 143, '2015-01-15 00:30:57.000000', 'temperatura', 138.0000, 'ºC'),
	(315907, 143, '2015-01-15 00:30:58.000000', 'temperatura', 1048.0000, 'ºC'),
	(315908, 143, '2015-01-15 00:30:59.000000', 'temperatura', 26.0000, 'ºC'),
	(315909, 143, '2015-01-15 00:31:00.000000', 'temperatura', 589.0000, 'ºC'),
	(315910, 143, '2015-01-15 00:31:01.000000', 'temperatura', 466.0000, 'ºC'),
	(315911, 143, '2015-01-15 00:31:02.000000', 'temperatura', 562.0000, 'ºC'),
	(315912, 143, '2015-01-15 00:31:03.000000', 'temperatura', 216.0000, 'ºC'),
	(315913, 143, '2015-01-15 00:31:04.000000', 'temperatura', 591.0000, 'ºC'),
	(315914, 143, '2015-01-15 00:31:05.000000', 'temperatura', 1109.0000, 'ºC'),
	(315915, 143, '2015-01-15 00:31:06.000000', 'temperatura', 173.0000, 'ºC'),
	(315916, 143, '2015-01-15 00:31:07.000000', 'temperatura', 1137.0000, 'ºC'),
	(315917, 143, '2015-01-15 00:31:08.000000', 'temperatura', 366.0000, 'ºC'),
	(315918, 143, '2015-01-15 00:31:09.000000', 'temperatura', 820.0000, 'ºC'),
	(315919, 143, '2015-01-15 00:31:10.000000', 'temperatura', 604.0000, 'ºC'),
	(315920, 143, '2015-01-15 00:31:11.000000', 'temperatura', 558.0000, 'ºC'),
	(315921, 143, '2015-01-15 00:31:12.000000', 'temperatura', 981.0000, 'ºC'),
	(315922, 143, '2015-01-15 00:31:13.000000', 'temperatura', 830.0000, 'ºC'),
	(315923, 143, '2015-01-15 00:31:14.000000', 'temperatura', 8.0000, 'ºC'),
	(315924, 143, '2015-01-15 00:31:15.000000', 'temperatura', 1150.0000, 'ºC'),
	(315925, 143, '2015-01-15 00:31:16.000000', 'temperatura', 926.0000, 'ºC'),
	(315926, 143, '2015-01-15 00:31:17.000000', 'temperatura', 1181.0000, 'ºC'),
	(315927, 143, '2015-01-15 00:31:18.000000', 'temperatura', 728.0000, 'ºC'),
	(315928, 143, '2015-01-15 00:31:19.000000', 'temperatura', 96.0000, 'ºC'),
	(315929, 143, '2015-01-15 00:31:20.000000', 'temperatura', 699.0000, 'ºC'),
	(315930, 143, '2015-01-15 00:31:21.000000', 'temperatura', 807.0000, 'ºC'),
	(315931, 143, '2015-01-15 00:31:22.000000', 'temperatura', 740.0000, 'ºC'),
	(315932, 143, '2015-01-15 00:31:23.000000', 'temperatura', 78.0000, 'ºC'),
	(315933, 143, '2015-01-15 00:31:24.000000', 'temperatura', 572.0000, 'ºC'),
	(315934, 143, '2015-01-15 00:31:25.000000', 'temperatura', 224.0000, 'ºC'),
	(315935, 143, '2015-01-15 00:31:26.000000', 'temperatura', 606.0000, 'ºC'),
	(315936, 143, '2015-01-15 00:31:27.000000', 'temperatura', 1157.0000, 'ºC'),
	(315937, 143, '2015-01-15 00:31:28.000000', 'temperatura', 367.0000, 'ºC'),
	(315938, 143, '2015-01-15 00:31:29.000000', 'temperatura', 767.0000, 'ºC'),
	(315939, 143, '2015-01-15 00:31:30.000000', 'temperatura', 334.0000, 'ºC'),
	(315940, 143, '2015-01-15 00:31:31.000000', 'temperatura', 569.0000, 'ºC'),
	(315941, 143, '2015-01-15 00:31:32.000000', 'temperatura', 643.0000, 'ºC'),
	(315942, 143, '2015-01-15 00:31:33.000000', 'temperatura', 310.0000, 'ºC'),
	(315943, 143, '2015-01-15 00:31:34.000000', 'temperatura', 822.0000, 'ºC'),
	(315944, 143, '2015-01-15 00:31:35.000000', 'temperatura', 780.0000, 'ºC'),
	(315945, 143, '2015-01-15 00:31:36.000000', 'temperatura', 235.0000, 'ºC'),
	(315946, 143, '2015-01-15 00:31:37.000000', 'temperatura', 33.0000, 'ºC'),
	(315947, 143, '2015-01-15 00:31:38.000000', 'temperatura', 663.0000, 'ºC'),
	(315948, 143, '2015-01-15 00:31:39.000000', 'temperatura', 815.0000, 'ºC'),
	(315949, 143, '2015-01-15 00:31:40.000000', 'temperatura', 887.0000, 'ºC'),
	(315950, 143, '2015-01-15 00:31:41.000000', 'temperatura', 792.0000, 'ºC'),
	(315951, 143, '2015-01-15 00:31:42.000000', 'temperatura', 100.0000, 'ºC'),
	(315952, 143, '2015-01-15 00:31:43.000000', 'temperatura', 525.0000, 'ºC'),
	(315953, 143, '2015-01-15 00:31:44.000000', 'temperatura', 1123.0000, 'ºC'),
	(315954, 143, '2015-01-15 00:31:45.000000', 'temperatura', 441.0000, 'ºC'),
	(315955, 143, '2015-01-15 00:31:46.000000', 'temperatura', 36.0000, 'ºC'),
	(315956, 143, '2015-01-15 00:31:47.000000', 'temperatura', 58.0000, 'ºC'),
	(315957, 143, '2015-01-15 00:31:48.000000', 'temperatura', 182.0000, 'ºC'),
	(315958, 143, '2015-01-15 00:31:49.000000', 'temperatura', 736.0000, 'ºC'),
	(315959, 143, '2015-01-15 00:31:50.000000', 'temperatura', 736.0000, 'ºC'),
	(315960, 143, '2015-01-15 00:31:51.000000', 'temperatura', 272.0000, 'ºC'),
	(315961, 143, '2015-01-15 00:31:52.000000', 'temperatura', 354.0000, 'ºC'),
	(315962, 143, '2015-01-15 00:31:53.000000', 'temperatura', 953.0000, 'ºC'),
	(315963, 143, '2015-01-15 00:31:54.000000', 'temperatura', 103.0000, 'ºC'),
	(315964, 143, '2015-01-15 00:31:55.000000', 'temperatura', 57.0000, 'ºC'),
	(315965, 143, '2015-01-15 00:31:56.000000', 'temperatura', 1175.0000, 'ºC'),
	(315966, 143, '2015-01-15 00:31:57.000000', 'temperatura', 905.0000, 'ºC'),
	(315967, 143, '2015-01-15 00:31:58.000000', 'temperatura', 1001.0000, 'ºC'),
	(315968, 143, '2015-01-15 00:31:59.000000', 'temperatura', 1092.0000, 'ºC'),
	(315969, 143, '2015-01-15 00:32:00.000000', 'temperatura', 55.0000, 'ºC'),
	(315970, 143, '2015-01-15 00:32:01.000000', 'temperatura', 600.0000, 'ºC'),
	(315971, 143, '2015-01-15 00:32:02.000000', 'temperatura', 436.0000, 'ºC'),
	(315972, 143, '2015-01-15 00:32:03.000000', 'temperatura', 382.0000, 'ºC'),
	(315973, 143, '2015-01-15 00:32:04.000000', 'temperatura', 603.0000, 'ºC'),
	(315974, 143, '2015-01-15 00:32:05.000000', 'temperatura', 668.0000, 'ºC'),
	(315975, 143, '2015-01-15 00:32:06.000000', 'temperatura', 330.0000, 'ºC'),
	(315976, 143, '2015-01-15 00:32:07.000000', 'temperatura', 847.0000, 'ºC'),
	(315977, 143, '2015-01-15 00:32:08.000000', 'temperatura', 847.0000, 'ºC'),
	(315978, 143, '2015-01-15 00:32:09.000000', 'temperatura', 494.0000, 'ºC'),
	(315979, 143, '2015-01-15 00:32:10.000000', 'temperatura', 1128.0000, 'ºC'),
	(315980, 143, '2015-01-15 00:32:11.000000', 'temperatura', 559.0000, 'ºC'),
	(315981, 143, '2015-01-15 00:32:12.000000', 'temperatura', 612.0000, 'ºC'),
	(315982, 143, '2015-01-15 00:32:13.000000', 'temperatura', 183.0000, 'ºC'),
	(315983, 143, '2015-01-15 00:32:14.000000', 'temperatura', 279.0000, 'ºC'),
	(315984, 143, '2015-01-15 00:32:15.000000', 'temperatura', 848.0000, 'ºC'),
	(315985, 143, '2015-01-15 00:32:16.000000', 'temperatura', 1002.0000, 'ºC'),
	(315986, 143, '2015-01-15 00:32:17.000000', 'temperatura', 66.0000, 'ºC'),
	(315987, 143, '2015-01-15 00:32:18.000000', 'temperatura', 924.0000, 'ºC'),
	(315988, 143, '2015-01-15 00:32:19.000000', 'temperatura', 824.0000, 'ºC'),
	(315989, 143, '2015-01-15 00:32:20.000000', 'temperatura', 146.0000, 'ºC'),
	(315990, 143, '2015-01-15 00:32:21.000000', 'temperatura', 661.0000, 'ºC'),
	(315991, 143, '2015-01-15 00:32:22.000000', 'temperatura', 468.0000, 'ºC'),
	(315992, 143, '2015-01-15 00:32:23.000000', 'temperatura', 355.0000, 'ºC'),
	(315993, 143, '2015-01-15 00:32:24.000000', 'temperatura', 373.0000, 'ºC'),
	(315994, 143, '2015-01-15 00:32:25.000000', 'temperatura', 798.0000, 'ºC'),
	(315995, 143, '2015-01-15 00:32:26.000000', 'temperatura', 474.0000, 'ºC'),
	(315996, 143, '2015-01-15 00:32:27.000000', 'temperatura', 1174.0000, 'ºC'),
	(315997, 143, '2015-01-15 00:32:28.000000', 'temperatura', 850.0000, 'ºC'),
	(315998, 143, '2015-01-15 00:32:29.000000', 'temperatura', 729.0000, 'ºC'),
	(315999, 143, '2015-01-15 00:32:30.000000', 'temperatura', 1096.0000, 'ºC'),
	(316000, 143, '2015-01-15 00:32:31.000000', 'temperatura', 893.0000, 'ºC'),
	(316001, 143, '2015-01-15 00:32:32.000000', 'temperatura', 1175.0000, 'ºC'),
	(316002, 143, '2015-01-15 00:32:33.000000', 'temperatura', 800.0000, 'ºC'),
	(316003, 143, '2015-01-15 00:32:34.000000', 'temperatura', 473.0000, 'ºC'),
	(316004, 143, '2015-01-15 00:32:35.000000', 'temperatura', 1168.0000, 'ºC'),
	(316005, 143, '2015-01-15 00:32:36.000000', 'temperatura', 821.0000, 'ºC'),
	(316006, 143, '2015-01-15 00:32:37.000000', 'temperatura', 602.0000, 'ºC'),
	(316007, 143, '2015-01-15 00:32:38.000000', 'temperatura', 549.0000, 'ºC'),
	(316008, 143, '2015-01-15 00:32:39.000000', 'temperatura', 938.0000, 'ºC'),
	(316009, 143, '2015-01-15 00:32:40.000000', 'temperatura', 643.0000, 'ºC'),
	(316010, 143, '2015-01-15 00:32:41.000000', 'temperatura', 400.0000, 'ºC'),
	(316011, 143, '2015-01-15 00:32:42.000000', 'temperatura', 72.0000, 'ºC'),
	(316012, 143, '2015-01-15 00:32:43.000000', 'temperatura', 362.0000, 'ºC'),
	(316013, 143, '2015-01-15 00:32:44.000000', 'temperatura', 393.0000, 'ºC'),
	(316014, 143, '2015-01-15 00:32:45.000000', 'temperatura', 879.0000, 'ºC'),
	(316015, 143, '2015-01-15 00:32:46.000000', 'temperatura', 817.0000, 'ºC'),
	(316016, 143, '2015-01-15 00:32:47.000000', 'temperatura', 247.0000, 'ºC'),
	(316017, 143, '2015-01-15 00:32:48.000000', 'temperatura', 1187.0000, 'ºC'),
	(316018, 143, '2015-01-15 00:32:49.000000', 'temperatura', 392.0000, 'ºC'),
	(316019, 143, '2015-01-15 00:32:50.000000', 'temperatura', 802.0000, 'ºC'),
	(316020, 143, '2015-01-15 00:32:51.000000', 'temperatura', 436.0000, 'ºC'),
	(316021, 143, '2015-01-15 00:32:52.000000', 'temperatura', 971.0000, 'ºC'),
	(316022, 143, '2015-01-15 00:32:53.000000', 'temperatura', 1149.0000, 'ºC'),
	(316023, 143, '2015-01-15 00:32:54.000000', 'temperatura', 434.0000, 'ºC'),
	(316024, 143, '2015-01-15 00:32:55.000000', 'temperatura', 1122.0000, 'ºC'),
	(316025, 143, '2015-01-15 00:32:56.000000', 'temperatura', 708.0000, 'ºC'),
	(316026, 143, '2015-01-15 00:32:57.000000', 'temperatura', 176.0000, 'ºC'),
	(316027, 143, '2015-01-15 00:32:58.000000', 'temperatura', 1155.0000, 'ºC'),
	(316028, 143, '2015-01-15 00:32:59.000000', 'temperatura', 450.0000, 'ºC'),
	(316029, 143, '2015-01-15 00:33:00.000000', 'temperatura', 1184.0000, 'ºC'),
	(316030, 143, '2015-01-15 00:33:01.000000', 'temperatura', 973.0000, 'ºC'),
	(316031, 143, '2015-01-15 00:33:02.000000', 'temperatura', 110.0000, 'ºC'),
	(316032, 143, '2015-01-15 00:33:03.000000', 'temperatura', 33.0000, 'ºC'),
	(316033, 143, '2015-01-15 00:33:04.000000', 'temperatura', 1034.0000, 'ºC'),
	(316034, 143, '2015-01-15 00:33:05.000000', 'temperatura', 271.0000, 'ºC'),
	(316035, 143, '2015-01-15 00:33:06.000000', 'temperatura', 655.0000, 'ºC'),
	(316036, 143, '2015-01-15 00:33:07.000000', 'temperatura', 63.0000, 'ºC'),
	(316037, 143, '2015-01-15 00:33:08.000000', 'temperatura', 750.0000, 'ºC'),
	(316038, 143, '2015-01-15 00:33:09.000000', 'temperatura', 1160.0000, 'ºC'),
	(316039, 143, '2015-01-15 00:33:10.000000', 'temperatura', 1152.0000, 'ºC'),
	(316040, 143, '2015-01-15 00:33:11.000000', 'temperatura', 1080.0000, 'ºC'),
	(316041, 143, '2015-01-15 00:33:12.000000', 'temperatura', 746.0000, 'ºC'),
	(316042, 143, '2015-01-15 00:33:13.000000', 'temperatura', 489.0000, 'ºC'),
	(316043, 143, '2015-01-15 00:33:14.000000', 'temperatura', 207.0000, 'ºC'),
	(316044, 143, '2015-01-15 00:33:15.000000', 'temperatura', 769.0000, 'ºC'),
	(316045, 143, '2015-01-15 00:33:16.000000', 'temperatura', 824.0000, 'ºC'),
	(316046, 143, '2015-01-15 00:33:17.000000', 'temperatura', 614.0000, 'ºC'),
	(316047, 143, '2015-01-15 00:33:18.000000', 'temperatura', 600.0000, 'ºC'),
	(316048, 143, '2015-01-15 00:33:19.000000', 'temperatura', 1157.0000, 'ºC'),
	(316049, 143, '2015-01-15 00:33:20.000000', 'temperatura', 385.0000, 'ºC'),
	(316050, 143, '2015-01-15 00:33:21.000000', 'temperatura', 857.0000, 'ºC'),
	(316051, 143, '2015-01-15 00:33:22.000000', 'temperatura', 729.0000, 'ºC'),
	(316052, 143, '2015-01-15 00:33:23.000000', 'temperatura', 1075.0000, 'ºC'),
	(316053, 143, '2015-01-15 00:33:24.000000', 'temperatura', 786.0000, 'ºC'),
	(316054, 143, '2015-01-15 00:33:25.000000', 'temperatura', 708.0000, 'ºC'),
	(316055, 143, '2015-01-15 00:33:26.000000', 'temperatura', 1181.0000, 'ºC'),
	(316056, 143, '2015-01-15 00:33:27.000000', 'temperatura', 180.0000, 'ºC'),
	(316057, 143, '2015-01-15 00:33:28.000000', 'temperatura', 960.0000, 'ºC'),
	(316058, 143, '2015-01-15 00:33:29.000000', 'temperatura', 661.0000, 'ºC'),
	(316059, 143, '2015-01-15 00:33:30.000000', 'temperatura', 427.0000, 'ºC'),
	(316060, 143, '2015-01-15 00:33:31.000000', 'temperatura', 149.0000, 'ºC'),
	(316061, 143, '2015-01-15 00:33:32.000000', 'temperatura', 668.0000, 'ºC'),
	(316062, 143, '2015-01-15 00:33:33.000000', 'temperatura', 490.0000, 'ºC'),
	(316063, 143, '2015-01-15 00:33:34.000000', 'temperatura', 449.0000, 'ºC'),
	(316064, 143, '2015-01-15 00:33:35.000000', 'temperatura', 773.0000, 'ºC'),
	(316065, 143, '2015-01-15 00:33:36.000000', 'temperatura', 122.0000, 'ºC'),
	(316066, 143, '2015-01-15 00:33:37.000000', 'temperatura', 688.0000, 'ºC'),
	(316067, 143, '2015-01-15 00:33:38.000000', 'temperatura', 677.0000, 'ºC'),
	(316068, 143, '2015-01-15 00:33:39.000000', 'temperatura', 121.0000, 'ºC'),
	(316069, 143, '2015-01-15 00:33:40.000000', 'temperatura', 974.0000, 'ºC'),
	(316070, 143, '2015-01-15 00:33:41.000000', 'temperatura', 906.0000, 'ºC'),
	(316071, 143, '2015-01-15 00:33:42.000000', 'temperatura', 411.0000, 'ºC'),
	(316072, 143, '2015-01-15 00:33:43.000000', 'temperatura', 535.0000, 'ºC'),
	(316073, 143, '2015-01-15 00:33:44.000000', 'temperatura', 242.0000, 'ºC'),
	(316074, 143, '2015-01-15 00:33:45.000000', 'temperatura', 807.0000, 'ºC'),
	(316075, 143, '2015-01-15 00:33:46.000000', 'temperatura', 911.0000, 'ºC'),
	(316076, 143, '2015-01-15 00:33:47.000000', 'temperatura', 934.0000, 'ºC'),
	(316077, 143, '2015-01-15 00:33:48.000000', 'temperatura', 736.0000, 'ºC'),
	(316078, 143, '2015-01-15 00:33:49.000000', 'temperatura', 878.0000, 'ºC'),
	(316079, 143, '2015-01-15 00:33:50.000000', 'temperatura', 983.0000, 'ºC'),
	(316080, 143, '2015-01-15 00:33:51.000000', 'temperatura', 1082.0000, 'ºC'),
	(316081, 143, '2015-01-15 00:33:52.000000', 'temperatura', 60.0000, 'ºC'),
	(316082, 143, '2015-01-15 00:33:53.000000', 'temperatura', 656.0000, 'ºC'),
	(316083, 143, '2015-01-15 00:33:54.000000', 'temperatura', 700.0000, 'ºC'),
	(316084, 143, '2015-01-15 00:33:55.000000', 'temperatura', 333.0000, 'ºC'),
	(316085, 143, '2015-01-15 00:33:56.000000', 'temperatura', 763.0000, 'ºC'),
	(316086, 143, '2015-01-15 00:33:57.000000', 'temperatura', 420.0000, 'ºC'),
	(316087, 143, '2015-01-15 00:33:58.000000', 'temperatura', 1008.0000, 'ºC'),
	(316088, 143, '2015-01-15 00:33:59.000000', 'temperatura', 183.0000, 'ºC'),
	(316089, 143, '2015-01-15 00:34:00.000000', 'temperatura', 290.0000, 'ºC'),
	(316090, 143, '2015-01-15 00:34:01.000000', 'temperatura', 900.0000, 'ºC'),
	(316091, 143, '2015-01-15 00:34:02.000000', 'temperatura', 33.0000, 'ºC'),
	(316092, 143, '2015-01-15 00:34:03.000000', 'temperatura', 1063.0000, 'ºC'),
	(316093, 143, '2015-01-15 00:34:04.000000', 'temperatura', 416.0000, 'ºC'),
	(316094, 143, '2015-01-15 00:34:05.000000', 'temperatura', 93.0000, 'ºC'),
	(316095, 143, '2015-01-15 00:34:06.000000', 'temperatura', 419.0000, 'ºC'),
	(316096, 143, '2015-01-15 00:34:07.000000', 'temperatura', 616.0000, 'ºC'),
	(316097, 143, '2015-01-15 00:34:08.000000', 'temperatura', 622.0000, 'ºC'),
	(316098, 143, '2015-01-15 00:34:09.000000', 'temperatura', 65.0000, 'ºC'),
	(316099, 143, '2015-01-15 00:34:10.000000', 'temperatura', 857.0000, 'ºC'),
	(316100, 143, '2015-01-15 00:34:11.000000', 'temperatura', 490.0000, 'ºC'),
	(316101, 143, '2015-01-15 00:34:12.000000', 'temperatura', 1079.0000, 'ºC'),
	(316102, 143, '2015-01-15 00:34:13.000000', 'temperatura', 326.0000, 'ºC'),
	(316103, 143, '2015-01-15 00:34:14.000000', 'temperatura', 793.0000, 'ºC'),
	(316104, 143, '2015-01-15 00:34:15.000000', 'temperatura', 587.0000, 'ºC'),
	(316105, 143, '2015-01-15 00:34:16.000000', 'temperatura', 555.0000, 'ºC'),
	(316106, 143, '2015-01-15 00:34:17.000000', 'temperatura', 1017.0000, 'ºC'),
	(316107, 143, '2015-01-15 00:34:18.000000', 'temperatura', 1018.0000, 'ºC'),
	(316108, 143, '2015-01-15 00:34:19.000000', 'temperatura', 841.0000, 'ºC'),
	(316109, 143, '2015-01-15 00:34:20.000000', 'temperatura', 1152.0000, 'ºC'),
	(316110, 143, '2015-01-15 00:34:21.000000', 'temperatura', 839.0000, 'ºC'),
	(316111, 143, '2015-01-15 00:34:22.000000', 'temperatura', 736.0000, 'ºC'),
	(316112, 143, '2015-01-15 00:34:23.000000', 'temperatura', 1166.0000, 'ºC'),
	(316113, 143, '2015-01-15 00:34:24.000000', 'temperatura', 24.0000, 'ºC'),
	(316114, 143, '2015-01-15 00:34:25.000000', 'temperatura', 219.0000, 'ºC'),
	(316115, 143, '2015-01-15 00:34:26.000000', 'temperatura', 1025.0000, 'ºC'),
	(316116, 143, '2015-01-15 00:34:27.000000', 'temperatura', 869.0000, 'ºC'),
	(316117, 143, '2015-01-15 00:34:28.000000', 'temperatura', 70.0000, 'ºC'),
	(316118, 143, '2015-01-15 00:34:29.000000', 'temperatura', 143.0000, 'ºC'),
	(316119, 143, '2015-01-15 00:34:30.000000', 'temperatura', 504.0000, 'ºC'),
	(316120, 143, '2015-01-15 00:34:31.000000', 'temperatura', 892.0000, 'ºC'),
	(316121, 143, '2015-01-15 00:34:32.000000', 'temperatura', 551.0000, 'ºC'),
	(316122, 143, '2015-01-15 00:34:33.000000', 'temperatura', 77.0000, 'ºC'),
	(316123, 143, '2015-01-15 00:34:34.000000', 'temperatura', 1134.0000, 'ºC'),
	(316124, 143, '2015-01-15 00:34:35.000000', 'temperatura', 641.0000, 'ºC'),
	(316125, 143, '2015-01-15 00:34:36.000000', 'temperatura', 1002.0000, 'ºC'),
	(316126, 143, '2015-01-15 00:34:37.000000', 'temperatura', 688.0000, 'ºC'),
	(316127, 143, '2015-01-15 00:34:38.000000', 'temperatura', 435.0000, 'ºC'),
	(316128, 143, '2015-01-15 00:34:39.000000', 'temperatura', 113.0000, 'ºC'),
	(316129, 143, '2015-01-15 00:34:40.000000', 'temperatura', 459.0000, 'ºC'),
	(316130, 143, '2015-01-15 00:34:41.000000', 'temperatura', 757.0000, 'ºC'),
	(316131, 143, '2015-01-15 00:34:42.000000', 'temperatura', 10.0000, 'ºC'),
	(316132, 143, '2015-01-15 00:34:43.000000', 'temperatura', 176.0000, 'ºC'),
	(316133, 143, '2015-01-15 00:34:44.000000', 'temperatura', 854.0000, 'ºC'),
	(316134, 143, '2015-01-15 00:34:45.000000', 'temperatura', 141.0000, 'ºC'),
	(316135, 143, '2015-01-15 00:34:46.000000', 'temperatura', 542.0000, 'ºC'),
	(316136, 143, '2015-01-15 00:34:47.000000', 'temperatura', 1089.0000, 'ºC'),
	(316137, 143, '2015-01-15 00:34:48.000000', 'temperatura', 219.0000, 'ºC'),
	(316138, 143, '2015-01-15 00:34:49.000000', 'temperatura', 230.0000, 'ºC'),
	(316139, 143, '2015-01-15 00:34:50.000000', 'temperatura', 490.0000, 'ºC'),
	(316140, 143, '2015-01-15 00:34:51.000000', 'temperatura', 564.0000, 'ºC'),
	(316141, 143, '2015-01-15 00:34:52.000000', 'temperatura', 151.0000, 'ºC'),
	(316142, 143, '2015-01-15 00:34:53.000000', 'temperatura', 261.0000, 'ºC'),
	(316143, 143, '2015-01-15 00:34:54.000000', 'temperatura', 855.0000, 'ºC'),
	(316144, 143, '2015-01-15 00:34:55.000000', 'temperatura', 1090.0000, 'ºC'),
	(316145, 143, '2015-01-15 00:34:56.000000', 'temperatura', 485.0000, 'ºC'),
	(316146, 143, '2015-01-15 00:34:57.000000', 'temperatura', 356.0000, 'ºC'),
	(316147, 143, '2015-01-15 00:34:58.000000', 'temperatura', 327.0000, 'ºC'),
	(316148, 143, '2015-01-15 00:34:59.000000', 'temperatura', 567.0000, 'ºC'),
	(316149, 143, '2015-01-15 00:35:00.000000', 'temperatura', 654.0000, 'ºC'),
	(316150, 143, '2015-01-15 00:35:01.000000', 'temperatura', 369.0000, 'ºC'),
	(316151, 143, '2015-01-15 00:35:02.000000', 'temperatura', 1084.0000, 'ºC'),
	(316152, 143, '2015-01-15 00:35:03.000000', 'temperatura', 715.0000, 'ºC'),
	(316153, 143, '2015-01-15 00:35:04.000000', 'temperatura', 323.0000, 'ºC'),
	(316154, 143, '2015-01-15 00:35:05.000000', 'temperatura', 669.0000, 'ºC'),
	(316155, 143, '2015-01-15 00:35:06.000000', 'temperatura', 1176.0000, 'ºC'),
	(316156, 143, '2015-01-15 00:35:07.000000', 'temperatura', 274.0000, 'ºC'),
	(316157, 143, '2015-01-15 00:35:08.000000', 'temperatura', 242.0000, 'ºC'),
	(316158, 143, '2015-01-15 00:35:09.000000', 'temperatura', 388.0000, 'ºC'),
	(316159, 143, '2015-01-15 00:35:10.000000', 'temperatura', 14.0000, 'ºC'),
	(316160, 143, '2015-01-15 00:35:11.000000', 'temperatura', 108.0000, 'ºC'),
	(316161, 143, '2015-01-15 00:35:12.000000', 'temperatura', 497.0000, 'ºC'),
	(316162, 143, '2015-01-15 00:35:13.000000', 'temperatura', 962.0000, 'ºC'),
	(316163, 143, '2015-01-15 00:35:14.000000', 'temperatura', 922.0000, 'ºC'),
	(316164, 143, '2015-01-15 00:35:15.000000', 'temperatura', 521.0000, 'ºC'),
	(316165, 143, '2015-01-15 00:35:16.000000', 'temperatura', 1041.0000, 'ºC'),
	(316166, 143, '2015-01-15 00:35:17.000000', 'temperatura', 42.0000, 'ºC'),
	(316167, 143, '2015-01-15 00:35:18.000000', 'temperatura', 689.0000, 'ºC'),
	(316168, 143, '2015-01-15 00:35:19.000000', 'temperatura', 918.0000, 'ºC'),
	(316169, 143, '2015-01-15 00:35:20.000000', 'temperatura', 124.0000, 'ºC'),
	(316170, 143, '2015-01-15 00:35:21.000000', 'temperatura', 265.0000, 'ºC'),
	(316171, 143, '2015-01-15 00:35:22.000000', 'temperatura', 955.0000, 'ºC'),
	(316172, 143, '2015-01-15 00:35:23.000000', 'temperatura', 379.0000, 'ºC'),
	(316173, 143, '2015-01-15 00:35:24.000000', 'temperatura', 232.0000, 'ºC'),
	(316174, 143, '2015-01-15 00:35:25.000000', 'temperatura', 24.0000, 'ºC'),
	(316175, 143, '2015-01-15 00:35:26.000000', 'temperatura', 623.0000, 'ºC'),
	(316176, 143, '2015-01-15 00:35:27.000000', 'temperatura', 644.0000, 'ºC'),
	(316177, 143, '2015-01-15 00:35:28.000000', 'temperatura', 153.0000, 'ºC'),
	(316178, 143, '2015-01-15 00:35:29.000000', 'temperatura', 30.0000, 'ºC'),
	(316179, 143, '2015-01-15 00:35:30.000000', 'temperatura', 895.0000, 'ºC'),
	(316180, 143, '2015-01-15 00:35:31.000000', 'temperatura', 784.0000, 'ºC'),
	(316181, 143, '2015-01-15 00:35:32.000000', 'temperatura', 35.0000, 'ºC'),
	(316182, 143, '2015-01-15 00:35:33.000000', 'temperatura', 222.0000, 'ºC'),
	(316183, 143, '2015-01-15 00:35:34.000000', 'temperatura', 1006.0000, 'ºC'),
	(316184, 143, '2015-01-15 00:35:35.000000', 'temperatura', 767.0000, 'ºC'),
	(316185, 143, '2015-01-15 00:35:36.000000', 'temperatura', 815.0000, 'ºC'),
	(316186, 143, '2015-01-15 00:35:37.000000', 'temperatura', 575.0000, 'ºC'),
	(316187, 143, '2015-01-15 00:35:38.000000', 'temperatura', 432.0000, 'ºC'),
	(316188, 143, '2015-01-15 00:35:39.000000', 'temperatura', 433.0000, 'ºC'),
	(316189, 143, '2015-01-15 00:35:40.000000', 'temperatura', 872.0000, 'ºC'),
	(316190, 143, '2015-01-15 00:35:41.000000', 'temperatura', 662.0000, 'ºC'),
	(316191, 143, '2015-01-15 00:35:42.000000', 'temperatura', 693.0000, 'ºC'),
	(316192, 143, '2015-01-15 00:35:43.000000', 'temperatura', 281.0000, 'ºC'),
	(316193, 143, '2015-01-15 00:35:44.000000', 'temperatura', 526.0000, 'ºC'),
	(316194, 143, '2015-01-15 00:35:45.000000', 'temperatura', 585.0000, 'ºC'),
	(316195, 143, '2015-01-15 00:35:46.000000', 'temperatura', 150.0000, 'ºC'),
	(316196, 143, '2015-01-15 00:35:47.000000', 'temperatura', 193.0000, 'ºC'),
	(316197, 143, '2015-01-15 00:35:48.000000', 'temperatura', 519.0000, 'ºC'),
	(316198, 143, '2015-01-15 00:35:49.000000', 'temperatura', 814.0000, 'ºC'),
	(316199, 143, '2015-01-15 00:35:50.000000', 'temperatura', 114.0000, 'ºC'),
	(316200, 143, '2015-01-15 00:35:51.000000', 'temperatura', 528.0000, 'ºC'),
	(316201, 143, '2015-01-15 00:35:52.000000', 'temperatura', 1101.0000, 'ºC'),
	(316202, 143, '2015-01-15 00:35:53.000000', 'temperatura', 319.0000, 'ºC'),
	(316203, 143, '2015-01-15 00:35:54.000000', 'temperatura', 692.0000, 'ºC'),
	(316204, 143, '2015-01-15 00:35:55.000000', 'temperatura', 106.0000, 'ºC'),
	(316205, 143, '2015-01-15 00:35:56.000000', 'temperatura', 853.0000, 'ºC'),
	(316206, 143, '2015-01-15 00:35:57.000000', 'temperatura', 348.0000, 'ºC'),
	(316207, 143, '2015-01-15 00:35:58.000000', 'temperatura', 380.0000, 'ºC'),
	(316208, 143, '2015-01-15 00:35:59.000000', 'temperatura', 858.0000, 'ºC'),
	(316209, 143, '2015-01-15 00:36:00.000000', 'temperatura', 749.0000, 'ºC'),
	(316210, 143, '2015-01-15 00:36:01.000000', 'temperatura', 1171.0000, 'ºC'),
	(316211, 143, '2015-01-15 00:36:02.000000', 'temperatura', 11.0000, 'ºC'),
	(316212, 143, '2015-01-15 00:36:03.000000', 'temperatura', 142.0000, 'ºC'),
	(316213, 143, '2015-01-15 00:36:04.000000', 'temperatura', 676.0000, 'ºC'),
	(316214, 143, '2015-01-15 00:36:05.000000', 'temperatura', 556.0000, 'ºC'),
	(316215, 143, '2015-01-15 00:36:06.000000', 'temperatura', 752.0000, 'ºC'),
	(316216, 143, '2015-01-15 00:36:07.000000', 'temperatura', 892.0000, 'ºC'),
	(316217, 143, '2015-01-15 00:36:08.000000', 'temperatura', 1005.0000, 'ºC'),
	(316218, 143, '2015-01-15 00:36:09.000000', 'temperatura', 1147.0000, 'ºC'),
	(316219, 143, '2015-01-15 00:36:10.000000', 'temperatura', 323.0000, 'ºC'),
	(316220, 143, '2015-01-15 00:36:11.000000', 'temperatura', 576.0000, 'ºC'),
	(316221, 143, '2015-01-15 00:36:12.000000', 'temperatura', 709.0000, 'ºC'),
	(316222, 143, '2015-01-15 00:36:13.000000', 'temperatura', 617.0000, 'ºC'),
	(316223, 143, '2015-01-15 00:36:14.000000', 'temperatura', 957.0000, 'ºC'),
	(316224, 143, '2015-01-15 00:36:15.000000', 'temperatura', 538.0000, 'ºC'),
	(316225, 143, '2015-01-15 00:36:16.000000', 'temperatura', 1016.0000, 'ºC'),
	(316226, 143, '2015-01-15 00:36:17.000000', 'temperatura', 1069.0000, 'ºC'),
	(316227, 143, '2015-01-15 00:36:18.000000', 'temperatura', 1097.0000, 'ºC'),
	(316228, 143, '2015-01-15 00:36:19.000000', 'temperatura', 1080.0000, 'ºC'),
	(316229, 143, '2015-01-15 00:36:20.000000', 'temperatura', 909.0000, 'ºC'),
	(316230, 143, '2015-01-15 00:36:21.000000', 'temperatura', 103.0000, 'ºC'),
	(316231, 143, '2015-01-15 00:36:22.000000', 'temperatura', 192.0000, 'ºC'),
	(316232, 143, '2015-01-15 00:36:23.000000', 'temperatura', 649.0000, 'ºC'),
	(316233, 143, '2015-01-15 00:36:24.000000', 'temperatura', 270.0000, 'ºC'),
	(316234, 143, '2015-01-15 00:36:25.000000', 'temperatura', 605.0000, 'ºC'),
	(316235, 143, '2015-01-15 00:36:26.000000', 'temperatura', 1015.0000, 'ºC'),
	(316236, 143, '2015-01-15 00:36:27.000000', 'temperatura', 860.0000, 'ºC'),
	(316237, 143, '2015-01-15 00:36:28.000000', 'temperatura', 56.0000, 'ºC'),
	(316238, 143, '2015-01-15 00:36:29.000000', 'temperatura', 99.0000, 'ºC'),
	(316239, 143, '2015-01-15 00:36:30.000000', 'temperatura', 329.0000, 'ºC'),
	(316240, 143, '2015-01-15 00:36:31.000000', 'temperatura', 147.0000, 'ºC'),
	(316241, 143, '2015-01-15 00:36:32.000000', 'temperatura', 950.0000, 'ºC'),
	(316242, 143, '2015-01-15 00:36:33.000000', 'temperatura', 708.0000, 'ºC'),
	(316243, 143, '2015-01-15 00:36:34.000000', 'temperatura', 692.0000, 'ºC'),
	(316244, 143, '2015-01-15 00:36:35.000000', 'temperatura', 135.0000, 'ºC'),
	(316245, 143, '2015-01-15 00:36:36.000000', 'temperatura', 1000.0000, 'ºC'),
	(316246, 143, '2015-01-15 00:36:37.000000', 'temperatura', 997.0000, 'ºC'),
	(316247, 143, '2015-01-15 00:36:38.000000', 'temperatura', 784.0000, 'ºC'),
	(316248, 143, '2015-01-15 00:36:39.000000', 'temperatura', 930.0000, 'ºC'),
	(316249, 143, '2015-01-15 00:36:40.000000', 'temperatura', 1100.0000, 'ºC'),
	(316250, 143, '2015-01-15 00:36:41.000000', 'temperatura', 310.0000, 'ºC'),
	(316251, 143, '2015-01-15 00:36:42.000000', 'temperatura', 652.0000, 'ºC'),
	(316252, 143, '2015-01-15 00:36:43.000000', 'temperatura', 1127.0000, 'ºC'),
	(316253, 143, '2015-01-15 00:36:44.000000', 'temperatura', 82.0000, 'ºC'),
	(316254, 143, '2015-01-15 00:36:45.000000', 'temperatura', 628.0000, 'ºC'),
	(316255, 143, '2015-01-15 00:36:46.000000', 'temperatura', 495.0000, 'ºC'),
	(316256, 143, '2015-01-15 00:36:47.000000', 'temperatura', 590.0000, 'ºC'),
	(316257, 143, '2015-01-15 00:36:48.000000', 'temperatura', 267.0000, 'ºC'),
	(316258, 143, '2015-01-15 00:36:49.000000', 'temperatura', 767.0000, 'ºC'),
	(316259, 143, '2015-01-15 00:36:50.000000', 'temperatura', 631.0000, 'ºC'),
	(316260, 143, '2015-01-15 00:36:51.000000', 'temperatura', 858.0000, 'ºC'),
	(316261, 143, '2015-01-15 00:36:52.000000', 'temperatura', 1194.0000, 'ºC'),
	(316262, 143, '2015-01-15 00:36:53.000000', 'temperatura', 1000.0000, 'ºC'),
	(316263, 143, '2015-01-15 00:36:54.000000', 'temperatura', 216.0000, 'ºC'),
	(316264, 143, '2015-01-15 00:36:55.000000', 'temperatura', 481.0000, 'ºC'),
	(316265, 143, '2015-01-15 00:36:56.000000', 'temperatura', 556.0000, 'ºC'),
	(316266, 143, '2015-01-15 00:36:57.000000', 'temperatura', 139.0000, 'ºC'),
	(316267, 143, '2015-01-15 00:36:58.000000', 'temperatura', 228.0000, 'ºC'),
	(316268, 143, '2015-01-15 00:36:59.000000', 'temperatura', 723.0000, 'ºC'),
	(316269, 143, '2015-01-15 00:37:00.000000', 'temperatura', 531.0000, 'ºC'),
	(316270, 143, '2015-01-15 00:37:01.000000', 'temperatura', 489.0000, 'ºC'),
	(316271, 143, '2015-01-15 00:37:02.000000', 'temperatura', 849.0000, 'ºC'),
	(316272, 143, '2015-01-15 00:37:03.000000', 'temperatura', 380.0000, 'ºC'),
	(316273, 143, '2015-01-15 00:37:04.000000', 'temperatura', 554.0000, 'ºC'),
	(316274, 143, '2015-01-15 00:37:05.000000', 'temperatura', 431.0000, 'ºC'),
	(316275, 143, '2015-01-15 00:37:06.000000', 'temperatura', 492.0000, 'ºC'),
	(316276, 143, '2015-01-15 00:37:07.000000', 'temperatura', 1170.0000, 'ºC'),
	(316277, 143, '2015-01-15 00:37:08.000000', 'temperatura', 773.0000, 'ºC'),
	(316278, 143, '2015-01-15 00:37:09.000000', 'temperatura', 354.0000, 'ºC'),
	(316279, 143, '2015-01-15 00:37:10.000000', 'temperatura', 652.0000, 'ºC'),
	(316280, 143, '2015-01-15 00:37:11.000000', 'temperatura', 1001.0000, 'ºC'),
	(316281, 143, '2015-01-15 00:37:12.000000', 'temperatura', 647.0000, 'ºC'),
	(316282, 143, '2015-01-15 00:37:13.000000', 'temperatura', 234.0000, 'ºC'),
	(316283, 143, '2015-01-15 00:37:14.000000', 'temperatura', 428.0000, 'ºC'),
	(316284, 143, '2015-01-15 00:37:15.000000', 'temperatura', 241.0000, 'ºC'),
	(316285, 143, '2015-01-15 00:37:16.000000', 'temperatura', 1119.0000, 'ºC'),
	(316286, 143, '2015-01-15 00:37:17.000000', 'temperatura', 74.0000, 'ºC'),
	(316287, 143, '2015-01-15 00:37:18.000000', 'temperatura', 612.0000, 'ºC'),
	(316288, 143, '2015-01-15 00:37:19.000000', 'temperatura', 440.0000, 'ºC'),
	(316289, 143, '2015-01-15 00:37:20.000000', 'temperatura', 366.0000, 'ºC'),
	(316290, 143, '2015-01-15 00:37:21.000000', 'temperatura', 508.0000, 'ºC'),
	(316291, 143, '2015-01-15 00:37:22.000000', 'temperatura', 244.0000, 'ºC'),
	(316292, 143, '2015-01-15 00:37:23.000000', 'temperatura', 895.0000, 'ºC'),
	(316293, 143, '2015-01-15 00:37:24.000000', 'temperatura', 146.0000, 'ºC'),
	(316294, 143, '2015-01-15 00:37:25.000000', 'temperatura', 444.0000, 'ºC'),
	(316295, 143, '2015-01-15 00:37:26.000000', 'temperatura', 581.0000, 'ºC'),
	(316296, 143, '2015-01-15 00:37:27.000000', 'temperatura', 376.0000, 'ºC'),
	(316297, 143, '2015-01-15 00:37:28.000000', 'temperatura', 136.0000, 'ºC'),
	(316298, 143, '2015-01-15 00:37:29.000000', 'temperatura', 752.0000, 'ºC'),
	(316299, 143, '2015-01-15 00:37:30.000000', 'temperatura', 954.0000, 'ºC'),
	(316300, 143, '2015-01-15 00:37:31.000000', 'temperatura', 115.0000, 'ºC'),
	(316301, 143, '2015-01-15 00:37:32.000000', 'temperatura', 111.0000, 'ºC'),
	(316302, 143, '2015-01-15 00:37:33.000000', 'temperatura', 211.0000, 'ºC'),
	(316303, 143, '2015-01-15 00:37:34.000000', 'temperatura', 721.0000, 'ºC'),
	(316304, 143, '2015-01-15 00:37:35.000000', 'temperatura', 574.0000, 'ºC'),
	(316305, 143, '2015-01-15 00:37:36.000000', 'temperatura', 709.0000, 'ºC'),
	(316306, 143, '2015-01-15 00:37:37.000000', 'temperatura', 622.0000, 'ºC'),
	(316307, 143, '2015-01-15 00:37:38.000000', 'temperatura', 984.0000, 'ºC'),
	(316308, 143, '2015-01-15 00:37:39.000000', 'temperatura', 654.0000, 'ºC'),
	(316309, 143, '2015-01-15 00:37:40.000000', 'temperatura', 318.0000, 'ºC'),
	(316310, 143, '2015-01-15 00:37:41.000000', 'temperatura', 828.0000, 'ºC'),
	(316311, 143, '2015-01-15 00:37:42.000000', 'temperatura', 788.0000, 'ºC'),
	(316312, 143, '2015-01-15 00:37:43.000000', 'temperatura', 258.0000, 'ºC'),
	(316313, 143, '2015-01-15 00:37:44.000000', 'temperatura', 125.0000, 'ºC'),
	(316314, 143, '2015-01-15 00:37:45.000000', 'temperatura', 1051.0000, 'ºC'),
	(316315, 143, '2015-01-15 00:37:46.000000', 'temperatura', 83.0000, 'ºC'),
	(316316, 143, '2015-01-15 00:37:47.000000', 'temperatura', 861.0000, 'ºC'),
	(316317, 143, '2015-01-15 00:37:48.000000', 'temperatura', 454.0000, 'ºC'),
	(316318, 143, '2015-01-15 00:37:49.000000', 'temperatura', 891.0000, 'ºC'),
	(316319, 143, '2015-01-15 00:37:50.000000', 'temperatura', 694.0000, 'ºC'),
	(316320, 143, '2015-01-15 00:37:51.000000', 'temperatura', 795.0000, 'ºC'),
	(316321, 143, '2015-01-15 00:37:52.000000', 'temperatura', 693.0000, 'ºC'),
	(316322, 143, '2015-01-15 00:37:53.000000', 'temperatura', 1083.0000, 'ºC'),
	(316323, 143, '2015-01-15 00:37:54.000000', 'temperatura', 936.0000, 'ºC'),
	(316324, 143, '2015-01-15 00:37:55.000000', 'temperatura', 230.0000, 'ºC'),
	(316325, 143, '2015-01-15 00:37:56.000000', 'temperatura', 743.0000, 'ºC'),
	(316326, 143, '2015-01-15 00:37:57.000000', 'temperatura', 628.0000, 'ºC'),
	(316327, 143, '2015-01-15 00:37:58.000000', 'temperatura', 908.0000, 'ºC'),
	(316328, 143, '2015-01-15 00:37:59.000000', 'temperatura', 259.0000, 'ºC'),
	(316329, 143, '2015-01-15 00:38:00.000000', 'temperatura', 970.0000, 'ºC'),
	(316330, 143, '2015-01-15 00:38:01.000000', 'temperatura', 473.0000, 'ºC'),
	(316331, 143, '2015-01-15 00:38:02.000000', 'temperatura', 657.0000, 'ºC'),
	(316332, 143, '2015-01-15 00:38:03.000000', 'temperatura', 664.0000, 'ºC'),
	(316333, 143, '2015-01-15 00:38:04.000000', 'temperatura', 152.0000, 'ºC'),
	(316334, 143, '2015-01-15 00:38:05.000000', 'temperatura', 1168.0000, 'ºC'),
	(316335, 143, '2015-01-15 00:38:06.000000', 'temperatura', 583.0000, 'ºC'),
	(316336, 143, '2015-01-15 00:38:07.000000', 'temperatura', 613.0000, 'ºC'),
	(316337, 143, '2015-01-15 00:38:08.000000', 'temperatura', 117.0000, 'ºC'),
	(316338, 143, '2015-01-15 00:38:09.000000', 'temperatura', 1145.0000, 'ºC'),
	(316339, 143, '2015-01-15 00:38:10.000000', 'temperatura', 575.0000, 'ºC'),
	(316340, 143, '2015-01-15 00:38:11.000000', 'temperatura', 640.0000, 'ºC'),
	(316341, 143, '2015-01-15 00:38:12.000000', 'temperatura', 275.0000, 'ºC'),
	(316342, 143, '2015-01-15 00:38:13.000000', 'temperatura', 656.0000, 'ºC'),
	(316343, 143, '2015-01-15 00:38:14.000000', 'temperatura', 57.0000, 'ºC'),
	(316344, 143, '2015-01-15 00:38:15.000000', 'temperatura', 716.0000, 'ºC'),
	(316345, 143, '2015-01-15 00:38:16.000000', 'temperatura', 1011.0000, 'ºC'),
	(316346, 143, '2015-01-15 00:38:17.000000', 'temperatura', 507.0000, 'ºC'),
	(316347, 143, '2015-01-15 00:38:18.000000', 'temperatura', 704.0000, 'ºC'),
	(316348, 143, '2015-01-15 00:38:19.000000', 'temperatura', 800.0000, 'ºC'),
	(316349, 143, '2015-01-15 00:38:20.000000', 'temperatura', 687.0000, 'ºC'),
	(316350, 143, '2015-01-15 00:38:21.000000', 'temperatura', 1036.0000, 'ºC'),
	(316351, 143, '2015-01-15 00:38:22.000000', 'temperatura', 720.0000, 'ºC'),
	(316352, 143, '2015-01-15 00:38:23.000000', 'temperatura', 492.0000, 'ºC'),
	(316353, 143, '2015-01-15 00:38:24.000000', 'temperatura', 302.0000, 'ºC'),
	(316354, 143, '2015-01-15 00:38:25.000000', 'temperatura', 35.0000, 'ºC'),
	(316355, 143, '2015-01-15 00:38:26.000000', 'temperatura', 470.0000, 'ºC'),
	(316356, 143, '2015-01-15 00:38:27.000000', 'temperatura', 1042.0000, 'ºC'),
	(316357, 143, '2015-01-15 00:38:28.000000', 'temperatura', 203.0000, 'ºC'),
	(316358, 143, '2015-01-15 00:38:29.000000', 'temperatura', 291.0000, 'ºC'),
	(316359, 143, '2015-01-15 00:38:30.000000', 'temperatura', 845.0000, 'ºC'),
	(316360, 143, '2015-01-15 00:38:31.000000', 'temperatura', 953.0000, 'ºC'),
	(316361, 143, '2015-01-15 00:38:32.000000', 'temperatura', 1031.0000, 'ºC'),
	(316362, 143, '2015-01-15 00:38:33.000000', 'temperatura', 1097.0000, 'ºC'),
	(316363, 143, '2015-01-15 00:38:34.000000', 'temperatura', 1193.0000, 'ºC'),
	(316364, 143, '2015-01-15 00:38:35.000000', 'temperatura', 272.0000, 'ºC'),
	(316365, 143, '2015-01-15 00:38:36.000000', 'temperatura', 181.0000, 'ºC'),
	(316366, 143, '2015-01-15 00:38:37.000000', 'temperatura', 91.0000, 'ºC'),
	(316367, 143, '2015-01-15 00:38:38.000000', 'temperatura', 1112.0000, 'ºC'),
	(316368, 143, '2015-01-15 00:38:39.000000', 'temperatura', 486.0000, 'ºC'),
	(316369, 143, '2015-01-15 00:38:40.000000', 'temperatura', 297.0000, 'ºC'),
	(316370, 143, '2015-01-15 00:38:41.000000', 'temperatura', 26.0000, 'ºC'),
	(316371, 143, '2015-01-15 00:38:42.000000', 'temperatura', 441.0000, 'ºC'),
	(316372, 143, '2015-01-15 00:38:43.000000', 'temperatura', 926.0000, 'ºC'),
	(316373, 143, '2015-01-15 00:38:44.000000', 'temperatura', 906.0000, 'ºC'),
	(316374, 143, '2015-01-15 00:38:45.000000', 'temperatura', 555.0000, 'ºC'),
	(316375, 143, '2015-01-15 00:38:46.000000', 'temperatura', 58.0000, 'ºC'),
	(316376, 143, '2015-01-15 00:38:47.000000', 'temperatura', 1023.0000, 'ºC'),
	(316377, 143, '2015-01-15 00:38:48.000000', 'temperatura', 141.0000, 'ºC'),
	(316378, 143, '2015-01-15 00:38:49.000000', 'temperatura', 36.0000, 'ºC'),
	(316379, 143, '2015-01-15 00:38:50.000000', 'temperatura', 960.0000, 'ºC'),
	(316380, 143, '2015-01-15 00:38:51.000000', 'temperatura', 1091.0000, 'ºC'),
	(316381, 143, '2015-01-15 00:38:52.000000', 'temperatura', 178.0000, 'ºC'),
	(316382, 143, '2015-01-15 00:38:53.000000', 'temperatura', 15.0000, 'ºC'),
	(316383, 143, '2015-01-15 00:38:54.000000', 'temperatura', 741.0000, 'ºC'),
	(316384, 143, '2015-01-15 00:38:55.000000', 'temperatura', 63.0000, 'ºC'),
	(316385, 143, '2015-01-15 00:38:56.000000', 'temperatura', 493.0000, 'ºC'),
	(316386, 143, '2015-01-15 00:38:57.000000', 'temperatura', 1074.0000, 'ºC'),
	(316387, 143, '2015-01-15 00:38:58.000000', 'temperatura', 294.0000, 'ºC'),
	(316388, 143, '2015-01-15 00:38:59.000000', 'temperatura', 647.0000, 'ºC'),
	(316389, 143, '2015-01-15 00:39:00.000000', 'temperatura', 1155.0000, 'ºC'),
	(316390, 143, '2015-01-15 00:39:01.000000', 'temperatura', 236.0000, 'ºC'),
	(316391, 143, '2015-01-15 00:39:02.000000', 'temperatura', 112.0000, 'ºC'),
	(316392, 143, '2015-01-15 00:39:03.000000', 'temperatura', 1053.0000, 'ºC'),
	(316393, 143, '2015-01-15 00:39:04.000000', 'temperatura', 132.0000, 'ºC'),
	(316394, 143, '2015-01-15 00:39:05.000000', 'temperatura', 1100.0000, 'ºC'),
	(316395, 143, '2015-01-15 00:39:06.000000', 'temperatura', 305.0000, 'ºC'),
	(316396, 143, '2015-01-15 00:39:07.000000', 'temperatura', 624.0000, 'ºC'),
	(316397, 143, '2015-01-15 00:39:08.000000', 'temperatura', 1005.0000, 'ºC'),
	(316398, 143, '2015-01-15 00:39:09.000000', 'temperatura', 754.0000, 'ºC'),
	(316399, 143, '2015-01-15 00:39:10.000000', 'temperatura', 756.0000, 'ºC'),
	(316400, 143, '2015-01-15 00:39:11.000000', 'temperatura', 317.0000, 'ºC'),
	(316401, 143, '2015-01-15 00:39:12.000000', 'temperatura', 520.0000, 'ºC'),
	(316402, 143, '2015-01-15 00:39:13.000000', 'temperatura', 449.0000, 'ºC'),
	(316403, 143, '2015-01-15 00:39:14.000000', 'temperatura', 684.0000, 'ºC'),
	(316404, 143, '2015-01-15 00:39:15.000000', 'temperatura', 873.0000, 'ºC'),
	(316405, 143, '2015-01-15 00:39:16.000000', 'temperatura', 1113.0000, 'ºC'),
	(316406, 143, '2015-01-15 00:39:17.000000', 'temperatura', 549.0000, 'ºC'),
	(316407, 143, '2015-01-15 00:39:18.000000', 'temperatura', 606.0000, 'ºC'),
	(316408, 143, '2015-01-15 00:39:19.000000', 'temperatura', 181.0000, 'ºC'),
	(316409, 143, '2015-01-15 00:39:20.000000', 'temperatura', 291.0000, 'ºC'),
	(316410, 143, '2015-01-15 00:39:21.000000', 'temperatura', 909.0000, 'ºC'),
	(316411, 143, '2015-01-15 00:39:22.000000', 'temperatura', 76.0000, 'ºC'),
	(316412, 143, '2015-01-15 00:39:23.000000', 'temperatura', 52.0000, 'ºC'),
	(316413, 143, '2015-01-15 00:39:24.000000', 'temperatura', 31.0000, 'ºC'),
	(316414, 143, '2015-01-15 00:39:25.000000', 'temperatura', 2.0000, 'ºC'),
	(316415, 143, '2015-01-15 00:39:26.000000', 'temperatura', 1115.0000, 'ºC'),
	(316416, 143, '2015-01-15 00:39:27.000000', 'temperatura', 772.0000, 'ºC'),
	(316417, 143, '2015-01-15 00:39:28.000000', 'temperatura', 512.0000, 'ºC'),
	(316418, 143, '2015-01-15 00:39:29.000000', 'temperatura', 248.0000, 'ºC'),
	(316419, 143, '2015-01-15 00:39:30.000000', 'temperatura', 903.0000, 'ºC'),
	(316420, 143, '2015-01-15 00:39:31.000000', 'temperatura', 171.0000, 'ºC'),
	(316421, 143, '2015-01-15 00:39:32.000000', 'temperatura', 549.0000, 'ºC'),
	(316422, 143, '2015-01-15 00:39:33.000000', 'temperatura', 1031.0000, 'ºC'),
	(316423, 143, '2015-01-15 00:39:34.000000', 'temperatura', 1109.0000, 'ºC'),
	(316424, 143, '2015-01-15 00:39:35.000000', 'temperatura', 53.0000, 'ºC'),
	(316425, 143, '2015-01-15 00:39:36.000000', 'temperatura', 537.0000, 'ºC'),
	(316426, 143, '2015-01-15 00:39:37.000000', 'temperatura', 128.0000, 'ºC'),
	(316427, 143, '2015-01-15 00:39:38.000000', 'temperatura', 230.0000, 'ºC'),
	(316428, 143, '2015-01-15 00:39:39.000000', 'temperatura', 765.0000, 'ºC'),
	(316429, 143, '2015-01-15 00:39:40.000000', 'temperatura', 735.0000, 'ºC'),
	(316430, 143, '2015-01-15 00:39:41.000000', 'temperatura', 183.0000, 'ºC'),
	(316431, 143, '2015-01-15 00:39:42.000000', 'temperatura', 1108.0000, 'ºC'),
	(316432, 143, '2015-01-15 00:39:43.000000', 'temperatura', 194.0000, 'ºC'),
	(316433, 143, '2015-01-15 00:39:44.000000', 'temperatura', 44.0000, 'ºC'),
	(316434, 143, '2015-01-15 00:39:45.000000', 'temperatura', 839.0000, 'ºC'),
	(316435, 143, '2015-01-15 00:39:46.000000', 'temperatura', 465.0000, 'ºC'),
	(316436, 143, '2015-01-15 00:39:47.000000', 'temperatura', 1008.0000, 'ºC'),
	(316437, 143, '2015-01-15 00:39:48.000000', 'temperatura', 47.0000, 'ºC'),
	(316438, 143, '2015-01-15 00:39:49.000000', 'temperatura', 811.0000, 'ºC'),
	(316439, 143, '2015-01-15 00:39:50.000000', 'temperatura', 312.0000, 'ºC'),
	(316440, 143, '2015-01-15 00:39:51.000000', 'temperatura', 330.0000, 'ºC'),
	(316441, 143, '2015-01-15 00:39:52.000000', 'temperatura', 714.0000, 'ºC'),
	(316442, 143, '2015-01-15 00:39:53.000000', 'temperatura', 180.0000, 'ºC'),
	(316443, 143, '2015-01-15 00:39:54.000000', 'temperatura', 1161.0000, 'ºC'),
	(316444, 143, '2015-01-15 00:39:55.000000', 'temperatura', 462.0000, 'ºC'),
	(316445, 143, '2015-01-15 00:39:56.000000', 'temperatura', 29.0000, 'ºC'),
	(316446, 143, '2015-01-15 00:39:57.000000', 'temperatura', 1159.0000, 'ºC'),
	(316447, 143, '2015-01-15 00:39:58.000000', 'temperatura', 908.0000, 'ºC'),
	(316448, 143, '2015-01-15 00:39:59.000000', 'temperatura', 1064.0000, 'ºC'),
	(316449, 143, '2015-01-15 00:40:00.000000', 'temperatura', 198.0000, 'ºC'),
	(316450, 143, '2015-01-15 00:40:01.000000', 'temperatura', 198.0000, 'ºC'),
	(316451, 143, '2015-01-15 00:40:02.000000', 'temperatura', 394.0000, 'ºC'),
	(316452, 143, '2015-01-15 00:40:03.000000', 'temperatura', 178.0000, 'ºC'),
	(316453, 143, '2015-01-15 00:40:04.000000', 'temperatura', 909.0000, 'ºC'),
	(316454, 143, '2015-01-15 00:40:05.000000', 'temperatura', 410.0000, 'ºC'),
	(316455, 143, '2015-01-15 00:40:06.000000', 'temperatura', 526.0000, 'ºC'),
	(316456, 143, '2015-01-15 00:40:07.000000', 'temperatura', 198.0000, 'ºC'),
	(316457, 143, '2015-01-15 00:40:08.000000', 'temperatura', 615.0000, 'ºC'),
	(316458, 143, '2015-01-15 00:40:09.000000', 'temperatura', 80.0000, 'ºC'),
	(316459, 143, '2015-01-15 00:40:10.000000', 'temperatura', 957.0000, 'ºC'),
	(316460, 143, '2015-01-15 00:40:11.000000', 'temperatura', 947.0000, 'ºC'),
	(316461, 143, '2015-01-15 00:40:12.000000', 'temperatura', 662.0000, 'ºC'),
	(316462, 143, '2015-01-15 00:40:13.000000', 'temperatura', 469.0000, 'ºC'),
	(316463, 143, '2015-01-15 00:40:14.000000', 'temperatura', 361.0000, 'ºC'),
	(316464, 143, '2015-01-15 00:40:15.000000', 'temperatura', 397.0000, 'ºC'),
	(316465, 143, '2015-01-15 00:40:16.000000', 'temperatura', 902.0000, 'ºC'),
	(316466, 143, '2015-01-15 00:40:17.000000', 'temperatura', 921.0000, 'ºC'),
	(316467, 143, '2015-01-15 00:40:18.000000', 'temperatura', 699.0000, 'ºC'),
	(316468, 143, '2015-01-15 00:40:19.000000', 'temperatura', 732.0000, 'ºC'),
	(316469, 143, '2015-01-15 00:40:20.000000', 'temperatura', 363.0000, 'ºC'),
	(316470, 143, '2015-01-15 00:40:21.000000', 'temperatura', 822.0000, 'ºC'),
	(316471, 143, '2015-01-15 00:40:22.000000', 'temperatura', 619.0000, 'ºC'),
	(316472, 143, '2015-01-15 00:40:23.000000', 'temperatura', 631.0000, 'ºC'),
	(316473, 143, '2015-01-15 00:40:24.000000', 'temperatura', 99.0000, 'ºC'),
	(316474, 143, '2015-01-15 00:40:25.000000', 'temperatura', 1003.0000, 'ºC'),
	(316475, 143, '2015-01-15 00:40:26.000000', 'temperatura', 1119.0000, 'ºC'),
	(316476, 143, '2015-01-15 00:40:27.000000', 'temperatura', 188.0000, 'ºC'),
	(316477, 143, '2015-01-15 00:40:28.000000', 'temperatura', 1180.0000, 'ºC'),
	(316478, 143, '2015-01-15 00:40:29.000000', 'temperatura', 537.0000, 'ºC'),
	(316479, 143, '2015-01-15 00:40:30.000000', 'temperatura', 347.0000, 'ºC'),
	(316480, 143, '2015-01-15 00:40:31.000000', 'temperatura', 124.0000, 'ºC'),
	(316481, 143, '2015-01-15 00:40:32.000000', 'temperatura', 780.0000, 'ºC'),
	(316482, 143, '2015-01-15 00:40:33.000000', 'temperatura', 1127.0000, 'ºC'),
	(316483, 143, '2015-01-15 00:40:34.000000', 'temperatura', 894.0000, 'ºC'),
	(316484, 143, '2015-01-15 00:40:35.000000', 'temperatura', 1092.0000, 'ºC'),
	(316485, 143, '2015-01-15 00:40:36.000000', 'temperatura', 378.0000, 'ºC'),
	(316486, 143, '2015-01-15 00:40:37.000000', 'temperatura', 1014.0000, 'ºC'),
	(316487, 143, '2015-01-15 00:40:38.000000', 'temperatura', 336.0000, 'ºC'),
	(316488, 143, '2015-01-15 00:40:39.000000', 'temperatura', 1040.0000, 'ºC'),
	(316489, 143, '2015-01-15 00:40:40.000000', 'temperatura', 591.0000, 'ºC'),
	(316490, 143, '2015-01-15 00:40:41.000000', 'temperatura', 1034.0000, 'ºC'),
	(316491, 143, '2015-01-15 00:40:42.000000', 'temperatura', 999.0000, 'ºC'),
	(316492, 143, '2015-01-15 00:40:43.000000', 'temperatura', 693.0000, 'ºC'),
	(316493, 143, '2015-01-15 00:40:44.000000', 'temperatura', 470.0000, 'ºC'),
	(316494, 143, '2015-01-15 00:40:45.000000', 'temperatura', 273.0000, 'ºC'),
	(316495, 143, '2015-01-15 00:40:46.000000', 'temperatura', 1152.0000, 'ºC'),
	(316496, 143, '2015-01-15 00:40:47.000000', 'temperatura', 144.0000, 'ºC'),
	(316497, 143, '2015-01-15 00:40:48.000000', 'temperatura', 862.0000, 'ºC'),
	(316498, 143, '2015-01-15 00:40:49.000000', 'temperatura', 278.0000, 'ºC'),
	(316499, 143, '2015-01-15 00:40:50.000000', 'temperatura', 7.0000, 'ºC'),
	(316500, 143, '2015-01-15 00:40:51.000000', 'temperatura', 399.0000, 'ºC'),
	(316501, 143, '2015-01-15 00:40:52.000000', 'temperatura', 774.0000, 'ºC'),
	(316502, 143, '2015-01-15 00:40:53.000000', 'temperatura', 274.0000, 'ºC'),
	(316503, 143, '2015-01-15 00:40:54.000000', 'temperatura', 247.0000, 'ºC'),
	(316504, 143, '2015-01-15 00:40:55.000000', 'temperatura', 416.0000, 'ºC'),
	(316505, 143, '2015-01-15 00:40:56.000000', 'temperatura', 137.0000, 'ºC'),
	(316506, 143, '2015-01-15 00:40:57.000000', 'temperatura', 637.0000, 'ºC'),
	(316507, 143, '2015-01-15 00:40:58.000000', 'temperatura', 375.0000, 'ºC'),
	(316508, 143, '2015-01-15 00:40:59.000000', 'temperatura', 1164.0000, 'ºC'),
	(316509, 143, '2015-01-15 00:41:00.000000', 'temperatura', 1094.0000, 'ºC'),
	(316510, 143, '2015-01-15 00:41:01.000000', 'temperatura', 782.0000, 'ºC'),
	(316511, 143, '2015-01-15 00:41:02.000000', 'temperatura', 627.0000, 'ºC'),
	(316512, 143, '2015-01-15 00:41:03.000000', 'temperatura', 788.0000, 'ºC'),
	(316513, 143, '2015-01-15 00:41:04.000000', 'temperatura', 859.0000, 'ºC'),
	(316514, 143, '2015-01-15 00:41:05.000000', 'temperatura', 733.0000, 'ºC'),
	(316515, 143, '2015-01-15 00:41:06.000000', 'temperatura', 1088.0000, 'ºC'),
	(316516, 143, '2015-01-15 00:41:07.000000', 'temperatura', 841.0000, 'ºC'),
	(316517, 143, '2015-01-15 00:41:08.000000', 'temperatura', 940.0000, 'ºC'),
	(316518, 143, '2015-01-15 00:41:09.000000', 'temperatura', 980.0000, 'ºC'),
	(316519, 143, '2015-01-15 00:41:10.000000', 'temperatura', 879.0000, 'ºC'),
	(316520, 143, '2015-01-15 00:41:11.000000', 'temperatura', 257.0000, 'ºC'),
	(316521, 143, '2015-01-15 00:41:12.000000', 'temperatura', 1049.0000, 'ºC'),
	(316522, 143, '2015-01-15 00:41:13.000000', 'temperatura', 875.0000, 'ºC'),
	(316523, 143, '2015-01-15 00:41:14.000000', 'temperatura', 29.0000, 'ºC'),
	(316524, 143, '2015-01-15 00:41:15.000000', 'temperatura', 1119.0000, 'ºC'),
	(316525, 143, '2015-01-15 00:41:16.000000', 'temperatura', 707.0000, 'ºC'),
	(316526, 143, '2015-01-15 00:41:17.000000', 'temperatura', 180.0000, 'ºC'),
	(316527, 143, '2015-01-15 00:41:18.000000', 'temperatura', 1179.0000, 'ºC'),
	(316528, 143, '2015-01-15 00:41:19.000000', 'temperatura', 557.0000, 'ºC'),
	(316529, 143, '2015-01-15 00:41:20.000000', 'temperatura', 448.0000, 'ºC'),
	(316530, 143, '2015-01-15 00:41:21.000000', 'temperatura', 569.0000, 'ºC'),
	(316531, 143, '2015-01-15 00:41:22.000000', 'temperatura', 303.0000, 'ºC'),
	(316532, 143, '2015-01-15 00:41:23.000000', 'temperatura', 1007.0000, 'ºC'),
	(316533, 143, '2015-01-15 00:41:24.000000', 'temperatura', 527.0000, 'ºC'),
	(316534, 143, '2015-01-15 00:41:25.000000', 'temperatura', 816.0000, 'ºC'),
	(316535, 143, '2015-01-15 00:41:26.000000', 'temperatura', 98.0000, 'ºC'),
	(316536, 143, '2015-01-15 00:41:27.000000', 'temperatura', 441.0000, 'ºC'),
	(316537, 143, '2015-01-15 00:41:28.000000', 'temperatura', 712.0000, 'ºC'),
	(316538, 143, '2015-01-15 00:41:29.000000', 'temperatura', 1040.0000, 'ºC'),
	(316539, 143, '2015-01-15 00:41:30.000000', 'temperatura', 662.0000, 'ºC'),
	(316540, 143, '2015-01-15 00:41:31.000000', 'temperatura', 190.0000, 'ºC'),
	(316541, 143, '2015-01-15 00:41:32.000000', 'temperatura', 165.0000, 'ºC'),
	(316542, 143, '2015-01-15 00:41:33.000000', 'temperatura', 256.0000, 'ºC'),
	(316543, 143, '2015-01-15 00:41:34.000000', 'temperatura', 786.0000, 'ºC'),
	(316544, 143, '2015-01-15 00:41:35.000000', 'temperatura', 763.0000, 'ºC'),
	(316545, 143, '2015-01-15 00:41:36.000000', 'temperatura', 258.0000, 'ºC'),
	(316546, 143, '2015-01-15 00:41:37.000000', 'temperatura', 201.0000, 'ºC'),
	(316547, 143, '2015-01-15 00:41:38.000000', 'temperatura', 232.0000, 'ºC'),
	(316548, 143, '2015-01-15 00:41:39.000000', 'temperatura', 556.0000, 'ºC'),
	(316549, 143, '2015-01-15 00:41:40.000000', 'temperatura', 886.0000, 'ºC'),
	(316550, 143, '2015-01-15 00:41:41.000000', 'temperatura', 361.0000, 'ºC'),
	(316551, 143, '2015-01-15 00:41:42.000000', 'temperatura', 349.0000, 'ºC'),
	(316552, 143, '2015-01-15 00:41:43.000000', 'temperatura', 663.0000, 'ºC'),
	(316553, 143, '2015-01-15 00:41:44.000000', 'temperatura', 1067.0000, 'ºC'),
	(316554, 143, '2015-01-15 00:41:45.000000', 'temperatura', 945.0000, 'ºC'),
	(316555, 143, '2015-01-15 00:41:46.000000', 'temperatura', 326.0000, 'ºC'),
	(316556, 143, '2015-01-15 00:41:47.000000', 'temperatura', 1196.0000, 'ºC'),
	(316557, 143, '2015-01-15 00:41:48.000000', 'temperatura', 204.0000, 'ºC'),
	(316558, 143, '2015-01-15 00:41:49.000000', 'temperatura', 1030.0000, 'ºC'),
	(316559, 143, '2015-01-15 00:41:50.000000', 'temperatura', 938.0000, 'ºC'),
	(316560, 143, '2015-01-15 00:41:51.000000', 'temperatura', 400.0000, 'ºC'),
	(316561, 143, '2015-01-15 00:41:52.000000', 'temperatura', 386.0000, 'ºC'),
	(316562, 143, '2015-01-15 00:41:53.000000', 'temperatura', 729.0000, 'ºC'),
	(316563, 143, '2015-01-15 00:41:54.000000', 'temperatura', 91.0000, 'ºC'),
	(316564, 143, '2015-01-15 00:41:55.000000', 'temperatura', 668.0000, 'ºC'),
	(316565, 143, '2015-01-15 00:41:56.000000', 'temperatura', 669.0000, 'ºC'),
	(316566, 143, '2015-01-15 00:41:57.000000', 'temperatura', 140.0000, 'ºC'),
	(316567, 143, '2015-01-15 00:41:58.000000', 'temperatura', 1093.0000, 'ºC'),
	(316568, 143, '2015-01-15 00:41:59.000000', 'temperatura', 244.0000, 'ºC'),
	(316569, 143, '2015-01-15 00:42:00.000000', 'temperatura', 344.0000, 'ºC'),
	(316570, 143, '2015-01-15 00:42:01.000000', 'temperatura', 989.0000, 'ºC'),
	(316571, 143, '2015-01-15 00:42:02.000000', 'temperatura', 311.0000, 'ºC'),
	(316572, 143, '2015-01-15 00:42:03.000000', 'temperatura', 990.0000, 'ºC'),
	(316573, 143, '2015-01-15 00:42:04.000000', 'temperatura', 419.0000, 'ºC'),
	(316574, 143, '2015-01-15 00:42:05.000000', 'temperatura', 323.0000, 'ºC'),
	(316575, 143, '2015-01-15 00:42:06.000000', 'temperatura', 359.0000, 'ºC'),
	(316576, 143, '2015-01-15 00:42:07.000000', 'temperatura', 825.0000, 'ºC'),
	(316577, 143, '2015-01-15 00:42:08.000000', 'temperatura', 652.0000, 'ºC'),
	(316578, 143, '2015-01-15 00:42:09.000000', 'temperatura', 782.0000, 'ºC'),
	(316579, 143, '2015-01-15 00:42:10.000000', 'temperatura', 757.0000, 'ºC'),
	(316580, 143, '2015-01-15 00:42:11.000000', 'temperatura', 240.0000, 'ºC'),
	(316581, 143, '2015-01-15 00:42:12.000000', 'temperatura', 130.0000, 'ºC'),
	(316582, 143, '2015-01-15 00:42:13.000000', 'temperatura', 1130.0000, 'ºC'),
	(316583, 143, '2015-01-15 00:42:14.000000', 'temperatura', 462.0000, 'ºC'),
	(316584, 143, '2015-01-15 00:42:15.000000', 'temperatura', 119.0000, 'ºC'),
	(316585, 143, '2015-01-15 00:42:16.000000', 'temperatura', 411.0000, 'ºC'),
	(316586, 143, '2015-01-15 00:42:17.000000', 'temperatura', 499.0000, 'ºC'),
	(316587, 143, '2015-01-15 00:42:18.000000', 'temperatura', 63.0000, 'ºC'),
	(316588, 143, '2015-01-15 00:42:19.000000', 'temperatura', 17.0000, 'ºC'),
	(316589, 143, '2015-01-15 00:42:20.000000', 'temperatura', 1098.0000, 'ºC'),
	(316590, 143, '2015-01-15 00:42:21.000000', 'temperatura', 639.0000, 'ºC'),
	(316591, 143, '2015-01-15 00:42:22.000000', 'temperatura', 1103.0000, 'ºC'),
	(316592, 143, '2015-01-15 00:42:23.000000', 'temperatura', 1197.0000, 'ºC'),
	(316593, 143, '2015-01-15 00:42:24.000000', 'temperatura', 276.0000, 'ºC'),
	(316594, 143, '2015-01-15 00:42:25.000000', 'temperatura', 192.0000, 'ºC'),
	(316595, 143, '2015-01-15 00:42:26.000000', 'temperatura', 130.0000, 'ºC'),
	(316596, 143, '2015-01-15 00:42:27.000000', 'temperatura', 76.0000, 'ºC'),
	(316597, 143, '2015-01-15 00:42:28.000000', 'temperatura', 1190.0000, 'ºC'),
	(316598, 143, '2015-01-15 00:42:29.000000', 'temperatura', 923.0000, 'ºC'),
	(316599, 143, '2015-01-15 00:42:30.000000', 'temperatura', 1047.0000, 'ºC'),
	(316600, 143, '2015-01-15 00:42:31.000000', 'temperatura', 65.0000, 'ºC'),
	(316601, 143, '2015-01-15 00:42:32.000000', 'temperatura', 785.0000, 'ºC'),
	(316602, 143, '2015-01-15 00:42:33.000000', 'temperatura', 132.0000, 'ºC'),
	(316603, 143, '2015-01-15 00:42:34.000000', 'temperatura', 703.0000, 'ºC'),
	(316604, 143, '2015-01-15 00:42:35.000000', 'temperatura', 720.0000, 'ºC'),
	(316605, 143, '2015-01-15 00:42:36.000000', 'temperatura', 293.0000, 'ºC'),
	(316606, 143, '2015-01-15 00:42:37.000000', 'temperatura', 505.0000, 'ºC'),
	(316607, 143, '2015-01-15 00:42:38.000000', 'temperatura', 448.0000, 'ºC'),
	(316608, 143, '2015-01-15 00:42:39.000000', 'temperatura', 725.0000, 'ºC'),
	(316609, 143, '2015-01-15 00:42:40.000000', 'temperatura', 1083.0000, 'ºC'),
	(316610, 143, '2015-01-15 00:42:41.000000', 'temperatura', 838.0000, 'ºC'),
	(316611, 143, '2015-01-15 00:42:42.000000', 'temperatura', 941.0000, 'ºC'),
	(316612, 143, '2015-01-15 00:42:43.000000', 'temperatura', 993.0000, 'ºC'),
	(316613, 143, '2015-01-15 00:42:44.000000', 'temperatura', 944.0000, 'ºC'),
	(316614, 143, '2015-01-15 00:42:45.000000', 'temperatura', 540.0000, 'ºC'),
	(316615, 143, '2015-01-15 00:42:46.000000', 'temperatura', 1070.0000, 'ºC'),
	(316616, 143, '2015-01-15 00:42:47.000000', 'temperatura', 128.0000, 'ºC'),
	(316617, 143, '2015-01-15 00:42:48.000000', 'temperatura', 1031.0000, 'ºC'),
	(316618, 143, '2015-01-15 00:42:49.000000', 'temperatura', 1173.0000, 'ºC'),
	(316619, 143, '2015-01-15 00:42:50.000000', 'temperatura', 373.0000, 'ºC'),
	(316620, 143, '2015-01-15 00:42:51.000000', 'temperatura', 747.0000, 'ºC'),
	(316621, 143, '2015-01-15 00:42:52.000000', 'temperatura', 217.0000, 'ºC'),
	(316622, 143, '2015-01-15 00:42:53.000000', 'temperatura', 45.0000, 'ºC'),
	(316623, 143, '2015-01-15 00:42:54.000000', 'temperatura', 775.0000, 'ºC'),
	(316624, 143, '2015-01-15 00:42:55.000000', 'temperatura', 138.0000, 'ºC'),
	(316625, 143, '2015-01-15 00:42:56.000000', 'temperatura', 768.0000, 'ºC'),
	(316626, 143, '2015-01-15 00:42:57.000000', 'temperatura', 1026.0000, 'ºC'),
	(316627, 143, '2015-01-15 00:42:58.000000', 'temperatura', 426.0000, 'ºC'),
	(316628, 143, '2015-01-15 00:42:59.000000', 'temperatura', 252.0000, 'ºC'),
	(316629, 143, '2015-01-15 00:43:00.000000', 'temperatura', 1183.0000, 'ºC'),
	(316630, 143, '2015-01-15 00:43:01.000000', 'temperatura', 360.0000, 'ºC'),
	(316631, 143, '2015-01-15 00:43:02.000000', 'temperatura', 650.0000, 'ºC'),
	(316632, 143, '2015-01-15 00:43:03.000000', 'temperatura', 970.0000, 'ºC'),
	(316633, 143, '2015-01-15 00:43:04.000000', 'temperatura', 502.0000, 'ºC'),
	(316634, 143, '2015-01-15 00:43:05.000000', 'temperatura', 799.0000, 'ºC'),
	(316635, 143, '2015-01-15 00:43:06.000000', 'temperatura', 90.0000, 'ºC'),
	(316636, 143, '2015-01-15 00:43:07.000000', 'temperatura', 454.0000, 'ºC'),
	(316637, 143, '2015-01-15 00:43:08.000000', 'temperatura', 799.0000, 'ºC'),
	(316638, 143, '2015-01-15 00:43:09.000000', 'temperatura', 234.0000, 'ºC'),
	(316639, 143, '2015-01-15 00:43:10.000000', 'temperatura', 1175.0000, 'ºC'),
	(316640, 143, '2015-01-15 00:43:11.000000', 'temperatura', 372.0000, 'ºC'),
	(316641, 143, '2015-01-15 00:43:12.000000', 'temperatura', 735.0000, 'ºC'),
	(316642, 143, '2015-01-15 00:43:13.000000', 'temperatura', 162.0000, 'ºC'),
	(316643, 143, '2015-01-15 00:43:14.000000', 'temperatura', 1005.0000, 'ºC'),
	(316644, 143, '2015-01-15 00:43:15.000000', 'temperatura', 938.0000, 'ºC'),
	(316645, 143, '2015-01-15 00:43:16.000000', 'temperatura', 476.0000, 'ºC'),
	(316646, 143, '2015-01-15 00:43:17.000000', 'temperatura', 765.0000, 'ºC'),
	(316647, 143, '2015-01-15 00:43:18.000000', 'temperatura', 1199.0000, 'ºC'),
	(316648, 143, '2015-01-15 00:43:19.000000', 'temperatura', 100.0000, 'ºC'),
	(316649, 143, '2015-01-15 00:43:20.000000', 'temperatura', 505.0000, 'ºC'),
	(316650, 143, '2015-01-15 00:43:21.000000', 'temperatura', 1024.0000, 'ºC'),
	(316651, 143, '2015-01-15 00:43:22.000000', 'temperatura', 7.0000, 'ºC'),
	(316652, 143, '2015-01-15 00:43:23.000000', 'temperatura', 562.0000, 'ºC'),
	(316653, 143, '2015-01-15 00:43:24.000000', 'temperatura', 391.0000, 'ºC'),
	(316654, 143, '2015-01-15 00:43:25.000000', 'temperatura', 270.0000, 'ºC'),
	(316655, 143, '2015-01-15 00:43:26.000000', 'temperatura', 177.0000, 'ºC'),
	(316656, 143, '2015-01-15 00:43:27.000000', 'temperatura', 76.0000, 'ºC'),
	(316657, 143, '2015-01-15 00:43:28.000000', 'temperatura', 1049.0000, 'ºC'),
	(316658, 143, '2015-01-15 00:43:29.000000', 'temperatura', 218.0000, 'ºC'),
	(316659, 143, '2015-01-15 00:43:30.000000', 'temperatura', 345.0000, 'ºC'),
	(316660, 143, '2015-01-15 00:43:31.000000', 'temperatura', 1070.0000, 'ºC'),
	(316661, 143, '2015-01-15 00:43:32.000000', 'temperatura', 716.0000, 'ºC'),
	(316662, 143, '2015-01-15 00:43:33.000000', 'temperatura', 370.0000, 'ºC'),
	(316663, 143, '2015-01-15 00:43:34.000000', 'temperatura', 904.0000, 'ºC'),
	(316664, 143, '2015-01-15 00:43:35.000000', 'temperatura', 1012.0000, 'ºC'),
	(316665, 143, '2015-01-15 00:43:36.000000', 'temperatura', 1145.0000, 'ºC'),
	(316666, 143, '2015-01-15 00:43:37.000000', 'temperatura', 292.0000, 'ºC'),
	(316667, 143, '2015-01-15 00:43:38.000000', 'temperatura', 424.0000, 'ºC'),
	(316668, 143, '2015-01-15 00:43:39.000000', 'temperatura', 44.0000, 'ºC'),
	(316669, 143, '2015-01-15 00:43:40.000000', 'temperatura', 150.0000, 'ºC'),
	(316670, 143, '2015-01-15 00:43:41.000000', 'temperatura', 617.0000, 'ºC'),
	(316671, 143, '2015-01-15 00:43:42.000000', 'temperatura', 237.0000, 'ºC'),
	(316672, 143, '2015-01-15 00:43:43.000000', 'temperatura', 533.0000, 'ºC'),
	(316673, 143, '2015-01-15 00:43:44.000000', 'temperatura', 756.0000, 'ºC'),
	(316674, 143, '2015-01-15 00:43:45.000000', 'temperatura', 981.0000, 'ºC'),
	(316675, 143, '2015-01-15 00:43:46.000000', 'temperatura', 239.0000, 'ºC'),
	(316676, 143, '2015-01-15 00:43:47.000000', 'temperatura', 650.0000, 'ºC'),
	(316677, 143, '2015-01-15 00:43:48.000000', 'temperatura', 136.0000, 'ºC'),
	(316678, 143, '2015-01-15 00:43:49.000000', 'temperatura', 1129.0000, 'ºC'),
	(316679, 143, '2015-01-15 00:43:50.000000', 'temperatura', 436.0000, 'ºC'),
	(316680, 143, '2015-01-15 00:43:51.000000', 'temperatura', 1194.0000, 'ºC'),
	(316681, 143, '2015-01-15 00:43:52.000000', 'temperatura', 1062.0000, 'ºC'),
	(316682, 143, '2015-01-15 00:43:53.000000', 'temperatura', 528.0000, 'ºC'),
	(316683, 143, '2015-01-15 00:43:54.000000', 'temperatura', 656.0000, 'ºC'),
	(316684, 143, '2015-01-15 00:43:55.000000', 'temperatura', 496.0000, 'ºC'),
	(316685, 143, '2015-01-15 00:43:56.000000', 'temperatura', 514.0000, 'ºC'),
	(316686, 143, '2015-01-15 00:43:57.000000', 'temperatura', 1081.0000, 'ºC'),
	(316687, 143, '2015-01-15 00:43:58.000000', 'temperatura', 266.0000, 'ºC'),
	(316688, 143, '2015-01-15 00:43:59.000000', 'temperatura', 484.0000, 'ºC'),
	(316689, 143, '2015-01-15 00:44:00.000000', 'temperatura', 426.0000, 'ºC'),
	(316690, 143, '2015-01-15 00:44:01.000000', 'temperatura', 677.0000, 'ºC'),
	(316691, 143, '2015-01-15 00:44:02.000000', 'temperatura', 906.0000, 'ºC'),
	(316692, 143, '2015-01-15 00:44:03.000000', 'temperatura', 99.0000, 'ºC'),
	(316693, 143, '2015-01-15 00:44:04.000000', 'temperatura', 178.0000, 'ºC'),
	(316694, 143, '2015-01-15 00:44:05.000000', 'temperatura', 595.0000, 'ºC'),
	(316695, 143, '2015-01-15 00:44:06.000000', 'temperatura', 40.0000, 'ºC'),
	(316696, 143, '2015-01-15 00:44:07.000000', 'temperatura', 816.0000, 'ºC'),
	(316697, 143, '2015-01-15 00:44:08.000000', 'temperatura', 358.0000, 'ºC'),
	(316698, 143, '2015-01-15 00:44:09.000000', 'temperatura', 546.0000, 'ºC'),
	(316699, 143, '2015-01-15 00:44:10.000000', 'temperatura', 455.0000, 'ºC'),
	(316700, 143, '2015-01-15 00:44:11.000000', 'temperatura', 636.0000, 'ºC'),
	(316701, 143, '2015-01-15 00:44:12.000000', 'temperatura', 616.0000, 'ºC'),
	(316702, 143, '2015-01-15 00:44:13.000000', 'temperatura', 1173.0000, 'ºC'),
	(316703, 143, '2015-01-15 00:44:14.000000', 'temperatura', 415.0000, 'ºC'),
	(316704, 143, '2015-01-15 00:44:15.000000', 'temperatura', 960.0000, 'ºC'),
	(316705, 143, '2015-01-15 00:44:16.000000', 'temperatura', 1156.0000, 'ºC'),
	(316706, 143, '2015-01-15 00:44:17.000000', 'temperatura', 497.0000, 'ºC'),
	(316707, 143, '2015-01-15 00:44:18.000000', 'temperatura', 220.0000, 'ºC'),
	(316708, 143, '2015-01-15 00:44:19.000000', 'temperatura', 809.0000, 'ºC'),
	(316709, 143, '2015-01-15 00:44:20.000000', 'temperatura', 986.0000, 'ºC'),
	(316710, 143, '2015-01-15 00:44:21.000000', 'temperatura', 104.0000, 'ºC'),
	(316711, 143, '2015-01-15 00:44:22.000000', 'temperatura', 1161.0000, 'ºC'),
	(316712, 143, '2015-01-15 00:44:23.000000', 'temperatura', 693.0000, 'ºC'),
	(316713, 143, '2015-01-15 00:44:24.000000', 'temperatura', 1183.0000, 'ºC'),
	(316714, 143, '2015-01-15 00:44:25.000000', 'temperatura', 236.0000, 'ºC'),
	(316715, 143, '2015-01-15 00:44:26.000000', 'temperatura', 33.0000, 'ºC'),
	(316716, 143, '2015-01-15 00:44:27.000000', 'temperatura', 655.0000, 'ºC'),
	(316717, 143, '2015-01-15 00:44:28.000000', 'temperatura', 777.0000, 'ºC'),
	(316718, 143, '2015-01-15 00:44:29.000000', 'temperatura', 720.0000, 'ºC'),
	(316719, 143, '2015-01-15 00:44:30.000000', 'temperatura', 71.0000, 'ºC'),
	(316720, 143, '2015-01-15 00:44:31.000000', 'temperatura', 594.0000, 'ºC'),
	(316721, 143, '2015-01-15 00:44:32.000000', 'temperatura', 358.0000, 'ºC'),
	(316722, 143, '2015-01-15 00:44:33.000000', 'temperatura', 8.0000, 'ºC'),
	(316723, 143, '2015-01-15 00:44:34.000000', 'temperatura', 167.0000, 'ºC'),
	(316724, 143, '2015-01-15 00:44:35.000000', 'temperatura', 813.0000, 'ºC'),
	(316725, 143, '2015-01-15 00:44:36.000000', 'temperatura', 1165.0000, 'ºC'),
	(316726, 143, '2015-01-15 00:44:37.000000', 'temperatura', 985.0000, 'ºC'),
	(316727, 143, '2015-01-15 00:44:38.000000', 'temperatura', 232.0000, 'ºC'),
	(316728, 143, '2015-01-15 00:44:39.000000', 'temperatura', 606.0000, 'ºC'),
	(316729, 143, '2015-01-15 00:44:40.000000', 'temperatura', 1132.0000, 'ºC'),
	(316730, 143, '2015-01-15 00:44:41.000000', 'temperatura', 244.0000, 'ºC'),
	(316731, 143, '2015-01-15 00:44:42.000000', 'temperatura', 223.0000, 'ºC'),
	(316732, 143, '2015-01-15 00:44:43.000000', 'temperatura', 384.0000, 'ºC'),
	(316733, 143, '2015-01-15 00:44:44.000000', 'temperatura', 50.0000, 'ºC'),
	(316734, 143, '2015-01-15 00:44:45.000000', 'temperatura', 301.0000, 'ºC'),
	(316735, 143, '2015-01-15 00:44:46.000000', 'temperatura', 155.0000, 'ºC'),
	(316736, 143, '2015-01-15 00:44:47.000000', 'temperatura', 1074.0000, 'ºC'),
	(316737, 143, '2015-01-15 00:44:48.000000', 'temperatura', 104.0000, 'ºC'),
	(316738, 143, '2015-01-15 00:44:49.000000', 'temperatura', 897.0000, 'ºC'),
	(316739, 143, '2015-01-15 00:44:50.000000', 'temperatura', 576.0000, 'ºC'),
	(316740, 143, '2015-01-15 00:44:51.000000', 'temperatura', 187.0000, 'ºC'),
	(316741, 143, '2015-01-15 00:44:52.000000', 'temperatura', 408.0000, 'ºC'),
	(316742, 143, '2015-01-15 00:44:53.000000', 'temperatura', 282.0000, 'ºC'),
	(316743, 143, '2015-01-15 00:44:54.000000', 'temperatura', 183.0000, 'ºC'),
	(316744, 143, '2015-01-15 00:44:55.000000', 'temperatura', 71.0000, 'ºC'),
	(316745, 143, '2015-01-15 00:44:56.000000', 'temperatura', 1008.0000, 'ºC'),
	(316746, 143, '2015-01-15 00:44:57.000000', 'temperatura', 26.0000, 'ºC'),
	(316747, 143, '2015-01-15 00:44:58.000000', 'temperatura', 705.0000, 'ºC'),
	(316748, 143, '2015-01-15 00:44:59.000000', 'temperatura', 1050.0000, 'ºC'),
	(316749, 143, '2015-01-15 00:45:00.000000', 'temperatura', 735.0000, 'ºC'),
	(316750, 143, '2015-01-15 00:45:01.000000', 'temperatura', 527.0000, 'ºC'),
	(316751, 143, '2015-01-15 00:45:02.000000', 'temperatura', 429.0000, 'ºC'),
	(316752, 143, '2015-01-15 00:45:03.000000', 'temperatura', 566.0000, 'ºC'),
	(316753, 143, '2015-01-15 00:45:04.000000', 'temperatura', 342.0000, 'ºC'),
	(316754, 143, '2015-01-15 00:45:05.000000', 'temperatura', 14.0000, 'ºC'),
	(316755, 143, '2015-01-15 00:45:06.000000', 'temperatura', 243.0000, 'ºC'),
	(316756, 143, '2015-01-15 00:45:07.000000', 'temperatura', 1175.0000, 'ºC'),
	(316757, 143, '2015-01-15 00:45:08.000000', 'temperatura', 346.0000, 'ºC'),
	(316758, 143, '2015-01-15 00:45:09.000000', 'temperatura', 606.0000, 'ºC'),
	(316759, 143, '2015-01-15 00:45:10.000000', 'temperatura', 793.0000, 'ºC'),
	(316760, 143, '2015-01-15 00:45:11.000000', 'temperatura', 949.0000, 'ºC'),
	(316761, 143, '2015-01-15 00:45:12.000000', 'temperatura', 1164.0000, 'ºC'),
	(316762, 143, '2015-01-15 00:45:13.000000', 'temperatura', 573.0000, 'ºC'),
	(316763, 143, '2015-01-15 00:45:14.000000', 'temperatura', 575.0000, 'ºC'),
	(316764, 143, '2015-01-15 00:45:15.000000', 'temperatura', 1156.0000, 'ºC'),
	(316765, 143, '2015-01-15 00:45:16.000000', 'temperatura', 457.0000, 'ºC'),
	(316766, 143, '2015-01-15 00:45:17.000000', 'temperatura', 18.0000, 'ºC'),
	(316767, 143, '2015-01-15 00:45:18.000000', 'temperatura', 1118.0000, 'ºC'),
	(316768, 143, '2015-01-15 00:45:19.000000', 'temperatura', 736.0000, 'ºC'),
	(316769, 143, '2015-01-15 00:45:20.000000', 'temperatura', 327.0000, 'ºC'),
	(316770, 143, '2015-01-15 00:45:21.000000', 'temperatura', 629.0000, 'ºC'),
	(316771, 143, '2015-01-15 00:45:22.000000', 'temperatura', 962.0000, 'ºC'),
	(316772, 143, '2015-01-15 00:45:23.000000', 'temperatura', 525.0000, 'ºC'),
	(316773, 143, '2015-01-15 00:45:24.000000', 'temperatura', 941.0000, 'ºC'),
	(316774, 143, '2015-01-15 00:45:25.000000', 'temperatura', 728.0000, 'ºC'),
	(316775, 143, '2015-01-15 00:45:26.000000', 'temperatura', 820.0000, 'ºC'),
	(316776, 143, '2015-01-15 00:45:27.000000', 'temperatura', 714.0000, 'ºC'),
	(316777, 143, '2015-01-15 00:45:28.000000', 'temperatura', 1112.0000, 'ºC'),
	(316778, 143, '2015-01-15 00:45:29.000000', 'temperatura', 1020.0000, 'ºC'),
	(316779, 143, '2015-01-15 00:45:30.000000', 'temperatura', 564.0000, 'ºC'),
	(316780, 143, '2015-01-15 00:45:31.000000', 'temperatura', 961.0000, 'ºC'),
	(316781, 143, '2015-01-15 00:45:32.000000', 'temperatura', 713.0000, 'ºC'),
	(316782, 143, '2015-01-15 00:45:33.000000', 'temperatura', 684.0000, 'ºC'),
	(316783, 143, '2015-01-15 00:45:34.000000', 'temperatura', 79.0000, 'ºC'),
	(316784, 143, '2015-01-15 00:45:35.000000', 'temperatura', 742.0000, 'ºC'),
	(316785, 143, '2015-01-15 00:45:36.000000', 'temperatura', 1077.0000, 'ºC'),
	(316786, 143, '2015-01-15 00:45:37.000000', 'temperatura', 758.0000, 'ºC'),
	(316787, 143, '2015-01-15 00:45:38.000000', 'temperatura', 561.0000, 'ºC'),
	(316788, 143, '2015-01-15 00:45:39.000000', 'temperatura', 532.0000, 'ºC'),
	(316789, 143, '2015-01-15 00:45:40.000000', 'temperatura', 975.0000, 'ºC'),
	(316790, 143, '2015-01-15 00:45:41.000000', 'temperatura', 882.0000, 'ºC'),
	(316791, 143, '2015-01-15 00:45:42.000000', 'temperatura', 283.0000, 'ºC'),
	(316792, 143, '2015-01-15 00:45:43.000000', 'temperatura', 1169.0000, 'ºC'),
	(316793, 143, '2015-01-15 00:45:44.000000', 'temperatura', 197.0000, 'ºC'),
	(316794, 143, '2015-01-15 00:45:45.000000', 'temperatura', 1080.0000, 'ºC'),
	(316795, 143, '2015-01-15 00:45:46.000000', 'temperatura', 8.0000, 'ºC'),
	(316796, 143, '2015-01-15 00:45:47.000000', 'temperatura', 402.0000, 'ºC'),
	(316797, 143, '2015-01-15 00:45:48.000000', 'temperatura', 784.0000, 'ºC'),
	(316798, 143, '2015-01-15 00:45:49.000000', 'temperatura', 314.0000, 'ºC'),
	(316799, 143, '2015-01-15 00:45:50.000000', 'temperatura', 421.0000, 'ºC'),
	(316800, 143, '2015-01-15 00:45:51.000000', 'temperatura', 1164.0000, 'ºC'),
	(316801, 143, '2015-01-15 00:45:52.000000', 'temperatura', 956.0000, 'ºC'),
	(316802, 143, '2015-01-15 00:45:53.000000', 'temperatura', 89.0000, 'ºC'),
	(316803, 143, '2015-01-15 00:45:54.000000', 'temperatura', 1177.0000, 'ºC'),
	(316804, 143, '2015-01-15 00:45:55.000000', 'temperatura', 820.0000, 'ºC'),
	(316805, 143, '2015-01-15 00:45:56.000000', 'temperatura', 569.0000, 'ºC'),
	(316806, 143, '2015-01-15 00:45:57.000000', 'temperatura', 386.0000, 'ºC'),
	(316807, 143, '2015-01-15 00:45:58.000000', 'temperatura', 225.0000, 'ºC'),
	(316808, 143, '2015-01-15 00:45:59.000000', 'temperatura', 1167.0000, 'ºC'),
	(316809, 143, '2015-01-15 00:46:00.000000', 'temperatura', 358.0000, 'ºC'),
	(316810, 143, '2015-01-15 00:46:01.000000', 'temperatura', 690.0000, 'ºC'),
	(316811, 143, '2015-01-15 00:46:02.000000', 'temperatura', 1179.0000, 'ºC'),
	(316812, 143, '2015-01-15 00:46:03.000000', 'temperatura', 223.0000, 'ºC'),
	(316813, 143, '2015-01-15 00:46:04.000000', 'temperatura', 1177.0000, 'ºC'),
	(316814, 143, '2015-01-15 00:46:05.000000', 'temperatura', 420.0000, 'ºC'),
	(316815, 143, '2015-01-15 00:46:06.000000', 'temperatura', 967.0000, 'ºC'),
	(316816, 143, '2015-01-15 00:46:07.000000', 'temperatura', 1177.0000, 'ºC'),
	(316817, 143, '2015-01-15 00:46:08.000000', 'temperatura', 586.0000, 'ºC'),
	(316818, 143, '2015-01-15 00:46:09.000000', 'temperatura', 597.0000, 'ºC'),
	(316819, 143, '2015-01-15 00:46:10.000000', 'temperatura', 29.0000, 'ºC'),
	(316820, 143, '2015-01-15 00:46:11.000000', 'temperatura', 753.0000, 'ºC'),
	(316821, 143, '2015-01-15 00:46:12.000000', 'temperatura', 78.0000, 'ºC'),
	(316822, 143, '2015-01-15 00:46:13.000000', 'temperatura', 533.0000, 'ºC'),
	(316823, 143, '2015-01-15 00:46:14.000000', 'temperatura', 32.0000, 'ºC'),
	(316824, 143, '2015-01-15 00:46:15.000000', 'temperatura', 962.0000, 'ºC'),
	(316825, 143, '2015-01-15 00:46:16.000000', 'temperatura', 1115.0000, 'ºC'),
	(316826, 143, '2015-01-15 00:46:17.000000', 'temperatura', 290.0000, 'ºC'),
	(316827, 143, '2015-01-15 00:46:18.000000', 'temperatura', 506.0000, 'ºC'),
	(316828, 143, '2015-01-15 00:46:19.000000', 'temperatura', 461.0000, 'ºC'),
	(316829, 143, '2015-01-15 00:46:20.000000', 'temperatura', 785.0000, 'ºC'),
	(316830, 143, '2015-01-15 00:46:21.000000', 'temperatura', 142.0000, 'ºC'),
	(316831, 143, '2015-01-15 00:46:22.000000', 'temperatura', 758.0000, 'ºC'),
	(316832, 143, '2015-01-15 00:46:23.000000', 'temperatura', 963.0000, 'ºC'),
	(316833, 143, '2015-01-15 00:46:24.000000', 'temperatura', 142.0000, 'ºC'),
	(316834, 143, '2015-01-15 00:46:25.000000', 'temperatura', 220.0000, 'ºC'),
	(316835, 143, '2015-01-15 00:46:26.000000', 'temperatura', 676.0000, 'ºC'),
	(316836, 143, '2015-01-15 00:46:27.000000', 'temperatura', 320.0000, 'ºC'),
	(316837, 143, '2015-01-15 00:46:28.000000', 'temperatura', 774.0000, 'ºC'),
	(316838, 143, '2015-01-15 00:46:29.000000', 'temperatura', 509.0000, 'ºC'),
	(316839, 143, '2015-01-15 00:46:30.000000', 'temperatura', 225.0000, 'ºC'),
	(316840, 143, '2015-01-15 00:46:31.000000', 'temperatura', 797.0000, 'ºC'),
	(316841, 143, '2015-01-15 00:46:32.000000', 'temperatura', 909.0000, 'ºC'),
	(316842, 143, '2015-01-15 00:46:33.000000', 'temperatura', 958.0000, 'ºC'),
	(316843, 143, '2015-01-15 00:46:34.000000', 'temperatura', 860.0000, 'ºC'),
	(316844, 143, '2015-01-15 00:46:35.000000', 'temperatura', 228.0000, 'ºC'),
	(316845, 143, '2015-01-15 00:46:36.000000', 'temperatura', 962.0000, 'ºC'),
	(316846, 143, '2015-01-15 00:46:37.000000', 'temperatura', 528.0000, 'ºC'),
	(316847, 143, '2015-01-15 00:46:38.000000', 'temperatura', 951.0000, 'ºC'),
	(316848, 143, '2015-01-15 00:46:39.000000', 'temperatura', 771.0000, 'ºC'),
	(316849, 143, '2015-01-15 00:46:40.000000', 'temperatura', 1006.0000, 'ºC'),
	(316850, 143, '2015-01-15 00:46:41.000000', 'temperatura', 315.0000, 'ºC'),
	(316851, 143, '2015-01-15 00:46:42.000000', 'temperatura', 956.0000, 'ºC'),
	(316852, 143, '2015-01-15 00:46:43.000000', 'temperatura', 239.0000, 'ºC'),
	(316853, 143, '2015-01-15 00:46:44.000000', 'temperatura', 725.0000, 'ºC'),
	(316854, 143, '2015-01-15 00:46:45.000000', 'temperatura', 510.0000, 'ºC'),
	(316855, 143, '2015-01-15 00:46:46.000000', 'temperatura', 374.0000, 'ºC'),
	(316856, 143, '2015-01-15 00:46:47.000000', 'temperatura', 342.0000, 'ºC'),
	(316857, 143, '2015-01-15 00:46:48.000000', 'temperatura', 587.0000, 'ºC'),
	(316858, 143, '2015-01-15 00:46:49.000000', 'temperatura', 709.0000, 'ºC'),
	(316859, 143, '2015-01-15 00:46:50.000000', 'temperatura', 586.0000, 'ºC'),
	(316860, 143, '2015-01-15 00:46:51.000000', 'temperatura', 805.0000, 'ºC'),
	(316861, 143, '2015-01-15 00:46:52.000000', 'temperatura', 1065.0000, 'ºC'),
	(316862, 143, '2015-01-15 00:46:53.000000', 'temperatura', 510.0000, 'ºC'),
	(316863, 143, '2015-01-15 00:46:54.000000', 'temperatura', 557.0000, 'ºC'),
	(316864, 143, '2015-01-15 00:46:55.000000', 'temperatura', 56.0000, 'ºC'),
	(316865, 143, '2015-01-15 00:46:56.000000', 'temperatura', 1011.0000, 'ºC'),
	(316866, 143, '2015-01-15 00:46:57.000000', 'temperatura', 84.0000, 'ºC'),
	(316867, 143, '2015-01-15 00:46:58.000000', 'temperatura', 990.0000, 'ºC'),
	(316868, 143, '2015-01-15 00:46:59.000000', 'temperatura', 1099.0000, 'ºC'),
	(316869, 143, '2015-01-15 00:47:00.000000', 'temperatura', 123.0000, 'ºC'),
	(316870, 143, '2015-01-15 00:47:01.000000', 'temperatura', 921.0000, 'ºC'),
	(316871, 143, '2015-01-15 00:47:02.000000', 'temperatura', 634.0000, 'ºC'),
	(316872, 143, '2015-01-15 00:47:03.000000', 'temperatura', 411.0000, 'ºC'),
	(316873, 143, '2015-01-15 00:47:04.000000', 'temperatura', 150.0000, 'ºC'),
	(316874, 143, '2015-01-15 00:47:05.000000', 'temperatura', 718.0000, 'ºC'),
	(316875, 143, '2015-01-15 00:47:06.000000', 'temperatura', 741.0000, 'ºC'),
	(316876, 143, '2015-01-15 00:47:07.000000', 'temperatura', 352.0000, 'ºC'),
	(316877, 143, '2015-01-15 00:47:08.000000', 'temperatura', 737.0000, 'ºC'),
	(316878, 143, '2015-01-15 00:47:09.000000', 'temperatura', 230.0000, 'ºC'),
	(316879, 143, '2015-01-15 00:47:10.000000', 'temperatura', 138.0000, 'ºC'),
	(316880, 143, '2015-01-15 00:47:11.000000', 'temperatura', 2.0000, 'ºC'),
	(316881, 143, '2015-01-15 00:47:12.000000', 'temperatura', 795.0000, 'ºC'),
	(316882, 143, '2015-01-15 00:47:13.000000', 'temperatura', 371.0000, 'ºC'),
	(316883, 143, '2015-01-15 00:47:14.000000', 'temperatura', 671.0000, 'ºC'),
	(316884, 143, '2015-01-15 00:47:15.000000', 'temperatura', 1040.0000, 'ºC'),
	(316885, 143, '2015-01-15 00:47:16.000000', 'temperatura', 788.0000, 'ºC'),
	(316886, 143, '2015-01-15 00:47:17.000000', 'temperatura', 820.0000, 'ºC'),
	(316887, 143, '2015-01-15 00:47:18.000000', 'temperatura', 538.0000, 'ºC'),
	(316888, 143, '2015-01-15 00:47:19.000000', 'temperatura', 230.0000, 'ºC'),
	(316889, 143, '2015-01-15 00:47:20.000000', 'temperatura', 737.0000, 'ºC'),
	(316890, 143, '2015-01-15 00:47:21.000000', 'temperatura', 593.0000, 'ºC'),
	(316891, 143, '2015-01-15 00:47:22.000000', 'temperatura', 756.0000, 'ºC'),
	(316892, 143, '2015-01-15 00:47:23.000000', 'temperatura', 803.0000, 'ºC'),
	(316893, 143, '2015-01-15 00:47:24.000000', 'temperatura', 546.0000, 'ºC'),
	(316894, 143, '2015-01-15 00:47:25.000000', 'temperatura', 324.0000, 'ºC'),
	(316895, 143, '2015-01-15 00:47:26.000000', 'temperatura', 1181.0000, 'ºC'),
	(316896, 143, '2015-01-15 00:47:27.000000', 'temperatura', 132.0000, 'ºC'),
	(316897, 143, '2015-01-15 00:47:28.000000', 'temperatura', 719.0000, 'ºC'),
	(316898, 143, '2015-01-15 00:47:29.000000', 'temperatura', 798.0000, 'ºC'),
	(316899, 143, '2015-01-15 00:47:30.000000', 'temperatura', 635.0000, 'ºC'),
	(316900, 143, '2015-01-15 00:47:31.000000', 'temperatura', 780.0000, 'ºC'),
	(316901, 143, '2015-01-15 00:47:32.000000', 'temperatura', 794.0000, 'ºC'),
	(316902, 143, '2015-01-15 00:47:33.000000', 'temperatura', 433.0000, 'ºC'),
	(316903, 143, '2015-01-15 00:47:34.000000', 'temperatura', 984.0000, 'ºC'),
	(316904, 143, '2015-01-15 00:47:35.000000', 'temperatura', 22.0000, 'ºC'),
	(316905, 143, '2015-01-15 00:47:36.000000', 'temperatura', 758.0000, 'ºC'),
	(316906, 143, '2015-01-15 00:47:37.000000', 'temperatura', 123.0000, 'ºC'),
	(316907, 143, '2015-01-15 00:47:38.000000', 'temperatura', 743.0000, 'ºC'),
	(316908, 143, '2015-01-15 00:47:39.000000', 'temperatura', 948.0000, 'ºC'),
	(316909, 143, '2015-01-15 00:47:40.000000', 'temperatura', 111.0000, 'ºC'),
	(316910, 143, '2015-01-15 00:47:41.000000', 'temperatura', 109.0000, 'ºC'),
	(316911, 143, '2015-01-15 00:47:42.000000', 'temperatura', 215.0000, 'ºC'),
	(316912, 143, '2015-01-15 00:47:43.000000', 'temperatura', 748.0000, 'ºC'),
	(316913, 143, '2015-01-15 00:47:44.000000', 'temperatura', 697.0000, 'ºC'),
	(316914, 143, '2015-01-15 00:47:45.000000', 'temperatura', 42.0000, 'ºC'),
	(316915, 143, '2015-01-15 00:47:46.000000', 'temperatura', 519.0000, 'ºC'),
	(316916, 143, '2015-01-15 00:47:47.000000', 'temperatura', 68.0000, 'ºC'),
	(316917, 143, '2015-01-15 00:47:48.000000', 'temperatura', 1186.0000, 'ºC'),
	(316918, 143, '2015-01-15 00:47:49.000000', 'temperatura', 924.0000, 'ºC'),
	(316919, 143, '2015-01-15 00:47:50.000000', 'temperatura', 1062.0000, 'ºC'),
	(316920, 143, '2015-01-15 00:47:51.000000', 'temperatura', 138.0000, 'ºC'),
	(316921, 143, '2015-01-15 00:47:52.000000', 'temperatura', 1107.0000, 'ºC'),
	(316922, 143, '2015-01-15 00:47:53.000000', 'temperatura', 320.0000, 'ºC'),
	(316923, 143, '2015-01-15 00:47:54.000000', 'temperatura', 681.0000, 'ºC'),
	(316924, 143, '2015-01-15 00:47:55.000000', 'temperatura', 47.0000, 'ºC'),
	(316925, 143, '2015-01-15 00:47:56.000000', 'temperatura', 589.0000, 'ºC'),
	(316926, 143, '2015-01-15 00:47:57.000000', 'temperatura', 405.0000, 'ºC'),
	(316927, 143, '2015-01-15 00:47:58.000000', 'temperatura', 258.0000, 'ºC'),
	(316928, 143, '2015-01-15 00:47:59.000000', 'temperatura', 78.0000, 'ºC'),
	(316929, 143, '2015-01-15 00:48:00.000000', 'temperatura', 816.0000, 'ºC'),
	(316930, 143, '2015-01-15 00:48:01.000000', 'temperatura', 248.0000, 'ºC'),
	(316931, 143, '2015-01-15 00:48:02.000000', 'temperatura', 1189.0000, 'ºC'),
	(316932, 143, '2015-01-15 00:48:03.000000', 'temperatura', 404.0000, 'ºC'),
	(316933, 143, '2015-01-15 00:48:04.000000', 'temperatura', 855.0000, 'ºC'),
	(316934, 143, '2015-01-15 00:48:05.000000', 'temperatura', 662.0000, 'ºC'),
	(316935, 143, '2015-01-15 00:48:06.000000', 'temperatura', 744.0000, 'ºC'),
	(316936, 143, '2015-01-15 00:48:07.000000', 'temperatura', 534.0000, 'ºC'),
	(316937, 143, '2015-01-15 00:48:08.000000', 'temperatura', 438.0000, 'ºC'),
	(316938, 143, '2015-01-15 00:48:09.000000', 'temperatura', 591.0000, 'ºC'),
	(316939, 143, '2015-01-15 00:48:10.000000', 'temperatura', 442.0000, 'ºC'),
	(316940, 143, '2015-01-15 00:48:11.000000', 'temperatura', 438.0000, 'ºC'),
	(316941, 143, '2015-01-15 00:48:12.000000', 'temperatura', 863.0000, 'ºC'),
	(316942, 143, '2015-01-15 00:48:13.000000', 'temperatura', 602.0000, 'ºC'),
	(316943, 143, '2015-01-15 00:48:14.000000', 'temperatura', 423.0000, 'ºC'),
	(316944, 143, '2015-01-15 00:48:15.000000', 'temperatura', 310.0000, 'ºC'),
	(316945, 143, '2015-01-15 00:48:16.000000', 'temperatura', 282.0000, 'ºC'),
	(316946, 143, '2015-01-15 00:48:17.000000', 'temperatura', 480.0000, 'ºC'),
	(316947, 143, '2015-01-15 00:48:18.000000', 'temperatura', 355.0000, 'ºC'),
	(316948, 143, '2015-01-15 00:48:19.000000', 'temperatura', 337.0000, 'ºC'),
	(316949, 143, '2015-01-15 00:48:20.000000', 'temperatura', 619.0000, 'ºC'),
	(316950, 143, '2015-01-15 00:48:21.000000', 'temperatura', 883.0000, 'ºC'),
	(316951, 143, '2015-01-15 00:48:22.000000', 'temperatura', 162.0000, 'ºC'),
	(316952, 143, '2015-01-15 00:48:23.000000', 'temperatura', 558.0000, 'ºC'),
	(316953, 143, '2015-01-15 00:48:24.000000', 'temperatura', 1108.0000, 'ºC'),
	(316954, 143, '2015-01-15 00:48:25.000000', 'temperatura', 263.0000, 'ºC'),
	(316955, 143, '2015-01-15 00:48:26.000000', 'temperatura', 395.0000, 'ºC'),
	(316956, 143, '2015-01-15 00:48:27.000000', 'temperatura', 1185.0000, 'ºC'),
	(316957, 143, '2015-01-15 00:48:28.000000', 'temperatura', 1139.0000, 'ºC'),
	(316958, 143, '2015-01-15 00:48:29.000000', 'temperatura', 943.0000, 'ºC'),
	(316959, 143, '2015-01-15 00:48:30.000000', 'temperatura', 98.0000, 'ºC'),
	(316960, 143, '2015-01-15 00:48:31.000000', 'temperatura', 59.0000, 'ºC'),
	(316961, 143, '2015-01-15 00:48:32.000000', 'temperatura', 3.0000, 'ºC'),
	(316962, 143, '2015-01-15 00:48:33.000000', 'temperatura', 1039.0000, 'ºC'),
	(316963, 143, '2015-01-15 00:48:34.000000', 'temperatura', 387.0000, 'ºC'),
	(316964, 143, '2015-01-15 00:48:35.000000', 'temperatura', 16.0000, 'ºC'),
	(316965, 143, '2015-01-15 00:48:36.000000', 'temperatura', 121.0000, 'ºC'),
	(316966, 143, '2015-01-15 00:48:37.000000', 'temperatura', 556.0000, 'ºC'),
	(316967, 143, '2015-01-15 00:48:38.000000', 'temperatura', 18.0000, 'ºC'),
	(316968, 143, '2015-01-15 00:48:39.000000', 'temperatura', 823.0000, 'ºC'),
	(316969, 143, '2015-01-15 00:48:40.000000', 'temperatura', 460.0000, 'ºC'),
	(316970, 143, '2015-01-15 00:48:41.000000', 'temperatura', 1034.0000, 'ºC'),
	(316971, 143, '2015-01-15 00:48:42.000000', 'temperatura', 190.0000, 'ºC'),
	(316972, 143, '2015-01-15 00:48:43.000000', 'temperatura', 249.0000, 'ºC'),
	(316973, 143, '2015-01-15 00:48:44.000000', 'temperatura', 676.0000, 'ºC'),
	(316974, 143, '2015-01-15 00:48:45.000000', 'temperatura', 234.0000, 'ºC'),
	(316975, 143, '2015-01-15 00:48:46.000000', 'temperatura', 341.0000, 'ºC'),
	(316976, 143, '2015-01-15 00:48:47.000000', 'temperatura', 1006.0000, 'ºC'),
	(316977, 143, '2015-01-15 00:48:48.000000', 'temperatura', 405.0000, 'ºC'),
	(316978, 143, '2015-01-15 00:48:49.000000', 'temperatura', 207.0000, 'ºC'),
	(316979, 143, '2015-01-15 00:48:50.000000', 'temperatura', 1020.0000, 'ºC'),
	(316980, 143, '2015-01-15 00:48:51.000000', 'temperatura', 880.0000, 'ºC'),
	(316981, 143, '2015-01-15 00:48:52.000000', 'temperatura', 142.0000, 'ºC'),
	(316982, 143, '2015-01-15 00:48:53.000000', 'temperatura', 472.0000, 'ºC'),
	(316983, 143, '2015-01-15 00:48:54.000000', 'temperatura', 732.0000, 'ºC'),
	(316984, 143, '2015-01-15 00:48:55.000000', 'temperatura', 1045.0000, 'ºC'),
	(316985, 143, '2015-01-15 00:48:56.000000', 'temperatura', 631.0000, 'ºC'),
	(316986, 143, '2015-01-15 00:48:57.000000', 'temperatura', 19.0000, 'ºC'),
	(316987, 143, '2015-01-15 00:48:58.000000', 'temperatura', 602.0000, 'ºC'),
	(316988, 143, '2015-01-15 00:48:59.000000', 'temperatura', 554.0000, 'ºC'),
	(316989, 143, '2015-01-15 00:49:00.000000', 'temperatura', 963.0000, 'ºC'),
	(316990, 143, '2015-01-15 00:49:01.000000', 'temperatura', 756.0000, 'ºC'),
	(316991, 143, '2015-01-15 00:49:02.000000', 'temperatura', 891.0000, 'ºC'),
	(316992, 143, '2015-01-15 00:49:03.000000', 'temperatura', 987.0000, 'ºC'),
	(316993, 143, '2015-01-15 00:49:04.000000', 'temperatura', 1064.0000, 'ºC'),
	(316994, 143, '2015-01-15 00:49:05.000000', 'temperatura', 1160.0000, 'ºC'),
	(316995, 143, '2015-01-15 00:49:06.000000', 'temperatura', 207.0000, 'ºC'),
	(316996, 143, '2015-01-15 00:49:07.000000', 'temperatura', 1154.0000, 'ºC'),
	(316997, 143, '2015-01-15 00:49:08.000000', 'temperatura', 350.0000, 'ºC'),
	(316998, 143, '2015-01-15 00:49:09.000000', 'temperatura', 691.0000, 'ºC'),
	(316999, 143, '2015-01-15 00:49:10.000000', 'temperatura', 2.0000, 'ºC'),
	(317000, 143, '2015-01-15 00:49:11.000000', 'temperatura', 340.0000, 'ºC'),
	(317001, 143, '2015-01-15 00:49:12.000000', 'temperatura', 493.0000, 'ºC'),
	(317002, 143, '2015-01-15 00:49:13.000000', 'temperatura', 247.0000, 'ºC'),
	(317003, 143, '2015-01-15 00:49:14.000000', 'temperatura', 958.0000, 'ºC'),
	(317004, 143, '2015-01-15 00:49:15.000000', 'temperatura', 447.0000, 'ºC'),
	(317005, 143, '2015-01-15 00:49:16.000000', 'temperatura', 562.0000, 'ºC'),
	(317006, 143, '2015-01-15 00:49:17.000000', 'temperatura', 270.0000, 'ºC'),
	(317007, 143, '2015-01-15 00:49:18.000000', 'temperatura', 864.0000, 'ºC'),
	(317008, 143, '2015-01-15 00:49:19.000000', 'temperatura', 1112.0000, 'ºC'),
	(317009, 143, '2015-01-15 00:49:20.000000', 'temperatura', 568.0000, 'ºC'),
	(317010, 143, '2015-01-15 00:49:21.000000', 'temperatura', 705.0000, 'ºC'),
	(317011, 143, '2015-01-15 00:49:22.000000', 'temperatura', 623.0000, 'ºC'),
	(317012, 143, '2015-01-15 00:49:23.000000', 'temperatura', 999.0000, 'ºC'),
	(317013, 143, '2015-01-15 00:49:24.000000', 'temperatura', 728.0000, 'ºC'),
	(317014, 143, '2015-01-15 00:49:25.000000', 'temperatura', 642.0000, 'ºC'),
	(317015, 143, '2015-01-15 00:49:26.000000', 'temperatura', 1026.0000, 'ºC'),
	(317016, 143, '2015-01-15 00:49:27.000000', 'temperatura', 805.0000, 'ºC'),
	(317017, 143, '2015-01-15 00:49:28.000000', 'temperatura', 946.0000, 'ºC'),
	(317018, 143, '2015-01-15 00:49:29.000000', 'temperatura', 1117.0000, 'ºC'),
	(317019, 143, '2015-01-15 00:49:30.000000', 'temperatura', 348.0000, 'ºC'),
	(317020, 143, '2015-01-15 00:49:31.000000', 'temperatura', 789.0000, 'ºC'),
	(317021, 143, '2015-01-15 00:49:32.000000', 'temperatura', 500.0000, 'ºC'),
	(317022, 143, '2015-01-15 00:49:33.000000', 'temperatura', 133.0000, 'ºC'),
	(317023, 143, '2015-01-15 00:49:34.000000', 'temperatura', 367.0000, 'ºC'),
	(317024, 143, '2015-01-15 00:49:35.000000', 'temperatura', 238.0000, 'ºC'),
	(317025, 143, '2015-01-15 00:49:36.000000', 'temperatura', 89.0000, 'ºC'),
	(317026, 143, '2015-01-15 00:49:37.000000', 'temperatura', 929.0000, 'ºC'),
	(317027, 143, '2015-01-15 00:49:38.000000', 'temperatura', 780.0000, 'ºC'),
	(317028, 143, '2015-01-15 00:49:39.000000', 'temperatura', 1113.0000, 'ºC'),
	(317029, 143, '2015-01-15 00:49:40.000000', 'temperatura', 825.0000, 'ºC'),
	(317030, 143, '2015-01-15 00:49:41.000000', 'temperatura', 788.0000, 'ºC'),
	(317031, 143, '2015-01-15 00:49:42.000000', 'temperatura', 265.0000, 'ºC'),
	(317032, 143, '2015-01-15 00:49:43.000000', 'temperatura', 159.0000, 'ºC'),
	(317033, 143, '2015-01-15 00:49:44.000000', 'temperatura', 4.0000, 'ºC'),
	(317034, 143, '2015-01-15 00:49:45.000000', 'temperatura', 743.0000, 'ºC'),
	(317035, 143, '2015-01-15 00:49:46.000000', 'temperatura', 104.0000, 'ºC'),
	(317036, 143, '2015-01-15 00:49:47.000000', 'temperatura', 691.0000, 'ºC'),
	(317037, 143, '2015-01-15 00:49:48.000000', 'temperatura', 742.0000, 'ºC'),
	(317038, 143, '2015-01-15 00:49:49.000000', 'temperatura', 437.0000, 'ºC'),
	(317039, 143, '2015-01-15 00:49:50.000000', 'temperatura', 1160.0000, 'ºC'),
	(317040, 143, '2015-01-15 00:49:51.000000', 'temperatura', 891.0000, 'ºC'),
	(317041, 143, '2015-01-15 00:49:52.000000', 'temperatura', 977.0000, 'ºC'),
	(317042, 143, '2015-01-15 00:49:53.000000', 'temperatura', 1010.0000, 'ºC'),
	(317043, 143, '2015-01-15 00:49:54.000000', 'temperatura', 919.0000, 'ºC'),
	(317044, 143, '2015-01-15 00:49:55.000000', 'temperatura', 368.0000, 'ºC'),
	(317045, 143, '2015-01-15 00:49:56.000000', 'temperatura', 282.0000, 'ºC'),
	(317046, 143, '2015-01-15 00:49:57.000000', 'temperatura', 306.0000, 'ºC'),
	(317047, 143, '2015-01-15 00:49:58.000000', 'temperatura', 685.0000, 'ºC'),
	(317048, 143, '2015-01-15 00:49:59.000000', 'temperatura', 107.0000, 'ºC'),
	(317049, 143, '2015-01-15 00:50:00.000000', 'temperatura', 880.0000, 'ºC'),
	(317050, 143, '2015-01-15 00:50:01.000000', 'temperatura', 478.0000, 'ºC'),
	(317051, 143, '2015-01-15 00:50:02.000000', 'temperatura', 953.0000, 'ºC'),
	(317052, 143, '2015-01-15 00:50:03.000000', 'temperatura', 930.0000, 'ºC'),
	(317053, 143, '2015-01-15 00:50:04.000000', 'temperatura', 590.0000, 'ºC'),
	(317054, 143, '2015-01-15 00:50:05.000000', 'temperatura', 162.0000, 'ºC'),
	(317055, 143, '2015-01-15 00:50:06.000000', 'temperatura', 239.0000, 'ºC'),
	(317056, 143, '2015-01-15 00:50:07.000000', 'temperatura', 709.0000, 'ºC'),
	(317057, 143, '2015-01-15 00:50:08.000000', 'temperatura', 430.0000, 'ºC'),
	(317058, 143, '2015-01-15 00:50:09.000000', 'temperatura', 23.0000, 'ºC'),
	(317059, 143, '2015-01-15 00:50:10.000000', 'temperatura', 25.0000, 'ºC'),
	(317060, 143, '2015-01-15 00:50:11.000000', 'temperatura', 58.0000, 'ºC'),
	(317061, 143, '2015-01-15 00:50:12.000000', 'temperatura', 217.0000, 'ºC'),
	(317062, 143, '2015-01-15 00:50:13.000000', 'temperatura', 908.0000, 'ºC'),
	(317063, 143, '2015-01-15 00:50:14.000000', 'temperatura', 293.0000, 'ºC'),
	(317064, 143, '2015-01-15 00:50:15.000000', 'temperatura', 1138.0000, 'ºC'),
	(317065, 143, '2015-01-15 00:50:16.000000', 'temperatura', 15.0000, 'ºC'),
	(317066, 143, '2015-01-15 00:50:17.000000', 'temperatura', 259.0000, 'ºC'),
	(317067, 143, '2015-01-15 00:50:18.000000', 'temperatura', 52.0000, 'ºC'),
	(317068, 143, '2015-01-15 00:50:19.000000', 'temperatura', 684.0000, 'ºC'),
	(317069, 143, '2015-01-15 00:50:20.000000', 'temperatura', 865.0000, 'ºC'),
	(317070, 143, '2015-01-15 00:50:21.000000', 'temperatura', 1071.0000, 'ºC'),
	(317071, 143, '2015-01-15 00:50:22.000000', 'temperatura', 361.0000, 'ºC'),
	(317072, 143, '2015-01-15 00:50:23.000000', 'temperatura', 993.0000, 'ºC'),
	(317073, 143, '2015-01-15 00:50:24.000000', 'temperatura', 282.0000, 'ºC'),
	(317074, 143, '2015-01-15 00:50:25.000000', 'temperatura', 831.0000, 'ºC'),
	(317075, 143, '2015-01-15 00:50:26.000000', 'temperatura', 908.0000, 'ºC'),
	(317076, 143, '2015-01-15 00:50:27.000000', 'temperatura', 849.0000, 'ºC'),
	(317077, 143, '2015-01-15 00:50:28.000000', 'temperatura', 324.0000, 'ºC'),
	(317078, 143, '2015-01-15 00:50:29.000000', 'temperatura', 270.0000, 'ºC'),
	(317079, 143, '2015-01-15 00:50:30.000000', 'temperatura', 378.0000, 'ºC'),
	(317080, 143, '2015-01-15 00:50:31.000000', 'temperatura', 1082.0000, 'ºC'),
	(317081, 143, '2015-01-15 00:50:32.000000', 'temperatura', 678.0000, 'ºC'),
	(317082, 143, '2015-01-15 00:50:33.000000', 'temperatura', 143.0000, 'ºC'),
	(317083, 143, '2015-01-15 00:50:34.000000', 'temperatura', 1084.0000, 'ºC'),
	(317084, 143, '2015-01-15 00:50:35.000000', 'temperatura', 189.0000, 'ºC'),
	(317085, 143, '2015-01-15 00:50:36.000000', 'temperatura', 94.0000, 'ºC'),
	(317086, 143, '2015-01-15 00:50:37.000000', 'temperatura', 1105.0000, 'ºC'),
	(317087, 143, '2015-01-15 00:50:38.000000', 'temperatura', 444.0000, 'ºC'),
	(317088, 143, '2015-01-15 00:50:39.000000', 'temperatura', 104.0000, 'ºC'),
	(317089, 143, '2015-01-15 00:50:40.000000', 'temperatura', 390.0000, 'ºC'),
	(317090, 143, '2015-01-15 00:50:41.000000', 'temperatura', 438.0000, 'ºC'),
	(317091, 143, '2015-01-15 00:50:42.000000', 'temperatura', 1020.0000, 'ºC'),
	(317092, 143, '2015-01-15 00:50:43.000000', 'temperatura', 187.0000, 'ºC'),
	(317093, 143, '2015-01-15 00:50:44.000000', 'temperatura', 274.0000, 'ºC'),
	(317094, 143, '2015-01-15 00:50:45.000000', 'temperatura', 809.0000, 'ºC'),
	(317095, 143, '2015-01-15 00:50:46.000000', 'temperatura', 823.0000, 'ºC'),
	(317096, 143, '2015-01-15 00:50:47.000000', 'temperatura', 489.0000, 'ºC'),
	(317097, 143, '2015-01-15 00:50:48.000000', 'temperatura', 1175.0000, 'ºC'),
	(317098, 143, '2015-01-15 00:50:49.000000', 'temperatura', 810.0000, 'ºC'),
	(317099, 143, '2015-01-15 00:50:50.000000', 'temperatura', 525.0000, 'ºC'),
	(317100, 143, '2015-01-15 00:50:51.000000', 'temperatura', 196.0000, 'ºC'),
	(317101, 143, '2015-01-15 00:50:52.000000', 'temperatura', 604.0000, 'ºC'),
	(317102, 143, '2015-01-15 00:50:53.000000', 'temperatura', 33.0000, 'ºC'),
	(317103, 143, '2015-01-15 00:50:54.000000', 'temperatura', 753.0000, 'ºC'),
	(317104, 143, '2015-01-15 00:50:55.000000', 'temperatura', 65.0000, 'ºC'),
	(317105, 143, '2015-01-15 00:50:56.000000', 'temperatura', 468.0000, 'ºC'),
	(317106, 143, '2015-01-15 00:50:57.000000', 'temperatura', 946.0000, 'ºC'),
	(317107, 143, '2015-01-15 00:50:58.000000', 'temperatura', 925.0000, 'ºC'),
	(317108, 143, '2015-01-15 00:50:59.000000', 'temperatura', 588.0000, 'ºC'),
	(317109, 143, '2015-01-15 00:51:00.000000', 'temperatura', 165.0000, 'ºC'),
	(317110, 143, '2015-01-15 00:51:01.000000', 'temperatura', 264.0000, 'ºC'),
	(317111, 143, '2015-01-15 00:51:02.000000', 'temperatura', 823.0000, 'ºC'),
	(317112, 143, '2015-01-15 00:51:03.000000', 'temperatura', 923.0000, 'ºC'),
	(317113, 143, '2015-01-15 00:51:04.000000', 'temperatura', 946.0000, 'ºC'),
	(317114, 143, '2015-01-15 00:51:05.000000', 'temperatura', 763.0000, 'ºC'),
	(317115, 143, '2015-01-15 00:51:06.000000', 'temperatura', 977.0000, 'ºC'),
	(317116, 143, '2015-01-15 00:51:07.000000', 'temperatura', 196.0000, 'ºC'),
	(317117, 143, '2015-01-15 00:51:08.000000', 'temperatura', 449.0000, 'ºC'),
	(317118, 143, '2015-01-15 00:51:09.000000', 'temperatura', 458.0000, 'ºC'),
	(317119, 143, '2015-01-15 00:51:10.000000', 'temperatura', 944.0000, 'ºC'),
	(317120, 143, '2015-01-15 00:51:11.000000', 'temperatura', 948.0000, 'ºC'),
	(317121, 143, '2015-01-15 00:51:12.000000', 'temperatura', 708.0000, 'ºC'),
	(317122, 143, '2015-01-15 00:51:13.000000', 'temperatura', 698.0000, 'ºC'),
	(317123, 143, '2015-01-15 00:51:14.000000', 'temperatura', 163.0000, 'ºC'),
	(317124, 143, '2015-01-15 00:51:15.000000', 'temperatura', 1123.0000, 'ºC'),
	(317125, 143, '2015-01-15 00:51:16.000000', 'temperatura', 326.0000, 'ºC'),
	(317126, 143, '2015-01-15 00:51:17.000000', 'temperatura', 660.0000, 'ºC'),
	(317127, 143, '2015-01-15 00:51:18.000000', 'temperatura', 1123.0000, 'ºC'),
	(317128, 143, '2015-01-15 00:51:19.000000', 'temperatura', 36.0000, 'ºC'),
	(317129, 143, '2015-01-15 00:51:20.000000', 'temperatura', 409.0000, 'ºC'),
	(317130, 143, '2015-01-15 00:51:21.000000', 'temperatura', 741.0000, 'ºC'),
	(317131, 143, '2015-01-15 00:51:22.000000', 'temperatura', 77.0000, 'ºC'),
	(317132, 143, '2015-01-15 00:51:23.000000', 'temperatura', 564.0000, 'ºC'),
	(317133, 143, '2015-01-15 00:51:24.000000', 'temperatura', 190.0000, 'ºC'),
	(317134, 143, '2015-01-15 00:51:25.000000', 'temperatura', 456.0000, 'ºC'),
	(317135, 143, '2015-01-15 00:51:26.000000', 'temperatura', 513.0000, 'ºC'),
	(317136, 143, '2015-01-15 00:51:27.000000', 'temperatura', 1198.0000, 'ºC'),
	(317137, 143, '2015-01-15 00:51:28.000000', 'temperatura', 848.0000, 'ºC'),
	(317138, 143, '2015-01-15 00:51:29.000000', 'temperatura', 650.0000, 'ºC'),
	(317139, 143, '2015-01-15 00:51:30.000000', 'temperatura', 706.0000, 'ºC'),
	(317140, 143, '2015-01-15 00:51:31.000000', 'temperatura', 380.0000, 'ºC'),
	(317141, 143, '2015-01-15 00:51:32.000000', 'temperatura', 985.0000, 'ºC'),
	(317142, 143, '2015-01-15 00:51:33.000000', 'temperatura', 182.0000, 'ºC'),
	(317143, 143, '2015-01-15 00:51:34.000000', 'temperatura', 355.0000, 'ºC'),
	(317144, 143, '2015-01-15 00:51:35.000000', 'temperatura', 31.0000, 'ºC'),
	(317145, 143, '2015-01-15 00:51:36.000000', 'temperatura', 290.0000, 'ºC'),
	(317146, 143, '2015-01-15 00:51:37.000000', 'temperatura', 160.0000, 'ºC'),
	(317147, 143, '2015-01-15 00:51:38.000000', 'temperatura', 1127.0000, 'ºC'),
	(317148, 143, '2015-01-15 00:51:39.000000', 'temperatura', 356.0000, 'ºC'),
	(317149, 143, '2015-01-15 00:51:40.000000', 'temperatura', 802.0000, 'ºC'),
	(317150, 143, '2015-01-15 00:51:41.000000', 'temperatura', 540.0000, 'ºC'),
	(317151, 143, '2015-01-15 00:51:42.000000', 'temperatura', 296.0000, 'ºC'),
	(317152, 143, '2015-01-15 00:51:43.000000', 'temperatura', 1062.0000, 'ºC'),
	(317153, 143, '2015-01-15 00:51:44.000000', 'temperatura', 819.0000, 'ºC'),
	(317154, 143, '2015-01-15 00:51:45.000000', 'temperatura', 912.0000, 'ºC'),
	(317155, 143, '2015-01-15 00:51:46.000000', 'temperatura', 905.0000, 'ºC'),
	(317156, 143, '2015-01-15 00:51:47.000000', 'temperatura', 587.0000, 'ºC'),
	(317157, 143, '2015-01-15 00:51:48.000000', 'temperatura', 222.0000, 'ºC'),
	(317158, 143, '2015-01-15 00:51:49.000000', 'temperatura', 550.0000, 'ºC'),
	(317159, 143, '2015-01-15 00:51:50.000000', 'temperatura', 882.0000, 'ºC'),
	(317160, 143, '2015-01-15 00:51:51.000000', 'temperatura', 362.0000, 'ºC'),
	(317161, 143, '2015-01-15 00:51:52.000000', 'temperatura', 362.0000, 'ºC'),
	(317162, 143, '2015-01-15 00:51:53.000000', 'temperatura', 727.0000, 'ºC'),
	(317163, 143, '2015-01-15 00:51:54.000000', 'temperatura', 150.0000, 'ºC'),
	(317164, 143, '2015-01-15 00:51:55.000000', 'temperatura', 968.0000, 'ºC'),
	(317165, 143, '2015-01-15 00:51:56.000000', 'temperatura', 790.0000, 'ºC'),
	(317166, 143, '2015-01-15 00:51:57.000000', 'temperatura', 1049.0000, 'ºC'),
	(317167, 143, '2015-01-15 00:51:58.000000', 'temperatura', 474.0000, 'ºC'),
	(317168, 143, '2015-01-15 00:51:59.000000', 'temperatura', 425.0000, 'ºC'),
	(317169, 143, '2015-01-15 00:52:00.000000', 'temperatura', 702.0000, 'ºC'),
	(317170, 143, '2015-01-15 00:52:01.000000', 'temperatura', 1038.0000, 'ºC'),
	(317171, 143, '2015-01-15 00:52:02.000000', 'temperatura', 681.0000, 'ºC'),
	(317172, 143, '2015-01-15 00:52:03.000000', 'temperatura', 294.0000, 'ºC'),
	(317173, 143, '2015-01-15 00:52:04.000000', 'temperatura', 626.0000, 'ºC'),
	(317174, 143, '2015-01-15 00:52:05.000000', 'temperatura', 1048.0000, 'ºC'),
	(317175, 143, '2015-01-15 00:52:06.000000', 'temperatura', 961.0000, 'ºC'),
	(317176, 143, '2015-01-15 00:52:07.000000', 'temperatura', 464.0000, 'ºC'),
	(317177, 143, '2015-01-15 00:52:08.000000', 'temperatura', 637.0000, 'ºC'),
	(317178, 143, '2015-01-15 00:52:09.000000', 'temperatura', 593.0000, 'ºC'),
	(317179, 143, '2015-01-15 00:52:10.000000', 'temperatura', 1056.0000, 'ºC'),
	(317180, 143, '2015-01-15 00:52:11.000000', 'temperatura', 1101.0000, 'ºC'),
	(317181, 143, '2015-01-15 00:52:12.000000', 'temperatura', 1137.0000, 'ºC'),
	(317182, 143, '2015-01-15 00:52:13.000000', 'temperatura', 1183.0000, 'ºC'),
	(317183, 143, '2015-01-15 00:52:14.000000', 'temperatura', 102.0000, 'ºC'),
	(317184, 143, '2015-01-15 00:52:15.000000', 'temperatura', 565.0000, 'ºC'),
	(317185, 143, '2015-01-15 00:52:16.000000', 'temperatura', 117.0000, 'ºC'),
	(317186, 143, '2015-01-15 00:52:17.000000', 'temperatura', 93.0000, 'ºC'),
	(317187, 143, '2015-01-15 00:52:18.000000', 'temperatura', 115.0000, 'ºC'),
	(317188, 143, '2015-01-15 00:52:19.000000', 'temperatura', 296.0000, 'ºC'),
	(317189, 143, '2015-01-15 00:52:20.000000', 'temperatura', 1137.0000, 'ºC'),
	(317190, 143, '2015-01-15 00:52:21.000000', 'temperatura', 1195.0000, 'ºC'),
	(317191, 143, '2015-01-15 00:52:22.000000', 'temperatura', 166.0000, 'ºC'),
	(317192, 143, '2015-01-15 00:52:23.000000', 'temperatura', 843.0000, 'ºC'),
	(317193, 143, '2015-01-15 00:52:24.000000', 'temperatura', 120.0000, 'ºC'),
	(317194, 143, '2015-01-15 00:52:25.000000', 'temperatura', 470.0000, 'ºC'),
	(317195, 143, '2015-01-15 00:52:26.000000', 'temperatura', 792.0000, 'ºC'),
	(317196, 143, '2015-01-15 00:52:27.000000', 'temperatura', 150.0000, 'ºC'),
	(317197, 143, '2015-01-15 00:52:28.000000', 'temperatura', 776.0000, 'ºC'),
	(317198, 143, '2015-01-15 00:52:29.000000', 'temperatura', 1027.0000, 'ºC'),
	(317199, 143, '2015-01-15 00:52:30.000000', 'temperatura', 410.0000, 'ºC'),
	(317200, 143, '2015-01-15 00:52:31.000000', 'temperatura', 169.0000, 'ºC'),
	(317201, 143, '2015-01-15 00:52:32.000000', 'temperatura', 816.0000, 'ºC'),
	(317202, 143, '2015-01-15 00:52:33.000000', 'temperatura', 1175.0000, 'ºC'),
	(317203, 143, '2015-01-15 00:52:34.000000', 'temperatura', 1027.0000, 'ºC'),
	(317204, 143, '2015-01-15 00:52:35.000000', 'temperatura', 410.0000, 'ºC'),
	(317205, 143, '2015-01-15 00:52:36.000000', 'temperatura', 169.0000, 'ºC'),
	(317206, 143, '2015-01-15 00:52:37.000000', 'temperatura', 817.0000, 'ºC'),
	(317207, 143, '2015-01-15 00:52:38.000000', 'temperatura', 1178.0000, 'ºC'),
	(317208, 143, '2015-01-15 00:52:39.000000', 'temperatura', 1040.0000, 'ºC'),
	(317209, 143, '2015-01-15 00:52:40.000000', 'temperatura', 465.0000, 'ºC'),
	(317210, 143, '2015-01-15 00:52:41.000000', 'temperatura', 406.0000, 'ºC'),
	(317211, 143, '2015-01-15 00:52:42.000000', 'temperatura', 638.0000, 'ºC'),
	(317212, 143, '2015-01-15 00:52:43.000000', 'temperatura', 769.0000, 'ºC'),
	(317213, 143, '2015-01-15 00:52:44.000000', 'temperatura', 733.0000, 'ºC'),
	(317214, 143, '2015-01-15 00:52:45.000000', 'temperatura', 157.0000, 'ºC'),
	(317215, 143, '2015-01-15 00:52:46.000000', 'temperatura', 989.0000, 'ºC'),
	(317216, 143, '2015-01-15 00:52:47.000000', 'temperatura', 872.0000, 'ºC'),
	(317217, 143, '2015-01-15 00:52:48.000000', 'temperatura', 194.0000, 'ºC'),
	(317218, 143, '2015-01-15 00:52:49.000000', 'temperatura', 757.0000, 'ºC'),
	(317219, 143, '2015-01-15 00:52:50.000000', 'temperatura', 801.0000, 'ºC'),
	(317220, 143, '2015-01-15 00:52:51.000000', 'temperatura', 535.0000, 'ºC'),
	(317221, 143, '2015-01-15 00:52:52.000000', 'temperatura', 273.0000, 'ºC'),
	(317222, 143, '2015-01-15 00:52:53.000000', 'temperatura', 961.0000, 'ºC'),
	(317223, 143, '2015-01-15 00:52:54.000000', 'temperatura', 384.0000, 'ºC'),
	(317224, 143, '2015-01-15 00:52:55.000000', 'temperatura', 239.0000, 'ºC'),
	(317225, 143, '2015-01-15 00:52:56.000000', 'temperatura', 44.0000, 'ºC'),
	(317226, 143, '2015-01-15 00:52:57.000000', 'temperatura', 701.0000, 'ºC'),
	(317227, 143, '2015-01-15 00:52:58.000000', 'temperatura', 975.0000, 'ºC'),
	(317228, 143, '2015-01-15 00:52:59.000000', 'temperatura', 375.0000, 'ºC'),
	(317229, 143, '2015-01-15 00:53:00.000000', 'temperatura', 147.0000, 'ºC'),
	(317230, 143, '2015-01-15 00:53:01.000000', 'temperatura', 812.0000, 'ºC'),
	(317231, 143, '2015-01-15 00:53:02.000000', 'temperatura', 19.0000, 'ºC'),
	(317232, 143, '2015-01-15 00:53:03.000000', 'temperatura', 58.0000, 'ºC'),
	(317233, 143, '2015-01-15 00:53:04.000000', 'temperatura', 236.0000, 'ºC'),
	(317234, 143, '2015-01-15 00:53:05.000000', 'temperatura', 1007.0000, 'ºC'),
	(317235, 143, '2015-01-15 00:53:06.000000', 'temperatura', 725.0000, 'ºC'),
	(317236, 143, '2015-01-15 00:53:07.000000', 'temperatura', 604.0000, 'ºC'),
	(317237, 143, '2015-01-15 00:53:08.000000', 'temperatura', 848.0000, 'ºC'),
	(317238, 143, '2015-01-15 00:53:09.000000', 'temperatura', 28.0000, 'ºC'),
	(317239, 143, '2015-01-15 00:53:10.000000', 'temperatura', 1196.0000, 'ºC'),
	(317240, 143, '2015-01-15 00:53:11.000000', 'temperatura', 1098.0000, 'ºC'),
	(317241, 143, '2015-01-15 00:53:12.000000', 'temperatura', 701.0000, 'ºC'),
	(317242, 143, '2015-01-15 00:53:13.000000', 'temperatura', 211.0000, 'ºC'),
	(317243, 143, '2015-01-15 00:53:14.000000', 'temperatura', 153.0000, 'ºC'),
	(317244, 143, '2015-01-15 00:53:15.000000', 'temperatura', 134.0000, 'ºC'),
	(317245, 143, '2015-01-15 00:53:16.000000', 'temperatura', 208.0000, 'ºC'),
	(317246, 143, '2015-01-15 00:53:17.000000', 'temperatura', 642.0000, 'ºC'),
	(317247, 143, '2015-01-15 00:53:18.000000', 'temperatura', 185.0000, 'ºC'),
	(317248, 143, '2015-01-15 00:53:19.000000', 'temperatura', 202.0000, 'ºC'),
	(317249, 143, '2015-01-15 00:53:20.000000', 'temperatura', 453.0000, 'ºC'),
	(317250, 143, '2015-01-15 00:53:21.000000', 'temperatura', 458.0000, 'ºC'),
	(317251, 143, '2015-01-15 00:53:22.000000', 'temperatura', 935.0000, 'ºC'),
	(317252, 143, '2015-01-15 00:53:23.000000', 'temperatura', 899.0000, 'ºC'),
	(317253, 143, '2015-01-15 00:53:24.000000', 'temperatura', 490.0000, 'ºC'),
	(317254, 143, '2015-01-15 00:53:25.000000', 'temperatura', 954.0000, 'ºC'),
	(317255, 143, '2015-01-15 00:53:26.000000', 'temperatura', 902.0000, 'ºC'),
	(317256, 143, '2015-01-15 00:53:27.000000', 'temperatura', 449.0000, 'ºC'),
	(317257, 143, '2015-01-15 00:53:28.000000', 'temperatura', 738.0000, 'ºC'),
	(317258, 143, '2015-01-15 00:53:29.000000', 'temperatura', 1143.0000, 'ºC'),
	(317259, 143, '2015-01-15 00:53:30.000000', 'temperatura', 1102.0000, 'ºC'),
	(317260, 143, '2015-01-15 00:53:31.000000', 'temperatura', 881.0000, 'ºC'),
	(317261, 143, '2015-01-15 00:53:32.000000', 'temperatura', 1100.0000, 'ºC'),
	(317262, 143, '2015-01-15 00:53:33.000000', 'temperatura', 456.0000, 'ºC'),
	(317263, 143, '2015-01-15 00:53:34.000000', 'temperatura', 182.0000, 'ºC'),
	(317264, 143, '2015-01-15 00:53:35.000000', 'temperatura', 744.0000, 'ºC'),
	(317265, 143, '2015-01-15 00:53:36.000000', 'temperatura', 774.0000, 'ºC'),
	(317266, 143, '2015-01-15 00:53:37.000000', 'temperatura', 437.0000, 'ºC'),
	(317267, 143, '2015-01-15 00:53:38.000000', 'temperatura', 1065.0000, 'ºC'),
	(317268, 143, '2015-01-15 00:53:39.000000', 'temperatura', 413.0000, 'ºC'),
	(317269, 143, '2015-01-15 00:53:40.000000', 'temperatura', 70.0000, 'ºC'),
	(317270, 143, '2015-01-15 00:53:41.000000', 'temperatura', 311.0000, 'ºC'),
	(317271, 143, '2015-01-15 00:53:42.000000', 'temperatura', 146.0000, 'ºC'),
	(317272, 143, '2015-01-15 00:53:43.000000', 'temperatura', 999.0000, 'ºC'),
	(317273, 143, '2015-01-15 00:53:44.000000', 'temperatura', 958.0000, 'ºC'),
	(317274, 143, '2015-01-15 00:53:45.000000', 'temperatura', 594.0000, 'ºC'),
	(317275, 143, '2015-01-15 00:53:46.000000', 'temperatura', 95.0000, 'ºC'),
	(317276, 143, '2015-01-15 00:53:47.000000', 'temperatura', 1092.0000, 'ºC'),
	(317277, 143, '2015-01-15 00:53:48.000000', 'temperatura', 378.0000, 'ºC'),
	(317278, 143, '2015-01-15 00:53:49.000000', 'temperatura', 1015.0000, 'ºC'),
	(317279, 143, '2015-01-15 00:53:50.000000', 'temperatura', 339.0000, 'ºC'),
	(317280, 143, '2015-01-15 00:53:51.000000', 'temperatura', 1051.0000, 'ºC'),
	(317281, 143, '2015-01-15 00:53:52.000000', 'temperatura', 641.0000, 'ºC'),
	(317282, 143, '2015-01-15 00:53:53.000000', 'temperatura', 49.0000, 'ºC'),
	(317283, 143, '2015-01-15 00:53:54.000000', 'temperatura', 725.0000, 'ºC'),
	(317284, 143, '2015-01-15 00:53:55.000000', 'temperatura', 1079.0000, 'ºC'),
	(317285, 143, '2015-01-15 00:53:56.000000', 'temperatura', 819.0000, 'ºC'),
	(317286, 143, '2015-01-15 00:53:57.000000', 'temperatura', 859.0000, 'ºC'),
	(317287, 143, '2015-01-15 00:53:58.000000', 'temperatura', 640.0000, 'ºC'),
	(317288, 143, '2015-01-15 00:53:59.000000', 'temperatura', 624.0000, 'ºC'),
	(317289, 143, '2015-01-15 00:54:00.000000', 'temperatura', 1.0000, 'ºC'),
	(317290, 143, '2015-01-15 00:54:01.000000', 'temperatura', 534.0000, 'ºC'),
	(317291, 143, '2015-01-15 00:54:02.000000', 'temperatura', 268.0000, 'ºC'),
	(317292, 143, '2015-01-15 00:54:03.000000', 'temperatura', 937.0000, 'ºC'),
	(317293, 143, '2015-01-15 00:54:04.000000', 'temperatura', 283.0000, 'ºC'),
	(317294, 143, '2015-01-15 00:54:05.000000', 'temperatura', 1003.0000, 'ºC'),
	(317295, 143, '2015-01-15 00:54:06.000000', 'temperatura', 569.0000, 'ºC'),
	(317296, 143, '2015-01-15 00:54:07.000000', 'temperatura', 1035.0000, 'ºC'),
	(317297, 143, '2015-01-15 00:54:08.000000', 'temperatura', 1066.0000, 'ºC'),
	(317298, 143, '2015-01-15 00:54:09.000000', 'temperatura', 1029.0000, 'ºC'),
	(317299, 143, '2015-01-15 00:54:10.000000', 'temperatura', 746.0000, 'ºC'),
	(317300, 143, '2015-01-15 00:54:11.000000', 'temperatura', 644.0000, 'ºC'),
	(317301, 143, '2015-01-15 00:54:12.000000', 'temperatura', 984.0000, 'ºC'),
	(317302, 143, '2015-01-15 00:54:13.000000', 'temperatura', 588.0000, 'ºC'),
	(317303, 143, '2015-01-15 00:54:14.000000', 'temperatura', 1190.0000, 'ºC'),
	(317304, 143, '2015-01-15 00:54:15.000000', 'temperatura', 586.0000, 'ºC'),
	(317305, 143, '2015-01-15 00:54:16.000000', 'temperatura', 559.0000, 'ºC'),
	(317306, 143, '2015-01-15 00:54:17.000000', 'temperatura', 1036.0000, 'ºC'),
	(317307, 143, '2015-01-15 00:54:18.000000', 'temperatura', 1106.0000, 'ºC'),
	(317308, 143, '2015-01-15 00:54:19.000000', 'temperatura', 24.0000, 'ºC'),
	(317309, 143, '2015-01-15 00:54:20.000000', 'temperatura', 399.0000, 'ºC'),
	(317310, 143, '2015-01-15 00:54:21.000000', 'temperatura', 725.0000, 'ºC'),
	(317311, 143, '2015-01-15 00:54:22.000000', 'temperatura', 30.0000, 'ºC'),
	(317312, 143, '2015-01-15 00:54:23.000000', 'temperatura', 372.0000, 'ºC'),
	(317313, 143, '2015-01-15 00:54:24.000000', 'temperatura', 574.0000, 'ºC'),
	(317314, 143, '2015-01-15 00:54:25.000000', 'temperatura', 554.0000, 'ºC'),
	(317315, 143, '2015-01-15 00:54:26.000000', 'temperatura', 1046.0000, 'ºC'),
	(317316, 143, '2015-01-15 00:54:27.000000', 'temperatura', 1170.0000, 'ºC'),
	(317317, 143, '2015-01-15 00:54:28.000000', 'temperatura', 313.0000, 'ºC'),
	(317318, 143, '2015-01-15 00:54:29.000000', 'temperatura', 455.0000, 'ºC'),
	(317319, 143, '2015-01-15 00:54:30.000000', 'temperatura', 138.0000, 'ºC'),
	(317320, 143, '2015-01-15 00:54:31.000000', 'temperatura', 525.0000, 'ºC'),
	(317321, 143, '2015-01-15 00:54:32.000000', 'temperatura', 1012.0000, 'ºC'),
	(317322, 143, '2015-01-15 00:54:33.000000', 'temperatura', 1084.0000, 'ºC'),
	(317323, 143, '2015-01-15 00:54:34.000000', 'temperatura', 1183.0000, 'ºC'),
	(317324, 143, '2015-01-15 00:54:35.000000', 'temperatura', 267.0000, 'ºC'),
	(317325, 143, '2015-01-15 00:54:36.000000', 'temperatura', 185.0000, 'ºC'),
	(317326, 143, '2015-01-15 00:54:37.000000', 'temperatura', 126.0000, 'ºC'),
	(317327, 143, '2015-01-15 00:54:38.000000', 'temperatura', 76.0000, 'ºC'),
	(317328, 143, '2015-01-15 00:54:39.000000', 'temperatura', 0.0000, 'ºC'),
	(317329, 143, '2015-01-15 00:54:40.000000', 'temperatura', 974.0000, 'ºC'),
	(317330, 143, '2015-01-15 00:54:41.000000', 'temperatura', 72.0000, 'ºC'),
	(317331, 143, '2015-01-15 00:54:42.000000', 'temperatura', 1036.0000, 'ºC'),
	(317332, 143, '2015-01-15 00:54:43.000000', 'temperatura', 167.0000, 'ºC'),
	(317333, 143, '2015-01-15 00:54:44.000000', 'temperatura', 125.0000, 'ºC'),
	(317334, 143, '2015-01-15 00:54:45.000000', 'temperatura', 125.0000, 'ºC'),
	(317335, 143, '2015-01-15 00:54:46.000000', 'temperatura', 252.0000, 'ºC'),
	(317336, 143, '2015-01-15 00:54:47.000000', 'temperatura', 883.0000, 'ºC'),
	(317337, 143, '2015-01-15 00:54:48.000000', 'temperatura', 62.0000, 'ºC'),
	(317338, 143, '2015-01-15 00:54:49.000000', 'temperatura', 60.0000, 'ºC'),
	(317339, 143, '2015-01-15 00:54:50.000000', 'temperatura', 116.0000, 'ºC'),
	(317340, 143, '2015-01-15 00:54:51.000000', 'temperatura', 401.0000, 'ºC'),
	(317341, 143, '2015-01-15 00:54:52.000000', 'temperatura', 456.0000, 'ºC'),
	(317342, 143, '2015-01-15 00:54:53.000000', 'temperatura', 1078.0000, 'ºC'),
	(317343, 143, '2015-01-15 00:54:54.000000', 'temperatura', 424.0000, 'ºC'),
	(317344, 143, '2015-01-15 00:54:55.000000', 'temperatura', 84.0000, 'ºC'),
	(317345, 143, '2015-01-15 00:54:56.000000', 'temperatura', 350.0000, 'ºC'),
	(317346, 143, '2015-01-15 00:54:57.000000', 'temperatura', 296.0000, 'ºC'),
	(317347, 143, '2015-01-15 00:54:58.000000', 'temperatura', 434.0000, 'ºC'),
	(317348, 143, '2015-01-15 00:54:59.000000', 'temperatura', 81.0000, 'ºC'),
	(317349, 143, '2015-01-15 00:55:00.000000', 'temperatura', 302.0000, 'ºC'),
	(317350, 143, '2015-01-15 00:55:01.000000', 'temperatura', 69.0000, 'ºC'),
	(317351, 143, '2015-01-15 00:55:02.000000', 'temperatura', 639.0000, 'ºC'),
	(317352, 143, '2015-01-15 00:55:03.000000', 'temperatura', 587.0000, 'ºC'),
	(317353, 143, '2015-01-15 00:55:04.000000', 'temperatura', 1019.0000, 'ºC'),
	(317354, 143, '2015-01-15 00:55:05.000000', 'temperatura', 935.0000, 'ºC'),
	(317355, 143, '2015-01-15 00:55:06.000000', 'temperatura', 418.0000, 'ºC'),
	(317356, 143, '2015-01-15 00:55:07.000000', 'temperatura', 488.0000, 'ºC'),
	(317357, 143, '2015-01-15 00:55:08.000000', 'temperatura', 1184.0000, 'ºC'),
	(317358, 143, '2015-01-15 00:55:09.000000', 'temperatura', 856.0000, 'ºC'),
	(317359, 143, '2015-01-15 00:55:10.000000', 'temperatura', 730.0000, 'ºC'),
	(317360, 143, '2015-01-15 00:55:11.000000', 'temperatura', 1084.0000, 'ºC'),
	(317361, 143, '2015-01-15 00:55:12.000000', 'temperatura', 830.0000, 'ºC'),
	(317362, 143, '2015-01-15 00:55:13.000000', 'temperatura', 897.0000, 'ºC'),
	(317363, 143, '2015-01-15 00:55:14.000000', 'temperatura', 794.0000, 'ºC'),
	(317364, 143, '2015-01-15 00:55:15.000000', 'temperatura', 81.0000, 'ºC'),
	(317365, 143, '2015-01-15 00:55:16.000000', 'temperatura', 423.0000, 'ºC'),
	(317366, 143, '2015-01-15 00:55:17.000000', 'temperatura', 674.0000, 'ºC'),
	(317367, 143, '2015-01-15 00:55:18.000000', 'temperatura', 902.0000, 'ºC'),
	(317368, 143, '2015-01-15 00:55:19.000000', 'temperatura', 88.0000, 'ºC'),
	(317369, 143, '2015-01-15 00:55:20.000000', 'temperatura', 134.0000, 'ºC'),
	(317370, 143, '2015-01-15 00:55:21.000000', 'temperatura', 405.0000, 'ºC'),
	(317371, 143, '2015-01-15 00:55:22.000000', 'temperatura', 425.0000, 'ºC'),
	(317372, 143, '2015-01-15 00:55:23.000000', 'temperatura', 911.0000, 'ºC'),
	(317373, 143, '2015-01-15 00:55:24.000000', 'temperatura', 882.0000, 'ºC'),
	(317374, 143, '2015-01-15 00:55:25.000000', 'temperatura', 475.0000, 'ºC'),
	(317375, 143, '2015-01-15 00:55:26.000000', 'temperatura', 931.0000, 'ºC'),
	(317376, 143, '2015-01-15 00:55:27.000000', 'temperatura', 830.0000, 'ºC'),
	(317377, 143, '2015-01-15 00:55:28.000000', 'temperatura', 157.0000, 'ºC'),
	(317378, 143, '2015-01-15 00:55:29.000000', 'temperatura', 694.0000, 'ºC'),
	(317379, 143, '2015-01-15 00:55:30.000000', 'temperatura', 600.0000, 'ºC'),
	(317380, 143, '2015-01-15 00:55:31.000000', 'temperatura', 921.0000, 'ºC'),
	(317381, 143, '2015-01-15 00:55:32.000000', 'temperatura', 404.0000, 'ºC'),
	(317382, 143, '2015-01-15 00:55:33.000000', 'temperatura', 457.0000, 'ºC'),
	(317383, 143, '2015-01-15 00:55:34.000000', 'temperatura', 1072.0000, 'ºC'),
	(317384, 143, '2015-01-15 00:55:35.000000', 'temperatura', 393.0000, 'ºC'),
	(317385, 143, '2015-01-15 00:55:36.000000', 'temperatura', 1146.0000, 'ºC'),
	(317386, 143, '2015-01-15 00:55:37.000000', 'temperatura', 953.0000, 'ºC'),
	(317387, 143, '2015-01-15 00:55:38.000000', 'temperatura', 126.0000, 'ºC'),
	(317388, 143, '2015-01-15 00:55:39.000000', 'temperatura', 170.0000, 'ºC'),
	(317389, 143, '2015-01-15 00:55:40.000000', 'temperatura', 476.0000, 'ºC'),
	(317390, 143, '2015-01-15 00:55:41.000000', 'temperatura', 670.0000, 'ºC'),
	(317391, 143, '2015-01-15 00:55:42.000000', 'temperatura', 721.0000, 'ºC'),
	(317392, 143, '2015-01-15 00:55:43.000000', 'temperatura', 394.0000, 'ºC'),
	(317393, 143, '2015-01-15 00:55:44.000000', 'temperatura', 1010.0000, 'ºC'),
	(317394, 143, '2015-01-15 00:55:45.000000', 'temperatura', 267.0000, 'ºC'),
	(317395, 143, '2015-01-15 00:55:46.000000', 'temperatura', 706.0000, 'ºC'),
	(317396, 143, '2015-01-15 00:55:47.000000', 'temperatura', 328.0000, 'ºC'),
	(317397, 143, '2015-01-15 00:55:48.000000', 'temperatura', 723.0000, 'ºC'),
	(317398, 143, '2015-01-15 00:55:49.000000', 'temperatura', 231.0000, 'ºC'),
	(317399, 143, '2015-01-15 00:55:50.000000', 'temperatura', 188.0000, 'ºC'),
	(317400, 143, '2015-01-15 00:55:51.000000', 'temperatura', 248.0000, 'ºC'),
	(317401, 143, '2015-01-15 00:55:52.000000', 'temperatura', 677.0000, 'ºC'),
	(317402, 143, '2015-01-15 00:55:53.000000', 'temperatura', 241.0000, 'ºC'),
	(317403, 143, '2015-01-15 00:55:54.000000', 'temperatura', 376.0000, 'ºC'),
	(317404, 143, '2015-01-15 00:55:55.000000', 'temperatura', 1157.0000, 'ºC'),
	(317405, 143, '2015-01-15 00:55:56.000000', 'temperatura', 1058.0000, 'ºC'),
	(317406, 143, '2015-01-15 00:55:57.000000', 'temperatura', 617.0000, 'ºC'),
	(317407, 143, '2015-01-15 00:55:58.000000', 'temperatura', 1113.0000, 'ºC'),
	(317408, 143, '2015-01-15 00:55:59.000000', 'temperatura', 116.0000, 'ºC'),
	(317409, 143, '2015-01-15 00:56:00.000000', 'temperatura', 840.0000, 'ºC'),
	(317410, 143, '2015-01-15 00:56:01.000000', 'temperatura', 253.0000, 'ºC'),
	(317411, 143, '2015-01-15 00:56:02.000000', 'temperatura', 1145.0000, 'ºC'),
	(317412, 143, '2015-01-15 00:56:03.000000', 'temperatura', 168.0000, 'ºC'),
	(317413, 143, '2015-01-15 00:56:04.000000', 'temperatura', 1004.0000, 'ºC'),
	(317414, 143, '2015-01-15 00:56:05.000000', 'temperatura', 919.0000, 'ºC'),
	(317415, 143, '2015-01-15 00:56:06.000000', 'temperatura', 382.0000, 'ºC'),
	(317416, 143, '2015-01-15 00:56:07.000000', 'temperatura', 352.0000, 'ºC'),
	(317417, 143, '2015-01-15 00:56:08.000000', 'temperatura', 618.0000, 'ºC'),
	(317418, 143, '2015-01-15 00:56:09.000000', 'temperatura', 831.0000, 'ºC'),
	(317419, 143, '2015-01-15 00:56:10.000000', 'temperatura', 1102.0000, 'ºC'),
	(317420, 143, '2015-01-15 00:56:11.000000', 'temperatura', 619.0000, 'ºC'),
	(317421, 143, '2015-01-15 00:56:12.000000', 'temperatura', 987.0000, 'ºC'),
	(317422, 143, '2015-01-15 00:56:13.000000', 'temperatura', 679.0000, 'ºC'),
	(317423, 143, '2015-01-15 00:56:14.000000', 'temperatura', 436.0000, 'ºC'),
	(317424, 143, '2015-01-15 00:56:15.000000', 'temperatura', 141.0000, 'ºC'),
	(317425, 143, '2015-01-15 00:56:16.000000', 'temperatura', 600.0000, 'ºC'),
	(317426, 143, '2015-01-15 00:56:17.000000', 'temperatura', 175.0000, 'ºC'),
	(317427, 143, '2015-01-15 00:56:18.000000', 'temperatura', 277.0000, 'ºC'),
	(317428, 143, '2015-01-15 00:56:19.000000', 'temperatura', 862.0000, 'ºC'),
	(317429, 143, '2015-01-15 00:56:20.000000', 'temperatura', 1077.0000, 'ºC'),
	(317430, 143, '2015-01-15 00:56:21.000000', 'temperatura', 401.0000, 'ºC'),
	(317431, 143, '2015-01-15 00:56:22.000000', 'temperatura', 1176.0000, 'ºC'),
	(317432, 143, '2015-01-15 00:56:23.000000', 'temperatura', 1075.0000, 'ºC'),
	(317433, 143, '2015-01-15 00:56:24.000000', 'temperatura', 648.0000, 'ºC'),
	(317434, 143, '2015-01-15 00:56:25.000000', 'temperatura', 16.0000, 'ºC'),
	(317435, 143, '2015-01-15 00:56:26.000000', 'temperatura', 535.0000, 'ºC'),
	(317436, 143, '2015-01-15 00:56:27.000000', 'temperatura', 229.0000, 'ºC'),
	(317437, 143, '2015-01-15 00:56:28.000000', 'temperatura', 740.0000, 'ºC'),
	(317438, 143, '2015-01-15 00:56:29.000000', 'temperatura', 613.0000, 'ºC'),
	(317439, 143, '2015-01-15 00:56:30.000000', 'temperatura', 845.0000, 'ºC'),
	(317440, 143, '2015-01-15 00:56:31.000000', 'temperatura', 1188.0000, 'ºC'),
	(317441, 143, '2015-01-15 00:56:32.000000', 'temperatura', 1007.0000, 'ºC'),
	(317442, 143, '2015-01-15 00:56:33.000000', 'temperatura', 270.0000, 'ºC'),
	(317443, 143, '2015-01-15 00:56:34.000000', 'temperatura', 729.0000, 'ºC'),
	(317444, 143, '2015-01-15 00:56:35.000000', 'temperatura', 436.0000, 'ºC'),
	(317445, 143, '2015-01-15 00:56:36.000000', 'temperatura', 1191.0000, 'ºC'),
	(317446, 143, '2015-01-15 00:56:37.000000', 'temperatura', 1050.0000, 'ºC'),
	(317447, 143, '2015-01-15 00:56:38.000000', 'temperatura', 478.0000, 'ºC'),
	(317448, 143, '2015-01-15 00:56:39.000000', 'temperatura', 440.0000, 'ºC'),
	(317449, 143, '2015-01-15 00:56:40.000000', 'temperatura', 767.0000, 'ºC'),
	(317450, 143, '2015-01-15 00:56:41.000000', 'temperatura', 117.0000, 'ºC'),
	(317451, 143, '2015-01-15 00:56:42.000000', 'temperatura', 683.0000, 'ºC'),
	(317452, 143, '2015-01-15 00:56:43.000000', 'temperatura', 664.0000, 'ºC'),
	(317453, 143, '2015-01-15 00:56:44.000000', 'temperatura', 71.0000, 'ºC'),
	(317454, 143, '2015-01-15 00:56:45.000000', 'temperatura', 765.0000, 'ºC'),
	(317455, 143, '2015-01-15 00:56:46.000000', 'temperatura', 13.0000, 'ºC'),
	(317456, 143, '2015-01-15 00:56:47.000000', 'temperatura', 169.0000, 'ºC'),
	(317457, 143, '2015-01-15 00:56:48.000000', 'temperatura', 805.0000, 'ºC'),
	(317458, 143, '2015-01-15 00:56:49.000000', 'temperatura', 1122.0000, 'ºC'),
	(317459, 143, '2015-01-15 00:56:50.000000', 'temperatura', 792.0000, 'ºC'),
	(317460, 143, '2015-01-15 00:56:51.000000', 'temperatura', 596.0000, 'ºC'),
	(317461, 143, '2015-01-15 00:56:52.000000', 'temperatura', 606.0000, 'ºC'),
	(317462, 143, '2015-01-15 00:56:53.000000', 'temperatura', 41.0000, 'ºC'),
	(317463, 143, '2015-01-15 00:56:54.000000', 'temperatura', 786.0000, 'ºC'),
	(317464, 143, '2015-01-15 00:56:55.000000', 'temperatura', 208.0000, 'ºC'),
	(317465, 143, '2015-01-15 00:56:56.000000', 'temperatura', 1082.0000, 'ºC'),
	(317466, 143, '2015-01-15 00:56:57.000000', 'temperatura', 1187.0000, 'ºC'),
	(317467, 143, '2015-01-15 00:56:58.000000', 'temperatura', 292.0000, 'ºC'),
	(317468, 143, '2015-01-15 00:56:59.000000', 'temperatura', 296.0000, 'ºC'),
	(317469, 143, '2015-01-15 00:57:00.000000', 'temperatura', 607.0000, 'ºC'),
	(317470, 143, '2015-01-15 00:57:01.000000', 'temperatura', 949.0000, 'ºC'),
	(317471, 143, '2015-01-15 00:57:02.000000', 'temperatura', 521.0000, 'ºC'),
	(317472, 143, '2015-01-15 00:57:03.000000', 'temperatura', 961.0000, 'ºC'),
	(317473, 143, '2015-01-15 00:57:04.000000', 'temperatura', 840.0000, 'ºC'),
	(317474, 143, '2015-01-15 00:57:05.000000', 'temperatura', 119.0000, 'ºC'),
	(317475, 143, '2015-01-15 00:57:06.000000', 'temperatura', 477.0000, 'ºC'),
	(317476, 143, '2015-01-15 00:57:07.000000', 'temperatura', 827.0000, 'ºC'),
	(317477, 143, '2015-01-15 00:57:08.000000', 'temperatura', 304.0000, 'ºC'),
	(317478, 143, '2015-01-15 00:57:09.000000', 'temperatura', 241.0000, 'ºC'),
	(317479, 143, '2015-01-15 00:57:10.000000', 'temperatura', 295.0000, 'ºC'),
	(317480, 143, '2015-01-15 00:57:11.000000', 'temperatura', 750.0000, 'ºC'),
	(317481, 143, '2015-01-15 00:57:12.000000', 'temperatura', 464.0000, 'ºC'),
	(317482, 143, '2015-01-15 00:57:13.000000', 'temperatura', 73.0000, 'ºC'),
	(317483, 143, '2015-01-15 00:57:14.000000', 'temperatura', 173.0000, 'ºC'),
	(317484, 143, '2015-01-15 00:57:15.000000', 'temperatura', 647.0000, 'ºC'),
	(317485, 143, '2015-01-15 00:57:16.000000', 'temperatura', 317.0000, 'ºC'),
	(317486, 143, '2015-01-15 00:57:17.000000', 'temperatura', 844.0000, 'ºC'),
	(317487, 143, '2015-01-15 00:57:18.000000', 'temperatura', 870.0000, 'ºC'),
	(317488, 143, '2015-01-15 00:57:19.000000', 'temperatura', 618.0000, 'ºC'),
	(317489, 143, '2015-01-15 00:57:20.000000', 'temperatura', 480.0000, 'ºC'),
	(317490, 143, '2015-01-15 00:57:21.000000', 'temperatura', 547.0000, 'ºC'),
	(317491, 143, '2015-01-15 00:57:22.000000', 'temperatura', 96.0000, 'ºC'),
	(317492, 143, '2015-01-15 00:57:23.000000', 'temperatura', 38.0000, 'ºC'),
	(317493, 143, '2015-01-15 00:57:24.000000', 'temperatura', 1101.0000, 'ºC'),
	(317494, 143, '2015-01-15 00:57:25.000000', 'temperatura', 595.0000, 'ºC'),
	(317495, 143, '2015-01-15 00:57:26.000000', 'temperatura', 870.0000, 'ºC'),
	(317496, 143, '2015-01-15 00:57:27.000000', 'temperatura', 166.0000, 'ºC'),
	(317497, 143, '2015-01-15 00:57:28.000000', 'temperatura', 620.0000, 'ºC'),
	(317498, 143, '2015-01-15 00:57:29.000000', 'temperatura', 203.0000, 'ºC'),
	(317499, 143, '2015-01-15 00:57:30.000000', 'temperatura', 356.0000, 'ºC'),
	(317500, 143, '2015-01-15 00:57:31.000000', 'temperatura', 1173.0000, 'ºC'),
	(317501, 143, '2015-01-15 00:57:32.000000', 'temperatura', 1194.0000, 'ºC'),
	(317502, 143, '2015-01-15 00:57:33.000000', 'temperatura', 53.0000, 'ºC'),
	(317503, 143, '2015-01-15 00:57:34.000000', 'temperatura', 285.0000, 'ºC'),
	(317504, 143, '2015-01-15 00:57:35.000000', 'temperatura', 67.0000, 'ºC'),
	(317505, 143, '2015-01-15 00:57:36.000000', 'temperatura', 679.0000, 'ºC'),
	(317506, 143, '2015-01-15 00:57:37.000000', 'temperatura', 794.0000, 'ºC'),
	(317507, 143, '2015-01-15 00:57:38.000000', 'temperatura', 733.0000, 'ºC'),
	(317508, 143, '2015-01-15 00:57:39.000000', 'temperatura', 83.0000, 'ºC'),
	(317509, 143, '2015-01-15 00:57:40.000000', 'temperatura', 618.0000, 'ºC'),
	(317510, 143, '2015-01-15 00:57:41.000000', 'temperatura', 440.0000, 'ºC'),
	(317511, 143, '2015-01-15 00:57:42.000000', 'temperatura', 346.0000, 'ºC'),
	(317512, 143, '2015-01-15 00:57:43.000000', 'temperatura', 411.0000, 'ºC'),
	(317513, 143, '2015-01-15 00:57:44.000000', 'temperatura', 1017.0000, 'ºC'),
	(317514, 143, '2015-01-15 00:57:45.000000', 'temperatura', 251.0000, 'ºC'),
	(317515, 143, '2015-01-15 00:57:46.000000', 'temperatura', 606.0000, 'ºC'),
	(317516, 143, '2015-01-15 00:57:47.000000', 'temperatura', 1080.0000, 'ºC'),
	(317517, 143, '2015-01-15 00:57:48.000000', 'temperatura', 1179.0000, 'ºC'),
	(317518, 143, '2015-01-15 00:57:49.000000', 'temperatura', 256.0000, 'ºC'),
	(317519, 143, '2015-01-15 00:57:50.000000', 'temperatura', 145.0000, 'ºC'),
	(317520, 143, '2015-01-15 00:57:51.000000', 'temperatura', 1156.0000, 'ºC'),
	(317521, 143, '2015-01-15 00:57:52.000000', 'temperatura', 545.0000, 'ºC'),
	(317522, 143, '2015-01-15 00:57:53.000000', 'temperatura', 460.0000, 'ºC'),
	(317523, 143, '2015-01-15 00:57:54.000000', 'temperatura', 664.0000, 'ºC'),
	(317524, 143, '2015-01-15 00:57:55.000000', 'temperatura', 742.0000, 'ºC'),
	(317525, 143, '2015-01-15 00:57:56.000000', 'temperatura', 520.0000, 'ºC'),
	(317526, 143, '2015-01-15 00:57:57.000000', 'temperatura', 371.0000, 'ºC'),
	(317527, 143, '2015-01-15 00:57:58.000000', 'temperatura', 297.0000, 'ºC'),
	(317528, 143, '2015-01-15 00:57:59.000000', 'temperatura', 372.0000, 'ºC'),
	(317529, 143, '2015-01-15 00:58:00.000000', 'temperatura', 970.0000, 'ºC'),
	(317530, 143, '2015-01-15 00:58:01.000000', 'temperatura', 133.0000, 'ºC'),
	(317531, 143, '2015-01-15 00:58:02.000000', 'temperatura', 158.0000, 'ºC'),
	(317532, 143, '2015-01-15 00:58:03.000000', 'temperatura', 389.0000, 'ºC'),
	(317533, 143, '2015-01-15 00:58:04.000000', 'temperatura', 273.0000, 'ºC'),
	(317534, 143, '2015-01-15 00:58:05.000000', 'temperatura', 198.0000, 'ºC'),
	(317535, 143, '2015-01-15 00:58:06.000000', 'temperatura', 172.0000, 'ºC'),
	(317536, 143, '2015-01-15 00:58:07.000000', 'temperatura', 267.0000, 'ºC'),
	(317537, 143, '2015-01-15 00:58:08.000000', 'temperatura', 821.0000, 'ºC'),
	(317538, 143, '2015-01-15 00:58:09.000000', 'temperatura', 903.0000, 'ºC'),
	(317539, 143, '2015-01-15 00:58:10.000000', 'temperatura', 851.0000, 'ºC'),
	(317540, 143, '2015-01-15 00:58:11.000000', 'temperatura', 346.0000, 'ºC'),
	(317541, 143, '2015-01-15 00:58:12.000000', 'temperatura', 378.0000, 'ºC'),
	(317542, 143, '2015-01-15 00:58:13.000000', 'temperatura', 855.0000, 'ºC'),
	(317543, 143, '2015-01-15 00:58:14.000000', 'temperatura', 738.0000, 'ºC'),
	(317544, 143, '2015-01-15 00:58:15.000000', 'temperatura', 1127.0000, 'ºC'),
	(317545, 143, '2015-01-15 00:58:16.000000', 'temperatura', 1021.0000, 'ºC'),
	(317546, 143, '2015-01-15 00:58:17.000000', 'temperatura', 526.0000, 'ºC'),
	(317547, 143, '2015-01-15 00:58:18.000000', 'temperatura', 766.0000, 'ºC'),
	(317548, 143, '2015-01-15 00:58:19.000000', 'temperatura', 1053.0000, 'ºC'),
	(317549, 143, '2015-01-15 00:58:20.000000', 'temperatura', 570.0000, 'ºC'),
	(317550, 143, '2015-01-15 00:58:21.000000', 'temperatura', 888.0000, 'ºC'),
	(317551, 143, '2015-01-15 00:58:22.000000', 'temperatura', 332.0000, 'ºC'),
	(317552, 143, '2015-01-15 00:58:23.000000', 'temperatura', 198.0000, 'ºC'),
	(317553, 143, '2015-01-15 00:58:24.000000', 'temperatura', 1192.0000, 'ºC'),
	(317554, 143, '2015-01-15 00:58:25.000000', 'temperatura', 567.0000, 'ºC'),
	(317555, 143, '2015-01-15 00:58:26.000000', 'temperatura', 460.0000, 'ºC'),
	(317556, 143, '2015-01-15 00:58:27.000000', 'temperatura', 599.0000, 'ºC'),
	(317557, 143, '2015-01-15 00:58:28.000000', 'temperatura', 415.0000, 'ºC'),
	(317558, 143, '2015-01-15 00:58:29.000000', 'temperatura', 281.0000, 'ºC'),
	(317559, 143, '2015-01-15 00:58:30.000000', 'temperatura', 158.0000, 'ºC'),
	(317560, 143, '2015-01-15 00:58:31.000000', 'temperatura', 1150.0000, 'ºC'),
	(317561, 143, '2015-01-15 00:58:32.000000', 'temperatura', 475.0000, 'ºC'),
	(317562, 143, '2015-01-15 00:58:33.000000', 'temperatura', 124.0000, 'ºC'),
	(317563, 143, '2015-01-15 00:58:34.000000', 'temperatura', 397.0000, 'ºC'),
	(317564, 143, '2015-01-15 00:58:35.000000', 'temperatura', 414.0000, 'ºC'),
	(317565, 143, '2015-01-15 00:58:36.000000', 'temperatura', 881.0000, 'ºC'),
	(317566, 143, '2015-01-15 00:58:37.000000', 'temperatura', 762.0000, 'ºC'),
	(317567, 143, '2015-01-15 00:58:38.000000', 'temperatura', 1169.0000, 'ºC'),
	(317568, 143, '2015-01-15 00:58:39.000000', 'temperatura', 1159.0000, 'ºC'),
	(317569, 143, '2015-01-15 00:58:40.000000', 'temperatura', 1087.0000, 'ºC'),
	(317570, 143, '2015-01-15 00:58:41.000000', 'temperatura', 758.0000, 'ºC'),
	(317571, 143, '2015-01-15 00:58:42.000000', 'temperatura', 530.0000, 'ºC'),
	(317572, 143, '2015-01-15 00:58:43.000000', 'temperatura', 379.0000, 'ºC'),
	(317573, 143, '2015-01-15 00:58:44.000000', 'temperatura', 302.0000, 'ºC'),
	(317574, 143, '2015-01-15 00:58:45.000000', 'temperatura', 376.0000, 'ºC'),
	(317575, 143, '2015-01-15 00:58:46.000000', 'temperatura', 975.0000, 'ºC'),
	(317576, 143, '2015-01-15 00:58:47.000000', 'temperatura', 148.0000, 'ºC'),
	(317577, 143, '2015-01-15 00:58:48.000000', 'temperatura', 215.0000, 'ºC'),
	(317578, 143, '2015-01-15 00:58:49.000000', 'temperatura', 629.0000, 'ºC'),
	(317579, 143, '2015-01-15 00:58:50.000000', 'temperatura', 102.0000, 'ºC'),
	(317580, 143, '2015-01-15 00:58:51.000000', 'temperatura', 1025.0000, 'ºC'),
	(317581, 143, '2015-01-15 00:58:52.000000', 'temperatura', 17.0000, 'ºC'),
	(317582, 143, '2015-01-15 00:58:53.000000', 'temperatura', 611.0000, 'ºC'),
	(317583, 143, '2015-01-15 00:58:54.000000', 'temperatura', 606.0000, 'ºC'),
	(317584, 143, '2015-01-15 00:58:55.000000', 'temperatura', 1197.0000, 'ºC'),
	(317585, 143, '2015-01-15 00:58:56.000000', 'temperatura', 569.0000, 'ºC'),
	(317586, 143, '2015-01-15 00:58:57.000000', 'temperatura', 452.0000, 'ºC'),
	(317587, 143, '2015-01-15 00:58:58.000000', 'temperatura', 554.0000, 'ºC'),
	(317588, 143, '2015-01-15 00:58:59.000000', 'temperatura', 217.0000, 'ºC'),
	(317589, 143, '2015-01-15 00:59:00.000000', 'temperatura', 621.0000, 'ºC'),
	(317590, 143, '2015-01-15 00:59:01.000000', 'temperatura', 54.0000, 'ºC'),
	(317591, 143, '2015-01-15 00:59:02.000000', 'temperatura', 807.0000, 'ºC'),
	(317592, 143, '2015-01-15 00:59:03.000000', 'temperatura', 273.0000, 'ºC'),
	(317593, 143, '2015-01-15 00:59:04.000000', 'temperatura', 147.0000, 'ºC'),
	(317594, 143, '2015-01-15 00:59:05.000000', 'temperatura', 1115.0000, 'ºC'),
	(317595, 143, '2015-01-15 00:59:06.000000', 'temperatura', 334.0000, 'ºC'),
	(317596, 143, '2015-01-15 00:59:07.000000', 'temperatura', 725.0000, 'ºC'),
	(317597, 143, '2015-01-15 00:59:08.000000', 'temperatura', 223.0000, 'ºC'),
	(317598, 143, '2015-01-15 00:59:09.000000', 'temperatura', 140.0000, 'ºC'),
	(317599, 143, '2015-01-15 00:59:10.000000', 'temperatura', 35.0000, 'ºC'),
	(317600, 143, '2015-01-15 00:59:11.000000', 'temperatura', 952.0000, 'ºC'),
	(317601, 143, '2015-01-15 00:59:12.000000', 'temperatura', 1056.0000, 'ºC'),
	(317602, 143, '2015-01-15 00:59:13.000000', 'temperatura', 25.0000, 'ºC'),
	(317603, 143, '2015-01-15 00:59:14.000000', 'temperatura', 557.0000, 'ºC'),
	(317604, 143, '2015-01-15 00:59:15.000000', 'temperatura', 309.0000, 'ºC'),
	(317605, 143, '2015-01-15 00:59:16.000000', 'temperatura', 1076.0000, 'ºC'),
	(317606, 143, '2015-01-15 00:59:17.000000', 'temperatura', 854.0000, 'ºC'),
	(317607, 143, '2015-01-15 00:59:18.000000', 'temperatura', 1044.0000, 'ºC'),
	(317608, 143, '2015-01-15 00:59:19.000000', 'temperatura', 255.0000, 'ºC'),
	(317609, 143, '2015-01-15 00:59:20.000000', 'temperatura', 546.0000, 'ºC'),
	(317610, 143, '2015-01-15 00:59:21.000000', 'temperatura', 766.0000, 'ºC'),
	(317611, 143, '2015-01-15 00:59:22.000000', 'temperatura', 993.0000, 'ºC'),
	(317612, 143, '2015-01-15 00:59:23.000000', 'temperatura', 267.0000, 'ºC'),
	(317613, 143, '2015-01-15 00:59:24.000000', 'temperatura', 757.0000, 'ºC'),
	(317614, 143, '2015-01-15 00:59:25.000000', 'temperatura', 586.0000, 'ºC'),
	(317615, 143, '2015-01-15 00:59:26.000000', 'temperatura', 658.0000, 'ºC'),
	(317616, 143, '2015-01-15 00:59:27.000000', 'temperatura', 334.0000, 'ºC'),
	(317617, 143, '2015-01-15 00:59:28.000000', 'temperatura', 895.0000, 'ºC'),
	(317618, 143, '2015-01-15 00:59:29.000000', 'temperatura', 1073.0000, 'ºC'),
	(317619, 143, '2015-01-15 00:59:30.000000', 'temperatura', 281.0000, 'ºC'),
	(317620, 143, '2015-01-15 00:59:31.000000', 'temperatura', 586.0000, 'ºC'),
	(317621, 143, '2015-01-15 00:59:32.000000', 'temperatura', 887.0000, 'ºC'),
	(317622, 143, '2015-01-15 00:59:33.000000', 'temperatura', 276.0000, 'ºC'),
	(317623, 143, '2015-01-15 00:59:34.000000', 'temperatura', 1121.0000, 'ºC'),
	(317624, 143, '2015-01-15 00:59:35.000000', 'temperatura', 1179.0000, 'ºC'),
	(317625, 143, '2015-01-15 00:59:36.000000', 'temperatura', 131.0000, 'ºC'),
	(317626, 143, '2015-01-15 00:59:37.000000', 'temperatura', 721.0000, 'ºC'),
	(317627, 143, '2015-01-15 00:59:38.000000', 'temperatura', 810.0000, 'ºC'),
	(317628, 143, '2015-01-15 00:59:39.000000', 'temperatura', 688.0000, 'ºC'),
	(317629, 143, '2015-01-15 00:59:40.000000', 'temperatura', 1012.0000, 'ºC'),
	(317630, 143, '2015-01-15 00:59:41.000000', 'temperatura', 595.0000, 'ºC'),
	(317631, 143, '2015-01-15 00:59:42.000000', 'temperatura', 1140.0000, 'ºC'),
	(317632, 143, '2015-01-15 00:59:43.000000', 'temperatura', 317.0000, 'ºC'),
	(317633, 143, '2015-01-15 00:59:44.000000', 'temperatura', 563.0000, 'ºC'),
	(317634, 143, '2015-01-15 00:59:45.000000', 'temperatura', 667.0000, 'ºC'),
	(317635, 143, '2015-01-15 00:59:46.000000', 'temperatura', 444.0000, 'ºC'),
	(317636, 143, '2015-01-15 00:59:47.000000', 'temperatura', 219.0000, 'ºC'),
	(317637, 143, '2015-01-15 00:59:48.000000', 'temperatura', 963.0000, 'ºC'),
	(317638, 143, '2015-01-15 00:59:49.000000', 'temperatura', 561.0000, 'ºC'),
	(317639, 143, '2015-01-15 00:59:50.000000', 'temperatura', 1117.0000, 'ºC'),
	(317640, 143, '2015-01-15 00:59:51.000000', 'temperatura', 303.0000, 'ºC'),
	(317641, 143, '2015-01-15 00:59:52.000000', 'temperatura', 563.0000, 'ºC'),
	(317642, 143, '2015-01-15 00:59:53.000000', 'temperatura', 708.0000, 'ºC'),
	(317643, 143, '2015-01-15 00:59:54.000000', 'temperatura', 651.0000, 'ºC'),
	(317644, 143, '2015-01-15 00:59:55.000000', 'temperatura', 1130.0000, 'ºC'),
	(317645, 143, '2015-01-15 00:59:56.000000', 'temperatura', 97.0000, 'ºC'),
	(317646, 143, '2015-01-15 00:59:57.000000', 'temperatura', 697.0000, 'ºC'),
	(317647, 143, '2015-01-15 00:59:58.000000', 'temperatura', 795.0000, 'ºC'),
	(317648, 143, '2015-01-15 00:59:59.000000', 'temperatura', 685.0000, 'ºC'),
	(317649, 143, '2015-01-15 01:00:00.000000', 'temperatura', 1041.0000, 'ºC'),
	(317650, 143, '2015-01-15 01:00:01.000000', 'temperatura', 748.0000, 'ºC'),
	(317651, 143, '2015-01-15 01:00:02.000000', 'temperatura', 620.0000, 'ºC'),
	(317652, 143, '2015-01-15 01:00:03.000000', 'temperatura', 857.0000, 'ºC'),
	(317653, 143, '2015-01-15 01:00:04.000000', 'temperatura', 24.0000, 'ºC'),
	(317654, 143, '2015-01-15 01:00:05.000000', 'temperatura', 1150.0000, 'ºC'),
	(317655, 143, '2015-01-15 01:00:06.000000', 'temperatura', 879.0000, 'ºC'),
	(317656, 143, '2015-01-15 01:00:07.000000', 'temperatura', 945.0000, 'ºC'),
	(317657, 143, '2015-01-15 01:00:08.000000', 'temperatura', 888.0000, 'ºC'),
	(317658, 143, '2015-01-15 01:00:09.000000', 'temperatura', 406.0000, 'ºC'),
	(317659, 143, '2015-01-15 01:00:10.000000', 'temperatura', 565.0000, 'ºC'),
	(317660, 143, '2015-01-15 01:00:11.000000', 'temperatura', 409.0000, 'ºC'),
	(317661, 143, '2015-01-15 01:00:12.000000', 'temperatura', 352.0000, 'ºC'),
	(317662, 143, '2015-01-15 01:00:13.000000', 'temperatura', 531.0000, 'ºC'),
	(317663, 143, '2015-01-15 01:00:14.000000', 'temperatura', 398.0000, 'ºC'),
	(317664, 143, '2015-01-15 01:00:15.000000', 'temperatura', 400.0000, 'ºC'),
	(317665, 143, '2015-01-15 01:00:16.000000', 'temperatura', 806.0000, 'ºC'),
	(317666, 143, '2015-01-15 01:00:17.000000', 'temperatura', 431.0000, 'ºC'),
	(317667, 143, '2015-01-15 01:00:18.000000', 'temperatura', 938.0000, 'ºC'),
	(317668, 143, '2015-01-15 01:00:19.000000', 'temperatura', 995.0000, 'ºC'),
	(317669, 143, '2015-01-15 01:00:20.000000', 'temperatura', 964.0000, 'ºC'),
	(317670, 143, '2015-01-15 01:00:21.000000', 'temperatura', 637.0000, 'ºC'),
	(317671, 143, '2015-01-15 01:00:22.000000', 'temperatura', 291.0000, 'ºC'),
	(317672, 143, '2015-01-15 01:00:23.000000', 'temperatura', 743.0000, 'ºC'),
	(317673, 143, '2015-01-15 01:00:24.000000', 'temperatura', 444.0000, 'ºC'),
	(317674, 143, '2015-01-15 01:00:25.000000', 'temperatura', 1193.0000, 'ºC'),
	(317675, 143, '2015-01-15 01:00:26.000000', 'temperatura', 1034.0000, 'ºC'),
	(317676, 143, '2015-01-15 01:00:27.000000', 'temperatura', 391.0000, 'ºC'),
	(317677, 143, '2015-01-15 01:00:28.000000', 'temperatura', 53.0000, 'ºC'),
	(317678, 143, '2015-01-15 01:00:29.000000', 'temperatura', 294.0000, 'ºC'),
	(317679, 143, '2015-01-15 01:00:30.000000', 'temperatura', 109.0000, 'ºC'),
	(317680, 143, '2015-01-15 01:00:31.000000', 'temperatura', 865.0000, 'ºC'),
	(317681, 143, '2015-01-15 01:00:32.000000', 'temperatura', 396.0000, 'ºC'),
	(317682, 143, '2015-01-15 01:00:33.000000', 'temperatura', 589.0000, 'ºC'),
	(317683, 143, '2015-01-15 01:00:34.000000', 'temperatura', 555.0000, 'ºC'),
	(317684, 143, '2015-01-15 01:00:35.000000', 'temperatura', 1011.0000, 'ºC'),
	(317685, 143, '2015-01-15 01:00:36.000000', 'temperatura', 989.0000, 'ºC'),
	(317686, 143, '2015-01-15 01:00:37.000000', 'temperatura', 713.0000, 'ºC'),
	(317687, 143, '2015-01-15 01:00:38.000000', 'temperatura', 597.0000, 'ºC'),
	(317688, 143, '2015-01-15 01:00:39.000000', 'temperatura', 849.0000, 'ºC'),
	(317689, 143, '2015-01-15 01:00:40.000000', 'temperatura', 55.0000, 'ºC'),
	(317690, 143, '2015-01-15 01:00:41.000000', 'temperatura', 129.0000, 'ºC'),
	(317691, 143, '2015-01-15 01:00:42.000000', 'temperatura', 481.0000, 'ºC'),
	(317692, 143, '2015-01-15 01:00:43.000000', 'temperatura', 816.0000, 'ºC'),
	(317693, 143, '2015-01-15 01:00:44.000000', 'temperatura', 240.0000, 'ºC'),
	(317694, 143, '2015-01-15 01:00:45.000000', 'temperatura', 1152.0000, 'ºC'),
	(317695, 143, '2015-01-15 01:00:46.000000', 'temperatura', 240.0000, 'ºC'),
	(317696, 143, '2015-01-15 01:00:47.000000', 'temperatura', 145.0000, 'ºC'),
	(317697, 143, '2015-01-15 01:00:48.000000', 'temperatura', 4.0000, 'ºC'),
	(317698, 143, '2015-01-15 01:00:49.000000', 'temperatura', 788.0000, 'ºC'),
	(317699, 143, '2015-01-15 01:00:50.000000', 'temperatura', 329.0000, 'ºC'),
	(317700, 143, '2015-01-15 01:00:51.000000', 'temperatura', 479.0000, 'ºC'),
	(317701, 143, '2015-01-15 01:00:52.000000', 'temperatura', 208.0000, 'ºC'),
	(317702, 143, '2015-01-15 01:00:53.000000', 'temperatura', 803.0000, 'ºC'),
	(317703, 143, '2015-01-15 01:00:54.000000', 'temperatura', 993.0000, 'ºC'),
	(317704, 143, '2015-01-15 01:00:55.000000', 'temperatura', 155.0000, 'ºC'),
	(317705, 143, '2015-01-15 01:00:56.000000', 'temperatura', 198.0000, 'ºC'),
	(317706, 143, '2015-01-15 01:00:57.000000', 'temperatura', 524.0000, 'ºC'),
	(317707, 143, '2015-01-15 01:00:58.000000', 'temperatura', 828.0000, 'ºC'),
	(317708, 143, '2015-01-15 01:00:59.000000', 'temperatura', 168.0000, 'ºC'),
	(317709, 143, '2015-01-15 01:01:00.000000', 'temperatura', 757.0000, 'ºC'),
	(317710, 143, '2015-01-15 01:01:01.000000', 'temperatura', 880.0000, 'ºC'),
	(317711, 143, '2015-01-15 01:01:02.000000', 'temperatura', 928.0000, 'ºC'),
	(317712, 143, '2015-01-15 01:01:03.000000', 'temperatura', 804.0000, 'ºC'),
	(317713, 143, '2015-01-15 01:01:04.000000', 'temperatura', 34.0000, 'ºC'),
	(317714, 143, '2015-01-15 01:01:05.000000', 'temperatura', 158.0000, 'ºC'),
	(317715, 143, '2015-01-15 01:01:06.000000', 'temperatura', 689.0000, 'ºC'),
	(317716, 143, '2015-01-15 01:01:07.000000', 'temperatura', 573.0000, 'ºC'),
	(317717, 143, '2015-01-15 01:01:08.000000', 'temperatura', 797.0000, 'ºC'),
	(317718, 143, '2015-01-15 01:01:09.000000', 'temperatura', 1069.0000, 'ºC'),
	(317719, 143, '2015-01-15 01:01:10.000000', 'temperatura', 552.0000, 'ºC'),
	(317720, 143, '2015-01-15 01:01:11.000000', 'temperatura', 755.0000, 'ºC'),
	(317721, 143, '2015-01-15 01:01:12.000000', 'temperatura', 918.0000, 'ºC'),
	(317722, 143, '2015-01-15 01:01:13.000000', 'temperatura', 1128.0000, 'ºC'),
	(317723, 143, '2015-01-15 01:01:14.000000', 'temperatura', 485.0000, 'ºC'),
	(317724, 143, '2015-01-15 01:01:15.000000', 'temperatura', 240.0000, 'ºC'),
	(317725, 143, '2015-01-15 01:01:16.000000', 'temperatura', 947.0000, 'ºC'),
	(317726, 143, '2015-01-15 01:01:17.000000', 'temperatura', 414.0000, 'ºC'),
	(317727, 143, '2015-01-15 01:01:18.000000', 'temperatura', 432.0000, 'ºC'),
	(317728, 143, '2015-01-15 01:01:19.000000', 'temperatura', 919.0000, 'ºC'),
	(317729, 143, '2015-01-15 01:01:20.000000', 'temperatura', 900.0000, 'ºC'),
	(317730, 143, '2015-01-15 01:01:21.000000', 'temperatura', 544.0000, 'ºC'),
	(317731, 143, '2015-01-15 01:01:22.000000', 'temperatura', 18.0000, 'ºC'),
	(317732, 143, '2015-01-15 01:01:23.000000', 'temperatura', 860.0000, 'ºC'),
	(317733, 143, '2015-01-15 01:01:24.000000', 'temperatura', 648.0000, 'ºC'),
	(317734, 143, '2015-01-15 01:01:25.000000', 'temperatura', 657.0000, 'ºC'),
	(317735, 143, '2015-01-15 01:01:26.000000', 'temperatura', 144.0000, 'ºC'),
	(317736, 143, '2015-01-15 01:01:27.000000', 'temperatura', 1147.0000, 'ºC'),
	(317737, 143, '2015-01-15 01:01:28.000000', 'temperatura', 503.0000, 'ºC'),
	(317738, 143, '2015-01-15 01:01:29.000000', 'temperatura', 277.0000, 'ºC'),
	(317739, 143, '2015-01-15 01:01:30.000000', 'temperatura', 1077.0000, 'ºC'),
	(317740, 143, '2015-01-15 01:01:31.000000', 'temperatura', 953.0000, 'ºC'),
	(317741, 143, '2015-01-15 01:01:32.000000', 'temperatura', 335.0000, 'ºC'),
	(317742, 143, '2015-01-15 01:01:33.000000', 'temperatura', 16.0000, 'ºC'),
	(317743, 143, '2015-01-15 01:01:34.000000', 'temperatura', 274.0000, 'ºC'),
	(317744, 143, '2015-01-15 01:01:35.000000', 'temperatura', 124.0000, 'ºC'),
	(317745, 143, '2015-01-15 01:01:36.000000', 'temperatura', 998.0000, 'ºC'),
	(317746, 143, '2015-01-15 01:01:37.000000', 'temperatura', 1021.0000, 'ºC'),
	(317747, 143, '2015-01-15 01:01:38.000000', 'temperatura', 908.0000, 'ºC'),
	(317748, 143, '2015-01-15 01:01:39.000000', 'temperatura', 279.0000, 'ºC'),
	(317749, 143, '2015-01-15 01:01:40.000000', 'temperatura', 1070.0000, 'ºC'),
	(317750, 143, '2015-01-15 01:01:41.000000', 'temperatura', 916.0000, 'ºC'),
	(317751, 143, '2015-01-15 01:01:42.000000', 'temperatura', 168.0000, 'ºC'),
	(317752, 143, '2015-01-15 01:01:43.000000', 'temperatura', 494.0000, 'ºC'),
	(317753, 143, '2015-01-15 01:01:44.000000', 'temperatura', 767.0000, 'ºC'),
	(317754, 143, '2015-01-15 01:01:45.000000', 'temperatura', 1154.0000, 'ºC'),
	(317755, 143, '2015-01-15 01:01:46.000000', 'temperatura', 1067.0000, 'ºC'),
	(317756, 143, '2015-01-15 01:01:47.000000', 'temperatura', 676.0000, 'ºC'),
	(317757, 143, '2015-01-15 01:01:48.000000', 'temperatura', 178.0000, 'ºC'),
	(317758, 143, '2015-01-15 01:01:49.000000', 'temperatura', 64.0000, 'ºC'),
	(317759, 143, '2015-01-15 01:01:50.000000', 'temperatura', 985.0000, 'ºC'),
	(317760, 143, '2015-01-15 01:01:51.000000', 'temperatura', 1132.0000, 'ºC'),
	(317761, 143, '2015-01-15 01:01:52.000000', 'temperatura', 308.0000, 'ºC'),
	(317762, 143, '2015-01-15 01:01:53.000000', 'temperatura', 544.0000, 'ºC'),
	(317763, 143, '2015-01-15 01:01:54.000000', 'temperatura', 598.0000, 'ºC'),
	(317764, 143, '2015-01-15 01:01:55.000000', 'temperatura', 156.0000, 'ºC'),
	(317765, 143, '2015-01-15 01:01:56.000000', 'temperatura', 189.0000, 'ºC'),
	(317766, 143, '2015-01-15 01:01:57.000000', 'temperatura', 475.0000, 'ºC'),
	(317767, 143, '2015-01-15 01:01:58.000000', 'temperatura', 610.0000, 'ºC'),
	(317768, 143, '2015-01-15 01:01:59.000000', 'temperatura', 424.0000, 'ºC'),
	(317769, 143, '2015-01-15 01:02:00.000000', 'temperatura', 293.0000, 'ºC'),
	(317770, 143, '2015-01-15 01:02:01.000000', 'temperatura', 194.0000, 'ºC'),
	(317771, 143, '2015-01-15 01:02:02.000000', 'temperatura', 91.0000, 'ºC'),
	(317772, 143, '2015-01-15 01:02:03.000000', 'temperatura', 1071.0000, 'ºC'),
	(317773, 143, '2015-01-15 01:02:04.000000', 'temperatura', 286.0000, 'ºC'),
	(317774, 143, '2015-01-15 01:02:05.000000', 'temperatura', 615.0000, 'ºC'),
	(317775, 143, '2015-01-15 01:02:06.000000', 'temperatura', 1020.0000, 'ºC'),
	(317776, 143, '2015-01-15 01:02:07.000000', 'temperatura', 853.0000, 'ºC'),
	(317777, 143, '2015-01-15 01:02:08.000000', 'temperatura', 6.0000, 'ºC'),
	(317778, 143, '2015-01-15 01:02:09.000000', 'temperatura', 1072.0000, 'ºC'),
	(317779, 143, '2015-01-15 01:02:10.000000', 'temperatura', 542.0000, 'ºC'),
	(317780, 143, '2015-01-15 01:02:11.000000', 'temperatura', 695.0000, 'ºC'),
	(317781, 143, '2015-01-15 01:02:12.000000', 'temperatura', 649.0000, 'ºC'),
	(317782, 143, '2015-01-15 01:02:13.000000', 'temperatura', 1160.0000, 'ºC'),
	(317783, 143, '2015-01-15 01:02:14.000000', 'temperatura', 252.0000, 'ºC'),
	(317784, 143, '2015-01-15 01:02:15.000000', 'temperatura', 182.0000, 'ºC'),
	(317785, 143, '2015-01-15 01:02:16.000000', 'temperatura', 156.0000, 'ºC'),
	(317786, 143, '2015-01-15 01:02:17.000000', 'temperatura', 234.0000, 'ºC'),
	(317787, 143, '2015-01-15 01:02:18.000000', 'temperatura', 704.0000, 'ºC'),
	(317788, 143, '2015-01-15 01:02:19.000000', 'temperatura', 417.0000, 'ºC'),
	(317789, 143, '2015-01-15 01:02:20.000000', 'temperatura', 1172.0000, 'ºC'),
	(317790, 143, '2015-01-15 01:02:21.000000', 'temperatura', 1011.0000, 'ºC'),
	(317791, 143, '2015-01-15 01:02:22.000000', 'temperatura', 341.0000, 'ºC'),
	(317792, 143, '2015-01-15 01:02:23.000000', 'temperatura', 1071.0000, 'ºC'),
	(317793, 143, '2015-01-15 01:02:24.000000', 'temperatura', 734.0000, 'ºC'),
	(317794, 143, '2015-01-15 01:02:25.000000', 'temperatura', 459.0000, 'ºC'),
	(317795, 143, '2015-01-15 01:02:26.000000', 'temperatura', 91.0000, 'ºC'),
	(317796, 143, '2015-01-15 01:02:27.000000', 'temperatura', 277.0000, 'ºC'),
	(317797, 143, '2015-01-15 01:02:28.000000', 'temperatura', 1115.0000, 'ºC'),
	(317798, 143, '2015-01-15 01:02:29.000000', 'temperatura', 1144.0000, 'ºC'),
	(317799, 143, '2015-01-15 01:02:30.000000', 'temperatura', 1176.0000, 'ºC'),
	(317800, 143, '2015-01-15 01:02:31.000000', 'temperatura', 47.0000, 'ºC'),
	(317801, 143, '2015-01-15 01:02:32.000000', 'temperatura', 307.0000, 'ºC'),
	(317802, 143, '2015-01-15 01:02:33.000000', 'temperatura', 194.0000, 'ºC'),
	(317803, 143, '2015-01-15 01:02:34.000000', 'temperatura', 51.0000, 'ºC'),
	(317804, 143, '2015-01-15 01:02:35.000000', 'temperatura', 875.0000, 'ºC'),
	(317805, 143, '2015-01-15 01:02:36.000000', 'temperatura', 620.0000, 'ºC'),
	(317806, 143, '2015-01-15 01:02:37.000000', 'temperatura', 475.0000, 'ºC'),
	(317807, 143, '2015-01-15 01:02:38.000000', 'temperatura', 517.0000, 'ºC'),
	(317808, 143, '2015-01-15 01:02:39.000000', 'temperatura', 1160.0000, 'ºC'),
	(317809, 143, '2015-01-15 01:02:40.000000', 'temperatura', 648.0000, 'ºC'),
	(317810, 143, '2015-01-15 01:02:41.000000', 'temperatura', 960.0000, 'ºC'),
	(317811, 143, '2015-01-15 01:02:42.000000', 'temperatura', 458.0000, 'ºC'),
	(317812, 143, '2015-01-15 01:02:43.000000', 'temperatura', 611.0000, 'ºC'),
	(317813, 143, '2015-01-15 01:02:44.000000', 'temperatura', 480.0000, 'ºC'),
	(317814, 143, '2015-01-15 01:02:45.000000', 'temperatura', 567.0000, 'ºC'),
	(317815, 143, '2015-01-15 01:02:46.000000', 'temperatura', 195.0000, 'ºC'),
	(317816, 143, '2015-01-15 01:02:47.000000', 'temperatura', 477.0000, 'ºC'),
	(317817, 143, '2015-01-15 01:02:48.000000', 'temperatura', 601.0000, 'ºC'),
	(317818, 143, '2015-01-15 01:02:49.000000', 'temperatura', 373.0000, 'ºC'),
	(317819, 143, '2015-01-15 01:02:50.000000', 'temperatura', 64.0000, 'ºC'),
	(317820, 143, '2015-01-15 01:02:51.000000', 'temperatura', 399.0000, 'ºC'),
	(317821, 143, '2015-01-15 01:02:52.000000', 'temperatura', 605.0000, 'ºC'),
	(317822, 143, '2015-01-15 01:02:53.000000', 'temperatura', 626.0000, 'ºC'),
	(317823, 143, '2015-01-15 01:02:54.000000', 'temperatura', 118.0000, 'ºC'),
	(317824, 143, '2015-01-15 01:02:55.000000', 'temperatura', 1113.0000, 'ºC'),
	(317825, 143, '2015-01-15 01:02:56.000000', 'temperatura', 412.0000, 'ºC'),
	(317826, 143, '2015-01-15 01:02:57.000000', 'temperatura', 1122.0000, 'ºC'),
	(317827, 143, '2015-01-15 01:02:58.000000', 'temperatura', 772.0000, 'ºC'),
	(317828, 143, '2015-01-15 01:02:59.000000', 'temperatura', 496.0000, 'ºC'),
	(317829, 143, '2015-01-15 01:03:00.000000', 'temperatura', 164.0000, 'ºC'),
	(317830, 143, '2015-01-15 01:03:01.000000', 'temperatura', 533.0000, 'ºC'),
	(317831, 143, '2015-01-15 01:03:02.000000', 'temperatura', 974.0000, 'ºC'),
	(317832, 143, '2015-01-15 01:03:03.000000', 'temperatura', 871.0000, 'ºC'),
	(317833, 143, '2015-01-15 01:03:04.000000', 'temperatura', 233.0000, 'ºC'),
	(317834, 143, '2015-01-15 01:03:05.000000', 'temperatura', 952.0000, 'ºC'),
	(317835, 143, '2015-01-15 01:03:06.000000', 'temperatura', 462.0000, 'ºC'),
	(317836, 143, '2015-01-15 01:03:07.000000', 'temperatura', 655.0000, 'ºC'),
	(317837, 143, '2015-01-15 01:03:08.000000', 'temperatura', 688.0000, 'ºC'),
	(317838, 143, '2015-01-15 01:03:09.000000', 'temperatura', 275.0000, 'ºC'),
	(317839, 143, '2015-01-15 01:03:10.000000', 'temperatura', 512.0000, 'ºC'),
	(317840, 143, '2015-01-15 01:03:11.000000', 'temperatura', 538.0000, 'ºC'),
	(317841, 143, '2015-01-15 01:03:12.000000', 'temperatura', 1151.0000, 'ºC'),
	(317842, 143, '2015-01-15 01:03:13.000000', 'temperatura', 543.0000, 'ºC'),
	(317843, 143, '2015-01-15 01:03:14.000000', 'temperatura', 462.0000, 'ºC'),
	(317844, 143, '2015-01-15 01:03:15.000000', 'temperatura', 681.0000, 'ºC'),
	(317845, 143, '2015-01-15 01:03:16.000000', 'temperatura', 821.0000, 'ºC'),
	(317846, 143, '2015-01-15 01:03:17.000000', 'temperatura', 860.0000, 'ºC'),
	(317847, 143, '2015-01-15 01:03:18.000000', 'temperatura', 640.0000, 'ºC'),
	(317848, 143, '2015-01-15 01:03:19.000000', 'temperatura', 619.0000, 'ºC'),
	(317849, 143, '2015-01-15 01:03:20.000000', 'temperatura', 1175.0000, 'ºC'),
	(317850, 143, '2015-01-15 01:03:21.000000', 'temperatura', 419.0000, 'ºC'),
	(317851, 143, '2015-01-15 01:03:22.000000', 'temperatura', 969.0000, 'ºC'),
	(317852, 143, '2015-01-15 01:03:23.000000', 'temperatura', 1189.0000, 'ºC'),
	(317853, 143, '2015-01-15 01:03:24.000000', 'temperatura', 637.0000, 'ºC'),
	(317854, 143, '2015-01-15 01:03:25.000000', 'temperatura', 819.0000, 'ºC'),
	(317855, 143, '2015-01-15 01:03:26.000000', 'temperatura', 985.0000, 'ºC'),
	(317856, 143, '2015-01-15 01:03:27.000000', 'temperatura', 68.0000, 'ºC'),
	(317857, 143, '2015-01-15 01:03:28.000000', 'temperatura', 986.0000, 'ºC'),
	(317858, 143, '2015-01-15 01:03:29.000000', 'temperatura', 1126.0000, 'ºC'),
	(317859, 143, '2015-01-15 01:03:30.000000', 'temperatura', 274.0000, 'ºC'),
	(317860, 143, '2015-01-15 01:03:31.000000', 'temperatura', 392.0000, 'ºC'),
	(317861, 143, '2015-01-15 01:03:32.000000', 'temperatura', 1137.0000, 'ºC'),
	(317862, 143, '2015-01-15 01:03:33.000000', 'temperatura', 911.0000, 'ºC'),
	(317863, 143, '2015-01-15 01:03:34.000000', 'temperatura', 1144.0000, 'ºC'),
	(317864, 143, '2015-01-15 01:03:35.000000', 'temperatura', 587.0000, 'ºC'),
	(317865, 143, '2015-01-15 01:03:36.000000', 'temperatura', 702.0000, 'ºC'),
	(317866, 143, '2015-01-15 01:03:37.000000', 'temperatura', 552.0000, 'ºC'),
	(317867, 143, '2015-01-15 01:03:38.000000', 'temperatura', 653.0000, 'ºC'),
	(317868, 143, '2015-01-15 01:03:39.000000', 'temperatura', 411.0000, 'ºC'),
	(317869, 143, '2015-01-15 01:03:40.000000', 'temperatura', 94.0000, 'ºC'),
	(317870, 143, '2015-01-15 01:03:41.000000', 'temperatura', 438.0000, 'ºC'),
	(317871, 143, '2015-01-15 01:03:42.000000', 'temperatura', 709.0000, 'ºC'),
	(317872, 143, '2015-01-15 01:03:43.000000', 'temperatura', 1033.0000, 'ºC'),
	(317873, 143, '2015-01-15 01:03:44.000000', 'temperatura', 639.0000, 'ºC'),
	(317874, 143, '2015-01-15 01:03:45.000000', 'temperatura', 97.0000, 'ºC'),
	(317875, 143, '2015-01-15 01:03:46.000000', 'temperatura', 965.0000, 'ºC'),
	(317876, 143, '2015-01-15 01:03:47.000000', 'temperatura', 937.0000, 'ºC'),
	(317877, 143, '2015-01-15 01:03:48.000000', 'temperatura', 591.0000, 'ºC'),
	(317878, 143, '2015-01-15 01:03:49.000000', 'temperatura', 145.0000, 'ºC'),
	(317879, 143, '2015-01-15 01:03:50.000000', 'temperatura', 151.0000, 'ºC'),
	(317880, 143, '2015-01-15 01:03:51.000000', 'temperatura', 322.0000, 'ºC'),
	(317881, 143, '2015-01-15 01:03:52.000000', 'temperatura', 1158.0000, 'ºC'),
	(317882, 143, '2015-01-15 01:03:53.000000', 'temperatura', 26.0000, 'ºC'),
	(317883, 143, '2015-01-15 01:03:54.000000', 'temperatura', 253.0000, 'ºC'),
	(317884, 143, '2015-01-15 01:03:55.000000', 'temperatura', 1189.0000, 'ºC'),
	(317885, 143, '2015-01-15 01:03:56.000000', 'temperatura', 387.0000, 'ºC'),
	(317886, 143, '2015-01-15 01:03:57.000000', 'temperatura', 768.0000, 'ºC'),
	(317887, 143, '2015-01-15 01:03:58.000000', 'temperatura', 278.0000, 'ºC'),
	(317888, 143, '2015-01-15 01:03:59.000000', 'temperatura', 288.0000, 'ºC'),
	(317889, 143, '2015-01-15 01:04:00.000000', 'temperatura', 606.0000, 'ºC'),
	(317890, 143, '2015-01-15 01:04:01.000000', 'temperatura', 966.0000, 'ºC'),
	(317891, 143, '2015-01-15 01:04:02.000000', 'temperatura', 614.0000, 'ºC'),
	(317892, 143, '2015-01-15 01:04:03.000000', 'temperatura', 170.0000, 'ºC'),
	(317893, 143, '2015-01-15 01:04:04.000000', 'temperatura', 209.0000, 'ºC'),
	(317894, 143, '2015-01-15 01:04:05.000000', 'temperatura', 536.0000, 'ºC'),
	(317895, 143, '2015-01-15 01:04:06.000000', 'temperatura', 852.0000, 'ºC'),
	(317896, 143, '2015-01-15 01:04:07.000000', 'temperatura', 252.0000, 'ºC'),
	(317897, 143, '2015-01-15 01:04:08.000000', 'temperatura', 1105.0000, 'ºC'),
	(317898, 143, '2015-01-15 01:04:09.000000', 'temperatura', 1171.0000, 'ºC'),
	(317899, 143, '2015-01-15 01:04:10.000000', 'temperatura', 141.0000, 'ºC'),
	(317900, 143, '2015-01-15 01:04:11.000000', 'temperatura', 792.0000, 'ºC'),
	(317901, 143, '2015-01-15 01:04:12.000000', 'temperatura', 1137.0000, 'ºC'),
	(317902, 143, '2015-01-15 01:04:13.000000', 'temperatura', 912.0000, 'ºC'),
	(317903, 143, '2015-01-15 01:04:14.000000', 'temperatura', 1146.0000, 'ºC'),
	(317904, 143, '2015-01-15 01:04:15.000000', 'temperatura', 596.0000, 'ºC'),
	(317905, 143, '2015-01-15 01:04:16.000000', 'temperatura', 741.0000, 'ºC'),
	(317906, 143, '2015-01-15 01:04:17.000000', 'temperatura', 720.0000, 'ºC'),
	(317907, 143, '2015-01-15 01:04:18.000000', 'temperatura', 176.0000, 'ºC'),
	(317908, 143, '2015-01-15 01:04:19.000000', 'temperatura', 1120.0000, 'ºC'),
	(317909, 143, '2015-01-15 01:04:20.000000', 'temperatura', 274.0000, 'ºC'),
	(317910, 143, '2015-01-15 01:04:21.000000', 'temperatura', 411.0000, 'ºC'),
	(317911, 143, '2015-01-15 01:04:22.000000', 'temperatura', 32.0000, 'ºC'),
	(317912, 143, '2015-01-15 01:04:23.000000', 'temperatura', 126.0000, 'ºC'),
	(317913, 143, '2015-01-15 01:04:24.000000', 'temperatura', 538.0000, 'ºC'),
	(317914, 143, '2015-01-15 01:04:25.000000', 'temperatura', 1111.0000, 'ºC'),
	(317915, 143, '2015-01-15 01:04:26.000000', 'temperatura', 342.0000, 'ºC'),
	(317916, 143, '2015-01-15 01:04:27.000000', 'temperatura', 777.0000, 'ºC'),
	(317917, 143, '2015-01-15 01:04:28.000000', 'temperatura', 462.0000, 'ºC'),
	(317918, 143, '2015-01-15 01:04:29.000000', 'temperatura', 1176.0000, 'ºC'),
	(317919, 143, '2015-01-15 01:04:30.000000', 'temperatura', 896.0000, 'ºC'),
	(317920, 143, '2015-01-15 01:04:31.000000', 'temperatura', 954.0000, 'ºC'),
	(317921, 143, '2015-01-15 01:04:32.000000', 'temperatura', 883.0000, 'ºC'),
	(317922, 143, '2015-01-15 01:04:33.000000', 'temperatura', 351.0000, 'ºC'),
	(317923, 143, '2015-01-15 01:04:34.000000', 'temperatura', 309.0000, 'ºC'),
	(317924, 143, '2015-01-15 01:04:35.000000', 'temperatura', 493.0000, 'ºC'),
	(317925, 143, '2015-01-15 01:04:36.000000', 'temperatura', 335.0000, 'ºC'),
	(317926, 143, '2015-01-15 01:04:37.000000', 'temperatura', 200.0000, 'ºC'),
	(317927, 143, '2015-01-15 01:04:38.000000', 'temperatura', 1194.0000, 'ºC'),
	(317928, 143, '2015-01-15 01:04:39.000000', 'temperatura', 571.0000, 'ºC'),
	(317929, 143, '2015-01-15 01:04:40.000000', 'temperatura', 472.0000, 'ºC'),
	(317930, 143, '2015-01-15 01:04:41.000000', 'temperatura', 650.0000, 'ºC'),
	(317931, 143, '2015-01-15 01:04:42.000000', 'temperatura', 632.0000, 'ºC'),
	(317932, 143, '2015-01-15 01:04:43.000000', 'temperatura', 10.0000, 'ºC'),
	(317933, 143, '2015-01-15 01:04:44.000000', 'temperatura', 557.0000, 'ºC'),
	(317934, 143, '2015-01-15 01:04:45.000000', 'temperatura', 354.0000, 'ºC'),
	(317935, 143, '2015-01-15 01:04:46.000000', 'temperatura', 102.0000, 'ºC'),
	(317936, 143, '2015-01-15 01:04:47.000000', 'temperatura', 645.0000, 'ºC'),
	(317937, 143, '2015-01-15 01:04:48.000000', 'temperatura', 522.0000, 'ºC'),
	(317938, 143, '2015-01-15 01:04:49.000000', 'temperatura', 673.0000, 'ºC'),
	(317939, 143, '2015-01-15 01:04:50.000000', 'temperatura', 601.0000, 'ºC'),
	(317940, 143, '2015-01-15 01:04:51.000000', 'temperatura', 988.0000, 'ºC'),
	(317941, 143, '2015-01-15 01:04:52.000000', 'temperatura', 736.0000, 'ºC'),
	(317942, 143, '2015-01-15 01:04:53.000000', 'temperatura', 715.0000, 'ºC'),
	(317943, 143, '2015-01-15 01:04:54.000000', 'temperatura', 170.0000, 'ºC'),
	(317944, 143, '2015-01-15 01:04:55.000000', 'temperatura', 1106.0000, 'ºC'),
	(317945, 143, '2015-01-15 01:04:56.000000', 'temperatura', 219.0000, 'ºC'),
	(317946, 143, '2015-01-15 01:04:57.000000', 'temperatura', 180.0000, 'ºC'),
	(317947, 143, '2015-01-15 01:04:58.000000', 'temperatura', 241.0000, 'ºC'),
	(317948, 143, '2015-01-15 01:04:59.000000', 'temperatura', 667.0000, 'ºC'),
	(317949, 143, '2015-01-15 01:05:00.000000', 'temperatura', 214.0000, 'ºC'),
	(317950, 143, '2015-01-15 01:05:01.000000', 'temperatura', 268.0000, 'ºC'),
	(317951, 143, '2015-01-15 01:05:02.000000', 'temperatura', 699.0000, 'ºC'),
	(317952, 143, '2015-01-15 01:05:03.000000', 'temperatura', 289.0000, 'ºC'),
	(317953, 143, '2015-01-15 01:05:04.000000', 'temperatura', 551.0000, 'ºC'),
	(317954, 143, '2015-01-15 01:05:05.000000', 'temperatura', 686.0000, 'ºC'),
	(317955, 143, '2015-01-15 01:05:06.000000', 'temperatura', 579.0000, 'ºC'),
	(317956, 143, '2015-01-15 01:05:07.000000', 'temperatura', 837.0000, 'ºC'),
	(317957, 143, '2015-01-15 01:05:08.000000', 'temperatura', 51.0000, 'ºC'),
	(317958, 143, '2015-01-15 01:05:09.000000', 'temperatura', 142.0000, 'ºC'),
	(317959, 143, '2015-01-15 01:05:10.000000', 'temperatura', 557.0000, 'ºC'),
	(317960, 143, '2015-01-15 01:05:11.000000', 'temperatura', 1160.0000, 'ºC'),
	(317961, 143, '2015-01-15 01:05:12.000000', 'temperatura', 529.0000, 'ºC'),
	(317962, 143, '2015-01-15 01:05:13.000000', 'temperatura', 364.0000, 'ºC'),
	(317963, 143, '2015-01-15 01:05:14.000000', 'temperatura', 235.0000, 'ºC'),
	(317964, 143, '2015-01-15 01:05:15.000000', 'temperatura', 84.0000, 'ºC'),
	(317965, 143, '2015-01-15 01:05:16.000000', 'temperatura', 913.0000, 'ºC'),
	(317966, 143, '2015-01-15 01:05:17.000000', 'temperatura', 717.0000, 'ºC'),
	(317967, 143, '2015-01-15 01:05:18.000000', 'temperatura', 843.0000, 'ºC'),
	(317968, 143, '2015-01-15 01:05:19.000000', 'temperatura', 866.0000, 'ºC'),
	(317969, 143, '2015-01-15 01:05:20.000000', 'temperatura', 604.0000, 'ºC'),
	(317970, 143, '2015-01-15 01:05:21.000000', 'temperatura', 419.0000, 'ºC'),
	(317971, 143, '2015-01-15 01:05:22.000000', 'temperatura', 284.0000, 'ºC'),
	(317972, 143, '2015-01-15 01:05:23.000000', 'temperatura', 163.0000, 'ºC'),
	(317973, 143, '2015-01-15 01:05:24.000000', 'temperatura', 1164.0000, 'ºC'),
	(317974, 143, '2015-01-15 01:05:25.000000', 'temperatura', 530.0000, 'ºC'),
	(317975, 143, '2015-01-15 01:05:26.000000', 'temperatura', 358.0000, 'ºC'),
	(317976, 143, '2015-01-15 01:05:27.000000', 'temperatura', 202.0000, 'ºC'),
	(317977, 143, '2015-01-15 01:05:28.000000', 'temperatura', 1134.0000, 'ºC'),
	(317978, 143, '2015-01-15 01:05:29.000000', 'temperatura', 267.0000, 'ºC'),
	(317979, 143, '2015-01-15 01:05:30.000000', 'temperatura', 332.0000, 'ºC'),
	(317980, 143, '2015-01-15 01:05:31.000000', 'temperatura', 858.0000, 'ºC'),
	(317981, 143, '2015-01-15 01:05:32.000000', 'temperatura', 898.0000, 'ºC'),
	(317982, 143, '2015-01-15 01:05:33.000000', 'temperatura', 714.0000, 'ºC'),
	(317983, 143, '2015-01-15 01:05:34.000000', 'temperatura', 878.0000, 'ºC'),
	(317984, 143, '2015-01-15 01:05:35.000000', 'temperatura', 1050.0000, 'ºC'),
	(317985, 143, '2015-01-15 01:05:36.000000', 'temperatura', 214.0000, 'ºC'),
	(317986, 143, '2015-01-15 01:05:37.000000', 'temperatura', 322.0000, 'ºC'),
	(317987, 143, '2015-01-15 01:05:38.000000', 'temperatura', 969.0000, 'ºC'),
	(317988, 143, '2015-01-15 01:05:39.000000', 'temperatura', 277.0000, 'ºC'),
	(317989, 143, '2015-01-15 01:05:40.000000', 'temperatura', 880.0000, 'ºC'),
	(317990, 143, '2015-01-15 01:05:41.000000', 'temperatura', 1170.0000, 'ºC'),
	(317991, 143, '2015-01-15 01:05:42.000000', 'temperatura', 811.0000, 'ºC'),
	(317992, 143, '2015-01-15 01:05:43.000000', 'temperatura', 545.0000, 'ºC'),
	(317993, 143, '2015-01-15 01:05:44.000000', 'temperatura', 292.0000, 'ºC'),
	(317994, 143, '2015-01-15 01:05:45.000000', 'temperatura', 1026.0000, 'ºC'),
	(317995, 143, '2015-01-15 01:05:46.000000', 'temperatura', 656.0000, 'ºC'),
	(317996, 143, '2015-01-15 01:05:47.000000', 'temperatura', 202.0000, 'ºC'),
	(317997, 143, '2015-01-15 01:05:48.000000', 'temperatura', 242.0000, 'ºC'),
	(317998, 143, '2015-01-15 01:05:49.000000', 'temperatura', 604.0000, 'ºC'),
	(317999, 143, '2015-01-15 01:05:50.000000', 'temperatura', 1096.0000, 'ºC'),
	(318000, 143, '2015-01-15 01:05:51.000000', 'temperatura', 67.0000, 'ºC'),
	(318001, 143, '2015-01-15 01:05:52.000000', 'temperatura', 649.0000, 'ºC'),
	(318002, 143, '2015-01-15 01:05:53.000000', 'temperatura', 646.0000, 'ºC'),
	(318003, 143, '2015-01-15 01:05:54.000000', 'temperatura', 81.0000, 'ºC'),
	(318004, 143, '2015-01-15 01:05:55.000000', 'temperatura', 868.0000, 'ºC'),
	(318005, 143, '2015-01-15 01:05:56.000000', 'temperatura', 498.0000, 'ºC'),
	(318006, 143, '2015-01-15 01:05:57.000000', 'temperatura', 1088.0000, 'ºC'),
	(318007, 143, '2015-01-15 01:05:58.000000', 'temperatura', 344.0000, 'ºC'),
	(318008, 143, '2015-01-15 01:05:59.000000', 'temperatura', 857.0000, 'ºC'),
	(318009, 143, '2015-01-15 01:06:00.000000', 'temperatura', 855.0000, 'ºC'),
	(318010, 143, '2015-01-15 01:06:01.000000', 'temperatura', 502.0000, 'ºC'),
	(318011, 143, '2015-01-15 01:06:02.000000', 'temperatura', 1147.0000, 'ºC'),
	(318012, 143, '2015-01-15 01:06:03.000000', 'temperatura', 629.0000, 'ºC'),
	(318013, 143, '2015-01-15 01:06:04.000000', 'temperatura', 904.0000, 'ºC'),
	(318014, 143, '2015-01-15 01:06:05.000000', 'temperatura', 235.0000, 'ºC'),
	(318015, 143, '2015-01-15 01:06:06.000000', 'temperatura', 862.0000, 'ºC'),
	(318016, 143, '2015-01-15 01:06:07.000000', 'temperatura', 6.0000, 'ºC'),
	(318017, 143, '2015-01-15 01:06:08.000000', 'temperatura', 1046.0000, 'ºC'),
	(318018, 143, '2015-01-15 01:06:09.000000', 'temperatura', 413.0000, 'ºC'),
	(318019, 143, '2015-01-15 01:06:10.000000', 'temperatura', 128.0000, 'ºC'),
	(318020, 143, '2015-01-15 01:06:11.000000', 'temperatura', 599.0000, 'ºC'),
	(318021, 143, '2015-01-15 01:06:12.000000', 'temperatura', 213.0000, 'ºC'),
	(318022, 143, '2015-01-15 01:06:13.000000', 'temperatura', 470.0000, 'ºC'),
	(318023, 143, '2015-01-15 01:06:14.000000', 'temperatura', 510.0000, 'ºC'),
	(318024, 143, '2015-01-15 01:06:15.000000', 'temperatura', 1141.0000, 'ºC'),
	(318025, 143, '2015-01-15 01:06:16.000000', 'temperatura', 576.0000, 'ºC'),
	(318026, 143, '2015-01-15 01:06:17.000000', 'temperatura', 658.0000, 'ºC'),
	(318027, 143, '2015-01-15 01:06:18.000000', 'temperatura', 362.0000, 'ºC'),
	(318028, 143, '2015-01-15 01:06:19.000000', 'temperatura', 1036.0000, 'ºC'),
	(318029, 143, '2015-01-15 01:06:20.000000', 'temperatura', 495.0000, 'ºC'),
	(318030, 143, '2015-01-15 01:06:21.000000', 'temperatura', 569.0000, 'ºC'),
	(318031, 143, '2015-01-15 01:06:22.000000', 'temperatura', 160.0000, 'ºC'),
	(318032, 143, '2015-01-15 01:06:23.000000', 'temperatura', 294.0000, 'ºC'),
	(318033, 143, '2015-01-15 01:06:24.000000', 'temperatura', 991.0000, 'ºC'),
	(318034, 143, '2015-01-15 01:06:25.000000', 'temperatura', 472.0000, 'ºC'),
	(318035, 143, '2015-01-15 01:06:26.000000', 'temperatura', 587.0000, 'ºC'),
	(318036, 143, '2015-01-15 01:06:27.000000', 'temperatura', 322.0000, 'ºC'),
	(318037, 143, '2015-01-15 01:06:28.000000', 'temperatura', 1048.0000, 'ºC'),
	(318038, 143, '2015-01-15 01:06:29.000000', 'temperatura', 676.0000, 'ºC'),
	(318039, 143, '2015-01-15 01:06:30.000000', 'temperatura', 238.0000, 'ºC'),
	(318040, 143, '2015-01-15 01:06:31.000000', 'temperatura', 359.0000, 'ºC'),
	(318041, 143, '2015-01-15 01:06:32.000000', 'temperatura', 1083.0000, 'ºC'),
	(318042, 143, '2015-01-15 01:06:33.000000', 'temperatura', 740.0000, 'ºC'),
	(318043, 143, '2015-01-15 01:06:34.000000', 'temperatura', 451.0000, 'ºC'),
	(318044, 143, '2015-01-15 01:06:35.000000', 'temperatura', 36.0000, 'ºC'),
	(318045, 143, '2015-01-15 01:06:36.000000', 'temperatura', 27.0000, 'ºC'),
	(318046, 143, '2015-01-15 01:06:37.000000', 'temperatura', 28.0000, 'ºC'),
	(318047, 143, '2015-01-15 01:06:38.000000', 'temperatura', 58.0000, 'ºC'),
	(318048, 143, '2015-01-15 01:06:39.000000', 'temperatura', 205.0000, 'ºC'),
	(318049, 143, '2015-01-15 01:06:40.000000', 'temperatura', 854.0000, 'ºC'),
	(318050, 143, '2015-01-15 01:06:41.000000', 'temperatura', 53.0000, 'ºC'),
	(318051, 143, '2015-01-15 01:06:42.000000', 'temperatura', 105.0000, 'ºC'),
	(318052, 143, '2015-01-15 01:06:43.000000', 'temperatura', 368.0000, 'ºC'),
	(318053, 143, '2015-01-15 01:06:44.000000', 'temperatura', 324.0000, 'ºC'),
	(318054, 143, '2015-01-15 01:06:45.000000', 'temperatura', 518.0000, 'ºC'),
	(318055, 143, '2015-01-15 01:06:46.000000', 'temperatura', 416.0000, 'ºC'),
	(318056, 143, '2015-01-15 01:06:47.000000', 'temperatura', 529.0000, 'ºC'),
	(318057, 143, '2015-01-15 01:06:48.000000', 'temperatura', 196.0000, 'ºC'),
	(318058, 143, '2015-01-15 01:06:49.000000', 'temperatura', 593.0000, 'ºC'),
	(318059, 143, '2015-01-15 01:06:50.000000', 'temperatura', 1179.0000, 'ºC'),
	(318060, 143, '2015-01-15 01:06:51.000000', 'temperatura', 515.0000, 'ºC'),
	(318061, 143, '2015-01-15 01:06:52.000000', 'temperatura', 241.0000, 'ºC'),
	(318062, 143, '2015-01-15 01:06:53.000000', 'temperatura', 859.0000, 'ºC'),
	(318063, 143, '2015-01-15 01:06:54.000000', 'temperatura', 1171.0000, 'ºC'),
	(318064, 143, '2015-01-15 01:06:55.000000', 'temperatura', 879.0000, 'ºC'),
	(318065, 143, '2015-01-15 01:06:56.000000', 'temperatura', 884.0000, 'ºC'),
	(318066, 143, '2015-01-15 01:06:57.000000', 'temperatura', 581.0000, 'ºC'),
	(318067, 143, '2015-01-15 01:06:58.000000', 'temperatura', 255.0000, 'ºC'),
	(318068, 143, '2015-01-15 01:06:59.000000', 'temperatura', 733.0000, 'ºC'),
	(318069, 143, '2015-01-15 01:07:00.000000', 'temperatura', 500.0000, 'ºC'),
	(318070, 143, '2015-01-15 01:07:01.000000', 'temperatura', 300.0000, 'ºC'),
	(318071, 143, '2015-01-15 01:07:02.000000', 'temperatura', 0.0000, 'ºC'),
	(318072, 143, '2015-01-15 01:07:03.000000', 'temperatura', 302.0000, 'ºC'),
	(318073, 143, '2015-01-15 01:07:04.000000', 'temperatura', 311.0000, 'ºC'),
	(318074, 143, '2015-01-15 01:07:05.000000', 'temperatura', 650.0000, 'ºC'),
	(318075, 143, '2015-01-15 01:07:06.000000', 'temperatura', 1118.0000, 'ºC'),
	(318076, 143, '2015-01-15 01:07:07.000000', 'temperatura', 41.0000, 'ºC'),
	(318077, 143, '2015-01-15 01:07:08.000000', 'temperatura', 452.0000, 'ºC'),
	(318078, 143, '2015-01-15 01:07:09.000000', 'temperatura', 935.0000, 'ºC'),
	(318079, 143, '2015-01-15 01:07:10.000000', 'temperatura', 920.0000, 'ºC'),
	(318080, 143, '2015-01-15 01:07:11.000000', 'temperatura', 595.0000, 'ºC'),
	(318081, 143, '2015-01-15 01:07:12.000000', 'temperatura', 215.0000, 'ºC'),
	(318082, 143, '2015-01-15 01:07:13.000000', 'temperatura', 490.0000, 'ºC'),
	(318083, 143, '2015-01-15 01:07:14.000000', 'temperatura', 606.0000, 'ºC'),
	(318084, 143, '2015-01-15 01:07:15.000000', 'temperatura', 362.0000, 'ºC'),
	(318085, 143, '2015-01-15 01:07:16.000000', 'temperatura', 1193.0000, 'ºC'),
	(318086, 143, '2015-01-15 01:07:17.000000', 'temperatura', 79.0000, 'ºC'),
	(318087, 143, '2015-01-15 01:07:18.000000', 'temperatura', 414.0000, 'ºC'),
	(318088, 143, '2015-01-15 01:07:19.000000', 'temperatura', 636.0000, 'ºC'),
	(318089, 143, '2015-01-15 01:07:20.000000', 'temperatura', 739.0000, 'ºC'),
	(318090, 143, '2015-01-15 01:07:21.000000', 'temperatura', 585.0000, 'ºC'),
	(318091, 143, '2015-01-15 01:07:22.000000', 'temperatura', 710.0000, 'ºC'),
	(318092, 143, '2015-01-15 01:07:23.000000', 'temperatura', 597.0000, 'ºC'),
	(318093, 143, '2015-01-15 01:07:24.000000', 'temperatura', 853.0000, 'ºC'),
	(318094, 143, '2015-01-15 01:07:25.000000', 'temperatura', 74.0000, 'ºC'),
	(318095, 143, '2015-01-15 01:07:26.000000', 'temperatura', 213.0000, 'ºC'),
	(318096, 143, '2015-01-15 01:07:27.000000', 'temperatura', 843.0000, 'ºC'),
	(318097, 143, '2015-01-15 01:07:28.000000', 'temperatura', 1177.0000, 'ºC'),
	(318098, 143, '2015-01-15 01:07:29.000000', 'temperatura', 956.0000, 'ºC'),
	(318099, 143, '2015-01-15 01:07:30.000000', 'temperatura', 48.0000, 'ºC'),
	(318100, 143, '2015-01-15 01:07:31.000000', 'temperatura', 976.0000, 'ºC'),
	(318101, 143, '2015-01-15 01:07:32.000000', 'temperatura', 1133.0000, 'ºC'),
	(318102, 143, '2015-01-15 01:07:33.000000', 'temperatura', 338.0000, 'ºC'),
	(318103, 143, '2015-01-15 01:07:34.000000', 'temperatura', 691.0000, 'ºC'),
	(318104, 143, '2015-01-15 01:07:35.000000', 'temperatura', 43.0000, 'ºC'),
	(318105, 143, '2015-01-15 01:07:36.000000', 'temperatura', 540.0000, 'ºC'),
	(318106, 143, '2015-01-15 01:07:37.000000', 'temperatura', 174.0000, 'ºC'),
	(318107, 143, '2015-01-15 01:07:38.000000', 'temperatura', 450.0000, 'ºC'),
	(318108, 143, '2015-01-15 01:07:39.000000', 'temperatura', 527.0000, 'ºC'),
	(318109, 143, '2015-01-15 01:07:40.000000', 'temperatura', 88.0000, 'ºC'),
	(318110, 143, '2015-01-15 01:07:41.000000', 'temperatura', 57.0000, 'ºC'),
	(318111, 143, '2015-01-15 01:07:42.000000', 'temperatura', 24.0000, 'ºC'),
	(318112, 143, '2015-01-15 01:07:43.000000', 'temperatura', 1150.0000, 'ºC'),
	(318113, 143, '2015-01-15 01:07:44.000000', 'temperatura', 878.0000, 'ºC'),
	(318114, 143, '2015-01-15 01:07:45.000000', 'temperatura', 940.0000, 'ºC'),
	(318115, 143, '2015-01-15 01:07:46.000000', 'temperatura', 865.0000, 'ºC'),
	(318116, 143, '2015-01-15 01:07:47.000000', 'temperatura', 306.0000, 'ºC'),
	(318117, 143, '2015-01-15 01:07:48.000000', 'temperatura', 134.0000, 'ºC'),
	(318118, 143, '2015-01-15 01:07:49.000000', 'temperatura', 954.0000, 'ºC'),
	(318119, 143, '2015-01-15 01:07:50.000000', 'temperatura', 768.0000, 'ºC'),
	(318120, 143, '2015-01-15 01:07:51.000000', 'temperatura', 977.0000, 'ºC'),
	(318121, 143, '2015-01-15 01:07:52.000000', 'temperatura', 182.0000, 'ºC'),
	(318122, 143, '2015-01-15 01:07:53.000000', 'temperatura', 378.0000, 'ºC'),
	(318123, 143, '2015-01-15 01:07:54.000000', 'temperatura', 147.0000, 'ºC'),
	(318124, 143, '2015-01-15 01:07:55.000000', 'temperatura', 800.0000, 'ºC'),
	(318125, 143, '2015-01-15 01:07:56.000000', 'temperatura', 1162.0000, 'ºC'),
	(318126, 143, '2015-01-15 01:07:57.000000', 'temperatura', 1010.0000, 'ºC'),
	(318127, 143, '2015-01-15 01:07:58.000000', 'temperatura', 363.0000, 'ºC'),
	(318128, 143, '2015-01-15 01:07:59.000000', 'temperatura', 1186.0000, 'ºC'),
	(318129, 143, '2015-01-15 01:08:00.000000', 'temperatura', 41.0000, 'ºC'),
	(318130, 143, '2015-01-15 01:08:01.000000', 'temperatura', 248.0000, 'ºC'),
	(318131, 143, '2015-01-15 01:08:02.000000', 'temperatura', 1118.0000, 'ºC'),
	(318132, 143, '2015-01-15 01:08:03.000000', 'temperatura', 46.0000, 'ºC'),
	(318133, 143, '2015-01-15 01:08:04.000000', 'temperatura', 479.0000, 'ºC'),
	(318134, 143, '2015-01-15 01:08:05.000000', 'temperatura', 1054.0000, 'ºC'),
	(318135, 143, '2015-01-15 01:08:06.000000', 'temperatura', 236.0000, 'ºC'),
	(318136, 143, '2015-01-15 01:08:07.000000', 'temperatura', 416.0000, 'ºC'),
	(318137, 143, '2015-01-15 01:08:08.000000', 'temperatura', 173.0000, 'ºC'),
	(318138, 143, '2015-01-15 01:08:09.000000', 'temperatura', 817.0000, 'ºC'),
	(318139, 143, '2015-01-15 01:08:10.000000', 'temperatura', 1169.0000, 'ºC'),
	(318140, 143, '2015-01-15 01:08:11.000000', 'temperatura', 994.0000, 'ºC'),
	(318141, 143, '2015-01-15 01:08:12.000000', 'temperatura', 262.0000, 'ºC'),
	(318142, 143, '2015-01-15 01:08:13.000000', 'temperatura', 727.0000, 'ºC'),
	(318143, 143, '2015-01-15 01:08:14.000000', 'temperatura', 451.0000, 'ºC'),
	(318144, 143, '2015-01-15 01:08:15.000000', 'temperatura', 75.0000, 'ºC'),
	(318145, 143, '2015-01-15 01:08:16.000000', 'temperatura', 224.0000, 'ºC'),
	(318146, 143, '2015-01-15 01:08:17.000000', 'temperatura', 892.0000, 'ºC'),
	(318147, 143, '2015-01-15 01:08:18.000000', 'temperatura', 191.0000, 'ºC'),
	(318148, 143, '2015-01-15 01:08:19.000000', 'temperatura', 679.0000, 'ºC'),
	(318149, 143, '2015-01-15 01:08:20.000000', 'temperatura', 424.0000, 'ºC'),
	(318150, 143, '2015-01-15 01:08:21.000000', 'temperatura', 84.0000, 'ºC'),
	(318151, 143, '2015-01-15 01:08:22.000000', 'temperatura', 346.0000, 'ºC'),
	(318152, 143, '2015-01-15 01:08:23.000000', 'temperatura', 278.0000, 'ºC'),
	(318153, 143, '2015-01-15 01:08:24.000000', 'temperatura', 353.0000, 'ºC'),
	(318154, 143, '2015-01-15 01:08:25.000000', 'temperatura', 930.0000, 'ºC'),
	(318155, 143, '2015-01-15 01:08:26.000000', 'temperatura', 1192.0000, 'ºC'),
	(318156, 143, '2015-01-15 01:08:27.000000', 'temperatura', 770.0000, 'ºC'),
	(318157, 143, '2015-01-15 01:08:28.000000', 'temperatura', 276.0000, 'ºC'),
	(318158, 143, '2015-01-15 01:08:29.000000', 'temperatura', 269.0000, 'ºC'),
	(318159, 143, '2015-01-15 01:08:30.000000', 'temperatura', 519.0000, 'ºC'),
	(318160, 143, '2015-01-15 01:08:31.000000', 'temperatura', 586.0000, 'ºC'),
	(318161, 143, '2015-01-15 01:08:32.000000', 'temperatura', 176.0000, 'ºC'),
	(318162, 143, '2015-01-15 01:08:33.000000', 'temperatura', 322.0000, 'ºC'),
	(318163, 143, '2015-01-15 01:08:34.000000', 'temperatura', 1084.0000, 'ºC'),
	(318164, 143, '2015-01-15 01:08:35.000000', 'temperatura', 853.0000, 'ºC'),
	(318165, 143, '2015-01-15 01:08:36.000000', 'temperatura', 1014.0000, 'ºC'),
	(318166, 143, '2015-01-15 01:08:37.000000', 'temperatura', 112.0000, 'ºC'),
	(318167, 143, '2015-01-15 01:08:38.000000', 'temperatura', 1120.0000, 'ºC'),
	(318168, 143, '2015-01-15 01:08:39.000000', 'temperatura', 462.0000, 'ºC'),
	(318169, 143, '2015-01-15 01:08:40.000000', 'temperatura', 150.0000, 'ºC'),
	(318170, 143, '2015-01-15 01:08:41.000000', 'temperatura', 566.0000, 'ºC'),
	(318171, 143, '2015-01-15 01:08:42.000000', 'temperatura', 1180.0000, 'ºC'),
	(318172, 143, '2015-01-15 01:08:43.000000', 'temperatura', 604.0000, 'ºC'),
	(318173, 143, '2015-01-15 01:08:44.000000', 'temperatura', 680.0000, 'ºC'),
	(318174, 143, '2015-01-15 01:08:45.000000', 'temperatura', 386.0000, 'ºC'),
	(318175, 143, '2015-01-15 01:08:46.000000', 'temperatura', 1094.0000, 'ºC'),
	(318176, 143, '2015-01-15 01:08:47.000000', 'temperatura', 710.0000, 'ºC'),
	(318177, 143, '2015-01-15 01:08:48.000000', 'temperatura', 269.0000, 'ºC'),
	(318178, 143, '2015-01-15 01:08:49.000000', 'temperatura', 416.0000, 'ºC'),
	(318179, 143, '2015-01-15 01:08:50.000000', 'temperatura', 73.0000, 'ºC'),
	(318180, 143, '2015-01-15 01:08:51.000000', 'temperatura', 319.0000, 'ºC'),
	(318181, 143, '2015-01-15 01:08:52.000000', 'temperatura', 174.0000, 'ºC'),
	(318182, 143, '2015-01-15 01:08:53.000000', 'temperatura', 1112.0000, 'ºC'),
	(318183, 143, '2015-01-15 01:08:54.000000', 'temperatura', 242.0000, 'ºC'),
	(318184, 143, '2015-01-15 01:08:55.000000', 'temperatura', 275.0000, 'ºC'),
	(318185, 143, '2015-01-15 01:08:56.000000', 'temperatura', 648.0000, 'ºC'),
	(318186, 143, '2015-01-15 01:08:57.000000', 'temperatura', 17.0000, 'ºC'),
	(318187, 143, '2015-01-15 01:08:58.000000', 'temperatura', 539.0000, 'ºC'),
	(318188, 143, '2015-01-15 01:08:59.000000', 'temperatura', 246.0000, 'ºC'),
	(318189, 143, '2015-01-15 01:09:00.000000', 'temperatura', 814.0000, 'ºC'),
	(318190, 143, '2015-01-15 01:09:01.000000', 'temperatura', 930.0000, 'ºC'),
	(318191, 143, '2015-01-15 01:09:02.000000', 'temperatura', 1011.0000, 'ºC'),
	(318192, 143, '2015-01-15 01:09:03.000000', 'temperatura', 1064.0000, 'ºC'),
	(318193, 143, '2015-01-15 01:09:04.000000', 'temperatura', 1090.0000, 'ºC'),
	(318194, 143, '2015-01-15 01:09:05.000000', 'temperatura', 1057.0000, 'ºC'),
	(318195, 143, '2015-01-15 01:09:06.000000', 'temperatura', 814.0000, 'ºC'),
	(318196, 143, '2015-01-15 01:09:07.000000', 'temperatura', 899.0000, 'ºC'),
	(318197, 143, '2015-01-15 01:09:08.000000', 'temperatura', 856.0000, 'ºC'),
	(318198, 143, '2015-01-15 01:09:09.000000', 'temperatura', 384.0000, 'ºC'),
	(318199, 143, '2015-01-15 01:09:10.000000', 'temperatura', 552.0000, 'ºC'),
	(318200, 143, '2015-01-15 01:09:11.000000', 'temperatura', 407.0000, 'ºC'),
	(318201, 143, '2015-01-15 01:09:12.000000', 'temperatura', 380.0000, 'ºC'),
	(318202, 143, '2015-01-15 01:09:13.000000', 'temperatura', 681.0000, 'ºC'),
	(318203, 143, '2015-01-15 01:09:14.000000', 'temperatura', 1064.0000, 'ºC'),
	(318204, 143, '2015-01-15 01:09:15.000000', 'temperatura', 877.0000, 'ºC'),
	(318205, 143, '2015-01-15 01:09:16.000000', 'temperatura', 1194.0000, 'ºC'),
	(318206, 143, '2015-01-15 01:09:17.000000', 'temperatura', 940.0000, 'ºC'),
	(318207, 143, '2015-01-15 01:09:18.000000', 'temperatura', 1119.0000, 'ºC'),
	(318208, 143, '2015-01-15 01:09:19.000000', 'temperatura', 377.0000, 'ºC'),
	(318209, 143, '2015-01-15 01:09:20.000000', 'temperatura', 927.0000, 'ºC'),
	(318210, 143, '2015-01-15 01:09:21.000000', 'temperatura', 1102.0000, 'ºC'),
	(318211, 143, '2015-01-15 01:09:22.000000', 'temperatura', 333.0000, 'ºC'),
	(318212, 143, '2015-01-15 01:09:23.000000', 'temperatura', 759.0000, 'ºC'),
	(318213, 143, '2015-01-15 01:09:24.000000', 'temperatura', 398.0000, 'ºC'),
	(318214, 143, '2015-01-15 01:09:25.000000', 'temperatura', 912.0000, 'ºC'),
	(318215, 143, '2015-01-15 01:09:26.000000', 'temperatura', 968.0000, 'ºC'),
	(318216, 143, '2015-01-15 01:09:27.000000', 'temperatura', 904.0000, 'ºC'),
	(318217, 143, '2015-01-15 01:09:28.000000', 'temperatura', 418.0000, 'ºC'),
	(318218, 143, '2015-01-15 01:09:29.000000', 'temperatura', 578.0000, 'ºC'),
	(318219, 143, '2015-01-15 01:09:30.000000', 'temperatura', 438.0000, 'ºC'),
	(318220, 143, '2015-01-15 01:09:31.000000', 'temperatura', 453.0000, 'ºC'),
	(318221, 143, '2015-01-15 01:09:32.000000', 'temperatura', 953.0000, 'ºC'),
	(318222, 143, '2015-01-15 01:09:33.000000', 'temperatura', 1007.0000, 'ºC'),
	(318223, 143, '2015-01-15 01:09:34.000000', 'temperatura', 974.0000, 'ºC'),
	(318224, 143, '2015-01-15 01:09:35.000000', 'temperatura', 652.0000, 'ºC'),
	(318225, 143, '2015-01-15 01:09:36.000000', 'temperatura', 338.0000, 'ºC'),
	(318226, 143, '2015-01-15 01:09:37.000000', 'temperatura', 933.0000, 'ºC'),
	(318227, 143, '2015-01-15 01:09:38.000000', 'temperatura', 54.0000, 'ºC'),
	(318228, 143, '2015-01-15 01:09:39.000000', 'temperatura', 1069.0000, 'ºC'),
	(318229, 143, '2015-01-15 01:09:40.000000', 'temperatura', 386.0000, 'ºC'),
	(318230, 143, '2015-01-15 01:09:41.000000', 'temperatura', 1121.0000, 'ºC'),
	(318231, 143, '2015-01-15 01:09:42.000000', 'temperatura', 848.0000, 'ºC'),
	(318232, 143, '2015-01-15 01:09:43.000000', 'temperatura', 878.0000, 'ºC'),
	(318233, 143, '2015-01-15 01:09:44.000000', 'temperatura', 645.0000, 'ºC'),
	(318234, 143, '2015-01-15 01:09:45.000000', 'temperatura', 591.0000, 'ºC'),
	(318235, 143, '2015-01-15 01:09:46.000000', 'temperatura', 1022.0000, 'ºC'),
	(318236, 143, '2015-01-15 01:09:47.000000', 'temperatura', 939.0000, 'ºC'),
	(318237, 143, '2015-01-15 01:09:48.000000', 'temperatura', 428.0000, 'ºC'),
	(318238, 143, '2015-01-15 01:09:49.000000', 'temperatura', 525.0000, 'ºC'),
	(318239, 143, '2015-01-15 01:09:50.000000', 'temperatura', 142.0000, 'ºC'),
	(318240, 143, '2015-01-15 01:09:51.000000', 'temperatura', 334.0000, 'ºC'),
	(318241, 143, '2015-01-15 01:09:52.000000', 'temperatura', 44.0000, 'ºC'),
	(318242, 143, '2015-01-15 01:09:53.000000', 'temperatura', 419.0000, 'ºC'),
	(318243, 143, '2015-01-15 01:09:54.000000', 'temperatura', 764.0000, 'ºC'),
	(318244, 143, '2015-01-15 01:09:55.000000', 'temperatura', 164.0000, 'ºC'),
	(318245, 143, '2015-01-15 01:09:56.000000', 'temperatura', 930.0000, 'ºC'),
	(318246, 143, '2015-01-15 01:09:57.000000', 'temperatura', 557.0000, 'ºC'),
	(318247, 143, '2015-01-15 01:09:58.000000', 'temperatura', 1197.0000, 'ºC'),
	(318248, 143, '2015-01-15 01:09:59.000000', 'temperatura', 714.0000, 'ºC'),
	(318249, 143, '2015-01-15 01:10:00.000000', 'temperatura', 1179.0000, 'ºC'),
	(318250, 143, '2015-01-15 01:10:01.000000', 'temperatura', 153.0000, 'ºC'),
	(318251, 143, '2015-01-15 01:10:02.000000', 'temperatura', 829.0000, 'ºC'),
	(318252, 143, '2015-01-15 01:10:03.000000', 'temperatura', 87.0000, 'ºC'),
	(318253, 143, '2015-01-15 01:10:04.000000', 'temperatura', 347.0000, 'ºC'),
	(318254, 143, '2015-01-15 01:10:05.000000', 'temperatura', 276.0000, 'ºC'),
	(318255, 143, '2015-01-15 01:10:06.000000', 'temperatura', 337.0000, 'ºC'),
	(318256, 143, '2015-01-15 01:10:07.000000', 'temperatura', 859.0000, 'ºC'),
	(318257, 143, '2015-01-15 01:10:08.000000', 'temperatura', 884.0000, 'ºC'),
	(318258, 143, '2015-01-15 01:10:09.000000', 'temperatura', 645.0000, 'ºC'),
	(318259, 143, '2015-01-15 01:10:10.000000', 'temperatura', 571.0000, 'ºC'),
	(318260, 143, '2015-01-15 01:10:11.000000', 'temperatura', 922.0000, 'ºC'),
	(318261, 143, '2015-01-15 01:10:12.000000', 'temperatura', 495.0000, 'ºC'),
	(318262, 143, '2015-01-15 01:10:13.000000', 'temperatura', 913.0000, 'ºC'),
	(318263, 143, '2015-01-15 01:10:14.000000', 'temperatura', 679.0000, 'ºC'),
	(318264, 143, '2015-01-15 01:10:15.000000', 'temperatura', 655.0000, 'ºC'),
	(318265, 143, '2015-01-15 01:10:16.000000', 'temperatura', 42.0000, 'ºC'),
	(318266, 143, '2015-01-15 01:10:17.000000', 'temperatura', 643.0000, 'ºC'),
	(318267, 143, '2015-01-15 01:10:18.000000', 'temperatura', 689.0000, 'ºC'),
	(318268, 143, '2015-01-15 01:10:19.000000', 'temperatura', 317.0000, 'ºC'),
	(318269, 143, '2015-01-15 01:10:20.000000', 'temperatura', 718.0000, 'ºC'),
	(318270, 143, '2015-01-15 01:10:21.000000', 'temperatura', 241.0000, 'ºC'),
	(318271, 143, '2015-01-15 01:10:22.000000', 'temperatura', 252.0000, 'ºC'),
	(318272, 143, '2015-01-15 01:10:23.000000', 'temperatura', 536.0000, 'ºC'),
	(318273, 143, '2015-01-15 01:10:24.000000', 'temperatura', 725.0000, 'ºC'),
	(318274, 143, '2015-01-15 01:10:25.000000', 'temperatura', 815.0000, 'ºC'),
	(318275, 143, '2015-01-15 01:10:26.000000', 'temperatura', 704.0000, 'ºC'),
	(318276, 143, '2015-01-15 01:10:27.000000', 'temperatura', 1074.0000, 'ºC'),
	(318277, 143, '2015-01-15 01:10:28.000000', 'temperatura', 859.0000, 'ºC'),
	(318278, 143, '2015-01-15 01:10:29.000000', 'temperatura', 1074.0000, 'ºC'),
	(318279, 143, '2015-01-15 01:10:30.000000', 'temperatura', 391.0000, 'ºC'),
	(318280, 143, '2015-01-15 01:10:31.000000', 'temperatura', 1137.0000, 'ºC'),
	(318281, 143, '2015-01-15 01:10:32.000000', 'temperatura', 909.0000, 'ºC'),
	(318282, 143, '2015-01-15 01:10:33.000000', 'temperatura', 1137.0000, 'ºC'),
	(318283, 143, '2015-01-15 01:10:34.000000', 'temperatura', 558.0000, 'ºC'),
	(318284, 143, '2015-01-15 01:10:35.000000', 'temperatura', 580.0000, 'ºC'),
	(318285, 143, '2015-01-15 01:10:36.000000', 'temperatura', 27.0000, 'ºC'),
	(318286, 143, '2015-01-15 01:10:37.000000', 'temperatura', 795.0000, 'ºC'),
	(318287, 143, '2015-01-15 01:10:38.000000', 'temperatura', 295.0000, 'ºC'),
	(318288, 143, '2015-01-15 01:10:39.000000', 'temperatura', 291.0000, 'ºC'),
	(318289, 143, '2015-01-15 01:10:40.000000', 'temperatura', 568.0000, 'ºC'),
	(318290, 143, '2015-01-15 01:10:41.000000', 'temperatura', 770.0000, 'ºC'),
	(318291, 143, '2015-01-15 01:10:42.000000', 'temperatura', 944.0000, 'ºC'),
	(318292, 143, '2015-01-15 01:10:43.000000', 'temperatura', 12.0000, 'ºC'),
	(318293, 143, '2015-01-15 01:10:44.000000', 'temperatura', 827.0000, 'ºC'),
	(318294, 143, '2015-01-15 01:10:45.000000', 'temperatura', 499.0000, 'ºC'),
	(318295, 143, '2015-01-15 01:10:46.000000', 'temperatura', 15.0000, 'ºC'),
	(318296, 143, '2015-01-15 01:10:47.000000', 'temperatura', 977.0000, 'ºC'),
	(318297, 143, '2015-01-15 01:10:48.000000', 'temperatura', 43.0000, 'ºC'),
	(318298, 143, '2015-01-15 01:10:49.000000', 'temperatura', 883.0000, 'ºC'),
	(318299, 143, '2015-01-15 01:10:50.000000', 'temperatura', 688.0000, 'ºC'),
	(318300, 143, '2015-01-15 01:10:51.000000', 'temperatura', 792.0000, 'ºC'),
	(318301, 143, '2015-01-15 01:10:52.000000', 'temperatura', 697.0000, 'ºC'),
	(318302, 143, '2015-01-15 01:10:53.000000', 'temperatura', 1108.0000, 'ºC'),
	(318303, 143, '2015-01-15 01:10:54.000000', 'temperatura', 1051.0000, 'ºC'),
	(318304, 143, '2015-01-15 01:10:55.000000', 'temperatura', 730.0000, 'ºC'),
	(318305, 143, '2015-01-15 01:10:56.000000', 'temperatura', 496.0000, 'ºC'),
	(318306, 143, '2015-01-15 01:10:57.000000', 'temperatura', 294.0000, 'ºC'),
	(318307, 143, '2015-01-15 01:10:58.000000', 'temperatura', 1180.0000, 'ºC'),
	(318308, 143, '2015-01-15 01:10:59.000000', 'temperatura', 218.0000, 'ºC'),
	(318309, 143, '2015-01-15 01:11:00.000000', 'temperatura', 1152.0000, 'ºC'),
	(318310, 143, '2015-01-15 01:11:01.000000', 'temperatura', 307.0000, 'ºC'),
	(318311, 143, '2015-01-15 01:11:02.000000', 'temperatura', 478.0000, 'ºC'),
	(318312, 143, '2015-01-15 01:11:03.000000', 'temperatura', 272.0000, 'ºC'),
	(318313, 143, '2015-01-15 01:11:04.000000', 'temperatura', 1125.0000, 'ºC'),
	(318314, 144, '2015-01-15 00:00:00.000000', 'temperatura', 267.0000, 'ºC'),
	(318315, 144, '2015-01-15 00:00:01.000000', 'temperatura', 110.0000, 'ºC'),
	(318316, 144, '2015-01-15 00:00:02.000000', 'temperatura', 949.0000, 'ºC'),
	(318317, 144, '2015-01-15 00:00:03.000000', 'temperatura', 816.0000, 'ºC'),
	(318318, 144, '2015-01-15 00:00:04.000000', 'temperatura', 33.0000, 'ºC'),
	(318319, 144, '2015-01-15 00:00:05.000000', 'temperatura', 119.0000, 'ºC'),
	(318320, 144, '2015-01-15 00:00:06.000000', 'temperatura', 494.0000, 'ºC'),
	(318321, 144, '2015-01-15 00:00:07.000000', 'temperatura', 915.0000, 'ºC'),
	(318322, 144, '2015-01-15 00:00:08.000000', 'temperatura', 693.0000, 'ºC'),
	(318323, 144, '2015-01-15 00:00:09.000000', 'temperatura', 721.0000, 'ºC'),
	(318324, 144, '2015-01-15 00:00:10.000000', 'temperatura', 326.0000, 'ºC'),
	(318325, 144, '2015-01-15 00:00:11.000000', 'temperatura', 666.0000, 'ºC'),
	(318326, 144, '2015-01-15 00:00:12.000000', 'temperatura', 1152.0000, 'ºC'),
	(318327, 144, '2015-01-15 00:00:13.000000', 'temperatura', 164.0000, 'ºC'),
	(318328, 144, '2015-01-15 00:00:14.000000', 'temperatura', 963.0000, 'ºC'),
	(318329, 144, '2015-01-15 00:00:15.000000', 'temperatura', 724.0000, 'ºC'),
	(318330, 144, '2015-01-15 00:00:16.000000', 'temperatura', 733.0000, 'ºC'),
	(318331, 144, '2015-01-15 00:00:17.000000', 'temperatura', 291.0000, 'ºC'),
	(318332, 144, '2015-01-15 00:00:18.000000', 'temperatura', 456.0000, 'ºC'),
	(318333, 144, '2015-01-15 00:00:19.000000', 'temperatura', 209.0000, 'ºC'),
	(318334, 144, '2015-01-15 00:00:20.000000', 'temperatura', 879.0000, 'ºC'),
	(318335, 144, '2015-01-15 00:00:21.000000', 'temperatura', 169.0000, 'ºC'),
	(318336, 144, '2015-01-15 00:00:22.000000', 'temperatura', 607.0000, 'ºC'),
	(318337, 144, '2015-01-15 00:00:23.000000', 'temperatura', 131.0000, 'ºC'),
	(318338, 144, '2015-01-15 00:00:24.000000', 'temperatura', 31.0000, 'ºC'),
	(318339, 144, '2015-01-15 00:00:25.000000', 'temperatura', 963.0000, 'ºC'),
	(318340, 144, '2015-01-15 00:00:26.000000', 'temperatura', 1124.0000, 'ºC'),
	(318341, 144, '2015-01-15 00:00:27.000000', 'temperatura', 330.0000, 'ºC'),
	(318342, 144, '2015-01-15 00:00:28.000000', 'temperatura', 678.0000, 'ºC'),
	(318343, 144, '2015-01-15 00:00:29.000000', 'temperatura', 1199.0000, 'ºC'),
	(318344, 144, '2015-01-15 00:00:30.000000', 'temperatura', 364.0000, 'ºC'),
	(318345, 144, '2015-01-15 00:00:31.000000', 'temperatura', 624.0000, 'ºC'),
	(318346, 144, '2015-01-15 00:00:32.000000', 'temperatura', 828.0000, 'ºC'),
	(318347, 144, '2015-01-15 00:00:33.000000', 'temperatura', 1066.0000, 'ºC'),
	(318348, 144, '2015-01-15 00:00:34.000000', 'temperatura', 450.0000, 'ºC'),
	(318349, 144, '2015-01-15 00:00:35.000000', 'temperatura', 251.0000, 'ºC'),
	(318350, 144, '2015-01-15 00:00:36.000000', 'temperatura', 1107.0000, 'ºC'),
	(318351, 144, '2015-01-15 00:00:37.000000', 'temperatura', 1182.0000, 'ºC'),
	(318352, 144, '2015-01-15 00:00:38.000000', 'temperatura', 190.0000, 'ºC'),
	(318353, 144, '2015-01-15 00:00:39.000000', 'temperatura', 1002.0000, 'ºC'),
	(318354, 144, '2015-01-15 00:00:40.000000', 'temperatura', 842.0000, 'ºC'),
	(318355, 144, '2015-01-15 00:00:41.000000', 'temperatura', 2.0000, 'ºC'),
	(318356, 144, '2015-01-15 00:00:42.000000', 'temperatura', 1088.0000, 'ºC'),
	(318357, 144, '2015-01-15 00:00:43.000000', 'temperatura', 633.0000, 'ºC'),
	(318358, 144, '2015-01-15 00:00:44.000000', 'temperatura', 1101.0000, 'ºC'),
	(318359, 144, '2015-01-15 00:00:45.000000', 'temperatura', 9.0000, 'ºC'),
	(318360, 144, '2015-01-15 00:00:46.000000', 'temperatura', 341.0000, 'ºC'),
	(318361, 144, '2015-01-15 00:00:47.000000', 'temperatura', 477.0000, 'ºC'),
	(318362, 144, '2015-01-15 00:00:48.000000', 'temperatura', 164.0000, 'ºC'),
	(318363, 144, '2015-01-15 00:00:49.000000', 'temperatura', 587.0000, 'ºC'),
	(318364, 144, '2015-01-15 00:00:50.000000', 'temperatura', 46.0000, 'ºC'),
	(318365, 144, '2015-01-15 00:00:51.000000', 'temperatura', 868.0000, 'ºC'),
	(318366, 144, '2015-01-15 00:00:52.000000', 'temperatura', 604.0000, 'ºC'),
	(318367, 144, '2015-01-15 00:00:53.000000', 'temperatura', 417.0000, 'ºC'),
	(318368, 144, '2015-01-15 00:00:54.000000', 'temperatura', 273.0000, 'ºC'),
	(318369, 144, '2015-01-15 00:00:55.000000', 'temperatura', 115.0000, 'ºC'),
	(318370, 144, '2015-01-15 00:00:56.000000', 'temperatura', 954.0000, 'ºC'),
	(318371, 144, '2015-01-15 00:00:57.000000', 'temperatura', 827.0000, 'ºC'),
	(318372, 144, '2015-01-15 00:00:58.000000', 'temperatura', 75.0000, 'ºC'),
	(318373, 144, '2015-01-15 00:00:59.000000', 'temperatura', 293.0000, 'ºC'),
	(318374, 144, '2015-01-15 00:01:00.000000', 'temperatura', 42.0000, 'ºC'),
	(318375, 144, '2015-01-15 00:01:01.000000', 'temperatura', 529.0000, 'ºC'),
	(318376, 144, '2015-01-15 00:01:02.000000', 'temperatura', 121.0000, 'ºC'),
	(318377, 144, '2015-01-15 00:01:03.000000', 'temperatura', 220.0000, 'ºC'),
	(318378, 144, '2015-01-15 00:01:04.000000', 'temperatura', 737.0000, 'ºC'),
	(318379, 144, '2015-01-15 00:01:05.000000', 'temperatura', 627.0000, 'ºC'),
	(318380, 144, '2015-01-15 00:01:06.000000', 'temperatura', 923.0000, 'ºC'),
	(318381, 144, '2015-01-15 00:01:07.000000', 'temperatura', 335.0000, 'ºC'),
	(318382, 144, '2015-01-15 00:01:08.000000', 'temperatura', 108.0000, 'ºC'),
	(318383, 144, '2015-01-15 00:01:09.000000', 'temperatura', 733.0000, 'ºC'),
	(318384, 144, '2015-01-15 00:01:10.000000', 'temperatura', 942.0000, 'ºC'),
	(318385, 144, '2015-01-15 00:01:11.000000', 'temperatura', 113.0000, 'ºC'),
	(318386, 144, '2015-01-15 00:01:12.000000', 'temperatura', 139.0000, 'ºC'),
	(318387, 144, '2015-01-15 00:01:13.000000', 'temperatura', 355.0000, 'ºC'),
	(318388, 144, '2015-01-15 00:01:14.000000', 'temperatura', 158.0000, 'ºC'),
	(318389, 144, '2015-01-15 00:01:15.000000', 'temperatura', 927.0000, 'ºC'),
	(318390, 144, '2015-01-15 00:01:16.000000', 'temperatura', 563.0000, 'ºC'),
	(318391, 144, '2015-01-15 00:01:17.000000', 'temperatura', 32.0000, 'ºC'),
	(318392, 144, '2015-01-15 00:01:18.000000', 'temperatura', 870.0000, 'ºC'),
	(318393, 144, '2015-01-15 00:01:19.000000', 'temperatura', 658.0000, 'ºC'),
	(318394, 144, '2015-01-15 00:01:20.000000', 'temperatura', 678.0000, 'ºC'),
	(318395, 144, '2015-01-15 00:01:21.000000', 'temperatura', 216.0000, 'ºC'),
	(318396, 144, '2015-01-15 00:01:22.000000', 'temperatura', 246.0000, 'ºC'),
	(318397, 144, '2015-01-15 00:01:23.000000', 'temperatura', 584.0000, 'ºC'),
	(318398, 144, '2015-01-15 00:01:24.000000', 'temperatura', 982.0000, 'ºC'),
	(318399, 144, '2015-01-15 00:01:25.000000', 'temperatura', 757.0000, 'ºC'),
	(318400, 144, '2015-01-15 00:01:26.000000', 'temperatura', 841.0000, 'ºC'),
	(318401, 144, '2015-01-15 00:01:27.000000', 'temperatura', 736.0000, 'ºC'),
	(318402, 144, '2015-01-15 00:01:28.000000', 'temperatura', 1154.0000, 'ºC'),
	(318403, 144, '2015-01-15 00:01:29.000000', 'temperatura', 1165.0000, 'ºC'),
	(318404, 144, '2015-01-15 00:01:30.000000', 'temperatura', 1162.0000, 'ºC'),
	(318405, 144, '2015-01-15 00:01:31.000000', 'temperatura', 1118.0000, 'ºC'),
	(318406, 144, '2015-01-15 00:01:32.000000', 'temperatura', 903.0000, 'ºC'),
	(318407, 144, '2015-01-15 00:01:33.000000', 'temperatura', 1161.0000, 'ºC'),
	(318408, 144, '2015-01-15 00:01:34.000000', 'temperatura', 696.0000, 'ºC'),
	(318409, 144, '2015-01-15 00:01:35.000000', 'temperatura', 1197.0000, 'ºC'),
	(318410, 144, '2015-01-15 00:01:36.000000', 'temperatura', 299.0000, 'ºC'),
	(318411, 144, '2015-01-15 00:01:37.000000', 'temperatura', 302.0000, 'ºC'),
	(318412, 144, '2015-01-15 00:01:38.000000', 'temperatura', 617.0000, 'ºC'),
	(318413, 144, '2015-01-15 00:01:39.000000', 'temperatura', 977.0000, 'ºC'),
	(318414, 144, '2015-01-15 00:01:40.000000', 'temperatura', 636.0000, 'ºC'),
	(318415, 144, '2015-01-15 00:01:41.000000', 'temperatura', 247.0000, 'ºC'),
	(318416, 144, '2015-01-15 00:01:42.000000', 'temperatura', 531.0000, 'ºC'),
	(318417, 144, '2015-01-15 00:01:43.000000', 'temperatura', 713.0000, 'ºC'),
	(318418, 144, '2015-01-15 00:01:44.000000', 'temperatura', 772.0000, 'ºC'),
	(318419, 144, '2015-01-15 00:01:45.000000', 'temperatura', 523.0000, 'ºC'),
	(318420, 144, '2015-01-15 00:01:46.000000', 'temperatura', 298.0000, 'ºC'),
	(318421, 144, '2015-01-15 00:01:47.000000', 'temperatura', 1123.0000, 'ºC'),
	(318422, 144, '2015-01-15 00:01:48.000000', 'temperatura', 1119.0000, 'ºC'),
	(318423, 144, '2015-01-15 00:01:49.000000', 'temperatura', 1028.0000, 'ºC'),
	(318424, 144, '2015-01-15 00:01:50.000000', 'temperatura', 584.0000, 'ºC'),
	(318425, 144, '2015-01-15 00:01:51.000000', 'temperatura', 1034.0000, 'ºC'),
	(318426, 144, '2015-01-15 00:01:52.000000', 'temperatura', 1020.0000, 'ºC'),
	(318427, 144, '2015-01-15 00:01:53.000000', 'temperatura', 799.0000, 'ºC'),
	(318428, 144, '2015-01-15 00:01:54.000000', 'temperatura', 933.0000, 'ºC'),
	(318429, 144, '2015-01-15 00:01:55.000000', 'temperatura', 1070.0000, 'ºC'),
	(318430, 144, '2015-01-15 00:01:56.000000', 'temperatura', 153.0000, 'ºC'),
	(318431, 144, '2015-01-15 00:01:57.000000', 'temperatura', 1156.0000, 'ºC'),
	(318432, 144, '2015-01-15 00:01:58.000000', 'temperatura', 522.0000, 'ºC'),
	(318433, 144, '2015-01-15 00:01:59.000000', 'temperatura', 341.0000, 'ºC'),
	(318434, 144, '2015-01-15 00:02:00.000000', 'temperatura', 142.0000, 'ºC'),
	(318435, 144, '2015-01-15 00:02:01.000000', 'temperatura', 885.0000, 'ºC'),
	(318436, 144, '2015-01-15 00:02:02.000000', 'temperatura', 402.0000, 'ºC'),
	(318437, 144, '2015-01-15 00:02:03.000000', 'temperatura', 555.0000, 'ºC'),
	(318438, 144, '2015-01-15 00:02:04.000000', 'temperatura', 369.0000, 'ºC'),
	(318439, 144, '2015-01-15 00:02:05.000000', 'temperatura', 182.0000, 'ºC'),
	(318440, 144, '2015-01-15 00:02:06.000000', 'temperatura', 1000.0000, 'ºC'),
	(318441, 144, '2015-01-15 00:02:07.000000', 'temperatura', 858.0000, 'ºC'),
	(318442, 144, '2015-01-15 00:02:08.000000', 'temperatura', 88.0000, 'ºC'),
	(318443, 144, '2015-01-15 00:02:09.000000', 'temperatura', 269.0000, 'ºC'),
	(318444, 144, '2015-01-15 00:02:10.000000', 'temperatura', 1081.0000, 'ºC'),
	(318445, 144, '2015-01-15 00:02:11.000000', 'temperatura', 997.0000, 'ºC'),
	(318446, 144, '2015-01-15 00:02:12.000000', 'temperatura', 543.0000, 'ºC'),
	(318447, 144, '2015-01-15 00:02:13.000000', 'temperatura', 925.0000, 'ºC'),
	(318448, 144, '2015-01-15 00:02:14.000000', 'temperatura', 597.0000, 'ºC'),
	(318449, 144, '2015-01-15 00:02:15.000000', 'temperatura', 210.0000, 'ºC'),
	(318450, 144, '2015-01-15 00:02:16.000000', 'temperatura', 460.0000, 'ºC'),
	(318451, 144, '2015-01-15 00:02:17.000000', 'temperatura', 469.0000, 'ºC'),
	(318452, 144, '2015-01-15 00:02:18.000000', 'temperatura', 965.0000, 'ºC'),
	(318453, 144, '2015-01-15 00:02:19.000000', 'temperatura', 1018.0000, 'ºC'),
	(318454, 144, '2015-01-15 00:02:20.000000', 'temperatura', 996.0000, 'ºC'),
	(318455, 144, '2015-01-15 00:02:21.000000', 'temperatura', 729.0000, 'ºC'),
	(318456, 144, '2015-01-15 00:02:22.000000', 'temperatura', 654.0000, 'ºC'),
	(318457, 144, '2015-01-15 00:02:23.000000', 'temperatura', 1087.0000, 'ºC'),
	(318458, 144, '2015-01-15 00:02:24.000000', 'temperatura', 1071.0000, 'ºC'),
	(318459, 144, '2015-01-15 00:02:25.000000', 'temperatura', 896.0000, 'ºC'),
	(318460, 144, '2015-01-15 00:02:26.000000', 'temperatura', 68.0000, 'ºC'),
	(318461, 144, '2015-01-15 00:02:27.000000', 'temperatura', 53.0000, 'ºC'),
	(318462, 144, '2015-01-15 00:02:28.000000', 'temperatura', 62.0000, 'ºC'),
	(318463, 144, '2015-01-15 00:02:29.000000', 'temperatura', 152.0000, 'ºC'),
	(318464, 144, '2015-01-15 00:02:30.000000', 'temperatura', 571.0000, 'ºC'),
	(318465, 144, '2015-01-15 00:02:31.000000', 'temperatura', 3.0000, 'ºC'),
	(318466, 144, '2015-01-15 00:02:32.000000', 'temperatura', 701.0000, 'ºC'),
	(318467, 144, '2015-01-15 00:02:33.000000', 'temperatura', 1099.0000, 'ºC'),
	(318468, 144, '2015-01-15 00:02:34.000000', 'temperatura', 990.0000, 'ºC'),
	(318469, 144, '2015-01-15 00:02:35.000000', 'temperatura', 453.0000, 'ºC'),
	(318470, 144, '2015-01-15 00:02:36.000000', 'temperatura', 494.0000, 'ºC'),
	(318471, 144, '2015-01-15 00:02:37.000000', 'temperatura', 1114.0000, 'ºC'),
	(318472, 144, '2015-01-15 00:02:38.000000', 'temperatura', 488.0000, 'ºC'),
	(318473, 144, '2015-01-15 00:02:39.000000', 'temperatura', 299.0000, 'ºC'),
	(318474, 144, '2015-01-15 00:02:40.000000', 'temperatura', 32.0000, 'ºC'),
	(318475, 144, '2015-01-15 00:02:41.000000', 'temperatura', 461.0000, 'ºC'),
	(318476, 144, '2015-01-15 00:02:42.000000', 'temperatura', 1012.0000, 'ºC'),
	(318477, 144, '2015-01-15 00:02:43.000000', 'temperatura', 78.0000, 'ºC'),
	(318478, 144, '2015-01-15 00:02:44.000000', 'temperatura', 953.0000, 'ºC'),
	(318479, 144, '2015-01-15 00:02:45.000000', 'temperatura', 930.0000, 'ºC'),
	(318480, 144, '2015-01-15 00:02:46.000000', 'temperatura', 593.0000, 'ºC'),
	(318481, 144, '2015-01-15 00:02:47.000000', 'temperatura', 177.0000, 'ºC'),
	(318482, 144, '2015-01-15 00:02:48.000000', 'temperatura', 306.0000, 'ºC'),
	(318483, 144, '2015-01-15 00:02:49.000000', 'temperatura', 1001.0000, 'ºC'),
	(318484, 144, '2015-01-15 00:02:50.000000', 'temperatura', 486.0000, 'ºC'),
	(318485, 144, '2015-01-15 00:02:51.000000', 'temperatura', 629.0000, 'ºC'),
	(318486, 144, '2015-01-15 00:02:52.000000', 'temperatura', 487.0000, 'ºC'),
	(318487, 144, '2015-01-15 00:02:53.000000', 'temperatura', 547.0000, 'ºC'),
	(318488, 144, '2015-01-15 00:02:54.000000', 'temperatura', 75.0000, 'ºC'),
	(318489, 144, '2015-01-15 00:02:55.000000', 'temperatura', 1133.0000, 'ºC'),
	(318490, 144, '2015-01-15 00:02:56.000000', 'temperatura', 642.0000, 'ºC'),
	(318491, 144, '2015-01-15 00:02:57.000000', 'temperatura', 1012.0000, 'ºC'),
	(318492, 144, '2015-01-15 00:02:58.000000', 'temperatura', 736.0000, 'ºC'),
	(318493, 144, '2015-01-15 00:02:59.000000', 'temperatura', 644.0000, 'ºC'),
	(318494, 144, '2015-01-15 00:03:00.000000', 'temperatura', 1011.0000, 'ºC'),
	(318495, 144, '2015-01-15 00:03:01.000000', 'temperatura', 723.0000, 'ºC'),
	(318496, 144, '2015-01-15 00:03:02.000000', 'temperatura', 582.0000, 'ºC'),
	(318497, 144, '2015-01-15 00:03:03.000000', 'temperatura', 743.0000, 'ºC'),
	(318498, 144, '2015-01-15 00:03:04.000000', 'temperatura', 771.0000, 'ºC'),
	(318499, 144, '2015-01-15 00:03:05.000000', 'temperatura', 424.0000, 'ºC'),
	(318500, 144, '2015-01-15 00:03:06.000000', 'temperatura', 1007.0000, 'ºC'),
	(318501, 144, '2015-01-15 00:03:07.000000', 'temperatura', 165.0000, 'ºC'),
	(318502, 144, '2015-01-15 00:03:08.000000', 'temperatura', 205.0000, 'ºC'),
	(318503, 144, '2015-01-15 00:03:09.000000', 'temperatura', 529.0000, 'ºC'),
	(318504, 144, '2015-01-15 00:03:10.000000', 'temperatura', 830.0000, 'ºC'),
	(318505, 144, '2015-01-15 00:03:11.000000', 'temperatura', 164.0000, 'ºC'),
	(318506, 144, '2015-01-15 00:03:12.000000', 'temperatura', 732.0000, 'ºC'),
	(318507, 144, '2015-01-15 00:03:13.000000', 'temperatura', 766.0000, 'ºC'),
	(318508, 144, '2015-01-15 00:03:14.000000', 'temperatura', 436.0000, 'ºC'),
	(318509, 144, '2015-01-15 00:03:15.000000', 'temperatura', 1082.0000, 'ºC'),
	(318510, 144, '2015-01-15 00:03:16.000000', 'temperatura', 501.0000, 'ºC'),
	(318511, 144, '2015-01-15 00:03:17.000000', 'temperatura', 462.0000, 'ºC'),
	(318512, 144, '2015-01-15 00:03:18.000000', 'temperatura', 806.0000, 'ºC'),
	(318513, 144, '2015-01-15 00:03:19.000000', 'temperatura', 244.0000, 'ºC'),
	(318514, 144, '2015-01-15 00:03:20.000000', 'temperatura', 3.0000, 'ºC'),
	(318515, 144, '2015-01-15 00:03:21.000000', 'temperatura', 484.0000, 'ºC'),
	(318516, 144, '2015-01-15 00:03:22.000000', 'temperatura', 12.0000, 'ºC'),
	(318517, 144, '2015-01-15 00:03:23.000000', 'temperatura', 1009.0000, 'ºC'),
	(318518, 144, '2015-01-15 00:03:24.000000', 'temperatura', 208.0000, 'ºC'),
	(318519, 144, '2015-01-15 00:03:25.000000', 'temperatura', 415.0000, 'ºC'),
	(318520, 144, '2015-01-15 00:03:26.000000', 'temperatura', 249.0000, 'ºC'),
	(318521, 144, '2015-01-15 00:03:27.000000', 'temperatura', 2.0000, 'ºC'),
	(318522, 144, '2015-01-15 00:03:28.000000', 'temperatura', 465.0000, 'ºC'),
	(318523, 144, '2015-01-15 00:03:29.000000', 'temperatura', 1120.0000, 'ºC'),
	(318524, 144, '2015-01-15 00:03:30.000000', 'temperatura', 605.0000, 'ºC'),
	(318525, 144, '2015-01-15 00:03:31.000000', 'temperatura', 865.0000, 'ºC'),
	(318526, 144, '2015-01-15 00:03:32.000000', 'temperatura', 109.0000, 'ºC'),
	(318527, 144, '2015-01-15 00:03:33.000000', 'temperatura', 351.0000, 'ºC'),
	(318528, 144, '2015-01-15 00:03:34.000000', 'temperatura', 229.0000, 'ºC'),
	(318529, 144, '2015-01-15 00:03:35.000000', 'temperatura', 94.0000, 'ºC'),
	(318530, 144, '2015-01-15 00:03:36.000000', 'temperatura', 981.0000, 'ºC'),
	(318531, 144, '2015-01-15 00:03:37.000000', 'temperatura', 1024.0000, 'ºC'),
	(318532, 144, '2015-01-15 00:03:38.000000', 'temperatura', 978.0000, 'ºC'),
	(318533, 144, '2015-01-15 00:03:39.000000', 'temperatura', 618.0000, 'ºC'),
	(318534, 144, '2015-01-15 00:03:40.000000', 'temperatura', 155.0000, 'ºC'),
	(318535, 144, '2015-01-15 00:03:41.000000', 'temperatura', 122.0000, 'ºC'),
	(318536, 144, '2015-01-15 00:03:42.000000', 'temperatura', 144.0000, 'ºC'),
	(318537, 144, '2015-01-15 00:03:43.000000', 'temperatura', 356.0000, 'ºC'),
	(318538, 144, '2015-01-15 00:03:44.000000', 'temperatura', 147.0000, 'ºC'),
	(318539, 144, '2015-01-15 00:03:45.000000', 'temperatura', 867.0000, 'ºC'),
	(318540, 144, '2015-01-15 00:03:46.000000', 'temperatura', 294.0000, 'ºC'),
	(318541, 144, '2015-01-15 00:03:47.000000', 'temperatura', 72.0000, 'ºC'),
	(318542, 144, '2015-01-15 00:03:48.000000', 'temperatura', 677.0000, 'ºC'),
	(318543, 144, '2015-01-15 00:03:49.000000', 'temperatura', 772.0000, 'ºC'),
	(318544, 144, '2015-01-15 00:03:50.000000', 'temperatura', 627.0000, 'ºC'),
	(318545, 144, '2015-01-15 00:03:51.000000', 'temperatura', 819.0000, 'ºC'),
	(318546, 144, '2015-01-15 00:03:52.000000', 'temperatura', 1015.0000, 'ºC'),
	(318547, 144, '2015-01-15 00:03:53.000000', 'temperatura', 217.0000, 'ºC'),
	(318548, 144, '2015-01-15 00:03:54.000000', 'temperatura', 441.0000, 'ºC'),
	(318549, 144, '2015-01-15 00:03:55.000000', 'temperatura', 355.0000, 'ºC'),
	(318550, 144, '2015-01-15 00:03:56.000000', 'temperatura', 451.0000, 'ºC'),
	(318551, 144, '2015-01-15 00:03:57.000000', 'temperatura', 1191.0000, 'ºC'),
	(318552, 144, '2015-01-15 00:03:58.000000', 'temperatura', 1002.0000, 'ºC'),
	(318553, 144, '2015-01-15 00:03:59.000000', 'temperatura', 239.0000, 'ºC'),
	(318554, 144, '2015-01-15 00:04:00.000000', 'temperatura', 587.0000, 'ºC'),
	(318555, 144, '2015-01-15 00:04:01.000000', 'temperatura', 1020.0000, 'ºC'),
	(318556, 144, '2015-01-15 00:04:02.000000', 'temperatura', 941.0000, 'ºC'),
	(318557, 144, '2015-01-15 00:04:03.000000', 'temperatura', 445.0000, 'ºC'),
	(318558, 144, '2015-01-15 00:04:04.000000', 'temperatura', 602.0000, 'ºC'),
	(318559, 144, '2015-01-15 00:04:05.000000', 'temperatura', 474.0000, 'ºC'),
	(318560, 144, '2015-01-15 00:04:06.000000', 'temperatura', 565.0000, 'ºC'),
	(318561, 144, '2015-01-15 00:04:07.000000', 'temperatura', 205.0000, 'ºC'),
	(318562, 144, '2015-01-15 00:04:08.000000', 'temperatura', 532.0000, 'ºC'),
	(318563, 144, '2015-01-15 00:04:09.000000', 'temperatura', 842.0000, 'ºC'),
	(318564, 144, '2015-01-15 00:04:10.000000', 'temperatura', 215.0000, 'ºC'),
	(318565, 144, '2015-01-15 00:04:11.000000', 'temperatura', 950.0000, 'ºC'),
	(318566, 144, '2015-01-15 00:04:12.000000', 'temperatura', 505.0000, 'ºC'),
	(318567, 144, '2015-01-15 00:04:13.000000', 'temperatura', 876.0000, 'ºC'),
	(318568, 144, '2015-01-15 00:04:14.000000', 'temperatura', 466.0000, 'ºC'),
	(318569, 144, '2015-01-15 00:04:15.000000', 'temperatura', 904.0000, 'ºC'),
	(318570, 144, '2015-01-15 00:04:16.000000', 'temperatura', 720.0000, 'ºC'),
	(318571, 144, '2015-01-15 00:04:17.000000', 'temperatura', 888.0000, 'ºC'),
	(318572, 144, '2015-01-15 00:04:18.000000', 'temperatura', 1082.0000, 'ºC'),
	(318573, 144, '2015-01-15 00:04:19.000000', 'temperatura', 345.0000, 'ºC'),
	(318574, 144, '2015-01-15 00:04:20.000000', 'temperatura', 879.0000, 'ºC'),
	(318575, 144, '2015-01-15 00:04:21.000000', 'temperatura', 960.0000, 'ºC'),
	(318576, 144, '2015-01-15 00:04:22.000000', 'temperatura', 965.0000, 'ºC'),
	(318577, 144, '2015-01-15 00:04:23.000000', 'temperatura', 747.0000, 'ºC'),
	(318578, 144, '2015-01-15 00:04:24.000000', 'temperatura', 838.0000, 'ºC'),
	(318579, 144, '2015-01-15 00:04:25.000000', 'temperatura', 751.0000, 'ºC'),
	(318580, 144, '2015-01-15 00:04:26.000000', 'temperatura', 40.0000, 'ºC'),
	(318581, 144, '2015-01-15 00:04:27.000000', 'temperatura', 348.0000, 'ºC'),
	(318582, 144, '2015-01-15 00:04:28.000000', 'temperatura', 421.0000, 'ºC'),
	(318583, 144, '2015-01-15 00:04:29.000000', 'temperatura', 1059.0000, 'ºC'),
	(318584, 144, '2015-01-15 00:04:30.000000', 'temperatura', 435.0000, 'ºC'),
	(318585, 144, '2015-01-15 00:04:31.000000', 'temperatura', 198.0000, 'ºC'),
	(318586, 144, '2015-01-15 00:04:32.000000', 'temperatura', 885.0000, 'ºC'),
	(318587, 144, '2015-01-15 00:04:33.000000', 'temperatura', 233.0000, 'ºC'),
	(318588, 144, '2015-01-15 00:04:34.000000', 'temperatura', 910.0000, 'ºC'),
	(318589, 144, '2015-01-15 00:04:35.000000', 'temperatura', 253.0000, 'ºC'),
	(318590, 144, '2015-01-15 00:04:36.000000', 'temperatura', 933.0000, 'ºC'),
	(318591, 144, '2015-01-15 00:04:37.000000', 'temperatura', 306.0000, 'ºC'),
	(318592, 144, '2015-01-15 00:04:38.000000', 'temperatura', 1131.0000, 'ºC'),
	(318593, 144, '2015-01-15 00:04:39.000000', 'temperatura', 1139.0000, 'ºC'),
	(318594, 144, '2015-01-15 00:04:40.000000', 'temperatura', 1103.0000, 'ºC'),
	(318595, 144, '2015-01-15 00:04:41.000000', 'temperatura', 897.0000, 'ºC'),
	(318596, 144, '2015-01-15 00:04:42.000000', 'temperatura', 1177.0000, 'ºC'),
	(318597, 144, '2015-01-15 00:04:43.000000', 'temperatura', 795.0000, 'ºC'),
	(318598, 144, '2015-01-15 00:04:44.000000', 'temperatura', 445.0000, 'ºC'),
	(318599, 144, '2015-01-15 00:04:45.000000', 'temperatura', 1040.0000, 'ºC'),
	(318600, 144, '2015-01-15 00:04:46.000000', 'temperatura', 265.0000, 'ºC'),
	(318601, 144, '2015-01-15 00:04:47.000000', 'temperatura', 607.0000, 'ºC'),
	(318602, 144, '2015-01-15 00:04:48.000000', 'temperatura', 1039.0000, 'ºC'),
	(318603, 144, '2015-01-15 00:04:49.000000', 'temperatura', 976.0000, 'ºC'),
	(318604, 144, '2015-01-15 00:04:50.000000', 'temperatura', 564.0000, 'ºC'),
	(318605, 144, '2015-01-15 00:04:51.000000', 'temperatura', 1093.0000, 'ºC'),
	(318606, 144, '2015-01-15 00:04:52.000000', 'temperatura', 174.0000, 'ºC'),
	(318607, 144, '2015-01-15 00:04:53.000000', 'temperatura', 1192.0000, 'ºC'),
	(318608, 144, '2015-01-15 00:04:54.000000', 'temperatura', 636.0000, 'ºC'),
	(318609, 144, '2015-01-15 00:04:55.000000', 'temperatura', 807.0000, 'ºC'),
	(318610, 144, '2015-01-15 00:04:56.000000', 'temperatura', 927.0000, 'ºC'),
	(318611, 144, '2015-01-15 00:04:57.000000', 'temperatura', 1014.0000, 'ºC'),
	(318612, 144, '2015-01-15 00:04:58.000000', 'temperatura', 1092.0000, 'ºC'),
	(318613, 144, '2015-01-15 00:04:59.000000', 'temperatura', 15.0000, 'ºC'),
	(318614, 144, '2015-01-15 00:05:00.000000', 'temperatura', 402.0000, 'ºC'),
	(318615, 144, '2015-01-15 00:05:01.000000', 'temperatura', 764.0000, 'ºC'),
	(318616, 144, '2015-01-15 00:05:02.000000', 'temperatura', 214.0000, 'ºC'),
	(318617, 144, '2015-01-15 00:05:03.000000', 'temperatura', 1181.0000, 'ºC'),
	(318618, 144, '2015-01-15 00:05:04.000000', 'temperatura', 461.0000, 'ºC'),
	(318619, 144, '2015-01-15 00:05:05.000000', 'temperatura', 1161.0000, 'ºC'),
	(318620, 144, '2015-01-15 00:05:06.000000', 'temperatura', 826.0000, 'ºC'),
	(318621, 144, '2015-01-15 00:05:07.000000', 'temperatura', 645.0000, 'ºC'),
	(318622, 144, '2015-01-15 00:05:08.000000', 'temperatura', 749.0000, 'ºC'),
	(318623, 144, '2015-01-15 00:05:09.000000', 'temperatura', 610.0000, 'ºC'),
	(318624, 144, '2015-01-15 00:05:10.000000', 'temperatura', 805.0000, 'ºC'),
	(318625, 144, '2015-01-15 00:05:11.000000', 'temperatura', 996.0000, 'ºC'),
	(318626, 144, '2015-01-15 00:05:12.000000', 'temperatura', 163.0000, 'ºC'),
	(318627, 144, '2015-01-15 00:05:13.000000', 'temperatura', 228.0000, 'ºC'),
	(318628, 144, '2015-01-15 00:05:14.000000', 'temperatura', 653.0000, 'ºC'),
	(318629, 144, '2015-01-15 00:05:15.000000', 'temperatura', 181.0000, 'ºC'),
	(318630, 144, '2015-01-15 00:05:16.000000', 'temperatura', 147.0000, 'ºC'),
	(318631, 144, '2015-01-15 00:05:17.000000', 'temperatura', 193.0000, 'ºC'),
	(318632, 144, '2015-01-15 00:05:18.000000', 'temperatura', 523.0000, 'ºC'),
	(318633, 144, '2015-01-15 00:05:19.000000', 'temperatura', 838.0000, 'ºC'),
	(318634, 144, '2015-01-15 00:05:20.000000', 'temperatura', 221.0000, 'ºC'),
	(318635, 144, '2015-01-15 00:05:21.000000', 'temperatura', 993.0000, 'ºC'),
	(318636, 144, '2015-01-15 00:05:22.000000', 'temperatura', 700.0000, 'ºC'),
	(318637, 144, '2015-01-15 00:05:23.000000', 'temperatura', 524.0000, 'ºC'),
	(318638, 144, '2015-01-15 00:05:24.000000', 'temperatura', 519.0000, 'ºC'),
	(318639, 144, '2015-01-15 00:05:25.000000', 'temperatura', 1023.0000, 'ºC'),
	(318640, 144, '2015-01-15 00:05:26.000000', 'temperatura', 1159.0000, 'ºC'),
	(318641, 144, '2015-01-15 00:05:27.000000', 'temperatura', 325.0000, 'ºC'),
	(318642, 144, '2015-01-15 00:05:28.000000', 'temperatura', 552.0000, 'ºC'),
	(318643, 144, '2015-01-15 00:05:29.000000', 'temperatura', 583.0000, 'ºC'),
	(318644, 144, '2015-01-15 00:05:30.000000', 'temperatura', 58.0000, 'ºC'),
	(318645, 144, '2015-01-15 00:05:31.000000', 'temperatura', 944.0000, 'ºC'),
	(318646, 144, '2015-01-15 00:05:32.000000', 'temperatura', 945.0000, 'ºC'),
	(318647, 144, '2015-01-15 00:05:33.000000', 'temperatura', 693.0000, 'ºC'),
	(318648, 144, '2015-01-15 00:05:34.000000', 'temperatura', 630.0000, 'ºC'),
	(318649, 144, '2015-01-15 00:05:35.000000', 'temperatura', 1073.0000, 'ºC'),
	(318650, 144, '2015-01-15 00:05:36.000000', 'temperatura', 1075.0000, 'ºC'),
	(318651, 144, '2015-01-15 00:05:37.000000', 'temperatura', 956.0000, 'ºC'),
	(318652, 144, '2015-01-15 00:05:38.000000', 'temperatura', 354.0000, 'ºC'),
	(318653, 144, '2015-01-15 00:05:39.000000', 'temperatura', 103.0000, 'ºC'),
	(318654, 144, '2015-01-15 00:05:40.000000', 'temperatura', 652.0000, 'ºC'),
	(318655, 144, '2015-01-15 00:05:41.000000', 'temperatura', 554.0000, 'ºC'),
	(318656, 144, '2015-01-15 00:05:42.000000', 'temperatura', 816.0000, 'ºC'),
	(318657, 144, '2015-01-15 00:05:43.000000', 'temperatura', 15.0000, 'ºC'),
	(318658, 144, '2015-01-15 00:05:44.000000', 'temperatura', 29.0000, 'ºC'),
	(318659, 144, '2015-01-15 00:05:45.000000', 'temperatura', 102.0000, 'ºC'),
	(318660, 144, '2015-01-15 00:05:46.000000', 'temperatura', 423.0000, 'ºC'),
	(318661, 144, '2015-01-15 00:05:47.000000', 'temperatura', 608.0000, 'ºC'),
	(318662, 144, '2015-01-15 00:05:48.000000', 'temperatura', 572.0000, 'ºC'),
	(318663, 144, '2015-01-15 00:05:49.000000', 'temperatura', 1035.0000, 'ºC'),
	(318664, 144, '2015-01-15 00:05:50.000000', 'temperatura', 1059.0000, 'ºC'),
	(318665, 144, '2015-01-15 00:05:51.000000', 'temperatura', 991.0000, 'ºC'),
	(318666, 144, '2015-01-15 00:05:52.000000', 'temperatura', 578.0000, 'ºC'),
	(318667, 144, '2015-01-15 00:05:53.000000', 'temperatura', 1118.0000, 'ºC'),
	(318668, 144, '2015-01-15 00:05:54.000000', 'temperatura', 258.0000, 'ºC'),
	(318669, 144, '2015-01-15 00:05:55.000000', 'temperatura', 334.0000, 'ºC'),
	(318670, 144, '2015-01-15 00:05:56.000000', 'temperatura', 896.0000, 'ºC'),
	(318671, 144, '2015-01-15 00:05:57.000000', 'temperatura', 1081.0000, 'ºC'),
	(318672, 144, '2015-01-15 00:05:58.000000', 'temperatura', 318.0000, 'ºC'),
	(318673, 144, '2015-01-15 00:05:59.000000', 'temperatura', 746.0000, 'ºC'),
	(318674, 144, '2015-01-15 00:06:00.000000', 'temperatura', 379.0000, 'ºC'),
	(318675, 144, '2015-01-15 00:06:01.000000', 'temperatura', 855.0000, 'ºC'),
	(318676, 144, '2015-01-15 00:06:02.000000', 'temperatura', 741.0000, 'ºC'),
	(318677, 144, '2015-01-15 00:06:03.000000', 'temperatura', 1140.0000, 'ºC'),
	(318678, 144, '2015-01-15 00:06:04.000000', 'temperatura', 1077.0000, 'ºC'),
	(318679, 144, '2015-01-15 00:06:05.000000', 'temperatura', 765.0000, 'ºC'),
	(318680, 144, '2015-01-15 00:06:06.000000', 'temperatura', 594.0000, 'ºC'),
	(318681, 144, '2015-01-15 00:06:07.000000', 'temperatura', 676.0000, 'ºC'),
	(318682, 144, '2015-01-15 00:06:08.000000', 'temperatura', 397.0000, 'ºC'),
	(318683, 144, '2015-01-15 00:06:09.000000', 'temperatura', 1157.0000, 'ºC'),
	(318684, 144, '2015-01-15 00:06:10.000000', 'temperatura', 997.0000, 'ºC'),
	(318685, 144, '2015-01-15 00:06:11.000000', 'temperatura', 315.0000, 'ºC'),
	(318686, 144, '2015-01-15 00:06:12.000000', 'temperatura', 983.0000, 'ºC'),
	(318687, 144, '2015-01-15 00:06:13.000000', 'temperatura', 372.0000, 'ºC'),
	(318688, 144, '2015-01-15 00:06:14.000000', 'temperatura', 112.0000, 'ºC'),
	(318689, 144, '2015-01-15 00:06:15.000000', 'temperatura', 644.0000, 'ºC'),
	(318690, 144, '2015-01-15 00:06:16.000000', 'temperatura', 485.0000, 'ºC'),
	(318691, 144, '2015-01-15 00:06:17.000000', 'temperatura', 492.0000, 'ºC'),
	(318692, 144, '2015-01-15 00:06:18.000000', 'temperatura', 1005.0000, 'ºC'),
	(318693, 144, '2015-01-15 00:06:19.000000', 'temperatura', 1149.0000, 'ºC'),
	(318694, 144, '2015-01-15 00:06:20.000000', 'temperatura', 332.0000, 'ºC'),
	(318695, 144, '2015-01-15 00:06:21.000000', 'temperatura', 613.0000, 'ºC'),
	(318696, 144, '2015-01-15 00:06:22.000000', 'temperatura', 869.0000, 'ºC'),
	(318697, 144, '2015-01-15 00:06:23.000000', 'temperatura', 109.0000, 'ºC'),
	(318698, 144, '2015-01-15 00:06:24.000000', 'temperatura', 336.0000, 'ºC'),
	(318699, 144, '2015-01-15 00:06:25.000000', 'temperatura', 156.0000, 'ºC'),
	(318700, 144, '2015-01-15 00:06:26.000000', 'temperatura', 970.0000, 'ºC'),
	(318701, 144, '2015-01-15 00:06:27.000000', 'temperatura', 784.0000, 'ºC'),
	(318702, 144, '2015-01-15 00:06:28.000000', 'temperatura', 1012.0000, 'ºC'),
	(318703, 144, '2015-01-15 00:06:29.000000', 'temperatura', 306.0000, 'ºC'),
	(318704, 144, '2015-01-15 00:06:30.000000', 'temperatura', 896.0000, 'ºC'),
	(318705, 144, '2015-01-15 00:06:31.000000', 'temperatura', 1162.0000, 'ºC'),
	(318706, 144, '2015-01-15 00:06:32.000000', 'temperatura', 722.0000, 'ºC'),
	(318707, 144, '2015-01-15 00:06:33.000000', 'temperatura', 125.0000, 'ºC'),
	(318708, 144, '2015-01-15 00:06:34.000000', 'temperatura', 862.0000, 'ºC'),
	(318709, 144, '2015-01-15 00:06:35.000000', 'temperatura', 332.0000, 'ºC'),
	(318710, 144, '2015-01-15 00:06:36.000000', 'temperatura', 274.0000, 'ºC'),
	(318711, 144, '2015-01-15 00:06:37.000000', 'temperatura', 377.0000, 'ºC'),
	(318712, 144, '2015-01-15 00:06:38.000000', 'temperatura', 1061.0000, 'ºC'),
	(318713, 144, '2015-01-15 00:06:39.000000', 'temperatura', 575.0000, 'ºC'),
	(318714, 144, '2015-01-15 00:06:40.000000', 'temperatura', 894.0000, 'ºC'),
	(318715, 144, '2015-01-15 00:06:41.000000', 'temperatura', 345.0000, 'ºC'),
	(318716, 144, '2015-01-15 00:06:42.000000', 'temperatura', 245.0000, 'ºC'),
	(318717, 144, '2015-01-15 00:06:43.000000', 'temperatura', 187.0000, 'ºC'),
	(318718, 144, '2015-01-15 00:06:44.000000', 'temperatura', 203.0000, 'ºC'),
	(318719, 144, '2015-01-15 00:06:45.000000', 'temperatura', 454.0000, 'ºC'),
	(318720, 144, '2015-01-15 00:06:46.000000', 'temperatura', 460.0000, 'ºC'),
	(318721, 144, '2015-01-15 00:06:47.000000', 'temperatura', 938.0000, 'ºC'),
	(318722, 144, '2015-01-15 00:06:48.000000', 'temperatura', 912.0000, 'ºC'),
	(318723, 144, '2015-01-15 00:06:49.000000', 'temperatura', 547.0000, 'ºC'),
	(318724, 144, '2015-01-15 00:06:50.000000', 'temperatura', 1197.0000, 'ºC'),
	(318725, 144, '2015-01-15 00:06:51.000000', 'temperatura', 748.0000, 'ºC'),
	(318726, 144, '2015-01-15 00:06:52.000000', 'temperatura', 147.0000, 'ºC'),
	(318727, 144, '2015-01-15 00:06:53.000000', 'temperatura', 893.0000, 'ºC'),
	(318728, 144, '2015-01-15 00:06:54.000000', 'temperatura', 425.0000, 'ºC'),
	(318729, 144, '2015-01-15 00:06:55.000000', 'temperatura', 648.0000, 'ºC'),
	(318730, 144, '2015-01-15 00:06:56.000000', 'temperatura', 762.0000, 'ºC'),
	(318731, 144, '2015-01-15 00:06:57.000000', 'temperatura', 668.0000, 'ºC'),
	(318732, 144, '2015-01-15 00:06:58.000000', 'temperatura', 1052.0000, 'ºC'),
	(318733, 144, '2015-01-15 00:06:59.000000', 'temperatura', 860.0000, 'ºC'),
	(318734, 144, '2015-01-15 00:07:00.000000', 'temperatura', 1143.0000, 'ºC'),
	(318735, 144, '2015-01-15 00:07:01.000000', 'temperatura', 736.0000, 'ºC'),
	(318736, 144, '2015-01-15 00:07:02.000000', 'temperatura', 253.0000, 'ºC'),
	(318737, 144, '2015-01-15 00:07:03.000000', 'temperatura', 258.0000, 'ºC'),
	(318738, 144, '2015-01-15 00:07:04.000000', 'temperatura', 529.0000, 'ºC'),
	(318739, 144, '2015-01-15 00:07:05.000000', 'temperatura', 671.0000, 'ºC'),
	(318740, 144, '2015-01-15 00:07:06.000000', 'temperatura', 569.0000, 'ºC'),
	(318741, 144, '2015-01-15 00:07:07.000000', 'temperatura', 832.0000, 'ºC'),
	(318742, 144, '2015-01-15 00:07:08.000000', 'temperatura', 53.0000, 'ºC'),
	(318743, 144, '2015-01-15 00:07:09.000000', 'temperatura', 171.0000, 'ºC'),
	(318744, 144, '2015-01-15 00:07:10.000000', 'temperatura', 696.0000, 'ºC'),
	(318745, 144, '2015-01-15 00:07:11.000000', 'temperatura', 568.0000, 'ºC'),
	(318746, 144, '2015-01-15 00:07:12.000000', 'temperatura', 753.0000, 'ºC'),
	(318747, 144, '2015-01-15 00:07:13.000000', 'temperatura', 860.0000, 'ºC'),
	(318748, 144, '2015-01-15 00:07:14.000000', 'temperatura', 842.0000, 'ºC'),
	(318749, 144, '2015-01-15 00:07:15.000000', 'temperatura', 429.0000, 'ºC'),
	(318750, 144, '2015-01-15 00:07:16.000000', 'temperatura', 822.0000, 'ºC'),
	(318751, 144, '2015-01-15 00:07:17.000000', 'temperatura', 422.0000, 'ºC'),
	(318752, 144, '2015-01-15 00:07:18.000000', 'temperatura', 845.0000, 'ºC'),
	(318753, 144, '2015-01-15 00:07:19.000000', 'temperatura', 558.0000, 'ºC'),
	(318754, 144, '2015-01-15 00:07:20.000000', 'temperatura', 256.0000, 'ºC'),
	(318755, 144, '2015-01-15 00:07:21.000000', 'temperatura', 807.0000, 'ºC'),
	(318756, 144, '2015-01-15 00:07:22.000000', 'temperatura', 867.0000, 'ºC'),
	(318757, 144, '2015-01-15 00:07:23.000000', 'temperatura', 716.0000, 'ºC'),
	(318758, 144, '2015-01-15 00:07:24.000000', 'temperatura', 977.0000, 'ºC'),
	(318759, 144, '2015-01-15 00:07:25.000000', 'temperatura', 337.0000, 'ºC'),
	(318760, 144, '2015-01-15 00:07:26.000000', 'temperatura', 1157.0000, 'ºC'),
	(318761, 144, '2015-01-15 00:07:27.000000', 'temperatura', 1172.0000, 'ºC'),
	(318762, 144, '2015-01-15 00:07:28.000000', 'temperatura', 1189.0000, 'ºC'),
	(318763, 144, '2015-01-15 00:07:29.000000', 'temperatura', 31.0000, 'ºC'),
	(318764, 144, '2015-01-15 00:07:30.000000', 'temperatura', 190.0000, 'ºC'),
	(318765, 144, '2015-01-15 00:07:31.000000', 'temperatura', 855.0000, 'ºC'),
	(318766, 144, '2015-01-15 00:07:32.000000', 'temperatura', 108.0000, 'ºC'),
	(318767, 144, '2015-01-15 00:07:33.000000', 'temperatura', 374.0000, 'ºC'),
	(318768, 144, '2015-01-15 00:07:34.000000', 'temperatura', 345.0000, 'ºC'),
	(318769, 144, '2015-01-15 00:07:35.000000', 'temperatura', 606.0000, 'ºC'),
	(318770, 144, '2015-01-15 00:07:36.000000', 'temperatura', 793.0000, 'ºC'),
	(318771, 144, '2015-01-15 00:07:37.000000', 'temperatura', 949.0000, 'ºC'),
	(318772, 144, '2015-01-15 00:07:38.000000', 'temperatura', 1166.0000, 'ºC'),
	(318773, 144, '2015-01-15 00:07:39.000000', 'temperatura', 585.0000, 'ºC'),
	(318774, 144, '2015-01-15 00:07:40.000000', 'temperatura', 624.0000, 'ºC'),
	(318775, 144, '2015-01-15 00:07:41.000000', 'temperatura', 169.0000, 'ºC'),
	(318776, 144, '2015-01-15 00:07:42.000000', 'temperatura', 174.0000, 'ºC'),
	(318777, 144, '2015-01-15 00:07:43.000000', 'temperatura', 363.0000, 'ºC'),
	(318778, 144, '2015-01-15 00:07:44.000000', 'temperatura', 92.0000, 'ºC'),
	(318779, 144, '2015-01-15 00:07:45.000000', 'temperatura', 574.0000, 'ºC'),
	(318780, 144, '2015-01-15 00:07:46.000000', 'temperatura', 193.0000, 'ºC'),
	(318781, 144, '2015-01-15 00:07:47.000000', 'temperatura', 442.0000, 'ºC'),
	(318782, 144, '2015-01-15 00:07:48.000000', 'temperatura', 432.0000, 'ºC'),
	(318783, 144, '2015-01-15 00:07:49.000000', 'temperatura', 833.0000, 'ºC'),
	(318784, 144, '2015-01-15 00:07:50.000000', 'temperatura', 471.0000, 'ºC'),
	(318785, 144, '2015-01-15 00:07:51.000000', 'temperatura', 1056.0000, 'ºC'),
	(318786, 144, '2015-01-15 00:07:52.000000', 'temperatura', 270.0000, 'ºC'),
	(318787, 144, '2015-01-15 00:07:53.000000', 'temperatura', 579.0000, 'ºC'),
	(318788, 144, '2015-01-15 00:07:54.000000', 'temperatura', 887.0000, 'ºC'),
	(318789, 144, '2015-01-15 00:07:55.000000', 'temperatura', 299.0000, 'ºC'),
	(318790, 144, '2015-01-15 00:07:56.000000', 'temperatura', 35.0000, 'ºC'),
	(318791, 144, '2015-01-15 00:07:57.000000', 'temperatura', 479.0000, 'ºC'),
	(318792, 144, '2015-01-15 00:07:58.000000', 'temperatura', 1091.0000, 'ºC'),
	(318793, 144, '2015-01-15 00:07:59.000000', 'temperatura', 419.0000, 'ºC'),
	(318794, 144, '2015-01-15 00:08:00.000000', 'temperatura', 23.0000, 'ºC'),
	(318795, 144, '2015-01-15 00:08:01.000000', 'temperatura', 58.0000, 'ºC'),
	(318796, 144, '2015-01-15 00:08:02.000000', 'temperatura', 223.0000, 'ºC'),
	(318797, 144, '2015-01-15 00:08:03.000000', 'temperatura', 939.0000, 'ºC'),
	(318798, 144, '2015-01-15 00:08:04.000000', 'temperatura', 427.0000, 'ºC'),
	(318799, 144, '2015-01-15 00:08:05.000000', 'temperatura', 517.0000, 'ºC'),
	(318800, 144, '2015-01-15 00:08:06.000000', 'temperatura', 105.0000, 'ºC'),
	(318801, 144, '2015-01-15 00:08:07.000000', 'temperatura', 176.0000, 'ºC'),
	(318802, 144, '2015-01-15 00:08:08.000000', 'temperatura', 565.0000, 'ºC'),
	(318803, 144, '2015-01-15 00:08:09.000000', 'temperatura', 1098.0000, 'ºC'),
	(318804, 144, '2015-01-15 00:08:10.000000', 'temperatura', 197.0000, 'ºC'),
	(318805, 144, '2015-01-15 00:08:11.000000', 'temperatura', 90.0000, 'ºC'),
	(318806, 144, '2015-01-15 00:08:12.000000', 'temperatura', 1061.0000, 'ºC'),
	(318807, 144, '2015-01-15 00:08:13.000000', 'temperatura', 234.0000, 'ºC'),
	(318808, 144, '2015-01-15 00:08:14.000000', 'temperatura', 389.0000, 'ºC'),
	(318809, 144, '2015-01-15 00:08:15.000000', 'temperatura', 42.0000, 'ºC'),
	(318810, 144, '2015-01-15 00:08:16.000000', 'temperatura', 245.0000, 'ºC'),
	(318811, 144, '2015-01-15 00:08:17.000000', 'temperatura', 1099.0000, 'ºC'),
	(318812, 144, '2015-01-15 00:08:18.000000', 'temperatura', 1162.0000, 'ºC'),
	(318813, 144, '2015-01-15 00:08:19.000000', 'temperatura', 114.0000, 'ºC'),
	(318814, 144, '2015-01-15 00:08:20.000000', 'temperatura', 682.0000, 'ºC'),
	(318815, 144, '2015-01-15 00:08:21.000000', 'temperatura', 669.0000, 'ºC'),
	(318816, 144, '2015-01-15 00:08:22.000000', 'temperatura', 99.0000, 'ºC'),
	(318817, 144, '2015-01-15 00:08:23.000000', 'temperatura', 891.0000, 'ºC'),
	(318818, 144, '2015-01-15 00:08:24.000000', 'temperatura', 557.0000, 'ºC'),
	(318819, 144, '2015-01-15 00:08:25.000000', 'temperatura', 114.0000, 'ºC'),
	(318820, 144, '2015-01-15 00:08:26.000000', 'temperatura', 97.0000, 'ºC'),
	(318821, 144, '2015-01-15 00:08:27.000000', 'temperatura', 144.0000, 'ºC'),
	(318822, 144, '2015-01-15 00:08:28.000000', 'temperatura', 428.0000, 'ºC'),
	(318823, 144, '2015-01-15 00:08:29.000000', 'temperatura', 510.0000, 'ºC'),
	(318824, 144, '2015-01-15 00:08:30.000000', 'temperatura', 65.0000, 'ºC'),
	(318825, 144, '2015-01-15 00:08:31.000000', 'temperatura', 1197.0000, 'ºC'),
	(318826, 144, '2015-01-15 00:08:32.000000', 'temperatura', 991.0000, 'ºC'),
	(318827, 144, '2015-01-15 00:08:33.000000', 'temperatura', 163.0000, 'ºC'),
	(318828, 144, '2015-01-15 00:08:34.000000', 'temperatura', 244.0000, 'ºC'),
	(318829, 144, '2015-01-15 00:08:35.000000', 'temperatura', 731.0000, 'ºC'),
	(318830, 144, '2015-01-15 00:08:36.000000', 'temperatura', 525.0000, 'ºC'),
	(318831, 144, '2015-01-15 00:08:37.000000', 'temperatura', 432.0000, 'ºC'),
	(318832, 144, '2015-01-15 00:08:38.000000', 'temperatura', 587.0000, 'ºC'),
	(318833, 144, '2015-01-15 00:08:39.000000', 'temperatura', 436.0000, 'ºC'),
	(318834, 144, '2015-01-15 00:08:40.000000', 'temperatura', 422.0000, 'ºC'),
	(318835, 144, '2015-01-15 00:08:41.000000', 'temperatura', 804.0000, 'ºC'),
	(318836, 144, '2015-01-15 00:08:42.000000', 'temperatura', 351.0000, 'ºC'),
	(318837, 144, '2015-01-15 00:08:43.000000', 'temperatura', 546.0000, 'ºC'),
	(318838, 144, '2015-01-15 00:08:44.000000', 'temperatura', 477.0000, 'ºC'),
	(318839, 144, '2015-01-15 00:08:45.000000', 'temperatura', 747.0000, 'ºC'),
	(318840, 144, '2015-01-15 00:08:46.000000', 'temperatura', 1107.0000, 'ºC'),
	(318841, 144, '2015-01-15 00:08:47.000000', 'temperatura', 892.0000, 'ºC'),
	(318842, 144, '2015-01-15 00:08:48.000000', 'temperatura', 1141.0000, 'ºC'),
	(318843, 144, '2015-01-15 00:08:49.000000', 'temperatura', 631.0000, 'ºC'),
	(318844, 144, '2015-01-15 00:08:50.000000', 'temperatura', 929.0000, 'ºC'),
	(318845, 144, '2015-01-15 00:08:51.000000', 'temperatura', 355.0000, 'ºC'),
	(318846, 144, '2015-01-15 00:08:52.000000', 'temperatura', 187.0000, 'ºC'),
	(318847, 144, '2015-01-15 00:08:53.000000', 'temperatura', 1072.0000, 'ºC'),
	(318848, 144, '2015-01-15 00:08:54.000000', 'temperatura', 0.0000, 'ºC'),
	(318849, 144, '2015-01-15 00:08:55.000000', 'temperatura', 385.0000, 'ºC'),
	(318850, 144, '2015-01-15 00:08:56.000000', 'temperatura', 723.0000, 'ºC'),
	(318851, 144, '2015-01-15 00:08:57.000000', 'temperatura', 62.0000, 'ºC'),
	(318852, 144, '2015-01-15 00:08:58.000000', 'temperatura', 542.0000, 'ºC'),
	(318853, 144, '2015-01-15 00:08:59.000000', 'temperatura', 123.0000, 'ºC'),
	(318854, 144, '2015-01-15 00:09:00.000000', 'temperatura', 190.0000, 'ºC'),
	(318855, 144, '2015-01-15 00:09:01.000000', 'temperatura', 581.0000, 'ºC'),
	(318856, 144, '2015-01-15 00:09:02.000000', 'temperatura', 1135.0000, 'ºC'),
	(318857, 144, '2015-01-15 00:09:03.000000', 'temperatura', 334.0000, 'ºC'),
	(318858, 144, '2015-01-15 00:09:04.000000', 'temperatura', 664.0000, 'ºC'),
	(318859, 144, '2015-01-15 00:09:05.000000', 'temperatura', 1119.0000, 'ºC'),
	(318860, 144, '2015-01-15 00:09:06.000000', 'temperatura', 4.0000, 'ºC'),
	(318861, 144, '2015-01-15 00:09:07.000000', 'temperatura', 262.0000, 'ºC'),
	(318862, 144, '2015-01-15 00:09:08.000000', 'temperatura', 97.0000, 'ºC'),
	(318863, 144, '2015-01-15 00:09:09.000000', 'temperatura', 903.0000, 'ºC'),
	(318864, 144, '2015-01-15 00:09:10.000000', 'temperatura', 622.0000, 'ºC'),
	(318865, 144, '2015-01-15 00:09:11.000000', 'temperatura', 402.0000, 'ºC'),
	(318866, 144, '2015-01-15 00:09:12.000000', 'temperatura', 146.0000, 'ºC'),
	(318867, 144, '2015-01-15 00:09:13.000000', 'temperatura', 723.0000, 'ºC'),
	(318868, 144, '2015-01-15 00:09:14.000000', 'temperatura', 778.0000, 'ºC'),
	(318869, 144, '2015-01-15 00:09:15.000000', 'temperatura', 520.0000, 'ºC'),
	(318870, 144, '2015-01-15 00:09:16.000000', 'temperatura', 268.0000, 'ºC'),
	(318871, 144, '2015-01-15 00:09:17.000000', 'temperatura', 980.0000, 'ºC'),
	(318872, 144, '2015-01-15 00:09:18.000000', 'temperatura', 496.0000, 'ºC'),
	(318873, 144, '2015-01-15 00:09:19.000000', 'temperatura', 741.0000, 'ºC'),
	(318874, 144, '2015-01-15 00:09:20.000000', 'temperatura', 1017.0000, 'ºC'),
	(318875, 144, '2015-01-15 00:09:21.000000', 'temperatura', 462.0000, 'ºC'),
	(318876, 144, '2015-01-15 00:09:22.000000', 'temperatura', 461.0000, 'ºC'),
	(318877, 144, '2015-01-15 00:09:23.000000', 'temperatura', 918.0000, 'ºC'),
	(318878, 144, '2015-01-15 00:09:24.000000', 'temperatura', 807.0000, 'ºC'),
	(318879, 144, '2015-01-15 00:09:25.000000', 'temperatura', 81.0000, 'ºC'),
	(318880, 144, '2015-01-15 00:09:26.000000', 'temperatura', 383.0000, 'ºC'),
	(318881, 144, '2015-01-15 00:09:27.000000', 'temperatura', 476.0000, 'ºC'),
	(318882, 144, '2015-01-15 00:09:28.000000', 'temperatura', 28.0000, 'ºC'),
	(318883, 144, '2015-01-15 00:09:29.000000', 'temperatura', 1115.0000, 'ºC'),
	(318884, 144, '2015-01-15 00:09:30.000000', 'temperatura', 692.0000, 'ºC'),
	(318885, 144, '2015-01-15 00:09:31.000000', 'temperatura', 115.0000, 'ºC'),
	(318886, 144, '2015-01-15 00:09:32.000000', 'temperatura', 897.0000, 'ºC'),
	(318887, 144, '2015-01-15 00:09:33.000000', 'temperatura', 544.0000, 'ºC'),
	(318888, 144, '2015-01-15 00:09:34.000000', 'temperatura', 29.0000, 'ºC'),
	(318889, 144, '2015-01-15 00:09:35.000000', 'temperatura', 911.0000, 'ºC'),
	(318890, 144, '2015-01-15 00:09:36.000000', 'temperatura', 871.0000, 'ºC'),
	(318891, 144, '2015-01-15 00:09:37.000000', 'temperatura', 420.0000, 'ºC'),
	(318892, 144, '2015-01-15 00:09:38.000000', 'temperatura', 690.0000, 'ºC'),
	(318893, 144, '2015-01-15 00:09:39.000000', 'temperatura', 992.0000, 'ºC'),
	(318894, 144, '2015-01-15 00:09:40.000000', 'temperatura', 487.0000, 'ºC'),
	(318895, 144, '2015-01-15 00:09:41.000000', 'temperatura', 662.0000, 'ºC'),
	(318896, 144, '2015-01-15 00:09:42.000000', 'temperatura', 648.0000, 'ºC'),
	(318897, 144, '2015-01-15 00:09:43.000000', 'temperatura', 54.0000, 'ºC'),
	(318898, 144, '2015-01-15 00:09:44.000000', 'temperatura', 726.0000, 'ºC'),
	(318899, 144, '2015-01-15 00:09:45.000000', 'temperatura', 1070.0000, 'ºC'),
	(318900, 144, '2015-01-15 00:09:46.000000', 'temperatura', 774.0000, 'ºC'),
	(318901, 144, '2015-01-15 00:09:47.000000', 'temperatura', 658.0000, 'ºC'),
	(318902, 144, '2015-01-15 00:09:48.000000', 'temperatura', 971.0000, 'ºC'),
	(318903, 144, '2015-01-15 00:09:49.000000', 'temperatura', 481.0000, 'ºC'),
	(318904, 144, '2015-01-15 00:09:50.000000', 'temperatura', 691.0000, 'ºC'),
	(318905, 144, '2015-01-15 00:09:51.000000', 'temperatura', 815.0000, 'ºC'),
	(318906, 144, '2015-01-15 00:09:52.000000', 'temperatura', 799.0000, 'ºC'),
	(318907, 144, '2015-01-15 00:09:53.000000', 'temperatura', 353.0000, 'ºC'),
	(318908, 144, '2015-01-15 00:09:54.000000', 'temperatura', 569.0000, 'ºC'),
	(318909, 144, '2015-01-15 00:09:55.000000', 'temperatura', 585.0000, 'ºC'),
	(318910, 144, '2015-01-15 00:09:56.000000', 'temperatura', 18.0000, 'ºC'),
	(318911, 144, '2015-01-15 00:09:57.000000', 'temperatura', 737.0000, 'ºC'),
	(318912, 144, '2015-01-15 00:09:58.000000', 'temperatura', 29.0000, 'ºC'),
	(318913, 144, '2015-01-15 00:09:59.000000', 'temperatura', 337.0000, 'ºC'),
	(318914, 144, '2015-01-15 00:10:00.000000', 'temperatura', 400.0000, 'ºC'),
	(318915, 144, '2015-01-15 00:10:01.000000', 'temperatura', 987.0000, 'ºC'),
	(318916, 144, '2015-01-15 00:10:02.000000', 'temperatura', 135.0000, 'ºC'),
	(318917, 144, '2015-01-15 00:10:03.000000', 'temperatura', 115.0000, 'ºC'),
	(318918, 144, '2015-01-15 00:10:04.000000', 'temperatura', 171.0000, 'ºC'),
	(318919, 144, '2015-01-15 00:10:05.000000', 'temperatura', 510.0000, 'ºC'),
	(318920, 144, '2015-01-15 00:10:06.000000', 'temperatura', 836.0000, 'ºC'),
	(318921, 144, '2015-01-15 00:10:07.000000', 'temperatura', 250.0000, 'ºC'),
	(318922, 144, '2015-01-15 00:10:08.000000', 'temperatura', 1146.0000, 'ºC'),
	(318923, 144, '2015-01-15 00:10:09.000000', 'temperatura', 178.0000, 'ºC'),
	(318924, 144, '2015-01-15 00:10:10.000000', 'temperatura', 1051.0000, 'ºC'),
	(318925, 144, '2015-01-15 00:10:11.000000', 'temperatura', 1125.0000, 'ºC'),
	(318926, 144, '2015-01-15 00:10:12.000000', 'temperatura', 71.0000, 'ºC'),
	(318927, 144, '2015-01-15 00:10:13.000000', 'temperatura', 581.0000, 'ºC'),
	(318928, 144, '2015-01-15 00:10:14.000000', 'temperatura', 291.0000, 'ºC'),
	(318929, 144, '2015-01-15 00:10:15.000000', 'temperatura', 913.0000, 'ºC'),
	(318930, 144, '2015-01-15 00:10:16.000000', 'temperatura', 94.0000, 'ºC'),
	(318931, 144, '2015-01-15 00:10:17.000000', 'temperatura', 133.0000, 'ºC'),
	(318932, 144, '2015-01-15 00:10:18.000000', 'temperatura', 381.0000, 'ºC'),
	(318933, 144, '2015-01-15 00:10:19.000000', 'temperatura', 306.0000, 'ºC'),
	(318934, 144, '2015-01-15 00:10:20.000000', 'temperatura', 388.0000, 'ºC'),
	(318935, 144, '2015-01-15 00:10:21.000000', 'temperatura', 1021.0000, 'ºC'),
	(318936, 144, '2015-01-15 00:10:22.000000', 'temperatura', 342.0000, 'ºC'),
	(318937, 144, '2015-01-15 00:10:23.000000', 'temperatura', 1050.0000, 'ºC'),
	(318938, 144, '2015-01-15 00:10:24.000000', 'temperatura', 622.0000, 'ºC'),
	(318939, 144, '2015-01-15 00:10:25.000000', 'temperatura', 1162.0000, 'ºC'),
	(318940, 144, '2015-01-15 00:10:26.000000', 'temperatura', 344.0000, 'ºC'),
	(318941, 144, '2015-01-15 00:10:27.000000', 'temperatura', 636.0000, 'ºC'),
	(318942, 144, '2015-01-15 00:10:28.000000', 'temperatura', 948.0000, 'ºC'),
	(318943, 144, '2015-01-15 00:10:29.000000', 'temperatura', 434.0000, 'ºC'),
	(318944, 144, '2015-01-15 00:10:30.000000', 'temperatura', 524.0000, 'ºC'),
	(318945, 144, '2015-01-15 00:10:31.000000', 'temperatura', 120.0000, 'ºC'),
	(318946, 144, '2015-01-15 00:10:32.000000', 'temperatura', 229.0000, 'ºC'),
	(318947, 144, '2015-01-15 00:10:33.000000', 'temperatura', 783.0000, 'ºC'),
	(318948, 144, '2015-01-15 00:10:34.000000', 'temperatura', 830.0000, 'ºC'),
	(318949, 144, '2015-01-15 00:10:35.000000', 'temperatura', 602.0000, 'ºC'),
	(318950, 144, '2015-01-15 00:10:36.000000', 'temperatura', 521.0000, 'ºC'),
	(318951, 144, '2015-01-15 00:10:37.000000', 'temperatura', 798.0000, 'ºC'),
	(318952, 144, '2015-01-15 00:10:38.000000', 'temperatura', 30.0000, 'ºC'),
	(318953, 144, '2015-01-15 00:10:39.000000', 'temperatura', 155.0000, 'ºC'),
	(318954, 144, '2015-01-15 00:10:40.000000', 'temperatura', 684.0000, 'ºC'),
	(318955, 144, '2015-01-15 00:10:41.000000', 'temperatura', 555.0000, 'ºC'),
	(318956, 144, '2015-01-15 00:10:42.000000', 'temperatura', 724.0000, 'ºC'),
	(318957, 144, '2015-01-15 00:10:43.000000', 'temperatura', 756.0000, 'ºC'),
	(318958, 144, '2015-01-15 00:10:44.000000', 'temperatura', 409.0000, 'ºC'),
	(318959, 144, '2015-01-15 00:10:45.000000', 'temperatura', 977.0000, 'ºC'),
	(318960, 144, '2015-01-15 00:10:46.000000', 'temperatura', 57.0000, 'ºC'),
	(318961, 144, '2015-01-15 00:10:47.000000', 'temperatura', 956.0000, 'ºC'),
	(318962, 144, '2015-01-15 00:10:48.000000', 'temperatura', 1010.0000, 'ºC'),
	(318963, 144, '2015-01-15 00:10:49.000000', 'temperatura', 982.0000, 'ºC'),
	(318964, 144, '2015-01-15 00:10:50.000000', 'temperatura', 679.0000, 'ºC'),
	(318965, 144, '2015-01-15 00:10:51.000000', 'temperatura', 451.0000, 'ºC'),
	(318966, 144, '2015-01-15 00:10:52.000000', 'temperatura', 218.0000, 'ºC'),
	(318967, 144, '2015-01-15 00:10:53.000000', 'temperatura', 938.0000, 'ºC'),
	(318968, 144, '2015-01-15 00:10:54.000000', 'temperatura', 436.0000, 'ºC'),
	(318969, 144, '2015-01-15 00:10:55.000000', 'temperatura', 565.0000, 'ºC'),
	(318970, 144, '2015-01-15 00:10:56.000000', 'temperatura', 318.0000, 'ºC'),
	(318971, 144, '2015-01-15 00:10:57.000000', 'temperatura', 1096.0000, 'ºC'),
	(318972, 144, '2015-01-15 00:10:58.000000', 'temperatura', 926.0000, 'ºC'),
	(318973, 144, '2015-01-15 00:10:59.000000', 'temperatura', 144.0000, 'ºC'),
	(318974, 144, '2015-01-15 00:11:00.000000', 'temperatura', 342.0000, 'ºC'),
	(318975, 144, '2015-01-15 00:11:01.000000', 'temperatura', 80.0000, 'ºC'),
	(318976, 144, '2015-01-15 00:11:02.000000', 'temperatura', 574.0000, 'ºC'),
	(318977, 144, '2015-01-15 00:11:03.000000', 'temperatura', 232.0000, 'ºC'),
	(318978, 144, '2015-01-15 00:11:04.000000', 'temperatura', 637.0000, 'ºC'),
	(318979, 144, '2015-01-15 00:11:05.000000', 'temperatura', 89.0000, 'ºC'),
	(318980, 144, '2015-01-15 00:11:06.000000', 'temperatura', 936.0000, 'ºC'),
	(318981, 144, '2015-01-15 00:11:07.000000', 'temperatura', 813.0000, 'ºC'),
	(318982, 144, '2015-01-15 00:11:08.000000', 'temperatura', 59.0000, 'ºC'),
	(318983, 144, '2015-01-15 00:11:09.000000', 'temperatura', 255.0000, 'ºC'),
	(318984, 144, '2015-01-15 00:11:10.000000', 'temperatura', 1100.0000, 'ºC'),
	(318985, 144, '2015-01-15 00:11:11.000000', 'temperatura', 1134.0000, 'ºC'),
	(318986, 144, '2015-01-15 00:11:12.000000', 'temperatura', 1170.0000, 'ºC'),
	(318987, 144, '2015-01-15 00:11:13.000000', 'temperatura', 48.0000, 'ºC'),
	(318988, 144, '2015-01-15 00:11:14.000000', 'temperatura', 330.0000, 'ºC'),
	(318989, 144, '2015-01-15 00:11:15.000000', 'temperatura', 308.0000, 'ºC'),
	(318990, 144, '2015-01-15 00:11:16.000000', 'temperatura', 550.0000, 'ºC'),
	(318991, 144, '2015-01-15 00:11:17.000000', 'temperatura', 627.0000, 'ºC'),
	(318992, 144, '2015-01-15 00:11:18.000000', 'temperatura', 285.0000, 'ºC'),
	(318993, 144, '2015-01-15 00:11:19.000000', 'temperatura', 744.0000, 'ºC'),
	(318994, 144, '2015-01-15 00:11:20.000000', 'temperatura', 468.0000, 'ºC'),
	(318995, 144, '2015-01-15 00:11:21.000000', 'temperatura', 107.0000, 'ºC'),
	(318996, 144, '2015-01-15 00:11:22.000000', 'temperatura', 333.0000, 'ºC'),
	(318997, 144, '2015-01-15 00:11:23.000000', 'temperatura', 145.0000, 'ºC'),
	(318998, 144, '2015-01-15 00:11:24.000000', 'temperatura', 926.0000, 'ºC'),
	(318999, 144, '2015-01-15 00:11:25.000000', 'temperatura', 595.0000, 'ºC'),
	(319000, 144, '2015-01-15 00:11:26.000000', 'temperatura', 198.0000, 'ºC'),
	(319001, 144, '2015-01-15 00:11:27.000000', 'temperatura', 406.0000, 'ºC'),
	(319002, 144, '2015-01-15 00:11:28.000000', 'temperatura', 236.0000, 'ºC'),
	(319003, 144, '2015-01-15 00:11:29.000000', 'temperatura', 1163.0000, 'ºC'),
	(319004, 144, '2015-01-15 00:11:30.000000', 'temperatura', 308.0000, 'ºC'),
	(319005, 144, '2015-01-15 00:11:31.000000', 'temperatura', 450.0000, 'ºC'),
	(319006, 144, '2015-01-15 00:11:32.000000', 'temperatura', 128.0000, 'ºC'),
	(319007, 144, '2015-01-15 00:11:33.000000', 'temperatura', 488.0000, 'ºC'),
	(319008, 144, '2015-01-15 00:11:34.000000', 'temperatura', 860.0000, 'ºC'),
	(319009, 144, '2015-01-15 00:11:35.000000', 'temperatura', 434.0000, 'ºC'),
	(319010, 144, '2015-01-15 00:11:36.000000', 'temperatura', 789.0000, 'ºC'),
	(319011, 144, '2015-01-15 00:11:37.000000', 'temperatura', 247.0000, 'ºC'),
	(319012, 144, '2015-01-15 00:11:38.000000', 'temperatura', 66.0000, 'ºC'),
	(319013, 144, '2015-01-15 00:11:39.000000', 'temperatura', 790.0000, 'ºC'),
	(319014, 144, '2015-01-15 00:11:40.000000', 'temperatura', 153.0000, 'ºC'),
	(319015, 144, '2015-01-15 00:11:41.000000', 'temperatura', 794.0000, 'ºC'),
	(319016, 144, '2015-01-15 00:11:42.000000', 'temperatura', 1110.0000, 'ºC'),
	(319017, 144, '2015-01-15 00:11:43.000000', 'temperatura', 771.0000, 'ºC'),
	(319018, 144, '2015-01-15 00:11:44.000000', 'temperatura', 527.0000, 'ºC'),
	(319019, 144, '2015-01-15 00:11:45.000000', 'temperatura', 320.0000, 'ºC'),
	(319020, 144, '2015-01-15 00:11:46.000000', 'temperatura', 22.0000, 'ºC'),
	(319021, 144, '2015-01-15 00:11:47.000000', 'temperatura', 349.0000, 'ºC'),
	(319022, 144, '2015-01-15 00:11:48.000000', 'temperatura', 480.0000, 'ºC'),
	(319023, 144, '2015-01-15 00:11:49.000000', 'temperatura', 155.0000, 'ºC'),
	(319024, 144, '2015-01-15 00:11:50.000000', 'temperatura', 533.0000, 'ºC'),
	(319025, 144, '2015-01-15 00:11:51.000000', 'temperatura', 1000.0000, 'ºC'),
	(319026, 144, '2015-01-15 00:11:52.000000', 'temperatura', 1003.0000, 'ºC'),
	(319027, 144, '2015-01-15 00:11:53.000000', 'temperatura', 817.0000, 'ºC'),
	(319028, 144, '2015-01-15 00:11:54.000000', 'temperatura', 1073.0000, 'ºC'),
	(319029, 144, '2015-01-15 00:11:55.000000', 'temperatura', 518.0000, 'ºC'),
	(319030, 144, '2015-01-15 00:11:56.000000', 'temperatura', 568.0000, 'ºC'),
	(319031, 144, '2015-01-15 00:11:57.000000', 'temperatura', 88.0000, 'ºC'),
	(319032, 144, '2015-01-15 00:11:58.000000', 'temperatura', 1137.0000, 'ºC'),
	(319033, 144, '2015-01-15 00:11:59.000000', 'temperatura', 620.0000, 'ºC'),
	(319034, 144, '2015-01-15 00:12:00.000000', 'temperatura', 892.0000, 'ºC'),
	(319035, 144, '2015-01-15 00:12:01.000000', 'temperatura', 198.0000, 'ºC'),
	(319036, 144, '2015-01-15 00:12:02.000000', 'temperatura', 716.0000, 'ºC'),
	(319037, 144, '2015-01-15 00:12:03.000000', 'temperatura', 588.0000, 'ºC'),
	(319038, 144, '2015-01-15 00:12:04.000000', 'temperatura', 791.0000, 'ºC'),
	(319039, 144, '2015-01-15 00:12:05.000000', 'temperatura', 993.0000, 'ºC'),
	(319040, 144, '2015-01-15 00:12:06.000000', 'temperatura', 192.0000, 'ºC'),
	(319041, 144, '2015-01-15 00:12:07.000000', 'temperatura', 383.0000, 'ºC'),
	(319042, 144, '2015-01-15 00:12:08.000000', 'temperatura', 138.0000, 'ºC'),
	(319043, 144, '2015-01-15 00:12:09.000000', 'temperatura', 741.0000, 'ºC'),
	(319044, 144, '2015-01-15 00:12:10.000000', 'temperatura', 890.0000, 'ºC'),
	(319045, 144, '2015-01-15 00:12:11.000000', 'temperatura', 1030.0000, 'ºC'),
	(319046, 144, '2015-01-15 00:12:12.000000', 'temperatura', 78.0000, 'ºC'),
	(319047, 144, '2015-01-15 00:12:13.000000', 'temperatura', 900.0000, 'ºC'),
	(319048, 144, '2015-01-15 00:12:14.000000', 'temperatura', 667.0000, 'ºC'),
	(319049, 144, '2015-01-15 00:12:15.000000', 'temperatura', 638.0000, 'ºC'),
	(319050, 144, '2015-01-15 00:12:16.000000', 'temperatura', 1187.0000, 'ºC'),
	(319051, 144, '2015-01-15 00:12:17.000000', 'temperatura', 420.0000, 'ºC'),
	(319052, 144, '2015-01-15 00:12:18.000000', 'temperatura', 942.0000, 'ºC'),
	(319053, 144, '2015-01-15 00:12:19.000000', 'temperatura', 1049.0000, 'ºC'),
	(319054, 144, '2015-01-15 00:12:20.000000', 'temperatura', 20.0000, 'ºC'),
	(319055, 144, '2015-01-15 00:12:21.000000', 'temperatura', 552.0000, 'ºC'),
	(319056, 144, '2015-01-15 00:12:22.000000', 'temperatura', 301.0000, 'ºC'),
	(319057, 144, '2015-01-15 00:12:23.000000', 'temperatura', 1051.0000, 'ºC'),
	(319058, 144, '2015-01-15 00:12:24.000000', 'temperatura', 751.0000, 'ºC'),
	(319059, 144, '2015-01-15 00:12:25.000000', 'temperatura', 602.0000, 'ºC'),
	(319060, 144, '2015-01-15 00:12:26.000000', 'temperatura', 758.0000, 'ºC'),
	(319061, 144, '2015-01-15 00:12:27.000000', 'temperatura', 784.0000, 'ºC'),
	(319062, 144, '2015-01-15 00:12:28.000000', 'temperatura', 448.0000, 'ºC'),
	(319063, 144, '2015-01-15 00:12:29.000000', 'temperatura', 1088.0000, 'ºC'),
	(319064, 144, '2015-01-15 00:12:30.000000', 'temperatura', 496.0000, 'ºC'),
	(319065, 144, '2015-01-15 00:12:31.000000', 'temperatura', 415.0000, 'ºC'),
	(319066, 144, '2015-01-15 00:12:32.000000', 'temperatura', 590.0000, 'ºC'),
	(319067, 144, '2015-01-15 00:12:33.000000', 'temperatura', 504.0000, 'ºC'),
	(319068, 144, '2015-01-15 00:12:34.000000', 'temperatura', 750.0000, 'ºC'),
	(319069, 144, '2015-01-15 00:12:35.000000', 'temperatura', 1040.0000, 'ºC'),
	(319070, 144, '2015-01-15 00:12:36.000000', 'temperatura', 548.0000, 'ºC'),
	(319071, 144, '2015-01-15 00:12:37.000000', 'temperatura', 824.0000, 'ºC'),
	(319072, 144, '2015-01-15 00:12:38.000000', 'temperatura', 74.0000, 'ºC'),
	(319073, 144, '2015-01-15 00:12:39.000000', 'temperatura', 298.0000, 'ºC'),
	(319074, 144, '2015-01-15 00:12:40.000000', 'temperatura', 69.0000, 'ºC'),
	(319075, 144, '2015-01-15 00:12:41.000000', 'temperatura', 653.0000, 'ºC'),
	(319076, 144, '2015-01-15 00:12:42.000000', 'temperatura', 657.0000, 'ºC'),
	(319077, 144, '2015-01-15 00:12:43.000000', 'temperatura', 127.0000, 'ºC'),
	(319078, 144, '2015-01-15 00:12:44.000000', 'temperatura', 1065.0000, 'ºC'),
	(319079, 144, '2015-01-15 00:12:45.000000', 'temperatura', 145.0000, 'ºC'),
	(319080, 144, '2015-01-15 00:12:46.000000', 'temperatura', 1129.0000, 'ºC'),
	(319081, 144, '2015-01-15 00:12:47.000000', 'temperatura', 412.0000, 'ºC'),
	(319082, 144, '2015-01-15 00:12:48.000000', 'temperatura', 1073.0000, 'ºC'),
	(319083, 144, '2015-01-15 00:12:49.000000', 'temperatura', 529.0000, 'ºC'),
	(319084, 144, '2015-01-15 00:12:50.000000', 'temperatura', 626.0000, 'ºC'),
	(319085, 144, '2015-01-15 00:12:51.000000', 'temperatura', 346.0000, 'ºC'),
	(319086, 144, '2015-01-15 00:12:52.000000', 'temperatura', 1050.0000, 'ºC'),
	(319087, 144, '2015-01-15 00:12:53.000000', 'temperatura', 613.0000, 'ºC'),
	(319088, 144, '2015-01-15 00:12:54.000000', 'temperatura', 1117.0000, 'ºC'),
	(319089, 144, '2015-01-15 00:12:55.000000', 'temperatura', 147.0000, 'ºC'),
	(319090, 144, '2015-01-15 00:12:56.000000', 'temperatura', 982.0000, 'ºC'),
	(319091, 144, '2015-01-15 00:12:57.000000', 'temperatura', 870.0000, 'ºC'),
	(319092, 144, '2015-01-15 00:12:58.000000', 'temperatura', 207.0000, 'ºC'),
	(319093, 144, '2015-01-15 00:12:59.000000', 'temperatura', 824.0000, 'ºC'),
	(319094, 144, '2015-01-15 00:13:00.000000', 'temperatura', 1098.0000, 'ºC'),
	(319095, 144, '2015-01-15 00:13:01.000000', 'temperatura', 620.0000, 'ºC'),
	(319096, 144, '2015-01-15 00:13:02.000000', 'temperatura', 1005.0000, 'ºC'),
	(319097, 144, '2015-01-15 00:13:03.000000', 'temperatura', 766.0000, 'ºC'),
	(319098, 144, '2015-01-15 00:13:04.000000', 'temperatura', 816.0000, 'ºC'),
	(319099, 144, '2015-01-15 00:13:05.000000', 'temperatura', 583.0000, 'ºC'),
	(319100, 144, '2015-01-15 00:13:06.000000', 'temperatura', 467.0000, 'ºC'),
	(319101, 144, '2015-01-15 00:13:07.000000', 'temperatura', 585.0000, 'ºC'),
	(319102, 144, '2015-01-15 00:13:08.000000', 'temperatura', 328.0000, 'ºC'),
	(319103, 144, '2015-01-15 00:13:09.000000', 'temperatura', 1082.0000, 'ºC'),
	(319104, 144, '2015-01-15 00:13:10.000000', 'temperatura', 829.0000, 'ºC'),
	(319105, 144, '2015-01-15 00:13:11.000000', 'temperatura', 898.0000, 'ºC'),
	(319106, 144, '2015-01-15 00:13:12.000000', 'temperatura', 803.0000, 'ºC'),
	(319107, 144, '2015-01-15 00:13:13.000000', 'temperatura', 121.0000, 'ºC'),
	(319108, 144, '2015-01-15 00:13:14.000000', 'temperatura', 598.0000, 'ºC'),
	(319109, 144, '2015-01-15 00:13:15.000000', 'temperatura', 227.0000, 'ºC'),
	(319110, 144, '2015-01-15 00:13:16.000000', 'temperatura', 543.0000, 'ºC'),
	(319111, 144, '2015-01-15 00:13:17.000000', 'temperatura', 834.0000, 'ºC'),
	(319112, 144, '2015-01-15 00:13:18.000000', 'temperatura', 142.0000, 'ºC'),
	(319113, 144, '2015-01-15 00:13:19.000000', 'temperatura', 607.0000, 'ºC'),
	(319114, 144, '2015-01-15 00:13:20.000000', 'temperatura', 208.0000, 'ºC'),
	(319115, 144, '2015-01-15 00:13:21.000000', 'temperatura', 422.0000, 'ºC'),
	(319116, 144, '2015-01-15 00:13:22.000000', 'temperatura', 285.0000, 'ºC'),
	(319117, 144, '2015-01-15 00:13:23.000000', 'temperatura', 161.0000, 'ºC'),
	(319118, 144, '2015-01-15 00:13:24.000000', 'temperatura', 1149.0000, 'ºC'),
	(319119, 144, '2015-01-15 00:13:25.000000', 'temperatura', 462.0000, 'ºC'),
	(319120, 144, '2015-01-15 00:13:26.000000', 'temperatura', 65.0000, 'ºC'),
	(319121, 144, '2015-01-15 00:13:27.000000', 'temperatura', 137.0000, 'ºC'),
	(319122, 144, '2015-01-15 00:13:28.000000', 'temperatura', 493.0000, 'ºC'),
	(319123, 144, '2015-01-15 00:13:29.000000', 'temperatura', 855.0000, 'ºC'),
	(319124, 144, '2015-01-15 00:13:30.000000', 'temperatura', 395.0000, 'ºC'),
	(319125, 144, '2015-01-15 00:13:31.000000', 'temperatura', 613.0000, 'ºC'),
	(319126, 144, '2015-01-15 00:13:32.000000', 'temperatura', 677.0000, 'ºC'),
	(319127, 144, '2015-01-15 00:13:33.000000', 'temperatura', 350.0000, 'ºC'),
	(319128, 144, '2015-01-15 00:13:34.000000', 'temperatura', 917.0000, 'ºC'),
	(319129, 144, '2015-01-15 00:13:35.000000', 'temperatura', 1135.0000, 'ºC'),
	(319130, 144, '2015-01-15 00:13:36.000000', 'temperatura', 525.0000, 'ºC'),
	(319131, 144, '2015-01-15 00:13:37.000000', 'temperatura', 423.0000, 'ºC'),
	(319132, 144, '2015-01-15 00:13:38.000000', 'temperatura', 538.0000, 'ºC'),
	(319133, 144, '2015-01-15 00:13:39.000000', 'temperatura', 224.0000, 'ºC'),
	(319134, 144, '2015-01-15 00:13:40.000000', 'temperatura', 705.0000, 'ºC'),
	(319135, 144, '2015-01-15 00:13:41.000000', 'temperatura', 452.0000, 'ºC'),
	(319136, 144, '2015-01-15 00:13:42.000000', 'temperatura', 147.0000, 'ºC'),
	(319137, 144, '2015-01-15 00:13:43.000000', 'temperatura', 578.0000, 'ºC'),
	(319138, 144, '2015-01-15 00:13:44.000000', 'temperatura', 49.0000, 'ºC'),
	(319139, 144, '2015-01-15 00:13:45.000000', 'temperatura', 913.0000, 'ºC'),
	(319140, 144, '2015-01-15 00:13:46.000000', 'temperatura', 820.0000, 'ºC'),
	(319141, 144, '2015-01-15 00:13:47.000000', 'temperatura', 158.0000, 'ºC'),
	(319142, 144, '2015-01-15 00:13:48.000000', 'temperatura', 734.0000, 'ºC'),
	(319143, 144, '2015-01-15 00:13:49.000000', 'temperatura', 795.0000, 'ºC'),
	(319144, 144, '2015-01-15 00:13:50.000000', 'temperatura', 572.0000, 'ºC'),
	(319145, 144, '2015-01-15 00:13:51.000000', 'temperatura', 476.0000, 'ºC'),
	(319146, 144, '2015-01-15 00:13:52.000000', 'temperatura', 663.0000, 'ºC'),
	(319147, 144, '2015-01-15 00:13:53.000000', 'temperatura', 690.0000, 'ºC'),
	(319148, 144, '2015-01-15 00:13:54.000000', 'temperatura', 260.0000, 'ºC'),
	(319149, 144, '2015-01-15 00:13:55.000000', 'temperatura', 431.0000, 'ºC'),
	(319150, 144, '2015-01-15 00:13:56.000000', 'temperatura', 176.0000, 'ºC'),
	(319151, 144, '2015-01-15 00:13:57.000000', 'temperatura', 786.0000, 'ºC'),
	(319152, 144, '2015-01-15 00:13:58.000000', 'temperatura', 1005.0000, 'ºC'),
	(319153, 144, '2015-01-15 00:13:59.000000', 'temperatura', 264.0000, 'ºC'),
	(319154, 144, '2015-01-15 00:14:00.000000', 'temperatura', 709.0000, 'ºC'),
	(319155, 144, '2015-01-15 00:14:01.000000', 'temperatura', 351.0000, 'ºC'),
	(319156, 144, '2015-01-15 00:14:02.000000', 'temperatura', 829.0000, 'ºC'),
	(319157, 144, '2015-01-15 00:14:03.000000', 'temperatura', 691.0000, 'ºC'),
	(319158, 144, '2015-01-15 00:14:04.000000', 'temperatura', 969.0000, 'ºC'),
	(319159, 144, '2015-01-15 00:14:05.000000', 'temperatura', 372.0000, 'ºC'),
	(319160, 144, '2015-01-15 00:14:06.000000', 'temperatura', 156.0000, 'ºC'),
	(319161, 144, '2015-01-15 00:14:07.000000', 'temperatura', 861.0000, 'ºC'),
	(319162, 144, '2015-01-15 00:14:08.000000', 'temperatura', 241.0000, 'ºC'),
	(319163, 144, '2015-01-15 00:14:09.000000', 'temperatura', 1021.0000, 'ºC'),
	(319164, 144, '2015-01-15 00:14:10.000000', 'temperatura', 782.0000, 'ºC'),
	(319165, 144, '2015-01-15 00:14:11.000000', 'temperatura', 847.0000, 'ºC'),
	(319166, 144, '2015-01-15 00:14:12.000000', 'temperatura', 691.0000, 'ºC'),
	(319167, 144, '2015-01-15 00:14:13.000000', 'temperatura', 913.0000, 'ºC'),
	(319168, 144, '2015-01-15 00:14:14.000000', 'temperatura', 95.0000, 'ºC'),
	(319169, 144, '2015-01-15 00:14:15.000000', 'temperatura', 136.0000, 'ºC'),
	(319170, 144, '2015-01-15 00:14:16.000000', 'temperatura', 396.0000, 'ºC'),
	(319171, 144, '2015-01-15 00:14:17.000000', 'temperatura', 374.0000, 'ºC'),
	(319172, 144, '2015-01-15 00:14:18.000000', 'temperatura', 680.0000, 'ºC'),
	(319173, 144, '2015-01-15 00:14:19.000000', 'temperatura', 1081.0000, 'ºC'),
	(319174, 144, '2015-01-15 00:14:20.000000', 'temperatura', 963.0000, 'ºC'),
	(319175, 144, '2015-01-15 00:14:21.000000', 'temperatura', 373.0000, 'ºC'),
	(319176, 144, '2015-01-15 00:14:22.000000', 'temperatura', 178.0000, 'ºC'),
	(319177, 144, '2015-01-15 00:14:23.000000', 'temperatura', 969.0000, 'ºC'),
	(319178, 144, '2015-01-15 00:14:24.000000', 'temperatura', 714.0000, 'ºC'),
	(319179, 144, '2015-01-15 00:14:25.000000', 'temperatura', 661.0000, 'ºC'),
	(319180, 144, '2015-01-15 00:14:26.000000', 'temperatura', 1163.0000, 'ºC'),
	(319181, 144, '2015-01-15 00:14:27.000000', 'temperatura', 232.0000, 'ºC'),
	(319182, 144, '2015-01-15 00:14:28.000000', 'temperatura', 71.0000, 'ºC'),
	(319183, 144, '2015-01-15 00:14:29.000000', 'temperatura', 861.0000, 'ºC'),
	(319184, 144, '2015-01-15 00:14:30.000000', 'temperatura', 494.0000, 'ºC'),
	(319185, 144, '2015-01-15 00:14:31.000000', 'temperatura', 1086.0000, 'ºC'),
	(319186, 144, '2015-01-15 00:14:32.000000', 'temperatura', 349.0000, 'ºC'),
	(319187, 144, '2015-01-15 00:14:33.000000', 'temperatura', 888.0000, 'ºC'),
	(319188, 144, '2015-01-15 00:14:34.000000', 'temperatura', 992.0000, 'ºC'),
	(319189, 144, '2015-01-15 00:14:35.000000', 'temperatura', 1096.0000, 'ºC'),
	(319190, 144, '2015-01-15 00:14:36.000000', 'temperatura', 104.0000, 'ºC'),
	(319191, 144, '2015-01-15 00:14:37.000000', 'temperatura', 833.0000, 'ºC'),
	(319192, 144, '2015-01-15 00:14:38.000000', 'temperatura', 255.0000, 'ºC'),
	(319193, 144, '2015-01-15 00:14:39.000000', 'temperatura', 1176.0000, 'ºC'),
	(319194, 144, '2015-01-15 00:14:40.000000', 'temperatura', 316.0000, 'ºC'),
	(319195, 144, '2015-01-15 00:14:41.000000', 'temperatura', 453.0000, 'ºC'),
	(319196, 144, '2015-01-15 00:14:42.000000', 'temperatura', 118.0000, 'ºC'),
	(319197, 144, '2015-01-15 00:14:43.000000', 'temperatura', 431.0000, 'ºC'),
	(319198, 144, '2015-01-15 00:14:44.000000', 'temperatura', 600.0000, 'ºC'),
	(319199, 144, '2015-01-15 00:14:45.000000', 'temperatura', 509.0000, 'ºC'),
	(319200, 144, '2015-01-15 00:14:46.000000', 'temperatura', 744.0000, 'ºC'),
	(319201, 144, '2015-01-15 00:14:47.000000', 'temperatura', 994.0000, 'ºC'),
	(319202, 144, '2015-01-15 00:14:48.000000', 'temperatura', 337.0000, 'ºC'),
	(319203, 144, '2015-01-15 00:14:49.000000', 'temperatura', 1103.0000, 'ºC'),
	(319204, 144, '2015-01-15 00:14:50.000000', 'temperatura', 907.0000, 'ºC'),
	(319205, 144, '2015-01-15 00:14:51.000000', 'temperatura', 27.0000, 'ºC'),
	(319206, 144, '2015-01-15 00:14:52.000000', 'temperatura', 1012.0000, 'ºC'),
	(319207, 144, '2015-01-15 00:14:53.000000', 'temperatura', 181.0000, 'ºC'),
	(319208, 144, '2015-01-15 00:14:54.000000', 'temperatura', 270.0000, 'ºC'),
	(319209, 144, '2015-01-15 00:14:55.000000', 'temperatura', 808.0000, 'ºC'),
	(319210, 144, '2015-01-15 00:14:56.000000', 'temperatura', 830.0000, 'ºC'),
	(319211, 144, '2015-01-15 00:14:57.000000', 'temperatura', 525.0000, 'ºC'),
	(319212, 144, '2015-01-15 00:14:58.000000', 'temperatura', 136.0000, 'ºC'),
	(319213, 144, '2015-01-15 00:14:59.000000', 'temperatura', 306.0000, 'ºC'),
	(319214, 144, '2015-01-15 00:15:00.000000', 'temperatura', 1123.0000, 'ºC'),
	(319215, 144, '2015-01-15 00:15:01.000000', 'temperatura', 1098.0000, 'ºC'),
	(319216, 144, '2015-01-15 00:15:02.000000', 'temperatura', 921.0000, 'ºC'),
	(319217, 144, '2015-01-15 00:15:03.000000', 'temperatura', 110.0000, 'ºC'),
	(319218, 144, '2015-01-15 00:15:04.000000', 'temperatura', 190.0000, 'ºC'),
	(319219, 144, '2015-01-15 00:15:05.000000', 'temperatura', 619.0000, 'ºC'),
	(319220, 144, '2015-01-15 00:15:06.000000', 'temperatura', 126.0000, 'ºC'),
	(319221, 144, '2015-01-15 00:15:07.000000', 'temperatura', 1173.0000, 'ºC'),
	(319222, 144, '2015-01-15 00:15:08.000000', 'temperatura', 688.0000, 'ºC'),
	(319223, 144, '2015-01-15 00:15:09.000000', 'temperatura', 1123.0000, 'ºC'),
	(319224, 144, '2015-01-15 00:15:10.000000', 'temperatura', 1149.0000, 'ºC'),
	(319225, 144, '2015-01-15 00:15:11.000000', 'temperatura', 1180.0000, 'ºC'),
	(319226, 144, '2015-01-15 00:15:12.000000', 'temperatura', 50.0000, 'ºC'),
	(319227, 144, '2015-01-15 00:15:13.000000', 'temperatura', 311.0000, 'ºC'),
	(319228, 144, '2015-01-15 00:15:14.000000', 'temperatura', 207.0000, 'ºC'),
	(319229, 144, '2015-01-15 00:15:15.000000', 'temperatura', 100.0000, 'ºC'),
	(319230, 144, '2015-01-15 00:15:16.000000', 'temperatura', 1079.0000, 'ºC'),
	(319231, 144, '2015-01-15 00:15:17.000000', 'temperatura', 299.0000, 'ºC'),
	(319232, 144, '2015-01-15 00:15:18.000000', 'temperatura', 656.0000, 'ºC'),
	(319233, 144, '2015-01-15 00:15:19.000000', 'temperatura', 1185.0000, 'ºC'),
	(319234, 144, '2015-01-15 00:15:20.000000', 'temperatura', 357.0000, 'ºC'),
	(319235, 144, '2015-01-15 00:15:21.000000', 'temperatura', 629.0000, 'ºC'),
	(319236, 144, '2015-01-15 00:15:22.000000', 'temperatura', 876.0000, 'ºC'),
	(319237, 144, '2015-01-15 00:15:23.000000', 'temperatura', 93.0000, 'ºC'),
	(319238, 144, '2015-01-15 00:15:24.000000', 'temperatura', 237.0000, 'ºC'),
	(319239, 144, '2015-01-15 00:15:25.000000', 'temperatura', 909.0000, 'ºC'),
	(319240, 144, '2015-01-15 00:15:26.000000', 'temperatura', 233.0000, 'ºC'),
	(319241, 144, '2015-01-15 00:15:27.000000', 'temperatura', 840.0000, 'ºC'),
	(319242, 144, '2015-01-15 00:15:28.000000', 'temperatura', 1100.0000, 'ºC'),
	(319243, 144, '2015-01-15 00:15:29.000000', 'temperatura', 580.0000, 'ºC'),
	(319244, 144, '2015-01-15 00:15:30.000000', 'temperatura', 800.0000, 'ºC'),
	(319245, 144, '2015-01-15 00:15:31.000000', 'temperatura', 1061.0000, 'ºC'),
	(319246, 144, '2015-01-15 00:15:32.000000', 'temperatura', 504.0000, 'ºC'),
	(319247, 144, '2015-01-15 00:15:33.000000', 'temperatura', 540.0000, 'ºC'),
	(319248, 144, '2015-01-15 00:15:34.000000', 'temperatura', 1186.0000, 'ºC'),
	(319249, 144, '2015-01-15 00:15:35.000000', 'temperatura', 713.0000, 'ºC'),
	(319250, 144, '2015-01-15 00:15:36.000000', 'temperatura', 8.0000, 'ºC'),
	(319251, 144, '2015-01-15 00:15:37.000000', 'temperatura', 302.0000, 'ºC'),
	(319252, 144, '2015-01-15 00:15:38.000000', 'temperatura', 286.0000, 'ºC'),
	(319253, 144, '2015-01-15 00:15:39.000000', 'temperatura', 524.0000, 'ºC'),
	(319254, 144, '2015-01-15 00:15:40.000000', 'temperatura', 561.0000, 'ºC'),
	(319255, 144, '2015-01-15 00:15:41.000000', 'temperatura', 35.0000, 'ºC'),
	(319256, 144, '2015-01-15 00:15:42.000000', 'temperatura', 894.0000, 'ºC'),
	(319257, 144, '2015-01-15 00:15:43.000000', 'temperatura', 766.0000, 'ºC'),
	(319258, 144, '2015-01-15 00:15:44.000000', 'temperatura', 1146.0000, 'ºC'),
	(319259, 144, '2015-01-15 00:15:45.000000', 'temperatura', 1032.0000, 'ºC'),
	(319260, 144, '2015-01-15 00:15:46.000000', 'temperatura', 522.0000, 'ºC'),
	(319261, 144, '2015-01-15 00:15:47.000000', 'temperatura', 717.0000, 'ºC'),
	(319262, 144, '2015-01-15 00:15:48.000000', 'temperatura', 817.0000, 'ºC'),
	(319263, 144, '2015-01-15 00:15:49.000000', 'temperatura', 735.0000, 'ºC'),
	(319264, 144, '2015-01-15 00:15:50.000000', 'temperatura', 23.0000, 'ºC'),
	(319265, 144, '2015-01-15 00:15:51.000000', 'temperatura', 314.0000, 'ºC'),
	(319266, 144, '2015-01-15 00:15:52.000000', 'temperatura', 299.0000, 'ºC'),
	(319267, 144, '2015-01-15 00:15:53.000000', 'temperatura', 555.0000, 'ºC'),
	(319268, 144, '2015-01-15 00:15:54.000000', 'temperatura', 676.0000, 'ºC'),
	(319269, 144, '2015-01-15 00:15:55.000000', 'temperatura', 518.0000, 'ºC'),
	(319270, 144, '2015-01-15 00:15:56.000000', 'temperatura', 563.0000, 'ºC'),
	(319271, 144, '2015-01-15 00:15:57.000000', 'temperatura', 62.0000, 'ºC'),
	(319272, 144, '2015-01-15 00:15:58.000000', 'temperatura', 1022.0000, 'ºC'),
	(319273, 144, '2015-01-15 00:15:59.000000', 'temperatura', 124.0000, 'ºC'),
	(319274, 144, '2015-01-15 00:16:00.000000', 'temperatura', 1152.0000, 'ºC'),
	(319275, 144, '2015-01-15 00:16:01.000000', 'temperatura', 590.0000, 'ºC'),
	(319276, 144, '2015-01-15 00:16:02.000000', 'temperatura', 695.0000, 'ºC'),
	(319277, 144, '2015-01-15 00:16:03.000000', 'temperatura', 504.0000, 'ºC'),
	(319278, 144, '2015-01-15 00:16:04.000000', 'temperatura', 436.0000, 'ºC'),
	(319279, 144, '2015-01-15 00:16:05.000000', 'temperatura', 667.0000, 'ºC'),
	(319280, 144, '2015-01-15 00:16:06.000000', 'temperatura', 829.0000, 'ºC'),
	(319281, 144, '2015-01-15 00:16:07.000000', 'temperatura', 943.0000, 'ºC'),
	(319282, 144, '2015-01-15 00:16:08.000000', 'temperatura', 1031.0000, 'ºC'),
	(319283, 144, '2015-01-15 00:16:09.000000', 'temperatura', 1124.0000, 'ºC'),
	(319284, 144, '2015-01-15 00:16:10.000000', 'temperatura', 127.0000, 'ºC'),
	(319285, 144, '2015-01-15 00:16:11.000000', 'temperatura', 863.0000, 'ºC'),
	(319286, 144, '2015-01-15 00:16:12.000000', 'temperatura', 336.0000, 'ºC'),
	(319287, 144, '2015-01-15 00:16:13.000000', 'temperatura', 293.0000, 'ºC'),
	(319288, 144, '2015-01-15 00:16:14.000000', 'temperatura', 454.0000, 'ºC'),
	(319289, 144, '2015-01-15 00:16:15.000000', 'temperatura', 194.0000, 'ºC'),
	(319290, 144, '2015-01-15 00:16:16.000000', 'temperatura', 809.0000, 'ºC'),
	(319291, 144, '2015-01-15 00:16:17.000000', 'temperatura', 1064.0000, 'ºC'),
	(319292, 144, '2015-01-15 00:16:18.000000', 'temperatura', 491.0000, 'ºC'),
	(319293, 144, '2015-01-15 00:16:19.000000', 'temperatura', 465.0000, 'ºC'),
	(319294, 144, '2015-01-15 00:16:20.000000', 'temperatura', 853.0000, 'ºC'),
	(319295, 144, '2015-01-15 00:16:21.000000', 'temperatura', 470.0000, 'ºC'),
	(319296, 144, '2015-01-15 00:16:22.000000', 'temperatura', 991.0000, 'ºC'),
	(319297, 144, '2015-01-15 00:16:23.000000', 'temperatura', 1145.0000, 'ºC'),
	(319298, 144, '2015-01-15 00:16:24.000000', 'temperatura', 352.0000, 'ºC'),
	(319299, 144, '2015-01-15 00:16:25.000000', 'temperatura', 728.0000, 'ºC'),
	(319300, 144, '2015-01-15 00:16:26.000000', 'temperatura', 184.0000, 'ºC'),
	(319301, 144, '2015-01-15 00:16:27.000000', 'temperatura', 1138.0000, 'ºC'),
	(319302, 144, '2015-01-15 00:16:28.000000', 'temperatura', 336.0000, 'ºC'),
	(319303, 144, '2015-01-15 00:16:29.000000', 'temperatura', 669.0000, 'ºC'),
	(319304, 144, '2015-01-15 00:16:30.000000', 'temperatura', 1138.0000, 'ºC'),
	(319305, 144, '2015-01-15 00:16:31.000000', 'temperatura', 82.0000, 'ºC'),
	(319306, 144, '2015-01-15 00:16:32.000000', 'temperatura', 596.0000, 'ºC'),
	(319307, 144, '2015-01-15 00:16:33.000000', 'temperatura', 334.0000, 'ºC'),
	(319308, 144, '2015-01-15 00:16:34.000000', 'temperatura', 1084.0000, 'ºC'),
	(319309, 144, '2015-01-15 00:16:35.000000', 'temperatura', 820.0000, 'ºC'),
	(319310, 144, '2015-01-15 00:16:36.000000', 'temperatura', 847.0000, 'ºC'),
	(319311, 144, '2015-01-15 00:16:37.000000', 'temperatura', 574.0000, 'ºC'),
	(319312, 144, '2015-01-15 00:16:38.000000', 'temperatura', 331.0000, 'ºC'),
	(319313, 144, '2015-01-15 00:16:39.000000', 'temperatura', 1134.0000, 'ºC'),
	(319314, 144, '2015-01-15 00:16:40.000000', 'temperatura', 1077.0000, 'ºC'),
	(319315, 144, '2015-01-15 00:16:41.000000', 'temperatura', 786.0000, 'ºC'),
	(319316, 144, '2015-01-15 00:16:42.000000', 'temperatura', 696.0000, 'ºC'),
	(319317, 144, '2015-01-15 00:16:43.000000', 'temperatura', 1122.0000, 'ºC'),
	(319318, 144, '2015-01-15 00:16:44.000000', 'temperatura', 1125.0000, 'ºC'),
	(319319, 144, '2015-01-15 00:16:45.000000', 'temperatura', 1057.0000, 'ºC'),
	(319320, 144, '2015-01-15 00:16:46.000000', 'temperatura', 711.0000, 'ºC'),
	(319321, 144, '2015-01-15 00:16:47.000000', 'temperatura', 385.0000, 'ºC'),
	(319322, 144, '2015-01-15 00:16:48.000000', 'temperatura', 991.0000, 'ºC'),
	(319323, 144, '2015-01-15 00:16:49.000000', 'temperatura', 203.0000, 'ºC'),
	(319324, 144, '2015-01-15 00:16:50.000000', 'temperatura', 440.0000, 'ºC'),
	(319325, 144, '2015-01-15 00:16:51.000000', 'temperatura', 391.0000, 'ºC'),
	(319326, 144, '2015-01-15 00:16:52.000000', 'temperatura', 636.0000, 'ºC'),
	(319327, 144, '2015-01-15 00:16:53.000000', 'temperatura', 806.0000, 'ºC'),
	(319328, 144, '2015-01-15 00:16:54.000000', 'temperatura', 925.0000, 'ºC'),
	(319329, 144, '2015-01-15 00:16:55.000000', 'temperatura', 1008.0000, 'ºC'),
	(319330, 144, '2015-01-15 00:16:56.000000', 'temperatura', 1064.0000, 'ºC'),
	(319331, 144, '2015-01-15 00:16:57.000000', 'temperatura', 1098.0000, 'ºC'),
	(319332, 144, '2015-01-15 00:16:58.000000', 'temperatura', 1099.0000, 'ºC'),
	(319333, 144, '2015-01-15 00:16:59.000000', 'temperatura', 999.0000, 'ºC'),
	(319334, 144, '2015-01-15 00:17:00.000000', 'temperatura', 501.0000, 'ºC'),
	(319335, 144, '2015-01-15 00:17:01.000000', 'temperatura', 708.0000, 'ºC'),
	(319336, 144, '2015-01-15 00:17:02.000000', 'temperatura', 837.0000, 'ºC'),
	(319337, 144, '2015-01-15 00:17:03.000000', 'temperatura', 860.0000, 'ºC'),
	(319338, 144, '2015-01-15 00:17:04.000000', 'temperatura', 590.0000, 'ºC'),
	(319339, 144, '2015-01-15 00:17:05.000000', 'temperatura', 372.0000, 'ºC'),
	(319340, 144, '2015-01-15 00:17:06.000000', 'temperatura', 91.0000, 'ºC'),
	(319341, 144, '2015-01-15 00:17:07.000000', 'temperatura', 539.0000, 'ºC'),
	(319342, 144, '2015-01-15 00:17:08.000000', 'temperatura', 22.0000, 'ºC'),
	(319343, 144, '2015-01-15 00:17:09.000000', 'temperatura', 894.0000, 'ºC'),
	(319344, 144, '2015-01-15 00:17:10.000000', 'temperatura', 803.0000, 'ºC'),
	(319345, 144, '2015-01-15 00:17:11.000000', 'temperatura', 135.0000, 'ºC'),
	(319346, 144, '2015-01-15 00:17:12.000000', 'temperatura', 667.0000, 'ºC'),
	(319347, 144, '2015-01-15 00:17:13.000000', 'temperatura', 529.0000, 'ºC'),
	(319348, 144, '2015-01-15 00:17:14.000000', 'temperatura', 645.0000, 'ºC'),
	(319349, 144, '2015-01-15 00:17:15.000000', 'temperatura', 437.0000, 'ºC'),
	(319350, 144, '2015-01-15 00:17:16.000000', 'temperatura', 252.0000, 'ºC'),
	(319351, 144, '2015-01-15 00:17:17.000000', 'temperatura', 1147.0000, 'ºC'),
	(319352, 144, '2015-01-15 00:17:18.000000', 'temperatura', 182.0000, 'ºC'),
	(319353, 144, '2015-01-15 00:17:19.000000', 'temperatura', 1068.0000, 'ºC'),
	(319354, 144, '2015-01-15 00:17:20.000000', 'temperatura', 1197.0000, 'ºC'),
	(319355, 144, '2015-01-15 00:17:21.000000', 'temperatura', 379.0000, 'ºC'),
	(319356, 144, '2015-01-15 00:17:22.000000', 'temperatura', 703.0000, 'ºC'),
	(319357, 144, '2015-01-15 00:17:23.000000', 'temperatura', 1182.0000, 'ºC'),
	(319358, 144, '2015-01-15 00:17:24.000000', 'temperatura', 198.0000, 'ºC'),
	(319359, 144, '2015-01-15 00:17:25.000000', 'temperatura', 1048.0000, 'ºC'),
	(319360, 144, '2015-01-15 00:17:26.000000', 'temperatura', 1045.0000, 'ºC'),
	(319361, 144, '2015-01-15 00:17:27.000000', 'temperatura', 880.0000, 'ºC'),
	(319362, 144, '2015-01-15 00:17:28.000000', 'temperatura', 68.0000, 'ºC'),
	(319363, 144, '2015-01-15 00:17:29.000000', 'temperatura', 101.0000, 'ºC'),
	(319364, 144, '2015-01-15 00:17:30.000000', 'temperatura', 301.0000, 'ºC'),
	(319365, 144, '2015-01-15 00:17:31.000000', 'temperatura', 3.0000, 'ºC'),
	(319366, 144, '2015-01-15 00:17:32.000000', 'temperatura', 310.0000, 'ºC'),
	(319367, 144, '2015-01-15 00:17:33.000000', 'temperatura', 344.0000, 'ºC'),
	(319368, 144, '2015-01-15 00:17:34.000000', 'temperatura', 791.0000, 'ºC'),
	(319369, 144, '2015-01-15 00:17:35.000000', 'temperatura', 522.0000, 'ºC'),
	(319370, 144, '2015-01-15 00:17:36.000000', 'temperatura', 239.0000, 'ºC'),
	(319371, 144, '2015-01-15 00:17:37.000000', 'temperatura', 830.0000, 'ºC'),
	(319372, 144, '2015-01-15 00:17:38.000000', 'temperatura', 1035.0000, 'ºC'),
	(319373, 144, '2015-01-15 00:17:39.000000', 'temperatura', 282.0000, 'ºC'),
	(319374, 144, '2015-01-15 00:17:40.000000', 'temperatura', 708.0000, 'ºC'),
	(319375, 144, '2015-01-15 00:17:41.000000', 'temperatura', 294.0000, 'ºC'),
	(319376, 144, '2015-01-15 00:17:42.000000', 'temperatura', 544.0000, 'ºC'),
	(319377, 144, '2015-01-15 00:17:43.000000', 'temperatura', 641.0000, 'ºC'),
	(319378, 144, '2015-01-15 00:17:44.000000', 'temperatura', 374.0000, 'ºC'),
	(319379, 144, '2015-01-15 00:17:45.000000', 'temperatura', 1147.0000, 'ºC'),
	(319380, 144, '2015-01-15 00:17:46.000000', 'temperatura', 1014.0000, 'ºC'),
	(319381, 144, '2015-01-15 00:17:47.000000', 'temperatura', 430.0000, 'ºC'),
	(319382, 144, '2015-01-15 00:17:48.000000', 'temperatura', 307.0000, 'ºC'),
	(319383, 144, '2015-01-15 00:17:49.000000', 'temperatura', 244.0000, 'ºC'),
	(319384, 144, '2015-01-15 00:17:50.000000', 'temperatura', 302.0000, 'ºC'),
	(319385, 144, '2015-01-15 00:17:51.000000', 'temperatura', 780.0000, 'ºC'),
	(319386, 144, '2015-01-15 00:17:52.000000', 'temperatura', 591.0000, 'ºC'),
	(319387, 144, '2015-01-15 00:17:53.000000', 'temperatura', 616.0000, 'ºC'),
	(319388, 144, '2015-01-15 00:17:54.000000', 'temperatura', 110.0000, 'ºC'),
	(319389, 144, '2015-01-15 00:17:55.000000', 'temperatura', 1101.0000, 'ºC'),
	(319390, 144, '2015-01-15 00:17:56.000000', 'temperatura', 377.0000, 'ºC'),
	(319391, 144, '2015-01-15 00:17:57.000000', 'temperatura', 981.0000, 'ºC'),
	(319392, 144, '2015-01-15 00:17:58.000000', 'temperatura', 176.0000, 'ºC'),
	(319393, 144, '2015-01-15 00:17:59.000000', 'temperatura', 338.0000, 'ºC'),
	(319394, 144, '2015-01-15 00:18:00.000000', 'temperatura', 1161.0000, 'ºC'),
	(319395, 144, '2015-01-15 00:18:01.000000', 'temperatura', 1192.0000, 'ºC'),
	(319396, 144, '2015-01-15 00:18:02.000000', 'temperatura', 78.0000, 'ºC'),
	(319397, 144, '2015-01-15 00:18:03.000000', 'temperatura', 413.0000, 'ºC'),
	(319398, 144, '2015-01-15 00:18:04.000000', 'temperatura', 630.0000, 'ºC'),
	(319399, 144, '2015-01-15 00:18:05.000000', 'temperatura', 715.0000, 'ºC'),
	(319400, 144, '2015-01-15 00:18:06.000000', 'temperatura', 484.0000, 'ºC'),
	(319401, 144, '2015-01-15 00:18:07.000000', 'temperatura', 276.0000, 'ºC'),
	(319402, 144, '2015-01-15 00:18:08.000000', 'temperatura', 1128.0000, 'ºC'),
	(319403, 144, '2015-01-15 00:18:09.000000', 'temperatura', 13.0000, 'ºC'),
	(319404, 144, '2015-01-15 00:18:10.000000', 'temperatura', 282.0000, 'ºC'),
	(319405, 144, '2015-01-15 00:18:11.000000', 'temperatura', 169.0000, 'ºC'),
	(319406, 144, '2015-01-15 00:18:12.000000', 'temperatura', 0.0000, 'ºC'),
	(319407, 144, '2015-01-15 00:18:13.000000', 'temperatura', 696.0000, 'ºC'),
	(319408, 144, '2015-01-15 00:18:14.000000', 'temperatura', 1077.0000, 'ºC'),
	(319409, 144, '2015-01-15 00:18:15.000000', 'temperatura', 901.0000, 'ºC'),
	(319410, 144, '2015-01-15 00:18:16.000000', 'temperatura', 73.0000, 'ºC'),
	(319411, 144, '2015-01-15 00:18:17.000000', 'temperatura', 63.0000, 'ºC'),
	(319412, 144, '2015-01-15 00:18:18.000000', 'temperatura', 96.0000, 'ºC'),
	(319413, 144, '2015-01-15 00:18:19.000000', 'temperatura', 293.0000, 'ºC'),
	(319414, 144, '2015-01-15 00:18:20.000000', 'temperatura', 1176.0000, 'ºC'),
	(319415, 144, '2015-01-15 00:18:21.000000', 'temperatura', 200.0000, 'ºC'),
	(319416, 144, '2015-01-15 00:18:22.000000', 'temperatura', 1074.0000, 'ºC'),
	(319417, 144, '2015-01-15 00:18:23.000000', 'temperatura', 1169.0000, 'ºC'),
	(319418, 144, '2015-01-15 00:18:24.000000', 'temperatura', 224.0000, 'ºC'),
	(319419, 144, '2015-01-15 00:18:25.000000', 'temperatura', 13.0000, 'ºC'),
	(319420, 144, '2015-01-15 00:18:26.000000', 'temperatura', 595.0000, 'ºC'),
	(319421, 144, '2015-01-15 00:18:27.000000', 'temperatura', 536.0000, 'ºC'),
	(319422, 144, '2015-01-15 00:18:28.000000', 'temperatura', 894.0000, 'ºC'),
	(319423, 144, '2015-01-15 00:18:29.000000', 'temperatura', 462.0000, 'ºC'),
	(319424, 144, '2015-01-15 00:18:30.000000', 'temperatura', 829.0000, 'ºC'),
	(319425, 144, '2015-01-15 00:18:31.000000', 'temperatura', 360.0000, 'ºC'),
	(319426, 144, '2015-01-15 00:18:32.000000', 'temperatura', 515.0000, 'ºC'),
	(319427, 144, '2015-01-15 00:18:33.000000', 'temperatura', 296.0000, 'ºC'),
	(319428, 144, '2015-01-15 00:18:34.000000', 'temperatura', 1133.0000, 'ºC'),
	(319429, 144, '2015-01-15 00:18:35.000000', 'temperatura', 1181.0000, 'ºC'),
	(319430, 144, '2015-01-15 00:18:36.000000', 'temperatura', 103.0000, 'ºC'),
	(319431, 144, '2015-01-15 00:18:37.000000', 'temperatura', 573.0000, 'ºC'),
	(319432, 144, '2015-01-15 00:18:38.000000', 'temperatura', 158.0000, 'ºC'),
	(319433, 144, '2015-01-15 00:18:39.000000', 'temperatura', 272.0000, 'ºC'),
	(319434, 144, '2015-01-15 00:18:40.000000', 'temperatura', 885.0000, 'ºC'),
	(319435, 144, '2015-01-15 00:18:41.000000', 'temperatura', 9.0000, 'ºC'),
	(319436, 144, '2015-01-15 00:18:42.000000', 'temperatura', 992.0000, 'ºC'),
	(319437, 144, '2015-01-15 00:18:43.000000', 'temperatura', 134.0000, 'ºC'),
	(319438, 144, '2015-01-15 00:18:44.000000', 'temperatura', 93.0000, 'ºC'),
	(319439, 144, '2015-01-15 00:18:45.000000', 'temperatura', 66.0000, 'ºC'),
	(319440, 144, '2015-01-15 00:18:46.000000', 'temperatura', 50.0000, 'ºC'),
	(319441, 144, '2015-01-15 00:18:47.000000', 'temperatura', 52.0000, 'ºC'),
	(319442, 144, '2015-01-15 00:18:48.000000', 'temperatura', 112.0000, 'ºC'),
	(319443, 144, '2015-01-15 00:18:49.000000', 'temperatura', 405.0000, 'ºC'),
	(319444, 144, '2015-01-15 00:18:50.000000', 'temperatura', 490.0000, 'ºC'),
	(319445, 144, '2015-01-15 00:18:51.000000', 'temperatura', 33.0000, 'ºC'),
	(319446, 144, '2015-01-15 00:18:52.000000', 'temperatura', 1096.0000, 'ºC'),
	(319447, 144, '2015-01-15 00:18:53.000000', 'temperatura', 583.0000, 'ºC'),
	(319448, 144, '2015-01-15 00:18:54.000000', 'temperatura', 826.0000, 'ºC'),
	(319449, 144, '2015-01-15 00:18:55.000000', 'temperatura', 1182.0000, 'ºC'),
	(319450, 144, '2015-01-15 00:18:56.000000', 'temperatura', 1031.0000, 'ºC'),
	(319451, 144, '2015-01-15 00:18:57.000000', 'temperatura', 409.0000, 'ºC'),
	(319452, 144, '2015-01-15 00:18:58.000000', 'temperatura', 155.0000, 'ºC'),
	(319453, 144, '2015-01-15 00:18:59.000000', 'temperatura', 748.0000, 'ºC'),
	(319454, 144, '2015-01-15 00:19:00.000000', 'temperatura', 876.0000, 'ºC'),
	(319455, 144, '2015-01-15 00:19:01.000000', 'temperatura', 935.0000, 'ºC'),
	(319456, 144, '2015-01-15 00:19:02.000000', 'temperatura', 848.0000, 'ºC'),
	(319457, 144, '2015-01-15 00:19:03.000000', 'temperatura', 233.0000, 'ºC'),
	(319458, 144, '2015-01-15 00:19:04.000000', 'temperatura', 1025.0000, 'ºC'),
	(319459, 144, '2015-01-15 00:19:05.000000', 'temperatura', 827.0000, 'ºC'),
	(319460, 144, '2015-01-15 00:19:06.000000', 'temperatura', 1058.0000, 'ºC'),
	(319461, 144, '2015-01-15 00:19:07.000000', 'temperatura', 410.0000, 'ºC'),
	(319462, 144, '2015-01-15 00:19:08.000000', 'temperatura', 76.0000, 'ºC'),
	(319463, 144, '2015-01-15 00:19:09.000000', 'temperatura', 351.0000, 'ºC'),
	(319464, 144, '2015-01-15 00:19:10.000000', 'temperatura', 327.0000, 'ºC'),
	(319465, 144, '2015-01-15 00:19:11.000000', 'temperatura', 583.0000, 'ºC'),
	(319466, 144, '2015-01-15 00:19:12.000000', 'temperatura', 733.0000, 'ºC'),
	(319467, 144, '2015-01-15 00:19:13.000000', 'temperatura', 715.0000, 'ºC'),
	(319468, 144, '2015-01-15 00:19:14.000000', 'temperatura', 180.0000, 'ºC'),
	(319469, 144, '2015-01-15 00:19:15.000000', 'temperatura', 1154.0000, 'ºC'),
	(319470, 144, '2015-01-15 00:19:16.000000', 'temperatura', 429.0000, 'ºC'),
	(319471, 144, '2015-01-15 00:19:17.000000', 'temperatura', 1086.0000, 'ºC'),
	(319472, 144, '2015-01-15 00:19:18.000000', 'temperatura', 543.0000, 'ºC'),
	(319473, 144, '2015-01-15 00:19:19.000000', 'temperatura', 656.0000, 'ºC'),
	(319474, 144, '2015-01-15 00:19:20.000000', 'temperatura', 452.0000, 'ºC'),
	(319475, 144, '2015-01-15 00:19:21.000000', 'temperatura', 295.0000, 'ºC'),
	(319476, 144, '2015-01-15 00:19:22.000000', 'temperatura', 117.0000, 'ºC'),
	(319477, 144, '2015-01-15 00:19:23.000000', 'temperatura', 900.0000, 'ºC'),
	(319478, 144, '2015-01-15 00:19:24.000000', 'temperatura', 549.0000, 'ºC'),
	(319479, 144, '2015-01-15 00:19:25.000000', 'temperatura', 45.0000, 'ºC'),
	(319480, 144, '2015-01-15 00:19:26.000000', 'temperatura', 980.0000, 'ºC'),
	(319481, 144, '2015-01-15 00:19:27.000000', 'temperatura', 1167.0000, 'ºC'),
	(319482, 144, '2015-01-15 00:19:28.000000', 'temperatura', 495.0000, 'ºC'),
	(319483, 144, '2015-01-15 00:19:29.000000', 'temperatura', 174.0000, 'ºC'),
	(319484, 144, '2015-01-15 00:19:30.000000', 'temperatura', 587.0000, 'ºC'),
	(319485, 144, '2015-01-15 00:19:31.000000', 'temperatura', 14.0000, 'ºC'),
	(319486, 144, '2015-01-15 00:19:32.000000', 'temperatura', 708.0000, 'ºC'),
	(319487, 144, '2015-01-15 00:19:33.000000', 'temperatura', 1097.0000, 'ºC'),
	(319488, 144, '2015-01-15 00:19:34.000000', 'temperatura', 964.0000, 'ºC'),
	(319489, 144, '2015-01-15 00:19:35.000000', 'temperatura', 330.0000, 'ºC'),
	(319490, 144, '2015-01-15 00:19:36.000000', 'temperatura', 1159.0000, 'ºC'),
	(319491, 144, '2015-01-15 00:19:37.000000', 'temperatura', 6.0000, 'ºC'),
	(319492, 144, '2015-01-15 00:19:38.000000', 'temperatura', 153.0000, 'ºC'),
	(319493, 144, '2015-01-15 00:19:39.000000', 'temperatura', 746.0000, 'ºC'),
	(319494, 144, '2015-01-15 00:19:40.000000', 'temperatura', 873.0000, 'ºC'),
	(319495, 144, '2015-01-15 00:19:41.000000', 'temperatura', 926.0000, 'ºC'),
	(319496, 144, '2015-01-15 00:19:42.000000', 'temperatura', 814.0000, 'ºC'),
	(319497, 144, '2015-01-15 00:19:43.000000', 'temperatura', 92.0000, 'ºC'),
	(319498, 144, '2015-01-15 00:19:44.000000', 'temperatura', 419.0000, 'ºC'),
	(319499, 144, '2015-01-15 00:19:45.000000', 'temperatura', 617.0000, 'ºC'),
	(319500, 144, '2015-01-15 00:19:46.000000', 'temperatura', 630.0000, 'ºC'),
	(319501, 144, '2015-01-15 00:19:47.000000', 'temperatura', 98.0000, 'ºC'),
	(319502, 144, '2015-01-15 00:19:48.000000', 'temperatura', 1002.0000, 'ºC'),
	(319503, 144, '2015-01-15 00:19:49.000000', 'temperatura', 1117.0000, 'ºC'),
	(319504, 144, '2015-01-15 00:19:50.000000', 'temperatura', 178.0000, 'ºC'),
	(319505, 144, '2015-01-15 00:19:51.000000', 'temperatura', 1141.0000, 'ºC'),
	(319506, 144, '2015-01-15 00:19:52.000000', 'temperatura', 371.0000, 'ºC'),
	(319507, 144, '2015-01-15 00:19:53.000000', 'temperatura', 832.0000, 'ºC'),
	(319508, 144, '2015-01-15 00:19:54.000000', 'temperatura', 649.0000, 'ºC'),
	(319509, 144, '2015-01-15 00:19:55.000000', 'temperatura', 748.0000, 'ºC'),
	(319510, 144, '2015-01-15 00:19:56.000000', 'temperatura', 595.0000, 'ºC'),
	(319511, 144, '2015-01-15 00:19:57.000000', 'temperatura', 733.0000, 'ºC'),
	(319512, 144, '2015-01-15 00:19:58.000000', 'temperatura', 677.0000, 'ºC'),
	(319513, 144, '2015-01-15 00:19:59.000000', 'temperatura', 1188.0000, 'ºC'),
	(319514, 144, '2015-01-15 00:20:00.000000', 'temperatura', 310.0000, 'ºC'),
	(319515, 144, '2015-01-15 00:20:01.000000', 'temperatura', 385.0000, 'ºC'),
	(319516, 144, '2015-01-15 00:20:02.000000', 'temperatura', 996.0000, 'ºC'),
	(319517, 144, '2015-01-15 00:20:03.000000', 'temperatura', 228.0000, 'ºC'),
	(319518, 144, '2015-01-15 00:20:04.000000', 'temperatura', 550.0000, 'ºC'),
	(319519, 144, '2015-01-15 00:20:05.000000', 'temperatura', 867.0000, 'ºC'),
	(319520, 144, '2015-01-15 00:20:06.000000', 'temperatura', 285.0000, 'ºC'),
	(319521, 144, '2015-01-15 00:20:07.000000', 'temperatura', 27.0000, 'ºC'),
	(319522, 144, '2015-01-15 00:20:08.000000', 'temperatura', 477.0000, 'ºC'),
	(319523, 144, '2015-01-15 00:20:09.000000', 'temperatura', 1106.0000, 'ºC'),
	(319524, 144, '2015-01-15 00:20:10.000000', 'temperatura', 501.0000, 'ºC'),
	(319525, 144, '2015-01-15 00:20:11.000000', 'temperatura', 384.0000, 'ºC'),
	(319526, 144, '2015-01-15 00:20:12.000000', 'temperatura', 421.0000, 'ºC'),
	(319527, 144, '2015-01-15 00:20:13.000000', 'temperatura', 953.0000, 'ºC'),
	(319528, 144, '2015-01-15 00:20:14.000000', 'temperatura', 1101.0000, 'ºC'),
	(319529, 144, '2015-01-15 00:20:15.000000', 'temperatura', 246.0000, 'ºC'),
	(319530, 144, '2015-01-15 00:20:16.000000', 'temperatura', 330.0000, 'ºC'),
	(319531, 144, '2015-01-15 00:20:17.000000', 'temperatura', 912.0000, 'ºC'),
	(319532, 144, '2015-01-15 00:20:18.000000', 'temperatura', 1171.0000, 'ºC'),
	(319533, 144, '2015-01-15 00:20:19.000000', 'temperatura', 717.0000, 'ºC'),
	(319534, 144, '2015-01-15 00:20:20.000000', 'temperatura', 73.0000, 'ºC'),
	(319535, 144, '2015-01-15 00:20:21.000000', 'temperatura', 614.0000, 'ºC'),
	(319536, 144, '2015-01-15 00:20:22.000000', 'temperatura', 452.0000, 'ºC'),
	(319537, 144, '2015-01-15 00:20:23.000000', 'temperatura', 418.0000, 'ºC'),
	(319538, 144, '2015-01-15 00:20:24.000000', 'temperatura', 736.0000, 'ºC'),
	(319539, 144, '2015-01-15 00:20:25.000000', 'temperatura', 27.0000, 'ºC'),
	(319540, 144, '2015-01-15 00:20:26.000000', 'temperatura', 326.0000, 'ºC'),
	(319541, 144, '2015-01-15 00:20:27.000000', 'temperatura', 350.0000, 'ºC'),
	(319542, 144, '2015-01-15 00:20:28.000000', 'temperatura', 772.0000, 'ºC'),
	(319543, 144, '2015-01-15 00:20:29.000000', 'temperatura', 411.0000, 'ºC'),
	(319544, 144, '2015-01-15 00:20:30.000000', 'temperatura', 939.0000, 'ºC'),
	(319545, 144, '2015-01-15 00:20:31.000000', 'temperatura', 1061.0000, 'ºC'),
	(319546, 144, '2015-01-15 00:20:32.000000', 'temperatura', 89.0000, 'ºC'),
	(319547, 144, '2015-01-15 00:20:33.000000', 'temperatura', 863.0000, 'ºC'),
	(319548, 144, '2015-01-15 00:20:34.000000', 'temperatura', 448.0000, 'ºC'),
	(319549, 144, '2015-01-15 00:20:35.000000', 'temperatura', 851.0000, 'ºC'),
	(319550, 144, '2015-01-15 00:20:36.000000', 'temperatura', 513.0000, 'ºC'),
	(319551, 144, '2015-01-15 00:20:37.000000', 'temperatura', 10.0000, 'ºC'),
	(319552, 144, '2015-01-15 00:20:38.000000', 'temperatura', 913.0000, 'ºC'),
	(319553, 144, '2015-01-15 00:20:39.000000', 'temperatura', 934.0000, 'ºC'),
	(319554, 144, '2015-01-15 00:20:40.000000', 'temperatura', 734.0000, 'ºC'),
	(319555, 144, '2015-01-15 00:20:41.000000', 'temperatura', 868.0000, 'ºC'),
	(319556, 144, '2015-01-15 00:20:42.000000', 'temperatura', 940.0000, 'ºC'),
	(319557, 144, '2015-01-15 00:20:43.000000', 'temperatura', 896.0000, 'ºC'),
	(319558, 144, '2015-01-15 00:20:44.000000', 'temperatura', 459.0000, 'ºC'),
	(319559, 144, '2015-01-15 00:20:45.000000', 'temperatura', 808.0000, 'ºC'),
	(319560, 144, '2015-01-15 00:20:46.000000', 'temperatura', 264.0000, 'ºC'),
	(319561, 144, '2015-01-15 00:20:47.000000', 'temperatura', 95.0000, 'ºC'),
	(319562, 144, '2015-01-15 00:20:48.000000', 'temperatura', 884.0000, 'ºC'),
	(319563, 144, '2015-01-15 00:20:49.000000', 'temperatura', 535.0000, 'ºC'),
	(319564, 144, '2015-01-15 00:20:50.000000', 'temperatura', 26.0000, 'ºC'),
	(319565, 144, '2015-01-15 00:20:51.000000', 'temperatura', 923.0000, 'ºC'),
	(319566, 144, '2015-01-15 00:20:52.000000', 'temperatura', 936.0000, 'ºC'),
	(319567, 144, '2015-01-15 00:20:53.000000', 'temperatura', 715.0000, 'ºC'),
	(319568, 144, '2015-01-15 00:20:54.000000', 'temperatura', 766.0000, 'ºC'),
	(319569, 144, '2015-01-15 00:20:55.000000', 'temperatura', 488.0000, 'ºC'),
	(319570, 144, '2015-01-15 00:20:56.000000', 'temperatura', 140.0000, 'ºC'),
	(319571, 144, '2015-01-15 00:20:57.000000', 'temperatura', 435.0000, 'ºC'),
	(319572, 144, '2015-01-15 00:20:58.000000', 'temperatura', 558.0000, 'ºC'),
	(319573, 144, '2015-01-15 00:20:59.000000', 'temperatura', 284.0000, 'ºC'),
	(319574, 144, '2015-01-15 00:21:00.000000', 'temperatura', 946.0000, 'ºC'),
	(319575, 144, '2015-01-15 00:21:01.000000', 'temperatura', 278.0000, 'ºC'),
	(319576, 144, '2015-01-15 00:21:02.000000', 'temperatura', 951.0000, 'ºC'),
	(319577, 144, '2015-01-15 00:21:03.000000', 'temperatura', 324.0000, 'ºC'),
	(319578, 144, '2015-01-15 00:21:04.000000', 'temperatura', 1167.0000, 'ºC'),
	(319579, 144, '2015-01-15 00:21:05.000000', 'temperatura', 65.0000, 'ºC'),
	(319580, 144, '2015-01-15 00:21:06.000000', 'temperatura', 424.0000, 'ºC'),
	(319581, 144, '2015-01-15 00:21:07.000000', 'temperatura', 723.0000, 'ºC'),
	(319582, 144, '2015-01-15 00:21:08.000000', 'temperatura', 1145.0000, 'ºC'),
	(319583, 144, '2015-01-15 00:21:09.000000', 'temperatura', 1156.0000, 'ºC'),
	(319584, 144, '2015-01-15 00:21:10.000000', 'temperatura', 1146.0000, 'ºC'),
	(319585, 144, '2015-01-15 00:21:11.000000', 'temperatura', 1062.0000, 'ºC'),
	(319586, 144, '2015-01-15 00:21:12.000000', 'temperatura', 674.0000, 'ºC'),
	(319587, 144, '2015-01-15 00:21:13.000000', 'temperatura', 184.0000, 'ºC'),
	(319588, 144, '2015-01-15 00:21:14.000000', 'temperatura', 100.0000, 'ºC'),
	(319589, 144, '2015-01-15 00:21:15.000000', 'temperatura', 1147.0000, 'ºC'),
	(319590, 144, '2015-01-15 00:21:16.000000', 'temperatura', 637.0000, 'ºC'),
	(319591, 144, '2015-01-15 00:21:17.000000', 'temperatura', 943.0000, 'ºC'),
	(319592, 144, '2015-01-15 00:21:18.000000', 'temperatura', 405.0000, 'ºC'),
	(319593, 144, '2015-01-15 00:21:19.000000', 'temperatura', 394.0000, 'ºC'),
	(319594, 144, '2015-01-15 00:21:20.000000', 'temperatura', 759.0000, 'ºC'),
	(319595, 144, '2015-01-15 00:21:21.000000', 'temperatura', 213.0000, 'ºC'),
	(319596, 144, '2015-01-15 00:21:22.000000', 'temperatura', 1189.0000, 'ºC'),
	(319597, 144, '2015-01-15 00:21:23.000000', 'temperatura', 505.0000, 'ºC'),
	(319598, 144, '2015-01-15 00:21:24.000000', 'temperatura', 158.0000, 'ºC'),
	(319599, 144, '2015-01-15 00:21:25.000000', 'temperatura', 475.0000, 'ºC'),
	(319600, 144, '2015-01-15 00:21:26.000000', 'temperatura', 701.0000, 'ºC'),
	(319601, 144, '2015-01-15 00:21:27.000000', 'temperatura', 881.0000, 'ºC'),
	(319602, 144, '2015-01-15 00:21:28.000000', 'temperatura', 1101.0000, 'ºC'),
	(319603, 144, '2015-01-15 00:21:29.000000', 'temperatura', 463.0000, 'ºC'),
	(319604, 144, '2015-01-15 00:21:30.000000', 'temperatura', 211.0000, 'ºC'),
	(319605, 144, '2015-01-15 00:21:31.000000', 'temperatura', 869.0000, 'ºC'),
	(319606, 144, '2015-01-15 00:21:32.000000', 'temperatura', 112.0000, 'ºC'),
	(319607, 144, '2015-01-15 00:21:33.000000', 'temperatura', 354.0000, 'ºC'),
	(319608, 144, '2015-01-15 00:21:34.000000', 'temperatura', 233.0000, 'ºC'),
	(319609, 144, '2015-01-15 00:21:35.000000', 'temperatura', 105.0000, 'ºC'),
	(319610, 144, '2015-01-15 00:21:36.000000', 'temperatura', 1027.0000, 'ºC'),
	(319611, 144, '2015-01-15 00:21:37.000000', 'temperatura', 18.0000, 'ºC'),
	(319612, 144, '2015-01-15 00:21:38.000000', 'temperatura', 611.0000, 'ºC'),
	(319613, 144, '2015-01-15 00:21:39.000000', 'temperatura', 601.0000, 'ºC'),
	(319614, 144, '2015-01-15 00:21:40.000000', 'temperatura', 1172.0000, 'ºC'),
	(319615, 144, '2015-01-15 00:21:41.000000', 'temperatura', 459.0000, 'ºC'),
	(319616, 144, '2015-01-15 00:21:42.000000', 'temperatura', 1181.0000, 'ºC'),
	(319617, 144, '2015-01-15 00:21:43.000000', 'temperatura', 926.0000, 'ºC'),
	(319618, 144, '2015-01-15 00:21:44.000000', 'temperatura', 1087.0000, 'ºC'),
	(319619, 144, '2015-01-15 00:21:45.000000', 'temperatura', 258.0000, 'ºC'),
	(319620, 144, '2015-01-15 00:21:46.000000', 'temperatura', 431.0000, 'ºC'),
	(319621, 144, '2015-01-15 00:21:47.000000', 'temperatura', 179.0000, 'ºC'),
	(319622, 144, '2015-01-15 00:21:48.000000', 'temperatura', 802.0000, 'ºC'),
	(319623, 144, '2015-01-15 00:21:49.000000', 'temperatura', 1073.0000, 'ºC'),
	(319624, 144, '2015-01-15 00:21:50.000000', 'temperatura', 560.0000, 'ºC'),
	(319625, 144, '2015-01-15 00:21:51.000000', 'temperatura', 780.0000, 'ºC'),
	(319626, 144, '2015-01-15 00:21:52.000000', 'temperatura', 1023.0000, 'ºC'),
	(319627, 144, '2015-01-15 00:21:53.000000', 'temperatura', 376.0000, 'ºC'),
	(319628, 144, '2015-01-15 00:21:54.000000', 'temperatura', 9.0000, 'ºC'),
	(319629, 144, '2015-01-15 00:21:55.000000', 'temperatura', 118.0000, 'ºC'),
	(319630, 144, '2015-01-15 00:21:56.000000', 'temperatura', 566.0000, 'ºC'),
	(319631, 144, '2015-01-15 00:21:57.000000', 'temperatura', 75.0000, 'ºC'),
	(319632, 144, '2015-01-15 00:21:58.000000', 'temperatura', 1076.0000, 'ºC'),
	(319633, 144, '2015-01-15 00:21:59.000000', 'temperatura', 358.0000, 'ºC'),
	(319634, 144, '2015-01-15 00:22:00.000000', 'temperatura', 961.0000, 'ºC'),
	(319635, 144, '2015-01-15 00:22:01.000000', 'temperatura', 132.0000, 'ºC'),
	(319636, 144, '2015-01-15 00:22:02.000000', 'temperatura', 177.0000, 'ºC'),
	(319637, 144, '2015-01-15 00:22:03.000000', 'temperatura', 491.0000, 'ºC'),
	(319638, 144, '2015-01-15 00:22:04.000000', 'temperatura', 723.0000, 'ºC'),
	(319639, 144, '2015-01-15 00:22:05.000000', 'temperatura', 944.0000, 'ºC'),
	(319640, 144, '2015-01-15 00:22:06.000000', 'temperatura', 153.0000, 'ºC'),
	(319641, 144, '2015-01-15 00:22:07.000000', 'temperatura', 331.0000, 'ºC'),
	(319642, 144, '2015-01-15 00:22:08.000000', 'temperatura', 1197.0000, 'ºC'),
	(319643, 144, '2015-01-15 00:22:09.000000', 'temperatura', 192.0000, 'ºC'),
	(319644, 144, '2015-01-15 00:22:10.000000', 'temperatura', 969.0000, 'ºC'),
	(319645, 144, '2015-01-15 00:22:11.000000', 'temperatura', 672.0000, 'ºC'),
	(319646, 144, '2015-01-15 00:22:12.000000', 'temperatura', 451.0000, 'ºC'),
	(319647, 144, '2015-01-15 00:22:13.000000', 'temperatura', 242.0000, 'ºC'),
	(319648, 144, '2015-01-15 00:22:14.000000', 'temperatura', 1057.0000, 'ºC'),
	(319649, 144, '2015-01-15 00:22:15.000000', 'temperatura', 960.0000, 'ºC'),
	(319650, 144, '2015-01-15 00:22:16.000000', 'temperatura', 427.0000, 'ºC'),
	(319651, 144, '2015-01-15 00:22:17.000000', 'temperatura', 457.0000, 'ºC'),
	(319652, 144, '2015-01-15 00:22:18.000000', 'temperatura', 1003.0000, 'ºC'),
	(319653, 144, '2015-01-15 00:22:19.000000', 'temperatura', 46.0000, 'ºC'),
	(319654, 144, '2015-01-15 00:22:20.000000', 'temperatura', 820.0000, 'ºC'),
	(319655, 144, '2015-01-15 00:22:21.000000', 'temperatura', 365.0000, 'ºC'),
	(319656, 144, '2015-01-15 00:22:22.000000', 'temperatura', 565.0000, 'ºC'),
	(319657, 144, '2015-01-15 00:22:23.000000', 'temperatura', 528.0000, 'ºC'),
	(319658, 144, '2015-01-15 00:22:24.000000', 'temperatura', 947.0000, 'ºC'),
	(319659, 144, '2015-01-15 00:22:25.000000', 'temperatura', 751.0000, 'ºC'),
	(319660, 144, '2015-01-15 00:22:26.000000', 'temperatura', 916.0000, 'ºC'),
	(319661, 144, '2015-01-15 00:22:27.000000', 'temperatura', 1128.0000, 'ºC'),
	(319662, 144, '2015-01-15 00:22:28.000000', 'temperatura', 492.0000, 'ºC'),
	(319663, 144, '2015-01-15 00:22:29.000000', 'temperatura', 276.0000, 'ºC'),
	(319664, 144, '2015-01-15 00:22:30.000000', 'temperatura', 1106.0000, 'ºC'),
	(319665, 144, '2015-01-15 00:22:31.000000', 'temperatura', 1103.0000, 'ºC'),
	(319666, 144, '2015-01-15 00:22:32.000000', 'temperatura', 996.0000, 'ºC'),
	(319667, 144, '2015-01-15 00:22:33.000000', 'temperatura', 471.0000, 'ºC'),
	(319668, 144, '2015-01-15 00:22:34.000000', 'temperatura', 567.0000, 'ºC'),
	(319669, 144, '2015-01-15 00:22:35.000000', 'temperatura', 224.0000, 'ºC'),
	(319670, 144, '2015-01-15 00:22:36.000000', 'temperatura', 620.0000, 'ºC'),
	(319671, 144, '2015-01-15 00:22:37.000000', 'temperatura', 26.0000, 'ºC'),
	(319672, 144, '2015-01-15 00:22:38.000000', 'temperatura', 671.0000, 'ºC'),
	(319673, 144, '2015-01-15 00:22:39.000000', 'temperatura', 876.0000, 'ºC'),
	(319674, 144, '2015-01-15 00:22:40.000000', 'temperatura', 1170.0000, 'ºC'),
	(319675, 144, '2015-01-15 00:22:41.000000', 'temperatura', 820.0000, 'ºC'),
	(319676, 144, '2015-01-15 00:22:42.000000', 'temperatura', 590.0000, 'ºC'),
	(319677, 144, '2015-01-15 00:22:43.000000', 'temperatura', 492.0000, 'ºC'),
	(319678, 144, '2015-01-15 00:22:44.000000', 'temperatura', 691.0000, 'ºC'),
	(319679, 144, '2015-01-15 00:22:45.000000', 'temperatura', 777.0000, 'ºC'),
	(319680, 144, '2015-01-15 00:22:46.000000', 'temperatura', 616.0000, 'ºC'),
	(319681, 144, '2015-01-15 00:22:47.000000', 'temperatura', 747.0000, 'ºC'),
	(319682, 144, '2015-01-15 00:22:48.000000', 'temperatura', 686.0000, 'ºC'),
	(319683, 144, '2015-01-15 00:22:49.000000', 'temperatura', 1192.0000, 'ºC'),
	(319684, 144, '2015-01-15 00:22:50.000000', 'temperatura', 300.0000, 'ºC'),
	(319685, 144, '2015-01-15 00:22:51.000000', 'temperatura', 327.0000, 'ºC'),
	(319686, 144, '2015-01-15 00:22:52.000000', 'temperatura', 735.0000, 'ºC'),
	(319687, 144, '2015-01-15 00:22:53.000000', 'temperatura', 293.0000, 'ºC'),
	(319688, 144, '2015-01-15 00:22:54.000000', 'temperatura', 462.0000, 'ºC'),
	(319689, 144, '2015-01-15 00:22:55.000000', 'temperatura', 231.0000, 'ºC'),
	(319690, 144, '2015-01-15 00:22:56.000000', 'temperatura', 971.0000, 'ºC'),
	(319691, 144, '2015-01-15 00:22:57.000000', 'temperatura', 562.0000, 'ºC'),
	(319692, 144, '2015-01-15 00:22:58.000000', 'temperatura', 1098.0000, 'ºC'),
	(319693, 144, '2015-01-15 00:22:59.000000', 'temperatura', 206.0000, 'ºC'),
	(319694, 144, '2015-01-15 00:23:00.000000', 'temperatura', 135.0000, 'ºC'),
	(319695, 144, '2015-01-15 00:23:01.000000', 'temperatura', 56.0000, 'ºC'),
	(319696, 144, '2015-01-15 00:23:02.000000', 'temperatura', 1079.0000, 'ºC'),
	(319697, 144, '2015-01-15 00:23:03.000000', 'temperatura', 424.0000, 'ºC'),
	(319698, 144, '2015-01-15 00:23:04.000000', 'temperatura', 86.0000, 'ºC'),
	(319699, 144, '2015-01-15 00:23:05.000000', 'temperatura', 359.0000, 'ºC'),
	(319700, 144, '2015-01-15 00:23:06.000000', 'temperatura', 338.0000, 'ºC'),
	(319701, 144, '2015-01-15 00:23:07.000000', 'temperatura', 612.0000, 'ºC'),
	(319702, 144, '2015-01-15 00:23:08.000000', 'temperatura', 845.0000, 'ºC'),
	(319703, 144, '2015-01-15 00:23:09.000000', 'temperatura', 1191.0000, 'ºC'),
	(319704, 144, '2015-01-15 00:23:10.000000', 'temperatura', 1020.0000, 'ºC'),
	(319705, 144, '2015-01-15 00:23:11.000000', 'temperatura', 327.0000, 'ºC'),
	(319706, 144, '2015-01-15 00:23:12.000000', 'temperatura', 978.0000, 'ºC'),
	(319707, 144, '2015-01-15 00:23:13.000000', 'temperatura', 307.0000, 'ºC'),
	(319708, 144, '2015-01-15 00:23:14.000000', 'temperatura', 1001.0000, 'ºC'),
	(319709, 144, '2015-01-15 00:23:15.000000', 'temperatura', 485.0000, 'ºC'),
	(319710, 144, '2015-01-15 00:23:16.000000', 'temperatura', 621.0000, 'ºC'),
	(319711, 144, '2015-01-15 00:23:17.000000', 'temperatura', 451.0000, 'ºC'),
	(319712, 144, '2015-01-15 00:23:18.000000', 'temperatura', 394.0000, 'ºC'),
	(319713, 144, '2015-01-15 00:23:19.000000', 'temperatura', 617.0000, 'ºC'),
	(319714, 144, '2015-01-15 00:23:20.000000', 'temperatura', 703.0000, 'ºC'),
	(319715, 144, '2015-01-15 00:23:21.000000', 'temperatura', 466.0000, 'ºC'),
	(319716, 144, '2015-01-15 00:23:22.000000', 'temperatura', 222.0000, 'ºC'),
	(319717, 144, '2015-01-15 00:23:23.000000', 'temperatura', 914.0000, 'ºC'),
	(319718, 144, '2015-01-15 00:23:24.000000', 'temperatura', 301.0000, 'ºC'),
	(319719, 144, '2015-01-15 00:23:25.000000', 'temperatura', 1166.0000, 'ºC'),
	(319720, 144, '2015-01-15 00:23:26.000000', 'temperatura', 126.0000, 'ºC'),
	(319721, 144, '2015-01-15 00:23:27.000000', 'temperatura', 732.0000, 'ºC'),
	(319722, 144, '2015-01-15 00:23:28.000000', 'temperatura', 882.0000, 'ºC'),
	(319723, 144, '2015-01-15 00:23:29.000000', 'temperatura', 1016.0000, 'ºC'),
	(319724, 144, '2015-01-15 00:23:30.000000', 'temperatura', 35.0000, 'ºC'),
	(319725, 144, '2015-01-15 00:23:31.000000', 'temperatura', 725.0000, 'ºC'),
	(319726, 144, '2015-01-15 00:23:32.000000', 'temperatura', 1123.0000, 'ºC'),
	(319727, 144, '2015-01-15 00:23:33.000000', 'temperatura', 1039.0000, 'ºC'),
	(319728, 144, '2015-01-15 00:23:34.000000', 'temperatura', 627.0000, 'ºC'),
	(319729, 144, '2015-01-15 00:23:35.000000', 'temperatura', 19.0000, 'ºC'),
	(319730, 144, '2015-01-15 00:23:36.000000', 'temperatura', 615.0000, 'ºC'),
	(319731, 144, '2015-01-15 00:23:37.000000', 'temperatura', 618.0000, 'ºC'),
	(319732, 144, '2015-01-15 00:23:38.000000', 'temperatura', 46.0000, 'ºC'),
	(319733, 144, '2015-01-15 00:23:39.000000', 'temperatura', 778.0000, 'ºC'),
	(319734, 144, '2015-01-15 00:23:40.000000', 'temperatura', 152.0000, 'ºC'),
	(319735, 144, '2015-01-15 00:23:41.000000', 'temperatura', 824.0000, 'ºC'),
	(319736, 144, '2015-01-15 00:23:42.000000', 'temperatura', 65.0000, 'ºC'),
	(319737, 144, '2015-01-15 00:23:43.000000', 'temperatura', 255.0000, 'ºC'),
	(319738, 144, '2015-01-15 00:23:44.000000', 'temperatura', 1079.0000, 'ºC'),
	(319739, 144, '2015-01-15 00:23:45.000000', 'temperatura', 1029.0000, 'ºC'),
	(319740, 144, '2015-01-15 00:23:46.000000', 'temperatura', 712.0000, 'ºC'),
	(319741, 144, '2015-01-15 00:23:47.000000', 'temperatura', 472.0000, 'ºC'),
	(319742, 144, '2015-01-15 00:23:48.000000', 'temperatura', 226.0000, 'ºC'),
	(319743, 144, '2015-01-15 00:23:49.000000', 'temperatura', 912.0000, 'ºC'),
	(319744, 144, '2015-01-15 00:23:50.000000', 'temperatura', 282.0000, 'ºC'),
	(319745, 144, '2015-01-15 00:23:51.000000', 'temperatura', 1074.0000, 'ºC'),
	(319746, 144, '2015-01-15 00:23:52.000000', 'temperatura', 926.0000, 'ºC'),
	(319747, 144, '2015-01-15 00:23:53.000000', 'temperatura', 209.0000, 'ºC'),
	(319748, 144, '2015-01-15 00:23:54.000000', 'temperatura', 667.0000, 'ºC'),
	(319749, 144, '2015-01-15 00:23:55.000000', 'temperatura', 307.0000, 'ºC'),
	(319750, 144, '2015-01-15 00:23:56.000000', 'temperatura', 736.0000, 'ºC'),
	(319751, 144, '2015-01-15 00:23:57.000000', 'temperatura', 357.0000, 'ºC'),
	(319752, 144, '2015-01-15 00:23:58.000000', 'temperatura', 780.0000, 'ºC'),
	(319753, 144, '2015-01-15 00:23:59.000000', 'temperatura', 428.0000, 'ºC'),
	(319754, 144, '2015-01-15 00:24:00.000000', 'temperatura', 1000.0000, 'ºC'),
	(319755, 144, '2015-01-15 00:24:01.000000', 'temperatura', 115.0000, 'ºC'),
	(319756, 144, '2015-01-15 00:24:02.000000', 'temperatura', 1179.0000, 'ºC'),
	(319757, 144, '2015-01-15 00:24:03.000000', 'temperatura', 747.0000, 'ºC'),
	(319758, 144, '2015-01-15 00:24:04.000000', 'temperatura', 202.0000, 'ºC'),
	(319759, 144, '2015-01-15 00:24:05.000000', 'temperatura', 1168.0000, 'ºC'),
	(319760, 144, '2015-01-15 00:24:06.000000', 'temperatura', 434.0000, 'ºC'),
	(319761, 144, '2015-01-15 00:24:07.000000', 'temperatura', 1065.0000, 'ºC'),
	(319762, 144, '2015-01-15 00:24:08.000000', 'temperatura', 424.0000, 'ºC'),
	(319763, 144, '2015-01-15 00:24:09.000000', 'temperatura', 128.0000, 'ºC'),
	(319764, 144, '2015-01-15 00:24:10.000000', 'temperatura', 566.0000, 'ºC'),
	(319765, 144, '2015-01-15 00:24:11.000000', 'temperatura', 48.0000, 'ºC'),
	(319766, 144, '2015-01-15 00:24:12.000000', 'temperatura', 942.0000, 'ºC'),
	(319767, 144, '2015-01-15 00:24:13.000000', 'temperatura', 968.0000, 'ºC'),
	(319768, 144, '2015-01-15 00:24:14.000000', 'temperatura', 814.0000, 'ºC'),
	(319769, 144, '2015-01-15 00:24:15.000000', 'temperatura', 1164.0000, 'ºC'),
	(319770, 144, '2015-01-15 00:24:16.000000', 'temperatura', 982.0000, 'ºC'),
	(319771, 144, '2015-01-15 00:24:17.000000', 'temperatura', 216.0000, 'ºC'),
	(319772, 144, '2015-01-15 00:24:18.000000', 'temperatura', 533.0000, 'ºC'),
	(319773, 144, '2015-01-15 00:24:19.000000', 'temperatura', 820.0000, 'ºC'),
	(319774, 144, '2015-01-15 00:24:20.000000', 'temperatura', 100.0000, 'ºC'),
	(319775, 144, '2015-01-15 00:24:21.000000', 'temperatura', 439.0000, 'ºC'),
	(319776, 144, '2015-01-15 00:24:22.000000', 'temperatura', 697.0000, 'ºC'),
	(319777, 144, '2015-01-15 00:24:23.000000', 'temperatura', 970.0000, 'ºC'),
	(319778, 144, '2015-01-15 00:24:24.000000', 'temperatura', 359.0000, 'ºC'),
	(319779, 144, '2015-01-15 00:24:25.000000', 'temperatura', 86.0000, 'ºC'),
	(319780, 144, '2015-01-15 00:24:26.000000', 'temperatura', 555.0000, 'ºC'),
	(319781, 144, '2015-01-15 00:24:27.000000', 'temperatura', 114.0000, 'ºC'),
	(319782, 144, '2015-01-15 00:24:28.000000', 'temperatura', 107.0000, 'ºC'),
	(319783, 144, '2015-01-15 00:24:29.000000', 'temperatura', 194.0000, 'ºC'),
	(319784, 144, '2015-01-15 00:24:30.000000', 'temperatura', 651.0000, 'ºC'),
	(319785, 144, '2015-01-15 00:24:31.000000', 'temperatura', 271.0000, 'ºC'),
	(319786, 144, '2015-01-15 00:24:32.000000', 'temperatura', 602.0000, 'ºC'),
	(319787, 144, '2015-01-15 00:24:33.000000', 'temperatura', 998.0000, 'ºC'),
	(319788, 144, '2015-01-15 00:24:34.000000', 'temperatura', 786.0000, 'ºC'),
	(319789, 144, '2015-01-15 00:24:35.000000', 'temperatura', 934.0000, 'ºC'),
	(319790, 144, '2015-01-15 00:24:36.000000', 'temperatura', 1114.0000, 'ºC'),
	(319791, 144, '2015-01-15 00:24:37.000000', 'temperatura', 370.0000, 'ºC'),
	(319792, 144, '2015-01-15 00:24:38.000000', 'temperatura', 906.0000, 'ºC'),
	(319793, 144, '2015-01-15 00:24:39.000000', 'temperatura', 1019.0000, 'ºC'),
	(319794, 144, '2015-01-15 00:24:40.000000', 'temperatura', 1180.0000, 'ºC'),
	(319795, 144, '2015-01-15 00:24:41.000000', 'temperatura', 445.0000, 'ºC'),
	(319796, 144, '2015-01-15 00:24:42.000000', 'temperatura', 1083.0000, 'ºC'),
	(319797, 144, '2015-01-15 00:24:43.000000', 'temperatura', 482.0000, 'ºC'),
	(319798, 144, '2015-01-15 00:24:44.000000', 'temperatura', 360.0000, 'ºC'),
	(319799, 144, '2015-01-15 00:24:45.000000', 'temperatura', 357.0000, 'ºC'),
	(319800, 144, '2015-01-15 00:24:46.000000', 'temperatura', 704.0000, 'ºC'),
	(319801, 144, '2015-01-15 00:24:47.000000', 'temperatura', 51.0000, 'ºC'),
	(319802, 144, '2015-01-15 00:24:48.000000', 'temperatura', 544.0000, 'ºC'),
	(319803, 144, '2015-01-15 00:24:49.000000', 'temperatura', 167.0000, 'ºC'),
	(319804, 144, '2015-01-15 00:24:50.000000', 'temperatura', 402.0000, 'ºC'),
	(319805, 144, '2015-01-15 00:24:51.000000', 'temperatura', 311.0000, 'ºC'),
	(319806, 144, '2015-01-15 00:24:52.000000', 'temperatura', 351.0000, 'ºC'),
	(319807, 144, '2015-01-15 00:24:53.000000', 'temperatura', 822.0000, 'ºC'),
	(319808, 144, '2015-01-15 00:24:54.000000', 'temperatura', 655.0000, 'ºC'),
	(319809, 144, '2015-01-15 00:24:55.000000', 'temperatura', 812.0000, 'ºC'),
	(319810, 144, '2015-01-15 00:24:56.000000', 'temperatura', 895.0000, 'ºC'),
	(319811, 144, '2015-01-15 00:24:57.000000', 'temperatura', 837.0000, 'ºC'),
	(319812, 144, '2015-01-15 00:24:58.000000', 'temperatura', 304.0000, 'ºC'),
	(319813, 144, '2015-01-15 00:24:59.000000', 'temperatura', 208.0000, 'ºC'),
	(319814, 144, '2015-01-15 00:25:00.000000', 'temperatura', 128.0000, 'ºC'),
	(319815, 144, '2015-01-15 00:25:01.000000', 'temperatura', 17.0000, 'ºC'),
	(319816, 144, '2015-01-15 00:25:02.000000', 'temperatura', 900.0000, 'ºC'),
	(319817, 144, '2015-01-15 00:25:03.000000', 'temperatura', 849.0000, 'ºC'),
	(319818, 144, '2015-01-15 00:25:04.000000', 'temperatura', 346.0000, 'ºC'),
	(319819, 144, '2015-01-15 00:25:05.000000', 'temperatura', 386.0000, 'ºC'),
	(319820, 144, '2015-01-15 00:25:06.000000', 'temperatura', 890.0000, 'ºC'),
	(319821, 144, '2015-01-15 00:25:07.000000', 'temperatura', 892.0000, 'ºC'),
	(319822, 144, '2015-01-15 00:25:08.000000', 'temperatura', 593.0000, 'ºC'),
	(319823, 144, '2015-01-15 00:25:09.000000', 'temperatura', 289.0000, 'ºC'),
	(319824, 144, '2015-01-15 00:25:10.000000', 'temperatura', 865.0000, 'ºC'),
	(319825, 144, '2015-01-15 00:25:11.000000', 'temperatura', 1058.0000, 'ºC'),
	(319826, 144, '2015-01-15 00:25:12.000000', 'temperatura', 298.0000, 'ºC'),
	(319827, 144, '2015-01-15 00:25:13.000000', 'temperatura', 714.0000, 'ºC'),
	(319828, 144, '2015-01-15 00:25:14.000000', 'temperatura', 277.0000, 'ºC'),
	(319829, 144, '2015-01-15 00:25:15.000000', 'temperatura', 445.0000, 'ºC'),
	(319830, 144, '2015-01-15 00:25:16.000000', 'temperatura', 194.0000, 'ºC'),
	(319831, 144, '2015-01-15 00:25:17.000000', 'temperatura', 835.0000, 'ºC'),
	(319832, 144, '2015-01-15 00:25:18.000000', 'temperatura', 1192.0000, 'ºC'),
	(319833, 144, '2015-01-15 00:25:19.000000', 'temperatura', 1058.0000, 'ºC'),
	(319834, 144, '2015-01-15 00:25:20.000000', 'temperatura', 513.0000, 'ºC'),
	(319835, 144, '2015-01-15 00:25:21.000000', 'temperatura', 592.0000, 'ºC'),
	(319836, 144, '2015-01-15 00:25:22.000000', 'temperatura', 220.0000, 'ºC'),
	(319837, 144, '2015-01-15 00:25:23.000000', 'temperatura', 525.0000, 'ºC'),
	(319838, 144, '2015-01-15 00:25:24.000000', 'temperatura', 767.0000, 'ºC'),
	(319839, 144, '2015-01-15 00:25:25.000000', 'temperatura', 1061.0000, 'ºC'),
	(319840, 144, '2015-01-15 00:25:26.000000', 'temperatura', 602.0000, 'ºC'),
	(319841, 144, '2015-01-15 00:25:27.000000', 'temperatura', 1029.0000, 'ºC'),
	(319842, 144, '2015-01-15 00:25:28.000000', 'temperatura', 939.0000, 'ºC'),
	(319843, 144, '2015-01-15 00:25:29.000000', 'temperatura', 408.0000, 'ºC'),
	(319844, 144, '2015-01-15 00:25:30.000000', 'temperatura', 424.0000, 'ºC'),
	(319845, 144, '2015-01-15 00:25:31.000000', 'temperatura', 897.0000, 'ºC'),
	(319846, 144, '2015-01-15 00:25:32.000000', 'temperatura', 812.0000, 'ºC'),
	(319847, 144, '2015-01-15 00:25:33.000000', 'temperatura', 172.0000, 'ºC'),
	(319848, 144, '2015-01-15 00:25:34.000000', 'temperatura', 823.0000, 'ºC'),
	(319849, 144, '2015-01-15 00:25:35.000000', 'temperatura', 1198.0000, 'ºC'),
	(319850, 144, '2015-01-15 00:25:36.000000', 'temperatura', 1121.0000, 'ºC'),
	(319851, 144, '2015-01-15 00:25:37.000000', 'temperatura', 813.0000, 'ºC'),
	(319852, 144, '2015-01-15 00:25:38.000000', 'temperatura', 701.0000, 'ºC'),
	(319853, 144, '2015-01-15 00:25:39.000000', 'temperatura', 1067.0000, 'ºC'),
	(319854, 144, '2015-01-15 00:25:40.000000', 'temperatura', 833.0000, 'ºC'),
	(319855, 144, '2015-01-15 00:25:41.000000', 'temperatura', 962.0000, 'ºC'),
	(319856, 144, '2015-01-15 00:25:42.000000', 'temperatura', 1115.0000, 'ºC'),
	(319857, 144, '2015-01-15 00:25:43.000000', 'temperatura', 289.0000, 'ºC'),
	(319858, 144, '2015-01-15 00:25:44.000000', 'temperatura', 498.0000, 'ºC'),
	(319859, 144, '2015-01-15 00:25:45.000000', 'temperatura', 426.0000, 'ºC'),
	(319860, 144, '2015-01-15 00:25:46.000000', 'temperatura', 635.0000, 'ºC'),
	(319861, 144, '2015-01-15 00:25:47.000000', 'temperatura', 697.0000, 'ºC'),
	(319862, 144, '2015-01-15 00:25:48.000000', 'temperatura', 383.0000, 'ºC'),
	(319863, 144, '2015-01-15 00:25:49.000000', 'temperatura', 1022.0000, 'ºC'),
	(319864, 144, '2015-01-15 00:25:50.000000', 'temperatura', 362.0000, 'ºC'),
	(319865, 144, '2015-01-15 00:25:51.000000', 'temperatura', 1144.0000, 'ºC'),
	(319866, 144, '2015-01-15 00:25:52.000000', 'temperatura', 1036.0000, 'ºC'),
	(319867, 144, '2015-01-15 00:25:53.000000', 'temperatura', 546.0000, 'ºC'),
	(319868, 144, '2015-01-15 00:25:54.000000', 'temperatura', 824.0000, 'ºC'),
	(319869, 144, '2015-01-15 00:25:55.000000', 'temperatura', 84.0000, 'ºC'),
	(319870, 144, '2015-01-15 00:25:56.000000', 'temperatura', 348.0000, 'ºC'),
	(319871, 144, '2015-01-15 00:25:57.000000', 'temperatura', 289.0000, 'ºC'),
	(319872, 144, '2015-01-15 00:25:58.000000', 'temperatura', 403.0000, 'ºC'),
	(319873, 144, '2015-01-15 00:25:59.000000', 'temperatura', 1146.0000, 'ºC'),
	(319874, 144, '2015-01-15 00:26:00.000000', 'temperatura', 922.0000, 'ºC'),
	(319875, 144, '2015-01-15 00:26:01.000000', 'temperatura', 1171.0000, 'ºC'),
	(319876, 144, '2015-01-15 00:26:02.000000', 'temperatura', 692.0000, 'ºC'),
	(319877, 144, '2015-01-15 00:26:03.000000', 'temperatura', 1146.0000, 'ºC'),
	(319878, 144, '2015-01-15 00:26:04.000000', 'temperatura', 55.0000, 'ºC'),
	(319879, 144, '2015-01-15 00:26:05.000000', 'temperatura', 436.0000, 'ºC'),
	(319880, 144, '2015-01-15 00:26:06.000000', 'temperatura', 815.0000, 'ºC'),
	(319881, 144, '2015-01-15 00:26:07.000000', 'temperatura', 369.0000, 'ºC'),
	(319882, 144, '2015-01-15 00:26:08.000000', 'temperatura', 601.0000, 'ºC'),
	(319883, 144, '2015-01-15 00:26:09.000000', 'temperatura', 697.0000, 'ºC'),
	(319884, 144, '2015-01-15 00:26:10.000000', 'temperatura', 484.0000, 'ºC'),
	(319885, 144, '2015-01-15 00:26:11.000000', 'temperatura', 328.0000, 'ºC'),
	(319886, 144, '2015-01-15 00:26:12.000000', 'temperatura', 189.0000, 'ºC'),
	(319887, 144, '2015-01-15 00:26:13.000000', 'temperatura', 1163.0000, 'ºC'),
	(319888, 144, '2015-01-15 00:26:14.000000', 'temperatura', 446.0000, 'ºC'),
	(319889, 144, '2015-01-15 00:26:15.000000', 'temperatura', 1144.0000, 'ºC'),
	(319890, 144, '2015-01-15 00:26:16.000000', 'temperatura', 780.0000, 'ºC'),
	(319891, 144, '2015-01-15 00:26:17.000000', 'temperatura', 470.0000, 'ºC'),
	(319892, 144, '2015-01-15 00:26:18.000000', 'temperatura', 10.0000, 'ºC'),
	(319893, 144, '2015-01-15 00:26:19.000000', 'temperatura', 1043.0000, 'ºC'),
	(319894, 144, '2015-01-15 00:26:20.000000', 'temperatura', 382.0000, 'ºC'),
	(319895, 144, '2015-01-15 00:26:21.000000', 'temperatura', 1184.0000, 'ºC'),
	(319896, 144, '2015-01-15 00:26:22.000000', 'temperatura', 1174.0000, 'ºC'),
	(319897, 144, '2015-01-15 00:26:23.000000', 'temperatura', 1117.0000, 'ºC'),
	(319898, 144, '2015-01-15 00:26:24.000000', 'temperatura', 866.0000, 'ºC'),
	(319899, 144, '2015-01-15 00:26:25.000000', 'temperatura', 980.0000, 'ºC'),
	(319900, 144, '2015-01-15 00:26:26.000000', 'temperatura', 1100.0000, 'ºC'),
	(319901, 144, '2015-01-15 00:26:27.000000', 'temperatura', 163.0000, 'ºC'),
	(319902, 144, '2015-01-15 00:26:28.000000', 'temperatura', 1113.0000, 'ºC'),
	(319903, 144, '2015-01-15 00:26:29.000000', 'temperatura', 277.0000, 'ºC'),
	(319904, 144, '2015-01-15 00:26:30.000000', 'temperatura', 448.0000, 'ºC'),
	(319905, 144, '2015-01-15 00:26:31.000000', 'temperatura', 210.0000, 'ºC'),
	(319906, 144, '2015-01-15 00:26:32.000000', 'temperatura', 906.0000, 'ºC'),
	(319907, 144, '2015-01-15 00:26:33.000000', 'temperatura', 302.0000, 'ºC'),
	(319908, 144, '2015-01-15 00:26:34.000000', 'temperatura', 1189.0000, 'ºC'),
	(319909, 144, '2015-01-15 00:26:35.000000', 'temperatura', 242.0000, 'ºC'),
	(319910, 144, '2015-01-15 00:26:36.000000', 'temperatura', 43.0000, 'ºC'),
	(319911, 144, '2015-01-15 00:26:37.000000', 'temperatura', 688.0000, 'ºC'),
	(319912, 144, '2015-01-15 00:26:38.000000', 'temperatura', 913.0000, 'ºC'),
	(319913, 144, '2015-01-15 00:26:39.000000', 'temperatura', 102.0000, 'ºC'),
	(319914, 144, '2015-01-15 00:26:40.000000', 'temperatura', 170.0000, 'ºC'),
	(319915, 144, '2015-01-15 00:26:41.000000', 'temperatura', 547.0000, 'ºC'),
	(319916, 144, '2015-01-15 00:26:42.000000', 'temperatura', 1023.0000, 'ºC'),
	(319917, 144, '2015-01-15 00:26:43.000000', 'temperatura', 1075.0000, 'ºC'),
	(319918, 144, '2015-01-15 00:26:44.000000', 'temperatura', 1108.0000, 'ºC'),
	(319919, 144, '2015-01-15 00:26:45.000000', 'temperatura', 1115.0000, 'ºC'),
	(319920, 144, '2015-01-15 00:26:46.000000', 'temperatura', 1052.0000, 'ºC'),
	(319921, 144, '2015-01-15 00:26:47.000000', 'temperatura', 715.0000, 'ºC'),
	(319922, 144, '2015-01-15 00:26:48.000000', 'temperatura', 421.0000, 'ºC'),
	(319923, 144, '2015-01-15 00:26:49.000000', 'temperatura', 1158.0000, 'ºC'),
	(319924, 144, '2015-01-15 00:26:50.000000', 'temperatura', 927.0000, 'ºC'),
	(319925, 144, '2015-01-15 00:26:51.000000', 'temperatura', 1162.0000, 'ºC'),
	(319926, 144, '2015-01-15 00:26:52.000000', 'temperatura', 632.0000, 'ºC'),
	(319927, 144, '2015-01-15 00:26:53.000000', 'temperatura', 872.0000, 'ºC'),
	(319928, 144, '2015-01-15 00:26:54.000000', 'temperatura', 65.0000, 'ºC'),
	(319929, 144, '2015-01-15 00:26:55.000000', 'temperatura', 110.0000, 'ºC'),
	(319930, 144, '2015-01-15 00:26:56.000000', 'temperatura', 355.0000, 'ºC'),
	(319931, 144, '2015-01-15 00:26:57.000000', 'temperatura', 246.0000, 'ºC'),
	(319932, 144, '2015-01-15 00:26:58.000000', 'temperatura', 164.0000, 'ºC'),
	(319933, 144, '2015-01-15 00:26:59.000000', 'temperatura', 85.0000, 'ºC'),
	(319934, 144, '2015-01-15 00:27:00.000000', 'temperatura', 1131.0000, 'ºC'),
	(319935, 144, '2015-01-15 00:27:01.000000', 'temperatura', 602.0000, 'ºC'),
	(319936, 144, '2015-01-15 00:27:02.000000', 'temperatura', 819.0000, 'ºC'),
	(319937, 144, '2015-01-15 00:27:03.000000', 'temperatura', 1089.0000, 'ºC'),
	(319938, 144, '2015-01-15 00:27:04.000000', 'temperatura', 587.0000, 'ºC'),
	(319939, 144, '2015-01-15 00:27:05.000000', 'temperatura', 869.0000, 'ºC'),
	(319940, 144, '2015-01-15 00:27:06.000000', 'temperatura', 182.0000, 'ºC'),
	(319941, 144, '2015-01-15 00:27:07.000000', 'temperatura', 707.0000, 'ºC'),
	(319942, 144, '2015-01-15 00:27:08.000000', 'temperatura', 590.0000, 'ºC'),
	(319943, 144, '2015-01-15 00:27:09.000000', 'temperatura', 828.0000, 'ºC'),
	(319944, 144, '2015-01-15 00:27:10.000000', 'temperatura', 1172.0000, 'ºC'),
	(319945, 144, '2015-01-15 00:27:11.000000', 'temperatura', 976.0000, 'ºC'),
	(319946, 144, '2015-01-15 00:27:12.000000', 'temperatura', 163.0000, 'ºC'),
	(319947, 144, '2015-01-15 00:27:13.000000', 'temperatura', 287.0000, 'ºC'),
	(319948, 144, '2015-01-15 00:27:14.000000', 'temperatura', 949.0000, 'ºC'),
	(319949, 144, '2015-01-15 00:27:15.000000', 'temperatura', 282.0000, 'ºC'),
	(319950, 144, '2015-01-15 00:27:16.000000', 'temperatura', 965.0000, 'ºC'),
	(319951, 144, '2015-01-15 00:27:17.000000', 'temperatura', 380.0000, 'ºC'),
	(319952, 144, '2015-01-15 00:27:18.000000', 'temperatura', 205.0000, 'ºC'),
	(319953, 144, '2015-01-15 00:27:19.000000', 'temperatura', 1086.0000, 'ºC'),
	(319954, 144, '2015-01-15 00:27:20.000000', 'temperatura', 14.0000, 'ºC'),
	(319955, 144, '2015-01-15 00:27:21.000000', 'temperatura', 413.0000, 'ºC'),
	(319956, 144, '2015-01-15 00:27:22.000000', 'temperatura', 823.0000, 'ºC'),
	(319957, 144, '2015-01-15 00:27:23.000000', 'temperatura', 475.0000, 'ºC'),
	(319958, 144, '2015-01-15 00:27:24.000000', 'temperatura', 1109.0000, 'ºC'),
	(319959, 144, '2015-01-15 00:27:25.000000', 'temperatura', 521.0000, 'ºC'),
	(319960, 144, '2015-01-15 00:27:26.000000', 'temperatura', 478.0000, 'ºC'),
	(319961, 144, '2015-01-15 00:27:27.000000', 'temperatura', 825.0000, 'ºC'),
	(319962, 144, '2015-01-15 00:27:28.000000', 'temperatura', 294.0000, 'ºC'),
	(319963, 144, '2015-01-15 00:27:29.000000', 'temperatura', 194.0000, 'ºC'),
	(319964, 144, '2015-01-15 00:27:30.000000', 'temperatura', 87.0000, 'ºC'),
	(319965, 144, '2015-01-15 00:27:31.000000', 'temperatura', 1057.0000, 'ºC'),
	(319966, 144, '2015-01-15 00:27:32.000000', 'temperatura', 221.0000, 'ºC'),
	(319967, 144, '2015-01-15 00:27:33.000000', 'temperatura', 337.0000, 'ºC'),
	(319968, 144, '2015-01-15 00:27:34.000000', 'temperatura', 1020.0000, 'ºC'),
	(319969, 144, '2015-01-15 00:27:35.000000', 'temperatura', 489.0000, 'ºC'),
	(319970, 144, '2015-01-15 00:27:36.000000', 'temperatura', 587.0000, 'ºC'),
	(319971, 144, '2015-01-15 00:27:37.000000', 'temperatura', 269.0000, 'ºC'),
	(319972, 144, '2015-01-15 00:27:38.000000', 'temperatura', 785.0000, 'ºC'),
	(319973, 144, '2015-01-15 00:27:39.000000', 'temperatura', 718.0000, 'ºC'),
	(319974, 144, '2015-01-15 00:27:40.000000', 'temperatura', 34.0000, 'ºC'),
	(319975, 144, '2015-01-15 00:27:41.000000', 'temperatura', 416.0000, 'ºC'),
	(319976, 144, '2015-01-15 00:27:42.000000', 'temperatura', 780.0000, 'ºC'),
	(319977, 144, '2015-01-15 00:27:43.000000', 'temperatura', 253.0000, 'ºC'),
	(319978, 144, '2015-01-15 00:27:44.000000', 'temperatura', 123.0000, 'ºC'),
	(319979, 144, '2015-01-15 00:27:45.000000', 'temperatura', 1058.0000, 'ºC'),
	(319980, 144, '2015-01-15 00:27:46.000000', 'temperatura', 123.0000, 'ºC'),
	(319981, 144, '2015-01-15 00:27:47.000000', 'temperatura', 1041.0000, 'ºC'),
	(319982, 144, '2015-01-15 00:27:48.000000', 'temperatura', 37.0000, 'ºC'),
	(319983, 144, '2015-01-15 00:27:49.000000', 'temperatura', 662.0000, 'ºC'),
	(319984, 144, '2015-01-15 00:27:50.000000', 'temperatura', 798.0000, 'ºC'),
	(319985, 144, '2015-01-15 00:27:51.000000', 'temperatura', 806.0000, 'ºC'),
	(319986, 144, '2015-01-15 00:27:52.000000', 'temperatura', 434.0000, 'ºC'),
	(319987, 144, '2015-01-15 00:27:53.000000', 'temperatura', 955.0000, 'ºC'),
	(319988, 144, '2015-01-15 00:27:54.000000', 'temperatura', 1073.0000, 'ºC'),
	(319989, 144, '2015-01-15 00:27:55.000000', 'temperatura', 98.0000, 'ºC'),
	(319990, 144, '2015-01-15 00:27:56.000000', 'temperatura', 874.0000, 'ºC'),
	(319991, 144, '2015-01-15 00:27:57.000000', 'temperatura', 476.0000, 'ºC'),
	(319992, 144, '2015-01-15 00:27:58.000000', 'temperatura', 959.0000, 'ºC'),
	(319993, 144, '2015-01-15 00:27:59.000000', 'temperatura', 968.0000, 'ºC'),
	(319994, 144, '2015-01-15 00:28:00.000000', 'temperatura', 763.0000, 'ºC'),
	(319995, 144, '2015-01-15 00:28:01.000000', 'temperatura', 912.0000, 'ºC'),
	(319996, 144, '2015-01-15 00:28:02.000000', 'temperatura', 1069.0000, 'ºC'),
	(319997, 144, '2015-01-15 00:28:03.000000', 'temperatura', 212.0000, 'ºC'),
	(319998, 144, '2015-01-15 00:28:04.000000', 'temperatura', 253.0000, 'ºC'),
	(319999, 144, '2015-01-15 00:28:05.000000', 'temperatura', 630.0000, 'ºC'),
	(320000, 144, '2015-01-15 00:28:06.000000', 'temperatura', 1193.0000, 'ºC'),
	(320001, 144, '2015-01-15 00:28:07.000000', 'temperatura', 474.0000, 'ºC'),
	(320002, 144, '2015-01-15 00:28:08.000000', 'temperatura', 1190.0000, 'ºC'),
	(320003, 144, '2015-01-15 00:28:09.000000', 'temperatura', 928.0000, 'ºC'),
	(320004, 144, '2015-01-15 00:28:10.000000', 'temperatura', 1070.0000, 'ºC'),
	(320005, 144, '2015-01-15 00:28:11.000000', 'temperatura', 168.0000, 'ºC'),
	(320006, 144, '2015-01-15 00:28:12.000000', 'temperatura', 30.0000, 'ºC'),
	(320007, 144, '2015-01-15 00:28:13.000000', 'temperatura', 845.0000, 'ºC'),
	(320008, 144, '2015-01-15 00:28:14.000000', 'temperatura', 536.0000, 'ºC'),
	(320009, 144, '2015-01-15 00:28:15.000000', 'temperatura', 146.0000, 'ºC'),
	(320010, 144, '2015-01-15 00:28:16.000000', 'temperatura', 321.0000, 'ºC'),
	(320011, 144, '2015-01-15 00:28:17.000000', 'temperatura', 1169.0000, 'ºC'),
	(320012, 144, '2015-01-15 00:28:18.000000', 'temperatura', 83.0000, 'ºC'),
	(320013, 144, '2015-01-15 00:28:19.000000', 'temperatura', 506.0000, 'ºC'),
	(320014, 144, '2015-01-15 00:28:20.000000', 'temperatura', 1082.0000, 'ºC'),
	(320015, 144, '2015-01-15 00:28:21.000000', 'temperatura', 293.0000, 'ºC'),
	(320016, 144, '2015-01-15 00:28:22.000000', 'temperatura', 622.0000, 'ºC'),
	(320017, 144, '2015-01-15 00:28:23.000000', 'temperatura', 1028.0000, 'ºC'),
	(320018, 144, '2015-01-15 00:28:24.000000', 'temperatura', 876.0000, 'ºC'),
	(320019, 144, '2015-01-15 00:28:25.000000', 'temperatura', 97.0000, 'ºC'),
	(320020, 144, '2015-01-15 00:28:26.000000', 'temperatura', 256.0000, 'ºC'),
	(320021, 144, '2015-01-15 00:28:27.000000', 'temperatura', 990.0000, 'ºC'),
	(320022, 144, '2015-01-15 00:28:28.000000', 'temperatura', 583.0000, 'ºC'),
	(320023, 144, '2015-01-15 00:28:29.000000', 'temperatura', 1146.0000, 'ºC'),
	(320024, 144, '2015-01-15 00:28:30.000000', 'temperatura', 380.0000, 'ºC'),
	(320025, 144, '2015-01-15 00:28:31.000000', 'temperatura', 861.0000, 'ºC'),
	(320026, 144, '2015-01-15 00:28:32.000000', 'temperatura', 767.0000, 'ºC'),
	(320027, 144, '2015-01-15 00:28:33.000000', 'temperatura', 53.0000, 'ºC'),
	(320028, 144, '2015-01-15 00:28:34.000000', 'temperatura', 365.0000, 'ºC'),
	(320029, 144, '2015-01-15 00:28:35.000000', 'temperatura', 467.0000, 'ºC'),
	(320030, 144, '2015-01-15 00:28:36.000000', 'temperatura', 40.0000, 'ºC'),
	(320031, 144, '2015-01-15 00:28:37.000000', 'temperatura', 0.0000, 'ºC'),
	(320032, 144, '2015-01-15 00:28:38.000000', 'temperatura', 1081.0000, 'ºC'),
	(320033, 144, '2015-01-15 00:28:39.000000', 'temperatura', 607.0000, 'ºC'),
	(320034, 144, '2015-01-15 00:28:40.000000', 'temperatura', 990.0000, 'ºC'),
	(320035, 144, '2015-01-15 00:28:41.000000', 'temperatura', 732.0000, 'ºC'),
	(320036, 144, '2015-01-15 00:28:42.000000', 'temperatura', 691.0000, 'ºC'),
	(320037, 144, '2015-01-15 00:28:43.000000', 'temperatura', 57.0000, 'ºC'),
	(320038, 144, '2015-01-15 00:28:44.000000', 'temperatura', 611.0000, 'ºC'),
	(320039, 144, '2015-01-15 00:28:45.000000', 'temperatura', 488.0000, 'ºC'),
	(320040, 144, '2015-01-15 00:28:46.000000', 'temperatura', 605.0000, 'ºC'),
	(320041, 144, '2015-01-15 00:28:47.000000', 'temperatura', 363.0000, 'ºC'),
	(320042, 144, '2015-01-15 00:28:48.000000', 'temperatura', 1.0000, 'ºC'),
	(320043, 144, '2015-01-15 00:28:49.000000', 'temperatura', 116.0000, 'ºC'),
	(320044, 144, '2015-01-15 00:28:50.000000', 'temperatura', 578.0000, 'ºC'),
	(320045, 144, '2015-01-15 00:28:51.000000', 'temperatura', 142.0000, 'ºC'),
	(320046, 144, '2015-01-15 00:28:52.000000', 'temperatura', 175.0000, 'ºC'),
	(320047, 144, '2015-01-15 00:28:53.000000', 'temperatura', 450.0000, 'ºC'),
	(320048, 144, '2015-01-15 00:28:54.000000', 'temperatura', 526.0000, 'ºC'),
	(320049, 144, '2015-01-15 00:28:55.000000', 'temperatura', 81.0000, 'ºC'),
	(320050, 144, '2015-01-15 00:28:56.000000', 'temperatura', 29.0000, 'ºC'),
	(320051, 144, '2015-01-15 00:28:57.000000', 'temperatura', 1099.0000, 'ºC'),
	(320052, 144, '2015-01-15 00:28:58.000000', 'temperatura', 611.0000, 'ºC'),
	(320053, 144, '2015-01-15 00:28:59.000000', 'temperatura', 958.0000, 'ºC'),
	(320054, 144, '2015-01-15 00:29:00.000000', 'temperatura', 559.0000, 'ºC'),
	(320055, 144, '2015-01-15 00:29:01.000000', 'temperatura', 1118.0000, 'ºC'),
	(320056, 144, '2015-01-15 00:29:02.000000', 'temperatura', 317.0000, 'ºC'),
	(320057, 144, '2015-01-15 00:29:03.000000', 'temperatura', 630.0000, 'ºC'),
	(320058, 144, '2015-01-15 00:29:04.000000', 'temperatura', 1000.0000, 'ºC'),
	(320059, 144, '2015-01-15 00:29:05.000000', 'temperatura', 712.0000, 'ºC'),
	(320060, 144, '2015-01-15 00:29:06.000000', 'temperatura', 558.0000, 'ºC'),
	(320061, 144, '2015-01-15 00:29:07.000000', 'temperatura', 654.0000, 'ºC'),
	(320062, 144, '2015-01-15 00:29:08.000000', 'temperatura', 398.0000, 'ºC'),
	(320063, 144, '2015-01-15 00:29:09.000000', 'temperatura', 26.0000, 'ºC'),
	(320064, 144, '2015-01-15 00:29:10.000000', 'temperatura', 140.0000, 'ºC'),
	(320065, 144, '2015-01-15 00:29:11.000000', 'temperatura', 620.0000, 'ºC'),
	(320066, 144, '2015-01-15 00:29:12.000000', 'temperatura', 282.0000, 'ºC'),
	(320067, 144, '2015-01-15 00:29:13.000000', 'temperatura', 749.0000, 'ºC'),
	(320068, 144, '2015-01-15 00:29:14.000000', 'temperatura', 502.0000, 'ºC'),
	(320069, 144, '2015-01-15 00:29:15.000000', 'temperatura', 261.0000, 'ºC'),
	(320070, 144, '2015-01-15 00:29:16.000000', 'temperatura', 999.0000, 'ºC'),
	(320071, 144, '2015-01-15 00:29:17.000000', 'temperatura', 612.0000, 'ºC'),
	(320072, 144, '2015-01-15 00:29:18.000000', 'temperatura', 63.0000, 'ºC'),
	(320073, 144, '2015-01-15 00:29:19.000000', 'temperatura', 881.0000, 'ºC'),
	(320074, 144, '2015-01-15 00:29:20.000000', 'temperatura', 615.0000, 'ºC'),
	(320075, 144, '2015-01-15 00:29:21.000000', 'temperatura', 435.0000, 'ºC'),
	(320076, 144, '2015-01-15 00:29:22.000000', 'temperatura', 329.0000, 'ºC'),
	(320077, 144, '2015-01-15 00:29:23.000000', 'temperatura', 341.0000, 'ºC'),
	(320078, 144, '2015-01-15 00:29:24.000000', 'temperatura', 719.0000, 'ºC'),
	(320079, 144, '2015-01-15 00:29:25.000000', 'temperatura', 170.0000, 'ºC'),
	(320080, 144, '2015-01-15 00:29:26.000000', 'temperatura', 1096.0000, 'ºC'),
	(320081, 144, '2015-01-15 00:29:27.000000', 'temperatura', 168.0000, 'ºC'),
	(320082, 144, '2015-01-15 00:29:28.000000', 'temperatura', 1155.0000, 'ºC'),
	(320083, 144, '2015-01-15 00:29:29.000000', 'temperatura', 472.0000, 'ºC'),
	(320084, 144, '2015-01-15 00:29:30.000000', 'temperatura', 96.0000, 'ºC'),
	(320085, 144, '2015-01-15 00:29:31.000000', 'temperatura', 264.0000, 'ºC'),
	(320086, 144, '2015-01-15 00:29:32.000000', 'temperatura', 1032.0000, 'ºC'),
	(320087, 144, '2015-01-15 00:29:33.000000', 'temperatura', 767.0000, 'ºC'),
	(320088, 144, '2015-01-15 00:29:34.000000', 'temperatura', 741.0000, 'ºC'),
	(320089, 144, '2015-01-15 00:29:35.000000', 'temperatura', 203.0000, 'ºC'),
	(320090, 144, '2015-01-15 00:29:36.000000', 'temperatura', 1195.0000, 'ºC'),
	(320091, 144, '2015-01-15 00:29:37.000000', 'temperatura', 564.0000, 'ºC'),
	(320092, 144, '2015-01-15 00:29:38.000000', 'temperatura', 434.0000, 'ºC'),
	(320093, 144, '2015-01-15 00:29:39.000000', 'temperatura', 482.0000, 'ºC'),
	(320094, 144, '2015-01-15 00:29:40.000000', 'temperatura', 1109.0000, 'ºC'),
	(320095, 144, '2015-01-15 00:29:41.000000', 'temperatura', 496.0000, 'ºC'),
	(320096, 144, '2015-01-15 00:29:42.000000', 'temperatura', 356.0000, 'ºC'),
	(320097, 144, '2015-01-15 00:29:43.000000', 'temperatura', 292.0000, 'ºC'),
	(320098, 144, '2015-01-15 00:29:44.000000', 'temperatura', 393.0000, 'ºC'),
	(320099, 144, '2015-01-15 00:29:45.000000', 'temperatura', 1088.0000, 'ºC'),
	(320100, 144, '2015-01-15 00:29:46.000000', 'temperatura', 663.0000, 'ºC'),
	(320101, 144, '2015-01-15 00:29:47.000000', 'temperatura', 52.0000, 'ºC'),
	(320102, 144, '2015-01-15 00:29:48.000000', 'temperatura', 670.0000, 'ºC'),
	(320103, 144, '2015-01-15 00:29:49.000000', 'temperatura', 797.0000, 'ºC'),
	(320104, 144, '2015-01-15 00:29:50.000000', 'temperatura', 774.0000, 'ºC'),
	(320105, 144, '2015-01-15 00:29:51.000000', 'temperatura', 281.0000, 'ºC'),
	(320106, 144, '2015-01-15 00:29:52.000000', 'temperatura', 283.0000, 'ºC'),
	(320107, 144, '2015-01-15 00:29:53.000000', 'temperatura', 573.0000, 'ºC'),
	(320108, 144, '2015-01-15 00:29:54.000000', 'temperatura', 814.0000, 'ºC'),
	(320109, 144, '2015-01-15 00:29:55.000000', 'temperatura', 1153.0000, 'ºC'),
	(320110, 144, '2015-01-15 00:29:56.000000', 'temperatura', 925.0000, 'ºC'),
	(320111, 144, '2015-01-15 00:29:57.000000', 'temperatura', 1166.0000, 'ºC'),
	(320112, 144, '2015-01-15 00:29:58.000000', 'temperatura', 653.0000, 'ºC'),
	(320113, 144, '2015-01-15 00:29:59.000000', 'temperatura', 971.0000, 'ºC'),
	(320114, 144, '2015-01-15 00:30:00.000000', 'temperatura', 493.0000, 'ºC'),
	(320115, 144, '2015-01-15 00:30:01.000000', 'temperatura', 756.0000, 'ºC'),
	(320116, 144, '2015-01-15 00:30:02.000000', 'temperatura', 1099.0000, 'ºC'),
	(320117, 144, '2015-01-15 00:30:03.000000', 'temperatura', 828.0000, 'ºC'),
	(320118, 144, '2015-01-15 00:30:04.000000', 'temperatura', 843.0000, 'ºC'),
	(320119, 144, '2015-01-15 00:30:05.000000', 'temperatura', 533.0000, 'ºC'),
	(320120, 144, '2015-01-15 00:30:06.000000', 'temperatura', 135.0000, 'ºC'),
	(320121, 144, '2015-01-15 00:30:07.000000', 'temperatura', 278.0000, 'ºC'),
	(320122, 144, '2015-01-15 00:30:08.000000', 'temperatura', 983.0000, 'ºC'),
	(320123, 144, '2015-01-15 00:30:09.000000', 'temperatura', 483.0000, 'ºC'),
	(320124, 144, '2015-01-15 00:30:10.000000', 'temperatura', 666.0000, 'ºC'),
	(320125, 144, '2015-01-15 00:30:11.000000', 'temperatura', 681.0000, 'ºC'),
	(320126, 144, '2015-01-15 00:30:12.000000', 'temperatura', 207.0000, 'ºC'),
	(320127, 144, '2015-01-15 00:30:13.000000', 'temperatura', 195.0000, 'ºC'),
	(320128, 144, '2015-01-15 00:30:14.000000', 'temperatura', 352.0000, 'ºC'),
	(320129, 144, '2015-01-15 00:30:15.000000', 'temperatura', 1176.0000, 'ºC'),
	(320130, 144, '2015-01-15 00:30:16.000000', 'temperatura', 23.0000, 'ºC'),
	(320131, 144, '2015-01-15 00:30:17.000000', 'temperatura', 188.0000, 'ºC'),
	(320132, 144, '2015-01-15 00:30:18.000000', 'temperatura', 872.0000, 'ºC'),
	(320133, 144, '2015-01-15 00:30:19.000000', 'temperatura', 195.0000, 'ºC'),
	(320134, 144, '2015-01-15 00:30:20.000000', 'temperatura', 760.0000, 'ºC'),
	(320135, 144, '2015-01-15 00:30:21.000000', 'temperatura', 818.0000, 'ºC'),
	(320136, 144, '2015-01-15 00:30:22.000000', 'temperatura', 607.0000, 'ºC'),
	(320137, 144, '2015-01-15 00:30:23.000000', 'temperatura', 585.0000, 'ºC'),
	(320138, 144, '2015-01-15 00:30:24.000000', 'temperatura', 1102.0000, 'ºC'),
	(320139, 144, '2015-01-15 00:30:25.000000', 'temperatura', 155.0000, 'ºC'),
	(320140, 144, '2015-01-15 00:30:26.000000', 'temperatura', 1069.0000, 'ºC'),
	(320141, 144, '2015-01-15 00:30:27.000000', 'temperatura', 83.0000, 'ºC'),
	(320142, 144, '2015-01-15 00:30:28.000000', 'temperatura', 808.0000, 'ºC'),
	(320143, 144, '2015-01-15 00:30:29.000000', 'temperatura', 191.0000, 'ºC'),
	(320144, 144, '2015-01-15 00:30:30.000000', 'temperatura', 933.0000, 'ºC'),
	(320145, 144, '2015-01-15 00:30:31.000000', 'temperatura', 491.0000, 'ºC'),
	(320146, 144, '2015-01-15 00:30:32.000000', 'temperatura', 855.0000, 'ºC'),
	(320147, 144, '2015-01-15 00:30:33.000000', 'temperatura', 403.0000, 'ºC'),
	(320148, 144, '2015-01-15 00:30:34.000000', 'temperatura', 651.0000, 'ºC'),
	(320149, 144, '2015-01-15 00:30:35.000000', 'temperatura', 845.0000, 'ºC'),
	(320150, 144, '2015-01-15 00:30:36.000000', 'temperatura', 1075.0000, 'ºC'),
	(320151, 144, '2015-01-15 00:30:37.000000', 'temperatura', 437.0000, 'ºC'),
	(320152, 144, '2015-01-15 00:30:38.000000', 'temperatura', 164.0000, 'ºC'),
	(320153, 144, '2015-01-15 00:30:39.000000', 'temperatura', 709.0000, 'ºC'),
	(320154, 144, '2015-01-15 00:30:40.000000', 'temperatura', 651.0000, 'ºC'),
	(320155, 144, '2015-01-15 00:30:41.000000', 'temperatura', 1130.0000, 'ºC'),
	(320156, 144, '2015-01-15 00:30:42.000000', 'temperatura', 99.0000, 'ºC'),
	(320157, 144, '2015-01-15 00:30:43.000000', 'temperatura', 706.0000, 'ºC'),
	(320158, 144, '2015-01-15 00:30:44.000000', 'temperatura', 833.0000, 'ºC'),
	(320159, 144, '2015-01-15 00:30:45.000000', 'temperatura', 847.0000, 'ºC'),
	(320160, 144, '2015-01-15 00:30:46.000000', 'temperatura', 538.0000, 'ºC'),
	(320161, 144, '2015-01-15 00:30:47.000000', 'temperatura', 149.0000, 'ºC'),
	(320162, 144, '2015-01-15 00:30:48.000000', 'temperatura', 329.0000, 'ºC'),
	(320163, 144, '2015-01-15 00:30:49.000000', 'temperatura', 0.0000, 'ºC'),
	(320164, 144, '2015-01-15 00:30:50.000000', 'temperatura', 215.0000, 'ºC'),
	(320165, 144, '2015-01-15 00:30:51.000000', 'temperatura', 1073.0000, 'ºC'),
	(320166, 144, '2015-01-15 00:30:52.000000', 'temperatura', 1122.0000, 'ºC'),
	(320167, 144, '2015-01-15 00:30:53.000000', 'temperatura', 1190.0000, 'ºC'),
	(320168, 144, '2015-01-15 00:30:54.000000', 'temperatura', 184.0000, 'ºC'),
	(320169, 144, '2015-01-15 00:30:55.000000', 'temperatura', 950.0000, 'ºC'),
	(320170, 144, '2015-01-15 00:30:56.000000', 'temperatura', 600.0000, 'ºC'),
	(320171, 144, '2015-01-15 00:30:57.000000', 'temperatura', 151.0000, 'ºC'),
	(320172, 144, '2015-01-15 00:30:58.000000', 'temperatura', 157.0000, 'ºC'),
	(320173, 144, '2015-01-15 00:30:59.000000', 'temperatura', 329.0000, 'ºC'),
	(320174, 144, '2015-01-15 00:31:00.000000', 'temperatura', 1177.0000, 'ºC'),
	(320175, 144, '2015-01-15 00:31:01.000000', 'temperatura', 97.0000, 'ºC'),
	(320176, 144, '2015-01-15 00:31:02.000000', 'temperatura', 554.0000, 'ºC'),
	(320177, 144, '2015-01-15 00:31:03.000000', 'temperatura', 81.0000, 'ºC'),
	(320178, 144, '2015-01-15 00:31:04.000000', 'temperatura', 1143.0000, 'ºC'),
	(320179, 144, '2015-01-15 00:31:05.000000', 'temperatura', 670.0000, 'ºC'),
	(320180, 144, '2015-01-15 00:31:06.000000', 'temperatura', 1125.0000, 'ºC'),
	(320181, 144, '2015-01-15 00:31:07.000000', 'temperatura', 14.0000, 'ºC'),
	(320182, 144, '2015-01-15 00:31:08.000000', 'temperatura', 295.0000, 'ºC'),
	(320183, 144, '2015-01-15 00:31:09.000000', 'temperatura', 233.0000, 'ºC'),
	(320184, 144, '2015-01-15 00:31:10.000000', 'temperatura', 283.0000, 'ºC'),
	(320185, 144, '2015-01-15 00:31:11.000000', 'temperatura', 714.0000, 'ºC'),
	(320186, 144, '2015-01-15 00:31:12.000000', 'temperatura', 323.0000, 'ºC'),
	(320187, 144, '2015-01-15 00:31:13.000000', 'temperatura', 673.0000, 'ºC'),
	(320188, 144, '2015-01-15 00:31:14.000000', 'temperatura', 1195.0000, 'ºC'),
	(320189, 144, '2015-01-15 00:31:15.000000', 'temperatura', 359.0000, 'ºC'),
	(320190, 144, '2015-01-15 00:31:16.000000', 'temperatura', 610.0000, 'ºC'),
	(320191, 144, '2015-01-15 00:31:17.000000', 'temperatura', 773.0000, 'ºC'),
	(320192, 144, '2015-01-15 00:31:18.000000', 'temperatura', 835.0000, 'ºC'),
	(320193, 144, '2015-01-15 00:31:19.000000', 'temperatura', 658.0000, 'ºC'),
	(320194, 144, '2015-01-15 00:31:20.000000', 'temperatura', 785.0000, 'ºC'),
	(320195, 144, '2015-01-15 00:31:21.000000', 'temperatura', 750.0000, 'ºC'),
	(320196, 144, '2015-01-15 00:31:22.000000', 'temperatura', 198.0000, 'ºC'),
	(320197, 144, '2015-01-15 00:31:23.000000', 'temperatura', 1137.0000, 'ºC'),
	(320198, 144, '2015-01-15 00:31:24.000000', 'temperatura', 295.0000, 'ºC'),
	(320199, 144, '2015-01-15 00:31:25.000000', 'temperatura', 463.0000, 'ºC'),
	(320200, 144, '2015-01-15 00:31:26.000000', 'temperatura', 229.0000, 'ºC'),
	(320201, 144, '2015-01-15 00:31:27.000000', 'temperatura', 959.0000, 'ºC'),
	(320202, 144, '2015-01-15 00:31:28.000000', 'temperatura', 509.0000, 'ºC'),
	(320203, 144, '2015-01-15 00:31:29.000000', 'temperatura', 867.0000, 'ºC'),
	(320204, 144, '2015-01-15 00:31:30.000000', 'temperatura', 410.0000, 'ºC'),
	(320205, 144, '2015-01-15 00:31:31.000000', 'temperatura', 649.0000, 'ºC'),
	(320206, 144, '2015-01-15 00:31:32.000000', 'temperatura', 814.0000, 'ºC'),
	(320207, 144, '2015-01-15 00:31:33.000000', 'temperatura', 927.0000, 'ºC'),
	(320208, 144, '2015-01-15 00:31:34.000000', 'temperatura', 990.0000, 'ºC'),
	(320209, 144, '2015-01-15 00:31:35.000000', 'temperatura', 969.0000, 'ºC'),
	(320210, 144, '2015-01-15 00:31:36.000000', 'temperatura', 677.0000, 'ºC'),
	(320211, 144, '2015-01-15 00:31:37.000000', 'temperatura', 478.0000, 'ºC'),
	(320212, 144, '2015-01-15 00:31:38.000000', 'temperatura', 359.0000, 'ºC'),
	(320213, 144, '2015-01-15 00:31:39.000000', 'temperatura', 363.0000, 'ºC'),
	(320214, 144, '2015-01-15 00:31:40.000000', 'temperatura', 738.0000, 'ºC'),
	(320215, 144, '2015-01-15 00:31:41.000000', 'temperatura', 203.0000, 'ºC'),
	(320216, 144, '2015-01-15 00:31:42.000000', 'temperatura', 2.0000, 'ºC'),
	(320217, 144, '2015-01-15 00:31:43.000000', 'temperatura', 600.0000, 'ºC'),
	(320218, 144, '2015-01-15 00:31:44.000000', 'temperatura', 594.0000, 'ºC'),
	(320219, 144, '2015-01-15 00:31:45.000000', 'temperatura', 1172.0000, 'ºC'),
	(320220, 144, '2015-01-15 00:31:46.000000', 'temperatura', 479.0000, 'ºC'),
	(320221, 144, '2015-01-15 00:31:47.000000', 'temperatura', 80.0000, 'ºC'),
	(320222, 144, '2015-01-15 00:31:48.000000', 'temperatura', 164.0000, 'ºC'),
	(320223, 144, '2015-01-15 00:31:49.000000', 'temperatura', 578.0000, 'ºC'),
	(320224, 144, '2015-01-15 00:31:50.000000', 'temperatura', 1.0000, 'ºC'),
	(320225, 144, '2015-01-15 00:31:51.000000', 'temperatura', 673.0000, 'ºC'),
	(320226, 144, '2015-01-15 00:31:52.000000', 'temperatura', 959.0000, 'ºC'),
	(320227, 144, '2015-01-15 00:31:53.000000', 'temperatura', 376.0000, 'ºC'),
	(320228, 144, '2015-01-15 00:31:54.000000', 'temperatura', 206.0000, 'ºC'),
	(320229, 144, '2015-01-15 00:31:55.000000', 'temperatura', 1103.0000, 'ºC'),
	(320230, 144, '2015-01-15 00:31:56.000000', 'temperatura', 96.0000, 'ºC'),
	(320231, 144, '2015-01-15 00:31:57.000000', 'temperatura', 771.0000, 'ºC'),
	(320232, 144, '2015-01-15 00:31:58.000000', 'temperatura', 1168.0000, 'ºC'),
	(320233, 144, '2015-01-15 00:31:59.000000', 'temperatura', 1127.0000, 'ºC'),
	(320234, 144, '2015-01-15 00:32:00.000000', 'temperatura', 931.0000, 'ºC'),
	(320235, 144, '2015-01-15 00:32:01.000000', 'temperatura', 73.0000, 'ºC'),
	(320236, 144, '2015-01-15 00:32:02.000000', 'temperatura', 1174.0000, 'ºC'),
	(320237, 144, '2015-01-15 00:32:03.000000', 'temperatura', 853.0000, 'ºC'),
	(320238, 144, '2015-01-15 00:32:04.000000', 'temperatura', 744.0000, 'ºC'),
	(320239, 144, '2015-01-15 00:32:05.000000', 'temperatura', 1161.0000, 'ºC'),
	(320240, 144, '2015-01-15 00:32:06.000000', 'temperatura', 1175.0000, 'ºC'),
	(320241, 144, '2015-01-15 00:32:07.000000', 'temperatura', 1190.0000, 'ºC'),
	(320242, 144, '2015-01-15 00:32:08.000000', 'temperatura', 25.0000, 'ºC'),
	(320243, 144, '2015-01-15 00:32:09.000000', 'temperatura', 157.0000, 'ºC'),
	(320244, 144, '2015-01-15 00:32:10.000000', 'temperatura', 710.0000, 'ºC'),
	(320245, 144, '2015-01-15 00:32:11.000000', 'temperatura', 681.0000, 'ºC'),
	(320246, 144, '2015-01-15 00:32:12.000000', 'temperatura', 76.0000, 'ºC'),
	(320247, 144, '2015-01-15 00:32:13.000000', 'temperatura', 737.0000, 'ºC'),
	(320248, 144, '2015-01-15 00:32:14.000000', 'temperatura', 1057.0000, 'ºC'),
	(320249, 144, '2015-01-15 00:32:15.000000', 'temperatura', 675.0000, 'ºC'),
	(320250, 144, '2015-01-15 00:32:16.000000', 'temperatura', 205.0000, 'ºC'),
	(320251, 144, '2015-01-15 00:32:17.000000', 'temperatura', 200.0000, 'ºC'),
	(320252, 144, '2015-01-15 00:32:18.000000', 'temperatura', 385.0000, 'ºC'),
	(320253, 144, '2015-01-15 00:32:19.000000', 'temperatura', 124.0000, 'ºC'),
	(320254, 144, '2015-01-15 00:32:20.000000', 'temperatura', 666.0000, 'ºC'),
	(320255, 144, '2015-01-15 00:32:21.000000', 'temperatura', 561.0000, 'ºC'),
	(320256, 144, '2015-01-15 00:32:22.000000', 'temperatura', 805.0000, 'ºC'),
	(320257, 144, '2015-01-15 00:32:23.000000', 'temperatura', 1141.0000, 'ºC'),
	(320258, 144, '2015-01-15 00:32:24.000000', 'temperatura', 894.0000, 'ºC'),
	(320259, 144, '2015-01-15 00:32:25.000000', 'temperatura', 1047.0000, 'ºC'),
	(320260, 144, '2015-01-15 00:32:26.000000', 'temperatura', 154.0000, 'ºC'),
	(320261, 144, '2015-01-15 00:32:27.000000', 'temperatura', 27.0000, 'ºC'),
	(320262, 144, '2015-01-15 00:32:28.000000', 'temperatura', 877.0000, 'ºC'),
	(320263, 144, '2015-01-15 00:32:29.000000', 'temperatura', 702.0000, 'ºC'),
	(320264, 144, '2015-01-15 00:32:30.000000', 'temperatura', 878.0000, 'ºC'),
	(320265, 144, '2015-01-15 00:32:31.000000', 'temperatura', 1088.0000, 'ºC'),
	(320266, 144, '2015-01-15 00:32:32.000000', 'temperatura', 403.0000, 'ºC'),
	(320267, 144, '2015-01-15 00:32:33.000000', 'temperatura', 1154.0000, 'ºC'),
	(320268, 144, '2015-01-15 00:32:34.000000', 'temperatura', 960.0000, 'ºC'),
	(320269, 144, '2015-01-15 00:32:35.000000', 'temperatura', 140.0000, 'ºC'),
	(320270, 144, '2015-01-15 00:32:36.000000', 'temperatura', 220.0000, 'ºC'),
	(320271, 144, '2015-01-15 00:32:37.000000', 'temperatura', 679.0000, 'ºC'),
	(320272, 144, '2015-01-15 00:32:38.000000', 'temperatura', 335.0000, 'ºC'),
	(320273, 144, '2015-01-15 00:32:39.000000', 'temperatura', 840.0000, 'ºC'),
	(320274, 144, '2015-01-15 00:32:40.000000', 'temperatura', 795.0000, 'ºC'),
	(320275, 144, '2015-01-15 00:32:41.000000', 'temperatura', 256.0000, 'ºC'),
	(320276, 144, '2015-01-15 00:32:42.000000', 'temperatura', 94.0000, 'ºC'),
	(320277, 144, '2015-01-15 00:32:43.000000', 'temperatura', 902.0000, 'ºC'),
	(320278, 144, '2015-01-15 00:32:44.000000', 'temperatura', 631.0000, 'ºC'),
	(320279, 144, '2015-01-15 00:32:45.000000', 'temperatura', 448.0000, 'ºC'),
	(320280, 144, '2015-01-15 00:32:46.000000', 'temperatura', 349.0000, 'ºC'),
	(320281, 144, '2015-01-15 00:32:47.000000', 'temperatura', 403.0000, 'ºC'),
	(320282, 144, '2015-01-15 00:32:48.000000', 'temperatura', 965.0000, 'ºC'),
	(320283, 144, '2015-01-15 00:32:49.000000', 'temperatura', 18.0000, 'ºC'),
	(320284, 144, '2015-01-15 00:32:50.000000', 'temperatura', 796.0000, 'ºC'),
	(320285, 144, '2015-01-15 00:32:51.000000', 'temperatura', 326.0000, 'ºC'),
	(320286, 144, '2015-01-15 00:32:52.000000', 'temperatura', 441.0000, 'ºC'),
	(320287, 144, '2015-01-15 00:32:53.000000', 'temperatura', 30.0000, 'ºC'),
	(320288, 144, '2015-01-15 00:32:54.000000', 'temperatura', 25.0000, 'ºC'),
	(320289, 144, '2015-01-15 00:32:55.000000', 'temperatura', 36.0000, 'ºC'),
	(320290, 144, '2015-01-15 00:32:56.000000', 'temperatura', 104.0000, 'ºC'),
	(320291, 144, '2015-01-15 00:32:57.000000', 'temperatura', 415.0000, 'ºC'),
	(320292, 144, '2015-01-15 00:32:58.000000', 'temperatura', 562.0000, 'ºC'),
	(320293, 144, '2015-01-15 00:32:59.000000', 'temperatura', 365.0000, 'ºC'),
	(320294, 144, '2015-01-15 00:33:00.000000', 'temperatura', 141.0000, 'ºC'),
	(320295, 144, '2015-01-15 00:33:01.000000', 'temperatura', 811.0000, 'ºC'),
	(320296, 144, '2015-01-15 00:33:02.000000', 'temperatura', 32.0000, 'ºC'),
	(320297, 144, '2015-01-15 00:33:03.000000', 'temperatura', 128.0000, 'ºC'),
	(320298, 144, '2015-01-15 00:33:04.000000', 'temperatura', 545.0000, 'ºC'),
	(320299, 144, '2015-01-15 00:33:05.000000', 'temperatura', 1140.0000, 'ºC'),
	(320300, 144, '2015-01-15 00:33:06.000000', 'temperatura', 468.0000, 'ºC'),
	(320301, 144, '2015-01-15 00:33:07.000000', 'temperatura', 117.0000, 'ºC'),
	(320302, 144, '2015-01-15 00:33:08.000000', 'temperatura', 385.0000, 'ºC'),
	(320303, 144, '2015-01-15 00:33:09.000000', 'temperatura', 373.0000, 'ºC'),
	(320304, 144, '2015-01-15 00:33:10.000000', 'temperatura', 711.0000, 'ºC'),
	(320305, 144, '2015-01-15 00:33:11.000000', 'temperatura', 37.0000, 'ºC'),
	(320306, 144, '2015-01-15 00:33:12.000000', 'temperatura', 453.0000, 'ºC'),
	(320307, 144, '2015-01-15 00:33:13.000000', 'temperatura', 954.0000, 'ºC'),
	(320308, 144, '2015-01-15 00:33:14.000000', 'temperatura', 1013.0000, 'ºC'),
	(320309, 144, '2015-01-15 00:33:15.000000', 'temperatura', 1002.0000, 'ºC'),
	(320310, 144, '2015-01-15 00:33:16.000000', 'temperatura', 773.0000, 'ºC'),
	(320311, 144, '2015-01-15 00:33:17.000000', 'temperatura', 858.0000, 'ºC'),
	(320312, 144, '2015-01-15 00:33:18.000000', 'temperatura', 772.0000, 'ºC'),
	(320313, 144, '2015-01-15 00:33:19.000000', 'temperatura', 85.0000, 'ºC'),
	(320314, 144, '2015-01-15 00:33:20.000000', 'temperatura', 510.0000, 'ºC'),
	(320315, 144, '2015-01-15 00:33:21.000000', 'temperatura', 1097.0000, 'ºC'),
	(320316, 144, '2015-01-15 00:33:22.000000', 'temperatura', 355.0000, 'ºC'),
	(320317, 144, '2015-01-15 00:33:23.000000', 'temperatura', 884.0000, 'ºC'),
	(320318, 144, '2015-01-15 00:33:24.000000', 'temperatura', 955.0000, 'ºC'),
	(320319, 144, '2015-01-15 00:33:25.000000', 'temperatura', 923.0000, 'ºC'),
	(320320, 144, '2015-01-15 00:33:26.000000', 'temperatura', 549.0000, 'ºC'),
	(320321, 144, '2015-01-15 00:33:27.000000', 'temperatura', 1180.0000, 'ºC'),
	(320322, 144, '2015-01-15 00:33:28.000000', 'temperatura', 653.0000, 'ºC'),
	(320323, 144, '2015-01-15 00:33:29.000000', 'temperatura', 924.0000, 'ºC'),
	(320324, 144, '2015-01-15 00:33:30.000000', 'temperatura', 261.0000, 'ºC'),
	(320325, 144, '2015-01-15 00:33:31.000000', 'temperatura', 934.0000, 'ºC'),
	(320326, 144, '2015-01-15 00:33:32.000000', 'temperatura', 290.0000, 'ºC'),
	(320327, 144, '2015-01-15 00:33:33.000000', 'temperatura', 1046.0000, 'ºC'),
	(320328, 144, '2015-01-15 00:33:34.000000', 'temperatura', 761.0000, 'ºC'),
	(320329, 144, '2015-01-15 00:33:35.000000', 'temperatura', 666.0000, 'ºC'),
	(320330, 144, '2015-01-15 00:33:36.000000', 'temperatura', 1049.0000, 'ºC'),
	(320331, 144, '2015-01-15 00:33:37.000000', 'temperatura', 847.0000, 'ºC'),
	(320332, 144, '2015-01-15 00:33:38.000000', 'temperatura', 1088.0000, 'ºC'),
	(320333, 144, '2015-01-15 00:33:39.000000', 'temperatura', 499.0000, 'ºC'),
	(320334, 144, '2015-01-15 00:33:40.000000', 'temperatura', 430.0000, 'ºC'),
	(320335, 144, '2015-01-15 00:33:41.000000', 'temperatura', 656.0000, 'ºC'),
	(320336, 144, '2015-01-15 00:33:42.000000', 'temperatura', 790.0000, 'ºC'),
	(320337, 144, '2015-01-15 00:33:43.000000', 'temperatura', 782.0000, 'ºC'),
	(320338, 144, '2015-01-15 00:33:44.000000', 'temperatura', 341.0000, 'ºC'),
	(320339, 144, '2015-01-15 00:33:45.000000', 'temperatura', 561.0000, 'ºC'),
	(320340, 144, '2015-01-15 00:33:46.000000', 'temperatura', 580.0000, 'ºC'),
	(320341, 144, '2015-01-15 00:33:47.000000', 'temperatura', 19.0000, 'ºC'),
	(320342, 144, '2015-01-15 00:33:48.000000', 'temperatura', 754.0000, 'ºC'),
	(320343, 144, '2015-01-15 00:33:49.000000', 'temperatura', 115.0000, 'ºC'),
	(320344, 144, '2015-01-15 00:33:50.000000', 'temperatura', 713.0000, 'ºC'),
	(320345, 144, '2015-01-15 00:33:51.000000', 'temperatura', 819.0000, 'ºC'),
	(320346, 144, '2015-01-15 00:33:52.000000', 'temperatura', 758.0000, 'ºC'),
	(320347, 144, '2015-01-15 00:33:53.000000', 'temperatura', 135.0000, 'ºC'),
	(320348, 144, '2015-01-15 00:33:54.000000', 'temperatura', 801.0000, 'ºC'),
	(320349, 144, '2015-01-15 00:33:55.000000', 'temperatura', 0.0000, 'ºC'),
	(320350, 144, '2015-01-15 00:33:56.000000', 'temperatura', 1198.0000, 'ºC'),
	(320351, 144, '2015-01-15 00:33:57.000000', 'temperatura', 1190.0000, 'ºC'),
	(320352, 144, '2015-01-15 00:33:58.000000', 'temperatura', 1158.0000, 'ºC'),
	(320353, 144, '2015-01-15 00:33:59.000000', 'temperatura', 1019.0000, 'ºC'),
	(320354, 144, '2015-01-15 00:34:00.000000', 'temperatura', 422.0000, 'ºC'),
	(320355, 144, '2015-01-15 00:34:01.000000', 'temperatura', 253.0000, 'ºC'),
	(320356, 144, '2015-01-15 00:34:02.000000', 'temperatura', 1199.0000, 'ºC'),
	(320357, 144, '2015-01-15 00:34:03.000000', 'temperatura', 439.0000, 'ºC'),
	(320358, 144, '2015-01-15 00:34:04.000000', 'temperatura', 996.0000, 'ºC'),
	(320359, 144, '2015-01-15 00:34:05.000000', 'temperatura', 63.0000, 'ºC'),
	(320360, 144, '2015-01-15 00:34:06.000000', 'temperatura', 927.0000, 'ºC'),
	(320361, 144, '2015-01-15 00:34:07.000000', 'temperatura', 847.0000, 'ºC'),
	(320362, 144, '2015-01-15 00:34:08.000000', 'temperatura', 255.0000, 'ºC'),
	(320363, 144, '2015-01-15 00:34:09.000000', 'temperatura', 1135.0000, 'ºC'),
	(320364, 144, '2015-01-15 00:34:10.000000', 'temperatura', 110.0000, 'ºC'),
	(320365, 144, '2015-01-15 00:34:11.000000', 'temperatura', 746.0000, 'ºC'),
	(320366, 144, '2015-01-15 00:34:12.000000', 'temperatura', 1000.0000, 'ºC'),
	(320367, 144, '2015-01-15 00:34:13.000000', 'temperatura', 362.0000, 'ºC'),
	(320368, 144, '2015-01-15 00:34:14.000000', 'temperatura', 10.0000, 'ºC'),
	(320369, 144, '2015-01-15 00:34:15.000000', 'temperatura', 165.0000, 'ºC'),
	(320370, 144, '2015-01-15 00:34:16.000000', 'temperatura', 794.0000, 'ºC'),
	(320371, 144, '2015-01-15 00:34:17.000000', 'temperatura', 1076.0000, 'ºC'),
	(320372, 144, '2015-01-15 00:34:18.000000', 'temperatura', 598.0000, 'ºC'),
	(320373, 144, '2015-01-15 00:34:19.000000', 'temperatura', 965.0000, 'ºC'),
	(320374, 144, '2015-01-15 00:34:20.000000', 'temperatura', 630.0000, 'ºC'),
	(320375, 144, '2015-01-15 00:34:21.000000', 'temperatura', 257.0000, 'ºC'),
	(320376, 144, '2015-01-15 00:34:22.000000', 'temperatura', 594.0000, 'ºC'),
	(320377, 144, '2015-01-15 00:34:23.000000', 'temperatura', 1002.0000, 'ºC'),
	(320378, 144, '2015-01-15 00:34:24.000000', 'temperatura', 825.0000, 'ºC'),
	(320379, 144, '2015-01-15 00:34:25.000000', 'temperatura', 1121.0000, 'ºC'),
	(320380, 144, '2015-01-15 00:34:26.000000', 'temperatura', 729.0000, 'ºC'),
	(320381, 144, '2015-01-15 00:34:27.000000', 'temperatura', 284.0000, 'ºC'),
	(320382, 144, '2015-01-15 00:34:28.000000', 'temperatura', 433.0000, 'ºC'),
	(320383, 144, '2015-01-15 00:34:29.000000', 'temperatura', 115.0000, 'ºC'),
	(320384, 144, '2015-01-15 00:34:30.000000', 'temperatura', 476.0000, 'ºC'),
	(320385, 144, '2015-01-15 00:34:31.000000', 'temperatura', 836.0000, 'ºC'),
	(320386, 144, '2015-01-15 00:34:32.000000', 'temperatura', 351.0000, 'ºC'),
	(320387, 144, '2015-01-15 00:34:33.000000', 'temperatura', 449.0000, 'ºC'),
	(320388, 144, '2015-01-15 00:34:34.000000', 'temperatura', 1191.0000, 'ºC'),
	(320389, 144, '2015-01-15 00:34:35.000000', 'temperatura', 1011.0000, 'ºC'),
	(320390, 144, '2015-01-15 00:34:36.000000', 'temperatura', 282.0000, 'ºC'),
	(320391, 144, '2015-01-15 00:34:37.000000', 'temperatura', 777.0000, 'ºC'),
	(320392, 144, '2015-01-15 00:34:38.000000', 'temperatura', 638.0000, 'ºC'),
	(320393, 144, '2015-01-15 00:34:39.000000', 'temperatura', 859.0000, 'ºC'),
	(320394, 144, '2015-01-15 00:34:40.000000', 'temperatura', 1182.0000, 'ºC'),
	(320395, 144, '2015-01-15 00:34:41.000000', 'temperatura', 934.0000, 'ºC'),
	(320396, 144, '2015-01-15 00:34:42.000000', 'temperatura', 1127.0000, 'ºC'),
	(320397, 144, '2015-01-15 00:34:43.000000', 'temperatura', 430.0000, 'ºC'),
	(320398, 144, '2015-01-15 00:34:44.000000', 'temperatura', 1169.0000, 'ºC'),
	(320399, 144, '2015-01-15 00:34:45.000000', 'temperatura', 957.0000, 'ºC'),
	(320400, 144, '2015-01-15 00:34:46.000000', 'temperatura', 78.0000, 'ºC'),
	(320401, 144, '2015-01-15 00:34:47.000000', 'temperatura', 1121.0000, 'ºC'),
	(320402, 144, '2015-01-15 00:34:48.000000', 'temperatura', 573.0000, 'ºC'),
	(320403, 144, '2015-01-15 00:34:49.000000', 'temperatura', 699.0000, 'ºC'),
	(320404, 144, '2015-01-15 00:34:50.000000', 'temperatura', 580.0000, 'ºC'),
	(320405, 144, '2015-01-15 00:34:51.000000', 'temperatura', 800.0000, 'ºC'),
	(320406, 144, '2015-01-15 00:34:52.000000', 'temperatura', 1062.0000, 'ºC'),
	(320407, 144, '2015-01-15 00:34:53.000000', 'temperatura', 511.0000, 'ºC'),
	(320408, 144, '2015-01-15 00:34:54.000000', 'temperatura', 568.0000, 'ºC'),
	(320409, 144, '2015-01-15 00:34:55.000000', 'temperatura', 109.0000, 'ºC'),
	(320410, 144, '2015-01-15 00:34:56.000000', 'temperatura', 42.0000, 'ºC'),
	(320411, 144, '2015-01-15 00:34:57.000000', 'temperatura', 1083.0000, 'ºC'),
	(320412, 144, '2015-01-15 00:34:58.000000', 'temperatura', 491.0000, 'ºC'),
	(320413, 144, '2015-01-15 00:34:59.000000', 'temperatura', 404.0000, 'ºC'),
	(320414, 144, '2015-01-15 00:35:00.000000', 'temperatura', 550.0000, 'ºC'),
	(320415, 144, '2015-01-15 00:35:01.000000', 'temperatura', 335.0000, 'ºC'),
	(320416, 144, '2015-01-15 00:35:02.000000', 'temperatura', 29.0000, 'ºC'),
	(320417, 144, '2015-01-15 00:35:03.000000', 'temperatura', 340.0000, 'ºC'),
	(320418, 144, '2015-01-15 00:35:04.000000', 'temperatura', 411.0000, 'ºC'),
	(320419, 144, '2015-01-15 00:35:05.000000', 'temperatura', 1038.0000, 'ºC'),
	(320420, 144, '2015-01-15 00:35:06.000000', 'temperatura', 355.0000, 'ºC'),
	(320421, 144, '2015-01-15 00:35:07.000000', 'temperatura', 1064.0000, 'ºC'),
	(320422, 144, '2015-01-15 00:35:08.000000', 'temperatura', 653.0000, 'ºC'),
	(320423, 144, '2015-01-15 00:35:09.000000', 'temperatura', 74.0000, 'ºC'),
	(320424, 144, '2015-01-15 00:35:10.000000', 'temperatura', 810.0000, 'ºC'),
	(320425, 144, '2015-01-15 00:35:11.000000', 'temperatura', 229.0000, 'ºC'),
	(320426, 144, '2015-01-15 00:35:12.000000', 'temperatura', 1118.0000, 'ºC'),
	(320427, 144, '2015-01-15 00:35:13.000000', 'temperatura', 101.0000, 'ºC'),
	(320428, 144, '2015-01-15 00:35:14.000000', 'temperatura', 752.0000, 'ºC'),
	(320429, 144, '2015-01-15 00:35:15.000000', 'temperatura', 1060.0000, 'ºC'),
	(320430, 144, '2015-01-15 00:35:16.000000', 'temperatura', 642.0000, 'ºC'),
	(320431, 144, '2015-01-15 00:35:17.000000', 'temperatura', 29.0000, 'ºC'),
	(320432, 144, '2015-01-15 00:35:18.000000', 'temperatura', 622.0000, 'ºC'),
	(320433, 144, '2015-01-15 00:35:19.000000', 'temperatura', 623.0000, 'ºC'),
	(320434, 144, '2015-01-15 00:35:20.000000', 'temperatura', 48.0000, 'ºC'),
	(320435, 144, '2015-01-15 00:35:21.000000', 'temperatura', 771.0000, 'ºC'),
	(320436, 144, '2015-01-15 00:35:22.000000', 'temperatura', 112.0000, 'ºC'),
	(320437, 144, '2015-01-15 00:35:23.000000', 'temperatura', 650.0000, 'ºC'),
	(320438, 144, '2015-01-15 00:35:24.000000', 'temperatura', 513.0000, 'ºC'),
	(320439, 144, '2015-01-15 00:35:25.000000', 'temperatura', 615.0000, 'ºC'),
	(320440, 144, '2015-01-15 00:35:26.000000', 'temperatura', 338.0000, 'ºC'),
	(320441, 144, '2015-01-15 00:35:27.000000', 'temperatura', 1045.0000, 'ºC'),
	(320442, 144, '2015-01-15 00:35:28.000000', 'temperatura', 613.0000, 'ºC'),
	(320443, 144, '2015-01-15 00:35:29.000000', 'temperatura', 1130.0000, 'ºC'),
	(320444, 144, '2015-01-15 00:35:30.000000', 'temperatura', 209.0000, 'ºC'),
	(320445, 144, '2015-01-15 00:35:31.000000', 'temperatura', 58.0000, 'ºC'),
	(320446, 144, '2015-01-15 00:35:32.000000', 'temperatura', 865.0000, 'ºC'),
	(320447, 144, '2015-01-15 00:35:33.000000', 'temperatura', 548.0000, 'ºC'),
	(320448, 144, '2015-01-15 00:35:34.000000', 'temperatura', 146.0000, 'ºC'),
	(320449, 144, '2015-01-15 00:35:35.000000', 'temperatura', 289.0000, 'ºC'),
	(320450, 144, '2015-01-15 00:35:36.000000', 'temperatura', 1005.0000, 'ºC'),
	(320451, 144, '2015-01-15 00:35:37.000000', 'temperatura', 559.0000, 'ºC'),
	(320452, 144, '2015-01-15 00:35:38.000000', 'temperatura', 981.0000, 'ºC'),
	(320453, 144, '2015-01-15 00:35:39.000000', 'temperatura', 830.0000, 'ºC'),
	(320454, 144, '2015-01-15 00:35:40.000000', 'temperatura', 8.0000, 'ºC'),
	(320455, 144, '2015-01-15 00:35:41.000000', 'temperatura', 1148.0000, 'ºC'),
	(320456, 144, '2015-01-15 00:35:42.000000', 'temperatura', 919.0000, 'ºC'),
	(320457, 144, '2015-01-15 00:35:43.000000', 'temperatura', 1151.0000, 'ºC'),
	(320458, 144, '2015-01-15 00:35:44.000000', 'temperatura', 597.0000, 'ºC'),
	(320459, 144, '2015-01-15 00:35:45.000000', 'temperatura', 733.0000, 'ºC'),
	(320460, 144, '2015-01-15 00:35:46.000000', 'temperatura', 676.0000, 'ºC'),
	(320461, 144, '2015-01-15 00:35:47.000000', 'temperatura', 1181.0000, 'ºC'),
	(320462, 144, '2015-01-15 00:35:48.000000', 'temperatura', 278.0000, 'ºC'),
	(320463, 144, '2015-01-15 00:35:49.000000', 'temperatura', 249.0000, 'ºC'),
	(320464, 144, '2015-01-15 00:35:50.000000', 'temperatura', 410.0000, 'ºC'),
	(320465, 144, '2015-01-15 00:35:51.000000', 'temperatura', 105.0000, 'ºC'),
	(320466, 144, '2015-01-15 00:35:52.000000', 'temperatura', 494.0000, 'ºC'),
	(320467, 144, '2015-01-15 00:35:53.000000', 'temperatura', 958.0000, 'ºC'),
	(320468, 144, '2015-01-15 00:35:54.000000', 'temperatura', 905.0000, 'ºC'),
	(320469, 144, '2015-01-15 00:35:55.000000', 'temperatura', 453.0000, 'ºC'),
	(320470, 144, '2015-01-15 00:35:56.000000', 'temperatura', 751.0000, 'ºC'),
	(320471, 144, '2015-01-15 00:35:57.000000', 'temperatura', 1194.0000, 'ºC'),
	(320472, 144, '2015-01-15 00:35:58.000000', 'temperatura', 119.0000, 'ºC'),
	(320473, 144, '2015-01-15 00:35:59.000000', 'temperatura', 615.0000, 'ºC'),
	(320474, 144, '2015-01-15 00:36:00.000000', 'temperatura', 319.0000, 'ºC'),
	(320475, 144, '2015-01-15 00:36:01.000000', 'temperatura', 950.0000, 'ºC'),
	(320476, 144, '2015-01-15 00:36:02.000000', 'temperatura', 191.0000, 'ºC'),
	(320477, 144, '2015-01-15 00:36:03.000000', 'temperatura', 507.0000, 'ºC'),
	(320478, 144, '2015-01-15 00:36:04.000000', 'temperatura', 764.0000, 'ºC'),
	(320479, 144, '2015-01-15 00:36:05.000000', 'temperatura', 1097.0000, 'ºC'),
	(320480, 144, '2015-01-15 00:36:06.000000', 'temperatura', 796.0000, 'ºC'),
	(320481, 144, '2015-01-15 00:36:07.000000', 'temperatura', 690.0000, 'ºC'),
	(320482, 144, '2015-01-15 00:36:08.000000', 'temperatura', 1060.0000, 'ºC'),
	(320483, 144, '2015-01-15 00:36:09.000000', 'temperatura', 833.0000, 'ºC'),
	(320484, 144, '2015-01-15 00:36:10.000000', 'temperatura', 982.0000, 'ºC'),
	(320485, 144, '2015-01-15 00:36:11.000000', 'temperatura', 15.0000, 'ºC'),
	(320486, 144, '2015-01-15 00:36:12.000000', 'temperatura', 726.0000, 'ºC'),
	(320487, 144, '2015-01-15 00:36:13.000000', 'temperatura', 1188.0000, 'ºC'),
	(320488, 144, '2015-01-15 00:36:14.000000', 'temperatura', 163.0000, 'ºC'),
	(320489, 144, '2015-01-15 00:36:15.000000', 'temperatura', 850.0000, 'ºC'),
	(320490, 144, '2015-01-15 00:36:16.000000', 'temperatura', 163.0000, 'ºC'),
	(320491, 144, '2015-01-15 00:36:17.000000', 'temperatura', 664.0000, 'ºC'),
	(320492, 144, '2015-01-15 00:36:18.000000', 'temperatura', 434.0000, 'ºC'),
	(320493, 144, '2015-01-15 00:36:19.000000', 'temperatura', 176.0000, 'ºC'),
	(320494, 144, '2015-01-15 00:36:20.000000', 'temperatura', 781.0000, 'ºC'),
	(320495, 144, '2015-01-15 00:36:21.000000', 'temperatura', 976.0000, 'ºC'),
	(320496, 144, '2015-01-15 00:36:22.000000', 'temperatura', 138.0000, 'ºC'),
	(320497, 144, '2015-01-15 00:36:23.000000', 'temperatura', 164.0000, 'ºC'),
	(320498, 144, '2015-01-15 00:36:24.000000', 'temperatura', 405.0000, 'ºC'),
	(320499, 144, '2015-01-15 00:36:25.000000', 'temperatura', 334.0000, 'ºC'),
	(320500, 144, '2015-01-15 00:36:26.000000', 'temperatura', 456.0000, 'ºC'),
	(320501, 144, '2015-01-15 00:36:27.000000', 'temperatura', 77.0000, 'ºC'),
	(320502, 144, '2015-01-15 00:36:28.000000', 'temperatura', 219.0000, 'ºC'),
	(320503, 144, '2015-01-15 00:36:29.000000', 'temperatura', 864.0000, 'ºC'),
	(320504, 144, '2015-01-15 00:36:30.000000', 'temperatura', 62.0000, 'ºC'),
	(320505, 144, '2015-01-15 00:36:31.000000', 'temperatura', 121.0000, 'ºC'),
	(320506, 144, '2015-01-15 00:36:32.000000', 'temperatura', 417.0000, 'ºC'),
	(320507, 144, '2015-01-15 00:36:33.000000', 'temperatura', 522.0000, 'ºC'),
	(320508, 144, '2015-01-15 00:36:34.000000', 'temperatura', 159.0000, 'ºC'),
	(320509, 144, '2015-01-15 00:36:35.000000', 'temperatura', 429.0000, 'ºC'),
	(320510, 144, '2015-01-15 00:36:36.000000', 'temperatura', 470.0000, 'ºC'),
	(320511, 144, '2015-01-15 00:36:37.000000', 'temperatura', 1062.0000, 'ºC'),
	(320512, 144, '2015-01-15 00:36:38.000000', 'temperatura', 302.0000, 'ºC'),
	(320513, 144, '2015-01-15 00:36:39.000000', 'temperatura', 723.0000, 'ºC'),
	(320514, 144, '2015-01-15 00:36:40.000000', 'temperatura', 309.0000, 'ºC'),
	(320515, 144, '2015-01-15 00:36:41.000000', 'temperatura', 576.0000, 'ºC'),
	(320516, 144, '2015-01-15 00:36:42.000000', 'temperatura', 756.0000, 'ºC'),
	(320517, 144, '2015-01-15 00:36:43.000000', 'temperatura', 850.0000, 'ºC'),
	(320518, 144, '2015-01-15 00:36:44.000000', 'temperatura', 785.0000, 'ºC'),
	(320519, 144, '2015-01-15 00:36:45.000000', 'temperatura', 176.0000, 'ºC'),
	(320520, 144, '2015-01-15 00:36:46.000000', 'temperatura', 926.0000, 'ºC'),
	(320521, 144, '2015-01-15 00:36:47.000000', 'temperatura', 500.0000, 'ºC'),
	(320522, 144, '2015-01-15 00:36:48.000000', 'temperatura', 922.0000, 'ºC'),
	(320523, 144, '2015-01-15 00:36:49.000000', 'temperatura', 710.0000, 'ºC'),
	(320524, 144, '2015-01-15 00:36:50.000000', 'temperatura', 785.0000, 'ºC'),
	(320525, 144, '2015-01-15 00:36:51.000000', 'temperatura', 597.0000, 'ºC'),
	(320526, 144, '2015-01-15 00:36:52.000000', 'temperatura', 631.0000, 'ºC'),
	(320527, 144, '2015-01-15 00:36:53.000000', 'temperatura', 165.0000, 'ºC'),
	(320528, 144, '2015-01-15 00:36:54.000000', 'temperatura', 130.0000, 'ºC'),
	(320529, 144, '2015-01-15 00:36:55.000000', 'temperatura', 156.0000, 'ºC'),
	(320530, 144, '2015-01-15 00:36:56.000000', 'temperatura', 391.0000, 'ºC'),
	(320531, 144, '2015-01-15 00:36:57.000000', 'temperatura', 288.0000, 'ºC'),
	(320532, 144, '2015-01-15 00:36:58.000000', 'temperatura', 268.0000, 'ºC'),
	(320533, 144, '2015-01-15 00:36:59.000000', 'temperatura', 475.0000, 'ºC'),
	(320534, 144, '2015-01-15 00:37:00.000000', 'temperatura', 373.0000, 'ºC'),
	(320535, 144, '2015-01-15 00:37:01.000000', 'temperatura', 441.0000, 'ºC'),
	(320536, 144, '2015-01-15 00:37:02.000000', 'temperatura', 1085.0000, 'ºC'),
	(320537, 144, '2015-01-15 00:37:03.000000', 'temperatura', 503.0000, 'ºC'),
	(320538, 144, '2015-01-15 00:37:04.000000', 'temperatura', 461.0000, 'ºC'),
	(320539, 144, '2015-01-15 00:37:05.000000', 'temperatura', 796.0000, 'ºC'),
	(320540, 144, '2015-01-15 00:37:06.000000', 'temperatura', 199.0000, 'ºC'),
	(320541, 144, '2015-01-15 00:37:07.000000', 'temperatura', 1005.0000, 'ºC'),
	(320542, 144, '2015-01-15 00:37:08.000000', 'temperatura', 830.0000, 'ºC'),
	(320543, 144, '2015-01-15 00:37:09.000000', 'temperatura', 1135.0000, 'ºC'),
	(320544, 144, '2015-01-15 00:37:10.000000', 'temperatura', 786.0000, 'ºC'),
	(320545, 144, '2015-01-15 00:37:11.000000', 'temperatura', 525.0000, 'ºC'),
	(320546, 144, '2015-01-15 00:37:12.000000', 'temperatura', 268.0000, 'ºC'),
	(320547, 144, '2015-01-15 00:37:13.000000', 'temperatura', 966.0000, 'ºC'),
	(320548, 144, '2015-01-15 00:37:14.000000', 'temperatura', 427.0000, 'ºC'),
	(320549, 144, '2015-01-15 00:37:15.000000', 'temperatura', 436.0000, 'ºC'),
	(320550, 144, '2015-01-15 00:37:16.000000', 'temperatura', 898.0000, 'ºC'),
	(320551, 144, '2015-01-15 00:37:17.000000', 'temperatura', 785.0000, 'ºC'),
	(320552, 144, '2015-01-15 00:37:18.000000', 'temperatura', 30.0000, 'ºC'),
	(320553, 144, '2015-01-15 00:37:19.000000', 'temperatura', 194.0000, 'ºC'),
	(320554, 144, '2015-01-15 00:37:20.000000', 'temperatura', 882.0000, 'ºC'),
	(320555, 144, '2015-01-15 00:37:21.000000', 'temperatura', 229.0000, 'ºC'),
	(320556, 144, '2015-01-15 00:37:22.000000', 'temperatura', 900.0000, 'ºC'),
	(320557, 144, '2015-01-15 00:37:23.000000', 'temperatura', 214.0000, 'ºC'),
	(320558, 144, '2015-01-15 00:37:24.000000', 'temperatura', 769.0000, 'ºC'),
	(320559, 144, '2015-01-15 00:37:25.000000', 'temperatura', 806.0000, 'ºC'),
	(320560, 144, '2015-01-15 00:37:26.000000', 'temperatura', 522.0000, 'ºC'),
	(320561, 144, '2015-01-15 00:37:27.000000', 'temperatura', 194.0000, 'ºC'),
	(320562, 144, '2015-01-15 00:37:28.000000', 'temperatura', 604.0000, 'ºC'),
	(320563, 144, '2015-01-15 00:37:29.000000', 'temperatura', 37.0000, 'ºC'),
	(320564, 144, '2015-01-15 00:37:30.000000', 'temperatura', 776.0000, 'ºC'),
	(320565, 144, '2015-01-15 00:37:31.000000', 'temperatura', 167.0000, 'ºC'),
	(320566, 144, '2015-01-15 00:37:32.000000', 'temperatura', 910.0000, 'ºC'),
	(320567, 144, '2015-01-15 00:37:33.000000', 'temperatura', 448.0000, 'ºC'),
	(320568, 144, '2015-01-15 00:37:34.000000', 'temperatura', 711.0000, 'ºC'),
	(320569, 144, '2015-01-15 00:37:35.000000', 'temperatura', 1011.0000, 'ºC'),
	(320570, 144, '2015-01-15 00:37:36.000000', 'temperatura', 522.0000, 'ºC'),
	(320571, 144, '2015-01-15 00:37:37.000000', 'temperatura', 778.0000, 'ºC'),
	(320572, 144, '2015-01-15 00:37:38.000000', 'temperatura', 1124.0000, 'ºC'),
	(320573, 144, '2015-01-15 00:37:39.000000', 'temperatura', 887.0000, 'ºC'),
	(320574, 144, '2015-01-15 00:37:40.000000', 'temperatura', 1065.0000, 'ºC'),
	(320575, 144, '2015-01-15 00:37:41.000000', 'temperatura', 262.0000, 'ºC'),
	(320576, 144, '2015-01-15 00:37:42.000000', 'temperatura', 516.0000, 'ºC'),
	(320577, 144, '2015-01-15 00:37:43.000000', 'temperatura', 595.0000, 'ºC'),
	(320578, 144, '2015-01-15 00:37:44.000000', 'temperatura', 227.0000, 'ºC'),
	(320579, 144, '2015-01-15 00:37:45.000000', 'temperatura', 550.0000, 'ºC'),
	(320580, 144, '2015-01-15 00:37:46.000000', 'temperatura', 872.0000, 'ºC'),
	(320581, 144, '2015-01-15 00:37:47.000000', 'temperatura', 310.0000, 'ºC'),
	(320582, 144, '2015-01-15 00:37:48.000000', 'temperatura', 133.0000, 'ºC'),
	(320583, 144, '2015-01-15 00:37:49.000000', 'temperatura', 937.0000, 'ºC'),
	(320584, 144, '2015-01-15 00:37:50.000000', 'temperatura', 685.0000, 'ºC'),
	(320585, 144, '2015-01-15 00:37:51.000000', 'temperatura', 615.0000, 'ºC'),
	(320586, 144, '2015-01-15 00:37:52.000000', 'temperatura', 1020.0000, 'ºC'),
	(320587, 144, '2015-01-15 00:37:53.000000', 'temperatura', 855.0000, 'ºC'),
	(320588, 144, '2015-01-15 00:37:54.000000', 'temperatura', 15.0000, 'ºC'),
	(320589, 144, '2015-01-15 00:37:55.000000', 'temperatura', 1110.0000, 'ºC'),
	(320590, 144, '2015-01-15 00:37:56.000000', 'temperatura', 705.0000, 'ºC'),
	(320591, 144, '2015-01-15 00:37:57.000000', 'temperatura', 197.0000, 'ºC'),
	(320592, 144, '2015-01-15 00:37:58.000000', 'temperatura', 70.0000, 'ºC'),
	(320593, 144, '2015-01-15 00:37:59.000000', 'temperatura', 960.0000, 'ºC'),
	(320594, 144, '2015-01-15 00:38:00.000000', 'temperatura', 992.0000, 'ºC'),
	(320595, 144, '2015-01-15 00:38:01.000000', 'temperatura', 880.0000, 'ºC'),
	(320596, 144, '2015-01-15 00:38:02.000000', 'temperatura', 225.0000, 'ºC'),
	(320597, 144, '2015-01-15 00:38:03.000000', 'temperatura', 886.0000, 'ºC'),
	(320598, 144, '2015-01-15 00:38:04.000000', 'temperatura', 153.0000, 'ºC'),
	(320599, 144, '2015-01-15 00:38:05.000000', 'temperatura', 510.0000, 'ºC'),
	(320600, 144, '2015-01-15 00:38:06.000000', 'temperatura', 893.0000, 'ºC'),
	(320601, 144, '2015-01-15 00:38:07.000000', 'temperatura', 532.0000, 'ºC'),
	(320602, 144, '2015-01-15 00:38:08.000000', 'temperatura', 1183.0000, 'ºC'),
	(320603, 144, '2015-01-15 00:38:09.000000', 'temperatura', 720.0000, 'ºC'),
	(320604, 144, '2015-01-15 00:38:10.000000', 'temperatura', 51.0000, 'ºC'),
	(320605, 144, '2015-01-15 00:38:11.000000', 'temperatura', 497.0000, 'ºC'),
	(320606, 144, '2015-01-15 00:38:12.000000', 'temperatura', 1130.0000, 'ºC'),
	(320607, 144, '2015-01-15 00:38:13.000000', 'temperatura', 560.0000, 'ºC'),
	(320608, 144, '2015-01-15 00:38:14.000000', 'temperatura', 610.0000, 'ºC'),
	(320609, 144, '2015-01-15 00:38:15.000000', 'temperatura', 173.0000, 'ºC'),
	(320610, 144, '2015-01-15 00:38:16.000000', 'temperatura', 234.0000, 'ºC'),
	(320611, 144, '2015-01-15 00:38:17.000000', 'temperatura', 650.0000, 'ºC'),
	(320612, 144, '2015-01-15 00:38:18.000000', 'temperatura', 149.0000, 'ºC'),
	(320613, 144, '2015-01-15 00:38:19.000000', 'temperatura', 1196.0000, 'ºC'),
	(320614, 144, '2015-01-15 00:38:20.000000', 'temperatura', 734.0000, 'ºC'),
	(320615, 144, '2015-01-15 00:38:21.000000', 'temperatura', 82.0000, 'ºC'),
	(320616, 144, '2015-01-15 00:38:22.000000', 'temperatura', 608.0000, 'ºC'),
	(320617, 144, '2015-01-15 00:38:23.000000', 'temperatura', 396.0000, 'ºC'),
	(320618, 144, '2015-01-15 00:38:24.000000', 'temperatura', 157.0000, 'ºC'),
	(320619, 144, '2015-01-15 00:38:25.000000', 'temperatura', 797.0000, 'ºC'),
	(320620, 144, '2015-01-15 00:38:26.000000', 'temperatura', 1115.0000, 'ºC'),
	(320621, 144, '2015-01-15 00:38:27.000000', 'temperatura', 786.0000, 'ºC'),
	(320622, 144, '2015-01-15 00:38:28.000000', 'temperatura', 584.0000, 'ºC'),
	(320623, 144, '2015-01-15 00:38:29.000000', 'temperatura', 563.0000, 'ºC'),
	(320624, 144, '2015-01-15 00:38:30.000000', 'temperatura', 1061.0000, 'ºC'),
	(320625, 144, '2015-01-15 00:38:31.000000', 'temperatura', 19.0000, 'ºC'),
	(320626, 144, '2015-01-15 00:38:32.000000', 'temperatura', 512.0000, 'ºC'),
	(320627, 144, '2015-01-15 00:38:33.000000', 'temperatura', 105.0000, 'ºC'),
	(320628, 144, '2015-01-15 00:38:34.000000', 'temperatura', 188.0000, 'ºC'),
	(320629, 144, '2015-01-15 00:38:35.000000', 'temperatura', 628.0000, 'ºC'),
	(320630, 144, '2015-01-15 00:38:36.000000', 'temperatura', 173.0000, 'ºC'),
	(320631, 144, '2015-01-15 00:38:37.000000', 'temperatura', 184.0000, 'ºC'),
	(320632, 144, '2015-01-15 00:38:38.000000', 'temperatura', 401.0000, 'ºC'),
	(320633, 144, '2015-01-15 00:38:39.000000', 'temperatura', 255.0000, 'ºC'),
	(320634, 144, '2015-01-15 00:38:40.000000', 'temperatura', 73.0000, 'ºC'),
	(320635, 144, '2015-01-15 00:38:41.000000', 'temperatura', 800.0000, 'ºC'),
	(320636, 144, '2015-01-15 00:38:42.000000', 'temperatura', 179.0000, 'ºC'),
	(320637, 144, '2015-01-15 00:38:43.000000', 'temperatura', 898.0000, 'ºC'),
	(320638, 144, '2015-01-15 00:38:44.000000', 'temperatura', 352.0000, 'ºC'),
	(320639, 144, '2015-01-15 00:38:45.000000', 'temperatura', 266.0000, 'ºC'),
	(320640, 144, '2015-01-15 00:38:46.000000', 'temperatura', 274.0000, 'ºC'),
	(320641, 144, '2015-01-15 00:38:47.000000', 'temperatura', 575.0000, 'ºC'),
	(320642, 144, '2015-01-15 00:38:48.000000', 'temperatura', 851.0000, 'ºC'),
	(320643, 144, '2015-01-15 00:38:49.000000', 'temperatura', 133.0000, 'ºC'),
	(320644, 144, '2015-01-15 00:38:50.000000', 'temperatura', 512.0000, 'ºC'),
	(320645, 144, '2015-01-15 00:38:51.000000', 'temperatura', 961.0000, 'ºC'),
	(320646, 144, '2015-01-15 00:38:52.000000', 'temperatura', 869.0000, 'ºC'),
	(320647, 144, '2015-01-15 00:38:53.000000', 'temperatura', 263.0000, 'ºC'),
	(320648, 144, '2015-01-15 00:38:54.000000', 'temperatura', 1109.0000, 'ºC'),
	(320649, 144, '2015-01-15 00:38:55.000000', 'temperatura', 1158.0000, 'ºC'),
	(320650, 144, '2015-01-15 00:38:56.000000', 'temperatura', 61.0000, 'ºC'),
	(320651, 144, '2015-01-15 00:38:57.000000', 'temperatura', 433.0000, 'ºC'),
	(320652, 144, '2015-01-15 00:38:58.000000', 'temperatura', 781.0000, 'ºC'),
	(320653, 144, '2015-01-15 00:38:59.000000', 'temperatura', 207.0000, 'ºC'),
	(320654, 144, '2015-01-15 00:39:00.000000', 'temperatura', 1093.0000, 'ºC'),
	(320655, 144, '2015-01-15 00:39:01.000000', 'temperatura', 45.0000, 'ºC'),
	(320656, 144, '2015-01-15 00:39:02.000000', 'temperatura', 545.0000, 'ºC'),
	(320657, 144, '2015-01-15 00:39:03.000000', 'temperatura', 192.0000, 'ºC'),
	(320658, 144, '2015-01-15 00:39:04.000000', 'temperatura', 525.0000, 'ºC'),
	(320659, 144, '2015-01-15 00:39:05.000000', 'temperatura', 851.0000, 'ºC'),
	(320660, 144, '2015-01-15 00:39:06.000000', 'temperatura', 279.0000, 'ºC'),
	(320661, 144, '2015-01-15 00:39:07.000000', 'temperatura', 41.0000, 'ºC'),
	(320662, 144, '2015-01-15 00:39:08.000000', 'temperatura', 572.0000, 'ºC'),
	(320663, 144, '2015-01-15 00:39:09.000000', 'temperatura', 334.0000, 'ºC'),
	(320664, 144, '2015-01-15 00:39:10.000000', 'temperatura', 1155.0000, 'ºC'),
	(320665, 144, '2015-01-15 00:39:11.000000', 'temperatura', 1175.0000, 'ºC'),
	(320666, 144, '2015-01-15 00:39:12.000000', 'temperatura', 9.0000, 'ºC'),
	(320667, 144, '2015-01-15 00:39:13.000000', 'temperatura', 123.0000, 'ºC'),
	(320668, 144, '2015-01-15 00:39:14.000000', 'temperatura', 585.0000, 'ºC'),
	(320669, 144, '2015-01-15 00:39:15.000000', 'temperatura', 160.0000, 'ºC'),
	(320670, 144, '2015-01-15 00:39:16.000000', 'temperatura', 244.0000, 'ºC'),
	(320671, 144, '2015-01-15 00:39:17.000000', 'temperatura', 742.0000, 'ºC'),
	(320672, 144, '2015-01-15 00:39:18.000000', 'temperatura', 578.0000, 'ºC'),
	(320673, 144, '2015-01-15 00:39:19.000000', 'temperatura', 664.0000, 'ºC'),
	(320674, 144, '2015-01-15 00:39:20.000000', 'temperatura', 385.0000, 'ºC'),
	(320675, 144, '2015-01-15 00:39:21.000000', 'temperatura', 1135.0000, 'ºC'),
	(320676, 144, '2015-01-15 00:39:22.000000', 'temperatura', 921.0000, 'ºC'),
	(320677, 144, '2015-01-15 00:39:23.000000', 'temperatura', 0.0000, 'ºC'),
	(320678, 144, '2015-01-15 00:39:24.000000', 'temperatura', 836.0000, 'ºC'),
	(320679, 144, '2015-01-15 00:39:25.000000', 'temperatura', 580.0000, 'ºC'),
	(320680, 144, '2015-01-15 00:39:26.000000', 'temperatura', 395.0000, 'ºC'),
	(320681, 144, '2015-01-15 00:39:27.000000', 'temperatura', 234.0000, 'ºC'),
	(320682, 144, '2015-01-15 00:39:28.000000', 'temperatura', 1184.0000, 'ºC'),
	(320683, 144, '2015-01-15 00:39:29.000000', 'temperatura', 419.0000, 'ºC'),
	(320684, 144, '2015-01-15 00:39:30.000000', 'temperatura', 945.0000, 'ºC'),
	(320685, 144, '2015-01-15 00:39:31.000000', 'temperatura', 1068.0000, 'ºC'),
	(320686, 144, '2015-01-15 00:39:32.000000', 'temperatura', 105.0000, 'ºC'),
	(320687, 144, '2015-01-15 00:39:33.000000', 'temperatura', 924.0000, 'ºC'),
	(320688, 144, '2015-01-15 00:39:34.000000', 'temperatura', 702.0000, 'ºC'),
	(320689, 144, '2015-01-15 00:39:35.000000', 'temperatura', 741.0000, 'ºC'),
	(320690, 144, '2015-01-15 00:39:36.000000', 'temperatura', 399.0000, 'ºC'),
	(320691, 144, '2015-01-15 00:39:37.000000', 'temperatura', 974.0000, 'ºC'),
	(320692, 144, '2015-01-15 00:39:38.000000', 'temperatura', 72.0000, 'ºC'),
	(320693, 144, '2015-01-15 00:39:39.000000', 'temperatura', 1037.0000, 'ºC'),
	(320694, 144, '2015-01-15 00:39:40.000000', 'temperatura', 171.0000, 'ºC'),
	(320695, 144, '2015-01-15 00:39:41.000000', 'temperatura', 145.0000, 'ºC'),
	(320696, 144, '2015-01-15 00:39:42.000000', 'temperatura', 210.0000, 'ºC'),
	(320697, 144, '2015-01-15 00:39:43.000000', 'temperatura', 619.0000, 'ºC'),
	(320698, 144, '2015-01-15 00:39:44.000000', 'temperatura', 64.0000, 'ºC'),
	(320699, 144, '2015-01-15 00:39:45.000000', 'temperatura', 862.0000, 'ºC'),
	(320700, 144, '2015-01-15 00:39:46.000000', 'temperatura', 521.0000, 'ºC'),
	(320701, 144, '2015-01-15 00:39:47.000000', 'temperatura', 19.0000, 'ºC'),
	(320702, 144, '2015-01-15 00:39:48.000000', 'temperatura', 933.0000, 'ºC'),
	(320703, 144, '2015-01-15 00:39:49.000000', 'temperatura', 1010.0000, 'ºC'),
	(320704, 144, '2015-01-15 00:39:50.000000', 'temperatura', 1049.0000, 'ºC'),
	(320705, 144, '2015-01-15 00:39:51.000000', 'temperatura', 1017.0000, 'ºC'),
	(320706, 144, '2015-01-15 00:39:52.000000', 'temperatura', 737.0000, 'ºC'),
	(320707, 144, '2015-01-15 00:39:53.000000', 'temperatura', 634.0000, 'ºC'),
	(320708, 144, '2015-01-15 00:39:54.000000', 'temperatura', 961.0000, 'ºC'),
	(320709, 144, '2015-01-15 00:39:55.000000', 'temperatura', 504.0000, 'ºC'),
	(320710, 144, '2015-01-15 00:39:56.000000', 'temperatura', 838.0000, 'ºC'),
	(320711, 144, '2015-01-15 00:39:57.000000', 'temperatura', 278.0000, 'ºC'),
	(320712, 144, '2015-01-15 00:39:58.000000', 'temperatura', 78.0000, 'ºC'),
	(320713, 144, '2015-01-15 00:39:59.000000', 'temperatura', 754.0000, 'ºC'),
	(320714, 144, '2015-01-15 00:40:00.000000', 'temperatura', 1137.0000, 'ºC'),
	(320715, 144, '2015-01-15 00:40:01.000000', 'temperatura', 1022.0000, 'ºC'),
	(320716, 144, '2015-01-15 00:40:02.000000', 'temperatura', 501.0000, 'ºC'),
	(320717, 144, '2015-01-15 00:40:03.000000', 'temperatura', 640.0000, 'ºC'),
	(320718, 144, '2015-01-15 00:40:04.000000', 'temperatura', 496.0000, 'ºC'),
	(320719, 144, '2015-01-15 00:40:05.000000', 'temperatura', 562.0000, 'ºC'),
	(320720, 144, '2015-01-15 00:40:06.000000', 'temperatura', 123.0000, 'ºC'),
	(320721, 144, '2015-01-15 00:40:07.000000', 'temperatura', 128.0000, 'ºC'),
	(320722, 144, '2015-01-15 00:40:08.000000', 'temperatura', 270.0000, 'ºC'),
	(320723, 144, '2015-01-15 00:40:09.000000', 'temperatura', 968.0000, 'ºC'),
	(320724, 144, '2015-01-15 00:40:10.000000', 'temperatura', 431.0000, 'ºC'),
	(320725, 144, '2015-01-15 00:40:11.000000', 'temperatura', 450.0000, 'ºC'),
	(320726, 144, '2015-01-15 00:40:12.000000', 'temperatura', 960.0000, 'ºC'),
	(320727, 144, '2015-01-15 00:40:13.000000', 'temperatura', 1050.0000, 'ºC'),
	(320728, 144, '2015-01-15 00:40:14.000000', 'temperatura', 1169.0000, 'ºC'),
	(320729, 144, '2015-01-15 00:40:15.000000', 'temperatura', 295.0000, 'ºC'),
	(320730, 144, '2015-01-15 00:40:16.000000', 'temperatura', 370.0000, 'ºC'),
	(320731, 144, '2015-01-15 00:40:17.000000', 'temperatura', 966.0000, 'ºC'),
	(320732, 144, '2015-01-15 00:40:18.000000', 'temperatura', 118.0000, 'ºC'),
	(320733, 144, '2015-01-15 00:40:19.000000', 'temperatura', 93.0000, 'ºC'),
	(320734, 144, '2015-01-15 00:40:20.000000', 'temperatura', 114.0000, 'ºC'),
	(320735, 144, '2015-01-15 00:40:21.000000', 'temperatura', 289.0000, 'ºC'),
	(320736, 144, '2015-01-15 00:40:22.000000', 'temperatura', 1102.0000, 'ºC'),
	(320737, 144, '2015-01-15 00:40:23.000000', 'temperatura', 1046.0000, 'ºC'),
	(320738, 144, '2015-01-15 00:40:24.000000', 'temperatura', 726.0000, 'ºC'),
	(320739, 144, '2015-01-15 00:40:25.000000', 'temperatura', 490.0000, 'ºC'),
	(320740, 144, '2015-01-15 00:40:26.000000', 'temperatura', 274.0000, 'ºC'),
	(320741, 144, '2015-01-15 00:40:27.000000', 'temperatura', 1101.0000, 'ºC'),
	(320742, 144, '2015-01-15 00:40:28.000000', 'temperatura', 1083.0000, 'ºC'),
	(320743, 144, '2015-01-15 00:40:29.000000', 'temperatura', 913.0000, 'ºC'),
	(320744, 144, '2015-01-15 00:40:30.000000', 'temperatura', 116.0000, 'ºC'),
	(320745, 144, '2015-01-15 00:40:31.000000', 'temperatura', 240.0000, 'ºC'),
	(320746, 144, '2015-01-15 00:40:32.000000', 'temperatura', 855.0000, 'ºC'),
	(320747, 144, '2015-01-15 00:40:33.000000', 'temperatura', 1155.0000, 'ºC'),
	(320748, 144, '2015-01-15 00:40:34.000000', 'temperatura', 810.0000, 'ºC'),
	(320749, 144, '2015-01-15 00:40:35.000000', 'temperatura', 585.0000, 'ºC'),
	(320750, 144, '2015-01-15 00:40:36.000000', 'temperatura', 496.0000, 'ºC'),
	(320751, 144, '2015-01-15 00:40:37.000000', 'temperatura', 724.0000, 'ºC'),
	(320752, 144, '2015-01-15 00:40:38.000000', 'temperatura', 935.0000, 'ºC'),
	(320753, 144, '2015-01-15 00:40:39.000000', 'temperatura', 104.0000, 'ºC'),
	(320754, 144, '2015-01-15 00:40:40.000000', 'temperatura', 113.0000, 'ºC'),
	(320755, 144, '2015-01-15 00:40:41.000000', 'temperatura', 257.0000, 'ºC'),
	(320756, 144, '2015-01-15 00:40:42.000000', 'temperatura', 943.0000, 'ºC'),
	(320757, 144, '2015-01-15 00:40:43.000000', 'temperatura', 344.0000, 'ºC'),
	(320758, 144, '2015-01-15 00:40:44.000000', 'temperatura', 94.0000, 'ºC'),
	(320759, 144, '2015-01-15 00:40:45.000000', 'temperatura', 636.0000, 'ºC'),
	(320760, 144, '2015-01-15 00:40:46.000000', 'temperatura', 499.0000, 'ºC'),
	(320761, 144, '2015-01-15 00:40:47.000000', 'temperatura', 588.0000, 'ºC'),
	(320762, 144, '2015-01-15 00:40:48.000000', 'temperatura', 243.0000, 'ºC'),
	(320763, 144, '2015-01-15 00:40:49.000000', 'temperatura', 652.0000, 'ºC'),
	(320764, 144, '2015-01-15 00:40:50.000000', 'temperatura', 131.0000, 'ºC'),
	(320765, 144, '2015-01-15 00:40:51.000000', 'temperatura', 1101.0000, 'ºC'),
	(320766, 144, '2015-01-15 00:40:52.000000', 'temperatura', 313.0000, 'ºC'),
	(320767, 144, '2015-01-15 00:40:53.000000', 'temperatura', 661.0000, 'ºC'),
	(320768, 144, '2015-01-15 00:40:54.000000', 'temperatura', 1167.0000, 'ºC'),
	(320769, 144, '2015-01-15 00:40:55.000000', 'temperatura', 254.0000, 'ºC'),
	(320770, 144, '2015-01-15 00:40:56.000000', 'temperatura', 167.0000, 'ºC'),
	(320771, 144, '2015-01-15 00:40:57.000000', 'temperatura', 76.0000, 'ºC'),
	(320772, 144, '2015-01-15 00:40:58.000000', 'temperatura', 1079.0000, 'ºC'),
	(320773, 144, '2015-01-15 00:40:59.000000', 'temperatura', 367.0000, 'ºC'),
	(320774, 144, '2015-01-15 00:41:00.000000', 'temperatura', 998.0000, 'ºC'),
	(320775, 144, '2015-01-15 00:41:01.000000', 'temperatura', 291.0000, 'ºC'),
	(320776, 144, '2015-01-15 00:41:02.000000', 'temperatura', 862.0000, 'ºC'),
	(320777, 144, '2015-01-15 00:41:03.000000', 'temperatura', 1038.0000, 'ºC'),
	(320778, 144, '2015-01-15 00:41:04.000000', 'temperatura', 205.0000, 'ºC'),
	(320779, 144, '2015-01-15 00:41:05.000000', 'temperatura', 311.0000, 'ºC'),
	(320780, 144, '2015-01-15 00:41:06.000000', 'temperatura', 939.0000, 'ºC'),
	(320781, 144, '2015-01-15 00:41:07.000000', 'temperatura', 163.0000, 'ºC'),
	(320782, 144, '2015-01-15 00:41:08.000000', 'temperatura', 400.0000, 'ºC'),
	(320783, 144, '2015-01-15 00:41:09.000000', 'temperatura', 311.0000, 'ºC'),
	(320784, 144, '2015-01-15 00:41:10.000000', 'temperatura', 355.0000, 'ºC'),
	(320785, 144, '2015-01-15 00:41:11.000000', 'temperatura', 842.0000, 'ºC'),
	(320786, 144, '2015-01-15 00:41:12.000000', 'temperatura', 746.0000, 'ºC'),
	(320787, 144, '2015-01-15 00:41:13.000000', 'temperatura', 5.0000, 'ºC'),
	(320788, 144, '2015-01-15 00:41:14.000000', 'temperatura', 187.0000, 'ºC'),
	(320789, 144, '2015-01-15 00:41:15.000000', 'temperatura', 919.0000, 'ºC'),
	(320790, 144, '2015-01-15 00:41:16.000000', 'temperatura', 435.0000, 'ºC'),
	(320791, 144, '2015-01-15 00:41:17.000000', 'temperatura', 619.0000, 'ºC'),
	(320792, 144, '2015-01-15 00:41:18.000000', 'temperatura', 593.0000, 'ºC'),
	(320793, 144, '2015-01-15 00:41:19.000000', 'temperatura', 1105.0000, 'ºC'),
	(320794, 144, '2015-01-15 00:41:20.000000', 'temperatura', 146.0000, 'ºC'),
	(320795, 144, '2015-01-15 00:41:21.000000', 'temperatura', 1016.0000, 'ºC'),
	(320796, 144, '2015-01-15 00:41:22.000000', 'temperatura', 1043.0000, 'ºC'),
	(320797, 144, '2015-01-15 00:41:23.000000', 'temperatura', 970.0000, 'ºC'),
	(320798, 144, '2015-01-15 00:41:24.000000', 'temperatura', 518.0000, 'ºC'),
	(320799, 144, '2015-01-15 00:41:25.000000', 'temperatura', 880.0000, 'ºC'),
	(320800, 144, '2015-01-15 00:41:26.000000', 'temperatura', 449.0000, 'ºC'),
	(320801, 144, '2015-01-15 00:41:27.000000', 'temperatura', 803.0000, 'ºC'),
	(320802, 144, '2015-01-15 00:41:28.000000', 'temperatura', 268.0000, 'ºC'),
	(320803, 144, '2015-01-15 00:41:29.000000', 'temperatura', 132.0000, 'ºC'),
	(320804, 144, '2015-01-15 00:41:30.000000', 'temperatura', 1056.0000, 'ºC'),
	(320805, 144, '2015-01-15 00:41:31.000000', 'temperatura', 85.0000, 'ºC'),
	(320806, 144, '2015-01-15 00:41:32.000000', 'temperatura', 856.0000, 'ºC'),
	(320807, 144, '2015-01-15 00:41:33.000000', 'temperatura', 427.0000, 'ºC'),
	(320808, 144, '2015-01-15 00:41:34.000000', 'temperatura', 767.0000, 'ºC'),
	(320809, 144, '2015-01-15 00:41:35.000000', 'temperatura', 153.0000, 'ºC'),
	(320810, 144, '2015-01-15 00:41:36.000000', 'temperatura', 864.0000, 'ºC'),
	(320811, 144, '2015-01-15 00:41:37.000000', 'temperatura', 264.0000, 'ºC'),
	(320812, 144, '2015-01-15 00:41:38.000000', 'temperatura', 1129.0000, 'ºC'),
	(320813, 144, '2015-01-15 00:41:39.000000', 'temperatura', 53.0000, 'ºC'),
	(320814, 144, '2015-01-15 00:41:40.000000', 'temperatura', 476.0000, 'ºC'),
	(320815, 144, '2015-01-15 00:41:41.000000', 'temperatura', 1023.0000, 'ºC'),
	(320816, 144, '2015-01-15 00:41:42.000000', 'temperatura', 89.0000, 'ºC'),
	(320817, 144, '2015-01-15 00:41:43.000000', 'temperatura', 975.0000, 'ºC'),
	(320818, 144, '2015-01-15 00:41:44.000000', 'temperatura', 1008.0000, 'ºC'),
	(320819, 144, '2015-01-15 00:41:45.000000', 'temperatura', 918.0000, 'ºC'),
	(320820, 144, '2015-01-15 00:41:46.000000', 'temperatura', 364.0000, 'ºC'),
	(320821, 144, '2015-01-15 00:41:47.000000', 'temperatura', 268.0000, 'ºC'),
	(320822, 144, '2015-01-15 00:41:48.000000', 'temperatura', 246.0000, 'ºC'),
	(320823, 144, '2015-01-15 00:41:49.000000', 'temperatura', 430.0000, 'ºC'),
	(320824, 144, '2015-01-15 00:41:50.000000', 'temperatura', 210.0000, 'ºC'),
	(320825, 144, '2015-01-15 00:41:51.000000', 'temperatura', 961.0000, 'ºC'),
	(320826, 144, '2015-01-15 00:41:52.000000', 'temperatura', 577.0000, 'ºC'),
	(320827, 144, '2015-01-15 00:41:53.000000', 'temperatura', 4.0000, 'ºC'),
	(320828, 144, '2015-01-15 00:41:54.000000', 'temperatura', 686.0000, 'ºC'),
	(320829, 144, '2015-01-15 00:41:55.000000', 'temperatura', 1022.0000, 'ºC'),
	(320830, 144, '2015-01-15 00:41:56.000000', 'temperatura', 650.0000, 'ºC'),
	(320831, 144, '2015-01-15 00:41:57.000000', 'temperatura', 186.0000, 'ºC'),
	(320832, 144, '2015-01-15 00:41:58.000000', 'temperatura', 180.0000, 'ºC'),
	(320833, 144, '2015-01-15 00:41:59.000000', 'temperatura', 344.0000, 'ºC'),
	(320834, 144, '2015-01-15 00:42:00.000000', 'temperatura', 1178.0000, 'ºC'),
	(320835, 144, '2015-01-15 00:42:01.000000', 'temperatura', 58.0000, 'ºC'),
	(320836, 144, '2015-01-15 00:42:02.000000', 'temperatura', 360.0000, 'ºC'),
	(320837, 144, '2015-01-15 00:42:03.000000', 'temperatura', 423.0000, 'ºC'),
	(320838, 144, '2015-01-15 00:42:04.000000', 'temperatura', 1037.0000, 'ºC'),
	(320839, 144, '2015-01-15 00:42:05.000000', 'temperatura', 318.0000, 'ºC'),
	(320840, 144, '2015-01-15 00:42:06.000000', 'temperatura', 877.0000, 'ºC'),
	(320841, 144, '2015-01-15 00:42:07.000000', 'temperatura', 1034.0000, 'ºC'),
	(320842, 144, '2015-01-15 00:42:08.000000', 'temperatura', 139.0000, 'ºC'),
	(320843, 144, '2015-01-15 00:42:09.000000', 'temperatura', 1191.0000, 'ºC'),
	(320844, 144, '2015-01-15 00:42:10.000000', 'temperatura', 741.0000, 'ºC'),
	(320845, 144, '2015-01-15 00:42:11.000000', 'temperatura', 130.0000, 'ºC'),
	(320846, 144, '2015-01-15 00:42:12.000000', 'temperatura', 828.0000, 'ºC'),
	(320847, 144, '2015-01-15 00:42:13.000000', 'temperatura', 151.0000, 'ºC'),
	(320848, 144, '2015-01-15 00:42:14.000000', 'temperatura', 672.0000, 'ºC'),
	(320849, 144, '2015-01-15 00:42:15.000000', 'temperatura', 507.0000, 'ºC'),
	(320850, 144, '2015-01-15 00:42:16.000000', 'temperatura', 520.0000, 'ºC'),
	(320851, 144, '2015-01-15 00:42:17.000000', 'temperatura', 1078.0000, 'ºC'),
	(320852, 144, '2015-01-15 00:42:18.000000', 'temperatura', 232.0000, 'ºC'),
	(320853, 144, '2015-01-15 00:42:19.000000', 'temperatura', 326.0000, 'ºC'),
	(320854, 144, '2015-01-15 00:42:20.000000', 'temperatura', 933.0000, 'ºC'),
	(320855, 144, '2015-01-15 00:42:21.000000', 'temperatura', 87.0000, 'ºC'),
	(320856, 144, '2015-01-15 00:42:22.000000', 'temperatura', 36.0000, 'ºC'),
	(320857, 144, '2015-01-15 00:42:23.000000', 'temperatura', 1119.0000, 'ºC'),
	(320858, 144, '2015-01-15 00:42:24.000000', 'temperatura', 690.0000, 'ºC'),
	(320859, 144, '2015-01-15 00:42:25.000000', 'temperatura', 91.0000, 'ºC'),
	(320860, 144, '2015-01-15 00:42:26.000000', 'temperatura', 788.0000, 'ºC'),
	(320861, 144, '2015-01-15 00:42:27.000000', 'temperatura', 66.0000, 'ºC'),
	(320862, 144, '2015-01-15 00:42:28.000000', 'temperatura', 366.0000, 'ºC'),
	(320863, 144, '2015-01-15 00:42:29.000000', 'temperatura', 432.0000, 'ºC'),
	(320864, 144, '2015-01-15 00:42:30.000000', 'temperatura', 1065.0000, 'ºC'),
	(320865, 144, '2015-01-15 00:42:31.000000', 'temperatura', 427.0000, 'ºC'),
	(320866, 144, '2015-01-15 00:42:32.000000', 'temperatura', 143.0000, 'ºC'),
	(320867, 144, '2015-01-15 00:42:33.000000', 'temperatura', 633.0000, 'ºC'),
	(320868, 144, '2015-01-15 00:42:34.000000', 'temperatura', 335.0000, 'ºC'),
	(320869, 144, '2015-01-15 00:42:35.000000', 'temperatura', 978.0000, 'ºC'),
	(320870, 144, '2015-01-15 00:42:36.000000', 'temperatura', 284.0000, 'ºC'),
	(320871, 144, '2015-01-15 00:42:37.000000', 'temperatura', 887.0000, 'ºC'),
	(320872, 144, '2015-01-15 00:42:38.000000', 'temperatura', 1184.0000, 'ºC'),
	(320873, 144, '2015-01-15 00:42:39.000000', 'temperatura', 861.0000, 'ºC'),
	(320874, 144, '2015-01-15 00:42:40.000000', 'temperatura', 751.0000, 'ºC'),
	(320875, 144, '2015-01-15 00:42:41.000000', 'temperatura', 1175.0000, 'ºC'),
	(320876, 144, '2015-01-15 00:42:42.000000', 'temperatura', 22.0000, 'ºC'),
	(320877, 144, '2015-01-15 00:42:43.000000', 'temperatura', 187.0000, 'ºC'),
	(320878, 144, '2015-01-15 00:42:44.000000', 'temperatura', 868.0000, 'ºC'),
	(320879, 144, '2015-01-15 00:42:45.000000', 'temperatura', 178.0000, 'ºC'),
	(320880, 144, '2015-01-15 00:42:46.000000', 'temperatura', 689.0000, 'ºC'),
	(320881, 144, '2015-01-15 00:42:47.000000', 'temperatura', 511.0000, 'ºC'),
	(320882, 144, '2015-01-15 00:42:48.000000', 'temperatura', 489.0000, 'ºC'),
	(320883, 144, '2015-01-15 00:42:49.000000', 'temperatura', 914.0000, 'ºC'),
	(320884, 144, '2015-01-15 00:42:50.000000', 'temperatura', 700.0000, 'ºC'),
	(320885, 144, '2015-01-15 00:42:51.000000', 'temperatura', 760.0000, 'ºC'),
	(320886, 144, '2015-01-15 00:42:52.000000', 'temperatura', 500.0000, 'ºC'),
	(320887, 144, '2015-01-15 00:42:53.000000', 'temperatura', 221.0000, 'ºC'),
	(320888, 144, '2015-01-15 00:42:54.000000', 'temperatura', 805.0000, 'ºC'),
	(320889, 144, '2015-01-15 00:42:55.000000', 'temperatura', 962.0000, 'ºC'),
	(320890, 144, '2015-01-15 00:42:56.000000', 'temperatura', 1197.0000, 'ºC'),
	(320891, 144, '2015-01-15 00:42:57.000000', 'temperatura', 700.0000, 'ºC'),
	(320892, 144, '2015-01-15 00:42:58.000000', 'temperatura', 1107.0000, 'ºC'),
	(320893, 144, '2015-01-15 00:42:59.000000', 'temperatura', 1037.0000, 'ºC'),
	(320894, 144, '2015-01-15 00:43:00.000000', 'temperatura', 666.0000, 'ºC'),
	(320895, 144, '2015-01-15 00:43:01.000000', 'temperatura', 217.0000, 'ºC'),
	(320896, 144, '2015-01-15 00:43:02.000000', 'temperatura', 287.0000, 'ºC'),
	(320897, 144, '2015-01-15 00:43:03.000000', 'temperatura', 788.0000, 'ºC'),
	(320898, 144, '2015-01-15 00:43:04.000000', 'temperatura', 676.0000, 'ºC'),
	(320899, 144, '2015-01-15 00:43:05.000000', 'temperatura', 1016.0000, 'ºC'),
	(320900, 144, '2015-01-15 00:43:06.000000', 'temperatura', 654.0000, 'ºC'),
	(320901, 144, '2015-01-15 00:43:07.000000', 'temperatura', 222.0000, 'ºC'),
	(320902, 144, '2015-01-15 00:43:08.000000', 'temperatura', 348.0000, 'ºC'),
	(320903, 144, '2015-01-15 00:43:09.000000', 'temperatura', 1073.0000, 'ºC'),
	(320904, 144, '2015-01-15 00:43:10.000000', 'temperatura', 725.0000, 'ºC'),
	(320905, 144, '2015-01-15 00:43:11.000000', 'temperatura', 404.0000, 'ºC'),
	(320906, 144, '2015-01-15 00:43:12.000000', 'temperatura', 1048.0000, 'ºC'),
	(320907, 144, '2015-01-15 00:43:13.000000', 'temperatura', 426.0000, 'ºC'),
	(320908, 144, '2015-01-15 00:43:14.000000', 'temperatura', 186.0000, 'ºC'),
	(320909, 144, '2015-01-15 00:43:15.000000', 'temperatura', 855.0000, 'ºC'),
	(320910, 144, '2015-01-15 00:43:16.000000', 'temperatura', 118.0000, 'ºC'),
	(320911, 144, '2015-01-15 00:43:17.000000', 'temperatura', 423.0000, 'ºC'),
	(320912, 144, '2015-01-15 00:43:18.000000', 'temperatura', 560.0000, 'ºC'),
	(320913, 144, '2015-01-15 00:43:19.000000', 'temperatura', 335.0000, 'ºC'),
	(320914, 144, '2015-01-15 00:43:20.000000', 'temperatura', 1195.0000, 'ºC'),
	(320915, 144, '2015-01-15 00:43:21.000000', 'temperatura', 172.0000, 'ºC'),
	(320916, 144, '2015-01-15 00:43:22.000000', 'temperatura', 873.0000, 'ºC'),
	(320917, 144, '2015-01-15 00:43:23.000000', 'temperatura', 249.0000, 'ºC'),
	(320918, 144, '2015-01-15 00:43:24.000000', 'temperatura', 1027.0000, 'ºC'),
	(320919, 144, '2015-01-15 00:43:25.000000', 'temperatura', 790.0000, 'ºC'),
	(320920, 144, '2015-01-15 00:43:26.000000', 'temperatura', 868.0000, 'ºC'),
	(320921, 144, '2015-01-15 00:43:27.000000', 'temperatura', 771.0000, 'ºC'),
	(320922, 144, '2015-01-15 00:43:28.000000', 'temperatura', 52.0000, 'ºC'),
	(320923, 144, '2015-01-15 00:43:29.000000', 'temperatura', 346.0000, 'ºC'),
	(320924, 144, '2015-01-15 00:43:30.000000', 'temperatura', 375.0000, 'ºC'),
	(320925, 144, '2015-01-15 00:43:31.000000', 'temperatura', 838.0000, 'ºC'),
	(320926, 144, '2015-01-15 00:43:32.000000', 'temperatura', 664.0000, 'ºC'),
	(320927, 144, '2015-01-15 00:43:33.000000', 'temperatura', 809.0000, 'ºC'),
	(320928, 144, '2015-01-15 00:43:34.000000', 'temperatura', 854.0000, 'ºC'),
	(320929, 144, '2015-01-15 00:43:35.000000', 'temperatura', 640.0000, 'ºC'),
	(320930, 144, '2015-01-15 00:43:36.000000', 'temperatura', 642.0000, 'ºC'),
	(320931, 144, '2015-01-15 00:43:37.000000', 'temperatura', 88.0000, 'ºC'),
	(320932, 144, '2015-01-15 00:43:38.000000', 'temperatura', 914.0000, 'ºC'),
	(320933, 144, '2015-01-15 00:43:39.000000', 'temperatura', 709.0000, 'ºC'),
	(320934, 144, '2015-01-15 00:43:40.000000', 'temperatura', 803.0000, 'ºC'),
	(320935, 144, '2015-01-15 00:43:41.000000', 'temperatura', 689.0000, 'ºC'),
	(320936, 144, '2015-01-15 00:43:42.000000', 'temperatura', 1038.0000, 'ºC'),
	(320937, 144, '2015-01-15 00:43:43.000000', 'temperatura', 720.0000, 'ºC'),
	(320938, 144, '2015-01-15 00:43:44.000000', 'temperatura', 490.0000, 'ºC'),
	(320939, 144, '2015-01-15 00:43:45.000000', 'temperatura', 287.0000, 'ºC'),
	(320940, 144, '2015-01-15 00:43:46.000000', 'temperatura', 1167.0000, 'ºC'),
	(320941, 144, '2015-01-15 00:43:47.000000', 'temperatura', 175.0000, 'ºC'),
	(320942, 144, '2015-01-15 00:43:48.000000', 'temperatura', 975.0000, 'ºC'),
	(320943, 144, '2015-01-15 00:43:49.000000', 'temperatura', 748.0000, 'ºC'),
	(320944, 144, '2015-01-15 00:43:50.000000', 'temperatura', 819.0000, 'ºC'),
	(320945, 144, '2015-01-15 00:43:51.000000', 'temperatura', 648.0000, 'ºC'),
	(320946, 144, '2015-01-15 00:43:52.000000', 'temperatura', 787.0000, 'ºC'),
	(320947, 144, '2015-01-15 00:43:53.000000', 'temperatura', 789.0000, 'ºC'),
	(320948, 144, '2015-01-15 00:43:54.000000', 'temperatura', 385.0000, 'ºC'),
	(320949, 144, '2015-01-15 00:43:55.000000', 'temperatura', 760.0000, 'ºC'),
	(320950, 144, '2015-01-15 00:43:56.000000', 'temperatura', 245.0000, 'ºC'),
	(320951, 144, '2015-01-15 00:43:57.000000', 'temperatura', 145.0000, 'ºC'),
	(320952, 144, '2015-01-15 00:43:58.000000', 'temperatura', 1191.0000, 'ºC'),
	(320953, 144, '2015-01-15 00:43:59.000000', 'temperatura', 720.0000, 'ºC'),
	(320954, 144, '2015-01-15 00:44:00.000000', 'temperatura', 30.0000, 'ºC'),
	(320955, 144, '2015-01-15 00:44:01.000000', 'temperatura', 387.0000, 'ºC'),
	(320956, 144, '2015-01-15 00:44:02.000000', 'temperatura', 648.0000, 'ºC'),
	(320957, 144, '2015-01-15 00:44:03.000000', 'temperatura', 879.0000, 'ºC'),
	(320958, 144, '2015-01-15 00:44:04.000000', 'temperatura', 51.0000, 'ºC'),
	(320959, 144, '2015-01-15 00:44:05.000000', 'temperatura', 18.0000, 'ºC'),
	(320960, 144, '2015-01-15 00:44:06.000000', 'temperatura', 1137.0000, 'ºC'),
	(320961, 144, '2015-01-15 00:44:07.000000', 'temperatura', 834.0000, 'ºC'),
	(320962, 144, '2015-01-15 00:44:08.000000', 'temperatura', 757.0000, 'ºC'),
	(320963, 144, '2015-01-15 00:44:09.000000', 'temperatura', 84.0000, 'ºC'),
	(320964, 144, '2015-01-15 00:44:10.000000', 'temperatura', 549.0000, 'ºC'),
	(320965, 144, '2015-01-15 00:44:11.000000', 'temperatura', 94.0000, 'ºC'),
	(320966, 144, '2015-01-15 00:44:12.000000', 'temperatura', 22.0000, 'ºC'),
	(320967, 144, '2015-01-15 00:44:13.000000', 'temperatura', 1031.0000, 'ºC'),
	(320968, 144, '2015-01-15 00:44:14.000000', 'temperatura', 289.0000, 'ºC'),
	(320969, 144, '2015-01-15 00:44:15.000000', 'temperatura', 751.0000, 'ºC'),
	(320970, 144, '2015-01-15 00:44:16.000000', 'temperatura', 488.0000, 'ºC'),
	(320971, 144, '2015-01-15 00:44:17.000000', 'temperatura', 191.0000, 'ºC'),
	(320972, 144, '2015-01-15 00:44:18.000000', 'temperatura', 688.0000, 'ºC'),
	(320973, 144, '2015-01-15 00:44:19.000000', 'temperatura', 467.0000, 'ºC'),
	(320974, 144, '2015-01-15 00:44:20.000000', 'temperatura', 275.0000, 'ºC'),
	(320975, 144, '2015-01-15 00:44:21.000000', 'temperatura', 1171.0000, 'ºC'),
	(320976, 144, '2015-01-15 00:44:22.000000', 'temperatura', 231.0000, 'ºC'),
	(320977, 144, '2015-01-15 00:44:23.000000', 'temperatura', 45.0000, 'ºC'),
	(320978, 144, '2015-01-15 00:44:24.000000', 'temperatura', 731.0000, 'ºC'),
	(320979, 144, '2015-01-15 00:44:25.000000', 'temperatura', 1120.0000, 'ºC'),
	(320980, 144, '2015-01-15 00:44:26.000000', 'temperatura', 1006.0000, 'ºC'),
	(320981, 144, '2015-01-15 00:44:27.000000', 'temperatura', 471.0000, 'ºC'),
	(320982, 144, '2015-01-15 00:44:28.000000', 'temperatura', 539.0000, 'ºC'),
	(320983, 144, '2015-01-15 00:44:29.000000', 'temperatura', 81.0000, 'ºC'),
	(320984, 144, '2015-01-15 00:44:30.000000', 'temperatura', 1191.0000, 'ºC'),
	(320985, 144, '2015-01-15 00:44:31.000000', 'temperatura', 912.0000, 'ºC'),
	(320986, 144, '2015-01-15 00:44:32.000000', 'temperatura', 988.0000, 'ºC'),
	(320987, 144, '2015-01-15 00:44:33.000000', 'temperatura', 1004.0000, 'ºC'),
	(320988, 144, '2015-01-15 00:44:34.000000', 'temperatura', 855.0000, 'ºC'),
	(320989, 144, '2015-01-15 00:44:35.000000', 'temperatura', 64.0000, 'ºC'),
	(320990, 144, '2015-01-15 00:44:36.000000', 'temperatura', 157.0000, 'ºC'),
	(320991, 144, '2015-01-15 00:44:37.000000', 'temperatura', 593.0000, 'ºC'),
	(320992, 144, '2015-01-15 00:44:38.000000', 'temperatura', 94.0000, 'ºC'),
	(320993, 144, '2015-01-15 00:44:39.000000', 'temperatura', 1090.0000, 'ºC'),
	(320994, 144, '2015-01-15 00:44:40.000000', 'temperatura', 369.0000, 'ºC'),
	(320995, 144, '2015-01-15 00:44:41.000000', 'temperatura', 974.0000, 'ºC'),
	(320996, 144, '2015-01-15 00:44:42.000000', 'temperatura', 167.0000, 'ºC'),
	(320997, 144, '2015-01-15 00:44:43.000000', 'temperatura', 310.0000, 'ºC'),
	(320998, 144, '2015-01-15 00:44:44.000000', 'temperatura', 1052.0000, 'ºC'),
	(320999, 144, '2015-01-15 00:44:45.000000', 'temperatura', 730.0000, 'ºC'),
	(321000, 144, '2015-01-15 00:44:46.000000', 'temperatura', 496.0000, 'ºC'),
	(321001, 144, '2015-01-15 00:44:47.000000', 'temperatura', 288.0000, 'ºC'),
	(321002, 144, '2015-01-15 00:44:48.000000', 'temperatura', 1152.0000, 'ºC'),
	(321003, 144, '2015-01-15 00:44:49.000000', 'temperatura', 99.0000, 'ºC'),
	(321004, 144, '2015-01-15 00:44:50.000000', 'temperatura', 637.0000, 'ºC'),
	(321005, 144, '2015-01-15 00:44:51.000000', 'temperatura', 488.0000, 'ºC'),
	(321006, 144, '2015-01-15 00:44:52.000000', 'temperatura', 531.0000, 'ºC'),
	(321007, 144, '2015-01-15 00:44:53.000000', 'temperatura', 1193.0000, 'ºC'),
	(321008, 144, '2015-01-15 00:44:54.000000', 'temperatura', 770.0000, 'ºC'),
	(321009, 144, '2015-01-15 00:44:55.000000', 'temperatura', 272.0000, 'ºC'),
	(321010, 144, '2015-01-15 00:44:56.000000', 'temperatura', 249.0000, 'ºC'),
	(321011, 144, '2015-01-15 00:44:57.000000', 'temperatura', 431.0000, 'ºC'),
	(321012, 144, '2015-01-15 00:44:58.000000', 'temperatura', 210.0000, 'ºC'),
	(321013, 144, '2015-01-15 00:44:59.000000', 'temperatura', 958.0000, 'ºC'),
	(321014, 144, '2015-01-15 00:45:00.000000', 'temperatura', 558.0000, 'ºC'),
	(321015, 144, '2015-01-15 00:45:01.000000', 'temperatura', 1116.0000, 'ºC'),
	(321016, 144, '2015-01-15 00:45:02.000000', 'temperatura', 306.0000, 'ºC'),
	(321017, 144, '2015-01-15 00:45:03.000000', 'temperatura', 586.0000, 'ºC'),
	(321018, 144, '2015-01-15 00:45:04.000000', 'temperatura', 809.0000, 'ºC'),
	(321019, 144, '2015-01-15 00:45:05.000000', 'temperatura', 1088.0000, 'ºC'),
	(321020, 144, '2015-01-15 00:45:06.000000', 'temperatura', 616.0000, 'ºC'),
	(321021, 144, '2015-01-15 00:45:07.000000', 'temperatura', 1016.0000, 'ºC'),
	(321022, 144, '2015-01-15 00:45:08.000000', 'temperatura', 831.0000, 'ºC'),
	(321023, 144, '2015-01-15 00:45:09.000000', 'temperatura', 1109.0000, 'ºC'),
	(321024, 144, '2015-01-15 00:45:10.000000', 'temperatura', 652.0000, 'ºC'),
	(321025, 144, '2015-01-15 00:45:11.000000', 'temperatura', 1135.0000, 'ºC'),
	(321026, 144, '2015-01-15 00:45:12.000000', 'temperatura', 118.0000, 'ºC'),
	(321027, 144, '2015-01-15 00:45:13.000000', 'temperatura', 786.0000, 'ºC'),
	(321028, 144, '2015-01-15 00:45:14.000000', 'temperatura', 1176.0000, 'ºC'),
	(321029, 144, '2015-01-15 00:45:15.000000', 'temperatura', 1123.0000, 'ºC'),
	(321030, 144, '2015-01-15 00:45:16.000000', 'temperatura', 886.0000, 'ºC'),
	(321031, 144, '2015-01-15 00:45:17.000000', 'temperatura', 1064.0000, 'ºC'),
	(321032, 144, '2015-01-15 00:45:18.000000', 'temperatura', 261.0000, 'ºC'),
	(321033, 144, '2015-01-15 00:45:19.000000', 'temperatura', 515.0000, 'ºC'),
	(321034, 144, '2015-01-15 00:45:20.000000', 'temperatura', 593.0000, 'ºC'),
	(321035, 144, '2015-01-15 00:45:21.000000', 'temperatura', 221.0000, 'ºC'),
	(321036, 144, '2015-01-15 00:45:22.000000', 'temperatura', 525.0000, 'ºC'),
	(321037, 144, '2015-01-15 00:45:23.000000', 'temperatura', 765.0000, 'ºC'),
	(321038, 144, '2015-01-15 00:45:24.000000', 'temperatura', 1048.0000, 'ºC'),
	(321039, 144, '2015-01-15 00:45:25.000000', 'temperatura', 548.0000, 'ºC'),
	(321040, 144, '2015-01-15 00:45:26.000000', 'temperatura', 796.0000, 'ºC'),
	(321041, 144, '2015-01-15 00:45:27.000000', 'temperatura', 1134.0000, 'ºC'),
	(321042, 144, '2015-01-15 00:45:28.000000', 'temperatura', 883.0000, 'ºC'),
	(321043, 144, '2015-01-15 00:45:29.000000', 'temperatura', 1015.0000, 'ºC'),
	(321044, 144, '2015-01-15 00:45:30.000000', 'temperatura', 24.0000, 'ºC'),
	(321045, 144, '2015-01-15 00:45:31.000000', 'temperatura', 678.0000, 'ºC'),
	(321046, 144, '2015-01-15 00:45:32.000000', 'temperatura', 918.0000, 'ºC'),
	(321047, 144, '2015-01-15 00:45:33.000000', 'temperatura', 157.0000, 'ºC'),
	(321048, 144, '2015-01-15 00:45:34.000000', 'temperatura', 433.0000, 'ºC'),
	(321049, 144, '2015-01-15 00:45:35.000000', 'temperatura', 492.0000, 'ºC'),
	(321050, 144, '2015-01-15 00:45:36.000000', 'temperatura', 1164.0000, 'ºC'),
	(321051, 144, '2015-01-15 00:45:37.000000', 'temperatura', 742.0000, 'ºC'),
	(321052, 144, '2015-01-15 00:45:38.000000', 'temperatura', 217.0000, 'ºC'),
	(321053, 144, '2015-01-15 00:45:39.000000', 'temperatura', 62.0000, 'ºC'),
	(321054, 144, '2015-01-15 00:45:40.000000', 'temperatura', 860.0000, 'ºC'),
	(321055, 144, '2015-01-15 00:45:41.000000', 'temperatura', 514.0000, 'ºC'),
	(321056, 144, '2015-01-15 00:45:42.000000', 'temperatura', 1190.0000, 'ºC'),
	(321057, 144, '2015-01-15 00:45:43.000000', 'temperatura', 808.0000, 'ºC'),
	(321058, 144, '2015-01-15 00:45:44.000000', 'temperatura', 470.0000, 'ºC'),
	(321059, 144, '2015-01-15 00:45:45.000000', 'temperatura', 1127.0000, 'ºC'),
	(321060, 144, '2015-01-15 00:45:46.000000', 'temperatura', 624.0000, 'ºC'),
	(321061, 144, '2015-01-15 00:45:47.000000', 'temperatura', 941.0000, 'ºC'),
	(321062, 144, '2015-01-15 00:45:48.000000', 'temperatura', 433.0000, 'ºC'),
	(321063, 144, '2015-01-15 00:45:49.000000', 'temperatura', 544.0000, 'ºC'),
	(321064, 144, '2015-01-15 00:45:50.000000', 'temperatura', 220.0000, 'ºC'),
	(321065, 144, '2015-01-15 00:45:51.000000', 'temperatura', 669.0000, 'ºC'),
	(321066, 144, '2015-01-15 00:45:52.000000', 'temperatura', 286.0000, 'ºC'),
	(321067, 144, '2015-01-15 00:45:53.000000', 'temperatura', 622.0000, 'ºC'),
	(321068, 144, '2015-01-15 00:45:54.000000', 'temperatura', 1051.0000, 'ºC'),
	(321069, 144, '2015-01-15 00:45:55.000000', 'temperatura', 993.0000, 'ºC'),
	(321070, 144, '2015-01-15 00:45:56.000000', 'temperatura', 610.0000, 'ºC'),
	(321071, 144, '2015-01-15 00:45:57.000000', 'temperatura', 73.0000, 'ºC'),
	(321072, 144, '2015-01-15 00:45:58.000000', 'temperatura', 933.0000, 'ºC'),
	(321073, 144, '2015-01-15 00:45:59.000000', 'temperatura', 848.0000, 'ºC'),
	(321074, 144, '2015-01-15 00:46:00.000000', 'temperatura', 242.0000, 'ºC'),
	(321075, 144, '2015-01-15 00:46:01.000000', 'temperatura', 1068.0000, 'ºC'),
	(321076, 144, '2015-01-15 00:46:02.000000', 'temperatura', 1012.0000, 'ºC'),
	(321077, 144, '2015-01-15 00:46:03.000000', 'temperatura', 657.0000, 'ºC'),
	(321078, 144, '2015-01-15 00:46:04.000000', 'temperatura', 252.0000, 'ºC'),
	(321079, 144, '2015-01-15 00:46:05.000000', 'temperatura', 486.0000, 'ºC'),
	(321080, 144, '2015-01-15 00:46:06.000000', 'temperatura', 478.0000, 'ºC'),
	(321081, 144, '2015-01-15 00:46:07.000000', 'temperatura', 931.0000, 'ºC'),
	(321082, 144, '2015-01-15 00:46:08.000000', 'temperatura', 820.0000, 'ºC'),
	(321083, 144, '2015-01-15 00:46:09.000000', 'temperatura', 109.0000, 'ºC'),
	(321084, 144, '2015-01-15 00:46:10.000000', 'temperatura', 485.0000, 'ºC'),
	(321085, 144, '2015-01-15 00:46:11.000000', 'temperatura', 899.0000, 'ºC'),
	(321086, 144, '2015-01-15 00:46:12.000000', 'temperatura', 638.0000, 'ºC'),
	(321087, 144, '2015-01-15 00:46:13.000000', 'temperatura', 496.0000, 'ºC'),
	(321088, 144, '2015-01-15 00:46:14.000000', 'temperatura', 566.0000, 'ºC'),
	(321089, 144, '2015-01-15 00:46:15.000000', 'temperatura', 143.0000, 'ºC'),
	(321090, 144, '2015-01-15 00:46:16.000000', 'temperatura', 216.0000, 'ºC'),
	(321091, 144, '2015-01-15 00:46:17.000000', 'temperatura', 651.0000, 'ºC'),
	(321092, 144, '2015-01-15 00:46:18.000000', 'temperatura', 208.0000, 'ºC'),
	(321093, 144, '2015-01-15 00:46:19.000000', 'temperatura', 287.0000, 'ºC'),
	(321094, 144, '2015-01-15 00:46:20.000000', 'temperatura', 811.0000, 'ºC'),
	(321095, 144, '2015-01-15 00:46:21.000000', 'temperatura', 795.0000, 'ºC'),
	(321096, 144, '2015-01-15 00:46:22.000000', 'temperatura', 343.0000, 'ºC'),
	(321097, 144, '2015-01-15 00:46:23.000000', 'temperatura', 530.0000, 'ºC'),
	(321098, 144, '2015-01-15 00:46:24.000000', 'temperatura', 423.0000, 'ºC'),
	(321099, 144, '2015-01-15 00:46:25.000000', 'temperatura', 524.0000, 'ºC'),
	(321100, 144, '2015-01-15 00:46:26.000000', 'temperatura', 150.0000, 'ºC'),
	(321101, 144, '2015-01-15 00:46:27.000000', 'temperatura', 379.0000, 'ºC'),
	(321102, 144, '2015-01-15 00:46:28.000000', 'temperatura', 248.0000, 'ºC'),
	(321103, 144, '2015-01-15 00:46:29.000000', 'temperatura', 101.0000, 'ºC'),
	(321104, 144, '2015-01-15 00:46:30.000000', 'temperatura', 961.0000, 'ºC'),
	(321105, 144, '2015-01-15 00:46:31.000000', 'temperatura', 904.0000, 'ºC'),
	(321106, 144, '2015-01-15 00:46:32.000000', 'temperatura', 438.0000, 'ºC'),
	(321107, 144, '2015-01-15 00:46:33.000000', 'temperatura', 679.0000, 'ºC'),
	(321108, 144, '2015-01-15 00:46:34.000000', 'temperatura', 881.0000, 'ºC'),
	(321109, 144, '2015-01-15 00:46:35.000000', 'temperatura', 1167.0000, 'ºC'),
	(321110, 144, '2015-01-15 00:46:36.000000', 'temperatura', 793.0000, 'ºC'),
	(321111, 144, '2015-01-15 00:46:37.000000', 'temperatura', 467.0000, 'ºC'),
	(321112, 144, '2015-01-15 00:46:38.000000', 'temperatura', 1154.0000, 'ºC'),
	(321113, 144, '2015-01-15 00:46:39.000000', 'temperatura', 770.0000, 'ºC'),
	(321114, 144, '2015-01-15 00:46:40.000000', 'temperatura', 390.0000, 'ºC'),
	(321115, 144, '2015-01-15 00:46:41.000000', 'temperatura', 839.0000, 'ºC'),
	(321116, 144, '2015-01-15 00:46:42.000000', 'temperatura', 628.0000, 'ºC'),
	(321117, 144, '2015-01-15 00:46:43.000000', 'temperatura', 622.0000, 'ºC'),
	(321118, 144, '2015-01-15 00:46:44.000000', 'temperatura', 25.0000, 'ºC'),
	(321119, 144, '2015-01-15 00:46:45.000000', 'temperatura', 659.0000, 'ºC'),
	(321120, 144, '2015-01-15 00:46:46.000000', 'temperatura', 822.0000, 'ºC'),
	(321121, 144, '2015-01-15 00:46:47.000000', 'temperatura', 934.0000, 'ºC'),
	(321122, 144, '2015-01-15 00:46:48.000000', 'temperatura', 1005.0000, 'ºC'),
	(321123, 144, '2015-01-15 00:46:49.000000', 'temperatura', 1024.0000, 'ºC'),
	(321124, 144, '2015-01-15 00:46:50.000000', 'temperatura', 903.0000, 'ºC'),
	(321125, 144, '2015-01-15 00:46:51.000000', 'temperatura', 244.0000, 'ºC'),
	(321126, 144, '2015-01-15 00:46:52.000000', 'temperatura', 910.0000, 'ºC'),
	(321127, 144, '2015-01-15 00:46:53.000000', 'temperatura', 222.0000, 'ºC'),
	(321128, 144, '2015-01-15 00:46:54.000000', 'temperatura', 779.0000, 'ºC'),
	(321129, 144, '2015-01-15 00:46:55.000000', 'temperatura', 828.0000, 'ºC'),
	(321130, 144, '2015-01-15 00:46:56.000000', 'temperatura', 607.0000, 'ºC'),
	(321131, 144, '2015-01-15 00:46:57.000000', 'temperatura', 548.0000, 'ºC'),
	(321132, 144, '2015-01-15 00:46:58.000000', 'temperatura', 920.0000, 'ºC'),
	(321133, 144, '2015-01-15 00:46:59.000000', 'temperatura', 556.0000, 'ºC'),
	(321134, 144, '2015-01-15 00:47:00.000000', 'temperatura', 22.0000, 'ºC'),
	(321135, 144, '2015-01-15 00:47:01.000000', 'temperatura', 841.0000, 'ºC'),
	(321136, 144, '2015-01-15 00:47:02.000000', 'temperatura', 542.0000, 'ºC'),
	(321137, 144, '2015-01-15 00:47:03.000000', 'temperatura', 187.0000, 'ºC'),
	(321138, 144, '2015-01-15 00:47:04.000000', 'temperatura', 511.0000, 'ºC'),
	(321139, 144, '2015-01-15 00:47:05.000000', 'temperatura', 792.0000, 'ºC'),
	(321140, 144, '2015-01-15 00:47:06.000000', 'temperatura', 27.0000, 'ºC'),
	(321141, 144, '2015-01-15 00:47:07.000000', 'temperatura', 161.0000, 'ºC'),
	(321142, 144, '2015-01-15 00:47:08.000000', 'temperatura', 725.0000, 'ºC'),
	(321143, 144, '2015-01-15 00:47:09.000000', 'temperatura', 742.0000, 'ºC'),
	(321144, 144, '2015-01-15 00:47:10.000000', 'temperatura', 335.0000, 'ºC'),
	(321145, 144, '2015-01-15 00:47:11.000000', 'temperatura', 651.0000, 'ºC'),
	(321146, 144, '2015-01-15 00:47:12.000000', 'temperatura', 1049.0000, 'ºC'),
	(321147, 144, '2015-01-15 00:47:13.000000', 'temperatura', 895.0000, 'ºC'),
	(321148, 144, '2015-01-15 00:47:14.000000', 'temperatura', 127.0000, 'ºC'),
	(321149, 144, '2015-01-15 00:47:15.000000', 'temperatura', 352.0000, 'ºC'),
	(321150, 144, '2015-01-15 00:47:16.000000', 'temperatura', 178.0000, 'ºC'),
	(321151, 144, '2015-01-15 00:47:17.000000', 'temperatura', 1033.0000, 'ºC'),
	(321152, 144, '2015-01-15 00:47:18.000000', 'temperatura', 1032.0000, 'ºC'),
	(321153, 144, '2015-01-15 00:47:19.000000', 'temperatura', 863.0000, 'ºC'),
	(321154, 144, '2015-01-15 00:47:20.000000', 'temperatura', 18.0000, 'ºC'),
	(321155, 144, '2015-01-15 00:47:21.000000', 'temperatura', 1104.0000, 'ºC'),
	(321156, 144, '2015-01-15 00:47:22.000000', 'temperatura', 664.0000, 'ºC'),
	(321157, 144, '2015-01-15 00:47:23.000000', 'temperatura', 9.0000, 'ºC'),
	(321158, 144, '2015-01-15 00:47:24.000000', 'temperatura', 454.0000, 'ºC'),
	(321159, 144, '2015-01-15 00:47:25.000000', 'temperatura', 1045.0000, 'ºC'),
	(321160, 144, '2015-01-15 00:47:26.000000', 'temperatura', 261.0000, 'ºC'),
	(321161, 144, '2015-01-15 00:47:27.000000', 'temperatura', 569.0000, 'ºC'),
	(321162, 144, '2015-01-15 00:47:28.000000', 'temperatura', 866.0000, 'ºC'),
	(321163, 144, '2015-01-15 00:47:29.000000', 'temperatura', 223.0000, 'ºC'),
	(321164, 144, '2015-01-15 00:47:30.000000', 'temperatura', 919.0000, 'ºC'),
	(321165, 144, '2015-01-15 00:47:31.000000', 'temperatura', 324.0000, 'ºC'),
	(321166, 144, '2015-01-15 00:47:32.000000', 'temperatura', 65.0000, 'ºC'),
	(321167, 144, '2015-01-15 00:47:33.000000', 'temperatura', 552.0000, 'ºC'),
	(321168, 144, '2015-01-15 00:47:34.000000', 'temperatura', 168.0000, 'ºC'),
	(321169, 144, '2015-01-15 00:47:35.000000', 'temperatura', 382.0000, 'ºC'),
	(321170, 144, '2015-01-15 00:47:36.000000', 'temperatura', 208.0000, 'ºC'),
	(321171, 144, '2015-01-15 00:47:37.000000', 'temperatura', 1094.0000, 'ºC'),
	(321172, 144, '2015-01-15 00:47:38.000000', 'temperatura', 45.0000, 'ºC'),
	(321173, 144, '2015-01-15 00:47:39.000000', 'temperatura', 546.0000, 'ºC'),
	(321174, 144, '2015-01-15 00:47:40.000000', 'temperatura', 194.0000, 'ºC'),
	(321175, 144, '2015-01-15 00:47:41.000000', 'temperatura', 533.0000, 'ºC'),
	(321176, 144, '2015-01-15 00:47:42.000000', 'temperatura', 883.0000, 'ºC'),
	(321177, 144, '2015-01-15 00:47:43.000000', 'temperatura', 419.0000, 'ºC'),
	(321178, 144, '2015-01-15 00:47:44.000000', 'temperatura', 643.0000, 'ºC'),
	(321179, 144, '2015-01-15 00:47:45.000000', 'temperatura', 760.0000, 'ºC'),
	(321180, 144, '2015-01-15 00:47:46.000000', 'temperatura', 672.0000, 'ºC'),
	(321181, 144, '2015-01-15 00:47:47.000000', 'temperatura', 1079.0000, 'ºC'),
	(321182, 144, '2015-01-15 00:47:48.000000', 'temperatura', 980.0000, 'ºC'),
	(321183, 144, '2015-01-15 00:47:49.000000', 'temperatura', 464.0000, 'ºC'),
	(321184, 144, '2015-01-15 00:47:50.000000', 'temperatura', 578.0000, 'ºC'),
	(321185, 144, '2015-01-15 00:47:51.000000', 'temperatura', 301.0000, 'ºC'),
	(321186, 144, '2015-01-15 00:47:52.000000', 'temperatura', 972.0000, 'ºC'),
	(321187, 144, '2015-01-15 00:47:53.000000', 'temperatura', 358.0000, 'ºC'),
	(321188, 144, '2015-01-15 00:47:54.000000', 'temperatura', 74.0000, 'ºC'),
	(321189, 144, '2015-01-15 00:47:55.000000', 'temperatura', 496.0000, 'ºC'),
	(321190, 144, '2015-01-15 00:47:56.000000', 'temperatura', 1060.0000, 'ºC'),
	(321191, 144, '2015-01-15 00:47:57.000000', 'temperatura', 212.0000, 'ºC'),
	(321192, 144, '2015-01-15 00:47:58.000000', 'temperatura', 278.0000, 'ºC'),
	(321193, 144, '2015-01-15 00:47:59.000000', 'temperatura', 757.0000, 'ºC'),
	(321194, 144, '2015-01-15 00:48:00.000000', 'temperatura', 549.0000, 'ºC'),
	(321195, 144, '2015-01-15 00:48:01.000000', 'temperatura', 475.0000, 'ºC'),
	(321196, 144, '2015-01-15 00:48:02.000000', 'temperatura', 727.0000, 'ºC'),
	(321197, 144, '2015-01-15 00:48:03.000000', 'temperatura', 1012.0000, 'ºC'),
	(321198, 144, '2015-01-15 00:48:04.000000', 'temperatura', 480.0000, 'ºC'),
	(321199, 144, '2015-01-15 00:48:05.000000', 'temperatura', 565.0000, 'ºC'),
	(321200, 144, '2015-01-15 00:48:06.000000', 'temperatura', 186.0000, 'ºC'),
	(321201, 144, '2015-01-15 00:48:07.000000', 'temperatura', 433.0000, 'ºC'),
	(321202, 144, '2015-01-15 00:48:08.000000', 'temperatura', 407.0000, 'ºC'),
	(321203, 144, '2015-01-15 00:48:09.000000', 'temperatura', 738.0000, 'ºC'),
	(321204, 144, '2015-01-15 00:48:10.000000', 'temperatura', 70.0000, 'ºC'),
	(321205, 144, '2015-01-15 00:48:11.000000', 'temperatura', 534.0000, 'ºC'),
	(321206, 144, '2015-01-15 00:48:12.000000', 'temperatura', 63.0000, 'ºC'),
	(321207, 144, '2015-01-15 00:48:13.000000', 'temperatura', 1113.0000, 'ºC'),
	(321208, 144, '2015-01-15 00:48:14.000000', 'temperatura', 575.0000, 'ºC'),
	(321209, 144, '2015-01-15 00:48:15.000000', 'temperatura', 736.0000, 'ºC'),
	(321210, 144, '2015-01-15 00:48:16.000000', 'temperatura', 755.0000, 'ºC'),
	(321211, 144, '2015-01-15 00:48:17.000000', 'temperatura', 369.0000, 'ºC'),
	(321212, 144, '2015-01-15 00:48:18.000000', 'temperatura', 782.0000, 'ºC'),
	(321213, 144, '2015-01-15 00:48:19.000000', 'temperatura', 402.0000, 'ºC'),
	(321214, 144, '2015-01-15 00:48:20.000000', 'temperatura', 865.0000, 'ºC'),
	(321215, 144, '2015-01-15 00:48:21.000000', 'temperatura', 718.0000, 'ºC'),
	(321216, 144, '2015-01-15 00:48:22.000000', 'temperatura', 998.0000, 'ºC'),
	(321217, 144, '2015-01-15 00:48:23.000000', 'temperatura', 435.0000, 'ºC'),
	(321218, 144, '2015-01-15 00:48:24.000000', 'temperatura', 380.0000, 'ºC'),
	(321219, 144, '2015-01-15 00:48:25.000000', 'temperatura', 596.0000, 'ºC'),
	(321220, 144, '2015-01-15 00:48:26.000000', 'temperatura', 641.0000, 'ºC'),
	(321221, 144, '2015-01-15 00:48:27.000000', 'temperatura', 216.0000, 'ºC'),
	(321222, 144, '2015-01-15 00:48:28.000000', 'temperatura', 359.0000, 'ºC'),
	(321223, 144, '2015-01-15 00:48:29.000000', 'temperatura', 1149.0000, 'ºC'),
	(321224, 144, '2015-01-15 00:48:30.000000', 'temperatura', 1068.0000, 'ºC'),
	(321225, 144, '2015-01-15 00:48:31.000000', 'temperatura', 695.0000, 'ºC'),
	(321226, 144, '2015-01-15 00:48:32.000000', 'temperatura', 270.0000, 'ºC'),
	(321227, 144, '2015-01-15 00:48:33.000000', 'temperatura', 466.0000, 'ºC'),
	(321228, 144, '2015-01-15 00:48:34.000000', 'temperatura', 319.0000, 'ºC'),
	(321229, 144, '2015-01-15 00:48:35.000000', 'temperatura', 198.0000, 'ºC'),
	(321230, 144, '2015-01-15 00:48:36.000000', 'temperatura', 33.0000, 'ºC'),
	(321231, 144, '2015-01-15 00:48:37.000000', 'temperatura', 772.0000, 'ºC'),
	(321232, 144, '2015-01-15 00:48:38.000000', 'temperatura', 160.0000, 'ºC'),
	(321233, 144, '2015-01-15 00:48:39.000000', 'temperatura', 885.0000, 'ºC'),
	(321234, 144, '2015-01-15 00:48:40.000000', 'temperatura', 346.0000, 'ºC'),
	(321235, 144, '2015-01-15 00:48:41.000000', 'temperatura', 276.0000, 'ºC'),
	(321236, 144, '2015-01-15 00:48:42.000000', 'temperatura', 342.0000, 'ºC'),
	(321237, 144, '2015-01-15 00:48:43.000000', 'temperatura', 881.0000, 'ºC'),
	(321238, 144, '2015-01-15 00:48:44.000000', 'temperatura', 981.0000, 'ºC'),
	(321239, 144, '2015-01-15 00:48:45.000000', 'temperatura', 1063.0000, 'ºC'),
	(321240, 144, '2015-01-15 00:48:46.000000', 'temperatura', 1170.0000, 'ºC'),
	(321241, 144, '2015-01-15 00:48:47.000000', 'temperatura', 262.0000, 'ºC'),
	(321242, 144, '2015-01-15 00:48:48.000000', 'temperatura', 202.0000, 'ºC'),
	(321243, 144, '2015-01-15 00:48:49.000000', 'temperatura', 225.0000, 'ºC'),
	(321244, 144, '2015-01-15 00:48:50.000000', 'temperatura', 519.0000, 'ºC'),
	(321245, 144, '2015-01-15 00:48:51.000000', 'temperatura', 721.0000, 'ºC'),
	(321246, 144, '2015-01-15 00:48:52.000000', 'temperatura', 847.0000, 'ºC'),
	(321247, 144, '2015-01-15 00:48:53.000000', 'temperatura', 872.0000, 'ºC'),
	(321248, 144, '2015-01-15 00:48:54.000000', 'temperatura', 620.0000, 'ºC'),
	(321249, 144, '2015-01-15 00:48:55.000000', 'temperatura', 485.0000, 'ºC'),
	(321250, 144, '2015-01-15 00:48:56.000000', 'temperatura', 565.0000, 'ºC'),
	(321251, 144, '2015-01-15 00:48:57.000000', 'temperatura', 172.0000, 'ºC'),
	(321252, 144, '2015-01-15 00:48:58.000000', 'temperatura', 366.0000, 'ºC'),
	(321253, 144, '2015-01-15 00:48:59.000000', 'temperatura', 116.0000, 'ºC'),
	(321254, 144, '2015-01-15 00:49:00.000000', 'temperatura', 679.0000, 'ºC'),
	(321255, 144, '2015-01-15 00:49:01.000000', 'temperatura', 648.0000, 'ºC'),
	(321256, 144, '2015-01-15 00:49:02.000000', 'temperatura', 5.0000, 'ºC'),
	(321257, 144, '2015-01-15 00:49:03.000000', 'temperatura', 481.0000, 'ºC'),
	(321258, 144, '2015-01-15 00:49:04.000000', 'temperatura', 1191.0000, 'ºC'),
	(321259, 144, '2015-01-15 00:49:05.000000', 'temperatura', 914.0000, 'ºC'),
	(321260, 144, '2015-01-15 00:49:06.000000', 'temperatura', 994.0000, 'ºC'),
	(321261, 144, '2015-01-15 00:49:07.000000', 'temperatura', 1032.0000, 'ºC'),
	(321262, 144, '2015-01-15 00:49:08.000000', 'temperatura', 978.0000, 'ºC'),
	(321263, 144, '2015-01-15 00:49:09.000000', 'temperatura', 592.0000, 'ºC'),
	(321264, 144, '2015-01-15 00:49:10.000000', 'temperatura', 27.0000, 'ºC'),
	(321265, 144, '2015-01-15 00:49:11.000000', 'temperatura', 759.0000, 'ºC'),
	(321266, 144, '2015-01-15 00:49:12.000000', 'temperatura', 116.0000, 'ºC'),
	(321267, 144, '2015-01-15 00:49:13.000000', 'temperatura', 701.0000, 'ºC'),
	(321268, 144, '2015-01-15 00:49:14.000000', 'temperatura', 760.0000, 'ºC'),
	(321269, 144, '2015-01-15 00:49:15.000000', 'temperatura', 498.0000, 'ºC'),
	(321270, 144, '2015-01-15 00:49:16.000000', 'temperatura', 211.0000, 'ºC'),
	(321271, 144, '2015-01-15 00:49:17.000000', 'temperatura', 761.0000, 'ºC'),
	(321272, 144, '2015-01-15 00:49:18.000000', 'temperatura', 772.0000, 'ºC'),
	(321273, 144, '2015-01-15 00:49:19.000000', 'temperatura', 379.0000, 'ºC'),
	(321274, 144, '2015-01-15 00:49:20.000000', 'temperatura', 780.0000, 'ºC'),
	(321275, 144, '2015-01-15 00:49:21.000000', 'temperatura', 364.0000, 'ºC'),
	(321276, 144, '2015-01-15 00:49:22.000000', 'temperatura', 679.0000, 'ºC'),
	(321277, 144, '2015-01-15 00:49:23.000000', 'temperatura', 1104.0000, 'ºC'),
	(321278, 144, '2015-01-15 00:49:24.000000', 'temperatura', 1083.0000, 'ºC'),
	(321279, 144, '2015-01-15 00:49:25.000000', 'temperatura', 902.0000, 'ºC'),
	(321280, 144, '2015-01-15 00:49:26.000000', 'temperatura', 62.0000, 'ºC'),
	(321281, 144, '2015-01-15 00:49:27.000000', 'temperatura', 3.0000, 'ºC'),
	(321282, 144, '2015-01-15 00:49:28.000000', 'temperatura', 1030.0000, 'ºC'),
	(321283, 144, '2015-01-15 00:49:29.000000', 'temperatura', 344.0000, 'ºC'),
	(321284, 144, '2015-01-15 00:49:30.000000', 'temperatura', 1028.0000, 'ºC'),
	(321285, 144, '2015-01-15 00:49:31.000000', 'temperatura', 510.0000, 'ºC'),
	(321286, 144, '2015-01-15 00:49:32.000000', 'temperatura', 664.0000, 'ºC'),
	(321287, 144, '2015-01-15 00:49:33.000000', 'temperatura', 594.0000, 'ºC'),
	(321288, 144, '2015-01-15 00:49:34.000000', 'temperatura', 975.0000, 'ºC'),
	(321289, 144, '2015-01-15 00:49:35.000000', 'temperatura', 696.0000, 'ºC'),
	(321290, 144, '2015-01-15 00:49:36.000000', 'temperatura', 553.0000, 'ºC'),
	(321291, 144, '2015-01-15 00:49:37.000000', 'temperatura', 678.0000, 'ºC'),
	(321292, 144, '2015-01-15 00:49:38.000000', 'temperatura', 532.0000, 'ºC'),
	(321293, 144, '2015-01-15 00:49:39.000000', 'temperatura', 625.0000, 'ºC'),
	(321294, 144, '2015-01-15 00:49:40.000000', 'temperatura', 332.0000, 'ºC'),
	(321295, 144, '2015-01-15 00:49:41.000000', 'temperatura', 985.0000, 'ºC'),
	(321296, 144, '2015-01-15 00:49:42.000000', 'temperatura', 331.0000, 'ºC'),
	(321297, 144, '2015-01-15 00:49:43.000000', 'temperatura', 1100.0000, 'ºC'),
	(321298, 144, '2015-01-15 00:49:44.000000', 'temperatura', 908.0000, 'ºC'),
	(321299, 144, '2015-01-15 00:49:45.000000', 'temperatura', 39.0000, 'ºC'),
	(321300, 144, '2015-01-15 00:49:46.000000', 'temperatura', 1070.0000, 'ºC'),
	(321301, 144, '2015-01-15 00:49:47.000000', 'temperatura', 435.0000, 'ºC'),
	(321302, 144, '2015-01-15 00:49:48.000000', 'temperatura', 168.0000, 'ºC'),
	(321303, 144, '2015-01-15 00:49:49.000000', 'temperatura', 732.0000, 'ºC'),
	(321304, 144, '2015-01-15 00:49:50.000000', 'temperatura', 756.0000, 'ºC'),
	(321305, 144, '2015-01-15 00:49:51.000000', 'temperatura', 386.0000, 'ºC'),
	(321306, 144, '2015-01-15 00:49:52.000000', 'temperatura', 863.0000, 'ºC'),
	(321307, 144, '2015-01-15 00:49:53.000000', 'temperatura', 757.0000, 'ºC'),
	(321308, 144, '2015-01-15 00:49:54.000000', 'temperatura', 1196.0000, 'ºC'),
	(321309, 144, '2015-01-15 00:49:55.000000', 'temperatura', 110.0000, 'ºC'),
	(321310, 144, '2015-01-15 00:49:56.000000', 'temperatura', 563.0000, 'ºC'),
	(321311, 144, '2015-01-15 00:49:57.000000', 'temperatura', 86.0000, 'ºC'),
	(321312, 144, '2015-01-15 00:49:58.000000', 'temperatura', 1143.0000, 'ºC'),
	(321313, 144, '2015-01-15 00:49:59.000000', 'temperatura', 654.0000, 'ºC'),
	(321314, 144, '2015-01-15 00:50:00.000000', 'temperatura', 1044.0000, 'ºC'),
	(321315, 144, '2015-01-15 00:50:01.000000', 'temperatura', 859.0000, 'ºC'),
	(321316, 144, '2015-01-15 00:50:02.000000', 'temperatura', 1163.0000, 'ºC'),
	(321317, 144, '2015-01-15 00:50:03.000000', 'temperatura', 839.0000, 'ºC'),
	(321318, 144, '2015-01-15 00:50:04.000000', 'temperatura', 704.0000, 'ºC'),
	(321319, 144, '2015-01-15 00:50:05.000000', 'temperatura', 1007.0000, 'ºC'),
	(321320, 144, '2015-01-15 00:50:06.000000', 'temperatura', 520.0000, 'ºC'),
	(321321, 144, '2015-01-15 00:50:07.000000', 'temperatura', 783.0000, 'ºC'),
	(321322, 144, '2015-01-15 00:50:08.000000', 'temperatura', 1154.0000, 'ºC'),
	(321323, 144, '2015-01-15 00:50:09.000000', 'temperatura', 1021.0000, 'ºC'),
	(321324, 144, '2015-01-15 00:50:10.000000', 'temperatura', 444.0000, 'ºC'),
	(321325, 144, '2015-01-15 00:50:11.000000', 'temperatura', 359.0000, 'ºC'),
	(321326, 144, '2015-01-15 00:50:12.000000', 'temperatura', 461.0000, 'ºC'),
	(321327, 144, '2015-01-15 00:50:13.000000', 'temperatura', 31.0000, 'ºC'),
	(321328, 144, '2015-01-15 00:50:14.000000', 'temperatura', 1172.0000, 'ºC'),
	(321329, 144, '2015-01-15 00:50:15.000000', 'temperatura', 966.0000, 'ºC'),
	(321330, 144, '2015-01-15 00:50:16.000000', 'temperatura', 113.0000, 'ºC'),
	(321331, 144, '2015-01-15 00:50:17.000000', 'temperatura', 71.0000, 'ºC'),
	(321332, 144, '2015-01-15 00:50:18.000000', 'temperatura', 15.0000, 'ºC'),
	(321333, 144, '2015-01-15 00:50:19.000000', 'temperatura', 1064.0000, 'ºC'),
	(321334, 144, '2015-01-15 00:50:20.000000', 'temperatura', 476.0000, 'ºC'),
	(321335, 145, '2015-01-15 00:00:00.000000', 'temperatura', 509.0000, 'ºC'),
	(321336, 145, '2015-01-15 00:00:01.000000', 'temperatura', 182.0000, 'ºC'),
	(321337, 145, '2015-01-15 00:00:02.000000', 'temperatura', 583.0000, 'ºC'),
	(321338, 145, '2015-01-15 00:00:03.000000', 'temperatura', 1171.0000, 'ºC'),
	(321339, 145, '2015-01-15 00:00:04.000000', 'temperatura', 506.0000, 'ºC'),
	(321340, 145, '2015-01-15 00:00:05.000000', 'temperatura', 219.0000, 'ºC'),
	(321341, 145, '2015-01-15 00:00:06.000000', 'temperatura', 777.0000, 'ºC'),
	(321342, 145, '2015-01-15 00:00:07.000000', 'temperatura', 830.0000, 'ºC'),
	(321343, 145, '2015-01-15 00:00:08.000000', 'temperatura', 617.0000, 'ºC'),
	(321344, 145, '2015-01-15 00:00:09.000000', 'temperatura', 595.0000, 'ºC'),
	(321345, 145, '2015-01-15 00:00:10.000000', 'temperatura', 1127.0000, 'ºC'),
	(321346, 145, '2015-01-15 00:00:11.000000', 'temperatura', 250.0000, 'ºC'),
	(321347, 145, '2015-01-15 00:00:12.000000', 'temperatura', 270.0000, 'ºC'),
	(321348, 145, '2015-01-15 00:00:13.000000', 'temperatura', 599.0000, 'ºC'),
	(321349, 145, '2015-01-15 00:00:14.000000', 'temperatura', 987.0000, 'ºC'),
	(321350, 145, '2015-01-15 00:00:15.000000', 'temperatura', 739.0000, 'ºC'),
	(321351, 145, '2015-01-15 00:00:16.000000', 'temperatura', 734.0000, 'ºC'),
	(321352, 145, '2015-01-15 00:00:17.000000', 'temperatura', 252.0000, 'ºC'),
	(321353, 145, '2015-01-15 00:00:18.000000', 'temperatura', 258.0000, 'ºC'),
	(321354, 145, '2015-01-15 00:00:19.000000', 'temperatura', 535.0000, 'ºC'),
	(321355, 145, '2015-01-15 00:00:20.000000', 'temperatura', 701.0000, 'ºC'),
	(321356, 145, '2015-01-15 00:00:21.000000', 'temperatura', 702.0000, 'ºC'),
	(321357, 145, '2015-01-15 00:00:22.000000', 'temperatura', 209.0000, 'ºC'),
	(321358, 145, '2015-01-15 00:00:23.000000', 'temperatura', 137.0000, 'ºC'),
	(321359, 145, '2015-01-15 00:00:24.000000', 'temperatura', 59.0000, 'ºC'),
	(321360, 145, '2015-01-15 00:00:25.000000', 'temperatura', 1086.0000, 'ºC'),
	(321361, 145, '2015-01-15 00:00:26.000000', 'temperatura', 451.0000, 'ºC'),
	(321362, 145, '2015-01-15 00:00:27.000000', 'temperatura', 197.0000, 'ºC'),
	(321363, 145, '2015-01-15 00:00:28.000000', 'temperatura', 833.0000, 'ºC'),
	(321364, 145, '2015-01-15 00:00:29.000000', 'temperatura', 1174.0000, 'ºC'),
	(321365, 145, '2015-01-15 00:00:30.000000', 'temperatura', 972.0000, 'ºC'),
	(321366, 145, '2015-01-15 00:00:31.000000', 'temperatura', 139.0000, 'ºC'),
	(321367, 145, '2015-01-15 00:00:32.000000', 'temperatura', 180.0000, 'ºC'),
	(321368, 145, '2015-01-15 00:00:33.000000', 'temperatura', 483.0000, 'ºC'),
	(321369, 145, '2015-01-15 00:00:34.000000', 'temperatura', 674.0000, 'ºC'),
	(321370, 145, '2015-01-15 00:00:35.000000', 'temperatura', 723.0000, 'ºC'),
	(321371, 145, '2015-01-15 00:00:36.000000', 'temperatura', 393.0000, 'ºC'),
	(321372, 145, '2015-01-15 00:00:37.000000', 'temperatura', 996.0000, 'ºC'),
	(321373, 145, '2015-01-15 00:00:38.000000', 'temperatura', 202.0000, 'ºC'),
	(321374, 145, '2015-01-15 00:00:39.000000', 'temperatura', 421.0000, 'ºC'),
	(321375, 145, '2015-01-15 00:00:40.000000', 'temperatura', 298.0000, 'ºC'),
	(321376, 145, '2015-01-15 00:00:41.000000', 'temperatura', 231.0000, 'ºC'),
	(321377, 145, '2015-01-15 00:00:42.000000', 'temperatura', 262.0000, 'ºC'),
	(321378, 145, '2015-01-15 00:00:43.000000', 'temperatura', 615.0000, 'ºC'),
	(321379, 145, '2015-01-15 00:00:44.000000', 'temperatura', 1092.0000, 'ºC'),
	(321380, 145, '2015-01-15 00:00:45.000000', 'temperatura', 15.0000, 'ºC'),
	(321381, 145, '2015-01-15 00:00:46.000000', 'temperatura', 401.0000, 'ºC'),
	(321382, 145, '2015-01-15 00:00:47.000000', 'temperatura', 758.0000, 'ºC'),
	(321383, 145, '2015-01-15 00:00:48.000000', 'temperatura', 190.0000, 'ºC'),
	(321384, 145, '2015-01-15 00:00:49.000000', 'temperatura', 1075.0000, 'ºC'),
	(321385, 145, '2015-01-15 00:00:50.000000', 'temperatura', 7.0000, 'ºC'),
	(321386, 145, '2015-01-15 00:00:51.000000', 'temperatura', 408.0000, 'ºC'),
	(321387, 145, '2015-01-15 00:00:52.000000', 'temperatura', 822.0000, 'ºC'),
	(321388, 145, '2015-01-15 00:00:53.000000', 'temperatura', 485.0000, 'ºC'),
	(321389, 145, '2015-01-15 00:00:54.000000', 'temperatura', 1159.0000, 'ºC'),
	(321390, 145, '2015-01-15 00:00:55.000000', 'temperatura', 740.0000, 'ºC'),
	(321391, 145, '2015-01-15 00:00:56.000000', 'temperatura', 226.0000, 'ºC'),
	(321392, 145, '2015-01-15 00:00:57.000000', 'temperatura', 111.0000, 'ºC'),
	(321393, 145, '2015-01-15 00:00:58.000000', 'temperatura', 1077.0000, 'ºC'),
	(321394, 145, '2015-01-15 00:00:59.000000', 'temperatura', 250.0000, 'ºC'),
	(321395, 145, '2015-01-15 00:01:00.000000', 'temperatura', 420.0000, 'ºC'),
	(321396, 145, '2015-01-15 00:01:01.000000', 'temperatura', 153.0000, 'ºC'),
	(321397, 145, '2015-01-15 00:01:02.000000', 'temperatura', 703.0000, 'ºC'),
	(321398, 145, '2015-01-15 00:01:03.000000', 'temperatura', 659.0000, 'ºC'),
	(321399, 145, '2015-01-15 00:01:04.000000', 'temperatura', 1185.0000, 'ºC'),
	(321400, 145, '2015-01-15 00:01:05.000000', 'temperatura', 349.0000, 'ºC'),
	(321401, 145, '2015-01-15 00:01:06.000000', 'temperatura', 590.0000, 'ºC'),
	(321402, 145, '2015-01-15 00:01:07.000000', 'temperatura', 703.0000, 'ºC'),
	(321403, 145, '2015-01-15 00:01:08.000000', 'temperatura', 548.0000, 'ºC'),
	(321404, 145, '2015-01-15 00:01:09.000000', 'temperatura', 629.0000, 'ºC'),
	(321405, 145, '2015-01-15 00:01:10.000000', 'temperatura', 302.0000, 'ºC'),
	(321406, 145, '2015-01-15 00:01:11.000000', 'temperatura', 824.0000, 'ºC'),
	(321407, 145, '2015-01-15 00:01:12.000000', 'temperatura', 816.0000, 'ºC'),
	(321408, 145, '2015-01-15 00:01:13.000000', 'temperatura', 405.0000, 'ºC'),
	(321409, 145, '2015-01-15 00:01:14.000000', 'temperatura', 780.0000, 'ºC'),
	(321410, 145, '2015-01-15 00:01:15.000000', 'temperatura', 285.0000, 'ºC'),
	(321411, 145, '2015-01-15 00:01:16.000000', 'temperatura', 285.0000, 'ºC'),
	(321412, 145, '2015-01-15 00:01:17.000000', 'temperatura', 572.0000, 'ºC'),
	(321413, 145, '2015-01-15 00:01:18.000000', 'temperatura', 806.0000, 'ºC'),
	(321414, 145, '2015-01-15 00:01:19.000000', 'temperatura', 1115.0000, 'ºC'),
	(321415, 145, '2015-01-15 00:01:20.000000', 'temperatura', 758.0000, 'ºC'),
	(321416, 145, '2015-01-15 00:01:21.000000', 'temperatura', 445.0000, 'ºC'),
	(321417, 145, '2015-01-15 00:01:22.000000', 'temperatura', 1151.0000, 'ºC'),
	(321418, 145, '2015-01-15 00:01:23.000000', 'temperatura', 819.0000, 'ºC'),
	(321419, 145, '2015-01-15 00:01:24.000000', 'temperatura', 643.0000, 'ºC'),
	(321420, 145, '2015-01-15 00:01:25.000000', 'temperatura', 761.0000, 'ºC'),
	(321421, 145, '2015-01-15 00:01:26.000000', 'temperatura', 674.0000, 'ºC'),
	(321422, 145, '2015-01-15 00:01:27.000000', 'temperatura', 1090.0000, 'ºC'),
	(321423, 145, '2015-01-15 00:01:28.000000', 'temperatura', 1025.0000, 'ºC'),
	(321424, 145, '2015-01-15 00:01:29.000000', 'temperatura', 658.0000, 'ºC'),
	(321425, 145, '2015-01-15 00:01:30.000000', 'temperatura', 217.0000, 'ºC'),
	(321426, 145, '2015-01-15 00:01:31.000000', 'temperatura', 310.0000, 'ºC'),
	(321427, 145, '2015-01-15 00:01:32.000000', 'temperatura', 899.0000, 'ºC'),
	(321428, 145, '2015-01-15 00:01:33.000000', 'temperatura', 1164.0000, 'ºC'),
	(321429, 145, '2015-01-15 00:01:34.000000', 'temperatura', 724.0000, 'ºC'),
	(321430, 145, '2015-01-15 00:01:35.000000', 'temperatura', 131.0000, 'ºC'),
	(321431, 145, '2015-01-15 00:01:36.000000', 'temperatura', 881.0000, 'ºC'),
	(321432, 145, '2015-01-15 00:01:37.000000', 'temperatura', 415.0000, 'ºC'),
	(321433, 145, '2015-01-15 00:01:38.000000', 'temperatura', 633.0000, 'ºC'),
	(321434, 145, '2015-01-15 00:01:39.000000', 'temperatura', 718.0000, 'ºC'),
	(321435, 145, '2015-01-15 00:01:40.000000', 'temperatura', 491.0000, 'ºC'),
	(321436, 145, '2015-01-15 00:01:41.000000', 'temperatura', 302.0000, 'ºC'),
	(321437, 145, '2015-01-15 00:01:42.000000', 'temperatura', 39.0000, 'ºC'),
	(321438, 145, '2015-01-15 00:01:43.000000', 'temperatura', 487.0000, 'ºC'),
	(321439, 145, '2015-01-15 00:01:44.000000', 'temperatura', 1121.0000, 'ºC'),
	(321440, 145, '2015-01-15 00:01:45.000000', 'temperatura', 543.0000, 'ºC'),
	(321441, 145, '2015-01-15 00:01:46.000000', 'temperatura', 551.0000, 'ºC'),
	(321442, 145, '2015-01-15 00:01:47.000000', 'temperatura', 1127.0000, 'ºC'),
	(321443, 145, '2015-01-15 00:01:48.000000', 'temperatura', 384.0000, 'ºC'),
	(321444, 145, '2015-01-15 00:01:49.000000', 'temperatura', 939.0000, 'ºC'),
	(321445, 145, '2015-01-15 00:01:50.000000', 'temperatura', 1143.0000, 'ºC'),
	(321446, 145, '2015-01-15 00:01:51.000000', 'temperatura', 498.0000, 'ºC'),
	(321447, 145, '2015-01-15 00:01:52.000000', 'temperatura', 262.0000, 'ºC'),
	(321448, 145, '2015-01-15 00:01:53.000000', 'temperatura', 1018.0000, 'ºC'),
	(321449, 145, '2015-01-15 00:01:54.000000', 'temperatura', 702.0000, 'ºC'),
	(321450, 145, '2015-01-15 00:01:55.000000', 'temperatura', 457.0000, 'ºC'),
	(321451, 145, '2015-01-15 00:01:56.000000', 'temperatura', 182.0000, 'ºC'),
	(321452, 145, '2015-01-15 00:01:57.000000', 'temperatura', 738.0000, 'ºC'),
	(321453, 145, '2015-01-15 00:01:58.000000', 'temperatura', 743.0000, 'ºC'),
	(321454, 145, '2015-01-15 00:01:59.000000', 'temperatura', 303.0000, 'ºC'),
	(321455, 145, '2015-01-15 00:02:00.000000', 'temperatura', 486.0000, 'ºC'),
	(321456, 145, '2015-01-15 00:02:01.000000', 'temperatura', 322.0000, 'ºC'),
	(321457, 145, '2015-01-15 00:02:02.000000', 'temperatura', 153.0000, 'ºC'),
	(321458, 145, '2015-01-15 00:02:03.000000', 'temperatura', 999.0000, 'ºC'),
	(321459, 145, '2015-01-15 00:02:04.000000', 'temperatura', 938.0000, 'ºC'),
	(321460, 145, '2015-01-15 00:02:05.000000', 'temperatura', 491.0000, 'ºC'),
	(321461, 145, '2015-01-15 00:02:06.000000', 'temperatura', 842.0000, 'ºC'),
	(321462, 145, '2015-01-15 00:02:07.000000', 'temperatura', 336.0000, 'ºC'),
	(321463, 145, '2015-01-15 00:02:08.000000', 'temperatura', 357.0000, 'ºC'),
	(321464, 145, '2015-01-15 00:02:09.000000', 'temperatura', 778.0000, 'ºC'),
	(321465, 145, '2015-01-15 00:02:10.000000', 'temperatura', 417.0000, 'ºC'),
	(321466, 145, '2015-01-15 00:02:11.000000', 'temperatura', 952.0000, 'ºC'),
	(321467, 145, '2015-01-15 00:02:12.000000', 'temperatura', 1108.0000, 'ºC'),
	(321468, 145, '2015-01-15 00:02:13.000000', 'temperatura', 288.0000, 'ºC'),
	(321469, 145, '2015-01-15 00:02:14.000000', 'temperatura', 513.0000, 'ºC'),
	(321470, 145, '2015-01-15 00:02:15.000000', 'temperatura', 504.0000, 'ºC'),
	(321471, 145, '2015-01-15 00:02:16.000000', 'temperatura', 982.0000, 'ºC'),
	(321472, 145, '2015-01-15 00:02:17.000000', 'temperatura', 998.0000, 'ºC'),
	(321473, 145, '2015-01-15 00:02:18.000000', 'temperatura', 844.0000, 'ºC'),
	(321474, 145, '2015-01-15 00:02:19.000000', 'temperatura', 28.0000, 'ºC'),
	(321475, 145, '2015-01-15 00:02:20.000000', 'temperatura', 7.0000, 'ºC'),
	(321476, 145, '2015-01-15 00:02:21.000000', 'temperatura', 1154.0000, 'ºC'),
	(321477, 145, '2015-01-15 00:02:22.000000', 'temperatura', 947.0000, 'ºC'),
	(321478, 145, '2015-01-15 00:02:23.000000', 'temperatura', 72.0000, 'ºC'),
	(321479, 145, '2015-01-15 00:02:24.000000', 'temperatura', 1123.0000, 'ºC'),
	(321480, 145, '2015-01-15 00:02:25.000000', 'temperatura', 597.0000, 'ºC'),
	(321481, 145, '2015-01-15 00:02:26.000000', 'temperatura', 816.0000, 'ºC'),
	(321482, 145, '2015-01-15 00:02:27.000000', 'temperatura', 1092.0000, 'ºC'),
	(321483, 145, '2015-01-15 00:02:28.000000', 'temperatura', 613.0000, 'ºC'),
	(321484, 145, '2015-01-15 00:02:29.000000', 'temperatura', 990.0000, 'ºC'),
	(321485, 145, '2015-01-15 00:02:30.000000', 'temperatura', 708.0000, 'ºC'),
	(321486, 145, '2015-01-15 00:02:31.000000', 'temperatura', 573.0000, 'ºC'),
	(321487, 145, '2015-01-15 00:02:32.000000', 'temperatura', 742.0000, 'ºC'),
	(321488, 145, '2015-01-15 00:02:33.000000', 'temperatura', 792.0000, 'ºC'),
	(321489, 145, '2015-01-15 00:02:34.000000', 'temperatura', 536.0000, 'ºC'),
	(321490, 145, '2015-01-15 00:02:35.000000', 'temperatura', 301.0000, 'ºC'),
	(321491, 145, '2015-01-15 00:02:36.000000', 'temperatura', 1100.0000, 'ºC'),
	(321492, 145, '2015-01-15 00:02:37.000000', 'temperatura', 998.0000, 'ºC'),
	(321493, 145, '2015-01-15 00:02:38.000000', 'temperatura', 492.0000, 'ºC'),
	(321494, 145, '2015-01-15 00:02:39.000000', 'temperatura', 663.0000, 'ºC'),
	(321495, 145, '2015-01-15 00:02:40.000000', 'temperatura', 640.0000, 'ºC'),
	(321496, 145, '2015-01-15 00:02:41.000000', 'temperatura', 14.0000, 'ºC'),
	(321497, 145, '2015-01-15 00:02:42.000000', 'temperatura', 549.0000, 'ºC'),
	(321498, 145, '2015-01-15 00:02:43.000000', 'temperatura', 302.0000, 'ºC'),
	(321499, 145, '2015-01-15 00:02:44.000000', 'temperatura', 1063.0000, 'ºC'),
	(321500, 145, '2015-01-15 00:02:45.000000', 'temperatura', 810.0000, 'ºC'),
	(321501, 145, '2015-01-15 00:02:46.000000', 'temperatura', 861.0000, 'ºC'),
	(321502, 145, '2015-01-15 00:02:47.000000', 'temperatura', 678.0000, 'ºC'),
	(321503, 145, '2015-01-15 00:02:48.000000', 'temperatura', 806.0000, 'ºC'),
	(321504, 145, '2015-01-15 00:02:49.000000', 'temperatura', 795.0000, 'ºC'),
	(321505, 145, '2015-01-15 00:02:50.000000', 'temperatura', 359.0000, 'ºC'),
	(321506, 145, '2015-01-15 00:02:51.000000', 'temperatura', 612.0000, 'ºC'),
	(321507, 145, '2015-01-15 00:02:52.000000', 'temperatura', 783.0000, 'ºC'),
	(321508, 145, '2015-01-15 00:02:53.000000', 'temperatura', 877.0000, 'ºC'),
	(321509, 145, '2015-01-15 00:02:54.000000', 'temperatura', 838.0000, 'ºC'),
	(321510, 145, '2015-01-15 00:02:55.000000', 'temperatura', 358.0000, 'ºC'),
	(321511, 145, '2015-01-15 00:02:56.000000', 'temperatura', 479.0000, 'ºC'),
	(321512, 145, '2015-01-15 00:02:57.000000', 'temperatura', 122.0000, 'ºC'),
	(321513, 145, '2015-01-15 00:02:58.000000', 'temperatura', 375.0000, 'ºC'),
	(321514, 145, '2015-01-15 00:02:59.000000', 'temperatura', 306.0000, 'ºC'),
	(321515, 145, '2015-01-15 00:03:00.000000', 'temperatura', 406.0000, 'ºC'),
	(321516, 145, '2015-01-15 00:03:01.000000', 'temperatura', 1111.0000, 'ºC'),
	(321517, 145, '2015-01-15 00:03:02.000000', 'temperatura', 739.0000, 'ºC'),
	(321518, 145, '2015-01-15 00:03:03.000000', 'temperatura', 362.0000, 'ºC'),
	(321519, 145, '2015-01-15 00:03:04.000000', 'temperatura', 793.0000, 'ºC'),
	(321520, 145, '2015-01-15 00:03:05.000000', 'temperatura', 480.0000, 'ºC'),
	(321521, 145, '2015-01-15 00:03:06.000000', 'temperatura', 24.0000, 'ºC'),
	(321522, 145, '2015-01-15 00:03:07.000000', 'temperatura', 1077.0000, 'ºC'),
	(321523, 145, '2015-01-15 00:03:08.000000', 'temperatura', 515.0000, 'ºC'),
	(321524, 145, '2015-01-15 00:03:09.000000', 'temperatura', 543.0000, 'ºC'),
	(321525, 145, '2015-01-15 00:03:10.000000', 'temperatura', 1171.0000, 'ºC'),
	(321526, 145, '2015-01-15 00:03:11.000000', 'temperatura', 627.0000, 'ºC'),
	(321527, 145, '2015-01-15 00:03:12.000000', 'temperatura', 823.0000, 'ºC'),
	(321528, 145, '2015-01-15 00:03:13.000000', 'temperatura', 1034.0000, 'ºC'),
	(321529, 145, '2015-01-15 00:03:14.000000', 'temperatura', 302.0000, 'ºC'),
	(321530, 145, '2015-01-15 00:03:15.000000', 'temperatura', 809.0000, 'ºC'),
	(321531, 145, '2015-01-15 00:03:16.000000', 'temperatura', 739.0000, 'ºC'),
	(321532, 145, '2015-01-15 00:03:17.000000', 'temperatura', 70.0000, 'ºC'),
	(321533, 145, '2015-01-15 00:03:18.000000', 'temperatura', 534.0000, 'ºC'),
	(321534, 145, '2015-01-15 00:03:19.000000', 'temperatura', 58.0000, 'ºC'),
	(321535, 145, '2015-01-15 00:03:20.000000', 'temperatura', 1089.0000, 'ºC'),
	(321536, 145, '2015-01-15 00:03:21.000000', 'temperatura', 471.0000, 'ºC'),
	(321537, 145, '2015-01-15 00:03:22.000000', 'temperatura', 291.0000, 'ºC'),
	(321538, 145, '2015-01-15 00:03:23.000000', 'temperatura', 40.0000, 'ºC'),
	(321539, 145, '2015-01-15 00:03:24.000000', 'temperatura', 529.0000, 'ºC'),
	(321540, 145, '2015-01-15 00:03:25.000000', 'temperatura', 126.0000, 'ºC'),
	(321541, 145, '2015-01-15 00:03:26.000000', 'temperatura', 242.0000, 'ºC'),
	(321542, 145, '2015-01-15 00:03:27.000000', 'temperatura', 834.0000, 'ºC'),
	(321543, 145, '2015-01-15 00:03:28.000000', 'temperatura', 1043.0000, 'ºC'),
	(321544, 145, '2015-01-15 00:03:29.000000', 'temperatura', 313.0000, 'ºC'),
	(321545, 145, '2015-01-15 00:03:30.000000', 'temperatura', 836.0000, 'ºC'),
	(321546, 145, '2015-01-15 00:03:31.000000', 'temperatura', 843.0000, 'ºC'),
	(321547, 145, '2015-01-15 00:03:32.000000', 'temperatura', 507.0000, 'ºC'),
	(321548, 145, '2015-01-15 00:03:33.000000', 'temperatura', 6.0000, 'ºC'),
	(321549, 145, '2015-01-15 00:03:34.000000', 'temperatura', 910.0000, 'ºC'),
	(321550, 145, '2015-01-15 00:03:35.000000', 'temperatura', 933.0000, 'ºC'),
	(321551, 145, '2015-01-15 00:03:36.000000', 'temperatura', 737.0000, 'ºC'),
	(321552, 145, '2015-01-15 00:03:37.000000', 'temperatura', 883.0000, 'ºC'),
	(321553, 145, '2015-01-15 00:03:38.000000', 'temperatura', 1006.0000, 'ºC'),
	(321554, 145, '2015-01-15 00:03:39.000000', 'temperatura', 1182.0000, 'ºC'),
	(321555, 145, '2015-01-15 00:03:40.000000', 'temperatura', 494.0000, 'ºC'),
	(321556, 145, '2015-01-15 00:03:41.000000', 'temperatura', 121.0000, 'ºC'),
	(321557, 145, '2015-01-15 00:03:42.000000', 'temperatura', 326.0000, 'ºC'),
	(321558, 145, '2015-01-15 00:03:43.000000', 'temperatura', 67.0000, 'ºC'),
	(321559, 145, '2015-01-15 00:03:44.000000', 'temperatura', 558.0000, 'ºC'),
	(321560, 145, '2015-01-15 00:03:45.000000', 'temperatura', 189.0000, 'ºC'),
	(321561, 145, '2015-01-15 00:03:46.000000', 'temperatura', 472.0000, 'ºC'),
	(321562, 145, '2015-01-15 00:03:47.000000', 'temperatura', 594.0000, 'ºC'),
	(321563, 145, '2015-01-15 00:03:48.000000', 'temperatura', 352.0000, 'ºC'),
	(321564, 145, '2015-01-15 00:03:49.000000', 'temperatura', 1180.0000, 'ºC'),
	(321565, 145, '2015-01-15 00:03:50.000000', 'temperatura', 45.0000, 'ºC'),
	(321566, 145, '2015-01-15 00:03:51.000000', 'temperatura', 287.0000, 'ºC'),
	(321567, 145, '2015-01-15 00:03:52.000000', 'temperatura', 98.0000, 'ºC'),
	(321568, 145, '2015-01-15 00:03:53.000000', 'temperatura', 832.0000, 'ºC'),
	(321569, 145, '2015-01-15 00:03:54.000000', 'temperatura', 267.0000, 'ºC'),
	(321570, 145, '2015-01-15 00:03:55.000000', 'temperatura', 37.0000, 'ºC'),
	(321571, 145, '2015-01-15 00:03:56.000000', 'temperatura', 584.0000, 'ºC'),
	(321572, 145, '2015-01-15 00:03:57.000000', 'temperatura', 410.0000, 'ºC'),
	(321573, 145, '2015-01-15 00:03:58.000000', 'temperatura', 297.0000, 'ºC'),
	(321574, 145, '2015-01-15 00:03:59.000000', 'temperatura', 258.0000, 'ºC'),
	(321575, 145, '2015-01-15 00:04:00.000000', 'temperatura', 398.0000, 'ºC'),
	(321576, 145, '2015-01-15 00:04:01.000000', 'temperatura', 16.0000, 'ºC'),
	(321577, 145, '2015-01-15 00:04:02.000000', 'temperatura', 86.0000, 'ºC'),
	(321578, 145, '2015-01-15 00:04:03.000000', 'temperatura', 384.0000, 'ºC'),
	(321579, 145, '2015-01-15 00:04:04.000000', 'temperatura', 462.0000, 'ºC'),
	(321580, 145, '2015-01-15 00:04:05.000000', 'temperatura', 1157.0000, 'ºC'),
	(321581, 145, '2015-01-15 00:04:06.000000', 'temperatura', 799.0000, 'ºC'),
	(321582, 145, '2015-01-15 00:04:07.000000', 'temperatura', 527.0000, 'ºC'),
	(321583, 145, '2015-01-15 00:04:08.000000', 'temperatura', 237.0000, 'ºC'),
	(321584, 145, '2015-01-15 00:04:09.000000', 'temperatura', 804.0000, 'ºC'),
	(321585, 145, '2015-01-15 00:04:10.000000', 'temperatura', 909.0000, 'ºC'),
	(321586, 145, '2015-01-15 00:04:11.000000', 'temperatura', 936.0000, 'ºC'),
	(321587, 145, '2015-01-15 00:04:12.000000', 'temperatura', 751.0000, 'ºC'),
	(321588, 145, '2015-01-15 00:04:13.000000', 'temperatura', 948.0000, 'ºC'),
	(321589, 145, '2015-01-15 00:04:14.000000', 'temperatura', 86.0000, 'ºC'),
	(321590, 145, '2015-01-15 00:04:15.000000', 'temperatura', 1189.0000, 'ºC'),
	(321591, 145, '2015-01-15 00:04:16.000000', 'temperatura', 885.0000, 'ºC'),
	(321592, 145, '2015-01-15 00:04:17.000000', 'temperatura', 862.0000, 'ºC'),
	(321593, 145, '2015-01-15 00:04:18.000000', 'temperatura', 452.0000, 'ºC'),
	(321594, 145, '2015-01-15 00:04:19.000000', 'temperatura', 875.0000, 'ºC'),
	(321595, 145, '2015-01-15 00:04:20.000000', 'temperatura', 621.0000, 'ºC'),
	(321596, 145, '2015-01-15 00:04:21.000000', 'temperatura', 480.0000, 'ºC'),
	(321597, 145, '2015-01-15 00:04:22.000000', 'temperatura', 539.0000, 'ºC'),
	(321598, 145, '2015-01-15 00:04:23.000000', 'temperatura', 55.0000, 'ºC'),
	(321599, 145, '2015-01-15 00:04:24.000000', 'temperatura', 1058.0000, 'ºC'),
	(321600, 145, '2015-01-15 00:04:25.000000', 'temperatura', 327.0000, 'ºC'),
	(321601, 145, '2015-01-15 00:04:26.000000', 'temperatura', 859.0000, 'ºC'),
	(321602, 145, '2015-01-15 00:04:27.000000', 'temperatura', 915.0000, 'ºC'),
	(321603, 145, '2015-01-15 00:04:28.000000', 'temperatura', 800.0000, 'ºC'),
	(321604, 145, '2015-01-15 00:04:29.000000', 'temperatura', 56.0000, 'ºC'),
	(321605, 145, '2015-01-15 00:04:30.000000', 'temperatura', 281.0000, 'ºC'),
	(321606, 145, '2015-01-15 00:04:31.000000', 'temperatura', 35.0000, 'ºC'),
	(321607, 145, '2015-01-15 00:04:32.000000', 'temperatura', 532.0000, 'ºC'),
	(321608, 145, '2015-01-15 00:04:33.000000', 'temperatura', 157.0000, 'ºC'),
	(321609, 145, '2015-01-15 00:04:34.000000', 'temperatura', 389.0000, 'ºC'),
	(321610, 145, '2015-01-15 00:04:35.000000', 'temperatura', 275.0000, 'ºC'),
	(321611, 145, '2015-01-15 00:04:36.000000', 'temperatura', 207.0000, 'ºC'),
	(321612, 145, '2015-01-15 00:04:37.000000', 'temperatura', 212.0000, 'ºC'),
	(321613, 145, '2015-01-15 00:04:38.000000', 'temperatura', 438.0000, 'ºC'),
	(321614, 145, '2015-01-15 00:04:39.000000', 'temperatura', 355.0000, 'ºC'),
	(321615, 145, '2015-01-15 00:04:40.000000', 'temperatura', 462.0000, 'ºC'),
	(321616, 145, '2015-01-15 00:04:41.000000', 'temperatura', 46.0000, 'ºC'),
	(321617, 145, '2015-01-15 00:04:42.000000', 'temperatura', 44.0000, 'ºC'),
	(321618, 145, '2015-01-15 00:04:43.000000', 'temperatura', 82.0000, 'ºC'),
	(321619, 145, '2015-01-15 00:04:44.000000', 'temperatura', 278.0000, 'ºC'),
	(321620, 145, '2015-01-15 00:04:45.000000', 'temperatura', 1147.0000, 'ºC'),
	(321621, 145, '2015-01-15 00:04:46.000000', 'temperatura', 101.0000, 'ºC'),
	(321622, 145, '2015-01-15 00:04:47.000000', 'temperatura', 662.0000, 'ºC'),
	(321623, 145, '2015-01-15 00:04:48.000000', 'temperatura', 608.0000, 'ºC'),
	(321624, 145, '2015-01-15 00:04:49.000000', 'temperatura', 1055.0000, 'ºC'),
	(321625, 145, '2015-01-15 00:04:50.000000', 'temperatura', 1050.0000, 'ºC'),
	(321626, 145, '2015-01-15 00:04:51.000000', 'temperatura', 888.0000, 'ºC'),
	(321627, 145, '2015-01-15 00:04:52.000000', 'temperatura', 91.0000, 'ºC'),
	(321628, 145, '2015-01-15 00:04:53.000000', 'temperatura', 192.0000, 'ºC'),
	(321629, 145, '2015-01-15 00:04:54.000000', 'temperatura', 688.0000, 'ºC'),
	(321630, 145, '2015-01-15 00:04:55.000000', 'temperatura', 463.0000, 'ºC'),
	(321631, 145, '2015-01-15 00:04:56.000000', 'temperatura', 252.0000, 'ºC'),
	(321632, 145, '2015-01-15 00:04:57.000000', 'temperatura', 1071.0000, 'ºC'),
	(321633, 145, '2015-01-15 00:04:58.000000', 'temperatura', 1001.0000, 'ºC'),
	(321634, 145, '2015-01-15 00:04:59.000000', 'temperatura', 593.0000, 'ºC'),
	(321635, 145, '2015-01-15 00:05:00.000000', 'temperatura', 1162.0000, 'ºC'),
	(321636, 145, '2015-01-15 00:05:01.000000', 'temperatura', 433.0000, 'ºC'),
	(321637, 145, '2015-01-15 00:05:02.000000', 'temperatura', 1078.0000, 'ºC'),
	(321638, 145, '2015-01-15 00:05:03.000000', 'temperatura', 490.0000, 'ºC'),
	(321639, 145, '2015-01-15 00:05:04.000000', 'temperatura', 420.0000, 'ºC'),
	(321640, 145, '2015-01-15 00:05:05.000000', 'temperatura', 627.0000, 'ºC'),
	(321641, 145, '2015-01-15 00:05:06.000000', 'temperatura', 678.0000, 'ºC'),
	(321642, 145, '2015-01-15 00:05:07.000000', 'temperatura', 310.0000, 'ºC'),
	(321643, 145, '2015-01-15 00:05:08.000000', 'temperatura', 716.0000, 'ºC'),
	(321644, 145, '2015-01-15 00:05:09.000000', 'temperatura', 252.0000, 'ºC'),
	(321645, 145, '2015-01-15 00:05:10.000000', 'temperatura', 312.0000, 'ºC'),
	(321646, 145, '2015-01-15 00:05:11.000000', 'temperatura', 803.0000, 'ºC'),
	(321647, 145, '2015-01-15 00:05:12.000000', 'temperatura', 681.0000, 'ºC'),
	(321648, 145, '2015-01-15 00:05:13.000000', 'temperatura', 995.0000, 'ºC'),
	(321649, 145, '2015-01-15 00:05:14.000000', 'temperatura', 535.0000, 'ºC'),
	(321650, 145, '2015-01-15 00:05:15.000000', 'temperatura', 889.0000, 'ºC'),
	(321651, 145, '2015-01-15 00:05:16.000000', 'temperatura', 442.0000, 'ºC'),
	(321652, 145, '2015-01-15 00:05:17.000000', 'temperatura', 741.0000, 'ºC'),
	(321653, 145, '2015-01-15 00:05:18.000000', 'temperatura', 1183.0000, 'ºC'),
	(321654, 145, '2015-01-15 00:05:19.000000', 'temperatura', 89.0000, 'ºC'),
	(321655, 145, '2015-01-15 00:05:20.000000', 'temperatura', 498.0000, 'ºC'),
	(321656, 145, '2015-01-15 00:05:21.000000', 'temperatura', 1023.0000, 'ºC'),
	(321657, 145, '2015-01-15 00:05:22.000000', 'temperatura', 22.0000, 'ºC'),
	(321658, 145, '2015-01-15 00:05:23.000000', 'temperatura', 641.0000, 'ºC'),
	(321659, 145, '2015-01-15 00:05:24.000000', 'temperatura', 740.0000, 'ºC'),
	(321660, 145, '2015-01-15 00:05:25.000000', 'temperatura', 579.0000, 'ºC'),
	(321661, 145, '2015-01-15 00:05:26.000000', 'temperatura', 672.0000, 'ºC'),
	(321662, 145, '2015-01-15 00:05:27.000000', 'temperatura', 427.0000, 'ºC'),
	(321663, 145, '2015-01-15 00:05:28.000000', 'temperatura', 119.0000, 'ºC'),
	(321664, 145, '2015-01-15 00:05:29.000000', 'temperatura', 512.0000, 'ºC'),
	(321665, 145, '2015-01-15 00:05:30.000000', 'temperatura', 1005.0000, 'ºC'),
	(321666, 145, '2015-01-15 00:05:31.000000', 'temperatura', 1088.0000, 'ºC'),
	(321667, 145, '2015-01-15 00:05:32.000000', 'temperatura', 28.0000, 'ºC'),
	(321668, 145, '2015-01-15 00:05:33.000000', 'temperatura', 476.0000, 'ºC'),
	(321669, 145, '2015-01-15 00:05:34.000000', 'temperatura', 1098.0000, 'ºC'),
	(321670, 145, '2015-01-15 00:05:35.000000', 'temperatura', 461.0000, 'ºC'),
	(321671, 145, '2015-01-15 00:05:36.000000', 'temperatura', 212.0000, 'ºC'),
	(321672, 145, '2015-01-15 00:05:37.000000', 'temperatura', 877.0000, 'ºC'),
	(321673, 145, '2015-01-15 00:05:38.000000', 'temperatura', 150.0000, 'ºC'),
	(321674, 145, '2015-01-15 00:05:39.000000', 'temperatura', 519.0000, 'ºC'),
	(321675, 145, '2015-01-15 00:05:40.000000', 'temperatura', 947.0000, 'ºC'),
	(321676, 145, '2015-01-15 00:05:41.000000', 'temperatura', 777.0000, 'ºC'),
	(321677, 145, '2015-01-15 00:05:42.000000', 'temperatura', 1044.0000, 'ºC'),
	(321678, 145, '2015-01-15 00:05:43.000000', 'temperatura', 491.0000, 'ºC'),
	(321679, 145, '2015-01-15 00:05:44.000000', 'temperatura', 521.0000, 'ºC'),
	(321680, 145, '2015-01-15 00:05:45.000000', 'temperatura', 1133.0000, 'ºC'),
	(321681, 145, '2015-01-15 00:05:46.000000', 'temperatura', 503.0000, 'ºC'),
	(321682, 145, '2015-01-15 00:05:47.000000', 'temperatura', 315.0000, 'ºC'),
	(321683, 145, '2015-01-15 00:05:48.000000', 'temperatura', 67.0000, 'ºC'),
	(321684, 145, '2015-01-15 00:05:49.000000', 'temperatura', 592.0000, 'ºC'),
	(321685, 145, '2015-01-15 00:05:50.000000', 'temperatura', 357.0000, 'ºC'),
	(321686, 145, '2015-01-15 00:05:51.000000', 'temperatura', 10.0000, 'ºC'),
	(321687, 145, '2015-01-15 00:05:52.000000', 'temperatura', 179.0000, 'ºC'),
	(321688, 145, '2015-01-15 00:05:53.000000', 'temperatura', 867.0000, 'ºC'),
	(321689, 145, '2015-01-15 00:05:54.000000', 'temperatura', 199.0000, 'ºC'),
	(321690, 145, '2015-01-15 00:05:55.000000', 'temperatura', 794.0000, 'ºC'),
	(321691, 145, '2015-01-15 00:05:56.000000', 'temperatura', 974.0000, 'ºC'),
	(321692, 145, '2015-01-15 00:05:57.000000', 'temperatura', 89.0000, 'ºC'),
	(321693, 145, '2015-01-15 00:05:58.000000', 'temperatura', 1122.0000, 'ºC'),
	(321694, 145, '2015-01-15 00:05:59.000000', 'temperatura', 545.0000, 'ºC'),
	(321695, 145, '2015-01-15 00:06:00.000000', 'temperatura', 559.0000, 'ºC'),
	(321696, 145, '2015-01-15 00:06:01.000000', 'temperatura', 1159.0000, 'ºC'),
	(321697, 145, '2015-01-15 00:06:02.000000', 'temperatura', 520.0000, 'ºC'),
	(321698, 145, '2015-01-15 00:06:03.000000', 'temperatura', 321.0000, 'ºC'),
	(321699, 145, '2015-01-15 00:06:04.000000', 'temperatura', 47.0000, 'ºC'),
	(321700, 145, '2015-01-15 00:06:05.000000', 'temperatura', 473.0000, 'ºC'),
	(321701, 145, '2015-01-15 00:06:06.000000', 'temperatura', 1024.0000, 'ºC'),
	(321702, 145, '2015-01-15 00:06:07.000000', 'temperatura', 102.0000, 'ºC'),
	(321703, 145, '2015-01-15 00:06:08.000000', 'temperatura', 1038.0000, 'ºC'),
	(321704, 145, '2015-01-15 00:06:09.000000', 'temperatura', 84.0000, 'ºC'),
	(321705, 145, '2015-01-15 00:06:10.000000', 'temperatura', 908.0000, 'ºC'),
	(321706, 145, '2015-01-15 00:06:11.000000', 'temperatura', 687.0000, 'ºC'),
	(321707, 145, '2015-01-15 00:06:12.000000', 'temperatura', 712.0000, 'ºC'),
	(321708, 145, '2015-01-15 00:06:13.000000', 'temperatura', 300.0000, 'ºC'),
	(321709, 145, '2015-01-15 00:06:14.000000', 'temperatura', 564.0000, 'ºC'),
	(321710, 145, '2015-01-15 00:06:15.000000', 'temperatura', 721.0000, 'ºC'),
	(321711, 145, '2015-01-15 00:06:16.000000', 'temperatura', 715.0000, 'ºC'),
	(321712, 145, '2015-01-15 00:06:17.000000', 'temperatura', 210.0000, 'ºC'),
	(321713, 145, '2015-01-15 00:06:18.000000', 'temperatura', 105.0000, 'ºC'),
	(321714, 145, '2015-01-15 00:06:19.000000', 'temperatura', 1095.0000, 'ºC'),
	(321715, 145, '2015-01-15 00:06:20.000000', 'temperatura', 362.0000, 'ºC'),
	(321716, 145, '2015-01-15 00:06:21.000000', 'temperatura', 927.0000, 'ºC'),
	(321717, 145, '2015-01-15 00:06:22.000000', 'temperatura', 1147.0000, 'ºC'),
	(321718, 145, '2015-01-15 00:06:23.000000', 'temperatura', 556.0000, 'ºC'),
	(321719, 145, '2015-01-15 00:06:24.000000', 'temperatura', 540.0000, 'ºC'),
	(321720, 145, '2015-01-15 00:06:25.000000', 'temperatura', 1033.0000, 'ºC'),
	(321721, 145, '2015-01-15 00:06:26.000000', 'temperatura', 1143.0000, 'ºC'),
	(321722, 145, '2015-01-15 00:06:27.000000', 'temperatura', 219.0000, 'ºC'),
	(321723, 145, '2015-01-15 00:06:28.000000', 'temperatura', 65.0000, 'ºC'),
	(321724, 145, '2015-01-15 00:06:29.000000', 'temperatura', 870.0000, 'ºC'),
	(321725, 145, '2015-01-15 00:06:30.000000', 'temperatura', 554.0000, 'ºC'),
	(321726, 145, '2015-01-15 00:06:31.000000', 'temperatura', 163.0000, 'ºC'),
	(321727, 145, '2015-01-15 00:06:32.000000', 'temperatura', 351.0000, 'ºC'),
	(321728, 145, '2015-01-15 00:06:33.000000', 'temperatura', 66.0000, 'ºC'),
	(321729, 145, '2015-01-15 00:06:34.000000', 'temperatura', 476.0000, 'ºC'),
	(321730, 145, '2015-01-15 00:06:35.000000', 'temperatura', 986.0000, 'ºC'),
	(321731, 145, '2015-01-15 00:06:36.000000', 'temperatura', 1100.0000, 'ºC'),
	(321732, 145, '2015-01-15 00:06:37.000000', 'temperatura', 145.0000, 'ºC'),
	(321733, 145, '2015-01-15 00:06:38.000000', 'temperatura', 1024.0000, 'ºC'),
	(321734, 145, '2015-01-15 00:06:39.000000', 'temperatura', 1087.0000, 'ºC'),
	(321735, 145, '2015-01-15 00:06:40.000000', 'temperatura', 1162.0000, 'ºC'),
	(321736, 145, '2015-01-15 00:06:41.000000', 'temperatura', 151.0000, 'ºC'),
	(321737, 145, '2015-01-15 00:06:42.000000', 'temperatura', 870.0000, 'ºC'),
	(321738, 145, '2015-01-15 00:06:43.000000', 'temperatura', 298.0000, 'ºC'),
	(321739, 145, '2015-01-15 00:06:44.000000', 'temperatura', 78.0000, 'ºC'),
	(321740, 145, '2015-01-15 00:06:45.000000', 'temperatura', 696.0000, 'ºC'),
	(321741, 145, '2015-01-15 00:06:46.000000', 'temperatura', 846.0000, 'ºC'),
	(321742, 145, '2015-01-15 00:06:47.000000', 'temperatura', 943.0000, 'ºC'),
	(321743, 145, '2015-01-15 00:06:48.000000', 'temperatura', 977.0000, 'ºC'),
	(321744, 145, '2015-01-15 00:06:49.000000', 'temperatura', 855.0000, 'ºC'),
	(321745, 145, '2015-01-15 00:06:50.000000', 'temperatura', 146.0000, 'ºC'),
	(321746, 145, '2015-01-15 00:06:51.000000', 'temperatura', 565.0000, 'ºC'),
	(321747, 145, '2015-01-15 00:06:52.000000', 'temperatura', 1190.0000, 'ºC'),
	(321748, 145, '2015-01-15 00:06:53.000000', 'temperatura', 653.0000, 'ºC'),
	(321749, 145, '2015-01-15 00:06:54.000000', 'temperatura', 896.0000, 'ºC'),
	(321750, 145, '2015-01-15 00:06:55.000000', 'temperatura', 121.0000, 'ºC'),
	(321751, 145, '2015-01-15 00:06:56.000000', 'temperatura', 319.0000, 'ºC'),
	(321752, 145, '2015-01-15 00:06:57.000000', 'temperatura', 34.0000, 'ºC'),
	(321753, 145, '2015-01-15 00:06:58.000000', 'temperatura', 411.0000, 'ºC'),
	(321754, 145, '2015-01-15 00:06:59.000000', 'temperatura', 756.0000, 'ºC'),
	(321755, 145, '2015-01-15 00:07:00.000000', 'temperatura', 147.0000, 'ºC'),
	(321756, 145, '2015-01-15 00:07:01.000000', 'temperatura', 866.0000, 'ºC'),
	(321757, 145, '2015-01-15 00:07:02.000000', 'temperatura', 289.0000, 'ºC'),
	(321758, 145, '2015-01-15 00:07:03.000000', 'temperatura', 49.0000, 'ºC'),
	(321759, 145, '2015-01-15 00:07:04.000000', 'temperatura', 580.0000, 'ºC'),
	(321760, 145, '2015-01-15 00:07:05.000000', 'temperatura', 352.0000, 'ºC'),
	(321761, 145, '2015-01-15 00:07:06.000000', 'temperatura', 23.0000, 'ºC'),
	(321762, 145, '2015-01-15 00:07:07.000000', 'temperatura', 256.0000, 'ºC'),
	(321763, 145, '2015-01-15 00:07:08.000000', 'temperatura', 12.0000, 'ºC'),
	(321764, 145, '2015-01-15 00:07:09.000000', 'temperatura', 494.0000, 'ºC'),
	(321765, 145, '2015-01-15 00:07:10.000000', 'temperatura', 33.0000, 'ºC'),
	(321766, 145, '2015-01-15 00:07:11.000000', 'temperatura', 1082.0000, 'ºC'),
	(321767, 145, '2015-01-15 00:07:12.000000', 'temperatura', 514.0000, 'ºC'),
	(321768, 145, '2015-01-15 00:07:13.000000', 'temperatura', 523.0000, 'ºC'),
	(321769, 145, '2015-01-15 00:07:14.000000', 'temperatura', 1073.0000, 'ºC'),
	(321770, 145, '2015-01-15 00:07:15.000000', 'temperatura', 198.0000, 'ºC'),
	(321771, 145, '2015-01-15 00:07:16.000000', 'temperatura', 171.0000, 'ºC'),
	(321772, 145, '2015-01-15 00:07:17.000000', 'temperatura', 263.0000, 'ºC'),
	(321773, 145, '2015-01-15 00:07:18.000000', 'temperatura', 800.0000, 'ºC'),
	(321774, 145, '2015-01-15 00:07:19.000000', 'temperatura', 811.0000, 'ºC'),
	(321775, 145, '2015-01-15 00:07:20.000000', 'temperatura', 456.0000, 'ºC'),
	(321776, 145, '2015-01-15 00:07:21.000000', 'temperatura', 1046.0000, 'ºC'),
	(321777, 145, '2015-01-15 00:07:22.000000', 'temperatura', 263.0000, 'ºC'),
	(321778, 145, '2015-01-15 00:07:23.000000', 'temperatura', 580.0000, 'ºC'),
	(321779, 145, '2015-01-15 00:07:24.000000', 'temperatura', 909.0000, 'ºC'),
	(321780, 145, '2015-01-15 00:07:25.000000', 'temperatura', 404.0000, 'ºC'),
	(321781, 145, '2015-01-15 00:07:26.000000', 'temperatura', 497.0000, 'ºC'),
	(321782, 145, '2015-01-15 00:07:27.000000', 'temperatura', 71.0000, 'ºC'),
	(321783, 145, '2015-01-15 00:07:28.000000', 'temperatura', 66.0000, 'ºC'),
	(321784, 145, '2015-01-15 00:07:29.000000', 'temperatura', 118.0000, 'ºC'),
	(321785, 145, '2015-01-15 00:07:30.000000', 'temperatura', 392.0000, 'ºC'),
	(321786, 145, '2015-01-15 00:07:31.000000', 'temperatura', 408.0000, 'ºC'),
	(321787, 145, '2015-01-15 00:07:32.000000', 'temperatura', 864.0000, 'ºC'),
	(321788, 145, '2015-01-15 00:07:33.000000', 'temperatura', 694.0000, 'ºC'),
	(321789, 145, '2015-01-15 00:07:34.000000', 'temperatura', 880.0000, 'ºC'),
	(321790, 145, '2015-01-15 00:07:35.000000', 'temperatura', 1117.0000, 'ºC'),
	(321791, 145, '2015-01-15 00:07:36.000000', 'temperatura', 545.0000, 'ºC'),
	(321792, 145, '2015-01-15 00:07:37.000000', 'temperatura', 575.0000, 'ºC'),
	(321793, 145, '2015-01-15 00:07:38.000000', 'temperatura', 42.0000, 'ºC'),
	(321794, 145, '2015-01-15 00:07:39.000000', 'temperatura', 884.0000, 'ºC'),
	(321795, 145, '2015-01-15 00:07:40.000000', 'temperatura', 696.0000, 'ºC'),
	(321796, 145, '2015-01-15 00:07:41.000000', 'temperatura', 829.0000, 'ºC'),
	(321797, 145, '2015-01-15 00:07:42.000000', 'temperatura', 855.0000, 'ºC'),
	(321798, 145, '2015-01-15 00:07:43.000000', 'temperatura', 591.0000, 'ºC'),
	(321799, 145, '2015-01-15 00:07:44.000000', 'temperatura', 389.0000, 'ºC'),
	(321800, 145, '2015-01-15 00:07:45.000000', 'temperatura', 173.0000, 'ºC'),
	(321801, 145, '2015-01-15 00:07:46.000000', 'temperatura', 897.0000, 'ºC'),
	(321802, 145, '2015-01-15 00:07:47.000000', 'temperatura', 368.0000, 'ºC'),
	(321803, 145, '2015-01-15 00:07:48.000000', 'temperatura', 350.0000, 'ºC'),
	(321804, 145, '2015-01-15 00:07:49.000000', 'temperatura', 646.0000, 'ºC'),
	(321805, 145, '2015-01-15 00:07:50.000000', 'temperatura', 980.0000, 'ºC'),
	(321806, 145, '2015-01-15 00:07:51.000000', 'temperatura', 564.0000, 'ºC'),
	(321807, 145, '2015-01-15 00:07:52.000000', 'temperatura', 1081.0000, 'ºC'),
	(321808, 145, '2015-01-15 00:07:53.000000', 'temperatura', 113.0000, 'ºC'),
	(321809, 145, '2015-01-15 00:07:54.000000', 'temperatura', 924.0000, 'ºC'),
	(321810, 145, '2015-01-15 00:07:55.000000', 'temperatura', 679.0000, 'ºC'),
	(321811, 145, '2015-01-15 00:07:56.000000', 'temperatura', 625.0000, 'ºC'),
	(321812, 145, '2015-01-15 00:07:57.000000', 'temperatura', 1086.0000, 'ºC'),
	(321813, 145, '2015-01-15 00:07:58.000000', 'temperatura', 1157.0000, 'ºC'),
	(321814, 145, '2015-01-15 00:07:59.000000', 'temperatura', 129.0000, 'ºC'),
	(321815, 145, '2015-01-15 00:08:00.000000', 'temperatura', 775.0000, 'ºC'),
	(321816, 145, '2015-01-15 00:08:01.000000', 'temperatura', 1088.0000, 'ºC'),
	(321817, 145, '2015-01-15 00:08:02.000000', 'temperatura', 714.0000, 'ºC'),
	(321818, 145, '2015-01-15 00:08:03.000000', 'temperatura', 308.0000, 'ºC'),
	(321819, 145, '2015-01-15 00:08:04.000000', 'temperatura', 599.0000, 'ºC'),
	(321820, 145, '2015-01-15 00:08:05.000000', 'temperatura', 870.0000, 'ºC'),
	(321821, 145, '2015-01-15 00:08:06.000000', 'temperatura', 156.0000, 'ºC'),
	(321822, 145, '2015-01-15 00:08:07.000000', 'temperatura', 567.0000, 'ºC'),
	(321823, 145, '2015-01-15 00:08:08.000000', 'temperatura', 1170.0000, 'ºC'),
	(321824, 145, '2015-01-15 00:08:09.000000', 'temperatura', 551.0000, 'ºC'),
	(321825, 145, '2015-01-15 00:08:10.000000', 'temperatura', 442.0000, 'ºC'),
	(321826, 145, '2015-01-15 00:08:11.000000', 'temperatura', 560.0000, 'ºC'),
	(321827, 145, '2015-01-15 00:08:12.000000', 'temperatura', 273.0000, 'ºC'),
	(321828, 145, '2015-01-15 00:08:13.000000', 'temperatura', 885.0000, 'ºC'),
	(321829, 145, '2015-01-15 00:08:14.000000', 'temperatura', 6.0000, 'ºC'),
	(321830, 145, '2015-01-15 00:08:15.000000', 'temperatura', 977.0000, 'ºC'),
	(321831, 145, '2015-01-15 00:08:16.000000', 'temperatura', 66.0000, 'ºC'),
	(321832, 145, '2015-01-15 00:08:17.000000', 'temperatura', 998.0000, 'ºC'),
	(321833, 145, '2015-01-15 00:08:18.000000', 'temperatura', 1195.0000, 'ºC'),
	(321834, 145, '2015-01-15 00:08:19.000000', 'temperatura', 582.0000, 'ºC'),
	(321835, 145, '2015-01-15 00:08:20.000000', 'temperatura', 527.0000, 'ºC'),
	(321836, 145, '2015-01-15 00:08:21.000000', 'temperatura', 886.0000, 'ºC'),
	(321837, 145, '2015-01-15 00:08:22.000000', 'temperatura', 450.0000, 'ºC'),
	(321838, 145, '2015-01-15 00:08:23.000000', 'temperatura', 793.0000, 'ºC'),
	(321839, 145, '2015-01-15 00:08:24.000000', 'temperatura', 215.0000, 'ºC'),
	(321840, 145, '2015-01-15 00:08:25.000000', 'temperatura', 1096.0000, 'ºC'),
	(321841, 145, '2015-01-15 00:08:26.000000', 'temperatura', 38.0000, 'ºC'),
	(321842, 145, '2015-01-15 00:08:27.000000', 'temperatura', 501.0000, 'ºC'),
	(321843, 145, '2015-01-15 00:08:28.000000', 'temperatura', 1192.0000, 'ºC'),
	(321844, 145, '2015-01-15 00:08:29.000000', 'temperatura', 855.0000, 'ºC'),
	(321845, 145, '2015-01-15 00:08:30.000000', 'temperatura', 702.0000, 'ºC'),
	(321846, 145, '2015-01-15 00:08:31.000000', 'temperatura', 943.0000, 'ºC'),
	(321847, 145, '2015-01-15 00:08:32.000000', 'temperatura', 211.0000, 'ºC'),
	(321848, 145, '2015-01-15 00:08:33.000000', 'temperatura', 626.0000, 'ºC'),
	(321849, 145, '2015-01-15 00:08:34.000000', 'temperatura', 96.0000, 'ºC'),
	(321850, 145, '2015-01-15 00:08:35.000000', 'temperatura', 1004.0000, 'ºC'),
	(321851, 145, '2015-01-15 00:08:36.000000', 'temperatura', 1133.0000, 'ºC'),
	(321852, 145, '2015-01-15 00:08:37.000000', 'temperatura', 252.0000, 'ºC'),
	(321853, 145, '2015-01-15 00:08:38.000000', 'temperatura', 260.0000, 'ºC'),
	(321854, 145, '2015-01-15 00:08:39.000000', 'temperatura', 546.0000, 'ºC'),
	(321855, 145, '2015-01-15 00:08:40.000000', 'temperatura', 752.0000, 'ºC'),
	(321856, 145, '2015-01-15 00:08:41.000000', 'temperatura', 921.0000, 'ºC'),
	(321857, 145, '2015-01-15 00:08:42.000000', 'temperatura', 1149.0000, 'ºC'),
	(321858, 145, '2015-01-15 00:08:43.000000', 'temperatura', 584.0000, 'ºC'),
	(321859, 145, '2015-01-15 00:08:44.000000', 'temperatura', 672.0000, 'ºC'),
	(321860, 145, '2015-01-15 00:08:45.000000', 'temperatura', 411.0000, 'ºC'),
	(321861, 145, '2015-01-15 00:08:46.000000', 'temperatura', 38.0000, 'ºC'),
	(321862, 145, '2015-01-15 00:08:47.000000', 'temperatura', 158.0000, 'ºC'),
	(321863, 145, '2015-01-15 00:08:48.000000', 'temperatura', 675.0000, 'ºC'),
	(321864, 145, '2015-01-15 00:08:49.000000', 'temperatura', 504.0000, 'ºC'),
	(321865, 145, '2015-01-15 00:08:50.000000', 'temperatura', 496.0000, 'ºC'),
	(321866, 145, '2015-01-15 00:08:51.000000', 'temperatura', 966.0000, 'ºC'),
	(321867, 145, '2015-01-15 00:08:52.000000', 'temperatura', 943.0000, 'ºC'),
	(321868, 145, '2015-01-15 00:08:53.000000', 'temperatura', 620.0000, 'ºC'),
	(321869, 145, '2015-01-15 00:08:54.000000', 'temperatura', 269.0000, 'ºC'),
	(321870, 145, '2015-01-15 00:08:55.000000', 'temperatura', 688.0000, 'ºC'),
	(321871, 145, '2015-01-15 00:08:56.000000', 'temperatura', 231.0000, 'ºC'),
	(321872, 145, '2015-01-15 00:08:57.000000', 'temperatura', 292.0000, 'ºC'),
	(321873, 145, '2015-01-15 00:08:58.000000', 'temperatura', 767.0000, 'ºC'),
	(321874, 145, '2015-01-15 00:08:59.000000', 'temperatura', 562.0000, 'ºC'),
	(321875, 145, '2015-01-15 00:09:00.000000', 'temperatura', 508.0000, 'ºC'),
	(321876, 145, '2015-01-15 00:09:01.000000', 'temperatura', 853.0000, 'ºC'),
	(321877, 145, '2015-01-15 00:09:02.000000', 'temperatura', 341.0000, 'ºC'),
	(321878, 145, '2015-01-15 00:09:03.000000', 'temperatura', 349.0000, 'ºC'),
	(321879, 145, '2015-01-15 00:09:04.000000', 'temperatura', 724.0000, 'ºC'),
	(321880, 145, '2015-01-15 00:09:05.000000', 'temperatura', 170.0000, 'ºC'),
	(321881, 145, '2015-01-15 00:09:06.000000', 'temperatura', 1080.0000, 'ºC'),
	(321882, 145, '2015-01-15 00:09:07.000000', 'temperatura', 91.0000, 'ºC'),
	(321883, 145, '2015-01-15 00:09:08.000000', 'temperatura', 816.0000, 'ºC'),
	(321884, 145, '2015-01-15 00:09:09.000000', 'temperatura', 208.0000, 'ºC'),
	(321885, 145, '2015-01-15 00:09:10.000000', 'temperatura', 992.0000, 'ºC'),
	(321886, 145, '2015-01-15 00:09:11.000000', 'temperatura', 738.0000, 'ºC'),
	(321887, 145, '2015-01-15 00:09:12.000000', 'temperatura', 713.0000, 'ºC'),
	(321888, 145, '2015-01-15 00:09:13.000000', 'temperatura', 151.0000, 'ºC'),
	(321889, 145, '2015-01-15 00:09:14.000000', 'temperatura', 1017.0000, 'ºC'),
	(321890, 145, '2015-01-15 00:09:15.000000', 'temperatura', 1031.0000, 'ºC'),
	(321891, 145, '2015-01-15 00:09:16.000000', 'temperatura', 904.0000, 'ºC'),
	(321892, 145, '2015-01-15 00:09:17.000000', 'temperatura', 229.0000, 'ºC'),
	(321893, 145, '2015-01-15 00:09:18.000000', 'temperatura', 832.0000, 'ºC'),
	(321894, 145, '2015-01-15 00:09:19.000000', 'temperatura', 1073.0000, 'ºC'),
	(321895, 145, '2015-01-15 00:09:20.000000', 'temperatura', 470.0000, 'ºC'),
	(321896, 145, '2015-01-15 00:09:21.000000', 'temperatura', 331.0000, 'ºC'),
	(321897, 145, '2015-01-15 00:09:22.000000', 'temperatura', 248.0000, 'ºC'),
	(321898, 145, '2015-01-15 00:09:23.000000', 'temperatura', 247.0000, 'ºC'),
	(321899, 145, '2015-01-15 00:09:24.000000', 'temperatura', 490.0000, 'ºC'),
	(321900, 145, '2015-01-15 00:09:25.000000', 'temperatura', 508.0000, 'ºC'),
	(321901, 145, '2015-01-15 00:09:26.000000', 'temperatura', 1074.0000, 'ºC'),
	(321902, 145, '2015-01-15 00:09:27.000000', 'temperatura', 244.0000, 'ºC'),
	(321903, 145, '2015-01-15 00:09:28.000000', 'temperatura', 398.0000, 'ºC'),
	(321904, 145, '2015-01-15 00:09:29.000000', 'temperatura', 61.0000, 'ºC'),
	(321905, 145, '2015-01-15 00:09:30.000000', 'temperatura', 311.0000, 'ºC'),
	(321906, 145, '2015-01-15 00:09:31.000000', 'temperatura', 172.0000, 'ºC'),
	(321907, 145, '2015-01-15 00:09:32.000000', 'temperatura', 1128.0000, 'ºC'),
	(321908, 145, '2015-01-15 00:09:33.000000', 'temperatura', 326.0000, 'ºC'),
	(321909, 145, '2015-01-15 00:09:34.000000', 'temperatura', 644.0000, 'ºC'),
	(321910, 145, '2015-01-15 00:09:35.000000', 'temperatura', 1043.0000, 'ºC'),
	(321911, 145, '2015-01-15 00:09:36.000000', 'temperatura', 882.0000, 'ºC'),
	(321912, 145, '2015-01-15 00:09:37.000000', 'temperatura', 84.0000, 'ºC'),
	(321913, 145, '2015-01-15 00:09:38.000000', 'temperatura', 175.0000, 'ºC'),
	(321914, 145, '2015-01-15 00:09:39.000000', 'temperatura', 622.0000, 'ºC'),
	(321915, 145, '2015-01-15 00:09:40.000000', 'temperatura', 185.0000, 'ºC'),
	(321916, 145, '2015-01-15 00:09:41.000000', 'temperatura', 261.0000, 'ºC'),
	(321917, 145, '2015-01-15 00:09:42.000000', 'temperatura', 749.0000, 'ºC'),
	(321918, 145, '2015-01-15 00:09:43.000000', 'temperatura', 563.0000, 'ºC'),
	(321919, 145, '2015-01-15 00:09:44.000000', 'temperatura', 568.0000, 'ºC'),
	(321920, 145, '2015-01-15 00:09:45.000000', 'temperatura', 1150.0000, 'ºC'),
	(321921, 145, '2015-01-15 00:09:46.000000', 'temperatura', 448.0000, 'ºC'),
	(321922, 145, '2015-01-15 00:09:47.000000', 'temperatura', 1190.0000, 'ºC'),
	(321923, 145, '2015-01-15 00:09:48.000000', 'temperatura', 1007.0000, 'ºC'),
	(321924, 145, '2015-01-15 00:09:49.000000', 'temperatura', 267.0000, 'ºC'),
	(321925, 145, '2015-01-15 00:09:50.000000', 'temperatura', 714.0000, 'ºC'),
	(321926, 145, '2015-01-15 00:09:51.000000', 'temperatura', 368.0000, 'ºC'),
	(321927, 145, '2015-01-15 00:09:52.000000', 'temperatura', 899.0000, 'ºC'),
	(321928, 145, '2015-01-15 00:09:53.000000', 'temperatura', 993.0000, 'ºC'),
	(321929, 145, '2015-01-15 00:09:54.000000', 'temperatura', 1067.0000, 'ºC'),
	(321930, 145, '2015-01-15 00:09:55.000000', 'temperatura', 1156.0000, 'ºC'),
	(321931, 145, '2015-01-15 00:09:56.000000', 'temperatura', 179.0000, 'ºC'),
	(321932, 145, '2015-01-15 00:09:57.000000', 'temperatura', 1026.0000, 'ºC'),
	(321933, 145, '2015-01-15 00:09:58.000000', 'temperatura', 997.0000, 'ºC'),
	(321934, 145, '2015-01-15 00:09:59.000000', 'temperatura', 704.0000, 'ºC'),
	(321935, 145, '2015-01-15 00:10:00.000000', 'temperatura', 532.0000, 'ºC'),
	(321936, 145, '2015-01-15 00:10:01.000000', 'temperatura', 549.0000, 'ºC'),
	(321937, 145, '2015-01-15 00:10:02.000000', 'temperatura', 1151.0000, 'ºC'),
	(321938, 145, '2015-01-15 00:10:03.000000', 'temperatura', 505.0000, 'ºC'),
	(321939, 145, '2015-01-15 00:10:04.000000', 'temperatura', 275.0000, 'ºC'),
	(321940, 145, '2015-01-15 00:10:05.000000', 'temperatura', 1061.0000, 'ºC'),
	(321941, 145, '2015-01-15 00:10:06.000000', 'temperatura', 879.0000, 'ºC'),
	(321942, 145, '2015-01-15 00:10:07.000000', 'temperatura', 13.0000, 'ºC'),
	(321943, 145, '2015-01-15 00:10:08.000000', 'temperatura', 1027.0000, 'ºC'),
	(321944, 145, '2015-01-15 00:10:09.000000', 'temperatura', 298.0000, 'ºC'),
	(321945, 145, '2015-01-15 00:10:10.000000', 'temperatura', 811.0000, 'ºC'),
	(321946, 145, '2015-01-15 00:10:11.000000', 'temperatura', 758.0000, 'ºC'),
	(321947, 145, '2015-01-15 00:10:12.000000', 'temperatura', 161.0000, 'ºC'),
	(321948, 145, '2015-01-15 00:10:13.000000', 'temperatura', 929.0000, 'ºC'),
	(321949, 145, '2015-01-15 00:10:14.000000', 'temperatura', 564.0000, 'ºC'),
	(321950, 145, '2015-01-15 00:10:15.000000', 'temperatura', 34.0000, 'ºC'),
	(321951, 145, '2015-01-15 00:10:16.000000', 'temperatura', 880.0000, 'ºC'),
	(321952, 145, '2015-01-15 00:10:17.000000', 'temperatura', 696.0000, 'ºC'),
	(321953, 145, '2015-01-15 00:10:18.000000', 'temperatura', 839.0000, 'ºC'),
	(321954, 145, '2015-01-15 00:10:19.000000', 'temperatura', 909.0000, 'ºC'),
	(321955, 145, '2015-01-15 00:10:20.000000', 'temperatura', 829.0000, 'ºC'),
	(321956, 145, '2015-01-15 00:10:21.000000', 'temperatura', 220.0000, 'ºC'),
	(321957, 145, '2015-01-15 00:10:22.000000', 'temperatura', 1012.0000, 'ºC'),
	(321958, 145, '2015-01-15 00:10:23.000000', 'temperatura', 803.0000, 'ºC'),
	(321959, 145, '2015-01-15 00:10:24.000000', 'temperatura', 976.0000, 'ºC'),
	(321960, 145, '2015-01-15 00:10:25.000000', 'temperatura', 75.0000, 'ºC'),
	(321961, 145, '2015-01-15 00:10:26.000000', 'temperatura', 1045.0000, 'ºC'),
	(321962, 145, '2015-01-15 00:10:27.000000', 'temperatura', 199.0000, 'ºC'),
	(321963, 145, '2015-01-15 00:10:28.000000', 'temperatura', 263.0000, 'ºC'),
	(321964, 145, '2015-01-15 00:10:29.000000', 'temperatura', 718.0000, 'ºC'),
	(321965, 145, '2015-01-15 00:10:30.000000', 'temperatura', 401.0000, 'ºC'),
	(321966, 145, '2015-01-15 00:10:31.000000', 'temperatura', 1053.0000, 'ºC'),
	(321967, 145, '2015-01-15 00:10:32.000000', 'temperatura', 461.0000, 'ºC'),
	(321968, 145, '2015-01-15 00:10:33.000000', 'temperatura', 348.0000, 'ºC'),
	(321969, 145, '2015-01-15 00:10:34.000000', 'temperatura', 355.0000, 'ºC'),
	(321970, 145, '2015-01-15 00:10:35.000000', 'temperatura', 734.0000, 'ºC'),
	(321971, 145, '2015-01-15 00:10:36.000000', 'temperatura', 205.0000, 'ºC'),
	(321972, 145, '2015-01-15 00:10:37.000000', 'temperatura', 25.0000, 'ºC'),
	(321973, 145, '2015-01-15 00:10:38.000000', 'temperatura', 710.0000, 'ºC'),
	(321974, 145, '2015-01-15 00:10:39.000000', 'temperatura', 1075.0000, 'ºC'),
	(321975, 145, '2015-01-15 00:10:40.000000', 'temperatura', 845.0000, 'ºC'),
	(321976, 145, '2015-01-15 00:10:41.000000', 'temperatura', 999.0000, 'ºC'),
	(321977, 145, '2015-01-15 00:10:42.000000', 'temperatura', 61.0000, 'ºC'),
	(321978, 145, '2015-01-15 00:10:43.000000', 'temperatura', 910.0000, 'ºC'),
	(321979, 145, '2015-01-15 00:10:44.000000', 'temperatura', 766.0000, 'ºC'),
	(321980, 145, '2015-01-15 00:10:45.000000', 'temperatura', 1103.0000, 'ºC'),
	(321981, 145, '2015-01-15 00:10:46.000000', 'temperatura', 817.0000, 'ºC'),
	(321982, 145, '2015-01-15 00:10:47.000000', 'temperatura', 776.0000, 'ºC'),
	(321983, 145, '2015-01-15 00:10:48.000000', 'temperatura', 229.0000, 'ºC'),
	(321984, 145, '2015-01-15 00:10:49.000000', 'temperatura', 18.0000, 'ºC'),
	(321985, 145, '2015-01-15 00:10:50.000000', 'temperatura', 602.0000, 'ºC'),
	(321986, 145, '2015-01-15 00:10:51.000000', 'temperatura', 556.0000, 'ºC'),
	(321987, 145, '2015-01-15 00:10:52.000000', 'temperatura', 973.0000, 'ºC'),
	(321988, 145, '2015-01-15 00:10:53.000000', 'temperatura', 801.0000, 'ºC'),
	(321989, 145, '2015-01-15 00:10:54.000000', 'temperatura', 1087.0000, 'ºC'),
	(321990, 145, '2015-01-15 00:10:55.000000', 'temperatura', 631.0000, 'ºC'),
	(321991, 145, '2015-01-15 00:10:56.000000', 'temperatura', 1094.0000, 'ºC'),
	(321992, 145, '2015-01-15 00:10:57.000000', 'temperatura', 1176.0000, 'ºC'),
	(321993, 145, '2015-01-15 00:10:58.000000', 'temperatura', 200.0000, 'ºC'),
	(321994, 145, '2015-01-15 00:10:59.000000', 'temperatura', 1072.0000, 'ºC'),
	(321995, 145, '2015-01-15 00:11:00.000000', 'temperatura', 1159.0000, 'ºC'),
	(321996, 145, '2015-01-15 00:11:01.000000', 'temperatura', 180.0000, 'ºC'),
	(321997, 145, '2015-01-15 00:11:02.000000', 'temperatura', 1026.0000, 'ºC'),
	(321998, 145, '2015-01-15 00:11:03.000000', 'temperatura', 989.0000, 'ºC'),
	(321999, 145, '2015-01-15 00:11:04.000000', 'temperatura', 667.0000, 'ºC'),
	(322000, 145, '2015-01-15 00:11:05.000000', 'temperatura', 367.0000, 'ºC'),
	(322001, 145, '2015-01-15 00:11:06.000000', 'temperatura', 1035.0000, 'ºC'),
	(322002, 145, '2015-01-15 00:11:07.000000', 'temperatura', 474.0000, 'ºC'),
	(322003, 145, '2015-01-15 00:11:08.000000', 'temperatura', 467.0000, 'ºC'),
	(322004, 145, '2015-01-15 00:11:09.000000', 'temperatura', 913.0000, 'ºC'),
	(322005, 145, '2015-01-15 00:11:10.000000', 'temperatura', 764.0000, 'ºC'),
	(322006, 145, '2015-01-15 00:11:11.000000', 'temperatura', 1081.0000, 'ºC'),
	(322007, 145, '2015-01-15 00:11:12.000000', 'temperatura', 713.0000, 'ºC'),
	(322008, 145, '2015-01-15 00:11:13.000000', 'temperatura', 323.0000, 'ºC'),
	(322009, 145, '2015-01-15 00:11:14.000000', 'temperatura', 677.0000, 'ºC'),
	(322010, 145, '2015-01-15 00:11:15.000000', 'temperatura', 18.0000, 'ºC'),
	(322011, 145, '2015-01-15 00:11:16.000000', 'temperatura', 458.0000, 'ºC'),
	(322012, 145, '2015-01-15 00:11:17.000000', 'temperatura', 1036.0000, 'ºC'),
	(322013, 145, '2015-01-15 00:11:18.000000', 'temperatura', 207.0000, 'ºC'),
	(322014, 145, '2015-01-15 00:11:19.000000', 'temperatura', 326.0000, 'ºC'),
	(322015, 145, '2015-01-15 00:11:20.000000', 'temperatura', 1013.0000, 'ºC'),
	(322016, 145, '2015-01-15 00:11:21.000000', 'temperatura', 484.0000, 'ºC'),
	(322017, 145, '2015-01-15 00:11:22.000000', 'temperatura', 583.0000, 'ºC'),
	(322018, 145, '2015-01-15 00:11:23.000000', 'temperatura', 264.0000, 'ºC'),
	(322019, 145, '2015-01-15 00:11:24.000000', 'temperatura', 771.0000, 'ºC'),
	(322020, 145, '2015-01-15 00:11:25.000000', 'temperatura', 663.0000, 'ºC'),
	(322021, 145, '2015-01-15 00:11:26.000000', 'temperatura', 1001.0000, 'ºC'),
	(322022, 145, '2015-01-15 00:11:27.000000', 'temperatura', 618.0000, 'ºC'),
	(322023, 145, '2015-01-15 00:11:28.000000', 'temperatura', 87.0000, 'ºC'),
	(322024, 145, '2015-01-15 00:11:29.000000', 'temperatura', 981.0000, 'ºC'),
	(322025, 145, '2015-01-15 00:11:30.000000', 'temperatura', 1046.0000, 'ºC'),
	(322026, 145, '2015-01-15 00:11:31.000000', 'temperatura', 1089.0000, 'ºC'),
	(322027, 145, '2015-01-15 00:11:32.000000', 'temperatura', 1105.0000, 'ºC'),
	(322028, 145, '2015-01-15 00:11:33.000000', 'temperatura', 1060.0000, 'ºC'),
	(322029, 145, '2015-01-15 00:11:34.000000', 'temperatura', 786.0000, 'ºC'),
	(322030, 145, '2015-01-15 00:11:35.000000', 'temperatura', 749.0000, 'ºC'),
	(322031, 145, '2015-01-15 00:11:36.000000', 'temperatura', 188.0000, 'ºC'),
	(322032, 145, '2015-01-15 00:11:37.000000', 'temperatura', 1094.0000, 'ºC'),
	(322033, 145, '2015-01-15 00:11:38.000000', 'temperatura', 105.0000, 'ºC'),
	(322034, 145, '2015-01-15 00:11:39.000000', 'temperatura', 844.0000, 'ºC'),
	(322035, 145, '2015-01-15 00:11:40.000000', 'temperatura', 306.0000, 'ºC'),
	(322036, 145, '2015-01-15 00:11:41.000000', 'temperatura', 197.0000, 'ºC'),
	(322037, 145, '2015-01-15 00:11:42.000000', 'temperatura', 68.0000, 'ºC'),
	(322038, 145, '2015-01-15 00:11:43.000000', 'temperatura', 950.0000, 'ºC'),
	(322039, 145, '2015-01-15 00:11:44.000000', 'temperatura', 948.0000, 'ºC'),
	(322040, 145, '2015-01-15 00:11:45.000000', 'temperatura', 688.0000, 'ºC'),
	(322041, 145, '2015-01-15 00:11:46.000000', 'temperatura', 596.0000, 'ºC'),
	(322042, 145, '2015-01-15 00:11:47.000000', 'temperatura', 918.0000, 'ºC'),
	(322043, 145, '2015-01-15 00:11:48.000000', 'temperatura', 403.0000, 'ºC'),
	(322044, 145, '2015-01-15 00:11:49.000000', 'temperatura', 461.0000, 'ºC'),
	(322045, 145, '2015-01-15 00:11:50.000000', 'temperatura', 1097.0000, 'ºC'),
	(322046, 145, '2015-01-15 00:11:51.000000', 'temperatura', 501.0000, 'ºC'),
	(322047, 145, '2015-01-15 00:11:52.000000', 'temperatura', 415.0000, 'ºC'),
	(322048, 145, '2015-01-15 00:11:53.000000', 'temperatura', 571.0000, 'ºC'),
	(322049, 145, '2015-01-15 00:11:54.000000', 'temperatura', 412.0000, 'ºC'),
	(322050, 145, '2015-01-15 00:11:55.000000', 'temperatura', 349.0000, 'ºC'),
	(322051, 145, '2015-01-15 00:11:56.000000', 'temperatura', 506.0000, 'ºC'),
	(322052, 145, '2015-01-15 00:11:57.000000', 'temperatura', 286.0000, 'ºC'),
	(322053, 145, '2015-01-15 00:11:58.000000', 'temperatura', 1112.0000, 'ºC'),
	(322054, 145, '2015-01-15 00:11:59.000000', 'temperatura', 1101.0000, 'ºC'),
	(322055, 145, '2015-01-15 00:12:00.000000', 'temperatura', 971.0000, 'ºC'),
	(322056, 145, '2015-01-15 00:12:01.000000', 'temperatura', 353.0000, 'ºC'),
	(322057, 145, '2015-01-15 00:12:02.000000', 'temperatura', 51.0000, 'ºC'),
	(322058, 145, '2015-01-15 00:12:03.000000', 'temperatura', 395.0000, 'ºC'),
	(322059, 145, '2015-01-15 00:12:04.000000', 'temperatura', 624.0000, 'ºC'),
	(322060, 145, '2015-01-15 00:12:05.000000', 'temperatura', 737.0000, 'ºC'),
	(322061, 145, '2015-01-15 00:12:06.000000', 'temperatura', 610.0000, 'ºC'),
	(322062, 145, '2015-01-15 00:12:07.000000', 'temperatura', 843.0000, 'ºC'),
	(322063, 145, '2015-01-15 00:12:08.000000', 'temperatura', 1184.0000, 'ºC'),
	(322064, 145, '2015-01-15 00:12:09.000000', 'temperatura', 993.0000, 'ºC'),
	(322065, 145, '2015-01-15 00:12:10.000000', 'temperatura', 214.0000, 'ºC'),
	(322066, 145, '2015-01-15 00:12:11.000000', 'temperatura', 491.0000, 'ºC'),
	(322067, 145, '2015-01-15 00:12:12.000000', 'temperatura', 612.0000, 'ºC'),
	(322068, 145, '2015-01-15 00:12:13.000000', 'temperatura', 389.0000, 'ºC'),
	(322069, 145, '2015-01-15 00:12:14.000000', 'temperatura', 111.0000, 'ºC'),
	(322070, 145, '2015-01-15 00:12:15.000000', 'temperatura', 586.0000, 'ºC'),
	(322071, 145, '2015-01-15 00:12:16.000000', 'temperatura', 199.0000, 'ºC'),
	(322072, 145, '2015-01-15 00:12:17.000000', 'temperatura', 436.0000, 'ºC'),
	(322073, 145, '2015-01-15 00:12:18.000000', 'temperatura', 384.0000, 'ºC'),
	(322074, 145, '2015-01-15 00:12:19.000000', 'temperatura', 613.0000, 'ºC'),
	(322075, 145, '2015-01-15 00:12:20.000000', 'temperatura', 713.0000, 'ºC'),
	(322076, 145, '2015-01-15 00:12:21.000000', 'temperatura', 525.0000, 'ºC'),
	(322077, 145, '2015-01-15 00:12:22.000000', 'temperatura', 489.0000, 'ºC'),
	(322078, 145, '2015-01-15 00:12:23.000000', 'temperatura', 871.0000, 'ºC'),
	(322079, 145, '2015-01-15 00:12:24.000000', 'temperatura', 486.0000, 'ºC'),
	(322080, 145, '2015-01-15 00:12:25.000000', 'temperatura', 1019.0000, 'ºC'),
	(322081, 145, '2015-01-15 00:12:26.000000', 'temperatura', 35.0000, 'ºC'),
	(322082, 145, '2015-01-15 00:12:27.000000', 'temperatura', 721.0000, 'ºC'),
	(322083, 145, '2015-01-15 00:12:28.000000', 'temperatura', 1101.0000, 'ºC'),
	(322084, 145, '2015-01-15 00:12:29.000000', 'temperatura', 942.0000, 'ºC'),
	(322085, 145, '2015-01-15 00:12:30.000000', 'temperatura', 205.0000, 'ºC'),
	(322086, 145, '2015-01-15 00:12:31.000000', 'temperatura', 602.0000, 'ºC'),
	(322087, 145, '2015-01-15 00:12:32.000000', 'temperatura', 1196.0000, 'ºC'),
	(322088, 145, '2015-01-15 00:12:33.000000', 'temperatura', 573.0000, 'ºC'),
	(322089, 145, '2015-01-15 00:12:34.000000', 'temperatura', 478.0000, 'ºC'),
	(322090, 145, '2015-01-15 00:12:35.000000', 'temperatura', 670.0000, 'ºC'),
	(322091, 145, '2015-01-15 00:12:36.000000', 'temperatura', 718.0000, 'ºC'),
	(322092, 145, '2015-01-15 00:12:37.000000', 'temperatura', 382.0000, 'ºC'),
	(322093, 145, '2015-01-15 00:12:38.000000', 'temperatura', 955.0000, 'ºC'),
	(322094, 145, '2015-01-15 00:12:39.000000', 'temperatura', 30.0000, 'ºC'),
	(322095, 145, '2015-01-15 00:12:40.000000', 'temperatura', 884.0000, 'ºC'),
	(322096, 145, '2015-01-15 00:12:41.000000', 'temperatura', 731.0000, 'ºC'),
	(322097, 145, '2015-01-15 00:12:42.000000', 'temperatura', 1004.0000, 'ºC'),
	(322098, 145, '2015-01-15 00:12:43.000000', 'temperatura', 429.0000, 'ºC'),
	(322099, 145, '2015-01-15 00:12:44.000000', 'temperatura', 334.0000, 'ºC'),
	(322100, 145, '2015-01-15 00:12:45.000000', 'temperatura', 381.0000, 'ºC'),
	(322101, 145, '2015-01-15 00:12:46.000000', 'temperatura', 906.0000, 'ºC'),
	(322102, 145, '2015-01-15 00:12:47.000000', 'temperatura', 988.0000, 'ºC'),
	(322103, 145, '2015-01-15 00:12:48.000000', 'temperatura', 1022.0000, 'ºC'),
	(322104, 145, '2015-01-15 00:12:49.000000', 'temperatura', 947.0000, 'ºC'),
	(322105, 145, '2015-01-15 00:12:50.000000', 'temperatura', 470.0000, 'ºC'),
	(322106, 145, '2015-01-15 00:12:51.000000', 'temperatura', 710.0000, 'ºC'),
	(322107, 145, '2015-01-15 00:12:52.000000', 'temperatura', 941.0000, 'ºC'),
	(322108, 145, '2015-01-15 00:12:53.000000', 'temperatura', 175.0000, 'ºC'),
	(322109, 145, '2015-01-15 00:12:54.000000', 'temperatura', 454.0000, 'ºC'),
	(322110, 145, '2015-01-15 00:12:55.000000', 'temperatura', 543.0000, 'ºC'),
	(322111, 145, '2015-01-15 00:12:56.000000', 'temperatura', 154.0000, 'ºC'),
	(322112, 145, '2015-01-15 00:12:57.000000', 'temperatura', 343.0000, 'ºC'),
	(322113, 145, '2015-01-15 00:12:58.000000', 'temperatura', 54.0000, 'ºC'),
	(322114, 145, '2015-01-15 00:12:59.000000', 'temperatura', 441.0000, 'ºC'),
	(322115, 145, '2015-01-15 00:13:00.000000', 'temperatura', 845.0000, 'ºC'),
	(322116, 145, '2015-01-15 00:13:01.000000', 'temperatura', 499.0000, 'ºC'),
	(322117, 145, '2015-01-15 00:13:02.000000', 'temperatura', 1163.0000, 'ºC'),
	(322118, 145, '2015-01-15 00:13:03.000000', 'temperatura', 716.0000, 'ºC'),
	(322119, 145, '2015-01-15 00:13:04.000000', 'temperatura', 92.0000, 'ºC'),
	(322120, 145, '2015-01-15 00:13:05.000000', 'temperatura', 714.0000, 'ºC'),
	(322121, 145, '2015-01-15 00:13:06.000000', 'temperatura', 895.0000, 'ºC'),
	(322122, 145, '2015-01-15 00:13:07.000000', 'temperatura', 1132.0000, 'ºC'),
	(322123, 145, '2015-01-15 00:13:08.000000', 'temperatura', 574.0000, 'ºC'),
	(322124, 145, '2015-01-15 00:13:09.000000', 'temperatura', 677.0000, 'ºC'),
	(322125, 145, '2015-01-15 00:13:10.000000', 'temperatura', 464.0000, 'ºC'),
	(322126, 145, '2015-01-15 00:13:11.000000', 'temperatura', 288.0000, 'ºC'),
	(322127, 145, '2015-01-15 00:13:12.000000', 'temperatura', 49.0000, 'ºC'),
	(322128, 145, '2015-01-15 00:13:13.000000', 'temperatura', 582.0000, 'ºC'),
	(322129, 145, '2015-01-15 00:13:14.000000', 'temperatura', 361.0000, 'ºC'),
	(322130, 145, '2015-01-15 00:13:15.000000', 'temperatura', 61.0000, 'ºC'),
	(322131, 145, '2015-01-15 00:13:16.000000', 'temperatura', 424.0000, 'ºC'),
	(322132, 145, '2015-01-15 00:13:17.000000', 'temperatura', 735.0000, 'ºC'),
	(322133, 145, '2015-01-15 00:13:18.000000', 'temperatura', 6.0000, 'ºC'),
	(322134, 145, '2015-01-15 00:13:19.000000', 'temperatura', 226.0000, 'ºC'),
	(322135, 145, '2015-01-15 00:13:20.000000', 'temperatura', 1110.0000, 'ºC'),
	(322136, 145, '2015-01-15 00:13:21.000000', 'temperatura', 76.0000, 'ºC'),
	(322137, 145, '2015-01-15 00:13:22.000000', 'temperatura', 647.0000, 'ºC'),
	(322138, 145, '2015-01-15 00:13:23.000000', 'temperatura', 609.0000, 'ºC'),
	(322139, 145, '2015-01-15 00:13:24.000000', 'temperatura', 1105.0000, 'ºC'),
	(322140, 145, '2015-01-15 00:13:25.000000', 'temperatura', 97.0000, 'ºC'),
	(322141, 145, '2015-01-15 00:13:26.000000', 'temperatura', 769.0000, 'ºC'),
	(322142, 145, '2015-01-15 00:13:27.000000', 'temperatura', 1158.0000, 'ºC'),
	(322143, 145, '2015-01-15 00:13:28.000000', 'temperatura', 1081.0000, 'ºC'),
	(322144, 145, '2015-01-15 00:13:29.000000', 'temperatura', 731.0000, 'ºC'),
	(322145, 145, '2015-01-15 00:13:30.000000', 'temperatura', 415.0000, 'ºC'),
	(322146, 145, '2015-01-15 00:13:31.000000', 'temperatura', 1083.0000, 'ºC'),
	(322147, 145, '2015-01-15 00:13:32.000000', 'temperatura', 568.0000, 'ºC'),
	(322148, 145, '2015-01-15 00:13:33.000000', 'temperatura', 791.0000, 'ºC'),
	(322149, 145, '2015-01-15 00:13:34.000000', 'temperatura', 1054.0000, 'ºC'),
	(322150, 145, '2015-01-15 00:13:35.000000', 'temperatura', 497.0000, 'ºC'),
	(322151, 145, '2015-01-15 00:13:36.000000', 'temperatura', 522.0000, 'ºC'),
	(322152, 145, '2015-01-15 00:13:37.000000', 'temperatura', 1120.0000, 'ºC'),
	(322153, 145, '2015-01-15 00:13:38.000000', 'temperatura', 435.0000, 'ºC'),
	(322154, 145, '2015-01-15 00:13:39.000000', 'temperatura', 13.0000, 'ºC'),
	(322155, 145, '2015-01-15 00:13:40.000000', 'temperatura', 1163.0000, 'ºC'),
	(322156, 145, '2015-01-15 00:13:41.000000', 'temperatura', 977.0000, 'ºC'),
	(322157, 145, '2015-01-15 00:13:42.000000', 'temperatura', 194.0000, 'ºC'),
	(322158, 145, '2015-01-15 00:13:43.000000', 'temperatura', 442.0000, 'ºC'),
	(322159, 145, '2015-01-15 00:13:44.000000', 'temperatura', 428.0000, 'ºC'),
	(322160, 145, '2015-01-15 00:13:45.000000', 'temperatura', 813.0000, 'ºC'),
	(322161, 145, '2015-01-15 00:13:46.000000', 'temperatura', 384.0000, 'ºC'),
	(322162, 145, '2015-01-15 00:13:47.000000', 'temperatura', 681.0000, 'ºC'),
	(322163, 145, '2015-01-15 00:13:48.000000', 'temperatura', 1052.0000, 'ºC'),
	(322164, 145, '2015-01-15 00:13:49.000000', 'temperatura', 820.0000, 'ºC'),
	(322165, 145, '2015-01-15 00:13:50.000000', 'temperatura', 942.0000, 'ºC'),
	(322166, 145, '2015-01-15 00:13:51.000000', 'temperatura', 1051.0000, 'ºC'),
	(322167, 145, '2015-01-15 00:13:52.000000', 'temperatura', 29.0000, 'ºC'),
	(322168, 145, '2015-01-15 00:13:53.000000', 'temperatura', 591.0000, 'ºC'),
	(322169, 145, '2015-01-15 00:13:54.000000', 'temperatura', 471.0000, 'ºC'),
	(322170, 145, '2015-01-15 00:13:55.000000', 'temperatura', 584.0000, 'ºC'),
	(322171, 145, '2015-01-15 00:13:56.000000', 'temperatura', 305.0000, 'ºC'),
	(322172, 145, '2015-01-15 00:13:57.000000', 'temperatura', 973.0000, 'ºC'),
	(322173, 145, '2015-01-15 00:13:58.000000', 'temperatura', 353.0000, 'ºC'),
	(322174, 145, '2015-01-15 00:13:59.000000', 'temperatura', 45.0000, 'ºC'),
	(322175, 145, '2015-01-15 00:14:00.000000', 'temperatura', 366.0000, 'ºC'),
	(322176, 145, '2015-01-15 00:14:01.000000', 'temperatura', 498.0000, 'ºC'),
	(322177, 145, '2015-01-15 00:14:02.000000', 'temperatura', 190.0000, 'ºC'),
	(322178, 145, '2015-01-15 00:14:03.000000', 'temperatura', 656.0000, 'ºC'),
	(322179, 145, '2015-01-15 00:14:04.000000', 'temperatura', 313.0000, 'ºC'),
	(322180, 145, '2015-01-15 00:14:05.000000', 'temperatura', 796.0000, 'ºC'),
	(322181, 145, '2015-01-15 00:14:06.000000', 'temperatura', 640.0000, 'ºC'),
	(322182, 145, '2015-01-15 00:14:07.000000', 'temperatura', 815.0000, 'ºC'),
	(322183, 145, '2015-01-15 00:14:08.000000', 'temperatura', 954.0000, 'ºC'),
	(322184, 145, '2015-01-15 00:14:09.000000', 'temperatura', 1127.0000, 'ºC'),
	(322185, 145, '2015-01-15 00:14:10.000000', 'temperatura', 372.0000, 'ºC'),
	(322186, 145, '2015-01-15 00:14:11.000000', 'temperatura', 882.0000, 'ºC'),
	(322187, 145, '2015-01-15 00:14:12.000000', 'temperatura', 893.0000, 'ºC'),
	(322188, 145, '2015-01-15 00:14:13.000000', 'temperatura', 622.0000, 'ºC'),
	(322189, 145, '2015-01-15 00:14:14.000000', 'temperatura', 428.0000, 'ºC'),
	(322190, 145, '2015-01-15 00:14:15.000000', 'temperatura', 278.0000, 'ºC'),
	(322191, 145, '2015-01-15 00:14:16.000000', 'temperatura', 104.0000, 'ºC'),
	(322192, 145, '2015-01-15 00:14:17.000000', 'temperatura', 888.0000, 'ºC'),
	(322193, 145, '2015-01-15 00:14:18.000000', 'temperatura', 530.0000, 'ºC'),
	(322194, 145, '2015-01-15 00:14:19.000000', 'temperatura', 1185.0000, 'ºC'),
	(322195, 145, '2015-01-15 00:14:20.000000', 'temperatura', 734.0000, 'ºC'),
	(322196, 145, '2015-01-15 00:14:21.000000', 'temperatura', 116.0000, 'ºC'),
	(322197, 145, '2015-01-15 00:14:22.000000', 'temperatura', 779.0000, 'ºC'),
	(322198, 145, '2015-01-15 00:14:23.000000', 'temperatura', 1149.0000, 'ºC'),
	(322199, 145, '2015-01-15 00:14:24.000000', 'temperatura', 1009.0000, 'ºC'),
	(322200, 145, '2015-01-15 00:14:25.000000', 'temperatura', 398.0000, 'ºC'),
	(322201, 145, '2015-01-15 00:14:26.000000', 'temperatura', 165.0000, 'ºC'),
	(322202, 145, '2015-01-15 00:14:27.000000', 'temperatura', 830.0000, 'ºC'),
	(322203, 145, '2015-01-15 00:14:28.000000', 'temperatura', 55.0000, 'ºC'),
	(322204, 145, '2015-01-15 00:14:29.000000', 'temperatura', 185.0000, 'ºC'),
	(322205, 145, '2015-01-15 00:14:30.000000', 'temperatura', 763.0000, 'ºC'),
	(322206, 145, '2015-01-15 00:14:31.000000', 'temperatura', 858.0000, 'ºC'),
	(322207, 145, '2015-01-15 00:14:32.000000', 'temperatura', 804.0000, 'ºC'),
	(322208, 145, '2015-01-15 00:14:33.000000', 'temperatura', 246.0000, 'ºC'),
	(322209, 145, '2015-01-15 00:14:34.000000', 'temperatura', 18.0000, 'ºC'),
	(322210, 145, '2015-01-15 00:14:35.000000', 'temperatura', 552.0000, 'ºC'),
	(322211, 145, '2015-01-15 00:14:36.000000', 'temperatura', 307.0000, 'ºC'),
	(322212, 145, '2015-01-15 00:14:37.000000', 'temperatura', 1078.0000, 'ºC'),
	(322213, 145, '2015-01-15 00:14:38.000000', 'temperatura', 872.0000, 'ºC'),
	(322214, 145, '2015-01-15 00:14:39.000000', 'temperatura', 1124.0000, 'ºC'),
	(322215, 145, '2015-01-15 00:14:40.000000', 'temperatura', 606.0000, 'ºC'),
	(322216, 145, '2015-01-15 00:14:41.000000', 'temperatura', 857.0000, 'ºC'),
	(322217, 145, '2015-01-15 00:14:42.000000', 'temperatura', 69.0000, 'ºC'),
	(322218, 145, '2015-01-15 00:14:43.000000', 'temperatura', 175.0000, 'ºC'),
	(322219, 145, '2015-01-15 00:14:44.000000', 'temperatura', 668.0000, 'ºC'),
	(322220, 145, '2015-01-15 00:14:45.000000', 'temperatura', 414.0000, 'ºC'),
	(322221, 145, '2015-01-15 00:14:46.000000', 'temperatura', 68.0000, 'ºC'),
	(322222, 145, '2015-01-15 00:14:47.000000', 'temperatura', 297.0000, 'ºC'),
	(322223, 145, '2015-01-15 00:14:48.000000', 'temperatura', 83.0000, 'ºC'),
	(322224, 145, '2015-01-15 00:14:49.000000', 'temperatura', 724.0000, 'ºC'),
	(322225, 145, '2015-01-15 00:14:50.000000', 'temperatura', 972.0000, 'ºC'),
	(322226, 145, '2015-01-15 00:14:51.000000', 'temperatura', 286.0000, 'ºC'),
	(322227, 145, '2015-01-15 00:14:52.000000', 'temperatura', 917.0000, 'ºC'),
	(322228, 145, '2015-01-15 00:14:53.000000', 'temperatura', 126.0000, 'ºC'),
	(322229, 145, '2015-01-15 00:14:54.000000', 'temperatura', 282.0000, 'ºC'),
	(322230, 145, '2015-01-15 00:14:55.000000', 'temperatura', 1029.0000, 'ºC'),
	(322231, 145, '2015-01-15 00:14:56.000000', 'temperatura', 703.0000, 'ºC'),
	(322232, 145, '2015-01-15 00:14:57.000000', 'temperatura', 426.0000, 'ºC'),
	(322233, 145, '2015-01-15 00:14:58.000000', 'temperatura', 20.0000, 'ºC'),
	(322234, 145, '2015-01-15 00:14:59.000000', 'temperatura', 26.0000, 'ºC'),
	(322235, 145, '2015-01-15 00:15:00.000000', 'temperatura', 70.0000, 'ºC'),
	(322236, 145, '2015-01-15 00:15:01.000000', 'temperatura', 272.0000, 'ºC'),
	(322237, 145, '2015-01-15 00:15:02.000000', 'temperatura', 1149.0000, 'ºC'),
	(322238, 145, '2015-01-15 00:15:03.000000', 'temperatura', 132.0000, 'ºC'),
	(322239, 145, '2015-01-15 00:15:04.000000', 'temperatura', 812.0000, 'ºC'),
	(322240, 145, '2015-01-15 00:15:05.000000', 'temperatura', 67.0000, 'ºC'),
	(322241, 145, '2015-01-15 00:15:06.000000', 'temperatura', 296.0000, 'ºC'),
	(322242, 145, '2015-01-15 00:15:07.000000', 'temperatura', 80.0000, 'ºC'),
	(322243, 145, '2015-01-15 00:15:08.000000', 'temperatura', 714.0000, 'ºC'),
	(322244, 145, '2015-01-15 00:15:09.000000', 'temperatura', 930.0000, 'ºC'),
	(322245, 145, '2015-01-15 00:15:10.000000', 'temperatura', 107.0000, 'ºC'),
	(322246, 145, '2015-01-15 00:15:11.000000', 'temperatura', 145.0000, 'ºC'),
	(322247, 145, '2015-01-15 00:15:12.000000', 'temperatura', 405.0000, 'ºC'),
	(322248, 145, '2015-01-15 00:15:13.000000', 'temperatura', 391.0000, 'ºC'),
	(322249, 145, '2015-01-15 00:15:14.000000', 'temperatura', 740.0000, 'ºC'),
	(322250, 145, '2015-01-15 00:15:15.000000', 'temperatura', 127.0000, 'ºC'),
	(322251, 145, '2015-01-15 00:15:16.000000', 'temperatura', 817.0000, 'ºC'),
	(322252, 145, '2015-01-15 00:15:17.000000', 'temperatura', 104.0000, 'ºC'),
	(322253, 145, '2015-01-15 00:15:18.000000', 'temperatura', 470.0000, 'ºC'),
	(322254, 145, '2015-01-15 00:15:19.000000', 'temperatura', 840.0000, 'ºC'),
	(322255, 145, '2015-01-15 00:15:20.000000', 'temperatura', 387.0000, 'ºC'),
	(322256, 145, '2015-01-15 00:15:21.000000', 'temperatura', 619.0000, 'ºC'),
	(322257, 145, '2015-01-15 00:15:22.000000', 'temperatura', 733.0000, 'ºC'),
	(322258, 145, '2015-01-15 00:15:23.000000', 'temperatura', 608.0000, 'ºC'),
	(322259, 145, '2015-01-15 00:15:24.000000', 'temperatura', 844.0000, 'ºC'),
	(322260, 145, '2015-01-15 00:15:25.000000', 'temperatura', 1193.0000, 'ºC'),
	(322261, 145, '2015-01-15 00:15:26.000000', 'temperatura', 1036.0000, 'ºC'),
	(322262, 145, '2015-01-15 00:15:27.000000', 'temperatura', 400.0000, 'ºC'),
	(322263, 145, '2015-01-15 00:15:28.000000', 'temperatura', 95.0000, 'ºC'),
	(322264, 145, '2015-01-15 00:15:29.000000', 'temperatura', 473.0000, 'ºC'),
	(322265, 145, '2015-01-15 00:15:30.000000', 'temperatura', 883.0000, 'ºC'),
	(322266, 145, '2015-01-15 00:15:31.000000', 'temperatura', 597.0000, 'ºC'),
	(322267, 145, '2015-01-15 00:15:32.000000', 'temperatura', 335.0000, 'ºC'),
	(322268, 145, '2015-01-15 00:15:33.000000', 'temperatura', 1083.0000, 'ºC'),
	(322269, 145, '2015-01-15 00:15:34.000000', 'temperatura', 814.0000, 'ºC'),
	(322270, 145, '2015-01-15 00:15:35.000000', 'temperatura', 819.0000, 'ºC'),
	(322271, 145, '2015-01-15 00:15:36.000000', 'temperatura', 453.0000, 'ºC'),
	(322272, 145, '2015-01-15 00:15:37.000000', 'temperatura', 1009.0000, 'ºC'),
	(322273, 145, '2015-01-15 00:15:38.000000', 'temperatura', 86.0000, 'ºC'),
	(322274, 145, '2015-01-15 00:15:39.000000', 'temperatura', 1002.0000, 'ºC'),
	(322275, 145, '2015-01-15 00:15:40.000000', 'temperatura', 1156.0000, 'ºC'),
	(322276, 145, '2015-01-15 00:15:41.000000', 'temperatura', 372.0000, 'ºC'),
	(322277, 145, '2015-01-15 00:15:42.000000', 'temperatura', 792.0000, 'ºC'),
	(322278, 145, '2015-01-15 00:15:43.000000', 'temperatura', 446.0000, 'ºC'),
	(322279, 145, '2015-01-15 00:15:44.000000', 'temperatura', 1053.0000, 'ºC'),
	(322280, 145, '2015-01-15 00:15:45.000000', 'temperatura', 326.0000, 'ºC'),
	(322281, 145, '2015-01-15 00:15:46.000000', 'temperatura', 874.0000, 'ºC'),
	(322282, 145, '2015-01-15 00:15:47.000000', 'temperatura', 991.0000, 'ºC'),
	(322283, 145, '2015-01-15 00:15:48.000000', 'temperatura', 1134.0000, 'ºC'),
	(322284, 145, '2015-01-15 00:15:49.000000', 'temperatura', 297.0000, 'ºC'),
	(322285, 145, '2015-01-15 00:15:50.000000', 'temperatura', 482.0000, 'ºC'),
	(322286, 145, '2015-01-15 00:15:51.000000', 'temperatura', 320.0000, 'ºC'),
	(322287, 145, '2015-01-15 00:15:52.000000', 'temperatura', 156.0000, 'ºC'),
	(322288, 145, '2015-01-15 00:15:53.000000', 'temperatura', 1021.0000, 'ºC'),
	(322289, 145, '2015-01-15 00:15:54.000000', 'temperatura', 1036.0000, 'ºC'),
	(322290, 145, '2015-01-15 00:15:55.000000', 'temperatura', 916.0000, 'ºC'),
	(322291, 145, '2015-01-15 00:15:56.000000', 'temperatura', 274.0000, 'ºC'),
	(322292, 145, '2015-01-15 00:15:57.000000', 'temperatura', 1021.0000, 'ºC'),
	(322293, 145, '2015-01-15 00:15:58.000000', 'temperatura', 685.0000, 'ºC'),
	(322294, 145, '2015-01-15 00:15:59.000000', 'temperatura', 363.0000, 'ºC'),
	(322295, 145, '2015-01-15 00:16:00.000000', 'temperatura', 961.0000, 'ºC'),
	(322296, 145, '2015-01-15 00:16:01.000000', 'temperatura', 116.0000, 'ºC'),
	(322297, 145, '2015-01-15 00:16:02.000000', 'temperatura', 97.0000, 'ºC'),
	(322298, 145, '2015-01-15 00:16:03.000000', 'temperatura', 140.0000, 'ºC'),
	(322299, 145, '2015-01-15 00:16:04.000000', 'temperatura', 407.0000, 'ºC'),
	(322300, 145, '2015-01-15 00:16:05.000000', 'temperatura', 415.0000, 'ºC'),
	(322301, 145, '2015-01-15 00:16:06.000000', 'temperatura', 857.0000, 'ºC'),
	(322302, 145, '2015-01-15 00:16:07.000000', 'temperatura', 641.0000, 'ºC'),
	(322303, 145, '2015-01-15 00:16:08.000000', 'temperatura', 634.0000, 'ºC'),
	(322304, 145, '2015-01-15 00:16:09.000000', 'temperatura', 47.0000, 'ºC'),
	(322305, 145, '2015-01-15 00:16:10.000000', 'temperatura', 734.0000, 'ºC'),
	(322306, 145, '2015-01-15 00:16:11.000000', 'temperatura', 1129.0000, 'ºC'),
	(322307, 145, '2015-01-15 00:16:12.000000', 'temperatura', 1042.0000, 'ºC'),
	(322308, 145, '2015-01-15 00:16:13.000000', 'temperatura', 623.0000, 'ºC'),
	(322309, 145, '2015-01-15 00:16:14.000000', 'temperatura', 1192.0000, 'ºC'),
	(322310, 145, '2015-01-15 00:16:15.000000', 'temperatura', 489.0000, 'ºC'),
	(322311, 145, '2015-01-15 00:16:16.000000', 'temperatura', 72.0000, 'ºC'),
	(322312, 145, '2015-01-15 00:16:17.000000', 'temperatura', 92.0000, 'ºC'),
	(322313, 145, '2015-01-15 00:16:18.000000', 'temperatura', 247.0000, 'ºC'),
	(322314, 145, '2015-01-15 00:16:19.000000', 'temperatura', 958.0000, 'ºC'),
	(322315, 145, '2015-01-15 00:16:20.000000', 'temperatura', 448.0000, 'ºC'),
	(322316, 145, '2015-01-15 00:16:21.000000', 'temperatura', 569.0000, 'ºC'),
	(322317, 145, '2015-01-15 00:16:22.000000', 'temperatura', 300.0000, 'ºC'),
	(322318, 145, '2015-01-15 00:16:23.000000', 'temperatura', 995.0000, 'ºC'),
	(322319, 145, '2015-01-15 00:16:24.000000', 'temperatura', 477.0000, 'ºC'),
	(322320, 145, '2015-01-15 00:16:25.000000', 'temperatura', 598.0000, 'ºC'),
	(322321, 145, '2015-01-15 00:16:26.000000', 'temperatura', 361.0000, 'ºC'),
	(322322, 145, '2015-01-15 00:16:27.000000', 'temperatura', 10.0000, 'ºC'),
	(322323, 145, '2015-01-15 00:16:28.000000', 'temperatura', 166.0000, 'ºC'),
	(322324, 145, '2015-01-15 00:16:29.000000', 'temperatura', 803.0000, 'ºC'),
	(322325, 145, '2015-01-15 00:16:30.000000', 'temperatura', 1119.0000, 'ºC'),
	(322326, 145, '2015-01-15 00:16:31.000000', 'temperatura', 784.0000, 'ºC'),
	(322327, 145, '2015-01-15 00:16:32.000000', 'temperatura', 562.0000, 'ºC'),
	(322328, 145, '2015-01-15 00:16:33.000000', 'temperatura', 462.0000, 'ºC'),
	(322329, 145, '2015-01-15 00:16:34.000000', 'temperatura', 622.0000, 'ºC'),
	(322330, 145, '2015-01-15 00:16:35.000000', 'temperatura', 527.0000, 'ºC'),
	(322331, 145, '2015-01-15 00:16:36.000000', 'temperatura', 769.0000, 'ºC'),
	(322332, 145, '2015-01-15 00:16:37.000000', 'temperatura', 1063.0000, 'ºC'),
	(322333, 145, '2015-01-15 00:16:38.000000', 'temperatura', 609.0000, 'ºC'),
	(322334, 145, '2015-01-15 00:16:39.000000', 'temperatura', 1056.0000, 'ºC'),
	(322335, 145, '2015-01-15 00:16:40.000000', 'temperatura', 1054.0000, 'ºC'),
	(322336, 145, '2015-01-15 00:16:41.000000', 'temperatura', 904.0000, 'ºC'),
	(322337, 145, '2015-01-15 00:16:42.000000', 'temperatura', 156.0000, 'ºC'),
	(322338, 145, '2015-01-15 00:16:43.000000', 'temperatura', 469.0000, 'ºC'),
	(322339, 145, '2015-01-15 00:16:44.000000', 'temperatura', 677.0000, 'ºC'),
	(322340, 145, '2015-01-15 00:16:45.000000', 'temperatura', 779.0000, 'ºC'),
	(322341, 145, '2015-01-15 00:16:46.000000', 'temperatura', 667.0000, 'ºC'),
	(322342, 145, '2015-01-15 00:16:47.000000', 'temperatura', 996.0000, 'ºC'),
	(322343, 145, '2015-01-15 00:16:48.000000', 'temperatura', 578.0000, 'ºC'),
	(322344, 145, '2015-01-15 00:16:49.000000', 'temperatura', 1104.0000, 'ºC'),
	(322345, 145, '2015-01-15 00:16:50.000000', 'temperatura', 185.0000, 'ºC'),
	(322346, 145, '2015-01-15 00:16:51.000000', 'temperatura', 13.0000, 'ºC'),
	(322347, 145, '2015-01-15 00:16:52.000000', 'temperatura', 712.0000, 'ºC'),
	(322348, 145, '2015-01-15 00:16:53.000000', 'temperatura', 1119.0000, 'ºC'),
	(322349, 145, '2015-01-15 00:16:54.000000', 'temperatura', 1062.0000, 'ºC'),
	(322350, 145, '2015-01-15 00:16:55.000000', 'temperatura', 751.0000, 'ºC'),
	(322351, 145, '2015-01-15 00:16:56.000000', 'temperatura', 571.0000, 'ºC'),
	(322352, 145, '2015-01-15 00:16:57.000000', 'temperatura', 603.0000, 'ºC'),
	(322353, 145, '2015-01-15 00:16:58.000000', 'temperatura', 102.0000, 'ºC'),
	(322354, 145, '2015-01-15 00:16:59.000000', 'temperatura', 1100.0000, 'ºC'),
	(322355, 145, '2015-01-15 00:17:00.000000', 'temperatura', 395.0000, 'ºC'),
	(322356, 145, '2015-01-15 00:17:01.000000', 'temperatura', 1074.0000, 'ºC'),
	(322357, 145, '2015-01-15 00:17:02.000000', 'temperatura', 586.0000, 'ºC'),
	(322358, 145, '2015-01-15 00:17:03.000000', 'temperatura', 908.0000, 'ºC'),
	(322359, 145, '2015-01-15 00:17:04.000000', 'temperatura', 385.0000, 'ºC'),
	(322360, 145, '2015-01-15 00:17:05.000000', 'temperatura', 400.0000, 'ºC'),
	(322361, 145, '2015-01-15 00:17:06.000000', 'temperatura', 847.0000, 'ºC'),
	(322362, 145, '2015-01-15 00:17:07.000000', 'temperatura', 635.0000, 'ºC'),
	(322363, 145, '2015-01-15 00:17:08.000000', 'temperatura', 633.0000, 'ºC'),
	(322364, 145, '2015-01-15 00:17:09.000000', 'temperatura', 62.0000, 'ºC'),
	(322365, 145, '2015-01-15 00:17:10.000000', 'temperatura', 812.0000, 'ºC'),
	(322366, 145, '2015-01-15 00:17:11.000000', 'temperatura', 272.0000, 'ºC'),
	(322367, 145, '2015-01-15 00:17:12.000000', 'temperatura', 127.0000, 'ºC'),
	(322368, 145, '2015-01-15 00:17:13.000000', 'temperatura', 1018.0000, 'ºC'),
	(322369, 145, '2015-01-15 00:17:14.000000', 'temperatura', 1111.0000, 'ºC'),
	(322370, 145, '2015-01-15 00:17:15.000000', 'temperatura', 103.0000, 'ºC'),
	(322371, 145, '2015-01-15 00:17:16.000000', 'temperatura', 781.0000, 'ºC'),
	(322372, 145, '2015-01-15 00:17:17.000000', 'temperatura', 1194.0000, 'ºC'),
	(322373, 145, '2015-01-15 00:17:18.000000', 'temperatura', 31.0000, 'ºC'),
	(322374, 145, '2015-01-15 00:17:19.000000', 'temperatura', 174.0000, 'ºC'),
	(322375, 145, '2015-01-15 00:17:20.000000', 'temperatura', 775.0000, 'ºC'),
	(322376, 145, '2015-01-15 00:17:21.000000', 'temperatura', 952.0000, 'ºC'),
	(322377, 145, '2015-01-15 00:17:22.000000', 'temperatura', 39.0000, 'ºC'),
	(322378, 145, '2015-01-15 00:17:23.000000', 'temperatura', 937.0000, 'ºC'),
	(322379, 145, '2015-01-15 00:17:24.000000', 'temperatura', 968.0000, 'ºC'),
	(322380, 145, '2015-01-15 00:17:25.000000', 'temperatura', 830.0000, 'ºC'),
	(322381, 145, '2015-01-15 00:17:26.000000', 'temperatura', 48.0000, 'ºC'),
	(322382, 145, '2015-01-15 00:17:27.000000', 'temperatura', 151.0000, 'ºC'),
	(322383, 145, '2015-01-15 00:17:28.000000', 'temperatura', 609.0000, 'ºC'),
	(322384, 145, '2015-01-15 00:17:29.000000', 'temperatura', 195.0000, 'ºC'),
	(322385, 145, '2015-01-15 00:17:30.000000', 'temperatura', 348.0000, 'ºC'),
	(322386, 145, '2015-01-15 00:17:31.000000', 'temperatura', 1156.0000, 'ºC'),
	(322387, 145, '2015-01-15 00:17:32.000000', 'temperatura', 1138.0000, 'ºC'),
	(322388, 145, '2015-01-15 00:17:33.000000', 'temperatura', 1021.0000, 'ºC'),
	(322389, 145, '2015-01-15 00:17:34.000000', 'temperatura', 490.0000, 'ºC'),
	(322390, 145, '2015-01-15 00:17:35.000000', 'temperatura', 588.0000, 'ºC'),
	(322391, 145, '2015-01-15 00:17:36.000000', 'temperatura', 270.0000, 'ºC'),
	(322392, 145, '2015-01-15 00:17:37.000000', 'temperatura', 787.0000, 'ºC'),
	(322393, 145, '2015-01-15 00:17:38.000000', 'temperatura', 727.0000, 'ºC'),
	(322394, 145, '2015-01-15 00:17:39.000000', 'temperatura', 76.0000, 'ºC'),
	(322395, 145, '2015-01-15 00:17:40.000000', 'temperatura', 596.0000, 'ºC'),
	(322396, 145, '2015-01-15 00:17:41.000000', 'temperatura', 355.0000, 'ºC'),
	(322397, 145, '2015-01-15 00:17:42.000000', 'temperatura', 1186.0000, 'ºC'),
	(322398, 145, '2015-01-15 00:17:43.000000', 'temperatura', 66.0000, 'ºC'),
	(322399, 145, '2015-01-15 00:17:44.000000', 'temperatura', 371.0000, 'ºC'),
	(322400, 145, '2015-01-15 00:17:45.000000', 'temperatura', 459.0000, 'ºC'),
	(322401, 145, '2015-01-15 00:17:46.000000', 'temperatura', 1181.0000, 'ºC'),
	(322402, 145, '2015-01-15 00:17:47.000000', 'temperatura', 929.0000, 'ºC'),
	(322403, 145, '2015-01-15 00:17:48.000000', 'temperatura', 1102.0000, 'ºC'),
	(322404, 145, '2015-01-15 00:17:49.000000', 'temperatura', 325.0000, 'ºC'),
	(322405, 145, '2015-01-15 00:17:50.000000', 'temperatura', 720.0000, 'ºC'),
	(322406, 145, '2015-01-15 00:17:51.000000', 'temperatura', 224.0000, 'ºC'),
	(322407, 145, '2015-01-15 00:17:52.000000', 'temperatura', 159.0000, 'ºC'),
	(322408, 145, '2015-01-15 00:17:53.000000', 'temperatura', 125.0000, 'ºC'),
	(322409, 145, '2015-01-15 00:17:54.000000', 'temperatura', 149.0000, 'ºC'),
	(322410, 145, '2015-01-15 00:17:55.000000', 'temperatura', 369.0000, 'ºC'),
	(322411, 145, '2015-01-15 00:17:56.000000', 'temperatura', 198.0000, 'ºC'),
	(322412, 145, '2015-01-15 00:17:57.000000', 'temperatura', 1086.0000, 'ºC'),
	(322413, 145, '2015-01-15 00:17:58.000000', 'temperatura', 35.0000, 'ºC'),
	(322414, 145, '2015-01-15 00:17:59.000000', 'temperatura', 517.0000, 'ºC'),
	(322415, 145, '2015-01-15 00:18:00.000000', 'temperatura', 79.0000, 'ºC'),
	(322416, 145, '2015-01-15 00:18:01.000000', 'temperatura', 48.0000, 'ºC'),
	(322417, 145, '2015-01-15 00:18:02.000000', 'temperatura', 0.0000, 'ºC'),
	(322418, 145, '2015-01-15 00:18:03.000000', 'temperatura', 1059.0000, 'ºC'),
	(322419, 145, '2015-01-15 00:18:04.000000', 'temperatura', 496.0000, 'ºC'),
	(322420, 145, '2015-01-15 00:18:05.000000', 'temperatura', 503.0000, 'ºC'),
	(322421, 145, '2015-01-15 00:18:06.000000', 'temperatura', 1027.0000, 'ºC'),
	(322422, 145, '2015-01-15 00:18:07.000000', 'temperatura', 28.0000, 'ºC'),
	(322423, 145, '2015-01-15 00:18:08.000000', 'temperatura', 659.0000, 'ºC'),
	(322424, 145, '2015-01-15 00:18:09.000000', 'temperatura', 811.0000, 'ºC'),
	(322425, 145, '2015-01-15 00:18:10.000000', 'temperatura', 880.0000, 'ºC'),
	(322426, 145, '2015-01-15 00:18:11.000000', 'temperatura', 765.0000, 'ºC'),
	(322427, 145, '2015-01-15 00:18:12.000000', 'temperatura', 1188.0000, 'ºC'),
	(322428, 145, '2015-01-15 00:18:13.000000', 'temperatura', 43.0000, 'ºC'),
	(322429, 145, '2015-01-15 00:18:14.000000', 'temperatura', 254.0000, 'ºC'),
	(322430, 145, '2015-01-15 00:18:15.000000', 'temperatura', 1142.0000, 'ºC'),
	(322431, 145, '2015-01-15 00:18:16.000000', 'temperatura', 146.0000, 'ºC'),
	(322432, 145, '2015-01-15 00:18:17.000000', 'temperatura', 904.0000, 'ºC'),
	(322433, 145, '2015-01-15 00:18:18.000000', 'temperatura', 483.0000, 'ºC'),
	(322434, 145, '2015-01-15 00:18:19.000000', 'temperatura', 902.0000, 'ºC'),
	(322435, 145, '2015-01-15 00:18:20.000000', 'temperatura', 662.0000, 'ºC'),
	(322436, 145, '2015-01-15 00:18:21.000000', 'temperatura', 604.0000, 'ºC'),
	(322437, 145, '2015-01-15 00:18:22.000000', 'temperatura', 1037.0000, 'ºC'),
	(322438, 145, '2015-01-15 00:18:23.000000', 'temperatura', 973.0000, 'ºC'),
	(322439, 145, '2015-01-15 00:18:24.000000', 'temperatura', 552.0000, 'ºC'),
	(322440, 145, '2015-01-15 00:18:25.000000', 'temperatura', 1045.0000, 'ºC'),
	(322441, 145, '2015-01-15 00:18:26.000000', 'temperatura', 1168.0000, 'ºC'),
	(322442, 145, '2015-01-15 00:18:27.000000', 'temperatura', 306.0000, 'ºC'),
	(322443, 145, '2015-01-15 00:18:28.000000', 'temperatura', 427.0000, 'ºC'),
	(322444, 145, '2015-01-15 00:18:29.000000', 'temperatura', 19.0000, 'ºC'),
	(322445, 145, '2015-01-15 00:18:30.000000', 'temperatura', 13.0000, 'ºC'),
	(322446, 145, '2015-01-15 00:18:31.000000', 'temperatura', 9.0000, 'ºC'),
	(322447, 145, '2015-01-15 00:18:32.000000', 'temperatura', 5.0000, 'ºC'),
	(322448, 145, '2015-01-15 00:18:33.000000', 'temperatura', 1198.0000, 'ºC'),
	(322449, 145, '2015-01-15 00:18:34.000000', 'temperatura', 1174.0000, 'ºC'),
	(322450, 145, '2015-01-15 00:18:35.000000', 'temperatura', 1079.0000, 'ºC'),
	(322451, 145, '2015-01-15 00:18:36.000000', 'temperatura', 675.0000, 'ºC'),
	(322452, 145, '2015-01-15 00:18:37.000000', 'temperatura', 137.0000, 'ºC'),
	(322453, 145, '2015-01-15 00:18:38.000000', 'temperatura', 1062.0000, 'ºC'),
	(322454, 145, '2015-01-15 00:18:39.000000', 'temperatura', 97.0000, 'ºC'),
	(322455, 145, '2015-01-15 00:18:40.000000', 'temperatura', 902.0000, 'ºC'),
	(322456, 145, '2015-01-15 00:18:41.000000', 'temperatura', 620.0000, 'ºC'),
	(322457, 145, '2015-01-15 00:18:42.000000', 'temperatura', 395.0000, 'ºC'),
	(322458, 145, '2015-01-15 00:18:43.000000', 'temperatura', 113.0000, 'ºC'),
	(322459, 145, '2015-01-15 00:18:44.000000', 'temperatura', 579.0000, 'ºC'),
	(322460, 145, '2015-01-15 00:18:45.000000', 'temperatura', 160.0000, 'ºC'),
	(322461, 145, '2015-01-15 00:18:46.000000', 'temperatura', 264.0000, 'ºC'),
	(322462, 145, '2015-01-15 00:18:47.000000', 'temperatura', 839.0000, 'ºC'),
	(322463, 145, '2015-01-15 00:18:48.000000', 'temperatura', 1003.0000, 'ºC'),
	(322464, 145, '2015-01-15 00:18:49.000000', 'temperatura', 100.0000, 'ºC'),
	(322465, 145, '2015-01-15 00:18:50.000000', 'temperatura', 1092.0000, 'ºC'),
	(322466, 145, '2015-01-15 00:18:51.000000', 'temperatura', 358.0000, 'ºC'),
	(322467, 145, '2015-01-15 00:18:52.000000', 'temperatura', 915.0000, 'ºC'),
	(322468, 145, '2015-01-15 00:18:53.000000', 'temperatura', 1104.0000, 'ºC'),
	(322469, 145, '2015-01-15 00:18:54.000000', 'temperatura', 373.0000, 'ºC'),
	(322470, 145, '2015-01-15 00:18:55.000000', 'temperatura', 954.0000, 'ºC'),
	(322471, 145, '2015-01-15 00:18:56.000000', 'temperatura', 54.0000, 'ºC'),
	(322472, 145, '2015-01-15 00:18:57.000000', 'temperatura', 1006.0000, 'ºC'),
	(322473, 145, '2015-01-15 00:18:58.000000', 'temperatura', 69.0000, 'ºC'),
	(322474, 145, '2015-01-15 00:18:59.000000', 'temperatura', 926.0000, 'ºC'),
	(322475, 145, '2015-01-15 00:19:00.000000', 'temperatura', 824.0000, 'ºC'),
	(322476, 145, '2015-01-15 00:19:01.000000', 'temperatura', 144.0000, 'ºC'),
	(322477, 145, '2015-01-15 00:19:02.000000', 'temperatura', 649.0000, 'ºC'),
	(322478, 145, '2015-01-15 00:19:03.000000', 'temperatura', 414.0000, 'ºC'),
	(322479, 145, '2015-01-15 00:19:04.000000', 'temperatura', 121.0000, 'ºC'),
	(322480, 145, '2015-01-15 00:19:05.000000', 'temperatura', 563.0000, 'ºC'),
	(322481, 145, '2015-01-15 00:19:06.000000', 'temperatura', 53.0000, 'ºC'),
	(322482, 145, '2015-01-15 00:19:07.000000', 'temperatura', 979.0000, 'ºC'),
	(322483, 145, '2015-01-15 00:19:08.000000', 'temperatura', 1135.0000, 'ºC'),
	(322484, 145, '2015-01-15 00:19:09.000000', 'temperatura', 338.0000, 'ºC'),
	(322485, 145, '2015-01-15 00:19:10.000000', 'temperatura', 685.0000, 'ºC'),
	(322486, 145, '2015-01-15 00:19:11.000000', 'temperatura', 14.0000, 'ºC'),
	(322487, 145, '2015-01-15 00:19:12.000000', 'temperatura', 415.0000, 'ºC'),
	(322488, 145, '2015-01-15 00:19:13.000000', 'temperatura', 832.0000, 'ºC'),
	(322489, 145, '2015-01-15 00:19:14.000000', 'temperatura', 517.0000, 'ºC'),
	(322490, 145, '2015-01-15 00:19:15.000000', 'temperatura', 90.0000, 'ºC'),
	(322491, 145, '2015-01-15 00:19:16.000000', 'temperatura', 99.0000, 'ºC'),
	(322492, 145, '2015-01-15 00:19:17.000000', 'temperatura', 227.0000, 'ºC'),
	(322493, 145, '2015-01-15 00:19:18.000000', 'temperatura', 838.0000, 'ºC'),
	(322494, 145, '2015-01-15 00:19:19.000000', 'temperatura', 1110.0000, 'ºC'),
	(322495, 145, '2015-01-15 00:19:20.000000', 'temperatura', 636.0000, 'ºC'),
	(322496, 145, '2015-01-15 00:19:21.000000', 'temperatura', 1050.0000, 'ºC'),
	(322497, 145, '2015-01-15 00:19:22.000000', 'temperatura', 941.0000, 'ºC'),
	(322498, 145, '2015-01-15 00:19:23.000000', 'temperatura', 355.0000, 'ºC'),
	(322499, 145, '2015-01-15 00:19:24.000000', 'temperatura', 155.0000, 'ºC'),
	(322500, 145, '2015-01-15 00:19:25.000000', 'temperatura', 909.0000, 'ºC'),
	(322501, 145, '2015-01-15 00:19:26.000000', 'temperatura', 480.0000, 'ºC'),
	(322502, 145, '2015-01-15 00:19:27.000000', 'temperatura', 873.0000, 'ºC'),
	(322503, 145, '2015-01-15 00:19:28.000000', 'temperatura', 525.0000, 'ºC'),
	(322504, 145, '2015-01-15 00:19:29.000000', 'temperatura', 8.0000, 'ºC'),
	(322505, 145, '2015-01-15 00:19:30.000000', 'temperatura', 866.0000, 'ºC'),
	(322506, 145, '2015-01-15 00:19:31.000000', 'temperatura', 706.0000, 'ºC'),
	(322507, 145, '2015-01-15 00:19:32.000000', 'temperatura', 933.0000, 'ºC'),
	(322508, 145, '2015-01-15 00:19:33.000000', 'temperatura', 148.0000, 'ºC'),
	(322509, 145, '2015-01-15 00:19:34.000000', 'temperatura', 340.0000, 'ºC'),
	(322510, 145, '2015-01-15 00:19:35.000000', 'temperatura', 58.0000, 'ºC'),
	(322511, 145, '2015-01-15 00:19:36.000000', 'temperatura', 468.0000, 'ºC'),
	(322512, 145, '2015-01-15 00:19:37.000000', 'temperatura', 968.0000, 'ºC'),
	(322513, 145, '2015-01-15 00:19:38.000000', 'temperatura', 1038.0000, 'ºC'),
	(322514, 145, '2015-01-15 00:19:39.000000', 'temperatura', 1085.0000, 'ºC'),
	(322515, 145, '2015-01-15 00:19:40.000000', 'temperatura', 1112.0000, 'ºC'),
	(322516, 145, '2015-01-15 00:19:41.000000', 'temperatura', 1107.0000, 'ºC'),
	(322517, 145, '2015-01-15 00:19:42.000000', 'temperatura', 999.0000, 'ºC'),
	(322518, 145, '2015-01-15 00:19:43.000000', 'temperatura', 474.0000, 'ºC'),
	(322519, 145, '2015-01-15 00:19:44.000000', 'temperatura', 573.0000, 'ºC'),
	(322520, 145, '2015-01-15 00:19:45.000000', 'temperatura', 245.0000, 'ºC'),
	(322521, 145, '2015-01-15 00:19:46.000000', 'temperatura', 705.0000, 'ºC'),
	(322522, 145, '2015-01-15 00:19:47.000000', 'temperatura', 392.0000, 'ºC'),
	(322523, 145, '2015-01-15 00:19:48.000000', 'temperatura', 1044.0000, 'ºC'),
	(322524, 145, '2015-01-15 00:19:49.000000', 'temperatura', 443.0000, 'ºC'),
	(322525, 145, '2015-01-15 00:19:50.000000', 'temperatura', 287.0000, 'ºC'),
	(322526, 145, '2015-01-15 00:19:51.000000', 'temperatura', 104.0000, 'ºC'),
	(322527, 145, '2015-01-15 00:19:52.000000', 'temperatura', 862.0000, 'ºC'),
	(322528, 145, '2015-01-15 00:19:53.000000', 'temperatura', 397.0000, 'ºC'),
	(322529, 145, '2015-01-15 00:19:54.000000', 'temperatura', 600.0000, 'ºC'),
	(322530, 145, '2015-01-15 00:19:55.000000', 'temperatura', 607.0000, 'ºC'),
	(322531, 145, '2015-01-15 00:19:56.000000', 'temperatura', 38.0000, 'ºC'),
	(322532, 145, '2015-01-15 00:19:57.000000', 'temperatura', 770.0000, 'ºC'),
	(322533, 145, '2015-01-15 00:19:58.000000', 'temperatura', 137.0000, 'ºC'),
	(322534, 145, '2015-01-15 00:19:59.000000', 'temperatura', 777.0000, 'ºC'),
	(322535, 145, '2015-01-15 00:20:00.000000', 'temperatura', 1071.0000, 'ºC'),
	(322536, 145, '2015-01-15 00:20:01.000000', 'temperatura', 627.0000, 'ºC'),
	(322537, 145, '2015-01-15 00:20:02.000000', 'temperatura', 1122.0000, 'ºC'),
	(322538, 145, '2015-01-15 00:20:03.000000', 'temperatura', 129.0000, 'ºC'),
	(322539, 145, '2015-01-15 00:20:04.000000', 'temperatura', 879.0000, 'ºC'),
	(322540, 145, '2015-01-15 00:20:05.000000', 'temperatura', 408.0000, 'ºC'),
	(322541, 145, '2015-01-15 00:20:06.000000', 'temperatura', 603.0000, 'ºC'),
	(322542, 145, '2015-01-15 00:20:07.000000', 'temperatura', 593.0000, 'ºC'),
	(322543, 145, '2015-01-15 00:20:08.000000', 'temperatura', 1154.0000, 'ºC'),
	(322544, 145, '2015-01-15 00:20:09.000000', 'temperatura', 394.0000, 'ºC'),
	(322545, 145, '2015-01-15 00:20:10.000000', 'temperatura', 908.0000, 'ºC'),
	(322546, 145, '2015-01-15 00:20:11.000000', 'temperatura', 956.0000, 'ºC'),
	(322547, 145, '2015-01-15 00:20:12.000000', 'temperatura', 860.0000, 'ºC'),
	(322548, 145, '2015-01-15 00:20:13.000000', 'temperatura', 232.0000, 'ºC'),
	(322549, 145, '2015-01-15 00:20:14.000000', 'temperatura', 979.0000, 'ºC'),
	(322550, 145, '2015-01-15 00:20:15.000000', 'temperatura', 602.0000, 'ºC'),
	(322551, 145, '2015-01-15 00:20:16.000000', 'temperatura', 72.0000, 'ºC'),
	(322552, 145, '2015-01-15 00:20:17.000000', 'temperatura', 955.0000, 'ºC'),
	(322553, 145, '2015-01-15 00:20:18.000000', 'temperatura', 957.0000, 'ºC'),
	(322554, 145, '2015-01-15 00:20:19.000000', 'temperatura', 723.0000, 'ºC'),
	(322555, 145, '2015-01-15 00:20:20.000000', 'temperatura', 742.0000, 'ºC'),
	(322556, 145, '2015-01-15 00:20:21.000000', 'temperatura', 343.0000, 'ºC'),
	(322557, 145, '2015-01-15 00:20:22.000000', 'temperatura', 691.0000, 'ºC'),
	(322558, 145, '2015-01-15 00:20:23.000000', 'temperatura', 26.0000, 'ºC'),
	(322559, 145, '2015-01-15 00:20:24.000000', 'temperatura', 455.0000, 'ºC'),
	(322560, 145, '2015-01-15 00:20:25.000000', 'temperatura', 999.0000, 'ºC'),
	(322561, 145, '2015-01-15 00:20:26.000000', 'temperatura', 29.0000, 'ºC'),
	(322562, 145, '2015-01-15 00:20:27.000000', 'temperatura', 751.0000, 'ºC'),
	(322563, 145, '2015-01-15 00:20:28.000000', 'temperatura', 67.0000, 'ºC'),
	(322564, 145, '2015-01-15 00:20:29.000000', 'temperatura', 481.0000, 'ºC'),
	(322565, 145, '2015-01-15 00:20:30.000000', 'temperatura', 1005.0000, 'ºC'),
	(322566, 145, '2015-01-15 00:20:31.000000', 'temperatura', 1183.0000, 'ºC'),
	(322567, 145, '2015-01-15 00:20:32.000000', 'temperatura', 501.0000, 'ºC'),
	(322568, 145, '2015-01-15 00:20:33.000000', 'temperatura', 156.0000, 'ºC'),
	(322569, 145, '2015-01-15 00:20:34.000000', 'temperatura', 478.0000, 'ºC'),
	(322570, 145, '2015-01-15 00:20:35.000000', 'temperatura', 723.0000, 'ºC'),
	(322571, 145, '2015-01-15 00:20:36.000000', 'temperatura', 982.0000, 'ºC'),
	(322572, 145, '2015-01-15 00:20:37.000000', 'temperatura', 339.0000, 'ºC'),
	(322573, 145, '2015-01-15 00:20:38.000000', 'temperatura', 1151.0000, 'ºC'),
	(322574, 145, '2015-01-15 00:20:39.000000', 'temperatura', 1138.0000, 'ºC'),
	(322575, 145, '2015-01-15 00:20:40.000000', 'temperatura', 1038.0000, 'ºC'),
	(322576, 145, '2015-01-15 00:20:41.000000', 'temperatura', 575.0000, 'ºC'),
	(322577, 145, '2015-01-15 00:20:42.000000', 'temperatura', 961.0000, 'ºC'),
	(322578, 145, '2015-01-15 00:20:43.000000', 'temperatura', 683.0000, 'ºC'),
	(322579, 145, '2015-01-15 00:20:44.000000', 'temperatura', 531.0000, 'ºC'),
	(322580, 145, '2015-01-15 00:20:45.000000', 'temperatura', 607.0000, 'ºC'),
	(322581, 145, '2015-01-15 00:20:46.000000', 'temperatura', 240.0000, 'ºC'),
	(322582, 145, '2015-01-15 00:20:47.000000', 'temperatura', 583.0000, 'ºC'),
	(322583, 145, '2015-01-15 00:20:48.000000', 'temperatura', 995.0000, 'ºC'),
	(322584, 145, '2015-01-15 00:20:49.000000', 'temperatura', 826.0000, 'ºC'),
	(322585, 145, '2015-01-15 00:20:50.000000', 'temperatura', 1147.0000, 'ºC'),
	(322586, 145, '2015-01-15 00:20:51.000000', 'temperatura', 856.0000, 'ºC'),
	(322587, 145, '2015-01-15 00:20:52.000000', 'temperatura', 840.0000, 'ºC'),
	(322588, 145, '2015-01-15 00:20:53.000000', 'temperatura', 433.0000, 'ºC'),
	(322589, 145, '2015-01-15 00:20:54.000000', 'temperatura', 847.0000, 'ºC'),
	(322590, 145, '2015-01-15 00:20:55.000000', 'temperatura', 535.0000, 'ºC'),
	(322591, 145, '2015-01-15 00:20:56.000000', 'temperatura', 137.0000, 'ºC'),
	(322592, 145, '2015-01-15 00:20:57.000000', 'temperatura', 277.0000, 'ºC'),
	(322593, 145, '2015-01-15 00:20:58.000000', 'temperatura', 976.0000, 'ºC'),
	(322594, 145, '2015-01-15 00:20:59.000000', 'temperatura', 450.0000, 'ºC'),
	(322595, 145, '2015-01-15 00:21:00.000000', 'temperatura', 522.0000, 'ºC'),
	(322596, 145, '2015-01-15 00:21:01.000000', 'temperatura', 59.0000, 'ºC'),
	(322597, 145, '2015-01-15 00:21:02.000000', 'temperatura', 1131.0000, 'ºC'),
	(322598, 145, '2015-01-15 00:21:03.000000', 'temperatura', 678.0000, 'ºC'),
	(322599, 145, '2015-01-15 00:21:04.000000', 'temperatura', 1197.0000, 'ºC'),
	(322600, 145, '2015-01-15 00:21:05.000000', 'temperatura', 352.0000, 'ºC'),
	(322601, 145, '2015-01-15 00:21:06.000000', 'temperatura', 571.0000, 'ºC'),
	(322602, 145, '2015-01-15 00:21:07.000000', 'temperatura', 600.0000, 'ºC'),
	(322603, 145, '2015-01-15 00:21:08.000000', 'temperatura', 86.0000, 'ºC'),
	(322604, 145, '2015-01-15 00:21:09.000000', 'temperatura', 1029.0000, 'ºC'),
	(322605, 145, '2015-01-15 00:21:10.000000', 'temperatura', 90.0000, 'ºC'),
	(322606, 145, '2015-01-15 00:21:11.000000', 'temperatura', 963.0000, 'ºC'),
	(322607, 145, '2015-01-15 00:21:12.000000', 'temperatura', 945.0000, 'ºC'),
	(322608, 145, '2015-01-15 00:21:13.000000', 'temperatura', 636.0000, 'ºC'),
	(322609, 145, '2015-01-15 00:21:14.000000', 'temperatura', 345.0000, 'ºC'),
	(322610, 145, '2015-01-15 00:21:15.000000', 'temperatura', 1018.0000, 'ºC'),
	(322611, 145, '2015-01-15 00:21:16.000000', 'temperatura', 456.0000, 'ºC'),
	(322612, 145, '2015-01-15 00:21:17.000000', 'temperatura', 428.0000, 'ºC'),
	(322613, 145, '2015-01-15 00:21:18.000000', 'temperatura', 771.0000, 'ºC'),
	(322614, 145, '2015-01-15 00:21:19.000000', 'temperatura', 173.0000, 'ºC'),
	(322615, 145, '2015-01-15 00:21:20.000000', 'temperatura', 953.0000, 'ºC'),
	(322616, 145, '2015-01-15 00:21:21.000000', 'temperatura', 646.0000, 'ºC'),
	(322617, 145, '2015-01-15 00:21:22.000000', 'temperatura', 370.0000, 'ºC'),
	(322618, 145, '2015-01-15 00:21:23.000000', 'temperatura', 1111.0000, 'ºC'),
	(322619, 145, '2015-01-15 00:21:24.000000', 'temperatura', 849.0000, 'ºC'),
	(322620, 145, '2015-01-15 00:21:25.000000', 'temperatura', 911.0000, 'ºC'),
	(322621, 145, '2015-01-15 00:21:26.000000', 'temperatura', 808.0000, 'ºC'),
	(322622, 145, '2015-01-15 00:21:27.000000', 'temperatura', 109.0000, 'ºC'),
	(322623, 145, '2015-01-15 00:21:28.000000', 'temperatura', 520.0000, 'ºC'),
	(322624, 145, '2015-01-15 00:21:29.000000', 'temperatura', 1074.0000, 'ºC'),
	(322625, 145, '2015-01-15 00:21:30.000000', 'temperatura', 210.0000, 'ºC'),
	(322626, 145, '2015-01-15 00:21:31.000000', 'temperatura', 230.0000, 'ºC'),
	(322627, 145, '2015-01-15 00:21:32.000000', 'temperatura', 520.0000, 'ºC'),
	(322628, 145, '2015-01-15 00:21:33.000000', 'temperatura', 709.0000, 'ºC'),
	(322629, 145, '2015-01-15 00:21:34.000000', 'temperatura', 786.0000, 'ºC'),
	(322630, 145, '2015-01-15 00:21:35.000000', 'temperatura', 602.0000, 'ºC'),
	(322631, 145, '2015-01-15 00:21:36.000000', 'temperatura', 653.0000, 'ºC'),
	(322632, 145, '2015-01-15 00:21:37.000000', 'temperatura', 258.0000, 'ºC'),
	(322633, 145, '2015-01-15 00:21:38.000000', 'temperatura', 533.0000, 'ºC'),
	(322634, 145, '2015-01-15 00:21:39.000000', 'temperatura', 693.0000, 'ºC'),
	(322635, 145, '2015-01-15 00:21:40.000000', 'temperatura', 665.0000, 'ºC'),
	(322636, 145, '2015-01-15 00:21:41.000000', 'temperatura', 46.0000, 'ºC'),
	(322637, 145, '2015-01-15 00:21:42.000000', 'temperatura', 635.0000, 'ºC'),
	(322638, 145, '2015-01-15 00:21:43.000000', 'temperatura', 638.0000, 'ºC'),
	(322639, 145, '2015-01-15 00:21:44.000000', 'temperatura', 87.0000, 'ºC'),
	(322640, 145, '2015-01-15 00:21:45.000000', 'temperatura', 919.0000, 'ºC'),
	(322641, 145, '2015-01-15 00:21:46.000000', 'temperatura', 735.0000, 'ºC'),
	(322642, 145, '2015-01-15 00:21:47.000000', 'temperatura', 917.0000, 'ºC'),
	(322643, 145, '2015-01-15 00:21:48.000000', 'temperatura', 1182.0000, 'ºC'),
	(322644, 145, '2015-01-15 00:21:49.000000', 'temperatura', 758.0000, 'ºC'),
	(322645, 145, '2015-01-15 00:21:50.000000', 'temperatura', 245.0000, 'ºC'),
	(322646, 145, '2015-01-15 00:21:51.000000', 'temperatura', 150.0000, 'ºC'),
	(322647, 145, '2015-01-15 00:21:52.000000', 'temperatura', 16.0000, 'ºC'),
	(322648, 145, '2015-01-15 00:21:53.000000', 'temperatura', 832.0000, 'ºC'),
	(322649, 145, '2015-01-15 00:21:54.000000', 'temperatura', 514.0000, 'ºC'),
	(322650, 145, '2015-01-15 00:21:55.000000', 'temperatura', 72.0000, 'ºC'),
	(322651, 145, '2015-01-15 00:21:56.000000', 'temperatura', 18.0000, 'ºC'),
	(322652, 145, '2015-01-15 00:21:57.000000', 'temperatura', 1074.0000, 'ºC'),
	(322653, 145, '2015-01-15 00:21:58.000000', 'temperatura', 519.0000, 'ºC'),
	(322654, 145, '2015-01-15 00:21:59.000000', 'temperatura', 571.0000, 'ºC'),
	(322655, 145, '2015-01-15 00:22:00.000000', 'temperatura', 101.0000, 'ºC'),
	(322656, 145, '2015-01-15 00:22:01.000000', 'temperatura', 1192.0000, 'ºC'),
	(322657, 145, '2015-01-15 00:22:02.000000', 'temperatura', 856.0000, 'ºC'),
	(322658, 145, '2015-01-15 00:22:03.000000', 'temperatura', 705.0000, 'ºC'),
	(322659, 145, '2015-01-15 00:22:04.000000', 'temperatura', 956.0000, 'ºC'),
	(322660, 145, '2015-01-15 00:22:05.000000', 'temperatura', 267.0000, 'ºC'),
	(322661, 145, '2015-01-15 00:22:06.000000', 'temperatura', 869.0000, 'ºC'),
	(322662, 145, '2015-01-15 00:22:07.000000', 'temperatura', 1144.0000, 'ºC'),
	(322663, 145, '2015-01-15 00:22:08.000000', 'temperatura', 711.0000, 'ºC'),
	(322664, 145, '2015-01-15 00:22:09.000000', 'temperatura', 126.0000, 'ºC'),
	(322665, 145, '2015-01-15 00:22:10.000000', 'temperatura', 898.0000, 'ºC'),
	(322666, 145, '2015-01-15 00:22:11.000000', 'temperatura', 512.0000, 'ºC'),
	(322667, 145, '2015-01-15 00:22:12.000000', 'temperatura', 1064.0000, 'ºC'),
	(322668, 145, '2015-01-15 00:22:13.000000', 'temperatura', 187.0000, 'ºC'),
	(322669, 145, '2015-01-15 00:22:14.000000', 'temperatura', 143.0000, 'ºC'),
	(322670, 145, '2015-01-15 00:22:15.000000', 'temperatura', 154.0000, 'ºC'),
	(322671, 145, '2015-01-15 00:22:16.000000', 'temperatura', 343.0000, 'ºC'),
	(322672, 145, '2015-01-15 00:22:17.000000', 'temperatura', 54.0000, 'ºC'),
	(322673, 145, '2015-01-15 00:22:18.000000', 'temperatura', 441.0000, 'ºC'),
	(322674, 145, '2015-01-15 00:22:19.000000', 'temperatura', 845.0000, 'ºC'),
	(322675, 145, '2015-01-15 00:22:20.000000', 'temperatura', 501.0000, 'ºC'),
	(322676, 145, '2015-01-15 00:22:21.000000', 'temperatura', 1171.0000, 'ºC'),
	(322677, 145, '2015-01-15 00:22:22.000000', 'temperatura', 751.0000, 'ºC'),
	(322678, 145, '2015-01-15 00:22:23.000000', 'temperatura', 245.0000, 'ºC'),
	(322679, 145, '2015-01-15 00:22:24.000000', 'temperatura', 170.0000, 'ºC'),
	(322680, 145, '2015-01-15 00:22:25.000000', 'temperatura', 115.0000, 'ºC'),
	(322681, 145, '2015-01-15 00:22:26.000000', 'temperatura', 65.0000, 'ºC'),
	(322682, 145, '2015-01-15 00:22:27.000000', 'temperatura', 1180.0000, 'ºC'),
	(322683, 145, '2015-01-15 00:22:28.000000', 'temperatura', 909.0000, 'ºC'),
	(322684, 145, '2015-01-15 00:22:29.000000', 'temperatura', 1002.0000, 'ºC'),
	(322685, 145, '2015-01-15 00:22:30.000000', 'temperatura', 1087.0000, 'ºC'),
	(322686, 145, '2015-01-15 00:22:31.000000', 'temperatura', 26.0000, 'ºC'),
	(322687, 145, '2015-01-15 00:22:32.000000', 'temperatura', 472.0000, 'ºC'),
	(322688, 145, '2015-01-15 00:22:33.000000', 'temperatura', 1080.0000, 'ºC'),
	(322689, 145, '2015-01-15 00:22:34.000000', 'temperatura', 386.0000, 'ºC'),
	(322690, 145, '2015-01-15 00:22:35.000000', 'temperatura', 1091.0000, 'ºC'),
	(322691, 145, '2015-01-15 00:22:36.000000', 'temperatura', 695.0000, 'ºC'),
	(322692, 145, '2015-01-15 00:22:37.000000', 'temperatura', 204.0000, 'ºC'),
	(322693, 145, '2015-01-15 00:22:38.000000', 'temperatura', 135.0000, 'ºC'),
	(322694, 145, '2015-01-15 00:22:39.000000', 'temperatura', 62.0000, 'ºC'),
	(322695, 145, '2015-01-15 00:22:40.000000', 'temperatura', 1109.0000, 'ºC'),
	(322696, 145, '2015-01-15 00:22:41.000000', 'temperatura', 557.0000, 'ºC'),
	(322697, 145, '2015-01-15 00:22:42.000000', 'temperatura', 658.0000, 'ºC'),
	(322698, 145, '2015-01-15 00:22:43.000000', 'temperatura', 422.0000, 'ºC'),
	(322699, 145, '2015-01-15 00:22:44.000000', 'temperatura', 134.0000, 'ºC'),
	(322700, 145, '2015-01-15 00:22:45.000000', 'temperatura', 604.0000, 'ºC'),
	(322701, 145, '2015-01-15 00:22:46.000000', 'temperatura', 219.0000, 'ºC'),
	(322702, 145, '2015-01-15 00:22:47.000000', 'temperatura', 484.0000, 'ºC'),
	(322703, 145, '2015-01-15 00:22:48.000000', 'temperatura', 563.0000, 'ºC'),
	(322704, 145, '2015-01-15 00:22:49.000000', 'temperatura', 162.0000, 'ºC'),
	(322705, 145, '2015-01-15 00:22:50.000000', 'temperatura', 324.0000, 'ºC'),
	(322706, 145, '2015-01-15 00:22:51.000000', 'temperatura', 1133.0000, 'ºC'),
	(322707, 145, '2015-01-15 00:22:52.000000', 'temperatura', 1096.0000, 'ºC'),
	(322708, 145, '2015-01-15 00:22:53.000000', 'temperatura', 880.0000, 'ºC'),
	(322709, 145, '2015-01-15 00:22:54.000000', 'temperatura', 1112.0000, 'ºC'),
	(322710, 145, '2015-01-15 00:22:55.000000', 'temperatura', 522.0000, 'ºC'),
	(322711, 145, '2015-01-15 00:22:56.000000', 'temperatura', 475.0000, 'ºC'),
	(322712, 145, '2015-01-15 00:22:57.000000', 'temperatura', 807.0000, 'ºC'),
	(322713, 145, '2015-01-15 00:22:58.000000', 'temperatura', 210.0000, 'ºC'),
	(322714, 145, '2015-01-15 00:22:59.000000', 'temperatura', 1031.0000, 'ºC'),
	(322715, 145, '2015-01-15 00:23:00.000000', 'temperatura', 925.0000, 'ºC'),
	(322716, 145, '2015-01-15 00:23:01.000000', 'temperatura', 334.0000, 'ºC'),
	(322717, 145, '2015-01-15 00:23:02.000000', 'temperatura', 95.0000, 'ºC'),
	(322718, 145, '2015-01-15 00:23:03.000000', 'temperatura', 674.0000, 'ºC'),
	(322719, 145, '2015-01-15 00:23:04.000000', 'temperatura', 686.0000, 'ºC'),
	(322720, 145, '2015-01-15 00:23:05.000000', 'temperatura', 209.0000, 'ºC'),
	(322721, 145, '2015-01-15 00:23:06.000000', 'temperatura', 185.0000, 'ºC'),
	(322722, 145, '2015-01-15 00:23:07.000000', 'temperatura', 300.0000, 'ºC'),
	(322723, 145, '2015-01-15 00:23:08.000000', 'temperatura', 944.0000, 'ºC'),
	(322724, 145, '2015-01-15 00:23:09.000000', 'temperatura', 219.0000, 'ºC'),
	(322725, 145, '2015-01-15 00:23:10.000000', 'temperatura', 667.0000, 'ºC'),
	(322726, 145, '2015-01-15 00:23:11.000000', 'temperatura', 277.0000, 'ºC'),
	(322727, 145, '2015-01-15 00:23:12.000000', 'temperatura', 583.0000, 'ºC'),
	(322728, 145, '2015-01-15 00:23:13.000000', 'temperatura', 887.0000, 'ºC'),
	(322729, 145, '2015-01-15 00:23:14.000000', 'temperatura', 287.0000, 'ºC'),
	(322730, 145, '2015-01-15 00:23:15.000000', 'temperatura', 1174.0000, 'ºC'),
	(322731, 145, '2015-01-15 00:23:16.000000', 'temperatura', 211.0000, 'ºC'),
	(322732, 145, '2015-01-15 00:23:17.000000', 'temperatura', 1132.0000, 'ºC'),
	(322733, 145, '2015-01-15 00:23:18.000000', 'temperatura', 226.0000, 'ºC'),
	(322734, 145, '2015-01-15 00:23:19.000000', 'temperatura', 136.0000, 'ºC'),
	(322735, 145, '2015-01-15 00:23:20.000000', 'temperatura', 4.0000, 'ºC'),
	(322736, 145, '2015-01-15 00:23:21.000000', 'temperatura', 810.0000, 'ºC'),
	(322737, 145, '2015-01-15 00:23:22.000000', 'temperatura', 440.0000, 'ºC'),
	(322738, 145, '2015-01-15 00:23:23.000000', 'temperatura', 972.0000, 'ºC'),
	(322739, 145, '2015-01-15 00:23:24.000000', 'temperatura', 1139.0000, 'ºC'),
	(322740, 145, '2015-01-15 00:23:25.000000', 'temperatura', 381.0000, 'ºC'),
	(322741, 145, '2015-01-15 00:23:26.000000', 'temperatura', 887.0000, 'ºC'),
	(322742, 145, '2015-01-15 00:23:27.000000', 'temperatura', 894.0000, 'ºC'),
	(322743, 145, '2015-01-15 00:23:28.000000', 'temperatura', 608.0000, 'ºC'),
	(322744, 145, '2015-01-15 00:23:29.000000', 'temperatura', 360.0000, 'ºC'),
	(322745, 145, '2015-01-15 00:23:30.000000', 'temperatura', 1176.0000, 'ºC'),
	(322746, 145, '2015-01-15 00:23:31.000000', 'temperatura', 0.0000, 'ºC'),
	(322747, 145, '2015-01-15 00:23:32.000000', 'temperatura', 72.0000, 'ºC'),
	(322748, 145, '2015-01-15 00:23:33.000000', 'temperatura', 363.0000, 'ºC'),
	(322749, 145, '2015-01-15 00:23:34.000000', 'temperatura', 397.0000, 'ºC'),
	(322750, 145, '2015-01-15 00:23:35.000000', 'temperatura', 899.0000, 'ºC'),
	(322751, 145, '2015-01-15 00:23:36.000000', 'temperatura', 905.0000, 'ºC'),
	(322752, 145, '2015-01-15 00:23:37.000000', 'temperatura', 628.0000, 'ºC'),
	(322753, 145, '2015-01-15 00:23:38.000000', 'temperatura', 424.0000, 'ºC'),
	(322754, 145, '2015-01-15 00:23:39.000000', 'temperatura', 238.0000, 'ºC'),
	(322755, 145, '2015-01-15 00:23:40.000000', 'temperatura', 1117.0000, 'ºC'),
	(322756, 145, '2015-01-15 00:23:41.000000', 'temperatura', 71.0000, 'ºC'),
	(322757, 145, '2015-01-15 00:23:42.000000', 'temperatura', 607.0000, 'ºC'),
	(322758, 145, '2015-01-15 00:23:43.000000', 'temperatura', 421.0000, 'ºC'),
	(322759, 145, '2015-01-15 00:23:44.000000', 'temperatura', 285.0000, 'ºC'),
	(322760, 145, '2015-01-15 00:23:45.000000', 'temperatura', 163.0000, 'ºC'),
	(322761, 145, '2015-01-15 00:23:46.000000', 'temperatura', 1161.0000, 'ºC'),
	(322762, 145, '2015-01-15 00:23:47.000000', 'temperatura', 516.0000, 'ºC'),
	(322763, 145, '2015-01-15 00:23:48.000000', 'temperatura', 296.0000, 'ºC'),
	(322764, 145, '2015-01-15 00:23:49.000000', 'temperatura', 1134.0000, 'ºC'),
	(322765, 145, '2015-01-15 00:23:50.000000', 'temperatura', 1182.0000, 'ºC'),
	(322766, 145, '2015-01-15 00:23:51.000000', 'temperatura', 110.0000, 'ºC'),
	(322767, 145, '2015-01-15 00:23:52.000000', 'temperatura', 605.0000, 'ºC'),
	(322768, 145, '2015-01-15 00:23:53.000000', 'temperatura', 293.0000, 'ºC'),
	(322769, 145, '2015-01-15 00:23:54.000000', 'temperatura', 854.0000, 'ºC'),
	(322770, 145, '2015-01-15 00:23:55.000000', 'temperatura', 988.0000, 'ºC'),
	(322771, 145, '2015-01-15 00:23:56.000000', 'temperatura', 1179.0000, 'ºC'),
	(322772, 145, '2015-01-15 00:23:57.000000', 'temperatura', 531.0000, 'ºC'),
	(322773, 145, '2015-01-15 00:23:58.000000', 'temperatura', 321.0000, 'ºC'),
	(322774, 145, '2015-01-15 00:23:59.000000', 'temperatura', 12.0000, 'ºC'),
	(322775, 145, '2015-01-15 00:24:00.000000', 'temperatura', 297.0000, 'ºC'),
	(322776, 145, '2015-01-15 00:24:01.000000', 'temperatura', 250.0000, 'ºC'),
	(322777, 145, '2015-01-15 00:24:02.000000', 'temperatura', 361.0000, 'ºC'),
	(322778, 145, '2015-01-15 00:24:03.000000', 'temperatura', 1054.0000, 'ºC'),
	(322779, 145, '2015-01-15 00:24:04.000000', 'temperatura', 587.0000, 'ºC'),
	(322780, 145, '2015-01-15 00:24:05.000000', 'temperatura', 973.0000, 'ºC'),
	(322781, 145, '2015-01-15 00:24:06.000000', 'temperatura', 705.0000, 'ºC'),
	(322782, 145, '2015-01-15 00:24:07.000000', 'temperatura', 605.0000, 'ºC'),
	(322783, 145, '2015-01-15 00:24:08.000000', 'temperatura', 912.0000, 'ºC'),
	(322784, 145, '2015-01-15 00:24:09.000000', 'temperatura', 343.0000, 'ºC'),
	(322785, 145, '2015-01-15 00:24:10.000000', 'temperatura', 182.0000, 'ºC'),
	(322786, 145, '2015-01-15 00:24:11.000000', 'temperatura', 1081.0000, 'ºC'),
	(322787, 145, '2015-01-15 00:24:12.000000', 'temperatura', 57.0000, 'ºC'),
	(322788, 145, '2015-01-15 00:24:13.000000', 'temperatura', 646.0000, 'ºC'),
	(322789, 145, '2015-01-15 00:24:14.000000', 'temperatura', 657.0000, 'ºC'),
	(322790, 145, '2015-01-15 00:24:15.000000', 'temperatura', 147.0000, 'ºC'),
	(322791, 145, '2015-01-15 00:24:16.000000', 'temperatura', 1167.0000, 'ºC'),
	(322792, 145, '2015-01-15 00:24:17.000000', 'temperatura', 592.0000, 'ºC'),
	(322793, 145, '2015-01-15 00:24:18.000000', 'temperatura', 659.0000, 'ºC'),
	(322794, 145, '2015-01-15 00:24:19.000000', 'temperatura', 318.0000, 'ºC'),
	(322795, 145, '2015-01-15 00:24:20.000000', 'temperatura', 817.0000, 'ºC'),
	(322796, 145, '2015-01-15 00:24:21.000000', 'temperatura', 732.0000, 'ºC'),
	(322797, 145, '2015-01-15 00:24:22.000000', 'temperatura', 8.0000, 'ºC'),
	(322798, 145, '2015-01-15 00:24:23.000000', 'temperatura', 245.0000, 'ºC'),
	(322799, 145, '2015-01-15 00:24:24.000000', 'temperatura', 2.0000, 'ºC'),
	(322800, 145, '2015-01-15 00:24:25.000000', 'temperatura', 473.0000, 'ºC'),
	(322801, 145, '2015-01-15 00:24:26.000000', 'temperatura', 1163.0000, 'ºC'),
	(322802, 145, '2015-01-15 00:24:27.000000', 'temperatura', 795.0000, 'ºC'),
	(322803, 145, '2015-01-15 00:24:28.000000', 'temperatura', 487.0000, 'ºC'),
	(322804, 145, '2015-01-15 00:24:29.000000', 'temperatura', 48.0000, 'ºC'),
	(322805, 145, '2015-01-15 00:24:30.000000', 'temperatura', 1182.0000, 'ºC'),
	(322806, 145, '2015-01-15 00:24:31.000000', 'temperatura', 968.0000, 'ºC'),
	(322807, 145, '2015-01-15 00:24:32.000000', 'temperatura', 92.0000, 'ºC'),
	(322808, 145, '2015-01-15 00:24:33.000000', 'temperatura', 1159.0000, 'ºC'),
	(322809, 145, '2015-01-15 00:24:34.000000', 'temperatura', 717.0000, 'ºC'),
	(322810, 145, '2015-01-15 00:24:35.000000', 'temperatura', 110.0000, 'ºC'),
	(322811, 145, '2015-01-15 00:24:36.000000', 'temperatura', 800.0000, 'ºC'),
	(322812, 145, '2015-01-15 00:24:37.000000', 'temperatura', 70.0000, 'ºC'),
	(322813, 145, '2015-01-15 00:24:38.000000', 'temperatura', 350.0000, 'ºC'),
	(322814, 145, '2015-01-15 00:24:39.000000', 'temperatura', 340.0000, 'ºC'),
	(322815, 145, '2015-01-15 00:24:40.000000', 'temperatura', 649.0000, 'ºC'),
	(322816, 145, '2015-01-15 00:24:41.000000', 'temperatura', 1029.0000, 'ºC'),
	(322817, 145, '2015-01-15 00:24:42.000000', 'temperatura', 797.0000, 'ºC'),
	(322818, 145, '2015-01-15 00:24:43.000000', 'temperatura', 899.0000, 'ºC'),
	(322819, 145, '2015-01-15 00:24:44.000000', 'temperatura', 902.0000, 'ºC'),
	(322820, 145, '2015-01-15 00:24:45.000000', 'temperatura', 616.0000, 'ºC'),
	(322821, 145, '2015-01-15 00:24:46.000000', 'temperatura', 373.0000, 'ºC'),
	(322822, 145, '2015-01-15 00:24:47.000000', 'temperatura', 20.0000, 'ºC'),
	(322823, 145, '2015-01-15 00:24:48.000000', 'temperatura', 178.0000, 'ºC'),
	(322824, 145, '2015-01-15 00:24:49.000000', 'temperatura', 832.0000, 'ºC'),
	(322825, 145, '2015-01-15 00:24:50.000000', 'temperatura', 27.0000, 'ºC'),
	(322826, 145, '2015-01-15 00:24:51.000000', 'temperatura', 38.0000, 'ºC'),
	(322827, 145, '2015-01-15 00:24:52.000000', 'temperatura', 109.0000, 'ºC'),
	(322828, 145, '2015-01-15 00:24:53.000000', 'temperatura', 431.0000, 'ºC'),
	(322829, 145, '2015-01-15 00:24:54.000000', 'temperatura', 630.0000, 'ºC'),
	(322830, 145, '2015-01-15 00:24:55.000000', 'temperatura', 655.0000, 'ºC'),
	(322831, 145, '2015-01-15 00:24:56.000000', 'temperatura', 188.0000, 'ºC'),
	(322832, 145, '2015-01-15 00:24:57.000000', 'temperatura', 177.0000, 'ºC'),
	(322833, 145, '2015-01-15 00:24:58.000000', 'temperatura', 320.0000, 'ºC'),
	(322834, 145, '2015-01-15 00:24:59.000000', 'temperatura', 1068.0000, 'ºC'),
	(322835, 145, '2015-01-15 00:25:00.000000', 'temperatura', 783.0000, 'ºC'),
	(322836, 145, '2015-01-15 00:25:01.000000', 'temperatura', 710.0000, 'ºC'),
	(322837, 145, '2015-01-15 00:25:02.000000', 'temperatura', 2.0000, 'ºC'),
	(322838, 145, '2015-01-15 00:25:03.000000', 'temperatura', 281.0000, 'ºC'),
	(322839, 145, '2015-01-15 00:25:04.000000', 'temperatura', 198.0000, 'ºC'),
	(322840, 145, '2015-01-15 00:25:05.000000', 'temperatura', 150.0000, 'ºC'),
	(322841, 145, '2015-01-15 00:25:06.000000', 'temperatura', 157.0000, 'ºC'),
	(322842, 145, '2015-01-15 00:25:07.000000', 'temperatura', 333.0000, 'ºC'),
	(322843, 145, '2015-01-15 00:25:08.000000', 'temperatura', 1195.0000, 'ºC'),
	(322844, 145, '2015-01-15 00:25:09.000000', 'temperatura', 178.0000, 'ºC'),
	(322845, 145, '2015-01-15 00:25:10.000000', 'temperatura', 905.0000, 'ºC'),
	(322846, 145, '2015-01-15 00:25:11.000000', 'temperatura', 391.0000, 'ºC'),
	(322847, 145, '2015-01-15 00:25:12.000000', 'temperatura', 440.0000, 'ºC'),
	(322848, 145, '2015-01-15 00:25:13.000000', 'temperatura', 1027.0000, 'ºC'),
	(322849, 145, '2015-01-15 00:25:14.000000', 'temperatura', 214.0000, 'ºC'),
	(322850, 145, '2015-01-15 00:25:15.000000', 'temperatura', 391.0000, 'ºC'),
	(322851, 145, '2015-01-15 00:25:16.000000', 'temperatura', 115.0000, 'ºC'),
	(322852, 145, '2015-01-15 00:25:17.000000', 'temperatura', 603.0000, 'ºC'),
	(322853, 145, '2015-01-15 00:25:18.000000', 'temperatura', 267.0000, 'ºC'),
	(322854, 145, '2015-01-15 00:25:19.000000', 'temperatura', 730.0000, 'ºC'),
	(322855, 145, '2015-01-15 00:25:20.000000', 'temperatura', 447.0000, 'ºC'),
	(322856, 145, '2015-01-15 00:25:21.000000', 'temperatura', 44.0000, 'ºC'),
	(322857, 145, '2015-01-15 00:25:22.000000', 'temperatura', 82.0000, 'ºC'),
	(322858, 145, '2015-01-15 00:25:23.000000', 'temperatura', 279.0000, 'ºC'),
	(322859, 145, '2015-01-15 00:25:24.000000', 'temperatura', 1151.0000, 'ºC'),
	(322860, 145, '2015-01-15 00:25:25.000000', 'temperatura', 116.0000, 'ºC'),
	(322861, 145, '2015-01-15 00:25:26.000000', 'temperatura', 729.0000, 'ºC'),
	(322862, 145, '2015-01-15 00:25:27.000000', 'temperatura', 899.0000, 'ºC'),
	(322863, 145, '2015-01-15 00:25:28.000000', 'temperatura', 1106.0000, 'ºC'),
	(322864, 145, '2015-01-15 00:25:29.000000', 'temperatura', 436.0000, 'ºC'),
	(322865, 145, '2015-01-15 00:25:30.000000', 'temperatura', 62.0000, 'ºC'),
	(322866, 145, '2015-01-15 00:25:31.000000', 'temperatura', 203.0000, 'ºC'),
	(322867, 145, '2015-01-15 00:25:32.000000', 'temperatura', 829.0000, 'ºC'),
	(322868, 145, '2015-01-15 00:25:33.000000', 'temperatura', 1134.0000, 'ºC'),
	(322869, 145, '2015-01-15 00:25:34.000000', 'temperatura', 787.0000, 'ºC'),
	(322870, 145, '2015-01-15 00:25:35.000000', 'temperatura', 532.0000, 'ºC'),
	(322871, 145, '2015-01-15 00:25:36.000000', 'temperatura', 298.0000, 'ºC'),
	(322872, 145, '2015-01-15 00:25:37.000000', 'temperatura', 1096.0000, 'ºC'),
	(322873, 145, '2015-01-15 00:25:38.000000', 'temperatura', 985.0000, 'ºC'),
	(322874, 145, '2015-01-15 00:25:39.000000', 'temperatura', 438.0000, 'ºC'),
	(322875, 145, '2015-01-15 00:25:40.000000', 'temperatura', 434.0000, 'ºC'),
	(322876, 145, '2015-01-15 00:25:41.000000', 'temperatura', 859.0000, 'ºC'),
	(322877, 145, '2015-01-15 00:25:42.000000', 'temperatura', 593.0000, 'ºC'),
	(322878, 145, '2015-01-15 00:25:43.000000', 'temperatura', 387.0000, 'ºC'),
	(322879, 145, '2015-01-15 00:25:44.000000', 'temperatura', 157.0000, 'ºC'),
	(322880, 145, '2015-01-15 00:25:45.000000', 'temperatura', 823.0000, 'ºC'),
	(322881, 145, '2015-01-15 00:25:46.000000', 'temperatura', 44.0000, 'ºC'),
	(322882, 145, '2015-01-15 00:25:47.000000', 'temperatura', 153.0000, 'ºC'),
	(322883, 145, '2015-01-15 00:25:48.000000', 'temperatura', 633.0000, 'ºC'),
	(322884, 145, '2015-01-15 00:25:49.000000', 'temperatura', 308.0000, 'ºC'),
	(322885, 145, '2015-01-15 00:25:50.000000', 'temperatura', 839.0000, 'ºC'),
	(322886, 145, '2015-01-15 00:25:51.000000', 'temperatura', 872.0000, 'ºC'),
	(322887, 145, '2015-01-15 00:25:52.000000', 'temperatura', 642.0000, 'ºC'),
	(322888, 145, '2015-01-15 00:25:53.000000', 'temperatura', 598.0000, 'ºC'),
	(322889, 145, '2015-01-15 00:25:54.000000', 'temperatura', 1061.0000, 'ºC'),
	(322890, 145, '2015-01-15 00:25:55.000000', 'temperatura', 1115.0000, 'ºC'),
	(322891, 145, '2015-01-15 00:25:56.000000', 'temperatura', 1190.0000, 'ºC'),
	(322892, 145, '2015-01-15 00:25:57.000000', 'temperatura', 206.0000, 'ºC'),
	(322893, 145, '2015-01-15 00:25:58.000000', 'temperatura', 1059.0000, 'ºC'),
	(322894, 145, '2015-01-15 00:25:59.000000', 'temperatura', 1077.0000, 'ºC'),
	(322895, 145, '2015-01-15 00:26:00.000000', 'temperatura', 1009.0000, 'ºC'),
	(322896, 145, '2015-01-15 00:26:01.000000', 'temperatura', 615.0000, 'ºC'),
	(322897, 145, '2015-01-15 00:26:02.000000', 'temperatura', 50.0000, 'ºC'),
	(322898, 145, '2015-01-15 00:26:03.000000', 'temperatura', 804.0000, 'ºC'),
	(322899, 145, '2015-01-15 00:26:04.000000', 'temperatura', 269.0000, 'ºC'),
	(322900, 145, '2015-01-15 00:26:05.000000', 'temperatura', 137.0000, 'ºC'),
	(322901, 145, '2015-01-15 00:26:06.000000', 'temperatura', 1075.0000, 'ºC'),
	(322902, 145, '2015-01-15 00:26:07.000000', 'temperatura', 166.0000, 'ºC'),
	(322903, 145, '2015-01-15 00:26:08.000000', 'temperatura', 5.0000, 'ºC'),
	(322904, 145, '2015-01-15 00:26:09.000000', 'temperatura', 728.0000, 'ºC'),
	(322905, 145, '2015-01-15 00:26:10.000000', 'temperatura', 25.0000, 'ºC'),
	(322906, 145, '2015-01-15 00:26:11.000000', 'temperatura', 341.0000, 'ºC'),
	(322907, 145, '2015-01-15 00:26:12.000000', 'temperatura', 433.0000, 'ºC'),
	(322908, 145, '2015-01-15 00:26:13.000000', 'temperatura', 1141.0000, 'ºC'),
	(322909, 145, '2015-01-15 00:26:14.000000', 'temperatura', 805.0000, 'ºC'),
	(322910, 145, '2015-01-15 00:26:15.000000', 'temperatura', 606.0000, 'ºC'),
	(322911, 145, '2015-01-15 00:26:16.000000', 'temperatura', 612.0000, 'ºC'),
	(322912, 145, '2015-01-15 00:26:17.000000', 'temperatura', 43.0000, 'ºC'),
	(322913, 145, '2015-01-15 00:26:18.000000', 'temperatura', 782.0000, 'ºC'),
	(322914, 145, '2015-01-15 00:26:19.000000', 'temperatura', 181.0000, 'ºC'),
	(322915, 145, '2015-01-15 00:26:20.000000', 'temperatura', 958.0000, 'ºC'),
	(322916, 145, '2015-01-15 00:26:21.000000', 'temperatura', 647.0000, 'ºC'),
	(322917, 145, '2015-01-15 00:26:22.000000', 'temperatura', 364.0000, 'ºC'),
	(322918, 145, '2015-01-15 00:26:23.000000', 'temperatura', 1079.0000, 'ºC'),
	(322919, 145, '2015-01-15 00:26:24.000000', 'temperatura', 704.0000, 'ºC'),
	(322920, 145, '2015-01-15 00:26:25.000000', 'temperatura', 281.0000, 'ºC'),
	(322921, 145, '2015-01-15 00:26:26.000000', 'temperatura', 497.0000, 'ºC'),
	(322922, 145, '2015-01-15 00:26:27.000000', 'temperatura', 440.0000, 'ºC'),
	(322923, 145, '2015-01-15 00:26:28.000000', 'temperatura', 712.0000, 'ºC'),
	(322924, 145, '2015-01-15 00:26:29.000000', 'temperatura', 1037.0000, 'ºC'),
	(322925, 145, '2015-01-15 00:26:30.000000', 'temperatura', 651.0000, 'ºC'),
	(322926, 145, '2015-01-15 00:26:31.000000', 'temperatura', 146.0000, 'ºC'),
	(322927, 145, '2015-01-15 00:26:32.000000', 'temperatura', 1177.0000, 'ºC'),
	(322928, 145, '2015-01-15 00:26:33.000000', 'temperatura', 649.0000, 'ºC'),
	(322929, 145, '2015-01-15 00:26:34.000000', 'temperatura', 912.0000, 'ºC'),
	(322930, 145, '2015-01-15 00:26:35.000000', 'temperatura', 216.0000, 'ºC'),
	(322931, 145, '2015-01-15 00:26:36.000000', 'temperatura', 742.0000, 'ºC'),
	(322932, 145, '2015-01-15 00:26:37.000000', 'temperatura', 663.0000, 'ºC'),
	(322933, 145, '2015-01-15 00:26:38.000000', 'temperatura', 1088.0000, 'ºC'),
	(322934, 145, '2015-01-15 00:26:39.000000', 'temperatura', 1054.0000, 'ºC'),
	(322935, 145, '2015-01-15 00:26:40.000000', 'temperatura', 804.0000, 'ºC'),
	(322936, 145, '2015-01-15 00:26:41.000000', 'temperatura', 859.0000, 'ºC'),
	(322937, 145, '2015-01-15 00:26:42.000000', 'temperatura', 683.0000, 'ºC'),
	(322938, 145, '2015-01-15 00:26:43.000000', 'temperatura', 841.0000, 'ºC'),
	(322939, 145, '2015-01-15 00:26:44.000000', 'temperatura', 954.0000, 'ºC'),
	(322940, 145, '2015-01-15 00:26:45.000000', 'temperatura', 1049.0000, 'ºC'),
	(322941, 145, '2015-01-15 00:26:46.000000', 'temperatura', 1185.0000, 'ºC'),
	(322942, 145, '2015-01-15 00:26:47.000000', 'temperatura', 376.0000, 'ºC'),
	(322943, 145, '2015-01-15 00:26:48.000000', 'temperatura', 726.0000, 'ºC'),
	(322944, 145, '2015-01-15 00:26:49.000000', 'temperatura', 102.0000, 'ºC'),
	(322945, 145, '2015-01-15 00:26:50.000000', 'temperatura', 735.0000, 'ºC'),
	(322946, 145, '2015-01-15 00:26:51.000000', 'temperatura', 967.0000, 'ºC'),
	(322947, 145, '2015-01-15 00:26:52.000000', 'temperatura', 233.0000, 'ºC'),
	(322948, 145, '2015-01-15 00:26:53.000000', 'temperatura', 662.0000, 'ºC'),
	(322949, 145, '2015-01-15 00:26:54.000000', 'temperatura', 214.0000, 'ºC'),
	(322950, 145, '2015-01-15 00:26:55.000000', 'temperatura', 285.0000, 'ºC'),
	(322951, 145, '2015-01-15 00:26:56.000000', 'temperatura', 784.0000, 'ºC'),
	(322952, 145, '2015-01-15 00:26:57.000000', 'temperatura', 663.0000, 'ºC'),
	(322953, 145, '2015-01-15 00:26:58.000000', 'temperatura', 965.0000, 'ºC'),
	(322954, 145, '2015-01-15 00:26:59.000000', 'temperatura', 435.0000, 'ºC'),
	(322955, 145, '2015-01-15 00:27:00.000000', 'temperatura', 480.0000, 'ºC'),
	(322956, 145, '2015-01-15 00:27:01.000000', 'temperatura', 1095.0000, 'ºC'),
	(322957, 145, '2015-01-15 00:27:02.000000', 'temperatura', 438.0000, 'ºC'),
	(322958, 145, '2015-01-15 00:27:03.000000', 'temperatura', 106.0000, 'ºC'),
	(322959, 145, '2015-01-15 00:27:04.000000', 'temperatura', 416.0000, 'ºC'),
	(322960, 145, '2015-01-15 00:27:05.000000', 'temperatura', 563.0000, 'ºC'),
	(322961, 145, '2015-01-15 00:27:06.000000', 'temperatura', 368.0000, 'ºC'),
	(322962, 145, '2015-01-15 00:27:07.000000', 'temperatura', 149.0000, 'ºC'),
	(322963, 145, '2015-01-15 00:27:08.000000', 'temperatura', 843.0000, 'ºC'),
	(322964, 145, '2015-01-15 00:27:09.000000', 'temperatura', 168.0000, 'ºC'),
	(322965, 145, '2015-01-15 00:27:10.000000', 'temperatura', 714.0000, 'ºC'),
	(322966, 145, '2015-01-15 00:27:11.000000', 'temperatura', 664.0000, 'ºC'),
	(322967, 145, '2015-01-15 00:27:12.000000', 'temperatura', 1178.0000, 'ºC'),
	(322968, 145, '2015-01-15 00:27:13.000000', 'temperatura', 300.0000, 'ºC'),
	(322969, 145, '2015-01-15 00:27:14.000000', 'temperatura', 364.0000, 'ºC'),
	(322970, 145, '2015-01-15 00:27:15.000000', 'temperatura', 922.0000, 'ºC'),
	(322971, 145, '2015-01-15 00:27:16.000000', 'temperatura', 1118.0000, 'ºC'),
	(322972, 145, '2015-01-15 00:27:17.000000', 'temperatura', 425.0000, 'ºC'),
	(322973, 145, '2015-01-15 00:27:18.000000', 'temperatura', 1173.0000, 'ºC'),
	(322974, 145, '2015-01-15 00:27:19.000000', 'temperatura', 988.0000, 'ºC'),
	(322975, 145, '2015-01-15 00:27:20.000000', 'temperatura', 224.0000, 'ºC'),
	(322976, 145, '2015-01-15 00:27:21.000000', 'temperatura', 554.0000, 'ºC'),
	(322977, 145, '2015-01-15 00:27:22.000000', 'temperatura', 898.0000, 'ºC'),
	(322978, 145, '2015-01-15 00:27:23.000000', 'temperatura', 430.0000, 'ºC'),
	(322979, 145, '2015-01-15 00:27:24.000000', 'temperatura', 656.0000, 'ºC'),
	(322980, 145, '2015-01-15 00:27:25.000000', 'temperatura', 789.0000, 'ºC'),
	(322981, 145, '2015-01-15 00:27:26.000000', 'temperatura', 777.0000, 'ºC'),
	(322982, 145, '2015-01-15 00:27:27.000000', 'temperatura', 318.0000, 'ºC'),
	(322983, 145, '2015-01-15 00:27:28.000000', 'temperatura', 460.0000, 'ºC'),
	(322984, 145, '2015-01-15 00:27:29.000000', 'temperatura', 147.0000, 'ºC'),
	(322985, 145, '2015-01-15 00:27:30.000000', 'temperatura', 555.0000, 'ºC'),
	(322986, 145, '2015-01-15 00:27:31.000000', 'temperatura', 1136.0000, 'ºC'),
	(322987, 145, '2015-01-15 00:27:32.000000', 'temperatura', 416.0000, 'ºC'),
	(322988, 145, '2015-01-15 00:27:33.000000', 'temperatura', 1071.0000, 'ºC'),
	(322989, 145, '2015-01-15 00:27:34.000000', 'temperatura', 507.0000, 'ºC'),
	(322990, 145, '2015-01-15 00:27:35.000000', 'temperatura', 525.0000, 'ºC'),
	(322991, 145, '2015-01-15 00:27:36.000000', 'temperatura', 1103.0000, 'ºC'),
	(322992, 145, '2015-01-15 00:27:37.000000', 'temperatura', 342.0000, 'ºC'),
	(322993, 145, '2015-01-15 00:27:38.000000', 'temperatura', 800.0000, 'ºC'),
	(322994, 145, '2015-01-15 00:27:39.000000', 'temperatura', 576.0000, 'ºC'),
	(322995, 145, '2015-01-15 00:27:40.000000', 'temperatura', 478.0000, 'ºC'),
	(322996, 145, '2015-01-15 00:27:41.000000', 'temperatura', 665.0000, 'ºC'),
	(322997, 145, '2015-01-15 00:27:42.000000', 'temperatura', 690.0000, 'ºC'),
	(322998, 145, '2015-01-15 00:27:43.000000', 'temperatura', 257.0000, 'ºC'),
	(322999, 145, '2015-01-15 00:27:44.000000', 'temperatura', 415.0000, 'ºC'),
	(323000, 145, '2015-01-15 00:27:45.000000', 'temperatura', 102.0000, 'ºC'),
	(323001, 145, '2015-01-15 00:27:46.000000', 'temperatura', 469.0000, 'ºC'),
	(323002, 145, '2015-01-15 00:27:47.000000', 'temperatura', 839.0000, 'ºC'),
	(323003, 145, '2015-01-15 00:27:48.000000', 'temperatura', 386.0000, 'ºC'),
	(323004, 145, '2015-01-15 00:27:49.000000', 'temperatura', 615.0000, 'ºC'),
	(323005, 145, '2015-01-15 00:27:50.000000', 'temperatura', 716.0000, 'ºC'),
	(323006, 145, '2015-01-15 00:27:51.000000', 'temperatura', 537.0000, 'ºC'),
	(323007, 145, '2015-01-15 00:27:52.000000', 'temperatura', 537.0000, 'ºC'),
	(323008, 145, '2015-01-15 00:27:53.000000', 'temperatura', 1073.0000, 'ºC'),
	(323009, 145, '2015-01-15 00:27:54.000000', 'temperatura', 154.0000, 'ºC'),
	(323010, 145, '2015-01-15 00:27:55.000000', 'temperatura', 1154.0000, 'ºC'),
	(323011, 145, '2015-01-15 00:27:56.000000', 'temperatura', 507.0000, 'ºC'),
	(323012, 145, '2015-01-15 00:27:57.000000', 'temperatura', 273.0000, 'ºC'),
	(323013, 145, '2015-01-15 00:27:58.000000', 'temperatura', 1047.0000, 'ºC'),
	(323014, 145, '2015-01-15 00:27:59.000000', 'temperatura', 815.0000, 'ºC'),
	(323015, 145, '2015-01-15 00:28:00.000000', 'temperatura', 935.0000, 'ºC'),
	(323016, 145, '2015-01-15 00:28:01.000000', 'temperatura', 1028.0000, 'ºC'),
	(323017, 145, '2015-01-15 00:28:02.000000', 'temperatura', 1139.0000, 'ºC'),
	(323018, 145, '2015-01-15 00:28:03.000000', 'temperatura', 208.0000, 'ºC'),
	(323019, 145, '2015-01-15 00:28:04.000000', 'temperatura', 26.0000, 'ºC'),
	(323020, 145, '2015-01-15 00:28:05.000000', 'temperatura', 705.0000, 'ºC'),
	(323021, 145, '2015-01-15 00:28:06.000000', 'temperatura', 1047.0000, 'ºC'),
	(323022, 145, '2015-01-15 00:28:07.000000', 'temperatura', 720.0000, 'ºC'),
	(323023, 145, '2015-01-15 00:28:08.000000', 'temperatura', 461.0000, 'ºC'),
	(323024, 145, '2015-01-15 00:28:09.000000', 'temperatura', 145.0000, 'ºC'),
	(323025, 145, '2015-01-15 00:28:10.000000', 'temperatura', 541.0000, 'ºC'),
	(323026, 145, '2015-01-15 00:28:11.000000', 'temperatura', 1073.0000, 'ºC'),
	(323027, 145, '2015-01-15 00:28:12.000000', 'temperatura', 142.0000, 'ºC'),
	(323028, 145, '2015-01-15 00:28:13.000000', 'temperatura', 1089.0000, 'ºC'),
	(323029, 145, '2015-01-15 00:28:14.000000', 'temperatura', 222.0000, 'ºC'),
	(323030, 145, '2015-01-15 00:28:15.000000', 'temperatura', 243.0000, 'ºC'),
	(323031, 145, '2015-01-15 00:28:16.000000', 'temperatura', 550.0000, 'ºC'),
	(323032, 145, '2015-01-15 00:28:17.000000', 'temperatura', 820.0000, 'ºC'),
	(323033, 145, '2015-01-15 00:28:18.000000', 'temperatura', 53.0000, 'ºC'),
	(323034, 145, '2015-01-15 00:28:19.000000', 'temperatura', 206.0000, 'ºC'),
	(323035, 145, '2015-01-15 00:28:20.000000', 'temperatura', 870.0000, 'ºC'),
	(323036, 145, '2015-01-15 00:28:21.000000', 'temperatura', 132.0000, 'ºC'),
	(323037, 145, '2015-01-15 00:28:22.000000', 'temperatura', 451.0000, 'ºC'),
	(323038, 145, '2015-01-15 00:28:23.000000', 'temperatura', 660.0000, 'ºC'),
	(323039, 145, '2015-01-15 00:28:24.000000', 'temperatura', 745.0000, 'ºC'),
	(323040, 145, '2015-01-15 00:28:25.000000', 'temperatura', 547.0000, 'ºC'),
	(323041, 145, '2015-01-15 00:28:26.000000', 'temperatura', 502.0000, 'ºC'),
	(323042, 145, '2015-01-15 00:28:27.000000', 'temperatura', 867.0000, 'ºC'),
	(323043, 145, '2015-01-15 00:28:28.000000', 'temperatura', 430.0000, 'ºC'),
	(323044, 145, '2015-01-15 00:28:29.000000', 'temperatura', 749.0000, 'ºC'),
	(323045, 145, '2015-01-15 00:28:30.000000', 'temperatura', 54.0000, 'ºC'),
	(323046, 145, '2015-01-15 00:28:31.000000', 'temperatura', 426.0000, 'ºC'),
	(323047, 145, '2015-01-15 00:28:32.000000', 'temperatura', 766.0000, 'ºC'),
	(323048, 145, '2015-01-15 00:28:33.000000', 'temperatura', 154.0000, 'ºC'),
	(323049, 145, '2015-01-15 00:28:34.000000', 'temperatura', 873.0000, 'ºC'),
	(323050, 145, '2015-01-15 00:28:35.000000', 'temperatura', 304.0000, 'ºC'),
	(323051, 145, '2015-01-15 00:28:36.000000', 'temperatura', 99.0000, 'ºC'),
	(323052, 145, '2015-01-15 00:28:37.000000', 'temperatura', 785.0000, 'ºC'),
	(323053, 145, '2015-01-15 00:28:38.000000', 'temperatura', 28.0000, 'ºC'),
	(323054, 145, '2015-01-15 00:28:39.000000', 'temperatura', 185.0000, 'ºC'),
	(323055, 145, '2015-01-15 00:28:40.000000', 'temperatura', 841.0000, 'ºC'),
	(323056, 145, '2015-01-15 00:28:41.000000', 'temperatura', 51.0000, 'ºC'),
	(323057, 145, '2015-01-15 00:28:42.000000', 'temperatura', 134.0000, 'ºC'),
	(323058, 145, '2015-01-15 00:28:43.000000', 'temperatura', 516.0000, 'ºC'),
	(323059, 145, '2015-01-15 00:28:44.000000', 'temperatura', 980.0000, 'ºC'),
	(323060, 145, '2015-01-15 00:28:45.000000', 'temperatura', 951.0000, 'ºC'),
	(323061, 145, '2015-01-15 00:28:46.000000', 'temperatura', 615.0000, 'ºC'),
	(323062, 145, '2015-01-15 00:28:47.000000', 'temperatura', 222.0000, 'ºC'),
	(323063, 145, '2015-01-15 00:28:48.000000', 'temperatura', 466.0000, 'ºC'),
	(323064, 145, '2015-01-15 00:28:49.000000', 'temperatura', 463.0000, 'ºC'),
	(323065, 145, '2015-01-15 00:28:50.000000', 'temperatura', 920.0000, 'ºC'),
	(323066, 145, '2015-01-15 00:28:51.000000', 'temperatura', 809.0000, 'ºC'),
	(323067, 145, '2015-01-15 00:28:52.000000', 'temperatura', 87.0000, 'ºC'),
	(323068, 145, '2015-01-15 00:28:53.000000', 'temperatura', 406.0000, 'ºC'),
	(323069, 145, '2015-01-15 00:28:54.000000', 'temperatura', 572.0000, 'ºC'),
	(323070, 145, '2015-01-15 00:28:55.000000', 'temperatura', 441.0000, 'ºC'),
	(323071, 145, '2015-01-15 00:28:56.000000', 'temperatura', 489.0000, 'ºC'),
	(323072, 145, '2015-01-15 00:28:57.000000', 'temperatura', 1123.0000, 'ºC'),
	(323073, 145, '2015-01-15 00:28:58.000000', 'temperatura', 550.0000, 'ºC'),
	(323074, 145, '2015-01-15 00:28:59.000000', 'temperatura', 581.0000, 'ºC'),
	(323075, 145, '2015-01-15 00:29:00.000000', 'temperatura', 55.0000, 'ºC'),
	(323076, 145, '2015-01-15 00:29:01.000000', 'temperatura', 931.0000, 'ºC'),
	(323077, 145, '2015-01-15 00:29:02.000000', 'temperatura', 891.0000, 'ºC'),
	(323078, 145, '2015-01-15 00:29:03.000000', 'temperatura', 461.0000, 'ºC'),
	(323079, 145, '2015-01-15 00:29:04.000000', 'temperatura', 834.0000, 'ºC'),
	(323080, 145, '2015-01-15 00:29:05.000000', 'temperatura', 389.0000, 'ºC'),
	(323081, 145, '2015-01-15 00:29:06.000000', 'temperatura', 641.0000, 'ºC'),
	(323082, 145, '2015-01-15 00:29:07.000000', 'temperatura', 838.0000, 'ºC'),
	(323083, 145, '2015-01-15 00:29:08.000000', 'temperatura', 1067.0000, 'ºC'),
	(323084, 145, '2015-01-15 00:29:09.000000', 'temperatura', 422.0000, 'ºC'),
	(323085, 145, '2015-01-15 00:29:10.000000', 'temperatura', 109.0000, 'ºC'),
	(323086, 145, '2015-01-15 00:29:11.000000', 'temperatura', 478.0000, 'ºC'),
	(323087, 145, '2015-01-15 00:29:12.000000', 'temperatura', 866.0000, 'ºC'),
	(323088, 145, '2015-01-15 00:29:13.000000', 'temperatura', 495.0000, 'ºC'),
	(323089, 145, '2015-01-15 00:29:14.000000', 'temperatura', 1078.0000, 'ºC'),
	(323090, 145, '2015-01-15 00:29:15.000000', 'temperatura', 307.0000, 'ºC'),
	(323091, 145, '2015-01-15 00:29:16.000000', 'temperatura', 701.0000, 'ºC'),
	(323092, 145, '2015-01-15 00:29:17.000000', 'temperatura', 182.0000, 'ºC'),
	(323093, 145, '2015-01-15 00:29:18.000000', 'temperatura', 11.0000, 'ºC'),
	(323094, 145, '2015-01-15 00:29:19.000000', 'temperatura', 708.0000, 'ºC'),
	(323095, 145, '2015-01-15 00:29:20.000000', 'temperatura', 1108.0000, 'ºC'),
	(323096, 145, '2015-01-15 00:29:21.000000', 'temperatura', 1015.0000, 'ºC'),
	(323097, 145, '2015-01-15 00:29:22.000000', 'temperatura', 554.0000, 'ºC'),
	(323098, 145, '2015-01-15 00:29:23.000000', 'temperatura', 924.0000, 'ºC'),
	(323099, 145, '2015-01-15 00:29:24.000000', 'temperatura', 558.0000, 'ºC'),
	(323100, 145, '2015-01-15 00:29:25.000000', 'temperatura', 17.0000, 'ºC'),
	(323101, 145, '2015-01-15 00:29:26.000000', 'temperatura', 813.0000, 'ºC'),
	(323102, 145, '2015-01-15 00:29:27.000000', 'temperatura', 415.0000, 'ºC'),
	(323103, 145, '2015-01-15 00:29:28.000000', 'temperatura', 836.0000, 'ºC'),
	(323104, 145, '2015-01-15 00:29:29.000000', 'temperatura', 538.0000, 'ºC'),
	(323105, 145, '2015-01-15 00:29:30.000000', 'temperatura', 179.0000, 'ºC'),
	(323106, 145, '2015-01-15 00:29:31.000000', 'temperatura', 484.0000, 'ºC'),
	(323107, 145, '2015-01-15 00:29:32.000000', 'temperatura', 684.0000, 'ºC'),
	(323108, 145, '2015-01-15 00:29:33.000000', 'temperatura', 767.0000, 'ºC'),
	(323109, 145, '2015-01-15 00:29:34.000000', 'temperatura', 582.0000, 'ºC'),
	(323110, 145, '2015-01-15 00:29:35.000000', 'temperatura', 612.0000, 'ºC'),
	(323111, 145, '2015-01-15 00:29:36.000000', 'temperatura', 112.0000, 'ºC'),
	(323112, 145, '2015-01-15 00:29:37.000000', 'temperatura', 1126.0000, 'ºC'),
	(323113, 145, '2015-01-15 00:29:38.000000', 'temperatura', 492.0000, 'ºC'),
	(323114, 145, '2015-01-15 00:29:39.000000', 'temperatura', 285.0000, 'ºC'),
	(323115, 145, '2015-01-15 00:29:40.000000', 'temperatura', 1149.0000, 'ºC'),
	(323116, 145, '2015-01-15 00:29:41.000000', 'temperatura', 92.0000, 'ºC'),
	(323117, 145, '2015-01-15 00:29:42.000000', 'temperatura', 613.0000, 'ºC'),
	(323118, 145, '2015-01-15 00:29:43.000000', 'temperatura', 391.0000, 'ºC'),
	(323119, 145, '2015-01-15 00:29:44.000000', 'temperatura', 116.0000, 'ºC'),
	(323120, 145, '2015-01-15 00:29:45.000000', 'temperatura', 605.0000, 'ºC'),
	(323121, 145, '2015-01-15 00:29:46.000000', 'temperatura', 278.0000, 'ºC'),
	(323122, 145, '2015-01-15 00:29:47.000000', 'temperatura', 775.0000, 'ºC'),
	(323123, 145, '2015-01-15 00:29:48.000000', 'temperatura', 644.0000, 'ºC'),
	(323124, 145, '2015-01-15 00:29:49.000000', 'temperatura', 895.0000, 'ºC'),
	(323125, 145, '2015-01-15 00:29:50.000000', 'temperatura', 142.0000, 'ºC'),
	(323126, 145, '2015-01-15 00:29:51.000000', 'temperatura', 426.0000, 'ºC'),
	(323127, 145, '2015-01-15 00:29:52.000000', 'temperatura', 504.0000, 'ºC'),
	(323128, 145, '2015-01-15 00:29:53.000000', 'temperatura', 42.0000, 'ºC'),
	(323129, 145, '2015-01-15 00:29:54.000000', 'temperatura', 1101.0000, 'ºC'),
	(323130, 145, '2015-01-15 00:29:55.000000', 'temperatura', 578.0000, 'ºC'),
	(323131, 145, '2015-01-15 00:29:56.000000', 'temperatura', 786.0000, 'ºC'),
	(323132, 145, '2015-01-15 00:29:57.000000', 'temperatura', 996.0000, 'ºC'),
	(323133, 145, '2015-01-15 00:29:58.000000', 'temperatura', 223.0000, 'ºC'),
	(323134, 145, '2015-01-15 00:29:59.000000', 'temperatura', 530.0000, 'ºC'),
	(323135, 145, '2015-01-15 00:30:00.000000', 'temperatura', 779.0000, 'ºC'),
	(323136, 145, '2015-01-15 00:30:01.000000', 'temperatura', 1105.0000, 'ºC'),
	(323137, 145, '2015-01-15 00:30:02.000000', 'temperatura', 790.0000, 'ºC'),
	(323138, 145, '2015-01-15 00:30:03.000000', 'temperatura', 636.0000, 'ºC'),
	(323139, 145, '2015-01-15 00:30:04.000000', 'temperatura', 808.0000, 'ºC'),
	(323140, 145, '2015-01-15 00:30:05.000000', 'temperatura', 933.0000, 'ºC'),
	(323141, 145, '2015-01-15 00:30:06.000000', 'temperatura', 1041.0000, 'ºC'),
	(323142, 145, '2015-01-15 00:30:07.000000', 'temperatura', 9.0000, 'ºC'),
	(323143, 145, '2015-01-15 00:30:08.000000', 'temperatura', 521.0000, 'ºC'),
	(323144, 145, '2015-01-15 00:30:09.000000', 'temperatura', 177.0000, 'ºC'),
	(323145, 145, '2015-01-15 00:30:10.000000', 'temperatura', 522.0000, 'ºC'),
	(323146, 145, '2015-01-15 00:30:11.000000', 'temperatura', 882.0000, 'ºC'),
	(323147, 145, '2015-01-15 00:30:12.000000', 'temperatura', 443.0000, 'ºC'),
	(323148, 145, '2015-01-15 00:30:13.000000', 'temperatura', 771.0000, 'ºC'),
	(323149, 145, '2015-01-15 00:30:14.000000', 'temperatura', 127.0000, 'ºC'),
	(323150, 145, '2015-01-15 00:30:15.000000', 'temperatura', 721.0000, 'ºC'),
	(323151, 145, '2015-01-15 00:30:16.000000', 'temperatura', 825.0000, 'ºC'),
	(323152, 145, '2015-01-15 00:30:17.000000', 'temperatura', 764.0000, 'ºC'),
	(323153, 145, '2015-01-15 00:30:18.000000', 'temperatura', 145.0000, 'ºC'),
	(323154, 145, '2015-01-15 00:30:19.000000', 'temperatura', 833.0000, 'ºC'),
	(323155, 145, '2015-01-15 00:30:20.000000', 'temperatura', 132.0000, 'ºC'),
	(323156, 145, '2015-01-15 00:30:21.000000', 'temperatura', 559.0000, 'ºC'),
	(323157, 145, '2015-01-15 00:30:22.000000', 'temperatura', 0.0000, 'ºC'),
	(323158, 145, '2015-01-15 00:30:23.000000', 'temperatura', 725.0000, 'ºC'),
	(323159, 145, '2015-01-15 00:30:24.000000', 'temperatura', 23.0000, 'ºC'),
	(323160, 145, '2015-01-15 00:30:25.000000', 'temperatura', 341.0000, 'ºC'),
	(323161, 145, '2015-01-15 00:30:26.000000', 'temperatura', 435.0000, 'ºC'),
	(323162, 145, '2015-01-15 00:30:27.000000', 'temperatura', 1154.0000, 'ºC'),
	(323163, 145, '2015-01-15 00:30:28.000000', 'temperatura', 865.0000, 'ºC'),
	(323164, 145, '2015-01-15 00:30:29.000000', 'temperatura', 866.0000, 'ºC'),
	(323165, 145, '2015-01-15 00:30:30.000000', 'temperatura', 532.0000, 'ºC'),
	(323166, 145, '2015-01-15 00:30:31.000000', 'temperatura', 65.0000, 'ºC'),
	(323167, 145, '2015-01-15 00:30:32.000000', 'temperatura', 1129.0000, 'ºC'),
	(323168, 145, '2015-01-15 00:30:33.000000', 'temperatura', 652.0000, 'ºC'),
	(323169, 145, '2015-01-15 00:30:34.000000', 'temperatura', 1074.0000, 'ºC'),
	(323170, 145, '2015-01-15 00:30:35.000000', 'temperatura', 1014.0000, 'ºC'),
	(323171, 145, '2015-01-15 00:30:36.000000', 'temperatura', 647.0000, 'ºC'),
	(323172, 145, '2015-01-15 00:30:37.000000', 'temperatura', 192.0000, 'ºC'),
	(323173, 145, '2015-01-15 00:30:38.000000', 'temperatura', 223.0000, 'ºC'),
	(323174, 145, '2015-01-15 00:30:39.000000', 'temperatura', 538.0000, 'ºC'),
	(323175, 145, '2015-01-15 00:30:40.000000', 'temperatura', 821.0000, 'ºC'),
	(323176, 145, '2015-01-15 00:30:41.000000', 'temperatura', 91.0000, 'ºC'),
	(323177, 145, '2015-01-15 00:30:42.000000', 'temperatura', 395.0000, 'ºC'),
	(323178, 145, '2015-01-15 00:30:43.000000', 'temperatura', 500.0000, 'ºC'),
	(323179, 145, '2015-01-15 00:30:44.000000', 'temperatura', 118.0000, 'ºC'),
	(323180, 145, '2015-01-15 00:30:45.000000', 'temperatura', 291.0000, 'ºC'),
	(323181, 145, '2015-01-15 00:30:46.000000', 'temperatura', 1101.0000, 'ºC'),
	(323182, 145, '2015-01-15 00:30:47.000000', 'temperatura', 1034.0000, 'ºC'),
	(323183, 145, '2015-01-15 00:30:48.000000', 'temperatura', 665.0000, 'ºC'),
	(323184, 145, '2015-01-15 00:30:49.000000', 'temperatura', 224.0000, 'ºC'),
	(323185, 145, '2015-01-15 00:30:50.000000', 'temperatura', 328.0000, 'ºC'),
	(323186, 145, '2015-01-15 00:30:51.000000', 'temperatura', 965.0000, 'ºC'),
	(323187, 145, '2015-01-15 00:30:52.000000', 'temperatura', 243.0000, 'ºC'),
	(323188, 145, '2015-01-15 00:30:53.000000', 'temperatura', 719.0000, 'ºC'),
	(323189, 145, '2015-01-15 00:30:54.000000', 'temperatura', 468.0000, 'ºC'),
	(323190, 145, '2015-01-15 00:30:55.000000', 'temperatura', 182.0000, 'ºC'),
	(323191, 145, '2015-01-15 00:30:56.000000', 'temperatura', 708.0000, 'ºC'),
	(323192, 145, '2015-01-15 00:30:57.000000', 'temperatura', 592.0000, 'ºC'),
	(323193, 145, '2015-01-15 00:30:58.000000', 'temperatura', 839.0000, 'ºC'),
	(323194, 145, '2015-01-15 00:30:59.000000', 'temperatura', 21.0000, 'ºC'),
	(323195, 145, '2015-01-15 00:31:00.000000', 'temperatura', 1185.0000, 'ºC'),
	(323196, 145, '2015-01-15 00:31:01.000000', 'temperatura', 1063.0000, 'ºC'),
	(323197, 145, '2015-01-15 00:31:02.000000', 'temperatura', 562.0000, 'ºC'),
	(323198, 145, '2015-01-15 00:31:03.000000', 'temperatura', 820.0000, 'ºC'),
	(323199, 145, '2015-01-15 00:31:04.000000', 'temperatura', 16.0000, 'ºC'),
	(323200, 145, '2015-01-15 00:31:05.000000', 'temperatura', 21.0000, 'ºC'),
	(323201, 145, '2015-01-15 00:31:06.000000', 'temperatura', 57.0000, 'ºC'),
	(323202, 145, '2015-01-15 00:31:07.000000', 'temperatura', 224.0000, 'ºC'),
	(323203, 145, '2015-01-15 00:31:08.000000', 'temperatura', 948.0000, 'ºC'),
	(323204, 145, '2015-01-15 00:31:09.000000', 'temperatura', 467.0000, 'ºC'),
	(323205, 145, '2015-01-15 00:31:10.000000', 'temperatura', 693.0000, 'ºC'),
	(323206, 145, '2015-01-15 00:31:11.000000', 'temperatura', 864.0000, 'ºC'),
	(323207, 145, '2015-01-15 00:31:12.000000', 'temperatura', 1041.0000, 'ºC'),
	(323208, 145, '2015-01-15 00:31:13.000000', 'temperatura', 215.0000, 'ºC'),
	(323209, 145, '2015-01-15 00:31:14.000000', 'temperatura', 351.0000, 'ºC'),
	(323210, 145, '2015-01-15 00:31:15.000000', 'temperatura', 1109.0000, 'ºC'),
	(323211, 145, '2015-01-15 00:31:16.000000', 'temperatura', 895.0000, 'ºC'),
	(323212, 145, '2015-01-15 00:31:17.000000', 'temperatura', 1148.0000, 'ºC'),
	(323213, 145, '2015-01-15 00:31:18.000000', 'temperatura', 657.0000, 'ºC'),
	(323214, 145, '2015-01-15 00:31:19.000000', 'temperatura', 1042.0000, 'ºC'),
	(323215, 145, '2015-01-15 00:31:20.000000', 'temperatura', 838.0000, 'ºC'),
	(323216, 145, '2015-01-15 00:31:21.000000', 'temperatura', 1066.0000, 'ºC'),
	(323217, 145, '2015-01-15 00:31:22.000000', 'temperatura', 417.0000, 'ºC'),
	(323218, 145, '2015-01-15 00:31:23.000000', 'temperatura', 85.0000, 'ºC'),
	(323219, 145, '2015-01-15 00:31:24.000000', 'temperatura', 375.0000, 'ºC'),
	(323220, 145, '2015-01-15 00:31:25.000000', 'temperatura', 421.0000, 'ºC'),
	(323221, 145, '2015-01-15 00:31:26.000000', 'temperatura', 980.0000, 'ºC'),
	(323222, 145, '2015-01-15 00:31:27.000000', 'temperatura', 39.0000, 'ºC'),
	(323223, 145, '2015-01-15 00:31:28.000000', 'temperatura', 856.0000, 'ºC'),
	(323224, 145, '2015-01-15 00:31:29.000000', 'temperatura', 562.0000, 'ºC'),
	(323225, 145, '2015-01-15 00:31:30.000000', 'temperatura', 243.0000, 'ºC'),
	(323226, 145, '2015-01-15 00:31:31.000000', 'temperatura', 729.0000, 'ºC'),
	(323227, 145, '2015-01-15 00:31:32.000000', 'temperatura', 517.0000, 'ºC'),
	(323228, 145, '2015-01-15 00:31:33.000000', 'temperatura', 399.0000, 'ºC'),
	(323229, 145, '2015-01-15 00:31:34.000000', 'temperatura', 444.0000, 'ºC'),
	(323230, 145, '2015-01-15 00:31:35.000000', 'temperatura', 1022.0000, 'ºC'),
	(323231, 145, '2015-01-15 00:31:36.000000', 'temperatura', 181.0000, 'ºC'),
	(323232, 145, '2015-01-15 00:31:37.000000', 'temperatura', 238.0000, 'ºC'),
	(323233, 145, '2015-01-15 00:31:38.000000', 'temperatura', 650.0000, 'ºC'),
	(323234, 145, '2015-01-15 00:31:39.000000', 'temperatura', 135.0000, 'ºC'),
	(323235, 145, '2015-01-15 00:31:40.000000', 'temperatura', 1125.0000, 'ºC'),
	(323236, 145, '2015-01-15 00:31:41.000000', 'temperatura', 421.0000, 'ºC'),
	(323237, 145, '2015-01-15 00:31:42.000000', 'temperatura', 1129.0000, 'ºC'),
	(323238, 145, '2015-01-15 00:31:43.000000', 'temperatura', 784.0000, 'ºC'),
	(323239, 145, '2015-01-15 00:31:44.000000', 'temperatura', 534.0000, 'ºC'),
	(323240, 145, '2015-01-15 00:31:45.000000', 'temperatura', 317.0000, 'ºC'),
	(323241, 145, '2015-01-15 00:31:46.000000', 'temperatura', 1184.0000, 'ºC'),
	(323242, 145, '2015-01-15 00:31:47.000000', 'temperatura', 169.0000, 'ºC'),
	(323243, 145, '2015-01-15 00:31:48.000000', 'temperatura', 895.0000, 'ºC'),
	(323244, 145, '2015-01-15 00:31:49.000000', 'temperatura', 367.0000, 'ºC'),
	(323245, 145, '2015-01-15 00:31:50.000000', 'temperatura', 351.0000, 'ºC'),
	(323246, 145, '2015-01-15 00:31:51.000000', 'temperatura', 654.0000, 'ºC'),
	(323247, 145, '2015-01-15 00:31:52.000000', 'temperatura', 1018.0000, 'ºC'),
	(323248, 145, '2015-01-15 00:31:53.000000', 'temperatura', 729.0000, 'ºC'),
	(323249, 145, '2015-01-15 00:31:54.000000', 'temperatura', 593.0000, 'ºC'),
	(323250, 145, '2015-01-15 00:31:55.000000', 'temperatura', 776.0000, 'ºC'),
	(323251, 145, '2015-01-15 00:31:56.000000', 'temperatura', 902.0000, 'ºC'),
	(323252, 145, '2015-01-15 00:31:57.000000', 'temperatura', 982.0000, 'ºC'),
	(323253, 145, '2015-01-15 00:31:58.000000', 'temperatura', 1005.0000, 'ºC'),
	(323254, 145, '2015-01-15 00:31:59.000000', 'temperatura', 880.0000, 'ºC'),
	(323255, 145, '2015-01-15 00:32:00.000000', 'temperatura', 185.0000, 'ºC'),
	(323256, 145, '2015-01-15 00:32:01.000000', 'temperatura', 684.0000, 'ºC'),
	(323257, 145, '2015-01-15 00:32:02.000000', 'temperatura', 466.0000, 'ºC'),
	(323258, 145, '2015-01-15 00:32:03.000000', 'temperatura', 281.0000, 'ºC'),
	(323259, 145, '2015-01-15 00:32:04.000000', 'temperatura', 5.0000, 'ºC'),
	(323260, 145, '2015-01-15 00:32:05.000000', 'temperatura', 381.0000, 'ºC'),
	(323261, 145, '2015-01-15 00:32:06.000000', 'temperatura', 693.0000, 'ºC'),
	(323262, 145, '2015-01-15 00:32:07.000000', 'temperatura', 1120.0000, 'ºC'),
	(323263, 145, '2015-01-15 00:32:08.000000', 'temperatura', 1123.0000, 'ºC'),
	(323264, 145, '2015-01-15 00:32:09.000000', 'temperatura', 1054.0000, 'ºC'),
	(323265, 145, '2015-01-15 00:32:10.000000', 'temperatura', 700.0000, 'ºC'),
	(323266, 145, '2015-01-15 00:32:11.000000', 'temperatura', 342.0000, 'ºC'),
	(323267, 145, '2015-01-15 00:32:12.000000', 'temperatura', 808.0000, 'ºC'),
	(323268, 145, '2015-01-15 00:32:13.000000', 'temperatura', 617.0000, 'ºC'),
	(323269, 145, '2015-01-15 00:32:14.000000', 'temperatura', 658.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(323270, 145, '2015-01-15 00:32:15.000000', 'temperatura', 242.0000, 'ºC'),
	(323271, 145, '2015-01-15 00:32:16.000000', 'temperatura', 437.0000, 'ºC'),
	(323272, 145, '2015-01-15 00:32:17.000000', 'temperatura', 257.0000, 'ºC'),
	(323273, 145, '2015-01-15 00:32:18.000000', 'temperatura', 1175.0000, 'ºC'),
	(323274, 145, '2015-01-15 00:32:19.000000', 'temperatura', 306.0000, 'ºC'),
	(323275, 145, '2015-01-15 00:32:20.000000', 'temperatura', 406.0000, 'ºC'),
	(323276, 145, '2015-01-15 00:32:21.000000', 'temperatura', 1110.0000, 'ºC'),
	(323277, 145, '2015-01-15 00:32:22.000000', 'temperatura', 732.0000, 'ºC'),
	(323278, 145, '2015-01-15 00:32:23.000000', 'temperatura', 332.0000, 'ºC'),
	(323279, 145, '2015-01-15 00:32:24.000000', 'temperatura', 663.0000, 'ºC'),
	(323280, 145, '2015-01-15 00:32:25.000000', 'temperatura', 1119.0000, 'ºC'),
	(323281, 145, '2015-01-15 00:32:26.000000', 'temperatura', 8.0000, 'ºC'),
	(323282, 145, '2015-01-15 00:32:27.000000', 'temperatura', 285.0000, 'ºC'),
	(323283, 145, '2015-01-15 00:32:28.000000', 'temperatura', 198.0000, 'ºC'),
	(323284, 145, '2015-01-15 00:32:29.000000', 'temperatura', 139.0000, 'ºC'),
	(323285, 145, '2015-01-15 00:32:30.000000', 'temperatura', 99.0000, 'ºC'),
	(323286, 145, '2015-01-15 00:32:31.000000', 'temperatura', 81.0000, 'ºC'),
	(323287, 145, '2015-01-15 00:32:32.000000', 'temperatura', 106.0000, 'ºC'),
	(323288, 145, '2015-01-15 00:32:33.000000', 'temperatura', 290.0000, 'ºC'),
	(323289, 145, '2015-01-15 00:32:34.000000', 'temperatura', 1133.0000, 'ºC'),
	(323290, 145, '2015-01-15 00:32:35.000000', 'temperatura', 1193.0000, 'ºC'),
	(323291, 145, '2015-01-15 00:32:36.000000', 'temperatura', 169.0000, 'ºC'),
	(323292, 145, '2015-01-15 00:32:37.000000', 'temperatura', 865.0000, 'ºC'),
	(323293, 145, '2015-01-15 00:32:38.000000', 'temperatura', 221.0000, 'ºC'),
	(323294, 145, '2015-01-15 00:32:39.000000', 'temperatura', 907.0000, 'ºC'),
	(323295, 145, '2015-01-15 00:32:40.000000', 'temperatura', 275.0000, 'ºC'),
	(323296, 145, '2015-01-15 00:32:41.000000', 'temperatura', 1055.0000, 'ºC'),
	(323297, 145, '2015-01-15 00:32:42.000000', 'temperatura', 848.0000, 'ºC'),
	(323298, 145, '2015-01-15 00:32:43.000000', 'temperatura', 1077.0000, 'ºC'),
	(323299, 145, '2015-01-15 00:32:44.000000', 'temperatura', 443.0000, 'ºC'),
	(323300, 145, '2015-01-15 00:32:45.000000', 'temperatura', 184.0000, 'ºC'),
	(323301, 145, '2015-01-15 00:32:46.000000', 'temperatura', 791.0000, 'ºC'),
	(323302, 145, '2015-01-15 00:32:47.000000', 'temperatura', 1006.0000, 'ºC'),
	(323303, 145, '2015-01-15 00:32:48.000000', 'temperatura', 254.0000, 'ºC'),
	(323304, 145, '2015-01-15 00:32:49.000000', 'temperatura', 654.0000, 'ºC'),
	(323305, 145, '2015-01-15 00:32:50.000000', 'temperatura', 110.0000, 'ºC'),
	(323306, 145, '2015-01-15 00:32:51.000000', 'temperatura', 989.0000, 'ºC'),
	(323307, 145, '2015-01-15 00:32:52.000000', 'temperatura', 1015.0000, 'ºC'),
	(323308, 145, '2015-01-15 00:32:53.000000', 'temperatura', 907.0000, 'ºC'),
	(323309, 145, '2015-01-15 00:32:54.000000', 'temperatura', 290.0000, 'ºC'),
	(323310, 145, '2015-01-15 00:32:55.000000', 'temperatura', 1130.0000, 'ºC'),
	(323311, 145, '2015-01-15 00:32:56.000000', 'temperatura', 1179.0000, 'ºC'),
	(323312, 145, '2015-01-15 00:32:57.000000', 'temperatura', 107.0000, 'ºC'),
	(323313, 145, '2015-01-15 00:32:58.000000', 'temperatura', 596.0000, 'ºC'),
	(323314, 145, '2015-01-15 00:32:59.000000', 'temperatura', 263.0000, 'ºC'),
	(323315, 145, '2015-01-15 00:33:00.000000', 'temperatura', 727.0000, 'ºC'),
	(323316, 145, '2015-01-15 00:33:01.000000', 'temperatura', 446.0000, 'ºC'),
	(323317, 145, '2015-01-15 00:33:02.000000', 'temperatura', 50.0000, 'ºC'),
	(323318, 145, '2015-01-15 00:33:03.000000', 'temperatura', 113.0000, 'ºC'),
	(323319, 145, '2015-01-15 00:33:04.000000', 'temperatura', 415.0000, 'ºC'),
	(323320, 145, '2015-01-15 00:33:05.000000', 'temperatura', 536.0000, 'ºC'),
	(323321, 145, '2015-01-15 00:33:06.000000', 'temperatura', 234.0000, 'ºC'),
	(323322, 145, '2015-01-15 00:33:07.000000', 'temperatura', 765.0000, 'ºC'),
	(323323, 145, '2015-01-15 00:33:08.000000', 'temperatura', 725.0000, 'ºC'),
	(323324, 145, '2015-01-15 00:33:09.000000', 'temperatura', 127.0000, 'ºC'),
	(323325, 145, '2015-01-15 00:33:10.000000', 'temperatura', 863.0000, 'ºC'),
	(323326, 145, '2015-01-15 00:33:11.000000', 'temperatura', 334.0000, 'ºC'),
	(323327, 145, '2015-01-15 00:33:12.000000', 'temperatura', 279.0000, 'ºC'),
	(323328, 145, '2015-01-15 00:33:13.000000', 'temperatura', 396.0000, 'ºC'),
	(323329, 145, '2015-01-15 00:33:14.000000', 'temperatura', 1142.0000, 'ºC'),
	(323330, 145, '2015-01-15 00:33:15.000000', 'temperatura', 924.0000, 'ºC'),
	(323331, 145, '2015-01-15 00:33:16.000000', 'temperatura', 1192.0000, 'ºC'),
	(323332, 145, '2015-01-15 00:33:17.000000', 'temperatura', 790.0000, 'ºC'),
	(323333, 145, '2015-01-15 00:33:18.000000', 'temperatura', 373.0000, 'ºC'),
	(323334, 145, '2015-01-15 00:33:19.000000', 'temperatura', 698.0000, 'ºC'),
	(323335, 145, '2015-01-15 00:33:20.000000', 'temperatura', 1168.0000, 'ºC'),
	(323336, 145, '2015-01-15 00:33:21.000000', 'temperatura', 150.0000, 'ºC'),
	(323337, 145, '2015-01-15 00:33:22.000000', 'temperatura', 844.0000, 'ºC'),
	(323338, 145, '2015-01-15 00:33:23.000000', 'temperatura', 171.0000, 'ºC'),
	(323339, 145, '2015-01-15 00:33:24.000000', 'temperatura', 722.0000, 'ºC'),
	(323340, 145, '2015-01-15 00:33:25.000000', 'temperatura', 698.0000, 'ºC'),
	(323341, 145, '2015-01-15 00:33:26.000000', 'temperatura', 125.0000, 'ºC'),
	(323342, 145, '2015-01-15 00:33:27.000000', 'temperatura', 930.0000, 'ºC'),
	(323343, 145, '2015-01-15 00:33:28.000000', 'temperatura', 675.0000, 'ºC'),
	(323344, 145, '2015-01-15 00:33:29.000000', 'temperatura', 587.0000, 'ºC'),
	(323345, 145, '2015-01-15 00:33:30.000000', 'temperatura', 909.0000, 'ºC'),
	(323346, 145, '2015-01-15 00:33:31.000000', 'temperatura', 385.0000, 'ºC'),
	(323347, 145, '2015-01-15 00:33:32.000000', 'temperatura', 400.0000, 'ºC'),
	(323348, 145, '2015-01-15 00:33:33.000000', 'temperatura', 846.0000, 'ºC'),
	(323349, 145, '2015-01-15 00:33:34.000000', 'temperatura', 631.0000, 'ºC'),
	(323350, 145, '2015-01-15 00:33:35.000000', 'temperatura', 615.0000, 'ºC'),
	(323351, 145, '2015-01-15 00:33:36.000000', 'temperatura', 1185.0000, 'ºC'),
	(323352, 145, '2015-01-15 00:33:37.000000', 'temperatura', 477.0000, 'ºC'),
	(323353, 145, '2015-01-15 00:33:38.000000', 'temperatura', 34.0000, 'ºC'),
	(323354, 145, '2015-01-15 00:33:39.000000', 'temperatura', 1137.0000, 'ºC'),
	(323355, 145, '2015-01-15 00:33:40.000000', 'temperatura', 786.0000, 'ºC'),
	(323356, 145, '2015-01-15 00:33:41.000000', 'temperatura', 519.0000, 'ºC'),
	(323357, 145, '2015-01-15 00:33:42.000000', 'temperatura', 237.0000, 'ºC'),
	(323358, 145, '2015-01-15 00:33:43.000000', 'temperatura', 827.0000, 'ºC'),
	(323359, 145, '2015-01-15 00:33:44.000000', 'temperatura', 1025.0000, 'ºC'),
	(323360, 145, '2015-01-15 00:33:45.000000', 'temperatura', 246.0000, 'ºC'),
	(323361, 145, '2015-01-15 00:33:46.000000', 'temperatura', 553.0000, 'ºC'),
	(323362, 145, '2015-01-15 00:33:47.000000', 'temperatura', 830.0000, 'ºC'),
	(323363, 145, '2015-01-15 00:33:48.000000', 'temperatura', 89.0000, 'ºC'),
	(323364, 145, '2015-01-15 00:33:49.000000', 'temperatura', 358.0000, 'ºC'),
	(323365, 145, '2015-01-15 00:33:50.000000', 'temperatura', 324.0000, 'ºC'),
	(323366, 145, '2015-01-15 00:33:51.000000', 'temperatura', 544.0000, 'ºC'),
	(323367, 145, '2015-01-15 00:33:52.000000', 'temperatura', 551.0000, 'ºC'),
	(323368, 145, '2015-01-15 00:33:53.000000', 'temperatura', 1122.0000, 'ºC'),
	(323369, 145, '2015-01-15 00:33:54.000000', 'temperatura', 360.0000, 'ºC'),
	(323370, 145, '2015-01-15 00:33:55.000000', 'temperatura', 832.0000, 'ºC'),
	(323371, 145, '2015-01-15 00:33:56.000000', 'temperatura', 681.0000, 'ºC'),
	(323372, 145, '2015-01-15 00:33:57.000000', 'temperatura', 912.0000, 'ºC'),
	(323373, 145, '2015-01-15 00:33:58.000000', 'temperatura', 115.0000, 'ºC'),
	(323374, 145, '2015-01-15 00:33:59.000000', 'temperatura', 238.0000, 'ºC'),
	(323375, 145, '2015-01-15 00:34:00.000000', 'temperatura', 847.0000, 'ºC'),
	(323376, 145, '2015-01-15 00:34:01.000000', 'temperatura', 1122.0000, 'ºC'),
	(323377, 145, '2015-01-15 00:34:02.000000', 'temperatura', 668.0000, 'ºC'),
	(323378, 145, '2015-01-15 00:34:03.000000', 'temperatura', 1173.0000, 'ºC'),
	(323379, 145, '2015-01-15 00:34:04.000000', 'temperatura', 264.0000, 'ºC'),
	(323380, 145, '2015-01-15 00:34:05.000000', 'temperatura', 200.0000, 'ºC'),
	(323381, 145, '2015-01-15 00:34:06.000000', 'temperatura', 211.0000, 'ºC'),
	(323382, 145, '2015-01-15 00:34:07.000000', 'temperatura', 454.0000, 'ºC'),
	(323383, 145, '2015-01-15 00:34:08.000000', 'temperatura', 438.0000, 'ºC'),
	(323384, 145, '2015-01-15 00:34:09.000000', 'temperatura', 828.0000, 'ºC'),
	(323385, 145, '2015-01-15 00:34:10.000000', 'temperatura', 426.0000, 'ºC'),
	(323386, 145, '2015-01-15 00:34:11.000000', 'temperatura', 849.0000, 'ºC'),
	(323387, 145, '2015-01-15 00:34:12.000000', 'temperatura', 566.0000, 'ºC'),
	(323388, 145, '2015-01-15 00:34:13.000000', 'temperatura', 285.0000, 'ºC'),
	(323389, 145, '2015-01-15 00:34:14.000000', 'temperatura', 925.0000, 'ºC'),
	(323390, 145, '2015-01-15 00:34:15.000000', 'temperatura', 170.0000, 'ºC'),
	(323391, 145, '2015-01-15 00:34:16.000000', 'temperatura', 478.0000, 'ºC'),
	(323392, 145, '2015-01-15 00:34:17.000000', 'temperatura', 680.0000, 'ºC'),
	(323393, 145, '2015-01-15 00:34:18.000000', 'temperatura', 768.0000, 'ºC'),
	(323394, 145, '2015-01-15 00:34:19.000000', 'temperatura', 597.0000, 'ºC'),
	(323395, 145, '2015-01-15 00:34:20.000000', 'temperatura', 685.0000, 'ºC'),
	(323396, 145, '2015-01-15 00:34:21.000000', 'temperatura', 431.0000, 'ºC'),
	(323397, 145, '2015-01-15 00:34:22.000000', 'temperatura', 104.0000, 'ºC'),
	(323398, 145, '2015-01-15 00:34:23.000000', 'temperatura', 426.0000, 'ºC'),
	(323399, 145, '2015-01-15 00:34:24.000000', 'temperatura', 619.0000, 'ºC'),
	(323400, 145, '2015-01-15 00:34:25.000000', 'temperatura', 617.0000, 'ºC'),
	(323401, 145, '2015-01-15 00:34:26.000000', 'temperatura', 28.0000, 'ºC'),
	(323402, 145, '2015-01-15 00:34:27.000000', 'temperatura', 691.0000, 'ºC'),
	(323403, 145, '2015-01-15 00:34:28.000000', 'temperatura', 970.0000, 'ºC'),
	(323404, 145, '2015-01-15 00:34:29.000000', 'temperatura', 380.0000, 'ºC'),
	(323405, 145, '2015-01-15 00:34:30.000000', 'temperatura', 189.0000, 'ºC'),
	(323406, 145, '2015-01-15 00:34:31.000000', 'temperatura', 1007.0000, 'ºC'),
	(323407, 145, '2015-01-15 00:34:32.000000', 'temperatura', 869.0000, 'ºC'),
	(323408, 145, '2015-01-15 00:34:33.000000', 'temperatura', 124.0000, 'ºC'),
	(323409, 145, '2015-01-15 00:34:34.000000', 'temperatura', 414.0000, 'ºC'),
	(323410, 145, '2015-01-15 00:34:35.000000', 'temperatura', 498.0000, 'ºC'),
	(323411, 145, '2015-01-15 00:34:36.000000', 'temperatura', 48.0000, 'ºC'),
	(323412, 145, '2015-01-15 00:34:37.000000', 'temperatura', 1147.0000, 'ºC'),
	(323413, 145, '2015-01-15 00:34:38.000000', 'temperatura', 792.0000, 'ºC'),
	(323414, 145, '2015-01-15 00:34:39.000000', 'temperatura', 519.0000, 'ºC'),
	(323415, 145, '2015-01-15 00:34:40.000000', 'temperatura', 218.0000, 'ºC'),
	(323416, 145, '2015-01-15 00:34:41.000000', 'temperatura', 736.0000, 'ºC'),
	(323417, 145, '2015-01-15 00:34:42.000000', 'temperatura', 624.0000, 'ºC'),
	(323418, 145, '2015-01-15 00:34:43.000000', 'temperatura', 914.0000, 'ºC'),
	(323419, 145, '2015-01-15 00:34:44.000000', 'temperatura', 296.0000, 'ºC'),
	(323420, 145, '2015-01-15 00:34:45.000000', 'temperatura', 1141.0000, 'ºC'),
	(323421, 145, '2015-01-15 00:34:46.000000', 'temperatura', 16.0000, 'ºC'),
	(323422, 145, '2015-01-15 00:34:47.000000', 'temperatura', 257.0000, 'ºC'),
	(323423, 145, '2015-01-15 00:34:48.000000', 'temperatura', 38.0000, 'ºC'),
	(323424, 145, '2015-01-15 00:34:49.000000', 'temperatura', 619.0000, 'ºC'),
	(323425, 145, '2015-01-15 00:34:50.000000', 'temperatura', 581.0000, 'ºC'),
	(323426, 145, '2015-01-15 00:34:51.000000', 'temperatura', 1050.0000, 'ºC'),
	(323427, 145, '2015-01-15 00:34:52.000000', 'temperatura', 1106.0000, 'ºC'),
	(323428, 145, '2015-01-15 00:34:53.000000', 'temperatura', 1181.0000, 'ºC'),
	(323429, 145, '2015-01-15 00:34:54.000000', 'temperatura', 189.0000, 'ºC'),
	(323430, 145, '2015-01-15 00:34:55.000000', 'temperatura', 1000.0000, 'ºC'),
	(323431, 145, '2015-01-15 00:34:56.000000', 'temperatura', 836.0000, 'ºC'),
	(323432, 145, '2015-01-15 00:34:57.000000', 'temperatura', 1181.0000, 'ºC'),
	(323433, 145, '2015-01-15 00:34:58.000000', 'temperatura', 995.0000, 'ºC'),
	(323434, 145, '2015-01-15 00:34:59.000000', 'temperatura', 232.0000, 'ºC'),
	(323435, 145, '2015-01-15 00:35:00.000000', 'temperatura', 576.0000, 'ºC'),
	(323436, 145, '2015-01-15 00:35:01.000000', 'temperatura', 986.0000, 'ºC'),
	(323437, 145, '2015-01-15 00:35:02.000000', 'temperatura', 800.0000, 'ºC'),
	(323438, 145, '2015-01-15 00:35:03.000000', 'temperatura', 1042.0000, 'ºC'),
	(323439, 145, '2015-01-15 00:35:04.000000', 'temperatura', 413.0000, 'ºC'),
	(323440, 145, '2015-01-15 00:35:05.000000', 'temperatura', 139.0000, 'ºC'),
	(323441, 145, '2015-01-15 00:35:06.000000', 'temperatura', 656.0000, 'ºC'),
	(323442, 145, '2015-01-15 00:35:07.000000', 'temperatura', 465.0000, 'ºC'),
	(323443, 145, '2015-01-15 00:35:08.000000', 'temperatura', 358.0000, 'ºC'),
	(323444, 145, '2015-01-15 00:35:09.000000', 'temperatura', 394.0000, 'ºC'),
	(323445, 145, '2015-01-15 00:35:10.000000', 'temperatura', 898.0000, 'ºC'),
	(323446, 145, '2015-01-15 00:35:11.000000', 'temperatura', 909.0000, 'ºC'),
	(323447, 145, '2015-01-15 00:35:12.000000', 'temperatura', 652.0000, 'ºC'),
	(323448, 145, '2015-01-15 00:35:13.000000', 'temperatura', 531.0000, 'ºC'),
	(323449, 145, '2015-01-15 00:35:14.000000', 'temperatura', 702.0000, 'ºC'),
	(323450, 145, '2015-01-15 00:35:15.000000', 'temperatura', 716.0000, 'ºC'),
	(323451, 145, '2015-01-15 00:35:16.000000', 'temperatura', 275.0000, 'ºC'),
	(323452, 145, '2015-01-15 00:35:17.000000', 'temperatura', 428.0000, 'ºC'),
	(323453, 145, '2015-01-15 00:35:18.000000', 'temperatura', 114.0000, 'ºC'),
	(323454, 145, '2015-01-15 00:35:19.000000', 'temperatura', 488.0000, 'ºC'),
	(323455, 145, '2015-01-15 00:35:20.000000', 'temperatura', 897.0000, 'ºC'),
	(323456, 145, '2015-01-15 00:35:21.000000', 'temperatura', 623.0000, 'ºC'),
	(323457, 145, '2015-01-15 00:35:22.000000', 'temperatura', 424.0000, 'ºC'),
	(323458, 145, '2015-01-15 00:35:23.000000', 'temperatura', 253.0000, 'ºC'),
	(323459, 145, '2015-01-15 00:35:24.000000', 'temperatura', 1191.0000, 'ºC'),
	(323460, 145, '2015-01-15 00:35:25.000000', 'temperatura', 398.0000, 'ºC'),
	(323461, 145, '2015-01-15 00:35:26.000000', 'temperatura', 818.0000, 'ºC'),
	(323462, 145, '2015-01-15 00:35:27.000000', 'temperatura', 496.0000, 'ºC'),
	(323463, 145, '2015-01-15 00:35:28.000000', 'temperatura', 28.0000, 'ºC'),
	(323464, 145, '2015-01-15 00:35:29.000000', 'temperatura', 1053.0000, 'ºC'),
	(323465, 145, '2015-01-15 00:35:30.000000', 'temperatura', 382.0000, 'ºC'),
	(323466, 145, '2015-01-15 00:35:31.000000', 'temperatura', 1151.0000, 'ºC'),
	(323467, 145, '2015-01-15 00:35:32.000000', 'temperatura', 1010.0000, 'ºC'),
	(323468, 145, '2015-01-15 00:35:33.000000', 'temperatura', 397.0000, 'ºC'),
	(323469, 145, '2015-01-15 00:35:34.000000', 'temperatura', 154.0000, 'ºC'),
	(323470, 145, '2015-01-15 00:35:35.000000', 'temperatura', 782.0000, 'ºC'),
	(323471, 145, '2015-01-15 00:35:36.000000', 'temperatura', 1047.0000, 'ºC'),
	(323472, 145, '2015-01-15 00:35:37.000000', 'temperatura', 490.0000, 'ºC'),
	(323473, 145, '2015-01-15 00:35:38.000000', 'temperatura', 509.0000, 'ºC'),
	(323474, 145, '2015-01-15 00:35:39.000000', 'temperatura', 1075.0000, 'ºC'),
	(323475, 145, '2015-01-15 00:35:40.000000', 'temperatura', 248.0000, 'ºC'),
	(323476, 145, '2015-01-15 00:35:41.000000', 'temperatura', 418.0000, 'ºC'),
	(323477, 145, '2015-01-15 00:35:42.000000', 'temperatura', 145.0000, 'ºC'),
	(323478, 145, '2015-01-15 00:35:43.000000', 'temperatura', 672.0000, 'ºC'),
	(323479, 145, '2015-01-15 00:35:44.000000', 'temperatura', 526.0000, 'ºC'),
	(323480, 145, '2015-01-15 00:35:45.000000', 'temperatura', 614.0000, 'ºC'),
	(323481, 145, '2015-01-15 00:35:46.000000', 'temperatura', 293.0000, 'ºC'),
	(323482, 145, '2015-01-15 00:35:47.000000', 'temperatura', 823.0000, 'ºC'),
	(323483, 145, '2015-01-15 00:35:48.000000', 'temperatura', 839.0000, 'ºC'),
	(323484, 145, '2015-01-15 00:35:49.000000', 'temperatura', 523.0000, 'ºC'),
	(323485, 145, '2015-01-15 00:35:50.000000', 'temperatura', 102.0000, 'ºC'),
	(323486, 145, '2015-01-15 00:35:51.000000', 'temperatura', 139.0000, 'ºC'),
	(323487, 145, '2015-01-15 00:35:52.000000', 'temperatura', 390.0000, 'ºC'),
	(323488, 145, '2015-01-15 00:35:53.000000', 'temperatura', 335.0000, 'ºC'),
	(323489, 145, '2015-01-15 00:35:54.000000', 'temperatura', 503.0000, 'ºC'),
	(323490, 145, '2015-01-15 00:35:55.000000', 'temperatura', 310.0000, 'ºC'),
	(323491, 145, '2015-01-15 00:35:56.000000', 'temperatura', 43.0000, 'ºC'),
	(323492, 145, '2015-01-15 00:35:57.000000', 'temperatura', 485.0000, 'ºC'),
	(323493, 145, '2015-01-15 00:35:58.000000', 'temperatura', 1099.0000, 'ºC'),
	(323494, 145, '2015-01-15 00:35:59.000000', 'temperatura', 438.0000, 'ºC'),
	(323495, 145, '2015-01-15 00:36:00.000000', 'temperatura', 94.0000, 'ºC'),
	(323496, 145, '2015-01-15 00:36:01.000000', 'temperatura', 355.0000, 'ºC'),
	(323497, 145, '2015-01-15 00:36:02.000000', 'temperatura', 295.0000, 'ºC'),
	(323498, 145, '2015-01-15 00:36:03.000000', 'temperatura', 411.0000, 'ºC'),
	(323499, 145, '2015-01-15 00:36:04.000000', 'temperatura', 1171.0000, 'ºC'),
	(323500, 145, '2015-01-15 00:36:05.000000', 'temperatura', 1023.0000, 'ºC'),
	(323501, 145, '2015-01-15 00:36:06.000000', 'temperatura', 402.0000, 'ºC'),
	(323502, 145, '2015-01-15 00:36:07.000000', 'temperatura', 142.0000, 'ºC'),
	(323503, 145, '2015-01-15 00:36:08.000000', 'temperatura', 704.0000, 'ºC'),
	(323504, 145, '2015-01-15 00:36:09.000000', 'temperatura', 693.0000, 'ºC'),
	(323505, 145, '2015-01-15 00:36:10.000000', 'temperatura', 153.0000, 'ºC'),
	(323506, 145, '2015-01-15 00:36:11.000000', 'temperatura', 1089.0000, 'ºC'),
	(323507, 145, '2015-01-15 00:36:12.000000', 'temperatura', 186.0000, 'ºC'),
	(323508, 145, '2015-01-15 00:36:13.000000', 'temperatura', 64.0000, 'ºC'),
	(323509, 145, '2015-01-15 00:36:14.000000', 'temperatura', 963.0000, 'ºC'),
	(323510, 145, '2015-01-15 00:36:15.000000', 'temperatura', 1022.0000, 'ºC'),
	(323511, 145, '2015-01-15 00:36:16.000000', 'temperatura', 1023.0000, 'ºC'),
	(323512, 145, '2015-01-15 00:36:17.000000', 'temperatura', 848.0000, 'ºC'),
	(323513, 145, '2015-01-15 00:36:18.000000', 'temperatura', 1173.0000, 'ºC'),
	(323514, 145, '2015-01-15 00:36:19.000000', 'temperatura', 922.0000, 'ºC'),
	(323515, 145, '2015-01-15 00:36:20.000000', 'temperatura', 1090.0000, 'ºC'),
	(323516, 145, '2015-01-15 00:36:21.000000', 'temperatura', 283.0000, 'ºC'),
	(323517, 145, '2015-01-15 00:36:22.000000', 'temperatura', 547.0000, 'ºC'),
	(323518, 145, '2015-01-15 00:36:23.000000', 'temperatura', 687.0000, 'ºC'),
	(323519, 145, '2015-01-15 00:36:24.000000', 'temperatura', 594.0000, 'ºC'),
	(323520, 145, '2015-01-15 00:36:25.000000', 'temperatura', 909.0000, 'ºC'),
	(323521, 145, '2015-01-15 00:36:26.000000', 'temperatura', 365.0000, 'ºC'),
	(323522, 145, '2015-01-15 00:36:27.000000', 'temperatura', 299.0000, 'ºC'),
	(323523, 145, '2015-01-15 00:36:28.000000', 'temperatura', 399.0000, 'ºC'),
	(323524, 145, '2015-01-15 00:36:29.000000', 'temperatura', 1100.0000, 'ºC'),
	(323525, 145, '2015-01-15 00:36:30.000000', 'temperatura', 704.0000, 'ºC'),
	(323526, 145, '2015-01-15 00:36:31.000000', 'temperatura', 220.0000, 'ºC'),
	(323527, 145, '2015-01-15 00:36:32.000000', 'temperatura', 190.0000, 'ºC'),
	(323528, 145, '2015-01-15 00:36:33.000000', 'temperatura', 289.0000, 'ºC'),
	(323529, 145, '2015-01-15 00:36:34.000000', 'temperatura', 877.0000, 'ºC'),
	(323530, 145, '2015-01-15 00:36:35.000000', 'temperatura', 1119.0000, 'ºC'),
	(323531, 145, '2015-01-15 00:36:36.000000', 'temperatura', 564.0000, 'ºC'),
	(323532, 145, '2015-01-15 00:36:37.000000', 'temperatura', 664.0000, 'ºC'),
	(323533, 145, '2015-01-15 00:36:38.000000', 'temperatura', 428.0000, 'ºC'),
	(323534, 145, '2015-01-15 00:36:39.000000', 'temperatura', 146.0000, 'ºC'),
	(323535, 145, '2015-01-15 00:36:40.000000', 'temperatura', 650.0000, 'ºC'),
	(323536, 145, '2015-01-15 00:36:41.000000', 'temperatura', 411.0000, 'ºC'),
	(323537, 145, '2015-01-15 00:36:42.000000', 'temperatura', 106.0000, 'ºC'),
	(323538, 145, '2015-01-15 00:36:43.000000', 'temperatura', 496.0000, 'ºC'),
	(323539, 145, '2015-01-15 00:36:44.000000', 'temperatura', 961.0000, 'ºC'),
	(323540, 145, '2015-01-15 00:36:45.000000', 'temperatura', 920.0000, 'ºC'),
	(323541, 145, '2015-01-15 00:36:46.000000', 'temperatura', 519.0000, 'ºC'),
	(323542, 145, '2015-01-15 00:36:47.000000', 'temperatura', 1034.0000, 'ºC'),
	(323543, 145, '2015-01-15 00:36:48.000000', 'temperatura', 13.0000, 'ºC'),
	(323544, 145, '2015-01-15 00:36:49.000000', 'temperatura', 566.0000, 'ºC'),
	(323545, 145, '2015-01-15 00:36:50.000000', 'temperatura', 389.0000, 'ºC'),
	(323546, 145, '2015-01-15 00:36:51.000000', 'temperatura', 247.0000, 'ºC'),
	(323547, 145, '2015-01-15 00:36:52.000000', 'temperatura', 71.0000, 'ºC'),
	(323548, 145, '2015-01-15 00:36:53.000000', 'temperatura', 814.0000, 'ºC'),
	(323549, 145, '2015-01-15 00:36:54.000000', 'temperatura', 256.0000, 'ºC'),
	(323550, 145, '2015-01-15 00:36:55.000000', 'temperatura', 38.0000, 'ºC'),
	(323551, 145, '2015-01-15 00:36:56.000000', 'temperatura', 622.0000, 'ºC'),
	(323552, 145, '2015-01-15 00:36:57.000000', 'temperatura', 599.0000, 'ºC'),
	(323553, 145, '2015-01-15 00:36:58.000000', 'temperatura', 1127.0000, 'ºC'),
	(323554, 145, '2015-01-15 00:36:59.000000', 'temperatura', 241.0000, 'ºC'),
	(323555, 145, '2015-01-15 00:37:00.000000', 'temperatura', 222.0000, 'ºC'),
	(323556, 145, '2015-01-15 00:37:01.000000', 'temperatura', 388.0000, 'ºC'),
	(323557, 145, '2015-01-15 00:37:02.000000', 'temperatura', 76.0000, 'ºC'),
	(323558, 145, '2015-01-15 00:37:03.000000', 'temperatura', 415.0000, 'ºC'),
	(323559, 145, '2015-01-15 00:37:04.000000', 'temperatura', 648.0000, 'ºC'),
	(323560, 145, '2015-01-15 00:37:05.000000', 'temperatura', 794.0000, 'ºC'),
	(323561, 145, '2015-01-15 00:37:06.000000', 'temperatura', 828.0000, 'ºC'),
	(323562, 145, '2015-01-15 00:37:07.000000', 'temperatura', 559.0000, 'ºC'),
	(323563, 145, '2015-01-15 00:37:08.000000', 'temperatura', 311.0000, 'ºC'),
	(323564, 145, '2015-01-15 00:37:09.000000', 'temperatura', 1079.0000, 'ºC'),
	(323565, 145, '2015-01-15 00:37:10.000000', 'temperatura', 861.0000, 'ºC'),
	(323566, 145, '2015-01-15 00:37:11.000000', 'temperatura', 1070.0000, 'ºC'),
	(323567, 145, '2015-01-15 00:37:12.000000', 'temperatura', 368.0000, 'ºC'),
	(323568, 145, '2015-01-15 00:37:13.000000', 'temperatura', 1029.0000, 'ºC'),
	(323569, 145, '2015-01-15 00:37:14.000000', 'temperatura', 442.0000, 'ºC'),
	(323570, 145, '2015-01-15 00:37:15.000000', 'temperatura', 325.0000, 'ºC'),
	(323571, 145, '2015-01-15 00:37:16.000000', 'temperatura', 299.0000, 'ºC'),
	(323572, 145, '2015-01-15 00:37:17.000000', 'temperatura', 520.0000, 'ºC'),
	(323573, 145, '2015-01-15 00:37:18.000000', 'temperatura', 502.0000, 'ºC'),
	(323574, 145, '2015-01-15 00:37:19.000000', 'temperatura', 951.0000, 'ºC'),
	(323575, 145, '2015-01-15 00:37:20.000000', 'temperatura', 848.0000, 'ºC'),
	(323576, 145, '2015-01-15 00:37:21.000000', 'temperatura', 189.0000, 'ºC'),
	(323577, 145, '2015-01-15 00:37:22.000000', 'temperatura', 803.0000, 'ºC'),
	(323578, 145, '2015-01-15 00:37:23.000000', 'temperatura', 1048.0000, 'ºC'),
	(323579, 145, '2015-01-15 00:37:24.000000', 'temperatura', 431.0000, 'ºC'),
	(323580, 145, '2015-01-15 00:37:25.000000', 'temperatura', 212.0000, 'ºC'),
	(323581, 145, '2015-01-15 00:37:26.000000', 'temperatura', 966.0000, 'ºC'),
	(323582, 145, '2015-01-15 00:37:27.000000', 'temperatura', 595.0000, 'ºC'),
	(323583, 145, '2015-01-15 00:37:28.000000', 'temperatura', 76.0000, 'ºC'),
	(323584, 145, '2015-01-15 00:37:29.000000', 'temperatura', 996.0000, 'ºC'),
	(323585, 145, '2015-01-15 00:37:30.000000', 'temperatura', 1154.0000, 'ºC'),
	(323586, 145, '2015-01-15 00:37:31.000000', 'temperatura', 381.0000, 'ºC'),
	(323587, 145, '2015-01-15 00:37:32.000000', 'temperatura', 845.0000, 'ºC'),
	(323588, 145, '2015-01-15 00:37:33.000000', 'temperatura', 680.0000, 'ºC'),
	(323589, 145, '2015-01-15 00:37:34.000000', 'temperatura', 867.0000, 'ºC'),
	(323590, 145, '2015-01-15 00:37:35.000000', 'temperatura', 1096.0000, 'ºC'),
	(323591, 145, '2015-01-15 00:37:36.000000', 'temperatura', 479.0000, 'ºC'),
	(323592, 145, '2015-01-15 00:37:37.000000', 'temperatura', 306.0000, 'ºC'),
	(323593, 145, '2015-01-15 00:37:38.000000', 'temperatura', 94.0000, 'ºC'),
	(323594, 145, '2015-01-15 00:37:39.000000', 'temperatura', 754.0000, 'ºC'),
	(323595, 145, '2015-01-15 00:37:40.000000', 'temperatura', 1089.0000, 'ºC'),
	(323596, 145, '2015-01-15 00:37:41.000000', 'temperatura', 784.0000, 'ºC'),
	(323597, 145, '2015-01-15 00:37:42.000000', 'temperatura', 654.0000, 'ºC'),
	(323598, 145, '2015-01-15 00:37:43.000000', 'temperatura', 916.0000, 'ºC'),
	(323599, 145, '2015-01-15 00:37:44.000000', 'temperatura', 221.0000, 'ºC'),
	(323600, 145, '2015-01-15 00:37:45.000000', 'temperatura', 755.0000, 'ºC'),
	(323601, 145, '2015-01-15 00:37:46.000000', 'temperatura', 716.0000, 'ºC'),
	(323602, 145, '2015-01-15 00:37:47.000000', 'temperatura', 112.0000, 'ºC'),
	(323603, 145, '2015-01-15 00:37:48.000000', 'temperatura', 813.0000, 'ºC'),
	(323604, 145, '2015-01-15 00:37:49.000000', 'temperatura', 131.0000, 'ºC'),
	(323605, 145, '2015-01-15 00:37:50.000000', 'temperatura', 614.0000, 'ºC'),
	(323606, 145, '2015-01-15 00:37:51.000000', 'temperatura', 277.0000, 'ºC'),
	(323607, 145, '2015-01-15 00:37:52.000000', 'temperatura', 746.0000, 'ºC'),
	(323608, 145, '2015-01-15 00:37:53.000000', 'temperatura', 499.0000, 'ºC'),
	(323609, 145, '2015-01-15 00:37:54.000000', 'temperatura', 259.0000, 'ºC'),
	(323610, 145, '2015-01-15 00:37:55.000000', 'temperatura', 997.0000, 'ºC'),
	(323611, 145, '2015-01-15 00:37:56.000000', 'temperatura', 607.0000, 'ºC'),
	(323612, 145, '2015-01-15 00:37:57.000000', 'temperatura', 47.0000, 'ºC'),
	(323613, 145, '2015-01-15 00:37:58.000000', 'temperatura', 813.0000, 'ºC'),
	(323614, 145, '2015-01-15 00:37:59.000000', 'temperatura', 324.0000, 'ºC'),
	(323615, 145, '2015-01-15 00:38:00.000000', 'temperatura', 380.0000, 'ºC'),
	(323616, 145, '2015-01-15 00:38:01.000000', 'temperatura', 930.0000, 'ºC'),
	(323617, 145, '2015-01-15 00:38:02.000000', 'temperatura', 1112.0000, 'ºC'),
	(323618, 145, '2015-01-15 00:38:03.000000', 'temperatura', 368.0000, 'ºC'),
	(323619, 145, '2015-01-15 00:38:04.000000', 'temperatura', 907.0000, 'ºC'),
	(323620, 145, '2015-01-15 00:38:05.000000', 'temperatura', 1032.0000, 'ºC'),
	(323621, 145, '2015-01-15 00:38:06.000000', 'temperatura', 40.0000, 'ºC'),
	(323622, 145, '2015-01-15 00:38:07.000000', 'temperatura', 703.0000, 'ºC'),
	(323623, 145, '2015-01-15 00:38:08.000000', 'temperatura', 994.0000, 'ºC'),
	(323624, 145, '2015-01-15 00:38:09.000000', 'temperatura', 464.0000, 'ºC'),
	(323625, 145, '2015-01-15 00:38:10.000000', 'temperatura', 536.0000, 'ºC'),
	(323626, 145, '2015-01-15 00:38:11.000000', 'temperatura', 89.0000, 'ºC'),
	(323627, 145, '2015-01-15 00:38:12.000000', 'temperatura', 38.0000, 'ºC'),
	(323628, 145, '2015-01-15 00:38:13.000000', 'temperatura', 1125.0000, 'ºC'),
	(323629, 145, '2015-01-15 00:38:14.000000', 'temperatura', 710.0000, 'ºC'),
	(323630, 145, '2015-01-15 00:38:15.000000', 'temperatura', 176.0000, 'ºC'),
	(323631, 145, '2015-01-15 00:38:16.000000', 'temperatura', 1152.0000, 'ºC'),
	(323632, 145, '2015-01-15 00:38:17.000000', 'temperatura', 430.0000, 'ºC'),
	(323633, 145, '2015-01-15 00:38:18.000000', 'temperatura', 1094.0000, 'ºC'),
	(323634, 145, '2015-01-15 00:38:19.000000', 'temperatura', 581.0000, 'ºC'),
	(323635, 145, '2015-01-15 00:38:20.000000', 'temperatura', 825.0000, 'ºC'),
	(323636, 145, '2015-01-15 00:38:21.000000', 'temperatura', 1182.0000, 'ºC'),
	(323637, 145, '2015-01-15 00:38:22.000000', 'temperatura', 1037.0000, 'ºC'),
	(323638, 145, '2015-01-15 00:38:23.000000', 'temperatura', 439.0000, 'ºC'),
	(323639, 145, '2015-01-15 00:38:24.000000', 'temperatura', 284.0000, 'ºC'),
	(323640, 145, '2015-01-15 00:38:25.000000', 'temperatura', 105.0000, 'ºC'),
	(323641, 145, '2015-01-15 00:38:26.000000', 'temperatura', 873.0000, 'ºC'),
	(323642, 145, '2015-01-15 00:38:27.000000', 'temperatura', 448.0000, 'ºC'),
	(323643, 145, '2015-01-15 00:38:28.000000', 'temperatura', 825.0000, 'ºC'),
	(323644, 145, '2015-01-15 00:38:29.000000', 'temperatura', 380.0000, 'ºC'),
	(323645, 145, '2015-01-15 00:38:30.000000', 'temperatura', 624.0000, 'ºC'),
	(323646, 145, '2015-01-15 00:38:31.000000', 'temperatura', 783.0000, 'ºC'),
	(323647, 145, '2015-01-15 00:38:32.000000', 'temperatura', 841.0000, 'ºC'),
	(323648, 145, '2015-01-15 00:38:33.000000', 'temperatura', 660.0000, 'ºC'),
	(323649, 145, '2015-01-15 00:38:34.000000', 'temperatura', 774.0000, 'ºC'),
	(323650, 145, '2015-01-15 00:38:35.000000', 'temperatura', 691.0000, 'ºC'),
	(323651, 145, '2015-01-15 00:38:36.000000', 'temperatura', 1134.0000, 'ºC'),
	(323652, 145, '2015-01-15 00:38:37.000000', 'temperatura', 1198.0000, 'ºC'),
	(323653, 145, '2015-01-15 00:38:38.000000', 'temperatura', 188.0000, 'ºC'),
	(323654, 145, '2015-01-15 00:38:39.000000', 'temperatura', 947.0000, 'ºC'),
	(323655, 145, '2015-01-15 00:38:40.000000', 'temperatura', 572.0000, 'ºC'),
	(323656, 145, '2015-01-15 00:38:41.000000', 'temperatura', 21.0000, 'ºC'),
	(323657, 145, '2015-01-15 00:38:42.000000', 'temperatura', 788.0000, 'ºC'),
	(323658, 145, '2015-01-15 00:38:43.000000', 'temperatura', 280.0000, 'ºC'),
	(323659, 145, '2015-01-15 00:38:44.000000', 'temperatura', 233.0000, 'ºC'),
	(323660, 145, '2015-01-15 00:38:45.000000', 'temperatura', 326.0000, 'ºC'),
	(323661, 145, '2015-01-15 00:38:46.000000', 'temperatura', 931.0000, 'ºC'),
	(323662, 145, '2015-01-15 00:38:47.000000', 'temperatura', 77.0000, 'ºC'),
	(323663, 145, '2015-01-15 00:38:48.000000', 'temperatura', 1193.0000, 'ºC'),
	(323664, 145, '2015-01-15 00:38:49.000000', 'temperatura', 935.0000, 'ºC'),
	(323665, 145, '2015-01-15 00:38:50.000000', 'temperatura', 1095.0000, 'ºC'),
	(323666, 145, '2015-01-15 00:38:51.000000', 'temperatura', 273.0000, 'ºC'),
	(323667, 145, '2015-01-15 00:38:52.000000', 'temperatura', 481.0000, 'ºC'),
	(323668, 145, '2015-01-15 00:38:53.000000', 'temperatura', 387.0000, 'ºC'),
	(323669, 145, '2015-01-15 00:38:54.000000', 'temperatura', 492.0000, 'ºC'),
	(323670, 145, '2015-01-15 00:38:55.000000', 'temperatura', 99.0000, 'ºC'),
	(323671, 145, '2015-01-15 00:38:56.000000', 'temperatura', 221.0000, 'ºC'),
	(323672, 145, '2015-01-15 00:38:57.000000', 'temperatura', 807.0000, 'ºC'),
	(323673, 145, '2015-01-15 00:38:58.000000', 'temperatura', 972.0000, 'ºC'),
	(323674, 145, '2015-01-15 00:38:59.000000', 'temperatura', 38.0000, 'ºC'),
	(323675, 145, '2015-01-15 00:39:00.000000', 'temperatura', 876.0000, 'ºC'),
	(323676, 145, '2015-01-15 00:39:01.000000', 'temperatura', 666.0000, 'ºC'),
	(323677, 145, '2015-01-15 00:39:02.000000', 'temperatura', 705.0000, 'ºC'),
	(323678, 145, '2015-01-15 00:39:03.000000', 'temperatura', 324.0000, 'ºC'),
	(323679, 145, '2015-01-15 00:39:04.000000', 'temperatura', 707.0000, 'ºC'),
	(323680, 145, '2015-01-15 00:39:05.000000', 'temperatura', 162.0000, 'ºC'),
	(323681, 145, '2015-01-15 00:39:06.000000', 'temperatura', 1092.0000, 'ºC'),
	(323682, 145, '2015-01-15 00:39:07.000000', 'temperatura', 175.0000, 'ºC'),
	(323683, 145, '2015-01-15 00:39:08.000000', 'temperatura', 1199.0000, 'ºC'),
	(323684, 145, '2015-01-15 00:39:09.000000', 'temperatura', 672.0000, 'ºC'),
	(323685, 145, '2015-01-15 00:39:10.000000', 'temperatura', 962.0000, 'ºC'),
	(323686, 145, '2015-01-15 00:39:11.000000', 'temperatura', 394.0000, 'ºC'),
	(323687, 145, '2015-01-15 00:39:12.000000', 'temperatura', 287.0000, 'ºC'),
	(323688, 145, '2015-01-15 00:39:13.000000', 'temperatura', 251.0000, 'ºC'),
	(323689, 145, '2015-01-15 00:39:14.000000', 'temperatura', 396.0000, 'ºC'),
	(323690, 145, '2015-01-15 00:39:15.000000', 'temperatura', 25.0000, 'ºC'),
	(323691, 145, '2015-01-15 00:39:16.000000', 'temperatura', 139.0000, 'ºC'),
	(323692, 145, '2015-01-15 00:39:17.000000', 'temperatura', 620.0000, 'ºC'),
	(323693, 145, '2015-01-15 00:39:18.000000', 'temperatura', 282.0000, 'ºC'),
	(323694, 145, '2015-01-15 00:39:19.000000', 'temperatura', 753.0000, 'ºC'),
	(323695, 145, '2015-01-15 00:39:20.000000', 'temperatura', 517.0000, 'ºC'),
	(323696, 145, '2015-01-15 00:39:21.000000', 'temperatura', 329.0000, 'ºC'),
	(323697, 145, '2015-01-15 00:39:22.000000', 'temperatura', 95.0000, 'ºC'),
	(323698, 145, '2015-01-15 00:39:23.000000', 'temperatura', 687.0000, 'ºC'),
	(323699, 145, '2015-01-15 00:39:24.000000', 'temperatura', 750.0000, 'ºC'),
	(323700, 145, '2015-01-15 00:39:25.000000', 'temperatura', 488.0000, 'ºC'),
	(323701, 145, '2015-01-15 00:39:26.000000', 'temperatura', 193.0000, 'ºC'),
	(323702, 145, '2015-01-15 00:39:27.000000', 'temperatura', 702.0000, 'ºC'),
	(323703, 145, '2015-01-15 00:39:28.000000', 'temperatura', 532.0000, 'ºC'),
	(323704, 145, '2015-01-15 00:39:29.000000', 'temperatura', 553.0000, 'ºC'),
	(323705, 145, '2015-01-15 00:39:30.000000', 'temperatura', 1169.0000, 'ºC'),
	(323706, 145, '2015-01-15 00:39:31.000000', 'temperatura', 587.0000, 'ºC'),
	(323707, 145, '2015-01-15 00:39:32.000000', 'temperatura', 627.0000, 'ºC'),
	(323708, 145, '2015-01-15 00:39:33.000000', 'temperatura', 176.0000, 'ºC'),
	(323709, 145, '2015-01-15 00:39:34.000000', 'temperatura', 198.0000, 'ºC'),
	(323710, 145, '2015-01-15 00:39:35.000000', 'temperatura', 462.0000, 'ºC'),
	(323711, 145, '2015-01-15 00:39:36.000000', 'temperatura', 518.0000, 'ºC'),
	(323712, 145, '2015-01-15 00:39:37.000000', 'temperatura', 6.0000, 'ºC'),
	(323713, 145, '2015-01-15 00:39:38.000000', 'temperatura', 876.0000, 'ºC'),
	(323714, 145, '2015-01-15 00:39:39.000000', 'temperatura', 761.0000, 'ºC'),
	(323715, 145, '2015-01-15 00:39:40.000000', 'temperatura', 1177.0000, 'ºC'),
	(323716, 145, '2015-01-15 00:39:41.000000', 'temperatura', 2.0000, 'ºC'),
	(323717, 145, '2015-01-15 00:39:42.000000', 'temperatura', 82.0000, 'ºC'),
	(323718, 145, '2015-01-15 00:39:43.000000', 'temperatura', 402.0000, 'ºC'),
	(323719, 145, '2015-01-15 00:39:44.000000', 'temperatura', 566.0000, 'ºC'),
	(323720, 145, '2015-01-15 00:39:45.000000', 'temperatura', 426.0000, 'ºC'),
	(323721, 145, '2015-01-15 00:39:46.000000', 'temperatura', 431.0000, 'ºC'),
	(323722, 145, '2015-01-15 00:39:47.000000', 'temperatura', 876.0000, 'ºC'),
	(323723, 145, '2015-01-15 00:39:48.000000', 'temperatura', 690.0000, 'ºC'),
	(323724, 145, '2015-01-15 00:39:49.000000', 'temperatura', 821.0000, 'ºC'),
	(323725, 145, '2015-01-15 00:39:50.000000', 'temperatura', 838.0000, 'ºC'),
	(323726, 145, '2015-01-15 00:39:51.000000', 'temperatura', 524.0000, 'ºC'),
	(323727, 145, '2015-01-15 00:39:52.000000', 'temperatura', 109.0000, 'ºC'),
	(323728, 145, '2015-01-15 00:39:53.000000', 'temperatura', 172.0000, 'ºC'),
	(323729, 145, '2015-01-15 00:39:54.000000', 'temperatura', 534.0000, 'ºC'),
	(323730, 145, '2015-01-15 00:39:55.000000', 'temperatura', 953.0000, 'ºC'),
	(323731, 145, '2015-01-15 00:39:56.000000', 'temperatura', 766.0000, 'ºC'),
	(323732, 145, '2015-01-15 00:39:57.000000', 'temperatura', 972.0000, 'ºC'),
	(323733, 145, '2015-01-15 00:39:58.000000', 'temperatura', 160.0000, 'ºC'),
	(323734, 145, '2015-01-15 00:39:59.000000', 'temperatura', 284.0000, 'ºC'),
	(323735, 145, '2015-01-15 00:40:00.000000', 'temperatura', 941.0000, 'ºC'),
	(323736, 145, '2015-01-15 00:40:01.000000', 'temperatura', 253.0000, 'ºC'),
	(323737, 145, '2015-01-15 00:40:02.000000', 'temperatura', 842.0000, 'ºC'),
	(323738, 145, '2015-01-15 00:40:03.000000', 'temperatura', 1054.0000, 'ºC'),
	(323739, 145, '2015-01-15 00:40:04.000000', 'temperatura', 343.0000, 'ºC'),
	(323740, 145, '2015-01-15 00:40:05.000000', 'temperatura', 956.0000, 'ºC'),
	(323741, 145, '2015-01-15 00:40:06.000000', 'temperatura', 148.0000, 'ºC'),
	(323742, 145, '2015-01-15 00:40:07.000000', 'temperatura', 275.0000, 'ºC'),
	(323743, 145, '2015-01-15 00:40:08.000000', 'temperatura', 930.0000, 'ºC'),
	(323744, 145, '2015-01-15 00:40:09.000000', 'temperatura', 226.0000, 'ºC'),
	(323745, 145, '2015-01-15 00:40:10.000000', 'temperatura', 739.0000, 'ºC'),
	(323746, 145, '2015-01-15 00:40:11.000000', 'temperatura', 620.0000, 'ºC'),
	(323747, 145, '2015-01-15 00:40:12.000000', 'temperatura', 882.0000, 'ºC'),
	(323748, 145, '2015-01-15 00:40:13.000000', 'temperatura', 149.0000, 'ºC'),
	(323749, 145, '2015-01-15 00:40:14.000000', 'temperatura', 503.0000, 'ºC'),
	(323750, 145, '2015-01-15 00:40:15.000000', 'temperatura', 865.0000, 'ºC'),
	(323751, 145, '2015-01-15 00:40:16.000000', 'temperatura', 420.0000, 'ºC'),
	(323752, 145, '2015-01-15 00:40:17.000000', 'temperatura', 703.0000, 'ºC'),
	(323753, 145, '2015-01-15 00:40:18.000000', 'temperatura', 1058.0000, 'ºC'),
	(323754, 145, '2015-01-15 00:40:19.000000', 'temperatura', 782.0000, 'ºC'),
	(323755, 145, '2015-01-15 00:40:20.000000', 'temperatura', 734.0000, 'ºC'),
	(323756, 145, '2015-01-15 00:40:21.000000', 'temperatura', 126.0000, 'ºC'),
	(323757, 145, '2015-01-15 00:40:22.000000', 'temperatura', 829.0000, 'ºC'),
	(323758, 145, '2015-01-15 00:40:23.000000', 'temperatura', 167.0000, 'ºC'),
	(323759, 145, '2015-01-15 00:40:24.000000', 'temperatura', 748.0000, 'ºC'),
	(323760, 145, '2015-01-15 00:40:25.000000', 'temperatura', 841.0000, 'ºC'),
	(323761, 145, '2015-01-15 00:40:26.000000', 'temperatura', 761.0000, 'ºC'),
	(323762, 145, '2015-01-15 00:40:27.000000', 'temperatura', 82.0000, 'ºC'),
	(323763, 145, '2015-01-15 00:40:28.000000', 'temperatura', 529.0000, 'ºC'),
	(323764, 145, '2015-01-15 00:40:29.000000', 'temperatura', 0.0000, 'ºC'),
	(323765, 145, '2015-01-15 00:40:30.000000', 'temperatura', 813.0000, 'ºC'),
	(323766, 145, '2015-01-15 00:40:31.000000', 'temperatura', 467.0000, 'ºC'),
	(323767, 145, '2015-01-15 00:40:32.000000', 'temperatura', 1096.0000, 'ºC'),
	(323768, 145, '2015-01-15 00:40:33.000000', 'temperatura', 480.0000, 'ºC'),
	(323769, 145, '2015-01-15 00:40:34.000000', 'temperatura', 310.0000, 'ºC'),
	(323770, 145, '2015-01-15 00:40:35.000000', 'temperatura', 113.0000, 'ºC'),
	(323771, 145, '2015-01-15 00:40:36.000000', 'temperatura', 835.0000, 'ºC'),
	(323772, 145, '2015-01-15 00:40:37.000000', 'temperatura', 236.0000, 'ºC'),
	(323773, 145, '2015-01-15 00:40:38.000000', 'temperatura', 1078.0000, 'ºC'),
	(323774, 145, '2015-01-15 00:40:39.000000', 'temperatura', 1080.0000, 'ºC'),
	(323775, 145, '2015-01-15 00:40:40.000000', 'temperatura', 965.0000, 'ºC'),
	(323776, 145, '2015-01-15 00:40:41.000000', 'temperatura', 388.0000, 'ºC'),
	(323777, 145, '2015-01-15 00:40:42.000000', 'temperatura', 244.0000, 'ºC'),
	(323778, 145, '2015-01-15 00:40:43.000000', 'temperatura', 55.0000, 'ºC'),
	(323779, 145, '2015-01-15 00:40:44.000000', 'temperatura', 747.0000, 'ºC'),
	(323780, 145, '2015-01-15 00:40:45.000000', 'temperatura', 1167.0000, 'ºC'),
	(323781, 145, '2015-01-15 00:40:46.000000', 'temperatura', 1197.0000, 'ºC'),
	(323782, 145, '2015-01-15 00:40:47.000000', 'temperatura', 85.0000, 'ºC'),
	(323783, 145, '2015-01-15 00:40:48.000000', 'temperatura', 435.0000, 'ºC'),
	(323784, 145, '2015-01-15 00:40:49.000000', 'temperatura', 719.0000, 'ºC'),
	(323785, 145, '2015-01-15 00:40:50.000000', 'temperatura', 1089.0000, 'ºC'),
	(323786, 145, '2015-01-15 00:40:51.000000', 'temperatura', 889.0000, 'ºC'),
	(323787, 145, '2015-01-15 00:40:52.000000', 'temperatura', 1179.0000, 'ºC'),
	(323788, 145, '2015-01-15 00:40:53.000000', 'temperatura', 829.0000, 'ºC'),
	(323789, 145, '2015-01-15 00:40:54.000000', 'temperatura', 606.0000, 'ºC'),
	(323790, 145, '2015-01-15 00:40:55.000000', 'temperatura', 546.0000, 'ºC'),
	(323791, 145, '2015-01-15 00:40:56.000000', 'temperatura', 914.0000, 'ºC'),
	(323792, 145, '2015-01-15 00:40:57.000000', 'temperatura', 529.0000, 'ºC'),
	(323793, 145, '2015-01-15 00:40:58.000000', 'temperatura', 1105.0000, 'ºC'),
	(323794, 145, '2015-01-15 00:40:59.000000', 'temperatura', 337.0000, 'ºC'),
	(323795, 145, '2015-01-15 00:41:00.000000', 'temperatura', 771.0000, 'ºC'),
	(323796, 145, '2015-01-15 00:41:01.000000', 'temperatura', 444.0000, 'ºC'),
	(323797, 145, '2015-01-15 00:41:02.000000', 'temperatura', 1109.0000, 'ºC'),
	(323798, 145, '2015-01-15 00:41:03.000000', 'temperatura', 615.0000, 'ºC'),
	(323799, 145, '2015-01-15 00:41:04.000000', 'temperatura', 945.0000, 'ºC'),
	(323800, 145, '2015-01-15 00:41:05.000000', 'temperatura', 484.0000, 'ºC'),
	(323801, 145, '2015-01-15 00:41:06.000000', 'temperatura', 783.0000, 'ºC'),
	(323802, 145, '2015-01-15 00:41:07.000000', 'temperatura', 66.0000, 'ºC'),
	(323803, 145, '2015-01-15 00:41:08.000000', 'temperatura', 381.0000, 'ºC'),
	(323804, 145, '2015-01-15 00:41:09.000000', 'temperatura', 507.0000, 'ºC'),
	(323805, 145, '2015-01-15 00:41:10.000000', 'temperatura', 192.0000, 'ºC'),
	(323806, 145, '2015-01-15 00:41:11.000000', 'temperatura', 638.0000, 'ºC'),
	(323807, 145, '2015-01-15 00:41:12.000000', 'temperatura', 216.0000, 'ºC'),
	(323808, 145, '2015-01-15 00:41:13.000000', 'temperatura', 366.0000, 'ºC'),
	(323809, 145, '2015-01-15 00:41:14.000000', 'temperatura', 1181.0000, 'ºC'),
	(323810, 145, '2015-01-15 00:41:15.000000', 'temperatura', 9.0000, 'ºC'),
	(323811, 145, '2015-01-15 00:41:16.000000', 'temperatura', 101.0000, 'ºC'),
	(323812, 145, '2015-01-15 00:41:17.000000', 'temperatura', 479.0000, 'ºC'),
	(323813, 145, '2015-01-15 00:41:18.000000', 'temperatura', 891.0000, 'ºC'),
	(323814, 145, '2015-01-15 00:41:19.000000', 'temperatura', 618.0000, 'ºC'),
	(323815, 145, '2015-01-15 00:41:20.000000', 'temperatura', 420.0000, 'ºC'),
	(323816, 145, '2015-01-15 00:41:21.000000', 'temperatura', 245.0000, 'ºC'),
	(323817, 145, '2015-01-15 00:41:22.000000', 'temperatura', 1164.0000, 'ºC'),
	(323818, 145, '2015-01-15 00:41:23.000000', 'temperatura', 288.0000, 'ºC'),
	(323819, 145, '2015-01-15 00:41:24.000000', 'temperatura', 348.0000, 'ºC'),
	(323820, 145, '2015-01-15 00:41:25.000000', 'temperatura', 875.0000, 'ºC'),
	(323821, 145, '2015-01-15 00:41:26.000000', 'temperatura', 932.0000, 'ºC'),
	(323822, 145, '2015-01-15 00:41:27.000000', 'temperatura', 834.0000, 'ºC'),
	(323823, 145, '2015-01-15 00:41:28.000000', 'temperatura', 175.0000, 'ºC'),
	(323824, 145, '2015-01-15 00:41:29.000000', 'temperatura', 774.0000, 'ºC'),
	(323825, 145, '2015-01-15 00:41:30.000000', 'temperatura', 943.0000, 'ºC'),
	(323826, 145, '2015-01-15 00:41:31.000000', 'temperatura', 1197.0000, 'ºC'),
	(323827, 145, '2015-01-15 00:41:32.000000', 'temperatura', 757.0000, 'ºC'),
	(323828, 145, '2015-01-15 00:41:33.000000', 'temperatura', 192.0000, 'ºC'),
	(323829, 145, '2015-01-15 00:41:34.000000', 'temperatura', 1088.0000, 'ºC'),
	(323830, 145, '2015-01-15 00:41:35.000000', 'temperatura', 68.0000, 'ºC'),
	(323831, 145, '2015-01-15 00:41:36.000000', 'temperatura', 675.0000, 'ºC'),
	(323832, 145, '2015-01-15 00:41:37.000000', 'temperatura', 772.0000, 'ºC'),
	(323833, 145, '2015-01-15 00:41:38.000000', 'temperatura', 636.0000, 'ºC'),
	(323834, 145, '2015-01-15 00:41:39.000000', 'temperatura', 866.0000, 'ºC'),
	(323835, 145, '2015-01-15 00:41:40.000000', 'temperatura', 20.0000, 'ºC'),
	(323836, 145, '2015-01-15 00:41:41.000000', 'temperatura', 1104.0000, 'ºC'),
	(323837, 145, '2015-01-15 00:41:42.000000', 'temperatura', 659.0000, 'ºC'),
	(323838, 145, '2015-01-15 00:41:43.000000', 'temperatura', 1182.0000, 'ºC'),
	(323839, 145, '2015-01-15 00:41:44.000000', 'temperatura', 336.0000, 'ºC'),
	(323840, 145, '2015-01-15 00:41:45.000000', 'temperatura', 534.0000, 'ºC'),
	(323841, 145, '2015-01-15 00:41:46.000000', 'temperatura', 463.0000, 'ºC'),
	(323842, 145, '2015-01-15 00:41:47.000000', 'temperatura', 714.0000, 'ºC'),
	(323843, 145, '2015-01-15 00:41:48.000000', 'temperatura', 983.0000, 'ºC'),
	(323844, 145, '2015-01-15 00:41:49.000000', 'temperatura', 370.0000, 'ºC'),
	(323845, 145, '2015-01-15 00:41:50.000000', 'temperatura', 104.0000, 'ºC'),
	(323846, 145, '2015-01-15 00:41:51.000000', 'temperatura', 611.0000, 'ºC'),
	(323847, 145, '2015-01-15 00:41:52.000000', 'temperatura', 342.0000, 'ºC'),
	(323848, 145, '2015-01-15 00:41:53.000000', 'temperatura', 1076.0000, 'ºC'),
	(323849, 145, '2015-01-15 00:41:54.000000', 'temperatura', 757.0000, 'ºC'),
	(323850, 145, '2015-01-15 00:41:55.000000', 'temperatura', 556.0000, 'ºC'),
	(323851, 145, '2015-01-15 00:41:56.000000', 'temperatura', 510.0000, 'ºC'),
	(323852, 145, '2015-01-15 00:41:57.000000', 'temperatura', 883.0000, 'ºC'),
	(323853, 145, '2015-01-15 00:41:58.000000', 'temperatura', 485.0000, 'ºC'),
	(323854, 145, '2015-01-15 00:41:59.000000', 'temperatura', 977.0000, 'ºC'),
	(323855, 145, '2015-01-15 00:42:00.000000', 'temperatura', 1030.0000, 'ºC'),
	(323856, 145, '2015-01-15 00:42:01.000000', 'temperatura', 1020.0000, 'ºC'),
	(323857, 145, '2015-01-15 00:42:02.000000', 'temperatura', 808.0000, 'ºC'),
	(323858, 145, '2015-01-15 00:42:03.000000', 'temperatura', 983.0000, 'ºC'),
	(323859, 145, '2015-01-15 00:42:04.000000', 'temperatura', 91.0000, 'ºC'),
	(323860, 145, '2015-01-15 00:42:05.000000', 'temperatura', 1108.0000, 'ºC'),
	(323861, 145, '2015-01-15 00:42:06.000000', 'temperatura', 468.0000, 'ºC'),
	(323862, 145, '2015-01-15 00:42:07.000000', 'temperatura', 218.0000, 'ºC'),
	(323863, 145, '2015-01-15 00:42:08.000000', 'temperatura', 883.0000, 'ºC'),
	(323864, 145, '2015-01-15 00:42:09.000000', 'temperatura', 161.0000, 'ºC'),
	(323865, 145, '2015-01-15 00:42:10.000000', 'temperatura', 557.0000, 'ºC'),
	(323866, 145, '2015-01-15 00:42:11.000000', 'temperatura', 1102.0000, 'ºC'),
	(323867, 145, '2015-01-15 00:42:12.000000', 'temperatura', 239.0000, 'ºC'),
	(323868, 145, '2015-01-15 00:42:13.000000', 'temperatura', 292.0000, 'ºC'),
	(323869, 145, '2015-01-15 00:42:14.000000', 'temperatura', 742.0000, 'ºC'),
	(323870, 145, '2015-01-15 00:42:15.000000', 'temperatura', 433.0000, 'ºC'),
	(323871, 145, '2015-01-15 00:42:16.000000', 'temperatura', 1140.0000, 'ºC'),
	(323872, 145, '2015-01-15 00:42:17.000000', 'temperatura', 802.0000, 'ºC'),
	(323873, 145, '2015-01-15 00:42:18.000000', 'temperatura', 592.0000, 'ºC'),
	(323874, 145, '2015-01-15 00:42:19.000000', 'temperatura', 556.0000, 'ºC'),
	(323875, 145, '2015-01-15 00:42:20.000000', 'temperatura', 1001.0000, 'ºC'),
	(323876, 145, '2015-01-15 00:42:21.000000', 'temperatura', 938.0000, 'ºC'),
	(323877, 145, '2015-01-15 00:42:22.000000', 'temperatura', 490.0000, 'ºC'),
	(323878, 145, '2015-01-15 00:42:23.000000', 'temperatura', 835.0000, 'ºC'),
	(323879, 145, '2015-01-15 00:42:24.000000', 'temperatura', 303.0000, 'ºC'),
	(323880, 145, '2015-01-15 00:42:25.000000', 'temperatura', 214.0000, 'ºC'),
	(323881, 145, '2015-01-15 00:42:26.000000', 'temperatura', 161.0000, 'ºC'),
	(323882, 145, '2015-01-15 00:42:27.000000', 'temperatura', 163.0000, 'ºC'),
	(323883, 145, '2015-01-15 00:42:28.000000', 'temperatura', 333.0000, 'ºC'),
	(323884, 145, '2015-01-15 00:42:29.000000', 'temperatura', 1176.0000, 'ºC'),
	(323885, 145, '2015-01-15 00:42:30.000000', 'temperatura', 80.0000, 'ºC'),
	(323886, 145, '2015-01-15 00:42:31.000000', 'temperatura', 472.0000, 'ºC'),
	(323887, 145, '2015-01-15 00:42:32.000000', 'temperatura', 922.0000, 'ºC'),
	(323888, 145, '2015-01-15 00:42:33.000000', 'temperatura', 794.0000, 'ºC'),
	(323889, 145, '2015-01-15 00:42:34.000000', 'temperatura', 4.0000, 'ºC'),
	(323890, 145, '2015-01-15 00:42:35.000000', 'temperatura', 39.0000, 'ºC'),
	(323891, 145, '2015-01-15 00:42:36.000000', 'temperatura', 182.0000, 'ºC'),
	(323892, 145, '2015-01-15 00:42:37.000000', 'temperatura', 796.0000, 'ºC'),
	(323893, 145, '2015-01-15 00:42:38.000000', 'temperatura', 1032.0000, 'ºC'),
	(323894, 145, '2015-01-15 00:42:39.000000', 'temperatura', 375.0000, 'ºC'),
	(323895, 145, '2015-01-15 00:42:40.000000', 'temperatura', 1178.0000, 'ºC'),
	(323896, 145, '2015-01-15 00:42:41.000000', 'temperatura', 1166.0000, 'ºC'),
	(323897, 145, '2015-01-15 00:42:42.000000', 'temperatura', 1097.0000, 'ºC'),
	(323898, 145, '2015-01-15 00:42:43.000000', 'temperatura', 789.0000, 'ºC'),
	(323899, 145, '2015-01-15 00:42:44.000000', 'temperatura', 654.0000, 'ºC'),
	(323900, 145, '2015-01-15 00:42:45.000000', 'temperatura', 902.0000, 'ºC'),
	(323901, 145, '2015-01-15 00:42:46.000000', 'temperatura', 150.0000, 'ºC'),
	(323902, 145, '2015-01-15 00:42:47.000000', 'temperatura', 442.0000, 'ºC'),
	(323903, 145, '2015-01-15 00:42:48.000000', 'temperatura', 563.0000, 'ºC'),
	(323904, 145, '2015-01-15 00:42:49.000000', 'temperatura', 290.0000, 'ºC'),
	(323905, 145, '2015-01-15 00:42:50.000000', 'temperatura', 959.0000, 'ºC'),
	(323906, 145, '2015-01-15 00:42:51.000000', 'temperatura', 327.0000, 'ºC'),
	(323907, 145, '2015-01-15 00:42:52.000000', 'temperatura', 1158.0000, 'ºC'),
	(323908, 145, '2015-01-15 00:42:53.000000', 'temperatura', 9.0000, 'ºC'),
	(323909, 145, '2015-01-15 00:42:54.000000', 'temperatura', 172.0000, 'ºC'),
	(323910, 145, '2015-01-15 00:42:55.000000', 'temperatura', 834.0000, 'ºC'),
	(323911, 145, '2015-01-15 00:42:56.000000', 'temperatura', 54.0000, 'ºC'),
	(323912, 145, '2015-01-15 00:42:57.000000', 'temperatura', 171.0000, 'ºC'),
	(323913, 145, '2015-01-15 00:42:58.000000', 'temperatura', 690.0000, 'ºC'),
	(323914, 145, '2015-01-15 00:42:59.000000', 'temperatura', 541.0000, 'ºC'),
	(323915, 145, '2015-01-15 00:43:00.000000', 'temperatura', 634.0000, 'ºC'),
	(323916, 145, '2015-01-15 00:43:01.000000', 'temperatura', 346.0000, 'ºC'),
	(323917, 145, '2015-01-15 00:43:02.000000', 'temperatura', 1028.0000, 'ºC'),
	(323918, 145, '2015-01-15 00:43:03.000000', 'temperatura', 504.0000, 'ºC'),
	(323919, 145, '2015-01-15 00:43:04.000000', 'temperatura', 636.0000, 'ºC'),
	(323920, 145, '2015-01-15 00:43:05.000000', 'temperatura', 469.0000, 'ºC'),
	(323921, 145, '2015-01-15 00:43:06.000000', 'temperatura', 438.0000, 'ºC'),
	(323922, 145, '2015-01-15 00:43:07.000000', 'temperatura', 781.0000, 'ºC'),
	(323923, 145, '2015-01-15 00:43:08.000000', 'temperatura', 194.0000, 'ºC'),
	(323924, 145, '2015-01-15 00:43:09.000000', 'temperatura', 1027.0000, 'ºC'),
	(323925, 145, '2015-01-15 00:43:10.000000', 'temperatura', 954.0000, 'ºC'),
	(323926, 145, '2015-01-15 00:43:11.000000', 'temperatura', 491.0000, 'ºC'),
	(323927, 145, '2015-01-15 00:43:12.000000', 'temperatura', 791.0000, 'ºC'),
	(323928, 145, '2015-01-15 00:43:13.000000', 'temperatura', 83.0000, 'ºC'),
	(323929, 145, '2015-01-15 00:43:14.000000', 'temperatura', 444.0000, 'ºC'),
	(323930, 145, '2015-01-15 00:43:15.000000', 'temperatura', 771.0000, 'ºC'),
	(323931, 145, '2015-01-15 00:43:16.000000', 'temperatura', 122.0000, 'ºC'),
	(323932, 145, '2015-01-15 00:43:17.000000', 'temperatura', 698.0000, 'ºC'),
	(323933, 145, '2015-01-15 00:43:18.000000', 'temperatura', 726.0000, 'ºC'),
	(323934, 145, '2015-01-15 00:43:19.000000', 'temperatura', 337.0000, 'ºC'),
	(323935, 145, '2015-01-15 00:43:20.000000', 'temperatura', 707.0000, 'ºC'),
	(323936, 145, '2015-01-15 00:43:21.000000', 'temperatura', 126.0000, 'ºC'),
	(323937, 145, '2015-01-15 00:43:22.000000', 'temperatura', 909.0000, 'ºC'),
	(323938, 145, '2015-01-15 00:43:23.000000', 'temperatura', 566.0000, 'ºC'),
	(323939, 145, '2015-01-15 00:43:24.000000', 'temperatura', 103.0000, 'ºC'),
	(323940, 145, '2015-01-15 00:43:25.000000', 'temperatura', 20.0000, 'ºC'),
	(323941, 145, '2015-01-15 00:43:26.000000', 'temperatura', 990.0000, 'ºC'),
	(323942, 145, '2015-01-15 00:43:27.000000', 'temperatura', 89.0000, 'ºC'),
	(323943, 145, '2015-01-15 00:43:28.000000', 'temperatura', 1076.0000, 'ºC'),
	(323944, 145, '2015-01-15 00:43:29.000000', 'temperatura', 315.0000, 'ºC'),
	(323945, 145, '2015-01-15 00:43:30.000000', 'temperatura', 746.0000, 'ºC'),
	(323946, 145, '2015-01-15 00:43:31.000000', 'temperatura', 385.0000, 'ºC'),
	(323947, 145, '2015-01-15 00:43:32.000000', 'temperatura', 887.0000, 'ºC'),
	(323948, 145, '2015-01-15 00:43:33.000000', 'temperatura', 883.0000, 'ºC'),
	(323949, 145, '2015-01-15 00:43:34.000000', 'temperatura', 552.0000, 'ºC'),
	(323950, 145, '2015-01-15 00:43:35.000000', 'temperatura', 112.0000, 'ºC'),
	(323951, 145, '2015-01-15 00:43:36.000000', 'temperatura', 107.0000, 'ºC'),
	(323952, 145, '2015-01-15 00:43:37.000000', 'temperatura', 197.0000, 'ºC'),
	(323953, 145, '2015-01-15 00:43:38.000000', 'temperatura', 665.0000, 'ºC'),
	(323954, 145, '2015-01-15 00:43:39.000000', 'temperatura', 334.0000, 'ºC'),
	(323955, 145, '2015-01-15 00:43:40.000000', 'temperatura', 874.0000, 'ºC'),
	(323956, 145, '2015-01-15 00:43:41.000000', 'temperatura', 970.0000, 'ºC'),
	(323957, 145, '2015-01-15 00:43:42.000000', 'temperatura', 1026.0000, 'ºC'),
	(323958, 145, '2015-01-15 00:43:43.000000', 'temperatura', 1024.0000, 'ºC'),
	(323959, 145, '2015-01-15 00:43:44.000000', 'temperatura', 842.0000, 'ºC'),
	(323960, 145, '2015-01-15 00:43:45.000000', 'temperatura', 1136.0000, 'ºC'),
	(323961, 145, '2015-01-15 00:43:46.000000', 'temperatura', 756.0000, 'ºC'),
	(323962, 145, '2015-01-15 00:43:47.000000', 'temperatura', 372.0000, 'ºC'),
	(323963, 145, '2015-01-15 00:43:48.000000', 'temperatura', 792.0000, 'ºC'),
	(323964, 145, '2015-01-15 00:43:49.000000', 'temperatura', 446.0000, 'ºC'),
	(323965, 145, '2015-01-15 00:43:50.000000', 'temperatura', 1053.0000, 'ºC'),
	(323966, 145, '2015-01-15 00:43:51.000000', 'temperatura', 326.0000, 'ºC'),
	(323967, 145, '2015-01-15 00:43:52.000000', 'temperatura', 873.0000, 'ºC'),
	(323968, 145, '2015-01-15 00:43:53.000000', 'temperatura', 988.0000, 'ºC'),
	(323969, 145, '2015-01-15 00:43:54.000000', 'temperatura', 1123.0000, 'ºC'),
	(323970, 145, '2015-01-15 00:43:55.000000', 'temperatura', 251.0000, 'ºC'),
	(323971, 145, '2015-01-15 00:43:56.000000', 'temperatura', 287.0000, 'ºC'),
	(323972, 145, '2015-01-15 00:43:57.000000', 'temperatura', 682.0000, 'ºC'),
	(323973, 145, '2015-01-15 00:43:58.000000', 'temperatura', 149.0000, 'ºC'),
	(323974, 145, '2015-01-15 00:43:59.000000', 'temperatura', 1098.0000, 'ºC'),
	(323975, 145, '2015-01-15 00:44:00.000000', 'temperatura', 246.0000, 'ºC'),
	(323976, 145, '2015-01-15 00:44:01.000000', 'temperatura', 336.0000, 'ºC'),
	(323977, 145, '2015-01-15 00:44:02.000000', 'temperatura', 944.0000, 'ºC'),
	(323978, 145, '2015-01-15 00:44:03.000000', 'temperatura', 110.0000, 'ºC'),
	(323979, 145, '2015-01-15 00:44:04.000000', 'temperatura', 118.0000, 'ºC'),
	(323980, 145, '2015-01-15 00:44:05.000000', 'temperatura', 262.0000, 'ºC'),
	(323981, 145, '2015-01-15 00:44:06.000000', 'temperatura', 954.0000, 'ºC'),
	(323982, 145, '2015-01-15 00:44:07.000000', 'temperatura', 388.0000, 'ºC'),
	(323983, 145, '2015-01-15 00:44:08.000000', 'temperatura', 276.0000, 'ºC'),
	(323984, 145, '2015-01-15 00:44:09.000000', 'temperatura', 219.0000, 'ºC'),
	(323985, 145, '2015-01-15 00:44:10.000000', 'temperatura', 265.0000, 'ºC'),
	(323986, 145, '2015-01-15 00:44:11.000000', 'temperatura', 668.0000, 'ºC'),
	(323987, 145, '2015-01-15 00:44:12.000000', 'temperatura', 146.0000, 'ºC'),
	(323988, 145, '2015-01-15 00:44:13.000000', 'temperatura', 1127.0000, 'ºC'),
	(323989, 145, '2015-01-15 00:44:14.000000', 'temperatura', 398.0000, 'ºC'),
	(323990, 145, '2015-01-15 00:44:15.000000', 'temperatura', 1009.0000, 'ºC'),
	(323991, 145, '2015-01-15 00:44:16.000000', 'temperatura', 251.0000, 'ºC'),
	(323992, 145, '2015-01-15 00:44:17.000000', 'temperatura', 630.0000, 'ºC'),
	(323993, 145, '2015-01-15 00:44:18.000000', 'temperatura', 1195.0000, 'ºC'),
	(323994, 145, '2015-01-15 00:44:19.000000', 'temperatura', 487.0000, 'ºC'),
	(323995, 145, '2015-01-15 00:44:20.000000', 'temperatura', 51.0000, 'ºC'),
	(323996, 145, '2015-01-15 00:44:21.000000', 'temperatura', 1194.0000, 'ºC'),
	(323997, 145, '2015-01-15 00:44:22.000000', 'temperatura', 1017.0000, 'ºC'),
	(323998, 145, '2015-01-15 00:44:23.000000', 'temperatura', 305.0000, 'ºC'),
	(323999, 145, '2015-01-15 00:44:24.000000', 'temperatura', 872.0000, 'ºC'),
	(324000, 145, '2015-01-15 00:44:25.000000', 'temperatura', 1048.0000, 'ºC'),
	(324001, 145, '2015-01-15 00:44:26.000000', 'temperatura', 222.0000, 'ºC'),
	(324002, 145, '2015-01-15 00:44:27.000000', 'temperatura', 369.0000, 'ºC'),
	(324003, 145, '2015-01-15 00:44:28.000000', 'temperatura', 1178.0000, 'ºC'),
	(324004, 145, '2015-01-15 00:44:29.000000', 'temperatura', 1186.0000, 'ºC'),
	(324005, 145, '2015-01-15 00:44:30.000000', 'temperatura', 1194.0000, 'ºC'),
	(324006, 145, '2015-01-15 00:44:31.000000', 'temperatura', 13.0000, 'ºC'),
	(324007, 145, '2015-01-15 00:44:32.000000', 'temperatura', 86.0000, 'ºC'),
	(324008, 145, '2015-01-15 00:44:33.000000', 'temperatura', 388.0000, 'ºC'),
	(324009, 145, '2015-01-15 00:44:34.000000', 'temperatura', 484.0000, 'ºC'),
	(324010, 145, '2015-01-15 00:44:35.000000', 'temperatura', 55.0000, 'ºC'),
	(324011, 145, '2015-01-15 00:44:36.000000', 'temperatura', 26.0000, 'ºC'),
	(324012, 145, '2015-01-15 00:44:37.000000', 'temperatura', 1163.0000, 'ºC'),
	(324013, 145, '2015-01-15 00:44:38.000000', 'temperatura', 938.0000, 'ºC'),
	(324014, 145, '2015-01-15 00:44:39.000000', 'temperatura', 2.0000, 'ºC'),
	(324015, 145, '2015-01-15 00:44:40.000000', 'temperatura', 798.0000, 'ºC'),
	(324016, 145, '2015-01-15 00:44:41.000000', 'temperatura', 384.0000, 'ºC'),
	(324017, 145, '2015-01-15 00:44:42.000000', 'temperatura', 725.0000, 'ºC'),
	(324018, 145, '2015-01-15 00:44:43.000000', 'temperatura', 75.0000, 'ºC'),
	(324019, 145, '2015-01-15 00:44:44.000000', 'temperatura', 598.0000, 'ºC'),
	(324020, 145, '2015-01-15 00:44:45.000000', 'temperatura', 369.0000, 'ºC'),
	(324021, 145, '2015-01-15 00:44:46.000000', 'temperatura', 50.0000, 'ºC'),
	(324022, 145, '2015-01-15 00:44:47.000000', 'temperatura', 342.0000, 'ºC'),
	(324023, 145, '2015-01-15 00:44:48.000000', 'temperatura', 361.0000, 'ºC'),
	(324024, 145, '2015-01-15 00:44:49.000000', 'temperatura', 779.0000, 'ºC'),
	(324025, 145, '2015-01-15 00:44:50.000000', 'temperatura', 412.0000, 'ºC'),
	(324026, 145, '2015-01-15 00:44:51.000000', 'temperatura', 926.0000, 'ºC'),
	(324027, 145, '2015-01-15 00:44:52.000000', 'temperatura', 992.0000, 'ºC'),
	(324028, 145, '2015-01-15 00:44:53.000000', 'temperatura', 982.0000, 'ºC'),
	(324029, 145, '2015-01-15 00:44:54.000000', 'temperatura', 735.0000, 'ºC'),
	(324030, 145, '2015-01-15 00:44:55.000000', 'temperatura', 729.0000, 'ºC'),
	(324031, 145, '2015-01-15 00:44:56.000000', 'temperatura', 242.0000, 'ºC'),
	(324032, 145, '2015-01-15 00:44:57.000000', 'temperatura', 222.0000, 'ºC'),
	(324033, 145, '2015-01-15 00:44:58.000000', 'temperatura', 384.0000, 'ºC'),
	(324034, 145, '2015-01-15 00:44:59.000000', 'temperatura', 54.0000, 'ºC'),
	(324035, 145, '2015-01-15 00:45:00.000000', 'temperatura', 318.0000, 'ºC'),
	(324036, 145, '2015-01-15 00:45:01.000000', 'temperatura', 230.0000, 'ºC'),
	(324037, 145, '2015-01-15 00:45:02.000000', 'temperatura', 194.0000, 'ºC'),
	(324038, 145, '2015-01-15 00:45:03.000000', 'temperatura', 282.0000, 'ºC'),
	(324039, 145, '2015-01-15 00:45:04.000000', 'temperatura', 829.0000, 'ºC'),
	(324040, 145, '2015-01-15 00:45:05.000000', 'temperatura', 900.0000, 'ºC'),
	(324041, 145, '2015-01-15 00:45:06.000000', 'temperatura', 812.0000, 'ºC'),
	(324042, 145, '2015-01-15 00:45:07.000000', 'temperatura', 162.0000, 'ºC'),
	(324043, 145, '2015-01-15 00:45:08.000000', 'temperatura', 773.0000, 'ºC'),
	(324044, 145, '2015-01-15 00:45:09.000000', 'temperatura', 981.0000, 'ºC'),
	(324045, 145, '2015-01-15 00:45:10.000000', 'temperatura', 184.0000, 'ºC'),
	(324046, 145, '2015-01-15 00:45:11.000000', 'temperatura', 378.0000, 'ºC'),
	(324047, 145, '2015-01-15 00:45:12.000000', 'temperatura', 140.0000, 'ºC'),
	(324048, 145, '2015-01-15 00:45:13.000000', 'temperatura', 765.0000, 'ºC'),
	(324049, 145, '2015-01-15 00:45:14.000000', 'temperatura', 1005.0000, 'ºC'),
	(324050, 145, '2015-01-15 00:45:15.000000', 'temperatura', 330.0000, 'ºC'),
	(324051, 145, '2015-01-15 00:45:16.000000', 'temperatura', 1036.0000, 'ºC'),
	(324052, 145, '2015-01-15 00:45:17.000000', 'temperatura', 589.0000, 'ºC'),
	(324053, 145, '2015-01-15 00:45:18.000000', 'temperatura', 1039.0000, 'ºC'),
	(324054, 145, '2015-01-15 00:45:19.000000', 'temperatura', 1027.0000, 'ºC'),
	(324055, 145, '2015-01-15 00:45:20.000000', 'temperatura', 819.0000, 'ºC'),
	(324056, 145, '2015-01-15 00:45:21.000000', 'temperatura', 1015.0000, 'ºC'),
	(324057, 145, '2015-01-15 00:45:22.000000', 'temperatura', 219.0000, 'ºC'),
	(324058, 145, '2015-01-15 00:45:23.000000', 'temperatura', 449.0000, 'ºC'),
	(324059, 145, '2015-01-15 00:45:24.000000', 'temperatura', 389.0000, 'ºC'),
	(324060, 145, '2015-01-15 00:45:25.000000', 'temperatura', 598.0000, 'ºC'),
	(324061, 145, '2015-01-15 00:45:26.000000', 'temperatura', 625.0000, 'ºC'),
	(324062, 145, '2015-01-15 00:45:27.000000', 'temperatura', 129.0000, 'ºC'),
	(324063, 145, '2015-01-15 00:45:28.000000', 'temperatura', 1172.0000, 'ºC'),
	(324064, 145, '2015-01-15 00:45:29.000000', 'temperatura', 674.0000, 'ºC'),
	(324065, 145, '2015-01-15 00:45:30.000000', 'temperatura', 1054.0000, 'ºC'),
	(324066, 145, '2015-01-15 00:45:31.000000', 'temperatura', 847.0000, 'ºC'),
	(324067, 145, '2015-01-15 00:45:32.000000', 'temperatura', 1073.0000, 'ºC'),
	(324068, 145, '2015-01-15 00:45:33.000000', 'temperatura', 424.0000, 'ºC'),
	(324069, 145, '2015-01-15 00:45:34.000000', 'temperatura', 104.0000, 'ºC'),
	(324070, 145, '2015-01-15 00:45:35.000000', 'temperatura', 445.0000, 'ºC'),
	(324071, 145, '2015-01-15 00:45:36.000000', 'temperatura', 717.0000, 'ºC'),
	(324072, 145, '2015-01-15 00:45:37.000000', 'temperatura', 1050.0000, 'ºC'),
	(324073, 145, '2015-01-15 00:45:38.000000', 'temperatura', 699.0000, 'ºC'),
	(324074, 145, '2015-01-15 00:45:39.000000', 'temperatura', 344.0000, 'ºC'),
	(324075, 145, '2015-01-15 00:45:40.000000', 'temperatura', 823.0000, 'ºC'),
	(324076, 145, '2015-01-15 00:45:41.000000', 'temperatura', 686.0000, 'ºC'),
	(324077, 145, '2015-01-15 00:45:42.000000', 'temperatura', 958.0000, 'ºC'),
	(324078, 145, '2015-01-15 00:45:43.000000', 'temperatura', 336.0000, 'ºC'),
	(324079, 145, '2015-01-15 00:45:44.000000', 'temperatura', 6.0000, 'ºC'),
	(324080, 145, '2015-01-15 00:45:45.000000', 'temperatura', 221.0000, 'ºC'),
	(324081, 145, '2015-01-15 00:45:46.000000', 'temperatura', 1087.0000, 'ºC'),
	(324082, 145, '2015-01-15 00:45:47.000000', 'temperatura', 1174.0000, 'ºC'),
	(324083, 145, '2015-01-15 00:45:48.000000', 'temperatura', 208.0000, 'ºC'),
	(324084, 145, '2015-01-15 00:45:49.000000', 'temperatura', 1119.0000, 'ºC'),
	(324085, 145, '2015-01-15 00:45:50.000000', 'temperatura', 173.0000, 'ºC'),
	(324086, 145, '2015-01-15 00:45:51.000000', 'temperatura', 1108.0000, 'ºC'),
	(324087, 145, '2015-01-15 00:45:52.000000', 'temperatura', 223.0000, 'ºC'),
	(324088, 145, '2015-01-15 00:45:53.000000', 'temperatura', 188.0000, 'ºC'),
	(324089, 145, '2015-01-15 00:45:54.000000', 'temperatura', 274.0000, 'ºC'),
	(324090, 145, '2015-01-15 00:45:55.000000', 'temperatura', 804.0000, 'ºC'),
	(324091, 145, '2015-01-15 00:45:56.000000', 'temperatura', 800.0000, 'ºC'),
	(324092, 145, '2015-01-15 00:45:57.000000', 'temperatura', 390.0000, 'ºC'),
	(324093, 145, '2015-01-15 00:45:58.000000', 'temperatura', 750.0000, 'ºC'),
	(324094, 145, '2015-01-15 00:45:59.000000', 'temperatura', 180.0000, 'ºC'),
	(324095, 145, '2015-01-15 00:46:00.000000', 'temperatura', 1050.0000, 'ºC'),
	(324096, 145, '2015-01-15 00:46:01.000000', 'temperatura', 1112.0000, 'ºC'),
	(324097, 145, '2015-01-15 00:46:02.000000', 'temperatura', 9.0000, 'ºC'),
	(324098, 145, '2015-01-15 00:46:03.000000', 'temperatura', 310.0000, 'ºC'),
	(324099, 145, '2015-01-15 00:46:04.000000', 'temperatura', 322.0000, 'ºC'),
	(324100, 145, '2015-01-15 00:46:05.000000', 'temperatura', 684.0000, 'ºC'),
	(324101, 145, '2015-01-15 00:46:06.000000', 'temperatura', 51.0000, 'ºC'),
	(324102, 145, '2015-01-15 00:46:07.000000', 'temperatura', 606.0000, 'ºC'),
	(324103, 145, '2015-01-15 00:46:08.000000', 'temperatura', 475.0000, 'ºC'),
	(324104, 145, '2015-01-15 00:46:09.000000', 'temperatura', 557.0000, 'ºC'),
	(324105, 145, '2015-01-15 00:46:10.000000', 'temperatura', 163.0000, 'ºC'),
	(324106, 145, '2015-01-15 00:46:11.000000', 'temperatura', 344.0000, 'ºC'),
	(324107, 145, '2015-01-15 00:46:12.000000', 'temperatura', 31.0000, 'ºC'),
	(324108, 145, '2015-01-15 00:46:13.000000', 'temperatura', 326.0000, 'ºC'),
	(324109, 145, '2015-01-15 00:46:14.000000', 'temperatura', 334.0000, 'ºC'),
	(324110, 145, '2015-01-15 00:46:15.000000', 'temperatura', 695.0000, 'ºC'),
	(324111, 145, '2015-01-15 00:46:16.000000', 'temperatura', 72.0000, 'ºC'),
	(324112, 145, '2015-01-15 00:46:17.000000', 'temperatura', 678.0000, 'ºC'),
	(324113, 145, '2015-01-15 00:46:18.000000', 'temperatura', 773.0000, 'ºC'),
	(324114, 145, '2015-01-15 00:46:19.000000', 'temperatura', 633.0000, 'ºC'),
	(324115, 145, '2015-01-15 00:46:20.000000', 'temperatura', 846.0000, 'ºC'),
	(324116, 145, '2015-01-15 00:46:21.000000', 'temperatura', 1132.0000, 'ºC'),
	(324117, 145, '2015-01-15 00:46:22.000000', 'temperatura', 723.0000, 'ºC'),
	(324118, 145, '2015-01-15 00:46:23.000000', 'temperatura', 219.0000, 'ºC'),
	(324119, 145, '2015-01-15 00:46:24.000000', 'temperatura', 126.0000, 'ºC'),
	(324120, 145, '2015-01-15 00:46:25.000000', 'temperatura', 1176.0000, 'ºC'),
	(324121, 145, '2015-01-15 00:46:26.000000', 'temperatura', 699.0000, 'ºC'),
	(324122, 145, '2015-01-15 00:46:27.000000', 'temperatura', 1169.0000, 'ºC'),
	(324123, 145, '2015-01-15 00:46:28.000000', 'temperatura', 148.0000, 'ºC'),
	(324124, 145, '2015-01-15 00:46:29.000000', 'temperatura', 833.0000, 'ºC'),
	(324125, 145, '2015-01-15 00:46:30.000000', 'temperatura', 121.0000, 'ºC'),
	(324126, 145, '2015-01-15 00:46:31.000000', 'temperatura', 509.0000, 'ºC'),
	(324127, 145, '2015-01-15 00:46:32.000000', 'temperatura', 982.0000, 'ºC'),
	(324128, 145, '2015-01-15 00:46:33.000000', 'temperatura', 984.0000, 'ºC'),
	(324129, 145, '2015-01-15 00:46:34.000000', 'temperatura', 772.0000, 'ºC'),
	(324130, 145, '2015-01-15 00:46:35.000000', 'temperatura', 910.0000, 'ºC'),
	(324131, 145, '2015-01-15 00:46:36.000000', 'temperatura', 1036.0000, 'ºC'),
	(324132, 145, '2015-01-15 00:46:37.000000', 'temperatura', 49.0000, 'ºC'),
	(324133, 145, '2015-01-15 00:46:38.000000', 'temperatura', 736.0000, 'ºC'),
	(324134, 145, '2015-01-15 00:46:39.000000', 'temperatura', 1136.0000, 'ºC'),
	(324135, 145, '2015-01-15 00:46:40.000000', 'temperatura', 1072.0000, 'ºC'),
	(324136, 145, '2015-01-15 00:46:41.000000', 'temperatura', 752.0000, 'ºC'),
	(324137, 145, '2015-01-15 00:46:42.000000', 'temperatura', 544.0000, 'ºC'),
	(324138, 145, '2015-01-15 00:46:43.000000', 'temperatura', 463.0000, 'ºC'),
	(324139, 145, '2015-01-15 00:46:44.000000', 'temperatura', 687.0000, 'ºC'),
	(324140, 145, '2015-01-15 00:46:45.000000', 'temperatura', 844.0000, 'ºC'),
	(324141, 145, '2015-01-15 00:46:46.000000', 'temperatura', 958.0000, 'ºC'),
	(324142, 145, '2015-01-15 00:46:47.000000', 'temperatura', 1062.0000, 'ºC'),
	(324143, 145, '2015-01-15 00:46:48.000000', 'temperatura', 34.0000, 'ºC'),
	(324144, 145, '2015-01-15 00:46:49.000000', 'temperatura', 584.0000, 'ºC'),
	(324145, 145, '2015-01-15 00:46:50.000000', 'temperatura', 417.0000, 'ºC'),
	(324146, 145, '2015-01-15 00:46:51.000000', 'temperatura', 337.0000, 'ºC'),
	(324147, 145, '2015-01-15 00:46:52.000000', 'temperatura', 433.0000, 'ºC'),
	(324148, 145, '2015-01-15 00:46:53.000000', 'temperatura', 1153.0000, 'ºC'),
	(324149, 145, '2015-01-15 00:46:54.000000', 'temperatura', 868.0000, 'ºC'),
	(324150, 145, '2015-01-15 00:46:55.000000', 'temperatura', 883.0000, 'ºC'),
	(324151, 145, '2015-01-15 00:46:56.000000', 'temperatura', 611.0000, 'ºC'),
	(324152, 145, '2015-01-15 00:46:57.000000', 'temperatura', 404.0000, 'ºC'),
	(324153, 145, '2015-01-15 00:46:58.000000', 'temperatura', 190.0000, 'ºC'),
	(324154, 145, '2015-01-15 00:46:59.000000', 'temperatura', 938.0000, 'ºC'),
	(324155, 145, '2015-01-15 00:47:00.000000', 'temperatura', 520.0000, 'ºC'),
	(324156, 145, '2015-01-15 00:47:01.000000', 'temperatura', 986.0000, 'ºC'),
	(324157, 145, '2015-01-15 00:47:02.000000', 'temperatura', 973.0000, 'ºC'),
	(324158, 145, '2015-01-15 00:47:03.000000', 'temperatura', 704.0000, 'ºC'),
	(324159, 145, '2015-01-15 00:47:04.000000', 'temperatura', 603.0000, 'ºC'),
	(324160, 145, '2015-01-15 00:47:05.000000', 'temperatura', 904.0000, 'ºC'),
	(324161, 145, '2015-01-15 00:47:06.000000', 'temperatura', 310.0000, 'ºC'),
	(324162, 145, '2015-01-15 00:47:07.000000', 'temperatura', 41.0000, 'ºC'),
	(324163, 145, '2015-01-15 00:47:08.000000', 'temperatura', 474.0000, 'ºC'),
	(324164, 145, '2015-01-15 00:47:09.000000', 'temperatura', 1047.0000, 'ºC'),
	(324165, 145, '2015-01-15 00:47:10.000000', 'temperatura', 212.0000, 'ºC'),
	(324166, 145, '2015-01-15 00:47:11.000000', 'temperatura', 320.0000, 'ºC'),
	(324167, 145, '2015-01-15 00:47:12.000000', 'temperatura', 967.0000, 'ºC'),
	(324168, 145, '2015-01-15 00:47:13.000000', 'temperatura', 273.0000, 'ºC'),
	(324169, 145, '2015-01-15 00:47:14.000000', 'temperatura', 866.0000, 'ºC'),
	(324170, 145, '2015-01-15 00:47:15.000000', 'temperatura', 1112.0000, 'ºC'),
	(324171, 145, '2015-01-15 00:47:16.000000', 'temperatura', 560.0000, 'ºC'),
	(324172, 145, '2015-01-15 00:47:17.000000', 'temperatura', 665.0000, 'ºC'),
	(324173, 145, '2015-01-15 00:47:18.000000', 'temperatura', 445.0000, 'ºC'),
	(324174, 145, '2015-01-15 00:47:19.000000', 'temperatura', 231.0000, 'ºC'),
	(324175, 145, '2015-01-15 00:47:20.000000', 'temperatura', 1020.0000, 'ºC'),
	(324176, 145, '2015-01-15 00:47:21.000000', 'temperatura', 809.0000, 'ºC'),
	(324177, 145, '2015-01-15 00:47:22.000000', 'temperatura', 987.0000, 'ºC'),
	(324178, 145, '2015-01-15 00:47:23.000000', 'temperatura', 105.0000, 'ºC'),
	(324179, 145, '2015-01-15 00:47:24.000000', 'temperatura', 1165.0000, 'ºC'),
	(324180, 145, '2015-01-15 00:47:25.000000', 'temperatura', 712.0000, 'ºC'),
	(324181, 145, '2015-01-15 00:47:26.000000', 'temperatura', 67.0000, 'ºC'),
	(324182, 145, '2015-01-15 00:47:27.000000', 'temperatura', 596.0000, 'ºC'),
	(324183, 145, '2015-01-15 00:47:28.000000', 'temperatura', 382.0000, 'ºC'),
	(324184, 145, '2015-01-15 00:47:29.000000', 'temperatura', 123.0000, 'ºC'),
	(324185, 145, '2015-01-15 00:47:30.000000', 'temperatura', 668.0000, 'ºC'),
	(324186, 145, '2015-01-15 00:47:31.000000', 'temperatura', 572.0000, 'ºC'),
	(324187, 145, '2015-01-15 00:47:32.000000', 'temperatura', 858.0000, 'ºC'),
	(324188, 145, '2015-01-15 00:47:33.000000', 'temperatura', 173.0000, 'ºC'),
	(324189, 145, '2015-01-15 00:47:34.000000', 'temperatura', 693.0000, 'ºC'),
	(324190, 145, '2015-01-15 00:47:35.000000', 'temperatura', 544.0000, 'ºC'),
	(324191, 145, '2015-01-15 00:47:36.000000', 'temperatura', 641.0000, 'ºC'),
	(324192, 145, '2015-01-15 00:47:37.000000', 'temperatura', 373.0000, 'ºC'),
	(324193, 145, '2015-01-15 00:47:38.000000', 'temperatura', 1143.0000, 'ºC'),
	(324194, 145, '2015-01-15 00:47:39.000000', 'temperatura', 997.0000, 'ºC'),
	(324195, 145, '2015-01-15 00:47:40.000000', 'temperatura', 356.0000, 'ºC'),
	(324196, 145, '2015-01-15 00:47:41.000000', 'temperatura', 1191.0000, 'ºC'),
	(324197, 145, '2015-01-15 00:47:42.000000', 'temperatura', 86.0000, 'ºC'),
	(324198, 145, '2015-01-15 00:47:43.000000', 'temperatura', 459.0000, 'ºC'),
	(324199, 145, '2015-01-15 00:47:44.000000', 'temperatura', 835.0000, 'ºC'),
	(324200, 145, '2015-01-15 00:47:45.000000', 'temperatura', 401.0000, 'ºC'),
	(324201, 145, '2015-01-15 00:47:46.000000', 'temperatura', 698.0000, 'ºC'),
	(324202, 145, '2015-01-15 00:47:47.000000', 'temperatura', 1090.0000, 'ºC'),
	(324203, 145, '2015-01-15 00:47:48.000000', 'temperatura', 954.0000, 'ºC'),
	(324204, 145, '2015-01-15 00:47:49.000000', 'temperatura', 300.0000, 'ºC'),
	(324205, 145, '2015-01-15 00:47:50.000000', 'temperatura', 1038.0000, 'ºC'),
	(324206, 145, '2015-01-15 00:47:51.000000', 'temperatura', 690.0000, 'ºC'),
	(324207, 145, '2015-01-15 00:47:52.000000', 'temperatura', 337.0000, 'ºC'),
	(324208, 145, '2015-01-15 00:47:53.000000', 'temperatura', 816.0000, 'ºC'),
	(324209, 145, '2015-01-15 00:47:54.000000', 'temperatura', 668.0000, 'ºC'),
	(324210, 145, '2015-01-15 00:47:55.000000', 'temperatura', 892.0000, 'ºC'),
	(324211, 145, '2015-01-15 00:47:56.000000', 'temperatura', 59.0000, 'ºC'),
	(324212, 145, '2015-01-15 00:47:57.000000', 'temperatura', 17.0000, 'ºC'),
	(324213, 145, '2015-01-15 00:47:58.000000', 'temperatura', 1110.0000, 'ºC'),
	(324214, 145, '2015-01-15 00:47:59.000000', 'temperatura', 700.0000, 'ºC'),
	(324215, 145, '2015-01-15 00:48:00.000000', 'temperatura', 169.0000, 'ºC'),
	(324216, 145, '2015-01-15 00:48:01.000000', 'temperatura', 1147.0000, 'ºC'),
	(324217, 145, '2015-01-15 00:48:02.000000', 'temperatura', 428.0000, 'ºC'),
	(324218, 145, '2015-01-15 00:48:03.000000', 'temperatura', 1099.0000, 'ºC'),
	(324219, 145, '2015-01-15 00:48:04.000000', 'temperatura', 613.0000, 'ºC'),
	(324220, 145, '2015-01-15 00:48:05.000000', 'temperatura', 967.0000, 'ºC'),
	(324221, 145, '2015-01-15 00:48:06.000000', 'temperatura', 598.0000, 'ºC'),
	(324222, 145, '2015-01-15 00:48:07.000000', 'temperatura', 89.0000, 'ºC'),
	(324223, 145, '2015-01-15 00:48:08.000000', 'temperatura', 1049.0000, 'ºC'),
	(324224, 145, '2015-01-15 00:48:09.000000', 'temperatura', 181.0000, 'ºC'),
	(324225, 145, '2015-01-15 00:48:10.000000', 'temperatura', 159.0000, 'ºC'),
	(324226, 145, '2015-01-15 00:48:11.000000', 'temperatura', 253.0000, 'ºC'),
	(324227, 145, '2015-01-15 00:48:12.000000', 'temperatura', 787.0000, 'ºC'),
	(324228, 145, '2015-01-15 00:48:13.000000', 'temperatura', 776.0000, 'ºC'),
	(324229, 145, '2015-01-15 00:48:14.000000', 'temperatura', 319.0000, 'ºC'),
	(324230, 145, '2015-01-15 00:48:15.000000', 'temperatura', 469.0000, 'ºC'),
	(324231, 145, '2015-01-15 00:48:16.000000', 'temperatura', 187.0000, 'ºC'),
	(324232, 145, '2015-01-15 00:48:17.000000', 'temperatura', 729.0000, 'ºC'),
	(324233, 145, '2015-01-15 00:48:18.000000', 'temperatura', 685.0000, 'ºC'),
	(324234, 145, '2015-01-15 00:48:19.000000', 'temperatura', 37.0000, 'ºC'),
	(324235, 145, '2015-01-15 00:48:20.000000', 'temperatura', 529.0000, 'ºC'),
	(324236, 145, '2015-01-15 00:48:21.000000', 'temperatura', 138.0000, 'ºC'),
	(324237, 145, '2015-01-15 00:48:22.000000', 'temperatura', 300.0000, 'ºC'),
	(324238, 145, '2015-01-15 00:48:23.000000', 'temperatura', 1088.0000, 'ºC'),
	(324239, 145, '2015-01-15 00:48:24.000000', 'temperatura', 943.0000, 'ºC'),
	(324240, 145, '2015-01-15 00:48:25.000000', 'temperatura', 248.0000, 'ºC'),
	(324241, 145, '2015-01-15 00:48:26.000000', 'temperatura', 811.0000, 'ºC'),
	(324242, 145, '2015-01-15 00:48:27.000000', 'temperatura', 914.0000, 'ºC'),
	(324243, 145, '2015-01-15 00:48:28.000000', 'temperatura', 935.0000, 'ºC'),
	(324244, 145, '2015-01-15 00:48:29.000000', 'temperatura', 736.0000, 'ºC'),
	(324245, 145, '2015-01-15 00:48:30.000000', 'temperatura', 874.0000, 'ºC'),
	(324246, 145, '2015-01-15 00:48:31.000000', 'temperatura', 964.0000, 'ºC'),
	(324247, 145, '2015-01-15 00:48:32.000000', 'temperatura', 997.0000, 'ºC'),
	(324248, 145, '2015-01-15 00:48:33.000000', 'temperatura', 894.0000, 'ºC'),
	(324249, 145, '2015-01-15 00:48:34.000000', 'temperatura', 279.0000, 'ºC'),
	(324250, 145, '2015-01-15 00:48:35.000000', 'temperatura', 1115.0000, 'ºC'),
	(324251, 145, '2015-01-15 00:48:36.000000', 'temperatura', 1138.0000, 'ºC'),
	(324252, 145, '2015-01-15 00:48:37.000000', 'temperatura', 1147.0000, 'ºC'),
	(324253, 145, '2015-01-15 00:48:38.000000', 'temperatura', 1122.0000, 'ºC'),
	(324254, 145, '2015-01-15 00:48:39.000000', 'temperatura', 968.0000, 'ºC'),
	(324255, 145, '2015-01-15 00:48:40.000000', 'temperatura', 275.0000, 'ºC'),
	(324256, 145, '2015-01-15 00:48:41.000000', 'temperatura', 873.0000, 'ºC'),
	(324257, 145, '2015-01-15 00:48:42.000000', 'temperatura', 1141.0000, 'ºC'),
	(324258, 145, '2015-01-15 00:48:43.000000', 'temperatura', 686.0000, 'ºC'),
	(324259, 145, '2015-01-15 00:48:44.000000', 'temperatura', 5.0000, 'ºC'),
	(324260, 145, '2015-01-15 00:48:45.000000', 'temperatura', 370.0000, 'ºC'),
	(324261, 145, '2015-01-15 00:48:46.000000', 'temperatura', 634.0000, 'ºC'),
	(324262, 145, '2015-01-15 00:48:47.000000', 'temperatura', 862.0000, 'ºC'),
	(324263, 145, '2015-01-15 00:48:48.000000', 'temperatura', 8.0000, 'ºC'),
	(324264, 145, '2015-01-15 00:48:49.000000', 'temperatura', 1052.0000, 'ºC'),
	(324265, 145, '2015-01-15 00:48:50.000000', 'temperatura', 440.0000, 'ºC'),
	(324266, 145, '2015-01-15 00:48:51.000000', 'temperatura', 244.0000, 'ºC'),
	(324267, 145, '2015-01-15 00:48:52.000000', 'temperatura', 1099.0000, 'ºC'),
	(324268, 145, '2015-01-15 00:48:53.000000', 'temperatura', 1166.0000, 'ºC'),
	(324269, 145, '2015-01-15 00:48:54.000000', 'temperatura', 131.0000, 'ºC'),
	(324270, 145, '2015-01-15 00:48:55.000000', 'temperatura', 759.0000, 'ºC'),
	(324271, 145, '2015-01-15 00:48:56.000000', 'temperatura', 1001.0000, 'ºC'),
	(324272, 145, '2015-01-15 00:48:57.000000', 'temperatura', 328.0000, 'ºC'),
	(324273, 145, '2015-01-15 00:48:58.000000', 'temperatura', 1037.0000, 'ºC'),
	(324274, 145, '2015-01-15 00:48:59.000000', 'temperatura', 601.0000, 'ºC'),
	(324275, 145, '2015-01-15 00:49:00.000000', 'temperatura', 1097.0000, 'ºC'),
	(324276, 145, '2015-01-15 00:49:01.000000', 'temperatura', 83.0000, 'ºC'),
	(324277, 145, '2015-01-15 00:49:02.000000', 'temperatura', 725.0000, 'ºC'),
	(324278, 145, '2015-01-15 00:49:03.000000', 'temperatura', 974.0000, 'ºC'),
	(324279, 145, '2015-01-15 00:49:04.000000', 'temperatura', 295.0000, 'ºC'),
	(324280, 145, '2015-01-15 00:49:05.000000', 'temperatura', 956.0000, 'ºC'),
	(324281, 145, '2015-01-15 00:49:06.000000', 'temperatura', 297.0000, 'ºC'),
	(324282, 145, '2015-01-15 00:49:07.000000', 'temperatura', 1014.0000, 'ºC'),
	(324283, 145, '2015-01-15 00:49:08.000000', 'temperatura', 580.0000, 'ºC'),
	(324284, 145, '2015-01-15 00:49:09.000000', 'temperatura', 1059.0000, 'ºC'),
	(324285, 145, '2015-01-15 00:49:10.000000', 'temperatura', 1156.0000, 'ºC'),
	(324286, 145, '2015-01-15 00:49:11.000000', 'temperatura', 203.0000, 'ºC'),
	(324287, 145, '2015-01-15 00:49:12.000000', 'temperatura', 1148.0000, 'ºC'),
	(324288, 145, '2015-01-15 00:49:13.000000', 'temperatura', 332.0000, 'ºC'),
	(324289, 145, '2015-01-15 00:49:14.000000', 'temperatura', 617.0000, 'ºC'),
	(324290, 145, '2015-01-15 00:49:15.000000', 'temperatura', 888.0000, 'ºC'),
	(324291, 145, '2015-01-15 00:49:16.000000', 'temperatura', 192.0000, 'ºC'),
	(324292, 145, '2015-01-15 00:49:17.000000', 'temperatura', 696.0000, 'ºC'),
	(324293, 145, '2015-01-15 00:49:18.000000', 'temperatura', 502.0000, 'ºC'),
	(324294, 145, '2015-01-15 00:49:19.000000', 'temperatura', 426.0000, 'ºC'),
	(324295, 145, '2015-01-15 00:49:20.000000', 'temperatura', 623.0000, 'ºC'),
	(324296, 145, '2015-01-15 00:49:21.000000', 'temperatura', 636.0000, 'ºC'),
	(324297, 145, '2015-01-15 00:49:22.000000', 'temperatura', 113.0000, 'ºC'),
	(324298, 145, '2015-01-15 00:49:23.000000', 'temperatura', 1056.0000, 'ºC'),
	(324299, 145, '2015-01-15 00:49:24.000000', 'temperatura', 142.0000, 'ºC'),
	(324300, 145, '2015-01-15 00:49:25.000000', 'temperatura', 1145.0000, 'ºC'),
	(324301, 145, '2015-01-15 00:49:26.000000', 'temperatura', 496.0000, 'ºC'),
	(324302, 145, '2015-01-15 00:49:27.000000', 'temperatura', 248.0000, 'ºC'),
	(324303, 145, '2015-01-15 00:49:28.000000', 'temperatura', 953.0000, 'ºC'),
	(324304, 145, '2015-01-15 00:49:29.000000', 'temperatura', 421.0000, 'ºC'),
	(324305, 145, '2015-01-15 00:49:30.000000', 'temperatura', 447.0000, 'ºC'),
	(324306, 145, '2015-01-15 00:49:31.000000', 'temperatura', 973.0000, 'ºC'),
	(324307, 145, '2015-01-15 00:49:32.000000', 'temperatura', 1125.0000, 'ºC'),
	(324308, 145, '2015-01-15 00:49:33.000000', 'temperatura', 304.0000, 'ºC'),
	(324309, 145, '2015-01-15 00:49:34.000000', 'temperatura', 547.0000, 'ºC'),
	(324310, 145, '2015-01-15 00:49:35.000000', 'temperatura', 622.0000, 'ºC'),
	(324311, 145, '2015-01-15 00:49:36.000000', 'temperatura', 269.0000, 'ºC'),
	(324312, 145, '2015-01-15 00:49:37.000000', 'temperatura', 682.0000, 'ºC'),
	(324313, 145, '2015-01-15 00:49:38.000000', 'temperatura', 202.0000, 'ºC'),
	(324314, 145, '2015-01-15 00:49:39.000000', 'temperatura', 164.0000, 'ºC'),
	(324315, 145, '2015-01-15 00:49:40.000000', 'temperatura', 216.0000, 'ºC'),
	(324316, 145, '2015-01-15 00:49:41.000000', 'temperatura', 590.0000, 'ºC'),
	(324317, 145, '2015-01-15 00:49:42.000000', 'temperatura', 1099.0000, 'ºC'),
	(324318, 145, '2015-01-15 00:49:43.000000', 'temperatura', 128.0000, 'ºC'),
	(324319, 145, '2015-01-15 00:49:44.000000', 'temperatura', 943.0000, 'ºC'),
	(324320, 145, '2015-01-15 00:49:45.000000', 'temperatura', 733.0000, 'ºC'),
	(324321, 145, '2015-01-15 00:49:46.000000', 'temperatura', 835.0000, 'ºC'),
	(324322, 145, '2015-01-15 00:49:47.000000', 'temperatura', 775.0000, 'ºC'),
	(324323, 145, '2015-01-15 00:49:48.000000', 'temperatura', 171.0000, 'ºC'),
	(324324, 145, '2015-01-15 00:49:49.000000', 'temperatura', 930.0000, 'ºC'),
	(324325, 145, '2015-01-15 00:49:50.000000', 'temperatura', 538.0000, 'ºC'),
	(324326, 145, '2015-01-15 00:49:51.000000', 'temperatura', 1102.0000, 'ºC'),
	(324327, 145, '2015-01-15 00:49:52.000000', 'temperatura', 296.0000, 'ºC'),
	(324328, 145, '2015-01-15 00:49:53.000000', 'temperatura', 573.0000, 'ºC'),
	(324329, 145, '2015-01-15 00:49:54.000000', 'temperatura', 779.0000, 'ºC'),
	(324330, 145, '2015-01-15 00:49:55.000000', 'temperatura', 975.0000, 'ºC'),
	(324331, 145, '2015-01-15 00:49:56.000000', 'temperatura', 141.0000, 'ºC'),
	(324332, 145, '2015-01-15 00:49:57.000000', 'temperatura', 180.0000, 'ºC'),
	(324333, 145, '2015-01-15 00:49:58.000000', 'temperatura', 477.0000, 'ºC'),
	(324334, 145, '2015-01-15 00:49:59.000000', 'temperatura', 644.0000, 'ºC'),
	(324335, 145, '2015-01-15 00:50:00.000000', 'temperatura', 590.0000, 'ºC'),
	(324336, 145, '2015-01-15 00:50:01.000000', 'temperatura', 1019.0000, 'ºC'),
	(324337, 145, '2015-01-15 00:50:02.000000', 'temperatura', 924.0000, 'ºC'),
	(324338, 145, '2015-01-15 00:50:03.000000', 'temperatura', 366.0000, 'ºC'),
	(324339, 145, '2015-01-15 00:50:04.000000', 'temperatura', 257.0000, 'ºC'),
	(324340, 145, '2015-01-15 00:50:05.000000', 'temperatura', 187.0000, 'ºC'),
	(324341, 145, '2015-01-15 00:50:06.000000', 'temperatura', 163.0000, 'ºC'),
	(324342, 145, '2015-01-15 00:50:07.000000', 'temperatura', 258.0000, 'ºC'),
	(324343, 145, '2015-01-15 00:50:08.000000', 'temperatura', 798.0000, 'ºC'),
	(324344, 145, '2015-01-15 00:50:09.000000', 'temperatura', 818.0000, 'ºC'),
	(324345, 145, '2015-01-15 00:50:10.000000', 'temperatura', 495.0000, 'ºC'),
	(324346, 145, '2015-01-15 00:50:11.000000', 'temperatura', 24.0000, 'ºC'),
	(324347, 145, '2015-01-15 00:50:12.000000', 'temperatura', 1033.0000, 'ºC'),
	(324348, 145, '2015-01-15 00:50:13.000000', 'temperatura', 297.0000, 'ºC'),
	(324349, 145, '2015-01-15 00:50:14.000000', 'temperatura', 783.0000, 'ºC'),
	(324350, 145, '2015-01-15 00:50:15.000000', 'temperatura', 626.0000, 'ºC'),
	(324351, 145, '2015-01-15 00:50:16.000000', 'temperatura', 781.0000, 'ºC'),
	(324352, 145, '2015-01-15 00:50:17.000000', 'temperatura', 826.0000, 'ºC'),
	(324353, 145, '2015-01-15 00:50:18.000000', 'temperatura', 590.0000, 'ºC'),
	(324354, 145, '2015-01-15 00:50:19.000000', 'temperatura', 473.0000, 'ºC'),
	(324355, 145, '2015-01-15 00:50:20.000000', 'temperatura', 592.0000, 'ºC'),
	(324356, 145, '2015-01-15 00:50:21.000000', 'temperatura', 345.0000, 'ºC'),
	(324357, 145, '2015-01-15 00:50:22.000000', 'temperatura', 1149.0000, 'ºC'),
	(324358, 145, '2015-01-15 00:50:23.000000', 'temperatura', 1110.0000, 'ºC'),
	(324359, 145, '2015-01-15 00:50:24.000000', 'temperatura', 903.0000, 'ºC'),
	(324360, 145, '2015-01-15 00:50:25.000000', 'temperatura', 1184.0000, 'ºC'),
	(324361, 145, '2015-01-15 00:50:26.000000', 'temperatura', 812.0000, 'ºC'),
	(324362, 145, '2015-01-15 00:50:27.000000', 'temperatura', 507.0000, 'ºC'),
	(324363, 145, '2015-01-15 00:50:28.000000', 'temperatura', 101.0000, 'ºC'),
	(324364, 145, '2015-01-15 00:50:29.000000', 'temperatura', 186.0000, 'ºC'),
	(324365, 145, '2015-01-15 00:50:30.000000', 'temperatura', 628.0000, 'ºC'),
	(324366, 145, '2015-01-15 00:50:31.000000', 'temperatura', 181.0000, 'ºC'),
	(324367, 145, '2015-01-15 00:50:32.000000', 'temperatura', 221.0000, 'ºC'),
	(324368, 145, '2015-01-15 00:50:33.000000', 'temperatura', 564.0000, 'ºC'),
	(324369, 145, '2015-01-15 00:50:34.000000', 'temperatura', 955.0000, 'ºC'),
	(324370, 145, '2015-01-15 00:50:35.000000', 'temperatura', 684.0000, 'ºC'),
	(324371, 145, '2015-01-15 00:50:36.000000', 'temperatura', 557.0000, 'ºC'),
	(324372, 145, '2015-01-15 00:50:37.000000', 'temperatura', 734.0000, 'ºC'),
	(324373, 145, '2015-01-15 00:50:38.000000', 'temperatura', 798.0000, 'ºC'),
	(324374, 145, '2015-01-15 00:50:39.000000', 'temperatura', 589.0000, 'ºC'),
	(324375, 145, '2015-01-15 00:50:40.000000', 'temperatura', 553.0000, 'ºC'),
	(324376, 145, '2015-01-15 00:50:41.000000', 'temperatura', 998.0000, 'ºC'),
	(324377, 145, '2015-01-15 00:50:42.000000', 'temperatura', 929.0000, 'ºC'),
	(324378, 145, '2015-01-15 00:50:43.000000', 'temperatura', 454.0000, 'ºC'),
	(324379, 145, '2015-01-15 00:50:44.000000', 'temperatura', 685.0000, 'ºC'),
	(324380, 145, '2015-01-15 00:50:45.000000', 'temperatura', 861.0000, 'ºC'),
	(324381, 145, '2015-01-15 00:50:46.000000', 'temperatura', 1050.0000, 'ºC'),
	(324382, 145, '2015-01-15 00:50:47.000000', 'temperatura', 270.0000, 'ºC'),
	(324383, 145, '2015-01-15 00:50:48.000000', 'temperatura', 598.0000, 'ºC'),
	(324384, 145, '2015-01-15 00:50:49.000000', 'temperatura', 980.0000, 'ºC'),
	(324385, 145, '2015-01-15 00:50:50.000000', 'temperatura', 708.0000, 'ºC'),
	(324386, 145, '2015-01-15 00:50:51.000000', 'temperatura', 600.0000, 'ºC'),
	(324387, 145, '2015-01-15 00:50:52.000000', 'temperatura', 876.0000, 'ºC'),
	(324388, 145, '2015-01-15 00:50:53.000000', 'temperatura', 179.0000, 'ºC'),
	(324389, 145, '2015-01-15 00:50:54.000000', 'temperatura', 669.0000, 'ºC'),
	(324390, 145, '2015-01-15 00:50:55.000000', 'temperatura', 410.0000, 'ºC'),
	(324391, 145, '2015-01-15 00:50:56.000000', 'temperatura', 44.0000, 'ºC'),
	(324392, 145, '2015-01-15 00:50:57.000000', 'temperatura', 190.0000, 'ºC'),
	(324393, 145, '2015-01-15 00:50:58.000000', 'temperatura', 818.0000, 'ºC'),
	(324394, 145, '2015-01-15 00:50:59.000000', 'temperatura', 1122.0000, 'ºC'),
	(324395, 145, '2015-01-15 00:51:00.000000', 'temperatura', 757.0000, 'ºC'),
	(324396, 145, '2015-01-15 00:51:01.000000', 'temperatura', 417.0000, 'ºC'),
	(324397, 145, '2015-01-15 00:51:02.000000', 'temperatura', 1014.0000, 'ºC'),
	(324398, 145, '2015-01-15 00:51:03.000000', 'temperatura', 222.0000, 'ºC'),
	(324399, 145, '2015-01-15 00:51:04.000000', 'temperatura', 467.0000, 'ºC'),
	(324400, 145, '2015-01-15 00:51:05.000000', 'temperatura', 471.0000, 'ºC'),
	(324401, 145, '2015-01-15 00:51:06.000000', 'temperatura', 953.0000, 'ºC'),
	(324402, 145, '2015-01-15 00:51:07.000000', 'temperatura', 952.0000, 'ºC'),
	(324403, 145, '2015-01-15 00:51:08.000000', 'temperatura', 703.0000, 'ºC'),
	(324404, 145, '2015-01-15 00:51:09.000000', 'temperatura', 660.0000, 'ºC'),
	(324405, 145, '2015-01-15 00:51:10.000000', 'temperatura', 1192.0000, 'ºC'),
	(324406, 145, '2015-01-15 00:51:11.000000', 'temperatura', 378.0000, 'ºC'),
	(324407, 145, '2015-01-15 00:51:12.000000', 'temperatura', 714.0000, 'ºC'),
	(324408, 145, '2015-01-15 00:51:13.000000', 'temperatura', 38.0000, 'ºC'),
	(324409, 145, '2015-01-15 00:51:14.000000', 'temperatura', 449.0000, 'ºC'),
	(324410, 145, '2015-01-15 00:51:15.000000', 'temperatura', 933.0000, 'ºC'),
	(324411, 145, '2015-01-15 00:51:16.000000', 'temperatura', 915.0000, 'ºC'),
	(324412, 145, '2015-01-15 00:51:17.000000', 'temperatura', 579.0000, 'ºC'),
	(324413, 145, '2015-01-15 00:51:18.000000', 'temperatura', 150.0000, 'ºC'),
	(324414, 145, '2015-01-15 00:51:19.000000', 'temperatura', 213.0000, 'ºC'),
	(324415, 145, '2015-01-15 00:51:20.000000', 'temperatura', 614.0000, 'ºC'),
	(324416, 145, '2015-01-15 00:51:21.000000', 'temperatura', 33.0000, 'ºC'),
	(324417, 145, '2015-01-15 00:51:22.000000', 'temperatura', 725.0000, 'ºC'),
	(324418, 145, '2015-01-15 00:51:23.000000', 'temperatura', 1124.0000, 'ºC'),
	(324419, 145, '2015-01-15 00:51:24.000000', 'temperatura', 1046.0000, 'ºC'),
	(324420, 145, '2015-01-15 00:51:25.000000', 'temperatura', 661.0000, 'ºC'),
	(324421, 145, '2015-01-15 00:51:26.000000', 'temperatura', 164.0000, 'ºC'),
	(324422, 145, '2015-01-15 00:51:27.000000', 'temperatura', 40.0000, 'ºC'),
	(324423, 145, '2015-01-15 00:51:28.000000', 'temperatura', 907.0000, 'ºC'),
	(324424, 145, '2015-01-15 00:51:29.000000', 'temperatura', 817.0000, 'ºC'),
	(324425, 145, '2015-01-15 00:51:30.000000', 'temperatura', 166.0000, 'ºC'),
	(324426, 145, '2015-01-15 00:51:31.000000', 'temperatura', 777.0000, 'ºC'),
	(324427, 145, '2015-01-15 00:51:32.000000', 'temperatura', 990.0000, 'ºC'),
	(324428, 145, '2015-01-15 00:51:33.000000', 'temperatura', 218.0000, 'ºC'),
	(324429, 145, '2015-01-15 00:51:34.000000', 'temperatura', 521.0000, 'ºC'),
	(324430, 145, '2015-01-15 00:51:35.000000', 'temperatura', 750.0000, 'ºC'),
	(324431, 145, '2015-01-15 00:51:36.000000', 'temperatura', 990.0000, 'ºC'),
	(324432, 145, '2015-01-15 00:51:37.000000', 'temperatura', 299.0000, 'ºC'),
	(324433, 145, '2015-01-15 00:51:38.000000', 'temperatura', 924.0000, 'ºC'),
	(324434, 145, '2015-01-15 00:51:39.000000', 'temperatura', 123.0000, 'ºC'),
	(324435, 145, '2015-01-15 00:51:40.000000', 'temperatura', 246.0000, 'ºC'),
	(324436, 145, '2015-01-15 00:51:41.000000', 'temperatura', 861.0000, 'ºC'),
	(324437, 145, '2015-01-15 00:51:42.000000', 'temperatura', 1166.0000, 'ºC'),
	(324438, 145, '2015-01-15 00:51:43.000000', 'temperatura', 847.0000, 'ºC'),
	(324439, 145, '2015-01-15 00:51:44.000000', 'temperatura', 737.0000, 'ºC'),
	(324440, 145, '2015-01-15 00:51:45.000000', 'temperatura', 1145.0000, 'ºC'),
	(324441, 145, '2015-01-15 00:51:46.000000', 'temperatura', 1114.0000, 'ºC'),
	(324442, 145, '2015-01-15 00:51:47.000000', 'temperatura', 936.0000, 'ºC'),
	(324443, 145, '2015-01-15 00:51:48.000000', 'temperatura', 138.0000, 'ºC'),
	(324444, 145, '2015-01-15 00:51:49.000000', 'temperatura', 281.0000, 'ºC'),
	(324445, 145, '2015-01-15 00:51:50.000000', 'temperatura', 993.0000, 'ºC'),
	(324446, 145, '2015-01-15 00:51:51.000000', 'temperatura', 524.0000, 'ºC'),
	(324447, 145, '2015-01-15 00:51:52.000000', 'temperatura', 841.0000, 'ºC'),
	(324448, 145, '2015-01-15 00:51:53.000000', 'temperatura', 235.0000, 'ºC'),
	(324449, 145, '2015-01-15 00:51:54.000000', 'temperatura', 1050.0000, 'ºC'),
	(324450, 145, '2015-01-15 00:51:55.000000', 'temperatura', 947.0000, 'ºC'),
	(324451, 145, '2015-01-15 00:51:56.000000', 'temperatura', 386.0000, 'ºC'),
	(324452, 145, '2015-01-15 00:51:57.000000', 'temperatura', 289.0000, 'ºC'),
	(324453, 145, '2015-01-15 00:51:58.000000', 'temperatura', 285.0000, 'ºC'),
	(324454, 145, '2015-01-15 00:51:59.000000', 'temperatura', 562.0000, 'ºC'),
	(324455, 145, '2015-01-15 00:52:00.000000', 'temperatura', 754.0000, 'ºC'),
	(324456, 145, '2015-01-15 00:52:01.000000', 'temperatura', 885.0000, 'ºC'),
	(324457, 145, '2015-01-15 00:52:02.000000', 'temperatura', 962.0000, 'ºC'),
	(324458, 145, '2015-01-15 00:52:03.000000', 'temperatura', 957.0000, 'ºC'),
	(324459, 145, '2015-01-15 00:52:04.000000', 'temperatura', 697.0000, 'ºC'),
	(324460, 145, '2015-01-15 00:52:05.000000', 'temperatura', 618.0000, 'ºC'),
	(324461, 145, '2015-01-15 00:52:06.000000', 'temperatura', 998.0000, 'ºC'),
	(324462, 145, '2015-01-15 00:52:07.000000', 'temperatura', 738.0000, 'ºC'),
	(324463, 145, '2015-01-15 00:52:08.000000', 'temperatura', 695.0000, 'ºC'),
	(324464, 145, '2015-01-15 00:52:09.000000', 'temperatura', 63.0000, 'ºC'),
	(324465, 145, '2015-01-15 00:52:10.000000', 'temperatura', 629.0000, 'ºC'),
	(324466, 145, '2015-01-15 00:52:11.000000', 'temperatura', 555.0000, 'ºC'),
	(324467, 145, '2015-01-15 00:52:12.000000', 'temperatura', 892.0000, 'ºC'),
	(324468, 145, '2015-01-15 00:52:13.000000', 'temperatura', 392.0000, 'ºC'),
	(324469, 145, '2015-01-15 00:52:14.000000', 'temperatura', 487.0000, 'ºC'),
	(324470, 145, '2015-01-15 00:52:15.000000', 'temperatura', 61.0000, 'ºC'),
	(324471, 145, '2015-01-15 00:52:16.000000', 'temperatura', 41.0000, 'ºC'),
	(324472, 145, '2015-01-15 00:52:17.000000', 'temperatura', 26.0000, 'ºC'),
	(324473, 145, '2015-01-15 00:52:18.000000', 'temperatura', 5.0000, 'ºC'),
	(324474, 145, '2015-01-15 00:52:19.000000', 'temperatura', 1148.0000, 'ºC'),
	(324475, 145, '2015-01-15 00:52:20.000000', 'temperatura', 928.0000, 'ºC'),
	(324476, 145, '2015-01-15 00:52:21.000000', 'temperatura', 1193.0000, 'ºC'),
	(324477, 145, '2015-01-15 00:52:22.000000', 'temperatura', 785.0000, 'ºC'),
	(324478, 145, '2015-01-15 00:52:23.000000', 'temperatura', 344.0000, 'ºC'),
	(324479, 145, '2015-01-15 00:52:24.000000', 'temperatura', 568.0000, 'ºC'),
	(324480, 145, '2015-01-15 00:52:25.000000', 'temperatura', 606.0000, 'ºC'),
	(324481, 145, '2015-01-15 00:52:26.000000', 'temperatura', 129.0000, 'ºC'),
	(324482, 145, '2015-01-15 00:52:27.000000', 'temperatura', 26.0000, 'ºC'),
	(324483, 145, '2015-01-15 00:52:28.000000', 'temperatura', 943.0000, 'ºC'),
	(324484, 145, '2015-01-15 00:52:29.000000', 'temperatura', 1037.0000, 'ºC'),
	(324485, 145, '2015-01-15 00:52:30.000000', 'temperatura', 1156.0000, 'ºC'),
	(324486, 145, '2015-01-15 00:52:31.000000', 'temperatura', 271.0000, 'ºC'),
	(324487, 145, '2015-01-15 00:52:32.000000', 'temperatura', 285.0000, 'ºC'),
	(324488, 145, '2015-01-15 00:52:33.000000', 'temperatura', 615.0000, 'ºC'),
	(324489, 145, '2015-01-15 00:52:34.000000', 'temperatura', 1021.0000, 'ºC'),
	(324490, 145, '2015-01-15 00:52:35.000000', 'temperatura', 858.0000, 'ºC'),
	(324491, 145, '2015-01-15 00:52:36.000000', 'temperatura', 28.0000, 'ºC'),
	(324492, 145, '2015-01-15 00:52:37.000000', 'temperatura', 1166.0000, 'ºC'),
	(324493, 145, '2015-01-15 00:52:38.000000', 'temperatura', 948.0000, 'ºC'),
	(324494, 145, '2015-01-15 00:52:39.000000', 'temperatura', 43.0000, 'ºC'),
	(324495, 145, '2015-01-15 00:52:40.000000', 'temperatura', 969.0000, 'ºC'),
	(324496, 145, '2015-01-15 00:52:41.000000', 'temperatura', 1116.0000, 'ºC'),
	(324497, 145, '2015-01-15 00:52:42.000000', 'temperatura', 276.0000, 'ºC'),
	(324498, 145, '2015-01-15 00:52:43.000000', 'temperatura', 431.0000, 'ºC'),
	(324499, 145, '2015-01-15 00:52:44.000000', 'temperatura', 126.0000, 'ºC'),
	(324500, 145, '2015-01-15 00:52:45.000000', 'temperatura', 540.0000, 'ºC'),
	(324501, 145, '2015-01-15 00:52:46.000000', 'temperatura', 1120.0000, 'ºC'),
	(324502, 145, '2015-01-15 00:52:47.000000', 'temperatura', 381.0000, 'ºC'),
	(324503, 145, '2015-01-15 00:52:48.000000', 'temperatura', 946.0000, 'ºC'),
	(324504, 145, '2015-01-15 00:52:49.000000', 'temperatura', 1189.0000, 'ºC'),
	(324505, 145, '2015-01-15 00:52:50.000000', 'temperatura', 705.0000, 'ºC'),
	(324506, 145, '2015-01-15 00:52:51.000000', 'temperatura', 1160.0000, 'ºC'),
	(324507, 145, '2015-01-15 00:52:52.000000', 'temperatura', 85.0000, 'ºC'),
	(324508, 145, '2015-01-15 00:52:53.000000', 'temperatura', 544.0000, 'ºC'),
	(324509, 145, '2015-01-15 00:52:54.000000', 'temperatura', 66.0000, 'ºC'),
	(324510, 145, '2015-01-15 00:52:55.000000', 'temperatura', 1099.0000, 'ºC'),
	(324511, 145, '2015-01-15 00:52:56.000000', 'temperatura', 498.0000, 'ºC'),
	(324512, 145, '2015-01-15 00:52:57.000000', 'temperatura', 392.0000, 'ºC'),
	(324513, 145, '2015-01-15 00:52:58.000000', 'temperatura', 468.0000, 'ºC'),
	(324514, 145, '2015-01-15 00:52:59.000000', 'temperatura', 1165.0000, 'ºC'),
	(324515, 145, '2015-01-15 00:53:00.000000', 'temperatura', 820.0000, 'ºC'),
	(324516, 145, '2015-01-15 00:53:01.000000', 'temperatura', 605.0000, 'ºC'),
	(324517, 145, '2015-01-15 00:53:02.000000', 'temperatura', 565.0000, 'ºC'),
	(324518, 145, '2015-01-15 00:53:03.000000', 'temperatura', 1010.0000, 'ºC'),
	(324519, 145, '2015-01-15 00:53:04.000000', 'temperatura', 955.0000, 'ºC'),
	(324520, 145, '2015-01-15 00:53:05.000000', 'temperatura', 546.0000, 'ºC'),
	(324521, 145, '2015-01-15 00:53:06.000000', 'temperatura', 1066.0000, 'ºC'),
	(324522, 145, '2015-01-15 00:53:07.000000', 'temperatura', 92.0000, 'ºC'),
	(324523, 145, '2015-01-15 00:53:08.000000', 'temperatura', 863.0000, 'ºC'),
	(324524, 145, '2015-01-15 00:53:09.000000', 'temperatura', 441.0000, 'ºC'),
	(324525, 145, '2015-01-15 00:53:10.000000', 'temperatura', 814.0000, 'ºC'),
	(324526, 145, '2015-01-15 00:53:11.000000', 'temperatura', 350.0000, 'ºC'),
	(324527, 145, '2015-01-15 00:53:12.000000', 'temperatura', 509.0000, 'ºC'),
	(324528, 145, '2015-01-15 00:53:13.000000', 'temperatura', 296.0000, 'ºC'),
	(324529, 145, '2015-01-15 00:53:14.000000', 'temperatura', 1152.0000, 'ºC'),
	(324530, 145, '2015-01-15 00:53:15.000000', 'temperatura', 72.0000, 'ºC'),
	(324531, 145, '2015-01-15 00:53:16.000000', 'temperatura', 504.0000, 'ºC'),
	(324532, 145, '2015-01-15 00:53:17.000000', 'temperatura', 1105.0000, 'ºC'),
	(324533, 145, '2015-01-15 00:53:18.000000', 'temperatura', 412.0000, 'ºC'),
	(324534, 145, '2015-01-15 00:53:19.000000', 'temperatura', 1145.0000, 'ºC'),
	(324535, 145, '2015-01-15 00:53:20.000000', 'temperatura', 889.0000, 'ºC'),
	(324536, 145, '2015-01-15 00:53:21.000000', 'temperatura', 1012.0000, 'ºC'),
	(324537, 145, '2015-01-15 00:53:22.000000', 'temperatura', 1194.0000, 'ºC'),
	(324538, 145, '2015-01-15 00:53:23.000000', 'temperatura', 535.0000, 'ºC'),
	(324539, 145, '2015-01-15 00:53:24.000000', 'temperatura', 294.0000, 'ºC'),
	(324540, 145, '2015-01-15 00:53:25.000000', 'temperatura', 1066.0000, 'ºC'),
	(324541, 145, '2015-01-15 00:53:26.000000', 'temperatura', 849.0000, 'ºC'),
	(324542, 145, '2015-01-15 00:53:27.000000', 'temperatura', 1047.0000, 'ºC'),
	(324543, 145, '2015-01-15 00:53:28.000000', 'temperatura', 288.0000, 'ºC'),
	(324544, 145, '2015-01-15 00:53:29.000000', 'temperatura', 700.0000, 'ºC'),
	(324545, 145, '2015-01-15 00:53:30.000000', 'temperatura', 237.0000, 'ºC'),
	(324546, 145, '2015-01-15 00:53:31.000000', 'temperatura', 286.0000, 'ºC'),
	(324547, 145, '2015-01-15 00:53:32.000000', 'temperatura', 719.0000, 'ºC'),
	(324548, 145, '2015-01-15 00:53:33.000000', 'temperatura', 337.0000, 'ºC'),
	(324549, 145, '2015-01-15 00:53:34.000000', 'temperatura', 728.0000, 'ºC'),
	(324550, 145, '2015-01-15 00:53:35.000000', 'temperatura', 230.0000, 'ºC'),
	(324551, 145, '2015-01-15 00:53:36.000000', 'temperatura', 166.0000, 'ºC'),
	(324552, 145, '2015-01-15 00:53:37.000000', 'temperatura', 141.0000, 'ºC'),
	(324553, 145, '2015-01-15 00:53:38.000000', 'temperatura', 208.0000, 'ºC'),
	(324554, 145, '2015-01-15 00:53:39.000000', 'temperatura', 616.0000, 'ºC'),
	(324555, 145, '2015-01-15 00:53:40.000000', 'temperatura', 59.0000, 'ºC'),
	(324556, 145, '2015-01-15 00:53:41.000000', 'temperatura', 846.0000, 'ºC'),
	(324557, 145, '2015-01-15 00:53:42.000000', 'temperatura', 453.0000, 'ºC'),
	(324558, 145, '2015-01-15 00:53:43.000000', 'temperatura', 927.0000, 'ºC'),
	(324559, 145, '2015-01-15 00:53:44.000000', 'temperatura', 879.0000, 'ºC'),
	(324560, 145, '2015-01-15 00:53:45.000000', 'temperatura', 415.0000, 'ºC'),
	(324561, 145, '2015-01-15 00:53:46.000000', 'temperatura', 636.0000, 'ºC'),
	(324562, 145, '2015-01-15 00:53:47.000000', 'temperatura', 736.0000, 'ºC'),
	(324563, 145, '2015-01-15 00:53:48.000000', 'temperatura', 573.0000, 'ºC'),
	(324564, 145, '2015-01-15 00:53:49.000000', 'temperatura', 657.0000, 'ºC'),
	(324565, 145, '2015-01-15 00:53:50.000000', 'temperatura', 365.0000, 'ºC'),
	(324566, 145, '2015-01-15 00:53:51.000000', 'temperatura', 1058.0000, 'ºC'),
	(324567, 145, '2015-01-15 00:53:52.000000', 'temperatura', 593.0000, 'ºC'),
	(324568, 145, '2015-01-15 00:53:53.000000', 'temperatura', 992.0000, 'ºC'),
	(324569, 145, '2015-01-15 00:53:54.000000', 'temperatura', 783.0000, 'ºC'),
	(324570, 145, '2015-01-15 00:53:55.000000', 'temperatura', 939.0000, 'ºC'),
	(324571, 145, '2015-01-15 00:53:56.000000', 'temperatura', 1145.0000, 'ºC'),
	(324572, 145, '2015-01-15 00:53:57.000000', 'temperatura', 508.0000, 'ºC'),
	(324573, 145, '2015-01-15 00:53:58.000000', 'temperatura', 305.0000, 'ºC'),
	(324574, 145, '2015-01-15 00:53:59.000000', 'temperatura', 2.0000, 'ºC'),
	(324575, 145, '2015-01-15 00:54:00.000000', 'temperatura', 294.0000, 'ºC'),
	(324576, 145, '2015-01-15 00:54:01.000000', 'temperatura', 266.0000, 'ºC'),
	(324577, 145, '2015-01-15 00:54:02.000000', 'temperatura', 448.0000, 'ºC'),
	(324578, 145, '2015-01-15 00:54:03.000000', 'temperatura', 244.0000, 'ºC'),
	(324579, 145, '2015-01-15 00:54:04.000000', 'temperatura', 1076.0000, 'ºC'),
	(324580, 145, '2015-01-15 00:54:05.000000', 'temperatura', 1047.0000, 'ºC'),
	(324581, 145, '2015-01-15 00:54:06.000000', 'temperatura', 809.0000, 'ºC'),
	(324582, 145, '2015-01-15 00:54:07.000000', 'temperatura', 905.0000, 'ºC'),
	(324583, 145, '2015-01-15 00:54:08.000000', 'temperatura', 899.0000, 'ºC'),
	(324584, 145, '2015-01-15 00:54:09.000000', 'temperatura', 578.0000, 'ºC'),
	(324585, 145, '2015-01-15 00:54:10.000000', 'temperatura', 196.0000, 'ºC'),
	(324586, 145, '2015-01-15 00:54:11.000000', 'temperatura', 447.0000, 'ºC'),
	(324587, 145, '2015-01-15 00:54:12.000000', 'temperatura', 444.0000, 'ºC'),
	(324588, 145, '2015-01-15 00:54:13.000000', 'temperatura', 883.0000, 'ºC'),
	(324589, 145, '2015-01-15 00:54:14.000000', 'temperatura', 683.0000, 'ºC'),
	(324590, 145, '2015-01-15 00:54:15.000000', 'temperatura', 765.0000, 'ºC'),
	(324591, 145, '2015-01-15 00:54:16.000000', 'temperatura', 577.0000, 'ºC'),
	(324592, 145, '2015-01-15 00:54:17.000000', 'temperatura', 590.0000, 'ºC'),
	(324593, 145, '2015-01-15 00:54:18.000000', 'temperatura', 18.0000, 'ºC'),
	(324594, 145, '2015-01-15 00:54:19.000000', 'temperatura', 722.0000, 'ºC'),
	(324595, 145, '2015-01-15 00:54:20.000000', 'temperatura', 1158.0000, 'ºC'),
	(324596, 145, '2015-01-15 00:54:21.000000', 'temperatura', 24.0000, 'ºC'),
	(324597, 145, '2015-01-15 00:54:22.000000', 'temperatura', 246.0000, 'ºC'),
	(324598, 145, '2015-01-15 00:54:23.000000', 'temperatura', 1160.0000, 'ºC'),
	(324599, 145, '2015-01-15 00:54:24.000000', 'temperatura', 260.0000, 'ºC'),
	(324600, 145, '2015-01-15 00:54:25.000000', 'temperatura', 223.0000, 'ºC'),
	(324601, 145, '2015-01-15 00:54:26.000000', 'temperatura', 333.0000, 'ºC'),
	(324602, 145, '2015-01-15 00:54:27.000000', 'temperatura', 997.0000, 'ºC'),
	(324603, 145, '2015-01-15 00:54:28.000000', 'temperatura', 385.0000, 'ºC'),
	(324604, 145, '2015-01-15 00:54:29.000000', 'temperatura', 137.0000, 'ºC'),
	(324605, 145, '2015-01-15 00:54:30.000000', 'temperatura', 729.0000, 'ºC'),
	(324606, 145, '2015-01-15 00:54:31.000000', 'temperatura', 836.0000, 'ºC'),
	(324607, 145, '2015-01-15 00:54:32.000000', 'temperatura', 792.0000, 'ºC'),
	(324608, 145, '2015-01-15 00:54:33.000000', 'temperatura', 254.0000, 'ºC'),
	(324609, 145, '2015-01-15 00:54:34.000000', 'temperatura', 95.0000, 'ºC'),
	(324610, 145, '2015-01-15 00:54:35.000000', 'temperatura', 913.0000, 'ºC'),
	(324611, 145, '2015-01-15 00:54:36.000000', 'temperatura', 681.0000, 'ºC'),
	(324612, 145, '2015-01-15 00:54:37.000000', 'temperatura', 664.0000, 'ºC'),
	(324613, 145, '2015-01-15 00:54:38.000000', 'temperatura', 81.0000, 'ºC'),
	(324614, 145, '2015-01-15 00:54:39.000000', 'temperatura', 810.0000, 'ºC'),
	(324615, 145, '2015-01-15 00:54:40.000000', 'temperatura', 210.0000, 'ºC'),
	(324616, 145, '2015-01-15 00:54:41.000000', 'temperatura', 1021.0000, 'ºC'),
	(324617, 145, '2015-01-15 00:54:42.000000', 'temperatura', 873.0000, 'ºC'),
	(324618, 145, '2015-01-15 00:54:43.000000', 'temperatura', 103.0000, 'ºC'),
	(324619, 145, '2015-01-15 00:54:44.000000', 'temperatura', 297.0000, 'ºC'),
	(324620, 145, '2015-01-15 00:54:45.000000', 'temperatura', 1176.0000, 'ºC'),
	(324621, 145, '2015-01-15 00:54:46.000000', 'temperatura', 190.0000, 'ºC'),
	(324622, 145, '2015-01-15 00:54:47.000000', 'temperatura', 1021.0000, 'ºC'),
	(324623, 145, '2015-01-15 00:54:48.000000', 'temperatura', 935.0000, 'ºC'),
	(324624, 145, '2015-01-15 00:54:49.000000', 'temperatura', 414.0000, 'ºC'),
	(324625, 145, '2015-01-15 00:54:50.000000', 'temperatura', 466.0000, 'ºC'),
	(324626, 145, '2015-01-15 00:54:51.000000', 'temperatura', 1088.0000, 'ºC'),
	(324627, 145, '2015-01-15 00:54:52.000000', 'temperatura', 442.0000, 'ºC'),
	(324628, 145, '2015-01-15 00:54:53.000000', 'temperatura', 146.0000, 'ºC'),
	(324629, 145, '2015-01-15 00:54:54.000000', 'temperatura', 603.0000, 'ºC'),
	(324630, 145, '2015-01-15 00:54:55.000000', 'temperatura', 181.0000, 'ºC'),
	(324631, 145, '2015-01-15 00:54:56.000000', 'temperatura', 295.0000, 'ºC'),
	(324632, 145, '2015-01-15 00:54:57.000000', 'temperatura', 931.0000, 'ºC'),
	(324633, 145, '2015-01-15 00:54:58.000000', 'temperatura', 172.0000, 'ºC'),
	(324634, 145, '2015-01-15 00:54:59.000000', 'temperatura', 466.0000, 'ºC'),
	(324635, 145, '2015-01-15 00:55:00.000000', 'temperatura', 614.0000, 'ºC'),
	(324636, 145, '2015-01-15 00:55:01.000000', 'temperatura', 472.0000, 'ºC'),
	(324637, 145, '2015-01-15 00:55:02.000000', 'temperatura', 519.0000, 'ºC'),
	(324638, 145, '2015-01-15 00:55:03.000000', 'temperatura', 1181.0000, 'ºC'),
	(324639, 145, '2015-01-15 00:55:04.000000', 'temperatura', 750.0000, 'ºC'),
	(324640, 145, '2015-01-15 00:55:05.000000', 'temperatura', 205.0000, 'ºC'),
	(324641, 145, '2015-01-15 00:55:06.000000', 'temperatura', 1174.0000, 'ºC'),
	(324642, 145, '2015-01-15 00:55:07.000000', 'temperatura', 457.0000, 'ºC'),
	(324643, 145, '2015-01-15 00:55:08.000000', 'temperatura', 1164.0000, 'ºC'),
	(324644, 145, '2015-01-15 00:55:09.000000', 'temperatura', 848.0000, 'ºC'),
	(324645, 145, '2015-01-15 00:55:10.000000', 'temperatura', 751.0000, 'ºC'),
	(324646, 145, '2015-01-15 00:55:11.000000', 'temperatura', 10.0000, 'ºC'),
	(324647, 145, '2015-01-15 00:55:12.000000', 'temperatura', 199.0000, 'ºC'),
	(324648, 145, '2015-01-15 00:55:13.000000', 'temperatura', 964.0000, 'ºC'),
	(324649, 145, '2015-01-15 00:55:14.000000', 'temperatura', 623.0000, 'ºC'),
	(324650, 145, '2015-01-15 00:55:15.000000', 'temperatura', 225.0000, 'ºC'),
	(324651, 145, '2015-01-15 00:55:16.000000', 'temperatura', 458.0000, 'ºC'),
	(324652, 145, '2015-01-15 00:55:17.000000', 'temperatura', 412.0000, 'ºC'),
	(324653, 145, '2015-01-15 00:55:18.000000', 'temperatura', 689.0000, 'ºC'),
	(324654, 145, '2015-01-15 00:55:19.000000', 'temperatura', 1009.0000, 'ºC'),
	(324655, 145, '2015-01-15 00:55:20.000000', 'temperatura', 579.0000, 'ºC'),
	(324656, 145, '2015-01-15 00:55:21.000000', 'temperatura', 1067.0000, 'ºC'),
	(324657, 145, '2015-01-15 00:55:22.000000', 'temperatura', 0.0000, 'ºC'),
	(324658, 145, '2015-01-15 00:55:23.000000', 'temperatura', 397.0000, 'ºC'),
	(324659, 145, '2015-01-15 00:55:24.000000', 'temperatura', 787.0000, 'ºC'),
	(324660, 145, '2015-01-15 00:55:25.000000', 'temperatura', 342.0000, 'ºC'),
	(324661, 145, '2015-01-15 00:55:26.000000', 'temperatura', 553.0000, 'ºC'),
	(324662, 145, '2015-01-15 00:55:27.000000', 'temperatura', 536.0000, 'ºC'),
	(324663, 145, '2015-01-15 00:55:28.000000', 'temperatura', 1025.0000, 'ºC'),
	(324664, 145, '2015-01-15 00:55:29.000000', 'temperatura', 1115.0000, 'ºC'),
	(324665, 145, '2015-01-15 00:55:30.000000', 'temperatura', 102.0000, 'ºC'),
	(324666, 145, '2015-01-15 00:55:31.000000', 'temperatura', 763.0000, 'ºC'),
	(324667, 145, '2015-01-15 00:55:32.000000', 'temperatura', 1111.0000, 'ºC'),
	(324668, 145, '2015-01-15 00:55:33.000000', 'temperatura', 868.0000, 'ºC'),
	(324669, 145, '2015-01-15 00:55:34.000000', 'temperatura', 1008.0000, 'ºC'),
	(324670, 145, '2015-01-15 00:55:35.000000', 'temperatura', 35.0000, 'ºC'),
	(324671, 145, '2015-01-15 00:55:36.000000', 'temperatura', 751.0000, 'ºC'),
	(324672, 145, '2015-01-15 00:55:37.000000', 'temperatura', 52.0000, 'ºC'),
	(324673, 145, '2015-01-15 00:55:38.000000', 'temperatura', 407.0000, 'ºC'),
	(324674, 145, '2015-01-15 00:55:39.000000', 'temperatura', 680.0000, 'ºC'),
	(324675, 145, '2015-01-15 00:55:40.000000', 'temperatura', 977.0000, 'ºC'),
	(324676, 145, '2015-01-15 00:55:41.000000', 'temperatura', 448.0000, 'ºC'),
	(324677, 145, '2015-01-15 00:55:42.000000', 'temperatura', 511.0000, 'ºC'),
	(324678, 145, '2015-01-15 00:55:43.000000', 'temperatura', 9.0000, 'ºC'),
	(324679, 145, '2015-01-15 00:55:44.000000', 'temperatura', 911.0000, 'ºC'),
	(324680, 145, '2015-01-15 00:55:45.000000', 'temperatura', 931.0000, 'ºC'),
	(324681, 145, '2015-01-15 00:55:46.000000', 'temperatura', 721.0000, 'ºC'),
	(324682, 145, '2015-01-15 00:55:47.000000', 'temperatura', 812.0000, 'ºC'),
	(324683, 145, '2015-01-15 00:55:48.000000', 'temperatura', 699.0000, 'ºC'),
	(324684, 145, '2015-01-15 00:55:49.000000', 'temperatura', 1061.0000, 'ºC'),
	(324685, 145, '2015-01-15 00:55:50.000000', 'temperatura', 806.0000, 'ºC'),
	(324686, 145, '2015-01-15 00:55:51.000000', 'temperatura', 849.0000, 'ºC'),
	(324687, 145, '2015-01-15 00:55:52.000000', 'temperatura', 627.0000, 'ºC'),
	(324688, 145, '2015-01-15 00:55:53.000000', 'temperatura', 588.0000, 'ºC'),
	(324689, 145, '2015-01-15 00:55:54.000000', 'temperatura', 1062.0000, 'ºC'),
	(324690, 145, '2015-01-15 00:55:55.000000', 'temperatura', 1145.0000, 'ºC'),
	(324691, 145, '2015-01-15 00:55:56.000000', 'temperatura', 139.0000, 'ºC'),
	(324692, 145, '2015-01-15 00:55:57.000000', 'temperatura', 860.0000, 'ºC'),
	(324693, 145, '2015-01-15 00:55:58.000000', 'temperatura', 284.0000, 'ºC'),
	(324694, 145, '2015-01-15 00:55:59.000000', 'temperatura', 42.0000, 'ºC'),
	(324695, 145, '2015-01-15 00:56:00.000000', 'temperatura', 559.0000, 'ºC'),
	(324696, 145, '2015-01-15 00:56:01.000000', 'temperatura', 268.0000, 'ºC'),
	(324697, 145, '2015-01-15 00:56:02.000000', 'temperatura', 862.0000, 'ºC'),
	(324698, 145, '2015-01-15 00:56:03.000000', 'temperatura', 1110.0000, 'ºC'),
	(324699, 145, '2015-01-15 00:56:04.000000', 'temperatura', 561.0000, 'ºC'),
	(324700, 145, '2015-01-15 00:56:05.000000', 'temperatura', 676.0000, 'ºC'),
	(324701, 145, '2015-01-15 00:56:06.000000', 'temperatura', 499.0000, 'ºC'),
	(324702, 145, '2015-01-15 00:56:07.000000', 'temperatura', 468.0000, 'ºC'),
	(324703, 145, '2015-01-15 00:56:08.000000', 'temperatura', 844.0000, 'ºC'),
	(324704, 145, '2015-01-15 00:56:09.000000', 'temperatura', 416.0000, 'ºC'),
	(324705, 145, '2015-01-15 00:56:10.000000', 'temperatura', 750.0000, 'ºC'),
	(324706, 145, '2015-01-15 00:56:11.000000', 'temperatura', 101.0000, 'ºC'),
	(324707, 145, '2015-01-15 00:56:12.000000', 'temperatura', 654.0000, 'ºC'),
	(324708, 145, '2015-01-15 00:56:13.000000', 'temperatura', 570.0000, 'ºC'),
	(324709, 145, '2015-01-15 00:56:14.000000', 'temperatura', 886.0000, 'ºC'),
	(324710, 145, '2015-01-15 00:56:15.000000', 'temperatura', 323.0000, 'ºC'),
	(324711, 145, '2015-01-15 00:56:16.000000', 'temperatura', 155.0000, 'ºC'),
	(324712, 145, '2015-01-15 00:56:17.000000', 'temperatura', 1008.0000, 'ºC'),
	(324713, 145, '2015-01-15 00:56:18.000000', 'temperatura', 975.0000, 'ºC'),
	(324714, 145, '2015-01-15 00:56:19.000000', 'temperatura', 653.0000, 'ºC'),
	(324715, 145, '2015-01-15 00:56:20.000000', 'temperatura', 340.0000, 'ºC'),
	(324716, 145, '2015-01-15 00:56:21.000000', 'temperatura', 940.0000, 'ºC'),
	(324717, 145, '2015-01-15 00:56:22.000000', 'temperatura', 81.0000, 'ºC'),
	(324718, 145, '2015-01-15 00:56:23.000000', 'temperatura', 1185.0000, 'ºC'),
	(324719, 145, '2015-01-15 00:56:24.000000', 'temperatura', 883.0000, 'ºC'),
	(324720, 145, '2015-01-15 00:56:25.000000', 'temperatura', 863.0000, 'ºC'),
	(324721, 145, '2015-01-15 00:56:26.000000', 'temperatura', 463.0000, 'ºC'),
	(324722, 145, '2015-01-15 00:56:27.000000', 'temperatura', 927.0000, 'ºC'),
	(324723, 145, '2015-01-15 00:56:28.000000', 'temperatura', 847.0000, 'ºC'),
	(324724, 145, '2015-01-15 00:56:29.000000', 'temperatura', 255.0000, 'ºC'),
	(324725, 145, '2015-01-15 00:56:30.000000', 'temperatura', 1135.0000, 'ºC'),
	(324726, 145, '2015-01-15 00:56:31.000000', 'temperatura', 110.0000, 'ºC'),
	(324727, 145, '2015-01-15 00:56:32.000000', 'temperatura', 747.0000, 'ºC'),
	(324728, 145, '2015-01-15 00:56:33.000000', 'temperatura', 1006.0000, 'ºC'),
	(324729, 145, '2015-01-15 00:56:34.000000', 'temperatura', 390.0000, 'ºC'),
	(324730, 145, '2015-01-15 00:56:35.000000', 'temperatura', 131.0000, 'ºC'),
	(324731, 145, '2015-01-15 00:56:36.000000', 'temperatura', 687.0000, 'ºC'),
	(324732, 145, '2015-01-15 00:56:37.000000', 'temperatura', 644.0000, 'ºC'),
	(324733, 145, '2015-01-15 00:56:38.000000', 'temperatura', 1156.0000, 'ºC'),
	(324734, 145, '2015-01-15 00:56:39.000000', 'temperatura', 252.0000, 'ºC'),
	(324735, 145, '2015-01-15 00:56:40.000000', 'temperatura', 189.0000, 'ºC'),
	(324736, 145, '2015-01-15 00:56:41.000000', 'temperatura', 192.0000, 'ºC'),
	(324737, 145, '2015-01-15 00:56:42.000000', 'temperatura', 392.0000, 'ºC'),
	(324738, 145, '2015-01-15 00:56:43.000000', 'temperatura', 185.0000, 'ºC'),
	(324739, 145, '2015-01-15 00:56:44.000000', 'temperatura', 950.0000, 'ºC'),
	(324740, 145, '2015-01-15 00:56:45.000000', 'temperatura', 594.0000, 'ºC'),
	(324741, 145, '2015-01-15 00:56:46.000000', 'temperatura', 122.0000, 'ºC'),
	(324742, 145, '2015-01-15 00:56:47.000000', 'temperatura', 28.0000, 'ºC'),
	(324743, 145, '2015-01-15 00:56:48.000000', 'temperatura', 972.0000, 'ºC'),
	(324744, 145, '2015-01-15 00:56:49.000000', 'temperatura', 1180.0000, 'ºC'),
	(324745, 145, '2015-01-15 00:56:50.000000', 'temperatura', 584.0000, 'ºC'),
	(324746, 145, '2015-01-15 00:56:51.000000', 'temperatura', 580.0000, 'ºC'),
	(324747, 145, '2015-01-15 00:56:52.000000', 'temperatura', 1148.0000, 'ºC'),
	(324748, 145, '2015-01-15 00:56:53.000000', 'temperatura', 402.0000, 'ºC'),
	(324749, 145, '2015-01-15 00:56:54.000000', 'temperatura', 967.0000, 'ºC'),
	(324750, 145, '2015-01-15 00:56:55.000000', 'temperatura', 29.0000, 'ºC'),
	(324751, 145, '2015-01-15 00:56:56.000000', 'temperatura', 845.0000, 'ºC'),
	(324752, 145, '2015-01-15 00:56:57.000000', 'temperatura', 537.0000, 'ºC'),
	(324753, 145, '2015-01-15 00:56:58.000000', 'temperatura', 152.0000, 'ºC'),
	(324754, 145, '2015-01-15 00:56:59.000000', 'temperatura', 350.0000, 'ºC'),
	(324755, 145, '2015-01-15 00:57:00.000000', 'temperatura', 94.0000, 'ºC'),
	(324756, 145, '2015-01-15 00:57:01.000000', 'temperatura', 619.0000, 'ºC'),
	(324757, 145, '2015-01-15 00:57:02.000000', 'temperatura', 413.0000, 'ºC'),
	(324758, 145, '2015-01-15 00:57:03.000000', 'temperatura', 208.0000, 'ºC'),
	(324759, 145, '2015-01-15 00:57:04.000000', 'temperatura', 1005.0000, 'ºC'),
	(324760, 145, '2015-01-15 00:57:05.000000', 'temperatura', 798.0000, 'ºC'),
	(324761, 145, '2015-01-15 00:57:06.000000', 'temperatura', 977.0000, 'ºC'),
	(324762, 145, '2015-01-15 00:57:07.000000', 'temperatura', 91.0000, 'ºC'),
	(324763, 145, '2015-01-15 00:57:08.000000', 'temperatura', 1123.0000, 'ºC'),
	(324764, 145, '2015-01-15 00:57:09.000000', 'temperatura', 545.0000, 'ºC'),
	(324765, 145, '2015-01-15 00:57:10.000000', 'temperatura', 554.0000, 'ºC'),
	(324766, 145, '2015-01-15 00:57:11.000000', 'temperatura', 1137.0000, 'ºC'),
	(324767, 145, '2015-01-15 00:57:12.000000', 'temperatura', 423.0000, 'ºC'),
	(324768, 145, '2015-01-15 00:57:13.000000', 'temperatura', 1105.0000, 'ºC'),
	(324769, 145, '2015-01-15 00:57:14.000000', 'temperatura', 658.0000, 'ºC'),
	(324770, 145, '2015-01-15 00:57:15.000000', 'temperatura', 1176.0000, 'ºC'),
	(324771, 145, '2015-01-15 00:57:16.000000', 'temperatura', 304.0000, 'ºC'),
	(324772, 145, '2015-01-15 00:57:17.000000', 'temperatura', 394.0000, 'ºC'),
	(324773, 145, '2015-01-15 00:57:18.000000', 'temperatura', 1057.0000, 'ºC'),
	(324774, 145, '2015-01-15 00:57:19.000000', 'temperatura', 502.0000, 'ºC'),
	(324775, 145, '2015-01-15 00:57:20.000000', 'temperatura', 542.0000, 'ºC'),
	(324776, 145, '2015-01-15 00:57:21.000000', 'temperatura', 2.0000, 'ºC'),
	(324777, 145, '2015-01-15 00:57:22.000000', 'temperatura', 788.0000, 'ºC'),
	(324778, 145, '2015-01-15 00:57:23.000000', 'temperatura', 331.0000, 'ºC'),
	(324779, 145, '2015-01-15 00:57:24.000000', 'temperatura', 493.0000, 'ºC'),
	(324780, 145, '2015-01-15 00:57:25.000000', 'temperatura', 273.0000, 'ºC'),
	(324781, 145, '2015-01-15 00:57:26.000000', 'temperatura', 1088.0000, 'ºC'),
	(324782, 145, '2015-01-15 00:57:27.000000', 'temperatura', 1021.0000, 'ºC'),
	(324783, 145, '2015-01-15 00:57:28.000000', 'temperatura', 639.0000, 'ºC'),
	(324784, 145, '2015-01-15 00:57:29.000000', 'temperatura', 135.0000, 'ºC'),
	(324785, 145, '2015-01-15 00:57:30.000000', 'temperatura', 1158.0000, 'ºC'),
	(324786, 145, '2015-01-15 00:57:31.000000', 'temperatura', 584.0000, 'ºC'),
	(324787, 145, '2015-01-15 00:57:32.000000', 'temperatura', 648.0000, 'ºC'),
	(324788, 145, '2015-01-15 00:57:33.000000', 'temperatura', 286.0000, 'ºC'),
	(324789, 145, '2015-01-15 00:57:34.000000', 'temperatura', 689.0000, 'ºC'),
	(324790, 145, '2015-01-15 00:57:35.000000', 'temperatura', 186.0000, 'ºC'),
	(324791, 145, '2015-01-15 00:57:36.000000', 'temperatura', 64.0000, 'ºC'),
	(324792, 145, '2015-01-15 00:57:37.000000', 'temperatura', 964.0000, 'ºC'),
	(324793, 145, '2015-01-15 00:57:38.000000', 'temperatura', 1026.0000, 'ºC'),
	(324794, 145, '2015-01-15 00:57:39.000000', 'temperatura', 1041.0000, 'ºC'),
	(324795, 145, '2015-01-15 00:57:40.000000', 'temperatura', 925.0000, 'ºC'),
	(324796, 145, '2015-01-15 00:57:41.000000', 'temperatura', 302.0000, 'ºC'),
	(324797, 145, '2015-01-15 00:57:42.000000', 'temperatura', 1139.0000, 'ºC'),
	(324798, 145, '2015-01-15 00:57:43.000000', 'temperatura', 1186.0000, 'ºC'),
	(324799, 145, '2015-01-15 00:57:44.000000', 'temperatura', 116.0000, 'ºC'),
	(324800, 145, '2015-01-15 00:57:45.000000', 'temperatura', 621.0000, 'ºC'),
	(324801, 145, '2015-01-15 00:57:46.000000', 'temperatura', 356.0000, 'ºC'),
	(324802, 145, '2015-01-15 00:57:47.000000', 'temperatura', 1120.0000, 'ºC'),
	(324803, 145, '2015-01-15 00:57:48.000000', 'temperatura', 931.0000, 'ºC'),
	(324804, 145, '2015-01-15 00:57:49.000000', 'temperatura', 96.0000, 'ºC'),
	(324805, 145, '2015-01-15 00:57:50.000000', 'temperatura', 89.0000, 'ºC'),
	(324806, 145, '2015-01-15 00:57:51.000000', 'temperatura', 155.0000, 'ºC'),
	(324807, 145, '2015-01-15 00:57:52.000000', 'temperatura', 508.0000, 'ºC'),
	(324808, 145, '2015-01-15 00:57:53.000000', 'temperatura', 875.0000, 'ºC'),
	(324809, 145, '2015-01-15 00:57:54.000000', 'temperatura', 453.0000, 'ºC'),
	(324810, 145, '2015-01-15 00:57:55.000000', 'temperatura', 840.0000, 'ºC'),
	(324811, 145, '2015-01-15 00:57:56.000000', 'temperatura', 440.0000, 'ºC'),
	(324812, 145, '2015-01-15 00:57:57.000000', 'temperatura', 880.0000, 'ºC'),
	(324813, 145, '2015-01-15 00:57:58.000000', 'temperatura', 682.0000, 'ºC'),
	(324814, 145, '2015-01-15 00:57:59.000000', 'temperatura', 769.0000, 'ºC'),
	(324815, 145, '2015-01-15 00:58:00.000000', 'temperatura', 602.0000, 'ºC'),
	(324816, 145, '2015-01-15 00:58:01.000000', 'temperatura', 702.0000, 'ºC'),
	(324817, 145, '2015-01-15 00:58:02.000000', 'temperatura', 503.0000, 'ºC'),
	(324818, 145, '2015-01-15 00:58:03.000000', 'temperatura', 411.0000, 'ºC'),
	(324819, 145, '2015-01-15 00:58:04.000000', 'temperatura', 544.0000, 'ºC'),
	(324820, 145, '2015-01-15 00:58:05.000000', 'temperatura', 290.0000, 'ºC'),
	(324821, 145, '2015-01-15 00:58:06.000000', 'temperatura', 1017.0000, 'ºC'),
	(324822, 145, '2015-01-15 00:58:07.000000', 'temperatura', 618.0000, 'ºC'),
	(324823, 145, '2015-01-15 00:58:08.000000', 'temperatura', 36.0000, 'ºC'),
	(324824, 145, '2015-01-15 00:58:09.000000', 'temperatura', 730.0000, 'ºC'),
	(324825, 145, '2015-01-15 00:58:10.000000', 'temperatura', 1141.0000, 'ºC'),
	(324826, 145, '2015-01-15 00:58:11.000000', 'temperatura', 1116.0000, 'ºC'),
	(324827, 145, '2015-01-15 00:58:12.000000', 'temperatura', 957.0000, 'ºC'),
	(324828, 145, '2015-01-15 00:58:13.000000', 'temperatura', 238.0000, 'ºC'),
	(324829, 145, '2015-01-15 00:58:14.000000', 'temperatura', 720.0000, 'ºC'),
	(324830, 145, '2015-01-15 00:58:15.000000', 'temperatura', 484.0000, 'ºC'),
	(324831, 145, '2015-01-15 00:58:16.000000', 'temperatura', 264.0000, 'ºC'),
	(324832, 145, '2015-01-15 00:58:17.000000', 'temperatura', 1066.0000, 'ºC'),
	(324833, 145, '2015-01-15 00:58:18.000000', 'temperatura', 941.0000, 'ºC'),
	(324834, 145, '2015-01-15 00:58:19.000000', 'temperatura', 305.0000, 'ºC'),
	(324835, 145, '2015-01-15 00:58:20.000000', 'temperatura', 1105.0000, 'ºC'),
	(324836, 145, '2015-01-15 00:58:21.000000', 'temperatura', 1011.0000, 'ºC'),
	(324837, 145, '2015-01-15 00:58:22.000000', 'temperatura', 541.0000, 'ºC'),
	(324838, 145, '2015-01-15 00:58:23.000000', 'temperatura', 870.0000, 'ºC'),
	(324839, 145, '2015-01-15 00:58:24.000000', 'temperatura', 328.0000, 'ºC'),
	(324840, 145, '2015-01-15 00:58:25.000000', 'temperatura', 231.0000, 'ºC'),
	(324841, 145, '2015-01-15 00:58:26.000000', 'temperatura', 172.0000, 'ºC'),
	(324842, 145, '2015-01-15 00:58:27.000000', 'temperatura', 168.0000, 'ºC'),
	(324843, 145, '2015-01-15 00:58:28.000000', 'temperatura', 325.0000, 'ºC'),
	(324844, 145, '2015-01-15 00:58:29.000000', 'temperatura', 1120.0000, 'ºC'),
	(324845, 145, '2015-01-15 00:58:30.000000', 'temperatura', 1027.0000, 'ºC'),
	(324846, 145, '2015-01-15 00:58:31.000000', 'temperatura', 574.0000, 'ºC'),
	(324847, 145, '2015-01-15 00:58:32.000000', 'temperatura', 991.0000, 'ºC'),
	(324848, 145, '2015-01-15 00:58:33.000000', 'temperatura', 831.0000, 'ºC'),
	(324849, 145, '2015-01-15 00:58:34.000000', 'temperatura', 1184.0000, 'ºC'),
	(324850, 145, '2015-01-15 00:58:35.000000', 'temperatura', 1028.0000, 'ºC'),
	(324851, 145, '2015-01-15 00:58:36.000000', 'temperatura', 389.0000, 'ºC'),
	(324852, 145, '2015-01-15 00:58:37.000000', 'temperatura', 59.0000, 'ºC'),
	(324853, 145, '2015-01-15 00:58:38.000000', 'temperatura', 331.0000, 'ºC'),
	(324854, 145, '2015-01-15 00:58:39.000000', 'temperatura', 278.0000, 'ºC'),
	(324855, 145, '2015-01-15 00:58:40.000000', 'temperatura', 395.0000, 'ºC'),
	(324856, 145, '2015-01-15 00:58:41.000000', 'temperatura', 1144.0000, 'ºC'),
	(324857, 145, '2015-01-15 00:58:42.000000', 'temperatura', 933.0000, 'ºC'),
	(324858, 145, '2015-01-15 00:58:43.000000', 'temperatura', 37.0000, 'ºC'),
	(324859, 145, '2015-01-15 00:58:44.000000', 'temperatura', 983.0000, 'ºC'),
	(324860, 145, '2015-01-15 00:58:45.000000', 'temperatura', 6.0000, 'ºC'),
	(324861, 145, '2015-01-15 00:58:46.000000', 'temperatura', 680.0000, 'ºC'),
	(324862, 145, '2015-01-15 00:58:47.000000', 'temperatura', 986.0000, 'ºC'),
	(324863, 145, '2015-01-15 00:58:48.000000', 'temperatura', 487.0000, 'ºC'),
	(324864, 145, '2015-01-15 00:58:49.000000', 'temperatura', 678.0000, 'ºC'),
	(324865, 145, '2015-01-15 00:58:50.000000', 'temperatura', 728.0000, 'ºC'),
	(324866, 145, '2015-01-15 00:58:51.000000', 'temperatura', 408.0000, 'ºC'),
	(324867, 145, '2015-01-15 00:58:52.000000', 'temperatura', 1058.0000, 'ºC'),
	(324868, 145, '2015-01-15 00:58:53.000000', 'temperatura', 467.0000, 'ºC'),
	(324869, 145, '2015-01-15 00:58:54.000000', 'temperatura', 360.0000, 'ºC'),
	(324870, 145, '2015-01-15 00:58:55.000000', 'temperatura', 401.0000, 'ºC'),
	(324871, 145, '2015-01-15 00:58:56.000000', 'temperatura', 924.0000, 'ºC'),
	(324872, 145, '2015-01-15 00:58:57.000000', 'temperatura', 1018.0000, 'ºC'),
	(324873, 145, '2015-01-15 00:58:58.000000', 'temperatura', 1119.0000, 'ºC'),
	(324874, 145, '2015-01-15 00:58:59.000000', 'temperatura', 142.0000, 'ºC'),
	(324875, 145, '2015-01-15 00:59:00.000000', 'temperatura', 952.0000, 'ºC'),
	(324876, 145, '2015-01-15 00:59:01.000000', 'temperatura', 737.0000, 'ºC'),
	(324877, 145, '2015-01-15 00:59:02.000000', 'temperatura', 829.0000, 'ºC'),
	(324878, 145, '2015-01-15 00:59:03.000000', 'temperatura', 735.0000, 'ºC'),
	(324879, 145, '2015-01-15 00:59:04.000000', 'temperatura', 1189.0000, 'ºC'),
	(324880, 145, '2015-01-15 00:59:05.000000', 'temperatura', 139.0000, 'ºC'),
	(324881, 145, '2015-01-15 00:59:06.000000', 'temperatura', 727.0000, 'ºC'),
	(324882, 145, '2015-01-15 00:59:07.000000', 'temperatura', 822.0000, 'ºC'),
	(324883, 145, '2015-01-15 00:59:08.000000', 'temperatura', 727.0000, 'ºC'),
	(324884, 145, '2015-01-15 00:59:09.000000', 'temperatura', 1168.0000, 'ºC'),
	(324885, 145, '2015-01-15 00:59:10.000000', 'temperatura', 63.0000, 'ºC'),
	(324886, 145, '2015-01-15 00:59:11.000000', 'temperatura', 411.0000, 'ºC'),
	(324887, 145, '2015-01-15 00:59:12.000000', 'temperatura', 664.0000, 'ºC'),
	(324888, 145, '2015-01-15 00:59:13.000000', 'temperatura', 888.0000, 'ºC'),
	(324889, 145, '2015-01-15 00:59:14.000000', 'temperatura', 48.0000, 'ºC'),
	(324890, 145, '2015-01-15 00:59:15.000000', 'temperatura', 1178.0000, 'ºC'),
	(324891, 145, '2015-01-15 00:59:16.000000', 'temperatura', 945.0000, 'ºC'),
	(324892, 145, '2015-01-15 00:59:17.000000', 'temperatura', 1194.0000, 'ºC'),
	(324893, 145, '2015-01-15 00:59:18.000000', 'temperatura', 734.0000, 'ºC'),
	(324894, 145, '2015-01-15 00:59:19.000000', 'temperatura', 88.0000, 'ºC'),
	(324895, 145, '2015-01-15 00:59:20.000000', 'temperatura', 638.0000, 'ºC'),
	(324896, 145, '2015-01-15 00:59:21.000000', 'temperatura', 529.0000, 'ºC'),
	(324897, 145, '2015-01-15 00:59:22.000000', 'temperatura', 728.0000, 'ºC'),
	(324898, 145, '2015-01-15 00:59:23.000000', 'temperatura', 857.0000, 'ºC'),
	(324899, 145, '2015-01-15 00:59:24.000000', 'temperatura', 900.0000, 'ºC'),
	(324900, 145, '2015-01-15 00:59:25.000000', 'temperatura', 728.0000, 'ºC'),
	(324901, 145, '2015-01-15 00:59:26.000000', 'temperatura', 941.0000, 'ºC'),
	(324902, 145, '2015-01-15 00:59:27.000000', 'temperatura', 121.0000, 'ºC'),
	(324903, 145, '2015-01-15 00:59:28.000000', 'temperatura', 185.0000, 'ºC'),
	(324904, 145, '2015-01-15 00:59:29.000000', 'temperatura', 561.0000, 'ºC'),
	(324905, 145, '2015-01-15 00:59:30.000000', 'temperatura', 1050.0000, 'ºC'),
	(324906, 145, '2015-01-15 00:59:31.000000', 'temperatura', 1167.0000, 'ºC'),
	(324907, 145, '2015-01-15 00:59:32.000000', 'temperatura', 288.0000, 'ºC'),
	(324908, 145, '2015-01-15 00:59:33.000000', 'temperatura', 336.0000, 'ºC'),
	(324909, 145, '2015-01-15 00:59:34.000000', 'temperatura', 819.0000, 'ºC'),
	(324910, 145, '2015-01-15 00:59:35.000000', 'temperatura', 685.0000, 'ºC'),
	(324911, 145, '2015-01-15 00:59:36.000000', 'temperatura', 969.0000, 'ºC'),
	(324912, 145, '2015-01-15 00:59:37.000000', 'temperatura', 393.0000, 'ºC'),
	(324913, 145, '2015-01-15 00:59:38.000000', 'temperatura', 255.0000, 'ºC'),
	(324914, 145, '2015-01-15 00:59:39.000000', 'temperatura', 99.0000, 'ºC'),
	(324915, 145, '2015-01-15 00:59:40.000000', 'temperatura', 929.0000, 'ºC'),
	(324916, 145, '2015-01-15 00:59:41.000000', 'temperatura', 750.0000, 'ºC'),
	(324917, 145, '2015-01-15 00:59:42.000000', 'temperatura', 961.0000, 'ºC'),
	(324918, 145, '2015-01-15 00:59:43.000000', 'temperatura', 157.0000, 'ºC'),
	(324919, 145, '2015-01-15 00:59:44.000000', 'temperatura', 304.0000, 'ºC'),
	(324920, 145, '2015-01-15 00:59:45.000000', 'temperatura', 1046.0000, 'ºC'),
	(324921, 145, '2015-01-15 00:59:46.000000', 'temperatura', 721.0000, 'ºC'),
	(324922, 145, '2015-01-15 00:59:47.000000', 'temperatura', 469.0000, 'ºC'),
	(324923, 145, '2015-01-15 00:59:48.000000', 'temperatura', 180.0000, 'ºC'),
	(324924, 145, '2015-01-15 00:59:49.000000', 'temperatura', 695.0000, 'ºC'),
	(324925, 145, '2015-01-15 00:59:50.000000', 'temperatura', 535.0000, 'ºC'),
	(324926, 145, '2015-01-15 00:59:51.000000', 'temperatura', 590.0000, 'ºC'),
	(324927, 145, '2015-01-15 00:59:52.000000', 'temperatura', 148.0000, 'ºC'),
	(324928, 145, '2015-01-15 00:59:53.000000', 'temperatura', 168.0000, 'ºC'),
	(324929, 145, '2015-01-15 00:59:54.000000', 'temperatura', 396.0000, 'ºC'),
	(324930, 145, '2015-01-15 00:59:55.000000', 'temperatura', 275.0000, 'ºC'),
	(324931, 145, '2015-01-15 00:59:56.000000', 'temperatura', 191.0000, 'ºC'),
	(324932, 145, '2015-01-15 00:59:57.000000', 'temperatura', 129.0000, 'ºC'),
	(324933, 145, '2015-01-15 00:59:58.000000', 'temperatura', 71.0000, 'ºC'),
	(324934, 145, '2015-01-15 00:59:59.000000', 'temperatura', 1169.0000, 'ºC'),
	(324935, 145, '2015-01-15 01:00:00.000000', 'temperatura', 834.0000, 'ºC'),
	(324936, 145, '2015-01-15 01:00:01.000000', 'temperatura', 665.0000, 'ºC'),
	(324937, 145, '2015-01-15 01:00:02.000000', 'temperatura', 821.0000, 'ºC'),
	(324938, 145, '2015-01-15 01:00:03.000000', 'temperatura', 913.0000, 'ºC'),
	(324939, 145, '2015-01-15 01:00:04.000000', 'temperatura', 900.0000, 'ºC'),
	(324940, 145, '2015-01-15 01:00:05.000000', 'temperatura', 564.0000, 'ºC'),
	(324941, 145, '2015-01-15 01:00:06.000000', 'temperatura', 118.0000, 'ºC'),
	(324942, 145, '2015-01-15 01:00:07.000000', 'temperatura', 100.0000, 'ºC'),
	(324943, 145, '2015-01-15 01:00:08.000000', 'temperatura', 148.0000, 'ºC'),
	(324944, 145, '2015-01-15 01:00:09.000000', 'temperatura', 438.0000, 'ºC'),
	(324945, 145, '2015-01-15 01:00:10.000000', 'temperatura', 546.0000, 'ºC'),
	(324946, 145, '2015-01-15 01:00:11.000000', 'temperatura', 217.0000, 'ºC'),
	(324947, 145, '2015-01-15 01:00:12.000000', 'temperatura', 649.0000, 'ºC'),
	(324948, 145, '2015-01-15 01:00:13.000000', 'temperatura', 192.0000, 'ºC'),
	(324949, 145, '2015-01-15 01:00:14.000000', 'temperatura', 214.0000, 'ºC'),
	(324950, 145, '2015-01-15 01:00:15.000000', 'temperatura', 495.0000, 'ºC'),
	(324951, 145, '2015-01-15 01:00:16.000000', 'temperatura', 634.0000, 'ºC'),
	(324952, 145, '2015-01-15 01:00:17.000000', 'temperatura', 486.0000, 'ºC'),
	(324953, 145, '2015-01-15 01:00:18.000000', 'temperatura', 529.0000, 'ºC'),
	(324954, 145, '2015-01-15 01:00:19.000000', 'temperatura', 1189.0000, 'ºC'),
	(324955, 145, '2015-01-15 01:00:20.000000', 'temperatura', 756.0000, 'ºC'),
	(324956, 145, '2015-01-15 01:00:21.000000', 'temperatura', 212.0000, 'ºC'),
	(324957, 145, '2015-01-15 01:00:22.000000', 'temperatura', 1195.0000, 'ºC'),
	(324958, 145, '2015-01-15 01:00:23.000000', 'temperatura', 538.0000, 'ºC'),
	(324959, 145, '2015-01-15 01:00:24.000000', 'temperatura', 308.0000, 'ºC'),
	(324960, 145, '2015-01-15 01:00:25.000000', 'temperatura', 1126.0000, 'ºC'),
	(324961, 145, '2015-01-15 01:00:26.000000', 'temperatura', 1105.0000, 'ºC'),
	(324962, 145, '2015-01-15 01:00:27.000000', 'temperatura', 948.0000, 'ºC'),
	(324963, 145, '2015-01-15 01:00:28.000000', 'temperatura', 224.0000, 'ºC'),
	(324964, 145, '2015-01-15 01:00:29.000000', 'temperatura', 677.0000, 'ºC'),
	(324965, 145, '2015-01-15 01:00:30.000000', 'temperatura', 312.0000, 'ºC'),
	(324966, 145, '2015-01-15 01:00:31.000000', 'temperatura', 732.0000, 'ºC'),
	(324967, 145, '2015-01-15 01:00:32.000000', 'temperatura', 324.0000, 'ºC'),
	(324968, 145, '2015-01-15 01:00:33.000000', 'temperatura', 623.0000, 'ºC'),
	(324969, 145, '2015-01-15 01:00:34.000000', 'temperatura', 945.0000, 'ºC'),
	(324970, 145, '2015-01-15 01:00:35.000000', 'temperatura', 458.0000, 'ºC'),
	(324971, 145, '2015-01-15 01:00:36.000000', 'temperatura', 655.0000, 'ºC'),
	(324972, 145, '2015-01-15 01:00:37.000000', 'temperatura', 701.0000, 'ºC'),
	(324973, 145, '2015-01-15 01:00:38.000000', 'temperatura', 341.0000, 'ºC'),
	(324974, 145, '2015-01-15 01:00:39.000000', 'temperatura', 800.0000, 'ºC'),
	(324975, 145, '2015-01-15 01:00:40.000000', 'temperatura', 580.0000, 'ºC'),
	(324976, 145, '2015-01-15 01:00:41.000000', 'temperatura', 500.0000, 'ºC'),
	(324977, 145, '2015-01-15 01:00:42.000000', 'temperatura', 760.0000, 'ºC'),
	(324978, 145, '2015-01-15 01:00:43.000000', 'temperatura', 1100.0000, 'ºC'),
	(324979, 145, '2015-01-15 01:00:44.000000', 'temperatura', 819.0000, 'ºC'),
	(324980, 145, '2015-01-15 01:00:45.000000', 'temperatura', 799.0000, 'ºC'),
	(324981, 145, '2015-01-15 01:00:46.000000', 'temperatura', 336.0000, 'ºC'),
	(324982, 145, '2015-01-15 01:00:47.000000', 'temperatura', 482.0000, 'ºC'),
	(324983, 145, '2015-01-15 01:00:48.000000', 'temperatura', 204.0000, 'ºC'),
	(324984, 145, '2015-01-15 01:00:49.000000', 'temperatura', 777.0000, 'ºC'),
	(324985, 145, '2015-01-15 01:00:50.000000', 'temperatura', 870.0000, 'ºC'),
	(324986, 145, '2015-01-15 01:00:51.000000', 'temperatura', 821.0000, 'ºC'),
	(324987, 145, '2015-01-15 01:00:52.000000', 'temperatura', 294.0000, 'ºC'),
	(324988, 145, '2015-01-15 01:00:53.000000', 'temperatura', 207.0000, 'ºC'),
	(324989, 145, '2015-01-15 01:00:54.000000', 'temperatura', 155.0000, 'ºC'),
	(324990, 145, '2015-01-15 01:00:55.000000', 'temperatura', 154.0000, 'ºC'),
	(324991, 145, '2015-01-15 01:00:56.000000', 'temperatura', 305.0000, 'ºC'),
	(324992, 145, '2015-01-15 01:00:57.000000', 'temperatura', 1063.0000, 'ºC'),
	(324993, 145, '2015-01-15 01:00:58.000000', 'temperatura', 802.0000, 'ºC'),
	(324994, 145, '2015-01-15 01:00:59.000000', 'temperatura', 820.0000, 'ºC'),
	(324995, 145, '2015-01-15 01:01:00.000000', 'temperatura', 493.0000, 'ºC'),
	(324996, 145, '2015-01-15 01:01:01.000000', 'temperatura', 9.0000, 'ºC'),
	(324997, 145, '2015-01-15 01:01:02.000000', 'temperatura', 966.0000, 'ºC'),
	(324998, 145, '2015-01-15 01:01:03.000000', 'temperatura', 1.0000, 'ºC'),
	(324999, 145, '2015-01-15 01:01:04.000000', 'temperatura', 709.0000, 'ºC'),
	(325000, 145, '2015-01-15 01:01:05.000000', 'temperatura', 1142.0000, 'ºC'),
	(325001, 145, '2015-01-15 01:01:06.000000', 'temperatura', 1184.0000, 'ºC'),
	(325002, 145, '2015-01-15 01:01:07.000000', 'temperatura', 96.0000, 'ºC'),
	(325003, 145, '2015-01-15 01:01:08.000000', 'temperatura', 526.0000, 'ºC'),
	(325004, 145, '2015-01-15 01:01:09.000000', 'temperatura', 1142.0000, 'ºC'),
	(325005, 145, '2015-01-15 01:01:10.000000', 'temperatura', 534.0000, 'ºC'),
	(325006, 145, '2015-01-15 01:01:11.000000', 'temperatura', 445.0000, 'ºC'),
	(325007, 145, '2015-01-15 01:01:12.000000', 'temperatura', 622.0000, 'ºC'),
	(325008, 145, '2015-01-15 01:01:13.000000', 'temperatura', 577.0000, 'ºC'),
	(325009, 145, '2015-01-15 01:01:14.000000', 'temperatura', 1020.0000, 'ºC'),
	(325010, 145, '2015-01-15 01:01:15.000000', 'temperatura', 969.0000, 'ºC'),
	(325011, 145, '2015-01-15 01:01:16.000000', 'temperatura', 584.0000, 'ºC'),
	(325012, 145, '2015-01-15 01:01:17.000000', 'temperatura', 14.0000, 'ºC'),
	(325013, 145, '2015-01-15 01:01:18.000000', 'temperatura', 717.0000, 'ºC'),
	(325014, 145, '2015-01-15 01:01:19.000000', 'temperatura', 1145.0000, 'ºC'),
	(325015, 145, '2015-01-15 01:01:20.000000', 'temperatura', 1173.0000, 'ºC'),
	(325016, 145, '2015-01-15 01:01:21.000000', 'temperatura', 33.0000, 'ºC'),
	(325017, 145, '2015-01-15 01:01:22.000000', 'temperatura', 244.0000, 'ºC'),
	(325018, 145, '2015-01-15 01:01:23.000000', 'temperatura', 1121.0000, 'ºC'),
	(325019, 145, '2015-01-15 01:01:24.000000', 'temperatura', 76.0000, 'ºC'),
	(325020, 145, '2015-01-15 01:01:25.000000', 'temperatura', 616.0000, 'ºC'),
	(325021, 145, '2015-01-15 01:01:26.000000', 'temperatura', 453.0000, 'ºC'),
	(325022, 145, '2015-01-15 01:01:27.000000', 'temperatura', 417.0000, 'ºC'),
	(325023, 145, '2015-01-15 01:01:28.000000', 'temperatura', 728.0000, 'ºC'),
	(325024, 145, '2015-01-15 01:01:29.000000', 'temperatura', 1190.0000, 'ºC'),
	(325025, 145, '2015-01-15 01:01:30.000000', 'temperatura', 164.0000, 'ºC'),
	(325026, 145, '2015-01-15 01:01:31.000000', 'temperatura', 853.0000, 'ºC'),
	(325027, 145, '2015-01-15 01:01:32.000000', 'temperatura', 173.0000, 'ºC'),
	(325028, 145, '2015-01-15 01:01:33.000000', 'temperatura', 707.0000, 'ºC'),
	(325029, 145, '2015-01-15 01:01:34.000000', 'temperatura', 616.0000, 'ºC'),
	(325030, 145, '2015-01-15 01:01:35.000000', 'temperatura', 962.0000, 'ºC'),
	(325031, 145, '2015-01-15 01:01:36.000000', 'temperatura', 559.0000, 'ºC'),
	(325032, 145, '2015-01-15 01:01:37.000000', 'temperatura', 1110.0000, 'ºC'),
	(325033, 145, '2015-01-15 01:01:38.000000', 'temperatura', 274.0000, 'ºC'),
	(325034, 145, '2015-01-15 01:01:39.000000', 'temperatura', 439.0000, 'ºC'),
	(325035, 145, '2015-01-15 01:01:40.000000', 'temperatura', 177.0000, 'ºC'),
	(325036, 145, '2015-01-15 01:01:41.000000', 'temperatura', 765.0000, 'ºC'),
	(325037, 145, '2015-01-15 01:01:42.000000', 'temperatura', 895.0000, 'ºC'),
	(325038, 145, '2015-01-15 01:01:43.000000', 'temperatura', 980.0000, 'ºC'),
	(325039, 145, '2015-01-15 01:01:44.000000', 'temperatura', 1016.0000, 'ºC'),
	(325040, 145, '2015-01-15 01:01:45.000000', 'temperatura', 941.0000, 'ºC'),
	(325041, 145, '2015-01-15 01:01:46.000000', 'temperatura', 458.0000, 'ºC'),
	(325042, 145, '2015-01-15 01:01:47.000000', 'temperatura', 666.0000, 'ºC'),
	(325043, 145, '2015-01-15 01:01:48.000000', 'temperatura', 757.0000, 'ºC'),
	(325044, 145, '2015-01-15 01:01:49.000000', 'temperatura', 587.0000, 'ºC'),
	(325045, 145, '2015-01-15 01:01:50.000000', 'temperatura', 663.0000, 'ºC'),
	(325046, 145, '2015-01-15 01:01:51.000000', 'temperatura', 357.0000, 'ºC'),
	(325047, 145, '2015-01-15 01:01:52.000000', 'temperatura', 994.0000, 'ºC'),
	(325048, 145, '2015-01-15 01:01:53.000000', 'temperatura', 301.0000, 'ºC'),
	(325049, 145, '2015-01-15 01:01:54.000000', 'temperatura', 922.0000, 'ºC'),
	(325050, 145, '2015-01-15 01:01:55.000000', 'temperatura', 108.0000, 'ºC'),
	(325051, 145, '2015-01-15 01:01:56.000000', 'temperatura', 173.0000, 'ºC'),
	(325052, 145, '2015-01-15 01:01:57.000000', 'temperatura', 542.0000, 'ºC'),
	(325053, 145, '2015-01-15 01:01:58.000000', 'temperatura', 992.0000, 'ºC'),
	(325054, 145, '2015-01-15 01:01:59.000000', 'temperatura', 934.0000, 'ºC'),
	(325055, 145, '2015-01-15 01:02:00.000000', 'temperatura', 494.0000, 'ºC'),
	(325056, 145, '2015-01-15 01:02:01.000000', 'temperatura', 868.0000, 'ºC'),
	(325057, 145, '2015-01-15 01:02:02.000000', 'temperatura', 457.0000, 'ºC'),
	(325058, 145, '2015-01-15 01:02:03.000000', 'temperatura', 885.0000, 'ºC'),
	(325059, 145, '2015-01-15 01:02:04.000000', 'temperatura', 651.0000, 'ºC'),
	(325060, 145, '2015-01-15 01:02:05.000000', 'temperatura', 603.0000, 'ºC'),
	(325061, 145, '2015-01-15 01:02:06.000000', 'temperatura', 1061.0000, 'ºC'),
	(325062, 145, '2015-01-15 01:02:07.000000', 'temperatura', 1098.0000, 'ºC'),
	(325063, 145, '2015-01-15 01:02:08.000000', 'temperatura', 1105.0000, 'ºC'),
	(325064, 145, '2015-01-15 01:02:09.000000', 'temperatura', 1032.0000, 'ºC'),
	(325065, 145, '2015-01-15 01:02:10.000000', 'temperatura', 646.0000, 'ºC'),
	(325066, 145, '2015-01-15 01:02:11.000000', 'temperatura', 133.0000, 'ºC'),
	(325067, 145, '2015-01-15 01:02:12.000000', 'temperatura', 1129.0000, 'ºC'),
	(325068, 145, '2015-01-15 01:02:13.000000', 'temperatura', 445.0000, 'ºC'),
	(325069, 145, '2015-01-15 01:02:14.000000', 'temperatura', 40.0000, 'ºC'),
	(325070, 145, '2015-01-15 01:02:15.000000', 'temperatura', 67.0000, 'ºC'),
	(325071, 145, '2015-01-15 01:02:16.000000', 'temperatura', 213.0000, 'ºC'),
	(325072, 145, '2015-01-15 01:02:17.000000', 'temperatura', 866.0000, 'ºC'),
	(325073, 145, '2015-01-15 01:02:18.000000', 'temperatura', 90.0000, 'ºC'),
	(325074, 145, '2015-01-15 01:02:19.000000', 'temperatura', 253.0000, 'ºC'),
	(325075, 145, '2015-01-15 01:02:20.000000', 'temperatura', 997.0000, 'ºC'),
	(325076, 145, '2015-01-15 01:02:21.000000', 'temperatura', 626.0000, 'ºC'),
	(325077, 145, '2015-01-15 01:02:22.000000', 'temperatura', 138.0000, 'ºC'),
	(325078, 145, '2015-01-15 01:02:23.000000', 'temperatura', 15.0000, 'ºC'),
	(325079, 145, '2015-01-15 01:02:24.000000', 'temperatura', 861.0000, 'ºC'),
	(325080, 145, '2015-01-15 01:02:25.000000', 'temperatura', 660.0000, 'ºC'),
	(325081, 145, '2015-01-15 01:02:26.000000', 'temperatura', 717.0000, 'ºC'),
	(325082, 145, '2015-01-15 01:02:27.000000', 'temperatura', 404.0000, 'ºC'),
	(325083, 145, '2015-01-15 01:02:28.000000', 'temperatura', 1070.0000, 'ºC'),
	(325084, 145, '2015-01-15 01:02:29.000000', 'temperatura', 540.0000, 'ºC'),
	(325085, 145, '2015-01-15 01:02:30.000000', 'temperatura', 689.0000, 'ºC'),
	(325086, 145, '2015-01-15 01:02:31.000000', 'temperatura', 628.0000, 'ºC'),
	(325087, 145, '2015-01-15 01:02:32.000000', 'temperatura', 1072.0000, 'ºC'),
	(325088, 145, '2015-01-15 01:02:33.000000', 'temperatura', 1077.0000, 'ºC'),
	(325089, 145, '2015-01-15 01:02:34.000000', 'temperatura', 971.0000, 'ºC'),
	(325090, 145, '2015-01-15 01:02:35.000000', 'temperatura', 423.0000, 'ºC'),
	(325091, 145, '2015-01-15 01:02:36.000000', 'temperatura', 403.0000, 'ºC'),
	(325092, 145, '2015-01-15 01:02:37.000000', 'temperatura', 745.0000, 'ºC'),
	(325093, 145, '2015-01-15 01:02:38.000000', 'temperatura', 116.0000, 'ºC'),
	(325094, 145, '2015-01-15 01:02:39.000000', 'temperatura', 749.0000, 'ºC'),
	(325095, 145, '2015-01-15 01:02:40.000000', 'temperatura', 994.0000, 'ºC'),
	(325096, 145, '2015-01-15 01:02:41.000000', 'temperatura', 325.0000, 'ºC'),
	(325097, 145, '2015-01-15 01:02:42.000000', 'temperatura', 1043.0000, 'ºC'),
	(325098, 145, '2015-01-15 01:02:43.000000', 'temperatura', 641.0000, 'ºC'),
	(325099, 145, '2015-01-15 01:02:44.000000', 'temperatura', 77.0000, 'ºC'),
	(325100, 145, '2015-01-15 01:02:45.000000', 'temperatura', 862.0000, 'ºC'),
	(325101, 145, '2015-01-15 01:02:46.000000', 'temperatura', 479.0000, 'ºC'),
	(325102, 145, '2015-01-15 01:02:47.000000', 'temperatura', 1011.0000, 'ºC'),
	(325103, 145, '2015-01-15 01:02:48.000000', 'temperatura', 16.0000, 'ºC'),
	(325104, 145, '2015-01-15 01:02:49.000000', 'temperatura', 647.0000, 'ºC'),
	(325105, 145, '2015-01-15 01:02:50.000000', 'temperatura', 788.0000, 'ºC'),
	(325106, 145, '2015-01-15 01:02:51.000000', 'temperatura', 799.0000, 'ºC'),
	(325107, 145, '2015-01-15 01:02:52.000000', 'temperatura', 433.0000, 'ºC'),
	(325108, 145, '2015-01-15 01:02:53.000000', 'temperatura', 967.0000, 'ºC'),
	(325109, 145, '2015-01-15 01:02:54.000000', 'temperatura', 1137.0000, 'ºC'),
	(325110, 145, '2015-01-15 01:02:55.000000', 'temperatura', 385.0000, 'ºC'),
	(325111, 145, '2015-01-15 01:02:56.000000', 'temperatura', 912.0000, 'ºC'),
	(325112, 145, '2015-01-15 01:02:57.000000', 'temperatura', 1008.0000, 'ºC'),
	(325113, 145, '2015-01-15 01:02:58.000000', 'temperatura', 1105.0000, 'ºC'),
	(325114, 145, '2015-01-15 01:02:59.000000', 'temperatura', 100.0000, 'ºC'),
	(325115, 145, '2015-01-15 01:03:00.000000', 'temperatura', 785.0000, 'ºC'),
	(325116, 145, '2015-01-15 01:03:01.000000', 'temperatura', 24.0000, 'ºC'),
	(325117, 145, '2015-01-15 01:03:02.000000', 'temperatura', 169.0000, 'ºC'),
	(325118, 145, '2015-01-15 01:03:03.000000', 'temperatura', 772.0000, 'ºC'),
	(325119, 145, '2015-01-15 01:03:04.000000', 'temperatura', 952.0000, 'ºC'),
	(325120, 145, '2015-01-15 01:03:05.000000', 'temperatura', 43.0000, 'ºC'),
	(325121, 145, '2015-01-15 01:03:06.000000', 'temperatura', 963.0000, 'ºC'),
	(325122, 145, '2015-01-15 01:03:07.000000', 'temperatura', 1086.0000, 'ºC'),
	(325123, 145, '2015-01-15 01:03:08.000000', 'temperatura', 143.0000, 'ºC'),
	(325124, 145, '2015-01-15 01:03:09.000000', 'temperatura', 1057.0000, 'ºC'),
	(325125, 145, '2015-01-15 01:03:10.000000', 'temperatura', 54.0000, 'ºC'),
	(325126, 145, '2015-01-15 01:03:11.000000', 'temperatura', 702.0000, 'ºC'),
	(325127, 145, '2015-01-15 01:03:12.000000', 'temperatura', 947.0000, 'ºC'),
	(325128, 145, '2015-01-15 01:03:13.000000', 'temperatura', 230.0000, 'ºC'),
	(325129, 145, '2015-01-15 01:03:14.000000', 'temperatura', 709.0000, 'ºC'),
	(325130, 145, '2015-01-15 01:03:15.000000', 'temperatura', 456.0000, 'ºC'),
	(325131, 145, '2015-01-15 01:03:16.000000', 'temperatura', 153.0000, 'ºC'),
	(325132, 145, '2015-01-15 01:03:17.000000', 'temperatura', 598.0000, 'ºC'),
	(325133, 145, '2015-01-15 01:03:18.000000', 'temperatura', 132.0000, 'ºC'),
	(325134, 145, '2015-01-15 01:03:19.000000', 'temperatura', 64.0000, 'ºC'),
	(325135, 145, '2015-01-15 01:03:20.000000', 'temperatura', 1128.0000, 'ºC'),
	(325136, 145, '2015-01-15 01:03:21.000000', 'temperatura', 647.0000, 'ºC'),
	(325137, 145, '2015-01-15 01:03:22.000000', 'temperatura', 1051.0000, 'ºC'),
	(325138, 145, '2015-01-15 01:03:23.000000', 'temperatura', 914.0000, 'ºC'),
	(325139, 145, '2015-01-15 01:03:24.000000', 'temperatura', 217.0000, 'ºC'),
	(325140, 145, '2015-01-15 01:03:25.000000', 'temperatura', 745.0000, 'ºC'),
	(325141, 145, '2015-01-15 01:03:26.000000', 'temperatura', 672.0000, 'ºC'),
	(325142, 145, '2015-01-15 01:03:27.000000', 'temperatura', 1129.0000, 'ºC'),
	(325143, 145, '2015-01-15 01:03:28.000000', 'temperatura', 28.0000, 'ºC'),
	(325144, 145, '2015-01-15 01:03:29.000000', 'temperatura', 352.0000, 'ºC'),
	(325145, 145, '2015-01-15 01:03:30.000000', 'temperatura', 479.0000, 'ºC'),
	(325146, 145, '2015-01-15 01:03:31.000000', 'temperatura', 140.0000, 'ºC'),
	(325147, 145, '2015-01-15 01:03:32.000000', 'temperatura', 464.0000, 'ºC'),
	(325148, 145, '2015-01-15 01:03:33.000000', 'temperatura', 697.0000, 'ºC'),
	(325149, 145, '2015-01-15 01:03:34.000000', 'temperatura', 897.0000, 'ºC'),
	(325150, 145, '2015-01-15 01:03:35.000000', 'temperatura', 1194.0000, 'ºC'),
	(325151, 145, '2015-01-15 01:03:36.000000', 'temperatura', 878.0000, 'ºC'),
	(325152, 145, '2015-01-15 01:03:37.000000', 'temperatura', 810.0000, 'ºC'),
	(325153, 145, '2015-01-15 01:03:38.000000', 'temperatura', 215.0000, 'ºC'),
	(325154, 145, '2015-01-15 01:03:39.000000', 'temperatura', 1045.0000, 'ºC'),
	(325155, 145, '2015-01-15 01:03:40.000000', 'temperatura', 981.0000, 'ºC'),
	(325156, 145, '2015-01-15 01:03:41.000000', 'temperatura', 570.0000, 'ºC'),
	(325157, 145, '2015-01-15 01:03:42.000000', 'temperatura', 1108.0000, 'ºC'),
	(325158, 145, '2015-01-15 01:03:43.000000', 'temperatura', 231.0000, 'ºC'),
	(325159, 145, '2015-01-15 01:03:44.000000', 'temperatura', 231.0000, 'ºC'),
	(325160, 145, '2015-01-15 01:03:45.000000', 'temperatura', 462.0000, 'ºC'),
	(325161, 145, '2015-01-15 01:03:46.000000', 'temperatura', 418.0000, 'ºC'),
	(325162, 145, '2015-01-15 01:03:47.000000', 'temperatura', 704.0000, 'ºC'),
	(325163, 145, '2015-01-15 01:03:48.000000', 'temperatura', 1066.0000, 'ºC'),
	(325164, 145, '2015-01-15 01:03:49.000000', 'temperatura', 821.0000, 'ºC'),
	(325165, 145, '2015-01-15 01:03:50.000000', 'temperatura', 906.0000, 'ºC'),
	(325166, 145, '2015-01-15 01:03:51.000000', 'temperatura', 869.0000, 'ºC'),
	(325167, 145, '2015-01-15 01:03:52.000000', 'temperatura', 428.0000, 'ºC'),
	(325168, 145, '2015-01-15 01:03:53.000000', 'temperatura', 732.0000, 'ºC'),
	(325169, 145, '2015-01-15 01:03:54.000000', 'temperatura', 1178.0000, 'ºC'),
	(325170, 145, '2015-01-15 01:03:55.000000', 'temperatura', 93.0000, 'ºC'),
	(325171, 145, '2015-01-15 01:03:56.000000', 'temperatura', 530.0000, 'ºC'),
	(325172, 145, '2015-01-15 01:03:57.000000', 'temperatura', 1173.0000, 'ºC'),
	(325173, 145, '2015-01-15 01:03:58.000000', 'temperatura', 675.0000, 'ºC'),
	(325174, 145, '2015-01-15 01:03:59.000000', 'temperatura', 1057.0000, 'ºC'),
	(325175, 145, '2015-01-15 01:04:00.000000', 'temperatura', 861.0000, 'ºC'),
	(325176, 145, '2015-01-15 01:04:01.000000', 'temperatura', 1132.0000, 'ºC'),
	(325177, 145, '2015-01-15 01:04:02.000000', 'temperatura', 679.0000, 'ºC'),
	(325178, 145, '2015-01-15 01:04:03.000000', 'temperatura', 1199.0000, 'ºC'),
	(325179, 145, '2015-01-15 01:04:04.000000', 'temperatura', 358.0000, 'ºC'),
	(325180, 145, '2015-01-15 01:04:05.000000', 'temperatura', 594.0000, 'ºC'),
	(325181, 145, '2015-01-15 01:04:06.000000', 'temperatura', 698.0000, 'ºC'),
	(325182, 145, '2015-01-15 01:04:07.000000', 'temperatura', 506.0000, 'ºC'),
	(325183, 145, '2015-01-15 01:04:08.000000', 'temperatura', 437.0000, 'ºC'),
	(325184, 145, '2015-01-15 01:04:09.000000', 'temperatura', 666.0000, 'ºC'),
	(325185, 145, '2015-01-15 01:04:10.000000', 'temperatura', 821.0000, 'ºC'),
	(325186, 145, '2015-01-15 01:04:11.000000', 'temperatura', 906.0000, 'ºC'),
	(325187, 145, '2015-01-15 01:04:12.000000', 'temperatura', 870.0000, 'ºC'),
	(325188, 145, '2015-01-15 01:04:13.000000', 'temperatura', 430.0000, 'ºC'),
	(325189, 145, '2015-01-15 01:04:14.000000', 'temperatura', 741.0000, 'ºC'),
	(325190, 145, '2015-01-15 01:04:15.000000', 'temperatura', 15.0000, 'ºC'),
	(325191, 145, '2015-01-15 01:04:16.000000', 'temperatura', 253.0000, 'ºC'),
	(325192, 145, '2015-01-15 01:04:17.000000', 'temperatura', 19.0000, 'ºC'),
	(325193, 145, '2015-01-15 01:04:18.000000', 'temperatura', 537.0000, 'ºC'),
	(325194, 145, '2015-01-15 01:04:19.000000', 'temperatura', 228.0000, 'ºC'),
	(325195, 145, '2015-01-15 01:04:20.000000', 'temperatura', 729.0000, 'ºC'),
	(325196, 145, '2015-01-15 01:04:21.000000', 'temperatura', 562.0000, 'ºC'),
	(325197, 145, '2015-01-15 01:04:22.000000', 'temperatura', 624.0000, 'ºC'),
	(325198, 145, '2015-01-15 01:04:23.000000', 'temperatura', 236.0000, 'ºC'),
	(325199, 145, '2015-01-15 01:04:24.000000', 'temperatura', 509.0000, 'ºC'),
	(325200, 145, '2015-01-15 01:04:25.000000', 'temperatura', 636.0000, 'ºC'),
	(325201, 145, '2015-01-15 01:04:26.000000', 'temperatura', 454.0000, 'ºC'),
	(325202, 145, '2015-01-15 01:04:27.000000', 'temperatura', 361.0000, 'ºC'),
	(325203, 145, '2015-01-15 01:04:28.000000', 'temperatura', 445.0000, 'ºC'),
	(325204, 145, '2015-01-15 01:04:29.000000', 'temperatura', 1141.0000, 'ºC'),
	(325205, 145, '2015-01-15 01:04:30.000000', 'temperatura', 770.0000, 'ºC'),
	(325206, 145, '2015-01-15 01:04:31.000000', 'temperatura', 426.0000, 'ºC'),
	(325207, 145, '2015-01-15 01:04:32.000000', 'temperatura', 1024.0000, 'ºC'),
	(325208, 145, '2015-01-15 01:04:33.000000', 'temperatura', 241.0000, 'ºC'),
	(325209, 145, '2015-01-15 01:04:34.000000', 'temperatura', 533.0000, 'ºC'),
	(325210, 145, '2015-01-15 01:04:35.000000', 'temperatura', 744.0000, 'ºC'),
	(325211, 145, '2015-01-15 01:04:36.000000', 'temperatura', 921.0000, 'ºC'),
	(325212, 145, '2015-01-15 01:04:37.000000', 'temperatura', 1173.0000, 'ºC'),
	(325213, 145, '2015-01-15 01:04:38.000000', 'temperatura', 704.0000, 'ºC'),
	(325214, 145, '2015-01-15 01:04:39.000000', 'temperatura', 1.0000, 'ºC'),
	(325215, 145, '2015-01-15 01:04:40.000000', 'temperatura', 291.0000, 'ºC'),
	(325216, 145, '2015-01-15 01:04:41.000000', 'temperatura', 256.0000, 'ºC'),
	(325217, 145, '2015-01-15 01:04:42.000000', 'temperatura', 406.0000, 'ºC'),
	(325218, 145, '2015-01-15 01:04:43.000000', 'temperatura', 63.0000, 'ºC'),
	(325219, 145, '2015-01-15 01:04:44.000000', 'temperatura', 299.0000, 'ºC'),
	(325220, 145, '2015-01-15 01:04:45.000000', 'temperatura', 105.0000, 'ºC'),
	(325221, 145, '2015-01-15 01:04:46.000000', 'temperatura', 829.0000, 'ºC'),
	(325222, 145, '2015-01-15 01:04:47.000000', 'temperatura', 232.0000, 'ºC'),
	(325223, 145, '2015-01-15 01:04:48.000000', 'temperatura', 1071.0000, 'ºC'),
	(325224, 145, '2015-01-15 01:04:49.000000', 'temperatura', 1061.0000, 'ºC'),
	(325225, 145, '2015-01-15 01:04:50.000000', 'temperatura', 892.0000, 'ºC'),
	(325226, 145, '2015-01-15 01:04:51.000000', 'temperatura', 76.0000, 'ºC'),
	(325227, 145, '2015-01-15 01:04:52.000000', 'temperatura', 105.0000, 'ºC'),
	(325228, 145, '2015-01-15 01:04:53.000000', 'temperatura', 299.0000, 'ºC'),
	(325229, 145, '2015-01-15 01:04:54.000000', 'temperatura', 1180.0000, 'ºC'),
	(325230, 145, '2015-01-15 01:04:55.000000', 'temperatura', 201.0000, 'ºC'),
	(325231, 145, '2015-01-15 01:04:56.000000', 'temperatura', 1069.0000, 'ºC'),
	(325232, 145, '2015-01-15 01:04:57.000000', 'temperatura', 1140.0000, 'ºC'),
	(325233, 145, '2015-01-15 01:04:58.000000', 'temperatura', 96.0000, 'ºC'),
	(325234, 145, '2015-01-15 01:04:59.000000', 'temperatura', 659.0000, 'ºC'),
	(325235, 145, '2015-01-15 01:05:00.000000', 'temperatura', 609.0000, 'ºC'),
	(325236, 145, '2015-01-15 01:05:01.000000', 'temperatura', 1068.0000, 'ºC'),
	(325237, 145, '2015-01-15 01:05:02.000000', 'temperatura', 1113.0000, 'ºC'),
	(325238, 145, '2015-01-15 01:05:03.000000', 'temperatura', 1160.0000, 'ºC'),
	(325239, 145, '2015-01-15 01:05:04.000000', 'temperatura', 62.0000, 'ºC'),
	(325240, 145, '2015-01-15 01:05:05.000000', 'temperatura', 429.0000, 'ºC'),
	(325241, 145, '2015-01-15 01:05:06.000000', 'temperatura', 762.0000, 'ºC'),
	(325242, 145, '2015-01-15 01:05:07.000000', 'temperatura', 125.0000, 'ºC'),
	(325243, 145, '2015-01-15 01:05:08.000000', 'temperatura', 736.0000, 'ºC'),
	(325244, 145, '2015-01-15 01:05:09.000000', 'temperatura', 907.0000, 'ºC'),
	(325245, 145, '2015-01-15 01:05:10.000000', 'temperatura', 1127.0000, 'ºC'),
	(325246, 145, '2015-01-15 01:05:11.000000', 'temperatura', 516.0000, 'ºC'),
	(325247, 145, '2015-01-15 01:05:12.000000', 'temperatura', 400.0000, 'ºC'),
	(325248, 145, '2015-01-15 01:05:13.000000', 'temperatura', 451.0000, 'ºC'),
	(325249, 145, '2015-01-15 01:05:14.000000', 'temperatura', 1057.0000, 'ºC'),
	(325250, 145, '2015-01-15 01:05:15.000000', 'temperatura', 330.0000, 'ºC'),
	(325251, 145, '2015-01-15 01:05:16.000000', 'temperatura', 883.0000, 'ºC'),
	(325252, 145, '2015-01-15 01:05:17.000000', 'temperatura', 1023.0000, 'ºC'),
	(325253, 145, '2015-01-15 01:05:18.000000', 'temperatura', 65.0000, 'ºC'),
	(325254, 145, '2015-01-15 01:05:19.000000', 'temperatura', 860.0000, 'ºC'),
	(325255, 145, '2015-01-15 01:05:20.000000', 'temperatura', 503.0000, 'ºC'),
	(325256, 145, '2015-01-15 01:05:21.000000', 'temperatura', 1138.0000, 'ºC'),
	(325257, 145, '2015-01-15 01:05:22.000000', 'temperatura', 579.0000, 'ºC'),
	(325258, 145, '2015-01-15 01:05:23.000000', 'temperatura', 681.0000, 'ºC'),
	(325259, 145, '2015-01-15 01:05:24.000000', 'temperatura', 469.0000, 'ºC'),
	(325260, 145, '2015-01-15 01:05:25.000000', 'temperatura', 303.0000, 'ºC'),
	(325261, 145, '2015-01-15 01:05:26.000000', 'temperatura', 109.0000, 'ºC'),
	(325262, 145, '2015-01-15 01:05:27.000000', 'temperatura', 837.0000, 'ºC'),
	(325263, 145, '2015-01-15 01:05:28.000000', 'temperatura', 259.0000, 'ºC'),
	(325264, 145, '2015-01-15 01:05:29.000000', 'temperatura', 1185.0000, 'ºC'),
	(325265, 145, '2015-01-15 01:05:30.000000', 'temperatura', 349.0000, 'ºC'),
	(325266, 145, '2015-01-15 01:05:31.000000', 'temperatura', 590.0000, 'ºC'),
	(325267, 145, '2015-01-15 01:05:32.000000', 'temperatura', 704.0000, 'ºC'),
	(325268, 145, '2015-01-15 01:05:33.000000', 'temperatura', 551.0000, 'ºC'),
	(325269, 145, '2015-01-15 01:05:34.000000', 'temperatura', 641.0000, 'ºC'),
	(325270, 145, '2015-01-15 01:05:35.000000', 'temperatura', 353.0000, 'ºC'),
	(325271, 145, '2015-01-15 01:05:36.000000', 'temperatura', 1043.0000, 'ºC'),
	(325272, 145, '2015-01-15 01:05:37.000000', 'temperatura', 555.0000, 'ºC'),
	(325273, 145, '2015-01-15 01:05:38.000000', 'temperatura', 848.0000, 'ºC'),
	(325274, 145, '2015-01-15 01:05:39.000000', 'temperatura', 176.0000, 'ºC'),
	(325275, 145, '2015-01-15 01:05:40.000000', 'temperatura', 736.0000, 'ºC'),
	(325276, 145, '2015-01-15 01:05:41.000000', 'temperatura', 754.0000, 'ºC'),
	(325277, 145, '2015-01-15 01:05:42.000000', 'temperatura', 362.0000, 'ºC'),
	(325278, 145, '2015-01-15 01:05:43.000000', 'temperatura', 747.0000, 'ºC'),
	(325279, 145, '2015-01-15 01:05:44.000000', 'temperatura', 250.0000, 'ºC'),
	(325280, 145, '2015-01-15 01:05:45.000000', 'temperatura', 208.0000, 'ºC'),
	(325281, 145, '2015-01-15 01:05:46.000000', 'temperatura', 291.0000, 'ºC'),
	(325282, 145, '2015-01-15 01:05:47.000000', 'temperatura', 831.0000, 'ºC'),
	(325283, 145, '2015-01-15 01:05:48.000000', 'temperatura', 883.0000, 'ºC'),
	(325284, 145, '2015-01-15 01:05:49.000000', 'temperatura', 723.0000, 'ºC'),
	(325285, 145, '2015-01-15 01:05:50.000000', 'temperatura', 965.0000, 'ºC'),
	(325286, 145, '2015-01-15 01:05:51.000000', 'temperatura', 258.0000, 'ºC'),
	(325287, 145, '2015-01-15 01:05:52.000000', 'temperatura', 796.0000, 'ºC'),
	(325288, 145, '2015-01-15 01:05:53.000000', 'temperatura', 807.0000, 'ºC'),
	(325289, 145, '2015-01-15 01:05:54.000000', 'temperatura', 446.0000, 'ºC'),
	(325290, 145, '2015-01-15 01:05:55.000000', 'temperatura', 1009.0000, 'ºC'),
	(325291, 145, '2015-01-15 01:05:56.000000', 'temperatura', 110.0000, 'ºC'),
	(325292, 145, '2015-01-15 01:05:57.000000', 'temperatura', 1121.0000, 'ºC'),
	(325293, 145, '2015-01-15 01:05:58.000000', 'temperatura', 478.0000, 'ºC'),
	(325294, 145, '2015-01-15 01:05:59.000000', 'temperatura', 226.0000, 'ºC'),
	(325295, 145, '2015-01-15 01:06:00.000000', 'temperatura', 897.0000, 'ºC'),
	(325296, 145, '2015-01-15 01:06:01.000000', 'temperatura', 206.0000, 'ºC'),
	(325297, 145, '2015-01-15 01:06:02.000000', 'temperatura', 743.0000, 'ºC'),
	(325298, 145, '2015-01-15 01:06:03.000000', 'temperatura', 694.0000, 'ºC'),
	(325299, 145, '2015-01-15 01:06:04.000000', 'temperatura', 42.0000, 'ºC'),
	(325300, 145, '2015-01-15 01:06:05.000000', 'temperatura', 527.0000, 'ºC'),
	(325301, 145, '2015-01-15 01:06:06.000000', 'temperatura', 110.0000, 'ºC'),
	(325302, 145, '2015-01-15 01:06:07.000000', 'temperatura', 171.0000, 'ºC'),
	(325303, 145, '2015-01-15 01:06:08.000000', 'temperatura', 524.0000, 'ºC'),
	(325304, 146, '2015-01-15 00:00:00.000000', 'temperatura', 578.0000, 'ºC'),
	(325305, 146, '2015-01-15 00:00:01.000000', 'temperatura', 160.0000, 'ºC'),
	(325306, 146, '2015-01-15 00:00:02.000000', 'temperatura', 268.0000, 'ºC'),
	(325307, 146, '2015-01-15 00:00:03.000000', 'temperatura', 859.0000, 'ºC'),
	(325308, 146, '2015-01-15 00:00:04.000000', 'temperatura', 1094.0000, 'ºC'),
	(325309, 146, '2015-01-15 00:00:05.000000', 'temperatura', 490.0000, 'ºC'),
	(325310, 146, '2015-01-15 00:00:06.000000', 'temperatura', 371.0000, 'ºC'),
	(325311, 146, '2015-01-15 00:00:07.000000', 'temperatura', 383.0000, 'ºC'),
	(325312, 146, '2015-01-15 00:00:08.000000', 'temperatura', 804.0000, 'ºC'),
	(325313, 146, '2015-01-15 00:00:09.000000', 'temperatura', 472.0000, 'ºC'),
	(325314, 146, '2015-01-15 00:00:10.000000', 'temperatura', 1149.0000, 'ºC'),
	(325315, 146, '2015-01-15 00:00:11.000000', 'temperatura', 728.0000, 'ºC'),
	(325316, 146, '2015-01-15 00:00:12.000000', 'temperatura', 193.0000, 'ºC'),
	(325317, 146, '2015-01-15 00:00:13.000000', 'temperatura', 1184.0000, 'ºC'),
	(325318, 146, '2015-01-15 00:00:14.000000', 'temperatura', 541.0000, 'ºC'),
	(325319, 146, '2015-01-15 00:00:15.000000', 'temperatura', 354.0000, 'ºC'),
	(325320, 146, '2015-01-15 00:00:16.000000', 'temperatura', 145.0000, 'ºC'),
	(325321, 146, '2015-01-15 00:00:17.000000', 'temperatura', 863.0000, 'ºC'),
	(325322, 146, '2015-01-15 00:00:18.000000', 'temperatura', 283.0000, 'ºC'),
	(325323, 146, '2015-01-15 00:00:19.000000', 'temperatura', 25.0000, 'ºC'),
	(325324, 146, '2015-01-15 00:00:20.000000', 'temperatura', 475.0000, 'ºC'),
	(325325, 146, '2015-01-15 00:00:21.000000', 'temperatura', 1104.0000, 'ºC'),
	(325326, 146, '2015-01-15 00:00:22.000000', 'temperatura', 493.0000, 'ºC'),
	(325327, 146, '2015-01-15 00:00:23.000000', 'temperatura', 355.0000, 'ºC'),
	(325328, 146, '2015-01-15 00:00:24.000000', 'temperatura', 297.0000, 'ºC'),
	(325329, 146, '2015-01-15 00:00:25.000000', 'temperatura', 421.0000, 'ºC'),
	(325330, 146, '2015-01-15 00:00:26.000000', 'temperatura', 14.0000, 'ºC'),
	(325331, 146, '2015-01-15 00:00:27.000000', 'temperatura', 6.0000, 'ºC'),
	(325332, 146, '2015-01-15 00:00:28.000000', 'temperatura', 1191.0000, 'ºC'),
	(325333, 146, '2015-01-15 00:00:29.000000', 'temperatura', 1138.0000, 'ºC'),
	(325334, 146, '2015-01-15 00:00:30.000000', 'temperatura', 915.0000, 'ºC'),
	(325335, 146, '2015-01-15 00:00:31.000000', 'temperatura', 1165.0000, 'ºC'),
	(325336, 146, '2015-01-15 00:00:32.000000', 'temperatura', 677.0000, 'ºC'),
	(325337, 146, '2015-01-15 00:00:33.000000', 'temperatura', 1092.0000, 'ºC'),
	(325338, 146, '2015-01-15 00:00:34.000000', 'temperatura', 1028.0000, 'ºC'),
	(325339, 146, '2015-01-15 00:00:35.000000', 'temperatura', 664.0000, 'ºC'),
	(325340, 146, '2015-01-15 00:00:36.000000', 'temperatura', 238.0000, 'ºC'),
	(325341, 146, '2015-01-15 00:00:37.000000', 'temperatura', 398.0000, 'ºC'),
	(325342, 146, '2015-01-15 00:00:38.000000', 'temperatura', 77.0000, 'ºC'),
	(325343, 146, '2015-01-15 00:00:39.000000', 'temperatura', 390.0000, 'ºC'),
	(325344, 146, '2015-01-15 00:00:40.000000', 'temperatura', 522.0000, 'ºC'),
	(325345, 146, '2015-01-15 00:00:41.000000', 'temperatura', 238.0000, 'ºC'),
	(325346, 146, '2015-01-15 00:00:42.000000', 'temperatura', 826.0000, 'ºC'),
	(325347, 146, '2015-01-15 00:00:43.000000', 'temperatura', 1014.0000, 'ºC'),
	(325348, 146, '2015-01-15 00:00:44.000000', 'temperatura', 196.0000, 'ºC'),
	(325349, 146, '2015-01-15 00:00:45.000000', 'temperatura', 338.0000, 'ºC'),
	(325350, 146, '2015-01-15 00:00:46.000000', 'temperatura', 1100.0000, 'ºC'),
	(325351, 146, '2015-01-15 00:00:47.000000', 'temperatura', 887.0000, 'ºC'),
	(325352, 146, '2015-01-15 00:00:48.000000', 'temperatura', 1138.0000, 'ºC'),
	(325353, 146, '2015-01-15 00:00:49.000000', 'temperatura', 628.0000, 'ºC'),
	(325354, 146, '2015-01-15 00:00:50.000000', 'temperatura', 927.0000, 'ºC'),
	(325355, 146, '2015-01-15 00:00:51.000000', 'temperatura', 351.0000, 'ºC'),
	(325356, 146, '2015-01-15 00:00:52.000000', 'temperatura', 175.0000, 'ºC'),
	(325357, 146, '2015-01-15 00:00:53.000000', 'temperatura', 1021.0000, 'ºC'),
	(325358, 146, '2015-01-15 00:00:54.000000', 'temperatura', 979.0000, 'ºC'),
	(325359, 146, '2015-01-15 00:00:55.000000', 'temperatura', 636.0000, 'ºC'),
	(325360, 146, '2015-01-15 00:00:56.000000', 'temperatura', 243.0000, 'ºC'),
	(325361, 146, '2015-01-15 00:00:57.000000', 'temperatura', 506.0000, 'ºC'),
	(325362, 146, '2015-01-15 00:00:58.000000', 'temperatura', 602.0000, 'ºC'),
	(325363, 146, '2015-01-15 00:00:59.000000', 'temperatura', 292.0000, 'ºC'),
	(325364, 146, '2015-01-15 00:01:00.000000', 'temperatura', 855.0000, 'ºC'),
	(325365, 146, '2015-01-15 00:01:01.000000', 'temperatura', 999.0000, 'ºC'),
	(325366, 146, '2015-01-15 00:01:02.000000', 'temperatura', 30.0000, 'ºC'),
	(325367, 146, '2015-01-15 00:01:03.000000', 'temperatura', 753.0000, 'ºC'),
	(325368, 146, '2015-01-15 00:01:04.000000', 'temperatura', 76.0000, 'ºC'),
	(325369, 146, '2015-01-15 00:01:05.000000', 'temperatura', 520.0000, 'ºC'),
	(325370, 146, '2015-01-15 00:01:06.000000', 'temperatura', 1173.0000, 'ºC'),
	(325371, 146, '2015-01-15 00:01:07.000000', 'temperatura', 706.0000, 'ºC'),
	(325372, 146, '2015-01-15 00:01:08.000000', 'temperatura', 10.0000, 'ºC'),
	(325373, 146, '2015-01-15 00:01:09.000000', 'temperatura', 334.0000, 'ºC'),
	(325374, 146, '2015-01-15 00:01:10.000000', 'temperatura', 440.0000, 'ºC'),
	(325375, 146, '2015-01-15 00:01:11.000000', 'temperatura', 1.0000, 'ºC'),
	(325376, 146, '2015-01-15 00:01:12.000000', 'temperatura', 1082.0000, 'ºC'),
	(325377, 146, '2015-01-15 00:01:13.000000', 'temperatura', 609.0000, 'ºC'),
	(325378, 146, '2015-01-15 00:01:14.000000', 'temperatura', 1001.0000, 'ºC'),
	(325379, 146, '2015-01-15 00:01:15.000000', 'temperatura', 776.0000, 'ºC'),
	(325380, 146, '2015-01-15 00:01:16.000000', 'temperatura', 877.0000, 'ºC'),
	(325381, 146, '2015-01-15 00:01:17.000000', 'temperatura', 859.0000, 'ºC'),
	(325382, 146, '2015-01-15 00:01:18.000000', 'temperatura', 463.0000, 'ºC'),
	(325383, 146, '2015-01-15 00:01:19.000000', 'temperatura', 939.0000, 'ºC'),
	(325384, 146, '2015-01-15 00:01:20.000000', 'temperatura', 907.0000, 'ºC'),
	(325385, 146, '2015-01-15 00:01:21.000000', 'temperatura', 520.0000, 'ºC'),
	(325386, 146, '2015-01-15 00:01:22.000000', 'temperatura', 1077.0000, 'ºC'),
	(325387, 146, '2015-01-15 00:01:23.000000', 'temperatura', 224.0000, 'ºC'),
	(325388, 146, '2015-01-15 00:01:24.000000', 'temperatura', 292.0000, 'ºC'),
	(325389, 146, '2015-01-15 00:01:25.000000', 'temperatura', 790.0000, 'ºC'),
	(325390, 146, '2015-01-15 00:01:26.000000', 'temperatura', 673.0000, 'ºC'),
	(325391, 146, '2015-01-15 00:01:27.000000', 'temperatura', 994.0000, 'ºC'),
	(325392, 146, '2015-01-15 00:01:28.000000', 'temperatura', 552.0000, 'ºC'),
	(325393, 146, '2015-01-15 00:01:29.000000', 'temperatura', 979.0000, 'ºC'),
	(325394, 146, '2015-01-15 00:01:30.000000', 'temperatura', 841.0000, 'ºC'),
	(325395, 146, '2015-01-15 00:01:31.000000', 'temperatura', 67.0000, 'ºC'),
	(325396, 146, '2015-01-15 00:01:32.000000', 'temperatura', 213.0000, 'ºC'),
	(325397, 146, '2015-01-15 00:01:33.000000', 'temperatura', 865.0000, 'ºC'),
	(325398, 146, '2015-01-15 00:01:34.000000', 'temperatura', 87.0000, 'ºC'),
	(325399, 146, '2015-01-15 00:01:35.000000', 'temperatura', 240.0000, 'ºC'),
	(325400, 146, '2015-01-15 00:01:36.000000', 'temperatura', 940.0000, 'ºC'),
	(325401, 146, '2015-01-15 00:01:37.000000', 'temperatura', 378.0000, 'ºC'),
	(325402, 146, '2015-01-15 00:01:38.000000', 'temperatura', 273.0000, 'ºC'),
	(325403, 146, '2015-01-15 00:01:39.000000', 'temperatura', 232.0000, 'ºC'),
	(325404, 146, '2015-01-15 00:01:40.000000', 'temperatura', 342.0000, 'ºC'),
	(325405, 146, '2015-01-15 00:01:41.000000', 'temperatura', 1014.0000, 'ºC'),
	(325406, 146, '2015-01-15 00:01:42.000000', 'temperatura', 443.0000, 'ºC'),
	(325407, 146, '2015-01-15 00:01:43.000000', 'temperatura', 376.0000, 'ºC'),
	(325408, 146, '2015-01-15 00:01:44.000000', 'temperatura', 552.0000, 'ºC'),
	(325409, 146, '2015-01-15 00:01:45.000000', 'temperatura', 431.0000, 'ºC'),
	(325410, 146, '2015-01-15 00:01:46.000000', 'temperatura', 499.0000, 'ºC'),
	(325411, 146, '2015-01-15 00:01:47.000000', 'temperatura', 5.0000, 'ºC'),
	(325412, 146, '2015-01-15 00:01:48.000000', 'temperatura', 926.0000, 'ºC'),
	(325413, 146, '2015-01-15 00:01:49.000000', 'temperatura', 1017.0000, 'ºC'),
	(325414, 146, '2015-01-15 00:01:50.000000', 'temperatura', 1105.0000, 'ºC'),
	(325415, 146, '2015-01-15 00:01:51.000000', 'temperatura', 77.0000, 'ºC'),
	(325416, 146, '2015-01-15 00:01:52.000000', 'temperatura', 671.0000, 'ºC'),
	(325417, 146, '2015-01-15 00:01:53.000000', 'temperatura', 725.0000, 'ºC'),
	(325418, 146, '2015-01-15 00:01:54.000000', 'temperatura', 411.0000, 'ºC'),
	(325419, 146, '2015-01-15 00:01:55.000000', 'temperatura', 1082.0000, 'ºC'),
	(325420, 146, '2015-01-15 00:01:56.000000', 'temperatura', 577.0000, 'ºC'),
	(325421, 146, '2015-01-15 00:01:57.000000', 'temperatura', 841.0000, 'ºC'),
	(325422, 146, '2015-01-15 00:01:58.000000', 'temperatura', 75.0000, 'ºC'),
	(325423, 146, '2015-01-15 00:01:59.000000', 'temperatura', 252.0000, 'ºC'),
	(325424, 146, '2015-01-15 00:02:00.000000', 'temperatura', 1034.0000, 'ºC'),
	(325425, 146, '2015-01-15 00:02:01.000000', 'temperatura', 816.0000, 'ºC'),
	(325426, 146, '2015-01-15 00:02:02.000000', 'temperatura', 976.0000, 'ºC'),
	(325427, 146, '2015-01-15 00:02:03.000000', 'temperatura', 34.0000, 'ºC'),
	(325428, 146, '2015-01-15 00:02:04.000000', 'temperatura', 841.0000, 'ºC'),
	(325429, 146, '2015-01-15 00:02:05.000000', 'temperatura', 506.0000, 'ºC'),
	(325430, 146, '2015-01-15 00:02:06.000000', 'temperatura', 8.0000, 'ºC'),
	(325431, 146, '2015-01-15 00:02:07.000000', 'temperatura', 923.0000, 'ºC'),
	(325432, 146, '2015-01-15 00:02:08.000000', 'temperatura', 991.0000, 'ºC'),
	(325433, 146, '2015-01-15 00:02:09.000000', 'temperatura', 987.0000, 'ºC'),
	(325434, 146, '2015-01-15 00:02:10.000000', 'temperatura', 762.0000, 'ºC'),
	(325435, 146, '2015-01-15 00:02:11.000000', 'temperatura', 851.0000, 'ºC'),
	(325436, 146, '2015-01-15 00:02:12.000000', 'temperatura', 768.0000, 'ºC'),
	(325437, 146, '2015-01-15 00:02:13.000000', 'temperatura', 86.0000, 'ºC'),
	(325438, 146, '2015-01-15 00:02:14.000000', 'temperatura', 528.0000, 'ºC'),
	(325439, 146, '2015-01-15 00:02:15.000000', 'temperatura', 1184.0000, 'ºC'),
	(325440, 146, '2015-01-15 00:02:16.000000', 'temperatura', 736.0000, 'ºC'),
	(325441, 146, '2015-01-15 00:02:17.000000', 'temperatura', 128.0000, 'ºC'),
	(325442, 146, '2015-01-15 00:02:18.000000', 'temperatura', 831.0000, 'ºC'),
	(325443, 146, '2015-01-15 00:02:19.000000', 'temperatura', 170.0000, 'ºC'),
	(325444, 146, '2015-01-15 00:02:20.000000', 'temperatura', 761.0000, 'ºC'),
	(325445, 146, '2015-01-15 00:02:21.000000', 'temperatura', 895.0000, 'ºC'),
	(325446, 146, '2015-01-15 00:02:22.000000', 'temperatura', 992.0000, 'ºC'),
	(325447, 146, '2015-01-15 00:02:23.000000', 'temperatura', 1075.0000, 'ºC'),
	(325448, 146, '2015-01-15 00:02:24.000000', 'temperatura', 0.0000, 'ºC'),
	(325449, 146, '2015-01-15 00:02:25.000000', 'temperatura', 377.0000, 'ºC'),
	(325450, 146, '2015-01-15 00:02:26.000000', 'temperatura', 684.0000, 'ºC'),
	(325451, 146, '2015-01-15 00:02:27.000000', 'temperatura', 1088.0000, 'ºC'),
	(325452, 146, '2015-01-15 00:02:28.000000', 'temperatura', 992.0000, 'ºC'),
	(325453, 146, '2015-01-15 00:02:29.000000', 'temperatura', 493.0000, 'ºC'),
	(325454, 146, '2015-01-15 00:02:30.000000', 'temperatura', 692.0000, 'ºC'),
	(325455, 146, '2015-01-15 00:02:31.000000', 'temperatura', 781.0000, 'ºC'),
	(325456, 146, '2015-01-15 00:02:32.000000', 'temperatura', 629.0000, 'ºC'),
	(325457, 146, '2015-01-15 00:02:33.000000', 'temperatura', 804.0000, 'ºC'),
	(325458, 146, '2015-01-15 00:02:34.000000', 'temperatura', 933.0000, 'ºC'),
	(325459, 146, '2015-01-15 00:02:35.000000', 'temperatura', 1053.0000, 'ºC'),
	(325460, 146, '2015-01-15 00:02:36.000000', 'temperatura', 68.0000, 'ºC'),
	(325461, 146, '2015-01-15 00:02:37.000000', 'temperatura', 783.0000, 'ºC'),
	(325462, 146, '2015-01-15 00:02:38.000000', 'temperatura', 108.0000, 'ºC'),
	(325463, 146, '2015-01-15 00:02:39.000000', 'temperatura', 591.0000, 'ºC'),
	(325464, 146, '2015-01-15 00:02:40.000000', 'temperatura', 234.0000, 'ºC'),
	(325465, 146, '2015-01-15 00:02:41.000000', 'temperatura', 597.0000, 'ºC'),
	(325466, 146, '2015-01-15 00:02:42.000000', 'temperatura', 1083.0000, 'ºC'),
	(325467, 146, '2015-01-15 00:02:43.000000', 'temperatura', 24.0000, 'ºC'),
	(325468, 146, '2015-01-15 00:02:44.000000', 'temperatura', 473.0000, 'ºC'),
	(325469, 146, '2015-01-15 00:02:45.000000', 'temperatura', 1094.0000, 'ºC'),
	(325470, 146, '2015-01-15 00:02:46.000000', 'temperatura', 450.0000, 'ºC'),
	(325471, 146, '2015-01-15 00:02:47.000000', 'temperatura', 171.0000, 'ºC'),
	(325472, 146, '2015-01-15 00:02:48.000000', 'temperatura', 704.0000, 'ºC'),
	(325473, 146, '2015-01-15 00:02:49.000000', 'temperatura', 609.0000, 'ºC'),
	(325474, 146, '2015-01-15 00:02:50.000000', 'temperatura', 932.0000, 'ºC'),
	(325475, 146, '2015-01-15 00:02:51.000000', 'temperatura', 435.0000, 'ºC'),
	(325476, 146, '2015-01-15 00:02:52.000000', 'temperatura', 579.0000, 'ºC'),
	(325477, 146, '2015-01-15 00:02:53.000000', 'temperatura', 389.0000, 'ºC'),
	(325478, 146, '2015-01-15 00:02:54.000000', 'temperatura', 209.0000, 'ºC'),
	(325479, 146, '2015-01-15 00:02:55.000000', 'temperatura', 1078.0000, 'ºC'),
	(325480, 146, '2015-01-15 00:02:56.000000', 'temperatura', 1163.0000, 'ºC'),
	(325481, 146, '2015-01-15 00:02:57.000000', 'temperatura', 183.0000, 'ºC'),
	(325482, 146, '2015-01-15 00:02:58.000000', 'temperatura', 1028.0000, 'ºC'),
	(325483, 146, '2015-01-15 00:02:59.000000', 'temperatura', 988.0000, 'ºC'),
	(325484, 146, '2015-01-15 00:03:00.000000', 'temperatura', 660.0000, 'ºC'),
	(325485, 146, '2015-01-15 00:03:01.000000', 'temperatura', 335.0000, 'ºC'),
	(325486, 146, '2015-01-15 00:03:02.000000', 'temperatura', 897.0000, 'ºC'),
	(325487, 146, '2015-01-15 00:03:03.000000', 'temperatura', 1080.0000, 'ºC'),
	(325488, 146, '2015-01-15 00:03:04.000000', 'temperatura', 308.0000, 'ºC'),
	(325489, 146, '2015-01-15 00:03:05.000000', 'temperatura', 700.0000, 'ºC'),
	(325490, 146, '2015-01-15 00:03:06.000000', 'temperatura', 177.0000, 'ºC'),
	(325491, 146, '2015-01-15 00:03:07.000000', 'temperatura', 1185.0000, 'ºC'),
	(325492, 146, '2015-01-15 00:03:08.000000', 'temperatura', 596.0000, 'ºC'),
	(325493, 146, '2015-01-15 00:03:09.000000', 'temperatura', 624.0000, 'ºC'),
	(325494, 146, '2015-01-15 00:03:10.000000', 'temperatura', 131.0000, 'ºC'),
	(325495, 146, '2015-01-15 00:03:11.000000', 'temperatura', 1186.0000, 'ºC'),
	(325496, 146, '2015-01-15 00:03:12.000000', 'temperatura', 737.0000, 'ºC'),
	(325497, 146, '2015-01-15 00:03:13.000000', 'temperatura', 128.0000, 'ºC'),
	(325498, 146, '2015-01-15 00:03:14.000000', 'temperatura', 830.0000, 'ºC'),
	(325499, 146, '2015-01-15 00:03:15.000000', 'temperatura', 165.0000, 'ºC'),
	(325500, 146, '2015-01-15 00:03:16.000000', 'temperatura', 734.0000, 'ºC'),
	(325501, 146, '2015-01-15 00:03:17.000000', 'temperatura', 778.0000, 'ºC'),
	(325502, 146, '2015-01-15 00:03:18.000000', 'temperatura', 486.0000, 'ºC'),
	(325503, 146, '2015-01-15 00:03:19.000000', 'temperatura', 99.0000, 'ºC'),
	(325504, 146, '2015-01-15 00:03:20.000000', 'temperatura', 235.0000, 'ºC'),
	(325505, 146, '2015-01-15 00:03:21.000000', 'temperatura', 881.0000, 'ºC'),
	(325506, 146, '2015-01-15 00:03:22.000000', 'temperatura', 99.0000, 'ºC'),
	(325507, 146, '2015-01-15 00:03:23.000000', 'temperatura', 252.0000, 'ºC'),
	(325508, 146, '2015-01-15 00:03:24.000000', 'temperatura', 964.0000, 'ºC'),
	(325509, 146, '2015-01-15 00:03:25.000000', 'temperatura', 465.0000, 'ºC'),
	(325510, 146, '2015-01-15 00:03:26.000000', 'temperatura', 633.0000, 'ºC'),
	(325511, 146, '2015-01-15 00:03:27.000000', 'temperatura', 572.0000, 'ºC'),
	(325512, 146, '2015-01-15 00:03:28.000000', 'temperatura', 960.0000, 'ºC'),
	(325513, 146, '2015-01-15 00:03:29.000000', 'temperatura', 684.0000, 'ºC'),
	(325514, 146, '2015-01-15 00:03:30.000000', 'temperatura', 541.0000, 'ºC'),
	(325515, 146, '2015-01-15 00:03:31.000000', 'temperatura', 655.0000, 'ºC'),
	(325516, 146, '2015-01-15 00:03:32.000000', 'temperatura', 451.0000, 'ºC'),
	(325517, 146, '2015-01-15 00:03:33.000000', 'temperatura', 289.0000, 'ºC'),
	(325518, 146, '2015-01-15 00:03:34.000000', 'temperatura', 95.0000, 'ºC'),
	(325519, 146, '2015-01-15 00:03:35.000000', 'temperatura', 807.0000, 'ºC'),
	(325520, 146, '2015-01-15 00:03:36.000000', 'temperatura', 153.0000, 'ºC'),
	(325521, 146, '2015-01-15 00:03:37.000000', 'temperatura', 741.0000, 'ºC'),
	(325522, 146, '2015-01-15 00:03:38.000000', 'temperatura', 849.0000, 'ºC'),
	(325523, 146, '2015-01-15 00:03:39.000000', 'temperatura', 823.0000, 'ºC'),
	(325524, 146, '2015-01-15 00:03:40.000000', 'temperatura', 367.0000, 'ºC'),
	(325525, 146, '2015-01-15 00:03:41.000000', 'temperatura', 567.0000, 'ºC'),
	(325526, 146, '2015-01-15 00:03:42.000000', 'temperatura', 532.0000, 'ºC'),
	(325527, 146, '2015-01-15 00:03:43.000000', 'temperatura', 963.0000, 'ºC'),
	(325528, 146, '2015-01-15 00:03:44.000000', 'temperatura', 818.0000, 'ºC'),
	(325529, 146, '2015-01-15 00:03:45.000000', 'temperatura', 4.0000, 'ºC'),
	(325530, 146, '2015-01-15 00:03:46.000000', 'temperatura', 1163.0000, 'ºC'),
	(325531, 146, '2015-01-15 00:03:47.000000', 'temperatura', 1005.0000, 'ºC'),
	(325532, 146, '2015-01-15 00:03:48.000000', 'temperatura', 337.0000, 'ºC'),
	(325533, 146, '2015-01-15 00:03:49.000000', 'temperatura', 1069.0000, 'ºC'),
	(325534, 146, '2015-01-15 00:03:50.000000', 'temperatura', 737.0000, 'ºC'),
	(325535, 146, '2015-01-15 00:03:51.000000', 'temperatura', 479.0000, 'ºC'),
	(325536, 146, '2015-01-15 00:03:52.000000', 'temperatura', 182.0000, 'ºC'),
	(325537, 146, '2015-01-15 00:03:53.000000', 'temperatura', 674.0000, 'ºC'),
	(325538, 146, '2015-01-15 00:03:54.000000', 'temperatura', 425.0000, 'ºC'),
	(325539, 146, '2015-01-15 00:03:55.000000', 'temperatura', 105.0000, 'ºC'),
	(325540, 146, '2015-01-15 00:03:56.000000', 'temperatura', 451.0000, 'ºC'),
	(325541, 146, '2015-01-15 00:03:57.000000', 'temperatura', 737.0000, 'ºC'),
	(325542, 146, '2015-01-15 00:03:58.000000', 'temperatura', 1136.0000, 'ºC'),
	(325543, 146, '2015-01-15 00:03:59.000000', 'temperatura', 1069.0000, 'ºC'),
	(325544, 146, '2015-01-15 00:04:00.000000', 'temperatura', 738.0000, 'ºC'),
	(325545, 146, '2015-01-15 00:04:01.000000', 'temperatura', 484.0000, 'ºC'),
	(325546, 146, '2015-01-15 00:04:02.000000', 'temperatura', 206.0000, 'ºC'),
	(325547, 146, '2015-01-15 00:04:03.000000', 'temperatura', 779.0000, 'ºC'),
	(325548, 146, '2015-01-15 00:04:04.000000', 'temperatura', 878.0000, 'ºC'),
	(325549, 146, '2015-01-15 00:04:05.000000', 'temperatura', 853.0000, 'ºC'),
	(325550, 146, '2015-01-15 00:04:06.000000', 'temperatura', 433.0000, 'ºC'),
	(325551, 146, '2015-01-15 00:04:07.000000', 'temperatura', 805.0000, 'ºC'),
	(325552, 146, '2015-01-15 00:04:08.000000', 'temperatura', 325.0000, 'ºC'),
	(325553, 146, '2015-01-15 00:04:09.000000', 'temperatura', 413.0000, 'ºC'),
	(325554, 146, '2015-01-15 00:04:10.000000', 'temperatura', 1091.0000, 'ºC'),
	(325555, 146, '2015-01-15 00:04:11.000000', 'temperatura', 614.0000, 'ºC'),
	(325556, 146, '2015-01-15 00:04:12.000000', 'temperatura', 997.0000, 'ºC'),
	(325557, 146, '2015-01-15 00:04:13.000000', 'temperatura', 743.0000, 'ºC'),
	(325558, 146, '2015-01-15 00:04:14.000000', 'temperatura', 727.0000, 'ºC'),
	(325559, 146, '2015-01-15 00:04:15.000000', 'temperatura', 205.0000, 'ºC'),
	(325560, 146, '2015-01-15 00:04:16.000000', 'temperatura', 45.0000, 'ºC'),
	(325561, 146, '2015-01-15 00:04:17.000000', 'temperatura', 811.0000, 'ºC'),
	(325562, 146, '2015-01-15 00:04:18.000000', 'temperatura', 320.0000, 'ºC'),
	(325563, 146, '2015-01-15 00:04:19.000000', 'temperatura', 366.0000, 'ºC'),
	(325564, 146, '2015-01-15 00:04:20.000000', 'temperatura', 871.0000, 'ºC'),
	(325565, 146, '2015-01-15 00:04:21.000000', 'temperatura', 858.0000, 'ºC'),
	(325566, 146, '2015-01-15 00:04:22.000000', 'temperatura', 479.0000, 'ºC'),
	(325567, 146, '2015-01-15 00:04:23.000000', 'temperatura', 1023.0000, 'ºC'),
	(325568, 146, '2015-01-15 00:04:24.000000', 'temperatura', 75.0000, 'ºC'),
	(325569, 146, '2015-01-15 00:04:25.000000', 'temperatura', 907.0000, 'ºC'),
	(325570, 146, '2015-01-15 00:04:26.000000', 'temperatura', 710.0000, 'ºC'),
	(325571, 146, '2015-01-15 00:04:27.000000', 'temperatura', 831.0000, 'ºC'),
	(325572, 146, '2015-01-15 00:04:28.000000', 'temperatura', 827.0000, 'ºC'),
	(325573, 146, '2015-01-15 00:04:29.000000', 'temperatura', 439.0000, 'ºC'),
	(325574, 146, '2015-01-15 00:04:30.000000', 'temperatura', 917.0000, 'ºC'),
	(325575, 146, '2015-01-15 00:04:31.000000', 'temperatura', 866.0000, 'ºC'),
	(325576, 146, '2015-01-15 00:04:32.000000', 'temperatura', 382.0000, 'ºC'),
	(325577, 146, '2015-01-15 00:04:33.000000', 'temperatura', 510.0000, 'ºC'),
	(325578, 146, '2015-01-15 00:04:34.000000', 'temperatura', 206.0000, 'ºC'),
	(325579, 146, '2015-01-15 00:04:35.000000', 'temperatura', 698.0000, 'ºC'),
	(325580, 146, '2015-01-15 00:04:36.000000', 'temperatura', 476.0000, 'ºC'),
	(325581, 146, '2015-01-15 00:04:37.000000', 'temperatura', 284.0000, 'ºC'),
	(325582, 146, '2015-01-15 00:04:38.000000', 'temperatura', 1195.0000, 'ºC'),
	(325583, 146, '2015-01-15 00:04:39.000000', 'temperatura', 322.0000, 'ºC'),
	(325584, 146, '2015-01-15 00:04:40.000000', 'temperatura', 426.0000, 'ºC'),
	(325585, 146, '2015-01-15 00:04:41.000000', 'temperatura', 1166.0000, 'ºC'),
	(325586, 146, '2015-01-15 00:04:42.000000', 'temperatura', 950.0000, 'ºC'),
	(325587, 146, '2015-01-15 00:04:43.000000', 'temperatura', 53.0000, 'ºC'),
	(325588, 146, '2015-01-15 00:04:44.000000', 'temperatura', 1016.0000, 'ºC'),
	(325589, 146, '2015-01-15 00:04:45.000000', 'temperatura', 120.0000, 'ºC'),
	(325590, 146, '2015-01-15 00:04:46.000000', 'temperatura', 1155.0000, 'ºC'),
	(325591, 146, '2015-01-15 00:04:47.000000', 'temperatura', 616.0000, 'ºC'),
	(325592, 146, '2015-01-15 00:04:48.000000', 'temperatura', 814.0000, 'ºC'),
	(325593, 146, '2015-01-15 00:04:49.000000', 'temperatura', 1025.0000, 'ºC'),
	(325594, 146, '2015-01-15 00:04:50.000000', 'temperatura', 281.0000, 'ºC'),
	(325595, 146, '2015-01-15 00:04:51.000000', 'temperatura', 730.0000, 'ºC'),
	(325596, 146, '2015-01-15 00:04:52.000000', 'temperatura', 408.0000, 'ºC'),
	(325597, 146, '2015-01-15 00:04:53.000000', 'temperatura', 1050.0000, 'ºC'),
	(325598, 146, '2015-01-15 00:04:54.000000', 'temperatura', 426.0000, 'ºC'),
	(325599, 146, '2015-01-15 00:04:55.000000', 'temperatura', 181.0000, 'ºC'),
	(325600, 146, '2015-01-15 00:04:56.000000', 'temperatura', 829.0000, 'ºC'),
	(325601, 146, '2015-01-15 00:04:57.000000', 'temperatura', 0.0000, 'ºC'),
	(325602, 146, '2015-01-15 00:04:58.000000', 'temperatura', 1116.0000, 'ºC'),
	(325603, 146, '2015-01-15 00:04:59.000000', 'temperatura', 778.0000, 'ºC'),
	(325604, 146, '2015-01-15 00:05:00.000000', 'temperatura', 544.0000, 'ºC'),
	(325605, 146, '2015-01-15 00:05:01.000000', 'temperatura', 387.0000, 'ºC'),
	(325606, 146, '2015-01-15 00:05:02.000000', 'temperatura', 304.0000, 'ºC'),
	(325607, 146, '2015-01-15 00:05:03.000000', 'temperatura', 361.0000, 'ºC'),
	(325608, 146, '2015-01-15 00:05:04.000000', 'temperatura', 890.0000, 'ºC'),
	(325609, 146, '2015-01-15 00:05:05.000000', 'temperatura', 969.0000, 'ºC'),
	(325610, 146, '2015-01-15 00:05:06.000000', 'temperatura', 975.0000, 'ºC'),
	(325611, 146, '2015-01-15 00:05:07.000000', 'temperatura', 768.0000, 'ºC'),
	(325612, 146, '2015-01-15 00:05:08.000000', 'temperatura', 917.0000, 'ºC'),
	(325613, 146, '2015-01-15 00:05:09.000000', 'temperatura', 1082.0000, 'ºC'),
	(325614, 146, '2015-01-15 00:05:10.000000', 'temperatura', 260.0000, 'ºC'),
	(325615, 146, '2015-01-15 00:05:11.000000', 'temperatura', 453.0000, 'ºC'),
	(325616, 146, '2015-01-15 00:05:12.000000', 'temperatura', 287.0000, 'ºC'),
	(325617, 146, '2015-01-15 00:05:13.000000', 'temperatura', 75.0000, 'ºC'),
	(325618, 146, '2015-01-15 00:05:14.000000', 'temperatura', 714.0000, 'ºC'),
	(325619, 146, '2015-01-15 00:05:15.000000', 'temperatura', 948.0000, 'ºC'),
	(325620, 146, '2015-01-15 00:05:16.000000', 'temperatura', 197.0000, 'ºC'),
	(325621, 146, '2015-01-15 00:05:17.000000', 'temperatura', 543.0000, 'ºC'),
	(325622, 146, '2015-01-15 00:05:18.000000', 'temperatura', 923.0000, 'ºC'),
	(325623, 146, '2015-01-15 00:05:19.000000', 'temperatura', 586.0000, 'ºC'),
	(325624, 146, '2015-01-15 00:05:20.000000', 'temperatura', 161.0000, 'ºC'),
	(325625, 146, '2015-01-15 00:05:21.000000', 'temperatura', 249.0000, 'ºC'),
	(325626, 146, '2015-01-15 00:05:22.000000', 'temperatura', 760.0000, 'ºC'),
	(325627, 146, '2015-01-15 00:05:23.000000', 'temperatura', 657.0000, 'ºC'),
	(325628, 146, '2015-01-15 00:05:24.000000', 'temperatura', 1003.0000, 'ºC'),
	(325629, 146, '2015-01-15 00:05:25.000000', 'temperatura', 645.0000, 'ºC'),
	(325630, 146, '2015-01-15 00:05:26.000000', 'temperatura', 217.0000, 'ºC'),
	(325631, 146, '2015-01-15 00:05:27.000000', 'temperatura', 350.0000, 'ºC'),
	(325632, 146, '2015-01-15 00:05:28.000000', 'temperatura', 1098.0000, 'ºC'),
	(325633, 146, '2015-01-15 00:05:29.000000', 'temperatura', 841.0000, 'ºC'),
	(325634, 146, '2015-01-15 00:05:30.000000', 'temperatura', 912.0000, 'ºC'),
	(325635, 146, '2015-01-15 00:05:31.000000', 'temperatura', 837.0000, 'ºC'),
	(325636, 146, '2015-01-15 00:05:32.000000', 'temperatura', 250.0000, 'ºC'),
	(325637, 146, '2015-01-15 00:05:33.000000', 'temperatura', 1141.0000, 'ºC'),
	(325638, 146, '2015-01-15 00:05:34.000000', 'temperatura', 156.0000, 'ºC'),
	(325639, 146, '2015-01-15 00:05:35.000000', 'temperatura', 958.0000, 'ºC'),
	(325640, 146, '2015-01-15 00:05:36.000000', 'temperatura', 723.0000, 'ºC'),
	(325641, 146, '2015-01-15 00:05:37.000000', 'temperatura', 739.0000, 'ºC'),
	(325642, 146, '2015-01-15 00:05:38.000000', 'temperatura', 328.0000, 'ºC'),
	(325643, 146, '2015-01-15 00:05:39.000000', 'temperatura', 621.0000, 'ºC'),
	(325644, 146, '2015-01-15 00:05:40.000000', 'temperatura', 924.0000, 'ºC'),
	(325645, 146, '2015-01-15 00:05:41.000000', 'temperatura', 355.0000, 'ºC'),
	(325646, 146, '2015-01-15 00:05:42.000000', 'temperatura', 206.0000, 'ºC'),
	(325647, 146, '2015-01-15 00:05:43.000000', 'temperatura', 1164.0000, 'ºC'),
	(325648, 146, '2015-01-15 00:05:44.000000', 'temperatura', 405.0000, 'ºC'),
	(325649, 146, '2015-01-15 00:05:45.000000', 'temperatura', 931.0000, 'ºC'),
	(325650, 146, '2015-01-15 00:05:46.000000', 'temperatura', 1041.0000, 'ºC'),
	(325651, 146, '2015-01-15 00:05:47.000000', 'temperatura', 14.0000, 'ºC'),
	(325652, 146, '2015-01-15 00:05:48.000000', 'temperatura', 549.0000, 'ºC'),
	(325653, 146, '2015-01-15 00:05:49.000000', 'temperatura', 300.0000, 'ºC'),
	(325654, 146, '2015-01-15 00:05:50.000000', 'temperatura', 1055.0000, 'ºC'),
	(325655, 146, '2015-01-15 00:05:51.000000', 'temperatura', 776.0000, 'ºC'),
	(325656, 146, '2015-01-15 00:05:52.000000', 'temperatura', 715.0000, 'ºC'),
	(325657, 146, '2015-01-15 00:05:53.000000', 'temperatura', 48.0000, 'ºC'),
	(325658, 146, '2015-01-15 00:05:54.000000', 'temperatura', 495.0000, 'ºC'),
	(325659, 146, '2015-01-15 00:05:55.000000', 'temperatura', 1132.0000, 'ºC'),
	(325660, 146, '2015-01-15 00:05:56.000000', 'temperatura', 577.0000, 'ºC'),
	(325661, 146, '2015-01-15 00:05:57.000000', 'temperatura', 688.0000, 'ºC'),
	(325662, 146, '2015-01-15 00:05:58.000000', 'temperatura', 509.0000, 'ºC'),
	(325663, 146, '2015-01-15 00:05:59.000000', 'temperatura', 483.0000, 'ºC'),
	(325664, 146, '2015-01-15 00:06:00.000000', 'temperatura', 889.0000, 'ºC'),
	(325665, 146, '2015-01-15 00:06:01.000000', 'temperatura', 594.0000, 'ºC'),
	(325666, 146, '2015-01-15 00:06:02.000000', 'temperatura', 303.0000, 'ºC'),
	(325667, 146, '2015-01-15 00:06:03.000000', 'temperatura', 936.0000, 'ºC'),
	(325668, 146, '2015-01-15 00:06:04.000000', 'temperatura', 169.0000, 'ºC'),
	(325669, 146, '2015-01-15 00:06:05.000000', 'temperatura', 438.0000, 'ºC'),
	(325670, 146, '2015-01-15 00:06:06.000000', 'temperatura', 485.0000, 'ºC'),
	(325671, 146, '2015-01-15 00:06:07.000000', 'temperatura', 1109.0000, 'ºC'),
	(325672, 146, '2015-01-15 00:06:08.000000', 'temperatura', 493.0000, 'ºC'),
	(325673, 146, '2015-01-15 00:06:09.000000', 'temperatura', 339.0000, 'ºC'),
	(325674, 146, '2015-01-15 00:06:10.000000', 'temperatura', 215.0000, 'ºC'),
	(325675, 146, '2015-01-15 00:06:11.000000', 'temperatura', 61.0000, 'ºC'),
	(325676, 146, '2015-01-15 00:06:12.000000', 'temperatura', 857.0000, 'ºC'),
	(325677, 146, '2015-01-15 00:06:13.000000', 'temperatura', 505.0000, 'ºC'),
	(325678, 146, '2015-01-15 00:06:14.000000', 'temperatura', 1155.0000, 'ºC'),
	(325679, 146, '2015-01-15 00:06:15.000000', 'temperatura', 659.0000, 'ºC'),
	(325680, 146, '2015-01-15 00:06:16.000000', 'temperatura', 1030.0000, 'ºC'),
	(325681, 146, '2015-01-15 00:06:17.000000', 'temperatura', 772.0000, 'ºC'),
	(325682, 146, '2015-01-15 00:06:18.000000', 'temperatura', 772.0000, 'ºC'),
	(325683, 146, '2015-01-15 00:06:19.000000', 'temperatura', 345.0000, 'ºC'),
	(325684, 146, '2015-01-15 00:06:20.000000', 'temperatura', 608.0000, 'ºC'),
	(325685, 146, '2015-01-15 00:06:21.000000', 'temperatura', 805.0000, 'ºC'),
	(325686, 146, '2015-01-15 00:06:22.000000', 'temperatura', 1004.0000, 'ºC'),
	(325687, 146, '2015-01-15 00:06:23.000000', 'temperatura', 205.0000, 'ºC'),
	(325688, 146, '2015-01-15 00:06:24.000000', 'temperatura', 414.0000, 'ºC'),
	(325689, 146, '2015-01-15 00:06:25.000000', 'temperatura', 254.0000, 'ºC'),
	(325690, 146, '2015-01-15 00:06:26.000000', 'temperatura', 31.0000, 'ºC'),
	(325691, 146, '2015-01-15 00:06:27.000000', 'temperatura', 591.0000, 'ºC'),
	(325692, 146, '2015-01-15 00:06:28.000000', 'temperatura', 465.0000, 'ºC'),
	(325693, 146, '2015-01-15 00:06:29.000000', 'temperatura', 550.0000, 'ºC'),
	(325694, 146, '2015-01-15 00:06:30.000000', 'temperatura', 155.0000, 'ºC'),
	(325695, 146, '2015-01-15 00:06:31.000000', 'temperatura', 327.0000, 'ºC'),
	(325696, 146, '2015-01-15 00:06:32.000000', 'temperatura', 1170.0000, 'ºC'),
	(325697, 146, '2015-01-15 00:06:33.000000', 'temperatura', 70.0000, 'ºC'),
	(325698, 146, '2015-01-15 00:06:34.000000', 'temperatura', 438.0000, 'ºC'),
	(325699, 146, '2015-01-15 00:06:35.000000', 'temperatura', 783.0000, 'ºC'),
	(325700, 146, '2015-01-15 00:06:36.000000', 'temperatura', 200.0000, 'ºC'),
	(325701, 146, '2015-01-15 00:06:37.000000', 'temperatura', 1054.0000, 'ºC'),
	(325702, 146, '2015-01-15 00:06:38.000000', 'temperatura', 1070.0000, 'ºC'),
	(325703, 146, '2015-01-15 00:06:39.000000', 'temperatura', 988.0000, 'ºC'),
	(325704, 146, '2015-01-15 00:06:40.000000', 'temperatura', 530.0000, 'ºC'),
	(325705, 146, '2015-01-15 00:06:41.000000', 'temperatura', 889.0000, 'ºC'),
	(325706, 146, '2015-01-15 00:06:42.000000', 'temperatura', 452.0000, 'ºC'),
	(325707, 146, '2015-01-15 00:06:43.000000', 'temperatura', 797.0000, 'ºC'),
	(325708, 146, '2015-01-15 00:06:44.000000', 'temperatura', 227.0000, 'ºC'),
	(325709, 146, '2015-01-15 00:06:45.000000', 'temperatura', 1147.0000, 'ºC'),
	(325710, 146, '2015-01-15 00:06:46.000000', 'temperatura', 254.0000, 'ºC'),
	(325711, 146, '2015-01-15 00:06:47.000000', 'temperatura', 231.0000, 'ºC'),
	(325712, 146, '2015-01-15 00:06:48.000000', 'temperatura', 391.0000, 'ºC'),
	(325713, 146, '2015-01-15 00:06:49.000000', 'temperatura', 65.0000, 'ºC'),
	(325714, 146, '2015-01-15 00:06:50.000000', 'temperatura', 350.0000, 'ºC'),
	(325715, 146, '2015-01-15 00:06:51.000000', 'temperatura', 356.0000, 'ºC'),
	(325716, 146, '2015-01-15 00:06:52.000000', 'temperatura', 730.0000, 'ºC'),
	(325717, 146, '2015-01-15 00:06:53.000000', 'temperatura', 182.0000, 'ºC'),
	(325718, 146, '2015-01-15 00:06:54.000000', 'temperatura', 1121.0000, 'ºC'),
	(325719, 146, '2015-01-15 00:06:55.000000', 'temperatura', 261.0000, 'ºC'),
	(325720, 146, '2015-01-15 00:06:56.000000', 'temperatura', 340.0000, 'ºC'),
	(325721, 146, '2015-01-15 00:06:57.000000', 'temperatura', 917.0000, 'ºC'),
	(325722, 146, '2015-01-15 00:06:58.000000', 'temperatura', 1165.0000, 'ºC'),
	(325723, 146, '2015-01-15 00:06:59.000000', 'temperatura', 676.0000, 'ºC'),
	(325724, 146, '2015-01-15 00:07:00.000000', 'temperatura', 1084.0000, 'ºC'),
	(325725, 146, '2015-01-15 00:07:01.000000', 'temperatura', 995.0000, 'ºC'),
	(325726, 146, '2015-01-15 00:07:02.000000', 'temperatura', 523.0000, 'ºC'),
	(325727, 146, '2015-01-15 00:07:03.000000', 'temperatura', 831.0000, 'ºC'),
	(325728, 146, '2015-01-15 00:07:04.000000', 'temperatura', 185.0000, 'ºC'),
	(325729, 146, '2015-01-15 00:07:05.000000', 'temperatura', 834.0000, 'ºC'),
	(325730, 146, '2015-01-15 00:07:06.000000', 'temperatura', 16.0000, 'ºC'),
	(325731, 146, '2015-01-15 00:07:07.000000', 'temperatura', 1176.0000, 'ºC'),
	(325732, 146, '2015-01-15 00:07:08.000000', 'temperatura', 1034.0000, 'ºC'),
	(325733, 146, '2015-01-15 00:07:09.000000', 'temperatura', 443.0000, 'ºC'),
	(325734, 146, '2015-01-15 00:07:10.000000', 'temperatura', 313.0000, 'ºC'),
	(325735, 146, '2015-01-15 00:07:11.000000', 'temperatura', 237.0000, 'ºC'),
	(325736, 146, '2015-01-15 00:07:12.000000', 'temperatura', 248.0000, 'ºC'),
	(325737, 146, '2015-01-15 00:07:13.000000', 'temperatura', 528.0000, 'ºC'),
	(325738, 146, '2015-01-15 00:07:14.000000', 'temperatura', 698.0000, 'ºC'),
	(325739, 146, '2015-01-15 00:07:15.000000', 'temperatura', 706.0000, 'ºC'),
	(325740, 146, '2015-01-15 00:07:16.000000', 'temperatura', 237.0000, 'ºC'),
	(325741, 146, '2015-01-15 00:07:17.000000', 'temperatura', 266.0000, 'ºC'),
	(325742, 146, '2015-01-15 00:07:18.000000', 'temperatura', 622.0000, 'ºC'),
	(325743, 146, '2015-01-15 00:07:19.000000', 'temperatura', 1111.0000, 'ºC'),
	(325744, 146, '2015-01-15 00:07:20.000000', 'temperatura', 92.0000, 'ºC'),
	(325745, 146, '2015-01-15 00:07:21.000000', 'temperatura', 724.0000, 'ºC'),
	(325746, 146, '2015-01-15 00:07:22.000000', 'temperatura', 947.0000, 'ºC'),
	(325747, 146, '2015-01-15 00:07:23.000000', 'temperatura', 161.0000, 'ºC'),
	(325748, 146, '2015-01-15 00:07:24.000000', 'temperatura', 365.0000, 'ºC'),
	(325749, 146, '2015-01-15 00:07:25.000000', 'temperatura', 143.0000, 'ºC'),
	(325750, 146, '2015-01-15 00:07:26.000000', 'temperatura', 819.0000, 'ºC'),
	(325751, 146, '2015-01-15 00:07:27.000000', 'temperatura', 67.0000, 'ºC'),
	(325752, 146, '2015-01-15 00:07:28.000000', 'temperatura', 280.0000, 'ºC'),
	(325753, 146, '2015-01-15 00:07:29.000000', 'temperatura', 0.0000, 'ºC'),
	(325754, 146, '2015-01-15 00:07:30.000000', 'temperatura', 360.0000, 'ºC'),
	(325755, 146, '2015-01-15 00:07:31.000000', 'temperatura', 599.0000, 'ºC'),
	(325756, 146, '2015-01-15 00:07:32.000000', 'temperatura', 718.0000, 'ºC'),
	(325757, 146, '2015-01-15 00:07:33.000000', 'temperatura', 592.0000, 'ºC'),
	(325758, 146, '2015-01-15 00:07:34.000000', 'temperatura', 806.0000, 'ºC'),
	(325759, 146, '2015-01-15 00:07:35.000000', 'temperatura', 1055.0000, 'ºC'),
	(325760, 146, '2015-01-15 00:07:36.000000', 'temperatura', 457.0000, 'ºC'),
	(325761, 146, '2015-01-15 00:07:37.000000', 'temperatura', 320.0000, 'ºC'),
	(325762, 146, '2015-01-15 00:07:38.000000', 'temperatura', 228.0000, 'ºC'),
	(325763, 146, '2015-01-15 00:07:39.000000', 'temperatura', 182.0000, 'ºC'),
	(325764, 146, '2015-01-15 00:07:40.000000', 'temperatura', 226.0000, 'ºC'),
	(325765, 146, '2015-01-15 00:07:41.000000', 'temperatura', 584.0000, 'ºC'),
	(325766, 146, '2015-01-15 00:07:42.000000', 'temperatura', 1045.0000, 'ºC'),
	(325767, 146, '2015-01-15 00:07:43.000000', 'temperatura', 1071.0000, 'ºC'),
	(325768, 146, '2015-01-15 00:07:44.000000', 'temperatura', 1021.0000, 'ºC'),
	(325769, 146, '2015-01-15 00:07:45.000000', 'temperatura', 693.0000, 'ºC'),
	(325770, 146, '2015-01-15 00:07:46.000000', 'temperatura', 401.0000, 'ºC'),
	(325771, 146, '2015-01-15 00:07:47.000000', 'temperatura', 1127.0000, 'ºC'),
	(325772, 146, '2015-01-15 00:07:48.000000', 'temperatura', 834.0000, 'ºC'),
	(325773, 146, '2015-01-15 00:07:49.000000', 'temperatura', 789.0000, 'ºC'),
	(325774, 146, '2015-01-15 00:07:50.000000', 'temperatura', 241.0000, 'ºC'),
	(325775, 146, '2015-01-15 00:07:51.000000', 'temperatura', 42.0000, 'ºC'),
	(325776, 146, '2015-01-15 00:07:52.000000', 'temperatura', 685.0000, 'ºC'),
	(325777, 146, '2015-01-15 00:07:53.000000', 'temperatura', 901.0000, 'ºC'),
	(325778, 146, '2015-01-15 00:07:54.000000', 'temperatura', 49.0000, 'ºC'),
	(325779, 146, '2015-01-15 00:07:55.000000', 'temperatura', 1145.0000, 'ºC'),
	(325780, 146, '2015-01-15 00:07:56.000000', 'temperatura', 778.0000, 'ºC'),
	(325781, 146, '2015-01-15 00:07:57.000000', 'temperatura', 454.0000, 'ºC'),
	(325782, 146, '2015-01-15 00:07:58.000000', 'temperatura', 1138.0000, 'ºC'),
	(325783, 146, '2015-01-15 00:07:59.000000', 'temperatura', 727.0000, 'ºC'),
	(325784, 146, '2015-01-15 00:08:00.000000', 'temperatura', 223.0000, 'ºC'),
	(325785, 146, '2015-01-15 00:08:01.000000', 'temperatura', 132.0000, 'ºC'),
	(325786, 146, '2015-01-15 00:08:02.000000', 'temperatura', 1192.0000, 'ºC'),
	(325787, 146, '2015-01-15 00:08:03.000000', 'temperatura', 766.0000, 'ºC'),
	(325788, 146, '2015-01-15 00:08:04.000000', 'temperatura', 254.0000, 'ºC'),
	(325789, 146, '2015-01-15 00:08:05.000000', 'temperatura', 175.0000, 'ºC'),
	(325790, 146, '2015-01-15 00:08:06.000000', 'temperatura', 110.0000, 'ºC'),
	(325791, 146, '2015-01-15 00:08:07.000000', 'temperatura', 25.0000, 'ºC'),
	(325792, 146, '2015-01-15 00:08:08.000000', 'temperatura', 997.0000, 'ºC'),
	(325793, 146, '2015-01-15 00:08:09.000000', 'temperatura', 111.0000, 'ºC'),
	(325794, 146, '2015-01-15 00:08:10.000000', 'temperatura', 1164.0000, 'ºC'),
	(325795, 146, '2015-01-15 00:08:11.000000', 'temperatura', 689.0000, 'ºC'),
	(325796, 146, '2015-01-15 00:08:12.000000', 'temperatura', 1154.0000, 'ºC'),
	(325797, 146, '2015-01-15 00:08:13.000000', 'temperatura', 103.0000, 'ºC'),
	(325798, 146, '2015-01-15 00:08:14.000000', 'temperatura', 653.0000, 'ºC'),
	(325799, 146, '2015-01-15 00:08:15.000000', 'temperatura', 556.0000, 'ºC'),
	(325800, 146, '2015-01-15 00:08:16.000000', 'temperatura', 822.0000, 'ºC'),
	(325801, 146, '2015-01-15 00:08:17.000000', 'temperatura', 42.0000, 'ºC'),
	(325802, 146, '2015-01-15 00:08:18.000000', 'temperatura', 143.0000, 'ºC'),
	(325803, 146, '2015-01-15 00:08:19.000000', 'temperatura', 592.0000, 'ºC'),
	(325804, 146, '2015-01-15 00:08:20.000000', 'temperatura', 130.0000, 'ºC'),
	(325805, 146, '2015-01-15 00:08:21.000000', 'temperatura', 75.0000, 'ºC'),
	(325806, 146, '2015-01-15 00:08:22.000000', 'temperatura', 1185.0000, 'ºC'),
	(325807, 146, '2015-01-15 00:08:23.000000', 'temperatura', 902.0000, 'ºC'),
	(325808, 146, '2015-01-15 00:08:24.000000', 'temperatura', 956.0000, 'ºC'),
	(325809, 146, '2015-01-15 00:08:25.000000', 'temperatura', 874.0000, 'ºC'),
	(325810, 146, '2015-01-15 00:08:26.000000', 'temperatura', 304.0000, 'ºC'),
	(325811, 146, '2015-01-15 00:08:27.000000', 'temperatura', 97.0000, 'ºC'),
	(325812, 146, '2015-01-15 00:08:28.000000', 'temperatura', 774.0000, 'ºC'),
	(325813, 146, '2015-01-15 00:08:29.000000', 'temperatura', 1179.0000, 'ºC'),
	(325814, 146, '2015-01-15 00:08:30.000000', 'temperatura', 1174.0000, 'ºC'),
	(325815, 146, '2015-01-15 00:08:31.000000', 'temperatura', 1134.0000, 'ºC'),
	(325816, 146, '2015-01-15 00:08:32.000000', 'temperatura', 947.0000, 'ºC'),
	(325817, 146, '2015-01-15 00:08:33.000000', 'temperatura', 134.0000, 'ºC'),
	(325818, 146, '2015-01-15 00:08:34.000000', 'temperatura', 231.0000, 'ºC'),
	(325819, 146, '2015-01-15 00:08:35.000000', 'temperatura', 752.0000, 'ºC'),
	(325820, 146, '2015-01-15 00:08:36.000000', 'temperatura', 667.0000, 'ºC'),
	(325821, 146, '2015-01-15 00:08:37.000000', 'temperatura', 1082.0000, 'ºC'),
	(325822, 146, '2015-01-15 00:08:38.000000', 'temperatura', 1008.0000, 'ºC'),
	(325823, 146, '2015-01-15 00:08:39.000000', 'temperatura', 594.0000, 'ºC'),
	(325824, 146, '2015-01-15 00:08:40.000000', 'temperatura', 1146.0000, 'ºC'),
	(325825, 146, '2015-01-15 00:08:41.000000', 'temperatura', 347.0000, 'ºC'),
	(325826, 146, '2015-01-15 00:08:42.000000', 'temperatura', 700.0000, 'ºC'),
	(325827, 146, '2015-01-15 00:08:43.000000', 'temperatura', 59.0000, 'ºC'),
	(325828, 146, '2015-01-15 00:08:44.000000', 'temperatura', 594.0000, 'ºC'),
	(325829, 146, '2015-01-15 00:08:45.000000', 'temperatura', 395.0000, 'ºC'),
	(325830, 146, '2015-01-15 00:08:46.000000', 'temperatura', 194.0000, 'ºC'),
	(325831, 146, '2015-01-15 00:08:47.000000', 'temperatura', 983.0000, 'ºC'),
	(325832, 146, '2015-01-15 00:08:48.000000', 'temperatura', 735.0000, 'ºC'),
	(325833, 146, '2015-01-15 00:08:49.000000', 'temperatura', 725.0000, 'ºC'),
	(325834, 146, '2015-01-15 00:08:50.000000', 'temperatura', 220.0000, 'ºC'),
	(325835, 146, '2015-01-15 00:08:51.000000', 'temperatura', 125.0000, 'ºC'),
	(325836, 146, '2015-01-15 00:08:52.000000', 'temperatura', 1165.0000, 'ºC'),
	(325837, 146, '2015-01-15 00:08:53.000000', 'temperatura', 652.0000, 'ºC'),
	(325838, 146, '2015-01-15 00:08:54.000000', 'temperatura', 966.0000, 'ºC'),
	(325839, 146, '2015-01-15 00:08:55.000000', 'temperatura', 472.0000, 'ºC'),
	(325840, 146, '2015-01-15 00:08:56.000000', 'temperatura', 665.0000, 'ºC'),
	(325841, 146, '2015-01-15 00:08:57.000000', 'temperatura', 708.0000, 'ºC'),
	(325842, 146, '2015-01-15 00:08:58.000000', 'temperatura', 348.0000, 'ºC'),
	(325843, 146, '2015-01-15 00:08:59.000000', 'temperatura', 816.0000, 'ºC'),
	(325844, 146, '2015-01-15 00:09:00.000000', 'temperatura', 634.0000, 'ºC'),
	(325845, 146, '2015-01-15 00:09:01.000000', 'temperatura', 725.0000, 'ºC'),
	(325846, 146, '2015-01-15 00:09:02.000000', 'temperatura', 522.0000, 'ºC'),
	(325847, 146, '2015-01-15 00:09:03.000000', 'temperatura', 434.0000, 'ºC'),
	(325848, 146, '2015-01-15 00:09:04.000000', 'temperatura', 606.0000, 'ºC'),
	(325849, 146, '2015-01-15 00:09:05.000000', 'temperatura', 527.0000, 'ºC'),
	(325850, 146, '2015-01-15 00:09:06.000000', 'temperatura', 817.0000, 'ºC'),
	(325851, 146, '2015-01-15 00:09:07.000000', 'temperatura', 107.0000, 'ºC'),
	(325852, 146, '2015-01-15 00:09:08.000000', 'temperatura', 484.0000, 'ºC'),
	(325853, 146, '2015-01-15 00:09:09.000000', 'temperatura', 898.0000, 'ºC'),
	(325854, 146, '2015-01-15 00:09:10.000000', 'temperatura', 641.0000, 'ºC'),
	(325855, 146, '2015-01-15 00:09:11.000000', 'temperatura', 510.0000, 'ºC'),
	(325856, 146, '2015-01-15 00:09:12.000000', 'temperatura', 629.0000, 'ºC'),
	(325857, 146, '2015-01-15 00:09:13.000000', 'temperatura', 416.0000, 'ºC'),
	(325858, 146, '2015-01-15 00:09:14.000000', 'temperatura', 193.0000, 'ºC'),
	(325859, 146, '2015-01-15 00:09:15.000000', 'temperatura', 918.0000, 'ºC'),
	(325860, 146, '2015-01-15 00:09:16.000000', 'temperatura', 411.0000, 'ºC'),
	(325861, 146, '2015-01-15 00:09:17.000000', 'temperatura', 503.0000, 'ºC'),
	(325862, 146, '2015-01-15 00:09:18.000000', 'temperatura', 81.0000, 'ºC'),
	(325863, 146, '2015-01-15 00:09:19.000000', 'temperatura', 98.0000, 'ºC'),
	(325864, 146, '2015-01-15 00:09:20.000000', 'temperatura', 248.0000, 'ºC'),
	(325865, 146, '2015-01-15 00:09:21.000000', 'temperatura', 946.0000, 'ºC'),
	(325866, 146, '2015-01-15 00:09:22.000000', 'temperatura', 386.0000, 'ºC'),
	(325867, 146, '2015-01-15 00:09:23.000000', 'temperatura', 291.0000, 'ºC'),
	(325868, 146, '2015-01-15 00:09:24.000000', 'temperatura', 298.0000, 'ºC'),
	(325869, 146, '2015-01-15 00:09:25.000000', 'temperatura', 616.0000, 'ºC'),
	(325870, 146, '2015-01-15 00:09:26.000000', 'temperatura', 989.0000, 'ºC'),
	(325871, 146, '2015-01-15 00:09:27.000000', 'temperatura', 698.0000, 'ºC'),
	(325872, 146, '2015-01-15 00:09:28.000000', 'temperatura', 522.0000, 'ºC'),
	(325873, 146, '2015-01-15 00:09:29.000000', 'temperatura', 518.0000, 'ºC'),
	(325874, 146, '2015-01-15 00:09:30.000000', 'temperatura', 1022.0000, 'ºC'),
	(325875, 146, '2015-01-15 00:09:31.000000', 'temperatura', 1158.0000, 'ºC'),
	(325876, 146, '2015-01-15 00:09:32.000000', 'temperatura', 323.0000, 'ºC'),
	(325877, 146, '2015-01-15 00:09:33.000000', 'temperatura', 540.0000, 'ºC'),
	(325878, 146, '2015-01-15 00:09:34.000000', 'temperatura', 535.0000, 'ºC'),
	(325879, 146, '2015-01-15 00:09:35.000000', 'temperatura', 1053.0000, 'ºC'),
	(325880, 146, '2015-01-15 00:09:36.000000', 'temperatura', 60.0000, 'ºC'),
	(325881, 146, '2015-01-15 00:09:37.000000', 'temperatura', 742.0000, 'ºC'),
	(325882, 146, '2015-01-15 00:09:38.000000', 'temperatura', 1131.0000, 'ºC'),
	(325883, 146, '2015-01-15 00:09:39.000000', 'temperatura', 1030.0000, 'ºC'),
	(325884, 146, '2015-01-15 00:09:40.000000', 'temperatura', 559.0000, 'ºC'),
	(325885, 146, '2015-01-15 00:09:41.000000', 'temperatura', 903.0000, 'ºC'),
	(325886, 146, '2015-01-15 00:09:42.000000', 'temperatura', 438.0000, 'ºC'),
	(325887, 146, '2015-01-15 00:09:43.000000', 'temperatura', 681.0000, 'ºC'),
	(325888, 146, '2015-01-15 00:09:44.000000', 'temperatura', 891.0000, 'ºC'),
	(325889, 146, '2015-01-15 00:09:45.000000', 'temperatura', 12.0000, 'ºC'),
	(325890, 146, '2015-01-15 00:09:46.000000', 'temperatura', 987.0000, 'ºC'),
	(325891, 146, '2015-01-15 00:09:47.000000', 'temperatura', 100.0000, 'ºC'),
	(325892, 146, '2015-01-15 00:09:48.000000', 'temperatura', 1139.0000, 'ºC'),
	(325893, 146, '2015-01-15 00:09:49.000000', 'temperatura', 596.0000, 'ºC'),
	(325894, 146, '2015-01-15 00:09:50.000000', 'temperatura', 765.0000, 'ºC'),
	(325895, 146, '2015-01-15 00:09:51.000000', 'temperatura', 835.0000, 'ºC'),
	(325896, 146, '2015-01-15 00:09:52.000000', 'temperatura', 683.0000, 'ºC'),
	(325897, 146, '2015-01-15 00:09:53.000000', 'temperatura', 909.0000, 'ºC'),
	(325898, 146, '2015-01-15 00:09:54.000000', 'temperatura', 97.0000, 'ºC'),
	(325899, 146, '2015-01-15 00:09:55.000000', 'temperatura', 159.0000, 'ºC'),
	(325900, 146, '2015-01-15 00:09:56.000000', 'temperatura', 502.0000, 'ºC'),
	(325901, 146, '2015-01-15 00:09:57.000000', 'temperatura', 837.0000, 'ºC'),
	(325902, 146, '2015-01-15 00:09:58.000000', 'temperatura', 276.0000, 'ºC'),
	(325903, 146, '2015-01-15 00:09:59.000000', 'temperatura', 72.0000, 'ºC'),
	(325904, 146, '2015-01-15 00:10:00.000000', 'temperatura', 734.0000, 'ºC'),
	(325905, 146, '2015-01-15 00:10:01.000000', 'temperatura', 1051.0000, 'ºC'),
	(325906, 146, '2015-01-15 00:10:02.000000', 'temperatura', 654.0000, 'ºC'),
	(325907, 146, '2015-01-15 00:10:03.000000', 'temperatura', 118.0000, 'ºC'),
	(325908, 146, '2015-01-15 00:10:04.000000', 'temperatura', 1029.0000, 'ºC'),
	(325909, 146, '2015-01-15 00:10:05.000000', 'temperatura', 1192.0000, 'ºC'),
	(325910, 146, '2015-01-15 00:10:06.000000', 'temperatura', 472.0000, 'ºC'),
	(325911, 146, '2015-01-15 00:10:07.000000', 'temperatura', 1184.0000, 'ºC'),
	(325912, 146, '2015-01-15 00:10:08.000000', 'temperatura', 903.0000, 'ºC'),
	(325913, 146, '2015-01-15 00:10:09.000000', 'temperatura', 967.0000, 'ºC'),
	(325914, 146, '2015-01-15 00:10:10.000000', 'temperatura', 923.0000, 'ºC'),
	(325915, 146, '2015-01-15 00:10:11.000000', 'temperatura', 516.0000, 'ºC'),
	(325916, 146, '2015-01-15 00:10:12.000000', 'temperatura', 1012.0000, 'ºC'),
	(325917, 146, '2015-01-15 00:10:13.000000', 'temperatura', 1114.0000, 'ºC'),
	(325918, 146, '2015-01-15 00:10:14.000000', 'temperatura', 132.0000, 'ºC'),
	(325919, 146, '2015-01-15 00:10:15.000000', 'temperatura', 919.0000, 'ºC'),
	(325920, 146, '2015-01-15 00:10:16.000000', 'temperatura', 601.0000, 'ºC'),
	(325921, 146, '2015-01-15 00:10:17.000000', 'temperatura', 250.0000, 'ºC'),
	(325922, 146, '2015-01-15 00:10:18.000000', 'temperatura', 644.0000, 'ºC'),
	(325923, 146, '2015-01-15 00:10:19.000000', 'temperatura', 73.0000, 'ºC'),
	(325924, 146, '2015-01-15 00:10:20.000000', 'temperatura', 834.0000, 'ºC'),
	(325925, 146, '2015-01-15 00:10:21.000000', 'temperatura', 351.0000, 'ºC'),
	(325926, 146, '2015-01-15 00:10:22.000000', 'temperatura', 453.0000, 'ºC'),
	(325927, 146, '2015-01-15 00:10:23.000000', 'temperatura', 14.0000, 'ºC'),
	(325928, 146, '2015-01-15 00:10:24.000000', 'temperatura', 1111.0000, 'ºC'),
	(325929, 146, '2015-01-15 00:10:25.000000', 'temperatura', 715.0000, 'ºC'),
	(325930, 146, '2015-01-15 00:10:26.000000', 'temperatura', 240.0000, 'ºC'),
	(325931, 146, '2015-01-15 00:10:27.000000', 'temperatura', 258.0000, 'ºC'),
	(325932, 146, '2015-01-15 00:10:28.000000', 'temperatura', 568.0000, 'ºC'),
	(325933, 146, '2015-01-15 00:10:29.000000', 'temperatura', 868.0000, 'ºC'),
	(325934, 146, '2015-01-15 00:10:30.000000', 'temperatura', 237.0000, 'ºC'),
	(325935, 146, '2015-01-15 00:10:31.000000', 'temperatura', 981.0000, 'ºC'),
	(325936, 146, '2015-01-15 00:10:32.000000', 'temperatura', 593.0000, 'ºC'),
	(325937, 146, '2015-01-15 00:10:33.000000', 'temperatura', 22.0000, 'ºC'),
	(325938, 146, '2015-01-15 00:10:34.000000', 'temperatura', 731.0000, 'ºC'),
	(325939, 146, '2015-01-15 00:10:35.000000', 'temperatura', 1190.0000, 'ºC'),
	(325940, 146, '2015-01-15 00:10:36.000000', 'temperatura', 158.0000, 'ºC'),
	(325941, 146, '2015-01-15 00:10:37.000000', 'temperatura', 821.0000, 'ºC'),
	(325942, 146, '2015-01-15 00:10:38.000000', 'temperatura', 32.0000, 'ºC'),
	(325943, 146, '2015-01-15 00:10:39.000000', 'temperatura', 96.0000, 'ºC'),
	(325944, 146, '2015-01-15 00:10:40.000000', 'temperatura', 387.0000, 'ºC'),
	(325945, 146, '2015-01-15 00:10:41.000000', 'temperatura', 444.0000, 'ºC'),
	(325946, 146, '2015-01-15 00:10:42.000000', 'temperatura', 1062.0000, 'ºC'),
	(325947, 146, '2015-01-15 00:10:43.000000', 'temperatura', 376.0000, 'ºC'),
	(325948, 146, '2015-01-15 00:10:44.000000', 'temperatura', 1096.0000, 'ºC'),
	(325949, 146, '2015-01-15 00:10:45.000000', 'temperatura', 753.0000, 'ºC'),
	(325950, 146, '2015-01-15 00:10:46.000000', 'temperatura', 478.0000, 'ºC'),
	(325951, 146, '2015-01-15 00:10:47.000000', 'temperatura', 130.0000, 'ºC'),
	(325952, 146, '2015-01-15 00:10:48.000000', 'temperatura', 419.0000, 'ºC'),
	(325953, 146, '2015-01-15 00:10:49.000000', 'temperatura', 505.0000, 'ºC'),
	(325954, 146, '2015-01-15 00:10:50.000000', 'temperatura', 68.0000, 'ºC'),
	(325955, 146, '2015-01-15 00:10:51.000000', 'temperatura', 26.0000, 'ºC'),
	(325956, 146, '2015-01-15 00:10:52.000000', 'temperatura', 1128.0000, 'ºC'),
	(325957, 146, '2015-01-15 00:10:53.000000', 'temperatura', 762.0000, 'ºC'),
	(325958, 146, '2015-01-15 00:10:54.000000', 'temperatura', 427.0000, 'ºC'),
	(325959, 146, '2015-01-15 00:10:55.000000', 'temperatura', 1048.0000, 'ºC'),
	(325960, 146, '2015-01-15 00:10:56.000000', 'temperatura', 359.0000, 'ºC'),
	(325961, 146, '2015-01-15 00:10:57.000000', 'temperatura', 1052.0000, 'ºC'),
	(325962, 146, '2015-01-15 00:10:58.000000', 'temperatura', 583.0000, 'ºC'),
	(325963, 146, '2015-01-15 00:10:59.000000', 'temperatura', 962.0000, 'ºC'),
	(325964, 146, '2015-01-15 00:11:00.000000', 'temperatura', 660.0000, 'ºC'),
	(325965, 146, '2015-01-15 00:11:01.000000', 'temperatura', 412.0000, 'ºC'),
	(325966, 146, '2015-01-15 00:11:02.000000', 'temperatura', 84.0000, 'ºC'),
	(325967, 146, '2015-01-15 00:11:03.000000', 'temperatura', 384.0000, 'ºC'),
	(325968, 146, '2015-01-15 00:11:04.000000', 'temperatura', 470.0000, 'ºC'),
	(325969, 146, '2015-01-15 00:11:05.000000', 'temperatura', 1197.0000, 'ºC'),
	(325970, 146, '2015-01-15 00:11:06.000000', 'temperatura', 974.0000, 'ºC'),
	(325971, 146, '2015-01-15 00:11:07.000000', 'temperatura', 80.0000, 'ºC'),
	(325972, 146, '2015-01-15 00:11:08.000000', 'temperatura', 1080.0000, 'ºC'),
	(325973, 146, '2015-01-15 00:11:09.000000', 'temperatura', 361.0000, 'ºC'),
	(325974, 146, '2015-01-15 00:11:10.000000', 'temperatura', 964.0000, 'ºC'),
	(325975, 146, '2015-01-15 00:11:11.000000', 'temperatura', 136.0000, 'ºC'),
	(325976, 146, '2015-01-15 00:11:12.000000', 'temperatura', 191.0000, 'ºC'),
	(325977, 146, '2015-01-15 00:11:13.000000', 'temperatura', 546.0000, 'ºC'),
	(325978, 146, '2015-01-15 00:11:14.000000', 'temperatura', 958.0000, 'ºC'),
	(325979, 146, '2015-01-15 00:11:15.000000', 'temperatura', 754.0000, 'ºC'),
	(325980, 146, '2015-01-15 00:11:16.000000', 'temperatura', 897.0000, 'ºC'),
	(325981, 146, '2015-01-15 00:11:17.000000', 'temperatura', 1024.0000, 'ºC'),
	(325982, 146, '2015-01-15 00:11:18.000000', 'temperatura', 27.0000, 'ºC'),
	(325983, 146, '2015-01-15 00:11:19.000000', 'temperatura', 664.0000, 'ºC'),
	(325984, 146, '2015-01-15 00:11:20.000000', 'temperatura', 838.0000, 'ºC'),
	(325985, 146, '2015-01-15 00:11:21.000000', 'temperatura', 999.0000, 'ºC'),
	(325986, 146, '2015-01-15 00:11:22.000000', 'temperatura', 81.0000, 'ºC'),
	(325987, 146, '2015-01-15 00:11:23.000000', 'temperatura', 1008.0000, 'ºC'),
	(325988, 146, '2015-01-15 00:11:24.000000', 'temperatura', 0.0000, 'ºC'),
	(325989, 146, '2015-01-15 00:11:25.000000', 'temperatura', 574.0000, 'ºC'),
	(325990, 146, '2015-01-15 00:11:26.000000', 'temperatura', 473.0000, 'ºC'),
	(325991, 146, '2015-01-15 00:11:27.000000', 'temperatura', 642.0000, 'ºC'),
	(325992, 146, '2015-01-15 00:11:28.000000', 'temperatura', 594.0000, 'ºC'),
	(325993, 146, '2015-01-15 00:11:29.000000', 'temperatura', 1043.0000, 'ºC'),
	(325994, 146, '2015-01-15 00:11:30.000000', 'temperatura', 1031.0000, 'ºC'),
	(325995, 146, '2015-01-15 00:11:31.000000', 'temperatura', 830.0000, 'ºC'),
	(325996, 146, '2015-01-15 00:11:32.000000', 'temperatura', 1056.0000, 'ºC'),
	(325997, 146, '2015-01-15 00:11:33.000000', 'temperatura', 393.0000, 'ºC'),
	(325998, 146, '2015-01-15 00:11:34.000000', 'temperatura', 1195.0000, 'ºC'),
	(325999, 146, '2015-01-15 00:11:35.000000', 'temperatura', 1197.0000, 'ºC'),
	(326000, 146, '2015-01-15 00:11:36.000000', 'temperatura', 1198.0000, 'ºC'),
	(326001, 146, '2015-01-15 00:11:37.000000', 'temperatura', 3.0000, 'ºC'),
	(326002, 146, '2015-01-15 00:11:38.000000', 'temperatura', 21.0000, 'ºC'),
	(326003, 146, '2015-01-15 00:11:39.000000', 'temperatura', 96.0000, 'ºC'),
	(326004, 146, '2015-01-15 00:11:40.000000', 'temperatura', 417.0000, 'ºC'),
	(326005, 146, '2015-01-15 00:11:41.000000', 'temperatura', 599.0000, 'ºC'),
	(326006, 146, '2015-01-15 00:11:42.000000', 'temperatura', 542.0000, 'ºC'),
	(326007, 146, '2015-01-15 00:11:43.000000', 'temperatura', 913.0000, 'ºC'),
	(326008, 146, '2015-01-15 00:11:44.000000', 'temperatura', 541.0000, 'ºC'),
	(326009, 146, '2015-01-15 00:11:45.000000', 'temperatura', 1167.0000, 'ºC'),
	(326010, 146, '2015-01-15 00:11:46.000000', 'temperatura', 613.0000, 'ºC'),
	(326011, 146, '2015-01-15 00:11:47.000000', 'temperatura', 765.0000, 'ºC'),
	(326012, 146, '2015-01-15 00:11:48.000000', 'temperatura', 785.0000, 'ºC'),
	(326013, 146, '2015-01-15 00:11:49.000000', 'temperatura', 429.0000, 'ºC'),
	(326014, 146, '2015-01-15 00:11:50.000000', 'temperatura', 991.0000, 'ºC'),
	(326015, 146, '2015-01-15 00:11:51.000000', 'temperatura', 71.0000, 'ºC'),
	(326016, 146, '2015-01-15 00:11:52.000000', 'temperatura', 981.0000, 'ºC'),
	(326017, 146, '2015-01-15 00:11:53.000000', 'temperatura', 1094.0000, 'ºC'),
	(326018, 146, '2015-01-15 00:11:54.000000', 'temperatura', 126.0000, 'ºC'),
	(326019, 146, '2015-01-15 00:11:55.000000', 'temperatura', 949.0000, 'ºC'),
	(326020, 146, '2015-01-15 00:11:56.000000', 'temperatura', 767.0000, 'ºC'),
	(326021, 146, '2015-01-15 00:11:57.000000', 'temperatura', 990.0000, 'ºC'),
	(326022, 146, '2015-01-15 00:11:58.000000', 'temperatura', 247.0000, 'ºC'),
	(326023, 146, '2015-01-15 00:11:59.000000', 'temperatura', 668.0000, 'ºC'),
	(326024, 146, '2015-01-15 00:12:00.000000', 'temperatura', 199.0000, 'ºC'),
	(326025, 146, '2015-01-15 00:12:01.000000', 'temperatura', 193.0000, 'ºC'),
	(326026, 146, '2015-01-15 00:12:02.000000', 'temperatura', 367.0000, 'ºC'),
	(326027, 146, '2015-01-15 00:12:03.000000', 'temperatura', 56.0000, 'ºC'),
	(326028, 146, '2015-01-15 00:12:04.000000', 'temperatura', 380.0000, 'ºC'),
	(326029, 146, '2015-01-15 00:12:05.000000', 'temperatura', 531.0000, 'ºC'),
	(326030, 146, '2015-01-15 00:12:06.000000', 'temperatura', 316.0000, 'ºC'),
	(326031, 146, '2015-01-15 00:12:07.000000', 'temperatura', 1186.0000, 'ºC'),
	(326032, 146, '2015-01-15 00:12:08.000000', 'temperatura', 183.0000, 'ºC'),
	(326033, 146, '2015-01-15 00:12:09.000000', 'temperatura', 957.0000, 'ºC'),
	(326034, 146, '2015-01-15 00:12:10.000000', 'temperatura', 638.0000, 'ºC'),
	(326035, 146, '2015-01-15 00:12:11.000000', 'temperatura', 320.0000, 'ºC'),
	(326036, 146, '2015-01-15 00:12:12.000000', 'temperatura', 884.0000, 'ºC'),
	(326037, 146, '2015-01-15 00:12:13.000000', 'temperatura', 1060.0000, 'ºC'),
	(326038, 146, '2015-01-15 00:12:14.000000', 'temperatura', 251.0000, 'ºC'),
	(326039, 146, '2015-01-15 00:12:15.000000', 'temperatura', 477.0000, 'ºC'),
	(326040, 146, '2015-01-15 00:12:16.000000', 'temperatura', 429.0000, 'ºC'),
	(326041, 146, '2015-01-15 00:12:17.000000', 'temperatura', 715.0000, 'ºC'),
	(326042, 146, '2015-01-15 00:12:18.000000', 'temperatura', 1087.0000, 'ºC'),
	(326043, 146, '2015-01-15 00:12:19.000000', 'temperatura', 892.0000, 'ºC'),
	(326044, 146, '2015-01-15 00:12:20.000000', 'temperatura', 0.0000, 'ºC'),
	(326045, 146, '2015-01-15 00:12:21.000000', 'temperatura', 924.0000, 'ºC'),
	(326046, 146, '2015-01-15 00:12:22.000000', 'temperatura', 1022.0000, 'ºC'),
	(326047, 146, '2015-01-15 00:12:23.000000', 'temperatura', 1139.0000, 'ºC'),
	(326048, 146, '2015-01-15 00:12:24.000000', 'temperatura', 229.0000, 'ºC'),
	(326049, 146, '2015-01-15 00:12:25.000000', 'temperatura', 129.0000, 'ºC'),
	(326050, 146, '2015-01-15 00:12:26.000000', 'temperatura', 1158.0000, 'ºC'),
	(326051, 146, '2015-01-15 00:12:27.000000', 'temperatura', 603.0000, 'ºC'),
	(326052, 146, '2015-01-15 00:12:28.000000', 'temperatura', 740.0000, 'ºC'),
	(326053, 146, '2015-01-15 00:12:29.000000', 'temperatura', 691.0000, 'ºC'),
	(326054, 146, '2015-01-15 00:12:30.000000', 'temperatura', 39.0000, 'ºC'),
	(326055, 146, '2015-01-15 00:12:31.000000', 'temperatura', 520.0000, 'ºC'),
	(326056, 146, '2015-01-15 00:12:32.000000', 'temperatura', 83.0000, 'ºC'),
	(326057, 146, '2015-01-15 00:12:33.000000', 'temperatura', 57.0000, 'ºC'),
	(326058, 146, '2015-01-15 00:12:34.000000', 'temperatura', 35.0000, 'ºC'),
	(326059, 146, '2015-01-15 00:12:35.000000', 'temperatura', 6.0000, 'ºC'),
	(326060, 146, '2015-01-15 00:12:36.000000', 'temperatura', 1126.0000, 'ºC'),
	(326061, 146, '2015-01-15 00:12:37.000000', 'temperatura', 812.0000, 'ºC'),
	(326062, 146, '2015-01-15 00:12:38.000000', 'temperatura', 684.0000, 'ºC'),
	(326063, 146, '2015-01-15 00:12:39.000000', 'temperatura', 984.0000, 'ºC'),
	(326064, 146, '2015-01-15 00:12:40.000000', 'temperatura', 467.0000, 'ºC'),
	(326065, 146, '2015-01-15 00:12:41.000000', 'temperatura', 582.0000, 'ºC'),
	(326066, 146, '2015-01-15 00:12:42.000000', 'temperatura', 312.0000, 'ºC'),
	(326067, 146, '2015-01-15 00:12:43.000000', 'temperatura', 1012.0000, 'ºC'),
	(326068, 146, '2015-01-15 00:12:44.000000', 'temperatura', 528.0000, 'ºC'),
	(326069, 146, '2015-01-15 00:12:45.000000', 'temperatura', 801.0000, 'ºC'),
	(326070, 146, '2015-01-15 00:12:46.000000', 'temperatura', 25.0000, 'ºC'),
	(326071, 146, '2015-01-15 00:12:47.000000', 'temperatura', 121.0000, 'ºC'),
	(326072, 146, '2015-01-15 00:12:48.000000', 'temperatura', 530.0000, 'ºC'),
	(326073, 146, '2015-01-15 00:12:49.000000', 'temperatura', 1087.0000, 'ºC'),
	(326074, 146, '2015-01-15 00:12:50.000000', 'temperatura', 248.0000, 'ºC'),
	(326075, 146, '2015-01-15 00:12:51.000000', 'temperatura', 379.0000, 'ºC'),
	(326076, 146, '2015-01-15 00:12:52.000000', 'temperatura', 1151.0000, 'ºC'),
	(326077, 146, '2015-01-15 00:12:53.000000', 'temperatura', 1017.0000, 'ºC'),
	(326078, 146, '2015-01-15 00:12:54.000000', 'temperatura', 434.0000, 'ºC'),
	(326079, 146, '2015-01-15 00:12:55.000000', 'temperatura', 319.0000, 'ºC'),
	(326080, 146, '2015-01-15 00:12:56.000000', 'temperatura', 294.0000, 'ºC'),
	(326081, 146, '2015-01-15 00:12:57.000000', 'temperatura', 511.0000, 'ºC'),
	(326082, 146, '2015-01-15 00:12:58.000000', 'temperatura', 476.0000, 'ºC'),
	(326083, 146, '2015-01-15 00:12:59.000000', 'temperatura', 847.0000, 'ºC'),
	(326084, 146, '2015-01-15 00:13:00.000000', 'temperatura', 407.0000, 'ºC'),
	(326085, 146, '2015-01-15 00:13:01.000000', 'temperatura', 695.0000, 'ºC'),
	(326086, 146, '2015-01-15 00:13:02.000000', 'temperatura', 1056.0000, 'ºC'),
	(326087, 146, '2015-01-15 00:13:03.000000', 'temperatura', 795.0000, 'ºC'),
	(326088, 146, '2015-01-15 00:13:04.000000', 'temperatura', 806.0000, 'ºC'),
	(326089, 146, '2015-01-15 00:13:05.000000', 'temperatura', 445.0000, 'ºC'),
	(326090, 146, '2015-01-15 00:13:06.000000', 'temperatura', 1008.0000, 'ºC'),
	(326091, 146, '2015-01-15 00:13:07.000000', 'temperatura', 105.0000, 'ºC'),
	(326092, 146, '2015-01-15 00:13:08.000000', 'temperatura', 1101.0000, 'ºC'),
	(326093, 146, '2015-01-15 00:13:09.000000', 'temperatura', 389.0000, 'ºC'),
	(326094, 146, '2015-01-15 00:13:10.000000', 'temperatura', 1045.0000, 'ºC'),
	(326095, 146, '2015-01-15 00:13:11.000000', 'temperatura', 459.0000, 'ºC'),
	(326096, 146, '2015-01-15 00:13:12.000000', 'temperatura', 358.0000, 'ºC'),
	(326097, 146, '2015-01-15 00:13:13.000000', 'temperatura', 415.0000, 'ºC'),
	(326098, 146, '2015-01-15 00:13:14.000000', 'temperatura', 1002.0000, 'ºC'),
	(326099, 146, '2015-01-15 00:13:15.000000', 'temperatura', 164.0000, 'ºC'),
	(326100, 146, '2015-01-15 00:13:16.000000', 'temperatura', 215.0000, 'ºC'),
	(326101, 146, '2015-01-15 00:13:17.000000', 'temperatura', 585.0000, 'ºC'),
	(326102, 146, '2015-01-15 00:13:18.000000', 'temperatura', 1080.0000, 'ºC'),
	(326103, 146, '2015-01-15 00:13:19.000000', 'temperatura', 45.0000, 'ºC'),
	(326104, 146, '2015-01-15 00:13:20.000000', 'temperatura', 586.0000, 'ºC'),
	(326105, 146, '2015-01-15 00:13:21.000000', 'temperatura', 397.0000, 'ºC'),
	(326106, 146, '2015-01-15 00:13:22.000000', 'temperatura', 225.0000, 'ºC'),
	(326107, 146, '2015-01-15 00:13:23.000000', 'temperatura', 1134.0000, 'ºC'),
	(326108, 146, '2015-01-15 00:13:24.000000', 'temperatura', 196.0000, 'ºC'),
	(326109, 146, '2015-01-15 00:13:25.000000', 'temperatura', 1179.0000, 'ºC'),
	(326110, 146, '2015-01-15 00:13:26.000000', 'temperatura', 507.0000, 'ºC'),
	(326111, 146, '2015-01-15 00:13:27.000000', 'temperatura', 197.0000, 'ºC'),
	(326112, 146, '2015-01-15 00:13:28.000000', 'temperatura', 664.0000, 'ºC'),
	(326113, 146, '2015-01-15 00:13:29.000000', 'temperatura', 332.0000, 'ºC'),
	(326114, 146, '2015-01-15 00:13:30.000000', 'temperatura', 868.0000, 'ºC'),
	(326115, 146, '2015-01-15 00:13:31.000000', 'temperatura', 943.0000, 'ºC'),
	(326116, 146, '2015-01-15 00:13:32.000000', 'temperatura', 911.0000, 'ºC'),
	(326117, 146, '2015-01-15 00:13:33.000000', 'temperatura', 529.0000, 'ºC'),
	(326118, 146, '2015-01-15 00:13:34.000000', 'temperatura', 1111.0000, 'ºC'),
	(326119, 146, '2015-01-15 00:13:35.000000', 'temperatura', 369.0000, 'ºC'),
	(326120, 146, '2015-01-15 00:13:36.000000', 'temperatura', 914.0000, 'ºC'),
	(326121, 146, '2015-01-15 00:13:37.000000', 'temperatura', 1062.0000, 'ºC'),
	(326122, 146, '2015-01-15 00:13:38.000000', 'temperatura', 167.0000, 'ºC'),
	(326123, 146, '2015-01-15 00:13:39.000000', 'temperatura', 50.0000, 'ºC'),
	(326124, 146, '2015-01-15 00:13:40.000000', 'temperatura', 948.0000, 'ºC'),
	(326125, 146, '2015-01-15 00:13:41.000000', 'temperatura', 993.0000, 'ºC'),
	(326126, 146, '2015-01-15 00:13:42.000000', 'temperatura', 923.0000, 'ºC'),
	(326127, 146, '2015-01-15 00:13:43.000000', 'temperatura', 434.0000, 'ºC'),
	(326128, 146, '2015-01-15 00:13:44.000000', 'temperatura', 602.0000, 'ºC'),
	(326129, 146, '2015-01-15 00:13:45.000000', 'temperatura', 510.0000, 'ºC'),
	(326130, 146, '2015-01-15 00:13:46.000000', 'temperatura', 741.0000, 'ºC'),
	(326131, 146, '2015-01-15 00:13:47.000000', 'temperatura', 979.0000, 'ºC'),
	(326132, 146, '2015-01-15 00:13:48.000000', 'temperatura', 271.0000, 'ºC'),
	(326133, 146, '2015-01-15 00:13:49.000000', 'temperatura', 820.0000, 'ºC'),
	(326134, 146, '2015-01-15 00:13:50.000000', 'temperatura', 888.0000, 'ºC'),
	(326135, 146, '2015-01-15 00:13:51.000000', 'temperatura', 779.0000, 'ºC'),
	(326136, 146, '2015-01-15 00:13:52.000000', 'temperatura', 31.0000, 'ºC'),
	(326137, 146, '2015-01-15 00:13:53.000000', 'temperatura', 218.0000, 'ºC'),
	(326138, 146, '2015-01-15 00:13:54.000000', 'temperatura', 998.0000, 'ºC'),
	(326139, 146, '2015-01-15 00:13:55.000000', 'temperatura', 736.0000, 'ºC'),
	(326140, 146, '2015-01-15 00:13:56.000000', 'temperatura', 689.0000, 'ºC'),
	(326141, 146, '2015-01-15 00:13:57.000000', 'temperatura', 37.0000, 'ºC'),
	(326142, 146, '2015-01-15 00:13:58.000000', 'temperatura', 516.0000, 'ºC'),
	(326143, 146, '2015-01-15 00:13:59.000000', 'temperatura', 72.0000, 'ºC'),
	(326144, 146, '2015-01-15 00:14:00.000000', 'temperatura', 12.0000, 'ºC'),
	(326145, 146, '2015-01-15 00:14:01.000000', 'temperatura', 1044.0000, 'ºC'),
	(326146, 146, '2015-01-15 00:14:02.000000', 'temperatura', 385.0000, 'ºC'),
	(326147, 146, '2015-01-15 00:14:03.000000', 'temperatura', 1195.0000, 'ºC'),
	(326148, 146, '2015-01-15 00:14:04.000000', 'temperatura', 19.0000, 'ºC'),
	(326149, 146, '2015-01-15 00:14:05.000000', 'temperatura', 109.0000, 'ºC'),
	(326150, 146, '2015-01-15 00:14:06.000000', 'temperatura', 492.0000, 'ºC'),
	(326151, 146, '2015-01-15 00:14:07.000000', 'temperatura', 930.0000, 'ºC'),
	(326152, 146, '2015-01-15 00:14:08.000000', 'temperatura', 776.0000, 'ºC'),
	(326153, 146, '2015-01-15 00:14:09.000000', 'temperatura', 1089.0000, 'ºC'),
	(326154, 146, '2015-01-15 00:14:10.000000', 'temperatura', 719.0000, 'ºC'),
	(326155, 146, '2015-01-15 00:14:11.000000', 'temperatura', 326.0000, 'ºC'),
	(326156, 146, '2015-01-15 00:14:12.000000', 'temperatura', 677.0000, 'ºC'),
	(326157, 146, '2015-01-15 00:14:13.000000', 'temperatura', 5.0000, 'ºC'),
	(326158, 146, '2015-01-15 00:14:14.000000', 'temperatura', 395.0000, 'ºC'),
	(326159, 146, '2015-01-15 00:14:15.000000', 'temperatura', 762.0000, 'ºC'),
	(326160, 146, '2015-01-15 00:14:16.000000', 'temperatura', 226.0000, 'ºC'),
	(326161, 146, '2015-01-15 00:14:17.000000', 'temperatura', 42.0000, 'ºC'),
	(326162, 146, '2015-01-15 00:14:18.000000', 'temperatura', 733.0000, 'ºC'),
	(326163, 146, '2015-01-15 00:14:19.000000', 'temperatura', 1138.0000, 'ºC'),
	(326164, 146, '2015-01-15 00:14:20.000000', 'temperatura', 1094.0000, 'ºC'),
	(326165, 146, '2015-01-15 00:14:21.000000', 'temperatura', 855.0000, 'ºC'),
	(326166, 146, '2015-01-15 00:14:22.000000', 'temperatura', 995.0000, 'ºC'),
	(326167, 146, '2015-01-15 00:14:23.000000', 'temperatura', 8.0000, 'ºC'),
	(326168, 146, '2015-01-15 00:14:24.000000', 'temperatura', 659.0000, 'ºC'),
	(326169, 146, '2015-01-15 00:14:25.000000', 'temperatura', 868.0000, 'ºC'),
	(326170, 146, '2015-01-15 00:14:26.000000', 'temperatura', 1165.0000, 'ºC'),
	(326171, 146, '2015-01-15 00:14:27.000000', 'temperatura', 823.0000, 'ºC'),
	(326172, 146, '2015-01-15 00:14:28.000000', 'temperatura', 620.0000, 'ºC'),
	(326173, 146, '2015-01-15 00:14:29.000000', 'temperatura', 631.0000, 'ºC'),
	(326174, 146, '2015-01-15 00:14:30.000000', 'temperatura', 94.0000, 'ºC'),
	(326175, 146, '2015-01-15 00:14:31.000000', 'temperatura', 978.0000, 'ºC'),
	(326176, 146, '2015-01-15 00:14:32.000000', 'temperatura', 1007.0000, 'ºC'),
	(326177, 146, '2015-01-15 00:14:33.000000', 'temperatura', 903.0000, 'ºC'),
	(326178, 146, '2015-01-15 00:14:34.000000', 'temperatura', 293.0000, 'ºC'),
	(326179, 146, '2015-01-15 00:14:35.000000', 'temperatura', 1160.0000, 'ºC'),
	(326180, 146, '2015-01-15 00:14:36.000000', 'temperatura', 118.0000, 'ºC'),
	(326181, 146, '2015-01-15 00:14:37.000000', 'temperatura', 710.0000, 'ºC'),
	(326182, 146, '2015-01-15 00:14:38.000000', 'temperatura', 798.0000, 'ºC'),
	(326183, 146, '2015-01-15 00:14:39.000000', 'temperatura', 661.0000, 'ºC'),
	(326184, 146, '2015-01-15 00:14:40.000000', 'temperatura', 913.0000, 'ºC'),
	(326185, 146, '2015-01-15 00:14:41.000000', 'temperatura', 179.0000, 'ºC'),
	(326186, 146, '2015-01-15 00:14:42.000000', 'temperatura', 558.0000, 'ºC'),
	(326187, 146, '2015-01-15 00:14:43.000000', 'temperatura', 1055.0000, 'ºC'),
	(326188, 146, '2015-01-15 00:14:44.000000', 'temperatura', 0.0000, 'ºC'),
	(326189, 146, '2015-01-15 00:14:45.000000', 'temperatura', 437.0000, 'ºC'),
	(326190, 146, '2015-01-15 00:14:46.000000', 'temperatura', 984.0000, 'ºC'),
	(326191, 146, '2015-01-15 00:14:47.000000', 'temperatura', 11.0000, 'ºC'),
	(326192, 146, '2015-01-15 00:14:48.000000', 'temperatura', 701.0000, 'ºC'),
	(326193, 146, '2015-01-15 00:14:49.000000', 'temperatura', 1073.0000, 'ºC'),
	(326194, 146, '2015-01-15 00:14:50.000000', 'temperatura', 863.0000, 'ºC'),
	(326195, 146, '2015-01-15 00:14:51.000000', 'temperatura', 1095.0000, 'ºC'),
	(326196, 146, '2015-01-15 00:14:52.000000', 'temperatura', 487.0000, 'ºC'),
	(326197, 146, '2015-01-15 00:14:53.000000', 'temperatura', 352.0000, 'ºC'),
	(326198, 146, '2015-01-15 00:14:54.000000', 'temperatura', 300.0000, 'ºC'),
	(326199, 146, '2015-01-15 00:14:55.000000', 'temperatura', 444.0000, 'ºC'),
	(326200, 146, '2015-01-15 00:14:56.000000', 'temperatura', 122.0000, 'ºC'),
	(326201, 146, '2015-01-15 00:14:57.000000', 'temperatura', 475.0000, 'ºC'),
	(326202, 146, '2015-01-15 00:14:58.000000', 'temperatura', 812.0000, 'ºC'),
	(326203, 146, '2015-01-15 00:14:59.000000', 'temperatura', 234.0000, 'ºC'),
	(326204, 146, '2015-01-15 00:15:00.000000', 'temperatura', 1134.0000, 'ºC'),
	(326205, 146, '2015-01-15 00:15:01.000000', 'temperatura', 167.0000, 'ºC'),
	(326206, 146, '2015-01-15 00:15:02.000000', 'temperatura', 1036.0000, 'ºC'),
	(326207, 146, '2015-01-15 00:15:03.000000', 'temperatura', 1079.0000, 'ºC'),
	(326208, 146, '2015-01-15 00:15:04.000000', 'temperatura', 1088.0000, 'ºC'),
	(326209, 146, '2015-01-15 00:15:05.000000', 'temperatura', 1003.0000, 'ºC'),
	(326210, 146, '2015-01-15 00:15:06.000000', 'temperatura', 551.0000, 'ºC'),
	(326211, 146, '2015-01-15 00:15:07.000000', 'temperatura', 946.0000, 'ºC'),
	(326212, 146, '2015-01-15 00:15:08.000000', 'temperatura', 680.0000, 'ºC'),
	(326213, 146, '2015-01-15 00:15:09.000000', 'temperatura', 559.0000, 'ºC'),
	(326214, 146, '2015-01-15 00:15:10.000000', 'temperatura', 758.0000, 'ºC'),
	(326215, 146, '2015-01-15 00:15:11.000000', 'temperatura', 912.0000, 'ºC'),
	(326216, 146, '2015-01-15 00:15:12.000000', 'temperatura', 1087.0000, 'ºC'),
	(326217, 146, '2015-01-15 00:15:13.000000', 'temperatura', 298.0000, 'ºC'),
	(326218, 146, '2015-01-15 00:15:14.000000', 'temperatura', 631.0000, 'ºC'),
	(326219, 146, '2015-01-15 00:15:15.000000', 'temperatura', 1063.0000, 'ºC'),
	(326220, 146, '2015-01-15 00:15:16.000000', 'temperatura', 1022.0000, 'ºC'),
	(326221, 146, '2015-01-15 00:15:17.000000', 'temperatura', 721.0000, 'ºC'),
	(326222, 146, '2015-01-15 00:15:18.000000', 'temperatura', 541.0000, 'ºC'),
	(326223, 146, '2015-01-15 00:15:19.000000', 'temperatura', 543.0000, 'ºC'),
	(326224, 146, '2015-01-15 00:15:20.000000', 'temperatura', 1090.0000, 'ºC'),
	(326225, 146, '2015-01-15 00:15:21.000000', 'temperatura', 222.0000, 'ºC'),
	(326226, 146, '2015-01-15 00:15:22.000000', 'temperatura', 241.0000, 'ºC'),
	(326227, 146, '2015-01-15 00:15:23.000000', 'temperatura', 537.0000, 'ºC'),
	(326228, 146, '2015-01-15 00:15:24.000000', 'temperatura', 766.0000, 'ºC'),
	(326229, 146, '2015-01-15 00:15:25.000000', 'temperatura', 1017.0000, 'ºC'),
	(326230, 146, '2015-01-15 00:15:26.000000', 'temperatura', 389.0000, 'ºC'),
	(326231, 146, '2015-01-15 00:15:27.000000', 'temperatura', 95.0000, 'ºC'),
	(326232, 146, '2015-01-15 00:15:28.000000', 'temperatura', 507.0000, 'ºC'),
	(326233, 146, '2015-01-15 00:15:29.000000', 'temperatura', 1050.0000, 'ºC'),
	(326234, 146, '2015-01-15 00:15:30.000000', 'temperatura', 129.0000, 'ºC'),
	(326235, 146, '2015-01-15 00:15:31.000000', 'temperatura', 1097.0000, 'ºC'),
	(326236, 146, '2015-01-15 00:15:32.000000', 'temperatura', 297.0000, 'ºC'),
	(326237, 146, '2015-01-15 00:15:33.000000', 'temperatura', 593.0000, 'ºC'),
	(326238, 146, '2015-01-15 00:15:34.000000', 'temperatura', 878.0000, 'ºC'),
	(326239, 146, '2015-01-15 00:15:35.000000', 'temperatura', 209.0000, 'ºC'),
	(326240, 146, '2015-01-15 00:15:36.000000', 'temperatura', 813.0000, 'ºC'),
	(326241, 146, '2015-01-15 00:15:37.000000', 'temperatura', 1037.0000, 'ºC'),
	(326242, 146, '2015-01-15 00:15:38.000000', 'temperatura', 347.0000, 'ºC'),
	(326243, 146, '2015-01-15 00:15:39.000000', 'temperatura', 1026.0000, 'ºC'),
	(326244, 146, '2015-01-15 00:15:40.000000', 'temperatura', 489.0000, 'ºC'),
	(326245, 146, '2015-01-15 00:15:41.000000', 'temperatura', 569.0000, 'ºC'),
	(326246, 146, '2015-01-15 00:15:42.000000', 'temperatura', 178.0000, 'ºC'),
	(326247, 146, '2015-01-15 00:15:43.000000', 'temperatura', 384.0000, 'ºC'),
	(326248, 146, '2015-01-15 00:15:44.000000', 'temperatura', 184.0000, 'ºC'),
	(326249, 146, '2015-01-15 00:15:45.000000', 'temperatura', 971.0000, 'ºC'),
	(326250, 146, '2015-01-15 00:15:46.000000', 'temperatura', 702.0000, 'ºC'),
	(326251, 146, '2015-01-15 00:15:47.000000', 'temperatura', 598.0000, 'ºC'),
	(326252, 146, '2015-01-15 00:15:48.000000', 'temperatura', 883.0000, 'ºC'),
	(326253, 146, '2015-01-15 00:15:49.000000', 'temperatura', 222.0000, 'ºC'),
	(326254, 146, '2015-01-15 00:15:50.000000', 'temperatura', 863.0000, 'ºC'),
	(326255, 146, '2015-01-15 00:15:51.000000', 'temperatura', 50.0000, 'ºC'),
	(326256, 146, '2015-01-15 00:15:52.000000', 'temperatura', 59.0000, 'ºC'),
	(326257, 146, '2015-01-15 00:15:53.000000', 'temperatura', 147.0000, 'ºC'),
	(326258, 146, '2015-01-15 00:15:54.000000', 'temperatura', 557.0000, 'ºC'),
	(326259, 146, '2015-01-15 00:15:55.000000', 'temperatura', 1147.0000, 'ºC'),
	(326260, 146, '2015-01-15 00:15:56.000000', 'temperatura', 465.0000, 'ºC'),
	(326261, 146, '2015-01-15 00:15:57.000000', 'temperatura', 82.0000, 'ºC'),
	(326262, 146, '2015-01-15 00:15:58.000000', 'temperatura', 218.0000, 'ºC'),
	(326263, 146, '2015-01-15 00:15:59.000000', 'temperatura', 844.0000, 'ºC'),
	(326264, 146, '2015-01-15 00:16:00.000000', 'temperatura', 1166.0000, 'ºC'),
	(326265, 146, '2015-01-15 00:16:01.000000', 'temperatura', 897.0000, 'ºC'),
	(326266, 146, '2015-01-15 00:16:02.000000', 'temperatura', 987.0000, 'ºC'),
	(326267, 146, '2015-01-15 00:16:03.000000', 'temperatura', 1046.0000, 'ºC'),
	(326268, 146, '2015-01-15 00:16:04.000000', 'temperatura', 1069.0000, 'ºC'),
	(326269, 146, '2015-01-15 00:16:05.000000', 'temperatura', 1007.0000, 'ºC'),
	(326270, 146, '2015-01-15 00:16:06.000000', 'temperatura', 630.0000, 'ºC'),
	(326271, 146, '2015-01-15 00:16:07.000000', 'temperatura', 127.0000, 'ºC'),
	(326272, 146, '2015-01-15 00:16:08.000000', 'temperatura', 1146.0000, 'ºC'),
	(326273, 146, '2015-01-15 00:16:09.000000', 'temperatura', 552.0000, 'ºC'),
	(326274, 146, '2015-01-15 00:16:10.000000', 'temperatura', 520.0000, 'ºC'),
	(326275, 146, '2015-01-15 00:16:11.000000', 'temperatura', 944.0000, 'ºC'),
	(326276, 146, '2015-01-15 00:16:12.000000', 'temperatura', 762.0000, 'ºC'),
	(326277, 146, '2015-01-15 00:16:13.000000', 'temperatura', 977.0000, 'ºC'),
	(326278, 146, '2015-01-15 00:16:14.000000', 'temperatura', 198.0000, 'ºC'),
	(326279, 146, '2015-01-15 00:16:15.000000', 'temperatura', 463.0000, 'ºC'),
	(326280, 146, '2015-01-15 00:16:16.000000', 'temperatura', 521.0000, 'ºC'),
	(326281, 146, '2015-01-15 00:16:17.000000', 'temperatura', 15.0000, 'ºC'),
	(326282, 146, '2015-01-15 00:16:18.000000', 'temperatura', 913.0000, 'ºC'),
	(326283, 146, '2015-01-15 00:16:19.000000', 'temperatura', 922.0000, 'ºC'),
	(326284, 146, '2015-01-15 00:16:20.000000', 'temperatura', 671.0000, 'ºC'),
	(326285, 146, '2015-01-15 00:16:21.000000', 'temperatura', 589.0000, 'ºC'),
	(326286, 146, '2015-01-15 00:16:22.000000', 'temperatura', 934.0000, 'ºC'),
	(326287, 146, '2015-01-15 00:16:23.000000', 'temperatura', 503.0000, 'ºC'),
	(326288, 146, '2015-01-15 00:16:24.000000', 'temperatura', 912.0000, 'ºC'),
	(326289, 146, '2015-01-15 00:16:25.000000', 'temperatura', 654.0000, 'ºC'),
	(326290, 146, '2015-01-15 00:16:26.000000', 'temperatura', 534.0000, 'ºC'),
	(326291, 146, '2015-01-15 00:16:27.000000', 'temperatura', 709.0000, 'ºC'),
	(326292, 146, '2015-01-15 00:16:28.000000', 'temperatura', 742.0000, 'ºC'),
	(326293, 146, '2015-01-15 00:16:29.000000', 'temperatura', 383.0000, 'ºC'),
	(326294, 146, '2015-01-15 00:16:30.000000', 'temperatura', 890.0000, 'ºC'),
	(326295, 146, '2015-01-15 00:16:31.000000', 'temperatura', 902.0000, 'ºC'),
	(326296, 146, '2015-01-15 00:16:32.000000', 'temperatura', 640.0000, 'ºC'),
	(326297, 146, '2015-01-15 00:16:33.000000', 'temperatura', 494.0000, 'ºC'),
	(326298, 146, '2015-01-15 00:16:34.000000', 'temperatura', 550.0000, 'ºC'),
	(326299, 146, '2015-01-15 00:16:35.000000', 'temperatura', 70.0000, 'ºC'),
	(326300, 146, '2015-01-15 00:16:36.000000', 'temperatura', 1099.0000, 'ºC'),
	(326301, 146, '2015-01-15 00:16:37.000000', 'temperatura', 486.0000, 'ºC'),
	(326302, 146, '2015-01-15 00:16:38.000000', 'temperatura', 333.0000, 'ºC'),
	(326303, 146, '2015-01-15 00:16:39.000000', 'temperatura', 209.0000, 'ºC'),
	(326304, 146, '2015-01-15 00:16:40.000000', 'temperatura', 46.0000, 'ºC'),
	(326305, 146, '2015-01-15 00:16:41.000000', 'temperatura', 803.0000, 'ºC'),
	(326306, 146, '2015-01-15 00:16:42.000000', 'temperatura', 276.0000, 'ºC'),
	(326307, 146, '2015-01-15 00:16:43.000000', 'temperatura', 173.0000, 'ºC'),
	(326308, 146, '2015-01-15 00:16:44.000000', 'temperatura', 38.0000, 'ºC'),
	(326309, 146, '2015-01-15 00:16:45.000000', 'temperatura', 869.0000, 'ºC'),
	(326310, 146, '2015-01-15 00:16:46.000000', 'temperatura', 632.0000, 'ºC'),
	(326311, 146, '2015-01-15 00:16:47.000000', 'temperatura', 556.0000, 'ºC'),
	(326312, 146, '2015-01-15 00:16:48.000000', 'temperatura', 881.0000, 'ºC'),
	(326313, 146, '2015-01-15 00:16:49.000000', 'temperatura', 341.0000, 'ºC'),
	(326314, 146, '2015-01-15 00:16:50.000000', 'temperatura', 261.0000, 'ºC'),
	(326315, 146, '2015-01-15 00:16:51.000000', 'temperatura', 282.0000, 'ºC'),
	(326316, 146, '2015-01-15 00:16:52.000000', 'temperatura', 629.0000, 'ºC'),
	(326317, 146, '2015-01-15 00:16:53.000000', 'temperatura', 1100.0000, 'ºC'),
	(326318, 146, '2015-01-15 00:16:54.000000', 'temperatura', 11.0000, 'ºC'),
	(326319, 146, '2015-01-15 00:16:55.000000', 'temperatura', 356.0000, 'ºC'),
	(326320, 146, '2015-01-15 00:16:56.000000', 'temperatura', 546.0000, 'ºC'),
	(326321, 146, '2015-01-15 00:16:57.000000', 'temperatura', 465.0000, 'ºC'),
	(326322, 146, '2015-01-15 00:16:58.000000', 'temperatura', 686.0000, 'ºC'),
	(326323, 146, '2015-01-15 00:16:59.000000', 'temperatura', 837.0000, 'ºC'),
	(326324, 146, '2015-01-15 00:17:00.000000', 'temperatura', 925.0000, 'ºC'),
	(326325, 146, '2015-01-15 00:17:01.000000', 'temperatura', 917.0000, 'ºC'),
	(326326, 146, '2015-01-15 00:17:02.000000', 'temperatura', 608.0000, 'ºC'),
	(326327, 146, '2015-01-15 00:17:03.000000', 'temperatura', 289.0000, 'ºC'),
	(326328, 146, '2015-01-15 00:17:04.000000', 'temperatura', 823.0000, 'ºC'),
	(326329, 146, '2015-01-15 00:17:05.000000', 'temperatura', 848.0000, 'ºC'),
	(326330, 146, '2015-01-15 00:17:06.000000', 'temperatura', 573.0000, 'ºC'),
	(326331, 146, '2015-01-15 00:17:07.000000', 'temperatura', 320.0000, 'ºC'),
	(326332, 146, '2015-01-15 00:17:08.000000', 'temperatura', 1080.0000, 'ºC'),
	(326333, 146, '2015-01-15 00:17:09.000000', 'temperatura', 841.0000, 'ºC'),
	(326334, 146, '2015-01-15 00:17:10.000000', 'temperatura', 967.0000, 'ºC'),
	(326335, 146, '2015-01-15 00:17:11.000000', 'temperatura', 1111.0000, 'ºC'),
	(326336, 146, '2015-01-15 00:17:12.000000', 'temperatura', 257.0000, 'ºC'),
	(326337, 146, '2015-01-15 00:17:13.000000', 'temperatura', 350.0000, 'ºC'),
	(326338, 146, '2015-01-15 00:17:14.000000', 'temperatura', 979.0000, 'ºC'),
	(326339, 146, '2015-01-15 00:17:15.000000', 'temperatura', 245.0000, 'ºC'),
	(326340, 146, '2015-01-15 00:17:16.000000', 'temperatura', 689.0000, 'ºC'),
	(326341, 146, '2015-01-15 00:17:17.000000', 'temperatura', 311.0000, 'ºC'),
	(326342, 146, '2015-01-15 00:17:18.000000', 'temperatura', 687.0000, 'ºC'),
	(326343, 146, '2015-01-15 00:17:19.000000', 'temperatura', 105.0000, 'ºC'),
	(326344, 146, '2015-01-15 00:17:20.000000', 'temperatura', 866.0000, 'ºC'),
	(326345, 146, '2015-01-15 00:17:21.000000', 'temperatura', 412.0000, 'ºC'),
	(326346, 146, '2015-01-15 00:17:22.000000', 'temperatura', 663.0000, 'ºC'),
	(326347, 146, '2015-01-15 00:17:23.000000', 'temperatura', 878.0000, 'ºC'),
	(326348, 146, '2015-01-15 00:17:24.000000', 'temperatura', 5.0000, 'ºC'),
	(326349, 146, '2015-01-15 00:17:25.000000', 'temperatura', 989.0000, 'ºC'),
	(326350, 146, '2015-01-15 00:17:26.000000', 'temperatura', 130.0000, 'ºC'),
	(326351, 146, '2015-01-15 00:17:27.000000', 'temperatura', 85.0000, 'ºC'),
	(326352, 146, '2015-01-15 00:17:28.000000', 'temperatura', 36.0000, 'ºC'),
	(326353, 146, '2015-01-15 00:17:29.000000', 'temperatura', 1125.0000, 'ºC'),
	(326354, 146, '2015-01-15 00:17:30.000000', 'temperatura', 716.0000, 'ºC'),
	(326355, 146, '2015-01-15 00:17:31.000000', 'temperatura', 208.0000, 'ºC'),
	(326356, 146, '2015-01-15 00:17:32.000000', 'temperatura', 90.0000, 'ºC'),
	(326357, 146, '2015-01-15 00:17:33.000000', 'temperatura', 1029.0000, 'ºC'),
	(326358, 146, '2015-01-15 00:17:34.000000', 'temperatura', 74.0000, 'ºC'),
	(326359, 146, '2015-01-15 00:17:35.000000', 'temperatura', 884.0000, 'ºC'),
	(326360, 146, '2015-01-15 00:17:36.000000', 'temperatura', 598.0000, 'ºC'),
	(326361, 146, '2015-01-15 00:17:37.000000', 'temperatura', 340.0000, 'ºC'),
	(326362, 146, '2015-01-15 00:17:38.000000', 'temperatura', 1105.0000, 'ºC'),
	(326363, 146, '2015-01-15 00:17:39.000000', 'temperatura', 906.0000, 'ºC'),
	(326364, 146, '2015-01-15 00:17:40.000000', 'temperatura', 16.0000, 'ºC'),
	(326365, 146, '2015-01-15 00:17:41.000000', 'temperatura', 964.0000, 'ºC'),
	(326366, 146, '2015-01-15 00:17:42.000000', 'temperatura', 1171.0000, 'ºC'),
	(326367, 146, '2015-01-15 00:17:43.000000', 'temperatura', 562.0000, 'ºC'),
	(326368, 146, '2015-01-15 00:17:44.000000', 'temperatura', 499.0000, 'ºC'),
	(326369, 146, '2015-01-15 00:17:45.000000', 'temperatura', 809.0000, 'ºC'),
	(326370, 146, '2015-01-15 00:17:46.000000', 'temperatura', 149.0000, 'ºC'),
	(326371, 146, '2015-01-15 00:17:47.000000', 'temperatura', 719.0000, 'ºC'),
	(326372, 146, '2015-01-15 00:17:48.000000', 'temperatura', 746.0000, 'ºC'),
	(326373, 146, '2015-01-15 00:17:49.000000', 'temperatura', 375.0000, 'ºC'),
	(326374, 146, '2015-01-15 00:17:50.000000', 'temperatura', 838.0000, 'ºC'),
	(326375, 146, '2015-01-15 00:17:51.000000', 'temperatura', 665.0000, 'ºC'),
	(326376, 146, '2015-01-15 00:17:52.000000', 'temperatura', 812.0000, 'ºC'),
	(326377, 146, '2015-01-15 00:17:53.000000', 'temperatura', 867.0000, 'ºC'),
	(326378, 146, '2015-01-15 00:17:54.000000', 'temperatura', 699.0000, 'ºC'),
	(326379, 146, '2015-01-15 00:17:55.000000', 'temperatura', 894.0000, 'ºC'),
	(326380, 146, '2015-01-15 00:17:56.000000', 'temperatura', 1173.0000, 'ºC'),
	(326381, 146, '2015-01-15 00:17:57.000000', 'temperatura', 786.0000, 'ºC'),
	(326382, 146, '2015-01-15 00:17:58.000000', 'temperatura', 409.0000, 'ºC'),
	(326383, 146, '2015-01-15 00:17:59.000000', 'temperatura', 890.0000, 'ºC'),
	(326384, 146, '2015-01-15 00:18:00.000000', 'temperatura', 822.0000, 'ºC'),
	(326385, 146, '2015-01-15 00:18:01.000000', 'temperatura', 239.0000, 'ºC'),
	(326386, 146, '2015-01-15 00:18:02.000000', 'temperatura', 1130.0000, 'ºC'),
	(326387, 146, '2015-01-15 00:18:03.000000', 'temperatura', 133.0000, 'ºC'),
	(326388, 146, '2015-01-15 00:18:04.000000', 'temperatura', 878.0000, 'ºC'),
	(326389, 146, '2015-01-15 00:18:05.000000', 'temperatura', 391.0000, 'ºC'),
	(326390, 146, '2015-01-15 00:18:06.000000', 'temperatura', 519.0000, 'ºC'),
	(326391, 146, '2015-01-15 00:18:07.000000', 'temperatura', 224.0000, 'ºC'),
	(326392, 146, '2015-01-15 00:18:08.000000', 'temperatura', 763.0000, 'ºC'),
	(326393, 146, '2015-01-15 00:18:09.000000', 'temperatura', 742.0000, 'ºC'),
	(326394, 146, '2015-01-15 00:18:10.000000', 'temperatura', 225.0000, 'ºC'),
	(326395, 146, '2015-01-15 00:18:11.000000', 'temperatura', 97.0000, 'ºC'),
	(326396, 146, '2015-01-15 00:18:12.000000', 'temperatura', 1012.0000, 'ºC'),
	(326397, 146, '2015-01-15 00:18:13.000000', 'temperatura', 1168.0000, 'ºC'),
	(326398, 146, '2015-01-15 00:18:14.000000', 'temperatura', 404.0000, 'ºC'),
	(326399, 146, '2015-01-15 00:18:15.000000', 'temperatura', 915.0000, 'ºC'),
	(326400, 146, '2015-01-15 00:18:16.000000', 'temperatura', 966.0000, 'ºC'),
	(326401, 146, '2015-01-15 00:18:17.000000', 'temperatura', 886.0000, 'ºC'),
	(326402, 146, '2015-01-15 00:18:18.000000', 'temperatura', 330.0000, 'ºC'),
	(326403, 146, '2015-01-15 00:18:19.000000', 'temperatura', 194.0000, 'ºC'),
	(326404, 146, '2015-01-15 00:18:20.000000', 'temperatura', 1182.0000, 'ºC'),
	(326405, 146, '2015-01-15 00:18:21.000000', 'temperatura', 529.0000, 'ºC'),
	(326406, 146, '2015-01-15 00:18:22.000000', 'temperatura', 297.0000, 'ºC'),
	(326407, 146, '2015-01-15 00:18:23.000000', 'temperatura', 1098.0000, 'ºC'),
	(326408, 146, '2015-01-15 00:18:24.000000', 'temperatura', 999.0000, 'ºC'),
	(326409, 146, '2015-01-15 00:18:25.000000', 'temperatura', 502.0000, 'ºC'),
	(326410, 146, '2015-01-15 00:18:26.000000', 'temperatura', 713.0000, 'ºC'),
	(326411, 146, '2015-01-15 00:18:27.000000', 'temperatura', 858.0000, 'ºC'),
	(326412, 146, '2015-01-15 00:18:28.000000', 'temperatura', 953.0000, 'ºC'),
	(326413, 146, '2015-01-15 00:18:29.000000', 'temperatura', 993.0000, 'ºC'),
	(326414, 146, '2015-01-15 00:18:30.000000', 'temperatura', 904.0000, 'ºC'),
	(326415, 146, '2015-01-15 00:18:31.000000', 'temperatura', 343.0000, 'ºC'),
	(326416, 146, '2015-01-15 00:18:32.000000', 'temperatura', 202.0000, 'ºC'),
	(326417, 146, '2015-01-15 00:18:33.000000', 'temperatura', 1182.0000, 'ºC'),
	(326418, 146, '2015-01-15 00:18:34.000000', 'temperatura', 505.0000, 'ºC'),
	(326419, 146, '2015-01-15 00:18:35.000000', 'temperatura', 181.0000, 'ºC'),
	(326420, 146, '2015-01-15 00:18:36.000000', 'temperatura', 589.0000, 'ºC'),
	(326421, 146, '2015-01-15 00:18:37.000000', 'temperatura', 2.0000, 'ºC'),
	(326422, 146, '2015-01-15 00:18:38.000000', 'temperatura', 645.0000, 'ºC'),
	(326423, 146, '2015-01-15 00:18:39.000000', 'temperatura', 820.0000, 'ºC'),
	(326424, 146, '2015-01-15 00:18:40.000000', 'temperatura', 963.0000, 'ºC'),
	(326425, 146, '2015-01-15 00:18:41.000000', 'temperatura', 1158.0000, 'ºC'),
	(326426, 146, '2015-01-15 00:18:42.000000', 'temperatura', 501.0000, 'ºC'),
	(326427, 146, '2015-01-15 00:18:43.000000', 'temperatura', 231.0000, 'ºC'),
	(326428, 146, '2015-01-15 00:18:44.000000', 'temperatura', 851.0000, 'ºC'),
	(326429, 146, '2015-01-15 00:18:45.000000', 'temperatura', 1164.0000, 'ºC'),
	(326430, 146, '2015-01-15 00:18:46.000000', 'temperatura', 865.0000, 'ºC'),
	(326431, 146, '2015-01-15 00:18:47.000000', 'temperatura', 837.0000, 'ºC'),
	(326432, 146, '2015-01-15 00:18:48.000000', 'temperatura', 390.0000, 'ºC'),
	(326433, 146, '2015-01-15 00:18:49.000000', 'temperatura', 638.0000, 'ºC'),
	(326434, 146, '2015-01-15 00:18:50.000000', 'temperatura', 823.0000, 'ºC'),
	(326435, 146, '2015-01-15 00:18:51.000000', 'temperatura', 999.0000, 'ºC'),
	(326436, 146, '2015-01-15 00:18:52.000000', 'temperatura', 129.0000, 'ºC'),
	(326437, 146, '2015-01-15 00:18:53.000000', 'temperatura', 45.0000, 'ºC'),
	(326438, 146, '2015-01-15 00:18:54.000000', 'temperatura', 1042.0000, 'ºC'),
	(326439, 146, '2015-01-15 00:18:55.000000', 'temperatura', 273.0000, 'ºC'),
	(326440, 146, '2015-01-15 00:18:56.000000', 'temperatura', 641.0000, 'ºC'),
	(326441, 146, '2015-01-15 00:18:57.000000', 'temperatura', 1187.0000, 'ºC'),
	(326442, 146, '2015-01-15 00:18:58.000000', 'temperatura', 413.0000, 'ºC'),
	(326443, 146, '2015-01-15 00:18:59.000000', 'temperatura', 906.0000, 'ºC'),
	(326444, 146, '2015-01-15 00:19:00.000000', 'temperatura', 888.0000, 'ºC'),
	(326445, 146, '2015-01-15 00:19:01.000000', 'temperatura', 525.0000, 'ºC'),
	(326446, 146, '2015-01-15 00:19:02.000000', 'temperatura', 1161.0000, 'ºC'),
	(326447, 146, '2015-01-15 00:19:03.000000', 'temperatura', 632.0000, 'ºC'),
	(326448, 146, '2015-01-15 00:19:04.000000', 'temperatura', 878.0000, 'ºC'),
	(326449, 146, '2015-01-15 00:19:05.000000', 'temperatura', 92.0000, 'ºC'),
	(326450, 146, '2015-01-15 00:19:06.000000', 'temperatura', 227.0000, 'ºC'),
	(326451, 146, '2015-01-15 00:19:07.000000', 'temperatura', 860.0000, 'ºC'),
	(326452, 146, '2015-01-15 00:19:08.000000', 'temperatura', 17.0000, 'ºC'),
	(326453, 146, '2015-01-15 00:19:09.000000', 'temperatura', 1108.0000, 'ºC'),
	(326454, 146, '2015-01-15 00:19:10.000000', 'temperatura', 690.0000, 'ºC'),
	(326455, 146, '2015-01-15 00:19:11.000000', 'temperatura', 127.0000, 'ºC'),
	(326456, 146, '2015-01-15 00:19:12.000000', 'temperatura', 966.0000, 'ºC'),
	(326457, 146, '2015-01-15 00:19:13.000000', 'temperatura', 850.0000, 'ºC'),
	(326458, 146, '2015-01-15 00:19:14.000000', 'temperatura', 153.0000, 'ºC'),
	(326459, 146, '2015-01-15 00:19:15.000000', 'temperatura', 613.0000, 'ºC'),
	(326460, 146, '2015-01-15 00:19:16.000000', 'temperatura', 208.0000, 'ºC'),
	(326461, 146, '2015-01-15 00:19:17.000000', 'temperatura', 399.0000, 'ºC'),
	(326462, 146, '2015-01-15 00:19:18.000000', 'temperatura', 175.0000, 'ºC'),
	(326463, 146, '2015-01-15 00:19:19.000000', 'temperatura', 876.0000, 'ºC'),
	(326464, 146, '2015-01-15 00:19:20.000000', 'temperatura', 256.0000, 'ºC'),
	(326465, 146, '2015-01-15 00:19:21.000000', 'temperatura', 1053.0000, 'ºC'),
	(326466, 146, '2015-01-15 00:19:22.000000', 'temperatura', 896.0000, 'ºC'),
	(326467, 146, '2015-01-15 00:19:23.000000', 'temperatura', 122.0000, 'ºC'),
	(326468, 146, '2015-01-15 00:19:24.000000', 'temperatura', 323.0000, 'ºC'),
	(326469, 146, '2015-01-15 00:19:25.000000', 'temperatura', 49.0000, 'ºC'),
	(326470, 146, '2015-01-15 00:19:26.000000', 'temperatura', 479.0000, 'ºC'),
	(326471, 146, '2015-01-15 00:19:27.000000', 'temperatura', 1046.0000, 'ºC'),
	(326472, 146, '2015-01-15 00:19:28.000000', 'temperatura', 195.0000, 'ºC'),
	(326473, 146, '2015-01-15 00:19:29.000000', 'temperatura', 238.0000, 'ºC'),
	(326474, 146, '2015-01-15 00:19:30.000000', 'temperatura', 606.0000, 'ºC'),
	(326475, 146, '2015-01-15 00:19:31.000000', 'temperatura', 1114.0000, 'ºC'),
	(326476, 146, '2015-01-15 00:19:32.000000', 'temperatura', 154.0000, 'ºC'),
	(326477, 146, '2015-01-15 00:19:33.000000', 'temperatura', 1029.0000, 'ºC'),
	(326478, 146, '2015-01-15 00:19:34.000000', 'temperatura', 1082.0000, 'ºC'),
	(326479, 146, '2015-01-15 00:19:35.000000', 'temperatura', 1124.0000, 'ºC'),
	(326480, 146, '2015-01-15 00:19:36.000000', 'temperatura', 1173.0000, 'ºC'),
	(326481, 146, '2015-01-15 00:19:37.000000', 'temperatura', 95.0000, 'ºC'),
	(326482, 146, '2015-01-15 00:19:38.000000', 'temperatura', 557.0000, 'ºC'),
	(326483, 146, '2015-01-15 00:19:39.000000', 'temperatura', 99.0000, 'ºC'),
	(326484, 146, '2015-01-15 00:19:40.000000', 'temperatura', 27.0000, 'ºC'),
	(326485, 146, '2015-01-15 00:19:41.000000', 'temperatura', 1037.0000, 'ºC'),
	(326486, 146, '2015-01-15 00:19:42.000000', 'temperatura', 303.0000, 'ºC'),
	(326487, 146, '2015-01-15 00:19:43.000000', 'temperatura', 804.0000, 'ºC'),
	(326488, 146, '2015-01-15 00:19:44.000000', 'temperatura', 713.0000, 'ºC'),
	(326489, 146, '2015-01-15 00:19:45.000000', 'temperatura', 1153.0000, 'ºC'),
	(326490, 146, '2015-01-15 00:19:46.000000', 'temperatura', 28.0000, 'ºC'),
	(326491, 146, '2015-01-15 00:19:47.000000', 'temperatura', 279.0000, 'ºC'),
	(326492, 146, '2015-01-15 00:19:48.000000', 'temperatura', 113.0000, 'ºC'),
	(326493, 146, '2015-01-15 00:19:49.000000', 'temperatura', 930.0000, 'ºC'),
	(326494, 146, '2015-01-15 00:19:50.000000', 'temperatura', 711.0000, 'ºC'),
	(326495, 146, '2015-01-15 00:19:51.000000', 'temperatura', 766.0000, 'ºC'),
	(326496, 146, '2015-01-15 00:19:52.000000', 'temperatura', 495.0000, 'ºC'),
	(326497, 146, '2015-01-15 00:19:53.000000', 'temperatura', 180.0000, 'ºC'),
	(326498, 146, '2015-01-15 00:19:54.000000', 'temperatura', 616.0000, 'ºC'),
	(326499, 146, '2015-01-15 00:19:55.000000', 'temperatura', 139.0000, 'ºC'),
	(326500, 146, '2015-01-15 00:19:56.000000', 'temperatura', 48.0000, 'ºC'),
	(326501, 146, '2015-01-15 00:19:57.000000', 'temperatura', 1022.0000, 'ºC'),
	(326502, 146, '2015-01-15 00:19:58.000000', 'temperatura', 169.0000, 'ºC'),
	(326503, 146, '2015-01-15 00:19:59.000000', 'temperatura', 178.0000, 'ºC'),
	(326504, 146, '2015-01-15 00:20:00.000000', 'temperatura', 383.0000, 'ºC'),
	(326505, 146, '2015-01-15 00:20:01.000000', 'temperatura', 181.0000, 'ºC'),
	(326506, 146, '2015-01-15 00:20:02.000000', 'temperatura', 956.0000, 'ºC'),
	(326507, 146, '2015-01-15 00:20:03.000000', 'temperatura', 639.0000, 'ºC'),
	(326508, 146, '2015-01-15 00:20:04.000000', 'temperatura', 328.0000, 'ºC'),
	(326509, 146, '2015-01-15 00:20:05.000000', 'temperatura', 924.0000, 'ºC'),
	(326510, 146, '2015-01-15 00:20:06.000000', 'temperatura', 35.0000, 'ºC'),
	(326511, 146, '2015-01-15 00:20:07.000000', 'temperatura', 1004.0000, 'ºC'),
	(326512, 146, '2015-01-15 00:20:08.000000', 'temperatura', 113.0000, 'ºC'),
	(326513, 146, '2015-01-15 00:20:09.000000', 'temperatura', 1157.0000, 'ºC'),
	(326514, 146, '2015-01-15 00:20:10.000000', 'temperatura', 645.0000, 'ºC'),
	(326515, 146, '2015-01-15 00:20:11.000000', 'temperatura', 957.0000, 'ºC'),
	(326516, 146, '2015-01-15 00:20:12.000000', 'temperatura', 448.0000, 'ºC'),
	(326517, 146, '2015-01-15 00:20:13.000000', 'temperatura', 568.0000, 'ºC'),
	(326518, 146, '2015-01-15 00:20:14.000000', 'temperatura', 298.0000, 'ºC'),
	(326519, 146, '2015-01-15 00:20:15.000000', 'temperatura', 987.0000, 'ºC'),
	(326520, 146, '2015-01-15 00:20:16.000000', 'temperatura', 441.0000, 'ºC'),
	(326521, 146, '2015-01-15 00:20:17.000000', 'temperatura', 444.0000, 'ºC'),
	(326522, 146, '2015-01-15 00:20:18.000000', 'temperatura', 900.0000, 'ºC'),
	(326523, 146, '2015-01-15 00:20:19.000000', 'temperatura', 767.0000, 'ºC'),
	(326524, 146, '2015-01-15 00:20:20.000000', 'temperatura', 1136.0000, 'ºC'),
	(326525, 146, '2015-01-15 00:20:21.000000', 'temperatura', 979.0000, 'ºC'),
	(326526, 146, '2015-01-15 00:20:22.000000', 'temperatura', 287.0000, 'ºC'),
	(326527, 146, '2015-01-15 00:20:23.000000', 'temperatura', 897.0000, 'ºC'),
	(326528, 146, '2015-01-15 00:20:24.000000', 'temperatura', 27.0000, 'ºC'),
	(326529, 146, '2015-01-15 00:20:25.000000', 'temperatura', 1043.0000, 'ºC'),
	(326530, 146, '2015-01-15 00:20:26.000000', 'temperatura', 337.0000, 'ºC'),
	(326531, 146, '2015-01-15 00:20:27.000000', 'temperatura', 956.0000, 'ºC'),
	(326532, 146, '2015-01-15 00:20:28.000000', 'temperatura', 167.0000, 'ºC'),
	(326533, 146, '2015-01-15 00:20:29.000000', 'temperatura', 370.0000, 'ºC'),
	(326534, 146, '2015-01-15 00:20:30.000000', 'temperatura', 150.0000, 'ºC'),
	(326535, 146, '2015-01-15 00:20:31.000000', 'temperatura', 841.0000, 'ºC'),
	(326536, 146, '2015-01-15 00:20:32.000000', 'temperatura', 154.0000, 'ºC'),
	(326537, 146, '2015-01-15 00:20:33.000000', 'temperatura', 647.0000, 'ºC'),
	(326538, 146, '2015-01-15 00:20:34.000000', 'temperatura', 374.0000, 'ºC'),
	(326539, 146, '2015-01-15 00:20:35.000000', 'temperatura', 1128.0000, 'ºC'),
	(326540, 146, '2015-01-15 00:20:36.000000', 'temperatura', 919.0000, 'ºC'),
	(326541, 146, '2015-01-15 00:20:37.000000', 'temperatura', 13.0000, 'ºC'),
	(326542, 146, '2015-01-15 00:20:38.000000', 'temperatura', 907.0000, 'ºC'),
	(326543, 146, '2015-01-15 00:20:39.000000', 'temperatura', 896.0000, 'ºC'),
	(326544, 146, '2015-01-15 00:20:40.000000', 'temperatura', 560.0000, 'ºC'),
	(326545, 146, '2015-01-15 00:20:41.000000', 'temperatura', 113.0000, 'ºC'),
	(326546, 146, '2015-01-15 00:20:42.000000', 'temperatura', 84.0000, 'ºC'),
	(326547, 146, '2015-01-15 00:20:43.000000', 'temperatura', 83.0000, 'ºC'),
	(326548, 146, '2015-01-15 00:20:44.000000', 'temperatura', 164.0000, 'ºC'),
	(326549, 146, '2015-01-15 00:20:45.000000', 'temperatura', 570.0000, 'ºC'),
	(326550, 146, '2015-01-15 00:20:46.000000', 'temperatura', 1158.0000, 'ºC'),
	(326551, 146, '2015-01-15 00:20:47.000000', 'temperatura', 480.0000, 'ºC'),
	(326552, 146, '2015-01-15 00:20:48.000000', 'temperatura', 128.0000, 'ºC'),
	(326553, 146, '2015-01-15 00:20:49.000000', 'temperatura', 399.0000, 'ºC'),
	(326554, 146, '2015-01-15 00:20:50.000000', 'temperatura', 411.0000, 'ºC'),
	(326555, 146, '2015-01-15 00:20:51.000000', 'temperatura', 860.0000, 'ºC'),
	(326556, 146, '2015-01-15 00:20:52.000000', 'temperatura', 667.0000, 'ºC'),
	(326557, 146, '2015-01-15 00:20:53.000000', 'temperatura', 755.0000, 'ºC'),
	(326558, 146, '2015-01-15 00:20:54.000000', 'temperatura', 577.0000, 'ºC'),
	(326559, 146, '2015-01-15 00:20:55.000000', 'temperatura', 619.0000, 'ºC'),
	(326560, 146, '2015-01-15 00:20:56.000000', 'temperatura', 162.0000, 'ºC'),
	(326561, 146, '2015-01-15 00:20:57.000000', 'temperatura', 157.0000, 'ºC'),
	(326562, 146, '2015-01-15 00:20:58.000000', 'temperatura', 299.0000, 'ºC'),
	(326563, 146, '2015-01-15 00:20:59.000000', 'temperatura', 1026.0000, 'ºC'),
	(326564, 146, '2015-01-15 00:21:00.000000', 'temperatura', 632.0000, 'ºC'),
	(326565, 146, '2015-01-15 00:21:01.000000', 'temperatura', 84.0000, 'ºC'),
	(326566, 146, '2015-01-15 00:21:02.000000', 'temperatura', 922.0000, 'ºC'),
	(326567, 146, '2015-01-15 00:21:03.000000', 'temperatura', 760.0000, 'ºC'),
	(326568, 146, '2015-01-15 00:21:04.000000', 'temperatura', 1036.0000, 'ºC'),
	(326569, 146, '2015-01-15 00:21:05.000000', 'temperatura', 501.0000, 'ºC'),
	(326570, 146, '2015-01-15 00:21:06.000000', 'temperatura', 595.0000, 'ºC'),
	(326571, 146, '2015-01-15 00:21:07.000000', 'temperatura', 272.0000, 'ºC'),
	(326572, 146, '2015-01-15 00:21:08.000000', 'temperatura', 775.0000, 'ºC'),
	(326573, 146, '2015-01-15 00:21:09.000000', 'temperatura', 659.0000, 'ºC'),
	(326574, 146, '2015-01-15 00:21:10.000000', 'temperatura', 973.0000, 'ºC'),
	(326575, 146, '2015-01-15 00:21:11.000000', 'temperatura', 489.0000, 'ºC'),
	(326576, 146, '2015-01-15 00:21:12.000000', 'temperatura', 727.0000, 'ºC'),
	(326577, 146, '2015-01-15 00:21:13.000000', 'temperatura', 968.0000, 'ºC'),
	(326578, 146, '2015-01-15 00:21:14.000000', 'temperatura', 259.0000, 'ºC'),
	(326579, 146, '2015-01-15 00:21:15.000000', 'temperatura', 791.0000, 'ºC'),
	(326580, 146, '2015-01-15 00:21:16.000000', 'temperatura', 779.0000, 'ºC'),
	(326581, 146, '2015-01-15 00:21:17.000000', 'temperatura', 324.0000, 'ºC'),
	(326582, 146, '2015-01-15 00:21:18.000000', 'temperatura', 482.0000, 'ºC'),
	(326583, 146, '2015-01-15 00:21:19.000000', 'temperatura', 238.0000, 'ºC'),
	(326584, 146, '2015-01-15 00:21:20.000000', 'temperatura', 947.0000, 'ºC'),
	(326585, 146, '2015-01-15 00:21:21.000000', 'temperatura', 420.0000, 'ºC'),
	(326586, 146, '2015-01-15 00:21:22.000000', 'temperatura', 461.0000, 'ºC'),
	(326587, 146, '2015-01-15 00:21:23.000000', 'temperatura', 1044.0000, 'ºC'),
	(326588, 146, '2015-01-15 00:21:24.000000', 'temperatura', 240.0000, 'ºC'),
	(326589, 146, '2015-01-15 00:21:25.000000', 'temperatura', 467.0000, 'ºC'),
	(326590, 146, '2015-01-15 00:21:26.000000', 'temperatura', 414.0000, 'ºC'),
	(326591, 146, '2015-01-15 00:21:27.000000', 'temperatura', 669.0000, 'ºC'),
	(326592, 146, '2015-01-15 00:21:28.000000', 'temperatura', 906.0000, 'ºC'),
	(326593, 146, '2015-01-15 00:21:29.000000', 'temperatura', 122.0000, 'ºC'),
	(326594, 146, '2015-01-15 00:21:30.000000', 'temperatura', 295.0000, 'ºC'),
	(326595, 146, '2015-01-15 00:21:31.000000', 'temperatura', 1107.0000, 'ºC'),
	(326596, 146, '2015-01-15 00:21:32.000000', 'temperatura', 1051.0000, 'ºC'),
	(326597, 146, '2015-01-15 00:21:33.000000', 'temperatura', 736.0000, 'ºC'),
	(326598, 146, '2015-01-15 00:21:34.000000', 'temperatura', 526.0000, 'ºC'),
	(326599, 146, '2015-01-15 00:21:35.000000', 'temperatura', 421.0000, 'ºC'),
	(326600, 146, '2015-01-15 00:21:36.000000', 'temperatura', 529.0000, 'ºC'),
	(326601, 146, '2015-01-15 00:21:37.000000', 'temperatura', 184.0000, 'ºC'),
	(326602, 146, '2015-01-15 00:21:38.000000', 'temperatura', 532.0000, 'ºC'),
	(326603, 146, '2015-01-15 00:21:39.000000', 'temperatura', 910.0000, 'ºC'),
	(326604, 146, '2015-01-15 00:21:40.000000', 'temperatura', 552.0000, 'ºC'),
	(326605, 146, '2015-01-15 00:21:41.000000', 'temperatura', 30.0000, 'ºC'),
	(326606, 146, '2015-01-15 00:21:42.000000', 'temperatura', 894.0000, 'ºC'),
	(326607, 146, '2015-01-15 00:21:43.000000', 'temperatura', 780.0000, 'ºC'),
	(326608, 146, '2015-01-15 00:21:44.000000', 'temperatura', 19.0000, 'ºC'),
	(326609, 146, '2015-01-15 00:21:45.000000', 'temperatura', 157.0000, 'ºC'),
	(326610, 146, '2015-01-15 00:21:46.000000', 'temperatura', 729.0000, 'ºC'),
	(326611, 146, '2015-01-15 00:21:47.000000', 'temperatura', 773.0000, 'ºC'),
	(326612, 146, '2015-01-15 00:21:48.000000', 'temperatura', 477.0000, 'ºC'),
	(326613, 146, '2015-01-15 00:21:49.000000', 'temperatura', 68.0000, 'ºC'),
	(326614, 146, '2015-01-15 00:21:50.000000', 'temperatura', 110.0000, 'ºC'),
	(326615, 146, '2015-01-15 00:21:51.000000', 'temperatura', 345.0000, 'ºC'),
	(326616, 146, '2015-01-15 00:21:52.000000', 'temperatura', 197.0000, 'ºC'),
	(326617, 146, '2015-01-15 00:21:53.000000', 'temperatura', 1151.0000, 'ºC'),
	(326618, 146, '2015-01-15 00:21:54.000000', 'temperatura', 363.0000, 'ºC'),
	(326619, 146, '2015-01-15 00:21:55.000000', 'temperatura', 764.0000, 'ºC'),
	(326620, 146, '2015-01-15 00:21:56.000000', 'temperatura', 332.0000, 'ºC'),
	(326621, 146, '2015-01-15 00:21:57.000000', 'temperatura', 569.0000, 'ºC'),
	(326622, 146, '2015-01-15 00:21:58.000000', 'temperatura', 648.0000, 'ºC'),
	(326623, 146, '2015-01-15 00:21:59.000000', 'temperatura', 333.0000, 'ºC'),
	(326624, 146, '2015-01-15 00:22:00.000000', 'temperatura', 923.0000, 'ºC'),
	(326625, 146, '2015-01-15 00:22:01.000000', 'temperatura', 14.0000, 'ºC'),
	(326626, 146, '2015-01-15 00:22:02.000000', 'temperatura', 902.0000, 'ºC'),
	(326627, 146, '2015-01-15 00:22:03.000000', 'temperatura', 871.0000, 'ºC'),
	(326628, 146, '2015-01-15 00:22:04.000000', 'temperatura', 447.0000, 'ºC'),
	(326629, 146, '2015-01-15 00:22:05.000000', 'temperatura', 822.0000, 'ºC'),
	(326630, 146, '2015-01-15 00:22:06.000000', 'temperatura', 371.0000, 'ºC'),
	(326631, 146, '2015-01-15 00:22:07.000000', 'temperatura', 590.0000, 'ºC'),
	(326632, 146, '2015-01-15 00:22:08.000000', 'temperatura', 636.0000, 'ºC'),
	(326633, 146, '2015-01-15 00:22:09.000000', 'temperatura', 213.0000, 'ºC'),
	(326634, 146, '2015-01-15 00:22:10.000000', 'temperatura', 357.0000, 'ºC'),
	(326635, 146, '2015-01-15 00:22:11.000000', 'temperatura', 1146.0000, 'ºC'),
	(326636, 146, '2015-01-15 00:22:12.000000', 'temperatura', 1059.0000, 'ºC'),
	(326637, 146, '2015-01-15 00:22:13.000000', 'temperatura', 657.0000, 'ºC'),
	(326638, 146, '2015-01-15 00:22:14.000000', 'temperatura', 110.0000, 'ºC'),
	(326639, 146, '2015-01-15 00:22:15.000000', 'temperatura', 979.0000, 'ºC'),
	(326640, 146, '2015-01-15 00:22:16.000000', 'temperatura', 967.0000, 'ºC'),
	(326641, 146, '2015-01-15 00:22:17.000000', 'temperatura', 697.0000, 'ºC'),
	(326642, 146, '2015-01-15 00:22:18.000000', 'temperatura', 585.0000, 'ºC'),
	(326643, 146, '2015-01-15 00:22:19.000000', 'temperatura', 835.0000, 'ºC'),
	(326644, 146, '2015-01-15 00:22:20.000000', 'temperatura', 21.0000, 'ºC'),
	(326645, 146, '2015-01-15 00:22:21.000000', 'temperatura', 0.0000, 'ºC'),
	(326646, 146, '2015-01-15 00:22:22.000000', 'temperatura', 1136.0000, 'ºC'),
	(326647, 146, '2015-01-15 00:22:23.000000', 'temperatura', 881.0000, 'ºC'),
	(326648, 146, '2015-01-15 00:22:24.000000', 'temperatura', 999.0000, 'ºC'),
	(326649, 146, '2015-01-15 00:22:25.000000', 'temperatura', 1151.0000, 'ºC'),
	(326650, 146, '2015-01-15 00:22:26.000000', 'temperatura', 359.0000, 'ºC'),
	(326651, 146, '2015-01-15 00:22:27.000000', 'temperatura', 743.0000, 'ºC'),
	(326652, 146, '2015-01-15 00:22:28.000000', 'temperatura', 239.0000, 'ºC'),
	(326653, 146, '2015-01-15 00:22:29.000000', 'temperatura', 164.0000, 'ºC'),
	(326654, 146, '2015-01-15 00:22:30.000000', 'temperatura', 106.0000, 'ºC'),
	(326655, 146, '2015-01-15 00:22:31.000000', 'temperatura', 38.0000, 'ºC'),
	(326656, 146, '2015-01-15 00:22:32.000000', 'temperatura', 1071.0000, 'ºC'),
	(326657, 146, '2015-01-15 00:22:33.000000', 'temperatura', 443.0000, 'ºC'),
	(326658, 146, '2015-01-15 00:22:34.000000', 'temperatura', 201.0000, 'ºC'),
	(326659, 146, '2015-01-15 00:22:35.000000', 'temperatura', 878.0000, 'ºC'),
	(326660, 146, '2015-01-15 00:22:36.000000', 'temperatura', 186.0000, 'ºC'),
	(326661, 146, '2015-01-15 00:22:37.000000', 'temperatura', 696.0000, 'ºC'),
	(326662, 146, '2015-01-15 00:22:38.000000', 'temperatura', 525.0000, 'ºC'),
	(326663, 146, '2015-01-15 00:22:39.000000', 'temperatura', 537.0000, 'ºC'),
	(326664, 146, '2015-01-15 00:22:40.000000', 'temperatura', 1109.0000, 'ºC'),
	(326665, 146, '2015-01-15 00:22:41.000000', 'temperatura', 336.0000, 'ºC'),
	(326666, 146, '2015-01-15 00:22:42.000000', 'temperatura', 752.0000, 'ºC'),
	(326667, 146, '2015-01-15 00:22:43.000000', 'temperatura', 354.0000, 'ºC'),
	(326668, 146, '2015-01-15 00:22:44.000000', 'temperatura', 715.0000, 'ºC'),
	(326669, 146, '2015-01-15 00:22:45.000000', 'temperatura', 114.0000, 'ºC'),
	(326670, 146, '2015-01-15 00:22:46.000000', 'temperatura', 824.0000, 'ºC'),
	(326671, 146, '2015-01-15 00:22:47.000000', 'temperatura', 180.0000, 'ºC'),
	(326672, 146, '2015-01-15 00:22:48.000000', 'temperatura', 828.0000, 'ºC'),
	(326673, 146, '2015-01-15 00:22:49.000000', 'temperatura', 2.0000, 'ºC'),
	(326674, 146, '2015-01-15 00:22:50.000000', 'temperatura', 1127.0000, 'ºC'),
	(326675, 146, '2015-01-15 00:22:51.000000', 'temperatura', 827.0000, 'ºC'),
	(326676, 146, '2015-01-15 00:22:52.000000', 'temperatura', 755.0000, 'ºC'),
	(326677, 146, '2015-01-15 00:22:53.000000', 'temperatura', 97.0000, 'ºC'),
	(326678, 146, '2015-01-15 00:22:54.000000', 'temperatura', 619.0000, 'ºC'),
	(326679, 146, '2015-01-15 00:22:55.000000', 'temperatura', 403.0000, 'ºC'),
	(326680, 146, '2015-01-15 00:22:56.000000', 'temperatura', 160.0000, 'ºC'),
	(326681, 146, '2015-01-15 00:22:57.000000', 'temperatura', 790.0000, 'ºC'),
	(326682, 146, '2015-01-15 00:22:58.000000', 'temperatura', 1072.0000, 'ºC'),
	(326683, 146, '2015-01-15 00:22:59.000000', 'temperatura', 588.0000, 'ºC'),
	(326684, 146, '2015-01-15 00:23:00.000000', 'temperatura', 927.0000, 'ºC'),
	(326685, 146, '2015-01-15 00:23:01.000000', 'temperatura', 470.0000, 'ºC'),
	(326686, 146, '2015-01-15 00:23:02.000000', 'temperatura', 769.0000, 'ºC'),
	(326687, 146, '2015-01-15 00:23:03.000000', 'temperatura', 37.0000, 'ºC'),
	(326688, 146, '2015-01-15 00:23:04.000000', 'temperatura', 278.0000, 'ºC'),
	(326689, 146, '2015-01-15 00:23:05.000000', 'temperatura', 78.0000, 'ºC'),
	(326690, 146, '2015-01-15 00:23:06.000000', 'temperatura', 755.0000, 'ºC'),
	(326691, 146, '2015-01-15 00:23:07.000000', 'temperatura', 1145.0000, 'ºC'),
	(326692, 146, '2015-01-15 00:23:08.000000', 'temperatura', 1059.0000, 'ºC'),
	(326693, 146, '2015-01-15 00:23:09.000000', 'temperatura', 661.0000, 'ºC'),
	(326694, 146, '2015-01-15 00:23:10.000000', 'temperatura', 130.0000, 'ºC'),
	(326695, 146, '2015-01-15 00:23:11.000000', 'temperatura', 1067.0000, 'ºC'),
	(326696, 146, '2015-01-15 00:23:12.000000', 'temperatura', 145.0000, 'ºC'),
	(326697, 146, '2015-01-15 00:23:13.000000', 'temperatura', 1125.0000, 'ºC'),
	(326698, 146, '2015-01-15 00:23:14.000000', 'temperatura', 392.0000, 'ºC'),
	(326699, 146, '2015-01-15 00:23:15.000000', 'temperatura', 985.0000, 'ºC'),
	(326700, 146, '2015-01-15 00:23:16.000000', 'temperatura', 150.0000, 'ºC'),
	(326701, 146, '2015-01-15 00:23:17.000000', 'temperatura', 193.0000, 'ºC'),
	(326702, 146, '2015-01-15 00:23:18.000000', 'temperatura', 517.0000, 'ºC'),
	(326703, 146, '2015-01-15 00:23:19.000000', 'temperatura', 805.0000, 'ºC'),
	(326704, 146, '2015-01-15 00:23:20.000000', 'temperatura', 76.0000, 'ºC'),
	(326705, 146, '2015-01-15 00:23:21.000000', 'temperatura', 365.0000, 'ºC'),
	(326706, 146, '2015-01-15 00:23:22.000000', 'temperatura', 399.0000, 'ºC'),
	(326707, 146, '2015-01-15 00:23:23.000000', 'temperatura', 899.0000, 'ºC'),
	(326708, 146, '2015-01-15 00:23:24.000000', 'temperatura', 900.0000, 'ºC'),
	(326709, 146, '2015-01-15 00:23:25.000000', 'temperatura', 601.0000, 'ºC'),
	(326710, 146, '2015-01-15 00:23:26.000000', 'temperatura', 307.0000, 'ºC'),
	(326711, 146, '2015-01-15 00:23:27.000000', 'temperatura', 933.0000, 'ºC'),
	(326712, 146, '2015-01-15 00:23:28.000000', 'temperatura', 145.0000, 'ºC'),
	(326713, 146, '2015-01-15 00:23:29.000000', 'temperatura', 326.0000, 'ºC'),
	(326714, 146, '2015-01-15 00:23:30.000000', 'temperatura', 1196.0000, 'ºC'),
	(326715, 146, '2015-01-15 00:23:31.000000', 'temperatura', 201.0000, 'ºC'),
	(326716, 146, '2015-01-15 00:23:32.000000', 'temperatura', 1018.0000, 'ºC'),
	(326717, 146, '2015-01-15 00:23:33.000000', 'temperatura', 888.0000, 'ºC'),
	(326718, 146, '2015-01-15 00:23:34.000000', 'temperatura', 187.0000, 'ºC'),
	(326719, 146, '2015-01-15 00:23:35.000000', 'temperatura', 670.0000, 'ºC'),
	(326720, 146, '2015-01-15 00:23:36.000000', 'temperatura', 392.0000, 'ºC'),
	(326721, 146, '2015-01-15 00:23:37.000000', 'temperatura', 1148.0000, 'ºC'),
	(326722, 146, '2015-01-15 00:23:38.000000', 'temperatura', 965.0000, 'ºC'),
	(326723, 146, '2015-01-15 00:23:39.000000', 'temperatura', 182.0000, 'ºC'),
	(326724, 146, '2015-01-15 00:23:40.000000', 'temperatura', 414.0000, 'ºC'),
	(326725, 146, '2015-01-15 00:23:41.000000', 'temperatura', 327.0000, 'ºC'),
	(326726, 146, '2015-01-15 00:23:42.000000', 'temperatura', 394.0000, 'ºC'),
	(326727, 146, '2015-01-15 00:23:43.000000', 'temperatura', 987.0000, 'ºC'),
	(326728, 146, '2015-01-15 00:23:44.000000', 'temperatura', 156.0000, 'ºC'),
	(326729, 146, '2015-01-15 00:23:45.000000', 'temperatura', 218.0000, 'ºC'),
	(326730, 146, '2015-01-15 00:23:46.000000', 'temperatura', 622.0000, 'ºC'),
	(326731, 146, '2015-01-15 00:23:47.000000', 'temperatura', 58.0000, 'ºC'),
	(326732, 146, '2015-01-15 00:23:48.000000', 'temperatura', 826.0000, 'ºC'),
	(326733, 146, '2015-01-15 00:23:49.000000', 'temperatura', 353.0000, 'ºC'),
	(326734, 146, '2015-01-15 00:23:50.000000', 'temperatura', 489.0000, 'ºC'),
	(326735, 146, '2015-01-15 00:23:51.000000', 'temperatura', 185.0000, 'ºC'),
	(326736, 146, '2015-01-15 00:23:52.000000', 'temperatura', 661.0000, 'ºC'),
	(326737, 146, '2015-01-15 00:23:53.000000', 'temperatura', 350.0000, 'ºC'),
	(326738, 146, '2015-01-15 00:23:54.000000', 'temperatura', 967.0000, 'ºC'),
	(326739, 146, '2015-01-15 00:23:55.000000', 'temperatura', 187.0000, 'ºC'),
	(326740, 146, '2015-01-15 00:23:56.000000', 'temperatura', 435.0000, 'ºC'),
	(326741, 146, '2015-01-15 00:23:57.000000', 'temperatura', 415.0000, 'ºC'),
	(326742, 146, '2015-01-15 00:23:58.000000', 'temperatura', 771.0000, 'ºC'),
	(326743, 146, '2015-01-15 00:23:59.000000', 'temperatura', 211.0000, 'ºC'),
	(326744, 146, '2015-01-15 00:24:00.000000', 'temperatura', 1141.0000, 'ºC'),
	(326745, 146, '2015-01-15 00:24:01.000000', 'temperatura', 271.0000, 'ºC'),
	(326746, 146, '2015-01-15 00:24:02.000000', 'temperatura', 334.0000, 'ºC'),
	(326747, 146, '2015-01-15 00:24:03.000000', 'temperatura', 858.0000, 'ºC'),
	(326748, 146, '2015-01-15 00:24:04.000000', 'temperatura', 888.0000, 'ºC'),
	(326749, 146, '2015-01-15 00:24:05.000000', 'temperatura', 665.0000, 'ºC'),
	(326750, 146, '2015-01-15 00:24:06.000000', 'temperatura', 662.0000, 'ºC'),
	(326751, 146, '2015-01-15 00:24:07.000000', 'temperatura', 118.0000, 'ºC'),
	(326752, 146, '2015-01-15 00:24:08.000000', 'temperatura', 1001.0000, 'ºC'),
	(326753, 146, '2015-01-15 00:24:09.000000', 'temperatura', 1053.0000, 'ºC'),
	(326754, 146, '2015-01-15 00:24:10.000000', 'temperatura', 1061.0000, 'ºC'),
	(326755, 146, '2015-01-15 00:24:11.000000', 'temperatura', 945.0000, 'ºC'),
	(326756, 146, '2015-01-15 00:24:12.000000', 'temperatura', 346.0000, 'ºC'),
	(326757, 146, '2015-01-15 00:24:13.000000', 'temperatura', 94.0000, 'ºC'),
	(326758, 146, '2015-01-15 00:24:14.000000', 'temperatura', 631.0000, 'ºC'),
	(326759, 146, '2015-01-15 00:24:15.000000', 'temperatura', 476.0000, 'ºC'),
	(326760, 146, '2015-01-15 00:24:16.000000', 'temperatura', 485.0000, 'ºC'),
	(326761, 146, '2015-01-15 00:24:17.000000', 'temperatura', 998.0000, 'ºC'),
	(326762, 146, '2015-01-15 00:24:18.000000', 'temperatura', 1134.0000, 'ºC'),
	(326763, 146, '2015-01-15 00:24:19.000000', 'temperatura', 278.0000, 'ºC'),
	(326764, 146, '2015-01-15 00:24:20.000000', 'temperatura', 387.0000, 'ºC'),
	(326765, 146, '2015-01-15 00:24:21.000000', 'temperatura', 1101.0000, 'ºC'),
	(326766, 146, '2015-01-15 00:24:22.000000', 'temperatura', 746.0000, 'ºC'),
	(326767, 146, '2015-01-15 00:24:23.000000', 'temperatura', 426.0000, 'ºC'),
	(326768, 146, '2015-01-15 00:24:24.000000', 'temperatura', 1092.0000, 'ºC'),
	(326769, 146, '2015-01-15 00:24:25.000000', 'temperatura', 583.0000, 'ºC'),
	(326770, 146, '2015-01-15 00:24:26.000000', 'temperatura', 840.0000, 'ºC'),
	(326771, 146, '2015-01-15 00:24:27.000000', 'temperatura', 51.0000, 'ºC'),
	(326772, 146, '2015-01-15 00:24:28.000000', 'temperatura', 138.0000, 'ºC'),
	(326773, 146, '2015-01-15 00:24:29.000000', 'temperatura', 535.0000, 'ºC'),
	(326774, 146, '2015-01-15 00:24:30.000000', 'temperatura', 1064.0000, 'ºC'),
	(326775, 146, '2015-01-15 00:24:31.000000', 'temperatura', 114.0000, 'ºC'),
	(326776, 146, '2015-01-15 00:24:32.000000', 'temperatura', 980.0000, 'ºC'),
	(326777, 146, '2015-01-15 00:24:33.000000', 'temperatura', 958.0000, 'ºC'),
	(326778, 146, '2015-01-15 00:24:34.000000', 'temperatura', 651.0000, 'ºC'),
	(326779, 146, '2015-01-15 00:24:35.000000', 'temperatura', 379.0000, 'ºC'),
	(326780, 146, '2015-01-15 00:24:36.000000', 'temperatura', 1146.0000, 'ºC'),
	(326781, 146, '2015-01-15 00:24:37.000000', 'temperatura', 990.0000, 'ºC'),
	(326782, 146, '2015-01-15 00:24:38.000000', 'temperatura', 316.0000, 'ºC'),
	(326783, 146, '2015-01-15 00:24:39.000000', 'temperatura', 1007.0000, 'ºC'),
	(326784, 146, '2015-01-15 00:24:40.000000', 'temperatura', 491.0000, 'ºC'),
	(326785, 146, '2015-01-15 00:24:41.000000', 'temperatura', 633.0000, 'ºC'),
	(326786, 146, '2015-01-15 00:24:42.000000', 'temperatura', 494.0000, 'ºC'),
	(326787, 146, '2015-01-15 00:24:43.000000', 'temperatura', 570.0000, 'ºC'),
	(326788, 146, '2015-01-15 00:24:44.000000', 'temperatura', 169.0000, 'ºC'),
	(326789, 146, '2015-01-15 00:24:45.000000', 'temperatura', 336.0000, 'ºC'),
	(326790, 146, '2015-01-15 00:24:46.000000', 'temperatura', 1174.0000, 'ºC'),
	(326791, 146, '2015-01-15 00:24:47.000000', 'temperatura', 63.0000, 'ºC'),
	(326792, 146, '2015-01-15 00:24:48.000000', 'temperatura', 395.0000, 'ºC'),
	(326793, 146, '2015-01-15 00:24:49.000000', 'temperatura', 583.0000, 'ºC'),
	(326794, 146, '2015-01-15 00:24:50.000000', 'temperatura', 533.0000, 'ºC'),
	(326795, 146, '2015-01-15 00:24:51.000000', 'temperatura', 915.0000, 'ºC'),
	(326796, 146, '2015-01-15 00:24:52.000000', 'temperatura', 576.0000, 'ºC'),
	(326797, 146, '2015-01-15 00:24:53.000000', 'temperatura', 135.0000, 'ºC'),
	(326798, 146, '2015-01-15 00:24:54.000000', 'temperatura', 146.0000, 'ºC'),
	(326799, 146, '2015-01-15 00:24:55.000000', 'temperatura', 329.0000, 'ºC'),
	(326800, 146, '2015-01-15 00:24:56.000000', 'temperatura', 5.0000, 'ºC'),
	(326801, 146, '2015-01-15 00:24:57.000000', 'temperatura', 241.0000, 'ºC'),
	(326802, 146, '2015-01-15 00:24:58.000000', 'temperatura', 1188.0000, 'ºC'),
	(326803, 146, '2015-01-15 00:24:59.000000', 'temperatura', 419.0000, 'ºC'),
	(326804, 146, '2015-01-15 00:25:00.000000', 'temperatura', 931.0000, 'ºC'),
	(326805, 146, '2015-01-15 00:25:01.000000', 'temperatura', 1001.0000, 'ºC'),
	(326806, 146, '2015-01-15 00:25:02.000000', 'temperatura', 1009.0000, 'ºC'),
	(326807, 146, '2015-01-15 00:25:03.000000', 'temperatura', 842.0000, 'ºC'),
	(326808, 146, '2015-01-15 00:25:04.000000', 'temperatura', 1186.0000, 'ºC'),
	(326809, 146, '2015-01-15 00:25:05.000000', 'temperatura', 1005.0000, 'ºC'),
	(326810, 146, '2015-01-15 00:25:06.000000', 'temperatura', 266.0000, 'ºC'),
	(326811, 146, '2015-01-15 00:25:07.000000', 'temperatura', 714.0000, 'ºC'),
	(326812, 146, '2015-01-15 00:25:08.000000', 'temperatura', 375.0000, 'ºC'),
	(326813, 146, '2015-01-15 00:25:09.000000', 'temperatura', 931.0000, 'ºC'),
	(326814, 146, '2015-01-15 00:25:10.000000', 'temperatura', 1131.0000, 'ºC'),
	(326815, 146, '2015-01-15 00:25:11.000000', 'temperatura', 462.0000, 'ºC'),
	(326816, 146, '2015-01-15 00:25:12.000000', 'temperatura', 118.0000, 'ºC'),
	(326817, 146, '2015-01-15 00:25:13.000000', 'temperatura', 404.0000, 'ºC'),
	(326818, 146, '2015-01-15 00:25:14.000000', 'temperatura', 465.0000, 'ºC'),
	(326819, 146, '2015-01-15 00:25:15.000000', 'temperatura', 1117.0000, 'ºC'),
	(326820, 146, '2015-01-15 00:25:16.000000', 'temperatura', 588.0000, 'ºC'),
	(326821, 146, '2015-01-15 00:25:17.000000', 'temperatura', 789.0000, 'ºC'),
	(326822, 146, '2015-01-15 00:25:18.000000', 'temperatura', 982.0000, 'ºC'),
	(326823, 146, '2015-01-15 00:25:19.000000', 'temperatura', 146.0000, 'ºC'),
	(326824, 146, '2015-01-15 00:25:20.000000', 'temperatura', 182.0000, 'ºC'),
	(326825, 146, '2015-01-15 00:25:21.000000', 'temperatura', 472.0000, 'ºC'),
	(326826, 146, '2015-01-15 00:25:22.000000', 'temperatura', 617.0000, 'ºC'),
	(326827, 146, '2015-01-15 00:25:23.000000', 'temperatura', 468.0000, 'ºC'),
	(326828, 146, '2015-01-15 00:25:24.000000', 'temperatura', 491.0000, 'ºC'),
	(326829, 146, '2015-01-15 00:25:25.000000', 'temperatura', 1050.0000, 'ºC'),
	(326830, 146, '2015-01-15 00:25:26.000000', 'temperatura', 178.0000, 'ºC'),
	(326831, 146, '2015-01-15 00:25:27.000000', 'temperatura', 139.0000, 'ºC'),
	(326832, 146, '2015-01-15 00:25:28.000000', 'temperatura', 164.0000, 'ºC'),
	(326833, 146, '2015-01-15 00:25:29.000000', 'temperatura', 403.0000, 'ºC'),
	(326834, 146, '2015-01-15 00:25:30.000000', 'temperatura', 321.0000, 'ºC'),
	(326835, 146, '2015-01-15 00:25:31.000000', 'temperatura', 398.0000, 'ºC'),
	(326836, 146, '2015-01-15 00:25:32.000000', 'temperatura', 1028.0000, 'ºC'),
	(326837, 146, '2015-01-15 00:25:33.000000', 'temperatura', 345.0000, 'ºC'),
	(326838, 146, '2015-01-15 00:25:34.000000', 'temperatura', 1044.0000, 'ºC'),
	(326839, 146, '2015-01-15 00:25:35.000000', 'temperatura', 585.0000, 'ºC'),
	(326840, 146, '2015-01-15 00:25:36.000000', 'temperatura', 993.0000, 'ºC'),
	(326841, 146, '2015-01-15 00:25:37.000000', 'temperatura', 810.0000, 'ºC'),
	(326842, 146, '2015-01-15 00:25:38.000000', 'temperatura', 1074.0000, 'ºC'),
	(326843, 146, '2015-01-15 00:25:39.000000', 'temperatura', 538.0000, 'ºC'),
	(326844, 146, '2015-01-15 00:25:40.000000', 'temperatura', 670.0000, 'ºC'),
	(326845, 146, '2015-01-15 00:25:41.000000', 'temperatura', 535.0000, 'ºC'),
	(326846, 146, '2015-01-15 00:25:42.000000', 'temperatura', 668.0000, 'ºC'),
	(326847, 146, '2015-01-15 00:25:43.000000', 'temperatura', 534.0000, 'ºC'),
	(326848, 146, '2015-01-15 00:25:44.000000', 'temperatura', 666.0000, 'ºC'),
	(326849, 146, '2015-01-15 00:25:45.000000', 'temperatura', 527.0000, 'ºC'),
	(326850, 146, '2015-01-15 00:25:46.000000', 'temperatura', 638.0000, 'ºC'),
	(326851, 146, '2015-01-15 00:25:47.000000', 'temperatura', 411.0000, 'ºC'),
	(326852, 146, '2015-01-15 00:25:48.000000', 'temperatura', 141.0000, 'ºC'),
	(326853, 146, '2015-01-15 00:25:49.000000', 'temperatura', 673.0000, 'ºC'),
	(326854, 146, '2015-01-15 00:25:50.000000', 'temperatura', 543.0000, 'ºC'),
	(326855, 146, '2015-01-15 00:25:51.000000', 'temperatura', 696.0000, 'ºC'),
	(326856, 146, '2015-01-15 00:25:52.000000', 'temperatura', 651.0000, 'ºC'),
	(326857, 146, '2015-01-15 00:25:53.000000', 'temperatura', 1167.0000, 'ºC'),
	(326858, 146, '2015-01-15 00:25:54.000000', 'temperatura', 281.0000, 'ºC'),
	(326859, 146, '2015-01-15 00:25:55.000000', 'temperatura', 307.0000, 'ºC'),
	(326860, 146, '2015-01-15 00:25:56.000000', 'temperatura', 693.0000, 'ºC'),
	(326861, 146, '2015-01-15 00:25:57.000000', 'temperatura', 142.0000, 'ºC'),
	(326862, 146, '2015-01-15 00:25:58.000000', 'temperatura', 1032.0000, 'ºC'),
	(326863, 146, '2015-01-15 00:25:59.000000', 'temperatura', 1137.0000, 'ºC'),
	(326864, 146, '2015-01-15 00:26:00.000000', 'temperatura', 186.0000, 'ºC'),
	(326865, 146, '2015-01-15 00:26:01.000000', 'temperatura', 1123.0000, 'ºC'),
	(326866, 146, '2015-01-15 00:26:02.000000', 'temperatura', 254.0000, 'ºC'),
	(326867, 146, '2015-01-15 00:26:03.000000', 'temperatura', 304.0000, 'ºC'),
	(326868, 146, '2015-01-15 00:26:04.000000', 'temperatura', 759.0000, 'ºC'),
	(326869, 146, '2015-01-15 00:26:05.000000', 'temperatura', 482.0000, 'ºC'),
	(326870, 146, '2015-01-15 00:26:06.000000', 'temperatura', 133.0000, 'ºC'),
	(326871, 146, '2015-01-15 00:26:07.000000', 'temperatura', 422.0000, 'ºC'),
	(326872, 146, '2015-01-15 00:26:08.000000', 'temperatura', 509.0000, 'ºC'),
	(326873, 146, '2015-01-15 00:26:09.000000', 'temperatura', 80.0000, 'ºC'),
	(326874, 146, '2015-01-15 00:26:10.000000', 'temperatura', 74.0000, 'ºC'),
	(326875, 146, '2015-01-15 00:26:11.000000', 'temperatura', 132.0000, 'ºC'),
	(326876, 146, '2015-01-15 00:26:12.000000', 'temperatura', 436.0000, 'ºC'),
	(326877, 146, '2015-01-15 00:26:13.000000', 'temperatura', 585.0000, 'ºC'),
	(326878, 146, '2015-01-15 00:26:14.000000', 'temperatura', 420.0000, 'ºC'),
	(326879, 146, '2015-01-15 00:26:15.000000', 'temperatura', 342.0000, 'ºC'),
	(326880, 146, '2015-01-15 00:26:16.000000', 'temperatura', 453.0000, 'ºC'),
	(326881, 146, '2015-01-15 00:26:17.000000', 'temperatura', 40.0000, 'ºC'),
	(326882, 146, '2015-01-15 00:26:18.000000', 'temperatura', 39.0000, 'ºC'),
	(326883, 146, '2015-01-15 00:26:19.000000', 'temperatura', 79.0000, 'ºC'),
	(326884, 146, '2015-01-15 00:26:20.000000', 'temperatura', 276.0000, 'ºC'),
	(326885, 146, '2015-01-15 00:26:21.000000', 'temperatura', 1143.0000, 'ºC'),
	(326886, 146, '2015-01-15 00:26:22.000000', 'temperatura', 90.0000, 'ºC'),
	(326887, 146, '2015-01-15 00:26:23.000000', 'temperatura', 619.0000, 'ºC'),
	(326888, 146, '2015-01-15 00:26:24.000000', 'temperatura', 427.0000, 'ºC'),
	(326889, 146, '2015-01-15 00:26:25.000000', 'temperatura', 277.0000, 'ºC'),
	(326890, 146, '2015-01-15 00:26:26.000000', 'temperatura', 105.0000, 'ºC'),
	(326891, 146, '2015-01-15 00:26:27.000000', 'temperatura', 894.0000, 'ºC'),
	(326892, 146, '2015-01-15 00:26:28.000000', 'temperatura', 556.0000, 'ºC'),
	(326893, 146, '2015-01-15 00:26:29.000000', 'temperatura', 100.0000, 'ºC'),
	(326894, 146, '2015-01-15 00:26:30.000000', 'temperatura', 29.0000, 'ºC'),
	(326895, 146, '2015-01-15 00:26:31.000000', 'temperatura', 1049.0000, 'ºC'),
	(326896, 146, '2015-01-15 00:26:32.000000', 'temperatura', 356.0000, 'ºC'),
	(326897, 146, '2015-01-15 00:26:33.000000', 'temperatura', 1034.0000, 'ºC'),
	(326898, 146, '2015-01-15 00:26:34.000000', 'temperatura', 502.0000, 'ºC'),
	(326899, 146, '2015-01-15 00:26:35.000000', 'temperatura', 610.0000, 'ºC'),
	(326900, 146, '2015-01-15 00:26:36.000000', 'temperatura', 343.0000, 'ºC'),
	(326901, 146, '2015-01-15 00:26:37.000000', 'temperatura', 1085.0000, 'ºC'),
	(326902, 146, '2015-01-15 00:26:38.000000', 'temperatura', 798.0000, 'ºC'),
	(326903, 146, '2015-01-15 00:26:39.000000', 'temperatura', 736.0000, 'ºC'),
	(326904, 146, '2015-01-15 00:26:40.000000', 'temperatura', 86.0000, 'ºC'),
	(326905, 146, '2015-01-15 00:26:41.000000', 'temperatura', 622.0000, 'ºC'),
	(326906, 146, '2015-01-15 00:26:42.000000', 'temperatura', 453.0000, 'ºC'),
	(326907, 146, '2015-01-15 00:26:43.000000', 'temperatura', 397.0000, 'ºC'),
	(326908, 146, '2015-01-15 00:26:44.000000', 'temperatura', 629.0000, 'ºC'),
	(326909, 146, '2015-01-15 00:26:45.000000', 'temperatura', 754.0000, 'ºC'),
	(326910, 146, '2015-01-15 00:26:46.000000', 'temperatura', 685.0000, 'ºC'),
	(326911, 146, '2015-01-15 00:26:47.000000', 'temperatura', 1162.0000, 'ºC'),
	(326912, 146, '2015-01-15 00:26:48.000000', 'temperatura', 155.0000, 'ºC'),
	(326913, 146, '2015-01-15 00:26:49.000000', 'temperatura', 889.0000, 'ºC'),
	(326914, 146, '2015-01-15 00:26:50.000000', 'temperatura', 383.0000, 'ºC'),
	(326915, 146, '2015-01-15 00:26:51.000000', 'temperatura', 447.0000, 'ºC'),
	(326916, 146, '2015-01-15 00:26:52.000000', 'temperatura', 1086.0000, 'ºC'),
	(326917, 146, '2015-01-15 00:26:53.000000', 'temperatura', 491.0000, 'ºC'),
	(326918, 146, '2015-01-15 00:26:54.000000', 'temperatura', 395.0000, 'ºC'),
	(326919, 146, '2015-01-15 00:26:55.000000', 'temperatura', 502.0000, 'ºC'),
	(326920, 146, '2015-01-15 00:26:56.000000', 'temperatura', 128.0000, 'ºC'),
	(326921, 146, '2015-01-15 00:26:57.000000', 'temperatura', 334.0000, 'ºC'),
	(326922, 146, '2015-01-15 00:26:58.000000', 'temperatura', 85.0000, 'ºC'),
	(326923, 146, '2015-01-15 00:26:59.000000', 'temperatura', 626.0000, 'ºC'),
	(326924, 146, '2015-01-15 00:27:00.000000', 'temperatura', 473.0000, 'ºC'),
	(326925, 146, '2015-01-15 00:27:01.000000', 'temperatura', 490.0000, 'ºC'),
	(326926, 146, '2015-01-15 00:27:02.000000', 'temperatura', 1030.0000, 'ºC'),
	(326927, 146, '2015-01-15 00:27:03.000000', 'temperatura', 81.0000, 'ºC'),
	(326928, 146, '2015-01-15 00:27:04.000000', 'temperatura', 917.0000, 'ºC'),
	(326929, 146, '2015-01-15 00:27:05.000000', 'temperatura', 742.0000, 'ºC'),
	(326930, 146, '2015-01-15 00:27:06.000000', 'temperatura', 961.0000, 'ºC'),
	(326931, 146, '2015-01-15 00:27:07.000000', 'temperatura', 177.0000, 'ºC'),
	(326932, 146, '2015-01-15 00:27:08.000000', 'temperatura', 405.0000, 'ºC'),
	(326933, 146, '2015-01-15 00:27:09.000000', 'temperatura', 293.0000, 'ºC'),
	(326934, 146, '2015-01-15 00:27:10.000000', 'temperatura', 250.0000, 'ºC'),
	(326935, 146, '2015-01-15 00:27:11.000000', 'temperatura', 373.0000, 'ºC'),
	(326936, 146, '2015-01-15 00:27:12.000000', 'temperatura', 1117.0000, 'ºC'),
	(326937, 146, '2015-01-15 00:27:13.000000', 'temperatura', 864.0000, 'ºC'),
	(326938, 146, '2015-01-15 00:27:14.000000', 'temperatura', 971.0000, 'ºC'),
	(326939, 146, '2015-01-15 00:27:15.000000', 'temperatura', 1063.0000, 'ºC'),
	(326940, 146, '2015-01-15 00:27:16.000000', 'temperatura', 3.0000, 'ºC'),
	(326941, 146, '2015-01-15 00:27:17.000000', 'temperatura', 427.0000, 'ºC'),
	(326942, 146, '2015-01-15 00:27:18.000000', 'temperatura', 925.0000, 'ºC'),
	(326943, 146, '2015-01-15 00:27:19.000000', 'temperatura', 943.0000, 'ºC'),
	(326944, 146, '2015-01-15 00:27:20.000000', 'temperatura', 742.0000, 'ºC'),
	(326945, 146, '2015-01-15 00:27:21.000000', 'temperatura', 883.0000, 'ºC'),
	(326946, 146, '2015-01-15 00:27:22.000000', 'temperatura', 988.0000, 'ºC'),
	(326947, 146, '2015-01-15 00:27:23.000000', 'temperatura', 1091.0000, 'ºC'),
	(326948, 146, '2015-01-15 00:27:24.000000', 'temperatura', 91.0000, 'ºC'),
	(326949, 146, '2015-01-15 00:27:25.000000', 'temperatura', 784.0000, 'ºC'),
	(326950, 146, '2015-01-15 00:27:26.000000', 'temperatura', 46.0000, 'ºC'),
	(326951, 146, '2015-01-15 00:27:27.000000', 'temperatura', 277.0000, 'ºC'),
	(326952, 146, '2015-01-15 00:27:28.000000', 'temperatura', 51.0000, 'ºC'),
	(326953, 146, '2015-01-15 00:27:29.000000', 'temperatura', 622.0000, 'ºC'),
	(326954, 146, '2015-01-15 00:27:30.000000', 'temperatura', 557.0000, 'ºC'),
	(326955, 146, '2015-01-15 00:27:31.000000', 'temperatura', 920.0000, 'ºC'),
	(326956, 146, '2015-01-15 00:27:32.000000', 'temperatura', 531.0000, 'ºC'),
	(326957, 146, '2015-01-15 00:27:33.000000', 'temperatura', 1093.0000, 'ºC'),
	(326958, 146, '2015-01-15 00:27:34.000000', 'temperatura', 274.0000, 'ºC'),
	(326959, 146, '2015-01-15 00:27:35.000000', 'temperatura', 493.0000, 'ºC'),
	(326960, 146, '2015-01-15 00:27:36.000000', 'temperatura', 443.0000, 'ºC'),
	(326961, 146, '2015-01-15 00:27:37.000000', 'temperatura', 734.0000, 'ºC'),
	(326962, 146, '2015-01-15 00:27:38.000000', 'temperatura', 1143.0000, 'ºC'),
	(326963, 146, '2015-01-15 00:27:39.000000', 'temperatura', 1112.0000, 'ºC'),
	(326964, 146, '2015-01-15 00:27:40.000000', 'temperatura', 934.0000, 'ºC'),
	(326965, 146, '2015-01-15 00:27:41.000000', 'temperatura', 134.0000, 'ºC'),
	(326966, 146, '2015-01-15 00:27:42.000000', 'temperatura', 267.0000, 'ºC'),
	(326967, 146, '2015-01-15 00:27:43.000000', 'temperatura', 934.0000, 'ºC'),
	(326968, 146, '2015-01-15 00:27:44.000000', 'temperatura', 272.0000, 'ºC'),
	(326969, 146, '2015-01-15 00:27:45.000000', 'temperatura', 956.0000, 'ºC'),
	(326970, 146, '2015-01-15 00:27:46.000000', 'temperatura', 364.0000, 'ºC'),
	(326971, 146, '2015-01-15 00:27:47.000000', 'temperatura', 153.0000, 'ºC'),
	(326972, 146, '2015-01-15 00:27:48.000000', 'temperatura', 875.0000, 'ºC'),
	(326973, 146, '2015-01-15 00:27:49.000000', 'temperatura', 315.0000, 'ºC'),
	(326974, 146, '2015-01-15 00:27:50.000000', 'temperatura', 153.0000, 'ºC'),
	(326975, 146, '2015-01-15 00:27:51.000000', 'temperatura', 1018.0000, 'ºC'),
	(326976, 146, '2015-01-15 00:27:52.000000', 'temperatura', 1033.0000, 'ºC'),
	(326977, 146, '2015-01-15 00:27:53.000000', 'temperatura', 910.0000, 'ºC'),
	(326978, 146, '2015-01-15 00:27:54.000000', 'temperatura', 251.0000, 'ºC'),
	(326979, 146, '2015-01-15 00:27:55.000000', 'temperatura', 927.0000, 'ºC'),
	(326980, 146, '2015-01-15 00:27:56.000000', 'temperatura', 281.0000, 'ºC'),
	(326981, 146, '2015-01-15 00:27:57.000000', 'temperatura', 1025.0000, 'ºC'),
	(326982, 146, '2015-01-15 00:27:58.000000', 'temperatura', 684.0000, 'ºC'),
	(326983, 146, '2015-01-15 00:27:59.000000', 'temperatura', 345.0000, 'ºC'),
	(326984, 146, '2015-01-15 00:28:00.000000', 'temperatura', 872.0000, 'ºC'),
	(326985, 146, '2015-01-15 00:28:01.000000', 'temperatura', 928.0000, 'ºC'),
	(326986, 146, '2015-01-15 00:28:02.000000', 'temperatura', 824.0000, 'ºC'),
	(326987, 146, '2015-01-15 00:28:03.000000', 'temperatura', 134.0000, 'ºC'),
	(326988, 146, '2015-01-15 00:28:04.000000', 'temperatura', 599.0000, 'ºC'),
	(326989, 146, '2015-01-15 00:28:05.000000', 'temperatura', 196.0000, 'ºC'),
	(326990, 146, '2015-01-15 00:28:06.000000', 'temperatura', 383.0000, 'ºC'),
	(326991, 146, '2015-01-15 00:28:07.000000', 'temperatura', 127.0000, 'ºC'),
	(326992, 146, '2015-01-15 00:28:08.000000', 'temperatura', 687.0000, 'ºC'),
	(326993, 146, '2015-01-15 00:28:09.000000', 'temperatura', 655.0000, 'ºC'),
	(326994, 146, '2015-01-15 00:28:10.000000', 'temperatura', 13.0000, 'ºC'),
	(326995, 146, '2015-01-15 00:28:11.000000', 'temperatura', 500.0000, 'ºC'),
	(326996, 146, '2015-01-15 00:28:12.000000', 'temperatura', 61.0000, 'ºC'),
	(326997, 146, '2015-01-15 00:28:13.000000', 'temperatura', 6.0000, 'ºC'),
	(326998, 146, '2015-01-15 00:28:14.000000', 'temperatura', 1048.0000, 'ºC'),
	(326999, 146, '2015-01-15 00:28:15.000000', 'temperatura', 420.0000, 'ºC'),
	(327000, 146, '2015-01-15 00:28:16.000000', 'temperatura', 160.0000, 'ºC'),
	(327001, 146, '2015-01-15 00:28:17.000000', 'temperatura', 738.0000, 'ºC'),
	(327002, 146, '2015-01-15 00:28:18.000000', 'temperatura', 810.0000, 'ºC'),
	(327003, 146, '2015-01-15 00:28:19.000000', 'temperatura', 637.0000, 'ºC'),
	(327004, 146, '2015-01-15 00:28:20.000000', 'temperatura', 755.0000, 'ºC'),
	(327005, 146, '2015-01-15 00:28:21.000000', 'temperatura', 666.0000, 'ºC'),
	(327006, 146, '2015-01-15 00:28:22.000000', 'temperatura', 1064.0000, 'ºC'),
	(327007, 146, '2015-01-15 00:28:23.000000', 'temperatura', 924.0000, 'ºC'),
	(327008, 146, '2015-01-15 00:28:24.000000', 'temperatura', 227.0000, 'ºC'),
	(327009, 146, '2015-01-15 00:28:25.000000', 'temperatura', 764.0000, 'ºC'),
	(327010, 146, '2015-01-15 00:28:26.000000', 'temperatura', 739.0000, 'ºC'),
	(327011, 146, '2015-01-15 00:28:27.000000', 'temperatura', 204.0000, 'ºC'),
	(327012, 146, '2015-01-15 00:28:28.000000', 'temperatura', 2.0000, 'ºC'),
	(327013, 146, '2015-01-15 00:28:29.000000', 'temperatura', 598.0000, 'ºC'),
	(327014, 146, '2015-01-15 00:28:30.000000', 'temperatura', 585.0000, 'ºC'),
	(327015, 146, '2015-01-15 00:28:31.000000', 'temperatura', 1131.0000, 'ºC'),
	(327016, 146, '2015-01-15 00:28:32.000000', 'temperatura', 302.0000, 'ºC'),
	(327017, 146, '2015-01-15 00:28:33.000000', 'temperatura', 515.0000, 'ºC'),
	(327018, 146, '2015-01-15 00:28:34.000000', 'temperatura', 471.0000, 'ºC'),
	(327019, 146, '2015-01-15 00:28:35.000000', 'temperatura', 811.0000, 'ºC'),
	(327020, 146, '2015-01-15 00:28:36.000000', 'temperatura', 243.0000, 'ºC'),
	(327021, 146, '2015-01-15 00:28:37.000000', 'temperatura', 1181.0000, 'ºC'),
	(327022, 146, '2015-01-15 00:28:38.000000', 'temperatura', 376.0000, 'ºC'),
	(327023, 146, '2015-01-15 00:28:39.000000', 'temperatura', 739.0000, 'ºC'),
	(327024, 146, '2015-01-15 00:28:40.000000', 'temperatura', 168.0000, 'ºC'),
	(327025, 146, '2015-01-15 00:28:41.000000', 'temperatura', 1023.0000, 'ºC'),
	(327026, 146, '2015-01-15 00:28:42.000000', 'temperatura', 1010.0000, 'ºC'),
	(327027, 146, '2015-01-15 00:28:43.000000', 'temperatura', 783.0000, 'ºC'),
	(327028, 146, '2015-01-15 00:28:44.000000', 'temperatura', 887.0000, 'ºC'),
	(327029, 146, '2015-01-15 00:28:45.000000', 'temperatura', 884.0000, 'ºC'),
	(327030, 146, '2015-01-15 00:28:46.000000', 'temperatura', 561.0000, 'ºC'),
	(327031, 146, '2015-01-15 00:28:47.000000', 'temperatura', 155.0000, 'ºC'),
	(327032, 146, '2015-01-15 00:28:48.000000', 'temperatura', 292.0000, 'ºC'),
	(327033, 146, '2015-01-15 00:28:49.000000', 'temperatura', 994.0000, 'ºC'),
	(327034, 146, '2015-01-15 00:28:50.000000', 'temperatura', 496.0000, 'ºC'),
	(327035, 146, '2015-01-15 00:28:51.000000', 'temperatura', 700.0000, 'ºC'),
	(327036, 146, '2015-01-15 00:28:52.000000', 'temperatura', 810.0000, 'ºC'),
	(327037, 146, '2015-01-15 00:28:53.000000', 'temperatura', 751.0000, 'ºC'),
	(327038, 146, '2015-01-15 00:28:54.000000', 'temperatura', 126.0000, 'ºC'),
	(327039, 146, '2015-01-15 00:28:55.000000', 'temperatura', 778.0000, 'ºC'),
	(327040, 146, '2015-01-15 00:28:56.000000', 'temperatura', 1111.0000, 'ºC'),
	(327041, 146, '2015-01-15 00:28:57.000000', 'temperatura', 822.0000, 'ºC'),
	(327042, 146, '2015-01-15 00:28:58.000000', 'temperatura', 777.0000, 'ºC'),
	(327043, 146, '2015-01-15 00:28:59.000000', 'temperatura', 218.0000, 'ºC'),
	(327044, 146, '2015-01-15 00:29:00.000000', 'temperatura', 1162.0000, 'ºC'),
	(327045, 146, '2015-01-15 00:29:01.000000', 'temperatura', 354.0000, 'ºC'),
	(327046, 146, '2015-01-15 00:29:02.000000', 'temperatura', 687.0000, 'ºC'),
	(327047, 146, '2015-01-15 00:29:03.000000', 'temperatura', 1173.0000, 'ºC'),
	(327048, 146, '2015-01-15 00:29:04.000000', 'temperatura', 204.0000, 'ºC'),
	(327049, 146, '2015-01-15 00:29:05.000000', 'temperatura', 1103.0000, 'ºC'),
	(327050, 146, '2015-01-15 00:29:06.000000', 'temperatura', 104.0000, 'ºC'),
	(327051, 146, '2015-01-15 00:29:07.000000', 'temperatura', 811.0000, 'ºC'),
	(327052, 146, '2015-01-15 00:29:08.000000', 'temperatura', 143.0000, 'ºC'),
	(327053, 146, '2015-01-15 00:29:09.000000', 'temperatura', 681.0000, 'ºC'),
	(327054, 146, '2015-01-15 00:29:10.000000', 'temperatura', 578.0000, 'ºC'),
	(327055, 146, '2015-01-15 00:29:11.000000', 'temperatura', 848.0000, 'ºC'),
	(327056, 146, '2015-01-15 00:29:12.000000', 'temperatura', 105.0000, 'ºC'),
	(327057, 146, '2015-01-15 00:29:13.000000', 'temperatura', 383.0000, 'ºC'),
	(327058, 146, '2015-01-15 00:29:14.000000', 'temperatura', 400.0000, 'ºC'),
	(327059, 146, '2015-01-15 00:29:15.000000', 'temperatura', 851.0000, 'ºC'),
	(327060, 146, '2015-01-15 00:29:16.000000', 'temperatura', 656.0000, 'ºC'),
	(327061, 146, '2015-01-15 00:29:17.000000', 'temperatura', 726.0000, 'ºC'),
	(327062, 146, '2015-01-15 00:29:18.000000', 'temperatura', 465.0000, 'ºC'),
	(327063, 146, '2015-01-15 00:29:19.000000', 'temperatura', 144.0000, 'ºC'),
	(327064, 146, '2015-01-15 00:29:20.000000', 'temperatura', 529.0000, 'ºC'),
	(327065, 146, '2015-01-15 00:29:21.000000', 'temperatura', 1013.0000, 'ºC'),
	(327066, 146, '2015-01-15 00:29:22.000000', 'temperatura', 1078.0000, 'ºC'),
	(327067, 146, '2015-01-15 00:29:23.000000', 'temperatura', 1152.0000, 'ºC'),
	(327068, 146, '2015-01-15 00:29:24.000000', 'temperatura', 124.0000, 'ºC'),
	(327069, 146, '2015-01-15 00:29:25.000000', 'temperatura', 766.0000, 'ºC'),
	(327070, 146, '2015-01-15 00:29:26.000000', 'temperatura', 1059.0000, 'ºC'),
	(327071, 146, '2015-01-15 00:29:27.000000', 'temperatura', 598.0000, 'ºC'),
	(327072, 146, '2015-01-15 00:29:28.000000', 'temperatura', 1012.0000, 'ºC'),
	(327073, 146, '2015-01-15 00:29:29.000000', 'temperatura', 868.0000, 'ºC'),
	(327074, 146, '2015-01-15 00:29:30.000000', 'temperatura', 102.0000, 'ºC'),
	(327075, 146, '2015-01-15 00:29:31.000000', 'temperatura', 308.0000, 'ºC'),
	(327076, 146, '2015-01-15 00:29:32.000000', 'temperatura', 34.0000, 'ºC'),
	(327077, 146, '2015-01-15 00:29:33.000000', 'temperatura', 446.0000, 'ºC'),
	(327078, 146, '2015-01-15 00:29:34.000000', 'temperatura', 929.0000, 'ºC'),
	(327079, 146, '2015-01-15 00:29:35.000000', 'temperatura', 907.0000, 'ºC'),
	(327080, 146, '2015-01-15 00:29:36.000000', 'temperatura', 548.0000, 'ºC'),
	(327081, 146, '2015-01-15 00:29:37.000000', 'temperatura', 22.0000, 'ºC'),
	(327082, 146, '2015-01-15 00:29:38.000000', 'temperatura', 863.0000, 'ºC'),
	(327083, 146, '2015-01-15 00:29:39.000000', 'temperatura', 653.0000, 'ºC'),
	(327084, 146, '2015-01-15 00:29:40.000000', 'temperatura', 673.0000, 'ºC'),
	(327085, 146, '2015-01-15 00:29:41.000000', 'temperatura', 210.0000, 'ºC'),
	(327086, 146, '2015-01-15 00:29:42.000000', 'temperatura', 230.0000, 'ºC'),
	(327087, 146, '2015-01-15 00:29:43.000000', 'temperatura', 519.0000, 'ºC'),
	(327088, 146, '2015-01-15 00:29:44.000000', 'temperatura', 705.0000, 'ºC'),
	(327089, 146, '2015-01-15 00:29:45.000000', 'temperatura', 768.0000, 'ºC'),
	(327090, 146, '2015-01-15 00:29:46.000000', 'temperatura', 525.0000, 'ºC'),
	(327091, 146, '2015-01-15 00:29:47.000000', 'temperatura', 325.0000, 'ºC'),
	(327092, 146, '2015-01-15 00:29:48.000000', 'temperatura', 47.0000, 'ºC'),
	(327093, 146, '2015-01-15 00:29:49.000000', 'temperatura', 461.0000, 'ºC'),
	(327094, 146, '2015-01-15 00:29:50.000000', 'temperatura', 967.0000, 'ºC'),
	(327095, 146, '2015-01-15 00:29:51.000000', 'temperatura', 1052.0000, 'ºC'),
	(327096, 146, '2015-01-15 00:29:52.000000', 'temperatura', 1158.0000, 'ºC'),
	(327097, 146, '2015-01-15 00:29:53.000000', 'temperatura', 236.0000, 'ºC'),
	(327098, 146, '2015-01-15 00:29:54.000000', 'temperatura', 108.0000, 'ºC'),
	(327099, 146, '2015-01-15 00:29:55.000000', 'temperatura', 1031.0000, 'ºC'),
	(327100, 146, '2015-01-15 00:29:56.000000', 'temperatura', 31.0000, 'ºC'),
	(327101, 146, '2015-01-15 00:29:57.000000', 'temperatura', 665.0000, 'ºC'),
	(327102, 146, '2015-01-15 00:29:58.000000', 'temperatura', 829.0000, 'ºC'),
	(327103, 146, '2015-01-15 00:29:59.000000', 'temperatura', 953.0000, 'ºC'),
	(327104, 146, '2015-01-15 00:30:00.000000', 'temperatura', 1076.0000, 'ºC'),
	(327105, 146, '2015-01-15 00:30:01.000000', 'temperatura', 122.0000, 'ºC'),
	(327106, 146, '2015-01-15 00:30:02.000000', 'temperatura', 985.0000, 'ºC'),
	(327107, 146, '2015-01-15 00:30:03.000000', 'temperatura', 958.0000, 'ºC'),
	(327108, 146, '2015-01-15 00:30:04.000000', 'temperatura', 635.0000, 'ºC'),
	(327109, 146, '2015-01-15 00:30:05.000000', 'temperatura', 300.0000, 'ºC'),
	(327110, 146, '2015-01-15 00:30:06.000000', 'temperatura', 797.0000, 'ºC'),
	(327111, 146, '2015-01-15 00:30:07.000000', 'temperatura', 687.0000, 'ºC'),
	(327112, 146, '2015-01-15 00:30:08.000000', 'temperatura', 1042.0000, 'ºC'),
	(327113, 146, '2015-01-15 00:30:09.000000', 'temperatura', 751.0000, 'ºC'),
	(327114, 146, '2015-01-15 00:30:10.000000', 'temperatura', 629.0000, 'ºC'),
	(327115, 146, '2015-01-15 00:30:11.000000', 'temperatura', 892.0000, 'ºC'),
	(327116, 146, '2015-01-15 00:30:12.000000', 'temperatura', 176.0000, 'ºC'),
	(327117, 146, '2015-01-15 00:30:13.000000', 'temperatura', 601.0000, 'ºC'),
	(327118, 146, '2015-01-15 00:30:14.000000', 'temperatura', 79.0000, 'ºC'),
	(327119, 146, '2015-01-15 00:30:15.000000', 'temperatura', 993.0000, 'ºC'),
	(327120, 146, '2015-01-15 00:30:16.000000', 'temperatura', 1128.0000, 'ºC'),
	(327121, 146, '2015-01-15 00:30:17.000000', 'temperatura', 263.0000, 'ºC'),
	(327122, 146, '2015-01-15 00:30:18.000000', 'temperatura', 329.0000, 'ºC'),
	(327123, 146, '2015-01-15 00:30:19.000000', 'temperatura', 859.0000, 'ºC'),
	(327124, 146, '2015-01-15 00:30:20.000000', 'temperatura', 908.0000, 'ºC'),
	(327125, 146, '2015-01-15 00:30:21.000000', 'temperatura', 765.0000, 'ºC'),
	(327126, 146, '2015-01-15 00:30:22.000000', 'temperatura', 1100.0000, 'ºC'),
	(327127, 146, '2015-01-15 00:30:23.000000', 'temperatura', 805.0000, 'ºC'),
	(327128, 146, '2015-01-15 00:30:24.000000', 'temperatura', 726.0000, 'ºC'),
	(327129, 146, '2015-01-15 00:30:25.000000', 'temperatura', 15.0000, 'ºC'),
	(327130, 146, '2015-01-15 00:30:26.000000', 'temperatura', 297.0000, 'ºC'),
	(327131, 146, '2015-01-15 00:30:27.000000', 'temperatura', 242.0000, 'ºC'),
	(327132, 146, '2015-01-15 00:30:28.000000', 'temperatura', 318.0000, 'ºC'),
	(327133, 146, '2015-01-15 00:30:29.000000', 'temperatura', 864.0000, 'ºC'),
	(327134, 146, '2015-01-15 00:30:30.000000', 'temperatura', 969.0000, 'ºC'),
	(327135, 146, '2015-01-15 00:30:31.000000', 'temperatura', 1052.0000, 'ºC'),
	(327136, 146, '2015-01-15 00:30:32.000000', 'temperatura', 1152.0000, 'ºC'),
	(327137, 146, '2015-01-15 00:30:33.000000', 'temperatura', 204.0000, 'ºC'),
	(327138, 146, '2015-01-15 00:30:34.000000', 'temperatura', 1167.0000, 'ºC'),
	(327139, 146, '2015-01-15 00:30:35.000000', 'temperatura', 422.0000, 'ºC'),
	(327140, 146, '2015-01-15 00:30:36.000000', 'temperatura', 1009.0000, 'ºC'),
	(327141, 146, '2015-01-15 00:30:37.000000', 'temperatura', 181.0000, 'ºC'),
	(327142, 146, '2015-01-15 00:30:38.000000', 'temperatura', 279.0000, 'ºC'),
	(327143, 146, '2015-01-15 00:30:39.000000', 'temperatura', 854.0000, 'ºC'),
	(327144, 146, '2015-01-15 00:30:40.000000', 'temperatura', 1030.0000, 'ºC'),
	(327145, 146, '2015-01-15 00:30:41.000000', 'temperatura', 189.0000, 'ºC'),
	(327146, 146, '2015-01-15 00:30:42.000000', 'temperatura', 255.0000, 'ºC'),
	(327147, 146, '2015-01-15 00:30:43.000000', 'temperatura', 711.0000, 'ºC'),
	(327148, 146, '2015-01-15 00:30:44.000000', 'temperatura', 389.0000, 'ºC'),
	(327149, 146, '2015-01-15 00:30:45.000000', 'temperatura', 1011.0000, 'ºC'),
	(327150, 146, '2015-01-15 00:30:46.000000', 'temperatura', 291.0000, 'ºC'),
	(327151, 146, '2015-01-15 00:30:47.000000', 'temperatura', 821.0000, 'ºC'),
	(327152, 146, '2015-01-15 00:30:48.000000', 'temperatura', 833.0000, 'ºC'),
	(327153, 146, '2015-01-15 00:30:49.000000', 'temperatura', 501.0000, 'ºC'),
	(327154, 146, '2015-01-15 00:30:50.000000', 'temperatura', 6.0000, 'ºC'),
	(327155, 146, '2015-01-15 00:30:51.000000', 'temperatura', 927.0000, 'ºC'),
	(327156, 146, '2015-01-15 00:30:52.000000', 'temperatura', 1020.0000, 'ºC'),
	(327157, 146, '2015-01-15 00:30:53.000000', 'temperatura', 1117.0000, 'ºC'),
	(327158, 146, '2015-01-15 00:30:54.000000', 'temperatura', 128.0000, 'ºC'),
	(327159, 146, '2015-01-15 00:30:55.000000', 'temperatura', 889.0000, 'ºC'),
	(327160, 146, '2015-01-15 00:30:56.000000', 'temperatura', 463.0000, 'ºC'),
	(327161, 146, '2015-01-15 00:30:57.000000', 'temperatura', 846.0000, 'ºC'),
	(327162, 146, '2015-01-15 00:30:58.000000', 'temperatura', 443.0000, 'ºC'),
	(327163, 146, '2015-01-15 00:30:59.000000', 'temperatura', 879.0000, 'ºC'),
	(327164, 146, '2015-01-15 00:31:00.000000', 'temperatura', 663.0000, 'ºC'),
	(327165, 146, '2015-01-15 00:31:01.000000', 'temperatura', 680.0000, 'ºC'),
	(327166, 146, '2015-01-15 00:31:02.000000', 'temperatura', 213.0000, 'ºC'),
	(327167, 146, '2015-01-15 00:31:03.000000', 'temperatura', 223.0000, 'ºC'),
	(327168, 146, '2015-01-15 00:31:04.000000', 'temperatura', 478.0000, 'ºC'),
	(327169, 146, '2015-01-15 00:31:05.000000', 'temperatura', 521.0000, 'ºC'),
	(327170, 146, '2015-01-15 00:31:06.000000', 'temperatura', 1173.0000, 'ºC'),
	(327171, 146, '2015-01-15 00:31:07.000000', 'temperatura', 704.0000, 'ºC'),
	(327172, 146, '2015-01-15 00:31:08.000000', 'temperatura', 1198.0000, 'ºC'),
	(327173, 146, '2015-01-15 00:31:09.000000', 'temperatura', 279.0000, 'ºC'),
	(327174, 146, '2015-01-15 00:31:10.000000', 'temperatura', 204.0000, 'ºC'),
	(327175, 146, '2015-01-15 00:31:11.000000', 'temperatura', 182.0000, 'ºC'),
	(327176, 146, '2015-01-15 00:31:12.000000', 'temperatura', 300.0000, 'ºC'),
	(327177, 146, '2015-01-15 00:31:13.000000', 'temperatura', 953.0000, 'ºC'),
	(327178, 146, '2015-01-15 00:31:14.000000', 'temperatura', 265.0000, 'ºC'),
	(327179, 146, '2015-01-15 00:31:15.000000', 'temperatura', 869.0000, 'ºC'),
	(327180, 146, '2015-01-15 00:31:16.000000', 'temperatura', 1150.0000, 'ºC'),
	(327181, 146, '2015-01-15 00:31:17.000000', 'temperatura', 741.0000, 'ºC'),
	(327182, 146, '2015-01-15 00:31:18.000000', 'temperatura', 258.0000, 'ºC'),
	(327183, 146, '2015-01-15 00:31:19.000000', 'temperatura', 269.0000, 'ºC'),
	(327184, 146, '2015-01-15 00:31:20.000000', 'temperatura', 568.0000, 'ºC'),
	(327185, 146, '2015-01-15 00:31:21.000000', 'temperatura', 834.0000, 'ºC'),
	(327186, 146, '2015-01-15 00:31:22.000000', 'temperatura', 68.0000, 'ºC'),
	(327187, 146, '2015-01-15 00:31:23.000000', 'temperatura', 238.0000, 'ºC'),
	(327188, 146, '2015-01-15 00:31:24.000000', 'temperatura', 987.0000, 'ºC'),
	(327189, 146, '2015-01-15 00:31:25.000000', 'temperatura', 622.0000, 'ºC'),
	(327190, 146, '2015-01-15 00:31:26.000000', 'temperatura', 147.0000, 'ºC'),
	(327191, 146, '2015-01-15 00:31:27.000000', 'temperatura', 72.0000, 'ºC'),
	(327192, 146, '2015-01-15 00:31:28.000000', 'temperatura', 1117.0000, 'ºC'),
	(327193, 146, '2015-01-15 00:31:29.000000', 'temperatura', 571.0000, 'ºC'),
	(327194, 146, '2015-01-15 00:31:30.000000', 'temperatura', 704.0000, 'ºC'),
	(327195, 146, '2015-01-15 00:31:31.000000', 'temperatura', 610.0000, 'ºC'),
	(327196, 146, '2015-01-15 00:31:32.000000', 'temperatura', 936.0000, 'ºC'),
	(327197, 146, '2015-01-15 00:31:33.000000', 'temperatura', 451.0000, 'ºC'),
	(327198, 146, '2015-01-15 00:31:34.000000', 'temperatura', 648.0000, 'ºC'),
	(327199, 146, '2015-01-15 00:31:35.000000', 'temperatura', 688.0000, 'ºC'),
	(327200, 146, '2015-01-15 00:31:36.000000', 'temperatura', 296.0000, 'ºC'),
	(327201, 146, '2015-01-15 00:31:37.000000', 'temperatura', 616.0000, 'ºC'),
	(327202, 146, '2015-01-15 00:31:38.000000', 'temperatura', 993.0000, 'ºC'),
	(327203, 146, '2015-01-15 00:31:39.000000', 'temperatura', 720.0000, 'ºC'),
	(327204, 146, '2015-01-15 00:31:40.000000', 'temperatura', 618.0000, 'ºC'),
	(327205, 146, '2015-01-15 00:31:41.000000', 'temperatura', 930.0000, 'ºC'),
	(327206, 146, '2015-01-15 00:31:42.000000', 'temperatura', 398.0000, 'ºC'),
	(327207, 146, '2015-01-15 00:31:43.000000', 'temperatura', 398.0000, 'ºC'),
	(327208, 146, '2015-01-15 00:31:44.000000', 'temperatura', 800.0000, 'ºC'),
	(327209, 146, '2015-01-15 00:31:45.000000', 'temperatura', 403.0000, 'ºC'),
	(327210, 146, '2015-01-15 00:31:46.000000', 'temperatura', 818.0000, 'ºC'),
	(327211, 146, '2015-01-15 00:31:47.000000', 'temperatura', 480.0000, 'ºC'),
	(327212, 146, '2015-01-15 00:31:48.000000', 'temperatura', 1146.0000, 'ºC'),
	(327213, 146, '2015-01-15 00:31:49.000000', 'temperatura', 689.0000, 'ºC'),
	(327214, 146, '2015-01-15 00:31:50.000000', 'temperatura', 10.0000, 'ºC'),
	(327215, 146, '2015-01-15 00:31:51.000000', 'temperatura', 384.0000, 'ºC'),
	(327216, 146, '2015-01-15 00:31:52.000000', 'temperatura', 689.0000, 'ºC'),
	(327217, 146, '2015-01-15 00:31:53.000000', 'temperatura', 1093.0000, 'ºC'),
	(327218, 146, '2015-01-15 00:31:54.000000', 'temperatura', 1000.0000, 'ºC'),
	(327219, 146, '2015-01-15 00:31:55.000000', 'temperatura', 522.0000, 'ºC'),
	(327220, 146, '2015-01-15 00:31:56.000000', 'temperatura', 811.0000, 'ºC'),
	(327221, 146, '2015-01-15 00:31:57.000000', 'temperatura', 88.0000, 'ºC'),
	(327222, 146, '2015-01-15 00:31:58.000000', 'temperatura', 408.0000, 'ºC'),
	(327223, 146, '2015-01-15 00:31:59.000000', 'temperatura', 575.0000, 'ºC'),
	(327224, 146, '2015-01-15 00:32:00.000000', 'temperatura', 454.0000, 'ºC'),
	(327225, 146, '2015-01-15 00:32:01.000000', 'temperatura', 546.0000, 'ºC'),
	(327226, 146, '2015-01-15 00:32:02.000000', 'temperatura', 166.0000, 'ºC'),
	(327227, 146, '2015-01-15 00:32:03.000000', 'temperatura', 392.0000, 'ºC'),
	(327228, 146, '2015-01-15 00:32:04.000000', 'temperatura', 263.0000, 'ºC'),
	(327229, 146, '2015-01-15 00:32:05.000000', 'temperatura', 142.0000, 'ºC'),
	(327230, 146, '2015-01-15 00:32:06.000000', 'temperatura', 1120.0000, 'ºC'),
	(327231, 146, '2015-01-15 00:32:07.000000', 'temperatura', 373.0000, 'ºC'),
	(327232, 146, '2015-01-15 00:32:08.000000', 'temperatura', 906.0000, 'ºC'),
	(327233, 146, '2015-01-15 00:32:09.000000', 'temperatura', 1010.0000, 'ºC'),
	(327234, 146, '2015-01-15 00:32:10.000000', 'temperatura', 1134.0000, 'ºC'),
	(327235, 146, '2015-01-15 00:32:11.000000', 'temperatura', 241.0000, 'ºC'),
	(327236, 146, '2015-01-15 00:32:12.000000', 'temperatura', 202.0000, 'ºC'),
	(327237, 146, '2015-01-15 00:32:13.000000', 'temperatura', 286.0000, 'ºC'),
	(327238, 146, '2015-01-15 00:32:14.000000', 'temperatura', 827.0000, 'ºC'),
	(327239, 146, '2015-01-15 00:32:15.000000', 'temperatura', 876.0000, 'ºC'),
	(327240, 146, '2015-01-15 00:32:16.000000', 'temperatura', 701.0000, 'ºC'),
	(327241, 146, '2015-01-15 00:32:17.000000', 'temperatura', 877.0000, 'ºC'),
	(327242, 146, '2015-01-15 00:32:18.000000', 'temperatura', 1081.0000, 'ºC'),
	(327243, 146, '2015-01-15 00:32:19.000000', 'temperatura', 376.0000, 'ºC'),
	(327244, 146, '2015-01-15 00:32:20.000000', 'temperatura', 1038.0000, 'ºC'),
	(327245, 146, '2015-01-15 00:32:21.000000', 'temperatura', 463.0000, 'ºC'),
	(327246, 146, '2015-01-15 00:32:22.000000', 'temperatura', 400.0000, 'ºC'),
	(327247, 146, '2015-01-15 00:32:23.000000', 'temperatura', 612.0000, 'ºC'),
	(327248, 146, '2015-01-15 00:32:24.000000', 'temperatura', 659.0000, 'ºC'),
	(327249, 146, '2015-01-15 00:32:25.000000', 'temperatura', 260.0000, 'ºC'),
	(327250, 146, '2015-01-15 00:32:26.000000', 'temperatura', 525.0000, 'ºC'),
	(327251, 146, '2015-01-15 00:32:27.000000', 'temperatura', 646.0000, 'ºC'),
	(327252, 146, '2015-01-15 00:32:28.000000', 'temperatura', 454.0000, 'ºC'),
	(327253, 146, '2015-01-15 00:32:29.000000', 'temperatura', 334.0000, 'ºC'),
	(327254, 146, '2015-01-15 00:32:30.000000', 'temperatura', 310.0000, 'ºC'),
	(327255, 146, '2015-01-15 00:32:31.000000', 'temperatura', 545.0000, 'ºC'),
	(327256, 146, '2015-01-15 00:32:32.000000', 'temperatura', 598.0000, 'ºC'),
	(327257, 146, '2015-01-15 00:32:33.000000', 'temperatura', 154.0000, 'ºC'),
	(327258, 146, '2015-01-15 00:32:34.000000', 'temperatura', 177.0000, 'ºC'),
	(327259, 146, '2015-01-15 00:32:35.000000', 'temperatura', 424.0000, 'ºC'),
	(327260, 146, '2015-01-15 00:32:36.000000', 'temperatura', 391.0000, 'ºC'),
	(327261, 146, '2015-01-15 00:32:37.000000', 'temperatura', 681.0000, 'ºC'),
	(327262, 146, '2015-01-15 00:32:38.000000', 'temperatura', 1033.0000, 'ºC'),
	(327263, 146, '2015-01-15 00:32:39.000000', 'temperatura', 723.0000, 'ºC'),
	(327264, 146, '2015-01-15 00:32:40.000000', 'temperatura', 515.0000, 'ºC'),
	(327265, 146, '2015-01-15 00:32:41.000000', 'temperatura', 408.0000, 'ºC'),
	(327266, 146, '2015-01-15 00:32:42.000000', 'temperatura', 497.0000, 'ºC'),
	(327267, 146, '2015-01-15 00:32:43.000000', 'temperatura', 58.0000, 'ºC'),
	(327268, 146, '2015-01-15 00:32:44.000000', 'temperatura', 2.0000, 'ºC'),
	(327269, 146, '2015-01-15 00:32:45.000000', 'temperatura', 1036.0000, 'ºC'),
	(327270, 146, '2015-01-15 00:32:46.000000', 'temperatura', 376.0000, 'ºC'),
	(327271, 146, '2015-01-15 00:32:47.000000', 'temperatura', 1172.0000, 'ºC'),
	(327272, 146, '2015-01-15 00:32:48.000000', 'temperatura', 1131.0000, 'ºC'),
	(327273, 146, '2015-01-15 00:32:49.000000', 'temperatura', 942.0000, 'ºC'),
	(327274, 146, '2015-01-15 00:32:50.000000', 'temperatura', 117.0000, 'ºC'),
	(327275, 146, '2015-01-15 00:32:51.000000', 'temperatura', 159.0000, 'ºC'),
	(327276, 146, '2015-01-15 00:32:52.000000', 'temperatura', 446.0000, 'ºC'),
	(327277, 146, '2015-01-15 00:32:53.000000', 'temperatura', 553.0000, 'ºC'),
	(327278, 146, '2015-01-15 00:32:54.000000', 'temperatura', 228.0000, 'ºC'),
	(327279, 146, '2015-01-15 00:32:55.000000', 'temperatura', 682.0000, 'ºC'),
	(327280, 146, '2015-01-15 00:32:56.000000', 'temperatura', 328.0000, 'ºC'),
	(327281, 146, '2015-01-15 00:32:57.000000', 'temperatura', 791.0000, 'ºC'),
	(327282, 146, '2015-01-15 00:32:58.000000', 'temperatura', 572.0000, 'ºC'),
	(327283, 146, '2015-01-15 00:32:59.000000', 'temperatura', 488.0000, 'ºC'),
	(327284, 146, '2015-01-15 00:33:00.000000', 'temperatura', 726.0000, 'ºC'),
	(327285, 146, '2015-01-15 00:33:01.000000', 'temperatura', 965.0000, 'ºC'),
	(327286, 146, '2015-01-15 00:33:02.000000', 'temperatura', 249.0000, 'ºC'),
	(327287, 146, '2015-01-15 00:33:03.000000', 'temperatura', 750.0000, 'ºC'),
	(327288, 146, '2015-01-15 00:33:04.000000', 'temperatura', 604.0000, 'ºC'),
	(327289, 146, '2015-01-15 00:33:05.000000', 'temperatura', 772.0000, 'ºC'),
	(327290, 146, '2015-01-15 00:33:06.000000', 'temperatura', 847.0000, 'ºC'),
	(327291, 146, '2015-01-15 00:33:07.000000', 'temperatura', 720.0000, 'ºC'),
	(327292, 146, '2015-01-15 00:33:08.000000', 'temperatura', 1061.0000, 'ºC'),
	(327293, 146, '2015-01-15 00:33:09.000000', 'temperatura', 745.0000, 'ºC'),
	(327294, 146, '2015-01-15 00:33:10.000000', 'temperatura', 541.0000, 'ºC'),
	(327295, 146, '2015-01-15 00:33:11.000000', 'temperatura', 473.0000, 'ºC'),
	(327296, 146, '2015-01-15 00:33:12.000000', 'temperatura', 742.0000, 'ºC'),
	(327297, 146, '2015-01-15 00:33:13.000000', 'temperatura', 1093.0000, 'ºC'),
	(327298, 146, '2015-01-15 00:33:14.000000', 'temperatura', 838.0000, 'ºC'),
	(327299, 146, '2015-01-15 00:33:15.000000', 'temperatura', 913.0000, 'ºC'),
	(327300, 146, '2015-01-15 00:33:16.000000', 'temperatura', 850.0000, 'ºC'),
	(327301, 146, '2015-01-15 00:33:17.000000', 'temperatura', 312.0000, 'ºC'),
	(327302, 146, '2015-01-15 00:33:18.000000', 'temperatura', 210.0000, 'ºC'),
	(327303, 146, '2015-01-15 00:33:19.000000', 'temperatura', 115.0000, 'ºC'),
	(327304, 146, '2015-01-15 00:33:20.000000', 'temperatura', 1145.0000, 'ºC'),
	(327305, 146, '2015-01-15 00:33:21.000000', 'temperatura', 580.0000, 'ºC'),
	(327306, 146, '2015-01-15 00:33:22.000000', 'temperatura', 666.0000, 'ºC'),
	(327307, 146, '2015-01-15 00:33:23.000000', 'temperatura', 390.0000, 'ºC'),
	(327308, 146, '2015-01-15 00:33:24.000000', 'temperatura', 1152.0000, 'ºC'),
	(327309, 146, '2015-01-15 00:33:25.000000', 'temperatura', 993.0000, 'ºC'),
	(327310, 146, '2015-01-15 00:33:26.000000', 'temperatura', 307.0000, 'ºC'),
	(327311, 146, '2015-01-15 00:33:27.000000', 'temperatura', 956.0000, 'ºC'),
	(327312, 146, '2015-01-15 00:33:28.000000', 'temperatura', 262.0000, 'ºC'),
	(327313, 146, '2015-01-15 00:33:29.000000', 'temperatura', 842.0000, 'ºC'),
	(327314, 146, '2015-01-15 00:33:30.000000', 'temperatura', 1025.0000, 'ºC'),
	(327315, 146, '2015-01-15 00:33:31.000000', 'temperatura', 199.0000, 'ºC'),
	(327316, 146, '2015-01-15 00:33:32.000000', 'temperatura', 321.0000, 'ºC'),
	(327317, 146, '2015-01-15 00:33:33.000000', 'temperatura', 1009.0000, 'ºC'),
	(327318, 146, '2015-01-15 00:33:34.000000', 'temperatura', 482.0000, 'ºC'),
	(327319, 146, '2015-01-15 00:33:35.000000', 'temperatura', 585.0000, 'ºC'),
	(327320, 146, '2015-01-15 00:33:36.000000', 'temperatura', 280.0000, 'ºC'),
	(327321, 146, '2015-01-15 00:33:37.000000', 'temperatura', 846.0000, 'ºC'),
	(327322, 146, '2015-01-15 00:33:38.000000', 'temperatura', 990.0000, 'ºC'),
	(327323, 146, '2015-01-15 00:33:39.000000', 'temperatura', 11.0000, 'ºC'),
	(327324, 146, '2015-01-15 00:33:40.000000', 'temperatura', 687.0000, 'ºC'),
	(327325, 146, '2015-01-15 00:33:41.000000', 'temperatura', 1002.0000, 'ºC'),
	(327326, 146, '2015-01-15 00:33:42.000000', 'temperatura', 550.0000, 'ºC'),
	(327327, 146, '2015-01-15 00:33:43.000000', 'temperatura', 944.0000, 'ºC'),
	(327328, 146, '2015-01-15 00:33:44.000000', 'temperatura', 669.0000, 'ºC'),
	(327329, 146, '2015-01-15 00:33:45.000000', 'temperatura', 515.0000, 'ºC'),
	(327330, 146, '2015-01-15 00:33:46.000000', 'temperatura', 566.0000, 'ºC'),
	(327331, 146, '2015-01-15 00:33:47.000000', 'temperatura', 89.0000, 'ºC'),
	(327332, 146, '2015-01-15 00:33:48.000000', 'temperatura', 1147.0000, 'ºC'),
	(327333, 146, '2015-01-15 00:33:49.000000', 'temperatura', 667.0000, 'ºC'),
	(327334, 146, '2015-01-15 00:33:50.000000', 'temperatura', 1095.0000, 'ºC'),
	(327335, 146, '2015-01-15 00:33:51.000000', 'temperatura', 1075.0000, 'ºC'),
	(327336, 146, '2015-01-15 00:33:52.000000', 'temperatura', 892.0000, 'ºC'),
	(327337, 146, '2015-01-15 00:33:53.000000', 'temperatura', 36.0000, 'ºC'),
	(327338, 146, '2015-01-15 00:33:54.000000', 'temperatura', 1102.0000, 'ºC'),
	(327339, 146, '2015-01-15 00:33:55.000000', 'temperatura', 605.0000, 'ºC'),
	(327340, 146, '2015-01-15 00:33:56.000000', 'temperatura', 920.0000, 'ºC'),
	(327341, 146, '2015-01-15 00:33:57.000000', 'temperatura', 386.0000, 'ºC'),
	(327342, 146, '2015-01-15 00:33:58.000000', 'temperatura', 369.0000, 'ºC'),
	(327343, 146, '2015-01-15 00:33:59.000000', 'temperatura', 686.0000, 'ºC'),
	(327344, 146, '2015-01-15 00:34:00.000000', 'temperatura', 1127.0000, 'ºC'),
	(327345, 146, '2015-01-15 00:34:01.000000', 'temperatura', 1174.0000, 'ºC'),
	(327346, 146, '2015-01-15 00:34:02.000000', 'temperatura', 90.0000, 'ºC'),
	(327347, 146, '2015-01-15 00:34:03.000000', 'temperatura', 529.0000, 'ºC'),
	(327348, 146, '2015-01-15 00:34:04.000000', 'temperatura', 1176.0000, 'ºC'),
	(327349, 146, '2015-01-15 00:34:05.000000', 'temperatura', 692.0000, 'ºC'),
	(327350, 146, '2015-01-15 00:34:06.000000', 'temperatura', 1135.0000, 'ºC'),
	(327351, 146, '2015-01-15 00:34:07.000000', 'temperatura', 0.0000, 'ºC'),
	(327352, 146, '2015-01-15 00:34:08.000000', 'temperatura', 195.0000, 'ºC'),
	(327353, 146, '2015-01-15 00:34:09.000000', 'temperatura', 973.0000, 'ºC'),
	(327354, 146, '2015-01-15 00:34:10.000000', 'temperatura', 684.0000, 'ºC'),
	(327355, 146, '2015-01-15 00:34:11.000000', 'temperatura', 500.0000, 'ºC'),
	(327356, 146, '2015-01-15 00:34:12.000000', 'temperatura', 450.0000, 'ºC'),
	(327357, 146, '2015-01-15 00:34:13.000000', 'temperatura', 749.0000, 'ºC'),
	(327358, 146, '2015-01-15 00:34:14.000000', 'temperatura', 1196.0000, 'ºC'),
	(327359, 146, '2015-01-15 00:34:15.000000', 'temperatura', 133.0000, 'ºC'),
	(327360, 146, '2015-01-15 00:34:16.000000', 'temperatura', 677.0000, 'ºC'),
	(327361, 146, '2015-01-15 00:34:17.000000', 'temperatura', 586.0000, 'ºC'),
	(327362, 146, '2015-01-15 00:34:18.000000', 'temperatura', 899.0000, 'ºC'),
	(327363, 146, '2015-01-15 00:34:19.000000', 'temperatura', 337.0000, 'ºC'),
	(327364, 146, '2015-01-15 00:34:20.000000', 'temperatura', 190.0000, 'ºC'),
	(327365, 146, '2015-01-15 00:34:21.000000', 'temperatura', 1139.0000, 'ºC'),
	(327366, 146, '2015-01-15 00:34:22.000000', 'temperatura', 326.0000, 'ºC'),
	(327367, 146, '2015-01-15 00:34:23.000000', 'temperatura', 614.0000, 'ºC'),
	(327368, 146, '2015-01-15 00:34:24.000000', 'temperatura', 891.0000, 'ºC'),
	(327369, 146, '2015-01-15 00:34:25.000000', 'temperatura', 212.0000, 'ºC'),
	(327370, 146, '2015-01-15 00:34:26.000000', 'temperatura', 790.0000, 'ºC'),
	(327371, 146, '2015-01-15 00:34:27.000000', 'temperatura', 915.0000, 'ºC'),
	(327372, 146, '2015-01-15 00:34:28.000000', 'temperatura', 1005.0000, 'ºC'),
	(327373, 146, '2015-01-15 00:34:29.000000', 'temperatura', 1082.0000, 'ºC'),
	(327374, 146, '2015-01-15 00:34:30.000000', 'temperatura', 1194.0000, 'ºC'),
	(327375, 146, '2015-01-15 00:34:31.000000', 'temperatura', 324.0000, 'ºC'),
	(327376, 146, '2015-01-15 00:34:32.000000', 'temperatura', 439.0000, 'ºC'),
	(327377, 146, '2015-01-15 00:34:33.000000', 'temperatura', 24.0000, 'ºC'),
	(327378, 146, '2015-01-15 00:34:34.000000', 'temperatura', 2.0000, 'ºC'),
	(327379, 146, '2015-01-15 00:34:35.000000', 'temperatura', 1141.0000, 'ºC'),
	(327380, 146, '2015-01-15 00:34:36.000000', 'temperatura', 899.0000, 'ºC'),
	(327381, 146, '2015-01-15 00:34:37.000000', 'temperatura', 1072.0000, 'ºC'),
	(327382, 146, '2015-01-15 00:34:38.000000', 'temperatura', 263.0000, 'ºC'),
	(327383, 146, '2015-01-15 00:34:39.000000', 'temperatura', 499.0000, 'ºC'),
	(327384, 146, '2015-01-15 00:34:40.000000', 'temperatura', 506.0000, 'ºC'),
	(327385, 146, '2015-01-15 00:34:41.000000', 'temperatura', 1032.0000, 'ºC'),
	(327386, 146, '2015-01-15 00:34:42.000000', 'temperatura', 45.0000, 'ºC'),
	(327387, 146, '2015-01-15 00:34:43.000000', 'temperatura', 731.0000, 'ºC'),
	(327388, 146, '2015-01-15 00:34:44.000000', 'temperatura', 1117.0000, 'ºC'),
	(327389, 146, '2015-01-15 00:34:45.000000', 'temperatura', 996.0000, 'ºC'),
	(327390, 146, '2015-01-15 00:34:46.000000', 'temperatura', 427.0000, 'ºC'),
	(327391, 146, '2015-01-15 00:34:47.000000', 'temperatura', 347.0000, 'ºC'),
	(327392, 146, '2015-01-15 00:34:48.000000', 'temperatura', 455.0000, 'ºC'),
	(327393, 146, '2015-01-15 00:34:49.000000', 'temperatura', 37.0000, 'ºC'),
	(327394, 146, '2015-01-15 00:34:50.000000', 'temperatura', 17.0000, 'ºC'),
	(327395, 146, '2015-01-15 00:34:51.000000', 'temperatura', 1178.0000, 'ºC'),
	(327396, 146, '2015-01-15 00:34:52.000000', 'temperatura', 1038.0000, 'ºC'),
	(327397, 146, '2015-01-15 00:34:53.000000', 'temperatura', 456.0000, 'ºC'),
	(327398, 146, '2015-01-15 00:34:54.000000', 'temperatura', 367.0000, 'ºC'),
	(327399, 146, '2015-01-15 00:34:55.000000', 'temperatura', 469.0000, 'ºC'),
	(327400, 146, '2015-01-15 00:34:56.000000', 'temperatura', 44.0000, 'ºC'),
	(327401, 146, '2015-01-15 00:34:57.000000', 'temperatura', 13.0000, 'ºC'),
	(327402, 146, '2015-01-15 00:34:58.000000', 'temperatura', 1134.0000, 'ºC'),
	(327403, 146, '2015-01-15 00:34:59.000000', 'temperatura', 830.0000, 'ºC'),
	(327404, 146, '2015-01-15 00:35:00.000000', 'temperatura', 748.0000, 'ºC'),
	(327405, 146, '2015-01-15 00:35:01.000000', 'temperatura', 50.0000, 'ºC'),
	(327406, 146, '2015-01-15 00:35:02.000000', 'temperatura', 406.0000, 'ºC'),
	(327407, 146, '2015-01-15 00:35:03.000000', 'temperatura', 683.0000, 'ºC'),
	(327408, 146, '2015-01-15 00:35:04.000000', 'temperatura', 995.0000, 'ºC'),
	(327409, 146, '2015-01-15 00:35:05.000000', 'temperatura', 526.0000, 'ºC'),
	(327410, 146, '2015-01-15 00:35:06.000000', 'temperatura', 848.0000, 'ºC'),
	(327411, 146, '2015-01-15 00:35:07.000000', 'temperatura', 263.0000, 'ºC'),
	(327412, 146, '2015-01-15 00:35:08.000000', 'temperatura', 1170.0000, 'ºC'),
	(327413, 146, '2015-01-15 00:35:09.000000', 'temperatura', 261.0000, 'ºC'),
	(327414, 146, '2015-01-15 00:35:10.000000', 'temperatura', 197.0000, 'ºC'),
	(327415, 146, '2015-01-15 00:35:11.000000', 'temperatura', 204.0000, 'ºC'),
	(327416, 146, '2015-01-15 00:35:12.000000', 'temperatura', 428.0000, 'ºC'),
	(327417, 146, '2015-01-15 00:35:13.000000', 'temperatura', 327.0000, 'ºC'),
	(327418, 146, '2015-01-15 00:35:14.000000', 'temperatura', 354.0000, 'ºC'),
	(327419, 146, '2015-01-15 00:35:15.000000', 'temperatura', 787.0000, 'ºC'),
	(327420, 146, '2015-01-15 00:35:16.000000', 'temperatura', 475.0000, 'ºC'),
	(327421, 146, '2015-01-15 00:35:17.000000', 'temperatura', 14.0000, 'ºC'),
	(327422, 146, '2015-01-15 00:35:18.000000', 'temperatura', 1045.0000, 'ºC'),
	(327423, 146, '2015-01-15 00:35:19.000000', 'temperatura', 383.0000, 'ºC'),
	(327424, 146, '2015-01-15 00:35:20.000000', 'temperatura', 1180.0000, 'ºC'),
	(327425, 146, '2015-01-15 00:35:21.000000', 'temperatura', 1152.0000, 'ºC'),
	(327426, 146, '2015-01-15 00:35:22.000000', 'temperatura', 1023.0000, 'ºC'),
	(327427, 146, '2015-01-15 00:35:23.000000', 'temperatura', 457.0000, 'ºC'),
	(327428, 146, '2015-01-15 00:35:24.000000', 'temperatura', 416.0000, 'ºC'),
	(327429, 146, '2015-01-15 00:35:25.000000', 'temperatura', 709.0000, 'ºC'),
	(327430, 146, '2015-01-15 00:35:26.000000', 'temperatura', 1099.0000, 'ºC'),
	(327431, 146, '2015-01-15 00:35:27.000000', 'temperatura', 968.0000, 'ºC'),
	(327432, 146, '2015-01-15 00:35:28.000000', 'temperatura', 344.0000, 'ºC'),
	(327433, 146, '2015-01-15 00:35:29.000000', 'temperatura', 16.0000, 'ºC'),
	(327434, 146, '2015-01-15 00:35:30.000000', 'temperatura', 249.0000, 'ºC'),
	(327435, 146, '2015-01-15 00:35:31.000000', 'temperatura', 1197.0000, 'ºC'),
	(327436, 146, '2015-01-15 00:35:32.000000', 'temperatura', 437.0000, 'ºC'),
	(327437, 146, '2015-01-15 00:35:33.000000', 'temperatura', 997.0000, 'ºC'),
	(327438, 146, '2015-01-15 00:35:34.000000', 'temperatura', 75.0000, 'ºC'),
	(327439, 146, '2015-01-15 00:35:35.000000', 'temperatura', 985.0000, 'ºC'),
	(327440, 146, '2015-01-15 00:35:36.000000', 'temperatura', 1098.0000, 'ºC'),
	(327441, 146, '2015-01-15 00:35:37.000000', 'temperatura', 135.0000, 'ºC'),
	(327442, 146, '2015-01-15 00:35:38.000000', 'temperatura', 981.0000, 'ºC'),
	(327443, 146, '2015-01-15 00:35:39.000000', 'temperatura', 903.0000, 'ºC'),
	(327444, 146, '2015-01-15 00:35:40.000000', 'temperatura', 373.0000, 'ºC'),
	(327445, 146, '2015-01-15 00:35:41.000000', 'temperatura', 356.0000, 'ºC'),
	(327446, 146, '2015-01-15 00:35:42.000000', 'temperatura', 661.0000, 'ºC'),
	(327447, 146, '2015-01-15 00:35:43.000000', 'temperatura', 1040.0000, 'ºC'),
	(327448, 146, '2015-01-15 00:35:44.000000', 'temperatura', 815.0000, 'ºC'),
	(327449, 146, '2015-01-15 00:35:45.000000', 'temperatura', 955.0000, 'ºC'),
	(327450, 146, '2015-01-15 00:35:46.000000', 'temperatura', 1129.0000, 'ºC'),
	(327451, 146, '2015-01-15 00:35:47.000000', 'temperatura', 384.0000, 'ºC'),
	(327452, 146, '2015-01-15 00:35:48.000000', 'temperatura', 930.0000, 'ºC'),
	(327453, 146, '2015-01-15 00:35:49.000000', 'temperatura', 1100.0000, 'ºC'),
	(327454, 146, '2015-01-15 00:35:50.000000', 'temperatura', 312.0000, 'ºC'),
	(327455, 146, '2015-01-15 00:35:51.000000', 'temperatura', 660.0000, 'ºC'),
	(327456, 146, '2015-01-15 00:35:52.000000', 'temperatura', 1163.0000, 'ºC'),
	(327457, 146, '2015-01-15 00:35:53.000000', 'temperatura', 235.0000, 'ºC'),
	(327458, 146, '2015-01-15 00:35:54.000000', 'temperatura', 89.0000, 'ºC'),
	(327459, 146, '2015-01-15 00:35:55.000000', 'temperatura', 939.0000, 'ºC'),
	(327460, 146, '2015-01-15 00:35:56.000000', 'temperatura', 830.0000, 'ºC'),
	(327461, 146, '2015-01-15 00:35:57.000000', 'temperatura', 131.0000, 'ºC'),
	(327462, 146, '2015-01-15 00:35:58.000000', 'temperatura', 568.0000, 'ºC'),
	(327463, 146, '2015-01-15 00:35:59.000000', 'temperatura', 47.0000, 'ºC'),
	(327464, 146, '2015-01-15 00:36:00.000000', 'temperatura', 931.0000, 'ºC'),
	(327465, 146, '2015-01-15 00:36:01.000000', 'temperatura', 914.0000, 'ºC'),
	(327466, 146, '2015-01-15 00:36:02.000000', 'temperatura', 577.0000, 'ºC'),
	(327467, 146, '2015-01-15 00:36:03.000000', 'temperatura', 146.0000, 'ºC'),
	(327468, 146, '2015-01-15 00:36:04.000000', 'temperatura', 198.0000, 'ºC'),
	(327469, 146, '2015-01-15 00:36:05.000000', 'temperatura', 553.0000, 'ºC'),
	(327470, 146, '2015-01-15 00:36:06.000000', 'temperatura', 970.0000, 'ºC'),
	(327471, 146, '2015-01-15 00:36:07.000000', 'temperatura', 793.0000, 'ºC'),
	(327472, 146, '2015-01-15 00:36:08.000000', 'temperatura', 1056.0000, 'ºC'),
	(327473, 146, '2015-01-15 00:36:09.000000', 'temperatura', 501.0000, 'ºC'),
	(327474, 146, '2015-01-15 00:36:10.000000', 'temperatura', 535.0000, 'ºC'),
	(327475, 146, '2015-01-15 00:36:11.000000', 'temperatura', 1175.0000, 'ºC'),
	(327476, 146, '2015-01-15 00:36:12.000000', 'temperatura', 672.0000, 'ºC'),
	(327477, 146, '2015-01-15 00:36:13.000000', 'temperatura', 1034.0000, 'ºC'),
	(327478, 146, '2015-01-15 00:36:14.000000', 'temperatura', 756.0000, 'ºC'),
	(327479, 146, '2015-01-15 00:36:15.000000', 'temperatura', 678.0000, 'ºC'),
	(327480, 146, '2015-01-15 00:36:16.000000', 'temperatura', 1121.0000, 'ºC'),
	(327481, 146, '2015-01-15 00:36:17.000000', 'temperatura', 1174.0000, 'ºC'),
	(327482, 146, '2015-01-15 00:36:18.000000', 'temperatura', 108.0000, 'ºC'),
	(327483, 146, '2015-01-15 00:36:19.000000', 'temperatura', 615.0000, 'ºC'),
	(327484, 146, '2015-01-15 00:36:20.000000', 'temperatura', 355.0000, 'ºC'),
	(327485, 146, '2015-01-15 00:36:21.000000', 'temperatura', 1129.0000, 'ºC'),
	(327486, 146, '2015-01-15 00:36:22.000000', 'temperatura', 982.0000, 'ºC'),
	(327487, 146, '2015-01-15 00:36:23.000000', 'temperatura', 323.0000, 'ºC'),
	(327488, 146, '2015-01-15 00:36:24.000000', 'temperatura', 1068.0000, 'ºC'),
	(327489, 146, '2015-01-15 00:36:25.000000', 'temperatura', 772.0000, 'ºC'),
	(327490, 146, '2015-01-15 00:36:26.000000', 'temperatura', 656.0000, 'ºC'),
	(327491, 146, '2015-01-15 00:36:27.000000', 'temperatura', 964.0000, 'ºC'),
	(327492, 146, '2015-01-15 00:36:28.000000', 'temperatura', 452.0000, 'ºC'),
	(327493, 146, '2015-01-15 00:36:29.000000', 'temperatura', 570.0000, 'ºC'),
	(327494, 146, '2015-01-15 00:36:30.000000', 'temperatura', 293.0000, 'ºC'),
	(327495, 146, '2015-01-15 00:36:31.000000', 'temperatura', 956.0000, 'ºC'),
	(327496, 146, '2015-01-15 00:36:32.000000', 'temperatura', 300.0000, 'ºC'),
	(327497, 146, '2015-01-15 00:36:33.000000', 'temperatura', 1034.0000, 'ºC'),
	(327498, 146, '2015-01-15 00:36:34.000000', 'temperatura', 669.0000, 'ºC'),
	(327499, 146, '2015-01-15 00:36:35.000000', 'temperatura', 245.0000, 'ºC'),
	(327500, 146, '2015-01-15 00:36:36.000000', 'temperatura', 417.0000, 'ºC'),
	(327501, 146, '2015-01-15 00:36:37.000000', 'temperatura', 150.0000, 'ºC'),
	(327502, 146, '2015-01-15 00:36:38.000000', 'temperatura', 700.0000, 'ºC'),
	(327503, 146, '2015-01-15 00:36:39.000000', 'temperatura', 652.0000, 'ºC'),
	(327504, 146, '2015-01-15 00:36:40.000000', 'temperatura', 1162.0000, 'ºC'),
	(327505, 146, '2015-01-15 00:36:41.000000', 'temperatura', 251.0000, 'ºC'),
	(327506, 146, '2015-01-15 00:36:42.000000', 'temperatura', 171.0000, 'ºC'),
	(327507, 146, '2015-01-15 00:36:43.000000', 'temperatura', 104.0000, 'ºC'),
	(327508, 146, '2015-01-15 00:36:44.000000', 'temperatura', 5.0000, 'ºC'),
	(327509, 146, '2015-01-15 00:36:45.000000', 'temperatura', 913.0000, 'ºC'),
	(327510, 146, '2015-01-15 00:36:46.000000', 'temperatura', 950.0000, 'ºC'),
	(327511, 146, '2015-01-15 00:36:47.000000', 'temperatura', 812.0000, 'ºC'),
	(327512, 146, '2015-01-15 00:36:48.000000', 'temperatura', 10.0000, 'ºC'),
	(327513, 146, '2015-01-15 00:36:49.000000', 'temperatura', 14.0000, 'ºC'),
	(327514, 146, '2015-01-15 00:36:50.000000', 'temperatura', 39.0000, 'ºC'),
	(327515, 146, '2015-01-15 00:36:51.000000', 'temperatura', 157.0000, 'ºC'),
	(327516, 146, '2015-01-15 00:36:52.000000', 'temperatura', 667.0000, 'ºC'),
	(327517, 146, '2015-01-15 00:36:53.000000', 'temperatura', 463.0000, 'ºC'),
	(327518, 146, '2015-01-15 00:36:54.000000', 'temperatura', 314.0000, 'ºC'),
	(327519, 146, '2015-01-15 00:36:55.000000', 'temperatura', 182.0000, 'ºC'),
	(327520, 146, '2015-01-15 00:36:56.000000', 'temperatura', 1168.0000, 'ºC'),
	(327521, 146, '2015-01-15 00:36:57.000000', 'temperatura', 496.0000, 'ºC'),
	(327522, 146, '2015-01-15 00:36:58.000000', 'temperatura', 178.0000, 'ºC'),
	(327523, 146, '2015-01-15 00:36:59.000000', 'temperatura', 599.0000, 'ºC'),
	(327524, 146, '2015-01-15 00:37:00.000000', 'temperatura', 63.0000, 'ºC'),
	(327525, 146, '2015-01-15 00:37:01.000000', 'temperatura', 921.0000, 'ºC'),
	(327526, 146, '2015-01-15 00:37:02.000000', 'temperatura', 813.0000, 'ºC'),
	(327527, 146, '2015-01-15 00:37:03.000000', 'temperatura', 103.0000, 'ºC'),
	(327528, 146, '2015-01-15 00:37:04.000000', 'temperatura', 475.0000, 'ºC'),
	(327529, 146, '2015-01-15 00:37:05.000000', 'temperatura', 869.0000, 'ºC'),
	(327530, 146, '2015-01-15 00:37:06.000000', 'temperatura', 518.0000, 'ºC'),
	(327531, 146, '2015-01-15 00:37:07.000000', 'temperatura', 1184.0000, 'ºC'),
	(327532, 146, '2015-01-15 00:37:08.000000', 'temperatura', 766.0000, 'ºC'),
	(327533, 146, '2015-01-15 00:37:09.000000', 'temperatura', 279.0000, 'ºC'),
	(327534, 146, '2015-01-15 00:37:10.000000', 'temperatura', 297.0000, 'ºC'),
	(327535, 146, '2015-01-15 00:37:11.000000', 'temperatura', 650.0000, 'ºC'),
	(327536, 146, '2015-01-15 00:37:12.000000', 'temperatura', 1159.0000, 'ºC'),
	(327537, 146, '2015-01-15 00:37:13.000000', 'temperatura', 246.0000, 'ºC'),
	(327538, 146, '2015-01-15 00:37:14.000000', 'temperatura', 154.0000, 'ºC'),
	(327539, 146, '2015-01-15 00:37:15.000000', 'temperatura', 33.0000, 'ºC'),
	(327540, 146, '2015-01-15 00:37:16.000000', 'temperatura', 901.0000, 'ºC'),
	(327541, 146, '2015-01-15 00:37:17.000000', 'temperatura', 806.0000, 'ºC'),
	(327542, 146, '2015-01-15 00:37:18.000000', 'temperatura', 130.0000, 'ºC'),
	(327543, 146, '2015-01-15 00:37:19.000000', 'temperatura', 631.0000, 'ºC'),
	(327544, 146, '2015-01-15 00:37:20.000000', 'temperatura', 368.0000, 'ºC'),
	(327545, 146, '2015-01-15 00:37:21.000000', 'temperatura', 1146.0000, 'ºC'),
	(327546, 146, '2015-01-15 00:37:22.000000', 'temperatura', 1025.0000, 'ºC'),
	(327547, 146, '2015-01-15 00:37:23.000000', 'temperatura', 489.0000, 'ºC'),
	(327548, 146, '2015-01-15 00:37:24.000000', 'temperatura', 572.0000, 'ºC'),
	(327549, 146, '2015-01-15 00:37:25.000000', 'temperatura', 191.0000, 'ºC'),
	(327550, 146, '2015-01-15 00:37:26.000000', 'temperatura', 439.0000, 'ºC'),
	(327551, 146, '2015-01-15 00:37:27.000000', 'temperatura', 423.0000, 'ºC'),
	(327552, 146, '2015-01-15 00:37:28.000000', 'temperatura', 800.0000, 'ºC'),
	(327553, 146, '2015-01-15 00:37:29.000000', 'temperatura', 330.0000, 'ºC'),
	(327554, 146, '2015-01-15 00:37:30.000000', 'temperatura', 450.0000, 'ºC'),
	(327555, 146, '2015-01-15 00:37:31.000000', 'temperatura', 63.0000, 'ºC'),
	(327556, 146, '2015-01-15 00:37:32.000000', 'temperatura', 165.0000, 'ºC'),
	(327557, 146, '2015-01-15 00:37:33.000000', 'temperatura', 636.0000, 'ºC'),
	(327558, 146, '2015-01-15 00:37:34.000000', 'temperatura', 286.0000, 'ºC'),
	(327559, 146, '2015-01-15 00:37:35.000000', 'temperatura', 724.0000, 'ºC'),
	(327560, 146, '2015-01-15 00:37:36.000000', 'temperatura', 362.0000, 'ºC'),
	(327561, 146, '2015-01-15 00:37:37.000000', 'temperatura', 839.0000, 'ºC'),
	(327562, 146, '2015-01-15 00:37:38.000000', 'temperatura', 707.0000, 'ºC'),
	(327563, 146, '2015-01-15 00:37:39.000000', 'temperatura', 1019.0000, 'ºC'),
	(327564, 146, '2015-01-15 00:37:40.000000', 'temperatura', 576.0000, 'ºC'),
	(327565, 146, '2015-01-15 00:37:41.000000', 'temperatura', 1023.0000, 'ºC'),
	(327566, 146, '2015-01-15 00:37:42.000000', 'temperatura', 988.0000, 'ºC'),
	(327567, 146, '2015-01-15 00:37:43.000000', 'temperatura', 672.0000, 'ºC'),
	(327568, 146, '2015-01-15 00:37:44.000000', 'temperatura', 397.0000, 'ºC'),
	(327569, 146, '2015-01-15 00:37:45.000000', 'temperatura', 1169.0000, 'ºC'),
	(327570, 146, '2015-01-15 00:37:46.000000', 'temperatura', 1056.0000, 'ºC'),
	(327571, 146, '2015-01-15 00:37:47.000000', 'temperatura', 573.0000, 'ºC'),
	(327572, 146, '2015-01-15 00:37:48.000000', 'temperatura', 898.0000, 'ºC'),
	(327573, 146, '2015-01-15 00:37:49.000000', 'temperatura', 372.0000, 'ºC'),
	(327574, 146, '2015-01-15 00:37:50.000000', 'temperatura', 367.0000, 'ºC'),
	(327575, 146, '2015-01-15 00:37:51.000000', 'temperatura', 718.0000, 'ºC'),
	(327576, 146, '2015-01-15 00:37:52.000000', 'temperatura', 91.0000, 'ºC'),
	(327577, 146, '2015-01-15 00:37:53.000000', 'temperatura', 700.0000, 'ºC'),
	(327578, 146, '2015-01-15 00:37:54.000000', 'temperatura', 827.0000, 'ºC'),
	(327579, 146, '2015-01-15 00:37:55.000000', 'temperatura', 836.0000, 'ºC'),
	(327580, 146, '2015-01-15 00:37:56.000000', 'temperatura', 502.0000, 'ºC'),
	(327581, 146, '2015-01-15 00:37:57.000000', 'temperatura', 1199.0000, 'ºC'),
	(327582, 146, '2015-01-15 00:37:58.000000', 'temperatura', 891.0000, 'ºC'),
	(327583, 146, '2015-01-15 00:37:59.000000', 'temperatura', 860.0000, 'ºC'),
	(327584, 146, '2015-01-15 00:38:00.000000', 'temperatura', 426.0000, 'ºC'),
	(327585, 146, '2015-01-15 00:38:01.000000', 'temperatura', 750.0000, 'ºC'),
	(327586, 146, '2015-01-15 00:38:02.000000', 'temperatura', 75.0000, 'ºC'),
	(327587, 146, '2015-01-15 00:38:03.000000', 'temperatura', 524.0000, 'ºC'),
	(327588, 146, '2015-01-15 00:38:04.000000', 'temperatura', 1195.0000, 'ºC'),
	(327589, 146, '2015-01-15 00:38:05.000000', 'temperatura', 804.0000, 'ºC'),
	(327590, 146, '2015-01-15 00:38:06.000000', 'temperatura', 436.0000, 'ºC'),
	(327591, 146, '2015-01-15 00:38:07.000000', 'temperatura', 970.0000, 'ºC'),
	(327592, 146, '2015-01-15 00:38:08.000000', 'temperatura', 1142.0000, 'ºC'),
	(327593, 146, '2015-01-15 00:38:09.000000', 'temperatura', 401.0000, 'ºC'),
	(327594, 146, '2015-01-15 00:38:10.000000', 'temperatura', 978.0000, 'ºC'),
	(327595, 146, '2015-01-15 00:38:11.000000', 'temperatura', 88.0000, 'ºC'),
	(327596, 146, '2015-01-15 00:38:12.000000', 'temperatura', 1108.0000, 'ºC'),
	(327597, 146, '2015-01-15 00:38:13.000000', 'temperatura', 476.0000, 'ºC'),
	(327598, 146, '2015-01-15 00:38:14.000000', 'temperatura', 255.0000, 'ºC'),
	(327599, 146, '2015-01-15 00:38:15.000000', 'temperatura', 1048.0000, 'ºC'),
	(327600, 146, '2015-01-15 00:38:16.000000', 'temperatura', 877.0000, 'ºC'),
	(327601, 146, '2015-01-15 00:38:17.000000', 'temperatura', 39.0000, 'ºC'),
	(327602, 146, '2015-01-15 00:38:18.000000', 'temperatura', 1168.0000, 'ºC'),
	(327603, 146, '2015-01-15 00:38:19.000000', 'temperatura', 920.0000, 'ºC'),
	(327604, 146, '2015-01-15 00:38:20.000000', 'temperatura', 1097.0000, 'ºC'),
	(327605, 146, '2015-01-15 00:38:21.000000', 'temperatura', 325.0000, 'ºC'),
	(327606, 146, '2015-01-15 00:38:22.000000', 'temperatura', 736.0000, 'ºC'),
	(327607, 146, '2015-01-15 00:38:23.000000', 'temperatura', 306.0000, 'ºC'),
	(327608, 146, '2015-01-15 00:38:24.000000', 'temperatura', 521.0000, 'ºC'),
	(327609, 146, '2015-01-15 00:38:25.000000', 'temperatura', 490.0000, 'ºC'),
	(327610, 146, '2015-01-15 00:38:26.000000', 'temperatura', 885.0000, 'ºC'),
	(327611, 146, '2015-01-15 00:38:27.000000', 'temperatura', 555.0000, 'ºC'),
	(327612, 146, '2015-01-15 00:38:28.000000', 'temperatura', 123.0000, 'ºC'),
	(327613, 146, '2015-01-15 00:38:29.000000', 'temperatura', 149.0000, 'ºC'),
	(327614, 146, '2015-01-15 00:38:30.000000', 'temperatura', 376.0000, 'ºC'),
	(327615, 146, '2015-01-15 00:38:31.000000', 'temperatura', 233.0000, 'ºC'),
	(327616, 146, '2015-01-15 00:38:32.000000', 'temperatura', 36.0000, 'ºC'),
	(327617, 146, '2015-01-15 00:38:33.000000', 'temperatura', 684.0000, 'ºC'),
	(327618, 146, '2015-01-15 00:38:34.000000', 'temperatura', 914.0000, 'ºC'),
	(327619, 146, '2015-01-15 00:38:35.000000', 'temperatura', 116.0000, 'ºC'),
	(327620, 146, '2015-01-15 00:38:36.000000', 'temperatura', 238.0000, 'ºC'),
	(327621, 146, '2015-01-15 00:38:37.000000', 'temperatura', 841.0000, 'ºC'),
	(327622, 146, '2015-01-15 00:38:38.000000', 'temperatura', 1094.0000, 'ºC'),
	(327623, 146, '2015-01-15 00:38:39.000000', 'temperatura', 548.0000, 'ºC'),
	(327624, 146, '2015-01-15 00:38:40.000000', 'temperatura', 656.0000, 'ºC'),
	(327625, 146, '2015-01-15 00:38:41.000000', 'temperatura', 436.0000, 'ºC'),
	(327626, 146, '2015-01-15 00:38:42.000000', 'temperatura', 215.0000, 'ºC'),
	(327627, 146, '2015-01-15 00:38:43.000000', 'temperatura', 967.0000, 'ºC'),
	(327628, 146, '2015-01-15 00:38:44.000000', 'temperatura', 591.0000, 'ºC'),
	(327629, 146, '2015-01-15 00:38:45.000000', 'temperatura', 56.0000, 'ºC'),
	(327630, 146, '2015-01-15 00:38:46.000000', 'temperatura', 904.0000, 'ºC'),
	(327631, 146, '2015-01-15 00:38:47.000000', 'temperatura', 754.0000, 'ºC'),
	(327632, 146, '2015-01-15 00:38:48.000000', 'temperatura', 1057.0000, 'ºC'),
	(327633, 146, '2015-01-15 00:38:49.000000', 'temperatura', 626.0000, 'ºC'),
	(327634, 146, '2015-01-15 00:38:50.000000', 'temperatura', 1157.0000, 'ºC'),
	(327635, 146, '2015-01-15 00:38:51.000000', 'temperatura', 307.0000, 'ºC'),
	(327636, 146, '2015-01-15 00:38:52.000000', 'temperatura', 465.0000, 'ºC'),
	(327637, 146, '2015-01-15 00:38:53.000000', 'temperatura', 204.0000, 'ºC'),
	(327638, 146, '2015-01-15 00:38:54.000000', 'temperatura', 827.0000, 'ºC'),
	(327639, 146, '2015-01-15 00:38:55.000000', 'temperatura', 1123.0000, 'ºC'),
	(327640, 146, '2015-01-15 00:38:56.000000', 'temperatura', 734.0000, 'ºC'),
	(327641, 146, '2015-01-15 00:38:57.000000', 'temperatura', 301.0000, 'ºC'),
	(327642, 146, '2015-01-15 00:38:58.000000', 'temperatura', 505.0000, 'ºC'),
	(327643, 146, '2015-01-15 00:38:59.000000', 'temperatura', 420.0000, 'ºC'),
	(327644, 146, '2015-01-15 00:39:00.000000', 'temperatura', 588.0000, 'ºC'),
	(327645, 146, '2015-01-15 00:39:01.000000', 'temperatura', 481.0000, 'ºC'),
	(327646, 146, '2015-01-15 00:39:02.000000', 'temperatura', 639.0000, 'ºC'),
	(327647, 146, '2015-01-15 00:39:03.000000', 'temperatura', 552.0000, 'ºC'),
	(327648, 146, '2015-01-15 00:39:04.000000', 'temperatura', 843.0000, 'ºC'),
	(327649, 146, '2015-01-15 00:39:05.000000', 'temperatura', 161.0000, 'ºC'),
	(327650, 146, '2015-01-15 00:39:06.000000', 'temperatura', 677.0000, 'ºC'),
	(327651, 146, '2015-01-15 00:39:07.000000', 'temperatura', 504.0000, 'ºC'),
	(327652, 146, '2015-01-15 00:39:08.000000', 'temperatura', 487.0000, 'ºC'),
	(327653, 146, '2015-01-15 00:39:09.000000', 'temperatura', 925.0000, 'ºC'),
	(327654, 146, '2015-01-15 00:39:10.000000', 'temperatura', 762.0000, 'ºC'),
	(327655, 146, '2015-01-15 00:39:11.000000', 'temperatura', 1036.0000, 'ºC'),
	(327656, 146, '2015-01-15 00:39:12.000000', 'temperatura', 496.0000, 'ºC'),
	(327657, 146, '2015-01-15 00:39:13.000000', 'temperatura', 573.0000, 'ºC'),
	(327658, 146, '2015-01-15 00:39:14.000000', 'temperatura', 175.0000, 'ºC'),
	(327659, 146, '2015-01-15 00:39:15.000000', 'temperatura', 358.0000, 'ºC'),
	(327660, 146, '2015-01-15 00:39:16.000000', 'temperatura', 64.0000, 'ºC'),
	(327661, 146, '2015-01-15 00:39:17.000000', 'temperatura', 446.0000, 'ºC'),
	(327662, 146, '2015-01-15 00:39:18.000000', 'temperatura', 839.0000, 'ºC'),
	(327663, 146, '2015-01-15 00:39:19.000000', 'temperatura', 459.0000, 'ºC'),
	(327664, 146, '2015-01-15 00:39:20.000000', 'temperatura', 976.0000, 'ºC'),
	(327665, 146, '2015-01-15 00:39:21.000000', 'temperatura', 1106.0000, 'ºC'),
	(327666, 146, '2015-01-15 00:39:22.000000', 'temperatura', 201.0000, 'ºC'),
	(327667, 146, '2015-01-15 00:39:23.000000', 'temperatura', 88.0000, 'ºC'),
	(327668, 146, '2015-01-15 00:39:24.000000', 'temperatura', 1036.0000, 'ºC'),
	(327669, 146, '2015-01-15 00:39:25.000000', 'temperatura', 118.0000, 'ºC'),
	(327670, 146, '2015-01-15 00:39:26.000000', 'temperatura', 1081.0000, 'ºC'),
	(327671, 146, '2015-01-15 00:39:27.000000', 'temperatura', 250.0000, 'ºC'),
	(327672, 146, '2015-01-15 00:39:28.000000', 'temperatura', 411.0000, 'ºC'),
	(327673, 146, '2015-01-15 00:39:29.000000', 'temperatura', 104.0000, 'ºC'),
	(327674, 146, '2015-01-15 00:39:30.000000', 'temperatura', 486.0000, 'ºC'),
	(327675, 146, '2015-01-15 00:39:31.000000', 'temperatura', 918.0000, 'ºC'),
	(327676, 146, '2015-01-15 00:39:32.000000', 'temperatura', 733.0000, 'ºC'),
	(327677, 146, '2015-01-15 00:39:33.000000', 'temperatura', 912.0000, 'ºC'),
	(327678, 146, '2015-01-15 00:39:34.000000', 'temperatura', 1160.0000, 'ºC'),
	(327679, 146, '2015-01-15 00:39:35.000000', 'temperatura', 665.0000, 'ºC'),
	(327680, 146, '2015-01-15 00:39:36.000000', 'temperatura', 1047.0000, 'ºC'),
	(327681, 146, '2015-01-15 00:39:37.000000', 'temperatura', 838.0000, 'ºC'),
	(327682, 146, '2015-01-15 00:39:38.000000', 'temperatura', 1050.0000, 'ºC'),
	(327683, 146, '2015-01-15 00:39:39.000000', 'temperatura', 337.0000, 'ºC'),
	(327684, 146, '2015-01-15 00:39:40.000000', 'temperatura', 935.0000, 'ºC'),
	(327685, 146, '2015-01-15 00:39:41.000000', 'temperatura', 67.0000, 'ºC'),
	(327686, 146, '2015-01-15 00:39:42.000000', 'temperatura', 1128.0000, 'ºC'),
	(327687, 146, '2015-01-15 00:39:43.000000', 'temperatura', 639.0000, 'ºC'),
	(327688, 146, '2015-01-15 00:39:44.000000', 'temperatura', 1013.0000, 'ºC'),
	(327689, 146, '2015-01-15 00:39:45.000000', 'temperatura', 750.0000, 'ºC'),
	(327690, 146, '2015-01-15 00:39:46.000000', 'temperatura', 711.0000, 'ºC'),
	(327691, 146, '2015-01-15 00:39:47.000000', 'temperatura', 103.0000, 'ºC'),
	(327692, 146, '2015-01-15 00:39:48.000000', 'temperatura', 784.0000, 'ºC'),
	(327693, 146, '2015-01-15 00:39:49.000000', 'temperatura', 9.0000, 'ºC'),
	(327694, 146, '2015-01-15 00:39:50.000000', 'temperatura', 96.0000, 'ºC'),
	(327695, 146, '2015-01-15 00:39:51.000000', 'temperatura', 454.0000, 'ºC'),
	(327696, 146, '2015-01-15 00:39:52.000000', 'temperatura', 784.0000, 'ºC'),
	(327697, 146, '2015-01-15 00:39:53.000000', 'temperatura', 155.0000, 'ºC'),
	(327698, 146, '2015-01-15 00:39:54.000000', 'temperatura', 826.0000, 'ºC'),
	(327699, 146, '2015-01-15 00:39:55.000000', 'temperatura', 63.0000, 'ºC'),
	(327700, 146, '2015-01-15 00:39:56.000000', 'temperatura', 238.0000, 'ºC'),
	(327701, 146, '2015-01-15 00:39:57.000000', 'temperatura', 1002.0000, 'ºC'),
	(327702, 146, '2015-01-15 00:39:58.000000', 'temperatura', 695.0000, 'ºC'),
	(327703, 146, '2015-01-15 00:39:59.000000', 'temperatura', 470.0000, 'ºC'),
	(327704, 146, '2015-01-15 00:40:00.000000', 'temperatura', 264.0000, 'ºC'),
	(327705, 146, '2015-01-15 00:40:01.000000', 'temperatura', 1111.0000, 'ºC'),
	(327706, 146, '2015-01-15 00:40:02.000000', 'temperatura', 1164.0000, 'ºC'),
	(327707, 146, '2015-01-15 00:40:03.000000', 'temperatura', 87.0000, 'ºC'),
	(327708, 146, '2015-01-15 00:40:04.000000', 'temperatura', 542.0000, 'ºC'),
	(327709, 146, '2015-01-15 00:40:05.000000', 'temperatura', 51.0000, 'ºC'),
	(327710, 146, '2015-01-15 00:40:06.000000', 'temperatura', 1029.0000, 'ºC'),
	(327711, 146, '2015-01-15 00:40:07.000000', 'temperatura', 193.0000, 'ºC'),
	(327712, 146, '2015-01-15 00:40:08.000000', 'temperatura', 278.0000, 'ºC'),
	(327713, 146, '2015-01-15 00:40:09.000000', 'temperatura', 812.0000, 'ºC'),
	(327714, 146, '2015-01-15 00:40:10.000000', 'temperatura', 827.0000, 'ºC'),
	(327715, 146, '2015-01-15 00:40:11.000000', 'temperatura', 499.0000, 'ºC'),
	(327716, 146, '2015-01-15 00:40:12.000000', 'temperatura', 14.0000, 'ºC'),
	(327717, 146, '2015-01-15 00:40:13.000000', 'temperatura', 972.0000, 'ºC'),
	(327718, 146, '2015-01-15 00:40:14.000000', 'temperatura', 20.0000, 'ºC'),
	(327719, 146, '2015-01-15 00:40:15.000000', 'temperatura', 784.0000, 'ºC'),
	(327720, 146, '2015-01-15 00:40:16.000000', 'temperatura', 259.0000, 'ºC'),
	(327721, 146, '2015-01-15 00:40:17.000000', 'temperatura', 144.0000, 'ºC'),
	(327722, 146, '2015-01-15 00:40:18.000000', 'temperatura', 1145.0000, 'ºC'),
	(327723, 146, '2015-01-15 00:40:19.000000', 'temperatura', 492.0000, 'ºC'),
	(327724, 146, '2015-01-15 00:40:20.000000', 'temperatura', 226.0000, 'ºC'),
	(327725, 146, '2015-01-15 00:40:21.000000', 'temperatura', 853.0000, 'ºC'),
	(327726, 146, '2015-01-15 00:40:22.000000', 'temperatura', 1191.0000, 'ºC'),
	(327727, 146, '2015-01-15 00:40:23.000000', 'temperatura', 994.0000, 'ºC'),
	(327728, 146, '2015-01-15 00:40:24.000000', 'temperatura', 196.0000, 'ºC'),
	(327729, 146, '2015-01-15 00:40:25.000000', 'temperatura', 401.0000, 'ºC'),
	(327730, 146, '2015-01-15 00:40:26.000000', 'temperatura', 216.0000, 'ºC'),
	(327731, 146, '2015-01-15 00:40:27.000000', 'temperatura', 1076.0000, 'ºC'),
	(327732, 146, '2015-01-15 00:40:28.000000', 'temperatura', 1135.0000, 'ºC'),
	(327733, 146, '2015-01-15 00:40:29.000000', 'temperatura', 48.0000, 'ºC'),
	(327734, 146, '2015-01-15 00:40:30.000000', 'temperatura', 435.0000, 'ºC'),
	(327735, 146, '2015-01-15 00:40:31.000000', 'temperatura', 832.0000, 'ºC'),
	(327736, 146, '2015-01-15 00:40:32.000000', 'temperatura', 455.0000, 'ºC'),
	(327737, 146, '2015-01-15 00:40:33.000000', 'temperatura', 978.0000, 'ºC'),
	(327738, 146, '2015-01-15 00:40:34.000000', 'temperatura', 1127.0000, 'ºC'),
	(327739, 146, '2015-01-15 00:40:35.000000', 'temperatura', 300.0000, 'ºC'),
	(327740, 146, '2015-01-15 00:40:36.000000', 'temperatura', 519.0000, 'ºC'),
	(327741, 146, '2015-01-15 00:40:37.000000', 'temperatura', 498.0000, 'ºC'),
	(327742, 146, '2015-01-15 00:40:38.000000', 'temperatura', 932.0000, 'ºC'),
	(327743, 146, '2015-01-15 00:40:39.000000', 'temperatura', 767.0000, 'ºC'),
	(327744, 146, '2015-01-15 00:40:40.000000', 'temperatura', 1040.0000, 'ºC'),
	(327745, 146, '2015-01-15 00:40:41.000000', 'temperatura', 500.0000, 'ºC'),
	(327746, 146, '2015-01-15 00:40:42.000000', 'temperatura', 581.0000, 'ºC'),
	(327747, 146, '2015-01-15 00:40:43.000000', 'temperatura', 204.0000, 'ºC'),
	(327748, 146, '2015-01-15 00:40:44.000000', 'temperatura', 476.0000, 'ºC'),
	(327749, 146, '2015-01-15 00:40:45.000000', 'temperatura', 571.0000, 'ºC'),
	(327750, 146, '2015-01-15 00:40:46.000000', 'temperatura', 228.0000, 'ºC'),
	(327751, 146, '2015-01-15 00:40:47.000000', 'temperatura', 625.0000, 'ºC'),
	(327752, 146, '2015-01-15 00:40:48.000000', 'temperatura', 44.0000, 'ºC'),
	(327753, 146, '2015-01-15 00:40:49.000000', 'temperatura', 746.0000, 'ºC'),
	(327754, 146, '2015-01-15 00:40:50.000000', 'temperatura', 1196.0000, 'ºC'),
	(327755, 146, '2015-01-15 00:40:51.000000', 'temperatura', 142.0000, 'ºC'),
	(327756, 146, '2015-01-15 00:40:52.000000', 'temperatura', 725.0000, 'ºC'),
	(327757, 146, '2015-01-15 00:40:53.000000', 'temperatura', 799.0000, 'ºC'),
	(327758, 146, '2015-01-15 00:40:54.000000', 'temperatura', 622.0000, 'ºC'),
	(327759, 146, '2015-01-15 00:40:55.000000', 'temperatura', 713.0000, 'ºC'),
	(327760, 146, '2015-01-15 00:40:56.000000', 'temperatura', 498.0000, 'ºC'),
	(327761, 146, '2015-01-15 00:40:57.000000', 'temperatura', 352.0000, 'ºC'),
	(327762, 146, '2015-01-15 00:40:58.000000', 'temperatura', 267.0000, 'ºC'),
	(327763, 146, '2015-01-15 00:40:59.000000', 'temperatura', 280.0000, 'ºC'),
	(327764, 146, '2015-01-15 00:41:00.000000', 'temperatura', 599.0000, 'ºC'),
	(327765, 146, '2015-01-15 00:41:01.000000', 'temperatura', 954.0000, 'ºC'),
	(327766, 146, '2015-01-15 00:41:02.000000', 'temperatura', 574.0000, 'ºC'),
	(327767, 146, '2015-01-15 00:41:03.000000', 'temperatura', 9.0000, 'ºC'),
	(327768, 146, '2015-01-15 00:41:04.000000', 'temperatura', 725.0000, 'ºC'),
	(327769, 146, '2015-01-15 00:41:05.000000', 'temperatura', 1197.0000, 'ºC'),
	(327770, 146, '2015-01-15 00:41:06.000000', 'temperatura', 210.0000, 'ºC'),
	(327771, 146, '2015-01-15 00:41:07.000000', 'temperatura', 1060.0000, 'ºC'),
	(327772, 146, '2015-01-15 00:41:08.000000', 'temperatura', 1070.0000, 'ºC'),
	(327773, 146, '2015-01-15 00:41:09.000000', 'temperatura', 970.0000, 'ºC'),
	(327774, 146, '2015-01-15 00:41:10.000000', 'temperatura', 442.0000, 'ºC'),
	(327775, 146, '2015-01-15 00:41:11.000000', 'temperatura', 498.0000, 'ºC'),
	(327776, 146, '2015-01-15 00:41:12.000000', 'temperatura', 1165.0000, 'ºC'),
	(327777, 146, '2015-01-15 00:41:13.000000', 'temperatura', 731.0000, 'ºC'),
	(327778, 146, '2015-01-15 00:41:14.000000', 'temperatura', 159.0000, 'ºC'),
	(327779, 146, '2015-01-15 00:41:15.000000', 'temperatura', 1005.0000, 'ºC'),
	(327780, 146, '2015-01-15 00:41:16.000000', 'temperatura', 948.0000, 'ºC'),
	(327781, 146, '2015-01-15 00:41:17.000000', 'temperatura', 527.0000, 'ºC'),
	(327782, 146, '2015-01-15 00:41:18.000000', 'temperatura', 989.0000, 'ºC'),
	(327783, 146, '2015-01-15 00:41:19.000000', 'temperatura', 967.0000, 'ºC'),
	(327784, 146, '2015-01-15 00:41:20.000000', 'temperatura', 669.0000, 'ºC'),
	(327785, 146, '2015-01-15 00:41:21.000000', 'temperatura', 442.0000, 'ºC'),
	(327786, 146, '2015-01-15 00:41:22.000000', 'temperatura', 206.0000, 'ºC'),
	(327787, 146, '2015-01-15 00:41:23.000000', 'temperatura', 905.0000, 'ºC'),
	(327788, 146, '2015-01-15 00:41:24.000000', 'temperatura', 308.0000, 'ºC'),
	(327789, 146, '2015-01-15 00:41:25.000000', 'temperatura', 23.0000, 'ºC'),
	(327790, 146, '2015-01-15 00:41:26.000000', 'temperatura', 393.0000, 'ºC'),
	(327791, 146, '2015-01-15 00:41:27.000000', 'temperatura', 696.0000, 'ºC'),
	(327792, 146, '2015-01-15 00:41:28.000000', 'temperatura', 1103.0000, 'ºC'),
	(327793, 146, '2015-01-15 00:41:29.000000', 'temperatura', 1028.0000, 'ºC'),
	(327794, 146, '2015-01-15 00:41:30.000000', 'temperatura', 629.0000, 'ºC'),
	(327795, 146, '2015-01-15 00:41:31.000000', 'temperatura', 61.0000, 'ºC'),
	(327796, 146, '2015-01-15 00:41:32.000000', 'temperatura', 821.0000, 'ºC'),
	(327797, 146, '2015-01-15 00:41:33.000000', 'temperatura', 320.0000, 'ºC'),
	(327798, 146, '2015-01-15 00:41:34.000000', 'temperatura', 337.0000, 'ºC'),
	(327799, 146, '2015-01-15 00:41:35.000000', 'temperatura', 726.0000, 'ºC'),
	(327800, 146, '2015-01-15 00:41:36.000000', 'temperatura', 221.0000, 'ºC'),
	(327801, 146, '2015-01-15 00:41:37.000000', 'temperatura', 126.0000, 'ºC'),
	(327802, 146, '2015-01-15 00:41:38.000000', 'temperatura', 1170.0000, 'ºC'),
	(327803, 146, '2015-01-15 00:41:39.000000', 'temperatura', 670.0000, 'ºC'),
	(327804, 146, '2015-01-15 00:41:40.000000', 'temperatura', 1042.0000, 'ºC'),
	(327805, 146, '2015-01-15 00:41:41.000000', 'temperatura', 799.0000, 'ºC'),
	(327806, 146, '2015-01-15 00:41:42.000000', 'temperatura', 870.0000, 'ºC'),
	(327807, 146, '2015-01-15 00:41:43.000000', 'temperatura', 753.0000, 'ºC'),
	(327808, 146, '2015-01-15 00:41:44.000000', 'temperatura', 1156.0000, 'ºC'),
	(327809, 146, '2015-01-15 00:41:45.000000', 'temperatura', 1123.0000, 'ºC'),
	(327810, 146, '2015-01-15 00:41:46.000000', 'temperatura', 947.0000, 'ºC'),
	(327811, 146, '2015-01-15 00:41:47.000000', 'temperatura', 167.0000, 'ºC'),
	(327812, 146, '2015-01-15 00:41:48.000000', 'temperatura', 395.0000, 'ºC'),
	(327813, 146, '2015-01-15 00:41:49.000000', 'temperatura', 272.0000, 'ºC'),
	(327814, 146, '2015-01-15 00:41:50.000000', 'temperatura', 176.0000, 'ºC'),
	(327815, 146, '2015-01-15 00:41:51.000000', 'temperatura', 66.0000, 'ºC'),
	(327816, 146, '2015-01-15 00:41:52.000000', 'temperatura', 1002.0000, 'ºC'),
	(327817, 146, '2015-01-15 00:41:53.000000', 'temperatura', 13.0000, 'ºC'),
	(327818, 146, '2015-01-15 00:41:54.000000', 'temperatura', 659.0000, 'ºC'),
	(327819, 146, '2015-01-15 00:41:55.000000', 'temperatura', 856.0000, 'ºC'),
	(327820, 146, '2015-01-15 00:41:56.000000', 'temperatura', 1105.0000, 'ºC'),
	(327821, 146, '2015-01-15 00:41:57.000000', 'temperatura', 559.0000, 'ºC'),
	(327822, 146, '2015-01-15 00:41:58.000000', 'temperatura', 677.0000, 'ºC'),
	(327823, 146, '2015-01-15 00:41:59.000000', 'temperatura', 509.0000, 'ºC'),
	(327824, 146, '2015-01-15 00:42:00.000000', 'temperatura', 516.0000, 'ºC'),
	(327825, 146, '2015-01-15 00:42:01.000000', 'temperatura', 1053.0000, 'ºC'),
	(327826, 146, '2015-01-15 00:42:02.000000', 'temperatura', 118.0000, 'ºC'),
	(327827, 146, '2015-01-15 00:42:03.000000', 'temperatura', 1030.0000, 'ºC'),
	(327828, 146, '2015-01-15 00:42:04.000000', 'temperatura', 1198.0000, 'ºC'),
	(327829, 146, '2015-01-15 00:42:05.000000', 'temperatura', 498.0000, 'ºC'),
	(327830, 146, '2015-01-15 00:42:06.000000', 'temperatura', 98.0000, 'ºC'),
	(327831, 146, '2015-01-15 00:42:07.000000', 'temperatura', 196.0000, 'ºC'),
	(327832, 146, '2015-01-15 00:42:08.000000', 'temperatura', 686.0000, 'ºC'),
	(327833, 146, '2015-01-15 00:42:09.000000', 'temperatura', 444.0000, 'ºC'),
	(327834, 146, '2015-01-15 00:42:10.000000', 'temperatura', 163.0000, 'ºC'),
	(327835, 146, '2015-01-15 00:42:11.000000', 'temperatura', 681.0000, 'ºC'),
	(327836, 146, '2015-01-15 00:42:12.000000', 'temperatura', 516.0000, 'ºC'),
	(327837, 146, '2015-01-15 00:42:13.000000', 'temperatura', 540.0000, 'ºC'),
	(327838, 146, '2015-01-15 00:42:14.000000', 'temperatura', 1150.0000, 'ºC'),
	(327839, 146, '2015-01-15 00:42:15.000000', 'temperatura', 531.0000, 'ºC'),
	(327840, 146, '2015-01-15 00:42:16.000000', 'temperatura', 405.0000, 'ºC'),
	(327841, 146, '2015-01-15 00:42:17.000000', 'temperatura', 433.0000, 'ºC'),
	(327842, 146, '2015-01-15 00:42:18.000000', 'temperatura', 950.0000, 'ºC'),
	(327843, 146, '2015-01-15 00:42:19.000000', 'temperatura', 1050.0000, 'ºC'),
	(327844, 146, '2015-01-15 00:42:20.000000', 'temperatura', 1.0000, 'ºC'),
	(327845, 146, '2015-01-15 00:42:21.000000', 'temperatura', 457.0000, 'ºC'),
	(327846, 146, '2015-01-15 00:42:22.000000', 'temperatura', 1080.0000, 'ºC'),
	(327847, 146, '2015-01-15 00:42:23.000000', 'temperatura', 433.0000, 'ºC'),
	(327848, 146, '2015-01-15 00:42:24.000000', 'temperatura', 123.0000, 'ºC'),
	(327849, 146, '2015-01-15 00:42:25.000000', 'temperatura', 519.0000, 'ºC'),
	(327850, 146, '2015-01-15 00:42:26.000000', 'temperatura', 1024.0000, 'ºC'),
	(327851, 146, '2015-01-15 00:42:27.000000', 'temperatura', 1165.0000, 'ºC'),
	(327852, 146, '2015-01-15 00:42:28.000000', 'temperatura', 355.0000, 'ºC'),
	(327853, 146, '2015-01-15 00:42:29.000000', 'temperatura', 680.0000, 'ºC'),
	(327854, 146, '2015-01-15 00:42:30.000000', 'temperatura', 1134.0000, 'ºC'),
	(327855, 146, '2015-01-15 00:42:31.000000', 'temperatura', 30.0000, 'ºC'),
	(327856, 146, '2015-01-15 00:42:32.000000', 'temperatura', 350.0000, 'ºC'),
	(327857, 146, '2015-01-15 00:42:33.000000', 'temperatura', 461.0000, 'ºC'),
	(327858, 146, '2015-01-15 00:42:34.000000', 'temperatura', 55.0000, 'ºC'),
	(327859, 146, '2015-01-15 00:42:35.000000', 'temperatura', 90.0000, 'ºC'),
	(327860, 146, '2015-01-15 00:42:36.000000', 'temperatura', 288.0000, 'ºC'),
	(327861, 146, '2015-01-15 00:42:37.000000', 'temperatura', 1172.0000, 'ºC'),
	(327862, 146, '2015-01-15 00:42:38.000000', 'temperatura', 194.0000, 'ºC'),
	(327863, 146, '2015-01-15 00:42:39.000000', 'temperatura', 1057.0000, 'ºC'),
	(327864, 146, '2015-01-15 00:42:40.000000', 'temperatura', 1101.0000, 'ºC'),
	(327865, 146, '2015-01-15 00:42:41.000000', 'temperatura', 1133.0000, 'ºC'),
	(327866, 146, '2015-01-15 00:42:42.000000', 'temperatura', 1166.0000, 'ºC'),
	(327867, 146, '2015-01-15 00:42:43.000000', 'temperatura', 29.0000, 'ºC'),
	(327868, 146, '2015-01-15 00:42:44.000000', 'temperatura', 249.0000, 'ºC'),
	(327869, 146, '2015-01-15 00:42:45.000000', 'temperatura', 1156.0000, 'ºC'),
	(327870, 146, '2015-01-15 00:42:46.000000', 'temperatura', 236.0000, 'ºC'),
	(327871, 146, '2015-01-15 00:42:47.000000', 'temperatura', 110.0000, 'ºC'),
	(327872, 146, '2015-01-15 00:42:48.000000', 'temperatura', 1043.0000, 'ºC'),
	(327873, 146, '2015-01-15 00:42:49.000000', 'temperatura', 88.0000, 'ºC'),
	(327874, 146, '2015-01-15 00:42:50.000000', 'temperatura', 909.0000, 'ºC'),
	(327875, 146, '2015-01-15 00:42:51.000000', 'temperatura', 680.0000, 'ºC'),
	(327876, 146, '2015-01-15 00:42:52.000000', 'temperatura', 676.0000, 'ºC'),
	(327877, 146, '2015-01-15 00:42:53.000000', 'temperatura', 139.0000, 'ºC'),
	(327878, 146, '2015-01-15 00:42:54.000000', 'temperatura', 1070.0000, 'ºC'),
	(327879, 146, '2015-01-15 00:42:55.000000', 'temperatura', 132.0000, 'ºC'),
	(327880, 146, '2015-01-15 00:42:56.000000', 'temperatura', 1052.0000, 'ºC'),
	(327881, 146, '2015-01-15 00:42:57.000000', 'temperatura', 62.0000, 'ºC'),
	(327882, 146, '2015-01-15 00:42:58.000000', 'temperatura', 757.0000, 'ºC'),
	(327883, 146, '2015-01-15 00:42:59.000000', 'temperatura', 1199.0000, 'ºC'),
	(327884, 146, '2015-01-15 00:43:00.000000', 'temperatura', 123.0000, 'ºC'),
	(327885, 146, '2015-01-15 00:43:01.000000', 'temperatura', 620.0000, 'ºC'),
	(327886, 146, '2015-01-15 00:43:02.000000', 'temperatura', 329.0000, 'ºC'),
	(327887, 146, '2015-01-15 00:43:03.000000', 'temperatura', 987.0000, 'ºC'),
	(327888, 146, '2015-01-15 00:43:04.000000', 'temperatura', 349.0000, 'ºC'),
	(327889, 146, '2015-01-15 00:43:05.000000', 'temperatura', 1183.0000, 'ºC'),
	(327890, 146, '2015-01-15 00:43:06.000000', 'temperatura', 69.0000, 'ºC'),
	(327891, 146, '2015-01-15 00:43:07.000000', 'temperatura', 395.0000, 'ºC'),
	(327892, 146, '2015-01-15 00:43:08.000000', 'temperatura', 571.0000, 'ºC'),
	(327893, 146, '2015-01-15 00:43:09.000000', 'temperatura', 469.0000, 'ºC'),
	(327894, 146, '2015-01-15 00:43:10.000000', 'temperatura', 631.0000, 'ºC'),
	(327895, 146, '2015-01-15 00:43:11.000000', 'temperatura', 552.0000, 'ºC'),
	(327896, 146, '2015-01-15 00:43:12.000000', 'temperatura', 865.0000, 'ºC'),
	(327897, 146, '2015-01-15 00:43:13.000000', 'temperatura', 269.0000, 'ºC'),
	(327898, 146, '2015-01-15 00:43:14.000000', 'temperatura', 1152.0000, 'ºC'),
	(327899, 146, '2015-01-15 00:43:15.000000', 'temperatura', 152.0000, 'ºC'),
	(327900, 146, '2015-01-15 00:43:16.000000', 'temperatura', 906.0000, 'ºC'),
	(327901, 146, '2015-01-15 00:43:17.000000', 'temperatura', 475.0000, 'ºC'),
	(327902, 146, '2015-01-15 00:43:18.000000', 'temperatura', 858.0000, 'ºC'),
	(327903, 146, '2015-01-15 00:43:19.000000', 'temperatura', 465.0000, 'ºC'),
	(327904, 146, '2015-01-15 00:43:20.000000', 'temperatura', 949.0000, 'ºC'),
	(327905, 146, '2015-01-15 00:43:21.000000', 'temperatura', 953.0000, 'ºC'),
	(327906, 146, '2015-01-15 00:43:22.000000', 'temperatura', 718.0000, 'ºC'),
	(327907, 146, '2015-01-15 00:43:23.000000', 'temperatura', 732.0000, 'ºC'),
	(327908, 146, '2015-01-15 00:43:24.000000', 'temperatura', 304.0000, 'ºC'),
	(327909, 146, '2015-01-15 00:43:25.000000', 'temperatura', 527.0000, 'ºC'),
	(327910, 146, '2015-01-15 00:43:26.000000', 'temperatura', 523.0000, 'ºC'),
	(327911, 146, '2015-01-15 00:43:27.000000', 'temperatura', 1034.0000, 'ºC'),
	(327912, 146, '2015-01-15 00:43:28.000000', 'temperatura', 2.0000, 'ºC'),
	(327913, 146, '2015-01-15 00:43:29.000000', 'temperatura', 510.0000, 'ºC'),
	(327914, 146, '2015-01-15 00:43:30.000000', 'temperatura', 143.0000, 'ºC'),
	(327915, 146, '2015-01-15 00:43:31.000000', 'temperatura', 387.0000, 'ºC'),
	(327916, 146, '2015-01-15 00:43:32.000000', 'temperatura', 304.0000, 'ºC'),
	(327917, 146, '2015-01-15 00:43:33.000000', 'temperatura', 362.0000, 'ºC'),
	(327918, 146, '2015-01-15 00:43:34.000000', 'temperatura', 899.0000, 'ºC'),
	(327919, 146, '2015-01-15 00:43:35.000000', 'temperatura', 1010.0000, 'ºC'),
	(327920, 146, '2015-01-15 00:43:36.000000', 'temperatura', 1154.0000, 'ºC'),
	(327921, 146, '2015-01-15 00:43:37.000000', 'temperatura', 338.0000, 'ºC'),
	(327922, 146, '2015-01-15 00:43:38.000000', 'temperatura', 631.0000, 'ºC'),
	(327923, 146, '2015-01-15 00:43:39.000000', 'temperatura', 942.0000, 'ºC'),
	(327924, 146, '2015-01-15 00:43:40.000000', 'temperatura', 417.0000, 'ºC'),
	(327925, 146, '2015-01-15 00:43:41.000000', 'temperatura', 458.0000, 'ºC'),
	(327926, 146, '2015-01-15 00:43:42.000000', 'temperatura', 1042.0000, 'ºC'),
	(327927, 146, '2015-01-15 00:43:43.000000', 'temperatura', 233.0000, 'ºC'),
	(327928, 146, '2015-01-15 00:43:44.000000', 'temperatura', 443.0000, 'ºC'),
	(327929, 146, '2015-01-15 00:43:45.000000', 'temperatura', 316.0000, 'ºC'),
	(327930, 146, '2015-01-15 00:43:46.000000', 'temperatura', 250.0000, 'ºC'),
	(327931, 146, '2015-01-15 00:43:47.000000', 'temperatura', 304.0000, 'ºC'),
	(327932, 146, '2015-01-15 00:43:48.000000', 'temperatura', 771.0000, 'ºC'),
	(327933, 146, '2015-01-15 00:43:49.000000', 'temperatura', 544.0000, 'ºC'),
	(327934, 146, '2015-01-15 00:43:50.000000', 'temperatura', 406.0000, 'ºC'),
	(327935, 146, '2015-01-15 00:43:51.000000', 'temperatura', 398.0000, 'ºC'),
	(327936, 146, '2015-01-15 00:43:52.000000', 'temperatura', 772.0000, 'ºC'),
	(327937, 146, '2015-01-15 00:43:53.000000', 'temperatura', 265.0000, 'ºC'),
	(327938, 146, '2015-01-15 00:43:54.000000', 'temperatura', 212.0000, 'ºC'),
	(327939, 146, '2015-01-15 00:43:55.000000', 'temperatura', 266.0000, 'ºC'),
	(327940, 146, '2015-01-15 00:43:56.000000', 'temperatura', 692.0000, 'ºC'),
	(327941, 146, '2015-01-15 00:43:57.000000', 'temperatura', 265.0000, 'ºC'),
	(327942, 146, '2015-01-15 00:43:58.000000', 'temperatura', 449.0000, 'ºC'),
	(327943, 146, '2015-01-15 00:43:59.000000', 'temperatura', 250.0000, 'ºC'),
	(327944, 146, '2015-01-15 00:44:00.000000', 'temperatura', 1105.0000, 'ºC'),
	(327945, 146, '2015-01-15 00:44:01.000000', 'temperatura', 1175.0000, 'ºC'),
	(327946, 146, '2015-01-15 00:44:02.000000', 'temperatura', 162.0000, 'ºC'),
	(327947, 146, '2015-01-15 00:44:03.000000', 'temperatura', 885.0000, 'ºC'),
	(327948, 146, '2015-01-15 00:44:04.000000', 'temperatura', 340.0000, 'ºC'),
	(327949, 146, '2015-01-15 00:44:05.000000', 'temperatura', 246.0000, 'ºC'),
	(327950, 146, '2015-01-15 00:44:06.000000', 'temperatura', 208.0000, 'ºC'),
	(327951, 146, '2015-01-15 00:44:07.000000', 'temperatura', 304.0000, 'ºC'),
	(327952, 146, '2015-01-15 00:44:08.000000', 'temperatura', 898.0000, 'ºC'),
	(327953, 146, '2015-01-15 00:44:09.000000', 'temperatura', 1177.0000, 'ºC'),
	(327954, 146, '2015-01-15 00:44:10.000000', 'temperatura', 790.0000, 'ºC'),
	(327955, 146, '2015-01-15 00:44:11.000000', 'temperatura', 421.0000, 'ºC'),
	(327956, 146, '2015-01-15 00:44:12.000000', 'temperatura', 934.0000, 'ºC'),
	(327957, 146, '2015-01-15 00:44:13.000000', 'temperatura', 1007.0000, 'ºC'),
	(327958, 146, '2015-01-15 00:44:14.000000', 'temperatura', 1034.0000, 'ºC'),
	(327959, 146, '2015-01-15 00:44:15.000000', 'temperatura', 948.0000, 'ºC'),
	(327960, 146, '2015-01-15 00:44:16.000000', 'temperatura', 440.0000, 'ºC'),
	(327961, 146, '2015-01-15 00:44:17.000000', 'temperatura', 554.0000, 'ºC'),
	(327962, 146, '2015-01-15 00:44:18.000000', 'temperatura', 254.0000, 'ºC'),
	(327963, 146, '2015-01-15 00:44:19.000000', 'temperatura', 808.0000, 'ºC'),
	(327964, 146, '2015-01-15 00:44:20.000000', 'temperatura', 877.0000, 'ºC'),
	(327965, 146, '2015-01-15 00:44:21.000000', 'temperatura', 763.0000, 'ºC'),
	(327966, 146, '2015-01-15 00:44:22.000000', 'temperatura', 1186.0000, 'ºC'),
	(327967, 146, '2015-01-15 00:44:23.000000', 'temperatura', 39.0000, 'ºC'),
	(327968, 146, '2015-01-15 00:44:24.000000', 'temperatura', 237.0000, 'ºC'),
	(327969, 146, '2015-01-15 00:44:25.000000', 'temperatura', 1070.0000, 'ºC'),
	(327970, 146, '2015-01-15 00:44:26.000000', 'temperatura', 1038.0000, 'ºC'),
	(327971, 146, '2015-01-15 00:44:27.000000', 'temperatura', 782.0000, 'ºC'),
	(327972, 146, '2015-01-15 00:44:28.000000', 'temperatura', 794.0000, 'ºC'),
	(327973, 146, '2015-01-15 00:44:29.000000', 'temperatura', 426.0000, 'ºC'),
	(327974, 146, '2015-01-15 00:44:30.000000', 'temperatura', 950.0000, 'ºC'),
	(327975, 146, '2015-01-15 00:44:31.000000', 'temperatura', 1073.0000, 'ºC'),
	(327976, 146, '2015-01-15 00:44:32.000000', 'temperatura', 112.0000, 'ºC'),
	(327977, 146, '2015-01-15 00:44:33.000000', 'temperatura', 945.0000, 'ºC'),
	(327978, 146, '2015-01-15 00:44:34.000000', 'temperatura', 787.0000, 'ºC'),
	(327979, 146, '2015-01-15 00:44:35.000000', 'temperatura', 1100.0000, 'ºC'),
	(327980, 146, '2015-01-15 00:44:36.000000', 'temperatura', 740.0000, 'ºC'),
	(327981, 146, '2015-01-15 00:44:37.000000', 'temperatura', 399.0000, 'ºC'),
	(327982, 146, '2015-01-15 00:44:38.000000', 'temperatura', 977.0000, 'ºC'),
	(327983, 146, '2015-01-15 00:44:39.000000', 'temperatura', 87.0000, 'ºC'),
	(327984, 146, '2015-01-15 00:44:40.000000', 'temperatura', 1106.0000, 'ºC'),
	(327985, 146, '2015-01-15 00:44:41.000000', 'temperatura', 469.0000, 'ºC'),
	(327986, 146, '2015-01-15 00:44:42.000000', 'temperatura', 227.0000, 'ºC'),
	(327987, 146, '2015-01-15 00:44:43.000000', 'temperatura', 929.0000, 'ºC'),
	(327988, 146, '2015-01-15 00:44:44.000000', 'temperatura', 366.0000, 'ºC'),
	(327989, 146, '2015-01-15 00:44:45.000000', 'temperatura', 243.0000, 'ºC'),
	(327990, 146, '2015-01-15 00:44:46.000000', 'temperatura', 116.0000, 'ºC'),
	(327991, 146, '2015-01-15 00:44:47.000000', 'temperatura', 1054.0000, 'ºC'),
	(327992, 146, '2015-01-15 00:44:48.000000', 'temperatura', 121.0000, 'ºC'),
	(327993, 146, '2015-01-15 00:44:49.000000', 'temperatura', 1046.0000, 'ºC'),
	(327994, 146, '2015-01-15 00:44:50.000000', 'temperatura', 65.0000, 'ºC'),
	(327995, 146, '2015-01-15 00:44:51.000000', 'temperatura', 789.0000, 'ºC'),
	(327996, 146, '2015-01-15 00:44:52.000000', 'temperatura', 149.0000, 'ºC'),
	(327997, 146, '2015-01-15 00:44:53.000000', 'temperatura', 779.0000, 'ºC'),
	(327998, 146, '2015-01-15 00:44:54.000000', 'temperatura', 1050.0000, 'ºC'),
	(327999, 146, '2015-01-15 00:44:55.000000', 'temperatura', 513.0000, 'ºC'),
	(328000, 146, '2015-01-15 00:44:56.000000', 'temperatura', 614.0000, 'ºC'),
	(328001, 146, '2015-01-15 00:44:57.000000', 'temperatura', 333.0000, 'ºC'),
	(328002, 146, '2015-01-15 00:44:58.000000', 'temperatura', 1022.0000, 'ºC'),
	(328003, 146, '2015-01-15 00:44:59.000000', 'temperatura', 514.0000, 'ºC'),
	(328004, 146, '2015-01-15 00:45:00.000000', 'temperatura', 703.0000, 'ºC'),
	(328005, 146, '2015-01-15 00:45:01.000000', 'temperatura', 775.0000, 'ºC'),
	(328006, 146, '2015-01-15 00:45:02.000000', 'temperatura', 567.0000, 'ºC'),
	(328007, 146, '2015-01-15 00:45:03.000000', 'temperatura', 510.0000, 'ºC'),
	(328008, 146, '2015-01-15 00:45:04.000000', 'temperatura', 851.0000, 'ºC'),
	(328009, 146, '2015-01-15 00:45:05.000000', 'temperatura', 324.0000, 'ºC'),
	(328010, 146, '2015-01-15 00:45:06.000000', 'temperatura', 266.0000, 'ºC'),
	(328011, 146, '2015-01-15 00:45:07.000000', 'temperatura', 358.0000, 'ºC'),
	(328012, 146, '2015-01-15 00:45:08.000000', 'temperatura', 995.0000, 'ºC'),
	(328013, 146, '2015-01-15 00:45:09.000000', 'temperatura', 299.0000, 'ºC'),
	(328014, 146, '2015-01-15 00:45:10.000000', 'temperatura', 913.0000, 'ºC'),
	(328015, 146, '2015-01-15 00:45:11.000000', 'temperatura', 66.0000, 'ºC'),
	(328016, 146, '2015-01-15 00:45:12.000000', 'temperatura', 1191.0000, 'ºC'),
	(328017, 146, '2015-01-15 00:45:13.000000', 'temperatura', 960.0000, 'ºC'),
	(328018, 146, '2015-01-15 00:45:14.000000', 'temperatura', 27.0000, 'ºC'),
	(328019, 146, '2015-01-15 00:45:15.000000', 'temperatura', 856.0000, 'ºC'),
	(328020, 146, '2015-01-15 00:45:16.000000', 'temperatura', 598.0000, 'ºC'),
	(328021, 146, '2015-01-15 00:45:17.000000', 'temperatura', 424.0000, 'ºC'),
	(328022, 146, '2015-01-15 00:45:18.000000', 'temperatura', 324.0000, 'ºC'),
	(328023, 146, '2015-01-15 00:45:19.000000', 'temperatura', 350.0000, 'ºC'),
	(328024, 146, '2015-01-15 00:45:20.000000', 'temperatura', 777.0000, 'ºC'),
	(328025, 146, '2015-01-15 00:45:21.000000', 'temperatura', 435.0000, 'ºC'),
	(328026, 146, '2015-01-15 00:45:22.000000', 'temperatura', 1045.0000, 'ºC'),
	(328027, 146, '2015-01-15 00:45:23.000000', 'temperatura', 322.0000, 'ºC'),
	(328028, 146, '2015-01-15 00:45:24.000000', 'temperatura', 873.0000, 'ºC'),
	(328029, 146, '2015-01-15 00:45:25.000000', 'temperatura', 1000.0000, 'ºC'),
	(328030, 146, '2015-01-15 00:45:26.000000', 'temperatura', 1182.0000, 'ºC'),
	(328031, 146, '2015-01-15 00:45:27.000000', 'temperatura', 510.0000, 'ºC'),
	(328032, 146, '2015-01-15 00:45:28.000000', 'temperatura', 205.0000, 'ºC'),
	(328033, 146, '2015-01-15 00:45:29.000000', 'temperatura', 695.0000, 'ºC'),
	(328034, 146, '2015-01-15 00:45:30.000000', 'temperatura', 460.0000, 'ºC'),
	(328035, 146, '2015-01-15 00:45:31.000000', 'temperatura', 218.0000, 'ºC'),
	(328036, 146, '2015-01-15 00:45:32.000000', 'temperatura', 908.0000, 'ºC'),
	(328037, 146, '2015-01-15 00:45:33.000000', 'temperatura', 287.0000, 'ºC'),
	(328038, 146, '2015-01-15 00:45:34.000000', 'temperatura', 1113.0000, 'ºC'),
	(328039, 146, '2015-01-15 00:45:35.000000', 'temperatura', 1104.0000, 'ºC'),
	(328040, 146, '2015-01-15 00:45:36.000000', 'temperatura', 982.0000, 'ºC'),
	(328041, 146, '2015-01-15 00:45:37.000000', 'temperatura', 397.0000, 'ºC'),
	(328042, 146, '2015-01-15 00:45:38.000000', 'temperatura', 239.0000, 'ºC'),
	(328043, 146, '2015-01-15 00:45:39.000000', 'temperatura', 5.0000, 'ºC'),
	(328044, 146, '2015-01-15 00:45:40.000000', 'temperatura', 508.0000, 'ºC'),
	(328045, 146, '2015-01-15 00:45:41.000000', 'temperatura', 124.0000, 'ºC'),
	(328046, 146, '2015-01-15 00:45:42.000000', 'temperatura', 300.0000, 'ºC'),
	(328047, 146, '2015-01-15 00:45:43.000000', 'temperatura', 1126.0000, 'ºC'),
	(328048, 146, '2015-01-15 00:45:44.000000', 'temperatura', 1130.0000, 'ºC'),
	(328049, 146, '2015-01-15 00:45:45.000000', 'temperatura', 1074.0000, 'ºC'),
	(328050, 146, '2015-01-15 00:45:46.000000', 'temperatura', 781.0000, 'ºC'),
	(328051, 146, '2015-01-15 00:45:47.000000', 'temperatura', 684.0000, 'ºC'),
	(328052, 146, '2015-01-15 00:45:48.000000', 'temperatura', 1078.0000, 'ºC'),
	(328053, 146, '2015-01-15 00:45:49.000000', 'temperatura', 937.0000, 'ºC'),
	(328054, 146, '2015-01-15 00:45:50.000000', 'temperatura', 253.0000, 'ºC'),
	(328055, 146, '2015-01-15 00:45:51.000000', 'temperatura', 852.0000, 'ºC'),
	(328056, 146, '2015-01-15 00:45:52.000000', 'temperatura', 1105.0000, 'ºC'),
	(328057, 146, '2015-01-15 00:45:53.000000', 'temperatura', 567.0000, 'ºC'),
	(328058, 146, '2015-01-15 00:45:54.000000', 'temperatura', 720.0000, 'ºC'),
	(328059, 146, '2015-01-15 00:45:55.000000', 'temperatura', 700.0000, 'ºC'),
	(328060, 146, '2015-01-15 00:45:56.000000', 'temperatura', 142.0000, 'ºC'),
	(328061, 146, '2015-01-15 00:45:57.000000', 'temperatura', 1008.0000, 'ºC'),
	(328062, 146, '2015-01-15 00:45:58.000000', 'temperatura', 1014.0000, 'ºC'),
	(328063, 146, '2015-01-15 00:45:59.000000', 'temperatura', 848.0000, 'ºC'),
	(328064, 146, '2015-01-15 00:46:00.000000', 'temperatura', 1199.0000, 'ºC'),
	(328065, 146, '2015-01-15 00:46:01.000000', 'temperatura', 1053.0000, 'ºC'),
	(328066, 146, '2015-01-15 00:46:02.000000', 'temperatura', 465.0000, 'ºC'),
	(328067, 146, '2015-01-15 00:46:03.000000', 'temperatura', 369.0000, 'ºC'),
	(328068, 146, '2015-01-15 00:46:04.000000', 'temperatura', 449.0000, 'ºC'),
	(328069, 146, '2015-01-15 00:46:05.000000', 'temperatura', 1139.0000, 'ºC'),
	(328070, 146, '2015-01-15 00:46:06.000000', 'temperatura', 747.0000, 'ºC'),
	(328071, 146, '2015-01-15 00:46:07.000000', 'temperatura', 321.0000, 'ºC'),
	(328072, 146, '2015-01-15 00:46:08.000000', 'temperatura', 562.0000, 'ºC'),
	(328073, 146, '2015-01-15 00:46:09.000000', 'temperatura', 648.0000, 'ºC'),
	(328074, 146, '2015-01-15 00:46:10.000000', 'temperatura', 356.0000, 'ºC'),
	(328075, 146, '2015-01-15 00:46:11.000000', 'temperatura', 1038.0000, 'ºC'),
	(328076, 146, '2015-01-15 00:46:12.000000', 'temperatura', 520.0000, 'ºC'),
	(328077, 146, '2015-01-15 00:46:13.000000', 'temperatura', 686.0000, 'ºC'),
	(328078, 146, '2015-01-15 00:46:14.000000', 'temperatura', 673.0000, 'ºC'),
	(328079, 146, '2015-01-15 00:46:15.000000', 'temperatura', 108.0000, 'ºC'),
	(328080, 146, '2015-01-15 00:46:16.000000', 'temperatura', 921.0000, 'ºC'),
	(328081, 146, '2015-01-15 00:46:17.000000', 'temperatura', 681.0000, 'ºC'),
	(328082, 146, '2015-01-15 00:46:18.000000', 'temperatura', 644.0000, 'ºC'),
	(328083, 146, '2015-01-15 00:46:19.000000', 'temperatura', 1178.0000, 'ºC'),
	(328084, 146, '2015-01-15 00:46:20.000000', 'temperatura', 358.0000, 'ºC'),
	(328085, 146, '2015-01-15 00:46:21.000000', 'temperatura', 656.0000, 'ºC'),
	(328086, 146, '2015-01-15 00:46:22.000000', 'temperatura', 1007.0000, 'ºC'),
	(328087, 146, '2015-01-15 00:46:23.000000', 'temperatura', 666.0000, 'ºC'),
	(328088, 146, '2015-01-15 00:46:24.000000', 'temperatura', 308.0000, 'ºC'),
	(328089, 146, '2015-01-15 00:46:25.000000', 'temperatura', 746.0000, 'ºC'),
	(328090, 146, '2015-01-15 00:46:26.000000', 'temperatura', 405.0000, 'ºC'),
	(328091, 146, '2015-01-15 00:46:27.000000', 'temperatura', 988.0000, 'ºC'),
	(328092, 146, '2015-01-15 00:46:28.000000', 'temperatura', 127.0000, 'ºC'),
	(328093, 146, '2015-01-15 00:46:29.000000', 'temperatura', 70.0000, 'ºC'),
	(328094, 146, '2015-01-15 00:46:30.000000', 'temperatura', 1170.0000, 'ºC'),
	(328095, 146, '2015-01-15 00:46:31.000000', 'temperatura', 841.0000, 'ºC'),
	(328096, 146, '2015-01-15 00:46:32.000000', 'temperatura', 694.0000, 'ºC'),
	(328097, 146, '2015-01-15 00:46:33.000000', 'temperatura', 947.0000, 'ºC'),
	(328098, 146, '2015-01-15 00:46:34.000000', 'temperatura', 253.0000, 'ºC'),
	(328099, 146, '2015-01-15 00:46:35.000000', 'temperatura', 823.0000, 'ºC'),
	(328100, 146, '2015-01-15 00:46:36.000000', 'temperatura', 960.0000, 'ºC'),
	(328101, 146, '2015-01-15 00:46:37.000000', 'temperatura', 1131.0000, 'ºC'),
	(328102, 146, '2015-01-15 00:46:38.000000', 'temperatura', 375.0000, 'ºC'),
	(328103, 146, '2015-01-15 00:46:39.000000', 'temperatura', 881.0000, 'ºC'),
	(328104, 146, '2015-01-15 00:46:40.000000', 'temperatura', 882.0000, 'ºC'),
	(328105, 146, '2015-01-15 00:46:41.000000', 'temperatura', 569.0000, 'ºC'),
	(328106, 146, '2015-01-15 00:46:42.000000', 'temperatura', 198.0000, 'ºC'),
	(328107, 146, '2015-01-15 00:46:43.000000', 'temperatura', 485.0000, 'ºC'),
	(328108, 146, '2015-01-15 00:46:44.000000', 'temperatura', 629.0000, 'ºC'),
	(328109, 146, '2015-01-15 00:46:45.000000', 'temperatura', 490.0000, 'ºC'),
	(328110, 146, '2015-01-15 00:46:46.000000', 'temperatura', 564.0000, 'ºC'),
	(328111, 146, '2015-01-15 00:46:47.000000', 'temperatura', 152.0000, 'ºC'),
	(328112, 146, '2015-01-15 00:46:48.000000', 'temperatura', 269.0000, 'ºC'),
	(328113, 146, '2015-01-15 00:46:49.000000', 'temperatura', 890.0000, 'ºC'),
	(328114, 146, '2015-01-15 00:46:50.000000', 'temperatura', 42.0000, 'ºC'),
	(328115, 146, '2015-01-15 00:46:51.000000', 'temperatura', 1143.0000, 'ºC'),
	(328116, 146, '2015-01-15 00:46:52.000000', 'temperatura', 788.0000, 'ºC'),
	(328117, 146, '2015-01-15 00:46:53.000000', 'temperatura', 511.0000, 'ºC'),
	(328118, 146, '2015-01-15 00:46:54.000000', 'temperatura', 192.0000, 'ºC'),
	(328119, 146, '2015-01-15 00:46:55.000000', 'temperatura', 627.0000, 'ºC'),
	(328120, 146, '2015-01-15 00:46:56.000000', 'temperatura', 160.0000, 'ºC'),
	(328121, 146, '2015-01-15 00:46:57.000000', 'temperatura', 118.0000, 'ºC'),
	(328122, 146, '2015-01-15 00:46:58.000000', 'temperatura', 112.0000, 'ºC'),
	(328123, 146, '2015-01-15 00:46:59.000000', 'temperatura', 205.0000, 'ºC'),
	(328124, 146, '2015-01-15 00:47:00.000000', 'temperatura', 691.0000, 'ºC'),
	(328125, 146, '2015-01-15 00:47:01.000000', 'temperatura', 442.0000, 'ºC'),
	(328126, 146, '2015-01-15 00:47:02.000000', 'temperatura', 134.0000, 'ºC'),
	(328127, 146, '2015-01-15 00:47:03.000000', 'temperatura', 548.0000, 'ºC'),
	(328128, 146, '2015-01-15 00:47:04.000000', 'temperatura', 1136.0000, 'ºC'),
	(328129, 146, '2015-01-15 00:47:05.000000', 'temperatura', 436.0000, 'ºC'),
	(328130, 146, '2015-01-15 00:47:06.000000', 'temperatura', 1174.0000, 'ºC'),
	(328131, 146, '2015-01-15 00:47:07.000000', 'temperatura', 960.0000, 'ºC'),
	(328132, 146, '2015-01-15 00:47:08.000000', 'temperatura', 82.0000, 'ºC'),
	(328133, 146, '2015-01-15 00:47:09.000000', 'temperatura', 1128.0000, 'ºC'),
	(328134, 146, '2015-01-15 00:47:10.000000', 'temperatura', 595.0000, 'ºC'),
	(328135, 146, '2015-01-15 00:47:11.000000', 'temperatura', 793.0000, 'ºC'),
	(328136, 146, '2015-01-15 00:47:12.000000', 'temperatura', 978.0000, 'ºC'),
	(328137, 146, '2015-01-15 00:47:13.000000', 'temperatura', 114.0000, 'ºC'),
	(328138, 146, '2015-01-15 00:47:14.000000', 'temperatura', 37.0000, 'ºC'),
	(328139, 146, '2015-01-15 00:47:15.000000', 'temperatura', 1042.0000, 'ºC'),
	(328140, 146, '2015-01-15 00:47:16.000000', 'temperatura', 302.0000, 'ºC'),
	(328141, 146, '2015-01-15 00:47:17.000000', 'temperatura', 782.0000, 'ºC'),
	(328142, 146, '2015-01-15 00:47:18.000000', 'temperatura', 605.0000, 'ºC'),
	(328143, 146, '2015-01-15 00:47:19.000000', 'temperatura', 681.0000, 'ºC'),
	(328144, 146, '2015-01-15 00:47:20.000000', 'temperatura', 390.0000, 'ºC'),
	(328145, 146, '2015-01-15 00:47:21.000000', 'temperatura', 1108.0000, 'ºC'),
	(328146, 146, '2015-01-15 00:47:22.000000', 'temperatura', 772.0000, 'ºC'),
	(328147, 146, '2015-01-15 00:47:23.000000', 'temperatura', 534.0000, 'ºC'),
	(328148, 146, '2015-01-15 00:47:24.000000', 'temperatura', 357.0000, 'ºC'),
	(328149, 146, '2015-01-15 00:47:25.000000', 'temperatura', 181.0000, 'ºC'),
	(328150, 146, '2015-01-15 00:47:26.000000', 'temperatura', 1034.0000, 'ºC'),
	(328151, 146, '2015-01-15 00:47:27.000000', 'temperatura', 1028.0000, 'ºC'),
	(328152, 146, '2015-01-15 00:47:28.000000', 'temperatura', 838.0000, 'ºC'),
	(328153, 146, '2015-01-15 00:47:29.000000', 'temperatura', 1106.0000, 'ºC'),
	(328154, 146, '2015-01-15 00:47:30.000000', 'temperatura', 615.0000, 'ºC'),
	(328155, 146, '2015-01-15 00:47:31.000000', 'temperatura', 961.0000, 'ºC'),
	(328156, 146, '2015-01-15 00:47:32.000000', 'temperatura', 558.0000, 'ºC'),
	(328157, 146, '2015-01-15 00:47:33.000000', 'temperatura', 1109.0000, 'ºC'),
	(328158, 146, '2015-01-15 00:47:34.000000', 'temperatura', 270.0000, 'ºC'),
	(328159, 146, '2015-01-15 00:47:35.000000', 'temperatura', 426.0000, 'ºC'),
	(328160, 146, '2015-01-15 00:47:36.000000', 'temperatura', 118.0000, 'ºC'),
	(328161, 146, '2015-01-15 00:47:37.000000', 'temperatura', 514.0000, 'ºC'),
	(328162, 146, '2015-01-15 00:47:38.000000', 'temperatura', 1014.0000, 'ºC'),
	(328163, 146, '2015-01-15 00:47:39.000000', 'temperatura', 1131.0000, 'ºC'),
	(328164, 146, '2015-01-15 00:47:40.000000', 'temperatura', 212.0000, 'ºC'),
	(328165, 146, '2015-01-15 00:47:41.000000', 'temperatura', 67.0000, 'ºC'),
	(328166, 146, '2015-01-15 00:47:42.000000', 'temperatura', 901.0000, 'ºC'),
	(328167, 146, '2015-01-15 00:47:43.000000', 'temperatura', 702.0000, 'ºC'),
	(328168, 146, '2015-01-15 00:47:44.000000', 'temperatura', 810.0000, 'ºC'),
	(328169, 146, '2015-01-15 00:47:45.000000', 'temperatura', 742.0000, 'ºC'),
	(328170, 146, '2015-01-15 00:47:46.000000', 'temperatura', 84.0000, 'ºC'),
	(328171, 146, '2015-01-15 00:47:47.000000', 'temperatura', 592.0000, 'ºC'),
	(328172, 146, '2015-01-15 00:47:48.000000', 'temperatura', 309.0000, 'ºC'),
	(328173, 146, '2015-01-15 00:47:49.000000', 'temperatura', 970.0000, 'ºC'),
	(328174, 146, '2015-01-15 00:47:50.000000', 'temperatura', 324.0000, 'ºC'),
	(328175, 146, '2015-01-15 00:47:51.000000', 'temperatura', 1112.0000, 'ºC'),
	(328176, 146, '2015-01-15 00:47:52.000000', 'temperatura', 985.0000, 'ºC'),
	(328177, 146, '2015-01-15 00:47:53.000000', 'temperatura', 392.0000, 'ºC'),
	(328178, 146, '2015-01-15 00:47:54.000000', 'temperatura', 206.0000, 'ºC'),
	(328179, 146, '2015-01-15 00:47:55.000000', 'temperatura', 1052.0000, 'ºC'),
	(328180, 146, '2015-01-15 00:47:56.000000', 'temperatura', 1045.0000, 'ºC'),
	(328181, 146, '2015-01-15 00:47:57.000000', 'temperatura', 869.0000, 'ºC'),
	(328182, 146, '2015-01-15 00:47:58.000000', 'temperatura', 11.0000, 'ºC'),
	(328183, 146, '2015-01-15 00:47:59.000000', 'temperatura', 1048.0000, 'ºC'),
	(328184, 146, '2015-01-15 00:48:00.000000', 'temperatura', 407.0000, 'ºC'),
	(328185, 146, '2015-01-15 00:48:01.000000', 'temperatura', 93.0000, 'ºC'),
	(328186, 146, '2015-01-15 00:48:02.000000', 'temperatura', 443.0000, 'ºC'),
	(328187, 146, '2015-01-15 00:48:03.000000', 'temperatura', 738.0000, 'ºC'),
	(328188, 146, '2015-01-15 00:48:04.000000', 'temperatura', 1160.0000, 'ºC'),
	(328189, 146, '2015-01-15 00:48:05.000000', 'temperatura', 1189.0000, 'ºC'),
	(328190, 146, '2015-01-15 00:48:06.000000', 'temperatura', 63.0000, 'ºC'),
	(328191, 146, '2015-01-15 00:48:07.000000', 'temperatura', 348.0000, 'ºC'),
	(328192, 146, '2015-01-15 00:48:08.000000', 'temperatura', 353.0000, 'ºC'),
	(328193, 146, '2015-01-15 00:48:09.000000', 'temperatura', 722.0000, 'ºC'),
	(328194, 146, '2015-01-15 00:48:10.000000', 'temperatura', 149.0000, 'ºC'),
	(328195, 146, '2015-01-15 00:48:11.000000', 'temperatura', 980.0000, 'ºC'),
	(328196, 146, '2015-01-15 00:48:12.000000', 'temperatura', 853.0000, 'ºC'),
	(328197, 146, '2015-01-15 00:48:13.000000', 'temperatura', 128.0000, 'ºC'),
	(328198, 146, '2015-01-15 00:48:14.000000', 'temperatura', 479.0000, 'ºC'),
	(328199, 146, '2015-01-15 00:48:15.000000', 'temperatura', 813.0000, 'ºC'),
	(328200, 146, '2015-01-15 00:48:16.000000', 'temperatura', 227.0000, 'ºC'),
	(328201, 146, '2015-01-15 00:48:17.000000', 'temperatura', 1097.0000, 'ºC'),
	(328202, 146, '2015-01-15 00:48:18.000000', 'temperatura', 4.0000, 'ºC'),
	(328203, 146, '2015-01-15 00:48:19.000000', 'temperatura', 328.0000, 'ºC'),
	(328204, 146, '2015-01-15 00:48:20.000000', 'temperatura', 430.0000, 'ºC'),
	(328205, 146, '2015-01-15 00:48:21.000000', 'temperatura', 1165.0000, 'ºC'),
	(328206, 146, '2015-01-15 00:48:22.000000', 'temperatura', 936.0000, 'ºC'),
	(328207, 146, '2015-01-15 00:48:23.000000', 'temperatura', 1184.0000, 'ºC'),
	(328208, 146, '2015-01-15 00:48:24.000000', 'temperatura', 716.0000, 'ºC'),
	(328209, 146, '2015-01-15 00:48:25.000000', 'temperatura', 26.0000, 'ºC'),
	(328210, 146, '2015-01-15 00:48:26.000000', 'temperatura', 382.0000, 'ºC'),
	(328211, 146, '2015-01-15 00:48:27.000000', 'temperatura', 632.0000, 'ºC'),
	(328212, 146, '2015-01-15 00:48:28.000000', 'temperatura', 817.0000, 'ºC'),
	(328213, 146, '2015-01-15 00:48:29.000000', 'temperatura', 990.0000, 'ºC'),
	(328214, 146, '2015-01-15 00:48:30.000000', 'temperatura', 100.0000, 'ºC'),
	(328215, 146, '2015-01-15 00:48:31.000000', 'temperatura', 1128.0000, 'ºC'),
	(328216, 146, '2015-01-15 00:48:32.000000', 'temperatura', 540.0000, 'ºC'),
	(328217, 146, '2015-01-15 00:48:33.000000', 'temperatura', 519.0000, 'ºC'),
	(328218, 146, '2015-01-15 00:48:34.000000', 'temperatura', 975.0000, 'ºC'),
	(328219, 146, '2015-01-15 00:48:35.000000', 'temperatura', 916.0000, 'ºC'),
	(328220, 146, '2015-01-15 00:48:36.000000', 'temperatura', 457.0000, 'ºC'),
	(328221, 146, '2015-01-15 00:48:37.000000', 'temperatura', 739.0000, 'ºC'),
	(328222, 146, '2015-01-15 00:48:38.000000', 'temperatura', 1122.0000, 'ºC'),
	(328223, 146, '2015-01-15 00:48:39.000000', 'temperatura', 995.0000, 'ºC'),
	(328224, 146, '2015-01-15 00:48:40.000000', 'temperatura', 409.0000, 'ºC'),
	(328225, 146, '2015-01-15 00:48:41.000000', 'temperatura', 260.0000, 'ºC'),
	(328226, 146, '2015-01-15 00:48:42.000000', 'temperatura', 74.0000, 'ºC'),
	(328227, 146, '2015-01-15 00:48:43.000000', 'temperatura', 792.0000, 'ºC'),
	(328228, 146, '2015-01-15 00:48:44.000000', 'temperatura', 136.0000, 'ºC'),
	(328229, 146, '2015-01-15 00:48:45.000000', 'temperatura', 705.0000, 'ºC'),
	(328230, 146, '2015-01-15 00:48:46.000000', 'temperatura', 720.0000, 'ºC'),
	(328231, 146, '2015-01-15 00:48:47.000000', 'temperatura', 283.0000, 'ºC'),
	(328232, 146, '2015-01-15 00:48:48.000000', 'temperatura', 456.0000, 'ºC'),
	(328233, 146, '2015-01-15 00:48:49.000000', 'temperatura', 230.0000, 'ºC'),
	(328234, 146, '2015-01-15 00:48:50.000000', 'temperatura', 982.0000, 'ºC'),
	(328235, 146, '2015-01-15 00:48:51.000000', 'temperatura', 623.0000, 'ºC'),
	(328236, 146, '2015-01-15 00:48:52.000000', 'temperatura', 169.0000, 'ºC'),
	(328237, 146, '2015-01-15 00:48:53.000000', 'temperatura', 176.0000, 'ºC'),
	(328238, 146, '2015-01-15 00:48:54.000000', 'temperatura', 373.0000, 'ºC'),
	(328239, 146, '2015-01-15 00:48:55.000000', 'temperatura', 137.0000, 'ºC'),
	(328240, 146, '2015-01-15 00:48:56.000000', 'temperatura', 768.0000, 'ºC'),
	(328241, 146, '2015-01-15 00:48:57.000000', 'temperatura', 1030.0000, 'ºC'),
	(328242, 146, '2015-01-15 00:48:58.000000', 'temperatura', 447.0000, 'ºC'),
	(328243, 146, '2015-01-15 00:48:59.000000', 'temperatura', 343.0000, 'ºC'),
	(328244, 146, '2015-01-15 00:49:00.000000', 'temperatura', 374.0000, 'ºC'),
	(328245, 146, '2015-01-15 00:49:01.000000', 'temperatura', 845.0000, 'ºC'),
	(328246, 146, '2015-01-15 00:49:02.000000', 'temperatura', 701.0000, 'ºC'),
	(328247, 146, '2015-01-15 00:49:03.000000', 'temperatura', 970.0000, 'ºC'),
	(328248, 146, '2015-01-15 00:49:04.000000', 'temperatura', 347.0000, 'ºC'),
	(328249, 146, '2015-01-15 00:49:05.000000', 'temperatura', 26.0000, 'ºC'),
	(328250, 146, '2015-01-15 00:49:06.000000', 'temperatura', 290.0000, 'ºC'),
	(328251, 146, '2015-01-15 00:49:07.000000', 'temperatura', 174.0000, 'ºC'),
	(328252, 146, '2015-01-15 00:49:08.000000', 'temperatura', 0.0000, 'ºC'),
	(328253, 146, '2015-01-15 00:49:09.000000', 'temperatura', 679.0000, 'ºC'),
	(328254, 146, '2015-01-15 00:49:10.000000', 'temperatura', 994.0000, 'ºC'),
	(328255, 146, '2015-01-15 00:49:11.000000', 'temperatura', 535.0000, 'ºC'),
	(328256, 146, '2015-01-15 00:49:12.000000', 'temperatura', 891.0000, 'ºC'),
	(328257, 146, '2015-01-15 00:49:13.000000', 'temperatura', 453.0000, 'ºC'),
	(328258, 146, '2015-01-15 00:49:14.000000', 'temperatura', 794.0000, 'ºC'),
	(328259, 146, '2015-01-15 00:49:15.000000', 'temperatura', 209.0000, 'ºC'),
	(328260, 146, '2015-01-15 00:49:16.000000', 'temperatura', 1062.0000, 'ºC'),
	(328261, 146, '2015-01-15 00:49:17.000000', 'temperatura', 1086.0000, 'ºC'),
	(328262, 146, '2015-01-15 00:49:18.000000', 'temperatura', 1045.0000, 'ºC'),
	(328263, 146, '2015-01-15 00:49:19.000000', 'temperatura', 767.0000, 'ºC'),
	(328264, 146, '2015-01-15 00:49:20.000000', 'temperatura', 699.0000, 'ºC'),
	(328265, 146, '2015-01-15 00:49:21.000000', 'temperatura', 1193.0000, 'ºC'),
	(328266, 146, '2015-01-15 00:49:22.000000', 'temperatura', 272.0000, 'ºC'),
	(328267, 146, '2015-01-15 00:49:23.000000', 'temperatura', 181.0000, 'ºC'),
	(328268, 146, '2015-01-15 00:49:24.000000', 'temperatura', 91.0000, 'ºC'),
	(328269, 146, '2015-01-15 00:49:25.000000', 'temperatura', 1110.0000, 'ºC'),
	(328270, 146, '2015-01-15 00:49:26.000000', 'temperatura', 476.0000, 'ºC'),
	(328271, 146, '2015-01-15 00:49:27.000000', 'temperatura', 253.0000, 'ºC'),
	(328272, 146, '2015-01-15 00:49:28.000000', 'temperatura', 1035.0000, 'ºC'),
	(328273, 146, '2015-01-15 00:49:29.000000', 'temperatura', 819.0000, 'ºC'),
	(328274, 146, '2015-01-15 00:49:30.000000', 'temperatura', 988.0000, 'ºC'),
	(328275, 146, '2015-01-15 00:49:31.000000', 'temperatura', 83.0000, 'ºC'),
	(328276, 146, '2015-01-15 00:49:32.000000', 'temperatura', 1051.0000, 'ºC'),
	(328277, 146, '2015-01-15 00:49:33.000000', 'temperatura', 210.0000, 'ºC'),
	(328278, 146, '2015-01-15 00:49:34.000000', 'temperatura', 295.0000, 'ºC'),
	(328279, 146, '2015-01-15 00:49:35.000000', 'temperatura', 845.0000, 'ºC'),
	(328280, 146, '2015-01-15 00:49:36.000000', 'temperatura', 941.0000, 'ºC'),
	(328281, 146, '2015-01-15 00:49:37.000000', 'temperatura', 971.0000, 'ºC'),
	(328282, 146, '2015-01-15 00:49:38.000000', 'temperatura', 831.0000, 'ºC'),
	(328283, 146, '2015-01-15 00:49:39.000000', 'temperatura', 42.0000, 'ºC'),
	(328284, 146, '2015-01-15 00:49:40.000000', 'temperatura', 119.0000, 'ºC'),
	(328285, 146, '2015-01-15 00:49:41.000000', 'temperatura', 470.0000, 'ºC'),
	(328286, 146, '2015-01-15 00:49:42.000000', 'temperatura', 792.0000, 'ºC'),
	(328287, 146, '2015-01-15 00:49:43.000000', 'temperatura', 150.0000, 'ºC'),
	(328288, 146, '2015-01-15 00:49:44.000000', 'temperatura', 776.0000, 'ºC'),
	(328289, 146, '2015-01-15 00:49:45.000000', 'temperatura', 1030.0000, 'ºC'),
	(328290, 146, '2015-01-15 00:49:46.000000', 'temperatura', 421.0000, 'ºC'),
	(328291, 146, '2015-01-15 00:49:47.000000', 'temperatura', 218.0000, 'ºC'),
	(328292, 146, '2015-01-15 00:49:48.000000', 'temperatura', 1025.0000, 'ºC'),
	(328293, 146, '2015-01-15 00:49:49.000000', 'temperatura', 872.0000, 'ºC'),
	(328294, 146, '2015-01-15 00:49:50.000000', 'temperatura', 88.0000, 'ºC'),
	(328295, 146, '2015-01-15 00:49:51.000000', 'temperatura', 222.0000, 'ºC'),
	(328296, 146, '2015-01-15 00:49:52.000000', 'temperatura', 845.0000, 'ºC'),
	(328297, 146, '2015-01-15 00:49:53.000000', 'temperatura', 1163.0000, 'ºC'),
	(328298, 146, '2015-01-15 00:49:54.000000', 'temperatura', 879.0000, 'ºC'),
	(328299, 146, '2015-01-15 00:49:55.000000', 'temperatura', 907.0000, 'ºC'),
	(328300, 146, '2015-01-15 00:49:56.000000', 'temperatura', 697.0000, 'ºC'),
	(328301, 146, '2015-01-15 00:49:57.000000', 'temperatura', 763.0000, 'ºC'),
	(328302, 146, '2015-01-15 00:49:58.000000', 'temperatura', 527.0000, 'ºC'),
	(328303, 146, '2015-01-15 00:49:59.000000', 'temperatura', 346.0000, 'ºC'),
	(328304, 146, '2015-01-15 00:50:00.000000', 'temperatura', 150.0000, 'ºC'),
	(328305, 146, '2015-01-15 00:50:01.000000', 'temperatura', 914.0000, 'ºC'),
	(328306, 146, '2015-01-15 00:50:02.000000', 'temperatura', 519.0000, 'ºC'),
	(328307, 146, '2015-01-15 00:50:03.000000', 'temperatura', 1053.0000, 'ºC'),
	(328308, 146, '2015-01-15 00:50:04.000000', 'temperatura', 107.0000, 'ºC'),
	(328309, 146, '2015-01-15 00:50:05.000000', 'temperatura', 980.0000, 'ºC'),
	(328310, 146, '2015-01-15 00:50:06.000000', 'temperatura', 977.0000, 'ºC'),
	(328311, 146, '2015-01-15 00:50:07.000000', 'temperatura', 747.0000, 'ºC'),
	(328312, 146, '2015-01-15 00:50:08.000000', 'temperatura', 803.0000, 'ºC'),
	(328313, 146, '2015-01-15 00:50:09.000000', 'temperatura', 575.0000, 'ºC'),
	(328314, 146, '2015-01-15 00:50:10.000000', 'temperatura', 467.0000, 'ºC'),
	(328315, 146, '2015-01-15 00:50:11.000000', 'temperatura', 610.0000, 'ºC'),
	(328316, 146, '2015-01-15 00:50:12.000000', 'temperatura', 451.0000, 'ºC'),
	(328317, 146, '2015-01-15 00:50:13.000000', 'temperatura', 423.0000, 'ºC'),
	(328318, 146, '2015-01-15 00:50:14.000000', 'temperatura', 762.0000, 'ºC'),
	(328319, 146, '2015-01-15 00:50:15.000000', 'temperatura', 142.0000, 'ºC'),
	(328320, 146, '2015-01-15 00:50:16.000000', 'temperatura', 823.0000, 'ºC'),
	(328321, 146, '2015-01-15 00:50:17.000000', 'temperatura', 92.0000, 'ºC'),
	(328322, 146, '2015-01-15 00:50:18.000000', 'temperatura', 390.0000, 'ºC'),
	(328323, 146, '2015-01-15 00:50:19.000000', 'temperatura', 475.0000, 'ºC'),
	(328324, 146, '2015-01-15 00:50:20.000000', 'temperatura', 5.0000, 'ºC'),
	(328325, 146, '2015-01-15 00:50:21.000000', 'temperatura', 1000.0000, 'ºC'),
	(328326, 146, '2015-01-15 00:50:22.000000', 'temperatura', 185.0000, 'ºC'),
	(328327, 146, '2015-01-15 00:50:23.000000', 'temperatura', 325.0000, 'ºC'),
	(328328, 146, '2015-01-15 00:50:24.000000', 'temperatura', 1069.0000, 'ºC'),
	(328329, 146, '2015-01-15 00:50:25.000000', 'temperatura', 774.0000, 'ºC'),
	(328330, 146, '2015-01-15 00:50:26.000000', 'temperatura', 661.0000, 'ºC'),
	(328331, 146, '2015-01-15 00:50:27.000000', 'temperatura', 986.0000, 'ºC'),
	(328332, 146, '2015-01-15 00:50:28.000000', 'temperatura', 548.0000, 'ºC'),
	(328333, 146, '2015-01-15 00:50:29.000000', 'temperatura', 982.0000, 'ºC'),
	(328334, 146, '2015-01-15 00:50:30.000000', 'temperatura', 866.0000, 'ºC'),
	(328335, 146, '2015-01-15 00:50:31.000000', 'temperatura', 186.0000, 'ºC'),
	(328336, 146, '2015-01-15 00:50:32.000000', 'temperatura', 733.0000, 'ºC'),
	(328337, 146, '2015-01-15 00:50:33.000000', 'temperatura', 707.0000, 'ºC'),
	(328338, 146, '2015-01-15 00:50:34.000000', 'temperatura', 135.0000, 'ºC'),
	(328339, 146, '2015-01-15 00:50:35.000000', 'temperatura', 957.0000, 'ºC'),
	(328340, 146, '2015-01-15 00:50:36.000000', 'temperatura', 780.0000, 'ºC'),
	(328341, 146, '2015-01-15 00:50:37.000000', 'temperatura', 1029.0000, 'ºC'),
	(328342, 146, '2015-01-15 00:50:38.000000', 'temperatura', 406.0000, 'ºC'),
	(328343, 146, '2015-01-15 00:50:39.000000', 'temperatura', 142.0000, 'ºC'),
	(328344, 146, '2015-01-15 00:50:40.000000', 'temperatura', 693.0000, 'ºC'),
	(328345, 146, '2015-01-15 00:50:41.000000', 'temperatura', 642.0000, 'ºC'),
	(328346, 146, '2015-01-15 00:50:42.000000', 'temperatura', 1128.0000, 'ºC'),
	(328347, 146, '2015-01-15 00:50:43.000000', 'temperatura', 117.0000, 'ºC'),
	(328348, 146, '2015-01-15 00:50:44.000000', 'temperatura', 800.0000, 'ºC'),
	(328349, 146, '2015-01-15 00:50:45.000000', 'temperatura', 49.0000, 'ºC'),
	(328350, 146, '2015-01-15 00:50:46.000000', 'temperatura', 246.0000, 'ºC'),
	(328351, 146, '2015-01-15 00:50:47.000000', 'temperatura', 1085.0000, 'ºC'),
	(328352, 146, '2015-01-15 00:50:48.000000', 'temperatura', 1085.0000, 'ºC'),
	(328353, 146, '2015-01-15 00:50:49.000000', 'temperatura', 972.0000, 'ºC'),
	(328354, 146, '2015-01-15 00:50:50.000000', 'temperatura', 406.0000, 'ºC'),
	(328355, 146, '2015-01-15 00:50:51.000000', 'temperatura', 315.0000, 'ºC'),
	(328356, 146, '2015-01-15 00:50:52.000000', 'temperatura', 358.0000, 'ºC'),
	(328357, 146, '2015-01-15 00:50:53.000000', 'temperatura', 844.0000, 'ºC'),
	(328358, 146, '2015-01-15 00:50:54.000000', 'temperatura', 746.0000, 'ºC'),
	(328359, 146, '2015-01-15 00:50:55.000000', 'temperatura', 1198.0000, 'ºC'),
	(328360, 146, '2015-01-15 00:50:56.000000', 'temperatura', 153.0000, 'ºC'),
	(328361, 146, '2015-01-15 00:50:57.000000', 'temperatura', 770.0000, 'ºC'),
	(328362, 146, '2015-01-15 00:50:58.000000', 'temperatura', 993.0000, 'ºC'),
	(328363, 146, '2015-01-15 00:50:59.000000', 'temperatura', 256.0000, 'ºC'),
	(328364, 146, '2015-01-15 00:51:00.000000', 'temperatura', 702.0000, 'ºC'),
	(328365, 146, '2015-01-15 00:51:01.000000', 'temperatura', 342.0000, 'ºC'),
	(328366, 146, '2015-01-15 00:51:02.000000', 'temperatura', 806.0000, 'ºC'),
	(328367, 146, '2015-01-15 00:51:03.000000', 'temperatura', 603.0000, 'ºC'),
	(328368, 146, '2015-01-15 00:51:04.000000', 'temperatura', 597.0000, 'ºC'),
	(328369, 146, '2015-01-15 00:51:05.000000', 'temperatura', 1179.0000, 'ºC'),
	(328370, 146, '2015-01-15 00:51:06.000000', 'temperatura', 503.0000, 'ºC'),
	(328371, 146, '2015-01-15 00:51:07.000000', 'temperatura', 179.0000, 'ºC'),
	(328372, 146, '2015-01-15 00:51:08.000000', 'temperatura', 587.0000, 'ºC'),
	(328373, 146, '2015-01-15 00:51:09.000000', 'temperatura', 1196.0000, 'ºC'),
	(328374, 146, '2015-01-15 00:51:10.000000', 'temperatura', 621.0000, 'ºC'),
	(328375, 146, '2015-01-15 00:51:11.000000', 'temperatura', 716.0000, 'ºC'),
	(328376, 146, '2015-01-15 00:51:12.000000', 'temperatura', 518.0000, 'ºC'),
	(328377, 146, '2015-01-15 00:51:13.000000', 'temperatura', 444.0000, 'ºC'),
	(328378, 146, '2015-01-15 00:51:14.000000', 'temperatura', 668.0000, 'ºC'),
	(328379, 146, '2015-01-15 00:51:15.000000', 'temperatura', 805.0000, 'ºC'),
	(328380, 146, '2015-01-15 00:51:16.000000', 'temperatura', 822.0000, 'ºC'),
	(328381, 146, '2015-01-15 00:51:17.000000', 'temperatura', 496.0000, 'ºC'),
	(328382, 146, '2015-01-15 00:51:18.000000', 'temperatura', 16.0000, 'ºC'),
	(328383, 146, '2015-01-15 00:51:19.000000', 'temperatura', 993.0000, 'ºC'),
	(328384, 146, '2015-01-15 00:51:20.000000', 'temperatura', 117.0000, 'ºC'),
	(328385, 146, '2015-01-15 00:51:21.000000', 'temperatura', 5.0000, 'ºC'),
	(328386, 146, '2015-01-15 00:51:22.000000', 'temperatura', 874.0000, 'ºC'),
	(328387, 146, '2015-01-15 00:51:23.000000', 'temperatura', 757.0000, 'ºC'),
	(328388, 146, '2015-01-15 00:51:24.000000', 'temperatura', 1161.0000, 'ºC'),
	(328389, 146, '2015-01-15 00:51:25.000000', 'temperatura', 1136.0000, 'ºC'),
	(328390, 146, '2015-01-15 00:51:26.000000', 'temperatura', 996.0000, 'ºC'),
	(328391, 146, '2015-01-15 00:51:27.000000', 'temperatura', 373.0000, 'ºC'),
	(328392, 146, '2015-01-15 00:51:28.000000', 'temperatura', 78.0000, 'ºC'),
	(328393, 146, '2015-01-15 00:51:29.000000', 'temperatura', 473.0000, 'ºC'),
	(328394, 146, '2015-01-15 00:51:30.000000', 'temperatura', 931.0000, 'ºC'),
	(328395, 146, '2015-01-15 00:51:31.000000', 'temperatura', 836.0000, 'ºC'),
	(328396, 146, '2015-01-15 00:51:32.000000', 'temperatura', 188.0000, 'ºC'),
	(328397, 146, '2015-01-15 00:51:33.000000', 'temperatura', 831.0000, 'ºC'),
	(328398, 146, '2015-01-15 00:51:34.000000', 'temperatura', 1194.0000, 'ºC'),
	(328399, 146, '2015-01-15 00:51:35.000000', 'temperatura', 1077.0000, 'ºC'),
	(328400, 146, '2015-01-15 00:51:36.000000', 'temperatura', 604.0000, 'ºC'),
	(328401, 146, '2015-01-15 00:51:37.000000', 'temperatura', 990.0000, 'ºC'),
	(328402, 146, '2015-01-15 00:51:38.000000', 'temperatura', 736.0000, 'ºC'),
	(328403, 146, '2015-01-15 00:51:39.000000', 'temperatura', 711.0000, 'ºC'),
	(328404, 146, '2015-01-15 00:51:40.000000', 'temperatura', 149.0000, 'ºC'),
	(328405, 146, '2015-01-15 00:51:41.000000', 'temperatura', 1010.0000, 'ºC'),
	(328406, 146, '2015-01-15 00:51:42.000000', 'temperatura', 1004.0000, 'ºC'),
	(328407, 146, '2015-01-15 00:51:43.000000', 'temperatura', 792.0000, 'ºC'),
	(328408, 146, '2015-01-15 00:51:44.000000', 'temperatura', 950.0000, 'ºC'),
	(328409, 146, '2015-01-15 00:51:45.000000', 'temperatura', 1171.0000, 'ºC'),
	(328410, 146, '2015-01-15 00:51:46.000000', 'temperatura', 608.0000, 'ºC'),
	(328411, 146, '2015-01-15 00:51:47.000000', 'temperatura', 725.0000, 'ºC'),
	(328412, 146, '2015-01-15 00:51:48.000000', 'temperatura', 603.0000, 'ºC'),
	(328413, 146, '2015-01-15 00:51:49.000000', 'temperatura', 839.0000, 'ºC'),
	(328414, 146, '2015-01-15 00:51:50.000000', 'temperatura', 1186.0000, 'ºC'),
	(328415, 146, '2015-01-15 00:51:51.000000', 'temperatura', 1012.0000, 'ºC'),
	(328416, 146, '2015-01-15 00:51:52.000000', 'temperatura', 306.0000, 'ºC'),
	(328417, 146, '2015-01-15 00:51:53.000000', 'temperatura', 894.0000, 'ºC'),
	(328418, 146, '2015-01-15 00:51:54.000000', 'temperatura', 1152.0000, 'ºC'),
	(328419, 146, '2015-01-15 00:51:55.000000', 'temperatura', 680.0000, 'ºC'),
	(328420, 146, '2015-01-15 00:51:56.000000', 'temperatura', 1143.0000, 'ºC'),
	(328421, 146, '2015-01-15 00:51:57.000000', 'temperatura', 76.0000, 'ºC'),
	(328422, 146, '2015-01-15 00:51:58.000000', 'temperatura', 550.0000, 'ºC'),
	(328423, 146, '2015-01-15 00:51:59.000000', 'temperatura', 125.0000, 'ºC'),
	(328424, 146, '2015-01-15 00:52:00.000000', 'temperatura', 175.0000, 'ºC'),
	(328425, 146, '2015-01-15 00:52:01.000000', 'temperatura', 502.0000, 'ºC'),
	(328426, 146, '2015-01-15 00:52:02.000000', 'temperatura', 784.0000, 'ºC'),
	(328427, 146, '2015-01-15 00:52:03.000000', 'temperatura', 14.0000, 'ºC'),
	(328428, 146, '2015-01-15 00:52:04.000000', 'temperatura', 119.0000, 'ºC'),
	(328429, 146, '2015-01-15 00:52:05.000000', 'temperatura', 555.0000, 'ºC'),
	(328430, 146, '2015-01-15 00:52:06.000000', 'temperatura', 15.0000, 'ºC'),
	(328431, 146, '2015-01-15 00:52:07.000000', 'temperatura', 814.0000, 'ºC'),
	(328432, 146, '2015-01-15 00:52:08.000000', 'temperatura', 424.0000, 'ºC'),
	(328433, 146, '2015-01-15 00:52:09.000000', 'temperatura', 878.0000, 'ºC'),
	(328434, 146, '2015-01-15 00:52:10.000000', 'temperatura', 718.0000, 'ºC'),
	(328435, 146, '2015-01-15 00:52:11.000000', 'temperatura', 957.0000, 'ºC'),
	(328436, 146, '2015-01-15 00:52:12.000000', 'temperatura', 230.0000, 'ºC'),
	(328437, 146, '2015-01-15 00:52:13.000000', 'temperatura', 681.0000, 'ºC'),
	(328438, 146, '2015-01-15 00:52:14.000000', 'temperatura', 314.0000, 'ºC'),
	(328439, 146, '2015-01-15 00:52:15.000000', 'temperatura', 730.0000, 'ºC'),
	(328440, 146, '2015-01-15 00:52:16.000000', 'temperatura', 308.0000, 'ºC'),
	(328441, 146, '2015-01-15 00:52:17.000000', 'temperatura', 548.0000, 'ºC'),
	(328442, 146, '2015-01-15 00:52:18.000000', 'temperatura', 618.0000, 'ºC'),
	(328443, 146, '2015-01-15 00:52:19.000000', 'temperatura', 247.0000, 'ºC'),
	(328444, 146, '2015-01-15 00:52:20.000000', 'temperatura', 581.0000, 'ºC'),
	(328445, 146, '2015-01-15 00:52:21.000000', 'temperatura', 962.0000, 'ºC'),
	(328446, 146, '2015-01-15 00:52:22.000000', 'temperatura', 671.0000, 'ºC'),
	(328447, 146, '2015-01-15 00:52:23.000000', 'temperatura', 469.0000, 'ºC'),
	(328448, 146, '2015-01-15 00:52:24.000000', 'temperatura', 333.0000, 'ºC'),
	(328449, 146, '2015-01-15 00:52:25.000000', 'temperatura', 256.0000, 'ºC'),
	(328450, 146, '2015-01-15 00:52:26.000000', 'temperatura', 283.0000, 'ºC'),
	(328451, 146, '2015-01-15 00:52:27.000000', 'temperatura', 645.0000, 'ºC'),
	(328452, 146, '2015-01-15 00:52:28.000000', 'temperatura', 1180.0000, 'ºC'),
	(328453, 146, '2015-01-15 00:52:29.000000', 'temperatura', 364.0000, 'ºC'),
	(328454, 146, '2015-01-15 00:52:30.000000', 'temperatura', 681.0000, 'ºC'),
	(328455, 146, '2015-01-15 00:52:31.000000', 'temperatura', 1113.0000, 'ºC'),
	(328456, 146, '2015-01-15 00:52:32.000000', 'temperatura', 1124.0000, 'ºC'),
	(328457, 146, '2015-01-15 00:52:33.000000', 'temperatura', 1081.0000, 'ºC'),
	(328458, 146, '2015-01-15 00:52:34.000000', 'temperatura', 832.0000, 'ºC'),
	(328459, 146, '2015-01-15 00:52:35.000000', 'temperatura', 916.0000, 'ºC'),
	(328460, 146, '2015-01-15 00:52:36.000000', 'temperatura', 888.0000, 'ºC'),
	(328461, 146, '2015-01-15 00:52:37.000000', 'temperatura', 490.0000, 'ºC'),
	(328462, 146, '2015-01-15 00:52:38.000000', 'temperatura', 987.0000, 'ºC'),
	(328463, 146, '2015-01-15 00:52:39.000000', 'temperatura', 1065.0000, 'ºC'),
	(328464, 146, '2015-01-15 00:52:40.000000', 'temperatura', 1167.0000, 'ºC'),
	(328465, 146, '2015-01-15 00:52:41.000000', 'temperatura', 238.0000, 'ºC'),
	(328466, 146, '2015-01-15 00:52:42.000000', 'temperatura', 89.0000, 'ºC'),
	(328467, 146, '2015-01-15 00:52:43.000000', 'temperatura', 934.0000, 'ºC'),
	(328468, 146, '2015-01-15 00:52:44.000000', 'temperatura', 800.0000, 'ºC'),
	(328469, 146, '2015-01-15 00:52:45.000000', 'temperatura', 2.0000, 'ºC'),
	(328470, 146, '2015-01-15 00:52:46.000000', 'temperatura', 10.0000, 'ºC'),
	(328471, 146, '2015-01-15 00:52:47.000000', 'temperatura', 44.0000, 'ºC'),
	(328472, 146, '2015-01-15 00:52:48.000000', 'temperatura', 192.0000, 'ºC'),
	(328473, 146, '2015-01-15 00:52:49.000000', 'temperatura', 827.0000, 'ºC'),
	(328474, 146, '2015-01-15 00:52:50.000000', 'temperatura', 1160.0000, 'ºC'),
	(328475, 146, '2015-01-15 00:52:51.000000', 'temperatura', 918.0000, 'ºC'),
	(328476, 146, '2015-01-15 00:52:52.000000', 'temperatura', 1111.0000, 'ºC'),
	(328477, 146, '2015-01-15 00:52:53.000000', 'temperatura', 403.0000, 'ºC'),
	(328478, 146, '2015-01-15 00:52:54.000000', 'temperatura', 1082.0000, 'ºC'),
	(328479, 146, '2015-01-15 00:52:55.000000', 'temperatura', 601.0000, 'ºC'),
	(328480, 146, '2015-01-15 00:52:56.000000', 'temperatura', 962.0000, 'ºC'),
	(328481, 146, '2015-01-15 00:52:57.000000', 'temperatura', 604.0000, 'ºC'),
	(328482, 146, '2015-01-15 00:52:58.000000', 'temperatura', 135.0000, 'ºC'),
	(328483, 146, '2015-01-15 00:52:59.000000', 'temperatura', 66.0000, 'ºC'),
	(328484, 146, '2015-01-15 00:53:00.000000', 'temperatura', 1124.0000, 'ºC'),
	(328485, 146, '2015-01-15 00:53:01.000000', 'temperatura', 625.0000, 'ºC'),
	(328486, 146, '2015-01-15 00:53:02.000000', 'temperatura', 951.0000, 'ºC'),
	(328487, 146, '2015-01-15 00:53:03.000000', 'temperatura', 480.0000, 'ºC'),
	(328488, 146, '2015-01-15 00:53:04.000000', 'temperatura', 748.0000, 'ºC'),
	(328489, 146, '2015-01-15 00:53:05.000000', 'temperatura', 1101.0000, 'ºC'),
	(328490, 146, '2015-01-15 00:53:06.000000', 'temperatura', 862.0000, 'ºC'),
	(328491, 146, '2015-01-15 00:53:07.000000', 'temperatura', 1009.0000, 'ºC'),
	(328492, 146, '2015-01-15 00:53:08.000000', 'temperatura', 57.0000, 'ºC'),
	(328493, 146, '2015-01-15 00:53:09.000000', 'temperatura', 861.0000, 'ºC'),
	(328494, 146, '2015-01-15 00:53:10.000000', 'temperatura', 534.0000, 'ºC'),
	(328495, 146, '2015-01-15 00:53:11.000000', 'temperatura', 88.0000, 'ºC'),
	(328496, 146, '2015-01-15 00:53:12.000000', 'temperatura', 37.0000, 'ºC'),
	(328497, 146, '2015-01-15 00:53:13.000000', 'temperatura', 1122.0000, 'ºC'),
	(328498, 146, '2015-01-15 00:53:14.000000', 'temperatura', 702.0000, 'ºC'),
	(328499, 146, '2015-01-15 00:53:15.000000', 'temperatura', 141.0000, 'ºC'),
	(328500, 146, '2015-01-15 00:53:16.000000', 'temperatura', 1003.0000, 'ºC'),
	(328501, 146, '2015-01-15 00:53:17.000000', 'temperatura', 990.0000, 'ºC'),
	(328502, 146, '2015-01-15 00:53:18.000000', 'temperatura', 741.0000, 'ºC'),
	(328503, 146, '2015-01-15 00:53:19.000000', 'temperatura', 738.0000, 'ºC'),
	(328504, 146, '2015-01-15 00:53:20.000000', 'temperatura', 267.0000, 'ºC'),
	(328505, 146, '2015-01-15 00:53:21.000000', 'temperatura', 320.0000, 'ºC'),
	(328506, 146, '2015-01-15 00:53:22.000000', 'temperatura', 799.0000, 'ºC'),
	(328507, 146, '2015-01-15 00:53:23.000000', 'temperatura', 638.0000, 'ºC'),
	(328508, 146, '2015-01-15 00:53:24.000000', 'temperatura', 793.0000, 'ºC'),
	(328509, 146, '2015-01-15 00:53:25.000000', 'temperatura', 853.0000, 'ºC'),
	(328510, 146, '2015-01-15 00:53:26.000000', 'temperatura', 686.0000, 'ºC'),
	(328511, 146, '2015-01-15 00:53:27.000000', 'temperatura', 869.0000, 'ºC'),
	(328512, 146, '2015-01-15 00:53:28.000000', 'temperatura', 1089.0000, 'ºC'),
	(328513, 146, '2015-01-15 00:53:29.000000', 'temperatura', 440.0000, 'ºC'),
	(328514, 146, '2015-01-15 00:53:30.000000', 'temperatura', 134.0000, 'ºC'),
	(328515, 146, '2015-01-15 00:53:31.000000', 'temperatura', 551.0000, 'ºC'),
	(328516, 146, '2015-01-15 00:53:32.000000', 'temperatura', 1153.0000, 'ºC'),
	(328517, 146, '2015-01-15 00:53:33.000000', 'temperatura', 510.0000, 'ºC'),
	(328518, 146, '2015-01-15 00:53:34.000000', 'temperatura', 293.0000, 'ºC'),
	(328519, 146, '2015-01-15 00:53:35.000000', 'temperatura', 1134.0000, 'ºC'),
	(328520, 146, '2015-01-15 00:53:36.000000', 'temperatura', 1193.0000, 'ºC'),
	(328521, 146, '2015-01-15 00:53:37.000000', 'temperatura', 164.0000, 'ºC'),
	(328522, 146, '2015-01-15 00:53:38.000000', 'temperatura', 842.0000, 'ºC'),
	(328523, 146, '2015-01-15 00:53:39.000000', 'temperatura', 119.0000, 'ºC'),
	(328524, 146, '2015-01-15 00:53:40.000000', 'temperatura', 468.0000, 'ºC'),
	(328525, 146, '2015-01-15 00:53:41.000000', 'temperatura', 785.0000, 'ºC'),
	(328526, 146, '2015-01-15 00:53:42.000000', 'temperatura', 122.0000, 'ºC'),
	(328527, 146, '2015-01-15 00:53:43.000000', 'temperatura', 657.0000, 'ºC'),
	(328528, 146, '2015-01-15 00:53:44.000000', 'temperatura', 517.0000, 'ºC'),
	(328529, 146, '2015-01-15 00:53:45.000000', 'temperatura', 615.0000, 'ºC'),
	(328530, 146, '2015-01-15 00:53:46.000000', 'temperatura', 323.0000, 'ºC'),
	(328531, 146, '2015-01-15 00:53:47.000000', 'temperatura', 971.0000, 'ºC'),
	(328532, 146, '2015-01-15 00:53:48.000000', 'temperatura', 287.0000, 'ºC'),
	(328533, 146, '2015-01-15 00:53:49.000000', 'temperatura', 921.0000, 'ºC'),
	(328534, 146, '2015-01-15 00:53:50.000000', 'temperatura', 146.0000, 'ºC'),
	(328535, 146, '2015-01-15 00:53:51.000000', 'temperatura', 367.0000, 'ºC'),
	(328536, 146, '2015-01-15 00:53:52.000000', 'temperatura', 196.0000, 'ºC'),
	(328537, 146, '2015-01-15 00:53:53.000000', 'temperatura', 1081.0000, 'ºC'),
	(328538, 146, '2015-01-15 00:53:54.000000', 'temperatura', 18.0000, 'ºC'),
	(328539, 146, '2015-01-15 00:53:55.000000', 'temperatura', 449.0000, 'ºC'),
	(328540, 146, '2015-01-15 00:53:56.000000', 'temperatura', 990.0000, 'ºC'),
	(328541, 146, '2015-01-15 00:53:57.000000', 'temperatura', 2.0000, 'ºC'),
	(328542, 146, '2015-01-15 00:53:58.000000', 'temperatura', 644.0000, 'ºC'),
	(328543, 146, '2015-01-15 00:53:59.000000', 'temperatura', 812.0000, 'ºC'),
	(328544, 146, '2015-01-15 00:54:00.000000', 'temperatura', 927.0000, 'ºC'),
	(328545, 146, '2015-01-15 00:54:01.000000', 'temperatura', 1001.0000, 'ºC'),
	(328546, 146, '2015-01-15 00:54:02.000000', 'temperatura', 1026.0000, 'ºC'),
	(328547, 146, '2015-01-15 00:54:03.000000', 'temperatura', 928.0000, 'ºC'),
	(328548, 146, '2015-01-15 00:54:04.000000', 'temperatura', 363.0000, 'ºC'),
	(328549, 146, '2015-01-15 00:54:05.000000', 'temperatura', 230.0000, 'ºC'),
	(328550, 146, '2015-01-15 00:54:06.000000', 'temperatura', 63.0000, 'ºC'),
	(328551, 146, '2015-01-15 00:54:07.000000', 'temperatura', 824.0000, 'ºC'),
	(328552, 146, '2015-01-15 00:54:08.000000', 'temperatura', 333.0000, 'ºC'),
	(328553, 146, '2015-01-15 00:54:09.000000', 'temperatura', 391.0000, 'ºC'),
	(328554, 146, '2015-01-15 00:54:10.000000', 'temperatura', 959.0000, 'ºC'),
	(328555, 146, '2015-01-15 00:54:11.000000', 'temperatura', 23.0000, 'ºC'),
	(328556, 146, '2015-01-15 00:54:12.000000', 'temperatura', 837.0000, 'ºC'),
	(328557, 146, '2015-01-15 00:54:13.000000', 'temperatura', 516.0000, 'ºC'),
	(328558, 146, '2015-01-15 00:54:14.000000', 'temperatura', 69.0000, 'ºC'),
	(328559, 146, '2015-01-15 00:54:15.000000', 'temperatura', 1198.0000, 'ºC'),
	(328560, 146, '2015-01-15 00:54:16.000000', 'temperatura', 984.0000, 'ºC'),
	(328561, 146, '2015-01-15 00:54:17.000000', 'temperatura', 127.0000, 'ºC'),
	(328562, 146, '2015-01-15 00:54:18.000000', 'temperatura', 84.0000, 'ºC'),
	(328563, 146, '2015-01-15 00:54:19.000000', 'temperatura', 41.0000, 'ºC'),
	(328564, 146, '2015-01-15 00:54:20.000000', 'temperatura', 1151.0000, 'ºC'),
	(328565, 146, '2015-01-15 00:54:21.000000', 'temperatura', 834.0000, 'ºC'),
	(328566, 146, '2015-01-15 00:54:22.000000', 'temperatura', 717.0000, 'ºC'),
	(328567, 146, '2015-01-15 00:54:23.000000', 'temperatura', 1085.0000, 'ºC'),
	(328568, 146, '2015-01-15 00:54:24.000000', 'temperatura', 874.0000, 'ºC'),
	(328569, 146, '2015-01-15 00:54:25.000000', 'temperatura', 1114.0000, 'ºC'),
	(328570, 146, '2015-01-15 00:54:26.000000', 'temperatura', 547.0000, 'ºC'),
	(328571, 146, '2015-01-15 00:54:27.000000', 'temperatura', 597.0000, 'ºC'),
	(328572, 146, '2015-01-15 00:54:28.000000', 'temperatura', 142.0000, 'ºC'),
	(328573, 146, '2015-01-15 00:54:29.000000', 'temperatura', 120.0000, 'ºC'),
	(328574, 146, '2015-01-15 00:54:30.000000', 'temperatura', 174.0000, 'ºC'),
	(328575, 146, '2015-01-15 00:54:31.000000', 'temperatura', 511.0000, 'ºC'),
	(328576, 146, '2015-01-15 00:54:32.000000', 'temperatura', 834.0000, 'ºC'),
	(328577, 146, '2015-01-15 00:54:33.000000', 'temperatura', 235.0000, 'ºC'),
	(328578, 146, '2015-01-15 00:54:34.000000', 'temperatura', 1076.0000, 'ºC'),
	(328579, 146, '2015-01-15 00:54:35.000000', 'temperatura', 1076.0000, 'ºC'),
	(328580, 146, '2015-01-15 00:54:36.000000', 'temperatura', 951.0000, 'ºC'),
	(328581, 146, '2015-01-15 00:54:37.000000', 'temperatura', 328.0000, 'ºC'),
	(328582, 146, '2015-01-15 00:54:38.000000', 'temperatura', 1188.0000, 'ºC'),
	(328583, 146, '2015-01-15 00:54:39.000000', 'temperatura', 156.0000, 'ºC'),
	(328584, 146, '2015-01-15 00:54:40.000000', 'temperatura', 818.0000, 'ºC'),
	(328585, 146, '2015-01-15 00:54:41.000000', 'temperatura', 24.0000, 'ºC'),
	(328586, 146, '2015-01-15 00:54:42.000000', 'temperatura', 63.0000, 'ºC'),
	(328587, 146, '2015-01-15 00:54:43.000000', 'temperatura', 245.0000, 'ºC'),
	(328588, 146, '2015-01-15 00:54:44.000000', 'temperatura', 1038.0000, 'ºC'),
	(328589, 146, '2015-01-15 00:54:45.000000', 'temperatura', 855.0000, 'ºC'),
	(328590, 146, '2015-01-15 00:54:46.000000', 'temperatura', 1160.0000, 'ºC'),
	(328591, 146, '2015-01-15 00:54:47.000000', 'temperatura', 834.0000, 'ºC'),
	(328592, 146, '2015-01-15 00:54:48.000000', 'temperatura', 693.0000, 'ºC'),
	(328593, 146, '2015-01-15 00:54:49.000000', 'temperatura', 962.0000, 'ºC'),
	(328594, 146, '2015-01-15 00:54:50.000000', 'temperatura', 332.0000, 'ºC'),
	(328595, 146, '2015-01-15 00:54:51.000000', 'temperatura', 1173.0000, 'ºC'),
	(328596, 146, '2015-01-15 00:54:52.000000', 'temperatura', 72.0000, 'ºC'),
	(328597, 146, '2015-01-15 00:54:53.000000', 'temperatura', 439.0000, 'ºC'),
	(328598, 146, '2015-01-15 00:54:54.000000', 'temperatura', 783.0000, 'ºC'),
	(328599, 146, '2015-01-15 00:54:55.000000', 'temperatura', 195.0000, 'ºC'),
	(328600, 146, '2015-01-15 00:54:56.000000', 'temperatura', 1029.0000, 'ºC'),
	(328601, 146, '2015-01-15 00:54:57.000000', 'temperatura', 962.0000, 'ºC'),
	(328602, 146, '2015-01-15 00:54:58.000000', 'temperatura', 520.0000, 'ºC'),
	(328603, 146, '2015-01-15 00:54:59.000000', 'temperatura', 916.0000, 'ºC'),
	(328604, 146, '2015-01-15 00:55:00.000000', 'temperatura', 618.0000, 'ºC'),
	(328605, 146, '2015-01-15 00:55:01.000000', 'temperatura', 346.0000, 'ºC'),
	(328606, 146, '2015-01-15 00:55:02.000000', 'temperatura', 1074.0000, 'ºC'),
	(328607, 146, '2015-01-15 00:55:03.000000', 'temperatura', 735.0000, 'ºC'),
	(328608, 146, '2015-01-15 00:55:04.000000', 'temperatura', 451.0000, 'ºC'),
	(328609, 146, '2015-01-15 00:55:05.000000', 'temperatura', 52.0000, 'ºC'),
	(328610, 146, '2015-01-15 00:55:06.000000', 'temperatura', 106.0000, 'ºC'),
	(328611, 146, '2015-01-15 00:55:07.000000', 'temperatura', 376.0000, 'ºC'),
	(328612, 146, '2015-01-15 00:55:08.000000', 'temperatura', 363.0000, 'ºC'),
	(328613, 146, '2015-01-15 00:55:09.000000', 'temperatura', 686.0000, 'ºC'),
	(328614, 146, '2015-01-15 00:55:10.000000', 'temperatura', 1143.0000, 'ºC'),
	(328615, 146, '2015-01-15 00:55:11.000000', 'temperatura', 56.0000, 'ºC'),
	(328616, 146, '2015-01-15 00:55:12.000000', 'temperatura', 453.0000, 'ºC'),
	(328617, 146, '2015-01-15 00:55:13.000000', 'temperatura', 899.0000, 'ºC'),
	(328618, 146, '2015-01-15 00:55:14.000000', 'temperatura', 734.0000, 'ºC'),
	(328619, 146, '2015-01-15 00:55:15.000000', 'temperatura', 973.0000, 'ºC'),
	(328620, 146, '2015-01-15 00:55:16.000000', 'temperatura', 265.0000, 'ºC'),
	(328621, 146, '2015-01-15 00:55:17.000000', 'temperatura', 807.0000, 'ºC'),
	(328622, 146, '2015-01-15 00:55:18.000000', 'temperatura', 841.0000, 'ºC'),
	(328623, 146, '2015-01-15 00:55:19.000000', 'temperatura', 582.0000, 'ºC'),
	(328624, 146, '2015-01-15 00:55:20.000000', 'temperatura', 388.0000, 'ºC'),
	(328625, 146, '2015-01-15 00:55:21.000000', 'temperatura', 196.0000, 'ºC'),
	(328626, 146, '2015-01-15 00:55:22.000000', 'temperatura', 1017.0000, 'ºC'),
	(328627, 146, '2015-01-15 00:55:23.000000', 'temperatura', 895.0000, 'ºC'),
	(328628, 146, '2015-01-15 00:55:24.000000', 'temperatura', 228.0000, 'ºC'),
	(328629, 146, '2015-01-15 00:55:25.000000', 'temperatura', 853.0000, 'ºC'),
	(328630, 146, '2015-01-15 00:55:26.000000', 'temperatura', 1181.0000, 'ºC'),
	(328631, 146, '2015-01-15 00:55:27.000000', 'temperatura', 947.0000, 'ºC'),
	(328632, 146, '2015-01-15 00:55:28.000000', 'temperatura', 1194.0000, 'ºC'),
	(328633, 146, '2015-01-15 00:55:29.000000', 'temperatura', 727.0000, 'ºC'),
	(328634, 146, '2015-01-15 00:55:30.000000', 'temperatura', 55.0000, 'ºC'),
	(328635, 146, '2015-01-15 00:55:31.000000', 'temperatura', 493.0000, 'ºC'),
	(328636, 146, '2015-01-15 00:55:32.000000', 'temperatura', 1103.0000, 'ºC'),
	(328637, 146, '2015-01-15 00:55:33.000000', 'temperatura', 434.0000, 'ºC'),
	(328638, 146, '2015-01-15 00:55:34.000000', 'temperatura', 62.0000, 'ºC'),
	(328639, 146, '2015-01-15 00:55:35.000000', 'temperatura', 209.0000, 'ºC'),
	(328640, 146, '2015-01-15 00:55:36.000000', 'temperatura', 861.0000, 'ºC'),
	(328641, 146, '2015-01-15 00:55:37.000000', 'temperatura', 79.0000, 'ºC'),
	(328642, 146, '2015-01-15 00:55:38.000000', 'temperatura', 210.0000, 'ºC'),
	(328643, 146, '2015-01-15 00:55:39.000000', 'temperatura', 813.0000, 'ºC'),
	(328644, 146, '2015-01-15 00:55:40.000000', 'temperatura', 1036.0000, 'ºC'),
	(328645, 146, '2015-01-15 00:55:41.000000', 'temperatura', 342.0000, 'ºC'),
	(328646, 146, '2015-01-15 00:55:42.000000', 'temperatura', 1001.0000, 'ºC'),
	(328647, 146, '2015-01-15 00:55:43.000000', 'temperatura', 381.0000, 'ºC'),
	(328648, 146, '2015-01-15 00:55:44.000000', 'temperatura', 102.0000, 'ºC'),
	(328649, 146, '2015-01-15 00:55:45.000000', 'temperatura', 566.0000, 'ºC'),
	(328650, 146, '2015-01-15 00:55:46.000000', 'temperatura', 124.0000, 'ºC'),
	(328651, 146, '2015-01-15 00:55:47.000000', 'temperatura', 122.0000, 'ºC'),
	(328652, 146, '2015-01-15 00:55:48.000000', 'temperatura', 238.0000, 'ºC'),
	(328653, 146, '2015-01-15 00:55:49.000000', 'temperatura', 825.0000, 'ºC'),
	(328654, 146, '2015-01-15 00:55:50.000000', 'temperatura', 1010.0000, 'ºC'),
	(328655, 146, '2015-01-15 00:55:51.000000', 'temperatura', 176.0000, 'ºC'),
	(328656, 146, '2015-01-15 00:55:52.000000', 'temperatura', 252.0000, 'ºC'),
	(328657, 146, '2015-01-15 00:55:53.000000', 'temperatura', 730.0000, 'ºC'),
	(328658, 146, '2015-01-15 00:55:54.000000', 'temperatura', 496.0000, 'ºC'),
	(328659, 146, '2015-01-15 00:55:55.000000', 'temperatura', 292.0000, 'ºC'),
	(328660, 146, '2015-01-15 00:55:56.000000', 'temperatura', 1172.0000, 'ºC'),
	(328661, 146, '2015-01-15 00:55:57.000000', 'temperatura', 183.0000, 'ºC'),
	(328662, 146, '2015-01-15 00:55:58.000000', 'temperatura', 1000.0000, 'ºC'),
	(328663, 146, '2015-01-15 00:55:59.000000', 'temperatura', 850.0000, 'ºC'),
	(328664, 146, '2015-01-15 00:56:00.000000', 'temperatura', 52.0000, 'ºC'),
	(328665, 146, '2015-01-15 00:56:01.000000', 'temperatura', 112.0000, 'ºC'),
	(328666, 146, '2015-01-15 00:56:02.000000', 'temperatura', 404.0000, 'ºC'),
	(328667, 146, '2015-01-15 00:56:03.000000', 'temperatura', 484.0000, 'ºC'),
	(328668, 146, '2015-01-15 00:56:04.000000', 'temperatura', 10.0000, 'ºC'),
	(328669, 146, '2015-01-15 00:56:05.000000', 'temperatura', 995.0000, 'ºC'),
	(328670, 146, '2015-01-15 00:56:06.000000', 'temperatura', 149.0000, 'ºC'),
	(328671, 146, '2015-01-15 00:56:07.000000', 'temperatura', 158.0000, 'ºC'),
	(328672, 146, '2015-01-15 00:56:08.000000', 'temperatura', 342.0000, 'ºC'),
	(328673, 146, '2015-01-15 00:56:09.000000', 'temperatura', 40.0000, 'ºC'),
	(328674, 146, '2015-01-15 00:56:10.000000', 'temperatura', 374.0000, 'ºC'),
	(328675, 146, '2015-01-15 00:56:11.000000', 'temperatura', 549.0000, 'ºC'),
	(328676, 146, '2015-01-15 00:56:12.000000', 'temperatura', 426.0000, 'ºC'),
	(328677, 146, '2015-01-15 00:56:13.000000', 'temperatura', 483.0000, 'ºC'),
	(328678, 146, '2015-01-15 00:56:14.000000', 'temperatura', 1138.0000, 'ºC'),
	(328679, 146, '2015-01-15 00:56:15.000000', 'temperatura', 643.0000, 'ºC'),
	(328680, 146, '2015-01-15 00:56:16.000000', 'temperatura', 999.0000, 'ºC'),
	(328681, 146, '2015-01-15 00:56:17.000000', 'temperatura', 666.0000, 'ºC'),
	(328682, 146, '2015-01-15 00:56:18.000000', 'temperatura', 333.0000, 'ºC'),
	(328683, 146, '2015-01-15 00:56:19.000000', 'temperatura', 869.0000, 'ºC'),
	(328684, 146, '2015-01-15 00:56:20.000000', 'temperatura', 947.0000, 'ºC'),
	(328685, 146, '2015-01-15 00:56:21.000000', 'temperatura', 926.0000, 'ºC'),
	(328686, 146, '2015-01-15 00:56:22.000000', 'temperatura', 593.0000, 'ºC'),
	(328687, 146, '2015-01-15 00:56:23.000000', 'temperatura', 185.0000, 'ºC'),
	(328688, 146, '2015-01-15 00:56:24.000000', 'temperatura', 349.0000, 'ºC'),
	(328689, 146, '2015-01-15 00:56:25.000000', 'temperatura', 1190.0000, 'ºC'),
	(328690, 146, '2015-01-15 00:56:26.000000', 'temperatura', 103.0000, 'ºC'),
	(328691, 146, '2015-01-15 00:56:27.000000', 'temperatura', 545.0000, 'ºC'),
	(328692, 146, '2015-01-15 00:56:28.000000', 'temperatura', 15.0000, 'ºC'),
	(328693, 146, '2015-01-15 00:56:29.000000', 'temperatura', 841.0000, 'ºC'),
	(328694, 146, '2015-01-15 00:56:30.000000', 'temperatura', 562.0000, 'ºC'),
	(328695, 146, '2015-01-15 00:56:31.000000', 'temperatura', 288.0000, 'ºC'),
	(328696, 146, '2015-01-15 00:56:32.000000', 'temperatura', 954.0000, 'ºC'),
	(328697, 146, '2015-01-15 00:56:33.000000', 'temperatura', 306.0000, 'ºC'),
	(328698, 146, '2015-01-15 00:56:34.000000', 'temperatura', 1070.0000, 'ºC'),
	(328699, 146, '2015-01-15 00:56:35.000000', 'temperatura', 832.0000, 'ºC'),
	(328700, 146, '2015-01-15 00:56:36.000000', 'temperatura', 949.0000, 'ºC'),
	(328701, 146, '2015-01-15 00:56:37.000000', 'temperatura', 1049.0000, 'ºC'),
	(328702, 146, '2015-01-15 00:56:38.000000', 'temperatura', 0.0000, 'ºC'),
	(328703, 146, '2015-01-15 00:56:39.000000', 'temperatura', 452.0000, 'ºC'),
	(328704, 146, '2015-01-15 00:56:40.000000', 'temperatura', 1062.0000, 'ºC'),
	(328705, 146, '2015-01-15 00:56:41.000000', 'temperatura', 356.0000, 'ºC'),
	(328706, 146, '2015-01-15 00:56:42.000000', 'temperatura', 992.0000, 'ºC'),
	(328707, 146, '2015-01-15 00:56:43.000000', 'temperatura', 293.0000, 'ºC'),
	(328708, 146, '2015-01-15 00:56:44.000000', 'temperatura', 891.0000, 'ºC'),
	(328709, 146, '2015-01-15 00:56:45.000000', 'temperatura', 1177.0000, 'ºC'),
	(328710, 146, '2015-01-15 00:56:46.000000', 'temperatura', 812.0000, 'ºC'),
	(328711, 146, '2015-01-15 00:56:47.000000', 'temperatura', 528.0000, 'ºC'),
	(328712, 146, '2015-01-15 00:56:48.000000', 'temperatura', 204.0000, 'ºC'),
	(328713, 146, '2015-01-15 00:56:49.000000', 'temperatura', 636.0000, 'ºC'),
	(328714, 146, '2015-01-15 00:56:50.000000', 'temperatura', 169.0000, 'ºC'),
	(328715, 146, '2015-01-15 00:56:51.000000', 'temperatura', 138.0000, 'ºC'),
	(328716, 146, '2015-01-15 00:56:52.000000', 'temperatura', 181.0000, 'ºC'),
	(328717, 146, '2015-01-15 00:56:53.000000', 'temperatura', 495.0000, 'ºC'),
	(328718, 146, '2015-01-15 00:56:54.000000', 'temperatura', 732.0000, 'ºC'),
	(328719, 146, '2015-01-15 00:56:55.000000', 'temperatura', 976.0000, 'ºC'),
	(328720, 146, '2015-01-15 00:56:56.000000', 'temperatura', 286.0000, 'ºC'),
	(328721, 146, '2015-01-15 00:56:57.000000', 'temperatura', 900.0000, 'ºC'),
	(328722, 146, '2015-01-15 00:56:58.000000', 'temperatura', 45.0000, 'ºC'),
	(328723, 146, '2015-01-15 00:56:59.000000', 'temperatura', 1125.0000, 'ºC'),
	(328724, 146, '2015-01-15 00:57:00.000000', 'temperatura', 692.0000, 'ºC'),
	(328725, 146, '2015-01-15 00:57:01.000000', 'temperatura', 84.0000, 'ºC'),
	(328726, 146, '2015-01-15 00:57:02.000000', 'temperatura', 745.0000, 'ºC'),
	(328727, 146, '2015-01-15 00:57:03.000000', 'temperatura', 1073.0000, 'ºC'),
	(328728, 146, '2015-01-15 00:57:04.000000', 'temperatura', 731.0000, 'ºC'),
	(328729, 146, '2015-01-15 00:57:05.000000', 'temperatura', 437.0000, 'ºC'),
	(328730, 146, '2015-01-15 00:57:06.000000', 'temperatura', 1191.0000, 'ºC'),
	(328731, 146, '2015-01-15 00:57:07.000000', 'temperatura', 1044.0000, 'ºC'),
	(328732, 146, '2015-01-15 00:57:08.000000', 'temperatura', 448.0000, 'ºC'),
	(328733, 146, '2015-01-15 00:57:09.000000', 'temperatura', 308.0000, 'ºC'),
	(328734, 146, '2015-01-15 00:57:10.000000', 'temperatura', 198.0000, 'ºC'),
	(328735, 146, '2015-01-15 00:57:11.000000', 'temperatura', 64.0000, 'ºC'),
	(328736, 146, '2015-01-15 00:57:12.000000', 'temperatura', 928.0000, 'ºC'),
	(328737, 146, '2015-01-15 00:57:13.000000', 'temperatura', 848.0000, 'ºC'),
	(328738, 146, '2015-01-15 00:57:14.000000', 'temperatura', 258.0000, 'ºC'),
	(328739, 146, '2015-01-15 00:57:15.000000', 'temperatura', 1145.0000, 'ºC'),
	(328740, 146, '2015-01-15 00:57:16.000000', 'temperatura', 153.0000, 'ºC'),
	(328741, 146, '2015-01-15 00:57:17.000000', 'temperatura', 930.0000, 'ºC'),
	(328742, 146, '2015-01-15 00:57:18.000000', 'temperatura', 592.0000, 'ºC'),
	(328743, 146, '2015-01-15 00:57:19.000000', 'temperatura', 172.0000, 'ºC'),
	(328744, 146, '2015-01-15 00:57:20.000000', 'temperatura', 282.0000, 'ºC'),
	(328745, 146, '2015-01-15 00:57:21.000000', 'temperatura', 897.0000, 'ºC'),
	(328746, 146, '2015-01-15 00:57:22.000000', 'temperatura', 37.0000, 'ºC'),
	(328747, 146, '2015-01-15 00:57:23.000000', 'temperatura', 1097.0000, 'ºC'),
	(328748, 146, '2015-01-15 00:57:24.000000', 'temperatura', 575.0000, 'ºC'),
	(328749, 146, '2015-01-15 00:57:25.000000', 'temperatura', 783.0000, 'ºC'),
	(328750, 146, '2015-01-15 00:57:26.000000', 'temperatura', 992.0000, 'ºC'),
	(328751, 146, '2015-01-15 00:57:27.000000', 'temperatura', 212.0000, 'ºC'),
	(328752, 146, '2015-01-15 00:57:28.000000', 'temperatura', 486.0000, 'ºC'),
	(328753, 146, '2015-01-15 00:57:29.000000', 'temperatura', 591.0000, 'ºC'),
	(328754, 146, '2015-01-15 00:57:30.000000', 'temperatura', 298.0000, 'ºC'),
	(328755, 146, '2015-01-15 00:57:31.000000', 'temperatura', 916.0000, 'ºC'),
	(328756, 146, '2015-01-15 00:57:32.000000', 'temperatura', 88.0000, 'ºC'),
	(328757, 146, '2015-01-15 00:57:33.000000', 'temperatura', 93.0000, 'ºC'),
	(328758, 146, '2015-01-15 00:57:34.000000', 'temperatura', 201.0000, 'ºC'),
	(328759, 146, '2015-01-15 00:57:35.000000', 'temperatura', 728.0000, 'ºC'),
	(328760, 146, '2015-01-15 00:57:36.000000', 'temperatura', 636.0000, 'ºC'),
	(328761, 146, '2015-01-15 00:57:37.000000', 'temperatura', 998.0000, 'ºC'),
	(328762, 146, '2015-01-15 00:57:38.000000', 'temperatura', 682.0000, 'ºC'),
	(328763, 146, '2015-01-15 00:57:39.000000', 'temperatura', 414.0000, 'ºC'),
	(328764, 146, '2015-01-15 00:57:40.000000', 'temperatura', 27.0000, 'ºC'),
	(328765, 146, '2015-01-15 00:57:41.000000', 'temperatura', 95.0000, 'ºC'),
	(328766, 146, '2015-01-15 00:57:42.000000', 'temperatura', 392.0000, 'ºC'),
	(328767, 146, '2015-01-15 00:57:43.000000', 'temperatura', 478.0000, 'ºC'),
	(328768, 146, '2015-01-15 00:57:44.000000', 'temperatura', 13.0000, 'ºC'),
	(328769, 146, '2015-01-15 00:57:45.000000', 'temperatura', 1032.0000, 'ºC'),
	(328770, 146, '2015-01-15 00:57:46.000000', 'temperatura', 321.0000, 'ºC'),
	(328771, 146, '2015-01-15 00:57:47.000000', 'temperatura', 912.0000, 'ºC'),
	(328772, 146, '2015-01-15 00:57:48.000000', 'temperatura', 1195.0000, 'ºC'),
	(328773, 146, '2015-01-15 00:57:49.000000', 'temperatura', 841.0000, 'ºC'),
	(328774, 146, '2015-01-15 00:57:50.000000', 'temperatura', 619.0000, 'ºC'),
	(328775, 146, '2015-01-15 00:57:51.000000', 'temperatura', 574.0000, 'ºC'),
	(328776, 146, '2015-01-15 00:57:52.000000', 'temperatura', 1011.0000, 'ºC'),
	(328777, 146, '2015-01-15 00:57:53.000000', 'temperatura', 935.0000, 'ºC'),
	(328778, 146, '2015-01-15 00:57:54.000000', 'temperatura', 442.0000, 'ºC'),
	(328779, 146, '2015-01-15 00:57:55.000000', 'temperatura', 604.0000, 'ºC'),
	(328780, 146, '2015-01-15 00:57:56.000000', 'temperatura', 497.0000, 'ºC'),
	(328781, 146, '2015-01-15 00:57:57.000000', 'temperatura', 672.0000, 'ºC'),
	(328782, 146, '2015-01-15 00:57:58.000000', 'temperatura', 670.0000, 'ºC'),
	(328783, 146, '2015-01-15 00:57:59.000000', 'temperatura', 134.0000, 'ºC'),
	(328784, 146, '2015-01-15 00:58:00.000000', 'temperatura', 1063.0000, 'ºC'),
	(328785, 146, '2015-01-15 00:58:01.000000', 'temperatura', 110.0000, 'ºC'),
	(328786, 146, '2015-01-15 00:58:02.000000', 'temperatura', 964.0000, 'ºC'),
	(328787, 146, '2015-01-15 00:58:03.000000', 'temperatura', 891.0000, 'ºC'),
	(328788, 146, '2015-01-15 00:58:04.000000', 'temperatura', 364.0000, 'ºC'),
	(328789, 146, '2015-01-15 00:58:05.000000', 'temperatura', 345.0000, 'ºC'),
	(328790, 146, '2015-01-15 00:58:06.000000', 'temperatura', 633.0000, 'ºC'),
	(328791, 146, '2015-01-15 00:58:07.000000', 'temperatura', 931.0000, 'ºC'),
	(328792, 146, '2015-01-15 00:58:08.000000', 'temperatura', 359.0000, 'ºC'),
	(328793, 146, '2015-01-15 00:58:09.000000', 'temperatura', 200.0000, 'ºC'),
	(328794, 146, '2015-01-15 00:58:10.000000', 'temperatura', 1125.0000, 'ºC'),
	(328795, 146, '2015-01-15 00:58:11.000000', 'temperatura', 227.0000, 'ºC'),
	(328796, 146, '2015-01-15 00:58:12.000000', 'temperatura', 158.0000, 'ºC'),
	(328797, 146, '2015-01-15 00:58:13.000000', 'temperatura', 110.0000, 'ºC'),
	(328798, 146, '2015-01-15 00:58:14.000000', 'temperatura', 77.0000, 'ºC'),
	(328799, 146, '2015-01-15 00:58:15.000000', 'temperatura', 56.0000, 'ºC'),
	(328800, 146, '2015-01-15 00:58:16.000000', 'temperatura', 51.0000, 'ºC'),
	(328801, 146, '2015-01-15 00:58:17.000000', 'temperatura', 86.0000, 'ºC'),
	(328802, 146, '2015-01-15 00:58:18.000000', 'temperatura', 276.0000, 'ºC'),
	(328803, 146, '2015-01-15 00:58:19.000000', 'temperatura', 1124.0000, 'ºC'),
	(328804, 146, '2015-01-15 00:58:20.000000', 'temperatura', 1192.0000, 'ºC'),
	(328805, 146, '2015-01-15 00:58:21.000000', 'temperatura', 187.0000, 'ºC'),
	(328806, 146, '2015-01-15 00:58:22.000000', 'temperatura', 960.0000, 'ºC'),
	(328807, 146, '2015-01-15 00:58:23.000000', 'temperatura', 642.0000, 'ºC'),
	(328808, 146, '2015-01-15 00:58:24.000000', 'temperatura', 329.0000, 'ºC'),
	(328809, 146, '2015-01-15 00:58:25.000000', 'temperatura', 920.0000, 'ºC'),
	(328810, 146, '2015-01-15 00:58:26.000000', 'temperatura', 15.0000, 'ºC'),
	(328811, 146, '2015-01-15 00:58:27.000000', 'temperatura', 914.0000, 'ºC'),
	(328812, 146, '2015-01-15 00:58:28.000000', 'temperatura', 927.0000, 'ºC'),
	(328813, 146, '2015-01-15 00:58:29.000000', 'temperatura', 692.0000, 'ºC'),
	(328814, 146, '2015-01-15 00:58:30.000000', 'temperatura', 682.0000, 'ºC'),
	(328815, 146, '2015-01-15 00:58:31.000000', 'temperatura', 132.0000, 'ºC'),
	(328816, 146, '2015-01-15 00:58:32.000000', 'temperatura', 1014.0000, 'ºC'),
	(328817, 146, '2015-01-15 00:58:33.000000', 'temperatura', 1076.0000, 'ºC'),
	(328818, 146, '2015-01-15 00:58:34.000000', 'temperatura', 1136.0000, 'ºC'),
	(328819, 146, '2015-01-15 00:58:35.000000', 'temperatura', 54.0000, 'ºC'),
	(328820, 146, '2015-01-15 00:58:36.000000', 'temperatura', 464.0000, 'ºC'),
	(328821, 146, '2015-01-15 00:58:37.000000', 'temperatura', 956.0000, 'ºC'),
	(328822, 146, '2015-01-15 00:58:38.000000', 'temperatura', 990.0000, 'ºC'),
	(328823, 146, '2015-01-15 00:58:39.000000', 'temperatura', 882.0000, 'ºC'),
	(328824, 146, '2015-01-15 00:58:40.000000', 'temperatura', 239.0000, 'ºC'),
	(328825, 146, '2015-01-15 00:58:41.000000', 'temperatura', 949.0000, 'ºC'),
	(328826, 146, '2015-01-15 00:58:42.000000', 'temperatura', 430.0000, 'ºC'),
	(328827, 146, '2015-01-15 00:58:43.000000', 'temperatura', 504.0000, 'ºC'),
	(328828, 146, '2015-01-15 00:58:44.000000', 'temperatura', 29.0000, 'ºC'),
	(328829, 146, '2015-01-15 00:58:45.000000', 'temperatura', 1035.0000, 'ºC'),
	(328830, 146, '2015-01-15 00:58:46.000000', 'temperatura', 289.0000, 'ºC'),
	(328831, 146, '2015-01-15 00:58:47.000000', 'temperatura', 739.0000, 'ºC'),
	(328832, 146, '2015-01-15 00:58:48.000000', 'temperatura', 428.0000, 'ºC'),
	(328833, 146, '2015-01-15 00:58:49.000000', 'temperatura', 1123.0000, 'ºC'),
	(328834, 146, '2015-01-15 00:58:50.000000', 'temperatura', 732.0000, 'ºC'),
	(328835, 146, '2015-01-15 00:58:51.000000', 'temperatura', 293.0000, 'ºC'),
	(328836, 146, '2015-01-15 00:58:52.000000', 'temperatura', 468.0000, 'ºC'),
	(328837, 146, '2015-01-15 00:58:53.000000', 'temperatura', 261.0000, 'ºC'),
	(328838, 146, '2015-01-15 00:58:54.000000', 'temperatura', 1100.0000, 'ºC'),
	(328839, 146, '2015-01-15 00:58:55.000000', 'temperatura', 1119.0000, 'ºC'),
	(328840, 146, '2015-01-15 00:58:56.000000', 'temperatura', 1097.0000, 'ºC'),
	(328841, 146, '2015-01-15 00:58:57.000000', 'temperatura', 929.0000, 'ºC'),
	(328842, 146, '2015-01-15 00:58:58.000000', 'temperatura', 154.0000, 'ºC'),
	(328843, 146, '2015-01-15 00:58:59.000000', 'temperatura', 383.0000, 'ºC'),
	(328844, 146, '2015-01-15 00:59:00.000000', 'temperatura', 253.0000, 'ºC'),
	(328845, 146, '2015-01-15 00:59:01.000000', 'temperatura', 117.0000, 'ºC'),
	(328846, 146, '2015-01-15 00:59:02.000000', 'temperatura', 1026.0000, 'ºC'),
	(328847, 146, '2015-01-15 00:59:03.000000', 'temperatura', 1179.0000, 'ºC'),
	(328848, 146, '2015-01-15 00:59:04.000000', 'temperatura', 418.0000, 'ºC'),
	(328849, 146, '2015-01-15 00:59:05.000000', 'temperatura', 955.0000, 'ºC'),
	(328850, 146, '2015-01-15 00:59:06.000000', 'temperatura', 1120.0000, 'ºC'),
	(328851, 146, '2015-01-15 00:59:07.000000', 'temperatura', 338.0000, 'ºC'),
	(328852, 146, '2015-01-15 00:59:08.000000', 'temperatura', 728.0000, 'ºC'),
	(328853, 146, '2015-01-15 00:59:09.000000', 'temperatura', 226.0000, 'ºC'),
	(328854, 146, '2015-01-15 00:59:10.000000', 'temperatura', 148.0000, 'ºC'),
	(328855, 146, '2015-01-15 00:59:11.000000', 'temperatura', 60.0000, 'ºC'),
	(328856, 146, '2015-01-15 00:59:12.000000', 'temperatura', 1058.0000, 'ºC'),
	(328857, 146, '2015-01-15 00:59:13.000000', 'temperatura', 311.0000, 'ºC'),
	(328858, 146, '2015-01-15 00:59:14.000000', 'temperatura', 780.0000, 'ºC'),
	(328859, 146, '2015-01-15 00:59:15.000000', 'temperatura', 567.0000, 'ºC'),
	(328860, 146, '2015-01-15 00:59:16.000000', 'temperatura', 495.0000, 'ºC'),
	(328861, 146, '2015-01-15 00:59:17.000000', 'temperatura', 774.0000, 'ºC'),
	(328862, 146, '2015-01-15 00:59:18.000000', 'temperatura', 1185.0000, 'ºC'),
	(328863, 146, '2015-01-15 00:59:19.000000', 'temperatura', 4.0000, 'ºC'),
	(328864, 146, '2015-01-15 00:59:20.000000', 'temperatura', 68.0000, 'ºC'),
	(328865, 146, '2015-01-15 00:59:21.000000', 'temperatura', 327.0000, 'ºC'),
	(328866, 146, '2015-01-15 00:59:22.000000', 'temperatura', 230.0000, 'ºC'),
	(328867, 146, '2015-01-15 00:59:23.000000', 'temperatura', 170.0000, 'ºC'),
	(328868, 146, '2015-01-15 00:59:24.000000', 'temperatura', 159.0000, 'ºC'),
	(328869, 146, '2015-01-15 00:59:25.000000', 'temperatura', 289.0000, 'ºC'),
	(328870, 146, '2015-01-15 00:59:26.000000', 'temperatura', 966.0000, 'ºC'),
	(328871, 146, '2015-01-15 00:59:27.000000', 'temperatura', 364.0000, 'ºC'),
	(328872, 146, '2015-01-15 00:59:28.000000', 'temperatura', 124.0000, 'ºC'),
	(328873, 146, '2015-01-15 00:59:29.000000', 'temperatura', 727.0000, 'ºC'),
	(328874, 146, '2015-01-15 00:59:30.000000', 'temperatura', 863.0000, 'ºC'),
	(328875, 146, '2015-01-15 00:59:31.000000', 'temperatura', 933.0000, 'ºC'),
	(328876, 146, '2015-01-15 00:59:32.000000', 'temperatura', 878.0000, 'ºC'),
	(328877, 146, '2015-01-15 00:59:33.000000', 'temperatura', 392.0000, 'ºC'),
	(328878, 146, '2015-01-15 00:59:34.000000', 'temperatura', 527.0000, 'ºC'),
	(328879, 146, '2015-01-15 00:59:35.000000', 'temperatura', 261.0000, 'ºC'),
	(328880, 146, '2015-01-15 00:59:36.000000', 'temperatura', 922.0000, 'ºC'),
	(328881, 146, '2015-01-15 00:59:37.000000', 'temperatura', 230.0000, 'ºC'),
	(328882, 146, '2015-01-15 00:59:38.000000', 'temperatura', 782.0000, 'ºC'),
	(328883, 146, '2015-01-15 00:59:39.000000', 'temperatura', 822.0000, 'ºC'),
	(328884, 146, '2015-01-15 00:59:40.000000', 'temperatura', 563.0000, 'ºC'),
	(328885, 146, '2015-01-15 00:59:41.000000', 'temperatura', 350.0000, 'ºC'),
	(328886, 146, '2015-01-15 00:59:42.000000', 'temperatura', 63.0000, 'ºC'),
	(328887, 146, '2015-01-15 00:59:43.000000', 'temperatura', 466.0000, 'ºC'),
	(328888, 146, '2015-01-15 00:59:44.000000', 'temperatura', 940.0000, 'ºC'),
	(328889, 146, '2015-01-15 00:59:45.000000', 'temperatura', 905.0000, 'ºC'),
	(328890, 146, '2015-01-15 00:59:46.000000', 'temperatura', 503.0000, 'ºC'),
	(328891, 146, '2015-01-15 00:59:47.000000', 'temperatura', 1000.0000, 'ºC'),
	(328892, 146, '2015-01-15 00:59:48.000000', 'temperatura', 1094.0000, 'ºC'),
	(328893, 146, '2015-01-15 00:59:49.000000', 'temperatura', 68.0000, 'ºC'),
	(328894, 146, '2015-01-15 00:59:50.000000', 'temperatura', 661.0000, 'ºC'),
	(328895, 146, '2015-01-15 00:59:51.000000', 'temperatura', 701.0000, 'ºC'),
	(328896, 146, '2015-01-15 00:59:52.000000', 'temperatura', 323.0000, 'ºC'),
	(328897, 146, '2015-01-15 00:59:53.000000', 'temperatura', 711.0000, 'ºC'),
	(328898, 146, '2015-01-15 00:59:54.000000', 'temperatura', 187.0000, 'ºC'),
	(328899, 146, '2015-01-15 00:59:55.000000', 'temperatura', 4.0000, 'ºC'),
	(328900, 146, '2015-01-15 00:59:56.000000', 'temperatura', 660.0000, 'ºC'),
	(328901, 146, '2015-01-15 00:59:57.000000', 'temperatura', 889.0000, 'ºC'),
	(328902, 146, '2015-01-15 00:59:58.000000', 'temperatura', 65.0000, 'ºC'),
	(328903, 146, '2015-01-15 00:59:59.000000', 'temperatura', 57.0000, 'ºC'),
	(328904, 146, '2015-01-15 01:00:00.000000', 'temperatura', 89.0000, 'ºC'),
	(328905, 146, '2015-01-15 01:00:01.000000', 'temperatura', 278.0000, 'ºC'),
	(328906, 146, '2015-01-15 01:00:02.000000', 'temperatura', 1123.0000, 'ºC'),
	(328907, 146, '2015-01-15 01:00:03.000000', 'temperatura', 1180.0000, 'ºC'),
	(328908, 146, '2015-01-15 01:00:04.000000', 'temperatura', 133.0000, 'ºC'),
	(328909, 146, '2015-01-15 01:00:05.000000', 'temperatura', 726.0000, 'ºC'),
	(328910, 146, '2015-01-15 01:00:06.000000', 'temperatura', 831.0000, 'ºC'),
	(328911, 146, '2015-01-15 01:00:07.000000', 'temperatura', 777.0000, 'ºC'),
	(328912, 146, '2015-01-15 01:00:08.000000', 'temperatura', 193.0000, 'ºC'),
	(328913, 146, '2015-01-15 01:00:09.000000', 'temperatura', 1036.0000, 'ºC'),
	(328914, 146, '2015-01-15 01:00:10.000000', 'temperatura', 1000.0000, 'ºC'),
	(328915, 146, '2015-01-15 01:00:11.000000', 'temperatura', 694.0000, 'ºC'),
	(328916, 146, '2015-01-15 01:00:12.000000', 'temperatura', 468.0000, 'ºC'),
	(328917, 146, '2015-01-15 01:00:13.000000', 'temperatura', 261.0000, 'ºC'),
	(328918, 146, '2015-01-15 01:00:14.000000', 'temperatura', 1102.0000, 'ºC'),
	(328919, 146, '2015-01-15 01:00:15.000000', 'temperatura', 1127.0000, 'ºC'),
	(328920, 146, '2015-01-15 01:00:16.000000', 'temperatura', 1128.0000, 'ºC'),
	(328921, 146, '2015-01-15 01:00:17.000000', 'temperatura', 1061.0000, 'ºC'),
	(328922, 146, '2015-01-15 01:00:18.000000', 'temperatura', 719.0000, 'ºC'),
	(328923, 146, '2015-01-15 01:00:19.000000', 'temperatura', 413.0000, 'ºC'),
	(328924, 146, '2015-01-15 01:00:20.000000', 'temperatura', 1111.0000, 'ºC'),
	(328925, 146, '2015-01-15 01:00:21.000000', 'temperatura', 715.0000, 'ºC'),
	(328926, 146, '2015-01-15 01:00:22.000000', 'temperatura', 245.0000, 'ºC'),
	(328927, 146, '2015-01-15 01:00:23.000000', 'temperatura', 278.0000, 'ºC'),
	(328928, 146, '2015-01-15 01:00:24.000000', 'temperatura', 655.0000, 'ºC'),
	(328929, 146, '2015-01-15 01:00:25.000000', 'temperatura', 43.0000, 'ºC'),
	(328930, 146, '2015-01-15 01:00:26.000000', 'temperatura', 651.0000, 'ºC'),
	(328931, 146, '2015-01-15 01:00:27.000000', 'temperatura', 725.0000, 'ºC'),
	(328932, 146, '2015-01-15 01:00:28.000000', 'temperatura', 473.0000, 'ºC'),
	(328933, 146, '2015-01-15 01:00:29.000000', 'temperatura', 190.0000, 'ºC'),
	(328934, 146, '2015-01-15 01:00:30.000000', 'temperatura', 734.0000, 'ºC'),
	(328935, 146, '2015-01-15 01:00:31.000000', 'temperatura', 699.0000, 'ºC'),
	(328936, 146, '2015-01-15 01:00:32.000000', 'temperatura', 92.0000, 'ºC'),
	(328937, 146, '2015-01-15 01:00:33.000000', 'temperatura', 763.0000, 'ºC'),
	(328938, 146, '2015-01-15 01:00:34.000000', 'temperatura', 1140.0000, 'ºC'),
	(328939, 146, '2015-01-15 01:00:35.000000', 'temperatura', 1013.0000, 'ºC'),
	(328940, 146, '2015-01-15 01:00:36.000000', 'temperatura', 445.0000, 'ºC'),
	(328941, 146, '2015-01-15 01:00:37.000000', 'temperatura', 388.0000, 'ºC'),
	(328942, 146, '2015-01-15 01:00:38.000000', 'temperatura', 606.0000, 'ºC'),
	(328943, 146, '2015-01-15 01:00:39.000000', 'temperatura', 666.0000, 'ºC'),
	(328944, 146, '2015-01-15 01:00:40.000000', 'temperatura', 312.0000, 'ºC'),
	(328945, 146, '2015-01-15 01:00:41.000000', 'temperatura', 763.0000, 'ºC'),
	(328946, 146, '2015-01-15 01:00:42.000000', 'temperatura', 480.0000, 'ºC'),
	(328947, 146, '2015-01-15 01:00:43.000000', 'temperatura', 111.0000, 'ºC'),
	(328948, 146, '2015-01-15 01:00:44.000000', 'temperatura', 317.0000, 'ºC'),
	(328949, 146, '2015-01-15 01:00:45.000000', 'temperatura', 53.0000, 'ºC'),
	(328950, 146, '2015-01-15 01:00:46.000000', 'temperatura', 513.0000, 'ºC'),
	(328951, 146, '2015-01-15 01:00:47.000000', 'temperatura', 8.0000, 'ºC'),
	(328952, 146, '2015-01-15 01:00:48.000000', 'temperatura', 901.0000, 'ºC'),
	(328953, 146, '2015-01-15 01:00:49.000000', 'temperatura', 882.0000, 'ºC'),
	(328954, 146, '2015-01-15 01:00:50.000000', 'temperatura', 506.0000, 'ºC'),
	(328955, 146, '2015-01-15 01:00:51.000000', 'temperatura', 1087.0000, 'ºC'),
	(328956, 146, '2015-01-15 01:00:52.000000', 'temperatura', 316.0000, 'ºC'),
	(328957, 146, '2015-01-15 01:00:53.000000', 'temperatura', 721.0000, 'ºC'),
	(328958, 146, '2015-01-15 01:00:54.000000', 'temperatura', 255.0000, 'ºC'),
	(328959, 146, '2015-01-15 01:00:55.000000', 'temperatura', 314.0000, 'ºC'),
	(328960, 146, '2015-01-15 01:00:56.000000', 'temperatura', 804.0000, 'ºC'),
	(328961, 146, '2015-01-15 01:00:57.000000', 'temperatura', 679.0000, 'ºC'),
	(328962, 146, '2015-01-15 01:00:58.000000', 'temperatura', 982.0000, 'ºC'),
	(328963, 146, '2015-01-15 01:00:59.000000', 'temperatura', 475.0000, 'ºC'),
	(328964, 146, '2015-01-15 01:01:00.000000', 'temperatura', 628.0000, 'ºC'),
	(328965, 146, '2015-01-15 01:01:01.000000', 'temperatura', 516.0000, 'ºC'),
	(328966, 146, '2015-01-15 01:01:02.000000', 'temperatura', 697.0000, 'ºC'),
	(328967, 146, '2015-01-15 01:01:03.000000', 'temperatura', 739.0000, 'ºC'),
	(328968, 146, '2015-01-15 01:01:04.000000', 'temperatura', 402.0000, 'ºC'),
	(328969, 146, '2015-01-15 01:01:05.000000', 'temperatura', 996.0000, 'ºC'),
	(328970, 146, '2015-01-15 01:01:06.000000', 'temperatura', 175.0000, 'ºC'),
	(328971, 146, '2015-01-15 01:01:07.000000', 'temperatura', 286.0000, 'ºC'),
	(328972, 146, '2015-01-15 01:01:08.000000', 'temperatura', 908.0000, 'ºC'),
	(328973, 146, '2015-01-15 01:01:09.000000', 'temperatura', 80.0000, 'ºC'),
	(328974, 146, '2015-01-15 01:01:10.000000', 'temperatura', 76.0000, 'ºC'),
	(328975, 146, '2015-01-15 01:01:11.000000', 'temperatura', 142.0000, 'ºC'),
	(328976, 146, '2015-01-15 01:01:12.000000', 'temperatura', 484.0000, 'ºC'),
	(328977, 146, '2015-01-15 01:01:13.000000', 'temperatura', 792.0000, 'ºC'),
	(328978, 146, '2015-01-15 01:01:14.000000', 'temperatura', 108.0000, 'ºC'),
	(328979, 146, '2015-01-15 01:01:15.000000', 'temperatura', 565.0000, 'ºC'),
	(328980, 146, '2015-01-15 01:01:16.000000', 'temperatura', 103.0000, 'ºC'),
	(328981, 146, '2015-01-15 01:01:17.000000', 'temperatura', 21.0000, 'ºC'),
	(328982, 146, '2015-01-15 01:01:18.000000', 'temperatura', 995.0000, 'ºC'),
	(328983, 146, '2015-01-15 01:01:19.000000', 'temperatura', 111.0000, 'ºC'),
	(328984, 146, '2015-01-15 01:01:20.000000', 'temperatura', 1174.0000, 'ºC'),
	(328985, 146, '2015-01-15 01:01:21.000000', 'temperatura', 735.0000, 'ºC'),
	(328986, 146, '2015-01-15 01:01:22.000000', 'temperatura', 154.0000, 'ºC'),
	(328987, 146, '2015-01-15 01:01:23.000000', 'temperatura', 965.0000, 'ºC'),
	(328988, 146, '2015-01-15 01:01:24.000000', 'temperatura', 763.0000, 'ºC'),
	(328989, 146, '2015-01-15 01:01:25.000000', 'temperatura', 921.0000, 'ºC'),
	(328990, 146, '2015-01-15 01:01:26.000000', 'temperatura', 1116.0000, 'ºC'),
	(328991, 146, '2015-01-15 01:01:27.000000', 'temperatura', 419.0000, 'ºC'),
	(328992, 146, '2015-01-15 01:01:28.000000', 'temperatura', 1147.0000, 'ºC'),
	(328993, 146, '2015-01-15 01:01:29.000000', 'temperatura', 877.0000, 'ºC'),
	(328994, 146, '2015-01-15 01:01:30.000000', 'temperatura', 946.0000, 'ºC'),
	(328995, 146, '2015-01-15 01:01:31.000000', 'temperatura', 899.0000, 'ºC'),
	(328996, 146, '2015-01-15 01:01:32.000000', 'temperatura', 457.0000, 'ºC'),
	(328997, 146, '2015-01-15 01:01:33.000000', 'temperatura', 788.0000, 'ºC'),
	(328998, 146, '2015-01-15 01:01:34.000000', 'temperatura', 169.0000, 'ºC'),
	(328999, 146, '2015-01-15 01:01:35.000000', 'temperatura', 883.0000, 'ºC'),
	(329000, 146, '2015-01-15 01:01:36.000000', 'temperatura', 306.0000, 'ºC'),
	(329001, 146, '2015-01-15 01:01:37.000000', 'temperatura', 83.0000, 'ºC'),
	(329002, 146, '2015-01-15 01:01:38.000000', 'temperatura', 697.0000, 'ºC'),
	(329003, 146, '2015-01-15 01:01:39.000000', 'temperatura', 836.0000, 'ºC'),
	(329004, 146, '2015-01-15 01:01:40.000000', 'temperatura', 891.0000, 'ºC'),
	(329005, 146, '2015-01-15 01:01:41.000000', 'temperatura', 749.0000, 'ºC'),
	(329006, 146, '2015-01-15 01:01:42.000000', 'temperatura', 1070.0000, 'ºC'),
	(329007, 146, '2015-01-15 01:01:43.000000', 'temperatura', 706.0000, 'ºC'),
	(329008, 146, '2015-01-15 01:01:44.000000', 'temperatura', 318.0000, 'ºC'),
	(329009, 146, '2015-01-15 01:01:45.000000', 'temperatura', 673.0000, 'ºC'),
	(329010, 146, '2015-01-15 01:01:46.000000', 'temperatura', 13.0000, 'ºC'),
	(329011, 146, '2015-01-15 01:01:47.000000', 'temperatura', 444.0000, 'ºC'),
	(329012, 146, '2015-01-15 01:01:48.000000', 'temperatura', 985.0000, 'ºC'),
	(329013, 146, '2015-01-15 01:01:49.000000', 'temperatura', 1191.0000, 'ºC'),
	(329014, 146, '2015-01-15 01:01:50.000000', 'temperatura', 599.0000, 'ºC'),
	(329015, 146, '2015-01-15 01:01:51.000000', 'temperatura', 625.0000, 'ºC'),
	(329016, 146, '2015-01-15 01:01:52.000000', 'temperatura', 128.0000, 'ºC'),
	(329017, 146, '2015-01-15 01:01:53.000000', 'temperatura', 1167.0000, 'ºC'),
	(329018, 146, '2015-01-15 01:01:54.000000', 'temperatura', 651.0000, 'ºC'),
	(329019, 146, '2015-01-15 01:01:55.000000', 'temperatura', 954.0000, 'ºC'),
	(329020, 146, '2015-01-15 01:01:56.000000', 'temperatura', 418.0000, 'ºC'),
	(329021, 146, '2015-01-15 01:01:57.000000', 'temperatura', 427.0000, 'ºC'),
	(329022, 146, '2015-01-15 01:01:58.000000', 'temperatura', 882.0000, 'ºC'),
	(329023, 146, '2015-01-15 01:01:59.000000', 'temperatura', 731.0000, 'ºC'),
	(329024, 146, '2015-01-15 01:02:00.000000', 'temperatura', 1009.0000, 'ºC'),
	(329025, 146, '2015-01-15 01:02:01.000000', 'temperatura', 452.0000, 'ºC'),
	(329026, 146, '2015-01-15 01:02:02.000000', 'temperatura', 433.0000, 'ºC'),
	(329027, 146, '2015-01-15 01:02:03.000000', 'temperatura', 811.0000, 'ºC'),
	(329028, 146, '2015-01-15 01:02:04.000000', 'temperatura', 358.0000, 'ºC'),
	(329029, 146, '2015-01-15 01:02:05.000000', 'temperatura', 554.0000, 'ºC'),
	(329030, 146, '2015-01-15 01:02:06.000000', 'temperatura', 498.0000, 'ºC'),
	(329031, 146, '2015-01-15 01:02:07.000000', 'temperatura', 828.0000, 'ºC'),
	(329032, 146, '2015-01-15 01:02:08.000000', 'temperatura', 245.0000, 'ºC'),
	(329033, 146, '2015-01-15 01:02:09.000000', 'temperatura', 1142.0000, 'ºC'),
	(329034, 146, '2015-01-15 01:02:10.000000', 'temperatura', 174.0000, 'ºC'),
	(329035, 146, '2015-01-15 01:02:11.000000', 'temperatura', 1047.0000, 'ºC'),
	(329036, 146, '2015-01-15 01:02:12.000000', 'temperatura', 1111.0000, 'ºC'),
	(329037, 146, '2015-01-15 01:02:13.000000', 'temperatura', 15.0000, 'ºC'),
	(329038, 146, '2015-01-15 01:02:14.000000', 'temperatura', 342.0000, 'ºC'),
	(329039, 146, '2015-01-15 01:02:15.000000', 'temperatura', 465.0000, 'ºC'),
	(329040, 146, '2015-01-15 01:02:16.000000', 'temperatura', 100.0000, 'ºC'),
	(329041, 146, '2015-01-15 01:02:17.000000', 'temperatura', 305.0000, 'ºC'),
	(329042, 146, '2015-01-15 01:02:18.000000', 'temperatura', 28.0000, 'ºC'),
	(329043, 146, '2015-01-15 01:02:19.000000', 'temperatura', 424.0000, 'ºC'),
	(329044, 146, '2015-01-15 01:02:20.000000', 'temperatura', 836.0000, 'ºC'),
	(329045, 146, '2015-01-15 01:02:21.000000', 'temperatura', 510.0000, 'ºC'),
	(329046, 146, '2015-01-15 01:02:22.000000', 'temperatura', 40.0000, 'ºC'),
	(329047, 146, '2015-01-15 01:02:23.000000', 'temperatura', 1072.0000, 'ºC'),
	(329048, 146, '2015-01-15 01:02:24.000000', 'temperatura', 441.0000, 'ºC'),
	(329049, 146, '2015-01-15 01:02:25.000000', 'temperatura', 191.0000, 'ºC'),
	(329050, 146, '2015-01-15 01:02:26.000000', 'temperatura', 831.0000, 'ºC'),
	(329051, 146, '2015-01-15 01:02:27.000000', 'temperatura', 1184.0000, 'ºC'),
	(329052, 146, '2015-01-15 01:02:28.000000', 'temperatura', 1024.0000, 'ºC'),
	(329053, 146, '2015-01-15 01:02:29.000000', 'temperatura', 372.0000, 'ºC'),
	(329054, 146, '2015-01-15 01:02:30.000000', 'temperatura', 1188.0000, 'ºC'),
	(329055, 146, '2015-01-15 01:02:31.000000', 'temperatura', 24.0000, 'ºC'),
	(329056, 146, '2015-01-15 01:02:32.000000', 'temperatura', 155.0000, 'ºC'),
	(329057, 146, '2015-01-15 01:02:33.000000', 'temperatura', 705.0000, 'ºC'),
	(329058, 146, '2015-01-15 01:02:34.000000', 'temperatura', 662.0000, 'ºC'),
	(329059, 146, '2015-01-15 01:02:35.000000', 'temperatura', 1194.0000, 'ºC'),
	(329060, 146, '2015-01-15 01:02:36.000000', 'temperatura', 383.0000, 'ºC'),
	(329061, 146, '2015-01-15 01:02:37.000000', 'temperatura', 734.0000, 'ºC'),
	(329062, 146, '2015-01-15 01:02:38.000000', 'temperatura', 122.0000, 'ºC'),
	(329063, 146, '2015-01-15 01:02:39.000000', 'temperatura', 810.0000, 'ºC'),
	(329064, 146, '2015-01-15 01:02:40.000000', 'temperatura', 81.0000, 'ºC'),
	(329065, 146, '2015-01-15 01:02:41.000000', 'temperatura', 379.0000, 'ºC'),
	(329066, 146, '2015-01-15 01:02:42.000000', 'temperatura', 452.0000, 'ºC'),
	(329067, 146, '2015-01-15 01:02:43.000000', 'temperatura', 1123.0000, 'ºC'),
	(329068, 146, '2015-01-15 01:02:44.000000', 'temperatura', 658.0000, 'ºC'),
	(329069, 146, '2015-01-15 01:02:45.000000', 'temperatura', 1121.0000, 'ºC'),
	(329070, 146, '2015-01-15 01:02:46.000000', 'temperatura', 34.0000, 'ºC'),
	(329071, 146, '2015-01-15 01:02:47.000000', 'temperatura', 406.0000, 'ºC'),
	(329072, 146, '2015-01-15 01:02:48.000000', 'temperatura', 729.0000, 'ºC'),
	(329073, 146, '2015-01-15 01:02:49.000000', 'temperatura', 26.0000, 'ºC'),
	(329074, 146, '2015-01-15 01:02:50.000000', 'temperatura', 345.0000, 'ºC'),
	(329075, 146, '2015-01-15 01:02:51.000000', 'temperatura', 449.0000, 'ºC'),
	(329076, 146, '2015-01-15 01:02:52.000000', 'temperatura', 10.0000, 'ºC'),
	(329077, 146, '2015-01-15 01:02:53.000000', 'temperatura', 1103.0000, 'ºC'),
	(329078, 146, '2015-01-15 01:02:54.000000', 'temperatura', 686.0000, 'ºC'),
	(329079, 146, '2015-01-15 01:02:55.000000', 'temperatura', 122.0000, 'ºC'),
	(329080, 146, '2015-01-15 01:02:56.000000', 'temperatura', 954.0000, 'ºC'),
	(329081, 146, '2015-01-15 01:02:57.000000', 'temperatura', 801.0000, 'ºC'),
	(329082, 146, '2015-01-15 01:02:58.000000', 'temperatura', 1147.0000, 'ºC'),
	(329083, 146, '2015-01-15 01:02:59.000000', 'temperatura', 931.0000, 'ºC'),
	(329084, 146, '2015-01-15 01:03:00.000000', 'temperatura', 14.0000, 'ºC'),
	(329085, 146, '2015-01-15 01:03:01.000000', 'temperatura', 879.0000, 'ºC'),
	(329086, 146, '2015-01-15 01:03:02.000000', 'temperatura', 754.0000, 'ºC'),
	(329087, 146, '2015-01-15 01:03:03.000000', 'temperatura', 1133.0000, 'ºC'),
	(329088, 146, '2015-01-15 01:03:04.000000', 'temperatura', 1005.0000, 'ºC'),
	(329089, 146, '2015-01-15 01:03:05.000000', 'temperatura', 424.0000, 'ºC'),
	(329090, 146, '2015-01-15 01:03:06.000000', 'temperatura', 306.0000, 'ºC'),
	(329091, 146, '2015-01-15 01:03:07.000000', 'temperatura', 258.0000, 'ºC'),
	(329092, 146, '2015-01-15 01:03:08.000000', 'temperatura', 374.0000, 'ºC'),
	(329093, 146, '2015-01-15 01:03:09.000000', 'temperatura', 1096.0000, 'ºC'),
	(329094, 146, '2015-01-15 01:03:10.000000', 'temperatura', 760.0000, 'ºC'),
	(329095, 146, '2015-01-15 01:03:11.000000', 'temperatura', 510.0000, 'ºC'),
	(329096, 146, '2015-01-15 01:03:12.000000', 'temperatura', 272.0000, 'ºC'),
	(329097, 146, '2015-01-15 01:03:13.000000', 'temperatura', 1030.0000, 'ºC'),
	(329098, 146, '2015-01-15 01:03:14.000000', 'temperatura', 734.0000, 'ºC'),
	(329099, 146, '2015-01-15 01:03:15.000000', 'temperatura', 583.0000, 'ºC'),
	(329100, 146, '2015-01-15 01:03:16.000000', 'temperatura', 710.0000, 'ºC'),
	(329101, 146, '2015-01-15 01:03:17.000000', 'temperatura', 604.0000, 'ºC'),
	(329102, 146, '2015-01-15 01:03:18.000000', 'temperatura', 890.0000, 'ºC'),
	(329103, 146, '2015-01-15 01:03:19.000000', 'temperatura', 237.0000, 'ºC'),
	(329104, 146, '2015-01-15 01:03:20.000000', 'temperatura', 917.0000, 'ºC'),
	(329105, 146, '2015-01-15 01:03:21.000000', 'temperatura', 272.0000, 'ºC'),
	(329106, 146, '2015-01-15 01:03:22.000000', 'temperatura', 1012.0000, 'ºC'),
	(329107, 146, '2015-01-15 01:03:23.000000', 'temperatura', 642.0000, 'ºC'),
	(329108, 146, '2015-01-15 01:03:24.000000', 'temperatura', 177.0000, 'ºC'),
	(329109, 146, '2015-01-15 01:03:25.000000', 'temperatura', 157.0000, 'ºC'),
	(329110, 146, '2015-01-15 01:03:26.000000', 'temperatura', 255.0000, 'ºC'),
	(329111, 146, '2015-01-15 01:03:27.000000', 'temperatura', 804.0000, 'ºC'),
	(329112, 146, '2015-01-15 01:03:28.000000', 'temperatura', 856.0000, 'ºC'),
	(329113, 146, '2015-01-15 01:03:29.000000', 'temperatura', 667.0000, 'ºC'),
	(329114, 146, '2015-01-15 01:03:30.000000', 'temperatura', 770.0000, 'ºC'),
	(329115, 146, '2015-01-15 01:03:31.000000', 'temperatura', 647.0000, 'ºC'),
	(329116, 146, '2015-01-15 01:03:32.000000', 'temperatura', 926.0000, 'ºC'),
	(329117, 146, '2015-01-15 01:03:33.000000', 'temperatura', 291.0000, 'ºC'),
	(329118, 146, '2015-01-15 01:03:34.000000', 'temperatura', 1078.0000, 'ºC'),
	(329119, 146, '2015-01-15 01:03:35.000000', 'temperatura', 915.0000, 'ºC'),
	(329120, 146, '2015-01-15 01:03:36.000000', 'temperatura', 143.0000, 'ºC'),
	(329121, 146, '2015-01-15 01:03:37.000000', 'temperatura', 371.0000, 'ºC'),
	(329122, 146, '2015-01-15 01:03:38.000000', 'temperatura', 227.0000, 'ºC'),
	(329123, 146, '2015-01-15 01:03:39.000000', 'temperatura', 24.0000, 'ºC'),
	(329124, 146, '2015-01-15 01:03:40.000000', 'temperatura', 636.0000, 'ºC'),
	(329125, 146, '2015-01-15 01:03:41.000000', 'temperatura', 710.0000, 'ºC'),
	(329126, 146, '2015-01-15 01:03:42.000000', 'temperatura', 444.0000, 'ºC'),
	(329127, 146, '2015-01-15 01:03:43.000000', 'temperatura', 87.0000, 'ºC'),
	(329128, 146, '2015-01-15 01:03:44.000000', 'temperatura', 307.0000, 'ºC'),
	(329129, 146, '2015-01-15 01:03:45.000000', 'temperatura', 74.0000, 'ºC'),
	(329130, 146, '2015-01-15 01:03:46.000000', 'temperatura', 649.0000, 'ºC'),
	(329131, 146, '2015-01-15 01:03:47.000000', 'temperatura', 623.0000, 'ºC'),
	(329132, 146, '2015-01-15 01:03:48.000000', 'temperatura', 1170.0000, 'ºC'),
	(329133, 146, '2015-01-15 01:03:49.000000', 'temperatura', 382.0000, 'ºC'),
	(329134, 146, '2015-01-15 01:03:50.000000', 'temperatura', 799.0000, 'ºC'),
	(329135, 146, '2015-01-15 01:03:51.000000', 'temperatura', 452.0000, 'ºC'),
	(329136, 146, '2015-01-15 01:03:52.000000', 'temperatura', 1060.0000, 'ºC'),
	(329137, 146, '2015-01-15 01:03:53.000000', 'temperatura', 346.0000, 'ºC'),
	(329138, 146, '2015-01-15 01:03:54.000000', 'temperatura', 950.0000, 'ºC'),
	(329139, 146, '2015-01-15 01:03:55.000000', 'temperatura', 114.0000, 'ºC'),
	(329140, 146, '2015-01-15 01:03:56.000000', 'temperatura', 121.0000, 'ºC'),
	(329141, 146, '2015-01-15 01:03:57.000000', 'temperatura', 262.0000, 'ºC'),
	(329142, 146, '2015-01-15 01:03:58.000000', 'temperatura', 949.0000, 'ºC'),
	(329143, 146, '2015-01-15 01:03:59.000000', 'temperatura', 358.0000, 'ºC'),
	(329144, 146, '2015-01-15 01:04:00.000000', 'temperatura', 144.0000, 'ºC'),
	(329145, 146, '2015-01-15 01:04:01.000000', 'temperatura', 846.0000, 'ºC'),
	(329146, 146, '2015-01-15 01:04:02.000000', 'temperatura', 200.0000, 'ºC'),
	(329147, 146, '2015-01-15 01:04:03.000000', 'temperatura', 860.0000, 'ºC'),
	(329148, 146, '2015-01-15 01:04:04.000000', 'temperatura', 100.0000, 'ºC'),
	(329149, 146, '2015-01-15 01:04:05.000000', 'temperatura', 323.0000, 'ºC'),
	(329150, 146, '2015-01-15 01:04:06.000000', 'temperatura', 113.0000, 'ºC'),
	(329151, 146, '2015-01-15 01:04:07.000000', 'temperatura', 796.0000, 'ºC'),
	(329152, 146, '2015-01-15 01:04:08.000000', 'temperatura', 44.0000, 'ºC'),
	(329153, 146, '2015-01-15 01:04:09.000000', 'temperatura', 233.0000, 'ºC'),
	(329154, 146, '2015-01-15 01:04:10.000000', 'temperatura', 1033.0000, 'ºC'),
	(329155, 146, '2015-01-15 01:04:11.000000', 'temperatura', 868.0000, 'ºC'),
	(329156, 146, '2015-01-15 01:04:12.000000', 'temperatura', 40.0000, 'ºC'),
	(329157, 146, '2015-01-15 01:04:13.000000', 'temperatura', 1196.0000, 'ºC'),
	(329158, 146, '2015-01-15 01:04:14.000000', 'temperatura', 1062.0000, 'ºC'),
	(329159, 146, '2015-01-15 01:04:15.000000', 'temperatura', 521.0000, 'ºC'),
	(329160, 146, '2015-01-15 01:04:16.000000', 'temperatura', 618.0000, 'ºC'),
	(329161, 146, '2015-01-15 01:04:17.000000', 'temperatura', 329.0000, 'ºC'),
	(329162, 146, '2015-01-15 01:04:18.000000', 'temperatura', 990.0000, 'ºC'),
	(329163, 146, '2015-01-15 01:04:19.000000', 'temperatura', 363.0000, 'ºC'),
	(329164, 146, '2015-01-15 01:04:20.000000', 'temperatura', 45.0000, 'ºC'),
	(329165, 146, '2015-01-15 01:04:21.000000', 'temperatura', 337.0000, 'ºC'),
	(329166, 146, '2015-01-15 01:04:22.000000', 'temperatura', 351.0000, 'ºC'),
	(329167, 146, '2015-01-15 01:04:23.000000', 'temperatura', 745.0000, 'ºC'),
	(329168, 146, '2015-01-15 01:04:24.000000', 'temperatura', 274.0000, 'ºC'),
	(329169, 146, '2015-01-15 01:04:25.000000', 'temperatura', 333.0000, 'ºC'),
	(329170, 146, '2015-01-15 01:04:26.000000', 'temperatura', 846.0000, 'ºC'),
	(329171, 146, '2015-01-15 01:04:27.000000', 'temperatura', 828.0000, 'ºC'),
	(329172, 146, '2015-01-15 01:04:28.000000', 'temperatura', 406.0000, 'ºC'),
	(329173, 146, '2015-01-15 01:04:29.000000', 'temperatura', 746.0000, 'ºC'),
	(329174, 146, '2015-01-15 01:04:30.000000', 'temperatura', 110.0000, 'ºC'),
	(329175, 146, '2015-01-15 01:04:31.000000', 'temperatura', 715.0000, 'ºC'),
	(329176, 146, '2015-01-15 01:04:32.000000', 'temperatura', 843.0000, 'ºC'),
	(329177, 146, '2015-01-15 01:04:33.000000', 'temperatura', 871.0000, 'ºC'),
	(329178, 146, '2015-01-15 01:04:34.000000', 'temperatura', 625.0000, 'ºC'),
	(329179, 146, '2015-01-15 01:04:35.000000', 'temperatura', 515.0000, 'ºC'),
	(329180, 146, '2015-01-15 01:04:36.000000', 'temperatura', 698.0000, 'ºC'),
	(329181, 146, '2015-01-15 01:04:37.000000', 'temperatura', 746.0000, 'ºC'),
	(329182, 146, '2015-01-15 01:04:38.000000', 'temperatura', 439.0000, 'ºC'),
	(329183, 146, '2015-01-15 01:04:39.000000', 'temperatura', 1156.0000, 'ºC'),
	(329184, 146, '2015-01-15 01:04:40.000000', 'temperatura', 864.0000, 'ºC'),
	(329185, 146, '2015-01-15 01:04:41.000000', 'temperatura', 851.0000, 'ºC'),
	(329186, 146, '2015-01-15 01:04:42.000000', 'temperatura', 466.0000, 'ºC'),
	(329187, 146, '2015-01-15 01:04:43.000000', 'temperatura', 978.0000, 'ºC'),
	(329188, 146, '2015-01-15 01:04:44.000000', 'temperatura', 1089.0000, 'ºC'),
	(329189, 146, '2015-01-15 01:04:45.000000', 'temperatura', 115.0000, 'ºC'),
	(329190, 146, '2015-01-15 01:04:46.000000', 'temperatura', 906.0000, 'ºC'),
	(329191, 146, '2015-01-15 01:04:47.000000', 'temperatura', 588.0000, 'ºC'),
	(329192, 146, '2015-01-15 01:04:48.000000', 'temperatura', 222.0000, 'ºC'),
	(329193, 146, '2015-01-15 01:04:49.000000', 'temperatura', 545.0000, 'ºC'),
	(329194, 146, '2015-01-15 01:04:50.000000', 'temperatura', 859.0000, 'ºC'),
	(329195, 146, '2015-01-15 01:04:51.000000', 'temperatura', 260.0000, 'ºC'),
	(329196, 146, '2015-01-15 01:04:52.000000', 'temperatura', 1125.0000, 'ºC'),
	(329197, 146, '2015-01-15 01:04:53.000000', 'temperatura', 45.0000, 'ºC'),
	(329198, 146, '2015-01-15 01:04:54.000000', 'temperatura', 450.0000, 'ºC'),
	(329199, 146, '2015-01-15 01:04:55.000000', 'temperatura', 915.0000, 'ºC'),
	(329200, 146, '2015-01-15 01:04:56.000000', 'temperatura', 827.0000, 'ºC'),
	(329201, 146, '2015-01-15 01:04:57.000000', 'temperatura', 188.0000, 'ºC'),
	(329202, 146, '2015-01-15 01:04:58.000000', 'temperatura', 862.0000, 'ºC'),
	(329203, 146, '2015-01-15 01:04:59.000000', 'temperatura', 145.0000, 'ºC'),
	(329204, 146, '2015-01-15 01:05:00.000000', 'temperatura', 540.0000, 'ºC'),
	(329205, 146, '2015-01-15 01:05:01.000000', 'temperatura', 1066.0000, 'ºC'),
	(329206, 146, '2015-01-15 01:05:02.000000', 'temperatura', 109.0000, 'ºC'),
	(329207, 146, '2015-01-15 01:05:03.000000', 'temperatura', 948.0000, 'ºC'),
	(329208, 146, '2015-01-15 01:05:04.000000', 'temperatura', 813.0000, 'ºC'),
	(329209, 146, '2015-01-15 01:05:05.000000', 'temperatura', 20.0000, 'ºC'),
	(329210, 146, '2015-01-15 01:05:06.000000', 'temperatura', 65.0000, 'ºC'),
	(329211, 146, '2015-01-15 01:05:07.000000', 'temperatura', 262.0000, 'ºC'),
	(329212, 146, '2015-01-15 01:05:08.000000', 'temperatura', 1118.0000, 'ºC'),
	(329213, 146, '2015-01-15 01:05:09.000000', 'temperatura', 3.0000, 'ºC'),
	(329214, 146, '2015-01-15 01:05:10.000000', 'temperatura', 262.0000, 'ºC'),
	(329215, 146, '2015-01-15 01:05:11.000000', 'temperatura', 102.0000, 'ºC'),
	(329216, 146, '2015-01-15 01:05:12.000000', 'temperatura', 925.0000, 'ºC'),
	(329217, 146, '2015-01-15 01:05:13.000000', 'temperatura', 718.0000, 'ºC'),
	(329218, 146, '2015-01-15 01:05:14.000000', 'temperatura', 815.0000, 'ºC'),
	(329219, 146, '2015-01-15 01:05:15.000000', 'temperatura', 723.0000, 'ºC'),
	(329220, 146, '2015-01-15 01:05:16.000000', 'temperatura', 1171.0000, 'ºC'),
	(329221, 146, '2015-01-15 01:05:17.000000', 'temperatura', 87.0000, 'ºC'),
	(329222, 146, '2015-01-15 01:05:18.000000', 'temperatura', 523.0000, 'ºC'),
	(329223, 146, '2015-01-15 01:05:19.000000', 'temperatura', 1154.0000, 'ºC'),
	(329224, 146, '2015-01-15 01:05:20.000000', 'temperatura', 601.0000, 'ºC'),
	(329225, 146, '2015-01-15 01:05:21.000000', 'temperatura', 745.0000, 'ºC'),
	(329226, 146, '2015-01-15 01:05:22.000000', 'temperatura', 721.0000, 'ºC'),
	(329227, 146, '2015-01-15 01:05:23.000000', 'temperatura', 170.0000, 'ºC'),
	(329228, 146, '2015-01-15 01:05:24.000000', 'temperatura', 1089.0000, 'ºC'),
	(329229, 146, '2015-01-15 01:05:25.000000', 'temperatura', 134.0000, 'ºC'),
	(329230, 146, '2015-01-15 01:05:26.000000', 'temperatura', 1006.0000, 'ºC'),
	(329231, 146, '2015-01-15 01:05:27.000000', 'temperatura', 1026.0000, 'ºC'),
	(329232, 146, '2015-01-15 01:05:28.000000', 'temperatura', 915.0000, 'ºC'),
	(329233, 146, '2015-01-15 01:05:29.000000', 'temperatura', 298.0000, 'ºC'),
	(329234, 146, '2015-01-15 01:05:30.000000', 'temperatura', 1146.0000, 'ºC'),
	(329235, 146, '2015-01-15 01:05:31.000000', 'temperatura', 34.0000, 'ºC'),
	(329236, 146, '2015-01-15 01:05:32.000000', 'temperatura', 333.0000, 'ºC'),
	(329237, 146, '2015-01-15 01:05:33.000000', 'temperatura', 363.0000, 'ºC'),
	(329238, 146, '2015-01-15 01:05:34.000000', 'temperatura', 816.0000, 'ºC'),
	(329239, 146, '2015-01-15 01:05:35.000000', 'temperatura', 593.0000, 'ºC'),
	(329240, 146, '2015-01-15 01:05:36.000000', 'temperatura', 519.0000, 'ºC'),
	(329241, 146, '2015-01-15 01:05:37.000000', 'temperatura', 814.0000, 'ºC'),
	(329242, 146, '2015-01-15 01:05:38.000000', 'temperatura', 116.0000, 'ºC'),
	(329243, 146, '2015-01-15 01:05:39.000000', 'temperatura', 539.0000, 'ºC'),
	(329244, 146, '2015-01-15 01:05:40.000000', 'temperatura', 1145.0000, 'ºC'),
	(329245, 146, '2015-01-15 01:05:41.000000', 'temperatura', 509.0000, 'ºC'),
	(329246, 146, '2015-01-15 01:05:42.000000', 'temperatura', 310.0000, 'ºC'),
	(329247, 146, '2015-01-15 01:05:43.000000', 'temperatura', 24.0000, 'ºC'),
	(329248, 146, '2015-01-15 01:05:44.000000', 'temperatura', 390.0000, 'ºC'),
	(329249, 146, '2015-01-15 01:05:45.000000', 'temperatura', 677.0000, 'ºC'),
	(329250, 146, '2015-01-15 01:05:46.000000', 'temperatura', 1016.0000, 'ºC'),
	(329251, 146, '2015-01-15 01:05:47.000000', 'temperatura', 651.0000, 'ºC'),
	(329252, 146, '2015-01-15 01:05:48.000000', 'temperatura', 206.0000, 'ºC'),
	(329253, 146, '2015-01-15 01:05:49.000000', 'temperatura', 277.0000, 'ºC'),
	(329254, 146, '2015-01-15 01:05:50.000000', 'temperatura', 767.0000, 'ºC'),
	(329255, 146, '2015-01-15 01:05:51.000000', 'temperatura', 604.0000, 'ºC'),
	(329256, 146, '2015-01-15 01:05:52.000000', 'temperatura', 720.0000, 'ºC'),
	(329257, 146, '2015-01-15 01:05:53.000000', 'temperatura', 590.0000, 'ºC'),
	(329258, 146, '2015-01-15 01:05:54.000000', 'temperatura', 790.0000, 'ºC'),
	(329259, 146, '2015-01-15 01:05:55.000000', 'temperatura', 980.0000, 'ºC'),
	(329260, 146, '2015-01-15 01:05:56.000000', 'temperatura', 131.0000, 'ºC'),
	(329261, 146, '2015-01-15 01:05:57.000000', 'temperatura', 115.0000, 'ºC'),
	(329262, 146, '2015-01-15 01:05:58.000000', 'temperatura', 184.0000, 'ºC'),
	(329263, 146, '2015-01-15 01:05:59.000000', 'temperatura', 574.0000, 'ºC'),
	(329264, 146, '2015-01-15 01:06:00.000000', 'temperatura', 1118.0000, 'ºC'),
	(329265, 146, '2015-01-15 01:06:01.000000', 'temperatura', 270.0000, 'ºC'),
	(329266, 146, '2015-01-15 01:06:02.000000', 'temperatura', 394.0000, 'ºC'),
	(329267, 146, '2015-01-15 01:06:03.000000', 'temperatura', 1163.0000, 'ºC'),
	(329268, 146, '2015-01-15 01:06:04.000000', 'temperatura', 1031.0000, 'ºC'),
	(329269, 146, '2015-01-15 01:06:05.000000', 'temperatura', 466.0000, 'ºC'),
	(329270, 146, '2015-01-15 01:06:06.000000', 'temperatura', 441.0000, 'ºC'),
	(329271, 146, '2015-01-15 01:06:07.000000', 'temperatura', 805.0000, 'ºC'),
	(329272, 146, '2015-01-15 01:06:08.000000', 'temperatura', 302.0000, 'ºC'),
	(329273, 146, '2015-01-15 01:06:09.000000', 'temperatura', 297.0000, 'ºC'),
	(329274, 146, '2015-01-15 01:06:10.000000', 'temperatura', 579.0000, 'ºC'),
	(329275, 146, '2015-01-15 01:06:11.000000', 'temperatura', 805.0000, 'ºC'),
	(329276, 146, '2015-01-15 01:06:12.000000', 'temperatura', 1089.0000, 'ºC'),
	(329277, 146, '2015-01-15 01:06:13.000000', 'temperatura', 630.0000, 'ºC'),
	(329278, 146, '2015-01-15 01:06:14.000000', 'temperatura', 1084.0000, 'ºC'),
	(329279, 146, '2015-01-15 01:06:15.000000', 'temperatura', 1129.0000, 'ºC'),
	(329280, 146, '2015-01-15 01:06:16.000000', 'temperatura', 1194.0000, 'ºC'),
	(329281, 146, '2015-01-15 01:06:17.000000', 'temperatura', 182.0000, 'ºC'),
	(329282, 146, '2015-01-15 01:06:18.000000', 'temperatura', 929.0000, 'ºC'),
	(329283, 146, '2015-01-15 01:06:19.000000', 'temperatura', 500.0000, 'ºC'),
	(329284, 146, '2015-01-15 01:06:20.000000', 'temperatura', 913.0000, 'ºC'),
	(329285, 146, '2015-01-15 01:06:21.000000', 'temperatura', 667.0000, 'ºC'),
	(329286, 146, '2015-01-15 01:06:22.000000', 'temperatura', 594.0000, 'ºC'),
	(329287, 146, '2015-01-15 01:06:23.000000', 'temperatura', 973.0000, 'ºC'),
	(329288, 146, '2015-01-15 01:06:24.000000', 'temperatura', 681.0000, 'ºC'),
	(329289, 146, '2015-01-15 01:06:25.000000', 'temperatura', 486.0000, 'ºC'),
	(329290, 146, '2015-01-15 01:06:26.000000', 'temperatura', 390.0000, 'ºC'),
	(329291, 146, '2015-01-15 01:06:27.000000', 'temperatura', 492.0000, 'ºC'),
	(329292, 146, '2015-01-15 01:06:28.000000', 'temperatura', 92.0000, 'ºC'),
	(329293, 146, '2015-01-15 01:06:29.000000', 'temperatura', 184.0000, 'ºC'),
	(329294, 146, '2015-01-15 01:06:30.000000', 'temperatura', 642.0000, 'ºC'),
	(329295, 146, '2015-01-15 01:06:31.000000', 'temperatura', 259.0000, 'ºC'),
	(329296, 146, '2015-01-15 01:06:32.000000', 'temperatura', 570.0000, 'ºC'),
	(329297, 146, '2015-01-15 01:06:33.000000', 'temperatura', 875.0000, 'ºC'),
	(329298, 146, '2015-01-15 01:06:34.000000', 'temperatura', 264.0000, 'ºC'),
	(329299, 146, '2015-01-15 01:06:35.000000', 'temperatura', 1094.0000, 'ºC'),
	(329300, 146, '2015-01-15 01:06:36.000000', 'temperatura', 1080.0000, 'ºC'),
	(329301, 146, '2015-01-15 01:06:37.000000', 'temperatura', 918.0000, 'ºC'),
	(329302, 146, '2015-01-15 01:06:38.000000', 'temperatura', 150.0000, 'ºC'),
	(329303, 146, '2015-01-15 01:06:39.000000', 'temperatura', 396.0000, 'ºC'),
	(329304, 146, '2015-01-15 01:06:40.000000', 'temperatura', 329.0000, 'ºC'),
	(329305, 146, '2015-01-15 01:06:41.000000', 'temperatura', 460.0000, 'ºC'),
	(329306, 146, '2015-01-15 01:06:42.000000', 'temperatura', 113.0000, 'ºC'),
	(329307, 146, '2015-01-15 01:06:43.000000', 'temperatura', 387.0000, 'ºC'),
	(329308, 146, '2015-01-15 01:06:44.000000', 'temperatura', 393.0000, 'ºC'),
	(329309, 146, '2015-01-15 01:06:45.000000', 'temperatura', 807.0000, 'ºC'),
	(329310, 146, '2015-01-15 01:06:46.000000', 'temperatura', 457.0000, 'ºC'),
	(329311, 146, '2015-01-15 01:06:47.000000', 'temperatura', 1064.0000, 'ºC'),
	(329312, 146, '2015-01-15 01:06:48.000000', 'temperatura', 348.0000, 'ºC'),
	(329313, 146, '2015-01-15 01:06:49.000000', 'temperatura', 948.0000, 'ºC'),
	(329314, 146, '2015-01-15 01:06:50.000000', 'temperatura', 98.0000, 'ºC'),
	(329315, 146, '2015-01-15 01:06:51.000000', 'temperatura', 46.0000, 'ºC'),
	(329316, 146, '2015-01-15 01:06:52.000000', 'temperatura', 1136.0000, 'ºC'),
	(329317, 146, '2015-01-15 01:06:53.000000', 'temperatura', 742.0000, 'ºC'),
	(329318, 146, '2015-01-15 01:06:54.000000', 'temperatura', 305.0000, 'ºC'),
	(329319, 146, '2015-01-15 01:06:55.000000', 'temperatura', 497.0000, 'ºC'),
	(329320, 146, '2015-01-15 01:06:56.000000', 'temperatura', 371.0000, 'ºC'),
	(329321, 146, '2015-01-15 01:06:57.000000', 'temperatura', 366.0000, 'ºC'),
	(329322, 146, '2015-01-15 01:06:58.000000', 'temperatura', 717.0000, 'ºC'),
	(329323, 146, '2015-01-15 01:06:59.000000', 'temperatura', 87.0000, 'ºC'),
	(329324, 146, '2015-01-15 01:07:00.000000', 'temperatura', 683.0000, 'ºC'),
	(329325, 146, '2015-01-15 01:07:01.000000', 'temperatura', 754.0000, 'ºC'),
	(329326, 146, '2015-01-15 01:07:02.000000', 'temperatura', 522.0000, 'ºC'),
	(329327, 146, '2015-01-15 01:07:03.000000', 'temperatura', 349.0000, 'ºC'),
	(329328, 146, '2015-01-15 01:07:04.000000', 'temperatura', 181.0000, 'ºC'),
	(329329, 146, '2015-01-15 01:07:05.000000', 'temperatura', 1059.0000, 'ºC'),
	(329330, 146, '2015-01-15 01:07:06.000000', 'temperatura', 1152.0000, 'ºC'),
	(329331, 146, '2015-01-15 01:07:07.000000', 'temperatura', 182.0000, 'ºC'),
	(329332, 146, '2015-01-15 01:07:08.000000', 'temperatura', 1055.0000, 'ºC'),
	(329333, 146, '2015-01-15 01:07:09.000000', 'temperatura', 1129.0000, 'ºC'),
	(329334, 146, '2015-01-15 01:07:10.000000', 'temperatura', 80.0000, 'ºC'),
	(329335, 146, '2015-01-15 01:07:11.000000', 'temperatura', 612.0000, 'ºC'),
	(329336, 146, '2015-01-15 01:07:12.000000', 'temperatura', 422.0000, 'ºC'),
	(329337, 146, '2015-01-15 01:07:13.000000', 'temperatura', 275.0000, 'ºC'),
	(329338, 146, '2015-01-15 01:07:14.000000', 'temperatura', 111.0000, 'ºC'),
	(329339, 146, '2015-01-15 01:07:15.000000', 'temperatura', 927.0000, 'ºC'),
	(329340, 146, '2015-01-15 01:07:16.000000', 'temperatura', 706.0000, 'ºC'),
	(329341, 146, '2015-01-15 01:07:17.000000', 'temperatura', 748.0000, 'ºC'),
	(329342, 146, '2015-01-15 01:07:18.000000', 'temperatura', 420.0000, 'ºC'),
	(329343, 146, '2015-01-15 01:07:19.000000', 'temperatura', 1060.0000, 'ºC'),
	(329344, 146, '2015-01-15 01:07:20.000000', 'temperatura', 441.0000, 'ºC'),
	(329345, 146, '2015-01-15 01:07:21.000000', 'temperatura', 224.0000, 'ºC'),
	(329346, 146, '2015-01-15 01:07:22.000000', 'temperatura', 1000.0000, 'ºC'),
	(329347, 146, '2015-01-15 01:07:23.000000', 'temperatura', 726.0000, 'ºC'),
	(329348, 146, '2015-01-15 01:07:24.000000', 'temperatura', 632.0000, 'ºC'),
	(329349, 146, '2015-01-15 01:07:25.000000', 'temperatura', 982.0000, 'ºC'),
	(329350, 146, '2015-01-15 01:07:26.000000', 'temperatura', 614.0000, 'ºC'),
	(329351, 146, '2015-01-15 01:07:27.000000', 'temperatura', 125.0000, 'ºC'),
	(329352, 146, '2015-01-15 01:07:28.000000', 'temperatura', 1185.0000, 'ºC'),
	(329353, 146, '2015-01-15 01:07:29.000000', 'temperatura', 750.0000, 'ºC'),
	(329354, 146, '2015-01-15 01:07:30.000000', 'temperatura', 194.0000, 'ºC'),
	(329355, 146, '2015-01-15 01:07:31.000000', 'temperatura', 1120.0000, 'ºC'),
	(329356, 146, '2015-01-15 01:07:32.000000', 'temperatura', 220.0000, 'ºC'),
	(329357, 146, '2015-01-15 01:07:33.000000', 'temperatura', 142.0000, 'ºC'),
	(329358, 146, '2015-01-15 01:07:34.000000', 'temperatura', 50.0000, 'ºC'),
	(329359, 146, '2015-01-15 01:07:35.000000', 'temperatura', 1022.0000, 'ºC'),
	(329360, 146, '2015-01-15 01:07:36.000000', 'temperatura', 163.0000, 'ºC'),
	(329361, 146, '2015-01-15 01:07:37.000000', 'temperatura', 149.0000, 'ºC'),
	(329362, 146, '2015-01-15 01:07:38.000000', 'temperatura', 258.0000, 'ºC'),
	(329363, 146, '2015-01-15 01:07:39.000000', 'temperatura', 841.0000, 'ºC'),
	(329364, 146, '2015-01-15 01:07:40.000000', 'temperatura', 1033.0000, 'ºC'),
	(329365, 146, '2015-01-15 01:07:41.000000', 'temperatura', 240.0000, 'ºC'),
	(329366, 146, '2015-01-15 01:07:42.000000', 'temperatura', 505.0000, 'ºC'),
	(329367, 146, '2015-01-15 01:07:43.000000', 'temperatura', 604.0000, 'ºC'),
	(329368, 146, '2015-01-15 01:07:44.000000', 'temperatura', 306.0000, 'ºC'),
	(329369, 146, '2015-01-15 01:07:45.000000', 'temperatura', 920.0000, 'ºC'),
	(329370, 146, '2015-01-15 01:07:46.000000', 'temperatura', 81.0000, 'ºC'),
	(329371, 146, '2015-01-15 01:07:47.000000', 'temperatura', 47.0000, 'ºC'),
	(329372, 146, '2015-01-15 01:07:48.000000', 'temperatura', 1191.0000, 'ºC'),
	(329373, 146, '2015-01-15 01:07:49.000000', 'temperatura', 1014.0000, 'ºC'),
	(329374, 146, '2015-01-15 01:07:50.000000', 'temperatura', 298.0000, 'ºC'),
	(329375, 146, '2015-01-15 01:07:51.000000', 'temperatura', 848.0000, 'ºC'),
	(329376, 146, '2015-01-15 01:07:52.000000', 'temperatura', 946.0000, 'ºC'),
	(329377, 146, '2015-01-15 01:07:53.000000', 'temperatura', 987.0000, 'ºC'),
	(329378, 146, '2015-01-15 01:07:54.000000', 'temperatura', 899.0000, 'ºC'),
	(329379, 146, '2015-01-15 01:07:55.000000', 'temperatura', 334.0000, 'ºC'),
	(329380, 146, '2015-01-15 01:07:56.000000', 'temperatura', 175.0000, 'ºC'),
	(329381, 146, '2015-01-15 01:07:57.000000', 'temperatura', 1073.0000, 'ºC'),
	(329382, 146, '2015-01-15 01:07:58.000000', 'temperatura', 40.0000, 'ºC'),
	(329383, 146, '2015-01-15 01:07:59.000000', 'temperatura', 583.0000, 'ºC'),
	(329384, 146, '2015-01-15 01:08:00.000000', 'temperatura', 396.0000, 'ºC'),
	(329385, 146, '2015-01-15 01:08:01.000000', 'temperatura', 232.0000, 'ºC'),
	(329386, 146, '2015-01-15 01:08:02.000000', 'temperatura', 1171.0000, 'ºC'),
	(329387, 146, '2015-01-15 01:08:03.000000', 'temperatura', 360.0000, 'ºC'),
	(329388, 146, '2015-01-15 01:08:04.000000', 'temperatura', 689.0000, 'ºC'),
	(329389, 146, '2015-01-15 01:08:05.000000', 'temperatura', 1166.0000, 'ºC'),
	(329390, 146, '2015-01-15 01:08:06.000000', 'temperatura', 163.0000, 'ºC'),
	(329391, 146, '2015-01-15 01:08:07.000000', 'temperatura', 915.0000, 'ºC'),
	(329392, 146, '2015-01-15 01:08:08.000000', 'temperatura', 488.0000, 'ºC'),
	(329393, 146, '2015-01-15 01:08:09.000000', 'temperatura', 895.0000, 'ºC'),
	(329394, 146, '2015-01-15 01:08:10.000000', 'temperatura', 612.0000, 'ºC'),
	(329395, 146, '2015-01-15 01:08:11.000000', 'temperatura', 376.0000, 'ºC'),
	(329396, 146, '2015-01-15 01:08:12.000000', 'temperatura', 44.0000, 'ºC'),
	(329397, 146, '2015-01-15 01:08:13.000000', 'temperatura', 294.0000, 'ºC'),
	(329398, 146, '2015-01-15 01:08:14.000000', 'temperatura', 138.0000, 'ºC'),
	(329399, 146, '2015-01-15 01:08:15.000000', 'temperatura', 1007.0000, 'ºC'),
	(329400, 146, '2015-01-15 01:08:16.000000', 'temperatura', 1023.0000, 'ºC'),
	(329401, 146, '2015-01-15 01:08:17.000000', 'temperatura', 892.0000, 'ºC'),
	(329402, 146, '2015-01-15 01:08:18.000000', 'temperatura', 195.0000, 'ºC'),
	(329403, 146, '2015-01-15 01:08:19.000000', 'temperatura', 698.0000, 'ºC'),
	(329404, 146, '2015-01-15 01:08:20.000000', 'temperatura', 504.0000, 'ºC'),
	(329405, 146, '2015-01-15 01:08:21.000000', 'temperatura', 429.0000, 'ºC'),
	(329406, 146, '2015-01-15 01:08:22.000000', 'temperatura', 634.0000, 'ºC'),
	(329407, 146, '2015-01-15 01:08:23.000000', 'temperatura', 685.0000, 'ºC'),
	(329408, 146, '2015-01-15 01:08:24.000000', 'temperatura', 320.0000, 'ºC'),
	(329409, 146, '2015-01-15 01:08:25.000000', 'temperatura', 745.0000, 'ºC'),
	(329410, 146, '2015-01-15 01:08:26.000000', 'temperatura', 367.0000, 'ºC'),
	(329411, 146, '2015-01-15 01:08:27.000000', 'temperatura', 801.0000, 'ºC'),
	(329412, 146, '2015-01-15 01:08:28.000000', 'temperatura', 502.0000, 'ºC'),
	(329413, 146, '2015-01-15 01:08:29.000000', 'temperatura', 110.0000, 'ºC'),
	(329414, 146, '2015-01-15 01:08:30.000000', 'temperatura', 242.0000, 'ºC'),
	(329415, 146, '2015-01-15 01:08:31.000000', 'temperatura', 882.0000, 'ºC'),
	(329416, 146, '2015-01-15 01:08:32.000000', 'temperatura', 86.0000, 'ºC'),
	(329417, 146, '2015-01-15 01:08:33.000000', 'temperatura', 185.0000, 'ºC'),
	(329418, 146, '2015-01-15 01:08:34.000000', 'temperatura', 664.0000, 'ºC'),
	(329419, 146, '2015-01-15 01:08:35.000000', 'temperatura', 369.0000, 'ºC'),
	(329420, 146, '2015-01-15 01:08:36.000000', 'temperatura', 1051.0000, 'ºC'),
	(329421, 146, '2015-01-15 01:08:37.000000', 'temperatura', 549.0000, 'ºC'),
	(329422, 146, '2015-01-15 01:08:38.000000', 'temperatura', 792.0000, 'ºC'),
	(329423, 146, '2015-01-15 01:08:39.000000', 'temperatura', 1113.0000, 'ºC'),
	(329424, 146, '2015-01-15 01:08:40.000000', 'temperatura', 788.0000, 'ºC'),
	(329425, 146, '2015-01-15 01:08:41.000000', 'temperatura', 604.0000, 'ºC'),
	(329426, 146, '2015-01-15 01:08:42.000000', 'temperatura', 654.0000, 'ºC'),
	(329427, 146, '2015-01-15 01:08:43.000000', 'temperatura', 261.0000, 'ºC'),
	(329428, 146, '2015-01-15 01:08:44.000000', 'temperatura', 541.0000, 'ºC'),
	(329429, 146, '2015-01-15 01:08:45.000000', 'temperatura', 723.0000, 'ºC'),
	(329430, 146, '2015-01-15 01:08:46.000000', 'temperatura', 791.0000, 'ºC'),
	(329431, 146, '2015-01-15 01:08:47.000000', 'temperatura', 588.0000, 'ºC'),
	(329432, 146, '2015-01-15 01:08:48.000000', 'temperatura', 567.0000, 'ºC'),
	(329433, 146, '2015-01-15 01:08:49.000000', 'temperatura', 1072.0000, 'ºC'),
	(329434, 146, '2015-01-15 01:08:50.000000', 'temperatura', 58.0000, 'ºC'),
	(329435, 146, '2015-01-15 01:08:51.000000', 'temperatura', 674.0000, 'ºC'),
	(329436, 146, '2015-01-15 01:08:52.000000', 'temperatura', 799.0000, 'ºC'),
	(329437, 146, '2015-01-15 01:08:53.000000', 'temperatura', 771.0000, 'ºC'),
	(329438, 146, '2015-01-15 01:08:54.000000', 'temperatura', 260.0000, 'ºC'),
	(329439, 146, '2015-01-15 01:08:55.000000', 'temperatura', 186.0000, 'ºC'),
	(329440, 146, '2015-01-15 01:08:56.000000', 'temperatura', 151.0000, 'ºC'),
	(329441, 146, '2015-01-15 01:08:57.000000', 'temperatura', 199.0000, 'ºC'),
	(329442, 146, '2015-01-15 01:08:58.000000', 'temperatura', 540.0000, 'ºC'),
	(329443, 146, '2015-01-15 01:08:59.000000', 'temperatura', 905.0000, 'ºC'),
	(329444, 146, '2015-01-15 01:09:00.000000', 'temperatura', 503.0000, 'ºC'),
	(329445, 146, '2015-01-15 01:09:01.000000', 'temperatura', 1002.0000, 'ºC'),
	(329446, 146, '2015-01-15 01:09:02.000000', 'temperatura', 1104.0000, 'ºC'),
	(329447, 146, '2015-01-15 01:09:03.000000', 'temperatura', 111.0000, 'ºC'),
	(329448, 146, '2015-01-15 01:09:04.000000', 'temperatura', 843.0000, 'ºC'),
	(329449, 146, '2015-01-15 01:09:05.000000', 'temperatura', 285.0000, 'ºC'),
	(329450, 146, '2015-01-15 01:09:06.000000', 'temperatura', 98.0000, 'ºC'),
	(329451, 146, '2015-01-15 01:09:07.000000', 'temperatura', 832.0000, 'ºC'),
	(329452, 146, '2015-01-15 01:09:08.000000', 'temperatura', 268.0000, 'ºC'),
	(329453, 146, '2015-01-15 01:09:09.000000', 'temperatura', 45.0000, 'ºC'),
	(329454, 146, '2015-01-15 01:09:10.000000', 'temperatura', 622.0000, 'ºC'),
	(329455, 146, '2015-01-15 01:09:11.000000', 'temperatura', 573.0000, 'ºC'),
	(329456, 146, '2015-01-15 01:09:12.000000', 'temperatura', 1000.0000, 'ºC'),
	(329457, 146, '2015-01-15 01:09:13.000000', 'temperatura', 883.0000, 'ºC'),
	(329458, 146, '2015-01-15 01:09:14.000000', 'temperatura', 213.0000, 'ºC'),
	(329459, 146, '2015-01-15 01:09:15.000000', 'temperatura', 816.0000, 'ºC'),
	(329460, 146, '2015-01-15 01:09:16.000000', 'temperatura', 1045.0000, 'ºC'),
	(329461, 146, '2015-01-15 01:09:17.000000', 'temperatura', 375.0000, 'ºC'),
	(329462, 146, '2015-01-15 01:09:18.000000', 'temperatura', 1142.0000, 'ºC'),
	(329463, 146, '2015-01-15 01:09:19.000000', 'temperatura', 983.0000, 'ºC'),
	(329464, 146, '2015-01-15 01:09:20.000000', 'temperatura', 291.0000, 'ºC'),
	(329465, 146, '2015-01-15 01:09:21.000000', 'temperatura', 907.0000, 'ºC'),
	(329466, 146, '2015-01-15 01:09:22.000000', 'temperatura', 63.0000, 'ºC'),
	(329467, 146, '2015-01-15 01:09:23.000000', 'temperatura', 1193.0000, 'ºC'),
	(329468, 146, '2015-01-15 01:09:24.000000', 'temperatura', 978.0000, 'ºC'),
	(329469, 146, '2015-01-15 01:09:25.000000', 'temperatura', 110.0000, 'ºC'),
	(329470, 146, '2015-01-15 01:09:26.000000', 'temperatura', 19.0000, 'ºC'),
	(329471, 146, '2015-01-15 01:09:27.000000', 'temperatura', 964.0000, 'ºC'),
	(329472, 146, '2015-01-15 01:09:28.000000', 'temperatura', 1162.0000, 'ºC'),
	(329473, 146, '2015-01-15 01:09:29.000000', 'temperatura', 519.0000, 'ºC'),
	(329474, 146, '2015-01-15 01:09:30.000000', 'temperatura', 309.0000, 'ºC'),
	(329475, 146, '2015-01-15 01:09:31.000000', 'temperatura', 1191.0000, 'ºC'),
	(329476, 146, '2015-01-15 01:09:32.000000', 'temperatura', 227.0000, 'ºC'),
	(329477, 146, '2015-01-15 01:09:33.000000', 'temperatura', 1164.0000, 'ºC'),
	(329478, 146, '2015-01-15 01:09:34.000000', 'temperatura', 340.0000, 'ºC'),
	(329479, 146, '2015-01-15 01:09:35.000000', 'temperatura', 609.0000, 'ºC'),
	(329480, 146, '2015-01-15 01:09:36.000000', 'temperatura', 826.0000, 'ºC'),
	(329481, 146, '2015-01-15 01:09:37.000000', 'temperatura', 1102.0000, 'ºC'),
	(329482, 146, '2015-01-15 01:09:38.000000', 'temperatura', 635.0000, 'ºC'),
	(329483, 146, '2015-01-15 01:09:39.000000', 'temperatura', 1066.0000, 'ºC'),
	(329484, 146, '2015-01-15 01:09:40.000000', 'temperatura', 1028.0000, 'ºC'),
	(329485, 146, '2015-01-15 01:09:41.000000', 'temperatura', 743.0000, 'ºC'),
	(329486, 146, '2015-01-15 01:09:42.000000', 'temperatura', 631.0000, 'ºC'),
	(329487, 146, '2015-01-15 01:09:43.000000', 'temperatura', 925.0000, 'ºC'),
	(329488, 146, '2015-01-15 01:09:44.000000', 'temperatura', 333.0000, 'ºC'),
	(329489, 146, '2015-01-15 01:09:45.000000', 'temperatura', 93.0000, 'ºC'),
	(329490, 146, '2015-01-15 01:09:46.000000', 'temperatura', 664.0000, 'ºC'),
	(329491, 146, '2015-01-15 01:09:47.000000', 'temperatura', 643.0000, 'ºC'),
	(329492, 146, '2015-01-15 01:09:48.000000', 'temperatura', 21.0000, 'ºC'),
	(329493, 146, '2015-01-15 01:09:49.000000', 'temperatura', 579.0000, 'ºC'),
	(329494, 146, '2015-01-15 01:09:50.000000', 'temperatura', 434.0000, 'ºC'),
	(329495, 146, '2015-01-15 01:09:51.000000', 'temperatura', 431.0000, 'ºC'),
	(329496, 146, '2015-01-15 01:09:52.000000', 'temperatura', 854.0000, 'ºC'),
	(329497, 146, '2015-01-15 01:09:53.000000', 'temperatura', 577.0000, 'ºC'),
	(329498, 146, '2015-01-15 01:09:54.000000', 'temperatura', 323.0000, 'ºC'),
	(329499, 146, '2015-01-15 01:09:55.000000', 'temperatura', 1087.0000, 'ºC'),
	(329500, 146, '2015-01-15 01:09:56.000000', 'temperatura', 864.0000, 'ºC'),
	(329501, 146, '2015-01-15 01:09:57.000000', 'temperatura', 1060.0000, 'ºC'),
	(329502, 146, '2015-01-15 01:09:58.000000', 'temperatura', 310.0000, 'ºC'),
	(329503, 146, '2015-01-15 01:09:59.000000', 'temperatura', 772.0000, 'ºC'),
	(329504, 146, '2015-01-15 01:10:00.000000', 'temperatura', 528.0000, 'ºC'),
	(329505, 146, '2015-01-15 01:10:01.000000', 'temperatura', 323.0000, 'ºC'),
	(329506, 146, '2015-01-15 01:10:02.000000', 'temperatura', 33.0000, 'ºC'),
	(329507, 146, '2015-01-15 01:10:03.000000', 'temperatura', 396.0000, 'ºC'),
	(329508, 146, '2015-01-15 01:10:04.000000', 'temperatura', 682.0000, 'ºC'),
	(329509, 146, '2015-01-15 01:10:05.000000', 'temperatura', 1023.0000, 'ºC'),
	(329510, 146, '2015-01-15 01:10:06.000000', 'temperatura', 668.0000, 'ºC'),
	(329511, 146, '2015-01-15 01:10:07.000000', 'temperatura', 271.0000, 'ºC'),
	(329512, 146, '2015-01-15 01:10:08.000000', 'temperatura', 554.0000, 'ºC'),
	(329513, 146, '2015-01-15 01:10:09.000000', 'temperatura', 756.0000, 'ºC'),
	(329514, 146, '2015-01-15 01:10:10.000000', 'temperatura', 921.0000, 'ºC'),
	(329515, 146, '2015-01-15 01:10:11.000000', 'temperatura', 1134.0000, 'ºC'),
	(329516, 146, '2015-01-15 01:10:12.000000', 'temperatura', 509.0000, 'ºC'),
	(329517, 146, '2015-01-15 01:10:13.000000', 'temperatura', 343.0000, 'ºC'),
	(329518, 146, '2015-01-15 01:10:14.000000', 'temperatura', 188.0000, 'ºC'),
	(329519, 146, '2015-01-15 01:10:15.000000', 'temperatura', 1112.0000, 'ºC'),
	(329520, 146, '2015-01-15 01:10:16.000000', 'temperatura', 197.0000, 'ºC'),
	(329521, 146, '2015-01-15 01:10:17.000000', 'temperatura', 48.0000, 'ºC'),
	(329522, 146, '2015-01-15 01:10:18.000000', 'temperatura', 851.0000, 'ºC'),
	(329523, 146, '2015-01-15 01:10:19.000000', 'temperatura', 511.0000, 'ºC'),
	(329524, 146, '2015-01-15 01:10:20.000000', 'temperatura', 5.0000, 'ºC'),
	(329525, 146, '2015-01-15 01:10:21.000000', 'temperatura', 889.0000, 'ºC'),
	(329526, 146, '2015-01-15 01:10:22.000000', 'temperatura', 831.0000, 'ºC'),
	(329527, 146, '2015-01-15 01:10:23.000000', 'temperatura', 290.0000, 'ºC'),
	(329528, 146, '2015-01-15 01:10:24.000000', 'temperatura', 158.0000, 'ºC'),
	(329529, 146, '2015-01-15 01:10:25.000000', 'temperatura', 1118.0000, 'ºC'),
	(329530, 146, '2015-01-15 01:10:26.000000', 'temperatura', 317.0000, 'ºC'),
	(329531, 146, '2015-01-15 01:10:27.000000', 'temperatura', 634.0000, 'ºC'),
	(329532, 146, '2015-01-15 01:10:28.000000', 'temperatura', 1016.0000, 'ºC'),
	(329533, 146, '2015-01-15 01:10:29.000000', 'temperatura', 781.0000, 'ºC'),
	(329534, 146, '2015-01-15 01:10:30.000000', 'temperatura', 856.0000, 'ºC'),
	(329535, 146, '2015-01-15 01:10:31.000000', 'temperatura', 736.0000, 'ºC'),
	(329536, 146, '2015-01-15 01:10:32.000000', 'temperatura', 1116.0000, 'ºC'),
	(329537, 146, '2015-01-15 01:10:33.000000', 'temperatura', 970.0000, 'ºC'),
	(329538, 146, '2015-01-15 01:10:34.000000', 'temperatura', 302.0000, 'ºC'),
	(329539, 146, '2015-01-15 01:10:35.000000', 'temperatura', 1002.0000, 'ºC'),
	(329540, 146, '2015-01-15 01:10:36.000000', 'temperatura', 504.0000, 'ºC'),
	(329541, 146, '2015-01-15 01:10:37.000000', 'temperatura', 716.0000, 'ºC'),
	(329542, 146, '2015-01-15 01:10:38.000000', 'temperatura', 868.0000, 'ºC'),
	(329543, 146, '2015-01-15 01:10:39.000000', 'temperatura', 993.0000, 'ºC'),
	(329544, 146, '2015-01-15 01:10:40.000000', 'temperatura', 1160.0000, 'ºC'),
	(329545, 146, '2015-01-15 01:10:41.000000', 'temperatura', 420.0000, 'ºC'),
	(329546, 146, '2015-01-15 01:10:42.000000', 'temperatura', 1022.0000, 'ºC'),
	(329547, 146, '2015-01-15 01:10:43.000000', 'temperatura', 251.0000, 'ºC'),
	(329548, 146, '2015-01-15 01:10:44.000000', 'temperatura', 590.0000, 'ºC'),
	(329549, 146, '2015-01-15 01:10:45.000000', 'temperatura', 996.0000, 'ºC'),
	(329550, 146, '2015-01-15 01:10:46.000000', 'temperatura', 811.0000, 'ºC'),
	(329551, 146, '2015-01-15 01:10:47.000000', 'temperatura', 1067.0000, 'ºC'),
	(329552, 146, '2015-01-15 01:10:48.000000', 'temperatura', 503.0000, 'ºC'),
	(329553, 146, '2015-01-15 01:10:49.000000', 'temperatura', 516.0000, 'ºC'),
	(329554, 146, '2015-01-15 01:10:50.000000', 'temperatura', 1071.0000, 'ºC'),
	(329555, 146, '2015-01-15 01:10:51.000000', 'temperatura', 206.0000, 'ºC'),
	(329556, 146, '2015-01-15 01:10:52.000000', 'temperatura', 217.0000, 'ºC'),
	(329557, 146, '2015-01-15 01:10:53.000000', 'temperatura', 468.0000, 'ºC'),
	(329558, 146, '2015-01-15 01:10:54.000000', 'temperatura', 491.0000, 'ºC'),
	(329559, 146, '2015-01-15 01:10:55.000000', 'temperatura', 1052.0000, 'ºC'),
	(329560, 146, '2015-01-15 01:10:56.000000', 'temperatura', 186.0000, 'ºC'),
	(329561, 146, '2015-01-15 01:10:57.000000', 'temperatura', 174.0000, 'ºC'),
	(329562, 146, '2015-01-15 01:10:58.000000', 'temperatura', 313.0000, 'ºC'),
	(329563, 146, '2015-01-15 01:10:59.000000', 'temperatura', 1044.0000, 'ºC'),
	(329564, 146, '2015-01-15 01:11:00.000000', 'temperatura', 680.0000, 'ºC'),
	(329565, 146, '2015-01-15 01:11:01.000000', 'temperatura', 271.0000, 'ºC'),
	(329566, 146, '2015-01-15 01:11:02.000000', 'temperatura', 516.0000, 'ºC'),
	(329567, 146, '2015-01-15 01:11:03.000000', 'temperatura', 564.0000, 'ºC'),
	(329568, 146, '2015-01-15 01:11:04.000000', 'temperatura', 75.0000, 'ºC'),
	(329569, 146, '2015-01-15 01:11:05.000000', 'temperatura', 1083.0000, 'ºC'),
	(329570, 146, '2015-01-15 01:11:06.000000', 'temperatura', 391.0000, 'ºC'),
	(329571, 146, '2015-01-15 01:11:07.000000', 'temperatura', 1108.0000, 'ºC'),
	(329572, 146, '2015-01-15 01:11:08.000000', 'temperatura', 765.0000, 'ºC'),
	(329573, 146, '2015-01-15 01:11:09.000000', 'temperatura', 504.0000, 'ºC'),
	(329574, 146, '2015-01-15 01:11:10.000000', 'temperatura', 224.0000, 'ºC'),
	(329575, 146, '2015-01-15 01:11:11.000000', 'temperatura', 807.0000, 'ºC'),
	(329576, 146, '2015-01-15 01:11:12.000000', 'temperatura', 964.0000, 'ºC'),
	(329577, 146, '2015-01-15 01:11:13.000000', 'temperatura', 1199.0000, 'ºC'),
	(329578, 146, '2015-01-15 01:11:14.000000', 'temperatura', 703.0000, 'ºC'),
	(329579, 146, '2015-01-15 01:11:15.000000', 'temperatura', 1119.0000, 'ºC'),
	(329580, 146, '2015-01-15 01:11:16.000000', 'temperatura', 1085.0000, 'ºC'),
	(329581, 146, '2015-01-15 01:11:17.000000', 'temperatura', 869.0000, 'ºC'),
	(329582, 146, '2015-01-15 01:11:18.000000', 'temperatura', 1092.0000, 'ºC'),
	(329583, 146, '2015-01-15 01:11:19.000000', 'temperatura', 451.0000, 'ºC'),
	(329584, 146, '2015-01-15 01:11:20.000000', 'temperatura', 179.0000, 'ºC'),
	(329585, 146, '2015-01-15 01:11:21.000000', 'temperatura', 745.0000, 'ºC'),
	(329586, 146, '2015-01-15 01:11:22.000000', 'temperatura', 789.0000, 'ºC'),
	(329587, 146, '2015-01-15 01:11:23.000000', 'temperatura', 509.0000, 'ºC'),
	(329588, 146, '2015-01-15 01:11:24.000000', 'temperatura', 178.0000, 'ºC'),
	(329589, 146, '2015-01-15 01:11:25.000000', 'temperatura', 564.0000, 'ºC'),
	(329590, 146, '2015-01-15 01:11:26.000000', 'temperatura', 1089.0000, 'ºC'),
	(329591, 146, '2015-01-15 01:11:27.000000', 'temperatura', 150.0000, 'ºC'),
	(329592, 146, '2015-01-15 01:11:28.000000', 'temperatura', 1087.0000, 'ºC'),
	(329593, 146, '2015-01-15 01:11:29.000000', 'temperatura', 182.0000, 'ºC'),
	(329594, 146, '2015-01-15 01:11:30.000000', 'temperatura', 50.0000, 'ºC'),
	(329595, 146, '2015-01-15 01:11:31.000000', 'temperatura', 906.0000, 'ºC'),
	(329596, 146, '2015-01-15 01:11:32.000000', 'temperatura', 779.0000, 'ºC'),
	(329597, 146, '2015-01-15 01:11:33.000000', 'temperatura', 1179.0000, 'ºC'),
	(329598, 146, '2015-01-15 01:11:34.000000', 'temperatura', 1159.0000, 'ºC'),
	(329599, 146, '2015-01-15 01:11:35.000000', 'temperatura', 1056.0000, 'ºC'),
	(329600, 146, '2015-01-15 01:11:36.000000', 'temperatura', 603.0000, 'ºC'),
	(329601, 146, '2015-01-15 01:11:37.000000', 'temperatura', 1050.0000, 'ºC'),
	(329602, 146, '2015-01-15 01:11:38.000000', 'temperatura', 1040.0000, 'ºC'),
	(329603, 146, '2015-01-15 01:11:39.000000', 'temperatura', 852.0000, 'ºC'),
	(329604, 146, '2015-01-15 01:11:40.000000', 'temperatura', 1139.0000, 'ºC'),
	(329605, 146, '2015-01-15 01:11:41.000000', 'temperatura', 739.0000, 'ºC'),
	(329606, 146, '2015-01-15 01:11:42.000000', 'temperatura', 281.0000, 'ºC'),
	(329607, 146, '2015-01-15 01:11:43.000000', 'temperatura', 386.0000, 'ºC'),
	(329608, 146, '2015-01-15 01:11:44.000000', 'temperatura', 1087.0000, 'ºC'),
	(329609, 146, '2015-01-15 01:11:45.000000', 'temperatura', 679.0000, 'ºC'),
	(329610, 146, '2015-01-15 01:11:46.000000', 'temperatura', 136.0000, 'ºC'),
	(329611, 146, '2015-01-15 01:11:47.000000', 'temperatura', 1041.0000, 'ºC'),
	(329612, 146, '2015-01-15 01:11:48.000000', 'temperatura', 1198.0000, 'ºC'),
	(329613, 146, '2015-01-15 01:11:49.000000', 'temperatura', 467.0000, 'ºC'),
	(329614, 146, '2015-01-15 01:11:50.000000', 'temperatura', 1141.0000, 'ºC'),
	(329615, 146, '2015-01-15 01:11:51.000000', 'temperatura', 704.0000, 'ºC'),
	(329616, 146, '2015-01-15 01:11:52.000000', 'temperatura', 100.0000, 'ºC'),
	(329617, 146, '2015-01-15 01:11:53.000000', 'temperatura', 788.0000, 'ºC'),
	(329618, 146, '2015-01-15 01:11:54.000000', 'temperatura', 41.0000, 'ºC'),
	(329619, 146, '2015-01-15 01:11:55.000000', 'temperatura', 242.0000, 'ºC'),
	(329620, 146, '2015-01-15 01:11:56.000000', 'temperatura', 1087.0000, 'ºC'),
	(329621, 146, '2015-01-15 01:11:57.000000', 'temperatura', 1109.0000, 'ºC'),
	(329622, 146, '2015-01-15 01:11:58.000000', 'temperatura', 1084.0000, 'ºC'),
	(329623, 146, '2015-01-15 01:11:59.000000', 'temperatura', 894.0000, 'ºC'),
	(329624, 146, '2015-01-15 01:12:00.000000', 'temperatura', 19.0000, 'ºC'),
	(329625, 146, '2015-01-15 01:12:01.000000', 'temperatura', 1014.0000, 'ºC'),
	(329626, 146, '2015-01-15 01:12:02.000000', 'temperatura', 215.0000, 'ºC'),
	(329627, 146, '2015-01-15 01:12:03.000000', 'temperatura', 432.0000, 'ºC'),
	(329628, 146, '2015-01-15 01:12:04.000000', 'temperatura', 316.0000, 'ºC'),
	(329629, 146, '2015-01-15 01:12:05.000000', 'temperatura', 283.0000, 'ºC'),
	(329630, 146, '2015-01-15 01:12:06.000000', 'temperatura', 469.0000, 'ºC'),
	(329631, 146, '2015-01-15 01:12:07.000000', 'temperatura', 298.0000, 'ºC'),
	(329632, 146, '2015-01-15 01:12:08.000000', 'temperatura', 82.0000, 'ºC'),
	(329633, 146, '2015-01-15 01:12:09.000000', 'temperatura', 716.0000, 'ºC'),
	(329634, 146, '2015-01-15 01:12:10.000000', 'temperatura', 933.0000, 'ºC'),
	(329635, 146, '2015-01-15 01:12:11.000000', 'temperatura', 118.0000, 'ºC'),
	(329636, 146, '2015-01-15 01:12:12.000000', 'temperatura', 192.0000, 'ºC'),
	(329637, 146, '2015-01-15 01:12:13.000000', 'temperatura', 606.0000, 'ºC'),
	(329638, 146, '2015-01-15 01:12:14.000000', 'temperatura', 56.0000, 'ºC'),
	(329639, 146, '2015-01-15 01:12:15.000000', 'temperatura', 864.0000, 'ºC'),
	(329640, 146, '2015-01-15 01:12:16.000000', 'temperatura', 550.0000, 'ºC'),
	(329641, 146, '2015-01-15 01:12:17.000000', 'temperatura', 159.0000, 'ºC'),
	(329642, 146, '2015-01-15 01:12:18.000000', 'temperatura', 345.0000, 'ºC'),
	(329643, 146, '2015-01-15 01:12:19.000000', 'temperatura', 51.0000, 'ºC'),
	(329644, 146, '2015-01-15 01:12:20.000000', 'temperatura', 419.0000, 'ºC'),
	(329645, 146, '2015-01-15 01:12:21.000000', 'temperatura', 743.0000, 'ºC'),
	(329646, 146, '2015-01-15 01:12:22.000000', 'temperatura', 57.0000, 'ºC'),
	(329647, 146, '2015-01-15 01:12:23.000000', 'temperatura', 458.0000, 'ºC'),
	(329648, 146, '2015-01-15 01:12:24.000000', 'temperatura', 919.0000, 'ºC'),
	(329649, 146, '2015-01-15 01:12:25.000000', 'temperatura', 822.0000, 'ºC'),
	(329650, 146, '2015-01-15 01:12:26.000000', 'temperatura', 155.0000, 'ºC'),
	(329651, 146, '2015-01-15 01:12:27.000000', 'temperatura', 707.0000, 'ºC'),
	(329652, 146, '2015-01-15 01:12:28.000000', 'temperatura', 671.0000, 'ºC'),
	(329653, 146, '2015-01-15 01:12:29.000000', 'temperatura', 34.0000, 'ºC'),
	(329654, 146, '2015-01-15 01:12:30.000000', 'temperatura', 560.0000, 'ºC'),
	(329655, 146, '2015-01-15 01:12:31.000000', 'temperatura', 295.0000, 'ºC'),
	(329656, 146, '2015-01-15 01:12:32.000000', 'temperatura', 999.0000, 'ºC'),
	(329657, 146, '2015-01-15 01:12:33.000000', 'temperatura', 508.0000, 'ºC'),
	(329658, 146, '2015-01-15 01:12:34.000000', 'temperatura', 743.0000, 'ºC'),
	(329659, 146, '2015-01-15 01:12:35.000000', 'temperatura', 993.0000, 'ºC'),
	(329660, 146, '2015-01-15 01:12:36.000000', 'temperatura', 336.0000, 'ºC'),
	(329661, 146, '2015-01-15 01:12:37.000000', 'temperatura', 1103.0000, 'ºC'),
	(329662, 146, '2015-01-15 01:12:38.000000', 'temperatura', 905.0000, 'ºC'),
	(329663, 146, '2015-01-15 01:12:39.000000', 'temperatura', 16.0000, 'ºC'),
	(329664, 146, '2015-01-15 01:12:40.000000', 'temperatura', 965.0000, 'ºC'),
	(329665, 146, '2015-01-15 01:12:41.000000', 'temperatura', 1179.0000, 'ºC'),
	(329666, 146, '2015-01-15 01:12:42.000000', 'temperatura', 600.0000, 'ºC'),
	(329667, 146, '2015-01-15 01:12:43.000000', 'temperatura', 665.0000, 'ºC'),
	(329668, 146, '2015-01-15 01:12:44.000000', 'temperatura', 325.0000, 'ºC'),
	(329669, 146, '2015-01-15 01:12:45.000000', 'temperatura', 829.0000, 'ºC'),
	(329670, 146, '2015-01-15 01:12:46.000000', 'temperatura', 770.0000, 'ºC'),
	(329671, 146, '2015-01-15 01:12:47.000000', 'temperatura', 164.0000, 'ºC'),
	(329672, 146, '2015-01-15 01:12:48.000000', 'temperatura', 912.0000, 'ºC'),
	(329673, 146, '2015-01-15 01:12:49.000000', 'temperatura', 467.0000, 'ºC'),
	(329674, 146, '2015-01-15 01:12:50.000000', 'temperatura', 801.0000, 'ºC'),
	(329675, 146, '2015-01-15 01:12:51.000000', 'temperatura', 204.0000, 'ºC'),
	(329676, 146, '2015-01-15 01:12:52.000000', 'temperatura', 1019.0000, 'ºC'),
	(329677, 146, '2015-01-15 01:12:53.000000', 'temperatura', 884.0000, 'ºC'),
	(329678, 146, '2015-01-15 01:12:54.000000', 'temperatura', 164.0000, 'ºC'),
	(329679, 146, '2015-01-15 01:12:55.000000', 'temperatura', 568.0000, 'ºC'),
	(329680, 146, '2015-01-15 01:12:56.000000', 'temperatura', 1147.0000, 'ºC'),
	(329681, 146, '2015-01-15 01:12:57.000000', 'temperatura', 431.0000, 'ºC'),
	(329682, 146, '2015-01-15 01:12:58.000000', 'temperatura', 1117.0000, 'ºC'),
	(329683, 146, '2015-01-15 01:12:59.000000', 'temperatura', 692.0000, 'ºC'),
	(329684, 146, '2015-01-15 01:13:00.000000', 'temperatura', 110.0000, 'ºC'),
	(329685, 146, '2015-01-15 01:13:01.000000', 'temperatura', 874.0000, 'ºC'),
	(329686, 146, '2015-01-15 01:13:02.000000', 'temperatura', 441.0000, 'ºC'),
	(329687, 146, '2015-01-15 01:13:03.000000', 'temperatura', 781.0000, 'ºC'),
	(329688, 146, '2015-01-15 01:13:04.000000', 'temperatura', 185.0000, 'ºC'),
	(329689, 146, '2015-01-15 01:13:05.000000', 'temperatura', 983.0000, 'ºC'),
	(329690, 146, '2015-01-15 01:13:06.000000', 'temperatura', 761.0000, 'ºC'),
	(329691, 146, '2015-01-15 01:13:07.000000', 'temperatura', 855.0000, 'ºC'),
	(329692, 146, '2015-01-15 01:13:08.000000', 'temperatura', 794.0000, 'ºC'),
	(329693, 146, '2015-01-15 01:13:09.000000', 'temperatura', 203.0000, 'ºC'),
	(329694, 146, '2015-01-15 01:13:10.000000', 'temperatura', 1036.0000, 'ºC'),
	(329695, 146, '2015-01-15 01:13:11.000000', 'temperatura', 970.0000, 'ºC'),
	(329696, 146, '2015-01-15 01:13:12.000000', 'temperatura', 544.0000, 'ºC'),
	(329697, 146, '2015-01-15 01:13:13.000000', 'temperatura', 1012.0000, 'ºC'),
	(329698, 146, '2015-01-15 01:13:14.000000', 'temperatura', 1025.0000, 'ºC'),
	(329699, 146, '2015-01-15 01:13:15.000000', 'temperatura', 891.0000, 'ºC'),
	(329700, 146, '2015-01-15 01:13:16.000000', 'temperatura', 179.0000, 'ºC'),
	(329701, 146, '2015-01-15 01:13:17.000000', 'temperatura', 622.0000, 'ºC'),
	(329702, 146, '2015-01-15 01:13:18.000000', 'temperatura', 174.0000, 'ºC'),
	(329703, 146, '2015-01-15 01:13:19.000000', 'temperatura', 204.0000, 'ºC'),
	(329704, 146, '2015-01-15 01:13:20.000000', 'temperatura', 497.0000, 'ºC'),
	(329705, 146, '2015-01-15 01:13:21.000000', 'temperatura', 676.0000, 'ºC'),
	(329706, 146, '2015-01-15 01:13:22.000000', 'temperatura', 688.0000, 'ºC'),
	(329707, 146, '2015-01-15 01:13:23.000000', 'temperatura', 214.0000, 'ºC'),
	(329708, 146, '2015-01-15 01:13:24.000000', 'temperatura', 206.0000, 'ºC'),
	(329709, 146, '2015-01-15 01:13:25.000000', 'temperatura', 388.0000, 'ºC'),
	(329710, 146, '2015-01-15 01:13:26.000000', 'temperatura', 122.0000, 'ºC'),
	(329711, 146, '2015-01-15 01:13:27.000000', 'temperatura', 646.0000, 'ºC'),
	(329712, 146, '2015-01-15 01:13:28.000000', 'temperatura', 467.0000, 'ºC'),
	(329713, 146, '2015-01-15 01:13:29.000000', 'temperatura', 396.0000, 'ºC'),
	(329714, 146, '2015-01-15 01:13:30.000000', 'temperatura', 580.0000, 'ºC'),
	(329715, 146, '2015-01-15 01:13:31.000000', 'temperatura', 511.0000, 'ºC'),
	(329716, 146, '2015-01-15 01:13:32.000000', 'temperatura', 815.0000, 'ºC'),
	(329717, 146, '2015-01-15 01:13:33.000000', 'temperatura', 141.0000, 'ºC'),
	(329718, 146, '2015-01-15 01:13:34.000000', 'temperatura', 664.0000, 'ºC'),
	(329719, 146, '2015-01-15 01:13:35.000000', 'temperatura', 496.0000, 'ºC'),
	(329720, 146, '2015-01-15 01:13:36.000000', 'temperatura', 487.0000, 'ºC'),
	(329721, 146, '2015-01-15 01:13:37.000000', 'temperatura', 949.0000, 'ºC'),
	(329722, 146, '2015-01-15 01:13:38.000000', 'temperatura', 885.0000, 'ºC'),
	(329723, 146, '2015-01-15 01:13:39.000000', 'temperatura', 376.0000, 'ºC'),
	(329724, 146, '2015-01-15 01:13:40.000000', 'temperatura', 426.0000, 'ºC'),
	(329725, 146, '2015-01-15 01:13:41.000000', 'temperatura', 1005.0000, 'ºC'),
	(329726, 146, '2015-01-15 01:13:42.000000', 'temperatura', 147.0000, 'ºC'),
	(329727, 146, '2015-01-15 01:13:43.000000', 'temperatura', 119.0000, 'ºC'),
	(329728, 146, '2015-01-15 01:13:44.000000', 'temperatura', 155.0000, 'ºC'),
	(329729, 146, '2015-01-15 01:13:45.000000', 'temperatura', 420.0000, 'ºC'),
	(329730, 146, '2015-01-15 01:13:46.000000', 'temperatura', 435.0000, 'ºC'),
	(329731, 146, '2015-01-15 01:13:47.000000', 'temperatura', 916.0000, 'ºC'),
	(329732, 146, '2015-01-15 01:13:48.000000', 'temperatura', 877.0000, 'ºC'),
	(329733, 146, '2015-01-15 01:13:49.000000', 'temperatura', 436.0000, 'ºC'),
	(329734, 146, '2015-01-15 01:13:50.000000', 'temperatura', 748.0000, 'ºC'),
	(329735, 146, '2015-01-15 01:13:51.000000', 'temperatura', 35.0000, 'ºC'),
	(329736, 146, '2015-01-15 01:13:52.000000', 'temperatura', 330.0000, 'ºC'),
	(329737, 146, '2015-01-15 01:13:53.000000', 'temperatura', 345.0000, 'ºC'),
	(329738, 146, '2015-01-15 01:13:54.000000', 'temperatura', 737.0000, 'ºC'),
	(329739, 146, '2015-01-15 01:13:55.000000', 'temperatura', 249.0000, 'ºC'),
	(329740, 146, '2015-01-15 01:13:56.000000', 'temperatura', 236.0000, 'ºC'),
	(329741, 146, '2015-01-15 01:13:57.000000', 'temperatura', 431.0000, 'ºC'),
	(329742, 146, '2015-01-15 01:13:58.000000', 'temperatura', 248.0000, 'ºC'),
	(329743, 146, '2015-01-15 01:13:59.000000', 'temperatura', 1148.0000, 'ºC'),
	(329744, 146, '2015-01-15 01:14:00.000000', 'temperatura', 197.0000, 'ºC'),
	(329745, 146, '2015-01-15 01:14:01.000000', 'temperatura', 1143.0000, 'ºC'),
	(329746, 146, '2015-01-15 01:14:02.000000', 'temperatura', 323.0000, 'ºC'),
	(329747, 146, '2015-01-15 01:14:03.000000', 'temperatura', 588.0000, 'ºC'),
	(329748, 146, '2015-01-15 01:14:04.000000', 'temperatura', 771.0000, 'ºC'),
	(329749, 146, '2015-01-15 01:14:05.000000', 'temperatura', 891.0000, 'ºC'),
	(329750, 146, '2015-01-15 01:14:06.000000', 'temperatura', 942.0000, 'ºC'),
	(329751, 146, '2015-01-15 01:14:07.000000', 'temperatura', 838.0000, 'ºC'),
	(329752, 146, '2015-01-15 01:14:08.000000', 'temperatura', 165.0000, 'ºC'),
	(329753, 146, '2015-01-15 01:14:09.000000', 'temperatura', 711.0000, 'ºC'),
	(329754, 146, '2015-01-15 01:14:10.000000', 'temperatura', 659.0000, 'ºC'),
	(329755, 146, '2015-01-15 01:14:11.000000', 'temperatura', 1163.0000, 'ºC'),
	(329756, 146, '2015-01-15 01:14:12.000000', 'temperatura', 238.0000, 'ºC'),
	(329757, 146, '2015-01-15 01:14:13.000000', 'temperatura', 103.0000, 'ºC'),
	(329758, 146, '2015-01-15 01:14:14.000000', 'temperatura', 1001.0000, 'ºC'),
	(329759, 146, '2015-01-15 01:14:15.000000', 'temperatura', 1097.0000, 'ºC'),
	(329760, 146, '2015-01-15 01:14:16.000000', 'temperatura', 82.0000, 'ºC'),
	(329761, 146, '2015-01-15 01:14:17.000000', 'temperatura', 721.0000, 'ºC'),
	(329762, 146, '2015-01-15 01:14:18.000000', 'temperatura', 958.0000, 'ºC'),
	(329763, 146, '2015-01-15 01:14:19.000000', 'temperatura', 227.0000, 'ºC'),
	(329764, 146, '2015-01-15 01:14:20.000000', 'temperatura', 664.0000, 'ºC'),
	(329765, 146, '2015-01-15 01:14:21.000000', 'temperatura', 237.0000, 'ºC'),
	(329766, 146, '2015-01-15 01:14:22.000000', 'temperatura', 396.0000, 'ºC'),
	(329767, 146, '2015-01-15 01:14:23.000000', 'temperatura', 70.0000, 'ºC'),
	(329768, 146, '2015-01-15 01:14:24.000000', 'temperatura', 361.0000, 'ºC'),
	(329769, 146, '2015-01-15 01:14:25.000000', 'temperatura', 395.0000, 'ºC'),
	(329770, 146, '2015-01-15 01:14:26.000000', 'temperatura', 894.0000, 'ºC'),
	(329771, 146, '2015-01-15 01:14:27.000000', 'temperatura', 884.0000, 'ºC'),
	(329772, 146, '2015-01-15 01:14:28.000000', 'temperatura', 538.0000, 'ºC'),
	(329773, 146, '2015-01-15 01:14:29.000000', 'temperatura', 41.0000, 'ºC'),
	(329774, 146, '2015-01-15 01:14:30.000000', 'temperatura', 989.0000, 'ºC'),
	(329775, 146, '2015-01-15 01:14:31.000000', 'temperatura', 24.0000, 'ºC'),
	(329776, 146, '2015-01-15 01:14:32.000000', 'temperatura', 755.0000, 'ºC'),
	(329777, 146, '2015-01-15 01:14:33.000000', 'temperatura', 103.0000, 'ºC'),
	(329778, 146, '2015-01-15 01:14:34.000000', 'temperatura', 649.0000, 'ºC'),
	(329779, 146, '2015-01-15 01:14:35.000000', 'temperatura', 536.0000, 'ºC'),
	(329780, 146, '2015-01-15 01:14:36.000000', 'temperatura', 734.0000, 'ºC'),
	(329781, 146, '2015-01-15 01:14:37.000000', 'temperatura', 861.0000, 'ºC'),
	(329782, 146, '2015-01-15 01:14:38.000000', 'temperatura', 905.0000, 'ºC'),
	(329783, 146, '2015-01-15 01:14:39.000000', 'temperatura', 741.0000, 'ºC'),
	(329784, 146, '2015-01-15 01:14:40.000000', 'temperatura', 990.0000, 'ºC'),
	(329785, 146, '2015-01-15 01:14:41.000000', 'temperatura', 329.0000, 'ºC'),
	(329786, 146, '2015-01-15 01:14:42.000000', 'temperatura', 1074.0000, 'ºC'),
	(329787, 146, '2015-01-15 01:14:43.000000', 'temperatura', 783.0000, 'ºC'),
	(329788, 146, '2015-01-15 01:14:44.000000', 'temperatura', 693.0000, 'ºC'),
	(329789, 146, '2015-01-15 01:14:45.000000', 'temperatura', 1118.0000, 'ºC'),
	(329790, 146, '2015-01-15 01:14:46.000000', 'temperatura', 1111.0000, 'ºC'),
	(329791, 146, '2015-01-15 01:14:47.000000', 'temperatura', 1000.0000, 'ºC'),
	(329792, 146, '2015-01-15 01:14:48.000000', 'temperatura', 466.0000, 'ºC'),
	(329793, 146, '2015-01-15 01:14:49.000000', 'temperatura', 534.0000, 'ºC'),
	(329794, 146, '2015-01-15 01:14:50.000000', 'temperatura', 73.0000, 'ºC'),
	(329795, 146, '2015-01-15 01:14:51.000000', 'temperatura', 1163.0000, 'ºC'),
	(329796, 146, '2015-01-15 01:14:52.000000', 'temperatura', 795.0000, 'ºC'),
	(329797, 146, '2015-01-15 01:14:53.000000', 'temperatura', 489.0000, 'ºC'),
	(329798, 146, '2015-01-15 01:14:54.000000', 'temperatura', 59.0000, 'ºC'),
	(329799, 146, '2015-01-15 01:14:55.000000', 'temperatura', 27.0000, 'ºC'),
	(329800, 146, '2015-01-15 01:14:56.000000', 'temperatura', 1158.0000, 'ºC'),
	(329801, 146, '2015-01-15 01:14:57.000000', 'temperatura', 910.0000, 'ºC'),
	(329802, 146, '2015-01-15 01:14:58.000000', 'temperatura', 1078.0000, 'ºC'),
	(329803, 146, '2015-01-15 01:14:59.000000', 'temperatura', 261.0000, 'ºC'),
	(329804, 146, '2015-01-15 01:15:00.000000', 'temperatura', 470.0000, 'ºC'),
	(329805, 146, '2015-01-15 01:15:01.000000', 'temperatura', 368.0000, 'ºC'),
	(329806, 146, '2015-01-15 01:15:02.000000', 'temperatura', 430.0000, 'ºC'),
	(329807, 146, '2015-01-15 01:15:03.000000', 'temperatura', 1049.0000, 'ºC'),
	(329808, 146, '2015-01-15 01:15:04.000000', 'temperatura', 353.0000, 'ºC'),
	(329809, 146, '2015-01-15 01:15:05.000000', 'temperatura', 1019.0000, 'ºC'),
	(329810, 146, '2015-01-15 01:15:06.000000', 'temperatura', 437.0000, 'ºC'),
	(329811, 146, '2015-01-15 01:15:07.000000', 'temperatura', 329.0000, 'ºC'),
	(329812, 146, '2015-01-15 01:15:08.000000', 'temperatura', 333.0000, 'ºC'),
	(329813, 146, '2015-01-15 01:15:09.000000', 'temperatura', 680.0000, 'ºC'),
	(329814, 146, '2015-01-15 01:15:10.000000', 'temperatura', 1.0000, 'ºC'),
	(329815, 146, '2015-01-15 01:15:11.000000', 'temperatura', 367.0000, 'ºC'),
	(329816, 146, '2015-01-15 01:15:12.000000', 'temperatura', 632.0000, 'ºC'),
	(329817, 146, '2015-01-15 01:15:13.000000', 'temperatura', 859.0000, 'ºC'),
	(329818, 146, '2015-01-15 01:15:14.000000', 'temperatura', 0.0000, 'ºC'),
	(329819, 146, '2015-01-15 01:15:15.000000', 'temperatura', 1022.0000, 'ºC'),
	(329820, 146, '2015-01-15 01:15:16.000000', 'temperatura', 310.0000, 'ºC'),
	(329821, 146, '2015-01-15 01:15:17.000000', 'temperatura', 885.0000, 'ºC'),
	(329822, 146, '2015-01-15 01:15:18.000000', 'temperatura', 1096.0000, 'ºC'),
	(329823, 146, '2015-01-15 01:15:19.000000', 'temperatura', 426.0000, 'ºC'),
	(329824, 146, '2015-01-15 01:15:20.000000', 'temperatura', 43.0000, 'ºC'),
	(329825, 146, '2015-01-15 01:15:21.000000', 'temperatura', 136.0000, 'ºC'),
	(329826, 146, '2015-01-15 01:15:22.000000', 'temperatura', 553.0000, 'ºC'),
	(329827, 146, '2015-01-15 01:15:23.000000', 'temperatura', 1157.0000, 'ºC'),
	(329828, 146, '2015-01-15 01:15:24.000000', 'temperatura', 527.0000, 'ºC'),
	(329829, 146, '2015-01-15 01:15:25.000000', 'temperatura', 365.0000, 'ºC'),
	(329830, 146, '2015-01-15 01:15:26.000000', 'temperatura', 244.0000, 'ºC'),
	(329831, 146, '2015-01-15 01:15:27.000000', 'temperatura', 124.0000, 'ºC'),
	(329832, 146, '2015-01-15 01:15:28.000000', 'temperatura', 1090.0000, 'ºC'),
	(329833, 146, '2015-01-15 01:15:29.000000', 'temperatura', 277.0000, 'ºC'),
	(329834, 146, '2015-01-15 01:15:30.000000', 'temperatura', 515.0000, 'ºC'),
	(329835, 146, '2015-01-15 01:15:31.000000', 'temperatura', 543.0000, 'ºC'),
	(329836, 146, '2015-01-15 01:15:32.000000', 'temperatura', 1173.0000, 'ºC'),
	(329837, 146, '2015-01-15 01:15:33.000000', 'temperatura', 638.0000, 'ºC'),
	(329838, 146, '2015-01-15 01:15:34.000000', 'temperatura', 869.0000, 'ºC'),
	(329839, 146, '2015-01-15 01:15:35.000000', 'temperatura', 31.0000, 'ºC'),
	(329840, 146, '2015-01-15 01:15:36.000000', 'temperatura', 1149.0000, 'ºC'),
	(329841, 146, '2015-01-15 01:15:37.000000', 'temperatura', 851.0000, 'ºC'),
	(329842, 146, '2015-01-15 01:15:38.000000', 'temperatura', 809.0000, 'ºC'),
	(329843, 146, '2015-01-15 01:15:39.000000', 'temperatura', 292.0000, 'ºC'),
	(329844, 146, '2015-01-15 01:15:40.000000', 'temperatura', 234.0000, 'ºC'),
	(329845, 146, '2015-01-15 01:15:41.000000', 'temperatura', 293.0000, 'ºC'),
	(329846, 146, '2015-01-15 01:15:42.000000', 'temperatura', 766.0000, 'ºC'),
	(329847, 146, '2015-01-15 01:15:43.000000', 'temperatura', 549.0000, 'ºC'),
	(329848, 146, '2015-01-15 01:15:44.000000', 'temperatura', 450.0000, 'ºC'),
	(329849, 146, '2015-01-15 01:15:45.000000', 'temperatura', 601.0000, 'ºC'),
	(329850, 146, '2015-01-15 01:15:46.000000', 'temperatura', 455.0000, 'ºC'),
	(329851, 146, '2015-01-15 01:15:47.000000', 'temperatura', 472.0000, 'ºC'),
	(329852, 146, '2015-01-15 01:15:48.000000', 'temperatura', 996.0000, 'ºC'),
	(329853, 146, '2015-01-15 01:15:49.000000', 'temperatura', 1166.0000, 'ºC'),
	(329854, 146, '2015-01-15 01:15:50.000000', 'temperatura', 442.0000, 'ºC'),
	(329855, 146, '2015-01-15 01:15:51.000000', 'temperatura', 1112.0000, 'ºC'),
	(329856, 146, '2015-01-15 01:15:52.000000', 'temperatura', 634.0000, 'ºC'),
	(329857, 146, '2015-01-15 01:15:53.000000', 'temperatura', 1034.0000, 'ºC'),
	(329858, 146, '2015-01-15 01:15:54.000000', 'temperatura', 871.0000, 'ºC'),
	(329859, 146, '2015-01-15 01:15:55.000000', 'temperatura', 52.0000, 'ºC'),
	(329860, 146, '2015-01-15 01:15:56.000000', 'temperatura', 46.0000, 'ºC'),
	(329861, 146, '2015-01-15 01:15:57.000000', 'temperatura', 76.0000, 'ºC'),
	(329862, 146, '2015-01-15 01:15:58.000000', 'temperatura', 241.0000, 'ºC'),
	(329863, 146, '2015-01-15 01:15:59.000000', 'temperatura', 978.0000, 'ºC'),
	(329864, 146, '2015-01-15 01:16:00.000000', 'temperatura', 567.0000, 'ºC'),
	(329865, 146, '2015-01-15 01:16:01.000000', 'temperatura', 1101.0000, 'ºC'),
	(329866, 146, '2015-01-15 01:16:02.000000', 'temperatura', 203.0000, 'ºC'),
	(329867, 146, '2015-01-15 01:16:03.000000', 'temperatura', 116.0000, 'ºC'),
	(329868, 146, '2015-01-15 01:16:04.000000', 'temperatura', 1170.0000, 'ºC'),
	(329869, 146, '2015-01-15 01:16:05.000000', 'temperatura', 704.0000, 'ºC'),
	(329870, 146, '2015-01-15 01:16:06.000000', 'temperatura', 11.0000, 'ºC'),
	(329871, 146, '2015-01-15 01:16:07.000000', 'temperatura', 341.0000, 'ºC'),
	(329872, 146, '2015-01-15 01:16:08.000000', 'temperatura', 475.0000, 'ºC'),
	(329873, 146, '2015-01-15 01:16:09.000000', 'temperatura', 150.0000, 'ºC'),
	(329874, 146, '2015-01-15 01:16:10.000000', 'temperatura', 525.0000, 'ºC'),
	(329875, 146, '2015-01-15 01:16:11.000000', 'temperatura', 977.0000, 'ºC'),
	(329876, 146, '2015-01-15 01:16:12.000000', 'temperatura', 911.0000, 'ºC'),
	(329877, 146, '2015-01-15 01:16:13.000000', 'temperatura', 425.0000, 'ºC'),
	(329878, 146, '2015-01-15 01:16:14.000000', 'temperatura', 594.0000, 'ºC'),
	(329879, 146, '2015-01-15 01:16:15.000000', 'temperatura', 492.0000, 'ºC'),
	(329880, 146, '2015-01-15 01:16:16.000000', 'temperatura', 681.0000, 'ºC'),
	(329881, 146, '2015-01-15 01:16:17.000000', 'temperatura', 729.0000, 'ºC'),
	(329882, 146, '2015-01-15 01:16:18.000000', 'temperatura', 404.0000, 'ºC'),
	(329883, 146, '2015-01-15 01:16:19.000000', 'temperatura', 1033.0000, 'ºC'),
	(329884, 146, '2015-01-15 01:16:20.000000', 'temperatura', 352.0000, 'ºC'),
	(329885, 146, '2015-01-15 01:16:21.000000', 'temperatura', 1063.0000, 'ºC'),
	(329886, 146, '2015-01-15 01:16:22.000000', 'temperatura', 658.0000, 'ºC'),
	(329887, 146, '2015-01-15 01:16:23.000000', 'temperatura', 101.0000, 'ºC'),
	(329888, 146, '2015-01-15 01:16:24.000000', 'temperatura', 932.0000, 'ºC'),
	(329889, 146, '2015-01-15 01:16:25.000000', 'temperatura', 758.0000, 'ºC'),
	(329890, 146, '2015-01-15 01:16:26.000000', 'temperatura', 993.0000, 'ºC'),
	(329891, 146, '2015-01-15 01:16:27.000000', 'temperatura', 290.0000, 'ºC'),
	(329892, 146, '2015-01-15 01:16:28.000000', 'temperatura', 874.0000, 'ºC'),
	(329893, 146, '2015-01-15 01:16:29.000000', 'temperatura', 1102.0000, 'ºC'),
	(329894, 146, '2015-01-15 01:16:30.000000', 'temperatura', 487.0000, 'ºC'),
	(329895, 146, '2015-01-15 01:16:31.000000', 'temperatura', 328.0000, 'ºC'),
	(329896, 146, '2015-01-15 01:16:32.000000', 'temperatura', 182.0000, 'ºC'),
	(329897, 146, '2015-01-15 01:16:33.000000', 'temperatura', 1127.0000, 'ºC'),
	(329898, 146, '2015-01-15 01:16:34.000000', 'temperatura', 290.0000, 'ºC'),
	(329899, 146, '2015-01-15 01:16:35.000000', 'temperatura', 470.0000, 'ºC'),
	(329900, 146, '2015-01-15 01:16:36.000000', 'temperatura', 279.0000, 'ºC'),
	(329901, 146, '2015-01-15 01:16:37.000000', 'temperatura', 1186.0000, 'ºC'),
	(329902, 146, '2015-01-15 01:16:38.000000', 'temperatura', 293.0000, 'ºC'),
	(329903, 146, '2015-01-15 01:16:39.000000', 'temperatura', 310.0000, 'ºC'),
	(329904, 146, '2015-01-15 01:16:40.000000', 'temperatura', 669.0000, 'ºC'),
	(329905, 146, '2015-01-15 01:16:41.000000', 'temperatura', 17.0000, 'ºC'),
	(329906, 146, '2015-01-15 01:16:42.000000', 'temperatura', 480.0000, 'ºC'),
	(329907, 146, '2015-01-15 01:16:43.000000', 'temperatura', 1147.0000, 'ºC'),
	(329908, 146, '2015-01-15 01:16:44.000000', 'temperatura', 696.0000, 'ºC'),
	(329909, 146, '2015-01-15 01:16:45.000000', 'temperatura', 39.0000, 'ºC'),
	(329910, 146, '2015-01-15 01:16:46.000000', 'temperatura', 508.0000, 'ºC'),
	(329911, 146, '2015-01-15 01:16:47.000000', 'temperatura', 23.0000, 'ºC'),
	(329912, 146, '2015-01-15 01:16:48.000000', 'temperatura', 992.0000, 'ºC'),
	(329913, 146, '2015-01-15 01:16:49.000000', 'temperatura', 90.0000, 'ºC'),
	(329914, 146, '2015-01-15 01:16:50.000000', 'temperatura', 1076.0000, 'ºC'),
	(329915, 146, '2015-01-15 01:16:51.000000', 'temperatura', 312.0000, 'ºC'),
	(329916, 146, '2015-01-15 01:16:52.000000', 'temperatura', 731.0000, 'ºC'),
	(329917, 146, '2015-01-15 01:16:53.000000', 'temperatura', 318.0000, 'ºC'),
	(329918, 146, '2015-01-15 01:16:54.000000', 'temperatura', 597.0000, 'ºC'),
	(329919, 146, '2015-01-15 01:16:55.000000', 'temperatura', 830.0000, 'ºC'),
	(329920, 146, '2015-01-15 01:16:56.000000', 'temperatura', 1163.0000, 'ºC'),
	(329921, 146, '2015-01-15 01:16:57.000000', 'temperatura', 926.0000, 'ºC'),
	(329922, 146, '2015-01-15 01:16:58.000000', 'temperatura', 1142.0000, 'ºC'),
	(329923, 146, '2015-01-15 01:16:59.000000', 'temperatura', 532.0000, 'ºC'),
	(329924, 146, '2015-01-15 01:17:00.000000', 'temperatura', 434.0000, 'ºC'),
	(329925, 146, '2015-01-15 01:17:01.000000', 'temperatura', 573.0000, 'ºC'),
	(329926, 146, '2015-01-15 01:17:02.000000', 'temperatura', 366.0000, 'ºC'),
	(329927, 146, '2015-01-15 01:17:03.000000', 'temperatura', 109.0000, 'ºC'),
	(329928, 146, '2015-01-15 01:17:04.000000', 'temperatura', 648.0000, 'ºC'),
	(329929, 146, '2015-01-15 01:17:05.000000', 'temperatura', 514.0000, 'ºC'),
	(329930, 146, '2015-01-15 01:17:06.000000', 'temperatura', 627.0000, 'ºC'),
	(329931, 146, '2015-01-15 01:17:07.000000', 'temperatura', 393.0000, 'ºC'),
	(329932, 146, '2015-01-15 01:17:08.000000', 'temperatura', 86.0000, 'ºC'),
	(329933, 146, '2015-01-15 01:17:09.000000', 'temperatura', 451.0000, 'ºC'),
	(329934, 146, '2015-01-15 01:17:10.000000', 'temperatura', 796.0000, 'ºC'),
	(329935, 146, '2015-01-15 01:17:11.000000', 'temperatura', 227.0000, 'ºC'),
	(329936, 146, '2015-01-15 01:17:12.000000', 'temperatura', 1150.0000, 'ºC'),
	(329937, 146, '2015-01-15 01:17:13.000000', 'temperatura', 268.0000, 'ºC'),
	(329938, 146, '2015-01-15 01:17:14.000000', 'temperatura', 291.0000, 'ºC'),
	(329939, 146, '2015-01-15 01:17:15.000000', 'temperatura', 651.0000, 'ºC'),
	(329940, 146, '2015-01-15 01:17:16.000000', 'temperatura', 1185.0000, 'ºC'),
	(329941, 146, '2015-01-15 01:17:17.000000', 'temperatura', 370.0000, 'ºC'),
	(329942, 146, '2015-01-15 01:17:18.000000', 'temperatura', 697.0000, 'ºC'),
	(329943, 146, '2015-01-15 01:17:19.000000', 'temperatura', 1177.0000, 'ºC'),
	(329944, 146, '2015-01-15 01:17:20.000000', 'temperatura', 192.0000, 'ºC'),
	(329945, 146, '2015-01-15 01:17:21.000000', 'temperatura', 1028.0000, 'ºC'),
	(329946, 146, '2015-01-15 01:17:22.000000', 'temperatura', 968.0000, 'ºC'),
	(329947, 146, '2015-01-15 01:17:23.000000', 'temperatura', 555.0000, 'ºC'),
	(329948, 146, '2015-01-15 01:17:24.000000', 'temperatura', 1072.0000, 'ºC'),
	(329949, 146, '2015-01-15 01:17:25.000000', 'temperatura', 94.0000, 'ºC'),
	(329950, 146, '2015-01-15 01:17:26.000000', 'temperatura', 856.0000, 'ºC'),
	(329951, 146, '2015-01-15 01:17:27.000000', 'temperatura', 396.0000, 'ºC'),
	(329952, 146, '2015-01-15 01:17:28.000000', 'temperatura', 614.0000, 'ºC'),
	(329953, 146, '2015-01-15 01:17:29.000000', 'temperatura', 683.0000, 'ºC'),
	(329954, 146, '2015-01-15 01:17:30.000000', 'temperatura', 373.0000, 'ºC'),
	(329955, 146, '2015-01-15 01:17:31.000000', 'temperatura', 1015.0000, 'ºC'),
	(329956, 146, '2015-01-15 01:17:32.000000', 'temperatura', 357.0000, 'ºC'),
	(329957, 146, '2015-01-15 01:17:33.000000', 'temperatura', 1142.0000, 'ºC'),
	(329958, 146, '2015-01-15 01:17:34.000000', 'temperatura', 1040.0000, 'ºC'),
	(329959, 146, '2015-01-15 01:17:35.000000', 'temperatura', 575.0000, 'ºC'),
	(329960, 146, '2015-01-15 01:17:36.000000', 'temperatura', 955.0000, 'ºC'),
	(329961, 146, '2015-01-15 01:17:37.000000', 'temperatura', 649.0000, 'ºC'),
	(329962, 146, '2015-01-15 01:17:38.000000', 'temperatura', 380.0000, 'ºC'),
	(329963, 146, '2015-01-15 01:17:39.000000', 'temperatura', 1154.0000, 'ºC'),
	(329964, 146, '2015-01-15 01:17:40.000000', 'temperatura', 1031.0000, 'ºC'),
	(329965, 146, '2015-01-15 01:17:41.000000', 'temperatura', 494.0000, 'ºC'),
	(329966, 146, '2015-01-15 01:17:42.000000', 'temperatura', 578.0000, 'ºC'),
	(329967, 146, '2015-01-15 01:17:43.000000', 'temperatura', 206.0000, 'ºC'),
	(329968, 146, '2015-01-15 01:17:44.000000', 'temperatura', 497.0000, 'ºC'),
	(329969, 146, '2015-01-15 01:17:45.000000', 'temperatura', 669.0000, 'ºC'),
	(329970, 146, '2015-01-15 01:17:46.000000', 'temperatura', 653.0000, 'ºC'),
	(329971, 146, '2015-01-15 01:17:47.000000', 'temperatura', 59.0000, 'ºC'),
	(329972, 146, '2015-01-15 01:17:48.000000', 'temperatura', 735.0000, 'ºC'),
	(329973, 146, '2015-01-15 01:17:49.000000', 'temperatura', 1101.0000, 'ºC'),
	(329974, 146, '2015-01-15 01:17:50.000000', 'temperatura', 898.0000, 'ºC'),
	(329975, 146, '2015-01-15 01:17:51.000000', 'temperatura', 1191.0000, 'ºC'),
	(329976, 146, '2015-01-15 01:17:52.000000', 'temperatura', 858.0000, 'ºC'),
	(329977, 146, '2015-01-15 01:17:53.000000', 'temperatura', 719.0000, 'ºC'),
	(329978, 146, '2015-01-15 01:17:54.000000', 'temperatura', 1023.0000, 'ºC'),
	(329979, 146, '2015-01-15 01:17:55.000000', 'temperatura', 556.0000, 'ºC'),
	(329980, 146, '2015-01-15 01:17:56.000000', 'temperatura', 912.0000, 'ºC'),
	(329981, 146, '2015-01-15 01:17:57.000000', 'temperatura', 492.0000, 'ºC'),
	(329982, 146, '2015-01-15 01:17:58.000000', 'temperatura', 927.0000, 'ºC'),
	(329983, 146, '2015-01-15 01:17:59.000000', 'temperatura', 757.0000, 'ºC'),
	(329984, 146, '2015-01-15 01:18:00.000000', 'temperatura', 1006.0000, 'ºC'),
	(329985, 146, '2015-01-15 01:18:01.000000', 'temperatura', 360.0000, 'ºC'),
	(329986, 146, '2015-01-15 01:18:02.000000', 'temperatura', 1180.0000, 'ºC'),
	(329987, 146, '2015-01-15 01:18:03.000000', 'temperatura', 23.0000, 'ºC'),
	(329988, 146, '2015-01-15 01:18:04.000000', 'temperatura', 174.0000, 'ºC'),
	(329989, 146, '2015-01-15 01:18:05.000000', 'temperatura', 801.0000, 'ºC'),
	(329990, 146, '2015-01-15 01:18:06.000000', 'temperatura', 1083.0000, 'ºC'),
	(329991, 146, '2015-01-15 01:18:07.000000', 'temperatura', 612.0000, 'ºC'),
	(329992, 146, '2015-01-15 01:18:08.000000', 'temperatura', 1014.0000, 'ºC'),
	(329993, 146, '2015-01-15 01:18:09.000000', 'temperatura', 833.0000, 'ºC'),
	(329994, 146, '2015-01-15 01:18:10.000000', 'temperatura', 1124.0000, 'ºC'),
	(329995, 146, '2015-01-15 01:18:11.000000', 'temperatura', 722.0000, 'ºC'),
	(329996, 146, '2015-01-15 01:18:12.000000', 'temperatura', 239.0000, 'ºC'),
	(329997, 146, '2015-01-15 01:18:13.000000', 'temperatura', 228.0000, 'ºC'),
	(329998, 146, '2015-01-15 01:18:14.000000', 'temperatura', 422.0000, 'ºC'),
	(329999, 146, '2015-01-15 01:18:15.000000', 'temperatura', 229.0000, 'ºC'),
	(330000, 146, '2015-01-15 01:18:16.000000', 'temperatura', 1078.0000, 'ºC'),
	(330001, 146, '2015-01-15 01:18:17.000000', 'temperatura', 1104.0000, 'ºC'),
	(330002, 146, '2015-01-15 01:18:18.000000', 'temperatura', 1087.0000, 'ºC'),
	(330003, 146, '2015-01-15 01:18:19.000000', 'temperatura', 923.0000, 'ºC'),
	(330004, 146, '2015-01-15 01:18:20.000000', 'temperatura', 156.0000, 'ºC'),
	(330005, 146, '2015-01-15 01:18:21.000000', 'temperatura', 409.0000, 'ºC'),
	(330006, 146, '2015-01-15 01:18:22.000000', 'temperatura', 379.0000, 'ºC'),
	(330007, 146, '2015-01-15 01:18:23.000000', 'temperatura', 669.0000, 'ºC'),
	(330008, 146, '2015-01-15 01:18:24.000000', 'temperatura', 1008.0000, 'ºC'),
	(330009, 146, '2015-01-15 01:18:25.000000', 'temperatura', 635.0000, 'ºC'),
	(330010, 146, '2015-01-15 01:18:26.000000', 'temperatura', 152.0000, 'ºC'),
	(330011, 146, '2015-01-15 01:18:27.000000', 'temperatura', 53.0000, 'ºC'),
	(330012, 146, '2015-01-15 01:18:28.000000', 'temperatura', 1009.0000, 'ºC'),
	(330013, 146, '2015-01-15 01:18:29.000000', 'temperatura', 85.0000, 'ºC'),
	(330014, 146, '2015-01-15 01:18:30.000000', 'temperatura', 1002.0000, 'ºC'),
	(330015, 146, '2015-01-15 01:18:31.000000', 'temperatura', 1156.0000, 'ºC'),
	(330016, 146, '2015-01-15 01:18:32.000000', 'temperatura', 372.0000, 'ºC'),
	(330017, 146, '2015-01-15 01:18:33.000000', 'temperatura', 794.0000, 'ºC'),
	(330018, 146, '2015-01-15 01:18:34.000000', 'temperatura', 456.0000, 'ºC'),
	(330019, 146, '2015-01-15 01:18:35.000000', 'temperatura', 1097.0000, 'ºC'),
	(330020, 146, '2015-01-15 01:18:36.000000', 'temperatura', 518.0000, 'ºC'),
	(330021, 146, '2015-01-15 01:18:37.000000', 'temperatura', 498.0000, 'ºC'),
	(330022, 146, '2015-01-15 01:18:38.000000', 'temperatura', 939.0000, 'ºC'),
	(330023, 146, '2015-01-15 01:18:39.000000', 'temperatura', 800.0000, 'ºC'),
	(330024, 146, '2015-01-15 01:18:40.000000', 'temperatura', 1182.0000, 'ºC'),
	(330025, 146, '2015-01-15 01:18:41.000000', 'temperatura', 1114.0000, 'ºC'),
	(330026, 146, '2015-01-15 01:18:42.000000', 'temperatura', 821.0000, 'ºC'),
	(330027, 146, '2015-01-15 01:18:43.000000', 'temperatura', 766.0000, 'ºC'),
	(330028, 146, '2015-01-15 01:18:44.000000', 'temperatura', 167.0000, 'ºC'),
	(330029, 146, '2015-01-15 01:18:45.000000', 'temperatura', 936.0000, 'ºC'),
	(330030, 146, '2015-01-15 01:18:46.000000', 'temperatura', 579.0000, 'ºC'),
	(330031, 146, '2015-01-15 01:18:47.000000', 'temperatura', 87.0000, 'ºC'),
	(330032, 146, '2015-01-15 01:18:48.000000', 'temperatura', 1099.0000, 'ºC'),
	(330033, 146, '2015-01-15 01:18:49.000000', 'temperatura', 436.0000, 'ºC'),
	(330034, 146, '2015-01-15 01:18:50.000000', 'temperatura', 83.0000, 'ºC'),
	(330035, 146, '2015-01-15 01:18:51.000000', 'temperatura', 306.0000, 'ºC'),
	(330036, 146, '2015-01-15 01:18:52.000000', 'temperatura', 82.0000, 'ºC'),
	(330037, 146, '2015-01-15 01:18:53.000000', 'temperatura', 695.0000, 'ºC'),
	(330038, 146, '2015-01-15 01:18:54.000000', 'temperatura', 827.0000, 'ºC'),
	(330039, 146, '2015-01-15 01:18:55.000000', 'temperatura', 850.0000, 'ºC'),
	(330040, 146, '2015-01-15 01:18:56.000000', 'temperatura', 569.0000, 'ºC'),
	(330041, 146, '2015-01-15 01:18:57.000000', 'temperatura', 298.0000, 'ºC'),
	(330042, 146, '2015-01-15 01:18:58.000000', 'temperatura', 983.0000, 'ºC'),
	(330043, 146, '2015-01-15 01:18:59.000000', 'temperatura', 421.0000, 'ºC'),
	(330044, 146, '2015-01-15 01:19:00.000000', 'temperatura', 356.0000, 'ºC'),
	(330045, 146, '2015-01-15 01:19:01.000000', 'temperatura', 518.0000, 'ºC'),
	(330046, 146, '2015-01-15 01:19:02.000000', 'temperatura', 321.0000, 'ºC'),
	(330047, 146, '2015-01-15 01:19:03.000000', 'temperatura', 52.0000, 'ºC'),
	(330048, 146, '2015-01-15 01:19:04.000000', 'temperatura', 498.0000, 'ºC'),
	(330049, 146, '2015-01-15 01:19:05.000000', 'temperatura', 1133.0000, 'ºC'),
	(330050, 146, '2015-01-15 01:19:06.000000', 'temperatura', 573.0000, 'ºC'),
	(330051, 146, '2015-01-15 01:19:07.000000', 'temperatura', 666.0000, 'ºC'),
	(330052, 146, '2015-01-15 01:19:08.000000', 'temperatura', 411.0000, 'ºC'),
	(330053, 146, '2015-01-15 01:19:09.000000', 'temperatura', 60.0000, 'ºC'),
	(330054, 146, '2015-01-15 01:19:10.000000', 'temperatura', 264.0000, 'ºC'),
	(330055, 146, '2015-01-15 01:19:11.000000', 'temperatura', 1142.0000, 'ºC'),
	(330056, 146, '2015-01-15 01:19:12.000000', 'temperatura', 118.0000, 'ºC'),
	(330057, 146, '2015-01-15 01:19:13.000000', 'temperatura', 765.0000, 'ºC'),
	(330058, 146, '2015-01-15 01:19:14.000000', 'temperatura', 1070.0000, 'ºC'),
	(330059, 146, '2015-01-15 01:19:15.000000', 'temperatura', 658.0000, 'ºC'),
	(330060, 146, '2015-01-15 01:19:16.000000', 'temperatura', 80.0000, 'ºC'),
	(330061, 146, '2015-01-15 01:19:17.000000', 'temperatura', 827.0000, 'ºC'),
	(330062, 146, '2015-01-15 01:19:18.000000', 'temperatura', 293.0000, 'ºC'),
	(330063, 146, '2015-01-15 01:19:19.000000', 'temperatura', 187.0000, 'ºC'),
	(330064, 146, '2015-01-15 01:19:20.000000', 'temperatura', 57.0000, 'ºC'),
	(330065, 146, '2015-01-15 01:19:21.000000', 'temperatura', 924.0000, 'ºC'),
	(330066, 146, '2015-01-15 01:19:22.000000', 'temperatura', 851.0000, 'ºC'),
	(330067, 146, '2015-01-15 01:19:23.000000', 'temperatura', 282.0000, 'ºC'),
	(330068, 146, '2015-01-15 01:19:24.000000', 'temperatura', 56.0000, 'ºC'),
	(330069, 146, '2015-01-15 01:19:25.000000', 'temperatura', 637.0000, 'ºC'),
	(330070, 146, '2015-01-15 01:19:26.000000', 'temperatura', 616.0000, 'ºC'),
	(330071, 146, '2015-01-15 01:19:27.000000', 'temperatura', 1169.0000, 'ºC'),
	(330072, 146, '2015-01-15 01:19:28.000000', 'temperatura', 397.0000, 'ºC'),
	(330073, 146, '2015-01-15 01:19:29.000000', 'temperatura', 881.0000, 'ºC'),
	(330074, 146, '2015-01-15 01:19:30.000000', 'temperatura', 815.0000, 'ºC'),
	(330075, 146, '2015-01-15 01:19:31.000000', 'temperatura', 231.0000, 'ºC'),
	(330076, 146, '2015-01-15 01:19:32.000000', 'temperatura', 1112.0000, 'ºC'),
	(330077, 146, '2015-01-15 01:19:33.000000', 'temperatura', 67.0000, 'ºC'),
	(330078, 146, '2015-01-15 01:19:34.000000', 'temperatura', 601.0000, 'ºC'),
	(330079, 146, '2015-01-15 01:19:35.000000', 'temperatura', 403.0000, 'ºC'),
	(330080, 146, '2015-01-15 01:19:36.000000', 'temperatura', 213.0000, 'ºC'),
	(330081, 146, '2015-01-15 01:19:37.000000', 'temperatura', 1056.0000, 'ºC'),
	(330082, 146, '2015-01-15 01:19:38.000000', 'temperatura', 1043.0000, 'ºC'),
	(330083, 146, '2015-01-15 01:19:39.000000', 'temperatura', 848.0000, 'ºC'),
	(330084, 146, '2015-01-15 01:19:40.000000', 'temperatura', 1111.0000, 'ºC'),
	(330085, 146, '2015-01-15 01:19:41.000000', 'temperatura', 612.0000, 'ºC'),
	(330086, 146, '2015-01-15 01:19:42.000000', 'temperatura', 927.0000, 'ºC'),
	(330087, 146, '2015-01-15 01:19:43.000000', 'temperatura', 400.0000, 'ºC'),
	(330088, 146, '2015-01-15 01:19:44.000000', 'temperatura', 421.0000, 'ºC'),
	(330089, 146, '2015-01-15 01:19:45.000000', 'temperatura', 903.0000, 'ºC'),
	(330090, 146, '2015-01-15 01:19:46.000000', 'temperatura', 854.0000, 'ºC'),
	(330091, 146, '2015-01-15 01:19:47.000000', 'temperatura', 360.0000, 'ºC'),
	(330092, 146, '2015-01-15 01:19:48.000000', 'temperatura', 438.0000, 'ºC'),
	(330093, 146, '2015-01-15 01:19:49.000000', 'temperatura', 1111.0000, 'ºC'),
	(330094, 146, '2015-01-15 01:19:50.000000', 'temperatura', 644.0000, 'ºC'),
	(330095, 146, '2015-01-15 01:19:51.000000', 'temperatura', 1084.0000, 'ºC'),
	(330096, 146, '2015-01-15 01:19:52.000000', 'temperatura', 1090.0000, 'ºC'),
	(330097, 146, '2015-01-15 01:19:53.000000', 'temperatura', 998.0000, 'ºC'),
	(330098, 146, '2015-01-15 01:19:54.000000', 'temperatura', 522.0000, 'ºC'),
	(330099, 146, '2015-01-15 01:19:55.000000', 'temperatura', 814.0000, 'ºC'),
	(330100, 146, '2015-01-15 01:19:56.000000', 'temperatura', 105.0000, 'ºC'),
	(330101, 146, '2015-01-15 01:19:57.000000', 'temperatura', 482.0000, 'ºC'),
	(330102, 146, '2015-01-15 01:19:58.000000', 'temperatura', 899.0000, 'ºC'),
	(330103, 146, '2015-01-15 01:19:59.000000', 'temperatura', 648.0000, 'ºC'),
	(330104, 146, '2015-01-15 01:20:00.000000', 'temperatura', 544.0000, 'ºC'),
	(330105, 146, '2015-01-15 01:20:01.000000', 'temperatura', 775.0000, 'ºC'),
	(330106, 146, '2015-01-15 01:20:02.000000', 'temperatura', 1043.0000, 'ºC'),
	(330107, 146, '2015-01-15 01:20:03.000000', 'temperatura', 490.0000, 'ºC'),
	(330108, 146, '2015-01-15 01:20:04.000000', 'temperatura', 523.0000, 'ºC'),
	(330109, 146, '2015-01-15 01:20:05.000000', 'temperatura', 1147.0000, 'ºC'),
	(330110, 146, '2015-01-15 01:20:06.000000', 'temperatura', 566.0000, 'ºC'),
	(330111, 146, '2015-01-15 01:20:07.000000', 'temperatura', 588.0000, 'ºC'),
	(330112, 146, '2015-01-15 01:20:08.000000', 'temperatura', 44.0000, 'ºC'),
	(330113, 146, '2015-01-15 01:20:09.000000', 'temperatura', 854.0000, 'ºC'),
	(330114, 146, '2015-01-15 01:20:10.000000', 'temperatura', 539.0000, 'ºC'),
	(330115, 146, '2015-01-15 01:20:11.000000', 'temperatura', 135.0000, 'ºC'),
	(330116, 146, '2015-01-15 01:20:12.000000', 'temperatura', 260.0000, 'ºC'),
	(330117, 146, '2015-01-15 01:20:13.000000', 'temperatura', 892.0000, 'ºC'),
	(330118, 146, '2015-01-15 01:20:14.000000', 'temperatura', 84.0000, 'ºC'),
	(330119, 146, '2015-01-15 01:20:15.000000', 'temperatura', 141.0000, 'ºC'),
	(330120, 146, '2015-01-15 01:20:16.000000', 'temperatura', 456.0000, 'ºC'),
	(330121, 146, '2015-01-15 01:20:17.000000', 'temperatura', 656.0000, 'ºC'),
	(330122, 146, '2015-01-15 01:20:18.000000', 'temperatura', 713.0000, 'ºC'),
	(330123, 146, '2015-01-15 01:20:19.000000', 'temperatura', 398.0000, 'ºC'),
	(330124, 146, '2015-01-15 01:20:20.000000', 'temperatura', 1051.0000, 'ºC'),
	(330125, 146, '2015-01-15 01:20:21.000000', 'temperatura', 463.0000, 'ºC'),
	(330126, 146, '2015-01-15 01:20:22.000000', 'temperatura', 361.0000, 'ºC'),
	(330127, 146, '2015-01-15 01:20:23.000000', 'temperatura', 415.0000, 'ºC'),
	(330128, 146, '2015-01-15 01:20:24.000000', 'temperatura', 995.0000, 'ºC'),
	(330129, 146, '2015-01-15 01:20:25.000000', 'temperatura', 128.0000, 'ºC'),
	(330130, 146, '2015-01-15 01:20:26.000000', 'temperatura', 57.0000, 'ºC'),
	(330131, 146, '2015-01-15 01:20:27.000000', 'temperatura', 1102.0000, 'ºC'),
	(330132, 146, '2015-01-15 01:20:28.000000', 'temperatura', 540.0000, 'ºC'),
	(330133, 146, '2015-01-15 01:20:29.000000', 'temperatura', 594.0000, 'ºC'),
	(330134, 146, '2015-01-15 01:20:30.000000', 'temperatura', 149.0000, 'ºC'),
	(330135, 146, '2015-01-15 01:20:31.000000', 'temperatura', 166.0000, 'ºC'),
	(330136, 146, '2015-01-15 01:20:32.000000', 'temperatura', 381.0000, 'ºC'),
	(330137, 146, '2015-01-15 01:20:33.000000', 'temperatura', 209.0000, 'ºC'),
	(330138, 146, '2015-01-15 01:20:34.000000', 'temperatura', 1104.0000, 'ºC'),
	(330139, 146, '2015-01-15 01:20:35.000000', 'temperatura', 92.0000, 'ºC'),
	(330140, 146, '2015-01-15 01:20:36.000000', 'temperatura', 748.0000, 'ºC'),
	(330141, 146, '2015-01-15 01:20:37.000000', 'temperatura', 1066.0000, 'ºC'),
	(330142, 146, '2015-01-15 01:20:38.000000', 'temperatura', 686.0000, 'ºC'),
	(330143, 146, '2015-01-15 01:20:39.000000', 'temperatura', 231.0000, 'ºC'),
	(330144, 146, '2015-01-15 01:20:40.000000', 'temperatura', 300.0000, 'ºC'),
	(330145, 146, '2015-01-15 01:20:41.000000', 'temperatura', 807.0000, 'ºC'),
	(330146, 146, '2015-01-15 01:20:42.000000', 'temperatura', 735.0000, 'ºC'),
	(330147, 146, '2015-01-15 01:20:43.000000', 'temperatura', 55.0000, 'ºC'),
	(330148, 146, '2015-01-15 01:20:44.000000', 'temperatura', 471.0000, 'ºC'),
	(330149, 146, '2015-01-15 01:20:45.000000', 'temperatura', 989.0000, 'ºC'),
	(330150, 146, '2015-01-15 01:20:46.000000', 'temperatura', 1133.0000, 'ºC'),
	(330151, 146, '2015-01-15 01:20:47.000000', 'temperatura', 300.0000, 'ºC'),
	(330152, 146, '2015-01-15 01:20:48.000000', 'temperatura', 502.0000, 'ºC'),
	(330153, 146, '2015-01-15 01:20:49.000000', 'temperatura', 410.0000, 'ºC'),
	(330154, 146, '2015-01-15 01:20:50.000000', 'temperatura', 545.0000, 'ºC'),
	(330155, 146, '2015-01-15 01:20:51.000000', 'temperatura', 293.0000, 'ºC'),
	(330156, 146, '2015-01-15 01:20:52.000000', 'temperatura', 1034.0000, 'ºC'),
	(330157, 146, '2015-01-15 01:20:53.000000', 'temperatura', 690.0000, 'ºC'),
	(330158, 146, '2015-01-15 01:20:54.000000', 'temperatura', 347.0000, 'ºC'),
	(330159, 146, '2015-01-15 01:20:55.000000', 'temperatura', 866.0000, 'ºC'),
	(330160, 146, '2015-01-15 01:20:56.000000', 'temperatura', 889.0000, 'ºC'),
	(330161, 146, '2015-01-15 01:20:57.000000', 'temperatura', 647.0000, 'ºC'),
	(330162, 146, '2015-01-15 01:20:58.000000', 'temperatura', 570.0000, 'ºC'),
	(330163, 146, '2015-01-15 01:20:59.000000', 'temperatura', 910.0000, 'ºC'),
	(330164, 146, '2015-01-15 01:21:00.000000', 'temperatura', 442.0000, 'ºC'),
	(330165, 146, '2015-01-15 01:21:01.000000', 'temperatura', 677.0000, 'ºC'),
	(330166, 146, '2015-01-15 01:21:02.000000', 'temperatura', 861.0000, 'ºC'),
	(330167, 146, '2015-01-15 01:21:03.000000', 'temperatura', 1074.0000, 'ºC'),
	(330168, 146, '2015-01-15 01:21:04.000000', 'temperatura', 387.0000, 'ºC'),
	(330169, 146, '2015-01-15 01:21:05.000000', 'temperatura', 1114.0000, 'ºC'),
	(330170, 146, '2015-01-15 01:21:06.000000', 'temperatura', 810.0000, 'ºC'),
	(330171, 146, '2015-01-15 01:21:07.000000', 'temperatura', 709.0000, 'ºC'),
	(330172, 146, '2015-01-15 01:21:08.000000', 'temperatura', 1113.0000, 'ºC'),
	(330173, 146, '2015-01-15 01:21:09.000000', 'temperatura', 1040.0000, 'ºC'),
	(330174, 146, '2015-01-15 01:21:10.000000', 'temperatura', 660.0000, 'ºC'),
	(330175, 146, '2015-01-15 01:21:11.000000', 'temperatura', 181.0000, 'ºC'),
	(330176, 146, '2015-01-15 01:21:12.000000', 'temperatura', 127.0000, 'ºC'),
	(330177, 146, '2015-01-15 01:21:13.000000', 'temperatura', 93.0000, 'ºC'),
	(330178, 146, '2015-01-15 01:21:14.000000', 'temperatura', 85.0000, 'ºC'),
	(330179, 146, '2015-01-15 01:21:15.000000', 'temperatura', 147.0000, 'ºC'),
	(330180, 146, '2015-01-15 01:21:16.000000', 'temperatura', 477.0000, 'ºC'),
	(330181, 146, '2015-01-15 01:21:17.000000', 'temperatura', 748.0000, 'ºC'),
	(330182, 146, '2015-01-15 01:21:18.000000', 'temperatura', 1110.0000, 'ºC'),
	(330183, 146, '2015-01-15 01:21:19.000000', 'temperatura', 904.0000, 'ºC'),
	(330184, 146, '2015-01-15 01:21:20.000000', 'temperatura', 1191.0000, 'ºC'),
	(330185, 146, '2015-01-15 01:21:21.000000', 'temperatura', 843.0000, 'ºC'),
	(330186, 146, '2015-01-15 01:21:22.000000', 'temperatura', 643.0000, 'ºC'),
	(330187, 146, '2015-01-15 01:21:23.000000', 'temperatura', 687.0000, 'ºC'),
	(330188, 146, '2015-01-15 01:21:24.000000', 'temperatura', 305.0000, 'ºC'),
	(330189, 146, '2015-01-15 01:21:25.000000', 'temperatura', 667.0000, 'ºC'),
	(330190, 146, '2015-01-15 01:21:26.000000', 'temperatura', 20.0000, 'ºC'),
	(330191, 146, '2015-01-15 01:21:27.000000', 'temperatura', 500.0000, 'ºC'),
	(330192, 146, '2015-01-15 01:21:28.000000', 'temperatura', 42.0000, 'ºC'),
	(330193, 146, '2015-01-15 01:21:29.000000', 'temperatura', 1108.0000, 'ºC'),
	(330194, 146, '2015-01-15 01:21:30.000000', 'temperatura', 617.0000, 'ºC'),
	(330195, 146, '2015-01-15 01:21:31.000000', 'temperatura', 962.0000, 'ºC'),
	(330196, 146, '2015-01-15 01:21:32.000000', 'temperatura', 556.0000, 'ºC'),
	(330197, 146, '2015-01-15 01:21:33.000000', 'temperatura', 1098.0000, 'ºC'),
	(330198, 146, '2015-01-15 01:21:34.000000', 'temperatura', 220.0000, 'ºC'),
	(330199, 146, '2015-01-15 01:21:35.000000', 'temperatura', 206.0000, 'ºC'),
	(330200, 146, '2015-01-15 01:21:36.000000', 'temperatura', 372.0000, 'ºC'),
	(330201, 146, '2015-01-15 01:21:37.000000', 'temperatura', 42.0000, 'ºC'),
	(330202, 146, '2015-01-15 01:21:38.000000', 'temperatura', 294.0000, 'ºC'),
	(330203, 146, '2015-01-15 01:21:39.000000', 'temperatura', 145.0000, 'ºC'),
	(330204, 146, '2015-01-15 01:21:40.000000', 'temperatura', 1043.0000, 'ºC'),
	(330205, 146, '2015-01-15 01:21:41.000000', 'temperatura', 1180.0000, 'ºC'),
	(330206, 146, '2015-01-15 01:21:42.000000', 'temperatura', 371.0000, 'ºC'),
	(330207, 146, '2015-01-15 01:21:43.000000', 'temperatura', 715.0000, 'ºC'),
	(330208, 146, '2015-01-15 01:21:44.000000', 'temperatura', 65.0000, 'ºC'),
	(330209, 146, '2015-01-15 01:21:45.000000', 'temperatura', 581.0000, 'ºC'),
	(330210, 146, '2015-01-15 01:21:46.000000', 'temperatura', 309.0000, 'ºC'),
	(330211, 146, '2015-01-15 01:21:47.000000', 'temperatura', 1004.0000, 'ºC'),
	(330212, 146, '2015-01-15 01:21:48.000000', 'temperatura', 494.0000, 'ºC'),
	(330213, 146, '2015-01-15 01:21:49.000000', 'temperatura', 658.0000, 'ºC'),
	(330214, 146, '2015-01-15 01:21:50.000000', 'temperatura', 609.0000, 'ºC'),
	(330215, 146, '2015-01-15 01:21:51.000000', 'temperatura', 1071.0000, 'ºC'),
	(330216, 146, '2015-01-15 01:21:52.000000', 'temperatura', 1130.0000, 'ºC'),
	(330217, 146, '2015-01-15 01:21:53.000000', 'temperatura', 34.0000, 'ºC'),
	(330218, 146, '2015-01-15 01:21:54.000000', 'temperatura', 384.0000, 'ºC'),
	(330219, 146, '2015-01-15 01:21:55.000000', 'temperatura', 616.0000, 'ºC'),
	(330220, 146, '2015-01-15 01:21:56.000000', 'temperatura', 731.0000, 'ºC'),
	(330221, 146, '2015-01-15 01:21:57.000000', 'temperatura', 605.0000, 'ºC'),
	(330222, 146, '2015-01-15 01:21:58.000000', 'temperatura', 835.0000, 'ºC'),
	(330223, 146, '2015-01-15 01:21:59.000000', 'temperatura', 1161.0000, 'ºC'),
	(330224, 146, '2015-01-15 01:22:00.000000', 'temperatura', 900.0000, 'ºC'),
	(330225, 146, '2015-01-15 01:22:01.000000', 'temperatura', 1017.0000, 'ºC'),
	(330226, 146, '2015-01-15 01:22:02.000000', 'temperatura', 1186.0000, 'ºC'),
	(330227, 146, '2015-01-15 01:22:03.000000', 'temperatura', 481.0000, 'ºC'),
	(330228, 146, '2015-01-15 01:22:04.000000', 'temperatura', 48.0000, 'ºC'),
	(330229, 146, '2015-01-15 01:22:05.000000', 'temperatura', 1194.0000, 'ºC'),
	(330230, 146, '2015-01-15 01:22:06.000000', 'temperatura', 1030.0000, 'ºC'),
	(330231, 146, '2015-01-15 01:22:07.000000', 'temperatura', 367.0000, 'ºC'),
	(330232, 146, '2015-01-15 01:22:08.000000', 'temperatura', 1146.0000, 'ºC'),
	(330233, 146, '2015-01-15 01:22:09.000000', 'temperatura', 1029.0000, 'ºC'),
	(330234, 146, '2015-01-15 01:22:10.000000', 'temperatura', 507.0000, 'ºC'),
	(330235, 146, '2015-01-15 01:22:11.000000', 'temperatura', 651.0000, 'ºC'),
	(330236, 146, '2015-01-15 01:22:12.000000', 'temperatura', 531.0000, 'ºC'),
	(330237, 146, '2015-01-15 01:22:13.000000', 'temperatura', 705.0000, 'ºC'),
	(330238, 146, '2015-01-15 01:22:14.000000', 'temperatura', 733.0000, 'ºC'),
	(330239, 146, '2015-01-15 01:22:15.000000', 'temperatura', 349.0000, 'ºC'),
	(330240, 146, '2015-01-15 01:22:16.000000', 'temperatura', 748.0000, 'ºC'),
	(330241, 146, '2015-01-15 01:22:17.000000', 'temperatura', 291.0000, 'ºC'),
	(330242, 146, '2015-01-15 01:22:18.000000', 'temperatura', 412.0000, 'ºC'),
	(330243, 146, '2015-01-15 01:22:19.000000', 'temperatura', 1188.0000, 'ºC'),
	(330244, 146, '2015-01-15 01:22:20.000000', 'temperatura', 1105.0000, 'ºC'),
	(330245, 146, '2015-01-15 01:22:21.000000', 'temperatura', 763.0000, 'ºC'),
	(330246, 146, '2015-01-15 01:22:22.000000', 'temperatura', 500.0000, 'ºC'),
	(330247, 146, '2015-01-15 01:22:23.000000', 'temperatura', 213.0000, 'ºC'),
	(330248, 146, '2015-01-15 01:22:24.000000', 'temperatura', 763.0000, 'ºC'),
	(330249, 146, '2015-01-15 01:22:25.000000', 'temperatura', 779.0000, 'ºC'),
	(330250, 146, '2015-01-15 01:22:26.000000', 'temperatura', 405.0000, 'ºC'),
	(330251, 146, '2015-01-15 01:22:27.000000', 'temperatura', 891.0000, 'ºC'),
	(330252, 146, '2015-01-15 01:22:28.000000', 'temperatura', 837.0000, 'ºC'),
	(330253, 146, '2015-01-15 01:22:29.000000', 'temperatura', 315.0000, 'ºC'),
	(330254, 146, '2015-01-15 01:22:30.000000', 'temperatura', 264.0000, 'ºC'),
	(330255, 146, '2015-01-15 01:22:31.000000', 'temperatura', 375.0000, 'ºC'),
	(330256, 146, '2015-01-15 01:22:32.000000', 'temperatura', 1084.0000, 'ºC'),
	(330257, 146, '2015-01-15 01:22:33.000000', 'temperatura', 696.0000, 'ºC'),
	(330258, 146, '2015-01-15 01:22:34.000000', 'temperatura', 230.0000, 'ºC'),
	(330259, 146, '2015-01-15 01:22:35.000000', 'temperatura', 261.0000, 'ºC'),
	(330260, 146, '2015-01-15 01:22:36.000000', 'temperatura', 617.0000, 'ºC'),
	(330261, 146, '2015-01-15 01:22:37.000000', 'temperatura', 1100.0000, 'ºC'),
	(330262, 146, '2015-01-15 01:22:38.000000', 'temperatura', 51.0000, 'ºC'),
	(330263, 146, '2015-01-15 01:22:39.000000', 'temperatura', 557.0000, 'ºC'),
	(330264, 146, '2015-01-15 01:22:40.000000', 'temperatura', 232.0000, 'ºC'),
	(330265, 146, '2015-01-15 01:22:41.000000', 'temperatura', 691.0000, 'ºC'),
	(330266, 146, '2015-01-15 01:22:42.000000', 'temperatura', 357.0000, 'ºC'),
	(330267, 146, '2015-01-15 01:22:43.000000', 'temperatura', 912.0000, 'ºC'),
	(330268, 146, '2015-01-15 01:22:44.000000', 'temperatura', 1089.0000, 'ºC'),
	(330269, 146, '2015-01-15 01:22:45.000000', 'temperatura', 309.0000, 'ºC'),
	(330270, 146, '2015-01-15 01:22:46.000000', 'temperatura', 680.0000, 'ºC'),
	(330271, 146, '2015-01-15 01:22:47.000000', 'temperatura', 74.0000, 'ºC'),
	(330272, 146, '2015-01-15 01:22:48.000000', 'temperatura', 732.0000, 'ºC'),
	(330273, 146, '2015-01-15 01:22:49.000000', 'temperatura', 1035.0000, 'ºC'),
	(330274, 146, '2015-01-15 01:22:50.000000', 'temperatura', 581.0000, 'ºC'),
	(330275, 146, '2015-01-15 01:22:51.000000', 'temperatura', 1000.0000, 'ºC'),
	(330276, 146, '2015-01-15 01:22:52.000000', 'temperatura', 860.0000, 'ºC'),
	(330277, 146, '2015-01-15 01:22:53.000000', 'temperatura', 97.0000, 'ºC'),
	(330278, 146, '2015-01-15 01:22:54.000000', 'temperatura', 308.0000, 'ºC'),
	(330279, 146, '2015-01-15 01:22:55.000000', 'temperatura', 47.0000, 'ºC'),
	(330280, 146, '2015-01-15 01:22:56.000000', 'temperatura', 511.0000, 'ºC'),
	(330281, 146, '2015-01-15 01:22:57.000000', 'temperatura', 15.0000, 'ºC'),
	(330282, 146, '2015-01-15 01:22:58.000000', 'temperatura', 944.0000, 'ºC'),
	(330283, 146, '2015-01-15 01:22:59.000000', 'temperatura', 1075.0000, 'ºC'),
	(330284, 146, '2015-01-15 01:23:00.000000', 'temperatura', 142.0000, 'ºC'),
	(330285, 146, '2015-01-15 01:23:01.000000', 'temperatura', 1085.0000, 'ºC'),
	(330286, 146, '2015-01-15 01:23:02.000000', 'temperatura', 201.0000, 'ºC'),
	(330287, 146, '2015-01-15 01:23:03.000000', 'temperatura', 149.0000, 'ºC'),
	(330288, 146, '2015-01-15 01:23:04.000000', 'temperatura', 145.0000, 'ºC'),
	(330289, 146, '2015-01-15 01:23:05.000000', 'temperatura', 279.0000, 'ºC'),
	(330290, 146, '2015-01-15 01:23:06.000000', 'temperatura', 960.0000, 'ºC'),
	(330291, 146, '2015-01-15 01:23:07.000000', 'temperatura', 364.0000, 'ºC'),
	(330292, 146, '2015-01-15 01:23:08.000000', 'temperatura', 140.0000, 'ºC'),
	(330293, 146, '2015-01-15 01:23:09.000000', 'temperatura', 808.0000, 'ºC'),
	(330294, 146, '2015-01-15 01:23:10.000000', 'temperatura', 19.0000, 'ºC'),
	(330295, 146, '2015-01-15 01:23:11.000000', 'temperatura', 71.0000, 'ºC'),
	(330296, 146, '2015-01-15 01:23:12.000000', 'temperatura', 301.0000, 'ºC'),
	(330297, 146, '2015-01-15 01:23:13.000000', 'temperatura', 91.0000, 'ºC'),
	(330298, 146, '2015-01-15 01:23:14.000000', 'temperatura', 754.0000, 'ºC'),
	(330299, 146, '2015-01-15 01:23:15.000000', 'temperatura', 1097.0000, 'ºC'),
	(330300, 146, '2015-01-15 01:23:16.000000', 'temperatura', 822.0000, 'ºC'),
	(330301, 146, '2015-01-15 01:23:17.000000', 'temperatura', 822.0000, 'ºC'),
	(330302, 146, '2015-01-15 01:23:18.000000', 'temperatura', 442.0000, 'ºC'),
	(330303, 146, '2015-01-15 01:23:19.000000', 'temperatura', 944.0000, 'ºC'),
	(330304, 146, '2015-01-15 01:23:20.000000', 'temperatura', 996.0000, 'ºC'),
	(330305, 146, '2015-01-15 01:23:21.000000', 'temperatura', 948.0000, 'ºC'),
	(330306, 146, '2015-01-15 01:23:22.000000', 'temperatura', 554.0000, 'ºC'),
	(330307, 146, '2015-01-15 01:23:23.000000', 'temperatura', 1127.0000, 'ºC'),
	(330308, 146, '2015-01-15 01:23:24.000000', 'temperatura', 373.0000, 'ºC'),
	(330309, 146, '2015-01-15 01:23:25.000000', 'temperatura', 886.0000, 'ºC'),
	(330310, 146, '2015-01-15 01:23:26.000000', 'temperatura', 911.0000, 'ºC'),
	(330311, 146, '2015-01-15 01:23:27.000000', 'temperatura', 695.0000, 'ºC'),
	(330312, 146, '2015-01-15 01:23:28.000000', 'temperatura', 744.0000, 'ºC'),
	(330313, 146, '2015-01-15 01:23:29.000000', 'temperatura', 437.0000, 'ºC'),
	(330314, 146, '2015-01-15 01:23:30.000000', 'temperatura', 1154.0000, 'ºC'),
	(330315, 146, '2015-01-15 01:23:31.000000', 'temperatura', 857.0000, 'ºC'),
	(330316, 146, '2015-01-15 01:23:32.000000', 'temperatura', 824.0000, 'ºC'),
	(330317, 146, '2015-01-15 01:23:33.000000', 'temperatura', 350.0000, 'ºC'),
	(330318, 146, '2015-01-15 01:23:34.000000', 'temperatura', 478.0000, 'ºC'),
	(330319, 146, '2015-01-15 01:23:35.000000', 'temperatura', 143.0000, 'ºC'),
	(330320, 146, '2015-01-15 01:23:36.000000', 'temperatura', 478.0000, 'ºC'),
	(330321, 146, '2015-01-15 01:23:37.000000', 'temperatura', 762.0000, 'ºC'),
	(330322, 146, '2015-01-15 01:23:38.000000', 'temperatura', 1178.0000, 'ºC'),
	(330323, 146, '2015-01-15 01:23:39.000000', 'temperatura', 5.0000, 'ºC'),
	(330324, 146, '2015-01-15 01:23:40.000000', 'temperatura', 90.0000, 'ºC'),
	(330325, 146, '2015-01-15 01:23:41.000000', 'temperatura', 436.0000, 'ºC'),
	(330326, 146, '2015-01-15 01:23:42.000000', 'temperatura', 709.0000, 'ºC'),
	(330327, 146, '2015-01-15 01:23:43.000000', 'temperatura', 1038.0000, 'ºC'),
	(330328, 146, '2015-01-15 01:23:44.000000', 'temperatura', 662.0000, 'ºC'),
	(330329, 146, '2015-01-15 01:23:45.000000', 'temperatura', 200.0000, 'ºC'),
	(330330, 146, '2015-01-15 01:23:46.000000', 'temperatura', 212.0000, 'ºC'),
	(330331, 146, '2015-01-15 01:23:47.000000', 'temperatura', 459.0000, 'ºC'),
	(330332, 146, '2015-01-15 01:23:48.000000', 'temperatura', 461.0000, 'ºC'),
	(330333, 146, '2015-01-15 01:23:49.000000', 'temperatura', 930.0000, 'ºC'),
	(330334, 146, '2015-01-15 01:23:50.000000', 'temperatura', 868.0000, 'ºC'),
	(330335, 146, '2015-01-15 01:23:51.000000', 'temperatura', 351.0000, 'ºC'),
	(330336, 146, '2015-01-15 01:23:52.000000', 'temperatura', 351.0000, 'ºC'),
	(330337, 146, '2015-01-15 01:23:53.000000', 'temperatura', 702.0000, 'ºC'),
	(330338, 146, '2015-01-15 01:23:54.000000', 'temperatura', 57.0000, 'ºC'),
	(330339, 146, '2015-01-15 01:23:55.000000', 'temperatura', 579.0000, 'ºC'),
	(330340, 146, '2015-01-15 01:23:56.000000', 'temperatura', 326.0000, 'ºC'),
	(330341, 146, '2015-01-15 01:23:57.000000', 'temperatura', 1095.0000, 'ºC'),
	(330342, 146, '2015-01-15 01:23:58.000000', 'temperatura', 894.0000, 'ºC'),
	(330343, 146, '2015-01-15 01:23:59.000000', 'temperatura', 1188.0000, 'ºC'),
	(330344, 146, '2015-01-15 01:24:00.000000', 'temperatura', 857.0000, 'ºC'),
	(330345, 146, '2015-01-15 01:24:01.000000', 'temperatura', 723.0000, 'ºC'),
	(330346, 146, '2015-01-15 01:24:02.000000', 'temperatura', 1044.0000, 'ºC'),
	(330347, 146, '2015-01-15 01:24:03.000000', 'temperatura', 649.0000, 'ºC'),
	(330348, 146, '2015-01-15 01:24:04.000000', 'temperatura', 117.0000, 'ºC'),
	(330349, 146, '2015-01-15 01:24:05.000000', 'temperatura', 1036.0000, 'ºC'),
	(330350, 146, '2015-01-15 01:24:06.000000', 'temperatura', 30.0000, 'ºC'),
	(330351, 146, '2015-01-15 01:24:07.000000', 'temperatura', 641.0000, 'ºC'),
	(330352, 146, '2015-01-15 01:24:08.000000', 'temperatura', 718.0000, 'ºC'),
	(330353, 146, '2015-01-15 01:24:09.000000', 'temperatura', 466.0000, 'ºC'),
	(330354, 146, '2015-01-15 01:24:10.000000', 'temperatura', 177.0000, 'ºC'),
	(330355, 146, '2015-01-15 01:24:11.000000', 'temperatura', 688.0000, 'ºC'),
	(330356, 146, '2015-01-15 01:24:12.000000', 'temperatura', 510.0000, 'ºC'),
	(330357, 146, '2015-01-15 01:24:13.000000', 'temperatura', 487.0000, 'ºC'),
	(330358, 146, '2015-01-15 01:24:14.000000', 'temperatura', 904.0000, 'ºC'),
	(330359, 146, '2015-01-15 01:24:15.000000', 'temperatura', 660.0000, 'ºC'),
	(330360, 146, '2015-01-15 01:24:16.000000', 'temperatura', 590.0000, 'ºC'),
	(330361, 146, '2015-01-15 01:24:17.000000', 'temperatura', 971.0000, 'ºC'),
	(330362, 146, '2015-01-15 01:24:18.000000', 'temperatura', 685.0000, 'ºC'),
	(330363, 146, '2015-01-15 01:24:19.000000', 'temperatura', 512.0000, 'ºC'),
	(330364, 146, '2015-01-15 01:24:20.000000', 'temperatura', 503.0000, 'ºC'),
	(330365, 146, '2015-01-15 01:24:21.000000', 'temperatura', 983.0000, 'ºC'),
	(330366, 146, '2015-01-15 01:24:22.000000', 'temperatura', 1006.0000, 'ºC'),
	(330367, 146, '2015-01-15 01:24:23.000000', 'temperatura', 883.0000, 'ºC'),
	(330368, 146, '2015-01-15 01:24:24.000000', 'temperatura', 195.0000, 'ºC'),
	(330369, 146, '2015-01-15 01:24:25.000000', 'temperatura', 728.0000, 'ºC'),
	(330370, 146, '2015-01-15 01:24:26.000000', 'temperatura', 653.0000, 'ºC'),
	(330371, 146, '2015-01-15 01:24:27.000000', 'temperatura', 1083.0000, 'ºC'),
	(330372, 146, '2015-01-15 01:24:28.000000', 'temperatura', 1058.0000, 'ºC'),
	(330373, 146, '2015-01-15 01:24:29.000000', 'temperatura', 841.0000, 'ºC'),
	(330374, 146, '2015-01-15 01:24:30.000000', 'temperatura', 1030.0000, 'ºC'),
	(330375, 146, '2015-01-15 01:24:31.000000', 'temperatura', 226.0000, 'ºC'),
	(330376, 146, '2015-01-15 01:24:32.000000', 'temperatura', 444.0000, 'ºC'),
	(330377, 146, '2015-01-15 01:24:33.000000', 'temperatura', 339.0000, 'ºC'),
	(330378, 146, '2015-01-15 01:24:34.000000', 'temperatura', 366.0000, 'ºC'),
	(330379, 146, '2015-01-15 01:24:35.000000', 'temperatura', 812.0000, 'ºC'),
	(330380, 146, '2015-01-15 01:24:36.000000', 'temperatura', 563.0000, 'ºC'),
	(330381, 146, '2015-01-15 01:24:37.000000', 'temperatura', 380.0000, 'ºC'),
	(330382, 146, '2015-01-15 01:24:38.000000', 'temperatura', 210.0000, 'ºC'),
	(330383, 146, '2015-01-15 01:24:39.000000', 'temperatura', 1112.0000, 'ºC'),
	(330384, 146, '2015-01-15 01:24:40.000000', 'temperatura', 129.0000, 'ºC'),
	(330385, 146, '2015-01-15 01:24:41.000000', 'temperatura', 910.0000, 'ºC'),
	(330386, 146, '2015-01-15 01:24:42.000000', 'temperatura', 566.0000, 'ºC'),
	(330387, 146, '2015-01-15 01:24:43.000000', 'temperatura', 98.0000, 'ºC'),
	(330388, 146, '2015-01-15 01:24:44.000000', 'temperatura', 1191.0000, 'ºC'),
	(330389, 146, '2015-01-15 01:24:45.000000', 'temperatura', 865.0000, 'ºC'),
	(330390, 146, '2015-01-15 01:24:46.000000', 'temperatura', 750.0000, 'ºC'),
	(330391, 146, '2015-01-15 01:24:47.000000', 'temperatura', 1156.0000, 'ºC'),
	(330392, 146, '2015-01-15 01:24:48.000000', 'temperatura', 1132.0000, 'ºC'),
	(330393, 146, '2015-01-15 01:24:49.000000', 'temperatura', 993.0000, 'ºC'),
	(330394, 146, '2015-01-15 01:24:50.000000', 'temperatura', 367.0000, 'ºC'),
	(330395, 146, '2015-01-15 01:24:51.000000', 'temperatura', 56.0000, 'ºC'),
	(330396, 146, '2015-01-15 01:24:52.000000', 'temperatura', 382.0000, 'ºC'),
	(330397, 146, '2015-01-15 01:24:53.000000', 'temperatura', 542.0000, 'ºC'),
	(330398, 146, '2015-01-15 01:24:54.000000', 'temperatura', 366.0000, 'ºC'),
	(330399, 146, '2015-01-15 01:24:55.000000', 'temperatura', 201.0000, 'ºC'),
	(330400, 146, '2015-01-15 01:24:56.000000', 'temperatura', 1109.0000, 'ºC'),
	(330401, 146, '2015-01-15 01:24:57.000000', 'temperatura', 145.0000, 'ºC'),
	(330402, 146, '2015-01-15 01:24:58.000000', 'temperatura', 995.0000, 'ºC'),
	(330403, 146, '2015-01-15 01:24:59.000000', 'temperatura', 942.0000, 'ºC'),
	(330404, 146, '2015-01-15 01:25:00.000000', 'temperatura', 527.0000, 'ºC'),
	(330405, 146, '2015-01-15 01:25:01.000000', 'temperatura', 1009.0000, 'ºC'),
	(330406, 146, '2015-01-15 01:25:02.000000', 'temperatura', 1065.0000, 'ºC'),
	(330407, 146, '2015-01-15 01:25:03.000000', 'temperatura', 1097.0000, 'ºC'),
	(330408, 146, '2015-01-15 01:25:04.000000', 'temperatura', 1091.0000, 'ºC'),
	(330409, 146, '2015-01-15 01:25:05.000000', 'temperatura', 965.0000, 'ºC'),
	(330410, 146, '2015-01-15 01:25:06.000000', 'temperatura', 352.0000, 'ºC'),
	(330411, 146, '2015-01-15 01:25:07.000000', 'temperatura', 67.0000, 'ºC'),
	(330412, 146, '2015-01-15 01:25:08.000000', 'temperatura', 477.0000, 'ºC'),
	(330413, 146, '2015-01-15 01:25:09.000000', 'temperatura', 988.0000, 'ºC'),
	(330414, 146, '2015-01-15 01:25:10.000000', 'temperatura', 1106.0000, 'ºC'),
	(330415, 146, '2015-01-15 01:25:11.000000', 'temperatura', 170.0000, 'ºC'),
	(330416, 146, '2015-01-15 01:25:12.000000', 'temperatura', 1130.0000, 'ºC'),
	(330417, 146, '2015-01-15 01:25:13.000000', 'temperatura', 342.0000, 'ºC'),
	(330418, 146, '2015-01-15 01:25:14.000000', 'temperatura', 718.0000, 'ºC'),
	(330419, 146, '2015-01-15 01:25:15.000000', 'temperatura', 166.0000, 'ºC'),
	(330420, 146, '2015-01-15 01:25:16.000000', 'temperatura', 1076.0000, 'ºC'),
	(330421, 146, '2015-01-15 01:25:17.000000', 'temperatura', 81.0000, 'ºC'),
	(330422, 146, '2015-01-15 01:25:18.000000', 'temperatura', 778.0000, 'ºC'),
	(330423, 146, '2015-01-15 01:25:19.000000', 'temperatura', 49.0000, 'ºC'),
	(330424, 146, '2015-01-15 01:25:20.000000', 'temperatura', 312.0000, 'ºC'),
	(330425, 146, '2015-01-15 01:25:21.000000', 'temperatura', 211.0000, 'ºC'),
	(330426, 146, '2015-01-15 01:25:22.000000', 'temperatura', 120.0000, 'ºC'),
	(330427, 146, '2015-01-15 01:25:23.000000', 'temperatura', 1167.0000, 'ºC'),
	(330428, 146, '2015-01-15 01:25:24.000000', 'temperatura', 678.0000, 'ºC'),
	(330429, 146, '2015-01-15 01:25:25.000000', 'temperatura', 1090.0000, 'ºC'),
	(330430, 146, '2015-01-15 01:25:26.000000', 'temperatura', 1013.0000, 'ºC'),
	(330431, 146, '2015-01-15 01:25:27.000000', 'temperatura', 598.0000, 'ºC'),
	(330432, 146, '2015-01-15 01:25:28.000000', 'temperatura', 1153.0000, 'ºC'),
	(330433, 146, '2015-01-15 01:25:29.000000', 'temperatura', 369.0000, 'ºC'),
	(330434, 146, '2015-01-15 01:25:30.000000', 'temperatura', 788.0000, 'ºC'),
	(330435, 146, '2015-01-15 01:25:31.000000', 'temperatura', 432.0000, 'ºC'),
	(330436, 146, '2015-01-15 01:25:32.000000', 'temperatura', 997.0000, 'ºC'),
	(330437, 146, '2015-01-15 01:25:33.000000', 'temperatura', 92.0000, 'ºC'),
	(330438, 146, '2015-01-15 01:25:34.000000', 'temperatura', 1066.0000, 'ºC'),
	(330439, 146, '2015-01-15 01:25:35.000000', 'temperatura', 256.0000, 'ºC'),
	(330440, 146, '2015-01-15 01:25:36.000000', 'temperatura', 483.0000, 'ºC'),
	(330441, 146, '2015-01-15 01:25:37.000000', 'temperatura', 445.0000, 'ºC'),
	(330442, 146, '2015-01-15 01:25:38.000000', 'temperatura', 778.0000, 'ºC'),
	(330443, 146, '2015-01-15 01:25:39.000000', 'temperatura', 155.0000, 'ºC'),
	(330444, 146, '2015-01-15 01:25:40.000000', 'temperatura', 843.0000, 'ºC'),
	(330445, 146, '2015-01-15 01:25:41.000000', 'temperatura', 149.0000, 'ºC'),
	(330446, 146, '2015-01-15 01:25:42.000000', 'temperatura', 619.0000, 'ºC'),
	(330447, 146, '2015-01-15 01:25:43.000000', 'temperatura', 245.0000, 'ºC'),
	(330448, 146, '2015-01-15 01:25:44.000000', 'temperatura', 571.0000, 'ºC'),
	(330449, 146, '2015-01-15 01:25:45.000000', 'temperatura', 922.0000, 'ºC'),
	(330450, 146, '2015-01-15 01:25:46.000000', 'temperatura', 495.0000, 'ºC'),
	(330451, 146, '2015-01-15 01:25:47.000000', 'temperatura', 911.0000, 'ºC'),
	(330452, 146, '2015-01-15 01:25:48.000000', 'temperatura', 672.0000, 'ºC'),
	(330453, 146, '2015-01-15 01:25:49.000000', 'temperatura', 624.0000, 'ºC'),
	(330454, 146, '2015-01-15 01:25:50.000000', 'temperatura', 1106.0000, 'ºC'),
	(330455, 146, '2015-01-15 01:25:51.000000', 'temperatura', 60.0000, 'ºC'),
	(330456, 146, '2015-01-15 01:25:52.000000', 'temperatura', 583.0000, 'ºC'),
	(330457, 146, '2015-01-15 01:25:53.000000', 'temperatura', 334.0000, 'ºC'),
	(330458, 146, '2015-01-15 01:25:54.000000', 'temperatura', 1122.0000, 'ºC'),
	(330459, 146, '2015-01-15 01:25:55.000000', 'temperatura', 1010.0000, 'ºC'),
	(330460, 146, '2015-01-15 01:25:56.000000', 'temperatura', 484.0000, 'ºC'),
	(330461, 146, '2015-01-15 01:25:57.000000', 'temperatura', 588.0000, 'ºC'),
	(330462, 146, '2015-01-15 01:25:58.000000', 'temperatura', 290.0000, 'ºC'),
	(330463, 146, '2015-01-15 01:25:59.000000', 'temperatura', 886.0000, 'ºC'),
	(330464, 146, '2015-01-15 01:26:00.000000', 'temperatura', 1160.0000, 'ºC'),
	(330465, 146, '2015-01-15 01:26:01.000000', 'temperatura', 742.0000, 'ºC'),
	(330466, 146, '2015-01-15 01:26:02.000000', 'temperatura', 230.0000, 'ºC'),
	(330467, 146, '2015-01-15 01:26:03.000000', 'temperatura', 124.0000, 'ºC'),
	(330468, 146, '2015-01-15 01:26:04.000000', 'temperatura', 1133.0000, 'ºC'),
	(330469, 146, '2015-01-15 01:26:05.000000', 'temperatura', 494.0000, 'ºC'),
	(330470, 146, '2015-01-15 01:26:06.000000', 'temperatura', 268.0000, 'ºC'),
	(330471, 146, '2015-01-15 01:26:07.000000', 'temperatura', 1062.0000, 'ºC'),
	(330472, 146, '2015-01-15 01:26:08.000000', 'temperatura', 904.0000, 'ºC'),
	(330473, 146, '2015-01-15 01:26:09.000000', 'temperatura', 134.0000, 'ºC'),
	(330474, 146, '2015-01-15 01:26:10.000000', 'temperatura', 358.0000, 'ºC'),
	(330475, 146, '2015-01-15 01:26:11.000000', 'temperatura', 188.0000, 'ºC'),
	(330476, 146, '2015-01-15 01:26:12.000000', 'temperatura', 1067.0000, 'ºC'),
	(330477, 146, '2015-01-15 01:26:13.000000', 'temperatura', 1171.0000, 'ºC'),
	(330478, 146, '2015-01-15 01:26:14.000000', 'temperatura', 255.0000, 'ºC'),
	(330479, 146, '2015-01-15 01:26:15.000000', 'temperatura', 165.0000, 'ºC'),
	(330480, 146, '2015-01-15 01:26:16.000000', 'temperatura', 58.0000, 'ºC'),
	(330481, 146, '2015-01-15 01:26:17.000000', 'temperatura', 994.0000, 'ºC'),
	(330482, 146, '2015-01-15 01:26:18.000000', 'temperatura', 1198.0000, 'ºC'),
	(330483, 146, '2015-01-15 01:26:19.000000', 'temperatura', 610.0000, 'ºC'),
	(330484, 146, '2015-01-15 01:26:20.000000', 'temperatura', 655.0000, 'ºC'),
	(330485, 146, '2015-01-15 01:26:21.000000', 'temperatura', 247.0000, 'ºC'),
	(330486, 146, '2015-01-15 01:26:22.000000', 'temperatura', 469.0000, 'ºC'),
	(330487, 146, '2015-01-15 01:26:23.000000', 'temperatura', 406.0000, 'ºC'),
	(330488, 146, '2015-01-15 01:26:24.000000', 'temperatura', 624.0000, 'ºC'),
	(330489, 146, '2015-01-15 01:26:25.000000', 'temperatura', 700.0000, 'ºC'),
	(330490, 146, '2015-01-15 01:26:26.000000', 'temperatura', 430.0000, 'ºC'),
	(330491, 146, '2015-01-15 01:26:27.000000', 'temperatura', 48.0000, 'ºC'),
	(330492, 146, '2015-01-15 01:26:28.000000', 'temperatura', 154.0000, 'ºC'),
	(330493, 146, '2015-01-15 01:26:29.000000', 'temperatura', 624.0000, 'ºC'),
	(330494, 146, '2015-01-15 01:26:30.000000', 'temperatura', 259.0000, 'ºC'),
	(330495, 146, '2015-01-15 01:26:31.000000', 'temperatura', 625.0000, 'ºC'),
	(330496, 146, '2015-01-15 01:26:32.000000', 'temperatura', 1146.0000, 'ºC'),
	(330497, 146, '2015-01-15 01:26:33.000000', 'temperatura', 257.0000, 'ºC'),
	(330498, 146, '2015-01-15 01:26:34.000000', 'temperatura', 246.0000, 'ºC'),
	(330499, 146, '2015-01-15 01:26:35.000000', 'temperatura', 458.0000, 'ºC'),
	(330500, 146, '2015-01-15 01:26:36.000000', 'temperatura', 356.0000, 'ºC'),
	(330501, 146, '2015-01-15 01:26:37.000000', 'temperatura', 405.0000, 'ºC'),
	(330502, 146, '2015-01-15 01:26:38.000000', 'temperatura', 959.0000, 'ºC'),
	(330503, 146, '2015-01-15 01:26:39.000000', 'temperatura', 1179.0000, 'ºC'),
	(330504, 146, '2015-01-15 01:26:40.000000', 'temperatura', 620.0000, 'ºC'),
	(330505, 146, '2015-01-15 01:26:41.000000', 'temperatura', 764.0000, 'ºC'),
	(330506, 146, '2015-01-15 01:26:42.000000', 'temperatura', 761.0000, 'ºC'),
	(330507, 146, '2015-01-15 01:26:43.000000', 'temperatura', 314.0000, 'ºC'),
	(330508, 146, '2015-01-15 01:26:44.000000', 'temperatura', 486.0000, 'ºC'),
	(330509, 146, '2015-01-15 01:26:45.000000', 'temperatura', 291.0000, 'ºC'),
	(330510, 146, '2015-01-15 01:26:46.000000', 'temperatura', 1196.0000, 'ºC'),
	(330511, 146, '2015-01-15 01:26:47.000000', 'temperatura', 306.0000, 'ºC'),
	(330512, 146, '2015-01-15 01:26:48.000000', 'temperatura', 345.0000, 'ºC'),
	(330513, 146, '2015-01-15 01:26:49.000000', 'temperatura', 806.0000, 'ºC'),
	(330514, 146, '2015-01-15 01:26:50.000000', 'temperatura', 597.0000, 'ºC'),
	(330515, 146, '2015-01-15 01:26:51.000000', 'temperatura', 568.0000, 'ºC'),
	(330516, 146, '2015-01-15 01:26:52.000000', 'temperatura', 1048.0000, 'ºC'),
	(330517, 146, '2015-01-15 01:26:53.000000', 'temperatura', 1136.0000, 'ºC'),
	(330518, 146, '2015-01-15 01:26:54.000000', 'temperatura', 139.0000, 'ºC'),
	(330519, 146, '2015-01-15 01:26:55.000000', 'temperatura', 885.0000, 'ºC'),
	(330520, 146, '2015-01-15 01:26:56.000000', 'temperatura', 410.0000, 'ºC'),
	(330521, 146, '2015-01-15 01:26:57.000000', 'temperatura', 596.0000, 'ºC'),
	(330522, 146, '2015-01-15 01:26:58.000000', 'temperatura', 551.0000, 'ºC'),
	(330523, 146, '2015-01-15 01:26:59.000000', 'temperatura', 968.0000, 'ºC'),
	(330524, 146, '2015-01-15 01:27:00.000000', 'temperatura', 786.0000, 'ºC'),
	(330525, 146, '2015-01-15 01:27:01.000000', 'temperatura', 1025.0000, 'ºC'),
	(330526, 146, '2015-01-15 01:27:02.000000', 'temperatura', 369.0000, 'ºC'),
	(330527, 146, '2015-01-15 01:27:03.000000', 'temperatura', 1170.0000, 'ºC'),
	(330528, 146, '2015-01-15 01:27:04.000000', 'temperatura', 1143.0000, 'ºC'),
	(330529, 146, '2015-01-15 01:27:05.000000', 'temperatura', 1007.0000, 'ºC'),
	(330530, 146, '2015-01-15 01:27:06.000000', 'temperatura', 406.0000, 'ºC'),
	(330531, 146, '2015-01-15 01:27:07.000000', 'temperatura', 208.0000, 'ºC'),
	(330532, 146, '2015-01-15 01:27:08.000000', 'temperatura', 1024.0000, 'ºC'),
	(330533, 146, '2015-01-15 01:27:09.000000', 'temperatura', 896.0000, 'ºC'),
	(330534, 146, '2015-01-15 01:27:10.000000', 'temperatura', 208.0000, 'ºC'),
	(330535, 146, '2015-01-15 01:27:11.000000', 'temperatura', 754.0000, 'ºC'),
	(330536, 146, '2015-01-15 01:27:12.000000', 'temperatura', 745.0000, 'ºC'),
	(330537, 146, '2015-01-15 01:27:13.000000', 'temperatura', 263.0000, 'ºC'),
	(330538, 146, '2015-01-15 01:27:14.000000', 'temperatura', 282.0000, 'ºC'),
	(330539, 146, '2015-01-15 01:27:15.000000', 'temperatura', 619.0000, 'ºC'),
	(330540, 146, '2015-01-15 01:27:16.000000', 'temperatura', 1050.0000, 'ºC'),
	(330541, 146, '2015-01-15 01:27:17.000000', 'temperatura', 995.0000, 'ºC'),
	(330542, 146, '2015-01-15 01:27:18.000000', 'temperatura', 624.0000, 'ºC'),
	(330543, 146, '2015-01-15 01:27:19.000000', 'temperatura', 137.0000, 'ºC'),
	(330544, 146, '2015-01-15 01:27:20.000000', 'temperatura', 12.0000, 'ºC'),
	(330545, 146, '2015-01-15 01:27:21.000000', 'temperatura', 849.0000, 'ºC'),
	(330546, 146, '2015-01-15 01:27:22.000000', 'temperatura', 610.0000, 'ºC'),
	(330547, 146, '2015-01-15 01:27:23.000000', 'temperatura', 504.0000, 'ºC'),
	(330548, 146, '2015-01-15 01:27:24.000000', 'temperatura', 691.0000, 'ºC'),
	(330549, 146, '2015-01-15 01:27:25.000000', 'temperatura', 741.0000, 'ºC'),
	(330550, 146, '2015-01-15 01:27:26.000000', 'temperatura', 434.0000, 'ºC'),
	(330551, 146, '2015-01-15 01:27:27.000000', 'temperatura', 1149.0000, 'ºC'),
	(330552, 146, '2015-01-15 01:27:28.000000', 'temperatura', 844.0000, 'ºC'),
	(330553, 146, '2015-01-15 01:27:29.000000', 'temperatura', 770.0000, 'ºC'),
	(330554, 146, '2015-01-15 01:27:30.000000', 'temperatura', 121.0000, 'ºC'),
	(330555, 146, '2015-01-15 01:27:31.000000', 'temperatura', 697.0000, 'ºC'),
	(330556, 146, '2015-01-15 01:27:32.000000', 'temperatura', 721.0000, 'ºC'),
	(330557, 146, '2015-01-15 01:27:33.000000', 'temperatura', 315.0000, 'ºC'),
	(330558, 146, '2015-01-15 01:27:34.000000', 'temperatura', 611.0000, 'ºC'),
	(330559, 146, '2015-01-15 01:27:35.000000', 'temperatura', 911.0000, 'ºC'),
	(330560, 146, '2015-01-15 01:27:36.000000', 'temperatura', 324.0000, 'ºC'),
	(330561, 146, '2015-01-15 01:27:37.000000', 'temperatura', 87.0000, 'ºC'),
	(330562, 146, '2015-01-15 01:27:38.000000', 'temperatura', 662.0000, 'ºC'),
	(330563, 146, '2015-01-15 01:27:39.000000', 'temperatura', 651.0000, 'ºC'),
	(330564, 146, '2015-01-15 01:27:40.000000', 'temperatura', 70.0000, 'ºC'),
	(330565, 146, '2015-01-15 01:27:41.000000', 'temperatura', 797.0000, 'ºC'),
	(330566, 146, '2015-01-15 01:27:42.000000', 'temperatura', 177.0000, 'ºC'),
	(330567, 146, '2015-01-15 01:27:43.000000', 'temperatura', 891.0000, 'ºC'),
	(330568, 146, '2015-01-15 01:27:44.000000', 'temperatura', 328.0000, 'ºC'),
	(330569, 146, '2015-01-15 01:27:45.000000', 'temperatura', 166.0000, 'ºC'),
	(330570, 146, '2015-01-15 01:27:46.000000', 'temperatura', 1046.0000, 'ºC'),
	(330571, 146, '2015-01-15 01:27:47.000000', 'temperatura', 1134.0000, 'ºC'),
	(330572, 146, '2015-01-15 01:27:48.000000', 'temperatura', 130.0000, 'ºC'),
	(330573, 146, '2015-01-15 01:27:49.000000', 'temperatura', 849.0000, 'ºC'),
	(330574, 146, '2015-01-15 01:27:50.000000', 'temperatura', 258.0000, 'ºC'),
	(330575, 146, '2015-01-15 01:27:51.000000', 'temperatura', 1140.0000, 'ºC'),
	(330576, 146, '2015-01-15 01:27:52.000000', 'temperatura', 129.0000, 'ºC'),
	(330577, 146, '2015-01-15 01:27:53.000000', 'temperatura', 824.0000, 'ºC'),
	(330578, 146, '2015-01-15 01:27:54.000000', 'temperatura', 133.0000, 'ºC'),
	(330579, 146, '2015-01-15 01:27:55.000000', 'temperatura', 593.0000, 'ºC'),
	(330580, 142, '2015-02-01 00:00:00.000000', 'temperatura', 254.0000, 'ºC'),
	(330581, 142, '2015-02-01 00:00:01.000000', 'temperatura', 772.0000, 'ºC'),
	(330582, 142, '2015-02-01 00:00:02.000000', 'temperatura', 698.0000, 'ºC'),
	(330583, 142, '2015-02-01 00:00:03.000000', 'temperatura', 1174.0000, 'ºC'),
	(330584, 142, '2015-02-01 00:00:04.000000', 'temperatura', 177.0000, 'ºC'),
	(330585, 142, '2015-02-01 00:00:05.000000', 'temperatura', 965.0000, 'ºC'),
	(330586, 142, '2015-02-01 00:00:06.000000', 'temperatura', 693.0000, 'ºC'),
	(330587, 142, '2015-02-01 00:00:07.000000', 'temperatura', 570.0000, 'ºC'),
	(330588, 142, '2015-02-01 00:00:08.000000', 'temperatura', 773.0000, 'ºC'),
	(330589, 142, '2015-02-01 00:00:09.000000', 'temperatura', 957.0000, 'ºC'),
	(330590, 142, '2015-02-01 00:00:10.000000', 'temperatura', 65.0000, 'ºC'),
	(330591, 142, '2015-02-01 00:00:11.000000', 'temperatura', 1053.0000, 'ºC'),
	(330592, 142, '2015-02-01 00:00:12.000000', 'temperatura', 270.0000, 'ºC'),
	(330593, 142, '2015-02-01 00:00:13.000000', 'temperatura', 591.0000, 'ºC'),
	(330594, 142, '2015-02-01 00:00:14.000000', 'temperatura', 945.0000, 'ºC'),
	(330595, 142, '2015-02-01 00:00:15.000000', 'temperatura', 553.0000, 'ºC'),
	(330596, 142, '2015-02-01 00:00:16.000000', 'temperatura', 1131.0000, 'ºC'),
	(330597, 142, '2015-02-01 00:00:17.000000', 'temperatura', 397.0000, 'ºC'),
	(330598, 142, '2015-02-01 00:00:18.000000', 'temperatura', 993.0000, 'ºC'),
	(330599, 142, '2015-02-01 00:00:19.000000', 'temperatura', 173.0000, 'ºC'),
	(330600, 142, '2015-02-01 00:00:20.000000', 'temperatura', 286.0000, 'ºC'),
	(330601, 142, '2015-02-01 00:00:21.000000', 'temperatura', 912.0000, 'ºC'),
	(330602, 142, '2015-02-01 00:00:22.000000', 'temperatura', 103.0000, 'ºC'),
	(330603, 142, '2015-02-01 00:00:23.000000', 'temperatura', 180.0000, 'ºC'),
	(330604, 142, '2015-02-01 00:00:24.000000', 'temperatura', 590.0000, 'ºC'),
	(330605, 142, '2015-02-01 00:00:25.000000', 'temperatura', 12.0000, 'ºC'),
	(330606, 142, '2015-02-01 00:00:26.000000', 'temperatura', 691.0000, 'ºC'),
	(330607, 142, '2015-02-01 00:00:27.000000', 'temperatura', 1020.0000, 'ºC'),
	(330608, 142, '2015-02-01 00:00:28.000000', 'temperatura', 627.0000, 'ºC'),
	(330609, 142, '2015-02-01 00:00:29.000000', 'temperatura', 76.0000, 'ºC'),
	(330610, 142, '2015-02-01 00:00:30.000000', 'temperatura', 897.0000, 'ºC'),
	(330611, 142, '2015-02-01 00:00:31.000000', 'temperatura', 661.0000, 'ºC'),
	(330612, 142, '2015-02-01 00:00:32.000000', 'temperatura', 611.0000, 'ºC'),
	(330613, 142, '2015-02-01 00:00:33.000000', 'temperatura', 1074.0000, 'ºC'),
	(330614, 142, '2015-02-01 00:00:34.000000', 'temperatura', 1138.0000, 'ºC'),
	(330615, 142, '2015-02-01 00:00:35.000000', 'temperatura', 67.0000, 'ºC'),
	(330616, 142, '2015-02-01 00:00:36.000000', 'temperatura', 524.0000, 'ºC'),
	(330617, 142, '2015-02-01 00:00:37.000000', 'temperatura', 18.0000, 'ºC'),
	(330618, 142, '2015-02-01 00:00:38.000000', 'temperatura', 918.0000, 'ºC'),
	(330619, 142, '2015-02-01 00:00:39.000000', 'temperatura', 936.0000, 'ºC'),
	(330620, 142, '2015-02-01 00:00:40.000000', 'temperatura', 726.0000, 'ºC'),
	(330621, 142, '2015-02-01 00:00:41.000000', 'temperatura', 823.0000, 'ºC'),
	(330622, 142, '2015-02-01 00:00:42.000000', 'temperatura', 737.0000, 'ºC'),
	(330623, 142, '2015-02-01 00:00:43.000000', 'temperatura', 16.0000, 'ºC'),
	(330624, 142, '2015-02-01 00:00:44.000000', 'temperatura', 271.0000, 'ºC'),
	(330625, 142, '2015-02-01 00:00:45.000000', 'temperatura', 108.0000, 'ºC'),
	(330626, 142, '2015-02-01 00:00:46.000000', 'temperatura', 926.0000, 'ºC'),
	(330627, 142, '2015-02-01 00:00:47.000000', 'temperatura', 708.0000, 'ºC'),
	(330628, 142, '2015-02-01 00:00:48.000000', 'temperatura', 761.0000, 'ºC'),
	(330629, 142, '2015-02-01 00:00:49.000000', 'temperatura', 483.0000, 'ºC'),
	(330630, 142, '2015-02-01 00:00:50.000000', 'temperatura', 132.0000, 'ºC'),
	(330631, 142, '2015-02-01 00:00:51.000000', 'temperatura', 411.0000, 'ºC'),
	(330632, 142, '2015-02-01 00:00:52.000000', 'temperatura', 459.0000, 'ºC'),
	(330633, 142, '2015-02-01 00:00:53.000000', 'temperatura', 1063.0000, 'ºC'),
	(330634, 142, '2015-02-01 00:00:54.000000', 'temperatura', 340.0000, 'ºC'),
	(330635, 142, '2015-02-01 00:00:55.000000', 'temperatura', 912.0000, 'ºC'),
	(330636, 142, '2015-02-01 00:00:56.000000', 'temperatura', 1141.0000, 'ºC'),
	(330637, 142, '2015-02-01 00:00:57.000000', 'temperatura', 568.0000, 'ºC'),
	(330638, 142, '2015-02-01 00:00:58.000000', 'temperatura', 618.0000, 'ºC'),
	(330639, 142, '2015-02-01 00:00:59.000000', 'temperatura', 188.0000, 'ºC'),
	(330640, 142, '2015-02-01 00:01:00.000000', 'temperatura', 287.0000, 'ºC'),
	(330641, 142, '2015-02-01 00:01:01.000000', 'temperatura', 870.0000, 'ºC'),
	(330642, 142, '2015-02-01 00:01:02.000000', 'temperatura', 1090.0000, 'ºC'),
	(330643, 142, '2015-02-01 00:01:03.000000', 'temperatura', 441.0000, 'ºC'),
	(330644, 142, '2015-02-01 00:01:04.000000', 'temperatura', 136.0000, 'ºC'),
	(330645, 142, '2015-02-01 00:01:05.000000', 'temperatura', 555.0000, 'ºC'),
	(330646, 142, '2015-02-01 00:01:06.000000', 'temperatura', 1167.0000, 'ºC'),
	(330647, 142, '2015-02-01 00:01:07.000000', 'temperatura', 574.0000, 'ºC'),
	(330648, 142, '2015-02-01 00:01:08.000000', 'temperatura', 566.0000, 'ºC'),
	(330649, 142, '2015-02-01 00:01:09.000000', 'temperatura', 1110.0000, 'ºC'),
	(330650, 142, '2015-02-01 00:01:10.000000', 'temperatura', 250.0000, 'ºC'),
	(330651, 142, '2015-02-01 00:01:11.000000', 'temperatura', 323.0000, 'ºC'),
	(330652, 142, '2015-02-01 00:01:12.000000', 'temperatura', 866.0000, 'ºC'),
	(330653, 142, '2015-02-01 00:01:13.000000', 'temperatura', 960.0000, 'ºC'),
	(330654, 142, '2015-02-01 00:01:14.000000', 'temperatura', 1005.0000, 'ºC'),
	(330655, 142, '2015-02-01 00:01:15.000000', 'temperatura', 943.0000, 'ºC'),
	(330656, 142, '2015-02-01 00:01:16.000000', 'temperatura', 500.0000, 'ºC'),
	(330657, 142, '2015-02-01 00:01:17.000000', 'temperatura', 873.0000, 'ºC'),
	(330658, 142, '2015-02-01 00:01:18.000000', 'temperatura', 466.0000, 'ºC'),
	(330659, 142, '2015-02-01 00:01:19.000000', 'temperatura', 913.0000, 'ºC'),
	(330660, 142, '2015-02-01 00:01:20.000000', 'temperatura', 765.0000, 'ºC'),
	(330661, 142, '2015-02-01 00:01:21.000000', 'temperatura', 1089.0000, 'ºC'),
	(330662, 142, '2015-02-01 00:01:22.000000', 'temperatura', 749.0000, 'ºC'),
	(330663, 142, '2015-02-01 00:01:23.000000', 'temperatura', 479.0000, 'ºC'),
	(330664, 142, '2015-02-01 00:01:24.000000', 'temperatura', 147.0000, 'ºC'),
	(330665, 142, '2015-02-01 00:01:25.000000', 'temperatura', 501.0000, 'ºC'),
	(330666, 142, '2015-02-01 00:01:26.000000', 'temperatura', 862.0000, 'ºC'),
	(330667, 142, '2015-02-01 00:01:27.000000', 'temperatura', 407.0000, 'ºC'),
	(330668, 142, '2015-02-01 00:01:28.000000', 'temperatura', 652.0000, 'ºC'),
	(330669, 142, '2015-02-01 00:01:29.000000', 'temperatura', 837.0000, 'ºC'),
	(330670, 142, '2015-02-01 00:01:30.000000', 'temperatura', 1031.0000, 'ºC'),
	(330671, 142, '2015-02-01 00:01:31.000000', 'temperatura', 245.0000, 'ºC'),
	(330672, 142, '2015-02-01 00:01:32.000000', 'temperatura', 532.0000, 'ºC'),
	(330673, 142, '2015-02-01 00:01:33.000000', 'temperatura', 725.0000, 'ºC'),
	(330674, 142, '2015-02-01 00:01:34.000000', 'temperatura', 830.0000, 'ºC'),
	(330675, 142, '2015-02-01 00:01:35.000000', 'temperatura', 775.0000, 'ºC'),
	(330676, 142, '2015-02-01 00:01:36.000000', 'temperatura', 184.0000, 'ºC'),
	(330677, 142, '2015-02-01 00:01:37.000000', 'temperatura', 996.0000, 'ºC'),
	(330678, 142, '2015-02-01 00:01:38.000000', 'temperatura', 830.0000, 'ºC'),
	(330679, 142, '2015-02-01 00:01:39.000000', 'temperatura', 1161.0000, 'ºC'),
	(330680, 142, '2015-02-01 00:01:40.000000', 'temperatura', 916.0000, 'ºC'),
	(330681, 142, '2015-02-01 00:01:41.000000', 'temperatura', 1098.0000, 'ºC'),
	(330682, 142, '2015-02-01 00:01:42.000000', 'temperatura', 341.0000, 'ºC'),
	(330683, 142, '2015-02-01 00:01:43.000000', 'temperatura', 814.0000, 'ºC'),
	(330684, 142, '2015-02-01 00:01:44.000000', 'temperatura', 648.0000, 'ºC'),
	(330685, 142, '2015-02-01 00:01:45.000000', 'temperatura', 797.0000, 'ºC'),
	(330686, 142, '2015-02-01 00:01:46.000000', 'temperatura', 841.0000, 'ºC'),
	(330687, 142, '2015-02-01 00:01:47.000000', 'temperatura', 615.0000, 'ºC'),
	(330688, 142, '2015-02-01 00:01:48.000000', 'temperatura', 554.0000, 'ºC'),
	(330689, 142, '2015-02-01 00:01:49.000000', 'temperatura', 922.0000, 'ºC'),
	(330690, 142, '2015-02-01 00:01:50.000000', 'temperatura', 552.0000, 'ºC'),
	(330691, 142, '2015-02-01 00:01:51.000000', 'temperatura', 1193.0000, 'ºC'),
	(330692, 142, '2015-02-01 00:01:52.000000', 'temperatura', 711.0000, 'ºC'),
	(330693, 142, '2015-02-01 00:01:53.000000', 'temperatura', 1177.0000, 'ºC'),
	(330694, 142, '2015-02-01 00:01:54.000000', 'temperatura', 152.0000, 'ºC'),
	(330695, 142, '2015-02-01 00:01:55.000000', 'temperatura', 828.0000, 'ºC'),
	(330696, 142, '2015-02-01 00:01:56.000000', 'temperatura', 83.0000, 'ºC'),
	(330697, 142, '2015-02-01 00:01:57.000000', 'temperatura', 335.0000, 'ºC'),
	(330698, 142, '2015-02-01 00:01:58.000000', 'temperatura', 224.0000, 'ºC'),
	(330699, 142, '2015-02-01 00:01:59.000000', 'temperatura', 116.0000, 'ºC'),
	(330700, 142, '2015-02-01 00:02:00.000000', 'temperatura', 1109.0000, 'ºC'),
	(330701, 142, '2015-02-01 00:02:01.000000', 'temperatura', 399.0000, 'ºC'),
	(330702, 142, '2015-02-01 00:02:02.000000', 'temperatura', 1067.0000, 'ºC'),
	(330703, 142, '2015-02-01 00:02:03.000000', 'temperatura', 538.0000, 'ºC'),
	(330704, 142, '2015-02-01 00:02:04.000000', 'temperatura', 690.0000, 'ºC'),
	(330705, 142, '2015-02-01 00:02:05.000000', 'temperatura', 635.0000, 'ºC'),
	(330706, 142, '2015-02-01 00:02:06.000000', 'temperatura', 1107.0000, 'ºC'),
	(330707, 142, '2015-02-01 00:02:07.000000', 'temperatura', 31.0000, 'ºC'),
	(330708, 142, '2015-02-01 00:02:08.000000', 'temperatura', 433.0000, 'ºC'),
	(330709, 142, '2015-02-01 00:02:09.000000', 'temperatura', 873.0000, 'ºC'),
	(330710, 142, '2015-02-01 00:02:10.000000', 'temperatura', 666.0000, 'ºC'),
	(330711, 142, '2015-02-01 00:02:11.000000', 'temperatura', 712.0000, 'ºC'),
	(330712, 142, '2015-02-01 00:02:12.000000', 'temperatura', 363.0000, 'ºC'),
	(330713, 142, '2015-02-01 00:02:13.000000', 'temperatura', 877.0000, 'ºC'),
	(330714, 142, '2015-02-01 00:02:14.000000', 'temperatura', 898.0000, 'ºC'),
	(330715, 142, '2015-02-01 00:02:15.000000', 'temperatura', 661.0000, 'ºC'),
	(330716, 142, '2015-02-01 00:02:16.000000', 'temperatura', 610.0000, 'ºC'),
	(330717, 142, '2015-02-01 00:02:17.000000', 'temperatura', 1069.0000, 'ºC'),
	(330718, 142, '2015-02-01 00:02:18.000000', 'temperatura', 1117.0000, 'ºC'),
	(330719, 142, '2015-02-01 00:02:19.000000', 'temperatura', 1176.0000, 'ºC'),
	(330720, 142, '2015-02-01 00:02:20.000000', 'temperatura', 130.0000, 'ºC'),
	(330721, 142, '2015-02-01 00:02:21.000000', 'temperatura', 724.0000, 'ºC'),
	(330722, 142, '2015-02-01 00:02:22.000000', 'temperatura', 828.0000, 'ºC'),
	(330723, 142, '2015-02-01 00:02:23.000000', 'temperatura', 770.0000, 'ºC'),
	(330724, 142, '2015-02-01 00:02:24.000000', 'temperatura', 167.0000, 'ºC'),
	(330725, 142, '2015-02-01 00:02:25.000000', 'temperatura', 926.0000, 'ºC'),
	(330726, 142, '2015-02-01 00:02:26.000000', 'temperatura', 529.0000, 'ºC'),
	(330727, 142, '2015-02-01 00:02:27.000000', 'temperatura', 1066.0000, 'ºC'),
	(330728, 142, '2015-02-01 00:02:28.000000', 'temperatura', 146.0000, 'ºC'),
	(330729, 142, '2015-02-01 00:02:29.000000', 'temperatura', 1132.0000, 'ºC'),
	(330730, 142, '2015-02-01 00:02:30.000000', 'temperatura', 421.0000, 'ºC'),
	(330731, 142, '2015-02-01 00:02:31.000000', 'temperatura', 1109.0000, 'ºC'),
	(330732, 142, '2015-02-01 00:02:32.000000', 'temperatura', 681.0000, 'ºC'),
	(330733, 142, '2015-02-01 00:02:33.000000', 'temperatura', 82.0000, 'ºC'),
	(330734, 142, '2015-02-01 00:02:34.000000', 'temperatura', 766.0000, 'ºC'),
	(330735, 142, '2015-02-01 00:02:35.000000', 'temperatura', 1185.0000, 'ºC'),
	(330736, 142, '2015-02-01 00:02:36.000000', 'temperatura', 28.0000, 'ºC'),
	(330737, 142, '2015-02-01 00:02:37.000000', 'temperatura', 183.0000, 'ºC'),
	(330738, 142, '2015-02-01 00:02:38.000000', 'temperatura', 833.0000, 'ºC'),
	(330739, 142, '2015-02-01 00:02:39.000000', 'temperatura', 14.0000, 'ºC'),
	(330740, 142, '2015-02-01 00:02:40.000000', 'temperatura', 1175.0000, 'ºC'),
	(330741, 142, '2015-02-01 00:02:41.000000', 'temperatura', 1033.0000, 'ºC'),
	(330742, 142, '2015-02-01 00:02:42.000000', 'temperatura', 439.0000, 'ºC'),
	(330743, 142, '2015-02-01 00:02:43.000000', 'temperatura', 299.0000, 'ºC'),
	(330744, 142, '2015-02-01 00:02:44.000000', 'temperatura', 176.0000, 'ºC'),
	(330745, 142, '2015-02-01 00:02:45.000000', 'temperatura', 1185.0000, 'ºC'),
	(330746, 142, '2015-02-01 00:02:46.000000', 'temperatura', 599.0000, 'ºC'),
	(330747, 142, '2015-02-01 00:02:47.000000', 'temperatura', 638.0000, 'ºC'),
	(330748, 142, '2015-02-01 00:02:48.000000', 'temperatura', 194.0000, 'ºC'),
	(330749, 142, '2015-02-01 00:02:49.000000', 'temperatura', 258.0000, 'ºC'),
	(330750, 142, '2015-02-01 00:02:50.000000', 'temperatura', 708.0000, 'ºC'),
	(330751, 142, '2015-02-01 00:02:51.000000', 'temperatura', 368.0000, 'ºC'),
	(330752, 142, '2015-02-01 00:02:52.000000', 'temperatura', 915.0000, 'ºC'),
	(330753, 142, '2015-02-01 00:02:53.000000', 'temperatura', 1073.0000, 'ºC'),
	(330754, 142, '2015-02-01 00:02:54.000000', 'temperatura', 221.0000, 'ºC'),
	(330755, 142, '2015-02-01 00:02:55.000000', 'temperatura', 284.0000, 'ºC'),
	(330756, 142, '2015-02-01 00:02:56.000000', 'temperatura', 760.0000, 'ºC'),
	(330757, 142, '2015-02-01 00:02:57.000000', 'temperatura', 548.0000, 'ºC'),
	(330758, 142, '2015-02-01 00:02:58.000000', 'temperatura', 458.0000, 'ºC'),
	(330759, 142, '2015-02-01 00:02:59.000000', 'temperatura', 649.0000, 'ºC'),
	(330760, 142, '2015-02-01 00:03:00.000000', 'temperatura', 669.0000, 'ºC'),
	(330761, 142, '2015-02-01 00:03:01.000000', 'temperatura', 199.0000, 'ºC'),
	(330762, 142, '2015-02-01 00:03:02.000000', 'temperatura', 191.0000, 'ºC'),
	(330763, 142, '2015-02-01 00:03:03.000000', 'temperatura', 356.0000, 'ºC'),
	(330764, 142, '2015-02-01 00:03:04.000000', 'temperatura', 6.0000, 'ºC'),
	(330765, 142, '2015-02-01 00:03:05.000000', 'temperatura', 165.0000, 'ºC'),
	(330766, 142, '2015-02-01 00:03:06.000000', 'temperatura', 806.0000, 'ºC'),
	(330767, 142, '2015-02-01 00:03:07.000000', 'temperatura', 1137.0000, 'ºC'),
	(330768, 142, '2015-02-01 00:03:08.000000', 'temperatura', 868.0000, 'ºC'),
	(330769, 142, '2015-02-01 00:03:09.000000', 'temperatura', 929.0000, 'ºC'),
	(330770, 142, '2015-02-01 00:03:10.000000', 'temperatura', 842.0000, 'ºC'),
	(330771, 142, '2015-02-01 00:03:11.000000', 'temperatura', 225.0000, 'ºC'),
	(330772, 142, '2015-02-01 00:03:12.000000', 'temperatura', 997.0000, 'ºC'),
	(330773, 142, '2015-02-01 00:03:13.000000', 'temperatura', 710.0000, 'ºC'),
	(330774, 142, '2015-02-01 00:03:14.000000', 'temperatura', 558.0000, 'ºC'),
	(330775, 142, '2015-02-01 00:03:15.000000', 'temperatura', 664.0000, 'ºC'),
	(330776, 142, '2015-02-01 00:03:16.000000', 'temperatura', 445.0000, 'ºC'),
	(330777, 142, '2015-02-01 00:03:17.000000', 'temperatura', 233.0000, 'ºC'),
	(330778, 142, '2015-02-01 00:03:18.000000', 'temperatura', 1033.0000, 'ºC'),
	(330779, 142, '2015-02-01 00:03:19.000000', 'temperatura', 865.0000, 'ºC'),
	(330780, 142, '2015-02-01 00:03:20.000000', 'temperatura', 27.0000, 'ºC'),
	(330781, 142, '2015-02-01 00:03:21.000000', 'temperatura', 1138.0000, 'ºC'),
	(330782, 142, '2015-02-01 00:03:22.000000', 'temperatura', 811.0000, 'ºC'),
	(330783, 142, '2015-02-01 00:03:23.000000', 'temperatura', 642.0000, 'ºC'),
	(330784, 142, '2015-02-01 00:03:24.000000', 'temperatura', 779.0000, 'ºC'),
	(330785, 142, '2015-02-01 00:03:25.000000', 'temperatura', 767.0000, 'ºC'),
	(330786, 142, '2015-02-01 00:03:26.000000', 'temperatura', 300.0000, 'ºC'),
	(330787, 142, '2015-02-01 00:03:27.000000', 'temperatura', 398.0000, 'ºC'),
	(330788, 142, '2015-02-01 00:03:28.000000', 'temperatura', 1091.0000, 'ºC'),
	(330789, 142, '2015-02-01 00:03:29.000000', 'temperatura', 662.0000, 'ºC'),
	(330790, 142, '2015-02-01 00:03:30.000000', 'temperatura', 37.0000, 'ºC'),
	(330791, 142, '2015-02-01 00:03:31.000000', 'temperatura', 600.0000, 'ºC'),
	(330792, 142, '2015-02-01 00:03:32.000000', 'temperatura', 488.0000, 'ºC'),
	(330793, 142, '2015-02-01 00:03:33.000000', 'temperatura', 643.0000, 'ºC'),
	(330794, 142, '2015-02-01 00:03:34.000000', 'temperatura', 552.0000, 'ºC'),
	(330795, 142, '2015-02-01 00:03:35.000000', 'temperatura', 829.0000, 'ºC'),
	(330796, 142, '2015-02-01 00:03:36.000000', 'temperatura', 90.0000, 'ºC'),
	(330797, 142, '2015-02-01 00:03:37.000000', 'temperatura', 363.0000, 'ºC'),
	(330798, 142, '2015-02-01 00:03:38.000000', 'temperatura', 344.0000, 'ºC'),
	(330799, 142, '2015-02-01 00:03:39.000000', 'temperatura', 635.0000, 'ºC'),
	(330800, 142, '2015-02-01 00:03:40.000000', 'temperatura', 940.0000, 'ºC'),
	(330801, 142, '2015-02-01 00:03:41.000000', 'temperatura', 397.0000, 'ºC'),
	(330802, 142, '2015-02-01 00:03:42.000000', 'temperatura', 366.0000, 'ºC'),
	(330803, 142, '2015-02-01 00:03:43.000000', 'temperatura', 639.0000, 'ºC'),
	(330804, 142, '2015-02-01 00:03:44.000000', 'temperatura', 896.0000, 'ºC'),
	(330805, 142, '2015-02-01 00:03:45.000000', 'temperatura', 166.0000, 'ºC'),
	(330806, 142, '2015-02-01 00:03:46.000000', 'temperatura', 540.0000, 'ºC'),
	(330807, 142, '2015-02-01 00:03:47.000000', 'temperatura', 1003.0000, 'ºC'),
	(330808, 142, '2015-02-01 00:03:48.000000', 'temperatura', 995.0000, 'ºC'),
	(330809, 142, '2015-02-01 00:03:49.000000', 'temperatura', 768.0000, 'ºC'),
	(330810, 142, '2015-02-01 00:03:50.000000', 'temperatura', 856.0000, 'ºC'),
	(330811, 142, '2015-02-01 00:03:51.000000', 'temperatura', 777.0000, 'ºC'),
	(330812, 142, '2015-02-01 00:03:52.000000', 'temperatura', 118.0000, 'ºC'),
	(330813, 142, '2015-02-01 00:03:53.000000', 'temperatura', 657.0000, 'ºC'),
	(330814, 142, '2015-02-01 00:03:54.000000', 'temperatura', 533.0000, 'ºC'),
	(330815, 142, '2015-02-01 00:03:55.000000', 'temperatura', 695.0000, 'ºC'),
	(330816, 142, '2015-02-01 00:03:56.000000', 'temperatura', 674.0000, 'ºC'),
	(330817, 142, '2015-02-01 00:03:57.000000', 'temperatura', 87.0000, 'ºC'),
	(330818, 142, '2015-02-01 00:03:58.000000', 'temperatura', 813.0000, 'ºC'),
	(330819, 142, '2015-02-01 00:03:59.000000', 'temperatura', 204.0000, 'ºC'),
	(330820, 142, '2015-02-01 00:04:00.000000', 'temperatura', 983.0000, 'ºC'),
	(330821, 142, '2015-02-01 00:04:01.000000', 'temperatura', 705.0000, 'ºC'),
	(330822, 142, '2015-02-01 00:04:02.000000', 'temperatura', 573.0000, 'ºC'),
	(330823, 142, '2015-02-01 00:04:03.000000', 'temperatura', 753.0000, 'ºC'),
	(330824, 142, '2015-02-01 00:04:04.000000', 'temperatura', 845.0000, 'ºC'),
	(330825, 142, '2015-02-01 00:04:05.000000', 'temperatura', 767.0000, 'ºC'),
	(330826, 142, '2015-02-01 00:04:06.000000', 'temperatura', 99.0000, 'ºC'),
	(330827, 142, '2015-02-01 00:04:07.000000', 'temperatura', 594.0000, 'ºC'),
	(330828, 142, '2015-02-01 00:04:08.000000', 'temperatura', 273.0000, 'ºC'),
	(330829, 142, '2015-02-01 00:04:09.000000', 'temperatura', 787.0000, 'ºC'),
	(330830, 142, '2015-02-01 00:04:10.000000', 'temperatura', 713.0000, 'ºC'),
	(330831, 142, '2015-02-01 00:04:11.000000', 'temperatura', 6.0000, 'ºC'),
	(330832, 142, '2015-02-01 00:04:12.000000', 'temperatura', 290.0000, 'ºC'),
	(330833, 142, '2015-02-01 00:04:13.000000', 'temperatura', 233.0000, 'ºC'),
	(330834, 142, '2015-02-01 00:04:14.000000', 'temperatura', 298.0000, 'ºC'),
	(330835, 142, '2015-02-01 00:04:15.000000', 'temperatura', 788.0000, 'ºC'),
	(330836, 142, '2015-02-01 00:04:16.000000', 'temperatura', 648.0000, 'ºC'),
	(330837, 142, '2015-02-01 00:04:17.000000', 'temperatura', 876.0000, 'ºC'),
	(330838, 142, '2015-02-01 00:04:18.000000', 'temperatura', 37.0000, 'ºC'),
	(330839, 142, '2015-02-01 00:04:19.000000', 'temperatura', 1158.0000, 'ºC'),
	(330840, 142, '2015-02-01 00:04:20.000000', 'temperatura', 879.0000, 'ºC'),
	(330841, 142, '2015-02-01 00:04:21.000000', 'temperatura', 923.0000, 'ºC'),
	(330842, 142, '2015-02-01 00:04:22.000000', 'temperatura', 777.0000, 'ºC'),
	(330843, 142, '2015-02-01 00:04:23.000000', 'temperatura', 1117.0000, 'ºC'),
	(330844, 142, '2015-02-01 00:04:24.000000', 'temperatura', 853.0000, 'ºC'),
	(330845, 142, '2015-02-01 00:04:25.000000', 'temperatura', 914.0000, 'ºC'),
	(330846, 142, '2015-02-01 00:04:26.000000', 'temperatura', 814.0000, 'ºC'),
	(330847, 142, '2015-02-01 00:04:27.000000', 'temperatura', 127.0000, 'ºC'),
	(330848, 142, '2015-02-01 00:04:28.000000', 'temperatura', 592.0000, 'ºC'),
	(330849, 142, '2015-02-01 00:04:29.000000', 'temperatura', 181.0000, 'ºC'),
	(330850, 142, '2015-02-01 00:04:30.000000', 'temperatura', 331.0000, 'ºC'),
	(330851, 142, '2015-02-01 00:04:31.000000', 'temperatura', 1111.0000, 'ºC'),
	(330852, 142, '2015-02-01 00:04:32.000000', 'temperatura', 962.0000, 'ºC'),
	(330853, 142, '2015-02-01 00:04:33.000000', 'temperatura', 279.0000, 'ºC'),
	(330854, 142, '2015-02-01 00:04:34.000000', 'temperatura', 911.0000, 'ºC'),
	(330855, 142, '2015-02-01 00:04:35.000000', 'temperatura', 116.0000, 'ºC'),
	(330856, 142, '2015-02-01 00:04:36.000000', 'temperatura', 250.0000, 'ºC'),
	(330857, 142, '2015-02-01 00:04:37.000000', 'temperatura', 899.0000, 'ºC'),
	(330858, 142, '2015-02-01 00:04:38.000000', 'temperatura', 149.0000, 'ºC'),
	(330859, 142, '2015-02-01 00:04:39.000000', 'temperatura', 448.0000, 'ºC'),
	(330860, 142, '2015-02-01 00:04:40.000000', 'temperatura', 592.0000, 'ºC'),
	(330861, 142, '2015-02-01 00:04:41.000000', 'temperatura', 416.0000, 'ºC'),
	(330862, 142, '2015-02-01 00:04:42.000000', 'temperatura', 305.0000, 'ºC'),
	(330863, 142, '2015-02-01 00:04:43.000000', 'temperatura', 277.0000, 'ºC'),
	(330864, 142, '2015-02-01 00:04:44.000000', 'temperatura', 471.0000, 'ºC'),
	(330865, 142, '2015-02-01 00:04:45.000000', 'temperatura', 322.0000, 'ºC'),
	(330866, 142, '2015-02-01 00:04:46.000000', 'temperatura', 201.0000, 'ºC'),
	(330867, 142, '2015-02-01 00:04:47.000000', 'temperatura', 39.0000, 'ºC'),
	(330868, 142, '2015-02-01 00:04:48.000000', 'temperatura', 792.0000, 'ºC'),
	(330869, 142, '2015-02-01 00:04:49.000000', 'temperatura', 245.0000, 'ºC'),
	(330870, 142, '2015-02-01 00:04:50.000000', 'temperatura', 50.0000, 'ºC'),
	(330871, 142, '2015-02-01 00:04:51.000000', 'temperatura', 713.0000, 'ºC'),
	(330872, 142, '2015-02-01 00:04:52.000000', 'temperatura', 1016.0000, 'ºC'),
	(330873, 142, '2015-02-01 00:04:53.000000', 'temperatura', 541.0000, 'ºC'),
	(330874, 142, '2015-02-01 00:04:54.000000', 'temperatura', 856.0000, 'ºC'),
	(330875, 142, '2015-02-01 00:04:55.000000', 'temperatura', 259.0000, 'ºC'),
	(330876, 142, '2015-02-01 00:04:56.000000', 'temperatura', 1129.0000, 'ºC'),
	(330877, 142, '2015-02-01 00:04:57.000000', 'temperatura', 68.0000, 'ºC'),
	(330878, 142, '2015-02-01 00:04:58.000000', 'temperatura', 554.0000, 'ºC'),
	(330879, 142, '2015-02-01 00:04:59.000000', 'temperatura', 166.0000, 'ºC'),
	(330880, 142, '2015-02-01 00:05:00.000000', 'temperatura', 368.0000, 'ºC'),
	(330881, 142, '2015-02-01 00:05:01.000000', 'temperatura', 141.0000, 'ºC'),
	(330882, 142, '2015-02-01 00:05:02.000000', 'temperatura', 803.0000, 'ºC'),
	(330883, 142, '2015-02-01 00:05:03.000000', 'temperatura', 1191.0000, 'ºC'),
	(330884, 142, '2015-02-01 00:05:04.000000', 'temperatura', 1147.0000, 'ºC'),
	(330885, 142, '2015-02-01 00:05:05.000000', 'temperatura', 961.0000, 'ºC'),
	(330886, 142, '2015-02-01 00:05:06.000000', 'temperatura', 166.0000, 'ºC'),
	(330887, 142, '2015-02-01 00:05:07.000000', 'temperatura', 346.0000, 'ºC'),
	(330888, 142, '2015-02-01 00:05:08.000000', 'temperatura', 35.0000, 'ºC'),
	(330889, 142, '2015-02-01 00:05:09.000000', 'temperatura', 335.0000, 'ºC'),
	(330890, 142, '2015-02-01 00:05:10.000000', 'temperatura', 373.0000, 'ºC'),
	(330891, 142, '2015-02-01 00:05:11.000000', 'temperatura', 862.0000, 'ºC'),
	(330892, 142, '2015-02-01 00:05:12.000000', 'temperatura', 788.0000, 'ºC'),
	(330893, 142, '2015-02-01 00:05:13.000000', 'temperatura', 154.0000, 'ºC'),
	(330894, 142, '2015-02-01 00:05:14.000000', 'temperatura', 810.0000, 'ºC'),
	(330895, 142, '2015-02-01 00:05:15.000000', 'temperatura', 1186.0000, 'ºC'),
	(330896, 142, '2015-02-01 00:05:16.000000', 'temperatura', 1101.0000, 'ºC'),
	(330897, 142, '2015-02-01 00:05:17.000000', 'temperatura', 750.0000, 'ºC'),
	(330898, 142, '2015-02-01 00:05:18.000000', 'temperatura', 444.0000, 'ºC'),
	(330899, 142, '2015-02-01 00:05:19.000000', 'temperatura', 1172.0000, 'ºC'),
	(330900, 142, '2015-02-01 00:05:20.000000', 'temperatura', 928.0000, 'ºC'),
	(330901, 142, '2015-02-01 00:05:21.000000', 'temperatura', 1124.0000, 'ºC'),
	(330902, 142, '2015-02-01 00:05:22.000000', 'temperatura', 438.0000, 'ºC'),
	(330903, 142, '2015-02-01 00:05:23.000000', 'temperatura', 16.0000, 'ºC'),
	(330904, 142, '2015-02-01 00:05:24.000000', 'temperatura', 1167.0000, 'ºC'),
	(330905, 142, '2015-02-01 00:05:25.000000', 'temperatura', 988.0000, 'ºC'),
	(330906, 142, '2015-02-01 00:05:26.000000', 'temperatura', 241.0000, 'ºC'),
	(330907, 142, '2015-02-01 00:05:27.000000', 'temperatura', 641.0000, 'ºC'),
	(330908, 142, '2015-02-01 00:05:28.000000', 'temperatura', 81.0000, 'ºC'),
	(330909, 142, '2015-02-01 00:05:29.000000', 'temperatura', 883.0000, 'ºC'),
	(330910, 142, '2015-02-01 00:05:30.000000', 'temperatura', 574.0000, 'ºC'),
	(330911, 142, '2015-02-01 00:05:31.000000', 'temperatura', 221.0000, 'ºC'),
	(330912, 142, '2015-02-01 00:05:32.000000', 'temperatura', 582.0000, 'ºC'),
	(330913, 142, '2015-02-01 00:05:33.000000', 'temperatura', 1050.0000, 'ºC'),
	(330914, 142, '2015-02-01 00:05:34.000000', 'temperatura', 1102.0000, 'ºC'),
	(330915, 142, '2015-02-01 00:05:35.000000', 'temperatura', 1159.0000, 'ºC'),
	(330916, 142, '2015-02-01 00:05:36.000000', 'temperatura', 93.0000, 'ºC'),
	(330917, 142, '2015-02-01 00:05:37.000000', 'temperatura', 588.0000, 'ºC'),
	(330918, 142, '2015-02-01 00:05:38.000000', 'temperatura', 261.0000, 'ºC'),
	(330919, 142, '2015-02-01 00:05:39.000000', 'temperatura', 741.0000, 'ºC'),
	(330920, 142, '2015-02-01 00:05:40.000000', 'temperatura', 522.0000, 'ºC'),
	(330921, 142, '2015-02-01 00:05:41.000000', 'temperatura', 388.0000, 'ºC'),
	(330922, 142, '2015-02-01 00:05:42.000000', 'temperatura', 375.0000, 'ºC'),
	(330923, 142, '2015-02-01 00:05:43.000000', 'temperatura', 709.0000, 'ºC'),
	(330924, 142, '2015-02-01 00:05:44.000000', 'temperatura', 22.0000, 'ºC'),
	(330925, 142, '2015-02-01 00:05:45.000000', 'temperatura', 385.0000, 'ºC'),
	(330926, 142, '2015-02-01 00:05:46.000000', 'temperatura', 660.0000, 'ºC'),
	(330927, 142, '2015-02-01 00:05:47.000000', 'temperatura', 945.0000, 'ºC'),
	(330928, 142, '2015-02-01 00:05:48.000000', 'temperatura', 344.0000, 'ºC'),
	(330929, 142, '2015-02-01 00:05:49.000000', 'temperatura', 86.0000, 'ºC'),
	(330930, 142, '2015-02-01 00:05:50.000000', 'temperatura', 597.0000, 'ºC'),
	(330931, 142, '2015-02-01 00:05:51.000000', 'temperatura', 327.0000, 'ºC'),
	(330932, 142, '2015-02-01 00:05:52.000000', 'temperatura', 1045.0000, 'ºC'),
	(330933, 142, '2015-02-01 00:05:53.000000', 'temperatura', 643.0000, 'ºC'),
	(330934, 142, '2015-02-01 00:05:54.000000', 'temperatura', 83.0000, 'ºC'),
	(330935, 142, '2015-02-01 00:05:55.000000', 'temperatura', 887.0000, 'ºC'),
	(330936, 142, '2015-02-01 00:05:56.000000', 'temperatura', 588.0000, 'ºC'),
	(330937, 142, '2015-02-01 00:05:57.000000', 'temperatura', 276.0000, 'ºC'),
	(330938, 142, '2015-02-01 00:05:58.000000', 'temperatura', 819.0000, 'ºC'),
	(330939, 142, '2015-02-01 00:05:59.000000', 'temperatura', 865.0000, 'ºC'),
	(330940, 142, '2015-02-01 00:06:00.000000', 'temperatura', 670.0000, 'ºC'),
	(330941, 142, '2015-02-01 00:06:01.000000', 'temperatura', 753.0000, 'ºC'),
	(330942, 142, '2015-02-01 00:06:02.000000', 'temperatura', 558.0000, 'ºC'),
	(330943, 142, '2015-02-01 00:06:03.000000', 'temperatura', 530.0000, 'ºC'),
	(330944, 142, '2015-02-01 00:06:04.000000', 'temperatura', 977.0000, 'ºC'),
	(330945, 142, '2015-02-01 00:06:05.000000', 'temperatura', 896.0000, 'ºC'),
	(330946, 142, '2015-02-01 00:06:06.000000', 'temperatura', 349.0000, 'ºC'),
	(330947, 142, '2015-02-01 00:06:07.000000', 'temperatura', 257.0000, 'ºC'),
	(330948, 142, '2015-02-01 00:06:08.000000', 'temperatura', 237.0000, 'ºC'),
	(330949, 142, '2015-02-01 00:06:09.000000', 'temperatura', 417.0000, 'ºC'),
	(330950, 142, '2015-02-01 00:06:10.000000', 'temperatura', 172.0000, 'ºC'),
	(330951, 142, '2015-02-01 00:06:11.000000', 'temperatura', 810.0000, 'ºC'),
	(330952, 142, '2015-02-01 00:06:12.000000', 'temperatura', 1134.0000, 'ºC'),
	(330953, 142, '2015-02-01 00:06:13.000000', 'temperatura', 839.0000, 'ºC'),
	(330954, 142, '2015-02-01 00:06:14.000000', 'temperatura', 796.0000, 'ºC'),
	(330955, 142, '2015-02-01 00:06:15.000000', 'temperatura', 261.0000, 'ºC'),
	(330956, 142, '2015-02-01 00:06:16.000000', 'temperatura', 119.0000, 'ºC'),
	(330957, 142, '2015-02-01 00:06:17.000000', 'temperatura', 1011.0000, 'ºC'),
	(330958, 142, '2015-02-01 00:06:18.000000', 'temperatura', 1100.0000, 'ºC'),
	(330959, 142, '2015-02-01 00:06:19.000000', 'temperatura', 66.0000, 'ºC'),
	(330960, 142, '2015-02-01 00:06:20.000000', 'temperatura', 632.0000, 'ºC'),
	(330961, 142, '2015-02-01 00:06:21.000000', 'temperatura', 560.0000, 'ºC'),
	(330962, 142, '2015-02-01 00:06:22.000000', 'temperatura', 906.0000, 'ºC'),
	(330963, 142, '2015-02-01 00:06:23.000000', 'temperatura', 448.0000, 'ºC'),
	(330964, 142, '2015-02-01 00:06:24.000000', 'temperatura', 726.0000, 'ºC'),
	(330965, 142, '2015-02-01 00:06:25.000000', 'temperatura', 1087.0000, 'ºC'),
	(330966, 142, '2015-02-01 00:06:26.000000', 'temperatura', 854.0000, 'ºC'),
	(330967, 142, '2015-02-01 00:06:27.000000', 'temperatura', 1013.0000, 'ºC'),
	(330968, 142, '2015-02-01 00:06:28.000000', 'temperatura', 102.0000, 'ºC'),
	(330969, 142, '2015-02-01 00:06:29.000000', 'temperatura', 1070.0000, 'ºC'),
	(330970, 142, '2015-02-01 00:06:30.000000', 'temperatura', 245.0000, 'ºC'),
	(330971, 142, '2015-02-01 00:06:31.000000', 'temperatura', 414.0000, 'ºC'),
	(330972, 142, '2015-02-01 00:06:32.000000', 'temperatura', 137.0000, 'ºC'),
	(330973, 142, '2015-02-01 00:06:33.000000', 'temperatura', 642.0000, 'ºC'),
	(330974, 142, '2015-02-01 00:06:34.000000', 'temperatura', 403.0000, 'ºC'),
	(330975, 142, '2015-02-01 00:06:35.000000', 'temperatura', 86.0000, 'ºC'),
	(330976, 142, '2015-02-01 00:06:36.000000', 'temperatura', 423.0000, 'ºC'),
	(330977, 142, '2015-02-01 00:06:37.000000', 'temperatura', 655.0000, 'ºC'),
	(330978, 142, '2015-02-01 00:06:38.000000', 'temperatura', 809.0000, 'ºC'),
	(330979, 142, '2015-02-01 00:06:39.000000', 'temperatura', 880.0000, 'ºC'),
	(330980, 142, '2015-02-01 00:06:40.000000', 'temperatura', 772.0000, 'ºC'),
	(330981, 142, '2015-02-01 00:06:41.000000', 'temperatura', 22.0000, 'ºC'),
	(330982, 142, '2015-02-01 00:06:42.000000', 'temperatura', 193.0000, 'ºC'),
	(330983, 142, '2015-02-01 00:06:43.000000', 'temperatura', 900.0000, 'ºC'),
	(330984, 142, '2015-02-01 00:06:44.000000', 'temperatura', 320.0000, 'ºC'),
	(330985, 142, '2015-02-01 00:06:45.000000', 'temperatura', 102.0000, 'ºC'),
	(330986, 142, '2015-02-01 00:06:46.000000', 'temperatura', 750.0000, 'ºC'),
	(330987, 142, '2015-02-01 00:06:47.000000', 'temperatura', 1044.0000, 'ºC'),
	(330988, 142, '2015-02-01 00:06:48.000000', 'temperatura', 570.0000, 'ºC'),
	(330989, 142, '2015-02-01 00:06:49.000000', 'temperatura', 918.0000, 'ºC'),
	(330990, 142, '2015-02-01 00:06:50.000000', 'temperatura', 483.0000, 'ºC'),
	(330991, 142, '2015-02-01 00:06:51.000000', 'temperatura', 862.0000, 'ºC'),
	(330992, 142, '2015-02-01 00:06:52.000000', 'temperatura', 461.0000, 'ºC'),
	(330993, 142, '2015-02-01 00:06:53.000000', 'temperatura', 921.0000, 'ºC'),
	(330994, 142, '2015-02-01 00:06:54.000000', 'temperatura', 822.0000, 'ºC'),
	(330995, 142, '2015-02-01 00:06:55.000000', 'temperatura', 146.0000, 'ºC'),
	(330996, 142, '2015-02-01 00:06:56.000000', 'temperatura', 667.0000, 'ºC'),
	(330997, 142, '2015-02-01 00:06:57.000000', 'temperatura', 494.0000, 'ºC'),
	(330998, 142, '2015-02-01 00:06:58.000000', 'temperatura', 472.0000, 'ºC'),
	(330999, 142, '2015-02-01 00:06:59.000000', 'temperatura', 880.0000, 'ºC'),
	(331000, 142, '2015-02-01 00:07:00.000000', 'temperatura', 581.0000, 'ºC'),
	(331001, 142, '2015-02-01 00:07:01.000000', 'temperatura', 268.0000, 'ºC'),
	(331002, 142, '2015-02-01 00:07:02.000000', 'temperatura', 796.0000, 'ºC'),
	(331003, 142, '2015-02-01 00:07:03.000000', 'temperatura', 779.0000, 'ºC'),
	(331004, 142, '2015-02-01 00:07:04.000000', 'temperatura', 306.0000, 'ºC'),
	(331005, 142, '2015-02-01 00:07:05.000000', 'temperatura', 392.0000, 'ºC'),
	(331006, 142, '2015-02-01 00:07:06.000000', 'temperatura', 1042.0000, 'ºC'),
	(331007, 142, '2015-02-01 00:07:07.000000', 'temperatura', 433.0000, 'ºC'),
	(331008, 142, '2015-02-01 00:07:08.000000', 'temperatura', 243.0000, 'ºC'),
	(331009, 142, '2015-02-01 00:07:09.000000', 'temperatura', 1117.0000, 'ºC'),
	(331010, 142, '2015-02-01 00:07:10.000000', 'temperatura', 55.0000, 'ºC'),
	(331011, 142, '2015-02-01 00:07:11.000000', 'temperatura', 526.0000, 'ºC'),
	(331012, 142, '2015-02-01 00:07:12.000000', 'temperatura', 64.0000, 'ºC'),
	(331013, 142, '2015-02-01 00:07:13.000000', 'temperatura', 1142.0000, 'ºC'),
	(331014, 142, '2015-02-01 00:07:14.000000', 'temperatura', 721.0000, 'ºC'),
	(331015, 142, '2015-02-01 00:07:15.000000', 'temperatura', 177.0000, 'ºC'),
	(331016, 142, '2015-02-01 00:07:16.000000', 'temperatura', 1123.0000, 'ºC'),
	(331017, 142, '2015-02-01 00:07:17.000000', 'temperatura', 287.0000, 'ºC'),
	(331018, 142, '2015-02-01 00:07:18.000000', 'temperatura', 464.0000, 'ºC'),
	(331019, 142, '2015-02-01 00:07:19.000000', 'temperatura', 260.0000, 'ºC'),
	(331020, 142, '2015-02-01 00:07:20.000000', 'temperatura', 1107.0000, 'ºC'),
	(331021, 142, '2015-02-01 00:07:21.000000', 'temperatura', 1159.0000, 'ºC'),
	(331022, 142, '2015-02-01 00:07:22.000000', 'temperatura', 72.0000, 'ºC'),
	(331023, 142, '2015-02-01 00:07:23.000000', 'temperatura', 482.0000, 'ºC'),
	(331024, 142, '2015-02-01 00:07:24.000000', 'temperatura', 996.0000, 'ºC'),
	(331025, 142, '2015-02-01 00:07:25.000000', 'temperatura', 1136.0000, 'ºC'),
	(331026, 142, '2015-02-01 00:07:26.000000', 'temperatura', 290.0000, 'ºC'),
	(331027, 142, '2015-02-01 00:07:27.000000', 'temperatura', 445.0000, 'ºC'),
	(331028, 142, '2015-02-01 00:07:28.000000', 'temperatura', 153.0000, 'ºC'),
	(331029, 142, '2015-02-01 00:07:29.000000', 'temperatura', 633.0000, 'ºC'),
	(331030, 142, '2015-02-01 00:07:30.000000', 'temperatura', 307.0000, 'ºC'),
	(331031, 142, '2015-02-01 00:07:31.000000', 'temperatura', 834.0000, 'ºC'),
	(331032, 142, '2015-02-01 00:07:32.000000', 'temperatura', 851.0000, 'ºC'),
	(331033, 142, '2015-02-01 00:07:33.000000', 'temperatura', 552.0000, 'ºC'),
	(331034, 142, '2015-02-01 00:07:34.000000', 'temperatura', 210.0000, 'ºC'),
	(331035, 142, '2015-02-01 00:07:35.000000', 'temperatura', 592.0000, 'ºC'),
	(331036, 142, '2015-02-01 00:07:36.000000', 'temperatura', 1131.0000, 'ºC'),
	(331037, 142, '2015-02-01 00:07:37.000000', 'temperatura', 281.0000, 'ºC'),
	(331038, 142, '2015-02-01 00:07:38.000000', 'temperatura', 411.0000, 'ºC'),
	(331039, 142, '2015-02-01 00:07:39.000000', 'temperatura', 11.0000, 'ºC'),
	(331040, 142, '2015-02-01 00:07:40.000000', 'temperatura', 24.0000, 'ºC'),
	(331041, 142, '2015-02-01 00:07:41.000000', 'temperatura', 89.0000, 'ºC'),
	(331042, 142, '2015-02-01 00:07:42.000000', 'temperatura', 372.0000, 'ºC'),
	(331043, 142, '2015-02-01 00:07:43.000000', 'temperatura', 392.0000, 'ºC'),
	(331044, 142, '2015-02-01 00:07:44.000000', 'temperatura', 847.0000, 'ºC'),
	(331045, 142, '2015-02-01 00:07:45.000000', 'temperatura', 660.0000, 'ºC'),
	(331046, 142, '2015-02-01 00:07:46.000000', 'temperatura', 759.0000, 'ºC'),
	(331047, 142, '2015-02-01 00:07:47.000000', 'temperatura', 616.0000, 'ºC'),
	(331048, 142, '2015-02-01 00:07:48.000000', 'temperatura', 804.0000, 'ºC'),
	(331049, 142, '2015-02-01 00:07:49.000000', 'temperatura', 971.0000, 'ºC'),
	(331050, 142, '2015-02-01 00:07:50.000000', 'temperatura', 45.0000, 'ºC'),
	(331051, 142, '2015-02-01 00:07:51.000000', 'temperatura', 914.0000, 'ºC'),
	(331052, 142, '2015-02-01 00:07:52.000000', 'temperatura', 834.0000, 'ºC'),
	(331053, 142, '2015-02-01 00:07:53.000000', 'temperatura', 227.0000, 'ºC'),
	(331054, 142, '2015-02-01 00:07:54.000000', 'temperatura', 1035.0000, 'ºC'),
	(331055, 142, '2015-02-01 00:07:55.000000', 'temperatura', 893.0000, 'ºC'),
	(331056, 142, '2015-02-01 00:07:56.000000', 'temperatura', 160.0000, 'ºC'),
	(331057, 142, '2015-02-01 00:07:57.000000', 'temperatura', 521.0000, 'ºC'),
	(331058, 142, '2015-02-01 00:07:58.000000', 'temperatura', 927.0000, 'ºC'),
	(331059, 142, '2015-02-01 00:07:59.000000', 'temperatura', 672.0000, 'ºC'),
	(331060, 142, '2015-02-01 00:08:00.000000', 'temperatura', 578.0000, 'ºC'),
	(331061, 142, '2015-02-01 00:08:01.000000', 'temperatura', 874.0000, 'ºC'),
	(331062, 142, '2015-02-01 00:08:02.000000', 'temperatura', 236.0000, 'ºC'),
	(331063, 142, '2015-02-01 00:08:03.000000', 'temperatura', 959.0000, 'ºC'),
	(331064, 142, '2015-02-01 00:08:04.000000', 'temperatura', 487.0000, 'ºC'),
	(331065, 142, '2015-02-01 00:08:05.000000', 'temperatura', 761.0000, 'ºC'),
	(331066, 142, '2015-02-01 00:08:06.000000', 'temperatura', 1142.0000, 'ºC'),
	(331067, 142, '2015-02-01 00:08:07.000000', 'temperatura', 1027.0000, 'ºC'),
	(331068, 142, '2015-02-01 00:08:08.000000', 'temperatura', 508.0000, 'ºC'),
	(331069, 142, '2015-02-01 00:08:09.000000', 'temperatura', 663.0000, 'ºC'),
	(331070, 142, '2015-02-01 00:08:10.000000', 'temperatura', 588.0000, 'ºC'),
	(331071, 142, '2015-02-01 00:08:11.000000', 'temperatura', 954.0000, 'ºC'),
	(331072, 142, '2015-02-01 00:08:12.000000', 'temperatura', 604.0000, 'ºC'),
	(331073, 142, '2015-02-01 00:08:13.000000', 'temperatura', 161.0000, 'ºC'),
	(331074, 142, '2015-02-01 00:08:14.000000', 'temperatura', 193.0000, 'ºC'),
	(331075, 142, '2015-02-01 00:08:15.000000', 'temperatura', 483.0000, 'ºC'),
	(331076, 142, '2015-02-01 00:08:16.000000', 'temperatura', 634.0000, 'ºC'),
	(331077, 142, '2015-02-01 00:08:17.000000', 'temperatura', 522.0000, 'ºC'),
	(331078, 142, '2015-02-01 00:08:18.000000', 'temperatura', 710.0000, 'ºC'),
	(331079, 142, '2015-02-01 00:08:19.000000', 'temperatura', 783.0000, 'ºC'),
	(331080, 142, '2015-02-01 00:08:20.000000', 'temperatura', 587.0000, 'ºC'),
	(331081, 142, '2015-02-01 00:08:21.000000', 'temperatura', 588.0000, 'ºC'),
	(331082, 142, '2015-02-01 00:08:22.000000', 'temperatura', 1178.0000, 'ºC'),
	(331083, 142, '2015-02-01 00:08:23.000000', 'temperatura', 525.0000, 'ºC'),
	(331084, 142, '2015-02-01 00:08:24.000000', 'temperatura', 294.0000, 'ºC'),
	(331085, 142, '2015-02-01 00:08:25.000000', 'temperatura', 1096.0000, 'ºC'),
	(331086, 142, '2015-02-01 00:08:26.000000', 'temperatura', 998.0000, 'ºC'),
	(331087, 142, '2015-02-01 00:08:27.000000', 'temperatura', 503.0000, 'ºC'),
	(331088, 142, '2015-02-01 00:08:28.000000', 'temperatura', 719.0000, 'ºC'),
	(331089, 142, '2015-02-01 00:08:29.000000', 'temperatura', 889.0000, 'ºC'),
	(331090, 142, '2015-02-01 00:08:30.000000', 'temperatura', 1086.0000, 'ºC'),
	(331091, 142, '2015-02-01 00:08:31.000000', 'temperatura', 363.0000, 'ºC'),
	(331092, 142, '2015-02-01 00:08:32.000000', 'temperatura', 958.0000, 'ºC'),
	(331093, 142, '2015-02-01 00:08:33.000000', 'temperatura', 103.0000, 'ºC'),
	(331094, 142, '2015-02-01 00:08:34.000000', 'temperatura', 42.0000, 'ºC'),
	(331095, 142, '2015-02-01 00:08:35.000000', 'temperatura', 1103.0000, 'ºC'),
	(331096, 142, '2015-02-01 00:08:36.000000', 'temperatura', 586.0000, 'ºC'),
	(331097, 142, '2015-02-01 00:08:37.000000', 'temperatura', 824.0000, 'ºC'),
	(331098, 142, '2015-02-01 00:08:38.000000', 'temperatura', 1160.0000, 'ºC'),
	(331099, 142, '2015-02-01 00:08:39.000000', 'temperatura', 932.0000, 'ºC'),
	(331100, 142, '2015-02-01 00:08:40.000000', 'temperatura', 1177.0000, 'ºC'),
	(331101, 142, '2015-02-01 00:08:41.000000', 'temperatura', 692.0000, 'ºC'),
	(331102, 142, '2015-02-01 00:08:42.000000', 'temperatura', 1128.0000, 'ºC'),
	(331103, 142, '2015-02-01 00:08:43.000000', 'temperatura', 1166.0000, 'ºC'),
	(331104, 142, '2015-02-01 00:08:44.000000', 'temperatura', 48.0000, 'ºC'),
	(331105, 142, '2015-02-01 00:08:45.000000', 'temperatura', 340.0000, 'ºC'),
	(331106, 142, '2015-02-01 00:08:46.000000', 'temperatura', 359.0000, 'ºC'),
	(331107, 142, '2015-02-01 00:08:47.000000', 'temperatura', 773.0000, 'ºC'),
	(331108, 142, '2015-02-01 00:08:48.000000', 'temperatura', 391.0000, 'ºC'),
	(331109, 142, '2015-02-01 00:08:49.000000', 'temperatura', 834.0000, 'ºC'),
	(331110, 142, '2015-02-01 00:08:50.000000', 'temperatura', 597.0000, 'ºC'),
	(331111, 142, '2015-02-01 00:08:51.000000', 'temperatura', 483.0000, 'ºC'),
	(331112, 142, '2015-02-01 00:08:52.000000', 'temperatura', 624.0000, 'ºC'),
	(331113, 142, '2015-02-01 00:08:53.000000', 'temperatura', 472.0000, 'ºC'),
	(331114, 142, '2015-02-01 00:08:54.000000', 'temperatura', 487.0000, 'ºC'),
	(331115, 142, '2015-02-01 00:08:55.000000', 'temperatura', 1021.0000, 'ºC'),
	(331116, 142, '2015-02-01 00:08:56.000000', 'temperatura', 42.0000, 'ºC'),
	(331117, 142, '2015-02-01 00:08:57.000000', 'temperatura', 750.0000, 'ºC'),
	(331118, 142, '2015-02-01 00:08:58.000000', 'temperatura', 26.0000, 'ºC'),
	(331119, 142, '2015-02-01 00:08:59.000000', 'temperatura', 279.0000, 'ºC'),
	(331120, 142, '2015-02-01 00:09:00.000000', 'temperatura', 116.0000, 'ºC'),
	(331121, 142, '2015-02-01 00:09:01.000000', 'temperatura', 943.0000, 'ºC'),
	(331122, 142, '2015-02-01 00:09:02.000000', 'temperatura', 769.0000, 'ºC'),
	(331123, 142, '2015-02-01 00:09:03.000000', 'temperatura', 1014.0000, 'ºC'),
	(331124, 142, '2015-02-01 00:09:04.000000', 'temperatura', 367.0000, 'ºC'),
	(331125, 142, '2015-02-01 00:09:05.000000', 'temperatura', 1192.0000, 'ºC'),
	(331126, 142, '2015-02-01 00:09:06.000000', 'temperatura', 58.0000, 'ºC'),
	(331127, 142, '2015-02-01 00:09:07.000000', 'temperatura', 315.0000, 'ºC'),
	(331128, 142, '2015-02-01 00:09:08.000000', 'temperatura', 201.0000, 'ºC'),
	(331129, 142, '2015-02-01 00:09:09.000000', 'temperatura', 63.0000, 'ºC'),
	(331130, 142, '2015-02-01 00:09:10.000000', 'temperatura', 910.0000, 'ºC'),
	(331131, 142, '2015-02-01 00:09:11.000000', 'temperatura', 763.0000, 'ºC'),
	(331132, 142, '2015-02-01 00:09:12.000000', 'temperatura', 1085.0000, 'ºC'),
	(331133, 142, '2015-02-01 00:09:13.000000', 'temperatura', 736.0000, 'ºC'),
	(331134, 142, '2015-02-01 00:09:14.000000', 'temperatura', 427.0000, 'ºC'),
	(331135, 142, '2015-02-01 00:09:15.000000', 'temperatura', 1128.0000, 'ºC'),
	(331136, 142, '2015-02-01 00:09:16.000000', 'temperatura', 758.0000, 'ºC'),
	(331137, 142, '2015-02-01 00:09:17.000000', 'temperatura', 407.0000, 'ºC'),
	(331138, 142, '2015-02-01 00:09:18.000000', 'temperatura', 961.0000, 'ºC'),
	(331139, 142, '2015-02-01 00:09:19.000000', 'temperatura', 1184.0000, 'ºC'),
	(331140, 142, '2015-02-01 00:09:20.000000', 'temperatura', 637.0000, 'ºC'),
	(331141, 142, '2015-02-01 00:09:21.000000', 'temperatura', 835.0000, 'ºC'),
	(331142, 142, '2015-02-01 00:09:22.000000', 'temperatura', 1064.0000, 'ºC'),
	(331143, 142, '2015-02-01 00:09:23.000000', 'temperatura', 415.0000, 'ºC'),
	(331144, 142, '2015-02-01 00:09:24.000000', 'temperatura', 82.0000, 'ºC'),
	(331145, 142, '2015-02-01 00:09:25.000000', 'temperatura', 367.0000, 'ºC'),
	(331146, 142, '2015-02-01 00:09:26.000000', 'temperatura', 389.0000, 'ºC'),
	(331147, 142, '2015-02-01 00:09:27.000000', 'temperatura', 845.0000, 'ºC'),
	(331148, 142, '2015-02-01 00:09:28.000000', 'temperatura', 659.0000, 'ºC'),
	(331149, 142, '2015-02-01 00:09:29.000000', 'temperatura', 760.0000, 'ºC'),
	(331150, 142, '2015-02-01 00:09:30.000000', 'temperatura', 623.0000, 'ºC'),
	(331151, 142, '2015-02-01 00:09:31.000000', 'temperatura', 835.0000, 'ºC'),
	(331152, 142, '2015-02-01 00:09:32.000000', 'temperatura', 1106.0000, 'ºC'),
	(331153, 142, '2015-02-01 00:09:33.000000', 'temperatura', 626.0000, 'ºC'),
	(331154, 142, '2015-02-01 00:09:34.000000', 'temperatura', 1012.0000, 'ºC'),
	(331155, 142, '2015-02-01 00:09:35.000000', 'temperatura', 781.0000, 'ºC'),
	(331156, 142, '2015-02-01 00:09:36.000000', 'temperatura', 871.0000, 'ºC'),
	(331157, 142, '2015-02-01 00:09:37.000000', 'temperatura', 812.0000, 'ºC'),
	(331158, 142, '2015-02-01 00:09:38.000000', 'temperatura', 249.0000, 'ºC'),
	(331159, 142, '2015-02-01 00:09:39.000000', 'temperatura', 9.0000, 'ºC'),
	(331160, 142, '2015-02-01 00:09:40.000000', 'temperatura', 498.0000, 'ºC'),
	(331161, 142, '2015-02-01 00:09:41.000000', 'temperatura', 63.0000, 'ºC'),
	(331162, 142, '2015-02-01 00:09:42.000000', 'temperatura', 20.0000, 'ºC'),
	(331163, 142, '2015-02-01 00:09:43.000000', 'temperatura', 1114.0000, 'ºC'),
	(331164, 142, '2015-02-01 00:09:44.000000', 'temperatura', 711.0000, 'ºC'),
	(331165, 142, '2015-02-01 00:09:45.000000', 'temperatura', 211.0000, 'ºC'),
	(331166, 142, '2015-02-01 00:09:46.000000', 'temperatura', 123.0000, 'ºC'),
	(331167, 142, '2015-02-01 00:09:47.000000', 'temperatura', 1181.0000, 'ºC'),
	(331168, 142, '2015-02-01 00:09:48.000000', 'temperatura', 740.0000, 'ºC'),
	(331169, 142, '2015-02-01 00:09:49.000000', 'temperatura', 155.0000, 'ºC'),
	(331170, 142, '2015-02-01 00:09:50.000000', 'temperatura', 958.0000, 'ºC'),
	(331171, 142, '2015-02-01 00:09:51.000000', 'temperatura', 725.0000, 'ºC'),
	(331172, 142, '2015-02-01 00:09:52.000000', 'temperatura', 750.0000, 'ºC'),
	(331173, 142, '2015-02-01 00:09:53.000000', 'temperatura', 377.0000, 'ºC'),
	(331174, 142, '2015-02-01 00:09:54.000000', 'temperatura', 836.0000, 'ºC'),
	(331175, 142, '2015-02-01 00:09:55.000000', 'temperatura', 650.0000, 'ºC'),
	(331176, 142, '2015-02-01 00:09:56.000000', 'temperatura', 740.0000, 'ºC'),
	(331177, 142, '2015-02-01 00:09:57.000000', 'temperatura', 550.0000, 'ºC'),
	(331178, 142, '2015-02-01 00:09:58.000000', 'temperatura', 530.0000, 'ºC'),
	(331179, 142, '2015-02-01 00:09:59.000000', 'temperatura', 1001.0000, 'ºC'),
	(331180, 142, '2015-02-01 00:10:00.000000', 'temperatura', 1015.0000, 'ºC'),
	(331181, 142, '2015-02-01 00:10:01.000000', 'temperatura', 873.0000, 'ºC'),
	(331182, 142, '2015-02-01 00:10:02.000000', 'temperatura', 123.0000, 'ºC'),
	(331183, 142, '2015-02-01 00:10:03.000000', 'temperatura', 393.0000, 'ºC'),
	(331184, 142, '2015-02-01 00:10:04.000000', 'temperatura', 400.0000, 'ºC'),
	(331185, 142, '2015-02-01 00:10:05.000000', 'temperatura', 819.0000, 'ºC'),
	(331186, 142, '2015-02-01 00:10:06.000000', 'temperatura', 496.0000, 'ºC'),
	(331187, 142, '2015-02-01 00:10:07.000000', 'temperatura', 24.0000, 'ºC'),
	(331188, 142, '2015-02-01 00:10:08.000000', 'temperatura', 1032.0000, 'ºC'),
	(331189, 142, '2015-02-01 00:10:09.000000', 'temperatura', 290.0000, 'ºC'),
	(331190, 142, '2015-02-01 00:10:10.000000', 'temperatura', 756.0000, 'ºC'),
	(331191, 142, '2015-02-01 00:10:11.000000', 'temperatura', 508.0000, 'ºC'),
	(331192, 142, '2015-02-01 00:10:12.000000', 'temperatura', 271.0000, 'ºC'),
	(331193, 142, '2015-02-01 00:10:13.000000', 'temperatura', 1034.0000, 'ºC'),
	(331194, 142, '2015-02-01 00:10:14.000000', 'temperatura', 755.0000, 'ºC'),
	(331195, 142, '2015-02-01 00:10:15.000000', 'temperatura', 673.0000, 'ºC'),
	(331196, 142, '2015-02-01 00:10:16.000000', 'temperatura', 1103.0000, 'ºC'),
	(331197, 142, '2015-02-01 00:10:17.000000', 'temperatura', 1095.0000, 'ºC'),
	(331198, 142, '2015-02-01 00:10:18.000000', 'temperatura', 969.0000, 'ºC'),
	(331199, 142, '2015-02-01 00:10:19.000000', 'temperatura', 359.0000, 'ºC'),
	(331200, 142, '2015-02-01 00:10:20.000000', 'temperatura', 88.0000, 'ºC'),
	(331201, 142, '2015-02-01 00:10:21.000000', 'temperatura', 562.0000, 'ºC'),
	(331202, 142, '2015-02-01 00:10:22.000000', 'temperatura', 148.0000, 'ºC'),
	(331203, 142, '2015-02-01 00:10:23.000000', 'temperatura', 253.0000, 'ºC'),
	(331204, 142, '2015-02-01 00:10:24.000000', 'temperatura', 822.0000, 'ºC'),
	(331205, 142, '2015-02-01 00:10:25.000000', 'temperatura', 951.0000, 'ºC'),
	(331206, 142, '2015-02-01 00:10:26.000000', 'temperatura', 1091.0000, 'ºC'),
	(331207, 142, '2015-02-01 00:10:27.000000', 'temperatura', 200.0000, 'ºC'),
	(331208, 142, '2015-02-01 00:10:28.000000', 'temperatura', 131.0000, 'ºC'),
	(331209, 142, '2015-02-01 00:10:29.000000', 'temperatura', 52.0000, 'ºC'),
	(331210, 142, '2015-02-01 00:10:30.000000', 'temperatura', 1070.0000, 'ºC'),
	(331211, 142, '2015-02-01 00:10:31.000000', 'temperatura', 395.0000, 'ºC'),
	(331212, 142, '2015-02-01 00:10:32.000000', 'temperatura', 1166.0000, 'ºC'),
	(331213, 142, '2015-02-01 00:10:33.000000', 'temperatura', 1043.0000, 'ºC'),
	(331214, 142, '2015-02-01 00:10:34.000000', 'temperatura', 520.0000, 'ºC'),
	(331215, 142, '2015-02-01 00:10:35.000000', 'temperatura', 669.0000, 'ºC'),
	(331216, 142, '2015-02-01 00:10:36.000000', 'temperatura', 589.0000, 'ºC'),
	(331217, 142, '2015-02-01 00:10:37.000000', 'temperatura', 935.0000, 'ºC'),
	(331218, 142, '2015-02-01 00:10:38.000000', 'temperatura', 511.0000, 'ºC'),
	(331219, 142, '2015-02-01 00:10:39.000000', 'temperatura', 951.0000, 'ºC'),
	(331220, 142, '2015-02-01 00:10:40.000000', 'temperatura', 822.0000, 'ºC'),
	(331221, 142, '2015-02-01 00:10:41.000000', 'temperatura', 59.0000, 'ºC'),
	(331222, 142, '2015-02-01 00:10:42.000000', 'temperatura', 228.0000, 'ºC'),
	(331223, 142, '2015-02-01 00:10:43.000000', 'temperatura', 962.0000, 'ºC'),
	(331224, 142, '2015-02-01 00:10:44.000000', 'temperatura', 526.0000, 'ºC'),
	(331225, 142, '2015-02-01 00:10:45.000000', 'temperatura', 944.0000, 'ºC'),
	(331226, 142, '2015-02-01 00:10:46.000000', 'temperatura', 744.0000, 'ºC'),
	(331227, 142, '2015-02-01 00:10:47.000000', 'temperatura', 887.0000, 'ºC'),
	(331228, 142, '2015-02-01 00:10:48.000000', 'temperatura', 1005.0000, 'ºC'),
	(331229, 142, '2015-02-01 00:10:49.000000', 'temperatura', 1166.0000, 'ºC'),
	(331230, 142, '2015-02-01 00:10:50.000000', 'temperatura', 414.0000, 'ºC'),
	(331231, 142, '2015-02-01 00:10:51.000000', 'temperatura', 971.0000, 'ºC'),
	(331232, 142, '2015-02-01 00:10:52.000000', 'temperatura', 14.0000, 'ºC'),
	(331233, 142, '2015-02-01 00:10:53.000000', 'temperatura', 756.0000, 'ºC'),
	(331234, 142, '2015-02-01 00:10:54.000000', 'temperatura', 142.0000, 'ºC'),
	(331235, 142, '2015-02-01 00:10:55.000000', 'temperatura', 841.0000, 'ºC'),
	(331236, 142, '2015-02-01 00:10:56.000000', 'temperatura', 179.0000, 'ºC'),
	(331237, 142, '2015-02-01 00:10:57.000000', 'temperatura', 774.0000, 'ºC'),
	(331238, 142, '2015-02-01 00:10:58.000000', 'temperatura', 932.0000, 'ºC'),
	(331239, 142, '2015-02-01 00:10:59.000000', 'temperatura', 1141.0000, 'ºC'),
	(331240, 142, '2015-02-01 00:11:00.000000', 'temperatura', 509.0000, 'ºC'),
	(331241, 142, '2015-02-01 00:11:01.000000', 'temperatura', 320.0000, 'ºC'),
	(331242, 142, '2015-02-01 00:11:02.000000', 'temperatura', 75.0000, 'ºC'),
	(331243, 142, '2015-02-01 00:11:03.000000', 'temperatura', 615.0000, 'ºC'),
	(331244, 142, '2015-02-01 00:11:04.000000', 'temperatura', 450.0000, 'ºC'),
	(331245, 142, '2015-02-01 00:11:05.000000', 'temperatura', 404.0000, 'ºC'),
	(331246, 142, '2015-02-01 00:11:06.000000', 'temperatura', 672.0000, 'ºC'),
	(331247, 142, '2015-02-01 00:11:07.000000', 'temperatura', 947.0000, 'ºC'),
	(331248, 142, '2015-02-01 00:11:08.000000', 'temperatura', 318.0000, 'ºC'),
	(331249, 142, '2015-02-01 00:11:09.000000', 'temperatura', 1153.0000, 'ºC'),
	(331250, 142, '2015-02-01 00:11:10.000000', 'temperatura', 10.0000, 'ºC'),
	(331251, 142, '2015-02-01 00:11:11.000000', 'temperatura', 190.0000, 'ºC'),
	(331252, 142, '2015-02-01 00:11:12.000000', 'temperatura', 920.0000, 'ºC'),
	(331253, 142, '2015-02-01 00:11:13.000000', 'temperatura', 432.0000, 'ºC'),
	(331254, 142, '2015-02-01 00:11:14.000000', 'temperatura', 601.0000, 'ºC'),
	(331255, 142, '2015-02-01 00:11:15.000000', 'temperatura', 511.0000, 'ºC'),
	(331256, 142, '2015-02-01 00:11:16.000000', 'temperatura', 750.0000, 'ºC'),
	(331257, 142, '2015-02-01 00:11:17.000000', 'temperatura', 1020.0000, 'ºC'),
	(331258, 142, '2015-02-01 00:11:18.000000', 'temperatura', 449.0000, 'ºC'),
	(331259, 142, '2015-02-01 00:11:19.000000', 'temperatura', 385.0000, 'ºC'),
	(331260, 142, '2015-02-01 00:11:20.000000', 'temperatura', 578.0000, 'ºC'),
	(331261, 142, '2015-02-01 00:11:21.000000', 'temperatura', 535.0000, 'ºC'),
	(331262, 142, '2015-02-01 00:11:22.000000', 'temperatura', 944.0000, 'ºC'),
	(331263, 142, '2015-02-01 00:11:23.000000', 'temperatura', 716.0000, 'ºC'),
	(331264, 142, '2015-02-01 00:11:24.000000', 'temperatura', 748.0000, 'ºC'),
	(331265, 142, '2015-02-01 00:11:25.000000', 'temperatura', 393.0000, 'ºC'),
	(331266, 142, '2015-02-01 00:11:26.000000', 'temperatura', 921.0000, 'ºC'),
	(331267, 142, '2015-02-01 00:11:27.000000', 'temperatura', 1026.0000, 'ºC'),
	(331268, 142, '2015-02-01 00:11:28.000000', 'temperatura', 1167.0000, 'ºC'),
	(331269, 142, '2015-02-01 00:11:29.000000', 'temperatura', 356.0000, 'ºC'),
	(331270, 142, '2015-02-01 00:11:30.000000', 'temperatura', 681.0000, 'ºC'),
	(331271, 142, '2015-02-01 00:11:31.000000', 'temperatura', 1136.0000, 'ºC'),
	(331272, 142, '2015-02-01 00:11:32.000000', 'temperatura', 39.0000, 'ºC'),
	(331273, 142, '2015-02-01 00:11:33.000000', 'temperatura', 386.0000, 'ºC'),
	(331274, 142, '2015-02-01 00:11:34.000000', 'temperatura', 616.0000, 'ºC'),
	(331275, 142, '2015-02-01 00:11:35.000000', 'temperatura', 723.0000, 'ºC'),
	(331276, 142, '2015-02-01 00:11:36.000000', 'temperatura', 565.0000, 'ºC'),
	(331277, 142, '2015-02-01 00:11:37.000000', 'temperatura', 659.0000, 'ºC'),
	(331278, 142, '2015-02-01 00:11:38.000000', 'temperatura', 397.0000, 'ºC'),
	(331279, 142, '2015-02-01 00:11:39.000000', 'temperatura', 11.0000, 'ºC'),
	(331280, 142, '2015-02-01 00:11:40.000000', 'temperatura', 65.0000, 'ºC'),
	(331281, 142, '2015-02-01 00:11:41.000000', 'temperatura', 292.0000, 'ºC'),
	(331282, 142, '2015-02-01 00:11:42.000000', 'temperatura', 66.0000, 'ºC'),
	(331283, 142, '2015-02-01 00:11:43.000000', 'temperatura', 653.0000, 'ºC'),
	(331284, 142, '2015-02-01 00:11:44.000000', 'temperatura', 669.0000, 'ºC'),
	(331285, 142, '2015-02-01 00:11:45.000000', 'temperatura', 187.0000, 'ºC'),
	(331286, 142, '2015-02-01 00:11:46.000000', 'temperatura', 129.0000, 'ºC'),
	(331287, 142, '2015-02-01 00:11:47.000000', 'temperatura', 86.0000, 'ºC'),
	(331288, 142, '2015-02-01 00:11:48.000000', 'temperatura', 40.0000, 'ºC'),
	(331289, 142, '2015-02-01 00:11:49.000000', 'temperatura', 1144.0000, 'ºC'),
	(331290, 142, '2015-02-01 00:11:50.000000', 'temperatura', 799.0000, 'ºC'),
	(331291, 142, '2015-02-01 00:11:51.000000', 'temperatura', 565.0000, 'ºC'),
	(331292, 142, '2015-02-01 00:11:52.000000', 'temperatura', 427.0000, 'ºC'),
	(331293, 142, '2015-02-01 00:11:53.000000', 'temperatura', 439.0000, 'ºC'),
	(331294, 142, '2015-02-01 00:11:54.000000', 'temperatura', 918.0000, 'ºC'),
	(331295, 142, '2015-02-01 00:11:55.000000', 'temperatura', 872.0000, 'ºC'),
	(331296, 142, '2015-02-01 00:11:56.000000', 'temperatura', 406.0000, 'ºC'),
	(331297, 142, '2015-02-01 00:11:57.000000', 'temperatura', 613.0000, 'ºC'),
	(331298, 142, '2015-02-01 00:11:58.000000', 'temperatura', 650.0000, 'ºC'),
	(331299, 142, '2015-02-01 00:11:59.000000', 'temperatura', 213.0000, 'ºC'),
	(331300, 142, '2015-02-01 00:12:00.000000', 'temperatura', 312.0000, 'ºC'),
	(331301, 142, '2015-02-01 00:12:01.000000', 'temperatura', 923.0000, 'ºC'),
	(331302, 142, '2015-02-01 00:12:02.000000', 'temperatura', 79.0000, 'ºC'),
	(331303, 142, '2015-02-01 00:12:03.000000', 'temperatura', 27.0000, 'ºC'),
	(331304, 142, '2015-02-01 00:12:04.000000', 'temperatura', 1099.0000, 'ºC'),
	(331305, 142, '2015-02-01 00:12:05.000000', 'temperatura', 616.0000, 'ºC'),
	(331306, 142, '2015-02-01 00:12:06.000000', 'temperatura', 981.0000, 'ºC'),
	(331307, 142, '2015-02-01 00:12:07.000000', 'temperatura', 657.0000, 'ºC'),
	(331308, 142, '2015-02-01 00:12:08.000000', 'temperatura', 341.0000, 'ºC'),
	(331309, 142, '2015-02-01 00:12:09.000000', 'temperatura', 937.0000, 'ºC'),
	(331310, 142, '2015-02-01 00:12:10.000000', 'temperatura', 63.0000, 'ºC'),
	(331311, 142, '2015-02-01 00:12:11.000000', 'temperatura', 1104.0000, 'ºC'),
	(331312, 142, '2015-02-01 00:12:12.000000', 'temperatura', 532.0000, 'ºC'),
	(331313, 142, '2015-02-01 00:12:13.000000', 'temperatura', 549.0000, 'ºC'),
	(331314, 142, '2015-02-01 00:12:14.000000', 'temperatura', 1148.0000, 'ºC'),
	(331315, 142, '2015-02-01 00:12:15.000000', 'temperatura', 496.0000, 'ºC'),
	(331316, 142, '2015-02-01 00:12:16.000000', 'temperatura', 236.0000, 'ºC'),
	(331317, 142, '2015-02-01 00:12:17.000000', 'temperatura', 892.0000, 'ºC'),
	(331318, 142, '2015-02-01 00:12:18.000000', 'temperatura', 151.0000, 'ºC'),
	(331319, 142, '2015-02-01 00:12:19.000000', 'temperatura', 480.0000, 'ºC'),
	(331320, 142, '2015-02-01 00:12:20.000000', 'temperatura', 748.0000, 'ºC'),
	(331321, 142, '2015-02-01 00:12:21.000000', 'temperatura', 1100.0000, 'ºC'),
	(331322, 142, '2015-02-01 00:12:22.000000', 'temperatura', 859.0000, 'ºC'),
	(331323, 142, '2015-02-01 00:12:23.000000', 'temperatura', 992.0000, 'ºC'),
	(331324, 142, '2015-02-01 00:12:24.000000', 'temperatura', 1187.0000, 'ºC'),
	(331325, 142, '2015-02-01 00:12:25.000000', 'temperatura', 558.0000, 'ºC'),
	(331326, 142, '2015-02-01 00:12:26.000000', 'temperatura', 428.0000, 'ºC'),
	(331327, 142, '2015-02-01 00:12:27.000000', 'temperatura', 466.0000, 'ºC'),
	(331328, 142, '2015-02-01 00:12:28.000000', 'temperatura', 1048.0000, 'ºC'),
	(331329, 142, '2015-02-01 00:12:29.000000', 'temperatura', 244.0000, 'ºC'),
	(331330, 142, '2015-02-01 00:12:30.000000', 'temperatura', 476.0000, 'ºC'),
	(331331, 142, '2015-02-01 00:12:31.000000', 'temperatura', 447.0000, 'ºC'),
	(331332, 142, '2015-02-01 00:12:32.000000', 'temperatura', 808.0000, 'ºC'),
	(331333, 142, '2015-02-01 00:12:33.000000', 'temperatura', 299.0000, 'ºC'),
	(331334, 142, '2015-02-01 00:12:34.000000', 'temperatura', 272.0000, 'ºC'),
	(331335, 142, '2015-02-01 00:12:35.000000', 'temperatura', 465.0000, 'ºC'),
	(331336, 142, '2015-02-01 00:12:36.000000', 'temperatura', 307.0000, 'ºC'),
	(331337, 142, '2015-02-01 00:12:37.000000', 'temperatura', 141.0000, 'ºC'),
	(331338, 142, '2015-02-01 00:12:38.000000', 'temperatura', 983.0000, 'ºC'),
	(331339, 142, '2015-02-01 00:12:39.000000', 'temperatura', 895.0000, 'ºC'),
	(331340, 142, '2015-02-01 00:12:40.000000', 'temperatura', 325.0000, 'ºC'),
	(331341, 142, '2015-02-01 00:12:41.000000', 'temperatura', 142.0000, 'ºC'),
	(331342, 142, '2015-02-01 00:12:42.000000', 'temperatura', 933.0000, 'ºC'),
	(331343, 142, '2015-02-01 00:12:43.000000', 'temperatura', 639.0000, 'ºC'),
	(331344, 142, '2015-02-01 00:12:44.000000', 'temperatura', 399.0000, 'ºC'),
	(331345, 142, '2015-02-01 00:12:45.000000', 'temperatura', 78.0000, 'ºC'),
	(331346, 142, '2015-02-01 00:12:46.000000', 'temperatura', 392.0000, 'ºC'),
	(331347, 142, '2015-02-01 00:12:47.000000', 'temperatura', 526.0000, 'ºC'),
	(331348, 142, '2015-02-01 00:12:48.000000', 'temperatura', 256.0000, 'ºC'),
	(331349, 142, '2015-02-01 00:12:49.000000', 'temperatura', 902.0000, 'ºC'),
	(331350, 142, '2015-02-01 00:12:50.000000', 'temperatura', 144.0000, 'ºC'),
	(331351, 142, '2015-02-01 00:12:51.000000', 'temperatura', 415.0000, 'ºC'),
	(331352, 142, '2015-02-01 00:12:52.000000', 'temperatura', 444.0000, 'ºC'),
	(331353, 142, '2015-02-01 00:12:53.000000', 'temperatura', 976.0000, 'ºC'),
	(331354, 142, '2015-02-01 00:12:54.000000', 'temperatura', 1147.0000, 'ºC'),
	(331355, 142, '2015-02-01 00:12:55.000000', 'temperatura', 409.0000, 'ºC'),
	(331356, 142, '2015-02-01 00:12:56.000000', 'temperatura', 1004.0000, 'ºC'),
	(331357, 142, '2015-02-01 00:12:57.000000', 'temperatura', 195.0000, 'ºC'),
	(331358, 142, '2015-02-01 00:12:58.000000', 'temperatura', 362.0000, 'ºC'),
	(331359, 142, '2015-02-01 00:12:59.000000', 'temperatura', 26.0000, 'ºC'),
	(331360, 142, '2015-02-01 00:13:00.000000', 'temperatura', 244.0000, 'ºC'),
	(331361, 142, '2015-02-01 00:13:01.000000', 'temperatura', 1143.0000, 'ºC'),
	(331362, 142, '2015-02-01 00:13:02.000000', 'temperatura', 184.0000, 'ºC'),
	(331363, 142, '2015-02-01 00:13:03.000000', 'temperatura', 1090.0000, 'ºC'),
	(331364, 142, '2015-02-01 00:13:04.000000', 'temperatura', 99.0000, 'ºC'),
	(331365, 142, '2015-02-01 00:13:05.000000', 'temperatura', 825.0000, 'ºC'),
	(331366, 142, '2015-02-01 00:13:06.000000', 'temperatura', 229.0000, 'ºC'),
	(331367, 142, '2015-02-01 00:13:07.000000', 'temperatura', 1072.0000, 'ºC'),
	(331368, 142, '2015-02-01 00:13:08.000000', 'temperatura', 1073.0000, 'ºC'),
	(331369, 142, '2015-02-01 00:13:09.000000', 'temperatura', 949.0000, 'ºC'),
	(331370, 142, '2015-02-01 00:13:10.000000', 'temperatura', 328.0000, 'ºC'),
	(331371, 142, '2015-02-01 00:13:11.000000', 'temperatura', 1191.0000, 'ºC'),
	(331372, 142, '2015-02-01 00:13:12.000000', 'temperatura', 172.0000, 'ºC'),
	(331373, 142, '2015-02-01 00:13:13.000000', 'temperatura', 889.0000, 'ºC'),
	(331374, 142, '2015-02-01 00:13:14.000000', 'temperatura', 330.0000, 'ºC'),
	(331375, 142, '2015-02-01 00:13:15.000000', 'temperatura', 182.0000, 'ºC'),
	(331376, 142, '2015-02-01 00:13:16.000000', 'temperatura', 1119.0000, 'ºC'),
	(331377, 142, '2015-02-01 00:13:17.000000', 'temperatura', 251.0000, 'ºC'),
	(331378, 142, '2015-02-01 00:13:18.000000', 'temperatura', 297.0000, 'ºC'),
	(331379, 142, '2015-02-01 00:13:19.000000', 'temperatura', 732.0000, 'ºC'),
	(331380, 142, '2015-02-01 00:13:20.000000', 'temperatura', 371.0000, 'ºC'),
	(331381, 142, '2015-02-01 00:13:21.000000', 'temperatura', 861.0000, 'ºC'),
	(331382, 142, '2015-02-01 00:13:22.000000', 'temperatura', 791.0000, 'ºC'),
	(331383, 142, '2015-02-01 00:13:23.000000', 'temperatura', 174.0000, 'ºC'),
	(331384, 142, '2015-02-01 00:13:24.000000', 'temperatura', 895.0000, 'ºC'),
	(331385, 142, '2015-02-01 00:13:25.000000', 'temperatura', 356.0000, 'ºC'),
	(331386, 142, '2015-02-01 00:13:26.000000', 'temperatura', 296.0000, 'ºC'),
	(331387, 142, '2015-02-01 00:13:27.000000', 'temperatura', 412.0000, 'ºC'),
	(331388, 142, '2015-02-01 00:13:28.000000', 'temperatura', 1173.0000, 'ºC'),
	(331389, 142, '2015-02-01 00:13:29.000000', 'temperatura', 1028.0000, 'ºC'),
	(331390, 142, '2015-02-01 00:13:30.000000', 'temperatura', 421.0000, 'ºC'),
	(331391, 142, '2015-02-01 00:13:31.000000', 'temperatura', 223.0000, 'ºC'),
	(331392, 142, '2015-02-01 00:13:32.000000', 'temperatura', 1052.0000, 'ºC'),
	(331393, 142, '2015-02-01 00:13:33.000000', 'temperatura', 990.0000, 'ºC'),
	(331394, 142, '2015-02-01 00:13:34.000000', 'temperatura', 594.0000, 'ºC'),
	(331395, 142, '2015-02-01 00:13:35.000000', 'temperatura', 2.0000, 'ºC'),
	(331396, 142, '2015-02-01 00:13:36.000000', 'temperatura', 628.0000, 'ºC'),
	(331397, 142, '2015-02-01 00:13:37.000000', 'temperatura', 736.0000, 'ºC'),
	(331398, 142, '2015-02-01 00:13:38.000000', 'temperatura', 597.0000, 'ºC'),
	(331399, 142, '2015-02-01 00:13:39.000000', 'temperatura', 776.0000, 'ºC'),
	(331400, 142, '2015-02-01 00:13:40.000000', 'temperatura', 889.0000, 'ºC'),
	(331401, 142, '2015-02-01 00:13:41.000000', 'temperatura', 917.0000, 'ºC'),
	(331402, 142, '2015-02-01 00:13:42.000000', 'temperatura', 720.0000, 'ºC'),
	(331403, 142, '2015-02-01 00:13:43.000000', 'temperatura', 847.0000, 'ºC'),
	(331404, 142, '2015-02-01 00:13:44.000000', 'temperatura', 879.0000, 'ºC'),
	(331405, 142, '2015-02-01 00:13:45.000000', 'temperatura', 652.0000, 'ºC'),
	(331406, 142, '2015-02-01 00:13:46.000000', 'temperatura', 625.0000, 'ºC'),
	(331407, 142, '2015-02-01 00:13:47.000000', 'temperatura', 1169.0000, 'ºC'),
	(331408, 142, '2015-02-01 00:13:48.000000', 'temperatura', 369.0000, 'ºC'),
	(331409, 142, '2015-02-01 00:13:49.000000', 'temperatura', 738.0000, 'ºC'),
	(331410, 142, '2015-02-01 00:13:50.000000', 'temperatura', 186.0000, 'ºC'),
	(331411, 142, '2015-02-01 00:13:51.000000', 'temperatura', 1114.0000, 'ºC'),
	(331412, 142, '2015-02-01 00:13:52.000000', 'temperatura', 212.0000, 'ºC'),
	(331413, 142, '2015-02-01 00:13:53.000000', 'temperatura', 119.0000, 'ºC'),
	(331414, 142, '2015-02-01 00:13:54.000000', 'temperatura', 1160.0000, 'ºC'),
	(331415, 142, '2015-02-01 00:13:55.000000', 'temperatura', 642.0000, 'ºC'),
	(331416, 142, '2015-02-01 00:13:56.000000', 'temperatura', 934.0000, 'ºC'),
	(331417, 142, '2015-02-01 00:13:57.000000', 'temperatura', 341.0000, 'ºC'),
	(331418, 142, '2015-02-01 00:13:58.000000', 'temperatura', 104.0000, 'ºC'),
	(331419, 142, '2015-02-01 00:13:59.000000', 'temperatura', 700.0000, 'ºC'),
	(331420, 142, '2015-02-01 00:14:00.000000', 'temperatura', 788.0000, 'ºC'),
	(331421, 142, '2015-02-01 00:14:01.000000', 'temperatura', 638.0000, 'ºC'),
	(331422, 142, '2015-02-01 00:14:02.000000', 'temperatura', 828.0000, 'ºC'),
	(331423, 142, '2015-02-01 00:14:03.000000', 'temperatura', 1026.0000, 'ºC'),
	(331424, 142, '2015-02-01 00:14:04.000000', 'temperatura', 246.0000, 'ºC'),
	(331425, 142, '2015-02-01 00:14:05.000000', 'temperatura', 553.0000, 'ºC'),
	(331426, 142, '2015-02-01 00:14:06.000000', 'temperatura', 827.0000, 'ºC'),
	(331427, 142, '2015-02-01 00:14:07.000000', 'temperatura', 79.0000, 'ºC'),
	(331428, 142, '2015-02-01 00:14:08.000000', 'temperatura', 313.0000, 'ºC'),
	(331429, 142, '2015-02-01 00:14:09.000000', 'temperatura', 127.0000, 'ºC'),
	(331430, 142, '2015-02-01 00:14:10.000000', 'temperatura', 898.0000, 'ºC'),
	(331431, 142, '2015-02-01 00:14:11.000000', 'temperatura', 508.0000, 'ºC'),
	(331432, 142, '2015-02-01 00:14:12.000000', 'temperatura', 1047.0000, 'ºC'),
	(331433, 142, '2015-02-01 00:14:13.000000', 'temperatura', 114.0000, 'ºC'),
	(331434, 142, '2015-02-01 00:14:14.000000', 'temperatura', 1027.0000, 'ºC'),
	(331435, 142, '2015-02-01 00:14:15.000000', 'temperatura', 1194.0000, 'ºC'),
	(331436, 142, '2015-02-01 00:14:16.000000', 'temperatura', 491.0000, 'ºC'),
	(331437, 142, '2015-02-01 00:14:17.000000', 'temperatura', 73.0000, 'ºC'),
	(331438, 142, '2015-02-01 00:14:18.000000', 'temperatura', 90.0000, 'ºC'),
	(331439, 142, '2015-02-01 00:14:19.000000', 'temperatura', 234.0000, 'ºC'),
	(331440, 142, '2015-02-01 00:14:20.000000', 'temperatura', 899.0000, 'ºC'),
	(331441, 142, '2015-02-01 00:14:21.000000', 'temperatura', 195.0000, 'ºC'),
	(331442, 142, '2015-02-01 00:14:22.000000', 'temperatura', 680.0000, 'ºC'),
	(331443, 142, '2015-02-01 00:14:23.000000', 'temperatura', 414.0000, 'ºC'),
	(331444, 142, '2015-02-01 00:14:24.000000', 'temperatura', 30.0000, 'ºC'),
	(331445, 142, '2015-02-01 00:14:25.000000', 'temperatura', 107.0000, 'ºC'),
	(331446, 142, '2015-02-01 00:14:26.000000', 'temperatura', 446.0000, 'ºC'),
	(331447, 142, '2015-02-01 00:14:27.000000', 'temperatura', 711.0000, 'ºC'),
	(331448, 142, '2015-02-01 00:14:28.000000', 'temperatura', 1015.0000, 'ºC'),
	(331449, 142, '2015-02-01 00:14:29.000000', 'temperatura', 544.0000, 'ºC'),
	(331450, 142, '2015-02-01 00:14:30.000000', 'temperatura', 874.0000, 'ºC'),
	(331451, 142, '2015-02-01 00:14:31.000000', 'temperatura', 342.0000, 'ºC'),
	(331452, 142, '2015-02-01 00:14:32.000000', 'temperatura', 285.0000, 'ºC'),
	(331453, 142, '2015-02-01 00:14:33.000000', 'temperatura', 400.0000, 'ºC'),
	(331454, 142, '2015-02-01 00:14:34.000000', 'temperatura', 1145.0000, 'ºC'),
	(331455, 142, '2015-02-01 00:14:35.000000', 'temperatura', 926.0000, 'ºC'),
	(331456, 142, '2015-02-01 00:14:36.000000', 'temperatura', 1194.0000, 'ºC'),
	(331457, 142, '2015-02-01 00:14:37.000000', 'temperatura', 793.0000, 'ºC'),
	(331458, 142, '2015-02-01 00:14:38.000000', 'temperatura', 383.0000, 'ºC'),
	(331459, 142, '2015-02-01 00:14:39.000000', 'temperatura', 736.0000, 'ºC'),
	(331460, 142, '2015-02-01 00:14:40.000000', 'temperatura', 131.0000, 'ºC'),
	(331461, 142, '2015-02-01 00:14:41.000000', 'temperatura', 847.0000, 'ºC'),
	(331462, 142, '2015-02-01 00:14:42.000000', 'temperatura', 242.0000, 'ºC'),
	(331463, 142, '2015-02-01 00:14:43.000000', 'temperatura', 1072.0000, 'ºC'),
	(331464, 142, '2015-02-01 00:14:44.000000', 'temperatura', 1035.0000, 'ºC'),
	(331465, 142, '2015-02-01 00:14:45.000000', 'temperatura', 760.0000, 'ºC'),
	(331466, 142, '2015-02-01 00:14:46.000000', 'temperatura', 694.0000, 'ºC'),
	(331467, 142, '2015-02-01 00:14:47.000000', 'temperatura', 1191.0000, 'ºC'),
	(331468, 142, '2015-02-01 00:14:48.000000', 'temperatura', 274.0000, 'ºC'),
	(331469, 142, '2015-02-01 00:14:49.000000', 'temperatura', 198.0000, 'ºC'),
	(331470, 142, '2015-02-01 00:14:50.000000', 'temperatura', 166.0000, 'ºC'),
	(331471, 142, '2015-02-01 00:14:51.000000', 'temperatura', 239.0000, 'ºC'),
	(331472, 142, '2015-02-01 00:14:52.000000', 'temperatura', 695.0000, 'ºC'),
	(331473, 142, '2015-02-01 00:14:53.000000', 'temperatura', 361.0000, 'ºC'),
	(331474, 142, '2015-02-01 00:14:54.000000', 'temperatura', 920.0000, 'ºC'),
	(331475, 142, '2015-02-01 00:14:55.000000', 'temperatura', 1119.0000, 'ºC'),
	(331476, 142, '2015-02-01 00:14:56.000000', 'temperatura', 435.0000, 'ºC'),
	(331477, 142, '2015-02-01 00:14:57.000000', 'temperatura', 18.0000, 'ºC'),
	(331478, 142, '2015-02-01 00:14:58.000000', 'temperatura', 1184.0000, 'ºC'),
	(331479, 142, '2015-02-01 00:14:59.000000', 'temperatura', 1068.0000, 'ºC'),
	(331480, 142, '2015-02-01 00:15:00.000000', 'temperatura', 587.0000, 'ºC'),
	(331481, 142, '2015-02-01 00:15:01.000000', 'temperatura', 934.0000, 'ºC'),
	(331482, 142, '2015-02-01 00:15:02.000000', 'temperatura', 508.0000, 'ºC'),
	(331483, 142, '2015-02-01 00:15:03.000000', 'temperatura', 939.0000, 'ºC'),
	(331484, 142, '2015-02-01 00:15:04.000000', 'temperatura', 771.0000, 'ºC'),
	(331485, 142, '2015-02-01 00:15:05.000000', 'temperatura', 1038.0000, 'ºC'),
	(331486, 142, '2015-02-01 00:15:06.000000', 'temperatura', 477.0000, 'ºC'),
	(331487, 142, '2015-02-01 00:15:07.000000', 'temperatura', 474.0000, 'ºC'),
	(331488, 142, '2015-02-01 00:15:08.000000', 'temperatura', 939.0000, 'ºC'),
	(331489, 142, '2015-02-01 00:15:09.000000', 'temperatura', 872.0000, 'ºC'),
	(331490, 142, '2015-02-01 00:15:10.000000', 'temperatura', 345.0000, 'ºC'),
	(331491, 142, '2015-02-01 00:15:11.000000', 'temperatura', 308.0000, 'ºC'),
	(331492, 142, '2015-02-01 00:15:12.000000', 'temperatura', 507.0000, 'ºC'),
	(331493, 142, '2015-02-01 00:15:13.000000', 'temperatura', 412.0000, 'ºC'),
	(331494, 142, '2015-02-01 00:15:14.000000', 'temperatura', 539.0000, 'ºC'),
	(331495, 142, '2015-02-01 00:15:15.000000', 'temperatura', 260.0000, 'ºC'),
	(331496, 142, '2015-02-01 00:15:16.000000', 'temperatura', 882.0000, 'ºC'),
	(331497, 142, '2015-02-01 00:15:17.000000', 'temperatura', 32.0000, 'ºC'),
	(331498, 142, '2015-02-01 00:15:18.000000', 'temperatura', 1113.0000, 'ºC'),
	(331499, 142, '2015-02-01 00:15:19.000000', 'temperatura', 671.0000, 'ºC'),
	(331500, 142, '2015-02-01 00:15:20.000000', 'temperatura', 17.0000, 'ºC'),
	(331501, 142, '2015-02-01 00:15:21.000000', 'temperatura', 472.0000, 'ºC'),
	(331502, 142, '2015-02-01 00:15:22.000000', 'temperatura', 1111.0000, 'ºC'),
	(331503, 142, '2015-02-01 00:15:23.000000', 'temperatura', 537.0000, 'ºC'),
	(331504, 142, '2015-02-01 00:15:24.000000', 'temperatura', 553.0000, 'ºC'),
	(331505, 142, '2015-02-01 00:15:25.000000', 'temperatura', 1154.0000, 'ºC'),
	(331506, 142, '2015-02-01 00:15:26.000000', 'temperatura', 514.0000, 'ºC'),
	(331507, 142, '2015-02-01 00:15:27.000000', 'temperatura', 307.0000, 'ºC'),
	(331508, 142, '2015-02-01 00:15:28.000000', 'temperatura', 1196.0000, 'ºC'),
	(331509, 142, '2015-02-01 00:15:29.000000', 'temperatura', 256.0000, 'ºC'),
	(331510, 142, '2015-02-01 00:15:30.000000', 'temperatura', 95.0000, 'ºC'),
	(331511, 142, '2015-02-01 00:15:31.000000', 'temperatura', 907.0000, 'ºC'),
	(331512, 142, '2015-02-01 00:15:32.000000', 'temperatura', 648.0000, 'ºC'),
	(331513, 142, '2015-02-01 00:15:33.000000', 'temperatura', 522.0000, 'ºC'),
	(331514, 142, '2015-02-01 00:15:34.000000', 'temperatura', 665.0000, 'ºC'),
	(331515, 142, '2015-02-01 00:15:35.000000', 'temperatura', 560.0000, 'ºC'),
	(331516, 142, '2015-02-01 00:15:36.000000', 'temperatura', 807.0000, 'ºC'),
	(331517, 142, '2015-02-01 00:15:37.000000', 'temperatura', 1154.0000, 'ºC'),
	(331518, 142, '2015-02-01 00:15:38.000000', 'temperatura', 948.0000, 'ºC'),
	(331519, 142, '2015-02-01 00:15:39.000000', 'temperatura', 79.0000, 'ºC'),
	(331520, 142, '2015-02-01 00:15:40.000000', 'temperatura', 1150.0000, 'ºC'),
	(331521, 142, '2015-02-01 00:15:41.000000', 'temperatura', 717.0000, 'ºC'),
	(331522, 142, '2015-02-01 00:15:42.000000', 'temperatura', 132.0000, 'ºC'),
	(331523, 142, '2015-02-01 00:15:43.000000', 'temperatura', 913.0000, 'ºC'),
	(331524, 142, '2015-02-01 00:15:44.000000', 'temperatura', 566.0000, 'ºC'),
	(331525, 142, '2015-02-01 00:15:45.000000', 'temperatura', 94.0000, 'ºC'),
	(331526, 142, '2015-02-01 00:15:46.000000', 'temperatura', 1172.0000, 'ºC'),
	(331527, 142, '2015-02-01 00:15:47.000000', 'temperatura', 778.0000, 'ºC'),
	(331528, 142, '2015-02-01 00:15:48.000000', 'temperatura', 374.0000, 'ºC'),
	(331529, 142, '2015-02-01 00:15:49.000000', 'temperatura', 735.0000, 'ºC'),
	(331530, 142, '2015-02-01 00:15:50.000000', 'temperatura', 156.0000, 'ºC'),
	(331531, 142, '2015-02-01 00:15:51.000000', 'temperatura', 974.0000, 'ºC'),
	(331532, 142, '2015-02-01 00:15:52.000000', 'temperatura', 804.0000, 'ºC'),
	(331533, 142, '2015-02-01 00:15:53.000000', 'temperatura', 1097.0000, 'ºC'),
	(331534, 142, '2015-02-01 00:15:54.000000', 'temperatura', 673.0000, 'ºC'),
	(331535, 142, '2015-02-01 00:15:55.000000', 'temperatura', 74.0000, 'ºC'),
	(331536, 142, '2015-02-01 00:15:56.000000', 'temperatura', 753.0000, 'ºC'),
	(331537, 142, '2015-02-01 00:15:57.000000', 'temperatura', 1143.0000, 'ºC'),
	(331538, 142, '2015-02-01 00:15:58.000000', 'temperatura', 1057.0000, 'ºC'),
	(331539, 142, '2015-02-01 00:15:59.000000', 'temperatura', 655.0000, 'ºC'),
	(331540, 142, '2015-02-01 00:16:00.000000', 'temperatura', 105.0000, 'ºC'),
	(331541, 142, '2015-02-01 00:16:01.000000', 'temperatura', 960.0000, 'ºC'),
	(331542, 142, '2015-02-01 00:16:02.000000', 'temperatura', 887.0000, 'ºC'),
	(331543, 142, '2015-02-01 00:16:03.000000', 'temperatura', 357.0000, 'ºC'),
	(331544, 142, '2015-02-01 00:16:04.000000', 'temperatura', 321.0000, 'ºC'),
	(331545, 142, '2015-02-01 00:16:05.000000', 'temperatura', 537.0000, 'ºC'),
	(331546, 142, '2015-02-01 00:16:06.000000', 'temperatura', 523.0000, 'ºC'),
	(331547, 142, '2015-02-01 00:16:07.000000', 'temperatura', 1003.0000, 'ºC'),
	(331548, 142, '2015-02-01 00:16:08.000000', 'temperatura', 1046.0000, 'ºC'),
	(331549, 142, '2015-02-01 00:16:09.000000', 'temperatura', 1023.0000, 'ºC'),
	(331550, 142, '2015-02-01 00:16:10.000000', 'temperatura', 775.0000, 'ºC'),
	(331551, 142, '2015-02-01 00:16:11.000000', 'temperatura', 808.0000, 'ºC'),
	(331552, 142, '2015-02-01 00:16:12.000000', 'temperatura', 517.0000, 'ºC'),
	(331553, 142, '2015-02-01 00:16:13.000000', 'temperatura', 160.0000, 'ºC'),
	(331554, 142, '2015-02-01 00:16:14.000000', 'temperatura', 448.0000, 'ºC'),
	(331555, 142, '2015-02-01 00:16:15.000000', 'temperatura', 563.0000, 'ºC'),
	(331556, 142, '2015-02-01 00:16:16.000000', 'temperatura', 270.0000, 'ºC'),
	(331557, 142, '2015-02-01 00:16:17.000000', 'temperatura', 864.0000, 'ºC'),
	(331558, 142, '2015-02-01 00:16:18.000000', 'temperatura', 1109.0000, 'ºC'),
	(331559, 142, '2015-02-01 00:16:19.000000', 'temperatura', 554.0000, 'ºC'),
	(331560, 142, '2015-02-01 00:16:20.000000', 'temperatura', 642.0000, 'ºC'),
	(331561, 142, '2015-02-01 00:16:21.000000', 'temperatura', 350.0000, 'ºC'),
	(331562, 142, '2015-02-01 00:16:22.000000', 'temperatura', 1025.0000, 'ºC'),
	(331563, 142, '2015-02-01 00:16:23.000000', 'temperatura', 476.0000, 'ºC'),
	(331564, 142, '2015-02-01 00:16:24.000000', 'temperatura', 506.0000, 'ºC'),
	(331565, 142, '2015-02-01 00:16:25.000000', 'temperatura', 1103.0000, 'ºC'),
	(331566, 142, '2015-02-01 00:16:26.000000', 'temperatura', 397.0000, 'ºC'),
	(331567, 142, '2015-02-01 00:16:27.000000', 'temperatura', 1075.0000, 'ºC'),
	(331568, 142, '2015-02-01 00:16:28.000000', 'temperatura', 587.0000, 'ºC'),
	(331569, 142, '2015-02-01 00:16:29.000000', 'temperatura', 911.0000, 'ºC'),
	(331570, 142, '2015-02-01 00:16:30.000000', 'temperatura', 392.0000, 'ºC'),
	(331571, 142, '2015-02-01 00:16:31.000000', 'temperatura', 429.0000, 'ºC'),
	(331572, 142, '2015-02-01 00:16:32.000000', 'temperatura', 971.0000, 'ºC'),
	(331573, 142, '2015-02-01 00:16:33.000000', 'temperatura', 1165.0000, 'ºC'),
	(331574, 142, '2015-02-01 00:16:34.000000', 'temperatura', 515.0000, 'ºC'),
	(331575, 142, '2015-02-01 00:16:35.000000', 'temperatura', 279.0000, 'ºC'),
	(331576, 142, '2015-02-01 00:16:36.000000', 'temperatura', 1049.0000, 'ºC'),
	(331577, 142, '2015-02-01 00:16:37.000000', 'temperatura', 810.0000, 'ºC'),
	(331578, 142, '2015-02-01 00:16:38.000000', 'temperatura', 902.0000, 'ºC'),
	(331579, 142, '2015-02-01 00:16:39.000000', 'temperatura', 883.0000, 'ºC'),
	(331580, 142, '2015-02-01 00:16:40.000000', 'temperatura', 510.0000, 'ºC'),
	(331581, 142, '2015-02-01 00:16:41.000000', 'temperatura', 1099.0000, 'ºC'),
	(331582, 142, '2015-02-01 00:16:42.000000', 'temperatura', 365.0000, 'ºC'),
	(331583, 142, '2015-02-01 00:16:43.000000', 'temperatura', 929.0000, 'ºC'),
	(331584, 142, '2015-02-01 00:16:44.000000', 'temperatura', 1149.0000, 'ºC'),
	(331585, 142, '2015-02-01 00:16:45.000000', 'temperatura', 562.0000, 'ºC'),
	(331586, 142, '2015-02-01 00:16:46.000000', 'temperatura', 562.0000, 'ºC'),
	(331587, 142, '2015-02-01 00:16:47.000000', 'temperatura', 1123.0000, 'ºC'),
	(331588, 142, '2015-02-01 00:16:48.000000', 'temperatura', 331.0000, 'ºC'),
	(331589, 142, '2015-02-01 00:16:49.000000', 'temperatura', 685.0000, 'ºC'),
	(331590, 142, '2015-02-01 00:16:50.000000', 'temperatura', 32.0000, 'ºC'),
	(331591, 142, '2015-02-01 00:16:51.000000', 'temperatura', 505.0000, 'ºC'),
	(331592, 142, '2015-02-01 00:16:52.000000', 'temperatura', 30.0000, 'ºC'),
	(331593, 142, '2015-02-01 00:16:53.000000', 'temperatura', 1035.0000, 'ºC'),
	(331594, 142, '2015-02-01 00:16:54.000000', 'temperatura', 286.0000, 'ºC'),
	(331595, 142, '2015-02-01 00:16:55.000000', 'temperatura', 724.0000, 'ºC'),
	(331596, 142, '2015-02-01 00:16:56.000000', 'temperatura', 366.0000, 'ºC'),
	(331597, 142, '2015-02-01 00:16:57.000000', 'temperatura', 855.0000, 'ºC'),
	(331598, 142, '2015-02-01 00:16:58.000000', 'temperatura', 778.0000, 'ºC'),
	(331599, 142, '2015-02-01 00:16:59.000000', 'temperatura', 127.0000, 'ºC'),
	(331600, 142, '2015-02-01 00:17:00.000000', 'temperatura', 699.0000, 'ºC'),
	(331601, 142, '2015-02-01 00:17:01.000000', 'temperatura', 716.0000, 'ºC'),
	(331602, 142, '2015-02-01 00:17:02.000000', 'temperatura', 284.0000, 'ºC'),
	(331603, 142, '2015-02-01 00:17:03.000000', 'temperatura', 472.0000, 'ºC'),
	(331604, 142, '2015-02-01 00:17:04.000000', 'temperatura', 307.0000, 'ºC'),
	(331605, 142, '2015-02-01 00:17:05.000000', 'temperatura', 121.0000, 'ºC'),
	(331606, 142, '2015-02-01 00:17:06.000000', 'temperatura', 883.0000, 'ºC'),
	(331607, 142, '2015-02-01 00:17:07.000000', 'temperatura', 452.0000, 'ºC'),
	(331608, 142, '2015-02-01 00:17:08.000000', 'temperatura', 814.0000, 'ºC'),
	(331609, 142, '2015-02-01 00:17:09.000000', 'temperatura', 315.0000, 'ºC'),
	(331610, 142, '2015-02-01 00:17:10.000000', 'temperatura', 331.0000, 'ºC'),
	(331611, 142, '2015-02-01 00:17:11.000000', 'temperatura', 712.0000, 'ºC'),
	(331612, 142, '2015-02-01 00:17:12.000000', 'temperatura', 165.0000, 'ºC'),
	(331613, 142, '2015-02-01 00:17:13.000000', 'temperatura', 1091.0000, 'ºC'),
	(331614, 142, '2015-02-01 00:17:14.000000', 'temperatura', 163.0000, 'ºC'),
	(331615, 142, '2015-02-01 00:17:15.000000', 'temperatura', 1139.0000, 'ºC'),
	(331616, 142, '2015-02-01 00:17:16.000000', 'temperatura', 407.0000, 'ºC'),
	(331617, 142, '2015-02-01 00:17:17.000000', 'temperatura', 1018.0000, 'ºC'),
	(331618, 142, '2015-02-01 00:17:18.000000', 'temperatura', 269.0000, 'ºC'),
	(331619, 142, '2015-02-01 00:17:19.000000', 'temperatura', 692.0000, 'ºC'),
	(331620, 142, '2015-02-01 00:17:20.000000', 'temperatura', 255.0000, 'ºC'),
	(331621, 142, '2015-02-01 00:17:21.000000', 'temperatura', 397.0000, 'ºC'),
	(331622, 142, '2015-02-01 00:17:22.000000', 'temperatura', 21.0000, 'ºC'),
	(331623, 142, '2015-02-01 00:17:23.000000', 'temperatura', 113.0000, 'ºC'),
	(331624, 142, '2015-02-01 00:17:24.000000', 'temperatura', 503.0000, 'ºC'),
	(331625, 142, '2015-02-01 00:17:25.000000', 'temperatura', 978.0000, 'ºC'),
	(331626, 142, '2015-02-01 00:17:26.000000', 'temperatura', 981.0000, 'ºC'),
	(331627, 142, '2015-02-01 00:17:27.000000', 'temperatura', 770.0000, 'ºC'),
	(331628, 142, '2015-02-01 00:17:28.000000', 'temperatura', 907.0000, 'ºC'),
	(331629, 142, '2015-02-01 00:17:29.000000', 'temperatura', 1029.0000, 'ºC'),
	(331630, 142, '2015-02-01 00:17:30.000000', 'temperatura', 21.0000, 'ºC'),
	(331631, 142, '2015-02-01 00:17:31.000000', 'temperatura', 619.0000, 'ºC'),
	(331632, 142, '2015-02-01 00:17:32.000000', 'temperatura', 632.0000, 'ºC'),
	(331633, 142, '2015-02-01 00:17:33.000000', 'temperatura', 104.0000, 'ºC'),
	(331634, 142, '2015-02-01 00:17:34.000000', 'temperatura', 1024.0000, 'ºC'),
	(331635, 142, '2015-02-01 00:17:35.000000', 'temperatura', 9.0000, 'ºC'),
	(331636, 142, '2015-02-01 00:17:36.000000', 'temperatura', 574.0000, 'ºC'),
	(331637, 142, '2015-02-01 00:17:37.000000', 'temperatura', 444.0000, 'ºC'),
	(331638, 142, '2015-02-01 00:17:38.000000', 'temperatura', 496.0000, 'ºC'),
	(331639, 142, '2015-02-01 00:17:39.000000', 'temperatura', 1151.0000, 'ºC'),
	(331640, 142, '2015-02-01 00:17:40.000000', 'temperatura', 668.0000, 'ºC'),
	(331641, 142, '2015-02-01 00:17:41.000000', 'temperatura', 1087.0000, 'ºC'),
	(331642, 142, '2015-02-01 00:17:42.000000', 'temperatura', 1031.0000, 'ºC'),
	(331643, 142, '2015-02-01 00:17:43.000000', 'temperatura', 694.0000, 'ºC'),
	(331644, 142, '2015-02-01 00:17:44.000000', 'temperatura', 377.0000, 'ºC'),
	(331645, 142, '2015-02-01 00:17:45.000000', 'temperatura', 1006.0000, 'ºC'),
	(331646, 142, '2015-02-01 00:17:46.000000', 'temperatura', 299.0000, 'ºC'),
	(331647, 142, '2015-02-01 00:17:47.000000', 'temperatura', 875.0000, 'ºC'),
	(331648, 142, '2015-02-01 00:17:48.000000', 'temperatura', 1080.0000, 'ºC'),
	(331649, 142, '2015-02-01 00:17:49.000000', 'temperatura', 376.0000, 'ºC'),
	(331650, 142, '2015-02-01 00:17:50.000000', 'temperatura', 1042.0000, 'ºC'),
	(331651, 142, '2015-02-01 00:17:51.000000', 'temperatura', 481.0000, 'ºC'),
	(331652, 142, '2015-02-01 00:17:52.000000', 'temperatura', 479.0000, 'ºC'),
	(331653, 142, '2015-02-01 00:17:53.000000', 'temperatura', 954.0000, 'ºC'),
	(331654, 142, '2015-02-01 00:17:54.000000', 'temperatura', 931.0000, 'ºC'),
	(331655, 142, '2015-02-01 00:17:55.000000', 'temperatura', 594.0000, 'ºC'),
	(331656, 142, '2015-02-01 00:17:56.000000', 'temperatura', 178.0000, 'ºC'),
	(331657, 142, '2015-02-01 00:17:57.000000', 'temperatura', 307.0000, 'ºC'),
	(331658, 142, '2015-02-01 00:17:58.000000', 'temperatura', 1004.0000, 'ºC'),
	(331659, 142, '2015-02-01 00:17:59.000000', 'temperatura', 500.0000, 'ºC'),
	(331660, 142, '2015-02-01 00:18:00.000000', 'temperatura', 689.0000, 'ºC'),
	(331661, 142, '2015-02-01 00:18:01.000000', 'temperatura', 745.0000, 'ºC'),
	(331662, 142, '2015-02-01 00:18:02.000000', 'temperatura', 460.0000, 'ºC'),
	(331663, 142, '2015-02-01 00:18:03.000000', 'temperatura', 63.0000, 'ºC'),
	(331664, 142, '2015-02-01 00:18:04.000000', 'temperatura', 138.0000, 'ºC'),
	(331665, 142, '2015-02-01 00:18:05.000000', 'temperatura', 502.0000, 'ºC'),
	(331666, 142, '2015-02-01 00:18:06.000000', 'temperatura', 895.0000, 'ºC'),
	(331667, 142, '2015-02-01 00:18:07.000000', 'temperatura', 571.0000, 'ºC'),
	(331668, 142, '2015-02-01 00:18:08.000000', 'temperatura', 169.0000, 'ºC'),
	(331669, 142, '2015-02-01 00:18:09.000000', 'temperatura', 332.0000, 'ºC'),
	(331670, 142, '2015-02-01 00:18:10.000000', 'temperatura', 1156.0000, 'ºC'),
	(331671, 142, '2015-02-01 00:18:11.000000', 'temperatura', 1183.0000, 'ºC'),
	(331672, 142, '2015-02-01 00:18:12.000000', 'temperatura', 48.0000, 'ºC'),
	(331673, 142, '2015-02-01 00:18:13.000000', 'temperatura', 290.0000, 'ºC'),
	(331674, 142, '2015-02-01 00:18:14.000000', 'temperatura', 107.0000, 'ºC'),
	(331675, 142, '2015-02-01 00:18:15.000000', 'temperatura', 865.0000, 'ºC'),
	(331676, 142, '2015-02-01 00:18:16.000000', 'temperatura', 403.0000, 'ºC'),
	(331677, 142, '2015-02-01 00:18:17.000000', 'temperatura', 623.0000, 'ºC'),
	(331678, 142, '2015-02-01 00:18:18.000000', 'temperatura', 704.0000, 'ºC'),
	(331679, 142, '2015-02-01 00:18:19.000000', 'temperatura', 452.0000, 'ºC'),
	(331680, 142, '2015-02-01 00:18:20.000000', 'temperatura', 148.0000, 'ºC'),
	(331681, 142, '2015-02-01 00:18:21.000000', 'temperatura', 585.0000, 'ºC'),
	(331682, 142, '2015-02-01 00:18:22.000000', 'temperatura', 81.0000, 'ºC'),
	(331683, 142, '2015-02-01 00:18:23.000000', 'temperatura', 1052.0000, 'ºC'),
	(331684, 142, '2015-02-01 00:18:24.000000', 'temperatura', 215.0000, 'ºC'),
	(331685, 142, '2015-02-01 00:18:25.000000', 'temperatura', 322.0000, 'ºC'),
	(331686, 142, '2015-02-01 00:18:26.000000', 'temperatura', 965.0000, 'ºC'),
	(331687, 142, '2015-02-01 00:18:27.000000', 'temperatura', 257.0000, 'ºC'),
	(331688, 142, '2015-02-01 00:18:28.000000', 'temperatura', 793.0000, 'ºC'),
	(331689, 142, '2015-02-01 00:18:29.000000', 'temperatura', 795.0000, 'ºC'),
	(331690, 142, '2015-02-01 00:18:30.000000', 'temperatura', 395.0000, 'ºC'),
	(331691, 142, '2015-02-01 00:18:31.000000', 'temperatura', 790.0000, 'ºC'),
	(331692, 142, '2015-02-01 00:18:32.000000', 'temperatura', 368.0000, 'ºC'),
	(331693, 142, '2015-02-01 00:18:33.000000', 'temperatura', 669.0000, 'ºC'),
	(331694, 142, '2015-02-01 00:18:34.000000', 'temperatura', 1041.0000, 'ºC'),
	(331695, 142, '2015-02-01 00:18:35.000000', 'temperatura', 799.0000, 'ºC'),
	(331696, 142, '2015-02-01 00:18:36.000000', 'temperatura', 873.0000, 'ºC'),
	(331697, 142, '2015-02-01 00:18:37.000000', 'temperatura', 767.0000, 'ºC'),
	(331698, 142, '2015-02-01 00:18:38.000000', 'temperatura', 18.0000, 'ºC'),
	(331699, 142, '2015-02-01 00:18:39.000000', 'temperatura', 188.0000, 'ºC'),
	(331700, 142, '2015-02-01 00:18:40.000000', 'temperatura', 887.0000, 'ºC'),
	(331701, 142, '2015-02-01 00:18:41.000000', 'temperatura', 273.0000, 'ºC'),
	(331702, 142, '2015-02-01 00:18:42.000000', 'temperatura', 1103.0000, 'ºC'),
	(331703, 142, '2015-02-01 00:18:43.000000', 'temperatura', 1096.0000, 'ºC'),
	(331704, 142, '2015-02-01 00:18:44.000000', 'temperatura', 973.0000, 'ºC'),
	(331705, 142, '2015-02-01 00:18:45.000000', 'temperatura', 375.0000, 'ºC'),
	(331706, 142, '2015-02-01 00:18:46.000000', 'temperatura', 157.0000, 'ºC'),
	(331707, 142, '2015-02-01 00:18:47.000000', 'temperatura', 860.0000, 'ºC'),
	(331708, 142, '2015-02-01 00:18:48.000000', 'temperatura', 230.0000, 'ºC'),
	(331709, 142, '2015-02-01 00:18:49.000000', 'temperatura', 970.0000, 'ºC'),
	(331710, 142, '2015-02-01 00:18:50.000000', 'temperatura', 561.0000, 'ºC'),
	(331711, 142, '2015-02-01 00:18:51.000000', 'temperatura', 1094.0000, 'ºC'),
	(331712, 142, '2015-02-01 00:18:52.000000', 'temperatura', 190.0000, 'ºC'),
	(331713, 142, '2015-02-01 00:18:53.000000', 'temperatura', 66.0000, 'ºC'),
	(331714, 142, '2015-02-01 00:18:54.000000', 'temperatura', 961.0000, 'ºC'),
	(331715, 142, '2015-02-01 00:18:55.000000', 'temperatura', 1007.0000, 'ºC'),
	(331716, 142, '2015-02-01 00:18:56.000000', 'temperatura', 954.0000, 'ºC'),
	(331717, 142, '2015-02-01 00:18:57.000000', 'temperatura', 550.0000, 'ºC'),
	(331718, 142, '2015-02-01 00:18:58.000000', 'temperatura', 1086.0000, 'ºC'),
	(331719, 142, '2015-02-01 00:18:59.000000', 'temperatura', 184.0000, 'ºC'),
	(331720, 142, '2015-02-01 00:19:00.000000', 'temperatura', 60.0000, 'ºC'),
	(331721, 142, '2015-02-01 00:19:01.000000', 'temperatura', 950.0000, 'ºC'),
	(331722, 142, '2015-02-01 00:19:02.000000', 'temperatura', 970.0000, 'ºC'),
	(331723, 142, '2015-02-01 00:19:03.000000', 'temperatura', 800.0000, 'ºC'),
	(331724, 142, '2015-02-01 00:19:04.000000', 'temperatura', 1092.0000, 'ºC'),
	(331725, 142, '2015-02-01 00:19:05.000000', 'temperatura', 659.0000, 'ºC'),
	(331726, 142, '2015-02-01 00:19:06.000000', 'temperatura', 21.0000, 'ºC'),
	(331727, 142, '2015-02-01 00:19:07.000000', 'temperatura', 527.0000, 'ºC'),
	(331728, 142, '2015-02-01 00:19:08.000000', 'temperatura', 174.0000, 'ºC'),
	(331729, 142, '2015-02-01 00:19:09.000000', 'temperatura', 488.0000, 'ºC'),
	(331730, 142, '2015-02-01 00:19:10.000000', 'temperatura', 720.0000, 'ºC'),
	(331731, 142, '2015-02-01 00:19:11.000000', 'temperatura', 937.0000, 'ºC'),
	(331732, 142, '2015-02-01 00:19:12.000000', 'temperatura', 127.0000, 'ºC'),
	(331733, 142, '2015-02-01 00:19:13.000000', 'temperatura', 221.0000, 'ºC'),
	(331734, 142, '2015-02-01 00:19:14.000000', 'temperatura', 726.0000, 'ºC'),
	(331735, 142, '2015-02-01 00:19:15.000000', 'temperatura', 566.0000, 'ºC'),
	(331736, 142, '2015-02-01 00:19:16.000000', 'temperatura', 654.0000, 'ºC'),
	(331737, 142, '2015-02-01 00:19:17.000000', 'temperatura', 374.0000, 'ºC'),
	(331738, 142, '2015-02-01 00:19:18.000000', 'temperatura', 1107.0000, 'ºC'),
	(331739, 142, '2015-02-01 00:19:19.000000', 'temperatura', 813.0000, 'ºC'),
	(331740, 142, '2015-02-01 00:19:20.000000', 'temperatura', 743.0000, 'ºC'),
	(331741, 142, '2015-02-01 00:19:21.000000', 'temperatura', 79.0000, 'ºC'),
	(331742, 142, '2015-02-01 00:19:22.000000', 'temperatura', 565.0000, 'ºC'),
	(331743, 142, '2015-02-01 00:19:23.000000', 'temperatura', 188.0000, 'ºC'),
	(331744, 142, '2015-02-01 00:19:24.000000', 'temperatura', 448.0000, 'ºC'),
	(331745, 142, '2015-02-01 00:19:25.000000', 'temperatura', 475.0000, 'ºC'),
	(331746, 142, '2015-02-01 00:19:26.000000', 'temperatura', 1031.0000, 'ºC'),
	(331747, 142, '2015-02-01 00:19:27.000000', 'temperatura', 132.0000, 'ºC'),
	(331748, 142, '2015-02-01 00:19:28.000000', 'temperatura', 1165.0000, 'ºC'),
	(331749, 142, '2015-02-01 00:19:29.000000', 'temperatura', 630.0000, 'ºC'),
	(331750, 142, '2015-02-01 00:19:30.000000', 'temperatura', 857.0000, 'ºC'),
	(331751, 142, '2015-02-01 00:19:31.000000', 'temperatura', 1194.0000, 'ºC'),
	(331752, 142, '2015-02-01 00:19:32.000000', 'temperatura', 1000.0000, 'ºC'),
	(331753, 142, '2015-02-01 00:19:33.000000', 'temperatura', 218.0000, 'ºC'),
	(331754, 142, '2015-02-01 00:19:34.000000', 'temperatura', 489.0000, 'ºC'),
	(331755, 142, '2015-02-01 00:19:35.000000', 'temperatura', 594.0000, 'ºC'),
	(331756, 142, '2015-02-01 00:19:36.000000', 'temperatura', 303.0000, 'ºC'),
	(331757, 142, '2015-02-01 00:19:37.000000', 'temperatura', 935.0000, 'ºC'),
	(331758, 142, '2015-02-01 00:19:38.000000', 'temperatura', 165.0000, 'ºC'),
	(331759, 142, '2015-02-01 00:19:39.000000', 'temperatura', 420.0000, 'ºC'),
	(331760, 142, '2015-02-01 00:19:40.000000', 'temperatura', 405.0000, 'ºC'),
	(331761, 142, '2015-02-01 00:19:41.000000', 'temperatura', 768.0000, 'ºC'),
	(331762, 142, '2015-02-01 00:19:42.000000', 'temperatura', 224.0000, 'ºC'),
	(331763, 142, '2015-02-01 00:19:43.000000', 'temperatura', 16.0000, 'ºC'),
	(331764, 142, '2015-02-01 00:19:44.000000', 'temperatura', 610.0000, 'ºC'),
	(331765, 142, '2015-02-01 00:19:45.000000', 'temperatura', 602.0000, 'ºC'),
	(331766, 142, '2015-02-01 00:19:46.000000', 'temperatura', 1182.0000, 'ºC'),
	(331767, 142, '2015-02-01 00:19:47.000000', 'temperatura', 503.0000, 'ºC'),
	(331768, 142, '2015-02-01 00:19:48.000000', 'temperatura', 171.0000, 'ºC'),
	(331769, 142, '2015-02-01 00:19:49.000000', 'temperatura', 545.0000, 'ºC'),
	(331770, 142, '2015-02-01 00:19:50.000000', 'temperatura', 1014.0000, 'ºC'),
	(331771, 142, '2015-02-01 00:19:51.000000', 'temperatura', 1036.0000, 'ºC'),
	(331772, 142, '2015-02-01 00:19:52.000000', 'temperatura', 938.0000, 'ºC'),
	(331773, 142, '2015-02-01 00:19:53.000000', 'temperatura', 382.0000, 'ºC'),
	(331774, 142, '2015-02-01 00:19:54.000000', 'temperatura', 298.0000, 'ºC'),
	(331775, 142, '2015-02-01 00:19:55.000000', 'temperatura', 344.0000, 'ºC'),
	(331776, 142, '2015-02-01 00:19:56.000000', 'temperatura', 825.0000, 'ºC'),
	(331777, 142, '2015-02-01 00:19:57.000000', 'temperatura', 692.0000, 'ºC'),
	(331778, 142, '2015-02-01 00:19:58.000000', 'temperatura', 988.0000, 'ºC'),
	(331779, 142, '2015-02-01 00:19:59.000000', 'temperatura', 465.0000, 'ºC'),
	(331780, 142, '2015-02-01 00:20:00.000000', 'temperatura', 562.0000, 'ºC'),
	(331781, 142, '2015-02-01 00:20:01.000000', 'temperatura', 213.0000, 'ºC'),
	(331782, 142, '2015-02-01 00:20:02.000000', 'temperatura', 580.0000, 'ºC'),
	(331783, 142, '2015-02-01 00:20:03.000000', 'temperatura', 1062.0000, 'ºC'),
	(331784, 142, '2015-02-01 00:20:04.000000', 'temperatura', 1170.0000, 'ºC'),
	(331785, 142, '2015-02-01 00:20:05.000000', 'temperatura', 266.0000, 'ºC'),
	(331786, 142, '2015-02-01 00:20:06.000000', 'temperatura', 221.0000, 'ºC'),
	(331787, 142, '2015-02-01 00:20:07.000000', 'temperatura', 306.0000, 'ºC'),
	(331788, 142, '2015-02-01 00:20:08.000000', 'temperatura', 868.0000, 'ºC'),
	(331789, 142, '2015-02-01 00:20:09.000000', 'temperatura', 1021.0000, 'ºC'),
	(331790, 142, '2015-02-01 00:20:10.000000', 'temperatura', 104.0000, 'ºC'),
	(331791, 142, '2015-02-01 00:20:11.000000', 'temperatura', 1057.0000, 'ºC'),
	(331792, 142, '2015-02-01 00:20:12.000000', 'temperatura', 173.0000, 'ºC'),
	(331793, 142, '2015-02-01 00:20:13.000000', 'temperatura', 95.0000, 'ºC'),
	(331794, 142, '2015-02-01 00:20:14.000000', 'temperatura', 1158.0000, 'ºC'),
	(331795, 142, '2015-02-01 00:20:15.000000', 'temperatura', 706.0000, 'ºC'),
	(331796, 142, '2015-02-01 00:20:16.000000', 'temperatura', 54.0000, 'ºC'),
	(331797, 142, '2015-02-01 00:20:17.000000', 'temperatura', 554.0000, 'ºC'),
	(331798, 142, '2015-02-01 00:20:18.000000', 'temperatura', 208.0000, 'ºC'),
	(331799, 142, '2015-02-01 00:20:19.000000', 'temperatura', 578.0000, 'ºC'),
	(331800, 142, '2015-02-01 00:20:20.000000', 'temperatura', 1067.0000, 'ºC'),
	(331801, 142, '2015-02-01 00:20:21.000000', 'temperatura', 3.0000, 'ºC'),
	(331802, 142, '2015-02-01 00:20:22.000000', 'temperatura', 412.0000, 'ºC'),
	(331803, 142, '2015-02-01 00:20:23.000000', 'temperatura', 853.0000, 'ºC'),
	(331804, 142, '2015-02-01 00:20:24.000000', 'temperatura', 631.0000, 'ºC'),
	(331805, 142, '2015-02-01 00:20:25.000000', 'temperatura', 596.0000, 'ºC'),
	(331806, 142, '2015-02-01 00:20:26.000000', 'temperatura', 1085.0000, 'ºC'),
	(331807, 142, '2015-02-01 00:20:27.000000', 'temperatura', 38.0000, 'ºC'),
	(331808, 142, '2015-02-01 00:20:28.000000', 'temperatura', 538.0000, 'ºC'),
	(331809, 142, '2015-02-01 00:20:29.000000', 'temperatura', 176.0000, 'ºC'),
	(331810, 142, '2015-02-01 00:20:30.000000', 'temperatura', 465.0000, 'ºC'),
	(331811, 142, '2015-02-01 00:20:31.000000', 'temperatura', 596.0000, 'ºC'),
	(331812, 142, '2015-02-01 00:20:32.000000', 'temperatura', 387.0000, 'ºC'),
	(331813, 142, '2015-02-01 00:20:33.000000', 'temperatura', 148.0000, 'ºC'),
	(331814, 142, '2015-02-01 00:20:34.000000', 'temperatura', 779.0000, 'ºC'),
	(331815, 142, '2015-02-01 00:20:35.000000', 'temperatura', 1053.0000, 'ºC'),
	(331816, 142, '2015-02-01 00:20:36.000000', 'temperatura', 528.0000, 'ºC'),
	(331817, 142, '2015-02-01 00:20:37.000000', 'temperatura', 681.0000, 'ºC'),
	(331818, 142, '2015-02-01 00:20:38.000000', 'temperatura', 623.0000, 'ºC'),
	(331819, 142, '2015-02-01 00:20:39.000000', 'temperatura', 1071.0000, 'ºC'),
	(331820, 142, '2015-02-01 00:20:40.000000', 'temperatura', 1087.0000, 'ºC'),
	(331821, 142, '2015-02-01 00:20:41.000000', 'temperatura', 1021.0000, 'ºC'),
	(331822, 142, '2015-02-01 00:20:42.000000', 'temperatura', 643.0000, 'ºC'),
	(331823, 142, '2015-02-01 00:20:43.000000', 'temperatura', 156.0000, 'ºC'),
	(331824, 142, '2015-02-01 00:20:44.000000', 'temperatura', 52.0000, 'ºC'),
	(331825, 142, '2015-02-01 00:20:45.000000', 'temperatura', 990.0000, 'ºC'),
	(331826, 142, '2015-02-01 00:20:46.000000', 'temperatura', 1194.0000, 'ºC'),
	(331827, 142, '2015-02-01 00:20:47.000000', 'temperatura', 603.0000, 'ºC'),
	(331828, 142, '2015-02-01 00:20:48.000000', 'temperatura', 631.0000, 'ºC'),
	(331829, 142, '2015-02-01 00:20:49.000000', 'temperatura', 148.0000, 'ºC'),
	(331830, 142, '2015-02-01 00:20:50.000000', 'temperatura', 47.0000, 'ºC'),
	(331831, 142, '2015-02-01 00:20:51.000000', 'temperatura', 991.0000, 'ºC'),
	(331832, 142, '2015-02-01 00:20:52.000000', 'temperatura', 14.0000, 'ºC'),
	(331833, 142, '2015-02-01 00:20:53.000000', 'temperatura', 697.0000, 'ºC'),
	(331834, 142, '2015-02-01 00:20:54.000000', 'temperatura', 1044.0000, 'ºC'),
	(331835, 142, '2015-02-01 00:20:55.000000', 'temperatura', 730.0000, 'ºC'),
	(331836, 142, '2015-02-01 00:20:56.000000', 'temperatura', 519.0000, 'ºC'),
	(331837, 142, '2015-02-01 00:20:57.000000', 'temperatura', 406.0000, 'ºC'),
	(331838, 142, '2015-02-01 00:20:58.000000', 'temperatura', 473.0000, 'ºC'),
	(331839, 142, '2015-02-01 00:20:59.000000', 'temperatura', 1146.0000, 'ºC'),
	(331840, 142, '2015-02-01 00:21:00.000000', 'temperatura', 714.0000, 'ºC'),
	(331841, 142, '2015-02-01 00:21:01.000000', 'temperatura', 131.0000, 'ºC'),
	(331842, 142, '2015-02-01 00:21:02.000000', 'temperatura', 914.0000, 'ºC'),
	(331843, 142, '2015-02-01 00:21:03.000000', 'temperatura', 577.0000, 'ºC'),
	(331844, 142, '2015-02-01 00:21:04.000000', 'temperatura', 144.0000, 'ºC'),
	(331845, 142, '2015-02-01 00:21:05.000000', 'temperatura', 191.0000, 'ºC'),
	(331846, 142, '2015-02-01 00:21:06.000000', 'temperatura', 523.0000, 'ºC'),
	(331847, 142, '2015-02-01 00:21:07.000000', 'temperatura', 842.0000, 'ºC'),
	(331848, 142, '2015-02-01 00:21:08.000000', 'temperatura', 239.0000, 'ºC'),
	(331849, 142, '2015-02-01 00:21:09.000000', 'temperatura', 1073.0000, 'ºC'),
	(331850, 142, '2015-02-01 00:21:10.000000', 'temperatura', 1047.0000, 'ºC'),
	(331851, 142, '2015-02-01 00:21:11.000000', 'temperatura', 817.0000, 'ºC'),
	(331852, 142, '2015-02-01 00:21:12.000000', 'temperatura', 943.0000, 'ºC'),
	(331853, 142, '2015-02-01 00:21:13.000000', 'temperatura', 1065.0000, 'ºC'),
	(331854, 142, '2015-02-01 00:21:14.000000', 'temperatura', 96.0000, 'ºC'),
	(331855, 142, '2015-02-01 00:21:15.000000', 'temperatura', 884.0000, 'ºC'),
	(331856, 142, '2015-02-01 00:21:16.000000', 'temperatura', 536.0000, 'ºC'),
	(331857, 142, '2015-02-01 00:21:17.000000', 'temperatura', 25.0000, 'ºC'),
	(331858, 142, '2015-02-01 00:21:18.000000', 'temperatura', 920.0000, 'ºC'),
	(331859, 142, '2015-02-01 00:21:19.000000', 'temperatura', 924.0000, 'ºC'),
	(331860, 142, '2015-02-01 00:21:20.000000', 'temperatura', 661.0000, 'ºC'),
	(331861, 142, '2015-02-01 00:21:21.000000', 'temperatura', 533.0000, 'ºC'),
	(331862, 142, '2015-02-01 00:21:22.000000', 'temperatura', 683.0000, 'ºC'),
	(331863, 142, '2015-02-01 00:21:23.000000', 'temperatura', 617.0000, 'ºC'),
	(331864, 142, '2015-02-01 00:21:24.000000', 'temperatura', 1038.0000, 'ºC'),
	(331865, 142, '2015-02-01 00:21:25.000000', 'temperatura', 939.0000, 'ºC'),
	(331866, 142, '2015-02-01 00:21:26.000000', 'temperatura', 380.0000, 'ºC'),
	(331867, 142, '2015-02-01 00:21:27.000000', 'temperatura', 286.0000, 'ºC'),
	(331868, 142, '2015-02-01 00:21:28.000000', 'temperatura', 290.0000, 'ºC'),
	(331869, 142, '2015-02-01 00:21:29.000000', 'temperatura', 593.0000, 'ºC'),
	(331870, 142, '2015-02-01 00:21:30.000000', 'temperatura', 893.0000, 'ºC'),
	(331871, 142, '2015-02-01 00:21:31.000000', 'temperatura', 288.0000, 'ºC'),
	(331872, 142, '2015-02-01 00:21:32.000000', 'temperatura', 1160.0000, 'ºC'),
	(331873, 142, '2015-02-01 00:21:33.000000', 'temperatura', 137.0000, 'ºC'),
	(331874, 142, '2015-02-01 00:21:34.000000', 'temperatura', 804.0000, 'ºC'),
	(331875, 142, '2015-02-01 00:21:35.000000', 'temperatura', 10.0000, 'ºC'),
	(331876, 142, '2015-02-01 00:21:36.000000', 'temperatura', 40.0000, 'ºC'),
	(331877, 142, '2015-02-01 00:21:37.000000', 'temperatura', 171.0000, 'ºC'),
	(331878, 142, '2015-02-01 00:21:38.000000', 'temperatura', 736.0000, 'ºC'),
	(331879, 142, '2015-02-01 00:21:39.000000', 'temperatura', 767.0000, 'ºC'),
	(331880, 142, '2015-02-01 00:21:40.000000', 'temperatura', 426.0000, 'ºC'),
	(331881, 142, '2015-02-01 00:21:41.000000', 'temperatura', 1030.0000, 'ºC'),
	(331882, 142, '2015-02-01 00:21:42.000000', 'temperatura', 273.0000, 'ºC'),
	(331883, 142, '2015-02-01 00:21:43.000000', 'temperatura', 676.0000, 'ºC'),
	(331884, 142, '2015-02-01 00:21:44.000000', 'temperatura', 160.0000, 'ºC'),
	(331885, 142, '2015-02-01 00:21:45.000000', 'temperatura', 1175.0000, 'ºC'),
	(331886, 142, '2015-02-01 00:21:46.000000', 'temperatura', 593.0000, 'ºC'),
	(331887, 142, '2015-02-01 00:21:47.000000', 'temperatura', 641.0000, 'ºC'),
	(331888, 142, '2015-02-01 00:21:48.000000', 'temperatura', 225.0000, 'ºC'),
	(331889, 142, '2015-02-01 00:21:49.000000', 'temperatura', 405.0000, 'ºC'),
	(331890, 142, '2015-02-01 00:21:50.000000', 'temperatura', 151.0000, 'ºC'),
	(331891, 142, '2015-02-01 00:21:51.000000', 'temperatura', 739.0000, 'ºC'),
	(331892, 142, '2015-02-01 00:21:52.000000', 'temperatura', 842.0000, 'ºC'),
	(331893, 142, '2015-02-01 00:21:53.000000', 'temperatura', 794.0000, 'ºC'),
	(331894, 142, '2015-02-01 00:21:54.000000', 'temperatura', 244.0000, 'ºC'),
	(331895, 142, '2015-02-01 00:21:55.000000', 'temperatura', 37.0000, 'ºC'),
	(331896, 142, '2015-02-01 00:21:56.000000', 'temperatura', 654.0000, 'ºC'),
	(331897, 142, '2015-02-01 00:21:57.000000', 'temperatura', 759.0000, 'ºC'),
	(331898, 142, '2015-02-01 00:21:58.000000', 'temperatura', 635.0000, 'ºC'),
	(331899, 142, '2015-02-01 00:21:59.000000', 'temperatura', 896.0000, 'ºC'),
	(331900, 142, '2015-02-01 00:22:00.000000', 'temperatura', 177.0000, 'ºC'),
	(331901, 142, '2015-02-01 00:22:01.000000', 'temperatura', 596.0000, 'ºC'),
	(331902, 142, '2015-02-01 00:22:02.000000', 'temperatura', 52.0000, 'ºC'),
	(331903, 142, '2015-02-01 00:22:03.000000', 'temperatura', 869.0000, 'ºC'),
	(331904, 142, '2015-02-01 00:22:04.000000', 'temperatura', 593.0000, 'ºC'),
	(331905, 142, '2015-02-01 00:22:05.000000', 'temperatura', 359.0000, 'ºC'),
	(331906, 142, '2015-02-01 00:22:06.000000', 'temperatura', 13.0000, 'ºC'),
	(331907, 142, '2015-02-01 00:22:07.000000', 'temperatura', 191.0000, 'ºC'),
	(331908, 142, '2015-02-01 00:22:08.000000', 'temperatura', 914.0000, 'ºC'),
	(331909, 142, '2015-02-01 00:22:09.000000', 'temperatura', 400.0000, 'ºC'),
	(331910, 142, '2015-02-01 00:22:10.000000', 'temperatura', 460.0000, 'ºC'),
	(331911, 142, '2015-02-01 00:22:11.000000', 'temperatura', 1097.0000, 'ºC'),
	(331912, 142, '2015-02-01 00:22:12.000000', 'temperatura', 508.0000, 'ºC'),
	(331913, 142, '2015-02-01 00:22:13.000000', 'temperatura', 451.0000, 'ºC'),
	(331914, 142, '2015-02-01 00:22:14.000000', 'temperatura', 729.0000, 'ºC'),
	(331915, 142, '2015-02-01 00:22:15.000000', 'temperatura', 1091.0000, 'ºC'),
	(331916, 142, '2015-02-01 00:22:16.000000', 'temperatura', 870.0000, 'ºC'),
	(331917, 142, '2015-02-01 00:22:17.000000', 'temperatura', 1078.0000, 'ºC'),
	(331918, 142, '2015-02-01 00:22:18.000000', 'temperatura', 380.0000, 'ºC'),
	(331919, 142, '2015-02-01 00:22:19.000000', 'temperatura', 1065.0000, 'ºC'),
	(331920, 142, '2015-02-01 00:22:20.000000', 'temperatura', 587.0000, 'ºC'),
	(331921, 142, '2015-02-01 00:22:21.000000', 'temperatura', 942.0000, 'ºC'),
	(331922, 142, '2015-02-01 00:22:22.000000', 'temperatura', 549.0000, 'ºC'),
	(331923, 142, '2015-02-01 00:22:23.000000', 'temperatura', 1120.0000, 'ºC'),
	(331924, 142, '2015-02-01 00:22:24.000000', 'temperatura', 352.0000, 'ºC'),
	(331925, 142, '2015-02-01 00:22:25.000000', 'temperatura', 802.0000, 'ºC'),
	(331926, 142, '2015-02-01 00:22:26.000000', 'temperatura', 555.0000, 'ºC'),
	(331927, 142, '2015-02-01 00:22:27.000000', 'temperatura', 370.0000, 'ºC'),
	(331928, 142, '2015-02-01 00:22:28.000000', 'temperatura', 183.0000, 'ºC'),
	(331929, 142, '2015-02-01 00:22:29.000000', 'temperatura', 1008.0000, 'ºC'),
	(331930, 142, '2015-02-01 00:22:30.000000', 'temperatura', 890.0000, 'ºC'),
	(331931, 142, '2015-02-01 00:22:31.000000', 'temperatura', 229.0000, 'ºC'),
	(331932, 142, '2015-02-01 00:22:32.000000', 'temperatura', 873.0000, 'ºC'),
	(331933, 142, '2015-02-01 00:22:33.000000', 'temperatura', 77.0000, 'ºC'),
	(331934, 142, '2015-02-01 00:22:34.000000', 'temperatura', 169.0000, 'ºC'),
	(331935, 142, '2015-02-01 00:22:35.000000', 'temperatura', 615.0000, 'ºC'),
	(331936, 142, '2015-02-01 00:22:36.000000', 'temperatura', 166.0000, 'ºC'),
	(331937, 142, '2015-02-01 00:22:37.000000', 'temperatura', 188.0000, 'ºC'),
	(331938, 142, '2015-02-01 00:22:38.000000', 'temperatura', 440.0000, 'ºC'),
	(331939, 142, '2015-02-01 00:22:39.000000', 'temperatura', 437.0000, 'ºC'),
	(331940, 142, '2015-02-01 00:22:40.000000', 'temperatura', 866.0000, 'ºC'),
	(331941, 142, '2015-02-01 00:22:41.000000', 'temperatura', 617.0000, 'ºC'),
	(331942, 142, '2015-02-01 00:22:42.000000', 'temperatura', 491.0000, 'ºC'),
	(331943, 142, '2015-02-01 00:22:43.000000', 'temperatura', 602.0000, 'ºC'),
	(331944, 142, '2015-02-01 00:22:44.000000', 'temperatura', 339.0000, 'ºC'),
	(331945, 142, '2015-02-01 00:22:45.000000', 'temperatura', 1091.0000, 'ºC'),
	(331946, 142, '2015-02-01 00:22:46.000000', 'temperatura', 838.0000, 'ºC'),
	(331947, 142, '2015-02-01 00:22:47.000000', 'temperatura', 917.0000, 'ºC'),
	(331948, 142, '2015-02-01 00:22:48.000000', 'temperatura', 869.0000, 'ºC'),
	(331949, 142, '2015-02-01 00:22:49.000000', 'temperatura', 398.0000, 'ºC'),
	(331950, 142, '2015-02-01 00:22:50.000000', 'temperatura', 582.0000, 'ºC'),
	(331951, 142, '2015-02-01 00:22:51.000000', 'temperatura', 518.0000, 'ºC'),
	(331952, 142, '2015-02-01 00:22:52.000000', 'temperatura', 844.0000, 'ºC'),
	(331953, 142, '2015-02-01 00:22:53.000000', 'temperatura', 267.0000, 'ºC'),
	(331954, 142, '2015-02-01 00:22:54.000000', 'temperatura', 3.0000, 'ºC'),
	(331955, 142, '2015-02-01 00:22:55.000000', 'temperatura', 415.0000, 'ºC'),
	(331956, 142, '2015-02-01 00:22:56.000000', 'temperatura', 868.0000, 'ºC'),
	(331957, 142, '2015-02-01 00:22:57.000000', 'temperatura', 695.0000, 'ºC'),
	(331958, 142, '2015-02-01 00:22:58.000000', 'temperatura', 869.0000, 'ºC'),
	(331959, 142, '2015-02-01 00:22:59.000000', 'temperatura', 1061.0000, 'ºC'),
	(331960, 142, '2015-02-01 00:23:00.000000', 'temperatura', 300.0000, 'ºC'),
	(331961, 142, '2015-02-01 00:23:01.000000', 'temperatura', 715.0000, 'ºC'),
	(331962, 142, '2015-02-01 00:23:02.000000', 'temperatura', 276.0000, 'ºC'),
	(331963, 142, '2015-02-01 00:23:03.000000', 'temperatura', 438.0000, 'ºC'),
	(331964, 142, '2015-02-01 00:23:04.000000', 'temperatura', 161.0000, 'ºC'),
	(331965, 142, '2015-02-01 00:23:05.000000', 'temperatura', 690.0000, 'ºC'),
	(331966, 142, '2015-02-01 00:23:06.000000', 'temperatura', 567.0000, 'ºC'),
	(331967, 142, '2015-02-01 00:23:07.000000', 'temperatura', 768.0000, 'ºC'),
	(331968, 142, '2015-02-01 00:23:08.000000', 'temperatura', 937.0000, 'ºC'),
	(331969, 142, '2015-02-01 00:23:09.000000', 'temperatura', 1184.0000, 'ºC'),
	(331970, 142, '2015-02-01 00:23:10.000000', 'temperatura', 708.0000, 'ºC'),
	(331971, 142, '2015-02-01 00:23:11.000000', 'temperatura', 1188.0000, 'ºC'),
	(331972, 142, '2015-02-01 00:23:12.000000', 'temperatura', 218.0000, 'ºC'),
	(331973, 142, '2015-02-01 00:23:13.000000', 'temperatura', 1125.0000, 'ºC'),
	(331974, 142, '2015-02-01 00:23:14.000000', 'temperatura', 174.0000, 'ºC'),
	(331975, 142, '2015-02-01 00:23:15.000000', 'temperatura', 1095.0000, 'ºC'),
	(331976, 142, '2015-02-01 00:23:16.000000', 'temperatura', 153.0000, 'ºC'),
	(331977, 142, '2015-02-01 00:23:17.000000', 'temperatura', 1081.0000, 'ºC'),
	(331978, 142, '2015-02-01 00:23:18.000000', 'temperatura', 148.0000, 'ºC'),
	(331979, 142, '2015-02-01 00:23:19.000000', 'temperatura', 1095.0000, 'ºC'),
	(331980, 142, '2015-02-01 00:23:20.000000', 'temperatura', 232.0000, 'ºC'),
	(331981, 142, '2015-02-01 00:23:21.000000', 'temperatura', 276.0000, 'ºC'),
	(331982, 142, '2015-02-01 00:23:22.000000', 'temperatura', 683.0000, 'ºC'),
	(331983, 142, '2015-02-01 00:23:23.000000', 'temperatura', 188.0000, 'ºC'),
	(331984, 142, '2015-02-01 00:23:24.000000', 'temperatura', 93.0000, 'ºC'),
	(331985, 142, '2015-02-01 00:23:25.000000', 'temperatura', 1101.0000, 'ºC'),
	(331986, 142, '2015-02-01 00:23:26.000000', 'temperatura', 427.0000, 'ºC'),
	(331987, 142, '2015-02-01 00:23:27.000000', 'temperatura', 30.0000, 'ºC'),
	(331988, 142, '2015-02-01 00:23:28.000000', 'temperatura', 71.0000, 'ºC'),
	(331989, 142, '2015-02-01 00:23:29.000000', 'temperatura', 265.0000, 'ºC'),
	(331990, 142, '2015-02-01 00:23:30.000000', 'temperatura', 1114.0000, 'ºC'),
	(331991, 142, '2015-02-01 00:23:31.000000', 'temperatura', 1176.0000, 'ºC'),
	(331992, 142, '2015-02-01 00:23:32.000000', 'temperatura', 139.0000, 'ºC'),
	(331993, 142, '2015-02-01 00:23:33.000000', 'temperatura', 765.0000, 'ºC'),
	(331994, 142, '2015-02-01 00:23:34.000000', 'temperatura', 1011.0000, 'ºC'),
	(331995, 142, '2015-02-01 00:23:35.000000', 'temperatura', 361.0000, 'ºC'),
	(331996, 142, '2015-02-01 00:23:36.000000', 'temperatura', 1170.0000, 'ºC'),
	(331997, 142, '2015-02-01 00:23:37.000000', 'temperatura', 1169.0000, 'ºC'),
	(331998, 142, '2015-02-01 00:23:38.000000', 'temperatura', 1134.0000, 'ºC'),
	(331999, 142, '2015-02-01 00:23:39.000000', 'temperatura', 964.0000, 'ºC'),
	(332000, 142, '2015-02-01 00:23:40.000000', 'temperatura', 218.0000, 'ºC'),
	(332001, 142, '2015-02-01 00:23:41.000000', 'temperatura', 597.0000, 'ºC'),
	(332002, 142, '2015-02-01 00:23:42.000000', 'temperatura', 1134.0000, 'ºC'),
	(332003, 142, '2015-02-01 00:23:43.000000', 'temperatura', 280.0000, 'ºC'),
	(332004, 142, '2015-02-01 00:23:44.000000', 'temperatura', 396.0000, 'ºC'),
	(332005, 142, '2015-02-01 00:23:45.000000', 'temperatura', 1140.0000, 'ºC'),
	(332006, 142, '2015-02-01 00:23:46.000000', 'temperatura', 912.0000, 'ºC'),
	(332007, 142, '2015-02-01 00:23:47.000000', 'temperatura', 1140.0000, 'ºC'),
	(332008, 142, '2015-02-01 00:23:48.000000', 'temperatura', 564.0000, 'ºC'),
	(332009, 142, '2015-02-01 00:23:49.000000', 'temperatura', 600.0000, 'ºC'),
	(332010, 142, '2015-02-01 00:23:50.000000', 'temperatura', 110.0000, 'ºC'),
	(332011, 142, '2015-02-01 00:23:51.000000', 'temperatura', 1149.0000, 'ºC'),
	(332012, 142, '2015-02-01 00:23:52.000000', 'temperatura', 616.0000, 'ºC'),
	(332013, 142, '2015-02-01 00:23:53.000000', 'temperatura', 836.0000, 'ºC'),
	(332014, 142, '2015-02-01 00:23:54.000000', 'temperatura', 1130.0000, 'ºC'),
	(332015, 142, '2015-02-01 00:23:55.000000', 'temperatura', 743.0000, 'ºC'),
	(332016, 142, '2015-02-01 00:23:56.000000', 'temperatura', 328.0000, 'ºC'),
	(332017, 142, '2015-02-01 00:23:57.000000', 'temperatura', 608.0000, 'ºC'),
	(332018, 142, '2015-02-01 00:23:58.000000', 'temperatura', 859.0000, 'ºC'),
	(332019, 142, '2015-02-01 00:23:59.000000', 'temperatura', 72.0000, 'ºC'),
	(332020, 142, '2015-02-01 00:24:00.000000', 'temperatura', 183.0000, 'ºC'),
	(332021, 142, '2015-02-01 00:24:01.000000', 'temperatura', 697.0000, 'ºC'),
	(332022, 142, '2015-02-01 00:24:02.000000', 'temperatura', 540.0000, 'ºC'),
	(332023, 142, '2015-02-01 00:24:03.000000', 'temperatura', 608.0000, 'ºC'),
	(332024, 142, '2015-02-01 00:24:04.000000', 'temperatura', 222.0000, 'ºC'),
	(332025, 142, '2015-02-01 00:24:05.000000', 'temperatura', 487.0000, 'ºC'),
	(332026, 142, '2015-02-01 00:24:06.000000', 'temperatura', 568.0000, 'ºC'),
	(332027, 142, '2015-02-01 00:24:07.000000', 'temperatura', 178.0000, 'ºC'),
	(332028, 142, '2015-02-01 00:24:08.000000', 'temperatura', 390.0000, 'ºC'),
	(332029, 142, '2015-02-01 00:24:09.000000', 'temperatura', 214.0000, 'ºC'),
	(332030, 142, '2015-02-01 00:24:10.000000', 'temperatura', 1100.0000, 'ºC'),
	(332031, 142, '2015-02-01 00:24:11.000000', 'temperatura', 60.0000, 'ºC'),
	(332032, 142, '2015-02-01 00:24:12.000000', 'temperatura', 599.0000, 'ºC'),
	(332033, 142, '2015-02-01 00:24:13.000000', 'temperatura', 416.0000, 'ºC'),
	(332034, 142, '2015-02-01 00:24:14.000000', 'temperatura', 284.0000, 'ºC'),
	(332035, 142, '2015-02-01 00:24:15.000000', 'temperatura', 172.0000, 'ºC'),
	(332036, 142, '2015-02-01 00:24:16.000000', 'temperatura', 11.0000, 'ºC'),
	(332037, 142, '2015-02-01 00:24:17.000000', 'temperatura', 737.0000, 'ºC'),
	(332038, 142, '2015-02-01 00:24:18.000000', 'temperatura', 51.0000, 'ºC'),
	(332039, 142, '2015-02-01 00:24:19.000000', 'temperatura', 448.0000, 'ºC'),
	(332040, 142, '2015-02-01 00:24:20.000000', 'temperatura', 885.0000, 'ºC'),
	(332041, 142, '2015-02-01 00:24:21.000000', 'temperatura', 681.0000, 'ºC'),
	(332042, 142, '2015-02-01 00:24:22.000000', 'temperatura', 751.0000, 'ºC'),
	(332043, 142, '2015-02-01 00:24:23.000000', 'temperatura', 511.0000, 'ºC'),
	(332044, 142, '2015-02-01 00:24:24.000000', 'temperatura', 303.0000, 'ºC'),
	(332045, 142, '2015-02-01 00:24:25.000000', 'temperatura', 1181.0000, 'ºC'),
	(332046, 142, '2015-02-01 00:24:26.000000', 'temperatura', 199.0000, 'ºC'),
	(332047, 142, '2015-02-01 00:24:27.000000', 'temperatura', 1050.0000, 'ºC'),
	(332048, 142, '2015-02-01 00:24:28.000000', 'temperatura', 1055.0000, 'ºC'),
	(332049, 142, '2015-02-01 00:24:29.000000', 'temperatura', 927.0000, 'ºC'),
	(332050, 142, '2015-02-01 00:24:30.000000', 'temperatura', 269.0000, 'ºC'),
	(332051, 142, '2015-02-01 00:24:31.000000', 'temperatura', 963.0000, 'ºC'),
	(332052, 142, '2015-02-01 00:24:32.000000', 'temperatura', 412.0000, 'ºC'),
	(332053, 142, '2015-02-01 00:24:33.000000', 'temperatura', 369.0000, 'ºC'),
	(332054, 142, '2015-02-01 00:24:34.000000', 'temperatura', 608.0000, 'ºC'),
	(332055, 142, '2015-02-01 00:24:35.000000', 'temperatura', 736.0000, 'ºC'),
	(332056, 142, '2015-02-01 00:24:36.000000', 'temperatura', 657.0000, 'ºC'),
	(332057, 142, '2015-02-01 00:24:37.000000', 'temperatura', 1075.0000, 'ºC'),
	(332058, 142, '2015-02-01 00:24:38.000000', 'temperatura', 1006.0000, 'ºC'),
	(332059, 142, '2015-02-01 00:24:39.000000', 'temperatura', 603.0000, 'ºC'),
	(332060, 142, '2015-02-01 00:24:40.000000', 'temperatura', 0.0000, 'ºC'),
	(332061, 142, '2015-02-01 00:24:41.000000', 'temperatura', 593.0000, 'ºC'),
	(332062, 142, '2015-02-01 00:24:42.000000', 'temperatura', 564.0000, 'ºC'),
	(332063, 142, '2015-02-01 00:24:43.000000', 'temperatura', 1040.0000, 'ºC'),
	(332064, 142, '2015-02-01 00:24:44.000000', 'temperatura', 1109.0000, 'ºC'),
	(332065, 142, '2015-02-01 00:24:45.000000', 'temperatura', 27.0000, 'ºC'),
	(332066, 142, '2015-02-01 00:24:46.000000', 'temperatura', 408.0000, 'ºC'),
	(332067, 142, '2015-02-01 00:24:47.000000', 'temperatura', 758.0000, 'ºC'),
	(332068, 142, '2015-02-01 00:24:48.000000', 'temperatura', 169.0000, 'ºC'),
	(332069, 142, '2015-02-01 00:24:49.000000', 'temperatura', 969.0000, 'ºC'),
	(332070, 142, '2015-02-01 00:24:50.000000', 'temperatura', 738.0000, 'ºC'),
	(332071, 142, '2015-02-01 00:24:51.000000', 'temperatura', 786.0000, 'ºC'),
	(332072, 142, '2015-02-01 00:24:52.000000', 'temperatura', 517.0000, 'ºC'),
	(332073, 142, '2015-02-01 00:24:53.000000', 'temperatura', 226.0000, 'ºC'),
	(332074, 142, '2015-02-01 00:24:54.000000', 'temperatura', 781.0000, 'ºC'),
	(332075, 142, '2015-02-01 00:24:55.000000', 'temperatura', 827.0000, 'ºC'),
	(332076, 142, '2015-02-01 00:24:56.000000', 'temperatura', 592.0000, 'ºC'),
	(332077, 142, '2015-02-01 00:24:57.000000', 'temperatura', 478.0000, 'ºC'),
	(332078, 142, '2015-02-01 00:24:58.000000', 'temperatura', 615.0000, 'ºC'),
	(332079, 142, '2015-02-01 00:24:59.000000', 'temperatura', 441.0000, 'ºC'),
	(332080, 142, '2015-02-01 00:25:00.000000', 'temperatura', 361.0000, 'ºC'),
	(332081, 142, '2015-02-01 00:25:01.000000', 'temperatura', 482.0000, 'ºC'),
	(332082, 142, '2015-02-01 00:25:02.000000', 'temperatura', 129.0000, 'ºC'),
	(332083, 142, '2015-02-01 00:25:03.000000', 'temperatura', 397.0000, 'ºC'),
	(332084, 142, '2015-02-01 00:25:04.000000', 'temperatura', 399.0000, 'ºC'),
	(332085, 142, '2015-02-01 00:25:05.000000', 'temperatura', 805.0000, 'ºC'),
	(332086, 142, '2015-02-01 00:25:06.000000', 'temperatura', 427.0000, 'ºC'),
	(332087, 142, '2015-02-01 00:25:07.000000', 'temperatura', 922.0000, 'ºC'),
	(332088, 142, '2015-02-01 00:25:08.000000', 'temperatura', 930.0000, 'ºC'),
	(332089, 142, '2015-02-01 00:25:09.000000', 'temperatura', 683.0000, 'ºC'),
	(332090, 142, '2015-02-01 00:25:10.000000', 'temperatura', 626.0000, 'ºC'),
	(332091, 142, '2015-02-01 00:25:11.000000', 'temperatura', 1081.0000, 'ºC'),
	(332092, 142, '2015-02-01 00:25:12.000000', 'temperatura', 1126.0000, 'ºC'),
	(332093, 142, '2015-02-01 00:25:13.000000', 'temperatura', 1189.0000, 'ºC'),
	(332094, 142, '2015-02-01 00:25:14.000000', 'temperatura', 168.0000, 'ºC'),
	(332095, 142, '2015-02-01 00:25:15.000000', 'temperatura', 874.0000, 'ºC'),
	(332096, 142, '2015-02-01 00:25:16.000000', 'temperatura', 265.0000, 'ºC'),
	(332097, 142, '2015-02-01 00:25:17.000000', 'temperatura', 1105.0000, 'ºC'),
	(332098, 142, '2015-02-01 00:25:18.000000', 'temperatura', 1131.0000, 'ºC'),
	(332099, 142, '2015-02-01 00:25:19.000000', 'temperatura', 1139.0000, 'ºC'),
	(332100, 142, '2015-02-01 00:25:20.000000', 'temperatura', 1105.0000, 'ºC'),
	(332101, 142, '2015-02-01 00:25:21.000000', 'temperatura', 905.0000, 'ºC'),
	(332102, 142, '2015-02-01 00:25:22.000000', 'temperatura', 12.0000, 'ºC'),
	(332103, 142, '2015-02-01 00:25:23.000000', 'temperatura', 945.0000, 'ºC'),
	(332104, 142, '2015-02-01 00:25:24.000000', 'temperatura', 1089.0000, 'ºC'),
	(332105, 142, '2015-02-01 00:25:25.000000', 'temperatura', 210.0000, 'ºC'),
	(332106, 142, '2015-02-01 00:25:26.000000', 'temperatura', 185.0000, 'ºC'),
	(332107, 142, '2015-02-01 00:25:27.000000', 'temperatura', 293.0000, 'ºC'),
	(332108, 142, '2015-02-01 00:25:28.000000', 'temperatura', 912.0000, 'ºC'),
	(332109, 142, '2015-02-01 00:25:29.000000', 'temperatura', 81.0000, 'ºC'),
	(332110, 142, '2015-02-01 00:25:30.000000', 'temperatura', 68.0000, 'ºC'),
	(332111, 142, '2015-02-01 00:25:31.000000', 'temperatura', 99.0000, 'ºC'),
	(332112, 142, '2015-02-01 00:25:32.000000', 'temperatura', 293.0000, 'ºC'),
	(332113, 142, '2015-02-01 00:25:33.000000', 'temperatura', 1169.0000, 'ºC'),
	(332114, 142, '2015-02-01 00:25:34.000000', 'temperatura', 166.0000, 'ºC'),
	(332115, 142, '2015-02-01 00:25:35.000000', 'temperatura', 922.0000, 'ºC'),
	(332116, 142, '2015-02-01 00:25:36.000000', 'temperatura', 512.0000, 'ºC'),
	(332117, 142, '2015-02-01 00:25:37.000000', 'temperatura', 996.0000, 'ºC'),
	(332118, 142, '2015-02-01 00:25:38.000000', 'temperatura', 1045.0000, 'ºC'),
	(332119, 142, '2015-02-01 00:25:39.000000', 'temperatura', 1037.0000, 'ºC'),
	(332120, 142, '2015-02-01 00:25:40.000000', 'temperatura', 850.0000, 'ºC'),
	(332121, 142, '2015-02-01 00:25:41.000000', 'temperatura', 1141.0000, 'ºC'),
	(332122, 142, '2015-02-01 00:25:42.000000', 'temperatura', 753.0000, 'ºC'),
	(332123, 142, '2015-02-01 00:25:43.000000', 'temperatura', 342.0000, 'ºC'),
	(332124, 142, '2015-02-01 00:25:44.000000', 'temperatura', 654.0000, 'ºC'),
	(332125, 142, '2015-02-01 00:25:45.000000', 'temperatura', 1045.0000, 'ºC'),
	(332126, 142, '2015-02-01 00:25:46.000000', 'temperatura', 861.0000, 'ºC'),
	(332127, 142, '2015-02-01 00:25:47.000000', 'temperatura', 1173.0000, 'ºC'),
	(332128, 142, '2015-02-01 00:25:48.000000', 'temperatura', 882.0000, 'ºC'),
	(332129, 142, '2015-02-01 00:25:49.000000', 'temperatura', 890.0000, 'ºC'),
	(332130, 142, '2015-02-01 00:25:50.000000', 'temperatura', 604.0000, 'ºC'),
	(332131, 142, '2015-02-01 00:25:51.000000', 'temperatura', 352.0000, 'ºC'),
	(332132, 142, '2015-02-01 00:25:52.000000', 'temperatura', 1147.0000, 'ºC'),
	(332133, 142, '2015-02-01 00:25:53.000000', 'temperatura', 1082.0000, 'ºC'),
	(332134, 142, '2015-02-01 00:25:54.000000', 'temperatura', 767.0000, 'ºC'),
	(332135, 142, '2015-02-01 00:25:55.000000', 'temperatura', 591.0000, 'ºC'),
	(332136, 142, '2015-02-01 00:25:56.000000', 'temperatura', 655.0000, 'ºC'),
	(332137, 142, '2015-02-01 00:25:57.000000', 'temperatura', 301.0000, 'ºC'),
	(332138, 142, '2015-02-01 00:25:58.000000', 'temperatura', 739.0000, 'ºC'),
	(332139, 142, '2015-02-01 00:25:59.000000', 'temperatura', 395.0000, 'ºC'),
	(332140, 142, '2015-02-01 00:26:00.000000', 'temperatura', 956.0000, 'ºC'),
	(332141, 142, '2015-02-01 00:26:01.000000', 'temperatura', 1198.0000, 'ºC'),
	(332142, 142, '2015-02-01 00:26:02.000000', 'temperatura', 722.0000, 'ºC'),
	(332143, 142, '2015-02-01 00:26:03.000000', 'temperatura', 17.0000, 'ºC'),
	(332144, 142, '2015-02-01 00:26:04.000000', 'temperatura', 319.0000, 'ºC'),
	(332145, 142, '2015-02-01 00:26:05.000000', 'temperatura', 345.0000, 'ºC'),
	(332146, 142, '2015-02-01 00:26:06.000000', 'temperatura', 769.0000, 'ºC'),
	(332147, 142, '2015-02-01 00:26:07.000000', 'temperatura', 411.0000, 'ºC'),
	(332148, 142, '2015-02-01 00:26:08.000000', 'temperatura', 946.0000, 'ºC'),
	(332149, 142, '2015-02-01 00:26:09.000000', 'temperatura', 1098.0000, 'ºC'),
	(332150, 142, '2015-02-01 00:26:10.000000', 'temperatura', 254.0000, 'ºC'),
	(332151, 142, '2015-02-01 00:26:11.000000', 'temperatura', 375.0000, 'ºC'),
	(332152, 142, '2015-02-01 00:26:12.000000', 'temperatura', 1112.0000, 'ºC'),
	(332153, 142, '2015-02-01 00:26:13.000000', 'temperatura', 837.0000, 'ºC'),
	(332154, 142, '2015-02-01 00:26:14.000000', 'temperatura', 849.0000, 'ºC'),
	(332155, 142, '2015-02-01 00:26:15.000000', 'temperatura', 534.0000, 'ºC'),
	(332156, 142, '2015-02-01 00:26:16.000000', 'temperatura', 124.0000, 'ºC'),
	(332157, 142, '2015-02-01 00:26:17.000000', 'temperatura', 221.0000, 'ºC'),
	(332158, 142, '2015-02-01 00:26:18.000000', 'temperatura', 730.0000, 'ºC'),
	(332159, 142, '2015-02-01 00:26:19.000000', 'temperatura', 587.0000, 'ºC'),
	(332160, 142, '2015-02-01 00:26:20.000000', 'temperatura', 748.0000, 'ºC'),
	(332161, 142, '2015-02-01 00:26:21.000000', 'temperatura', 779.0000, 'ºC'),
	(332162, 142, '2015-02-01 00:26:22.000000', 'temperatura', 449.0000, 'ºC'),
	(332163, 142, '2015-02-01 00:26:23.000000', 'temperatura', 1110.0000, 'ºC'),
	(332164, 142, '2015-02-01 00:26:24.000000', 'temperatura', 605.0000, 'ºC'),
	(332165, 142, '2015-02-01 00:26:25.000000', 'temperatura', 896.0000, 'ºC'),
	(332166, 142, '2015-02-01 00:26:26.000000', 'temperatura', 264.0000, 'ºC'),
	(332167, 142, '2015-02-01 00:26:27.000000', 'temperatura', 1033.0000, 'ºC'),
	(332168, 142, '2015-02-01 00:26:28.000000', 'temperatura', 772.0000, 'ºC'),
	(332169, 142, '2015-02-01 00:26:29.000000', 'temperatura', 764.0000, 'ºC'),
	(332170, 142, '2015-02-01 00:26:30.000000', 'temperatura', 302.0000, 'ºC'),
	(332171, 142, '2015-02-01 00:26:31.000000', 'temperatura', 420.0000, 'ºC'),
	(332172, 142, '2015-02-01 00:26:32.000000', 'temperatura', 1195.0000, 'ºC'),
	(332173, 142, '2015-02-01 00:26:33.000000', 'temperatura', 1117.0000, 'ºC'),
	(332174, 142, '2015-02-01 00:26:34.000000', 'temperatura', 798.0000, 'ºC'),
	(332175, 142, '2015-02-01 00:26:35.000000', 'temperatura', 640.0000, 'ºC'),
	(332176, 142, '2015-02-01 00:26:36.000000', 'temperatura', 809.0000, 'ºC'),
	(332177, 142, '2015-02-01 00:26:37.000000', 'temperatura', 922.0000, 'ºC'),
	(332178, 142, '2015-02-01 00:26:38.000000', 'temperatura', 987.0000, 'ºC'),
	(332179, 142, '2015-02-01 00:26:39.000000', 'temperatura', 967.0000, 'ºC'),
	(332180, 142, '2015-02-01 00:26:40.000000', 'temperatura', 673.0000, 'ºC'),
	(332181, 142, '2015-02-01 00:26:41.000000', 'temperatura', 467.0000, 'ºC'),
	(332182, 142, '2015-02-01 00:26:42.000000', 'temperatura', 317.0000, 'ºC'),
	(332183, 142, '2015-02-01 00:26:43.000000', 'temperatura', 183.0000, 'ºC'),
	(332184, 142, '2015-02-01 00:26:44.000000', 'temperatura', 1166.0000, 'ºC'),
	(332185, 142, '2015-02-01 00:26:45.000000', 'temperatura', 480.0000, 'ºC'),
	(332186, 142, '2015-02-01 00:26:46.000000', 'temperatura', 103.0000, 'ºC'),
	(332187, 142, '2015-02-01 00:26:47.000000', 'temperatura', 276.0000, 'ºC'),
	(332188, 142, '2015-02-01 00:26:48.000000', 'temperatura', 1072.0000, 'ºC'),
	(332189, 142, '2015-02-01 00:26:49.000000', 'temperatura', 932.0000, 'ºC'),
	(332190, 142, '2015-02-01 00:26:50.000000', 'temperatura', 244.0000, 'ºC'),
	(332191, 142, '2015-02-01 00:26:51.000000', 'temperatura', 823.0000, 'ºC'),
	(332192, 142, '2015-02-01 00:26:52.000000', 'temperatura', 985.0000, 'ºC'),
	(332193, 142, '2015-02-01 00:26:53.000000', 'temperatura', 56.0000, 'ºC'),
	(332194, 142, '2015-02-01 00:26:54.000000', 'temperatura', 927.0000, 'ºC'),
	(332195, 142, '2015-02-01 00:26:55.000000', 'temperatura', 866.0000, 'ºC'),
	(332196, 142, '2015-02-01 00:26:56.000000', 'temperatura', 349.0000, 'ºC'),
	(332197, 142, '2015-02-01 00:26:57.000000', 'temperatura', 347.0000, 'ºC'),
	(332198, 142, '2015-02-01 00:26:58.000000', 'temperatura', 691.0000, 'ºC'),
	(332199, 142, '2015-02-01 00:26:59.000000', 'temperatura', 14.0000, 'ºC'),
	(332200, 142, '2015-02-01 00:27:00.000000', 'temperatura', 397.0000, 'ºC'),
	(332201, 142, '2015-02-01 00:27:01.000000', 'temperatura', 743.0000, 'ºC'),
	(332202, 142, '2015-02-01 00:27:02.000000', 'temperatura', 126.0000, 'ºC'),
	(332203, 142, '2015-02-01 00:27:03.000000', 'temperatura', 799.0000, 'ºC'),
	(332204, 142, '2015-02-01 00:27:04.000000', 'temperatura', 20.0000, 'ºC'),
	(332205, 142, '2015-02-01 00:27:05.000000', 'temperatura', 105.0000, 'ºC'),
	(332206, 142, '2015-02-01 00:27:06.000000', 'temperatura', 462.0000, 'ºC'),
	(332207, 142, '2015-02-01 00:27:07.000000', 'temperatura', 797.0000, 'ºC'),
	(332208, 142, '2015-02-01 00:27:08.000000', 'temperatura', 200.0000, 'ºC'),
	(332209, 142, '2015-02-01 00:27:09.000000', 'temperatura', 1007.0000, 'ºC'),
	(332210, 142, '2015-02-01 00:27:10.000000', 'temperatura', 839.0000, 'ºC'),
	(332211, 142, '2015-02-01 00:27:11.000000', 'temperatura', 1173.0000, 'ºC'),
	(332212, 142, '2015-02-01 00:27:12.000000', 'temperatura', 950.0000, 'ºC'),
	(332213, 142, '2015-02-01 00:27:13.000000', 'temperatura', 30.0000, 'ºC'),
	(332214, 142, '2015-02-01 00:27:14.000000', 'temperatura', 901.0000, 'ºC'),
	(332215, 142, '2015-02-01 00:27:15.000000', 'temperatura', 816.0000, 'ºC'),
	(332216, 142, '2015-02-01 00:27:16.000000', 'temperatura', 179.0000, 'ºC'),
	(332217, 142, '2015-02-01 00:27:17.000000', 'temperatura', 845.0000, 'ºC'),
	(332218, 142, '2015-02-01 00:27:18.000000', 'temperatura', 88.0000, 'ºC'),
	(332219, 142, '2015-02-01 00:27:19.000000', 'temperatura', 307.0000, 'ºC'),
	(332220, 142, '2015-02-01 00:27:20.000000', 'temperatura', 71.0000, 'ºC'),
	(332221, 142, '2015-02-01 00:27:21.000000', 'temperatura', 637.0000, 'ºC'),
	(332222, 142, '2015-02-01 00:27:22.000000', 'temperatura', 569.0000, 'ºC'),
	(332223, 142, '2015-02-01 00:27:23.000000', 'temperatura', 935.0000, 'ºC'),
	(332224, 142, '2015-02-01 00:27:24.000000', 'temperatura', 569.0000, 'ºC'),
	(332225, 142, '2015-02-01 00:27:25.000000', 'temperatura', 42.0000, 'ºC'),
	(332226, 142, '2015-02-01 00:27:26.000000', 'temperatura', 900.0000, 'ºC'),
	(332227, 142, '2015-02-01 00:27:27.000000', 'temperatura', 778.0000, 'ºC'),
	(332228, 142, '2015-02-01 00:27:28.000000', 'temperatura', 1190.0000, 'ºC'),
	(332229, 142, '2015-02-01 00:27:29.000000', 'temperatura', 16.0000, 'ºC'),
	(332230, 142, '2015-02-01 00:27:30.000000', 'temperatura', 113.0000, 'ºC'),
	(332231, 142, '2015-02-01 00:27:31.000000', 'temperatura', 514.0000, 'ºC'),
	(332232, 142, '2015-02-01 00:27:32.000000', 'temperatura', 1032.0000, 'ºC'),
	(332233, 142, '2015-02-01 00:27:33.000000', 'temperatura', 19.0000, 'ºC'),
	(332234, 142, '2015-02-01 00:27:34.000000', 'temperatura', 600.0000, 'ºC'),
	(332235, 142, '2015-02-01 00:27:35.000000', 'temperatura', 541.0000, 'ºC'),
	(332236, 142, '2015-02-01 00:27:36.000000', 'temperatura', 908.0000, 'ºC'),
	(332237, 142, '2015-02-01 00:27:37.000000', 'temperatura', 517.0000, 'ºC'),
	(332238, 142, '2015-02-01 00:27:38.000000', 'temperatura', 1059.0000, 'ºC'),
	(332239, 142, '2015-02-01 00:27:39.000000', 'temperatura', 147.0000, 'ºC'),
	(332240, 142, '2015-02-01 00:27:40.000000', 'temperatura', 1159.0000, 'ºC'),
	(332241, 142, '2015-02-01 00:27:41.000000', 'temperatura', 554.0000, 'ºC'),
	(332242, 142, '2015-02-01 00:27:42.000000', 'temperatura', 492.0000, 'ºC'),
	(332243, 142, '2015-02-01 00:27:43.000000', 'temperatura', 801.0000, 'ºC'),
	(332244, 142, '2015-02-01 00:27:44.000000', 'temperatura', 129.0000, 'ºC'),
	(332245, 142, '2015-02-01 00:27:45.000000', 'temperatura', 643.0000, 'ºC'),
	(332246, 142, '2015-02-01 00:27:46.000000', 'temperatura', 429.0000, 'ºC'),
	(332247, 142, '2015-02-01 00:27:47.000000', 'temperatura', 215.0000, 'ºC'),
	(332248, 142, '2015-02-01 00:27:48.000000', 'temperatura', 991.0000, 'ºC'),
	(332249, 142, '2015-02-01 00:27:49.000000', 'temperatura', 708.0000, 'ºC'),
	(332250, 142, '2015-02-01 00:27:50.000000', 'temperatura', 570.0000, 'ºC'),
	(332251, 142, '2015-02-01 00:27:51.000000', 'temperatura', 725.0000, 'ºC'),
	(332252, 142, '2015-02-01 00:27:52.000000', 'temperatura', 716.0000, 'ºC'),
	(332253, 142, '2015-02-01 00:27:53.000000', 'temperatura', 204.0000, 'ºC'),
	(332254, 142, '2015-02-01 00:27:54.000000', 'temperatura', 71.0000, 'ºC'),
	(332255, 142, '2015-02-01 00:27:55.000000', 'temperatura', 947.0000, 'ºC'),
	(332256, 142, '2015-02-01 00:27:56.000000', 'temperatura', 921.0000, 'ºC'),
	(332257, 142, '2015-02-01 00:27:57.000000', 'temperatura', 563.0000, 'ºC'),
	(332258, 142, '2015-02-01 00:27:58.000000', 'temperatura', 55.0000, 'ºC'),
	(332259, 142, '2015-02-01 00:27:59.000000', 'temperatura', 985.0000, 'ºC'),
	(332260, 142, '2015-02-01 00:28:00.000000', 'temperatura', 1161.0000, 'ºC'),
	(332261, 142, '2015-02-01 00:28:01.000000', 'temperatura', 452.0000, 'ºC'),
	(332262, 142, '2015-02-01 00:28:02.000000', 'temperatura', 1174.0000, 'ºC'),
	(332263, 142, '2015-02-01 00:28:03.000000', 'temperatura', 918.0000, 'ºC'),
	(332264, 142, '2015-02-01 00:28:04.000000', 'temperatura', 1066.0000, 'ºC'),
	(332265, 142, '2015-02-01 00:28:05.000000', 'temperatura', 176.0000, 'ºC'),
	(332266, 142, '2015-02-01 00:28:06.000000', 'temperatura', 82.0000, 'ºC'),
	(332267, 142, '2015-02-01 00:28:07.000000', 'temperatura', 1082.0000, 'ºC'),
	(332268, 142, '2015-02-01 00:28:08.000000', 'temperatura', 367.0000, 'ºC'),
	(332269, 142, '2015-02-01 00:28:09.000000', 'temperatura', 989.0000, 'ºC'),
	(332270, 142, '2015-02-01 00:28:10.000000', 'temperatura', 243.0000, 'ºC'),
	(332271, 142, '2015-02-01 00:28:11.000000', 'temperatura', 650.0000, 'ºC'),
	(332272, 142, '2015-02-01 00:28:12.000000', 'temperatura', 121.0000, 'ºC'),
	(332273, 142, '2015-02-01 00:28:13.000000', 'temperatura', 1056.0000, 'ºC'),
	(332274, 142, '2015-02-01 00:28:14.000000', 'temperatura', 119.0000, 'ºC'),
	(332275, 142, '2015-02-01 00:28:15.000000', 'temperatura', 1027.0000, 'ºC'),
	(332276, 142, '2015-02-01 00:28:16.000000', 'temperatura', 1176.0000, 'ºC'),
	(332277, 142, '2015-02-01 00:28:17.000000', 'temperatura', 403.0000, 'ºC'),
	(332278, 142, '2015-02-01 00:28:18.000000', 'temperatura', 884.0000, 'ºC'),
	(332279, 142, '2015-02-01 00:28:19.000000', 'temperatura', 814.0000, 'ºC'),
	(332280, 142, '2015-02-01 00:28:20.000000', 'temperatura', 216.0000, 'ºC'),
	(332281, 142, '2015-02-01 00:28:21.000000', 'temperatura', 1041.0000, 'ºC'),
	(332282, 142, '2015-02-01 00:28:22.000000', 'temperatura', 957.0000, 'ºC'),
	(332283, 142, '2015-02-01 00:28:23.000000', 'temperatura', 461.0000, 'ºC'),
	(332284, 142, '2015-02-01 00:28:24.000000', 'temperatura', 634.0000, 'ºC'),
	(332285, 142, '2015-02-01 00:28:25.000000', 'temperatura', 590.0000, 'ºC'),
	(332286, 142, '2015-02-01 00:28:26.000000', 'temperatura', 1047.0000, 'ºC'),
	(332287, 142, '2015-02-01 00:28:27.000000', 'temperatura', 1067.0000, 'ºC'),
	(332288, 142, '2015-02-01 00:28:28.000000', 'temperatura', 993.0000, 'ºC'),
	(332289, 142, '2015-02-01 00:28:29.000000', 'temperatura', 567.0000, 'ºC'),
	(332290, 142, '2015-02-01 00:28:30.000000', 'temperatura', 1053.0000, 'ºC'),
	(332291, 142, '2015-02-01 00:28:31.000000', 'temperatura', 1166.0000, 'ºC'),
	(332292, 142, '2015-02-01 00:28:32.000000', 'temperatura', 273.0000, 'ºC'),
	(332293, 142, '2015-02-01 00:28:33.000000', 'temperatura', 265.0000, 'ºC'),
	(332294, 142, '2015-02-01 00:28:34.000000', 'temperatura', 508.0000, 'ºC'),
	(332295, 142, '2015-02-01 00:28:35.000000', 'temperatura', 546.0000, 'ºC'),
	(332296, 142, '2015-02-01 00:28:36.000000', 'temperatura', 7.0000, 'ºC'),
	(332297, 142, '2015-02-01 00:28:37.000000', 'temperatura', 797.0000, 'ºC'),
	(332298, 142, '2015-02-01 00:28:38.000000', 'temperatura', 363.0000, 'ºC'),
	(332299, 142, '2015-02-01 00:28:39.000000', 'temperatura', 626.0000, 'ºC'),
	(332300, 142, '2015-02-01 00:28:40.000000', 'temperatura', 841.0000, 'ºC'),
	(332301, 142, '2015-02-01 00:28:41.000000', 'temperatura', 1129.0000, 'ºC'),
	(332302, 142, '2015-02-01 00:28:42.000000', 'temperatura', 721.0000, 'ºC'),
	(332303, 142, '2015-02-01 00:28:43.000000', 'temperatura', 218.0000, 'ºC'),
	(332304, 142, '2015-02-01 00:28:44.000000', 'temperatura', 130.0000, 'ºC'),
	(332305, 142, '2015-02-01 00:28:45.000000', 'temperatura', 1195.0000, 'ºC'),
	(332306, 142, '2015-02-01 00:28:46.000000', 'temperatura', 787.0000, 'ºC'),
	(332307, 142, '2015-02-01 00:28:47.000000', 'temperatura', 348.0000, 'ºC'),
	(332308, 142, '2015-02-01 00:28:48.000000', 'temperatura', 580.0000, 'ºC'),
	(332309, 142, '2015-02-01 00:28:49.000000', 'temperatura', 656.0000, 'ºC'),
	(332310, 142, '2015-02-01 00:28:50.000000', 'temperatura', 340.0000, 'ºC'),
	(332311, 142, '2015-02-01 00:28:51.000000', 'temperatura', 934.0000, 'ºC'),
	(332312, 142, '2015-02-01 00:28:52.000000', 'temperatura', 51.0000, 'ºC'),
	(332313, 142, '2015-02-01 00:28:53.000000', 'temperatura', 1053.0000, 'ºC'),
	(332314, 142, '2015-02-01 00:28:54.000000', 'temperatura', 311.0000, 'ºC'),
	(332315, 142, '2015-02-01 00:28:55.000000', 'temperatura', 799.0000, 'ºC'),
	(332316, 142, '2015-02-01 00:28:56.000000', 'temperatura', 663.0000, 'ºC'),
	(332317, 142, '2015-02-01 00:28:57.000000', 'temperatura', 917.0000, 'ºC'),
	(332318, 142, '2015-02-01 00:28:58.000000', 'temperatura', 199.0000, 'ºC'),
	(332319, 142, '2015-02-01 00:28:59.000000', 'temperatura', 641.0000, 'ºC'),
	(332320, 142, '2015-02-01 00:29:00.000000', 'temperatura', 211.0000, 'ºC'),
	(332321, 142, '2015-02-01 00:29:01.000000', 'temperatura', 333.0000, 'ºC'),
	(332322, 142, '2015-02-01 00:29:02.000000', 'temperatura', 1033.0000, 'ºC'),
	(332323, 142, '2015-02-01 00:29:03.000000', 'temperatura', 567.0000, 'ºC'),
	(332324, 142, '2015-02-01 00:29:04.000000', 'temperatura', 935.0000, 'ºC'),
	(332325, 142, '2015-02-01 00:29:05.000000', 'temperatura', 574.0000, 'ºC'),
	(332326, 142, '2015-02-01 00:29:06.000000', 'temperatura', 67.0000, 'ºC'),
	(332327, 142, '2015-02-01 00:29:07.000000', 'temperatura', 1014.0000, 'ºC'),
	(332328, 142, '2015-02-01 00:29:08.000000', 'temperatura', 69.0000, 'ºC'),
	(332329, 142, '2015-02-01 00:29:09.000000', 'temperatura', 903.0000, 'ºC'),
	(332330, 142, '2015-02-01 00:29:10.000000', 'temperatura', 709.0000, 'ºC'),
	(332331, 142, '2015-02-01 00:29:11.000000', 'temperatura', 838.0000, 'ºC'),
	(332332, 142, '2015-02-01 00:29:12.000000', 'temperatura', 863.0000, 'ºC'),
	(332333, 142, '2015-02-01 00:29:13.000000', 'temperatura', 603.0000, 'ºC'),
	(332334, 142, '2015-02-01 00:29:14.000000', 'temperatura', 424.0000, 'ºC'),
	(332335, 142, '2015-02-01 00:29:15.000000', 'temperatura', 312.0000, 'ºC'),
	(332336, 142, '2015-02-01 00:29:16.000000', 'temperatura', 288.0000, 'ºC'),
	(332337, 142, '2015-02-01 00:29:17.000000', 'temperatura', 505.0000, 'ºC'),
	(332338, 142, '2015-02-01 00:29:18.000000', 'temperatura', 459.0000, 'ºC'),
	(332339, 142, '2015-02-01 00:29:19.000000', 'temperatura', 784.0000, 'ºC'),
	(332340, 142, '2015-02-01 00:29:20.000000', 'temperatura', 143.0000, 'ºC'),
	(332341, 142, '2015-02-01 00:29:21.000000', 'temperatura', 764.0000, 'ºC'),
	(332342, 142, '2015-02-01 00:29:22.000000', 'temperatura', 992.0000, 'ºC'),
	(332343, 142, '2015-02-01 00:29:23.000000', 'temperatura', 267.0000, 'ºC'),
	(332344, 142, '2015-02-01 00:29:24.000000', 'temperatura', 760.0000, 'ºC'),
	(332345, 142, '2015-02-01 00:29:25.000000', 'temperatura', 601.0000, 'ºC'),
	(332346, 142, '2015-02-01 00:29:26.000000', 'temperatura', 726.0000, 'ºC'),
	(332347, 142, '2015-02-01 00:29:27.000000', 'temperatura', 624.0000, 'ºC'),
	(332348, 142, '2015-02-01 00:29:28.000000', 'temperatura', 946.0000, 'ºC'),
	(332349, 142, '2015-02-01 00:29:29.000000', 'temperatura', 455.0000, 'ºC'),
	(332350, 142, '2015-02-01 00:29:30.000000', 'temperatura', 640.0000, 'ºC'),
	(332351, 142, '2015-02-01 00:29:31.000000', 'temperatura', 634.0000, 'ºC'),
	(332352, 142, '2015-02-01 00:29:32.000000', 'temperatura', 50.0000, 'ºC'),
	(332353, 142, '2015-02-01 00:29:33.000000', 'temperatura', 747.0000, 'ºC'),
	(332354, 142, '2015-02-01 00:29:34.000000', 'temperatura', 1189.0000, 'ºC'),
	(332355, 142, '2015-02-01 00:29:35.000000', 'temperatura', 103.0000, 'ºC'),
	(332356, 142, '2015-02-01 00:29:36.000000', 'temperatura', 549.0000, 'ºC'),
	(332357, 142, '2015-02-01 00:29:37.000000', 'temperatura', 34.0000, 'ºC'),
	(332358, 142, '2015-02-01 00:29:38.000000', 'temperatura', 925.0000, 'ºC'),
	(332359, 142, '2015-02-01 00:29:39.000000', 'temperatura', 926.0000, 'ºC'),
	(332360, 142, '2015-02-01 00:29:40.000000', 'temperatura', 652.0000, 'ºC'),
	(332361, 142, '2015-02-01 00:29:41.000000', 'temperatura', 485.0000, 'ºC'),
	(332362, 142, '2015-02-01 00:29:42.000000', 'temperatura', 467.0000, 'ºC'),
	(332363, 142, '2015-02-01 00:29:43.000000', 'temperatura', 884.0000, 'ºC'),
	(332364, 142, '2015-02-01 00:29:44.000000', 'temperatura', 616.0000, 'ºC'),
	(332365, 142, '2015-02-01 00:29:45.000000', 'temperatura', 432.0000, 'ºC'),
	(332366, 142, '2015-02-01 00:29:46.000000', 'temperatura', 310.0000, 'ºC'),
	(332367, 142, '2015-02-01 00:29:47.000000', 'temperatura', 254.0000, 'ºC'),
	(332368, 142, '2015-02-01 00:29:48.000000', 'temperatura', 343.0000, 'ºC'),
	(332369, 142, '2015-02-01 00:29:49.000000', 'temperatura', 952.0000, 'ºC'),
	(332370, 142, '2015-02-01 00:29:50.000000', 'temperatura', 133.0000, 'ºC'),
	(332371, 142, '2015-02-01 00:29:51.000000', 'temperatura', 210.0000, 'ºC'),
	(332372, 142, '2015-02-01 00:29:52.000000', 'temperatura', 650.0000, 'ºC'),
	(332373, 142, '2015-02-01 00:29:53.000000', 'temperatura', 223.0000, 'ºC'),
	(332374, 142, '2015-02-01 00:29:54.000000', 'temperatura', 363.0000, 'ºC'),
	(332375, 142, '2015-02-01 00:29:55.000000', 'temperatura', 1147.0000, 'ºC'),
	(332376, 142, '2015-02-01 00:29:56.000000', 'temperatura', 1046.0000, 'ºC'),
	(332377, 142, '2015-02-01 00:29:57.000000', 'temperatura', 588.0000, 'ºC'),
	(332378, 142, '2015-02-01 00:29:58.000000', 'temperatura', 1004.0000, 'ºC'),
	(332379, 142, '2015-02-01 00:29:59.000000', 'temperatura', 857.0000, 'ºC'),
	(332380, 142, '2015-02-01 00:30:00.000000', 'temperatura', 72.0000, 'ºC'),
	(332381, 142, '2015-02-01 00:30:01.000000', 'temperatura', 189.0000, 'ºC'),
	(332382, 142, '2015-02-01 00:30:02.000000', 'temperatura', 730.0000, 'ºC'),
	(332383, 142, '2015-02-01 00:30:03.000000', 'temperatura', 682.0000, 'ºC'),
	(332384, 142, '2015-02-01 00:30:04.000000', 'temperatura', 21.0000, 'ºC'),
	(332385, 142, '2015-02-01 00:30:05.000000', 'temperatura', 458.0000, 'ºC'),
	(332386, 142, '2015-02-01 00:30:06.000000', 'temperatura', 1031.0000, 'ºC'),
	(332387, 142, '2015-02-01 00:30:07.000000', 'temperatura', 180.0000, 'ºC'),
	(332388, 142, '2015-02-01 00:30:08.000000', 'temperatura', 206.0000, 'ºC'),
	(332389, 142, '2015-02-01 00:30:09.000000', 'temperatura', 491.0000, 'ºC'),
	(332390, 142, '2015-02-01 00:30:10.000000', 'temperatura', 640.0000, 'ºC'),
	(332391, 142, '2015-02-01 00:30:11.000000', 'temperatura', 524.0000, 'ºC'),
	(332392, 142, '2015-02-01 00:30:12.000000', 'temperatura', 704.0000, 'ºC'),
	(332393, 142, '2015-02-01 00:30:13.000000', 'temperatura', 747.0000, 'ºC'),
	(332394, 142, '2015-02-01 00:30:14.000000', 'temperatura', 422.0000, 'ºC'),
	(332395, 142, '2015-02-01 00:30:15.000000', 'temperatura', 1069.0000, 'ºC'),
	(332396, 142, '2015-02-01 00:30:16.000000', 'temperatura', 480.0000, 'ºC'),
	(332397, 142, '2015-02-01 00:30:17.000000', 'temperatura', 396.0000, 'ºC'),
	(332398, 142, '2015-02-01 00:30:18.000000', 'temperatura', 539.0000, 'ºC'),
	(332399, 142, '2015-02-01 00:30:19.000000', 'temperatura', 308.0000, 'ºC'),
	(332400, 142, '2015-02-01 00:30:20.000000', 'temperatura', 1124.0000, 'ºC'),
	(332401, 142, '2015-02-01 00:30:21.000000', 'temperatura', 1094.0000, 'ºC'),
	(332402, 142, '2015-02-01 00:30:22.000000', 'temperatura', 899.0000, 'ºC'),
	(332403, 142, '2015-02-01 00:30:23.000000', 'temperatura', 14.0000, 'ºC'),
	(332404, 142, '2015-02-01 00:30:24.000000', 'temperatura', 973.0000, 'ºC'),
	(332405, 142, '2015-02-01 00:30:25.000000', 'temperatura', 23.0000, 'ºC'),
	(332406, 142, '2015-02-01 00:30:26.000000', 'temperatura', 796.0000, 'ºC'),
	(332407, 142, '2015-02-01 00:30:27.000000', 'temperatura', 312.0000, 'ºC'),
	(332408, 142, '2015-02-01 00:30:28.000000', 'temperatura', 374.0000, 'ºC'),
	(332409, 142, '2015-02-01 00:30:29.000000', 'temperatura', 934.0000, 'ºC'),
	(332410, 142, '2015-02-01 00:30:30.000000', 'temperatura', 1147.0000, 'ºC'),
	(332411, 142, '2015-02-01 00:30:31.000000', 'temperatura', 535.0000, 'ºC'),
	(332412, 142, '2015-02-01 00:30:32.000000', 'temperatura', 432.0000, 'ºC'),
	(332413, 142, '2015-02-01 00:30:33.000000', 'temperatura', 559.0000, 'ºC'),
	(332414, 142, '2015-02-01 00:30:34.000000', 'temperatura', 298.0000, 'ºC'),
	(332415, 142, '2015-02-01 00:30:35.000000', 'temperatura', 1012.0000, 'ºC'),
	(332416, 142, '2015-02-01 00:30:36.000000', 'temperatura', 567.0000, 'ºC'),
	(332417, 142, '2015-02-01 00:30:37.000000', 'temperatura', 999.0000, 'ºC'),
	(332418, 142, '2015-02-01 00:30:38.000000', 'temperatura', 895.0000, 'ºC'),
	(332419, 142, '2015-02-01 00:30:39.000000', 'temperatura', 277.0000, 'ºC'),
	(332420, 142, '2015-02-01 00:30:40.000000', 'temperatura', 1100.0000, 'ºC'),
	(332421, 142, '2015-02-01 00:30:41.000000', 'temperatura', 1070.0000, 'ºC'),
	(332422, 142, '2015-02-01 00:30:42.000000', 'temperatura', 852.0000, 'ºC'),
	(332423, 142, '2015-02-01 00:30:43.000000', 'temperatura', 1048.0000, 'ºC'),
	(332424, 142, '2015-02-01 00:30:44.000000', 'temperatura', 285.0000, 'ºC'),
	(332425, 142, '2015-02-01 00:30:45.000000', 'temperatura', 680.0000, 'ºC'),
	(332426, 142, '2015-02-01 00:30:46.000000', 'temperatura', 147.0000, 'ºC'),
	(332427, 142, '2015-02-01 00:30:47.000000', 'temperatura', 1097.0000, 'ºC'),
	(332428, 142, '2015-02-01 00:30:48.000000', 'temperatura', 242.0000, 'ºC'),
	(332429, 142, '2015-02-01 00:30:49.000000', 'temperatura', 322.0000, 'ºC'),
	(332430, 142, '2015-02-01 00:30:50.000000', 'temperatura', 883.0000, 'ºC'),
	(332431, 142, '2015-02-01 00:30:51.000000', 'temperatura', 1051.0000, 'ºC'),
	(332432, 142, '2015-02-01 00:30:52.000000', 'temperatura', 206.0000, 'ºC'),
	(332433, 142, '2015-02-01 00:30:53.000000', 'temperatura', 277.0000, 'ºC'),
	(332434, 142, '2015-02-01 00:30:54.000000', 'temperatura', 769.0000, 'ºC'),
	(332435, 142, '2015-02-01 00:30:55.000000', 'temperatura', 612.0000, 'ºC'),
	(332436, 142, '2015-02-01 00:30:56.000000', 'temperatura', 753.0000, 'ºC'),
	(332437, 142, '2015-02-01 00:30:57.000000', 'temperatura', 731.0000, 'ºC'),
	(332438, 142, '2015-02-01 00:30:58.000000', 'temperatura', 197.0000, 'ºC'),
	(332439, 142, '2015-02-01 00:30:59.000000', 'temperatura', 1191.0000, 'ºC'),
	(332440, 142, '2015-02-01 00:31:00.000000', 'temperatura', 567.0000, 'ºC'),
	(332441, 142, '2015-02-01 00:31:01.000000', 'temperatura', 462.0000, 'ºC'),
	(332442, 142, '2015-02-01 00:31:02.000000', 'temperatura', 609.0000, 'ºC'),
	(332443, 142, '2015-02-01 00:31:03.000000', 'temperatura', 458.0000, 'ºC'),
	(332444, 142, '2015-02-01 00:31:04.000000', 'temperatura', 463.0000, 'ºC'),
	(332445, 142, '2015-02-01 00:31:05.000000', 'temperatura', 943.0000, 'ºC'),
	(332446, 142, '2015-02-01 00:31:06.000000', 'temperatura', 928.0000, 'ºC'),
	(332447, 142, '2015-02-01 00:31:07.000000', 'temperatura', 610.0000, 'ºC'),
	(332448, 142, '2015-02-01 00:31:08.000000', 'temperatura', 268.0000, 'ºC'),
	(332449, 142, '2015-02-01 00:31:09.000000', 'temperatura', 709.0000, 'ºC'),
	(332450, 142, '2015-02-01 00:31:10.000000', 'temperatura', 341.0000, 'ºC'),
	(332451, 142, '2015-02-01 00:31:11.000000', 'temperatura', 778.0000, 'ºC'),
	(332452, 142, '2015-02-01 00:31:12.000000', 'temperatura', 468.0000, 'ºC'),
	(332453, 142, '2015-02-01 00:31:13.000000', 'temperatura', 6.0000, 'ºC'),
	(332454, 142, '2015-02-01 00:31:14.000000', 'temperatura', 1028.0000, 'ºC'),
	(332455, 142, '2015-02-01 00:31:15.000000', 'temperatura', 320.0000, 'ºC'),
	(332456, 142, '2015-02-01 00:31:16.000000', 'temperatura', 920.0000, 'ºC'),
	(332457, 142, '2015-02-01 00:31:17.000000', 'temperatura', 38.0000, 'ºC'),
	(332458, 142, '2015-02-01 00:31:18.000000', 'temperatura', 1033.0000, 'ºC'),
	(332459, 142, '2015-02-01 00:31:19.000000', 'temperatura', 249.0000, 'ºC'),
	(332460, 142, '2015-02-01 00:31:20.000000', 'temperatura', 546.0000, 'ºC'),
	(332461, 142, '2015-02-01 00:31:21.000000', 'temperatura', 784.0000, 'ºC'),
	(332462, 142, '2015-02-01 00:31:22.000000', 'temperatura', 1082.0000, 'ºC'),
	(332463, 142, '2015-02-01 00:31:23.000000', 'temperatura', 658.0000, 'ºC'),
	(332464, 142, '2015-02-01 00:31:24.000000', 'temperatura', 44.0000, 'ºC'),
	(332465, 142, '2015-02-01 00:31:25.000000', 'temperatura', 645.0000, 'ºC'),
	(332466, 142, '2015-02-01 00:31:26.000000', 'temperatura', 696.0000, 'ºC'),
	(332467, 142, '2015-02-01 00:31:27.000000', 'temperatura', 347.0000, 'ºC'),
	(332468, 142, '2015-02-01 00:31:28.000000', 'temperatura', 846.0000, 'ºC'),
	(332469, 142, '2015-02-01 00:31:29.000000', 'temperatura', 789.0000, 'ºC'),
	(332470, 142, '2015-02-01 00:31:30.000000', 'temperatura', 206.0000, 'ºC'),
	(332471, 142, '2015-02-01 00:31:31.000000', 'temperatura', 1067.0000, 'ºC'),
	(332472, 142, '2015-02-01 00:31:32.000000', 'temperatura', 1116.0000, 'ºC'),
	(332473, 142, '2015-02-01 00:31:33.000000', 'temperatura', 1178.0000, 'ºC'),
	(332474, 142, '2015-02-01 00:31:34.000000', 'temperatura', 143.0000, 'ºC'),
	(332475, 142, '2015-02-01 00:31:35.000000', 'temperatura', 782.0000, 'ºC'),
	(332476, 142, '2015-02-01 00:31:36.000000', 'temperatura', 1082.0000, 'ºC'),
	(332477, 142, '2015-02-01 00:31:37.000000', 'temperatura', 662.0000, 'ºC'),
	(332478, 142, '2015-02-01 00:31:38.000000', 'temperatura', 66.0000, 'ºC'),
	(332479, 142, '2015-02-01 00:31:39.000000', 'temperatura', 745.0000, 'ºC'),
	(332480, 142, '2015-02-01 00:31:40.000000', 'temperatura', 1129.0000, 'ºC'),
	(332481, 142, '2015-02-01 00:31:41.000000', 'temperatura', 1010.0000, 'ºC'),
	(332482, 142, '2015-02-01 00:31:42.000000', 'temperatura', 462.0000, 'ºC'),
	(332483, 142, '2015-02-01 00:31:43.000000', 'temperatura', 482.0000, 'ºC'),
	(332484, 142, '2015-02-01 00:31:44.000000', 'temperatura', 1023.0000, 'ºC'),
	(332485, 142, '2015-02-01 00:31:45.000000', 'temperatura', 68.0000, 'ºC'),
	(332486, 142, '2015-02-01 00:31:46.000000', 'temperatura', 874.0000, 'ºC'),
	(332487, 142, '2015-02-01 00:31:47.000000', 'temperatura', 567.0000, 'ºC'),
	(332488, 142, '2015-02-01 00:31:48.000000', 'temperatura', 212.0000, 'ºC'),
	(332489, 142, '2015-02-01 00:31:49.000000', 'temperatura', 558.0000, 'ºC'),
	(332490, 142, '2015-02-01 00:31:50.000000', 'temperatura', 956.0000, 'ºC'),
	(332491, 142, '2015-02-01 00:31:51.000000', 'temperatura', 706.0000, 'ºC'),
	(332492, 142, '2015-02-01 00:31:52.000000', 'temperatura', 663.0000, 'ºC'),
	(332493, 142, '2015-02-01 00:31:53.000000', 'temperatura', 1198.0000, 'ºC'),
	(332494, 142, '2015-02-01 00:31:54.000000', 'temperatura', 401.0000, 'ºC'),
	(332495, 142, '2015-02-01 00:31:55.000000', 'temperatura', 811.0000, 'ºC'),
	(332496, 142, '2015-02-01 00:31:56.000000', 'temperatura', 453.0000, 'ºC'),
	(332497, 142, '2015-02-01 00:31:57.000000', 'temperatura', 1033.0000, 'ºC'),
	(332498, 142, '2015-02-01 00:31:58.000000', 'temperatura', 206.0000, 'ºC'),
	(332499, 142, '2015-02-01 00:31:59.000000', 'temperatura', 331.0000, 'ºC'),
	(332500, 142, '2015-02-01 00:32:00.000000', 'temperatura', 1037.0000, 'ºC'),
	(332501, 142, '2015-02-01 00:32:01.000000', 'temperatura', 591.0000, 'ºC'),
	(332502, 142, '2015-02-01 00:32:02.000000', 'temperatura', 1046.0000, 'ºC'),
	(332503, 142, '2015-02-01 00:32:03.000000', 'temperatura', 1060.0000, 'ºC'),
	(332504, 142, '2015-02-01 00:32:04.000000', 'temperatura', 959.0000, 'ºC'),
	(332505, 142, '2015-02-01 00:32:05.000000', 'temperatura', 416.0000, 'ºC'),
	(332506, 142, '2015-02-01 00:32:06.000000', 'temperatura', 404.0000, 'ºC'),
	(332507, 142, '2015-02-01 00:32:07.000000', 'temperatura', 773.0000, 'ºC'),
	(332508, 142, '2015-02-01 00:32:08.000000', 'temperatura', 252.0000, 'ºC'),
	(332509, 142, '2015-02-01 00:32:09.000000', 'temperatura', 141.0000, 'ºC'),
	(332510, 142, '2015-02-01 00:32:10.000000', 'temperatura', 1152.0000, 'ºC'),
	(332511, 142, '2015-02-01 00:32:11.000000', 'temperatura', 537.0000, 'ºC'),
	(332512, 142, '2015-02-01 00:32:12.000000', 'temperatura', 427.0000, 'ºC'),
	(332513, 142, '2015-02-01 00:32:13.000000', 'temperatura', 527.0000, 'ºC'),
	(332514, 142, '2015-02-01 00:32:14.000000', 'temperatura', 152.0000, 'ºC'),
	(332515, 142, '2015-02-01 00:32:15.000000', 'temperatura', 382.0000, 'ºC'),
	(332516, 142, '2015-02-01 00:32:16.000000', 'temperatura', 252.0000, 'ºC'),
	(332517, 142, '2015-02-01 00:32:17.000000', 'temperatura', 116.0000, 'ºC'),
	(332518, 142, '2015-02-01 00:32:18.000000', 'temperatura', 1023.0000, 'ºC'),
	(332519, 142, '2015-02-01 00:32:19.000000', 'temperatura', 1168.0000, 'ºC'),
	(332520, 142, '2015-02-01 00:32:20.000000', 'temperatura', 373.0000, 'ºC'),
	(332521, 142, '2015-02-01 00:32:21.000000', 'temperatura', 761.0000, 'ºC'),
	(332522, 142, '2015-02-01 00:32:22.000000', 'temperatura', 285.0000, 'ºC'),
	(332523, 142, '2015-02-01 00:32:23.000000', 'temperatura', 343.0000, 'ºC'),
	(332524, 142, '2015-02-01 00:32:24.000000', 'temperatura', 861.0000, 'ºC'),
	(332525, 142, '2015-02-01 00:32:25.000000', 'temperatura', 878.0000, 'ºC'),
	(332526, 142, '2015-02-01 00:32:26.000000', 'temperatura', 606.0000, 'ºC'),
	(332527, 142, '2015-02-01 00:32:27.000000', 'temperatura', 395.0000, 'ºC'),
	(332528, 142, '2015-02-01 00:32:28.000000', 'temperatura', 158.0000, 'ºC'),
	(332529, 142, '2015-02-01 00:32:29.000000', 'temperatura', 807.0000, 'ºC'),
	(332530, 142, '2015-02-01 00:32:30.000000', 'temperatura', 1162.0000, 'ºC'),
	(332531, 142, '2015-02-01 00:32:31.000000', 'temperatura', 990.0000, 'ºC'),
	(332532, 142, '2015-02-01 00:32:32.000000', 'temperatura', 262.0000, 'ºC'),
	(332533, 142, '2015-02-01 00:32:33.000000', 'temperatura', 742.0000, 'ºC'),
	(332534, 142, '2015-02-01 00:32:34.000000', 'temperatura', 524.0000, 'ºC'),
	(332535, 142, '2015-02-01 00:32:35.000000', 'temperatura', 396.0000, 'ºC'),
	(332536, 142, '2015-02-01 00:32:36.000000', 'temperatura', 406.0000, 'ºC'),
	(332537, 142, '2015-02-01 00:32:37.000000', 'temperatura', 842.0000, 'ºC'),
	(332538, 142, '2015-02-01 00:32:38.000000', 'temperatura', 592.0000, 'ºC'),
	(332539, 142, '2015-02-01 00:32:39.000000', 'temperatura', 435.0000, 'ºC'),
	(332540, 142, '2015-02-01 00:32:40.000000', 'temperatura', 400.0000, 'ºC'),
	(332541, 142, '2015-02-01 00:32:41.000000', 'temperatura', 694.0000, 'ºC'),
	(332542, 142, '2015-02-01 00:32:42.000000', 'temperatura', 1073.0000, 'ºC'),
	(332543, 142, '2015-02-01 00:32:43.000000', 'temperatura', 884.0000, 'ºC'),
	(332544, 142, '2015-02-01 00:32:44.000000', 'temperatura', 1199.0000, 'ºC'),
	(332545, 142, '2015-02-01 00:32:45.000000', 'temperatura', 945.0000, 'ºC'),
	(332546, 142, '2015-02-01 00:32:46.000000', 'temperatura', 1127.0000, 'ºC'),
	(332547, 142, '2015-02-01 00:32:47.000000', 'temperatura', 403.0000, 'ºC'),
	(332548, 142, '2015-02-01 00:32:48.000000', 'temperatura', 1031.0000, 'ºC'),
	(332549, 142, '2015-02-01 00:32:49.000000', 'temperatura', 350.0000, 'ºC'),
	(332550, 142, '2015-02-01 00:32:50.000000', 'temperatura', 1056.0000, 'ºC'),
	(332551, 142, '2015-02-01 00:32:51.000000', 'temperatura', 630.0000, 'ºC'),
	(332552, 142, '2015-02-01 00:32:52.000000', 'temperatura', 1181.0000, 'ºC'),
	(332553, 142, '2015-02-01 00:32:53.000000', 'temperatura', 416.0000, 'ºC'),
	(332554, 142, '2015-02-01 00:32:54.000000', 'temperatura', 939.0000, 'ºC'),
	(332555, 142, '2015-02-01 00:32:55.000000', 'temperatura', 1047.0000, 'ºC'),
	(332556, 142, '2015-02-01 00:32:56.000000', 'temperatura', 19.0000, 'ºC'),
	(332557, 142, '2015-02-01 00:32:57.000000', 'temperatura', 555.0000, 'ºC'),
	(332558, 142, '2015-02-01 00:32:58.000000', 'temperatura', 320.0000, 'ºC'),
	(332559, 142, '2015-02-01 00:32:59.000000', 'temperatura', 1132.0000, 'ºC'),
	(332560, 142, '2015-02-01 00:33:00.000000', 'temperatura', 1104.0000, 'ºC'),
	(332561, 142, '2015-02-01 00:33:01.000000', 'temperatura', 922.0000, 'ºC'),
	(332562, 142, '2015-02-01 00:33:02.000000', 'temperatura', 97.0000, 'ºC'),
	(332563, 142, '2015-02-01 00:33:03.000000', 'temperatura', 123.0000, 'ºC'),
	(332564, 142, '2015-02-01 00:33:04.000000', 'temperatura', 322.0000, 'ºC'),
	(332565, 142, '2015-02-01 00:33:05.000000', 'temperatura', 43.0000, 'ºC'),
	(332566, 142, '2015-02-01 00:33:06.000000', 'temperatura', 451.0000, 'ºC'),
	(332567, 142, '2015-02-01 00:33:07.000000', 'temperatura', 925.0000, 'ºC'),
	(332568, 142, '2015-02-01 00:33:08.000000', 'temperatura', 873.0000, 'ºC'),
	(332569, 142, '2015-02-01 00:33:09.000000', 'temperatura', 389.0000, 'ºC'),
	(332570, 142, '2015-02-01 00:33:10.000000', 'temperatura', 529.0000, 'ºC'),
	(332571, 142, '2015-02-01 00:33:11.000000', 'temperatura', 277.0000, 'ºC'),
	(332572, 142, '2015-02-01 00:33:12.000000', 'temperatura', 999.0000, 'ºC'),
	(332573, 142, '2015-02-01 00:33:13.000000', 'temperatura', 565.0000, 'ºC'),
	(332574, 142, '2015-02-01 00:33:14.000000', 'temperatura', 1029.0000, 'ºC'),
	(332575, 142, '2015-02-01 00:33:15.000000', 'temperatura', 1050.0000, 'ºC'),
	(332576, 142, '2015-02-01 00:33:16.000000', 'temperatura', 964.0000, 'ºC'),
	(332577, 142, '2015-02-01 00:33:17.000000', 'temperatura', 470.0000, 'ºC'),
	(332578, 142, '2015-02-01 00:33:18.000000', 'temperatura', 659.0000, 'ºC'),
	(332579, 142, '2015-02-01 00:33:19.000000', 'temperatura', 684.0000, 'ºC'),
	(332580, 142, '2015-02-01 00:33:20.000000', 'temperatura', 246.0000, 'ºC'),
	(332581, 142, '2015-02-01 00:33:21.000000', 'temperatura', 378.0000, 'ºC'),
	(332582, 142, '2015-02-01 00:33:22.000000', 'temperatura', 1153.0000, 'ºC'),
	(332583, 142, '2015-02-01 00:33:23.000000', 'temperatura', 1031.0000, 'ºC'),
	(332584, 142, '2015-02-01 00:33:24.000000', 'temperatura', 496.0000, 'ºC'),
	(332585, 142, '2015-02-01 00:33:25.000000', 'temperatura', 588.0000, 'ºC'),
	(332586, 142, '2015-02-01 00:33:26.000000', 'temperatura', 253.0000, 'ºC'),
	(332587, 142, '2015-02-01 00:33:27.000000', 'temperatura', 701.0000, 'ºC'),
	(332588, 142, '2015-02-01 00:33:28.000000', 'temperatura', 347.0000, 'ºC'),
	(332589, 142, '2015-02-01 00:33:29.000000', 'temperatura', 831.0000, 'ºC'),
	(332590, 142, '2015-02-01 00:33:30.000000', 'temperatura', 714.0000, 'ºC'),
	(332591, 142, '2015-02-01 00:33:31.000000', 'temperatura', 1077.0000, 'ºC'),
	(332592, 142, '2015-02-01 00:33:32.000000', 'temperatura', 843.0000, 'ºC'),
	(332593, 142, '2015-02-01 00:33:33.000000', 'temperatura', 986.0000, 'ºC'),
	(332594, 142, '2015-02-01 00:33:34.000000', 'temperatura', 2.0000, 'ºC'),
	(332595, 142, '2015-02-01 00:33:35.000000', 'temperatura', 654.0000, 'ºC'),
	(332596, 142, '2015-02-01 00:33:36.000000', 'temperatura', 862.0000, 'ºC'),
	(332597, 142, '2015-02-01 00:33:37.000000', 'temperatura', 1150.0000, 'ºC'),
	(332598, 142, '2015-02-01 00:33:38.000000', 'temperatura', 764.0000, 'ºC'),
	(332599, 142, '2015-02-01 00:33:39.000000', 'temperatura', 371.0000, 'ºC'),
	(332600, 142, '2015-02-01 00:33:40.000000', 'temperatura', 761.0000, 'ºC'),
	(332601, 142, '2015-02-01 00:33:41.000000', 'temperatura', 296.0000, 'ºC'),
	(332602, 142, '2015-02-01 00:33:42.000000', 'temperatura', 395.0000, 'ºC'),
	(332603, 142, '2015-02-01 00:33:43.000000', 'temperatura', 1088.0000, 'ºC'),
	(332604, 142, '2015-02-01 00:33:44.000000', 'temperatura', 654.0000, 'ºC'),
	(332605, 142, '2015-02-01 00:33:45.000000', 'temperatura', 9.0000, 'ºC'),
	(332606, 142, '2015-02-01 00:33:46.000000', 'temperatura', 485.0000, 'ºC'),
	(332607, 142, '2015-02-01 00:33:47.000000', 'temperatura', 1195.0000, 'ºC'),
	(332608, 142, '2015-02-01 00:33:48.000000', 'temperatura', 921.0000, 'ºC'),
	(332609, 142, '2015-02-01 00:33:49.000000', 'temperatura', 1023.0000, 'ºC'),
	(332610, 142, '2015-02-01 00:33:50.000000', 'temperatura', 1152.0000, 'ºC'),
	(332611, 142, '2015-02-01 00:33:51.000000', 'temperatura', 290.0000, 'ºC'),
	(332612, 142, '2015-02-01 00:33:52.000000', 'temperatura', 394.0000, 'ºC'),
	(332613, 142, '2015-02-01 00:33:53.000000', 'temperatura', 1101.0000, 'ºC'),
	(332614, 142, '2015-02-01 00:33:54.000000', 'temperatura', 724.0000, 'ºC'),
	(332615, 142, '2015-02-01 00:33:55.000000', 'temperatura', 318.0000, 'ºC'),
	(332616, 142, '2015-02-01 00:33:56.000000', 'temperatura', 618.0000, 'ºC'),
	(332617, 142, '2015-02-01 00:33:57.000000', 'temperatura', 937.0000, 'ºC'),
	(332618, 142, '2015-02-01 00:33:58.000000', 'temperatura', 431.0000, 'ºC'),
	(332619, 142, '2015-02-01 00:33:59.000000', 'temperatura', 546.0000, 'ºC'),
	(332620, 142, '2015-02-01 00:34:00.000000', 'temperatura', 238.0000, 'ºC'),
	(332621, 142, '2015-02-01 00:34:01.000000', 'temperatura', 751.0000, 'ºC'),
	(332622, 142, '2015-02-01 00:34:02.000000', 'temperatura', 642.0000, 'ºC'),
	(332623, 142, '2015-02-01 00:34:03.000000', 'temperatura', 958.0000, 'ºC'),
	(332624, 142, '2015-02-01 00:34:04.000000', 'temperatura', 464.0000, 'ºC'),
	(332625, 142, '2015-02-01 00:34:05.000000', 'temperatura', 647.0000, 'ºC'),
	(332626, 142, '2015-02-01 00:34:06.000000', 'temperatura', 642.0000, 'ºC'),
	(332627, 142, '2015-02-01 00:34:07.000000', 'temperatura', 69.0000, 'ºC'),
	(332628, 142, '2015-02-01 00:34:08.000000', 'temperatura', 819.0000, 'ºC'),
	(332629, 142, '2015-02-01 00:34:09.000000', 'temperatura', 290.0000, 'ºC'),
	(332630, 142, '2015-02-01 00:34:10.000000', 'temperatura', 194.0000, 'ºC'),
	(332631, 142, '2015-02-01 00:34:11.000000', 'temperatura', 98.0000, 'ºC'),
	(332632, 142, '2015-02-01 00:34:12.000000', 'temperatura', 1111.0000, 'ºC'),
	(332633, 142, '2015-02-01 00:34:13.000000', 'temperatura', 462.0000, 'ºC'),
	(332634, 142, '2015-02-01 00:34:14.000000', 'temperatura', 179.0000, 'ºC'),
	(332635, 142, '2015-02-01 00:34:15.000000', 'temperatura', 707.0000, 'ºC'),
	(332636, 142, '2015-02-01 00:34:16.000000', 'temperatura', 597.0000, 'ºC'),
	(332637, 142, '2015-02-01 00:34:17.000000', 'temperatura', 868.0000, 'ºC'),
	(332638, 142, '2015-02-01 00:34:18.000000', 'temperatura', 148.0000, 'ºC'),
	(332639, 142, '2015-02-01 00:34:19.000000', 'temperatura', 537.0000, 'ºC'),
	(332640, 142, '2015-02-01 00:34:20.000000', 'temperatura', 1039.0000, 'ºC'),
	(332641, 142, '2015-02-01 00:34:21.000000', 'temperatura', 1188.0000, 'ºC'),
	(332642, 142, '2015-02-01 00:34:22.000000', 'temperatura', 422.0000, 'ºC'),
	(332643, 142, '2015-02-01 00:34:23.000000', 'temperatura', 947.0000, 'ºC'),
	(332644, 142, '2015-02-01 00:34:24.000000', 'temperatura', 1070.0000, 'ºC'),
	(332645, 142, '2015-02-01 00:34:25.000000', 'temperatura', 107.0000, 'ºC'),
	(332646, 142, '2015-02-01 00:34:26.000000', 'temperatura', 928.0000, 'ºC'),
	(332647, 142, '2015-02-01 00:34:27.000000', 'temperatura', 721.0000, 'ºC'),
	(332648, 142, '2015-02-01 00:34:28.000000', 'temperatura', 818.0000, 'ºC'),
	(332649, 142, '2015-02-01 00:34:29.000000', 'temperatura', 729.0000, 'ºC'),
	(332650, 142, '2015-02-01 00:34:30.000000', 'temperatura', 1192.0000, 'ºC'),
	(332651, 142, '2015-02-01 00:34:31.000000', 'temperatura', 173.0000, 'ºC'),
	(332652, 142, '2015-02-01 00:34:32.000000', 'temperatura', 890.0000, 'ºC'),
	(332653, 142, '2015-02-01 00:34:33.000000', 'temperatura', 330.0000, 'ºC'),
	(332654, 142, '2015-02-01 00:34:34.000000', 'temperatura', 180.0000, 'ºC'),
	(332655, 142, '2015-02-01 00:34:35.000000', 'temperatura', 1113.0000, 'ºC'),
	(332656, 142, '2015-02-01 00:34:36.000000', 'temperatura', 226.0000, 'ºC'),
	(332657, 142, '2015-02-01 00:34:37.000000', 'temperatura', 189.0000, 'ºC'),
	(332658, 142, '2015-02-01 00:34:38.000000', 'temperatura', 271.0000, 'ºC'),
	(332659, 142, '2015-02-01 00:34:39.000000', 'temperatura', 785.0000, 'ºC'),
	(332660, 142, '2015-02-01 00:34:40.000000', 'temperatura', 712.0000, 'ºC'),
	(332661, 142, '2015-02-01 00:34:41.000000', 'temperatura', 7.0000, 'ºC'),
	(332662, 142, '2015-02-01 00:34:42.000000', 'temperatura', 301.0000, 'ºC'),
	(332663, 142, '2015-02-01 00:34:43.000000', 'temperatura', 284.0000, 'ºC'),
	(332664, 142, '2015-02-01 00:34:44.000000', 'temperatura', 519.0000, 'ºC'),
	(332665, 142, '2015-02-01 00:34:45.000000', 'temperatura', 540.0000, 'ºC'),
	(332666, 142, '2015-02-01 00:34:46.000000', 'temperatura', 1146.0000, 'ºC'),
	(332667, 142, '2015-02-01 00:34:47.000000', 'temperatura', 512.0000, 'ºC'),
	(332668, 142, '2015-02-01 00:34:48.000000', 'temperatura', 319.0000, 'ºC'),
	(332669, 142, '2015-02-01 00:34:49.000000', 'temperatura', 63.0000, 'ºC'),
	(332670, 142, '2015-02-01 00:34:50.000000', 'temperatura', 556.0000, 'ºC'),
	(332671, 142, '2015-02-01 00:34:51.000000', 'temperatura', 193.0000, 'ºC'),
	(332672, 142, '2015-02-01 00:34:52.000000', 'temperatura', 499.0000, 'ºC'),
	(332673, 142, '2015-02-01 00:34:53.000000', 'temperatura', 713.0000, 'ºC'),
	(332674, 142, '2015-02-01 00:34:54.000000', 'temperatura', 871.0000, 'ºC'),
	(332675, 142, '2015-02-01 00:34:55.000000', 'temperatura', 1017.0000, 'ºC'),
	(332676, 142, '2015-02-01 00:34:56.000000', 'temperatura', 72.0000, 'ºC'),
	(332677, 142, '2015-02-01 00:34:57.000000', 'temperatura', 911.0000, 'ºC'),
	(332678, 142, '2015-02-01 00:34:58.000000', 'temperatura', 737.0000, 'ºC'),
	(332679, 142, '2015-02-01 00:34:59.000000', 'temperatura', 955.0000, 'ºC'),
	(332680, 142, '2015-02-01 00:35:00.000000', 'temperatura', 165.0000, 'ºC'),
	(332681, 142, '2015-02-01 00:35:01.000000', 'temperatura', 361.0000, 'ºC'),
	(332682, 142, '2015-02-01 00:35:02.000000', 'temperatura', 108.0000, 'ºC'),
	(332683, 142, '2015-02-01 00:35:03.000000', 'temperatura', 658.0000, 'ºC'),
	(332684, 142, '2015-02-01 00:35:04.000000', 'temperatura', 565.0000, 'ºC'),
	(332685, 142, '2015-02-01 00:35:05.000000', 'temperatura', 854.0000, 'ºC'),
	(332686, 142, '2015-02-01 00:35:06.000000', 'temperatura', 176.0000, 'ºC'),
	(332687, 142, '2015-02-01 00:35:07.000000', 'temperatura', 719.0000, 'ºC'),
	(332688, 142, '2015-02-01 00:35:08.000000', 'temperatura', 665.0000, 'ºC'),
	(332689, 142, '2015-02-01 00:35:09.000000', 'temperatura', 1171.0000, 'ºC'),
	(332690, 142, '2015-02-01 00:35:10.000000', 'temperatura', 260.0000, 'ºC'),
	(332691, 142, '2015-02-01 00:35:11.000000', 'temperatura', 187.0000, 'ºC'),
	(332692, 142, '2015-02-01 00:35:12.000000', 'temperatura', 156.0000, 'ºC'),
	(332693, 142, '2015-02-01 00:35:13.000000', 'temperatura', 219.0000, 'ºC'),
	(332694, 142, '2015-02-01 00:35:14.000000', 'temperatura', 629.0000, 'ºC'),
	(332695, 142, '2015-02-01 00:35:15.000000', 'temperatura', 87.0000, 'ºC'),
	(332696, 142, '2015-02-01 00:35:16.000000', 'temperatura', 948.0000, 'ºC'),
	(332697, 142, '2015-02-01 00:35:17.000000', 'temperatura', 881.0000, 'ºC'),
	(332698, 142, '2015-02-01 00:35:18.000000', 'temperatura', 360.0000, 'ºC'),
	(332699, 142, '2015-02-01 00:35:19.000000', 'temperatura', 359.0000, 'ºC'),
	(332700, 142, '2015-02-01 00:35:20.000000', 'temperatura', 714.0000, 'ºC'),
	(332701, 142, '2015-02-01 00:35:21.000000', 'temperatura', 93.0000, 'ºC'),
	(332702, 142, '2015-02-01 00:35:22.000000', 'temperatura', 726.0000, 'ºC'),
	(332703, 142, '2015-02-01 00:35:23.000000', 'temperatura', 950.0000, 'ºC'),
	(332704, 142, '2015-02-01 00:35:24.000000', 'temperatura', 174.0000, 'ºC'),
	(332705, 142, '2015-02-01 00:35:25.000000', 'temperatura', 421.0000, 'ºC'),
	(332706, 142, '2015-02-01 00:35:26.000000', 'temperatura', 381.0000, 'ºC'),
	(332707, 142, '2015-02-01 00:35:27.000000', 'temperatura', 643.0000, 'ºC'),
	(332708, 142, '2015-02-01 00:35:28.000000', 'temperatura', 873.0000, 'ºC'),
	(332709, 142, '2015-02-01 00:35:29.000000', 'temperatura', 36.0000, 'ºC'),
	(332710, 142, '2015-02-01 00:35:30.000000', 'temperatura', 1163.0000, 'ºC'),
	(332711, 142, '2015-02-01 00:35:31.000000', 'temperatura', 909.0000, 'ºC'),
	(332712, 142, '2015-02-01 00:35:32.000000', 'temperatura', 1053.0000, 'ºC'),
	(332713, 142, '2015-02-01 00:35:33.000000', 'temperatura', 142.0000, 'ºC'),
	(332714, 142, '2015-02-01 00:35:34.000000', 'temperatura', 1148.0000, 'ºC'),
	(332715, 142, '2015-02-01 00:35:35.000000', 'temperatura', 516.0000, 'ºC'),
	(332716, 142, '2015-02-01 00:35:36.000000', 'temperatura', 335.0000, 'ºC'),
	(332717, 142, '2015-02-01 00:35:37.000000', 'temperatura', 127.0000, 'ºC'),
	(332718, 142, '2015-02-01 00:35:38.000000', 'temperatura', 831.0000, 'ºC'),
	(332719, 142, '2015-02-01 00:35:39.000000', 'temperatura', 174.0000, 'ºC'),
	(332720, 142, '2015-02-01 00:35:40.000000', 'temperatura', 777.0000, 'ºC'),
	(332721, 142, '2015-02-01 00:35:41.000000', 'temperatura', 963.0000, 'ºC'),
	(332722, 142, '2015-02-01 00:35:42.000000', 'temperatura', 85.0000, 'ºC'),
	(332723, 142, '2015-02-01 00:35:43.000000', 'temperatura', 1138.0000, 'ºC'),
	(332724, 142, '2015-02-01 00:35:44.000000', 'temperatura', 636.0000, 'ºC'),
	(332725, 142, '2015-02-01 00:35:45.000000', 'temperatura', 967.0000, 'ºC'),
	(332726, 142, '2015-02-01 00:35:46.000000', 'temperatura', 526.0000, 'ºC'),
	(332727, 142, '2015-02-01 00:35:47.000000', 'temperatura', 930.0000, 'ºC'),
	(332728, 142, '2015-02-01 00:35:48.000000', 'temperatura', 672.0000, 'ºC'),
	(332729, 142, '2015-02-01 00:35:49.000000', 'temperatura', 570.0000, 'ºC'),
	(332730, 142, '2015-02-01 00:35:50.000000', 'temperatura', 835.0000, 'ºC'),
	(332731, 142, '2015-02-01 00:35:51.000000', 'temperatura', 67.0000, 'ºC'),
	(332732, 142, '2015-02-01 00:35:52.000000', 'temperatura', 228.0000, 'ºC'),
	(332733, 142, '2015-02-01 00:35:53.000000', 'temperatura', 939.0000, 'ºC'),
	(332734, 142, '2015-02-01 00:35:54.000000', 'temperatura', 415.0000, 'ºC'),
	(332735, 142, '2015-02-01 00:35:55.000000', 'temperatura', 455.0000, 'ºC'),
	(332736, 142, '2015-02-01 00:35:56.000000', 'temperatura', 1032.0000, 'ºC'),
	(332737, 142, '2015-02-01 00:35:57.000000', 'temperatura', 194.0000, 'ºC'),
	(332738, 142, '2015-02-01 00:35:58.000000', 'temperatura', 274.0000, 'ºC'),
	(332739, 142, '2015-02-01 00:35:59.000000', 'temperatura', 788.0000, 'ºC'),
	(332740, 142, '2015-02-01 00:36:00.000000', 'temperatura', 721.0000, 'ºC'),
	(332741, 142, '2015-02-01 00:36:01.000000', 'temperatura', 40.0000, 'ºC'),
	(332742, 142, '2015-02-01 00:36:02.000000', 'temperatura', 436.0000, 'ºC'),
	(332743, 142, '2015-02-01 00:36:03.000000', 'temperatura', 862.0000, 'ºC'),
	(332744, 142, '2015-02-01 00:36:04.000000', 'temperatura', 604.0000, 'ºC'),
	(332745, 142, '2015-02-01 00:36:05.000000', 'temperatura', 434.0000, 'ºC'),
	(332746, 142, '2015-02-01 00:36:06.000000', 'temperatura', 357.0000, 'ºC'),
	(332747, 142, '2015-02-01 00:36:07.000000', 'temperatura', 485.0000, 'ºC'),
	(332748, 142, '2015-02-01 00:36:08.000000', 'temperatura', 155.0000, 'ºC'),
	(332749, 142, '2015-02-01 00:36:09.000000', 'temperatura', 519.0000, 'ºC'),
	(332750, 142, '2015-02-01 00:36:10.000000', 'temperatura', 933.0000, 'ºC'),
	(332751, 142, '2015-02-01 00:36:11.000000', 'temperatura', 705.0000, 'ºC'),
	(332752, 142, '2015-02-01 00:36:12.000000', 'temperatura', 729.0000, 'ºC'),
	(332753, 142, '2015-02-01 00:36:13.000000', 'temperatura', 329.0000, 'ºC'),
	(332754, 142, '2015-02-01 00:36:14.000000', 'temperatura', 657.0000, 'ºC'),
	(332755, 142, '2015-02-01 00:36:15.000000', 'temperatura', 1100.0000, 'ºC'),
	(332756, 142, '2015-02-01 00:36:16.000000', 'temperatura', 1132.0000, 'ºC'),
	(332757, 142, '2015-02-01 00:36:17.000000', 'temperatura', 1157.0000, 'ºC'),
	(332758, 142, '2015-02-01 00:36:18.000000', 'temperatura', 1190.0000, 'ºC'),
	(332759, 142, '2015-02-01 00:36:19.000000', 'temperatura', 80.0000, 'ºC'),
	(332760, 142, '2015-02-01 00:36:20.000000', 'temperatura', 432.0000, 'ºC'),
	(332761, 142, '2015-02-01 00:36:21.000000', 'temperatura', 717.0000, 'ºC'),
	(332762, 142, '2015-02-01 00:36:22.000000', 'temperatura', 1093.0000, 'ºC'),
	(332763, 142, '2015-02-01 00:36:23.000000', 'temperatura', 914.0000, 'ºC'),
	(332764, 142, '2015-02-01 00:36:24.000000', 'temperatura', 93.0000, 'ºC'),
	(332765, 142, '2015-02-01 00:36:25.000000', 'temperatura', 121.0000, 'ºC'),
	(332766, 142, '2015-02-01 00:36:26.000000', 'temperatura', 327.0000, 'ºC'),
	(332767, 142, '2015-02-01 00:36:27.000000', 'temperatura', 74.0000, 'ºC'),
	(332768, 142, '2015-02-01 00:36:28.000000', 'temperatura', 587.0000, 'ºC'),
	(332769, 142, '2015-02-01 00:36:29.000000', 'temperatura', 313.0000, 'ºC'),
	(332770, 142, '2015-02-01 00:36:30.000000', 'temperatura', 1008.0000, 'ºC'),
	(332771, 142, '2015-02-01 00:36:31.000000', 'temperatura', 498.0000, 'ºC'),
	(332772, 142, '2015-02-01 00:36:32.000000', 'temperatura', 668.0000, 'ºC'),
	(332773, 142, '2015-02-01 00:36:33.000000', 'temperatura', 647.0000, 'ºC'),
	(332774, 142, '2015-02-01 00:36:34.000000', 'temperatura', 32.0000, 'ºC'),
	(332775, 142, '2015-02-01 00:36:35.000000', 'temperatura', 619.0000, 'ºC'),
	(332776, 142, '2015-02-01 00:36:36.000000', 'temperatura', 599.0000, 'ºC'),
	(332777, 142, '2015-02-01 00:36:37.000000', 'temperatura', 1137.0000, 'ºC'),
	(332778, 142, '2015-02-01 00:36:38.000000', 'temperatura', 290.0000, 'ºC'),
	(332779, 142, '2015-02-01 00:36:39.000000', 'temperatura', 438.0000, 'ºC'),
	(332780, 142, '2015-02-01 00:36:40.000000', 'temperatura', 123.0000, 'ºC'),
	(332781, 142, '2015-02-01 00:36:41.000000', 'temperatura', 498.0000, 'ºC'),
	(332782, 142, '2015-02-01 00:36:42.000000', 'temperatura', 925.0000, 'ºC'),
	(332783, 142, '2015-02-01 00:36:43.000000', 'temperatura', 731.0000, 'ºC'),
	(332784, 142, '2015-02-01 00:36:44.000000', 'temperatura', 879.0000, 'ºC'),
	(332785, 142, '2015-02-01 00:36:45.000000', 'temperatura', 1004.0000, 'ºC'),
	(332786, 142, '2015-02-01 00:36:46.000000', 'temperatura', 1182.0000, 'ºC'),
	(332787, 142, '2015-02-01 00:36:47.000000', 'temperatura', 499.0000, 'ºC'),
	(332788, 142, '2015-02-01 00:36:48.000000', 'temperatura', 148.0000, 'ºC'),
	(332789, 142, '2015-02-01 00:36:49.000000', 'temperatura', 446.0000, 'ºC'),
	(332790, 142, '2015-02-01 00:36:50.000000', 'temperatura', 584.0000, 'ºC'),
	(332791, 142, '2015-02-01 00:36:51.000000', 'temperatura', 382.0000, 'ºC'),
	(332792, 142, '2015-02-01 00:36:52.000000', 'temperatura', 161.0000, 'ºC'),
	(332793, 142, '2015-02-01 00:36:53.000000', 'temperatura', 860.0000, 'ºC'),
	(332794, 142, '2015-02-01 00:36:54.000000', 'temperatura', 218.0000, 'ºC'),
	(332795, 142, '2015-02-01 00:36:55.000000', 'temperatura', 910.0000, 'ºC'),
	(332796, 142, '2015-02-01 00:36:56.000000', 'temperatura', 294.0000, 'ºC'),
	(332797, 142, '2015-02-01 00:36:57.000000', 'temperatura', 1143.0000, 'ºC'),
	(332798, 142, '2015-02-01 00:36:58.000000', 'temperatura', 35.0000, 'ºC'),
	(332799, 142, '2015-02-01 00:36:59.000000', 'temperatura', 343.0000, 'ºC'),
	(332800, 142, '2015-02-01 00:37:00.000000', 'temperatura', 411.0000, 'ºC'),
	(332801, 142, '2015-02-01 00:37:01.000000', 'temperatura', 1029.0000, 'ºC'),
	(332802, 142, '2015-02-01 00:37:02.000000', 'temperatura', 311.0000, 'ºC'),
	(332803, 142, '2015-02-01 00:37:03.000000', 'temperatura', 868.0000, 'ºC'),
	(332804, 142, '2015-02-01 00:37:04.000000', 'temperatura', 1006.0000, 'ºC'),
	(332805, 142, '2015-02-01 00:37:05.000000', 'temperatura', 30.0000, 'ºC'),
	(332806, 142, '2015-02-01 00:37:06.000000', 'temperatura', 729.0000, 'ºC'),
	(332807, 142, '2015-02-01 00:37:07.000000', 'temperatura', 1157.0000, 'ºC'),
	(332808, 142, '2015-02-01 00:37:08.000000', 'temperatura', 1199.0000, 'ºC'),
	(332809, 142, '2015-02-01 00:37:09.000000', 'temperatura', 123.0000, 'ºC'),
	(332810, 142, '2015-02-01 00:37:10.000000', 'temperatura', 620.0000, 'ºC'),
	(332811, 142, '2015-02-01 00:37:11.000000', 'temperatura', 330.0000, 'ºC'),
	(332812, 142, '2015-02-01 00:37:12.000000', 'temperatura', 990.0000, 'ºC'),
	(332813, 142, '2015-02-01 00:37:13.000000', 'temperatura', 363.0000, 'ºC'),
	(332814, 142, '2015-02-01 00:37:14.000000', 'temperatura', 44.0000, 'ºC'),
	(332815, 142, '2015-02-01 00:37:15.000000', 'temperatura', 331.0000, 'ºC'),
	(332816, 142, '2015-02-01 00:37:16.000000', 'temperatura', 323.0000, 'ºC'),
	(332817, 142, '2015-02-01 00:37:17.000000', 'temperatura', 623.0000, 'ºC'),
	(332818, 142, '2015-02-01 00:37:18.000000', 'temperatura', 949.0000, 'ºC'),
	(332819, 142, '2015-02-01 00:37:19.000000', 'temperatura', 474.0000, 'ºC'),
	(332820, 142, '2015-02-01 00:37:20.000000', 'temperatura', 723.0000, 'ºC'),
	(332821, 142, '2015-02-01 00:37:21.000000', 'temperatura', 995.0000, 'ºC'),
	(332822, 142, '2015-02-01 00:37:22.000000', 'temperatura', 405.0000, 'ºC'),
	(332823, 142, '2015-02-01 00:37:23.000000', 'temperatura', 242.0000, 'ºC'),
	(332824, 142, '2015-02-01 00:37:24.000000', 'temperatura', 1197.0000, 'ºC'),
	(332825, 142, '2015-02-01 00:37:25.000000', 'temperatura', 456.0000, 'ºC'),
	(332826, 142, '2015-02-01 00:37:26.000000', 'temperatura', 1091.0000, 'ºC'),
	(332827, 142, '2015-02-01 00:37:27.000000', 'temperatura', 486.0000, 'ºC'),
	(332828, 142, '2015-02-01 00:37:28.000000', 'temperatura', 360.0000, 'ºC'),
	(332829, 142, '2015-02-01 00:37:29.000000', 'temperatura', 342.0000, 'ºC'),
	(332830, 142, '2015-02-01 00:37:30.000000', 'temperatura', 629.0000, 'ºC'),
	(332831, 142, '2015-02-01 00:37:31.000000', 'temperatura', 920.0000, 'ºC'),
	(332832, 142, '2015-02-01 00:37:32.000000', 'temperatura', 315.0000, 'ºC'),
	(332833, 142, '2015-02-01 00:37:33.000000', 'temperatura', 14.0000, 'ºC'),
	(332834, 142, '2015-02-01 00:37:34.000000', 'temperatura', 327.0000, 'ºC'),
	(332835, 142, '2015-02-01 00:37:35.000000', 'temperatura', 395.0000, 'ºC'),
	(332836, 142, '2015-02-01 00:37:36.000000', 'temperatura', 991.0000, 'ºC'),
	(332837, 142, '2015-02-01 00:37:37.000000', 'temperatura', 173.0000, 'ºC'),
	(332838, 142, '2015-02-01 00:37:38.000000', 'temperatura', 292.0000, 'ºC'),
	(332839, 142, '2015-02-01 00:37:39.000000', 'temperatura', 943.0000, 'ºC'),
	(332840, 142, '2015-02-01 00:37:40.000000', 'temperatura', 236.0000, 'ºC'),
	(332841, 142, '2015-02-01 00:37:41.000000', 'temperatura', 755.0000, 'ºC'),
	(332842, 142, '2015-02-01 00:37:42.000000', 'temperatura', 665.0000, 'ºC'),
	(332843, 142, '2015-02-01 00:37:43.000000', 'temperatura', 1060.0000, 'ºC'),
	(332844, 142, '2015-02-01 00:37:44.000000', 'temperatura', 909.0000, 'ºC'),
	(332845, 142, '2015-02-01 00:37:45.000000', 'temperatura', 162.0000, 'ºC'),
	(332846, 142, '2015-02-01 00:37:46.000000', 'temperatura', 483.0000, 'ºC'),
	(332847, 142, '2015-02-01 00:37:47.000000', 'temperatura', 732.0000, 'ºC'),
	(332848, 142, '2015-02-01 00:37:48.000000', 'temperatura', 1012.0000, 'ºC'),
	(332849, 142, '2015-02-01 00:37:49.000000', 'temperatura', 465.0000, 'ºC'),
	(332850, 142, '2015-02-01 00:37:50.000000', 'temperatura', 489.0000, 'ºC'),
	(332851, 142, '2015-02-01 00:37:51.000000', 'temperatura', 1049.0000, 'ºC'),
	(332852, 142, '2015-02-01 00:37:52.000000', 'temperatura', 177.0000, 'ºC'),
	(332853, 142, '2015-02-01 00:37:53.000000', 'temperatura', 141.0000, 'ºC'),
	(332854, 142, '2015-02-01 00:37:54.000000', 'temperatura', 176.0000, 'ºC'),
	(332855, 142, '2015-02-01 00:37:55.000000', 'temperatura', 456.0000, 'ºC'),
	(332856, 142, '2015-02-01 00:37:56.000000', 'temperatura', 551.0000, 'ºC'),
	(332857, 142, '2015-02-01 00:37:57.000000', 'temperatura', 187.0000, 'ºC'),
	(332858, 142, '2015-02-01 00:37:58.000000', 'temperatura', 482.0000, 'ºC'),
	(332859, 142, '2015-02-01 00:37:59.000000', 'temperatura', 650.0000, 'ºC'),
	(332860, 142, '2015-02-01 00:38:00.000000', 'temperatura', 606.0000, 'ºC'),
	(332861, 142, '2015-02-01 00:38:01.000000', 'temperatura', 1081.0000, 'ºC'),
	(332862, 142, '2015-02-01 00:38:02.000000', 'temperatura', 1185.0000, 'ºC'),
	(332863, 142, '2015-02-01 00:38:03.000000', 'temperatura', 286.0000, 'ºC'),
	(332864, 142, '2015-02-01 00:38:04.000000', 'temperatura', 272.0000, 'ºC'),
	(332865, 142, '2015-02-01 00:38:05.000000', 'temperatura', 504.0000, 'ºC'),
	(332866, 142, '2015-02-01 00:38:06.000000', 'temperatura', 503.0000, 'ºC'),
	(332867, 142, '2015-02-01 00:38:07.000000', 'temperatura', 1003.0000, 'ºC'),
	(332868, 142, '2015-02-01 00:38:08.000000', 'temperatura', 1106.0000, 'ºC'),
	(332869, 142, '2015-02-01 00:38:09.000000', 'temperatura', 122.0000, 'ºC'),
	(332870, 142, '2015-02-01 00:38:10.000000', 'temperatura', 895.0000, 'ºC'),
	(332871, 142, '2015-02-01 00:38:11.000000', 'temperatura', 507.0000, 'ºC'),
	(332872, 142, '2015-02-01 00:38:12.000000', 'temperatura', 1053.0000, 'ºC'),
	(332873, 142, '2015-02-01 00:38:13.000000', 'temperatura', 144.0000, 'ºC'),
	(332874, 142, '2015-02-01 00:38:14.000000', 'temperatura', 1161.0000, 'ºC'),
	(332875, 142, '2015-02-01 00:38:15.000000', 'temperatura', 575.0000, 'ºC'),
	(332876, 142, '2015-02-01 00:38:16.000000', 'temperatura', 590.0000, 'ºC'),
	(332877, 142, '2015-02-01 00:38:17.000000', 'temperatura', 25.0000, 'ºC'),
	(332878, 142, '2015-02-01 00:38:18.000000', 'temperatura', 757.0000, 'ºC'),
	(332879, 142, '2015-02-01 00:38:19.000000', 'temperatura', 112.0000, 'ºC'),
	(332880, 142, '2015-02-01 00:38:20.000000', 'temperatura', 687.0000, 'ºC'),
	(332881, 142, '2015-02-01 00:38:21.000000', 'temperatura', 701.0000, 'ºC'),
	(332882, 142, '2015-02-01 00:38:22.000000', 'temperatura', 244.0000, 'ºC'),
	(332883, 142, '2015-02-01 00:38:23.000000', 'temperatura', 318.0000, 'ºC'),
	(332884, 142, '2015-02-01 00:38:24.000000', 'temperatura', 857.0000, 'ºC'),
	(332885, 142, '2015-02-01 00:38:25.000000', 'temperatura', 933.0000, 'ºC'),
	(332886, 142, '2015-02-01 00:38:26.000000', 'temperatura', 894.0000, 'ºC'),
	(332887, 142, '2015-02-01 00:38:27.000000', 'temperatura', 472.0000, 'ºC'),
	(332888, 142, '2015-02-01 00:38:28.000000', 'temperatura', 877.0000, 'ºC'),
	(332889, 142, '2015-02-01 00:38:29.000000', 'temperatura', 571.0000, 'ºC'),
	(332890, 142, '2015-02-01 00:38:30.000000', 'temperatura', 222.0000, 'ºC'),
	(332891, 142, '2015-02-01 00:38:31.000000', 'temperatura', 600.0000, 'ºC'),
	(332892, 142, '2015-02-01 00:38:32.000000', 'temperatura', 1133.0000, 'ºC'),
	(332893, 142, '2015-02-01 00:38:33.000000', 'temperatura', 264.0000, 'ºC'),
	(332894, 142, '2015-02-01 00:38:34.000000', 'temperatura', 325.0000, 'ºC'),
	(332895, 142, '2015-02-01 00:38:35.000000', 'temperatura', 832.0000, 'ºC'),
	(332896, 142, '2015-02-01 00:38:36.000000', 'temperatura', 784.0000, 'ºC'),
	(332897, 142, '2015-02-01 00:38:37.000000', 'temperatura', 226.0000, 'ºC'),
	(332898, 142, '2015-02-01 00:38:38.000000', 'temperatura', 1179.0000, 'ºC'),
	(332899, 142, '2015-02-01 00:38:39.000000', 'temperatura', 416.0000, 'ºC'),
	(332900, 142, '2015-02-01 00:38:40.000000', 'temperatura', 946.0000, 'ºC'),
	(332901, 142, '2015-02-01 00:38:41.000000', 'temperatura', 1080.0000, 'ºC'),
	(332902, 142, '2015-02-01 00:38:42.000000', 'temperatura', 163.0000, 'ºC'),
	(332903, 142, '2015-02-01 00:38:43.000000', 'temperatura', 1174.0000, 'ºC'),
	(332904, 142, '2015-02-01 00:38:44.000000', 'temperatura', 585.0000, 'ºC'),
	(332905, 142, '2015-02-01 00:38:45.000000', 'temperatura', 601.0000, 'ºC'),
	(332906, 142, '2015-02-01 00:38:46.000000', 'temperatura', 52.0000, 'ºC'),
	(332907, 142, '2015-02-01 00:38:47.000000', 'temperatura', 857.0000, 'ºC'),
	(332908, 142, '2015-02-01 00:38:48.000000', 'temperatura', 531.0000, 'ºC'),
	(332909, 142, '2015-02-01 00:38:49.000000', 'temperatura', 82.0000, 'ºC'),
	(332910, 142, '2015-02-01 00:38:50.000000', 'temperatura', 19.0000, 'ºC'),
	(332911, 142, '2015-02-01 00:38:51.000000', 'temperatura', 1051.0000, 'ºC'),
	(332912, 142, '2015-02-01 00:38:52.000000', 'temperatura', 398.0000, 'ºC'),
	(332913, 142, '2015-02-01 00:38:53.000000', 'temperatura', 37.0000, 'ºC'),
	(332914, 142, '2015-02-01 00:38:54.000000', 'temperatura', 190.0000, 'ºC'),
	(332915, 142, '2015-02-01 00:38:55.000000', 'temperatura', 841.0000, 'ºC'),
	(332916, 142, '2015-02-01 00:38:56.000000', 'temperatura', 36.0000, 'ºC'),
	(332917, 142, '2015-02-01 00:38:57.000000', 'temperatura', 58.0000, 'ºC'),
	(332918, 142, '2015-02-01 00:38:58.000000', 'temperatura', 180.0000, 'ºC'),
	(332919, 142, '2015-02-01 00:38:59.000000', 'temperatura', 728.0000, 'ºC'),
	(332920, 142, '2015-02-01 00:39:00.000000', 'temperatura', 699.0000, 'ºC'),
	(332921, 142, '2015-02-01 00:39:01.000000', 'temperatura', 113.0000, 'ºC'),
	(332922, 142, '2015-02-01 00:39:02.000000', 'temperatura', 869.0000, 'ºC'),
	(332923, 142, '2015-02-01 00:39:03.000000', 'temperatura', 405.0000, 'ºC'),
	(332924, 142, '2015-02-01 00:39:04.000000', 'temperatura', 619.0000, 'ºC'),
	(332925, 142, '2015-02-01 00:39:05.000000', 'temperatura', 683.0000, 'ºC'),
	(332926, 142, '2015-02-01 00:39:06.000000', 'temperatura', 355.0000, 'ºC'),
	(332927, 142, '2015-02-01 00:39:07.000000', 'temperatura', 929.0000, 'ºC'),
	(332928, 142, '2015-02-01 00:39:08.000000', 'temperatura', 1182.0000, 'ºC'),
	(332929, 142, '2015-02-01 00:39:09.000000', 'temperatura', 720.0000, 'ºC'),
	(332930, 142, '2015-02-01 00:39:10.000000', 'temperatura', 57.0000, 'ºC'),
	(332931, 142, '2015-02-01 00:39:11.000000', 'temperatura', 523.0000, 'ºC'),
	(332932, 142, '2015-02-01 00:39:12.000000', 'temperatura', 45.0000, 'ºC'),
	(332933, 142, '2015-02-01 00:39:13.000000', 'temperatura', 1057.0000, 'ºC'),
	(332934, 142, '2015-02-01 00:39:14.000000', 'temperatura', 348.0000, 'ºC'),
	(332935, 142, '2015-02-01 00:39:15.000000', 'temperatura', 973.0000, 'ºC'),
	(332936, 142, '2015-02-01 00:39:16.000000', 'temperatura', 221.0000, 'ºC'),
	(332937, 142, '2015-02-01 00:39:17.000000', 'temperatura', 587.0000, 'ºC'),
	(332938, 142, '2015-02-01 00:39:18.000000', 'temperatura', 1071.0000, 'ºC'),
	(332939, 142, '2015-02-01 00:39:19.000000', 'temperatura', 1196.0000, 'ºC'),
	(332940, 142, '2015-02-01 00:39:20.000000', 'temperatura', 368.0000, 'ºC'),
	(332941, 142, '2015-02-01 00:39:21.000000', 'temperatura', 650.0000, 'ºC'),
	(332942, 142, '2015-02-01 00:39:22.000000', 'temperatura', 949.0000, 'ºC'),
	(332943, 142, '2015-02-01 00:39:23.000000', 'temperatura', 394.0000, 'ºC'),
	(332944, 142, '2015-02-01 00:39:24.000000', 'temperatura', 322.0000, 'ºC'),
	(332945, 142, '2015-02-01 00:39:25.000000', 'temperatura', 431.0000, 'ºC'),
	(332946, 142, '2015-02-01 00:39:26.000000', 'temperatura', 1189.0000, 'ºC'),
	(332947, 142, '2015-02-01 00:39:27.000000', 'temperatura', 1054.0000, 'ºC'),
	(332948, 142, '2015-02-01 00:39:28.000000', 'temperatura', 502.0000, 'ºC'),
	(332949, 142, '2015-02-01 00:39:29.000000', 'temperatura', 549.0000, 'ºC'),
	(332950, 142, '2015-02-01 00:39:30.000000', 'temperatura', 39.0000, 'ºC'),
	(332951, 142, '2015-02-01 00:39:31.000000', 'temperatura', 948.0000, 'ºC'),
	(332952, 142, '2015-02-01 00:39:32.000000', 'temperatura', 1026.0000, 'ºC'),
	(332953, 142, '2015-02-01 00:39:33.000000', 'temperatura', 1084.0000, 'ºC'),
	(332954, 142, '2015-02-01 00:39:34.000000', 'temperatura', 1145.0000, 'ºC'),
	(332955, 142, '2015-02-01 00:39:35.000000', 'temperatura', 72.0000, 'ºC'),
	(332956, 142, '2015-02-01 00:39:36.000000', 'temperatura', 526.0000, 'ºC'),
	(332957, 142, '2015-02-01 00:39:37.000000', 'temperatura', 13.0000, 'ºC'),
	(332958, 142, '2015-02-01 00:39:38.000000', 'temperatura', 890.0000, 'ºC'),
	(332959, 142, '2015-02-01 00:39:39.000000', 'temperatura', 808.0000, 'ºC'),
	(332960, 142, '2015-02-01 00:39:40.000000', 'temperatura', 174.0000, 'ºC'),
	(332961, 142, '2015-02-01 00:39:41.000000', 'temperatura', 844.0000, 'ºC'),
	(332962, 142, '2015-02-01 00:39:42.000000', 'temperatura', 99.0000, 'ºC'),
	(332963, 142, '2015-02-01 00:39:43.000000', 'temperatura', 363.0000, 'ºC'),
	(332964, 142, '2015-02-01 00:39:44.000000', 'temperatura', 321.0000, 'ºC'),
	(332965, 142, '2015-02-01 00:39:45.000000', 'temperatura', 513.0000, 'ºC'),
	(332966, 142, '2015-02-01 00:39:46.000000', 'temperatura', 404.0000, 'ºC'),
	(332967, 142, '2015-02-01 00:39:47.000000', 'temperatura', 483.0000, 'ºC'),
	(332968, 142, '2015-02-01 00:39:48.000000', 'temperatura', 2.0000, 'ºC'),
	(332969, 142, '2015-02-01 00:39:49.000000', 'temperatura', 963.0000, 'ºC'),
	(332970, 142, '2015-02-01 00:39:50.000000', 'temperatura', 8.0000, 'ºC'),
	(332971, 142, '2015-02-01 00:39:51.000000', 'temperatura', 752.0000, 'ºC'),
	(332972, 142, '2015-02-01 00:39:52.000000', 'temperatura', 136.0000, 'ºC'),
	(332973, 142, '2015-02-01 00:39:53.000000', 'temperatura', 825.0000, 'ºC'),
	(332974, 142, '2015-02-01 00:39:54.000000', 'temperatura', 118.0000, 'ºC'),
	(332975, 142, '2015-02-01 00:39:55.000000', 'temperatura', 517.0000, 'ºC'),
	(332976, 142, '2015-02-01 00:39:56.000000', 'temperatura', 1031.0000, 'ºC'),
	(332977, 142, '2015-02-01 00:39:57.000000', 'temperatura', 4.0000, 'ºC'),
	(332978, 142, '2015-02-01 00:39:58.000000', 'temperatura', 528.0000, 'ºC'),
	(332979, 142, '2015-02-01 00:39:59.000000', 'temperatura', 230.0000, 'ºC'),
	(332980, 142, '2015-02-01 00:40:00.000000', 'temperatura', 766.0000, 'ºC'),
	(332981, 142, '2015-02-01 00:40:01.000000', 'temperatura', 739.0000, 'ºC'),
	(332982, 142, '2015-02-01 00:40:02.000000', 'temperatura', 198.0000, 'ºC'),
	(332983, 142, '2015-02-01 00:40:03.000000', 'temperatura', 1172.0000, 'ºC'),
	(332984, 142, '2015-02-01 00:40:04.000000', 'temperatura', 468.0000, 'ºC'),
	(332985, 142, '2015-02-01 00:40:05.000000', 'temperatura', 26.0000, 'ºC'),
	(332986, 142, '2015-02-01 00:40:06.000000', 'temperatura', 1125.0000, 'ºC'),
	(332987, 142, '2015-02-01 00:40:07.000000', 'temperatura', 748.0000, 'ºC'),
	(332988, 142, '2015-02-01 00:40:08.000000', 'temperatura', 364.0000, 'ºC'),
	(332989, 142, '2015-02-01 00:40:09.000000', 'temperatura', 778.0000, 'ºC'),
	(332990, 142, '2015-02-01 00:40:10.000000', 'temperatura', 396.0000, 'ºC'),
	(332991, 142, '2015-02-01 00:40:11.000000', 'temperatura', 848.0000, 'ºC'),
	(332992, 142, '2015-02-01 00:40:12.000000', 'temperatura', 654.0000, 'ºC'),
	(332993, 142, '2015-02-01 00:40:13.000000', 'temperatura', 725.0000, 'ºC'),
	(332994, 142, '2015-02-01 00:40:14.000000', 'temperatura', 462.0000, 'ºC'),
	(332995, 142, '2015-02-01 00:40:15.000000', 'temperatura', 137.0000, 'ºC'),
	(332996, 142, '2015-02-01 00:40:16.000000', 'temperatura', 501.0000, 'ºC'),
	(332997, 142, '2015-02-01 00:40:17.000000', 'temperatura', 892.0000, 'ºC'),
	(332998, 142, '2015-02-01 00:40:18.000000', 'temperatura', 557.0000, 'ºC'),
	(332999, 142, '2015-02-01 00:40:19.000000', 'temperatura', 110.0000, 'ºC'),
	(333000, 142, '2015-02-01 00:40:20.000000', 'temperatura', 81.0000, 'ºC'),
	(333001, 142, '2015-02-01 00:40:21.000000', 'temperatura', 73.0000, 'ºC'),
	(333002, 142, '2015-02-01 00:40:22.000000', 'temperatura', 125.0000, 'ºC'),
	(333003, 142, '2015-02-01 00:40:23.000000', 'temperatura', 407.0000, 'ºC'),
	(333004, 142, '2015-02-01 00:40:24.000000', 'temperatura', 459.0000, 'ºC'),
	(333005, 142, '2015-02-01 00:40:25.000000', 'temperatura', 1073.0000, 'ºC'),
	(333006, 142, '2015-02-01 00:40:26.000000', 'temperatura', 391.0000, 'ºC'),
	(333007, 142, '2015-02-01 00:40:27.000000', 'temperatura', 1136.0000, 'ºC'),
	(333008, 142, '2015-02-01 00:40:28.000000', 'temperatura', 905.0000, 'ºC'),
	(333009, 142, '2015-02-01 00:40:29.000000', 'temperatura', 1120.0000, 'ºC'),
	(333010, 142, '2015-02-01 00:40:30.000000', 'temperatura', 485.0000, 'ºC'),
	(333011, 142, '2015-02-01 00:40:31.000000', 'temperatura', 266.0000, 'ºC'),
	(333012, 142, '2015-02-01 00:40:32.000000', 'temperatura', 1077.0000, 'ºC'),
	(333013, 142, '2015-02-01 00:40:33.000000', 'temperatura', 985.0000, 'ºC'),
	(333014, 142, '2015-02-01 00:40:34.000000', 'temperatura', 493.0000, 'ºC'),
	(333015, 142, '2015-02-01 00:40:35.000000', 'temperatura', 714.0000, 'ºC'),
	(333016, 142, '2015-02-01 00:40:36.000000', 'temperatura', 889.0000, 'ºC'),
	(333017, 142, '2015-02-01 00:40:37.000000', 'temperatura', 1104.0000, 'ºC'),
	(333018, 142, '2015-02-01 00:40:38.000000', 'temperatura', 455.0000, 'ºC'),
	(333019, 142, '2015-02-01 00:40:39.000000', 'temperatura', 161.0000, 'ºC'),
	(333020, 142, '2015-02-01 00:40:40.000000', 'temperatura', 641.0000, 'ºC'),
	(333021, 142, '2015-02-01 00:40:41.000000', 'temperatura', 321.0000, 'ºC'),
	(333022, 142, '2015-02-01 00:40:42.000000', 'temperatura', 883.0000, 'ºC'),
	(333023, 142, '2015-02-01 00:40:43.000000', 'temperatura', 1054.0000, 'ºC'),
	(333024, 142, '2015-02-01 00:40:44.000000', 'temperatura', 220.0000, 'ºC'),
	(333025, 142, '2015-02-01 00:40:45.000000', 'temperatura', 340.0000, 'ºC'),
	(333026, 142, '2015-02-01 00:40:46.000000', 'temperatura', 1039.0000, 'ºC'),
	(333027, 142, '2015-02-01 00:40:47.000000', 'temperatura', 576.0000, 'ºC'),
	(333028, 142, '2015-02-01 00:40:48.000000', 'temperatura', 962.0000, 'ºC'),
	(333029, 142, '2015-02-01 00:40:49.000000', 'temperatura', 686.0000, 'ºC'),
	(333030, 142, '2015-02-01 00:40:50.000000', 'temperatura', 541.0000, 'ºC'),
	(333031, 142, '2015-02-01 00:40:51.000000', 'temperatura', 649.0000, 'ºC'),
	(333032, 142, '2015-02-01 00:40:52.000000', 'temperatura', 421.0000, 'ºC'),
	(333033, 142, '2015-02-01 00:40:53.000000', 'temperatura', 159.0000, 'ºC'),
	(333034, 142, '2015-02-01 00:40:54.000000', 'temperatura', 732.0000, 'ºC'),
	(333035, 142, '2015-02-01 00:40:55.000000', 'temperatura', 784.0000, 'ºC'),
	(333036, 142, '2015-02-01 00:40:56.000000', 'temperatura', 525.0000, 'ºC'),
	(333037, 142, '2015-02-01 00:40:57.000000', 'temperatura', 275.0000, 'ºC'),
	(333038, 142, '2015-02-01 00:40:58.000000', 'temperatura', 1000.0000, 'ºC'),
	(333039, 142, '2015-02-01 00:40:59.000000', 'temperatura', 577.0000, 'ºC'),
	(333040, 142, '2015-02-01 00:41:00.000000', 'temperatura', 1083.0000, 'ºC'),
	(333041, 142, '2015-02-01 00:41:01.000000', 'temperatura', 84.0000, 'ºC'),
	(333042, 142, '2015-02-01 00:41:02.000000', 'temperatura', 770.0000, 'ºC'),
	(333043, 142, '2015-02-01 00:41:03.000000', 'temperatura', 2.0000, 'ºC'),
	(333044, 142, '2015-02-01 00:41:04.000000', 'temperatura', 99.0000, 'ºC'),
	(333045, 142, '2015-02-01 00:41:05.000000', 'temperatura', 489.0000, 'ºC'),
	(333046, 142, '2015-02-01 00:41:06.000000', 'temperatura', 949.0000, 'ºC'),
	(333047, 142, '2015-02-01 00:41:07.000000', 'temperatura', 877.0000, 'ºC'),
	(333048, 142, '2015-02-01 00:41:08.000000', 'temperatura', 340.0000, 'ºC'),
	(333049, 142, '2015-02-01 00:41:09.000000', 'temperatura', 269.0000, 'ºC'),
	(333050, 142, '2015-02-01 00:41:10.000000', 'temperatura', 327.0000, 'ºC'),
	(333051, 142, '2015-02-01 00:41:11.000000', 'temperatura', 827.0000, 'ºC'),
	(333052, 142, '2015-02-01 00:41:12.000000', 'temperatura', 754.0000, 'ºC'),
	(333053, 142, '2015-02-01 00:41:13.000000', 'temperatura', 90.0000, 'ºC'),
	(333054, 142, '2015-02-01 00:41:14.000000', 'temperatura', 587.0000, 'ºC'),
	(333055, 142, '2015-02-01 00:41:15.000000', 'temperatura', 267.0000, 'ºC'),
	(333056, 142, '2015-02-01 00:41:16.000000', 'temperatura', 773.0000, 'ºC'),
	(333057, 142, '2015-02-01 00:41:17.000000', 'temperatura', 665.0000, 'ºC'),
	(333058, 142, '2015-02-01 00:41:18.000000', 'temperatura', 1007.0000, 'ºC'),
	(333059, 142, '2015-02-01 00:41:19.000000', 'temperatura', 639.0000, 'ºC'),
	(333060, 142, '2015-02-01 00:41:20.000000', 'temperatura', 175.0000, 'ºC'),
	(333061, 142, '2015-02-01 00:41:21.000000', 'temperatura', 161.0000, 'ºC'),
	(333062, 142, '2015-02-01 00:41:22.000000', 'temperatura', 277.0000, 'ºC'),
	(333063, 142, '2015-02-01 00:41:23.000000', 'temperatura', 905.0000, 'ºC'),
	(333064, 142, '2015-02-01 00:41:24.000000', 'temperatura', 94.0000, 'ºC'),
	(333065, 142, '2015-02-01 00:41:25.000000', 'temperatura', 157.0000, 'ºC'),
	(333066, 142, '2015-02-01 00:41:26.000000', 'temperatura', 502.0000, 'ºC'),
	(333067, 142, '2015-02-01 00:41:27.000000', 'temperatura', 842.0000, 'ºC'),
	(333068, 142, '2015-02-01 00:41:28.000000', 'temperatura', 301.0000, 'ºC'),
	(333069, 142, '2015-02-01 00:41:29.000000', 'temperatura', 182.0000, 'ºC'),
	(333070, 142, '2015-02-01 00:41:30.000000', 'temperatura', 7.0000, 'ºC'),
	(333071, 142, '2015-02-01 00:41:31.000000', 'temperatura', 687.0000, 'ºC'),
	(333072, 142, '2015-02-01 00:41:32.000000', 'temperatura', 1017.0000, 'ºC'),
	(333073, 142, '2015-02-01 00:41:33.000000', 'temperatura', 625.0000, 'ºC'),
	(333074, 142, '2015-02-01 00:41:34.000000', 'temperatura', 76.0000, 'ºC'),
	(333075, 142, '2015-02-01 00:41:35.000000', 'temperatura', 903.0000, 'ºC'),
	(333076, 142, '2015-02-01 00:41:36.000000', 'temperatura', 689.0000, 'ºC'),
	(333077, 142, '2015-02-01 00:41:37.000000', 'temperatura', 736.0000, 'ºC'),
	(333078, 142, '2015-02-01 00:41:38.000000', 'temperatura', 413.0000, 'ºC'),
	(333079, 142, '2015-02-01 00:41:39.000000', 'temperatura', 1058.0000, 'ºC'),
	(333080, 142, '2015-02-01 00:41:40.000000', 'temperatura', 452.0000, 'ºC'),
	(333081, 142, '2015-02-01 00:41:41.000000', 'temperatura', 286.0000, 'ºC'),
	(333082, 142, '2015-02-01 00:41:42.000000', 'temperatura', 75.0000, 'ºC'),
	(333083, 142, '2015-02-01 00:41:43.000000', 'temperatura', 717.0000, 'ºC'),
	(333084, 142, '2015-02-01 00:41:44.000000', 'temperatura', 962.0000, 'ºC'),
	(333085, 142, '2015-02-01 00:41:45.000000', 'temperatura', 258.0000, 'ºC'),
	(333086, 142, '2015-02-01 00:41:46.000000', 'temperatura', 804.0000, 'ºC'),
	(333087, 142, '2015-02-01 00:41:47.000000', 'temperatura', 847.0000, 'ºC'),
	(333088, 142, '2015-02-01 00:41:48.000000', 'temperatura', 625.0000, 'ºC'),
	(333089, 142, '2015-02-01 00:41:49.000000', 'temperatura', 584.0000, 'ºC'),
	(333090, 142, '2015-02-01 00:41:50.000000', 'temperatura', 1047.0000, 'ºC'),
	(333091, 142, '2015-02-01 00:41:51.000000', 'temperatura', 1083.0000, 'ºC'),
	(333092, 142, '2015-02-01 00:41:52.000000', 'temperatura', 1076.0000, 'ºC'),
	(333093, 142, '2015-02-01 00:41:53.000000', 'temperatura', 929.0000, 'ºC'),
	(333094, 142, '2015-02-01 00:41:54.000000', 'temperatura', 220.0000, 'ºC'),
	(333095, 142, '2015-02-01 00:41:55.000000', 'temperatura', 710.0000, 'ºC'),
	(333096, 142, '2015-02-01 00:41:56.000000', 'temperatura', 494.0000, 'ºC'),
	(333097, 142, '2015-02-01 00:41:57.000000', 'temperatura', 339.0000, 'ºC'),
	(333098, 142, '2015-02-01 00:41:58.000000', 'temperatura', 214.0000, 'ºC'),
	(333099, 142, '2015-02-01 00:41:59.000000', 'temperatura', 55.0000, 'ºC'),
	(333100, 142, '2015-02-01 00:42:00.000000', 'temperatura', 832.0000, 'ºC'),
	(333101, 142, '2015-02-01 00:42:01.000000', 'temperatura', 396.0000, 'ºC'),
	(333102, 142, '2015-02-01 00:42:02.000000', 'temperatura', 683.0000, 'ºC'),
	(333103, 142, '2015-02-01 00:42:03.000000', 'temperatura', 1027.0000, 'ºC'),
	(333104, 142, '2015-02-01 00:42:04.000000', 'temperatura', 686.0000, 'ºC'),
	(333105, 142, '2015-02-01 00:42:05.000000', 'temperatura', 349.0000, 'ºC'),
	(333106, 142, '2015-02-01 00:42:06.000000', 'temperatura', 887.0000, 'ºC'),
	(333107, 142, '2015-02-01 00:42:07.000000', 'temperatura', 991.0000, 'ºC'),
	(333108, 142, '2015-02-01 00:42:08.000000', 'temperatura', 1094.0000, 'ºC'),
	(333109, 142, '2015-02-01 00:42:09.000000', 'temperatura', 97.0000, 'ºC'),
	(333110, 142, '2015-02-01 00:42:10.000000', 'temperatura', 804.0000, 'ºC'),
	(333111, 142, '2015-02-01 00:42:11.000000', 'temperatura', 130.0000, 'ºC'),
	(333112, 142, '2015-02-01 00:42:12.000000', 'temperatura', 636.0000, 'ºC'),
	(333113, 142, '2015-02-01 00:42:13.000000', 'temperatura', 391.0000, 'ºC'),
	(333114, 142, '2015-02-01 00:42:14.000000', 'temperatura', 49.0000, 'ºC'),
	(333115, 142, '2015-02-01 00:42:15.000000', 'temperatura', 271.0000, 'ºC'),
	(333116, 142, '2015-02-01 00:42:16.000000', 'temperatura', 8.0000, 'ºC'),
	(333117, 142, '2015-02-01 00:42:17.000000', 'temperatura', 429.0000, 'ºC'),
	(333118, 142, '2015-02-01 00:42:18.000000', 'temperatura', 923.0000, 'ºC'),
	(333119, 142, '2015-02-01 00:42:19.000000', 'temperatura', 927.0000, 'ºC'),
	(333120, 142, '2015-02-01 00:42:20.000000', 'temperatura', 666.0000, 'ºC'),
	(333121, 142, '2015-02-01 00:42:21.000000', 'temperatura', 551.0000, 'ºC'),
	(333122, 142, '2015-02-01 00:42:22.000000', 'temperatura', 757.0000, 'ºC'),
	(333123, 142, '2015-02-01 00:42:23.000000', 'temperatura', 931.0000, 'ºC'),
	(333124, 142, '2015-02-01 00:42:24.000000', 'temperatura', 1184.0000, 'ºC'),
	(333125, 142, '2015-02-01 00:42:25.000000', 'temperatura', 727.0000, 'ºC'),
	(333126, 142, '2015-02-01 00:42:26.000000', 'temperatura', 82.0000, 'ºC'),
	(333127, 142, '2015-02-01 00:42:27.000000', 'temperatura', 633.0000, 'ºC'),
	(333128, 142, '2015-02-01 00:42:28.000000', 'temperatura', 519.0000, 'ºC'),
	(333129, 142, '2015-02-01 00:42:29.000000', 'temperatura', 695.0000, 'ºC'),
	(333130, 142, '2015-02-01 00:42:30.000000', 'temperatura', 720.0000, 'ºC'),
	(333131, 142, '2015-02-01 00:42:31.000000', 'temperatura', 315.0000, 'ºC'),
	(333132, 142, '2015-02-01 00:42:32.000000', 'temperatura', 614.0000, 'ºC'),
	(333133, 142, '2015-02-01 00:42:33.000000', 'temperatura', 926.0000, 'ºC'),
	(333134, 142, '2015-02-01 00:42:34.000000', 'temperatura', 387.0000, 'ºC'),
	(333135, 142, '2015-02-01 00:42:35.000000', 'temperatura', 360.0000, 'ºC'),
	(333136, 142, '2015-02-01 00:42:36.000000', 'temperatura', 637.0000, 'ºC'),
	(333137, 142, '2015-02-01 00:42:37.000000', 'temperatura', 907.0000, 'ºC'),
	(333138, 142, '2015-02-01 00:42:38.000000', 'temperatura', 222.0000, 'ºC'),
	(333139, 142, '2015-02-01 00:42:39.000000', 'temperatura', 793.0000, 'ºC'),
	(333140, 142, '2015-02-01 00:42:40.000000', 'temperatura', 897.0000, 'ºC'),
	(333141, 142, '2015-02-01 00:42:41.000000', 'temperatura', 908.0000, 'ºC'),
	(333142, 142, '2015-02-01 00:42:42.000000', 'temperatura', 648.0000, 'ºC'),
	(333143, 142, '2015-02-01 00:42:43.000000', 'temperatura', 519.0000, 'ºC'),
	(333144, 142, '2015-02-01 00:42:44.000000', 'temperatura', 649.0000, 'ºC'),
	(333145, 142, '2015-02-01 00:42:45.000000', 'temperatura', 488.0000, 'ºC'),
	(333146, 142, '2015-02-01 00:42:46.000000', 'temperatura', 496.0000, 'ºC'),
	(333147, 142, '2015-02-01 00:42:47.000000', 'temperatura', 1015.0000, 'ºC'),
	(333148, 142, '2015-02-01 00:42:48.000000', 'temperatura', 1189.0000, 'ºC'),
	(333149, 142, '2015-02-01 00:42:49.000000', 'temperatura', 501.0000, 'ºC'),
	(333150, 142, '2015-02-01 00:42:50.000000', 'temperatura', 140.0000, 'ºC'),
	(333151, 142, '2015-02-01 00:42:51.000000', 'temperatura', 394.0000, 'ºC'),
	(333152, 142, '2015-02-01 00:42:52.000000', 'temperatura', 353.0000, 'ºC'),
	(333153, 142, '2015-02-01 00:42:53.000000', 'temperatura', 583.0000, 'ºC'),
	(333154, 142, '2015-02-01 00:42:54.000000', 'temperatura', 657.0000, 'ºC'),
	(333155, 142, '2015-02-01 00:42:55.000000', 'temperatura', 336.0000, 'ºC'),
	(333156, 142, '2015-02-01 00:42:56.000000', 'temperatura', 911.0000, 'ºC'),
	(333157, 142, '2015-02-01 00:42:57.000000', 'temperatura', 1148.0000, 'ºC'),
	(333158, 142, '2015-02-01 00:42:58.000000', 'temperatura', 605.0000, 'ºC'),
	(333159, 142, '2015-02-01 00:42:59.000000', 'temperatura', 781.0000, 'ºC'),
	(333160, 142, '2015-02-01 00:43:00.000000', 'temperatura', 893.0000, 'ºC'),
	(333161, 142, '2015-02-01 00:43:01.000000', 'temperatura', 920.0000, 'ºC'),
	(333162, 142, '2015-02-01 00:43:02.000000', 'temperatura', 724.0000, 'ºC'),
	(333163, 142, '2015-02-01 00:43:03.000000', 'temperatura', 862.0000, 'ºC'),
	(333164, 142, '2015-02-01 00:43:04.000000', 'temperatura', 935.0000, 'ºC'),
	(333165, 142, '2015-02-01 00:43:05.000000', 'temperatura', 890.0000, 'ºC'),
	(333166, 142, '2015-02-01 00:43:06.000000', 'temperatura', 447.0000, 'ºC'),
	(333167, 142, '2015-02-01 00:43:07.000000', 'temperatura', 766.0000, 'ºC'),
	(333168, 142, '2015-02-01 00:43:08.000000', 'temperatura', 88.0000, 'ºC'),
	(333169, 142, '2015-02-01 00:43:09.000000', 'temperatura', 544.0000, 'ºC'),
	(333170, 142, '2015-02-01 00:43:10.000000', 'temperatura', 56.0000, 'ºC'),
	(333171, 142, '2015-02-01 00:43:11.000000', 'temperatura', 1049.0000, 'ºC'),
	(333172, 142, '2015-02-01 00:43:12.000000', 'temperatura', 278.0000, 'ºC'),
	(333173, 142, '2015-02-01 00:43:13.000000', 'temperatura', 642.0000, 'ºC'),
	(333174, 142, '2015-02-01 00:43:14.000000', 'temperatura', 1178.0000, 'ºC'),
	(333175, 142, '2015-02-01 00:43:15.000000', 'temperatura', 365.0000, 'ºC'),
	(333176, 142, '2015-02-01 00:43:16.000000', 'temperatura', 691.0000, 'ºC'),
	(333177, 142, '2015-02-01 00:43:17.000000', 'temperatura', 1159.0000, 'ºC'),
	(333178, 142, '2015-02-01 00:43:18.000000', 'temperatura', 125.0000, 'ºC'),
	(333179, 142, '2015-02-01 00:43:19.000000', 'temperatura', 749.0000, 'ºC'),
	(333180, 142, '2015-02-01 00:43:20.000000', 'temperatura', 970.0000, 'ºC'),
	(333181, 142, '2015-02-01 00:43:21.000000', 'temperatura', 204.0000, 'ºC'),
	(333182, 142, '2015-02-01 00:43:22.000000', 'temperatura', 509.0000, 'ºC'),
	(333183, 142, '2015-02-01 00:43:23.000000', 'temperatura', 736.0000, 'ºC'),
	(333184, 142, '2015-02-01 00:43:24.000000', 'temperatura', 952.0000, 'ºC'),
	(333185, 142, '2015-02-01 00:43:25.000000', 'temperatura', 151.0000, 'ºC'),
	(333186, 142, '2015-02-01 00:43:26.000000', 'temperatura', 300.0000, 'ºC'),
	(333187, 142, '2015-02-01 00:43:27.000000', 'temperatura', 1049.0000, 'ºC'),
	(333188, 142, '2015-02-01 00:43:28.000000', 'temperatura', 745.0000, 'ºC'),
	(333189, 142, '2015-02-01 00:43:29.000000', 'temperatura', 580.0000, 'ºC'),
	(333190, 142, '2015-02-01 00:43:30.000000', 'temperatura', 664.0000, 'ºC'),
	(333191, 142, '2015-02-01 00:43:31.000000', 'temperatura', 381.0000, 'ºC'),
	(333192, 142, '2015-02-01 00:43:32.000000', 'temperatura', 1113.0000, 'ºC'),
	(333193, 142, '2015-02-01 00:43:33.000000', 'temperatura', 821.0000, 'ºC'),
	(333194, 142, '2015-02-01 00:43:34.000000', 'temperatura', 767.0000, 'ºC'),
	(333195, 142, '2015-02-01 00:43:35.000000', 'temperatura', 172.0000, 'ºC'),
	(333196, 142, '2015-02-01 00:43:36.000000', 'temperatura', 961.0000, 'ºC'),
	(333197, 142, '2015-02-01 00:43:37.000000', 'temperatura', 690.0000, 'ºC'),
	(333198, 142, '2015-02-01 00:43:38.000000', 'temperatura', 565.0000, 'ºC'),
	(333199, 142, '2015-02-01 00:43:39.000000', 'temperatura', 755.0000, 'ºC'),
	(333200, 142, '2015-02-01 00:43:40.000000', 'temperatura', 883.0000, 'ºC'),
	(333201, 142, '2015-02-01 00:43:41.000000', 'temperatura', 952.0000, 'ºC'),
	(333202, 142, '2015-02-01 00:43:42.000000', 'temperatura', 908.0000, 'ºC'),
	(333203, 142, '2015-02-01 00:43:43.000000', 'temperatura', 486.0000, 'ºC'),
	(333204, 142, '2015-02-01 00:43:44.000000', 'temperatura', 905.0000, 'ºC'),
	(333205, 142, '2015-02-01 00:43:45.000000', 'temperatura', 669.0000, 'ºC'),
	(333206, 142, '2015-02-01 00:43:46.000000', 'temperatura', 630.0000, 'ºC'),
	(333207, 142, '2015-02-01 00:43:47.000000', 'temperatura', 1146.0000, 'ºC'),
	(333208, 142, '2015-02-01 00:43:48.000000', 'temperatura', 237.0000, 'ºC'),
	(333209, 142, '2015-02-01 00:43:49.000000', 'temperatura', 149.0000, 'ºC'),
	(333210, 142, '2015-02-01 00:43:50.000000', 'temperatura', 34.0000, 'ºC'),
	(333211, 142, '2015-02-01 00:43:51.000000', 'temperatura', 924.0000, 'ºC'),
	(333212, 142, '2015-02-01 00:43:52.000000', 'temperatura', 919.0000, 'ºC'),
	(333213, 142, '2015-02-01 00:43:53.000000', 'temperatura', 624.0000, 'ºC'),
	(333214, 142, '2015-02-01 00:43:54.000000', 'temperatura', 364.0000, 'ºC'),
	(333215, 142, '2015-02-01 00:43:55.000000', 'temperatura', 1147.0000, 'ºC'),
	(333216, 142, '2015-02-01 00:43:56.000000', 'temperatura', 1045.0000, 'ºC'),
	(333217, 142, '2015-02-01 00:43:57.000000', 'temperatura', 582.0000, 'ºC'),
	(333218, 142, '2015-02-01 00:43:58.000000', 'temperatura', 976.0000, 'ºC'),
	(333219, 142, '2015-02-01 00:43:59.000000', 'temperatura', 735.0000, 'ºC'),
	(333220, 142, '2015-02-01 00:44:00.000000', 'temperatura', 747.0000, 'ºC'),
	(333221, 142, '2015-02-01 00:44:01.000000', 'temperatura', 331.0000, 'ºC'),
	(333222, 142, '2015-02-01 00:44:02.000000', 'temperatura', 616.0000, 'ºC'),
	(333223, 142, '2015-02-01 00:44:03.000000', 'temperatura', 887.0000, 'ºC'),
	(333224, 142, '2015-02-01 00:44:04.000000', 'temperatura', 185.0000, 'ºC'),
	(333225, 142, '2015-02-01 00:44:05.000000', 'temperatura', 666.0000, 'ºC'),
	(333226, 142, '2015-02-01 00:44:06.000000', 'temperatura', 374.0000, 'ºC'),
	(333227, 142, '2015-02-01 00:44:07.000000', 'temperatura', 1074.0000, 'ºC'),
	(333228, 142, '2015-02-01 00:44:08.000000', 'temperatura', 647.0000, 'ºC'),
	(333229, 142, '2015-02-01 00:44:09.000000', 'temperatura', 16.0000, 'ºC'),
	(333230, 142, '2015-02-01 00:44:10.000000', 'temperatura', 537.0000, 'ºC'),
	(333231, 142, '2015-02-01 00:44:11.000000', 'temperatura', 239.0000, 'ºC'),
	(333232, 142, '2015-02-01 00:44:12.000000', 'temperatura', 783.0000, 'ºC'),
	(333233, 142, '2015-02-01 00:44:13.000000', 'temperatura', 799.0000, 'ºC'),
	(333234, 142, '2015-02-01 00:44:14.000000', 'temperatura', 446.0000, 'ºC'),
	(333235, 142, '2015-02-01 00:44:15.000000', 'temperatura', 1035.0000, 'ºC'),
	(333236, 142, '2015-02-01 00:44:16.000000', 'temperatura', 236.0000, 'ºC'),
	(333237, 142, '2015-02-01 00:44:17.000000', 'temperatura', 474.0000, 'ºC'),
	(333238, 142, '2015-02-01 00:44:18.000000', 'temperatura', 466.0000, 'ºC'),
	(333239, 142, '2015-02-01 00:44:19.000000', 'temperatura', 906.0000, 'ºC'),
	(333240, 142, '2015-02-01 00:44:20.000000', 'temperatura', 734.0000, 'ºC'),
	(333241, 142, '2015-02-01 00:44:21.000000', 'temperatura', 952.0000, 'ºC'),
	(333242, 142, '2015-02-01 00:44:22.000000', 'temperatura', 158.0000, 'ºC'),
	(333243, 142, '2015-02-01 00:44:23.000000', 'temperatura', 335.0000, 'ºC'),
	(333244, 142, '2015-02-01 00:44:24.000000', 'temperatura', 3.0000, 'ºC'),
	(333245, 142, '2015-02-01 00:44:25.000000', 'temperatura', 209.0000, 'ºC'),
	(333246, 142, '2015-02-01 00:44:26.000000', 'temperatura', 1036.0000, 'ºC'),
	(333247, 142, '2015-02-01 00:44:27.000000', 'temperatura', 954.0000, 'ºC'),
	(333248, 142, '2015-02-01 00:44:28.000000', 'temperatura', 461.0000, 'ºC'),
	(333249, 142, '2015-02-01 00:44:29.000000', 'temperatura', 643.0000, 'ºC'),
	(333250, 142, '2015-02-01 00:44:30.000000', 'temperatura', 632.0000, 'ºC'),
	(333251, 142, '2015-02-01 00:44:31.000000', 'temperatura', 31.0000, 'ºC'),
	(333252, 142, '2015-02-01 00:44:32.000000', 'temperatura', 661.0000, 'ºC'),
	(333253, 142, '2015-02-01 00:44:33.000000', 'temperatura', 812.0000, 'ºC'),
	(333254, 142, '2015-02-01 00:44:34.000000', 'temperatura', 879.0000, 'ºC'),
	(333255, 142, '2015-02-01 00:44:35.000000', 'temperatura', 758.0000, 'ºC'),
	(333256, 142, '2015-02-01 00:44:36.000000', 'temperatura', 1153.0000, 'ºC'),
	(333257, 142, '2015-02-01 00:44:37.000000', 'temperatura', 1094.0000, 'ºC'),
	(333258, 142, '2015-02-01 00:44:38.000000', 'temperatura', 808.0000, 'ºC'),
	(333259, 142, '2015-02-01 00:44:39.000000', 'temperatura', 762.0000, 'ºC'),
	(333260, 142, '2015-02-01 00:44:40.000000', 'temperatura', 184.0000, 'ºC'),
	(333261, 142, '2015-02-01 00:44:41.000000', 'temperatura', 1033.0000, 'ºC'),
	(333262, 142, '2015-02-01 00:44:42.000000', 'temperatura', 1016.0000, 'ºC'),
	(333263, 142, '2015-02-01 00:44:43.000000', 'temperatura', 781.0000, 'ºC'),
	(333264, 142, '2015-02-01 00:44:44.000000', 'temperatura', 859.0000, 'ºC'),
	(333265, 142, '2015-02-01 00:44:45.000000', 'temperatura', 750.0000, 'ºC'),
	(333266, 142, '2015-02-01 00:44:46.000000', 'temperatura', 1174.0000, 'ºC'),
	(333267, 142, '2015-02-01 00:44:47.000000', 'temperatura', 22.0000, 'ºC'),
	(333268, 142, '2015-02-01 00:44:48.000000', 'temperatura', 188.0000, 'ºC'),
	(333269, 142, '2015-02-01 00:44:49.000000', 'temperatura', 873.0000, 'ºC'),
	(333270, 142, '2015-02-01 00:44:50.000000', 'temperatura', 202.0000, 'ºC'),
	(333271, 142, '2015-02-01 00:44:51.000000', 'temperatura', 793.0000, 'ºC'),
	(333272, 142, '2015-02-01 00:44:52.000000', 'temperatura', 959.0000, 'ºC'),
	(333273, 142, '2015-02-01 00:44:53.000000', 'temperatura', 15.0000, 'ºC'),
	(333274, 142, '2015-02-01 00:44:54.000000', 'temperatura', 799.0000, 'ºC'),
	(333275, 142, '2015-02-01 00:44:55.000000', 'temperatura', 350.0000, 'ºC'),
	(333276, 142, '2015-02-01 00:44:56.000000', 'temperatura', 556.0000, 'ºC'),
	(333277, 142, '2015-02-01 00:44:57.000000', 'temperatura', 529.0000, 'ºC'),
	(333278, 142, '2015-02-01 00:44:58.000000', 'temperatura', 977.0000, 'ºC'),
	(333279, 142, '2015-02-01 00:44:59.000000', 'temperatura', 900.0000, 'ºC'),
	(333280, 142, '2015-02-01 00:45:00.000000', 'temperatura', 368.0000, 'ºC'),
	(333281, 142, '2015-02-01 00:45:01.000000', 'temperatura', 342.0000, 'ºC'),
	(333282, 142, '2015-02-01 00:45:02.000000', 'temperatura', 604.0000, 'ºC'),
	(333283, 142, '2015-02-01 00:45:03.000000', 'temperatura', 797.0000, 'ºC'),
	(333284, 142, '2015-02-01 00:45:04.000000', 'temperatura', 974.0000, 'ºC'),
	(333285, 142, '2015-02-01 00:45:05.000000', 'temperatura', 77.0000, 'ºC'),
	(333286, 142, '2015-02-01 00:45:06.000000', 'temperatura', 1064.0000, 'ºC'),
	(333287, 142, '2015-02-01 00:45:07.000000', 'temperatura', 291.0000, 'ºC'),
	(333288, 142, '2015-02-01 00:45:08.000000', 'temperatura', 663.0000, 'ºC'),
	(333289, 142, '2015-02-01 00:45:09.000000', 'temperatura', 43.0000, 'ºC'),
	(333290, 142, '2015-02-01 00:45:10.000000', 'temperatura', 628.0000, 'ºC'),
	(333291, 142, '2015-02-01 00:45:11.000000', 'temperatura', 611.0000, 'ºC'),
	(333292, 142, '2015-02-01 00:45:12.000000', 'temperatura', 1169.0000, 'ºC'),
	(333293, 142, '2015-02-01 00:45:13.000000', 'temperatura', 413.0000, 'ºC'),
	(333294, 142, '2015-02-01 00:45:14.000000', 'temperatura', 958.0000, 'ºC'),
	(333295, 142, '2015-02-01 00:45:15.000000', 'temperatura', 1151.0000, 'ºC'),
	(333296, 142, '2015-02-01 00:45:16.000000', 'temperatura', 484.0000, 'ºC'),
	(333297, 142, '2015-02-01 00:45:17.000000', 'temperatura', 167.0000, 'ºC'),
	(333298, 142, '2015-02-01 00:45:18.000000', 'temperatura', 583.0000, 'ºC'),
	(333299, 142, '2015-02-01 00:45:19.000000', 'temperatura', 15.0000, 'ºC'),
	(333300, 142, '2015-02-01 00:45:20.000000', 'temperatura', 724.0000, 'ºC'),
	(333301, 142, '2015-02-01 00:45:21.000000', 'temperatura', 1177.0000, 'ºC'),
	(333302, 142, '2015-02-01 00:45:22.000000', 'temperatura', 115.0000, 'ºC'),
	(333303, 142, '2015-02-01 00:45:23.000000', 'temperatura', 641.0000, 'ºC'),
	(333304, 142, '2015-02-01 00:45:24.000000', 'temperatura', 464.0000, 'ºC'),
	(333305, 142, '2015-02-01 00:45:25.000000', 'temperatura', 395.0000, 'ºC'),
	(333306, 142, '2015-02-01 00:45:26.000000', 'temperatura', 583.0000, 'ºC'),
	(333307, 142, '2015-02-01 00:45:27.000000', 'temperatura', 534.0000, 'ºC'),
	(333308, 142, '2015-02-01 00:45:28.000000', 'temperatura', 918.0000, 'ºC'),
	(333309, 142, '2015-02-01 00:45:29.000000', 'temperatura', 590.0000, 'ºC'),
	(333310, 142, '2015-02-01 00:45:30.000000', 'temperatura', 196.0000, 'ºC'),
	(333311, 142, '2015-02-01 00:45:31.000000', 'temperatura', 409.0000, 'ºC'),
	(333312, 142, '2015-02-01 00:45:32.000000', 'temperatura', 257.0000, 'ºC'),
	(333313, 142, '2015-02-01 00:45:33.000000', 'temperatura', 61.0000, 'ºC'),
	(333314, 142, '2015-02-01 00:45:34.000000', 'temperatura', 734.0000, 'ºC'),
	(333315, 142, '2015-02-01 00:45:35.000000', 'temperatura', 1087.0000, 'ºC'),
	(333316, 142, '2015-02-01 00:45:36.000000', 'temperatura', 834.0000, 'ºC'),
	(333317, 142, '2015-02-01 00:45:37.000000', 'temperatura', 908.0000, 'ºC'),
	(333318, 142, '2015-02-01 00:45:38.000000', 'temperatura', 841.0000, 'ºC'),
	(333319, 142, '2015-02-01 00:45:39.000000', 'temperatura', 281.0000, 'ºC'),
	(333320, 142, '2015-02-01 00:45:40.000000', 'temperatura', 82.0000, 'ºC'),
	(333321, 142, '2015-02-01 00:45:41.000000', 'temperatura', 769.0000, 'ºC'),
	(333322, 142, '2015-02-01 00:45:42.000000', 'temperatura', 0.0000, 'ºC'),
	(333323, 142, '2015-02-01 00:45:43.000000', 'temperatura', 94.0000, 'ºC'),
	(333324, 142, '2015-02-01 00:45:44.000000', 'temperatura', 471.0000, 'ºC'),
	(333325, 142, '2015-02-01 00:45:45.000000', 'temperatura', 873.0000, 'ºC'),
	(333326, 142, '2015-02-01 00:45:46.000000', 'temperatura', 550.0000, 'ºC'),
	(333327, 142, '2015-02-01 00:45:47.000000', 'temperatura', 133.0000, 'ºC'),
	(333328, 142, '2015-02-01 00:45:48.000000', 'temperatura', 215.0000, 'ºC'),
	(333329, 142, '2015-02-01 00:45:49.000000', 'temperatura', 678.0000, 'ºC'),
	(333330, 142, '2015-02-01 00:45:50.000000', 'temperatura', 347.0000, 'ºC'),
	(333331, 142, '2015-02-01 00:45:51.000000', 'temperatura', 898.0000, 'ºC'),
	(333332, 142, '2015-02-01 00:45:52.000000', 'temperatura', 1052.0000, 'ºC'),
	(333333, 142, '2015-02-01 00:45:53.000000', 'temperatura', 165.0000, 'ºC'),
	(333334, 142, '2015-02-01 00:45:54.000000', 'temperatura', 69.0000, 'ºC'),
	(333335, 142, '2015-02-01 00:45:55.000000', 'temperatura', 1050.0000, 'ºC'),
	(333336, 142, '2015-02-01 00:45:56.000000', 'temperatura', 242.0000, 'ºC'),
	(333337, 142, '2015-02-01 00:45:57.000000', 'temperatura', 463.0000, 'ºC'),
	(333338, 142, '2015-02-01 00:45:58.000000', 'temperatura', 389.0000, 'ºC'),
	(333339, 142, '2015-02-01 00:45:59.000000', 'temperatura', 557.0000, 'ºC'),
	(333340, 142, '2015-02-01 00:46:00.000000', 'temperatura', 416.0000, 'ºC'),
	(333341, 142, '2015-02-01 00:46:01.000000', 'temperatura', 411.0000, 'ºC'),
	(333342, 142, '2015-02-01 00:46:02.000000', 'temperatura', 807.0000, 'ºC'),
	(333343, 142, '2015-02-01 00:46:03.000000', 'temperatura', 402.0000, 'ºC'),
	(333344, 142, '2015-02-01 00:46:04.000000', 'temperatura', 792.0000, 'ºC'),
	(333345, 142, '2015-02-01 00:46:05.000000', 'temperatura', 351.0000, 'ºC'),
	(333346, 142, '2015-02-01 00:46:06.000000', 'temperatura', 583.0000, 'ºC'),
	(333347, 142, '2015-02-01 00:46:07.000000', 'temperatura', 661.0000, 'ºC'),
	(333348, 142, '2015-02-01 00:46:08.000000', 'temperatura', 355.0000, 'ºC'),
	(333349, 142, '2015-02-01 00:46:09.000000', 'temperatura', 992.0000, 'ºC'),
	(333350, 142, '2015-02-01 00:46:10.000000', 'temperatura', 298.0000, 'ºC'),
	(333351, 142, '2015-02-01 00:46:11.000000', 'temperatura', 913.0000, 'ºC'),
	(333352, 142, '2015-02-01 00:46:12.000000', 'temperatura', 73.0000, 'ºC'),
	(333353, 142, '2015-02-01 00:46:13.000000', 'temperatura', 26.0000, 'ºC'),
	(333354, 142, '2015-02-01 00:46:14.000000', 'temperatura', 1110.0000, 'ºC'),
	(333355, 142, '2015-02-01 00:46:15.000000', 'temperatura', 674.0000, 'ºC'),
	(333356, 142, '2015-02-01 00:46:16.000000', 'temperatura', 38.0000, 'ºC'),
	(333357, 142, '2015-02-01 00:46:17.000000', 'temperatura', 571.0000, 'ºC'),
	(333358, 142, '2015-02-01 00:46:18.000000', 'temperatura', 343.0000, 'ºC'),
	(333359, 142, '2015-02-01 00:46:19.000000', 'temperatura', 1199.0000, 'ºC'),
	(333360, 142, '2015-02-01 00:46:20.000000', 'temperatura', 167.0000, 'ºC'),
	(333361, 142, '2015-02-01 00:46:21.000000', 'temperatura', 840.0000, 'ºC'),
	(333362, 142, '2015-02-01 00:46:22.000000', 'temperatura', 100.0000, 'ºC'),
	(333363, 142, '2015-02-01 00:46:23.000000', 'temperatura', 380.0000, 'ºC'),
	(333364, 142, '2015-02-01 00:46:24.000000', 'temperatura', 398.0000, 'ºC'),
	(333365, 142, '2015-02-01 00:46:25.000000', 'temperatura', 853.0000, 'ºC'),
	(333366, 142, '2015-02-01 00:46:26.000000', 'temperatura', 673.0000, 'ºC'),
	(333367, 142, '2015-02-01 00:46:27.000000', 'temperatura', 804.0000, 'ºC'),
	(333368, 142, '2015-02-01 00:46:28.000000', 'temperatura', 804.0000, 'ºC'),
	(333369, 142, '2015-02-01 00:46:29.000000', 'temperatura', 406.0000, 'ºC'),
	(333370, 142, '2015-02-01 00:46:30.000000', 'temperatura', 818.0000, 'ºC'),
	(333371, 142, '2015-02-01 00:46:31.000000', 'temperatura', 473.0000, 'ºC'),
	(333372, 142, '2015-02-01 00:46:32.000000', 'temperatura', 1112.0000, 'ºC'),
	(333373, 142, '2015-02-01 00:46:33.000000', 'temperatura', 539.0000, 'ºC'),
	(333374, 142, '2015-02-01 00:46:34.000000', 'temperatura', 562.0000, 'ºC'),
	(333375, 142, '2015-02-01 00:46:35.000000', 'temperatura', 1194.0000, 'ºC'),
	(333376, 142, '2015-02-01 00:46:36.000000', 'temperatura', 684.0000, 'ºC'),
	(333377, 142, '2015-02-01 00:46:37.000000', 'temperatura', 1037.0000, 'ºC'),
	(333378, 142, '2015-02-01 00:46:38.000000', 'temperatura', 735.0000, 'ºC'),
	(333379, 142, '2015-02-01 00:46:39.000000', 'temperatura', 563.0000, 'ºC'),
	(333380, 142, '2015-02-01 00:46:40.000000', 'temperatura', 610.0000, 'ºC'),
	(333381, 142, '2015-02-01 00:46:41.000000', 'temperatura', 163.0000, 'ºC'),
	(333382, 142, '2015-02-01 00:46:42.000000', 'temperatura', 185.0000, 'ºC'),
	(333383, 142, '2015-02-01 00:46:43.000000', 'temperatura', 437.0000, 'ºC'),
	(333384, 142, '2015-02-01 00:46:44.000000', 'temperatura', 432.0000, 'ºC'),
	(333385, 142, '2015-02-01 00:46:45.000000', 'temperatura', 846.0000, 'ºC'),
	(333386, 142, '2015-02-01 00:46:46.000000', 'temperatura', 538.0000, 'ºC'),
	(333387, 142, '2015-02-01 00:46:47.000000', 'temperatura', 149.0000, 'ºC'),
	(333388, 142, '2015-02-01 00:46:48.000000', 'temperatura', 335.0000, 'ºC'),
	(333389, 142, '2015-02-01 00:46:49.000000', 'temperatura', 26.0000, 'ºC'),
	(333390, 142, '2015-02-01 00:46:50.000000', 'temperatura', 328.0000, 'ºC'),
	(333391, 142, '2015-02-01 00:46:51.000000', 'temperatura', 361.0000, 'ºC'),
	(333392, 142, '2015-02-01 00:46:52.000000', 'temperatura', 820.0000, 'ºC'),
	(333393, 142, '2015-02-01 00:46:53.000000', 'temperatura', 619.0000, 'ºC'),
	(333394, 142, '2015-02-01 00:46:54.000000', 'temperatura', 635.0000, 'ºC'),
	(333395, 142, '2015-02-01 00:46:55.000000', 'temperatura', 119.0000, 'ºC'),
	(333396, 142, '2015-02-01 00:46:56.000000', 'temperatura', 1092.0000, 'ºC'),
	(333397, 142, '2015-02-01 00:46:57.000000', 'temperatura', 302.0000, 'ºC'),
	(333398, 142, '2015-02-01 00:46:58.000000', 'temperatura', 634.0000, 'ºC'),
	(333399, 142, '2015-02-01 00:46:59.000000', 'temperatura', 1065.0000, 'ºC'),
	(333400, 142, '2015-02-01 00:47:00.000000', 'temperatura', 1024.0000, 'ºC'),
	(333401, 142, '2015-02-01 00:47:01.000000', 'temperatura', 726.0000, 'ºC'),
	(333402, 142, '2015-02-01 00:47:02.000000', 'temperatura', 559.0000, 'ºC'),
	(333403, 142, '2015-02-01 00:47:03.000000', 'temperatura', 616.0000, 'ºC'),
	(333404, 142, '2015-02-01 00:47:04.000000', 'temperatura', 203.0000, 'ºC'),
	(333405, 142, '2015-02-01 00:47:05.000000', 'temperatura', 370.0000, 'ºC'),
	(333406, 142, '2015-02-01 00:47:06.000000', 'temperatura', 39.0000, 'ºC'),
	(333407, 142, '2015-02-01 00:47:07.000000', 'temperatura', 284.0000, 'ºC'),
	(333408, 142, '2015-02-01 00:47:08.000000', 'temperatura', 107.0000, 'ºC'),
	(333409, 142, '2015-02-01 00:47:09.000000', 'temperatura', 881.0000, 'ºC'),
	(333410, 142, '2015-02-01 00:47:10.000000', 'temperatura', 487.0000, 'ºC'),
	(333411, 142, '2015-02-01 00:47:11.000000', 'temperatura', 992.0000, 'ºC'),
	(333412, 142, '2015-02-01 00:47:12.000000', 'temperatura', 1101.0000, 'ºC'),
	(333413, 142, '2015-02-01 00:47:13.000000', 'temperatura', 129.0000, 'ºC'),
	(333414, 142, '2015-02-01 00:47:14.000000', 'temperatura', 942.0000, 'ºC'),
	(333415, 142, '2015-02-01 00:47:15.000000', 'temperatura', 722.0000, 'ºC'),
	(333416, 142, '2015-02-01 00:47:16.000000', 'temperatura', 786.0000, 'ºC'),
	(333417, 142, '2015-02-01 00:47:17.000000', 'temperatura', 562.0000, 'ºC'),
	(333418, 142, '2015-02-01 00:47:18.000000', 'temperatura', 455.0000, 'ºC'),
	(333419, 142, '2015-02-01 00:47:19.000000', 'temperatura', 591.0000, 'ºC'),
	(333420, 142, '2015-02-01 00:47:20.000000', 'temperatura', 388.0000, 'ºC'),
	(333421, 142, '2015-02-01 00:47:21.000000', 'temperatura', 170.0000, 'ºC'),
	(333422, 142, '2015-02-01 00:47:22.000000', 'temperatura', 885.0000, 'ºC'),
	(333423, 142, '2015-02-01 00:47:23.000000', 'temperatura', 317.0000, 'ºC'),
	(333424, 142, '2015-02-01 00:47:24.000000', 'temperatura', 131.0000, 'ºC'),
	(333425, 142, '2015-02-01 00:47:25.000000', 'temperatura', 903.0000, 'ºC'),
	(333426, 142, '2015-02-01 00:47:26.000000', 'temperatura', 524.0000, 'ºC'),
	(333427, 142, '2015-02-01 00:47:27.000000', 'temperatura', 1110.0000, 'ºC'),
	(333428, 142, '2015-02-01 00:47:28.000000', 'temperatura', 380.0000, 'ºC'),
	(333429, 142, '2015-02-01 00:47:29.000000', 'temperatura', 968.0000, 'ºC'),
	(333430, 142, '2015-02-01 00:47:30.000000', 'temperatura', 102.0000, 'ºC'),
	(333431, 142, '2015-02-01 00:47:31.000000', 'temperatura', 8.0000, 'ºC'),
	(333432, 142, '2015-02-01 00:47:32.000000', 'temperatura', 933.0000, 'ºC'),
	(333433, 142, '2015-02-01 00:47:33.000000', 'temperatura', 1043.0000, 'ºC'),
	(333434, 142, '2015-02-01 00:47:34.000000', 'temperatura', 16.0000, 'ºC'),
	(333435, 142, '2015-02-01 00:47:35.000000', 'temperatura', 552.0000, 'ºC'),
	(333436, 142, '2015-02-01 00:47:36.000000', 'temperatura', 313.0000, 'ºC'),
	(333437, 142, '2015-02-01 00:47:37.000000', 'temperatura', 1110.0000, 'ºC'),
	(333438, 142, '2015-02-01 00:47:38.000000', 'temperatura', 1009.0000, 'ºC'),
	(333439, 142, '2015-02-01 00:47:39.000000', 'temperatura', 516.0000, 'ºC'),
	(333440, 142, '2015-02-01 00:47:40.000000', 'temperatura', 755.0000, 'ºC'),
	(333441, 142, '2015-02-01 00:47:41.000000', 'temperatura', 1026.0000, 'ºC'),
	(333442, 142, '2015-02-01 00:47:42.000000', 'temperatura', 468.0000, 'ºC'),
	(333443, 142, '2015-02-01 00:47:43.000000', 'temperatura', 462.0000, 'ºC'),
	(333444, 142, '2015-02-01 00:47:44.000000', 'temperatura', 905.0000, 'ºC'),
	(333445, 142, '2015-02-01 00:47:45.000000', 'temperatura', 742.0000, 'ºC'),
	(333446, 142, '2015-02-01 00:47:46.000000', 'temperatura', 993.0000, 'ºC'),
	(333447, 142, '2015-02-01 00:47:47.000000', 'temperatura', 341.0000, 'ºC'),
	(333448, 142, '2015-02-01 00:47:48.000000', 'temperatura', 1127.0000, 'ºC'),
	(333449, 142, '2015-02-01 00:47:49.000000', 'temperatura', 1010.0000, 'ºC'),
	(333450, 142, '2015-02-01 00:47:50.000000', 'temperatura', 471.0000, 'ºC'),
	(333451, 142, '2015-02-01 00:47:51.000000', 'temperatura', 525.0000, 'ºC'),
	(333452, 142, '2015-02-01 00:47:52.000000', 'temperatura', 13.0000, 'ºC'),
	(333453, 142, '2015-02-01 00:47:53.000000', 'temperatura', 889.0000, 'ºC'),
	(333454, 142, '2015-02-01 00:47:54.000000', 'temperatura', 807.0000, 'ºC'),
	(333455, 142, '2015-02-01 00:47:55.000000', 'temperatura', 168.0000, 'ºC'),
	(333456, 142, '2015-02-01 00:47:56.000000', 'temperatura', 821.0000, 'ºC'),
	(333457, 142, '2015-02-01 00:47:57.000000', 'temperatura', 0.0000, 'ºC'),
	(333458, 142, '2015-02-01 00:47:58.000000', 'temperatura', 1139.0000, 'ºC'),
	(333459, 142, '2015-02-01 00:47:59.000000', 'temperatura', 896.0000, 'ºC'),
	(333460, 142, '2015-02-01 00:48:00.000000', 'temperatura', 1063.0000, 'ºC'),
	(333461, 142, '2015-02-01 00:48:01.000000', 'temperatura', 227.0000, 'ºC'),
	(333462, 142, '2015-02-01 00:48:02.000000', 'temperatura', 345.0000, 'ºC'),
	(333463, 142, '2015-02-01 00:48:03.000000', 'temperatura', 1044.0000, 'ºC'),
	(333464, 142, '2015-02-01 00:48:04.000000', 'temperatura', 589.0000, 'ºC'),
	(333465, 142, '2015-02-01 00:48:05.000000', 'temperatura', 1011.0000, 'ºC'),
	(333466, 142, '2015-02-01 00:48:06.000000', 'temperatura', 888.0000, 'ºC'),
	(333467, 142, '2015-02-01 00:48:07.000000', 'temperatura', 208.0000, 'ºC'),
	(333468, 142, '2015-02-01 00:48:08.000000', 'temperatura', 778.0000, 'ºC'),
	(333469, 142, '2015-02-01 00:48:09.000000', 'temperatura', 865.0000, 'ºC'),
	(333470, 142, '2015-02-01 00:48:10.000000', 'temperatura', 790.0000, 'ºC'),
	(333471, 142, '2015-02-01 00:48:11.000000', 'temperatura', 158.0000, 'ºC'),
	(333472, 142, '2015-02-01 00:48:12.000000', 'temperatura', 821.0000, 'ºC'),
	(333473, 142, '2015-02-01 00:48:13.000000', 'temperatura', 29.0000, 'ºC'),
	(333474, 142, '2015-02-01 00:48:14.000000', 'temperatura', 82.0000, 'ºC'),
	(333475, 142, '2015-02-01 00:48:15.000000', 'temperatura', 323.0000, 'ºC'),
	(333476, 142, '2015-02-01 00:48:16.000000', 'temperatura', 171.0000, 'ºC'),
	(333477, 142, '2015-02-01 00:48:17.000000', 'temperatura', 1086.0000, 'ºC'),
	(333478, 142, '2015-02-01 00:48:18.000000', 'temperatura', 119.0000, 'ºC'),
	(333479, 142, '2015-02-01 00:48:19.000000', 'temperatura', 938.0000, 'ºC'),
	(333480, 142, '2015-02-01 00:48:20.000000', 'temperatura', 733.0000, 'ºC'),
	(333481, 142, '2015-02-01 00:48:21.000000', 'temperatura', 853.0000, 'ºC'),
	(333482, 142, '2015-02-01 00:48:22.000000', 'temperatura', 863.0000, 'ºC'),
	(333483, 142, '2015-02-01 00:48:23.000000', 'temperatura', 559.0000, 'ºC'),
	(333484, 142, '2015-02-01 00:48:24.000000', 'temperatura', 206.0000, 'ºC'),
	(333485, 142, '2015-02-01 00:48:25.000000', 'temperatura', 551.0000, 'ºC'),
	(333486, 142, '2015-02-01 00:48:26.000000', 'temperatura', 941.0000, 'ºC'),
	(333487, 142, '2015-02-01 00:48:27.000000', 'temperatura', 651.0000, 'ºC'),
	(333488, 142, '2015-02-01 00:48:28.000000', 'temperatura', 431.0000, 'ºC'),
	(333489, 142, '2015-02-01 00:48:29.000000', 'temperatura', 204.0000, 'ºC'),
	(333490, 142, '2015-02-01 00:48:30.000000', 'temperatura', 927.0000, 'ºC'),
	(333491, 142, '2015-02-01 00:48:31.000000', 'temperatura', 423.0000, 'ºC'),
	(333492, 142, '2015-02-01 00:48:32.000000', 'temperatura', 534.0000, 'ºC'),
	(333493, 142, '2015-02-01 00:48:33.000000', 'temperatura', 201.0000, 'ºC'),
	(333494, 142, '2015-02-01 00:48:34.000000', 'temperatura', 604.0000, 'ºC'),
	(333495, 142, '2015-02-01 00:48:35.000000', 'temperatura', 18.0000, 'ºC'),
	(333496, 142, '2015-02-01 00:48:36.000000', 'temperatura', 677.0000, 'ºC'),
	(333497, 142, '2015-02-01 00:48:37.000000', 'temperatura', 934.0000, 'ºC'),
	(333498, 142, '2015-02-01 00:48:38.000000', 'temperatura', 237.0000, 'ºC'),
	(333499, 142, '2015-02-01 00:48:39.000000', 'temperatura', 787.0000, 'ºC'),
	(333500, 142, '2015-02-01 00:48:40.000000', 'temperatura', 821.0000, 'ºC'),
	(333501, 142, '2015-02-01 00:48:41.000000', 'temperatura', 544.0000, 'ºC'),
	(333502, 142, '2015-02-01 00:48:42.000000', 'temperatura', 258.0000, 'ºC'),
	(333503, 142, '2015-02-01 00:48:43.000000', 'temperatura', 861.0000, 'ºC'),
	(333504, 142, '2015-02-01 00:48:44.000000', 'temperatura', 1130.0000, 'ºC'),
	(333505, 142, '2015-02-01 00:48:45.000000', 'temperatura', 667.0000, 'ºC'),
	(333506, 142, '2015-02-01 00:48:46.000000', 'temperatura', 1148.0000, 'ºC'),
	(333507, 142, '2015-02-01 00:48:47.000000', 'temperatura', 137.0000, 'ºC'),
	(333508, 142, '2015-02-01 00:48:48.000000', 'temperatura', 843.0000, 'ºC'),
	(333509, 142, '2015-02-01 00:48:49.000000', 'temperatura', 205.0000, 'ºC'),
	(333510, 142, '2015-02-01 00:48:50.000000', 'temperatura', 897.0000, 'ºC'),
	(333511, 142, '2015-02-01 00:48:51.000000', 'temperatura', 271.0000, 'ºC'),
	(333512, 142, '2015-02-01 00:48:52.000000', 'temperatura', 1064.0000, 'ºC'),
	(333513, 142, '2015-02-01 00:48:53.000000', 'temperatura', 906.0000, 'ºC'),
	(333514, 142, '2015-02-01 00:48:54.000000', 'temperatura', 141.0000, 'ºC'),
	(333515, 142, '2015-02-01 00:48:55.000000', 'temperatura', 386.0000, 'ºC'),
	(333516, 142, '2015-02-01 00:48:56.000000', 'temperatura', 308.0000, 'ºC'),
	(333517, 142, '2015-02-01 00:48:57.000000', 'temperatura', 383.0000, 'ºC'),
	(333518, 142, '2015-02-01 00:48:58.000000', 'temperatura', 991.0000, 'ºC'),
	(333519, 142, '2015-02-01 00:48:59.000000', 'temperatura', 205.0000, 'ºC'),
	(333520, 142, '2015-02-01 00:49:00.000000', 'temperatura', 453.0000, 'ºC'),
	(333521, 142, '2015-02-01 00:49:01.000000', 'temperatura', 450.0000, 'ºC'),
	(333522, 142, '2015-02-01 00:49:02.000000', 'temperatura', 894.0000, 'ºC'),
	(333523, 142, '2015-02-01 00:49:03.000000', 'temperatura', 717.0000, 'ºC'),
	(333524, 142, '2015-02-01 00:49:04.000000', 'temperatura', 906.0000, 'ºC'),
	(333525, 142, '2015-02-01 00:49:05.000000', 'temperatura', 1177.0000, 'ºC'),
	(333526, 142, '2015-02-01 00:49:06.000000', 'temperatura', 770.0000, 'ºC'),
	(333527, 142, '2015-02-01 00:49:07.000000', 'temperatura', 319.0000, 'ºC'),
	(333528, 142, '2015-02-01 00:49:08.000000', 'temperatura', 484.0000, 'ºC'),
	(333529, 142, '2015-02-01 00:49:09.000000', 'temperatura', 265.0000, 'ºC'),
	(333530, 142, '2015-02-01 00:49:10.000000', 'temperatura', 1072.0000, 'ºC'),
	(333531, 142, '2015-02-01 00:49:11.000000', 'temperatura', 965.0000, 'ºC'),
	(333532, 142, '2015-02-01 00:49:12.000000', 'temperatura', 411.0000, 'ºC'),
	(333533, 142, '2015-02-01 00:49:13.000000', 'temperatura', 360.0000, 'ºC'),
	(333534, 142, '2015-02-01 00:49:14.000000', 'temperatura', 567.0000, 'ºC'),
	(333535, 142, '2015-02-01 00:49:15.000000', 'temperatura', 557.0000, 'ºC'),
	(333536, 142, '2015-02-01 00:49:16.000000', 'temperatura', 1082.0000, 'ºC'),
	(333537, 142, '2015-02-01 00:49:17.000000', 'temperatura', 142.0000, 'ºC'),
	(333538, 142, '2015-02-01 00:49:18.000000', 'temperatura', 1065.0000, 'ºC'),
	(333539, 142, '2015-02-01 00:49:19.000000', 'temperatura', 97.0000, 'ºC'),
	(333540, 142, '2015-02-01 00:49:20.000000', 'temperatura', 893.0000, 'ºC'),
	(333541, 142, '2015-02-01 00:49:21.000000', 'temperatura', 575.0000, 'ºC'),
	(333542, 142, '2015-02-01 00:49:22.000000', 'temperatura', 197.0000, 'ºC'),
	(333543, 142, '2015-02-01 00:49:23.000000', 'temperatura', 460.0000, 'ºC'),
	(333544, 142, '2015-02-01 00:49:24.000000', 'temperatura', 511.0000, 'ºC'),
	(333545, 142, '2015-02-01 00:49:25.000000', 'temperatura', 1175.0000, 'ºC'),
	(333546, 142, '2015-02-01 00:49:26.000000', 'temperatura', 741.0000, 'ºC'),
	(333547, 142, '2015-02-01 00:49:27.000000', 'temperatura', 181.0000, 'ºC'),
	(333548, 142, '2015-02-01 00:49:28.000000', 'temperatura', 1084.0000, 'ºC'),
	(333549, 142, '2015-02-01 00:49:29.000000', 'temperatura', 76.0000, 'ºC'),
	(333550, 142, '2015-02-01 00:49:30.000000', 'temperatura', 727.0000, 'ºC'),
	(333551, 142, '2015-02-01 00:49:31.000000', 'temperatura', 1010.0000, 'ºC'),
	(333552, 142, '2015-02-01 00:49:32.000000', 'temperatura', 467.0000, 'ºC'),
	(333553, 142, '2015-02-01 00:49:33.000000', 'temperatura', 507.0000, 'ºC'),
	(333554, 142, '2015-02-01 00:49:34.000000', 'temperatura', 1133.0000, 'ºC'),
	(333555, 142, '2015-02-01 00:49:35.000000', 'temperatura', 545.0000, 'ºC'),
	(333556, 142, '2015-02-01 00:49:36.000000', 'temperatura', 525.0000, 'ºC'),
	(333557, 142, '2015-02-01 00:49:37.000000', 'temperatura', 991.0000, 'ºC'),
	(333558, 142, '2015-02-01 00:49:38.000000', 'temperatura', 981.0000, 'ºC'),
	(333559, 142, '2015-02-01 00:49:39.000000', 'temperatura', 734.0000, 'ºC'),
	(333560, 142, '2015-02-01 00:49:40.000000', 'temperatura', 728.0000, 'ºC'),
	(333561, 142, '2015-02-01 00:49:41.000000', 'temperatura', 237.0000, 'ºC'),
	(333562, 142, '2015-02-01 00:49:42.000000', 'temperatura', 204.0000, 'ºC'),
	(333563, 142, '2015-02-01 00:49:43.000000', 'temperatura', 307.0000, 'ºC'),
	(333564, 142, '2015-02-01 00:49:44.000000', 'temperatura', 923.0000, 'ºC'),
	(333565, 142, '2015-02-01 00:49:45.000000', 'temperatura', 95.0000, 'ºC'),
	(333566, 142, '2015-02-01 00:49:46.000000', 'temperatura', 107.0000, 'ºC'),
	(333567, 142, '2015-02-01 00:49:47.000000', 'temperatura', 250.0000, 'ºC'),
	(333568, 142, '2015-02-01 00:49:48.000000', 'temperatura', 928.0000, 'ºC'),
	(333569, 142, '2015-02-01 00:49:49.000000', 'temperatura', 293.0000, 'ºC'),
	(333570, 142, '2015-02-01 00:49:50.000000', 'temperatura', 1081.0000, 'ºC'),
	(333571, 142, '2015-02-01 00:49:51.000000', 'temperatura', 925.0000, 'ºC'),
	(333572, 142, '2015-02-01 00:49:52.000000', 'temperatura', 183.0000, 'ºC'),
	(333573, 142, '2015-02-01 00:49:53.000000', 'temperatura', 540.0000, 'ºC'),
	(333574, 142, '2015-02-01 00:49:54.000000', 'temperatura', 951.0000, 'ºC'),
	(333575, 142, '2015-02-01 00:49:55.000000', 'temperatura', 736.0000, 'ºC'),
	(333576, 142, '2015-02-01 00:49:56.000000', 'temperatura', 830.0000, 'ºC'),
	(333577, 142, '2015-02-01 00:49:57.000000', 'temperatura', 739.0000, 'ºC'),
	(333578, 142, '2015-02-01 00:49:58.000000', 'temperatura', 8.0000, 'ºC'),
	(333579, 142, '2015-02-01 00:49:59.000000', 'temperatura', 222.0000, 'ºC'),
	(333580, 142, '2015-02-01 00:50:00.000000', 'temperatura', 1087.0000, 'ºC'),
	(333581, 142, '2015-02-01 00:50:01.000000', 'temperatura', 1170.0000, 'ºC'),
	(333582, 142, '2015-02-01 00:50:02.000000', 'temperatura', 188.0000, 'ºC'),
	(333583, 142, '2015-02-01 00:50:03.000000', 'temperatura', 1033.0000, 'ºC'),
	(333584, 142, '2015-02-01 00:50:04.000000', 'temperatura', 1001.0000, 'ºC'),
	(333585, 142, '2015-02-01 00:50:05.000000', 'temperatura', 706.0000, 'ºC'),
	(333586, 142, '2015-02-01 00:50:06.000000', 'temperatura', 530.0000, 'ºC'),
	(333587, 142, '2015-02-01 00:50:07.000000', 'temperatura', 529.0000, 'ºC'),
	(333588, 142, '2015-02-01 00:50:08.000000', 'temperatura', 1056.0000, 'ºC'),
	(333589, 142, '2015-02-01 00:50:09.000000', 'temperatura', 92.0000, 'ºC'),
	(333590, 142, '2015-02-01 00:50:10.000000', 'temperatura', 894.0000, 'ºC'),
	(333591, 142, '2015-02-01 00:50:11.000000', 'temperatura', 593.0000, 'ºC'),
	(333592, 142, '2015-02-01 00:50:12.000000', 'temperatura', 282.0000, 'ºC'),
	(333593, 142, '2015-02-01 00:50:13.000000', 'temperatura', 835.0000, 'ºC'),
	(333594, 142, '2015-02-01 00:50:14.000000', 'temperatura', 929.0000, 'ºC'),
	(333595, 142, '2015-02-01 00:50:15.000000', 'temperatura', 941.0000, 'ºC'),
	(333596, 142, '2015-02-01 00:50:16.000000', 'temperatura', 717.0000, 'ºC'),
	(333597, 142, '2015-02-01 00:50:17.000000', 'temperatura', 764.0000, 'ºC'),
	(333598, 142, '2015-02-01 00:50:18.000000', 'temperatura', 469.0000, 'ºC'),
	(333599, 142, '2015-02-01 00:50:19.000000', 'temperatura', 52.0000, 'ºC'),
	(333600, 142, '2015-02-01 00:50:20.000000', 'temperatura', 54.0000, 'ºC'),
	(333601, 142, '2015-02-01 00:50:21.000000', 'temperatura', 115.0000, 'ºC'),
	(333602, 142, '2015-02-01 00:50:22.000000', 'temperatura', 414.0000, 'ºC'),
	(333603, 142, '2015-02-01 00:50:23.000000', 'temperatura', 523.0000, 'ºC'),
	(333604, 142, '2015-02-01 00:50:24.000000', 'temperatura', 177.0000, 'ºC'),
	(333605, 142, '2015-02-01 00:50:25.000000', 'temperatura', 514.0000, 'ºC'),
	(333606, 142, '2015-02-01 00:50:26.000000', 'temperatura', 841.0000, 'ºC'),
	(333607, 142, '2015-02-01 00:50:27.000000', 'temperatura', 264.0000, 'ºC'),
	(333608, 142, '2015-02-01 00:50:28.000000', 'temperatura', 1196.0000, 'ºC'),
	(333609, 142, '2015-02-01 00:50:29.000000', 'temperatura', 390.0000, 'ºC'),
	(333610, 142, '2015-02-01 00:50:30.000000', 'temperatura', 762.0000, 'ºC'),
	(333611, 142, '2015-02-01 00:50:31.000000', 'temperatura', 241.0000, 'ºC'),
	(333612, 142, '2015-02-01 00:50:32.000000', 'temperatura', 120.0000, 'ºC'),
	(333613, 142, '2015-02-01 00:50:33.000000', 'temperatura', 1078.0000, 'ºC'),
	(333614, 142, '2015-02-01 00:50:34.000000', 'temperatura', 229.0000, 'ºC'),
	(333615, 142, '2015-02-01 00:50:35.000000', 'temperatura', 310.0000, 'ºC'),
	(333616, 142, '2015-02-01 00:50:36.000000', 'temperatura', 867.0000, 'ºC'),
	(333617, 142, '2015-02-01 00:50:37.000000', 'temperatura', 1002.0000, 'ºC'),
	(333618, 142, '2015-02-01 00:50:38.000000', 'temperatura', 11.0000, 'ºC'),
	(333619, 142, '2015-02-01 00:50:39.000000', 'temperatura', 650.0000, 'ºC'),
	(333620, 142, '2015-02-01 00:50:40.000000', 'temperatura', 818.0000, 'ºC'),
	(333621, 142, '2015-02-01 00:50:41.000000', 'temperatura', 941.0000, 'ºC'),
	(333622, 142, '2015-02-01 00:50:42.000000', 'temperatura', 1051.0000, 'ºC'),
	(333623, 142, '2015-02-01 00:50:43.000000', 'temperatura', 30.0000, 'ºC'),
	(333624, 142, '2015-02-01 00:50:44.000000', 'temperatura', 600.0000, 'ºC'),
	(333625, 142, '2015-02-01 00:50:45.000000', 'temperatura', 511.0000, 'ºC'),
	(333626, 142, '2015-02-01 00:50:46.000000', 'temperatura', 753.0000, 'ºC'),
	(333627, 142, '2015-02-01 00:50:47.000000', 'temperatura', 1036.0000, 'ºC'),
	(333628, 142, '2015-02-01 00:50:48.000000', 'temperatura', 519.0000, 'ºC'),
	(333629, 142, '2015-02-01 00:50:49.000000', 'temperatura', 687.0000, 'ºC'),
	(333630, 142, '2015-02-01 00:50:50.000000', 'temperatura', 680.0000, 'ºC'),
	(333631, 142, '2015-02-01 00:50:51.000000', 'temperatura', 141.0000, 'ºC'),
	(333632, 142, '2015-02-01 00:50:52.000000', 'temperatura', 1065.0000, 'ºC'),
	(333633, 142, '2015-02-01 00:50:53.000000', 'temperatura', 101.0000, 'ºC'),
	(333634, 142, '2015-02-01 00:50:54.000000', 'temperatura', 909.0000, 'ºC'),
	(333635, 142, '2015-02-01 00:50:55.000000', 'temperatura', 646.0000, 'ºC'),
	(333636, 142, '2015-02-01 00:50:56.000000', 'temperatura', 501.0000, 'ºC'),
	(333637, 142, '2015-02-01 00:50:57.000000', 'temperatura', 570.0000, 'ºC'),
	(333638, 142, '2015-02-01 00:50:58.000000', 'temperatura', 145.0000, 'ºC'),
	(333639, 142, '2015-02-01 00:50:59.000000', 'temperatura', 214.0000, 'ºC'),
	(333640, 142, '2015-02-01 00:51:00.000000', 'temperatura', 639.0000, 'ºC'),
	(333641, 142, '2015-02-01 00:51:01.000000', 'temperatura', 153.0000, 'ºC'),
	(333642, 142, '2015-02-01 00:51:02.000000', 'temperatura', 47.0000, 'ºC'),
	(333643, 142, '2015-02-01 00:51:03.000000', 'temperatura', 976.0000, 'ºC'),
	(333644, 142, '2015-02-01 00:51:04.000000', 'temperatura', 1141.0000, 'ºC'),
	(333645, 142, '2015-02-01 00:51:05.000000', 'temperatura', 377.0000, 'ºC'),
	(333646, 142, '2015-02-01 00:51:06.000000', 'temperatura', 862.0000, 'ºC'),
	(333647, 142, '2015-02-01 00:51:07.000000', 'temperatura', 778.0000, 'ºC'),
	(333648, 142, '2015-02-01 00:51:08.000000', 'temperatura', 107.0000, 'ºC'),
	(333649, 142, '2015-02-01 00:51:09.000000', 'temperatura', 599.0000, 'ºC'),
	(333650, 142, '2015-02-01 00:51:10.000000', 'temperatura', 277.0000, 'ºC'),
	(333651, 142, '2015-02-01 00:51:11.000000', 'temperatura', 789.0000, 'ºC'),
	(333652, 142, '2015-02-01 00:51:12.000000', 'temperatura', 712.0000, 'ºC'),
	(333653, 142, '2015-02-01 00:51:13.000000', 'temperatura', 1193.0000, 'ºC'),
	(333654, 142, '2015-02-01 00:51:14.000000', 'temperatura', 229.0000, 'ºC'),
	(333655, 142, '2015-02-01 00:51:15.000000', 'temperatura', 1168.0000, 'ºC'),
	(333656, 142, '2015-02-01 00:51:16.000000', 'temperatura', 353.0000, 'ºC'),
	(333657, 142, '2015-02-01 00:51:17.000000', 'temperatura', 661.0000, 'ºC'),
	(333658, 142, '2015-02-01 00:51:18.000000', 'temperatura', 1049.0000, 'ºC'),
	(333659, 142, '2015-02-01 00:51:19.000000', 'temperatura', 861.0000, 'ºC'),
	(333660, 142, '2015-02-01 00:51:20.000000', 'temperatura', 1157.0000, 'ºC'),
	(333661, 142, '2015-02-01 00:51:21.000000', 'temperatura', 805.0000, 'ºC'),
	(333662, 142, '2015-02-01 00:51:22.000000', 'temperatura', 555.0000, 'ºC'),
	(333663, 142, '2015-02-01 00:51:23.000000', 'temperatura', 361.0000, 'ºC'),
	(333664, 142, '2015-02-01 00:51:24.000000', 'temperatura', 139.0000, 'ºC'),
	(333665, 142, '2015-02-01 00:51:25.000000', 'temperatura', 811.0000, 'ºC'),
	(333666, 142, '2015-02-01 00:51:26.000000', 'temperatura', 38.0000, 'ºC'),
	(333667, 142, '2015-02-01 00:51:27.000000', 'temperatura', 161.0000, 'ºC'),
	(333668, 142, '2015-02-01 00:51:28.000000', 'temperatura', 688.0000, 'ºC'),
	(333669, 142, '2015-02-01 00:51:29.000000', 'temperatura', 559.0000, 'ºC'),
	(333670, 142, '2015-02-01 00:51:30.000000', 'temperatura', 733.0000, 'ºC'),
	(333671, 142, '2015-02-01 00:51:31.000000', 'temperatura', 787.0000, 'ºC'),
	(333672, 142, '2015-02-01 00:51:32.000000', 'temperatura', 537.0000, 'ºC'),
	(333673, 142, '2015-02-01 00:51:33.000000', 'temperatura', 323.0000, 'ºC'),
	(333674, 142, '2015-02-01 00:51:34.000000', 'temperatura', 5.0000, 'ºC'),
	(333675, 142, '2015-02-01 00:51:35.000000', 'temperatura', 258.0000, 'ºC'),
	(333676, 142, '2015-02-01 00:51:36.000000', 'temperatura', 73.0000, 'ºC'),
	(333677, 142, '2015-02-01 00:51:37.000000', 'temperatura', 791.0000, 'ºC'),
	(333678, 142, '2015-02-01 00:51:38.000000', 'temperatura', 138.0000, 'ºC'),
	(333679, 142, '2015-02-01 00:51:39.000000', 'temperatura', 718.0000, 'ºC'),
	(333680, 142, '2015-02-01 00:51:40.000000', 'temperatura', 778.0000, 'ºC'),
	(333681, 142, '2015-02-01 00:51:41.000000', 'temperatura', 535.0000, 'ºC'),
	(333682, 142, '2015-02-01 00:51:42.000000', 'temperatura', 340.0000, 'ºC'),
	(333683, 142, '2015-02-01 00:51:43.000000', 'temperatura', 96.0000, 'ºC'),
	(333684, 142, '2015-02-01 00:51:44.000000', 'temperatura', 659.0000, 'ºC'),
	(333685, 142, '2015-02-01 00:51:45.000000', 'temperatura', 608.0000, 'ºC'),
	(333686, 142, '2015-02-01 00:51:46.000000', 'temperatura', 1065.0000, 'ºC'),
	(333687, 142, '2015-02-01 00:51:47.000000', 'temperatura', 1103.0000, 'ºC'),
	(333688, 142, '2015-02-01 00:51:48.000000', 'temperatura', 1118.0000, 'ºC'),
	(333689, 142, '2015-02-01 00:51:49.000000', 'temperatura', 1080.0000, 'ºC'),
	(333690, 142, '2015-02-01 00:51:50.000000', 'temperatura', 849.0000, 'ºC'),
	(333691, 142, '2015-02-01 00:51:51.000000', 'temperatura', 1007.0000, 'ºC'),
	(333692, 142, '2015-02-01 00:51:52.000000', 'temperatura', 85.0000, 'ºC'),
	(333693, 142, '2015-02-01 00:51:53.000000', 'temperatura', 1005.0000, 'ºC'),
	(333694, 142, '2015-02-01 00:51:54.000000', 'temperatura', 1173.0000, 'ºC'),
	(333695, 142, '2015-02-01 00:51:55.000000', 'temperatura', 448.0000, 'ºC'),
	(333696, 142, '2015-02-01 00:51:56.000000', 'temperatura', 1120.0000, 'ºC'),
	(333697, 142, '2015-02-01 00:51:57.000000', 'temperatura', 659.0000, 'ºC'),
	(333698, 142, '2015-02-01 00:51:58.000000', 'temperatura', 1136.0000, 'ºC'),
	(333699, 142, '2015-02-01 00:51:59.000000', 'temperatura', 103.0000, 'ºC'),
	(333700, 142, '2015-02-01 00:52:00.000000', 'temperatura', 706.0000, 'ºC'),
	(333701, 142, '2015-02-01 00:52:01.000000', 'temperatura', 824.0000, 'ºC'),
	(333702, 142, '2015-02-01 00:52:02.000000', 'temperatura', 800.0000, 'ºC'),
	(333703, 142, '2015-02-01 00:52:03.000000', 'temperatura', 328.0000, 'ºC'),
	(333704, 142, '2015-02-01 00:52:04.000000', 'temperatura', 440.0000, 'ºC'),
	(333705, 142, '2015-02-01 00:52:05.000000', 'temperatura', 17.0000, 'ºC'),
	(333706, 142, '2015-02-01 00:52:06.000000', 'temperatura', 1167.0000, 'ºC'),
	(333707, 142, '2015-02-01 00:52:07.000000', 'temperatura', 984.0000, 'ºC'),
	(333708, 142, '2015-02-01 00:52:08.000000', 'temperatura', 220.0000, 'ºC'),
	(333709, 142, '2015-02-01 00:52:09.000000', 'temperatura', 547.0000, 'ºC'),
	(333710, 142, '2015-02-01 00:52:10.000000', 'temperatura', 874.0000, 'ºC'),
	(333711, 142, '2015-02-01 00:52:11.000000', 'temperatura', 332.0000, 'ºC'),
	(333712, 142, '2015-02-01 00:52:12.000000', 'temperatura', 237.0000, 'ºC'),
	(333713, 142, '2015-02-01 00:52:13.000000', 'temperatura', 190.0000, 'ºC'),
	(333714, 142, '2015-02-01 00:52:14.000000', 'temperatura', 240.0000, 'ºC'),
	(333715, 142, '2015-02-01 00:52:15.000000', 'temperatura', 628.0000, 'ºC'),
	(333716, 142, '2015-02-01 00:52:16.000000', 'temperatura', 23.0000, 'ºC'),
	(333717, 142, '2015-02-01 00:52:17.000000', 'temperatura', 630.0000, 'ºC'),
	(333718, 142, '2015-02-01 00:52:18.000000', 'temperatura', 684.0000, 'ºC'),
	(333719, 142, '2015-02-01 00:52:19.000000', 'temperatura', 330.0000, 'ºC'),
	(333720, 142, '2015-02-01 00:52:20.000000', 'temperatura', 796.0000, 'ºC'),
	(333721, 142, '2015-02-01 00:52:21.000000', 'temperatura', 594.0000, 'ºC'),
	(333722, 142, '2015-02-01 00:52:22.000000', 'temperatura', 579.0000, 'ºC'),
	(333723, 142, '2015-02-01 00:52:23.000000', 'temperatura', 1116.0000, 'ºC'),
	(333724, 142, '2015-02-01 00:52:24.000000', 'temperatura', 242.0000, 'ºC'),
	(333725, 142, '2015-02-01 00:52:25.000000', 'temperatura', 264.0000, 'ºC'),
	(333726, 142, '2015-02-01 00:52:26.000000', 'temperatura', 595.0000, 'ºC'),
	(333727, 142, '2015-02-01 00:52:27.000000', 'temperatura', 981.0000, 'ºC'),
	(333728, 142, '2015-02-01 00:52:28.000000', 'temperatura', 721.0000, 'ºC'),
	(333729, 142, '2015-02-01 00:52:29.000000', 'temperatura', 663.0000, 'ºC'),
	(333730, 142, '2015-02-01 00:52:30.000000', 'temperatura', 1151.0000, 'ºC'),
	(333731, 142, '2015-02-01 00:52:31.000000', 'temperatura', 167.0000, 'ºC'),
	(333732, 142, '2015-02-01 00:52:32.000000', 'temperatura', 983.0000, 'ºC'),
	(333733, 142, '2015-02-01 00:52:33.000000', 'temperatura', 812.0000, 'ºC'),
	(333734, 142, '2015-02-01 00:52:34.000000', 'temperatura', 1114.0000, 'ºC'),
	(333735, 142, '2015-02-01 00:52:35.000000', 'temperatura', 736.0000, 'ºC'),
	(333736, 142, '2015-02-01 00:52:36.000000', 'temperatura', 336.0000, 'ºC'),
	(333737, 142, '2015-02-01 00:52:37.000000', 'temperatura', 671.0000, 'ºC'),
	(333738, 142, '2015-02-01 00:52:38.000000', 'temperatura', 1150.0000, 'ºC'),
	(333739, 142, '2015-02-01 00:52:39.000000', 'temperatura', 136.0000, 'ºC'),
	(333740, 142, '2015-02-01 00:52:40.000000', 'temperatura', 832.0000, 'ºC'),
	(333741, 142, '2015-02-01 00:52:41.000000', 'temperatura', 150.0000, 'ºC'),
	(333742, 142, '2015-02-01 00:52:42.000000', 'temperatura', 658.0000, 'ºC'),
	(333743, 142, '2015-02-01 00:52:43.000000', 'temperatura', 437.0000, 'ºC'),
	(333744, 142, '2015-02-01 00:52:44.000000', 'temperatura', 212.0000, 'ºC'),
	(333745, 142, '2015-02-01 00:52:45.000000', 'temperatura', 951.0000, 'ºC'),
	(333746, 142, '2015-02-01 00:52:46.000000', 'temperatura', 519.0000, 'ºC'),
	(333747, 142, '2015-02-01 00:52:47.000000', 'temperatura', 940.0000, 'ºC'),
	(333748, 142, '2015-02-01 00:52:48.000000', 'temperatura', 747.0000, 'ºC'),
	(333749, 142, '2015-02-01 00:52:49.000000', 'temperatura', 913.0000, 'ºC'),
	(333750, 142, '2015-02-01 00:52:50.000000', 'temperatura', 1125.0000, 'ºC'),
	(333751, 142, '2015-02-01 00:52:51.000000', 'temperatura', 487.0000, 'ºC'),
	(333752, 142, '2015-02-01 00:52:52.000000', 'temperatura', 261.0000, 'ºC'),
	(333753, 142, '2015-02-01 00:52:53.000000', 'temperatura', 1046.0000, 'ºC'),
	(333754, 142, '2015-02-01 00:52:54.000000', 'temperatura', 845.0000, 'ºC'),
	(333755, 142, '2015-02-01 00:52:55.000000', 'temperatura', 1089.0000, 'ºC'),
	(333756, 142, '2015-02-01 00:52:56.000000', 'temperatura', 509.0000, 'ºC'),
	(333757, 142, '2015-02-01 00:52:57.000000', 'temperatura', 479.0000, 'ºC'),
	(333758, 142, '2015-02-01 00:52:58.000000', 'temperatura', 868.0000, 'ºC'),
	(333759, 142, '2015-02-01 00:52:59.000000', 'temperatura', 503.0000, 'ºC'),
	(333760, 142, '2015-02-01 00:53:00.000000', 'temperatura', 1111.0000, 'ºC'),
	(333761, 142, '2015-02-01 00:53:01.000000', 'temperatura', 447.0000, 'ºC'),
	(333762, 142, '2015-02-01 00:53:02.000000', 'temperatura', 102.0000, 'ºC'),
	(333763, 142, '2015-02-01 00:53:03.000000', 'temperatura', 369.0000, 'ºC'),
	(333764, 142, '2015-02-01 00:53:04.000000', 'temperatura', 340.0000, 'ºC'),
	(333765, 142, '2015-02-01 00:53:05.000000', 'temperatura', 595.0000, 'ºC'),
	(333766, 142, '2015-02-01 00:53:06.000000', 'temperatura', 754.0000, 'ºC'),
	(333767, 142, '2015-02-01 00:53:07.000000', 'temperatura', 786.0000, 'ºC'),
	(333768, 142, '2015-02-01 00:53:08.000000', 'temperatura', 467.0000, 'ºC'),
	(333769, 142, '2015-02-01 00:53:09.000000', 'temperatura', 1180.0000, 'ºC'),
	(333770, 142, '2015-02-01 00:53:10.000000', 'temperatura', 897.0000, 'ºC'),
	(333771, 142, '2015-02-01 00:53:11.000000', 'temperatura', 945.0000, 'ºC'),
	(333772, 142, '2015-02-01 00:53:12.000000', 'temperatura', 837.0000, 'ºC'),
	(333773, 142, '2015-02-01 00:53:13.000000', 'temperatura', 151.0000, 'ºC'),
	(333774, 142, '2015-02-01 00:53:14.000000', 'temperatura', 642.0000, 'ºC'),
	(333775, 142, '2015-02-01 00:53:15.000000', 'temperatura', 359.0000, 'ºC'),
	(333776, 142, '2015-02-01 00:53:16.000000', 'temperatura', 1068.0000, 'ºC'),
	(333777, 142, '2015-02-01 00:53:17.000000', 'temperatura', 665.0000, 'ºC'),
	(333778, 142, '2015-02-01 00:53:18.000000', 'temperatura', 122.0000, 'ºC'),
	(333779, 142, '2015-02-01 00:53:19.000000', 'temperatura', 1013.0000, 'ºC'),
	(333780, 142, '2015-02-01 00:53:20.000000', 'temperatura', 1100.0000, 'ºC'),
	(333781, 142, '2015-02-01 00:53:21.000000', 'temperatura', 62.0000, 'ºC'),
	(333782, 142, '2015-02-01 00:53:22.000000', 'temperatura', 611.0000, 'ºC'),
	(333783, 142, '2015-02-01 00:53:23.000000', 'temperatura', 470.0000, 'ºC'),
	(333784, 142, '2015-02-01 00:53:24.000000', 'temperatura', 517.0000, 'ºC'),
	(333785, 142, '2015-02-01 00:53:25.000000', 'temperatura', 1174.0000, 'ºC'),
	(333786, 142, '2015-02-01 00:53:26.000000', 'temperatura', 719.0000, 'ºC'),
	(333787, 142, '2015-02-01 00:53:27.000000', 'temperatura', 76.0000, 'ºC'),
	(333788, 142, '2015-02-01 00:53:28.000000', 'temperatura', 621.0000, 'ºC'),
	(333789, 142, '2015-02-01 00:53:29.000000', 'temperatura', 478.0000, 'ºC'),
	(333790, 142, '2015-02-01 00:53:30.000000', 'temperatura', 529.0000, 'ºC'),
	(333791, 142, '2015-02-01 00:53:31.000000', 'temperatura', 10.0000, 'ºC'),
	(333792, 142, '2015-02-01 00:53:32.000000', 'temperatura', 863.0000, 'ºC'),
	(333793, 142, '2015-02-01 00:53:33.000000', 'temperatura', 685.0000, 'ºC'),
	(333794, 142, '2015-02-01 00:53:34.000000', 'temperatura', 837.0000, 'ºC'),
	(333795, 142, '2015-02-01 00:53:35.000000', 'temperatura', 930.0000, 'ºC'),
	(333796, 142, '2015-02-01 00:53:36.000000', 'temperatura', 938.0000, 'ºC'),
	(333797, 142, '2015-02-01 00:53:37.000000', 'temperatura', 702.0000, 'ºC'),
	(333798, 142, '2015-02-01 00:53:38.000000', 'temperatura', 695.0000, 'ºC'),
	(333799, 142, '2015-02-01 00:53:39.000000', 'temperatura', 171.0000, 'ºC'),
	(333800, 142, '2015-02-01 00:53:40.000000', 'temperatura', 1171.0000, 'ºC'),
	(333801, 142, '2015-02-01 00:53:41.000000', 'temperatura', 540.0000, 'ºC'),
	(333802, 142, '2015-02-01 00:53:42.000000', 'temperatura', 390.0000, 'ºC'),
	(333803, 142, '2015-02-01 00:53:43.000000', 'temperatura', 331.0000, 'ºC'),
	(333804, 142, '2015-02-01 00:53:44.000000', 'temperatura', 483.0000, 'ºC'),
	(333805, 142, '2015-02-01 00:53:45.000000', 'temperatura', 225.0000, 'ºC'),
	(333806, 142, '2015-02-01 00:53:46.000000', 'temperatura', 876.0000, 'ºC'),
	(333807, 142, '2015-02-01 00:53:47.000000', 'temperatura', 104.0000, 'ºC'),
	(333808, 142, '2015-02-01 00:53:48.000000', 'temperatura', 293.0000, 'ºC'),
	(333809, 142, '2015-02-01 00:53:49.000000', 'temperatura', 1152.0000, 'ºC'),
	(333810, 142, '2015-02-01 00:53:50.000000', 'temperatura', 82.0000, 'ºC'),
	(333811, 142, '2015-02-01 00:53:51.000000', 'temperatura', 557.0000, 'ºC'),
	(333812, 142, '2015-02-01 00:53:52.000000', 'temperatura', 138.0000, 'ºC'),
	(333813, 142, '2015-02-01 00:53:53.000000', 'temperatura', 218.0000, 'ºC'),
	(333814, 142, '2015-02-01 00:53:54.000000', 'temperatura', 679.0000, 'ºC'),
	(333815, 142, '2015-02-01 00:53:55.000000', 'temperatura', 340.0000, 'ºC'),
	(333816, 142, '2015-02-01 00:53:56.000000', 'temperatura', 864.0000, 'ºC'),
	(333817, 142, '2015-02-01 00:53:57.000000', 'temperatura', 900.0000, 'ºC'),
	(333818, 142, '2015-02-01 00:53:58.000000', 'temperatura', 709.0000, 'ºC'),
	(333819, 142, '2015-02-01 00:53:59.000000', 'temperatura', 845.0000, 'ºC'),
	(333820, 142, '2015-02-01 00:54:00.000000', 'temperatura', 900.0000, 'ºC'),
	(333821, 142, '2015-02-01 00:54:01.000000', 'temperatura', 764.0000, 'ºC'),
	(333822, 142, '2015-02-01 00:54:02.000000', 'temperatura', 1123.0000, 'ºC'),
	(333823, 142, '2015-02-01 00:54:03.000000', 'temperatura', 921.0000, 'ºC'),
	(333824, 142, '2015-02-01 00:54:04.000000', 'temperatura', 38.0000, 'ºC'),
	(333825, 142, '2015-02-01 00:54:05.000000', 'temperatura', 1026.0000, 'ºC'),
	(333826, 142, '2015-02-01 00:54:06.000000', 'temperatura', 217.0000, 'ºC'),
	(333827, 142, '2015-02-01 00:54:07.000000', 'temperatura', 410.0000, 'ºC'),
	(333828, 142, '2015-02-01 00:54:08.000000', 'temperatura', 197.0000, 'ºC'),
	(333829, 142, '2015-02-01 00:54:09.000000', 'temperatura', 955.0000, 'ºC'),
	(333830, 142, '2015-02-01 00:54:10.000000', 'temperatura', 587.0000, 'ºC'),
	(333831, 142, '2015-02-01 00:54:11.000000', 'temperatura', 68.0000, 'ºC'),
	(333832, 142, '2015-02-01 00:54:12.000000', 'temperatura', 981.0000, 'ºC'),
	(333833, 142, '2015-02-01 00:54:13.000000', 'temperatura', 1099.0000, 'ºC'),
	(333834, 142, '2015-02-01 00:54:14.000000', 'temperatura', 155.0000, 'ºC'),
	(333835, 142, '2015-02-01 00:54:15.000000', 'temperatura', 1079.0000, 'ºC'),
	(333836, 142, '2015-02-01 00:54:16.000000', 'temperatura', 128.0000, 'ºC'),
	(333837, 142, '2015-02-01 00:54:17.000000', 'temperatura', 1005.0000, 'ºC'),
	(333838, 142, '2015-02-01 00:54:18.000000', 'temperatura', 1041.0000, 'ºC'),
	(333839, 142, '2015-02-01 00:54:19.000000', 'temperatura', 993.0000, 'ºC'),
	(333840, 142, '2015-02-01 00:54:20.000000', 'temperatura', 639.0000, 'ºC'),
	(333841, 142, '2015-02-01 00:54:21.000000', 'temperatura', 220.0000, 'ºC'),
	(333842, 142, '2015-02-01 00:54:22.000000', 'temperatura', 381.0000, 'ºC'),
	(333843, 142, '2015-02-01 00:54:23.000000', 'temperatura', 45.0000, 'ºC'),
	(333844, 142, '2015-02-01 00:54:24.000000', 'temperatura', 284.0000, 'ºC'),
	(333845, 142, '2015-02-01 00:54:25.000000', 'temperatura', 83.0000, 'ºC'),
	(333846, 142, '2015-02-01 00:54:26.000000', 'temperatura', 765.0000, 'ºC'),
	(333847, 142, '2015-02-01 00:54:27.000000', 'temperatura', 1174.0000, 'ºC'),
	(333848, 142, '2015-02-01 00:54:28.000000', 'temperatura', 1179.0000, 'ºC'),
	(333849, 142, '2015-02-01 00:54:29.000000', 'temperatura', 1174.0000, 'ºC'),
	(333850, 142, '2015-02-01 00:54:30.000000', 'temperatura', 1131.0000, 'ºC'),
	(333851, 142, '2015-02-01 00:54:31.000000', 'temperatura', 932.0000, 'ºC'),
	(333852, 142, '2015-02-01 00:54:32.000000', 'temperatura', 70.0000, 'ºC'),
	(333853, 142, '2015-02-01 00:54:33.000000', 'temperatura', 1155.0000, 'ºC'),
	(333854, 142, '2015-02-01 00:54:34.000000', 'temperatura', 766.0000, 'ºC'),
	(333855, 142, '2015-02-01 00:54:35.000000', 'temperatura', 366.0000, 'ºC'),
	(333856, 142, '2015-02-01 00:54:36.000000', 'temperatura', 730.0000, 'ºC'),
	(333857, 142, '2015-02-01 00:54:37.000000', 'temperatura', 155.0000, 'ºC'),
	(333858, 142, '2015-02-01 00:54:38.000000', 'temperatura', 984.0000, 'ºC'),
	(333859, 142, '2015-02-01 00:54:39.000000', 'temperatura', 854.0000, 'ºC'),
	(333860, 142, '2015-02-01 00:54:40.000000', 'temperatura', 121.0000, 'ºC'),
	(333861, 142, '2015-02-01 00:54:41.000000', 'temperatura', 444.0000, 'ºC'),
	(333862, 142, '2015-02-01 00:54:42.000000', 'temperatura', 655.0000, 'ºC'),
	(333863, 142, '2015-02-01 00:54:43.000000', 'temperatura', 743.0000, 'ºC'),
	(333864, 142, '2015-02-01 00:54:44.000000', 'temperatura', 553.0000, 'ºC'),
	(333865, 142, '2015-02-01 00:54:45.000000', 'temperatura', 534.0000, 'ºC'),
	(333866, 142, '2015-02-01 00:54:46.000000', 'temperatura', 1011.0000, 'ºC'),
	(333867, 142, '2015-02-01 00:54:47.000000', 'temperatura', 1054.0000, 'ºC'),
	(333868, 142, '2015-02-01 00:54:48.000000', 'temperatura', 1037.0000, 'ºC'),
	(333869, 142, '2015-02-01 00:54:49.000000', 'temperatura', 823.0000, 'ºC'),
	(333870, 142, '2015-02-01 00:54:50.000000', 'temperatura', 1007.0000, 'ºC'),
	(333871, 142, '2015-02-01 00:54:51.000000', 'temperatura', 164.0000, 'ºC'),
	(333872, 142, '2015-02-01 00:54:52.000000', 'temperatura', 202.0000, 'ºC'),
	(333873, 142, '2015-02-01 00:54:53.000000', 'temperatura', 517.0000, 'ºC'),
	(333874, 142, '2015-02-01 00:54:54.000000', 'temperatura', 780.0000, 'ºC'),
	(333875, 142, '2015-02-01 00:54:55.000000', 'temperatura', 1148.0000, 'ºC'),
	(333876, 142, '2015-02-01 00:54:56.000000', 'temperatura', 1003.0000, 'ºC'),
	(333877, 142, '2015-02-01 00:54:57.000000', 'temperatura', 371.0000, 'ºC'),
	(333878, 142, '2015-02-01 00:54:58.000000', 'temperatura', 47.0000, 'ºC'),
	(333879, 142, '2015-02-01 00:54:59.000000', 'temperatura', 321.0000, 'ºC'),
	(333880, 142, '2015-02-01 00:55:00.000000', 'temperatura', 264.0000, 'ºC'),
	(333881, 142, '2015-02-01 00:55:01.000000', 'temperatura', 359.0000, 'ºC'),
	(333882, 142, '2015-02-01 00:55:02.000000', 'temperatura', 1005.0000, 'ºC'),
	(333883, 142, '2015-02-01 00:55:03.000000', 'temperatura', 347.0000, 'ºC'),
	(333884, 142, '2015-02-01 00:55:04.000000', 'temperatura', 1120.0000, 'ºC'),
	(333885, 142, '2015-02-01 00:55:05.000000', 'temperatura', 960.0000, 'ºC'),
	(333886, 142, '2015-02-01 00:55:06.000000', 'temperatura', 242.0000, 'ºC'),
	(333887, 142, '2015-02-01 00:55:07.000000', 'temperatura', 729.0000, 'ºC'),
	(333888, 142, '2015-02-01 00:55:08.000000', 'temperatura', 519.0000, 'ºC'),
	(333889, 142, '2015-02-01 00:55:09.000000', 'temperatura', 410.0000, 'ºC'),
	(333890, 142, '2015-02-01 00:55:10.000000', 'temperatura', 494.0000, 'ºC'),
	(333891, 142, '2015-02-01 00:55:11.000000', 'temperatura', 41.0000, 'ºC'),
	(333892, 142, '2015-02-01 00:55:12.000000', 'temperatura', 1121.0000, 'ºC'),
	(333893, 142, '2015-02-01 00:55:13.000000', 'temperatura', 683.0000, 'ºC'),
	(333894, 142, '2015-02-01 00:55:14.000000', 'temperatura', 53.0000, 'ºC'),
	(333895, 142, '2015-02-01 00:55:15.000000', 'temperatura', 617.0000, 'ºC'),
	(333896, 142, '2015-02-01 00:55:16.000000', 'temperatura', 526.0000, 'ºC'),
	(333897, 142, '2015-02-01 00:55:17.000000', 'temperatura', 780.0000, 'ºC'),
	(333898, 142, '2015-02-01 00:55:18.000000', 'temperatura', 1122.0000, 'ºC'),
	(333899, 142, '2015-02-01 00:55:19.000000', 'temperatura', 872.0000, 'ºC'),
	(333900, 142, '2015-02-01 00:55:20.000000', 'temperatura', 992.0000, 'ºC'),
	(333901, 142, '2015-02-01 00:55:21.000000', 'temperatura', 1146.0000, 'ºC'),
	(333902, 142, '2015-02-01 00:55:22.000000', 'temperatura', 354.0000, 'ºC'),
	(333903, 142, '2015-02-01 00:55:23.000000', 'temperatura', 733.0000, 'ºC'),
	(333904, 142, '2015-02-01 00:55:24.000000', 'temperatura', 205.0000, 'ºC'),
	(333905, 142, '2015-02-01 00:55:25.000000', 'temperatura', 27.0000, 'ºC'),
	(333906, 142, '2015-02-01 00:55:26.000000', 'temperatura', 718.0000, 'ºC'),
	(333907, 142, '2015-02-01 00:55:27.000000', 'temperatura', 1109.0000, 'ºC'),
	(333908, 142, '2015-02-01 00:55:28.000000', 'temperatura', 993.0000, 'ºC'),
	(333909, 142, '2015-02-01 00:55:29.000000', 'temperatura', 440.0000, 'ºC'),
	(333910, 142, '2015-02-01 00:55:30.000000', 'temperatura', 421.0000, 'ºC'),
	(333911, 142, '2015-02-01 00:55:31.000000', 'temperatura', 786.0000, 'ºC'),
	(333912, 142, '2015-02-01 00:55:32.000000', 'temperatura', 267.0000, 'ºC'),
	(333913, 142, '2015-02-01 00:55:33.000000', 'temperatura', 179.0000, 'ºC'),
	(333914, 142, '2015-02-01 00:55:34.000000', 'temperatura', 94.0000, 'ºC'),
	(333915, 142, '2015-02-01 00:55:35.000000', 'temperatura', 1132.0000, 'ºC'),
	(333916, 142, '2015-02-01 00:55:36.000000', 'temperatura', 579.0000, 'ºC'),
	(333917, 142, '2015-02-01 00:55:37.000000', 'temperatura', 701.0000, 'ºC'),
	(333918, 142, '2015-02-01 00:55:38.000000', 'temperatura', 569.0000, 'ºC'),
	(333919, 142, '2015-02-01 00:55:39.000000', 'temperatura', 742.0000, 'ºC'),
	(333920, 142, '2015-02-01 00:55:40.000000', 'temperatura', 803.0000, 'ºC'),
	(333921, 142, '2015-02-01 00:55:41.000000', 'temperatura', 591.0000, 'ºC'),
	(333922, 142, '2015-02-01 00:55:42.000000', 'temperatura', 546.0000, 'ºC'),
	(333923, 142, '2015-02-01 00:55:43.000000', 'temperatura', 956.0000, 'ºC'),
	(333924, 142, '2015-02-01 00:55:44.000000', 'temperatura', 742.0000, 'ºC'),
	(333925, 142, '2015-02-01 00:55:45.000000', 'temperatura', 844.0000, 'ºC'),
	(333926, 142, '2015-02-01 00:55:46.000000', 'temperatura', 796.0000, 'ºC'),
	(333927, 142, '2015-02-01 00:55:47.000000', 'temperatura', 248.0000, 'ºC'),
	(333928, 142, '2015-02-01 00:55:48.000000', 'temperatura', 52.0000, 'ºC'),
	(333929, 142, '2015-02-01 00:55:49.000000', 'temperatura', 714.0000, 'ºC'),
	(333930, 142, '2015-02-01 00:55:50.000000', 'temperatura', 1018.0000, 'ºC'),
	(333931, 142, '2015-02-01 00:55:51.000000', 'temperatura', 546.0000, 'ºC'),
	(333932, 142, '2015-02-01 00:55:52.000000', 'temperatura', 875.0000, 'ºC'),
	(333933, 142, '2015-02-01 00:55:53.000000', 'temperatura', 340.0000, 'ºC'),
	(333934, 142, '2015-02-01 00:55:54.000000', 'temperatura', 276.0000, 'ºC'),
	(333935, 142, '2015-02-01 00:55:55.000000', 'temperatura', 359.0000, 'ºC'),
	(333936, 142, '2015-02-01 00:55:56.000000', 'temperatura', 967.0000, 'ºC'),
	(333937, 142, '2015-02-01 00:55:57.000000', 'temperatura', 160.0000, 'ºC'),
	(333938, 142, '2015-02-01 00:55:58.000000', 'temperatura', 299.0000, 'ºC'),
	(333939, 142, '2015-02-01 00:55:59.000000', 'temperatura', 1014.0000, 'ºC'),
	(333940, 142, '2015-02-01 00:56:00.000000', 'temperatura', 573.0000, 'ºC'),
	(333941, 142, '2015-02-01 00:56:01.000000', 'temperatura', 1025.0000, 'ºC'),
	(333942, 142, '2015-02-01 00:56:02.000000', 'temperatura', 1006.0000, 'ºC'),
	(333943, 142, '2015-02-01 00:56:03.000000', 'temperatura', 757.0000, 'ºC'),
	(333944, 142, '2015-02-01 00:56:04.000000', 'temperatura', 767.0000, 'ºC'),
	(333945, 142, '2015-02-01 00:56:05.000000', 'temperatura', 363.0000, 'ºC'),
	(333946, 142, '2015-02-01 00:56:06.000000', 'temperatura', 713.0000, 'ºC'),
	(333947, 142, '2015-02-01 00:56:07.000000', 'temperatura', 79.0000, 'ºC'),
	(333948, 142, '2015-02-01 00:56:08.000000', 'temperatura', 657.0000, 'ºC'),
	(333949, 142, '2015-02-01 00:56:09.000000', 'temperatura', 648.0000, 'ºC'),
	(333950, 142, '2015-02-01 00:56:10.000000', 'temperatura', 71.0000, 'ºC'),
	(333951, 142, '2015-02-01 00:56:11.000000', 'temperatura', 811.0000, 'ºC'),
	(333952, 142, '2015-02-01 00:56:12.000000', 'temperatura', 241.0000, 'ºC'),
	(333953, 142, '2015-02-01 00:56:13.000000', 'temperatura', 1173.0000, 'ºC'),
	(333954, 142, '2015-02-01 00:56:14.000000', 'temperatura', 342.0000, 'ºC'),
	(333955, 142, '2015-02-01 00:56:15.000000', 'temperatura', 591.0000, 'ºC'),
	(333956, 142, '2015-02-01 00:56:16.000000', 'temperatura', 730.0000, 'ºC'),
	(333957, 142, '2015-02-01 00:56:17.000000', 'temperatura', 676.0000, 'ºC'),
	(333958, 142, '2015-02-01 00:56:18.000000', 'temperatura', 1190.0000, 'ºC'),
	(333959, 142, '2015-02-01 00:56:19.000000', 'temperatura', 324.0000, 'ºC'),
	(333960, 142, '2015-02-01 00:56:20.000000', 'temperatura', 448.0000, 'ºC'),
	(333961, 142, '2015-02-01 00:56:21.000000', 'temperatura', 71.0000, 'ºC'),
	(333962, 142, '2015-02-01 00:56:22.000000', 'temperatura', 212.0000, 'ºC'),
	(333963, 142, '2015-02-01 00:56:23.000000', 'temperatura', 846.0000, 'ºC'),
	(333964, 142, '2015-02-01 00:56:24.000000', 'temperatura', 1195.0000, 'ºC'),
	(333965, 142, '2015-02-01 00:56:25.000000', 'temperatura', 1039.0000, 'ºC'),
	(333966, 142, '2015-02-01 00:56:26.000000', 'temperatura', 410.0000, 'ºC'),
	(333967, 142, '2015-02-01 00:56:27.000000', 'temperatura', 133.0000, 'ºC'),
	(333968, 142, '2015-02-01 00:56:28.000000', 'temperatura', 634.0000, 'ºC'),
	(333969, 142, '2015-02-01 00:56:29.000000', 'temperatura', 375.0000, 'ºC'),
	(333970, 142, '2015-02-01 00:56:30.000000', 'temperatura', 1170.0000, 'ºC'),
	(333971, 142, '2015-02-01 00:56:31.000000', 'temperatura', 1127.0000, 'ºC'),
	(333972, 142, '2015-02-01 00:56:32.000000', 'temperatura', 925.0000, 'ºC'),
	(333973, 142, '2015-02-01 00:56:33.000000', 'temperatura', 43.0000, 'ºC'),
	(333974, 142, '2015-02-01 00:56:34.000000', 'temperatura', 1041.0000, 'ºC'),
	(333975, 142, '2015-02-01 00:56:35.000000', 'temperatura', 278.0000, 'ºC'),
	(333976, 142, '2015-02-01 00:56:36.000000', 'temperatura', 669.0000, 'ºC'),
	(333977, 142, '2015-02-01 00:56:37.000000', 'temperatura', 109.0000, 'ºC'),
	(333978, 142, '2015-02-01 00:56:38.000000', 'temperatura', 937.0000, 'ºC'),
	(333979, 142, '2015-02-01 00:56:39.000000', 'temperatura', 760.0000, 'ºC'),
	(333980, 142, '2015-02-01 00:56:40.000000', 'temperatura', 991.0000, 'ºC'),
	(333981, 142, '2015-02-01 00:56:41.000000', 'temperatura', 274.0000, 'ºC'),
	(333982, 142, '2015-02-01 00:56:42.000000', 'temperatura', 800.0000, 'ºC'),
	(333983, 142, '2015-02-01 00:56:43.000000', 'temperatura', 776.0000, 'ºC'),
	(333984, 142, '2015-02-01 00:56:44.000000', 'temperatura', 281.0000, 'ºC'),
	(333985, 142, '2015-02-01 00:56:45.000000', 'temperatura', 280.0000, 'ºC'),
	(333986, 142, '2015-02-01 00:56:46.000000', 'temperatura', 555.0000, 'ºC'),
	(333987, 142, '2015-02-01 00:56:47.000000', 'temperatura', 736.0000, 'ºC'),
	(333988, 142, '2015-02-01 00:56:48.000000', 'temperatura', 814.0000, 'ºC'),
	(333989, 142, '2015-02-01 00:56:49.000000', 'temperatura', 663.0000, 'ºC'),
	(333990, 142, '2015-02-01 00:56:50.000000', 'temperatura', 875.0000, 'ºC'),
	(333991, 142, '2015-02-01 00:56:51.000000', 'temperatura', 1185.0000, 'ºC'),
	(333992, 142, '2015-02-01 00:56:52.000000', 'temperatura', 901.0000, 'ºC'),
	(333993, 142, '2015-02-01 00:56:53.000000', 'temperatura', 952.0000, 'ºC'),
	(333994, 142, '2015-02-01 00:56:54.000000', 'temperatura', 856.0000, 'ºC'),
	(333995, 142, '2015-02-01 00:56:55.000000', 'temperatura', 223.0000, 'ºC'),
	(333996, 142, '2015-02-01 00:56:56.000000', 'temperatura', 951.0000, 'ºC'),
	(333997, 143, '2015-02-01 00:00:00.000000', 'temperatura', 768.0000, 'ºC'),
	(333998, 143, '2015-02-01 00:00:01.000000', 'temperatura', 1188.0000, 'ºC'),
	(333999, 143, '2015-02-01 00:00:02.000000', 'temperatura', 35.0000, 'ºC'),
	(334000, 143, '2015-02-01 00:00:03.000000', 'temperatura', 214.0000, 'ºC'),
	(334001, 143, '2015-02-01 00:00:04.000000', 'temperatura', 965.0000, 'ºC'),
	(334002, 143, '2015-02-01 00:00:05.000000', 'temperatura', 583.0000, 'ºC'),
	(334003, 143, '2015-02-01 00:00:06.000000', 'temperatura', 19.0000, 'ºC'),
	(334004, 143, '2015-02-01 00:00:07.000000', 'temperatura', 747.0000, 'ºC'),
	(334005, 143, '2015-02-01 00:00:08.000000', 'temperatura', 79.0000, 'ºC'),
	(334006, 143, '2015-02-01 00:00:09.000000', 'temperatura', 556.0000, 'ºC'),
	(334007, 143, '2015-02-01 00:00:10.000000', 'temperatura', 142.0000, 'ºC'),
	(334008, 143, '2015-02-01 00:00:11.000000', 'temperatura', 244.0000, 'ºC'),
	(334009, 143, '2015-02-01 00:00:12.000000', 'temperatura', 793.0000, 'ºC'),
	(334010, 143, '2015-02-01 00:00:13.000000', 'temperatura', 832.0000, 'ºC'),
	(334011, 143, '2015-02-01 00:00:14.000000', 'temperatura', 583.0000, 'ºC'),
	(334012, 143, '2015-02-01 00:00:15.000000', 'temperatura', 418.0000, 'ºC'),
	(334013, 143, '2015-02-01 00:00:16.000000', 'temperatura', 341.0000, 'ºC'),
	(334014, 143, '2015-02-01 00:00:17.000000', 'temperatura', 452.0000, 'ºC'),
	(334015, 143, '2015-02-01 00:00:18.000000', 'temperatura', 38.0000, 'ºC'),
	(334016, 143, '2015-02-01 00:00:19.000000', 'temperatura', 34.0000, 'ºC'),
	(334017, 143, '2015-02-01 00:00:20.000000', 'temperatura', 58.0000, 'ºC'),
	(334018, 143, '2015-02-01 00:00:21.000000', 'temperatura', 188.0000, 'ºC'),
	(334019, 143, '2015-02-01 00:00:22.000000', 'temperatura', 766.0000, 'ºC'),
	(334020, 143, '2015-02-01 00:00:23.000000', 'temperatura', 865.0000, 'ºC'),
	(334021, 143, '2015-02-01 00:00:24.000000', 'temperatura', 828.0000, 'ºC'),
	(334022, 143, '2015-02-01 00:00:25.000000', 'temperatura', 347.0000, 'ºC'),
	(334023, 143, '2015-02-01 00:00:26.000000', 'temperatura', 453.0000, 'ºC'),
	(334024, 143, '2015-02-01 00:00:27.000000', 'temperatura', 21.0000, 'ºC'),
	(334025, 143, '2015-02-01 00:00:28.000000', 'temperatura', 1147.0000, 'ºC'),
	(334026, 143, '2015-02-01 00:00:29.000000', 'temperatura', 875.0000, 'ºC'),
	(334027, 143, '2015-02-01 00:00:30.000000', 'temperatura', 933.0000, 'ºC'),
	(334028, 143, '2015-02-01 00:00:31.000000', 'temperatura', 840.0000, 'ºC'),
	(334029, 143, '2015-02-01 00:00:32.000000', 'temperatura', 201.0000, 'ºC'),
	(334030, 143, '2015-02-01 00:00:33.000000', 'temperatura', 888.0000, 'ºC'),
	(334031, 143, '2015-02-01 00:00:34.000000', 'temperatura', 235.0000, 'ºC'),
	(334032, 143, '2015-02-01 00:00:35.000000', 'temperatura', 911.0000, 'ºC'),
	(334033, 143, '2015-02-01 00:00:36.000000', 'temperatura', 252.0000, 'ºC'),
	(334034, 143, '2015-02-01 00:00:37.000000', 'temperatura', 928.0000, 'ºC'),
	(334035, 143, '2015-02-01 00:00:38.000000', 'temperatura', 284.0000, 'ºC'),
	(334036, 143, '2015-02-01 00:00:39.000000', 'temperatura', 1036.0000, 'ºC'),
	(334037, 143, '2015-02-01 00:00:40.000000', 'temperatura', 729.0000, 'ºC'),
	(334038, 143, '2015-02-01 00:00:41.000000', 'temperatura', 536.0000, 'ºC'),
	(334039, 143, '2015-02-01 00:00:42.000000', 'temperatura', 495.0000, 'ºC'),
	(334040, 143, '2015-02-01 00:00:43.000000', 'temperatura', 868.0000, 'ºC'),
	(334041, 143, '2015-02-01 00:00:44.000000', 'temperatura', 456.0000, 'ºC'),
	(334042, 143, '2015-02-01 00:00:45.000000', 'temperatura', 877.0000, 'ºC'),
	(334043, 143, '2015-02-01 00:00:46.000000', 'temperatura', 615.0000, 'ºC'),
	(334044, 143, '2015-02-01 00:00:47.000000', 'temperatura', 446.0000, 'ºC'),
	(334045, 143, '2015-02-01 00:00:48.000000', 'temperatura', 386.0000, 'ºC'),
	(334046, 143, '2015-02-01 00:00:49.000000', 'temperatura', 591.0000, 'ºC'),
	(334047, 143, '2015-02-01 00:00:50.000000', 'temperatura', 597.0000, 'ºC'),
	(334048, 143, '2015-02-01 00:00:51.000000', 'temperatura', 15.0000, 'ºC'),
	(334049, 143, '2015-02-01 00:00:52.000000', 'temperatura', 682.0000, 'ºC'),
	(334050, 143, '2015-02-01 00:00:53.000000', 'temperatura', 965.0000, 'ºC'),
	(334051, 143, '2015-02-01 00:00:54.000000', 'temperatura', 382.0000, 'ºC'),
	(334052, 143, '2015-02-01 00:00:55.000000', 'temperatura', 216.0000, 'ºC'),
	(334053, 143, '2015-02-01 00:00:56.000000', 'temperatura', 1133.0000, 'ºC'),
	(334054, 143, '2015-02-01 00:00:57.000000', 'temperatura', 218.0000, 'ºC'),
	(334055, 143, '2015-02-01 00:00:58.000000', 'temperatura', 92.0000, 'ºC'),
	(334056, 143, '2015-02-01 00:00:59.000000', 'temperatura', 1007.0000, 'ºC'),
	(334057, 143, '2015-02-01 00:01:00.000000', 'temperatura', 1160.0000, 'ºC'),
	(334058, 143, '2015-02-01 00:01:01.000000', 'temperatura', 377.0000, 'ºC'),
	(334059, 143, '2015-02-01 00:01:02.000000', 'temperatura', 805.0000, 'ºC'),
	(334060, 143, '2015-02-01 00:01:03.000000', 'temperatura', 497.0000, 'ºC'),
	(334061, 143, '2015-02-01 00:01:04.000000', 'temperatura', 71.0000, 'ºC'),
	(334062, 143, '2015-02-01 00:01:05.000000', 'temperatura', 65.0000, 'ºC'),
	(334063, 143, '2015-02-01 00:01:06.000000', 'temperatura', 111.0000, 'ºC'),
	(334064, 143, '2015-02-01 00:01:07.000000', 'temperatura', 359.0000, 'ºC'),
	(334065, 143, '2015-02-01 00:01:08.000000', 'temperatura', 264.0000, 'ºC'),
	(334066, 143, '2015-02-01 00:01:09.000000', 'temperatura', 245.0000, 'ºC'),
	(334067, 143, '2015-02-01 00:01:10.000000', 'temperatura', 432.0000, 'ºC'),
	(334068, 143, '2015-02-01 00:01:11.000000', 'temperatura', 225.0000, 'ºC'),
	(334069, 143, '2015-02-01 00:01:12.000000', 'temperatura', 1032.0000, 'ºC'),
	(334070, 143, '2015-02-01 00:01:13.000000', 'temperatura', 884.0000, 'ºC'),
	(334071, 143, '2015-02-01 00:01:14.000000', 'temperatura', 125.0000, 'ºC'),
	(334072, 143, '2015-02-01 00:01:15.000000', 'temperatura', 372.0000, 'ºC'),
	(334073, 143, '2015-02-01 00:01:16.000000', 'temperatura', 287.0000, 'ºC'),
	(334074, 143, '2015-02-01 00:01:17.000000', 'temperatura', 319.0000, 'ºC'),
	(334075, 143, '2015-02-01 00:01:18.000000', 'temperatura', 733.0000, 'ºC'),
	(334076, 143, '2015-02-01 00:01:19.000000', 'temperatura', 311.0000, 'ºC'),
	(334077, 143, '2015-02-01 00:01:20.000000', 'temperatura', 554.0000, 'ºC'),
	(334078, 143, '2015-02-01 00:01:21.000000', 'temperatura', 639.0000, 'ºC'),
	(334079, 143, '2015-02-01 00:01:22.000000', 'temperatura', 332.0000, 'ºC'),
	(334080, 143, '2015-02-01 00:01:23.000000', 'temperatura', 944.0000, 'ºC'),
	(334081, 143, '2015-02-01 00:01:24.000000', 'temperatura', 124.0000, 'ºC'),
	(334082, 143, '2015-02-01 00:01:25.000000', 'temperatura', 188.0000, 'ºC'),
	(334083, 143, '2015-02-01 00:01:26.000000', 'temperatura', 570.0000, 'ºC'),
	(334084, 143, '2015-02-01 00:01:27.000000', 'temperatura', 1084.0000, 'ºC'),
	(334085, 143, '2015-02-01 00:01:28.000000', 'temperatura', 112.0000, 'ºC'),
	(334086, 143, '2015-02-01 00:01:29.000000', 'temperatura', 908.0000, 'ºC'),
	(334087, 143, '2015-02-01 00:01:30.000000', 'temperatura', 606.0000, 'ºC'),
	(334088, 143, '2015-02-01 00:01:31.000000', 'temperatura', 307.0000, 'ºC'),
	(334089, 143, '2015-02-01 00:01:32.000000', 'temperatura', 915.0000, 'ºC'),
	(334090, 143, '2015-02-01 00:01:33.000000', 'temperatura', 55.0000, 'ºC'),
	(334091, 143, '2015-02-01 00:01:34.000000', 'temperatura', 1131.0000, 'ºC'),
	(334092, 143, '2015-02-01 00:01:35.000000', 'temperatura', 689.0000, 'ºC'),
	(334093, 143, '2015-02-01 00:01:36.000000', 'temperatura', 54.0000, 'ºC'),
	(334094, 143, '2015-02-01 00:01:37.000000', 'temperatura', 604.0000, 'ºC'),
	(334095, 143, '2015-02-01 00:01:38.000000', 'temperatura', 459.0000, 'ºC'),
	(334096, 143, '2015-02-01 00:01:39.000000', 'temperatura', 481.0000, 'ºC'),
	(334097, 143, '2015-02-01 00:01:40.000000', 'temperatura', 1028.0000, 'ºC'),
	(334098, 143, '2015-02-01 00:01:41.000000', 'temperatura', 100.0000, 'ºC'),
	(334099, 143, '2015-02-01 00:01:42.000000', 'temperatura', 1015.0000, 'ºC'),
	(334100, 143, '2015-02-01 00:01:43.000000', 'temperatura', 1177.0000, 'ºC'),
	(334101, 143, '2015-02-01 00:01:44.000000', 'temperatura', 438.0000, 'ºC'),
	(334102, 143, '2015-02-01 00:01:45.000000', 'temperatura', 1062.0000, 'ºC'),
	(334103, 143, '2015-02-01 00:01:46.000000', 'temperatura', 396.0000, 'ºC'),
	(334104, 143, '2015-02-01 00:01:47.000000', 'temperatura', 1195.0000, 'ºC'),
	(334105, 143, '2015-02-01 00:01:48.000000', 'temperatura', 1186.0000, 'ºC'),
	(334106, 143, '2015-02-01 00:01:49.000000', 'temperatura', 1147.0000, 'ºC'),
	(334107, 143, '2015-02-01 00:01:50.000000', 'temperatura', 977.0000, 'ºC'),
	(334108, 143, '2015-02-01 00:01:51.000000', 'temperatura', 245.0000, 'ºC'),
	(334109, 143, '2015-02-01 00:01:52.000000', 'temperatura', 694.0000, 'ºC'),
	(334110, 143, '2015-02-01 00:01:53.000000', 'temperatura', 335.0000, 'ºC'),
	(334111, 143, '2015-02-01 00:01:54.000000', 'temperatura', 792.0000, 'ºC'),
	(334112, 143, '2015-02-01 00:01:55.000000', 'temperatura', 559.0000, 'ºC'),
	(334113, 143, '2015-02-01 00:01:56.000000', 'temperatura', 417.0000, 'ºC'),
	(334114, 143, '2015-02-01 00:01:57.000000', 'temperatura', 407.0000, 'ºC'),
	(334115, 143, '2015-02-01 00:01:58.000000', 'temperatura', 787.0000, 'ºC'),
	(334116, 143, '2015-02-01 00:01:59.000000', 'temperatura', 313.0000, 'ºC'),
	(334117, 143, '2015-02-01 00:02:00.000000', 'temperatura', 404.0000, 'ºC'),
	(334118, 143, '2015-02-01 00:02:01.000000', 'temperatura', 1083.0000, 'ºC'),
	(334119, 143, '2015-02-01 00:02:02.000000', 'temperatura', 602.0000, 'ºC'),
	(334120, 143, '2015-02-01 00:02:03.000000', 'temperatura', 964.0000, 'ºC'),
	(334121, 143, '2015-02-01 00:02:04.000000', 'temperatura', 615.0000, 'ºC'),
	(334122, 143, '2015-02-01 00:02:05.000000', 'temperatura', 180.0000, 'ºC'),
	(334123, 143, '2015-02-01 00:02:06.000000', 'temperatura', 258.0000, 'ºC'),
	(334124, 143, '2015-02-01 00:02:07.000000', 'temperatura', 748.0000, 'ºC'),
	(334125, 143, '2015-02-01 00:02:08.000000', 'temperatura', 568.0000, 'ºC'),
	(334126, 143, '2015-02-01 00:02:09.000000', 'temperatura', 598.0000, 'ºC'),
	(334127, 143, '2015-02-01 00:02:10.000000', 'temperatura', 87.0000, 'ºC'),
	(334128, 143, '2015-02-01 00:02:11.000000', 'temperatura', 1041.0000, 'ºC'),
	(334129, 143, '2015-02-01 00:02:12.000000', 'temperatura', 144.0000, 'ºC'),
	(334130, 143, '2015-02-01 00:02:13.000000', 'temperatura', 1198.0000, 'ºC'),
	(334131, 143, '2015-02-01 00:02:14.000000', 'temperatura', 760.0000, 'ºC'),
	(334132, 143, '2015-02-01 00:02:15.000000', 'temperatura', 206.0000, 'ºC'),
	(334133, 143, '2015-02-01 00:02:16.000000', 'temperatura', 1149.0000, 'ºC'),
	(334134, 143, '2015-02-01 00:02:17.000000', 'temperatura', 329.0000, 'ºC'),
	(334135, 143, '2015-02-01 00:02:18.000000', 'temperatura', 599.0000, 'ºC'),
	(334136, 143, '2015-02-01 00:02:19.000000', 'temperatura', 809.0000, 'ºC'),
	(334137, 143, '2015-02-01 00:02:20.000000', 'temperatura', 1048.0000, 'ºC'),
	(334138, 143, '2015-02-01 00:02:21.000000', 'temperatura', 413.0000, 'ºC'),
	(334139, 143, '2015-02-01 00:02:22.000000', 'temperatura', 122.0000, 'ºC'),
	(334140, 143, '2015-02-01 00:02:23.000000', 'temperatura', 572.0000, 'ºC'),
	(334141, 143, '2015-02-01 00:02:24.000000', 'temperatura', 94.0000, 'ºC'),
	(334142, 143, '2015-02-01 00:02:25.000000', 'temperatura', 1152.0000, 'ºC'),
	(334143, 143, '2015-02-01 00:02:26.000000', 'temperatura', 682.0000, 'ºC'),
	(334144, 143, '2015-02-01 00:02:27.000000', 'temperatura', 1152.0000, 'ºC'),
	(334145, 143, '2015-02-01 00:02:28.000000', 'temperatura', 117.0000, 'ºC'),
	(334146, 143, '2015-02-01 00:02:29.000000', 'temperatura', 726.0000, 'ºC'),
	(334147, 143, '2015-02-01 00:02:30.000000', 'temperatura', 883.0000, 'ºC'),
	(334148, 143, '2015-02-01 00:02:31.000000', 'temperatura', 1035.0000, 'ºC'),
	(334149, 143, '2015-02-01 00:02:32.000000', 'temperatura', 129.0000, 'ºC'),
	(334150, 143, '2015-02-01 00:02:33.000000', 'temperatura', 1141.0000, 'ºC'),
	(334151, 143, '2015-02-01 00:02:34.000000', 'temperatura', 516.0000, 'ºC'),
	(334152, 143, '2015-02-01 00:02:35.000000', 'temperatura', 357.0000, 'ºC'),
	(334153, 143, '2015-02-01 00:02:36.000000', 'temperatura', 237.0000, 'ºC'),
	(334154, 143, '2015-02-01 00:02:37.000000', 'temperatura', 116.0000, 'ºC'),
	(334155, 143, '2015-02-01 00:02:38.000000', 'temperatura', 1069.0000, 'ºC'),
	(334156, 143, '2015-02-01 00:02:39.000000', 'temperatura', 199.0000, 'ºC'),
	(334157, 143, '2015-02-01 00:02:40.000000', 'temperatura', 186.0000, 'ºC'),
	(334158, 143, '2015-02-01 00:02:41.000000', 'temperatura', 336.0000, 'ºC'),
	(334159, 143, '2015-02-01 00:02:42.000000', 'temperatura', 1120.0000, 'ºC'),
	(334160, 143, '2015-02-01 00:02:43.000000', 'temperatura', 995.0000, 'ºC'),
	(334161, 143, '2015-02-01 00:02:44.000000', 'temperatura', 413.0000, 'ºC'),
	(334162, 143, '2015-02-01 00:02:45.000000', 'temperatura', 280.0000, 'ºC'),
	(334163, 143, '2015-02-01 00:02:46.000000', 'temperatura', 163.0000, 'ºC'),
	(334164, 143, '2015-02-01 00:02:47.000000', 'temperatura', 1175.0000, 'ºC'),
	(334165, 143, '2015-02-01 00:02:48.000000', 'temperatura', 584.0000, 'ºC'),
	(334166, 143, '2015-02-01 00:02:49.000000', 'temperatura', 599.0000, 'ºC'),
	(334167, 143, '2015-02-01 00:02:50.000000', 'temperatura', 44.0000, 'ºC'),
	(334168, 143, '2015-02-01 00:02:51.000000', 'temperatura', 824.0000, 'ºC'),
	(334169, 143, '2015-02-01 00:02:52.000000', 'temperatura', 386.0000, 'ºC'),
	(334170, 143, '2015-02-01 00:02:53.000000', 'temperatura', 658.0000, 'ºC'),
	(334171, 143, '2015-02-01 00:02:54.000000', 'temperatura', 935.0000, 'ºC'),
	(334172, 143, '2015-02-01 00:02:55.000000', 'temperatura', 301.0000, 'ºC'),
	(334173, 143, '2015-02-01 00:02:56.000000', 'temperatura', 1100.0000, 'ºC'),
	(334174, 143, '2015-02-01 00:02:57.000000', 'temperatura', 997.0000, 'ºC'),
	(334175, 143, '2015-02-01 00:02:58.000000', 'temperatura', 484.0000, 'ºC'),
	(334176, 143, '2015-02-01 00:02:59.000000', 'temperatura', 630.0000, 'ºC'),
	(334177, 143, '2015-02-01 00:03:00.000000', 'temperatura', 500.0000, 'ºC'),
	(334178, 143, '2015-02-01 00:03:01.000000', 'temperatura', 610.0000, 'ºC'),
	(334179, 143, '2015-02-01 00:03:02.000000', 'temperatura', 351.0000, 'ºC'),
	(334180, 143, '2015-02-01 00:03:03.000000', 'temperatura', 1123.0000, 'ºC'),
	(334181, 143, '2015-02-01 00:03:04.000000', 'temperatura', 965.0000, 'ºC'),
	(334182, 143, '2015-02-01 00:03:05.000000', 'temperatura', 255.0000, 'ºC'),
	(334183, 143, '2015-02-01 00:03:06.000000', 'temperatura', 781.0000, 'ºC'),
	(334184, 143, '2015-02-01 00:03:07.000000', 'temperatura', 740.0000, 'ºC'),
	(334185, 143, '2015-02-01 00:03:08.000000', 'temperatura', 156.0000, 'ºC'),
	(334186, 143, '2015-02-01 00:03:09.000000', 'temperatura', 963.0000, 'ºC'),
	(334187, 143, '2015-02-01 00:03:10.000000', 'temperatura', 748.0000, 'ºC'),
	(334188, 143, '2015-02-01 00:03:11.000000', 'temperatura', 851.0000, 'ºC'),
	(334189, 143, '2015-02-01 00:03:12.000000', 'temperatura', 810.0000, 'ºC'),
	(334190, 143, '2015-02-01 00:03:13.000000', 'temperatura', 297.0000, 'ºC'),
	(334191, 143, '2015-02-01 00:03:14.000000', 'temperatura', 257.0000, 'ºC'),
	(334192, 143, '2015-02-01 00:03:15.000000', 'temperatura', 392.0000, 'ºC'),
	(334193, 143, '2015-02-01 00:03:16.000000', 'temperatura', 1191.0000, 'ºC'),
	(334194, 143, '2015-02-01 00:03:17.000000', 'temperatura', 1179.0000, 'ºC'),
	(334195, 143, '2015-02-01 00:03:18.000000', 'temperatura', 1124.0000, 'ºC'),
	(334196, 143, '2015-02-01 00:03:19.000000', 'temperatura', 883.0000, 'ºC'),
	(334197, 143, '2015-02-01 00:03:20.000000', 'temperatura', 1045.0000, 'ºC'),
	(334198, 143, '2015-02-01 00:03:21.000000', 'temperatura', 176.0000, 'ºC'),
	(334199, 143, '2015-02-01 00:03:22.000000', 'temperatura', 146.0000, 'ºC'),
	(334200, 143, '2015-02-01 00:03:23.000000', 'temperatura', 203.0000, 'ºC'),
	(334201, 143, '2015-02-01 00:03:24.000000', 'temperatura', 577.0000, 'ºC'),
	(334202, 143, '2015-02-01 00:03:25.000000', 'temperatura', 1076.0000, 'ºC'),
	(334203, 143, '2015-02-01 00:03:26.000000', 'temperatura', 51.0000, 'ºC'),
	(334204, 143, '2015-02-01 00:03:27.000000', 'temperatura', 625.0000, 'ºC'),
	(334205, 143, '2015-02-01 00:03:28.000000', 'temperatura', 572.0000, 'ºC'),
	(334206, 143, '2015-02-01 00:03:29.000000', 'temperatura', 985.0000, 'ºC'),
	(334207, 143, '2015-02-01 00:03:30.000000', 'temperatura', 811.0000, 'ºC'),
	(334208, 143, '2015-02-01 00:03:31.000000', 'temperatura', 1098.0000, 'ºC'),
	(334209, 143, '2015-02-01 00:03:32.000000', 'temperatura', 661.0000, 'ºC'),
	(334210, 143, '2015-02-01 00:03:33.000000', 'temperatura', 10.0000, 'ºC'),
	(334211, 143, '2015-02-01 00:03:34.000000', 'temperatura', 469.0000, 'ºC'),
	(334212, 143, '2015-02-01 00:03:35.000000', 'temperatura', 1114.0000, 'ºC'),
	(334213, 143, '2015-02-01 00:03:36.000000', 'temperatura', 564.0000, 'ºC'),
	(334214, 143, '2015-02-01 00:03:37.000000', 'temperatura', 679.0000, 'ºC'),
	(334215, 143, '2015-02-01 00:03:38.000000', 'temperatura', 502.0000, 'ºC'),
	(334216, 143, '2015-02-01 00:03:39.000000', 'temperatura', 472.0000, 'ºC'),
	(334217, 143, '2015-02-01 00:03:40.000000', 'temperatura', 857.0000, 'ºC'),
	(334218, 143, '2015-02-01 00:03:41.000000', 'temperatura', 470.0000, 'ºC'),
	(334219, 143, '2015-02-01 00:03:42.000000', 'temperatura', 978.0000, 'ºC'),
	(334220, 143, '2015-02-01 00:03:43.000000', 'temperatura', 1081.0000, 'ºC'),
	(334221, 143, '2015-02-01 00:03:44.000000', 'temperatura', 72.0000, 'ºC'),
	(334222, 143, '2015-02-01 00:03:45.000000', 'temperatura', 717.0000, 'ºC'),
	(334223, 143, '2015-02-01 00:03:46.000000', 'temperatura', 971.0000, 'ºC'),
	(334224, 143, '2015-02-01 00:03:47.000000', 'temperatura', 305.0000, 'ºC'),
	(334225, 143, '2015-02-01 00:03:48.000000', 'temperatura', 1011.0000, 'ºC'),
	(334226, 143, '2015-02-01 00:03:49.000000', 'temperatura', 543.0000, 'ºC'),
	(334227, 143, '2015-02-01 00:03:50.000000', 'temperatura', 880.0000, 'ºC'),
	(334228, 143, '2015-02-01 00:03:51.000000', 'temperatura', 372.0000, 'ºC'),
	(334229, 143, '2015-02-01 00:03:52.000000', 'temperatura', 419.0000, 'ºC'),
	(334230, 143, '2015-02-01 00:03:53.000000', 'temperatura', 980.0000, 'ºC'),
	(334231, 143, '2015-02-01 00:03:54.000000', 'temperatura', 43.0000, 'ºC'),
	(334232, 143, '2015-02-01 00:03:55.000000', 'temperatura', 874.0000, 'ºC'),
	(334233, 143, '2015-02-01 00:03:56.000000', 'temperatura', 644.0000, 'ºC'),
	(334234, 143, '2015-02-01 00:03:57.000000', 'temperatura', 599.0000, 'ºC'),
	(334235, 143, '2015-02-01 00:03:58.000000', 'temperatura', 1063.0000, 'ºC'),
	(334236, 143, '2015-02-01 00:03:59.000000', 'temperatura', 1119.0000, 'ºC'),
	(334237, 143, '2015-02-01 00:04:00.000000', 'temperatura', 7.0000, 'ºC'),
	(334238, 143, '2015-02-01 00:04:01.000000', 'temperatura', 279.0000, 'ºC'),
	(334239, 143, '2015-02-01 00:04:02.000000', 'temperatura', 174.0000, 'ºC'),
	(334240, 143, '2015-02-01 00:04:03.000000', 'temperatura', 32.0000, 'ºC'),
	(334241, 143, '2015-02-01 00:04:04.000000', 'temperatura', 837.0000, 'ºC'),
	(334242, 143, '2015-02-01 00:04:05.000000', 'temperatura', 493.0000, 'ºC'),
	(334243, 143, '2015-02-01 00:04:06.000000', 'temperatura', 1154.0000, 'ºC'),
	(334244, 143, '2015-02-01 00:04:07.000000', 'temperatura', 691.0000, 'ºC'),
	(334245, 143, '2015-02-01 00:04:08.000000', 'temperatura', 1193.0000, 'ºC'),
	(334246, 143, '2015-02-01 00:04:09.000000', 'temperatura', 292.0000, 'ºC'),
	(334247, 143, '2015-02-01 00:04:10.000000', 'temperatura', 284.0000, 'ºC'),
	(334248, 143, '2015-02-01 00:04:11.000000', 'temperatura', 542.0000, 'ºC'),
	(334249, 143, '2015-02-01 00:04:12.000000', 'temperatura', 660.0000, 'ºC'),
	(334250, 143, '2015-02-01 00:04:13.000000', 'temperatura', 475.0000, 'ºC'),
	(334251, 143, '2015-02-01 00:04:14.000000', 'temperatura', 395.0000, 'ºC'),
	(334252, 143, '2015-02-01 00:04:15.000000', 'temperatura', 552.0000, 'ºC'),
	(334253, 143, '2015-02-01 00:04:16.000000', 'temperatura', 375.0000, 'ºC'),
	(334254, 143, '2015-02-01 00:04:17.000000', 'temperatura', 219.0000, 'ºC'),
	(334255, 143, '2015-02-01 00:04:18.000000', 'temperatura', 1169.0000, 'ºC'),
	(334256, 143, '2015-02-01 00:04:19.000000', 'temperatura', 390.0000, 'ºC'),
	(334257, 143, '2015-02-01 00:04:20.000000', 'temperatura', 845.0000, 'ºC'),
	(334258, 143, '2015-02-01 00:04:21.000000', 'temperatura', 652.0000, 'ºC'),
	(334259, 143, '2015-02-01 00:04:22.000000', 'temperatura', 729.0000, 'ºC'),
	(334260, 143, '2015-02-01 00:04:23.000000', 'temperatura', 487.0000, 'ºC'),
	(334261, 143, '2015-02-01 00:04:24.000000', 'temperatura', 251.0000, 'ºC'),
	(334262, 143, '2015-02-01 00:04:25.000000', 'temperatura', 992.0000, 'ºC'),
	(334263, 143, '2015-02-01 00:04:26.000000', 'temperatura', 607.0000, 'ºC'),
	(334264, 143, '2015-02-01 00:04:27.000000', 'temperatura', 60.0000, 'ºC'),
	(334265, 143, '2015-02-01 00:04:28.000000', 'temperatura', 881.0000, 'ºC'),
	(334266, 143, '2015-02-01 00:04:29.000000', 'temperatura', 623.0000, 'ºC'),
	(334267, 143, '2015-02-01 00:04:30.000000', 'temperatura', 472.0000, 'ºC'),
	(334268, 143, '2015-02-01 00:04:31.000000', 'temperatura', 493.0000, 'ºC'),
	(334269, 143, '2015-02-01 00:04:32.000000', 'temperatura', 1048.0000, 'ºC'),
	(334270, 143, '2015-02-01 00:04:33.000000', 'temperatura', 161.0000, 'ºC'),
	(334271, 143, '2015-02-01 00:04:34.000000', 'temperatura', 61.0000, 'ºC'),
	(334272, 143, '2015-02-01 00:04:35.000000', 'temperatura', 1023.0000, 'ºC'),
	(334273, 143, '2015-02-01 00:04:36.000000', 'temperatura', 132.0000, 'ºC'),
	(334274, 143, '2015-02-01 00:04:37.000000', 'temperatura', 1193.0000, 'ºC'),
	(334275, 143, '2015-02-01 00:04:38.000000', 'temperatura', 767.0000, 'ºC'),
	(334276, 143, '2015-02-01 00:04:39.000000', 'temperatura', 257.0000, 'ºC'),
	(334277, 143, '2015-02-01 00:04:40.000000', 'temperatura', 186.0000, 'ºC'),
	(334278, 143, '2015-02-01 00:04:41.000000', 'temperatura', 159.0000, 'ºC'),
	(334279, 143, '2015-02-01 00:04:42.000000', 'temperatura', 239.0000, 'ºC'),
	(334280, 143, '2015-02-01 00:04:43.000000', 'temperatura', 716.0000, 'ºC'),
	(334281, 143, '2015-02-01 00:04:44.000000', 'temperatura', 464.0000, 'ºC'),
	(334282, 143, '2015-02-01 00:04:45.000000', 'temperatura', 172.0000, 'ºC'),
	(334283, 143, '2015-02-01 00:04:46.000000', 'temperatura', 671.0000, 'ºC'),
	(334284, 143, '2015-02-01 00:04:47.000000', 'temperatura', 437.0000, 'ºC'),
	(334285, 143, '2015-02-01 00:04:48.000000', 'temperatura', 173.0000, 'ºC'),
	(334286, 143, '2015-02-01 00:04:49.000000', 'temperatura', 755.0000, 'ºC'),
	(334287, 143, '2015-02-01 00:04:50.000000', 'temperatura', 854.0000, 'ºC'),
	(334288, 143, '2015-02-01 00:04:51.000000', 'temperatura', 809.0000, 'ºC'),
	(334289, 143, '2015-02-01 00:04:52.000000', 'temperatura', 283.0000, 'ºC'),
	(334290, 143, '2015-02-01 00:04:53.000000', 'temperatura', 187.0000, 'ºC'),
	(334291, 143, '2015-02-01 00:04:54.000000', 'temperatura', 88.0000, 'ºC'),
	(334292, 143, '2015-02-01 00:04:55.000000', 'temperatura', 1080.0000, 'ºC'),
	(334293, 143, '2015-02-01 00:04:56.000000', 'temperatura', 336.0000, 'ºC'),
	(334294, 143, '2015-02-01 00:04:57.000000', 'temperatura', 842.0000, 'ºC'),
	(334295, 143, '2015-02-01 00:04:58.000000', 'temperatura', 799.0000, 'ºC'),
	(334296, 143, '2015-02-01 00:04:59.000000', 'temperatura', 273.0000, 'ºC'),
	(334297, 143, '2015-02-01 00:05:00.000000', 'temperatura', 168.0000, 'ºC'),
	(334298, 143, '2015-02-01 00:05:01.000000', 'temperatura', 20.0000, 'ºC'),
	(334299, 143, '2015-02-01 00:05:02.000000', 'temperatura', 796.0000, 'ºC'),
	(334300, 143, '2015-02-01 00:05:03.000000', 'temperatura', 320.0000, 'ºC'),
	(334301, 143, '2015-02-01 00:05:04.000000', 'temperatura', 414.0000, 'ºC'),
	(334302, 143, '2015-02-01 00:05:05.000000', 'temperatura', 1108.0000, 'ºC'),
	(334303, 143, '2015-02-01 00:05:06.000000', 'temperatura', 701.0000, 'ºC'),
	(334304, 143, '2015-02-01 00:05:07.000000', 'temperatura', 181.0000, 'ºC'),
	(334305, 143, '2015-02-01 00:05:08.000000', 'temperatura', 2.0000, 'ºC'),
	(334306, 143, '2015-02-01 00:05:09.000000', 'temperatura', 666.0000, 'ºC'),
	(334307, 143, '2015-02-01 00:05:10.000000', 'temperatura', 926.0000, 'ºC'),
	(334308, 143, '2015-02-01 00:05:11.000000', 'temperatura', 230.0000, 'ºC'),
	(334309, 143, '2015-02-01 00:05:12.000000', 'temperatura', 776.0000, 'ºC'),
	(334310, 143, '2015-02-01 00:05:13.000000', 'temperatura', 789.0000, 'ºC'),
	(334311, 143, '2015-02-01 00:05:14.000000', 'temperatura', 417.0000, 'ºC'),
	(334312, 143, '2015-02-01 00:05:15.000000', 'temperatura', 920.0000, 'ºC'),
	(334313, 143, '2015-02-01 00:05:16.000000', 'temperatura', 947.0000, 'ºC'),
	(334314, 143, '2015-02-01 00:05:17.000000', 'temperatura', 778.0000, 'ºC'),
	(334315, 143, '2015-02-01 00:05:18.000000', 'temperatura', 1049.0000, 'ºC'),
	(334316, 143, '2015-02-01 00:05:19.000000', 'temperatura', 511.0000, 'ºC'),
	(334317, 143, '2015-02-01 00:05:20.000000', 'temperatura', 607.0000, 'ºC'),
	(334318, 143, '2015-02-01 00:05:21.000000', 'temperatura', 304.0000, 'ºC'),
	(334319, 143, '2015-02-01 00:05:22.000000', 'temperatura', 898.0000, 'ºC'),
	(334320, 143, '2015-02-01 00:05:23.000000', 'temperatura', 1178.0000, 'ºC'),
	(334321, 143, '2015-02-01 00:05:24.000000', 'temperatura', 800.0000, 'ºC'),
	(334322, 143, '2015-02-01 00:05:25.000000', 'temperatura', 463.0000, 'ºC'),
	(334323, 143, '2015-02-01 00:05:26.000000', 'temperatura', 1116.0000, 'ºC'),
	(334324, 143, '2015-02-01 00:05:27.000000', 'temperatura', 594.0000, 'ºC'),
	(334325, 143, '2015-02-01 00:05:28.000000', 'temperatura', 821.0000, 'ºC'),
	(334326, 143, '2015-02-01 00:05:29.000000', 'temperatura', 1125.0000, 'ºC'),
	(334327, 143, '2015-02-01 00:05:30.000000', 'temperatura', 760.0000, 'ºC'),
	(334328, 143, '2015-02-01 00:05:31.000000', 'temperatura', 428.0000, 'ºC'),
	(334329, 143, '2015-02-01 00:05:32.000000', 'temperatura', 1058.0000, 'ºC'),
	(334330, 143, '2015-02-01 00:05:33.000000', 'temperatura', 406.0000, 'ºC'),
	(334331, 143, '2015-02-01 00:05:34.000000', 'temperatura', 60.0000, 'ºC'),
	(334332, 143, '2015-02-01 00:05:35.000000', 'temperatura', 279.0000, 'ºC'),
	(334333, 143, '2015-02-01 00:05:36.000000', 'temperatura', 17.0000, 'ºC'),
	(334334, 143, '2015-02-01 00:05:37.000000', 'temperatura', 449.0000, 'ºC'),
	(334335, 143, '2015-02-01 00:05:38.000000', 'temperatura', 992.0000, 'ºC'),
	(334336, 143, '2015-02-01 00:05:39.000000', 'temperatura', 15.0000, 'ºC'),
	(334337, 143, '2015-02-01 00:05:40.000000', 'temperatura', 701.0000, 'ºC'),
	(334338, 143, '2015-02-01 00:05:41.000000', 'temperatura', 1061.0000, 'ºC'),
	(334339, 143, '2015-02-01 00:05:42.000000', 'temperatura', 803.0000, 'ºC'),
	(334340, 143, '2015-02-01 00:05:43.000000', 'temperatura', 833.0000, 'ºC'),
	(334341, 143, '2015-02-01 00:05:44.000000', 'temperatura', 557.0000, 'ºC'),
	(334342, 143, '2015-02-01 00:05:45.000000', 'temperatura', 286.0000, 'ºC'),
	(334343, 143, '2015-02-01 00:05:46.000000', 'temperatura', 959.0000, 'ºC'),
	(334344, 143, '2015-02-01 00:05:47.000000', 'temperatura', 336.0000, 'ºC'),
	(334345, 143, '2015-02-01 00:05:48.000000', 'temperatura', 6.0000, 'ºC'),
	(334346, 143, '2015-02-01 00:05:49.000000', 'temperatura', 221.0000, 'ºC'),
	(334347, 143, '2015-02-01 00:05:50.000000', 'temperatura', 1086.0000, 'ºC'),
	(334348, 143, '2015-02-01 00:05:51.000000', 'temperatura', 1170.0000, 'ºC'),
	(334349, 143, '2015-02-01 00:05:52.000000', 'temperatura', 192.0000, 'ºC'),
	(334350, 143, '2015-02-01 00:05:53.000000', 'temperatura', 1050.0000, 'ºC'),
	(334351, 143, '2015-02-01 00:05:54.000000', 'temperatura', 1073.0000, 'ºC'),
	(334352, 143, '2015-02-01 00:05:55.000000', 'temperatura', 1015.0000, 'ºC'),
	(334353, 143, '2015-02-01 00:05:56.000000', 'temperatura', 659.0000, 'ºC'),
	(334354, 143, '2015-02-01 00:05:57.000000', 'temperatura', 250.0000, 'ºC'),
	(334355, 143, '2015-02-01 00:05:58.000000', 'temperatura', 474.0000, 'ºC'),
	(334356, 143, '2015-02-01 00:05:59.000000', 'temperatura', 418.0000, 'ºC'),
	(334357, 143, '2015-02-01 00:06:00.000000', 'temperatura', 670.0000, 'ºC'),
	(334358, 143, '2015-02-01 00:06:01.000000', 'temperatura', 895.0000, 'ºC'),
	(334359, 143, '2015-02-01 00:06:02.000000', 'temperatura', 66.0000, 'ºC'),
	(334360, 143, '2015-02-01 00:06:03.000000', 'temperatura', 46.0000, 'ºC'),
	(334361, 143, '2015-02-01 00:06:04.000000', 'temperatura', 31.0000, 'ºC'),
	(334362, 143, '2015-02-01 00:06:05.000000', 'temperatura', 17.0000, 'ºC'),
	(334363, 143, '2015-02-01 00:06:06.000000', 'temperatura', 1193.0000, 'ºC'),
	(334364, 143, '2015-02-01 00:06:07.000000', 'temperatura', 1115.0000, 'ºC'),
	(334365, 143, '2015-02-01 00:06:08.000000', 'temperatura', 798.0000, 'ºC'),
	(334366, 143, '2015-02-01 00:06:09.000000', 'temperatura', 645.0000, 'ºC'),
	(334367, 143, '2015-02-01 00:06:10.000000', 'temperatura', 831.0000, 'ºC'),
	(334368, 143, '2015-02-01 00:06:11.000000', 'temperatura', 1019.0000, 'ºC'),
	(334369, 143, '2015-02-01 00:06:12.000000', 'temperatura', 202.0000, 'ºC'),
	(334370, 143, '2015-02-01 00:06:13.000000', 'temperatura', 356.0000, 'ºC'),
	(334371, 143, '2015-02-01 00:06:14.000000', 'temperatura', 1175.0000, 'ºC'),
	(334372, 143, '2015-02-01 00:06:15.000000', 'temperatura', 8.0000, 'ºC'),
	(334373, 143, '2015-02-01 00:06:16.000000', 'temperatura', 114.0000, 'ºC'),
	(334374, 143, '2015-02-01 00:06:17.000000', 'temperatura', 548.0000, 'ºC'),
	(334375, 143, '2015-02-01 00:06:18.000000', 'temperatura', 0.0000, 'ºC'),
	(334376, 143, '2015-02-01 00:06:19.000000', 'temperatura', 754.0000, 'ºC'),
	(334377, 143, '2015-02-01 00:06:20.000000', 'temperatura', 170.0000, 'ºC'),
	(334378, 143, '2015-02-01 00:06:21.000000', 'temperatura', 989.0000, 'ºC'),
	(334379, 143, '2015-02-01 00:06:22.000000', 'temperatura', 837.0000, 'ºC'),
	(334380, 143, '2015-02-01 00:06:23.000000', 'temperatura', 18.0000, 'ºC'),
	(334381, 143, '2015-02-01 00:06:24.000000', 'temperatura', 1180.0000, 'ºC'),
	(334382, 143, '2015-02-01 00:06:25.000000', 'temperatura', 1044.0000, 'ºC'),
	(334383, 143, '2015-02-01 00:06:26.000000', 'temperatura', 482.0000, 'ºC'),
	(334384, 143, '2015-02-01 00:06:27.000000', 'temperatura', 480.0000, 'ºC'),
	(334385, 143, '2015-02-01 00:06:28.000000', 'temperatura', 952.0000, 'ºC'),
	(334386, 143, '2015-02-01 00:06:29.000000', 'temperatura', 921.0000, 'ºC'),
	(334387, 143, '2015-02-01 00:06:30.000000', 'temperatura', 549.0000, 'ºC'),
	(334388, 143, '2015-02-01 00:06:31.000000', 'temperatura', 1184.0000, 'ºC'),
	(334389, 143, '2015-02-01 00:06:32.000000', 'temperatura', 673.0000, 'ºC'),
	(334390, 143, '2015-02-01 00:06:33.000000', 'temperatura', 1013.0000, 'ºC'),
	(334391, 143, '2015-02-01 00:06:34.000000', 'temperatura', 647.0000, 'ºC'),
	(334392, 143, '2015-02-01 00:06:35.000000', 'temperatura', 196.0000, 'ºC'),
	(334393, 143, '2015-02-01 00:06:36.000000', 'temperatura', 241.0000, 'ºC'),
	(334394, 143, '2015-02-01 00:06:37.000000', 'temperatura', 615.0000, 'ºC'),
	(334395, 143, '2015-02-01 00:06:38.000000', 'temperatura', 1155.0000, 'ºC'),
	(334396, 143, '2015-02-01 00:06:39.000000', 'temperatura', 330.0000, 'ºC'),
	(334397, 143, '2015-02-01 00:06:40.000000', 'temperatura', 586.0000, 'ºC'),
	(334398, 143, '2015-02-01 00:06:41.000000', 'temperatura', 741.0000, 'ºC'),
	(334399, 143, '2015-02-01 00:06:42.000000', 'temperatura', 748.0000, 'ºC'),
	(334400, 143, '2015-02-01 00:06:43.000000', 'temperatura', 315.0000, 'ºC'),
	(334401, 143, '2015-02-01 00:06:44.000000', 'temperatura', 532.0000, 'ºC'),
	(334402, 143, '2015-02-01 00:06:45.000000', 'temperatura', 516.0000, 'ºC'),
	(334403, 143, '2015-02-01 00:06:46.000000', 'temperatura', 985.0000, 'ºC'),
	(334404, 143, '2015-02-01 00:06:47.000000', 'temperatura', 979.0000, 'ºC'),
	(334405, 143, '2015-02-01 00:06:48.000000', 'temperatura', 738.0000, 'ºC'),
	(334406, 143, '2015-02-01 00:06:49.000000', 'temperatura', 755.0000, 'ºC'),
	(334407, 143, '2015-02-01 00:06:50.000000', 'temperatura', 361.0000, 'ºC'),
	(334408, 143, '2015-02-01 00:06:51.000000', 'temperatura', 741.0000, 'ºC'),
	(334409, 143, '2015-02-01 00:06:52.000000', 'temperatura', 222.0000, 'ºC'),
	(334410, 143, '2015-02-01 00:06:53.000000', 'temperatura', 89.0000, 'ºC'),
	(334411, 143, '2015-02-01 00:06:54.000000', 'temperatura', 980.0000, 'ºC'),
	(334412, 143, '2015-02-01 00:06:55.000000', 'temperatura', 1034.0000, 'ºC'),
	(334413, 143, '2015-02-01 00:06:56.000000', 'temperatura', 1030.0000, 'ºC'),
	(334414, 143, '2015-02-01 00:06:57.000000', 'temperatura', 849.0000, 'ºC'),
	(334415, 143, '2015-02-01 00:06:58.000000', 'temperatura', 1156.0000, 'ºC'),
	(334416, 143, '2015-02-01 00:06:59.000000', 'temperatura', 834.0000, 'ºC'),
	(334417, 143, '2015-02-01 00:07:00.000000', 'temperatura', 703.0000, 'ºC'),
	(334418, 143, '2015-02-01 00:07:01.000000', 'temperatura', 1014.0000, 'ºC'),
	(334419, 143, '2015-02-01 00:07:02.000000', 'temperatura', 562.0000, 'ºC'),
	(334420, 143, '2015-02-01 00:07:03.000000', 'temperatura', 968.0000, 'ºC'),
	(334421, 143, '2015-02-01 00:07:04.000000', 'temperatura', 755.0000, 'ºC'),
	(334422, 143, '2015-02-01 00:07:05.000000', 'temperatura', 869.0000, 'ºC'),
	(334423, 143, '2015-02-01 00:07:06.000000', 'temperatura', 884.0000, 'ºC'),
	(334424, 143, '2015-02-01 00:07:07.000000', 'temperatura', 611.0000, 'ºC'),
	(334425, 143, '2015-02-01 00:07:08.000000', 'temperatura', 406.0000, 'ºC'),
	(334426, 143, '2015-02-01 00:07:09.000000', 'temperatura', 195.0000, 'ºC'),
	(334427, 143, '2015-02-01 00:07:10.000000', 'temperatura', 958.0000, 'ºC'),
	(334428, 143, '2015-02-01 00:07:11.000000', 'temperatura', 604.0000, 'ºC'),
	(334429, 143, '2015-02-01 00:07:12.000000', 'temperatura', 148.0000, 'ºC'),
	(334430, 143, '2015-02-01 00:07:13.000000', 'temperatura', 130.0000, 'ºC'),
	(334431, 143, '2015-02-01 00:07:14.000000', 'temperatura', 205.0000, 'ºC'),
	(334432, 143, '2015-02-01 00:07:15.000000', 'temperatura', 636.0000, 'ºC'),
	(334433, 143, '2015-02-01 00:07:16.000000', 'temperatura', 167.0000, 'ºC'),
	(334434, 143, '2015-02-01 00:07:17.000000', 'temperatura', 126.0000, 'ºC'),
	(334435, 143, '2015-02-01 00:07:18.000000', 'temperatura', 128.0000, 'ºC'),
	(334436, 143, '2015-02-01 00:07:19.000000', 'temperatura', 265.0000, 'ºC'),
	(334437, 143, '2015-02-01 00:07:20.000000', 'temperatura', 942.0000, 'ºC'),
	(334438, 143, '2015-02-01 00:07:21.000000', 'temperatura', 316.0000, 'ºC'),
	(334439, 143, '2015-02-01 00:07:22.000000', 'temperatura', 1153.0000, 'ºC'),
	(334440, 143, '2015-02-01 00:07:23.000000', 'temperatura', 19.0000, 'ºC'),
	(334441, 143, '2015-02-01 00:07:24.000000', 'temperatura', 237.0000, 'ºC'),
	(334442, 143, '2015-02-01 00:07:25.000000', 'temperatura', 1127.0000, 'ºC'),
	(334443, 143, '2015-02-01 00:07:26.000000', 'temperatura', 125.0000, 'ºC'),
	(334444, 143, '2015-02-01 00:07:27.000000', 'temperatura', 843.0000, 'ºC'),
	(334445, 143, '2015-02-01 00:07:28.000000', 'temperatura', 243.0000, 'ºC'),
	(334446, 143, '2015-02-01 00:07:29.000000', 'temperatura', 1085.0000, 'ºC'),
	(334447, 143, '2015-02-01 00:07:30.000000', 'temperatura', 1099.0000, 'ºC'),
	(334448, 143, '2015-02-01 00:07:31.000000', 'temperatura', 1037.0000, 'ºC'),
	(334449, 143, '2015-02-01 00:07:32.000000', 'temperatura', 691.0000, 'ºC'),
	(334450, 143, '2015-02-01 00:07:33.000000', 'temperatura', 342.0000, 'ºC'),
	(334451, 143, '2015-02-01 00:07:34.000000', 'temperatura', 839.0000, 'ºC'),
	(334452, 143, '2015-02-01 00:07:35.000000', 'temperatura', 770.0000, 'ºC'),
	(334453, 143, '2015-02-01 00:07:36.000000', 'temperatura', 131.0000, 'ºC'),
	(334454, 143, '2015-02-01 00:07:37.000000', 'temperatura', 747.0000, 'ºC'),
	(334455, 143, '2015-02-01 00:07:38.000000', 'temperatura', 942.0000, 'ºC'),
	(334456, 143, '2015-02-01 00:07:39.000000', 'temperatura', 70.0000, 'ºC'),
	(334457, 143, '2015-02-01 00:07:40.000000', 'temperatura', 1126.0000, 'ºC'),
	(334458, 143, '2015-02-01 00:07:41.000000', 'temperatura', 618.0000, 'ºC'),
	(334459, 143, '2015-02-01 00:07:42.000000', 'temperatura', 913.0000, 'ºC'),
	(334460, 143, '2015-02-01 00:07:43.000000', 'temperatura', 310.0000, 'ºC'),
	(334461, 143, '2015-02-01 00:07:44.000000', 'temperatura', 14.0000, 'ºC'),
	(334462, 143, '2015-02-01 00:07:45.000000', 'temperatura', 339.0000, 'ºC'),
	(334463, 143, '2015-02-01 00:07:46.000000', 'temperatura', 455.0000, 'ºC'),
	(334464, 143, '2015-02-01 00:07:47.000000', 'temperatura', 57.0000, 'ºC'),
	(334465, 143, '2015-02-01 00:07:48.000000', 'temperatura', 123.0000, 'ºC'),
	(334466, 143, '2015-02-01 00:07:49.000000', 'temperatura', 443.0000, 'ºC'),
	(334467, 143, '2015-02-01 00:07:50.000000', 'temperatura', 648.0000, 'ºC'),
	(334468, 143, '2015-02-01 00:07:51.000000', 'temperatura', 712.0000, 'ºC'),
	(334469, 143, '2015-02-01 00:07:52.000000', 'temperatura', 415.0000, 'ºC'),
	(334470, 143, '2015-02-01 00:07:53.000000', 'temperatura', 1138.0000, 'ºC'),
	(334471, 143, '2015-02-01 00:07:54.000000', 'temperatura', 848.0000, 'ºC'),
	(334472, 143, '2015-02-01 00:07:55.000000', 'temperatura', 826.0000, 'ºC'),
	(334473, 143, '2015-02-01 00:07:56.000000', 'temperatura', 387.0000, 'ºC'),
	(334474, 143, '2015-02-01 00:07:57.000000', 'temperatura', 658.0000, 'ºC'),
	(334475, 143, '2015-02-01 00:07:58.000000', 'temperatura', 929.0000, 'ºC'),
	(334476, 143, '2015-02-01 00:07:59.000000', 'temperatura', 272.0000, 'ºC'),
	(334477, 143, '2015-02-01 00:08:00.000000', 'temperatura', 972.0000, 'ºC'),
	(334478, 143, '2015-02-01 00:08:01.000000', 'temperatura', 445.0000, 'ºC'),
	(334479, 143, '2015-02-01 00:08:02.000000', 'temperatura', 508.0000, 'ºC'),
	(334480, 143, '2015-02-01 00:08:03.000000', 'temperatura', 5.0000, 'ºC'),
	(334481, 143, '2015-02-01 00:08:04.000000', 'temperatura', 903.0000, 'ºC'),
	(334482, 143, '2015-02-01 00:08:05.000000', 'temperatura', 898.0000, 'ºC'),
	(334483, 143, '2015-02-01 00:08:06.000000', 'temperatura', 585.0000, 'ºC'),
	(334484, 143, '2015-02-01 00:08:07.000000', 'temperatura', 230.0000, 'ºC'),
	(334485, 143, '2015-02-01 00:08:08.000000', 'temperatura', 595.0000, 'ºC'),
	(334486, 143, '2015-02-01 00:08:09.000000', 'temperatura', 1088.0000, 'ºC'),
	(334487, 143, '2015-02-01 00:08:10.000000', 'temperatura', 53.0000, 'ºC'),
	(334488, 143, '2015-02-01 00:08:11.000000', 'temperatura', 604.0000, 'ºC'),
	(334489, 143, '2015-02-01 00:08:12.000000', 'temperatura', 461.0000, 'ºC'),
	(334490, 143, '2015-02-01 00:08:13.000000', 'temperatura', 493.0000, 'ºC'),
	(334491, 143, '2015-02-01 00:08:14.000000', 'temperatura', 1082.0000, 'ºC'),
	(334492, 143, '2015-02-01 00:08:15.000000', 'temperatura', 330.0000, 'ºC'),
	(334493, 143, '2015-02-01 00:08:16.000000', 'temperatura', 806.0000, 'ºC'),
	(334494, 143, '2015-02-01 00:08:17.000000', 'temperatura', 639.0000, 'ºC'),
	(334495, 143, '2015-02-01 00:08:18.000000', 'temperatura', 779.0000, 'ºC'),
	(334496, 143, '2015-02-01 00:08:19.000000', 'temperatura', 776.0000, 'ºC'),
	(334497, 143, '2015-02-01 00:08:20.000000', 'temperatura', 347.0000, 'ºC'),
	(334498, 143, '2015-02-01 00:08:21.000000', 'temperatura', 605.0000, 'ºC'),
	(334499, 143, '2015-02-01 00:08:22.000000', 'temperatura', 784.0000, 'ºC'),
	(334500, 143, '2015-02-01 00:08:23.000000', 'temperatura', 907.0000, 'ºC'),
	(334501, 143, '2015-02-01 00:08:24.000000', 'temperatura', 982.0000, 'ºC'),
	(334502, 143, '2015-02-01 00:08:25.000000', 'temperatura', 990.0000, 'ºC'),
	(334503, 143, '2015-02-01 00:08:26.000000', 'temperatura', 805.0000, 'ºC'),
	(334504, 143, '2015-02-01 00:08:27.000000', 'temperatura', 1055.0000, 'ºC'),
	(334505, 143, '2015-02-01 00:08:28.000000', 'temperatura', 461.0000, 'ºC'),
	(334506, 143, '2015-02-01 00:08:29.000000', 'temperatura', 341.0000, 'ºC'),
	(334507, 143, '2015-02-01 00:08:30.000000', 'temperatura', 324.0000, 'ºC'),
	(334508, 143, '2015-02-01 00:08:31.000000', 'temperatura', 594.0000, 'ºC'),
	(334509, 143, '2015-02-01 00:08:32.000000', 'temperatura', 801.0000, 'ºC'),
	(334510, 143, '2015-02-01 00:08:33.000000', 'temperatura', 1024.0000, 'ºC'),
	(334511, 143, '2015-02-01 00:08:34.000000', 'temperatura', 318.0000, 'ºC'),
	(334512, 143, '2015-02-01 00:08:35.000000', 'temperatura', 919.0000, 'ºC'),
	(334513, 143, '2015-02-01 00:08:36.000000', 'temperatura', 41.0000, 'ºC'),
	(334514, 143, '2015-02-01 00:08:37.000000', 'temperatura', 1050.0000, 'ºC'),
	(334515, 143, '2015-02-01 00:08:38.000000', 'temperatura', 326.0000, 'ºC'),
	(334516, 143, '2015-02-01 00:08:39.000000', 'temperatura', 879.0000, 'ºC'),
	(334517, 143, '2015-02-01 00:08:40.000000', 'temperatura', 1020.0000, 'ºC'),
	(334518, 143, '2015-02-01 00:08:41.000000', 'temperatura', 61.0000, 'ºC'),
	(334519, 143, '2015-02-01 00:08:42.000000', 'temperatura', 847.0000, 'ºC'),
	(334520, 143, '2015-02-01 00:08:43.000000', 'temperatura', 454.0000, 'ºC'),
	(334521, 143, '2015-02-01 00:08:44.000000', 'temperatura', 926.0000, 'ºC'),
	(334522, 143, '2015-02-01 00:08:45.000000', 'temperatura', 871.0000, 'ºC'),
	(334523, 143, '2015-02-01 00:08:46.000000', 'temperatura', 377.0000, 'ºC'),
	(334524, 143, '2015-02-01 00:08:47.000000', 'temperatura', 472.0000, 'ºC'),
	(334525, 143, '2015-02-01 00:08:48.000000', 'temperatura', 29.0000, 'ºC'),
	(334526, 143, '2015-02-01 00:08:49.000000', 'temperatura', 1128.0000, 'ºC'),
	(334527, 143, '2015-02-01 00:08:50.000000', 'temperatura', 757.0000, 'ºC'),
	(334528, 143, '2015-02-01 00:08:51.000000', 'temperatura', 400.0000, 'ºC'),
	(334529, 143, '2015-02-01 00:08:52.000000', 'temperatura', 928.0000, 'ºC'),
	(334530, 143, '2015-02-01 00:08:53.000000', 'temperatura', 1040.0000, 'ºC'),
	(334531, 143, '2015-02-01 00:08:54.000000', 'temperatura', 17.0000, 'ºC'),
	(334532, 143, '2015-02-01 00:08:55.000000', 'temperatura', 566.0000, 'ºC'),
	(334533, 143, '2015-02-01 00:08:56.000000', 'temperatura', 380.0000, 'ºC'),
	(334534, 143, '2015-02-01 00:08:57.000000', 'temperatura', 201.0000, 'ºC'),
	(334535, 143, '2015-02-01 00:08:58.000000', 'temperatura', 1068.0000, 'ºC'),
	(334536, 143, '2015-02-01 00:08:59.000000', 'temperatura', 1136.0000, 'ºC'),
	(334537, 143, '2015-02-01 00:09:00.000000', 'temperatura', 77.0000, 'ºC'),
	(334538, 143, '2015-02-01 00:09:01.000000', 'temperatura', 579.0000, 'ºC'),
	(334539, 143, '2015-02-01 00:09:02.000000', 'temperatura', 262.0000, 'ºC'),
	(334540, 143, '2015-02-01 00:09:03.000000', 'temperatura', 773.0000, 'ºC'),
	(334541, 143, '2015-02-01 00:09:04.000000', 'temperatura', 682.0000, 'ºC'),
	(334542, 143, '2015-02-01 00:09:05.000000', 'temperatura', 1090.0000, 'ºC'),
	(334543, 143, '2015-02-01 00:09:06.000000', 'temperatura', 1005.0000, 'ºC'),
	(334544, 143, '2015-02-01 00:09:07.000000', 'temperatura', 555.0000, 'ºC'),
	(334545, 143, '2015-02-01 00:09:08.000000', 'temperatura', 960.0000, 'ºC'),
	(334546, 143, '2015-02-01 00:09:09.000000', 'temperatura', 736.0000, 'ºC'),
	(334547, 143, '2015-02-01 00:09:10.000000', 'temperatura', 801.0000, 'ºC'),
	(334548, 143, '2015-02-01 00:09:11.000000', 'temperatura', 596.0000, 'ºC'),
	(334549, 143, '2015-02-01 00:09:12.000000', 'temperatura', 579.0000, 'ºC'),
	(334550, 143, '2015-02-01 00:09:13.000000', 'temperatura', 1108.0000, 'ºC'),
	(334551, 143, '2015-02-01 00:09:14.000000', 'temperatura', 202.0000, 'ºC'),
	(334552, 143, '2015-02-01 00:09:15.000000', 'temperatura', 89.0000, 'ºC'),
	(334553, 143, '2015-02-01 00:09:16.000000', 'temperatura', 1037.0000, 'ºC'),
	(334554, 143, '2015-02-01 00:09:17.000000', 'temperatura', 121.0000, 'ºC'),
	(334555, 143, '2015-02-01 00:09:18.000000', 'temperatura', 1095.0000, 'ºC'),
	(334556, 143, '2015-02-01 00:09:19.000000', 'temperatura', 311.0000, 'ºC'),
	(334557, 143, '2015-02-01 00:09:20.000000', 'temperatura', 672.0000, 'ºC'),
	(334558, 143, '2015-02-01 00:09:21.000000', 'temperatura', 25.0000, 'ºC'),
	(334559, 143, '2015-02-01 00:09:22.000000', 'temperatura', 509.0000, 'ºC'),
	(334560, 143, '2015-02-01 00:09:23.000000', 'temperatura', 73.0000, 'ºC'),
	(334561, 143, '2015-02-01 00:09:24.000000', 'temperatura', 38.0000, 'ºC'),
	(334562, 143, '2015-02-01 00:09:25.000000', 'temperatura', 1171.0000, 'ºC'),
	(334563, 143, '2015-02-01 00:09:26.000000', 'temperatura', 941.0000, 'ºC'),
	(334564, 143, '2015-02-01 00:09:27.000000', 'temperatura', 1193.0000, 'ºC'),
	(334565, 143, '2015-02-01 00:09:28.000000', 'temperatura', 743.0000, 'ºC'),
	(334566, 143, '2015-02-01 00:09:29.000000', 'temperatura', 136.0000, 'ºC'),
	(334567, 143, '2015-02-01 00:09:30.000000', 'temperatura', 851.0000, 'ºC'),
	(334568, 143, '2015-02-01 00:09:31.000000', 'temperatura', 246.0000, 'ºC'),
	(334569, 143, '2015-02-01 00:09:32.000000', 'temperatura', 1079.0000, 'ºC'),
	(334570, 143, '2015-02-01 00:09:33.000000', 'temperatura', 1057.0000, 'ºC'),
	(334571, 143, '2015-02-01 00:09:34.000000', 'temperatura', 848.0000, 'ºC'),
	(334572, 143, '2015-02-01 00:09:35.000000', 'temperatura', 1069.0000, 'ºC'),
	(334573, 143, '2015-02-01 00:09:36.000000', 'temperatura', 404.0000, 'ºC'),
	(334574, 143, '2015-02-01 00:09:37.000000', 'temperatura', 10.0000, 'ºC'),
	(334575, 143, '2015-02-01 00:09:38.000000', 'temperatura', 41.0000, 'ºC'),
	(334576, 143, '2015-02-01 00:09:39.000000', 'temperatura', 174.0000, 'ºC'),
	(334577, 143, '2015-02-01 00:09:40.000000', 'temperatura', 747.0000, 'ºC'),
	(334578, 143, '2015-02-01 00:09:41.000000', 'temperatura', 813.0000, 'ºC'),
	(334579, 143, '2015-02-01 00:09:42.000000', 'temperatura', 625.0000, 'ºC'),
	(334580, 143, '2015-02-01 00:09:43.000000', 'temperatura', 689.0000, 'ºC'),
	(334581, 143, '2015-02-01 00:09:44.000000', 'temperatura', 368.0000, 'ºC'),
	(334582, 143, '2015-02-01 00:09:45.000000', 'temperatura', 975.0000, 'ºC'),
	(334583, 143, '2015-02-01 00:09:46.000000', 'temperatura', 172.0000, 'ºC'),
	(334584, 143, '2015-02-01 00:09:47.000000', 'temperatura', 333.0000, 'ºC'),
	(334585, 143, '2015-02-01 00:09:48.000000', 'temperatura', 1150.0000, 'ºC'),
	(334586, 143, '2015-02-01 00:09:49.000000', 'temperatura', 1154.0000, 'ºC'),
	(334587, 143, '2015-02-01 00:09:50.000000', 'temperatura', 1120.0000, 'ºC'),
	(334588, 143, '2015-02-01 00:09:51.000000', 'temperatura', 936.0000, 'ºC'),
	(334589, 143, '2015-02-01 00:09:52.000000', 'temperatura', 122.0000, 'ºC'),
	(334590, 143, '2015-02-01 00:09:53.000000', 'temperatura', 203.0000, 'ºC'),
	(334591, 143, '2015-02-01 00:09:54.000000', 'temperatura', 650.0000, 'ºC'),
	(334592, 143, '2015-02-01 00:09:55.000000', 'temperatura', 240.0000, 'ºC'),
	(334593, 143, '2015-02-01 00:09:56.000000', 'temperatura', 452.0000, 'ºC'),
	(334594, 143, '2015-02-01 00:09:57.000000', 'temperatura', 338.0000, 'ºC'),
	(334595, 143, '2015-02-01 00:09:58.000000', 'temperatura', 335.0000, 'ºC'),
	(334596, 143, '2015-02-01 00:09:59.000000', 'temperatura', 662.0000, 'ºC'),
	(334597, 143, '2015-02-01 00:10:00.000000', 'temperatura', 1107.0000, 'ºC'),
	(334598, 143, '2015-02-01 00:10:01.000000', 'temperatura', 1149.0000, 'ºC'),
	(334599, 143, '2015-02-01 00:10:02.000000', 'temperatura', 24.0000, 'ºC'),
	(334600, 143, '2015-02-01 00:10:03.000000', 'temperatura', 274.0000, 'ºC'),
	(334601, 143, '2015-02-01 00:10:04.000000', 'temperatura', 100.0000, 'ºC'),
	(334602, 143, '2015-02-01 00:10:05.000000', 'temperatura', 876.0000, 'ºC'),
	(334603, 143, '2015-02-01 00:10:06.000000', 'temperatura', 480.0000, 'ºC'),
	(334604, 143, '2015-02-01 00:10:07.000000', 'temperatura', 973.0000, 'ºC'),
	(334605, 143, '2015-02-01 00:10:08.000000', 'temperatura', 1027.0000, 'ºC'),
	(334606, 143, '2015-02-01 00:10:09.000000', 'temperatura', 1015.0000, 'ºC'),
	(334607, 143, '2015-02-01 00:10:10.000000', 'temperatura', 796.0000, 'ºC'),
	(334608, 143, '2015-02-01 00:10:11.000000', 'temperatura', 935.0000, 'ºC'),
	(334609, 143, '2015-02-01 00:10:12.000000', 'temperatura', 1086.0000, 'ºC'),
	(334610, 143, '2015-02-01 00:10:13.000000', 'temperatura', 224.0000, 'ºC'),
	(334611, 143, '2015-02-01 00:10:14.000000', 'temperatura', 266.0000, 'ºC'),
	(334612, 143, '2015-02-01 00:10:15.000000', 'temperatura', 658.0000, 'ºC'),
	(334613, 143, '2015-02-01 00:10:16.000000', 'temperatura', 94.0000, 'ºC'),
	(334614, 143, '2015-02-01 00:10:17.000000', 'temperatura', 893.0000, 'ºC'),
	(334615, 143, '2015-02-01 00:10:18.000000', 'temperatura', 586.0000, 'ºC'),
	(334616, 143, '2015-02-01 00:10:19.000000', 'temperatura', 253.0000, 'ºC'),
	(334617, 143, '2015-02-01 00:10:20.000000', 'temperatura', 705.0000, 'ºC'),
	(334618, 143, '2015-02-01 00:10:21.000000', 'temperatura', 365.0000, 'ºC'),
	(334619, 143, '2015-02-01 00:10:22.000000', 'temperatura', 913.0000, 'ºC'),
	(334620, 143, '2015-02-01 00:10:23.000000', 'temperatura', 1070.0000, 'ºC'),
	(334621, 143, '2015-02-01 00:10:24.000000', 'temperatura', 213.0000, 'ºC'),
	(334622, 143, '2015-02-01 00:10:25.000000', 'temperatura', 254.0000, 'ºC'),
	(334623, 143, '2015-02-01 00:10:26.000000', 'temperatura', 633.0000, 'ºC'),
	(334624, 143, '2015-02-01 00:10:27.000000', 'temperatura', 5.0000, 'ºC'),
	(334625, 143, '2015-02-01 00:10:28.000000', 'temperatura', 524.0000, 'ºC'),
	(334626, 143, '2015-02-01 00:10:29.000000', 'temperatura', 204.0000, 'ºC'),
	(334627, 143, '2015-02-01 00:10:30.000000', 'temperatura', 651.0000, 'ºC'),
	(334628, 143, '2015-02-01 00:10:31.000000', 'temperatura', 244.0000, 'ºC'),
	(334629, 143, '2015-02-01 00:10:32.000000', 'temperatura', 466.0000, 'ºC'),
	(334630, 143, '2015-02-01 00:10:33.000000', 'temperatura', 400.0000, 'ºC'),
	(334631, 143, '2015-02-01 00:10:34.000000', 'temperatura', 603.0000, 'ºC'),
	(334632, 143, '2015-02-01 00:10:35.000000', 'temperatura', 615.0000, 'ºC'),
	(334633, 143, '2015-02-01 00:10:36.000000', 'temperatura', 65.0000, 'ºC'),
	(334634, 143, '2015-02-01 00:10:37.000000', 'temperatura', 881.0000, 'ºC'),
	(334635, 143, '2015-02-01 00:10:38.000000', 'temperatura', 611.0000, 'ºC'),
	(334636, 143, '2015-02-01 00:10:39.000000', 'temperatura', 414.0000, 'ºC'),
	(334637, 143, '2015-02-01 00:10:40.000000', 'temperatura', 238.0000, 'ºC'),
	(334638, 143, '2015-02-01 00:10:41.000000', 'temperatura', 1148.0000, 'ºC'),
	(334639, 143, '2015-02-01 00:10:42.000000', 'temperatura', 226.0000, 'ºC'),
	(334640, 143, '2015-02-01 00:10:43.000000', 'temperatura', 85.0000, 'ºC'),
	(334641, 143, '2015-02-01 00:10:44.000000', 'temperatura', 947.0000, 'ºC'),
	(334642, 143, '2015-02-01 00:10:45.000000', 'temperatura', 883.0000, 'ºC'),
	(334643, 143, '2015-02-01 00:10:46.000000', 'temperatura', 372.0000, 'ºC'),
	(334644, 143, '2015-02-01 00:10:47.000000', 'temperatura', 413.0000, 'ºC'),
	(334645, 143, '2015-02-01 00:10:48.000000', 'temperatura', 951.0000, 'ºC'),
	(334646, 143, '2015-02-01 00:10:49.000000', 'temperatura', 1114.0000, 'ºC'),
	(334647, 143, '2015-02-01 00:10:50.000000', 'temperatura', 319.0000, 'ºC'),
	(334648, 143, '2015-02-01 00:10:51.000000', 'temperatura', 652.0000, 'ºC'),
	(334649, 143, '2015-02-01 00:10:52.000000', 'temperatura', 1102.0000, 'ºC'),
	(334650, 143, '2015-02-01 00:10:53.000000', 'temperatura', 1158.0000, 'ºC'),
	(334651, 143, '2015-02-01 00:10:54.000000', 'temperatura', 83.0000, 'ºC'),
	(334652, 143, '2015-02-01 00:10:55.000000', 'temperatura', 542.0000, 'ºC'),
	(334653, 143, '2015-02-01 00:10:56.000000', 'temperatura', 61.0000, 'ºC'),
	(334654, 143, '2015-02-01 00:10:57.000000', 'temperatura', 1079.0000, 'ºC'),
	(334655, 143, '2015-02-01 00:10:58.000000', 'temperatura', 414.0000, 'ºC'),
	(334656, 143, '2015-02-01 00:10:59.000000', 'temperatura', 32.0000, 'ºC'),
	(334657, 143, '2015-02-01 00:11:00.000000', 'temperatura', 119.0000, 'ºC'),
	(334658, 143, '2015-02-01 00:11:01.000000', 'temperatura', 500.0000, 'ºC'),
	(334659, 143, '2015-02-01 00:11:02.000000', 'temperatura', 942.0000, 'ºC'),
	(334660, 143, '2015-02-01 00:11:03.000000', 'temperatura', 810.0000, 'ºC'),
	(334661, 143, '2015-02-01 00:11:04.000000', 'temperatura', 25.0000, 'ºC'),
	(334662, 143, '2015-02-01 00:11:05.000000', 'temperatura', 96.0000, 'ºC'),
	(334663, 143, '2015-02-01 00:11:06.000000', 'temperatura', 407.0000, 'ºC'),
	(334664, 143, '2015-02-01 00:11:07.000000', 'temperatura', 548.0000, 'ºC'),
	(334665, 143, '2015-02-01 00:11:08.000000', 'temperatura', 318.0000, 'ºC'),
	(334666, 143, '2015-02-01 00:11:09.000000', 'temperatura', 1148.0000, 'ºC'),
	(334667, 143, '2015-02-01 00:11:10.000000', 'temperatura', 1185.0000, 'ºC'),
	(334668, 143, '2015-02-01 00:11:11.000000', 'temperatura', 80.0000, 'ºC'),
	(334669, 143, '2015-02-01 00:11:12.000000', 'temperatura', 449.0000, 'ºC'),
	(334670, 143, '2015-02-01 00:11:13.000000', 'temperatura', 803.0000, 'ºC'),
	(334671, 143, '2015-02-01 00:11:14.000000', 'temperatura', 269.0000, 'ºC'),
	(334672, 143, '2015-02-01 00:11:15.000000', 'temperatura', 135.0000, 'ºC'),
	(334673, 143, '2015-02-01 00:11:16.000000', 'temperatura', 1069.0000, 'ºC'),
	(334674, 143, '2015-02-01 00:11:17.000000', 'temperatura', 142.0000, 'ºC'),
	(334675, 143, '2015-02-01 00:11:18.000000', 'temperatura', 1104.0000, 'ºC'),
	(334676, 143, '2015-02-01 00:11:19.000000', 'temperatura', 292.0000, 'ºC'),
	(334677, 143, '2015-02-01 00:11:20.000000', 'temperatura', 551.0000, 'ºC'),
	(334678, 143, '2015-02-01 00:11:21.000000', 'temperatura', 678.0000, 'ºC'),
	(334679, 143, '2015-02-01 00:11:22.000000', 'temperatura', 540.0000, 'ºC'),
	(334680, 143, '2015-02-01 00:11:23.000000', 'temperatura', 663.0000, 'ºC'),
	(334681, 143, '2015-02-01 00:11:24.000000', 'temperatura', 497.0000, 'ºC'),
	(334682, 143, '2015-02-01 00:11:25.000000', 'temperatura', 497.0000, 'ºC'),
	(334683, 143, '2015-02-01 00:11:26.000000', 'temperatura', 992.0000, 'ºC'),
	(334684, 143, '2015-02-01 00:11:27.000000', 'temperatura', 1072.0000, 'ºC'),
	(334685, 143, '2015-02-01 00:11:28.000000', 'temperatura', 1183.0000, 'ºC'),
	(334686, 143, '2015-02-01 00:11:29.000000', 'temperatura', 300.0000, 'ºC'),
	(334687, 143, '2015-02-01 00:11:30.000000', 'temperatura', 352.0000, 'ºC'),
	(334688, 143, '2015-02-01 00:11:31.000000', 'temperatura', 860.0000, 'ºC'),
	(334689, 143, '2015-02-01 00:11:32.000000', 'temperatura', 844.0000, 'ºC'),
	(334690, 143, '2015-02-01 00:11:33.000000', 'temperatura', 443.0000, 'ºC'),
	(334691, 143, '2015-02-01 00:11:34.000000', 'temperatura', 881.0000, 'ºC'),
	(334692, 143, '2015-02-01 00:11:35.000000', 'temperatura', 678.0000, 'ºC'),
	(334693, 143, '2015-02-01 00:11:36.000000', 'temperatura', 746.0000, 'ºC'),
	(334694, 143, '2015-02-01 00:11:37.000000', 'temperatura', 496.0000, 'ºC'),
	(334695, 143, '2015-02-01 00:11:38.000000', 'temperatura', 245.0000, 'ºC'),
	(334696, 143, '2015-02-01 00:11:39.000000', 'temperatura', 938.0000, 'ºC'),
	(334697, 143, '2015-02-01 00:11:40.000000', 'temperatura', 353.0000, 'ºC'),
	(334698, 143, '2015-02-01 00:11:41.000000', 'temperatura', 153.0000, 'ºC'),
	(334699, 143, '2015-02-01 00:11:42.000000', 'temperatura', 905.0000, 'ºC'),
	(334700, 143, '2015-02-01 00:11:43.000000', 'temperatura', 467.0000, 'ºC'),
	(334701, 143, '2015-02-01 00:11:44.000000', 'temperatura', 820.0000, 'ºC'),
	(334702, 143, '2015-02-01 00:11:45.000000', 'temperatura', 301.0000, 'ºC'),
	(334703, 143, '2015-02-01 00:11:46.000000', 'temperatura', 244.0000, 'ºC'),
	(334704, 143, '2015-02-01 00:11:47.000000', 'temperatura', 318.0000, 'ºC'),
	(334705, 143, '2015-02-01 00:11:48.000000', 'temperatura', 858.0000, 'ºC'),
	(334706, 143, '2015-02-01 00:11:49.000000', 'temperatura', 936.0000, 'ºC'),
	(334707, 143, '2015-02-01 00:11:50.000000', 'temperatura', 908.0000, 'ºC'),
	(334708, 143, '2015-02-01 00:11:51.000000', 'temperatura', 534.0000, 'ºC'),
	(334709, 143, '2015-02-01 00:11:52.000000', 'temperatura', 1143.0000, 'ºC'),
	(334710, 143, '2015-02-01 00:11:53.000000', 'temperatura', 514.0000, 'ºC'),
	(334711, 143, '2015-02-01 00:11:54.000000', 'temperatura', 344.0000, 'ºC'),
	(334712, 143, '2015-02-01 00:11:55.000000', 'temperatura', 177.0000, 'ºC'),
	(334713, 143, '2015-02-01 00:11:56.000000', 'temperatura', 1052.0000, 'ºC'),
	(334714, 143, '2015-02-01 00:11:57.000000', 'temperatura', 1131.0000, 'ºC'),
	(334715, 143, '2015-02-01 00:11:58.000000', 'temperatura', 101.0000, 'ºC'),
	(334716, 143, '2015-02-01 00:11:59.000000', 'temperatura', 710.0000, 'ºC'),
	(334717, 143, '2015-02-01 00:12:00.000000', 'temperatura', 848.0000, 'ºC'),
	(334718, 143, '2015-02-01 00:12:01.000000', 'temperatura', 912.0000, 'ºC'),
	(334719, 143, '2015-02-01 00:12:02.000000', 'temperatura', 817.0000, 'ºC'),
	(334720, 143, '2015-02-01 00:12:03.000000', 'temperatura', 149.0000, 'ºC'),
	(334721, 143, '2015-02-01 00:12:04.000000', 'temperatura', 693.0000, 'ºC'),
	(334722, 143, '2015-02-01 00:12:05.000000', 'temperatura', 619.0000, 'ºC'),
	(334723, 143, '2015-02-01 00:12:06.000000', 'temperatura', 1015.0000, 'ºC'),
	(334724, 143, '2015-02-01 00:12:07.000000', 'temperatura', 820.0000, 'ºC'),
	(334725, 143, '2015-02-01 00:12:08.000000', 'temperatura', 1054.0000, 'ºC'),
	(334726, 143, '2015-02-01 00:12:09.000000', 'temperatura', 411.0000, 'ºC'),
	(334727, 143, '2015-02-01 00:12:10.000000', 'temperatura', 93.0000, 'ºC'),
	(334728, 143, '2015-02-01 00:12:11.000000', 'temperatura', 431.0000, 'ºC'),
	(334729, 143, '2015-02-01 00:12:12.000000', 'temperatura', 678.0000, 'ºC'),
	(334730, 143, '2015-02-01 00:12:13.000000', 'temperatura', 897.0000, 'ºC'),
	(334731, 143, '2015-02-01 00:12:14.000000', 'temperatura', 52.0000, 'ºC'),
	(334732, 143, '2015-02-01 00:12:15.000000', 'temperatura', 1171.0000, 'ºC'),
	(334733, 143, '2015-02-01 00:12:16.000000', 'temperatura', 897.0000, 'ºC'),
	(334734, 143, '2015-02-01 00:12:17.000000', 'temperatura', 975.0000, 'ºC'),
	(334735, 143, '2015-02-01 00:12:18.000000', 'temperatura', 982.0000, 'ºC'),
	(334736, 143, '2015-02-01 00:12:19.000000', 'temperatura', 788.0000, 'ºC'),
	(334737, 143, '2015-02-01 00:12:20.000000', 'temperatura', 994.0000, 'ºC'),
	(334738, 143, '2015-02-01 00:12:21.000000', 'temperatura', 204.0000, 'ºC'),
	(334739, 143, '2015-02-01 00:12:22.000000', 'temperatura', 441.0000, 'ºC'),
	(334740, 143, '2015-02-01 00:12:23.000000', 'temperatura', 392.0000, 'ºC'),
	(334741, 143, '2015-02-01 00:12:24.000000', 'temperatura', 637.0000, 'ºC'),
	(334742, 143, '2015-02-01 00:12:25.000000', 'temperatura', 808.0000, 'ºC'),
	(334743, 143, '2015-02-01 00:12:26.000000', 'temperatura', 932.0000, 'ºC'),
	(334744, 143, '2015-02-01 00:12:27.000000', 'temperatura', 1038.0000, 'ºC'),
	(334745, 143, '2015-02-01 00:12:28.000000', 'temperatura', 1191.0000, 'ºC'),
	(334746, 143, '2015-02-01 00:12:29.000000', 'temperatura', 442.0000, 'ºC'),
	(334747, 143, '2015-02-01 00:12:30.000000', 'temperatura', 1039.0000, 'ºC'),
	(334748, 143, '2015-02-01 00:12:31.000000', 'temperatura', 271.0000, 'ºC'),
	(334749, 143, '2015-02-01 00:12:32.000000', 'temperatura', 636.0000, 'ºC'),
	(334750, 143, '2015-02-01 00:12:33.000000', 'temperatura', 1167.0000, 'ºC'),
	(334751, 143, '2015-02-01 00:12:34.000000', 'temperatura', 330.0000, 'ºC'),
	(334752, 143, '2015-02-01 00:12:35.000000', 'temperatura', 549.0000, 'ºC'),
	(334753, 143, '2015-02-01 00:12:36.000000', 'temperatura', 557.0000, 'ºC'),
	(334754, 143, '2015-02-01 00:12:37.000000', 'temperatura', 1136.0000, 'ºC'),
	(334755, 143, '2015-02-01 00:12:38.000000', 'temperatura', 409.0000, 'ºC'),
	(334756, 143, '2015-02-01 00:12:39.000000', 'temperatura', 1037.0000, 'ºC'),
	(334757, 143, '2015-02-01 00:12:40.000000', 'temperatura', 361.0000, 'ºC'),
	(334758, 143, '2015-02-01 00:12:41.000000', 'temperatura', 1092.0000, 'ºC'),
	(334759, 143, '2015-02-01 00:12:42.000000', 'temperatura', 780.0000, 'ºC'),
	(334760, 143, '2015-02-01 00:12:43.000000', 'temperatura', 625.0000, 'ºC'),
	(334761, 143, '2015-02-01 00:12:44.000000', 'temperatura', 785.0000, 'ºC'),
	(334762, 143, '2015-02-01 00:12:45.000000', 'temperatura', 850.0000, 'ºC'),
	(334763, 143, '2015-02-01 00:12:46.000000', 'temperatura', 695.0000, 'ºC'),
	(334764, 143, '2015-02-01 00:12:47.000000', 'temperatura', 928.0000, 'ºC'),
	(334765, 143, '2015-02-01 00:12:48.000000', 'temperatura', 154.0000, 'ºC'),
	(334766, 143, '2015-02-01 00:12:49.000000', 'temperatura', 386.0000, 'ºC'),
	(334767, 143, '2015-02-01 00:12:50.000000', 'temperatura', 268.0000, 'ºC'),
	(334768, 143, '2015-02-01 00:12:51.000000', 'temperatura', 183.0000, 'ºC'),
	(334769, 143, '2015-02-01 00:12:52.000000', 'temperatura', 112.0000, 'ºC'),
	(334770, 143, '2015-02-01 00:12:53.000000', 'temperatura', 9.0000, 'ºC'),
	(334771, 143, '2015-02-01 00:12:54.000000', 'temperatura', 913.0000, 'ºC'),
	(334772, 143, '2015-02-01 00:12:55.000000', 'temperatura', 937.0000, 'ºC'),
	(334773, 143, '2015-02-01 00:12:56.000000', 'temperatura', 747.0000, 'ºC'),
	(334774, 143, '2015-02-01 00:12:57.000000', 'temperatura', 924.0000, 'ºC'),
	(334775, 143, '2015-02-01 00:12:58.000000', 'temperatura', 1178.0000, 'ºC'),
	(334776, 143, '2015-02-01 00:12:59.000000', 'temperatura', 719.0000, 'ºC'),
	(334777, 143, '2015-02-01 00:13:00.000000', 'temperatura', 62.0000, 'ºC'),
	(334778, 143, '2015-02-01 00:13:01.000000', 'temperatura', 552.0000, 'ºC'),
	(334779, 143, '2015-02-01 00:13:02.000000', 'temperatura', 177.0000, 'ºC'),
	(334780, 143, '2015-02-01 00:13:03.000000', 'temperatura', 427.0000, 'ºC'),
	(334781, 143, '2015-02-01 00:13:04.000000', 'temperatura', 406.0000, 'ºC'),
	(334782, 143, '2015-02-01 00:13:05.000000', 'temperatura', 751.0000, 'ºC'),
	(334783, 143, '2015-02-01 00:13:06.000000', 'temperatura', 135.0000, 'ºC'),
	(334784, 143, '2015-02-01 00:13:07.000000', 'temperatura', 825.0000, 'ºC'),
	(334785, 143, '2015-02-01 00:13:08.000000', 'temperatura', 118.0000, 'ºC'),
	(334786, 143, '2015-02-01 00:13:09.000000', 'temperatura', 515.0000, 'ºC'),
	(334787, 143, '2015-02-01 00:13:10.000000', 'temperatura', 1023.0000, 'ºC'),
	(334788, 143, '2015-02-01 00:13:11.000000', 'temperatura', 1170.0000, 'ºC'),
	(334789, 143, '2015-02-01 00:13:12.000000', 'temperatura', 382.0000, 'ºC'),
	(334790, 143, '2015-02-01 00:13:13.000000', 'temperatura', 802.0000, 'ºC'),
	(334791, 143, '2015-02-01 00:13:14.000000', 'temperatura', 462.0000, 'ºC'),
	(334792, 143, '2015-02-01 00:13:15.000000', 'temperatura', 1106.0000, 'ºC'),
	(334793, 143, '2015-02-01 00:13:16.000000', 'temperatura', 542.0000, 'ºC'),
	(334794, 143, '2015-02-01 00:13:17.000000', 'temperatura', 594.0000, 'ºC'),
	(334795, 143, '2015-02-01 00:13:18.000000', 'temperatura', 145.0000, 'ºC'),
	(334796, 143, '2015-02-01 00:13:19.000000', 'temperatura', 145.0000, 'ºC'),
	(334797, 143, '2015-02-01 00:13:20.000000', 'temperatura', 288.0000, 'ºC'),
	(334798, 143, '2015-02-01 00:13:21.000000', 'temperatura', 1005.0000, 'ºC'),
	(334799, 143, '2015-02-01 00:13:22.000000', 'temperatura', 563.0000, 'ºC'),
	(334800, 143, '2015-02-01 00:13:23.000000', 'temperatura', 1000.0000, 'ºC'),
	(334801, 143, '2015-02-01 00:13:24.000000', 'temperatura', 912.0000, 'ºC'),
	(334802, 143, '2015-02-01 00:13:25.000000', 'temperatura', 358.0000, 'ºC'),
	(334803, 143, '2015-02-01 00:13:26.000000', 'temperatura', 256.0000, 'ºC'),
	(334804, 143, '2015-02-01 00:13:27.000000', 'temperatura', 208.0000, 'ºC'),
	(334805, 143, '2015-02-01 00:13:28.000000', 'temperatura', 272.0000, 'ºC'),
	(334806, 143, '2015-02-01 00:13:29.000000', 'temperatura', 735.0000, 'ºC'),
	(334807, 143, '2015-02-01 00:13:30.000000', 'temperatura', 459.0000, 'ºC'),
	(334808, 143, '2015-02-01 00:13:31.000000', 'temperatura', 93.0000, 'ºC'),
	(334809, 143, '2015-02-01 00:13:32.000000', 'temperatura', 287.0000, 'ºC'),
	(334810, 143, '2015-02-01 00:13:33.000000', 'temperatura', 1159.0000, 'ºC'),
	(334811, 143, '2015-02-01 00:13:34.000000', 'temperatura', 131.0000, 'ºC'),
	(334812, 143, '2015-02-01 00:13:35.000000', 'temperatura', 781.0000, 'ºC'),
	(334813, 143, '2015-02-01 00:13:36.000000', 'temperatura', 1111.0000, 'ºC'),
	(334814, 143, '2015-02-01 00:13:37.000000', 'temperatura', 814.0000, 'ºC'),
	(334815, 143, '2015-02-01 00:13:38.000000', 'temperatura', 738.0000, 'ºC'),
	(334816, 143, '2015-02-01 00:13:39.000000', 'temperatura', 47.0000, 'ºC'),
	(334817, 143, '2015-02-01 00:13:40.000000', 'temperatura', 420.0000, 'ºC'),
	(334818, 143, '2015-02-01 00:13:41.000000', 'temperatura', 762.0000, 'ºC'),
	(334819, 143, '2015-02-01 00:13:42.000000', 'temperatura', 149.0000, 'ºC'),
	(334820, 143, '2015-02-01 00:13:43.000000', 'temperatura', 858.0000, 'ºC'),
	(334821, 143, '2015-02-01 00:13:44.000000', 'temperatura', 245.0000, 'ºC'),
	(334822, 143, '2015-02-01 00:13:45.000000', 'temperatura', 1051.0000, 'ºC'),
	(334823, 143, '2015-02-01 00:13:46.000000', 'temperatura', 919.0000, 'ºC'),
	(334824, 143, '2015-02-01 00:13:47.000000', 'temperatura', 245.0000, 'ºC'),
	(334825, 143, '2015-02-01 00:13:48.000000', 'temperatura', 868.0000, 'ºC'),
	(334826, 143, '2015-02-01 00:13:49.000000', 'temperatura', 5.0000, 'ºC'),
	(334827, 143, '2015-02-01 00:13:50.000000', 'temperatura', 1024.0000, 'ºC'),
	(334828, 143, '2015-02-01 00:13:51.000000', 'temperatura', 302.0000, 'ºC'),
	(334829, 143, '2015-02-01 00:13:52.000000', 'temperatura', 839.0000, 'ºC'),
	(334830, 143, '2015-02-01 00:13:53.000000', 'temperatura', 892.0000, 'ºC'),
	(334831, 143, '2015-02-01 00:13:54.000000', 'temperatura', 740.0000, 'ºC'),
	(334832, 143, '2015-02-01 00:13:55.000000', 'temperatura', 1026.0000, 'ºC'),
	(334833, 143, '2015-02-01 00:13:56.000000', 'temperatura', 511.0000, 'ºC'),
	(334834, 143, '2015-02-01 00:13:57.000000', 'temperatura', 679.0000, 'ºC'),
	(334835, 143, '2015-02-01 00:13:58.000000', 'temperatura', 661.0000, 'ºC'),
	(334836, 143, '2015-02-01 00:13:59.000000', 'temperatura', 68.0000, 'ºC'),
	(334837, 143, '2015-02-01 00:14:00.000000', 'temperatura', 757.0000, 'ºC'),
	(334838, 143, '2015-02-01 00:14:01.000000', 'temperatura', 1183.0000, 'ºC'),
	(334839, 143, '2015-02-01 00:14:02.000000', 'temperatura', 42.0000, 'ºC'),
	(334840, 143, '2015-02-01 00:14:03.000000', 'temperatura', 263.0000, 'ºC'),
	(334841, 143, '2015-02-01 00:14:04.000000', 'temperatura', 1188.0000, 'ºC'),
	(334842, 143, '2015-02-01 00:14:05.000000', 'temperatura', 352.0000, 'ºC'),
	(334843, 143, '2015-02-01 00:14:06.000000', 'temperatura', 595.0000, 'ºC'),
	(334844, 143, '2015-02-01 00:14:07.000000', 'temperatura', 720.0000, 'ºC'),
	(334845, 143, '2015-02-01 00:14:08.000000', 'temperatura', 615.0000, 'ºC'),
	(334846, 143, '2015-02-01 00:14:09.000000', 'temperatura', 918.0000, 'ºC'),
	(334847, 143, '2015-02-01 00:14:10.000000', 'temperatura', 343.0000, 'ºC'),
	(334848, 143, '2015-02-01 00:14:11.000000', 'temperatura', 162.0000, 'ºC'),
	(334849, 143, '2015-02-01 00:14:12.000000', 'temperatura', 982.0000, 'ºC'),
	(334850, 143, '2015-02-01 00:14:13.000000', 'temperatura', 826.0000, 'ºC'),
	(334851, 143, '2015-02-01 00:14:14.000000', 'temperatura', 1185.0000, 'ºC'),
	(334852, 143, '2015-02-01 00:14:15.000000', 'temperatura', 1045.0000, 'ºC'),
	(334853, 143, '2015-02-01 00:14:16.000000', 'temperatura', 472.0000, 'ºC'),
	(334854, 143, '2015-02-01 00:14:17.000000', 'temperatura', 426.0000, 'ºC'),
	(334855, 143, '2015-02-01 00:14:18.000000', 'temperatura', 716.0000, 'ºC'),
	(334856, 143, '2015-02-01 00:14:19.000000', 'temperatura', 1100.0000, 'ºC'),
	(334857, 143, '2015-02-01 00:14:20.000000', 'temperatura', 951.0000, 'ºC'),
	(334858, 143, '2015-02-01 00:14:21.000000', 'temperatura', 258.0000, 'ºC'),
	(334859, 143, '2015-02-01 00:14:22.000000', 'temperatura', 835.0000, 'ºC'),
	(334860, 143, '2015-02-01 00:14:23.000000', 'temperatura', 1005.0000, 'ºC'),
	(334861, 143, '2015-02-01 00:14:24.000000', 'temperatura', 117.0000, 'ºC'),
	(334862, 143, '2015-02-01 00:14:25.000000', 'temperatura', 1174.0000, 'ºC'),
	(334863, 143, '2015-02-01 00:14:26.000000', 'temperatura', 717.0000, 'ºC'),
	(334864, 143, '2015-02-01 00:14:27.000000', 'temperatura', 66.0000, 'ºC'),
	(334865, 143, '2015-02-01 00:14:28.000000', 'temperatura', 578.0000, 'ºC'),
	(334866, 143, '2015-02-01 00:14:29.000000', 'temperatura', 291.0000, 'ºC'),
	(334867, 143, '2015-02-01 00:14:30.000000', 'temperatura', 922.0000, 'ºC'),
	(334868, 143, '2015-02-01 00:14:31.000000', 'temperatura', 137.0000, 'ºC'),
	(334869, 143, '2015-02-01 00:14:32.000000', 'temperatura', 320.0000, 'ºC'),
	(334870, 143, '2015-02-01 00:14:33.000000', 'temperatura', 1188.0000, 'ºC'),
	(334871, 143, '2015-02-01 00:14:34.000000', 'temperatura', 183.0000, 'ºC'),
	(334872, 143, '2015-02-01 00:14:35.000000', 'temperatura', 952.0000, 'ºC'),
	(334873, 143, '2015-02-01 00:14:36.000000', 'temperatura', 613.0000, 'ºC'),
	(334874, 143, '2015-02-01 00:14:37.000000', 'temperatura', 206.0000, 'ºC'),
	(334875, 143, '2015-02-01 00:14:38.000000', 'temperatura', 392.0000, 'ºC'),
	(334876, 143, '2015-02-01 00:14:39.000000', 'temperatura', 143.0000, 'ºC'),
	(334877, 143, '2015-02-01 00:14:40.000000', 'temperatura', 740.0000, 'ºC'),
	(334878, 143, '2015-02-01 00:14:41.000000', 'temperatura', 871.0000, 'ºC'),
	(334879, 143, '2015-02-01 00:14:42.000000', 'temperatura', 937.0000, 'ºC'),
	(334880, 143, '2015-02-01 00:14:43.000000', 'temperatura', 872.0000, 'ºC'),
	(334881, 143, '2015-02-01 00:14:44.000000', 'temperatura', 350.0000, 'ºC'),
	(334882, 143, '2015-02-01 00:14:45.000000', 'temperatura', 332.0000, 'ºC'),
	(334883, 143, '2015-02-01 00:14:46.000000', 'temperatura', 613.0000, 'ºC'),
	(334884, 143, '2015-02-01 00:14:47.000000', 'temperatura', 870.0000, 'ºC'),
	(334885, 143, '2015-02-01 00:14:48.000000', 'temperatura', 112.0000, 'ºC'),
	(334886, 143, '2015-02-01 00:14:49.000000', 'temperatura', 348.0000, 'ºC'),
	(334887, 143, '2015-02-01 00:14:50.000000', 'temperatura', 207.0000, 'ºC'),
	(334888, 143, '2015-02-01 00:14:51.000000', 'temperatura', 1192.0000, 'ºC'),
	(334889, 143, '2015-02-01 00:14:52.000000', 'temperatura', 538.0000, 'ºC'),
	(334890, 143, '2015-02-01 00:14:53.000000', 'temperatura', 313.0000, 'ºC'),
	(334891, 143, '2015-02-01 00:14:54.000000', 'temperatura', 1152.0000, 'ºC'),
	(334892, 143, '2015-02-01 00:14:55.000000', 'temperatura', 24.0000, 'ºC'),
	(334893, 143, '2015-02-01 00:14:56.000000', 'temperatura', 261.0000, 'ºC'),
	(334894, 143, '2015-02-01 00:14:57.000000', 'temperatura', 36.0000, 'ºC'),
	(334895, 143, '2015-02-01 00:14:58.000000', 'temperatura', 598.0000, 'ºC'),
	(334896, 143, '2015-02-01 00:14:59.000000', 'temperatura', 480.0000, 'ºC'),
	(334897, 143, '2015-02-01 00:15:00.000000', 'temperatura', 608.0000, 'ºC'),
	(334898, 143, '2015-02-01 00:15:01.000000', 'temperatura', 399.0000, 'ºC'),
	(334899, 143, '2015-02-01 00:15:02.000000', 'temperatura', 172.0000, 'ºC'),
	(334900, 143, '2015-02-01 00:15:03.000000', 'temperatura', 863.0000, 'ºC'),
	(334901, 143, '2015-02-01 00:15:04.000000', 'temperatura', 200.0000, 'ºC'),
	(334902, 143, '2015-02-01 00:15:05.000000', 'temperatura', 812.0000, 'ºC'),
	(334903, 143, '2015-02-01 00:15:06.000000', 'temperatura', 1058.0000, 'ºC'),
	(334904, 143, '2015-02-01 00:15:07.000000', 'temperatura', 456.0000, 'ºC'),
	(334905, 143, '2015-02-01 00:15:08.000000', 'temperatura', 308.0000, 'ºC'),
	(334906, 143, '2015-02-01 00:15:09.000000', 'temperatura', 172.0000, 'ºC'),
	(334907, 143, '2015-02-01 00:15:10.000000', 'temperatura', 1136.0000, 'ºC'),
	(334908, 143, '2015-02-01 00:15:11.000000', 'temperatura', 365.0000, 'ºC'),
	(334909, 143, '2015-02-01 00:15:12.000000', 'temperatura', 815.0000, 'ºC'),
	(334910, 143, '2015-02-01 00:15:13.000000', 'temperatura', 584.0000, 'ºC'),
	(334911, 143, '2015-02-01 00:15:14.000000', 'temperatura', 473.0000, 'ºC'),
	(334912, 143, '2015-02-01 00:15:15.000000', 'temperatura', 615.0000, 'ºC'),
	(334913, 143, '2015-02-01 00:15:16.000000', 'temperatura', 456.0000, 'ºC'),
	(334914, 143, '2015-02-01 00:15:17.000000', 'temperatura', 437.0000, 'ºC'),
	(334915, 143, '2015-02-01 00:15:18.000000', 'temperatura', 819.0000, 'ºC'),
	(334916, 143, '2015-02-01 00:15:19.000000', 'temperatura', 381.0000, 'ºC'),
	(334917, 143, '2015-02-01 00:15:20.000000', 'temperatura', 649.0000, 'ºC'),
	(334918, 143, '2015-02-01 00:15:21.000000', 'temperatura', 901.0000, 'ºC'),
	(334919, 143, '2015-02-01 00:15:22.000000', 'temperatura', 161.0000, 'ºC'),
	(334920, 143, '2015-02-01 00:15:23.000000', 'temperatura', 500.0000, 'ºC'),
	(334921, 143, '2015-02-01 00:15:24.000000', 'temperatura', 818.0000, 'ºC'),
	(334922, 143, '2015-02-01 00:15:25.000000', 'temperatura', 190.0000, 'ºC'),
	(334923, 143, '2015-02-01 00:15:26.000000', 'temperatura', 896.0000, 'ºC'),
	(334924, 143, '2015-02-01 00:15:27.000000', 'temperatura', 313.0000, 'ºC'),
	(334925, 143, '2015-02-01 00:15:28.000000', 'temperatura', 77.0000, 'ºC'),
	(334926, 143, '2015-02-01 00:15:29.000000', 'temperatura', 647.0000, 'ºC'),
	(334927, 143, '2015-02-01 00:15:30.000000', 'temperatura', 605.0000, 'ºC'),
	(334928, 143, '2015-02-01 00:15:31.000000', 'temperatura', 1082.0000, 'ºC'),
	(334929, 143, '2015-02-01 00:15:32.000000', 'temperatura', 1197.0000, 'ºC'),
	(334930, 143, '2015-02-01 00:15:33.000000', 'temperatura', 338.0000, 'ºC'),
	(334931, 143, '2015-02-01 00:15:34.000000', 'temperatura', 502.0000, 'ºC'),
	(334932, 143, '2015-02-01 00:15:35.000000', 'temperatura', 296.0000, 'ºC'),
	(334933, 143, '2015-02-01 00:15:36.000000', 'temperatura', 1176.0000, 'ºC'),
	(334934, 143, '2015-02-01 00:15:37.000000', 'temperatura', 192.0000, 'ºC'),
	(334935, 143, '2015-02-01 00:15:38.000000', 'temperatura', 1030.0000, 'ºC'),
	(334936, 143, '2015-02-01 00:15:39.000000', 'temperatura', 976.0000, 'ºC'),
	(334937, 143, '2015-02-01 00:15:40.000000', 'temperatura', 591.0000, 'ºC'),
	(334938, 143, '2015-02-01 00:15:41.000000', 'temperatura', 25.0000, 'ºC'),
	(334939, 143, '2015-02-01 00:15:42.000000', 'temperatura', 754.0000, 'ºC'),
	(334940, 143, '2015-02-01 00:15:43.000000', 'temperatura', 96.0000, 'ºC'),
	(334941, 143, '2015-02-01 00:15:44.000000', 'temperatura', 618.0000, 'ºC'),
	(334942, 143, '2015-02-01 00:15:45.000000', 'temperatura', 403.0000, 'ºC'),
	(334943, 143, '2015-02-01 00:15:46.000000', 'temperatura', 162.0000, 'ºC'),
	(334944, 143, '2015-02-01 00:15:47.000000', 'temperatura', 799.0000, 'ºC'),
	(334945, 143, '2015-02-01 00:15:48.000000', 'temperatura', 1110.0000, 'ºC'),
	(334946, 143, '2015-02-01 00:15:49.000000', 'temperatura', 754.0000, 'ºC'),
	(334947, 143, '2015-02-01 00:15:50.000000', 'temperatura', 442.0000, 'ºC'),
	(334948, 143, '2015-02-01 00:15:51.000000', 'temperatura', 1145.0000, 'ºC'),
	(334949, 143, '2015-02-01 00:15:52.000000', 'temperatura', 803.0000, 'ºC'),
	(334950, 143, '2015-02-01 00:15:53.000000', 'temperatura', 581.0000, 'ºC'),
	(334951, 143, '2015-02-01 00:15:54.000000', 'temperatura', 494.0000, 'ºC'),
	(334952, 143, '2015-02-01 00:15:55.000000', 'temperatura', 729.0000, 'ºC'),
	(334953, 143, '2015-02-01 00:15:56.000000', 'temperatura', 965.0000, 'ºC'),
	(334954, 143, '2015-02-01 00:15:57.000000', 'temperatura', 238.0000, 'ºC'),
	(334955, 143, '2015-02-01 00:15:58.000000', 'temperatura', 695.0000, 'ºC'),
	(334956, 143, '2015-02-01 00:15:59.000000', 'temperatura', 363.0000, 'ºC'),
	(334957, 143, '2015-02-01 00:16:00.000000', 'temperatura', 928.0000, 'ºC'),
	(334958, 143, '2015-02-01 00:16:01.000000', 'temperatura', 1152.0000, 'ºC'),
	(334959, 143, '2015-02-01 00:16:02.000000', 'temperatura', 576.0000, 'ºC'),
	(334960, 143, '2015-02-01 00:16:03.000000', 'temperatura', 627.0000, 'ºC'),
	(334961, 143, '2015-02-01 00:16:04.000000', 'temperatura', 205.0000, 'ºC'),
	(334962, 143, '2015-02-01 00:16:05.000000', 'temperatura', 344.0000, 'ºC'),
	(334963, 143, '2015-02-01 00:16:06.000000', 'temperatura', 1108.0000, 'ºC'),
	(334964, 143, '2015-02-01 00:16:07.000000', 'temperatura', 907.0000, 'ºC'),
	(334965, 143, '2015-02-01 00:16:08.000000', 'temperatura', 12.0000, 'ºC'),
	(334966, 143, '2015-02-01 00:16:09.000000', 'temperatura', 941.0000, 'ºC'),
	(334967, 143, '2015-02-01 00:16:10.000000', 'temperatura', 1067.0000, 'ºC'),
	(334968, 143, '2015-02-01 00:16:11.000000', 'temperatura', 115.0000, 'ºC'),
	(334969, 143, '2015-02-01 00:16:12.000000', 'temperatura', 973.0000, 'ºC'),
	(334970, 143, '2015-02-01 00:16:13.000000', 'temperatura', 920.0000, 'ºC'),
	(334971, 143, '2015-02-01 00:16:14.000000', 'temperatura', 483.0000, 'ºC'),
	(334972, 143, '2015-02-01 00:16:15.000000', 'temperatura', 856.0000, 'ºC'),
	(334973, 143, '2015-02-01 00:16:16.000000', 'temperatura', 431.0000, 'ºC'),
	(334974, 143, '2015-02-01 00:16:17.000000', 'temperatura', 787.0000, 'ºC'),
	(334975, 143, '2015-02-01 00:16:18.000000', 'temperatura', 243.0000, 'ºC'),
	(334976, 143, '2015-02-01 00:16:19.000000', 'temperatura', 53.0000, 'ºC'),
	(334977, 143, '2015-02-01 00:16:20.000000', 'temperatura', 739.0000, 'ºC'),
	(334978, 143, '2015-02-01 00:16:21.000000', 'temperatura', 1136.0000, 'ºC'),
	(334979, 143, '2015-02-01 00:16:22.000000', 'temperatura', 1063.0000, 'ºC'),
	(334980, 143, '2015-02-01 00:16:23.000000', 'temperatura', 707.0000, 'ºC'),
	(334981, 143, '2015-02-01 00:16:24.000000', 'temperatura', 348.0000, 'ºC'),
	(334982, 143, '2015-02-01 00:16:25.000000', 'temperatura', 818.0000, 'ºC'),
	(334983, 143, '2015-02-01 00:16:26.000000', 'temperatura', 646.0000, 'ºC'),
	(334984, 143, '2015-02-01 00:16:27.000000', 'temperatura', 776.0000, 'ºC'),
	(334985, 143, '2015-02-01 00:16:28.000000', 'temperatura', 745.0000, 'ºC'),
	(334986, 143, '2015-02-01 00:16:29.000000', 'temperatura', 195.0000, 'ºC'),
	(334987, 143, '2015-02-01 00:16:30.000000', 'temperatura', 1142.0000, 'ºC'),
	(334988, 143, '2015-02-01 00:16:31.000000', 'temperatura', 325.0000, 'ºC'),
	(334989, 143, '2015-02-01 00:16:32.000000', 'temperatura', 599.0000, 'ºC'),
	(334990, 143, '2015-02-01 00:16:33.000000', 'temperatura', 823.0000, 'ºC'),
	(334991, 143, '2015-02-01 00:16:34.000000', 'temperatura', 1116.0000, 'ºC'),
	(334992, 143, '2015-02-01 00:16:35.000000', 'temperatura', 711.0000, 'ºC'),
	(334993, 143, '2015-02-01 00:16:36.000000', 'temperatura', 210.0000, 'ºC'),
	(334994, 143, '2015-02-01 00:16:37.000000', 'temperatura', 115.0000, 'ºC'),
	(334995, 143, '2015-02-01 00:16:38.000000', 'temperatura', 1148.0000, 'ºC'),
	(334996, 143, '2015-02-01 00:16:39.000000', 'temperatura', 594.0000, 'ºC'),
	(334997, 143, '2015-02-01 00:16:40.000000', 'temperatura', 725.0000, 'ºC'),
	(334998, 143, '2015-02-01 00:16:41.000000', 'temperatura', 646.0000, 'ºC'),
	(334999, 143, '2015-02-01 00:16:42.000000', 'temperatura', 1054.0000, 'ºC'),
	(335000, 143, '2015-02-01 00:16:43.000000', 'temperatura', 932.0000, 'ºC'),
	(335001, 143, '2015-02-01 00:16:44.000000', 'temperatura', 300.0000, 'ºC'),
	(335002, 143, '2015-02-01 00:16:45.000000', 'temperatura', 1106.0000, 'ºC'),
	(335003, 143, '2015-02-01 00:16:46.000000', 'temperatura', 1028.0000, 'ºC'),
	(335004, 143, '2015-02-01 00:16:47.000000', 'temperatura', 623.0000, 'ºC'),
	(335005, 143, '2015-02-01 00:16:48.000000', 'temperatura', 30.0000, 'ºC'),
	(335006, 143, '2015-02-01 00:16:49.000000', 'temperatura', 682.0000, 'ºC'),
	(335007, 143, '2015-02-01 00:16:50.000000', 'temperatura', 923.0000, 'ºC'),
	(335008, 143, '2015-02-01 00:16:51.000000', 'temperatura', 168.0000, 'ºC'),
	(335009, 143, '2015-02-01 00:16:52.000000', 'temperatura', 473.0000, 'ºC'),
	(335010, 143, '2015-02-01 00:16:53.000000', 'temperatura', 661.0000, 'ºC'),
	(335011, 143, '2015-02-01 00:16:54.000000', 'temperatura', 685.0000, 'ºC'),
	(335012, 143, '2015-02-01 00:16:55.000000', 'temperatura', 241.0000, 'ºC'),
	(335013, 143, '2015-02-01 00:16:56.000000', 'temperatura', 354.0000, 'ºC'),
	(335014, 143, '2015-02-01 00:16:57.000000', 'temperatura', 1046.0000, 'ºC'),
	(335015, 143, '2015-02-01 00:16:58.000000', 'temperatura', 570.0000, 'ºC'),
	(335016, 143, '2015-02-01 00:16:59.000000', 'temperatura', 911.0000, 'ºC'),
	(335017, 143, '2015-02-01 00:17:00.000000', 'temperatura', 445.0000, 'ºC'),
	(335018, 143, '2015-02-01 00:17:01.000000', 'temperatura', 695.0000, 'ºC'),
	(335019, 143, '2015-02-01 00:17:02.000000', 'temperatura', 938.0000, 'ºC'),
	(335020, 143, '2015-02-01 00:17:03.000000', 'temperatura', 207.0000, 'ºC'),
	(335021, 143, '2015-02-01 00:17:04.000000', 'temperatura', 622.0000, 'ºC'),
	(335022, 143, '2015-02-01 00:17:05.000000', 'temperatura', 90.0000, 'ºC'),
	(335023, 143, '2015-02-01 00:17:06.000000', 'temperatura', 983.0000, 'ºC'),
	(335024, 143, '2015-02-01 00:17:07.000000', 'temperatura', 1044.0000, 'ºC'),
	(335025, 143, '2015-02-01 00:17:08.000000', 'temperatura', 1074.0000, 'ºC'),
	(335026, 143, '2015-02-01 00:17:09.000000', 'temperatura', 1037.0000, 'ºC'),
	(335027, 143, '2015-02-01 00:17:10.000000', 'temperatura', 765.0000, 'ºC'),
	(335028, 143, '2015-02-01 00:17:11.000000', 'temperatura', 715.0000, 'ºC'),
	(335029, 143, '2015-02-01 00:17:12.000000', 'temperatura', 80.0000, 'ºC'),
	(335030, 143, '2015-02-01 00:17:13.000000', 'temperatura', 656.0000, 'ºC'),
	(335031, 143, '2015-02-01 00:17:14.000000', 'temperatura', 639.0000, 'ºC'),
	(335032, 143, '2015-02-01 00:17:15.000000', 'temperatura', 26.0000, 'ºC'),
	(335033, 143, '2015-02-01 00:17:16.000000', 'temperatura', 616.0000, 'ºC'),
	(335034, 143, '2015-02-01 00:17:17.000000', 'temperatura', 602.0000, 'ºC'),
	(335035, 143, '2015-02-01 00:17:18.000000', 'temperatura', 1162.0000, 'ºC'),
	(335036, 143, '2015-02-01 00:17:19.000000', 'temperatura', 406.0000, 'ºC'),
	(335037, 143, '2015-02-01 00:17:20.000000', 'temperatura', 944.0000, 'ºC'),
	(335038, 143, '2015-02-01 00:17:21.000000', 'temperatura', 1103.0000, 'ºC'),
	(335039, 143, '2015-02-01 00:17:22.000000', 'temperatura', 284.0000, 'ºC'),
	(335040, 143, '2015-02-01 00:17:23.000000', 'temperatura', 513.0000, 'ºC'),
	(335041, 143, '2015-02-01 00:17:24.000000', 'temperatura', 511.0000, 'ºC'),
	(335042, 143, '2015-02-01 00:17:25.000000', 'temperatura', 1017.0000, 'ºC'),
	(335043, 143, '2015-02-01 00:17:26.000000', 'temperatura', 1151.0000, 'ºC'),
	(335044, 143, '2015-02-01 00:17:27.000000', 'temperatura', 305.0000, 'ºC'),
	(335045, 143, '2015-02-01 00:17:28.000000', 'temperatura', 471.0000, 'ºC'),
	(335046, 143, '2015-02-01 00:17:29.000000', 'temperatura', 241.0000, 'ºC'),
	(335047, 143, '2015-02-01 00:17:30.000000', 'temperatura', 995.0000, 'ºC'),
	(335048, 143, '2015-02-01 00:17:31.000000', 'temperatura', 651.0000, 'ºC'),
	(335049, 143, '2015-02-01 00:17:32.000000', 'temperatura', 269.0000, 'ºC'),
	(335050, 143, '2015-02-01 00:17:33.000000', 'temperatura', 592.0000, 'ºC'),
	(335051, 143, '2015-02-01 00:17:34.000000', 'temperatura', 956.0000, 'ºC'),
	(335052, 143, '2015-02-01 00:17:35.000000', 'temperatura', 605.0000, 'ºC'),
	(335053, 143, '2015-02-01 00:17:36.000000', 'temperatura', 159.0000, 'ºC'),
	(335054, 143, '2015-02-01 00:17:37.000000', 'temperatura', 177.0000, 'ºC'),
	(335055, 143, '2015-02-01 00:17:38.000000', 'temperatura', 408.0000, 'ºC'),
	(335056, 143, '2015-02-01 00:17:39.000000', 'temperatura', 313.0000, 'ºC'),
	(335057, 143, '2015-02-01 00:17:40.000000', 'temperatura', 338.0000, 'ºC'),
	(335058, 143, '2015-02-01 00:17:41.000000', 'temperatura', 755.0000, 'ºC'),
	(335059, 143, '2015-02-01 00:17:42.000000', 'temperatura', 360.0000, 'ºC'),
	(335060, 143, '2015-02-01 00:17:43.000000', 'temperatura', 735.0000, 'ºC'),
	(335061, 143, '2015-02-01 00:17:44.000000', 'temperatura', 195.0000, 'ºC'),
	(335062, 143, '2015-02-01 00:17:45.000000', 'temperatura', 1172.0000, 'ºC'),
	(335063, 143, '2015-02-01 00:17:46.000000', 'temperatura', 473.0000, 'ºC'),
	(335064, 143, '2015-02-01 00:17:47.000000', 'temperatura', 51.0000, 'ºC'),
	(335065, 143, '2015-02-01 00:17:48.000000', 'temperatura', 37.0000, 'ºC'),
	(335066, 143, '2015-02-01 00:17:49.000000', 'temperatura', 31.0000, 'ºC'),
	(335067, 143, '2015-02-01 00:17:50.000000', 'temperatura', 44.0000, 'ºC'),
	(335068, 143, '2015-02-01 00:17:51.000000', 'temperatura', 129.0000, 'ºC'),
	(335069, 143, '2015-02-01 00:17:52.000000', 'temperatura', 512.0000, 'ºC'),
	(335070, 143, '2015-02-01 00:17:53.000000', 'temperatura', 976.0000, 'ºC'),
	(335071, 143, '2015-02-01 00:17:54.000000', 'temperatura', 944.0000, 'ºC'),
	(335072, 143, '2015-02-01 00:17:55.000000', 'temperatura', 594.0000, 'ºC'),
	(335073, 143, '2015-02-01 00:17:56.000000', 'temperatura', 135.0000, 'ºC'),
	(335074, 143, '2015-02-01 00:17:57.000000', 'temperatura', 95.0000, 'ºC'),
	(335075, 143, '2015-02-01 00:17:58.000000', 'temperatura', 71.0000, 'ºC'),
	(335076, 143, '2015-02-01 00:17:59.000000', 'temperatura', 71.0000, 'ºC'),
	(335077, 143, '2015-02-01 00:18:00.000000', 'temperatura', 142.0000, 'ºC'),
	(335078, 143, '2015-02-01 00:18:01.000000', 'temperatura', 498.0000, 'ºC'),
	(335079, 143, '2015-02-01 00:18:02.000000', 'temperatura', 865.0000, 'ºC'),
	(335080, 143, '2015-02-01 00:18:03.000000', 'temperatura', 429.0000, 'ºC'),
	(335081, 143, '2015-02-01 00:18:04.000000', 'temperatura', 753.0000, 'ºC'),
	(335082, 143, '2015-02-01 00:18:05.000000', 'temperatura', 77.0000, 'ºC'),
	(335083, 143, '2015-02-01 00:18:06.000000', 'temperatura', 528.0000, 'ºC'),
	(335084, 143, '2015-02-01 00:18:07.000000', 'temperatura', 8.0000, 'ºC'),
	(335085, 143, '2015-02-01 00:18:08.000000', 'temperatura', 857.0000, 'ºC'),
	(335086, 143, '2015-02-01 00:18:09.000000', 'temperatura', 660.0000, 'ºC'),
	(335087, 143, '2015-02-01 00:18:10.000000', 'temperatura', 733.0000, 'ºC'),
	(335088, 143, '2015-02-01 00:18:11.000000', 'temperatura', 482.0000, 'ºC'),
	(335089, 143, '2015-02-01 00:18:12.000000', 'temperatura', 214.0000, 'ºC'),
	(335090, 143, '2015-02-01 00:18:13.000000', 'temperatura', 823.0000, 'ºC'),
	(335091, 143, '2015-02-01 00:18:14.000000', 'temperatura', 1076.0000, 'ºC'),
	(335092, 143, '2015-02-01 00:18:15.000000', 'temperatura', 508.0000, 'ºC'),
	(335093, 143, '2015-02-01 00:18:16.000000', 'temperatura', 514.0000, 'ºC'),
	(335094, 143, '2015-02-01 00:18:17.000000', 'temperatura', 1045.0000, 'ºC'),
	(335095, 143, '2015-02-01 00:18:18.000000', 'temperatura', 83.0000, 'ºC'),
	(335096, 143, '2015-02-01 00:18:19.000000', 'temperatura', 883.0000, 'ºC'),
	(335097, 143, '2015-02-01 00:18:20.000000', 'temperatura', 567.0000, 'ºC'),
	(335098, 143, '2015-02-01 00:18:21.000000', 'temperatura', 186.0000, 'ºC'),
	(335099, 143, '2015-02-01 00:18:22.000000', 'temperatura', 430.0000, 'ºC'),
	(335100, 143, '2015-02-01 00:18:23.000000', 'temperatura', 391.0000, 'ºC'),
	(335101, 143, '2015-02-01 00:18:24.000000', 'temperatura', 666.0000, 'ºC'),
	(335102, 143, '2015-02-01 00:18:25.000000', 'temperatura', 956.0000, 'ºC'),
	(335103, 143, '2015-02-01 00:18:26.000000', 'temperatura', 385.0000, 'ºC'),
	(335104, 143, '2015-02-01 00:18:27.000000', 'temperatura', 257.0000, 'ºC'),
	(335105, 143, '2015-02-01 00:18:28.000000', 'temperatura', 130.0000, 'ºC'),
	(335106, 143, '2015-02-01 00:18:29.000000', 'temperatura', 1078.0000, 'ºC'),
	(335107, 143, '2015-02-01 00:18:30.000000', 'temperatura', 203.0000, 'ºC'),
	(335108, 143, '2015-02-01 00:18:31.000000', 'temperatura', 182.0000, 'ºC'),
	(335109, 143, '2015-02-01 00:18:32.000000', 'temperatura', 301.0000, 'ºC'),
	(335110, 143, '2015-02-01 00:18:33.000000', 'temperatura', 961.0000, 'ºC'),
	(335111, 143, '2015-02-01 00:18:34.000000', 'temperatura', 301.0000, 'ºC'),
	(335112, 143, '2015-02-01 00:18:35.000000', 'temperatura', 1022.0000, 'ºC'),
	(335113, 143, '2015-02-01 00:18:36.000000', 'temperatura', 607.0000, 'ºC'),
	(335114, 143, '2015-02-01 00:18:37.000000', 'temperatura', 1171.0000, 'ºC'),
	(335115, 143, '2015-02-01 00:18:38.000000', 'temperatura', 432.0000, 'ºC'),
	(335116, 143, '2015-02-01 00:18:39.000000', 'temperatura', 1049.0000, 'ºC'),
	(335117, 143, '2015-02-01 00:18:40.000000', 'temperatura', 348.0000, 'ºC'),
	(335118, 143, '2015-02-01 00:18:41.000000', 'temperatura', 993.0000, 'ºC'),
	(335119, 143, '2015-02-01 00:18:42.000000', 'temperatura', 325.0000, 'ºC'),
	(335120, 143, '2015-02-01 00:18:43.000000', 'temperatura', 1043.0000, 'ºC'),
	(335121, 143, '2015-02-01 00:18:44.000000', 'temperatura', 642.0000, 'ºC'),
	(335122, 143, '2015-02-01 00:18:45.000000', 'temperatura', 81.0000, 'ºC'),
	(335123, 143, '2015-02-01 00:18:46.000000', 'temperatura', 880.0000, 'ºC'),
	(335124, 143, '2015-02-01 00:18:47.000000', 'temperatura', 557.0000, 'ºC'),
	(335125, 143, '2015-02-01 00:18:48.000000', 'temperatura', 148.0000, 'ºC'),
	(335126, 143, '2015-02-01 00:18:49.000000', 'temperatura', 267.0000, 'ºC'),
	(335127, 143, '2015-02-01 00:18:50.000000', 'temperatura', 891.0000, 'ºC'),
	(335128, 143, '2015-02-01 00:18:51.000000', 'temperatura', 54.0000, 'ºC'),
	(335129, 143, '2015-02-01 00:18:52.000000', 'temperatura', 0.0000, 'ºC'),
	(335130, 143, '2015-02-01 00:18:53.000000', 'temperatura', 1037.0000, 'ºC'),
	(335131, 143, '2015-02-01 00:18:54.000000', 'temperatura', 388.0000, 'ºC'),
	(335132, 143, '2015-02-01 00:18:55.000000', 'temperatura', 27.0000, 'ºC'),
	(335133, 143, '2015-02-01 00:18:56.000000', 'temperatura', 173.0000, 'ºC'),
	(335134, 143, '2015-02-01 00:18:57.000000', 'temperatura', 783.0000, 'ºC'),
	(335135, 143, '2015-02-01 00:18:58.000000', 'temperatura', 998.0000, 'ºC'),
	(335136, 143, '2015-02-01 00:18:59.000000', 'temperatura', 243.0000, 'ºC'),
	(335137, 143, '2015-02-01 00:19:00.000000', 'temperatura', 619.0000, 'ºC'),
	(335138, 143, '2015-02-01 00:19:01.000000', 'temperatura', 1166.0000, 'ºC'),
	(335139, 143, '2015-02-01 00:19:02.000000', 'temperatura', 376.0000, 'ºC'),
	(335140, 143, '2015-02-01 00:19:03.000000', 'temperatura', 782.0000, 'ºC'),
	(335141, 143, '2015-02-01 00:19:04.000000', 'temperatura', 383.0000, 'ºC'),
	(335142, 143, '2015-02-01 00:19:05.000000', 'temperatura', 767.0000, 'ºC'),
	(335143, 143, '2015-02-01 00:19:06.000000', 'temperatura', 288.0000, 'ºC'),
	(335144, 143, '2015-02-01 00:19:07.000000', 'temperatura', 339.0000, 'ºC'),
	(335145, 143, '2015-02-01 00:19:08.000000', 'temperatura', 834.0000, 'ºC'),
	(335146, 143, '2015-02-01 00:19:09.000000', 'temperatura', 751.0000, 'ºC'),
	(335147, 143, '2015-02-01 00:19:10.000000', 'temperatura', 55.0000, 'ºC'),
	(335148, 143, '2015-02-01 00:19:11.000000', 'temperatura', 423.0000, 'ºC'),
	(335149, 143, '2015-02-01 00:19:12.000000', 'temperatura', 748.0000, 'ºC'),
	(335150, 143, '2015-02-01 00:19:13.000000', 'temperatura', 75.0000, 'ºC'),
	(335151, 143, '2015-02-01 00:19:14.000000', 'temperatura', 529.0000, 'ºC'),
	(335152, 143, '2015-02-01 00:19:15.000000', 'temperatura', 22.0000, 'ºC'),
	(335153, 143, '2015-02-01 00:19:16.000000', 'temperatura', 923.0000, 'ºC'),
	(335154, 143, '2015-02-01 00:19:17.000000', 'temperatura', 949.0000, 'ºC'),
	(335155, 143, '2015-02-01 00:19:18.000000', 'temperatura', 778.0000, 'ºC'),
	(335156, 143, '2015-02-01 00:19:19.000000', 'temperatura', 1043.0000, 'ºC'),
	(335157, 143, '2015-02-01 00:19:20.000000', 'temperatura', 482.0000, 'ºC'),
	(335158, 143, '2015-02-01 00:19:21.000000', 'temperatura', 480.0000, 'ºC'),
	(335159, 143, '2015-02-01 00:19:22.000000', 'temperatura', 957.0000, 'ºC'),
	(335160, 143, '2015-02-01 00:19:23.000000', 'temperatura', 943.0000, 'ºC'),
	(335161, 143, '2015-02-01 00:19:24.000000', 'temperatura', 647.0000, 'ºC'),
	(335162, 143, '2015-02-01 00:19:25.000000', 'temperatura', 405.0000, 'ºC'),
	(335163, 143, '2015-02-01 00:19:26.000000', 'temperatura', 83.0000, 'ºC'),
	(335164, 143, '2015-02-01 00:19:27.000000', 'temperatura', 404.0000, 'ºC'),
	(335165, 143, '2015-02-01 00:19:28.000000', 'temperatura', 569.0000, 'ºC'),
	(335166, 143, '2015-02-01 00:19:29.000000', 'temperatura', 435.0000, 'ºC'),
	(335167, 143, '2015-02-01 00:19:30.000000', 'temperatura', 467.0000, 'ºC'),
	(335168, 143, '2015-02-01 00:19:31.000000', 'temperatura', 1031.0000, 'ºC'),
	(335169, 143, '2015-02-01 00:19:32.000000', 'temperatura', 154.0000, 'ºC'),
	(335170, 143, '2015-02-01 00:19:33.000000', 'temperatura', 76.0000, 'ºC'),
	(335171, 143, '2015-02-01 00:19:34.000000', 'temperatura', 1121.0000, 'ºC'),
	(335172, 143, '2015-02-01 00:19:35.000000', 'temperatura', 577.0000, 'ºC'),
	(335173, 143, '2015-02-01 00:19:36.000000', 'temperatura', 723.0000, 'ºC'),
	(335174, 143, '2015-02-01 00:19:37.000000', 'temperatura', 685.0000, 'ºC'),
	(335175, 143, '2015-02-01 00:19:38.000000', 'temperatura', 54.0000, 'ºC'),
	(335176, 143, '2015-02-01 00:19:39.000000', 'temperatura', 617.0000, 'ºC'),
	(335177, 143, '2015-02-01 00:19:40.000000', 'temperatura', 523.0000, 'ºC'),
	(335178, 143, '2015-02-01 00:19:41.000000', 'temperatura', 766.0000, 'ºC'),
	(335179, 143, '2015-02-01 00:19:42.000000', 'temperatura', 1061.0000, 'ºC'),
	(335180, 143, '2015-02-01 00:19:43.000000', 'temperatura', 607.0000, 'ºC'),
	(335181, 143, '2015-02-01 00:19:44.000000', 'temperatura', 1052.0000, 'ºC'),
	(335182, 143, '2015-02-01 00:19:45.000000', 'temperatura', 1040.0000, 'ºC'),
	(335183, 143, '2015-02-01 00:19:46.000000', 'temperatura', 845.0000, 'ºC'),
	(335184, 143, '2015-02-01 00:19:47.000000', 'temperatura', 1105.0000, 'ºC'),
	(335185, 143, '2015-02-01 00:19:48.000000', 'temperatura', 592.0000, 'ºC'),
	(335186, 143, '2015-02-01 00:19:49.000000', 'temperatura', 845.0000, 'ºC'),
	(335187, 143, '2015-02-01 00:19:50.000000', 'temperatura', 50.0000, 'ºC'),
	(335188, 143, '2015-02-01 00:19:51.000000', 'temperatura', 114.0000, 'ºC'),
	(335189, 143, '2015-02-01 00:19:52.000000', 'temperatura', 422.0000, 'ºC'),
	(335190, 143, '2015-02-01 00:19:53.000000', 'temperatura', 568.0000, 'ºC'),
	(335191, 143, '2015-02-01 00:19:54.000000', 'temperatura', 375.0000, 'ºC'),
	(335192, 143, '2015-02-01 00:19:55.000000', 'temperatura', 172.0000, 'ºC'),
	(335193, 143, '2015-02-01 00:19:56.000000', 'temperatura', 935.0000, 'ºC'),
	(335194, 143, '2015-02-01 00:19:57.000000', 'temperatura', 561.0000, 'ºC'),
	(335195, 143, '2015-02-01 00:19:58.000000', 'temperatura', 1.0000, 'ºC'),
	(335196, 143, '2015-02-01 00:19:59.000000', 'temperatura', 720.0000, 'ºC'),
	(335197, 143, '2015-02-01 00:20:00.000000', 'temperatura', 0.0000, 'ºC'),
	(335198, 143, '2015-02-01 00:20:01.000000', 'temperatura', 240.0000, 'ºC'),
	(335199, 143, '2015-02-01 00:20:02.000000', 'temperatura', 1198.0000, 'ºC'),
	(335200, 143, '2015-02-01 00:20:03.000000', 'temperatura', 472.0000, 'ºC'),
	(335201, 143, '2015-02-01 00:20:04.000000', 'temperatura', 1169.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(335202, 143, '2015-02-01 00:20:05.000000', 'temperatura', 826.0000, 'ºC'),
	(335203, 143, '2015-02-01 00:20:06.000000', 'temperatura', 624.0000, 'ºC'),
	(335204, 143, '2015-02-01 00:20:07.000000', 'temperatura', 643.0000, 'ºC'),
	(335205, 143, '2015-02-01 00:20:08.000000', 'temperatura', 143.0000, 'ºC'),
	(335206, 143, '2015-02-01 00:20:09.000000', 'temperatura', 1185.0000, 'ºC'),
	(335207, 143, '2015-02-01 00:20:10.000000', 'temperatura', 699.0000, 'ºC'),
	(335208, 143, '2015-02-01 00:20:11.000000', 'temperatura', 1140.0000, 'ºC'),
	(335209, 143, '2015-02-01 00:20:12.000000', 'temperatura', 5.0000, 'ºC'),
	(335210, 143, '2015-02-01 00:20:13.000000', 'temperatura', 203.0000, 'ºC'),
	(335211, 143, '2015-02-01 00:20:14.000000', 'temperatura', 1003.0000, 'ºC'),
	(335212, 143, '2015-02-01 00:20:15.000000', 'temperatura', 807.0000, 'ºC'),
	(335213, 143, '2015-02-01 00:20:16.000000', 'temperatura', 1027.0000, 'ºC'),
	(335214, 143, '2015-02-01 00:20:17.000000', 'temperatura', 311.0000, 'ºC'),
	(335215, 143, '2015-02-01 00:20:18.000000', 'temperatura', 878.0000, 'ºC'),
	(335216, 143, '2015-02-01 00:20:19.000000', 'temperatura', 1056.0000, 'ºC'),
	(335217, 143, '2015-02-01 00:20:20.000000', 'temperatura', 246.0000, 'ºC'),
	(335218, 143, '2015-02-01 00:20:21.000000', 'temperatura', 461.0000, 'ºC'),
	(335219, 143, '2015-02-01 00:20:22.000000', 'temperatura', 370.0000, 'ºC'),
	(335220, 143, '2015-02-01 00:20:23.000000', 'temperatura', 465.0000, 'ºC'),
	(335221, 143, '2015-02-01 00:20:24.000000', 'temperatura', 18.0000, 'ºC'),
	(335222, 143, '2015-02-01 00:20:25.000000', 'temperatura', 1097.0000, 'ºC'),
	(335223, 143, '2015-02-01 00:20:26.000000', 'temperatura', 628.0000, 'ºC'),
	(335224, 143, '2015-02-01 00:20:27.000000', 'temperatura', 1049.0000, 'ºC'),
	(335225, 143, '2015-02-01 00:20:28.000000', 'temperatura', 964.0000, 'ºC'),
	(335226, 143, '2015-02-01 00:20:29.000000', 'temperatura', 473.0000, 'ºC'),
	(335227, 143, '2015-02-01 00:20:30.000000', 'temperatura', 675.0000, 'ºC'),
	(335228, 143, '2015-02-01 00:20:31.000000', 'temperatura', 754.0000, 'ºC'),
	(335229, 143, '2015-02-01 00:20:32.000000', 'temperatura', 544.0000, 'ºC'),
	(335230, 143, '2015-02-01 00:20:33.000000', 'temperatura', 462.0000, 'ºC'),
	(335231, 143, '2015-02-01 00:20:34.000000', 'temperatura', 677.0000, 'ºC'),
	(335232, 143, '2015-02-01 00:20:35.000000', 'temperatura', 799.0000, 'ºC'),
	(335233, 143, '2015-02-01 00:20:36.000000', 'temperatura', 765.0000, 'ºC'),
	(335234, 143, '2015-02-01 00:20:37.000000', 'temperatura', 228.0000, 'ºC'),
	(335235, 143, '2015-02-01 00:20:38.000000', 'temperatura', 44.0000, 'ºC'),
	(335236, 143, '2015-02-01 00:20:39.000000', 'temperatura', 737.0000, 'ºC'),
	(335237, 143, '2015-02-01 00:20:40.000000', 'temperatura', 1156.0000, 'ºC'),
	(335238, 143, '2015-02-01 00:20:41.000000', 'temperatura', 1168.0000, 'ºC'),
	(335239, 143, '2015-02-01 00:20:42.000000', 'temperatura', 1175.0000, 'ºC'),
	(335240, 143, '2015-02-01 00:20:43.000000', 'temperatura', 1168.0000, 'ºC'),
	(335241, 143, '2015-02-01 00:20:44.000000', 'temperatura', 1115.0000, 'ºC'),
	(335242, 143, '2015-02-01 00:20:45.000000', 'temperatura', 874.0000, 'ºC'),
	(335243, 143, '2015-02-01 00:20:46.000000', 'temperatura', 1026.0000, 'ºC'),
	(335244, 143, '2015-02-01 00:20:47.000000', 'temperatura', 107.0000, 'ºC'),
	(335245, 143, '2015-02-01 00:20:48.000000', 'temperatura', 1058.0000, 'ºC'),
	(335246, 143, '2015-02-01 00:20:49.000000', 'temperatura', 167.0000, 'ºC'),
	(335247, 143, '2015-02-01 00:20:50.000000', 'temperatura', 65.0000, 'ºC'),
	(335248, 143, '2015-02-01 00:20:51.000000', 'temperatura', 1021.0000, 'ºC'),
	(335249, 143, '2015-02-01 00:20:52.000000', 'temperatura', 113.0000, 'ºC'),
	(335250, 143, '2015-02-01 00:20:53.000000', 'temperatura', 1102.0000, 'ºC'),
	(335251, 143, '2015-02-01 00:20:54.000000', 'temperatura', 369.0000, 'ºC'),
	(335252, 143, '2015-02-01 00:20:55.000000', 'temperatura', 943.0000, 'ºC'),
	(335253, 143, '2015-02-01 00:20:56.000000', 'temperatura', 8.0000, 'ºC'),
	(335254, 143, '2015-02-01 00:20:57.000000', 'temperatura', 812.0000, 'ºC'),
	(335255, 143, '2015-02-01 00:20:58.000000', 'temperatura', 435.0000, 'ºC'),
	(335256, 143, '2015-02-01 00:20:59.000000', 'temperatura', 940.0000, 'ºC'),
	(335257, 143, '2015-02-01 00:21:00.000000', 'temperatura', 998.0000, 'ºC'),
	(335258, 143, '2015-02-01 00:21:01.000000', 'temperatura', 967.0000, 'ºC'),
	(335259, 143, '2015-02-01 00:21:02.000000', 'temperatura', 643.0000, 'ºC'),
	(335260, 143, '2015-02-01 00:21:03.000000', 'temperatura', 313.0000, 'ºC'),
	(335261, 143, '2015-02-01 00:21:04.000000', 'temperatura', 836.0000, 'ºC'),
	(335262, 143, '2015-02-01 00:21:05.000000', 'temperatura', 841.0000, 'ºC'),
	(335263, 143, '2015-02-01 00:21:06.000000', 'temperatura', 499.0000, 'ºC'),
	(335264, 143, '2015-02-01 00:21:07.000000', 'temperatura', 1172.0000, 'ºC'),
	(335265, 143, '2015-02-01 00:21:08.000000', 'temperatura', 763.0000, 'ºC'),
	(335266, 143, '2015-02-01 00:21:09.000000', 'temperatura', 302.0000, 'ºC'),
	(335267, 143, '2015-02-01 00:21:10.000000', 'temperatura', 420.0000, 'ºC'),
	(335268, 143, '2015-02-01 00:21:11.000000', 'temperatura', 1196.0000, 'ºC'),
	(335269, 143, '2015-02-01 00:21:12.000000', 'temperatura', 1119.0000, 'ºC'),
	(335270, 143, '2015-02-01 00:21:13.000000', 'temperatura', 808.0000, 'ºC'),
	(335271, 143, '2015-02-01 00:21:14.000000', 'temperatura', 684.0000, 'ºC'),
	(335272, 143, '2015-02-01 00:21:15.000000', 'temperatura', 996.0000, 'ºC'),
	(335273, 143, '2015-02-01 00:21:16.000000', 'temperatura', 529.0000, 'ºC'),
	(335274, 143, '2015-02-01 00:21:17.000000', 'temperatura', 859.0000, 'ºC'),
	(335275, 143, '2015-02-01 00:21:18.000000', 'temperatura', 307.0000, 'ºC'),
	(335276, 143, '2015-02-01 00:21:19.000000', 'temperatura', 160.0000, 'ºC'),
	(335277, 143, '2015-02-01 00:21:20.000000', 'temperatura', 1080.0000, 'ºC'),
	(335278, 143, '2015-02-01 00:21:21.000000', 'temperatura', 121.0000, 'ºC'),
	(335279, 143, '2015-02-01 00:21:22.000000', 'temperatura', 965.0000, 'ºC'),
	(335280, 143, '2015-02-01 00:21:23.000000', 'temperatura', 861.0000, 'ºC'),
	(335281, 143, '2015-02-01 00:21:24.000000', 'temperatura', 212.0000, 'ºC'),
	(335282, 143, '2015-02-01 00:21:25.000000', 'temperatura', 875.0000, 'ºC'),
	(335283, 143, '2015-02-01 00:21:26.000000', 'temperatura', 142.0000, 'ºC'),
	(335284, 143, '2015-02-01 00:21:27.000000', 'temperatura', 483.0000, 'ºC'),
	(335285, 143, '2015-02-01 00:21:28.000000', 'temperatura', 792.0000, 'ºC'),
	(335286, 143, '2015-02-01 00:21:29.000000', 'temperatura', 112.0000, 'ºC'),
	(335287, 143, '2015-02-01 00:21:30.000000', 'temperatura', 582.0000, 'ºC'),
	(335288, 143, '2015-02-01 00:21:31.000000', 'temperatura', 175.0000, 'ºC'),
	(335289, 143, '2015-02-01 00:21:32.000000', 'temperatura', 330.0000, 'ºC'),
	(335290, 143, '2015-02-01 00:21:33.000000', 'temperatura', 1126.0000, 'ºC'),
	(335291, 143, '2015-02-01 00:21:34.000000', 'temperatura', 1039.0000, 'ºC'),
	(335292, 143, '2015-02-01 00:21:35.000000', 'temperatura', 619.0000, 'ºC'),
	(335293, 143, '2015-02-01 00:21:36.000000', 'temperatura', 1178.0000, 'ºC'),
	(335294, 143, '2015-02-01 00:21:37.000000', 'temperatura', 433.0000, 'ºC'),
	(335295, 143, '2015-02-01 00:21:38.000000', 'temperatura', 1033.0000, 'ºC'),
	(335296, 143, '2015-02-01 00:21:39.000000', 'temperatura', 265.0000, 'ºC'),
	(335297, 143, '2015-02-01 00:21:40.000000', 'temperatura', 628.0000, 'ºC'),
	(335298, 143, '2015-02-01 00:21:41.000000', 'temperatura', 1143.0000, 'ºC'),
	(335299, 143, '2015-02-01 00:21:42.000000', 'temperatura', 233.0000, 'ºC'),
	(335300, 143, '2015-02-01 00:21:43.000000', 'temperatura', 137.0000, 'ºC'),
	(335301, 143, '2015-02-01 00:21:44.000000', 'temperatura', 1186.0000, 'ºC'),
	(335302, 143, '2015-02-01 00:21:45.000000', 'temperatura', 718.0000, 'ºC'),
	(335303, 143, '2015-02-01 00:21:46.000000', 'temperatura', 33.0000, 'ºC'),
	(335304, 143, '2015-02-01 00:21:47.000000', 'temperatura', 412.0000, 'ºC'),
	(335305, 143, '2015-02-01 00:21:48.000000', 'temperatura', 761.0000, 'ºC'),
	(335306, 143, '2015-02-01 00:21:49.000000', 'temperatura', 169.0000, 'ºC'),
	(335307, 143, '2015-02-01 00:21:50.000000', 'temperatura', 962.0000, 'ºC'),
	(335308, 143, '2015-02-01 00:21:51.000000', 'temperatura', 703.0000, 'ºC'),
	(335309, 143, '2015-02-01 00:21:52.000000', 'temperatura', 630.0000, 'ºC'),
	(335310, 143, '2015-02-01 00:21:53.000000', 'temperatura', 1041.0000, 'ºC'),
	(335311, 143, '2015-02-01 00:21:54.000000', 'temperatura', 916.0000, 'ºC'),
	(335312, 143, '2015-02-01 00:21:55.000000', 'temperatura', 256.0000, 'ºC'),
	(335313, 143, '2015-02-01 00:21:56.000000', 'temperatura', 934.0000, 'ºC'),
	(335314, 143, '2015-02-01 00:21:57.000000', 'temperatura', 302.0000, 'ºC'),
	(335315, 143, '2015-02-01 00:21:58.000000', 'temperatura', 1109.0000, 'ºC'),
	(335316, 143, '2015-02-01 00:21:59.000000', 'temperatura', 1039.0000, 'ºC'),
	(335317, 143, '2015-02-01 00:22:00.000000', 'temperatura', 669.0000, 'ºC'),
	(335318, 143, '2015-02-01 00:22:01.000000', 'temperatura', 230.0000, 'ºC'),
	(335319, 143, '2015-02-01 00:22:02.000000', 'temperatura', 344.0000, 'ºC'),
	(335320, 143, '2015-02-01 00:22:03.000000', 'temperatura', 1028.0000, 'ºC'),
	(335321, 143, '2015-02-01 00:22:04.000000', 'temperatura', 510.0000, 'ºC'),
	(335322, 143, '2015-02-01 00:22:05.000000', 'temperatura', 664.0000, 'ºC'),
	(335323, 143, '2015-02-01 00:22:06.000000', 'temperatura', 594.0000, 'ºC'),
	(335324, 143, '2015-02-01 00:22:07.000000', 'temperatura', 977.0000, 'ºC'),
	(335325, 143, '2015-02-01 00:22:08.000000', 'temperatura', 703.0000, 'ºC'),
	(335326, 143, '2015-02-01 00:22:09.000000', 'temperatura', 583.0000, 'ºC'),
	(335327, 143, '2015-02-01 00:22:10.000000', 'temperatura', 808.0000, 'ºC'),
	(335328, 143, '2015-02-01 00:22:11.000000', 'temperatura', 1090.0000, 'ºC'),
	(335329, 143, '2015-02-01 00:22:12.000000', 'temperatura', 629.0000, 'ºC'),
	(335330, 143, '2015-02-01 00:22:13.000000', 'temperatura', 1075.0000, 'ºC'),
	(335331, 143, '2015-02-01 00:22:14.000000', 'temperatura', 1087.0000, 'ºC'),
	(335332, 143, '2015-02-01 00:22:15.000000', 'temperatura', 1011.0000, 'ºC'),
	(335333, 143, '2015-02-01 00:22:16.000000', 'temperatura', 593.0000, 'ºC'),
	(335334, 143, '2015-02-01 00:22:17.000000', 'temperatura', 1132.0000, 'ºC'),
	(335335, 143, '2015-02-01 00:22:18.000000', 'temperatura', 284.0000, 'ºC'),
	(335336, 143, '2015-02-01 00:22:19.000000', 'temperatura', 425.0000, 'ºC'),
	(335337, 143, '2015-02-01 00:22:20.000000', 'temperatura', 72.0000, 'ºC'),
	(335338, 143, '2015-02-01 00:22:21.000000', 'temperatura', 287.0000, 'ºC'),
	(335339, 143, '2015-02-01 00:22:22.000000', 'temperatura', 18.0000, 'ºC'),
	(335340, 143, '2015-02-01 00:22:23.000000', 'temperatura', 432.0000, 'ºC'),
	(335341, 143, '2015-02-01 00:22:24.000000', 'temperatura', 903.0000, 'ºC'),
	(335342, 143, '2015-02-01 00:22:25.000000', 'temperatura', 821.0000, 'ºC'),
	(335343, 143, '2015-02-01 00:22:26.000000', 'temperatura', 197.0000, 'ºC'),
	(335344, 143, '2015-02-01 00:22:27.000000', 'temperatura', 922.0000, 'ºC'),
	(335345, 143, '2015-02-01 00:22:28.000000', 'temperatura', 419.0000, 'ºC'),
	(335346, 143, '2015-02-01 00:22:29.000000', 'temperatura', 528.0000, 'ºC'),
	(335347, 143, '2015-02-01 00:22:30.000000', 'temperatura', 186.0000, 'ºC'),
	(335348, 143, '2015-02-01 00:22:31.000000', 'temperatura', 546.0000, 'ºC'),
	(335349, 143, '2015-02-01 00:22:32.000000', 'temperatura', 970.0000, 'ºC'),
	(335350, 143, '2015-02-01 00:22:33.000000', 'temperatura', 815.0000, 'ºC'),
	(335351, 143, '2015-02-01 00:22:34.000000', 'temperatura', 1165.0000, 'ºC'),
	(335352, 143, '2015-02-01 00:22:35.000000', 'temperatura', 979.0000, 'ºC'),
	(335353, 143, '2015-02-01 00:22:36.000000', 'temperatura', 201.0000, 'ºC'),
	(335354, 143, '2015-02-01 00:22:37.000000', 'temperatura', 468.0000, 'ºC'),
	(335355, 143, '2015-02-01 00:22:38.000000', 'temperatura', 537.0000, 'ºC'),
	(335356, 143, '2015-02-01 00:22:39.000000', 'temperatura', 81.0000, 'ºC'),
	(335357, 143, '2015-02-01 00:22:40.000000', 'temperatura', 1195.0000, 'ºC'),
	(335358, 143, '2015-02-01 00:22:41.000000', 'temperatura', 933.0000, 'ºC'),
	(335359, 143, '2015-02-01 00:22:42.000000', 'temperatura', 1080.0000, 'ºC'),
	(335360, 143, '2015-02-01 00:22:43.000000', 'temperatura', 202.0000, 'ºC'),
	(335361, 143, '2015-02-01 00:22:44.000000', 'temperatura', 172.0000, 'ºC'),
	(335362, 143, '2015-02-01 00:22:45.000000', 'temperatura', 252.0000, 'ºC'),
	(335363, 143, '2015-02-01 00:22:46.000000', 'temperatura', 747.0000, 'ºC'),
	(335364, 143, '2015-02-01 00:22:47.000000', 'temperatura', 577.0000, 'ºC'),
	(335365, 143, '2015-02-01 00:22:48.000000', 'temperatura', 645.0000, 'ºC'),
	(335366, 143, '2015-02-01 00:22:49.000000', 'temperatura', 294.0000, 'ºC'),
	(335367, 143, '2015-02-01 00:22:50.000000', 'temperatura', 734.0000, 'ºC'),
	(335368, 143, '2015-02-01 00:22:51.000000', 'temperatura', 392.0000, 'ºC'),
	(335369, 143, '2015-02-01 00:22:52.000000', 'temperatura', 956.0000, 'ºC'),
	(335370, 143, '2015-02-01 00:22:53.000000', 'temperatura', 5.0000, 'ºC'),
	(335371, 143, '2015-02-01 00:22:54.000000', 'temperatura', 759.0000, 'ºC'),
	(335372, 143, '2015-02-01 00:22:55.000000', 'temperatura', 178.0000, 'ºC'),
	(335373, 143, '2015-02-01 00:22:56.000000', 'temperatura', 1015.0000, 'ºC'),
	(335374, 143, '2015-02-01 00:22:57.000000', 'temperatura', 943.0000, 'ºC'),
	(335375, 143, '2015-02-01 00:22:58.000000', 'temperatura', 468.0000, 'ºC'),
	(335376, 143, '2015-02-01 00:22:59.000000', 'temperatura', 713.0000, 'ºC'),
	(335377, 143, '2015-02-01 00:23:00.000000', 'temperatura', 962.0000, 'ºC'),
	(335378, 143, '2015-02-01 00:23:01.000000', 'temperatura', 269.0000, 'ºC'),
	(335379, 143, '2015-02-01 00:23:02.000000', 'temperatura', 862.0000, 'ºC'),
	(335380, 143, '2015-02-01 00:23:03.000000', 'temperatura', 1102.0000, 'ºC'),
	(335381, 143, '2015-02-01 00:23:04.000000', 'temperatura', 525.0000, 'ºC'),
	(335382, 143, '2015-02-01 00:23:05.000000', 'temperatura', 519.0000, 'ºC'),
	(335383, 143, '2015-02-01 00:23:06.000000', 'temperatura', 1021.0000, 'ºC'),
	(335384, 143, '2015-02-01 00:23:07.000000', 'temperatura', 1147.0000, 'ºC'),
	(335385, 143, '2015-02-01 00:23:08.000000', 'temperatura', 274.0000, 'ºC'),
	(335386, 143, '2015-02-01 00:23:09.000000', 'temperatura', 327.0000, 'ºC'),
	(335387, 143, '2015-02-01 00:23:10.000000', 'temperatura', 815.0000, 'ºC'),
	(335388, 143, '2015-02-01 00:23:11.000000', 'temperatura', 696.0000, 'ºC'),
	(335389, 143, '2015-02-01 00:23:12.000000', 'temperatura', 1035.0000, 'ºC'),
	(335390, 143, '2015-02-01 00:23:13.000000', 'temperatura', 689.0000, 'ºC'),
	(335391, 143, '2015-02-01 00:23:14.000000', 'temperatura', 337.0000, 'ºC'),
	(335392, 143, '2015-02-01 00:23:15.000000', 'temperatura', 821.0000, 'ºC'),
	(335393, 143, '2015-02-01 00:23:16.000000', 'temperatura', 693.0000, 'ºC'),
	(335394, 143, '2015-02-01 00:23:17.000000', 'temperatura', 1002.0000, 'ºC'),
	(335395, 143, '2015-02-01 00:23:18.000000', 'temperatura', 534.0000, 'ºC'),
	(335396, 143, '2015-02-01 00:23:19.000000', 'temperatura', 863.0000, 'ºC'),
	(335397, 143, '2015-02-01 00:23:20.000000', 'temperatura', 315.0000, 'ºC'),
	(335398, 143, '2015-02-01 00:23:21.000000', 'temperatura', 186.0000, 'ºC'),
	(335399, 143, '2015-02-01 00:23:22.000000', 'temperatura', 1183.0000, 'ºC'),
	(335400, 143, '2015-02-01 00:23:23.000000', 'temperatura', 561.0000, 'ºC'),
	(335401, 143, '2015-02-01 00:23:24.000000', 'temperatura', 456.0000, 'ºC'),
	(335402, 143, '2015-02-01 00:23:25.000000', 'temperatura', 596.0000, 'ºC'),
	(335403, 143, '2015-02-01 00:23:26.000000', 'temperatura', 414.0000, 'ºC'),
	(335404, 143, '2015-02-01 00:23:27.000000', 'temperatura', 280.0000, 'ºC'),
	(335405, 143, '2015-02-01 00:23:28.000000', 'temperatura', 161.0000, 'ºC'),
	(335406, 143, '2015-02-01 00:23:29.000000', 'temperatura', 1167.0000, 'ºC'),
	(335407, 143, '2015-02-01 00:23:30.000000', 'temperatura', 549.0000, 'ºC'),
	(335408, 143, '2015-02-01 00:23:31.000000', 'temperatura', 447.0000, 'ºC'),
	(335409, 143, '2015-02-01 00:23:32.000000', 'temperatura', 588.0000, 'ºC'),
	(335410, 143, '2015-02-01 00:23:33.000000', 'temperatura', 400.0000, 'ºC'),
	(335411, 143, '2015-02-01 00:23:34.000000', 'temperatura', 235.0000, 'ºC'),
	(335412, 143, '2015-02-01 00:23:35.000000', 'temperatura', 1175.0000, 'ºC'),
	(335413, 143, '2015-02-01 00:23:36.000000', 'temperatura', 371.0000, 'ºC'),
	(335414, 143, '2015-02-01 00:23:37.000000', 'temperatura', 732.0000, 'ºC'),
	(335415, 143, '2015-02-01 00:23:38.000000', 'temperatura', 147.0000, 'ºC'),
	(335416, 143, '2015-02-01 00:23:39.000000', 'temperatura', 941.0000, 'ºC'),
	(335417, 143, '2015-02-01 00:23:40.000000', 'temperatura', 663.0000, 'ºC'),
	(335418, 143, '2015-02-01 00:23:41.000000', 'temperatura', 494.0000, 'ºC'),
	(335419, 143, '2015-02-01 00:23:42.000000', 'temperatura', 481.0000, 'ºC'),
	(335420, 143, '2015-02-01 00:23:43.000000', 'temperatura', 923.0000, 'ºC'),
	(335421, 143, '2015-02-01 00:23:44.000000', 'temperatura', 771.0000, 'ºC'),
	(335422, 143, '2015-02-01 00:23:45.000000', 'temperatura', 1089.0000, 'ºC'),
	(335423, 143, '2015-02-01 00:23:46.000000', 'temperatura', 733.0000, 'ºC'),
	(335424, 143, '2015-02-01 00:23:47.000000', 'temperatura', 399.0000, 'ºC'),
	(335425, 143, '2015-02-01 00:23:48.000000', 'temperatura', 998.0000, 'ºC'),
	(335426, 143, '2015-02-01 00:23:49.000000', 'temperatura', 190.0000, 'ºC'),
	(335427, 143, '2015-02-01 00:23:50.000000', 'temperatura', 356.0000, 'ºC'),
	(335428, 143, '2015-02-01 00:23:51.000000', 'temperatura', 13.0000, 'ºC'),
	(335429, 143, '2015-02-01 00:23:52.000000', 'temperatura', 196.0000, 'ºC'),
	(335430, 143, '2015-02-01 00:23:53.000000', 'temperatura', 942.0000, 'ºC'),
	(335431, 143, '2015-02-01 00:23:54.000000', 'temperatura', 523.0000, 'ºC'),
	(335432, 143, '2015-02-01 00:23:55.000000', 'temperatura', 991.0000, 'ºC'),
	(335433, 143, '2015-02-01 00:23:56.000000', 'temperatura', 983.0000, 'ºC'),
	(335434, 143, '2015-02-01 00:23:57.000000', 'temperatura', 746.0000, 'ºC'),
	(335435, 143, '2015-02-01 00:23:58.000000', 'temperatura', 778.0000, 'ºC'),
	(335436, 143, '2015-02-01 00:23:59.000000', 'temperatura', 454.0000, 'ºC'),
	(335437, 143, '2015-02-01 00:24:00.000000', 'temperatura', 1139.0000, 'ºC'),
	(335438, 143, '2015-02-01 00:24:01.000000', 'temperatura', 730.0000, 'ºC'),
	(335439, 143, '2015-02-01 00:24:02.000000', 'temperatura', 234.0000, 'ºC'),
	(335440, 143, '2015-02-01 00:24:03.000000', 'temperatura', 179.0000, 'ºC'),
	(335441, 143, '2015-02-01 00:24:04.000000', 'temperatura', 195.0000, 'ºC'),
	(335442, 143, '2015-02-01 00:24:05.000000', 'temperatura', 439.0000, 'ºC'),
	(335443, 143, '2015-02-01 00:24:06.000000', 'temperatura', 409.0000, 'ºC'),
	(335444, 143, '2015-02-01 00:24:07.000000', 'temperatura', 731.0000, 'ºC'),
	(335445, 143, '2015-02-01 00:24:08.000000', 'temperatura', 29.0000, 'ºC'),
	(335446, 143, '2015-02-01 00:24:09.000000', 'temperatura', 349.0000, 'ºC'),
	(335447, 143, '2015-02-01 00:24:10.000000', 'temperatura', 462.0000, 'ºC'),
	(335448, 143, '2015-02-01 00:24:11.000000', 'temperatura', 63.0000, 'ºC'),
	(335449, 143, '2015-02-01 00:24:12.000000', 'temperatura', 127.0000, 'ºC'),
	(335450, 143, '2015-02-01 00:24:13.000000', 'temperatura', 448.0000, 'ºC'),
	(335451, 143, '2015-02-01 00:24:14.000000', 'temperatura', 658.0000, 'ºC'),
	(335452, 143, '2015-02-01 00:24:15.000000', 'temperatura', 746.0000, 'ºC'),
	(335453, 143, '2015-02-01 00:24:16.000000', 'temperatura', 556.0000, 'ºC'),
	(335454, 143, '2015-02-01 00:24:17.000000', 'temperatura', 543.0000, 'ºC'),
	(335455, 143, '2015-02-01 00:24:18.000000', 'temperatura', 1047.0000, 'ºC'),
	(335456, 143, '2015-02-01 00:24:19.000000', 'temperatura', 6.0000, 'ºC'),
	(335457, 143, '2015-02-01 00:24:20.000000', 'temperatura', 491.0000, 'ºC'),
	(335458, 143, '2015-02-01 00:24:21.000000', 'temperatura', 36.0000, 'ºC'),
	(335459, 143, '2015-02-01 00:24:22.000000', 'temperatura', 1106.0000, 'ºC'),
	(335460, 143, '2015-02-01 00:24:23.000000', 'temperatura', 625.0000, 'ºC'),
	(335461, 143, '2015-02-01 00:24:24.000000', 'temperatura', 1009.0000, 'ºC'),
	(335462, 143, '2015-02-01 00:24:25.000000', 'temperatura', 768.0000, 'ºC'),
	(335463, 143, '2015-02-01 00:24:26.000000', 'temperatura', 816.0000, 'ºC'),
	(335464, 143, '2015-02-01 00:24:27.000000', 'temperatura', 576.0000, 'ºC'),
	(335465, 143, '2015-02-01 00:24:28.000000', 'temperatura', 430.0000, 'ºC'),
	(335466, 143, '2015-02-01 00:24:29.000000', 'temperatura', 425.0000, 'ºC'),
	(335467, 143, '2015-02-01 00:24:30.000000', 'temperatura', 834.0000, 'ºC'),
	(335468, 143, '2015-02-01 00:24:31.000000', 'temperatura', 497.0000, 'ºC'),
	(335469, 143, '2015-02-01 00:24:32.000000', 'temperatura', 1182.0000, 'ºC'),
	(335470, 143, '2015-02-01 00:24:33.000000', 'temperatura', 818.0000, 'ºC'),
	(335471, 143, '2015-02-01 00:24:34.000000', 'temperatura', 546.0000, 'ºC'),
	(335472, 143, '2015-02-01 00:24:35.000000', 'temperatura', 277.0000, 'ºC'),
	(335473, 143, '2015-02-01 00:24:36.000000', 'temperatura', 949.0000, 'ºC'),
	(335474, 143, '2015-02-01 00:24:37.000000', 'temperatura', 313.0000, 'ºC'),
	(335475, 143, '2015-02-01 00:24:38.000000', 'temperatura', 1120.0000, 'ºC'),
	(335476, 143, '2015-02-01 00:24:39.000000', 'temperatura', 1062.0000, 'ºC'),
	(335477, 143, '2015-02-01 00:24:40.000000', 'temperatura', 748.0000, 'ºC'),
	(335478, 143, '2015-02-01 00:24:41.000000', 'temperatura', 553.0000, 'ºC'),
	(335479, 143, '2015-02-01 00:24:42.000000', 'temperatura', 525.0000, 'ºC'),
	(335480, 143, '2015-02-01 00:24:43.000000', 'temperatura', 966.0000, 'ºC'),
	(335481, 143, '2015-02-01 00:24:44.000000', 'temperatura', 854.0000, 'ºC'),
	(335482, 143, '2015-02-01 00:24:45.000000', 'temperatura', 173.0000, 'ºC'),
	(335483, 143, '2015-02-01 00:24:46.000000', 'temperatura', 702.0000, 'ºC'),
	(335484, 143, '2015-02-01 00:24:47.000000', 'temperatura', 594.0000, 'ºC'),
	(335485, 143, '2015-02-01 00:24:48.000000', 'temperatura', 862.0000, 'ºC'),
	(335486, 143, '2015-02-01 00:24:49.000000', 'temperatura', 128.0000, 'ºC'),
	(335487, 143, '2015-02-01 00:24:50.000000', 'temperatura', 458.0000, 'ºC'),
	(335488, 143, '2015-02-01 00:24:51.000000', 'temperatura', 704.0000, 'ºC'),
	(335489, 143, '2015-02-01 00:24:52.000000', 'temperatura', 946.0000, 'ºC'),
	(335490, 143, '2015-02-01 00:24:53.000000', 'temperatura', 220.0000, 'ºC'),
	(335491, 143, '2015-02-01 00:24:54.000000', 'temperatura', 660.0000, 'ºC'),
	(335492, 143, '2015-02-01 00:24:55.000000', 'temperatura', 244.0000, 'ºC'),
	(335493, 143, '2015-02-01 00:24:56.000000', 'temperatura', 438.0000, 'ºC'),
	(335494, 143, '2015-02-01 00:24:57.000000', 'temperatura', 261.0000, 'ºC'),
	(335495, 143, '2015-02-01 00:24:58.000000', 'temperatura', 1191.0000, 'ºC'),
	(335496, 143, '2015-02-01 00:24:59.000000', 'temperatura', 371.0000, 'ºC'),
	(335497, 143, '2015-02-01 00:25:00.000000', 'temperatura', 682.0000, 'ºC'),
	(335498, 143, '2015-02-01 00:25:01.000000', 'temperatura', 1098.0000, 'ºC'),
	(335499, 143, '2015-02-01 00:25:02.000000', 'temperatura', 1043.0000, 'ºC'),
	(335500, 143, '2015-02-01 00:25:03.000000', 'temperatura', 721.0000, 'ºC'),
	(335501, 143, '2015-02-01 00:25:04.000000', 'temperatura', 479.0000, 'ºC'),
	(335502, 143, '2015-02-01 00:25:05.000000', 'temperatura', 231.0000, 'ºC'),
	(335503, 143, '2015-02-01 00:25:06.000000', 'temperatura', 919.0000, 'ºC'),
	(335504, 143, '2015-02-01 00:25:07.000000', 'temperatura', 303.0000, 'ºC'),
	(335505, 143, '2015-02-01 00:25:08.000000', 'temperatura', 1159.0000, 'ºC'),
	(335506, 143, '2015-02-01 00:25:09.000000', 'temperatura', 86.0000, 'ºC'),
	(335507, 143, '2015-02-01 00:25:10.000000', 'temperatura', 555.0000, 'ºC'),
	(335508, 143, '2015-02-01 00:25:11.000000', 'temperatura', 116.0000, 'ºC'),
	(335509, 143, '2015-02-01 00:25:12.000000', 'temperatura', 118.0000, 'ºC'),
	(335510, 143, '2015-02-01 00:25:13.000000', 'temperatura', 240.0000, 'ºC'),
	(335511, 143, '2015-02-01 00:25:14.000000', 'temperatura', 848.0000, 'ºC'),
	(335512, 143, '2015-02-01 00:25:15.000000', 'temperatura', 1122.0000, 'ºC'),
	(335513, 143, '2015-02-01 00:25:16.000000', 'temperatura', 664.0000, 'ºC'),
	(335514, 143, '2015-02-01 00:25:17.000000', 'temperatura', 1153.0000, 'ºC'),
	(335515, 143, '2015-02-01 00:25:18.000000', 'temperatura', 176.0000, 'ºC'),
	(335516, 143, '2015-02-01 00:25:19.000000', 'temperatura', 1020.0000, 'ºC'),
	(335517, 143, '2015-02-01 00:25:20.000000', 'temperatura', 971.0000, 'ºC'),
	(335518, 143, '2015-02-01 00:25:21.000000', 'temperatura', 598.0000, 'ºC'),
	(335519, 143, '2015-02-01 00:25:22.000000', 'temperatura', 78.0000, 'ºC'),
	(335520, 143, '2015-02-01 00:25:23.000000', 'temperatura', 994.0000, 'ºC'),
	(335521, 143, '2015-02-01 00:25:24.000000', 'temperatura', 1137.0000, 'ºC'),
	(335522, 143, '2015-02-01 00:25:25.000000', 'temperatura', 302.0000, 'ºC'),
	(335523, 143, '2015-02-01 00:25:26.000000', 'temperatura', 501.0000, 'ºC'),
	(335524, 143, '2015-02-01 00:25:27.000000', 'temperatura', 398.0000, 'ºC'),
	(335525, 143, '2015-02-01 00:25:28.000000', 'temperatura', 488.0000, 'ºC'),
	(335526, 143, '2015-02-01 00:25:29.000000', 'temperatura', 46.0000, 'ºC'),
	(335527, 143, '2015-02-01 00:25:30.000000', 'temperatura', 1168.0000, 'ºC'),
	(335528, 143, '2015-02-01 00:25:31.000000', 'temperatura', 901.0000, 'ºC'),
	(335529, 143, '2015-02-01 00:25:32.000000', 'temperatura', 1001.0000, 'ºC'),
	(335530, 143, '2015-02-01 00:25:33.000000', 'temperatura', 1105.0000, 'ºC'),
	(335531, 143, '2015-02-01 00:25:34.000000', 'temperatura', 123.0000, 'ºC'),
	(335532, 143, '2015-02-01 00:25:35.000000', 'temperatura', 898.0000, 'ºC'),
	(335533, 143, '2015-02-01 00:25:36.000000', 'temperatura', 523.0000, 'ºC'),
	(335534, 143, '2015-02-01 00:25:37.000000', 'temperatura', 1119.0000, 'ºC'),
	(335535, 143, '2015-02-01 00:25:38.000000', 'temperatura', 429.0000, 'ºC'),
	(335536, 143, '2015-02-01 00:25:39.000000', 'temperatura', 1190.0000, 'ºC'),
	(335537, 143, '2015-02-01 00:25:40.000000', 'temperatura', 1061.0000, 'ºC'),
	(335538, 143, '2015-02-01 00:25:41.000000', 'temperatura', 536.0000, 'ºC'),
	(335539, 143, '2015-02-01 00:25:42.000000', 'temperatura', 695.0000, 'ºC'),
	(335540, 143, '2015-02-01 00:25:43.000000', 'temperatura', 671.0000, 'ºC'),
	(335541, 143, '2015-02-01 00:25:44.000000', 'temperatura', 71.0000, 'ºC'),
	(335542, 143, '2015-02-01 00:25:45.000000', 'temperatura', 740.0000, 'ºC'),
	(335543, 143, '2015-02-01 00:25:46.000000', 'temperatura', 1090.0000, 'ºC'),
	(335544, 143, '2015-02-01 00:25:47.000000', 'temperatura', 828.0000, 'ºC'),
	(335545, 143, '2015-02-01 00:25:48.000000', 'temperatura', 872.0000, 'ºC'),
	(335546, 143, '2015-02-01 00:25:49.000000', 'temperatura', 677.0000, 'ºC'),
	(335547, 143, '2015-02-01 00:25:50.000000', 'temperatura', 770.0000, 'ºC'),
	(335548, 143, '2015-02-01 00:25:51.000000', 'temperatura', 620.0000, 'ºC'),
	(335549, 143, '2015-02-01 00:25:52.000000', 'temperatura', 789.0000, 'ºC'),
	(335550, 143, '2015-02-01 00:25:53.000000', 'temperatura', 885.0000, 'ºC'),
	(335551, 143, '2015-02-01 00:25:54.000000', 'temperatura', 860.0000, 'ºC'),
	(335552, 143, '2015-02-01 00:25:55.000000', 'temperatura', 445.0000, 'ºC'),
	(335553, 143, '2015-02-01 00:25:56.000000', 'temperatura', 844.0000, 'ºC'),
	(335554, 143, '2015-02-01 00:25:57.000000', 'temperatura', 485.0000, 'ºC'),
	(335555, 143, '2015-02-01 00:25:58.000000', 'temperatura', 1097.0000, 'ºC'),
	(335556, 143, '2015-02-01 00:25:59.000000', 'temperatura', 427.0000, 'ºC'),
	(335557, 143, '2015-02-01 00:26:00.000000', 'temperatura', 47.0000, 'ºC'),
	(335558, 143, '2015-02-01 00:26:01.000000', 'temperatura', 153.0000, 'ºC'),
	(335559, 143, '2015-02-01 00:26:02.000000', 'temperatura', 624.0000, 'ºC'),
	(335560, 143, '2015-02-01 00:26:03.000000', 'temperatura', 262.0000, 'ºC'),
	(335561, 143, '2015-02-01 00:26:04.000000', 'temperatura', 640.0000, 'ºC'),
	(335562, 143, '2015-02-01 00:26:05.000000', 'temperatura', 15.0000, 'ºC'),
	(335563, 143, '2015-02-01 00:26:06.000000', 'temperatura', 556.0000, 'ºC'),
	(335564, 143, '2015-02-01 00:26:07.000000', 'temperatura', 333.0000, 'ºC'),
	(335565, 143, '2015-02-01 00:26:08.000000', 'temperatura', 0.0000, 'ºC'),
	(335566, 143, '2015-02-01 00:26:09.000000', 'temperatura', 202.0000, 'ºC'),
	(335567, 143, '2015-02-01 00:26:10.000000', 'temperatura', 1011.0000, 'ºC'),
	(335568, 143, '2015-02-01 00:26:11.000000', 'temperatura', 849.0000, 'ºC'),
	(335569, 143, '2015-02-01 00:26:12.000000', 'temperatura', 14.0000, 'ºC'),
	(335570, 143, '2015-02-01 00:26:13.000000', 'temperatura', 1122.0000, 'ºC'),
	(335571, 143, '2015-02-01 00:26:14.000000', 'temperatura', 769.0000, 'ºC'),
	(335572, 143, '2015-02-01 00:26:15.000000', 'temperatura', 480.0000, 'ºC'),
	(335573, 143, '2015-02-01 00:26:16.000000', 'temperatura', 93.0000, 'ºC'),
	(335574, 143, '2015-02-01 00:26:17.000000', 'temperatura', 226.0000, 'ºC'),
	(335575, 143, '2015-02-01 00:26:18.000000', 'temperatura', 849.0000, 'ºC'),
	(335576, 143, '2015-02-01 00:26:19.000000', 'temperatura', 1170.0000, 'ºC'),
	(335577, 143, '2015-02-01 00:26:20.000000', 'temperatura', 903.0000, 'ºC'),
	(335578, 143, '2015-02-01 00:26:21.000000', 'temperatura', 1003.0000, 'ºC'),
	(335579, 143, '2015-02-01 00:26:22.000000', 'temperatura', 1110.0000, 'ºC'),
	(335580, 143, '2015-02-01 00:26:23.000000', 'temperatura', 141.0000, 'ºC'),
	(335581, 143, '2015-02-01 00:26:24.000000', 'temperatura', 975.0000, 'ºC'),
	(335582, 143, '2015-02-01 00:26:25.000000', 'temperatura', 852.0000, 'ºC'),
	(335583, 143, '2015-02-01 00:26:26.000000', 'temperatura', 134.0000, 'ºC'),
	(335584, 143, '2015-02-01 00:26:27.000000', 'temperatura', 516.0000, 'ºC'),
	(335585, 143, '2015-02-01 00:26:28.000000', 'temperatura', 978.0000, 'ºC'),
	(335586, 143, '2015-02-01 00:26:29.000000', 'temperatura', 942.0000, 'ºC'),
	(335587, 143, '2015-02-01 00:26:30.000000', 'temperatura', 575.0000, 'ºC'),
	(335588, 143, '2015-02-01 00:26:31.000000', 'temperatura', 53.0000, 'ºC'),
	(335589, 143, '2015-02-01 00:26:32.000000', 'temperatura', 937.0000, 'ºC'),
	(335590, 143, '2015-02-01 00:26:33.000000', 'temperatura', 930.0000, 'ºC'),
	(335591, 143, '2015-02-01 00:26:34.000000', 'temperatura', 636.0000, 'ºC'),
	(335592, 143, '2015-02-01 00:26:35.000000', 'temperatura', 394.0000, 'ºC'),
	(335593, 143, '2015-02-01 00:26:36.000000', 'temperatura', 60.0000, 'ºC'),
	(335594, 143, '2015-02-01 00:26:37.000000', 'temperatura', 318.0000, 'ºC'),
	(335595, 143, '2015-02-01 00:26:38.000000', 'temperatura', 212.0000, 'ºC'),
	(335596, 143, '2015-02-01 00:26:39.000000', 'temperatura', 106.0000, 'ºC'),
	(335597, 143, '2015-02-01 00:26:40.000000', 'temperatura', 1093.0000, 'ºC'),
	(335598, 143, '2015-02-01 00:26:41.000000', 'temperatura', 350.0000, 'ºC'),
	(335599, 143, '2015-02-01 00:26:42.000000', 'temperatura', 871.0000, 'ºC'),
	(335600, 143, '2015-02-01 00:26:43.000000', 'temperatura', 907.0000, 'ºC'),
	(335601, 143, '2015-02-01 00:26:44.000000', 'temperatura', 721.0000, 'ºC'),
	(335602, 143, '2015-02-01 00:26:45.000000', 'temperatura', 885.0000, 'ºC'),
	(335603, 143, '2015-02-01 00:26:46.000000', 'temperatura', 1062.0000, 'ºC'),
	(335604, 143, '2015-02-01 00:26:47.000000', 'temperatura', 254.0000, 'ºC'),
	(335605, 143, '2015-02-01 00:26:48.000000', 'temperatura', 484.0000, 'ºC'),
	(335606, 143, '2015-02-01 00:26:49.000000', 'temperatura', 459.0000, 'ºC'),
	(335607, 143, '2015-02-01 00:26:50.000000', 'temperatura', 844.0000, 'ºC'),
	(335608, 143, '2015-02-01 00:26:51.000000', 'temperatura', 443.0000, 'ºC'),
	(335609, 143, '2015-02-01 00:26:52.000000', 'temperatura', 885.0000, 'ºC'),
	(335610, 143, '2015-02-01 00:26:53.000000', 'temperatura', 698.0000, 'ºC'),
	(335611, 143, '2015-02-01 00:26:54.000000', 'temperatura', 832.0000, 'ºC'),
	(335612, 143, '2015-02-01 00:26:55.000000', 'temperatura', 869.0000, 'ºC'),
	(335613, 143, '2015-02-01 00:26:56.000000', 'temperatura', 649.0000, 'ºC'),
	(335614, 143, '2015-02-01 00:26:57.000000', 'temperatura', 639.0000, 'ºC'),
	(335615, 143, '2015-02-01 00:26:58.000000', 'temperatura', 48.0000, 'ºC'),
	(335616, 143, '2015-02-01 00:26:59.000000', 'temperatura', 725.0000, 'ºC'),
	(335617, 143, '2015-02-01 00:27:00.000000', 'temperatura', 1081.0000, 'ºC'),
	(335618, 143, '2015-02-01 00:27:01.000000', 'temperatura', 830.0000, 'ºC'),
	(335619, 143, '2015-02-01 00:27:02.000000', 'temperatura', 907.0000, 'ºC'),
	(335620, 143, '2015-02-01 00:27:03.000000', 'temperatura', 847.0000, 'ºC'),
	(335621, 143, '2015-02-01 00:27:04.000000', 'temperatura', 314.0000, 'ºC'),
	(335622, 143, '2015-02-01 00:27:05.000000', 'temperatura', 228.0000, 'ºC'),
	(335623, 143, '2015-02-01 00:27:06.000000', 'temperatura', 199.0000, 'ºC'),
	(335624, 143, '2015-02-01 00:27:07.000000', 'temperatura', 312.0000, 'ºC'),
	(335625, 143, '2015-02-01 00:27:08.000000', 'temperatura', 964.0000, 'ºC'),
	(335626, 143, '2015-02-01 00:27:09.000000', 'temperatura', 283.0000, 'ºC'),
	(335627, 143, '2015-02-01 00:27:10.000000', 'temperatura', 925.0000, 'ºC'),
	(335628, 143, '2015-02-01 00:27:11.000000', 'temperatura', 178.0000, 'ºC'),
	(335629, 143, '2015-02-01 00:27:12.000000', 'temperatura', 513.0000, 'ºC'),
	(335630, 143, '2015-02-01 00:27:13.000000', 'temperatura', 833.0000, 'ºC'),
	(335631, 143, '2015-02-01 00:27:14.000000', 'temperatura', 226.0000, 'ºC'),
	(335632, 143, '2015-02-01 00:27:15.000000', 'temperatura', 1033.0000, 'ºC'),
	(335633, 143, '2015-02-01 00:27:16.000000', 'temperatura', 889.0000, 'ºC'),
	(335634, 143, '2015-02-01 00:27:17.000000', 'temperatura', 143.0000, 'ºC'),
	(335635, 143, '2015-02-01 00:27:18.000000', 'temperatura', 448.0000, 'ºC'),
	(335636, 143, '2015-02-01 00:27:19.000000', 'temperatura', 614.0000, 'ºC'),
	(335637, 143, '2015-02-01 00:27:20.000000', 'temperatura', 527.0000, 'ºC'),
	(335638, 143, '2015-02-01 00:27:21.000000', 'temperatura', 793.0000, 'ºC'),
	(335639, 143, '2015-02-01 00:27:22.000000', 'temperatura', 1183.0000, 'ºC'),
	(335640, 143, '2015-02-01 00:27:23.000000', 'temperatura', 1137.0000, 'ºC'),
	(335641, 143, '2015-02-01 00:27:24.000000', 'temperatura', 937.0000, 'ºC'),
	(335642, 143, '2015-02-01 00:27:25.000000', 'temperatura', 73.0000, 'ºC'),
	(335643, 143, '2015-02-01 00:27:26.000000', 'temperatura', 1157.0000, 'ºC'),
	(335644, 143, '2015-02-01 00:27:27.000000', 'temperatura', 765.0000, 'ºC'),
	(335645, 143, '2015-02-01 00:27:28.000000', 'temperatura', 355.0000, 'ºC'),
	(335646, 143, '2015-02-01 00:27:29.000000', 'temperatura', 679.0000, 'ºC'),
	(335647, 143, '2015-02-01 00:27:30.000000', 'temperatura', 1130.0000, 'ºC'),
	(335648, 143, '2015-02-01 00:27:31.000000', 'temperatura', 14.0000, 'ºC'),
	(335649, 143, '2015-02-01 00:27:32.000000', 'temperatura', 280.0000, 'ºC'),
	(335650, 143, '2015-02-01 00:27:33.000000', 'temperatura', 158.0000, 'ºC'),
	(335651, 143, '2015-02-01 00:27:34.000000', 'temperatura', 1150.0000, 'ºC'),
	(335652, 143, '2015-02-01 00:27:35.000000', 'temperatura', 478.0000, 'ºC'),
	(335653, 143, '2015-02-01 00:27:36.000000', 'temperatura', 140.0000, 'ºC'),
	(335654, 143, '2015-02-01 00:27:37.000000', 'temperatura', 468.0000, 'ºC'),
	(335655, 143, '2015-02-01 00:27:38.000000', 'temperatura', 721.0000, 'ºC'),
	(335656, 143, '2015-02-01 00:27:39.000000', 'temperatura', 999.0000, 'ºC'),
	(335657, 143, '2015-02-01 00:27:40.000000', 'temperatura', 432.0000, 'ºC'),
	(335658, 143, '2015-02-01 00:27:41.000000', 'temperatura', 364.0000, 'ºC'),
	(335659, 143, '2015-02-01 00:27:42.000000', 'temperatura', 527.0000, 'ºC'),
	(335660, 143, '2015-02-01 00:27:43.000000', 'temperatura', 340.0000, 'ºC'),
	(335661, 143, '2015-02-01 00:27:44.000000', 'temperatura', 121.0000, 'ºC'),
	(335662, 143, '2015-02-01 00:27:45.000000', 'temperatura', 787.0000, 'ºC'),
	(335663, 143, '2015-02-01 00:27:46.000000', 'temperatura', 1170.0000, 'ºC'),
	(335664, 143, '2015-02-01 00:27:47.000000', 'temperatura', 1092.0000, 'ºC'),
	(335665, 143, '2015-02-01 00:27:48.000000', 'temperatura', 751.0000, 'ºC'),
	(335666, 143, '2015-02-01 00:27:49.000000', 'temperatura', 479.0000, 'ºC'),
	(335667, 143, '2015-02-01 00:27:50.000000', 'temperatura', 141.0000, 'ºC'),
	(335668, 143, '2015-02-01 00:27:51.000000', 'temperatura', 469.0000, 'ºC'),
	(335669, 143, '2015-02-01 00:27:52.000000', 'temperatura', 722.0000, 'ºC'),
	(335670, 143, '2015-02-01 00:27:53.000000', 'temperatura', 1006.0000, 'ºC'),
	(335671, 143, '2015-02-01 00:27:54.000000', 'temperatura', 462.0000, 'ºC'),
	(335672, 143, '2015-02-01 00:27:55.000000', 'temperatura', 495.0000, 'ºC'),
	(335673, 143, '2015-02-01 00:27:56.000000', 'temperatura', 1089.0000, 'ºC'),
	(335674, 143, '2015-02-01 00:27:57.000000', 'temperatura', 359.0000, 'ºC'),
	(335675, 143, '2015-02-01 00:27:58.000000', 'temperatura', 929.0000, 'ºC'),
	(335676, 143, '2015-02-01 00:27:59.000000', 'temperatura', 1170.0000, 'ºC'),
	(335677, 143, '2015-02-01 00:28:00.000000', 'temperatura', 663.0000, 'ºC'),
	(335678, 143, '2015-02-01 00:28:01.000000', 'temperatura', 1006.0000, 'ºC'),
	(335679, 143, '2015-02-01 00:28:02.000000', 'temperatura', 641.0000, 'ºC'),
	(335680, 143, '2015-02-01 00:28:03.000000', 'temperatura', 188.0000, 'ºC'),
	(335681, 143, '2015-02-01 00:28:04.000000', 'temperatura', 218.0000, 'ºC'),
	(335682, 143, '2015-02-01 00:28:05.000000', 'temperatura', 525.0000, 'ºC'),
	(335683, 143, '2015-02-01 00:28:06.000000', 'temperatura', 772.0000, 'ºC'),
	(335684, 143, '2015-02-01 00:28:07.000000', 'temperatura', 1085.0000, 'ºC'),
	(335685, 143, '2015-02-01 00:28:08.000000', 'temperatura', 711.0000, 'ºC'),
	(335686, 143, '2015-02-01 00:28:09.000000', 'temperatura', 301.0000, 'ºC'),
	(335687, 143, '2015-02-01 00:28:10.000000', 'temperatura', 574.0000, 'ºC'),
	(335688, 143, '2015-02-01 00:28:11.000000', 'temperatura', 764.0000, 'ºC'),
	(335689, 143, '2015-02-01 00:28:12.000000', 'temperatura', 899.0000, 'ºC'),
	(335690, 143, '2015-02-01 00:28:13.000000', 'temperatura', 1004.0000, 'ºC'),
	(335691, 143, '2015-02-01 00:28:14.000000', 'temperatura', 1121.0000, 'ºC'),
	(335692, 143, '2015-02-01 00:28:15.000000', 'temperatura', 197.0000, 'ºC'),
	(335693, 143, '2015-02-01 00:28:16.000000', 'temperatura', 23.0000, 'ºC'),
	(335694, 143, '2015-02-01 00:28:17.000000', 'temperatura', 723.0000, 'ºC'),
	(335695, 143, '2015-02-01 00:28:18.000000', 'temperatura', 1148.0000, 'ºC'),
	(335696, 143, '2015-02-01 00:28:19.000000', 'temperatura', 1172.0000, 'ºC'),
	(335697, 143, '2015-02-01 00:28:20.000000', 'temperatura', 14.0000, 'ºC'),
	(335698, 143, '2015-02-01 00:28:21.000000', 'temperatura', 155.0000, 'ºC'),
	(335699, 143, '2015-02-01 00:28:22.000000', 'temperatura', 734.0000, 'ºC'),
	(335700, 143, '2015-02-01 00:28:23.000000', 'temperatura', 806.0000, 'ºC'),
	(335701, 143, '2015-02-01 00:28:24.000000', 'temperatura', 628.0000, 'ºC'),
	(335702, 143, '2015-02-01 00:28:25.000000', 'temperatura', 723.0000, 'ºC'),
	(335703, 143, '2015-02-01 00:28:26.000000', 'temperatura', 529.0000, 'ºC'),
	(335704, 143, '2015-02-01 00:28:27.000000', 'temperatura', 480.0000, 'ºC'),
	(335705, 143, '2015-02-01 00:28:28.000000', 'temperatura', 812.0000, 'ºC'),
	(335706, 143, '2015-02-01 00:28:29.000000', 'temperatura', 222.0000, 'ºC'),
	(335707, 143, '2015-02-01 00:28:30.000000', 'temperatura', 1073.0000, 'ºC'),
	(335708, 143, '2015-02-01 00:28:31.000000', 'temperatura', 1099.0000, 'ºC'),
	(335709, 143, '2015-02-01 00:28:32.000000', 'temperatura', 1077.0000, 'ºC'),
	(335710, 143, '2015-02-01 00:28:33.000000', 'temperatura', 887.0000, 'ºC'),
	(335711, 143, '2015-02-01 00:28:34.000000', 'temperatura', 5.0000, 'ºC'),
	(335712, 143, '2015-02-01 00:28:35.000000', 'temperatura', 967.0000, 'ºC'),
	(335713, 143, '2015-02-01 00:28:36.000000', 'temperatura', 18.0000, 'ºC'),
	(335714, 143, '2015-02-01 00:28:37.000000', 'temperatura', 791.0000, 'ºC'),
	(335715, 143, '2015-02-01 00:28:38.000000', 'temperatura', 303.0000, 'ºC'),
	(335716, 143, '2015-02-01 00:28:39.000000', 'temperatura', 340.0000, 'ºC'),
	(335717, 143, '2015-02-01 00:28:40.000000', 'temperatura', 791.0000, 'ºC'),
	(335718, 143, '2015-02-01 00:28:41.000000', 'temperatura', 536.0000, 'ºC'),
	(335719, 143, '2015-02-01 00:28:42.000000', 'temperatura', 306.0000, 'ºC'),
	(335720, 143, '2015-02-01 00:28:43.000000', 'temperatura', 1124.0000, 'ºC'),
	(335721, 143, '2015-02-01 00:28:44.000000', 'temperatura', 1101.0000, 'ºC'),
	(335722, 143, '2015-02-01 00:28:45.000000', 'temperatura', 936.0000, 'ºC'),
	(335723, 143, '2015-02-01 00:28:46.000000', 'temperatura', 178.0000, 'ºC'),
	(335724, 143, '2015-02-01 00:28:47.000000', 'temperatura', 480.0000, 'ºC'),
	(335725, 143, '2015-02-01 00:28:48.000000', 'temperatura', 667.0000, 'ºC'),
	(335726, 143, '2015-02-01 00:28:49.000000', 'temperatura', 695.0000, 'ºC'),
	(335727, 143, '2015-02-01 00:28:50.000000', 'temperatura', 277.0000, 'ºC'),
	(335728, 143, '2015-02-01 00:28:51.000000', 'temperatura', 499.0000, 'ºC'),
	(335729, 143, '2015-02-01 00:28:52.000000', 'temperatura', 463.0000, 'ºC'),
	(335730, 143, '2015-02-01 00:28:53.000000', 'temperatura', 818.0000, 'ºC'),
	(335731, 143, '2015-02-01 00:28:54.000000', 'temperatura', 304.0000, 'ºC'),
	(335732, 143, '2015-02-01 00:28:55.000000', 'temperatura', 266.0000, 'ºC'),
	(335733, 143, '2015-02-01 00:28:56.000000', 'temperatura', 418.0000, 'ºC'),
	(335734, 143, '2015-02-01 00:28:57.000000', 'temperatura', 94.0000, 'ºC'),
	(335735, 143, '2015-02-01 00:28:58.000000', 'temperatura', 415.0000, 'ºC'),
	(335736, 143, '2015-02-01 00:28:59.000000', 'temperatura', 596.0000, 'ºC'),
	(335737, 143, '2015-02-01 00:29:00.000000', 'temperatura', 532.0000, 'ºC'),
	(335738, 143, '2015-02-01 00:29:01.000000', 'temperatura', 875.0000, 'ºC'),
	(335739, 143, '2015-02-01 00:29:02.000000', 'temperatura', 381.0000, 'ºC'),
	(335740, 143, '2015-02-01 00:29:03.000000', 'temperatura', 477.0000, 'ºC'),
	(335741, 143, '2015-02-01 00:29:04.000000', 'temperatura', 43.0000, 'ºC'),
	(335742, 143, '2015-02-01 00:29:05.000000', 'temperatura', 1186.0000, 'ºC'),
	(335743, 143, '2015-02-01 00:29:06.000000', 'temperatura', 1000.0000, 'ºC'),
	(335744, 143, '2015-02-01 00:29:07.000000', 'temperatura', 245.0000, 'ºC'),
	(335745, 143, '2015-02-01 00:29:08.000000', 'temperatura', 624.0000, 'ºC'),
	(335746, 143, '2015-02-01 00:29:09.000000', 'temperatura', 1186.0000, 'ºC'),
	(335747, 143, '2015-02-01 00:29:10.000000', 'temperatura', 459.0000, 'ºC'),
	(335748, 143, '2015-02-01 00:29:11.000000', 'temperatura', 1136.0000, 'ºC'),
	(335749, 143, '2015-02-01 00:29:12.000000', 'temperatura', 704.0000, 'ºC'),
	(335750, 143, '2015-02-01 00:29:13.000000', 'temperatura', 113.0000, 'ºC'),
	(335751, 143, '2015-02-01 00:29:14.000000', 'temperatura', 852.0000, 'ºC'),
	(335752, 143, '2015-02-01 00:29:15.000000', 'temperatura', 320.0000, 'ºC'),
	(335753, 143, '2015-02-01 00:29:16.000000', 'temperatura', 248.0000, 'ºC'),
	(335754, 143, '2015-02-01 00:29:17.000000', 'temperatura', 278.0000, 'ºC'),
	(335755, 143, '2015-02-01 00:29:18.000000', 'temperatura', 647.0000, 'ºC'),
	(335756, 143, '2015-02-01 00:29:19.000000', 'temperatura', 2.0000, 'ºC'),
	(335757, 143, '2015-02-01 00:29:20.000000', 'temperatura', 471.0000, 'ºC'),
	(335758, 143, '2015-02-01 00:29:21.000000', 'temperatura', 1150.0000, 'ºC'),
	(335759, 143, '2015-02-01 00:29:22.000000', 'temperatura', 736.0000, 'ºC'),
	(335760, 143, '2015-02-01 00:29:23.000000', 'temperatura', 230.0000, 'ºC'),
	(335761, 143, '2015-02-01 00:29:24.000000', 'temperatura', 145.0000, 'ºC'),
	(335762, 143, '2015-02-01 00:29:25.000000', 'temperatura', 32.0000, 'ºC'),
	(335763, 143, '2015-02-01 00:29:26.000000', 'temperatura', 927.0000, 'ºC'),
	(335764, 143, '2015-02-01 00:29:27.000000', 'temperatura', 939.0000, 'ºC'),
	(335765, 143, '2015-02-01 00:29:28.000000', 'temperatura', 717.0000, 'ºC'),
	(335766, 143, '2015-02-01 00:29:29.000000', 'temperatura', 767.0000, 'ºC'),
	(335767, 143, '2015-02-01 00:29:30.000000', 'temperatura', 483.0000, 'ºC'),
	(335768, 143, '2015-02-01 00:29:31.000000', 'temperatura', 117.0000, 'ºC'),
	(335769, 143, '2015-02-01 00:29:32.000000', 'temperatura', 335.0000, 'ºC'),
	(335770, 143, '2015-02-01 00:29:33.000000', 'temperatura', 123.0000, 'ºC'),
	(335771, 143, '2015-02-01 00:29:34.000000', 'temperatura', 811.0000, 'ºC'),
	(335772, 143, '2015-02-01 00:29:35.000000', 'temperatura', 87.0000, 'ºC'),
	(335773, 143, '2015-02-01 00:29:36.000000', 'temperatura', 403.0000, 'ºC'),
	(335774, 143, '2015-02-01 00:29:37.000000', 'temperatura', 556.0000, 'ºC'),
	(335775, 143, '2015-02-01 00:29:38.000000', 'temperatura', 370.0000, 'ºC'),
	(335776, 143, '2015-02-01 00:29:39.000000', 'temperatura', 184.0000, 'ºC'),
	(335777, 143, '2015-02-01 00:29:40.000000', 'temperatura', 1008.0000, 'ºC'),
	(335778, 143, '2015-02-01 00:29:41.000000', 'temperatura', 891.0000, 'ºC'),
	(335779, 143, '2015-02-01 00:29:42.000000', 'temperatura', 230.0000, 'ºC'),
	(335780, 143, '2015-02-01 00:29:43.000000', 'temperatura', 878.0000, 'ºC'),
	(335781, 143, '2015-02-01 00:29:44.000000', 'temperatura', 101.0000, 'ºC'),
	(335782, 143, '2015-02-01 00:29:45.000000', 'temperatura', 271.0000, 'ºC'),
	(335783, 143, '2015-02-01 00:29:46.000000', 'temperatura', 1054.0000, 'ºC'),
	(335784, 143, '2015-02-01 00:29:47.000000', 'temperatura', 856.0000, 'ºC'),
	(335785, 143, '2015-02-01 00:29:48.000000', 'temperatura', 1120.0000, 'ºC'),
	(335786, 143, '2015-02-01 00:29:49.000000', 'temperatura', 630.0000, 'ºC'),
	(335787, 143, '2015-02-01 00:29:50.000000', 'temperatura', 994.0000, 'ºC'),
	(335788, 143, '2015-02-01 00:29:51.000000', 'temperatura', 677.0000, 'ºC'),
	(335789, 143, '2015-02-01 00:29:52.000000', 'temperatura', 405.0000, 'ºC'),
	(335790, 143, '2015-02-01 00:29:53.000000', 'temperatura', 1195.0000, 'ºC'),
	(335791, 143, '2015-02-01 00:29:54.000000', 'temperatura', 1158.0000, 'ºC'),
	(335792, 143, '2015-02-01 00:29:55.000000', 'temperatura', 1009.0000, 'ºC'),
	(335793, 143, '2015-02-01 00:29:56.000000', 'temperatura', 370.0000, 'ºC'),
	(335794, 143, '2015-02-01 00:29:57.000000', 'temperatura', 22.0000, 'ºC'),
	(335795, 143, '2015-02-01 00:29:58.000000', 'temperatura', 201.0000, 'ºC'),
	(335796, 143, '2015-02-01 00:29:59.000000', 'temperatura', 942.0000, 'ºC'),
	(335797, 143, '2015-02-01 00:30:00.000000', 'temperatura', 505.0000, 'ºC'),
	(335798, 143, '2015-02-01 00:30:01.000000', 'temperatura', 901.0000, 'ºC'),
	(335799, 143, '2015-02-01 00:30:02.000000', 'temperatura', 588.0000, 'ºC'),
	(335800, 143, '2015-02-01 00:30:03.000000', 'temperatura', 240.0000, 'ºC'),
	(335801, 143, '2015-02-01 00:30:04.000000', 'temperatura', 636.0000, 'ºC'),
	(335802, 143, '2015-02-01 00:30:05.000000', 'temperatura', 58.0000, 'ºC'),
	(335803, 143, '2015-02-01 00:30:06.000000', 'temperatura', 786.0000, 'ºC'),
	(335804, 143, '2015-02-01 00:30:07.000000', 'temperatura', 153.0000, 'ºC'),
	(335805, 143, '2015-02-01 00:30:08.000000', 'temperatura', 811.0000, 'ºC'),
	(335806, 143, '2015-02-01 00:30:09.000000', 'temperatura', 1196.0000, 'ºC'),
	(335807, 143, '2015-02-01 00:30:10.000000', 'temperatura', 1145.0000, 'ºC'),
	(335808, 143, '2015-02-01 00:30:11.000000', 'temperatura', 940.0000, 'ºC'),
	(335809, 143, '2015-02-01 00:30:12.000000', 'temperatura', 63.0000, 'ºC'),
	(335810, 143, '2015-02-01 00:30:13.000000', 'temperatura', 1095.0000, 'ºC'),
	(335811, 143, '2015-02-01 00:30:14.000000', 'temperatura', 488.0000, 'ºC'),
	(335812, 143, '2015-02-01 00:30:15.000000', 'temperatura', 357.0000, 'ºC'),
	(335813, 143, '2015-02-01 00:30:16.000000', 'temperatura', 319.0000, 'ºC'),
	(335814, 143, '2015-02-01 00:30:17.000000', 'temperatura', 525.0000, 'ºC'),
	(335815, 143, '2015-02-01 00:30:18.000000', 'temperatura', 468.0000, 'ºC'),
	(335816, 143, '2015-02-01 00:30:19.000000', 'temperatura', 766.0000, 'ºC'),
	(335817, 143, '2015-02-01 00:30:20.000000', 'temperatura', 25.0000, 'ºC'),
	(335818, 143, '2015-02-01 00:30:21.000000', 'temperatura', 230.0000, 'ºC'),
	(335819, 143, '2015-02-01 00:30:22.000000', 'temperatura', 1074.0000, 'ºC'),
	(335820, 143, '2015-02-01 00:30:23.000000', 'temperatura', 1083.0000, 'ºC'),
	(335821, 143, '2015-02-01 00:30:24.000000', 'temperatura', 991.0000, 'ºC'),
	(335822, 143, '2015-02-01 00:30:25.000000', 'temperatura', 509.0000, 'ºC'),
	(335823, 143, '2015-02-01 00:30:26.000000', 'temperatura', 772.0000, 'ºC'),
	(335824, 143, '2015-02-01 00:30:27.000000', 'temperatura', 1134.0000, 'ºC'),
	(335825, 143, '2015-02-01 00:30:28.000000', 'temperatura', 952.0000, 'ºC'),
	(335826, 143, '2015-02-01 00:30:29.000000', 'temperatura', 160.0000, 'ºC'),
	(335827, 143, '2015-02-01 00:30:30.000000', 'temperatura', 344.0000, 'ºC'),
	(335828, 143, '2015-02-01 00:30:31.000000', 'temperatura', 42.0000, 'ºC'),
	(335829, 143, '2015-02-01 00:30:32.000000', 'temperatura', 377.0000, 'ºC'),
	(335830, 143, '2015-02-01 00:30:33.000000', 'temperatura', 560.0000, 'ºC'),
	(335831, 143, '2015-02-01 00:30:34.000000', 'temperatura', 468.0000, 'ºC'),
	(335832, 143, '2015-02-01 00:30:35.000000', 'temperatura', 661.0000, 'ºC'),
	(335833, 143, '2015-02-01 00:30:36.000000', 'temperatura', 703.0000, 'ºC'),
	(335834, 143, '2015-02-01 00:30:37.000000', 'temperatura', 331.0000, 'ºC'),
	(335835, 143, '2015-02-01 00:30:38.000000', 'temperatura', 747.0000, 'ºC'),
	(335836, 143, '2015-02-01 00:30:39.000000', 'temperatura', 342.0000, 'ºC'),
	(335837, 143, '2015-02-01 00:30:40.000000', 'temperatura', 670.0000, 'ºC'),
	(335838, 143, '2015-02-01 00:30:41.000000', 'temperatura', 1124.0000, 'ºC'),
	(335839, 143, '2015-02-01 00:30:42.000000', 'temperatura', 9.0000, 'ºC'),
	(335840, 143, '2015-02-01 00:30:43.000000', 'temperatura', 275.0000, 'ºC'),
	(335841, 143, '2015-02-01 00:30:44.000000', 'temperatura', 150.0000, 'ºC'),
	(335842, 143, '2015-02-01 00:30:45.000000', 'temperatura', 1123.0000, 'ºC'),
	(335843, 143, '2015-02-01 00:30:46.000000', 'temperatura', 366.0000, 'ºC'),
	(335844, 143, '2015-02-01 00:30:47.000000', 'temperatura', 861.0000, 'ºC'),
	(335845, 143, '2015-02-01 00:30:48.000000', 'temperatura', 810.0000, 'ºC'),
	(335846, 143, '2015-02-01 00:30:49.000000', 'temperatura', 265.0000, 'ºC'),
	(335847, 143, '2015-02-01 00:30:50.000000', 'temperatura', 96.0000, 'ºC'),
	(335848, 143, '2015-02-01 00:30:51.000000', 'temperatura', 885.0000, 'ºC'),
	(335849, 143, '2015-02-01 00:30:52.000000', 'temperatura', 539.0000, 'ºC'),
	(335850, 143, '2015-02-01 00:30:53.000000', 'temperatura', 39.0000, 'ºC'),
	(335851, 143, '2015-02-01 00:30:54.000000', 'temperatura', 978.0000, 'ºC'),
	(335852, 143, '2015-02-01 00:30:55.000000', 'temperatura', 1172.0000, 'ºC'),
	(335853, 143, '2015-02-01 00:30:56.000000', 'temperatura', 529.0000, 'ºC'),
	(335854, 143, '2015-02-01 00:30:57.000000', 'temperatura', 330.0000, 'ºC'),
	(335855, 143, '2015-02-01 00:30:58.000000', 'temperatura', 63.0000, 'ºC'),
	(335856, 143, '2015-02-01 00:30:59.000000', 'temperatura', 526.0000, 'ºC'),
	(335857, 143, '2015-02-01 00:31:00.000000', 'temperatura', 41.0000, 'ºC'),
	(335858, 143, '2015-02-01 00:31:01.000000', 'temperatura', 1028.0000, 'ºC'),
	(335859, 143, '2015-02-01 00:31:02.000000', 'temperatura', 217.0000, 'ºC'),
	(335860, 143, '2015-02-01 00:31:03.000000', 'temperatura', 404.0000, 'ºC'),
	(335861, 143, '2015-02-01 00:31:04.000000', 'temperatura', 167.0000, 'ºC'),
	(335862, 143, '2015-02-01 00:31:05.000000', 'temperatura', 822.0000, 'ºC'),
	(335863, 143, '2015-02-01 00:31:06.000000', 'temperatura', 11.0000, 'ºC'),
	(335864, 143, '2015-02-01 00:31:07.000000', 'temperatura', 1190.0000, 'ºC'),
	(335865, 143, '2015-02-01 00:31:08.000000', 'temperatura', 1118.0000, 'ºC'),
	(335866, 143, '2015-02-01 00:31:09.000000', 'temperatura', 821.0000, 'ºC'),
	(335867, 143, '2015-02-01 00:31:10.000000', 'temperatura', 753.0000, 'ºC'),
	(335868, 143, '2015-02-01 00:31:11.000000', 'temperatura', 99.0000, 'ºC'),
	(335869, 143, '2015-02-01 00:31:12.000000', 'temperatura', 637.0000, 'ºC'),
	(335870, 143, '2015-02-01 00:31:13.000000', 'temperatura', 490.0000, 'ºC'),
	(335871, 143, '2015-02-01 00:31:14.000000', 'temperatura', 540.0000, 'ºC'),
	(335872, 143, '2015-02-01 00:31:15.000000', 'temperatura', 30.0000, 'ºC'),
	(335873, 143, '2015-02-01 00:31:16.000000', 'temperatura', 931.0000, 'ºC'),
	(335874, 143, '2015-02-01 00:31:17.000000', 'temperatura', 965.0000, 'ºC'),
	(335875, 143, '2015-02-01 00:31:18.000000', 'temperatura', 831.0000, 'ºC'),
	(335876, 143, '2015-02-01 00:31:19.000000', 'temperatura', 62.0000, 'ºC'),
	(335877, 143, '2015-02-01 00:31:20.000000', 'temperatura', 219.0000, 'ºC'),
	(335878, 143, '2015-02-01 00:31:21.000000', 'temperatura', 909.0000, 'ºC'),
	(335879, 143, '2015-02-01 00:31:22.000000', 'temperatura', 289.0000, 'ºC'),
	(335880, 143, '2015-02-01 00:31:23.000000', 'temperatura', 1117.0000, 'ºC'),
	(335881, 143, '2015-02-01 00:31:24.000000', 'temperatura', 1117.0000, 'ºC'),
	(335882, 143, '2015-02-01 00:31:25.000000', 'temperatura', 1036.0000, 'ºC'),
	(335883, 143, '2015-02-01 00:31:26.000000', 'temperatura', 629.0000, 'ºC'),
	(335884, 143, '2015-02-01 00:31:27.000000', 'temperatura', 37.0000, 'ºC'),
	(335885, 143, '2015-02-01 00:31:28.000000', 'temperatura', 698.0000, 'ºC'),
	(335886, 143, '2015-02-01 00:31:29.000000', 'temperatura', 979.0000, 'ºC'),
	(335887, 143, '2015-02-01 00:31:30.000000', 'temperatura', 402.0000, 'ºC'),
	(335888, 143, '2015-02-01 00:31:31.000000', 'temperatura', 273.0000, 'ºC'),
	(335889, 143, '2015-02-01 00:31:32.000000', 'temperatura', 162.0000, 'ºC'),
	(335890, 143, '2015-02-01 00:31:33.000000', 'temperatura', 1188.0000, 'ºC'),
	(335891, 143, '2015-02-01 00:31:34.000000', 'temperatura', 657.0000, 'ºC'),
	(335892, 143, '2015-02-01 00:31:35.000000', 'temperatura', 920.0000, 'ºC'),
	(335893, 143, '2015-02-01 00:31:36.000000', 'temperatura', 232.0000, 'ºC'),
	(335894, 143, '2015-02-01 00:31:37.000000', 'temperatura', 797.0000, 'ºC'),
	(335895, 143, '2015-02-01 00:31:38.000000', 'temperatura', 892.0000, 'ºC'),
	(335896, 143, '2015-02-01 00:31:39.000000', 'temperatura', 869.0000, 'ºC'),
	(335897, 143, '2015-02-01 00:31:40.000000', 'temperatura', 468.0000, 'ºC'),
	(335898, 143, '2015-02-01 00:31:41.000000', 'temperatura', 932.0000, 'ºC'),
	(335899, 143, '2015-02-01 00:31:42.000000', 'temperatura', 860.0000, 'ºC'),
	(335900, 143, '2015-02-01 00:31:43.000000', 'temperatura', 302.0000, 'ºC'),
	(335901, 143, '2015-02-01 00:31:44.000000', 'temperatura', 129.0000, 'ºC'),
	(335902, 143, '2015-02-01 00:31:45.000000', 'temperatura', 942.0000, 'ºC'),
	(335903, 143, '2015-02-01 00:31:46.000000', 'temperatura', 725.0000, 'ºC'),
	(335904, 143, '2015-02-01 00:31:47.000000', 'temperatura', 796.0000, 'ºC'),
	(335905, 143, '2015-02-01 00:31:48.000000', 'temperatura', 608.0000, 'ºC'),
	(335906, 143, '2015-02-01 00:31:49.000000', 'temperatura', 650.0000, 'ºC'),
	(335907, 143, '2015-02-01 00:31:50.000000', 'temperatura', 229.0000, 'ºC'),
	(335908, 143, '2015-02-01 00:31:51.000000', 'temperatura', 393.0000, 'ºC'),
	(335909, 143, '2015-02-01 00:31:52.000000', 'temperatura', 78.0000, 'ºC'),
	(335910, 143, '2015-02-01 00:31:53.000000', 'temperatura', 413.0000, 'ºC'),
	(335911, 143, '2015-02-01 00:31:54.000000', 'temperatura', 632.0000, 'ºC'),
	(335912, 143, '2015-02-01 00:31:55.000000', 'temperatura', 723.0000, 'ºC'),
	(335913, 143, '2015-02-01 00:31:56.000000', 'temperatura', 517.0000, 'ºC'),
	(335914, 143, '2015-02-01 00:31:57.000000', 'temperatura', 416.0000, 'ºC'),
	(335915, 143, '2015-02-01 00:31:58.000000', 'temperatura', 532.0000, 'ºC'),
	(335916, 143, '2015-02-01 00:31:59.000000', 'temperatura', 211.0000, 'ºC'),
	(335917, 143, '2015-02-01 00:32:00.000000', 'temperatura', 661.0000, 'ºC'),
	(335918, 143, '2015-02-01 00:32:01.000000', 'temperatura', 272.0000, 'ºC'),
	(335919, 143, '2015-02-01 00:32:02.000000', 'temperatura', 579.0000, 'ºC'),
	(335920, 143, '2015-02-01 00:32:03.000000', 'temperatura', 879.0000, 'ºC'),
	(335921, 143, '2015-02-01 00:32:04.000000', 'temperatura', 259.0000, 'ºC'),
	(335922, 143, '2015-02-01 00:32:05.000000', 'temperatura', 1058.0000, 'ºC'),
	(335923, 143, '2015-02-01 00:32:06.000000', 'temperatura', 914.0000, 'ºC'),
	(335924, 143, '2015-02-01 00:32:07.000000', 'temperatura', 196.0000, 'ºC'),
	(335925, 143, '2015-02-01 00:32:08.000000', 'temperatura', 640.0000, 'ºC'),
	(335926, 143, '2015-02-01 00:32:09.000000', 'temperatura', 213.0000, 'ºC'),
	(335927, 143, '2015-02-01 00:32:10.000000', 'temperatura', 345.0000, 'ºC'),
	(335928, 143, '2015-02-01 00:32:11.000000', 'temperatura', 1088.0000, 'ºC'),
	(335929, 143, '2015-02-01 00:32:12.000000', 'temperatura', 805.0000, 'ºC'),
	(335930, 143, '2015-02-01 00:32:13.000000', 'temperatura', 760.0000, 'ºC'),
	(335931, 143, '2015-02-01 00:32:14.000000', 'temperatura', 188.0000, 'ºC'),
	(335932, 143, '2015-02-01 00:32:15.000000', 'temperatura', 1058.0000, 'ºC'),
	(335933, 143, '2015-02-01 00:32:16.000000', 'temperatura', 1127.0000, 'ºC'),
	(335934, 143, '2015-02-01 00:32:17.000000', 'temperatura', 62.0000, 'ºC'),
	(335935, 143, '2015-02-01 00:32:18.000000', 'temperatura', 531.0000, 'ºC'),
	(335936, 143, '2015-02-01 00:32:19.000000', 'temperatura', 67.0000, 'ºC'),
	(335937, 143, '2015-02-01 00:32:20.000000', 'temperatura', 1142.0000, 'ºC'),
	(335938, 143, '2015-02-01 00:32:21.000000', 'temperatura', 712.0000, 'ºC'),
	(335939, 143, '2015-02-01 00:32:22.000000', 'temperatura', 136.0000, 'ºC'),
	(335940, 143, '2015-02-01 00:32:23.000000', 'temperatura', 941.0000, 'ºC'),
	(335941, 143, '2015-02-01 00:32:24.000000', 'temperatura', 698.0000, 'ºC'),
	(335942, 143, '2015-02-01 00:32:25.000000', 'temperatura', 668.0000, 'ºC'),
	(335943, 143, '2015-02-01 00:32:26.000000', 'temperatura', 48.0000, 'ºC'),
	(335944, 143, '2015-02-01 00:32:27.000000', 'temperatura', 637.0000, 'ºC'),
	(335945, 143, '2015-02-01 00:32:28.000000', 'temperatura', 642.0000, 'ºC'),
	(335946, 143, '2015-02-01 00:32:29.000000', 'temperatura', 99.0000, 'ºC'),
	(335947, 143, '2015-02-01 00:32:30.000000', 'temperatura', 967.0000, 'ºC'),
	(335948, 143, '2015-02-01 00:32:31.000000', 'temperatura', 942.0000, 'ºC'),
	(335949, 143, '2015-02-01 00:32:32.000000', 'temperatura', 608.0000, 'ºC'),
	(335950, 143, '2015-02-01 00:32:33.000000', 'temperatura', 216.0000, 'ºC'),
	(335951, 143, '2015-02-01 00:32:34.000000', 'temperatura', 456.0000, 'ºC'),
	(335952, 143, '2015-02-01 00:32:35.000000', 'temperatura', 433.0000, 'ºC'),
	(335953, 143, '2015-02-01 00:32:36.000000', 'temperatura', 797.0000, 'ºC'),
	(335954, 143, '2015-02-01 00:32:37.000000', 'temperatura', 287.0000, 'ºC'),
	(335955, 143, '2015-02-01 00:32:38.000000', 'temperatura', 245.0000, 'ºC'),
	(335956, 143, '2015-02-01 00:32:39.000000', 'temperatura', 363.0000, 'ºC'),
	(335957, 143, '2015-02-01 00:32:40.000000', 'temperatura', 1081.0000, 'ºC'),
	(335958, 143, '2015-02-01 00:32:41.000000', 'temperatura', 715.0000, 'ºC'),
	(335959, 143, '2015-02-01 00:32:42.000000', 'temperatura', 332.0000, 'ºC'),
	(335960, 143, '2015-02-01 00:32:43.000000', 'temperatura', 716.0000, 'ºC'),
	(335961, 143, '2015-02-01 00:32:44.000000', 'temperatura', 184.0000, 'ºC'),
	(335962, 143, '2015-02-01 00:32:45.000000', 'temperatura', 1173.0000, 'ºC'),
	(335963, 143, '2015-02-01 00:32:46.000000', 'temperatura', 512.0000, 'ºC'),
	(335964, 143, '2015-02-01 00:32:47.000000', 'temperatura', 243.0000, 'ºC'),
	(335965, 143, '2015-02-01 00:32:48.000000', 'temperatura', 878.0000, 'ºC'),
	(335966, 143, '2015-02-01 00:32:49.000000', 'temperatura', 64.0000, 'ºC'),
	(335967, 143, '2015-02-01 00:32:50.000000', 'temperatura', 86.0000, 'ºC'),
	(335968, 143, '2015-02-01 00:32:51.000000', 'temperatura', 236.0000, 'ºC'),
	(335969, 143, '2015-02-01 00:32:52.000000', 'temperatura', 926.0000, 'ºC'),
	(335970, 143, '2015-02-01 00:32:53.000000', 'temperatura', 320.0000, 'ºC'),
	(335971, 143, '2015-02-01 00:32:54.000000', 'temperatura', 24.0000, 'ºC'),
	(335972, 143, '2015-02-01 00:32:55.000000', 'temperatura', 360.0000, 'ºC'),
	(335973, 143, '2015-02-01 00:32:56.000000', 'temperatura', 529.0000, 'ºC'),
	(335974, 143, '2015-02-01 00:32:57.000000', 'temperatura', 365.0000, 'ºC'),
	(335975, 143, '2015-02-01 00:32:58.000000', 'temperatura', 237.0000, 'ºC'),
	(335976, 143, '2015-02-01 00:32:59.000000', 'temperatura', 94.0000, 'ºC'),
	(335977, 143, '2015-02-01 00:33:00.000000', 'temperatura', 956.0000, 'ºC'),
	(335978, 143, '2015-02-01 00:33:01.000000', 'temperatura', 901.0000, 'ºC'),
	(335979, 143, '2015-02-01 00:33:02.000000', 'temperatura', 435.0000, 'ºC'),
	(335980, 143, '2015-02-01 00:33:03.000000', 'temperatura', 673.0000, 'ºC'),
	(335981, 143, '2015-02-01 00:33:04.000000', 'temperatura', 859.0000, 'ºC'),
	(335982, 143, '2015-02-01 00:33:05.000000', 'temperatura', 1078.0000, 'ºC'),
	(335983, 143, '2015-02-01 00:33:06.000000', 'temperatura', 415.0000, 'ºC'),
	(335984, 143, '2015-02-01 00:33:07.000000', 'temperatura', 40.0000, 'ºC'),
	(335985, 143, '2015-02-01 00:33:08.000000', 'temperatura', 156.0000, 'ºC'),
	(335986, 143, '2015-02-01 00:33:09.000000', 'temperatura', 659.0000, 'ºC'),
	(335987, 143, '2015-02-01 00:33:10.000000', 'temperatura', 427.0000, 'ºC'),
	(335988, 143, '2015-02-01 00:33:11.000000', 'temperatura', 159.0000, 'ºC'),
	(335989, 143, '2015-02-01 00:33:12.000000', 'temperatura', 714.0000, 'ºC'),
	(335990, 143, '2015-02-01 00:33:13.000000', 'temperatura', 695.0000, 'ºC'),
	(335991, 143, '2015-02-01 00:33:14.000000', 'temperatura', 131.0000, 'ºC'),
	(335992, 143, '2015-02-01 00:33:15.000000', 'temperatura', 973.0000, 'ºC'),
	(335993, 143, '2015-02-01 00:33:16.000000', 'temperatura', 872.0000, 'ºC'),
	(335994, 143, '2015-02-01 00:33:17.000000', 'temperatura', 240.0000, 'ºC'),
	(335995, 143, '2015-02-01 00:33:18.000000', 'temperatura', 985.0000, 'ºC'),
	(335996, 143, '2015-02-01 00:33:19.000000', 'temperatura', 608.0000, 'ºC'),
	(335997, 143, '2015-02-01 00:33:20.000000', 'temperatura', 83.0000, 'ºC'),
	(335998, 143, '2015-02-01 00:33:21.000000', 'temperatura', 994.0000, 'ºC'),
	(335999, 143, '2015-02-01 00:33:22.000000', 'temperatura', 1121.0000, 'ºC'),
	(336000, 143, '2015-02-01 00:33:23.000000', 'temperatura', 224.0000, 'ºC'),
	(336001, 143, '2015-02-01 00:33:24.000000', 'temperatura', 155.0000, 'ºC'),
	(336002, 143, '2015-02-01 00:33:25.000000', 'temperatura', 107.0000, 'ºC'),
	(336003, 143, '2015-02-01 00:33:26.000000', 'temperatura', 68.0000, 'ºC'),
	(336004, 143, '2015-02-01 00:33:27.000000', 'temperatura', 20.0000, 'ºC'),
	(336005, 143, '2015-02-01 00:33:28.000000', 'temperatura', 1097.0000, 'ºC'),
	(336006, 143, '2015-02-01 00:33:29.000000', 'temperatura', 626.0000, 'ºC'),
	(336007, 143, '2015-02-01 00:33:30.000000', 'temperatura', 1041.0000, 'ºC'),
	(336008, 143, '2015-02-01 00:33:31.000000', 'temperatura', 926.0000, 'ºC'),
	(336009, 143, '2015-02-01 00:33:32.000000', 'temperatura', 309.0000, 'ºC'),
	(336010, 143, '2015-02-01 00:33:33.000000', 'temperatura', 1168.0000, 'ºC'),
	(336011, 143, '2015-02-01 00:33:34.000000', 'temperatura', 111.0000, 'ºC'),
	(336012, 143, '2015-02-01 00:33:35.000000', 'temperatura', 652.0000, 'ºC'),
	(336013, 143, '2015-02-01 00:33:36.000000', 'temperatura', 529.0000, 'ºC'),
	(336014, 143, '2015-02-01 00:33:37.000000', 'temperatura', 691.0000, 'ºC'),
	(336015, 143, '2015-02-01 00:33:38.000000', 'temperatura', 665.0000, 'ºC'),
	(336016, 143, '2015-02-01 00:33:39.000000', 'temperatura', 53.0000, 'ºC'),
	(336017, 143, '2015-02-01 00:33:40.000000', 'temperatura', 670.0000, 'ºC'),
	(336018, 143, '2015-02-01 00:33:41.000000', 'temperatura', 793.0000, 'ºC'),
	(336019, 143, '2015-02-01 00:33:42.000000', 'temperatura', 754.0000, 'ºC'),
	(336020, 143, '2015-02-01 00:33:43.000000', 'temperatura', 191.0000, 'ºC'),
	(336021, 143, '2015-02-01 00:33:44.000000', 'temperatura', 1096.0000, 'ºC'),
	(336022, 143, '2015-02-01 00:33:45.000000', 'temperatura', 108.0000, 'ºC'),
	(336023, 143, '2015-02-01 00:33:46.000000', 'temperatura', 851.0000, 'ºC'),
	(336024, 143, '2015-02-01 00:33:47.000000', 'temperatura', 334.0000, 'ºC'),
	(336025, 143, '2015-02-01 00:33:48.000000', 'temperatura', 314.0000, 'ºC'),
	(336026, 143, '2015-02-01 00:33:49.000000', 'temperatura', 572.0000, 'ºC'),
	(336027, 143, '2015-02-01 00:33:50.000000', 'temperatura', 717.0000, 'ºC'),
	(336028, 143, '2015-02-01 00:33:51.000000', 'temperatura', 668.0000, 'ºC'),
	(336029, 143, '2015-02-01 00:33:52.000000', 'temperatura', 1189.0000, 'ºC'),
	(336030, 143, '2015-02-01 00:33:53.000000', 'temperatura', 344.0000, 'ºC'),
	(336031, 143, '2015-02-01 00:33:54.000000', 'temperatura', 553.0000, 'ºC'),
	(336032, 143, '2015-02-01 00:33:55.000000', 'temperatura', 533.0000, 'ºC'),
	(336033, 143, '2015-02-01 00:33:56.000000', 'temperatura', 1007.0000, 'ºC'),
	(336034, 143, '2015-02-01 00:33:57.000000', 'temperatura', 1038.0000, 'ºC'),
	(336035, 143, '2015-02-01 00:33:58.000000', 'temperatura', 968.0000, 'ºC'),
	(336036, 143, '2015-02-01 00:33:59.000000', 'temperatura', 528.0000, 'ºC'),
	(336037, 143, '2015-02-01 00:34:00.000000', 'temperatura', 938.0000, 'ºC'),
	(336038, 143, '2015-02-01 00:34:01.000000', 'temperatura', 703.0000, 'ºC'),
	(336039, 143, '2015-02-01 00:34:02.000000', 'temperatura', 702.0000, 'ºC'),
	(336040, 143, '2015-02-01 00:34:03.000000', 'temperatura', 204.0000, 'ºC'),
	(336041, 143, '2015-02-01 00:34:04.000000', 'temperatura', 112.0000, 'ºC'),
	(336042, 143, '2015-02-01 00:34:05.000000', 'temperatura', 1151.0000, 'ºC'),
	(336043, 143, '2015-02-01 00:34:06.000000', 'temperatura', 618.0000, 'ºC'),
	(336044, 143, '2015-02-01 00:34:07.000000', 'temperatura', 839.0000, 'ºC'),
	(336045, 143, '2015-02-01 00:34:08.000000', 'temperatura', 1141.0000, 'ºC'),
	(336046, 143, '2015-02-01 00:34:09.000000', 'temperatura', 788.0000, 'ºC'),
	(336047, 143, '2015-02-01 00:34:10.000000', 'temperatura', 518.0000, 'ºC'),
	(336048, 143, '2015-02-01 00:34:11.000000', 'temperatura', 225.0000, 'ºC'),
	(336049, 143, '2015-02-01 00:34:12.000000', 'temperatura', 773.0000, 'ºC'),
	(336050, 143, '2015-02-01 00:34:13.000000', 'temperatura', 790.0000, 'ºC'),
	(336051, 143, '2015-02-01 00:34:14.000000', 'temperatura', 431.0000, 'ºC'),
	(336052, 143, '2015-02-01 00:34:15.000000', 'temperatura', 987.0000, 'ºC'),
	(336053, 143, '2015-02-01 00:34:16.000000', 'temperatura', 40.0000, 'ºC'),
	(336054, 143, '2015-02-01 00:34:17.000000', 'temperatura', 843.0000, 'ºC'),
	(336055, 143, '2015-02-01 00:34:18.000000', 'temperatura', 493.0000, 'ºC'),
	(336056, 143, '2015-02-01 00:34:19.000000', 'temperatura', 1136.0000, 'ºC'),
	(336057, 143, '2015-02-01 00:34:20.000000', 'temperatura', 604.0000, 'ºC'),
	(336058, 143, '2015-02-01 00:34:21.000000', 'temperatura', 813.0000, 'ºC'),
	(336059, 143, '2015-02-01 00:34:22.000000', 'temperatura', 1052.0000, 'ºC'),
	(336060, 143, '2015-02-01 00:34:23.000000', 'temperatura', 424.0000, 'ºC'),
	(336061, 143, '2015-02-01 00:34:24.000000', 'temperatura', 161.0000, 'ºC'),
	(336062, 143, '2015-02-01 00:34:25.000000', 'temperatura', 737.0000, 'ºC'),
	(336063, 143, '2015-02-01 00:34:26.000000', 'temperatura', 800.0000, 'ºC'),
	(336064, 143, '2015-02-01 00:34:27.000000', 'temperatura', 588.0000, 'ºC'),
	(336065, 143, '2015-02-01 00:34:28.000000', 'temperatura', 543.0000, 'ºC'),
	(336066, 143, '2015-02-01 00:34:29.000000', 'temperatura', 950.0000, 'ºC'),
	(336067, 143, '2015-02-01 00:34:30.000000', 'temperatura', 721.0000, 'ºC'),
	(336068, 143, '2015-02-01 00:34:31.000000', 'temperatura', 758.0000, 'ºC'),
	(336069, 143, '2015-02-01 00:34:32.000000', 'temperatura', 426.0000, 'ºC'),
	(336070, 143, '2015-02-01 00:34:33.000000', 'temperatura', 1056.0000, 'ºC'),
	(336071, 143, '2015-02-01 00:34:34.000000', 'temperatura', 404.0000, 'ºC'),
	(336072, 143, '2015-02-01 00:34:35.000000', 'temperatura', 50.0000, 'ºC'),
	(336073, 143, '2015-02-01 00:34:36.000000', 'temperatura', 241.0000, 'ºC'),
	(336074, 143, '2015-02-01 00:34:37.000000', 'temperatura', 1053.0000, 'ºC'),
	(336075, 143, '2015-02-01 00:34:38.000000', 'temperatura', 945.0000, 'ºC'),
	(336076, 143, '2015-02-01 00:34:39.000000', 'temperatura', 367.0000, 'ºC'),
	(336077, 143, '2015-02-01 00:34:40.000000', 'temperatura', 198.0000, 'ºC'),
	(336078, 143, '2015-02-01 00:34:41.000000', 'temperatura', 1091.0000, 'ºC'),
	(336079, 143, '2015-02-01 00:34:42.000000', 'temperatura', 62.0000, 'ºC'),
	(336080, 143, '2015-02-01 00:34:43.000000', 'temperatura', 638.0000, 'ºC'),
	(336081, 143, '2015-02-01 00:34:44.000000', 'temperatura', 606.0000, 'ºC'),
	(336082, 143, '2015-02-01 00:34:45.000000', 'temperatura', 1113.0000, 'ºC'),
	(336083, 143, '2015-02-01 00:34:46.000000', 'temperatura', 149.0000, 'ºC'),
	(336084, 143, '2015-02-01 00:34:47.000000', 'temperatura', 1007.0000, 'ºC'),
	(336085, 143, '2015-02-01 00:34:48.000000', 'temperatura', 989.0000, 'ºC'),
	(336086, 143, '2015-02-01 00:34:49.000000', 'temperatura', 725.0000, 'ºC'),
	(336087, 143, '2015-02-01 00:34:50.000000', 'temperatura', 656.0000, 'ºC'),
	(336088, 143, '2015-02-01 00:34:51.000000', 'temperatura', 1106.0000, 'ºC'),
	(336089, 143, '2015-02-01 00:34:52.000000', 'temperatura', 1163.0000, 'ºC'),
	(336090, 143, '2015-02-01 00:34:53.000000', 'temperatura', 97.0000, 'ºC'),
	(336091, 143, '2015-02-01 00:34:54.000000', 'temperatura', 597.0000, 'ºC'),
	(336092, 143, '2015-02-01 00:34:55.000000', 'temperatura', 293.0000, 'ºC'),
	(336093, 143, '2015-02-01 00:34:56.000000', 'temperatura', 876.0000, 'ºC'),
	(336094, 143, '2015-02-01 00:34:57.000000', 'temperatura', 1100.0000, 'ºC'),
	(336095, 143, '2015-02-01 00:34:58.000000', 'temperatura', 475.0000, 'ºC'),
	(336096, 143, '2015-02-01 00:34:59.000000', 'temperatura', 275.0000, 'ºC'),
	(336097, 143, '2015-02-01 00:35:00.000000', 'temperatura', 1152.0000, 'ºC'),
	(336098, 143, '2015-02-01 00:35:01.000000', 'temperatura', 134.0000, 'ºC'),
	(336099, 143, '2015-02-01 00:35:02.000000', 'temperatura', 813.0000, 'ºC'),
	(336100, 143, '2015-02-01 00:35:03.000000', 'temperatura', 67.0000, 'ºC'),
	(336101, 143, '2015-02-01 00:35:04.000000', 'temperatura', 293.0000, 'ºC'),
	(336102, 143, '2015-02-01 00:35:05.000000', 'temperatura', 68.0000, 'ºC'),
	(336103, 143, '2015-02-01 00:35:06.000000', 'temperatura', 659.0000, 'ºC'),
	(336104, 143, '2015-02-01 00:35:07.000000', 'temperatura', 690.0000, 'ºC'),
	(336105, 143, '2015-02-01 00:35:08.000000', 'temperatura', 276.0000, 'ºC'),
	(336106, 143, '2015-02-01 00:35:09.000000', 'temperatura', 509.0000, 'ºC'),
	(336107, 143, '2015-02-01 00:35:10.000000', 'temperatura', 518.0000, 'ºC'),
	(336108, 143, '2015-02-01 00:35:11.000000', 'temperatura', 1065.0000, 'ºC'),
	(336109, 143, '2015-02-01 00:35:12.000000', 'temperatura', 168.0000, 'ºC'),
	(336110, 143, '2015-02-01 00:35:13.000000', 'temperatura', 49.0000, 'ºC'),
	(336111, 143, '2015-02-01 00:35:14.000000', 'temperatura', 941.0000, 'ºC'),
	(336112, 143, '2015-02-01 00:35:15.000000', 'temperatura', 957.0000, 'ºC'),
	(336113, 143, '2015-02-01 00:35:16.000000', 'temperatura', 762.0000, 'ºC'),
	(336114, 143, '2015-02-01 00:35:17.000000', 'temperatura', 940.0000, 'ºC'),
	(336115, 143, '2015-02-01 00:35:18.000000', 'temperatura', 14.0000, 'ºC'),
	(336116, 143, '2015-02-01 00:35:19.000000', 'temperatura', 850.0000, 'ºC'),
	(336117, 143, '2015-02-01 00:35:20.000000', 'temperatura', 609.0000, 'ºC'),
	(336118, 143, '2015-02-01 00:35:21.000000', 'temperatura', 496.0000, 'ºC'),
	(336119, 143, '2015-02-01 00:35:22.000000', 'temperatura', 652.0000, 'ºC'),
	(336120, 143, '2015-02-01 00:35:23.000000', 'temperatura', 575.0000, 'ºC'),
	(336121, 143, '2015-02-01 00:35:24.000000', 'temperatura', 918.0000, 'ºC'),
	(336122, 143, '2015-02-01 00:35:25.000000', 'temperatura', 464.0000, 'ºC'),
	(336123, 143, '2015-02-01 00:35:26.000000', 'temperatura', 767.0000, 'ºC'),
	(336124, 143, '2015-02-01 00:35:27.000000', 'temperatura', 42.0000, 'ºC'),
	(336125, 143, '2015-02-01 00:35:28.000000', 'temperatura', 311.0000, 'ºC'),
	(336126, 143, '2015-02-01 00:35:29.000000', 'temperatura', 228.0000, 'ºC'),
	(336127, 143, '2015-02-01 00:35:30.000000', 'temperatura', 209.0000, 'ºC'),
	(336128, 143, '2015-02-01 00:35:31.000000', 'temperatura', 363.0000, 'ºC'),
	(336129, 143, '2015-02-01 00:35:32.000000', 'temperatura', 1186.0000, 'ºC'),
	(336130, 143, '2015-02-01 00:35:33.000000', 'temperatura', 41.0000, 'ºC'),
	(336131, 143, '2015-02-01 00:35:34.000000', 'temperatura', 249.0000, 'ºC'),
	(336132, 143, '2015-02-01 00:35:35.000000', 'temperatura', 1121.0000, 'ºC'),
	(336133, 143, '2015-02-01 00:35:36.000000', 'temperatura', 60.0000, 'ºC'),
	(336134, 143, '2015-02-01 00:35:37.000000', 'temperatura', 536.0000, 'ºC'),
	(336135, 143, '2015-02-01 00:35:38.000000', 'temperatura', 102.0000, 'ºC'),
	(336136, 143, '2015-02-01 00:35:39.000000', 'temperatura', 102.0000, 'ºC'),
	(336137, 143, '2015-02-01 00:35:40.000000', 'temperatura', 205.0000, 'ºC'),
	(336138, 143, '2015-02-01 00:35:41.000000', 'temperatura', 718.0000, 'ºC'),
	(336139, 143, '2015-02-01 00:35:42.000000', 'temperatura', 575.0000, 'ºC'),
	(336140, 143, '2015-02-01 00:35:43.000000', 'temperatura', 722.0000, 'ºC'),
	(336141, 143, '2015-02-01 00:35:44.000000', 'temperatura', 685.0000, 'ºC'),
	(336142, 143, '2015-02-01 00:35:45.000000', 'temperatura', 59.0000, 'ºC'),
	(336143, 143, '2015-02-01 00:35:46.000000', 'temperatura', 639.0000, 'ºC'),
	(336144, 143, '2015-02-01 00:35:47.000000', 'temperatura', 621.0000, 'ºC'),
	(336145, 143, '2015-02-01 00:35:48.000000', 'temperatura', 1189.0000, 'ºC'),
	(336146, 143, '2015-02-01 00:35:49.000000', 'temperatura', 481.0000, 'ºC'),
	(336147, 143, '2015-02-01 00:35:50.000000', 'temperatura', 38.0000, 'ºC'),
	(336148, 143, '2015-02-01 00:35:51.000000', 'temperatura', 1147.0000, 'ºC'),
	(336149, 143, '2015-02-01 00:35:52.000000', 'temperatura', 823.0000, 'ºC'),
	(336150, 143, '2015-02-01 00:35:53.000000', 'temperatura', 676.0000, 'ºC'),
	(336151, 143, '2015-02-01 00:35:54.000000', 'temperatura', 910.0000, 'ºC'),
	(336152, 143, '2015-02-01 00:35:55.000000', 'temperatura', 121.0000, 'ºC'),
	(336153, 143, '2015-02-01 00:35:56.000000', 'temperatura', 275.0000, 'ºC'),
	(336154, 143, '2015-02-01 00:35:57.000000', 'temperatura', 1015.0000, 'ºC'),
	(336155, 143, '2015-02-01 00:35:58.000000', 'temperatura', 650.0000, 'ºC'),
	(336156, 143, '2015-02-01 00:35:59.000000', 'temperatura', 204.0000, 'ºC'),
	(336157, 143, '2015-02-01 00:36:00.000000', 'temperatura', 273.0000, 'ºC'),
	(336158, 143, '2015-02-01 00:36:01.000000', 'temperatura', 753.0000, 'ºC'),
	(336159, 143, '2015-02-01 00:36:02.000000', 'temperatura', 546.0000, 'ºC'),
	(336160, 143, '2015-02-01 00:36:03.000000', 'temperatura', 473.0000, 'ºC'),
	(336161, 143, '2015-02-01 00:36:04.000000', 'temperatura', 728.0000, 'ºC'),
	(336162, 143, '2015-02-01 00:36:05.000000', 'temperatura', 1022.0000, 'ºC'),
	(336163, 143, '2015-02-01 00:36:06.000000', 'temperatura', 524.0000, 'ºC'),
	(336164, 143, '2015-02-01 00:36:07.000000', 'temperatura', 754.0000, 'ºC'),
	(336165, 143, '2015-02-01 00:36:08.000000', 'temperatura', 1002.0000, 'ºC'),
	(336166, 143, '2015-02-01 00:36:09.000000', 'temperatura', 345.0000, 'ºC'),
	(336167, 143, '2015-02-01 00:36:10.000000', 'temperatura', 1120.0000, 'ºC'),
	(336168, 143, '2015-02-01 00:36:11.000000', 'temperatura', 966.0000, 'ºC'),
	(336169, 143, '2015-02-01 00:36:12.000000', 'temperatura', 271.0000, 'ºC'),
	(336170, 143, '2015-02-01 00:36:13.000000', 'temperatura', 857.0000, 'ºC'),
	(336171, 143, '2015-02-01 00:36:14.000000', 'temperatura', 1072.0000, 'ºC'),
	(336172, 143, '2015-02-01 00:36:15.000000', 'temperatura', 392.0000, 'ºC'),
	(336173, 143, '2015-02-01 00:36:16.000000', 'temperatura', 1142.0000, 'ºC'),
	(336174, 143, '2015-02-01 00:36:17.000000', 'temperatura', 935.0000, 'ºC'),
	(336175, 143, '2015-02-01 00:36:18.000000', 'temperatura', 48.0000, 'ºC'),
	(336176, 143, '2015-02-01 00:36:19.000000', 'temperatura', 1037.0000, 'ºC'),
	(336177, 143, '2015-02-01 00:36:20.000000', 'temperatura', 241.0000, 'ºC'),
	(336178, 143, '2015-02-01 00:36:21.000000', 'temperatura', 497.0000, 'ºC'),
	(336179, 143, '2015-02-01 00:36:22.000000', 'temperatura', 560.0000, 'ºC'),
	(336180, 143, '2015-02-01 00:36:23.000000', 'temperatura', 110.0000, 'ºC'),
	(336181, 143, '2015-02-01 00:36:24.000000', 'temperatura', 70.0000, 'ºC'),
	(336182, 143, '2015-02-01 00:36:25.000000', 'temperatura', 19.0000, 'ºC'),
	(336183, 143, '2015-02-01 00:36:26.000000', 'temperatura', 1089.0000, 'ºC'),
	(336184, 143, '2015-02-01 00:36:27.000000', 'temperatura', 586.0000, 'ºC'),
	(336185, 143, '2015-02-01 00:36:28.000000', 'temperatura', 862.0000, 'ºC'),
	(336186, 143, '2015-02-01 00:36:29.000000', 'temperatura', 155.0000, 'ºC'),
	(336187, 143, '2015-02-01 00:36:30.000000', 'temperatura', 589.0000, 'ºC'),
	(336188, 143, '2015-02-01 00:36:31.000000', 'temperatura', 81.0000, 'ºC'),
	(336189, 143, '2015-02-01 00:36:32.000000', 'temperatura', 1038.0000, 'ºC'),
	(336190, 143, '2015-02-01 00:36:33.000000', 'temperatura', 148.0000, 'ºC'),
	(336191, 143, '2015-02-01 00:36:34.000000', 'temperatura', 27.0000, 'ºC'),
	(336192, 143, '2015-02-01 00:36:35.000000', 'temperatura', 891.0000, 'ºC'),
	(336193, 143, '2015-02-01 00:36:36.000000', 'temperatura', 776.0000, 'ºC'),
	(336194, 143, '2015-02-01 00:36:37.000000', 'temperatura', 5.0000, 'ºC'),
	(336195, 143, '2015-02-01 00:36:38.000000', 'temperatura', 98.0000, 'ºC'),
	(336196, 143, '2015-02-01 00:36:39.000000', 'temperatura', 476.0000, 'ºC'),
	(336197, 143, '2015-02-01 00:36:40.000000', 'temperatura', 885.0000, 'ºC'),
	(336198, 143, '2015-02-01 00:36:41.000000', 'temperatura', 598.0000, 'ºC'),
	(336199, 143, '2015-02-01 00:36:42.000000', 'temperatura', 334.0000, 'ºC'),
	(336200, 143, '2015-02-01 00:36:43.000000', 'temperatura', 1078.0000, 'ºC'),
	(336201, 143, '2015-02-01 00:36:44.000000', 'temperatura', 788.0000, 'ºC'),
	(336202, 143, '2015-02-01 00:36:45.000000', 'temperatura', 705.0000, 'ºC'),
	(336203, 143, '2015-02-01 00:36:46.000000', 'temperatura', 1163.0000, 'ºC'),
	(336204, 143, '2015-02-01 00:36:47.000000', 'temperatura', 100.0000, 'ºC'),
	(336205, 143, '2015-02-01 00:36:48.000000', 'temperatura', 613.0000, 'ºC'),
	(336206, 143, '2015-02-01 00:36:49.000000', 'temperatura', 366.0000, 'ºC'),
	(336207, 143, '2015-02-01 00:36:50.000000', 'temperatura', 1191.0000, 'ºC'),
	(336208, 143, '2015-02-01 00:36:51.000000', 'temperatura', 58.0000, 'ºC'),
	(336209, 143, '2015-02-01 00:36:52.000000', 'temperatura', 319.0000, 'ºC'),
	(336210, 143, '2015-02-01 00:36:53.000000', 'temperatura', 220.0000, 'ºC'),
	(336211, 143, '2015-02-01 00:36:54.000000', 'temperatura', 142.0000, 'ºC'),
	(336212, 143, '2015-02-01 00:36:55.000000', 'temperatura', 52.0000, 'ºC'),
	(336213, 143, '2015-02-01 00:36:56.000000', 'temperatura', 1033.0000, 'ºC'),
	(336214, 143, '2015-02-01 00:36:57.000000', 'temperatura', 211.0000, 'ºC'),
	(336215, 143, '2015-02-01 00:36:58.000000', 'temperatura', 355.0000, 'ºC'),
	(336216, 143, '2015-02-01 00:36:59.000000', 'temperatura', 1144.0000, 'ºC'),
	(336217, 143, '2015-02-01 00:37:00.000000', 'temperatura', 1055.0000, 'ºC'),
	(336218, 143, '2015-02-01 00:37:01.000000', 'temperatura', 643.0000, 'ºC'),
	(336219, 143, '2015-02-01 00:37:02.000000', 'temperatura', 50.0000, 'ºC'),
	(336220, 143, '2015-02-01 00:37:03.000000', 'temperatura', 724.0000, 'ºC'),
	(336221, 143, '2015-02-01 00:37:04.000000', 'temperatura', 1068.0000, 'ºC'),
	(336222, 143, '2015-02-01 00:37:05.000000', 'temperatura', 768.0000, 'ºC'),
	(336223, 143, '2015-02-01 00:37:06.000000', 'temperatura', 637.0000, 'ºC'),
	(336224, 143, '2015-02-01 00:37:07.000000', 'temperatura', 882.0000, 'ºC'),
	(336225, 143, '2015-02-01 00:37:08.000000', 'temperatura', 99.0000, 'ºC'),
	(336226, 143, '2015-02-01 00:37:09.000000', 'temperatura', 251.0000, 'ºC'),
	(336227, 143, '2015-02-01 00:37:10.000000', 'temperatura', 960.0000, 'ºC'),
	(336228, 143, '2015-02-01 00:37:11.000000', 'temperatura', 444.0000, 'ºC'),
	(336229, 143, '2015-02-01 00:37:12.000000', 'temperatura', 543.0000, 'ºC'),
	(336230, 143, '2015-02-01 00:37:13.000000', 'temperatura', 184.0000, 'ºC'),
	(336231, 143, '2015-02-01 00:37:14.000000', 'temperatura', 492.0000, 'ºC'),
	(336232, 143, '2015-02-01 00:37:15.000000', 'temperatura', 707.0000, 'ºC'),
	(336233, 143, '2015-02-01 00:37:16.000000', 'temperatura', 859.0000, 'ºC'),
	(336234, 143, '2015-02-01 00:37:17.000000', 'temperatura', 975.0000, 'ºC'),
	(336235, 143, '2015-02-01 00:37:18.000000', 'temperatura', 1099.0000, 'ºC'),
	(336236, 143, '2015-02-01 00:37:19.000000', 'temperatura', 168.0000, 'ºC'),
	(336237, 143, '2015-02-01 00:37:20.000000', 'temperatura', 1147.0000, 'ºC'),
	(336238, 143, '2015-02-01 00:37:21.000000', 'temperatura', 429.0000, 'ºC'),
	(336239, 143, '2015-02-01 00:37:22.000000', 'temperatura', 1105.0000, 'ºC'),
	(336240, 143, '2015-02-01 00:37:23.000000', 'temperatura', 637.0000, 'ºC'),
	(336241, 143, '2015-02-01 00:37:24.000000', 'temperatura', 1072.0000, 'ºC'),
	(336242, 143, '2015-02-01 00:37:25.000000', 'temperatura', 1048.0000, 'ºC'),
	(336243, 143, '2015-02-01 00:37:26.000000', 'temperatura', 826.0000, 'ºC'),
	(336244, 143, '2015-02-01 00:37:27.000000', 'temperatura', 987.0000, 'ºC'),
	(336245, 143, '2015-02-01 00:37:28.000000', 'temperatura', 59.0000, 'ºC'),
	(336246, 143, '2015-02-01 00:37:29.000000', 'temperatura', 933.0000, 'ºC'),
	(336247, 143, '2015-02-01 00:37:30.000000', 'temperatura', 887.0000, 'ºC'),
	(336248, 143, '2015-02-01 00:37:31.000000', 'temperatura', 436.0000, 'ºC'),
	(336249, 143, '2015-02-01 00:37:32.000000', 'temperatura', 722.0000, 'ºC'),
	(336250, 143, '2015-02-01 00:37:33.000000', 'temperatura', 1102.0000, 'ºC'),
	(336251, 143, '2015-02-01 00:37:34.000000', 'temperatura', 944.0000, 'ºC'),
	(336252, 143, '2015-02-01 00:37:35.000000', 'temperatura', 216.0000, 'ºC'),
	(336253, 143, '2015-02-01 00:37:36.000000', 'temperatura', 649.0000, 'ºC'),
	(336254, 143, '2015-02-01 00:37:37.000000', 'temperatura', 199.0000, 'ºC'),
	(336255, 143, '2015-02-01 00:37:38.000000', 'temperatura', 245.0000, 'ºC'),
	(336256, 143, '2015-02-01 00:37:39.000000', 'temperatura', 628.0000, 'ºC'),
	(336257, 143, '2015-02-01 00:37:40.000000', 'temperatura', 9.0000, 'ºC'),
	(336258, 143, '2015-02-01 00:37:41.000000', 'temperatura', 558.0000, 'ºC'),
	(336259, 143, '2015-02-01 00:37:42.000000', 'temperatura', 364.0000, 'ºC'),
	(336260, 143, '2015-02-01 00:37:43.000000', 'temperatura', 148.0000, 'ºC'),
	(336261, 143, '2015-02-01 00:37:44.000000', 'temperatura', 848.0000, 'ºC'),
	(336262, 143, '2015-02-01 00:37:45.000000', 'temperatura', 198.0000, 'ºC'),
	(336263, 143, '2015-02-01 00:37:46.000000', 'temperatura', 847.0000, 'ºC'),
	(336264, 143, '2015-02-01 00:37:47.000000', 'temperatura', 40.0000, 'ºC'),
	(336265, 143, '2015-02-01 00:37:48.000000', 'temperatura', 60.0000, 'ºC'),
	(336266, 143, '2015-02-01 00:37:49.000000', 'temperatura', 180.0000, 'ºC'),
	(336267, 143, '2015-02-01 00:37:50.000000', 'temperatura', 721.0000, 'ºC'),
	(336268, 143, '2015-02-01 00:37:51.000000', 'temperatura', 664.0000, 'ºC'),
	(336269, 143, '2015-02-01 00:37:52.000000', 'temperatura', 1156.0000, 'ºC'),
	(336270, 143, '2015-02-01 00:37:53.000000', 'temperatura', 192.0000, 'ºC'),
	(336271, 143, '2015-02-01 00:37:54.000000', 'temperatura', 1090.0000, 'ºC'),
	(336272, 143, '2015-02-01 00:37:55.000000', 'temperatura', 75.0000, 'ºC'),
	(336273, 143, '2015-02-01 00:37:56.000000', 'temperatura', 706.0000, 'ºC'),
	(336274, 143, '2015-02-01 00:37:57.000000', 'temperatura', 903.0000, 'ºC'),
	(336275, 143, '2015-02-01 00:37:58.000000', 'temperatura', 0.0000, 'ºC'),
	(336276, 143, '2015-02-01 00:37:59.000000', 'temperatura', 893.0000, 'ºC'),
	(336277, 143, '2015-02-01 00:38:00.000000', 'temperatura', 862.0000, 'ºC'),
	(336278, 143, '2015-02-01 00:38:01.000000', 'temperatura', 434.0000, 'ºC'),
	(336279, 143, '2015-02-01 00:38:02.000000', 'temperatura', 782.0000, 'ºC'),
	(336280, 143, '2015-02-01 00:38:03.000000', 'temperatura', 209.0000, 'ºC'),
	(336281, 143, '2015-02-01 00:38:04.000000', 'temperatura', 1101.0000, 'ºC'),
	(336282, 143, '2015-02-01 00:38:05.000000', 'temperatura', 77.0000, 'ºC'),
	(336283, 143, '2015-02-01 00:38:06.000000', 'temperatura', 681.0000, 'ºC'),
	(336284, 143, '2015-02-01 00:38:07.000000', 'temperatura', 778.0000, 'ºC'),
	(336285, 143, '2015-02-01 00:38:08.000000', 'temperatura', 645.0000, 'ºC'),
	(336286, 143, '2015-02-01 00:38:09.000000', 'temperatura', 892.0000, 'ºC'),
	(336287, 143, '2015-02-01 00:38:10.000000', 'temperatura', 125.0000, 'ºC'),
	(336288, 143, '2015-02-01 00:38:11.000000', 'temperatura', 350.0000, 'ºC'),
	(336289, 143, '2015-02-01 00:38:12.000000', 'temperatura', 177.0000, 'ºC'),
	(336290, 143, '2015-02-01 00:38:13.000000', 'temperatura', 1035.0000, 'ºC'),
	(336291, 143, '2015-02-01 00:38:14.000000', 'temperatura', 1043.0000, 'ºC'),
	(336292, 143, '2015-02-01 00:38:15.000000', 'temperatura', 909.0000, 'ºC'),
	(336293, 143, '2015-02-01 00:38:16.000000', 'temperatura', 219.0000, 'ºC'),
	(336294, 143, '2015-02-01 00:38:17.000000', 'temperatura', 769.0000, 'ºC'),
	(336295, 143, '2015-02-01 00:38:18.000000', 'temperatura', 787.0000, 'ºC'),
	(336296, 143, '2015-02-01 00:38:19.000000', 'temperatura', 430.0000, 'ºC'),
	(336297, 143, '2015-02-01 00:38:20.000000', 'temperatura', 988.0000, 'ºC'),
	(336298, 143, '2015-02-01 00:38:21.000000', 'temperatura', 53.0000, 'ºC'),
	(336299, 143, '2015-02-01 00:38:22.000000', 'temperatura', 899.0000, 'ºC'),
	(336300, 143, '2015-02-01 00:38:23.000000', 'temperatura', 739.0000, 'ºC'),
	(336301, 143, '2015-02-01 00:38:24.000000', 'temperatura', 998.0000, 'ºC'),
	(336302, 143, '2015-02-01 00:38:25.000000', 'temperatura', 372.0000, 'ºC'),
	(336303, 143, '2015-02-01 00:38:26.000000', 'temperatura', 67.0000, 'ºC'),
	(336304, 143, '2015-02-01 00:38:27.000000', 'temperatura', 419.0000, 'ºC'),
	(336305, 143, '2015-02-01 00:38:28.000000', 'temperatura', 697.0000, 'ºC'),
	(336306, 143, '2015-02-01 00:38:29.000000', 'temperatura', 1027.0000, 'ºC'),
	(336307, 143, '2015-02-01 00:38:30.000000', 'temperatura', 643.0000, 'ºC'),
	(336308, 143, '2015-02-01 00:38:31.000000', 'temperatura', 136.0000, 'ºC'),
	(336309, 143, '2015-02-01 00:38:32.000000', 'temperatura', 1152.0000, 'ºC'),
	(336310, 143, '2015-02-01 00:38:33.000000', 'temperatura', 550.0000, 'ºC'),
	(336311, 143, '2015-02-01 00:38:34.000000', 'temperatura', 497.0000, 'ºC'),
	(336312, 143, '2015-02-01 00:38:35.000000', 'temperatura', 833.0000, 'ºC'),
	(336313, 143, '2015-02-01 00:38:36.000000', 'temperatura', 276.0000, 'ºC'),
	(336314, 143, '2015-02-01 00:38:37.000000', 'temperatura', 80.0000, 'ºC'),
	(336315, 143, '2015-02-01 00:38:38.000000', 'temperatura', 773.0000, 'ºC'),
	(336316, 143, '2015-02-01 00:38:39.000000', 'temperatura', 24.0000, 'ºC'),
	(336317, 143, '2015-02-01 00:38:40.000000', 'temperatura', 204.0000, 'ºC'),
	(336318, 143, '2015-02-01 00:38:41.000000', 'temperatura', 949.0000, 'ºC'),
	(336319, 143, '2015-02-01 00:38:42.000000', 'temperatura', 534.0000, 'ºC'),
	(336320, 143, '2015-02-01 00:38:43.000000', 'temperatura', 1021.0000, 'ºC'),
	(336321, 143, '2015-02-01 00:38:44.000000', 'temperatura', 1104.0000, 'ºC'),
	(336322, 143, '2015-02-01 00:38:45.000000', 'temperatura', 59.0000, 'ºC'),
	(336323, 143, '2015-02-01 00:38:46.000000', 'temperatura', 584.0000, 'ºC'),
	(336324, 143, '2015-02-01 00:38:47.000000', 'temperatura', 342.0000, 'ºC'),
	(336325, 143, '2015-02-01 00:38:48.000000', 'temperatura', 1157.0000, 'ºC'),
	(336326, 143, '2015-02-01 00:38:49.000000', 'temperatura', 1163.0000, 'ºC'),
	(336327, 143, '2015-02-01 00:38:50.000000', 'temperatura', 1142.0000, 'ºC'),
	(336328, 143, '2015-02-01 00:38:51.000000', 'temperatura', 1021.0000, 'ºC'),
	(336329, 143, '2015-02-01 00:38:52.000000', 'temperatura', 480.0000, 'ºC'),
	(336330, 143, '2015-02-01 00:38:53.000000', 'temperatura', 536.0000, 'ºC'),
	(336331, 143, '2015-02-01 00:38:54.000000', 'temperatura', 42.0000, 'ºC'),
	(336332, 143, '2015-02-01 00:38:55.000000', 'temperatura', 1004.0000, 'ºC'),
	(336333, 143, '2015-02-01 00:38:56.000000', 'temperatura', 92.0000, 'ºC'),
	(336334, 143, '2015-02-01 00:38:57.000000', 'temperatura', 1051.0000, 'ºC'),
	(336335, 143, '2015-02-01 00:38:58.000000', 'temperatura', 176.0000, 'ºC'),
	(336336, 143, '2015-02-01 00:38:59.000000', 'temperatura', 130.0000, 'ºC'),
	(336337, 143, '2015-02-01 00:39:00.000000', 'temperatura', 123.0000, 'ºC'),
	(336338, 143, '2015-02-01 00:39:01.000000', 'temperatura', 224.0000, 'ºC'),
	(336339, 143, '2015-02-01 00:39:02.000000', 'temperatura', 754.0000, 'ºC'),
	(336340, 143, '2015-02-01 00:39:03.000000', 'temperatura', 698.0000, 'ºC'),
	(336341, 143, '2015-02-01 00:39:04.000000', 'temperatura', 27.0000, 'ºC'),
	(336342, 143, '2015-02-01 00:39:05.000000', 'temperatura', 441.0000, 'ºC'),
	(336343, 143, '2015-02-01 00:39:06.000000', 'temperatura', 924.0000, 'ºC'),
	(336344, 143, '2015-02-01 00:39:07.000000', 'temperatura', 898.0000, 'ºC'),
	(336345, 143, '2015-02-01 00:39:08.000000', 'temperatura', 520.0000, 'ºC'),
	(336346, 143, '2015-02-01 00:39:09.000000', 'temperatura', 1106.0000, 'ºC'),
	(336347, 143, '2015-02-01 00:39:10.000000', 'temperatura', 368.0000, 'ºC'),
	(336348, 143, '2015-02-01 00:39:11.000000', 'temperatura', 926.0000, 'ºC'),
	(336349, 143, '2015-02-01 00:39:12.000000', 'temperatura', 1124.0000, 'ºC'),
	(336350, 143, '2015-02-01 00:39:13.000000', 'temperatura', 444.0000, 'ºC'),
	(336351, 143, '2015-02-01 00:39:14.000000', 'temperatura', 49.0000, 'ºC'),
	(336352, 143, '2015-02-01 00:39:15.000000', 'temperatura', 113.0000, 'ºC'),
	(336353, 143, '2015-02-01 00:39:16.000000', 'temperatura', 417.0000, 'ºC'),
	(336354, 143, '2015-02-01 00:39:17.000000', 'temperatura', 546.0000, 'ºC'),
	(336355, 143, '2015-02-01 00:39:18.000000', 'temperatura', 278.0000, 'ºC'),
	(336356, 143, '2015-02-01 00:39:19.000000', 'temperatura', 956.0000, 'ºC'),
	(336357, 143, '2015-02-01 00:39:20.000000', 'temperatura', 346.0000, 'ºC'),
	(336358, 143, '2015-02-01 00:39:21.000000', 'temperatura', 61.0000, 'ºC'),
	(336359, 143, '2015-02-01 00:39:22.000000', 'temperatura', 467.0000, 'ºC'),
	(336360, 143, '2015-02-01 00:39:23.000000', 'temperatura', 954.0000, 'ºC'),
	(336361, 143, '2015-02-01 00:39:24.000000', 'temperatura', 969.0000, 'ºC'),
	(336362, 143, '2015-02-01 00:39:25.000000', 'temperatura', 782.0000, 'ºC'),
	(336363, 143, '2015-02-01 00:39:26.000000', 'temperatura', 1004.0000, 'ºC'),
	(336364, 143, '2015-02-01 00:39:27.000000', 'temperatura', 274.0000, 'ºC'),
	(336365, 143, '2015-02-01 00:39:28.000000', 'temperatura', 760.0000, 'ºC'),
	(336366, 143, '2015-02-01 00:39:29.000000', 'temperatura', 578.0000, 'ºC'),
	(336367, 143, '2015-02-01 00:39:30.000000', 'temperatura', 610.0000, 'ºC'),
	(336368, 143, '2015-02-01 00:39:31.000000', 'temperatura', 119.0000, 'ºC'),
	(336369, 143, '2015-02-01 00:39:32.000000', 'temperatura', 1162.0000, 'ºC'),
	(336370, 143, '2015-02-01 00:39:33.000000', 'temperatura', 656.0000, 'ºC'),
	(336371, 143, '2015-02-01 00:39:34.000000', 'temperatura', 996.0000, 'ºC'),
	(336372, 143, '2015-02-01 00:39:35.000000', 'temperatura', 610.0000, 'ºC'),
	(336373, 143, '2015-02-01 00:39:36.000000', 'temperatura', 63.0000, 'ºC'),
	(336374, 143, '2015-02-01 00:39:37.000000', 'temperatura', 886.0000, 'ºC'),
	(336375, 143, '2015-02-01 00:39:38.000000', 'temperatura', 641.0000, 'ºC'),
	(336376, 143, '2015-02-01 00:39:39.000000', 'temperatura', 550.0000, 'ºC'),
	(336377, 143, '2015-02-01 00:39:40.000000', 'temperatura', 825.0000, 'ºC'),
	(336378, 143, '2015-02-01 00:39:41.000000', 'temperatura', 74.0000, 'ºC'),
	(336379, 143, '2015-02-01 00:39:42.000000', 'temperatura', 297.0000, 'ºC'),
	(336380, 143, '2015-02-01 00:39:43.000000', 'temperatura', 64.0000, 'ºC'),
	(336381, 143, '2015-02-01 00:39:44.000000', 'temperatura', 629.0000, 'ºC'),
	(336382, 143, '2015-02-01 00:39:45.000000', 'temperatura', 552.0000, 'ºC'),
	(336383, 143, '2015-02-01 00:39:46.000000', 'temperatura', 875.0000, 'ºC'),
	(336384, 143, '2015-02-01 00:39:47.000000', 'temperatura', 318.0000, 'ºC'),
	(336385, 143, '2015-02-01 00:39:48.000000', 'temperatura', 166.0000, 'ºC'),
	(336386, 143, '2015-02-01 00:39:49.000000', 'temperatura', 1078.0000, 'ºC'),
	(336387, 143, '2015-02-01 00:39:50.000000', 'temperatura', 91.0000, 'ºC'),
	(336388, 143, '2015-02-01 00:39:51.000000', 'temperatura', 820.0000, 'ºC'),
	(336389, 143, '2015-02-01 00:39:52.000000', 'temperatura', 228.0000, 'ºC'),
	(336390, 143, '2015-02-01 00:39:53.000000', 'temperatura', 1082.0000, 'ºC'),
	(336391, 143, '2015-02-01 00:39:54.000000', 'temperatura', 1128.0000, 'ºC'),
	(336392, 143, '2015-02-01 00:39:55.000000', 'temperatura', 1192.0000, 'ºC'),
	(336393, 143, '2015-02-01 00:39:56.000000', 'temperatura', 178.0000, 'ºC'),
	(336394, 143, '2015-02-01 00:39:57.000000', 'temperatura', 913.0000, 'ºC'),
	(336395, 143, '2015-02-01 00:39:58.000000', 'temperatura', 432.0000, 'ºC'),
	(336396, 143, '2015-02-01 00:39:59.000000', 'temperatura', 622.0000, 'ºC'),
	(336397, 143, '2015-02-01 00:40:00.000000', 'temperatura', 613.0000, 'ºC'),
	(336398, 143, '2015-02-01 00:40:01.000000', 'temperatura', 2.0000, 'ºC'),
	(336399, 143, '2015-02-01 00:40:02.000000', 'temperatura', 572.0000, 'ºC'),
	(336400, 143, '2015-02-01 00:40:03.000000', 'temperatura', 452.0000, 'ºC'),
	(336401, 143, '2015-02-01 00:40:04.000000', 'temperatura', 545.0000, 'ºC'),
	(336402, 143, '2015-02-01 00:40:05.000000', 'temperatura', 168.0000, 'ºC'),
	(336403, 143, '2015-02-01 00:40:06.000000', 'temperatura', 408.0000, 'ºC'),
	(336404, 143, '2015-02-01 00:40:07.000000', 'temperatura', 336.0000, 'ºC'),
	(336405, 143, '2015-02-01 00:40:08.000000', 'temperatura', 455.0000, 'ºC'),
	(336406, 143, '2015-02-01 00:40:09.000000', 'temperatura', 69.0000, 'ºC'),
	(336407, 143, '2015-02-01 00:40:10.000000', 'temperatura', 182.0000, 'ºC'),
	(336408, 143, '2015-02-01 00:40:11.000000', 'temperatura', 703.0000, 'ºC'),
	(336409, 143, '2015-02-01 00:40:12.000000', 'temperatura', 568.0000, 'ºC'),
	(336410, 143, '2015-02-01 00:40:13.000000', 'temperatura', 733.0000, 'ºC'),
	(336411, 143, '2015-02-01 00:40:14.000000', 'temperatura', 761.0000, 'ºC'),
	(336412, 143, '2015-02-01 00:40:15.000000', 'temperatura', 406.0000, 'ºC'),
	(336413, 143, '2015-02-01 00:40:16.000000', 'temperatura', 947.0000, 'ºC'),
	(336414, 143, '2015-02-01 00:40:17.000000', 'temperatura', 1120.0000, 'ºC'),
	(336415, 143, '2015-02-01 00:40:18.000000', 'temperatura', 356.0000, 'ºC'),
	(336416, 143, '2015-02-01 00:40:19.000000', 'temperatura', 823.0000, 'ºC'),
	(336417, 143, '2015-02-01 00:40:20.000000', 'temperatura', 647.0000, 'ºC'),
	(336418, 143, '2015-02-01 00:40:21.000000', 'temperatura', 765.0000, 'ºC'),
	(336419, 143, '2015-02-01 00:40:22.000000', 'temperatura', 688.0000, 'ºC'),
	(336420, 143, '2015-02-01 00:40:23.000000', 'temperatura', 1142.0000, 'ºC'),
	(336421, 143, '2015-02-01 00:40:24.000000', 'temperatura', 47.0000, 'ºC'),
	(336422, 143, '2015-02-01 00:40:25.000000', 'temperatura', 410.0000, 'ºC'),
	(336423, 143, '2015-02-01 00:40:26.000000', 'temperatura', 712.0000, 'ºC'),
	(336424, 143, '2015-02-01 00:40:27.000000', 'temperatura', 1127.0000, 'ºC'),
	(336425, 143, '2015-02-01 00:40:28.000000', 'temperatura', 1101.0000, 'ºC'),
	(336426, 143, '2015-02-01 00:40:29.000000', 'temperatura', 923.0000, 'ºC'),
	(336427, 143, '2015-02-01 00:40:30.000000', 'temperatura', 115.0000, 'ºC'),
	(336428, 143, '2015-02-01 00:40:31.000000', 'temperatura', 205.0000, 'ºC'),
	(336429, 143, '2015-02-01 00:40:32.000000', 'temperatura', 683.0000, 'ºC'),
	(336430, 143, '2015-02-01 00:40:33.000000', 'temperatura', 398.0000, 'ºC'),
	(336431, 143, '2015-02-01 00:40:34.000000', 'temperatura', 1143.0000, 'ºC'),
	(336432, 143, '2015-02-01 00:40:35.000000', 'temperatura', 921.0000, 'ºC'),
	(336433, 143, '2015-02-01 00:40:36.000000', 'temperatura', 1174.0000, 'ºC'),
	(336434, 143, '2015-02-01 00:40:37.000000', 'temperatura', 711.0000, 'ºC'),
	(336435, 143, '2015-02-01 00:40:38.000000', 'temperatura', 30.0000, 'ºC'),
	(336436, 143, '2015-02-01 00:40:39.000000', 'temperatura', 421.0000, 'ºC'),
	(336437, 143, '2015-02-01 00:40:40.000000', 'temperatura', 814.0000, 'ºC'),
	(336438, 143, '2015-02-01 00:40:41.000000', 'temperatura', 407.0000, 'ºC'),
	(336439, 143, '2015-02-01 00:40:42.000000', 'temperatura', 794.0000, 'ºC'),
	(336440, 143, '2015-02-01 00:40:43.000000', 'temperatura', 348.0000, 'ºC'),
	(336441, 143, '2015-02-01 00:40:44.000000', 'temperatura', 560.0000, 'ºC'),
	(336442, 143, '2015-02-01 00:40:45.000000', 'temperatura', 556.0000, 'ºC'),
	(336443, 143, '2015-02-01 00:40:46.000000', 'temperatura', 1102.0000, 'ºC'),
	(336444, 143, '2015-02-01 00:40:47.000000', 'temperatura', 243.0000, 'ºC'),
	(336445, 143, '2015-02-01 00:40:48.000000', 'temperatura', 307.0000, 'ºC'),
	(336446, 143, '2015-02-01 00:40:49.000000', 'temperatura', 807.0000, 'ºC'),
	(336447, 143, '2015-02-01 00:40:50.000000', 'temperatura', 716.0000, 'ºC'),
	(336448, 143, '2015-02-01 00:40:51.000000', 'temperatura', 1157.0000, 'ºC'),
	(336449, 143, '2015-02-01 00:40:52.000000', 'temperatura', 40.0000, 'ºC'),
	(336450, 143, '2015-02-01 00:40:53.000000', 'temperatura', 329.0000, 'ºC'),
	(336451, 143, '2015-02-01 00:40:54.000000', 'temperatura', 327.0000, 'ºC'),
	(336452, 143, '2015-02-01 00:40:55.000000', 'temperatura', 648.0000, 'ºC'),
	(336453, 143, '2015-02-01 00:40:56.000000', 'temperatura', 1060.0000, 'ºC'),
	(336454, 143, '2015-02-01 00:40:57.000000', 'temperatura', 955.0000, 'ºC'),
	(336455, 143, '2015-02-01 00:40:58.000000', 'temperatura', 395.0000, 'ºC'),
	(336456, 143, '2015-02-01 00:40:59.000000', 'temperatura', 310.0000, 'ºC'),
	(336457, 143, '2015-02-01 00:41:00.000000', 'temperatura', 367.0000, 'ºC'),
	(336458, 143, '2015-02-01 00:41:01.000000', 'temperatura', 907.0000, 'ºC'),
	(336459, 143, '2015-02-01 00:41:02.000000', 'temperatura', 1033.0000, 'ºC'),
	(336460, 143, '2015-02-01 00:41:03.000000', 'temperatura', 44.0000, 'ºC'),
	(336461, 143, '2015-02-01 00:41:04.000000', 'temperatura', 722.0000, 'ºC'),
	(336462, 143, '2015-02-01 00:41:05.000000', 'temperatura', 1079.0000, 'ºC'),
	(336463, 143, '2015-02-01 00:41:06.000000', 'temperatura', 829.0000, 'ºC'),
	(336464, 143, '2015-02-01 00:41:07.000000', 'temperatura', 910.0000, 'ºC'),
	(336465, 143, '2015-02-01 00:41:08.000000', 'temperatura', 862.0000, 'ºC'),
	(336466, 143, '2015-02-01 00:41:09.000000', 'temperatura', 380.0000, 'ºC'),
	(336467, 143, '2015-02-01 00:41:10.000000', 'temperatura', 516.0000, 'ºC'),
	(336468, 143, '2015-02-01 00:41:11.000000', 'temperatura', 241.0000, 'ºC'),
	(336469, 143, '2015-02-01 00:41:12.000000', 'temperatura', 855.0000, 'ºC'),
	(336470, 143, '2015-02-01 00:41:13.000000', 'temperatura', 1152.0000, 'ºC'),
	(336471, 143, '2015-02-01 00:41:14.000000', 'temperatura', 797.0000, 'ºC'),
	(336472, 143, '2015-02-01 00:41:15.000000', 'temperatura', 529.0000, 'ºC'),
	(336473, 143, '2015-02-01 00:41:16.000000', 'temperatura', 253.0000, 'ºC'),
	(336474, 143, '2015-02-01 00:41:17.000000', 'temperatura', 879.0000, 'ºC'),
	(336475, 143, '2015-02-01 00:41:18.000000', 'temperatura', 35.0000, 'ºC'),
	(336476, 143, '2015-02-01 00:41:19.000000', 'temperatura', 1141.0000, 'ºC'),
	(336477, 143, '2015-02-01 00:41:20.000000', 'temperatura', 798.0000, 'ºC'),
	(336478, 143, '2015-02-01 00:41:21.000000', 'temperatura', 570.0000, 'ºC'),
	(336479, 143, '2015-02-01 00:41:22.000000', 'temperatura', 455.0000, 'ºC'),
	(336480, 143, '2015-02-01 00:41:23.000000', 'temperatura', 564.0000, 'ºC'),
	(336481, 143, '2015-02-01 00:41:24.000000', 'temperatura', 258.0000, 'ºC'),
	(336482, 143, '2015-02-01 00:41:25.000000', 'temperatura', 800.0000, 'ºC'),
	(336483, 143, '2015-02-01 00:41:26.000000', 'temperatura', 824.0000, 'ºC'),
	(336484, 143, '2015-02-01 00:41:27.000000', 'temperatura', 522.0000, 'ºC'),
	(336485, 143, '2015-02-01 00:41:28.000000', 'temperatura', 137.0000, 'ºC'),
	(336486, 143, '2015-02-01 00:41:29.000000', 'temperatura', 319.0000, 'ºC'),
	(336487, 143, '2015-02-01 00:41:30.000000', 'temperatura', 1184.0000, 'ºC'),
	(336488, 143, '2015-02-01 00:41:31.000000', 'temperatura', 164.0000, 'ºC'),
	(336489, 143, '2015-02-01 00:41:32.000000', 'temperatura', 867.0000, 'ºC'),
	(336490, 143, '2015-02-01 00:41:33.000000', 'temperatura', 246.0000, 'ºC'),
	(336491, 143, '2015-02-01 00:41:34.000000', 'temperatura', 1029.0000, 'ºC'),
	(336492, 143, '2015-02-01 00:41:35.000000', 'temperatura', 805.0000, 'ºC'),
	(336493, 143, '2015-02-01 00:41:36.000000', 'temperatura', 942.0000, 'ºC'),
	(336494, 143, '2015-02-01 00:41:37.000000', 'temperatura', 1095.0000, 'ºC'),
	(336495, 143, '2015-02-01 00:41:38.000000', 'temperatura', 248.0000, 'ºC'),
	(336496, 143, '2015-02-01 00:41:39.000000', 'temperatura', 357.0000, 'ºC'),
	(336497, 143, '2015-02-01 00:41:40.000000', 'temperatura', 1039.0000, 'ºC'),
	(336498, 143, '2015-02-01 00:41:41.000000', 'temperatura', 525.0000, 'ºC'),
	(336499, 143, '2015-02-01 00:41:42.000000', 'temperatura', 710.0000, 'ºC'),
	(336500, 143, '2015-02-01 00:41:43.000000', 'temperatura', 776.0000, 'ºC'),
	(336501, 143, '2015-02-01 00:41:44.000000', 'temperatura', 551.0000, 'ºC'),
	(336502, 143, '2015-02-01 00:41:45.000000', 'temperatura', 428.0000, 'ºC'),
	(336503, 143, '2015-02-01 00:41:46.000000', 'temperatura', 486.0000, 'ºC'),
	(336504, 143, '2015-02-01 00:41:47.000000', 'temperatura', 1147.0000, 'ºC'),
	(336505, 143, '2015-02-01 00:41:48.000000', 'temperatura', 678.0000, 'ºC'),
	(336506, 143, '2015-02-01 00:41:49.000000', 'temperatura', 1148.0000, 'ºC'),
	(336507, 143, '2015-02-01 00:41:50.000000', 'temperatura', 109.0000, 'ºC'),
	(336508, 143, '2015-02-01 00:41:51.000000', 'temperatura', 699.0000, 'ºC'),
	(336509, 143, '2015-02-01 00:41:52.000000', 'temperatura', 769.0000, 'ºC'),
	(336510, 143, '2015-02-01 00:41:53.000000', 'temperatura', 547.0000, 'ºC'),
	(336511, 143, '2015-02-01 00:41:54.000000', 'temperatura', 429.0000, 'ºC'),
	(336512, 143, '2015-02-01 00:41:55.000000', 'temperatura', 506.0000, 'ºC'),
	(336513, 143, '2015-02-01 00:41:56.000000', 'temperatura', 44.0000, 'ºC'),
	(336514, 143, '2015-02-01 00:41:57.000000', 'temperatura', 1101.0000, 'ºC'),
	(336515, 143, '2015-02-01 00:41:58.000000', 'temperatura', 572.0000, 'ºC'),
	(336516, 143, '2015-02-01 00:41:59.000000', 'temperatura', 760.0000, 'ºC'),
	(336517, 143, '2015-02-01 00:42:00.000000', 'temperatura', 885.0000, 'ºC'),
	(336518, 143, '2015-02-01 00:42:01.000000', 'temperatura', 946.0000, 'ºC'),
	(336519, 143, '2015-02-01 00:42:02.000000', 'temperatura', 876.0000, 'ºC'),
	(336520, 143, '2015-02-01 00:42:03.000000', 'temperatura', 343.0000, 'ºC'),
	(336521, 143, '2015-02-01 00:42:04.000000', 'temperatura', 286.0000, 'ºC'),
	(336522, 143, '2015-02-01 00:42:05.000000', 'temperatura', 401.0000, 'ºC'),
	(336523, 143, '2015-02-01 00:42:06.000000', 'temperatura', 1150.0000, 'ºC'),
	(336524, 143, '2015-02-01 00:42:07.000000', 'temperatura', 944.0000, 'ºC'),
	(336525, 143, '2015-02-01 00:42:08.000000', 'temperatura', 73.0000, 'ºC'),
	(336526, 143, '2015-02-01 00:42:09.000000', 'temperatura', 1132.0000, 'ºC'),
	(336527, 143, '2015-02-01 00:42:10.000000', 'temperatura', 641.0000, 'ºC'),
	(336528, 143, '2015-02-01 00:42:11.000000', 'temperatura', 1010.0000, 'ºC'),
	(336529, 143, '2015-02-01 00:42:12.000000', 'temperatura', 726.0000, 'ºC'),
	(336530, 143, '2015-02-01 00:42:13.000000', 'temperatura', 602.0000, 'ºC'),
	(336531, 143, '2015-02-01 00:42:14.000000', 'temperatura', 831.0000, 'ºC'),
	(336532, 143, '2015-02-01 00:42:15.000000', 'temperatura', 1148.0000, 'ºC'),
	(336533, 143, '2015-02-01 00:42:16.000000', 'temperatura', 850.0000, 'ºC'),
	(336534, 143, '2015-02-01 00:42:17.000000', 'temperatura', 807.0000, 'ºC'),
	(336535, 143, '2015-02-01 00:42:18.000000', 'temperatura', 283.0000, 'ºC'),
	(336536, 143, '2015-02-01 00:42:19.000000', 'temperatura', 197.0000, 'ºC'),
	(336537, 143, '2015-02-01 00:42:20.000000', 'temperatura', 134.0000, 'ºC'),
	(336538, 143, '2015-02-01 00:42:21.000000', 'temperatura', 82.0000, 'ºC'),
	(336539, 143, '2015-02-01 00:42:22.000000', 'temperatura', 8.0000, 'ºC'),
	(336540, 143, '2015-02-01 00:42:23.000000', 'temperatura', 996.0000, 'ºC'),
	(336541, 143, '2015-02-01 00:42:24.000000', 'temperatura', 154.0000, 'ºC'),
	(336542, 143, '2015-02-01 00:42:25.000000', 'temperatura', 185.0000, 'ºC'),
	(336543, 143, '2015-02-01 00:42:26.000000', 'temperatura', 461.0000, 'ºC'),
	(336544, 143, '2015-02-01 00:42:27.000000', 'temperatura', 551.0000, 'ºC'),
	(336545, 143, '2015-02-01 00:42:28.000000', 'temperatura', 174.0000, 'ºC'),
	(336546, 143, '2015-02-01 00:42:29.000000', 'temperatura', 418.0000, 'ºC'),
	(336547, 143, '2015-02-01 00:42:30.000000', 'temperatura', 367.0000, 'ºC'),
	(336548, 143, '2015-02-01 00:42:31.000000', 'temperatura', 584.0000, 'ºC'),
	(336549, 143, '2015-02-01 00:42:32.000000', 'temperatura', 617.0000, 'ºC'),
	(336550, 143, '2015-02-01 00:42:33.000000', 'temperatura', 132.0000, 'ºC'),
	(336551, 143, '2015-02-01 00:42:34.000000', 'temperatura', 12.0000, 'ºC'),
	(336552, 143, '2015-02-01 00:42:35.000000', 'temperatura', 864.0000, 'ºC'),
	(336553, 143, '2015-02-01 00:42:36.000000', 'temperatura', 684.0000, 'ºC'),
	(336554, 143, '2015-02-01 00:42:37.000000', 'temperatura', 830.0000, 'ºC'),
	(336555, 143, '2015-02-01 00:42:38.000000', 'temperatura', 896.0000, 'ºC'),
	(336556, 143, '2015-02-01 00:42:39.000000', 'temperatura', 793.0000, 'ºC'),
	(336557, 143, '2015-02-01 00:42:40.000000', 'temperatura', 79.0000, 'ºC'),
	(336558, 143, '2015-02-01 00:42:41.000000', 'temperatura', 413.0000, 'ºC'),
	(336559, 143, '2015-02-01 00:42:42.000000', 'temperatura', 630.0000, 'ºC'),
	(336560, 143, '2015-02-01 00:42:43.000000', 'temperatura', 711.0000, 'ºC'),
	(336561, 143, '2015-02-01 00:42:44.000000', 'temperatura', 464.0000, 'ºC'),
	(336562, 143, '2015-02-01 00:42:45.000000', 'temperatura', 189.0000, 'ºC'),
	(336563, 143, '2015-02-01 00:42:46.000000', 'temperatura', 755.0000, 'ºC'),
	(336564, 143, '2015-02-01 00:42:47.000000', 'temperatura', 808.0000, 'ºC'),
	(336565, 143, '2015-02-01 00:42:48.000000', 'temperatura', 574.0000, 'ºC'),
	(336566, 143, '2015-02-01 00:42:49.000000', 'temperatura', 449.0000, 'ºC'),
	(336567, 143, '2015-02-01 00:42:50.000000', 'temperatura', 523.0000, 'ºC'),
	(336568, 143, '2015-02-01 00:42:51.000000', 'temperatura', 70.0000, 'ºC'),
	(336569, 143, '2015-02-01 00:42:52.000000', 'temperatura', 1180.0000, 'ºC'),
	(336570, 143, '2015-02-01 00:42:53.000000', 'temperatura', 890.0000, 'ºC'),
	(336571, 143, '2015-02-01 00:42:54.000000', 'temperatura', 910.0000, 'ºC'),
	(336572, 143, '2015-02-01 00:42:55.000000', 'temperatura', 682.0000, 'ºC'),
	(336573, 143, '2015-02-01 00:42:56.000000', 'temperatura', 679.0000, 'ºC'),
	(336574, 143, '2015-02-01 00:42:57.000000', 'temperatura', 149.0000, 'ºC'),
	(336575, 143, '2015-02-01 00:42:58.000000', 'temperatura', 1109.0000, 'ºC'),
	(336576, 143, '2015-02-01 00:42:59.000000', 'temperatura', 298.0000, 'ºC'),
	(336577, 143, '2015-02-01 00:43:00.000000', 'temperatura', 566.0000, 'ºC'),
	(336578, 143, '2015-02-01 00:43:01.000000', 'temperatura', 734.0000, 'ºC'),
	(336579, 143, '2015-02-01 00:43:02.000000', 'temperatura', 773.0000, 'ºC'),
	(336580, 143, '2015-02-01 00:43:03.000000', 'temperatura', 463.0000, 'ºC'),
	(336581, 143, '2015-02-01 00:43:04.000000', 'temperatura', 1196.0000, 'ºC'),
	(336582, 143, '2015-02-01 00:43:05.000000', 'temperatura', 991.0000, 'ºC'),
	(336583, 143, '2015-02-01 00:43:06.000000', 'temperatura', 169.0000, 'ºC'),
	(336584, 143, '2015-02-01 00:43:07.000000', 'temperatura', 273.0000, 'ºC'),
	(336585, 143, '2015-02-01 00:43:08.000000', 'temperatura', 857.0000, 'ºC'),
	(336586, 143, '2015-02-01 00:43:09.000000', 'temperatura', 1065.0000, 'ºC'),
	(336587, 143, '2015-02-01 00:43:10.000000', 'temperatura', 357.0000, 'ºC'),
	(336588, 143, '2015-02-01 00:43:11.000000', 'temperatura', 989.0000, 'ºC'),
	(336589, 143, '2015-02-01 00:43:12.000000', 'temperatura', 277.0000, 'ºC'),
	(336590, 143, '2015-02-01 00:43:13.000000', 'temperatura', 818.0000, 'ºC'),
	(336591, 143, '2015-02-01 00:43:14.000000', 'temperatura', 858.0000, 'ºC'),
	(336592, 143, '2015-02-01 00:43:15.000000', 'temperatura', 638.0000, 'ºC'),
	(336593, 143, '2015-02-01 00:43:16.000000', 'temperatura', 616.0000, 'ºC'),
	(336594, 143, '2015-02-01 00:43:17.000000', 'temperatura', 1167.0000, 'ºC'),
	(336595, 143, '2015-02-01 00:43:18.000000', 'temperatura', 387.0000, 'ºC'),
	(336596, 143, '2015-02-01 00:43:19.000000', 'temperatura', 834.0000, 'ºC'),
	(336597, 143, '2015-02-01 00:43:20.000000', 'temperatura', 610.0000, 'ºC'),
	(336598, 143, '2015-02-01 00:43:21.000000', 'temperatura', 548.0000, 'ºC'),
	(336599, 143, '2015-02-01 00:43:22.000000', 'temperatura', 913.0000, 'ºC'),
	(336600, 143, '2015-02-01 00:43:23.000000', 'temperatura', 518.0000, 'ºC'),
	(336601, 143, '2015-02-01 00:43:24.000000', 'temperatura', 1054.0000, 'ºC'),
	(336602, 143, '2015-02-01 00:43:25.000000', 'temperatura', 116.0000, 'ºC'),
	(336603, 143, '2015-02-01 00:43:26.000000', 'temperatura', 1020.0000, 'ºC'),
	(336604, 143, '2015-02-01 00:43:27.000000', 'temperatura', 1151.0000, 'ºC'),
	(336605, 143, '2015-02-01 00:43:28.000000', 'temperatura', 297.0000, 'ºC'),
	(336606, 143, '2015-02-01 00:43:29.000000', 'temperatura', 432.0000, 'ºC'),
	(336607, 143, '2015-02-01 00:43:30.000000', 'temperatura', 69.0000, 'ºC'),
	(336608, 143, '2015-02-01 00:43:31.000000', 'temperatura', 249.0000, 'ºC'),
	(336609, 143, '2015-02-01 00:43:32.000000', 'temperatura', 1040.0000, 'ºC'),
	(336610, 143, '2015-02-01 00:43:33.000000', 'temperatura', 855.0000, 'ºC'),
	(336611, 143, '2015-02-01 00:43:34.000000', 'temperatura', 1153.0000, 'ºC'),
	(336612, 143, '2015-02-01 00:43:35.000000', 'temperatura', 803.0000, 'ºC'),
	(336613, 143, '2015-02-01 00:43:36.000000', 'temperatura', 555.0000, 'ºC'),
	(336614, 143, '2015-02-01 00:43:37.000000', 'temperatura', 366.0000, 'ºC'),
	(336615, 143, '2015-02-01 00:43:38.000000', 'temperatura', 165.0000, 'ºC'),
	(336616, 143, '2015-02-01 00:43:39.000000', 'temperatura', 926.0000, 'ºC'),
	(336617, 143, '2015-02-01 00:43:40.000000', 'temperatura', 537.0000, 'ºC'),
	(336618, 143, '2015-02-01 00:43:41.000000', 'temperatura', 1108.0000, 'ºC'),
	(336619, 143, '2015-02-01 00:43:42.000000', 'temperatura', 330.0000, 'ºC'),
	(336620, 143, '2015-02-01 00:43:43.000000', 'temperatura', 727.0000, 'ºC'),
	(336621, 143, '2015-02-01 00:43:44.000000', 'temperatura', 243.0000, 'ºC'),
	(336622, 143, '2015-02-01 00:43:45.000000', 'temperatura', 237.0000, 'ºC'),
	(336623, 143, '2015-02-01 00:43:46.000000', 'temperatura', 457.0000, 'ºC'),
	(336624, 143, '2015-02-01 00:43:47.000000', 'temperatura', 375.0000, 'ºC'),
	(336625, 143, '2015-02-01 00:43:48.000000', 'temperatura', 505.0000, 'ºC'),
	(336626, 143, '2015-02-01 00:43:49.000000', 'temperatura', 199.0000, 'ºC'),
	(336627, 143, '2015-02-01 00:43:50.000000', 'temperatura', 680.0000, 'ºC'),
	(336628, 143, '2015-02-01 00:43:51.000000', 'temperatura', 404.0000, 'ºC'),
	(336629, 143, '2015-02-01 00:43:52.000000', 'temperatura', 1182.0000, 'ºC'),
	(336630, 143, '2015-02-01 00:43:53.000000', 'temperatura', 1098.0000, 'ºC'),
	(336631, 143, '2015-02-01 00:43:54.000000', 'temperatura', 745.0000, 'ºC'),
	(336632, 143, '2015-02-01 00:43:55.000000', 'temperatura', 432.0000, 'ºC'),
	(336633, 143, '2015-02-01 00:43:56.000000', 'temperatura', 1127.0000, 'ºC'),
	(336634, 143, '2015-02-01 00:43:57.000000', 'temperatura', 736.0000, 'ºC'),
	(336635, 143, '2015-02-01 00:43:58.000000', 'temperatura', 301.0000, 'ºC'),
	(336636, 143, '2015-02-01 00:43:59.000000', 'temperatura', 498.0000, 'ºC'),
	(336637, 143, '2015-02-01 00:44:00.000000', 'temperatura', 385.0000, 'ºC'),
	(336638, 143, '2015-02-01 00:44:01.000000', 'temperatura', 435.0000, 'ºC'),
	(336639, 143, '2015-02-01 00:44:02.000000', 'temperatura', 1019.0000, 'ºC'),
	(336640, 143, '2015-02-01 00:44:03.000000', 'temperatura', 192.0000, 'ºC'),
	(336641, 143, '2015-02-01 00:44:04.000000', 'temperatura', 301.0000, 'ºC'),
	(336642, 143, '2015-02-01 00:44:05.000000', 'temperatura', 931.0000, 'ºC'),
	(336643, 143, '2015-02-01 00:44:06.000000', 'temperatura', 151.0000, 'ºC'),
	(336644, 143, '2015-02-01 00:44:07.000000', 'temperatura', 362.0000, 'ºC'),
	(336645, 143, '2015-02-01 00:44:08.000000', 'temperatura', 157.0000, 'ºC'),
	(336646, 143, '2015-02-01 00:44:09.000000', 'temperatura', 902.0000, 'ºC'),
	(336647, 143, '2015-02-01 00:44:10.000000', 'temperatura', 439.0000, 'ºC'),
	(336648, 143, '2015-02-01 00:44:11.000000', 'temperatura', 690.0000, 'ºC'),
	(336649, 143, '2015-02-01 00:44:12.000000', 'temperatura', 931.0000, 'ºC'),
	(336650, 143, '2015-02-01 00:44:13.000000', 'temperatura', 186.0000, 'ºC'),
	(336651, 143, '2015-02-01 00:44:14.000000', 'temperatura', 539.0000, 'ºC'),
	(336652, 143, '2015-02-01 00:44:15.000000', 'temperatura', 937.0000, 'ºC'),
	(336653, 143, '2015-02-01 00:44:16.000000', 'temperatura', 667.0000, 'ºC'),
	(336654, 143, '2015-02-01 00:44:17.000000', 'temperatura', 526.0000, 'ºC'),
	(336655, 143, '2015-02-01 00:44:18.000000', 'temperatura', 628.0000, 'ºC'),
	(336656, 143, '2015-02-01 00:44:19.000000', 'temperatura', 363.0000, 'ºC'),
	(336657, 143, '2015-02-01 00:44:20.000000', 'temperatura', 1131.0000, 'ºC'),
	(336658, 143, '2015-02-01 00:44:21.000000', 'temperatura', 966.0000, 'ºC'),
	(336659, 143, '2015-02-01 00:44:22.000000', 'temperatura', 239.0000, 'ºC'),
	(336660, 143, '2015-02-01 00:44:23.000000', 'temperatura', 699.0000, 'ºC'),
	(336661, 143, '2015-02-01 00:44:24.000000', 'temperatura', 375.0000, 'ºC'),
	(336662, 143, '2015-02-01 00:44:25.000000', 'temperatura', 980.0000, 'ºC'),
	(336663, 143, '2015-02-01 00:44:26.000000', 'temperatura', 176.0000, 'ºC'),
	(336664, 143, '2015-02-01 00:44:27.000000', 'temperatura', 342.0000, 'ºC'),
	(336665, 143, '2015-02-01 00:44:28.000000', 'temperatura', 1182.0000, 'ºC'),
	(336666, 143, '2015-02-01 00:44:29.000000', 'temperatura', 84.0000, 'ºC'),
	(336667, 143, '2015-02-01 00:44:30.000000', 'temperatura', 475.0000, 'ºC'),
	(336668, 143, '2015-02-01 00:44:31.000000', 'temperatura', 924.0000, 'ºC'),
	(336669, 143, '2015-02-01 00:44:32.000000', 'temperatura', 794.0000, 'ºC'),
	(336670, 143, '2015-02-01 00:44:33.000000', 'temperatura', 1198.0000, 'ºC'),
	(336671, 143, '2015-02-01 00:44:34.000000', 'temperatura', 8.0000, 'ºC'),
	(336672, 143, '2015-02-01 00:44:35.000000', 'temperatura', 48.0000, 'ºC'),
	(336673, 143, '2015-02-01 00:44:36.000000', 'temperatura', 216.0000, 'ºC'),
	(336674, 143, '2015-02-01 00:44:37.000000', 'temperatura', 938.0000, 'ºC'),
	(336675, 143, '2015-02-01 00:44:38.000000', 'temperatura', 442.0000, 'ºC'),
	(336676, 143, '2015-02-01 00:44:39.000000', 'temperatura', 595.0000, 'ºC'),
	(336677, 143, '2015-02-01 00:44:40.000000', 'temperatura', 449.0000, 'ºC'),
	(336678, 143, '2015-02-01 00:44:41.000000', 'temperatura', 463.0000, 'ºC'),
	(336679, 143, '2015-02-01 00:44:42.000000', 'temperatura', 968.0000, 'ºC'),
	(336680, 143, '2015-02-01 00:44:43.000000', 'temperatura', 1050.0000, 'ºC'),
	(336681, 143, '2015-02-01 00:44:44.000000', 'temperatura', 1146.0000, 'ºC'),
	(336682, 143, '2015-02-01 00:44:45.000000', 'temperatura', 180.0000, 'ºC'),
	(336683, 143, '2015-02-01 00:44:46.000000', 'temperatura', 1061.0000, 'ºC'),
	(336684, 143, '2015-02-01 00:44:47.000000', 'temperatura', 1169.0000, 'ºC'),
	(336685, 143, '2015-02-01 00:44:48.000000', 'temperatura', 259.0000, 'ºC'),
	(336686, 143, '2015-02-01 00:44:49.000000', 'temperatura', 191.0000, 'ºC'),
	(336687, 143, '2015-02-01 00:44:50.000000', 'temperatura', 178.0000, 'ºC'),
	(336688, 143, '2015-02-01 00:44:51.000000', 'temperatura', 316.0000, 'ºC'),
	(336689, 143, '2015-02-01 00:44:52.000000', 'temperatura', 1048.0000, 'ºC'),
	(336690, 143, '2015-02-01 00:44:53.000000', 'temperatura', 690.0000, 'ºC'),
	(336691, 143, '2015-02-01 00:44:54.000000', 'temperatura', 309.0000, 'ºC'),
	(336692, 143, '2015-02-01 00:44:55.000000', 'temperatura', 673.0000, 'ºC'),
	(336693, 143, '2015-02-01 00:44:56.000000', 'temperatura', 41.0000, 'ºC'),
	(336694, 143, '2015-02-01 00:44:57.000000', 'temperatura', 588.0000, 'ºC'),
	(336695, 143, '2015-02-01 00:44:58.000000', 'temperatura', 414.0000, 'ºC'),
	(336696, 143, '2015-02-01 00:44:59.000000', 'temperatura', 307.0000, 'ºC'),
	(336697, 143, '2015-02-01 00:45:00.000000', 'temperatura', 294.0000, 'ºC'),
	(336698, 143, '2015-02-01 00:45:01.000000', 'temperatura', 548.0000, 'ºC'),
	(336699, 143, '2015-02-01 00:45:02.000000', 'temperatura', 659.0000, 'ºC'),
	(336700, 143, '2015-02-01 00:45:03.000000', 'temperatura', 453.0000, 'ºC'),
	(336701, 143, '2015-02-01 00:45:04.000000', 'temperatura', 288.0000, 'ºC'),
	(336702, 143, '2015-02-01 00:45:05.000000', 'temperatura', 81.0000, 'ºC'),
	(336703, 143, '2015-02-01 00:45:06.000000', 'temperatura', 741.0000, 'ºC'),
	(336704, 143, '2015-02-01 00:45:07.000000', 'temperatura', 1061.0000, 'ºC'),
	(336705, 143, '2015-02-01 00:45:08.000000', 'temperatura', 685.0000, 'ºC'),
	(336706, 143, '2015-02-01 00:45:09.000000', 'temperatura', 241.0000, 'ºC'),
	(336707, 143, '2015-02-01 00:45:10.000000', 'temperatura', 352.0000, 'ºC'),
	(336708, 143, '2015-02-01 00:45:11.000000', 'temperatura', 1035.0000, 'ºC'),
	(336709, 143, '2015-02-01 00:45:12.000000', 'temperatura', 520.0000, 'ºC'),
	(336710, 143, '2015-02-01 00:45:13.000000', 'temperatura', 696.0000, 'ºC'),
	(336711, 143, '2015-02-01 00:45:14.000000', 'temperatura', 721.0000, 'ºC'),
	(336712, 143, '2015-02-01 00:45:15.000000', 'temperatura', 319.0000, 'ºC'),
	(336713, 143, '2015-02-01 00:45:16.000000', 'temperatura', 630.0000, 'ºC'),
	(336714, 143, '2015-02-01 00:45:17.000000', 'temperatura', 994.0000, 'ºC'),
	(336715, 143, '2015-02-01 00:45:18.000000', 'temperatura', 682.0000, 'ºC'),
	(336716, 143, '2015-02-01 00:45:19.000000', 'temperatura', 425.0000, 'ºC'),
	(336717, 143, '2015-02-01 00:45:20.000000', 'temperatura', 83.0000, 'ºC'),
	(336718, 143, '2015-02-01 00:45:21.000000', 'temperatura', 341.0000, 'ºC'),
	(336719, 143, '2015-02-01 00:45:22.000000', 'temperatura', 257.0000, 'ºC'),
	(336720, 143, '2015-02-01 00:45:23.000000', 'temperatura', 259.0000, 'ºC'),
	(336721, 143, '2015-02-01 00:45:24.000000', 'temperatura', 527.0000, 'ºC'),
	(336722, 143, '2015-02-01 00:45:25.000000', 'temperatura', 659.0000, 'ºC'),
	(336723, 143, '2015-02-01 00:45:26.000000', 'temperatura', 515.0000, 'ºC'),
	(336724, 143, '2015-02-01 00:45:27.000000', 'temperatura', 598.0000, 'ºC'),
	(336725, 143, '2015-02-01 00:45:28.000000', 'temperatura', 247.0000, 'ºC'),
	(336726, 143, '2015-02-01 00:45:29.000000', 'temperatura', 641.0000, 'ºC'),
	(336727, 143, '2015-02-01 00:45:30.000000', 'temperatura', 65.0000, 'ºC'),
	(336728, 143, '2015-02-01 00:45:31.000000', 'temperatura', 802.0000, 'ºC'),
	(336729, 143, '2015-02-01 00:45:32.000000', 'temperatura', 214.0000, 'ºC'),
	(336730, 143, '2015-02-01 00:45:33.000000', 'temperatura', 1064.0000, 'ºC'),
	(336731, 143, '2015-02-01 00:45:34.000000', 'temperatura', 1078.0000, 'ºC'),
	(336732, 143, '2015-02-01 00:45:35.000000', 'temperatura', 1001.0000, 'ºC'),
	(336733, 143, '2015-02-01 00:45:36.000000', 'temperatura', 570.0000, 'ºC'),
	(336734, 143, '2015-02-01 00:45:37.000000', 'temperatura', 1048.0000, 'ºC'),
	(336735, 143, '2015-02-01 00:45:38.000000', 'temperatura', 1129.0000, 'ºC'),
	(336736, 143, '2015-02-01 00:45:39.000000', 'temperatura', 102.0000, 'ºC'),
	(336737, 143, '2015-02-01 00:45:40.000000', 'temperatura', 723.0000, 'ºC'),
	(336738, 143, '2015-02-01 00:45:41.000000', 'temperatura', 909.0000, 'ºC'),
	(336739, 143, '2015-02-01 00:45:42.000000', 'temperatura', 1178.0000, 'ºC'),
	(336740, 143, '2015-02-01 00:45:43.000000', 'temperatura', 765.0000, 'ºC'),
	(336741, 143, '2015-02-01 00:45:44.000000', 'temperatura', 288.0000, 'ºC'),
	(336742, 143, '2015-02-01 00:45:45.000000', 'temperatura', 349.0000, 'ºC'),
	(336743, 143, '2015-02-01 00:45:46.000000', 'temperatura', 879.0000, 'ºC'),
	(336744, 143, '2015-02-01 00:45:47.000000', 'temperatura', 950.0000, 'ºC'),
	(336745, 143, '2015-02-01 00:45:48.000000', 'temperatura', 912.0000, 'ºC'),
	(336746, 143, '2015-02-01 00:45:49.000000', 'temperatura', 509.0000, 'ºC'),
	(336747, 143, '2015-02-01 00:45:50.000000', 'temperatura', 1012.0000, 'ºC'),
	(336748, 143, '2015-02-01 00:45:51.000000', 'temperatura', 1133.0000, 'ºC'),
	(336749, 143, '2015-02-01 00:45:52.000000', 'temperatura', 230.0000, 'ºC'),
	(336750, 143, '2015-02-01 00:45:53.000000', 'temperatura', 150.0000, 'ºC'),
	(336751, 143, '2015-02-01 00:45:54.000000', 'temperatura', 61.0000, 'ºC'),
	(336752, 143, '2015-02-01 00:45:55.000000', 'temperatura', 1056.0000, 'ºC'),
	(336753, 143, '2015-02-01 00:45:56.000000', 'temperatura', 298.0000, 'ºC'),
	(336754, 143, '2015-02-01 00:45:57.000000', 'temperatura', 720.0000, 'ºC'),
	(336755, 143, '2015-02-01 00:45:58.000000', 'temperatura', 309.0000, 'ºC'),
	(336756, 143, '2015-02-01 00:45:59.000000', 'temperatura', 585.0000, 'ºC'),
	(336757, 143, '2015-02-01 00:46:00.000000', 'temperatura', 800.0000, 'ºC'),
	(336758, 143, '2015-02-01 00:46:01.000000', 'temperatura', 1045.0000, 'ºC'),
	(336759, 143, '2015-02-01 00:46:02.000000', 'temperatura', 426.0000, 'ºC'),
	(336760, 143, '2015-02-01 00:46:03.000000', 'temperatura', 193.0000, 'ºC'),
	(336761, 143, '2015-02-01 00:46:04.000000', 'temperatura', 888.0000, 'ºC'),
	(336762, 143, '2015-02-01 00:46:05.000000', 'temperatura', 261.0000, 'ºC'),
	(336763, 143, '2015-02-01 00:46:06.000000', 'temperatura', 1042.0000, 'ºC'),
	(336764, 143, '2015-02-01 00:46:07.000000', 'temperatura', 827.0000, 'ºC'),
	(336765, 143, '2015-02-01 00:46:08.000000', 'temperatura', 1010.0000, 'ºC'),
	(336766, 143, '2015-02-01 00:46:09.000000', 'temperatura', 170.0000, 'ºC'),
	(336767, 143, '2015-02-01 00:46:10.000000', 'temperatura', 220.0000, 'ºC'),
	(336768, 143, '2015-02-01 00:46:11.000000', 'temperatura', 591.0000, 'ºC'),
	(336769, 143, '2015-02-01 00:46:12.000000', 'temperatura', 1096.0000, 'ºC'),
	(336770, 143, '2015-02-01 00:46:13.000000', 'temperatura', 107.0000, 'ºC'),
	(336771, 143, '2015-02-01 00:46:14.000000', 'temperatura', 849.0000, 'ºC'),
	(336772, 143, '2015-02-01 00:46:15.000000', 'temperatura', 324.0000, 'ºC'),
	(336773, 143, '2015-02-01 00:46:16.000000', 'temperatura', 272.0000, 'ºC'),
	(336774, 143, '2015-02-01 00:46:17.000000', 'temperatura', 389.0000, 'ºC'),
	(336775, 143, '2015-02-01 00:46:18.000000', 'temperatura', 1128.0000, 'ºC'),
	(336776, 143, '2015-02-01 00:46:19.000000', 'temperatura', 873.0000, 'ºC'),
	(336777, 143, '2015-02-01 00:46:20.000000', 'temperatura', 983.0000, 'ºC'),
	(336778, 143, '2015-02-01 00:46:21.000000', 'temperatura', 1098.0000, 'ºC'),
	(336779, 143, '2015-02-01 00:46:22.000000', 'temperatura', 140.0000, 'ºC'),
	(336780, 143, '2015-02-01 00:46:23.000000', 'temperatura', 1005.0000, 'ºC'),
	(336781, 143, '2015-02-01 00:46:24.000000', 'temperatura', 1008.0000, 'ºC'),
	(336782, 143, '2015-02-01 00:46:25.000000', 'temperatura', 823.0000, 'ºC'),
	(336783, 143, '2015-02-01 00:46:26.000000', 'temperatura', 1092.0000, 'ºC'),
	(336784, 143, '2015-02-01 00:46:27.000000', 'temperatura', 590.0000, 'ºC'),
	(336785, 143, '2015-02-01 00:46:28.000000', 'temperatura', 877.0000, 'ºC'),
	(336786, 143, '2015-02-01 00:46:29.000000', 'temperatura', 214.0000, 'ºC'),
	(336787, 143, '2015-02-01 00:46:30.000000', 'temperatura', 841.0000, 'ºC'),
	(336788, 143, '2015-02-01 00:46:31.000000', 'temperatura', 1164.0000, 'ºC'),
	(336789, 143, '2015-02-01 00:46:32.000000', 'temperatura', 896.0000, 'ºC'),
	(336790, 143, '2015-02-01 00:46:33.000000', 'temperatura', 989.0000, 'ºC'),
	(336791, 143, '2015-02-01 00:46:34.000000', 'temperatura', 1058.0000, 'ºC'),
	(336792, 143, '2015-02-01 00:46:35.000000', 'temperatura', 1125.0000, 'ºC'),
	(336793, 143, '2015-02-01 00:46:36.000000', 'temperatura', 50.0000, 'ºC'),
	(336794, 143, '2015-02-01 00:46:37.000000', 'temperatura', 475.0000, 'ºC'),
	(336795, 143, '2015-02-01 00:46:38.000000', 'temperatura', 1026.0000, 'ºC'),
	(336796, 143, '2015-02-01 00:46:39.000000', 'temperatura', 104.0000, 'ºC'),
	(336797, 143, '2015-02-01 00:46:40.000000', 'temperatura', 1042.0000, 'ºC'),
	(336798, 143, '2015-02-01 00:46:41.000000', 'temperatura', 98.0000, 'ºC'),
	(336799, 143, '2015-02-01 00:46:42.000000', 'temperatura', 965.0000, 'ºC'),
	(336800, 143, '2015-02-01 00:46:43.000000', 'temperatura', 933.0000, 'ºC'),
	(336801, 143, '2015-02-01 00:46:44.000000', 'temperatura', 572.0000, 'ºC'),
	(336802, 143, '2015-02-01 00:46:45.000000', 'temperatura', 59.0000, 'ºC'),
	(336803, 143, '2015-02-01 00:46:46.000000', 'temperatura', 982.0000, 'ºC'),
	(336804, 143, '2015-02-01 00:46:47.000000', 'temperatura', 1132.0000, 'ºC'),
	(336805, 143, '2015-02-01 00:46:48.000000', 'temperatura', 316.0000, 'ºC'),
	(336806, 143, '2015-02-01 00:46:49.000000', 'temperatura', 586.0000, 'ºC'),
	(336807, 143, '2015-02-01 00:46:50.000000', 'temperatura', 779.0000, 'ºC'),
	(336808, 143, '2015-02-01 00:46:51.000000', 'temperatura', 938.0000, 'ºC'),
	(336809, 143, '2015-02-01 00:46:52.000000', 'temperatura', 1156.0000, 'ºC'),
	(336810, 143, '2015-02-01 00:46:53.000000', 'temperatura', 565.0000, 'ºC'),
	(336811, 143, '2015-02-01 00:46:54.000000', 'temperatura', 559.0000, 'ºC'),
	(336812, 143, '2015-02-01 00:46:55.000000', 'temperatura', 1100.0000, 'ºC'),
	(336813, 143, '2015-02-01 00:46:56.000000', 'temperatura', 224.0000, 'ºC'),
	(336814, 143, '2015-02-01 00:46:57.000000', 'temperatura', 218.0000, 'ºC'),
	(336815, 143, '2015-02-01 00:46:58.000000', 'temperatura', 422.0000, 'ºC'),
	(336816, 143, '2015-02-01 00:46:59.000000', 'temperatura', 254.0000, 'ºC'),
	(336817, 143, '2015-02-01 00:47:00.000000', 'temperatura', 5.0000, 'ºC'),
	(336818, 143, '2015-02-01 00:47:01.000000', 'temperatura', 463.0000, 'ºC'),
	(336819, 143, '2015-02-01 00:47:02.000000', 'temperatura', 1100.0000, 'ºC'),
	(336820, 143, '2015-02-01 00:47:03.000000', 'temperatura', 513.0000, 'ºC'),
	(336821, 143, '2015-02-01 00:47:04.000000', 'temperatura', 463.0000, 'ºC'),
	(336822, 143, '2015-02-01 00:47:05.000000', 'temperatura', 779.0000, 'ºC'),
	(336823, 143, '2015-02-01 00:47:06.000000', 'temperatura', 106.0000, 'ºC'),
	(336824, 143, '2015-02-01 00:47:07.000000', 'temperatura', 595.0000, 'ºC'),
	(336825, 143, '2015-02-01 00:47:08.000000', 'temperatura', 255.0000, 'ºC'),
	(336826, 143, '2015-02-01 00:47:09.000000', 'temperatura', 692.0000, 'ºC'),
	(336827, 143, '2015-02-01 00:47:10.000000', 'temperatura', 296.0000, 'ºC'),
	(336828, 143, '2015-02-01 00:47:11.000000', 'temperatura', 603.0000, 'ºC'),
	(336829, 143, '2015-02-01 00:47:12.000000', 'temperatura', 929.0000, 'ºC'),
	(336830, 143, '2015-02-01 00:47:13.000000', 'temperatura', 436.0000, 'ºC'),
	(336831, 143, '2015-02-01 00:47:14.000000', 'temperatura', 593.0000, 'ºC'),
	(336832, 143, '2015-02-01 00:47:15.000000', 'temperatura', 457.0000, 'ºC'),
	(336833, 143, '2015-02-01 00:47:16.000000', 'temperatura', 505.0000, 'ºC'),
	(336834, 143, '2015-02-01 00:47:17.000000', 'temperatura', 1156.0000, 'ºC'),
	(336835, 143, '2015-02-01 00:47:18.000000', 'temperatura', 665.0000, 'ºC'),
	(336836, 143, '2015-02-01 00:47:19.000000', 'temperatura', 1059.0000, 'ºC'),
	(336837, 143, '2015-02-01 00:47:20.000000', 'temperatura', 899.0000, 'ºC'),
	(336838, 143, '2015-02-01 00:47:21.000000', 'temperatura', 121.0000, 'ºC'),
	(336839, 143, '2015-02-01 00:47:22.000000', 'temperatura', 307.0000, 'ºC'),
	(336840, 143, '2015-02-01 00:47:23.000000', 'temperatura', 1171.0000, 'ºC'),
	(336841, 143, '2015-02-01 00:47:24.000000', 'temperatura', 134.0000, 'ºC'),
	(336842, 143, '2015-02-01 00:47:25.000000', 'temperatura', 760.0000, 'ºC'),
	(336843, 143, '2015-02-01 00:47:26.000000', 'temperatura', 998.0000, 'ºC'),
	(336844, 143, '2015-02-01 00:47:27.000000', 'temperatura', 309.0000, 'ºC'),
	(336845, 143, '2015-02-01 00:47:28.000000', 'temperatura', 952.0000, 'ºC'),
	(336846, 143, '2015-02-01 00:47:29.000000', 'temperatura', 234.0000, 'ºC'),
	(336847, 143, '2015-02-01 00:47:30.000000', 'temperatura', 712.0000, 'ºC'),
	(336848, 143, '2015-02-01 00:47:31.000000', 'temperatura', 462.0000, 'ºC'),
	(336849, 143, '2015-02-01 00:47:32.000000', 'temperatura', 174.0000, 'ºC'),
	(336850, 143, '2015-02-01 00:47:33.000000', 'temperatura', 684.0000, 'ºC'),
	(336851, 143, '2015-02-01 00:47:34.000000', 'temperatura', 500.0000, 'ºC'),
	(336852, 143, '2015-02-01 00:47:35.000000', 'temperatura', 446.0000, 'ºC'),
	(336853, 143, '2015-02-01 00:47:36.000000', 'temperatura', 734.0000, 'ºC'),
	(336854, 143, '2015-02-01 00:47:37.000000', 'temperatura', 1129.0000, 'ºC'),
	(336855, 143, '2015-02-01 00:47:38.000000', 'temperatura', 1044.0000, 'ºC'),
	(336856, 143, '2015-02-01 00:47:39.000000', 'temperatura', 635.0000, 'ºC'),
	(336857, 143, '2015-02-01 00:47:40.000000', 'temperatura', 41.0000, 'ºC'),
	(336858, 143, '2015-02-01 00:47:41.000000', 'temperatura', 700.0000, 'ºC'),
	(336859, 143, '2015-02-01 00:47:42.000000', 'temperatura', 980.0000, 'ºC'),
	(336860, 143, '2015-02-01 00:47:43.000000', 'temperatura', 401.0000, 'ºC'),
	(336861, 143, '2015-02-01 00:47:44.000000', 'temperatura', 263.0000, 'ºC'),
	(336862, 143, '2015-02-01 00:47:45.000000', 'temperatura', 112.0000, 'ºC'),
	(336863, 143, '2015-02-01 00:47:46.000000', 'temperatura', 972.0000, 'ºC'),
	(336864, 143, '2015-02-01 00:47:47.000000', 'temperatura', 925.0000, 'ºC'),
	(336865, 143, '2015-02-01 00:47:48.000000', 'temperatura', 511.0000, 'ºC'),
	(336866, 143, '2015-02-01 00:47:49.000000', 'temperatura', 979.0000, 'ºC'),
	(336867, 143, '2015-02-01 00:47:50.000000', 'temperatura', 962.0000, 'ºC'),
	(336868, 143, '2015-02-01 00:47:51.000000', 'temperatura', 676.0000, 'ºC'),
	(336869, 143, '2015-02-01 00:47:52.000000', 'temperatura', 491.0000, 'ºC'),
	(336870, 143, '2015-02-01 00:47:53.000000', 'temperatura', 431.0000, 'ºC'),
	(336871, 143, '2015-02-01 00:47:54.000000', 'temperatura', 681.0000, 'ºC'),
	(336872, 143, '2015-02-01 00:47:55.000000', 'temperatura', 911.0000, 'ºC'),
	(336873, 143, '2015-02-01 00:47:56.000000', 'temperatura', 114.0000, 'ºC'),
	(336874, 143, '2015-02-01 00:47:57.000000', 'temperatura', 236.0000, 'ºC'),
	(336875, 143, '2015-02-01 00:47:58.000000', 'temperatura', 837.0000, 'ºC'),
	(336876, 143, '2015-02-01 00:47:59.000000', 'temperatura', 1081.0000, 'ºC'),
	(336877, 143, '2015-02-01 00:48:00.000000', 'temperatura', 492.0000, 'ºC'),
	(336878, 143, '2015-02-01 00:48:01.000000', 'temperatura', 418.0000, 'ºC'),
	(336879, 143, '2015-02-01 00:48:02.000000', 'temperatura', 615.0000, 'ºC'),
	(336880, 143, '2015-02-01 00:48:03.000000', 'temperatura', 621.0000, 'ºC'),
	(336881, 143, '2015-02-01 00:48:04.000000', 'temperatura', 59.0000, 'ºC'),
	(336882, 143, '2015-02-01 00:48:05.000000', 'temperatura', 836.0000, 'ºC'),
	(336883, 143, '2015-02-01 00:48:06.000000', 'temperatura', 400.0000, 'ºC'),
	(336884, 143, '2015-02-01 00:48:07.000000', 'temperatura', 693.0000, 'ºC'),
	(336885, 143, '2015-02-01 00:48:08.000000', 'temperatura', 1067.0000, 'ºC'),
	(336886, 143, '2015-02-01 00:48:09.000000', 'temperatura', 858.0000, 'ºC'),
	(336887, 143, '2015-02-01 00:48:10.000000', 'temperatura', 1088.0000, 'ºC'),
	(336888, 143, '2015-02-01 00:48:11.000000', 'temperatura', 465.0000, 'ºC'),
	(336889, 143, '2015-02-01 00:48:12.000000', 'temperatura', 264.0000, 'ºC'),
	(336890, 143, '2015-02-01 00:48:13.000000', 'temperatura', 1124.0000, 'ºC'),
	(336891, 143, '2015-02-01 00:48:14.000000', 'temperatura', 27.0000, 'ºC'),
	(336892, 143, '2015-02-01 00:48:15.000000', 'temperatura', 366.0000, 'ºC'),
	(336893, 143, '2015-02-01 00:48:16.000000', 'temperatura', 547.0000, 'ºC'),
	(336894, 143, '2015-02-01 00:48:17.000000', 'temperatura', 440.0000, 'ºC'),
	(336895, 143, '2015-02-01 00:48:18.000000', 'temperatura', 557.0000, 'ºC'),
	(336896, 143, '2015-02-01 00:48:19.000000', 'temperatura', 267.0000, 'ºC'),
	(336897, 143, '2015-02-01 00:48:20.000000', 'temperatura', 866.0000, 'ºC'),
	(336898, 143, '2015-02-01 00:48:21.000000', 'temperatura', 1128.0000, 'ºC'),
	(336899, 143, '2015-02-01 00:48:22.000000', 'temperatura', 644.0000, 'ºC'),
	(336900, 143, '2015-02-01 00:48:23.000000', 'temperatura', 1036.0000, 'ºC'),
	(336901, 143, '2015-02-01 00:48:24.000000', 'temperatura', 850.0000, 'ºC'),
	(336902, 143, '2015-02-01 00:48:25.000000', 'temperatura', 1142.0000, 'ºC'),
	(336903, 143, '2015-02-01 00:48:26.000000', 'temperatura', 759.0000, 'ºC'),
	(336904, 143, '2015-02-01 00:48:27.000000', 'temperatura', 369.0000, 'ºC'),
	(336905, 143, '2015-02-01 00:48:28.000000', 'temperatura', 770.0000, 'ºC'),
	(336906, 143, '2015-02-01 00:48:29.000000', 'temperatura', 345.0000, 'ºC'),
	(336907, 143, '2015-02-01 00:48:30.000000', 'temperatura', 613.0000, 'ºC'),
	(336908, 143, '2015-02-01 00:48:31.000000', 'temperatura', 830.0000, 'ºC'),
	(336909, 143, '2015-02-01 00:48:32.000000', 'temperatura', 1113.0000, 'ºC'),
	(336910, 143, '2015-02-01 00:48:33.000000', 'temperatura', 675.0000, 'ºC'),
	(336911, 143, '2015-02-01 00:48:34.000000', 'temperatura', 37.0000, 'ºC'),
	(336912, 143, '2015-02-01 00:48:35.000000', 'temperatura', 560.0000, 'ºC'),
	(336913, 143, '2015-02-01 00:48:36.000000', 'temperatura', 288.0000, 'ºC'),
	(336914, 143, '2015-02-01 00:48:37.000000', 'temperatura', 964.0000, 'ºC'),
	(336915, 143, '2015-02-01 00:48:38.000000', 'temperatura', 354.0000, 'ºC'),
	(336916, 143, '2015-02-01 00:48:39.000000', 'temperatura', 78.0000, 'ºC'),
	(336917, 143, '2015-02-01 00:48:40.000000', 'temperatura', 528.0000, 'ºC'),
	(336918, 143, '2015-02-01 00:48:41.000000', 'temperatura', 9.0000, 'ºC'),
	(336919, 143, '2015-02-01 00:48:42.000000', 'temperatura', 859.0000, 'ºC'),
	(336920, 143, '2015-02-01 00:48:43.000000', 'temperatura', 671.0000, 'ºC'),
	(336921, 143, '2015-02-01 00:48:44.000000', 'temperatura', 779.0000, 'ºC'),
	(336922, 143, '2015-02-01 00:48:45.000000', 'temperatura', 682.0000, 'ºC'),
	(336923, 143, '2015-02-01 00:48:46.000000', 'temperatura', 1072.0000, 'ºC'),
	(336924, 143, '2015-02-01 00:48:47.000000', 'temperatura', 916.0000, 'ºC'),
	(336925, 143, '2015-02-01 00:48:48.000000', 'temperatura', 164.0000, 'ºC'),
	(336926, 143, '2015-02-01 00:48:49.000000', 'temperatura', 475.0000, 'ºC'),
	(336927, 143, '2015-02-01 00:48:50.000000', 'temperatura', 680.0000, 'ºC'),
	(336928, 143, '2015-02-01 00:48:51.000000', 'temperatura', 776.0000, 'ºC'),
	(336929, 143, '2015-02-01 00:48:52.000000', 'temperatura', 642.0000, 'ºC'),
	(336930, 143, '2015-02-01 00:48:53.000000', 'temperatura', 883.0000, 'ºC'),
	(336931, 143, '2015-02-01 00:48:54.000000', 'temperatura', 87.0000, 'ºC'),
	(336932, 143, '2015-02-01 00:48:55.000000', 'temperatura', 189.0000, 'ºC'),
	(336933, 143, '2015-02-01 00:48:56.000000', 'temperatura', 682.0000, 'ºC'),
	(336934, 143, '2015-02-01 00:48:57.000000', 'temperatura', 446.0000, 'ºC'),
	(336935, 143, '2015-02-01 00:48:58.000000', 'temperatura', 184.0000, 'ºC'),
	(336936, 143, '2015-02-01 00:48:59.000000', 'temperatura', 784.0000, 'ºC'),
	(336937, 143, '2015-02-01 00:49:00.000000', 'temperatura', 966.0000, 'ºC'),
	(336938, 143, '2015-02-01 00:49:01.000000', 'temperatura', 81.0000, 'ºC'),
	(336939, 143, '2015-02-01 00:49:02.000000', 'temperatura', 1106.0000, 'ºC'),
	(336940, 143, '2015-02-01 00:49:03.000000', 'temperatura', 489.0000, 'ºC'),
	(336941, 143, '2015-02-01 00:49:04.000000', 'temperatura', 328.0000, 'ºC'),
	(336942, 143, '2015-02-01 00:49:05.000000', 'temperatura', 174.0000, 'ºC'),
	(336943, 143, '2015-02-01 00:49:06.000000', 'temperatura', 1084.0000, 'ºC'),
	(336944, 143, '2015-02-01 00:49:07.000000', 'temperatura', 101.0000, 'ºC'),
	(336945, 143, '2015-02-01 00:49:08.000000', 'temperatura', 850.0000, 'ºC'),
	(336946, 143, '2015-02-01 00:49:09.000000', 'temperatura', 351.0000, 'ºC'),
	(336947, 143, '2015-02-01 00:49:10.000000', 'temperatura', 404.0000, 'ºC'),
	(336948, 143, '2015-02-01 00:49:11.000000', 'temperatura', 966.0000, 'ºC'),
	(336949, 143, '2015-02-01 00:49:12.000000', 'temperatura', 20.0000, 'ºC'),
	(336950, 143, '2015-02-01 00:49:13.000000', 'temperatura', 804.0000, 'ºC'),
	(336951, 143, '2015-02-01 00:49:14.000000', 'temperatura', 361.0000, 'ºC'),
	(336952, 143, '2015-02-01 00:49:15.000000', 'temperatura', 591.0000, 'ºC'),
	(336953, 143, '2015-02-01 00:49:16.000000', 'temperatura', 674.0000, 'ºC'),
	(336954, 143, '2015-02-01 00:49:17.000000', 'temperatura', 396.0000, 'ºC'),
	(336955, 143, '2015-02-01 00:49:18.000000', 'temperatura', 1159.0000, 'ºC'),
	(336956, 143, '2015-02-01 00:49:19.000000', 'temperatura', 1008.0000, 'ºC'),
	(336957, 143, '2015-02-01 00:49:20.000000', 'temperatura', 362.0000, 'ºC'),
	(336958, 143, '2015-02-01 00:49:21.000000', 'temperatura', 1188.0000, 'ºC'),
	(336959, 143, '2015-02-01 00:49:22.000000', 'temperatura', 53.0000, 'ºC'),
	(336960, 143, '2015-02-01 00:49:23.000000', 'temperatura', 300.0000, 'ºC'),
	(336961, 143, '2015-02-01 00:49:24.000000', 'temperatura', 144.0000, 'ºC'),
	(336962, 143, '2015-02-01 00:49:25.000000', 'temperatura', 1020.0000, 'ºC'),
	(336963, 143, '2015-02-01 00:49:26.000000', 'temperatura', 1068.0000, 'ºC'),
	(336964, 143, '2015-02-01 00:49:27.000000', 'temperatura', 1080.0000, 'ºC'),
	(336965, 143, '2015-02-01 00:49:28.000000', 'temperatura', 996.0000, 'ºC'),
	(336966, 143, '2015-02-01 00:49:29.000000', 'temperatura', 542.0000, 'ºC'),
	(336967, 143, '2015-02-01 00:49:30.000000', 'temperatura', 920.0000, 'ºC'),
	(336968, 143, '2015-02-01 00:49:31.000000', 'temperatura', 578.0000, 'ºC'),
	(336969, 143, '2015-02-01 00:49:32.000000', 'temperatura', 128.0000, 'ºC'),
	(336970, 143, '2015-02-01 00:49:33.000000', 'temperatura', 106.0000, 'ºC'),
	(336971, 143, '2015-02-01 00:49:34.000000', 'temperatura', 149.0000, 'ºC'),
	(336972, 143, '2015-02-01 00:49:35.000000', 'temperatura', 424.0000, 'ºC'),
	(336973, 143, '2015-02-01 00:49:36.000000', 'temperatura', 477.0000, 'ºC'),
	(336974, 143, '2015-02-01 00:49:37.000000', 'temperatura', 1113.0000, 'ºC'),
	(336975, 143, '2015-02-01 00:49:38.000000', 'temperatura', 533.0000, 'ºC'),
	(336976, 143, '2015-02-01 00:49:39.000000', 'temperatura', 528.0000, 'ºC'),
	(336977, 143, '2015-02-01 00:49:40.000000', 'temperatura', 1043.0000, 'ºC'),
	(336978, 143, '2015-02-01 00:49:41.000000', 'temperatura', 28.0000, 'ºC'),
	(336979, 143, '2015-02-01 00:49:42.000000', 'temperatura', 613.0000, 'ºC'),
	(336980, 143, '2015-02-01 00:49:43.000000', 'temperatura', 581.0000, 'ºC'),
	(336981, 143, '2015-02-01 00:49:44.000000', 'temperatura', 1065.0000, 'ºC'),
	(336982, 143, '2015-02-01 00:49:45.000000', 'temperatura', 1185.0000, 'ºC'),
	(336983, 143, '2015-02-01 00:49:46.000000', 'temperatura', 328.0000, 'ºC'),
	(336984, 143, '2015-02-01 00:49:47.000000', 'temperatura', 485.0000, 'ºC'),
	(336985, 143, '2015-02-01 00:49:48.000000', 'temperatura', 244.0000, 'ºC'),
	(336986, 143, '2015-02-01 00:49:49.000000', 'temperatura', 964.0000, 'ºC'),
	(336987, 143, '2015-02-01 00:49:50.000000', 'temperatura', 491.0000, 'ºC'),
	(336988, 143, '2015-02-01 00:49:51.000000', 'temperatura', 760.0000, 'ºC'),
	(336989, 143, '2015-02-01 00:49:52.000000', 'temperatura', 1131.0000, 'ºC'),
	(336990, 143, '2015-02-01 00:49:53.000000', 'temperatura', 974.0000, 'ºC'),
	(336991, 143, '2015-02-01 00:49:54.000000', 'temperatura', 277.0000, 'ºC'),
	(336992, 143, '2015-02-01 00:49:55.000000', 'temperatura', 863.0000, 'ºC'),
	(336993, 143, '2015-02-01 00:49:56.000000', 'temperatura', 1083.0000, 'ºC'),
	(336994, 143, '2015-02-01 00:49:57.000000', 'temperatura', 428.0000, 'ºC'),
	(336995, 143, '2015-02-01 00:49:58.000000', 'temperatura', 92.0000, 'ºC'),
	(336996, 143, '2015-02-01 00:49:59.000000', 'temperatura', 377.0000, 'ºC'),
	(336997, 143, '2015-02-01 00:50:00.000000', 'temperatura', 410.0000, 'ºC'),
	(336998, 143, '2015-02-01 00:50:01.000000', 'temperatura', 918.0000, 'ºC'),
	(336999, 143, '2015-02-01 00:50:02.000000', 'temperatura', 960.0000, 'ºC'),
	(337000, 143, '2015-02-01 00:50:03.000000', 'temperatura', 847.0000, 'ºC'),
	(337001, 143, '2015-02-01 00:50:04.000000', 'temperatura', 154.0000, 'ºC'),
	(337002, 143, '2015-02-01 00:50:05.000000', 'temperatura', 629.0000, 'ºC'),
	(337003, 143, '2015-02-01 00:50:06.000000', 'temperatura', 285.0000, 'ºC'),
	(337004, 143, '2015-02-01 00:50:07.000000', 'temperatura', 737.0000, 'ºC'),
	(337005, 143, '2015-02-01 00:50:08.000000', 'temperatura', 432.0000, 'ºC'),
	(337006, 143, '2015-02-01 00:50:09.000000', 'temperatura', 1148.0000, 'ºC'),
	(337007, 143, '2015-02-01 00:50:10.000000', 'temperatura', 847.0000, 'ºC'),
	(337008, 143, '2015-02-01 00:50:11.000000', 'temperatura', 792.0000, 'ºC'),
	(337009, 143, '2015-02-01 00:50:12.000000', 'temperatura', 218.0000, 'ºC'),
	(337010, 143, '2015-02-01 00:50:13.000000', 'temperatura', 1113.0000, 'ºC'),
	(337011, 143, '2015-02-01 00:50:14.000000', 'temperatura', 111.0000, 'ºC'),
	(337012, 143, '2015-02-01 00:50:15.000000', 'temperatura', 820.0000, 'ºC'),
	(337013, 143, '2015-02-01 00:50:16.000000', 'temperatura', 165.0000, 'ºC'),
	(337014, 143, '2015-02-01 00:50:17.000000', 'temperatura', 766.0000, 'ºC'),
	(337015, 143, '2015-02-01 00:50:18.000000', 'temperatura', 935.0000, 'ºC'),
	(337016, 143, '2015-02-01 00:50:19.000000', 'temperatura', 1176.0000, 'ºC'),
	(337017, 143, '2015-02-01 00:50:20.000000', 'temperatura', 677.0000, 'ºC'),
	(337018, 143, '2015-02-01 00:50:21.000000', 'temperatura', 1056.0000, 'ºC'),
	(337019, 143, '2015-02-01 00:50:22.000000', 'temperatura', 850.0000, 'ºC'),
	(337020, 143, '2015-02-01 00:50:23.000000', 'temperatura', 1084.0000, 'ºC'),
	(337021, 143, '2015-02-01 00:50:24.000000', 'temperatura', 470.0000, 'ºC'),
	(337022, 143, '2015-02-01 00:50:25.000000', 'temperatura', 296.0000, 'ºC'),
	(337023, 143, '2015-02-01 00:50:26.000000', 'temperatura', 74.0000, 'ºC'),
	(337024, 143, '2015-02-01 00:50:27.000000', 'temperatura', 682.0000, 'ºC'),
	(337025, 143, '2015-02-01 00:50:28.000000', 'temperatura', 787.0000, 'ºC'),
	(337026, 143, '2015-02-01 00:50:29.000000', 'temperatura', 690.0000, 'ºC'),
	(337027, 143, '2015-02-01 00:50:30.000000', 'temperatura', 1090.0000, 'ºC'),
	(337028, 143, '2015-02-01 00:50:31.000000', 'temperatura', 981.0000, 'ºC'),
	(337029, 143, '2015-02-01 00:50:32.000000', 'temperatura', 433.0000, 'ºC'),
	(337030, 143, '2015-02-01 00:50:33.000000', 'temperatura', 423.0000, 'ºC'),
	(337031, 143, '2015-02-01 00:50:34.000000', 'temperatura', 819.0000, 'ºC'),
	(337032, 143, '2015-02-01 00:50:35.000000', 'temperatura', 424.0000, 'ºC'),
	(337033, 143, '2015-02-01 00:50:36.000000', 'temperatura', 863.0000, 'ºC'),
	(337034, 143, '2015-02-01 00:50:37.000000', 'temperatura', 646.0000, 'ºC'),
	(337035, 143, '2015-02-01 00:50:38.000000', 'temperatura', 643.0000, 'ºC'),
	(337036, 143, '2015-02-01 00:50:39.000000', 'temperatura', 74.0000, 'ºC'),
	(337037, 143, '2015-02-01 00:50:40.000000', 'temperatura', 841.0000, 'ºC'),
	(337038, 143, '2015-02-01 00:50:41.000000', 'temperatura', 386.0000, 'ºC'),
	(337039, 143, '2015-02-01 00:50:42.000000', 'temperatura', 607.0000, 'ºC'),
	(337040, 143, '2015-02-01 00:50:43.000000', 'temperatura', 677.0000, 'ºC'),
	(337041, 143, '2015-02-01 00:50:44.000000', 'temperatura', 364.0000, 'ºC'),
	(337042, 143, '2015-02-01 00:50:45.000000', 'temperatura', 988.0000, 'ºC'),
	(337043, 143, '2015-02-01 00:50:46.000000', 'temperatura', 251.0000, 'ºC'),
	(337044, 143, '2015-02-01 00:50:47.000000', 'temperatura', 692.0000, 'ºC'),
	(337045, 143, '2015-02-01 00:50:48.000000', 'temperatura', 308.0000, 'ºC'),
	(337046, 143, '2015-02-01 00:50:49.000000', 'temperatura', 664.0000, 'ºC'),
	(337047, 143, '2015-02-01 00:50:50.000000', 'temperatura', 1196.0000, 'ºC'),
	(337048, 143, '2015-02-01 00:50:51.000000', 'temperatura', 388.0000, 'ºC'),
	(337049, 143, '2015-02-01 00:50:52.000000', 'temperatura', 754.0000, 'ºC'),
	(337050, 143, '2015-02-01 00:50:53.000000', 'temperatura', 206.0000, 'ºC'),
	(337051, 143, '2015-02-01 00:50:54.000000', 'temperatura', 1169.0000, 'ºC'),
	(337052, 143, '2015-02-01 00:50:55.000000', 'temperatura', 428.0000, 'ºC'),
	(337053, 143, '2015-02-01 00:50:56.000000', 'temperatura', 1031.0000, 'ºC'),
	(337054, 143, '2015-02-01 00:50:57.000000', 'temperatura', 273.0000, 'ºC'),
	(337055, 143, '2015-02-01 00:50:58.000000', 'temperatura', 670.0000, 'ºC'),
	(337056, 143, '2015-02-01 00:50:59.000000', 'temperatura', 134.0000, 'ºC'),
	(337057, 143, '2015-02-01 00:51:00.000000', 'temperatura', 1062.0000, 'ºC'),
	(337058, 143, '2015-02-01 00:51:01.000000', 'temperatura', 107.0000, 'ºC'),
	(337059, 143, '2015-02-01 00:51:02.000000', 'temperatura', 949.0000, 'ºC'),
	(337060, 143, '2015-02-01 00:51:03.000000', 'temperatura', 826.0000, 'ºC'),
	(337061, 143, '2015-02-01 00:51:04.000000', 'temperatura', 82.0000, 'ºC'),
	(337062, 143, '2015-02-01 00:51:05.000000', 'temperatura', 331.0000, 'ºC'),
	(337063, 143, '2015-02-01 00:51:06.000000', 'temperatura', 213.0000, 'ºC'),
	(337064, 143, '2015-02-01 00:51:07.000000', 'temperatura', 70.0000, 'ºC'),
	(337065, 143, '2015-02-01 00:51:08.000000', 'temperatura', 911.0000, 'ºC'),
	(337066, 143, '2015-02-01 00:51:09.000000', 'temperatura', 744.0000, 'ºC'),
	(337067, 143, '2015-02-01 00:51:10.000000', 'temperatura', 990.0000, 'ºC'),
	(337068, 143, '2015-02-01 00:51:11.000000', 'temperatura', 318.0000, 'ºC'),
	(337069, 143, '2015-02-01 00:51:12.000000', 'temperatura', 1021.0000, 'ºC'),
	(337070, 143, '2015-02-01 00:51:13.000000', 'temperatura', 549.0000, 'ºC'),
	(337071, 143, '2015-02-01 00:51:14.000000', 'temperatura', 885.0000, 'ºC'),
	(337072, 143, '2015-02-01 00:51:15.000000', 'temperatura', 378.0000, 'ºC'),
	(337073, 143, '2015-02-01 00:51:16.000000', 'temperatura', 434.0000, 'ºC'),
	(337074, 143, '2015-02-01 00:51:17.000000', 'temperatura', 1037.0000, 'ºC'),
	(337075, 143, '2015-02-01 00:51:18.000000', 'temperatura', 284.0000, 'ºC'),
	(337076, 143, '2015-02-01 00:51:19.000000', 'temperatura', 709.0000, 'ºC'),
	(337077, 143, '2015-02-01 00:51:20.000000', 'temperatura', 294.0000, 'ºC'),
	(337078, 143, '2015-02-01 00:51:21.000000', 'temperatura', 545.0000, 'ºC'),
	(337079, 143, '2015-02-01 00:51:22.000000', 'temperatura', 644.0000, 'ºC'),
	(337080, 143, '2015-02-01 00:51:23.000000', 'temperatura', 385.0000, 'ºC'),
	(337081, 143, '2015-02-01 00:51:24.000000', 'temperatura', 1194.0000, 'ºC'),
	(337082, 143, '2015-02-01 00:51:25.000000', 'temperatura', 16.0000, 'ºC'),
	(337083, 143, '2015-02-01 00:51:26.000000', 'temperatura', 97.0000, 'ºC'),
	(337084, 143, '2015-02-01 00:51:27.000000', 'temperatura', 438.0000, 'ºC'),
	(337085, 143, '2015-02-01 00:51:28.000000', 'temperatura', 699.0000, 'ºC'),
	(337086, 143, '2015-02-01 00:51:29.000000', 'temperatura', 980.0000, 'ºC'),
	(337087, 143, '2015-02-01 00:51:30.000000', 'temperatura', 405.0000, 'ºC'),
	(337088, 143, '2015-02-01 00:51:31.000000', 'temperatura', 287.0000, 'ºC'),
	(337089, 143, '2015-02-01 00:51:32.000000', 'temperatura', 219.0000, 'ºC'),
	(337090, 143, '2015-02-01 00:51:33.000000', 'temperatura', 236.0000, 'ºC'),
	(337091, 143, '2015-02-01 00:51:34.000000', 'temperatura', 523.0000, 'ºC'),
	(337092, 143, '2015-02-01 00:51:35.000000', 'temperatura', 709.0000, 'ºC'),
	(337093, 143, '2015-02-01 00:51:36.000000', 'temperatura', 777.0000, 'ºC'),
	(337094, 143, '2015-02-01 00:51:37.000000', 'temperatura', 556.0000, 'ºC'),
	(337095, 143, '2015-02-01 00:51:38.000000', 'temperatura', 450.0000, 'ºC'),
	(337096, 143, '2015-02-01 00:51:39.000000', 'temperatura', 581.0000, 'ºC'),
	(337097, 143, '2015-02-01 00:51:40.000000', 'temperatura', 357.0000, 'ºC'),
	(337098, 143, '2015-02-01 00:51:41.000000', 'temperatura', 41.0000, 'ºC'),
	(337099, 143, '2015-02-01 00:51:42.000000', 'temperatura', 335.0000, 'ºC'),
	(337100, 143, '2015-02-01 00:51:43.000000', 'temperatura', 352.0000, 'ºC'),
	(337101, 143, '2015-02-01 00:51:44.000000', 'temperatura', 757.0000, 'ºC'),
	(337102, 143, '2015-02-01 00:51:45.000000', 'temperatura', 330.0000, 'ºC'),
	(337103, 143, '2015-02-01 00:51:46.000000', 'temperatura', 577.0000, 'ºC'),
	(337104, 143, '2015-02-01 00:51:47.000000', 'temperatura', 697.0000, 'ºC'),
	(337105, 143, '2015-02-01 00:51:48.000000', 'temperatura', 555.0000, 'ºC'),
	(337106, 143, '2015-02-01 00:51:49.000000', 'temperatura', 684.0000, 'ºC'),
	(337107, 143, '2015-02-01 00:51:50.000000', 'temperatura', 555.0000, 'ºC'),
	(337108, 143, '2015-02-01 00:51:51.000000', 'temperatura', 723.0000, 'ºC'),
	(337109, 143, '2015-02-01 00:51:52.000000', 'temperatura', 749.0000, 'ºC'),
	(337110, 143, '2015-02-01 00:51:53.000000', 'temperatura', 379.0000, 'ºC'),
	(337111, 143, '2015-02-01 00:51:54.000000', 'temperatura', 847.0000, 'ºC'),
	(337112, 143, '2015-02-01 00:51:55.000000', 'temperatura', 698.0000, 'ºC'),
	(337113, 143, '2015-02-01 00:51:56.000000', 'temperatura', 951.0000, 'ºC'),
	(337114, 143, '2015-02-01 00:51:57.000000', 'temperatura', 263.0000, 'ºC'),
	(337115, 143, '2015-02-01 00:51:58.000000', 'temperatura', 861.0000, 'ºC'),
	(337116, 143, '2015-02-01 00:51:59.000000', 'temperatura', 1117.0000, 'ºC'),
	(337117, 143, '2015-02-01 00:52:00.000000', 'temperatura', 604.0000, 'ºC'),
	(337118, 143, '2015-02-01 00:52:01.000000', 'temperatura', 868.0000, 'ºC'),
	(337119, 143, '2015-02-01 00:52:02.000000', 'temperatura', 130.0000, 'ºC'),
	(337120, 143, '2015-02-01 00:52:03.000000', 'temperatura', 446.0000, 'ºC'),
	(337121, 143, '2015-02-01 00:52:04.000000', 'temperatura', 641.0000, 'ºC'),
	(337122, 143, '2015-02-01 00:52:05.000000', 'temperatura', 665.0000, 'ºC'),
	(337123, 143, '2015-02-01 00:52:06.000000', 'temperatura', 205.0000, 'ºC'),
	(337124, 143, '2015-02-01 00:52:07.000000', 'temperatura', 230.0000, 'ºC'),
	(337125, 143, '2015-02-01 00:52:08.000000', 'temperatura', 537.0000, 'ºC'),
	(337126, 143, '2015-02-01 00:52:09.000000', 'temperatura', 793.0000, 'ºC'),
	(337127, 143, '2015-02-01 00:52:10.000000', 'temperatura', 1153.0000, 'ºC'),
	(337128, 143, '2015-02-01 00:52:11.000000', 'temperatura', 990.0000, 'ºC'),
	(337129, 143, '2015-02-01 00:52:12.000000', 'temperatura', 290.0000, 'ºC'),
	(337130, 143, '2015-02-01 00:52:13.000000', 'temperatura', 879.0000, 'ºC'),
	(337131, 143, '2015-02-01 00:52:14.000000', 'temperatura', 1128.0000, 'ºC'),
	(337132, 143, '2015-02-01 00:52:15.000000', 'temperatura', 602.0000, 'ºC'),
	(337133, 143, '2015-02-01 00:52:16.000000', 'temperatura', 827.0000, 'ºC'),
	(337134, 143, '2015-02-01 00:52:17.000000', 'temperatura', 1130.0000, 'ºC'),
	(337135, 143, '2015-02-01 00:52:18.000000', 'temperatura', 768.0000, 'ºC'),
	(337136, 143, '2015-02-01 00:52:19.000000', 'temperatura', 451.0000, 'ºC'),
	(337137, 143, '2015-02-01 00:52:20.000000', 'temperatura', 1154.0000, 'ºC'),
	(337138, 143, '2015-02-01 00:52:21.000000', 'temperatura', 815.0000, 'ºC'),
	(337139, 143, '2015-02-01 00:52:22.000000', 'temperatura', 614.0000, 'ºC'),
	(337140, 143, '2015-02-01 00:52:23.000000', 'temperatura', 627.0000, 'ºC'),
	(337141, 143, '2015-02-01 00:52:24.000000', 'temperatura', 94.0000, 'ºC'),
	(337142, 143, '2015-02-01 00:52:25.000000', 'temperatura', 988.0000, 'ºC'),
	(337143, 143, '2015-02-01 00:52:26.000000', 'temperatura', 1057.0000, 'ºC'),
	(337144, 143, '2015-02-01 00:52:27.000000', 'temperatura', 1124.0000, 'ºC'),
	(337145, 143, '2015-02-01 00:52:28.000000', 'temperatura', 49.0000, 'ºC'),
	(337146, 143, '2015-02-01 00:52:29.000000', 'temperatura', 472.0000, 'ºC'),
	(337147, 143, '2015-02-01 00:52:30.000000', 'temperatura', 1013.0000, 'ºC'),
	(337148, 143, '2015-02-01 00:52:31.000000', 'temperatura', 51.0000, 'ºC'),
	(337149, 143, '2015-02-01 00:52:32.000000', 'temperatura', 818.0000, 'ºC'),
	(337150, 143, '2015-02-01 00:52:33.000000', 'temperatura', 336.0000, 'ºC'),
	(337151, 143, '2015-02-01 00:52:34.000000', 'temperatura', 426.0000, 'ºC'),
	(337152, 143, '2015-02-01 00:52:35.000000', 'temperatura', 1123.0000, 'ºC'),
	(337153, 143, '2015-02-01 00:52:36.000000', 'temperatura', 736.0000, 'ºC'),
	(337154, 143, '2015-02-01 00:52:37.000000', 'temperatura', 313.0000, 'ºC'),
	(337155, 143, '2015-02-01 00:52:38.000000', 'temperatura', 558.0000, 'ºC'),
	(337156, 143, '2015-02-01 00:52:39.000000', 'temperatura', 652.0000, 'ºC'),
	(337157, 143, '2015-02-01 00:52:40.000000', 'temperatura', 385.0000, 'ºC'),
	(337158, 143, '2015-02-01 00:52:41.000000', 'temperatura', 1171.0000, 'ºC'),
	(337159, 143, '2015-02-01 00:52:42.000000', 'temperatura', 1102.0000, 'ºC'),
	(337160, 143, '2015-02-01 00:52:43.000000', 'temperatura', 795.0000, 'ºC'),
	(337161, 143, '2015-02-01 00:52:44.000000', 'temperatura', 669.0000, 'ºC'),
	(337162, 143, '2015-02-01 00:52:45.000000', 'temperatura', 963.0000, 'ºC'),
	(337163, 143, '2015-02-01 00:52:46.000000', 'temperatura', 407.0000, 'ºC'),
	(337164, 143, '2015-02-01 00:52:47.000000', 'temperatura', 346.0000, 'ºC'),
	(337165, 143, '2015-02-01 00:52:48.000000', 'temperatura', 512.0000, 'ºC'),
	(337166, 143, '2015-02-01 00:52:49.000000', 'temperatura', 320.0000, 'ºC'),
	(337167, 143, '2015-02-01 00:52:50.000000', 'temperatura', 66.0000, 'ºC'),
	(337168, 143, '2015-02-01 00:52:51.000000', 'temperatura', 568.0000, 'ºC'),
	(337169, 143, '2015-02-01 00:52:52.000000', 'temperatura', 246.0000, 'ºC'),
	(337170, 143, '2015-02-01 00:52:53.000000', 'temperatura', 724.0000, 'ºC'),
	(337171, 143, '2015-02-01 00:52:54.000000', 'temperatura', 482.0000, 'ºC'),
	(337172, 143, '2015-02-01 00:52:55.000000', 'temperatura', 238.0000, 'ºC'),
	(337173, 143, '2015-02-01 00:52:56.000000', 'temperatura', 946.0000, 'ºC'),
	(337174, 143, '2015-02-01 00:52:57.000000', 'temperatura', 417.0000, 'ºC'),
	(337175, 143, '2015-02-01 00:52:58.000000', 'temperatura', 445.0000, 'ºC'),
	(337176, 143, '2015-02-01 00:52:59.000000', 'temperatura', 975.0000, 'ºC'),
	(337177, 143, '2015-02-01 00:53:00.000000', 'temperatura', 1142.0000, 'ºC'),
	(337178, 143, '2015-02-01 00:53:01.000000', 'temperatura', 386.0000, 'ºC'),
	(337179, 143, '2015-02-01 00:53:02.000000', 'temperatura', 903.0000, 'ºC'),
	(337180, 143, '2015-02-01 00:53:03.000000', 'temperatura', 956.0000, 'ºC'),
	(337181, 143, '2015-02-01 00:53:04.000000', 'temperatura', 875.0000, 'ºC'),
	(337182, 143, '2015-02-01 00:53:05.000000', 'temperatura', 305.0000, 'ºC'),
	(337183, 143, '2015-02-01 00:53:06.000000', 'temperatura', 102.0000, 'ºC'),
	(337184, 143, '2015-02-01 00:53:07.000000', 'temperatura', 796.0000, 'ºC'),
	(337185, 143, '2015-02-01 00:53:08.000000', 'temperatura', 72.0000, 'ºC'),
	(337186, 143, '2015-02-01 00:53:09.000000', 'temperatura', 372.0000, 'ºC'),
	(337187, 143, '2015-02-01 00:53:10.000000', 'temperatura', 447.0000, 'ºC'),
	(337188, 143, '2015-02-01 00:53:11.000000', 'temperatura', 1117.0000, 'ºC'),
	(337189, 143, '2015-02-01 00:53:12.000000', 'temperatura', 646.0000, 'ºC'),
	(337190, 143, '2015-02-01 00:53:13.000000', 'temperatura', 1078.0000, 'ºC'),
	(337191, 143, '2015-02-01 00:53:14.000000', 'temperatura', 1052.0000, 'ºC'),
	(337192, 143, '2015-02-01 00:53:15.000000', 'temperatura', 829.0000, 'ºC'),
	(337193, 143, '2015-02-01 00:53:16.000000', 'temperatura', 989.0000, 'ºC'),
	(337194, 143, '2015-02-01 00:53:17.000000', 'temperatura', 57.0000, 'ºC'),
	(337195, 143, '2015-02-01 00:53:18.000000', 'temperatura', 919.0000, 'ºC'),
	(337196, 143, '2015-02-01 00:53:19.000000', 'temperatura', 826.0000, 'ºC'),
	(337197, 143, '2015-02-01 00:53:20.000000', 'temperatura', 173.0000, 'ºC'),
	(337198, 143, '2015-02-01 00:53:21.000000', 'temperatura', 787.0000, 'ºC'),
	(337199, 143, '2015-02-01 00:53:22.000000', 'temperatura', 1017.0000, 'ºC'),
	(337200, 143, '2015-02-01 00:53:23.000000', 'temperatura', 326.0000, 'ºC'),
	(337201, 143, '2015-02-01 00:53:24.000000', 'temperatura', 977.0000, 'ºC'),
	(337202, 143, '2015-02-01 00:53:25.000000', 'temperatura', 306.0000, 'ºC'),
	(337203, 143, '2015-02-01 00:53:26.000000', 'temperatura', 1003.0000, 'ºC'),
	(337204, 143, '2015-02-01 00:53:27.000000', 'temperatura', 495.0000, 'ºC'),
	(337205, 143, '2015-02-01 00:53:28.000000', 'temperatura', 669.0000, 'ºC'),
	(337206, 143, '2015-02-01 00:53:29.000000', 'temperatura', 660.0000, 'ºC'),
	(337207, 143, '2015-02-01 00:53:30.000000', 'temperatura', 94.0000, 'ºC'),
	(337208, 143, '2015-02-01 00:53:31.000000', 'temperatura', 891.0000, 'ºC'),
	(337209, 143, '2015-02-01 00:53:32.000000', 'temperatura', 572.0000, 'ºC'),
	(337210, 143, '2015-02-01 00:53:33.000000', 'temperatura', 188.0000, 'ºC'),
	(337211, 143, '2015-02-01 00:53:34.000000', 'temperatura', 424.0000, 'ºC'),
	(337212, 143, '2015-02-01 00:53:35.000000', 'temperatura', 355.0000, 'ºC'),
	(337213, 143, '2015-02-01 00:53:36.000000', 'temperatura', 503.0000, 'ºC'),
	(337214, 143, '2015-02-01 00:53:37.000000', 'temperatura', 254.0000, 'ºC'),
	(337215, 143, '2015-02-01 00:53:38.000000', 'temperatura', 959.0000, 'ºC'),
	(337216, 143, '2015-02-01 00:53:39.000000', 'temperatura', 434.0000, 'ºC'),
	(337217, 143, '2015-02-01 00:53:40.000000', 'temperatura', 495.0000, 'ºC'),
	(337218, 143, '2015-02-01 00:53:41.000000', 'temperatura', 1173.0000, 'ºC'),
	(337219, 143, '2015-02-01 00:53:42.000000', 'temperatura', 779.0000, 'ºC'),
	(337220, 143, '2015-02-01 00:53:43.000000', 'temperatura', 378.0000, 'ºC'),
	(337221, 143, '2015-02-01 00:53:44.000000', 'temperatura', 751.0000, 'ºC'),
	(337222, 143, '2015-02-01 00:53:45.000000', 'temperatura', 223.0000, 'ºC'),
	(337223, 143, '2015-02-01 00:53:46.000000', 'temperatura', 63.0000, 'ºC'),
	(337224, 143, '2015-02-01 00:53:47.000000', 'temperatura', 848.0000, 'ºC'),
	(337225, 143, '2015-02-01 00:53:48.000000', 'temperatura', 450.0000, 'ºC'),
	(337226, 143, '2015-02-01 00:53:49.000000', 'temperatura', 907.0000, 'ºC'),
	(337227, 143, '2015-02-01 00:53:50.000000', 'temperatura', 784.0000, 'ºC'),
	(337228, 143, '2015-02-01 00:53:51.000000', 'temperatura', 2.0000, 'ºC'),
	(337229, 143, '2015-02-01 00:53:52.000000', 'temperatura', 57.0000, 'ºC'),
	(337230, 143, '2015-02-01 00:53:53.000000', 'temperatura', 279.0000, 'ºC'),
	(337231, 143, '2015-02-01 00:53:54.000000', 'temperatura', 25.0000, 'ºC'),
	(337232, 143, '2015-02-01 00:53:55.000000', 'temperatura', 489.0000, 'ºC'),
	(337233, 143, '2015-02-01 00:53:56.000000', 'temperatura', 1169.0000, 'ºC'),
	(337234, 143, '2015-02-01 00:53:57.000000', 'temperatura', 781.0000, 'ºC'),
	(337235, 143, '2015-02-01 00:53:58.000000', 'temperatura', 399.0000, 'ºC'),
	(337236, 143, '2015-02-01 00:53:59.000000', 'temperatura', 851.0000, 'ºC'),
	(337237, 143, '2015-02-01 00:54:00.000000', 'temperatura', 659.0000, 'ºC'),
	(337238, 143, '2015-02-01 00:54:01.000000', 'temperatura', 743.0000, 'ºC'),
	(337239, 143, '2015-02-01 00:54:02.000000', 'temperatura', 536.0000, 'ºC'),
	(337240, 143, '2015-02-01 00:54:03.000000', 'temperatura', 454.0000, 'ºC'),
	(337241, 143, '2015-02-01 00:54:04.000000', 'temperatura', 660.0000, 'ºC'),
	(337242, 143, '2015-02-01 00:54:05.000000', 'temperatura', 738.0000, 'ºC'),
	(337243, 143, '2015-02-01 00:54:06.000000', 'temperatura', 512.0000, 'ºC'),
	(337244, 143, '2015-02-01 00:54:07.000000', 'temperatura', 347.0000, 'ºC'),
	(337245, 143, '2015-02-01 00:54:08.000000', 'temperatura', 200.0000, 'ºC'),
	(337246, 143, '2015-02-01 00:54:09.000000', 'temperatura', 1157.0000, 'ºC'),
	(337247, 143, '2015-02-01 00:54:10.000000', 'temperatura', 388.0000, 'ºC'),
	(337248, 143, '2015-02-01 00:54:11.000000', 'temperatura', 870.0000, 'ºC'),
	(337249, 143, '2015-02-01 00:54:12.000000', 'temperatura', 785.0000, 'ºC'),
	(337250, 143, '2015-02-01 00:54:13.000000', 'temperatura', 117.0000, 'ºC'),
	(337251, 143, '2015-02-01 00:54:14.000000', 'temperatura', 631.0000, 'ºC'),
	(337252, 143, '2015-02-01 00:54:15.000000', 'temperatura', 403.0000, 'ºC'),
	(337253, 143, '2015-02-01 00:54:16.000000', 'temperatura', 121.0000, 'ºC'),
	(337254, 143, '2015-02-01 00:54:17.000000', 'temperatura', 600.0000, 'ºC'),
	(337255, 143, '2015-02-01 00:54:18.000000', 'temperatura', 235.0000, 'ºC'),
	(337256, 143, '2015-02-01 00:54:19.000000', 'temperatura', 574.0000, 'ºC'),
	(337257, 143, '2015-02-01 00:54:20.000000', 'temperatura', 969.0000, 'ºC'),
	(337258, 143, '2015-02-01 00:54:21.000000', 'temperatura', 720.0000, 'ºC'),
	(337259, 143, '2015-02-01 00:54:22.000000', 'temperatura', 695.0000, 'ºC'),
	(337260, 143, '2015-02-01 00:54:23.000000', 'temperatura', 118.0000, 'ºC'),
	(337261, 143, '2015-02-01 00:54:24.000000', 'temperatura', 902.0000, 'ºC'),
	(337262, 143, '2015-02-01 00:54:25.000000', 'temperatura', 557.0000, 'ºC'),
	(337263, 143, '2015-02-01 00:54:26.000000', 'temperatura', 82.0000, 'ºC'),
	(337264, 143, '2015-02-01 00:54:27.000000', 'temperatura', 1137.0000, 'ºC'),
	(337265, 143, '2015-02-01 00:54:28.000000', 'temperatura', 641.0000, 'ºC'),
	(337266, 143, '2015-02-01 00:54:29.000000', 'temperatura', 993.0000, 'ºC'),
	(337267, 143, '2015-02-01 00:54:30.000000', 'temperatura', 643.0000, 'ºC'),
	(337268, 143, '2015-02-01 00:54:31.000000', 'temperatura', 236.0000, 'ºC'),
	(337269, 143, '2015-02-01 00:54:32.000000', 'temperatura', 451.0000, 'ºC'),
	(337270, 143, '2015-02-01 00:54:33.000000', 'temperatura', 348.0000, 'ºC'),
	(337271, 143, '2015-02-01 00:54:34.000000', 'temperatura', 390.0000, 'ºC'),
	(337272, 143, '2015-02-01 00:54:35.000000', 'temperatura', 903.0000, 'ºC'),
	(337273, 143, '2015-02-01 00:54:36.000000', 'temperatura', 948.0000, 'ºC'),
	(337274, 143, '2015-02-01 00:54:37.000000', 'temperatura', 831.0000, 'ºC'),
	(337275, 143, '2015-02-01 00:54:38.000000', 'temperatura', 110.0000, 'ºC'),
	(337276, 143, '2015-02-01 00:54:39.000000', 'temperatura', 460.0000, 'ºC'),
	(337277, 143, '2015-02-01 00:54:40.000000', 'temperatura', 771.0000, 'ºC'),
	(337278, 143, '2015-02-01 00:54:41.000000', 'temperatura', 74.0000, 'ºC'),
	(337279, 143, '2015-02-01 00:54:42.000000', 'temperatura', 456.0000, 'ºC'),
	(337280, 143, '2015-02-01 00:54:43.000000', 'temperatura', 860.0000, 'ºC'),
	(337281, 143, '2015-02-01 00:54:44.000000', 'temperatura', 533.0000, 'ºC'),
	(337282, 143, '2015-02-01 00:54:45.000000', 'temperatura', 86.0000, 'ºC'),
	(337283, 143, '2015-02-01 00:54:46.000000', 'temperatura', 32.0000, 'ºC'),
	(337284, 143, '2015-02-01 00:54:47.000000', 'temperatura', 1103.0000, 'ºC'),
	(337285, 143, '2015-02-01 00:54:48.000000', 'temperatura', 619.0000, 'ºC'),
	(337286, 143, '2015-02-01 00:54:49.000000', 'temperatura', 987.0000, 'ºC'),
	(337287, 143, '2015-02-01 00:54:50.000000', 'temperatura', 677.0000, 'ºC'),
	(337288, 143, '2015-02-01 00:54:51.000000', 'temperatura', 424.0000, 'ºC'),
	(337289, 143, '2015-02-01 00:54:52.000000', 'temperatura', 92.0000, 'ºC'),
	(337290, 143, '2015-02-01 00:54:53.000000', 'temperatura', 385.0000, 'ºC'),
	(337291, 143, '2015-02-01 00:54:54.000000', 'temperatura', 452.0000, 'ºC'),
	(337292, 143, '2015-02-01 00:54:55.000000', 'temperatura', 1106.0000, 'ºC'),
	(337293, 143, '2015-02-01 00:54:56.000000', 'temperatura', 574.0000, 'ºC'),
	(337294, 143, '2015-02-01 00:54:57.000000', 'temperatura', 754.0000, 'ºC'),
	(337295, 143, '2015-02-01 00:54:58.000000', 'temperatura', 847.0000, 'ºC'),
	(337296, 143, '2015-02-01 00:54:59.000000', 'temperatura', 774.0000, 'ºC'),
	(337297, 143, '2015-02-01 00:55:00.000000', 'temperatura', 129.0000, 'ºC'),
	(337298, 143, '2015-02-01 00:55:01.000000', 'temperatura', 725.0000, 'ºC'),
	(337299, 143, '2015-02-01 00:55:02.000000', 'temperatura', 837.0000, 'ºC'),
	(337300, 143, '2015-02-01 00:55:03.000000', 'temperatura', 812.0000, 'ºC'),
	(337301, 143, '2015-02-01 00:55:04.000000', 'temperatura', 348.0000, 'ºC'),
	(337302, 143, '2015-02-01 00:55:05.000000', 'temperatura', 507.0000, 'ºC'),
	(337303, 143, '2015-02-01 00:55:06.000000', 'temperatura', 290.0000, 'ºC'),
	(337304, 143, '2015-02-01 00:55:07.000000', 'temperatura', 1129.0000, 'ºC'),
	(337305, 143, '2015-02-01 00:55:08.000000', 'temperatura', 1174.0000, 'ºC'),
	(337306, 143, '2015-02-01 00:55:09.000000', 'temperatura', 84.0000, 'ºC'),
	(337307, 143, '2015-02-01 00:55:10.000000', 'temperatura', 498.0000, 'ºC'),
	(337308, 143, '2015-02-01 00:55:11.000000', 'temperatura', 1041.0000, 'ºC'),
	(337309, 143, '2015-02-01 00:55:12.000000', 'temperatura', 112.0000, 'ºC'),
	(337310, 143, '2015-02-01 00:55:13.000000', 'temperatura', 1035.0000, 'ºC'),
	(337311, 143, '2015-02-01 00:55:14.000000', 'temperatura', 39.0000, 'ºC'),
	(337312, 143, '2015-02-01 00:55:15.000000', 'temperatura', 692.0000, 'ºC'),
	(337313, 143, '2015-02-01 00:55:16.000000', 'temperatura', 943.0000, 'ºC'),
	(337314, 143, '2015-02-01 00:55:17.000000', 'temperatura', 239.0000, 'ºC'),
	(337315, 143, '2015-02-01 00:55:18.000000', 'temperatura', 765.0000, 'ºC'),
	(337316, 143, '2015-02-01 00:55:19.000000', 'temperatura', 712.0000, 'ºC'),
	(337317, 143, '2015-02-01 00:55:20.000000', 'temperatura', 63.0000, 'ºC'),
	(337318, 143, '2015-02-01 00:55:21.000000', 'temperatura', 579.0000, 'ºC'),
	(337319, 143, '2015-02-01 00:55:22.000000', 'temperatura', 306.0000, 'ºC'),
	(337320, 143, '2015-02-01 00:55:23.000000', 'temperatura', 994.0000, 'ºC'),
	(337321, 143, '2015-02-01 00:55:24.000000', 'temperatura', 452.0000, 'ºC'),
	(337322, 143, '2015-02-01 00:55:25.000000', 'temperatura', 478.0000, 'ºC'),
	(337323, 143, '2015-02-01 00:55:26.000000', 'temperatura', 1033.0000, 'ºC'),
	(337324, 143, '2015-02-01 00:55:27.000000', 'temperatura', 134.0000, 'ºC'),
	(337325, 143, '2015-02-01 00:55:28.000000', 'temperatura', 1170.0000, 'ºC'),
	(337326, 143, '2015-02-01 00:55:29.000000', 'temperatura', 648.0000, 'ºC'),
	(337327, 143, '2015-02-01 00:55:30.000000', 'temperatura', 930.0000, 'ºC'),
	(337328, 143, '2015-02-01 00:55:31.000000', 'temperatura', 309.0000, 'ºC'),
	(337329, 143, '2015-02-01 00:55:32.000000', 'temperatura', 1153.0000, 'ºC'),
	(337330, 143, '2015-02-01 00:55:33.000000', 'temperatura', 37.0000, 'ºC'),
	(337331, 143, '2015-02-01 00:55:34.000000', 'temperatura', 330.0000, 'ºC'),
	(337332, 143, '2015-02-01 00:55:35.000000', 'temperatura', 337.0000, 'ºC'),
	(337333, 143, '2015-02-01 00:55:36.000000', 'temperatura', 695.0000, 'ºC'),
	(337334, 143, '2015-02-01 00:55:37.000000', 'temperatura', 67.0000, 'ºC'),
	(337335, 143, '2015-02-01 00:55:38.000000', 'temperatura', 650.0000, 'ºC'),
	(337336, 143, '2015-02-01 00:55:39.000000', 'temperatura', 649.0000, 'ºC'),
	(337337, 143, '2015-02-01 00:55:40.000000', 'temperatura', 96.0000, 'ºC'),
	(337338, 143, '2015-02-01 00:55:41.000000', 'temperatura', 933.0000, 'ºC'),
	(337339, 143, '2015-02-01 00:55:42.000000', 'temperatura', 777.0000, 'ºC'),
	(337340, 143, '2015-02-01 00:55:43.000000', 'temperatura', 1088.0000, 'ºC'),
	(337341, 143, '2015-02-01 00:55:44.000000', 'temperatura', 711.0000, 'ºC'),
	(337342, 143, '2015-02-01 00:55:45.000000', 'temperatura', 289.0000, 'ºC'),
	(337343, 143, '2015-02-01 00:55:46.000000', 'temperatura', 512.0000, 'ºC'),
	(337344, 143, '2015-02-01 00:55:47.000000', 'temperatura', 493.0000, 'ºC'),
	(337345, 143, '2015-02-01 00:55:48.000000', 'temperatura', 929.0000, 'ºC'),
	(337346, 143, '2015-02-01 00:55:49.000000', 'temperatura', 767.0000, 'ºC'),
	(337347, 143, '2015-02-01 00:55:50.000000', 'temperatura', 1050.0000, 'ºC'),
	(337348, 143, '2015-02-01 00:55:51.000000', 'temperatura', 549.0000, 'ºC'),
	(337349, 143, '2015-02-01 00:55:52.000000', 'temperatura', 795.0000, 'ºC'),
	(337350, 143, '2015-02-01 00:55:53.000000', 'temperatura', 1128.0000, 'ºC'),
	(337351, 143, '2015-02-01 00:55:54.000000', 'temperatura', 855.0000, 'ºC'),
	(337352, 143, '2015-02-01 00:55:55.000000', 'temperatura', 892.0000, 'ºC'),
	(337353, 143, '2015-02-01 00:55:56.000000', 'temperatura', 697.0000, 'ºC'),
	(337354, 143, '2015-02-01 00:55:57.000000', 'temperatura', 808.0000, 'ºC'),
	(337355, 143, '2015-02-01 00:55:58.000000', 'temperatura', 751.0000, 'ºC'),
	(337356, 143, '2015-02-01 00:55:59.000000', 'temperatura', 132.0000, 'ºC'),
	(337357, 143, '2015-02-01 00:56:00.000000', 'temperatura', 806.0000, 'ºC'),
	(337358, 143, '2015-02-01 00:56:01.000000', 'temperatura', 34.0000, 'ºC'),
	(337359, 143, '2015-02-01 00:56:02.000000', 'temperatura', 152.0000, 'ºC'),
	(337360, 143, '2015-02-01 00:56:03.000000', 'temperatura', 659.0000, 'ºC'),
	(337361, 143, '2015-02-01 00:56:04.000000', 'temperatura', 439.0000, 'ºC'),
	(337362, 143, '2015-02-01 00:56:05.000000', 'temperatura', 217.0000, 'ºC'),
	(337363, 143, '2015-02-01 00:56:06.000000', 'temperatura', 970.0000, 'ºC'),
	(337364, 143, '2015-02-01 00:56:07.000000', 'temperatura', 598.0000, 'ºC'),
	(337365, 143, '2015-02-01 00:56:08.000000', 'temperatura', 83.0000, 'ºC'),
	(337366, 143, '2015-02-01 00:56:09.000000', 'temperatura', 1018.0000, 'ºC'),
	(337367, 143, '2015-02-01 00:56:10.000000', 'temperatura', 45.0000, 'ºC'),
	(337368, 143, '2015-02-01 00:56:11.000000', 'temperatura', 770.0000, 'ºC'),
	(337369, 143, '2015-02-01 00:56:12.000000', 'temperatura', 114.0000, 'ºC'),
	(337370, 143, '2015-02-01 00:56:13.000000', 'temperatura', 660.0000, 'ºC'),
	(337371, 143, '2015-02-01 00:56:14.000000', 'temperatura', 559.0000, 'ºC'),
	(337372, 143, '2015-02-01 00:56:15.000000', 'temperatura', 815.0000, 'ºC'),
	(337373, 143, '2015-02-01 00:56:16.000000', 'temperatura', 1199.0000, 'ºC'),
	(337374, 143, '2015-02-01 00:56:17.000000', 'temperatura', 1151.0000, 'ºC'),
	(337375, 143, '2015-02-01 00:56:18.000000', 'temperatura', 957.0000, 'ºC'),
	(337376, 143, '2015-02-01 00:56:19.000000', 'temperatura', 133.0000, 'ºC'),
	(337377, 143, '2015-02-01 00:56:20.000000', 'temperatura', 193.0000, 'ºC'),
	(337378, 143, '2015-02-01 00:56:21.000000', 'temperatura', 568.0000, 'ºC'),
	(337379, 143, '2015-02-01 00:56:22.000000', 'temperatura', 1060.0000, 'ºC'),
	(337380, 143, '2015-02-01 00:56:23.000000', 'temperatura', 1198.0000, 'ºC'),
	(337381, 143, '2015-02-01 00:56:24.000000', 'temperatura', 410.0000, 'ºC'),
	(337382, 143, '2015-02-01 00:56:25.000000', 'temperatura', 857.0000, 'ºC'),
	(337383, 143, '2015-02-01 00:56:26.000000', 'temperatura', 657.0000, 'ºC'),
	(337384, 143, '2015-02-01 00:56:27.000000', 'temperatura', 712.0000, 'ºC'),
	(337385, 143, '2015-02-01 00:56:28.000000', 'temperatura', 390.0000, 'ºC'),
	(337386, 143, '2015-02-01 00:56:29.000000', 'temperatura', 1014.0000, 'ºC'),
	(337387, 143, '2015-02-01 00:56:30.000000', 'temperatura', 303.0000, 'ºC'),
	(337388, 143, '2015-02-01 00:56:31.000000', 'temperatura', 871.0000, 'ºC'),
	(337389, 143, '2015-02-01 00:56:32.000000', 'temperatura', 1049.0000, 'ºC'),
	(337390, 143, '2015-02-01 00:56:33.000000', 'temperatura', 230.0000, 'ºC'),
	(337391, 143, '2015-02-01 00:56:34.000000', 'temperatura', 406.0000, 'ºC'),
	(337392, 143, '2015-02-01 00:56:35.000000', 'temperatura', 138.0000, 'ºC'),
	(337393, 143, '2015-02-01 00:56:36.000000', 'temperatura', 674.0000, 'ºC'),
	(337394, 143, '2015-02-01 00:56:37.000000', 'temperatura', 556.0000, 'ºC'),
	(337395, 143, '2015-02-01 00:56:38.000000', 'temperatura', 759.0000, 'ºC'),
	(337396, 143, '2015-02-01 00:56:39.000000', 'temperatura', 927.0000, 'ºC'),
	(337397, 143, '2015-02-01 00:56:40.000000', 'temperatura', 1160.0000, 'ºC'),
	(337398, 143, '2015-02-01 00:56:41.000000', 'temperatura', 620.0000, 'ºC'),
	(337399, 143, '2015-02-01 00:56:42.000000', 'temperatura', 818.0000, 'ºC'),
	(337400, 143, '2015-02-01 00:56:43.000000', 'temperatura', 1033.0000, 'ºC'),
	(337401, 143, '2015-02-01 00:56:44.000000', 'temperatura', 311.0000, 'ºC'),
	(337402, 143, '2015-02-01 00:56:45.000000', 'temperatura', 857.0000, 'ºC'),
	(337403, 143, '2015-02-01 00:56:46.000000', 'temperatura', 951.0000, 'ºC'),
	(337404, 143, '2015-02-01 00:56:47.000000', 'temperatura', 985.0000, 'ºC'),
	(337405, 143, '2015-02-01 00:56:48.000000', 'temperatura', 873.0000, 'ºC'),
	(337406, 143, '2015-02-01 00:56:49.000000', 'temperatura', 209.0000, 'ºC'),
	(337407, 143, '2015-02-01 00:56:50.000000', 'temperatura', 827.0000, 'ºC'),
	(337408, 143, '2015-02-01 00:56:51.000000', 'temperatura', 1108.0000, 'ºC'),
	(337409, 143, '2015-02-01 00:56:52.000000', 'temperatura', 662.0000, 'ºC'),
	(337410, 143, '2015-02-01 00:56:53.000000', 'temperatura', 1186.0000, 'ºC'),
	(337411, 143, '2015-02-01 00:56:54.000000', 'temperatura', 343.0000, 'ºC'),
	(337412, 143, '2015-02-01 00:56:55.000000', 'temperatura', 556.0000, 'ºC'),
	(337413, 143, '2015-02-01 00:56:56.000000', 'temperatura', 555.0000, 'ºC'),
	(337414, 143, '2015-02-01 00:56:57.000000', 'temperatura', 1105.0000, 'ºC'),
	(337415, 143, '2015-02-01 00:56:58.000000', 'temperatura', 262.0000, 'ºC'),
	(337416, 143, '2015-02-01 00:56:59.000000', 'temperatura', 393.0000, 'ºC'),
	(337417, 143, '2015-02-01 00:57:00.000000', 'temperatura', 1181.0000, 'ºC'),
	(337418, 143, '2015-02-01 00:57:01.000000', 'temperatura', 1128.0000, 'ºC'),
	(337419, 143, '2015-02-01 00:57:02.000000', 'temperatura', 898.0000, 'ºC'),
	(337420, 143, '2015-02-01 00:57:03.000000', 'temperatura', 1105.0000, 'ºC'),
	(337421, 143, '2015-02-01 00:57:04.000000', 'temperatura', 430.0000, 'ºC'),
	(337422, 143, '2015-02-01 00:57:05.000000', 'temperatura', 35.0000, 'ºC'),
	(337423, 143, '2015-02-01 00:57:06.000000', 'temperatura', 88.0000, 'ºC'),
	(337424, 143, '2015-02-01 00:57:07.000000', 'temperatura', 334.0000, 'ºC'),
	(337425, 143, '2015-02-01 00:57:08.000000', 'temperatura', 207.0000, 'ºC'),
	(337426, 143, '2015-02-01 00:57:09.000000', 'temperatura', 34.0000, 'ºC'),
	(337427, 143, '2015-02-01 00:57:10.000000', 'temperatura', 748.0000, 'ºC'),
	(337428, 143, '2015-02-01 00:57:11.000000', 'temperatura', 40.0000, 'ºC'),
	(337429, 143, '2015-02-01 00:57:12.000000', 'temperatura', 357.0000, 'ºC'),
	(337430, 143, '2015-02-01 00:57:13.000000', 'temperatura', 465.0000, 'ºC'),
	(337431, 143, '2015-02-01 00:57:14.000000', 'temperatura', 53.0000, 'ºC'),
	(337432, 143, '2015-02-01 00:57:15.000000', 'temperatura', 72.0000, 'ºC'),
	(337433, 143, '2015-02-01 00:57:16.000000', 'temperatura', 200.0000, 'ºC'),
	(337434, 143, '2015-02-01 00:57:17.000000', 'temperatura', 786.0000, 'ºC'),
	(337435, 143, '2015-02-01 00:57:18.000000', 'temperatura', 929.0000, 'ºC'),
	(337436, 143, '2015-02-01 00:57:19.000000', 'temperatura', 1090.0000, 'ºC'),
	(337437, 143, '2015-02-01 00:57:20.000000', 'temperatura', 264.0000, 'ºC'),
	(337438, 143, '2015-02-01 00:57:21.000000', 'temperatura', 448.0000, 'ºC'),
	(337439, 143, '2015-02-01 00:57:22.000000', 'temperatura', 249.0000, 'ºC'),
	(337440, 143, '2015-02-01 00:57:23.000000', 'temperatura', 1102.0000, 'ºC'),
	(337441, 143, '2015-02-01 00:57:24.000000', 'temperatura', 1164.0000, 'ºC'),
	(337442, 143, '2015-02-01 00:57:25.000000', 'temperatura', 115.0000, 'ºC'),
	(337443, 143, '2015-02-01 00:57:26.000000', 'temperatura', 684.0000, 'ºC'),
	(337444, 143, '2015-02-01 00:57:27.000000', 'temperatura', 673.0000, 'ºC'),
	(337445, 143, '2015-02-01 00:57:28.000000', 'temperatura', 115.0000, 'ºC'),
	(337446, 143, '2015-02-01 00:57:29.000000', 'temperatura', 955.0000, 'ºC'),
	(337447, 143, '2015-02-01 00:57:30.000000', 'temperatura', 833.0000, 'ºC'),
	(337448, 143, '2015-02-01 00:57:31.000000', 'temperatura', 97.0000, 'ºC'),
	(337449, 143, '2015-02-01 00:57:32.000000', 'temperatura', 390.0000, 'ºC'),
	(337450, 143, '2015-02-01 00:57:33.000000', 'temperatura', 457.0000, 'ºC'),
	(337451, 143, '2015-02-01 00:57:34.000000', 'temperatura', 1115.0000, 'ºC'),
	(337452, 143, '2015-02-01 00:57:35.000000', 'temperatura', 604.0000, 'ºC'),
	(337453, 143, '2015-02-01 00:57:36.000000', 'temperatura', 878.0000, 'ºC'),
	(337454, 143, '2015-02-01 00:57:37.000000', 'temperatura', 177.0000, 'ºC'),
	(337455, 143, '2015-02-01 00:57:38.000000', 'temperatura', 651.0000, 'ºC'),
	(337456, 143, '2015-02-01 00:57:39.000000', 'temperatura', 326.0000, 'ºC'),
	(337457, 143, '2015-02-01 00:57:40.000000', 'temperatura', 876.0000, 'ºC'),
	(337458, 143, '2015-02-01 00:57:41.000000', 'temperatura', 1002.0000, 'ºC'),
	(337459, 143, '2015-02-01 00:57:42.000000', 'temperatura', 1184.0000, 'ºC'),
	(337460, 143, '2015-02-01 00:57:43.000000', 'temperatura', 514.0000, 'ºC'),
	(337461, 143, '2015-02-01 00:57:44.000000', 'temperatura', 218.0000, 'ºC'),
	(337462, 143, '2015-02-01 00:57:45.000000', 'temperatura', 749.0000, 'ºC'),
	(337463, 143, '2015-02-01 00:57:46.000000', 'temperatura', 692.0000, 'ºC'),
	(337464, 143, '2015-02-01 00:57:47.000000', 'temperatura', 14.0000, 'ºC'),
	(337465, 143, '2015-02-01 00:57:48.000000', 'temperatura', 393.0000, 'ºC'),
	(337466, 143, '2015-02-01 00:57:49.000000', 'temperatura', 724.0000, 'ºC'),
	(337467, 143, '2015-02-01 00:57:50.000000', 'temperatura', 43.0000, 'ºC'),
	(337468, 143, '2015-02-01 00:57:51.000000', 'temperatura', 444.0000, 'ºC'),
	(337469, 143, '2015-02-01 00:57:52.000000', 'temperatura', 891.0000, 'ºC'),
	(337470, 143, '2015-02-01 00:57:53.000000', 'temperatura', 723.0000, 'ºC'),
	(337471, 143, '2015-02-01 00:57:54.000000', 'temperatura', 942.0000, 'ºC'),
	(337472, 143, '2015-02-01 00:57:55.000000', 'temperatura', 144.0000, 'ºC'),
	(337473, 143, '2015-02-01 00:57:56.000000', 'temperatura', 291.0000, 'ºC'),
	(337474, 143, '2015-02-01 00:57:57.000000', 'temperatura', 1025.0000, 'ºC'),
	(337475, 143, '2015-02-01 00:57:58.000000', 'temperatura', 653.0000, 'ºC'),
	(337476, 143, '2015-02-01 00:57:59.000000', 'temperatura', 190.0000, 'ºC'),
	(337477, 143, '2015-02-01 00:58:00.000000', 'temperatura', 193.0000, 'ºC'),
	(337478, 143, '2015-02-01 00:58:01.000000', 'temperatura', 394.0000, 'ºC'),
	(337479, 143, '2015-02-01 00:58:02.000000', 'temperatura', 194.0000, 'ºC'),
	(337480, 143, '2015-02-01 00:58:03.000000', 'temperatura', 985.0000, 'ºC'),
	(337481, 143, '2015-02-01 00:58:04.000000', 'temperatura', 746.0000, 'ºC'),
	(337482, 143, '2015-02-01 00:58:05.000000', 'temperatura', 774.0000, 'ºC'),
	(337483, 143, '2015-02-01 00:58:06.000000', 'temperatura', 431.0000, 'ºC'),
	(337484, 143, '2015-02-01 00:58:07.000000', 'temperatura', 1034.0000, 'ºC'),
	(337485, 143, '2015-02-01 00:58:08.000000', 'temperatura', 280.0000, 'ºC'),
	(337486, 143, '2015-02-01 00:58:09.000000', 'temperatura', 698.0000, 'ºC'),
	(337487, 143, '2015-02-01 00:58:10.000000', 'temperatura', 250.0000, 'ºC'),
	(337488, 143, '2015-02-01 00:58:11.000000', 'temperatura', 354.0000, 'ºC'),
	(337489, 143, '2015-02-01 00:58:12.000000', 'temperatura', 1024.0000, 'ºC'),
	(337490, 143, '2015-02-01 00:58:13.000000', 'temperatura', 456.0000, 'ºC'),
	(337491, 143, '2015-02-01 00:58:14.000000', 'temperatura', 408.0000, 'ºC'),
	(337492, 143, '2015-02-01 00:58:15.000000', 'temperatura', 673.0000, 'ºC'),
	(337493, 143, '2015-02-01 00:58:16.000000', 'temperatura', 940.0000, 'ºC'),
	(337494, 143, '2015-02-01 00:58:17.000000', 'temperatura', 285.0000, 'ºC'),
	(337495, 143, '2015-02-01 00:58:18.000000', 'temperatura', 1003.0000, 'ºC'),
	(337496, 143, '2015-02-01 00:58:19.000000', 'temperatura', 561.0000, 'ºC'),
	(337497, 143, '2015-02-01 00:58:20.000000', 'temperatura', 998.0000, 'ºC'),
	(337498, 143, '2015-02-01 00:58:21.000000', 'temperatura', 905.0000, 'ºC'),
	(337499, 143, '2015-02-01 00:58:22.000000', 'temperatura', 335.0000, 'ºC'),
	(337500, 143, '2015-02-01 00:58:23.000000', 'temperatura', 157.0000, 'ºC'),
	(337501, 143, '2015-02-01 00:58:24.000000', 'temperatura', 984.0000, 'ºC'),
	(337502, 143, '2015-02-01 00:58:25.000000', 'temperatura', 846.0000, 'ºC'),
	(337503, 143, '2015-02-01 00:58:26.000000', 'temperatura', 81.0000, 'ºC'),
	(337504, 143, '2015-02-01 00:58:27.000000', 'temperatura', 268.0000, 'ºC'),
	(337505, 143, '2015-02-01 00:58:28.000000', 'temperatura', 1097.0000, 'ºC'),
	(337506, 143, '2015-02-01 00:58:29.000000', 'temperatura', 1083.0000, 'ºC'),
	(337507, 143, '2015-02-01 00:58:30.000000', 'temperatura', 923.0000, 'ºC'),
	(337508, 143, '2015-02-01 00:58:31.000000', 'temperatura', 165.0000, 'ºC'),
	(337509, 143, '2015-02-01 00:58:32.000000', 'temperatura', 457.0000, 'ºC'),
	(337510, 143, '2015-02-01 00:58:33.000000', 'temperatura', 593.0000, 'ºC'),
	(337511, 143, '2015-02-01 00:58:34.000000', 'temperatura', 391.0000, 'ºC'),
	(337512, 143, '2015-02-01 00:58:35.000000', 'temperatura', 180.0000, 'ºC'),
	(337513, 143, '2015-02-01 00:58:36.000000', 'temperatura', 924.0000, 'ºC'),
	(337514, 143, '2015-02-01 00:58:37.000000', 'temperatura', 483.0000, 'ºC'),
	(337515, 143, '2015-02-01 00:58:38.000000', 'temperatura', 841.0000, 'ºC'),
	(337516, 143, '2015-02-01 00:58:39.000000', 'temperatura', 359.0000, 'ºC'),
	(337517, 143, '2015-02-01 00:58:40.000000', 'temperatura', 472.0000, 'ºC'),
	(337518, 143, '2015-02-01 00:58:41.000000', 'temperatura', 84.0000, 'ºC'),
	(337519, 143, '2015-02-01 00:58:42.000000', 'temperatura', 203.0000, 'ºC'),
	(337520, 143, '2015-02-01 00:58:43.000000', 'temperatura', 766.0000, 'ºC'),
	(337521, 143, '2015-02-01 00:58:44.000000', 'temperatura', 819.0000, 'ºC'),
	(337522, 143, '2015-02-01 00:58:45.000000', 'temperatura', 597.0000, 'ºC'),
	(337523, 143, '2015-02-01 00:58:46.000000', 'temperatura', 529.0000, 'ºC'),
	(337524, 143, '2015-02-01 00:58:47.000000', 'temperatura', 857.0000, 'ºC'),
	(337525, 143, '2015-02-01 00:58:48.000000', 'temperatura', 296.0000, 'ºC'),
	(337526, 143, '2015-02-01 00:58:49.000000', 'temperatura', 111.0000, 'ºC'),
	(337527, 143, '2015-02-01 00:58:50.000000', 'temperatura', 868.0000, 'ºC'),
	(337528, 143, '2015-02-01 00:58:51.000000', 'temperatura', 406.0000, 'ºC'),
	(337529, 143, '2015-02-01 00:58:52.000000', 'temperatura', 627.0000, 'ºC'),
	(337530, 143, '2015-02-01 00:58:53.000000', 'temperatura', 717.0000, 'ºC'),
	(337531, 143, '2015-02-01 00:58:54.000000', 'temperatura', 505.0000, 'ºC'),
	(337532, 143, '2015-02-01 00:58:55.000000', 'temperatura', 375.0000, 'ºC'),
	(337533, 143, '2015-02-01 00:58:56.000000', 'temperatura', 361.0000, 'ºC'),
	(337534, 143, '2015-02-01 00:58:57.000000', 'temperatura', 681.0000, 'ºC'),
	(337535, 143, '2015-02-01 00:58:58.000000', 'temperatura', 1122.0000, 'ºC'),
	(337536, 143, '2015-02-01 00:58:59.000000', 'temperatura', 1167.0000, 'ºC'),
	(337537, 143, '2015-02-01 00:59:00.000000', 'temperatura', 68.0000, 'ºC'),
	(337538, 143, '2015-02-01 00:59:01.000000', 'temperatura', 441.0000, 'ºC'),
	(337539, 143, '2015-02-01 00:59:02.000000', 'temperatura', 803.0000, 'ºC'),
	(337540, 143, '2015-02-01 00:59:03.000000', 'temperatura', 292.0000, 'ºC'),
	(337541, 143, '2015-02-01 00:59:04.000000', 'temperatura', 253.0000, 'ºC'),
	(337542, 143, '2015-02-01 00:59:05.000000', 'temperatura', 386.0000, 'ºC'),
	(337543, 143, '2015-02-01 00:59:06.000000', 'temperatura', 1173.0000, 'ºC'),
	(337544, 143, '2015-02-01 00:59:07.000000', 'temperatura', 1109.0000, 'ºC'),
	(337545, 143, '2015-02-01 00:59:08.000000', 'temperatura', 824.0000, 'ºC'),
	(337546, 143, '2015-02-01 00:59:09.000000', 'temperatura', 794.0000, 'ºC'),
	(337547, 143, '2015-02-01 00:59:10.000000', 'temperatura', 299.0000, 'ºC'),
	(337548, 143, '2015-02-01 00:59:11.000000', 'temperatura', 312.0000, 'ºC'),
	(337549, 143, '2015-02-01 00:59:12.000000', 'temperatura', 664.0000, 'ºC'),
	(337550, 143, '2015-02-01 00:59:13.000000', 'temperatura', 1184.0000, 'ºC'),
	(337551, 143, '2015-02-01 00:59:14.000000', 'temperatura', 330.0000, 'ºC'),
	(337552, 143, '2015-02-01 00:59:15.000000', 'temperatura', 500.0000, 'ºC'),
	(337553, 143, '2015-02-01 00:59:16.000000', 'temperatura', 308.0000, 'ºC'),
	(337554, 143, '2015-02-01 00:59:17.000000', 'temperatura', 42.0000, 'ºC'),
	(337555, 143, '2015-02-01 00:59:18.000000', 'temperatura', 484.0000, 'ºC'),
	(337556, 143, '2015-02-01 00:59:19.000000', 'temperatura', 1096.0000, 'ºC'),
	(337557, 143, '2015-02-01 00:59:20.000000', 'temperatura', 429.0000, 'ºC'),
	(337558, 143, '2015-02-01 00:59:21.000000', 'temperatura', 59.0000, 'ºC'),
	(337559, 143, '2015-02-01 00:59:22.000000', 'temperatura', 206.0000, 'ºC'),
	(337560, 143, '2015-02-01 00:59:23.000000', 'temperatura', 854.0000, 'ºC'),
	(337561, 143, '2015-02-01 00:59:24.000000', 'temperatura', 52.0000, 'ºC'),
	(337562, 143, '2015-02-01 00:59:25.000000', 'temperatura', 100.0000, 'ºC'),
	(337563, 143, '2015-02-01 00:59:26.000000', 'temperatura', 345.0000, 'ºC'),
	(337564, 143, '2015-02-01 00:59:27.000000', 'temperatura', 223.0000, 'ºC'),
	(337565, 143, '2015-02-01 00:59:28.000000', 'temperatura', 84.0000, 'ºC'),
	(337566, 143, '2015-02-01 00:59:29.000000', 'temperatura', 948.0000, 'ºC'),
	(337567, 143, '2015-02-01 00:59:30.000000', 'temperatura', 891.0000, 'ºC'),
	(337568, 143, '2015-02-01 00:59:31.000000', 'temperatura', 411.0000, 'ºC'),
	(337569, 143, '2015-02-01 00:59:32.000000', 'temperatura', 582.0000, 'ºC'),
	(337570, 143, '2015-02-01 00:59:33.000000', 'temperatura', 479.0000, 'ºC'),
	(337571, 143, '2015-02-01 00:59:34.000000', 'temperatura', 647.0000, 'ºC'),
	(337572, 143, '2015-02-01 00:59:35.000000', 'temperatura', 598.0000, 'ºC'),
	(337573, 143, '2015-02-01 00:59:36.000000', 'temperatura', 1051.0000, 'ºC'),
	(337574, 143, '2015-02-01 00:59:37.000000', 'temperatura', 1063.0000, 'ºC'),
	(337575, 143, '2015-02-01 00:59:38.000000', 'temperatura', 960.0000, 'ºC'),
	(337576, 143, '2015-02-01 00:59:39.000000', 'temperatura', 413.0000, 'ºC'),
	(337577, 143, '2015-02-01 00:59:40.000000', 'temperatura', 386.0000, 'ºC'),
	(337578, 143, '2015-02-01 00:59:41.000000', 'temperatura', 689.0000, 'ºC'),
	(337579, 143, '2015-02-01 00:59:42.000000', 'temperatura', 1088.0000, 'ºC'),
	(337580, 143, '2015-02-01 00:59:43.000000', 'temperatura', 974.0000, 'ºC'),
	(337581, 143, '2015-02-01 00:59:44.000000', 'temperatura', 407.0000, 'ºC'),
	(337582, 143, '2015-02-01 00:59:45.000000', 'temperatura', 314.0000, 'ºC'),
	(337583, 143, '2015-02-01 00:59:46.000000', 'temperatura', 351.0000, 'ºC'),
	(337584, 143, '2015-02-01 00:59:47.000000', 'temperatura', 810.0000, 'ºC'),
	(337585, 143, '2015-02-01 00:59:48.000000', 'temperatura', 601.0000, 'ºC'),
	(337586, 143, '2015-02-01 00:59:49.000000', 'temperatura', 573.0000, 'ºC'),
	(337587, 143, '2015-02-01 00:59:50.000000', 'temperatura', 1065.0000, 'ºC'),
	(337588, 143, '2015-02-01 00:59:51.000000', 'temperatura', 3.0000, 'ºC'),
	(337589, 143, '2015-02-01 00:59:52.000000', 'temperatura', 423.0000, 'ºC'),
	(337590, 143, '2015-02-01 00:59:53.000000', 'temperatura', 907.0000, 'ºC'),
	(337591, 143, '2015-02-01 00:59:54.000000', 'temperatura', 865.0000, 'ºC'),
	(337592, 143, '2015-02-01 00:59:55.000000', 'temperatura', 404.0000, 'ºC'),
	(337593, 143, '2015-02-01 00:59:56.000000', 'temperatura', 625.0000, 'ºC'),
	(337594, 143, '2015-02-01 00:59:57.000000', 'temperatura', 712.0000, 'ºC'),
	(337595, 143, '2015-02-01 00:59:58.000000', 'temperatura', 489.0000, 'ºC'),
	(337596, 143, '2015-02-01 00:59:59.000000', 'temperatura', 306.0000, 'ºC'),
	(337597, 143, '2015-02-01 01:00:00.000000', 'temperatura', 66.0000, 'ºC'),
	(337598, 143, '2015-02-01 01:00:01.000000', 'temperatura', 612.0000, 'ºC'),
	(337599, 143, '2015-02-01 01:00:02.000000', 'temperatura', 462.0000, 'ºC'),
	(337600, 143, '2015-02-01 01:00:03.000000', 'temperatura', 475.0000, 'ºC'),
	(337601, 143, '2015-02-01 01:00:04.000000', 'temperatura', 989.0000, 'ºC'),
	(337602, 143, '2015-02-01 01:00:05.000000', 'temperatura', 1120.0000, 'ºC'),
	(337603, 143, '2015-02-01 01:00:06.000000', 'temperatura', 235.0000, 'ºC'),
	(337604, 143, '2015-02-01 01:00:07.000000', 'temperatura', 215.0000, 'ºC'),
	(337605, 143, '2015-02-01 01:00:08.000000', 'temperatura', 371.0000, 'ºC'),
	(337606, 143, '2015-02-01 01:00:09.000000', 'temperatura', 8.0000, 'ºC'),
	(337607, 143, '2015-02-01 01:00:10.000000', 'temperatura', 129.0000, 'ºC'),
	(337608, 143, '2015-02-01 01:00:11.000000', 'temperatura', 623.0000, 'ºC'),
	(337609, 143, '2015-02-01 01:00:12.000000', 'temperatura', 326.0000, 'ºC'),
	(337610, 143, '2015-02-01 01:00:13.000000', 'temperatura', 961.0000, 'ºC'),
	(337611, 143, '2015-02-01 01:00:14.000000', 'temperatura', 227.0000, 'ºC'),
	(337612, 143, '2015-02-01 01:00:15.000000', 'temperatura', 653.0000, 'ºC'),
	(337613, 143, '2015-02-01 01:00:16.000000', 'temperatura', 186.0000, 'ºC'),
	(337614, 143, '2015-02-01 01:00:17.000000', 'temperatura', 170.0000, 'ºC'),
	(337615, 143, '2015-02-01 01:00:18.000000', 'temperatura', 293.0000, 'ºC'),
	(337616, 143, '2015-02-01 01:00:19.000000', 'temperatura', 955.0000, 'ºC'),
	(337617, 143, '2015-02-01 01:00:20.000000', 'temperatura', 295.0000, 'ºC'),
	(337618, 143, '2015-02-01 01:00:21.000000', 'temperatura', 1011.0000, 'ºC'),
	(337619, 143, '2015-02-01 01:00:22.000000', 'temperatura', 569.0000, 'ºC'),
	(337620, 143, '2015-02-01 01:00:23.000000', 'temperatura', 1015.0000, 'ºC'),
	(337621, 143, '2015-02-01 01:00:24.000000', 'temperatura', 967.0000, 'ºC'),
	(337622, 143, '2015-02-01 01:00:25.000000', 'temperatura', 591.0000, 'ºC'),
	(337623, 143, '2015-02-01 01:00:26.000000', 'temperatura', 55.0000, 'ºC'),
	(337624, 143, '2015-02-01 01:00:27.000000', 'temperatura', 904.0000, 'ºC'),
	(337625, 143, '2015-02-01 01:00:28.000000', 'temperatura', 753.0000, 'ºC'),
	(337626, 143, '2015-02-01 01:00:29.000000', 'temperatura', 1054.0000, 'ºC'),
	(337627, 143, '2015-02-01 01:00:30.000000', 'temperatura', 612.0000, 'ºC'),
	(337628, 143, '2015-02-01 01:00:31.000000', 'temperatura', 1099.0000, 'ºC'),
	(337629, 143, '2015-02-01 01:00:32.000000', 'temperatura', 58.0000, 'ºC'),
	(337630, 143, '2015-02-01 01:00:33.000000', 'temperatura', 593.0000, 'ºC'),
	(337631, 143, '2015-02-01 01:00:34.000000', 'temperatura', 393.0000, 'ºC'),
	(337632, 143, '2015-02-01 01:00:35.000000', 'temperatura', 184.0000, 'ºC'),
	(337633, 143, '2015-02-01 01:00:36.000000', 'temperatura', 943.0000, 'ºC'),
	(337634, 143, '2015-02-01 01:00:37.000000', 'temperatura', 565.0000, 'ºC'),
	(337635, 143, '2015-02-01 01:00:38.000000', 'temperatura', 1193.0000, 'ºC'),
	(337636, 143, '2015-02-01 01:00:39.000000', 'temperatura', 674.0000, 'ºC'),
	(337637, 143, '2015-02-01 01:00:40.000000', 'temperatura', 988.0000, 'ºC'),
	(337638, 143, '2015-02-01 01:00:41.000000', 'temperatura', 521.0000, 'ºC'),
	(337639, 143, '2015-02-01 01:00:42.000000', 'temperatura', 841.0000, 'ºC'),
	(337640, 143, '2015-02-01 01:00:43.000000', 'temperatura', 244.0000, 'ºC'),
	(337641, 143, '2015-02-01 01:00:44.000000', 'temperatura', 1096.0000, 'ºC'),
	(337642, 143, '2015-02-01 01:00:45.000000', 'temperatura', 1148.0000, 'ºC'),
	(337643, 143, '2015-02-01 01:00:46.000000', 'temperatura', 54.0000, 'ºC'),
	(337644, 143, '2015-02-01 01:00:47.000000', 'temperatura', 427.0000, 'ºC'),
	(337645, 143, '2015-02-01 01:00:48.000000', 'temperatura', 773.0000, 'ºC'),
	(337646, 143, '2015-02-01 01:00:49.000000', 'temperatura', 184.0000, 'ºC'),
	(337647, 143, '2015-02-01 01:00:50.000000', 'temperatura', 1003.0000, 'ºC'),
	(337648, 143, '2015-02-01 01:00:51.000000', 'temperatura', 862.0000, 'ºC'),
	(337649, 143, '2015-02-01 01:00:52.000000', 'temperatura', 103.0000, 'ºC'),
	(337650, 143, '2015-02-01 01:00:53.000000', 'temperatura', 329.0000, 'ºC'),
	(337651, 143, '2015-02-01 01:00:54.000000', 'temperatura', 135.0000, 'ºC'),
	(337652, 143, '2015-02-01 01:00:55.000000', 'temperatura', 888.0000, 'ºC'),
	(337653, 143, '2015-02-01 01:00:56.000000', 'temperatura', 438.0000, 'ºC'),
	(337654, 143, '2015-02-01 01:00:57.000000', 'temperatura', 724.0000, 'ºC'),
	(337655, 143, '2015-02-01 01:00:58.000000', 'temperatura', 1106.0000, 'ºC'),
	(337656, 143, '2015-02-01 01:00:59.000000', 'temperatura', 958.0000, 'ºC'),
	(337657, 143, '2015-02-01 01:01:00.000000', 'temperatura', 275.0000, 'ºC'),
	(337658, 143, '2015-02-01 01:01:01.000000', 'temperatura', 900.0000, 'ºC'),
	(337659, 143, '2015-02-01 01:01:02.000000', 'temperatura', 77.0000, 'ºC'),
	(337660, 143, '2015-02-01 01:01:03.000000', 'temperatura', 85.0000, 'ºC'),
	(337661, 143, '2015-02-01 01:01:04.000000', 'temperatura', 195.0000, 'ºC'),
	(337662, 143, '2015-02-01 01:01:05.000000', 'temperatura', 719.0000, 'ºC'),
	(337663, 143, '2015-02-01 01:01:06.000000', 'temperatura', 610.0000, 'ºC'),
	(337664, 143, '2015-02-01 01:01:07.000000', 'temperatura', 893.0000, 'ºC'),
	(337665, 143, '2015-02-01 01:01:08.000000', 'temperatura', 237.0000, 'ºC'),
	(337666, 143, '2015-02-01 01:01:09.000000', 'temperatura', 908.0000, 'ºC'),
	(337667, 143, '2015-02-01 01:01:10.000000', 'temperatura', 226.0000, 'ºC'),
	(337668, 143, '2015-02-01 01:01:11.000000', 'temperatura', 809.0000, 'ºC'),
	(337669, 143, '2015-02-01 01:01:12.000000', 'temperatura', 965.0000, 'ºC'),
	(337670, 143, '2015-02-01 01:01:13.000000', 'temperatura', 1199.0000, 'ºC'),
	(337671, 143, '2015-02-01 01:01:14.000000', 'temperatura', 700.0000, 'ºC'),
	(337672, 143, '2015-02-01 01:01:15.000000', 'temperatura', 1104.0000, 'ºC'),
	(337673, 143, '2015-02-01 01:01:16.000000', 'temperatura', 1019.0000, 'ºC'),
	(337674, 143, '2015-02-01 01:01:17.000000', 'temperatura', 585.0000, 'ºC'),
	(337675, 143, '2015-02-01 01:01:18.000000', 'temperatura', 1070.0000, 'ºC'),
	(337676, 143, '2015-02-01 01:01:19.000000', 'temperatura', 1196.0000, 'ºC'),
	(337677, 143, '2015-02-01 01:01:20.000000', 'temperatura', 369.0000, 'ºC'),
	(337678, 143, '2015-02-01 01:01:21.000000', 'temperatura', 658.0000, 'ºC'),
	(337679, 143, '2015-02-01 01:01:22.000000', 'temperatura', 981.0000, 'ºC'),
	(337680, 143, '2015-02-01 01:01:23.000000', 'temperatura', 535.0000, 'ºC'),
	(337681, 143, '2015-02-01 01:01:24.000000', 'temperatura', 931.0000, 'ºC'),
	(337682, 143, '2015-02-01 01:01:25.000000', 'temperatura', 652.0000, 'ºC'),
	(337683, 143, '2015-02-01 01:01:26.000000', 'temperatura', 468.0000, 'ºC'),
	(337684, 143, '2015-02-01 01:01:27.000000', 'temperatura', 382.0000, 'ºC'),
	(337685, 143, '2015-02-01 01:01:28.000000', 'temperatura', 509.0000, 'ºC'),
	(337686, 143, '2015-02-01 01:01:29.000000', 'temperatura', 200.0000, 'ºC'),
	(337687, 143, '2015-02-01 01:01:30.000000', 'temperatura', 673.0000, 'ºC'),
	(337688, 143, '2015-02-01 01:01:31.000000', 'temperatura', 365.0000, 'ºC'),
	(337689, 143, '2015-02-01 01:01:32.000000', 'temperatura', 1005.0000, 'ºC'),
	(337690, 143, '2015-02-01 01:01:33.000000', 'temperatura', 331.0000, 'ºC'),
	(337691, 143, '2015-02-01 01:01:34.000000', 'temperatura', 1043.0000, 'ºC'),
	(337692, 143, '2015-02-01 01:01:35.000000', 'temperatura', 620.0000, 'ºC'),
	(337693, 143, '2015-02-01 01:01:36.000000', 'temperatura', 1173.0000, 'ºC'),
	(337694, 143, '2015-02-01 01:01:37.000000', 'temperatura', 407.0000, 'ºC'),
	(337695, 143, '2015-02-01 01:01:38.000000', 'temperatura', 915.0000, 'ºC'),
	(337696, 143, '2015-02-01 01:01:39.000000', 'temperatura', 953.0000, 'ºC'),
	(337697, 143, '2015-02-01 01:01:40.000000', 'temperatura', 820.0000, 'ºC'),
	(337698, 143, '2015-02-01 01:01:41.000000', 'temperatura', 45.0000, 'ºC'),
	(337699, 143, '2015-02-01 01:01:42.000000', 'temperatura', 162.0000, 'ºC'),
	(337700, 143, '2015-02-01 01:01:43.000000', 'temperatura', 679.0000, 'ºC'),
	(337701, 143, '2015-02-01 01:01:44.000000', 'temperatura', 506.0000, 'ºC'),
	(337702, 143, '2015-02-01 01:01:45.000000', 'temperatura', 495.0000, 'ºC'),
	(337703, 143, '2015-02-01 01:01:46.000000', 'temperatura', 956.0000, 'ºC'),
	(337704, 143, '2015-02-01 01:01:47.000000', 'temperatura', 897.0000, 'ºC'),
	(337705, 143, '2015-02-01 01:01:48.000000', 'temperatura', 419.0000, 'ºC'),
	(337706, 143, '2015-02-01 01:01:49.000000', 'temperatura', 603.0000, 'ºC'),
	(337707, 143, '2015-02-01 01:01:50.000000', 'temperatura', 557.0000, 'ºC'),
	(337708, 143, '2015-02-01 01:01:51.000000', 'temperatura', 977.0000, 'ºC'),
	(337709, 143, '2015-02-01 01:01:52.000000', 'temperatura', 815.0000, 'ºC'),
	(337710, 143, '2015-02-01 01:01:53.000000', 'temperatura', 1146.0000, 'ºC'),
	(337711, 143, '2015-02-01 01:01:54.000000', 'temperatura', 885.0000, 'ºC'),
	(337712, 143, '2015-02-01 01:01:55.000000', 'temperatura', 986.0000, 'ºC'),
	(337713, 143, '2015-02-01 01:01:56.000000', 'temperatura', 1077.0000, 'ºC'),
	(337714, 143, '2015-02-01 01:01:57.000000', 'temperatura', 26.0000, 'ºC'),
	(337715, 143, '2015-02-01 01:01:58.000000', 'temperatura', 502.0000, 'ºC'),
	(337716, 143, '2015-02-01 01:01:59.000000', 'temperatura', 31.0000, 'ºC'),
	(337717, 143, '2015-02-01 01:02:00.000000', 'temperatura', 1052.0000, 'ºC'),
	(337718, 143, '2015-02-01 01:02:01.000000', 'temperatura', 365.0000, 'ºC'),
	(337719, 143, '2015-02-01 01:02:02.000000', 'temperatura', 1068.0000, 'ºC'),
	(337720, 143, '2015-02-01 01:02:03.000000', 'temperatura', 649.0000, 'ºC'),
	(337721, 143, '2015-02-01 01:02:04.000000', 'temperatura', 39.0000, 'ºC'),
	(337722, 143, '2015-02-01 01:02:05.000000', 'temperatura', 647.0000, 'ºC'),
	(337723, 143, '2015-02-01 01:02:06.000000', 'temperatura', 722.0000, 'ºC'),
	(337724, 143, '2015-02-01 01:02:07.000000', 'temperatura', 467.0000, 'ºC'),
	(337725, 143, '2015-02-01 01:02:08.000000', 'temperatura', 169.0000, 'ºC'),
	(337726, 143, '2015-02-01 01:02:09.000000', 'temperatura', 644.0000, 'ºC'),
	(337727, 143, '2015-02-01 01:02:10.000000', 'temperatura', 316.0000, 'ºC'),
	(337728, 143, '2015-02-01 01:02:11.000000', 'temperatura', 847.0000, 'ºC'),
	(337729, 143, '2015-02-01 01:02:12.000000', 'temperatura', 888.0000, 'ºC'),
	(337730, 143, '2015-02-01 01:02:13.000000', 'temperatura', 698.0000, 'ºC'),
	(337731, 143, '2015-02-01 01:02:14.000000', 'temperatura', 828.0000, 'ºC'),
	(337732, 143, '2015-02-01 01:02:15.000000', 'temperatura', 845.0000, 'ºC'),
	(337733, 143, '2015-02-01 01:02:16.000000', 'temperatura', 542.0000, 'ºC'),
	(337734, 143, '2015-02-01 01:02:17.000000', 'temperatura', 177.0000, 'ºC'),
	(337735, 143, '2015-02-01 01:02:18.000000', 'temperatura', 459.0000, 'ºC'),
	(337736, 143, '2015-02-01 01:02:19.000000', 'temperatura', 565.0000, 'ºC'),
	(337737, 143, '2015-02-01 01:02:20.000000', 'temperatura', 249.0000, 'ºC'),
	(337738, 143, '2015-02-01 01:02:21.000000', 'temperatura', 749.0000, 'ºC'),
	(337739, 143, '2015-02-01 01:02:22.000000', 'temperatura', 601.0000, 'ºC'),
	(337740, 143, '2015-02-01 01:02:23.000000', 'temperatura', 755.0000, 'ºC'),
	(337741, 143, '2015-02-01 01:02:24.000000', 'temperatura', 775.0000, 'ºC'),
	(337742, 143, '2015-02-01 01:02:25.000000', 'temperatura', 411.0000, 'ºC'),
	(337743, 143, '2015-02-01 01:02:26.000000', 'temperatura', 931.0000, 'ºC'),
	(337744, 143, '2015-02-01 01:02:27.000000', 'temperatura', 1022.0000, 'ºC'),
	(337745, 143, '2015-02-01 01:02:28.000000', 'temperatura', 1118.0000, 'ºC'),
	(337746, 143, '2015-02-01 01:02:29.000000', 'temperatura', 125.0000, 'ºC'),
	(337747, 143, '2015-02-01 01:02:30.000000', 'temperatura', 871.0000, 'ºC'),
	(337748, 143, '2015-02-01 01:02:31.000000', 'temperatura', 379.0000, 'ºC'),
	(337749, 143, '2015-02-01 01:02:32.000000', 'temperatura', 485.0000, 'ºC'),
	(337750, 143, '2015-02-01 01:02:33.000000', 'temperatura', 88.0000, 'ºC'),
	(337751, 143, '2015-02-01 01:02:34.000000', 'temperatura', 184.0000, 'ºC'),
	(337752, 143, '2015-02-01 01:02:35.000000', 'temperatura', 659.0000, 'ºC'),
	(337753, 143, '2015-02-01 01:02:36.000000', 'temperatura', 341.0000, 'ºC'),
	(337754, 143, '2015-02-01 01:02:37.000000', 'temperatura', 928.0000, 'ºC'),
	(337755, 143, '2015-02-01 01:02:38.000000', 'temperatura', 17.0000, 'ºC'),
	(337756, 143, '2015-02-01 01:02:39.000000', 'temperatura', 903.0000, 'ºC'),
	(337757, 143, '2015-02-01 01:02:40.000000', 'temperatura', 865.0000, 'ºC'),
	(337758, 143, '2015-02-01 01:02:41.000000', 'temperatura', 418.0000, 'ºC'),
	(337759, 143, '2015-02-01 01:02:42.000000', 'temperatura', 692.0000, 'ºC'),
	(337760, 143, '2015-02-01 01:02:43.000000', 'temperatura', 1008.0000, 'ºC'),
	(337761, 143, '2015-02-01 01:02:44.000000', 'temperatura', 565.0000, 'ºC'),
	(337762, 143, '2015-02-01 01:02:45.000000', 'temperatura', 1001.0000, 'ºC'),
	(337763, 143, '2015-02-01 01:02:46.000000', 'temperatura', 912.0000, 'ºC'),
	(337764, 143, '2015-02-01 01:02:47.000000', 'temperatura', 358.0000, 'ºC'),
	(337765, 143, '2015-02-01 01:02:48.000000', 'temperatura', 254.0000, 'ºC'),
	(337766, 143, '2015-02-01 01:02:49.000000', 'temperatura', 196.0000, 'ºC'),
	(337767, 143, '2015-02-01 01:02:50.000000', 'temperatura', 219.0000, 'ºC'),
	(337768, 143, '2015-02-01 01:02:51.000000', 'temperatura', 509.0000, 'ºC'),
	(337769, 143, '2015-02-01 01:02:52.000000', 'temperatura', 689.0000, 'ºC'),
	(337770, 143, '2015-02-01 01:02:53.000000', 'temperatura', 716.0000, 'ºC'),
	(337771, 143, '2015-02-01 01:02:54.000000', 'temperatura', 316.0000, 'ºC'),
	(337772, 143, '2015-02-01 01:02:55.000000', 'temperatura', 631.0000, 'ºC'),
	(337773, 143, '2015-02-01 01:02:56.000000', 'temperatura', 1010.0000, 'ºC'),
	(337774, 143, '2015-02-01 01:02:57.000000', 'temperatura', 755.0000, 'ºC'),
	(337775, 143, '2015-02-01 01:02:58.000000', 'temperatura', 747.0000, 'ºC'),
	(337776, 143, '2015-02-01 01:02:59.000000', 'temperatura', 271.0000, 'ºC'),
	(337777, 143, '2015-02-01 01:03:00.000000', 'temperatura', 313.0000, 'ºC'),
	(337778, 143, '2015-02-01 01:03:01.000000', 'temperatura', 751.0000, 'ºC'),
	(337779, 143, '2015-02-01 01:03:02.000000', 'temperatura', 420.0000, 'ºC'),
	(337780, 143, '2015-02-01 01:03:03.000000', 'temperatura', 1045.0000, 'ºC'),
	(337781, 143, '2015-02-01 01:03:04.000000', 'temperatura', 365.0000, 'ºC'),
	(337782, 143, '2015-02-01 01:03:05.000000', 'temperatura', 1093.0000, 'ºC'),
	(337783, 143, '2015-02-01 01:03:06.000000', 'temperatura', 770.0000, 'ºC'),
	(337784, 143, '2015-02-01 01:03:07.000000', 'temperatura', 571.0000, 'ºC'),
	(337785, 143, '2015-02-01 01:03:08.000000', 'temperatura', 547.0000, 'ºC'),
	(337786, 143, '2015-02-01 01:03:09.000000', 'temperatura', 1022.0000, 'ºC'),
	(337787, 143, '2015-02-01 01:03:10.000000', 'temperatura', 1068.0000, 'ºC'),
	(337788, 143, '2015-02-01 01:03:11.000000', 'temperatura', 1075.0000, 'ºC'),
	(337789, 143, '2015-02-01 01:03:12.000000', 'temperatura', 972.0000, 'ºC'),
	(337790, 143, '2015-02-01 01:03:13.000000', 'temperatura', 436.0000, 'ºC'),
	(337791, 143, '2015-02-01 01:03:14.000000', 'temperatura', 464.0000, 'ºC'),
	(337792, 143, '2015-02-01 01:03:15.000000', 'temperatura', 1012.0000, 'ºC'),
	(337793, 143, '2015-02-01 01:03:16.000000', 'temperatura', 70.0000, 'ºC'),
	(337794, 143, '2015-02-01 01:03:17.000000', 'temperatura', 912.0000, 'ºC'),
	(337795, 143, '2015-02-01 01:03:18.000000', 'temperatura', 751.0000, 'ºC'),
	(337796, 143, '2015-02-01 01:03:19.000000', 'temperatura', 1021.0000, 'ºC'),
	(337797, 143, '2015-02-01 01:03:20.000000', 'temperatura', 450.0000, 'ºC'),
	(337798, 143, '2015-02-01 01:03:21.000000', 'temperatura', 391.0000, 'ºC'),
	(337799, 143, '2015-02-01 01:03:22.000000', 'temperatura', 603.0000, 'ºC'),
	(337800, 143, '2015-02-01 01:03:23.000000', 'temperatura', 645.0000, 'ºC'),
	(337801, 143, '2015-02-01 01:03:24.000000', 'temperatura', 215.0000, 'ºC'),
	(337802, 143, '2015-02-01 01:03:25.000000', 'temperatura', 343.0000, 'ºC'),
	(337803, 143, '2015-02-01 01:03:26.000000', 'temperatura', 1067.0000, 'ºC'),
	(337804, 143, '2015-02-01 01:03:27.000000', 'temperatura', 707.0000, 'ºC'),
	(337805, 143, '2015-02-01 01:03:28.000000', 'temperatura', 335.0000, 'ºC'),
	(337806, 143, '2015-02-01 01:03:29.000000', 'temperatura', 754.0000, 'ºC'),
	(337807, 143, '2015-02-01 01:03:30.000000', 'temperatura', 366.0000, 'ºC'),
	(337808, 143, '2015-02-01 01:03:31.000000', 'temperatura', 771.0000, 'ºC'),
	(337809, 143, '2015-02-01 01:03:32.000000', 'temperatura', 354.0000, 'ºC'),
	(337810, 143, '2015-02-01 01:03:33.000000', 'temperatura', 657.0000, 'ºC'),
	(337811, 143, '2015-02-01 01:03:34.000000', 'temperatura', 1026.0000, 'ºC'),
	(337812, 143, '2015-02-01 01:03:35.000000', 'temperatura', 760.0000, 'ºC'),
	(337813, 143, '2015-02-01 01:03:36.000000', 'temperatura', 722.0000, 'ºC'),
	(337814, 143, '2015-02-01 01:03:37.000000', 'temperatura', 131.0000, 'ºC'),
	(337815, 143, '2015-02-01 01:03:38.000000', 'temperatura', 891.0000, 'ºC'),
	(337816, 143, '2015-02-01 01:03:39.000000', 'temperatura', 460.0000, 'ºC'),
	(337817, 143, '2015-02-01 01:03:40.000000', 'temperatura', 830.0000, 'ºC'),
	(337818, 143, '2015-02-01 01:03:41.000000', 'temperatura', 368.0000, 'ºC'),
	(337819, 143, '2015-02-01 01:03:42.000000', 'temperatura', 553.0000, 'ºC'),
	(337820, 143, '2015-02-01 01:03:43.000000', 'temperatura', 461.0000, 'ºC'),
	(337821, 143, '2015-02-01 01:03:44.000000', 'temperatura', 647.0000, 'ºC'),
	(337822, 143, '2015-02-01 01:03:45.000000', 'temperatura', 652.0000, 'ºC'),
	(337823, 143, '2015-02-01 01:03:46.000000', 'temperatura', 117.0000, 'ºC'),
	(337824, 143, '2015-02-01 01:03:47.000000', 'temperatura', 1032.0000, 'ºC'),
	(337825, 143, '2015-02-01 01:03:48.000000', 'temperatura', 11.0000, 'ºC'),
	(337826, 143, '2015-02-01 01:03:49.000000', 'temperatura', 558.0000, 'ºC'),
	(337827, 143, '2015-02-01 01:03:50.000000', 'temperatura', 356.0000, 'ºC'),
	(337828, 143, '2015-02-01 01:03:51.000000', 'temperatura', 108.0000, 'ºC'),
	(337829, 143, '2015-02-01 01:03:52.000000', 'temperatura', 674.0000, 'ºC'),
	(337830, 143, '2015-02-01 01:03:53.000000', 'temperatura', 644.0000, 'ºC'),
	(337831, 143, '2015-02-01 01:03:54.000000', 'temperatura', 1199.0000, 'ºC'),
	(337832, 143, '2015-02-01 01:03:55.000000', 'temperatura', 462.0000, 'ºC'),
	(337833, 143, '2015-02-01 01:03:56.000000', 'temperatura', 1115.0000, 'ºC'),
	(337834, 143, '2015-02-01 01:03:57.000000', 'temperatura', 591.0000, 'ºC'),
	(337835, 143, '2015-02-01 01:03:58.000000', 'temperatura', 811.0000, 'ºC'),
	(337836, 143, '2015-02-01 01:03:59.000000', 'temperatura', 1082.0000, 'ºC'),
	(337837, 143, '2015-02-01 01:04:00.000000', 'temperatura', 575.0000, 'ºC'),
	(337838, 143, '2015-02-01 01:04:01.000000', 'temperatura', 831.0000, 'ºC'),
	(337839, 143, '2015-02-01 01:04:02.000000', 'temperatura', 31.0000, 'ºC'),
	(337840, 143, '2015-02-01 01:04:03.000000', 'temperatura', 64.0000, 'ºC'),
	(337841, 143, '2015-02-01 01:04:04.000000', 'temperatura', 226.0000, 'ºC'),
	(337842, 143, '2015-02-01 01:04:05.000000', 'temperatura', 937.0000, 'ºC'),
	(337843, 143, '2015-02-01 01:04:06.000000', 'temperatura', 409.0000, 'ºC'),
	(337844, 143, '2015-02-01 01:04:07.000000', 'temperatura', 436.0000, 'ºC'),
	(337845, 143, '2015-02-01 01:04:08.000000', 'temperatura', 953.0000, 'ºC'),
	(337846, 143, '2015-02-01 01:04:09.000000', 'temperatura', 1057.0000, 'ºC'),
	(337847, 143, '2015-02-01 01:04:10.000000', 'temperatura', 24.0000, 'ºC'),
	(337848, 143, '2015-02-01 01:04:11.000000', 'temperatura', 553.0000, 'ºC'),
	(337849, 143, '2015-02-01 01:04:12.000000', 'temperatura', 292.0000, 'ºC'),
	(337850, 143, '2015-02-01 01:04:13.000000', 'temperatura', 1002.0000, 'ºC'),
	(337851, 143, '2015-02-01 01:04:14.000000', 'temperatura', 536.0000, 'ºC'),
	(337852, 143, '2015-02-01 01:04:15.000000', 'temperatura', 872.0000, 'ºC'),
	(337853, 143, '2015-02-01 01:04:16.000000', 'temperatura', 355.0000, 'ºC'),
	(337854, 143, '2015-02-01 01:04:17.000000', 'temperatura', 359.0000, 'ºC'),
	(337855, 143, '2015-02-01 01:04:18.000000', 'temperatura', 731.0000, 'ºC'),
	(337856, 143, '2015-02-01 01:04:19.000000', 'temperatura', 176.0000, 'ºC'),
	(337857, 143, '2015-02-01 01:04:20.000000', 'temperatura', 1088.0000, 'ºC'),
	(337858, 143, '2015-02-01 01:04:21.000000', 'temperatura', 114.0000, 'ºC'),
	(337859, 143, '2015-02-01 01:04:22.000000', 'temperatura', 906.0000, 'ºC'),
	(337860, 143, '2015-02-01 01:04:23.000000', 'temperatura', 590.0000, 'ºC'),
	(337861, 143, '2015-02-01 01:04:24.000000', 'temperatura', 232.0000, 'ºC'),
	(337862, 143, '2015-02-01 01:04:25.000000', 'temperatura', 592.0000, 'ºC'),
	(337863, 143, '2015-02-01 01:04:26.000000', 'temperatura', 1062.0000, 'ºC'),
	(337864, 143, '2015-02-01 01:04:27.000000', 'temperatura', 1135.0000, 'ºC'),
	(337865, 143, '2015-02-01 01:04:28.000000', 'temperatura', 88.0000, 'ºC'),
	(337866, 143, '2015-02-01 01:04:29.000000', 'temperatura', 638.0000, 'ºC'),
	(337867, 143, '2015-02-01 01:04:30.000000', 'temperatura', 524.0000, 'ºC'),
	(337868, 143, '2015-02-01 01:04:31.000000', 'temperatura', 709.0000, 'ºC'),
	(337869, 143, '2015-02-01 01:04:32.000000', 'temperatura', 773.0000, 'ºC'),
	(337870, 143, '2015-02-01 01:04:33.000000', 'temperatura', 537.0000, 'ºC'),
	(337871, 143, '2015-02-01 01:04:34.000000', 'temperatura', 367.0000, 'ºC'),
	(337872, 143, '2015-02-01 01:04:35.000000', 'temperatura', 223.0000, 'ºC'),
	(337873, 143, '2015-02-01 01:04:36.000000', 'temperatura', 18.0000, 'ºC'),
	(337874, 143, '2015-02-01 01:04:37.000000', 'temperatura', 619.0000, 'ºC'),
	(337875, 143, '2015-02-01 01:04:38.000000', 'temperatura', 640.0000, 'ºC'),
	(337876, 143, '2015-02-01 01:04:39.000000', 'temperatura', 146.0000, 'ºC'),
	(337877, 143, '2015-02-01 01:04:40.000000', 'temperatura', 9.0000, 'ºC'),
	(337878, 143, '2015-02-01 01:04:41.000000', 'temperatura', 808.0000, 'ºC'),
	(337879, 143, '2015-02-01 01:04:42.000000', 'temperatura', 414.0000, 'ºC'),
	(337880, 143, '2015-02-01 01:04:43.000000', 'temperatura', 848.0000, 'ºC'),
	(337881, 143, '2015-02-01 01:04:44.000000', 'temperatura', 596.0000, 'ºC'),
	(337882, 143, '2015-02-01 01:04:45.000000', 'temperatura', 438.0000, 'ºC'),
	(337883, 143, '2015-02-01 01:04:46.000000', 'temperatura', 403.0000, 'ºC'),
	(337884, 143, '2015-02-01 01:04:47.000000', 'temperatura', 700.0000, 'ºC'),
	(337885, 143, '2015-02-01 01:04:48.000000', 'temperatura', 1092.0000, 'ºC'),
	(337886, 143, '2015-02-01 01:04:49.000000', 'temperatura', 961.0000, 'ºC'),
	(337887, 143, '2015-02-01 01:04:50.000000', 'temperatura', 328.0000, 'ºC'),
	(337888, 143, '2015-02-01 01:04:51.000000', 'temperatura', 1158.0000, 'ºC'),
	(337889, 143, '2015-02-01 01:04:52.000000', 'temperatura', 5.0000, 'ºC'),
	(337890, 143, '2015-02-01 01:04:53.000000', 'temperatura', 153.0000, 'ºC'),
	(337891, 143, '2015-02-01 01:04:54.000000', 'temperatura', 749.0000, 'ºC'),
	(337892, 143, '2015-02-01 01:04:55.000000', 'temperatura', 886.0000, 'ºC'),
	(337893, 143, '2015-02-01 01:04:56.000000', 'temperatura', 983.0000, 'ºC'),
	(337894, 143, '2015-02-01 01:04:57.000000', 'temperatura', 1057.0000, 'ºC'),
	(337895, 143, '2015-02-01 01:04:58.000000', 'temperatura', 1139.0000, 'ºC'),
	(337896, 143, '2015-02-01 01:04:59.000000', 'temperatura', 122.0000, 'ºC'),
	(337897, 143, '2015-02-01 01:05:00.000000', 'temperatura', 795.0000, 'ºC'),
	(337898, 143, '2015-02-01 01:05:01.000000', 'temperatura', 9.0000, 'ºC'),
	(337899, 143, '2015-02-01 01:05:02.000000', 'temperatura', 60.0000, 'ºC'),
	(337900, 143, '2015-02-01 01:05:03.000000', 'temperatura', 275.0000, 'ºC'),
	(337901, 143, '2015-02-01 01:05:04.000000', 'temperatura', 1194.0000, 'ºC'),
	(337902, 143, '2015-02-01 01:05:05.000000', 'temperatura', 348.0000, 'ºC'),
	(337903, 143, '2015-02-01 01:05:06.000000', 'temperatura', 557.0000, 'ºC'),
	(337904, 143, '2015-02-01 01:05:07.000000', 'temperatura', 543.0000, 'ºC'),
	(337905, 143, '2015-02-01 01:05:08.000000', 'temperatura', 1045.0000, 'ºC'),
	(337906, 143, '2015-02-01 01:05:09.000000', 'temperatura', 1194.0000, 'ºC'),
	(337907, 143, '2015-02-01 01:05:10.000000', 'temperatura', 438.0000, 'ºC'),
	(337908, 143, '2015-02-01 01:05:11.000000', 'temperatura', 1009.0000, 'ºC'),
	(337909, 143, '2015-02-01 01:05:12.000000', 'temperatura', 130.0000, 'ºC'),
	(337910, 143, '2015-02-01 01:05:13.000000', 'temperatura', 23.0000, 'ºC'),
	(337911, 143, '2015-02-01 01:05:14.000000', 'temperatura', 926.0000, 'ºC'),
	(337912, 143, '2015-02-01 01:05:15.000000', 'temperatura', 960.0000, 'ºC'),
	(337913, 143, '2015-02-01 01:05:16.000000', 'temperatura', 824.0000, 'ºC'),
	(337914, 143, '2015-02-01 01:05:17.000000', 'temperatura', 39.0000, 'ºC'),
	(337915, 143, '2015-02-01 01:05:18.000000', 'temperatura', 123.0000, 'ºC'),
	(337916, 143, '2015-02-01 01:05:19.000000', 'temperatura', 501.0000, 'ºC'),
	(337917, 143, '2015-02-01 01:05:20.000000', 'temperatura', 936.0000, 'ºC'),
	(337918, 143, '2015-02-01 01:05:21.000000', 'temperatura', 777.0000, 'ºC'),
	(337919, 143, '2015-02-01 01:05:22.000000', 'temperatura', 1079.0000, 'ºC'),
	(337920, 143, '2015-02-01 01:05:23.000000', 'temperatura', 662.0000, 'ºC'),
	(337921, 143, '2015-02-01 01:05:24.000000', 'temperatura', 76.0000, 'ºC'),
	(337922, 143, '2015-02-01 01:05:25.000000', 'temperatura', 795.0000, 'ºC'),
	(337923, 143, '2015-02-01 01:05:26.000000', 'temperatura', 146.0000, 'ºC'),
	(337924, 143, '2015-02-01 01:05:27.000000', 'temperatura', 747.0000, 'ºC'),
	(337925, 143, '2015-02-01 01:05:28.000000', 'temperatura', 897.0000, 'ºC'),
	(337926, 143, '2015-02-01 01:05:29.000000', 'temperatura', 1043.0000, 'ºC'),
	(337927, 143, '2015-02-01 01:05:30.000000', 'temperatura', 124.0000, 'ºC'),
	(337928, 143, '2015-02-01 01:05:31.000000', 'temperatura', 1092.0000, 'ºC'),
	(337929, 143, '2015-02-01 01:05:32.000000', 'temperatura', 290.0000, 'ºC'),
	(337930, 143, '2015-02-01 01:05:33.000000', 'temperatura', 573.0000, 'ºC'),
	(337931, 143, '2015-02-01 01:05:34.000000', 'temperatura', 797.0000, 'ºC'),
	(337932, 143, '2015-02-01 01:05:35.000000', 'temperatura', 1068.0000, 'ºC'),
	(337933, 143, '2015-02-01 01:05:36.000000', 'temperatura', 546.0000, 'ºC'),
	(337934, 143, '2015-02-01 01:05:37.000000', 'temperatura', 728.0000, 'ºC'),
	(337935, 143, '2015-02-01 01:05:38.000000', 'temperatura', 802.0000, 'ºC'),
	(337936, 143, '2015-02-01 01:05:39.000000', 'temperatura', 629.0000, 'ºC'),
	(337937, 143, '2015-02-01 01:05:40.000000', 'temperatura', 736.0000, 'ºC'),
	(337938, 143, '2015-02-01 01:05:41.000000', 'temperatura', 596.0000, 'ºC'),
	(337939, 143, '2015-02-01 01:05:42.000000', 'temperatura', 772.0000, 'ºC'),
	(337940, 143, '2015-02-01 01:05:43.000000', 'temperatura', 872.0000, 'ºC'),
	(337941, 143, '2015-02-01 01:05:44.000000', 'temperatura', 847.0000, 'ºC'),
	(337942, 143, '2015-02-01 01:05:45.000000', 'temperatura', 416.0000, 'ºC'),
	(337943, 143, '2015-02-01 01:05:46.000000', 'temperatura', 743.0000, 'ºC'),
	(337944, 143, '2015-02-01 01:05:47.000000', 'temperatura', 64.0000, 'ºC'),
	(337945, 143, '2015-02-01 01:05:48.000000', 'temperatura', 493.0000, 'ºC'),
	(337946, 143, '2015-02-01 01:05:49.000000', 'temperatura', 1073.0000, 'ºC'),
	(337947, 143, '2015-02-01 01:05:50.000000', 'temperatura', 288.0000, 'ºC'),
	(337948, 143, '2015-02-01 01:05:51.000000', 'temperatura', 620.0000, 'ºC'),
	(337949, 143, '2015-02-01 01:05:52.000000', 'temperatura', 1038.0000, 'ºC'),
	(337950, 143, '2015-02-01 01:05:53.000000', 'temperatura', 932.0000, 'ºC'),
	(337951, 143, '2015-02-01 01:05:54.000000', 'temperatura', 344.0000, 'ºC'),
	(337952, 143, '2015-02-01 01:05:55.000000', 'temperatura', 127.0000, 'ºC'),
	(337953, 143, '2015-02-01 01:05:56.000000', 'temperatura', 801.0000, 'ºC'),
	(337954, 143, '2015-02-01 01:05:57.000000', 'temperatura', 24.0000, 'ºC'),
	(337955, 143, '2015-02-01 01:05:58.000000', 'temperatura', 118.0000, 'ºC'),
	(337956, 143, '2015-02-01 01:05:59.000000', 'temperatura', 520.0000, 'ºC'),
	(337957, 143, '2015-02-01 01:06:00.000000', 'temperatura', 1046.0000, 'ºC'),
	(337958, 143, '2015-02-01 01:06:01.000000', 'temperatura', 69.0000, 'ºC'),
	(337959, 143, '2015-02-01 01:06:02.000000', 'temperatura', 806.0000, 'ºC'),
	(337960, 143, '2015-02-01 01:06:03.000000', 'temperatura', 227.0000, 'ºC'),
	(337961, 143, '2015-02-01 01:06:04.000000', 'temperatura', 1117.0000, 'ºC'),
	(337962, 143, '2015-02-01 01:06:05.000000', 'temperatura', 102.0000, 'ºC'),
	(337963, 143, '2015-02-01 01:06:06.000000', 'temperatura', 762.0000, 'ºC'),
	(337964, 143, '2015-02-01 01:06:07.000000', 'temperatura', 1105.0000, 'ºC'),
	(337965, 143, '2015-02-01 01:06:08.000000', 'temperatura', 840.0000, 'ºC'),
	(337966, 143, '2015-02-01 01:06:09.000000', 'temperatura', 886.0000, 'ºC'),
	(337967, 143, '2015-02-01 01:06:10.000000', 'temperatura', 710.0000, 'ºC'),
	(337968, 143, '2015-02-01 01:06:11.000000', 'temperatura', 893.0000, 'ºC'),
	(337969, 143, '2015-02-01 01:06:12.000000', 'temperatura', 1135.0000, 'ºC'),
	(337970, 143, '2015-02-01 01:06:13.000000', 'temperatura', 595.0000, 'ºC'),
	(337971, 143, '2015-02-01 01:06:14.000000', 'temperatura', 774.0000, 'ºC'),
	(337972, 143, '2015-02-01 01:06:15.000000', 'temperatura', 882.0000, 'ºC'),
	(337973, 143, '2015-02-01 01:06:16.000000', 'temperatura', 890.0000, 'ºC'),
	(337974, 143, '2015-02-01 01:06:17.000000', 'temperatura', 605.0000, 'ºC'),
	(337975, 143, '2015-02-01 01:06:18.000000', 'temperatura', 353.0000, 'ºC'),
	(337976, 143, '2015-02-01 01:06:19.000000', 'temperatura', 1153.0000, 'ºC'),
	(337977, 143, '2015-02-01 01:06:20.000000', 'temperatura', 1105.0000, 'ºC'),
	(337978, 143, '2015-02-01 01:06:21.000000', 'temperatura', 869.0000, 'ºC'),
	(337979, 143, '2015-02-01 01:06:22.000000', 'temperatura', 1029.0000, 'ºC'),
	(337980, 143, '2015-02-01 01:06:23.000000', 'temperatura', 140.0000, 'ºC'),
	(337981, 143, '2015-02-01 01:06:24.000000', 'temperatura', 12.0000, 'ºC'),
	(337982, 143, '2015-02-01 01:06:25.000000', 'temperatura', 841.0000, 'ºC'),
	(337983, 143, '2015-02-01 01:06:26.000000', 'temperatura', 570.0000, 'ºC'),
	(337984, 143, '2015-02-01 01:06:27.000000', 'temperatura', 325.0000, 'ºC'),
	(337985, 143, '2015-02-01 01:06:28.000000', 'temperatura', 1117.0000, 'ºC'),
	(337986, 143, '2015-02-01 01:06:29.000000', 'temperatura', 1011.0000, 'ºC'),
	(337987, 143, '2015-02-01 01:06:30.000000', 'temperatura', 504.0000, 'ºC'),
	(337988, 143, '2015-02-01 01:06:31.000000', 'temperatura', 686.0000, 'ºC'),
	(337989, 143, '2015-02-01 01:06:32.000000', 'temperatura', 719.0000, 'ºC'),
	(337990, 143, '2015-02-01 01:06:33.000000', 'temperatura', 336.0000, 'ºC'),
	(337991, 143, '2015-02-01 01:06:34.000000', 'temperatura', 725.0000, 'ºC'),
	(337992, 143, '2015-02-01 01:06:35.000000', 'temperatura', 218.0000, 'ºC'),
	(337993, 143, '2015-02-01 01:06:36.000000', 'temperatura', 115.0000, 'ºC'),
	(337994, 143, '2015-02-01 01:06:37.000000', 'temperatura', 1122.0000, 'ºC'),
	(337995, 143, '2015-02-01 01:06:38.000000', 'temperatura', 465.0000, 'ºC'),
	(337996, 143, '2015-02-01 01:06:39.000000', 'temperatura', 158.0000, 'ºC'),
	(337997, 143, '2015-02-01 01:06:40.000000', 'temperatura', 595.0000, 'ºC'),
	(337998, 143, '2015-02-01 01:06:41.000000', 'temperatura', 104.0000, 'ºC'),
	(337999, 143, '2015-02-01 01:06:42.000000', 'temperatura', 1137.0000, 'ºC'),
	(338000, 143, '2015-02-01 01:06:43.000000', 'temperatura', 570.0000, 'ºC'),
	(338001, 143, '2015-02-01 01:06:44.000000', 'temperatura', 641.0000, 'ºC'),
	(338002, 143, '2015-02-01 01:06:45.000000', 'temperatura', 295.0000, 'ºC'),
	(338003, 143, '2015-02-01 01:06:46.000000', 'temperatura', 751.0000, 'ºC'),
	(338004, 143, '2015-02-01 01:06:47.000000', 'temperatura', 472.0000, 'ºC'),
	(338005, 143, '2015-02-01 01:06:48.000000', 'temperatura', 109.0000, 'ºC'),
	(338006, 143, '2015-02-01 01:06:49.000000', 'temperatura', 328.0000, 'ºC'),
	(338007, 143, '2015-02-01 01:06:50.000000', 'temperatura', 114.0000, 'ºC'),
	(338008, 143, '2015-02-01 01:06:51.000000', 'temperatura', 784.0000, 'ºC'),
	(338009, 143, '2015-02-01 01:06:52.000000', 'temperatura', 1182.0000, 'ºC'),
	(338010, 143, '2015-02-01 01:06:53.000000', 'temperatura', 1155.0000, 'ºC'),
	(338011, 143, '2015-02-01 01:06:54.000000', 'temperatura', 1031.0000, 'ºC'),
	(338012, 143, '2015-02-01 01:06:55.000000', 'temperatura', 492.0000, 'ºC'),
	(338013, 143, '2015-02-01 01:06:56.000000', 'temperatura', 566.0000, 'ºC'),
	(338014, 143, '2015-02-01 01:06:57.000000', 'temperatura', 156.0000, 'ºC'),
	(338015, 143, '2015-02-01 01:06:58.000000', 'temperatura', 282.0000, 'ºC'),
	(338016, 143, '2015-02-01 01:06:59.000000', 'temperatura', 941.0000, 'ºC'),
	(338017, 143, '2015-02-01 01:07:00.000000', 'temperatura', 259.0000, 'ºC'),
	(338018, 143, '2015-02-01 01:07:01.000000', 'temperatura', 874.0000, 'ºC'),
	(338019, 143, '2015-02-01 01:07:02.000000', 'temperatura', 1192.0000, 'ºC'),
	(338020, 143, '2015-02-01 01:07:03.000000', 'temperatura', 937.0000, 'ºC'),
	(338021, 143, '2015-02-01 01:07:04.000000', 'temperatura', 1113.0000, 'ºC'),
	(338022, 143, '2015-02-01 01:07:05.000000', 'temperatura', 352.0000, 'ºC'),
	(338023, 143, '2015-02-01 01:07:06.000000', 'temperatura', 821.0000, 'ºC'),
	(338024, 143, '2015-02-01 01:07:07.000000', 'temperatura', 652.0000, 'ºC'),
	(338025, 143, '2015-02-01 01:07:08.000000', 'temperatura', 798.0000, 'ºC'),
	(338026, 143, '2015-02-01 01:07:09.000000', 'temperatura', 833.0000, 'ºC'),
	(338027, 143, '2015-02-01 01:07:10.000000', 'temperatura', 570.0000, 'ºC'),
	(338028, 143, '2015-02-01 01:07:11.000000', 'temperatura', 352.0000, 'ºC'),
	(338029, 143, '2015-02-01 01:07:12.000000', 'temperatura', 50.0000, 'ºC'),
	(338030, 143, '2015-02-01 01:07:13.000000', 'temperatura', 395.0000, 'ºC'),
	(338031, 143, '2015-02-01 01:07:14.000000', 'temperatura', 626.0000, 'ºC'),
	(338032, 143, '2015-02-01 01:07:15.000000', 'temperatura', 747.0000, 'ºC'),
	(338033, 143, '2015-02-01 01:07:16.000000', 'temperatura', 657.0000, 'ºC'),
	(338034, 143, '2015-02-01 01:07:17.000000', 'temperatura', 1046.0000, 'ºC'),
	(338035, 143, '2015-02-01 01:07:18.000000', 'temperatura', 857.0000, 'ºC'),
	(338036, 143, '2015-02-01 01:07:19.000000', 'temperatura', 1148.0000, 'ºC'),
	(338037, 143, '2015-02-01 01:07:20.000000', 'temperatura', 771.0000, 'ºC'),
	(338038, 143, '2015-02-01 01:07:21.000000', 'temperatura', 412.0000, 'ºC'),
	(338039, 143, '2015-02-01 01:07:22.000000', 'temperatura', 948.0000, 'ºC'),
	(338040, 143, '2015-02-01 01:07:23.000000', 'temperatura', 1101.0000, 'ºC'),
	(338041, 143, '2015-02-01 01:07:24.000000', 'temperatura', 265.0000, 'ºC'),
	(338042, 143, '2015-02-01 01:07:25.000000', 'temperatura', 421.0000, 'ºC'),
	(338043, 143, '2015-02-01 01:07:26.000000', 'temperatura', 112.0000, 'ºC'),
	(338044, 143, '2015-02-01 01:07:27.000000', 'temperatura', 498.0000, 'ºC'),
	(338045, 143, '2015-02-01 01:07:28.000000', 'temperatura', 954.0000, 'ºC'),
	(338046, 143, '2015-02-01 01:07:29.000000', 'temperatura', 877.0000, 'ºC'),
	(338047, 143, '2015-02-01 01:07:30.000000', 'temperatura', 324.0000, 'ºC'),
	(338048, 143, '2015-02-01 01:07:31.000000', 'temperatura', 191.0000, 'ºC'),
	(338049, 143, '2015-02-01 01:07:32.000000', 'temperatura', 1181.0000, 'ºC'),
	(338050, 143, '2015-02-01 01:07:33.000000', 'temperatura', 531.0000, 'ºC'),
	(338051, 143, '2015-02-01 01:07:34.000000', 'temperatura', 314.0000, 'ºC'),
	(338052, 143, '2015-02-01 01:07:35.000000', 'temperatura', 1179.0000, 'ºC'),
	(338053, 143, '2015-02-01 01:07:36.000000', 'temperatura', 152.0000, 'ºC'),
	(338054, 143, '2015-02-01 01:07:37.000000', 'temperatura', 825.0000, 'ºC'),
	(338055, 143, '2015-02-01 01:07:38.000000', 'temperatura', 69.0000, 'ºC'),
	(338056, 143, '2015-02-01 01:07:39.000000', 'temperatura', 271.0000, 'ºC'),
	(338057, 143, '2015-02-01 01:07:40.000000', 'temperatura', 1146.0000, 'ºC'),
	(338058, 143, '2015-02-01 01:07:41.000000', 'temperatura', 121.0000, 'ºC'),
	(338059, 143, '2015-02-01 01:07:42.000000', 'temperatura', 765.0000, 'ºC'),
	(338060, 143, '2015-02-01 01:07:43.000000', 'temperatura', 1064.0000, 'ºC'),
	(338061, 143, '2015-02-01 01:07:44.000000', 'temperatura', 625.0000, 'ºC'),
	(338062, 143, '2015-02-01 01:07:45.000000', 'temperatura', 1132.0000, 'ºC'),
	(338063, 143, '2015-02-01 01:07:46.000000', 'temperatura', 187.0000, 'ºC'),
	(338064, 143, '2015-02-01 01:07:47.000000', 'temperatura', 1141.0000, 'ºC'),
	(338065, 143, '2015-02-01 01:07:48.000000', 'temperatura', 341.0000, 'ºC'),
	(338066, 143, '2015-02-01 01:07:49.000000', 'temperatura', 685.0000, 'ºC'),
	(338067, 143, '2015-02-01 01:07:50.000000', 'temperatura', 4.0000, 'ºC'),
	(338068, 143, '2015-02-01 01:07:51.000000', 'temperatura', 363.0000, 'ºC'),
	(338069, 143, '2015-02-01 01:07:52.000000', 'temperatura', 604.0000, 'ºC'),
	(338070, 143, '2015-02-01 01:07:53.000000', 'temperatura', 732.0000, 'ºC'),
	(338071, 143, '2015-02-01 01:07:54.000000', 'temperatura', 648.0000, 'ºC'),
	(338072, 143, '2015-02-01 01:07:55.000000', 'temperatura', 1045.0000, 'ºC'),
	(338073, 143, '2015-02-01 01:07:56.000000', 'temperatura', 883.0000, 'ºC'),
	(338074, 143, '2015-02-01 01:07:57.000000', 'temperatura', 78.0000, 'ºC'),
	(338075, 143, '2015-02-01 01:07:58.000000', 'temperatura', 141.0000, 'ºC'),
	(338076, 143, '2015-02-01 01:07:59.000000', 'temperatura', 474.0000, 'ºC'),
	(338077, 143, '2015-02-01 01:08:00.000000', 'temperatura', 748.0000, 'ºC'),
	(338078, 143, '2015-02-01 01:08:01.000000', 'temperatura', 1117.0000, 'ºC'),
	(338079, 143, '2015-02-01 01:08:02.000000', 'temperatura', 942.0000, 'ºC'),
	(338080, 143, '2015-02-01 01:08:03.000000', 'temperatura', 159.0000, 'ºC'),
	(338081, 143, '2015-02-01 01:08:04.000000', 'temperatura', 369.0000, 'ºC'),
	(338082, 143, '2015-02-01 01:08:05.000000', 'temperatura', 170.0000, 'ºC'),
	(338083, 143, '2015-02-01 01:08:06.000000', 'temperatura', 944.0000, 'ºC'),
	(338084, 143, '2015-02-01 01:08:07.000000', 'temperatura', 612.0000, 'ºC'),
	(338085, 143, '2015-02-01 01:08:08.000000', 'temperatura', 225.0000, 'ºC'),
	(338086, 143, '2015-02-01 01:08:09.000000', 'temperatura', 490.0000, 'ºC'),
	(338087, 143, '2015-02-01 01:08:10.000000', 'temperatura', 576.0000, 'ºC'),
	(338088, 143, '2015-02-01 01:08:11.000000', 'temperatura', 210.0000, 'ºC'),
	(338089, 143, '2015-02-01 01:08:12.000000', 'temperatura', 524.0000, 'ºC'),
	(338090, 143, '2015-02-01 01:08:13.000000', 'temperatura', 789.0000, 'ºC'),
	(338091, 143, '2015-02-01 01:08:14.000000', 'temperatura', 1174.0000, 'ºC'),
	(338092, 143, '2015-02-01 01:08:15.000000', 'temperatura', 1104.0000, 'ºC'),
	(338093, 143, '2015-02-01 01:08:16.000000', 'temperatura', 799.0000, 'ºC'),
	(338094, 143, '2015-02-01 01:08:17.000000', 'temperatura', 682.0000, 'ºC'),
	(338095, 143, '2015-02-01 01:08:18.000000', 'temperatura', 1012.0000, 'ºC'),
	(338096, 143, '2015-02-01 01:08:19.000000', 'temperatura', 616.0000, 'ºC'),
	(338097, 143, '2015-02-01 01:08:20.000000', 'temperatura', 45.0000, 'ºC'),
	(338098, 143, '2015-02-01 01:08:21.000000', 'temperatura', 775.0000, 'ºC'),
	(338099, 143, '2015-02-01 01:08:22.000000', 'temperatura', 144.0000, 'ºC'),
	(338100, 143, '2015-02-01 01:08:23.000000', 'temperatura', 794.0000, 'ºC'),
	(338101, 143, '2015-02-01 01:08:24.000000', 'temperatura', 1140.0000, 'ºC'),
	(338102, 143, '2015-02-01 01:08:25.000000', 'temperatura', 916.0000, 'ºC'),
	(338103, 143, '2015-02-01 01:08:26.000000', 'temperatura', 1162.0000, 'ºC'),
	(338104, 143, '2015-02-01 01:08:27.000000', 'temperatura', 664.0000, 'ºC'),
	(338105, 143, '2015-02-01 01:08:28.000000', 'temperatura', 1032.0000, 'ºC'),
	(338106, 143, '2015-02-01 01:08:29.000000', 'temperatura', 771.0000, 'ºC'),
	(338107, 143, '2015-02-01 01:08:30.000000', 'temperatura', 758.0000, 'ºC'),
	(338108, 143, '2015-02-01 01:08:31.000000', 'temperatura', 277.0000, 'ºC'),
	(338109, 143, '2015-02-01 01:08:32.000000', 'temperatura', 311.0000, 'ºC'),
	(338110, 143, '2015-02-01 01:08:33.000000', 'temperatura', 725.0000, 'ºC'),
	(338111, 143, '2015-02-01 01:08:34.000000', 'temperatura', 292.0000, 'ºC'),
	(338112, 143, '2015-02-01 01:08:35.000000', 'temperatura', 486.0000, 'ºC'),
	(338113, 143, '2015-02-01 01:08:36.000000', 'temperatura', 355.0000, 'ºC'),
	(338114, 143, '2015-02-01 01:08:37.000000', 'temperatura', 318.0000, 'ºC'),
	(338115, 143, '2015-02-01 01:08:38.000000', 'temperatura', 523.0000, 'ºC'),
	(338116, 143, '2015-02-01 01:08:39.000000', 'temperatura', 463.0000, 'ºC'),
	(338117, 143, '2015-02-01 01:08:40.000000', 'temperatura', 744.0000, 'ºC'),
	(338118, 143, '2015-02-01 01:08:41.000000', 'temperatura', 1135.0000, 'ºC'),
	(338119, 143, '2015-02-01 01:08:42.000000', 'temperatura', 1042.0000, 'ºC'),
	(338120, 143, '2015-02-01 01:08:43.000000', 'temperatura', 605.0000, 'ºC'),
	(338121, 143, '2015-02-01 01:08:44.000000', 'temperatura', 1101.0000, 'ºC'),
	(338122, 143, '2015-02-01 01:08:45.000000', 'temperatura', 89.0000, 'ºC'),
	(338123, 143, '2015-02-01 01:08:46.000000', 'temperatura', 744.0000, 'ºC'),
	(338124, 143, '2015-02-01 01:08:47.000000', 'temperatura', 1052.0000, 'ºC'),
	(338125, 143, '2015-02-01 01:08:48.000000', 'temperatura', 628.0000, 'ºC'),
	(338126, 143, '2015-02-01 01:08:49.000000', 'temperatura', 1185.0000, 'ºC'),
	(338127, 143, '2015-02-01 01:08:50.000000', 'temperatura', 443.0000, 'ºC'),
	(338128, 143, '2015-02-01 01:08:51.000000', 'temperatura', 1058.0000, 'ºC'),
	(338129, 143, '2015-02-01 01:08:52.000000', 'temperatura', 361.0000, 'ºC'),
	(338130, 143, '2015-02-01 01:08:53.000000', 'temperatura', 1033.0000, 'ºC'),
	(338131, 143, '2015-02-01 01:08:54.000000', 'temperatura', 482.0000, 'ºC'),
	(338132, 143, '2015-02-01 01:08:55.000000', 'temperatura', 513.0000, 'ºC'),
	(338133, 143, '2015-02-01 01:08:56.000000', 'temperatura', 1118.0000, 'ºC'),
	(338134, 143, '2015-02-01 01:08:57.000000', 'temperatura', 451.0000, 'ºC'),
	(338135, 143, '2015-02-01 01:08:58.000000', 'temperatura', 104.0000, 'ºC'),
	(338136, 143, '2015-02-01 01:08:59.000000', 'temperatura', 365.0000, 'ºC'),
	(338137, 143, '2015-02-01 01:09:00.000000', 'temperatura', 316.0000, 'ºC'),
	(338138, 143, '2015-02-01 01:09:01.000000', 'temperatura', 485.0000, 'ºC'),
	(338139, 143, '2015-02-01 01:09:02.000000', 'temperatura', 278.0000, 'ºC'),
	(338140, 143, '2015-02-01 01:09:03.000000', 'temperatura', 1134.0000, 'ºC'),
	(338141, 143, '2015-02-01 01:09:04.000000', 'temperatura', 39.0000, 'ºC'),
	(338142, 143, '2015-02-01 01:09:05.000000', 'temperatura', 391.0000, 'ºC'),
	(338143, 143, '2015-02-01 01:09:06.000000', 'temperatura', 641.0000, 'ºC'),
	(338144, 143, '2015-02-01 01:09:07.000000', 'temperatura', 831.0000, 'ºC'),
	(338145, 143, '2015-02-01 01:09:08.000000', 'temperatura', 1031.0000, 'ºC'),
	(338146, 143, '2015-02-01 01:09:09.000000', 'temperatura', 265.0000, 'ºC'),
	(338147, 143, '2015-02-01 01:09:10.000000', 'temperatura', 631.0000, 'ºC'),
	(338148, 143, '2015-02-01 01:09:11.000000', 'temperatura', 1159.0000, 'ºC'),
	(338149, 143, '2015-02-01 01:09:12.000000', 'temperatura', 303.0000, 'ºC'),
	(338150, 143, '2015-02-01 01:09:13.000000', 'temperatura', 440.0000, 'ºC'),
	(338151, 143, '2015-02-01 01:09:14.000000', 'temperatura', 89.0000, 'ºC'),
	(338152, 143, '2015-02-01 01:09:15.000000', 'temperatura', 328.0000, 'ºC'),
	(338153, 143, '2015-02-01 01:09:16.000000', 'temperatura', 171.0000, 'ºC'),
	(338154, 143, '2015-02-01 01:09:17.000000', 'temperatura', 1072.0000, 'ºC'),
	(338155, 143, '2015-02-01 01:09:18.000000', 'temperatura', 48.0000, 'ºC'),
	(338156, 143, '2015-02-01 01:09:19.000000', 'temperatura', 623.0000, 'ºC'),
	(338157, 143, '2015-02-01 01:09:20.000000', 'temperatura', 572.0000, 'ºC'),
	(338158, 143, '2015-02-01 01:09:21.000000', 'temperatura', 994.0000, 'ºC'),
	(338159, 143, '2015-02-01 01:09:22.000000', 'temperatura', 852.0000, 'ºC'),
	(338160, 143, '2015-02-01 01:09:23.000000', 'temperatura', 78.0000, 'ºC'),
	(338161, 143, '2015-02-01 01:09:24.000000', 'temperatura', 236.0000, 'ºC'),
	(338162, 143, '2015-02-01 01:09:25.000000', 'temperatura', 945.0000, 'ºC'),
	(338163, 143, '2015-02-01 01:09:26.000000', 'temperatura', 419.0000, 'ºC'),
	(338164, 143, '2015-02-01 01:09:27.000000', 'temperatura', 460.0000, 'ºC'),
	(338165, 143, '2015-02-01 01:09:28.000000', 'temperatura', 1044.0000, 'ºC'),
	(338166, 143, '2015-02-01 01:09:29.000000', 'temperatura', 242.0000, 'ºC'),
	(338167, 143, '2015-02-01 01:09:30.000000', 'temperatura', 476.0000, 'ºC'),
	(338168, 143, '2015-02-01 01:09:31.000000', 'temperatura', 456.0000, 'ºC'),
	(338169, 143, '2015-02-01 01:09:32.000000', 'temperatura', 853.0000, 'ºC'),
	(338170, 143, '2015-02-01 01:09:33.000000', 'temperatura', 498.0000, 'ºC'),
	(338171, 143, '2015-02-01 01:09:34.000000', 'temperatura', 1129.0000, 'ºC'),
	(338172, 143, '2015-02-01 01:09:35.000000', 'temperatura', 552.0000, 'ºC'),
	(338173, 143, '2015-02-01 01:09:36.000000', 'temperatura', 573.0000, 'ºC'),
	(338174, 143, '2015-02-01 01:09:37.000000', 'temperatura', 10.0000, 'ºC'),
	(338175, 143, '2015-02-01 01:09:38.000000', 'temperatura', 733.0000, 'ºC'),
	(338176, 143, '2015-02-01 01:09:39.000000', 'temperatura', 36.0000, 'ºC'),
	(338177, 143, '2015-02-01 01:09:40.000000', 'temperatura', 382.0000, 'ºC'),
	(338178, 143, '2015-02-01 01:09:41.000000', 'temperatura', 600.0000, 'ºC'),
	(338179, 143, '2015-02-01 01:09:42.000000', 'temperatura', 657.0000, 'ºC'),
	(338180, 143, '2015-02-01 01:09:43.000000', 'temperatura', 283.0000, 'ºC'),
	(338181, 143, '2015-02-01 01:09:44.000000', 'temperatura', 645.0000, 'ºC'),
	(338182, 143, '2015-02-01 01:09:45.000000', 'temperatura', 1179.0000, 'ºC'),
	(338183, 143, '2015-02-01 01:09:46.000000', 'temperatura', 357.0000, 'ºC'),
	(338184, 143, '2015-02-01 01:09:47.000000', 'temperatura', 652.0000, 'ºC'),
	(338185, 143, '2015-02-01 01:09:48.000000', 'temperatura', 986.0000, 'ºC'),
	(338186, 143, '2015-02-01 01:09:49.000000', 'temperatura', 578.0000, 'ºC'),
	(338187, 143, '2015-02-01 01:09:50.000000', 'temperatura', 1130.0000, 'ºC'),
	(338188, 143, '2015-02-01 01:09:51.000000', 'temperatura', 315.0000, 'ºC'),
	(338189, 143, '2015-02-01 01:09:52.000000', 'temperatura', 588.0000, 'ºC'),
	(338190, 143, '2015-02-01 01:09:53.000000', 'temperatura', 797.0000, 'ºC'),
	(338191, 143, '2015-02-01 01:09:54.000000', 'temperatura', 1018.0000, 'ºC'),
	(338192, 143, '2015-02-01 01:09:55.000000', 'temperatura', 303.0000, 'ºC'),
	(338193, 143, '2015-02-01 01:09:56.000000', 'temperatura', 858.0000, 'ºC'),
	(338194, 143, '2015-02-01 01:09:57.000000', 'temperatura', 983.0000, 'ºC'),
	(338195, 143, '2015-02-01 01:09:58.000000', 'temperatura', 1141.0000, 'ºC'),
	(338196, 143, '2015-02-01 01:09:59.000000', 'temperatura', 358.0000, 'ºC'),
	(338197, 143, '2015-02-01 01:10:00.000000', 'temperatura', 766.0000, 'ºC'),
	(338198, 143, '2015-02-01 01:10:01.000000', 'temperatura', 358.0000, 'ºC'),
	(338199, 143, '2015-02-01 01:10:02.000000', 'temperatura', 692.0000, 'ºC'),
	(338200, 143, '2015-02-01 01:10:03.000000', 'temperatura', 1187.0000, 'ºC'),
	(338201, 143, '2015-02-01 01:10:04.000000', 'temperatura', 259.0000, 'ºC'),
	(338202, 143, '2015-02-01 01:10:05.000000', 'temperatura', 133.0000, 'ºC'),
	(338203, 143, '2015-02-01 01:10:06.000000', 'temperatura', 1088.0000, 'ºC'),
	(338204, 143, '2015-02-01 01:10:07.000000', 'temperatura', 244.0000, 'ºC'),
	(338205, 143, '2015-02-01 01:10:08.000000', 'temperatura', 357.0000, 'ºC'),
	(338206, 143, '2015-02-01 01:10:09.000000', 'temperatura', 1052.0000, 'ºC'),
	(338207, 143, '2015-02-01 01:10:10.000000', 'temperatura', 588.0000, 'ºC'),
	(338208, 144, '2015-02-01 00:00:00.000000', 'temperatura', 769.0000, 'ºC'),
	(338209, 144, '2015-02-01 00:00:01.000000', 'temperatura', 886.0000, 'ºC'),
	(338210, 144, '2015-02-01 00:00:02.000000', 'temperatura', 925.0000, 'ºC'),
	(338211, 144, '2015-02-01 00:00:03.000000', 'temperatura', 765.0000, 'ºC'),
	(338212, 144, '2015-02-01 00:00:04.000000', 'temperatura', 1051.0000, 'ºC'),
	(338213, 144, '2015-02-01 00:00:05.000000', 'temperatura', 560.0000, 'ºC'),
	(338214, 144, '2015-02-01 00:00:06.000000', 'temperatura', 849.0000, 'ºC'),
	(338215, 144, '2015-02-01 00:00:07.000000', 'temperatura', 164.0000, 'ºC'),
	(338216, 144, '2015-02-01 00:00:08.000000', 'temperatura', 676.0000, 'ºC'),
	(338217, 144, '2015-02-01 00:00:09.000000', 'temperatura', 486.0000, 'ºC'),
	(338218, 144, '2015-02-01 00:00:10.000000', 'temperatura', 402.0000, 'ºC'),
	(338219, 144, '2015-02-01 00:00:11.000000', 'temperatura', 554.0000, 'ºC'),
	(338220, 144, '2015-02-01 00:00:12.000000', 'temperatura', 365.0000, 'ºC'),
	(338221, 144, '2015-02-01 00:00:13.000000', 'temperatura', 163.0000, 'ºC'),
	(338222, 144, '2015-02-01 00:00:14.000000', 'temperatura', 921.0000, 'ºC'),
	(338223, 144, '2015-02-01 00:00:15.000000', 'temperatura', 518.0000, 'ºC'),
	(338224, 144, '2015-02-01 00:00:16.000000', 'temperatura', 1025.0000, 'ºC'),
	(338225, 144, '2015-02-01 00:00:17.000000', 'temperatura', 1173.0000, 'ºC'),
	(338226, 144, '2015-02-01 00:00:18.000000', 'temperatura', 390.0000, 'ºC'),
	(338227, 144, '2015-02-01 00:00:19.000000', 'temperatura', 833.0000, 'ºC'),
	(338228, 144, '2015-02-01 00:00:20.000000', 'temperatura', 596.0000, 'ºC'),
	(338229, 144, '2015-02-01 00:00:21.000000', 'temperatura', 482.0000, 'ºC'),
	(338230, 144, '2015-02-01 00:00:22.000000', 'temperatura', 621.0000, 'ºC'),
	(338231, 144, '2015-02-01 00:00:23.000000', 'temperatura', 459.0000, 'ºC'),
	(338232, 144, '2015-02-01 00:00:24.000000', 'temperatura', 431.0000, 'ºC'),
	(338233, 144, '2015-02-01 00:00:25.000000', 'temperatura', 782.0000, 'ºC'),
	(338234, 144, '2015-02-01 00:00:26.000000', 'temperatura', 215.0000, 'ºC'),
	(338235, 144, '2015-02-01 00:00:27.000000', 'temperatura', 1129.0000, 'ºC'),
	(338236, 144, '2015-02-01 00:00:28.000000', 'temperatura', 202.0000, 'ºC'),
	(338237, 144, '2015-02-01 00:00:29.000000', 'temperatura', 22.0000, 'ºC'),
	(338238, 144, '2015-02-01 00:00:30.000000', 'temperatura', 703.0000, 'ºC'),
	(338239, 144, '2015-02-01 00:00:31.000000', 'temperatura', 1052.0000, 'ºC'),
	(338240, 144, '2015-02-01 00:00:32.000000', 'temperatura', 750.0000, 'ºC'),
	(338241, 144, '2015-02-01 00:00:33.000000', 'temperatura', 595.0000, 'ºC'),
	(338242, 144, '2015-02-01 00:00:34.000000', 'temperatura', 726.0000, 'ºC'),
	(338243, 144, '2015-02-01 00:00:35.000000', 'temperatura', 644.0000, 'ºC'),
	(338244, 144, '2015-02-01 00:00:36.000000', 'temperatura', 1045.0000, 'ºC'),
	(338245, 144, '2015-02-01 00:00:37.000000', 'temperatura', 893.0000, 'ºC'),
	(338246, 144, '2015-02-01 00:00:38.000000', 'temperatura', 129.0000, 'ºC'),
	(338247, 144, '2015-02-01 00:00:39.000000', 'temperatura', 367.0000, 'ºC'),
	(338248, 144, '2015-02-01 00:00:40.000000', 'temperatura', 248.0000, 'ºC'),
	(338249, 144, '2015-02-01 00:00:41.000000', 'temperatura', 140.0000, 'ºC'),
	(338250, 144, '2015-02-01 00:00:42.000000', 'temperatura', 1155.0000, 'ºC'),
	(338251, 144, '2015-02-01 00:00:43.000000', 'temperatura', 556.0000, 'ºC'),
	(338252, 144, '2015-02-01 00:00:44.000000', 'temperatura', 514.0000, 'ºC'),
	(338253, 144, '2015-02-01 00:00:45.000000', 'temperatura', 906.0000, 'ºC'),
	(338254, 144, '2015-02-01 00:00:46.000000', 'temperatura', 586.0000, 'ºC'),
	(338255, 144, '2015-02-01 00:00:47.000000', 'temperatura', 213.0000, 'ºC'),
	(338256, 144, '2015-02-01 00:00:48.000000', 'temperatura', 506.0000, 'ºC'),
	(338257, 144, '2015-02-01 00:00:49.000000', 'temperatura', 694.0000, 'ºC'),
	(338258, 144, '2015-02-01 00:00:50.000000', 'temperatura', 752.0000, 'ºC'),
	(338259, 144, '2015-02-01 00:00:51.000000', 'temperatura', 480.0000, 'ºC'),
	(338260, 144, '2015-02-01 00:00:52.000000', 'temperatura', 143.0000, 'ºC'),
	(338261, 144, '2015-02-01 00:00:53.000000', 'temperatura', 478.0000, 'ºC'),
	(338262, 144, '2015-02-01 00:00:54.000000', 'temperatura', 758.0000, 'ºC'),
	(338263, 144, '2015-02-01 00:00:55.000000', 'temperatura', 1158.0000, 'ºC'),
	(338264, 144, '2015-02-01 00:00:56.000000', 'temperatura', 1118.0000, 'ºC'),
	(338265, 144, '2015-02-01 00:00:57.000000', 'temperatura', 916.0000, 'ºC'),
	(338266, 144, '2015-02-01 00:00:58.000000', 'temperatura', 26.0000, 'ºC'),
	(338267, 144, '2015-02-01 00:00:59.000000', 'temperatura', 984.0000, 'ºC'),
	(338268, 144, '2015-02-01 00:01:00.000000', 'temperatura', 43.0000, 'ºC'),
	(338269, 144, '2015-02-01 00:01:01.000000', 'temperatura', 864.0000, 'ºC'),
	(338270, 144, '2015-02-01 00:01:02.000000', 'temperatura', 588.0000, 'ºC'),
	(338271, 144, '2015-02-01 00:01:03.000000', 'temperatura', 352.0000, 'ºC'),
	(338272, 144, '2015-02-01 00:01:04.000000', 'temperatura', 1193.0000, 'ºC'),
	(338273, 144, '2015-02-01 00:01:05.000000', 'temperatura', 112.0000, 'ºC'),
	(338274, 144, '2015-02-01 00:01:06.000000', 'temperatura', 580.0000, 'ºC'),
	(338275, 144, '2015-02-01 00:01:07.000000', 'temperatura', 163.0000, 'ºC'),
	(338276, 144, '2015-02-01 00:01:08.000000', 'temperatura', 277.0000, 'ºC'),
	(338277, 144, '2015-02-01 00:01:09.000000', 'temperatura', 897.0000, 'ºC'),
	(338278, 144, '2015-02-01 00:01:10.000000', 'temperatura', 55.0000, 'ºC'),
	(338279, 144, '2015-02-01 00:01:11.000000', 'temperatura', 1185.0000, 'ºC'),
	(338280, 144, '2015-02-01 00:01:12.000000', 'temperatura', 961.0000, 'ºC'),
	(338281, 144, '2015-02-01 00:01:13.000000', 'temperatura', 50.0000, 'ºC'),
	(338282, 144, '2015-02-01 00:01:14.000000', 'temperatura', 966.0000, 'ºC'),
	(338283, 144, '2015-02-01 00:01:15.000000', 'temperatura', 1081.0000, 'ºC'),
	(338284, 144, '2015-02-01 00:01:16.000000', 'temperatura', 108.0000, 'ºC'),
	(338285, 144, '2015-02-01 00:01:17.000000', 'temperatura', 897.0000, 'ºC'),
	(338286, 144, '2015-02-01 00:01:18.000000', 'temperatura', 563.0000, 'ºC'),
	(338287, 144, '2015-02-01 00:01:19.000000', 'temperatura', 125.0000, 'ºC'),
	(338288, 144, '2015-02-01 00:01:20.000000', 'temperatura', 136.0000, 'ºC'),
	(338289, 144, '2015-02-01 00:01:21.000000', 'temperatura', 303.0000, 'ºC'),
	(338290, 144, '2015-02-01 00:01:22.000000', 'temperatura', 1109.0000, 'ºC'),
	(338291, 144, '2015-02-01 00:01:23.000000', 'temperatura', 1037.0000, 'ºC'),
	(338292, 144, '2015-02-01 00:01:24.000000', 'temperatura', 660.0000, 'ºC'),
	(338293, 144, '2015-02-01 00:01:25.000000', 'temperatura', 188.0000, 'ºC'),
	(338294, 144, '2015-02-01 00:01:26.000000', 'temperatura', 160.0000, 'ºC'),
	(338295, 144, '2015-02-01 00:01:27.000000', 'temperatura', 236.0000, 'ºC'),
	(338296, 144, '2015-02-01 00:01:28.000000', 'temperatura', 702.0000, 'ºC'),
	(338297, 144, '2015-02-01 00:01:29.000000', 'temperatura', 400.0000, 'ºC'),
	(338298, 144, '2015-02-01 00:01:30.000000', 'temperatura', 1097.0000, 'ºC'),
	(338299, 144, '2015-02-01 00:01:31.000000', 'temperatura', 685.0000, 'ºC'),
	(338300, 144, '2015-02-01 00:01:32.000000', 'temperatura', 133.0000, 'ºC'),
	(338301, 144, '2015-02-01 00:01:33.000000', 'temperatura', 1010.0000, 'ºC'),
	(338302, 144, '2015-02-01 00:01:34.000000', 'temperatura', 1052.0000, 'ºC'),
	(338303, 144, '2015-02-01 00:01:35.000000', 'temperatura', 1029.0000, 'ºC'),
	(338304, 144, '2015-02-01 00:01:36.000000', 'temperatura', 792.0000, 'ºC'),
	(338305, 144, '2015-02-01 00:01:37.000000', 'temperatura', 872.0000, 'ºC'),
	(338306, 144, '2015-02-01 00:01:38.000000', 'temperatura', 784.0000, 'ºC'),
	(338307, 144, '2015-02-01 00:01:39.000000', 'temperatura', 106.0000, 'ºC'),
	(338308, 144, '2015-02-01 00:01:40.000000', 'temperatura', 579.0000, 'ºC'),
	(338309, 144, '2015-02-01 00:01:41.000000', 'temperatura', 178.0000, 'ºC'),
	(338310, 144, '2015-02-01 00:01:42.000000', 'temperatura', 351.0000, 'ºC'),
	(338311, 144, '2015-02-01 00:01:43.000000', 'temperatura', 23.0000, 'ºC'),
	(338312, 144, '2015-02-01 00:01:44.000000', 'temperatura', 262.0000, 'ºC'),
	(338313, 144, '2015-02-01 00:01:45.000000', 'temperatura', 42.0000, 'ºC'),
	(338314, 144, '2015-02-01 00:01:46.000000', 'temperatura', 624.0000, 'ºC'),
	(338315, 144, '2015-02-01 00:01:47.000000', 'temperatura', 595.0000, 'ºC'),
	(338316, 144, '2015-02-01 00:01:48.000000', 'temperatura', 1105.0000, 'ºC'),
	(338317, 144, '2015-02-01 00:01:49.000000', 'temperatura', 138.0000, 'ºC'),
	(338318, 144, '2015-02-01 00:01:50.000000', 'temperatura', 975.0000, 'ºC'),
	(338319, 144, '2015-02-01 00:01:51.000000', 'temperatura', 863.0000, 'ºC'),
	(338320, 144, '2015-02-01 00:01:52.000000', 'temperatura', 191.0000, 'ºC'),
	(338321, 144, '2015-02-01 00:01:53.000000', 'temperatura', 766.0000, 'ºC'),
	(338322, 144, '2015-02-01 00:01:54.000000', 'temperatura', 856.0000, 'ºC'),
	(338323, 144, '2015-02-01 00:01:55.000000', 'temperatura', 783.0000, 'ºC'),
	(338324, 144, '2015-02-01 00:01:56.000000', 'temperatura', 150.0000, 'ºC'),
	(338325, 144, '2015-02-01 00:01:57.000000', 'temperatura', 799.0000, 'ºC'),
	(338326, 144, '2015-02-01 00:01:58.000000', 'temperatura', 1148.0000, 'ºC'),
	(338327, 144, '2015-02-01 00:01:59.000000', 'temperatura', 942.0000, 'ºC'),
	(338328, 144, '2015-02-01 00:02:00.000000', 'temperatura', 67.0000, 'ºC'),
	(338329, 144, '2015-02-01 00:02:01.000000', 'temperatura', 1110.0000, 'ºC'),
	(338330, 144, '2015-02-01 00:02:02.000000', 'temperatura', 550.0000, 'ºC'),
	(338331, 144, '2015-02-01 00:02:03.000000', 'temperatura', 622.0000, 'ºC'),
	(338332, 144, '2015-02-01 00:02:04.000000', 'temperatura', 258.0000, 'ºC'),
	(338333, 144, '2015-02-01 00:02:05.000000', 'temperatura', 627.0000, 'ºC'),
	(338334, 144, '2015-02-01 00:02:06.000000', 'temperatura', 1161.0000, 'ºC'),
	(338335, 144, '2015-02-01 00:02:07.000000', 'temperatura', 323.0000, 'ºC'),
	(338336, 144, '2015-02-01 00:02:08.000000', 'temperatura', 533.0000, 'ºC'),
	(338337, 144, '2015-02-01 00:02:09.000000', 'temperatura', 498.0000, 'ºC'),
	(338338, 144, '2015-02-01 00:02:10.000000', 'temperatura', 889.0000, 'ºC'),
	(338339, 144, '2015-02-01 00:02:11.000000', 'temperatura', 550.0000, 'ºC'),
	(338340, 144, '2015-02-01 00:02:12.000000', 'temperatura', 87.0000, 'ºC'),
	(338341, 144, '2015-02-01 00:02:13.000000', 'temperatura', 1185.0000, 'ºC'),
	(338342, 144, '2015-02-01 00:02:14.000000', 'temperatura', 863.0000, 'ºC'),
	(338343, 144, '2015-02-01 00:02:15.000000', 'temperatura', 762.0000, 'ºC'),
	(338344, 144, '2015-02-01 00:02:16.000000', 'temperatura', 21.0000, 'ºC'),
	(338345, 144, '2015-02-01 00:02:17.000000', 'temperatura', 220.0000, 'ºC'),
	(338346, 144, '2015-02-01 00:02:18.000000', 'temperatura', 1036.0000, 'ºC'),
	(338347, 144, '2015-02-01 00:02:19.000000', 'temperatura', 922.0000, 'ºC'),
	(338348, 144, '2015-02-01 00:02:20.000000', 'temperatura', 301.0000, 'ºC'),
	(338349, 144, '2015-02-01 00:02:21.000000', 'temperatura', 1140.0000, 'ºC'),
	(338350, 144, '2015-02-01 00:02:22.000000', 'temperatura', 1196.0000, 'ºC'),
	(338351, 144, '2015-02-01 00:02:23.000000', 'temperatura', 163.0000, 'ºC'),
	(338352, 144, '2015-02-01 00:02:24.000000', 'temperatura', 827.0000, 'ºC'),
	(338353, 144, '2015-02-01 00:02:25.000000', 'temperatura', 45.0000, 'ºC'),
	(338354, 144, '2015-02-01 00:02:26.000000', 'temperatura', 146.0000, 'ºC'),
	(338355, 144, '2015-02-01 00:02:27.000000', 'temperatura', 593.0000, 'ºC'),
	(338356, 144, '2015-02-01 00:02:28.000000', 'temperatura', 131.0000, 'ºC'),
	(338357, 144, '2015-02-01 00:02:29.000000', 'temperatura', 74.0000, 'ºC'),
	(338358, 144, '2015-02-01 00:02:30.000000', 'temperatura', 1179.0000, 'ºC'),
	(338359, 144, '2015-02-01 00:02:31.000000', 'temperatura', 872.0000, 'ºC'),
	(338360, 144, '2015-02-01 00:02:32.000000', 'temperatura', 825.0000, 'ºC'),
	(338361, 144, '2015-02-01 00:02:33.000000', 'temperatura', 307.0000, 'ºC'),
	(338362, 144, '2015-02-01 00:02:34.000000', 'temperatura', 263.0000, 'ºC'),
	(338363, 144, '2015-02-01 00:02:35.000000', 'temperatura', 393.0000, 'ºC'),
	(338364, 144, '2015-02-01 00:02:36.000000', 'temperatura', 1178.0000, 'ºC'),
	(338365, 144, '2015-02-01 00:02:37.000000', 'temperatura', 1109.0000, 'ºC'),
	(338366, 144, '2015-02-01 00:02:38.000000', 'temperatura', 814.0000, 'ºC'),
	(338367, 144, '2015-02-01 00:02:39.000000', 'temperatura', 741.0000, 'ºC'),
	(338368, 144, '2015-02-01 00:02:40.000000', 'temperatura', 66.0000, 'ºC'),
	(338369, 144, '2015-02-01 00:02:41.000000', 'temperatura', 508.0000, 'ºC'),
	(338370, 144, '2015-02-01 00:02:42.000000', 'temperatura', 1141.0000, 'ºC'),
	(338371, 144, '2015-02-01 00:02:43.000000', 'temperatura', 583.0000, 'ºC'),
	(338372, 144, '2015-02-01 00:02:44.000000', 'temperatura', 692.0000, 'ºC'),
	(338373, 144, '2015-02-01 00:02:45.000000', 'temperatura', 510.0000, 'ºC'),
	(338374, 144, '2015-02-01 00:02:46.000000', 'temperatura', 475.0000, 'ºC'),
	(338375, 144, '2015-02-01 00:02:47.000000', 'temperatura', 844.0000, 'ºC'),
	(338376, 144, '2015-02-01 00:02:48.000000', 'temperatura', 399.0000, 'ºC'),
	(338377, 144, '2015-02-01 00:02:49.000000', 'temperatura', 661.0000, 'ºC'),
	(338378, 144, '2015-02-01 00:02:50.000000', 'temperatura', 909.0000, 'ºC'),
	(338379, 144, '2015-02-01 00:02:51.000000', 'temperatura', 164.0000, 'ºC'),
	(338380, 144, '2015-02-01 00:02:52.000000', 'temperatura', 492.0000, 'ºC'),
	(338381, 144, '2015-02-01 00:02:53.000000', 'temperatura', 769.0000, 'ºC'),
	(338382, 144, '2015-02-01 00:02:54.000000', 'temperatura', 1169.0000, 'ºC'),
	(338383, 144, '2015-02-01 00:02:55.000000', 'temperatura', 1139.0000, 'ºC'),
	(338384, 144, '2015-02-01 00:02:56.000000', 'temperatura', 988.0000, 'ºC'),
	(338385, 144, '2015-02-01 00:02:57.000000', 'temperatura', 325.0000, 'ºC'),
	(338386, 144, '2015-02-01 00:02:58.000000', 'temperatura', 1061.0000, 'ºC'),
	(338387, 144, '2015-02-01 00:02:59.000000', 'temperatura', 730.0000, 'ºC'),
	(338388, 144, '2015-02-01 00:03:00.000000', 'temperatura', 469.0000, 'ºC'),
	(338389, 144, '2015-02-01 00:03:01.000000', 'temperatura', 156.0000, 'ºC'),
	(338390, 144, '2015-02-01 00:03:02.000000', 'temperatura', 573.0000, 'ºC'),
	(338391, 144, '2015-02-01 00:03:03.000000', 'temperatura', 1198.0000, 'ºC'),
	(338392, 144, '2015-02-01 00:03:04.000000', 'temperatura', 669.0000, 'ºC'),
	(338393, 144, '2015-02-01 00:03:05.000000', 'temperatura', 952.0000, 'ºC'),
	(338394, 144, '2015-02-01 00:03:06.000000', 'temperatura', 356.0000, 'ºC'),
	(338395, 144, '2015-02-01 00:03:07.000000', 'temperatura', 124.0000, 'ºC'),
	(338396, 144, '2015-02-01 00:03:08.000000', 'temperatura', 751.0000, 'ºC'),
	(338397, 144, '2015-02-01 00:03:09.000000', 'temperatura', 985.0000, 'ºC'),
	(338398, 144, '2015-02-01 00:03:10.000000', 'temperatura', 273.0000, 'ºC'),
	(338399, 144, '2015-02-01 00:03:11.000000', 'temperatura', 810.0000, 'ºC'),
	(338400, 144, '2015-02-01 00:03:12.000000', 'temperatura', 832.0000, 'ºC'),
	(338401, 144, '2015-02-01 00:03:13.000000', 'temperatura', 531.0000, 'ºC'),
	(338402, 144, '2015-02-01 00:03:14.000000', 'temperatura', 159.0000, 'ºC'),
	(338403, 144, '2015-02-01 00:03:15.000000', 'temperatura', 403.0000, 'ºC'),
	(338404, 144, '2015-02-01 00:03:16.000000', 'temperatura', 337.0000, 'ºC'),
	(338405, 144, '2015-02-01 00:03:17.000000', 'temperatura', 479.0000, 'ºC'),
	(338406, 144, '2015-02-01 00:03:18.000000', 'temperatura', 183.0000, 'ºC'),
	(338407, 144, '2015-02-01 00:03:19.000000', 'temperatura', 679.0000, 'ºC'),
	(338408, 144, '2015-02-01 00:03:20.000000', 'temperatura', 448.0000, 'ºC'),
	(338409, 144, '2015-02-01 00:03:21.000000', 'temperatura', 201.0000, 'ºC'),
	(338410, 144, '2015-02-01 00:03:22.000000', 'temperatura', 864.0000, 'ºC'),
	(338411, 144, '2015-02-01 00:03:23.000000', 'temperatura', 116.0000, 'ºC'),
	(338412, 144, '2015-02-01 00:03:24.000000', 'temperatura', 390.0000, 'ºC'),
	(338413, 144, '2015-02-01 00:03:25.000000', 'temperatura', 401.0000, 'ºC'),
	(338414, 144, '2015-02-01 00:03:26.000000', 'temperatura', 835.0000, 'ºC'),
	(338415, 144, '2015-02-01 00:03:27.000000', 'temperatura', 571.0000, 'ºC'),
	(338416, 144, '2015-02-01 00:03:28.000000', 'temperatura', 354.0000, 'ºC'),
	(338417, 144, '2015-02-01 00:03:29.000000', 'temperatura', 55.0000, 'ºC'),
	(338418, 144, '2015-02-01 00:03:30.000000', 'temperatura', 413.0000, 'ºC'),
	(338419, 144, '2015-02-01 00:03:31.000000', 'temperatura', 702.0000, 'ºC'),
	(338420, 144, '2015-02-01 00:03:32.000000', 'temperatura', 1072.0000, 'ºC'),
	(338421, 144, '2015-02-01 00:03:33.000000', 'temperatura', 852.0000, 'ºC'),
	(338422, 144, '2015-02-01 00:03:34.000000', 'temperatura', 1046.0000, 'ºC'),
	(338423, 144, '2015-02-01 00:03:35.000000', 'temperatura', 272.0000, 'ºC'),
	(338424, 144, '2015-02-01 00:03:36.000000', 'temperatura', 626.0000, 'ºC'),
	(338425, 144, '2015-02-01 00:03:37.000000', 'temperatura', 1112.0000, 'ºC'),
	(338426, 144, '2015-02-01 00:03:38.000000', 'temperatura', 84.0000, 'ºC'),
	(338427, 144, '2015-02-01 00:03:39.000000', 'temperatura', 683.0000, 'ºC'),
	(338428, 144, '2015-02-01 00:03:40.000000', 'temperatura', 766.0000, 'ºC'),
	(338429, 144, '2015-02-01 00:03:41.000000', 'temperatura', 580.0000, 'ºC'),
	(338430, 144, '2015-02-01 00:03:42.000000', 'temperatura', 604.0000, 'ºC'),
	(338431, 144, '2015-02-01 00:03:43.000000', 'temperatura', 80.0000, 'ºC'),
	(338432, 144, '2015-02-01 00:03:44.000000', 'temperatura', 989.0000, 'ºC'),
	(338433, 144, '2015-02-01 00:03:45.000000', 'temperatura', 1105.0000, 'ºC'),
	(338434, 144, '2015-02-01 00:03:46.000000', 'temperatura', 158.0000, 'ºC'),
	(338435, 144, '2015-02-01 00:03:47.000000', 'temperatura', 1075.0000, 'ºC'),
	(338436, 144, '2015-02-01 00:03:48.000000', 'temperatura', 100.0000, 'ºC'),
	(338437, 144, '2015-02-01 00:03:49.000000', 'temperatura', 879.0000, 'ºC'),
	(338438, 144, '2015-02-01 00:03:50.000000', 'temperatura', 492.0000, 'ºC'),
	(338439, 144, '2015-02-01 00:03:51.000000', 'temperatura', 1025.0000, 'ºC'),
	(338440, 144, '2015-02-01 00:03:52.000000', 'temperatura', 51.0000, 'ºC'),
	(338441, 144, '2015-02-01 00:03:53.000000', 'temperatura', 780.0000, 'ºC'),
	(338442, 144, '2015-02-01 00:03:54.000000', 'temperatura', 148.0000, 'ºC'),
	(338443, 144, '2015-02-01 00:03:55.000000', 'temperatura', 802.0000, 'ºC'),
	(338444, 144, '2015-02-01 00:03:56.000000', 'temperatura', 1163.0000, 'ºC'),
	(338445, 144, '2015-02-01 00:03:57.000000', 'temperatura', 1013.0000, 'ºC'),
	(338446, 144, '2015-02-01 00:03:58.000000', 'temperatura', 374.0000, 'ºC'),
	(338447, 144, '2015-02-01 00:03:59.000000', 'temperatura', 33.0000, 'ºC'),
	(338448, 144, '2015-02-01 00:04:00.000000', 'temperatura', 241.0000, 'ºC'),
	(338449, 144, '2015-02-01 00:04:01.000000', 'temperatura', 1109.0000, 'ºC'),
	(338450, 144, '2015-02-01 00:04:02.000000', 'temperatura', 22.0000, 'ºC'),
	(338451, 144, '2015-02-01 00:04:03.000000', 'temperatura', 382.0000, 'ºC'),
	(338452, 144, '2015-02-01 00:04:04.000000', 'temperatura', 646.0000, 'ºC'),
	(338453, 144, '2015-02-01 00:04:05.000000', 'temperatura', 882.0000, 'ºC'),
	(338454, 144, '2015-02-01 00:04:06.000000', 'temperatura', 74.0000, 'ºC'),
	(338455, 144, '2015-02-01 00:04:07.000000', 'temperatura', 126.0000, 'ºC'),
	(338456, 144, '2015-02-01 00:04:08.000000', 'temperatura', 409.0000, 'ºC'),
	(338457, 144, '2015-02-01 00:04:09.000000', 'temperatura', 465.0000, 'ºC'),
	(338458, 144, '2015-02-01 00:04:10.000000', 'temperatura', 1100.0000, 'ºC'),
	(338459, 144, '2015-02-01 00:04:11.000000', 'temperatura', 505.0000, 'ºC'),
	(338460, 144, '2015-02-01 00:04:12.000000', 'temperatura', 424.0000, 'ºC'),
	(338461, 144, '2015-02-01 00:04:13.000000', 'temperatura', 606.0000, 'ºC'),
	(338462, 144, '2015-02-01 00:04:14.000000', 'temperatura', 560.0000, 'ºC'),
	(338463, 144, '2015-02-01 00:04:15.000000', 'temperatura', 981.0000, 'ºC'),
	(338464, 144, '2015-02-01 00:04:16.000000', 'temperatura', 826.0000, 'ºC'),
	(338465, 144, '2015-02-01 00:04:17.000000', 'temperatura', 1187.0000, 'ºC'),
	(338466, 144, '2015-02-01 00:04:18.000000', 'temperatura', 1060.0000, 'ºC'),
	(338467, 144, '2015-02-01 00:04:19.000000', 'temperatura', 537.0000, 'ºC'),
	(338468, 144, '2015-02-01 00:04:20.000000', 'temperatura', 705.0000, 'ºC'),
	(338469, 144, '2015-02-01 00:04:21.000000', 'temperatura', 716.0000, 'ºC'),
	(338470, 144, '2015-02-01 00:04:22.000000', 'temperatura', 265.0000, 'ºC'),
	(338471, 144, '2015-02-01 00:04:23.000000', 'temperatura', 380.0000, 'ºC'),
	(338472, 144, '2015-02-01 00:04:24.000000', 'temperatura', 1102.0000, 'ºC'),
	(338473, 144, '2015-02-01 00:04:25.000000', 'temperatura', 773.0000, 'ºC'),
	(338474, 144, '2015-02-01 00:04:26.000000', 'temperatura', 558.0000, 'ºC'),
	(338475, 144, '2015-02-01 00:04:27.000000', 'temperatura', 473.0000, 'ºC'),
	(338476, 144, '2015-02-01 00:04:28.000000', 'temperatura', 689.0000, 'ºC'),
	(338477, 144, '2015-02-01 00:04:29.000000', 'temperatura', 826.0000, 'ºC'),
	(338478, 144, '2015-02-01 00:04:30.000000', 'temperatura', 866.0000, 'ºC'),
	(338479, 144, '2015-02-01 00:04:31.000000', 'temperatura', 653.0000, 'ºC'),
	(338480, 144, '2015-02-01 00:04:32.000000', 'temperatura', 665.0000, 'ºC'),
	(338481, 144, '2015-02-01 00:04:33.000000', 'temperatura', 169.0000, 'ºC'),
	(338482, 144, '2015-02-01 00:04:34.000000', 'temperatura', 48.0000, 'ºC'),
	(338483, 144, '2015-02-01 00:04:35.000000', 'temperatura', 934.0000, 'ºC'),
	(338484, 144, '2015-02-01 00:04:36.000000', 'temperatura', 926.0000, 'ºC'),
	(338485, 144, '2015-02-01 00:04:37.000000', 'temperatura', 629.0000, 'ºC'),
	(338486, 144, '2015-02-01 00:04:38.000000', 'temperatura', 367.0000, 'ºC'),
	(338487, 144, '2015-02-01 00:04:39.000000', 'temperatura', 1148.0000, 'ºC'),
	(338488, 144, '2015-02-01 00:04:40.000000', 'temperatura', 1038.0000, 'ºC'),
	(338489, 144, '2015-02-01 00:04:41.000000', 'temperatura', 550.0000, 'ºC'),
	(338490, 144, '2015-02-01 00:04:42.000000', 'temperatura', 835.0000, 'ºC'),
	(338491, 144, '2015-02-01 00:04:43.000000', 'temperatura', 126.0000, 'ºC'),
	(338492, 144, '2015-02-01 00:04:44.000000', 'temperatura', 523.0000, 'ºC'),
	(338493, 144, '2015-02-01 00:04:45.000000', 'temperatura', 1040.0000, 'ºC'),
	(338494, 144, '2015-02-01 00:04:46.000000', 'temperatura', 30.0000, 'ºC'),
	(338495, 144, '2015-02-01 00:04:47.000000', 'temperatura', 632.0000, 'ºC'),
	(338496, 144, '2015-02-01 00:04:48.000000', 'temperatura', 669.0000, 'ºC'),
	(338497, 144, '2015-02-01 00:04:49.000000', 'temperatura', 251.0000, 'ºC'),
	(338498, 144, '2015-02-01 00:04:50.000000', 'temperatura', 447.0000, 'ºC'),
	(338499, 144, '2015-02-01 00:04:51.000000', 'temperatura', 284.0000, 'ºC'),
	(338500, 144, '2015-02-01 00:04:52.000000', 'temperatura', 79.0000, 'ºC'),
	(338501, 144, '2015-02-01 00:04:53.000000', 'temperatura', 743.0000, 'ºC'),
	(338502, 144, '2015-02-01 00:04:54.000000', 'temperatura', 1080.0000, 'ºC'),
	(338503, 144, '2015-02-01 00:04:55.000000', 'temperatura', 770.0000, 'ºC'),
	(338504, 144, '2015-02-01 00:04:56.000000', 'temperatura', 611.0000, 'ºC'),
	(338505, 144, '2015-02-01 00:04:57.000000', 'temperatura', 747.0000, 'ºC'),
	(338506, 144, '2015-02-01 00:04:58.000000', 'temperatura', 703.0000, 'ºC'),
	(338507, 144, '2015-02-01 00:04:59.000000', 'temperatura', 71.0000, 'ºC'),
	(338508, 144, '2015-02-01 00:05:00.000000', 'temperatura', 650.0000, 'ºC'),
	(338509, 144, '2015-02-01 00:05:01.000000', 'temperatura', 635.0000, 'ºC'),
	(338510, 144, '2015-02-01 00:05:02.000000', 'temperatura', 27.0000, 'ºC'),
	(338511, 144, '2015-02-01 00:05:03.000000', 'temperatura', 629.0000, 'ºC'),
	(338512, 144, '2015-02-01 00:05:04.000000', 'temperatura', 667.0000, 'ºC'),
	(338513, 144, '2015-02-01 00:05:05.000000', 'temperatura', 246.0000, 'ºC'),
	(338514, 144, '2015-02-01 00:05:06.000000', 'temperatura', 428.0000, 'ºC'),
	(338515, 144, '2015-02-01 00:05:07.000000', 'temperatura', 205.0000, 'ºC'),
	(338516, 144, '2015-02-01 00:05:08.000000', 'temperatura', 942.0000, 'ºC'),
	(338517, 144, '2015-02-01 00:05:09.000000', 'temperatura', 494.0000, 'ºC'),
	(338518, 144, '2015-02-01 00:05:10.000000', 'temperatura', 844.0000, 'ºC'),
	(338519, 144, '2015-02-01 00:05:11.000000', 'temperatura', 340.0000, 'ºC'),
	(338520, 144, '2015-02-01 00:05:12.000000', 'temperatura', 368.0000, 'ºC'),
	(338521, 144, '2015-02-01 00:05:13.000000', 'temperatura', 819.0000, 'ºC'),
	(338522, 144, '2015-02-01 00:05:14.000000', 'temperatura', 591.0000, 'ºC'),
	(338523, 144, '2015-02-01 00:05:15.000000', 'temperatura', 499.0000, 'ºC'),
	(338524, 144, '2015-02-01 00:05:16.000000', 'temperatura', 723.0000, 'ºC'),
	(338525, 144, '2015-02-01 00:05:17.000000', 'temperatura', 917.0000, 'ºC'),
	(338526, 144, '2015-02-01 00:05:18.000000', 'temperatura', 19.0000, 'ºC'),
	(338527, 144, '2015-02-01 00:05:19.000000', 'temperatura', 942.0000, 'ºC'),
	(338528, 144, '2015-02-01 00:05:20.000000', 'temperatura', 1055.0000, 'ºC'),
	(338529, 144, '2015-02-01 00:05:21.000000', 'temperatura', 48.0000, 'ºC'),
	(338530, 144, '2015-02-01 00:05:22.000000', 'temperatura', 678.0000, 'ºC'),
	(338531, 144, '2015-02-01 00:05:23.000000', 'temperatura', 843.0000, 'ºC'),
	(338532, 144, '2015-02-01 00:05:24.000000', 'temperatura', 985.0000, 'ºC'),
	(338533, 144, '2015-02-01 00:05:25.000000', 'temperatura', 1194.0000, 'ºC'),
	(338534, 144, '2015-02-01 00:05:26.000000', 'temperatura', 615.0000, 'ºC'),
	(338535, 144, '2015-02-01 00:05:27.000000', 'temperatura', 693.0000, 'ºC'),
	(338536, 144, '2015-02-01 00:05:28.000000', 'temperatura', 420.0000, 'ºC'),
	(338537, 144, '2015-02-01 00:05:29.000000', 'temperatura', 22.0000, 'ºC'),
	(338538, 144, '2015-02-01 00:05:30.000000', 'temperatura', 51.0000, 'ºC'),
	(338539, 144, '2015-02-01 00:05:31.000000', 'temperatura', 188.0000, 'ºC'),
	(338540, 144, '2015-02-01 00:05:32.000000', 'temperatura', 788.0000, 'ºC'),
	(338541, 144, '2015-02-01 00:05:33.000000', 'temperatura', 977.0000, 'ºC'),
	(338542, 144, '2015-02-01 00:05:34.000000', 'temperatura', 120.0000, 'ºC'),
	(338543, 144, '2015-02-01 00:05:35.000000', 'temperatura', 69.0000, 'ºC'),
	(338544, 144, '2015-02-01 00:05:36.000000', 'temperatura', 1188.0000, 'ºC'),
	(338545, 144, '2015-02-01 00:05:37.000000', 'temperatura', 932.0000, 'ºC'),
	(338546, 144, '2015-02-01 00:05:38.000000', 'temperatura', 1096.0000, 'ºC'),
	(338547, 144, '2015-02-01 00:05:39.000000', 'temperatura', 283.0000, 'ºC'),
	(338548, 144, '2015-02-01 00:05:40.000000', 'temperatura', 530.0000, 'ºC'),
	(338549, 144, '2015-02-01 00:05:41.000000', 'temperatura', 601.0000, 'ºC'),
	(338550, 144, '2015-02-01 00:05:42.000000', 'temperatura', 215.0000, 'ºC'),
	(338551, 144, '2015-02-01 00:05:43.000000', 'temperatura', 474.0000, 'ºC'),
	(338552, 144, '2015-02-01 00:05:44.000000', 'temperatura', 524.0000, 'ºC'),
	(338553, 144, '2015-02-01 00:05:45.000000', 'temperatura', 1199.0000, 'ºC'),
	(338554, 144, '2015-02-01 00:05:46.000000', 'temperatura', 822.0000, 'ºC'),
	(338555, 144, '2015-02-01 00:05:47.000000', 'temperatura', 514.0000, 'ºC'),
	(338556, 144, '2015-02-01 00:05:48.000000', 'temperatura', 107.0000, 'ºC'),
	(338557, 144, '2015-02-01 00:05:49.000000', 'temperatura', 191.0000, 'ºC'),
	(338558, 144, '2015-02-01 00:05:50.000000', 'temperatura', 635.0000, 'ºC'),
	(338559, 144, '2015-02-01 00:05:51.000000', 'temperatura', 202.0000, 'ºC'),
	(338560, 144, '2015-02-01 00:05:52.000000', 'temperatura', 304.0000, 'ºC'),
	(338561, 144, '2015-02-01 00:05:53.000000', 'temperatura', 916.0000, 'ºC'),
	(338562, 144, '2015-02-01 00:05:54.000000', 'temperatura', 70.0000, 'ºC'),
	(338563, 144, '2015-02-01 00:05:55.000000', 'temperatura', 2.0000, 'ºC'),
	(338564, 144, '2015-02-01 00:05:56.000000', 'temperatura', 998.0000, 'ºC'),
	(338565, 144, '2015-02-01 00:05:57.000000', 'temperatura', 187.0000, 'ºC'),
	(338566, 144, '2015-02-01 00:05:58.000000', 'temperatura', 339.0000, 'ºC'),
	(338567, 144, '2015-02-01 00:05:59.000000', 'temperatura', 1135.0000, 'ºC'),
	(338568, 144, '2015-02-01 00:06:00.000000', 'temperatura', 1058.0000, 'ºC'),
	(338569, 144, '2015-02-01 00:06:01.000000', 'temperatura', 685.0000, 'ºC'),
	(338570, 144, '2015-02-01 00:06:02.000000', 'temperatura', 253.0000, 'ºC'),
	(338571, 144, '2015-02-01 00:06:03.000000', 'temperatura', 409.0000, 'ºC'),
	(338572, 144, '2015-02-01 00:06:04.000000', 'temperatura', 89.0000, 'ºC'),
	(338573, 144, '2015-02-01 00:06:05.000000', 'temperatura', 417.0000, 'ºC'),
	(338574, 144, '2015-02-01 00:06:06.000000', 'temperatura', 617.0000, 'ºC'),
	(338575, 144, '2015-02-01 00:06:07.000000', 'temperatura', 635.0000, 'ºC'),
	(338576, 144, '2015-02-01 00:06:08.000000', 'temperatura', 126.0000, 'ºC'),
	(338577, 144, '2015-02-01 00:06:09.000000', 'temperatura', 1126.0000, 'ºC'),
	(338578, 144, '2015-02-01 00:06:10.000000', 'temperatura', 451.0000, 'ºC'),
	(338579, 144, '2015-02-01 00:06:11.000000', 'temperatura', 80.0000, 'ºC'),
	(338580, 144, '2015-02-01 00:06:12.000000', 'temperatura', 244.0000, 'ºC'),
	(338581, 144, '2015-02-01 00:06:13.000000', 'temperatura', 983.0000, 'ºC'),
	(338582, 144, '2015-02-01 00:06:14.000000', 'temperatura', 581.0000, 'ºC'),
	(338583, 144, '2015-02-01 00:06:15.000000', 'temperatura', 1160.0000, 'ºC'),
	(338584, 144, '2015-02-01 00:06:16.000000', 'temperatura', 454.0000, 'ºC'),
	(338585, 144, '2015-02-01 00:06:17.000000', 'temperatura', 1192.0000, 'ºC'),
	(338586, 144, '2015-02-01 00:06:18.000000', 'temperatura', 997.0000, 'ºC'),
	(338587, 144, '2015-02-01 00:06:19.000000', 'temperatura', 210.0000, 'ºC'),
	(338588, 144, '2015-02-01 00:06:20.000000', 'temperatura', 458.0000, 'ºC'),
	(338589, 144, '2015-02-01 00:06:21.000000', 'temperatura', 461.0000, 'ºC'),
	(338590, 144, '2015-02-01 00:06:22.000000', 'temperatura', 933.0000, 'ºC'),
	(338591, 144, '2015-02-01 00:06:23.000000', 'temperatura', 881.0000, 'ºC'),
	(338592, 144, '2015-02-01 00:06:24.000000', 'temperatura', 408.0000, 'ºC'),
	(338593, 144, '2015-02-01 00:06:25.000000', 'temperatura', 596.0000, 'ºC'),
	(338594, 144, '2015-02-01 00:06:26.000000', 'temperatura', 556.0000, 'ºC'),
	(338595, 144, '2015-02-01 00:06:27.000000', 'temperatura', 994.0000, 'ºC'),
	(338596, 144, '2015-02-01 00:06:28.000000', 'temperatura', 901.0000, 'ºC'),
	(338597, 144, '2015-02-01 00:06:29.000000', 'temperatura', 324.0000, 'ºC'),
	(338598, 144, '2015-02-01 00:06:30.000000', 'temperatura', 117.0000, 'ºC'),
	(338599, 144, '2015-02-01 00:06:31.000000', 'temperatura', 812.0000, 'ºC'),
	(338600, 144, '2015-02-01 00:06:32.000000', 'temperatura', 112.0000, 'ºC'),
	(338601, 144, '2015-02-01 00:06:33.000000', 'temperatura', 523.0000, 'ºC'),
	(338602, 144, '2015-02-01 00:06:34.000000', 'temperatura', 1082.0000, 'ºC'),
	(338603, 144, '2015-02-01 00:06:35.000000', 'temperatura', 240.0000, 'ºC'),
	(338604, 144, '2015-02-01 00:06:36.000000', 'temperatura', 356.0000, 'ºC'),
	(338605, 144, '2015-02-01 00:06:37.000000', 'temperatura', 1059.0000, 'ºC'),
	(338606, 144, '2015-02-01 00:06:38.000000', 'temperatura', 628.0000, 'ºC'),
	(338607, 144, '2015-02-01 00:06:39.000000', 'temperatura', 1163.0000, 'ºC'),
	(338608, 144, '2015-02-01 00:06:40.000000', 'temperatura', 333.0000, 'ºC'),
	(338609, 144, '2015-02-01 00:06:41.000000', 'temperatura', 577.0000, 'ºC'),
	(338610, 144, '2015-02-01 00:06:42.000000', 'temperatura', 687.0000, 'ºC'),
	(338611, 144, '2015-02-01 00:06:43.000000', 'temperatura', 501.0000, 'ºC'),
	(338612, 144, '2015-02-01 00:06:44.000000', 'temperatura', 448.0000, 'ºC'),
	(338613, 144, '2015-02-01 00:06:45.000000', 'temperatura', 735.0000, 'ºC'),
	(338614, 144, '2015-02-01 00:06:46.000000', 'temperatura', 1134.0000, 'ºC'),
	(338615, 144, '2015-02-01 00:06:47.000000', 'temperatura', 1067.0000, 'ºC'),
	(338616, 144, '2015-02-01 00:06:48.000000', 'temperatura', 730.0000, 'ºC'),
	(338617, 144, '2015-02-01 00:06:49.000000', 'temperatura', 449.0000, 'ºC'),
	(338618, 144, '2015-02-01 00:06:50.000000', 'temperatura', 57.0000, 'ºC'),
	(338619, 144, '2015-02-01 00:06:51.000000', 'temperatura', 138.0000, 'ºC'),
	(338620, 144, '2015-02-01 00:06:52.000000', 'temperatura', 521.0000, 'ºC'),
	(338621, 144, '2015-02-01 00:06:53.000000', 'temperatura', 991.0000, 'ºC'),
	(338622, 144, '2015-02-01 00:06:54.000000', 'temperatura', 993.0000, 'ºC'),
	(338623, 144, '2015-02-01 00:06:55.000000', 'temperatura', 794.0000, 'ºC'),
	(338624, 144, '2015-02-01 00:06:56.000000', 'temperatura', 989.0000, 'ºC'),
	(338625, 144, '2015-02-01 00:06:57.000000', 'temperatura', 165.0000, 'ºC'),
	(338626, 144, '2015-02-01 00:06:58.000000', 'temperatura', 258.0000, 'ºC'),
	(338627, 144, '2015-02-01 00:06:59.000000', 'temperatura', 793.0000, 'ºC'),
	(338628, 144, '2015-02-01 00:07:00.000000', 'temperatura', 795.0000, 'ºC'),
	(338629, 144, '2015-02-01 00:07:01.000000', 'temperatura', 395.0000, 'ºC'),
	(338630, 144, '2015-02-01 00:07:02.000000', 'temperatura', 793.0000, 'ºC'),
	(338631, 144, '2015-02-01 00:07:03.000000', 'temperatura', 377.0000, 'ºC'),
	(338632, 144, '2015-02-01 00:07:04.000000', 'temperatura', 708.0000, 'ºC'),
	(338633, 144, '2015-02-01 00:07:05.000000', 'temperatura', 7.0000, 'ºC'),
	(338634, 144, '2015-02-01 00:07:06.000000', 'temperatura', 314.0000, 'ºC'),
	(338635, 144, '2015-02-01 00:07:07.000000', 'temperatura', 350.0000, 'ºC'),
	(338636, 144, '2015-02-01 00:07:08.000000', 'temperatura', 808.0000, 'ºC'),
	(338637, 144, '2015-02-01 00:07:09.000000', 'temperatura', 590.0000, 'ºC'),
	(338638, 144, '2015-02-01 00:07:10.000000', 'temperatura', 526.0000, 'ºC'),
	(338639, 144, '2015-02-01 00:07:11.000000', 'temperatura', 860.0000, 'ºC'),
	(338640, 144, '2015-02-01 00:07:12.000000', 'temperatura', 324.0000, 'ºC'),
	(338641, 144, '2015-02-01 00:07:13.000000', 'temperatura', 242.0000, 'ºC'),
	(338642, 144, '2015-02-01 00:07:14.000000', 'temperatura', 235.0000, 'ºC'),
	(338643, 144, '2015-02-01 00:07:15.000000', 'temperatura', 453.0000, 'ºC'),
	(338644, 144, '2015-02-01 00:07:16.000000', 'temperatura', 357.0000, 'ºC'),
	(338645, 144, '2015-02-01 00:07:17.000000', 'temperatura', 428.0000, 'ºC'),
	(338646, 144, '2015-02-01 00:07:18.000000', 'temperatura', 1070.0000, 'ºC'),
	(338647, 144, '2015-02-01 00:07:19.000000', 'temperatura', 468.0000, 'ºC'),
	(338648, 144, '2015-02-01 00:07:20.000000', 'temperatura', 328.0000, 'ºC'),
	(338649, 144, '2015-02-01 00:07:21.000000', 'temperatura', 238.0000, 'ºC'),
	(338650, 144, '2015-02-01 00:07:22.000000', 'temperatura', 207.0000, 'ºC'),
	(338651, 144, '2015-02-01 00:07:23.000000', 'temperatura', 320.0000, 'ºC'),
	(338652, 144, '2015-02-01 00:07:24.000000', 'temperatura', 979.0000, 'ºC'),
	(338653, 144, '2015-02-01 00:07:25.000000', 'temperatura', 336.0000, 'ºC'),
	(338654, 144, '2015-02-01 00:07:26.000000', 'temperatura', 1146.0000, 'ºC'),
	(338655, 144, '2015-02-01 00:07:27.000000', 'temperatura', 1119.0000, 'ºC'),
	(338656, 144, '2015-02-01 00:07:28.000000', 'temperatura', 959.0000, 'ºC'),
	(338657, 144, '2015-02-01 00:07:29.000000', 'temperatura', 238.0000, 'ºC'),
	(338658, 144, '2015-02-01 00:07:30.000000', 'temperatura', 714.0000, 'ºC'),
	(338659, 144, '2015-02-01 00:07:31.000000', 'temperatura', 457.0000, 'ºC'),
	(338660, 144, '2015-02-01 00:07:32.000000', 'temperatura', 145.0000, 'ºC'),
	(338661, 144, '2015-02-01 00:07:33.000000', 'temperatura', 551.0000, 'ºC'),
	(338662, 144, '2015-02-01 00:07:34.000000', 'temperatura', 1122.0000, 'ºC'),
	(338663, 144, '2015-02-01 00:07:35.000000', 'temperatura', 358.0000, 'ºC'),
	(338664, 144, '2015-02-01 00:07:36.000000', 'temperatura', 824.0000, 'ºC'),
	(338665, 144, '2015-02-01 00:07:37.000000', 'temperatura', 645.0000, 'ºC'),
	(338666, 144, '2015-02-01 00:07:38.000000', 'temperatura', 756.0000, 'ºC'),
	(338667, 144, '2015-02-01 00:07:39.000000', 'temperatura', 642.0000, 'ºC'),
	(338668, 144, '2015-02-01 00:07:40.000000', 'temperatura', 946.0000, 'ºC'),
	(338669, 144, '2015-02-01 00:07:41.000000', 'temperatura', 403.0000, 'ºC'),
	(338670, 144, '2015-02-01 00:07:42.000000', 'temperatura', 378.0000, 'ºC'),
	(338671, 144, '2015-02-01 00:07:43.000000', 'temperatura', 680.0000, 'ºC'),
	(338672, 144, '2015-02-01 00:07:44.000000', 'temperatura', 1069.0000, 'ºC'),
	(338673, 144, '2015-02-01 00:07:45.000000', 'temperatura', 906.0000, 'ºC'),
	(338674, 144, '2015-02-01 00:07:46.000000', 'temperatura', 120.0000, 'ºC'),
	(338675, 144, '2015-02-01 00:07:47.000000', 'temperatura', 285.0000, 'ºC'),
	(338676, 144, '2015-02-01 00:07:48.000000', 'temperatura', 1066.0000, 'ºC'),
	(338677, 144, '2015-02-01 00:07:49.000000', 'temperatura', 873.0000, 'ºC'),
	(338678, 144, '2015-02-01 00:07:50.000000', 'temperatura', 1170.0000, 'ºC'),
	(338679, 144, '2015-02-01 00:07:51.000000', 'temperatura', 832.0000, 'ºC'),
	(338680, 144, '2015-02-01 00:07:52.000000', 'temperatura', 648.0000, 'ºC'),
	(338681, 144, '2015-02-01 00:07:53.000000', 'temperatura', 745.0000, 'ºC'),
	(338682, 144, '2015-02-01 00:07:54.000000', 'temperatura', 582.0000, 'ºC'),
	(338683, 144, '2015-02-01 00:07:55.000000', 'temperatura', 677.0000, 'ºC'),
	(338684, 144, '2015-02-01 00:07:56.000000', 'temperatura', 436.0000, 'ºC'),
	(338685, 144, '2015-02-01 00:07:57.000000', 'temperatura', 152.0000, 'ºC'),
	(338686, 144, '2015-02-01 00:07:58.000000', 'temperatura', 653.0000, 'ºC'),
	(338687, 144, '2015-02-01 00:07:59.000000', 'temperatura', 409.0000, 'ºC'),
	(338688, 144, '2015-02-01 00:08:00.000000', 'temperatura', 88.0000, 'ºC'),
	(338689, 144, '2015-02-01 00:08:01.000000', 'temperatura', 412.0000, 'ºC'),
	(338690, 144, '2015-02-01 00:08:02.000000', 'temperatura', 598.0000, 'ºC'),
	(338691, 144, '2015-02-01 00:08:03.000000', 'temperatura', 553.0000, 'ºC'),
	(338692, 144, '2015-02-01 00:08:04.000000', 'temperatura', 970.0000, 'ºC'),
	(338693, 144, '2015-02-01 00:08:05.000000', 'temperatura', 793.0000, 'ºC'),
	(338694, 144, '2015-02-01 00:08:06.000000', 'temperatura', 1057.0000, 'ºC'),
	(338695, 144, '2015-02-01 00:08:07.000000', 'temperatura', 506.0000, 'ºC'),
	(338696, 144, '2015-02-01 00:08:08.000000', 'temperatura', 560.0000, 'ºC'),
	(338697, 144, '2015-02-01 00:08:09.000000', 'temperatura', 81.0000, 'ºC'),
	(338698, 144, '2015-02-01 00:08:10.000000', 'temperatura', 1125.0000, 'ºC'),
	(338699, 144, '2015-02-01 00:08:11.000000', 'temperatura', 584.0000, 'ºC'),
	(338700, 144, '2015-02-01 00:08:12.000000', 'temperatura', 744.0000, 'ºC'),
	(338701, 144, '2015-02-01 00:08:13.000000', 'temperatura', 770.0000, 'ºC'),
	(338702, 144, '2015-02-01 00:08:14.000000', 'temperatura', 419.0000, 'ºC'),
	(338703, 144, '2015-02-01 00:08:15.000000', 'temperatura', 983.0000, 'ºC'),
	(338704, 144, '2015-02-01 00:08:16.000000', 'temperatura', 59.0000, 'ºC'),
	(338705, 144, '2015-02-01 00:08:17.000000', 'temperatura', 946.0000, 'ºC'),
	(338706, 144, '2015-02-01 00:08:18.000000', 'temperatura', 954.0000, 'ºC'),
	(338707, 144, '2015-02-01 00:08:19.000000', 'temperatura', 732.0000, 'ºC'),
	(338708, 144, '2015-02-01 00:08:20.000000', 'temperatura', 799.0000, 'ºC'),
	(338709, 144, '2015-02-01 00:08:21.000000', 'temperatura', 601.0000, 'ºC'),
	(338710, 144, '2015-02-01 00:08:22.000000', 'temperatura', 608.0000, 'ºC'),
	(338711, 144, '2015-02-01 00:08:23.000000', 'temperatura', 38.0000, 'ºC'),
	(338712, 144, '2015-02-01 00:08:24.000000', 'temperatura', 766.0000, 'ºC'),
	(338713, 144, '2015-02-01 00:08:25.000000', 'temperatura', 117.0000, 'ºC'),
	(338714, 144, '2015-02-01 00:08:26.000000', 'temperatura', 686.0000, 'ºC'),
	(338715, 144, '2015-02-01 00:08:27.000000', 'temperatura', 680.0000, 'ºC'),
	(338716, 144, '2015-02-01 00:08:28.000000', 'temperatura', 142.0000, 'ºC'),
	(338717, 144, '2015-02-01 00:08:29.000000', 'temperatura', 1069.0000, 'ºC'),
	(338718, 144, '2015-02-01 00:08:30.000000', 'temperatura', 121.0000, 'ºC'),
	(338719, 144, '2015-02-01 00:08:31.000000', 'temperatura', 997.0000, 'ºC'),
	(338720, 144, '2015-02-01 00:08:32.000000', 'temperatura', 1021.0000, 'ºC'),
	(338721, 144, '2015-02-01 00:08:33.000000', 'temperatura', 918.0000, 'ºC'),
	(338722, 144, '2015-02-01 00:08:34.000000', 'temperatura', 327.0000, 'ºC'),
	(338723, 144, '2015-02-01 00:08:35.000000', 'temperatura', 80.0000, 'ºC'),
	(338724, 144, '2015-02-01 00:08:36.000000', 'temperatura', 619.0000, 'ºC'),
	(338725, 144, '2015-02-01 00:08:37.000000', 'temperatura', 458.0000, 'ºC'),
	(338726, 144, '2015-02-01 00:08:38.000000', 'temperatura', 431.0000, 'ºC'),
	(338727, 144, '2015-02-01 00:08:39.000000', 'temperatura', 781.0000, 'ºC'),
	(338728, 144, '2015-02-01 00:08:40.000000', 'temperatura', 212.0000, 'ºC'),
	(338729, 144, '2015-02-01 00:08:41.000000', 'temperatura', 1120.0000, 'ºC'),
	(338730, 144, '2015-02-01 00:08:42.000000', 'temperatura', 166.0000, 'ºC'),
	(338731, 144, '2015-02-01 00:08:43.000000', 'temperatura', 1067.0000, 'ºC'),
	(338732, 144, '2015-02-01 00:08:44.000000', 'temperatura', 38.0000, 'ºC'),
	(338733, 144, '2015-02-01 00:08:45.000000', 'temperatura', 588.0000, 'ºC'),
	(338734, 144, '2015-02-01 00:08:46.000000', 'temperatura', 429.0000, 'ºC'),
	(338735, 144, '2015-02-01 00:08:47.000000', 'temperatura', 382.0000, 'ºC'),
	(338736, 144, '2015-02-01 00:08:48.000000', 'temperatura', 623.0000, 'ºC'),
	(338737, 144, '2015-02-01 00:08:49.000000', 'temperatura', 769.0000, 'ºC'),
	(338738, 144, '2015-02-01 00:08:50.000000', 'temperatura', 776.0000, 'ºC'),
	(338739, 144, '2015-02-01 00:08:51.000000', 'temperatura', 375.0000, 'ºC'),
	(338740, 144, '2015-02-01 00:08:52.000000', 'temperatura', 746.0000, 'ºC'),
	(338741, 144, '2015-02-01 00:08:53.000000', 'temperatura', 208.0000, 'ºC'),
	(338742, 144, '2015-02-01 00:08:54.000000', 'temperatura', 2.0000, 'ºC'),
	(338743, 144, '2015-02-01 00:08:55.000000', 'temperatura', 585.0000, 'ºC'),
	(338744, 144, '2015-02-01 00:08:56.000000', 'temperatura', 521.0000, 'ºC'),
	(338745, 144, '2015-02-01 00:08:57.000000', 'temperatura', 851.0000, 'ºC'),
	(338746, 144, '2015-02-01 00:08:58.000000', 'temperatura', 291.0000, 'ºC'),
	(338747, 144, '2015-02-01 00:08:59.000000', 'temperatura', 103.0000, 'ºC'),
	(338748, 144, '2015-02-01 00:09:00.000000', 'temperatura', 844.0000, 'ºC'),
	(338749, 144, '2015-02-01 00:09:01.000000', 'temperatura', 312.0000, 'ºC'),
	(338750, 144, '2015-02-01 00:09:02.000000', 'temperatura', 226.0000, 'ºC'),
	(338751, 144, '2015-02-01 00:09:03.000000', 'temperatura', 194.0000, 'ºC'),
	(338752, 144, '2015-02-01 00:09:04.000000', 'temperatura', 294.0000, 'ºC'),
	(338753, 144, '2015-02-01 00:09:05.000000', 'temperatura', 886.0000, 'ºC'),
	(338754, 144, '2015-02-01 00:09:06.000000', 'temperatura', 1152.0000, 'ºC'),
	(338755, 144, '2015-02-01 00:09:07.000000', 'temperatura', 700.0000, 'ºC'),
	(338756, 144, '2015-02-01 00:09:08.000000', 'temperatura', 44.0000, 'ºC'),
	(338757, 144, '2015-02-01 00:09:09.000000', 'temperatura', 521.0000, 'ºC'),
	(338758, 144, '2015-02-01 00:09:10.000000', 'temperatura', 73.0000, 'ºC'),
	(338759, 144, '2015-02-01 00:09:11.000000', 'temperatura', 4.0000, 'ºC'),
	(338760, 144, '2015-02-01 00:09:12.000000', 'temperatura', 1001.0000, 'ºC'),
	(338761, 144, '2015-02-01 00:09:13.000000', 'temperatura', 193.0000, 'ºC'),
	(338762, 144, '2015-02-01 00:09:14.000000', 'temperatura', 362.0000, 'ºC'),
	(338763, 144, '2015-02-01 00:09:15.000000', 'temperatura', 32.0000, 'ºC'),
	(338764, 144, '2015-02-01 00:09:16.000000', 'temperatura', 275.0000, 'ºC'),
	(338765, 144, '2015-02-01 00:09:17.000000', 'temperatura', 79.0000, 'ºC'),
	(338766, 144, '2015-02-01 00:09:18.000000', 'temperatura', 772.0000, 'ºC'),
	(338767, 144, '2015-02-01 00:09:19.000000', 'temperatura', 22.0000, 'ºC'),
	(338768, 144, '2015-02-01 00:09:20.000000', 'temperatura', 195.0000, 'ºC'),
	(338769, 144, '2015-02-01 00:09:21.000000', 'temperatura', 910.0000, 'ºC'),
	(338770, 144, '2015-02-01 00:09:22.000000', 'temperatura', 364.0000, 'ºC'),
	(338771, 144, '2015-02-01 00:09:23.000000', 'temperatura', 293.0000, 'ºC'),
	(338772, 144, '2015-02-01 00:09:24.000000', 'temperatura', 371.0000, 'ºC'),
	(338773, 144, '2015-02-01 00:09:25.000000', 'temperatura', 978.0000, 'ºC'),
	(338774, 144, '2015-02-01 00:09:26.000000', 'temperatura', 178.0000, 'ºC'),
	(338775, 144, '2015-02-01 00:09:27.000000', 'temperatura', 358.0000, 'ºC'),
	(338776, 144, '2015-02-01 00:09:28.000000', 'temperatura', 54.0000, 'ºC'),
	(338777, 144, '2015-02-01 00:09:29.000000', 'temperatura', 399.0000, 'ºC'),
	(338778, 144, '2015-02-01 00:09:30.000000', 'temperatura', 633.0000, 'ºC'),
	(338779, 144, '2015-02-01 00:09:31.000000', 'temperatura', 768.0000, 'ºC'),
	(338780, 144, '2015-02-01 00:09:32.000000', 'temperatura', 740.0000, 'ºC'),
	(338781, 144, '2015-02-01 00:09:33.000000', 'temperatura', 196.0000, 'ºC'),
	(338782, 144, '2015-02-01 00:09:34.000000', 'temperatura', 1160.0000, 'ºC'),
	(338783, 144, '2015-02-01 00:09:35.000000', 'temperatura', 415.0000, 'ºC'),
	(338784, 144, '2015-02-01 00:09:36.000000', 'temperatura', 994.0000, 'ºC'),
	(338785, 144, '2015-02-01 00:09:37.000000', 'temperatura', 124.0000, 'ºC'),
	(338786, 144, '2015-02-01 00:09:38.000000', 'temperatura', 42.0000, 'ºC'),
	(338787, 144, '2015-02-01 00:09:39.000000', 'temperatura', 1037.0000, 'ºC'),
	(338788, 144, '2015-02-01 00:09:40.000000', 'temperatura', 257.0000, 'ºC'),
	(338789, 144, '2015-02-01 00:09:41.000000', 'temperatura', 578.0000, 'ºC'),
	(338790, 144, '2015-02-01 00:09:42.000000', 'temperatura', 919.0000, 'ºC'),
	(338791, 144, '2015-02-01 00:09:43.000000', 'temperatura', 463.0000, 'ºC'),
	(338792, 144, '2015-02-01 00:09:44.000000', 'temperatura', 756.0000, 'ºC'),
	(338793, 144, '2015-02-01 00:09:45.000000', 'temperatura', 1190.0000, 'ºC'),
	(338794, 144, '2015-02-01 00:09:46.000000', 'temperatura', 85.0000, 'ºC'),
	(338795, 144, '2015-02-01 00:09:47.000000', 'temperatura', 454.0000, 'ºC'),
	(338796, 144, '2015-02-01 00:09:48.000000', 'temperatura', 818.0000, 'ºC'),
	(338797, 144, '2015-02-01 00:09:49.000000', 'temperatura', 326.0000, 'ºC'),
	(338798, 144, '2015-02-01 00:09:50.000000', 'temperatura', 379.0000, 'ºC'),
	(338799, 144, '2015-02-01 00:09:51.000000', 'temperatura', 917.0000, 'ºC'),
	(338800, 144, '2015-02-01 00:09:52.000000', 'temperatura', 1049.0000, 'ºC'),
	(338801, 144, '2015-02-01 00:09:53.000000', 'temperatura', 92.0000, 'ºC'),
	(338802, 144, '2015-02-01 00:09:54.000000', 'temperatura', 914.0000, 'ºC'),
	(338803, 144, '2015-02-01 00:09:55.000000', 'temperatura', 695.0000, 'ºC'),
	(338804, 144, '2015-02-01 00:09:56.000000', 'temperatura', 732.0000, 'ºC'),
	(338805, 144, '2015-02-01 00:09:57.000000', 'temperatura', 378.0000, 'ºC'),
	(338806, 144, '2015-02-01 00:09:58.000000', 'temperatura', 891.0000, 'ºC'),
	(338807, 144, '2015-02-01 00:09:59.000000', 'temperatura', 925.0000, 'ºC'),
	(338808, 144, '2015-02-01 00:10:00.000000', 'temperatura', 751.0000, 'ºC'),
	(338809, 144, '2015-02-01 00:10:01.000000', 'temperatura', 981.0000, 'ºC'),
	(338810, 144, '2015-02-01 00:10:02.000000', 'temperatura', 252.0000, 'ºC'),
	(338811, 144, '2015-02-01 00:10:03.000000', 'temperatura', 716.0000, 'ºC'),
	(338812, 144, '2015-02-01 00:10:04.000000', 'temperatura', 427.0000, 'ºC'),
	(338813, 144, '2015-02-01 00:10:05.000000', 'temperatura', 1188.0000, 'ºC'),
	(338814, 144, '2015-02-01 00:10:06.000000', 'temperatura', 1058.0000, 'ºC'),
	(338815, 144, '2015-02-01 00:10:07.000000', 'temperatura', 526.0000, 'ºC'),
	(338816, 144, '2015-02-01 00:10:08.000000', 'temperatura', 657.0000, 'ºC'),
	(338817, 144, '2015-02-01 00:10:09.000000', 'temperatura', 507.0000, 'ºC'),
	(338818, 144, '2015-02-01 00:10:10.000000', 'temperatura', 563.0000, 'ºC'),
	(338819, 144, '2015-02-01 00:10:11.000000', 'temperatura', 97.0000, 'ºC'),
	(338820, 144, '2015-02-01 00:10:12.000000', 'temperatura', 1197.0000, 'ºC'),
	(338821, 144, '2015-02-01 00:10:13.000000', 'temperatura', 893.0000, 'ºC'),
	(338822, 144, '2015-02-01 00:10:14.000000', 'temperatura', 875.0000, 'ºC'),
	(338823, 144, '2015-02-01 00:10:15.000000', 'temperatura', 497.0000, 'ºC'),
	(338824, 144, '2015-02-01 00:10:16.000000', 'temperatura', 1059.0000, 'ºC'),
	(338825, 144, '2015-02-01 00:10:17.000000', 'temperatura', 204.0000, 'ºC'),
	(338826, 144, '2015-02-01 00:10:18.000000', 'temperatura', 245.0000, 'ºC'),
	(338827, 144, '2015-02-01 00:10:19.000000', 'temperatura', 615.0000, 'ºC'),
	(338828, 144, '2015-02-01 00:10:20.000000', 'temperatura', 1137.0000, 'ºC'),
	(338829, 144, '2015-02-01 00:10:21.000000', 'temperatura', 243.0000, 'ºC'),
	(338830, 144, '2015-02-01 00:10:22.000000', 'temperatura', 205.0000, 'ºC'),
	(338831, 144, '2015-02-01 00:10:23.000000', 'temperatura', 294.0000, 'ºC'),
	(338832, 144, '2015-02-01 00:10:24.000000', 'temperatura', 856.0000, 'ºC'),
	(338833, 144, '2015-02-01 00:10:25.000000', 'temperatura', 999.0000, 'ºC'),
	(338834, 144, '2015-02-01 00:10:26.000000', 'temperatura', 26.0000, 'ºC'),
	(338835, 144, '2015-02-01 00:10:27.000000', 'temperatura', 736.0000, 'ºC'),
	(338836, 144, '2015-02-01 00:10:28.000000', 'temperatura', 1199.0000, 'ºC'),
	(338837, 144, '2015-02-01 00:10:29.000000', 'temperatura', 191.0000, 'ºC'),
	(338838, 144, '2015-02-01 00:10:30.000000', 'temperatura', 958.0000, 'ºC'),
	(338839, 144, '2015-02-01 00:10:31.000000', 'temperatura', 619.0000, 'ºC'),
	(338840, 144, '2015-02-01 00:10:32.000000', 'temperatura', 220.0000, 'ºC'),
	(338841, 144, '2015-02-01 00:10:33.000000', 'temperatura', 444.0000, 'ºC'),
	(338842, 144, '2015-02-01 00:10:34.000000', 'temperatura', 358.0000, 'ºC'),
	(338843, 144, '2015-02-01 00:10:35.000000', 'temperatura', 461.0000, 'ºC'),
	(338844, 144, '2015-02-01 00:10:36.000000', 'temperatura', 30.0000, 'ºC'),
	(338845, 144, '2015-02-01 00:10:37.000000', 'temperatura', 1167.0000, 'ºC'),
	(338846, 144, '2015-02-01 00:10:38.000000', 'temperatura', 947.0000, 'ºC'),
	(338847, 144, '2015-02-01 00:10:39.000000', 'temperatura', 34.0000, 'ºC'),
	(338848, 144, '2015-02-01 00:10:40.000000', 'temperatura', 930.0000, 'ºC'),
	(338849, 144, '2015-02-01 00:10:41.000000', 'temperatura', 949.0000, 'ºC'),
	(338850, 144, '2015-02-01 00:10:42.000000', 'temperatura', 756.0000, 'ºC'),
	(338851, 144, '2015-02-01 00:10:43.000000', 'temperatura', 933.0000, 'ºC'),
	(338852, 144, '2015-02-01 00:10:44.000000', 'temperatura', 1197.0000, 'ºC'),
	(338853, 144, '2015-02-01 00:10:45.000000', 'temperatura', 789.0000, 'ºC'),
	(338854, 144, '2015-02-01 00:10:46.000000', 'temperatura', 351.0000, 'ºC'),
	(338855, 144, '2015-02-01 00:10:47.000000', 'temperatura', 591.0000, 'ºC'),
	(338856, 144, '2015-02-01 00:10:48.000000', 'temperatura', 702.0000, 'ºC'),
	(338857, 144, '2015-02-01 00:10:49.000000', 'temperatura', 536.0000, 'ºC'),
	(338858, 144, '2015-02-01 00:10:50.000000', 'temperatura', 574.0000, 'ºC'),
	(338859, 144, '2015-02-01 00:10:51.000000', 'temperatura', 64.0000, 'ºC'),
	(338860, 144, '2015-02-01 00:10:52.000000', 'temperatura', 999.0000, 'ºC'),
	(338861, 144, '2015-02-01 00:10:53.000000', 'temperatura', 3.0000, 'ºC'),
	(338862, 144, '2015-02-01 00:10:54.000000', 'temperatura', 618.0000, 'ºC'),
	(338863, 144, '2015-02-01 00:10:55.000000', 'temperatura', 683.0000, 'ºC'),
	(338864, 144, '2015-02-01 00:10:56.000000', 'temperatura', 360.0000, 'ºC'),
	(338865, 144, '2015-02-01 00:10:57.000000', 'temperatura', 951.0000, 'ºC'),
	(338866, 144, '2015-02-01 00:10:58.000000', 'temperatura', 77.0000, 'ºC'),
	(338867, 144, '2015-02-01 00:10:59.000000', 'temperatura', 1132.0000, 'ºC'),
	(338868, 144, '2015-02-01 00:11:00.000000', 'temperatura', 630.0000, 'ºC'),
	(338869, 144, '2015-02-01 00:11:01.000000', 'temperatura', 955.0000, 'ºC'),
	(338870, 144, '2015-02-01 00:11:02.000000', 'temperatura', 484.0000, 'ºC'),
	(338871, 144, '2015-02-01 00:11:03.000000', 'temperatura', 755.0000, 'ºC'),
	(338872, 144, '2015-02-01 00:11:04.000000', 'temperatura', 1123.0000, 'ºC'),
	(338873, 144, '2015-02-01 00:11:05.000000', 'temperatura', 953.0000, 'ºC'),
	(338874, 144, '2015-02-01 00:11:06.000000', 'temperatura', 194.0000, 'ºC'),
	(338875, 144, '2015-02-01 00:11:07.000000', 'temperatura', 511.0000, 'ºC'),
	(338876, 144, '2015-02-01 00:11:08.000000', 'temperatura', 774.0000, 'ºC'),
	(338877, 144, '2015-02-01 00:11:09.000000', 'temperatura', 1137.0000, 'ºC'),
	(338878, 144, '2015-02-01 00:11:10.000000', 'temperatura', 965.0000, 'ºC'),
	(338879, 144, '2015-02-01 00:11:11.000000', 'temperatura', 215.0000, 'ºC'),
	(338880, 144, '2015-02-01 00:11:12.000000', 'temperatura', 580.0000, 'ºC'),
	(338881, 144, '2015-02-01 00:11:13.000000', 'temperatura', 1054.0000, 'ºC'),
	(338882, 144, '2015-02-01 00:11:14.000000', 'temperatura', 1130.0000, 'ºC'),
	(338883, 144, '2015-02-01 00:11:15.000000', 'temperatura', 91.0000, 'ºC'),
	(338884, 144, '2015-02-01 00:11:16.000000', 'temperatura', 666.0000, 'ºC'),
	(338885, 144, '2015-02-01 00:11:17.000000', 'temperatura', 658.0000, 'ºC'),
	(338886, 144, '2015-02-01 00:11:18.000000', 'temperatura', 91.0000, 'ºC'),
	(338887, 144, '2015-02-01 00:11:19.000000', 'temperatura', 882.0000, 'ºC'),
	(338888, 144, '2015-02-01 00:11:20.000000', 'temperatura', 539.0000, 'ºC'),
	(338889, 144, '2015-02-01 00:11:21.000000', 'temperatura', 49.0000, 'ºC'),
	(338890, 144, '2015-02-01 00:11:22.000000', 'temperatura', 1029.0000, 'ºC'),
	(338891, 144, '2015-02-01 00:11:23.000000', 'temperatura', 200.0000, 'ºC'),
	(338892, 144, '2015-02-01 00:11:24.000000', 'temperatura', 312.0000, 'ºC'),
	(338893, 144, '2015-02-01 00:11:25.000000', 'temperatura', 959.0000, 'ºC'),
	(338894, 144, '2015-02-01 00:11:26.000000', 'temperatura', 260.0000, 'ºC'),
	(338895, 144, '2015-02-01 00:11:27.000000', 'temperatura', 823.0000, 'ºC'),
	(338896, 144, '2015-02-01 00:11:28.000000', 'temperatura', 934.0000, 'ºC'),
	(338897, 144, '2015-02-01 00:11:29.000000', 'temperatura', 1004.0000, 'ºC'),
	(338898, 144, '2015-02-01 00:11:30.000000', 'temperatura', 1019.0000, 'ºC'),
	(338899, 144, '2015-02-01 00:11:31.000000', 'temperatura', 883.0000, 'ºC'),
	(338900, 144, '2015-02-01 00:11:32.000000', 'temperatura', 158.0000, 'ºC'),
	(338901, 144, '2015-02-01 00:11:33.000000', 'temperatura', 544.0000, 'ºC'),
	(338902, 144, '2015-02-01 00:11:34.000000', 'temperatura', 1043.0000, 'ºC'),
	(338903, 144, '2015-02-01 00:11:35.000000', 'temperatura', 1184.0000, 'ºC'),
	(338904, 144, '2015-02-01 00:11:36.000000', 'temperatura', 393.0000, 'ºC'),
	(338905, 144, '2015-02-01 00:11:37.000000', 'temperatura', 812.0000, 'ºC'),
	(338906, 144, '2015-02-01 00:11:38.000000', 'temperatura', 482.0000, 'ºC'),
	(338907, 144, '2015-02-01 00:11:39.000000', 'temperatura', 1173.0000, 'ºC'),
	(338908, 144, '2015-02-01 00:11:40.000000', 'temperatura', 819.0000, 'ºC'),
	(338909, 144, '2015-02-01 00:11:41.000000', 'temperatura', 579.0000, 'ºC'),
	(338910, 144, '2015-02-01 00:11:42.000000', 'temperatura', 436.0000, 'ºC'),
	(338911, 144, '2015-02-01 00:11:43.000000', 'temperatura', 444.0000, 'ºC'),
	(338912, 144, '2015-02-01 00:11:44.000000', 'temperatura', 913.0000, 'ºC'),
	(338913, 144, '2015-02-01 00:11:45.000000', 'temperatura', 833.0000, 'ºC'),
	(338914, 144, '2015-02-01 00:11:46.000000', 'temperatura', 226.0000, 'ºC'),
	(338915, 144, '2015-02-01 00:11:47.000000', 'temperatura', 1033.0000, 'ºC'),
	(338916, 144, '2015-02-01 00:11:48.000000', 'temperatura', 888.0000, 'ºC'),
	(338917, 144, '2015-02-01 00:11:49.000000', 'temperatura', 139.0000, 'ºC'),
	(338918, 144, '2015-02-01 00:11:50.000000', 'temperatura', 435.0000, 'ºC'),
	(338919, 144, '2015-02-01 00:11:51.000000', 'temperatura', 556.0000, 'ºC'),
	(338920, 144, '2015-02-01 00:11:52.000000', 'temperatura', 275.0000, 'ºC'),
	(338921, 144, '2015-02-01 00:11:53.000000', 'temperatura', 907.0000, 'ºC'),
	(338922, 144, '2015-02-01 00:11:54.000000', 'temperatura', 110.0000, 'ºC'),
	(338923, 144, '2015-02-01 00:11:55.000000', 'temperatura', 232.0000, 'ºC'),
	(338924, 144, '2015-02-01 00:11:56.000000', 'temperatura', 831.0000, 'ºC'),
	(338925, 144, '2015-02-01 00:11:57.000000', 'temperatura', 1059.0000, 'ºC'),
	(338926, 144, '2015-02-01 00:11:58.000000', 'temperatura', 404.0000, 'ºC'),
	(338927, 144, '2015-02-01 00:11:59.000000', 'temperatura', 42.0000, 'ºC'),
	(338928, 144, '2015-02-01 00:12:00.000000', 'temperatura', 197.0000, 'ºC'),
	(338929, 144, '2015-02-01 00:12:01.000000', 'temperatura', 862.0000, 'ºC'),
	(338930, 144, '2015-02-01 00:12:02.000000', 'temperatura', 117.0000, 'ºC'),
	(338931, 144, '2015-02-01 00:12:03.000000', 'temperatura', 402.0000, 'ºC'),
	(338932, 144, '2015-02-01 00:12:04.000000', 'temperatura', 457.0000, 'ºC'),
	(338933, 144, '2015-02-01 00:12:05.000000', 'temperatura', 1082.0000, 'ºC'),
	(338934, 144, '2015-02-01 00:12:06.000000', 'temperatura', 440.0000, 'ºC'),
	(338935, 144, '2015-02-01 00:12:07.000000', 'temperatura', 156.0000, 'ºC'),
	(338936, 144, '2015-02-01 00:12:08.000000', 'temperatura', 657.0000, 'ºC'),
	(338937, 144, '2015-02-01 00:12:09.000000', 'temperatura', 418.0000, 'ºC'),
	(338938, 144, '2015-02-01 00:12:10.000000', 'temperatura', 119.0000, 'ºC'),
	(338939, 144, '2015-02-01 00:12:11.000000', 'temperatura', 543.0000, 'ºC'),
	(338940, 144, '2015-02-01 00:12:12.000000', 'temperatura', 1156.0000, 'ºC'),
	(338941, 144, '2015-02-01 00:12:13.000000', 'temperatura', 554.0000, 'ºC'),
	(338942, 144, '2015-02-01 00:12:14.000000', 'temperatura', 500.0000, 'ºC'),
	(338943, 144, '2015-02-01 00:12:15.000000', 'temperatura', 841.0000, 'ºC'),
	(338944, 144, '2015-02-01 00:12:16.000000', 'temperatura', 305.0000, 'ºC'),
	(338945, 144, '2015-02-01 00:12:17.000000', 'temperatura', 204.0000, 'ºC'),
	(338946, 144, '2015-02-01 00:12:18.000000', 'temperatura', 105.0000, 'ºC'),
	(338947, 144, '2015-02-01 00:12:19.000000', 'temperatura', 1114.0000, 'ºC'),
	(338948, 144, '2015-02-01 00:12:20.000000', 'temperatura', 453.0000, 'ºC'),
	(338949, 144, '2015-02-01 00:12:21.000000', 'temperatura', 127.0000, 'ºC'),
	(338950, 144, '2015-02-01 00:12:22.000000', 'temperatura', 474.0000, 'ºC'),
	(338951, 144, '2015-02-01 00:12:23.000000', 'temperatura', 791.0000, 'ºC'),
	(338952, 144, '2015-02-01 00:12:24.000000', 'temperatura', 133.0000, 'ºC'),
	(338953, 144, '2015-02-01 00:12:25.000000', 'temperatura', 692.0000, 'ºC'),
	(338954, 144, '2015-02-01 00:12:26.000000', 'temperatura', 662.0000, 'ºC'),
	(338955, 144, '2015-02-01 00:12:27.000000', 'temperatura', 34.0000, 'ºC'),
	(338956, 144, '2015-02-01 00:12:28.000000', 'temperatura', 586.0000, 'ºC'),
	(338957, 144, '2015-02-01 00:12:29.000000', 'temperatura', 428.0000, 'ºC'),
	(338958, 144, '2015-02-01 00:12:30.000000', 'temperatura', 380.0000, 'ºC'),
	(338959, 144, '2015-02-01 00:12:31.000000', 'temperatura', 620.0000, 'ºC'),
	(338960, 144, '2015-02-01 00:12:32.000000', 'temperatura', 759.0000, 'ºC'),
	(338961, 144, '2015-02-01 00:12:33.000000', 'temperatura', 738.0000, 'ºC'),
	(338962, 144, '2015-02-01 00:12:34.000000', 'temperatura', 211.0000, 'ºC'),
	(338963, 144, '2015-02-01 00:12:35.000000', 'temperatura', 41.0000, 'ºC'),
	(338964, 144, '2015-02-01 00:12:36.000000', 'temperatura', 771.0000, 'ºC'),
	(338965, 144, '2015-02-01 00:12:37.000000', 'temperatura', 135.0000, 'ºC'),
	(338966, 144, '2015-02-01 00:12:38.000000', 'temperatura', 762.0000, 'ºC'),
	(338967, 144, '2015-02-01 00:12:39.000000', 'temperatura', 1004.0000, 'ºC'),
	(338968, 144, '2015-02-01 00:12:40.000000', 'temperatura', 337.0000, 'ºC'),
	(338969, 144, '2015-02-01 00:12:41.000000', 'temperatura', 1071.0000, 'ºC'),
	(338970, 144, '2015-02-01 00:12:42.000000', 'temperatura', 745.0000, 'ºC'),
	(338971, 144, '2015-02-01 00:12:43.000000', 'temperatura', 514.0000, 'ºC'),
	(338972, 144, '2015-02-01 00:12:44.000000', 'temperatura', 335.0000, 'ºC'),
	(338973, 144, '2015-02-01 00:12:45.000000', 'temperatura', 132.0000, 'ºC'),
	(338974, 144, '2015-02-01 00:12:46.000000', 'temperatura', 856.0000, 'ºC'),
	(338975, 144, '2015-02-01 00:12:47.000000', 'temperatura', 285.0000, 'ºC'),
	(338976, 144, '2015-02-01 00:12:48.000000', 'temperatura', 56.0000, 'ºC'),
	(338977, 144, '2015-02-01 00:12:49.000000', 'temperatura', 628.0000, 'ºC'),
	(338978, 144, '2015-02-01 00:12:50.000000', 'temperatura', 572.0000, 'ºC'),
	(338979, 144, '2015-02-01 00:12:51.000000', 'temperatura', 977.0000, 'ºC'),
	(338980, 144, '2015-02-01 00:12:52.000000', 'temperatura', 767.0000, 'ºC'),
	(338981, 144, '2015-02-01 00:12:53.000000', 'temperatura', 906.0000, 'ºC'),
	(338982, 144, '2015-02-01 00:12:54.000000', 'temperatura', 1031.0000, 'ºC'),
	(338983, 144, '2015-02-01 00:12:55.000000', 'temperatura', 37.0000, 'ºC'),
	(338984, 144, '2015-02-01 00:12:56.000000', 'temperatura', 691.0000, 'ºC'),
	(338985, 144, '2015-02-01 00:12:57.000000', 'temperatura', 947.0000, 'ºC'),
	(338986, 144, '2015-02-01 00:12:58.000000', 'temperatura', 261.0000, 'ºC'),
	(338987, 144, '2015-02-01 00:12:59.000000', 'temperatura', 867.0000, 'ºC'),
	(338988, 144, '2015-02-01 00:13:00.000000', 'temperatura', 1149.0000, 'ºC'),
	(338989, 144, '2015-02-01 00:13:01.000000', 'temperatura', 745.0000, 'ºC'),
	(338990, 144, '2015-02-01 00:13:02.000000', 'temperatura', 279.0000, 'ºC'),
	(338991, 144, '2015-02-01 00:13:03.000000', 'temperatura', 362.0000, 'ºC'),
	(338992, 144, '2015-02-01 00:13:04.000000', 'temperatura', 972.0000, 'ºC'),
	(338993, 144, '2015-02-01 00:13:05.000000', 'temperatura', 174.0000, 'ºC'),
	(338994, 144, '2015-02-01 00:13:06.000000', 'temperatura', 353.0000, 'ºC'),
	(338995, 144, '2015-02-01 00:13:07.000000', 'temperatura', 46.0000, 'ºC'),
	(338996, 144, '2015-02-01 00:13:08.000000', 'temperatura', 373.0000, 'ºC'),
	(338997, 144, '2015-02-01 00:13:09.000000', 'temperatura', 524.0000, 'ºC'),
	(338998, 144, '2015-02-01 00:13:10.000000', 'temperatura', 304.0000, 'ºC'),
	(338999, 144, '2015-02-01 00:13:11.000000', 'temperatura', 1146.0000, 'ºC'),
	(339000, 144, '2015-02-01 00:13:12.000000', 'temperatura', 21.0000, 'ºC'),
	(339001, 144, '2015-02-01 00:13:13.000000', 'temperatura', 266.0000, 'ºC'),
	(339002, 144, '2015-02-01 00:13:14.000000', 'temperatura', 70.0000, 'ºC'),
	(339003, 144, '2015-02-01 00:13:15.000000', 'temperatura', 749.0000, 'ºC'),
	(339004, 144, '2015-02-01 00:13:16.000000', 'temperatura', 1138.0000, 'ºC'),
	(339005, 144, '2015-02-01 00:13:17.000000', 'temperatura', 1043.0000, 'ºC'),
	(339006, 144, '2015-02-01 00:13:18.000000', 'temperatura', 602.0000, 'ºC'),
	(339007, 144, '2015-02-01 00:13:19.000000', 'temperatura', 1079.0000, 'ºC'),
	(339008, 144, '2015-02-01 00:13:20.000000', 'temperatura', 1191.0000, 'ºC'),
	(339009, 144, '2015-02-01 00:13:21.000000', 'temperatura', 317.0000, 'ºC'),
	(339010, 144, '2015-02-01 00:13:22.000000', 'temperatura', 413.0000, 'ºC'),
	(339011, 144, '2015-02-01 00:13:23.000000', 'temperatura', 1116.0000, 'ºC'),
	(339012, 144, '2015-02-01 00:13:24.000000', 'temperatura', 741.0000, 'ºC'),
	(339013, 144, '2015-02-01 00:13:25.000000', 'temperatura', 355.0000, 'ºC'),
	(339014, 144, '2015-02-01 00:13:26.000000', 'temperatura', 756.0000, 'ºC'),
	(339015, 144, '2015-02-01 00:13:27.000000', 'temperatura', 312.0000, 'ºC'),
	(339016, 144, '2015-02-01 00:13:28.000000', 'temperatura', 495.0000, 'ºC'),
	(339017, 144, '2015-02-01 00:13:29.000000', 'temperatura', 337.0000, 'ºC'),
	(339018, 144, '2015-02-01 00:13:30.000000', 'temperatura', 203.0000, 'ºC'),
	(339019, 144, '2015-02-01 00:13:31.000000', 'temperatura', 5.0000, 'ºC'),
	(339020, 144, '2015-02-01 00:13:32.000000', 'temperatura', 618.0000, 'ºC'),
	(339021, 144, '2015-02-01 00:13:33.000000', 'temperatura', 672.0000, 'ºC'),
	(339022, 144, '2015-02-01 00:13:34.000000', 'temperatura', 308.0000, 'ºC'),
	(339023, 144, '2015-02-01 00:13:35.000000', 'temperatura', 724.0000, 'ºC'),
	(339024, 144, '2015-02-01 00:13:36.000000', 'temperatura', 298.0000, 'ºC'),
	(339025, 144, '2015-02-01 00:13:37.000000', 'temperatura', 516.0000, 'ºC'),
	(339026, 144, '2015-02-01 00:13:38.000000', 'temperatura', 486.0000, 'ºC'),
	(339027, 144, '2015-02-01 00:13:39.000000', 'temperatura', 885.0000, 'ºC'),
	(339028, 144, '2015-02-01 00:13:40.000000', 'temperatura', 567.0000, 'ºC'),
	(339029, 144, '2015-02-01 00:13:41.000000', 'temperatura', 181.0000, 'ºC'),
	(339030, 144, '2015-02-01 00:13:42.000000', 'temperatura', 402.0000, 'ºC'),
	(339031, 144, '2015-02-01 00:13:43.000000', 'temperatura', 269.0000, 'ºC'),
	(339032, 144, '2015-02-01 00:13:44.000000', 'temperatura', 138.0000, 'ºC'),
	(339033, 144, '2015-02-01 00:13:45.000000', 'temperatura', 1083.0000, 'ºC'),
	(339034, 144, '2015-02-01 00:13:46.000000', 'temperatura', 201.0000, 'ºC'),
	(339035, 144, '2015-02-01 00:13:47.000000', 'temperatura', 157.0000, 'ºC'),
	(339036, 144, '2015-02-01 00:13:48.000000', 'temperatura', 184.0000, 'ºC'),
	(339037, 144, '2015-02-01 00:13:49.000000', 'temperatura', 449.0000, 'ºC'),
	(339038, 144, '2015-02-01 00:13:50.000000', 'temperatura', 492.0000, 'ºC'),
	(339039, 144, '2015-02-01 00:13:51.000000', 'temperatura', 1114.0000, 'ºC'),
	(339040, 144, '2015-02-01 00:13:52.000000', 'temperatura', 494.0000, 'ºC'),
	(339041, 144, '2015-02-01 00:13:53.000000', 'temperatura', 328.0000, 'ºC'),
	(339042, 144, '2015-02-01 00:13:54.000000', 'temperatura', 158.0000, 'ºC'),
	(339043, 144, '2015-02-01 00:13:55.000000', 'temperatura', 1007.0000, 'ºC'),
	(339044, 144, '2015-02-01 00:13:56.000000', 'temperatura', 961.0000, 'ºC'),
	(339045, 144, '2015-02-01 00:13:57.000000', 'temperatura', 584.0000, 'ºC'),
	(339046, 144, '2015-02-01 00:13:58.000000', 'temperatura', 39.0000, 'ºC'),
	(339047, 144, '2015-02-01 00:13:59.000000', 'temperatura', 843.0000, 'ºC'),
	(339048, 144, '2015-02-01 00:14:00.000000', 'temperatura', 498.0000, 'ºC'),
	(339049, 144, '2015-02-01 00:14:01.000000', 'temperatura', 1162.0000, 'ºC'),
	(339050, 144, '2015-02-01 00:14:02.000000', 'temperatura', 715.0000, 'ºC'),
	(339051, 144, '2015-02-01 00:14:03.000000', 'temperatura', 92.0000, 'ºC'),
	(339052, 144, '2015-02-01 00:14:04.000000', 'temperatura', 713.0000, 'ºC'),
	(339053, 144, '2015-02-01 00:14:05.000000', 'temperatura', 892.0000, 'ºC'),
	(339054, 144, '2015-02-01 00:14:06.000000', 'temperatura', 1123.0000, 'ºC'),
	(339055, 144, '2015-02-01 00:14:07.000000', 'temperatura', 536.0000, 'ºC'),
	(339056, 144, '2015-02-01 00:14:08.000000', 'temperatura', 513.0000, 'ºC'),
	(339057, 144, '2015-02-01 00:14:09.000000', 'temperatura', 956.0000, 'ºC'),
	(339058, 144, '2015-02-01 00:14:10.000000', 'temperatura', 841.0000, 'ºC'),
	(339059, 144, '2015-02-01 00:14:11.000000', 'temperatura', 138.0000, 'ºC'),
	(339060, 144, '2015-02-01 00:14:12.000000', 'temperatura', 569.0000, 'ºC'),
	(339061, 144, '2015-02-01 00:14:13.000000', 'temperatura', 30.0000, 'ºC'),
	(339062, 144, '2015-02-01 00:14:14.000000', 'temperatura', 846.0000, 'ºC'),
	(339063, 144, '2015-02-01 00:14:15.000000', 'temperatura', 539.0000, 'ºC'),
	(339064, 144, '2015-02-01 00:14:16.000000', 'temperatura', 158.0000, 'ºC'),
	(339065, 144, '2015-02-01 00:14:17.000000', 'temperatura', 373.0000, 'ºC'),
	(339066, 144, '2015-02-01 00:14:18.000000', 'temperatura', 194.0000, 'ºC'),
	(339067, 144, '2015-02-01 00:14:19.000000', 'temperatura', 1048.0000, 'ºC'),
	(339068, 144, '2015-02-01 00:14:20.000000', 'temperatura', 1059.0000, 'ºC'),
	(339069, 144, '2015-02-01 00:14:21.000000', 'temperatura', 952.0000, 'ºC'),
	(339070, 144, '2015-02-01 00:14:22.000000', 'temperatura', 384.0000, 'ºC'),
	(339071, 144, '2015-02-01 00:14:23.000000', 'temperatura', 265.0000, 'ºC'),
	(339072, 144, '2015-02-01 00:14:24.000000', 'temperatura', 171.0000, 'ºC'),
	(339073, 144, '2015-02-01 00:14:25.000000', 'temperatura', 63.0000, 'ºC'),
	(339074, 144, '2015-02-01 00:14:26.000000', 'temperatura', 1000.0000, 'ºC'),
	(339075, 144, '2015-02-01 00:14:27.000000', 'temperatura', 12.0000, 'ºC'),
	(339076, 144, '2015-02-01 00:14:28.000000', 'temperatura', 659.0000, 'ºC'),
	(339077, 144, '2015-02-01 00:14:29.000000', 'temperatura', 861.0000, 'ºC'),
	(339078, 144, '2015-02-01 00:14:30.000000', 'temperatura', 1127.0000, 'ºC'),
	(339079, 144, '2015-02-01 00:14:31.000000', 'temperatura', 654.0000, 'ºC'),
	(339080, 144, '2015-02-01 00:14:32.000000', 'temperatura', 1091.0000, 'ºC'),
	(339081, 144, '2015-02-01 00:14:33.000000', 'temperatura', 1091.0000, 'ºC'),
	(339082, 144, '2015-02-01 00:14:34.000000', 'temperatura', 983.0000, 'ºC'),
	(339083, 144, '2015-02-01 00:14:35.000000', 'temperatura', 441.0000, 'ºC'),
	(339084, 144, '2015-02-01 00:14:36.000000', 'temperatura', 458.0000, 'ºC'),
	(339085, 144, '2015-02-01 00:14:37.000000', 'temperatura', 966.0000, 'ºC'),
	(339086, 144, '2015-02-01 00:14:38.000000', 'temperatura', 1056.0000, 'ºC'),
	(339087, 144, '2015-02-01 00:14:39.000000', 'temperatura', 1183.0000, 'ºC'),
	(339088, 144, '2015-02-01 00:14:40.000000', 'temperatura', 349.0000, 'ºC'),
	(339089, 144, '2015-02-01 00:14:41.000000', 'temperatura', 596.0000, 'ºC'),
	(339090, 144, '2015-02-01 00:14:42.000000', 'temperatura', 735.0000, 'ºC'),
	(339091, 144, '2015-02-01 00:14:43.000000', 'temperatura', 688.0000, 'ºC'),
	(339092, 144, '2015-02-01 00:14:44.000000', 'temperatura', 33.0000, 'ºC'),
	(339093, 144, '2015-02-01 00:14:45.000000', 'temperatura', 503.0000, 'ºC'),
	(339094, 144, '2015-02-01 00:14:46.000000', 'temperatura', 16.0000, 'ºC'),
	(339095, 144, '2015-02-01 00:14:47.000000', 'temperatura', 971.0000, 'ºC'),
	(339096, 144, '2015-02-01 00:14:48.000000', 'temperatura', 9.0000, 'ºC'),
	(339097, 144, '2015-02-01 00:14:49.000000', 'temperatura', 734.0000, 'ºC'),
	(339098, 144, '2015-02-01 00:14:50.000000', 'temperatura', 40.0000, 'ºC'),
	(339099, 144, '2015-02-01 00:14:51.000000', 'temperatura', 399.0000, 'ºC'),
	(339100, 144, '2015-02-01 00:14:52.000000', 'temperatura', 676.0000, 'ºC'),
	(339101, 144, '2015-02-01 00:14:53.000000', 'temperatura', 982.0000, 'ºC'),
	(339102, 144, '2015-02-01 00:14:54.000000', 'temperatura', 483.0000, 'ºC'),
	(339103, 144, '2015-02-01 00:14:55.000000', 'temperatura', 668.0000, 'ºC'),
	(339104, 144, '2015-02-01 00:14:56.000000', 'temperatura', 693.0000, 'ºC'),
	(339105, 144, '2015-02-01 00:14:57.000000', 'temperatura', 262.0000, 'ºC'),
	(339106, 144, '2015-02-01 00:14:58.000000', 'temperatura', 432.0000, 'ºC'),
	(339107, 144, '2015-02-01 00:14:59.000000', 'temperatura', 176.0000, 'ºC'),
	(339108, 144, '2015-02-01 00:15:00.000000', 'temperatura', 782.0000, 'ºC'),
	(339109, 144, '2015-02-01 00:15:01.000000', 'temperatura', 985.0000, 'ºC'),
	(339110, 144, '2015-02-01 00:15:02.000000', 'temperatura', 177.0000, 'ºC'),
	(339111, 144, '2015-02-01 00:15:03.000000', 'temperatura', 333.0000, 'ºC'),
	(339112, 144, '2015-02-01 00:15:04.000000', 'temperatura', 1132.0000, 'ºC'),
	(339113, 144, '2015-02-01 00:15:05.000000', 'temperatura', 1063.0000, 'ºC'),
	(339114, 144, '2015-02-01 00:15:06.000000', 'temperatura', 721.0000, 'ºC'),
	(339115, 144, '2015-02-01 00:15:07.000000', 'temperatura', 415.0000, 'ºC'),
	(339116, 144, '2015-02-01 00:15:08.000000', 'temperatura', 1113.0000, 'ºC'),
	(339117, 144, '2015-02-01 00:15:09.000000', 'temperatura', 719.0000, 'ºC'),
	(339118, 144, '2015-02-01 00:15:10.000000', 'temperatura', 259.0000, 'ºC'),
	(339119, 144, '2015-02-01 00:15:11.000000', 'temperatura', 336.0000, 'ºC'),
	(339120, 144, '2015-02-01 00:15:12.000000', 'temperatura', 902.0000, 'ºC'),
	(339121, 144, '2015-02-01 00:15:13.000000', 'temperatura', 1106.0000, 'ºC'),
	(339122, 144, '2015-02-01 00:15:14.000000', 'temperatura', 424.0000, 'ºC'),
	(339123, 144, '2015-02-01 00:15:15.000000', 'temperatura', 1.0000, 'ºC'),
	(339124, 144, '2015-02-01 00:15:16.000000', 'temperatura', 1133.0000, 'ºC'),
	(339125, 144, '2015-02-01 00:15:17.000000', 'temperatura', 862.0000, 'ºC'),
	(339126, 144, '2015-02-01 00:15:18.000000', 'temperatura', 912.0000, 'ºC'),
	(339127, 144, '2015-02-01 00:15:19.000000', 'temperatura', 776.0000, 'ºC'),
	(339128, 144, '2015-02-01 00:15:20.000000', 'temperatura', 1144.0000, 'ºC'),
	(339129, 144, '2015-02-01 00:15:21.000000', 'temperatura', 994.0000, 'ºC'),
	(339130, 144, '2015-02-01 00:15:22.000000', 'temperatura', 336.0000, 'ºC'),
	(339131, 144, '2015-02-01 00:15:23.000000', 'temperatura', 1101.0000, 'ºC'),
	(339132, 144, '2015-02-01 00:15:24.000000', 'temperatura', 896.0000, 'ºC'),
	(339133, 144, '2015-02-01 00:15:25.000000', 'temperatura', 1178.0000, 'ºC'),
	(339134, 144, '2015-02-01 00:15:26.000000', 'temperatura', 800.0000, 'ºC'),
	(339135, 144, '2015-02-01 00:15:27.000000', 'temperatura', 470.0000, 'ºC'),
	(339136, 144, '2015-02-01 00:15:28.000000', 'temperatura', 1150.0000, 'ºC'),
	(339137, 144, '2015-02-01 00:15:29.000000', 'temperatura', 741.0000, 'ºC'),
	(339138, 144, '2015-02-01 00:15:30.000000', 'temperatura', 254.0000, 'ºC'),
	(339139, 144, '2015-02-01 00:15:31.000000', 'temperatura', 247.0000, 'ºC'),
	(339140, 144, '2015-02-01 00:15:32.000000', 'temperatura', 472.0000, 'ºC'),
	(339141, 144, '2015-02-01 00:15:33.000000', 'temperatura', 423.0000, 'ºC'),
	(339142, 144, '2015-02-01 00:15:34.000000', 'temperatura', 697.0000, 'ºC'),
	(339143, 144, '2015-02-01 00:15:35.000000', 'temperatura', 1018.0000, 'ºC'),
	(339144, 144, '2015-02-01 00:15:36.000000', 'temperatura', 599.0000, 'ºC'),
	(339145, 144, '2015-02-01 00:15:37.000000', 'temperatura', 1141.0000, 'ºC'),
	(339146, 144, '2015-02-01 00:15:38.000000', 'temperatura', 307.0000, 'ºC'),
	(339147, 144, '2015-02-01 00:15:39.000000', 'temperatura', 515.0000, 'ºC'),
	(339148, 144, '2015-02-01 00:15:40.000000', 'temperatura', 454.0000, 'ºC'),
	(339149, 144, '2015-02-01 00:15:41.000000', 'temperatura', 726.0000, 'ºC'),
	(339150, 144, '2015-02-01 00:15:42.000000', 'temperatura', 1070.0000, 'ºC'),
	(339151, 144, '2015-02-01 00:15:43.000000', 'temperatura', 771.0000, 'ºC'),
	(339152, 144, '2015-02-01 00:15:44.000000', 'temperatura', 644.0000, 'ºC'),
	(339153, 144, '2015-02-01 00:15:45.000000', 'temperatura', 909.0000, 'ºC'),
	(339154, 144, '2015-02-01 00:15:46.000000', 'temperatura', 215.0000, 'ºC'),
	(339155, 144, '2015-02-01 00:15:47.000000', 'temperatura', 749.0000, 'ºC'),
	(339156, 144, '2015-02-01 00:15:48.000000', 'temperatura', 698.0000, 'ºC'),
	(339157, 144, '2015-02-01 00:15:49.000000', 'temperatura', 43.0000, 'ºC'),
	(339158, 144, '2015-02-01 00:15:50.000000', 'temperatura', 523.0000, 'ºC'),
	(339159, 144, '2015-02-01 00:15:51.000000', 'temperatura', 85.0000, 'ºC'),
	(339160, 144, '2015-02-01 00:15:52.000000', 'temperatura', 57.0000, 'ºC'),
	(339161, 144, '2015-02-01 00:15:53.000000', 'temperatura', 30.0000, 'ºC'),
	(339162, 144, '2015-02-01 00:15:54.000000', 'temperatura', 1182.0000, 'ºC'),
	(339163, 144, '2015-02-01 00:15:55.000000', 'temperatura', 1020.0000, 'ºC'),
	(339164, 144, '2015-02-01 00:15:56.000000', 'temperatura', 352.0000, 'ºC'),
	(339165, 144, '2015-02-01 00:15:57.000000', 'temperatura', 1103.0000, 'ºC'),
	(339166, 144, '2015-02-01 00:15:58.000000', 'temperatura', 860.0000, 'ºC'),
	(339167, 144, '2015-02-01 00:15:59.000000', 'temperatura', 992.0000, 'ºC'),
	(339168, 144, '2015-02-01 00:16:00.000000', 'temperatura', 1178.0000, 'ºC'),
	(339169, 144, '2015-02-01 00:16:01.000000', 'temperatura', 514.0000, 'ºC'),
	(339170, 144, '2015-02-01 00:16:02.000000', 'temperatura', 236.0000, 'ºC'),
	(339171, 144, '2015-02-01 00:16:03.000000', 'temperatura', 841.0000, 'ºC'),
	(339172, 144, '2015-02-01 00:16:04.000000', 'temperatura', 1098.0000, 'ºC'),
	(339173, 144, '2015-02-01 00:16:05.000000', 'temperatura', 568.0000, 'ºC'),
	(339174, 144, '2015-02-01 00:16:06.000000', 'temperatura', 747.0000, 'ºC'),
	(339175, 144, '2015-02-01 00:16:07.000000', 'temperatura', 829.0000, 'ºC'),
	(339176, 144, '2015-02-01 00:16:08.000000', 'temperatura', 708.0000, 'ºC'),
	(339177, 144, '2015-02-01 00:16:09.000000', 'temperatura', 1050.0000, 'ºC'),
	(339178, 144, '2015-02-01 00:16:10.000000', 'temperatura', 726.0000, 'ºC'),
	(339179, 144, '2015-02-01 00:16:11.000000', 'temperatura', 482.0000, 'ºC'),
	(339180, 144, '2015-02-01 00:16:12.000000', 'temperatura', 232.0000, 'ºC'),
	(339181, 144, '2015-02-01 00:16:13.000000', 'temperatura', 916.0000, 'ºC'),
	(339182, 144, '2015-02-01 00:16:14.000000', 'temperatura', 284.0000, 'ºC'),
	(339183, 144, '2015-02-01 00:16:15.000000', 'temperatura', 1073.0000, 'ºC'),
	(339184, 144, '2015-02-01 00:16:16.000000', 'temperatura', 914.0000, 'ºC'),
	(339185, 144, '2015-02-01 00:16:17.000000', 'temperatura', 153.0000, 'ºC'),
	(339186, 144, '2015-02-01 00:16:18.000000', 'temperatura', 420.0000, 'ºC'),
	(339187, 144, '2015-02-01 00:16:19.000000', 'temperatura', 444.0000, 'ºC'),
	(339188, 144, '2015-02-01 00:16:20.000000', 'temperatura', 960.0000, 'ºC'),
	(339189, 144, '2015-02-01 00:16:21.000000', 'temperatura', 1069.0000, 'ºC'),
	(339190, 144, '2015-02-01 00:16:22.000000', 'temperatura', 65.0000, 'ºC'),
	(339191, 144, '2015-02-01 00:16:23.000000', 'temperatura', 717.0000, 'ºC'),
	(339192, 144, '2015-02-01 00:16:24.000000', 'temperatura', 989.0000, 'ºC'),
	(339193, 144, '2015-02-01 00:16:25.000000', 'temperatura', 398.0000, 'ºC'),
	(339194, 144, '2015-02-01 00:16:26.000000', 'temperatura', 222.0000, 'ºC'),
	(339195, 144, '2015-02-01 00:16:27.000000', 'temperatura', 1118.0000, 'ºC'),
	(339196, 144, '2015-02-01 00:16:28.000000', 'temperatura', 126.0000, 'ºC'),
	(339197, 144, '2015-02-01 00:16:29.000000', 'temperatura', 873.0000, 'ºC'),
	(339198, 144, '2015-02-01 00:16:30.000000', 'temperatura', 390.0000, 'ºC'),
	(339199, 144, '2015-02-01 00:16:31.000000', 'temperatura', 532.0000, 'ºC'),
	(339200, 144, '2015-02-01 00:16:32.000000', 'temperatura', 288.0000, 'ºC'),
	(339201, 144, '2015-02-01 00:16:33.000000', 'temperatura', 1046.0000, 'ºC'),
	(339202, 144, '2015-02-01 00:16:34.000000', 'temperatura', 767.0000, 'ºC'),
	(339203, 144, '2015-02-01 00:16:35.000000', 'temperatura', 696.0000, 'ºC'),
	(339204, 144, '2015-02-01 00:16:36.000000', 'temperatura', 1181.0000, 'ºC'),
	(339205, 144, '2015-02-01 00:16:37.000000', 'temperatura', 217.0000, 'ºC'),
	(339206, 144, '2015-02-01 00:16:38.000000', 'temperatura', 1142.0000, 'ºC'),
	(339207, 144, '2015-02-01 00:16:39.000000', 'temperatura', 261.0000, 'ºC'),
	(339208, 144, '2015-02-01 00:16:40.000000', 'temperatura', 278.0000, 'ºC'),
	(339209, 144, '2015-02-01 00:16:41.000000', 'temperatura', 608.0000, 'ºC'),
	(339210, 144, '2015-02-01 00:16:42.000000', 'temperatura', 1005.0000, 'ºC'),
	(339211, 144, '2015-02-01 00:16:43.000000', 'temperatura', 803.0000, 'ºC'),
	(339212, 144, '2015-02-01 00:16:44.000000', 'temperatura', 999.0000, 'ºC'),
	(339213, 144, '2015-02-01 00:16:45.000000', 'temperatura', 188.0000, 'ºC'),
	(339214, 144, '2015-02-01 00:16:46.000000', 'temperatura', 344.0000, 'ºC'),
	(339215, 144, '2015-02-01 00:16:47.000000', 'temperatura', 1155.0000, 'ºC'),
	(339216, 144, '2015-02-01 00:16:48.000000', 'temperatura', 1143.0000, 'ºC'),
	(339217, 144, '2015-02-01 00:16:49.000000', 'temperatura', 1050.0000, 'ºC'),
	(339218, 144, '2015-02-01 00:16:50.000000', 'temperatura', 622.0000, 'ºC'),
	(339219, 144, '2015-02-01 00:16:51.000000', 'temperatura', 1162.0000, 'ºC'),
	(339220, 144, '2015-02-01 00:16:52.000000', 'temperatura', 343.0000, 'ºC'),
	(339221, 144, '2015-02-01 00:16:53.000000', 'temperatura', 630.0000, 'ºC'),
	(339222, 144, '2015-02-01 00:16:54.000000', 'temperatura', 922.0000, 'ºC'),
	(339223, 144, '2015-02-01 00:16:55.000000', 'temperatura', 320.0000, 'ºC'),
	(339224, 144, '2015-02-01 00:16:56.000000', 'temperatura', 33.0000, 'ºC'),
	(339225, 144, '2015-02-01 00:16:57.000000', 'temperatura', 408.0000, 'ºC'),
	(339226, 144, '2015-02-01 00:16:58.000000', 'temperatura', 743.0000, 'ºC'),
	(339227, 144, '2015-02-01 00:16:59.000000', 'temperatura', 88.0000, 'ºC'),
	(339228, 144, '2015-02-01 00:17:00.000000', 'temperatura', 613.0000, 'ºC'),
	(339229, 144, '2015-02-01 00:17:01.000000', 'temperatura', 403.0000, 'ºC'),
	(339230, 144, '2015-02-01 00:17:02.000000', 'temperatura', 177.0000, 'ºC'),
	(339231, 144, '2015-02-01 00:17:03.000000', 'temperatura', 876.0000, 'ºC'),
	(339232, 144, '2015-02-01 00:17:04.000000', 'temperatura', 249.0000, 'ºC'),
	(339233, 144, '2015-02-01 00:17:05.000000', 'temperatura', 1018.0000, 'ºC'),
	(339234, 144, '2015-02-01 00:17:06.000000', 'temperatura', 741.0000, 'ºC'),
	(339235, 144, '2015-02-01 00:17:07.000000', 'temperatura', 655.0000, 'ºC'),
	(339236, 144, '2015-02-01 00:17:08.000000', 'temperatura', 1049.0000, 'ºC'),
	(339237, 144, '2015-02-01 00:17:09.000000', 'temperatura', 884.0000, 'ºC'),
	(339238, 144, '2015-02-01 00:17:10.000000', 'temperatura', 72.0000, 'ºC'),
	(339239, 144, '2015-02-01 00:17:11.000000', 'temperatura', 109.0000, 'ºC'),
	(339240, 144, '2015-02-01 00:17:12.000000', 'temperatura', 327.0000, 'ºC'),
	(339241, 144, '2015-02-01 00:17:13.000000', 'temperatura', 110.0000, 'ºC'),
	(339242, 144, '2015-02-01 00:17:14.000000', 'temperatura', 772.0000, 'ºC'),
	(339243, 144, '2015-02-01 00:17:15.000000', 'temperatura', 1127.0000, 'ºC'),
	(339244, 144, '2015-02-01 00:17:16.000000', 'temperatura', 921.0000, 'ºC'),
	(339245, 144, '2015-02-01 00:17:17.000000', 'temperatura', 26.0000, 'ºC'),
	(339246, 144, '2015-02-01 00:17:18.000000', 'temperatura', 967.0000, 'ºC'),
	(339247, 144, '2015-02-01 00:17:19.000000', 'temperatura', 1156.0000, 'ºC'),
	(339248, 144, '2015-02-01 00:17:20.000000', 'temperatura', 480.0000, 'ºC'),
	(339249, 144, '2015-02-01 00:17:21.000000', 'temperatura', 134.0000, 'ºC'),
	(339250, 144, '2015-02-01 00:17:22.000000', 'temperatura', 431.0000, 'ºC'),
	(339251, 144, '2015-02-01 00:17:23.000000', 'temperatura', 553.0000, 'ºC'),
	(339252, 144, '2015-02-01 00:17:24.000000', 'temperatura', 272.0000, 'ºC'),
	(339253, 144, '2015-02-01 00:17:25.000000', 'temperatura', 900.0000, 'ºC'),
	(339254, 144, '2015-02-01 00:17:26.000000', 'temperatura', 87.0000, 'ºC'),
	(339255, 144, '2015-02-01 00:17:27.000000', 'temperatura', 136.0000, 'ºC'),
	(339256, 144, '2015-02-01 00:17:28.000000', 'temperatura', 420.0000, 'ºC'),
	(339257, 144, '2015-02-01 00:17:29.000000', 'temperatura', 491.0000, 'ºC'),
	(339258, 144, '2015-02-01 00:17:30.000000', 'temperatura', 1195.0000, 'ºC'),
	(339259, 144, '2015-02-01 00:17:31.000000', 'temperatura', 904.0000, 'ºC'),
	(339260, 144, '2015-02-01 00:17:32.000000', 'temperatura', 936.0000, 'ºC'),
	(339261, 144, '2015-02-01 00:17:33.000000', 'temperatura', 767.0000, 'ºC'),
	(339262, 144, '2015-02-01 00:17:34.000000', 'temperatura', 1030.0000, 'ºC'),
	(339263, 144, '2015-02-01 00:17:35.000000', 'temperatura', 447.0000, 'ºC'),
	(339264, 144, '2015-02-01 00:17:36.000000', 'temperatura', 344.0000, 'ºC'),
	(339265, 144, '2015-02-01 00:17:37.000000', 'temperatura', 382.0000, 'ºC'),
	(339266, 144, '2015-02-01 00:17:38.000000', 'temperatura', 879.0000, 'ºC'),
	(339267, 144, '2015-02-01 00:17:39.000000', 'temperatura', 849.0000, 'ºC'),
	(339268, 144, '2015-02-01 00:17:40.000000', 'temperatura', 409.0000, 'ºC'),
	(339269, 144, '2015-02-01 00:17:41.000000', 'temperatura', 699.0000, 'ºC'),
	(339270, 144, '2015-02-01 00:17:42.000000', 'temperatura', 1069.0000, 'ºC'),
	(339271, 144, '2015-02-01 00:17:43.000000', 'temperatura', 850.0000, 'ºC'),
	(339272, 144, '2015-02-01 00:17:44.000000', 'temperatura', 1040.0000, 'ºC'),
	(339273, 144, '2015-02-01 00:17:45.000000', 'temperatura', 253.0000, 'ºC'),
	(339274, 144, '2015-02-01 00:17:46.000000', 'temperatura', 544.0000, 'ºC'),
	(339275, 144, '2015-02-01 00:17:47.000000', 'temperatura', 761.0000, 'ºC'),
	(339276, 144, '2015-02-01 00:17:48.000000', 'temperatura', 974.0000, 'ºC'),
	(339277, 144, '2015-02-01 00:17:49.000000', 'temperatura', 189.0000, 'ºC'),
	(339278, 144, '2015-02-01 00:17:50.000000', 'temperatura', 424.0000, 'ºC'),
	(339279, 144, '2015-02-01 00:17:51.000000', 'temperatura', 351.0000, 'ºC'),
	(339280, 144, '2015-02-01 00:17:52.000000', 'temperatura', 484.0000, 'ºC'),
	(339281, 144, '2015-02-01 00:17:53.000000', 'temperatura', 170.0000, 'ºC'),
	(339282, 144, '2015-02-01 00:17:54.000000', 'temperatura', 596.0000, 'ºC'),
	(339283, 144, '2015-02-01 00:17:55.000000', 'temperatura', 71.0000, 'ºC'),
	(339284, 144, '2015-02-01 00:17:56.000000', 'temperatura', 966.0000, 'ºC'),
	(339285, 144, '2015-02-01 00:17:57.000000', 'temperatura', 1020.0000, 'ºC'),
	(339286, 144, '2015-02-01 00:17:58.000000', 'temperatura', 1001.0000, 'ºC'),
	(339287, 144, '2015-02-01 00:17:59.000000', 'temperatura', 747.0000, 'ºC'),
	(339288, 144, '2015-02-01 00:18:00.000000', 'temperatura', 730.0000, 'ºC'),
	(339289, 144, '2015-02-01 00:18:01.000000', 'temperatura', 212.0000, 'ºC'),
	(339290, 144, '2015-02-01 00:18:02.000000', 'temperatura', 70.0000, 'ºC'),
	(339291, 144, '2015-02-01 00:18:03.000000', 'temperatura', 915.0000, 'ºC'),
	(339292, 144, '2015-02-01 00:18:04.000000', 'temperatura', 765.0000, 'ºC'),
	(339293, 144, '2015-02-01 00:18:05.000000', 'temperatura', 1082.0000, 'ºC'),
	(339294, 144, '2015-02-01 00:18:06.000000', 'temperatura', 715.0000, 'ºC'),
	(339295, 144, '2015-02-01 00:18:07.000000', 'temperatura', 331.0000, 'ºC'),
	(339296, 144, '2015-02-01 00:18:08.000000', 'temperatura', 708.0000, 'ºC'),
	(339297, 144, '2015-02-01 00:18:09.000000', 'temperatura', 149.0000, 'ºC'),
	(339298, 144, '2015-02-01 00:18:10.000000', 'temperatura', 1021.0000, 'ºC'),
	(339299, 144, '2015-02-01 00:18:11.000000', 'temperatura', 1059.0000, 'ºC'),
	(339300, 144, '2015-02-01 00:18:12.000000', 'temperatura', 1033.0000, 'ºC'),
	(339301, 144, '2015-02-01 00:18:13.000000', 'temperatura', 789.0000, 'ºC'),
	(339302, 144, '2015-02-01 00:18:14.000000', 'temperatura', 847.0000, 'ºC'),
	(339303, 144, '2015-02-01 00:18:15.000000', 'temperatura', 669.0000, 'ºC'),
	(339304, 144, '2015-02-01 00:18:16.000000', 'temperatura', 804.0000, 'ºC'),
	(339305, 144, '2015-02-01 00:18:17.000000', 'temperatura', 815.0000, 'ºC'),
	(339306, 144, '2015-02-01 00:18:18.000000', 'temperatura', 463.0000, 'ºC'),
	(339307, 144, '2015-02-01 00:18:19.000000', 'temperatura', 1068.0000, 'ºC'),
	(339308, 144, '2015-02-01 00:18:20.000000', 'temperatura', 353.0000, 'ºC'),
	(339309, 144, '2015-02-01 00:18:21.000000', 'temperatura', 960.0000, 'ºC'),
	(339310, 144, '2015-02-01 00:18:22.000000', 'temperatura', 141.0000, 'ºC'),
	(339311, 144, '2015-02-01 00:18:23.000000', 'temperatura', 225.0000, 'ºC'),
	(339312, 144, '2015-02-01 00:18:24.000000', 'temperatura', 704.0000, 'ºC'),
	(339313, 144, '2015-02-01 00:18:25.000000', 'temperatura', 445.0000, 'ºC'),
	(339314, 144, '2015-02-01 00:18:26.000000', 'temperatura', 115.0000, 'ºC'),
	(339315, 144, '2015-02-01 00:18:27.000000', 'temperatura', 440.0000, 'ºC'),
	(339316, 144, '2015-02-01 00:18:28.000000', 'temperatura', 654.0000, 'ºC'),
	(339317, 144, '2015-02-01 00:18:29.000000', 'temperatura', 751.0000, 'ºC'),
	(339318, 144, '2015-02-01 00:18:30.000000', 'temperatura', 595.0000, 'ºC'),
	(339319, 144, '2015-02-01 00:18:31.000000', 'temperatura', 724.0000, 'ºC'),
	(339320, 144, '2015-02-01 00:18:32.000000', 'temperatura', 632.0000, 'ºC'),
	(339321, 144, '2015-02-01 00:18:33.000000', 'temperatura', 991.0000, 'ºC'),
	(339322, 144, '2015-02-01 00:18:34.000000', 'temperatura', 660.0000, 'ºC'),
	(339323, 144, '2015-02-01 00:18:35.000000', 'temperatura', 326.0000, 'ºC'),
	(339324, 144, '2015-02-01 00:18:36.000000', 'temperatura', 849.0000, 'ºC'),
	(339325, 144, '2015-02-01 00:18:37.000000', 'temperatura', 869.0000, 'ºC'),
	(339326, 144, '2015-02-01 00:18:38.000000', 'temperatura', 598.0000, 'ºC'),
	(339327, 144, '2015-02-01 00:18:39.000000', 'temperatura', 384.0000, 'ºC'),
	(339328, 144, '2015-02-01 00:18:40.000000', 'temperatura', 126.0000, 'ºC'),
	(339329, 144, '2015-02-01 00:18:41.000000', 'temperatura', 677.0000, 'ºC'),
	(339330, 144, '2015-02-01 00:18:42.000000', 'temperatura', 608.0000, 'ºC'),
	(339331, 144, '2015-02-01 00:18:43.000000', 'temperatura', 1012.0000, 'ºC'),
	(339332, 144, '2015-02-01 00:18:44.000000', 'temperatura', 834.0000, 'ºC'),
	(339333, 144, '2015-02-01 00:18:45.000000', 'temperatura', 1134.0000, 'ºC'),
	(339334, 144, '2015-02-01 00:18:46.000000', 'temperatura', 768.0000, 'ºC'),
	(339335, 144, '2015-02-01 00:18:47.000000', 'temperatura', 437.0000, 'ºC'),
	(339336, 144, '2015-02-01 00:18:48.000000', 'temperatura', 1085.0000, 'ºC'),
	(339337, 144, '2015-02-01 00:18:49.000000', 'temperatura', 514.0000, 'ºC'),
	(339338, 144, '2015-02-01 00:18:50.000000', 'temperatura', 517.0000, 'ºC'),
	(339339, 144, '2015-02-01 00:18:51.000000', 'temperatura', 1041.0000, 'ºC'),
	(339340, 144, '2015-02-01 00:18:52.000000', 'temperatura', 54.0000, 'ºC'),
	(339341, 144, '2015-02-01 00:18:53.000000', 'temperatura', 746.0000, 'ºC'),
	(339342, 144, '2015-02-01 00:18:54.000000', 'temperatura', 1172.0000, 'ºC'),
	(339343, 144, '2015-02-01 00:18:55.000000', 'temperatura', 20.0000, 'ºC'),
	(339344, 144, '2015-02-01 00:18:56.000000', 'temperatura', 186.0000, 'ºC'),
	(339345, 144, '2015-02-01 00:18:57.000000', 'temperatura', 871.0000, 'ºC'),
	(339346, 144, '2015-02-01 00:18:58.000000', 'temperatura', 196.0000, 'ºC'),
	(339347, 144, '2015-02-01 00:18:59.000000', 'temperatura', 768.0000, 'ºC'),
	(339348, 144, '2015-02-01 00:19:00.000000', 'temperatura', 850.0000, 'ºC'),
	(339349, 144, '2015-02-01 00:19:01.000000', 'temperatura', 750.0000, 'ºC'),
	(339350, 144, '2015-02-01 00:19:02.000000', 'temperatura', 0.0000, 'ºC'),
	(339351, 144, '2015-02-01 00:19:03.000000', 'temperatura', 152.0000, 'ºC'),
	(339352, 144, '2015-02-01 00:19:04.000000', 'temperatura', 759.0000, 'ºC'),
	(339353, 144, '2015-02-01 00:19:05.000000', 'temperatura', 939.0000, 'ºC'),
	(339354, 144, '2015-02-01 00:19:06.000000', 'temperatura', 19.0000, 'ºC'),
	(339355, 144, '2015-02-01 00:19:07.000000', 'temperatura', 877.0000, 'ºC'),
	(339356, 144, '2015-02-01 00:19:08.000000', 'temperatura', 731.0000, 'ºC'),
	(339357, 144, '2015-02-01 00:19:09.000000', 'temperatura', 1024.0000, 'ºC'),
	(339358, 144, '2015-02-01 00:19:10.000000', 'temperatura', 529.0000, 'ºC'),
	(339359, 144, '2015-02-01 00:19:11.000000', 'temperatura', 771.0000, 'ºC'),
	(339360, 144, '2015-02-01 00:19:12.000000', 'temperatura', 1071.0000, 'ºC'),
	(339361, 144, '2015-02-01 00:19:13.000000', 'temperatura', 641.0000, 'ºC'),
	(339362, 144, '2015-02-01 00:19:14.000000', 'temperatura', 1193.0000, 'ºC'),
	(339363, 144, '2015-02-01 00:19:15.000000', 'temperatura', 441.0000, 'ºC'),
	(339364, 144, '2015-02-01 00:19:16.000000', 'temperatura', 1027.0000, 'ºC'),
	(339365, 144, '2015-02-01 00:19:17.000000', 'temperatura', 211.0000, 'ºC'),
	(339366, 144, '2015-02-01 00:19:18.000000', 'temperatura', 378.0000, 'ºC'),
	(339367, 144, '2015-02-01 00:19:19.000000', 'temperatura', 54.0000, 'ºC'),
	(339368, 144, '2015-02-01 00:19:20.000000', 'temperatura', 337.0000, 'ºC'),
	(339369, 144, '2015-02-01 00:19:21.000000', 'temperatura', 326.0000, 'ºC'),
	(339370, 144, '2015-02-01 00:19:22.000000', 'temperatura', 618.0000, 'ºC'),
	(339371, 144, '2015-02-01 00:19:23.000000', 'temperatura', 915.0000, 'ºC'),
	(339372, 144, '2015-02-01 00:19:24.000000', 'temperatura', 318.0000, 'ºC'),
	(339373, 144, '2015-02-01 00:19:25.000000', 'temperatura', 46.0000, 'ºC'),
	(339374, 144, '2015-02-01 00:19:26.000000', 'temperatura', 478.0000, 'ºC'),
	(339375, 144, '2015-02-01 00:19:27.000000', 'temperatura', 1050.0000, 'ºC'),
	(339376, 144, '2015-02-01 00:19:28.000000', 'temperatura', 217.0000, 'ºC'),
	(339377, 144, '2015-02-01 00:19:29.000000', 'temperatura', 337.0000, 'ºC'),
	(339378, 144, '2015-02-01 00:19:30.000000', 'temperatura', 1035.0000, 'ºC'),
	(339379, 144, '2015-02-01 00:19:31.000000', 'temperatura', 566.0000, 'ºC'),
	(339380, 144, '2015-02-01 00:19:32.000000', 'temperatura', 922.0000, 'ºC'),
	(339381, 144, '2015-02-01 00:19:33.000000', 'temperatura', 516.0000, 'ºC'),
	(339382, 144, '2015-02-01 00:19:34.000000', 'temperatura', 1012.0000, 'ºC'),
	(339383, 144, '2015-02-01 00:19:35.000000', 'temperatura', 1113.0000, 'ºC'),
	(339384, 144, '2015-02-01 00:19:36.000000', 'temperatura', 132.0000, 'ºC'),
	(339385, 144, '2015-02-01 00:19:37.000000', 'temperatura', 919.0000, 'ºC'),
	(339386, 144, '2015-02-01 00:19:38.000000', 'temperatura', 598.0000, 'ºC'),
	(339387, 144, '2015-02-01 00:19:39.000000', 'temperatura', 237.0000, 'ºC'),
	(339388, 144, '2015-02-01 00:19:40.000000', 'temperatura', 589.0000, 'ºC'),
	(339389, 144, '2015-02-01 00:19:41.000000', 'temperatura', 1033.0000, 'ºC'),
	(339390, 144, '2015-02-01 00:19:42.000000', 'temperatura', 1002.0000, 'ºC'),
	(339391, 144, '2015-02-01 00:19:43.000000', 'temperatura', 711.0000, 'ºC'),
	(339392, 144, '2015-02-01 00:19:44.000000', 'temperatura', 548.0000, 'ºC'),
	(339393, 144, '2015-02-01 00:19:45.000000', 'temperatura', 609.0000, 'ºC'),
	(339394, 144, '2015-02-01 00:19:46.000000', 'temperatura', 202.0000, 'ºC'),
	(339395, 144, '2015-02-01 00:19:47.000000', 'temperatura', 383.0000, 'ºC'),
	(339396, 144, '2015-02-01 00:19:48.000000', 'temperatura', 108.0000, 'ºC'),
	(339397, 144, '2015-02-01 00:19:49.000000', 'temperatura', 592.0000, 'ºC'),
	(339398, 144, '2015-02-01 00:19:50.000000', 'temperatura', 238.0000, 'ºC'),
	(339399, 144, '2015-02-01 00:19:51.000000', 'temperatura', 613.0000, 'ºC'),
	(339400, 144, '2015-02-01 00:19:52.000000', 'temperatura', 1151.0000, 'ºC'),
	(339401, 144, '2015-02-01 00:19:53.000000', 'temperatura', 318.0000, 'ºC'),
	(339402, 144, '2015-02-01 00:19:54.000000', 'temperatura', 536.0000, 'ºC'),
	(339403, 144, '2015-02-01 00:19:55.000000', 'temperatura', 526.0000, 'ºC'),
	(339404, 144, '2015-02-01 00:19:56.000000', 'temperatura', 1025.0000, 'ºC'),
	(339405, 144, '2015-02-01 00:19:57.000000', 'temperatura', 1146.0000, 'ºC'),
	(339406, 144, '2015-02-01 00:19:58.000000', 'temperatura', 255.0000, 'ºC'),
	(339407, 144, '2015-02-01 00:19:59.000000', 'temperatura', 237.0000, 'ºC'),
	(339408, 144, '2015-02-01 00:20:00.000000', 'temperatura', 422.0000, 'ºC'),
	(339409, 144, '2015-02-01 00:20:01.000000', 'temperatura', 199.0000, 'ºC'),
	(339410, 144, '2015-02-01 00:20:02.000000', 'temperatura', 929.0000, 'ºC'),
	(339411, 144, '2015-02-01 00:20:03.000000', 'temperatura', 450.0000, 'ºC'),
	(339412, 144, '2015-02-01 00:20:04.000000', 'temperatura', 663.0000, 'ºC'),
	(339413, 144, '2015-02-01 00:20:05.000000', 'temperatura', 764.0000, 'ºC'),
	(339414, 144, '2015-02-01 00:20:06.000000', 'temperatura', 632.0000, 'ºC'),
	(339415, 144, '2015-02-01 00:20:07.000000', 'temperatura', 869.0000, 'ºC'),
	(339416, 144, '2015-02-01 00:20:08.000000', 'temperatura', 49.0000, 'ºC'),
	(339417, 144, '2015-02-01 00:20:09.000000', 'temperatura', 37.0000, 'ºC'),
	(339418, 144, '2015-02-01 00:20:10.000000', 'temperatura', 39.0000, 'ºC'),
	(339419, 144, '2015-02-01 00:20:11.000000', 'temperatura', 87.0000, 'ºC'),
	(339420, 144, '2015-02-01 00:20:12.000000', 'temperatura', 317.0000, 'ºC'),
	(339421, 144, '2015-02-01 00:20:13.000000', 'temperatura', 123.0000, 'ºC'),
	(339422, 144, '2015-02-01 00:20:14.000000', 'temperatura', 866.0000, 'ºC'),
	(339423, 144, '2015-02-01 00:20:15.000000', 'temperatura', 361.0000, 'ºC'),
	(339424, 144, '2015-02-01 00:20:16.000000', 'temperatura', 409.0000, 'ºC'),
	(339425, 144, '2015-02-01 00:20:17.000000', 'temperatura', 961.0000, 'ºC'),
	(339426, 144, '2015-02-01 00:20:18.000000', 'temperatura', 1178.0000, 'ºC'),
	(339427, 144, '2015-02-01 00:20:19.000000', 'temperatura', 606.0000, 'ºC'),
	(339428, 144, '2015-02-01 00:20:20.000000', 'temperatura', 699.0000, 'ºC'),
	(339429, 144, '2015-02-01 00:20:21.000000', 'temperatura', 476.0000, 'ºC'),
	(339430, 144, '2015-02-01 00:20:22.000000', 'temperatura', 282.0000, 'ºC'),
	(339431, 144, '2015-02-01 00:20:23.000000', 'temperatura', 1185.0000, 'ºC'),
	(339432, 144, '2015-02-01 00:20:24.000000', 'temperatura', 279.0000, 'ºC'),
	(339433, 144, '2015-02-01 00:20:25.000000', 'temperatura', 239.0000, 'ºC'),
	(339434, 144, '2015-02-01 00:20:26.000000', 'temperatura', 361.0000, 'ºC'),
	(339435, 144, '2015-02-01 00:20:27.000000', 'temperatura', 1089.0000, 'ºC'),
	(339436, 144, '2015-02-01 00:20:28.000000', 'temperatura', 763.0000, 'ºC'),
	(339437, 144, '2015-02-01 00:20:29.000000', 'temperatura', 549.0000, 'ºC'),
	(339438, 144, '2015-02-01 00:20:30.000000', 'temperatura', 455.0000, 'ºC'),
	(339439, 144, '2015-02-01 00:20:31.000000', 'temperatura', 628.0000, 'ºC'),
	(339440, 144, '2015-02-01 00:20:32.000000', 'temperatura', 577.0000, 'ºC'),
	(339441, 144, '2015-02-01 00:20:33.000000', 'temperatura', 1001.0000, 'ºC'),
	(339442, 144, '2015-02-01 00:20:34.000000', 'temperatura', 876.0000, 'ºC'),
	(339443, 144, '2015-02-01 00:20:35.000000', 'temperatura', 178.0000, 'ºC'),
	(339444, 144, '2015-02-01 00:20:36.000000', 'temperatura', 663.0000, 'ºC'),
	(339445, 144, '2015-02-01 00:20:37.000000', 'temperatura', 381.0000, 'ºC'),
	(339446, 144, '2015-02-01 00:20:38.000000', 'temperatura', 1115.0000, 'ºC'),
	(339447, 144, '2015-02-01 00:20:39.000000', 'temperatura', 834.0000, 'ºC'),
	(339448, 144, '2015-02-01 00:20:40.000000', 'temperatura', 824.0000, 'ºC'),
	(339449, 144, '2015-02-01 00:20:41.000000', 'temperatura', 418.0000, 'ºC'),
	(339450, 144, '2015-02-01 00:20:42.000000', 'temperatura', 820.0000, 'ºC'),
	(339451, 144, '2015-02-01 00:20:43.000000', 'temperatura', 445.0000, 'ºC'),
	(339452, 144, '2015-02-01 00:20:44.000000', 'temperatura', 965.0000, 'ºC'),
	(339453, 144, '2015-02-01 00:20:45.000000', 'temperatura', 1093.0000, 'ºC'),
	(339454, 144, '2015-02-01 00:20:46.000000', 'temperatura', 171.0000, 'ºC'),
	(339455, 144, '2015-02-01 00:20:47.000000', 'temperatura', 1176.0000, 'ºC'),
	(339456, 144, '2015-02-01 00:20:48.000000', 'temperatura', 569.0000, 'ºC'),
	(339457, 144, '2015-02-01 00:20:49.000000', 'temperatura', 514.0000, 'ºC'),
	(339458, 144, '2015-02-01 00:20:50.000000', 'temperatura', 865.0000, 'ºC'),
	(339459, 144, '2015-02-01 00:20:51.000000', 'temperatura', 385.0000, 'ºC'),
	(339460, 144, '2015-02-01 00:20:52.000000', 'temperatura', 531.0000, 'ºC'),
	(339461, 144, '2015-02-01 00:20:53.000000', 'temperatura', 301.0000, 'ºC'),
	(339462, 144, '2015-02-01 00:20:54.000000', 'temperatura', 1110.0000, 'ºC'),
	(339463, 144, '2015-02-01 00:20:55.000000', 'temperatura', 1051.0000, 'ºC'),
	(339464, 144, '2015-02-01 00:20:56.000000', 'temperatura', 722.0000, 'ºC'),
	(339465, 144, '2015-02-01 00:20:57.000000', 'temperatura', 458.0000, 'ºC'),
	(339466, 144, '2015-02-01 00:20:58.000000', 'temperatura', 125.0000, 'ºC'),
	(339467, 144, '2015-02-01 00:20:59.000000', 'temperatura', 451.0000, 'ºC'),
	(339468, 144, '2015-02-01 00:21:00.000000', 'temperatura', 682.0000, 'ºC'),
	(339469, 144, '2015-02-01 00:21:01.000000', 'temperatura', 858.0000, 'ºC'),
	(339470, 144, '2015-02-01 00:21:02.000000', 'temperatura', 1043.0000, 'ºC'),
	(339471, 144, '2015-02-01 00:21:03.000000', 'temperatura', 242.0000, 'ºC'),
	(339472, 144, '2015-02-01 00:21:04.000000', 'temperatura', 481.0000, 'ºC'),
	(339473, 144, '2015-02-01 00:21:05.000000', 'temperatura', 481.0000, 'ºC'),
	(339474, 144, '2015-02-01 00:21:06.000000', 'temperatura', 963.0000, 'ºC'),
	(339475, 144, '2015-02-01 00:21:07.000000', 'temperatura', 970.0000, 'ºC'),
	(339476, 144, '2015-02-01 00:21:08.000000', 'temperatura', 764.0000, 'ºC'),
	(339477, 144, '2015-02-01 00:21:09.000000', 'temperatura', 911.0000, 'ºC'),
	(339478, 144, '2015-02-01 00:21:10.000000', 'temperatura', 1064.0000, 'ºC'),
	(339479, 144, '2015-02-01 00:21:11.000000', 'temperatura', 184.0000, 'ºC'),
	(339480, 144, '2015-02-01 00:21:12.000000', 'temperatura', 132.0000, 'ºC'),
	(339481, 144, '2015-02-01 00:21:13.000000', 'temperatura', 107.0000, 'ºC'),
	(339482, 144, '2015-02-01 00:21:14.000000', 'temperatura', 141.0000, 'ºC'),
	(339483, 144, '2015-02-01 00:21:15.000000', 'temperatura', 386.0000, 'ºC'),
	(339484, 144, '2015-02-01 00:21:16.000000', 'temperatura', 304.0000, 'ºC'),
	(339485, 144, '2015-02-01 00:21:17.000000', 'temperatura', 363.0000, 'ºC'),
	(339486, 144, '2015-02-01 00:21:18.000000', 'temperatura', 904.0000, 'ºC'),
	(339487, 144, '2015-02-01 00:21:19.000000', 'temperatura', 1033.0000, 'ºC'),
	(339488, 144, '2015-02-01 00:21:20.000000', 'temperatura', 54.0000, 'ºC'),
	(339489, 144, '2015-02-01 00:21:21.000000', 'temperatura', 772.0000, 'ºC'),
	(339490, 144, '2015-02-01 00:21:22.000000', 'temperatura', 98.0000, 'ºC'),
	(339491, 144, '2015-02-01 00:21:23.000000', 'temperatura', 573.0000, 'ºC'),
	(339492, 144, '2015-02-01 00:21:24.000000', 'temperatura', 173.0000, 'ºC'),
	(339493, 144, '2015-02-01 00:21:25.000000', 'temperatura', 347.0000, 'ºC'),
	(339494, 144, '2015-02-01 00:21:26.000000', 'temperatura', 14.0000, 'ºC'),
	(339495, 144, '2015-02-01 00:21:27.000000', 'temperatura', 229.0000, 'ºC'),
	(339496, 144, '2015-02-01 00:21:28.000000', 'temperatura', 1106.0000, 'ºC'),
	(339497, 144, '2015-02-01 00:21:29.000000', 'temperatura', 42.0000, 'ºC'),
	(339498, 144, '2015-02-01 00:21:30.000000', 'temperatura', 493.0000, 'ºC'),
	(339499, 144, '2015-02-01 00:21:31.000000', 'temperatura', 1140.0000, 'ºC'),
	(339500, 144, '2015-02-01 00:21:32.000000', 'temperatura', 622.0000, 'ºC'),
	(339501, 144, '2015-02-01 00:21:33.000000', 'temperatura', 892.0000, 'ºC'),
	(339502, 144, '2015-02-01 00:21:34.000000', 'temperatura', 193.0000, 'ºC'),
	(339503, 144, '2015-02-01 00:21:35.000000', 'temperatura', 688.0000, 'ºC'),
	(339504, 144, '2015-02-01 00:21:36.000000', 'temperatura', 464.0000, 'ºC'),
	(339505, 144, '2015-02-01 00:21:37.000000', 'temperatura', 257.0000, 'ºC'),
	(339506, 144, '2015-02-01 00:21:38.000000', 'temperatura', 1091.0000, 'ºC'),
	(339507, 144, '2015-02-01 00:21:39.000000', 'temperatura', 1087.0000, 'ºC'),
	(339508, 144, '2015-02-01 00:21:40.000000', 'temperatura', 959.0000, 'ºC'),
	(339509, 144, '2015-02-01 00:21:41.000000', 'temperatura', 338.0000, 'ºC'),
	(339510, 144, '2015-02-01 00:21:42.000000', 'temperatura', 11.0000, 'ºC'),
	(339511, 144, '2015-02-01 00:21:43.000000', 'temperatura', 241.0000, 'ºC'),
	(339512, 144, '2015-02-01 00:21:44.000000', 'temperatura', 1175.0000, 'ºC'),
	(339513, 144, '2015-02-01 00:21:45.000000', 'temperatura', 350.0000, 'ºC'),
	(339514, 144, '2015-02-01 00:21:46.000000', 'temperatura', 627.0000, 'ºC'),
	(339515, 144, '2015-02-01 00:21:47.000000', 'temperatura', 886.0000, 'ºC'),
	(339516, 144, '2015-02-01 00:21:48.000000', 'temperatura', 148.0000, 'ºC'),
	(339517, 144, '2015-02-01 00:21:49.000000', 'temperatura', 483.0000, 'ºC'),
	(339518, 144, '2015-02-01 00:21:50.000000', 'temperatura', 772.0000, 'ºC'),
	(339519, 144, '2015-02-01 00:21:51.000000', 'temperatura', 11.0000, 'ºC'),
	(339520, 144, '2015-02-01 00:21:52.000000', 'temperatura', 140.0000, 'ºC'),
	(339521, 144, '2015-02-01 00:21:53.000000', 'temperatura', 667.0000, 'ºC'),
	(339522, 144, '2015-02-01 00:21:54.000000', 'temperatura', 515.0000, 'ºC'),
	(339523, 144, '2015-02-01 00:21:55.000000', 'temperatura', 577.0000, 'ºC'),
	(339524, 144, '2015-02-01 00:21:56.000000', 'temperatura', 137.0000, 'ºC'),
	(339525, 144, '2015-02-01 00:21:57.000000', 'temperatura', 156.0000, 'ºC'),
	(339526, 144, '2015-02-01 00:21:58.000000', 'temperatura', 370.0000, 'ºC'),
	(339527, 144, '2015-02-01 00:21:59.000000', 'temperatura', 181.0000, 'ºC'),
	(339528, 144, '2015-02-01 00:22:00.000000', 'temperatura', 997.0000, 'ºC'),
	(339529, 144, '2015-02-01 00:22:01.000000', 'temperatura', 841.0000, 'ºC'),
	(339530, 144, '2015-02-01 00:22:02.000000', 'temperatura', 13.0000, 'ºC'),
	(339531, 144, '2015-02-01 00:22:03.000000', 'temperatura', 1146.0000, 'ºC'),
	(339532, 144, '2015-02-01 00:22:04.000000', 'temperatura', 889.0000, 'ºC'),
	(339533, 144, '2015-02-01 00:22:05.000000', 'temperatura', 1007.0000, 'ºC'),
	(339534, 144, '2015-02-01 00:22:06.000000', 'temperatura', 1169.0000, 'ºC'),
	(339535, 144, '2015-02-01 00:22:07.000000', 'temperatura', 425.0000, 'ºC'),
	(339536, 144, '2015-02-01 00:22:08.000000', 'temperatura', 1019.0000, 'ºC'),
	(339537, 144, '2015-02-01 00:22:09.000000', 'temperatura', 219.0000, 'ºC'),
	(339538, 144, '2015-02-01 00:22:10.000000', 'temperatura', 440.0000, 'ºC'),
	(339539, 144, '2015-02-01 00:22:11.000000', 'temperatura', 342.0000, 'ºC'),
	(339540, 144, '2015-02-01 00:22:12.000000', 'temperatura', 390.0000, 'ºC'),
	(339541, 144, '2015-02-01 00:22:13.000000', 'temperatura', 925.0000, 'ºC'),
	(339542, 144, '2015-02-01 00:22:14.000000', 'temperatura', 1054.0000, 'ºC'),
	(339543, 144, '2015-02-01 00:22:15.000000', 'temperatura', 97.0000, 'ºC'),
	(339544, 144, '2015-02-01 00:22:16.000000', 'temperatura', 923.0000, 'ºC'),
	(339545, 144, '2015-02-01 00:22:17.000000', 'temperatura', 724.0000, 'ºC'),
	(339546, 144, '2015-02-01 00:22:18.000000', 'temperatura', 850.0000, 'ºC'),
	(339547, 144, '2015-02-01 00:22:19.000000', 'temperatura', 882.0000, 'ºC'),
	(339548, 144, '2015-02-01 00:22:20.000000', 'temperatura', 658.0000, 'ºC'),
	(339549, 144, '2015-02-01 00:22:21.000000', 'temperatura', 646.0000, 'ºC'),
	(339550, 144, '2015-02-01 00:22:22.000000', 'temperatura', 58.0000, 'ºC'),
	(339551, 144, '2015-02-01 00:22:23.000000', 'temperatura', 749.0000, 'ºC'),
	(339552, 144, '2015-02-01 00:22:24.000000', 'temperatura', 1173.0000, 'ºC'),
	(339553, 144, '2015-02-01 00:22:25.000000', 'temperatura', 20.0000, 'ºC'),
	(339554, 144, '2015-02-01 00:22:26.000000', 'temperatura', 181.0000, 'ºC'),
	(339555, 144, '2015-02-01 00:22:27.000000', 'temperatura', 846.0000, 'ºC'),
	(339556, 144, '2015-02-01 00:22:28.000000', 'temperatura', 86.0000, 'ºC'),
	(339557, 144, '2015-02-01 00:22:29.000000', 'temperatura', 295.0000, 'ºC'),
	(339558, 144, '2015-02-01 00:22:30.000000', 'temperatura', 16.0000, 'ºC'),
	(339559, 144, '2015-02-01 00:22:31.000000', 'temperatura', 396.0000, 'ºC'),
	(339560, 144, '2015-02-01 00:22:32.000000', 'temperatura', 734.0000, 'ºC'),
	(339561, 144, '2015-02-01 00:22:33.000000', 'temperatura', 81.0000, 'ºC'),
	(339562, 144, '2015-02-01 00:22:34.000000', 'temperatura', 604.0000, 'ºC'),
	(339563, 144, '2015-02-01 00:22:35.000000', 'temperatura', 375.0000, 'ºC'),
	(339564, 144, '2015-02-01 00:22:36.000000', 'temperatura', 67.0000, 'ºC'),
	(339565, 144, '2015-02-01 00:22:37.000000', 'temperatura', 407.0000, 'ºC'),
	(339566, 144, '2015-02-01 00:22:38.000000', 'temperatura', 637.0000, 'ºC'),
	(339567, 144, '2015-02-01 00:22:39.000000', 'temperatura', 763.0000, 'ºC'),
	(339568, 144, '2015-02-01 00:22:40.000000', 'temperatura', 703.0000, 'ºC'),
	(339569, 144, '2015-02-01 00:22:41.000000', 'temperatura', 29.0000, 'ºC'),
	(339570, 144, '2015-02-01 00:22:42.000000', 'temperatura', 435.0000, 'ºC'),
	(339571, 144, '2015-02-01 00:22:43.000000', 'temperatura', 887.0000, 'ºC'),
	(339572, 144, '2015-02-01 00:22:44.000000', 'temperatura', 732.0000, 'ºC'),
	(339573, 144, '2015-02-01 00:22:45.000000', 'temperatura', 997.0000, 'ºC'),
	(339574, 144, '2015-02-01 00:22:46.000000', 'temperatura', 393.0000, 'ºC'),
	(339575, 144, '2015-02-01 00:22:47.000000', 'temperatura', 172.0000, 'ºC'),
	(339576, 144, '2015-02-01 00:22:48.000000', 'temperatura', 881.0000, 'ºC'),
	(339577, 144, '2015-02-01 00:22:49.000000', 'temperatura', 291.0000, 'ºC'),
	(339578, 144, '2015-02-01 00:22:50.000000', 'temperatura', 12.0000, 'ºC'),
	(339579, 144, '2015-02-01 00:22:51.000000', 'temperatura', 386.0000, 'ºC'),
	(339580, 144, '2015-02-01 00:22:52.000000', 'temperatura', 698.0000, 'ºC'),
	(339581, 144, '2015-02-01 00:22:53.000000', 'temperatura', 1129.0000, 'ºC'),
	(339582, 144, '2015-02-01 00:22:54.000000', 'temperatura', 1152.0000, 'ºC'),
	(339583, 144, '2015-02-01 00:22:55.000000', 'temperatura', 1176.0000, 'ºC'),
	(339584, 144, '2015-02-01 00:22:56.000000', 'temperatura', 23.0000, 'ºC'),
	(339585, 144, '2015-02-01 00:22:57.000000', 'temperatura', 189.0000, 'ºC'),
	(339586, 144, '2015-02-01 00:22:58.000000', 'temperatura', 875.0000, 'ºC'),
	(339587, 144, '2015-02-01 00:22:59.000000', 'temperatura', 208.0000, 'ºC'),
	(339588, 144, '2015-02-01 00:23:00.000000', 'temperatura', 816.0000, 'ºC'),
	(339589, 144, '2015-02-01 00:23:01.000000', 'temperatura', 1057.0000, 'ºC'),
	(339590, 144, '2015-02-01 00:23:02.000000', 'temperatura', 436.0000, 'ºC'),
	(339591, 144, '2015-02-01 00:23:03.000000', 'temperatura', 209.0000, 'ºC'),
	(339592, 144, '2015-02-01 00:23:04.000000', 'temperatura', 940.0000, 'ºC'),
	(339593, 144, '2015-02-01 00:23:05.000000', 'temperatura', 472.0000, 'ºC'),
	(339594, 144, '2015-02-01 00:23:06.000000', 'temperatura', 741.0000, 'ºC'),
	(339595, 144, '2015-02-01 00:23:07.000000', 'temperatura', 1089.0000, 'ºC'),
	(339596, 144, '2015-02-01 00:23:08.000000', 'temperatura', 824.0000, 'ºC'),
	(339597, 144, '2015-02-01 00:23:09.000000', 'temperatura', 854.0000, 'ºC'),
	(339598, 144, '2015-02-01 00:23:10.000000', 'temperatura', 596.0000, 'ºC'),
	(339599, 144, '2015-02-01 00:23:11.000000', 'temperatura', 419.0000, 'ºC'),
	(339600, 144, '2015-02-01 00:23:12.000000', 'temperatura', 307.0000, 'ºC'),
	(339601, 144, '2015-02-01 00:23:13.000000', 'temperatura', 281.0000, 'ºC'),
	(339602, 144, '2015-02-01 00:23:14.000000', 'temperatura', 483.0000, 'ºC'),
	(339603, 144, '2015-02-01 00:23:15.000000', 'temperatura', 374.0000, 'ºC'),
	(339604, 144, '2015-02-01 00:23:16.000000', 'temperatura', 419.0000, 'ºC'),
	(339605, 144, '2015-02-01 00:23:17.000000', 'temperatura', 973.0000, 'ºC'),
	(339606, 144, '2015-02-01 00:23:18.000000', 'temperatura', 11.0000, 'ºC'),
	(339607, 144, '2015-02-01 00:23:19.000000', 'temperatura', 735.0000, 'ºC'),
	(339608, 144, '2015-02-01 00:23:20.000000', 'temperatura', 41.0000, 'ºC'),
	(339609, 144, '2015-02-01 00:23:21.000000', 'temperatura', 401.0000, 'ºC'),
	(339610, 144, '2015-02-01 00:23:22.000000', 'temperatura', 682.0000, 'ºC'),
	(339611, 144, '2015-02-01 00:23:23.000000', 'temperatura', 1008.0000, 'ºC'),
	(339612, 144, '2015-02-01 00:23:24.000000', 'temperatura', 596.0000, 'ºC'),
	(339613, 144, '2015-02-01 00:23:25.000000', 'temperatura', 1155.0000, 'ºC'),
	(339614, 144, '2015-02-01 00:23:26.000000', 'temperatura', 389.0000, 'ºC'),
	(339615, 144, '2015-02-01 00:23:27.000000', 'temperatura', 880.0000, 'ºC'),
	(339616, 144, '2015-02-01 00:23:28.000000', 'temperatura', 833.0000, 'ºC'),
	(339617, 144, '2015-02-01 00:23:29.000000', 'temperatura', 327.0000, 'ºC'),
	(339618, 144, '2015-02-01 00:23:30.000000', 'temperatura', 337.0000, 'ºC'),
	(339619, 144, '2015-02-01 00:23:31.000000', 'temperatura', 705.0000, 'ºC'),
	(339620, 144, '2015-02-01 00:23:32.000000', 'temperatura', 115.0000, 'ºC'),
	(339621, 144, '2015-02-01 00:23:33.000000', 'temperatura', 860.0000, 'ºC'),
	(339622, 144, '2015-02-01 00:23:34.000000', 'temperatura', 357.0000, 'ºC'),
	(339623, 144, '2015-02-01 00:23:35.000000', 'temperatura', 403.0000, 'ºC'),
	(339624, 144, '2015-02-01 00:23:36.000000', 'temperatura', 946.0000, 'ºC'),
	(339625, 144, '2015-02-01 00:23:37.000000', 'temperatura', 1120.0000, 'ºC'),
	(339626, 144, '2015-02-01 00:23:38.000000', 'temperatura', 365.0000, 'ºC'),
	(339627, 144, '2015-02-01 00:23:39.000000', 'temperatura', 864.0000, 'ºC'),
	(339628, 144, '2015-02-01 00:23:40.000000', 'temperatura', 827.0000, 'ºC'),
	(339629, 144, '2015-02-01 00:23:41.000000', 'temperatura', 343.0000, 'ºC'),
	(339630, 144, '2015-02-01 00:23:42.000000', 'temperatura', 434.0000, 'ºC'),
	(339631, 144, '2015-02-01 00:23:43.000000', 'temperatura', 1142.0000, 'ºC'),
	(339632, 144, '2015-02-01 00:23:44.000000', 'temperatura', 809.0000, 'ºC'),
	(339633, 144, '2015-02-01 00:23:45.000000', 'temperatura', 617.0000, 'ºC'),
	(339634, 144, '2015-02-01 00:23:46.000000', 'temperatura', 661.0000, 'ºC'),
	(339635, 144, '2015-02-01 00:23:47.000000', 'temperatura', 253.0000, 'ºC'),
	(339636, 144, '2015-02-01 00:23:48.000000', 'temperatura', 483.0000, 'ºC'),
	(339637, 144, '2015-02-01 00:23:49.000000', 'temperatura', 458.0000, 'ºC'),
	(339638, 144, '2015-02-01 00:23:50.000000', 'temperatura', 840.0000, 'ºC'),
	(339639, 144, '2015-02-01 00:23:51.000000', 'temperatura', 428.0000, 'ºC'),
	(339640, 144, '2015-02-01 00:23:52.000000', 'temperatura', 819.0000, 'ºC'),
	(339641, 144, '2015-02-01 00:23:53.000000', 'temperatura', 411.0000, 'ºC'),
	(339642, 144, '2015-02-01 00:23:54.000000', 'temperatura', 801.0000, 'ºC'),
	(339643, 144, '2015-02-01 00:23:55.000000', 'temperatura', 370.0000, 'ºC'),
	(339644, 144, '2015-02-01 00:23:56.000000', 'temperatura', 648.0000, 'ºC'),
	(339645, 144, '2015-02-01 00:23:57.000000', 'temperatura', 932.0000, 'ºC'),
	(339646, 144, '2015-02-01 00:23:58.000000', 'temperatura', 315.0000, 'ºC'),
	(339647, 144, '2015-02-01 00:23:59.000000', 'temperatura', 1180.0000, 'ºC'),
	(339648, 144, '2015-02-01 00:24:00.000000', 'temperatura', 156.0000, 'ºC'),
	(339649, 144, '2015-02-01 00:24:01.000000', 'temperatura', 839.0000, 'ºC'),
	(339650, 144, '2015-02-01 00:24:02.000000', 'temperatura', 127.0000, 'ºC'),
	(339651, 144, '2015-02-01 00:24:03.000000', 'temperatura', 520.0000, 'ºC'),
	(339652, 144, '2015-02-01 00:24:04.000000', 'temperatura', 1021.0000, 'ºC'),
	(339653, 144, '2015-02-01 00:24:05.000000', 'temperatura', 1145.0000, 'ºC'),
	(339654, 144, '2015-02-01 00:24:06.000000', 'temperatura', 261.0000, 'ºC'),
	(339655, 144, '2015-02-01 00:24:07.000000', 'temperatura', 272.0000, 'ºC'),
	(339656, 144, '2015-02-01 00:24:08.000000', 'temperatura', 575.0000, 'ºC'),
	(339657, 144, '2015-02-01 00:24:09.000000', 'temperatura', 862.0000, 'ºC'),
	(339658, 144, '2015-02-01 00:24:10.000000', 'temperatura', 184.0000, 'ºC'),
	(339659, 144, '2015-02-01 00:24:11.000000', 'temperatura', 735.0000, 'ºC'),
	(339660, 144, '2015-02-01 00:24:12.000000', 'temperatura', 723.0000, 'ºC'),
	(339661, 144, '2015-02-01 00:24:13.000000', 'temperatura', 212.0000, 'ºC'),
	(339662, 144, '2015-02-01 00:24:14.000000', 'temperatura', 91.0000, 'ºC'),
	(339663, 144, '2015-02-01 00:24:15.000000', 'temperatura', 1021.0000, 'ºC'),
	(339664, 144, '2015-02-01 00:24:16.000000', 'temperatura', 32.0000, 'ºC'),
	(339665, 144, '2015-02-01 00:24:17.000000', 'temperatura', 695.0000, 'ºC'),
	(339666, 144, '2015-02-01 00:24:18.000000', 'temperatura', 982.0000, 'ºC'),
	(339667, 144, '2015-02-01 00:24:19.000000', 'temperatura', 425.0000, 'ºC'),
	(339668, 144, '2015-02-01 00:24:20.000000', 'temperatura', 379.0000, 'ºC'),
	(339669, 144, '2015-02-01 00:24:21.000000', 'temperatura', 622.0000, 'ºC'),
	(339670, 144, '2015-02-01 00:24:22.000000', 'temperatura', 773.0000, 'ºC'),
	(339671, 144, '2015-02-01 00:24:23.000000', 'temperatura', 801.0000, 'ºC'),
	(339672, 144, '2015-02-01 00:24:24.000000', 'temperatura', 484.0000, 'ºC'),
	(339673, 144, '2015-02-01 00:24:25.000000', 'temperatura', 17.0000, 'ºC'),
	(339674, 144, '2015-02-01 00:24:26.000000', 'temperatura', 1036.0000, 'ºC'),
	(339675, 144, '2015-02-01 00:24:27.000000', 'temperatura', 327.0000, 'ºC'),
	(339676, 144, '2015-02-01 00:24:28.000000', 'temperatura', 930.0000, 'ºC'),
	(339677, 144, '2015-02-01 00:24:29.000000', 'temperatura', 68.0000, 'ºC'),
	(339678, 144, '2015-02-01 00:24:30.000000', 'temperatura', 1149.0000, 'ºC'),
	(339679, 144, '2015-02-01 00:24:31.000000', 'temperatura', 742.0000, 'ºC'),
	(339680, 144, '2015-02-01 00:24:32.000000', 'temperatura', 265.0000, 'ºC'),
	(339681, 144, '2015-02-01 00:24:33.000000', 'temperatura', 300.0000, 'ºC'),
	(339682, 144, '2015-02-01 00:24:34.000000', 'temperatura', 707.0000, 'ºC'),
	(339683, 144, '2015-02-01 00:24:35.000000', 'temperatura', 233.0000, 'ºC'),
	(339684, 144, '2015-02-01 00:24:36.000000', 'temperatura', 245.0000, 'ºC'),
	(339685, 144, '2015-02-01 00:24:37.000000', 'temperatura', 528.0000, 'ºC'),
	(339686, 144, '2015-02-01 00:24:38.000000', 'temperatura', 706.0000, 'ºC'),
	(339687, 144, '2015-02-01 00:24:39.000000', 'temperatura', 745.0000, 'ºC'),
	(339688, 144, '2015-02-01 00:24:40.000000', 'temperatura', 407.0000, 'ºC'),
	(339689, 144, '2015-02-01 00:24:41.000000', 'temperatura', 999.0000, 'ºC'),
	(339690, 144, '2015-02-01 00:24:42.000000', 'temperatura', 178.0000, 'ºC'),
	(339691, 144, '2015-02-01 00:24:43.000000', 'temperatura', 291.0000, 'ºC'),
	(339692, 144, '2015-02-01 00:24:44.000000', 'temperatura', 921.0000, 'ºC'),
	(339693, 144, '2015-02-01 00:24:45.000000', 'temperatura', 131.0000, 'ºC'),
	(339694, 144, '2015-02-01 00:24:46.000000', 'temperatura', 296.0000, 'ºC'),
	(339695, 144, '2015-02-01 00:24:47.000000', 'temperatura', 1084.0000, 'ºC'),
	(339696, 144, '2015-02-01 00:24:48.000000', 'temperatura', 934.0000, 'ºC'),
	(339697, 144, '2015-02-01 00:24:49.000000', 'temperatura', 221.0000, 'ºC'),
	(339698, 144, '2015-02-01 00:24:50.000000', 'temperatura', 700.0000, 'ºC'),
	(339699, 144, '2015-02-01 00:24:51.000000', 'temperatura', 438.0000, 'ºC'),
	(339700, 144, '2015-02-01 00:24:52.000000', 'temperatura', 90.0000, 'ºC'),
	(339701, 144, '2015-02-01 00:24:53.000000', 'temperatura', 336.0000, 'ºC'),
	(339702, 144, '2015-02-01 00:24:54.000000', 'temperatura', 211.0000, 'ºC'),
	(339703, 144, '2015-02-01 00:24:55.000000', 'temperatura', 48.0000, 'ºC'),
	(339704, 144, '2015-02-01 00:24:56.000000', 'temperatura', 806.0000, 'ºC'),
	(339705, 144, '2015-02-01 00:24:57.000000', 'temperatura', 288.0000, 'ºC'),
	(339706, 144, '2015-02-01 00:24:58.000000', 'temperatura', 221.0000, 'ºC'),
	(339707, 144, '2015-02-01 00:24:59.000000', 'temperatura', 244.0000, 'ºC'),
	(339708, 144, '2015-02-01 00:25:00.000000', 'temperatura', 554.0000, 'ºC'),
	(339709, 144, '2015-02-01 00:25:01.000000', 'temperatura', 842.0000, 'ºC'),
	(339710, 144, '2015-02-01 00:25:02.000000', 'temperatura', 146.0000, 'ºC'),
	(339711, 144, '2015-02-01 00:25:03.000000', 'temperatura', 603.0000, 'ºC'),
	(339712, 144, '2015-02-01 00:25:04.000000', 'temperatura', 180.0000, 'ºC'),
	(339713, 144, '2015-02-01 00:25:05.000000', 'temperatura', 291.0000, 'ºC'),
	(339714, 144, '2015-02-01 00:25:06.000000', 'temperatura', 916.0000, 'ºC'),
	(339715, 144, '2015-02-01 00:25:07.000000', 'temperatura', 108.0000, 'ºC'),
	(339716, 144, '2015-02-01 00:25:08.000000', 'temperatura', 191.0000, 'ºC'),
	(339717, 144, '2015-02-01 00:25:09.000000', 'temperatura', 632.0000, 'ºC'),
	(339718, 144, '2015-02-01 00:25:10.000000', 'temperatura', 186.0000, 'ºC'),
	(339719, 144, '2015-02-01 00:25:11.000000', 'temperatura', 237.0000, 'ºC'),
	(339720, 144, '2015-02-01 00:25:12.000000', 'temperatura', 628.0000, 'ºC'),
	(339721, 144, '2015-02-01 00:25:13.000000', 'temperatura', 26.0000, 'ºC'),
	(339722, 144, '2015-02-01 00:25:14.000000', 'temperatura', 650.0000, 'ºC'),
	(339723, 144, '2015-02-01 00:25:15.000000', 'temperatura', 772.0000, 'ºC'),
	(339724, 144, '2015-02-01 00:25:16.000000', 'temperatura', 709.0000, 'ºC'),
	(339725, 144, '2015-02-01 00:25:17.000000', 'temperatura', 31.0000, 'ºC'),
	(339726, 144, '2015-02-01 00:25:18.000000', 'temperatura', 428.0000, 'ºC'),
	(339727, 144, '2015-02-01 00:25:19.000000', 'temperatura', 847.0000, 'ºC'),
	(339728, 144, '2015-02-01 00:25:20.000000', 'temperatura', 552.0000, 'ºC'),
	(339729, 144, '2015-02-01 00:25:21.000000', 'temperatura', 218.0000, 'ºC'),
	(339730, 144, '2015-02-01 00:25:22.000000', 'temperatura', 635.0000, 'ºC'),
	(339731, 144, '2015-02-01 00:25:23.000000', 'temperatura', 120.0000, 'ºC'),
	(339732, 144, '2015-02-01 00:25:24.000000', 'temperatura', 1096.0000, 'ºC'),
	(339733, 144, '2015-02-01 00:25:25.000000', 'temperatura', 322.0000, 'ºC'),
	(339734, 144, '2015-02-01 00:25:26.000000', 'temperatura', 721.0000, 'ºC'),
	(339735, 144, '2015-02-01 00:25:27.000000', 'temperatura', 239.0000, 'ºC'),
	(339736, 144, '2015-02-01 00:25:28.000000', 'temperatura', 235.0000, 'ºC'),
	(339737, 144, '2015-02-01 00:25:29.000000', 'temperatura', 456.0000, 'ºC'),
	(339738, 144, '2015-02-01 00:25:30.000000', 'temperatura', 378.0000, 'ºC'),
	(339739, 144, '2015-02-01 00:25:31.000000', 'temperatura', 523.0000, 'ºC'),
	(339740, 144, '2015-02-01 00:25:32.000000', 'temperatura', 280.0000, 'ºC'),
	(339741, 144, '2015-02-01 00:25:33.000000', 'temperatura', 1034.0000, 'ºC'),
	(339742, 144, '2015-02-01 00:25:34.000000', 'temperatura', 728.0000, 'ºC'),
	(339743, 144, '2015-02-01 00:25:35.000000', 'temperatura', 539.0000, 'ºC'),
	(339744, 144, '2015-02-01 00:25:36.000000', 'temperatura', 513.0000, 'ºC'),
	(339745, 144, '2015-02-01 00:25:37.000000', 'temperatura', 946.0000, 'ºC'),
	(339746, 144, '2015-02-01 00:25:38.000000', 'temperatura', 793.0000, 'ºC'),
	(339747, 144, '2015-02-01 00:25:39.000000', 'temperatura', 1126.0000, 'ºC'),
	(339748, 144, '2015-02-01 00:25:40.000000', 'temperatura', 854.0000, 'ºC'),
	(339749, 144, '2015-02-01 00:25:41.000000', 'temperatura', 891.0000, 'ºC'),
	(339750, 144, '2015-02-01 00:25:42.000000', 'temperatura', 694.0000, 'ºC'),
	(339751, 144, '2015-02-01 00:25:43.000000', 'temperatura', 799.0000, 'ºC'),
	(339752, 144, '2015-02-01 00:25:44.000000', 'temperatura', 712.0000, 'ºC'),
	(339753, 144, '2015-02-01 00:25:45.000000', 'temperatura', 1163.0000, 'ºC'),
	(339754, 144, '2015-02-01 00:25:46.000000', 'temperatura', 82.0000, 'ºC'),
	(339755, 144, '2015-02-01 00:25:47.000000', 'temperatura', 518.0000, 'ºC'),
	(339756, 144, '2015-02-01 00:25:48.000000', 'temperatura', 1148.0000, 'ºC'),
	(339757, 144, '2015-02-01 00:25:49.000000', 'temperatura', 584.0000, 'ºC'),
	(339758, 144, '2015-02-01 00:25:50.000000', 'temperatura', 677.0000, 'ºC'),
	(339759, 144, '2015-02-01 00:25:51.000000', 'temperatura', 434.0000, 'ºC'),
	(339760, 144, '2015-02-01 00:25:52.000000', 'temperatura', 139.0000, 'ºC'),
	(339761, 144, '2015-02-01 00:25:53.000000', 'temperatura', 594.0000, 'ºC'),
	(339762, 144, '2015-02-01 00:25:54.000000', 'temperatura', 154.0000, 'ºC'),
	(339763, 144, '2015-02-01 00:25:55.000000', 'temperatura', 186.0000, 'ºC'),
	(339764, 144, '2015-02-01 00:25:56.000000', 'temperatura', 471.0000, 'ºC'),
	(339765, 144, '2015-02-01 00:25:57.000000', 'temperatura', 597.0000, 'ºC'),
	(339766, 144, '2015-02-01 00:25:58.000000', 'temperatura', 373.0000, 'ºC'),
	(339767, 144, '2015-02-01 00:25:59.000000', 'temperatura', 74.0000, 'ºC'),
	(339768, 144, '2015-02-01 00:26:00.000000', 'temperatura', 451.0000, 'ºC'),
	(339769, 144, '2015-02-01 00:26:01.000000', 'temperatura', 832.0000, 'ºC'),
	(339770, 144, '2015-02-01 00:26:02.000000', 'temperatura', 408.0000, 'ºC'),
	(339771, 144, '2015-02-01 00:26:03.000000', 'temperatura', 746.0000, 'ºC'),
	(339772, 144, '2015-02-01 00:26:04.000000', 'temperatura', 107.0000, 'ºC'),
	(339773, 144, '2015-02-01 00:26:05.000000', 'temperatura', 698.0000, 'ºC'),
	(339774, 144, '2015-02-01 00:26:06.000000', 'temperatura', 770.0000, 'ºC'),
	(339775, 144, '2015-02-01 00:26:07.000000', 'temperatura', 556.0000, 'ºC'),
	(339776, 144, '2015-02-01 00:26:08.000000', 'temperatura', 472.0000, 'ºC'),
	(339777, 144, '2015-02-01 00:26:09.000000', 'temperatura', 692.0000, 'ºC'),
	(339778, 144, '2015-02-01 00:26:10.000000', 'temperatura', 846.0000, 'ºC'),
	(339779, 144, '2015-02-01 00:26:11.000000', 'temperatura', 952.0000, 'ºC'),
	(339780, 144, '2015-02-01 00:26:12.000000', 'temperatura', 1022.0000, 'ºC'),
	(339781, 144, '2015-02-01 00:26:13.000000', 'temperatura', 1054.0000, 'ºC'),
	(339782, 144, '2015-02-01 00:26:14.000000', 'temperatura', 1004.0000, 'ºC'),
	(339783, 144, '2015-02-01 00:26:15.000000', 'temperatura', 660.0000, 'ºC'),
	(339784, 144, '2015-02-01 00:26:16.000000', 'temperatura', 288.0000, 'ºC'),
	(339785, 144, '2015-02-01 00:26:17.000000', 'temperatura', 659.0000, 'ºC'),
	(339786, 144, '2015-02-01 00:26:18.000000', 'temperatura', 33.0000, 'ºC'),
	(339787, 144, '2015-02-01 00:26:19.000000', 'temperatura', 587.0000, 'ºC'),
	(339788, 144, '2015-02-01 00:26:20.000000', 'temperatura', 438.0000, 'ºC'),
	(339789, 144, '2015-02-01 00:26:21.000000', 'temperatura', 429.0000, 'ºC'),
	(339790, 144, '2015-02-01 00:26:22.000000', 'temperatura', 831.0000, 'ºC'),
	(339791, 144, '2015-02-01 00:26:23.000000', 'temperatura', 471.0000, 'ºC'),
	(339792, 144, '2015-02-01 00:26:24.000000', 'temperatura', 1061.0000, 'ºC'),
	(339793, 144, '2015-02-01 00:26:25.000000', 'temperatura', 291.0000, 'ºC'),
	(339794, 144, '2015-02-01 00:26:26.000000', 'temperatura', 674.0000, 'ºC'),
	(339795, 144, '2015-02-01 00:26:27.000000', 'temperatura', 99.0000, 'ºC'),
	(339796, 144, '2015-02-01 00:26:28.000000', 'temperatura', 871.0000, 'ºC'),
	(339797, 144, '2015-02-01 00:26:29.000000', 'temperatura', 460.0000, 'ºC'),
	(339798, 144, '2015-02-01 00:26:30.000000', 'temperatura', 887.0000, 'ºC'),
	(339799, 144, '2015-02-01 00:26:31.000000', 'temperatura', 654.0000, 'ºC'),
	(339800, 144, '2015-02-01 00:26:32.000000', 'temperatura', 612.0000, 'ºC'),
	(339801, 144, '2015-02-01 00:26:33.000000', 'temperatura', 1096.0000, 'ºC'),
	(339802, 144, '2015-02-01 00:26:34.000000', 'temperatura', 45.0000, 'ºC'),
	(339803, 144, '2015-02-01 00:26:35.000000', 'temperatura', 538.0000, 'ºC'),
	(339804, 144, '2015-02-01 00:26:36.000000', 'temperatura', 157.0000, 'ºC'),
	(339805, 144, '2015-02-01 00:26:37.000000', 'temperatura', 372.0000, 'ºC'),
	(339806, 144, '2015-02-01 00:26:38.000000', 'temperatura', 190.0000, 'ºC'),
	(339807, 144, '2015-02-01 00:26:39.000000', 'temperatura', 1034.0000, 'ºC'),
	(339808, 144, '2015-02-01 00:26:40.000000', 'temperatura', 1002.0000, 'ºC'),
	(339809, 144, '2015-02-01 00:26:41.000000', 'temperatura', 708.0000, 'ºC'),
	(339810, 144, '2015-02-01 00:26:42.000000', 'temperatura', 532.0000, 'ºC'),
	(339811, 144, '2015-02-01 00:26:43.000000', 'temperatura', 538.0000, 'ºC'),
	(339812, 144, '2015-02-01 00:26:44.000000', 'temperatura', 1095.0000, 'ºC'),
	(339813, 144, '2015-02-01 00:26:45.000000', 'temperatura', 260.0000, 'ºC'),
	(339814, 144, '2015-02-01 00:26:46.000000', 'temperatura', 418.0000, 'ºC'),
	(339815, 144, '2015-02-01 00:26:47.000000', 'temperatura', 108.0000, 'ºC'),
	(339816, 144, '2015-02-01 00:26:48.000000', 'temperatura', 486.0000, 'ºC'),
	(339817, 144, '2015-02-01 00:26:49.000000', 'temperatura', 908.0000, 'ºC'),
	(339818, 144, '2015-02-01 00:26:50.000000', 'temperatura', 680.0000, 'ºC'),
	(339819, 144, '2015-02-01 00:26:51.000000', 'temperatura', 680.0000, 'ºC'),
	(339820, 144, '2015-02-01 00:26:52.000000', 'temperatura', 159.0000, 'ºC'),
	(339821, 144, '2015-02-01 00:26:53.000000', 'temperatura', 1157.0000, 'ºC'),
	(339822, 144, '2015-02-01 00:26:54.000000', 'temperatura', 508.0000, 'ºC'),
	(339823, 144, '2015-02-01 00:26:55.000000', 'temperatura', 270.0000, 'ºC'),
	(339824, 144, '2015-02-01 00:26:56.000000', 'temperatura', 1025.0000, 'ºC'),
	(339825, 144, '2015-02-01 00:26:57.000000', 'temperatura', 715.0000, 'ºC'),
	(339826, 144, '2015-02-01 00:26:58.000000', 'temperatura', 499.0000, 'ºC'),
	(339827, 144, '2015-02-01 00:26:59.000000', 'temperatura', 354.0000, 'ºC'),
	(339828, 144, '2015-02-01 00:27:00.000000', 'temperatura', 272.0000, 'ºC'),
	(339829, 144, '2015-02-01 00:27:01.000000', 'temperatura', 300.0000, 'ºC'),
	(339830, 144, '2015-02-01 00:27:02.000000', 'temperatura', 683.0000, 'ºC'),
	(339831, 144, '2015-02-01 00:27:03.000000', 'temperatura', 115.0000, 'ºC'),
	(339832, 144, '2015-02-01 00:27:04.000000', 'temperatura', 929.0000, 'ºC'),
	(339833, 144, '2015-02-01 00:27:05.000000', 'temperatura', 699.0000, 'ºC'),
	(339834, 144, '2015-02-01 00:27:06.000000', 'temperatura', 707.0000, 'ºC'),
	(339835, 144, '2015-02-01 00:27:07.000000', 'temperatura', 238.0000, 'ºC'),
	(339836, 144, '2015-02-01 00:27:08.000000', 'temperatura', 272.0000, 'ºC'),
	(339837, 144, '2015-02-01 00:27:09.000000', 'temperatura', 646.0000, 'ºC'),
	(339838, 144, '2015-02-01 00:27:10.000000', 'temperatura', 14.0000, 'ºC'),
	(339839, 144, '2015-02-01 00:27:11.000000', 'temperatura', 535.0000, 'ºC'),
	(339840, 144, '2015-02-01 00:27:12.000000', 'temperatura', 230.0000, 'ºC'),
	(339841, 144, '2015-02-01 00:27:13.000000', 'temperatura', 749.0000, 'ºC'),
	(339842, 144, '2015-02-01 00:27:14.000000', 'temperatura', 652.0000, 'ºC'),
	(339843, 144, '2015-02-01 00:27:15.000000', 'temperatura', 1015.0000, 'ºC'),
	(339844, 144, '2015-02-01 00:27:16.000000', 'temperatura', 719.0000, 'ºC'),
	(339845, 144, '2015-02-01 00:27:17.000000', 'temperatura', 552.0000, 'ºC'),
	(339846, 144, '2015-02-01 00:27:18.000000', 'temperatura', 603.0000, 'ºC'),
	(339847, 144, '2015-02-01 00:27:19.000000', 'temperatura', 161.0000, 'ºC'),
	(339848, 144, '2015-02-01 00:27:20.000000', 'temperatura', 194.0000, 'ºC'),
	(339849, 144, '2015-02-01 00:27:21.000000', 'temperatura', 489.0000, 'ºC'),
	(339850, 144, '2015-02-01 00:27:22.000000', 'temperatura', 662.0000, 'ºC'),
	(339851, 144, '2015-02-01 00:27:23.000000', 'temperatura', 646.0000, 'ºC'),
	(339852, 144, '2015-02-01 00:27:24.000000', 'temperatura', 42.0000, 'ºC'),
	(339853, 144, '2015-02-01 00:27:25.000000', 'temperatura', 671.0000, 'ºC'),
	(339854, 144, '2015-02-01 00:27:26.000000', 'temperatura', 833.0000, 'ºC'),
	(339855, 144, '2015-02-01 00:27:27.000000', 'temperatura', 950.0000, 'ºC'),
	(339856, 144, '2015-02-01 00:27:28.000000', 'temperatura', 1053.0000, 'ºC'),
	(339857, 144, '2015-02-01 00:27:29.000000', 'temperatura', 15.0000, 'ºC'),
	(339858, 144, '2015-02-01 00:27:30.000000', 'temperatura', 516.0000, 'ºC'),
	(339859, 144, '2015-02-01 00:27:31.000000', 'temperatura', 136.0000, 'ºC'),
	(339860, 144, '2015-02-01 00:27:32.000000', 'temperatura', 333.0000, 'ºC'),
	(339861, 144, '2015-02-01 00:27:33.000000', 'temperatura', 56.0000, 'ºC'),
	(339862, 144, '2015-02-01 00:27:34.000000', 'temperatura', 483.0000, 'ºC'),
	(339863, 144, '2015-02-01 00:27:35.000000', 'temperatura', 1049.0000, 'ºC'),
	(339864, 144, '2015-02-01 00:27:36.000000', 'temperatura', 194.0000, 'ºC'),
	(339865, 144, '2015-02-01 00:27:37.000000', 'temperatura', 223.0000, 'ºC'),
	(339866, 144, '2015-02-01 00:27:38.000000', 'temperatura', 533.0000, 'ºC'),
	(339867, 144, '2015-02-01 00:27:39.000000', 'temperatura', 796.0000, 'ºC'),
	(339868, 144, '2015-02-01 00:27:40.000000', 'temperatura', 1184.0000, 'ºC'),
	(339869, 144, '2015-02-01 00:27:41.000000', 'temperatura', 1132.0000, 'ºC'),
	(339870, 144, '2015-02-01 00:27:42.000000', 'temperatura', 909.0000, 'ºC'),
	(339871, 144, '2015-02-01 00:27:43.000000', 'temperatura', 1151.0000, 'ºC'),
	(339872, 144, '2015-02-01 00:27:44.000000', 'temperatura', 627.0000, 'ºC'),
	(339873, 144, '2015-02-01 00:27:45.000000', 'temperatura', 881.0000, 'ºC'),
	(339874, 144, '2015-02-01 00:27:46.000000', 'temperatura', 126.0000, 'ºC'),
	(339875, 144, '2015-02-01 00:27:47.000000', 'temperatura', 388.0000, 'ºC'),
	(339876, 144, '2015-02-01 00:27:48.000000', 'temperatura', 363.0000, 'ºC'),
	(339877, 144, '2015-02-01 00:27:49.000000', 'temperatura', 651.0000, 'ºC'),
	(339878, 144, '2015-02-01 00:27:50.000000', 'temperatura', 965.0000, 'ºC'),
	(339879, 144, '2015-02-01 00:27:51.000000', 'temperatura', 474.0000, 'ºC'),
	(339880, 144, '2015-02-01 00:27:52.000000', 'temperatura', 677.0000, 'ºC'),
	(339881, 144, '2015-02-01 00:27:53.000000', 'temperatura', 763.0000, 'ºC'),
	(339882, 144, '2015-02-01 00:27:54.000000', 'temperatura', 584.0000, 'ºC'),
	(339883, 144, '2015-02-01 00:27:55.000000', 'temperatura', 631.0000, 'ºC'),
	(339884, 144, '2015-02-01 00:27:56.000000', 'temperatura', 204.0000, 'ºC'),
	(339885, 144, '2015-02-01 00:27:57.000000', 'temperatura', 326.0000, 'ºC'),
	(339886, 144, '2015-02-01 00:27:58.000000', 'temperatura', 1020.0000, 'ºC'),
	(339887, 144, '2015-02-01 00:27:59.000000', 'temperatura', 520.0000, 'ºC'),
	(339888, 144, '2015-02-01 00:28:00.000000', 'temperatura', 742.0000, 'ºC'),
	(339889, 144, '2015-02-01 00:28:01.000000', 'temperatura', 950.0000, 'ºC'),
	(339890, 144, '2015-02-01 00:28:02.000000', 'temperatura', 126.0000, 'ºC'),
	(339891, 144, '2015-02-01 00:28:03.000000', 'temperatura', 179.0000, 'ºC'),
	(339892, 144, '2015-02-01 00:28:04.000000', 'temperatura', 519.0000, 'ºC'),
	(339893, 144, '2015-02-01 00:28:05.000000', 'temperatura', 860.0000, 'ºC'),
	(339894, 144, '2015-02-01 00:28:06.000000', 'temperatura', 340.0000, 'ºC'),
	(339895, 144, '2015-02-01 00:28:07.000000', 'temperatura', 322.0000, 'ºC'),
	(339896, 144, '2015-02-01 00:28:08.000000', 'temperatura', 591.0000, 'ºC'),
	(339897, 144, '2015-02-01 00:28:09.000000', 'temperatura', 791.0000, 'ºC'),
	(339898, 144, '2015-02-01 00:28:10.000000', 'temperatura', 980.0000, 'ºC'),
	(339899, 144, '2015-02-01 00:28:11.000000', 'temperatura', 127.0000, 'ºC'),
	(339900, 144, '2015-02-01 00:28:12.000000', 'temperatura', 96.0000, 'ºC'),
	(339901, 144, '2015-02-01 00:28:13.000000', 'temperatura', 100.0000, 'ºC'),
	(339902, 144, '2015-02-01 00:28:14.000000', 'temperatura', 213.0000, 'ºC'),
	(339903, 144, '2015-02-01 00:28:15.000000', 'temperatura', 766.0000, 'ºC'),
	(339904, 144, '2015-02-01 00:28:16.000000', 'temperatura', 791.0000, 'ºC'),
	(339905, 144, '2015-02-01 00:28:17.000000', 'temperatura', 457.0000, 'ºC'),
	(339906, 144, '2015-02-01 00:28:18.000000', 'temperatura', 1114.0000, 'ºC'),
	(339907, 144, '2015-02-01 00:28:19.000000', 'temperatura', 599.0000, 'ºC'),
	(339908, 144, '2015-02-01 00:28:20.000000', 'temperatura', 852.0000, 'ºC'),
	(339909, 144, '2015-02-01 00:28:21.000000', 'temperatura', 66.0000, 'ºC'),
	(339910, 144, '2015-02-01 00:28:22.000000', 'temperatura', 171.0000, 'ºC'),
	(339911, 144, '2015-02-01 00:28:23.000000', 'temperatura', 661.0000, 'ºC'),
	(339912, 144, '2015-02-01 00:28:24.000000', 'temperatura', 392.0000, 'ºC'),
	(339913, 144, '2015-02-01 00:28:25.000000', 'temperatura', 1176.0000, 'ºC'),
	(339914, 144, '2015-02-01 00:28:26.000000', 'temperatura', 1107.0000, 'ºC'),
	(339915, 144, '2015-02-01 00:28:27.000000', 'temperatura', 808.0000, 'ºC'),
	(339916, 144, '2015-02-01 00:28:28.000000', 'temperatura', 716.0000, 'ºC'),
	(339917, 144, '2015-02-01 00:28:29.000000', 'temperatura', 1159.0000, 'ºC'),
	(339918, 144, '2015-02-01 00:28:30.000000', 'temperatura', 47.0000, 'ºC'),
	(339919, 144, '2015-02-01 00:28:31.000000', 'temperatura', 358.0000, 'ºC'),
	(339920, 144, '2015-02-01 00:28:32.000000', 'temperatura', 449.0000, 'ºC'),
	(339921, 144, '2015-02-01 00:28:33.000000', 'temperatura', 1172.0000, 'ºC'),
	(339922, 144, '2015-02-01 00:28:34.000000', 'temperatura', 912.0000, 'ºC'),
	(339923, 144, '2015-02-01 00:28:35.000000', 'temperatura', 1048.0000, 'ºC'),
	(339924, 144, '2015-02-01 00:28:36.000000', 'temperatura', 102.0000, 'ºC'),
	(339925, 144, '2015-02-01 00:28:37.000000', 'temperatura', 965.0000, 'ºC'),
	(339926, 144, '2015-02-01 00:28:38.000000', 'temperatura', 921.0000, 'ºC'),
	(339927, 144, '2015-02-01 00:28:39.000000', 'temperatura', 512.0000, 'ºC'),
	(339928, 144, '2015-02-01 00:28:40.000000', 'temperatura', 998.0000, 'ºC'),
	(339929, 144, '2015-02-01 00:28:41.000000', 'temperatura', 1052.0000, 'ºC'),
	(339930, 144, '2015-02-01 00:28:42.000000', 'temperatura', 1067.0000, 'ºC'),
	(339931, 144, '2015-02-01 00:28:43.000000', 'temperatura', 978.0000, 'ºC'),
	(339932, 144, '2015-02-01 00:28:44.000000', 'temperatura', 490.0000, 'ºC'),
	(339933, 144, '2015-02-01 00:28:45.000000', 'temperatura', 719.0000, 'ºC'),
	(339934, 144, '2015-02-01 00:28:46.000000', 'temperatura', 924.0000, 'ºC'),
	(339935, 144, '2015-02-01 00:28:47.000000', 'temperatura', 64.0000, 'ºC'),
	(339936, 144, '2015-02-01 00:28:48.000000', 'temperatura', 1147.0000, 'ºC'),
	(339937, 144, '2015-02-01 00:28:49.000000', 'temperatura', 745.0000, 'ºC'),
	(339938, 144, '2015-02-01 00:28:50.000000', 'temperatura', 286.0000, 'ºC'),
	(339939, 144, '2015-02-01 00:28:51.000000', 'temperatura', 394.0000, 'ºC'),
	(339940, 144, '2015-02-01 00:28:52.000000', 'temperatura', 1113.0000, 'ºC'),
	(339941, 144, '2015-02-01 00:28:53.000000', 'temperatura', 782.0000, 'ºC'),
	(339942, 144, '2015-02-01 00:28:54.000000', 'temperatura', 573.0000, 'ºC'),
	(339943, 144, '2015-02-01 00:28:55.000000', 'temperatura', 521.0000, 'ºC'),
	(339944, 144, '2015-02-01 00:28:56.000000', 'temperatura', 885.0000, 'ºC'),
	(339945, 144, '2015-02-01 00:28:57.000000', 'temperatura', 463.0000, 'ºC'),
	(339946, 144, '2015-02-01 00:28:58.000000', 'temperatura', 861.0000, 'ºC'),
	(339947, 144, '2015-02-01 00:28:59.000000', 'temperatura', 515.0000, 'ºC'),
	(339948, 144, '2015-02-01 00:29:00.000000', 'temperatura', 1193.0000, 'ºC'),
	(339949, 144, '2015-02-01 00:29:01.000000', 'temperatura', 822.0000, 'ºC'),
	(339950, 144, '2015-02-01 00:29:02.000000', 'temperatura', 532.0000, 'ºC'),
	(339951, 144, '2015-02-01 00:29:03.000000', 'temperatura', 192.0000, 'ºC'),
	(339952, 144, '2015-02-01 00:29:04.000000', 'temperatura', 566.0000, 'ºC'),
	(339953, 144, '2015-02-01 00:29:05.000000', 'temperatura', 1054.0000, 'ºC'),
	(339954, 144, '2015-02-01 00:29:06.000000', 'temperatura', 1173.0000, 'ºC'),
	(339955, 144, '2015-02-01 00:29:07.000000', 'temperatura', 301.0000, 'ºC'),
	(339956, 144, '2015-02-01 00:29:08.000000', 'temperatura', 389.0000, 'ºC'),
	(339957, 144, '2015-02-01 00:29:09.000000', 'temperatura', 1044.0000, 'ºC'),
	(339958, 144, '2015-02-01 00:29:10.000000', 'temperatura', 451.0000, 'ºC'),
	(339959, 144, '2015-02-01 00:29:11.000000', 'temperatura', 326.0000, 'ºC'),
	(339960, 144, '2015-02-01 00:29:12.000000', 'temperatura', 276.0000, 'ºC'),
	(339961, 144, '2015-02-01 00:29:13.000000', 'temperatura', 404.0000, 'ºC'),
	(339962, 144, '2015-02-01 00:29:14.000000', 'temperatura', 1192.0000, 'ºC'),
	(339963, 144, '2015-02-01 00:29:15.000000', 'temperatura', 1149.0000, 'ºC'),
	(339964, 144, '2015-02-01 00:29:16.000000', 'temperatura', 968.0000, 'ºC'),
	(339965, 144, '2015-02-01 00:29:17.000000', 'temperatura', 194.0000, 'ºC'),
	(339966, 144, '2015-02-01 00:29:18.000000', 'temperatura', 467.0000, 'ºC'),
	(339967, 144, '2015-02-01 00:29:19.000000', 'temperatura', 553.0000, 'ºC'),
	(339968, 144, '2015-02-01 00:29:20.000000', 'temperatura', 167.0000, 'ºC'),
	(339969, 144, '2015-02-01 00:29:21.000000', 'temperatura', 374.0000, 'ºC'),
	(339970, 144, '2015-02-01 00:29:22.000000', 'temperatura', 170.0000, 'ºC'),
	(339971, 144, '2015-02-01 00:29:23.000000', 'temperatura', 930.0000, 'ºC'),
	(339972, 144, '2015-02-01 00:29:24.000000', 'temperatura', 538.0000, 'ºC'),
	(339973, 144, '2015-02-01 00:29:25.000000', 'temperatura', 1102.0000, 'ºC'),
	(339974, 144, '2015-02-01 00:29:26.000000', 'temperatura', 298.0000, 'ºC'),
	(339975, 144, '2015-02-01 00:29:27.000000', 'temperatura', 585.0000, 'ºC'),
	(339976, 144, '2015-02-01 00:29:28.000000', 'temperatura', 829.0000, 'ºC'),
	(339977, 144, '2015-02-01 00:29:29.000000', 'temperatura', 1190.0000, 'ºC'),
	(339978, 144, '2015-02-01 00:29:30.000000', 'temperatura', 1065.0000, 'ºC'),
	(339979, 144, '2015-02-01 00:29:31.000000', 'temperatura', 553.0000, 'ºC'),
	(339980, 144, '2015-02-01 00:29:32.000000', 'temperatura', 773.0000, 'ºC'),
	(339981, 144, '2015-02-01 00:29:33.000000', 'temperatura', 1006.0000, 'ºC'),
	(339982, 144, '2015-02-01 00:29:34.000000', 'temperatura', 311.0000, 'ºC'),
	(339983, 144, '2015-02-01 00:29:35.000000', 'temperatura', 938.0000, 'ºC'),
	(339984, 144, '2015-02-01 00:29:36.000000', 'temperatura', 157.0000, 'ºC'),
	(339985, 144, '2015-02-01 00:29:37.000000', 'temperatura', 370.0000, 'ºC'),
	(339986, 144, '2015-02-01 00:29:38.000000', 'temperatura', 180.0000, 'ºC'),
	(339987, 144, '2015-02-01 00:29:39.000000', 'temperatura', 992.0000, 'ºC'),
	(339988, 144, '2015-02-01 00:29:40.000000', 'temperatura', 820.0000, 'ºC'),
	(339989, 144, '2015-02-01 00:29:41.000000', 'temperatura', 1125.0000, 'ºC'),
	(339990, 144, '2015-02-01 00:29:42.000000', 'temperatura', 765.0000, 'ºC'),
	(339991, 144, '2015-02-01 00:29:43.000000', 'temperatura', 452.0000, 'ºC'),
	(339992, 144, '2015-02-01 00:29:44.000000', 'temperatura', 1164.0000, 'ºC'),
	(339993, 144, '2015-02-01 00:29:45.000000', 'temperatura', 863.0000, 'ºC'),
	(339994, 144, '2015-02-01 00:29:46.000000', 'temperatura', 825.0000, 'ºC'),
	(339995, 144, '2015-02-01 00:29:47.000000', 'temperatura', 336.0000, 'ºC'),
	(339996, 144, '2015-02-01 00:29:48.000000', 'temperatura', 405.0000, 'ºC'),
	(339997, 144, '2015-02-01 00:29:49.000000', 'temperatura', 1016.0000, 'ºC'),
	(339998, 144, '2015-02-01 00:29:50.000000', 'temperatura', 266.0000, 'ºC'),
	(339999, 144, '2015-02-01 00:29:51.000000', 'temperatura', 685.0000, 'ºC'),
	(340000, 144, '2015-02-01 00:29:52.000000', 'temperatura', 227.0000, 'ºC'),
	(340001, 144, '2015-02-01 00:29:53.000000', 'temperatura', 279.0000, 'ºC'),
	(340002, 144, '2015-02-01 00:29:54.000000', 'temperatura', 717.0000, 'ºC'),
	(340003, 144, '2015-02-01 00:29:55.000000', 'temperatura', 346.0000, 'ºC'),
	(340004, 144, '2015-02-01 00:29:56.000000', 'temperatura', 781.0000, 'ºC'),
	(340005, 144, '2015-02-01 00:29:57.000000', 'temperatura', 469.0000, 'ºC'),
	(340006, 144, '2015-02-01 00:29:58.000000', 'temperatura', 0.0000, 'ºC'),
	(340007, 144, '2015-02-01 00:29:59.000000', 'temperatura', 994.0000, 'ºC'),
	(340008, 144, '2015-02-01 00:30:00.000000', 'temperatura', 169.0000, 'ºC'),
	(340009, 144, '2015-02-01 00:30:01.000000', 'temperatura', 264.0000, 'ºC'),
	(340010, 144, '2015-02-01 00:30:02.000000', 'temperatura', 812.0000, 'ºC'),
	(340011, 144, '2015-02-01 00:30:03.000000', 'temperatura', 871.0000, 'ºC'),
	(340012, 144, '2015-02-01 00:30:04.000000', 'temperatura', 718.0000, 'ºC'),
	(340013, 144, '2015-02-01 00:30:05.000000', 'temperatura', 979.0000, 'ºC'),
	(340014, 144, '2015-02-01 00:30:06.000000', 'temperatura', 340.0000, 'ºC'),
	(340015, 144, '2015-02-01 00:30:07.000000', 'temperatura', 1163.0000, 'ºC'),
	(340016, 144, '2015-02-01 00:30:08.000000', 'temperatura', 1195.0000, 'ºC'),
	(340017, 144, '2015-02-01 00:30:09.000000', 'temperatura', 87.0000, 'ºC'),
	(340018, 144, '2015-02-01 00:30:10.000000', 'temperatura', 451.0000, 'ºC'),
	(340019, 144, '2015-02-01 00:30:11.000000', 'temperatura', 793.0000, 'ºC'),
	(340020, 144, '2015-02-01 00:30:12.000000', 'temperatura', 214.0000, 'ºC'),
	(340021, 144, '2015-02-01 00:30:13.000000', 'temperatura', 1090.0000, 'ºC'),
	(340022, 144, '2015-02-01 00:30:14.000000', 'temperatura', 8.0000, 'ºC'),
	(340023, 144, '2015-02-01 00:30:15.000000', 'temperatura', 372.0000, 'ºC'),
	(340024, 144, '2015-02-01 00:30:16.000000', 'temperatura', 637.0000, 'ºC'),
	(340025, 144, '2015-02-01 00:30:17.000000', 'temperatura', 870.0000, 'ºC'),
	(340026, 144, '2015-02-01 00:30:18.000000', 'temperatura', 38.0000, 'ºC'),
	(340027, 144, '2015-02-01 00:30:19.000000', 'temperatura', 1183.0000, 'ºC'),
	(340028, 144, '2015-02-01 00:30:20.000000', 'temperatura', 1000.0000, 'ºC'),
	(340029, 144, '2015-02-01 00:30:21.000000', 'temperatura', 253.0000, 'ºC'),
	(340030, 144, '2015-02-01 00:30:22.000000', 'temperatura', 663.0000, 'ºC'),
	(340031, 144, '2015-02-01 00:30:23.000000', 'temperatura', 159.0000, 'ºC'),
	(340032, 144, '2015-02-01 00:30:24.000000', 'temperatura', 5.0000, 'ºC'),
	(340033, 144, '2015-02-01 00:30:25.000000', 'temperatura', 748.0000, 'ºC'),
	(340034, 144, '2015-02-01 00:30:26.000000', 'temperatura', 125.0000, 'ºC'),
	(340035, 144, '2015-02-01 00:30:27.000000', 'temperatura', 783.0000, 'ºC'),
	(340036, 144, '2015-02-01 00:30:28.000000', 'temperatura', 1140.0000, 'ºC'),
	(340037, 144, '2015-02-01 00:30:29.000000', 'temperatura', 952.0000, 'ºC'),
	(340038, 144, '2015-02-01 00:30:30.000000', 'temperatura', 139.0000, 'ºC'),
	(340039, 144, '2015-02-01 00:30:31.000000', 'temperatura', 240.0000, 'ºC'),
	(340040, 144, '2015-02-01 00:30:32.000000', 'temperatura', 785.0000, 'ºC'),
	(340041, 144, '2015-02-01 00:30:33.000000', 'temperatura', 805.0000, 'ºC'),
	(340042, 144, '2015-02-01 00:30:34.000000', 'temperatura', 472.0000, 'ºC'),
	(340043, 144, '2015-02-01 00:30:35.000000', 'temperatura', 1144.0000, 'ºC'),
	(340044, 144, '2015-02-01 00:30:36.000000', 'temperatura', 705.0000, 'ºC'),
	(340045, 144, '2015-02-01 00:30:37.000000', 'temperatura', 94.0000, 'ºC'),
	(340046, 144, '2015-02-01 00:30:38.000000', 'temperatura', 755.0000, 'ºC'),
	(340047, 144, '2015-02-01 00:30:39.000000', 'temperatura', 1092.0000, 'ºC'),
	(340048, 144, '2015-02-01 00:30:40.000000', 'temperatura', 798.0000, 'ºC'),
	(340049, 144, '2015-02-01 00:30:41.000000', 'temperatura', 714.0000, 'ºC'),
	(340050, 144, '2015-02-01 00:30:42.000000', 'temperatura', 1178.0000, 'ºC'),
	(340051, 144, '2015-02-01 00:30:43.000000', 'temperatura', 148.0000, 'ºC'),
	(340052, 144, '2015-02-01 00:30:44.000000', 'temperatura', 804.0000, 'ºC'),
	(340053, 144, '2015-02-01 00:30:45.000000', 'temperatura', 1180.0000, 'ºC'),
	(340054, 144, '2015-02-01 00:30:46.000000', 'temperatura', 1087.0000, 'ºC'),
	(340055, 144, '2015-02-01 00:30:47.000000', 'temperatura', 695.0000, 'ºC'),
	(340056, 144, '2015-02-01 00:30:48.000000', 'temperatura', 215.0000, 'ºC'),
	(340057, 144, '2015-02-01 00:30:49.000000', 'temperatura', 191.0000, 'ºC'),
	(340058, 144, '2015-02-01 00:30:50.000000', 'temperatura', 311.0000, 'ºC'),
	(340059, 144, '2015-02-01 00:30:51.000000', 'temperatura', 982.0000, 'ºC'),
	(340060, 144, '2015-02-01 00:30:52.000000', 'temperatura', 378.0000, 'ºC'),
	(340061, 144, '2015-02-01 00:30:53.000000', 'temperatura', 145.0000, 'ºC'),
	(340062, 144, '2015-02-01 00:30:54.000000', 'temperatura', 793.0000, 'ºC'),
	(340063, 144, '2015-02-01 00:30:55.000000', 'temperatura', 1127.0000, 'ºC'),
	(340064, 144, '2015-02-01 00:30:56.000000', 'temperatura', 857.0000, 'ºC'),
	(340065, 144, '2015-02-01 00:30:57.000000', 'temperatura', 907.0000, 'ºC'),
	(340066, 144, '2015-02-01 00:30:58.000000', 'temperatura', 764.0000, 'ºC'),
	(340067, 144, '2015-02-01 00:30:59.000000', 'temperatura', 1100.0000, 'ºC'),
	(340068, 144, '2015-02-01 00:31:00.000000', 'temperatura', 807.0000, 'ºC'),
	(340069, 144, '2015-02-01 00:31:01.000000', 'temperatura', 736.0000, 'ºC'),
	(340070, 144, '2015-02-01 00:31:02.000000', 'temperatura', 57.0000, 'ºC'),
	(340071, 144, '2015-02-01 00:31:03.000000', 'temperatura', 481.0000, 'ºC'),
	(340072, 144, '2015-02-01 00:31:04.000000', 'temperatura', 1034.0000, 'ºC'),
	(340073, 144, '2015-02-01 00:31:05.000000', 'temperatura', 129.0000, 'ºC'),
	(340074, 144, '2015-02-01 00:31:06.000000', 'temperatura', 1141.0000, 'ºC'),
	(340075, 144, '2015-02-01 00:31:07.000000', 'temperatura', 518.0000, 'ºC'),
	(340076, 144, '2015-02-01 00:31:08.000000', 'temperatura', 369.0000, 'ºC'),
	(340077, 144, '2015-02-01 00:31:09.000000', 'temperatura', 291.0000, 'ºC'),
	(340078, 144, '2015-02-01 00:31:10.000000', 'temperatura', 350.0000, 'ºC'),
	(340079, 144, '2015-02-01 00:31:11.000000', 'temperatura', 875.0000, 'ºC'),
	(340080, 144, '2015-02-01 00:31:12.000000', 'temperatura', 928.0000, 'ºC'),
	(340081, 144, '2015-02-01 00:31:13.000000', 'temperatura', 813.0000, 'ºC'),
	(340082, 144, '2015-02-01 00:31:14.000000', 'temperatura', 82.0000, 'ºC'),
	(340083, 144, '2015-02-01 00:31:15.000000', 'temperatura', 374.0000, 'ºC'),
	(340084, 144, '2015-02-01 00:31:16.000000', 'temperatura', 422.0000, 'ºC'),
	(340085, 144, '2015-02-01 00:31:17.000000', 'temperatura', 988.0000, 'ºC'),
	(340086, 144, '2015-02-01 00:31:18.000000', 'temperatura', 76.0000, 'ºC'),
	(340087, 144, '2015-02-01 00:31:19.000000', 'temperatura', 1016.0000, 'ºC'),
	(340088, 144, '2015-02-01 00:31:20.000000', 'temperatura', 52.0000, 'ºC'),
	(340089, 144, '2015-02-01 00:31:21.000000', 'temperatura', 813.0000, 'ºC'),
	(340090, 144, '2015-02-01 00:31:22.000000', 'temperatura', 308.0000, 'ºC'),
	(340091, 144, '2015-02-01 00:31:23.000000', 'temperatura', 303.0000, 'ºC'),
	(340092, 144, '2015-02-01 00:31:24.000000', 'temperatura', 591.0000, 'ºC'),
	(340093, 144, '2015-02-01 00:31:25.000000', 'temperatura', 849.0000, 'ºC'),
	(340094, 144, '2015-02-01 00:31:26.000000', 'temperatura', 69.0000, 'ºC'),
	(340095, 144, '2015-02-01 00:31:27.000000', 'temperatura', 201.0000, 'ºC'),
	(340096, 144, '2015-02-01 00:31:28.000000', 'temperatura', 796.0000, 'ºC'),
	(340097, 144, '2015-02-01 00:31:29.000000', 'temperatura', 978.0000, 'ºC'),
	(340098, 144, '2015-02-01 00:31:30.000000', 'temperatura', 105.0000, 'ºC'),
	(340099, 144, '2015-02-01 00:31:31.000000', 'temperatura', 1190.0000, 'ºC'),
	(340100, 144, '2015-02-01 00:31:32.000000', 'temperatura', 834.0000, 'ºC'),
	(340101, 144, '2015-02-01 00:31:33.000000', 'temperatura', 604.0000, 'ºC'),
	(340102, 144, '2015-02-01 00:31:34.000000', 'temperatura', 515.0000, 'ºC'),
	(340103, 144, '2015-02-01 00:31:35.000000', 'temperatura', 766.0000, 'ºC'),
	(340104, 144, '2015-02-01 00:31:36.000000', 'temperatura', 1085.0000, 'ºC'),
	(340105, 144, '2015-02-01 00:31:37.000000', 'temperatura', 729.0000, 'ºC'),
	(340106, 144, '2015-02-01 00:31:38.000000', 'temperatura', 390.0000, 'ºC'),
	(340107, 144, '2015-02-01 00:31:39.000000', 'temperatura', 964.0000, 'ºC'),
	(340108, 144, '2015-02-01 00:31:40.000000', 'temperatura', 52.0000, 'ºC'),
	(340109, 144, '2015-02-01 00:31:41.000000', 'temperatura', 966.0000, 'ºC'),
	(340110, 144, '2015-02-01 00:31:42.000000', 'temperatura', 1074.0000, 'ºC'),
	(340111, 144, '2015-02-01 00:31:43.000000', 'temperatura', 75.0000, 'ºC'),
	(340112, 144, '2015-02-01 00:31:44.000000', 'temperatura', 754.0000, 'ºC'),
	(340113, 144, '2015-02-01 00:31:45.000000', 'temperatura', 1145.0000, 'ºC'),
	(340114, 144, '2015-02-01 00:31:46.000000', 'temperatura', 1063.0000, 'ºC'),
	(340115, 144, '2015-02-01 00:31:47.000000', 'temperatura', 682.0000, 'ºC'),
	(340116, 144, '2015-02-01 00:31:48.000000', 'temperatura', 220.0000, 'ºC'),
	(340117, 144, '2015-02-01 00:31:49.000000', 'temperatura', 255.0000, 'ºC'),
	(340118, 144, '2015-02-01 00:31:50.000000', 'temperatura', 616.0000, 'ºC'),
	(340119, 144, '2015-02-01 00:31:51.000000', 'temperatura', 1115.0000, 'ºC'),
	(340120, 144, '2015-02-01 00:31:52.000000', 'temperatura', 129.0000, 'ºC'),
	(340121, 144, '2015-02-01 00:31:53.000000', 'temperatura', 898.0000, 'ºC'),
	(340122, 144, '2015-02-01 00:31:54.000000', 'temperatura', 504.0000, 'ºC'),
	(340123, 144, '2015-02-01 00:31:55.000000', 'temperatura', 1026.0000, 'ºC'),
	(340124, 144, '2015-02-01 00:31:56.000000', 'temperatura', 21.0000, 'ºC'),
	(340125, 144, '2015-02-01 00:31:57.000000', 'temperatura', 626.0000, 'ºC'),
	(340126, 144, '2015-02-01 00:31:58.000000', 'temperatura', 667.0000, 'ºC'),
	(340127, 144, '2015-02-01 00:31:59.000000', 'temperatura', 257.0000, 'ºC'),
	(340128, 144, '2015-02-01 00:32:00.000000', 'temperatura', 487.0000, 'ºC'),
	(340129, 144, '2015-02-01 00:32:01.000000', 'temperatura', 461.0000, 'ºC'),
	(340130, 144, '2015-02-01 00:32:02.000000', 'temperatura', 848.0000, 'ºC'),
	(340131, 144, '2015-02-01 00:32:03.000000', 'temperatura', 455.0000, 'ºC'),
	(340132, 144, '2015-02-01 00:32:04.000000', 'temperatura', 930.0000, 'ºC'),
	(340133, 144, '2015-02-01 00:32:05.000000', 'temperatura', 888.0000, 'ºC'),
	(340134, 144, '2015-02-01 00:32:06.000000', 'temperatura', 451.0000, 'ºC'),
	(340135, 144, '2015-02-01 00:32:07.000000', 'temperatura', 792.0000, 'ºC'),
	(340136, 144, '2015-02-01 00:32:08.000000', 'temperatura', 208.0000, 'ºC'),
	(340137, 144, '2015-02-01 00:32:09.000000', 'temperatura', 1065.0000, 'ºC'),
	(340138, 144, '2015-02-01 00:32:10.000000', 'temperatura', 1102.0000, 'ºC'),
	(340139, 144, '2015-02-01 00:32:11.000000', 'temperatura', 1115.0000, 'ºC'),
	(340140, 144, '2015-02-01 00:32:12.000000', 'temperatura', 1068.0000, 'ºC'),
	(340141, 144, '2015-02-01 00:32:13.000000', 'temperatura', 795.0000, 'ºC'),
	(340142, 144, '2015-02-01 00:32:14.000000', 'temperatura', 773.0000, 'ºC'),
	(340143, 144, '2015-02-01 00:32:15.000000', 'temperatura', 278.0000, 'ºC'),
	(340144, 144, '2015-02-01 00:32:16.000000', 'temperatura', 273.0000, 'ºC'),
	(340145, 144, '2015-02-01 00:32:17.000000', 'temperatura', 531.0000, 'ºC'),
	(340146, 144, '2015-02-01 00:32:18.000000', 'temperatura', 635.0000, 'ºC'),
	(340147, 144, '2015-02-01 00:32:19.000000', 'temperatura', 385.0000, 'ºC'),
	(340148, 144, '2015-02-01 00:32:20.000000', 'temperatura', 19.0000, 'ºC'),
	(340149, 144, '2015-02-01 00:32:21.000000', 'temperatura', 142.0000, 'ºC'),
	(340150, 144, '2015-02-01 00:32:22.000000', 'temperatura', 654.0000, 'ºC'),
	(340151, 144, '2015-02-01 00:32:23.000000', 'temperatura', 442.0000, 'ºC'),
	(340152, 144, '2015-02-01 00:32:24.000000', 'temperatura', 251.0000, 'ºC'),
	(340153, 144, '2015-02-01 00:32:25.000000', 'temperatura', 1127.0000, 'ºC'),
	(340154, 144, '2015-02-01 00:32:26.000000', 'temperatura', 83.0000, 'ºC'),
	(340155, 144, '2015-02-01 00:32:27.000000', 'temperatura', 634.0000, 'ºC'),
	(340156, 144, '2015-02-01 00:32:28.000000', 'temperatura', 523.0000, 'ºC'),
	(340157, 144, '2015-02-01 00:32:29.000000', 'temperatura', 712.0000, 'ºC'),
	(340158, 144, '2015-02-01 00:32:30.000000', 'temperatura', 791.0000, 'ºC'),
	(340159, 144, '2015-02-01 00:32:31.000000', 'temperatura', 621.0000, 'ºC'),
	(340160, 144, '2015-02-01 00:32:32.000000', 'temperatura', 732.0000, 'ºC'),
	(340161, 144, '2015-02-01 00:32:33.000000', 'temperatura', 599.0000, 'ºC'),
	(340162, 144, '2015-02-01 00:32:34.000000', 'temperatura', 800.0000, 'ºC'),
	(340163, 144, '2015-02-01 00:32:35.000000', 'temperatura', 1003.0000, 'ºC'),
	(340164, 144, '2015-02-01 00:32:36.000000', 'temperatura', 216.0000, 'ºC'),
	(340165, 144, '2015-02-01 00:32:37.000000', 'temperatura', 472.0000, 'ºC'),
	(340166, 144, '2015-02-01 00:32:38.000000', 'temperatura', 512.0000, 'ºC'),
	(340167, 144, '2015-02-01 00:32:39.000000', 'temperatura', 1144.0000, 'ºC'),
	(340168, 144, '2015-02-01 00:32:40.000000', 'temperatura', 585.0000, 'ºC'),
	(340169, 144, '2015-02-01 00:32:41.000000', 'temperatura', 692.0000, 'ºC'),
	(340170, 144, '2015-02-01 00:32:42.000000', 'temperatura', 505.0000, 'ºC'),
	(340171, 144, '2015-02-01 00:32:43.000000', 'temperatura', 451.0000, 'ºC'),
	(340172, 144, '2015-02-01 00:32:44.000000', 'temperatura', 738.0000, 'ºC'),
	(340173, 144, '2015-02-01 00:32:45.000000', 'temperatura', 1140.0000, 'ºC'),
	(340174, 144, '2015-02-01 00:32:46.000000', 'temperatura', 1086.0000, 'ºC'),
	(340175, 144, '2015-02-01 00:32:47.000000', 'temperatura', 810.0000, 'ºC'),
	(340176, 144, '2015-02-01 00:32:48.000000', 'temperatura', 793.0000, 'ºC'),
	(340177, 144, '2015-02-01 00:32:49.000000', 'temperatura', 335.0000, 'ºC'),
	(340178, 144, '2015-02-01 00:32:50.000000', 'temperatura', 498.0000, 'ºC'),
	(340179, 144, '2015-02-01 00:32:51.000000', 'temperatura', 284.0000, 'ºC'),
	(340180, 144, '2015-02-01 00:32:52.000000', 'temperatura', 1128.0000, 'ºC'),
	(340181, 144, '2015-02-01 00:32:53.000000', 'temperatura', 1186.0000, 'ºC'),
	(340182, 144, '2015-02-01 00:32:54.000000', 'temperatura', 146.0000, 'ºC'),
	(340183, 144, '2015-02-01 00:32:55.000000', 'temperatura', 775.0000, 'ºC'),
	(340184, 144, '2015-02-01 00:32:56.000000', 'temperatura', 1035.0000, 'ºC'),
	(340185, 144, '2015-02-01 00:32:57.000000', 'temperatura', 452.0000, 'ºC'),
	(340186, 144, '2015-02-01 00:32:58.000000', 'temperatura', 356.0000, 'ºC'),
	(340187, 144, '2015-02-01 00:32:59.000000', 'temperatura', 423.0000, 'ºC'),
	(340188, 144, '2015-02-01 00:33:00.000000', 'temperatura', 1049.0000, 'ºC'),
	(340189, 144, '2015-02-01 00:33:01.000000', 'temperatura', 376.0000, 'ºC'),
	(340190, 144, '2015-02-01 00:33:02.000000', 'temperatura', 1132.0000, 'ºC'),
	(340191, 144, '2015-02-01 00:33:03.000000', 'temperatura', 932.0000, 'ºC'),
	(340192, 144, '2015-02-01 00:33:04.000000', 'temperatura', 65.0000, 'ºC'),
	(340193, 144, '2015-02-01 00:33:05.000000', 'temperatura', 1129.0000, 'ºC'),
	(340194, 144, '2015-02-01 00:33:06.000000', 'temperatura', 652.0000, 'ºC'),
	(340195, 144, '2015-02-01 00:33:07.000000', 'temperatura', 1075.0000, 'ºC'),
	(340196, 144, '2015-02-01 00:33:08.000000', 'temperatura', 1016.0000, 'ºC'),
	(340197, 144, '2015-02-01 00:33:09.000000', 'temperatura', 658.0000, 'ºC'),
	(340198, 144, '2015-02-01 00:33:10.000000', 'temperatura', 241.0000, 'ºC'),
	(340199, 144, '2015-02-01 00:33:11.000000', 'temperatura', 434.0000, 'ºC'),
	(340200, 144, '2015-02-01 00:33:12.000000', 'temperatura', 246.0000, 'ºC'),
	(340201, 144, '2015-02-01 00:33:13.000000', 'temperatura', 1128.0000, 'ºC'),
	(340202, 144, '2015-02-01 00:33:14.000000', 'temperatura', 102.0000, 'ºC'),
	(340203, 144, '2015-02-01 00:33:15.000000', 'temperatura', 729.0000, 'ºC'),
	(340204, 144, '2015-02-01 00:33:16.000000', 'temperatura', 937.0000, 'ºC'),
	(340205, 144, '2015-02-01 00:33:17.000000', 'temperatura', 99.0000, 'ºC'),
	(340206, 144, '2015-02-01 00:33:18.000000', 'temperatura', 87.0000, 'ºC'),
	(340207, 144, '2015-02-01 00:33:19.000000', 'temperatura', 135.0000, 'ºC'),
	(340208, 144, '2015-02-01 00:33:20.000000', 'temperatura', 416.0000, 'ºC'),
	(340209, 144, '2015-02-01 00:33:21.000000', 'temperatura', 476.0000, 'ºC'),
	(340210, 144, '2015-02-01 00:33:22.000000', 'temperatura', 1133.0000, 'ºC'),
	(340211, 144, '2015-02-01 00:33:23.000000', 'temperatura', 635.0000, 'ºC'),
	(340212, 144, '2015-02-01 00:33:24.000000', 'temperatura', 979.0000, 'ºC'),
	(340213, 144, '2015-02-01 00:33:25.000000', 'temperatura', 588.0000, 'ºC'),
	(340214, 144, '2015-02-01 00:33:26.000000', 'temperatura', 6.0000, 'ºC'),
	(340215, 144, '2015-02-01 00:33:27.000000', 'temperatura', 664.0000, 'ºC'),
	(340216, 144, '2015-02-01 00:33:28.000000', 'temperatura', 905.0000, 'ºC'),
	(340217, 144, '2015-02-01 00:33:29.000000', 'temperatura', 134.0000, 'ºC'),
	(340218, 144, '2015-02-01 00:33:30.000000', 'temperatura', 356.0000, 'ºC'),
	(340219, 144, '2015-02-01 00:33:31.000000', 'temperatura', 178.0000, 'ºC'),
	(340220, 144, '2015-02-01 00:33:32.000000', 'temperatura', 1020.0000, 'ºC'),
	(340221, 144, '2015-02-01 00:33:33.000000', 'temperatura', 969.0000, 'ºC'),
	(340222, 144, '2015-02-01 00:33:34.000000', 'temperatura', 587.0000, 'ºC'),
	(340223, 144, '2015-02-01 00:33:35.000000', 'temperatura', 26.0000, 'ºC'),
	(340224, 144, '2015-02-01 00:33:36.000000', 'temperatura', 769.0000, 'ºC'),
	(340225, 144, '2015-02-01 00:33:37.000000', 'temperatura', 167.0000, 'ºC'),
	(340226, 144, '2015-02-01 00:33:38.000000', 'temperatura', 928.0000, 'ºC'),
	(340227, 144, '2015-02-01 00:33:39.000000', 'temperatura', 539.0000, 'ºC'),
	(340228, 144, '2015-02-01 00:33:40.000000', 'temperatura', 1111.0000, 'ºC'),
	(340229, 144, '2015-02-01 00:33:41.000000', 'temperatura', 340.0000, 'ºC'),
	(340230, 144, '2015-02-01 00:33:42.000000', 'temperatura', 766.0000, 'ºC'),
	(340231, 144, '2015-02-01 00:33:43.000000', 'temperatura', 413.0000, 'ºC'),
	(340232, 144, '2015-02-01 00:33:44.000000', 'temperatura', 967.0000, 'ºC'),
	(340233, 144, '2015-02-01 00:33:45.000000', 'temperatura', 1197.0000, 'ºC'),
	(340234, 144, '2015-02-01 00:33:46.000000', 'temperatura', 684.0000, 'ºC'),
	(340235, 144, '2015-02-01 00:33:47.000000', 'temperatura', 1028.0000, 'ºC'),
	(340236, 144, '2015-02-01 00:33:48.000000', 'temperatura', 691.0000, 'ºC'),
	(340237, 144, '2015-02-01 00:33:49.000000', 'temperatura', 368.0000, 'ºC'),
	(340238, 144, '2015-02-01 00:33:50.000000', 'temperatura', 971.0000, 'ºC'),
	(340239, 144, '2015-02-01 00:33:51.000000', 'temperatura', 149.0000, 'ºC'),
	(340240, 144, '2015-02-01 00:33:52.000000', 'temperatura', 234.0000, 'ºC'),
	(340241, 144, '2015-02-01 00:33:53.000000', 'temperatura', 725.0000, 'ºC'),
	(340242, 144, '2015-02-01 00:33:54.000000', 'temperatura', 522.0000, 'ºC'),
	(340243, 144, '2015-02-01 00:33:55.000000', 'temperatura', 436.0000, 'ºC'),
	(340244, 144, '2015-02-01 00:33:56.000000', 'temperatura', 615.0000, 'ºC'),
	(340245, 144, '2015-02-01 00:33:57.000000', 'temperatura', 566.0000, 'ºC'),
	(340246, 144, '2015-02-01 00:33:58.000000', 'temperatura', 986.0000, 'ºC'),
	(340247, 144, '2015-02-01 00:33:59.000000', 'temperatura', 833.0000, 'ºC'),
	(340248, 144, '2015-02-01 00:34:00.000000', 'temperatura', 8.0000, 'ºC'),
	(340249, 144, '2015-02-01 00:34:01.000000', 'temperatura', 1143.0000, 'ºC'),
	(340250, 144, '2015-02-01 00:34:02.000000', 'temperatura', 889.0000, 'ºC'),
	(340251, 144, '2015-02-01 00:34:03.000000', 'temperatura', 1018.0000, 'ºC'),
	(340252, 144, '2015-02-01 00:34:04.000000', 'temperatura', 24.0000, 'ºC'),
	(340253, 144, '2015-02-01 00:34:05.000000', 'temperatura', 668.0000, 'ºC'),
	(340254, 144, '2015-02-01 00:34:06.000000', 'temperatura', 866.0000, 'ºC'),
	(340255, 144, '2015-02-01 00:34:07.000000', 'temperatura', 1127.0000, 'ºC'),
	(340256, 144, '2015-02-01 00:34:08.000000', 'temperatura', 638.0000, 'ºC'),
	(340257, 144, '2015-02-01 00:34:09.000000', 'temperatura', 1010.0000, 'ºC'),
	(340258, 144, '2015-02-01 00:34:10.000000', 'temperatura', 737.0000, 'ºC'),
	(340259, 144, '2015-02-01 00:34:11.000000', 'temperatura', 656.0000, 'ºC'),
	(340260, 144, '2015-02-01 00:34:12.000000', 'temperatura', 1069.0000, 'ºC'),
	(340261, 144, '2015-02-01 00:34:13.000000', 'temperatura', 978.0000, 'ºC'),
	(340262, 144, '2015-02-01 00:34:14.000000', 'temperatura', 484.0000, 'ºC'),
	(340263, 144, '2015-02-01 00:34:15.000000', 'temperatura', 686.0000, 'ºC'),
	(340264, 144, '2015-02-01 00:34:16.000000', 'temperatura', 779.0000, 'ºC'),
	(340265, 144, '2015-02-01 00:34:17.000000', 'temperatura', 637.0000, 'ºC'),
	(340266, 144, '2015-02-01 00:34:18.000000', 'temperatura', 849.0000, 'ºC'),
	(340267, 144, '2015-02-01 00:34:19.000000', 'temperatura', 1136.0000, 'ºC'),
	(340268, 144, '2015-02-01 00:34:20.000000', 'temperatura', 732.0000, 'ºC'),
	(340269, 144, '2015-02-01 00:34:21.000000', 'temperatura', 254.0000, 'ºC'),
	(340270, 144, '2015-02-01 00:34:22.000000', 'temperatura', 276.0000, 'ºC'),
	(340271, 144, '2015-02-01 00:34:23.000000', 'temperatura', 615.0000, 'ºC'),
	(340272, 144, '2015-02-01 00:34:24.000000', 'temperatura', 1050.0000, 'ºC'),
	(340273, 144, '2015-02-01 00:34:25.000000', 'temperatura', 1003.0000, 'ºC'),
	(340274, 144, '2015-02-01 00:34:26.000000', 'temperatura', 665.0000, 'ºC'),
	(340275, 144, '2015-02-01 00:34:27.000000', 'temperatura', 319.0000, 'ºC'),
	(340276, 144, '2015-02-01 00:34:28.000000', 'temperatura', 798.0000, 'ºC'),
	(340277, 144, '2015-02-01 00:34:29.000000', 'temperatura', 635.0000, 'ºC'),
	(340278, 144, '2015-02-01 00:34:30.000000', 'temperatura', 780.0000, 'ºC'),
	(340279, 144, '2015-02-01 00:34:31.000000', 'temperatura', 798.0000, 'ºC'),
	(340280, 144, '2015-02-01 00:34:32.000000', 'temperatura', 448.0000, 'ºC'),
	(340281, 144, '2015-02-01 00:34:33.000000', 'temperatura', 1048.0000, 'ºC'),
	(340282, 144, '2015-02-01 00:34:34.000000', 'temperatura', 296.0000, 'ºC'),
	(340283, 144, '2015-02-01 00:34:35.000000', 'temperatura', 738.0000, 'ºC'),
	(340284, 144, '2015-02-01 00:34:36.000000', 'temperatura', 403.0000, 'ºC'),
	(340285, 144, '2015-02-01 00:34:37.000000', 'temperatura', 999.0000, 'ºC'),
	(340286, 144, '2015-02-01 00:34:38.000000', 'temperatura', 187.0000, 'ºC'),
	(340287, 144, '2015-02-01 00:34:39.000000', 'temperatura', 338.0000, 'ºC'),
	(340288, 144, '2015-02-01 00:34:40.000000', 'temperatura', 1130.0000, 'ºC'),
	(340289, 144, '2015-02-01 00:34:41.000000', 'temperatura', 1036.0000, 'ºC'),
	(340290, 144, '2015-02-01 00:34:42.000000', 'temperatura', 591.0000, 'ºC'),
	(340291, 144, '2015-02-01 00:34:43.000000', 'temperatura', 1046.0000, 'ºC'),
	(340292, 144, '2015-02-01 00:34:44.000000', 'temperatura', 1059.0000, 'ºC'),
	(340293, 144, '2015-02-01 00:34:45.000000', 'temperatura', 959.0000, 'ºC'),
	(340294, 144, '2015-02-01 00:34:46.000000', 'temperatura', 416.0000, 'ºC'),
	(340295, 144, '2015-02-01 00:34:47.000000', 'temperatura', 404.0000, 'ºC'),
	(340296, 144, '2015-02-01 00:34:48.000000', 'temperatura', 774.0000, 'ºC'),
	(340297, 144, '2015-02-01 00:34:49.000000', 'temperatura', 256.0000, 'ºC'),
	(340298, 144, '2015-02-01 00:34:50.000000', 'temperatura', 161.0000, 'ºC'),
	(340299, 144, '2015-02-01 00:34:51.000000', 'temperatura', 36.0000, 'ºC'),
	(340300, 144, '2015-02-01 00:34:52.000000', 'temperatura', 900.0000, 'ºC'),
	(340301, 144, '2015-02-01 00:34:53.000000', 'temperatura', 791.0000, 'ºC'),
	(340302, 144, '2015-02-01 00:34:54.000000', 'temperatura', 53.0000, 'ºC'),
	(340303, 144, '2015-02-01 00:34:55.000000', 'temperatura', 296.0000, 'ºC'),
	(340304, 144, '2015-02-01 00:34:56.000000', 'temperatura', 120.0000, 'ºC'),
	(340305, 144, '2015-02-01 00:34:57.000000', 'temperatura', 911.0000, 'ºC'),
	(340306, 144, '2015-02-01 00:34:58.000000', 'temperatura', 596.0000, 'ºC'),
	(340307, 144, '2015-02-01 00:34:59.000000', 'temperatura', 250.0000, 'ºC'),
	(340308, 144, '2015-02-01 00:35:00.000000', 'temperatura', 660.0000, 'ºC'),
	(340309, 144, '2015-02-01 00:35:01.000000', 'temperatura', 153.0000, 'ºC'),
	(340310, 144, '2015-02-01 00:35:02.000000', 'temperatura', 1185.0000, 'ºC'),
	(340311, 144, '2015-02-01 00:35:03.000000', 'temperatura', 667.0000, 'ºC'),
	(340312, 144, '2015-02-01 00:35:04.000000', 'temperatura', 979.0000, 'ºC'),
	(340313, 144, '2015-02-01 00:35:05.000000', 'temperatura', 494.0000, 'ºC'),
	(340314, 144, '2015-02-01 00:35:06.000000', 'temperatura', 735.0000, 'ºC'),
	(340315, 144, '2015-02-01 00:35:07.000000', 'temperatura', 994.0000, 'ºC'),
	(340316, 144, '2015-02-01 00:35:08.000000', 'temperatura', 364.0000, 'ºC'),
	(340317, 144, '2015-02-01 00:35:09.000000', 'temperatura', 39.0000, 'ºC'),
	(340318, 144, '2015-02-01 00:35:10.000000', 'temperatura', 302.0000, 'ºC'),
	(340319, 144, '2015-02-01 00:35:11.000000', 'temperatura', 194.0000, 'ºC'),
	(340320, 144, '2015-02-01 00:35:12.000000', 'temperatura', 66.0000, 'ºC'),
	(340321, 144, '2015-02-01 00:35:13.000000', 'temperatura', 947.0000, 'ºC'),
	(340322, 144, '2015-02-01 00:35:14.000000', 'temperatura', 940.0000, 'ºC'),
	(340323, 144, '2015-02-01 00:35:15.000000', 'temperatura', 657.0000, 'ºC'),
	(340324, 144, '2015-02-01 00:35:16.000000', 'temperatura', 465.0000, 'ºC'),
	(340325, 144, '2015-02-01 00:35:17.000000', 'temperatura', 355.0000, 'ºC'),
	(340326, 144, '2015-02-01 00:35:18.000000', 'temperatura', 382.0000, 'ºC'),
	(340327, 144, '2015-02-01 00:35:19.000000', 'temperatura', 844.0000, 'ºC'),
	(340328, 144, '2015-02-01 00:35:20.000000', 'temperatura', 673.0000, 'ºC'),
	(340329, 144, '2015-02-01 00:35:21.000000', 'temperatura', 836.0000, 'ºC'),
	(340330, 144, '2015-02-01 00:35:22.000000', 'temperatura', 960.0000, 'ºC'),
	(340331, 144, '2015-02-01 00:35:23.000000', 'temperatura', 1091.0000, 'ºC'),
	(340332, 144, '2015-02-01 00:35:24.000000', 'temperatura', 177.0000, 'ºC'),
	(340333, 144, '2015-02-01 00:35:25.000000', 'temperatura', 12.0000, 'ºC'),
	(340334, 144, '2015-02-01 00:35:26.000000', 'temperatura', 732.0000, 'ºC'),
	(340335, 144, '2015-02-01 00:35:27.000000', 'temperatura', 22.0000, 'ºC'),
	(340336, 144, '2015-02-01 00:35:28.000000', 'temperatura', 315.0000, 'ºC'),
	(340337, 144, '2015-02-01 00:35:29.000000', 'temperatura', 309.0000, 'ºC'),
	(340338, 144, '2015-02-01 00:35:30.000000', 'temperatura', 600.0000, 'ºC'),
	(340339, 144, '2015-02-01 00:35:31.000000', 'temperatura', 875.0000, 'ºC'),
	(340340, 144, '2015-02-01 00:35:32.000000', 'temperatura', 173.0000, 'ºC'),
	(340341, 144, '2015-02-01 00:35:33.000000', 'temperatura', 643.0000, 'ºC'),
	(340342, 144, '2015-02-01 00:35:34.000000', 'temperatura', 294.0000, 'ºC'),
	(340343, 144, '2015-02-01 00:35:35.000000', 'temperatura', 741.0000, 'ºC'),
	(340344, 144, '2015-02-01 00:35:36.000000', 'temperatura', 424.0000, 'ºC'),
	(340345, 144, '2015-02-01 00:35:37.000000', 'temperatura', 1098.0000, 'ºC'),
	(340346, 144, '2015-02-01 00:35:38.000000', 'temperatura', 618.0000, 'ºC'),
	(340347, 144, '2015-02-01 00:35:39.000000', 'temperatura', 996.0000, 'ºC'),
	(340348, 144, '2015-02-01 00:35:40.000000', 'temperatura', 728.0000, 'ºC'),
	(340349, 144, '2015-02-01 00:35:41.000000', 'temperatura', 653.0000, 'ºC'),
	(340350, 144, '2015-02-01 00:35:42.000000', 'temperatura', 1079.0000, 'ºC'),
	(340351, 144, '2015-02-01 00:35:43.000000', 'temperatura', 1038.0000, 'ºC'),
	(340352, 144, '2015-02-01 00:35:44.000000', 'temperatura', 754.0000, 'ºC'),
	(340353, 144, '2015-02-01 00:35:45.000000', 'temperatura', 656.0000, 'ºC'),
	(340354, 144, '2015-02-01 00:35:46.000000', 'temperatura', 1018.0000, 'ºC'),
	(340355, 144, '2015-02-01 00:35:47.000000', 'temperatura', 725.0000, 'ºC'),
	(340356, 144, '2015-02-01 00:35:48.000000', 'temperatura', 568.0000, 'ºC'),
	(340357, 144, '2015-02-01 00:35:49.000000', 'temperatura', 667.0000, 'ºC'),
	(340358, 144, '2015-02-01 00:35:50.000000', 'temperatura', 432.0000, 'ºC'),
	(340359, 144, '2015-02-01 00:35:51.000000', 'temperatura', 160.0000, 'ºC'),
	(340360, 144, '2015-02-01 00:35:52.000000', 'temperatura', 705.0000, 'ºC'),
	(340361, 144, '2015-02-01 00:35:53.000000', 'temperatura', 643.0000, 'ºC'),
	(340362, 144, '2015-02-01 00:35:54.000000', 'temperatura', 1103.0000, 'ºC'),
	(340363, 144, '2015-02-01 00:35:55.000000', 'temperatura', 1187.0000, 'ºC'),
	(340364, 144, '2015-02-01 00:35:56.000000', 'temperatura', 224.0000, 'ºC'),
	(340365, 144, '2015-02-01 00:35:57.000000', 'temperatura', 1159.0000, 'ºC'),
	(340366, 144, '2015-02-01 00:35:58.000000', 'temperatura', 325.0000, 'ºC'),
	(340367, 144, '2015-02-01 00:35:59.000000', 'temperatura', 549.0000, 'ºC'),
	(340368, 144, '2015-02-01 00:36:00.000000', 'temperatura', 570.0000, 'ºC'),
	(340369, 144, '2015-02-01 00:36:01.000000', 'temperatura', 3.0000, 'ºC'),
	(340370, 144, '2015-02-01 00:36:02.000000', 'temperatura', 706.0000, 'ºC'),
	(340371, 144, '2015-02-01 00:36:03.000000', 'temperatura', 1123.0000, 'ºC'),
	(340372, 144, '2015-02-01 00:36:04.000000', 'temperatura', 1097.0000, 'ºC'),
	(340373, 144, '2015-02-01 00:36:05.000000', 'temperatura', 917.0000, 'ºC'),
	(340374, 144, '2015-02-01 00:36:06.000000', 'temperatura', 94.0000, 'ºC'),
	(340375, 144, '2015-02-01 00:36:07.000000', 'temperatura', 117.0000, 'ºC'),
	(340376, 144, '2015-02-01 00:36:08.000000', 'temperatura', 306.0000, 'ºC'),
	(340377, 144, '2015-02-01 00:36:09.000000', 'temperatura', 1181.0000, 'ºC'),
	(340378, 144, '2015-02-01 00:36:10.000000', 'temperatura', 185.0000, 'ºC'),
	(340379, 144, '2015-02-01 00:36:11.000000', 'temperatura', 982.0000, 'ºC'),
	(340380, 144, '2015-02-01 00:36:12.000000', 'temperatura', 758.0000, 'ºC'),
	(340381, 144, '2015-02-01 00:36:13.000000', 'temperatura', 843.0000, 'ºC'),
	(340382, 144, '2015-02-01 00:36:14.000000', 'temperatura', 740.0000, 'ºC'),
	(340383, 144, '2015-02-01 00:36:15.000000', 'temperatura', 1173.0000, 'ºC'),
	(340384, 144, '2015-02-01 00:36:16.000000', 'temperatura', 45.0000, 'ºC'),
	(340385, 144, '2015-02-01 00:36:17.000000', 'temperatura', 306.0000, 'ºC'),
	(340386, 144, '2015-02-01 00:36:18.000000', 'temperatura', 194.0000, 'ºC'),
	(340387, 144, '2015-02-01 00:36:19.000000', 'temperatura', 55.0000, 'ºC'),
	(340388, 144, '2015-02-01 00:36:20.000000', 'temperatura', 895.0000, 'ºC'),
	(340389, 144, '2015-02-01 00:36:21.000000', 'temperatura', 708.0000, 'ºC'),
	(340390, 144, '2015-02-01 00:36:22.000000', 'temperatura', 858.0000, 'ºC'),
	(340391, 144, '2015-02-01 00:36:23.000000', 'temperatura', 964.0000, 'ºC'),
	(340392, 144, '2015-02-01 00:36:24.000000', 'temperatura', 1048.0000, 'ºC'),
	(340393, 144, '2015-02-01 00:36:25.000000', 'temperatura', 1148.0000, 'ºC'),
	(340394, 144, '2015-02-01 00:36:26.000000', 'temperatura', 195.0000, 'ºC'),
	(340395, 144, '2015-02-01 00:36:27.000000', 'temperatura', 1131.0000, 'ºC'),
	(340396, 144, '2015-02-01 00:36:28.000000', 'temperatura', 271.0000, 'ºC'),
	(340397, 144, '2015-02-01 00:36:29.000000', 'temperatura', 362.0000, 'ºC'),
	(340398, 144, '2015-02-01 00:36:30.000000', 'temperatura', 997.0000, 'ºC'),
	(340399, 144, '2015-02-01 00:36:31.000000', 'temperatura', 301.0000, 'ºC'),
	(340400, 144, '2015-02-01 00:36:32.000000', 'temperatura', 913.0000, 'ºC'),
	(340401, 144, '2015-02-01 00:36:33.000000', 'temperatura', 63.0000, 'ºC'),
	(340402, 144, '2015-02-01 00:36:34.000000', 'temperatura', 1177.0000, 'ºC'),
	(340403, 144, '2015-02-01 00:36:35.000000', 'temperatura', 894.0000, 'ºC'),
	(340404, 144, '2015-02-01 00:36:36.000000', 'temperatura', 942.0000, 'ºC'),
	(340405, 144, '2015-02-01 00:36:37.000000', 'temperatura', 827.0000, 'ºC'),
	(340406, 144, '2015-02-01 00:36:38.000000', 'temperatura', 110.0000, 'ºC'),
	(340407, 144, '2015-02-01 00:36:39.000000', 'temperatura', 468.0000, 'ºC'),
	(340408, 144, '2015-02-01 00:36:40.000000', 'temperatura', 810.0000, 'ºC'),
	(340409, 144, '2015-02-01 00:36:41.000000', 'temperatura', 247.0000, 'ºC'),
	(340410, 144, '2015-02-01 00:36:42.000000', 'temperatura', 4.0000, 'ºC'),
	(340411, 144, '2015-02-01 00:36:43.000000', 'temperatura', 483.0000, 'ºC'),
	(340412, 144, '2015-02-01 00:36:44.000000', 'temperatura', 0.0000, 'ºC'),
	(340413, 144, '2015-02-01 00:36:45.000000', 'temperatura', 953.0000, 'ºC'),
	(340414, 144, '2015-02-01 00:36:46.000000', 'temperatura', 1166.0000, 'ºC'),
	(340415, 144, '2015-02-01 00:36:47.000000', 'temperatura', 571.0000, 'ºC'),
	(340416, 144, '2015-02-01 00:36:48.000000', 'temperatura', 558.0000, 'ºC'),
	(340417, 144, '2015-02-01 00:36:49.000000', 'temperatura', 1075.0000, 'ºC'),
	(340418, 144, '2015-02-01 00:36:50.000000', 'temperatura', 105.0000, 'ºC'),
	(340419, 144, '2015-02-01 00:36:51.000000', 'temperatura', 898.0000, 'ºC'),
	(340420, 144, '2015-02-01 00:36:52.000000', 'temperatura', 576.0000, 'ºC'),
	(340421, 144, '2015-02-01 00:36:53.000000', 'temperatura', 187.0000, 'ºC'),
	(340422, 144, '2015-02-01 00:36:54.000000', 'temperatura', 406.0000, 'ºC'),
	(340423, 144, '2015-02-01 00:36:55.000000', 'temperatura', 270.0000, 'ºC'),
	(340424, 144, '2015-02-01 00:36:56.000000', 'temperatura', 134.0000, 'ºC'),
	(340425, 144, '2015-02-01 00:36:57.000000', 'temperatura', 1061.0000, 'ºC'),
	(340426, 144, '2015-02-01 00:36:58.000000', 'temperatura', 101.0000, 'ºC'),
	(340427, 144, '2015-02-01 00:36:59.000000', 'temperatura', 922.0000, 'ºC'),
	(340428, 144, '2015-02-01 00:37:00.000000', 'temperatura', 708.0000, 'ºC'),
	(340429, 144, '2015-02-01 00:37:01.000000', 'temperatura', 776.0000, 'ºC'),
	(340430, 144, '2015-02-01 00:37:02.000000', 'temperatura', 557.0000, 'ºC'),
	(340431, 144, '2015-02-01 00:37:03.000000', 'temperatura', 457.0000, 'ºC'),
	(340432, 144, '2015-02-01 00:37:04.000000', 'temperatura', 614.0000, 'ºC'),
	(340433, 144, '2015-02-01 00:37:05.000000', 'temperatura', 499.0000, 'ºC'),
	(340434, 144, '2015-02-01 00:37:06.000000', 'temperatura', 656.0000, 'ºC'),
	(340435, 144, '2015-02-01 00:37:07.000000', 'temperatura', 581.0000, 'ºC'),
	(340436, 144, '2015-02-01 00:37:08.000000', 'temperatura', 937.0000, 'ºC'),
	(340437, 144, '2015-02-01 00:37:09.000000', 'temperatura', 543.0000, 'ºC'),
	(340438, 144, '2015-02-01 00:37:10.000000', 'temperatura', 1106.0000, 'ºC'),
	(340439, 144, '2015-02-01 00:37:11.000000', 'temperatura', 301.0000, 'ºC'),
	(340440, 144, '2015-02-01 00:37:12.000000', 'temperatura', 585.0000, 'ºC'),
	(340441, 144, '2015-02-01 00:37:13.000000', 'temperatura', 826.0000, 'ºC'),
	(340442, 144, '2015-02-01 00:37:14.000000', 'temperatura', 1172.0000, 'ºC'),
	(340443, 144, '2015-02-01 00:37:15.000000', 'temperatura', 986.0000, 'ºC'),
	(340444, 144, '2015-02-01 00:37:16.000000', 'temperatura', 213.0000, 'ºC'),
	(340445, 144, '2015-02-01 00:37:17.000000', 'temperatura', 506.0000, 'ºC'),
	(340446, 144, '2015-02-01 00:37:18.000000', 'temperatura', 691.0000, 'ºC'),
	(340447, 144, '2015-02-01 00:37:19.000000', 'temperatura', 738.0000, 'ºC'),
	(340448, 144, '2015-02-01 00:37:20.000000', 'temperatura', 418.0000, 'ºC'),
	(340449, 144, '2015-02-01 00:37:21.000000', 'temperatura', 1075.0000, 'ºC'),
	(340450, 144, '2015-02-01 00:37:22.000000', 'temperatura', 521.0000, 'ºC'),
	(340451, 144, '2015-02-01 00:37:23.000000', 'temperatura', 581.0000, 'ºC'),
	(340452, 144, '2015-02-01 00:37:24.000000', 'temperatura', 142.0000, 'ºC'),
	(340453, 144, '2015-02-01 00:37:25.000000', 'temperatura', 167.0000, 'ºC'),
	(340454, 144, '2015-02-01 00:37:26.000000', 'temperatura', 411.0000, 'ºC'),
	(340455, 144, '2015-02-01 00:37:27.000000', 'temperatura', 353.0000, 'ºC'),
	(340456, 144, '2015-02-01 00:37:28.000000', 'temperatura', 533.0000, 'ºC'),
	(340457, 144, '2015-02-01 00:37:29.000000', 'temperatura', 405.0000, 'ºC'),
	(340458, 144, '2015-02-01 00:37:30.000000', 'temperatura', 430.0000, 'ºC'),
	(340459, 144, '2015-02-01 00:37:31.000000', 'temperatura', 932.0000, 'ºC'),
	(340460, 144, '2015-02-01 00:37:32.000000', 'temperatura', 973.0000, 'ºC'),
	(340461, 144, '2015-02-01 00:37:33.000000', 'temperatura', 870.0000, 'ºC'),
	(340462, 144, '2015-02-01 00:37:34.000000', 'temperatura', 230.0000, 'ºC'),
	(340463, 144, '2015-02-01 00:37:35.000000', 'temperatura', 942.0000, 'ºC'),
	(340464, 144, '2015-02-01 00:37:36.000000', 'temperatura', 421.0000, 'ºC'),
	(340465, 144, '2015-02-01 00:37:37.000000', 'temperatura', 478.0000, 'ºC'),
	(340466, 144, '2015-02-01 00:37:38.000000', 'temperatura', 1127.0000, 'ºC'),
	(340467, 144, '2015-02-01 00:37:39.000000', 'temperatura', 602.0000, 'ºC'),
	(340468, 144, '2015-02-01 00:37:40.000000', 'temperatura', 829.0000, 'ºC'),
	(340469, 144, '2015-02-01 00:37:41.000000', 'temperatura', 1140.0000, 'ºC'),
	(340470, 144, '2015-02-01 00:37:42.000000', 'temperatura', 813.0000, 'ºC'),
	(340471, 144, '2015-02-01 00:37:43.000000', 'temperatura', 645.0000, 'ºC'),
	(340472, 144, '2015-02-01 00:37:44.000000', 'temperatura', 788.0000, 'ºC'),
	(340473, 144, '2015-02-01 00:37:45.000000', 'temperatura', 805.0000, 'ºC'),
	(340474, 144, '2015-02-01 00:37:46.000000', 'temperatura', 463.0000, 'ºC'),
	(340475, 144, '2015-02-01 00:37:47.000000', 'temperatura', 1098.0000, 'ºC'),
	(340476, 144, '2015-02-01 00:37:48.000000', 'temperatura', 504.0000, 'ºC'),
	(340477, 144, '2015-02-01 00:37:49.000000', 'temperatura', 425.0000, 'ºC'),
	(340478, 144, '2015-02-01 00:37:50.000000', 'temperatura', 614.0000, 'ºC'),
	(340479, 144, '2015-02-01 00:37:51.000000', 'temperatura', 596.0000, 'ºC'),
	(340480, 144, '2015-02-01 00:37:52.000000', 'temperatura', 1140.0000, 'ºC'),
	(340481, 144, '2015-02-01 00:37:53.000000', 'temperatura', 311.0000, 'ºC'),
	(340482, 144, '2015-02-01 00:37:54.000000', 'temperatura', 534.0000, 'ºC'),
	(340483, 144, '2015-02-01 00:37:55.000000', 'temperatura', 540.0000, 'ºC'),
	(340484, 144, '2015-02-01 00:37:56.000000', 'temperatura', 1099.0000, 'ºC'),
	(340485, 144, '2015-02-01 00:37:57.000000', 'temperatura', 276.0000, 'ºC'),
	(340486, 144, '2015-02-01 00:37:58.000000', 'temperatura', 483.0000, 'ºC'),
	(340487, 144, '2015-02-01 00:37:59.000000', 'temperatura', 389.0000, 'ºC'),
	(340488, 144, '2015-02-01 00:38:00.000000', 'temperatura', 495.0000, 'ºC'),
	(340489, 144, '2015-02-01 00:38:01.000000', 'temperatura', 110.0000, 'ºC'),
	(340490, 144, '2015-02-01 00:38:02.000000', 'temperatura', 263.0000, 'ºC'),
	(340491, 144, '2015-02-01 00:38:03.000000', 'temperatura', 985.0000, 'ºC'),
	(340492, 144, '2015-02-01 00:38:04.000000', 'temperatura', 537.0000, 'ºC'),
	(340493, 144, '2015-02-01 00:38:05.000000', 'temperatura', 930.0000, 'ºC'),
	(340494, 144, '2015-02-01 00:38:06.000000', 'temperatura', 641.0000, 'ºC'),
	(340495, 144, '2015-02-01 00:38:07.000000', 'temperatura', 417.0000, 'ºC'),
	(340496, 144, '2015-02-01 00:38:08.000000', 'temperatura', 159.0000, 'ºC'),
	(340497, 144, '2015-02-01 00:38:09.000000', 'temperatura', 746.0000, 'ºC'),
	(340498, 144, '2015-02-01 00:38:10.000000', 'temperatura', 853.0000, 'ºC'),
	(340499, 144, '2015-02-01 00:38:11.000000', 'temperatura', 830.0000, 'ºC'),
	(340500, 144, '2015-02-01 00:38:12.000000', 'temperatura', 388.0000, 'ºC'),
	(340501, 144, '2015-02-01 00:38:13.000000', 'temperatura', 652.0000, 'ºC'),
	(340502, 144, '2015-02-01 00:38:14.000000', 'temperatura', 897.0000, 'ºC'),
	(340503, 144, '2015-02-01 00:38:15.000000', 'temperatura', 129.0000, 'ºC'),
	(340504, 144, '2015-02-01 00:38:16.000000', 'temperatura', 354.0000, 'ºC'),
	(340505, 144, '2015-02-01 00:38:17.000000', 'temperatura', 186.0000, 'ºC'),
	(340506, 144, '2015-02-01 00:38:18.000000', 'temperatura', 1066.0000, 'ºC'),
	(340507, 144, '2015-02-01 00:38:19.000000', 'temperatura', 1175.0000, 'ºC'),
	(340508, 144, '2015-02-01 00:38:20.000000', 'temperatura', 277.0000, 'ºC'),
	(340509, 144, '2015-02-01 00:38:21.000000', 'temperatura', 259.0000, 'ºC'),
	(340510, 144, '2015-02-01 00:38:22.000000', 'temperatura', 463.0000, 'ºC'),
	(340511, 144, '2015-02-01 00:38:23.000000', 'temperatura', 341.0000, 'ºC'),
	(340512, 144, '2015-02-01 00:38:24.000000', 'temperatura', 316.0000, 'ºC'),
	(340513, 144, '2015-02-01 00:38:25.000000', 'temperatura', 558.0000, 'ºC'),
	(340514, 144, '2015-02-01 00:38:26.000000', 'temperatura', 644.0000, 'ºC'),
	(340515, 144, '2015-02-01 00:38:27.000000', 'temperatura', 343.0000, 'ºC'),
	(340516, 144, '2015-02-01 00:38:28.000000', 'temperatura', 986.0000, 'ºC'),
	(340517, 144, '2015-02-01 00:38:29.000000', 'temperatura', 299.0000, 'ºC'),
	(340518, 144, '2015-02-01 00:38:30.000000', 'temperatura', 938.0000, 'ºC'),
	(340519, 144, '2015-02-01 00:38:31.000000', 'temperatura', 193.0000, 'ºC'),
	(340520, 144, '2015-02-01 00:38:32.000000', 'temperatura', 554.0000, 'ºC'),
	(340521, 144, '2015-02-01 00:38:33.000000', 'temperatura', 991.0000, 'ºC'),
	(340522, 144, '2015-02-01 00:38:34.000000', 'temperatura', 892.0000, 'ºC'),
	(340523, 144, '2015-02-01 00:38:35.000000', 'temperatura', 289.0000, 'ºC'),
	(340524, 144, '2015-02-01 00:38:36.000000', 'temperatura', 1167.0000, 'ºC'),
	(340525, 144, '2015-02-01 00:38:37.000000', 'temperatura', 170.0000, 'ºC'),
	(340526, 144, '2015-02-01 00:38:38.000000', 'temperatura', 950.0000, 'ºC'),
	(340527, 144, '2015-02-01 00:38:39.000000', 'temperatura', 640.0000, 'ºC'),
	(340528, 144, '2015-02-01 00:38:40.000000', 'temperatura', 349.0000, 'ºC'),
	(340529, 144, '2015-02-01 00:38:41.000000', 'temperatura', 1027.0000, 'ºC'),
	(340530, 144, '2015-02-01 00:38:42.000000', 'temperatura', 490.0000, 'ºC'),
	(340531, 144, '2015-02-01 00:38:43.000000', 'temperatura', 568.0000, 'ºC'),
	(340532, 144, '2015-02-01 00:38:44.000000', 'temperatura', 170.0000, 'ºC'),
	(340533, 144, '2015-02-01 00:38:45.000000', 'temperatura', 346.0000, 'ºC'),
	(340534, 144, '2015-02-01 00:38:46.000000', 'temperatura', 22.0000, 'ºC'),
	(340535, 144, '2015-02-01 00:38:47.000000', 'temperatura', 272.0000, 'ºC'),
	(340536, 144, '2015-02-01 00:38:48.000000', 'temperatura', 93.0000, 'ºC'),
	(340537, 144, '2015-02-01 00:38:49.000000', 'temperatura', 853.0000, 'ºC'),
	(340538, 144, '2015-02-01 00:38:50.000000', 'temperatura', 383.0000, 'ºC'),
	(340539, 144, '2015-02-01 00:38:51.000000', 'temperatura', 558.0000, 'ºC'),
	(340540, 144, '2015-02-01 00:38:52.000000', 'temperatura', 441.0000, 'ºC'),
	(340541, 144, '2015-02-01 00:38:53.000000', 'temperatura', 533.0000, 'ºC'),
	(340542, 144, '2015-02-01 00:38:54.000000', 'temperatura', 142.0000, 'ºC'),
	(340543, 144, '2015-02-01 00:38:55.000000', 'temperatura', 310.0000, 'ºC'),
	(340544, 144, '2015-02-01 00:38:56.000000', 'temperatura', 1127.0000, 'ºC'),
	(340545, 144, '2015-02-01 00:38:57.000000', 'temperatura', 1104.0000, 'ºC'),
	(340546, 144, '2015-02-01 00:38:58.000000', 'temperatura', 940.0000, 'ºC'),
	(340547, 144, '2015-02-01 00:38:59.000000', 'temperatura', 187.0000, 'ºC'),
	(340548, 144, '2015-02-01 00:39:00.000000', 'temperatura', 516.0000, 'ºC'),
	(340549, 144, '2015-02-01 00:39:01.000000', 'temperatura', 822.0000, 'ºC'),
	(340550, 144, '2015-02-01 00:39:02.000000', 'temperatura', 159.0000, 'ºC'),
	(340551, 144, '2015-02-01 00:39:03.000000', 'temperatura', 731.0000, 'ºC'),
	(340552, 144, '2015-02-01 00:39:04.000000', 'temperatura', 780.0000, 'ºC'),
	(340553, 144, '2015-02-01 00:39:05.000000', 'temperatura', 506.0000, 'ºC'),
	(340554, 144, '2015-02-01 00:39:06.000000', 'temperatura', 191.0000, 'ºC'),
	(340555, 144, '2015-02-01 00:39:07.000000', 'temperatura', 637.0000, 'ºC'),
	(340556, 144, '2015-02-01 00:39:08.000000', 'temperatura', 214.0000, 'ºC'),
	(340557, 144, '2015-02-01 00:39:09.000000', 'temperatura', 357.0000, 'ºC'),
	(340558, 144, '2015-02-01 00:39:10.000000', 'temperatura', 1146.0000, 'ºC'),
	(340559, 144, '2015-02-01 00:39:11.000000', 'temperatura', 1061.0000, 'ºC'),
	(340560, 144, '2015-02-01 00:39:12.000000', 'temperatura', 664.0000, 'ºC'),
	(340561, 144, '2015-02-01 00:39:13.000000', 'temperatura', 140.0000, 'ºC'),
	(340562, 144, '2015-02-01 00:39:14.000000', 'temperatura', 1108.0000, 'ºC'),
	(340563, 144, '2015-02-01 00:39:15.000000', 'temperatura', 320.0000, 'ºC'),
	(340564, 144, '2015-02-01 00:39:16.000000', 'temperatura', 676.0000, 'ºC'),
	(340565, 144, '2015-02-01 00:39:17.000000', 'temperatura', 23.0000, 'ºC'),
	(340566, 144, '2015-02-01 00:39:18.000000', 'temperatura', 486.0000, 'ºC'),
	(340567, 144, '2015-02-01 00:39:19.000000', 'temperatura', 1163.0000, 'ºC'),
	(340568, 144, '2015-02-01 00:39:20.000000', 'temperatura', 755.0000, 'ºC'),
	(340569, 144, '2015-02-01 00:39:21.000000', 'temperatura', 286.0000, 'ºC'),
	(340570, 144, '2015-02-01 00:39:22.000000', 'temperatura', 368.0000, 'ºC'),
	(340571, 144, '2015-02-01 00:39:23.000000', 'temperatura', 983.0000, 'ºC'),
	(340572, 144, '2015-02-01 00:39:24.000000', 'temperatura', 212.0000, 'ºC'),
	(340573, 144, '2015-02-01 00:39:25.000000', 'temperatura', 508.0000, 'ºC'),
	(340574, 144, '2015-02-01 00:39:26.000000', 'temperatura', 708.0000, 'ºC'),
	(340575, 144, '2015-02-01 00:39:27.000000', 'temperatura', 816.0000, 'ºC'),
	(340576, 144, '2015-02-01 00:39:28.000000', 'temperatura', 756.0000, 'ºC'),
	(340577, 144, '2015-02-01 00:39:29.000000', 'temperatura', 134.0000, 'ºC'),
	(340578, 144, '2015-02-01 00:39:30.000000', 'temperatura', 801.0000, 'ºC'),
	(340579, 144, '2015-02-01 00:39:31.000000', 'temperatura', 4.0000, 'ºC'),
	(340580, 144, '2015-02-01 00:39:32.000000', 'temperatura', 16.0000, 'ºC'),
	(340581, 144, '2015-02-01 00:39:33.000000', 'temperatura', 68.0000, 'ºC'),
	(340582, 144, '2015-02-01 00:39:34.000000', 'temperatura', 295.0000, 'ºC'),
	(340583, 144, '2015-02-01 00:39:35.000000', 'temperatura', 69.0000, 'ºC'),
	(340584, 144, '2015-02-01 00:39:36.000000', 'temperatura', 662.0000, 'ºC'),
	(340585, 144, '2015-02-01 00:39:37.000000', 'temperatura', 704.0000, 'ºC'),
	(340586, 144, '2015-02-01 00:39:38.000000', 'temperatura', 332.0000, 'ºC'),
	(340587, 144, '2015-02-01 00:39:39.000000', 'temperatura', 750.0000, 'ºC'),
	(340588, 144, '2015-02-01 00:39:40.000000', 'temperatura', 355.0000, 'ºC'),
	(340589, 144, '2015-02-01 00:39:41.000000', 'temperatura', 725.0000, 'ºC'),
	(340590, 144, '2015-02-01 00:39:42.000000', 'temperatura', 163.0000, 'ºC'),
	(340591, 144, '2015-02-01 00:39:43.000000', 'temperatura', 1037.0000, 'ºC'),
	(340592, 144, '2015-02-01 00:39:44.000000', 'temperatura', 1099.0000, 'ºC'),
	(340593, 144, '2015-02-01 00:39:45.000000', 'temperatura', 1184.0000, 'ºC'),
	(340594, 144, '2015-02-01 00:39:46.000000', 'temperatura', 223.0000, 'ºC'),
	(340595, 144, '2015-02-01 00:39:47.000000', 'temperatura', 1162.0000, 'ºC'),
	(340596, 144, '2015-02-01 00:39:48.000000', 'temperatura', 344.0000, 'ºC'),
	(340597, 144, '2015-02-01 00:39:49.000000', 'temperatura', 632.0000, 'ºC'),
	(340598, 144, '2015-02-01 00:39:50.000000', 'temperatura', 928.0000, 'ºC'),
	(340599, 144, '2015-02-01 00:39:51.000000', 'temperatura', 346.0000, 'ºC'),
	(340600, 144, '2015-02-01 00:39:52.000000', 'temperatura', 146.0000, 'ºC'),
	(340601, 144, '2015-02-01 00:39:53.000000', 'temperatura', 895.0000, 'ºC'),
	(340602, 144, '2015-02-01 00:39:54.000000', 'temperatura', 435.0000, 'ºC'),
	(340603, 144, '2015-02-01 00:39:55.000000', 'temperatura', 690.0000, 'ºC'),
	(340604, 144, '2015-02-01 00:39:56.000000', 'temperatura', 946.0000, 'ºC'),
	(340605, 144, '2015-02-01 00:39:57.000000', 'temperatura', 260.0000, 'ºC'),
	(340606, 144, '2015-02-01 00:39:58.000000', 'temperatura', 861.0000, 'ºC'),
	(340607, 144, '2015-02-01 00:39:59.000000', 'temperatura', 1127.0000, 'ºC'),
	(340608, 144, '2015-02-01 00:40:00.000000', 'temperatura', 651.0000, 'ºC'),
	(340609, 144, '2015-02-01 00:40:01.000000', 'temperatura', 1077.0000, 'ºC'),
	(340610, 144, '2015-02-01 00:40:02.000000', 'temperatura', 1031.0000, 'ºC'),
	(340611, 144, '2015-02-01 00:40:03.000000', 'temperatura', 727.0000, 'ºC'),
	(340612, 144, '2015-02-01 00:40:04.000000', 'temperatura', 540.0000, 'ºC'),
	(340613, 144, '2015-02-01 00:40:05.000000', 'temperatura', 521.0000, 'ºC'),
	(340614, 144, '2015-02-01 00:40:06.000000', 'temperatura', 983.0000, 'ºC'),
	(340615, 144, '2015-02-01 00:40:07.000000', 'temperatura', 953.0000, 'ºC'),
	(340616, 144, '2015-02-01 00:40:08.000000', 'temperatura', 619.0000, 'ºC'),
	(340617, 144, '2015-02-01 00:40:09.000000', 'temperatura', 234.0000, 'ºC'),
	(340618, 144, '2015-02-01 00:40:10.000000', 'temperatura', 516.0000, 'ºC'),
	(340619, 144, '2015-02-01 00:40:11.000000', 'temperatura', 677.0000, 'ºC'),
	(340620, 144, '2015-02-01 00:40:12.000000', 'temperatura', 637.0000, 'ºC'),
	(340621, 144, '2015-02-01 00:40:13.000000', 'temperatura', 1154.0000, 'ºC'),
	(340622, 144, '2015-02-01 00:40:14.000000', 'temperatura', 261.0000, 'ºC'),
	(340623, 144, '2015-02-01 00:40:15.000000', 'temperatura', 243.0000, 'ºC'),
	(340624, 144, '2015-02-01 00:40:16.000000', 'temperatura', 431.0000, 'ºC'),
	(340625, 144, '2015-02-01 00:40:17.000000', 'temperatura', 226.0000, 'ºC'),
	(340626, 144, '2015-02-01 00:40:18.000000', 'temperatura', 1040.0000, 'ºC'),
	(340627, 144, '2015-02-01 00:40:19.000000', 'temperatura', 921.0000, 'ºC'),
	(340628, 144, '2015-02-01 00:40:20.000000', 'temperatura', 287.0000, 'ºC'),
	(340629, 144, '2015-02-01 00:40:21.000000', 'temperatura', 1072.0000, 'ºC'),
	(340630, 144, '2015-02-01 00:40:22.000000', 'temperatura', 898.0000, 'ºC'),
	(340631, 144, '2015-02-01 00:40:23.000000', 'temperatura', 77.0000, 'ºC'),
	(340632, 144, '2015-02-01 00:40:24.000000', 'temperatura', 90.0000, 'ºC'),
	(340633, 144, '2015-02-01 00:40:25.000000', 'temperatura', 221.0000, 'ºC'),
	(340634, 144, '2015-02-01 00:40:26.000000', 'temperatura', 836.0000, 'ºC'),
	(340635, 144, '2015-02-01 00:40:27.000000', 'temperatura', 1115.0000, 'ºC'),
	(340636, 144, '2015-02-01 00:40:28.000000', 'temperatura', 666.0000, 'ºC'),
	(340637, 144, '2015-02-01 00:40:29.000000', 'temperatura', 1189.0000, 'ºC'),
	(340638, 144, '2015-02-01 00:40:30.000000', 'temperatura', 348.0000, 'ºC'),
	(340639, 144, '2015-02-01 00:40:31.000000', 'temperatura', 572.0000, 'ºC'),
	(340640, 144, '2015-02-01 00:40:32.000000', 'temperatura', 617.0000, 'ºC'),
	(340641, 144, '2015-02-01 00:40:33.000000', 'temperatura', 170.0000, 'ºC'),
	(340642, 144, '2015-02-01 00:40:34.000000', 'temperatura', 200.0000, 'ºC'),
	(340643, 144, '2015-02-01 00:40:35.000000', 'temperatura', 490.0000, 'ºC'),
	(340644, 144, '2015-02-01 00:40:36.000000', 'temperatura', 651.0000, 'ºC'),
	(340645, 144, '2015-02-01 00:40:37.000000', 'temperatura', 585.0000, 'ºC'),
	(340646, 144, '2015-02-01 00:40:38.000000', 'temperatura', 972.0000, 'ºC'),
	(340647, 144, '2015-02-01 00:40:39.000000', 'temperatura', 705.0000, 'ºC'),
	(340648, 144, '2015-02-01 00:40:40.000000', 'temperatura', 608.0000, 'ºC'),
	(340649, 144, '2015-02-01 00:40:41.000000', 'temperatura', 927.0000, 'ºC'),
	(340650, 144, '2015-02-01 00:40:42.000000', 'temperatura', 411.0000, 'ºC'),
	(340651, 144, '2015-02-01 00:40:43.000000', 'temperatura', 474.0000, 'ºC'),
	(340652, 144, '2015-02-01 00:40:44.000000', 'temperatura', 1140.0000, 'ºC'),
	(340653, 144, '2015-02-01 00:40:45.000000', 'temperatura', 677.0000, 'ºC'),
	(340654, 144, '2015-02-01 00:40:46.000000', 'temperatura', 1166.0000, 'ºC'),
	(340655, 144, '2015-02-01 00:40:47.000000', 'temperatura', 198.0000, 'ºC'),
	(340656, 144, '2015-02-01 00:40:48.000000', 'temperatura', 1093.0000, 'ºC'),
	(340657, 144, '2015-02-01 00:40:49.000000', 'temperatura', 72.0000, 'ºC'),
	(340658, 144, '2015-02-01 00:40:50.000000', 'temperatura', 681.0000, 'ºC'),
	(340659, 144, '2015-02-01 00:40:51.000000', 'temperatura', 788.0000, 'ºC'),
	(340660, 144, '2015-02-01 00:40:52.000000', 'temperatura', 700.0000, 'ºC'),
	(340661, 144, '2015-02-01 00:40:53.000000', 'temperatura', 1134.0000, 'ºC'),
	(340662, 144, '2015-02-01 00:40:54.000000', 'temperatura', 1171.0000, 'ºC'),
	(340663, 144, '2015-02-01 00:40:55.000000', 'temperatura', 53.0000, 'ºC'),
	(340664, 144, '2015-02-01 00:40:56.000000', 'temperatura', 352.0000, 'ºC'),
	(340665, 144, '2015-02-01 00:40:57.000000', 'temperatura', 401.0000, 'ºC'),
	(340666, 144, '2015-02-01 00:40:58.000000', 'temperatura', 952.0000, 'ºC'),
	(340667, 144, '2015-02-01 00:40:59.000000', 'temperatura', 1157.0000, 'ºC'),
	(340668, 144, '2015-02-01 00:41:00.000000', 'temperatura', 529.0000, 'ºC'),
	(340669, 144, '2015-02-01 00:41:01.000000', 'temperatura', 374.0000, 'ºC'),
	(340670, 144, '2015-02-01 00:41:02.000000', 'temperatura', 286.0000, 'ºC'),
	(340671, 144, '2015-02-01 00:41:03.000000', 'temperatura', 306.0000, 'ºC'),
	(340672, 144, '2015-02-01 00:41:04.000000', 'temperatura', 674.0000, 'ºC'),
	(340673, 144, '2015-02-01 00:41:05.000000', 'temperatura', 51.0000, 'ºC'),
	(340674, 144, '2015-02-01 00:41:06.000000', 'temperatura', 636.0000, 'ºC'),
	(340675, 144, '2015-02-01 00:41:07.000000', 'temperatura', 627.0000, 'ºC'),
	(340676, 144, '2015-02-01 00:41:08.000000', 'temperatura', 27.0000, 'ºC'),
	(340677, 144, '2015-02-01 00:41:09.000000', 'temperatura', 653.0000, 'ºC'),
	(340678, 144, '2015-02-01 00:41:10.000000', 'temperatura', 785.0000, 'ºC'),
	(340679, 144, '2015-02-01 00:41:11.000000', 'temperatura', 768.0000, 'ºC'),
	(340680, 144, '2015-02-01 00:41:12.000000', 'temperatura', 283.0000, 'ºC'),
	(340681, 144, '2015-02-01 00:41:13.000000', 'temperatura', 314.0000, 'ºC'),
	(340682, 144, '2015-02-01 00:41:14.000000', 'temperatura', 722.0000, 'ºC'),
	(340683, 144, '2015-02-01 00:41:15.000000', 'temperatura', 268.0000, 'ºC'),
	(340684, 144, '2015-02-01 00:41:16.000000', 'temperatura', 373.0000, 'ºC'),
	(340685, 144, '2015-02-01 00:41:17.000000', 'temperatura', 1061.0000, 'ºC'),
	(340686, 144, '2015-02-01 00:41:18.000000', 'temperatura', 588.0000, 'ºC'),
	(340687, 144, '2015-02-01 00:41:19.000000', 'temperatura', 959.0000, 'ºC'),
	(340688, 144, '2015-02-01 00:41:20.000000', 'temperatura', 629.0000, 'ºC'),
	(340689, 144, '2015-02-01 00:41:21.000000', 'temperatura', 268.0000, 'ºC'),
	(340690, 144, '2015-02-01 00:41:22.000000', 'temperatura', 654.0000, 'ºC'),
	(340691, 144, '2015-02-01 00:41:23.000000', 'temperatura', 65.0000, 'ºC'),
	(340692, 144, '2015-02-01 00:41:24.000000', 'temperatura', 766.0000, 'ºC'),
	(340693, 144, '2015-02-01 00:41:25.000000', 'temperatura', 35.0000, 'ºC'),
	(340694, 144, '2015-02-01 00:41:26.000000', 'temperatura', 277.0000, 'ºC'),
	(340695, 144, '2015-02-01 00:41:27.000000', 'temperatura', 82.0000, 'ºC'),
	(340696, 144, '2015-02-01 00:41:28.000000', 'temperatura', 780.0000, 'ºC'),
	(340697, 144, '2015-02-01 00:41:29.000000', 'temperatura', 51.0000, 'ºC'),
	(340698, 144, '2015-02-01 00:41:30.000000', 'temperatura', 319.0000, 'ºC'),
	(340699, 144, '2015-02-01 00:41:31.000000', 'temperatura', 243.0000, 'ºC'),
	(340700, 144, '2015-02-01 00:41:32.000000', 'temperatura', 255.0000, 'ºC'),
	(340701, 144, '2015-02-01 00:41:33.000000', 'temperatura', 550.0000, 'ºC'),
	(340702, 144, '2015-02-01 00:41:34.000000', 'temperatura', 783.0000, 'ºC'),
	(340703, 144, '2015-02-01 00:41:35.000000', 'temperatura', 1065.0000, 'ºC'),
	(340704, 144, '2015-02-01 00:41:36.000000', 'temperatura', 576.0000, 'ºC'),
	(340705, 144, '2015-02-01 00:41:37.000000', 'temperatura', 889.0000, 'ºC'),
	(340706, 144, '2015-02-01 00:41:38.000000', 'temperatura', 314.0000, 'ºC'),
	(340707, 144, '2015-02-01 00:41:39.000000', 'temperatura', 104.0000, 'ºC'),
	(340708, 144, '2015-02-01 00:41:40.000000', 'temperatura', 777.0000, 'ºC'),
	(340709, 144, '2015-02-01 00:41:41.000000', 'temperatura', 1175.0000, 'ºC'),
	(340710, 144, '2015-02-01 00:41:42.000000', 'temperatura', 1146.0000, 'ºC'),
	(340711, 144, '2015-02-01 00:41:43.000000', 'temperatura', 1006.0000, 'ºC'),
	(340712, 144, '2015-02-01 00:41:44.000000', 'temperatura', 390.0000, 'ºC'),
	(340713, 144, '2015-02-01 00:41:45.000000', 'temperatura', 135.0000, 'ºC'),
	(340714, 144, '2015-02-01 00:41:46.000000', 'temperatura', 705.0000, 'ºC'),
	(340715, 144, '2015-02-01 00:41:47.000000', 'temperatura', 720.0000, 'ºC'),
	(340716, 144, '2015-02-01 00:41:48.000000', 'temperatura', 286.0000, 'ºC'),
	(340717, 144, '2015-02-01 00:41:49.000000', 'temperatura', 470.0000, 'ºC'),
	(340718, 144, '2015-02-01 00:41:50.000000', 'temperatura', 294.0000, 'ºC'),
	(340719, 144, '2015-02-01 00:41:51.000000', 'temperatura', 61.0000, 'ºC'),
	(340720, 144, '2015-02-01 00:41:52.000000', 'temperatura', 624.0000, 'ºC'),
	(340721, 144, '2015-02-01 00:41:53.000000', 'temperatura', 537.0000, 'ºC'),
	(340722, 144, '2015-02-01 00:41:54.000000', 'temperatura', 815.0000, 'ºC'),
	(340723, 144, '2015-02-01 00:41:55.000000', 'temperatura', 64.0000, 'ºC'),
	(340724, 144, '2015-02-01 00:41:56.000000', 'temperatura', 275.0000, 'ºC'),
	(340725, 144, '2015-02-01 00:41:57.000000', 'temperatura', 1184.0000, 'ºC'),
	(340726, 144, '2015-02-01 00:41:58.000000', 'temperatura', 293.0000, 'ºC'),
	(340727, 144, '2015-02-01 00:41:59.000000', 'temperatura', 317.0000, 'ºC'),
	(340728, 144, '2015-02-01 00:42:00.000000', 'temperatura', 705.0000, 'ºC'),
	(340729, 144, '2015-02-01 00:42:01.000000', 'temperatura', 175.0000, 'ºC'),
	(340730, 144, '2015-02-01 00:42:02.000000', 'temperatura', 1161.0000, 'ºC'),
	(340731, 144, '2015-02-01 00:42:03.000000', 'temperatura', 479.0000, 'ºC'),
	(340732, 144, '2015-02-01 00:42:04.000000', 'temperatura', 113.0000, 'ºC'),
	(340733, 144, '2015-02-01 00:42:05.000000', 'temperatura', 331.0000, 'ºC'),
	(340734, 144, '2015-02-01 00:42:06.000000', 'temperatura', 113.0000, 'ºC'),
	(340735, 144, '2015-02-01 00:42:07.000000', 'temperatura', 773.0000, 'ºC'),
	(340736, 144, '2015-02-01 00:42:08.000000', 'temperatura', 1126.0000, 'ºC'),
	(340737, 144, '2015-02-01 00:42:09.000000', 'temperatura', 910.0000, 'ºC'),
	(340738, 144, '2015-02-01 00:42:10.000000', 'temperatura', 1175.0000, 'ºC'),
	(340739, 144, '2015-02-01 00:42:11.000000', 'temperatura', 743.0000, 'ºC'),
	(340740, 144, '2015-02-01 00:42:12.000000', 'temperatura', 193.0000, 'ºC'),
	(340741, 144, '2015-02-01 00:42:13.000000', 'temperatura', 1135.0000, 'ºC'),
	(340742, 144, '2015-02-01 00:42:14.000000', 'temperatura', 299.0000, 'ºC'),
	(340743, 144, '2015-02-01 00:42:15.000000', 'temperatura', 487.0000, 'ºC'),
	(340744, 144, '2015-02-01 00:42:16.000000', 'temperatura', 340.0000, 'ºC'),
	(340745, 144, '2015-02-01 00:42:17.000000', 'temperatura', 238.0000, 'ºC'),
	(340746, 144, '2015-02-01 00:42:18.000000', 'temperatura', 172.0000, 'ºC'),
	(340747, 144, '2015-02-01 00:42:19.000000', 'temperatura', 146.0000, 'ºC'),
	(340748, 144, '2015-02-01 00:42:20.000000', 'temperatura', 214.0000, 'ºC'),
	(340749, 144, '2015-02-01 00:42:21.000000', 'temperatura', 635.0000, 'ºC'),
	(340750, 144, '2015-02-01 00:42:22.000000', 'temperatura', 131.0000, 'ºC'),
	(340751, 144, '2015-02-01 00:42:23.000000', 'temperatura', 1150.0000, 'ºC'),
	(340752, 144, '2015-02-01 00:42:24.000000', 'temperatura', 559.0000, 'ºC'),
	(340753, 144, '2015-02-01 00:42:25.000000', 'temperatura', 545.0000, 'ºC'),
	(340754, 144, '2015-02-01 00:42:26.000000', 'temperatura', 1048.0000, 'ºC'),
	(340755, 144, '2015-02-01 00:42:27.000000', 'temperatura', 7.0000, 'ºC'),
	(340756, 144, '2015-02-01 00:42:28.000000', 'temperatura', 491.0000, 'ºC'),
	(340757, 144, '2015-02-01 00:42:29.000000', 'temperatura', 34.0000, 'ºC'),
	(340758, 144, '2015-02-01 00:42:30.000000', 'temperatura', 1100.0000, 'ºC'),
	(340759, 144, '2015-02-01 00:42:31.000000', 'temperatura', 596.0000, 'ºC'),
	(340760, 144, '2015-02-01 00:42:32.000000', 'temperatura', 881.0000, 'ºC'),
	(340761, 144, '2015-02-01 00:42:33.000000', 'temperatura', 215.0000, 'ºC'),
	(340762, 144, '2015-02-01 00:42:34.000000', 'temperatura', 836.0000, 'ºC'),
	(340763, 144, '2015-02-01 00:42:35.000000', 'temperatura', 1136.0000, 'ºC'),
	(340764, 144, '2015-02-01 00:42:36.000000', 'temperatura', 770.0000, 'ºC'),
	(340765, 144, '2015-02-01 00:42:37.000000', 'temperatura', 443.0000, 'ºC'),
	(340766, 144, '2015-02-01 00:42:38.000000', 'temperatura', 1105.0000, 'ºC'),
	(340767, 144, '2015-02-01 00:42:39.000000', 'temperatura', 596.0000, 'ºC'),
	(340768, 144, '2015-02-01 00:42:40.000000', 'temperatura', 868.0000, 'ºC'),
	(340769, 144, '2015-02-01 00:42:41.000000', 'temperatura', 152.0000, 'ºC'),
	(340770, 144, '2015-02-01 00:42:42.000000', 'temperatura', 556.0000, 'ºC'),
	(340771, 144, '2015-02-01 00:42:43.000000', 'temperatura', 1125.0000, 'ºC'),
	(340772, 144, '2015-02-01 00:42:44.000000', 'temperatura', 357.0000, 'ºC'),
	(340773, 144, '2015-02-01 00:42:45.000000', 'temperatura', 810.0000, 'ºC'),
	(340774, 144, '2015-02-01 00:42:46.000000', 'temperatura', 578.0000, 'ºC'),
	(340775, 144, '2015-02-01 00:42:47.000000', 'temperatura', 462.0000, 'ºC'),
	(340776, 144, '2015-02-01 00:42:48.000000', 'temperatura', 578.0000, 'ºC'),
	(340777, 144, '2015-02-01 00:42:49.000000', 'temperatura', 302.0000, 'ºC'),
	(340778, 144, '2015-02-01 00:42:50.000000', 'temperatura', 977.0000, 'ºC'),
	(340779, 144, '2015-02-01 00:42:51.000000', 'temperatura', 382.0000, 'ºC'),
	(340780, 144, '2015-02-01 00:42:52.000000', 'temperatura', 176.0000, 'ºC'),
	(340781, 144, '2015-02-01 00:42:53.000000', 'temperatura', 936.0000, 'ºC'),
	(340782, 144, '2015-02-01 00:42:54.000000', 'temperatura', 553.0000, 'ºC'),
	(340783, 144, '2015-02-01 00:42:55.000000', 'temperatura', 1159.0000, 'ºC'),
	(340784, 144, '2015-02-01 00:42:56.000000', 'temperatura', 533.0000, 'ºC'),
	(340785, 144, '2015-02-01 00:42:57.000000', 'temperatura', 391.0000, 'ºC'),
	(340786, 144, '2015-02-01 00:42:58.000000', 'temperatura', 356.0000, 'ºC'),
	(340787, 144, '2015-02-01 00:42:59.000000', 'temperatura', 606.0000, 'ºC'),
	(340788, 144, '2015-02-01 00:43:00.000000', 'temperatura', 762.0000, 'ºC'),
	(340789, 144, '2015-02-01 00:43:01.000000', 'temperatura', 794.0000, 'ºC'),
	(340790, 144, '2015-02-01 00:43:02.000000', 'temperatura', 484.0000, 'ºC'),
	(340791, 144, '2015-02-01 00:43:03.000000', 'temperatura', 40.0000, 'ºC'),
	(340792, 144, '2015-02-01 00:43:04.000000', 'temperatura', 1147.0000, 'ºC'),
	(340793, 144, '2015-02-01 00:43:05.000000', 'temperatura', 815.0000, 'ºC'),
	(340794, 144, '2015-02-01 00:43:06.000000', 'temperatura', 637.0000, 'ºC'),
	(340795, 144, '2015-02-01 00:43:07.000000', 'temperatura', 738.0000, 'ºC'),
	(340796, 144, '2015-02-01 00:43:08.000000', 'temperatura', 579.0000, 'ºC'),
	(340797, 144, '2015-02-01 00:43:09.000000', 'temperatura', 681.0000, 'ºC'),
	(340798, 144, '2015-02-01 00:43:10.000000', 'temperatura', 471.0000, 'ºC'),
	(340799, 144, '2015-02-01 00:43:11.000000', 'temperatura', 313.0000, 'ºC'),
	(340800, 144, '2015-02-01 00:43:12.000000', 'temperatura', 149.0000, 'ºC'),
	(340801, 144, '2015-02-01 00:43:13.000000', 'temperatura', 1010.0000, 'ºC'),
	(340802, 144, '2015-02-01 00:43:14.000000', 'temperatura', 1000.0000, 'ºC'),
	(340803, 144, '2015-02-01 00:43:15.000000', 'temperatura', 773.0000, 'ºC'),
	(340804, 144, '2015-02-01 00:43:16.000000', 'temperatura', 863.0000, 'ºC'),
	(340805, 144, '2015-02-01 00:43:17.000000', 'temperatura', 797.0000, 'ºC'),
	(340806, 144, '2015-02-01 00:43:18.000000', 'temperatura', 198.0000, 'ºC'),
	(340807, 144, '2015-02-01 00:43:19.000000', 'temperatura', 997.0000, 'ºC'),
	(340808, 144, '2015-02-01 00:43:20.000000', 'temperatura', 793.0000, 'ºC'),
	(340809, 144, '2015-02-01 00:43:21.000000', 'temperatura', 974.0000, 'ºC'),
	(340810, 144, '2015-02-01 00:43:22.000000', 'temperatura', 94.0000, 'ºC'),
	(340811, 144, '2015-02-01 00:43:23.000000', 'temperatura', 1146.0000, 'ºC'),
	(340812, 144, '2015-02-01 00:43:24.000000', 'temperatura', 649.0000, 'ºC'),
	(340813, 144, '2015-02-01 00:43:25.000000', 'temperatura', 1009.0000, 'ºC'),
	(340814, 144, '2015-02-01 00:43:26.000000', 'temperatura', 699.0000, 'ºC'),
	(340815, 144, '2015-02-01 00:43:27.000000', 'temperatura', 468.0000, 'ºC'),
	(340816, 144, '2015-02-01 00:43:28.000000', 'temperatura', 245.0000, 'ºC'),
	(340817, 144, '2015-02-01 00:43:29.000000', 'temperatura', 1019.0000, 'ºC'),
	(340818, 144, '2015-02-01 00:43:30.000000', 'temperatura', 762.0000, 'ºC'),
	(340819, 144, '2015-02-01 00:43:31.000000', 'temperatura', 752.0000, 'ºC'),
	(340820, 144, '2015-02-01 00:43:32.000000', 'temperatura', 275.0000, 'ºC'),
	(340821, 144, '2015-02-01 00:43:33.000000', 'temperatura', 319.0000, 'ºC'),
	(340822, 144, '2015-02-01 00:43:34.000000', 'temperatura', 770.0000, 'ºC'),
	(340823, 144, '2015-02-01 00:43:35.000000', 'temperatura', 495.0000, 'ºC'),
	(340824, 144, '2015-02-01 00:43:36.000000', 'temperatura', 163.0000, 'ºC'),
	(340825, 144, '2015-02-01 00:43:37.000000', 'temperatura', 533.0000, 'ºC'),
	(340826, 144, '2015-02-01 00:43:38.000000', 'temperatura', 976.0000, 'ºC'),
	(340827, 144, '2015-02-01 00:43:39.000000', 'temperatura', 882.0000, 'ºC'),
	(340828, 144, '2015-02-01 00:43:40.000000', 'temperatura', 282.0000, 'ºC'),
	(340829, 144, '2015-02-01 00:43:41.000000', 'temperatura', 1163.0000, 'ºC'),
	(340830, 144, '2015-02-01 00:43:42.000000', 'temperatura', 172.0000, 'ºC'),
	(340831, 144, '2015-02-01 00:43:43.000000', 'temperatura', 969.0000, 'ºC'),
	(340832, 144, '2015-02-01 00:43:44.000000', 'temperatura', 733.0000, 'ºC'),
	(340833, 144, '2015-02-01 00:43:45.000000', 'temperatura', 755.0000, 'ºC'),
	(340834, 144, '2015-02-01 00:43:46.000000', 'temperatura', 378.0000, 'ºC'),
	(340835, 144, '2015-02-01 00:43:47.000000', 'temperatura', 826.0000, 'ºC'),
	(340836, 144, '2015-02-01 00:43:48.000000', 'temperatura', 597.0000, 'ºC'),
	(340837, 144, '2015-02-01 00:43:49.000000', 'temperatura', 508.0000, 'ºC'),
	(340838, 144, '2015-02-01 00:43:50.000000', 'temperatura', 747.0000, 'ºC'),
	(340839, 144, '2015-02-01 00:43:51.000000', 'temperatura', 1013.0000, 'ºC'),
	(340840, 144, '2015-02-01 00:43:52.000000', 'temperatura', 422.0000, 'ºC'),
	(340841, 144, '2015-02-01 00:43:53.000000', 'temperatura', 275.0000, 'ºC'),
	(340842, 144, '2015-02-01 00:43:54.000000', 'temperatura', 108.0000, 'ºC'),
	(340843, 144, '2015-02-01 00:43:55.000000', 'temperatura', 917.0000, 'ºC'),
	(340844, 144, '2015-02-01 00:43:56.000000', 'temperatura', 660.0000, 'ºC'),
	(340845, 144, '2015-02-01 00:43:57.000000', 'temperatura', 550.0000, 'ºC'),
	(340846, 144, '2015-02-01 00:43:58.000000', 'temperatura', 769.0000, 'ºC'),
	(340847, 144, '2015-02-01 00:43:59.000000', 'temperatura', 998.0000, 'ºC'),
	(340848, 144, '2015-02-01 00:44:00.000000', 'temperatura', 284.0000, 'ºC'),
	(340849, 144, '2015-02-01 00:44:01.000000', 'temperatura', 827.0000, 'ºC'),
	(340850, 144, '2015-02-01 00:44:02.000000', 'temperatura', 880.0000, 'ºC'),
	(340851, 144, '2015-02-01 00:44:03.000000', 'temperatura', 723.0000, 'ºC'),
	(340852, 144, '2015-02-01 00:44:04.000000', 'temperatura', 973.0000, 'ºC'),
	(340853, 144, '2015-02-01 00:44:05.000000', 'temperatura', 299.0000, 'ºC'),
	(340854, 144, '2015-02-01 00:44:06.000000', 'temperatura', 975.0000, 'ºC'),
	(340855, 144, '2015-02-01 00:44:07.000000', 'temperatura', 380.0000, 'ºC'),
	(340856, 144, '2015-02-01 00:44:08.000000', 'temperatura', 174.0000, 'ºC'),
	(340857, 144, '2015-02-01 00:44:09.000000', 'temperatura', 930.0000, 'ºC'),
	(340858, 144, '2015-02-01 00:44:10.000000', 'temperatura', 529.0000, 'ºC'),
	(340859, 144, '2015-02-01 00:44:11.000000', 'temperatura', 1054.0000, 'ºC'),
	(340860, 144, '2015-02-01 00:44:12.000000', 'temperatura', 83.0000, 'ºC'),
	(340861, 144, '2015-02-01 00:44:13.000000', 'temperatura', 855.0000, 'ºC'),
	(340862, 144, '2015-02-01 00:44:14.000000', 'temperatura', 427.0000, 'ºC'),
	(340863, 144, '2015-02-01 00:44:15.000000', 'temperatura', 770.0000, 'ºC'),
	(340864, 144, '2015-02-01 00:44:16.000000', 'temperatura', 171.0000, 'ºC'),
	(340865, 144, '2015-02-01 00:44:17.000000', 'temperatura', 944.0000, 'ºC'),
	(340866, 144, '2015-02-01 00:44:18.000000', 'temperatura', 606.0000, 'ºC'),
	(340867, 144, '2015-02-01 00:44:19.000000', 'temperatura', 200.0000, 'ºC'),
	(340868, 144, '2015-02-01 00:44:20.000000', 'temperatura', 381.0000, 'ºC'),
	(340869, 144, '2015-02-01 00:44:21.000000', 'temperatura', 106.0000, 'ºC'),
	(340870, 144, '2015-02-01 00:44:22.000000', 'temperatura', 586.0000, 'ºC'),
	(340871, 144, '2015-02-01 00:44:23.000000', 'temperatura', 214.0000, 'ºC'),
	(340872, 144, '2015-02-01 00:44:24.000000', 'temperatura', 513.0000, 'ºC'),
	(340873, 144, '2015-02-01 00:44:25.000000', 'temperatura', 724.0000, 'ºC'),
	(340874, 144, '2015-02-01 00:44:26.000000', 'temperatura', 881.0000, 'ºC'),
	(340875, 144, '2015-02-01 00:44:27.000000', 'temperatura', 1032.0000, 'ºC'),
	(340876, 144, '2015-02-01 00:44:28.000000', 'temperatura', 117.0000, 'ºC'),
	(340877, 144, '2015-02-01 00:44:29.000000', 'temperatura', 1091.0000, 'ºC'),
	(340878, 144, '2015-02-01 00:44:30.000000', 'temperatura', 305.0000, 'ºC'),
	(340879, 144, '2015-02-01 00:44:31.000000', 'temperatura', 652.0000, 'ºC'),
	(340880, 144, '2015-02-01 00:44:32.000000', 'temperatura', 1147.0000, 'ºC'),
	(340881, 144, '2015-02-01 00:44:33.000000', 'temperatura', 180.0000, 'ºC'),
	(340882, 144, '2015-02-01 00:44:34.000000', 'temperatura', 1060.0000, 'ºC'),
	(340883, 144, '2015-02-01 00:44:35.000000', 'temperatura', 1159.0000, 'ºC'),
	(340884, 144, '2015-02-01 00:44:36.000000', 'temperatura', 218.0000, 'ºC'),
	(340885, 144, '2015-02-01 00:44:37.000000', 'temperatura', 10.0000, 'ºC'),
	(340886, 144, '2015-02-01 00:44:38.000000', 'temperatura', 599.0000, 'ºC'),
	(340887, 144, '2015-02-01 00:44:39.000000', 'temperatura', 563.0000, 'ºC'),
	(340888, 144, '2015-02-01 00:44:40.000000', 'temperatura', 1018.0000, 'ºC'),
	(340889, 144, '2015-02-01 00:44:41.000000', 'temperatura', 1002.0000, 'ºC'),
	(340890, 144, '2015-02-01 00:44:42.000000', 'temperatura', 756.0000, 'ºC'),
	(340891, 144, '2015-02-01 00:44:43.000000', 'temperatura', 773.0000, 'ºC'),
	(340892, 144, '2015-02-01 00:44:44.000000', 'temperatura', 401.0000, 'ºC'),
	(340893, 144, '2015-02-01 00:44:45.000000', 'temperatura', 884.0000, 'ºC'),
	(340894, 144, '2015-02-01 00:44:46.000000', 'temperatura', 819.0000, 'ºC'),
	(340895, 144, '2015-02-01 00:44:47.000000', 'temperatura', 245.0000, 'ºC'),
	(340896, 144, '2015-02-01 00:44:48.000000', 'temperatura', 1166.0000, 'ºC'),
	(340897, 144, '2015-02-01 00:44:49.000000', 'temperatura', 295.0000, 'ºC'),
	(340898, 144, '2015-02-01 00:44:50.000000', 'temperatura', 377.0000, 'ºC'),
	(340899, 144, '2015-02-01 00:44:51.000000', 'temperatura', 1003.0000, 'ºC'),
	(340900, 144, '2015-02-01 00:44:52.000000', 'temperatura', 283.0000, 'ºC'),
	(340901, 144, '2015-02-01 00:44:53.000000', 'temperatura', 805.0000, 'ºC'),
	(340902, 144, '2015-02-01 00:44:54.000000', 'temperatura', 777.0000, 'ºC'),
	(340903, 144, '2015-02-01 00:44:55.000000', 'temperatura', 271.0000, 'ºC'),
	(340904, 144, '2015-02-01 00:44:56.000000', 'temperatura', 225.0000, 'ºC'),
	(340905, 144, '2015-02-01 00:44:57.000000', 'temperatura', 311.0000, 'ºC'),
	(340906, 144, '2015-02-01 00:44:58.000000', 'temperatura', 880.0000, 'ºC'),
	(340907, 144, '2015-02-01 00:44:59.000000', 'temperatura', 1070.0000, 'ºC'),
	(340908, 144, '2015-02-01 00:45:00.000000', 'temperatura', 311.0000, 'ºC'),
	(340909, 144, '2015-02-01 00:45:01.000000', 'temperatura', 742.0000, 'ºC'),
	(340910, 144, '2015-02-01 00:45:02.000000', 'temperatura', 381.0000, 'ºC'),
	(340911, 144, '2015-02-01 00:45:03.000000', 'temperatura', 876.0000, 'ºC'),
	(340912, 144, '2015-02-01 00:45:04.000000', 'temperatura', 840.0000, 'ºC'),
	(340913, 144, '2015-02-01 00:45:05.000000', 'temperatura', 370.0000, 'ºC'),
	(340914, 144, '2015-02-01 00:45:06.000000', 'temperatura', 533.0000, 'ºC'),
	(340915, 144, '2015-02-01 00:45:07.000000', 'temperatura', 356.0000, 'ºC'),
	(340916, 144, '2015-02-01 00:45:08.000000', 'temperatura', 182.0000, 'ºC'),
	(340917, 144, '2015-02-01 00:45:09.000000', 'temperatura', 1041.0000, 'ºC'),
	(340918, 144, '2015-02-01 00:45:10.000000', 'temperatura', 1060.0000, 'ºC'),
	(340919, 144, '2015-02-01 00:45:11.000000', 'temperatura', 977.0000, 'ºC'),
	(340920, 144, '2015-02-01 00:45:12.000000', 'temperatura', 505.0000, 'ºC'),
	(340921, 144, '2015-02-01 00:45:13.000000', 'temperatura', 797.0000, 'ºC'),
	(340922, 144, '2015-02-01 00:45:14.000000', 'temperatura', 68.0000, 'ºC'),
	(340923, 144, '2015-02-01 00:45:15.000000', 'temperatura', 350.0000, 'ºC'),
	(340924, 144, '2015-02-01 00:45:16.000000', 'temperatura', 345.0000, 'ºC'),
	(340925, 144, '2015-02-01 00:45:17.000000', 'temperatura', 678.0000, 'ºC'),
	(340926, 144, '2015-02-01 00:45:18.000000', 'temperatura', 1155.0000, 'ºC'),
	(340927, 144, '2015-02-01 00:45:19.000000', 'temperatura', 142.0000, 'ºC'),
	(340928, 144, '2015-02-01 00:45:20.000000', 'temperatura', 844.0000, 'ºC'),
	(340929, 144, '2015-02-01 00:45:21.000000', 'temperatura', 196.0000, 'ºC'),
	(340930, 144, '2015-02-01 00:45:22.000000', 'temperatura', 847.0000, 'ºC'),
	(340931, 144, '2015-02-01 00:45:23.000000', 'temperatura', 49.0000, 'ºC'),
	(340932, 144, '2015-02-01 00:45:24.000000', 'temperatura', 103.0000, 'ºC'),
	(340933, 144, '2015-02-01 00:45:25.000000', 'temperatura', 367.0000, 'ºC'),
	(340934, 144, '2015-02-01 00:45:26.000000', 'temperatura', 329.0000, 'ºC'),
	(340935, 144, '2015-02-01 00:45:27.000000', 'temperatura', 543.0000, 'ºC'),
	(340936, 144, '2015-02-01 00:45:28.000000', 'temperatura', 529.0000, 'ºC'),
	(340937, 144, '2015-02-01 00:45:29.000000', 'temperatura', 1017.0000, 'ºC'),
	(340938, 144, '2015-02-01 00:45:30.000000', 'temperatura', 1097.0000, 'ºC'),
	(340939, 144, '2015-02-01 00:45:31.000000', 'temperatura', 36.0000, 'ºC'),
	(340940, 144, '2015-02-01 00:45:32.000000', 'temperatura', 488.0000, 'ºC'),
	(340941, 144, '2015-02-01 00:45:33.000000', 'temperatura', 1133.0000, 'ºC'),
	(340942, 144, '2015-02-01 00:45:34.000000', 'temperatura', 600.0000, 'ºC'),
	(340943, 144, '2015-02-01 00:45:35.000000', 'temperatura', 802.0000, 'ºC'),
	(340944, 144, '2015-02-01 00:45:36.000000', 'temperatura', 1010.0000, 'ºC'),
	(340945, 144, '2015-02-01 00:45:37.000000', 'temperatura', 245.0000, 'ºC'),
	(340946, 144, '2015-02-01 00:45:38.000000', 'temperatura', 597.0000, 'ºC'),
	(340947, 144, '2015-02-01 00:45:39.000000', 'temperatura', 1051.0000, 'ºC'),
	(340948, 144, '2015-02-01 00:45:40.000000', 'temperatura', 1062.0000, 'ºC'),
	(340949, 144, '2015-02-01 00:45:41.000000', 'temperatura', 959.0000, 'ºC'),
	(340950, 144, '2015-02-01 00:45:42.000000', 'temperatura', 410.0000, 'ºC'),
	(340951, 144, '2015-02-01 00:45:43.000000', 'temperatura', 373.0000, 'ºC'),
	(340952, 144, '2015-02-01 00:45:44.000000', 'temperatura', 634.0000, 'ºC'),
	(340953, 144, '2015-02-01 00:45:45.000000', 'temperatura', 852.0000, 'ºC'),
	(340954, 144, '2015-02-01 00:45:46.000000', 'temperatura', 1159.0000, 'ºC'),
	(340955, 144, '2015-02-01 00:45:47.000000', 'temperatura', 837.0000, 'ºC'),
	(340956, 144, '2015-02-01 00:45:48.000000', 'temperatura', 712.0000, 'ºC'),
	(340957, 144, '2015-02-01 00:45:49.000000', 'temperatura', 1047.0000, 'ºC'),
	(340958, 144, '2015-02-01 00:45:50.000000', 'temperatura', 702.0000, 'ºC'),
	(340959, 144, '2015-02-01 00:45:51.000000', 'temperatura', 370.0000, 'ºC'),
	(340960, 144, '2015-02-01 00:45:52.000000', 'temperatura', 943.0000, 'ºC'),
	(340961, 144, '2015-02-01 00:45:53.000000', 'temperatura', 7.0000, 'ºC'),
	(340962, 144, '2015-02-01 00:45:54.000000', 'temperatura', 806.0000, 'ºC'),
	(340963, 144, '2015-02-01 00:45:55.000000', 'temperatura', 408.0000, 'ºC'),
	(340964, 144, '2015-02-01 00:45:56.000000', 'temperatura', 825.0000, 'ºC'),
	(340965, 144, '2015-02-01 00:45:57.000000', 'temperatura', 500.0000, 'ºC'),
	(340966, 144, '2015-02-01 00:45:58.000000', 'temperatura', 27.0000, 'ºC'),
	(340967, 144, '2015-02-01 00:45:59.000000', 'temperatura', 1035.0000, 'ºC'),
	(340968, 144, '2015-02-01 00:46:00.000000', 'temperatura', 293.0000, 'ºC'),
	(340969, 144, '2015-02-01 00:46:01.000000', 'temperatura', 760.0000, 'ºC'),
	(340970, 144, '2015-02-01 00:46:02.000000', 'temperatura', 523.0000, 'ºC'),
	(340971, 144, '2015-02-01 00:46:03.000000', 'temperatura', 336.0000, 'ºC'),
	(340972, 144, '2015-02-01 00:46:04.000000', 'temperatura', 113.0000, 'ºC'),
	(340973, 144, '2015-02-01 00:46:05.000000', 'temperatura', 755.0000, 'ºC'),
	(340974, 144, '2015-02-01 00:46:06.000000', 'temperatura', 1037.0000, 'ºC'),
	(340975, 144, '2015-02-01 00:46:07.000000', 'temperatura', 519.0000, 'ºC'),
	(340976, 144, '2015-02-01 00:46:08.000000', 'temperatura', 687.0000, 'ºC'),
	(340977, 144, '2015-02-01 00:46:09.000000', 'temperatura', 678.0000, 'ºC'),
	(340978, 144, '2015-02-01 00:46:10.000000', 'temperatura', 128.0000, 'ºC'),
	(340979, 144, '2015-02-01 00:46:11.000000', 'temperatura', 1006.0000, 'ºC'),
	(340980, 144, '2015-02-01 00:46:12.000000', 'temperatura', 1048.0000, 'ºC'),
	(340981, 144, '2015-02-01 00:46:13.000000', 'temperatura', 1023.0000, 'ºC'),
	(340982, 144, '2015-02-01 00:46:14.000000', 'temperatura', 772.0000, 'ºC'),
	(340983, 144, '2015-02-01 00:46:15.000000', 'temperatura', 789.0000, 'ºC'),
	(340984, 144, '2015-02-01 00:46:16.000000', 'temperatura', 429.0000, 'ºC'),
	(340985, 144, '2015-02-01 00:46:17.000000', 'temperatura', 981.0000, 'ºC'),
	(340986, 144, '2015-02-01 00:46:18.000000', 'temperatura', 19.0000, 'ºC'),
	(340987, 144, '2015-02-01 00:46:19.000000', 'temperatura', 750.0000, 'ºC'),
	(340988, 144, '2015-02-01 00:46:20.000000', 'temperatura', 93.0000, 'ºC'),
	(340989, 144, '2015-02-01 00:46:21.000000', 'temperatura', 617.0000, 'ºC'),
	(340990, 144, '2015-02-01 00:46:22.000000', 'temperatura', 407.0000, 'ºC'),
	(340991, 144, '2015-02-01 00:46:23.000000', 'temperatura', 185.0000, 'ºC'),
	(340992, 144, '2015-02-01 00:46:24.000000', 'temperatura', 905.0000, 'ºC'),
	(340993, 144, '2015-02-01 00:46:25.000000', 'temperatura', 368.0000, 'ºC'),
	(340994, 144, '2015-02-01 00:46:26.000000', 'temperatura', 326.0000, 'ºC'),
	(340995, 144, '2015-02-01 00:46:27.000000', 'temperatura', 528.0000, 'ºC'),
	(340996, 144, '2015-02-01 00:46:28.000000', 'temperatura', 461.0000, 'ºC'),
	(340997, 144, '2015-02-01 00:46:29.000000', 'temperatura', 720.0000, 'ºC'),
	(340998, 144, '2015-02-01 00:46:30.000000', 'temperatura', 1020.0000, 'ºC'),
	(340999, 144, '2015-02-01 00:46:31.000000', 'temperatura', 541.0000, 'ºC'),
	(341000, 144, '2015-02-01 00:46:32.000000', 'temperatura', 844.0000, 'ºC'),
	(341001, 144, '2015-02-01 00:46:33.000000', 'temperatura', 199.0000, 'ºC'),
	(341002, 144, '2015-02-01 00:46:34.000000', 'temperatura', 861.0000, 'ºC'),
	(341003, 144, '2015-02-01 00:46:35.000000', 'temperatura', 110.0000, 'ºC'),
	(341004, 144, '2015-02-01 00:46:36.000000', 'temperatura', 367.0000, 'ºC'),
	(341005, 144, '2015-02-01 00:46:37.000000', 'temperatura', 305.0000, 'ºC'),
	(341006, 144, '2015-02-01 00:46:38.000000', 'temperatura', 423.0000, 'ºC'),
	(341007, 144, '2015-02-01 00:46:39.000000', 'temperatura', 3.0000, 'ºC'),
	(341008, 144, '2015-02-01 00:46:40.000000', 'temperatura', 1148.0000, 'ºC'),
	(341009, 144, '2015-02-01 00:46:41.000000', 'temperatura', 929.0000, 'ºC'),
	(341010, 144, '2015-02-01 00:46:42.000000', 'temperatura', 2.0000, 'ºC'),
	(341011, 144, '2015-02-01 00:46:43.000000', 'temperatura', 825.0000, 'ºC'),
	(341012, 144, '2015-02-01 00:46:44.000000', 'temperatura', 519.0000, 'ºC'),
	(341013, 144, '2015-02-01 00:46:45.000000', 'temperatura', 120.0000, 'ºC'),
	(341014, 144, '2015-02-01 00:46:46.000000', 'temperatura', 246.0000, 'ºC'),
	(341015, 144, '2015-02-01 00:46:47.000000', 'temperatura', 867.0000, 'ºC'),
	(341016, 144, '2015-02-01 00:46:48.000000', 'temperatura', 1.0000, 'ºC'),
	(341017, 144, '2015-02-01 00:46:49.000000', 'temperatura', 1001.0000, 'ºC'),
	(341018, 144, '2015-02-01 00:46:50.000000', 'temperatura', 204.0000, 'ºC'),
	(341019, 144, '2015-02-01 00:46:51.000000', 'temperatura', 419.0000, 'ºC'),
	(341020, 144, '2015-02-01 00:46:52.000000', 'temperatura', 284.0000, 'ºC'),
	(341021, 144, '2015-02-01 00:46:53.000000', 'temperatura', 160.0000, 'ºC'),
	(341022, 144, '2015-02-01 00:46:54.000000', 'temperatura', 1152.0000, 'ºC'),
	(341023, 144, '2015-02-01 00:46:55.000000', 'temperatura', 478.0000, 'ºC'),
	(341024, 144, '2015-02-01 00:46:56.000000', 'temperatura', 137.0000, 'ºC'),
	(341025, 144, '2015-02-01 00:46:57.000000', 'temperatura', 452.0000, 'ºC'),
	(341026, 144, '2015-02-01 00:46:58.000000', 'temperatura', 650.0000, 'ºC'),
	(341027, 144, '2015-02-01 00:46:59.000000', 'temperatura', 692.0000, 'ºC'),
	(341028, 144, '2015-02-01 00:47:00.000000', 'temperatura', 311.0000, 'ºC'),
	(341029, 144, '2015-02-01 00:47:01.000000', 'temperatura', 681.0000, 'ºC'),
	(341030, 144, '2015-02-01 00:47:02.000000', 'temperatura', 71.0000, 'ºC'),
	(341031, 144, '2015-02-01 00:47:03.000000', 'temperatura', 713.0000, 'ºC'),
	(341032, 144, '2015-02-01 00:47:04.000000', 'temperatura', 951.0000, 'ºC'),
	(341033, 144, '2015-02-01 00:47:05.000000', 'temperatura', 218.0000, 'ºC'),
	(341034, 144, '2015-02-01 00:47:06.000000', 'temperatura', 637.0000, 'ºC'),
	(341035, 144, '2015-02-01 00:47:07.000000', 'temperatura', 132.0000, 'ºC'),
	(341036, 144, '2015-02-01 00:47:08.000000', 'temperatura', 1149.0000, 'ºC'),
	(341037, 144, '2015-02-01 00:47:09.000000', 'temperatura', 548.0000, 'ºC'),
	(341038, 144, '2015-02-01 00:47:10.000000', 'temperatura', 494.0000, 'ºC'),
	(341039, 144, '2015-02-01 00:47:11.000000', 'temperatura', 827.0000, 'ºC'),
	(341040, 144, '2015-02-01 00:47:12.000000', 'temperatura', 252.0000, 'ºC'),
	(341041, 144, '2015-02-01 00:47:13.000000', 'temperatura', 1181.0000, 'ºC'),
	(341042, 144, '2015-02-01 00:47:14.000000', 'temperatura', 350.0000, 'ºC'),
	(341043, 144, '2015-02-01 00:47:15.000000', 'temperatura', 605.0000, 'ºC'),
	(341044, 144, '2015-02-01 00:47:16.000000', 'temperatura', 776.0000, 'ºC'),
	(341045, 144, '2015-02-01 00:47:17.000000', 'temperatura', 868.0000, 'ºC'),
	(341046, 144, '2015-02-01 00:47:18.000000', 'temperatura', 810.0000, 'ºC'),
	(341047, 144, '2015-02-01 00:47:19.000000', 'temperatura', 246.0000, 'ºC'),
	(341048, 144, '2015-02-01 00:47:20.000000', 'temperatura', 2.0000, 'ºC'),
	(341049, 144, '2015-02-01 00:47:21.000000', 'temperatura', 472.0000, 'ºC'),
	(341050, 144, '2015-02-01 00:47:22.000000', 'temperatura', 1155.0000, 'ºC'),
	(341051, 144, '2015-02-01 00:47:23.000000', 'temperatura', 759.0000, 'ºC'),
	(341052, 144, '2015-02-01 00:47:24.000000', 'temperatura', 330.0000, 'ºC'),
	(341053, 144, '2015-02-01 00:47:25.000000', 'temperatura', 576.0000, 'ºC'),
	(341054, 144, '2015-02-01 00:47:26.000000', 'temperatura', 687.0000, 'ºC'),
	(341055, 144, '2015-02-01 00:47:27.000000', 'temperatura', 509.0000, 'ºC'),
	(341056, 144, '2015-02-01 00:47:28.000000', 'temperatura', 486.0000, 'ºC'),
	(341057, 144, '2015-02-01 00:47:29.000000', 'temperatura', 902.0000, 'ºC'),
	(341058, 144, '2015-02-01 00:47:30.000000', 'temperatura', 653.0000, 'ºC'),
	(341059, 144, '2015-02-01 00:47:31.000000', 'temperatura', 561.0000, 'ºC'),
	(341060, 144, '2015-02-01 00:47:32.000000', 'temperatura', 843.0000, 'ºC'),
	(341061, 144, '2015-02-01 00:47:33.000000', 'temperatura', 135.0000, 'ºC'),
	(341062, 144, '2015-02-01 00:47:34.000000', 'temperatura', 548.0000, 'ºC'),
	(341063, 144, '2015-02-01 00:47:35.000000', 'temperatura', 1133.0000, 'ºC'),
	(341064, 144, '2015-02-01 00:47:36.000000', 'temperatura', 420.0000, 'ºC'),
	(341065, 144, '2015-02-01 00:47:37.000000', 'temperatura', 1104.0000, 'ºC'),
	(341066, 144, '2015-02-01 00:47:38.000000', 'temperatura', 659.0000, 'ºC'),
	(341067, 144, '2015-02-01 00:47:39.000000', 'temperatura', 1184.0000, 'ºC'),
	(341068, 144, '2015-02-01 00:47:40.000000', 'temperatura', 343.0000, 'ºC'),
	(341069, 144, '2015-02-01 00:47:41.000000', 'temperatura', 562.0000, 'ºC'),
	(341070, 144, '2015-02-01 00:47:42.000000', 'temperatura', 583.0000, 'ºC'),
	(341071, 144, '2015-02-01 00:47:43.000000', 'temperatura', 31.0000, 'ºC'),
	(341072, 144, '2015-02-01 00:47:44.000000', 'temperatura', 803.0000, 'ºC'),
	(341073, 144, '2015-02-01 00:47:45.000000', 'temperatura', 325.0000, 'ºC'),
	(341074, 144, '2015-02-01 00:47:46.000000', 'temperatura', 417.0000, 'ºC'),
	(341075, 144, '2015-02-01 00:47:47.000000', 'temperatura', 1109.0000, 'ºC'),
	(341076, 144, '2015-02-01 00:47:48.000000', 'temperatura', 694.0000, 'ºC'),
	(341077, 144, '2015-02-01 00:47:49.000000', 'temperatura', 145.0000, 'ºC'),
	(341078, 144, '2015-02-01 00:47:50.000000', 'temperatura', 1042.0000, 'ºC'),
	(341079, 144, '2015-02-01 00:47:51.000000', 'temperatura', 1174.0000, 'ºC'),
	(341080, 144, '2015-02-01 00:47:52.000000', 'temperatura', 348.0000, 'ºC'),
	(341081, 144, '2015-02-01 00:47:53.000000', 'temperatura', 617.0000, 'ºC'),
	(341082, 144, '2015-02-01 00:47:54.000000', 'temperatura', 841.0000, 'ºC'),
	(341083, 144, '2015-02-01 00:47:55.000000', 'temperatura', 1157.0000, 'ºC'),
	(341084, 144, '2015-02-01 00:47:56.000000', 'temperatura', 860.0000, 'ºC'),
	(341085, 144, '2015-02-01 00:47:57.000000', 'temperatura', 831.0000, 'ºC'),
	(341086, 144, '2015-02-01 00:47:58.000000', 'temperatura', 374.0000, 'ºC'),
	(341087, 144, '2015-02-01 00:47:59.000000', 'temperatura', 578.0000, 'ºC'),
	(341088, 144, '2015-02-01 00:48:00.000000', 'temperatura', 570.0000, 'ºC'),
	(341089, 144, '2015-02-01 00:48:01.000000', 'temperatura', 1116.0000, 'ºC'),
	(341090, 144, '2015-02-01 00:48:02.000000', 'temperatura', 271.0000, 'ºC'),
	(341091, 144, '2015-02-01 00:48:03.000000', 'temperatura', 407.0000, 'ºC'),
	(341092, 144, '2015-02-01 00:48:04.000000', 'temperatura', 20.0000, 'ºC'),
	(341093, 144, '2015-02-01 00:48:05.000000', 'temperatura', 83.0000, 'ºC'),
	(341094, 144, '2015-02-01 00:48:06.000000', 'temperatura', 353.0000, 'ºC'),
	(341095, 144, '2015-02-01 00:48:07.000000', 'temperatura', 319.0000, 'ºC'),
	(341096, 144, '2015-02-01 00:48:08.000000', 'temperatura', 536.0000, 'ºC'),
	(341097, 144, '2015-02-01 00:48:09.000000', 'temperatura', 521.0000, 'ºC'),
	(341098, 144, '2015-02-01 00:48:10.000000', 'temperatura', 1001.0000, 'ºC'),
	(341099, 144, '2015-02-01 00:48:11.000000', 'temperatura', 1040.0000, 'ºC'),
	(341100, 144, '2015-02-01 00:48:12.000000', 'temperatura', 1000.0000, 'ºC'),
	(341101, 144, '2015-02-01 00:48:13.000000', 'temperatura', 678.0000, 'ºC'),
	(341102, 144, '2015-02-01 00:48:14.000000', 'temperatura', 392.0000, 'ºC'),
	(341103, 144, '2015-02-01 00:48:15.000000', 'temperatura', 1124.0000, 'ºC'),
	(341104, 144, '2015-02-01 00:48:16.000000', 'temperatura', 848.0000, 'ºC'),
	(341105, 144, '2015-02-01 00:48:17.000000', 'temperatura', 867.0000, 'ºC'),
	(341106, 144, '2015-02-01 00:48:18.000000', 'temperatura', 592.0000, 'ºC'),
	(341107, 144, '2015-02-01 00:48:19.000000', 'temperatura', 360.0000, 'ºC'),
	(341108, 144, '2015-02-01 00:48:20.000000', 'temperatura', 24.0000, 'ºC'),
	(341109, 144, '2015-02-01 00:48:21.000000', 'temperatura', 241.0000, 'ºC'),
	(341110, 144, '2015-02-01 00:48:22.000000', 'temperatura', 1131.0000, 'ºC'),
	(341111, 144, '2015-02-01 00:48:23.000000', 'temperatura', 135.0000, 'ºC'),
	(341112, 144, '2015-02-01 00:48:24.000000', 'temperatura', 881.0000, 'ºC'),
	(341113, 144, '2015-02-01 00:48:25.000000', 'temperatura', 400.0000, 'ºC'),
	(341114, 144, '2015-02-01 00:48:26.000000', 'temperatura', 560.0000, 'ºC'),
	(341115, 144, '2015-02-01 00:48:27.000000', 'temperatura', 400.0000, 'ºC'),
	(341116, 144, '2015-02-01 00:48:28.000000', 'temperatura', 320.0000, 'ºC'),
	(341117, 144, '2015-02-01 00:48:29.000000', 'temperatura', 401.0000, 'ºC'),
	(341118, 144, '2015-02-01 00:48:30.000000', 'temperatura', 1043.0000, 'ºC'),
	(341119, 144, '2015-02-01 00:48:31.000000', 'temperatura', 415.0000, 'ºC'),
	(341120, 144, '2015-02-01 00:48:32.000000', 'temperatura', 144.0000, 'ºC'),
	(341121, 144, '2015-02-01 00:48:33.000000', 'temperatura', 675.0000, 'ºC'),
	(341122, 144, '2015-02-01 00:48:34.000000', 'temperatura', 546.0000, 'ºC'),
	(341123, 144, '2015-02-01 00:48:35.000000', 'temperatura', 705.0000, 'ºC'),
	(341124, 144, '2015-02-01 00:48:36.000000', 'temperatura', 688.0000, 'ºC'),
	(341125, 144, '2015-02-01 00:48:37.000000', 'temperatura', 123.0000, 'ºC'),
	(341126, 144, '2015-02-01 00:48:38.000000', 'temperatura', 953.0000, 'ºC'),
	(341127, 144, '2015-02-01 00:48:39.000000', 'temperatura', 798.0000, 'ºC'),
	(341128, 144, '2015-02-01 00:48:40.000000', 'temperatura', 1131.0000, 'ºC'),
	(341129, 144, '2015-02-01 00:48:41.000000', 'temperatura', 861.0000, 'ºC'),
	(341130, 144, '2015-02-01 00:48:42.000000', 'temperatura', 914.0000, 'ºC'),
	(341131, 144, '2015-02-01 00:48:43.000000', 'temperatura', 785.0000, 'ºC'),
	(341132, 144, '2015-02-01 00:48:44.000000', 'temperatura', 1186.0000, 'ºC'),
	(341133, 144, '2015-02-01 00:48:45.000000', 'temperatura', 1176.0000, 'ºC'),
	(341134, 144, '2015-02-01 00:48:46.000000', 'temperatura', 1121.0000, 'ºC'),
	(341135, 144, '2015-02-01 00:48:47.000000', 'temperatura', 877.0000, 'ºC'),
	(341136, 144, '2015-02-01 00:48:48.000000', 'temperatura', 1025.0000, 'ºC'),
	(341137, 144, '2015-02-01 00:48:49.000000', 'temperatura', 93.0000, 'ºC'),
	(341138, 144, '2015-02-01 00:48:50.000000', 'temperatura', 989.0000, 'ºC'),
	(341139, 144, '2015-02-01 00:48:51.000000', 'temperatura', 1069.0000, 'ºC'),
	(341140, 144, '2015-02-01 00:48:52.000000', 'temperatura', 1176.0000, 'ºC'),
	(341141, 144, '2015-02-01 00:48:53.000000', 'temperatura', 274.0000, 'ºC'),
	(341142, 144, '2015-02-01 00:48:54.000000', 'temperatura', 245.0000, 'ºC'),
	(341143, 144, '2015-02-01 00:48:55.000000', 'temperatura', 401.0000, 'ºC'),
	(341144, 144, '2015-02-01 00:48:56.000000', 'temperatura', 69.0000, 'ºC'),
	(341145, 144, '2015-02-01 00:48:57.000000', 'temperatura', 346.0000, 'ºC'),
	(341146, 144, '2015-02-01 00:48:58.000000', 'temperatura', 321.0000, 'ºC'),
	(341147, 144, '2015-02-01 00:48:59.000000', 'temperatura', 567.0000, 'ºC'),
	(341148, 144, '2015-02-01 00:49:00.000000', 'temperatura', 675.0000, 'ºC'),
	(341149, 144, '2015-02-01 00:49:01.000000', 'temperatura', 472.0000, 'ºC'),
	(341150, 144, '2015-02-01 00:49:02.000000', 'temperatura', 335.0000, 'ºC'),
	(341151, 144, '2015-02-01 00:49:03.000000', 'temperatura', 260.0000, 'ºC'),
	(341152, 144, '2015-02-01 00:49:04.000000', 'temperatura', 296.0000, 'ºC'),
	(341153, 144, '2015-02-01 00:49:05.000000', 'temperatura', 701.0000, 'ºC'),
	(341154, 144, '2015-02-01 00:49:06.000000', 'temperatura', 217.0000, 'ºC'),
	(341155, 144, '2015-02-01 00:49:07.000000', 'temperatura', 183.0000, 'ºC'),
	(341156, 144, '2015-02-01 00:49:08.000000', 'temperatura', 266.0000, 'ºC'),
	(341157, 144, '2015-02-01 00:49:09.000000', 'temperatura', 779.0000, 'ºC'),
	(341158, 144, '2015-02-01 00:49:10.000000', 'temperatura', 697.0000, 'ºC'),
	(341159, 144, '2015-02-01 00:49:11.000000', 'temperatura', 1151.0000, 'ºC'),
	(341160, 144, '2015-02-01 00:49:12.000000', 'temperatura', 66.0000, 'ºC'),
	(341161, 144, '2015-02-01 00:49:13.000000', 'temperatura', 474.0000, 'ºC'),
	(341162, 144, '2015-02-01 00:49:14.000000', 'temperatura', 973.0000, 'ºC'),
	(341163, 144, '2015-02-01 00:49:15.000000', 'temperatura', 1043.0000, 'ºC'),
	(341164, 144, '2015-02-01 00:49:16.000000', 'temperatura', 1096.0000, 'ºC'),
	(341165, 144, '2015-02-01 00:49:17.000000', 'temperatura', 1152.0000, 'ºC'),
	(341166, 144, '2015-02-01 00:49:18.000000', 'temperatura', 72.0000, 'ºC'),
	(341167, 144, '2015-02-01 00:49:19.000000', 'temperatura', 503.0000, 'ºC'),
	(341168, 144, '2015-02-01 00:49:20.000000', 'temperatura', 1103.0000, 'ºC'),
	(341169, 144, '2015-02-01 00:49:21.000000', 'temperatura', 404.0000, 'ºC'),
	(341170, 144, '2015-02-01 00:49:22.000000', 'temperatura', 1114.0000, 'ºC'),
	(341171, 144, '2015-02-01 00:49:23.000000', 'temperatura', 755.0000, 'ºC'),
	(341172, 144, '2015-02-01 00:49:24.000000', 'temperatura', 437.0000, 'ºC'),
	(341173, 144, '2015-02-01 00:49:25.000000', 'temperatura', 1119.0000, 'ºC'),
	(341174, 144, '2015-02-01 00:49:26.000000', 'temperatura', 685.0000, 'ºC'),
	(341175, 144, '2015-02-01 00:49:27.000000', 'temperatura', 68.0000, 'ºC'),
	(341176, 144, '2015-02-01 00:49:28.000000', 'temperatura', 685.0000, 'ºC'),
	(341177, 144, '2015-02-01 00:49:29.000000', 'temperatura', 822.0000, 'ºC'),
	(341178, 144, '2015-02-01 00:49:30.000000', 'temperatura', 854.0000, 'ºC'),
	(341179, 144, '2015-02-01 00:49:31.000000', 'temperatura', 604.0000, 'ºC'),
	(341180, 144, '2015-02-01 00:49:32.000000', 'temperatura', 458.0000, 'ºC'),
	(341181, 144, '2015-02-01 00:49:33.000000', 'temperatura', 479.0000, 'ºC'),
	(341182, 144, '2015-02-01 00:49:34.000000', 'temperatura', 1022.0000, 'ºC'),
	(341183, 144, '2015-02-01 00:49:35.000000', 'temperatura', 75.0000, 'ºC'),
	(341184, 144, '2015-02-01 00:49:36.000000', 'temperatura', 907.0000, 'ºC'),
	(341185, 144, '2015-02-01 00:49:37.000000', 'temperatura', 710.0000, 'ºC'),
	(341186, 144, '2015-02-01 00:49:38.000000', 'temperatura', 830.0000, 'ºC'),
	(341187, 144, '2015-02-01 00:49:39.000000', 'temperatura', 823.0000, 'ºC'),
	(341188, 144, '2015-02-01 00:49:40.000000', 'temperatura', 422.0000, 'ºC'),
	(341189, 144, '2015-02-01 00:49:41.000000', 'temperatura', 845.0000, 'ºC'),
	(341190, 144, '2015-02-01 00:49:42.000000', 'temperatura', 557.0000, 'ºC'),
	(341191, 144, '2015-02-01 00:49:43.000000', 'temperatura', 253.0000, 'ºC'),
	(341192, 144, '2015-02-01 00:49:44.000000', 'temperatura', 793.0000, 'ºC'),
	(341193, 144, '2015-02-01 00:49:45.000000', 'temperatura', 808.0000, 'ºC'),
	(341194, 144, '2015-02-01 00:49:46.000000', 'temperatura', 459.0000, 'ºC'),
	(341195, 144, '2015-02-01 00:49:47.000000', 'temperatura', 1073.0000, 'ºC'),
	(341196, 144, '2015-02-01 00:49:48.000000', 'temperatura', 388.0000, 'ºC'),
	(341197, 144, '2015-02-01 00:49:49.000000', 'temperatura', 1120.0000, 'ºC'),
	(341198, 144, '2015-02-01 00:49:50.000000', 'temperatura', 837.0000, 'ºC'),
	(341199, 144, '2015-02-01 00:49:51.000000', 'temperatura', 827.0000, 'ºC'),
	(341200, 144, '2015-02-01 00:49:52.000000', 'temperatura', 425.0000, 'ºC'),
	(341201, 144, '2015-02-01 00:49:53.000000', 'temperatura', 845.0000, 'ºC'),
	(341202, 144, '2015-02-01 00:49:54.000000', 'temperatura', 550.0000, 'ºC'),
	(341203, 144, '2015-02-01 00:49:55.000000', 'temperatura', 216.0000, 'ºC'),
	(341204, 144, '2015-02-01 00:49:56.000000', 'temperatura', 629.0000, 'ºC'),
	(341205, 144, '2015-02-01 00:49:57.000000', 'temperatura', 98.0000, 'ºC'),
	(341206, 144, '2015-02-01 00:49:58.000000', 'temperatura', 1005.0000, 'ºC'),
	(341207, 144, '2015-02-01 00:49:59.000000', 'temperatura', 1132.0000, 'ºC'),
	(341208, 144, '2015-02-01 00:50:00.000000', 'temperatura', 246.0000, 'ºC'),
	(341209, 144, '2015-02-01 00:50:01.000000', 'temperatura', 232.0000, 'ºC'),
	(341210, 144, '2015-02-01 00:50:02.000000', 'temperatura', 424.0000, 'ºC'),
	(341211, 144, '2015-02-01 00:50:03.000000', 'temperatura', 226.0000, 'ºC'),
	(341212, 144, '2015-02-01 00:50:04.000000', 'temperatura', 1055.0000, 'ºC'),
	(341213, 144, '2015-02-01 00:50:05.000000', 'temperatura', 1000.0000, 'ºC'),
	(341214, 144, '2015-02-01 00:50:06.000000', 'temperatura', 633.0000, 'ºC'),
	(341215, 144, '2015-02-01 00:50:07.000000', 'temperatura', 167.0000, 'ºC'),
	(341216, 144, '2015-02-01 00:50:08.000000', 'temperatura', 136.0000, 'ºC'),
	(341217, 144, '2015-02-01 00:50:09.000000', 'temperatura', 180.0000, 'ºC'),
	(341218, 144, '2015-02-01 00:50:10.000000', 'temperatura', 492.0000, 'ºC'),
	(341219, 144, '2015-02-01 00:50:11.000000', 'temperatura', 720.0000, 'ºC'),
	(341220, 144, '2015-02-01 00:50:12.000000', 'temperatura', 923.0000, 'ºC'),
	(341221, 144, '2015-02-01 00:50:13.000000', 'temperatura', 57.0000, 'ºC'),
	(341222, 144, '2015-02-01 00:50:14.000000', 'temperatura', 1117.0000, 'ºC'),
	(341223, 144, '2015-02-01 00:50:15.000000', 'temperatura', 613.0000, 'ºC'),
	(341224, 144, '2015-02-01 00:50:16.000000', 'temperatura', 915.0000, 'ºC'),
	(341225, 144, '2015-02-01 00:50:17.000000', 'temperatura', 338.0000, 'ºC'),
	(341226, 144, '2015-02-01 00:50:18.000000', 'temperatura', 146.0000, 'ºC'),
	(341227, 144, '2015-02-01 00:50:19.000000', 'temperatura', 916.0000, 'ºC'),
	(341228, 144, '2015-02-01 00:50:20.000000', 'temperatura', 541.0000, 'ºC'),
	(341229, 144, '2015-02-01 00:50:21.000000', 'temperatura', 1159.0000, 'ºC'),
	(341230, 144, '2015-02-01 00:50:22.000000', 'temperatura', 573.0000, 'ºC'),
	(341231, 144, '2015-02-01 00:50:23.000000', 'temperatura', 590.0000, 'ºC'),
	(341232, 144, '2015-02-01 00:50:24.000000', 'temperatura', 29.0000, 'ºC'),
	(341233, 144, '2015-02-01 00:50:25.000000', 'temperatura', 776.0000, 'ºC'),
	(341234, 144, '2015-02-01 00:50:26.000000', 'temperatura', 195.0000, 'ºC'),
	(341235, 144, '2015-02-01 00:50:27.000000', 'temperatura', 1047.0000, 'ºC'),
	(341236, 144, '2015-02-01 00:50:28.000000', 'temperatura', 1050.0000, 'ºC'),
	(341237, 144, '2015-02-01 00:50:29.000000', 'temperatura', 909.0000, 'ºC'),
	(341238, 144, '2015-02-01 00:50:30.000000', 'temperatura', 196.0000, 'ºC'),
	(341239, 144, '2015-02-01 00:50:31.000000', 'temperatura', 651.0000, 'ºC'),
	(341240, 144, '2015-02-01 00:50:32.000000', 'temperatura', 271.0000, 'ºC'),
	(341241, 144, '2015-02-01 00:50:33.000000', 'temperatura', 602.0000, 'ºC'),
	(341242, 144, '2015-02-01 00:50:34.000000', 'temperatura', 995.0000, 'ºC'),
	(341243, 144, '2015-02-01 00:50:35.000000', 'temperatura', 772.0000, 'ºC'),
	(341244, 144, '2015-02-01 00:50:36.000000', 'temperatura', 874.0000, 'ºC'),
	(341245, 144, '2015-02-01 00:50:37.000000', 'temperatura', 855.0000, 'ºC'),
	(341246, 144, '2015-02-01 00:50:38.000000', 'temperatura', 455.0000, 'ºC'),
	(341247, 144, '2015-02-01 00:50:39.000000', 'temperatura', 908.0000, 'ºC'),
	(341248, 144, '2015-02-01 00:50:40.000000', 'temperatura', 777.0000, 'ºC'),
	(341249, 144, '2015-02-01 00:50:41.000000', 'temperatura', 1162.0000, 'ºC'),
	(341250, 144, '2015-02-01 00:50:42.000000', 'temperatura', 1081.0000, 'ºC'),
	(341251, 144, '2015-02-01 00:50:43.000000', 'temperatura', 718.0000, 'ºC'),
	(341252, 144, '2015-02-01 00:50:44.000000', 'temperatura', 348.0000, 'ºC'),
	(341253, 144, '2015-02-01 00:50:45.000000', 'temperatura', 785.0000, 'ºC'),
	(341254, 144, '2015-02-01 00:50:46.000000', 'temperatura', 484.0000, 'ºC'),
	(341255, 144, '2015-02-01 00:50:47.000000', 'temperatura', 65.0000, 'ºC'),
	(341256, 144, '2015-02-01 00:50:48.000000', 'temperatura', 74.0000, 'ºC'),
	(341257, 144, '2015-02-01 00:50:49.000000', 'temperatura', 175.0000, 'ºC'),
	(341258, 144, '2015-02-01 00:50:50.000000', 'temperatura', 652.0000, 'ºC'),
	(341259, 144, '2015-02-01 00:50:51.000000', 'temperatura', 335.0000, 'ºC'),
	(341260, 144, '2015-02-01 00:50:52.000000', 'temperatura', 921.0000, 'ºC'),
	(341261, 144, '2015-02-01 00:50:53.000000', 'temperatura', 2.0000, 'ºC'),
	(341262, 144, '2015-02-01 00:50:54.000000', 'temperatura', 844.0000, 'ºC'),
	(341263, 144, '2015-02-01 00:50:55.000000', 'temperatura', 617.0000, 'ºC'),
	(341264, 144, '2015-02-01 00:50:56.000000', 'temperatura', 553.0000, 'ºC'),
	(341265, 144, '2015-02-01 00:50:57.000000', 'temperatura', 914.0000, 'ºC'),
	(341266, 144, '2015-02-01 00:50:58.000000', 'temperatura', 513.0000, 'ºC'),
	(341267, 144, '2015-02-01 00:50:59.000000', 'temperatura', 1023.0000, 'ºC'),
	(341268, 144, '2015-02-01 00:51:00.000000', 'temperatura', 1176.0000, 'ºC'),
	(341269, 144, '2015-02-01 00:51:01.000000', 'temperatura', 412.0000, 'ºC'),
	(341270, 144, '2015-02-01 00:51:02.000000', 'temperatura', 933.0000, 'ºC'),
	(341271, 144, '2015-02-01 00:51:03.000000', 'temperatura', 1029.0000, 'ºC'),
	(341272, 144, '2015-02-01 00:51:04.000000', 'temperatura', 1148.0000, 'ºC'),
	(341273, 144, '2015-02-01 00:51:05.000000', 'temperatura', 254.0000, 'ºC'),
	(341274, 144, '2015-02-01 00:51:06.000000', 'temperatura', 227.0000, 'ºC'),
	(341275, 144, '2015-02-01 00:51:07.000000', 'temperatura', 371.0000, 'ºC'),
	(341276, 144, '2015-02-01 00:51:08.000000', 'temperatura', 1176.0000, 'ºC'),
	(341277, 144, '2015-02-01 00:51:09.000000', 'temperatura', 1167.0000, 'ºC'),
	(341278, 144, '2015-02-01 00:51:10.000000', 'temperatura', 1108.0000, 'ºC'),
	(341279, 144, '2015-02-01 00:51:11.000000', 'temperatura', 839.0000, 'ºC'),
	(341280, 144, '2015-02-01 00:51:12.000000', 'temperatura', 871.0000, 'ºC'),
	(341281, 144, '2015-02-01 00:51:13.000000', 'temperatura', 640.0000, 'ºC'),
	(341282, 144, '2015-02-01 00:51:14.000000', 'temperatura', 589.0000, 'ºC'),
	(341283, 144, '2015-02-01 00:51:15.000000', 'temperatura', 1023.0000, 'ºC'),
	(341284, 144, '2015-02-01 00:51:16.000000', 'temperatura', 950.0000, 'ºC'),
	(341285, 144, '2015-02-01 00:51:17.000000', 'temperatura', 481.0000, 'ºC'),
	(341286, 144, '2015-02-01 00:51:18.000000', 'temperatura', 755.0000, 'ºC'),
	(341287, 144, '2015-02-01 00:51:19.000000', 'temperatura', 1133.0000, 'ºC'),
	(341288, 144, '2015-02-01 00:51:20.000000', 'temperatura', 999.0000, 'ºC'),
	(341289, 144, '2015-02-01 00:51:21.000000', 'temperatura', 398.0000, 'ºC'),
	(341290, 144, '2015-02-01 00:51:22.000000', 'temperatura', 193.0000, 'ºC'),
	(341291, 144, '2015-02-01 00:51:23.000000', 'temperatura', 972.0000, 'ºC'),
	(341292, 144, '2015-02-01 00:51:24.000000', 'temperatura', 681.0000, 'ºC'),
	(341293, 144, '2015-02-01 00:51:25.000000', 'temperatura', 491.0000, 'ºC'),
	(341294, 144, '2015-02-01 00:51:26.000000', 'temperatura', 411.0000, 'ºC'),
	(341295, 144, '2015-02-01 00:51:27.000000', 'temperatura', 582.0000, 'ºC'),
	(341296, 144, '2015-02-01 00:51:28.000000', 'temperatura', 477.0000, 'ºC'),
	(341297, 144, '2015-02-01 00:51:29.000000', 'temperatura', 642.0000, 'ºC'),
	(341298, 144, '2015-02-01 00:51:30.000000', 'temperatura', 578.0000, 'ºC'),
	(341299, 144, '2015-02-01 00:51:31.000000', 'temperatura', 966.0000, 'ºC'),
	(341300, 144, '2015-02-01 00:51:32.000000', 'temperatura', 696.0000, 'ºC'),
	(341301, 144, '2015-02-01 00:51:33.000000', 'temperatura', 583.0000, 'ºC'),
	(341302, 144, '2015-02-01 00:51:34.000000', 'temperatura', 825.0000, 'ºC'),
	(341303, 144, '2015-02-01 00:51:35.000000', 'temperatura', 1180.0000, 'ºC'),
	(341304, 144, '2015-02-01 00:51:36.000000', 'temperatura', 1024.0000, 'ºC'),
	(341305, 144, '2015-02-01 00:51:37.000000', 'temperatura', 379.0000, 'ºC'),
	(341306, 144, '2015-02-01 00:51:38.000000', 'temperatura', 23.0000, 'ºC'),
	(341307, 144, '2015-02-01 00:51:39.000000', 'temperatura', 179.0000, 'ºC'),
	(341308, 144, '2015-02-01 00:51:40.000000', 'temperatura', 826.0000, 'ºC'),
	(341309, 144, '2015-02-01 00:51:41.000000', 'temperatura', 1193.0000, 'ºC'),
	(341310, 144, '2015-02-01 00:51:42.000000', 'temperatura', 1088.0000, 'ºC'),
	(341311, 144, '2015-02-01 00:51:43.000000', 'temperatura', 660.0000, 'ºC'),
	(341312, 144, '2015-02-01 00:51:44.000000', 'temperatura', 39.0000, 'ºC'),
	(341313, 144, '2015-02-01 00:51:45.000000', 'temperatura', 615.0000, 'ºC'),
	(341314, 144, '2015-02-01 00:51:46.000000', 'temperatura', 559.0000, 'ºC'),
	(341315, 144, '2015-02-01 00:51:47.000000', 'temperatura', 949.0000, 'ºC'),
	(341316, 144, '2015-02-01 00:51:48.000000', 'temperatura', 668.0000, 'ºC'),
	(341317, 144, '2015-02-01 00:51:49.000000', 'temperatura', 492.0000, 'ºC'),
	(341318, 144, '2015-02-01 00:51:50.000000', 'temperatura', 460.0000, 'ºC'),
	(341319, 144, '2015-02-01 00:51:51.000000', 'temperatura', 823.0000, 'ºC'),
	(341320, 144, '2015-02-01 00:51:52.000000', 'temperatura', 336.0000, 'ºC'),
	(341321, 144, '2015-02-01 00:51:53.000000', 'temperatura', 410.0000, 'ºC'),
	(341322, 144, '2015-02-01 00:51:54.000000', 'temperatura', 1042.0000, 'ºC'),
	(341323, 144, '2015-02-01 00:51:55.000000', 'temperatura', 384.0000, 'ºC'),
	(341324, 144, '2015-02-01 00:51:56.000000', 'temperatura', 1191.0000, 'ºC'),
	(341325, 144, '2015-02-01 00:51:57.000000', 'temperatura', 4.0000, 'ºC'),
	(341326, 144, '2015-02-01 00:51:58.000000', 'temperatura', 46.0000, 'ºC'),
	(341327, 144, '2015-02-01 00:51:59.000000', 'temperatura', 220.0000, 'ºC'),
	(341328, 144, '2015-02-01 00:52:00.000000', 'temperatura', 963.0000, 'ºC'),
	(341329, 144, '2015-02-01 00:52:01.000000', 'temperatura', 557.0000, 'ºC'),
	(341330, 144, '2015-02-01 00:52:02.000000', 'temperatura', 1093.0000, 'ºC'),
	(341331, 144, '2015-02-01 00:52:03.000000', 'temperatura', 197.0000, 'ºC'),
	(341332, 144, '2015-02-01 00:52:04.000000', 'temperatura', 106.0000, 'ºC'),
	(341333, 144, '2015-02-01 00:52:05.000000', 'temperatura', 1139.0000, 'ºC'),
	(341334, 144, '2015-02-01 00:52:06.000000', 'temperatura', 577.0000, 'ºC'),
	(341335, 144, '2015-02-01 00:52:07.000000', 'temperatura', 670.0000, 'ºC'),
	(341336, 144, '2015-02-01 00:52:08.000000', 'temperatura', 420.0000, 'ºC'),
	(341337, 144, '2015-02-01 00:52:09.000000', 'temperatura', 88.0000, 'ºC'),
	(341338, 144, '2015-02-01 00:52:10.000000', 'temperatura', 383.0000, 'ºC'),
	(341339, 144, '2015-02-01 00:52:11.000000', 'temperatura', 449.0000, 'ºC'),
	(341340, 144, '2015-02-01 00:52:12.000000', 'temperatura', 1099.0000, 'ºC'),
	(341341, 144, '2015-02-01 00:52:13.000000', 'temperatura', 549.0000, 'ºC'),
	(341342, 144, '2015-02-01 00:52:14.000000', 'temperatura', 646.0000, 'ºC'),
	(341343, 144, '2015-02-01 00:52:15.000000', 'temperatura', 384.0000, 'ºC'),
	(341344, 144, '2015-02-01 00:52:16.000000', 'temperatura', 1183.0000, 'ºC'),
	(341345, 144, '2015-02-01 00:52:17.000000', 'temperatura', 1164.0000, 'ºC'),
	(341346, 144, '2015-02-01 00:52:18.000000', 'temperatura', 1072.0000, 'ºC'),
	(341347, 144, '2015-02-01 00:52:19.000000', 'temperatura', 668.0000, 'ºC'),
	(341348, 144, '2015-02-01 00:52:20.000000', 'temperatura', 124.0000, 'ºC'),
	(341349, 144, '2015-02-01 00:52:21.000000', 'temperatura', 1016.0000, 'ºC'),
	(341350, 144, '2015-02-01 00:52:22.000000', 'temperatura', 1110.0000, 'ºC'),
	(341351, 144, '2015-02-01 00:52:23.000000', 'temperatura', 102.0000, 'ºC'),
	(341352, 144, '2015-02-01 00:52:24.000000', 'temperatura', 779.0000, 'ºC'),
	(341353, 144, '2015-02-01 00:52:25.000000', 'temperatura', 1193.0000, 'ºC'),
	(341354, 144, '2015-02-01 00:52:26.000000', 'temperatura', 25.0000, 'ºC'),
	(341355, 144, '2015-02-01 00:52:27.000000', 'temperatura', 147.0000, 'ºC'),
	(341356, 144, '2015-02-01 00:52:28.000000', 'temperatura', 662.0000, 'ºC'),
	(341357, 144, '2015-02-01 00:52:29.000000', 'temperatura', 467.0000, 'ºC'),
	(341358, 144, '2015-02-01 00:52:30.000000', 'temperatura', 352.0000, 'ºC'),
	(341359, 144, '2015-02-01 00:52:31.000000', 'temperatura', 357.0000, 'ºC'),
	(341360, 144, '2015-02-01 00:52:32.000000', 'temperatura', 729.0000, 'ºC'),
	(341361, 144, '2015-02-01 00:52:33.000000', 'temperatura', 177.0000, 'ºC'),
	(341362, 144, '2015-02-01 00:52:34.000000', 'temperatura', 1098.0000, 'ºC'),
	(341363, 144, '2015-02-01 00:52:35.000000', 'temperatura', 158.0000, 'ºC'),
	(341364, 144, '2015-02-01 00:52:36.000000', 'temperatura', 1097.0000, 'ºC'),
	(341365, 144, '2015-02-01 00:52:37.000000', 'temperatura', 213.0000, 'ºC'),
	(341366, 144, '2015-02-01 00:52:38.000000', 'temperatura', 172.0000, 'ºC'),
	(341367, 144, '2015-02-01 00:52:39.000000', 'temperatura', 223.0000, 'ºC'),
	(341368, 144, '2015-02-01 00:52:40.000000', 'temperatura', 597.0000, 'ºC'),
	(341369, 144, '2015-02-01 00:52:41.000000', 'temperatura', 1120.0000, 'ºC'),
	(341370, 144, '2015-02-01 00:52:42.000000', 'temperatura', 207.0000, 'ºC'),
	(341371, 144, '2015-02-01 00:52:43.000000', 'temperatura', 75.0000, 'ºC'),
	(341372, 144, '2015-02-01 00:52:44.000000', 'temperatura', 954.0000, 'ºC'),
	(341373, 144, '2015-02-01 00:52:45.000000', 'temperatura', 945.0000, 'ºC'),
	(341374, 144, '2015-02-01 00:52:46.000000', 'temperatura', 664.0000, 'ºC'),
	(341375, 144, '2015-02-01 00:52:47.000000', 'temperatura', 486.0000, 'ºC'),
	(341376, 144, '2015-02-01 00:52:48.000000', 'temperatura', 437.0000, 'ºC'),
	(341377, 144, '2015-02-01 00:52:49.000000', 'temperatura', 730.0000, 'ºC'),
	(341378, 144, '2015-02-01 00:52:50.000000', 'temperatura', 1138.0000, 'ºC'),
	(341379, 144, '2015-02-01 00:52:51.000000', 'temperatura', 1100.0000, 'ºC'),
	(341380, 144, '2015-02-01 00:52:52.000000', 'temperatura', 887.0000, 'ºC'),
	(341381, 144, '2015-02-01 00:52:53.000000', 'temperatura', 1136.0000, 'ºC'),
	(341382, 144, '2015-02-01 00:52:54.000000', 'temperatura', 618.0000, 'ºC'),
	(341383, 144, '2015-02-01 00:52:55.000000', 'temperatura', 883.0000, 'ºC'),
	(341384, 144, '2015-02-01 00:52:56.000000', 'temperatura', 162.0000, 'ºC'),
	(341385, 144, '2015-02-01 00:52:57.000000', 'temperatura', 559.0000, 'ºC'),
	(341386, 144, '2015-02-01 00:52:58.000000', 'temperatura', 1112.0000, 'ºC'),
	(341387, 144, '2015-02-01 00:52:59.000000', 'temperatura', 283.0000, 'ºC'),
	(341388, 144, '2015-02-01 00:53:00.000000', 'temperatura', 478.0000, 'ºC'),
	(341389, 144, '2015-02-01 00:53:01.000000', 'temperatura', 341.0000, 'ºC'),
	(341390, 144, '2015-02-01 00:53:02.000000', 'temperatura', 271.0000, 'ºC'),
	(341391, 144, '2015-02-01 00:53:03.000000', 'temperatura', 333.0000, 'ºC'),
	(341392, 144, '2015-02-01 00:53:04.000000', 'temperatura', 855.0000, 'ºC'),
	(341393, 144, '2015-02-01 00:53:05.000000', 'temperatura', 875.0000, 'ºC'),
	(341394, 144, '2015-02-01 00:53:06.000000', 'temperatura', 610.0000, 'ºC'),
	(341395, 144, '2015-02-01 00:53:07.000000', 'temperatura', 424.0000, 'ºC'),
	(341396, 144, '2015-02-01 00:53:08.000000', 'temperatura', 292.0000, 'ºC'),
	(341397, 144, '2015-02-01 00:53:09.000000', 'temperatura', 189.0000, 'ºC'),
	(341398, 144, '2015-02-01 00:53:10.000000', 'temperatura', 68.0000, 'ºC'),
	(341399, 144, '2015-02-01 00:53:11.000000', 'temperatura', 974.0000, 'ºC'),
	(341400, 144, '2015-02-01 00:53:12.000000', 'temperatura', 1068.0000, 'ºC'),
	(341401, 144, '2015-02-01 00:53:13.000000', 'temperatura', 20.0000, 'ºC'),
	(341402, 144, '2015-02-01 00:53:14.000000', 'temperatura', 493.0000, 'ºC'),
	(341403, 144, '2015-02-01 00:53:15.000000', 'temperatura', 9.0000, 'ºC'),
	(341404, 144, '2015-02-01 00:53:16.000000', 'temperatura', 964.0000, 'ºC'),
	(341405, 144, '2015-02-01 00:53:17.000000', 'temperatura', 1193.0000, 'ºC'),
	(341406, 144, '2015-02-01 00:53:18.000000', 'temperatura', 674.0000, 'ºC'),
	(341407, 144, '2015-02-01 00:53:19.000000', 'temperatura', 993.0000, 'ºC'),
	(341408, 144, '2015-02-01 00:53:20.000000', 'temperatura', 544.0000, 'ºC'),
	(341409, 144, '2015-02-01 00:53:21.000000', 'temperatura', 942.0000, 'ºC'),
	(341410, 144, '2015-02-01 00:53:22.000000', 'temperatura', 677.0000, 'ºC'),
	(341411, 144, '2015-02-01 00:53:23.000000', 'temperatura', 560.0000, 'ºC'),
	(341412, 144, '2015-02-01 00:53:24.000000', 'temperatura', 768.0000, 'ºC'),
	(341413, 144, '2015-02-01 00:53:25.000000', 'temperatura', 962.0000, 'ºC'),
	(341414, 144, '2015-02-01 00:53:26.000000', 'temperatura', 104.0000, 'ºC'),
	(341415, 144, '2015-02-01 00:53:27.000000', 'temperatura', 37.0000, 'ºC'),
	(341416, 144, '2015-02-01 00:53:28.000000', 'temperatura', 1072.0000, 'ºC'),
	(341417, 144, '2015-02-01 00:53:29.000000', 'temperatura', 448.0000, 'ºC'),
	(341418, 144, '2015-02-01 00:53:30.000000', 'temperatura', 227.0000, 'ºC'),
	(341419, 144, '2015-02-01 00:53:31.000000', 'temperatura', 989.0000, 'ºC'),
	(341420, 144, '2015-02-01 00:53:32.000000', 'temperatura', 668.0000, 'ºC'),
	(341421, 144, '2015-02-01 00:53:33.000000', 'temperatura', 371.0000, 'ºC'),
	(341422, 144, '2015-02-01 00:53:34.000000', 'temperatura', 1051.0000, 'ºC'),
	(341423, 144, '2015-02-01 00:53:35.000000', 'temperatura', 544.0000, 'ºC'),
	(341424, 144, '2015-02-01 00:53:36.000000', 'temperatura', 767.0000, 'ºC'),
	(341425, 144, '2015-02-01 00:53:37.000000', 'temperatura', 1002.0000, 'ºC'),
	(341426, 144, '2015-02-01 00:53:38.000000', 'temperatura', 308.0000, 'ºC'),
	(341427, 144, '2015-02-01 00:53:39.000000', 'temperatura', 938.0000, 'ºC'),
	(341428, 144, '2015-02-01 00:53:40.000000', 'temperatura', 166.0000, 'ºC'),
	(341429, 144, '2015-02-01 00:53:41.000000', 'temperatura', 414.0000, 'ºC'),
	(341430, 144, '2015-02-01 00:53:42.000000', 'temperatura', 374.0000, 'ºC'),
	(341431, 144, '2015-02-01 00:53:43.000000', 'temperatura', 629.0000, 'ºC'),
	(341432, 144, '2015-02-01 00:53:44.000000', 'temperatura', 823.0000, 'ºC'),
	(341433, 144, '2015-02-01 00:53:45.000000', 'temperatura', 1027.0000, 'ºC'),
	(341434, 144, '2015-02-01 00:53:46.000000', 'temperatura', 266.0000, 'ºC'),
	(341435, 144, '2015-02-01 00:53:47.000000', 'temperatura', 650.0000, 'ºC'),
	(341436, 144, '2015-02-01 00:53:48.000000', 'temperatura', 52.0000, 'ºC'),
	(341437, 144, '2015-02-01 00:53:49.000000', 'temperatura', 711.0000, 'ºC'),
	(341438, 144, '2015-02-01 00:53:50.000000', 'temperatura', 1002.0000, 'ºC'),
	(341439, 144, '2015-02-01 00:53:51.000000', 'temperatura', 474.0000, 'ºC'),
	(341440, 144, '2015-02-01 00:53:52.000000', 'temperatura', 566.0000, 'ºC'),
	(341441, 144, '2015-02-01 00:53:53.000000', 'temperatura', 208.0000, 'ºC'),
	(341442, 144, '2015-02-01 00:53:54.000000', 'temperatura', 544.0000, 'ºC'),
	(341443, 144, '2015-02-01 00:53:55.000000', 'temperatura', 898.0000, 'ºC'),
	(341444, 144, '2015-02-01 00:53:56.000000', 'temperatura', 455.0000, 'ºC'),
	(341445, 144, '2015-02-01 00:53:57.000000', 'temperatura', 783.0000, 'ºC'),
	(341446, 144, '2015-02-01 00:53:58.000000', 'temperatura', 151.0000, 'ºC'),
	(341447, 144, '2015-02-01 00:53:59.000000', 'temperatura', 807.0000, 'ºC'),
	(341448, 144, '2015-02-01 00:54:00.000000', 'temperatura', 1182.0000, 'ºC'),
	(341449, 144, '2015-02-01 00:54:01.000000', 'temperatura', 1091.0000, 'ºC'),
	(341450, 144, '2015-02-01 00:54:02.000000', 'temperatura', 708.0000, 'ºC'),
	(341451, 144, '2015-02-01 00:54:03.000000', 'temperatura', 270.0000, 'ºC'),
	(341452, 144, '2015-02-01 00:54:04.000000', 'temperatura', 424.0000, 'ºC'),
	(341453, 144, '2015-02-01 00:54:05.000000', 'temperatura', 109.0000, 'ºC'),
	(341454, 144, '2015-02-01 00:54:06.000000', 'temperatura', 475.0000, 'ºC'),
	(341455, 144, '2015-02-01 00:54:07.000000', 'temperatura', 849.0000, 'ºC'),
	(341456, 144, '2015-02-01 00:54:08.000000', 'temperatura', 421.0000, 'ºC'),
	(341457, 144, '2015-02-01 00:54:09.000000', 'temperatura', 756.0000, 'ºC'),
	(341458, 144, '2015-02-01 00:54:10.000000', 'temperatura', 120.0000, 'ºC'),
	(341459, 144, '2015-02-01 00:54:11.000000', 'temperatura', 730.0000, 'ºC'),
	(341460, 144, '2015-02-01 00:54:12.000000', 'temperatura', 891.0000, 'ºC'),
	(341461, 144, '2015-02-01 00:54:13.000000', 'temperatura', 1066.0000, 'ºC'),
	(341462, 144, '2015-02-01 00:54:14.000000', 'temperatura', 256.0000, 'ºC'),
	(341463, 144, '2015-02-01 00:54:15.000000', 'temperatura', 482.0000, 'ºC'),
	(341464, 144, '2015-02-01 00:54:16.000000', 'temperatura', 443.0000, 'ºC'),
	(341465, 144, '2015-02-01 00:54:17.000000', 'temperatura', 770.0000, 'ºC'),
	(341466, 144, '2015-02-01 00:54:18.000000', 'temperatura', 122.0000, 'ºC'),
	(341467, 144, '2015-02-01 00:54:19.000000', 'temperatura', 702.0000, 'ºC'),
	(341468, 144, '2015-02-01 00:54:20.000000', 'temperatura', 742.0000, 'ºC'),
	(341469, 144, '2015-02-01 00:54:21.000000', 'temperatura', 405.0000, 'ºC'),
	(341470, 144, '2015-02-01 00:54:22.000000', 'temperatura', 1000.0000, 'ºC'),
	(341471, 144, '2015-02-01 00:54:23.000000', 'temperatura', 183.0000, 'ºC'),
	(341472, 144, '2015-02-01 00:54:24.000000', 'temperatura', 319.0000, 'ºC'),
	(341473, 144, '2015-02-01 00:54:25.000000', 'temperatura', 1043.0000, 'ºC'),
	(341474, 144, '2015-02-01 00:54:26.000000', 'temperatura', 661.0000, 'ºC'),
	(341475, 144, '2015-02-01 00:54:27.000000', 'temperatura', 175.0000, 'ºC'),
	(341476, 144, '2015-02-01 00:54:28.000000', 'temperatura', 91.0000, 'ºC'),
	(341477, 144, '2015-02-01 00:54:29.000000', 'temperatura', 1132.0000, 'ºC'),
	(341478, 144, '2015-02-01 00:54:30.000000', 'temperatura', 586.0000, 'ºC'),
	(341479, 144, '2015-02-01 00:54:31.000000', 'temperatura', 737.0000, 'ºC'),
	(341480, 144, '2015-02-01 00:54:32.000000', 'temperatura', 727.0000, 'ºC'),
	(341481, 144, '2015-02-01 00:54:33.000000', 'temperatura', 222.0000, 'ºC'),
	(341482, 144, '2015-02-01 00:54:34.000000', 'temperatura', 131.0000, 'ºC'),
	(341483, 144, '2015-02-01 00:54:35.000000', 'temperatura', 1190.0000, 'ºC'),
	(341484, 144, '2015-02-01 00:54:36.000000', 'temperatura', 756.0000, 'ºC'),
	(341485, 144, '2015-02-01 00:54:37.000000', 'temperatura', 212.0000, 'ºC'),
	(341486, 144, '2015-02-01 00:54:38.000000', 'temperatura', 1194.0000, 'ºC'),
	(341487, 144, '2015-02-01 00:54:39.000000', 'temperatura', 533.0000, 'ºC'),
	(341488, 144, '2015-02-01 00:54:40.000000', 'temperatura', 283.0000, 'ºC'),
	(341489, 144, '2015-02-01 00:54:41.000000', 'temperatura', 1016.0000, 'ºC'),
	(341490, 144, '2015-02-01 00:54:42.000000', 'temperatura', 634.0000, 'ºC'),
	(341491, 144, '2015-02-01 00:54:43.000000', 'temperatura', 122.0000, 'ºC'),
	(341492, 144, '2015-02-01 00:54:44.000000', 'temperatura', 1107.0000, 'ºC'),
	(341493, 144, '2015-02-01 00:54:45.000000', 'temperatura', 371.0000, 'ºC'),
	(341494, 144, '2015-02-01 00:54:46.000000', 'temperatura', 932.0000, 'ºC'),
	(341495, 144, '2015-02-01 00:54:47.000000', 'temperatura', 1150.0000, 'ºC'),
	(341496, 144, '2015-02-01 00:54:48.000000', 'temperatura', 554.0000, 'ºC'),
	(341497, 144, '2015-02-01 00:54:49.000000', 'temperatura', 521.0000, 'ºC'),
	(341498, 144, '2015-02-01 00:54:50.000000', 'temperatura', 942.0000, 'ºC'),
	(341499, 144, '2015-02-01 00:54:51.000000', 'temperatura', 749.0000, 'ºC'),
	(341500, 144, '2015-02-01 00:54:52.000000', 'temperatura', 920.0000, 'ºC'),
	(341501, 144, '2015-02-01 00:54:53.000000', 'temperatura', 1152.0000, 'ºC'),
	(341502, 144, '2015-02-01 00:54:54.000000', 'temperatura', 601.0000, 'ºC'),
	(341503, 144, '2015-02-01 00:54:55.000000', 'temperatura', 751.0000, 'ºC'),
	(341504, 144, '2015-02-01 00:54:56.000000', 'temperatura', 750.0000, 'ºC'),
	(341505, 144, '2015-02-01 00:54:57.000000', 'temperatura', 296.0000, 'ºC'),
	(341506, 144, '2015-02-01 00:54:58.000000', 'temperatura', 434.0000, 'ºC'),
	(341507, 144, '2015-02-01 00:54:59.000000', 'temperatura', 82.0000, 'ºC'),
	(341508, 144, '2015-02-01 00:55:00.000000', 'temperatura', 308.0000, 'ºC'),
	(341509, 144, '2015-02-01 00:55:01.000000', 'temperatura', 94.0000, 'ºC'),
	(341510, 144, '2015-02-01 00:55:02.000000', 'temperatura', 746.0000, 'ºC'),
	(341511, 144, '2015-02-01 00:55:03.000000', 'temperatura', 1048.0000, 'ºC'),
	(341512, 144, '2015-02-01 00:55:04.000000', 'temperatura', 602.0000, 'ºC'),
	(341513, 144, '2015-02-01 00:55:05.000000', 'temperatura', 1069.0000, 'ºC'),
	(341514, 144, '2015-02-01 00:55:06.000000', 'temperatura', 1140.0000, 'ºC'),
	(341515, 144, '2015-02-01 00:55:07.000000', 'temperatura', 93.0000, 'ºC'),
	(341516, 144, '2015-02-01 00:55:08.000000', 'temperatura', 644.0000, 'ºC'),
	(341517, 144, '2015-02-01 00:55:09.000000', 'temperatura', 541.0000, 'ºC'),
	(341518, 144, '2015-02-01 00:55:10.000000', 'temperatura', 776.0000, 'ºC'),
	(341519, 144, '2015-02-01 00:55:11.000000', 'temperatura', 1054.0000, 'ºC'),
	(341520, 144, '2015-02-01 00:55:12.000000', 'temperatura', 546.0000, 'ºC'),
	(341521, 144, '2015-02-01 00:55:13.000000', 'temperatura', 765.0000, 'ºC'),
	(341522, 144, '2015-02-01 00:55:14.000000', 'temperatura', 989.0000, 'ºC'),
	(341523, 144, '2015-02-01 00:55:15.000000', 'temperatura', 253.0000, 'ºC'),
	(341524, 144, '2015-02-01 00:55:16.000000', 'temperatura', 695.0000, 'ºC'),
	(341525, 144, '2015-02-01 00:55:17.000000', 'temperatura', 317.0000, 'ºC'),
	(341526, 144, '2015-02-01 00:55:18.000000', 'temperatura', 702.0000, 'ºC'),
	(341527, 144, '2015-02-01 00:55:19.000000', 'temperatura', 160.0000, 'ºC'),
	(341528, 144, '2015-02-01 00:55:20.000000', 'temperatura', 1094.0000, 'ºC'),
	(341529, 144, '2015-02-01 00:55:21.000000', 'temperatura', 189.0000, 'ºC'),
	(341530, 144, '2015-02-01 00:55:22.000000', 'temperatura', 63.0000, 'ºC'),
	(341531, 144, '2015-02-01 00:55:23.000000', 'temperatura', 951.0000, 'ºC'),
	(341532, 144, '2015-02-01 00:55:24.000000', 'temperatura', 967.0000, 'ºC'),
	(341533, 144, '2015-02-01 00:55:25.000000', 'temperatura', 781.0000, 'ºC'),
	(341534, 144, '2015-02-01 00:55:26.000000', 'temperatura', 1007.0000, 'ºC'),
	(341535, 144, '2015-02-01 00:55:27.000000', 'temperatura', 290.0000, 'ºC'),
	(341536, 144, '2015-02-01 00:55:28.000000', 'temperatura', 831.0000, 'ºC'),
	(341537, 144, '2015-02-01 00:55:29.000000', 'temperatura', 885.0000, 'ºC'),
	(341538, 144, '2015-02-01 00:55:30.000000', 'temperatura', 732.0000, 'ºC'),
	(341539, 144, '2015-02-01 00:55:31.000000', 'temperatura', 1004.0000, 'ºC'),
	(341540, 144, '2015-02-01 00:55:32.000000', 'temperatura', 426.0000, 'ºC'),
	(341541, 144, '2015-02-01 00:55:33.000000', 'temperatura', 317.0000, 'ºC'),
	(341542, 144, '2015-02-01 00:55:34.000000', 'temperatura', 307.0000, 'ºC'),
	(341543, 144, '2015-02-01 00:55:35.000000', 'temperatura', 583.0000, 'ºC'),
	(341544, 144, '2015-02-01 00:55:36.000000', 'temperatura', 798.0000, 'ºC'),
	(341545, 144, '2015-02-01 00:55:37.000000', 'temperatura', 1039.0000, 'ºC'),
	(341546, 144, '2015-02-01 00:55:38.000000', 'temperatura', 404.0000, 'ºC'),
	(341547, 144, '2015-02-01 00:55:39.000000', 'temperatura', 103.0000, 'ºC'),
	(341548, 144, '2015-02-01 00:55:40.000000', 'temperatura', 501.0000, 'ºC'),
	(341549, 144, '2015-02-01 00:55:41.000000', 'temperatura', 1000.0000, 'ºC'),
	(341550, 144, '2015-02-01 00:55:42.000000', 'temperatura', 1095.0000, 'ºC'),
	(341551, 144, '2015-02-01 00:55:43.000000', 'temperatura', 75.0000, 'ºC'),
	(341552, 144, '2015-02-01 00:55:44.000000', 'temperatura', 692.0000, 'ºC'),
	(341553, 144, '2015-02-01 00:55:45.000000', 'temperatura', 836.0000, 'ºC'),
	(341554, 144, '2015-02-01 00:55:46.000000', 'temperatura', 905.0000, 'ºC'),
	(341555, 144, '2015-02-01 00:55:47.000000', 'temperatura', 816.0000, 'ºC'),
	(341556, 144, '2015-02-01 00:55:48.000000', 'temperatura', 165.0000, 'ºC'),
	(341557, 144, '2015-02-01 00:55:49.000000', 'temperatura', 776.0000, 'ºC'),
	(341558, 144, '2015-02-01 00:55:50.000000', 'temperatura', 988.0000, 'ºC'),
	(341559, 144, '2015-02-01 00:55:51.000000', 'temperatura', 210.0000, 'ºC'),
	(341560, 144, '2015-02-01 00:55:52.000000', 'temperatura', 487.0000, 'ºC'),
	(341561, 144, '2015-02-01 00:55:53.000000', 'temperatura', 605.0000, 'ºC'),
	(341562, 144, '2015-02-01 00:55:54.000000', 'temperatura', 367.0000, 'ºC'),
	(341563, 144, '2015-02-01 00:55:55.000000', 'temperatura', 18.0000, 'ºC'),
	(341564, 144, '2015-02-01 00:55:56.000000', 'temperatura', 189.0000, 'ºC'),
	(341565, 144, '2015-02-01 00:55:57.000000', 'temperatura', 892.0000, 'ºC'),
	(341566, 144, '2015-02-01 00:55:58.000000', 'temperatura', 293.0000, 'ºC'),
	(341567, 144, '2015-02-01 00:55:59.000000', 'temperatura', 1190.0000, 'ºC'),
	(341568, 144, '2015-02-01 00:56:00.000000', 'temperatura', 270.0000, 'ºC'),
	(341569, 144, '2015-02-01 00:56:01.000000', 'temperatura', 183.0000, 'ºC'),
	(341570, 144, '2015-02-01 00:56:02.000000', 'temperatura', 104.0000, 'ºC'),
	(341571, 144, '2015-02-01 00:56:03.000000', 'temperatura', 1170.0000, 'ºC'),
	(341572, 144, '2015-02-01 00:56:04.000000', 'temperatura', 740.0000, 'ºC'),
	(341573, 144, '2015-02-01 00:56:05.000000', 'temperatura', 190.0000, 'ºC'),
	(341574, 144, '2015-02-01 00:56:06.000000', 'temperatura', 1132.0000, 'ºC'),
	(341575, 144, '2015-02-01 00:56:07.000000', 'temperatura', 291.0000, 'ºC'),
	(341576, 144, '2015-02-01 00:56:08.000000', 'temperatura', 460.0000, 'ºC'),
	(341577, 144, '2015-02-01 00:56:09.000000', 'temperatura', 225.0000, 'ºC'),
	(341578, 144, '2015-02-01 00:56:10.000000', 'temperatura', 946.0000, 'ºC'),
	(341579, 144, '2015-02-01 00:56:11.000000', 'temperatura', 456.0000, 'ºC'),
	(341580, 144, '2015-02-01 00:56:12.000000', 'temperatura', 644.0000, 'ºC'),
	(341581, 144, '2015-02-01 00:56:13.000000', 'temperatura', 652.0000, 'ºC'),
	(341582, 144, '2015-02-01 00:56:14.000000', 'temperatura', 126.0000, 'ºC'),
	(341583, 144, '2015-02-01 00:56:15.000000', 'temperatura', 1078.0000, 'ºC'),
	(341584, 144, '2015-02-01 00:56:16.000000', 'temperatura', 211.0000, 'ºC'),
	(341585, 144, '2015-02-01 00:56:17.000000', 'temperatura', 223.0000, 'ºC'),
	(341586, 144, '2015-02-01 00:56:18.000000', 'temperatura', 482.0000, 'ºC'),
	(341587, 144, '2015-02-01 00:56:19.000000', 'temperatura', 540.0000, 'ºC'),
	(341588, 144, '2015-02-01 00:56:20.000000', 'temperatura', 55.0000, 'ºC'),
	(341589, 144, '2015-02-01 00:56:21.000000', 'temperatura', 1057.0000, 'ºC'),
	(341590, 144, '2015-02-01 00:56:22.000000', 'temperatura', 320.0000, 'ºC'),
	(341591, 144, '2015-02-01 00:56:23.000000', 'temperatura', 830.0000, 'ºC'),
	(341592, 144, '2015-02-01 00:56:24.000000', 'temperatura', 790.0000, 'ºC'),
	(341593, 144, '2015-02-01 00:56:25.000000', 'temperatura', 262.0000, 'ºC'),
	(341594, 144, '2015-02-01 00:56:26.000000', 'temperatura', 141.0000, 'ºC'),
	(341595, 144, '2015-02-01 00:56:27.000000', 'temperatura', 1117.0000, 'ºC'),
	(341596, 144, '2015-02-01 00:56:28.000000', 'temperatura', 361.0000, 'ºC'),
	(341597, 144, '2015-02-01 00:56:29.000000', 'temperatura', 858.0000, 'ºC'),
	(341598, 144, '2015-02-01 00:56:30.000000', 'temperatura', 805.0000, 'ºC'),
	(341599, 144, '2015-02-01 00:56:31.000000', 'temperatura', 253.0000, 'ºC'),
	(341600, 144, '2015-02-01 00:56:32.000000', 'temperatura', 50.0000, 'ºC'),
	(341601, 144, '2015-02-01 00:56:33.000000', 'temperatura', 693.0000, 'ºC'),
	(341602, 144, '2015-02-01 00:56:34.000000', 'temperatura', 914.0000, 'ºC'),
	(341603, 144, '2015-02-01 00:56:35.000000', 'temperatura', 92.0000, 'ºC'),
	(341604, 144, '2015-02-01 00:56:36.000000', 'temperatura', 119.0000, 'ºC'),
	(341605, 144, '2015-02-01 00:56:37.000000', 'temperatura', 318.0000, 'ºC'),
	(341606, 144, '2015-02-01 00:56:38.000000', 'temperatura', 34.0000, 'ºC'),
	(341607, 144, '2015-02-01 00:56:39.000000', 'temperatura', 418.0000, 'ºC'),
	(341608, 144, '2015-02-01 00:56:40.000000', 'temperatura', 787.0000, 'ºC'),
	(341609, 144, '2015-02-01 00:56:41.000000', 'temperatura', 283.0000, 'ºC'),
	(341610, 144, '2015-02-01 00:56:42.000000', 'temperatura', 254.0000, 'ºC'),
	(341611, 144, '2015-02-01 00:56:43.000000', 'temperatura', 422.0000, 'ºC'),
	(341612, 144, '2015-02-01 00:56:44.000000', 'temperatura', 147.0000, 'ºC'),
	(341613, 144, '2015-02-01 00:56:45.000000', 'temperatura', 670.0000, 'ºC'),
	(341614, 144, '2015-02-01 00:56:46.000000', 'temperatura', 511.0000, 'ºC'),
	(341615, 144, '2015-02-01 00:56:47.000000', 'temperatura', 542.0000, 'ºC'),
	(341616, 144, '2015-02-01 00:56:48.000000', 'temperatura', 1181.0000, 'ºC'),
	(341617, 144, '2015-02-01 00:56:49.000000', 'temperatura', 679.0000, 'ºC'),
	(341618, 144, '2015-02-01 00:56:50.000000', 'temperatura', 1053.0000, 'ºC'),
	(341619, 144, '2015-02-01 00:56:51.000000', 'temperatura', 829.0000, 'ºC'),
	(341620, 144, '2015-02-01 00:56:52.000000', 'temperatura', 986.0000, 'ºC'),
	(341621, 144, '2015-02-01 00:56:53.000000', 'temperatura', 43.0000, 'ºC'),
	(341622, 144, '2015-02-01 00:56:54.000000', 'temperatura', 858.0000, 'ºC'),
	(341623, 144, '2015-02-01 00:56:55.000000', 'temperatura', 562.0000, 'ºC'),
	(341624, 144, '2015-02-01 00:56:56.000000', 'temperatura', 235.0000, 'ºC'),
	(341625, 144, '2015-02-01 00:56:57.000000', 'temperatura', 692.0000, 'ºC'),
	(341626, 144, '2015-02-01 00:56:58.000000', 'temperatura', 355.0000, 'ºC'),
	(341627, 144, '2015-02-01 00:56:59.000000', 'temperatura', 898.0000, 'ºC'),
	(341628, 144, '2015-02-01 00:57:00.000000', 'temperatura', 1025.0000, 'ºC'),
	(341629, 144, '2015-02-01 00:57:01.000000', 'temperatura', 31.0000, 'ºC'),
	(341630, 144, '2015-02-01 00:57:02.000000', 'temperatura', 681.0000, 'ºC'),
	(341631, 144, '2015-02-01 00:57:03.000000', 'temperatura', 914.0000, 'ºC'),
	(341632, 144, '2015-02-01 00:57:04.000000', 'temperatura', 129.0000, 'ºC'),
	(341633, 144, '2015-02-01 00:57:05.000000', 'temperatura', 301.0000, 'ºC'),
	(341634, 144, '2015-02-01 00:57:06.000000', 'temperatura', 1119.0000, 'ºC'),
	(341635, 144, '2015-02-01 00:57:07.000000', 'temperatura', 1094.0000, 'ºC'),
	(341636, 144, '2015-02-01 00:57:08.000000', 'temperatura', 911.0000, 'ºC'),
	(341637, 144, '2015-02-01 00:57:09.000000', 'temperatura', 77.0000, 'ºC'),
	(341638, 144, '2015-02-01 00:57:10.000000', 'temperatura', 49.0000, 'ºC'),
	(341639, 144, '2015-02-01 00:57:11.000000', 'temperatura', 16.0000, 'ºC'),
	(341640, 144, '2015-02-01 00:57:12.000000', 'temperatura', 1132.0000, 'ºC'),
	(341641, 144, '2015-02-01 00:57:13.000000', 'temperatura', 814.0000, 'ºC'),
	(341642, 144, '2015-02-01 00:57:14.000000', 'temperatura', 676.0000, 'ºC'),
	(341643, 144, '2015-02-01 00:57:15.000000', 'temperatura', 938.0000, 'ºC'),
	(341644, 144, '2015-02-01 00:57:16.000000', 'temperatura', 263.0000, 'ºC'),
	(341645, 144, '2015-02-01 00:57:17.000000', 'temperatura', 899.0000, 'ºC'),
	(341646, 144, '2015-02-01 00:57:18.000000', 'temperatura', 107.0000, 'ºC'),
	(341647, 144, '2015-02-01 00:57:19.000000', 'temperatura', 240.0000, 'ºC'),
	(341648, 144, '2015-02-01 00:57:20.000000', 'temperatura', 879.0000, 'ºC'),
	(341649, 144, '2015-02-01 00:57:21.000000', 'temperatura', 77.0000, 'ºC'),
	(341650, 144, '2015-02-01 00:57:22.000000', 'temperatura', 149.0000, 'ºC'),
	(341651, 144, '2015-02-01 00:57:23.000000', 'temperatura', 512.0000, 'ºC'),
	(341652, 144, '2015-02-01 00:57:24.000000', 'temperatura', 915.0000, 'ºC'),
	(341653, 144, '2015-02-01 00:57:25.000000', 'temperatura', 638.0000, 'ºC'),
	(341654, 144, '2015-02-01 00:57:26.000000', 'temperatura', 445.0000, 'ºC'),
	(341655, 144, '2015-02-01 00:57:27.000000', 'temperatura', 312.0000, 'ºC'),
	(341656, 144, '2015-02-01 00:57:28.000000', 'temperatura', 224.0000, 'ºC'),
	(341657, 144, '2015-02-01 00:57:29.000000', 'temperatura', 185.0000, 'ºC'),
	(341658, 144, '2015-02-01 00:57:30.000000', 'temperatura', 253.0000, 'ºC'),
	(341659, 144, '2015-02-01 00:57:31.000000', 'temperatura', 711.0000, 'ºC'),
	(341660, 144, '2015-02-01 00:57:32.000000', 'temperatura', 395.0000, 'ºC'),
	(341661, 144, '2015-02-01 00:57:33.000000', 'temperatura', 1042.0000, 'ºC'),
	(341662, 144, '2015-02-01 00:57:34.000000', 'temperatura', 425.0000, 'ºC'),
	(341663, 144, '2015-02-01 00:57:35.000000', 'temperatura', 201.0000, 'ºC'),
	(341664, 144, '2015-02-01 00:57:36.000000', 'temperatura', 932.0000, 'ºC'),
	(341665, 144, '2015-02-01 00:57:37.000000', 'temperatura', 458.0000, 'ºC'),
	(341666, 144, '2015-02-01 00:57:38.000000', 'temperatura', 692.0000, 'ºC'),
	(341667, 144, '2015-02-01 00:57:39.000000', 'temperatura', 888.0000, 'ºC'),
	(341668, 144, '2015-02-01 00:57:40.000000', 'temperatura', 1165.0000, 'ºC'),
	(341669, 144, '2015-02-01 00:57:41.000000', 'temperatura', 759.0000, 'ºC'),
	(341670, 144, '2015-02-01 00:57:42.000000', 'temperatura', 302.0000, 'ºC'),
	(341671, 144, '2015-02-01 00:57:43.000000', 'temperatura', 432.0000, 'ºC'),
	(341672, 144, '2015-02-01 00:57:44.000000', 'temperatura', 56.0000, 'ºC'),
	(341673, 144, '2015-02-01 00:57:45.000000', 'temperatura', 183.0000, 'ºC'),
	(341674, 144, '2015-02-01 00:57:46.000000', 'temperatura', 748.0000, 'ºC'),
	(341675, 144, '2015-02-01 00:57:47.000000', 'temperatura', 793.0000, 'ºC'),
	(341676, 144, '2015-02-01 00:57:48.000000', 'temperatura', 523.0000, 'ºC'),
	(341677, 144, '2015-02-01 00:57:49.000000', 'temperatura', 233.0000, 'ºC'),
	(341678, 144, '2015-02-01 00:57:50.000000', 'temperatura', 798.0000, 'ºC'),
	(341679, 144, '2015-02-01 00:57:51.000000', 'temperatura', 889.0000, 'ºC'),
	(341680, 144, '2015-02-01 00:57:52.000000', 'temperatura', 854.0000, 'ºC'),
	(341681, 144, '2015-02-01 00:57:53.000000', 'temperatura', 404.0000, 'ºC'),
	(341682, 144, '2015-02-01 00:57:54.000000', 'temperatura', 658.0000, 'ºC'),
	(341683, 144, '2015-02-01 00:57:55.000000', 'temperatura', 878.0000, 'ºC'),
	(341684, 144, '2015-02-01 00:57:56.000000', 'temperatura', 18.0000, 'ºC'),
	(341685, 144, '2015-02-01 00:57:57.000000', 'temperatura', 1056.0000, 'ºC'),
	(341686, 144, '2015-02-01 00:57:58.000000', 'temperatura', 428.0000, 'ºC'),
	(341687, 144, '2015-02-01 00:57:59.000000', 'temperatura', 171.0000, 'ºC'),
	(341688, 144, '2015-02-01 00:58:00.000000', 'temperatura', 773.0000, 'ºC'),
	(341689, 144, '2015-02-01 00:58:01.000000', 'temperatura', 952.0000, 'ºC'),
	(341690, 144, '2015-02-01 00:58:02.000000', 'temperatura', 43.0000, 'ºC'),
	(341691, 144, '2015-02-01 00:58:03.000000', 'temperatura', 957.0000, 'ºC'),
	(341692, 144, '2015-02-01 00:58:04.000000', 'temperatura', 1057.0000, 'ºC'),
	(341693, 144, '2015-02-01 00:58:05.000000', 'temperatura', 13.0000, 'ºC'),
	(341694, 144, '2015-02-01 00:58:06.000000', 'temperatura', 496.0000, 'ºC'),
	(341695, 144, '2015-02-01 00:58:07.000000', 'temperatura', 42.0000, 'ºC'),
	(341696, 144, '2015-02-01 00:58:08.000000', 'temperatura', 1123.0000, 'ºC'),
	(341697, 144, '2015-02-01 00:58:09.000000', 'temperatura', 689.0000, 'ºC'),
	(341698, 144, '2015-02-01 00:58:10.000000', 'temperatura', 75.0000, 'ºC'),
	(341699, 144, '2015-02-01 00:58:11.000000', 'temperatura', 708.0000, 'ºC'),
	(341700, 144, '2015-02-01 00:58:12.000000', 'temperatura', 915.0000, 'ºC'),
	(341701, 144, '2015-02-01 00:58:13.000000', 'temperatura', 51.0000, 'ºC'),
	(341702, 144, '2015-02-01 00:58:14.000000', 'temperatura', 1112.0000, 'ºC'),
	(341703, 144, '2015-02-01 00:58:15.000000', 'temperatura', 606.0000, 'ºC'),
	(341704, 144, '2015-02-01 00:58:16.000000', 'temperatura', 896.0000, 'ºC'),
	(341705, 144, '2015-02-01 00:58:17.000000', 'temperatura', 261.0000, 'ºC'),
	(341706, 144, '2015-02-01 00:58:18.000000', 'temperatura', 1018.0000, 'ºC'),
	(341707, 144, '2015-02-01 00:58:19.000000', 'temperatura', 709.0000, 'ºC'),
	(341708, 144, '2015-02-01 00:58:20.000000', 'temperatura', 489.0000, 'ºC'),
	(341709, 144, '2015-02-01 00:58:21.000000', 'temperatura', 321.0000, 'ºC'),
	(341710, 144, '2015-02-01 00:58:22.000000', 'temperatura', 139.0000, 'ºC'),
	(341711, 144, '2015-02-01 00:58:23.000000', 'temperatura', 930.0000, 'ºC'),
	(341712, 144, '2015-02-01 00:58:24.000000', 'temperatura', 634.0000, 'ºC'),
	(341713, 144, '2015-02-01 00:58:25.000000', 'temperatura', 380.0000, 'ºC'),
	(341714, 144, '2015-02-01 00:58:26.000000', 'temperatura', 1199.0000, 'ºC'),
	(341715, 144, '2015-02-01 00:58:27.000000', 'temperatura', 57.0000, 'ºC'),
	(341716, 144, '2015-02-01 00:58:28.000000', 'temperatura', 287.0000, 'ºC'),
	(341717, 144, '2015-02-01 00:58:29.000000', 'temperatura', 64.0000, 'ºC'),
	(341718, 144, '2015-02-01 00:58:30.000000', 'temperatura', 661.0000, 'ºC'),
	(341719, 144, '2015-02-01 00:58:31.000000', 'temperatura', 712.0000, 'ºC'),
	(341720, 144, '2015-02-01 00:58:32.000000', 'temperatura', 379.0000, 'ºC'),
	(341721, 144, '2015-02-01 00:58:33.000000', 'temperatura', 959.0000, 'ºC'),
	(341722, 144, '2015-02-01 00:58:34.000000', 'temperatura', 58.0000, 'ºC'),
	(341723, 144, '2015-02-01 00:58:35.000000', 'temperatura', 1012.0000, 'ºC'),
	(341724, 144, '2015-02-01 00:58:36.000000', 'temperatura', 86.0000, 'ºC'),
	(341725, 144, '2015-02-01 00:58:37.000000', 'temperatura', 997.0000, 'ºC'),
	(341726, 144, '2015-02-01 00:58:38.000000', 'temperatura', 1126.0000, 'ºC'),
	(341727, 144, '2015-02-01 00:58:39.000000', 'temperatura', 238.0000, 'ºC'),
	(341728, 144, '2015-02-01 00:58:40.000000', 'temperatura', 213.0000, 'ºC'),
	(341729, 144, '2015-02-01 00:58:41.000000', 'temperatura', 352.0000, 'ºC'),
	(341730, 144, '2015-02-01 00:58:42.000000', 'temperatura', 1122.0000, 'ºC'),
	(341731, 144, '2015-02-01 00:58:43.000000', 'temperatura', 953.0000, 'ºC'),
	(341732, 144, '2015-02-01 00:58:44.000000', 'temperatura', 201.0000, 'ºC'),
	(341733, 144, '2015-02-01 00:58:45.000000', 'temperatura', 545.0000, 'ºC'),
	(341734, 144, '2015-02-01 00:58:46.000000', 'temperatura', 925.0000, 'ºC'),
	(341735, 144, '2015-02-01 00:58:47.000000', 'temperatura', 590.0000, 'ºC'),
	(341736, 144, '2015-02-01 00:58:48.000000', 'temperatura', 177.0000, 'ºC'),
	(341737, 144, '2015-02-01 00:58:49.000000', 'temperatura', 314.0000, 'ºC'),
	(341738, 144, '2015-02-01 00:58:50.000000', 'temperatura', 1039.0000, 'ºC'),
	(341739, 144, '2015-02-01 00:58:51.000000', 'temperatura', 655.0000, 'ºC'),
	(341740, 144, '2015-02-01 00:58:52.000000', 'temperatura', 159.0000, 'ºC'),
	(341741, 144, '2015-02-01 00:58:53.000000', 'temperatura', 29.0000, 'ºC'),
	(341742, 144, '2015-02-01 00:58:54.000000', 'temperatura', 871.0000, 'ºC'),
	(341743, 144, '2015-02-01 00:58:55.000000', 'temperatura', 666.0000, 'ºC'),
	(341744, 144, '2015-02-01 00:58:56.000000', 'temperatura', 719.0000, 'ºC'),
	(341745, 144, '2015-02-01 00:58:57.000000', 'temperatura', 398.0000, 'ºC'),
	(341746, 144, '2015-02-01 00:58:58.000000', 'temperatura', 1033.0000, 'ºC'),
	(341747, 144, '2015-02-01 00:58:59.000000', 'temperatura', 372.0000, 'ºC'),
	(341748, 144, '2015-02-01 00:59:00.000000', 'temperatura', 1163.0000, 'ºC'),
	(341749, 144, '2015-02-01 00:59:01.000000', 'temperatura', 1097.0000, 'ºC'),
	(341750, 144, '2015-02-01 00:59:02.000000', 'temperatura', 797.0000, 'ºC'),
	(341751, 144, '2015-02-01 00:59:03.000000', 'temperatura', 696.0000, 'ºC'),
	(341752, 144, '2015-02-01 00:59:04.000000', 'temperatura', 1088.0000, 'ºC'),
	(341753, 144, '2015-02-01 00:59:05.000000', 'temperatura', 955.0000, 'ºC'),
	(341754, 144, '2015-02-01 00:59:06.000000', 'temperatura', 310.0000, 'ºC'),
	(341755, 144, '2015-02-01 00:59:07.000000', 'temperatura', 1084.0000, 'ºC'),
	(341756, 144, '2015-02-01 00:59:08.000000', 'temperatura', 893.0000, 'ºC'),
	(341757, 144, '2015-02-01 00:59:09.000000', 'temperatura', 12.0000, 'ºC'),
	(341758, 144, '2015-02-01 00:59:10.000000', 'temperatura', 980.0000, 'ºC'),
	(341759, 144, '2015-02-01 00:59:11.000000', 'temperatura', 65.0000, 'ºC'),
	(341760, 144, '2015-02-01 00:59:12.000000', 'temperatura', 988.0000, 'ºC'),
	(341761, 144, '2015-02-01 00:59:13.000000', 'temperatura', 1145.0000, 'ºC'),
	(341762, 144, '2015-02-01 00:59:14.000000', 'temperatura', 359.0000, 'ºC'),
	(341763, 144, '2015-02-01 00:59:15.000000', 'temperatura', 763.0000, 'ºC'),
	(341764, 144, '2015-02-01 00:59:16.000000', 'temperatura', 338.0000, 'ºC'),
	(341765, 144, '2015-02-01 00:59:17.000000', 'temperatura', 603.0000, 'ºC'),
	(341766, 144, '2015-02-01 00:59:18.000000', 'temperatura', 799.0000, 'ºC'),
	(341767, 144, '2015-02-01 00:59:19.000000', 'temperatura', 987.0000, 'ºC'),
	(341768, 144, '2015-02-01 00:59:20.000000', 'temperatura', 137.0000, 'ºC'),
	(341769, 144, '2015-02-01 00:59:21.000000', 'temperatura', 125.0000, 'ºC'),
	(341770, 144, '2015-02-01 00:59:22.000000', 'temperatura', 215.0000, 'ºC'),
	(341771, 144, '2015-02-01 00:59:23.000000', 'temperatura', 699.0000, 'ºC'),
	(341772, 144, '2015-02-01 00:59:24.000000', 'temperatura', 454.0000, 'ºC'),
	(341773, 144, '2015-02-01 00:59:25.000000', 'temperatura', 170.0000, 'ºC'),
	(341774, 144, '2015-02-01 00:59:26.000000', 'temperatura', 690.0000, 'ºC'),
	(341775, 144, '2015-02-01 00:59:27.000000', 'temperatura', 539.0000, 'ºC'),
	(341776, 144, '2015-02-01 00:59:28.000000', 'temperatura', 624.0000, 'ºC'),
	(341777, 144, '2015-02-01 00:59:29.000000', 'temperatura', 307.0000, 'ºC'),
	(341778, 144, '2015-02-01 00:59:30.000000', 'temperatura', 862.0000, 'ºC'),
	(341779, 144, '2015-02-01 00:59:31.000000', 'temperatura', 989.0000, 'ºC'),
	(341780, 144, '2015-02-01 00:59:32.000000', 'temperatura', 1160.0000, 'ºC'),
	(341781, 144, '2015-02-01 00:59:33.000000', 'temperatura', 434.0000, 'ºC'),
	(341782, 144, '2015-02-01 00:59:34.000000', 'temperatura', 1090.0000, 'ºC'),
	(341783, 144, '2015-02-01 00:59:35.000000', 'temperatura', 550.0000, 'ºC'),
	(341784, 144, '2015-02-01 00:59:36.000000', 'temperatura', 682.0000, 'ºC'),
	(341785, 144, '2015-02-01 00:59:37.000000', 'temperatura', 557.0000, 'ºC'),
	(341786, 144, '2015-02-01 00:59:38.000000', 'temperatura', 740.0000, 'ºC'),
	(341787, 144, '2015-02-01 00:59:39.000000', 'temperatura', 829.0000, 'ºC'),
	(341788, 144, '2015-02-01 00:59:40.000000', 'temperatura', 725.0000, 'ºC'),
	(341789, 144, '2015-02-01 00:59:41.000000', 'temperatura', 1138.0000, 'ºC'),
	(341790, 144, '2015-02-01 00:59:42.000000', 'temperatura', 1117.0000, 'ºC'),
	(341791, 144, '2015-02-01 00:59:43.000000', 'temperatura', 972.0000, 'ºC'),
	(341792, 144, '2015-02-01 00:59:44.000000', 'temperatura', 310.0000, 'ºC'),
	(341793, 144, '2015-02-01 00:59:45.000000', 'temperatura', 1034.0000, 'ºC'),
	(341794, 144, '2015-02-01 00:59:46.000000', 'temperatura', 640.0000, 'ºC'),
	(341795, 144, '2015-02-01 00:59:47.000000', 'temperatura', 97.0000, 'ºC'),
	(341796, 144, '2015-02-01 00:59:48.000000', 'temperatura', 966.0000, 'ºC'),
	(341797, 144, '2015-02-01 00:59:49.000000', 'temperatura', 941.0000, 'ºC'),
	(341798, 144, '2015-02-01 00:59:50.000000', 'temperatura', 609.0000, 'ºC'),
	(341799, 144, '2015-02-01 00:59:51.000000', 'temperatura', 220.0000, 'ºC'),
	(341800, 144, '2015-02-01 00:59:52.000000', 'temperatura', 475.0000, 'ºC'),
	(341801, 144, '2015-02-01 00:59:53.000000', 'temperatura', 516.0000, 'ºC'),
	(341802, 144, '2015-02-01 00:59:54.000000', 'temperatura', 1153.0000, 'ºC'),
	(341803, 144, '2015-02-01 00:59:55.000000', 'temperatura', 618.0000, 'ºC'),
	(341804, 144, '2015-02-01 00:59:56.000000', 'temperatura', 834.0000, 'ºC'),
	(341805, 144, '2015-02-01 00:59:57.000000', 'temperatura', 1114.0000, 'ºC'),
	(341806, 144, '2015-02-01 00:59:58.000000', 'temperatura', 670.0000, 'ºC'),
	(341807, 144, '2015-02-01 00:59:59.000000', 'temperatura', 8.0000, 'ºC'),
	(341808, 144, '2015-02-01 01:00:00.000000', 'temperatura', 430.0000, 'ºC'),
	(341809, 144, '2015-02-01 01:00:01.000000', 'temperatura', 925.0000, 'ºC'),
	(341810, 144, '2015-02-01 01:00:02.000000', 'temperatura', 938.0000, 'ºC'),
	(341811, 144, '2015-02-01 01:00:03.000000', 'temperatura', 716.0000, 'ºC'),
	(341812, 144, '2015-02-01 01:00:04.000000', 'temperatura', 767.0000, 'ºC'),
	(341813, 144, '2015-02-01 01:00:05.000000', 'temperatura', 488.0000, 'ºC'),
	(341814, 144, '2015-02-01 01:00:06.000000', 'temperatura', 139.0000, 'ºC'),
	(341815, 144, '2015-02-01 01:00:07.000000', 'temperatura', 429.0000, 'ºC'),
	(341816, 144, '2015-02-01 01:00:08.000000', 'temperatura', 531.0000, 'ºC'),
	(341817, 144, '2015-02-01 01:00:09.000000', 'temperatura', 167.0000, 'ºC'),
	(341818, 144, '2015-02-01 01:00:10.000000', 'temperatura', 442.0000, 'ºC'),
	(341819, 144, '2015-02-01 01:00:11.000000', 'temperatura', 511.0000, 'ºC'),
	(341820, 144, '2015-02-01 01:00:12.000000', 'temperatura', 27.0000, 'ºC'),
	(341821, 144, '2015-02-01 01:00:13.000000', 'temperatura', 1005.0000, 'ºC'),
	(341822, 144, '2015-02-01 01:00:14.000000', 'temperatura', 145.0000, 'ºC'),
	(341823, 144, '2015-02-01 01:00:15.000000', 'temperatura', 108.0000, 'ºC'),
	(341824, 144, '2015-02-01 01:00:16.000000', 'temperatura', 106.0000, 'ºC'),
	(341825, 144, '2015-02-01 01:00:17.000000', 'temperatura', 206.0000, 'ºC'),
	(341826, 144, '2015-02-01 01:00:18.000000', 'temperatura', 714.0000, 'ºC'),
	(341827, 144, '2015-02-01 01:00:19.000000', 'temperatura', 554.0000, 'ºC'),
	(341828, 144, '2015-02-01 01:00:20.000000', 'temperatura', 626.0000, 'ºC'),
	(341829, 144, '2015-02-01 01:00:21.000000', 'temperatura', 271.0000, 'ºC'),
	(341830, 144, '2015-02-01 01:00:22.000000', 'temperatura', 674.0000, 'ºC'),
	(341831, 144, '2015-02-01 01:00:23.000000', 'temperatura', 160.0000, 'ºC'),
	(341832, 144, '2015-02-01 01:00:24.000000', 'temperatura', 1178.0000, 'ºC'),
	(341833, 144, '2015-02-01 01:00:25.000000', 'temperatura', 610.0000, 'ºC'),
	(341834, 144, '2015-02-01 01:00:26.000000', 'temperatura', 717.0000, 'ºC'),
	(341835, 144, '2015-02-01 01:00:27.000000', 'temperatura', 556.0000, 'ºC'),
	(341836, 144, '2015-02-01 01:00:28.000000', 'temperatura', 630.0000, 'ºC'),
	(341837, 144, '2015-02-01 01:00:29.000000', 'temperatura', 282.0000, 'ºC'),
	(341838, 144, '2015-02-01 01:00:30.000000', 'temperatura', 720.0000, 'ºC'),
	(341839, 144, '2015-02-01 01:00:31.000000', 'temperatura', 353.0000, 'ºC'),
	(341840, 144, '2015-02-01 01:00:32.000000', 'temperatura', 808.0000, 'ºC'),
	(341841, 144, '2015-02-01 01:00:33.000000', 'temperatura', 580.0000, 'ºC'),
	(341842, 144, '2015-02-01 01:00:34.000000', 'temperatura', 475.0000, 'ºC'),
	(341843, 144, '2015-02-01 01:00:35.000000', 'temperatura', 639.0000, 'ºC'),
	(341844, 144, '2015-02-01 01:00:36.000000', 'temperatura', 567.0000, 'ºC'),
	(341845, 144, '2015-02-01 01:00:37.000000', 'temperatura', 921.0000, 'ºC'),
	(341846, 144, '2015-02-01 01:00:38.000000', 'temperatura', 505.0000, 'ºC'),
	(341847, 144, '2015-02-01 01:00:39.000000', 'temperatura', 963.0000, 'ºC'),
	(341848, 144, '2015-02-01 01:00:40.000000', 'temperatura', 901.0000, 'ºC'),
	(341849, 144, '2015-02-01 01:00:41.000000', 'temperatura', 417.0000, 'ºC'),
	(341850, 144, '2015-02-01 01:00:42.000000', 'temperatura', 580.0000, 'ºC'),
	(341851, 144, '2015-02-01 01:00:43.000000', 'temperatura', 452.0000, 'ºC'),
	(341852, 144, '2015-02-01 01:00:44.000000', 'temperatura', 521.0000, 'ºC'),
	(341853, 144, '2015-02-01 01:00:45.000000', 'temperatura', 49.0000, 'ºC'),
	(341854, 144, '2015-02-01 01:00:46.000000', 'temperatura', 1084.0000, 'ºC'),
	(341855, 144, '2015-02-01 01:00:47.000000', 'temperatura', 472.0000, 'ºC'),
	(341856, 144, '2015-02-01 01:00:48.000000', 'temperatura', 307.0000, 'ºC'),
	(341857, 144, '2015-02-01 01:00:49.000000', 'temperatura', 121.0000, 'ºC'),
	(341858, 144, '2015-02-01 01:00:50.000000', 'temperatura', 882.0000, 'ºC'),
	(341859, 144, '2015-02-01 01:00:51.000000', 'temperatura', 451.0000, 'ºC'),
	(341860, 144, '2015-02-01 01:00:52.000000', 'temperatura', 807.0000, 'ºC'),
	(341861, 144, '2015-02-01 01:00:53.000000', 'temperatura', 281.0000, 'ºC'),
	(341862, 144, '2015-02-01 01:00:54.000000', 'temperatura', 188.0000, 'ºC'),
	(341863, 144, '2015-02-01 01:00:55.000000', 'temperatura', 96.0000, 'ºC'),
	(341864, 144, '2015-02-01 01:00:56.000000', 'temperatura', 1116.0000, 'ºC'),
	(341865, 144, '2015-02-01 01:00:57.000000', 'temperatura', 494.0000, 'ºC'),
	(341866, 144, '2015-02-01 01:00:58.000000', 'temperatura', 322.0000, 'ºC'),
	(341867, 144, '2015-02-01 01:00:59.000000', 'temperatura', 128.0000, 'ºC'),
	(341868, 144, '2015-02-01 01:01:00.000000', 'temperatura', 876.0000, 'ºC'),
	(341869, 144, '2015-02-01 01:01:01.000000', 'temperatura', 396.0000, 'ºC'),
	(341870, 144, '2015-02-01 01:01:02.000000', 'temperatura', 554.0000, 'ºC'),
	(341871, 144, '2015-02-01 01:01:03.000000', 'temperatura', 380.0000, 'ºC'),
	(341872, 144, '2015-02-01 01:01:04.000000', 'temperatura', 241.0000, 'ºC'),
	(341873, 144, '2015-02-01 01:01:05.000000', 'temperatura', 66.0000, 'ºC'),
	(341874, 144, '2015-02-01 01:01:06.000000', 'temperatura', 807.0000, 'ºC'),
	(341875, 144, '2015-02-01 01:01:07.000000', 'temperatura', 238.0000, 'ºC'),
	(341876, 144, '2015-02-01 01:01:08.000000', 'temperatura', 1169.0000, 'ºC'),
	(341877, 144, '2015-02-01 01:01:09.000000', 'temperatura', 332.0000, 'ºC'),
	(341878, 144, '2015-02-01 01:01:10.000000', 'temperatura', 553.0000, 'ºC'),
	(341879, 144, '2015-02-01 01:01:11.000000', 'temperatura', 568.0000, 'ºC'),
	(341880, 144, '2015-02-01 01:01:12.000000', 'temperatura', 1183.0000, 'ºC'),
	(341881, 144, '2015-02-01 01:01:13.000000', 'temperatura', 610.0000, 'ºC'),
	(341882, 144, '2015-02-01 01:01:14.000000', 'temperatura', 703.0000, 'ºC'),
	(341883, 144, '2015-02-01 01:01:15.000000', 'temperatura', 483.0000, 'ºC'),
	(341884, 144, '2015-02-01 01:01:16.000000', 'temperatura', 309.0000, 'ºC'),
	(341885, 144, '2015-02-01 01:01:17.000000', 'temperatura', 96.0000, 'ºC'),
	(341886, 144, '2015-02-01 01:01:18.000000', 'temperatura', 754.0000, 'ºC'),
	(341887, 144, '2015-02-01 01:01:19.000000', 'temperatura', 1081.0000, 'ºC'),
	(341888, 144, '2015-02-01 01:01:20.000000', 'temperatura', 744.0000, 'ºC'),
	(341889, 144, '2015-02-01 01:01:21.000000', 'temperatura', 478.0000, 'ºC'),
	(341890, 144, '2015-02-01 01:01:22.000000', 'temperatura', 159.0000, 'ºC'),
	(341891, 144, '2015-02-01 01:01:23.000000', 'temperatura', 562.0000, 'ºC'),
	(341892, 144, '2015-02-01 01:01:24.000000', 'temperatura', 1132.0000, 'ºC'),
	(341893, 144, '2015-02-01 01:01:25.000000', 'temperatura', 373.0000, 'ºC'),
	(341894, 144, '2015-02-01 01:01:26.000000', 'temperatura', 872.0000, 'ºC'),
	(341895, 144, '2015-02-01 01:01:27.000000', 'temperatura', 839.0000, 'ºC'),
	(341896, 144, '2015-02-01 01:01:28.000000', 'temperatura', 380.0000, 'ºC'),
	(341897, 144, '2015-02-01 01:01:29.000000', 'temperatura', 585.0000, 'ºC'),
	(341898, 144, '2015-02-01 01:01:30.000000', 'temperatura', 585.0000, 'ºC'),
	(341899, 144, '2015-02-01 01:01:31.000000', 'temperatura', 1170.0000, 'ºC'),
	(341900, 144, '2015-02-01 01:01:32.000000', 'temperatura', 497.0000, 'ºC'),
	(341901, 144, '2015-02-01 01:01:33.000000', 'temperatura', 174.0000, 'ºC'),
	(341902, 144, '2015-02-01 01:01:34.000000', 'temperatura', 582.0000, 'ºC'),
	(341903, 144, '2015-02-01 01:01:35.000000', 'temperatura', 1186.0000, 'ºC'),
	(341904, 144, '2015-02-01 01:01:36.000000', 'temperatura', 585.0000, 'ºC'),
	(341905, 144, '2015-02-01 01:01:37.000000', 'temperatura', 566.0000, 'ºC'),
	(341906, 144, '2015-02-01 01:01:38.000000', 'temperatura', 1077.0000, 'ºC'),
	(341907, 144, '2015-02-01 01:01:39.000000', 'temperatura', 89.0000, 'ºC'),
	(341908, 144, '2015-02-01 01:01:40.000000', 'temperatura', 815.0000, 'ºC'),
	(341909, 144, '2015-02-01 01:01:41.000000', 'temperatura', 208.0000, 'ºC'),
	(341910, 144, '2015-02-01 01:01:42.000000', 'temperatura', 993.0000, 'ºC'),
	(341911, 144, '2015-02-01 01:01:43.000000', 'temperatura', 745.0000, 'ºC'),
	(341912, 144, '2015-02-01 01:01:44.000000', 'temperatura', 743.0000, 'ºC'),
	(341913, 144, '2015-02-01 01:01:45.000000', 'temperatura', 282.0000, 'ºC'),
	(341914, 144, '2015-02-01 01:01:46.000000', 'temperatura', 382.0000, 'ºC'),
	(341915, 144, '2015-02-01 01:01:47.000000', 'temperatura', 1063.0000, 'ºC'),
	(341916, 144, '2015-02-01 01:01:48.000000', 'temperatura', 570.0000, 'ºC'),
	(341917, 144, '2015-02-01 01:01:49.000000', 'temperatura', 863.0000, 'ºC'),
	(341918, 144, '2015-02-01 01:01:50.000000', 'temperatura', 204.0000, 'ºC'),
	(341919, 144, '2015-02-01 01:01:51.000000', 'temperatura', 831.0000, 'ºC'),
	(341920, 144, '2015-02-01 01:01:52.000000', 'temperatura', 1146.0000, 'ºC'),
	(341921, 144, '2015-02-01 01:01:53.000000', 'temperatura', 837.0000, 'ºC'),
	(341922, 144, '2015-02-01 01:01:54.000000', 'temperatura', 748.0000, 'ºC'),
	(341923, 144, '2015-02-01 01:01:55.000000', 'temperatura', 29.0000, 'ºC'),
	(341924, 144, '2015-02-01 01:01:56.000000', 'temperatura', 303.0000, 'ºC'),
	(341925, 144, '2015-02-01 01:01:57.000000', 'temperatura', 226.0000, 'ºC'),
	(341926, 144, '2015-02-01 01:01:58.000000', 'temperatura', 223.0000, 'ºC'),
	(341927, 144, '2015-02-01 01:01:59.000000', 'temperatura', 437.0000, 'ºC'),
	(341928, 144, '2015-02-01 01:02:00.000000', 'temperatura', 315.0000, 'ºC'),
	(341929, 144, '2015-02-01 01:02:01.000000', 'temperatura', 266.0000, 'ºC'),
	(341930, 144, '2015-02-01 01:02:02.000000', 'temperatura', 385.0000, 'ºC'),
	(341931, 144, '2015-02-01 01:02:03.000000', 'temperatura', 1128.0000, 'ºC'),
	(341932, 144, '2015-02-01 01:02:04.000000', 'temperatura', 884.0000, 'ºC'),
	(341933, 144, '2015-02-01 01:02:05.000000', 'temperatura', 1035.0000, 'ºC'),
	(341934, 144, '2015-02-01 01:02:06.000000', 'temperatura', 127.0000, 'ºC'),
	(341935, 144, '2015-02-01 01:02:07.000000', 'temperatura', 1129.0000, 'ºC'),
	(341936, 144, '2015-02-01 01:02:08.000000', 'temperatura', 465.0000, 'ºC'),
	(341937, 144, '2015-02-01 01:02:09.000000', 'temperatura', 140.0000, 'ºC'),
	(341938, 144, '2015-02-01 01:02:10.000000', 'temperatura', 502.0000, 'ºC'),
	(341939, 144, '2015-02-01 01:02:11.000000', 'temperatura', 893.0000, 'ºC'),
	(341940, 144, '2015-02-01 01:02:12.000000', 'temperatura', 561.0000, 'ºC'),
	(341941, 144, '2015-02-01 01:02:13.000000', 'temperatura', 125.0000, 'ºC'),
	(341942, 144, '2015-02-01 01:02:14.000000', 'temperatura', 142.0000, 'ºC'),
	(341943, 144, '2015-02-01 01:02:15.000000', 'temperatura', 337.0000, 'ºC'),
	(341944, 144, '2015-02-01 01:02:16.000000', 'temperatura', 57.0000, 'ºC'),
	(341945, 144, '2015-02-01 01:02:17.000000', 'temperatura', 476.0000, 'ºC'),
	(341946, 144, '2015-02-01 01:02:18.000000', 'temperatura', 1009.0000, 'ºC'),
	(341947, 144, '2015-02-01 01:02:19.000000', 'temperatura', 19.0000, 'ºC'),
	(341948, 144, '2015-02-01 01:02:20.000000', 'temperatura', 668.0000, 'ºC'),
	(341949, 144, '2015-02-01 01:02:21.000000', 'temperatura', 882.0000, 'ºC'),
	(341950, 144, '2015-02-01 01:02:22.000000', 'temperatura', 7.0000, 'ºC'),
	(341951, 144, '2015-02-01 01:02:23.000000', 'temperatura', 991.0000, 'ºC'),
	(341952, 144, '2015-02-01 01:02:24.000000', 'temperatura', 135.0000, 'ºC'),
	(341953, 144, '2015-02-01 01:02:25.000000', 'temperatura', 100.0000, 'ºC'),
	(341954, 144, '2015-02-01 01:02:26.000000', 'temperatura', 96.0000, 'ºC'),
	(341955, 144, '2015-02-01 01:02:27.000000', 'temperatura', 180.0000, 'ºC'),
	(341956, 144, '2015-02-01 01:02:28.000000', 'temperatura', 612.0000, 'ºC'),
	(341957, 144, '2015-02-01 01:02:29.000000', 'temperatura', 122.0000, 'ºC'),
	(341958, 144, '2015-02-01 01:02:30.000000', 'temperatura', 1175.0000, 'ºC'),
	(341959, 144, '2015-02-01 01:02:31.000000', 'temperatura', 709.0000, 'ºC'),
	(341960, 144, '2015-02-01 01:02:32.000000', 'temperatura', 19.0000, 'ºC'),
	(341961, 144, '2015-02-01 01:02:33.000000', 'temperatura', 368.0000, 'ºC'),
	(341962, 144, '2015-02-01 01:02:34.000000', 'temperatura', 586.0000, 'ºC'),
	(341963, 144, '2015-02-01 01:02:35.000000', 'temperatura', 624.0000, 'ºC'),
	(341964, 144, '2015-02-01 01:02:36.000000', 'temperatura', 162.0000, 'ºC'),
	(341965, 144, '2015-02-01 01:02:37.000000', 'temperatura', 139.0000, 'ºC'),
	(341966, 144, '2015-02-01 01:02:38.000000', 'temperatura', 212.0000, 'ºC'),
	(341967, 144, '2015-02-01 01:02:39.000000', 'temperatura', 641.0000, 'ºC'),
	(341968, 144, '2015-02-01 01:02:40.000000', 'temperatura', 171.0000, 'ºC'),
	(341969, 144, '2015-02-01 01:02:41.000000', 'temperatura', 130.0000, 'ºC'),
	(341970, 144, '2015-02-01 01:02:42.000000', 'temperatura', 138.0000, 'ºC'),
	(341971, 144, '2015-02-01 01:02:43.000000', 'temperatura', 302.0000, 'ºC'),
	(341972, 144, '2015-02-01 01:02:44.000000', 'temperatura', 1095.0000, 'ºC'),
	(341973, 144, '2015-02-01 01:02:45.000000', 'temperatura', 969.0000, 'ºC'),
	(341974, 144, '2015-02-01 01:02:46.000000', 'temperatura', 363.0000, 'ºC'),
	(341975, 144, '2015-02-01 01:02:47.000000', 'temperatura', 105.0000, 'ºC'),
	(341976, 144, '2015-02-01 01:02:48.000000', 'temperatura', 640.0000, 'ºC'),
	(341977, 144, '2015-02-01 01:02:49.000000', 'temperatura', 482.0000, 'ºC'),
	(341978, 144, '2015-02-01 01:02:50.000000', 'temperatura', 494.0000, 'ºC'),
	(341979, 144, '2015-02-01 01:02:51.000000', 'temperatura', 1021.0000, 'ºC'),
	(341980, 144, '2015-02-01 01:02:52.000000', 'temperatura', 27.0000, 'ºC'),
	(341981, 144, '2015-02-01 01:02:53.000000', 'temperatura', 670.0000, 'ºC'),
	(341982, 144, '2015-02-01 01:02:54.000000', 'temperatura', 869.0000, 'ºC'),
	(341983, 144, '2015-02-01 01:02:55.000000', 'temperatura', 1135.0000, 'ºC'),
	(341984, 144, '2015-02-01 01:02:56.000000', 'temperatura', 671.0000, 'ºC'),
	(341985, 144, '2015-02-01 01:02:57.000000', 'temperatura', 1148.0000, 'ºC'),
	(341986, 144, '2015-02-01 01:02:58.000000', 'temperatura', 127.0000, 'ºC'),
	(341987, 144, '2015-02-01 01:02:59.000000', 'temperatura', 792.0000, 'ºC'),
	(341988, 144, '2015-02-01 01:03:00.000000', 'temperatura', 1179.0000, 'ºC'),
	(341989, 144, '2015-02-01 01:03:01.000000', 'temperatura', 1120.0000, 'ºC'),
	(341990, 144, '2015-02-01 01:03:02.000000', 'temperatura', 865.0000, 'ºC'),
	(341991, 144, '2015-02-01 01:03:03.000000', 'temperatura', 964.0000, 'ºC'),
	(341992, 144, '2015-02-01 01:03:04.000000', 'temperatura', 1027.0000, 'ºC'),
	(341993, 144, '2015-02-01 01:03:05.000000', 'temperatura', 1042.0000, 'ºC'),
	(341994, 144, '2015-02-01 01:03:06.000000', 'temperatura', 932.0000, 'ºC'),
	(341995, 144, '2015-02-01 01:03:07.000000', 'temperatura', 331.0000, 'ºC'),
	(341996, 144, '2015-02-01 01:03:08.000000', 'temperatura', 63.0000, 'ºC'),
	(341997, 144, '2015-02-01 01:03:09.000000', 'temperatura', 519.0000, 'ºC'),
	(341998, 144, '2015-02-01 01:03:10.000000', 'temperatura', 8.0000, 'ºC'),
	(341999, 144, '2015-02-01 01:03:11.000000', 'temperatura', 884.0000, 'ºC'),
	(342000, 144, '2015-02-01 01:03:12.000000', 'temperatura', 795.0000, 'ºC'),
	(342001, 144, '2015-02-01 01:03:13.000000', 'temperatura', 122.0000, 'ºC'),
	(342002, 144, '2015-02-01 01:03:14.000000', 'temperatura', 629.0000, 'ºC'),
	(342003, 144, '2015-02-01 01:03:15.000000', 'temperatura', 378.0000, 'ºC'),
	(342004, 144, '2015-02-01 01:03:16.000000', 'temperatura', 3.0000, 'ºC'),
	(342005, 144, '2015-02-01 01:03:17.000000', 'temperatura', 82.0000, 'ºC'),
	(342006, 144, '2015-02-01 01:03:18.000000', 'temperatura', 400.0000, 'ºC'),
	(342007, 144, '2015-02-01 01:03:19.000000', 'temperatura', 554.0000, 'ºC'),
	(342008, 144, '2015-02-01 01:03:20.000000', 'temperatura', 370.0000, 'ºC'),
	(342009, 144, '2015-02-01 01:03:21.000000', 'temperatura', 189.0000, 'ºC'),
	(342010, 144, '2015-02-01 01:03:22.000000', 'temperatura', 1035.0000, 'ºC'),
	(342011, 144, '2015-02-01 01:03:23.000000', 'temperatura', 1009.0000, 'ºC'),
	(342012, 144, '2015-02-01 01:03:24.000000', 'temperatura', 742.0000, 'ºC'),
	(342013, 144, '2015-02-01 01:03:25.000000', 'temperatura', 684.0000, 'ºC'),
	(342014, 144, '2015-02-01 01:03:26.000000', 'temperatura', 1193.0000, 'ºC'),
	(342015, 144, '2015-02-01 01:03:27.000000', 'temperatura', 314.0000, 'ºC'),
	(342016, 144, '2015-02-01 01:03:28.000000', 'temperatura', 391.0000, 'ºC'),
	(342017, 144, '2015-02-01 01:03:29.000000', 'temperatura', 1013.0000, 'ºC'),
	(342018, 144, '2015-02-01 01:03:30.000000', 'temperatura', 294.0000, 'ºC'),
	(342019, 144, '2015-02-01 01:03:31.000000', 'temperatura', 831.0000, 'ºC'),
	(342020, 144, '2015-02-01 01:03:32.000000', 'temperatura', 873.0000, 'ºC'),
	(342021, 144, '2015-02-01 01:03:33.000000', 'temperatura', 671.0000, 'ºC'),
	(342022, 144, '2015-02-01 01:03:34.000000', 'temperatura', 738.0000, 'ºC'),
	(342023, 144, '2015-02-01 01:03:35.000000', 'temperatura', 476.0000, 'ºC'),
	(342024, 144, '2015-02-01 01:03:36.000000', 'temperatura', 166.0000, 'ºC'),
	(342025, 144, '2015-02-01 01:03:37.000000', 'temperatura', 605.0000, 'ºC'),
	(342026, 144, '2015-02-01 01:03:38.000000', 'temperatura', 125.0000, 'ºC'),
	(342027, 144, '2015-02-01 01:03:39.000000', 'temperatura', 10.0000, 'ºC'),
	(342028, 144, '2015-02-01 01:03:40.000000', 'temperatura', 875.0000, 'ºC'),
	(342029, 144, '2015-02-01 01:03:41.000000', 'temperatura', 748.0000, 'ºC'),
	(342030, 144, '2015-02-01 01:03:42.000000', 'temperatura', 1114.0000, 'ºC'),
	(342031, 144, '2015-02-01 01:03:43.000000', 'temperatura', 925.0000, 'ºC'),
	(342032, 144, '2015-02-01 01:03:44.000000', 'temperatura', 84.0000, 'ºC'),
	(342033, 144, '2015-02-01 01:03:45.000000', 'temperatura', 44.0000, 'ºC'),
	(342034, 144, '2015-02-01 01:03:46.000000', 'temperatura', 1172.0000, 'ºC'),
	(342035, 144, '2015-02-01 01:03:47.000000', 'temperatura', 926.0000, 'ºC'),
	(342036, 144, '2015-02-01 01:03:48.000000', 'temperatura', 1115.0000, 'ºC'),
	(342037, 144, '2015-02-01 01:03:49.000000', 'temperatura', 396.0000, 'ºC'),
	(342038, 144, '2015-02-01 01:03:50.000000', 'temperatura', 1037.0000, 'ºC'),
	(342039, 144, '2015-02-01 01:03:51.000000', 'temperatura', 399.0000, 'ºC'),
	(342040, 144, '2015-02-01 01:03:52.000000', 'temperatura', 84.0000, 'ºC'),
	(342041, 144, '2015-02-01 01:03:53.000000', 'temperatura', 424.0000, 'ºC'),
	(342042, 144, '2015-02-01 01:03:54.000000', 'temperatura', 666.0000, 'ºC'),
	(342043, 144, '2015-02-01 01:03:55.000000', 'temperatura', 861.0000, 'ºC'),
	(342044, 144, '2015-02-01 01:03:56.000000', 'temperatura', 1108.0000, 'ºC'),
	(342045, 144, '2015-02-01 01:03:57.000000', 'temperatura', 559.0000, 'ºC'),
	(342046, 144, '2015-02-01 01:03:58.000000', 'temperatura', 668.0000, 'ºC'),
	(342047, 144, '2015-02-01 01:03:59.000000', 'temperatura', 465.0000, 'ºC'),
	(342048, 144, '2015-02-01 01:04:00.000000', 'temperatura', 323.0000, 'ºC'),
	(342049, 144, '2015-02-01 01:04:01.000000', 'temperatura', 220.0000, 'ºC'),
	(342050, 144, '2015-02-01 01:04:02.000000', 'temperatura', 130.0000, 'ºC'),
	(342051, 144, '2015-02-01 01:04:03.000000', 'temperatura', 1193.0000, 'ºC'),
	(342052, 144, '2015-02-01 01:04:04.000000', 'temperatura', 773.0000, 'ºC'),
	(342053, 144, '2015-02-01 01:04:05.000000', 'temperatura', 286.0000, 'ºC'),
	(342054, 144, '2015-02-01 01:04:06.000000', 'temperatura', 314.0000, 'ºC'),
	(342055, 144, '2015-02-01 01:04:07.000000', 'temperatura', 710.0000, 'ºC'),
	(342056, 144, '2015-02-01 01:04:08.000000', 'temperatura', 209.0000, 'ºC'),
	(342057, 144, '2015-02-01 01:04:09.000000', 'temperatura', 117.0000, 'ºC'),
	(342058, 144, '2015-02-01 01:04:10.000000', 'temperatura', 1158.0000, 'ºC'),
	(342059, 144, '2015-02-01 01:04:11.000000', 'temperatura', 640.0000, 'ºC'),
	(342060, 144, '2015-02-01 01:04:12.000000', 'temperatura', 926.0000, 'ºC'),
	(342061, 144, '2015-02-01 01:04:13.000000', 'temperatura', 309.0000, 'ºC'),
	(342062, 144, '2015-02-01 01:04:14.000000', 'temperatura', 1167.0000, 'ºC'),
	(342063, 144, '2015-02-01 01:04:15.000000', 'temperatura', 108.0000, 'ºC'),
	(342064, 144, '2015-02-01 01:04:16.000000', 'temperatura', 643.0000, 'ºC'),
	(342065, 144, '2015-02-01 01:04:17.000000', 'temperatura', 488.0000, 'ºC'),
	(342066, 144, '2015-02-01 01:04:18.000000', 'temperatura', 513.0000, 'ºC'),
	(342067, 144, '2015-02-01 01:04:19.000000', 'temperatura', 1102.0000, 'ºC'),
	(342068, 144, '2015-02-01 01:04:20.000000', 'temperatura', 372.0000, 'ºC'),
	(342069, 144, '2015-02-01 01:04:21.000000', 'temperatura', 952.0000, 'ºC'),
	(342070, 144, '2015-02-01 01:04:22.000000', 'temperatura', 45.0000, 'ºC'),
	(342071, 144, '2015-02-01 01:04:23.000000', 'temperatura', 972.0000, 'ºC'),
	(342072, 144, '2015-02-01 01:04:24.000000', 'temperatura', 1124.0000, 'ºC'),
	(342073, 144, '2015-02-01 01:04:25.000000', 'temperatura', 303.0000, 'ºC'),
	(342074, 144, '2015-02-01 01:04:26.000000', 'temperatura', 543.0000, 'ºC'),
	(342075, 144, '2015-02-01 01:04:27.000000', 'temperatura', 608.0000, 'ºC'),
	(342076, 144, '2015-02-01 01:04:28.000000', 'temperatura', 211.0000, 'ºC'),
	(342077, 144, '2015-02-01 01:04:29.000000', 'temperatura', 430.0000, 'ºC'),
	(342078, 144, '2015-02-01 01:04:30.000000', 'temperatura', 318.0000, 'ºC'),
	(342079, 144, '2015-02-01 01:04:31.000000', 'temperatura', 303.0000, 'ºC'),
	(342080, 144, '2015-02-01 01:04:32.000000', 'temperatura', 559.0000, 'ºC'),
	(342081, 144, '2015-02-01 01:04:33.000000', 'temperatura', 686.0000, 'ºC'),
	(342082, 144, '2015-02-01 01:04:34.000000', 'temperatura', 555.0000, 'ºC'),
	(342083, 144, '2015-02-01 01:04:35.000000', 'temperatura', 718.0000, 'ºC'),
	(342084, 144, '2015-02-01 01:04:36.000000', 'temperatura', 727.0000, 'ºC'),
	(342085, 144, '2015-02-01 01:04:37.000000', 'temperatura', 280.0000, 'ºC'),
	(342086, 144, '2015-02-01 01:04:38.000000', 'temperatura', 418.0000, 'ºC'),
	(342087, 144, '2015-02-01 01:04:39.000000', 'temperatura', 50.0000, 'ºC'),
	(342088, 144, '2015-02-01 01:04:40.000000', 'temperatura', 198.0000, 'ºC'),
	(342089, 144, '2015-02-01 01:04:41.000000', 'temperatura', 838.0000, 'ºC'),
	(342090, 144, '2015-02-01 01:04:42.000000', 'temperatura', 0.0000, 'ºC'),
	(342091, 144, '2015-02-01 01:04:43.000000', 'temperatura', 1085.0000, 'ºC'),
	(342092, 144, '2015-02-01 01:04:44.000000', 'temperatura', 627.0000, 'ºC'),
	(342093, 144, '2015-02-01 01:04:45.000000', 'temperatura', 1081.0000, 'ºC'),
	(342094, 144, '2015-02-01 01:04:46.000000', 'temperatura', 1122.0000, 'ºC'),
	(342095, 144, '2015-02-01 01:04:47.000000', 'temperatura', 1167.0000, 'ºC'),
	(342096, 144, '2015-02-01 01:04:48.000000', 'temperatura', 71.0000, 'ºC'),
	(342097, 144, '2015-02-01 01:04:49.000000', 'temperatura', 455.0000, 'ºC'),
	(342098, 144, '2015-02-01 01:04:50.000000', 'temperatura', 862.0000, 'ºC'),
	(342099, 144, '2015-02-01 01:04:51.000000', 'temperatura', 544.0000, 'ºC'),
	(342100, 144, '2015-02-01 01:04:52.000000', 'temperatura', 137.0000, 'ºC'),
	(342101, 144, '2015-02-01 01:04:53.000000', 'temperatura', 253.0000, 'ºC'),
	(342102, 144, '2015-02-01 01:04:54.000000', 'temperatura', 854.0000, 'ºC'),
	(342103, 144, '2015-02-01 01:04:55.000000', 'temperatura', 1111.0000, 'ºC'),
	(342104, 144, '2015-02-01 01:04:56.000000', 'temperatura', 594.0000, 'ºC'),
	(342105, 144, '2015-02-01 01:04:57.000000', 'temperatura', 839.0000, 'ºC'),
	(342106, 144, '2015-02-01 01:04:58.000000', 'temperatura', 14.0000, 'ºC'),
	(342107, 144, '2015-02-01 01:04:59.000000', 'temperatura', 1151.0000, 'ºC'),
	(342108, 144, '2015-02-01 01:05:00.000000', 'temperatura', 916.0000, 'ºC'),
	(342109, 144, '2015-02-01 01:05:01.000000', 'temperatura', 1124.0000, 'ºC'),
	(342110, 144, '2015-02-01 01:05:02.000000', 'temperatura', 476.0000, 'ºC'),
	(342111, 144, '2015-02-01 01:05:03.000000', 'temperatura', 209.0000, 'ºC'),
	(342112, 144, '2015-02-01 01:05:04.000000', 'temperatura', 814.0000, 'ºC'),
	(342113, 144, '2015-02-01 01:05:05.000000', 'temperatura', 1047.0000, 'ºC'),
	(342114, 144, '2015-02-01 01:05:06.000000', 'temperatura', 391.0000, 'ºC'),
	(342115, 144, '2015-02-01 01:05:07.000000', 'temperatura', 17.0000, 'ºC'),
	(342116, 144, '2015-02-01 01:05:08.000000', 'temperatura', 112.0000, 'ºC'),
	(342117, 144, '2015-02-01 01:05:09.000000', 'temperatura', 508.0000, 'ºC'),
	(342118, 144, '2015-02-01 01:05:10.000000', 'temperatura', 1005.0000, 'ºC'),
	(342119, 144, '2015-02-01 01:05:11.000000', 'temperatura', 1103.0000, 'ºC'),
	(342120, 144, '2015-02-01 01:05:12.000000', 'temperatura', 99.0000, 'ºC'),
	(342121, 144, '2015-02-01 01:05:13.000000', 'temperatura', 788.0000, 'ºC'),
	(342122, 144, '2015-02-01 01:05:14.000000', 'temperatura', 42.0000, 'ºC'),
	(342123, 144, '2015-02-01 01:05:15.000000', 'temperatura', 248.0000, 'ºC'),
	(342124, 144, '2015-02-01 01:05:16.000000', 'temperatura', 1116.0000, 'ºC'),
	(342125, 144, '2015-02-01 01:05:17.000000', 'temperatura', 33.0000, 'ºC'),
	(342126, 144, '2015-02-01 01:05:18.000000', 'temperatura', 419.0000, 'ºC'),
	(342127, 144, '2015-02-01 01:05:19.000000', 'temperatura', 795.0000, 'ºC'),
	(342128, 144, '2015-02-01 01:05:20.000000', 'temperatura', 319.0000, 'ºC'),
	(342129, 144, '2015-02-01 01:05:21.000000', 'temperatura', 411.0000, 'ºC'),
	(342130, 144, '2015-02-01 01:05:22.000000', 'temperatura', 1096.0000, 'ºC'),
	(342131, 144, '2015-02-01 01:05:23.000000', 'temperatura', 651.0000, 'ºC'),
	(342132, 144, '2015-02-01 01:05:24.000000', 'temperatura', 1167.0000, 'ºC'),
	(342133, 144, '2015-02-01 01:05:25.000000', 'temperatura', 283.0000, 'ºC'),
	(342134, 144, '2015-02-01 01:05:26.000000', 'temperatura', 314.0000, 'ºC'),
	(342135, 144, '2015-02-01 01:05:27.000000', 'temperatura', 722.0000, 'ºC'),
	(342136, 144, '2015-02-01 01:05:28.000000', 'temperatura', 269.0000, 'ºC'),
	(342137, 144, '2015-02-01 01:05:29.000000', 'temperatura', 377.0000, 'ºC'),
	(342138, 144, '2015-02-01 01:05:30.000000', 'temperatura', 1080.0000, 'ºC'),
	(342139, 144, '2015-02-01 01:05:31.000000', 'temperatura', 668.0000, 'ºC'),
	(342140, 144, '2015-02-01 01:05:32.000000', 'temperatura', 99.0000, 'ºC'),
	(342141, 144, '2015-02-01 01:05:33.000000', 'temperatura', 895.0000, 'ºC'),
	(342142, 144, '2015-02-01 01:05:34.000000', 'temperatura', 576.0000, 'ºC'),
	(342143, 144, '2015-02-01 01:05:35.000000', 'temperatura', 198.0000, 'ºC'),
	(342144, 144, '2015-02-01 01:05:36.000000', 'temperatura', 463.0000, 'ºC'),
	(342145, 144, '2015-02-01 01:05:37.000000', 'temperatura', 522.0000, 'ºC'),
	(342146, 144, '2015-02-01 01:05:38.000000', 'temperatura', 21.0000, 'ºC'),
	(342147, 144, '2015-02-01 01:05:39.000000', 'temperatura', 939.0000, 'ºC'),
	(342148, 144, '2015-02-01 01:05:40.000000', 'temperatura', 1033.0000, 'ºC'),
	(342149, 144, '2015-02-01 01:05:41.000000', 'temperatura', 1146.0000, 'ºC'),
	(342150, 144, '2015-02-01 01:05:42.000000', 'temperatura', 234.0000, 'ºC'),
	(342151, 144, '2015-02-01 01:05:43.000000', 'temperatura', 134.0000, 'ºC'),
	(342152, 144, '2015-02-01 01:05:44.000000', 'temperatura', 1166.0000, 'ºC'),
	(342153, 144, '2015-02-01 01:05:45.000000', 'temperatura', 630.0000, 'ºC'),
	(342154, 144, '2015-02-01 01:05:46.000000', 'temperatura', 851.0000, 'ºC'),
	(342155, 144, '2015-02-01 01:05:47.000000', 'temperatura', 1168.0000, 'ºC'),
	(342156, 144, '2015-02-01 01:05:48.000000', 'temperatura', 884.0000, 'ºC'),
	(342157, 144, '2015-02-01 01:05:49.000000', 'temperatura', 919.0000, 'ºC'),
	(342158, 144, '2015-02-01 01:05:50.000000', 'temperatura', 742.0000, 'ºC'),
	(342159, 144, '2015-02-01 01:05:51.000000', 'temperatura', 952.0000, 'ºC'),
	(342160, 144, '2015-02-01 01:05:52.000000', 'temperatura', 137.0000, 'ºC'),
	(342161, 144, '2015-02-01 01:05:53.000000', 'temperatura', 227.0000, 'ºC'),
	(342162, 144, '2015-02-01 01:05:54.000000', 'temperatura', 727.0000, 'ºC'),
	(342163, 144, '2015-02-01 01:05:55.000000', 'temperatura', 554.0000, 'ºC'),
	(342164, 144, '2015-02-01 01:05:56.000000', 'temperatura', 589.0000, 'ºC'),
	(342165, 144, '2015-02-01 01:05:57.000000', 'temperatura', 83.0000, 'ºC'),
	(342166, 144, '2015-02-01 01:05:58.000000', 'temperatura', 1048.0000, 'ºC'),
	(342167, 144, '2015-02-01 01:05:59.000000', 'temperatura', 191.0000, 'ºC'),
	(342168, 144, '2015-02-01 01:06:00.000000', 'temperatura', 211.0000, 'ºC'),
	(342169, 144, '2015-02-01 01:06:01.000000', 'temperatura', 482.0000, 'ºC'),
	(342170, 144, '2015-02-01 01:06:02.000000', 'temperatura', 579.0000, 'ºC'),
	(342171, 144, '2015-02-01 01:06:03.000000', 'temperatura', 250.0000, 'ºC'),
	(342172, 144, '2015-02-01 01:06:04.000000', 'temperatura', 712.0000, 'ºC'),
	(342173, 144, '2015-02-01 01:06:05.000000', 'temperatura', 409.0000, 'ºC'),
	(342174, 144, '2015-02-01 01:06:06.000000', 'temperatura', 1112.0000, 'ºC'),
	(342175, 144, '2015-02-01 01:06:07.000000', 'temperatura', 734.0000, 'ºC'),
	(342176, 144, '2015-02-01 01:06:08.000000', 'temperatura', 335.0000, 'ºC'),
	(342177, 144, '2015-02-01 01:06:09.000000', 'temperatura', 673.0000, 'ºC'),
	(342178, 144, '2015-02-01 01:06:10.000000', 'temperatura', 1158.0000, 'ºC'),
	(342179, 144, '2015-02-01 01:06:11.000000', 'temperatura', 174.0000, 'ºC'),
	(342180, 144, '2015-02-01 01:06:12.000000', 'temperatura', 995.0000, 'ºC'),
	(342181, 144, '2015-02-01 01:06:13.000000', 'temperatura', 853.0000, 'ºC'),
	(342182, 144, '2015-02-01 01:06:14.000000', 'temperatura', 83.0000, 'ºC'),
	(342183, 144, '2015-02-01 01:06:15.000000', 'temperatura', 254.0000, 'ºC'),
	(342184, 144, '2015-02-01 01:06:16.000000', 'temperatura', 1022.0000, 'ºC'),
	(342185, 144, '2015-02-01 01:06:17.000000', 'temperatura', 750.0000, 'ºC'),
	(342186, 144, '2015-02-01 01:06:18.000000', 'temperatura', 685.0000, 'ºC'),
	(342187, 144, '2015-02-01 01:06:19.000000', 'temperatura', 1175.0000, 'ºC'),
	(342188, 144, '2015-02-01 01:06:20.000000', 'temperatura', 222.0000, 'ºC'),
	(342189, 144, '2015-02-01 01:06:21.000000', 'temperatura', 1185.0000, 'ºC'),
	(342190, 144, '2015-02-01 01:06:22.000000', 'temperatura', 459.0000, 'ºC'),
	(342191, 144, '2015-02-01 01:06:23.000000', 'temperatura', 1143.0000, 'ºC'),
	(342192, 144, '2015-02-01 01:06:24.000000', 'temperatura', 735.0000, 'ºC'),
	(342193, 144, '2015-02-01 01:06:25.000000', 'temperatura', 247.0000, 'ºC'),
	(342194, 144, '2015-02-01 01:06:26.000000', 'temperatura', 232.0000, 'ºC'),
	(342195, 144, '2015-02-01 01:06:27.000000', 'temperatura', 418.0000, 'ºC'),
	(342196, 144, '2015-02-01 01:06:28.000000', 'temperatura', 196.0000, 'ºC'),
	(342197, 144, '2015-02-01 01:06:29.000000', 'temperatura', 926.0000, 'ºC'),
	(342198, 144, '2015-02-01 01:06:30.000000', 'temperatura', 443.0000, 'ºC'),
	(342199, 144, '2015-02-01 01:06:31.000000', 'temperatura', 639.0000, 'ºC'),
	(342200, 144, '2015-02-01 01:06:32.000000', 'temperatura', 665.0000, 'ºC'),
	(342201, 144, '2015-02-01 01:06:33.000000', 'temperatura', 207.0000, 'ºC'),
	(342202, 144, '2015-02-01 01:06:34.000000', 'temperatura', 244.0000, 'ºC'),
	(342203, 144, '2015-02-01 01:06:35.000000', 'temperatura', 596.0000, 'ºC'),
	(342204, 144, '2015-02-01 01:06:36.000000', 'temperatura', 1050.0000, 'ºC'),
	(342205, 144, '2015-02-01 01:06:37.000000', 'temperatura', 1063.0000, 'ºC'),
	(342206, 144, '2015-02-01 01:06:38.000000', 'temperatura', 966.0000, 'ºC'),
	(342207, 144, '2015-02-01 01:06:39.000000', 'temperatura', 442.0000, 'ºC'),
	(342208, 144, '2015-02-01 01:06:40.000000', 'temperatura', 513.0000, 'ºC'),
	(342209, 144, '2015-02-01 01:06:41.000000', 'temperatura', 36.0000, 'ºC'),
	(342210, 144, '2015-02-01 01:06:42.000000', 'temperatura', 1045.0000, 'ºC'),
	(342211, 144, '2015-02-01 01:06:43.000000', 'temperatura', 318.0000, 'ºC'),
	(342212, 144, '2015-02-01 01:06:44.000000', 'temperatura', 854.0000, 'ºC'),
	(342213, 144, '2015-02-01 01:06:45.000000', 'temperatura', 917.0000, 'ºC'),
	(342214, 144, '2015-02-01 01:06:46.000000', 'temperatura', 823.0000, 'ºC'),
	(342215, 144, '2015-02-01 01:06:47.000000', 'temperatura', 164.0000, 'ºC'),
	(342216, 144, '2015-02-01 01:06:48.000000', 'temperatura', 752.0000, 'ºC'),
	(342217, 144, '2015-02-01 01:06:49.000000', 'temperatura', 868.0000, 'ºC'),
	(342218, 144, '2015-02-01 01:06:50.000000', 'temperatura', 886.0000, 'ºC'),
	(342219, 144, '2015-02-01 01:06:51.000000', 'temperatura', 626.0000, 'ºC'),
	(342220, 144, '2015-02-01 01:06:52.000000', 'temperatura', 470.0000, 'ºC'),
	(342221, 144, '2015-02-01 01:06:53.000000', 'temperatura', 475.0000, 'ºC'),
	(342222, 144, '2015-02-01 01:06:54.000000', 'temperatura', 966.0000, 'ºC'),
	(342223, 144, '2015-02-01 01:06:55.000000', 'temperatura', 1004.0000, 'ºC'),
	(342224, 144, '2015-02-01 01:06:56.000000', 'temperatura', 922.0000, 'ºC'),
	(342225, 144, '2015-02-01 01:06:57.000000', 'temperatura', 400.0000, 'ºC'),
	(342226, 144, '2015-02-01 01:06:58.000000', 'temperatura', 433.0000, 'ºC'),
	(342227, 144, '2015-02-01 01:06:59.000000', 'temperatura', 965.0000, 'ºC'),
	(342228, 144, '2015-02-01 01:07:00.000000', 'temperatura', 1127.0000, 'ºC'),
	(342229, 144, '2015-02-01 01:07:01.000000', 'temperatura', 341.0000, 'ºC'),
	(342230, 144, '2015-02-01 01:07:02.000000', 'temperatura', 724.0000, 'ºC'),
	(342231, 144, '2015-02-01 01:07:03.000000', 'temperatura', 197.0000, 'ºC'),
	(342232, 144, '2015-02-01 01:07:04.000000', 'temperatura', 15.0000, 'ºC'),
	(342233, 144, '2015-02-01 01:07:05.000000', 'temperatura', 686.0000, 'ºC'),
	(342234, 144, '2015-02-01 01:07:06.000000', 'temperatura', 983.0000, 'ºC'),
	(342235, 144, '2015-02-01 01:07:07.000000', 'temperatura', 458.0000, 'ºC'),
	(342236, 144, '2015-02-01 01:07:08.000000', 'temperatura', 544.0000, 'ºC'),
	(342237, 144, '2015-02-01 01:07:09.000000', 'temperatura', 143.0000, 'ºC'),
	(342238, 144, '2015-02-01 01:07:10.000000', 'temperatura', 284.0000, 'ºC'),
	(342239, 144, '2015-02-01 01:07:11.000000', 'temperatura', 991.0000, 'ºC'),
	(342240, 144, '2015-02-01 01:07:12.000000', 'temperatura', 504.0000, 'ºC'),
	(342241, 144, '2015-02-01 01:07:13.000000', 'temperatura', 746.0000, 'ºC'),
	(342242, 144, '2015-02-01 01:07:14.000000', 'temperatura', 1020.0000, 'ºC'),
	(342243, 144, '2015-02-01 01:07:15.000000', 'temperatura', 462.0000, 'ºC'),
	(342244, 144, '2015-02-01 01:07:16.000000', 'temperatura', 451.0000, 'ºC'),
	(342245, 144, '2015-02-01 01:07:17.000000', 'temperatura', 869.0000, 'ºC'),
	(342246, 144, '2015-02-01 01:07:18.000000', 'temperatura', 594.0000, 'ºC'),
	(342247, 144, '2015-02-01 01:07:19.000000', 'temperatura', 363.0000, 'ºC'),
	(342248, 144, '2015-02-01 01:07:20.000000', 'temperatura', 34.0000, 'ºC'),
	(342249, 144, '2015-02-01 01:07:21.000000', 'temperatura', 281.0000, 'ºC'),
	(342250, 144, '2015-02-01 01:07:22.000000', 'temperatura', 104.0000, 'ºC'),
	(342251, 144, '2015-02-01 01:07:23.000000', 'temperatura', 878.0000, 'ºC'),
	(342252, 144, '2015-02-01 01:07:24.000000', 'temperatura', 480.0000, 'ºC'),
	(342253, 144, '2015-02-01 01:07:25.000000', 'temperatura', 963.0000, 'ºC'),
	(342254, 144, '2015-02-01 01:07:26.000000', 'temperatura', 977.0000, 'ºC'),
	(342255, 144, '2015-02-01 01:07:27.000000', 'temperatura', 796.0000, 'ºC'),
	(342256, 144, '2015-02-01 01:07:28.000000', 'temperatura', 1048.0000, 'ºC'),
	(342257, 144, '2015-02-01 01:07:29.000000', 'temperatura', 455.0000, 'ºC'),
	(342258, 144, '2015-02-01 01:07:30.000000', 'temperatura', 332.0000, 'ºC'),
	(342259, 144, '2015-02-01 01:07:31.000000', 'temperatura', 293.0000, 'ºC'),
	(342260, 144, '2015-02-01 01:07:32.000000', 'temperatura', 469.0000, 'ºC'),
	(342261, 144, '2015-02-01 01:07:33.000000', 'temperatura', 268.0000, 'ºC'),
	(342262, 144, '2015-02-01 01:07:34.000000', 'temperatura', 1134.0000, 'ºC'),
	(342263, 144, '2015-02-01 01:07:35.000000', 'temperatura', 65.0000, 'ºC'),
	(342264, 144, '2015-02-01 01:07:36.000000', 'temperatura', 523.0000, 'ºC'),
	(342265, 144, '2015-02-01 01:07:37.000000', 'temperatura', 20.0000, 'ºC'),
	(342266, 144, '2015-02-01 01:07:38.000000', 'temperatura', 933.0000, 'ºC'),
	(342267, 144, '2015-02-01 01:07:39.000000', 'temperatura', 1007.0000, 'ºC'),
	(342268, 144, '2015-02-01 01:07:40.000000', 'temperatura', 1035.0000, 'ºC'),
	(342269, 144, '2015-02-01 01:07:41.000000', 'temperatura', 953.0000, 'ºC'),
	(342270, 144, '2015-02-01 01:07:42.000000', 'temperatura', 463.0000, 'ºC'),
	(342271, 144, '2015-02-01 01:07:43.000000', 'temperatura', 656.0000, 'ºC'),
	(342272, 144, '2015-02-01 01:07:44.000000', 'temperatura', 691.0000, 'ºC'),
	(342273, 144, '2015-02-01 01:07:45.000000', 'temperatura', 289.0000, 'ºC'),
	(342274, 144, '2015-02-01 01:07:46.000000', 'temperatura', 570.0000, 'ºC'),
	(342275, 144, '2015-02-01 01:07:47.000000', 'temperatura', 784.0000, 'ºC'),
	(342276, 144, '2015-02-01 01:07:48.000000', 'temperatura', 1013.0000, 'ºC'),
	(342277, 144, '2015-02-01 01:07:49.000000', 'temperatura', 312.0000, 'ºC'),
	(342278, 144, '2015-02-01 01:07:50.000000', 'temperatura', 921.0000, 'ºC'),
	(342279, 144, '2015-02-01 01:07:51.000000', 'temperatura', 69.0000, 'ºC'),
	(342280, 144, '2015-02-01 01:07:52.000000', 'temperatura', 1185.0000, 'ºC'),
	(342281, 144, '2015-02-01 01:07:53.000000', 'temperatura', 918.0000, 'ºC'),
	(342282, 144, '2015-02-01 01:07:54.000000', 'temperatura', 1035.0000, 'ºC'),
	(342283, 144, '2015-02-01 01:07:55.000000', 'temperatura', 20.0000, 'ºC'),
	(342284, 144, '2015-02-01 01:07:56.000000', 'temperatura', 597.0000, 'ºC'),
	(342285, 144, '2015-02-01 01:07:57.000000', 'temperatura', 526.0000, 'ºC'),
	(342286, 144, '2015-02-01 01:07:58.000000', 'temperatura', 841.0000, 'ºC'),
	(342287, 144, '2015-02-01 01:07:59.000000', 'temperatura', 225.0000, 'ºC'),
	(342288, 144, '2015-02-01 01:08:00.000000', 'temperatura', 1005.0000, 'ºC'),
	(342289, 144, '2015-02-01 01:08:01.000000', 'temperatura', 749.0000, 'ºC'),
	(342290, 144, '2015-02-01 01:08:02.000000', 'temperatura', 731.0000, 'ºC'),
	(342291, 144, '2015-02-01 01:08:03.000000', 'temperatura', 207.0000, 'ºC'),
	(342292, 144, '2015-02-01 01:08:04.000000', 'temperatura', 45.0000, 'ºC'),
	(342293, 144, '2015-02-01 01:08:05.000000', 'temperatura', 805.0000, 'ºC'),
	(342294, 144, '2015-02-01 01:08:06.000000', 'temperatura', 291.0000, 'ºC'),
	(342295, 144, '2015-02-01 01:08:07.000000', 'temperatura', 241.0000, 'ºC'),
	(342296, 144, '2015-02-01 01:08:08.000000', 'temperatura', 330.0000, 'ºC'),
	(342297, 144, '2015-02-01 01:08:09.000000', 'temperatura', 928.0000, 'ºC'),
	(342298, 144, '2015-02-01 01:08:10.000000', 'temperatura', 50.0000, 'ºC'),
	(342299, 144, '2015-02-01 01:08:11.000000', 'temperatura', 1067.0000, 'ºC'),
	(342300, 144, '2015-02-01 01:08:12.000000', 'temperatura', 385.0000, 'ºC'),
	(342301, 144, '2015-02-01 01:08:13.000000', 'temperatura', 1123.0000, 'ºC'),
	(342302, 144, '2015-02-01 01:08:14.000000', 'temperatura', 863.0000, 'ºC'),
	(342303, 144, '2015-02-01 01:08:15.000000', 'temperatura', 944.0000, 'ºC'),
	(342304, 144, '2015-02-01 01:08:16.000000', 'temperatura', 932.0000, 'ºC'),
	(342305, 144, '2015-02-01 01:08:17.000000', 'temperatura', 627.0000, 'ºC'),
	(342306, 144, '2015-02-01 01:08:18.000000', 'temperatura', 342.0000, 'ºC'),
	(342307, 144, '2015-02-01 01:08:19.000000', 'temperatura', 1028.0000, 'ºC'),
	(342308, 144, '2015-02-01 01:08:20.000000', 'temperatura', 515.0000, 'ºC'),
	(342309, 144, '2015-02-01 01:08:21.000000', 'temperatura', 692.0000, 'ºC'),
	(342310, 144, '2015-02-01 01:08:22.000000', 'temperatura', 714.0000, 'ºC'),
	(342311, 144, '2015-02-01 01:08:23.000000', 'temperatura', 295.0000, 'ºC'),
	(342312, 144, '2015-02-01 01:08:24.000000', 'temperatura', 533.0000, 'ºC'),
	(342313, 144, '2015-02-01 01:08:25.000000', 'temperatura', 583.0000, 'ºC'),
	(342314, 144, '2015-02-01 01:08:26.000000', 'temperatura', 113.0000, 'ºC'),
	(342315, 144, '2015-02-01 01:08:27.000000', 'temperatura', 19.0000, 'ºC'),
	(342316, 144, '2015-02-01 01:08:28.000000', 'temperatura', 958.0000, 'ºC'),
	(342317, 144, '2015-02-01 01:08:29.000000', 'temperatura', 1131.0000, 'ºC'),
	(342318, 144, '2015-02-01 01:08:30.000000', 'temperatura', 380.0000, 'ºC'),
	(342319, 144, '2015-02-01 01:08:31.000000', 'temperatura', 911.0000, 'ºC'),
	(342320, 144, '2015-02-01 01:08:32.000000', 'temperatura', 1012.0000, 'ºC'),
	(342321, 144, '2015-02-01 01:08:33.000000', 'temperatura', 1130.0000, 'ºC'),
	(342322, 144, '2015-02-01 01:08:34.000000', 'temperatura', 214.0000, 'ºC'),
	(342323, 144, '2015-02-01 01:08:35.000000', 'temperatura', 78.0000, 'ºC'),
	(342324, 144, '2015-02-01 01:08:36.000000', 'temperatura', 951.0000, 'ºC'),
	(342325, 144, '2015-02-01 01:08:37.000000', 'temperatura', 922.0000, 'ºC'),
	(342326, 144, '2015-02-01 01:08:38.000000', 'temperatura', 555.0000, 'ºC'),
	(342327, 144, '2015-02-01 01:08:39.000000', 'temperatura', 11.0000, 'ºC'),
	(342328, 144, '2015-02-01 01:08:40.000000', 'temperatura', 788.0000, 'ºC'),
	(342329, 144, '2015-02-01 01:08:41.000000', 'temperatura', 310.0000, 'ºC'),
	(342330, 144, '2015-02-01 01:08:42.000000', 'temperatura', 386.0000, 'ºC'),
	(342331, 144, '2015-02-01 01:08:43.000000', 'temperatura', 1000.0000, 'ºC'),
	(342332, 144, '2015-02-01 01:08:44.000000', 'temperatura', 245.0000, 'ºC'),
	(342333, 144, '2015-02-01 01:08:45.000000', 'temperatura', 622.0000, 'ºC'),
	(342334, 144, '2015-02-01 01:08:46.000000', 'temperatura', 1176.0000, 'ºC'),
	(342335, 144, '2015-02-01 01:08:47.000000', 'temperatura', 417.0000, 'ºC'),
	(342336, 144, '2015-02-01 01:08:48.000000', 'temperatura', 954.0000, 'ºC'),
	(342337, 144, '2015-02-01 01:08:49.000000', 'temperatura', 1121.0000, 'ºC'),
	(342338, 144, '2015-02-01 01:08:50.000000', 'temperatura', 344.0000, 'ºC'),
	(342339, 144, '2015-02-01 01:08:51.000000', 'temperatura', 759.0000, 'ºC'),
	(342340, 144, '2015-02-01 01:08:52.000000', 'temperatura', 361.0000, 'ºC'),
	(342341, 144, '2015-02-01 01:08:53.000000', 'temperatura', 731.0000, 'ºC'),
	(342342, 144, '2015-02-01 01:08:54.000000', 'temperatura', 171.0000, 'ºC'),
	(342343, 144, '2015-02-01 01:08:55.000000', 'temperatura', 1062.0000, 'ºC'),
	(342344, 144, '2015-02-01 01:08:56.000000', 'temperatura', 1199.0000, 'ºC'),
	(342345, 144, '2015-02-01 01:08:57.000000', 'temperatura', 407.0000, 'ºC'),
	(342346, 144, '2015-02-01 01:08:58.000000', 'temperatura', 842.0000, 'ºC'),
	(342347, 144, '2015-02-01 01:08:59.000000', 'temperatura', 586.0000, 'ºC'),
	(342348, 144, '2015-02-01 01:09:00.000000', 'temperatura', 407.0000, 'ºC'),
	(342349, 144, '2015-02-01 01:09:01.000000', 'temperatura', 277.0000, 'ºC'),
	(342350, 144, '2015-02-01 01:09:02.000000', 'temperatura', 163.0000, 'ºC'),
	(342351, 144, '2015-02-01 01:09:03.000000', 'temperatura', 1184.0000, 'ºC'),
	(342352, 144, '2015-02-01 01:09:04.000000', 'temperatura', 633.0000, 'ºC'),
	(342353, 144, '2015-02-01 01:09:05.000000', 'temperatura', 813.0000, 'ºC'),
	(342354, 144, '2015-02-01 01:09:06.000000', 'temperatura', 965.0000, 'ºC'),
	(342355, 144, '2015-02-01 01:09:07.000000', 'temperatura', 1187.0000, 'ºC'),
	(342356, 144, '2015-02-01 01:09:08.000000', 'temperatura', 643.0000, 'ºC'),
	(342357, 144, '2015-02-01 01:09:09.000000', 'temperatura', 853.0000, 'ºC'),
	(342358, 144, '2015-02-01 01:09:10.000000', 'temperatura', 1135.0000, 'ºC'),
	(342359, 144, '2015-02-01 01:09:11.000000', 'temperatura', 718.0000, 'ºC'),
	(342360, 144, '2015-02-01 01:09:12.000000', 'temperatura', 187.0000, 'ºC'),
	(342361, 144, '2015-02-01 01:09:13.000000', 'temperatura', 1181.0000, 'ºC'),
	(342362, 144, '2015-02-01 01:09:14.000000', 'temperatura', 542.0000, 'ºC'),
	(342363, 144, '2015-02-01 01:09:15.000000', 'temperatura', 371.0000, 'ºC'),
	(342364, 144, '2015-02-01 01:09:16.000000', 'temperatura', 227.0000, 'ºC'),
	(342365, 144, '2015-02-01 01:09:17.000000', 'temperatura', 25.0000, 'ºC'),
	(342366, 144, '2015-02-01 01:09:18.000000', 'temperatura', 643.0000, 'ºC'),
	(342367, 144, '2015-02-01 01:09:19.000000', 'temperatura', 739.0000, 'ºC'),
	(342368, 144, '2015-02-01 01:09:20.000000', 'temperatura', 566.0000, 'ºC'),
	(342369, 144, '2015-02-01 01:09:21.000000', 'temperatura', 616.0000, 'ºC'),
	(342370, 144, '2015-02-01 01:09:22.000000', 'temperatura', 180.0000, 'ºC'),
	(342371, 144, '2015-02-01 01:09:23.000000', 'temperatura', 252.0000, 'ºC'),
	(342372, 144, '2015-02-01 01:09:24.000000', 'temperatura', 724.0000, 'ºC'),
	(342373, 144, '2015-02-01 01:09:25.000000', 'temperatura', 461.0000, 'ºC'),
	(342374, 144, '2015-02-01 01:09:26.000000', 'temperatura', 135.0000, 'ºC'),
	(342375, 144, '2015-02-01 01:09:27.000000', 'temperatura', 494.0000, 'ºC'),
	(342376, 144, '2015-02-01 01:09:28.000000', 'temperatura', 863.0000, 'ºC'),
	(342377, 144, '2015-02-01 01:09:29.000000', 'temperatura', 434.0000, 'ºC'),
	(342378, 144, '2015-02-01 01:09:30.000000', 'temperatura', 783.0000, 'ºC'),
	(342379, 144, '2015-02-01 01:09:31.000000', 'temperatura', 214.0000, 'ºC'),
	(342380, 144, '2015-02-01 01:09:32.000000', 'temperatura', 1119.0000, 'ºC'),
	(342381, 144, '2015-02-01 01:09:33.000000', 'temperatura', 153.0000, 'ºC'),
	(342382, 144, '2015-02-01 01:09:34.000000', 'temperatura', 1011.0000, 'ºC'),
	(342383, 144, '2015-02-01 01:09:35.000000', 'temperatura', 995.0000, 'ºC'),
	(342384, 144, '2015-02-01 01:09:36.000000', 'temperatura', 743.0000, 'ºC'),
	(342385, 144, '2015-02-01 01:09:37.000000', 'temperatura', 730.0000, 'ºC'),
	(342386, 144, '2015-02-01 01:09:38.000000', 'temperatura', 221.0000, 'ºC'),
	(342387, 144, '2015-02-01 01:09:39.000000', 'temperatura', 116.0000, 'ºC'),
	(342388, 144, '2015-02-01 01:09:40.000000', 'temperatura', 1118.0000, 'ºC'),
	(342389, 144, '2015-02-01 01:09:41.000000', 'temperatura', 441.0000, 'ºC'),
	(342390, 144, '2015-02-01 01:09:42.000000', 'temperatura', 51.0000, 'ºC'),
	(342391, 144, '2015-02-01 01:09:43.000000', 'temperatura', 135.0000, 'ºC'),
	(342392, 144, '2015-02-01 01:09:44.000000', 'temperatura', 521.0000, 'ºC'),
	(342393, 144, '2015-02-01 01:09:45.000000', 'temperatura', 999.0000, 'ºC'),
	(342394, 144, '2015-02-01 01:09:46.000000', 'temperatura', 1034.0000, 'ºC'),
	(342395, 144, '2015-02-01 01:09:47.000000', 'temperatura', 971.0000, 'ºC'),
	(342396, 144, '2015-02-01 01:09:48.000000', 'temperatura', 556.0000, 'ºC'),
	(342397, 144, '2015-02-01 01:09:49.000000', 'temperatura', 1068.0000, 'ºC'),
	(342398, 144, '2015-02-01 01:09:50.000000', 'temperatura', 73.0000, 'ºC'),
	(342399, 144, '2015-02-01 01:09:51.000000', 'temperatura', 761.0000, 'ºC'),
	(342400, 144, '2015-02-01 01:09:52.000000', 'temperatura', 1187.0000, 'ºC'),
	(342401, 144, '2015-02-01 01:09:53.000000', 'temperatura', 54.0000, 'ºC'),
	(342402, 144, '2015-02-01 01:09:54.000000', 'temperatura', 307.0000, 'ºC'),
	(342403, 144, '2015-02-01 01:09:55.000000', 'temperatura', 174.0000, 'ºC'),
	(342404, 144, '2015-02-01 01:09:56.000000', 'temperatura', 1151.0000, 'ºC'),
	(342405, 144, '2015-02-01 01:09:57.000000', 'temperatura', 434.0000, 'ºC'),
	(342406, 144, '2015-02-01 01:09:58.000000', 'temperatura', 1117.0000, 'ºC'),
	(342407, 144, '2015-02-01 01:09:59.000000', 'temperatura', 684.0000, 'ºC'),
	(342408, 144, '2015-02-01 01:10:00.000000', 'temperatura', 67.0000, 'ºC'),
	(342409, 144, '2015-02-01 01:10:01.000000', 'temperatura', 687.0000, 'ºC'),
	(342410, 144, '2015-02-01 01:10:02.000000', 'temperatura', 831.0000, 'ºC'),
	(342411, 144, '2015-02-01 01:10:03.000000', 'temperatura', 896.0000, 'ºC'),
	(342412, 144, '2015-02-01 01:10:04.000000', 'temperatura', 787.0000, 'ºC'),
	(342413, 144, '2015-02-01 01:10:05.000000', 'temperatura', 46.0000, 'ºC'),
	(342414, 144, '2015-02-01 01:10:06.000000', 'temperatura', 272.0000, 'ºC'),
	(342415, 144, '2015-02-01 01:10:07.000000', 'temperatura', 23.0000, 'ºC'),
	(342416, 144, '2015-02-01 01:10:08.000000', 'temperatura', 499.0000, 'ºC'),
	(342417, 144, '2015-02-01 01:10:09.000000', 'temperatura', 26.0000, 'ºC'),
	(342418, 144, '2015-02-01 01:10:10.000000', 'temperatura', 1031.0000, 'ºC'),
	(342419, 144, '2015-02-01 01:10:11.000000', 'temperatura', 281.0000, 'ºC'),
	(342420, 144, '2015-02-01 01:10:12.000000', 'temperatura', 713.0000, 'ºC'),
	(342421, 144, '2015-02-01 01:10:13.000000', 'temperatura', 322.0000, 'ºC'),
	(342422, 144, '2015-02-01 01:10:14.000000', 'temperatura', 670.0000, 'ºC'),
	(342423, 144, '2015-02-01 01:10:15.000000', 'temperatura', 1183.0000, 'ºC'),
	(342424, 144, '2015-02-01 01:10:16.000000', 'temperatura', 308.0000, 'ºC'),
	(342425, 144, '2015-02-01 01:10:17.000000', 'temperatura', 389.0000, 'ºC'),
	(342426, 144, '2015-02-01 01:10:18.000000', 'temperatura', 1023.0000, 'ºC'),
	(342427, 144, '2015-02-01 01:10:19.000000', 'temperatura', 347.0000, 'ºC'),
	(342428, 144, '2015-02-01 01:10:20.000000', 'temperatura', 1068.0000, 'ºC'),
	(342429, 144, '2015-02-01 01:10:21.000000', 'temperatura', 697.0000, 'ºC'),
	(342430, 144, '2015-02-01 01:10:22.000000', 'temperatura', 283.0000, 'ºC'),
	(342431, 144, '2015-02-01 01:10:23.000000', 'temperatura', 526.0000, 'ºC'),
	(342432, 144, '2015-02-01 01:10:24.000000', 'temperatura', 579.0000, 'ºC'),
	(342433, 144, '2015-02-01 01:10:25.000000', 'temperatura', 120.0000, 'ºC'),
	(342434, 144, '2015-02-01 01:10:26.000000', 'temperatura', 65.0000, 'ºC'),
	(342435, 144, '2015-02-01 01:10:27.000000', 'temperatura', 1162.0000, 'ºC'),
	(342436, 144, '2015-02-01 01:10:28.000000', 'temperatura', 816.0000, 'ºC'),
	(342437, 144, '2015-02-01 01:10:29.000000', 'temperatura', 594.0000, 'ºC'),
	(342438, 144, '2015-02-01 01:10:30.000000', 'temperatura', 524.0000, 'ºC'),
	(342439, 144, '2015-02-01 01:10:31.000000', 'temperatura', 836.0000, 'ºC'),
	(342440, 144, '2015-02-01 01:10:32.000000', 'temperatura', 210.0000, 'ºC'),
	(342441, 144, '2015-02-01 01:10:33.000000', 'temperatura', 941.0000, 'ºC'),
	(342442, 144, '2015-02-01 01:10:34.000000', 'temperatura', 476.0000, 'ºC'),
	(342443, 144, '2015-02-01 01:10:35.000000', 'temperatura', 757.0000, 'ºC'),
	(342444, 144, '2015-02-01 01:10:36.000000', 'temperatura', 1159.0000, 'ºC'),
	(342445, 144, '2015-02-01 01:10:37.000000', 'temperatura', 1123.0000, 'ºC'),
	(342446, 144, '2015-02-01 01:10:38.000000', 'temperatura', 938.0000, 'ºC'),
	(342447, 144, '2015-02-01 01:10:39.000000', 'temperatura', 122.0000, 'ºC'),
	(342448, 144, '2015-02-01 01:10:40.000000', 'temperatura', 195.0000, 'ºC'),
	(342449, 144, '2015-02-01 01:10:41.000000', 'temperatura', 609.0000, 'ºC'),
	(342450, 144, '2015-02-01 01:10:42.000000', 'temperatura', 64.0000, 'ºC'),
	(342451, 144, '2015-02-01 01:10:43.000000', 'temperatura', 890.0000, 'ºC'),
	(342452, 144, '2015-02-01 01:10:44.000000', 'temperatura', 660.0000, 'ºC'),
	(342453, 144, '2015-02-01 01:10:45.000000', 'temperatura', 630.0000, 'ºC'),
	(342454, 144, '2015-02-01 01:10:46.000000', 'temperatura', 1169.0000, 'ºC'),
	(342455, 144, '2015-02-01 01:10:47.000000', 'temperatura', 357.0000, 'ºC'),
	(342456, 144, '2015-02-01 01:10:48.000000', 'temperatura', 677.0000, 'ºC'),
	(342457, 144, '2015-02-01 01:10:49.000000', 'temperatura', 1114.0000, 'ºC'),
	(342458, 144, '2015-02-01 01:10:50.000000', 'temperatura', 1141.0000, 'ºC'),
	(342459, 144, '2015-02-01 01:10:51.000000', 'temperatura', 1163.0000, 'ºC'),
	(342460, 144, '2015-02-01 01:10:52.000000', 'temperatura', 1191.0000, 'ºC'),
	(342461, 144, '2015-02-01 01:10:53.000000', 'temperatura', 66.0000, 'ºC'),
	(342462, 144, '2015-02-01 01:10:54.000000', 'temperatura', 359.0000, 'ºC'),
	(342463, 144, '2015-02-01 01:10:55.000000', 'temperatura', 398.0000, 'ºC'),
	(342464, 144, '2015-02-01 01:10:56.000000', 'temperatura', 914.0000, 'ºC'),
	(342465, 144, '2015-02-01 01:10:57.000000', 'temperatura', 975.0000, 'ºC'),
	(342466, 144, '2015-02-01 01:10:58.000000', 'temperatura', 935.0000, 'ºC'),
	(342467, 144, '2015-02-01 01:10:59.000000', 'temperatura', 551.0000, 'ºC'),
	(342468, 144, '2015-02-01 01:11:00.000000', 'temperatura', 1149.0000, 'ºC'),
	(342469, 144, '2015-02-01 01:11:01.000000', 'temperatura', 492.0000, 'ºC'),
	(342470, 144, '2015-02-01 01:11:02.000000', 'temperatura', 216.0000, 'ºC'),
	(342471, 144, '2015-02-01 01:11:03.000000', 'temperatura', 802.0000, 'ºC'),
	(342472, 144, '2015-02-01 01:11:04.000000', 'temperatura', 965.0000, 'ºC'),
	(342473, 144, '2015-02-01 01:11:05.000000', 'temperatura', 20.0000, 'ºC'),
	(342474, 144, '2015-02-01 01:11:06.000000', 'temperatura', 804.0000, 'ºC'),
	(342475, 144, '2015-02-01 01:11:07.000000', 'temperatura', 361.0000, 'ºC'),
	(342476, 144, '2015-02-01 01:11:08.000000', 'temperatura', 594.0000, 'ºC'),
	(342477, 144, '2015-02-01 01:11:09.000000', 'temperatura', 685.0000, 'ºC'),
	(342478, 144, '2015-02-01 01:11:10.000000', 'temperatura', 445.0000, 'ºC'),
	(342479, 144, '2015-02-01 01:11:11.000000', 'temperatura', 172.0000, 'ºC'),
	(342480, 144, '2015-02-01 01:11:12.000000', 'temperatura', 723.0000, 'ºC'),
	(342481, 144, '2015-02-01 01:11:13.000000', 'temperatura', 700.0000, 'ºC'),
	(342482, 144, '2015-02-01 01:11:14.000000', 'temperatura', 132.0000, 'ºC'),
	(342483, 144, '2015-02-01 01:11:15.000000', 'temperatura', 960.0000, 'ºC'),
	(342484, 144, '2015-02-01 01:11:16.000000', 'temperatura', 804.0000, 'ºC'),
	(342485, 144, '2015-02-01 01:11:17.000000', 'temperatura', 1143.0000, 'ºC'),
	(342486, 144, '2015-02-01 01:11:18.000000', 'temperatura', 902.0000, 'ºC'),
	(342487, 144, '2015-02-01 01:11:19.000000', 'temperatura', 1080.0000, 'ºC'),
	(342488, 144, '2015-02-01 01:11:20.000000', 'temperatura', 295.0000, 'ºC'),
	(342489, 144, '2015-02-01 01:11:21.000000', 'temperatura', 634.0000, 'ºC'),
	(342490, 144, '2015-02-01 01:11:22.000000', 'temperatura', 1087.0000, 'ºC'),
	(342491, 144, '2015-02-01 01:11:23.000000', 'temperatura', 1135.0000, 'ºC'),
	(342492, 144, '2015-02-01 01:11:24.000000', 'temperatura', 14.0000, 'ºC'),
	(342493, 144, '2015-02-01 01:11:25.000000', 'temperatura', 263.0000, 'ºC'),
	(342494, 144, '2015-02-01 01:11:26.000000', 'temperatura', 75.0000, 'ºC'),
	(342495, 144, '2015-02-01 01:11:27.000000', 'temperatura', 788.0000, 'ºC'),
	(342496, 144, '2015-02-01 01:11:28.000000', 'temperatura', 114.0000, 'ºC'),
	(342497, 144, '2015-02-01 01:11:29.000000', 'temperatura', 607.0000, 'ºC'),
	(342498, 144, '2015-02-01 01:11:30.000000', 'temperatura', 294.0000, 'ºC'),
	(342499, 144, '2015-02-01 01:11:31.000000', 'temperatura', 849.0000, 'ºC'),
	(342500, 144, '2015-02-01 01:11:32.000000', 'temperatura', 964.0000, 'ºC'),
	(342501, 144, '2015-02-01 01:11:33.000000', 'temperatura', 1074.0000, 'ºC'),
	(342502, 144, '2015-02-01 01:11:34.000000', 'temperatura', 80.0000, 'ºC'),
	(342503, 144, '2015-02-01 01:11:35.000000', 'temperatura', 775.0000, 'ºC'),
	(342504, 144, '2015-02-01 01:11:36.000000', 'temperatura', 37.0000, 'ºC'),
	(342505, 144, '2015-02-01 01:11:37.000000', 'temperatura', 262.0000, 'ºC'),
	(342506, 144, '2015-02-01 01:11:38.000000', 'temperatura', 1198.0000, 'ºC'),
	(342507, 144, '2015-02-01 01:11:39.000000', 'temperatura', 406.0000, 'ºC'),
	(342508, 144, '2015-02-01 01:11:40.000000', 'temperatura', 836.0000, 'ºC'),
	(342509, 144, '2015-02-01 01:11:41.000000', 'temperatura', 562.0000, 'ºC'),
	(342510, 144, '2015-02-01 01:11:42.000000', 'temperatura', 305.0000, 'ºC'),
	(342511, 144, '2015-02-01 01:11:43.000000', 'temperatura', 1037.0000, 'ºC'),
	(342512, 144, '2015-02-01 01:11:44.000000', 'temperatura', 669.0000, 'ºC'),
	(342513, 144, '2015-02-01 01:11:45.000000', 'temperatura', 237.0000, 'ºC'),
	(342514, 144, '2015-02-01 01:11:46.000000', 'temperatura', 377.0000, 'ºC'),
	(342515, 144, '2015-02-01 01:11:47.000000', 'temperatura', 1177.0000, 'ºC'),
	(342516, 144, '2015-02-01 01:11:48.000000', 'temperatura', 1153.0000, 'ºC'),
	(342517, 144, '2015-02-01 01:11:49.000000', 'temperatura', 1035.0000, 'ºC'),
	(342518, 144, '2015-02-01 01:11:50.000000', 'temperatura', 515.0000, 'ºC'),
	(342519, 144, '2015-02-01 01:11:51.000000', 'temperatura', 671.0000, 'ºC'),
	(342520, 144, '2015-02-01 01:11:52.000000', 'temperatura', 611.0000, 'ºC'),
	(342521, 144, '2015-02-01 01:11:53.000000', 'temperatura', 1040.0000, 'ºC'),
	(342522, 144, '2015-02-01 01:11:54.000000', 'temperatura', 970.0000, 'ºC'),
	(342523, 144, '2015-02-01 01:11:55.000000', 'temperatura', 532.0000, 'ºC'),
	(342524, 144, '2015-02-01 01:11:56.000000', 'temperatura', 947.0000, 'ºC'),
	(342525, 144, '2015-02-01 01:11:57.000000', 'temperatura', 743.0000, 'ºC'),
	(342526, 144, '2015-02-01 01:11:58.000000', 'temperatura', 872.0000, 'ºC'),
	(342527, 144, '2015-02-01 01:11:59.000000', 'temperatura', 933.0000, 'ºC'),
	(342528, 144, '2015-02-01 01:12:00.000000', 'temperatura', 848.0000, 'ºC'),
	(342529, 144, '2015-02-01 01:12:01.000000', 'temperatura', 243.0000, 'ºC'),
	(342530, 144, '2015-02-01 01:12:02.000000', 'temperatura', 1070.0000, 'ºC'),
	(342531, 144, '2015-02-01 01:12:03.000000', 'temperatura', 1021.0000, 'ºC'),
	(342532, 144, '2015-02-01 01:12:04.000000', 'temperatura', 697.0000, 'ºC'),
	(342533, 144, '2015-02-01 01:12:05.000000', 'temperatura', 423.0000, 'ºC'),
	(342534, 144, '2015-02-01 01:12:06.000000', 'temperatura', 22.0000, 'ºC'),
	(342535, 144, '2015-02-01 01:12:07.000000', 'temperatura', 42.0000, 'ºC'),
	(342536, 144, '2015-02-01 01:12:08.000000', 'temperatura', 146.0000, 'ºC'),
	(342537, 144, '2015-02-01 01:12:09.000000', 'temperatura', 603.0000, 'ºC'),
	(342538, 144, '2015-02-01 01:12:10.000000', 'temperatura', 176.0000, 'ºC'),
	(342539, 144, '2015-02-01 01:12:11.000000', 'temperatura', 274.0000, 'ºC'),
	(342540, 144, '2015-02-01 01:12:12.000000', 'temperatura', 843.0000, 'ºC'),
	(342541, 144, '2015-02-01 01:12:13.000000', 'temperatura', 993.0000, 'ºC'),
	(342542, 144, '2015-02-01 01:12:14.000000', 'temperatura', 35.0000, 'ºC'),
	(342543, 144, '2015-02-01 01:12:15.000000', 'temperatura', 800.0000, 'ºC'),
	(342544, 144, '2015-02-01 01:12:16.000000', 'temperatura', 292.0000, 'ºC'),
	(342545, 144, '2015-02-01 01:12:17.000000', 'temperatura', 260.0000, 'ºC'),
	(342546, 144, '2015-02-01 01:12:18.000000', 'temperatura', 425.0000, 'ºC'),
	(342547, 144, '2015-02-01 01:12:19.000000', 'temperatura', 145.0000, 'ºC'),
	(342548, 144, '2015-02-01 01:12:20.000000', 'temperatura', 651.0000, 'ºC'),
	(342549, 144, '2015-02-01 01:12:21.000000', 'temperatura', 420.0000, 'ºC'),
	(342550, 144, '2015-02-01 01:12:22.000000', 'temperatura', 149.0000, 'ºC'),
	(342551, 144, '2015-02-01 01:12:23.000000', 'temperatura', 684.0000, 'ºC'),
	(342552, 144, '2015-02-01 01:12:24.000000', 'temperatura', 574.0000, 'ºC'),
	(342553, 144, '2015-02-01 01:12:25.000000', 'temperatura', 817.0000, 'ºC'),
	(342554, 144, '2015-02-01 01:12:26.000000', 'temperatura', 1165.0000, 'ºC'),
	(342555, 144, '2015-02-01 01:12:27.000000', 'temperatura', 973.0000, 'ºC'),
	(342556, 144, '2015-02-01 01:12:28.000000', 'temperatura', 173.0000, 'ºC'),
	(342557, 144, '2015-02-01 01:12:29.000000', 'temperatura', 347.0000, 'ºC'),
	(342558, 144, '2015-02-01 01:12:30.000000', 'temperatura', 16.0000, 'ºC'),
	(342559, 144, '2015-02-01 01:12:31.000000', 'temperatura', 238.0000, 'ºC'),
	(342560, 144, '2015-02-01 01:12:32.000000', 'temperatura', 1143.0000, 'ºC'),
	(342561, 144, '2015-02-01 01:12:33.000000', 'temperatura', 201.0000, 'ºC'),
	(342562, 144, '2015-02-01 01:12:34.000000', 'temperatura', 1177.0000, 'ºC'),
	(342563, 144, '2015-02-01 01:12:35.000000', 'temperatura', 481.0000, 'ºC'),
	(342564, 144, '2015-02-01 01:12:36.000000', 'temperatura', 73.0000, 'ºC'),
	(342565, 144, '2015-02-01 01:12:37.000000', 'temperatura', 126.0000, 'ºC'),
	(342566, 144, '2015-02-01 01:12:38.000000', 'temperatura', 412.0000, 'ºC'),
	(342567, 144, '2015-02-01 01:12:39.000000', 'temperatura', 481.0000, 'ºC'),
	(342568, 144, '2015-02-01 01:12:40.000000', 'temperatura', 1171.0000, 'ºC'),
	(342569, 144, '2015-02-01 01:12:41.000000', 'temperatura', 810.0000, 'ºC'),
	(342570, 144, '2015-02-01 01:12:42.000000', 'temperatura', 539.0000, 'ºC'),
	(342571, 144, '2015-02-01 01:12:43.000000', 'temperatura', 266.0000, 'ºC'),
	(342572, 144, '2015-02-01 01:12:44.000000', 'temperatura', 911.0000, 'ºC'),
	(342573, 144, '2015-02-01 01:12:45.000000', 'temperatura', 160.0000, 'ºC'),
	(342574, 144, '2015-02-01 01:12:46.000000', 'temperatura', 469.0000, 'ºC'),
	(342575, 144, '2015-02-01 01:12:47.000000', 'temperatura', 663.0000, 'ºC'),
	(342576, 144, '2015-02-01 01:12:48.000000', 'temperatura', 709.0000, 'ºC'),
	(342577, 144, '2015-02-01 01:12:49.000000', 'temperatura', 359.0000, 'ºC'),
	(342578, 144, '2015-02-01 01:12:50.000000', 'temperatura', 865.0000, 'ºC'),
	(342579, 144, '2015-02-01 01:12:51.000000', 'temperatura', 849.0000, 'ºC'),
	(342580, 144, '2015-02-01 01:12:52.000000', 'temperatura', 451.0000, 'ºC'),
	(342581, 144, '2015-02-01 01:12:53.000000', 'temperatura', 909.0000, 'ºC'),
	(342582, 144, '2015-02-01 01:12:54.000000', 'temperatura', 790.0000, 'ºC'),
	(342583, 144, '2015-02-01 01:12:55.000000', 'temperatura', 27.0000, 'ºC'),
	(342584, 144, '2015-02-01 01:12:56.000000', 'temperatura', 163.0000, 'ºC'),
	(342585, 144, '2015-02-01 01:12:57.000000', 'temperatura', 734.0000, 'ºC'),
	(342586, 144, '2015-02-01 01:12:58.000000', 'temperatura', 781.0000, 'ºC'),
	(342587, 144, '2015-02-01 01:12:59.000000', 'temperatura', 506.0000, 'ºC'),
	(342588, 144, '2015-02-01 01:13:00.000000', 'temperatura', 187.0000, 'ºC'),
	(342589, 144, '2015-02-01 01:13:01.000000', 'temperatura', 615.0000, 'ºC'),
	(342590, 144, '2015-02-01 01:13:02.000000', 'temperatura', 116.0000, 'ºC'),
	(342591, 144, '2015-02-01 01:13:03.000000', 'temperatura', 1135.0000, 'ºC'),
	(342592, 144, '2015-02-01 01:13:04.000000', 'temperatura', 529.0000, 'ºC'),
	(342593, 144, '2015-02-01 01:13:05.000000', 'temperatura', 438.0000, 'ºC'),
	(342594, 144, '2015-02-01 01:13:06.000000', 'temperatura', 606.0000, 'ºC'),
	(342595, 144, '2015-02-01 01:13:07.000000', 'temperatura', 514.0000, 'ºC'),
	(342596, 144, '2015-02-01 01:13:08.000000', 'temperatura', 752.0000, 'ºC'),
	(342597, 144, '2015-02-01 01:13:09.000000', 'temperatura', 1020.0000, 'ºC'),
	(342598, 144, '2015-02-01 01:13:10.000000', 'temperatura', 444.0000, 'ºC'),
	(342599, 144, '2015-02-01 01:13:11.000000', 'temperatura', 363.0000, 'ºC'),
	(342600, 144, '2015-02-01 01:13:12.000000', 'temperatura', 480.0000, 'ºC'),
	(342601, 144, '2015-02-01 01:13:13.000000', 'temperatura', 112.0000, 'ºC'),
	(342602, 144, '2015-02-01 01:13:14.000000', 'temperatura', 320.0000, 'ºC'),
	(342603, 144, '2015-02-01 01:13:15.000000', 'temperatura', 67.0000, 'ºC'),
	(342604, 144, '2015-02-01 01:13:16.000000', 'temperatura', 574.0000, 'ºC'),
	(342605, 144, '2015-02-01 01:13:17.000000', 'temperatura', 269.0000, 'ºC'),
	(342606, 144, '2015-02-01 01:13:18.000000', 'temperatura', 825.0000, 'ºC'),
	(342607, 144, '2015-02-01 01:13:19.000000', 'temperatura', 916.0000, 'ºC'),
	(342608, 144, '2015-02-01 01:13:20.000000', 'temperatura', 906.0000, 'ºC'),
	(342609, 144, '2015-02-01 01:13:21.000000', 'temperatura', 585.0000, 'ºC'),
	(342610, 144, '2015-02-01 01:13:22.000000', 'temperatura', 204.0000, 'ºC'),
	(342611, 144, '2015-02-01 01:13:23.000000', 'temperatura', 469.0000, 'ºC'),
	(342612, 144, '2015-02-01 01:13:24.000000', 'temperatura', 531.0000, 'ºC'),
	(342613, 144, '2015-02-01 01:13:25.000000', 'temperatura', 48.0000, 'ºC'),
	(342614, 144, '2015-02-01 01:13:26.000000', 'temperatura', 1049.0000, 'ºC'),
	(342615, 144, '2015-02-01 01:13:27.000000', 'temperatura', 302.0000, 'ºC'),
	(342616, 144, '2015-02-01 01:13:28.000000', 'temperatura', 764.0000, 'ºC'),
	(342617, 144, '2015-02-01 01:13:29.000000', 'temperatura', 514.0000, 'ºC'),
	(342618, 144, '2015-02-01 01:13:30.000000', 'temperatura', 277.0000, 'ºC'),
	(342619, 144, '2015-02-01 01:13:31.000000', 'temperatura', 1044.0000, 'ºC'),
	(342620, 144, '2015-02-01 01:13:32.000000', 'temperatura', 790.0000, 'ºC'),
	(342621, 144, '2015-02-01 01:13:33.000000', 'temperatura', 816.0000, 'ºC'),
	(342622, 144, '2015-02-01 01:13:34.000000', 'temperatura', 514.0000, 'ºC'),
	(342623, 144, '2015-02-01 01:13:35.000000', 'temperatura', 122.0000, 'ºC'),
	(342624, 144, '2015-02-01 01:13:36.000000', 'temperatura', 266.0000, 'ºC'),
	(342625, 144, '2015-02-01 01:13:37.000000', 'temperatura', 967.0000, 'ºC'),
	(342626, 144, '2015-02-01 01:13:38.000000', 'temperatura', 438.0000, 'ºC'),
	(342627, 144, '2015-02-01 01:13:39.000000', 'temperatura', 490.0000, 'ºC'),
	(342628, 144, '2015-02-01 01:13:40.000000', 'temperatura', 1134.0000, 'ºC'),
	(342629, 144, '2015-02-01 01:13:41.000000', 'temperatura', 599.0000, 'ºC'),
	(342630, 144, '2015-02-01 01:13:42.000000', 'temperatura', 797.0000, 'ºC'),
	(342631, 144, '2015-02-01 01:13:43.000000', 'temperatura', 989.0000, 'ºC'),
	(342632, 144, '2015-02-01 01:13:44.000000', 'temperatura', 153.0000, 'ºC'),
	(342633, 144, '2015-02-01 01:13:45.000000', 'temperatura', 198.0000, 'ºC'),
	(342634, 144, '2015-02-01 01:13:46.000000', 'temperatura', 532.0000, 'ºC'),
	(342635, 144, '2015-02-01 01:13:47.000000', 'temperatura', 867.0000, 'ºC'),
	(342636, 144, '2015-02-01 01:13:48.000000', 'temperatura', 340.0000, 'ºC'),
	(342637, 144, '2015-02-01 01:13:49.000000', 'temperatura', 299.0000, 'ºC'),
	(342638, 144, '2015-02-01 01:13:50.000000', 'temperatura', 475.0000, 'ºC'),
	(342639, 144, '2015-02-01 01:13:51.000000', 'temperatura', 277.0000, 'ºC'),
	(342640, 144, '2015-02-01 01:13:52.000000', 'temperatura', 1162.0000, 'ºC'),
	(342641, 144, '2015-02-01 01:13:53.000000', 'temperatura', 178.0000, 'ºC'),
	(342642, 144, '2015-02-01 01:13:54.000000', 'temperatura', 1004.0000, 'ºC'),
	(342643, 144, '2015-02-01 01:13:55.000000', 'temperatura', 886.0000, 'ºC'),
	(342644, 144, '2015-02-01 01:13:56.000000', 'temperatura', 218.0000, 'ºC'),
	(342645, 144, '2015-02-01 01:13:57.000000', 'temperatura', 832.0000, 'ºC'),
	(342646, 144, '2015-02-01 01:13:58.000000', 'temperatura', 1107.0000, 'ºC'),
	(342647, 144, '2015-02-01 01:13:59.000000', 'temperatura', 639.0000, 'ºC'),
	(342648, 144, '2015-02-01 01:14:00.000000', 'temperatura', 1073.0000, 'ºC'),
	(342649, 144, '2015-02-01 01:14:01.000000', 'temperatura', 1051.0000, 'ºC'),
	(342650, 144, '2015-02-01 01:14:02.000000', 'temperatura', 836.0000, 'ºC'),
	(342651, 144, '2015-02-01 01:14:03.000000', 'temperatura', 1029.0000, 'ºC'),
	(342652, 144, '2015-02-01 01:14:04.000000', 'temperatura', 236.0000, 'ºC'),
	(342653, 144, '2015-02-01 01:14:05.000000', 'temperatura', 496.0000, 'ºC'),
	(342654, 144, '2015-02-01 01:14:06.000000', 'temperatura', 569.0000, 'ºC'),
	(342655, 144, '2015-02-01 01:14:07.000000', 'temperatura', 161.0000, 'ºC'),
	(342656, 144, '2015-02-01 01:14:08.000000', 'temperatura', 295.0000, 'ºC'),
	(342657, 144, '2015-02-01 01:14:09.000000', 'temperatura', 996.0000, 'ºC'),
	(342658, 144, '2015-02-01 01:14:10.000000', 'temperatura', 492.0000, 'ºC'),
	(342659, 144, '2015-02-01 01:14:11.000000', 'temperatura', 675.0000, 'ºC'),
	(342660, 144, '2015-02-01 01:14:12.000000', 'temperatura', 700.0000, 'ºC'),
	(342661, 144, '2015-02-01 01:14:13.000000', 'temperatura', 277.0000, 'ºC'),
	(342662, 144, '2015-02-01 01:14:14.000000', 'temperatura', 482.0000, 'ºC'),
	(342663, 144, '2015-02-01 01:14:15.000000', 'temperatura', 380.0000, 'ºC'),
	(342664, 144, '2015-02-01 01:14:16.000000', 'temperatura', 453.0000, 'ºC'),
	(342665, 144, '2015-02-01 01:14:17.000000', 'temperatura', 1128.0000, 'ºC'),
	(342666, 144, '2015-02-01 01:14:18.000000', 'temperatura', 680.0000, 'ºC'),
	(342667, 144, '2015-02-01 01:14:19.000000', 'temperatura', 16.0000, 'ºC'),
	(342668, 144, '2015-02-01 01:14:20.000000', 'temperatura', 442.0000, 'ºC'),
	(342669, 144, '2015-02-01 01:14:21.000000', 'temperatura', 963.0000, 'ºC'),
	(342670, 144, '2015-02-01 01:14:22.000000', 'temperatura', 1088.0000, 'ºC'),
	(342671, 144, '2015-02-01 01:14:23.000000', 'temperatura', 153.0000, 'ºC'),
	(342672, 144, '2015-02-01 01:14:24.000000', 'temperatura', 1099.0000, 'ºC'),
	(342673, 144, '2015-02-01 01:14:25.000000', 'temperatura', 238.0000, 'ºC'),
	(342674, 144, '2015-02-01 01:14:26.000000', 'temperatura', 295.0000, 'ºC'),
	(342675, 144, '2015-02-01 01:14:27.000000', 'temperatura', 761.0000, 'ºC'),
	(342676, 144, '2015-02-01 01:14:28.000000', 'temperatura', 522.0000, 'ºC'),
	(342677, 144, '2015-02-01 01:14:29.000000', 'temperatura', 324.0000, 'ºC'),
	(342678, 144, '2015-02-01 01:14:30.000000', 'temperatura', 57.0000, 'ºC'),
	(342679, 144, '2015-02-01 01:14:31.000000', 'temperatura', 511.0000, 'ºC'),
	(342680, 144, '2015-02-01 01:14:32.000000', 'temperatura', 1184.0000, 'ºC'),
	(342681, 144, '2015-02-01 01:14:33.000000', 'temperatura', 791.0000, 'ºC'),
	(342682, 144, '2015-02-01 01:14:34.000000', 'temperatura', 400.0000, 'ºC'),
	(342683, 144, '2015-02-01 01:14:35.000000', 'temperatura', 830.0000, 'ºC'),
	(342684, 144, '2015-02-01 01:14:36.000000', 'temperatura', 549.0000, 'ºC'),
	(342685, 144, '2015-02-01 01:14:37.000000', 'temperatura', 254.0000, 'ºC'),
	(342686, 144, '2015-02-01 01:14:38.000000', 'temperatura', 825.0000, 'ºC'),
	(342687, 144, '2015-02-01 01:14:39.000000', 'temperatura', 962.0000, 'ºC'),
	(342688, 144, '2015-02-01 01:14:40.000000', 'temperatura', 1138.0000, 'ºC'),
	(342689, 144, '2015-02-01 01:14:41.000000', 'temperatura', 405.0000, 'ºC'),
	(342690, 144, '2015-02-01 01:14:42.000000', 'temperatura', 1009.0000, 'ºC'),
	(342691, 144, '2015-02-01 01:14:43.000000', 'temperatura', 233.0000, 'ºC'),
	(342692, 144, '2015-02-01 01:14:44.000000', 'temperatura', 537.0000, 'ºC'),
	(342693, 144, '2015-02-01 01:14:45.000000', 'temperatura', 786.0000, 'ºC'),
	(342694, 144, '2015-02-01 01:14:46.000000', 'temperatura', 1120.0000, 'ºC'),
	(342695, 144, '2015-02-01 01:14:47.000000', 'temperatura', 842.0000, 'ºC'),
	(342696, 144, '2015-02-01 01:14:48.000000', 'temperatura', 853.0000, 'ºC'),
	(342697, 144, '2015-02-01 01:14:49.000000', 'temperatura', 537.0000, 'ºC'),
	(342698, 144, '2015-02-01 01:14:50.000000', 'temperatura', 125.0000, 'ºC'),
	(342699, 144, '2015-02-01 01:14:51.000000', 'temperatura', 217.0000, 'ºC'),
	(342700, 144, '2015-02-01 01:14:52.000000', 'temperatura', 709.0000, 'ºC'),
	(342701, 144, '2015-02-01 01:14:53.000000', 'temperatura', 497.0000, 'ºC'),
	(342702, 144, '2015-02-01 01:14:54.000000', 'temperatura', 357.0000, 'ºC'),
	(342703, 144, '2015-02-01 01:14:55.000000', 'temperatura', 293.0000, 'ºC'),
	(342704, 144, '2015-02-01 01:14:56.000000', 'temperatura', 395.0000, 'ºC'),
	(342705, 144, '2015-02-01 01:14:57.000000', 'temperatura', 1098.0000, 'ºC'),
	(342706, 144, '2015-02-01 01:14:58.000000', 'temperatura', 705.0000, 'ºC'),
	(342707, 144, '2015-02-01 01:14:59.000000', 'temperatura', 233.0000, 'ºC'),
	(342708, 144, '2015-02-01 01:15:00.000000', 'temperatura', 251.0000, 'ºC'),
	(342709, 144, '2015-02-01 01:15:01.000000', 'temperatura', 555.0000, 'ºC'),
	(342710, 144, '2015-02-01 01:15:02.000000', 'temperatura', 822.0000, 'ºC'),
	(342711, 144, '2015-02-01 01:15:03.000000', 'temperatura', 45.0000, 'ºC'),
	(342712, 144, '2015-02-01 01:15:04.000000', 'temperatura', 161.0000, 'ºC'),
	(342713, 144, '2015-02-01 01:15:05.000000', 'temperatura', 668.0000, 'ºC'),
	(342714, 144, '2015-02-01 01:15:06.000000', 'temperatura', 459.0000, 'ºC'),
	(342715, 144, '2015-02-01 01:15:07.000000', 'temperatura', 292.0000, 'ºC'),
	(342716, 144, '2015-02-01 01:15:08.000000', 'temperatura', 83.0000, 'ºC'),
	(342717, 144, '2015-02-01 01:15:09.000000', 'temperatura', 738.0000, 'ºC'),
	(342718, 144, '2015-02-01 01:15:10.000000', 'temperatura', 1044.0000, 'ºC'),
	(342719, 144, '2015-02-01 01:15:11.000000', 'temperatura', 603.0000, 'ºC'),
	(342720, 144, '2015-02-01 01:15:12.000000', 'temperatura', 1087.0000, 'ºC'),
	(342721, 144, '2015-02-01 01:15:13.000000', 'temperatura', 25.0000, 'ºC'),
	(342722, 144, '2015-02-01 01:15:14.000000', 'temperatura', 464.0000, 'ºC'),
	(342723, 144, '2015-02-01 01:15:15.000000', 'temperatura', 1045.0000, 'ºC'),
	(342724, 144, '2015-02-01 01:15:16.000000', 'temperatura', 235.0000, 'ºC'),
	(342725, 144, '2015-02-01 01:15:17.000000', 'temperatura', 440.0000, 'ºC'),
	(342726, 144, '2015-02-01 01:15:18.000000', 'temperatura', 297.0000, 'ºC'),
	(342727, 144, '2015-02-01 01:15:19.000000', 'temperatura', 163.0000, 'ºC'),
	(342728, 144, '2015-02-01 01:15:20.000000', 'temperatura', 1125.0000, 'ºC'),
	(342729, 144, '2015-02-01 01:15:21.000000', 'temperatura', 337.0000, 'ºC'),
	(342730, 144, '2015-02-01 01:15:22.000000', 'temperatura', 712.0000, 'ºC'),
	(342731, 144, '2015-02-01 01:15:23.000000', 'temperatura', 147.0000, 'ºC'),
	(342732, 144, '2015-02-01 01:15:24.000000', 'temperatura', 999.0000, 'ºC'),
	(342733, 144, '2015-02-01 01:15:25.000000', 'temperatura', 954.0000, 'ºC'),
	(342734, 144, '2015-02-01 01:15:26.000000', 'temperatura', 573.0000, 'ºC'),
	(342735, 144, '2015-02-01 01:15:27.000000', 'temperatura', 6.0000, 'ºC'),
	(342736, 144, '2015-02-01 01:15:28.000000', 'temperatura', 711.0000, 'ºC'),
	(342737, 144, '2015-02-01 01:15:29.000000', 'temperatura', 1135.0000, 'ºC'),
	(342738, 144, '2015-02-01 01:15:30.000000', 'temperatura', 1145.0000, 'ºC'),
	(342739, 144, '2015-02-01 01:15:31.000000', 'temperatura', 1119.0000, 'ºC'),
	(342740, 144, '2015-02-01 01:15:32.000000', 'temperatura', 962.0000, 'ºC'),
	(342741, 144, '2015-02-01 01:15:33.000000', 'temperatura', 254.0000, 'ºC'),
	(342742, 144, '2015-02-01 01:15:34.000000', 'temperatura', 783.0000, 'ºC'),
	(342743, 144, '2015-02-01 01:15:35.000000', 'temperatura', 752.0000, 'ºC'),
	(342744, 144, '2015-02-01 01:15:36.000000', 'temperatura', 213.0000, 'ºC'),
	(342745, 144, '2015-02-01 01:15:37.000000', 'temperatura', 11.0000, 'ºC'),
	(342746, 144, '2015-02-01 01:15:38.000000', 'temperatura', 616.0000, 'ºC'),
	(342747, 144, '2015-02-01 01:15:39.000000', 'temperatura', 647.0000, 'ºC'),
	(342748, 144, '2015-02-01 01:15:40.000000', 'temperatura', 189.0000, 'ºC'),
	(342749, 144, '2015-02-01 01:15:41.000000', 'temperatura', 202.0000, 'ºC'),
	(342750, 144, '2015-02-01 01:15:42.000000', 'temperatura', 444.0000, 'ºC'),
	(342751, 144, '2015-02-01 01:15:43.000000', 'temperatura', 414.0000, 'ºC'),
	(342752, 144, '2015-02-01 01:15:44.000000', 'temperatura', 738.0000, 'ºC'),
	(342753, 144, '2015-02-01 01:15:45.000000', 'temperatura', 50.0000, 'ºC'),
	(342754, 144, '2015-02-01 01:15:46.000000', 'temperatura', 435.0000, 'ºC'),
	(342755, 144, '2015-02-01 01:15:47.000000', 'temperatura', 826.0000, 'ºC'),
	(342756, 144, '2015-02-01 01:15:48.000000', 'temperatura', 425.0000, 'ºC'),
	(342757, 144, '2015-02-01 01:15:49.000000', 'temperatura', 847.0000, 'ºC'),
	(342758, 144, '2015-02-01 01:15:50.000000', 'temperatura', 560.0000, 'ºC'),
	(342759, 144, '2015-02-01 01:15:51.000000', 'temperatura', 261.0000, 'ºC'),
	(342760, 144, '2015-02-01 01:15:52.000000', 'temperatura', 824.0000, 'ºC'),
	(342761, 144, '2015-02-01 01:15:53.000000', 'temperatura', 939.0000, 'ºC'),
	(342762, 144, '2015-02-01 01:15:54.000000', 'temperatura', 1023.0000, 'ºC'),
	(342763, 144, '2015-02-01 01:15:55.000000', 'temperatura', 1097.0000, 'ºC'),
	(342764, 144, '2015-02-01 01:15:56.000000', 'temperatura', 19.0000, 'ºC'),
	(342765, 144, '2015-02-01 01:15:57.000000', 'temperatura', 404.0000, 'ºC'),
	(342766, 144, '2015-02-01 01:15:58.000000', 'temperatura', 765.0000, 'ºC'),
	(342767, 144, '2015-02-01 01:15:59.000000', 'temperatura', 212.0000, 'ºC'),
	(342768, 144, '2015-02-01 01:16:00.000000', 'temperatura', 1166.0000, 'ºC'),
	(342769, 144, '2015-02-01 01:16:01.000000', 'temperatura', 393.0000, 'ºC'),
	(342770, 144, '2015-02-01 01:16:02.000000', 'temperatura', 869.0000, 'ºC'),
	(342771, 144, '2015-02-01 01:16:03.000000', 'temperatura', 767.0000, 'ºC'),
	(342772, 144, '2015-02-01 01:16:04.000000', 'temperatura', 27.0000, 'ºC'),
	(342773, 144, '2015-02-01 01:16:05.000000', 'temperatura', 237.0000, 'ºC'),
	(342774, 144, '2015-02-01 01:16:06.000000', 'temperatura', 1101.0000, 'ºC'),
	(342775, 144, '2015-02-01 01:16:07.000000', 'temperatura', 1197.0000, 'ºC'),
	(342776, 144, '2015-02-01 01:16:08.000000', 'temperatura', 284.0000, 'ºC'),
	(342777, 144, '2015-02-01 01:16:09.000000', 'temperatura', 227.0000, 'ºC'),
	(342778, 144, '2015-02-01 01:16:10.000000', 'temperatura', 286.0000, 'ºC'),
	(342779, 144, '2015-02-01 01:16:11.000000', 'temperatura', 747.0000, 'ºC'),
	(342780, 144, '2015-02-01 01:16:12.000000', 'temperatura', 478.0000, 'ºC'),
	(342781, 144, '2015-02-01 01:16:13.000000', 'temperatura', 150.0000, 'ºC'),
	(342782, 144, '2015-02-01 01:16:14.000000', 'temperatura', 515.0000, 'ºC'),
	(342783, 144, '2015-02-01 01:16:15.000000', 'temperatura', 926.0000, 'ºC'),
	(342784, 144, '2015-02-01 01:16:16.000000', 'temperatura', 687.0000, 'ºC'),
	(342785, 144, '2015-02-01 01:16:17.000000', 'temperatura', 657.0000, 'ºC'),
	(342786, 144, '2015-02-01 01:16:18.000000', 'temperatura', 26.0000, 'ºC'),
	(342787, 144, '2015-02-01 01:16:19.000000', 'temperatura', 558.0000, 'ºC'),
	(342788, 144, '2015-02-01 01:16:20.000000', 'temperatura', 311.0000, 'ºC'),
	(342789, 144, '2015-02-01 01:16:21.000000', 'temperatura', 1081.0000, 'ºC'),
	(342790, 144, '2015-02-01 01:16:22.000000', 'temperatura', 873.0000, 'ºC'),
	(342791, 144, '2015-02-01 01:16:23.000000', 'temperatura', 1122.0000, 'ºC'),
	(342792, 144, '2015-02-01 01:16:24.000000', 'temperatura', 592.0000, 'ºC'),
	(342793, 144, '2015-02-01 01:16:25.000000', 'temperatura', 793.0000, 'ºC'),
	(342794, 144, '2015-02-01 01:16:26.000000', 'temperatura', 992.0000, 'ºC'),
	(342795, 144, '2015-02-01 01:16:27.000000', 'temperatura', 183.0000, 'ºC'),
	(342796, 144, '2015-02-01 01:16:28.000000', 'temperatura', 336.0000, 'ºC'),
	(342797, 144, '2015-02-01 01:16:29.000000', 'temperatura', 1134.0000, 'ºC'),
	(342798, 144, '2015-02-01 01:16:30.000000', 'temperatura', 1063.0000, 'ºC'),
	(342799, 144, '2015-02-01 01:16:31.000000', 'temperatura', 711.0000, 'ºC'),
	(342800, 144, '2015-02-01 01:16:32.000000', 'temperatura', 367.0000, 'ºC'),
	(342801, 144, '2015-02-01 01:16:33.000000', 'temperatura', 901.0000, 'ºC'),
	(342802, 144, '2015-02-01 01:16:34.000000', 'temperatura', 1008.0000, 'ºC'),
	(342803, 144, '2015-02-01 01:16:35.000000', 'temperatura', 1134.0000, 'ºC'),
	(342804, 144, '2015-02-01 01:16:36.000000', 'temperatura', 249.0000, 'ºC'),
	(342805, 144, '2015-02-01 01:16:37.000000', 'temperatura', 245.0000, 'ºC'),
	(342806, 144, '2015-02-01 01:16:38.000000', 'temperatura', 475.0000, 'ºC'),
	(342807, 144, '2015-02-01 01:16:39.000000', 'temperatura', 441.0000, 'ºC'),
	(342808, 144, '2015-02-01 01:16:40.000000', 'temperatura', 782.0000, 'ºC'),
	(342809, 144, '2015-02-01 01:16:41.000000', 'temperatura', 189.0000, 'ºC'),
	(342810, 144, '2015-02-01 01:16:42.000000', 'temperatura', 996.0000, 'ºC'),
	(342811, 144, '2015-02-01 01:16:43.000000', 'temperatura', 816.0000, 'ºC'),
	(342812, 144, '2015-02-01 01:16:44.000000', 'temperatura', 1093.0000, 'ºC'),
	(342813, 144, '2015-02-01 01:16:45.000000', 'temperatura', 617.0000, 'ºC'),
	(342814, 144, '2015-02-01 01:16:46.000000', 'temperatura', 1006.0000, 'ºC'),
	(342815, 144, '2015-02-01 01:16:47.000000', 'temperatura', 782.0000, 'ºC'),
	(342816, 144, '2015-02-01 01:16:48.000000', 'temperatura', 890.0000, 'ºC'),
	(342817, 144, '2015-02-01 01:16:49.000000', 'temperatura', 905.0000, 'ºC'),
	(342818, 144, '2015-02-01 01:16:50.000000', 'temperatura', 654.0000, 'ºC'),
	(342819, 144, '2015-02-01 01:16:51.000000', 'temperatura', 556.0000, 'ºC'),
	(342820, 144, '2015-02-01 01:16:52.000000', 'temperatura', 817.0000, 'ºC'),
	(342821, 144, '2015-02-01 01:16:53.000000', 'temperatura', 20.0000, 'ºC'),
	(342822, 144, '2015-02-01 01:16:54.000000', 'temperatura', 49.0000, 'ºC'),
	(342823, 144, '2015-02-01 01:16:55.000000', 'temperatura', 186.0000, 'ºC'),
	(342824, 144, '2015-02-01 01:16:56.000000', 'temperatura', 783.0000, 'ºC'),
	(342825, 144, '2015-02-01 01:16:57.000000', 'temperatura', 957.0000, 'ºC'),
	(342826, 144, '2015-02-01 01:16:58.000000', 'temperatura', 39.0000, 'ºC'),
	(342827, 144, '2015-02-01 01:16:59.000000', 'temperatura', 922.0000, 'ºC'),
	(342828, 144, '2015-02-01 01:17:00.000000', 'temperatura', 895.0000, 'ºC'),
	(342829, 144, '2015-02-01 01:17:01.000000', 'temperatura', 509.0000, 'ºC'),
	(342830, 144, '2015-02-01 01:17:02.000000', 'temperatura', 1061.0000, 'ºC'),
	(342831, 144, '2015-02-01 01:17:03.000000', 'temperatura', 178.0000, 'ºC'),
	(342832, 144, '2015-02-01 01:17:04.000000', 'temperatura', 109.0000, 'ºC'),
	(342833, 144, '2015-02-01 01:17:05.000000', 'temperatura', 11.0000, 'ºC'),
	(342834, 144, '2015-02-01 01:17:06.000000', 'temperatura', 929.0000, 'ºC'),
	(342835, 144, '2015-02-01 01:17:07.000000', 'temperatura', 1012.0000, 'ºC'),
	(342836, 144, '2015-02-01 01:17:08.000000', 'temperatura', 1073.0000, 'ºC'),
	(342837, 144, '2015-02-01 01:17:09.000000', 'temperatura', 1131.0000, 'ºC'),
	(342838, 144, '2015-02-01 01:17:10.000000', 'temperatura', 35.0000, 'ºC'),
	(342839, 144, '2015-02-01 01:17:11.000000', 'temperatura', 382.0000, 'ºC'),
	(342840, 144, '2015-02-01 01:17:12.000000', 'temperatura', 605.0000, 'ºC'),
	(342841, 144, '2015-02-01 01:17:13.000000', 'temperatura', 681.0000, 'ºC'),
	(342842, 144, '2015-02-01 01:17:14.000000', 'temperatura', 391.0000, 'ºC'),
	(342843, 144, '2015-02-01 01:17:15.000000', 'temperatura', 1110.0000, 'ºC'),
	(342844, 144, '2015-02-01 01:17:16.000000', 'temperatura', 780.0000, 'ºC'),
	(342845, 144, '2015-02-01 01:17:17.000000', 'temperatura', 571.0000, 'ºC'),
	(342846, 144, '2015-02-01 01:17:18.000000', 'temperatura', 515.0000, 'ºC'),
	(342847, 144, '2015-02-01 01:17:19.000000', 'temperatura', 862.0000, 'ºC'),
	(342848, 144, '2015-02-01 01:17:20.000000', 'temperatura', 364.0000, 'ºC'),
	(342849, 144, '2015-02-01 01:17:21.000000', 'temperatura', 435.0000, 'ºC'),
	(342850, 144, '2015-02-01 01:17:22.000000', 'temperatura', 1086.0000, 'ºC'),
	(342851, 144, '2015-02-01 01:17:23.000000', 'temperatura', 523.0000, 'ºC'),
	(342852, 144, '2015-02-01 01:17:24.000000', 'temperatura', 557.0000, 'ºC'),
	(342853, 144, '2015-02-01 01:17:25.000000', 'temperatura', 17.0000, 'ºC'),
	(342854, 144, '2015-02-01 01:17:26.000000', 'temperatura', 815.0000, 'ºC'),
	(342855, 144, '2015-02-01 01:17:27.000000', 'temperatura', 426.0000, 'ºC'),
	(342856, 144, '2015-02-01 01:17:28.000000', 'temperatura', 884.0000, 'ºC'),
	(342857, 144, '2015-02-01 01:17:29.000000', 'temperatura', 742.0000, 'ºC'),
	(342858, 144, '2015-02-01 01:17:30.000000', 'temperatura', 1059.0000, 'ºC'),
	(342859, 144, '2015-02-01 01:17:31.000000', 'temperatura', 670.0000, 'ºC'),
	(342860, 144, '2015-02-01 01:17:32.000000', 'temperatura', 172.0000, 'ºC'),
	(342861, 144, '2015-02-01 01:17:33.000000', 'temperatura', 52.0000, 'ºC'),
	(342862, 144, '2015-02-01 01:17:34.000000', 'temperatura', 945.0000, 'ºC'),
	(342863, 144, '2015-02-01 01:17:35.000000', 'temperatura', 970.0000, 'ºC'),
	(342864, 144, '2015-02-01 01:17:36.000000', 'temperatura', 814.0000, 'ºC'),
	(342865, 144, '2015-02-01 01:17:37.000000', 'temperatura', 1159.0000, 'ºC'),
	(342866, 144, '2015-02-01 01:17:38.000000', 'temperatura', 957.0000, 'ºC'),
	(342867, 144, '2015-02-01 01:17:39.000000', 'temperatura', 105.0000, 'ºC'),
	(342868, 144, '2015-02-01 01:17:40.000000', 'temperatura', 56.0000, 'ºC'),
	(342869, 144, '2015-02-01 01:17:41.000000', 'temperatura', 1166.0000, 'ºC'),
	(342870, 144, '2015-02-01 01:17:42.000000', 'temperatura', 861.0000, 'ºC'),
	(342871, 144, '2015-02-01 01:17:43.000000', 'temperatura', 810.0000, 'ºC'),
	(342872, 144, '2015-02-01 01:17:44.000000', 'temperatura', 267.0000, 'ºC'),
	(342873, 144, '2015-02-01 01:17:45.000000', 'temperatura', 106.0000, 'ºC'),
	(342874, 144, '2015-02-01 01:17:46.000000', 'temperatura', 927.0000, 'ºC'),
	(342875, 144, '2015-02-01 01:17:47.000000', 'temperatura', 720.0000, 'ºC'),
	(342876, 144, '2015-02-01 01:17:48.000000', 'temperatura', 819.0000, 'ºC'),
	(342877, 144, '2015-02-01 01:17:49.000000', 'temperatura', 735.0000, 'ºC'),
	(342878, 144, '2015-02-01 01:17:50.000000', 'temperatura', 17.0000, 'ºC'),
	(342879, 144, '2015-02-01 01:17:51.000000', 'temperatura', 282.0000, 'ºC'),
	(342880, 144, '2015-02-01 01:17:52.000000', 'temperatura', 159.0000, 'ºC'),
	(342881, 144, '2015-02-01 01:17:53.000000', 'temperatura', 1152.0000, 'ºC'),
	(342882, 144, '2015-02-01 01:17:54.000000', 'temperatura', 480.0000, 'ºC'),
	(342883, 144, '2015-02-01 01:17:55.000000', 'temperatura', 147.0000, 'ºC'),
	(342884, 144, '2015-02-01 01:17:56.000000', 'temperatura', 495.0000, 'ºC'),
	(342885, 144, '2015-02-01 01:17:57.000000', 'temperatura', 834.0000, 'ºC'),
	(342886, 144, '2015-02-01 01:17:58.000000', 'temperatura', 284.0000, 'ºC'),
	(342887, 144, '2015-02-01 01:17:59.000000', 'temperatura', 119.0000, 'ºC'),
	(342888, 144, '2015-02-01 01:18:00.000000', 'temperatura', 943.0000, 'ºC'),
	(342889, 144, '2015-02-01 01:18:01.000000', 'temperatura', 760.0000, 'ºC'),
	(342890, 144, '2015-02-01 01:18:02.000000', 'temperatura', 973.0000, 'ºC'),
	(342891, 144, '2015-02-01 01:18:03.000000', 'temperatura', 184.0000, 'ºC'),
	(342892, 144, '2015-02-01 01:18:04.000000', 'temperatura', 402.0000, 'ºC'),
	(342893, 144, '2015-02-01 01:18:05.000000', 'temperatura', 259.0000, 'ºC'),
	(342894, 144, '2015-02-01 01:18:06.000000', 'temperatura', 88.0000, 'ºC'),
	(342895, 144, '2015-02-01 01:18:07.000000', 'temperatura', 864.0000, 'ºC'),
	(342896, 144, '2015-02-01 01:18:08.000000', 'temperatura', 457.0000, 'ºC'),
	(342897, 144, '2015-02-01 01:18:09.000000', 'temperatura', 892.0000, 'ºC'),
	(342898, 144, '2015-02-01 01:18:10.000000', 'temperatura', 690.0000, 'ºC'),
	(342899, 144, '2015-02-01 01:18:11.000000', 'temperatura', 773.0000, 'ºC'),
	(342900, 144, '2015-02-01 01:18:12.000000', 'temperatura', 599.0000, 'ºC'),
	(342901, 144, '2015-02-01 01:18:13.000000', 'temperatura', 673.0000, 'ºC'),
	(342902, 144, '2015-02-01 01:18:14.000000', 'temperatura', 369.0000, 'ºC'),
	(342903, 144, '2015-02-01 01:18:15.000000', 'temperatura', 1028.0000, 'ºC'),
	(342904, 144, '2015-02-01 01:18:16.000000', 'temperatura', 435.0000, 'ºC'),
	(342905, 144, '2015-02-01 01:18:17.000000', 'temperatura', 290.0000, 'ºC'),
	(342906, 144, '2015-02-01 01:18:18.000000', 'temperatura', 145.0000, 'ºC'),
	(342907, 144, '2015-02-01 01:18:19.000000', 'temperatura', 1056.0000, 'ºC'),
	(342908, 144, '2015-02-01 01:18:20.000000', 'temperatura', 47.0000, 'ºC'),
	(342909, 144, '2015-02-01 01:18:21.000000', 'temperatura', 667.0000, 'ºC'),
	(342910, 144, '2015-02-01 01:18:22.000000', 'temperatura', 793.0000, 'ºC'),
	(342911, 144, '2015-02-01 01:18:23.000000', 'temperatura', 765.0000, 'ºC'),
	(342912, 144, '2015-02-01 01:18:24.000000', 'temperatura', 246.0000, 'ºC'),
	(342913, 144, '2015-02-01 01:18:25.000000', 'temperatura', 137.0000, 'ºC'),
	(342914, 144, '2015-02-01 01:18:26.000000', 'temperatura', 1148.0000, 'ºC'),
	(342915, 144, '2015-02-01 01:18:27.000000', 'temperatura', 529.0000, 'ºC'),
	(342916, 144, '2015-02-01 01:18:28.000000', 'temperatura', 402.0000, 'ºC'),
	(342917, 144, '2015-02-01 01:18:29.000000', 'temperatura', 422.0000, 'ºC'),
	(342918, 144, '2015-02-01 01:18:30.000000', 'temperatura', 905.0000, 'ºC'),
	(342919, 144, '2015-02-01 01:18:31.000000', 'temperatura', 861.0000, 'ºC'),
	(342920, 144, '2015-02-01 01:18:32.000000', 'temperatura', 389.0000, 'ºC'),
	(342921, 144, '2015-02-01 01:18:33.000000', 'temperatura', 563.0000, 'ºC'),
	(342922, 144, '2015-02-01 01:18:34.000000', 'temperatura', 447.0000, 'ºC'),
	(342923, 144, '2015-02-01 01:18:35.000000', 'temperatura', 547.0000, 'ºC'),
	(342924, 144, '2015-02-01 01:18:36.000000', 'temperatura', 193.0000, 'ºC'),
	(342925, 144, '2015-02-01 01:18:37.000000', 'temperatura', 527.0000, 'ºC'),
	(342926, 144, '2015-02-01 01:18:38.000000', 'temperatura', 856.0000, 'ºC'),
	(342927, 144, '2015-02-01 01:18:39.000000', 'temperatura', 299.0000, 'ºC'),
	(342928, 144, '2015-02-01 01:18:40.000000', 'temperatura', 129.0000, 'ºC'),
	(342929, 144, '2015-02-01 01:18:41.000000', 'temperatura', 950.0000, 'ºC'),
	(342930, 144, '2015-02-01 01:18:42.000000', 'temperatura', 760.0000, 'ºC'),
	(342931, 144, '2015-02-01 01:18:43.000000', 'temperatura', 953.0000, 'ºC'),
	(342932, 144, '2015-02-01 01:18:44.000000', 'temperatura', 83.0000, 'ºC'),
	(342933, 144, '2015-02-01 01:18:45.000000', 'temperatura', 1158.0000, 'ºC'),
	(342934, 144, '2015-02-01 01:18:46.000000', 'temperatura', 741.0000, 'ºC'),
	(342935, 144, '2015-02-01 01:18:47.000000', 'temperatura', 233.0000, 'ºC'),
	(342936, 144, '2015-02-01 01:18:48.000000', 'temperatura', 143.0000, 'ºC'),
	(342937, 144, '2015-02-01 01:18:49.000000', 'temperatura', 16.0000, 'ºC'),
	(342938, 144, '2015-02-01 01:18:50.000000', 'temperatura', 849.0000, 'ºC'),
	(342939, 144, '2015-02-01 01:18:51.000000', 'temperatura', 601.0000, 'ºC'),
	(342940, 144, '2015-02-01 01:18:52.000000', 'temperatura', 457.0000, 'ºC'),
	(342941, 144, '2015-02-01 01:18:53.000000', 'temperatura', 483.0000, 'ºC'),
	(342942, 144, '2015-02-01 01:18:54.000000', 'temperatura', 1044.0000, 'ºC'),
	(342943, 144, '2015-02-01 01:18:55.000000', 'temperatura', 171.0000, 'ºC'),
	(342944, 144, '2015-02-01 01:18:56.000000', 'temperatura', 123.0000, 'ºC'),
	(342945, 144, '2015-02-01 01:18:57.000000', 'temperatura', 102.0000, 'ºC'),
	(342946, 144, '2015-02-01 01:18:58.000000', 'temperatura', 144.0000, 'ºC'),
	(342947, 144, '2015-02-01 01:18:59.000000', 'temperatura', 414.0000, 'ºC'),
	(342948, 144, '2015-02-01 01:19:00.000000', 'temperatura', 439.0000, 'ºC'),
	(342949, 144, '2015-02-01 01:19:01.000000', 'temperatura', 955.0000, 'ºC'),
	(342950, 144, '2015-02-01 01:19:02.000000', 'temperatura', 1056.0000, 'ºC'),
	(342951, 144, '2015-02-01 01:19:03.000000', 'temperatura', 18.0000, 'ºC'),
	(342952, 144, '2015-02-01 01:19:04.000000', 'temperatura', 519.0000, 'ºC'),
	(342953, 144, '2015-02-01 01:19:05.000000', 'temperatura', 144.0000, 'ºC'),
	(342954, 144, '2015-02-01 01:19:06.000000', 'temperatura', 364.0000, 'ºC'),
	(342955, 144, '2015-02-01 01:19:07.000000', 'temperatura', 187.0000, 'ºC'),
	(342956, 144, '2015-02-01 01:19:08.000000', 'temperatura', 1045.0000, 'ºC'),
	(342957, 144, '2015-02-01 01:19:09.000000', 'temperatura', 1062.0000, 'ºC'),
	(342958, 144, '2015-02-01 01:19:10.000000', 'temperatura', 979.0000, 'ºC'),
	(342959, 144, '2015-02-01 01:19:11.000000', 'temperatura', 506.0000, 'ºC'),
	(342960, 144, '2015-02-01 01:19:12.000000', 'temperatura', 797.0000, 'ºC'),
	(342961, 144, '2015-02-01 01:19:13.000000', 'temperatura', 65.0000, 'ºC'),
	(342962, 144, '2015-02-01 01:19:14.000000', 'temperatura', 336.0000, 'ºC'),
	(342963, 144, '2015-02-01 01:19:15.000000', 'temperatura', 284.0000, 'ºC'),
	(342964, 144, '2015-02-01 01:19:16.000000', 'temperatura', 413.0000, 'ºC'),
	(342965, 144, '2015-02-01 01:19:17.000000', 'temperatura', 15.0000, 'ºC'),
	(342966, 144, '2015-02-01 01:19:18.000000', 'temperatura', 37.0000, 'ºC'),
	(342967, 144, '2015-02-01 01:19:19.000000', 'temperatura', 139.0000, 'ºC'),
	(342968, 144, '2015-02-01 01:19:20.000000', 'temperatura', 585.0000, 'ºC'),
	(342969, 144, '2015-02-01 01:19:21.000000', 'temperatura', 108.0000, 'ºC'),
	(342970, 144, '2015-02-01 01:19:22.000000', 'temperatura', 1187.0000, 'ºC'),
	(342971, 144, '2015-02-01 01:19:23.000000', 'temperatura', 810.0000, 'ºC'),
	(342972, 144, '2015-02-01 01:19:24.000000', 'temperatura', 488.0000, 'ºC'),
	(342973, 144, '2015-02-01 01:19:25.000000', 'temperatura', 12.0000, 'ºC'),
	(342974, 144, '2015-02-01 01:19:26.000000', 'temperatura', 998.0000, 'ºC'),
	(342975, 144, '2015-02-01 01:19:27.000000', 'temperatura', 153.0000, 'ºC'),
	(342976, 144, '2015-02-01 01:19:28.000000', 'temperatura', 171.0000, 'ºC'),
	(342977, 144, '2015-02-01 01:19:29.000000', 'temperatura', 395.0000, 'ºC'),
	(342978, 144, '2015-02-01 01:19:30.000000', 'temperatura', 264.0000, 'ºC'),
	(342979, 144, '2015-02-01 01:19:31.000000', 'temperatura', 134.0000, 'ºC'),
	(342980, 144, '2015-02-01 01:19:32.000000', 'temperatura', 1081.0000, 'ºC'),
	(342981, 144, '2015-02-01 01:19:33.000000', 'temperatura', 204.0000, 'ºC'),
	(342982, 144, '2015-02-01 01:19:34.000000', 'temperatura', 178.0000, 'ºC'),
	(342983, 144, '2015-02-01 01:19:35.000000', 'temperatura', 279.0000, 'ºC'),
	(342984, 144, '2015-02-01 01:19:36.000000', 'temperatura', 861.0000, 'ºC'),
	(342985, 144, '2015-02-01 01:19:37.000000', 'temperatura', 1067.0000, 'ºC'),
	(342986, 144, '2015-02-01 01:19:38.000000', 'temperatura', 352.0000, 'ºC'),
	(342987, 144, '2015-02-01 01:19:39.000000', 'temperatura', 961.0000, 'ºC'),
	(342988, 144, '2015-02-01 01:19:40.000000', 'temperatura', 149.0000, 'ºC'),
	(342989, 144, '2015-02-01 01:19:41.000000', 'temperatura', 262.0000, 'ºC'),
	(342990, 144, '2015-02-01 01:19:42.000000', 'temperatura', 865.0000, 'ºC'),
	(342991, 144, '2015-02-01 01:19:43.000000', 'temperatura', 1138.0000, 'ºC'),
	(342992, 144, '2015-02-01 01:19:44.000000', 'temperatura', 697.0000, 'ºC'),
	(342993, 144, '2015-02-01 01:19:45.000000', 'temperatura', 69.0000, 'ºC'),
	(342994, 144, '2015-02-01 01:19:46.000000', 'temperatura', 656.0000, 'ºC'),
	(342995, 144, '2015-02-01 01:19:47.000000', 'temperatura', 675.0000, 'ºC'),
	(342996, 144, '2015-02-01 01:19:48.000000', 'temperatura', 208.0000, 'ºC'),
	(342997, 144, '2015-02-01 01:19:49.000000', 'temperatura', 215.0000, 'ºC'),
	(342998, 144, '2015-02-01 01:19:50.000000', 'temperatura', 451.0000, 'ºC'),
	(342999, 144, '2015-02-01 01:19:51.000000', 'temperatura', 412.0000, 'ºC'),
	(343000, 144, '2015-02-01 01:19:52.000000', 'temperatura', 706.0000, 'ºC'),
	(343001, 144, '2015-02-01 01:19:53.000000', 'temperatura', 1093.0000, 'ºC'),
	(343002, 144, '2015-02-01 01:19:54.000000', 'temperatura', 948.0000, 'ºC'),
	(343003, 144, '2015-02-01 01:19:55.000000', 'temperatura', 262.0000, 'ºC'),
	(343004, 144, '2015-02-01 01:19:56.000000', 'temperatura', 867.0000, 'ºC'),
	(343005, 144, '2015-02-01 01:19:57.000000', 'temperatura', 1151.0000, 'ºC'),
	(343006, 144, '2015-02-01 01:19:58.000000', 'temperatura', 753.0000, 'ºC'),
	(343007, 144, '2015-02-01 01:19:59.000000', 'temperatura', 314.0000, 'ºC'),
	(343008, 144, '2015-02-01 01:20:00.000000', 'temperatura', 511.0000, 'ºC'),
	(343009, 144, '2015-02-01 01:20:01.000000', 'temperatura', 412.0000, 'ºC'),
	(343010, 144, '2015-02-01 01:20:02.000000', 'temperatura', 527.0000, 'ºC'),
	(343011, 144, '2015-02-01 01:20:03.000000', 'temperatura', 199.0000, 'ºC'),
	(343012, 144, '2015-02-01 01:20:04.000000', 'temperatura', 614.0000, 'ºC'),
	(343013, 144, '2015-02-01 01:20:05.000000', 'temperatura', 76.0000, 'ºC'),
	(343014, 144, '2015-02-01 01:20:06.000000', 'temperatura', 936.0000, 'ºC'),
	(343015, 144, '2015-02-01 01:20:07.000000', 'temperatura', 856.0000, 'ºC'),
	(343016, 144, '2015-02-01 01:20:08.000000', 'temperatura', 269.0000, 'ºC'),
	(343017, 144, '2015-02-01 01:20:09.000000', 'temperatura', 1179.0000, 'ºC'),
	(343018, 144, '2015-02-01 01:20:10.000000', 'temperatura', 288.0000, 'ºC'),
	(343019, 144, '2015-02-01 01:20:11.000000', 'temperatura', 302.0000, 'ºC'),
	(343020, 144, '2015-02-01 01:20:12.000000', 'temperatura', 650.0000, 'ºC'),
	(343021, 144, '2015-02-01 01:20:13.000000', 'temperatura', 1142.0000, 'ºC'),
	(343022, 144, '2015-02-01 01:20:14.000000', 'temperatura', 162.0000, 'ºC'),
	(343023, 144, '2015-02-01 01:20:15.000000', 'temperatura', 983.0000, 'ºC'),
	(343024, 144, '2015-02-01 01:20:16.000000', 'temperatura', 832.0000, 'ºC'),
	(343025, 144, '2015-02-01 01:20:17.000000', 'temperatura', 10.0000, 'ºC'),
	(343026, 144, '2015-02-01 01:20:18.000000', 'temperatura', 1153.0000, 'ºC'),
	(343027, 144, '2015-02-01 01:20:19.000000', 'temperatura', 936.0000, 'ºC'),
	(343028, 144, '2015-02-01 01:20:20.000000', 'temperatura', 22.0000, 'ºC'),
	(343029, 144, '2015-02-01 01:20:21.000000', 'temperatura', 904.0000, 'ºC'),
	(343030, 144, '2015-02-01 01:20:22.000000', 'temperatura', 855.0000, 'ºC'),
	(343031, 144, '2015-02-01 01:20:23.000000', 'temperatura', 364.0000, 'ºC'),
	(343032, 144, '2015-02-01 01:20:24.000000', 'temperatura', 454.0000, 'ºC'),
	(343033, 144, '2015-02-01 01:20:25.000000', 'temperatura', 1180.0000, 'ºC'),
	(343034, 144, '2015-02-01 01:20:26.000000', 'temperatura', 940.0000, 'ºC'),
	(343035, 144, '2015-02-01 01:20:27.000000', 'temperatura', 1157.0000, 'ºC'),
	(343036, 144, '2015-02-01 01:20:28.000000', 'temperatura', 566.0000, 'ºC'),
	(343037, 144, '2015-02-01 01:20:29.000000', 'temperatura', 559.0000, 'ºC'),
	(343038, 144, '2015-02-01 01:20:30.000000', 'temperatura', 1099.0000, 'ºC'),
	(343039, 144, '2015-02-01 01:20:31.000000', 'temperatura', 219.0000, 'ºC'),
	(343040, 144, '2015-02-01 01:20:32.000000', 'temperatura', 199.0000, 'ºC'),
	(343041, 144, '2015-02-01 01:20:33.000000', 'temperatura', 339.0000, 'ºC'),
	(343042, 144, '2015-02-01 01:20:34.000000', 'temperatura', 1098.0000, 'ºC'),
	(343043, 144, '2015-02-01 01:20:35.000000', 'temperatura', 872.0000, 'ºC'),
	(343044, 144, '2015-02-01 01:20:36.000000', 'temperatura', 1066.0000, 'ºC'),
	(343045, 144, '2015-02-01 01:20:37.000000', 'temperatura', 317.0000, 'ºC'),
	(343046, 144, '2015-02-01 01:20:38.000000', 'temperatura', 786.0000, 'ºC'),
	(343047, 144, '2015-02-01 01:20:39.000000', 'temperatura', 581.0000, 'ºC'),
	(343048, 144, '2015-02-01 01:20:40.000000', 'temperatura', 549.0000, 'ºC'),
	(343049, 144, '2015-02-01 01:20:41.000000', 'temperatura', 1000.0000, 'ºC'),
	(343050, 144, '2015-02-01 01:20:42.000000', 'temperatura', 954.0000, 'ºC'),
	(343051, 144, '2015-02-01 01:20:43.000000', 'temperatura', 569.0000, 'ºC'),
	(343052, 144, '2015-02-01 01:20:44.000000', 'temperatura', 1186.0000, 'ºC'),
	(343053, 144, '2015-02-01 01:20:45.000000', 'temperatura', 622.0000, 'ºC'),
	(343054, 144, '2015-02-01 01:20:46.000000', 'temperatura', 752.0000, 'ºC'),
	(343055, 144, '2015-02-01 01:20:47.000000', 'temperatura', 694.0000, 'ºC'),
	(343056, 144, '2015-02-01 01:20:48.000000', 'temperatura', 16.0000, 'ºC'),
	(343057, 144, '2015-02-01 01:20:49.000000', 'temperatura', 397.0000, 'ºC'),
	(343058, 144, '2015-02-01 01:20:50.000000', 'temperatura', 738.0000, 'ºC'),
	(343059, 144, '2015-02-01 01:20:51.000000', 'temperatura', 100.0000, 'ºC'),
	(343060, 144, '2015-02-01 01:20:52.000000', 'temperatura', 686.0000, 'ºC'),
	(343061, 144, '2015-02-01 01:20:53.000000', 'temperatura', 731.0000, 'ºC'),
	(343062, 144, '2015-02-01 01:20:54.000000', 'temperatura', 397.0000, 'ºC'),
	(343063, 144, '2015-02-01 01:20:55.000000', 'temperatura', 994.0000, 'ºC'),
	(343064, 144, '2015-02-01 01:20:56.000000', 'temperatura', 179.0000, 'ºC'),
	(343065, 144, '2015-02-01 01:20:57.000000', 'temperatura', 314.0000, 'ºC'),
	(343066, 144, '2015-02-01 01:20:58.000000', 'temperatura', 1032.0000, 'ºC'),
	(343067, 144, '2015-02-01 01:20:59.000000', 'temperatura', 619.0000, 'ºC'),
	(343068, 144, '2015-02-01 01:21:00.000000', 'temperatura', 1198.0000, 'ºC'),
	(343069, 144, '2015-02-01 01:21:01.000000', 'temperatura', 534.0000, 'ºC'),
	(343070, 144, '2015-02-01 01:21:02.000000', 'temperatura', 276.0000, 'ºC'),
	(343071, 144, '2015-02-01 01:21:03.000000', 'temperatura', 981.0000, 'ºC'),
	(343072, 144, '2015-02-01 01:21:04.000000', 'temperatura', 475.0000, 'ºC'),
	(343073, 144, '2015-02-01 01:21:05.000000', 'temperatura', 633.0000, 'ºC'),
	(343074, 144, '2015-02-01 01:21:06.000000', 'temperatura', 541.0000, 'ºC'),
	(343075, 144, '2015-02-01 01:21:07.000000', 'temperatura', 805.0000, 'ºC'),
	(343076, 144, '2015-02-01 01:21:08.000000', 'temperatura', 3.0000, 'ºC'),
	(343077, 144, '2015-02-01 01:21:09.000000', 'temperatura', 0.0000, 'ºC'),
	(343078, 144, '2015-02-01 01:21:10.000000', 'temperatura', 1191.0000, 'ºC'),
	(343079, 144, '2015-02-01 01:21:11.000000', 'temperatura', 1155.0000, 'ºC'),
	(343080, 144, '2015-02-01 01:21:12.000000', 'temperatura', 1002.0000, 'ºC'),
	(343081, 144, '2015-02-01 01:21:13.000000', 'temperatura', 347.0000, 'ºC'),
	(343082, 144, '2015-02-01 01:21:14.000000', 'temperatura', 1129.0000, 'ºC'),
	(343083, 144, '2015-02-01 01:21:15.000000', 'temperatura', 1005.0000, 'ºC'),
	(343084, 144, '2015-02-01 01:21:16.000000', 'temperatura', 437.0000, 'ºC'),
	(343085, 144, '2015-02-01 01:21:17.000000', 'temperatura', 371.0000, 'ºC'),
	(343086, 144, '2015-02-01 01:21:18.000000', 'temperatura', 544.0000, 'ºC'),
	(343087, 144, '2015-02-01 01:21:19.000000', 'temperatura', 407.0000, 'ºC'),
	(343088, 144, '2015-02-01 01:21:20.000000', 'temperatura', 403.0000, 'ºC'),
	(343089, 144, '2015-02-01 01:21:21.000000', 'temperatura', 794.0000, 'ºC'),
	(343090, 144, '2015-02-01 01:21:22.000000', 'temperatura', 362.0000, 'ºC'),
	(343091, 144, '2015-02-01 01:21:23.000000', 'temperatura', 630.0000, 'ºC'),
	(343092, 144, '2015-02-01 01:21:24.000000', 'temperatura', 863.0000, 'ºC'),
	(343093, 144, '2015-02-01 01:21:25.000000', 'temperatura', 27.0000, 'ºC'),
	(343094, 144, '2015-02-01 01:21:26.000000', 'temperatura', 1147.0000, 'ºC'),
	(343095, 144, '2015-02-01 01:21:27.000000', 'temperatura', 856.0000, 'ºC'),
	(343096, 144, '2015-02-01 01:21:28.000000', 'temperatura', 837.0000, 'ºC'),
	(343097, 144, '2015-02-01 01:21:29.000000', 'temperatura', 417.0000, 'ºC'),
	(343098, 144, '2015-02-01 01:21:30.000000', 'temperatura', 777.0000, 'ºC'),
	(343099, 144, '2015-02-01 01:21:31.000000', 'temperatura', 231.0000, 'ºC'),
	(343100, 144, '2015-02-01 01:21:32.000000', 'temperatura', 27.0000, 'ºC'),
	(343101, 144, '2015-02-01 01:21:33.000000', 'temperatura', 641.0000, 'ºC'),
	(343102, 144, '2015-02-01 01:21:34.000000', 'temperatura', 726.0000, 'ºC'),
	(343103, 144, '2015-02-01 01:21:35.000000', 'temperatura', 509.0000, 'ºC'),
	(343104, 144, '2015-02-01 01:21:36.000000', 'temperatura', 365.0000, 'ºC'),
	(343105, 144, '2015-02-01 01:21:37.000000', 'temperatura', 300.0000, 'ºC'),
	(343106, 144, '2015-02-01 01:21:38.000000', 'temperatura', 406.0000, 'ºC'),
	(343107, 144, '2015-02-01 01:21:39.000000', 'temperatura', 1130.0000, 'ºC'),
	(343108, 144, '2015-02-01 01:21:40.000000', 'temperatura', 832.0000, 'ºC'),
	(343109, 144, '2015-02-01 01:21:41.000000', 'temperatura', 772.0000, 'ºC'),
	(343110, 144, '2015-02-01 01:21:42.000000', 'temperatura', 163.0000, 'ºC'),
	(343111, 144, '2015-02-01 01:21:43.000000', 'temperatura', 898.0000, 'ºC'),
	(343112, 144, '2015-02-01 01:21:44.000000', 'temperatura', 404.0000, 'ºC'),
	(343113, 144, '2015-02-01 01:21:45.000000', 'temperatura', 527.0000, 'ºC'),
	(343114, 144, '2015-02-01 01:21:46.000000', 'temperatura', 222.0000, 'ºC'),
	(343115, 144, '2015-02-01 01:21:47.000000', 'temperatura', 730.0000, 'ºC'),
	(343116, 144, '2015-02-01 01:21:48.000000', 'temperatura', 586.0000, 'ºC'),
	(343117, 144, '2015-02-01 01:21:49.000000', 'temperatura', 738.0000, 'ºC'),
	(343118, 144, '2015-02-01 01:21:50.000000', 'temperatura', 734.0000, 'ºC'),
	(343119, 144, '2015-02-01 01:21:51.000000', 'temperatura', 256.0000, 'ºC'),
	(343120, 144, '2015-02-01 01:21:52.000000', 'temperatura', 278.0000, 'ºC'),
	(343121, 144, '2015-02-01 01:21:53.000000', 'temperatura', 624.0000, 'ºC'),
	(343122, 144, '2015-02-01 01:21:54.000000', 'temperatura', 1084.0000, 'ºC'),
	(343123, 144, '2015-02-01 01:21:55.000000', 'temperatura', 1151.0000, 'ºC'),
	(343124, 144, '2015-02-01 01:21:56.000000', 'temperatura', 102.0000, 'ºC'),
	(343125, 144, '2015-02-01 01:21:57.000000', 'temperatura', 657.0000, 'ºC'),
	(343126, 144, '2015-02-01 01:21:58.000000', 'temperatura', 578.0000, 'ºC'),
	(343127, 144, '2015-02-01 01:21:59.000000', 'temperatura', 922.0000, 'ºC'),
	(343128, 144, '2015-02-01 01:22:00.000000', 'temperatura', 474.0000, 'ºC'),
	(343129, 144, '2015-02-01 01:22:01.000000', 'temperatura', 806.0000, 'ºC'),
	(343130, 144, '2015-02-01 01:22:02.000000', 'temperatura', 209.0000, 'ºC'),
	(343131, 144, '2015-02-01 01:22:03.000000', 'temperatura', 1028.0000, 'ºC'),
	(343132, 144, '2015-02-01 01:22:04.000000', 'temperatura', 914.0000, 'ºC'),
	(343133, 144, '2015-02-01 01:22:05.000000', 'temperatura', 286.0000, 'ºC'),
	(343134, 144, '2015-02-01 01:22:06.000000', 'temperatura', 1088.0000, 'ºC'),
	(343135, 144, '2015-02-01 01:22:07.000000', 'temperatura', 982.0000, 'ºC'),
	(343136, 144, '2015-02-01 01:22:08.000000', 'temperatura', 446.0000, 'ºC'),
	(343137, 144, '2015-02-01 01:22:09.000000', 'temperatura', 486.0000, 'ºC'),
	(343138, 144, '2015-02-01 01:22:10.000000', 'temperatura', 1090.0000, 'ºC'),
	(343139, 144, '2015-02-01 01:22:11.000000', 'temperatura', 396.0000, 'ºC'),
	(343140, 144, '2015-02-01 01:22:12.000000', 'temperatura', 1107.0000, 'ºC'),
	(343141, 144, '2015-02-01 01:22:13.000000', 'temperatura', 749.0000, 'ºC'),
	(343142, 144, '2015-02-01 01:22:14.000000', 'temperatura', 424.0000, 'ºC'),
	(343143, 144, '2015-02-01 01:22:15.000000', 'temperatura', 1076.0000, 'ºC'),
	(343144, 144, '2015-02-01 01:22:16.000000', 'temperatura', 505.0000, 'ºC'),
	(343145, 144, '2015-02-01 01:22:17.000000', 'temperatura', 498.0000, 'ºC'),
	(343146, 144, '2015-02-01 01:22:18.000000', 'temperatura', 978.0000, 'ºC'),
	(343147, 144, '2015-02-01 01:22:19.000000', 'temperatura', 993.0000, 'ºC'),
	(343148, 144, '2015-02-01 01:22:20.000000', 'temperatura', 834.0000, 'ºC'),
	(343149, 144, '2015-02-01 01:22:21.000000', 'temperatura', 1193.0000, 'ºC'),
	(343150, 144, '2015-02-01 01:22:22.000000', 'temperatura', 1061.0000, 'ºC'),
	(343151, 144, '2015-02-01 01:22:23.000000', 'temperatura', 528.0000, 'ºC'),
	(343152, 144, '2015-02-01 01:22:24.000000', 'temperatura', 656.0000, 'ºC'),
	(343153, 144, '2015-02-01 01:22:25.000000', 'temperatura', 496.0000, 'ºC'),
	(343154, 144, '2015-02-01 01:22:26.000000', 'temperatura', 515.0000, 'ºC'),
	(343155, 144, '2015-02-01 01:22:27.000000', 'temperatura', 1086.0000, 'ºC'),
	(343156, 144, '2015-02-01 01:22:28.000000', 'temperatura', 285.0000, 'ºC'),
	(343157, 144, '2015-02-01 01:22:29.000000', 'temperatura', 568.0000, 'ºC'),
	(343158, 144, '2015-02-01 01:22:30.000000', 'temperatura', 786.0000, 'ºC'),
	(343159, 144, '2015-02-01 01:22:31.000000', 'temperatura', 1026.0000, 'ºC'),
	(343160, 144, '2015-02-01 01:22:32.000000', 'temperatura', 372.0000, 'ºC'),
	(343161, 144, '2015-02-01 01:22:33.000000', 'temperatura', 1182.0000, 'ºC'),
	(343162, 144, '2015-02-01 01:22:34.000000', 'temperatura', 1193.0000, 'ºC'),
	(343163, 144, '2015-02-01 01:22:35.000000', 'temperatura', 22.0000, 'ºC'),
	(343164, 144, '2015-02-01 01:22:36.000000', 'temperatura', 129.0000, 'ºC'),
	(343165, 144, '2015-02-01 01:22:37.000000', 'temperatura', 580.0000, 'ºC'),
	(343166, 144, '2015-02-01 01:22:38.000000', 'temperatura', 116.0000, 'ºC'),
	(343167, 144, '2015-02-01 01:22:39.000000', 'temperatura', 38.0000, 'ºC'),
	(343168, 144, '2015-02-01 01:22:40.000000', 'temperatura', 1043.0000, 'ºC'),
	(343169, 144, '2015-02-01 01:22:41.000000', 'temperatura', 303.0000, 'ºC'),
	(343170, 144, '2015-02-01 01:22:42.000000', 'temperatura', 787.0000, 'ºC'),
	(343171, 144, '2015-02-01 01:22:43.000000', 'temperatura', 625.0000, 'ºC'),
	(343172, 144, '2015-02-01 01:22:44.000000', 'temperatura', 766.0000, 'ºC'),
	(343173, 144, '2015-02-01 01:22:45.000000', 'temperatura', 757.0000, 'ºC'),
	(343174, 144, '2015-02-01 01:22:46.000000', 'temperatura', 284.0000, 'ºC'),
	(343175, 144, '2015-02-01 01:22:47.000000', 'temperatura', 353.0000, 'ºC'),
	(343176, 144, '2015-02-01 01:22:48.000000', 'temperatura', 910.0000, 'ºC'),
	(343177, 144, '2015-02-01 01:22:49.000000', 'temperatura', 1093.0000, 'ºC'),
	(343178, 144, '2015-02-01 01:22:50.000000', 'temperatura', 336.0000, 'ºC'),
	(343179, 144, '2015-02-01 01:22:51.000000', 'temperatura', 802.0000, 'ºC'),
	(343180, 144, '2015-02-01 01:22:52.000000', 'temperatura', 601.0000, 'ºC'),
	(343181, 144, '2015-02-01 01:22:53.000000', 'temperatura', 601.0000, 'ºC'),
	(343182, 144, '2015-02-01 01:22:54.000000', 'temperatura', 2.0000, 'ºC'),
	(343183, 144, '2015-02-01 01:22:55.000000', 'temperatura', 609.0000, 'ºC'),
	(343184, 144, '2015-02-01 01:22:56.000000', 'temperatura', 637.0000, 'ºC'),
	(343185, 144, '2015-02-01 01:22:57.000000', 'temperatura', 158.0000, 'ºC'),
	(343186, 144, '2015-02-01 01:22:58.000000', 'temperatura', 81.0000, 'ºC'),
	(343187, 144, '2015-02-01 01:22:59.000000', 'temperatura', 1133.0000, 'ºC'),
	(343188, 144, '2015-02-01 01:23:00.000000', 'temperatura', 619.0000, 'ºC'),
	(343189, 144, '2015-02-01 01:23:01.000000', 'temperatura', 899.0000, 'ºC'),
	(343190, 144, '2015-02-01 01:23:02.000000', 'temperatura', 239.0000, 'ºC'),
	(343191, 144, '2015-02-01 01:23:03.000000', 'temperatura', 897.0000, 'ºC'),
	(343192, 144, '2015-02-01 01:23:04.000000', 'temperatura', 170.0000, 'ºC'),
	(343193, 144, '2015-02-01 01:23:05.000000', 'temperatura', 558.0000, 'ºC'),
	(343194, 144, '2015-02-01 01:23:06.000000', 'temperatura', 1080.0000, 'ºC'),
	(343195, 144, '2015-02-01 01:23:07.000000', 'temperatura', 128.0000, 'ºC'),
	(343196, 144, '2015-02-01 01:23:08.000000', 'temperatura', 1000.0000, 'ºC'),
	(343197, 144, '2015-02-01 01:23:09.000000', 'temperatura', 1016.0000, 'ºC'),
	(343198, 144, '2015-02-01 01:23:10.000000', 'temperatura', 882.0000, 'ºC'),
	(343199, 144, '2015-02-01 01:23:11.000000', 'temperatura', 164.0000, 'ºC'),
	(343200, 144, '2015-02-01 01:23:12.000000', 'temperatura', 571.0000, 'ºC'),
	(343201, 144, '2015-02-01 01:23:13.000000', 'temperatura', 1165.0000, 'ºC'),
	(343202, 144, '2015-02-01 01:23:14.000000', 'temperatura', 513.0000, 'ºC'),
	(343203, 144, '2015-02-01 01:23:15.000000', 'temperatura', 270.0000, 'ºC'),
	(343204, 144, '2015-02-01 01:23:16.000000', 'temperatura', 1010.0000, 'ºC'),
	(343205, 144, '2015-02-01 01:23:17.000000', 'temperatura', 642.0000, 'ºC'),
	(343206, 144, '2015-02-01 01:23:18.000000', 'temperatura', 180.0000, 'ºC'),
	(343207, 144, '2015-02-01 01:23:19.000000', 'temperatura', 177.0000, 'ºC'),
	(343208, 144, '2015-02-01 01:23:20.000000', 'temperatura', 343.0000, 'ºC'),
	(343209, 144, '2015-02-01 01:23:21.000000', 'temperatura', 1184.0000, 'ºC'),
	(343210, 144, '2015-02-01 01:23:22.000000', 'temperatura', 92.0000, 'ºC'),
	(343211, 144, '2015-02-01 01:23:23.000000', 'temperatura', 510.0000, 'ºC'),
	(343212, 144, '2015-02-01 01:23:24.000000', 'temperatura', 1071.0000, 'ºC'),
	(343213, 144, '2015-02-01 01:23:25.000000', 'temperatura', 229.0000, 'ºC'),
	(343214, 144, '2015-02-01 01:23:26.000000', 'temperatura', 332.0000, 'ºC'),
	(343215, 144, '2015-02-01 01:23:27.000000', 'temperatura', 974.0000, 'ºC'),
	(343216, 144, '2015-02-01 01:23:28.000000', 'temperatura', 274.0000, 'ºC'),
	(343217, 144, '2015-02-01 01:23:29.000000', 'temperatura', 847.0000, 'ºC'),
	(343218, 144, '2015-02-01 01:23:30.000000', 'temperatura', 1015.0000, 'ºC'),
	(343219, 144, '2015-02-01 01:23:31.000000', 'temperatura', 134.0000, 'ºC'),
	(343220, 144, '2015-02-01 01:23:32.000000', 'temperatura', 25.0000, 'ºC'),
	(343221, 144, '2015-02-01 01:23:33.000000', 'temperatura', 925.0000, 'ºC'),
	(343222, 144, '2015-02-01 01:23:34.000000', 'temperatura', 951.0000, 'ºC'),
	(343223, 144, '2015-02-01 01:23:35.000000', 'temperatura', 779.0000, 'ºC'),
	(343224, 144, '2015-02-01 01:23:36.000000', 'temperatura', 1041.0000, 'ºC'),
	(343225, 144, '2015-02-01 01:23:37.000000', 'temperatura', 472.0000, 'ºC'),
	(343226, 144, '2015-02-01 01:23:38.000000', 'temperatura', 435.0000, 'ºC'),
	(343227, 144, '2015-02-01 01:23:39.000000', 'temperatura', 760.0000, 'ºC'),
	(343228, 144, '2015-02-01 01:23:40.000000', 'temperatura', 95.0000, 'ºC'),
	(343229, 144, '2015-02-01 01:23:41.000000', 'temperatura', 596.0000, 'ºC'),
	(343230, 144, '2015-02-01 01:23:42.000000', 'temperatura', 294.0000, 'ºC'),
	(343231, 144, '2015-02-01 01:23:43.000000', 'temperatura', 884.0000, 'ºC'),
	(343232, 144, '2015-02-01 01:23:44.000000', 'temperatura', 1138.0000, 'ºC'),
	(343233, 144, '2015-02-01 01:23:45.000000', 'temperatura', 637.0000, 'ºC'),
	(343234, 144, '2015-02-01 01:23:46.000000', 'temperatura', 973.0000, 'ºC'),
	(343235, 144, '2015-02-01 01:23:47.000000', 'temperatura', 555.0000, 'ºC'),
	(343236, 144, '2015-02-01 01:23:48.000000', 'temperatura', 1058.0000, 'ºC'),
	(343237, 144, '2015-02-01 01:23:49.000000', 'temperatura', 24.0000, 'ºC'),
	(343238, 144, '2015-02-01 01:23:50.000000', 'temperatura', 546.0000, 'ºC'),
	(343239, 144, '2015-02-01 01:23:51.000000', 'temperatura', 257.0000, 'ºC'),
	(343240, 144, '2015-02-01 01:23:52.000000', 'temperatura', 849.0000, 'ºC'),
	(343241, 144, '2015-02-01 01:23:53.000000', 'temperatura', 1075.0000, 'ºC'),
	(343242, 144, '2015-02-01 01:23:54.000000', 'temperatura', 427.0000, 'ºC'),
	(343243, 144, '2015-02-01 01:23:55.000000', 'temperatura', 112.0000, 'ºC'),
	(343244, 144, '2015-02-01 01:23:56.000000', 'temperatura', 479.0000, 'ºC'),
	(343245, 144, '2015-02-01 01:23:57.000000', 'temperatura', 861.0000, 'ºC'),
	(343246, 144, '2015-02-01 01:23:58.000000', 'temperatura', 469.0000, 'ºC'),
	(343247, 144, '2015-02-01 01:23:59.000000', 'temperatura', 963.0000, 'ºC'),
	(343248, 144, '2015-02-01 01:24:00.000000', 'temperatura', 1009.0000, 'ºC'),
	(343249, 144, '2015-02-01 01:24:01.000000', 'temperatura', 957.0000, 'ºC'),
	(343250, 144, '2015-02-01 01:24:02.000000', 'temperatura', 558.0000, 'ºC'),
	(343251, 144, '2015-02-01 01:24:03.000000', 'temperatura', 1117.0000, 'ºC'),
	(343252, 144, '2015-02-01 01:24:04.000000', 'temperatura', 314.0000, 'ºC'),
	(343253, 144, '2015-02-01 01:24:05.000000', 'temperatura', 618.0000, 'ºC'),
	(343254, 144, '2015-02-01 01:24:06.000000', 'temperatura', 948.0000, 'ºC'),
	(343255, 144, '2015-02-01 01:24:07.000000', 'temperatura', 486.0000, 'ºC'),
	(343256, 144, '2015-02-01 01:24:08.000000', 'temperatura', 789.0000, 'ºC'),
	(343257, 144, '2015-02-01 01:24:09.000000', 'temperatura', 88.0000, 'ºC'),
	(343258, 144, '2015-02-01 01:24:10.000000', 'temperatura', 473.0000, 'ºC'),
	(343259, 144, '2015-02-01 01:24:11.000000', 'temperatura', 900.0000, 'ºC'),
	(343260, 144, '2015-02-01 01:24:12.000000', 'temperatura', 683.0000, 'ºC'),
	(343261, 144, '2015-02-01 01:24:13.000000', 'temperatura', 714.0000, 'ºC'),
	(343262, 144, '2015-02-01 01:24:14.000000', 'temperatura', 321.0000, 'ºC'),
	(343263, 144, '2015-02-01 01:24:15.000000', 'temperatura', 663.0000, 'ºC'),
	(343264, 144, '2015-02-01 01:24:16.000000', 'temperatura', 1155.0000, 'ºC'),
	(343265, 144, '2015-02-01 01:24:17.000000', 'temperatura', 184.0000, 'ºC'),
	(343266, 144, '2015-02-01 01:24:18.000000', 'temperatura', 1057.0000, 'ºC'),
	(343267, 144, '2015-02-01 01:24:19.000000', 'temperatura', 1134.0000, 'ºC'),
	(343268, 144, '2015-02-01 01:24:20.000000', 'temperatura', 98.0000, 'ºC'),
	(343269, 144, '2015-02-01 01:24:21.000000', 'temperatura', 690.0000, 'ºC'),
	(343270, 144, '2015-02-01 01:24:22.000000', 'temperatura', 756.0000, 'ºC'),
	(343271, 144, '2015-02-01 01:24:23.000000', 'temperatura', 512.0000, 'ºC'),
	(343272, 144, '2015-02-01 01:24:24.000000', 'temperatura', 291.0000, 'ºC'),
	(343273, 144, '2015-02-01 01:24:25.000000', 'temperatura', 1119.0000, 'ºC'),
	(343274, 144, '2015-02-01 01:24:26.000000', 'temperatura', 1123.0000, 'ºC'),
	(343275, 144, '2015-02-01 01:24:27.000000', 'temperatura', 1060.0000, 'ºC'),
	(343276, 144, '2015-02-01 01:24:28.000000', 'temperatura', 729.0000, 'ºC'),
	(343277, 144, '2015-02-01 01:24:29.000000', 'temperatura', 467.0000, 'ºC'),
	(343278, 144, '2015-02-01 01:24:30.000000', 'temperatura', 146.0000, 'ºC'),
	(343279, 144, '2015-02-01 01:24:31.000000', 'temperatura', 533.0000, 'ºC'),
	(343280, 144, '2015-02-01 01:24:32.000000', 'temperatura', 1027.0000, 'ºC'),
	(343281, 144, '2015-02-01 01:24:33.000000', 'temperatura', 1134.0000, 'ºC'),
	(343282, 144, '2015-02-01 01:24:34.000000', 'temperatura', 192.0000, 'ºC'),
	(343283, 144, '2015-02-01 01:24:35.000000', 'temperatura', 1156.0000, 'ºC'),
	(343284, 144, '2015-02-01 01:24:36.000000', 'temperatura', 406.0000, 'ºC'),
	(343285, 144, '2015-02-01 01:24:37.000000', 'temperatura', 961.0000, 'ºC'),
	(343286, 144, '2015-02-01 01:24:38.000000', 'temperatura', 1188.0000, 'ºC'),
	(343287, 144, '2015-02-01 01:24:39.000000', 'temperatura', 659.0000, 'ºC'),
	(343288, 144, '2015-02-01 01:24:40.000000', 'temperatura', 929.0000, 'ºC'),
	(343289, 144, '2015-02-01 01:24:41.000000', 'temperatura', 271.0000, 'ºC'),
	(343290, 144, '2015-02-01 01:24:42.000000', 'temperatura', 969.0000, 'ºC'),
	(343291, 144, '2015-02-01 01:24:43.000000', 'temperatura', 433.0000, 'ºC'),
	(343292, 144, '2015-02-01 01:24:44.000000', 'temperatura', 458.0000, 'ºC'),
	(343293, 144, '2015-02-01 01:24:45.000000', 'temperatura', 990.0000, 'ºC'),
	(343294, 144, '2015-02-01 01:24:46.000000', 'temperatura', 1179.0000, 'ºC'),
	(343295, 144, '2015-02-01 01:24:47.000000', 'temperatura', 525.0000, 'ºC'),
	(343296, 144, '2015-02-01 01:24:48.000000', 'temperatura', 286.0000, 'ºC'),
	(343297, 144, '2015-02-01 01:24:49.000000', 'temperatura', 1058.0000, 'ºC'),
	(343298, 144, '2015-02-01 01:24:50.000000', 'temperatura', 830.0000, 'ºC'),
	(343299, 144, '2015-02-01 01:24:51.000000', 'temperatura', 977.0000, 'ºC'),
	(343300, 144, '2015-02-01 01:24:52.000000', 'temperatura', 1198.0000, 'ºC'),
	(343301, 144, '2015-02-01 01:24:53.000000', 'temperatura', 656.0000, 'ºC'),
	(343302, 144, '2015-02-01 01:24:54.000000', 'temperatura', 888.0000, 'ºC'),
	(343303, 144, '2015-02-01 01:24:55.000000', 'temperatura', 73.0000, 'ºC'),
	(343304, 144, '2015-02-01 01:24:56.000000', 'temperatura', 102.0000, 'ºC'),
	(343305, 144, '2015-02-01 01:24:57.000000', 'temperatura', 292.0000, 'ºC'),
	(343306, 144, '2015-02-01 01:24:58.000000', 'temperatura', 1154.0000, 'ºC'),
	(343307, 144, '2015-02-01 01:24:59.000000', 'temperatura', 95.0000, 'ºC'),
	(343308, 144, '2015-02-01 01:25:00.000000', 'temperatura', 612.0000, 'ºC'),
	(343309, 144, '2015-02-01 01:25:01.000000', 'temperatura', 377.0000, 'ºC'),
	(343310, 144, '2015-02-01 01:25:02.000000', 'temperatura', 48.0000, 'ºC'),
	(343311, 144, '2015-02-01 01:25:03.000000', 'temperatura', 311.0000, 'ºC'),
	(343312, 144, '2015-02-01 01:25:04.000000', 'temperatura', 211.0000, 'ºC'),
	(343313, 144, '2015-02-01 01:25:05.000000', 'temperatura', 120.0000, 'ºC'),
	(343314, 144, '2015-02-01 01:25:06.000000', 'temperatura', 1171.0000, 'ºC'),
	(343315, 144, '2015-02-01 01:25:07.000000', 'temperatura', 693.0000, 'ºC'),
	(343316, 144, '2015-02-01 01:25:08.000000', 'temperatura', 1153.0000, 'ºC'),
	(343317, 144, '2015-02-01 01:25:09.000000', 'temperatura', 86.0000, 'ºC'),
	(343318, 144, '2015-02-01 01:25:10.000000', 'temperatura', 570.0000, 'ºC'),
	(343319, 144, '2015-02-01 01:25:11.000000', 'temperatura', 195.0000, 'ºC'),
	(343320, 144, '2015-02-01 01:25:12.000000', 'temperatura', 464.0000, 'ºC'),
	(343321, 144, '2015-02-01 01:25:13.000000', 'temperatura', 535.0000, 'ºC'),
	(343322, 144, '2015-02-01 01:25:14.000000', 'temperatura', 83.0000, 'ºC'),
	(343323, 144, '2015-02-01 01:25:15.000000', 'temperatura', 10.0000, 'ºC'),
	(343324, 144, '2015-02-01 01:25:16.000000', 'temperatura', 1001.0000, 'ºC'),
	(343325, 144, '2015-02-01 01:25:17.000000', 'temperatura', 179.0000, 'ºC'),
	(343326, 144, '2015-02-01 01:25:18.000000', 'temperatura', 289.0000, 'ºC'),
	(343327, 144, '2015-02-01 01:25:19.000000', 'temperatura', 909.0000, 'ºC'),
	(343328, 144, '2015-02-01 01:25:20.000000', 'temperatura', 80.0000, 'ºC'),
	(343329, 144, '2015-02-01 01:25:21.000000', 'temperatura', 72.0000, 'ºC'),
	(343330, 144, '2015-02-01 01:25:22.000000', 'temperatura', 122.0000, 'ºC'),
	(343331, 144, '2015-02-01 01:25:23.000000', 'temperatura', 394.0000, 'ºC'),
	(343332, 144, '2015-02-01 01:25:24.000000', 'temperatura', 402.0000, 'ºC'),
	(343333, 144, '2015-02-01 01:25:25.000000', 'temperatura', 832.0000, 'ºC'),
	(343334, 144, '2015-02-01 01:25:26.000000', 'temperatura', 551.0000, 'ºC'),
	(343335, 144, '2015-02-01 01:25:27.000000', 'temperatura', 262.0000, 'ºC'),
	(343336, 144, '2015-02-01 01:25:28.000000', 'temperatura', 855.0000, 'ºC'),
	(343337, 144, '2015-02-01 01:25:29.000000', 'temperatura', 1091.0000, 'ºC'),
	(343338, 144, '2015-02-01 01:25:30.000000', 'temperatura', 490.0000, 'ºC'),
	(343339, 144, '2015-02-01 01:25:31.000000', 'temperatura', 379.0000, 'ºC'),
	(343340, 144, '2015-02-01 01:25:32.000000', 'temperatura', 426.0000, 'ºC'),
	(343341, 144, '2015-02-01 01:25:33.000000', 'temperatura', 991.0000, 'ºC'),
	(343342, 144, '2015-02-01 01:25:34.000000', 'temperatura', 78.0000, 'ºC'),
	(343343, 144, '2015-02-01 01:25:35.000000', 'temperatura', 1017.0000, 'ºC'),
	(343344, 144, '2015-02-01 01:25:36.000000', 'temperatura', 53.0000, 'ºC'),
	(343345, 144, '2015-02-01 01:25:37.000000', 'temperatura', 814.0000, 'ºC'),
	(343346, 144, '2015-02-01 01:25:38.000000', 'temperatura', 309.0000, 'ºC'),
	(343347, 144, '2015-02-01 01:25:39.000000', 'temperatura', 307.0000, 'ºC'),
	(343348, 144, '2015-02-01 01:25:40.000000', 'temperatura', 605.0000, 'ºC'),
	(343349, 144, '2015-02-01 01:25:41.000000', 'temperatura', 908.0000, 'ºC'),
	(343350, 144, '2015-02-01 01:25:42.000000', 'temperatura', 325.0000, 'ºC'),
	(343351, 144, '2015-02-01 01:25:43.000000', 'temperatura', 100.0000, 'ºC'),
	(343352, 144, '2015-02-01 01:25:44.000000', 'temperatura', 727.0000, 'ºC'),
	(343353, 144, '2015-02-01 01:25:45.000000', 'temperatura', 933.0000, 'ºC'),
	(343354, 144, '2015-02-01 01:25:46.000000', 'temperatura', 85.0000, 'ºC'),
	(343355, 144, '2015-02-01 01:25:47.000000', 'temperatura', 28.0000, 'ºC'),
	(343356, 144, '2015-02-01 01:25:48.000000', 'temperatura', 1084.0000, 'ºC'),
	(343357, 144, '2015-02-01 01:25:49.000000', 'temperatura', 539.0000, 'ºC'),
	(343358, 144, '2015-02-01 01:25:50.000000', 'temperatura', 641.0000, 'ºC'),
	(343359, 144, '2015-02-01 01:25:51.000000', 'temperatura', 390.0000, 'ºC'),
	(343360, 144, '2015-02-01 01:25:52.000000', 'temperatura', 29.0000, 'ºC'),
	(343361, 144, '2015-02-01 01:25:53.000000', 'temperatura', 174.0000, 'ºC'),
	(343362, 144, '2015-02-01 01:25:54.000000', 'temperatura', 782.0000, 'ºC'),
	(343363, 144, '2015-02-01 01:25:55.000000', 'temperatura', 989.0000, 'ºC'),
	(343364, 144, '2015-02-01 01:25:56.000000', 'temperatura', 201.0000, 'ºC'),
	(343365, 144, '2015-02-01 01:25:57.000000', 'temperatura', 437.0000, 'ºC'),
	(343366, 144, '2015-02-01 01:25:58.000000', 'temperatura', 383.0000, 'ºC'),
	(343367, 144, '2015-02-01 01:25:59.000000', 'temperatura', 606.0000, 'ºC'),
	(343368, 144, '2015-02-01 01:26:00.000000', 'temperatura', 680.0000, 'ºC'),
	(343369, 144, '2015-02-01 01:26:01.000000', 'temperatura', 383.0000, 'ºC'),
	(343370, 144, '2015-02-01 01:26:02.000000', 'temperatura', 1076.0000, 'ºC'),
	(343371, 144, '2015-02-01 01:26:03.000000', 'temperatura', 630.0000, 'ºC'),
	(343372, 144, '2015-02-01 01:26:04.000000', 'temperatura', 1123.0000, 'ºC'),
	(343373, 144, '2015-02-01 01:26:05.000000', 'temperatura', 125.0000, 'ºC'),
	(343374, 144, '2015-02-01 01:26:06.000000', 'temperatura', 858.0000, 'ºC'),
	(343375, 144, '2015-02-01 01:26:07.000000', 'temperatura', 316.0000, 'ºC'),
	(343376, 144, '2015-02-01 01:26:08.000000', 'temperatura', 206.0000, 'ºC'),
	(343377, 144, '2015-02-01 01:26:09.000000', 'temperatura', 82.0000, 'ºC'),
	(343378, 144, '2015-02-01 01:26:10.000000', 'temperatura', 993.0000, 'ºC'),
	(343379, 144, '2015-02-01 01:26:11.000000', 'temperatura', 1121.0000, 'ºC'),
	(343380, 144, '2015-02-01 01:26:12.000000', 'temperatura', 225.0000, 'ºC'),
	(343381, 144, '2015-02-01 01:26:13.000000', 'temperatura', 162.0000, 'ºC'),
	(343382, 144, '2015-02-01 01:26:14.000000', 'temperatura', 137.0000, 'ºC'),
	(343383, 144, '2015-02-01 01:26:15.000000', 'temperatura', 199.0000, 'ºC'),
	(343384, 144, '2015-02-01 01:26:16.000000', 'temperatura', 585.0000, 'ºC'),
	(343385, 144, '2015-02-01 01:26:17.000000', 'temperatura', 1126.0000, 'ºC'),
	(343386, 144, '2015-02-01 01:26:18.000000', 'temperatura', 279.0000, 'ºC'),
	(343387, 144, '2015-02-01 01:26:19.000000', 'temperatura', 414.0000, 'ºC'),
	(343388, 144, '2015-02-01 01:26:20.000000', 'temperatura', 35.0000, 'ºC'),
	(343389, 144, '2015-02-01 01:26:21.000000', 'temperatura', 134.0000, 'ºC'),
	(343390, 144, '2015-02-01 01:26:22.000000', 'temperatura', 564.0000, 'ºC'),
	(343391, 144, '2015-02-01 01:26:23.000000', 'temperatura', 19.0000, 'ºC'),
	(343392, 144, '2015-02-01 01:26:24.000000', 'temperatura', 804.0000, 'ºC'),
	(343393, 144, '2015-02-01 01:26:25.000000', 'temperatura', 363.0000, 'ºC'),
	(343394, 144, '2015-02-01 01:26:26.000000', 'temperatura', 602.0000, 'ºC'),
	(343395, 144, '2015-02-01 01:26:27.000000', 'temperatura', 723.0000, 'ºC'),
	(343396, 144, '2015-02-01 01:26:28.000000', 'temperatura', 611.0000, 'ºC'),
	(343397, 144, '2015-02-01 01:26:29.000000', 'temperatura', 885.0000, 'ºC'),
	(343398, 144, '2015-02-01 01:26:30.000000', 'temperatura', 193.0000, 'ºC'),
	(343399, 144, '2015-02-01 01:26:31.000000', 'temperatura', 708.0000, 'ºC'),
	(343400, 144, '2015-02-01 01:26:32.000000', 'temperatura', 564.0000, 'ºC'),
	(343401, 144, '2015-02-01 01:26:33.000000', 'temperatura', 695.0000, 'ºC'),
	(343402, 144, '2015-02-01 01:26:34.000000', 'temperatura', 583.0000, 'ºC'),
	(343403, 144, '2015-02-01 01:26:35.000000', 'temperatura', 832.0000, 'ºC'),
	(343404, 144, '2015-02-01 01:26:36.000000', 'temperatura', 13.0000, 'ºC'),
	(343405, 144, '2015-02-01 01:26:37.000000', 'temperatura', 1169.0000, 'ºC'),
	(343406, 144, '2015-02-01 01:26:38.000000', 'temperatura', 1004.0000, 'ºC'),
	(343407, 144, '2015-02-01 01:26:39.000000', 'temperatura', 315.0000, 'ºC'),
	(343408, 144, '2015-02-01 01:26:40.000000', 'temperatura', 964.0000, 'ºC'),
	(343409, 144, '2015-02-01 01:26:41.000000', 'temperatura', 276.0000, 'ºC'),
	(343410, 144, '2015-02-01 01:26:42.000000', 'temperatura', 890.0000, 'ºC'),
	(343411, 144, '2015-02-01 01:26:43.000000', 'temperatura', 20.0000, 'ºC'),
	(343412, 144, '2015-02-01 01:26:44.000000', 'temperatura', 1032.0000, 'ºC'),
	(343413, 144, '2015-02-01 01:26:45.000000', 'temperatura', 300.0000, 'ºC'),
	(343414, 144, '2015-02-01 01:26:46.000000', 'temperatura', 805.0000, 'ºC'),
	(343415, 144, '2015-02-01 01:26:47.000000', 'temperatura', 726.0000, 'ºC'),
	(343416, 144, '2015-02-01 01:26:48.000000', 'temperatura', 16.0000, 'ºC'),
	(343417, 144, '2015-02-01 01:26:49.000000', 'temperatura', 300.0000, 'ºC'),
	(343418, 144, '2015-02-01 01:26:50.000000', 'temperatura', 252.0000, 'ºC'),
	(343419, 144, '2015-02-01 01:26:51.000000', 'temperatura', 363.0000, 'ºC'),
	(343420, 144, '2015-02-01 01:26:52.000000', 'temperatura', 1060.0000, 'ºC'),
	(343421, 144, '2015-02-01 01:26:53.000000', 'temperatura', 612.0000, 'ºC'),
	(343422, 144, '2015-02-01 01:26:54.000000', 'temperatura', 1081.0000, 'ºC'),
	(343423, 144, '2015-02-01 01:26:55.000000', 'temperatura', 1169.0000, 'ºC'),
	(343424, 144, '2015-02-01 01:26:56.000000', 'temperatura', 201.0000, 'ºC'),
	(343425, 144, '2015-02-01 01:26:57.000000', 'temperatura', 1098.0000, 'ºC'),
	(343426, 144, '2015-02-01 01:26:58.000000', 'temperatura', 89.0000, 'ºC'),
	(343427, 144, '2015-02-01 01:26:59.000000', 'temperatura', 753.0000, 'ºC'),
	(343428, 144, '2015-02-01 01:27:00.000000', 'temperatura', 1097.0000, 'ºC'),
	(343429, 144, '2015-02-01 01:27:01.000000', 'temperatura', 828.0000, 'ºC'),
	(343430, 144, '2015-02-01 01:27:02.000000', 'temperatura', 848.0000, 'ºC'),
	(343431, 144, '2015-02-01 01:27:03.000000', 'temperatura', 558.0000, 'ºC'),
	(343432, 144, '2015-02-01 01:27:04.000000', 'temperatura', 247.0000, 'ºC'),
	(343433, 144, '2015-02-01 01:27:05.000000', 'temperatura', 761.0000, 'ºC'),
	(343434, 144, '2015-02-01 01:27:06.000000', 'temperatura', 666.0000, 'ºC'),
	(343435, 144, '2015-02-01 01:27:07.000000', 'temperatura', 1046.0000, 'ºC'),
	(343436, 144, '2015-02-01 01:27:08.000000', 'temperatura', 831.0000, 'ºC'),
	(343437, 144, '2015-02-01 01:27:09.000000', 'temperatura', 1021.0000, 'ºC'),
	(343438, 144, '2015-02-01 01:27:10.000000', 'temperatura', 210.0000, 'ºC'),
	(343439, 144, '2015-02-01 01:27:11.000000', 'temperatura', 387.0000, 'ºC'),
	(343440, 144, '2015-02-01 01:27:12.000000', 'temperatura', 106.0000, 'ºC'),
	(343441, 144, '2015-02-01 01:27:13.000000', 'temperatura', 570.0000, 'ºC'),
	(343442, 144, '2015-02-01 01:27:14.000000', 'temperatura', 131.0000, 'ºC'),
	(343443, 144, '2015-02-01 01:27:15.000000', 'temperatura', 146.0000, 'ºC'),
	(343444, 144, '2015-02-01 01:27:16.000000', 'temperatura', 339.0000, 'ºC'),
	(343445, 144, '2015-02-01 01:27:17.000000', 'temperatura', 55.0000, 'ºC'),
	(343446, 144, '2015-02-01 01:27:18.000000', 'temperatura', 460.0000, 'ºC'),
	(343447, 144, '2015-02-01 01:27:19.000000', 'temperatura', 936.0000, 'ºC'),
	(343448, 144, '2015-02-01 01:27:20.000000', 'temperatura', 901.0000, 'ºC'),
	(343449, 144, '2015-02-01 01:27:21.000000', 'temperatura', 498.0000, 'ºC'),
	(343450, 144, '2015-02-01 01:27:22.000000', 'temperatura', 985.0000, 'ºC'),
	(343451, 144, '2015-02-01 01:27:23.000000', 'temperatura', 1033.0000, 'ºC'),
	(343452, 144, '2015-02-01 01:27:24.000000', 'temperatura', 1010.0000, 'ºC'),
	(343453, 144, '2015-02-01 01:27:25.000000', 'temperatura', 753.0000, 'ºC'),
	(343454, 144, '2015-02-01 01:27:26.000000', 'temperatura', 734.0000, 'ºC'),
	(343455, 144, '2015-02-01 01:27:27.000000', 'temperatura', 210.0000, 'ºC'),
	(343456, 144, '2015-02-01 01:27:28.000000', 'temperatura', 51.0000, 'ºC'),
	(343457, 144, '2015-02-01 01:27:29.000000', 'temperatura', 827.0000, 'ºC'),
	(343458, 144, '2015-02-01 01:27:30.000000', 'temperatura', 380.0000, 'ºC'),
	(343459, 144, '2015-02-01 01:27:31.000000', 'temperatura', 618.0000, 'ºC'),
	(343460, 144, '2015-02-01 01:27:32.000000', 'temperatura', 753.0000, 'ºC'),
	(343461, 144, '2015-02-01 01:27:33.000000', 'temperatura', 712.0000, 'ºC'),
	(343462, 144, '2015-02-01 01:27:34.000000', 'temperatura', 99.0000, 'ºC'),
	(343463, 144, '2015-02-01 01:27:35.000000', 'temperatura', 759.0000, 'ºC'),
	(343464, 144, '2015-02-01 01:27:36.000000', 'temperatura', 1098.0000, 'ºC'),
	(343465, 144, '2015-02-01 01:27:37.000000', 'temperatura', 814.0000, 'ºC'),
	(343466, 144, '2015-02-01 01:27:38.000000', 'temperatura', 775.0000, 'ºC'),
	(343467, 144, '2015-02-01 01:27:39.000000', 'temperatura', 235.0000, 'ºC'),
	(343468, 144, '2015-02-01 01:27:40.000000', 'temperatura', 49.0000, 'ºC'),
	(343469, 144, '2015-02-01 01:27:41.000000', 'temperatura', 741.0000, 'ºC'),
	(343470, 144, '2015-02-01 01:27:42.000000', 'temperatura', 1158.0000, 'ºC'),
	(343471, 144, '2015-02-01 01:27:43.000000', 'temperatura', 1169.0000, 'ºC'),
	(343472, 144, '2015-02-01 01:27:44.000000', 'temperatura', 1173.0000, 'ºC'),
	(343473, 144, '2015-02-01 01:27:45.000000', 'temperatura', 1156.0000, 'ºC'),
	(343474, 144, '2015-02-01 01:27:46.000000', 'temperatura', 1061.0000, 'ºC'),
	(343475, 144, '2015-02-01 01:27:47.000000', 'temperatura', 638.0000, 'ºC'),
	(343476, 144, '2015-02-01 01:27:48.000000', 'temperatura', 6.0000, 'ºC'),
	(343477, 144, '2015-02-01 01:27:49.000000', 'temperatura', 517.0000, 'ºC'),
	(343478, 144, '2015-02-01 01:27:50.000000', 'temperatura', 168.0000, 'ºC'),
	(343479, 144, '2015-02-01 01:27:51.000000', 'temperatura', 490.0000, 'ºC'),
	(343480, 144, '2015-02-01 01:27:52.000000', 'temperatura', 747.0000, 'ºC'),
	(343481, 144, '2015-02-01 01:27:53.000000', 'temperatura', 1063.0000, 'ºC'),
	(343482, 144, '2015-02-01 01:27:54.000000', 'temperatura', 677.0000, 'ºC'),
	(343483, 144, '2015-02-01 01:27:55.000000', 'temperatura', 197.0000, 'ºC'),
	(343484, 144, '2015-02-01 01:27:56.000000', 'temperatura', 154.0000, 'ºC'),
	(343485, 144, '2015-02-01 01:27:57.000000', 'temperatura', 179.0000, 'ºC'),
	(343486, 144, '2015-02-01 01:27:58.000000', 'temperatura', 434.0000, 'ºC'),
	(343487, 144, '2015-02-01 01:27:59.000000', 'temperatura', 432.0000, 'ºC'),
	(343488, 144, '2015-02-01 01:28:00.000000', 'temperatura', 861.0000, 'ºC'),
	(343489, 144, '2015-02-01 01:28:01.000000', 'temperatura', 607.0000, 'ºC'),
	(343490, 144, '2015-02-01 01:28:02.000000', 'temperatura', 452.0000, 'ºC'),
	(343491, 144, '2015-02-01 01:28:03.000000', 'temperatura', 441.0000, 'ºC'),
	(343492, 144, '2015-02-01 01:28:04.000000', 'temperatura', 851.0000, 'ºC'),
	(343493, 144, '2015-02-01 01:28:05.000000', 'temperatura', 532.0000, 'ºC'),
	(343494, 144, '2015-02-01 01:28:06.000000', 'temperatura', 105.0000, 'ºC'),
	(343495, 144, '2015-02-01 01:28:07.000000', 'temperatura', 130.0000, 'ºC'),
	(343496, 144, '2015-02-01 01:28:08.000000', 'temperatura', 338.0000, 'ºC'),
	(343497, 144, '2015-02-01 01:28:09.000000', 'temperatura', 100.0000, 'ºC'),
	(343498, 144, '2015-02-01 01:28:10.000000', 'temperatura', 684.0000, 'ºC'),
	(343499, 144, '2015-02-01 01:28:11.000000', 'temperatura', 723.0000, 'ºC'),
	(343500, 144, '2015-02-01 01:28:12.000000', 'temperatura', 361.0000, 'ºC'),
	(343501, 144, '2015-02-01 01:28:13.000000', 'temperatura', 840.0000, 'ºC'),
	(343502, 144, '2015-02-01 01:28:14.000000', 'temperatura', 715.0000, 'ºC'),
	(343503, 144, '2015-02-01 01:28:15.000000', 'temperatura', 1054.0000, 'ºC'),
	(343504, 144, '2015-02-01 01:28:16.000000', 'temperatura', 728.0000, 'ºC'),
	(343505, 144, '2015-02-01 01:28:17.000000', 'temperatura', 478.0000, 'ºC'),
	(343506, 144, '2015-02-01 01:28:18.000000', 'temperatura', 208.0000, 'ºC'),
	(343507, 144, '2015-02-01 01:28:19.000000', 'temperatura', 806.0000, 'ºC'),
	(343508, 144, '2015-02-01 01:28:20.000000', 'temperatura', 1006.0000, 'ºC'),
	(343509, 144, '2015-02-01 01:28:21.000000', 'temperatura', 213.0000, 'ºC'),
	(343510, 144, '2015-02-01 01:28:22.000000', 'temperatura', 446.0000, 'ºC'),
	(343511, 144, '2015-02-01 01:28:23.000000', 'temperatura', 394.0000, 'ºC'),
	(343512, 144, '2015-02-01 01:28:24.000000', 'temperatura', 633.0000, 'ºC'),
	(343513, 144, '2015-02-01 01:28:25.000000', 'temperatura', 781.0000, 'ºC'),
	(343514, 144, '2015-02-01 01:28:26.000000', 'temperatura', 809.0000, 'ºC'),
	(343515, 144, '2015-02-01 01:28:27.000000', 'temperatura', 503.0000, 'ºC'),
	(343516, 144, '2015-02-01 01:28:28.000000', 'temperatura', 88.0000, 'ºC'),
	(343517, 144, '2015-02-01 01:28:29.000000', 'temperatura', 131.0000, 'ºC'),
	(343518, 144, '2015-02-01 01:28:30.000000', 'temperatura', 392.0000, 'ºC'),
	(343519, 144, '2015-02-01 01:28:31.000000', 'temperatura', 367.0000, 'ºC'),
	(343520, 144, '2015-02-01 01:28:32.000000', 'temperatura', 661.0000, 'ºC'),
	(343521, 144, '2015-02-01 01:28:33.000000', 'temperatura', 1002.0000, 'ºC'),
	(343522, 144, '2015-02-01 01:28:34.000000', 'temperatura', 627.0000, 'ºC'),
	(343523, 144, '2015-02-01 01:28:35.000000', 'temperatura', 132.0000, 'ºC'),
	(343524, 144, '2015-02-01 01:28:36.000000', 'temperatura', 1180.0000, 'ºC'),
	(343525, 144, '2015-02-01 01:28:37.000000', 'temperatura', 704.0000, 'ºC'),
	(343526, 144, '2015-02-01 01:28:38.000000', 'temperatura', 1180.0000, 'ºC'),
	(343527, 144, '2015-02-01 01:28:39.000000', 'temperatura', 189.0000, 'ºC'),
	(343528, 144, '2015-02-01 01:28:40.000000', 'temperatura', 1006.0000, 'ºC'),
	(343529, 144, '2015-02-01 01:28:41.000000', 'temperatura', 864.0000, 'ºC'),
	(343530, 144, '2015-02-01 01:28:42.000000', 'temperatura', 102.0000, 'ºC'),
	(343531, 144, '2015-02-01 01:28:43.000000', 'temperatura', 319.0000, 'ºC'),
	(343532, 144, '2015-02-01 01:28:44.000000', 'temperatura', 89.0000, 'ºC'),
	(343533, 144, '2015-02-01 01:28:45.000000', 'temperatura', 687.0000, 'ºC'),
	(343534, 144, '2015-02-01 01:28:46.000000', 'temperatura', 768.0000, 'ºC'),
	(343535, 144, '2015-02-01 01:28:47.000000', 'temperatura', 579.0000, 'ºC'),
	(343536, 144, '2015-02-01 01:28:48.000000', 'temperatura', 591.0000, 'ºC'),
	(343537, 144, '2015-02-01 01:28:49.000000', 'temperatura', 18.0000, 'ºC'),
	(343538, 144, '2015-02-01 01:28:50.000000', 'temperatura', 721.0000, 'ºC'),
	(343539, 144, '2015-02-01 01:28:51.000000', 'temperatura', 1148.0000, 'ºC'),
	(343540, 144, '2015-02-01 01:28:52.000000', 'temperatura', 1178.0000, 'ºC'),
	(343541, 144, '2015-02-01 01:28:53.000000', 'temperatura', 49.0000, 'ºC'),
	(343542, 144, '2015-02-01 01:28:54.000000', 'temperatura', 309.0000, 'ºC'),
	(343543, 144, '2015-02-01 01:28:55.000000', 'temperatura', 200.0000, 'ºC'),
	(343544, 144, '2015-02-01 01:28:56.000000', 'temperatura', 71.0000, 'ºC'),
	(343545, 144, '2015-02-01 01:28:57.000000', 'temperatura', 956.0000, 'ºC'),
	(343546, 144, '2015-02-01 01:28:58.000000', 'temperatura', 969.0000, 'ºC'),
	(343547, 144, '2015-02-01 01:28:59.000000', 'temperatura', 779.0000, 'ºC'),
	(343548, 144, '2015-02-01 01:29:00.000000', 'temperatura', 986.0000, 'ºC'),
	(343549, 144, '2015-02-01 01:29:01.000000', 'temperatura', 193.0000, 'ºC'),
	(343550, 144, '2015-02-01 01:29:02.000000', 'temperatura', 410.0000, 'ºC'),
	(343551, 144, '2015-02-01 01:29:03.000000', 'temperatura', 270.0000, 'ºC'),
	(343552, 144, '2015-02-01 01:29:04.000000', 'temperatura', 119.0000, 'ºC'),
	(343553, 144, '2015-02-01 01:29:05.000000', 'temperatura', 987.0000, 'ºC'),
	(343554, 144, '2015-02-01 01:29:06.000000', 'temperatura', 979.0000, 'ºC'),
	(343555, 144, '2015-02-01 01:29:07.000000', 'temperatura', 732.0000, 'ºC'),
	(343556, 144, '2015-02-01 01:29:08.000000', 'temperatura', 727.0000, 'ºC'),
	(343557, 144, '2015-02-01 01:29:09.000000', 'temperatura', 237.0000, 'ºC'),
	(343558, 144, '2015-02-01 01:29:10.000000', 'temperatura', 205.0000, 'ºC'),
	(343559, 144, '2015-02-01 01:29:11.000000', 'temperatura', 313.0000, 'ºC'),
	(343560, 144, '2015-02-01 01:29:12.000000', 'temperatura', 951.0000, 'ºC'),
	(343561, 144, '2015-02-01 01:29:13.000000', 'temperatura', 215.0000, 'ºC'),
	(343562, 144, '2015-02-01 01:29:14.000000', 'temperatura', 624.0000, 'ºC'),
	(343563, 144, '2015-02-01 01:29:15.000000', 'temperatura', 75.0000, 'ºC'),
	(343564, 144, '2015-02-01 01:29:16.000000', 'temperatura', 904.0000, 'ºC'),
	(343565, 144, '2015-02-01 01:29:17.000000', 'temperatura', 695.0000, 'ºC'),
	(343566, 144, '2015-02-01 01:29:18.000000', 'temperatura', 763.0000, 'ºC'),
	(343567, 144, '2015-02-01 01:29:19.000000', 'temperatura', 531.0000, 'ºC'),
	(343568, 144, '2015-02-01 01:29:20.000000', 'temperatura', 366.0000, 'ºC'),
	(343569, 144, '2015-02-01 01:29:21.000000', 'temperatura', 237.0000, 'ºC'),
	(343570, 144, '2015-02-01 01:29:22.000000', 'temperatura', 88.0000, 'ºC'),
	(343571, 144, '2015-02-01 01:29:23.000000', 'temperatura', 928.0000, 'ºC'),
	(343572, 144, '2015-02-01 01:29:24.000000', 'temperatura', 778.0000, 'ºC'),
	(343573, 144, '2015-02-01 01:29:25.000000', 'temperatura', 1107.0000, 'ºC'),
	(343574, 144, '2015-02-01 01:29:26.000000', 'temperatura', 800.0000, 'ºC'),
	(343575, 144, '2015-02-01 01:29:27.000000', 'temperatura', 681.0000, 'ºC'),
	(343576, 144, '2015-02-01 01:29:28.000000', 'temperatura', 1007.0000, 'ºC'),
	(343577, 144, '2015-02-01 01:29:29.000000', 'temperatura', 589.0000, 'ºC'),
	(343578, 144, '2015-02-01 01:29:30.000000', 'temperatura', 1126.0000, 'ºC'),
	(343579, 144, '2015-02-01 01:29:31.000000', 'temperatura', 262.0000, 'ºC'),
	(343580, 144, '2015-02-01 01:29:32.000000', 'temperatura', 334.0000, 'ºC'),
	(343581, 144, '2015-02-01 01:29:33.000000', 'temperatura', 884.0000, 'ºC'),
	(343582, 144, '2015-02-01 01:29:34.000000', 'temperatura', 1020.0000, 'ºC'),
	(343583, 144, '2015-02-01 01:29:35.000000', 'temperatura', 45.0000, 'ºC'),
	(343584, 144, '2015-02-01 01:29:36.000000', 'temperatura', 769.0000, 'ºC'),
	(343585, 144, '2015-02-01 01:29:37.000000', 'temperatura', 110.0000, 'ºC'),
	(343586, 144, '2015-02-01 01:29:38.000000', 'temperatura', 644.0000, 'ºC'),
	(343587, 144, '2015-02-01 01:29:39.000000', 'temperatura', 488.0000, 'ºC'),
	(343588, 144, '2015-02-01 01:29:40.000000', 'temperatura', 510.0000, 'ºC'),
	(343589, 144, '2015-02-01 01:29:41.000000', 'temperatura', 1084.0000, 'ºC'),
	(343590, 144, '2015-02-01 01:29:42.000000', 'temperatura', 294.0000, 'ºC'),
	(343591, 144, '2015-02-01 01:29:43.000000', 'temperatura', 616.0000, 'ºC'),
	(343592, 144, '2015-02-01 01:29:44.000000', 'temperatura', 999.0000, 'ºC'),
	(343593, 144, '2015-02-01 01:29:45.000000', 'temperatura', 750.0000, 'ºC'),
	(343594, 144, '2015-02-01 01:29:46.000000', 'temperatura', 750.0000, 'ºC'),
	(343595, 144, '2015-02-01 01:29:47.000000', 'temperatura', 304.0000, 'ºC'),
	(343596, 144, '2015-02-01 01:29:48.000000', 'temperatura', 469.0000, 'ºC'),
	(343597, 144, '2015-02-01 01:29:49.000000', 'temperatura', 233.0000, 'ºC'),
	(343598, 144, '2015-02-01 01:29:50.000000', 'temperatura', 960.0000, 'ºC'),
	(343599, 144, '2015-02-01 01:29:51.000000', 'temperatura', 499.0000, 'ºC'),
	(343600, 144, '2015-02-01 01:29:52.000000', 'temperatura', 817.0000, 'ºC'),
	(343601, 144, '2015-02-01 01:29:53.000000', 'temperatura', 189.0000, 'ºC'),
	(343602, 144, '2015-02-01 01:29:54.000000', 'temperatura', 892.0000, 'ºC'),
	(343603, 144, '2015-02-01 01:29:55.000000', 'temperatura', 297.0000, 'ºC'),
	(343604, 144, '2015-02-01 01:29:56.000000', 'temperatura', 7.0000, 'ºC'),
	(343605, 144, '2015-02-01 01:29:57.000000', 'temperatura', 343.0000, 'ºC'),
	(343606, 144, '2015-02-01 01:29:58.000000', 'temperatura', 497.0000, 'ºC'),
	(343607, 144, '2015-02-01 01:29:59.000000', 'temperatura', 255.0000, 'ºC'),
	(343608, 144, '2015-02-01 01:30:00.000000', 'temperatura', 983.0000, 'ºC'),
	(343609, 144, '2015-02-01 01:30:01.000000', 'temperatura', 553.0000, 'ºC'),
	(343610, 144, '2015-02-01 01:30:02.000000', 'temperatura', 1017.0000, 'ºC'),
	(343611, 144, '2015-02-01 01:30:03.000000', 'temperatura', 1025.0000, 'ºC'),
	(343612, 144, '2015-02-01 01:30:04.000000', 'temperatura', 876.0000, 'ºC'),
	(343613, 144, '2015-02-01 01:30:05.000000', 'temperatura', 103.0000, 'ºC'),
	(343614, 144, '2015-02-01 01:30:06.000000', 'temperatura', 289.0000, 'ºC'),
	(343615, 144, '2015-02-01 01:30:07.000000', 'temperatura', 1137.0000, 'ºC'),
	(343616, 144, '2015-02-01 01:30:08.000000', 'temperatura', 18.0000, 'ºC'),
	(343617, 144, '2015-02-01 01:30:09.000000', 'temperatura', 279.0000, 'ºC'),
	(343618, 144, '2015-02-01 01:30:10.000000', 'temperatura', 143.0000, 'ºC'),
	(343619, 144, '2015-02-01 01:30:11.000000', 'temperatura', 1078.0000, 'ºC'),
	(343620, 144, '2015-02-01 01:30:12.000000', 'temperatura', 162.0000, 'ºC'),
	(343621, 144, '2015-02-01 01:30:13.000000', 'temperatura', 1178.0000, 'ºC'),
	(343622, 144, '2015-02-01 01:30:14.000000', 'temperatura', 603.0000, 'ºC'),
	(343623, 144, '2015-02-01 01:30:15.000000', 'temperatura', 680.0000, 'ºC'),
	(343624, 144, '2015-02-01 01:30:16.000000', 'temperatura', 394.0000, 'ºC'),
	(343625, 144, '2015-02-01 01:30:17.000000', 'temperatura', 1129.0000, 'ºC'),
	(343626, 144, '2015-02-01 01:30:18.000000', 'temperatura', 863.0000, 'ºC'),
	(343627, 144, '2015-02-01 01:30:19.000000', 'temperatura', 929.0000, 'ºC'),
	(343628, 144, '2015-02-01 01:30:20.000000', 'temperatura', 854.0000, 'ºC'),
	(343629, 144, '2015-02-01 01:30:21.000000', 'temperatura', 287.0000, 'ºC'),
	(343630, 144, '2015-02-01 01:30:22.000000', 'temperatura', 73.0000, 'ºC'),
	(343631, 144, '2015-02-01 01:30:23.000000', 'temperatura', 705.0000, 'ºC'),
	(343632, 144, '2015-02-01 01:30:24.000000', 'temperatura', 906.0000, 'ºC'),
	(343633, 144, '2015-02-01 01:30:25.000000', 'temperatura', 14.0000, 'ºC'),
	(343634, 144, '2015-02-01 01:30:26.000000', 'temperatura', 953.0000, 'ºC'),
	(343635, 144, '2015-02-01 01:30:27.000000', 'temperatura', 1124.0000, 'ºC'),
	(343636, 144, '2015-02-01 01:30:28.000000', 'temperatura', 363.0000, 'ºC'),
	(343637, 144, '2015-02-01 01:30:29.000000', 'temperatura', 844.0000, 'ºC'),
	(343638, 144, '2015-02-01 01:30:30.000000', 'temperatura', 732.0000, 'ºC'),
	(343639, 144, '2015-02-01 01:30:31.000000', 'temperatura', 1126.0000, 'ºC'),
	(343640, 144, '2015-02-01 01:30:32.000000', 'temperatura', 1037.0000, 'ºC'),
	(343641, 144, '2015-02-01 01:30:33.000000', 'temperatura', 606.0000, 'ºC'),
	(343642, 144, '2015-02-01 01:30:34.000000', 'temperatura', 1122.0000, 'ºC'),
	(343643, 144, '2015-02-01 01:30:35.000000', 'temperatura', 189.0000, 'ºC'),
	(343644, 144, '2015-02-01 01:30:36.000000', 'temperatura', 1181.0000, 'ºC'),
	(343645, 144, '2015-02-01 01:30:37.000000', 'temperatura', 537.0000, 'ºC'),
	(343646, 144, '2015-02-01 01:30:38.000000', 'temperatura', 345.0000, 'ºC'),
	(343647, 144, '2015-02-01 01:30:39.000000', 'temperatura', 114.0000, 'ºC'),
	(343648, 144, '2015-02-01 01:30:40.000000', 'temperatura', 737.0000, 'ºC'),
	(343649, 144, '2015-02-01 01:30:41.000000', 'temperatura', 940.0000, 'ºC'),
	(343650, 144, '2015-02-01 01:30:42.000000', 'temperatura', 93.0000, 'ºC'),
	(343651, 144, '2015-02-01 01:30:43.000000', 'temperatura', 45.0000, 'ºC'),
	(343652, 144, '2015-02-01 01:30:44.000000', 'temperatura', 1144.0000, 'ºC'),
	(343653, 144, '2015-02-01 01:30:45.000000', 'temperatura', 787.0000, 'ºC'),
	(343654, 144, '2015-02-01 01:30:46.000000', 'temperatura', 503.0000, 'ºC'),
	(343655, 144, '2015-02-01 01:30:47.000000', 'temperatura', 157.0000, 'ºC'),
	(343656, 144, '2015-02-01 01:30:48.000000', 'temperatura', 473.0000, 'ºC'),
	(343657, 144, '2015-02-01 01:30:49.000000', 'temperatura', 696.0000, 'ºC'),
	(343658, 144, '2015-02-01 01:30:50.000000', 'temperatura', 860.0000, 'ºC'),
	(343659, 144, '2015-02-01 01:30:51.000000', 'temperatura', 1015.0000, 'ºC'),
	(343660, 144, '2015-02-01 01:30:52.000000', 'temperatura', 93.0000, 'ºC'),
	(343661, 144, '2015-02-01 01:30:53.000000', 'temperatura', 1020.0000, 'ºC'),
	(343662, 144, '2015-02-01 01:30:54.000000', 'temperatura', 24.0000, 'ºC'),
	(343663, 144, '2015-02-01 01:30:55.000000', 'temperatura', 660.0000, 'ºC'),
	(343664, 144, '2015-02-01 01:30:56.000000', 'temperatura', 830.0000, 'ºC'),
	(343665, 144, '2015-02-01 01:30:57.000000', 'temperatura', 970.0000, 'ºC'),
	(343666, 144, '2015-02-01 01:30:58.000000', 'temperatura', 1158.0000, 'ºC'),
	(343667, 144, '2015-02-01 01:30:59.000000', 'temperatura', 483.0000, 'ºC'),
	(343668, 144, '2015-02-01 01:31:00.000000', 'temperatura', 140.0000, 'ºC'),
	(343669, 144, '2015-02-01 01:31:01.000000', 'temperatura', 451.0000, 'ºC'),
	(343670, 144, '2015-02-01 01:31:02.000000', 'temperatura', 635.0000, 'ºC'),
	(343671, 144, '2015-02-01 01:31:03.000000', 'temperatura', 622.0000, 'ºC'),
	(343672, 144, '2015-02-01 01:31:04.000000', 'temperatura', 4.0000, 'ºC'),
	(343673, 144, '2015-02-01 01:31:05.000000', 'temperatura', 558.0000, 'ºC'),
	(343674, 144, '2015-02-01 01:31:06.000000', 'temperatura', 378.0000, 'ºC'),
	(343675, 145, '2015-02-01 00:00:00.000000', 'temperatura', 1144.0000, 'ºC'),
	(343676, 145, '2015-02-01 00:00:01.000000', 'temperatura', 274.0000, 'ºC'),
	(343677, 145, '2015-02-01 00:00:02.000000', 'temperatura', 339.0000, 'ºC'),
	(343678, 145, '2015-02-01 00:00:03.000000', 'temperatura', 873.0000, 'ºC'),
	(343679, 145, '2015-02-01 00:00:04.000000', 'temperatura', 949.0000, 'ºC'),
	(343680, 145, '2015-02-01 00:00:05.000000', 'temperatura', 926.0000, 'ºC'),
	(343681, 145, '2015-02-01 00:00:06.000000', 'temperatura', 585.0000, 'ºC'),
	(343682, 145, '2015-02-01 00:00:07.000000', 'temperatura', 146.0000, 'ºC'),
	(343683, 145, '2015-02-01 00:00:08.000000', 'temperatura', 177.0000, 'ºC'),
	(343684, 145, '2015-02-01 00:00:09.000000', 'temperatura', 449.0000, 'ºC'),
	(343685, 145, '2015-02-01 00:00:10.000000', 'temperatura', 511.0000, 'ºC'),
	(343686, 145, '2015-02-01 00:00:11.000000', 'temperatura', 11.0000, 'ºC'),
	(343687, 145, '2015-02-01 00:00:12.000000', 'temperatura', 921.0000, 'ºC'),
	(343688, 145, '2015-02-01 00:00:13.000000', 'temperatura', 974.0000, 'ºC'),
	(343689, 145, '2015-02-01 00:00:14.000000', 'temperatura', 906.0000, 'ºC'),
	(343690, 145, '2015-02-01 00:00:15.000000', 'temperatura', 409.0000, 'ºC'),
	(343691, 145, '2015-02-01 00:00:16.000000', 'temperatura', 527.0000, 'ºC'),
	(343692, 145, '2015-02-01 00:00:17.000000', 'temperatura', 209.0000, 'ºC'),
	(343693, 145, '2015-02-01 00:00:18.000000', 'temperatura', 663.0000, 'ºC'),
	(343694, 145, '2015-02-01 00:00:19.000000', 'temperatura', 289.0000, 'ºC'),
	(343695, 145, '2015-02-01 00:00:20.000000', 'temperatura', 656.0000, 'ºC'),
	(343696, 145, '2015-02-01 00:00:21.000000', 'temperatura', 16.0000, 'ºC'),
	(343697, 145, '2015-02-01 00:00:22.000000', 'temperatura', 509.0000, 'ºC'),
	(343698, 145, '2015-02-01 00:00:23.000000', 'temperatura', 99.0000, 'ºC'),
	(343699, 145, '2015-02-01 00:00:24.000000', 'temperatura', 170.0000, 'ºC'),
	(343700, 145, '2015-02-01 00:00:25.000000', 'temperatura', 551.0000, 'ºC'),
	(343701, 145, '2015-02-01 00:00:26.000000', 'temperatura', 1048.0000, 'ºC'),
	(343702, 145, '2015-02-01 00:00:27.000000', 'temperatura', 1186.0000, 'ºC'),
	(343703, 145, '2015-02-01 00:00:28.000000', 'temperatura', 388.0000, 'ºC'),
	(343704, 145, '2015-02-01 00:00:29.000000', 'temperatura', 780.0000, 'ºC'),
	(343705, 145, '2015-02-01 00:00:30.000000', 'temperatura', 340.0000, 'ºC'),
	(343706, 145, '2015-02-01 00:00:31.000000', 'temperatura', 557.0000, 'ºC'),
	(343707, 145, '2015-02-01 00:00:32.000000', 'temperatura', 566.0000, 'ºC'),
	(343708, 145, '2015-02-01 00:00:33.000000', 'temperatura', 1159.0000, 'ºC'),
	(343709, 145, '2015-02-01 00:00:34.000000', 'temperatura', 496.0000, 'ºC'),
	(343710, 145, '2015-02-01 00:00:35.000000', 'temperatura', 206.0000, 'ºC'),
	(343711, 145, '2015-02-01 00:00:36.000000', 'temperatura', 744.0000, 'ºC'),
	(343712, 145, '2015-02-01 00:00:37.000000', 'temperatura', 700.0000, 'ºC'),
	(343713, 145, '2015-02-01 00:00:38.000000', 'temperatura', 69.0000, 'ºC'),
	(343714, 145, '2015-02-01 00:00:39.000000', 'temperatura', 647.0000, 'ºC'),
	(343715, 145, '2015-02-01 00:00:40.000000', 'temperatura', 628.0000, 'ºC'),
	(343716, 145, '2015-02-01 00:00:41.000000', 'temperatura', 1199.0000, 'ºC'),
	(343717, 145, '2015-02-01 00:00:42.000000', 'temperatura', 513.0000, 'ºC'),
	(343718, 145, '2015-02-01 00:00:43.000000', 'temperatura', 168.0000, 'ºC'),
	(343719, 145, '2015-02-01 00:00:44.000000', 'temperatura', 500.0000, 'ºC'),
	(343720, 145, '2015-02-01 00:00:45.000000', 'temperatura', 799.0000, 'ºC'),
	(343721, 145, '2015-02-01 00:00:46.000000', 'temperatura', 92.0000, 'ºC'),
	(343722, 145, '2015-02-01 00:00:47.000000', 'temperatura', 467.0000, 'ºC'),
	(343723, 145, '2015-02-01 00:00:48.000000', 'temperatura', 859.0000, 'ºC'),
	(343724, 145, '2015-02-01 00:00:49.000000', 'temperatura', 495.0000, 'ºC'),
	(343725, 145, '2015-02-01 00:00:50.000000', 'temperatura', 1098.0000, 'ºC'),
	(343726, 145, '2015-02-01 00:00:51.000000', 'temperatura', 407.0000, 'ºC'),
	(343727, 145, '2015-02-01 00:00:52.000000', 'temperatura', 1139.0000, 'ºC'),
	(343728, 145, '2015-02-01 00:00:53.000000', 'temperatura', 876.0000, 'ºC'),
	(343729, 145, '2015-02-01 00:00:54.000000', 'temperatura', 965.0000, 'ºC'),
	(343730, 145, '2015-02-01 00:00:55.000000', 'temperatura', 995.0000, 'ºC'),
	(343731, 145, '2015-02-01 00:00:56.000000', 'temperatura', 883.0000, 'ºC'),
	(343732, 145, '2015-02-01 00:00:57.000000', 'temperatura', 230.0000, 'ºC'),
	(343733, 145, '2015-02-01 00:00:58.000000', 'temperatura', 899.0000, 'ºC'),
	(343734, 145, '2015-02-01 00:00:59.000000', 'temperatura', 208.0000, 'ºC'),
	(343735, 145, '2015-02-01 00:01:00.000000', 'temperatura', 741.0000, 'ºC'),
	(343736, 145, '2015-02-01 00:01:01.000000', 'temperatura', 683.0000, 'ºC'),
	(343737, 145, '2015-02-01 00:01:02.000000', 'temperatura', 1192.0000, 'ºC'),
	(343738, 145, '2015-02-01 00:01:03.000000', 'temperatura', 311.0000, 'ºC'),
	(343739, 145, '2015-02-01 00:01:04.000000', 'temperatura', 379.0000, 'ºC'),
	(343740, 145, '2015-02-01 00:01:05.000000', 'temperatura', 963.0000, 'ºC'),
	(343741, 145, '2015-02-01 00:01:06.000000', 'temperatura', 77.0000, 'ºC'),
	(343742, 145, '2015-02-01 00:01:07.000000', 'temperatura', 1098.0000, 'ºC'),
	(343743, 145, '2015-02-01 00:01:08.000000', 'temperatura', 461.0000, 'ºC'),
	(343744, 145, '2015-02-01 00:01:09.000000', 'temperatura', 210.0000, 'ºC'),
	(343745, 145, '2015-02-01 00:01:10.000000', 'temperatura', 866.0000, 'ºC'),
	(343746, 145, '2015-02-01 00:01:11.000000', 'temperatura', 101.0000, 'ºC'),
	(343747, 145, '2015-02-01 00:01:12.000000', 'temperatura', 306.0000, 'ºC'),
	(343748, 145, '2015-02-01 00:01:13.000000', 'temperatura', 28.0000, 'ºC'),
	(343749, 145, '2015-02-01 00:01:14.000000', 'temperatura', 425.0000, 'ºC'),
	(343750, 145, '2015-02-01 00:01:15.000000', 'temperatura', 838.0000, 'ºC'),
	(343751, 145, '2015-02-01 00:01:16.000000', 'temperatura', 519.0000, 'ºC'),
	(343752, 145, '2015-02-01 00:01:17.000000', 'temperatura', 80.0000, 'ºC'),
	(343753, 145, '2015-02-01 00:01:18.000000', 'temperatura', 43.0000, 'ºC'),
	(343754, 145, '2015-02-01 00:01:19.000000', 'temperatura', 1175.0000, 'ºC'),
	(343755, 145, '2015-02-01 00:01:20.000000', 'temperatura', 947.0000, 'ºC'),
	(343756, 145, '2015-02-01 00:01:21.000000', 'temperatura', 9.0000, 'ºC'),
	(343757, 145, '2015-02-01 00:01:22.000000', 'temperatura', 806.0000, 'ºC'),
	(343758, 145, '2015-02-01 00:01:23.000000', 'temperatura', 404.0000, 'ºC'),
	(343759, 145, '2015-02-01 00:01:24.000000', 'temperatura', 800.0000, 'ºC'),
	(343760, 145, '2015-02-01 00:01:25.000000', 'temperatura', 390.0000, 'ºC'),
	(343761, 145, '2015-02-01 00:01:26.000000', 'temperatura', 752.0000, 'ºC'),
	(343762, 145, '2015-02-01 00:01:27.000000', 'temperatura', 187.0000, 'ºC'),
	(343763, 145, '2015-02-01 00:01:28.000000', 'temperatura', 1083.0000, 'ºC'),
	(343764, 145, '2015-02-01 00:01:29.000000', 'temperatura', 53.0000, 'ºC'),
	(343765, 145, '2015-02-01 00:01:30.000000', 'temperatura', 617.0000, 'ºC'),
	(343766, 145, '2015-02-01 00:01:31.000000', 'temperatura', 524.0000, 'ºC'),
	(343767, 145, '2015-02-01 00:01:32.000000', 'temperatura', 773.0000, 'ºC'),
	(343768, 145, '2015-02-01 00:01:33.000000', 'temperatura', 1092.0000, 'ºC'),
	(343769, 145, '2015-02-01 00:01:34.000000', 'temperatura', 743.0000, 'ºC'),
	(343770, 145, '2015-02-01 00:01:35.000000', 'temperatura', 437.0000, 'ºC'),
	(343771, 145, '2015-02-01 00:01:36.000000', 'temperatura', 1158.0000, 'ºC'),
	(343772, 145, '2015-02-01 00:01:37.000000', 'temperatura', 878.0000, 'ºC'),
	(343773, 145, '2015-02-01 00:01:38.000000', 'temperatura', 916.0000, 'ºC'),
	(343774, 145, '2015-02-01 00:01:39.000000', 'temperatura', 749.0000, 'ºC'),
	(343775, 145, '2015-02-01 00:01:40.000000', 'temperatura', 995.0000, 'ºC'),
	(343776, 145, '2015-02-01 00:01:41.000000', 'temperatura', 327.0000, 'ºC'),
	(343777, 145, '2015-02-01 00:01:42.000000', 'temperatura', 1054.0000, 'ºC'),
	(343778, 145, '2015-02-01 00:01:43.000000', 'temperatura', 689.0000, 'ºC'),
	(343779, 145, '2015-02-01 00:01:44.000000', 'temperatura', 285.0000, 'ºC'),
	(343780, 145, '2015-02-01 00:01:45.000000', 'temperatura', 556.0000, 'ºC'),
	(343781, 145, '2015-02-01 00:01:46.000000', 'temperatura', 728.0000, 'ºC'),
	(343782, 145, '2015-02-01 00:01:47.000000', 'temperatura', 770.0000, 'ºC'),
	(343783, 145, '2015-02-01 00:01:48.000000', 'temperatura', 467.0000, 'ºC'),
	(343784, 145, '2015-02-01 00:01:49.000000', 'temperatura', 27.0000, 'ºC'),
	(343785, 145, '2015-02-01 00:01:50.000000', 'temperatura', 1132.0000, 'ºC'),
	(343786, 145, '2015-02-01 00:01:51.000000', 'temperatura', 779.0000, 'ºC'),
	(343787, 145, '2015-02-01 00:01:52.000000', 'temperatura', 501.0000, 'ºC'),
	(343788, 145, '2015-02-01 00:01:53.000000', 'temperatura', 166.0000, 'ºC'),
	(343789, 145, '2015-02-01 00:01:54.000000', 'temperatura', 531.0000, 'ºC'),
	(343790, 145, '2015-02-01 00:01:55.000000', 'temperatura', 956.0000, 'ºC'),
	(343791, 145, '2015-02-01 00:01:56.000000', 'temperatura', 787.0000, 'ºC'),
	(343792, 145, '2015-02-01 00:01:57.000000', 'temperatura', 1068.0000, 'ºC'),
	(343793, 145, '2015-02-01 00:01:58.000000', 'temperatura', 581.0000, 'ºC'),
	(343794, 145, '2015-02-01 00:01:59.000000', 'temperatura', 899.0000, 'ºC'),
	(343795, 145, '2015-02-01 00:02:00.000000', 'temperatura', 352.0000, 'ºC'),
	(343796, 145, '2015-02-01 00:02:01.000000', 'temperatura', 266.0000, 'ºC'),
	(343797, 145, '2015-02-01 00:02:02.000000', 'temperatura', 275.0000, 'ºC'),
	(343798, 145, '2015-02-01 00:02:03.000000', 'temperatura', 575.0000, 'ºC'),
	(343799, 145, '2015-02-01 00:02:04.000000', 'temperatura', 850.0000, 'ºC'),
	(343800, 145, '2015-02-01 00:02:05.000000', 'temperatura', 128.0000, 'ºC'),
	(343801, 145, '2015-02-01 00:02:06.000000', 'temperatura', 488.0000, 'ºC'),
	(343802, 145, '2015-02-01 00:02:07.000000', 'temperatura', 857.0000, 'ºC'),
	(343803, 145, '2015-02-01 00:02:08.000000', 'temperatura', 423.0000, 'ºC'),
	(343804, 145, '2015-02-01 00:02:09.000000', 'temperatura', 745.0000, 'ºC'),
	(343805, 145, '2015-02-01 00:02:10.000000', 'temperatura', 54.0000, 'ºC'),
	(343806, 145, '2015-02-01 00:02:11.000000', 'temperatura', 435.0000, 'ºC'),
	(343807, 145, '2015-02-01 00:02:12.000000', 'temperatura', 816.0000, 'ºC'),
	(343808, 145, '2015-02-01 00:02:13.000000', 'temperatura', 376.0000, 'ºC'),
	(343809, 145, '2015-02-01 00:02:14.000000', 'temperatura', 633.0000, 'ºC'),
	(343810, 145, '2015-02-01 00:02:15.000000', 'temperatura', 838.0000, 'ºC'),
	(343811, 145, '2015-02-01 00:02:16.000000', 'temperatura', 1092.0000, 'ºC'),
	(343812, 145, '2015-02-01 00:02:17.000000', 'temperatura', 547.0000, 'ºC'),
	(343813, 145, '2015-02-01 00:02:18.000000', 'temperatura', 659.0000, 'ºC'),
	(343814, 145, '2015-02-01 00:02:19.000000', 'temperatura', 455.0000, 'ºC'),
	(343815, 145, '2015-02-01 00:02:20.000000', 'temperatura', 299.0000, 'ºC'),
	(343816, 145, '2015-02-01 00:02:21.000000', 'temperatura', 132.0000, 'ºC'),
	(343817, 145, '2015-02-01 00:02:22.000000', 'temperatura', 960.0000, 'ºC'),
	(343818, 145, '2015-02-01 00:02:23.000000', 'temperatura', 805.0000, 'ºC'),
	(343819, 145, '2015-02-01 00:02:24.000000', 'temperatura', 1147.0000, 'ºC'),
	(343820, 145, '2015-02-01 00:02:25.000000', 'temperatura', 922.0000, 'ºC'),
	(343821, 145, '2015-02-01 00:02:26.000000', 'temperatura', 1167.0000, 'ºC'),
	(343822, 145, '2015-02-01 00:02:27.000000', 'temperatura', 669.0000, 'ºC'),
	(343823, 145, '2015-02-01 00:02:28.000000', 'temperatura', 1045.0000, 'ºC'),
	(343824, 145, '2015-02-01 00:02:29.000000', 'temperatura', 819.0000, 'ºC'),
	(343825, 145, '2015-02-01 00:02:30.000000', 'temperatura', 959.0000, 'ºC'),
	(343826, 145, '2015-02-01 00:02:31.000000', 'temperatura', 1141.0000, 'ºC'),
	(343827, 145, '2015-02-01 00:02:32.000000', 'temperatura', 427.0000, 'ºC'),
	(343828, 145, '2015-02-01 00:02:33.000000', 'temperatura', 1111.0000, 'ºC'),
	(343829, 145, '2015-02-01 00:02:34.000000', 'temperatura', 677.0000, 'ºC'),
	(343830, 145, '2015-02-01 00:02:35.000000', 'temperatura', 49.0000, 'ºC'),
	(343831, 145, '2015-02-01 00:02:36.000000', 'temperatura', 618.0000, 'ºC'),
	(343832, 145, '2015-02-01 00:02:37.000000', 'temperatura', 544.0000, 'ºC'),
	(343833, 145, '2015-02-01 00:02:38.000000', 'temperatura', 867.0000, 'ºC'),
	(343834, 145, '2015-02-01 00:02:39.000000', 'temperatura', 300.0000, 'ºC'),
	(343835, 145, '2015-02-01 00:02:40.000000', 'temperatura', 102.0000, 'ºC'),
	(343836, 145, '2015-02-01 00:02:41.000000', 'temperatura', 810.0000, 'ºC'),
	(343837, 145, '2015-02-01 00:02:42.000000', 'temperatura', 146.0000, 'ºC'),
	(343838, 145, '2015-02-01 00:02:43.000000', 'temperatura', 700.0000, 'ºC'),
	(343839, 145, '2015-02-01 00:02:44.000000', 'temperatura', 661.0000, 'ºC'),
	(343840, 145, '2015-02-01 00:02:45.000000', 'temperatura', 5.0000, 'ºC'),
	(343841, 145, '2015-02-01 00:02:46.000000', 'temperatura', 443.0000, 'ºC'),
	(343842, 145, '2015-02-01 00:02:47.000000', 'temperatura', 1003.0000, 'ºC'),
	(343843, 145, '2015-02-01 00:02:48.000000', 'temperatura', 84.0000, 'ºC'),
	(343844, 145, '2015-02-01 00:02:49.000000', 'temperatura', 1013.0000, 'ºC'),
	(343845, 145, '2015-02-01 00:02:50.000000', 'temperatura', 12.0000, 'ºC'),
	(343846, 145, '2015-02-01 00:02:51.000000', 'temperatura', 623.0000, 'ºC'),
	(343847, 145, '2015-02-01 00:02:52.000000', 'temperatura', 679.0000, 'ºC'),
	(343848, 145, '2015-02-01 00:02:53.000000', 'temperatura', 327.0000, 'ºC'),
	(343849, 145, '2015-02-01 00:02:54.000000', 'temperatura', 799.0000, 'ºC'),
	(343850, 145, '2015-02-01 00:02:55.000000', 'temperatura', 612.0000, 'ºC'),
	(343851, 145, '2015-02-01 00:02:56.000000', 'temperatura', 664.0000, 'ºC'),
	(343852, 145, '2015-02-01 00:02:57.000000', 'temperatura', 285.0000, 'ºC'),
	(343853, 145, '2015-02-01 00:02:58.000000', 'temperatura', 634.0000, 'ºC'),
	(343854, 145, '2015-02-01 00:02:59.000000', 'temperatura', 1115.0000, 'ºC'),
	(343855, 145, '2015-02-01 00:03:00.000000', 'temperatura', 73.0000, 'ºC'),
	(343856, 145, '2015-02-01 00:03:01.000000', 'temperatura', 622.0000, 'ºC'),
	(343857, 145, '2015-02-01 00:03:02.000000', 'temperatura', 491.0000, 'ºC'),
	(343858, 145, '2015-02-01 00:03:03.000000', 'temperatura', 589.0000, 'ºC'),
	(343859, 145, '2015-02-01 00:03:04.000000', 'temperatura', 272.0000, 'ºC'),
	(343860, 145, '2015-02-01 00:03:05.000000', 'temperatura', 795.0000, 'ºC'),
	(343861, 145, '2015-02-01 00:03:06.000000', 'temperatura', 759.0000, 'ºC'),
	(343862, 145, '2015-02-01 00:03:07.000000', 'temperatura', 211.0000, 'ºC'),
	(343863, 145, '2015-02-01 00:03:08.000000', 'temperatura', 1177.0000, 'ºC'),
	(343864, 145, '2015-02-01 00:03:09.000000', 'temperatura', 453.0000, 'ºC'),
	(343865, 145, '2015-02-01 00:03:10.000000', 'temperatura', 1137.0000, 'ºC'),
	(343866, 145, '2015-02-01 00:03:11.000000', 'temperatura', 723.0000, 'ºC'),
	(343867, 145, '2015-02-01 00:03:12.000000', 'temperatura', 207.0000, 'ºC'),
	(343868, 145, '2015-02-01 00:03:13.000000', 'temperatura', 68.0000, 'ºC'),
	(343869, 145, '2015-02-01 00:03:14.000000', 'temperatura', 916.0000, 'ºC'),
	(343870, 145, '2015-02-01 00:03:15.000000', 'temperatura', 780.0000, 'ºC'),
	(343871, 145, '2015-02-01 00:03:16.000000', 'temperatura', 1149.0000, 'ºC'),
	(343872, 145, '2015-02-01 00:03:17.000000', 'temperatura', 1007.0000, 'ºC'),
	(343873, 145, '2015-02-01 00:03:18.000000', 'temperatura', 388.0000, 'ºC'),
	(343874, 145, '2015-02-01 00:03:19.000000', 'temperatura', 118.0000, 'ºC'),
	(343875, 145, '2015-02-01 00:03:20.000000', 'temperatura', 627.0000, 'ºC'),
	(343876, 145, '2015-02-01 00:03:21.000000', 'temperatura', 382.0000, 'ºC'),
	(343877, 145, '2015-02-01 00:03:22.000000', 'temperatura', 31.0000, 'ºC'),
	(343878, 145, '2015-02-01 00:03:23.000000', 'temperatura', 209.0000, 'ºC'),
	(343879, 145, '2015-02-01 00:03:24.000000', 'temperatura', 951.0000, 'ºC'),
	(343880, 145, '2015-02-01 00:03:25.000000', 'temperatura', 529.0000, 'ºC'),
	(343881, 145, '2015-02-01 00:03:26.000000', 'temperatura', 995.0000, 'ºC'),
	(343882, 145, '2015-02-01 00:03:27.000000', 'temperatura', 986.0000, 'ºC'),
	(343883, 145, '2015-02-01 00:03:28.000000', 'temperatura', 745.0000, 'ºC'),
	(343884, 145, '2015-02-01 00:03:29.000000', 'temperatura', 767.0000, 'ºC'),
	(343885, 145, '2015-02-01 00:03:30.000000', 'temperatura', 402.0000, 'ºC'),
	(343886, 145, '2015-02-01 00:03:31.000000', 'temperatura', 908.0000, 'ºC'),
	(343887, 145, '2015-02-01 00:03:32.000000', 'temperatura', 935.0000, 'ºC'),
	(343888, 145, '2015-02-01 00:03:33.000000', 'temperatura', 754.0000, 'ºC'),
	(343889, 145, '2015-02-01 00:03:34.000000', 'temperatura', 962.0000, 'ºC'),
	(343890, 145, '2015-02-01 00:03:35.000000', 'temperatura', 152.0000, 'ºC'),
	(343891, 145, '2015-02-01 00:03:36.000000', 'temperatura', 272.0000, 'ºC'),
	(343892, 145, '2015-02-01 00:03:37.000000', 'temperatura', 903.0000, 'ºC'),
	(343893, 145, '2015-02-01 00:03:38.000000', 'temperatura', 102.0000, 'ºC'),
	(343894, 145, '2015-02-01 00:03:39.000000', 'temperatura', 202.0000, 'ºC'),
	(343895, 145, '2015-02-01 00:03:40.000000', 'temperatura', 704.0000, 'ºC'),
	(343896, 145, '2015-02-01 00:03:41.000000', 'temperatura', 514.0000, 'ºC'),
	(343897, 145, '2015-02-01 00:03:42.000000', 'temperatura', 458.0000, 'ºC'),
	(343898, 145, '2015-02-01 00:03:43.000000', 'temperatura', 749.0000, 'ºC'),
	(343899, 145, '2015-02-01 00:03:44.000000', 'temperatura', 1172.0000, 'ºC'),
	(343900, 145, '2015-02-01 00:03:45.000000', 'temperatura', 12.0000, 'ºC'),
	(343901, 145, '2015-02-01 00:03:46.000000', 'temperatura', 145.0000, 'ºC'),
	(343902, 145, '2015-02-01 00:03:47.000000', 'temperatura', 691.0000, 'ºC'),
	(343903, 145, '2015-02-01 00:03:48.000000', 'temperatura', 619.0000, 'ºC'),
	(343904, 145, '2015-02-01 00:03:49.000000', 'temperatura', 1021.0000, 'ºC'),
	(343905, 145, '2015-02-01 00:03:50.000000', 'temperatura', 852.0000, 'ºC'),
	(343906, 145, '2015-02-01 00:03:51.000000', 'temperatura', 1194.0000, 'ºC'),
	(343907, 145, '2015-02-01 00:03:52.000000', 'temperatura', 1016.0000, 'ºC'),
	(343908, 145, '2015-02-01 00:03:53.000000', 'temperatura', 299.0000, 'ºC'),
	(343909, 145, '2015-02-01 00:03:54.000000', 'temperatura', 845.0000, 'ºC'),
	(343910, 145, '2015-02-01 00:03:55.000000', 'temperatura', 930.0000, 'ºC'),
	(343911, 145, '2015-02-01 00:03:56.000000', 'temperatura', 917.0000, 'ºC'),
	(343912, 145, '2015-02-01 00:03:57.000000', 'temperatura', 594.0000, 'ºC'),
	(343913, 145, '2015-02-01 00:03:58.000000', 'temperatura', 219.0000, 'ºC'),
	(343914, 145, '2015-02-01 00:03:59.000000', 'temperatura', 515.0000, 'ºC'),
	(343915, 145, '2015-02-01 00:04:00.000000', 'temperatura', 717.0000, 'ºC'),
	(343916, 145, '2015-02-01 00:04:01.000000', 'temperatura', 843.0000, 'ºC'),
	(343917, 145, '2015-02-01 00:04:02.000000', 'temperatura', 864.0000, 'ºC'),
	(343918, 145, '2015-02-01 00:04:03.000000', 'temperatura', 589.0000, 'ºC'),
	(343919, 145, '2015-02-01 00:04:04.000000', 'temperatura', 355.0000, 'ºC'),
	(343920, 145, '2015-02-01 00:04:05.000000', 'temperatura', 10.0000, 'ºC'),
	(343921, 145, '2015-02-01 00:04:06.000000', 'temperatura', 184.0000, 'ºC'),
	(343922, 145, '2015-02-01 00:04:07.000000', 'temperatura', 890.0000, 'ºC'),
	(343923, 145, '2015-02-01 00:04:08.000000', 'temperatura', 299.0000, 'ºC'),
	(343924, 145, '2015-02-01 00:04:09.000000', 'temperatura', 25.0000, 'ºC'),
	(343925, 145, '2015-02-01 00:04:10.000000', 'temperatura', 430.0000, 'ºC'),
	(343926, 145, '2015-02-01 00:04:11.000000', 'temperatura', 873.0000, 'ºC'),
	(343927, 145, '2015-02-01 00:04:12.000000', 'temperatura', 678.0000, 'ºC'),
	(343928, 145, '2015-02-01 00:04:13.000000', 'temperatura', 770.0000, 'ºC'),
	(343929, 145, '2015-02-01 00:04:14.000000', 'temperatura', 615.0000, 'ºC'),
	(343930, 145, '2015-02-01 00:04:15.000000', 'temperatura', 769.0000, 'ºC'),
	(343931, 145, '2015-02-01 00:04:16.000000', 'temperatura', 798.0000, 'ºC'),
	(343932, 145, '2015-02-01 00:04:17.000000', 'temperatura', 483.0000, 'ºC'),
	(343933, 145, '2015-02-01 00:04:18.000000', 'temperatura', 21.0000, 'ºC'),
	(343934, 145, '2015-02-01 00:04:19.000000', 'temperatura', 1056.0000, 'ºC'),
	(343935, 145, '2015-02-01 00:04:20.000000', 'temperatura', 419.0000, 'ºC'),
	(343936, 145, '2015-02-01 00:04:21.000000', 'temperatura', 129.0000, 'ºC'),
	(343937, 145, '2015-02-01 00:04:22.000000', 'temperatura', 587.0000, 'ºC'),
	(343938, 145, '2015-02-01 00:04:23.000000', 'temperatura', 151.0000, 'ºC'),
	(343939, 145, '2015-02-01 00:04:24.000000', 'temperatura', 192.0000, 'ºC'),
	(343940, 145, '2015-02-01 00:04:25.000000', 'temperatura', 507.0000, 'ºC'),
	(343941, 145, '2015-02-01 00:04:26.000000', 'temperatura', 760.0000, 'ºC'),
	(343942, 145, '2015-02-01 00:04:27.000000', 'temperatura', 1078.0000, 'ºC'),
	(343943, 145, '2015-02-01 00:04:28.000000', 'temperatura', 712.0000, 'ºC'),
	(343944, 145, '2015-02-01 00:04:29.000000', 'temperatura', 326.0000, 'ºC'),
	(343945, 145, '2015-02-01 00:04:30.000000', 'temperatura', 695.0000, 'ºC'),
	(343946, 145, '2015-02-01 00:04:31.000000', 'temperatura', 99.0000, 'ºC'),
	(343947, 145, '2015-02-01 00:04:32.000000', 'temperatura', 811.0000, 'ºC'),
	(343948, 145, '2015-02-01 00:04:33.000000', 'temperatura', 156.0000, 'ºC'),
	(343949, 145, '2015-02-01 00:04:34.000000', 'temperatura', 747.0000, 'ºC'),
	(343950, 145, '2015-02-01 00:04:35.000000', 'temperatura', 869.0000, 'ºC'),
	(343951, 145, '2015-02-01 00:04:36.000000', 'temperatura', 902.0000, 'ºC'),
	(343952, 145, '2015-02-01 00:04:37.000000', 'temperatura', 707.0000, 'ºC'),
	(343953, 145, '2015-02-01 00:04:38.000000', 'temperatura', 829.0000, 'ºC'),
	(343954, 145, '2015-02-01 00:04:39.000000', 'temperatura', 823.0000, 'ºC'),
	(343955, 145, '2015-02-01 00:04:40.000000', 'temperatura', 427.0000, 'ºC'),
	(343956, 145, '2015-02-01 00:04:41.000000', 'temperatura', 870.0000, 'ºC'),
	(343957, 145, '2015-02-01 00:04:42.000000', 'temperatura', 667.0000, 'ºC'),
	(343958, 145, '2015-02-01 00:04:43.000000', 'temperatura', 725.0000, 'ºC'),
	(343959, 145, '2015-02-01 00:04:44.000000', 'temperatura', 424.0000, 'ºC'),
	(343960, 145, '2015-02-01 00:04:45.000000', 'temperatura', 1148.0000, 'ºC'),
	(343961, 145, '2015-02-01 00:04:46.000000', 'temperatura', 868.0000, 'ºC'),
	(343962, 145, '2015-02-01 00:04:47.000000', 'temperatura', 894.0000, 'ºC'),
	(343963, 145, '2015-02-01 00:04:48.000000', 'temperatura', 668.0000, 'ºC'),
	(343964, 145, '2015-02-01 00:04:49.000000', 'temperatura', 660.0000, 'ºC'),
	(343965, 145, '2015-02-01 00:04:50.000000', 'temperatura', 97.0000, 'ºC'),
	(343966, 145, '2015-02-01 00:04:51.000000', 'temperatura', 903.0000, 'ºC'),
	(343967, 145, '2015-02-01 00:04:52.000000', 'temperatura', 624.0000, 'ºC'),
	(343968, 145, '2015-02-01 00:04:53.000000', 'temperatura', 415.0000, 'ºC'),
	(343969, 145, '2015-02-01 00:04:54.000000', 'temperatura', 200.0000, 'ºC'),
	(343970, 145, '2015-02-01 00:04:55.000000', 'temperatura', 957.0000, 'ºC'),
	(343971, 145, '2015-02-01 00:04:56.000000', 'temperatura', 585.0000, 'ºC'),
	(343972, 145, '2015-02-01 00:04:57.000000', 'temperatura', 56.0000, 'ºC'),
	(343973, 145, '2015-02-01 00:04:58.000000', 'temperatura', 923.0000, 'ºC'),
	(343974, 145, '2015-02-01 00:04:59.000000', 'temperatura', 849.0000, 'ºC'),
	(343975, 145, '2015-02-01 00:05:00.000000', 'temperatura', 274.0000, 'ºC'),
	(343976, 145, '2015-02-01 00:05:01.000000', 'temperatura', 26.0000, 'ºC'),
	(343977, 145, '2015-02-01 00:05:02.000000', 'temperatura', 510.0000, 'ºC'),
	(343978, 145, '2015-02-01 00:05:03.000000', 'temperatura', 71.0000, 'ºC'),
	(343979, 145, '2015-02-01 00:05:04.000000', 'temperatura', 25.0000, 'ºC'),
	(343980, 145, '2015-02-01 00:05:05.000000', 'temperatura', 1112.0000, 'ºC'),
	(343981, 145, '2015-02-01 00:05:06.000000', 'temperatura', 687.0000, 'ºC'),
	(343982, 145, '2015-02-01 00:05:07.000000', 'temperatura', 101.0000, 'ºC'),
	(343983, 145, '2015-02-01 00:05:08.000000', 'temperatura', 842.0000, 'ºC'),
	(343984, 145, '2015-02-01 00:05:09.000000', 'temperatura', 307.0000, 'ºC'),
	(343985, 145, '2015-02-01 00:05:10.000000', 'temperatura', 209.0000, 'ºC'),
	(343986, 145, '2015-02-01 00:05:11.000000', 'temperatura', 126.0000, 'ºC'),
	(343987, 145, '2015-02-01 00:05:12.000000', 'temperatura', 4.0000, 'ºC'),
	(343988, 145, '2015-02-01 00:05:13.000000', 'temperatura', 842.0000, 'ºC'),
	(343989, 145, '2015-02-01 00:05:14.000000', 'temperatura', 597.0000, 'ºC'),
	(343990, 145, '2015-02-01 00:05:15.000000', 'temperatura', 460.0000, 'ºC'),
	(343991, 145, '2015-02-01 00:05:16.000000', 'temperatura', 512.0000, 'ºC'),
	(343992, 145, '2015-02-01 00:05:17.000000', 'temperatura', 1177.0000, 'ºC'),
	(343993, 145, '2015-02-01 00:05:18.000000', 'temperatura', 753.0000, 'ºC'),
	(343994, 145, '2015-02-01 00:05:19.000000', 'temperatura', 233.0000, 'ºC'),
	(343995, 145, '2015-02-01 00:05:20.000000', 'temperatura', 106.0000, 'ºC'),
	(343996, 145, '2015-02-01 00:05:21.000000', 'temperatura', 1032.0000, 'ºC'),
	(343997, 145, '2015-02-01 00:05:22.000000', 'temperatura', 42.0000, 'ºC'),
	(343998, 145, '2015-02-01 00:05:23.000000', 'temperatura', 713.0000, 'ºC'),
	(343999, 145, '2015-02-01 00:05:24.000000', 'temperatura', 1042.0000, 'ºC'),
	(344000, 145, '2015-02-01 00:05:25.000000', 'temperatura', 670.0000, 'ºC'),
	(344001, 145, '2015-02-01 00:05:26.000000', 'temperatura', 226.0000, 'ºC'),
	(344002, 145, '2015-02-01 00:05:27.000000', 'temperatura', 320.0000, 'ºC'),
	(344003, 145, '2015-02-01 00:05:28.000000', 'temperatura', 924.0000, 'ºC'),
	(344004, 145, '2015-02-01 00:05:29.000000', 'temperatura', 59.0000, 'ºC'),
	(344005, 145, '2015-02-01 00:05:30.000000', 'temperatura', 1123.0000, 'ºC'),
	(344006, 145, '2015-02-01 00:05:31.000000', 'temperatura', 638.0000, 'ºC'),
	(344007, 145, '2015-02-01 00:05:32.000000', 'temperatura', 1023.0000, 'ºC'),
	(344008, 145, '2015-02-01 00:05:33.000000', 'temperatura', 800.0000, 'ºC'),
	(344009, 145, '2015-02-01 00:05:34.000000', 'temperatura', 930.0000, 'ºC'),
	(344010, 145, '2015-02-01 00:05:35.000000', 'temperatura', 1053.0000, 'ºC'),
	(344011, 145, '2015-02-01 00:05:36.000000', 'temperatura', 73.0000, 'ºC'),
	(344012, 145, '2015-02-01 00:05:37.000000', 'temperatura', 807.0000, 'ºC'),
	(344013, 145, '2015-02-01 00:05:38.000000', 'temperatura', 217.0000, 'ºC'),
	(344014, 145, '2015-02-01 00:05:39.000000', 'temperatura', 1065.0000, 'ºC'),
	(344015, 145, '2015-02-01 00:05:40.000000', 'temperatura', 1075.0000, 'ºC'),
	(344016, 145, '2015-02-01 00:05:41.000000', 'temperatura', 978.0000, 'ºC'),
	(344017, 145, '2015-02-01 00:05:42.000000', 'temperatura', 468.0000, 'ºC'),
	(344018, 145, '2015-02-01 00:05:43.000000', 'temperatura', 605.0000, 'ºC'),
	(344019, 145, '2015-02-01 00:05:44.000000', 'temperatura', 424.0000, 'ºC'),
	(344020, 145, '2015-02-01 00:05:45.000000', 'temperatura', 304.0000, 'ºC'),
	(344021, 145, '2015-02-01 00:05:46.000000', 'temperatura', 249.0000, 'ºC'),
	(344022, 145, '2015-02-01 00:05:47.000000', 'temperatura', 335.0000, 'ºC'),
	(344023, 145, '2015-02-01 00:05:48.000000', 'temperatura', 926.0000, 'ºC'),
	(344024, 145, '2015-02-01 00:05:49.000000', 'temperatura', 26.0000, 'ºC'),
	(344025, 145, '2015-02-01 00:05:50.000000', 'temperatura', 951.0000, 'ºC'),
	(344026, 145, '2015-02-01 00:05:51.000000', 'temperatura', 1078.0000, 'ºC'),
	(344027, 145, '2015-02-01 00:05:52.000000', 'temperatura', 137.0000, 'ºC'),
	(344028, 145, '2015-02-01 00:05:53.000000', 'temperatura', 1053.0000, 'ºC'),
	(344029, 145, '2015-02-01 00:05:54.000000', 'temperatura', 54.0000, 'ºC'),
	(344030, 145, '2015-02-01 00:05:55.000000', 'temperatura', 710.0000, 'ºC'),
	(344031, 145, '2015-02-01 00:05:56.000000', 'temperatura', 990.0000, 'ºC'),
	(344032, 145, '2015-02-01 00:05:57.000000', 'temperatura', 421.0000, 'ºC'),
	(344033, 145, '2015-02-01 00:05:58.000000', 'temperatura', 335.0000, 'ºC'),
	(344034, 145, '2015-02-01 00:05:59.000000', 'temperatura', 414.0000, 'ºC'),
	(344035, 145, '2015-02-01 00:06:00.000000', 'temperatura', 1066.0000, 'ºC'),
	(344036, 145, '2015-02-01 00:06:01.000000', 'temperatura', 488.0000, 'ºC'),
	(344037, 145, '2015-02-01 00:06:02.000000', 'temperatura', 441.0000, 'ºC'),
	(344038, 145, '2015-02-01 00:06:03.000000', 'temperatura', 740.0000, 'ºC'),
	(344039, 145, '2015-02-01 00:06:04.000000', 'temperatura', 1180.0000, 'ºC'),
	(344040, 145, '2015-02-01 00:06:05.000000', 'temperatura', 78.0000, 'ºC'),
	(344041, 145, '2015-02-01 00:06:06.000000', 'temperatura', 452.0000, 'ºC'),
	(344042, 145, '2015-02-01 00:06:07.000000', 'temperatura', 828.0000, 'ºC'),
	(344043, 145, '2015-02-01 00:06:08.000000', 'temperatura', 382.0000, 'ºC'),
	(344044, 145, '2015-02-01 00:06:09.000000', 'temperatura', 629.0000, 'ºC'),
	(344045, 145, '2015-02-01 00:06:10.000000', 'temperatura', 798.0000, 'ºC'),
	(344046, 145, '2015-02-01 00:06:11.000000', 'temperatura', 904.0000, 'ºC'),
	(344047, 145, '2015-02-01 00:06:12.000000', 'temperatura', 925.0000, 'ºC'),
	(344048, 145, '2015-02-01 00:06:13.000000', 'temperatura', 715.0000, 'ºC'),
	(344049, 145, '2015-02-01 00:06:14.000000', 'temperatura', 801.0000, 'ºC'),
	(344050, 145, '2015-02-01 00:06:15.000000', 'temperatura', 661.0000, 'ºC'),
	(344051, 145, '2015-02-01 00:06:16.000000', 'temperatura', 901.0000, 'ºC'),
	(344052, 145, '2015-02-01 00:06:17.000000', 'temperatura', 123.0000, 'ºC'),
	(344053, 145, '2015-02-01 00:06:18.000000', 'temperatura', 312.0000, 'ºC'),
	(344054, 145, '2015-02-01 00:06:19.000000', 'temperatura', 1190.0000, 'ºC'),
	(344055, 145, '2015-02-01 00:06:20.000000', 'temperatura', 218.0000, 'ºC'),
	(344056, 145, '2015-02-01 00:06:21.000000', 'temperatura', 1119.0000, 'ºC'),
	(344057, 145, '2015-02-01 00:06:22.000000', 'temperatura', 140.0000, 'ºC'),
	(344058, 145, '2015-02-01 00:06:23.000000', 'temperatura', 942.0000, 'ºC'),
	(344059, 145, '2015-02-01 00:06:24.000000', 'temperatura', 694.0000, 'ºC'),
	(344060, 145, '2015-02-01 00:06:25.000000', 'temperatura', 645.0000, 'ºC'),
	(344061, 145, '2015-02-01 00:06:26.000000', 'temperatura', 1140.0000, 'ºC'),
	(344062, 145, '2015-02-01 00:06:27.000000', 'temperatura', 169.0000, 'ºC'),
	(344063, 145, '2015-02-01 00:06:28.000000', 'temperatura', 1025.0000, 'ºC'),
	(344064, 145, '2015-02-01 00:06:29.000000', 'temperatura', 1018.0000, 'ºC'),
	(344065, 145, '2015-02-01 00:06:30.000000', 'temperatura', 817.0000, 'ºC'),
	(344066, 145, '2015-02-01 00:06:31.000000', 'temperatura', 1029.0000, 'ºC'),
	(344067, 145, '2015-02-01 00:06:32.000000', 'temperatura', 297.0000, 'ºC'),
	(344068, 145, '2015-02-01 00:06:33.000000', 'temperatura', 795.0000, 'ºC'),
	(344069, 145, '2015-02-01 00:06:34.000000', 'temperatura', 687.0000, 'ºC'),
	(344070, 145, '2015-02-01 00:06:35.000000', 'temperatura', 1052.0000, 'ºC'),
	(344071, 145, '2015-02-01 00:06:36.000000', 'temperatura', 798.0000, 'ºC'),
	(344072, 145, '2015-02-01 00:06:37.000000', 'temperatura', 836.0000, 'ºC'),
	(344073, 145, '2015-02-01 00:06:38.000000', 'temperatura', 585.0000, 'ºC'),
	(344074, 145, '2015-02-01 00:06:39.000000', 'temperatura', 420.0000, 'ºC'),
	(344075, 145, '2015-02-01 00:06:40.000000', 'temperatura', 344.0000, 'ºC'),
	(344076, 145, '2015-02-01 00:06:41.000000', 'temperatura', 460.0000, 'ºC'),
	(344077, 145, '2015-02-01 00:06:42.000000', 'temperatura', 67.0000, 'ºC'),
	(344078, 145, '2015-02-01 00:06:43.000000', 'temperatura', 156.0000, 'ºC'),
	(344079, 145, '2015-02-01 00:06:44.000000', 'temperatura', 582.0000, 'ºC'),
	(344080, 145, '2015-02-01 00:06:45.000000', 'temperatura', 41.0000, 'ºC'),
	(344081, 145, '2015-02-01 00:06:46.000000', 'temperatura', 860.0000, 'ºC'),
	(344082, 145, '2015-02-01 00:06:47.000000', 'temperatura', 579.0000, 'ºC'),
	(344083, 145, '2015-02-01 00:06:48.000000', 'temperatura', 312.0000, 'ºC'),
	(344084, 145, '2015-02-01 00:06:49.000000', 'temperatura', 1027.0000, 'ºC'),
	(344085, 145, '2015-02-01 00:06:50.000000', 'temperatura', 598.0000, 'ºC'),
	(344086, 145, '2015-02-01 00:06:51.000000', 'temperatura', 1109.0000, 'ºC'),
	(344087, 145, '2015-02-01 00:06:52.000000', 'temperatura', 151.0000, 'ºC'),
	(344088, 145, '2015-02-01 00:06:53.000000', 'temperatura', 1031.0000, 'ºC'),
	(344089, 145, '2015-02-01 00:06:54.000000', 'temperatura', 1101.0000, 'ºC'),
	(344090, 145, '2015-02-01 00:06:55.000000', 'temperatura', 11.0000, 'ºC'),
	(344091, 145, '2015-02-01 00:06:56.000000', 'temperatura', 355.0000, 'ºC'),
	(344092, 145, '2015-02-01 00:06:57.000000', 'temperatura', 541.0000, 'ºC'),
	(344093, 145, '2015-02-01 00:06:58.000000', 'temperatura', 439.0000, 'ºC'),
	(344094, 145, '2015-02-01 00:06:59.000000', 'temperatura', 573.0000, 'ºC'),
	(344095, 145, '2015-02-01 00:07:00.000000', 'temperatura', 348.0000, 'ºC'),
	(344096, 145, '2015-02-01 00:07:01.000000', 'temperatura', 22.0000, 'ºC'),
	(344097, 145, '2015-02-01 00:07:02.000000', 'temperatura', 268.0000, 'ºC'),
	(344098, 145, '2015-02-01 00:07:03.000000', 'temperatura', 73.0000, 'ºC'),
	(344099, 145, '2015-02-01 00:07:04.000000', 'temperatura', 761.0000, 'ºC'),
	(344100, 145, '2015-02-01 00:07:05.000000', 'temperatura', 1187.0000, 'ºC'),
	(344101, 145, '2015-02-01 00:07:06.000000', 'temperatura', 53.0000, 'ºC'),
	(344102, 145, '2015-02-01 00:07:07.000000', 'temperatura', 303.0000, 'ºC'),
	(344103, 145, '2015-02-01 00:07:08.000000', 'temperatura', 158.0000, 'ºC'),
	(344104, 145, '2015-02-01 00:07:09.000000', 'temperatura', 1082.0000, 'ºC'),
	(344105, 145, '2015-02-01 00:07:10.000000', 'temperatura', 135.0000, 'ºC'),
	(344106, 145, '2015-02-01 00:07:11.000000', 'temperatura', 1029.0000, 'ºC'),
	(344107, 145, '2015-02-01 00:07:12.000000', 'temperatura', 1140.0000, 'ºC'),
	(344108, 145, '2015-02-01 00:07:13.000000', 'temperatura', 216.0000, 'ºC'),
	(344109, 145, '2015-02-01 00:07:14.000000', 'temperatura', 61.0000, 'ºC'),
	(344110, 145, '2015-02-01 00:07:15.000000', 'temperatura', 858.0000, 'ºC'),
	(344111, 145, '2015-02-01 00:07:16.000000', 'temperatura', 505.0000, 'ºC'),
	(344112, 145, '2015-02-01 00:07:17.000000', 'temperatura', 1151.0000, 'ºC'),
	(344113, 145, '2015-02-01 00:07:18.000000', 'temperatura', 643.0000, 'ºC'),
	(344114, 145, '2015-02-01 00:07:19.000000', 'temperatura', 962.0000, 'ºC'),
	(344115, 145, '2015-02-01 00:07:20.000000', 'temperatura', 482.0000, 'ºC'),
	(344116, 145, '2015-02-01 00:07:21.000000', 'temperatura', 724.0000, 'ºC'),
	(344117, 145, '2015-02-01 00:07:22.000000', 'temperatura', 973.0000, 'ºC'),
	(344118, 145, '2015-02-01 00:07:23.000000', 'temperatura', 294.0000, 'ºC'),
	(344119, 145, '2015-02-01 00:07:24.000000', 'temperatura', 953.0000, 'ºC'),
	(344120, 145, '2015-02-01 00:07:25.000000', 'temperatura', 281.0000, 'ºC'),
	(344121, 145, '2015-02-01 00:07:26.000000', 'temperatura', 946.0000, 'ºC'),
	(344122, 145, '2015-02-01 00:07:27.000000', 'temperatura', 288.0000, 'ºC'),
	(344123, 145, '2015-02-01 00:07:28.000000', 'temperatura', 1002.0000, 'ºC'),
	(344124, 145, '2015-02-01 00:07:29.000000', 'temperatura', 549.0000, 'ºC'),
	(344125, 145, '2015-02-01 00:07:30.000000', 'temperatura', 938.0000, 'ºC'),
	(344126, 145, '2015-02-01 00:07:31.000000', 'temperatura', 644.0000, 'ºC'),
	(344127, 145, '2015-02-01 00:07:32.000000', 'temperatura', 407.0000, 'ºC'),
	(344128, 145, '2015-02-01 00:07:33.000000', 'temperatura', 102.0000, 'ºC'),
	(344129, 145, '2015-02-01 00:07:34.000000', 'temperatura', 489.0000, 'ºC'),
	(344130, 145, '2015-02-01 00:07:35.000000', 'temperatura', 942.0000, 'ºC'),
	(344131, 145, '2015-02-01 00:07:36.000000', 'temperatura', 842.0000, 'ºC'),
	(344132, 145, '2015-02-01 00:07:37.000000', 'temperatura', 185.0000, 'ºC'),
	(344133, 145, '2015-02-01 00:07:38.000000', 'temperatura', 799.0000, 'ºC'),
	(344134, 145, '2015-02-01 00:07:39.000000', 'temperatura', 1040.0000, 'ºC'),
	(344135, 145, '2015-02-01 00:07:40.000000', 'temperatura', 403.0000, 'ºC'),
	(344136, 145, '2015-02-01 00:07:41.000000', 'temperatura', 96.0000, 'ºC'),
	(344137, 145, '2015-02-01 00:07:42.000000', 'temperatura', 471.0000, 'ºC'),
	(344138, 145, '2015-02-01 00:07:43.000000', 'temperatura', 866.0000, 'ºC'),
	(344139, 145, '2015-02-01 00:07:44.000000', 'temperatura', 520.0000, 'ºC'),
	(344140, 145, '2015-02-01 00:07:45.000000', 'temperatura', 3.0000, 'ºC'),
	(344141, 145, '2015-02-01 00:07:46.000000', 'temperatura', 855.0000, 'ºC'),
	(344142, 145, '2015-02-01 00:07:47.000000', 'temperatura', 666.0000, 'ºC'),
	(344143, 145, '2015-02-01 00:07:48.000000', 'temperatura', 765.0000, 'ºC'),
	(344144, 145, '2015-02-01 00:07:49.000000', 'temperatura', 628.0000, 'ºC'),
	(344145, 145, '2015-02-01 00:07:50.000000', 'temperatura', 845.0000, 'ºC'),
	(344146, 145, '2015-02-01 00:07:51.000000', 'temperatura', 1142.0000, 'ºC'),
	(344147, 145, '2015-02-01 00:07:52.000000', 'temperatura', 773.0000, 'ºC'),
	(344148, 145, '2015-02-01 00:07:53.000000', 'temperatura', 443.0000, 'ºC'),
	(344149, 145, '2015-02-01 00:07:54.000000', 'temperatura', 1094.0000, 'ºC'),
	(344150, 145, '2015-02-01 00:07:55.000000', 'temperatura', 541.0000, 'ºC'),
	(344151, 145, '2015-02-01 00:07:56.000000', 'temperatura', 624.0000, 'ºC'),
	(344152, 145, '2015-02-01 00:07:57.000000', 'temperatura', 297.0000, 'ºC'),
	(344153, 145, '2015-02-01 00:07:58.000000', 'temperatura', 815.0000, 'ºC'),
	(344154, 145, '2015-02-01 00:07:59.000000', 'temperatura', 783.0000, 'ºC'),
	(344155, 145, '2015-02-01 00:08:00.000000', 'temperatura', 272.0000, 'ºC'),
	(344156, 145, '2015-02-01 00:08:01.000000', 'temperatura', 209.0000, 'ºC'),
	(344157, 145, '2015-02-01 00:08:02.000000', 'temperatura', 231.0000, 'ºC'),
	(344158, 145, '2015-02-01 00:08:03.000000', 'temperatura', 529.0000, 'ºC'),
	(344159, 145, '2015-02-01 00:08:04.000000', 'temperatura', 753.0000, 'ºC'),
	(344160, 145, '2015-02-01 00:08:05.000000', 'temperatura', 977.0000, 'ºC'),
	(344161, 145, '2015-02-01 00:08:06.000000', 'temperatura', 228.0000, 'ºC'),
	(344162, 145, '2015-02-01 00:08:07.000000', 'temperatura', 610.0000, 'ºC'),
	(344163, 145, '2015-02-01 00:08:08.000000', 'temperatura', 1166.0000, 'ºC'),
	(344164, 145, '2015-02-01 00:08:09.000000', 'temperatura', 400.0000, 'ºC'),
	(344165, 145, '2015-02-01 00:08:10.000000', 'temperatura', 904.0000, 'ºC'),
	(344166, 145, '2015-02-01 00:08:11.000000', 'temperatura', 920.0000, 'ºC'),
	(344167, 145, '2015-02-01 00:08:12.000000', 'temperatura', 688.0000, 'ºC'),
	(344168, 145, '2015-02-01 00:08:13.000000', 'temperatura', 680.0000, 'ºC'),
	(344169, 145, '2015-02-01 00:08:14.000000', 'temperatura', 137.0000, 'ºC'),
	(344170, 145, '2015-02-01 00:08:15.000000', 'temperatura', 1047.0000, 'ºC'),
	(344171, 145, '2015-02-01 00:08:16.000000', 'temperatura', 24.0000, 'ºC'),
	(344172, 145, '2015-02-01 00:08:17.000000', 'temperatura', 580.0000, 'ºC'),
	(344173, 145, '2015-02-01 00:08:18.000000', 'temperatura', 428.0000, 'ºC'),
	(344174, 145, '2015-02-01 00:08:19.000000', 'temperatura', 402.0000, 'ºC'),
	(344175, 145, '2015-02-01 00:08:20.000000', 'temperatura', 726.0000, 'ºC'),
	(344176, 145, '2015-02-01 00:08:21.000000', 'temperatura', 26.0000, 'ºC'),
	(344177, 145, '2015-02-01 00:08:22.000000', 'temperatura', 351.0000, 'ºC'),
	(344178, 145, '2015-02-01 00:08:23.000000', 'temperatura', 478.0000, 'ºC'),
	(344179, 145, '2015-02-01 00:08:24.000000', 'temperatura', 139.0000, 'ºC'),
	(344180, 145, '2015-02-01 00:08:25.000000', 'temperatura', 460.0000, 'ºC'),
	(344181, 145, '2015-02-01 00:08:26.000000', 'temperatura', 682.0000, 'ºC'),
	(344182, 145, '2015-02-01 00:08:27.000000', 'temperatura', 830.0000, 'ºC'),
	(344183, 145, '2015-02-01 00:08:28.000000', 'temperatura', 905.0000, 'ºC'),
	(344184, 145, '2015-02-01 00:08:29.000000', 'temperatura', 837.0000, 'ºC'),
	(344185, 145, '2015-02-01 00:08:30.000000', 'temperatura', 269.0000, 'ºC'),
	(344186, 145, '2015-02-01 00:08:31.000000', 'temperatura', 34.0000, 'ºC'),
	(344187, 145, '2015-02-01 00:08:32.000000', 'temperatura', 566.0000, 'ºC'),
	(344188, 145, '2015-02-01 00:08:33.000000', 'temperatura', 327.0000, 'ºC'),
	(344189, 145, '2015-02-01 00:08:34.000000', 'temperatura', 1136.0000, 'ºC'),
	(344190, 145, '2015-02-01 00:08:35.000000', 'temperatura', 1101.0000, 'ºC'),
	(344191, 145, '2015-02-01 00:08:36.000000', 'temperatura', 898.0000, 'ºC'),
	(344192, 145, '2015-02-01 00:08:37.000000', 'temperatura', 1186.0000, 'ºC'),
	(344193, 145, '2015-02-01 00:08:38.000000', 'temperatura', 839.0000, 'ºC'),
	(344194, 145, '2015-02-01 00:08:39.000000', 'temperatura', 637.0000, 'ºC'),
	(344195, 145, '2015-02-01 00:08:40.000000', 'temperatura', 670.0000, 'ºC'),
	(344196, 145, '2015-02-01 00:08:41.000000', 'temperatura', 236.0000, 'ºC'),
	(344197, 145, '2015-02-01 00:08:42.000000', 'temperatura', 373.0000, 'ºC'),
	(344198, 145, '2015-02-01 00:08:43.000000', 'temperatura', 1157.0000, 'ºC'),
	(344199, 145, '2015-02-01 00:08:44.000000', 'temperatura', 1068.0000, 'ºC'),
	(344200, 145, '2015-02-01 00:08:45.000000', 'temperatura', 668.0000, 'ºC'),
	(344201, 145, '2015-02-01 00:08:46.000000', 'temperatura', 138.0000, 'ºC'),
	(344202, 145, '2015-02-01 00:08:47.000000', 'temperatura', 1086.0000, 'ºC'),
	(344203, 145, '2015-02-01 00:08:48.000000', 'temperatura', 215.0000, 'ºC'),
	(344204, 145, '2015-02-01 00:08:49.000000', 'temperatura', 220.0000, 'ºC'),
	(344205, 145, '2015-02-01 00:08:50.000000', 'temperatura', 453.0000, 'ºC'),
	(344206, 145, '2015-02-01 00:08:51.000000', 'temperatura', 405.0000, 'ºC'),
	(344207, 145, '2015-02-01 00:08:52.000000', 'temperatura', 668.0000, 'ºC'),
	(344208, 145, '2015-02-01 00:08:53.000000', 'temperatura', 925.0000, 'ºC'),
	(344209, 145, '2015-02-01 00:08:54.000000', 'temperatura', 224.0000, 'ºC'),
	(344210, 145, '2015-02-01 00:08:55.000000', 'temperatura', 742.0000, 'ºC'),
	(344211, 145, '2015-02-01 00:08:56.000000', 'temperatura', 641.0000, 'ºC'),
	(344212, 145, '2015-02-01 00:08:57.000000', 'temperatura', 979.0000, 'ºC'),
	(344213, 145, '2015-02-01 00:08:58.000000', 'temperatura', 573.0000, 'ºC'),
	(344214, 145, '2015-02-01 00:08:59.000000', 'temperatura', 1128.0000, 'ºC'),
	(344215, 145, '2015-02-01 00:09:00.000000', 'temperatura', 322.0000, 'ºC'),
	(344216, 145, '2015-02-01 00:09:01.000000', 'temperatura', 625.0000, 'ºC'),
	(344217, 145, '2015-02-01 00:09:02.000000', 'temperatura', 962.0000, 'ºC'),
	(344218, 145, '2015-02-01 00:09:03.000000', 'temperatura', 533.0000, 'ºC'),
	(344219, 145, '2015-02-01 00:09:04.000000', 'temperatura', 979.0000, 'ºC'),
	(344220, 145, '2015-02-01 00:09:05.000000', 'temperatura', 897.0000, 'ºC'),
	(344221, 145, '2015-02-01 00:09:06.000000', 'temperatura', 347.0000, 'ºC'),
	(344222, 145, '2015-02-01 00:09:07.000000', 'temperatura', 247.0000, 'ºC'),
	(344223, 145, '2015-02-01 00:09:08.000000', 'temperatura', 194.0000, 'ºC'),
	(344224, 145, '2015-02-01 00:09:09.000000', 'temperatura', 231.0000, 'ºC'),
	(344225, 145, '2015-02-01 00:09:10.000000', 'temperatura', 570.0000, 'ºC'),
	(344226, 145, '2015-02-01 00:09:11.000000', 'temperatura', 961.0000, 'ºC'),
	(344227, 145, '2015-02-01 00:09:12.000000', 'temperatura', 692.0000, 'ºC'),
	(344228, 145, '2015-02-01 00:09:13.000000', 'temperatura', 580.0000, 'ºC'),
	(344229, 145, '2015-02-01 00:09:14.000000', 'temperatura', 822.0000, 'ºC'),
	(344230, 145, '2015-02-01 00:09:15.000000', 'temperatura', 1171.0000, 'ºC'),
	(344231, 145, '2015-02-01 00:09:16.000000', 'temperatura', 988.0000, 'ºC'),
	(344232, 145, '2015-02-01 00:09:17.000000', 'temperatura', 231.0000, 'ºC'),
	(344233, 145, '2015-02-01 00:09:18.000000', 'temperatura', 589.0000, 'ºC'),
	(344234, 145, '2015-02-01 00:09:19.000000', 'temperatura', 1054.0000, 'ºC'),
	(344235, 145, '2015-02-01 00:09:20.000000', 'temperatura', 1104.0000, 'ºC'),
	(344236, 145, '2015-02-01 00:09:21.000000', 'temperatura', 1157.0000, 'ºC'),
	(344237, 145, '2015-02-01 00:09:22.000000', 'temperatura', 75.0000, 'ºC'),
	(344238, 145, '2015-02-01 00:09:23.000000', 'temperatura', 504.0000, 'ºC'),
	(344239, 145, '2015-02-01 00:09:24.000000', 'temperatura', 1095.0000, 'ºC'),
	(344240, 145, '2015-02-01 00:09:25.000000', 'temperatura', 365.0000, 'ºC'),
	(344241, 145, '2015-02-01 00:09:26.000000', 'temperatura', 941.0000, 'ºC'),
	(344242, 145, '2015-02-01 00:09:27.000000', 'temperatura', 8.0000, 'ºC'),
	(344243, 145, '2015-02-01 00:09:28.000000', 'temperatura', 820.0000, 'ºC'),
	(344244, 145, '2015-02-01 00:09:29.000000', 'temperatura', 474.0000, 'ºC'),
	(344245, 145, '2015-02-01 00:09:30.000000', 'temperatura', 1112.0000, 'ºC'),
	(344246, 145, '2015-02-01 00:09:31.000000', 'temperatura', 537.0000, 'ºC'),
	(344247, 145, '2015-02-01 00:09:32.000000', 'temperatura', 552.0000, 'ºC'),
	(344248, 145, '2015-02-01 00:09:33.000000', 'temperatura', 1147.0000, 'ºC'),
	(344249, 145, '2015-02-01 00:09:34.000000', 'temperatura', 481.0000, 'ºC'),
	(344250, 145, '2015-02-01 00:09:35.000000', 'temperatura', 165.0000, 'ºC'),
	(344251, 145, '2015-02-01 00:09:36.000000', 'temperatura', 580.0000, 'ºC'),
	(344252, 145, '2015-02-01 00:09:37.000000', 'temperatura', 6.0000, 'ºC'),
	(344253, 145, '2015-02-01 00:09:38.000000', 'temperatura', 691.0000, 'ºC'),
	(344254, 145, '2015-02-01 00:09:39.000000', 'temperatura', 1039.0000, 'ºC'),
	(344255, 145, '2015-02-01 00:09:40.000000', 'temperatura', 722.0000, 'ºC'),
	(344256, 145, '2015-02-01 00:09:41.000000', 'temperatura', 491.0000, 'ºC'),
	(344257, 145, '2015-02-01 00:09:42.000000', 'temperatura', 292.0000, 'ºC'),
	(344258, 145, '2015-02-01 00:09:43.000000', 'temperatura', 1185.0000, 'ºC'),
	(344259, 145, '2015-02-01 00:09:44.000000', 'temperatura', 252.0000, 'ºC'),
	(344260, 145, '2015-02-01 00:09:45.000000', 'temperatura', 105.0000, 'ºC'),
	(344261, 145, '2015-02-01 00:09:46.000000', 'temperatura', 970.0000, 'ºC'),
	(344262, 145, '2015-02-01 00:09:47.000000', 'temperatura', 936.0000, 'ºC'),
	(344263, 145, '2015-02-01 00:09:48.000000', 'temperatura', 570.0000, 'ºC'),
	(344264, 145, '2015-02-01 00:09:49.000000', 'temperatura', 42.0000, 'ºC'),
	(344265, 145, '2015-02-01 00:09:50.000000', 'temperatura', 901.0000, 'ºC'),
	(344266, 145, '2015-02-01 00:09:51.000000', 'temperatura', 779.0000, 'ºC'),
	(344267, 145, '2015-02-01 00:09:52.000000', 'temperatura', 1192.0000, 'ºC'),
	(344268, 145, '2015-02-01 00:09:53.000000', 'temperatura', 24.0000, 'ºC'),
	(344269, 145, '2015-02-01 00:09:54.000000', 'temperatura', 145.0000, 'ºC'),
	(344270, 145, '2015-02-01 00:09:55.000000', 'temperatura', 654.0000, 'ºC'),
	(344271, 145, '2015-02-01 00:09:56.000000', 'temperatura', 434.0000, 'ºC'),
	(344272, 145, '2015-02-01 00:09:57.000000', 'temperatura', 209.0000, 'ºC'),
	(344273, 145, '2015-02-01 00:09:58.000000', 'temperatura', 944.0000, 'ºC'),
	(344274, 145, '2015-02-01 00:09:59.000000', 'temperatura', 491.0000, 'ºC'),
	(344275, 145, '2015-02-01 00:10:00.000000', 'temperatura', 826.0000, 'ºC'),
	(344276, 145, '2015-02-01 00:10:01.000000', 'temperatura', 256.0000, 'ºC'),
	(344277, 145, '2015-02-01 00:10:02.000000', 'temperatura', 3.0000, 'ºC'),
	(344278, 145, '2015-02-01 00:10:03.000000', 'temperatura', 447.0000, 'ºC'),
	(344279, 145, '2015-02-01 00:10:04.000000', 'temperatura', 1026.0000, 'ºC'),
	(344280, 145, '2015-02-01 00:10:05.000000', 'temperatura', 191.0000, 'ºC'),
	(344281, 145, '2015-02-01 00:10:06.000000', 'temperatura', 277.0000, 'ºC'),
	(344282, 145, '2015-02-01 00:10:07.000000', 'temperatura', 814.0000, 'ºC'),
	(344283, 145, '2015-02-01 00:10:08.000000', 'temperatura', 840.0000, 'ºC'),
	(344284, 145, '2015-02-01 00:10:09.000000', 'temperatura', 559.0000, 'ºC'),
	(344285, 145, '2015-02-01 00:10:10.000000', 'temperatura', 273.0000, 'ºC'),
	(344286, 145, '2015-02-01 00:10:11.000000', 'temperatura', 890.0000, 'ºC'),
	(344287, 145, '2015-02-01 00:10:12.000000', 'temperatura', 30.0000, 'ºC'),
	(344288, 145, '2015-02-01 00:10:13.000000', 'temperatura', 1082.0000, 'ºC'),
	(344289, 145, '2015-02-01 00:10:14.000000', 'temperatura', 522.0000, 'ºC'),
	(344290, 145, '2015-02-01 00:10:15.000000', 'temperatura', 562.0000, 'ºC'),
	(344291, 145, '2015-02-01 00:10:16.000000', 'temperatura', 44.0000, 'ºC'),
	(344292, 145, '2015-02-01 00:10:17.000000', 'temperatura', 934.0000, 'ºC'),
	(344293, 145, '2015-02-01 00:10:18.000000', 'temperatura', 937.0000, 'ºC'),
	(344294, 145, '2015-02-01 00:10:19.000000', 'temperatura', 687.0000, 'ºC'),
	(344295, 145, '2015-02-01 00:10:20.000000', 'temperatura', 624.0000, 'ºC'),
	(344296, 145, '2015-02-01 00:10:21.000000', 'temperatura', 1057.0000, 'ºC'),
	(344297, 145, '2015-02-01 00:10:22.000000', 'temperatura', 1016.0000, 'ºC'),
	(344298, 145, '2015-02-01 00:10:23.000000', 'temperatura', 707.0000, 'ºC'),
	(344299, 145, '2015-02-01 00:10:24.000000', 'temperatura', 489.0000, 'ºC'),
	(344300, 145, '2015-02-01 00:10:25.000000', 'temperatura', 324.0000, 'ºC'),
	(344301, 145, '2015-02-01 00:10:26.000000', 'temperatura', 155.0000, 'ºC'),
	(344302, 145, '2015-02-01 00:10:27.000000', 'temperatura', 1003.0000, 'ºC'),
	(344303, 145, '2015-02-01 00:10:28.000000', 'temperatura', 951.0000, 'ºC'),
	(344304, 145, '2015-02-01 00:10:29.000000', 'temperatura', 546.0000, 'ºC'),
	(344305, 145, '2015-02-01 00:10:30.000000', 'temperatura', 1079.0000, 'ºC'),
	(344306, 145, '2015-02-01 00:10:31.000000', 'temperatura', 158.0000, 'ºC'),
	(344307, 145, '2015-02-01 00:10:32.000000', 'temperatura', 1154.0000, 'ºC'),
	(344308, 145, '2015-02-01 00:10:33.000000', 'temperatura', 495.0000, 'ºC'),
	(344309, 145, '2015-02-01 00:10:34.000000', 'temperatura', 213.0000, 'ºC'),
	(344310, 145, '2015-02-01 00:10:35.000000', 'temperatura', 780.0000, 'ºC'),
	(344311, 145, '2015-02-01 00:10:36.000000', 'temperatura', 862.0000, 'ºC'),
	(344312, 145, '2015-02-01 00:10:37.000000', 'temperatura', 772.0000, 'ºC'),
	(344313, 145, '2015-02-01 00:10:38.000000', 'temperatura', 72.0000, 'ºC'),
	(344314, 145, '2015-02-01 00:10:39.000000', 'temperatura', 447.0000, 'ºC'),
	(344315, 145, '2015-02-01 00:10:40.000000', 'temperatura', 820.0000, 'ºC'),
	(344316, 145, '2015-02-01 00:10:41.000000', 'temperatura', 357.0000, 'ºC'),
	(344317, 145, '2015-02-01 00:10:42.000000', 'temperatura', 528.0000, 'ºC'),
	(344318, 145, '2015-02-01 00:10:43.000000', 'temperatura', 369.0000, 'ºC'),
	(344319, 145, '2015-02-01 00:10:44.000000', 'temperatura', 259.0000, 'ºC'),
	(344320, 145, '2015-02-01 00:10:45.000000', 'temperatura', 192.0000, 'ºC'),
	(344321, 145, '2015-02-01 00:10:46.000000', 'temperatura', 182.0000, 'ºC'),
	(344322, 145, '2015-02-01 00:10:47.000000', 'temperatura', 333.0000, 'ºC'),
	(344323, 145, '2015-02-01 00:10:48.000000', 'temperatura', 1120.0000, 'ºC'),
	(344324, 145, '2015-02-01 00:10:49.000000', 'temperatura', 1000.0000, 'ºC'),
	(344325, 145, '2015-02-01 00:10:50.000000', 'temperatura', 444.0000, 'ºC'),
	(344326, 145, '2015-02-01 00:10:51.000000', 'temperatura', 417.0000, 'ºC'),
	(344327, 145, '2015-02-01 00:10:52.000000', 'temperatura', 755.0000, 'ºC'),
	(344328, 145, '2015-02-01 00:10:53.000000', 'temperatura', 124.0000, 'ºC'),
	(344329, 145, '2015-02-01 00:10:54.000000', 'temperatura', 756.0000, 'ºC'),
	(344330, 145, '2015-02-01 00:10:55.000000', 'temperatura', 1007.0000, 'ºC'),
	(344331, 145, '2015-02-01 00:10:56.000000', 'temperatura', 369.0000, 'ºC'),
	(344332, 145, '2015-02-01 00:10:57.000000', 'temperatura', 22.0000, 'ºC'),
	(344333, 145, '2015-02-01 00:10:58.000000', 'temperatura', 207.0000, 'ºC'),
	(344334, 145, '2015-02-01 00:10:59.000000', 'temperatura', 966.0000, 'ºC'),
	(344335, 145, '2015-02-01 00:11:00.000000', 'temperatura', 613.0000, 'ºC'),
	(344336, 145, '2015-02-01 00:11:01.000000', 'temperatura', 166.0000, 'ºC'),
	(344337, 145, '2015-02-01 00:11:02.000000', 'temperatura', 191.0000, 'ºC'),
	(344338, 145, '2015-02-01 00:11:03.000000', 'temperatura', 456.0000, 'ºC'),
	(344339, 145, '2015-02-01 00:11:04.000000', 'temperatura', 510.0000, 'ºC'),
	(344340, 145, '2015-02-01 00:11:05.000000', 'temperatura', 1182.0000, 'ºC'),
	(344341, 145, '2015-02-01 00:11:06.000000', 'temperatura', 782.0000, 'ºC'),
	(344342, 145, '2015-02-01 00:11:07.000000', 'temperatura', 361.0000, 'ºC'),
	(344343, 145, '2015-02-01 00:11:08.000000', 'temperatura', 663.0000, 'ºC'),
	(344344, 145, '2015-02-01 00:11:09.000000', 'temperatura', 1031.0000, 'ºC'),
	(344345, 145, '2015-02-01 00:11:10.000000', 'temperatura', 765.0000, 'ºC'),
	(344346, 145, '2015-02-01 00:11:11.000000', 'temperatura', 732.0000, 'ºC'),
	(344347, 145, '2015-02-01 00:11:12.000000', 'temperatura', 168.0000, 'ºC'),
	(344348, 145, '2015-02-01 00:11:13.000000', 'temperatura', 1043.0000, 'ºC'),
	(344349, 145, '2015-02-01 00:11:14.000000', 'temperatura', 1113.0000, 'ºC'),
	(344350, 145, '2015-02-01 00:11:15.000000', 'temperatura', 34.0000, 'ºC'),
	(344351, 145, '2015-02-01 00:11:16.000000', 'temperatura', 431.0000, 'ºC'),
	(344352, 145, '2015-02-01 00:11:17.000000', 'temperatura', 854.0000, 'ºC'),
	(344353, 145, '2015-02-01 00:11:18.000000', 'temperatura', 579.0000, 'ºC'),
	(344354, 145, '2015-02-01 00:11:19.000000', 'temperatura', 334.0000, 'ºC'),
	(344355, 145, '2015-02-01 00:11:20.000000', 'temperatura', 1134.0000, 'ºC'),
	(344356, 145, '2015-02-01 00:11:21.000000', 'temperatura', 1069.0000, 'ºC'),
	(344357, 145, '2015-02-01 00:11:22.000000', 'temperatura', 744.0000, 'ºC'),
	(344358, 145, '2015-02-01 00:11:23.000000', 'temperatura', 512.0000, 'ºC'),
	(344359, 145, '2015-02-01 00:11:24.000000', 'temperatura', 330.0000, 'ºC'),
	(344360, 145, '2015-02-01 00:11:25.000000', 'temperatura', 114.0000, 'ºC'),
	(344361, 145, '2015-02-01 00:11:26.000000', 'temperatura', 782.0000, 'ºC'),
	(344362, 145, '2015-02-01 00:11:27.000000', 'temperatura', 1165.0000, 'ºC'),
	(344363, 145, '2015-02-01 00:11:28.000000', 'temperatura', 1082.0000, 'ºC'),
	(344364, 145, '2015-02-01 00:11:29.000000', 'temperatura', 716.0000, 'ºC'),
	(344365, 145, '2015-02-01 00:11:30.000000', 'temperatura', 333.0000, 'ºC'),
	(344366, 145, '2015-02-01 00:11:31.000000', 'temperatura', 717.0000, 'ºC'),
	(344367, 145, '2015-02-01 00:11:32.000000', 'temperatura', 189.0000, 'ºC'),
	(344368, 145, '2015-02-01 00:11:33.000000', 'temperatura', 1192.0000, 'ºC'),
	(344369, 145, '2015-02-01 00:11:34.000000', 'temperatura', 594.0000, 'ºC'),
	(344370, 145, '2015-02-01 00:11:35.000000', 'temperatura', 596.0000, 'ºC'),
	(344371, 145, '2015-02-01 00:11:36.000000', 'temperatura', 1199.0000, 'ºC'),
	(344372, 145, '2015-02-01 00:11:37.000000', 'temperatura', 606.0000, 'ºC'),
	(344373, 145, '2015-02-01 00:11:38.000000', 'temperatura', 635.0000, 'ºC'),
	(344374, 145, '2015-02-01 00:11:39.000000', 'temperatura', 156.0000, 'ºC'),
	(344375, 145, '2015-02-01 00:11:40.000000', 'temperatura', 74.0000, 'ºC'),
	(344376, 145, '2015-02-01 00:11:41.000000', 'temperatura', 1106.0000, 'ºC'),
	(344377, 145, '2015-02-01 00:11:42.000000', 'temperatura', 507.0000, 'ºC'),
	(344378, 145, '2015-02-01 00:11:43.000000', 'temperatura', 416.0000, 'ºC'),
	(344379, 145, '2015-02-01 00:11:44.000000', 'temperatura', 562.0000, 'ºC'),
	(344380, 145, '2015-02-01 00:11:45.000000', 'temperatura', 360.0000, 'ºC'),
	(344381, 145, '2015-02-01 00:11:46.000000', 'temperatura', 117.0000, 'ºC'),
	(344382, 145, '2015-02-01 00:11:47.000000', 'temperatura', 705.0000, 'ºC'),
	(344383, 145, '2015-02-01 00:11:48.000000', 'temperatura', 775.0000, 'ºC'),
	(344384, 145, '2015-02-01 00:11:49.000000', 'temperatura', 558.0000, 'ºC'),
	(344385, 145, '2015-02-01 00:11:50.000000', 'temperatura', 467.0000, 'ºC'),
	(344386, 145, '2015-02-01 00:11:51.000000', 'temperatura', 661.0000, 'ºC'),
	(344387, 145, '2015-02-01 00:11:52.000000', 'temperatura', 703.0000, 'ºC'),
	(344388, 145, '2015-02-01 00:11:53.000000', 'temperatura', 333.0000, 'ºC'),
	(344389, 145, '2015-02-01 00:11:54.000000', 'temperatura', 757.0000, 'ºC'),
	(344390, 145, '2015-02-01 00:11:55.000000', 'temperatura', 388.0000, 'ºC'),
	(344391, 145, '2015-02-01 00:11:56.000000', 'temperatura', 867.0000, 'ºC'),
	(344392, 145, '2015-02-01 00:11:57.000000', 'temperatura', 771.0000, 'ºC'),
	(344393, 145, '2015-02-01 00:11:58.000000', 'temperatura', 56.0000, 'ºC'),
	(344394, 145, '2015-02-01 00:11:59.000000', 'temperatura', 369.0000, 'ºC'),
	(344395, 145, '2015-02-01 00:12:00.000000', 'temperatura', 475.0000, 'ºC'),
	(344396, 145, '2015-02-01 00:12:01.000000', 'temperatura', 68.0000, 'ºC'),
	(344397, 145, '2015-02-01 00:12:02.000000', 'temperatura', 115.0000, 'ºC'),
	(344398, 145, '2015-02-01 00:12:03.000000', 'temperatura', 371.0000, 'ºC'),
	(344399, 145, '2015-02-01 00:12:04.000000', 'temperatura', 311.0000, 'ºC'),
	(344400, 145, '2015-02-01 00:12:05.000000', 'temperatura', 442.0000, 'ºC'),
	(344401, 145, '2015-02-01 00:12:06.000000', 'temperatura', 76.0000, 'ºC'),
	(344402, 145, '2015-02-01 00:12:07.000000', 'temperatura', 258.0000, 'ºC'),
	(344403, 145, '2015-02-01 00:12:08.000000', 'temperatura', 1060.0000, 'ºC'),
	(344404, 145, '2015-02-01 00:12:09.000000', 'temperatura', 927.0000, 'ºC'),
	(344405, 145, '2015-02-01 00:12:10.000000', 'temperatura', 255.0000, 'ºC'),
	(344406, 145, '2015-02-01 00:12:11.000000', 'temperatura', 895.0000, 'ºC'),
	(344407, 145, '2015-02-01 00:12:12.000000', 'temperatura', 112.0000, 'ºC'),
	(344408, 145, '2015-02-01 00:12:13.000000', 'temperatura', 274.0000, 'ºC'),
	(344409, 145, '2015-02-01 00:12:14.000000', 'temperatura', 1034.0000, 'ºC'),
	(344410, 145, '2015-02-01 00:12:15.000000', 'temperatura', 751.0000, 'ºC'),
	(344411, 145, '2015-02-01 00:12:16.000000', 'temperatura', 650.0000, 'ºC'),
	(344412, 145, '2015-02-01 00:12:17.000000', 'temperatura', 1000.0000, 'ºC'),
	(344413, 145, '2015-02-01 00:12:18.000000', 'temperatura', 650.0000, 'ºC'),
	(344414, 145, '2015-02-01 00:12:19.000000', 'temperatura', 250.0000, 'ºC'),
	(344415, 145, '2015-02-01 00:12:20.000000', 'temperatura', 501.0000, 'ºC'),
	(344416, 145, '2015-02-01 00:12:21.000000', 'temperatura', 555.0000, 'ºC'),
	(344417, 145, '2015-02-01 00:12:22.000000', 'temperatura', 73.0000, 'ºC'),
	(344418, 145, '2015-02-01 00:12:23.000000', 'temperatura', 1101.0000, 'ºC'),
	(344419, 145, '2015-02-01 00:12:24.000000', 'temperatura', 484.0000, 'ºC'),
	(344420, 145, '2015-02-01 00:12:25.000000', 'temperatura', 321.0000, 'ºC'),
	(344421, 145, '2015-02-01 00:12:26.000000', 'temperatura', 150.0000, 'ºC'),
	(344422, 145, '2015-02-01 00:12:27.000000', 'temperatura', 990.0000, 'ºC'),
	(344423, 145, '2015-02-01 00:12:28.000000', 'temperatura', 898.0000, 'ºC'),
	(344424, 145, '2015-02-01 00:12:29.000000', 'temperatura', 322.0000, 'ºC'),
	(344425, 145, '2015-02-01 00:12:30.000000', 'temperatura', 115.0000, 'ºC'),
	(344426, 145, '2015-02-01 00:12:31.000000', 'temperatura', 811.0000, 'ºC'),
	(344427, 145, '2015-02-01 00:12:32.000000', 'temperatura', 112.0000, 'ºC'),
	(344428, 145, '2015-02-01 00:12:33.000000', 'temperatura', 527.0000, 'ºC'),
	(344429, 145, '2015-02-01 00:12:34.000000', 'temperatura', 1099.0000, 'ºC'),
	(344430, 145, '2015-02-01 00:12:35.000000', 'temperatura', 312.0000, 'ºC'),
	(344431, 145, '2015-02-01 00:12:36.000000', 'temperatura', 667.0000, 'ºC'),
	(344432, 145, '2015-02-01 00:12:37.000000', 'temperatura', 1198.0000, 'ºC'),
	(344433, 145, '2015-02-01 00:12:38.000000', 'temperatura', 391.0000, 'ºC'),
	(344434, 145, '2015-02-01 00:12:39.000000', 'temperatura', 760.0000, 'ºC'),
	(344435, 145, '2015-02-01 00:12:40.000000', 'temperatura', 229.0000, 'ºC'),
	(344436, 145, '2015-02-01 00:12:41.000000', 'temperatura', 66.0000, 'ºC'),
	(344437, 145, '2015-02-01 00:12:42.000000', 'temperatura', 842.0000, 'ºC'),
	(344438, 145, '2015-02-01 00:12:43.000000', 'temperatura', 414.0000, 'ºC'),
	(344439, 145, '2015-02-01 00:12:44.000000', 'temperatura', 743.0000, 'ºC'),
	(344440, 145, '2015-02-01 00:12:45.000000', 'temperatura', 73.0000, 'ºC'),
	(344441, 145, '2015-02-01 00:12:46.000000', 'temperatura', 539.0000, 'ºC'),
	(344442, 145, '2015-02-01 00:12:47.000000', 'temperatura', 74.0000, 'ºC'),
	(344443, 145, '2015-02-01 00:12:48.000000', 'temperatura', 1155.0000, 'ºC'),
	(344444, 145, '2015-02-01 00:12:49.000000', 'temperatura', 753.0000, 'ºC'),
	(344445, 145, '2015-02-01 00:12:50.000000', 'temperatura', 302.0000, 'ºC'),
	(344446, 145, '2015-02-01 00:12:51.000000', 'temperatura', 451.0000, 'ºC'),
	(344447, 145, '2015-02-01 00:12:52.000000', 'temperatura', 148.0000, 'ºC'),
	(344448, 145, '2015-02-01 00:12:53.000000', 'temperatura', 589.0000, 'ºC'),
	(344449, 145, '2015-02-01 00:12:54.000000', 'temperatura', 99.0000, 'ºC'),
	(344450, 145, '2015-02-01 00:12:55.000000', 'temperatura', 1131.0000, 'ºC'),
	(344451, 145, '2015-02-01 00:12:56.000000', 'temperatura', 559.0000, 'ºC'),
	(344452, 145, '2015-02-01 00:12:57.000000', 'temperatura', 602.0000, 'ºC'),
	(344453, 145, '2015-02-01 00:12:58.000000', 'temperatura', 134.0000, 'ºC'),
	(344454, 145, '2015-02-01 00:12:59.000000', 'temperatura', 63.0000, 'ºC'),
	(344455, 145, '2015-02-01 00:13:00.000000', 'temperatura', 1115.0000, 'ºC'),
	(344456, 145, '2015-02-01 00:13:01.000000', 'temperatura', 585.0000, 'ºC'),
	(344457, 145, '2015-02-01 00:13:02.000000', 'temperatura', 783.0000, 'ºC'),
	(344458, 145, '2015-02-01 00:13:03.000000', 'temperatura', 960.0000, 'ºC'),
	(344459, 145, '2015-02-01 00:13:04.000000', 'temperatura', 49.0000, 'ºC'),
	(344460, 145, '2015-02-01 00:13:05.000000', 'temperatura', 966.0000, 'ºC'),
	(344461, 145, '2015-02-01 00:13:06.000000', 'temperatura', 1085.0000, 'ºC'),
	(344462, 145, '2015-02-01 00:13:07.000000', 'temperatura', 128.0000, 'ºC'),
	(344463, 145, '2015-02-01 00:13:08.000000', 'temperatura', 987.0000, 'ºC'),
	(344464, 145, '2015-02-01 00:13:09.000000', 'temperatura', 949.0000, 'ºC'),
	(344465, 145, '2015-02-01 00:13:10.000000', 'temperatura', 583.0000, 'ºC'),
	(344466, 145, '2015-02-01 00:13:11.000000', 'temperatura', 70.0000, 'ºC'),
	(344467, 145, '2015-02-01 00:13:12.000000', 'temperatura', 1002.0000, 'ºC'),
	(344468, 145, '2015-02-01 00:13:13.000000', 'temperatura', 2.0000, 'ºC'),
	(344469, 145, '2015-02-01 00:13:14.000000', 'temperatura', 603.0000, 'ºC'),
	(344470, 145, '2015-02-01 00:13:15.000000', 'temperatura', 612.0000, 'ºC'),
	(344471, 145, '2015-02-01 00:13:16.000000', 'temperatura', 48.0000, 'ºC'),
	(344472, 145, '2015-02-01 00:13:17.000000', 'temperatura', 807.0000, 'ºC'),
	(344473, 145, '2015-02-01 00:13:18.000000', 'temperatura', 292.0000, 'ºC'),
	(344474, 145, '2015-02-01 00:13:19.000000', 'temperatura', 238.0000, 'ºC'),
	(344475, 145, '2015-02-01 00:13:20.000000', 'temperatura', 314.0000, 'ºC'),
	(344476, 145, '2015-02-01 00:13:21.000000', 'temperatura', 857.0000, 'ºC'),
	(344477, 145, '2015-02-01 00:13:22.000000', 'temperatura', 942.0000, 'ºC'),
	(344478, 145, '2015-02-01 00:13:23.000000', 'temperatura', 943.0000, 'ºC'),
	(344479, 145, '2015-02-01 00:13:24.000000', 'temperatura', 686.0000, 'ºC'),
	(344480, 145, '2015-02-01 00:13:25.000000', 'temperatura', 601.0000, 'ºC'),
	(344481, 145, '2015-02-01 00:13:26.000000', 'temperatura', 951.0000, 'ºC'),
	(344482, 145, '2015-02-01 00:13:27.000000', 'temperatura', 550.0000, 'ºC'),
	(344483, 145, '2015-02-01 00:13:28.000000', 'temperatura', 1096.0000, 'ºC'),
	(344484, 145, '2015-02-01 00:13:29.000000', 'temperatura', 232.0000, 'ºC'),
	(344485, 145, '2015-02-01 00:13:30.000000', 'temperatura', 273.0000, 'ºC'),
	(344486, 145, '2015-02-01 00:13:31.000000', 'temperatura', 668.0000, 'ºC'),
	(344487, 145, '2015-02-01 00:13:32.000000', 'temperatura', 124.0000, 'ºC'),
	(344488, 145, '2015-02-01 00:13:33.000000', 'temperatura', 1017.0000, 'ºC'),
	(344489, 145, '2015-02-01 00:13:34.000000', 'temperatura', 1113.0000, 'ºC'),
	(344490, 145, '2015-02-01 00:13:35.000000', 'temperatura', 112.0000, 'ºC'),
	(344491, 145, '2015-02-01 00:13:36.000000', 'temperatura', 825.0000, 'ºC'),
	(344492, 145, '2015-02-01 00:13:37.000000', 'temperatura', 187.0000, 'ºC'),
	(344493, 145, '2015-02-01 00:13:38.000000', 'temperatura', 859.0000, 'ºC'),
	(344494, 145, '2015-02-01 00:13:39.000000', 'temperatura', 138.0000, 'ºC'),
	(344495, 145, '2015-02-01 00:13:40.000000', 'temperatura', 510.0000, 'ºC'),
	(344496, 145, '2015-02-01 00:13:41.000000', 'temperatura', 938.0000, 'ºC'),
	(344497, 145, '2015-02-01 00:13:42.000000', 'temperatura', 762.0000, 'ºC'),
	(344498, 145, '2015-02-01 00:13:43.000000', 'temperatura', 993.0000, 'ºC'),
	(344499, 145, '2015-02-01 00:13:44.000000', 'temperatura', 283.0000, 'ºC'),
	(344500, 145, '2015-02-01 00:13:45.000000', 'temperatura', 834.0000, 'ºC'),
	(344501, 145, '2015-02-01 00:13:46.000000', 'temperatura', 921.0000, 'ºC'),
	(344502, 145, '2015-02-01 00:13:47.000000', 'temperatura', 907.0000, 'ºC'),
	(344503, 145, '2015-02-01 00:13:48.000000', 'temperatura', 569.0000, 'ºC'),
	(344504, 145, '2015-02-01 00:13:49.000000', 'temperatura', 126.0000, 'ºC'),
	(344505, 145, '2015-02-01 00:13:50.000000', 'temperatura', 122.0000, 'ºC'),
	(344506, 145, '2015-02-01 00:13:51.000000', 'temperatura', 232.0000, 'ºC'),
	(344507, 145, '2015-02-01 00:13:52.000000', 'temperatura', 794.0000, 'ºC'),
	(344508, 145, '2015-02-01 00:13:53.000000', 'temperatura', 877.0000, 'ºC'),
	(344509, 145, '2015-02-01 00:13:54.000000', 'temperatura', 803.0000, 'ºC'),
	(344510, 145, '2015-02-01 00:13:55.000000', 'temperatura', 182.0000, 'ºC'),
	(344511, 145, '2015-02-01 00:13:56.000000', 'temperatura', 905.0000, 'ºC'),
	(344512, 145, '2015-02-01 00:13:57.000000', 'temperatura', 377.0000, 'ºC'),
	(344513, 145, '2015-02-01 00:13:58.000000', 'temperatura', 370.0000, 'ºC'),
	(344514, 145, '2015-02-01 00:13:59.000000', 'temperatura', 719.0000, 'ºC'),
	(344515, 145, '2015-02-01 00:14:00.000000', 'temperatura', 88.0000, 'ºC'),
	(344516, 145, '2015-02-01 00:14:01.000000', 'temperatura', 680.0000, 'ºC'),
	(344517, 145, '2015-02-01 00:14:02.000000', 'temperatura', 739.0000, 'ºC'),
	(344518, 145, '2015-02-01 00:14:03.000000', 'temperatura', 457.0000, 'ºC'),
	(344519, 145, '2015-02-01 00:14:04.000000', 'temperatura', 67.0000, 'ºC'),
	(344520, 145, '2015-02-01 00:14:05.000000', 'temperatura', 163.0000, 'ºC'),
	(344521, 145, '2015-02-01 00:14:06.000000', 'temperatura', 615.0000, 'ºC'),
	(344522, 145, '2015-02-01 00:14:07.000000', 'temperatura', 186.0000, 'ºC'),
	(344523, 145, '2015-02-01 00:14:08.000000', 'temperatura', 288.0000, 'ºC'),
	(344524, 145, '2015-02-01 00:14:09.000000', 'temperatura', 881.0000, 'ºC'),
	(344525, 145, '2015-02-01 00:14:10.000000', 'temperatura', 1140.0000, 'ºC'),
	(344526, 145, '2015-02-01 00:14:11.000000', 'temperatura', 657.0000, 'ºC'),
	(344527, 145, '2015-02-01 00:14:12.000000', 'temperatura', 1068.0000, 'ºC'),
	(344528, 145, '2015-02-01 00:14:13.000000', 'temperatura', 970.0000, 'ºC'),
	(344529, 145, '2015-02-01 00:14:14.000000', 'temperatura', 445.0000, 'ºC'),
	(344530, 145, '2015-02-01 00:14:15.000000', 'temperatura', 514.0000, 'ºC'),
	(344531, 145, '2015-02-01 00:14:16.000000', 'temperatura', 36.0000, 'ºC'),
	(344532, 145, '2015-02-01 00:14:17.000000', 'temperatura', 1040.0000, 'ºC'),
	(344533, 145, '2015-02-01 00:14:18.000000', 'temperatura', 290.0000, 'ºC'),
	(344534, 145, '2015-02-01 00:14:19.000000', 'temperatura', 733.0000, 'ºC'),
	(344535, 145, '2015-02-01 00:14:20.000000', 'temperatura', 397.0000, 'ºC'),
	(344536, 145, '2015-02-01 00:14:21.000000', 'temperatura', 984.0000, 'ºC'),
	(344537, 145, '2015-02-01 00:14:22.000000', 'temperatura', 130.0000, 'ºC'),
	(344538, 145, '2015-02-01 00:14:23.000000', 'temperatura', 97.0000, 'ºC'),
	(344539, 145, '2015-02-01 00:14:24.000000', 'temperatura', 97.0000, 'ºC'),
	(344540, 145, '2015-02-01 00:14:25.000000', 'temperatura', 193.0000, 'ºC'),
	(344541, 145, '2015-02-01 00:14:26.000000', 'temperatura', 677.0000, 'ºC'),
	(344542, 145, '2015-02-01 00:14:27.000000', 'temperatura', 407.0000, 'ºC'),
	(344543, 145, '2015-02-01 00:14:28.000000', 'temperatura', 3.0000, 'ºC'),
	(344544, 145, '2015-02-01 00:14:29.000000', 'temperatura', 1195.0000, 'ºC'),
	(344545, 145, '2015-02-01 00:14:30.000000', 'temperatura', 1164.0000, 'ºC'),
	(344546, 145, '2015-02-01 00:14:31.000000', 'temperatura', 1038.0000, 'ºC'),
	(344547, 145, '2015-02-01 00:14:32.000000', 'temperatura', 497.0000, 'ºC'),
	(344548, 145, '2015-02-01 00:14:33.000000', 'temperatura', 574.0000, 'ºC'),
	(344549, 145, '2015-02-01 00:14:34.000000', 'temperatura', 179.0000, 'ºC'),
	(344550, 145, '2015-02-01 00:14:35.000000', 'temperatura', 372.0000, 'ºC'),
	(344551, 145, '2015-02-01 00:14:36.000000', 'temperatura', 124.0000, 'ºC'),
	(344552, 145, '2015-02-01 00:14:37.000000', 'temperatura', 703.0000, 'ºC'),
	(344553, 145, '2015-02-01 00:14:38.000000', 'temperatura', 743.0000, 'ºC'),
	(344554, 145, '2015-02-01 00:14:39.000000', 'temperatura', 407.0000, 'ºC'),
	(344555, 145, '2015-02-01 00:14:40.000000', 'temperatura', 1005.0000, 'ºC'),
	(344556, 145, '2015-02-01 00:14:41.000000', 'temperatura', 205.0000, 'ºC'),
	(344557, 145, '2015-02-01 00:14:42.000000', 'temperatura', 413.0000, 'ºC'),
	(344558, 145, '2015-02-01 00:14:43.000000', 'temperatura', 249.0000, 'ºC'),
	(344559, 145, '2015-02-01 00:14:44.000000', 'temperatura', 8.0000, 'ºC'),
	(344560, 145, '2015-02-01 00:14:45.000000', 'temperatura', 493.0000, 'ºC'),
	(344561, 145, '2015-02-01 00:14:46.000000', 'temperatura', 40.0000, 'ºC'),
	(344562, 145, '2015-02-01 00:14:47.000000', 'temperatura', 1121.0000, 'ºC'),
	(344563, 145, '2015-02-01 00:14:48.000000', 'temperatura', 685.0000, 'ºC'),
	(344564, 145, '2015-02-01 00:14:49.000000', 'temperatura', 63.0000, 'ºC'),
	(344565, 145, '2015-02-01 00:14:50.000000', 'temperatura', 659.0000, 'ºC'),
	(344566, 145, '2015-02-01 00:14:51.000000', 'temperatura', 707.0000, 'ºC'),
	(344567, 145, '2015-02-01 00:14:52.000000', 'temperatura', 360.0000, 'ºC'),
	(344568, 145, '2015-02-01 00:14:53.000000', 'temperatura', 877.0000, 'ºC'),
	(344569, 145, '2015-02-01 00:14:54.000000', 'temperatura', 906.0000, 'ºC'),
	(344570, 145, '2015-02-01 00:14:55.000000', 'temperatura', 699.0000, 'ºC'),
	(344571, 145, '2015-02-01 00:14:56.000000', 'temperatura', 780.0000, 'ºC'),
	(344572, 145, '2015-02-01 00:14:57.000000', 'temperatura', 602.0000, 'ºC'),
	(344573, 145, '2015-02-01 00:14:58.000000', 'temperatura', 669.0000, 'ºC'),
	(344574, 145, '2015-02-01 00:14:59.000000', 'temperatura', 340.0000, 'ºC'),
	(344575, 145, '2015-02-01 00:15:00.000000', 'temperatura', 894.0000, 'ºC'),
	(344576, 145, '2015-02-01 00:15:01.000000', 'temperatura', 1052.0000, 'ºC'),
	(344577, 145, '2015-02-01 00:15:02.000000', 'temperatura', 176.0000, 'ºC'),
	(344578, 145, '2015-02-01 00:15:03.000000', 'temperatura', 126.0000, 'ºC'),
	(344579, 145, '2015-02-01 00:15:04.000000', 'temperatura', 102.0000, 'ºC'),
	(344580, 145, '2015-02-01 00:15:05.000000', 'temperatura', 134.0000, 'ºC'),
	(344581, 145, '2015-02-01 00:15:06.000000', 'temperatura', 362.0000, 'ºC'),
	(344582, 145, '2015-02-01 00:15:07.000000', 'temperatura', 208.0000, 'ºC'),
	(344583, 145, '2015-02-01 00:15:08.000000', 'temperatura', 1157.0000, 'ºC'),
	(344584, 145, '2015-02-01 00:15:09.000000', 'temperatura', 361.0000, 'ºC'),
	(344585, 145, '2015-02-01 00:15:10.000000', 'temperatura', 735.0000, 'ºC'),
	(344586, 145, '2015-02-01 00:15:11.000000', 'temperatura', 191.0000, 'ºC'),
	(344587, 145, '2015-02-01 00:15:12.000000', 'temperatura', 1151.0000, 'ºC'),
	(344588, 145, '2015-02-01 00:15:13.000000', 'temperatura', 384.0000, 'ºC'),
	(344589, 145, '2015-02-01 00:15:14.000000', 'temperatura', 866.0000, 'ºC'),
	(344590, 145, '2015-02-01 00:15:15.000000', 'temperatura', 781.0000, 'ºC'),
	(344591, 145, '2015-02-01 00:15:16.000000', 'temperatura', 104.0000, 'ºC'),
	(344592, 145, '2015-02-01 00:15:17.000000', 'temperatura', 579.0000, 'ºC'),
	(344593, 145, '2015-02-01 00:15:18.000000', 'temperatura', 182.0000, 'ºC'),
	(344594, 145, '2015-02-01 00:15:19.000000', 'temperatura', 375.0000, 'ºC'),
	(344595, 145, '2015-02-01 00:15:20.000000', 'temperatura', 129.0000, 'ºC'),
	(344596, 145, '2015-02-01 00:15:21.000000', 'temperatura', 722.0000, 'ºC'),
	(344597, 145, '2015-02-01 00:15:22.000000', 'temperatura', 822.0000, 'ºC'),
	(344598, 145, '2015-02-01 00:15:23.000000', 'temperatura', 747.0000, 'ºC'),
	(344599, 145, '2015-02-01 00:15:24.000000', 'temperatura', 67.0000, 'ºC'),
	(344600, 145, '2015-02-01 00:15:25.000000', 'temperatura', 494.0000, 'ºC'),
	(344601, 145, '2015-02-01 00:15:26.000000', 'temperatura', 1071.0000, 'ºC'),
	(344602, 145, '2015-02-01 00:15:27.000000', 'temperatura', 272.0000, 'ºC'),
	(344603, 145, '2015-02-01 00:15:28.000000', 'temperatura', 548.0000, 'ºC'),
	(344604, 145, '2015-02-01 00:15:29.000000', 'temperatura', 724.0000, 'ºC'),
	(344605, 145, '2015-02-01 00:15:30.000000', 'temperatura', 776.0000, 'ºC'),
	(344606, 145, '2015-02-01 00:15:31.000000', 'temperatura', 511.0000, 'ºC'),
	(344607, 145, '2015-02-01 00:15:32.000000', 'temperatura', 225.0000, 'ºC'),
	(344608, 145, '2015-02-01 00:15:33.000000', 'temperatura', 792.0000, 'ºC'),
	(344609, 145, '2015-02-01 00:15:34.000000', 'temperatura', 886.0000, 'ºC'),
	(344610, 145, '2015-02-01 00:15:35.000000', 'temperatura', 856.0000, 'ºC'),
	(344611, 145, '2015-02-01 00:15:36.000000', 'temperatura', 424.0000, 'ºC'),
	(344612, 145, '2015-02-01 00:15:37.000000', 'temperatura', 750.0000, 'ºC'),
	(344613, 145, '2015-02-01 00:15:38.000000', 'temperatura', 79.0000, 'ºC'),
	(344614, 145, '2015-02-01 00:15:39.000000', 'temperatura', 544.0000, 'ºC'),
	(344615, 145, '2015-02-01 00:15:40.000000', 'temperatura', 85.0000, 'ºC'),
	(344616, 145, '2015-02-01 00:15:41.000000', 'temperatura', 1192.0000, 'ºC'),
	(344617, 145, '2015-02-01 00:15:42.000000', 'temperatura', 908.0000, 'ºC'),
	(344618, 145, '2015-02-01 00:15:43.000000', 'temperatura', 964.0000, 'ºC'),
	(344619, 145, '2015-02-01 00:15:44.000000', 'temperatura', 898.0000, 'ºC'),
	(344620, 145, '2015-02-01 00:15:45.000000', 'temperatura', 395.0000, 'ºC'),
	(344621, 145, '2015-02-01 00:15:46.000000', 'temperatura', 484.0000, 'ºC'),
	(344622, 145, '2015-02-01 00:15:47.000000', 'temperatura', 36.0000, 'ºC'),
	(344623, 145, '2015-02-01 00:15:48.000000', 'temperatura', 1129.0000, 'ºC'),
	(344624, 145, '2015-02-01 00:15:49.000000', 'temperatura', 735.0000, 'ºC'),
	(344625, 145, '2015-02-01 00:15:50.000000', 'temperatura', 291.0000, 'ºC'),
	(344626, 145, '2015-02-01 00:15:51.000000', 'temperatura', 448.0000, 'ºC'),
	(344627, 145, '2015-02-01 00:15:52.000000', 'temperatura', 168.0000, 'ºC'),
	(344628, 145, '2015-02-01 00:15:53.000000', 'temperatura', 699.0000, 'ºC'),
	(344629, 145, '2015-02-01 00:15:54.000000', 'temperatura', 589.0000, 'ºC'),
	(344630, 145, '2015-02-01 00:15:55.000000', 'temperatura', 850.0000, 'ºC'),
	(344631, 145, '2015-02-01 00:15:56.000000', 'temperatura', 83.0000, 'ºC'),
	(344632, 145, '2015-02-01 00:15:57.000000', 'temperatura', 267.0000, 'ºC'),
	(344633, 145, '2015-02-01 00:15:58.000000', 'temperatura', 1087.0000, 'ºC'),
	(344634, 145, '2015-02-01 00:15:59.000000', 'temperatura', 1032.0000, 'ºC'),
	(344635, 145, '2015-02-01 00:16:00.000000', 'temperatura', 700.0000, 'ºC'),
	(344636, 145, '2015-02-01 00:16:01.000000', 'temperatura', 403.0000, 'ºC'),
	(344637, 145, '2015-02-01 00:16:02.000000', 'temperatura', 1116.0000, 'ºC'),
	(344638, 145, '2015-02-01 00:16:03.000000', 'temperatura', 770.0000, 'ºC'),
	(344639, 145, '2015-02-01 00:16:04.000000', 'temperatura', 504.0000, 'ºC'),
	(344640, 145, '2015-02-01 00:16:05.000000', 'temperatura', 211.0000, 'ºC'),
	(344641, 145, '2015-02-01 00:16:06.000000', 'temperatura', 742.0000, 'ºC'),
	(344642, 145, '2015-02-01 00:16:07.000000', 'temperatura', 676.0000, 'ºC'),
	(344643, 145, '2015-02-01 00:16:08.000000', 'temperatura', 1157.0000, 'ºC'),
	(344644, 145, '2015-02-01 00:16:09.000000', 'temperatura', 156.0000, 'ºC'),
	(344645, 145, '2015-02-01 00:16:10.000000', 'temperatura', 910.0000, 'ºC'),
	(344646, 145, '2015-02-01 00:16:11.000000', 'temperatura', 482.0000, 'ºC'),
	(344647, 145, '2015-02-01 00:16:12.000000', 'temperatura', 882.0000, 'ºC'),
	(344648, 145, '2015-02-01 00:16:13.000000', 'temperatura', 565.0000, 'ºC'),
	(344649, 145, '2015-02-01 00:16:14.000000', 'temperatura', 177.0000, 'ºC'),
	(344650, 145, '2015-02-01 00:16:15.000000', 'temperatura', 391.0000, 'ºC'),
	(344651, 145, '2015-02-01 00:16:16.000000', 'temperatura', 225.0000, 'ºC'),
	(344652, 145, '2015-02-01 00:16:17.000000', 'temperatura', 1154.0000, 'ºC'),
	(344653, 145, '2015-02-01 00:16:18.000000', 'temperatura', 292.0000, 'ºC'),
	(344654, 145, '2015-02-01 00:16:19.000000', 'temperatura', 402.0000, 'ºC'),
	(344655, 145, '2015-02-01 00:16:20.000000', 'temperatura', 1132.0000, 'ºC'),
	(344656, 145, '2015-02-01 00:16:21.000000', 'temperatura', 855.0000, 'ºC'),
	(344657, 145, '2015-02-01 00:16:22.000000', 'temperatura', 880.0000, 'ºC'),
	(344658, 145, '2015-02-01 00:16:23.000000', 'temperatura', 637.0000, 'ºC'),
	(344659, 145, '2015-02-01 00:16:24.000000', 'temperatura', 545.0000, 'ºC'),
	(344660, 145, '2015-02-01 00:16:25.000000', 'temperatura', 815.0000, 'ºC'),
	(344661, 145, '2015-02-01 00:16:26.000000', 'temperatura', 40.0000, 'ºC'),
	(344662, 145, '2015-02-01 00:16:27.000000', 'temperatura', 156.0000, 'ºC'),
	(344663, 145, '2015-02-01 00:16:28.000000', 'temperatura', 660.0000, 'ºC'),
	(344664, 145, '2015-02-01 00:16:29.000000', 'temperatura', 432.0000, 'ºC'),
	(344665, 145, '2015-02-01 00:16:30.000000', 'temperatura', 180.0000, 'ºC'),
	(344666, 145, '2015-02-01 00:16:31.000000', 'temperatura', 807.0000, 'ºC'),
	(344667, 145, '2015-02-01 00:16:32.000000', 'temperatura', 1095.0000, 'ºC'),
	(344668, 145, '2015-02-01 00:16:33.000000', 'temperatura', 654.0000, 'ºC'),
	(344669, 145, '2015-02-01 00:16:34.000000', 'temperatura', 1187.0000, 'ºC'),
	(344670, 145, '2015-02-01 00:16:35.000000', 'temperatura', 374.0000, 'ºC'),
	(344671, 145, '2015-02-01 00:16:36.000000', 'temperatura', 709.0000, 'ºC'),
	(344672, 145, '2015-02-01 00:16:37.000000', 'temperatura', 25.0000, 'ºC'),
	(344673, 145, '2015-02-01 00:16:38.000000', 'temperatura', 398.0000, 'ºC'),
	(344674, 145, '2015-02-01 00:16:39.000000', 'temperatura', 713.0000, 'ºC'),
	(344675, 145, '2015-02-01 00:16:40.000000', 'temperatura', 1173.0000, 'ºC'),
	(344676, 145, '2015-02-01 00:16:41.000000', 'temperatura', 125.0000, 'ºC'),
	(344677, 145, '2015-02-01 00:16:42.000000', 'temperatura', 708.0000, 'ºC'),
	(344678, 145, '2015-02-01 00:16:43.000000', 'temperatura', 765.0000, 'ºC'),
	(344679, 145, '2015-02-01 00:16:44.000000', 'temperatura', 501.0000, 'ºC'),
	(344680, 145, '2015-02-01 00:16:45.000000', 'temperatura', 213.0000, 'ºC'),
	(344681, 145, '2015-02-01 00:16:46.000000', 'temperatura', 761.0000, 'ºC'),
	(344682, 145, '2015-02-01 00:16:47.000000', 'temperatura', 765.0000, 'ºC'),
	(344683, 145, '2015-02-01 00:16:48.000000', 'temperatura', 344.0000, 'ºC'),
	(344684, 145, '2015-02-01 00:16:49.000000', 'temperatura', 627.0000, 'ºC'),
	(344685, 145, '2015-02-01 00:16:50.000000', 'temperatura', 903.0000, 'ºC'),
	(344686, 145, '2015-02-01 00:16:51.000000', 'temperatura', 233.0000, 'ºC'),
	(344687, 145, '2015-02-01 00:16:52.000000', 'temperatura', 858.0000, 'ºC'),
	(344688, 145, '2015-02-01 00:16:53.000000', 'temperatura', 1191.0000, 'ºC'),
	(344689, 145, '2015-02-01 00:16:54.000000', 'temperatura', 982.0000, 'ºC'),
	(344690, 145, '2015-02-01 00:16:55.000000', 'temperatura', 138.0000, 'ºC'),
	(344691, 145, '2015-02-01 00:16:56.000000', 'temperatura', 142.0000, 'ºC'),
	(344692, 145, '2015-02-01 00:16:57.000000', 'temperatura', 300.0000, 'ºC'),
	(344693, 145, '2015-02-01 00:16:58.000000', 'temperatura', 1073.0000, 'ºC'),
	(344694, 145, '2015-02-01 00:16:59.000000', 'temperatura', 864.0000, 'ºC'),
	(344695, 145, '2015-02-01 00:17:00.000000', 'temperatura', 1103.0000, 'ºC'),
	(344696, 145, '2015-02-01 00:17:01.000000', 'temperatura', 525.0000, 'ºC'),
	(344697, 145, '2015-02-01 00:17:02.000000', 'temperatura', 513.0000, 'ºC'),
	(344698, 145, '2015-02-01 00:17:03.000000', 'temperatura', 993.0000, 'ºC'),
	(344699, 145, '2015-02-01 00:17:04.000000', 'temperatura', 1024.0000, 'ºC'),
	(344700, 145, '2015-02-01 00:17:05.000000', 'temperatura', 944.0000, 'ºC'),
	(344701, 145, '2015-02-01 00:17:06.000000', 'temperatura', 446.0000, 'ºC'),
	(344702, 145, '2015-02-01 00:17:07.000000', 'temperatura', 601.0000, 'ºC'),
	(344703, 145, '2015-02-01 00:17:08.000000', 'temperatura', 469.0000, 'ºC'),
	(344704, 145, '2015-02-01 00:17:09.000000', 'temperatura', 540.0000, 'ºC'),
	(344705, 145, '2015-02-01 00:17:10.000000', 'temperatura', 92.0000, 'ºC'),
	(344706, 145, '2015-02-01 00:17:11.000000', 'temperatura', 42.0000, 'ºC'),
	(344707, 145, '2015-02-01 00:17:12.000000', 'temperatura', 1134.0000, 'ºC'),
	(344708, 145, '2015-02-01 00:17:13.000000', 'temperatura', 746.0000, 'ºC'),
	(344709, 145, '2015-02-01 00:17:14.000000', 'temperatura', 329.0000, 'ºC'),
	(344710, 145, '2015-02-01 00:17:15.000000', 'temperatura', 608.0000, 'ºC'),
	(344711, 145, '2015-02-01 00:17:16.000000', 'temperatura', 851.0000, 'ºC'),
	(344712, 145, '2015-02-01 00:17:17.000000', 'temperatura', 31.0000, 'ºC'),
	(344713, 145, '2015-02-01 00:17:18.000000', 'temperatura', 4.0000, 'ºC'),
	(344714, 145, '2015-02-01 00:17:19.000000', 'temperatura', 1127.0000, 'ºC'),
	(344715, 145, '2015-02-01 00:17:20.000000', 'temperatura', 824.0000, 'ºC'),
	(344716, 145, '2015-02-01 00:17:21.000000', 'temperatura', 741.0000, 'ºC'),
	(344717, 145, '2015-02-01 00:17:22.000000', 'temperatura', 31.0000, 'ºC'),
	(344718, 145, '2015-02-01 00:17:23.000000', 'temperatura', 333.0000, 'ºC'),
	(344719, 145, '2015-02-01 00:17:24.000000', 'temperatura', 372.0000, 'ºC'),
	(344720, 145, '2015-02-01 00:17:25.000000', 'temperatura', 861.0000, 'ºC'),
	(344721, 145, '2015-02-01 00:17:26.000000', 'temperatura', 788.0000, 'ºC'),
	(344722, 145, '2015-02-01 00:17:27.000000', 'temperatura', 160.0000, 'ºC'),
	(344723, 145, '2015-02-01 00:17:28.000000', 'temperatura', 836.0000, 'ºC'),
	(344724, 145, '2015-02-01 00:17:29.000000', 'temperatura', 98.0000, 'ºC'),
	(344725, 145, '2015-02-01 00:17:30.000000', 'temperatura', 385.0000, 'ºC'),
	(344726, 145, '2015-02-01 00:17:31.000000', 'temperatura', 432.0000, 'ºC'),
	(344727, 145, '2015-02-01 00:17:32.000000', 'temperatura', 1006.0000, 'ºC'),
	(344728, 145, '2015-02-01 00:17:33.000000', 'temperatura', 132.0000, 'ºC'),
	(344729, 145, '2015-02-01 00:17:34.000000', 'temperatura', 44.0000, 'ºC'),
	(344730, 145, '2015-02-01 00:17:35.000000', 'temperatura', 1024.0000, 'ºC'),
	(344731, 145, '2015-02-01 00:17:36.000000', 'temperatura', 190.0000, 'ºC'),
	(344732, 145, '2015-02-01 00:17:37.000000', 'temperatura', 279.0000, 'ºC'),
	(344733, 145, '2015-02-01 00:17:38.000000', 'temperatura', 824.0000, 'ºC'),
	(344734, 145, '2015-02-01 00:17:39.000000', 'temperatura', 884.0000, 'ºC'),
	(344735, 145, '2015-02-01 00:17:40.000000', 'temperatura', 750.0000, 'ºC'),
	(344736, 145, '2015-02-01 00:17:41.000000', 'temperatura', 1099.0000, 'ºC'),
	(344737, 145, '2015-02-01 00:17:42.000000', 'temperatura', 844.0000, 'ºC'),
	(344738, 145, '2015-02-01 00:17:43.000000', 'temperatura', 924.0000, 'ºC'),
	(344739, 145, '2015-02-01 00:17:44.000000', 'temperatura', 889.0000, 'ºC'),
	(344740, 145, '2015-02-01 00:17:45.000000', 'temperatura', 473.0000, 'ºC'),
	(344741, 145, '2015-02-01 00:17:46.000000', 'temperatura', 899.0000, 'ºC'),
	(344742, 145, '2015-02-01 00:17:47.000000', 'temperatura', 678.0000, 'ºC'),
	(344743, 145, '2015-02-01 00:17:48.000000', 'temperatura', 690.0000, 'ºC'),
	(344744, 145, '2015-02-01 00:17:49.000000', 'temperatura', 220.0000, 'ºC'),
	(344745, 145, '2015-02-01 00:17:50.000000', 'temperatura', 229.0000, 'ºC'),
	(344746, 145, '2015-02-01 00:17:51.000000', 'temperatura', 485.0000, 'ºC'),
	(344747, 145, '2015-02-01 00:17:52.000000', 'temperatura', 538.0000, 'ºC'),
	(344748, 145, '2015-02-01 00:17:53.000000', 'temperatura', 35.0000, 'ºC'),
	(344749, 145, '2015-02-01 00:17:54.000000', 'temperatura', 962.0000, 'ºC'),
	(344750, 145, '2015-02-01 00:17:55.000000', 'temperatura', 1108.0000, 'ºC'),
	(344751, 145, '2015-02-01 00:17:56.000000', 'temperatura', 251.0000, 'ºC'),
	(344752, 145, '2015-02-01 00:17:57.000000', 'temperatura', 333.0000, 'ºC'),
	(344753, 145, '2015-02-01 00:17:58.000000', 'temperatura', 910.0000, 'ºC'),
	(344754, 145, '2015-02-01 00:17:59.000000', 'temperatura', 1155.0000, 'ºC'),
	(344755, 145, '2015-02-01 00:18:00.000000', 'temperatura', 643.0000, 'ºC'),
	(344756, 145, '2015-02-01 00:18:01.000000', 'temperatura', 953.0000, 'ºC'),
	(344757, 145, '2015-02-01 00:18:02.000000', 'temperatura', 433.0000, 'ºC'),
	(344758, 145, '2015-02-01 00:18:03.000000', 'temperatura', 509.0000, 'ºC'),
	(344759, 145, '2015-02-01 00:18:04.000000', 'temperatura', 47.0000, 'ºC'),
	(344760, 145, '2015-02-01 00:18:05.000000', 'temperatura', 1107.0000, 'ºC'),
	(344761, 145, '2015-02-01 00:18:06.000000', 'temperatura', 595.0000, 'ºC'),
	(344762, 145, '2015-02-01 00:18:07.000000', 'temperatura', 853.0000, 'ºC'),
	(344763, 145, '2015-02-01 00:18:08.000000', 'temperatura', 82.0000, 'ºC'),
	(344764, 145, '2015-02-01 00:18:09.000000', 'temperatura', 253.0000, 'ºC'),
	(344765, 145, '2015-02-01 00:18:10.000000', 'temperatura', 1016.0000, 'ºC'),
	(344766, 145, '2015-02-01 00:18:11.000000', 'temperatura', 724.0000, 'ºC'),
	(344767, 145, '2015-02-01 00:18:12.000000', 'temperatura', 573.0000, 'ºC'),
	(344768, 145, '2015-02-01 00:18:13.000000', 'temperatura', 692.0000, 'ºC'),
	(344769, 145, '2015-02-01 00:18:14.000000', 'temperatura', 542.0000, 'ºC'),
	(344770, 145, '2015-02-01 00:18:15.000000', 'temperatura', 633.0000, 'ºC'),
	(344771, 145, '2015-02-01 00:18:16.000000', 'temperatura', 342.0000, 'ºC'),
	(344772, 145, '2015-02-01 00:18:17.000000', 'temperatura', 1010.0000, 'ºC'),
	(344773, 145, '2015-02-01 00:18:18.000000', 'temperatura', 426.0000, 'ºC'),
	(344774, 145, '2015-02-01 00:18:19.000000', 'temperatura', 301.0000, 'ºC'),
	(344775, 145, '2015-02-01 00:18:20.000000', 'temperatura', 227.0000, 'ºC'),
	(344776, 145, '2015-02-01 00:18:21.000000', 'temperatura', 233.0000, 'ºC'),
	(344777, 145, '2015-02-01 00:18:22.000000', 'temperatura', 485.0000, 'ºC'),
	(344778, 145, '2015-02-01 00:18:23.000000', 'temperatura', 527.0000, 'ºC'),
	(344779, 145, '2015-02-01 00:18:24.000000', 'temperatura', 1179.0000, 'ºC'),
	(344780, 145, '2015-02-01 00:18:25.000000', 'temperatura', 716.0000, 'ºC'),
	(344781, 145, '2015-02-01 00:18:26.000000', 'temperatura', 44.0000, 'ºC'),
	(344782, 145, '2015-02-01 00:18:27.000000', 'temperatura', 474.0000, 'ºC'),
	(344783, 145, '2015-02-01 00:18:28.000000', 'temperatura', 1035.0000, 'ºC'),
	(344784, 145, '2015-02-01 00:18:29.000000', 'temperatura', 156.0000, 'ºC'),
	(344785, 145, '2015-02-01 00:18:30.000000', 'temperatura', 77.0000, 'ºC'),
	(344786, 145, '2015-02-01 00:18:31.000000', 'temperatura', 1114.0000, 'ºC'),
	(344787, 145, '2015-02-01 00:18:32.000000', 'temperatura', 540.0000, 'ºC'),
	(344788, 145, '2015-02-01 00:18:33.000000', 'temperatura', 558.0000, 'ºC'),
	(344789, 145, '2015-02-01 00:18:34.000000', 'temperatura', 1172.0000, 'ºC'),
	(344790, 145, '2015-02-01 00:18:35.000000', 'temperatura', 585.0000, 'ºC'),
	(344791, 145, '2015-02-01 00:18:36.000000', 'temperatura', 610.0000, 'ºC'),
	(344792, 145, '2015-02-01 00:18:37.000000', 'temperatura', 98.0000, 'ºC'),
	(344793, 145, '2015-02-01 00:18:38.000000', 'temperatura', 1057.0000, 'ºC'),
	(344794, 145, '2015-02-01 00:18:39.000000', 'temperatura', 193.0000, 'ºC'),
	(344795, 145, '2015-02-01 00:18:40.000000', 'temperatura', 194.0000, 'ºC'),
	(344796, 145, '2015-02-01 00:18:41.000000', 'temperatura', 393.0000, 'ºC'),
	(344797, 145, '2015-02-01 00:18:42.000000', 'temperatura', 182.0000, 'ºC'),
	(344798, 145, '2015-02-01 00:18:43.000000', 'temperatura', 932.0000, 'ºC'),
	(344799, 145, '2015-02-01 00:18:44.000000', 'temperatura', 515.0000, 'ºC'),
	(344800, 145, '2015-02-01 00:18:45.000000', 'temperatura', 978.0000, 'ºC'),
	(344801, 145, '2015-02-01 00:18:46.000000', 'temperatura', 946.0000, 'ºC'),
	(344802, 145, '2015-02-01 00:18:47.000000', 'temperatura', 598.0000, 'ºC'),
	(344803, 145, '2015-02-01 00:18:48.000000', 'temperatura', 151.0000, 'ºC'),
	(344804, 145, '2015-02-01 00:18:49.000000', 'temperatura', 160.0000, 'ºC'),
	(344805, 145, '2015-02-01 00:18:50.000000', 'temperatura', 351.0000, 'ºC'),
	(344806, 145, '2015-02-01 00:18:51.000000', 'temperatura', 73.0000, 'ºC'),
	(344807, 145, '2015-02-01 00:18:52.000000', 'temperatura', 514.0000, 'ºC'),
	(344808, 145, '2015-02-01 00:18:53.000000', 'temperatura', 1153.0000, 'ºC'),
	(344809, 145, '2015-02-01 00:18:54.000000', 'temperatura', 622.0000, 'ºC'),
	(344810, 145, '2015-02-01 00:18:55.000000', 'temperatura', 852.0000, 'ºC'),
	(344811, 145, '2015-02-01 00:18:56.000000', 'temperatura', 1192.0000, 'ºC'),
	(344812, 145, '2015-02-01 00:18:57.000000', 'temperatura', 1007.0000, 'ºC'),
	(344813, 145, '2015-02-01 00:18:58.000000', 'temperatura', 261.0000, 'ºC'),
	(344814, 145, '2015-02-01 00:18:59.000000', 'temperatura', 682.0000, 'ºC'),
	(344815, 145, '2015-02-01 00:19:00.000000', 'temperatura', 226.0000, 'ºC'),
	(344816, 145, '2015-02-01 00:19:01.000000', 'temperatura', 287.0000, 'ºC'),
	(344817, 145, '2015-02-01 00:19:02.000000', 'temperatura', 757.0000, 'ºC'),
	(344818, 145, '2015-02-01 00:19:03.000000', 'temperatura', 525.0000, 'ºC'),
	(344819, 145, '2015-02-01 00:19:04.000000', 'temperatura', 353.0000, 'ºC'),
	(344820, 145, '2015-02-01 00:19:05.000000', 'temperatura', 189.0000, 'ºC'),
	(344821, 145, '2015-02-01 00:19:06.000000', 'temperatura', 1089.0000, 'ºC'),
	(344822, 145, '2015-02-01 00:19:07.000000', 'temperatura', 76.0000, 'ºC'),
	(344823, 145, '2015-02-01 00:19:08.000000', 'temperatura', 715.0000, 'ºC'),
	(344824, 145, '2015-02-01 00:19:09.000000', 'temperatura', 948.0000, 'ºC'),
	(344825, 145, '2015-02-01 00:19:10.000000', 'temperatura', 196.0000, 'ºC'),
	(344826, 145, '2015-02-01 00:19:11.000000', 'temperatura', 537.0000, 'ºC'),
	(344827, 145, '2015-02-01 00:19:12.000000', 'temperatura', 895.0000, 'ºC'),
	(344828, 145, '2015-02-01 00:19:13.000000', 'temperatura', 467.0000, 'ºC'),
	(344829, 145, '2015-02-01 00:19:14.000000', 'temperatura', 849.0000, 'ºC'),
	(344830, 145, '2015-02-01 00:19:15.000000', 'temperatura', 443.0000, 'ºC'),
	(344831, 145, '2015-02-01 00:19:16.000000', 'temperatura', 870.0000, 'ºC'),
	(344832, 145, '2015-02-01 00:19:17.000000', 'temperatura', 620.0000, 'ºC'),
	(344833, 145, '2015-02-01 00:19:18.000000', 'temperatura', 492.0000, 'ºC'),
	(344834, 145, '2015-02-01 00:19:19.000000', 'temperatura', 602.0000, 'ºC'),
	(344835, 145, '2015-02-01 00:19:20.000000', 'temperatura', 333.0000, 'ºC'),
	(344836, 145, '2015-02-01 00:19:21.000000', 'temperatura', 1061.0000, 'ºC'),
	(344837, 145, '2015-02-01 00:19:22.000000', 'temperatura', 706.0000, 'ºC'),
	(344838, 145, '2015-02-01 00:19:23.000000', 'temperatura', 348.0000, 'ºC'),
	(344839, 145, '2015-02-01 00:19:24.000000', 'temperatura', 822.0000, 'ºC'),
	(344840, 145, '2015-02-01 00:19:25.000000', 'temperatura', 665.0000, 'ºC'),
	(344841, 145, '2015-02-01 00:19:26.000000', 'temperatura', 862.0000, 'ºC'),
	(344842, 145, '2015-02-01 00:19:27.000000', 'temperatura', 1113.0000, 'ºC'),
	(344843, 145, '2015-02-01 00:19:28.000000', 'temperatura', 582.0000, 'ºC'),
	(344844, 145, '2015-02-01 00:19:29.000000', 'temperatura', 772.0000, 'ºC'),
	(344845, 145, '2015-02-01 00:19:30.000000', 'temperatura', 911.0000, 'ºC'),
	(344846, 145, '2015-02-01 00:19:31.000000', 'temperatura', 1043.0000, 'ºC'),
	(344847, 145, '2015-02-01 00:19:32.000000', 'temperatura', 83.0000, 'ºC'),
	(344848, 145, '2015-02-01 00:19:33.000000', 'temperatura', 884.0000, 'ºC'),
	(344849, 145, '2015-02-01 00:19:34.000000', 'temperatura', 572.0000, 'ºC'),
	(344850, 145, '2015-02-01 00:19:35.000000', 'temperatura', 211.0000, 'ºC'),
	(344851, 145, '2015-02-01 00:19:36.000000', 'temperatura', 536.0000, 'ºC'),
	(344852, 145, '2015-02-01 00:19:37.000000', 'temperatura', 850.0000, 'ºC'),
	(344853, 145, '2015-02-01 00:19:38.000000', 'temperatura', 242.0000, 'ºC'),
	(344854, 145, '2015-02-01 00:19:39.000000', 'temperatura', 1061.0000, 'ºC'),
	(344855, 145, '2015-02-01 00:19:40.000000', 'temperatura', 978.0000, 'ºC'),
	(344856, 145, '2015-02-01 00:19:41.000000', 'temperatura', 507.0000, 'ºC'),
	(344857, 145, '2015-02-01 00:19:42.000000', 'temperatura', 802.0000, 'ºC'),
	(344858, 145, '2015-02-01 00:19:43.000000', 'temperatura', 88.0000, 'ºC'),
	(344859, 145, '2015-02-01 00:19:44.000000', 'temperatura', 434.0000, 'ºC'),
	(344860, 145, '2015-02-01 00:19:45.000000', 'temperatura', 709.0000, 'ºC'),
	(344861, 145, '2015-02-01 00:19:46.000000', 'temperatura', 1041.0000, 'ºC'),
	(344862, 145, '2015-02-01 00:19:47.000000', 'temperatura', 680.0000, 'ºC'),
	(344863, 145, '2015-02-01 00:19:48.000000', 'temperatura', 276.0000, 'ºC'),
	(344864, 145, '2015-02-01 00:19:49.000000', 'temperatura', 542.0000, 'ºC'),
	(344865, 145, '2015-02-01 00:19:50.000000', 'temperatura', 681.0000, 'ºC'),
	(344866, 145, '2015-02-01 00:19:51.000000', 'temperatura', 580.0000, 'ºC'),
	(344867, 145, '2015-02-01 00:19:52.000000', 'temperatura', 856.0000, 'ºC'),
	(344868, 145, '2015-02-01 00:19:53.000000', 'temperatura', 140.0000, 'ºC'),
	(344869, 145, '2015-02-01 00:19:54.000000', 'temperatura', 535.0000, 'ºC'),
	(344870, 145, '2015-02-01 00:19:55.000000', 'temperatura', 1055.0000, 'ºC'),
	(344871, 145, '2015-02-01 00:19:56.000000', 'temperatura', 70.0000, 'ºC'),
	(344872, 145, '2015-02-01 00:19:57.000000', 'temperatura', 787.0000, 'ºC'),
	(344873, 145, '2015-02-01 00:19:58.000000', 'temperatura', 123.0000, 'ºC'),
	(344874, 145, '2015-02-01 00:19:59.000000', 'temperatura', 654.0000, 'ºC'),
	(344875, 145, '2015-02-01 00:20:00.000000', 'temperatura', 501.0000, 'ºC'),
	(344876, 145, '2015-02-01 00:20:01.000000', 'temperatura', 544.0000, 'ºC'),
	(344877, 145, '2015-02-01 00:20:02.000000', 'temperatura', 17.0000, 'ºC'),
	(344878, 145, '2015-02-01 00:20:03.000000', 'temperatura', 856.0000, 'ºC'),
	(344879, 145, '2015-02-01 00:20:04.000000', 'temperatura', 629.0000, 'ºC'),
	(344880, 145, '2015-02-01 00:20:05.000000', 'temperatura', 577.0000, 'ºC'),
	(344881, 145, '2015-02-01 00:20:06.000000', 'temperatura', 999.0000, 'ºC'),
	(344882, 145, '2015-02-01 00:20:07.000000', 'temperatura', 865.0000, 'ºC'),
	(344883, 145, '2015-02-01 00:20:08.000000', 'temperatura', 127.0000, 'ºC'),
	(344884, 145, '2015-02-01 00:20:09.000000', 'temperatura', 440.0000, 'ºC'),
	(344885, 145, '2015-02-01 00:20:10.000000', 'temperatura', 621.0000, 'ºC'),
	(344886, 145, '2015-02-01 00:20:11.000000', 'temperatura', 585.0000, 'ºC'),
	(344887, 145, '2015-02-01 00:20:12.000000', 'temperatura', 1062.0000, 'ºC'),
	(344888, 145, '2015-02-01 00:20:13.000000', 'temperatura', 1155.0000, 'ºC'),
	(344889, 145, '2015-02-01 00:20:14.000000', 'temperatura', 192.0000, 'ºC'),
	(344890, 145, '2015-02-01 00:20:15.000000', 'temperatura', 1092.0000, 'ºC'),
	(344891, 145, '2015-02-01 00:20:16.000000', 'temperatura', 87.0000, 'ºC'),
	(344892, 145, '2015-02-01 00:20:17.000000', 'temperatura', 759.0000, 'ºC'),
	(344893, 145, '2015-02-01 00:20:18.000000', 'temperatura', 1134.0000, 'ºC'),
	(344894, 145, '2015-02-01 00:20:19.000000', 'temperatura', 993.0000, 'ºC'),
	(344895, 145, '2015-02-01 00:20:20.000000', 'temperatura', 364.0000, 'ºC'),
	(344896, 145, '2015-02-01 00:20:21.000000', 'temperatura', 42.0000, 'ºC'),
	(344897, 145, '2015-02-01 00:20:22.000000', 'temperatura', 319.0000, 'ºC'),
	(344898, 145, '2015-02-01 00:20:23.000000', 'temperatura', 269.0000, 'ºC'),
	(344899, 145, '2015-02-01 00:20:24.000000', 'temperatura', 387.0000, 'ºC'),
	(344900, 145, '2015-02-01 00:20:25.000000', 'temperatura', 1128.0000, 'ºC'),
	(344901, 145, '2015-02-01 00:20:26.000000', 'temperatura', 879.0000, 'ºC'),
	(344902, 145, '2015-02-01 00:20:27.000000', 'temperatura', 1015.0000, 'ºC'),
	(344903, 145, '2015-02-01 00:20:28.000000', 'temperatura', 35.0000, 'ºC'),
	(344904, 145, '2015-02-01 00:20:29.000000', 'temperatura', 733.0000, 'ºC'),
	(344905, 145, '2015-02-01 00:20:30.000000', 'temperatura', 1159.0000, 'ºC'),
	(344906, 145, '2015-02-01 00:20:31.000000', 'temperatura', 1197.0000, 'ºC'),
	(344907, 145, '2015-02-01 00:20:32.000000', 'temperatura', 110.0000, 'ºC'),
	(344908, 145, '2015-02-01 00:20:33.000000', 'temperatura', 558.0000, 'ºC'),
	(344909, 145, '2015-02-01 00:20:34.000000', 'temperatura', 59.0000, 'ºC'),
	(344910, 145, '2015-02-01 00:20:35.000000', 'temperatura', 1024.0000, 'ºC'),
	(344911, 145, '2015-02-01 00:20:36.000000', 'temperatura', 142.0000, 'ºC'),
	(344912, 145, '2015-02-01 00:20:37.000000', 'temperatura', 38.0000, 'ºC'),
	(344913, 145, '2015-02-01 00:20:38.000000', 'temperatura', 964.0000, 'ºC'),
	(344914, 145, '2015-02-01 00:20:39.000000', 'temperatura', 1107.0000, 'ºC'),
	(344915, 145, '2015-02-01 00:20:40.000000', 'temperatura', 246.0000, 'ºC'),
	(344916, 145, '2015-02-01 00:20:41.000000', 'temperatura', 307.0000, 'ºC'),
	(344917, 145, '2015-02-01 00:20:42.000000', 'temperatura', 799.0000, 'ºC'),
	(344918, 145, '2015-02-01 00:20:43.000000', 'temperatura', 674.0000, 'ºC'),
	(344919, 145, '2015-02-01 00:20:44.000000', 'temperatura', 973.0000, 'ºC'),
	(344920, 145, '2015-02-01 00:20:45.000000', 'temperatura', 445.0000, 'ºC'),
	(344921, 145, '2015-02-01 00:20:46.000000', 'temperatura', 505.0000, 'ºC'),
	(344922, 145, '2015-02-01 00:20:47.000000', 'temperatura', 1192.0000, 'ºC'),
	(344923, 145, '2015-02-01 00:20:48.000000', 'temperatura', 846.0000, 'ºC'),
	(344924, 145, '2015-02-01 00:20:49.000000', 'temperatura', 654.0000, 'ºC'),
	(344925, 145, '2015-02-01 00:20:50.000000', 'temperatura', 732.0000, 'ºC'),
	(344926, 145, '2015-02-01 00:20:51.000000', 'temperatura', 498.0000, 'ºC'),
	(344927, 145, '2015-02-01 00:20:52.000000', 'temperatura', 296.0000, 'ºC'),
	(344928, 145, '2015-02-01 00:20:53.000000', 'temperatura', 1184.0000, 'ºC'),
	(344929, 145, '2015-02-01 00:20:54.000000', 'temperatura', 234.0000, 'ºC'),
	(344930, 145, '2015-02-01 00:20:55.000000', 'temperatura', 17.0000, 'ºC'),
	(344931, 145, '2015-02-01 00:20:56.000000', 'temperatura', 583.0000, 'ºC'),
	(344932, 145, '2015-02-01 00:20:57.000000', 'temperatura', 466.0000, 'ºC'),
	(344933, 145, '2015-02-01 00:20:58.000000', 'temperatura', 580.0000, 'ºC'),
	(344934, 145, '2015-02-01 00:20:59.000000', 'temperatura', 303.0000, 'ºC'),
	(344935, 145, '2015-02-01 00:21:00.000000', 'temperatura', 974.0000, 'ºC'),
	(344936, 145, '2015-02-01 00:21:01.000000', 'temperatura', 363.0000, 'ºC'),
	(344937, 145, '2015-02-01 00:21:02.000000', 'temperatura', 95.0000, 'ºC'),
	(344938, 145, '2015-02-01 00:21:03.000000', 'temperatura', 584.0000, 'ºC'),
	(344939, 145, '2015-02-01 00:21:04.000000', 'temperatura', 237.0000, 'ºC'),
	(344940, 145, '2015-02-01 00:21:05.000000', 'temperatura', 635.0000, 'ºC'),
	(344941, 145, '2015-02-01 00:21:06.000000', 'temperatura', 63.0000, 'ºC'),
	(344942, 145, '2015-02-01 00:21:07.000000', 'temperatura', 812.0000, 'ºC'),
	(344943, 145, '2015-02-01 00:21:08.000000', 'temperatura', 270.0000, 'ºC'),
	(344944, 145, '2015-02-01 00:21:09.000000', 'temperatura', 116.0000, 'ºC'),
	(344945, 145, '2015-02-01 00:21:10.000000', 'temperatura', 969.0000, 'ºC'),
	(344946, 145, '2015-02-01 00:21:11.000000', 'temperatura', 899.0000, 'ºC'),
	(344947, 145, '2015-02-01 00:21:12.000000', 'temperatura', 389.0000, 'ºC'),
	(344948, 145, '2015-02-01 00:21:13.000000', 'temperatura', 448.0000, 'ºC'),
	(344949, 145, '2015-02-01 00:21:14.000000', 'temperatura', 1075.0000, 'ºC'),
	(344950, 145, '2015-02-01 00:21:15.000000', 'temperatura', 429.0000, 'ºC'),
	(344951, 145, '2015-02-01 00:21:16.000000', 'temperatura', 121.0000, 'ºC'),
	(344952, 145, '2015-02-01 00:21:17.000000', 'temperatura', 518.0000, 'ºC'),
	(344953, 145, '2015-02-01 00:21:18.000000', 'temperatura', 1029.0000, 'ºC'),
	(344954, 145, '2015-02-01 00:21:19.000000', 'temperatura', 1189.0000, 'ºC'),
	(344955, 145, '2015-02-01 00:21:20.000000', 'temperatura', 461.0000, 'ºC'),
	(344956, 145, '2015-02-01 00:21:21.000000', 'temperatura', 1139.0000, 'ºC'),
	(344957, 145, '2015-02-01 00:21:22.000000', 'temperatura', 713.0000, 'ºC'),
	(344958, 145, '2015-02-01 00:21:23.000000', 'temperatura', 148.0000, 'ºC'),
	(344959, 145, '2015-02-01 00:21:24.000000', 'temperatura', 1001.0000, 'ºC'),
	(344960, 145, '2015-02-01 00:21:25.000000', 'temperatura', 962.0000, 'ºC'),
	(344961, 145, '2015-02-01 00:21:26.000000', 'temperatura', 607.0000, 'ºC'),
	(344962, 145, '2015-02-01 00:21:27.000000', 'temperatura', 148.0000, 'ºC'),
	(344963, 145, '2015-02-01 00:21:28.000000', 'temperatura', 120.0000, 'ºC'),
	(344964, 145, '2015-02-01 00:21:29.000000', 'temperatura', 156.0000, 'ºC'),
	(344965, 145, '2015-02-01 00:21:30.000000', 'temperatura', 420.0000, 'ºC'),
	(344966, 145, '2015-02-01 00:21:31.000000', 'temperatura', 433.0000, 'ºC'),
	(344967, 145, '2015-02-01 00:21:32.000000', 'temperatura', 905.0000, 'ºC'),
	(344968, 145, '2015-02-01 00:21:33.000000', 'temperatura', 828.0000, 'ºC'),
	(344969, 145, '2015-02-01 00:21:34.000000', 'temperatura', 224.0000, 'ºC'),
	(344970, 145, '2015-02-01 00:21:35.000000', 'temperatura', 1037.0000, 'ºC'),
	(344971, 145, '2015-02-01 00:21:36.000000', 'temperatura', 915.0000, 'ºC'),
	(344972, 145, '2015-02-01 00:21:37.000000', 'temperatura', 265.0000, 'ºC'),
	(344973, 145, '2015-02-01 00:21:38.000000', 'temperatura', 981.0000, 'ºC'),
	(344974, 145, '2015-02-01 00:21:39.000000', 'temperatura', 509.0000, 'ºC'),
	(344975, 145, '2015-02-01 00:21:40.000000', 'temperatura', 802.0000, 'ºC'),
	(344976, 145, '2015-02-01 00:21:41.000000', 'temperatura', 84.0000, 'ºC'),
	(344977, 145, '2015-02-01 00:21:42.000000', 'temperatura', 416.0000, 'ºC'),
	(344978, 145, '2015-02-01 00:21:43.000000', 'temperatura', 629.0000, 'ºC'),
	(344979, 145, '2015-02-01 00:21:44.000000', 'temperatura', 696.0000, 'ºC'),
	(344980, 145, '2015-02-01 00:21:45.000000', 'temperatura', 396.0000, 'ºC'),
	(344981, 145, '2015-02-01 00:21:46.000000', 'temperatura', 1090.0000, 'ºC'),
	(344982, 145, '2015-02-01 00:21:47.000000', 'temperatura', 663.0000, 'ºC'),
	(344983, 145, '2015-02-01 00:21:48.000000', 'temperatura', 45.0000, 'ºC'),
	(344984, 145, '2015-02-01 00:21:49.000000', 'temperatura', 635.0000, 'ºC'),
	(344985, 145, '2015-02-01 00:21:50.000000', 'temperatura', 642.0000, 'ºC'),
	(344986, 145, '2015-02-01 00:21:51.000000', 'temperatura', 105.0000, 'ºC'),
	(344987, 145, '2015-02-01 00:21:52.000000', 'temperatura', 1000.0000, 'ºC'),
	(344988, 145, '2015-02-01 00:21:53.000000', 'temperatura', 1084.0000, 'ºC'),
	(344989, 145, '2015-02-01 00:21:54.000000', 'temperatura', 23.0000, 'ºC'),
	(344990, 145, '2015-02-01 00:21:55.000000', 'temperatura', 464.0000, 'ºC'),
	(344991, 145, '2015-02-01 00:21:56.000000', 'temperatura', 1052.0000, 'ºC'),
	(344992, 145, '2015-02-01 00:21:57.000000', 'temperatura', 267.0000, 'ºC'),
	(344993, 145, '2015-02-01 00:21:58.000000', 'temperatura', 578.0000, 'ºC'),
	(344994, 145, '2015-02-01 00:21:59.000000', 'temperatura', 892.0000, 'ºC'),
	(344995, 145, '2015-02-01 00:22:00.000000', 'temperatura', 325.0000, 'ºC'),
	(344996, 145, '2015-02-01 00:22:01.000000', 'temperatura', 149.0000, 'ºC'),
	(344997, 145, '2015-02-01 00:22:02.000000', 'temperatura', 973.0000, 'ºC'),
	(344998, 145, '2015-02-01 00:22:03.000000', 'temperatura', 816.0000, 'ºC'),
	(344999, 145, '2015-02-01 00:22:04.000000', 'temperatura', 1163.0000, 'ºC'),
	(345000, 145, '2015-02-01 00:22:05.000000', 'temperatura', 966.0000, 'ºC'),
	(345001, 145, '2015-02-01 00:22:06.000000', 'temperatura', 142.0000, 'ºC'),
	(345002, 145, '2015-02-01 00:22:07.000000', 'temperatura', 211.0000, 'ºC'),
	(345003, 145, '2015-02-01 00:22:08.000000', 'temperatura', 629.0000, 'ºC'),
	(345004, 145, '2015-02-01 00:22:09.000000', 'temperatura', 114.0000, 'ºC'),
	(345005, 145, '2015-02-01 00:22:10.000000', 'temperatura', 1083.0000, 'ºC'),
	(345006, 145, '2015-02-01 00:22:11.000000', 'temperatura', 275.0000, 'ºC'),
	(345007, 145, '2015-02-01 00:22:12.000000', 'temperatura', 525.0000, 'ºC'),
	(345008, 145, '2015-02-01 00:22:13.000000', 'temperatura', 600.0000, 'ºC'),
	(345009, 145, '2015-02-01 00:22:14.000000', 'temperatura', 226.0000, 'ºC'),
	(345010, 145, '2015-02-01 00:22:15.000000', 'temperatura', 529.0000, 'ºC'),
	(345011, 145, '2015-02-01 00:22:16.000000', 'temperatura', 769.0000, 'ºC'),
	(345012, 145, '2015-02-01 00:22:17.000000', 'temperatura', 1060.0000, 'ºC'),
	(345013, 145, '2015-02-01 00:22:18.000000', 'temperatura', 592.0000, 'ºC'),
	(345014, 145, '2015-02-01 00:22:19.000000', 'temperatura', 980.0000, 'ºC'),
	(345015, 145, '2015-02-01 00:22:20.000000', 'temperatura', 724.0000, 'ºC'),
	(345016, 145, '2015-02-01 00:22:21.000000', 'temperatura', 680.0000, 'ºC'),
	(345017, 145, '2015-02-01 00:22:22.000000', 'temperatura', 30.0000, 'ºC'),
	(345018, 145, '2015-02-01 00:22:23.000000', 'temperatura', 509.0000, 'ºC'),
	(345019, 145, '2015-02-01 00:22:24.000000', 'temperatura', 57.0000, 'ºC'),
	(345020, 145, '2015-02-01 00:22:25.000000', 'temperatura', 1160.0000, 'ºC'),
	(345021, 145, '2015-02-01 00:22:26.000000', 'temperatura', 827.0000, 'ºC'),
	(345022, 145, '2015-02-01 00:22:27.000000', 'temperatura', 656.0000, 'ºC'),
	(345023, 145, '2015-02-01 00:22:28.000000', 'temperatura', 798.0000, 'ºC'),
	(345024, 145, '2015-02-01 00:22:29.000000', 'temperatura', 824.0000, 'ºC'),
	(345025, 145, '2015-02-01 00:22:30.000000', 'temperatura', 527.0000, 'ºC'),
	(345026, 145, '2015-02-01 00:22:31.000000', 'temperatura', 162.0000, 'ºC'),
	(345027, 145, '2015-02-01 00:22:32.000000', 'temperatura', 430.0000, 'ºC'),
	(345028, 145, '2015-02-01 00:22:33.000000', 'temperatura', 463.0000, 'ºC'),
	(345029, 145, '2015-02-01 00:22:34.000000', 'temperatura', 1028.0000, 'ºC'),
	(345030, 145, '2015-02-01 00:22:35.000000', 'temperatura', 149.0000, 'ºC'),
	(345031, 145, '2015-02-01 00:22:36.000000', 'temperatura', 64.0000, 'ºC'),
	(345032, 145, '2015-02-01 00:22:37.000000', 'temperatura', 1073.0000, 'ºC'),
	(345033, 145, '2015-02-01 00:22:38.000000', 'temperatura', 374.0000, 'ºC'),
	(345034, 145, '2015-02-01 00:22:39.000000', 'temperatura', 1051.0000, 'ºC'),
	(345035, 145, '2015-02-01 00:22:40.000000', 'temperatura', 534.0000, 'ºC'),
	(345036, 145, '2015-02-01 00:22:41.000000', 'temperatura', 718.0000, 'ºC'),
	(345037, 145, '2015-02-01 00:22:42.000000', 'temperatura', 789.0000, 'ºC'),
	(345038, 145, '2015-02-01 00:22:43.000000', 'temperatura', 593.0000, 'ºC'),
	(345039, 145, '2015-02-01 00:22:44.000000', 'temperatura', 596.0000, 'ºC'),
	(345040, 145, '2015-02-01 00:22:45.000000', 'temperatura', 2.0000, 'ºC'),
	(345041, 145, '2015-02-01 00:22:46.000000', 'temperatura', 622.0000, 'ºC'),
	(345042, 145, '2015-02-01 00:22:47.000000', 'temperatura', 705.0000, 'ºC'),
	(345043, 145, '2015-02-01 00:22:48.000000', 'temperatura', 457.0000, 'ºC'),
	(345044, 145, '2015-02-01 00:22:49.000000', 'temperatura', 173.0000, 'ºC'),
	(345045, 145, '2015-02-01 00:22:50.000000', 'temperatura', 696.0000, 'ºC'),
	(345046, 145, '2015-02-01 00:22:51.000000', 'temperatura', 560.0000, 'ºC'),
	(345047, 145, '2015-02-01 00:22:52.000000', 'temperatura', 714.0000, 'ºC'),
	(345048, 145, '2015-02-01 00:22:53.000000', 'temperatura', 690.0000, 'ºC'),
	(345049, 145, '2015-02-01 00:22:54.000000', 'temperatura', 110.0000, 'ºC'),
	(345050, 145, '2015-02-01 00:22:55.000000', 'temperatura', 880.0000, 'ºC'),
	(345051, 145, '2015-02-01 00:22:56.000000', 'temperatura', 468.0000, 'ºC'),
	(345052, 145, '2015-02-01 00:22:57.000000', 'temperatura', 902.0000, 'ºC'),
	(345053, 145, '2015-02-01 00:22:58.000000', 'temperatura', 708.0000, 'ºC'),
	(345054, 145, '2015-02-01 00:22:59.000000', 'temperatura', 832.0000, 'ºC'),
	(345055, 145, '2015-02-01 00:23:00.000000', 'temperatura', 837.0000, 'ºC'),
	(345056, 145, '2015-02-01 00:23:01.000000', 'temperatura', 492.0000, 'ºC'),
	(345057, 145, '2015-02-01 00:23:02.000000', 'temperatura', 1147.0000, 'ºC'),
	(345058, 145, '2015-02-01 00:23:03.000000', 'temperatura', 662.0000, 'ºC'),
	(345059, 145, '2015-02-01 00:23:04.000000', 'temperatura', 1069.0000, 'ºC'),
	(345060, 145, '2015-02-01 00:23:05.000000', 'temperatura', 961.0000, 'ºC'),
	(345061, 145, '2015-02-01 00:23:06.000000', 'temperatura', 397.0000, 'ºC'),
	(345062, 145, '2015-02-01 00:23:07.000000', 'temperatura', 301.0000, 'ºC'),
	(345063, 145, '2015-02-01 00:23:08.000000', 'temperatura', 316.0000, 'ºC'),
	(345064, 145, '2015-02-01 00:23:09.000000', 'temperatura', 676.0000, 'ºC'),
	(345065, 145, '2015-02-01 00:23:10.000000', 'temperatura', 33.0000, 'ºC'),
	(345066, 145, '2015-02-01 00:23:11.000000', 'temperatura', 538.0000, 'ºC'),
	(345067, 145, '2015-02-01 00:23:12.000000', 'temperatura', 193.0000, 'ºC'),
	(345068, 145, '2015-02-01 00:23:13.000000', 'temperatura', 552.0000, 'ºC'),
	(345069, 145, '2015-02-01 00:23:14.000000', 'temperatura', 980.0000, 'ºC'),
	(345070, 145, '2015-02-01 00:23:15.000000', 'temperatura', 847.0000, 'ºC'),
	(345071, 145, '2015-02-01 00:23:16.000000', 'temperatura', 92.0000, 'ºC'),
	(345072, 145, '2015-02-01 00:23:17.000000', 'temperatura', 322.0000, 'ºC'),
	(345073, 145, '2015-02-01 00:23:18.000000', 'temperatura', 133.0000, 'ºC'),
	(345074, 145, '2015-02-01 00:23:19.000000', 'temperatura', 900.0000, 'ºC'),
	(345075, 145, '2015-02-01 00:23:20.000000', 'temperatura', 500.0000, 'ºC'),
	(345076, 145, '2015-02-01 00:23:21.000000', 'temperatura', 1002.0000, 'ºC'),
	(345077, 145, '2015-02-01 00:23:22.000000', 'temperatura', 1110.0000, 'ºC'),
	(345078, 145, '2015-02-01 00:23:23.000000', 'temperatura', 143.0000, 'ºC'),
	(345079, 145, '2015-02-01 00:23:24.000000', 'temperatura', 985.0000, 'ºC'),
	(345080, 145, '2015-02-01 00:23:25.000000', 'temperatura', 896.0000, 'ºC'),
	(345081, 145, '2015-02-01 00:23:26.000000', 'temperatura', 325.0000, 'ºC'),
	(345082, 145, '2015-02-01 00:23:27.000000', 'temperatura', 139.0000, 'ºC'),
	(345083, 145, '2015-02-01 00:23:28.000000', 'temperatura', 920.0000, 'ºC'),
	(345084, 145, '2015-02-01 00:23:29.000000', 'temperatura', 583.0000, 'ºC'),
	(345085, 145, '2015-02-01 00:23:30.000000', 'temperatura', 155.0000, 'ºC'),
	(345086, 145, '2015-02-01 00:23:31.000000', 'temperatura', 228.0000, 'ºC'),
	(345087, 145, '2015-02-01 00:23:32.000000', 'temperatura', 675.0000, 'ºC'),
	(345088, 145, '2015-02-01 00:23:33.000000', 'temperatura', 293.0000, 'ºC'),
	(345089, 145, '2015-02-01 00:23:34.000000', 'temperatura', 640.0000, 'ºC'),
	(345090, 145, '2015-02-01 00:23:35.000000', 'temperatura', 1119.0000, 'ºC'),
	(345091, 145, '2015-02-01 00:23:36.000000', 'temperatura', 77.0000, 'ºC'),
	(345092, 145, '2015-02-01 00:23:37.000000', 'temperatura', 627.0000, 'ºC'),
	(345093, 145, '2015-02-01 00:23:38.000000', 'temperatura', 507.0000, 'ºC'),
	(345094, 145, '2015-02-01 00:23:39.000000', 'temperatura', 654.0000, 'ºC'),
	(345095, 145, '2015-02-01 00:23:40.000000', 'temperatura', 548.0000, 'ºC'),
	(345096, 145, '2015-02-01 00:23:41.000000', 'temperatura', 781.0000, 'ºC'),
	(345097, 145, '2015-02-01 00:23:42.000000', 'temperatura', 1062.0000, 'ºC'),
	(345098, 145, '2015-02-01 00:23:43.000000', 'temperatura', 565.0000, 'ºC'),
	(345099, 145, '2015-02-01 00:23:44.000000', 'temperatura', 838.0000, 'ºC'),
	(345100, 145, '2015-02-01 00:23:45.000000', 'temperatura', 99.0000, 'ºC'),
	(345101, 145, '2015-02-01 00:23:46.000000', 'temperatura', 381.0000, 'ºC'),
	(345102, 145, '2015-02-01 00:23:47.000000', 'temperatura', 408.0000, 'ºC'),
	(345103, 145, '2015-02-01 00:23:48.000000', 'temperatura', 898.0000, 'ºC'),
	(345104, 145, '2015-02-01 00:23:49.000000', 'temperatura', 865.0000, 'ºC'),
	(345105, 145, '2015-02-01 00:23:50.000000', 'temperatura', 432.0000, 'ºC'),
	(345106, 145, '2015-02-01 00:23:51.000000', 'temperatura', 766.0000, 'ºC'),
	(345107, 145, '2015-02-01 00:23:52.000000', 'temperatura', 136.0000, 'ºC'),
	(345108, 145, '2015-02-01 00:23:53.000000', 'temperatura', 780.0000, 'ºC'),
	(345109, 145, '2015-02-01 00:23:54.000000', 'temperatura', 1092.0000, 'ºC'),
	(345110, 145, '2015-02-01 00:23:55.000000', 'temperatura', 723.0000, 'ºC'),
	(345111, 145, '2015-02-01 00:23:56.000000', 'temperatura', 338.0000, 'ºC'),
	(345112, 145, '2015-02-01 00:23:57.000000', 'temperatura', 722.0000, 'ºC'),
	(345113, 145, '2015-02-01 00:23:58.000000', 'temperatura', 198.0000, 'ºC'),
	(345114, 145, '2015-02-01 00:23:59.000000', 'temperatura', 22.0000, 'ºC'),
	(345115, 145, '2015-02-01 00:24:00.000000', 'temperatura', 720.0000, 'ºC'),
	(345116, 145, '2015-02-01 00:24:01.000000', 'temperatura', 1131.0000, 'ºC'),
	(345117, 145, '2015-02-01 00:24:02.000000', 'temperatura', 1095.0000, 'ºC'),
	(345118, 145, '2015-02-01 00:24:03.000000', 'temperatura', 885.0000, 'ºC'),
	(345119, 145, '2015-02-01 00:24:04.000000', 'temperatura', 1140.0000, 'ºC'),
	(345120, 145, '2015-02-01 00:24:05.000000', 'temperatura', 645.0000, 'ºC'),
	(345121, 145, '2015-02-01 00:24:06.000000', 'temperatura', 1007.0000, 'ºC'),
	(345122, 145, '2015-02-01 00:24:07.000000', 'temperatura', 699.0000, 'ºC'),
	(345123, 145, '2015-02-01 00:24:08.000000', 'temperatura', 474.0000, 'ºC'),
	(345124, 145, '2015-02-01 00:24:09.000000', 'temperatura', 276.0000, 'ºC'),
	(345125, 145, '2015-02-01 00:24:10.000000', 'temperatura', 1158.0000, 'ºC'),
	(345126, 145, '2015-02-01 00:24:11.000000', 'temperatura', 161.0000, 'ºC'),
	(345127, 145, '2015-02-01 00:24:12.000000', 'temperatura', 933.0000, 'ºC'),
	(345128, 145, '2015-02-01 00:24:13.000000', 'temperatura', 580.0000, 'ºC'),
	(345129, 145, '2015-02-01 00:24:14.000000', 'temperatura', 102.0000, 'ºC'),
	(345130, 145, '2015-02-01 00:24:15.000000', 'temperatura', 1172.0000, 'ºC'),
	(345131, 145, '2015-02-01 00:24:16.000000', 'temperatura', 755.0000, 'ºC'),
	(345132, 145, '2015-02-01 00:24:17.000000', 'temperatura', 257.0000, 'ºC'),
	(345133, 145, '2015-02-01 00:24:18.000000', 'temperatura', 220.0000, 'ºC'),
	(345134, 145, '2015-02-01 00:24:19.000000', 'temperatura', 332.0000, 'ºC'),
	(345135, 145, '2015-02-01 00:24:20.000000', 'temperatura', 997.0000, 'ºC'),
	(345136, 145, '2015-02-01 00:24:21.000000', 'temperatura', 393.0000, 'ºC'),
	(345137, 145, '2015-02-01 00:24:22.000000', 'temperatura', 175.0000, 'ºC'),
	(345138, 145, '2015-02-01 00:24:23.000000', 'temperatura', 895.0000, 'ºC'),
	(345139, 145, '2015-02-01 00:24:24.000000', 'temperatura', 352.0000, 'ºC'),
	(345140, 145, '2015-02-01 00:24:25.000000', 'temperatura', 275.0000, 'ºC'),
	(345141, 145, '2015-02-01 00:24:26.000000', 'temperatura', 319.0000, 'ºC'),
	(345142, 145, '2015-02-01 00:24:27.000000', 'temperatura', 770.0000, 'ºC'),
	(345143, 145, '2015-02-01 00:24:28.000000', 'temperatura', 495.0000, 'ºC'),
	(345144, 145, '2015-02-01 00:24:29.000000', 'temperatura', 167.0000, 'ºC'),
	(345145, 145, '2015-02-01 00:24:30.000000', 'temperatura', 548.0000, 'ºC'),
	(345146, 145, '2015-02-01 00:24:31.000000', 'temperatura', 1039.0000, 'ºC'),
	(345147, 145, '2015-02-01 00:24:32.000000', 'temperatura', 1152.0000, 'ºC'),
	(345148, 145, '2015-02-01 00:24:33.000000', 'temperatura', 244.0000, 'ºC'),
	(345149, 145, '2015-02-01 00:24:34.000000', 'temperatura', 162.0000, 'ºC'),
	(345150, 145, '2015-02-01 00:24:35.000000', 'temperatura', 82.0000, 'ºC'),
	(345151, 145, '2015-02-01 00:24:36.000000', 'temperatura', 1123.0000, 'ºC'),
	(345152, 145, '2015-02-01 00:24:37.000000', 'temperatura', 569.0000, 'ºC'),
	(345153, 145, '2015-02-01 00:24:38.000000', 'temperatura', 675.0000, 'ºC'),
	(345154, 145, '2015-02-01 00:24:39.000000', 'temperatura', 472.0000, 'ºC'),
	(345155, 145, '2015-02-01 00:24:40.000000', 'temperatura', 333.0000, 'ºC'),
	(345156, 145, '2015-02-01 00:24:41.000000', 'temperatura', 250.0000, 'ºC'),
	(345157, 145, '2015-02-01 00:24:42.000000', 'temperatura', 254.0000, 'ºC'),
	(345158, 145, '2015-02-01 00:24:43.000000', 'temperatura', 518.0000, 'ºC'),
	(345159, 145, '2015-02-01 00:24:44.000000', 'temperatura', 628.0000, 'ºC'),
	(345160, 145, '2015-02-01 00:24:45.000000', 'temperatura', 387.0000, 'ºC'),
	(345161, 145, '2015-02-01 00:24:46.000000', 'temperatura', 54.0000, 'ºC'),
	(345162, 145, '2015-02-01 00:24:47.000000', 'temperatura', 307.0000, 'ºC'),
	(345163, 145, '2015-02-01 00:24:48.000000', 'temperatura', 172.0000, 'ºC'),
	(345164, 145, '2015-02-01 00:24:49.000000', 'temperatura', 1142.0000, 'ºC'),
	(345165, 145, '2015-02-01 00:24:50.000000', 'temperatura', 394.0000, 'ºC'),
	(345166, 145, '2015-02-01 00:24:51.000000', 'temperatura', 944.0000, 'ºC'),
	(345167, 145, '2015-02-01 00:24:52.000000', 'temperatura', 1138.0000, 'ºC'),
	(345168, 145, '2015-02-01 00:24:53.000000', 'temperatura', 459.0000, 'ºC'),
	(345169, 145, '2015-02-01 00:24:54.000000', 'temperatura', 79.0000, 'ºC'),
	(345170, 145, '2015-02-01 00:24:55.000000', 'temperatura', 222.0000, 'ºC'),
	(345171, 145, '2015-02-01 00:24:56.000000', 'temperatura', 873.0000, 'ºC'),
	(345172, 145, '2015-02-01 00:24:57.000000', 'temperatura', 99.0000, 'ºC'),
	(345173, 145, '2015-02-01 00:24:58.000000', 'temperatura', 277.0000, 'ºC'),
	(345174, 145, '2015-02-01 00:24:59.000000', 'temperatura', 1090.0000, 'ºC'),
	(345175, 145, '2015-02-01 00:25:00.000000', 'temperatura', 1019.0000, 'ºC'),
	(345176, 145, '2015-02-01 00:25:01.000000', 'temperatura', 623.0000, 'ºC'),
	(345177, 145, '2015-02-01 00:25:02.000000', 'temperatura', 59.0000, 'ºC'),
	(345178, 145, '2015-02-01 00:25:03.000000', 'temperatura', 827.0000, 'ºC'),
	(345179, 145, '2015-02-01 00:25:04.000000', 'temperatura', 360.0000, 'ºC'),
	(345180, 145, '2015-02-01 00:25:05.000000', 'temperatura', 517.0000, 'ºC'),
	(345181, 145, '2015-02-01 00:25:06.000000', 'temperatura', 306.0000, 'ºC'),
	(345182, 145, '2015-02-01 00:25:07.000000', 'temperatura', 1179.0000, 'ºC'),
	(345183, 145, '2015-02-01 00:25:08.000000', 'temperatura', 178.0000, 'ºC'),
	(345184, 145, '2015-02-01 00:25:09.000000', 'temperatura', 953.0000, 'ºC'),
	(345185, 145, '2015-02-01 00:25:10.000000', 'temperatura', 632.0000, 'ºC'),
	(345186, 145, '2015-02-01 00:25:11.000000', 'temperatura', 302.0000, 'ºC'),
	(345187, 145, '2015-02-01 00:25:12.000000', 'temperatura', 814.0000, 'ºC'),
	(345188, 145, '2015-02-01 00:25:13.000000', 'temperatura', 765.0000, 'ºC'),
	(345189, 145, '2015-02-01 00:25:14.000000', 'temperatura', 183.0000, 'ºC'),
	(345190, 145, '2015-02-01 00:25:15.000000', 'temperatura', 1022.0000, 'ºC'),
	(345191, 145, '2015-02-01 00:25:16.000000', 'temperatura', 961.0000, 'ºC'),
	(345192, 145, '2015-02-01 00:25:17.000000', 'temperatura', 541.0000, 'ºC'),
	(345193, 145, '2015-02-01 00:25:18.000000', 'temperatura', 1020.0000, 'ºC'),
	(345194, 145, '2015-02-01 00:25:19.000000', 'temperatura', 1077.0000, 'ºC'),
	(345195, 145, '2015-02-01 00:25:20.000000', 'temperatura', 1125.0000, 'ºC'),
	(345196, 145, '2015-02-01 00:25:21.000000', 'temperatura', 1196.0000, 'ºC'),
	(345197, 145, '2015-02-01 00:25:22.000000', 'temperatura', 207.0000, 'ºC'),
	(345198, 145, '2015-02-01 00:25:23.000000', 'temperatura', 1045.0000, 'ºC'),
	(345199, 145, '2015-02-01 00:25:24.000000', 'temperatura', 1004.0000, 'ºC'),
	(345200, 145, '2015-02-01 00:25:25.000000', 'temperatura', 685.0000, 'ºC'),
	(345201, 145, '2015-02-01 00:25:26.000000', 'temperatura', 416.0000, 'ºC'),
	(345202, 145, '2015-02-01 00:25:27.000000', 'temperatura', 25.0000, 'ºC'),
	(345203, 145, '2015-02-01 00:25:28.000000', 'temperatura', 76.0000, 'ºC'),
	(345204, 145, '2015-02-01 00:25:29.000000', 'temperatura', 305.0000, 'ºC'),
	(345205, 145, '2015-02-01 00:25:30.000000', 'temperatura', 99.0000, 'ºC'),
	(345206, 145, '2015-02-01 00:25:31.000000', 'temperatura', 779.0000, 'ºC'),
	(345207, 145, '2015-02-01 00:25:32.000000', 'temperatura', 1197.0000, 'ºC'),
	(345208, 145, '2015-02-01 00:25:33.000000', 'temperatura', 51.0000, 'ºC'),
	(345209, 145, '2015-02-01 00:25:34.000000', 'temperatura', 263.0000, 'ºC'),
	(345210, 145, '2015-02-01 00:25:35.000000', 'temperatura', 1164.0000, 'ºC'),
	(345211, 145, '2015-02-01 00:25:36.000000', 'temperatura', 233.0000, 'ºC'),
	(345212, 145, '2015-02-01 00:25:37.000000', 'temperatura', 71.0000, 'ºC'),
	(345213, 145, '2015-02-01 00:25:38.000000', 'temperatura', 857.0000, 'ºC'),
	(345214, 145, '2015-02-01 00:25:39.000000', 'temperatura', 471.0000, 'ºC'),
	(345215, 145, '2015-02-01 00:25:40.000000', 'temperatura', 984.0000, 'ºC'),
	(345216, 145, '2015-02-01 00:25:41.000000', 'temperatura', 1108.0000, 'ºC'),
	(345217, 145, '2015-02-01 00:25:42.000000', 'temperatura', 190.0000, 'ºC'),
	(345218, 145, '2015-02-01 00:25:43.000000', 'temperatura', 26.0000, 'ºC'),
	(345219, 145, '2015-02-01 00:25:44.000000', 'temperatura', 761.0000, 'ºC'),
	(345220, 145, '2015-02-01 00:25:45.000000', 'temperatura', 126.0000, 'ºC'),
	(345221, 145, '2015-02-01 00:25:46.000000', 'temperatura', 748.0000, 'ºC'),
	(345222, 145, '2015-02-01 00:25:47.000000', 'temperatura', 961.0000, 'ºC'),
	(345223, 145, '2015-02-01 00:25:48.000000', 'temperatura', 163.0000, 'ºC'),
	(345224, 145, '2015-02-01 00:25:49.000000', 'temperatura', 330.0000, 'ºC'),
	(345225, 145, '2015-02-01 00:25:50.000000', 'temperatura', 1165.0000, 'ºC'),
	(345226, 145, '2015-02-01 00:25:51.000000', 'temperatura', 33.0000, 'ºC'),
	(345227, 145, '2015-02-01 00:25:52.000000', 'temperatura', 271.0000, 'ºC'),
	(345228, 145, '2015-02-01 00:25:53.000000', 'temperatura', 58.0000, 'ºC'),
	(345229, 145, '2015-02-01 00:25:54.000000', 'temperatura', 675.0000, 'ºC'),
	(345230, 145, '2015-02-01 00:25:55.000000', 'temperatura', 801.0000, 'ºC'),
	(345231, 145, '2015-02-01 00:25:56.000000', 'temperatura', 780.0000, 'ºC'),
	(345232, 145, '2015-02-01 00:25:57.000000', 'temperatura', 299.0000, 'ºC'),
	(345233, 145, '2015-02-01 00:25:58.000000', 'temperatura', 357.0000, 'ºC'),
	(345234, 145, '2015-02-01 00:25:59.000000', 'temperatura', 889.0000, 'ºC'),
	(345235, 145, '2015-02-01 00:26:00.000000', 'temperatura', 973.0000, 'ºC'),
	(345236, 145, '2015-02-01 00:26:01.000000', 'temperatura', 999.0000, 'ºC'),
	(345237, 145, '2015-02-01 00:26:02.000000', 'temperatura', 877.0000, 'ºC'),
	(345238, 145, '2015-02-01 00:26:03.000000', 'temperatura', 189.0000, 'ºC'),
	(345239, 145, '2015-02-01 00:26:04.000000', 'temperatura', 712.0000, 'ºC'),
	(345240, 145, '2015-02-01 00:26:05.000000', 'temperatura', 594.0000, 'ºC'),
	(345241, 145, '2015-02-01 00:26:06.000000', 'temperatura', 837.0000, 'ºC'),
	(345242, 145, '2015-02-01 00:26:07.000000', 'temperatura', 0.0000, 'ºC'),
	(345243, 145, '2015-02-01 00:26:08.000000', 'temperatura', 1093.0000, 'ºC'),
	(345244, 145, '2015-02-01 00:26:09.000000', 'temperatura', 664.0000, 'ºC'),
	(345245, 145, '2015-02-01 00:26:10.000000', 'temperatura', 43.0000, 'ºC'),
	(345246, 145, '2015-02-01 00:26:11.000000', 'temperatura', 624.0000, 'ºC'),
	(345247, 145, '2015-02-01 00:26:12.000000', 'temperatura', 590.0000, 'ºC'),
	(345248, 145, '2015-02-01 00:26:13.000000', 'temperatura', 1080.0000, 'ºC'),
	(345249, 145, '2015-02-01 00:26:14.000000', 'temperatura', 29.0000, 'ºC'),
	(345250, 145, '2015-02-01 00:26:15.000000', 'temperatura', 505.0000, 'ºC'),
	(345251, 145, '2015-02-01 00:26:16.000000', 'temperatura', 37.0000, 'ºC'),
	(345252, 145, '2015-02-01 00:26:17.000000', 'temperatura', 1073.0000, 'ºC'),
	(345253, 145, '2015-02-01 00:26:18.000000', 'temperatura', 455.0000, 'ºC'),
	(345254, 145, '2015-02-01 00:26:19.000000', 'temperatura', 255.0000, 'ºC'),
	(345255, 145, '2015-02-01 00:26:20.000000', 'temperatura', 1109.0000, 'ºC'),
	(345256, 145, '2015-02-01 00:26:21.000000', 'temperatura', 1181.0000, 'ºC'),
	(345257, 145, '2015-02-01 00:26:22.000000', 'temperatura', 180.0000, 'ºC'),
	(345258, 145, '2015-02-01 00:26:23.000000', 'temperatura', 955.0000, 'ºC'),
	(345259, 145, '2015-02-01 00:26:24.000000', 'temperatura', 639.0000, 'ºC'),
	(345260, 145, '2015-02-01 00:26:25.000000', 'temperatura', 328.0000, 'ºC'),
	(345261, 145, '2015-02-01 00:26:26.000000', 'temperatura', 923.0000, 'ºC'),
	(345262, 145, '2015-02-01 00:26:27.000000', 'temperatura', 34.0000, 'ºC'),
	(345263, 145, '2015-02-01 00:26:28.000000', 'temperatura', 1000.0000, 'ºC'),
	(345264, 145, '2015-02-01 00:26:29.000000', 'temperatura', 100.0000, 'ºC'),
	(345265, 145, '2015-02-01 00:26:30.000000', 'temperatura', 1099.0000, 'ºC'),
	(345266, 145, '2015-02-01 00:26:31.000000', 'temperatura', 396.0000, 'ºC'),
	(345267, 145, '2015-02-01 00:26:32.000000', 'temperatura', 1084.0000, 'ºC'),
	(345268, 145, '2015-02-01 00:26:33.000000', 'temperatura', 631.0000, 'ºC'),
	(345269, 145, '2015-02-01 00:26:34.000000', 'temperatura', 1105.0000, 'ºC'),
	(345270, 145, '2015-02-01 00:26:35.000000', 'temperatura', 31.0000, 'ºC'),
	(345271, 145, '2015-02-01 00:26:36.000000', 'temperatura', 443.0000, 'ºC'),
	(345272, 145, '2015-02-01 00:26:37.000000', 'temperatura', 921.0000, 'ºC'),
	(345273, 145, '2015-02-01 00:26:38.000000', 'temperatura', 878.0000, 'ºC'),
	(345274, 145, '2015-02-01 00:26:39.000000', 'temperatura', 427.0000, 'ºC'),
	(345275, 145, '2015-02-01 00:26:40.000000', 'temperatura', 703.0000, 'ºC'),
	(345276, 145, '2015-02-01 00:26:41.000000', 'temperatura', 1033.0000, 'ºC'),
	(345277, 145, '2015-02-01 00:26:42.000000', 'temperatura', 655.0000, 'ºC'),
	(345278, 145, '2015-02-01 00:26:43.000000', 'temperatura', 177.0000, 'ºC'),
	(345279, 145, '2015-02-01 00:26:44.000000', 'temperatura', 120.0000, 'ºC'),
	(345280, 145, '2015-02-01 00:26:45.000000', 'temperatura', 69.0000, 'ºC'),
	(345281, 145, '2015-02-01 00:26:46.000000', 'temperatura', 1186.0000, 'ºC'),
	(345282, 145, '2015-02-01 00:26:47.000000', 'temperatura', 922.0000, 'ºC'),
	(345283, 145, '2015-02-01 00:26:48.000000', 'temperatura', 1052.0000, 'ºC'),
	(345284, 145, '2015-02-01 00:26:49.000000', 'temperatura', 95.0000, 'ºC'),
	(345285, 145, '2015-02-01 00:26:50.000000', 'temperatura', 921.0000, 'ºC'),
	(345286, 145, '2015-02-01 00:26:51.000000', 'temperatura', 720.0000, 'ºC'),
	(345287, 145, '2015-02-01 00:26:52.000000', 'temperatura', 836.0000, 'ºC'),
	(345288, 145, '2015-02-01 00:26:53.000000', 'temperatura', 820.0000, 'ºC'),
	(345289, 145, '2015-02-01 00:26:54.000000', 'temperatura', 394.0000, 'ºC'),
	(345290, 145, '2015-02-01 00:26:55.000000', 'temperatura', 710.0000, 'ºC'),
	(345291, 145, '2015-02-01 00:26:56.000000', 'temperatura', 1168.0000, 'ºC'),
	(345292, 145, '2015-02-01 00:26:57.000000', 'temperatura', 110.0000, 'ºC'),
	(345293, 145, '2015-02-01 00:26:58.000000', 'temperatura', 649.0000, 'ºC'),
	(345294, 145, '2015-02-01 00:26:59.000000', 'temperatura', 512.0000, 'ºC'),
	(345295, 145, '2015-02-01 00:27:00.000000', 'temperatura', 616.0000, 'ºC'),
	(345296, 145, '2015-02-01 00:27:01.000000', 'temperatura', 345.0000, 'ºC'),
	(345297, 145, '2015-02-01 00:27:02.000000', 'temperatura', 1078.0000, 'ºC'),
	(345298, 145, '2015-02-01 00:27:03.000000', 'temperatura', 755.0000, 'ºC'),
	(345299, 145, '2015-02-01 00:27:04.000000', 'temperatura', 539.0000, 'ºC'),
	(345300, 145, '2015-02-01 00:27:05.000000', 'temperatura', 433.0000, 'ºC'),
	(345301, 145, '2015-02-01 00:27:06.000000', 'temperatura', 547.0000, 'ºC'),
	(345302, 145, '2015-02-01 00:27:07.000000', 'temperatura', 237.0000, 'ºC'),
	(345303, 145, '2015-02-01 00:27:08.000000', 'temperatura', 743.0000, 'ºC'),
	(345304, 145, '2015-02-01 00:27:09.000000', 'temperatura', 605.0000, 'ºC'),
	(345305, 145, '2015-02-01 00:27:10.000000', 'temperatura', 799.0000, 'ºC'),
	(345306, 145, '2015-02-01 00:27:11.000000', 'temperatura', 979.0000, 'ºC'),
	(345307, 145, '2015-02-01 00:27:12.000000', 'temperatura', 97.0000, 'ºC'),
	(345308, 145, '2015-02-01 00:27:13.000000', 'temperatura', 1151.0000, 'ºC'),
	(345309, 145, '2015-02-01 00:27:14.000000', 'temperatura', 664.0000, 'ºC'),
	(345310, 145, '2015-02-01 00:27:15.000000', 'temperatura', 1066.0000, 'ºC'),
	(345311, 145, '2015-02-01 00:27:16.000000', 'temperatura', 938.0000, 'ºC'),
	(345312, 145, '2015-02-01 00:27:17.000000', 'temperatura', 295.0000, 'ºC'),
	(345313, 145, '2015-02-01 00:27:18.000000', 'temperatura', 1059.0000, 'ºC'),
	(345314, 145, '2015-02-01 00:27:19.000000', 'temperatura', 810.0000, 'ºC'),
	(345315, 145, '2015-02-01 00:27:20.000000', 'temperatura', 875.0000, 'ºC'),
	(345316, 145, '2015-02-01 00:27:21.000000', 'temperatura', 744.0000, 'ºC'),
	(345317, 145, '2015-02-01 00:27:22.000000', 'temperatura', 1097.0000, 'ºC'),
	(345318, 145, '2015-02-01 00:27:23.000000', 'temperatura', 852.0000, 'ºC'),
	(345319, 145, '2015-02-01 00:27:24.000000', 'temperatura', 971.0000, 'ºC'),
	(345320, 145, '2015-02-01 00:27:25.000000', 'temperatura', 1099.0000, 'ºC'),
	(345321, 145, '2015-02-01 00:27:26.000000', 'temperatura', 182.0000, 'ºC'),
	(345322, 145, '2015-02-01 00:27:27.000000', 'temperatura', 15.0000, 'ºC'),
	(345323, 145, '2015-02-01 00:27:28.000000', 'temperatura', 727.0000, 'ºC'),
	(345324, 145, '2015-02-01 00:27:29.000000', 'temperatura', 1190.0000, 'ºC'),
	(345325, 145, '2015-02-01 00:27:30.000000', 'temperatura', 171.0000, 'ºC'),
	(345326, 145, '2015-02-01 00:27:31.000000', 'temperatura', 886.0000, 'ºC'),
	(345327, 145, '2015-02-01 00:27:32.000000', 'temperatura', 317.0000, 'ºC'),
	(345328, 145, '2015-02-01 00:27:33.000000', 'temperatura', 130.0000, 'ºC'),
	(345329, 145, '2015-02-01 00:27:34.000000', 'temperatura', 896.0000, 'ºC'),
	(345330, 145, '2015-02-01 00:27:35.000000', 'temperatura', 490.0000, 'ºC'),
	(345331, 145, '2015-02-01 00:27:36.000000', 'temperatura', 966.0000, 'ºC'),
	(345332, 145, '2015-02-01 00:27:37.000000', 'temperatura', 957.0000, 'ºC'),
	(345333, 145, '2015-02-01 00:27:38.000000', 'temperatura', 688.0000, 'ºC'),
	(345334, 145, '2015-02-01 00:27:39.000000', 'temperatura', 569.0000, 'ºC'),
	(345335, 145, '2015-02-01 00:27:40.000000', 'temperatura', 783.0000, 'ºC'),
	(345336, 145, '2015-02-01 00:27:41.000000', 'temperatura', 1008.0000, 'ºC'),
	(345337, 145, '2015-02-01 00:27:42.000000', 'temperatura', 290.0000, 'ºC'),
	(345338, 145, '2015-02-01 00:27:43.000000', 'temperatura', 826.0000, 'ºC'),
	(345339, 145, '2015-02-01 00:27:44.000000', 'temperatura', 862.0000, 'ºC'),
	(345340, 145, '2015-02-01 00:27:45.000000', 'temperatura', 634.0000, 'ºC'),
	(345341, 145, '2015-02-01 00:27:46.000000', 'temperatura', 584.0000, 'ºC'),
	(345342, 145, '2015-02-01 00:27:47.000000', 'temperatura', 1017.0000, 'ºC'),
	(345343, 145, '2015-02-01 00:27:48.000000', 'temperatura', 936.0000, 'ºC'),
	(345344, 145, '2015-02-01 00:27:49.000000', 'temperatura', 429.0000, 'ºC'),
	(345345, 145, '2015-02-01 00:27:50.000000', 'temperatura', 536.0000, 'ºC'),
	(345346, 145, '2015-02-01 00:27:51.000000', 'temperatura', 195.0000, 'ºC'),
	(345347, 145, '2015-02-01 00:27:52.000000', 'temperatura', 567.0000, 'ºC'),
	(345348, 145, '2015-02-01 00:27:53.000000', 'temperatura', 1052.0000, 'ºC'),
	(345349, 145, '2015-02-01 00:27:54.000000', 'temperatura', 1159.0000, 'ºC'),
	(345350, 145, '2015-02-01 00:27:55.000000', 'temperatura', 240.0000, 'ºC'),
	(345351, 145, '2015-02-01 00:27:56.000000', 'temperatura', 124.0000, 'ºC'),
	(345352, 145, '2015-02-01 00:27:57.000000', 'temperatura', 1101.0000, 'ºC'),
	(345353, 145, '2015-02-01 00:27:58.000000', 'temperatura', 331.0000, 'ºC'),
	(345354, 145, '2015-02-01 00:27:59.000000', 'temperatura', 755.0000, 'ºC'),
	(345355, 145, '2015-02-01 00:28:00.000000', 'temperatura', 382.0000, 'ºC'),
	(345356, 145, '2015-02-01 00:28:01.000000', 'temperatura', 844.0000, 'ºC'),
	(345357, 145, '2015-02-01 00:28:02.000000', 'temperatura', 675.0000, 'ºC'),
	(345358, 145, '2015-02-01 00:28:03.000000', 'temperatura', 844.0000, 'ºC'),
	(345359, 145, '2015-02-01 00:28:04.000000', 'temperatura', 996.0000, 'ºC'),
	(345360, 145, '2015-02-01 00:28:05.000000', 'temperatura', 49.0000, 'ºC'),
	(345361, 145, '2015-02-01 00:28:06.000000', 'temperatura', 859.0000, 'ºC'),
	(345362, 145, '2015-02-01 00:28:07.000000', 'temperatura', 546.0000, 'ºC'),
	(345363, 145, '2015-02-01 00:28:08.000000', 'temperatura', 153.0000, 'ºC'),
	(345364, 145, '2015-02-01 00:28:09.000000', 'temperatura', 327.0000, 'ºC'),
	(345365, 145, '2015-02-01 00:28:10.000000', 'temperatura', 1178.0000, 'ºC'),
	(345366, 145, '2015-02-01 00:28:11.000000', 'temperatura', 111.0000, 'ºC'),
	(345367, 145, '2015-02-01 00:28:12.000000', 'temperatura', 620.0000, 'ºC'),
	(345368, 145, '2015-02-01 00:28:13.000000', 'temperatura', 367.0000, 'ºC'),
	(345369, 145, '2015-02-01 00:28:14.000000', 'temperatura', 1176.0000, 'ºC'),
	(345370, 145, '2015-02-01 00:28:15.000000', 'temperatura', 1177.0000, 'ºC'),
	(345371, 145, '2015-02-01 00:28:16.000000', 'temperatura', 1161.0000, 'ºC'),
	(345372, 145, '2015-02-01 00:28:17.000000', 'temperatura', 1073.0000, 'ºC'),
	(345373, 145, '2015-02-01 00:28:18.000000', 'temperatura', 682.0000, 'ºC'),
	(345374, 145, '2015-02-01 00:28:19.000000', 'temperatura', 191.0000, 'ºC'),
	(345375, 145, '2015-02-01 00:28:20.000000', 'temperatura', 109.0000, 'ºC'),
	(345376, 145, '2015-02-01 00:28:21.000000', 'temperatura', 1174.0000, 'ºC'),
	(345377, 145, '2015-02-01 00:28:22.000000', 'temperatura', 741.0000, 'ºC'),
	(345378, 145, '2015-02-01 00:28:23.000000', 'temperatura', 186.0000, 'ºC'),
	(345379, 145, '2015-02-01 00:28:24.000000', 'temperatura', 1108.0000, 'ºC'),
	(345380, 145, '2015-02-01 00:28:25.000000', 'temperatura', 181.0000, 'ºC'),
	(345381, 145, '2015-02-01 00:28:26.000000', 'temperatura', 1184.0000, 'ºC'),
	(345382, 145, '2015-02-01 00:28:27.000000', 'temperatura', 575.0000, 'ºC'),
	(345383, 145, '2015-02-01 00:28:28.000000', 'temperatura', 523.0000, 'ºC'),
	(345384, 145, '2015-02-01 00:28:29.000000', 'temperatura', 891.0000, 'ºC'),
	(345385, 145, '2015-02-01 00:28:30.000000', 'temperatura', 485.0000, 'ºC'),
	(345386, 145, '2015-02-01 00:28:31.000000', 'temperatura', 953.0000, 'ºC'),
	(345387, 145, '2015-02-01 00:28:32.000000', 'temperatura', 913.0000, 'ºC'),
	(345388, 145, '2015-02-01 00:28:33.000000', 'temperatura', 505.0000, 'ºC'),
	(345389, 145, '2015-02-01 00:28:34.000000', 'temperatura', 988.0000, 'ºC'),
	(345390, 145, '2015-02-01 00:28:35.000000', 'temperatura', 1024.0000, 'ºC'),
	(345391, 145, '2015-02-01 00:28:36.000000', 'temperatura', 957.0000, 'ºC'),
	(345392, 145, '2015-02-01 00:28:37.000000', 'temperatura', 512.0000, 'ºC'),
	(345393, 145, '2015-02-01 00:28:38.000000', 'temperatura', 890.0000, 'ºC'),
	(345394, 145, '2015-02-01 00:28:39.000000', 'temperatura', 515.0000, 'ºC'),
	(345395, 145, '2015-02-01 00:28:40.000000', 'temperatura', 1107.0000, 'ºC'),
	(345396, 145, '2015-02-01 00:28:41.000000', 'temperatura', 390.0000, 'ºC'),
	(345397, 145, '2015-02-01 00:28:42.000000', 'temperatura', 1030.0000, 'ºC'),
	(345398, 145, '2015-02-01 00:28:43.000000', 'temperatura', 381.0000, 'ºC'),
	(345399, 145, '2015-02-01 00:28:44.000000', 'temperatura', 15.0000, 'ºC'),
	(345400, 145, '2015-02-01 00:28:45.000000', 'temperatura', 134.0000, 'ºC'),
	(345401, 145, '2015-02-01 00:28:46.000000', 'temperatura', 626.0000, 'ºC'),
	(345402, 145, '2015-02-01 00:28:47.000000', 'temperatura', 327.0000, 'ºC'),
	(345403, 145, '2015-02-01 00:28:48.000000', 'temperatura', 959.0000, 'ºC'),
	(345404, 145, '2015-02-01 00:28:49.000000', 'temperatura', 212.0000, 'ºC'),
	(345405, 145, '2015-02-01 00:28:50.000000', 'temperatura', 583.0000, 'ºC'),
	(345406, 145, '2015-02-01 00:28:51.000000', 'temperatura', 1082.0000, 'ºC'),
	(345407, 145, '2015-02-01 00:28:52.000000', 'temperatura', 59.0000, 'ºC'),
	(345408, 145, '2015-02-01 00:28:53.000000', 'temperatura', 652.0000, 'ºC'),
	(345409, 145, '2015-02-01 00:28:54.000000', 'temperatura', 684.0000, 'ºC'),
	(345410, 145, '2015-02-01 00:28:55.000000', 'temperatura', 263.0000, 'ºC'),
	(345411, 145, '2015-02-01 00:28:56.000000', 'temperatura', 464.0000, 'ºC'),
	(345412, 145, '2015-02-01 00:28:57.000000', 'temperatura', 333.0000, 'ºC'),
	(345413, 145, '2015-02-01 00:28:58.000000', 'temperatura', 274.0000, 'ºC'),
	(345414, 145, '2015-02-01 00:28:59.000000', 'temperatura', 371.0000, 'ºC'),
	(345415, 145, '2015-02-01 00:29:00.000000', 'temperatura', 1034.0000, 'ºC'),
	(345416, 145, '2015-02-01 00:29:01.000000', 'temperatura', 457.0000, 'ºC'),
	(345417, 145, '2015-02-01 00:29:02.000000', 'temperatura', 381.0000, 'ºC'),
	(345418, 145, '2015-02-01 00:29:03.000000', 'temperatura', 538.0000, 'ºC'),
	(345419, 145, '2015-02-01 00:29:04.000000', 'temperatura', 346.0000, 'ºC'),
	(345420, 145, '2015-02-01 00:29:05.000000', 'temperatura', 117.0000, 'ºC'),
	(345421, 145, '2015-02-01 00:29:06.000000', 'temperatura', 749.0000, 'ºC'),
	(345422, 145, '2015-02-01 00:29:07.000000', 'temperatura', 993.0000, 'ºC'),
	(345423, 145, '2015-02-01 00:29:08.000000', 'temperatura', 320.0000, 'ºC'),
	(345424, 145, '2015-02-01 00:29:09.000000', 'temperatura', 1020.0000, 'ºC'),
	(345425, 145, '2015-02-01 00:29:10.000000', 'temperatura', 542.0000, 'ºC'),
	(345426, 145, '2015-02-01 00:29:11.000000', 'temperatura', 852.0000, 'ºC'),
	(345427, 145, '2015-02-01 00:29:12.000000', 'temperatura', 231.0000, 'ºC'),
	(345428, 145, '2015-02-01 00:29:13.000000', 'temperatura', 1002.0000, 'ºC'),
	(345429, 145, '2015-02-01 00:29:14.000000', 'temperatura', 715.0000, 'ºC'),
	(345430, 145, '2015-02-01 00:29:15.000000', 'temperatura', 572.0000, 'ºC'),
	(345431, 145, '2015-02-01 00:29:16.000000', 'temperatura', 717.0000, 'ºC'),
	(345432, 145, '2015-02-01 00:29:17.000000', 'temperatura', 666.0000, 'ºC'),
	(345433, 145, '2015-02-01 00:29:18.000000', 'temperatura', 1183.0000, 'ºC'),
	(345434, 145, '2015-02-01 00:29:19.000000', 'temperatura', 315.0000, 'ºC'),
	(345435, 145, '2015-02-01 00:29:20.000000', 'temperatura', 426.0000, 'ºC'),
	(345436, 145, '2015-02-01 00:29:21.000000', 'temperatura', 1187.0000, 'ºC'),
	(345437, 145, '2015-02-01 00:29:22.000000', 'temperatura', 1055.0000, 'ºC'),
	(345438, 145, '2015-02-01 00:29:23.000000', 'temperatura', 516.0000, 'ºC'),
	(345439, 145, '2015-02-01 00:29:24.000000', 'temperatura', 616.0000, 'ºC'),
	(345440, 145, '2015-02-01 00:29:25.000000', 'temperatura', 333.0000, 'ºC'),
	(345441, 145, '2015-02-01 00:29:26.000000', 'temperatura', 1018.0000, 'ºC'),
	(345442, 145, '2015-02-01 00:29:27.000000', 'temperatura', 492.0000, 'ºC'),
	(345443, 145, '2015-02-01 00:29:28.000000', 'temperatura', 604.0000, 'ºC'),
	(345444, 145, '2015-02-01 00:29:29.000000', 'temperatura', 347.0000, 'ºC'),
	(345445, 145, '2015-02-01 00:29:30.000000', 'temperatura', 1124.0000, 'ºC'),
	(345446, 145, '2015-02-01 00:29:31.000000', 'temperatura', 977.0000, 'ºC'),
	(345447, 145, '2015-02-01 00:29:32.000000', 'temperatura', 316.0000, 'ºC'),
	(345448, 145, '2015-02-01 00:29:33.000000', 'temperatura', 1048.0000, 'ºC'),
	(345449, 145, '2015-02-01 00:29:34.000000', 'temperatura', 693.0000, 'ºC'),
	(345450, 145, '2015-02-01 00:29:35.000000', 'temperatura', 322.0000, 'ºC'),
	(345451, 145, '2015-02-01 00:29:36.000000', 'temperatura', 730.0000, 'ºC'),
	(345452, 145, '2015-02-01 00:29:37.000000', 'temperatura', 287.0000, 'ºC'),
	(345453, 145, '2015-02-01 00:29:38.000000', 'temperatura', 445.0000, 'ºC'),
	(345454, 145, '2015-02-01 00:29:39.000000', 'temperatura', 166.0000, 'ºC'),
	(345455, 145, '2015-02-01 00:29:40.000000', 'temperatura', 692.0000, 'ºC'),
	(345456, 145, '2015-02-01 00:29:41.000000', 'temperatura', 566.0000, 'ºC'),
	(345457, 145, '2015-02-01 00:29:42.000000', 'temperatura', 752.0000, 'ºC'),
	(345458, 145, '2015-02-01 00:29:43.000000', 'temperatura', 863.0000, 'ºC'),
	(345459, 145, '2015-02-01 00:29:44.000000', 'temperatura', 858.0000, 'ºC'),
	(345460, 145, '2015-02-01 00:29:45.000000', 'temperatura', 501.0000, 'ºC'),
	(345461, 145, '2015-02-01 00:29:46.000000', 'temperatura', 1134.0000, 'ºC'),
	(345462, 145, '2015-02-01 00:29:47.000000', 'temperatura', 566.0000, 'ºC'),
	(345463, 145, '2015-02-01 00:29:48.000000', 'temperatura', 630.0000, 'ºC'),
	(345464, 145, '2015-02-01 00:29:49.000000', 'temperatura', 252.0000, 'ºC'),
	(345465, 145, '2015-02-01 00:29:50.000000', 'temperatura', 570.0000, 'ºC'),
	(345466, 145, '2015-02-01 00:29:51.000000', 'temperatura', 894.0000, 'ºC'),
	(345467, 145, '2015-02-01 00:29:52.000000', 'temperatura', 360.0000, 'ºC'),
	(345468, 145, '2015-02-01 00:29:53.000000', 'temperatura', 318.0000, 'ºC'),
	(345469, 145, '2015-02-01 00:29:54.000000', 'temperatura', 512.0000, 'ºC'),
	(345470, 145, '2015-02-01 00:29:55.000000', 'temperatura', 408.0000, 'ºC'),
	(345471, 145, '2015-02-01 00:29:56.000000', 'temperatura', 503.0000, 'ºC'),
	(345472, 145, '2015-02-01 00:29:57.000000', 'temperatura', 93.0000, 'ºC'),
	(345473, 145, '2015-02-01 00:29:58.000000', 'temperatura', 156.0000, 'ºC'),
	(345474, 145, '2015-02-01 00:29:59.000000', 'temperatura', 501.0000, 'ºC'),
	(345475, 145, '2015-02-01 00:30:00.000000', 'temperatura', 837.0000, 'ºC'),
	(345476, 145, '2015-02-01 00:30:01.000000', 'temperatura', 283.0000, 'ºC'),
	(345477, 145, '2015-02-01 00:30:02.000000', 'temperatura', 106.0000, 'ºC'),
	(345478, 145, '2015-02-01 00:30:03.000000', 'temperatura', 880.0000, 'ºC'),
	(345479, 145, '2015-02-01 00:30:04.000000', 'temperatura', 482.0000, 'ºC'),
	(345480, 145, '2015-02-01 00:30:05.000000', 'temperatura', 971.0000, 'ºC'),
	(345481, 145, '2015-02-01 00:30:06.000000', 'temperatura', 1008.0000, 'ºC'),
	(345482, 145, '2015-02-01 00:30:07.000000', 'temperatura', 927.0000, 'ºC'),
	(345483, 145, '2015-02-01 00:30:08.000000', 'temperatura', 414.0000, 'ºC'),
	(345484, 145, '2015-02-01 00:30:09.000000', 'temperatura', 489.0000, 'ºC'),
	(345485, 145, '2015-02-01 00:30:10.000000', 'temperatura', 5.0000, 'ºC'),
	(345486, 145, '2015-02-01 00:30:11.000000', 'temperatura', 955.0000, 'ºC'),
	(345487, 145, '2015-02-01 00:30:12.000000', 'temperatura', 1163.0000, 'ºC'),
	(345488, 145, '2015-02-01 00:30:13.000000', 'temperatura', 551.0000, 'ºC'),
	(345489, 145, '2015-02-01 00:30:14.000000', 'temperatura', 468.0000, 'ºC'),
	(345490, 145, '2015-02-01 00:30:15.000000', 'temperatura', 685.0000, 'ºC'),
	(345491, 145, '2015-02-01 00:30:16.000000', 'temperatura', 822.0000, 'ºC'),
	(345492, 145, '2015-02-01 00:30:17.000000', 'temperatura', 857.0000, 'ºC'),
	(345493, 145, '2015-02-01 00:30:18.000000', 'temperatura', 617.0000, 'ºC'),
	(345494, 145, '2015-02-01 00:30:19.000000', 'temperatura', 518.0000, 'ºC'),
	(345495, 145, '2015-02-01 00:30:20.000000', 'temperatura', 737.0000, 'ºC'),
	(345496, 145, '2015-02-01 00:30:21.000000', 'temperatura', 930.0000, 'ºC'),
	(345497, 145, '2015-02-01 00:30:22.000000', 'temperatura', 41.0000, 'ºC'),
	(345498, 145, '2015-02-01 00:30:23.000000', 'temperatura', 1014.0000, 'ºC'),
	(345499, 145, '2015-02-01 00:30:24.000000', 'temperatura', 147.0000, 'ºC'),
	(345500, 145, '2015-02-01 00:30:25.000000', 'temperatura', 96.0000, 'ºC'),
	(345501, 145, '2015-02-01 00:30:26.000000', 'temperatura', 38.0000, 'ºC'),
	(345502, 145, '2015-02-01 00:30:27.000000', 'temperatura', 1103.0000, 'ºC'),
	(345503, 145, '2015-02-01 00:30:28.000000', 'temperatura', 603.0000, 'ºC'),
	(345504, 145, '2015-02-01 00:30:29.000000', 'temperatura', 907.0000, 'ºC'),
	(345505, 145, '2015-02-01 00:30:30.000000', 'temperatura', 325.0000, 'ºC'),
	(345506, 145, '2015-02-01 00:30:31.000000', 'temperatura', 105.0000, 'ºC'),
	(345507, 145, '2015-02-01 00:30:32.000000', 'temperatura', 752.0000, 'ºC'),
	(345508, 145, '2015-02-01 00:30:33.000000', 'temperatura', 1043.0000, 'ºC'),
	(345509, 145, '2015-02-01 00:30:34.000000', 'temperatura', 562.0000, 'ºC'),
	(345510, 145, '2015-02-01 00:30:35.000000', 'temperatura', 882.0000, 'ºC'),
	(345511, 145, '2015-02-01 00:30:36.000000', 'temperatura', 324.0000, 'ºC'),
	(345512, 145, '2015-02-01 00:30:37.000000', 'temperatura', 175.0000, 'ºC'),
	(345513, 145, '2015-02-01 00:30:38.000000', 'temperatura', 1103.0000, 'ºC'),
	(345514, 145, '2015-02-01 00:30:39.000000', 'temperatura', 190.0000, 'ºC'),
	(345515, 145, '2015-02-01 00:30:40.000000', 'temperatura', 42.0000, 'ºC'),
	(345516, 145, '2015-02-01 00:30:41.000000', 'temperatura', 839.0000, 'ºC'),
	(345517, 145, '2015-02-01 00:30:42.000000', 'temperatura', 471.0000, 'ºC'),
	(345518, 145, '2015-02-01 00:30:43.000000', 'temperatura', 1039.0000, 'ºC'),
	(345519, 145, '2015-02-01 00:30:44.000000', 'temperatura', 183.0000, 'ºC'),
	(345520, 145, '2015-02-01 00:30:45.000000', 'temperatura', 199.0000, 'ºC'),
	(345521, 145, '2015-02-01 00:30:46.000000', 'temperatura', 445.0000, 'ºC'),
	(345522, 145, '2015-02-01 00:30:47.000000', 'temperatura', 429.0000, 'ºC'),
	(345523, 145, '2015-02-01 00:30:48.000000', 'temperatura', 810.0000, 'ºC'),
	(345524, 145, '2015-02-01 00:30:49.000000', 'temperatura', 364.0000, 'ºC'),
	(345525, 145, '2015-02-01 00:30:50.000000', 'temperatura', 591.0000, 'ºC'),
	(345526, 145, '2015-02-01 00:30:51.000000', 'temperatura', 663.0000, 'ºC'),
	(345527, 145, '2015-02-01 00:30:52.000000', 'temperatura', 344.0000, 'ºC'),
	(345528, 145, '2015-02-01 00:30:53.000000', 'temperatura', 931.0000, 'ºC'),
	(345529, 145, '2015-02-01 00:30:54.000000', 'temperatura', 21.0000, 'ºC'),
	(345530, 145, '2015-02-01 00:30:55.000000', 'temperatura', 915.0000, 'ºC'),
	(345531, 145, '2015-02-01 00:30:56.000000', 'temperatura', 910.0000, 'ºC'),
	(345532, 145, '2015-02-01 00:30:57.000000', 'temperatura', 608.0000, 'ºC'),
	(345533, 145, '2015-02-01 00:30:58.000000', 'temperatura', 311.0000, 'ºC'),
	(345534, 145, '2015-02-01 00:30:59.000000', 'temperatura', 930.0000, 'ºC'),
	(345535, 145, '2015-02-01 00:31:00.000000', 'temperatura', 117.0000, 'ºC'),
	(345536, 145, '2015-02-01 00:31:01.000000', 'temperatura', 195.0000, 'ºC'),
	(345537, 145, '2015-02-01 00:31:02.000000', 'temperatura', 625.0000, 'ºC'),
	(345538, 145, '2015-02-01 00:31:03.000000', 'temperatura', 142.0000, 'ºC'),
	(345539, 145, '2015-02-01 00:31:04.000000', 'temperatura', 36.0000, 'ºC'),
	(345540, 145, '2015-02-01 00:31:05.000000', 'temperatura', 953.0000, 'ºC'),
	(345541, 145, '2015-02-01 00:31:06.000000', 'temperatura', 1059.0000, 'ºC'),
	(345542, 145, '2015-02-01 00:31:07.000000', 'temperatura', 37.0000, 'ºC'),
	(345543, 145, '2015-02-01 00:31:08.000000', 'temperatura', 609.0000, 'ºC'),
	(345544, 145, '2015-02-01 00:31:09.000000', 'temperatura', 532.0000, 'ºC'),
	(345545, 145, '2015-02-01 00:31:10.000000', 'temperatura', 833.0000, 'ºC'),
	(345546, 145, '2015-02-01 00:31:11.000000', 'temperatura', 171.0000, 'ºC'),
	(345547, 145, '2015-02-01 00:31:12.000000', 'temperatura', 754.0000, 'ºC'),
	(345548, 145, '2015-02-01 00:31:13.000000', 'temperatura', 860.0000, 'ºC'),
	(345549, 145, '2015-02-01 00:31:14.000000', 'temperatura', 840.0000, 'ºC'),
	(345550, 145, '2015-02-01 00:31:15.000000', 'temperatura', 418.0000, 'ºC'),
	(345551, 145, '2015-02-01 00:31:16.000000', 'temperatura', 771.0000, 'ºC'),
	(345552, 145, '2015-02-01 00:31:17.000000', 'temperatura', 203.0000, 'ºC'),
	(345553, 145, '2015-02-01 00:31:18.000000', 'temperatura', 1104.0000, 'ºC'),
	(345554, 145, '2015-02-01 00:31:19.000000', 'temperatura', 108.0000, 'ºC'),
	(345555, 145, '2015-02-01 00:31:20.000000', 'temperatura', 830.0000, 'ºC'),
	(345556, 145, '2015-02-01 00:31:21.000000', 'temperatura', 228.0000, 'ºC'),
	(345557, 145, '2015-02-01 00:31:22.000000', 'temperatura', 1050.0000, 'ºC'),
	(345558, 145, '2015-02-01 00:31:23.000000', 'temperatura', 965.0000, 'ºC'),
	(345559, 145, '2015-02-01 00:31:24.000000', 'temperatura', 475.0000, 'ºC'),
	(345560, 145, '2015-02-01 00:31:25.000000', 'temperatura', 682.0000, 'ºC'),
	(345561, 145, '2015-02-01 00:31:26.000000', 'temperatura', 783.0000, 'ºC'),
	(345562, 145, '2015-02-01 00:31:27.000000', 'temperatura', 673.0000, 'ºC'),
	(345563, 145, '2015-02-01 00:31:28.000000', 'temperatura', 1014.0000, 'ºC'),
	(345564, 145, '2015-02-01 00:31:29.000000', 'temperatura', 654.0000, 'ºC'),
	(345565, 145, '2015-02-01 00:31:30.000000', 'temperatura', 226.0000, 'ºC'),
	(345566, 145, '2015-02-01 00:31:31.000000', 'temperatura', 369.0000, 'ºC'),
	(345567, 145, '2015-02-01 00:31:32.000000', 'temperatura', 1167.0000, 'ºC'),
	(345568, 145, '2015-02-01 00:31:33.000000', 'temperatura', 1130.0000, 'ºC'),
	(345569, 145, '2015-02-01 00:31:34.000000', 'temperatura', 950.0000, 'ºC'),
	(345570, 145, '2015-02-01 00:31:35.000000', 'temperatura', 161.0000, 'ºC'),
	(345571, 145, '2015-02-01 00:31:36.000000', 'temperatura', 355.0000, 'ºC'),
	(345572, 145, '2015-02-01 00:31:37.000000', 'temperatura', 92.0000, 'ºC'),
	(345573, 145, '2015-02-01 00:31:38.000000', 'temperatura', 596.0000, 'ºC'),
	(345574, 145, '2015-02-01 00:31:39.000000', 'temperatura', 304.0000, 'ºC'),
	(345575, 145, '2015-02-01 00:31:40.000000', 'temperatura', 931.0000, 'ºC'),
	(345576, 145, '2015-02-01 00:31:41.000000', 'temperatura', 143.0000, 'ºC'),
	(345577, 145, '2015-02-01 00:31:42.000000', 'temperatura', 322.0000, 'ºC'),
	(345578, 145, '2015-02-01 00:31:43.000000', 'temperatura', 1184.0000, 'ºC'),
	(345579, 145, '2015-02-01 00:31:44.000000', 'temperatura', 154.0000, 'ºC'),
	(345580, 145, '2015-02-01 00:31:45.000000', 'temperatura', 817.0000, 'ºC'),
	(345581, 145, '2015-02-01 00:31:46.000000', 'temperatura', 23.0000, 'ºC'),
	(345582, 145, '2015-02-01 00:31:47.000000', 'temperatura', 64.0000, 'ºC'),
	(345583, 145, '2015-02-01 00:31:48.000000', 'temperatura', 252.0000, 'ºC'),
	(345584, 145, '2015-02-01 00:31:49.000000', 'temperatura', 1067.0000, 'ºC'),
	(345585, 145, '2015-02-01 00:31:50.000000', 'temperatura', 980.0000, 'ºC'),
	(345586, 145, '2015-02-01 00:31:51.000000', 'temperatura', 501.0000, 'ºC'),
	(345587, 145, '2015-02-01 00:31:52.000000', 'temperatura', 766.0000, 'ºC'),
	(345588, 145, '2015-02-01 00:31:53.000000', 'temperatura', 1126.0000, 'ºC'),
	(345589, 145, '2015-02-01 00:31:54.000000', 'temperatura', 934.0000, 'ºC'),
	(345590, 145, '2015-02-01 00:31:55.000000', 'temperatura', 93.0000, 'ºC'),
	(345591, 145, '2015-02-01 00:31:56.000000', 'temperatura', 64.0000, 'ºC'),
	(345592, 145, '2015-02-01 00:31:57.000000', 'temperatura', 39.0000, 'ºC'),
	(345593, 145, '2015-02-01 00:31:58.000000', 'temperatura', 6.0000, 'ºC'),
	(345594, 145, '2015-02-01 00:31:59.000000', 'temperatura', 1112.0000, 'ºC'),
	(345595, 145, '2015-02-01 00:32:00.000000', 'temperatura', 744.0000, 'ºC'),
	(345596, 145, '2015-02-01 00:32:01.000000', 'temperatura', 382.0000, 'ºC'),
	(345597, 145, '2015-02-01 00:32:02.000000', 'temperatura', 880.0000, 'ºC'),
	(345598, 145, '2015-02-01 00:32:03.000000', 'temperatura', 855.0000, 'ºC'),
	(345599, 145, '2015-02-01 00:32:04.000000', 'temperatura', 437.0000, 'ºC'),
	(345600, 145, '2015-02-01 00:32:05.000000', 'temperatura', 818.0000, 'ºC'),
	(345601, 145, '2015-02-01 00:32:06.000000', 'temperatura', 382.0000, 'ºC'),
	(345602, 145, '2015-02-01 00:32:07.000000', 'temperatura', 656.0000, 'ºC'),
	(345603, 145, '2015-02-01 00:32:08.000000', 'temperatura', 932.0000, 'ºC'),
	(345604, 145, '2015-02-01 00:32:09.000000', 'temperatura', 295.0000, 'ºC'),
	(345605, 145, '2015-02-01 00:32:10.000000', 'temperatura', 1078.0000, 'ºC'),
	(345606, 145, '2015-02-01 00:32:11.000000', 'temperatura', 907.0000, 'ºC'),
	(345607, 145, '2015-02-01 00:32:12.000000', 'temperatura', 102.0000, 'ºC'),
	(345608, 145, '2015-02-01 00:32:13.000000', 'temperatura', 190.0000, 'ºC'),
	(345609, 145, '2015-02-01 00:32:14.000000', 'temperatura', 645.0000, 'ºC'),
	(345610, 145, '2015-02-01 00:32:15.000000', 'temperatura', 252.0000, 'ºC'),
	(345611, 145, '2015-02-01 00:32:16.000000', 'temperatura', 529.0000, 'ºC'),
	(345612, 145, '2015-02-01 00:32:17.000000', 'temperatura', 689.0000, 'ºC'),
	(345613, 145, '2015-02-01 00:32:18.000000', 'temperatura', 658.0000, 'ºC'),
	(345614, 145, '2015-02-01 00:32:19.000000', 'temperatura', 22.0000, 'ºC'),
	(345615, 145, '2015-02-01 00:32:20.000000', 'temperatura', 539.0000, 'ºC'),
	(345616, 145, '2015-02-01 00:32:21.000000', 'temperatura', 230.0000, 'ºC'),
	(345617, 145, '2015-02-01 00:32:22.000000', 'temperatura', 731.0000, 'ºC'),
	(345618, 145, '2015-02-01 00:32:23.000000', 'temperatura', 568.0000, 'ºC'),
	(345619, 145, '2015-02-01 00:32:24.000000', 'temperatura', 645.0000, 'ºC'),
	(345620, 145, '2015-02-01 00:32:25.000000', 'temperatura', 321.0000, 'ºC'),
	(345621, 145, '2015-02-01 00:32:26.000000', 'temperatura', 870.0000, 'ºC'),
	(345622, 145, '2015-02-01 00:32:27.000000', 'temperatura', 989.0000, 'ºC'),
	(345623, 145, '2015-02-01 00:32:28.000000', 'temperatura', 1134.0000, 'ºC'),
	(345624, 145, '2015-02-01 00:32:29.000000', 'temperatura', 306.0000, 'ºC'),
	(345625, 145, '2015-02-01 00:32:30.000000', 'temperatura', 529.0000, 'ºC'),
	(345626, 145, '2015-02-01 00:32:31.000000', 'temperatura', 526.0000, 'ºC'),
	(345627, 145, '2015-02-01 00:32:32.000000', 'temperatura', 1042.0000, 'ºC'),
	(345628, 145, '2015-02-01 00:32:33.000000', 'temperatura', 33.0000, 'ºC'),
	(345629, 145, '2015-02-01 00:32:34.000000', 'temperatura', 639.0000, 'ºC'),
	(345630, 145, '2015-02-01 00:32:35.000000', 'temperatura', 697.0000, 'ºC'),
	(345631, 145, '2015-02-01 00:32:36.000000', 'temperatura', 367.0000, 'ºC'),
	(345632, 145, '2015-02-01 00:32:37.000000', 'temperatura', 947.0000, 'ºC'),
	(345633, 145, '2015-02-01 00:32:38.000000', 'temperatura', 35.0000, 'ºC'),
	(345634, 145, '2015-02-01 00:32:39.000000', 'temperatura', 935.0000, 'ºC'),
	(345635, 145, '2015-02-01 00:32:40.000000', 'temperatura', 968.0000, 'ºC'),
	(345636, 145, '2015-02-01 00:32:41.000000', 'temperatura', 837.0000, 'ºC'),
	(345637, 145, '2015-02-01 00:32:42.000000', 'temperatura', 80.0000, 'ºC'),
	(345638, 145, '2015-02-01 00:32:43.000000', 'temperatura', 288.0000, 'ºC'),
	(345639, 145, '2015-02-01 00:32:44.000000', 'temperatura', 4.0000, 'ºC'),
	(345640, 145, '2015-02-01 00:32:45.000000', 'temperatura', 354.0000, 'ºC'),
	(345641, 145, '2015-02-01 00:32:46.000000', 'temperatura', 559.0000, 'ºC'),
	(345642, 145, '2015-02-01 00:32:47.000000', 'temperatura', 532.0000, 'ºC'),
	(345643, 145, '2015-02-01 00:32:48.000000', 'temperatura', 984.0000, 'ºC'),
	(345644, 145, '2015-02-01 00:32:49.000000', 'temperatura', 927.0000, 'ºC'),
	(345645, 145, '2015-02-01 00:32:50.000000', 'temperatura', 481.0000, 'ºC'),
	(345646, 145, '2015-02-01 00:32:51.000000', 'temperatura', 826.0000, 'ºC'),
	(345647, 145, '2015-02-01 00:32:52.000000', 'temperatura', 286.0000, 'ºC'),
	(345648, 145, '2015-02-01 00:32:53.000000', 'temperatura', 152.0000, 'ºC'),
	(345649, 145, '2015-02-01 00:32:54.000000', 'temperatura', 1103.0000, 'ºC'),
	(345650, 145, '2015-02-01 00:32:55.000000', 'temperatura', 259.0000, 'ºC'),
	(345651, 145, '2015-02-01 00:32:56.000000', 'temperatura', 388.0000, 'ºC'),
	(345652, 145, '2015-02-01 00:32:57.000000', 'temperatura', 1164.0000, 'ºC'),
	(345653, 145, '2015-02-01 00:32:58.000000', 'temperatura', 1055.0000, 'ºC'),
	(345654, 145, '2015-02-01 00:32:59.000000', 'temperatura', 583.0000, 'ºC'),
	(345655, 145, '2015-02-01 00:33:00.000000', 'temperatura', 950.0000, 'ºC'),
	(345656, 145, '2015-02-01 00:33:01.000000', 'temperatura', 604.0000, 'ºC'),
	(345657, 145, '2015-02-01 00:33:02.000000', 'temperatura', 171.0000, 'ºC'),
	(345658, 145, '2015-02-01 00:33:03.000000', 'temperatura', 243.0000, 'ºC'),
	(345659, 145, '2015-02-01 00:33:04.000000', 'temperatura', 703.0000, 'ºC'),
	(345660, 145, '2015-02-01 00:33:05.000000', 'temperatura', 387.0000, 'ºC'),
	(345661, 145, '2015-02-01 00:33:06.000000', 'temperatura', 1025.0000, 'ºC'),
	(345662, 145, '2015-02-01 00:33:07.000000', 'temperatura', 363.0000, 'ºC'),
	(345663, 145, '2015-02-01 00:33:08.000000', 'temperatura', 1143.0000, 'ºC'),
	(345664, 145, '2015-02-01 00:33:09.000000', 'temperatura', 1027.0000, 'ºC'),
	(345665, 145, '2015-02-01 00:33:10.000000', 'temperatura', 505.0000, 'ºC'),
	(345666, 145, '2015-02-01 00:33:11.000000', 'temperatura', 647.0000, 'ºC'),
	(345667, 145, '2015-02-01 00:33:12.000000', 'temperatura', 518.0000, 'ºC'),
	(345668, 145, '2015-02-01 00:33:13.000000', 'temperatura', 650.0000, 'ºC'),
	(345669, 145, '2015-02-01 00:33:14.000000', 'temperatura', 497.0000, 'ºC'),
	(345670, 145, '2015-02-01 00:33:15.000000', 'temperatura', 534.0000, 'ºC'),
	(345671, 145, '2015-02-01 00:33:16.000000', 'temperatura', 1181.0000, 'ºC'),
	(345672, 145, '2015-02-01 00:33:17.000000', 'temperatura', 701.0000, 'ºC'),
	(345673, 145, '2015-02-01 00:33:18.000000', 'temperatura', 1166.0000, 'ºC'),
	(345674, 145, '2015-02-01 00:33:19.000000', 'temperatura', 125.0000, 'ºC'),
	(345675, 145, '2015-02-01 00:33:20.000000', 'temperatura', 729.0000, 'ºC'),
	(345676, 145, '2015-02-01 00:33:21.000000', 'temperatura', 870.0000, 'ºC'),
	(345677, 145, '2015-02-01 00:33:22.000000', 'temperatura', 962.0000, 'ºC'),
	(345678, 145, '2015-02-01 00:33:23.000000', 'temperatura', 1003.0000, 'ºC'),
	(345679, 145, '2015-02-01 00:33:24.000000', 'temperatura', 927.0000, 'ºC'),
	(345680, 145, '2015-02-01 00:33:25.000000', 'temperatura', 427.0000, 'ºC'),
	(345681, 145, '2015-02-01 00:33:26.000000', 'temperatura', 556.0000, 'ºC'),
	(345682, 145, '2015-02-01 00:33:27.000000', 'temperatura', 298.0000, 'ºC'),
	(345683, 145, '2015-02-01 00:33:28.000000', 'temperatura', 1024.0000, 'ºC'),
	(345684, 145, '2015-02-01 00:33:29.000000', 'temperatura', 626.0000, 'ºC'),
	(345685, 145, '2015-02-01 00:33:30.000000', 'temperatura', 58.0000, 'ºC'),
	(345686, 145, '2015-02-01 00:33:31.000000', 'temperatura', 813.0000, 'ºC'),
	(345687, 145, '2015-02-01 00:33:32.000000', 'temperatura', 290.0000, 'ºC'),
	(345688, 145, '2015-02-01 00:33:33.000000', 'temperatura', 212.0000, 'ºC'),
	(345689, 145, '2015-02-01 00:33:34.000000', 'temperatura', 192.0000, 'ºC'),
	(345690, 145, '2015-02-01 00:33:35.000000', 'temperatura', 323.0000, 'ºC'),
	(345691, 145, '2015-02-01 00:33:36.000000', 'temperatura', 1039.0000, 'ºC'),
	(345692, 145, '2015-02-01 00:33:37.000000', 'temperatura', 628.0000, 'ºC'),
	(345693, 145, '2015-02-01 00:33:38.000000', 'temperatura', 24.0000, 'ºC'),
	(345694, 145, '2015-02-01 00:33:39.000000', 'temperatura', 636.0000, 'ºC'),
	(345695, 145, '2015-02-01 00:33:40.000000', 'temperatura', 707.0000, 'ºC'),
	(345696, 145, '2015-02-01 00:33:41.000000', 'temperatura', 429.0000, 'ºC'),
	(345697, 145, '2015-02-01 00:33:42.000000', 'temperatura', 22.0000, 'ºC'),
	(345698, 145, '2015-02-01 00:33:43.000000', 'temperatura', 25.0000, 'ºC'),
	(345699, 145, '2015-02-01 00:33:44.000000', 'temperatura', 61.0000, 'ºC'),
	(345700, 145, '2015-02-01 00:33:45.000000', 'temperatura', 228.0000, 'ºC'),
	(345701, 145, '2015-02-01 00:33:46.000000', 'temperatura', 957.0000, 'ºC'),
	(345702, 145, '2015-02-01 00:33:47.000000', 'temperatura', 504.0000, 'ºC'),
	(345703, 145, '2015-02-01 00:33:48.000000', 'temperatura', 848.0000, 'ºC'),
	(345704, 145, '2015-02-01 00:33:49.000000', 'temperatura', 327.0000, 'ºC'),
	(345705, 145, '2015-02-01 00:33:50.000000', 'temperatura', 292.0000, 'ºC'),
	(345706, 145, '2015-02-01 00:33:51.000000', 'temperatura', 482.0000, 'ºC'),
	(345707, 145, '2015-02-01 00:33:52.000000', 'temperatura', 332.0000, 'ºC'),
	(345708, 145, '2015-02-01 00:33:53.000000', 'temperatura', 214.0000, 'ºC'),
	(345709, 145, '2015-02-01 00:33:54.000000', 'temperatura', 74.0000, 'ºC'),
	(345710, 145, '2015-02-01 00:33:55.000000', 'temperatura', 931.0000, 'ºC'),
	(345711, 145, '2015-02-01 00:33:56.000000', 'temperatura', 834.0000, 'ºC'),
	(345712, 145, '2015-02-01 00:33:57.000000', 'temperatura', 177.0000, 'ºC'),
	(345713, 145, '2015-02-01 00:33:58.000000', 'temperatura', 784.0000, 'ºC'),
	(345714, 145, '2015-02-01 00:33:59.000000', 'temperatura', 991.0000, 'ºC'),
	(345715, 145, '2015-02-01 00:34:00.000000', 'temperatura', 201.0000, 'ºC'),
	(345716, 145, '2015-02-01 00:34:01.000000', 'temperatura', 434.0000, 'ºC'),
	(345717, 145, '2015-02-01 00:34:02.000000', 'temperatura', 366.0000, 'ºC'),
	(345718, 145, '2015-02-01 00:34:03.000000', 'temperatura', 530.0000, 'ºC'),
	(345719, 145, '2015-02-01 00:34:04.000000', 'temperatura', 351.0000, 'ºC'),
	(345720, 145, '2015-02-01 00:34:05.000000', 'temperatura', 168.0000, 'ºC'),
	(345721, 145, '2015-02-01 00:34:06.000000', 'temperatura', 986.0000, 'ºC'),
	(345722, 145, '2015-02-01 00:34:07.000000', 'temperatura', 826.0000, 'ºC'),
	(345723, 145, '2015-02-01 00:34:08.000000', 'temperatura', 1174.0000, 'ºC'),
	(345724, 145, '2015-02-01 00:34:09.000000', 'temperatura', 991.0000, 'ºC'),
	(345725, 145, '2015-02-01 00:34:10.000000', 'temperatura', 233.0000, 'ºC'),
	(345726, 145, '2015-02-01 00:34:11.000000', 'temperatura', 594.0000, 'ºC'),
	(345727, 145, '2015-02-01 00:34:12.000000', 'temperatura', 1069.0000, 'ºC'),
	(345728, 145, '2015-02-01 00:34:13.000000', 'temperatura', 1164.0000, 'ºC'),
	(345729, 145, '2015-02-01 00:34:14.000000', 'temperatura', 216.0000, 'ºC'),
	(345730, 145, '2015-02-01 00:34:15.000000', 'temperatura', 1187.0000, 'ºC'),
	(345731, 145, '2015-02-01 00:34:16.000000', 'temperatura', 488.0000, 'ºC'),
	(345732, 145, '2015-02-01 00:34:17.000000', 'temperatura', 81.0000, 'ºC'),
	(345733, 145, '2015-02-01 00:34:18.000000', 'temperatura', 140.0000, 'ºC'),
	(345734, 145, '2015-02-01 00:34:19.000000', 'temperatura', 456.0000, 'ºC'),
	(345735, 145, '2015-02-01 00:34:20.000000', 'temperatura', 663.0000, 'ºC'),
	(345736, 145, '2015-02-01 00:34:21.000000', 'temperatura', 746.0000, 'ºC'),
	(345737, 145, '2015-02-01 00:34:22.000000', 'temperatura', 542.0000, 'ºC'),
	(345738, 145, '2015-02-01 00:34:23.000000', 'temperatura', 473.0000, 'ºC'),
	(345739, 145, '2015-02-01 00:34:24.000000', 'temperatura', 739.0000, 'ºC'),
	(345740, 145, '2015-02-01 00:34:25.000000', 'temperatura', 1074.0000, 'ºC'),
	(345741, 145, '2015-02-01 00:34:26.000000', 'temperatura', 757.0000, 'ºC'),
	(345742, 145, '2015-02-01 00:34:27.000000', 'temperatura', 563.0000, 'ºC'),
	(345743, 145, '2015-02-01 00:34:28.000000', 'temperatura', 545.0000, 'ºC'),
	(345744, 145, '2015-02-01 00:34:29.000000', 'temperatura', 1035.0000, 'ºC'),
	(345745, 145, '2015-02-01 00:34:30.000000', 'temperatura', 1141.0000, 'ºC'),
	(345746, 145, '2015-02-01 00:34:31.000000', 'temperatura', 202.0000, 'ºC'),
	(345747, 145, '2015-02-01 00:34:32.000000', 'temperatura', 1187.0000, 'ºC'),
	(345748, 145, '2015-02-01 00:34:33.000000', 'temperatura', 529.0000, 'ºC'),
	(345749, 145, '2015-02-01 00:34:34.000000', 'temperatura', 285.0000, 'ºC'),
	(345750, 145, '2015-02-01 00:34:35.000000', 'temperatura', 1037.0000, 'ºC'),
	(345751, 145, '2015-02-01 00:34:36.000000', 'temperatura', 732.0000, 'ºC'),
	(345752, 145, '2015-02-01 00:34:37.000000', 'temperatura', 547.0000, 'ºC'),
	(345753, 145, '2015-02-01 00:34:38.000000', 'temperatura', 541.0000, 'ºC'),
	(345754, 145, '2015-02-01 00:34:39.000000', 'temperatura', 1063.0000, 'ºC'),
	(345755, 145, '2015-02-01 00:34:40.000000', 'temperatura', 93.0000, 'ºC'),
	(345756, 145, '2015-02-01 00:34:41.000000', 'temperatura', 879.0000, 'ºC'),
	(345757, 145, '2015-02-01 00:34:42.000000', 'temperatura', 513.0000, 'ºC'),
	(345758, 145, '2015-02-01 00:34:43.000000', 'temperatura', 1131.0000, 'ºC'),
	(345759, 145, '2015-02-01 00:34:44.000000', 'temperatura', 514.0000, 'ºC'),
	(345760, 145, '2015-02-01 00:34:45.000000', 'temperatura', 377.0000, 'ºC'),
	(345761, 145, '2015-02-01 00:34:46.000000', 'temperatura', 344.0000, 'ºC'),
	(345762, 145, '2015-02-01 00:34:47.000000', 'temperatura', 592.0000, 'ºC'),
	(345763, 145, '2015-02-01 00:34:48.000000', 'temperatura', 725.0000, 'ºC'),
	(345764, 145, '2015-02-01 00:34:49.000000', 'temperatura', 652.0000, 'ºC'),
	(345765, 145, '2015-02-01 00:34:50.000000', 'temperatura', 1084.0000, 'ºC'),
	(345766, 145, '2015-02-01 00:34:51.000000', 'temperatura', 1067.0000, 'ºC'),
	(345767, 145, '2015-02-01 00:34:52.000000', 'temperatura', 883.0000, 'ºC'),
	(345768, 145, '2015-02-01 00:34:53.000000', 'temperatura', 13.0000, 'ºC'),
	(345769, 145, '2015-02-01 00:34:54.000000', 'temperatura', 1016.0000, 'ºC'),
	(345770, 145, '2015-02-01 00:34:55.000000', 'temperatura', 240.0000, 'ºC'),
	(345771, 145, '2015-02-01 00:34:56.000000', 'temperatura', 555.0000, 'ºC'),
	(345772, 145, '2015-02-01 00:34:57.000000', 'temperatura', 855.0000, 'ºC'),
	(345773, 145, '2015-02-01 00:34:58.000000', 'temperatura', 209.0000, 'ºC'),
	(345774, 145, '2015-02-01 00:34:59.000000', 'temperatura', 882.0000, 'ºC'),
	(345775, 145, '2015-02-01 00:35:00.000000', 'temperatura', 182.0000, 'ºC'),
	(345776, 145, '2015-02-01 00:35:01.000000', 'temperatura', 664.0000, 'ºC'),
	(345777, 145, '2015-02-01 00:35:02.000000', 'temperatura', 377.0000, 'ºC'),
	(345778, 145, '2015-02-01 00:35:03.000000', 'temperatura', 1094.0000, 'ºC'),
	(345779, 145, '2015-02-01 00:35:04.000000', 'temperatura', 736.0000, 'ºC'),
	(345780, 145, '2015-02-01 00:35:05.000000', 'temperatura', 401.0000, 'ºC'),
	(345781, 145, '2015-02-01 00:35:06.000000', 'temperatura', 998.0000, 'ºC'),
	(345782, 145, '2015-02-01 00:35:07.000000', 'temperatura', 188.0000, 'ºC'),
	(345783, 145, '2015-02-01 00:35:08.000000', 'temperatura', 345.0000, 'ºC'),
	(345784, 145, '2015-02-01 00:35:09.000000', 'temperatura', 1163.0000, 'ºC'),
	(345785, 145, '2015-02-01 00:35:10.000000', 'temperatura', 1179.0000, 'ºC'),
	(345786, 145, '2015-02-01 00:35:11.000000', 'temperatura', 9.0000, 'ºC'),
	(345787, 145, '2015-02-01 00:35:12.000000', 'temperatura', 107.0000, 'ºC'),
	(345788, 145, '2015-02-01 00:35:13.000000', 'temperatura', 509.0000, 'ºC'),
	(345789, 145, '2015-02-01 00:35:14.000000', 'temperatura', 1026.0000, 'ºC'),
	(345790, 145, '2015-02-01 00:35:15.000000', 'temperatura', 3.0000, 'ºC'),
	(345791, 145, '2015-02-01 00:35:16.000000', 'temperatura', 537.0000, 'ºC'),
	(345792, 145, '2015-02-01 00:35:17.000000', 'temperatura', 274.0000, 'ºC'),
	(345793, 145, '2015-02-01 00:35:18.000000', 'temperatura', 963.0000, 'ºC'),
	(345794, 145, '2015-02-01 00:35:19.000000', 'temperatura', 392.0000, 'ºC'),
	(345795, 145, '2015-02-01 00:35:20.000000', 'temperatura', 270.0000, 'ºC'),
	(345796, 145, '2015-02-01 00:35:21.000000', 'temperatura', 176.0000, 'ºC'),
	(345797, 145, '2015-02-01 00:35:22.000000', 'temperatura', 72.0000, 'ºC'),
	(345798, 145, '2015-02-01 00:35:23.000000', 'temperatura', 1031.0000, 'ºC'),
	(345799, 145, '2015-02-01 00:35:24.000000', 'temperatura', 138.0000, 'ºC'),
	(345800, 145, '2015-02-01 00:35:25.000000', 'temperatura', 1198.0000, 'ºC'),
	(345801, 145, '2015-02-01 00:35:26.000000', 'temperatura', 778.0000, 'ºC'),
	(345802, 145, '2015-02-01 00:35:27.000000', 'temperatura', 296.0000, 'ºC'),
	(345803, 145, '2015-02-01 00:35:28.000000', 'temperatura', 348.0000, 'ºC'),
	(345804, 145, '2015-02-01 00:35:29.000000', 'temperatura', 851.0000, 'ºC'),
	(345805, 145, '2015-02-01 00:35:30.000000', 'temperatura', 810.0000, 'ºC'),
	(345806, 145, '2015-02-01 00:35:31.000000', 'temperatura', 301.0000, 'ºC'),
	(345807, 145, '2015-02-01 00:35:32.000000', 'temperatura', 273.0000, 'ºC'),
	(345808, 145, '2015-02-01 00:35:33.000000', 'temperatura', 464.0000, 'ºC'),
	(345809, 145, '2015-02-01 00:35:34.000000', 'temperatura', 301.0000, 'ºC'),
	(345810, 145, '2015-02-01 00:35:35.000000', 'temperatura', 112.0000, 'ºC'),
	(345811, 145, '2015-02-01 00:35:36.000000', 'temperatura', 860.0000, 'ºC'),
	(345812, 145, '2015-02-01 00:35:37.000000', 'temperatura', 365.0000, 'ºC'),
	(345813, 145, '2015-02-01 00:35:38.000000', 'temperatura', 443.0000, 'ºC'),
	(345814, 145, '2015-02-01 00:35:39.000000', 'temperatura', 1122.0000, 'ºC'),
	(345815, 145, '2015-02-01 00:35:40.000000', 'temperatura', 681.0000, 'ºC'),
	(345816, 145, '2015-02-01 00:35:41.000000', 'temperatura', 40.0000, 'ºC'),
	(345817, 145, '2015-02-01 00:35:42.000000', 'temperatura', 559.0000, 'ºC'),
	(345818, 145, '2015-02-01 00:35:43.000000', 'temperatura', 274.0000, 'ºC'),
	(345819, 145, '2015-02-01 00:35:44.000000', 'temperatura', 894.0000, 'ºC'),
	(345820, 145, '2015-02-01 00:35:45.000000', 'temperatura', 50.0000, 'ºC'),
	(345821, 145, '2015-02-01 00:35:46.000000', 'temperatura', 1166.0000, 'ºC'),
	(345822, 145, '2015-02-01 00:35:47.000000', 'temperatura', 883.0000, 'ºC'),
	(345823, 145, '2015-02-01 00:35:48.000000', 'temperatura', 918.0000, 'ºC'),
	(345824, 145, '2015-02-01 00:35:49.000000', 'temperatura', 740.0000, 'ºC'),
	(345825, 145, '2015-02-01 00:35:50.000000', 'temperatura', 947.0000, 'ºC'),
	(345826, 145, '2015-02-01 00:35:51.000000', 'temperatura', 115.0000, 'ºC'),
	(345827, 145, '2015-02-01 00:35:52.000000', 'temperatura', 134.0000, 'ºC'),
	(345828, 145, '2015-02-01 00:35:53.000000', 'temperatura', 328.0000, 'ºC'),
	(345829, 145, '2015-02-01 00:35:54.000000', 'temperatura', 37.0000, 'ºC'),
	(345830, 145, '2015-02-01 00:35:55.000000', 'temperatura', 404.0000, 'ºC'),
	(345831, 145, '2015-02-01 00:35:56.000000', 'temperatura', 706.0000, 'ºC'),
	(345832, 145, '2015-02-01 00:35:57.000000', 'temperatura', 1122.0000, 'ºC'),
	(345833, 145, '2015-02-01 00:35:58.000000', 'temperatura', 1090.0000, 'ºC'),
	(345834, 145, '2015-02-01 00:35:59.000000', 'temperatura', 884.0000, 'ºC'),
	(345835, 145, '2015-02-01 00:36:00.000000', 'temperatura', 1150.0000, 'ºC'),
	(345836, 145, '2015-02-01 00:36:01.000000', 'temperatura', 698.0000, 'ºC'),
	(345837, 145, '2015-02-01 00:36:02.000000', 'temperatura', 43.0000, 'ºC'),
	(345838, 145, '2015-02-01 00:36:03.000000', 'temperatura', 522.0000, 'ºC'),
	(345839, 145, '2015-02-01 00:36:04.000000', 'temperatura', 81.0000, 'ºC'),
	(345840, 145, '2015-02-01 00:36:05.000000', 'temperatura', 38.0000, 'ºC'),
	(345841, 145, '2015-02-01 00:36:06.000000', 'temperatura', 1149.0000, 'ºC'),
	(345842, 145, '2015-02-01 00:36:07.000000', 'temperatura', 830.0000, 'ºC'),
	(345843, 145, '2015-02-01 00:36:08.000000', 'temperatura', 705.0000, 'ºC'),
	(345844, 145, '2015-02-01 00:36:09.000000', 'temperatura', 1035.0000, 'ºC'),
	(345845, 145, '2015-02-01 00:36:10.000000', 'temperatura', 660.0000, 'ºC'),
	(345846, 145, '2015-02-01 00:36:11.000000', 'temperatura', 197.0000, 'ºC'),
	(345847, 145, '2015-02-01 00:36:12.000000', 'temperatura', 207.0000, 'ºC'),
	(345848, 145, '2015-02-01 00:36:13.000000', 'temperatura', 442.0000, 'ºC'),
	(345849, 145, '2015-02-01 00:36:14.000000', 'temperatura', 390.0000, 'ºC'),
	(345850, 145, '2015-02-01 00:36:15.000000', 'temperatura', 625.0000, 'ºC'),
	(345851, 145, '2015-02-01 00:36:16.000000', 'temperatura', 756.0000, 'ºC'),
	(345852, 145, '2015-02-01 00:36:17.000000', 'temperatura', 704.0000, 'ºC'),
	(345853, 145, '2015-02-01 00:36:18.000000', 'temperatura', 53.0000, 'ºC'),
	(345854, 145, '2015-02-01 00:36:19.000000', 'temperatura', 555.0000, 'ºC'),
	(345855, 145, '2015-02-01 00:36:20.000000', 'temperatura', 216.0000, 'ºC'),
	(345856, 145, '2015-02-01 00:36:21.000000', 'temperatura', 613.0000, 'ºC'),
	(345857, 145, '2015-02-01 00:36:22.000000', 'temperatura', 20.0000, 'ºC'),
	(345858, 145, '2015-02-01 00:36:23.000000', 'temperatura', 662.0000, 'ºC'),
	(345859, 145, '2015-02-01 00:36:24.000000', 'temperatura', 849.0000, 'ºC'),
	(345860, 145, '2015-02-01 00:36:25.000000', 'temperatura', 1059.0000, 'ºC'),
	(345861, 145, '2015-02-01 00:36:26.000000', 'temperatura', 347.0000, 'ºC'),
	(345862, 145, '2015-02-01 00:36:27.000000', 'temperatura', 961.0000, 'ºC'),
	(345863, 145, '2015-02-01 00:36:28.000000', 'temperatura', 165.0000, 'ºC'),
	(345864, 145, '2015-02-01 00:36:29.000000', 'temperatura', 340.0000, 'ºC'),
	(345865, 145, '2015-02-01 00:36:30.000000', 'temperatura', 5.0000, 'ºC'),
	(345866, 145, '2015-02-01 00:36:31.000000', 'temperatura', 209.0000, 'ºC'),
	(345867, 145, '2015-02-01 00:36:32.000000', 'temperatura', 1028.0000, 'ºC'),
	(345868, 145, '2015-02-01 00:36:33.000000', 'temperatura', 912.0000, 'ºC'),
	(345869, 145, '2015-02-01 00:36:34.000000', 'temperatura', 279.0000, 'ºC'),
	(345870, 145, '2015-02-01 00:36:35.000000', 'temperatura', 1057.0000, 'ºC'),
	(345871, 145, '2015-02-01 00:36:36.000000', 'temperatura', 849.0000, 'ºC'),
	(345872, 145, '2015-02-01 00:36:37.000000', 'temperatura', 1075.0000, 'ºC'),
	(345873, 145, '2015-02-01 00:36:38.000000', 'temperatura', 426.0000, 'ºC'),
	(345874, 145, '2015-02-01 00:36:39.000000', 'temperatura', 109.0000, 'ºC'),
	(345875, 145, '2015-02-01 00:36:40.000000', 'temperatura', 468.0000, 'ºC'),
	(345876, 145, '2015-02-01 00:36:41.000000', 'temperatura', 811.0000, 'ºC'),
	(345877, 145, '2015-02-01 00:36:42.000000', 'temperatura', 251.0000, 'ºC'),
	(345878, 145, '2015-02-01 00:36:43.000000', 'temperatura', 24.0000, 'ºC'),
	(345879, 145, '2015-02-01 00:36:44.000000', 'temperatura', 569.0000, 'ºC'),
	(345880, 145, '2015-02-01 00:36:45.000000', 'temperatura', 372.0000, 'ºC'),
	(345881, 145, '2015-02-01 00:36:46.000000', 'temperatura', 155.0000, 'ºC'),
	(345882, 145, '2015-02-01 00:36:47.000000', 'temperatura', 860.0000, 'ºC'),
	(345883, 145, '2015-02-01 00:36:48.000000', 'temperatura', 234.0000, 'ºC'),
	(345884, 145, '2015-02-01 00:36:49.000000', 'temperatura', 991.0000, 'ºC'),
	(345885, 145, '2015-02-01 00:36:50.000000', 'temperatura', 651.0000, 'ºC'),
	(345886, 145, '2015-02-01 00:36:51.000000', 'temperatura', 286.0000, 'ºC'),
	(345887, 145, '2015-02-01 00:36:52.000000', 'temperatura', 674.0000, 'ºC'),
	(345888, 145, '2015-02-01 00:36:53.000000', 'temperatura', 116.0000, 'ºC'),
	(345889, 145, '2015-02-01 00:36:54.000000', 'temperatura', 955.0000, 'ºC'),
	(345890, 145, '2015-02-01 00:36:55.000000', 'temperatura', 830.0000, 'ºC'),
	(345891, 145, '2015-02-01 00:36:56.000000', 'temperatura', 84.0000, 'ºC'),
	(345892, 145, '2015-02-01 00:36:57.000000', 'temperatura', 329.0000, 'ºC'),
	(345893, 145, '2015-02-01 00:36:58.000000', 'temperatura', 195.0000, 'ºC'),
	(345894, 145, '2015-02-01 00:36:59.000000', 'temperatura', 1188.0000, 'ºC'),
	(345895, 145, '2015-02-01 00:37:00.000000', 'temperatura', 554.0000, 'ºC'),
	(345896, 145, '2015-02-01 00:37:01.000000', 'temperatura', 407.0000, 'ºC'),
	(345897, 145, '2015-02-01 00:37:02.000000', 'temperatura', 375.0000, 'ºC'),
	(345898, 145, '2015-02-01 00:37:03.000000', 'temperatura', 652.0000, 'ºC'),
	(345899, 145, '2015-02-01 00:37:04.000000', 'temperatura', 936.0000, 'ºC'),
	(345900, 145, '2015-02-01 00:37:05.000000', 'temperatura', 323.0000, 'ºC'),
	(345901, 145, '2015-02-01 00:37:06.000000', 'temperatura', 9.0000, 'ºC'),
	(345902, 145, '2015-02-01 00:37:07.000000', 'temperatura', 275.0000, 'ºC'),
	(345903, 145, '2015-02-01 00:37:08.000000', 'temperatura', 151.0000, 'ºC'),
	(345904, 145, '2015-02-01 00:37:09.000000', 'temperatura', 1130.0000, 'ºC'),
	(345905, 145, '2015-02-01 00:37:10.000000', 'temperatura', 399.0000, 'ºC'),
	(345906, 145, '2015-02-01 00:37:11.000000', 'temperatura', 1004.0000, 'ºC'),
	(345907, 145, '2015-02-01 00:37:12.000000', 'temperatura', 224.0000, 'ºC'),
	(345908, 145, '2015-02-01 00:37:13.000000', 'temperatura', 510.0000, 'ºC'),
	(345909, 145, '2015-02-01 00:37:14.000000', 'temperatura', 676.0000, 'ºC'),
	(345910, 145, '2015-02-01 00:37:15.000000', 'temperatura', 651.0000, 'ºC'),
	(345911, 145, '2015-02-01 00:37:16.000000', 'temperatura', 27.0000, 'ºC'),
	(345912, 145, '2015-02-01 00:37:17.000000', 'temperatura', 582.0000, 'ºC'),
	(345913, 145, '2015-02-01 00:37:18.000000', 'temperatura', 430.0000, 'ºC'),
	(345914, 145, '2015-02-01 00:37:19.000000', 'temperatura', 406.0000, 'ºC'),
	(345915, 145, '2015-02-01 00:37:20.000000', 'temperatura', 739.0000, 'ºC'),
	(345916, 145, '2015-02-01 00:37:21.000000', 'temperatura', 76.0000, 'ºC'),
	(345917, 145, '2015-02-01 00:37:22.000000', 'temperatura', 565.0000, 'ºC'),
	(345918, 145, '2015-02-01 00:37:23.000000', 'temperatura', 197.0000, 'ºC'),
	(345919, 145, '2015-02-01 00:37:24.000000', 'temperatura', 489.0000, 'ºC'),
	(345920, 145, '2015-02-01 00:37:25.000000', 'temperatura', 655.0000, 'ºC'),
	(345921, 145, '2015-02-01 00:37:26.000000', 'temperatura', 609.0000, 'ºC'),
	(345922, 145, '2015-02-01 00:37:27.000000', 'temperatura', 1080.0000, 'ºC'),
	(345923, 145, '2015-02-01 00:37:28.000000', 'temperatura', 1173.0000, 'ºC'),
	(345924, 145, '2015-02-01 00:37:29.000000', 'temperatura', 227.0000, 'ºC'),
	(345925, 145, '2015-02-01 00:37:30.000000', 'temperatura', 15.0000, 'ºC'),
	(345926, 145, '2015-02-01 00:37:31.000000', 'temperatura', 595.0000, 'ºC'),
	(345927, 145, '2015-02-01 00:37:32.000000', 'temperatura', 529.0000, 'ºC'),
	(345928, 145, '2015-02-01 00:37:33.000000', 'temperatura', 861.0000, 'ºC'),
	(345929, 145, '2015-02-01 00:37:34.000000', 'temperatura', 321.0000, 'ºC'),
	(345930, 145, '2015-02-01 00:37:35.000000', 'temperatura', 221.0000, 'ºC'),
	(345931, 145, '2015-02-01 00:37:36.000000', 'temperatura', 142.0000, 'ºC'),
	(345932, 145, '2015-02-01 00:37:37.000000', 'temperatura', 46.0000, 'ºC'),
	(345933, 145, '2015-02-01 00:37:38.000000', 'temperatura', 1007.0000, 'ºC'),
	(345934, 145, '2015-02-01 00:37:39.000000', 'temperatura', 97.0000, 'ºC'),
	(345935, 145, '2015-02-01 00:37:40.000000', 'temperatura', 1066.0000, 'ºC'),
	(345936, 145, '2015-02-01 00:37:41.000000', 'temperatura', 239.0000, 'ºC'),
	(345937, 145, '2015-02-01 00:37:42.000000', 'temperatura', 397.0000, 'ºC'),
	(345938, 145, '2015-02-01 00:37:43.000000', 'temperatura', 68.0000, 'ºC'),
	(345939, 145, '2015-02-01 00:37:44.000000', 'temperatura', 352.0000, 'ºC'),
	(345940, 145, '2015-02-01 00:37:45.000000', 'temperatura', 353.0000, 'ºC'),
	(345941, 145, '2015-02-01 00:37:46.000000', 'temperatura', 713.0000, 'ºC'),
	(345942, 145, '2015-02-01 00:37:47.000000', 'temperatura', 104.0000, 'ºC'),
	(345943, 145, '2015-02-01 00:37:48.000000', 'temperatura', 781.0000, 'ºC'),
	(345944, 145, '2015-02-01 00:37:49.000000', 'temperatura', 1196.0000, 'ºC'),
	(345945, 145, '2015-02-01 00:37:50.000000', 'temperatura', 37.0000, 'ºC'),
	(345946, 145, '2015-02-01 00:37:51.000000', 'temperatura', 199.0000, 'ºC'),
	(345947, 145, '2015-02-01 00:37:52.000000', 'temperatura', 883.0000, 'ºC'),
	(345948, 145, '2015-02-01 00:37:53.000000', 'temperatura', 217.0000, 'ºC'),
	(345949, 145, '2015-02-01 00:37:54.000000', 'temperatura', 839.0000, 'ºC'),
	(345950, 145, '2015-02-01 00:37:55.000000', 'temperatura', 1145.0000, 'ºC'),
	(345951, 145, '2015-02-01 00:37:56.000000', 'temperatura', 809.0000, 'ºC'),
	(345952, 145, '2015-02-01 00:37:57.000000', 'temperatura', 611.0000, 'ºC'),
	(345953, 145, '2015-02-01 00:37:58.000000', 'temperatura', 628.0000, 'ºC'),
	(345954, 145, '2015-02-01 00:37:59.000000', 'temperatura', 108.0000, 'ºC'),
	(345955, 145, '2015-02-01 00:38:00.000000', 'temperatura', 1057.0000, 'ºC'),
	(345956, 145, '2015-02-01 00:38:01.000000', 'temperatura', 162.0000, 'ºC'),
	(345957, 145, '2015-02-01 00:38:02.000000', 'temperatura', 39.0000, 'ºC'),
	(345958, 145, '2015-02-01 00:38:03.000000', 'temperatura', 909.0000, 'ºC'),
	(345959, 145, '2015-02-01 00:38:04.000000', 'temperatura', 828.0000, 'ºC'),
	(345960, 145, '2015-02-01 00:38:05.000000', 'temperatura', 213.0000, 'ºC'),
	(345961, 145, '2015-02-01 00:38:06.000000', 'temperatura', 983.0000, 'ºC'),
	(345962, 145, '2015-02-01 00:38:07.000000', 'temperatura', 677.0000, 'ºC'),
	(345963, 145, '2015-02-01 00:38:08.000000', 'temperatura', 437.0000, 'ºC'),
	(345964, 145, '2015-02-01 00:38:09.000000', 'temperatura', 155.0000, 'ºC'),
	(345965, 145, '2015-02-01 00:38:10.000000', 'temperatura', 664.0000, 'ºC'),
	(345966, 145, '2015-02-01 00:38:11.000000', 'temperatura', 455.0000, 'ºC'),
	(345967, 145, '2015-02-01 00:38:12.000000', 'temperatura', 284.0000, 'ºC'),
	(345968, 145, '2015-02-01 00:38:13.000000', 'temperatura', 56.0000, 'ºC'),
	(345969, 145, '2015-02-01 00:38:14.000000', 'temperatura', 629.0000, 'ºC'),
	(345970, 145, '2015-02-01 00:38:15.000000', 'temperatura', 578.0000, 'ºC'),
	(345971, 145, '2015-02-01 00:38:16.000000', 'temperatura', 1001.0000, 'ºC'),
	(345972, 145, '2015-02-01 00:38:17.000000', 'temperatura', 871.0000, 'ºC'),
	(345973, 145, '2015-02-01 00:38:18.000000', 'temperatura', 152.0000, 'ºC'),
	(345974, 145, '2015-02-01 00:38:19.000000', 'temperatura', 550.0000, 'ºC'),
	(345975, 145, '2015-02-01 00:38:20.000000', 'temperatura', 1094.0000, 'ºC'),
	(345976, 145, '2015-02-01 00:38:21.000000', 'temperatura', 220.0000, 'ºC'),
	(345977, 145, '2015-02-01 00:38:22.000000', 'temperatura', 219.0000, 'ºC'),
	(345978, 145, '2015-02-01 00:38:23.000000', 'temperatura', 435.0000, 'ºC'),
	(345979, 145, '2015-02-01 00:38:24.000000', 'temperatura', 319.0000, 'ºC'),
	(345980, 145, '2015-02-01 00:38:25.000000', 'temperatura', 291.0000, 'ºC'),
	(345981, 145, '2015-02-01 00:38:26.000000', 'temperatura', 498.0000, 'ºC'),
	(345982, 145, '2015-02-01 00:38:27.000000', 'temperatura', 416.0000, 'ºC'),
	(345983, 145, '2015-02-01 00:38:28.000000', 'temperatura', 590.0000, 'ºC'),
	(345984, 145, '2015-02-01 00:38:29.000000', 'temperatura', 499.0000, 'ºC'),
	(345985, 145, '2015-02-01 00:38:30.000000', 'temperatura', 727.0000, 'ºC'),
	(345986, 145, '2015-02-01 00:38:31.000000', 'temperatura', 939.0000, 'ºC'),
	(345987, 145, '2015-02-01 00:38:32.000000', 'temperatura', 114.0000, 'ºC'),
	(345988, 145, '2015-02-01 00:38:33.000000', 'temperatura', 155.0000, 'ºC'),
	(345989, 145, '2015-02-01 00:38:34.000000', 'temperatura', 431.0000, 'ºC'),
	(345990, 145, '2015-02-01 00:38:35.000000', 'temperatura', 492.0000, 'ºC'),
	(345991, 145, '2015-02-01 00:38:36.000000', 'temperatura', 1167.0000, 'ºC'),
	(345992, 145, '2015-02-01 00:38:37.000000', 'temperatura', 761.0000, 'ºC'),
	(345993, 145, '2015-02-01 00:38:38.000000', 'temperatura', 305.0000, 'ºC'),
	(345994, 145, '2015-02-01 00:38:39.000000', 'temperatura', 440.0000, 'ºC'),
	(345995, 145, '2015-02-01 00:38:40.000000', 'temperatura', 87.0000, 'ºC'),
	(345996, 145, '2015-02-01 00:38:41.000000', 'temperatura', 313.0000, 'ºC'),
	(345997, 145, '2015-02-01 00:38:42.000000', 'temperatura', 107.0000, 'ºC'),
	(345998, 145, '2015-02-01 00:38:43.000000', 'temperatura', 794.0000, 'ºC'),
	(345999, 145, '2015-02-01 00:38:44.000000', 'temperatura', 50.0000, 'ºC'),
	(346000, 145, '2015-02-01 00:38:45.000000', 'temperatura', 269.0000, 'ºC'),
	(346001, 145, '2015-02-01 00:38:46.000000', 'temperatura', 1196.0000, 'ºC'),
	(346002, 145, '2015-02-01 00:38:47.000000', 'temperatura', 373.0000, 'ºC'),
	(346003, 145, '2015-02-01 00:38:48.000000', 'temperatura', 676.0000, 'ºC'),
	(346004, 145, '2015-02-01 00:38:49.000000', 'temperatura', 1064.0000, 'ºC'),
	(346005, 145, '2015-02-01 00:38:50.000000', 'temperatura', 891.0000, 'ºC'),
	(346006, 145, '2015-02-01 00:38:51.000000', 'temperatura', 66.0000, 'ºC'),
	(346007, 145, '2015-02-01 00:38:52.000000', 'temperatura', 55.0000, 'ºC'),
	(346008, 145, '2015-02-01 00:38:53.000000', 'temperatura', 76.0000, 'ºC'),
	(346009, 145, '2015-02-01 00:38:54.000000', 'temperatura', 218.0000, 'ºC'),
	(346010, 145, '2015-02-01 00:38:55.000000', 'temperatura', 863.0000, 'ºC'),
	(346011, 145, '2015-02-01 00:38:56.000000', 'temperatura', 60.0000, 'ºC'),
	(346012, 145, '2015-02-01 00:38:57.000000', 'temperatura', 111.0000, 'ºC'),
	(346013, 145, '2015-02-01 00:38:58.000000', 'temperatura', 376.0000, 'ºC'),
	(346014, 145, '2015-02-01 00:38:59.000000', 'temperatura', 349.0000, 'ºC'),
	(346015, 145, '2015-02-01 00:39:00.000000', 'temperatura', 616.0000, 'ºC'),
	(346016, 145, '2015-02-01 00:39:01.000000', 'temperatura', 835.0000, 'ºC'),
	(346017, 145, '2015-02-01 00:39:02.000000', 'temperatura', 1127.0000, 'ºC'),
	(346018, 145, '2015-02-01 00:39:03.000000', 'temperatura', 731.0000, 'ºC'),
	(346019, 145, '2015-02-01 00:39:04.000000', 'temperatura', 273.0000, 'ºC'),
	(346020, 145, '2015-02-01 00:39:05.000000', 'temperatura', 375.0000, 'ºC'),
	(346021, 145, '2015-02-01 00:39:06.000000', 'temperatura', 1055.0000, 'ºC'),
	(346022, 145, '2015-02-01 00:39:07.000000', 'temperatura', 549.0000, 'ºC'),
	(346023, 145, '2015-02-01 00:39:08.000000', 'temperatura', 780.0000, 'ºC'),
	(346024, 145, '2015-02-01 00:39:09.000000', 'temperatura', 1056.0000, 'ºC'),
	(346025, 145, '2015-02-01 00:39:10.000000', 'temperatura', 541.0000, 'ºC'),
	(346026, 145, '2015-02-01 00:39:11.000000', 'temperatura', 738.0000, 'ºC'),
	(346027, 145, '2015-02-01 00:39:12.000000', 'temperatura', 866.0000, 'ºC'),
	(346028, 145, '2015-02-01 00:39:13.000000', 'temperatura', 917.0000, 'ºC'),
	(346029, 145, '2015-02-01 00:39:14.000000', 'temperatura', 787.0000, 'ºC'),
	(346030, 145, '2015-02-01 00:39:15.000000', 'temperatura', 1186.0000, 'ºC'),
	(346031, 145, '2015-02-01 00:39:16.000000', 'temperatura', 1167.0000, 'ºC'),
	(346032, 145, '2015-02-01 00:39:17.000000', 'temperatura', 1079.0000, 'ºC'),
	(346033, 145, '2015-02-01 00:39:18.000000', 'temperatura', 696.0000, 'ºC'),
	(346034, 145, '2015-02-01 00:39:19.000000', 'temperatura', 243.0000, 'ºC'),
	(346035, 145, '2015-02-01 00:39:20.000000', 'temperatura', 328.0000, 'ºC'),
	(346036, 145, '2015-02-01 00:39:21.000000', 'temperatura', 910.0000, 'ºC'),
	(346037, 145, '2015-02-01 00:39:22.000000', 'temperatura', 1165.0000, 'ºC'),
	(346038, 145, '2015-02-01 00:39:23.000000', 'temperatura', 698.0000, 'ºC'),
	(346039, 145, '2015-02-01 00:39:24.000000', 'temperatura', 1193.0000, 'ºC'),
	(346040, 145, '2015-02-01 00:39:25.000000', 'temperatura', 272.0000, 'ºC'),
	(346041, 145, '2015-02-01 00:39:26.000000', 'temperatura', 180.0000, 'ºC'),
	(346042, 145, '2015-02-01 00:39:27.000000', 'temperatura', 87.0000, 'ºC'),
	(346043, 145, '2015-02-01 00:39:28.000000', 'temperatura', 1096.0000, 'ºC'),
	(346044, 145, '2015-02-01 00:39:29.000000', 'temperatura', 419.0000, 'ºC'),
	(346045, 145, '2015-02-01 00:39:30.000000', 'temperatura', 8.0000, 'ºC'),
	(346046, 145, '2015-02-01 00:39:31.000000', 'temperatura', 1183.0000, 'ºC'),
	(346047, 145, '2015-02-01 00:39:32.000000', 'temperatura', 1089.0000, 'ºC'),
	(346048, 145, '2015-02-01 00:39:33.000000', 'temperatura', 700.0000, 'ºC'),
	(346049, 145, '2015-02-01 00:39:34.000000', 'temperatura', 232.0000, 'ºC'),
	(346050, 145, '2015-02-01 00:39:35.000000', 'temperatura', 259.0000, 'ºC'),
	(346051, 145, '2015-02-01 00:39:36.000000', 'temperatura', 601.0000, 'ºC'),
	(346052, 145, '2015-02-01 00:39:37.000000', 'temperatura', 1029.0000, 'ºC'),
	(346053, 145, '2015-02-01 00:39:38.000000', 'temperatura', 942.0000, 'ºC'),
	(346054, 145, '2015-02-01 00:39:39.000000', 'temperatura', 422.0000, 'ºC'),
	(346055, 145, '2015-02-01 00:39:40.000000', 'temperatura', 485.0000, 'ºC'),
	(346056, 145, '2015-02-01 00:39:41.000000', 'temperatura', 1160.0000, 'ºC'),
	(346057, 145, '2015-02-01 00:39:42.000000', 'temperatura', 746.0000, 'ºC'),
	(346058, 145, '2015-02-01 00:39:43.000000', 'temperatura', 252.0000, 'ºC'),
	(346059, 145, '2015-02-01 00:39:44.000000', 'temperatura', 221.0000, 'ºC'),
	(346060, 145, '2015-02-01 00:39:45.000000', 'temperatura', 348.0000, 'ºC'),
	(346061, 145, '2015-02-01 00:39:46.000000', 'temperatura', 1081.0000, 'ºC'),
	(346062, 145, '2015-02-01 00:39:47.000000', 'temperatura', 758.0000, 'ºC'),
	(346063, 145, '2015-02-01 00:39:48.000000', 'temperatura', 550.0000, 'ºC'),
	(346064, 145, '2015-02-01 00:39:49.000000', 'temperatura', 476.0000, 'ºC'),
	(346065, 145, '2015-02-01 00:39:50.000000', 'temperatura', 732.0000, 'ºC'),
	(346066, 145, '2015-02-01 00:39:51.000000', 'temperatura', 1033.0000, 'ºC'),
	(346067, 145, '2015-02-01 00:39:52.000000', 'temperatura', 568.0000, 'ºC'),
	(346068, 145, '2015-02-01 00:39:53.000000', 'temperatura', 943.0000, 'ºC'),
	(346069, 145, '2015-02-01 00:39:54.000000', 'temperatura', 611.0000, 'ºC'),
	(346070, 145, '2015-02-01 00:39:55.000000', 'temperatura', 227.0000, 'ºC'),
	(346071, 145, '2015-02-01 00:39:56.000000', 'temperatura', 502.0000, 'ºC'),
	(346072, 145, '2015-02-01 00:39:57.000000', 'temperatura', 628.0000, 'ºC'),
	(346073, 145, '2015-02-01 00:39:58.000000', 'temperatura', 437.0000, 'ºC'),
	(346074, 145, '2015-02-01 00:39:59.000000', 'temperatura', 299.0000, 'ºC'),
	(346075, 145, '2015-02-01 00:40:00.000000', 'temperatura', 186.0000, 'ºC'),
	(346076, 145, '2015-02-01 00:40:01.000000', 'temperatura', 31.0000, 'ºC'),
	(346077, 145, '2015-02-01 00:40:02.000000', 'temperatura', 801.0000, 'ºC'),
	(346078, 145, '2015-02-01 00:40:03.000000', 'temperatura', 312.0000, 'ºC'),
	(346079, 145, '2015-02-01 00:40:04.000000', 'temperatura', 356.0000, 'ºC'),
	(346080, 145, '2015-02-01 00:40:05.000000', 'temperatura', 844.0000, 'ºC'),
	(346081, 145, '2015-02-01 00:40:06.000000', 'temperatura', 754.0000, 'ºC'),
	(346082, 145, '2015-02-01 00:40:07.000000', 'temperatura', 36.0000, 'ºC'),
	(346083, 145, '2015-02-01 00:40:08.000000', 'temperatura', 321.0000, 'ºC'),
	(346084, 145, '2015-02-01 00:40:09.000000', 'temperatura', 297.0000, 'ºC'),
	(346085, 145, '2015-02-01 00:40:10.000000', 'temperatura', 523.0000, 'ºC'),
	(346086, 145, '2015-02-01 00:40:11.000000', 'temperatura', 522.0000, 'ºC'),
	(346087, 145, '2015-02-01 00:40:12.000000', 'temperatura', 1043.0000, 'ºC'),
	(346088, 145, '2015-02-01 00:40:13.000000', 'temperatura', 50.0000, 'ºC'),
	(346089, 145, '2015-02-01 00:40:14.000000', 'temperatura', 722.0000, 'ºC'),
	(346090, 145, '2015-02-01 00:40:15.000000', 'temperatura', 1060.0000, 'ºC'),
	(346091, 145, '2015-02-01 00:40:16.000000', 'temperatura', 735.0000, 'ºC'),
	(346092, 145, '2015-02-01 00:40:17.000000', 'temperatura', 496.0000, 'ºC'),
	(346093, 145, '2015-02-01 00:40:18.000000', 'temperatura', 274.0000, 'ºC'),
	(346094, 145, '2015-02-01 00:40:19.000000', 'temperatura', 1084.0000, 'ºC'),
	(346095, 145, '2015-02-01 00:40:20.000000', 'temperatura', 997.0000, 'ºC'),
	(346096, 145, '2015-02-01 00:40:21.000000', 'temperatura', 533.0000, 'ºC'),
	(346097, 145, '2015-02-01 00:40:22.000000', 'temperatura', 874.0000, 'ºC'),
	(346098, 145, '2015-02-01 00:40:23.000000', 'temperatura', 372.0000, 'ºC'),
	(346099, 145, '2015-02-01 00:40:24.000000', 'temperatura', 440.0000, 'ºC'),
	(346100, 145, '2015-02-01 00:40:25.000000', 'temperatura', 1082.0000, 'ºC'),
	(346101, 145, '2015-02-01 00:40:26.000000', 'temperatura', 490.0000, 'ºC'),
	(346102, 145, '2015-02-01 00:40:27.000000', 'temperatura', 406.0000, 'ºC'),
	(346103, 145, '2015-02-01 00:40:28.000000', 'temperatura', 562.0000, 'ºC'),
	(346104, 145, '2015-02-01 00:40:29.000000', 'temperatura', 392.0000, 'ºC'),
	(346105, 145, '2015-02-01 00:40:30.000000', 'temperatura', 274.0000, 'ºC'),
	(346106, 145, '2015-02-01 00:40:31.000000', 'temperatura', 193.0000, 'ºC'),
	(346107, 145, '2015-02-01 00:40:32.000000', 'temperatura', 144.0000, 'ºC'),
	(346108, 145, '2015-02-01 00:40:33.000000', 'temperatura', 144.0000, 'ºC'),
	(346109, 145, '2015-02-01 00:40:34.000000', 'temperatura', 287.0000, 'ºC'),
	(346110, 145, '2015-02-01 00:40:35.000000', 'temperatura', 1002.0000, 'ºC'),
	(346111, 145, '2015-02-01 00:40:36.000000', 'temperatura', 550.0000, 'ºC'),
	(346112, 145, '2015-02-01 00:40:37.000000', 'temperatura', 943.0000, 'ºC'),
	(346113, 145, '2015-02-01 00:40:38.000000', 'temperatura', 667.0000, 'ºC'),
	(346114, 145, '2015-02-01 00:40:39.000000', 'temperatura', 505.0000, 'ºC'),
	(346115, 145, '2015-02-01 00:40:40.000000', 'temperatura', 526.0000, 'ºC'),
	(346116, 145, '2015-02-01 00:40:41.000000', 'temperatura', 1117.0000, 'ºC'),
	(346117, 145, '2015-02-01 00:40:42.000000', 'temperatura', 406.0000, 'ºC'),
	(346118, 145, '2015-02-01 00:40:43.000000', 'temperatura', 1081.0000, 'ºC'),
	(346119, 145, '2015-02-01 00:40:44.000000', 'temperatura', 584.0000, 'ºC'),
	(346120, 145, '2015-02-01 00:40:45.000000', 'temperatura', 881.0000, 'ºC'),
	(346121, 145, '2015-02-01 00:40:46.000000', 'temperatura', 253.0000, 'ºC'),
	(346122, 145, '2015-02-01 00:40:47.000000', 'temperatura', 1021.0000, 'ºC'),
	(346123, 145, '2015-02-01 00:40:48.000000', 'temperatura', 746.0000, 'ºC'),
	(346124, 145, '2015-02-01 00:40:49.000000', 'temperatura', 669.0000, 'ºC'),
	(346125, 145, '2015-02-01 00:40:50.000000', 'temperatura', 1106.0000, 'ºC'),
	(346126, 145, '2015-02-01 00:40:51.000000', 'temperatura', 1123.0000, 'ºC'),
	(346127, 145, '2015-02-01 00:40:52.000000', 'temperatura', 1099.0000, 'ºC'),
	(346128, 145, '2015-02-01 00:40:53.000000', 'temperatura', 927.0000, 'ºC'),
	(346129, 145, '2015-02-01 00:40:54.000000', 'temperatura', 139.0000, 'ºC'),
	(346130, 145, '2015-02-01 00:40:55.000000', 'temperatura', 315.0000, 'ºC'),
	(346131, 145, '2015-02-01 00:40:56.000000', 'temperatura', 1158.0000, 'ºC'),
	(346132, 145, '2015-02-01 00:40:57.000000', 'temperatura', 45.0000, 'ºC'),
	(346133, 145, '2015-02-01 00:40:58.000000', 'temperatura', 352.0000, 'ºC'),
	(346134, 145, '2015-02-01 00:40:59.000000', 'temperatura', 427.0000, 'ºC'),
	(346135, 145, '2015-02-01 00:41:00.000000', 'temperatura', 1078.0000, 'ºC'),
	(346136, 145, '2015-02-01 00:41:01.000000', 'temperatura', 511.0000, 'ºC'),
	(346137, 145, '2015-02-01 00:41:02.000000', 'temperatura', 519.0000, 'ºC'),
	(346138, 145, '2015-02-01 00:41:03.000000', 'temperatura', 1063.0000, 'ºC'),
	(346139, 145, '2015-02-01 00:41:04.000000', 'temperatura', 160.0000, 'ºC'),
	(346140, 145, '2015-02-01 00:41:05.000000', 'temperatura', 12.0000, 'ºC'),
	(346141, 145, '2015-02-01 00:41:06.000000', 'temperatura', 778.0000, 'ºC'),
	(346142, 145, '2015-02-01 00:41:07.000000', 'temperatura', 257.0000, 'ºC'),
	(346143, 145, '2015-02-01 00:41:08.000000', 'temperatura', 149.0000, 'ºC'),
	(346144, 145, '2015-02-01 00:41:09.000000', 'temperatura', 1174.0000, 'ºC'),
	(346145, 145, '2015-02-01 00:41:10.000000', 'temperatura', 623.0000, 'ºC'),
	(346146, 145, '2015-02-01 00:41:11.000000', 'temperatura', 796.0000, 'ºC'),
	(346147, 145, '2015-02-01 00:41:12.000000', 'temperatura', 910.0000, 'ºC'),
	(346148, 145, '2015-02-01 00:41:13.000000', 'temperatura', 963.0000, 'ºC'),
	(346149, 145, '2015-02-01 00:41:14.000000', 'temperatura', 886.0000, 'ºC'),
	(346150, 145, '2015-02-01 00:41:15.000000', 'temperatura', 342.0000, 'ºC'),
	(346151, 145, '2015-02-01 00:41:16.000000', 'temperatura', 252.0000, 'ºC'),
	(346152, 145, '2015-02-01 00:41:17.000000', 'temperatura', 233.0000, 'ºC'),
	(346153, 145, '2015-02-01 00:41:18.000000', 'temperatura', 410.0000, 'ºC'),
	(346154, 145, '2015-02-01 00:41:19.000000', 'temperatura', 154.0000, 'ºC'),
	(346155, 145, '2015-02-01 00:41:20.000000', 'temperatura', 738.0000, 'ºC'),
	(346156, 145, '2015-02-01 00:41:21.000000', 'temperatura', 830.0000, 'ºC'),
	(346157, 145, '2015-02-01 00:41:22.000000', 'temperatura', 735.0000, 'ºC'),
	(346158, 145, '2015-02-01 00:41:23.000000', 'temperatura', 1185.0000, 'ºC'),
	(346159, 145, '2015-02-01 00:41:24.000000', 'temperatura', 120.0000, 'ºC'),
	(346160, 145, '2015-02-01 00:41:25.000000', 'temperatura', 645.0000, 'ºC'),
	(346161, 145, '2015-02-01 00:41:26.000000', 'temperatura', 465.0000, 'ºC'),
	(346162, 145, '2015-02-01 00:41:27.000000', 'temperatura', 391.0000, 'ºC'),
	(346163, 145, '2015-02-01 00:41:28.000000', 'temperatura', 562.0000, 'ºC'),
	(346164, 145, '2015-02-01 00:41:29.000000', 'temperatura', 436.0000, 'ºC'),
	(346165, 145, '2015-02-01 00:41:30.000000', 'temperatura', 497.0000, 'ºC'),
	(346166, 145, '2015-02-01 00:41:31.000000', 'temperatura', 1175.0000, 'ºC'),
	(346167, 145, '2015-02-01 00:41:32.000000', 'temperatura', 784.0000, 'ºC'),
	(346168, 145, '2015-02-01 00:41:33.000000', 'temperatura', 395.0000, 'ºC'),
	(346169, 145, '2015-02-01 00:41:34.000000', 'temperatura', 826.0000, 'ºC'),
	(346170, 145, '2015-02-01 00:41:35.000000', 'temperatura', 544.0000, 'ºC'),
	(346171, 145, '2015-02-01 00:41:36.000000', 'temperatura', 241.0000, 'ºC'),
	(346172, 145, '2015-02-01 00:41:37.000000', 'temperatura', 774.0000, 'ºC'),
	(346173, 145, '2015-02-01 00:41:38.000000', 'temperatura', 749.0000, 'ºC'),
	(346174, 145, '2015-02-01 00:41:39.000000', 'temperatura', 224.0000, 'ºC'),
	(346175, 145, '2015-02-01 00:41:40.000000', 'temperatura', 72.0000, 'ºC'),
	(346176, 145, '2015-02-01 00:41:41.000000', 'temperatura', 890.0000, 'ºC'),
	(346177, 145, '2015-02-01 00:41:42.000000', 'temperatura', 634.0000, 'ºC'),
	(346178, 145, '2015-02-01 00:41:43.000000', 'temperatura', 501.0000, 'ºC'),
	(346179, 145, '2015-02-01 00:41:44.000000', 'temperatura', 603.0000, 'ºC'),
	(346180, 145, '2015-02-01 00:41:45.000000', 'temperatura', 314.0000, 'ºC'),
	(346181, 145, '2015-02-01 00:41:46.000000', 'temperatura', 962.0000, 'ºC'),
	(346182, 145, '2015-02-01 00:41:47.000000', 'temperatura', 267.0000, 'ºC'),
	(346183, 145, '2015-02-01 00:41:48.000000', 'temperatura', 850.0000, 'ºC'),
	(346184, 145, '2015-02-01 00:41:49.000000', 'temperatura', 1048.0000, 'ºC'),
	(346185, 145, '2015-02-01 00:41:50.000000', 'temperatura', 291.0000, 'ºC'),
	(346186, 145, '2015-02-01 00:41:51.000000', 'temperatura', 714.0000, 'ºC'),
	(346187, 145, '2015-02-01 00:41:52.000000', 'temperatura', 294.0000, 'ºC'),
	(346188, 145, '2015-02-01 00:41:53.000000', 'temperatura', 531.0000, 'ºC'),
	(346189, 145, '2015-02-01 00:41:54.000000', 'temperatura', 573.0000, 'ºC'),
	(346190, 145, '2015-02-01 00:41:55.000000', 'temperatura', 73.0000, 'ºC'),
	(346191, 145, '2015-02-01 00:41:56.000000', 'temperatura', 1046.0000, 'ºC'),
	(346192, 145, '2015-02-01 00:41:57.000000', 'temperatura', 211.0000, 'ºC'),
	(346193, 145, '2015-02-01 00:41:58.000000', 'temperatura', 318.0000, 'ºC'),
	(346194, 145, '2015-02-01 00:41:59.000000', 'temperatura', 959.0000, 'ºC'),
	(346195, 145, '2015-02-01 00:42:00.000000', 'temperatura', 240.0000, 'ºC'),
	(346196, 145, '2015-02-01 00:42:01.000000', 'temperatura', 726.0000, 'ºC'),
	(346197, 145, '2015-02-01 00:42:02.000000', 'temperatura', 508.0000, 'ºC'),
	(346198, 145, '2015-02-01 00:42:03.000000', 'temperatura', 362.0000, 'ºC'),
	(346199, 145, '2015-02-01 00:42:04.000000', 'temperatura', 286.0000, 'ºC'),
	(346200, 145, '2015-02-01 00:42:05.000000', 'temperatura', 347.0000, 'ºC'),
	(346201, 145, '2015-02-01 00:42:06.000000', 'temperatura', 875.0000, 'ºC'),
	(346202, 145, '2015-02-01 00:42:07.000000', 'temperatura', 934.0000, 'ºC'),
	(346203, 145, '2015-02-01 00:42:08.000000', 'temperatura', 846.0000, 'ºC'),
	(346204, 145, '2015-02-01 00:42:09.000000', 'temperatura', 230.0000, 'ºC'),
	(346205, 145, '2015-02-01 00:42:10.000000', 'temperatura', 1013.0000, 'ºC'),
	(346206, 145, '2015-02-01 00:42:11.000000', 'temperatura', 776.0000, 'ºC'),
	(346207, 145, '2015-02-01 00:42:12.000000', 'temperatura', 842.0000, 'ºC'),
	(346208, 145, '2015-02-01 00:42:13.000000', 'temperatura', 683.0000, 'ºC'),
	(346209, 145, '2015-02-01 00:42:14.000000', 'temperatura', 889.0000, 'ºC'),
	(346210, 145, '2015-02-01 00:42:15.000000', 'temperatura', 1194.0000, 'ºC'),
	(346211, 145, '2015-02-01 00:42:16.000000', 'temperatura', 907.0000, 'ºC'),
	(346212, 145, '2015-02-01 00:42:17.000000', 'temperatura', 951.0000, 'ºC'),
	(346213, 145, '2015-02-01 00:42:18.000000', 'temperatura', 835.0000, 'ºC'),
	(346214, 145, '2015-02-01 00:42:19.000000', 'temperatura', 123.0000, 'ºC'),
	(346215, 145, '2015-02-01 00:42:20.000000', 'temperatura', 512.0000, 'ºC'),
	(346216, 145, '2015-02-01 00:42:21.000000', 'temperatura', 991.0000, 'ºC'),
	(346217, 145, '2015-02-01 00:42:22.000000', 'temperatura', 1019.0000, 'ºC'),
	(346218, 145, '2015-02-01 00:42:23.000000', 'temperatura', 922.0000, 'ºC'),
	(346219, 145, '2015-02-01 00:42:24.000000', 'temperatura', 353.0000, 'ºC'),
	(346220, 145, '2015-02-01 00:42:25.000000', 'temperatura', 198.0000, 'ºC'),
	(346221, 145, '2015-02-01 00:42:26.000000', 'temperatura', 1133.0000, 'ºC'),
	(346222, 145, '2015-02-01 00:42:27.000000', 'temperatura', 272.0000, 'ºC'),
	(346223, 145, '2015-02-01 00:42:28.000000', 'temperatura', 360.0000, 'ºC'),
	(346224, 145, '2015-02-01 00:42:29.000000', 'temperatura', 985.0000, 'ºC'),
	(346225, 145, '2015-02-01 00:42:30.000000', 'temperatura', 246.0000, 'ºC'),
	(346226, 145, '2015-02-01 00:42:31.000000', 'temperatura', 675.0000, 'ºC'),
	(346227, 145, '2015-02-01 00:42:32.000000', 'temperatura', 236.0000, 'ºC'),
	(346228, 145, '2015-02-01 00:42:33.000000', 'temperatura', 357.0000, 'ºC'),
	(346229, 145, '2015-02-01 00:42:34.000000', 'temperatura', 1078.0000, 'ºC'),
	(346230, 145, '2015-02-01 00:42:35.000000', 'temperatura', 719.0000, 'ºC'),
	(346231, 145, '2015-02-01 00:42:36.000000', 'temperatura', 360.0000, 'ºC'),
	(346232, 145, '2015-02-01 00:42:37.000000', 'temperatura', 843.0000, 'ºC'),
	(346233, 145, '2015-02-01 00:42:38.000000', 'temperatura', 738.0000, 'ºC'),
	(346234, 145, '2015-02-01 00:42:39.000000', 'temperatura', 1162.0000, 'ºC'),
	(346235, 145, '2015-02-01 00:42:40.000000', 'temperatura', 1196.0000, 'ºC'),
	(346236, 145, '2015-02-01 00:42:41.000000', 'temperatura', 95.0000, 'ºC'),
	(346237, 145, '2015-02-01 00:42:42.000000', 'temperatura', 486.0000, 'ºC'),
	(346238, 145, '2015-02-01 00:42:43.000000', 'temperatura', 944.0000, 'ºC'),
	(346239, 145, '2015-02-01 00:42:44.000000', 'temperatura', 865.0000, 'ºC'),
	(346240, 145, '2015-02-01 00:42:45.000000', 'temperatura', 293.0000, 'ºC'),
	(346241, 145, '2015-02-01 00:42:46.000000', 'temperatura', 69.0000, 'ºC'),
	(346242, 145, '2015-02-01 00:42:47.000000', 'temperatura', 665.0000, 'ºC'),
	(346243, 145, '2015-02-01 00:42:48.000000', 'temperatura', 722.0000, 'ºC'),
	(346244, 145, '2015-02-01 00:42:49.000000', 'temperatura', 414.0000, 'ºC'),
	(346245, 145, '2015-02-01 00:42:50.000000', 'temperatura', 1105.0000, 'ºC'),
	(346246, 145, '2015-02-01 00:42:51.000000', 'temperatura', 681.0000, 'ºC'),
	(346247, 145, '2015-02-01 00:42:52.000000', 'temperatura', 94.0000, 'ºC'),
	(346248, 145, '2015-02-01 00:42:53.000000', 'temperatura', 825.0000, 'ºC'),
	(346249, 145, '2015-02-01 00:42:54.000000', 'temperatura', 243.0000, 'ºC'),
	(346250, 145, '2015-02-01 00:42:55.000000', 'temperatura', 1142.0000, 'ºC'),
	(346251, 145, '2015-02-01 00:42:56.000000', 'temperatura', 180.0000, 'ºC'),
	(346252, 145, '2015-02-01 00:42:57.000000', 'temperatura', 1073.0000, 'ºC'),
	(346253, 145, '2015-02-01 00:42:58.000000', 'temperatura', 28.0000, 'ºC'),
	(346254, 145, '2015-02-01 00:42:59.000000', 'temperatura', 519.0000, 'ºC'),
	(346255, 145, '2015-02-01 00:43:00.000000', 'temperatura', 113.0000, 'ºC'),
	(346256, 145, '2015-02-01 00:43:01.000000', 'temperatura', 209.0000, 'ºC'),
	(346257, 145, '2015-02-01 00:43:02.000000', 'temperatura', 705.0000, 'ºC'),
	(346258, 145, '2015-02-01 00:43:03.000000', 'temperatura', 501.0000, 'ºC'),
	(346259, 145, '2015-02-01 00:43:04.000000', 'temperatura', 388.0000, 'ºC'),
	(346260, 145, '2015-02-01 00:43:05.000000', 'temperatura', 438.0000, 'ºC'),
	(346261, 145, '2015-02-01 00:43:06.000000', 'temperatura', 1028.0000, 'ºC'),
	(346262, 145, '2015-02-01 00:43:07.000000', 'temperatura', 226.0000, 'ºC'),
	(346263, 145, '2015-02-01 00:43:08.000000', 'temperatura', 448.0000, 'ºC'),
	(346264, 145, '2015-02-01 00:43:09.000000', 'temperatura', 362.0000, 'ºC'),
	(346265, 145, '2015-02-01 00:43:10.000000', 'temperatura', 465.0000, 'ºC'),
	(346266, 145, '2015-02-01 00:43:11.000000', 'temperatura', 39.0000, 'ºC'),
	(346267, 145, '2015-02-01 00:43:12.000000', 'temperatura', 0.0000, 'ºC'),
	(346268, 145, '2015-02-01 00:43:13.000000', 'temperatura', 1082.0000, 'ºC'),
	(346269, 145, '2015-02-01 00:43:14.000000', 'temperatura', 613.0000, 'ºC'),
	(346270, 145, '2015-02-01 00:43:15.000000', 'temperatura', 1021.0000, 'ºC'),
	(346271, 145, '2015-02-01 00:43:16.000000', 'temperatura', 865.0000, 'ºC'),
	(346272, 145, '2015-02-01 00:43:17.000000', 'temperatura', 64.0000, 'ºC'),
	(346273, 145, '2015-02-01 00:43:18.000000', 'temperatura', 126.0000, 'ºC'),
	(346274, 145, '2015-02-01 00:43:19.000000', 'temperatura', 437.0000, 'ºC'),
	(346275, 145, '2015-02-01 00:43:20.000000', 'temperatura', 606.0000, 'ºC'),
	(346276, 145, '2015-02-01 00:43:21.000000', 'temperatura', 521.0000, 'ºC'),
	(346277, 145, '2015-02-01 00:43:22.000000', 'temperatura', 785.0000, 'ºC'),
	(346278, 145, '2015-02-01 00:43:23.000000', 'temperatura', 1166.0000, 'ºC'),
	(346279, 145, '2015-02-01 00:43:24.000000', 'temperatura', 1073.0000, 'ºC'),
	(346280, 145, '2015-02-01 00:43:25.000000', 'temperatura', 667.0000, 'ºC'),
	(346281, 145, '2015-02-01 00:43:26.000000', 'temperatura', 119.0000, 'ºC'),
	(346282, 145, '2015-02-01 00:43:27.000000', 'temperatura', 993.0000, 'ºC'),
	(346283, 145, '2015-02-01 00:43:28.000000', 'temperatura', 1009.0000, 'ºC'),
	(346284, 145, '2015-02-01 00:43:29.000000', 'temperatura', 865.0000, 'ºC'),
	(346285, 145, '2015-02-01 00:43:30.000000', 'temperatura', 99.0000, 'ºC'),
	(346286, 145, '2015-02-01 00:43:31.000000', 'temperatura', 300.0000, 'ºC'),
	(346287, 145, '2015-02-01 00:43:32.000000', 'temperatura', 4.0000, 'ºC'),
	(346288, 145, '2015-02-01 00:43:33.000000', 'temperatura', 319.0000, 'ºC'),
	(346289, 145, '2015-02-01 00:43:34.000000', 'temperatura', 383.0000, 'ºC'),
	(346290, 145, '2015-02-01 00:43:35.000000', 'temperatura', 959.0000, 'ºC'),
	(346291, 145, '2015-02-01 00:43:36.000000', 'temperatura', 48.0000, 'ºC'),
	(346292, 145, '2015-02-01 00:43:37.000000', 'temperatura', 964.0000, 'ºC'),
	(346293, 145, '2015-02-01 00:43:38.000000', 'temperatura', 1075.0000, 'ºC'),
	(346294, 145, '2015-02-01 00:43:39.000000', 'temperatura', 86.0000, 'ºC'),
	(346295, 145, '2015-02-01 00:43:40.000000', 'temperatura', 804.0000, 'ºC'),
	(346296, 145, '2015-02-01 00:43:41.000000', 'temperatura', 161.0000, 'ºC'),
	(346297, 145, '2015-02-01 00:43:42.000000', 'temperatura', 796.0000, 'ºC'),
	(346298, 145, '2015-02-01 00:43:43.000000', 'temperatura', 1097.0000, 'ºC'),
	(346299, 145, '2015-02-01 00:43:44.000000', 'temperatura', 697.0000, 'ºC'),
	(346300, 145, '2015-02-01 00:43:45.000000', 'temperatura', 195.0000, 'ºC'),
	(346301, 145, '2015-02-01 00:43:46.000000', 'temperatura', 86.0000, 'ºC'),
	(346302, 145, '2015-02-01 00:43:47.000000', 'temperatura', 1043.0000, 'ºC'),
	(346303, 145, '2015-02-01 00:43:48.000000', 'temperatura', 159.0000, 'ºC'),
	(346304, 145, '2015-02-01 00:43:49.000000', 'temperatura', 68.0000, 'ºC'),
	(346305, 145, '2015-02-01 00:43:50.000000', 'temperatura', 1062.0000, 'ºC'),
	(346306, 145, '2015-02-01 00:43:51.000000', 'temperatura', 305.0000, 'ºC'),
	(346307, 145, '2015-02-01 00:43:52.000000', 'temperatura', 740.0000, 'ºC'),
	(346308, 145, '2015-02-01 00:43:53.000000', 'temperatura', 387.0000, 'ºC'),
	(346309, 145, '2015-02-01 00:43:54.000000', 'temperatura', 916.0000, 'ºC'),
	(346310, 145, '2015-02-01 00:43:55.000000', 'temperatura', 1019.0000, 'ºC'),
	(346311, 145, '2015-02-01 00:43:56.000000', 'temperatura', 1148.0000, 'ºC'),
	(346312, 145, '2015-02-01 00:43:57.000000', 'temperatura', 282.0000, 'ºC'),
	(346313, 145, '2015-02-01 00:43:58.000000', 'temperatura', 369.0000, 'ºC'),
	(346314, 145, '2015-02-01 00:43:59.000000', 'temperatura', 999.0000, 'ºC'),
	(346315, 145, '2015-02-01 00:44:00.000000', 'temperatura', 289.0000, 'ºC'),
	(346316, 145, '2015-02-01 00:44:01.000000', 'temperatura', 846.0000, 'ºC'),
	(346317, 145, '2015-02-01 00:44:02.000000', 'temperatura', 966.0000, 'ºC'),
	(346318, 145, '2015-02-01 00:44:03.000000', 'temperatura', 1094.0000, 'ºC'),
	(346319, 145, '2015-02-01 00:44:04.000000', 'temperatura', 169.0000, 'ºC'),
	(346320, 145, '2015-02-01 00:44:05.000000', 'temperatura', 1166.0000, 'ºC'),
	(346321, 145, '2015-02-01 00:44:06.000000', 'temperatura', 523.0000, 'ºC'),
	(346322, 145, '2015-02-01 00:44:07.000000', 'temperatura', 318.0000, 'ºC'),
	(346323, 145, '2015-02-01 00:44:08.000000', 'temperatura', 21.0000, 'ºC'),
	(346324, 145, '2015-02-01 00:44:09.000000', 'temperatura', 353.0000, 'ºC'),
	(346325, 145, '2015-02-01 00:44:10.000000', 'temperatura', 501.0000, 'ºC'),
	(346326, 145, '2015-02-01 00:44:11.000000', 'temperatura', 248.0000, 'ºC'),
	(346327, 145, '2015-02-01 00:44:12.000000', 'temperatura', 937.0000, 'ºC'),
	(346328, 145, '2015-02-01 00:44:13.000000', 'temperatura', 343.0000, 'ºC'),
	(346329, 145, '2015-02-01 00:44:14.000000', 'temperatura', 104.0000, 'ºC'),
	(346330, 145, '2015-02-01 00:44:15.000000', 'temperatura', 692.0000, 'ºC'),
	(346331, 145, '2015-02-01 00:44:16.000000', 'temperatura', 747.0000, 'ºC'),
	(346332, 145, '2015-02-01 00:44:17.000000', 'temperatura', 460.0000, 'ºC'),
	(346333, 145, '2015-02-01 00:44:18.000000', 'temperatura', 59.0000, 'ºC'),
	(346334, 145, '2015-02-01 00:44:19.000000', 'temperatura', 117.0000, 'ºC'),
	(346335, 145, '2015-02-01 00:44:20.000000', 'temperatura', 408.0000, 'ºC'),
	(346336, 145, '2015-02-01 00:44:21.000000', 'temperatura', 491.0000, 'ºC'),
	(346337, 145, '2015-02-01 00:44:22.000000', 'temperatura', 32.0000, 'ºC'),
	(346338, 145, '2015-02-01 00:44:23.000000', 'temperatura', 1086.0000, 'ºC'),
	(346339, 145, '2015-02-01 00:44:24.000000', 'temperatura', 536.0000, 'ºC'),
	(346340, 145, '2015-02-01 00:44:25.000000', 'temperatura', 620.0000, 'ºC'),
	(346341, 145, '2015-02-01 00:44:26.000000', 'temperatura', 292.0000, 'ºC'),
	(346342, 145, '2015-02-01 00:44:27.000000', 'temperatura', 802.0000, 'ºC'),
	(346343, 145, '2015-02-01 00:44:28.000000', 'temperatura', 736.0000, 'ºC'),
	(346344, 145, '2015-02-01 00:44:29.000000', 'temperatura', 74.0000, 'ºC'),
	(346345, 145, '2015-02-01 00:44:30.000000', 'temperatura', 564.0000, 'ºC'),
	(346346, 145, '2015-02-01 00:44:31.000000', 'temperatura', 196.0000, 'ºC'),
	(346347, 145, '2015-02-01 00:44:32.000000', 'temperatura', 488.0000, 'ºC'),
	(346348, 145, '2015-02-01 00:44:33.000000', 'temperatura', 653.0000, 'ºC'),
	(346349, 145, '2015-02-01 00:44:34.000000', 'temperatura', 601.0000, 'ºC'),
	(346350, 145, '2015-02-01 00:44:35.000000', 'temperatura', 1047.0000, 'ºC'),
	(346351, 145, '2015-02-01 00:44:36.000000', 'temperatura', 1032.0000, 'ºC'),
	(346352, 145, '2015-02-01 00:44:37.000000', 'temperatura', 820.0000, 'ºC'),
	(346353, 145, '2015-02-01 00:44:38.000000', 'temperatura', 1004.0000, 'ºC'),
	(346354, 145, '2015-02-01 00:44:39.000000', 'temperatura', 162.0000, 'ºC'),
	(346355, 145, '2015-02-01 00:44:40.000000', 'temperatura', 197.0000, 'ºC'),
	(346356, 145, '2015-02-01 00:44:41.000000', 'temperatura', 499.0000, 'ºC'),
	(346357, 145, '2015-02-01 00:44:42.000000', 'temperatura', 703.0000, 'ºC'),
	(346358, 145, '2015-02-01 00:44:43.000000', 'temperatura', 821.0000, 'ºC'),
	(346359, 145, '2015-02-01 00:44:44.000000', 'temperatura', 794.0000, 'ºC'),
	(346360, 145, '2015-02-01 00:44:45.000000', 'temperatura', 307.0000, 'ºC'),
	(346361, 145, '2015-02-01 00:44:46.000000', 'temperatura', 356.0000, 'ºC'),
	(346362, 145, '2015-02-01 00:44:47.000000', 'temperatura', 860.0000, 'ºC'),
	(346363, 145, '2015-02-01 00:44:48.000000', 'temperatura', 830.0000, 'ºC'),
	(346364, 145, '2015-02-01 00:44:49.000000', 'temperatura', 371.0000, 'ºC'),
	(346365, 145, '2015-02-01 00:44:50.000000', 'temperatura', 564.0000, 'ºC'),
	(346366, 145, '2015-02-01 00:44:51.000000', 'temperatura', 511.0000, 'ºC'),
	(346367, 145, '2015-02-01 00:44:52.000000', 'temperatura', 862.0000, 'ºC'),
	(346368, 145, '2015-02-01 00:44:53.000000', 'temperatura', 375.0000, 'ºC'),
	(346369, 145, '2015-02-01 00:44:54.000000', 'temperatura', 493.0000, 'ºC'),
	(346370, 145, '2015-02-01 00:44:55.000000', 'temperatura', 140.0000, 'ºC'),
	(346371, 145, '2015-02-01 00:44:56.000000', 'temperatura', 422.0000, 'ºC'),
	(346372, 145, '2015-02-01 00:44:57.000000', 'temperatura', 488.0000, 'ºC'),
	(346373, 145, '2015-02-01 00:44:58.000000', 'temperatura', 1175.0000, 'ºC'),
	(346374, 145, '2015-02-01 00:44:59.000000', 'temperatura', 813.0000, 'ºC'),
	(346375, 145, '2015-02-01 00:45:00.000000', 'temperatura', 538.0000, 'ºC'),
	(346376, 145, '2015-02-01 00:45:01.000000', 'temperatura', 252.0000, 'ºC'),
	(346377, 145, '2015-02-01 00:45:02.000000', 'temperatura', 845.0000, 'ºC'),
	(346378, 145, '2015-02-01 00:45:03.000000', 'temperatura', 1073.0000, 'ºC'),
	(346379, 145, '2015-02-01 00:45:04.000000', 'temperatura', 428.0000, 'ºC'),
	(346380, 145, '2015-02-01 00:45:05.000000', 'temperatura', 122.0000, 'ºC'),
	(346381, 145, '2015-02-01 00:45:06.000000', 'temperatura', 527.0000, 'ºC'),
	(346382, 145, '2015-02-01 00:45:07.000000', 'temperatura', 1068.0000, 'ºC'),
	(346383, 145, '2015-02-01 00:45:08.000000', 'temperatura', 161.0000, 'ºC'),
	(346384, 145, '2015-02-01 00:45:09.000000', 'temperatura', 0.0000, 'ºC'),
	(346385, 145, '2015-02-01 00:45:10.000000', 'temperatura', 718.0000, 'ºC'),
	(346386, 145, '2015-02-01 00:45:11.000000', 'temperatura', 1189.0000, 'ºC'),
	(346387, 145, '2015-02-01 00:45:12.000000', 'temperatura', 192.0000, 'ºC'),
	(346388, 145, '2015-02-01 00:45:13.000000', 'temperatura', 994.0000, 'ºC'),
	(346389, 145, '2015-02-01 00:45:14.000000', 'temperatura', 795.0000, 'ºC'),
	(346390, 145, '2015-02-01 00:45:15.000000', 'temperatura', 993.0000, 'ºC'),
	(346391, 145, '2015-02-01 00:45:16.000000', 'temperatura', 183.0000, 'ºC'),
	(346392, 145, '2015-02-01 00:45:17.000000', 'temperatura', 334.0000, 'ºC'),
	(346393, 145, '2015-02-01 00:45:18.000000', 'temperatura', 1120.0000, 'ºC'),
	(346394, 145, '2015-02-01 00:45:19.000000', 'temperatura', 1000.0000, 'ºC'),
	(346395, 145, '2015-02-01 00:45:20.000000', 'temperatura', 440.0000, 'ºC'),
	(346396, 145, '2015-02-01 00:45:21.000000', 'temperatura', 403.0000, 'ºC'),
	(346397, 145, '2015-02-01 00:45:22.000000', 'temperatura', 692.0000, 'ºC'),
	(346398, 145, '2015-02-01 00:45:23.000000', 'temperatura', 1054.0000, 'ºC'),
	(346399, 145, '2015-02-01 00:45:24.000000', 'temperatura', 794.0000, 'ºC'),
	(346400, 145, '2015-02-01 00:45:25.000000', 'temperatura', 808.0000, 'ºC'),
	(346401, 145, '2015-02-01 00:45:26.000000', 'temperatura', 457.0000, 'ºC'),
	(346402, 145, '2015-02-01 00:45:27.000000', 'temperatura', 1062.0000, 'ºC'),
	(346403, 145, '2015-02-01 00:45:28.000000', 'temperatura', 340.0000, 'ºC'),
	(346404, 145, '2015-02-01 00:45:29.000000', 'temperatura', 915.0000, 'ºC'),
	(346405, 145, '2015-02-01 00:45:30.000000', 'temperatura', 1157.0000, 'ºC'),
	(346406, 145, '2015-02-01 00:45:31.000000', 'temperatura', 639.0000, 'ºC'),
	(346407, 145, '2015-02-01 00:45:32.000000', 'temperatura', 923.0000, 'ºC'),
	(346408, 145, '2015-02-01 00:45:33.000000', 'temperatura', 302.0000, 'ºC'),
	(346409, 145, '2015-02-01 00:45:34.000000', 'temperatura', 1138.0000, 'ºC'),
	(346410, 145, '2015-02-01 00:45:35.000000', 'temperatura', 1185.0000, 'ºC'),
	(346411, 145, '2015-02-01 00:45:36.000000', 'temperatura', 110.0000, 'ºC'),
	(346412, 145, '2015-02-01 00:45:37.000000', 'temperatura', 598.0000, 'ºC'),
	(346413, 145, '2015-02-01 00:45:38.000000', 'temperatura', 258.0000, 'ºC'),
	(346414, 145, '2015-02-01 00:45:39.000000', 'temperatura', 697.0000, 'ºC'),
	(346415, 145, '2015-02-01 00:45:40.000000', 'temperatura', 312.0000, 'ºC'),
	(346416, 145, '2015-02-01 00:45:41.000000', 'temperatura', 668.0000, 'ºC'),
	(346417, 145, '2015-02-01 00:45:42.000000', 'temperatura', 6.0000, 'ºC'),
	(346418, 145, '2015-02-01 00:45:43.000000', 'temperatura', 428.0000, 'ºC'),
	(346419, 145, '2015-02-01 00:45:44.000000', 'temperatura', 919.0000, 'ºC'),
	(346420, 145, '2015-02-01 00:45:45.000000', 'temperatura', 915.0000, 'ºC'),
	(346421, 145, '2015-02-01 00:45:46.000000', 'temperatura', 617.0000, 'ºC'),
	(346422, 145, '2015-02-01 00:45:47.000000', 'temperatura', 342.0000, 'ºC'),
	(346423, 145, '2015-02-01 00:45:48.000000', 'temperatura', 1057.0000, 'ºC'),
	(346424, 145, '2015-02-01 00:45:49.000000', 'temperatura', 659.0000, 'ºC'),
	(346425, 145, '2015-02-01 00:45:50.000000', 'temperatura', 128.0000, 'ºC'),
	(346426, 145, '2015-02-01 00:45:51.000000', 'temperatura', 1060.0000, 'ºC'),
	(346427, 145, '2015-02-01 00:45:52.000000', 'temperatura', 119.0000, 'ºC'),
	(346428, 145, '2015-02-01 00:45:53.000000', 'temperatura', 1014.0000, 'ºC'),
	(346429, 145, '2015-02-01 00:45:54.000000', 'temperatura', 1115.0000, 'ºC'),
	(346430, 145, '2015-02-01 00:45:55.000000', 'temperatura', 134.0000, 'ºC'),
	(346431, 145, '2015-02-01 00:45:56.000000', 'temperatura', 925.0000, 'ºC'),
	(346432, 145, '2015-02-01 00:45:57.000000', 'temperatura', 622.0000, 'ºC'),
	(346433, 145, '2015-02-01 00:45:58.000000', 'temperatura', 336.0000, 'ºC'),
	(346434, 145, '2015-02-01 00:45:59.000000', 'temperatura', 1014.0000, 'ºC'),
	(346435, 145, '2015-02-01 00:46:00.000000', 'temperatura', 465.0000, 'ºC'),
	(346436, 145, '2015-02-01 00:46:01.000000', 'temperatura', 482.0000, 'ºC'),
	(346437, 145, '2015-02-01 00:46:02.000000', 'temperatura', 1016.0000, 'ºC'),
	(346438, 145, '2015-02-01 00:46:03.000000', 'temperatura', 35.0000, 'ºC'),
	(346439, 145, '2015-02-01 00:46:04.000000', 'temperatura', 726.0000, 'ºC'),
	(346440, 145, '2015-02-01 00:46:05.000000', 'temperatura', 1125.0000, 'ºC'),
	(346441, 145, '2015-02-01 00:46:06.000000', 'temperatura', 1046.0000, 'ºC'),
	(346442, 145, '2015-02-01 00:46:07.000000', 'temperatura', 659.0000, 'ºC'),
	(346443, 145, '2015-02-01 00:46:08.000000', 'temperatura', 157.0000, 'ºC'),
	(346444, 145, '2015-02-01 00:46:09.000000', 'temperatura', 7.0000, 'ºC'),
	(346445, 145, '2015-02-01 00:46:10.000000', 'temperatura', 765.0000, 'ºC'),
	(346446, 145, '2015-02-01 00:46:11.000000', 'temperatura', 205.0000, 'ºC'),
	(346447, 145, '2015-02-01 00:46:12.000000', 'temperatura', 1132.0000, 'ºC'),
	(346448, 145, '2015-02-01 00:46:13.000000', 'temperatura', 242.0000, 'ºC'),
	(346449, 145, '2015-02-01 00:46:14.000000', 'temperatura', 218.0000, 'ºC'),
	(346450, 145, '2015-02-01 00:46:15.000000', 'temperatura', 363.0000, 'ºC'),
	(346451, 145, '2015-02-01 00:46:16.000000', 'temperatura', 1160.0000, 'ºC'),
	(346452, 145, '2015-02-01 00:46:17.000000', 'temperatura', 1114.0000, 'ºC'),
	(346453, 145, '2015-02-01 00:46:18.000000', 'temperatura', 889.0000, 'ºC'),
	(346454, 145, '2015-02-01 00:46:19.000000', 'temperatura', 1103.0000, 'ºC'),
	(346455, 145, '2015-02-01 00:46:20.000000', 'temperatura', 447.0000, 'ºC'),
	(346456, 145, '2015-02-01 00:46:21.000000', 'temperatura', 130.0000, 'ºC'),
	(346457, 145, '2015-02-01 00:46:22.000000', 'temperatura', 507.0000, 'ºC'),
	(346458, 145, '2015-02-01 00:46:23.000000', 'temperatura', 948.0000, 'ºC'),
	(346459, 145, '2015-02-01 00:46:24.000000', 'temperatura', 818.0000, 'ºC'),
	(346460, 145, '2015-02-01 00:46:25.000000', 'temperatura', 48.0000, 'ºC'),
	(346461, 145, '2015-02-01 00:46:26.000000', 'temperatura', 186.0000, 'ºC'),
	(346462, 145, '2015-02-01 00:46:27.000000', 'temperatura', 786.0000, 'ºC'),
	(346463, 145, '2015-02-01 00:46:28.000000', 'temperatura', 973.0000, 'ºC'),
	(346464, 145, '2015-02-01 00:46:29.000000', 'temperatura', 109.0000, 'ºC'),
	(346465, 145, '2015-02-01 00:46:30.000000', 'temperatura', 26.0000, 'ºC'),
	(346466, 145, '2015-02-01 00:46:31.000000', 'temperatura', 1001.0000, 'ºC'),
	(346467, 145, '2015-02-01 00:46:32.000000', 'temperatura', 128.0000, 'ºC'),
	(346468, 145, '2015-02-01 00:46:33.000000', 'temperatura', 39.0000, 'ºC'),
	(346469, 145, '2015-02-01 00:46:34.000000', 'temperatura', 1012.0000, 'ºC'),
	(346470, 145, '2015-02-01 00:46:35.000000', 'temperatura', 144.0000, 'ºC'),
	(346471, 145, '2015-02-01 00:46:36.000000', 'temperatura', 84.0000, 'ºC'),
	(346472, 145, '2015-02-01 00:46:37.000000', 'temperatura', 1187.0000, 'ºC'),
	(346473, 145, '2015-02-01 00:46:38.000000', 'temperatura', 883.0000, 'ºC'),
	(346474, 145, '2015-02-01 00:46:39.000000', 'temperatura', 856.0000, 'ºC'),
	(346475, 145, '2015-02-01 00:46:40.000000', 'temperatura', 431.0000, 'ºC'),
	(346476, 145, '2015-02-01 00:46:41.000000', 'temperatura', 786.0000, 'ºC'),
	(346477, 145, '2015-02-01 00:46:42.000000', 'temperatura', 238.0000, 'ºC'),
	(346478, 145, '2015-02-01 00:46:43.000000', 'temperatura', 34.0000, 'ºC'),
	(346479, 145, '2015-02-01 00:46:44.000000', 'temperatura', 654.0000, 'ºC'),
	(346480, 145, '2015-02-01 00:46:45.000000', 'temperatura', 769.0000, 'ºC'),
	(346481, 145, '2015-02-01 00:46:46.000000', 'temperatura', 686.0000, 'ºC'),
	(346482, 145, '2015-02-01 00:46:47.000000', 'temperatura', 1122.0000, 'ºC'),
	(346483, 145, '2015-02-01 00:46:48.000000', 'temperatura', 1153.0000, 'ºC'),
	(346484, 145, '2015-02-01 00:46:49.000000', 'temperatura', 1198.0000, 'ºC'),
	(346485, 145, '2015-02-01 00:46:50.000000', 'temperatura', 130.0000, 'ºC'),
	(346486, 145, '2015-02-01 00:46:51.000000', 'temperatura', 660.0000, 'ºC'),
	(346487, 145, '2015-02-01 00:46:52.000000', 'temperatura', 510.0000, 'ºC'),
	(346488, 145, '2015-02-01 00:46:53.000000', 'temperatura', 570.0000, 'ºC'),
	(346489, 145, '2015-02-01 00:46:54.000000', 'temperatura', 119.0000, 'ºC'),
	(346490, 145, '2015-02-01 00:46:55.000000', 'temperatura', 87.0000, 'ºC'),
	(346491, 145, '2015-02-01 00:46:56.000000', 'temperatura', 78.0000, 'ºC'),
	(346492, 145, '2015-02-01 00:46:57.000000', 'temperatura', 129.0000, 'ºC'),
	(346493, 145, '2015-02-01 00:46:58.000000', 'temperatura', 410.0000, 'ºC'),
	(346494, 145, '2015-02-01 00:46:59.000000', 'temperatura', 464.0000, 'ºC'),
	(346495, 145, '2015-02-01 00:47:00.000000', 'temperatura', 1091.0000, 'ºC'),
	(346496, 145, '2015-02-01 00:47:01.000000', 'temperatura', 462.0000, 'ºC'),
	(346497, 145, '2015-02-01 00:47:02.000000', 'temperatura', 238.0000, 'ºC'),
	(346498, 145, '2015-02-01 00:47:03.000000', 'temperatura', 1005.0000, 'ºC'),
	(346499, 145, '2015-02-01 00:47:04.000000', 'temperatura', 711.0000, 'ºC'),
	(346500, 145, '2015-02-01 00:47:05.000000', 'temperatura', 540.0000, 'ºC'),
	(346501, 145, '2015-02-01 00:47:06.000000', 'temperatura', 569.0000, 'ºC'),
	(346502, 145, '2015-02-01 00:47:07.000000', 'temperatura', 26.0000, 'ºC'),
	(346503, 145, '2015-02-01 00:47:08.000000', 'temperatura', 824.0000, 'ºC'),
	(346504, 145, '2015-02-01 00:47:09.000000', 'temperatura', 441.0000, 'ºC'),
	(346505, 145, '2015-02-01 00:47:10.000000', 'temperatura', 932.0000, 'ºC'),
	(346506, 145, '2015-02-01 00:47:11.000000', 'temperatura', 940.0000, 'ºC'),
	(346507, 145, '2015-02-01 00:47:12.000000', 'temperatura', 705.0000, 'ºC'),
	(346508, 145, '2015-02-01 00:47:13.000000', 'temperatura', 707.0000, 'ºC'),
	(346509, 145, '2015-02-01 00:47:14.000000', 'temperatura', 217.0000, 'ºC'),
	(346510, 145, '2015-02-01 00:47:15.000000', 'temperatura', 166.0000, 'ºC'),
	(346511, 145, '2015-02-01 00:47:16.000000', 'temperatura', 180.0000, 'ºC'),
	(346512, 145, '2015-02-01 00:47:17.000000', 'temperatura', 403.0000, 'ºC'),
	(346513, 145, '2015-02-01 00:47:18.000000', 'temperatura', 276.0000, 'ºC'),
	(346514, 145, '2015-02-01 00:47:19.000000', 'temperatura', 172.0000, 'ºC'),
	(346515, 145, '2015-02-01 00:47:20.000000', 'temperatura', 31.0000, 'ºC'),
	(346516, 145, '2015-02-01 00:47:21.000000', 'temperatura', 839.0000, 'ºC'),
	(346517, 145, '2015-02-01 00:47:22.000000', 'temperatura', 504.0000, 'ºC'),
	(346518, 145, '2015-02-01 00:47:23.000000', 'temperatura', 3.0000, 'ºC'),
	(346519, 145, '2015-02-01 00:47:24.000000', 'temperatura', 902.0000, 'ºC'),
	(346520, 145, '2015-02-01 00:47:25.000000', 'temperatura', 902.0000, 'ºC'),
	(346521, 145, '2015-02-01 00:47:26.000000', 'temperatura', 606.0000, 'ºC'),
	(346522, 145, '2015-02-01 00:47:27.000000', 'temperatura', 326.0000, 'ºC'),
	(346523, 145, '2015-02-01 00:47:28.000000', 'temperatura', 1009.0000, 'ºC'),
	(346524, 145, '2015-02-01 00:47:29.000000', 'temperatura', 468.0000, 'ºC'),
	(346525, 145, '2015-02-01 00:47:30.000000', 'temperatura', 514.0000, 'ºC'),
	(346526, 145, '2015-02-01 00:47:31.000000', 'temperatura', 1167.0000, 'ºC'),
	(346527, 145, '2015-02-01 00:47:32.000000', 'temperatura', 694.0000, 'ºC'),
	(346528, 145, '2015-02-01 00:47:33.000000', 'temperatura', 1168.0000, 'ºC'),
	(346529, 145, '2015-02-01 00:47:34.000000', 'temperatura', 160.0000, 'ºC'),
	(346530, 145, '2015-02-01 00:47:35.000000', 'temperatura', 895.0000, 'ºC'),
	(346531, 145, '2015-02-01 00:47:36.000000', 'temperatura', 397.0000, 'ºC'),
	(346532, 145, '2015-02-01 00:47:37.000000', 'temperatura', 501.0000, 'ºC'),
	(346533, 145, '2015-02-01 00:47:38.000000', 'temperatura', 114.0000, 'ºC'),
	(346534, 145, '2015-02-01 00:47:39.000000', 'temperatura', 267.0000, 'ºC'),
	(346535, 145, '2015-02-01 00:47:40.000000', 'temperatura', 993.0000, 'ºC'),
	(346536, 145, '2015-02-01 00:47:41.000000', 'temperatura', 565.0000, 'ºC'),
	(346537, 145, '2015-02-01 00:47:42.000000', 'temperatura', 1047.0000, 'ºC'),
	(346538, 145, '2015-02-01 00:47:43.000000', 'temperatura', 1141.0000, 'ºC'),
	(346539, 145, '2015-02-01 00:47:44.000000', 'temperatura', 163.0000, 'ºC'),
	(346540, 145, '2015-02-01 00:47:45.000000', 'temperatura', 993.0000, 'ºC'),
	(346541, 145, '2015-02-01 00:47:46.000000', 'temperatura', 878.0000, 'ºC'),
	(346542, 145, '2015-02-01 00:47:47.000000', 'temperatura', 210.0000, 'ºC'),
	(346543, 145, '2015-02-01 00:47:48.000000', 'temperatura', 818.0000, 'ºC'),
	(346544, 145, '2015-02-01 00:47:49.000000', 'temperatura', 1058.0000, 'ºC'),
	(346545, 145, '2015-02-01 00:47:50.000000', 'temperatura', 437.0000, 'ºC'),
	(346546, 145, '2015-02-01 00:47:51.000000', 'temperatura', 211.0000, 'ºC'),
	(346547, 145, '2015-02-01 00:47:52.000000', 'temperatura', 947.0000, 'ºC'),
	(346548, 145, '2015-02-01 00:47:53.000000', 'temperatura', 500.0000, 'ºC'),
	(346549, 145, '2015-02-01 00:47:54.000000', 'temperatura', 861.0000, 'ºC'),
	(346550, 145, '2015-02-01 00:47:55.000000', 'temperatura', 405.0000, 'ºC'),
	(346551, 145, '2015-02-01 00:47:56.000000', 'temperatura', 643.0000, 'ºC'),
	(346552, 145, '2015-02-01 00:47:57.000000', 'temperatura', 802.0000, 'ºC'),
	(346553, 145, '2015-02-01 00:47:58.000000', 'temperatura', 881.0000, 'ºC'),
	(346554, 145, '2015-02-01 00:47:59.000000', 'temperatura', 800.0000, 'ºC'),
	(346555, 145, '2015-02-01 00:48:00.000000', 'temperatura', 158.0000, 'ºC'),
	(346556, 145, '2015-02-01 00:48:01.000000', 'temperatura', 789.0000, 'ºC'),
	(346557, 145, '2015-02-01 00:48:02.000000', 'temperatura', 1070.0000, 'ºC'),
	(346558, 145, '2015-02-01 00:48:03.000000', 'temperatura', 586.0000, 'ºC'),
	(346559, 145, '2015-02-01 00:48:04.000000', 'temperatura', 922.0000, 'ºC'),
	(346560, 145, '2015-02-01 00:48:05.000000', 'temperatura', 449.0000, 'ºC'),
	(346561, 145, '2015-02-01 00:48:06.000000', 'temperatura', 683.0000, 'ºC'),
	(346562, 145, '2015-02-01 00:48:07.000000', 'temperatura', 865.0000, 'ºC'),
	(346563, 145, '2015-02-01 00:48:08.000000', 'temperatura', 1080.0000, 'ºC'),
	(346564, 145, '2015-02-01 00:48:09.000000', 'temperatura', 403.0000, 'ºC'),
	(346565, 145, '2015-02-01 00:48:10.000000', 'temperatura', 1175.0000, 'ºC'),
	(346566, 145, '2015-02-01 00:48:11.000000', 'temperatura', 1069.0000, 'ºC'),
	(346567, 145, '2015-02-01 00:48:12.000000', 'temperatura', 621.0000, 'ºC'),
	(346568, 145, '2015-02-01 00:48:13.000000', 'temperatura', 1096.0000, 'ºC'),
	(346569, 145, '2015-02-01 00:48:14.000000', 'temperatura', 18.0000, 'ºC'),
	(346570, 145, '2015-02-01 00:48:15.000000', 'temperatura', 401.0000, 'ºC'),
	(346571, 145, '2015-02-01 00:48:16.000000', 'temperatura', 754.0000, 'ºC'),
	(346572, 145, '2015-02-01 00:48:17.000000', 'temperatura', 168.0000, 'ºC'),
	(346573, 145, '2015-02-01 00:48:18.000000', 'temperatura', 978.0000, 'ºC'),
	(346574, 145, '2015-02-01 00:48:19.000000', 'temperatura', 788.0000, 'ºC'),
	(346575, 145, '2015-02-01 00:48:20.000000', 'temperatura', 1004.0000, 'ºC'),
	(346576, 145, '2015-02-01 00:48:21.000000', 'temperatura', 256.0000, 'ºC'),
	(346577, 145, '2015-02-01 00:48:22.000000', 'temperatura', 670.0000, 'ºC'),
	(346578, 145, '2015-02-01 00:48:23.000000', 'temperatura', 183.0000, 'ºC'),
	(346579, 145, '2015-02-01 00:48:24.000000', 'temperatura', 103.0000, 'ºC'),
	(346580, 145, '2015-02-01 00:48:25.000000', 'temperatura', 1169.0000, 'ºC'),
	(346581, 145, '2015-02-01 00:48:26.000000', 'temperatura', 735.0000, 'ºC'),
	(346582, 145, '2015-02-01 00:48:27.000000', 'temperatura', 170.0000, 'ºC'),
	(346583, 145, '2015-02-01 00:48:28.000000', 'temperatura', 1046.0000, 'ºC'),
	(346584, 145, '2015-02-01 00:48:29.000000', 'temperatura', 1121.0000, 'ºC'),
	(346585, 145, '2015-02-01 00:48:30.000000', 'temperatura', 65.0000, 'ºC'),
	(346586, 145, '2015-02-01 00:48:31.000000', 'temperatura', 562.0000, 'ºC'),
	(346587, 145, '2015-02-01 00:48:32.000000', 'temperatura', 216.0000, 'ºC'),
	(346588, 145, '2015-02-01 00:48:33.000000', 'temperatura', 593.0000, 'ºC'),
	(346589, 145, '2015-02-01 00:48:34.000000', 'temperatura', 1118.0000, 'ºC'),
	(346590, 145, '2015-02-01 00:48:35.000000', 'temperatura', 213.0000, 'ºC'),
	(346591, 145, '2015-02-01 00:48:36.000000', 'temperatura', 113.0000, 'ºC'),
	(346592, 145, '2015-02-01 00:48:37.000000', 'temperatura', 1123.0000, 'ºC'),
	(346593, 145, '2015-02-01 00:48:38.000000', 'temperatura', 478.0000, 'ºC'),
	(346594, 145, '2015-02-01 00:48:39.000000', 'temperatura', 221.0000, 'ºC'),
	(346595, 145, '2015-02-01 00:48:40.000000', 'temperatura', 870.0000, 'ºC'),
	(346596, 145, '2015-02-01 00:48:41.000000', 'temperatura', 89.0000, 'ºC'),
	(346597, 145, '2015-02-01 00:48:42.000000', 'temperatura', 237.0000, 'ºC'),
	(346598, 145, '2015-02-01 00:48:43.000000', 'temperatura', 917.0000, 'ºC'),
	(346599, 145, '2015-02-01 00:48:44.000000', 'temperatura', 274.0000, 'ºC'),
	(346600, 145, '2015-02-01 00:48:45.000000', 'temperatura', 1022.0000, 'ºC'),
	(346601, 145, '2015-02-01 00:48:46.000000', 'temperatura', 686.0000, 'ºC'),
	(346602, 145, '2015-02-01 00:48:47.000000', 'temperatura', 366.0000, 'ºC'),
	(346603, 145, '2015-02-01 00:48:48.000000', 'temperatura', 972.0000, 'ºC'),
	(346604, 145, '2015-02-01 00:48:49.000000', 'temperatura', 164.0000, 'ºC'),
	(346605, 145, '2015-02-01 00:48:50.000000', 'temperatura', 305.0000, 'ºC'),
	(346606, 145, '2015-02-01 00:48:51.000000', 'temperatura', 1032.0000, 'ºC'),
	(346607, 145, '2015-02-01 00:48:52.000000', 'temperatura', 647.0000, 'ºC'),
	(346608, 145, '2015-02-01 00:48:53.000000', 'temperatura', 141.0000, 'ºC'),
	(346609, 145, '2015-02-01 00:48:54.000000', 'temperatura', 1162.0000, 'ºC'),
	(346610, 145, '2015-02-01 00:48:55.000000', 'temperatura', 588.0000, 'ºC'),
	(346611, 145, '2015-02-01 00:48:56.000000', 'temperatura', 654.0000, 'ºC'),
	(346612, 145, '2015-02-01 00:48:57.000000', 'temperatura', 306.0000, 'ºC'),
	(346613, 145, '2015-02-01 00:48:58.000000', 'temperatura', 770.0000, 'ºC'),
	(346614, 145, '2015-02-01 00:48:59.000000', 'temperatura', 530.0000, 'ºC'),
	(346615, 145, '2015-02-01 00:49:00.000000', 'temperatura', 342.0000, 'ºC'),
	(346616, 145, '2015-02-01 00:49:01.000000', 'temperatura', 121.0000, 'ºC'),
	(346617, 145, '2015-02-01 00:49:02.000000', 'temperatura', 780.0000, 'ºC'),
	(346618, 145, '2015-02-01 00:49:03.000000', 'temperatura', 1139.0000, 'ºC'),
	(346619, 145, '2015-02-01 00:49:04.000000', 'temperatura', 954.0000, 'ºC'),
	(346620, 145, '2015-02-01 00:49:05.000000', 'temperatura', 151.0000, 'ºC'),
	(346621, 145, '2015-02-01 00:49:06.000000', 'temperatura', 297.0000, 'ºC'),
	(346622, 145, '2015-02-01 00:49:07.000000', 'temperatura', 1031.0000, 'ºC'),
	(346623, 145, '2015-02-01 00:49:08.000000', 'temperatura', 664.0000, 'ºC'),
	(346624, 145, '2015-02-01 00:49:09.000000', 'temperatura', 230.0000, 'ºC'),
	(346625, 145, '2015-02-01 00:49:10.000000', 'temperatura', 357.0000, 'ºC'),
	(346626, 145, '2015-02-01 00:49:11.000000', 'temperatura', 1096.0000, 'ºC'),
	(346627, 145, '2015-02-01 00:49:12.000000', 'temperatura', 811.0000, 'ºC'),
	(346628, 145, '2015-02-01 00:49:13.000000', 'temperatura', 766.0000, 'ºC'),
	(346629, 145, '2015-02-01 00:49:14.000000', 'temperatura', 196.0000, 'ºC'),
	(346630, 145, '2015-02-01 00:49:15.000000', 'temperatura', 1084.0000, 'ºC'),
	(346631, 145, '2015-02-01 00:49:16.000000', 'temperatura', 33.0000, 'ºC'),
	(346632, 145, '2015-02-01 00:49:17.000000', 'temperatura', 514.0000, 'ºC'),
	(346633, 145, '2015-02-01 00:49:18.000000', 'temperatura', 69.0000, 'ºC'),
	(346634, 145, '2015-02-01 00:49:19.000000', 'temperatura', 4.0000, 'ºC'),
	(346635, 145, '2015-02-01 00:49:20.000000', 'temperatura', 1013.0000, 'ºC'),
	(346636, 145, '2015-02-01 00:49:21.000000', 'temperatura', 256.0000, 'ºC'),
	(346637, 145, '2015-02-01 00:49:22.000000', 'temperatura', 639.0000, 'ºC'),
	(346638, 145, '2015-02-01 00:49:23.000000', 'temperatura', 29.0000, 'ºC'),
	(346639, 145, '2015-02-01 00:49:24.000000', 'temperatura', 627.0000, 'ºC'),
	(346640, 145, '2015-02-01 00:49:25.000000', 'temperatura', 650.0000, 'ºC'),
	(346641, 145, '2015-02-01 00:49:26.000000', 'temperatura', 168.0000, 'ºC'),
	(346642, 145, '2015-02-01 00:49:27.000000', 'temperatura', 92.0000, 'ºC'),
	(346643, 145, '2015-02-01 00:49:28.000000', 'temperatura', 1155.0000, 'ºC'),
	(346644, 145, '2015-02-01 00:49:29.000000', 'temperatura', 698.0000, 'ºC'),
	(346645, 145, '2015-02-01 00:49:30.000000', 'temperatura', 29.0000, 'ºC'),
	(346646, 145, '2015-02-01 00:49:31.000000', 'temperatura', 448.0000, 'ºC'),
	(346647, 145, '2015-02-01 00:49:32.000000', 'temperatura', 957.0000, 'ºC'),
	(346648, 145, '2015-02-01 00:49:33.000000', 'temperatura', 1038.0000, 'ºC'),
	(346649, 145, '2015-02-01 00:49:34.000000', 'temperatura', 1121.0000, 'ºC'),
	(346650, 145, '2015-02-01 00:49:35.000000', 'temperatura', 94.0000, 'ºC'),
	(346651, 145, '2015-02-01 00:49:36.000000', 'temperatura', 704.0000, 'ºC'),
	(346652, 145, '2015-02-01 00:49:37.000000', 'temperatura', 839.0000, 'ºC'),
	(346653, 145, '2015-02-01 00:49:38.000000', 'temperatura', 885.0000, 'ºC'),
	(346654, 145, '2015-02-01 00:49:39.000000', 'temperatura', 708.0000, 'ºC'),
	(346655, 145, '2015-02-01 00:49:40.000000', 'temperatura', 885.0000, 'ºC'),
	(346656, 145, '2015-02-01 00:49:41.000000', 'temperatura', 1102.0000, 'ºC'),
	(346657, 145, '2015-02-01 00:49:42.000000', 'temperatura', 454.0000, 'ºC'),
	(346658, 145, '2015-02-01 00:49:43.000000', 'temperatura', 167.0000, 'ºC'),
	(346659, 145, '2015-02-01 00:49:44.000000', 'temperatura', 672.0000, 'ºC'),
	(346660, 145, '2015-02-01 00:49:45.000000', 'temperatura', 459.0000, 'ºC'),
	(346661, 145, '2015-02-01 00:49:46.000000', 'temperatura', 278.0000, 'ºC'),
	(346662, 145, '2015-02-01 00:49:47.000000', 'temperatura', 17.0000, 'ºC'),
	(346663, 145, '2015-02-01 00:49:48.000000', 'temperatura', 448.0000, 'ºC'),
	(346664, 145, '2015-02-01 00:49:49.000000', 'temperatura', 992.0000, 'ºC'),
	(346665, 145, '2015-02-01 00:49:50.000000', 'temperatura', 15.0000, 'ºC'),
	(346666, 145, '2015-02-01 00:49:51.000000', 'temperatura', 698.0000, 'ºC'),
	(346667, 145, '2015-02-01 00:49:52.000000', 'temperatura', 1047.0000, 'ºC'),
	(346668, 145, '2015-02-01 00:49:53.000000', 'temperatura', 742.0000, 'ºC'),
	(346669, 145, '2015-02-01 00:49:54.000000', 'temperatura', 569.0000, 'ºC'),
	(346670, 145, '2015-02-01 00:49:55.000000', 'temperatura', 619.0000, 'ºC'),
	(346671, 145, '2015-02-01 00:49:56.000000', 'temperatura', 190.0000, 'ºC'),
	(346672, 145, '2015-02-01 00:49:57.000000', 'temperatura', 292.0000, 'ºC'),
	(346673, 145, '2015-02-01 00:49:58.000000', 'temperatura', 891.0000, 'ºC'),
	(346674, 145, '2015-02-01 00:49:59.000000', 'temperatura', 1181.0000, 'ºC'),
	(346675, 145, '2015-02-01 00:50:00.000000', 'temperatura', 834.0000, 'ºC'),
	(346676, 145, '2015-02-01 00:50:01.000000', 'temperatura', 624.0000, 'ºC'),
	(346677, 145, '2015-02-01 00:50:02.000000', 'temperatura', 618.0000, 'ºC'),
	(346678, 145, '2015-02-01 00:50:03.000000', 'temperatura', 21.0000, 'ºC'),
	(346679, 145, '2015-02-01 00:50:04.000000', 'temperatura', 649.0000, 'ºC'),
	(346680, 145, '2015-02-01 00:50:05.000000', 'temperatura', 785.0000, 'ºC'),
	(346681, 145, '2015-02-01 00:50:06.000000', 'temperatura', 779.0000, 'ºC'),
	(346682, 145, '2015-02-01 00:50:07.000000', 'temperatura', 339.0000, 'ºC'),
	(346683, 145, '2015-02-01 00:50:08.000000', 'temperatura', 557.0000, 'ºC'),
	(346684, 145, '2015-02-01 00:50:09.000000', 'temperatura', 572.0000, 'ºC'),
	(346685, 145, '2015-02-01 00:50:10.000000', 'temperatura', 1187.0000, 'ºC'),
	(346686, 145, '2015-02-01 00:50:11.000000', 'temperatura', 621.0000, 'ºC'),
	(346687, 145, '2015-02-01 00:50:12.000000', 'temperatura', 745.0000, 'ºC'),
	(346688, 145, '2015-02-01 00:50:13.000000', 'temperatura', 663.0000, 'ºC'),
	(346689, 145, '2015-02-01 00:50:14.000000', 'temperatura', 1078.0000, 'ºC'),
	(346690, 145, '2015-02-01 00:50:15.000000', 'temperatura', 1003.0000, 'ºC'),
	(346691, 145, '2015-02-01 00:50:16.000000', 'temperatura', 582.0000, 'ºC'),
	(346692, 145, '2015-02-01 00:50:17.000000', 'temperatura', 1100.0000, 'ºC'),
	(346693, 145, '2015-02-01 00:50:18.000000', 'temperatura', 157.0000, 'ºC'),
	(346694, 145, '2015-02-01 00:50:19.000000', 'temperatura', 1084.0000, 'ºC'),
	(346695, 145, '2015-02-01 00:50:20.000000', 'temperatura', 149.0000, 'ºC'),
	(346696, 145, '2015-02-01 00:50:21.000000', 'temperatura', 1096.0000, 'ºC'),
	(346697, 145, '2015-02-01 00:50:22.000000', 'temperatura', 231.0000, 'ºC'),
	(346698, 145, '2015-02-01 00:50:23.000000', 'temperatura', 270.0000, 'ºC'),
	(346699, 145, '2015-02-01 00:50:24.000000', 'temperatura', 657.0000, 'ºC'),
	(346700, 145, '2015-02-01 00:50:25.000000', 'temperatura', 77.0000, 'ºC'),
	(346701, 145, '2015-02-01 00:50:26.000000', 'temperatura', 813.0000, 'ºC'),
	(346702, 145, '2015-02-01 00:50:27.000000', 'temperatura', 234.0000, 'ºC'),
	(346703, 145, '2015-02-01 00:50:28.000000', 'temperatura', 1131.0000, 'ºC'),
	(346704, 145, '2015-02-01 00:50:29.000000', 'temperatura', 155.0000, 'ºC'),
	(346705, 145, '2015-02-01 00:50:30.000000', 'temperatura', 983.0000, 'ºC'),
	(346706, 145, '2015-02-01 00:50:31.000000', 'temperatura', 851.0000, 'ºC'),
	(346707, 145, '2015-02-01 00:50:32.000000', 'temperatura', 104.0000, 'ºC'),
	(346708, 145, '2015-02-01 00:50:33.000000', 'temperatura', 367.0000, 'ºC'),
	(346709, 145, '2015-02-01 00:50:34.000000', 'temperatura', 326.0000, 'ºC'),
	(346710, 145, '2015-02-01 00:50:35.000000', 'temperatura', 527.0000, 'ºC'),
	(346711, 145, '2015-02-01 00:50:36.000000', 'temperatura', 460.0000, 'ºC'),
	(346712, 145, '2015-02-01 00:50:37.000000', 'temperatura', 720.0000, 'ºC'),
	(346713, 145, '2015-02-01 00:50:38.000000', 'temperatura', 1018.0000, 'ºC'),
	(346714, 145, '2015-02-01 00:50:39.000000', 'temperatura', 532.0000, 'ºC'),
	(346715, 145, '2015-02-01 00:50:40.000000', 'temperatura', 808.0000, 'ºC'),
	(346716, 145, '2015-02-01 00:50:41.000000', 'temperatura', 42.0000, 'ºC'),
	(346717, 145, '2015-02-01 00:50:42.000000', 'temperatura', 188.0000, 'ºC'),
	(346718, 145, '2015-02-01 00:50:43.000000', 'temperatura', 815.0000, 'ºC'),
	(346719, 145, '2015-02-01 00:50:44.000000', 'temperatura', 1111.0000, 'ºC'),
	(346720, 145, '2015-02-01 00:50:45.000000', 'temperatura', 712.0000, 'ºC'),
	(346721, 145, '2015-02-01 00:50:46.000000', 'temperatura', 226.0000, 'ºC'),
	(346722, 145, '2015-02-01 00:50:47.000000', 'temperatura', 194.0000, 'ºC'),
	(346723, 145, '2015-02-01 00:50:48.000000', 'temperatura', 291.0000, 'ºC'),
	(346724, 145, '2015-02-01 00:50:49.000000', 'temperatura', 877.0000, 'ºC'),
	(346725, 145, '2015-02-01 00:50:50.000000', 'temperatura', 1111.0000, 'ºC'),
	(346726, 145, '2015-02-01 00:50:51.000000', 'temperatura', 524.0000, 'ºC'),
	(346727, 145, '2015-02-01 00:50:52.000000', 'temperatura', 489.0000, 'ºC'),
	(346728, 145, '2015-02-01 00:50:53.000000', 'temperatura', 871.0000, 'ºC'),
	(346729, 145, '2015-02-01 00:50:54.000000', 'temperatura', 491.0000, 'ºC'),
	(346730, 145, '2015-02-01 00:50:55.000000', 'temperatura', 1043.0000, 'ºC'),
	(346731, 145, '2015-02-01 00:50:56.000000', 'temperatura', 142.0000, 'ºC'),
	(346732, 145, '2015-02-01 00:50:57.000000', 'temperatura', 1181.0000, 'ºC'),
	(346733, 145, '2015-02-01 00:50:58.000000', 'temperatura', 679.0000, 'ºC'),
	(346734, 145, '2015-02-01 00:50:59.000000', 'temperatura', 1051.0000, 'ºC'),
	(346735, 145, '2015-02-01 00:51:00.000000', 'temperatura', 820.0000, 'ºC'),
	(346736, 145, '2015-02-01 00:51:01.000000', 'temperatura', 946.0000, 'ºC'),
	(346737, 145, '2015-02-01 00:51:02.000000', 'temperatura', 1073.0000, 'ºC'),
	(346738, 145, '2015-02-01 00:51:03.000000', 'temperatura', 125.0000, 'ºC'),
	(346739, 145, '2015-02-01 00:51:04.000000', 'temperatura', 1009.0000, 'ºC'),
	(346740, 145, '2015-02-01 00:51:05.000000', 'temperatura', 1070.0000, 'ºC'),
	(346741, 145, '2015-02-01 00:51:06.000000', 'temperatura', 1124.0000, 'ºC'),
	(346742, 145, '2015-02-01 00:51:07.000000', 'temperatura', 10.0000, 'ºC'),
	(346743, 145, '2015-02-01 00:51:08.000000', 'temperatura', 280.0000, 'ºC'),
	(346744, 145, '2015-02-01 00:51:09.000000', 'temperatura', 171.0000, 'ºC'),
	(346745, 145, '2015-02-01 00:51:10.000000', 'temperatura', 13.0000, 'ºC'),
	(346746, 145, '2015-02-01 00:51:11.000000', 'temperatura', 753.0000, 'ºC'),
	(346747, 145, '2015-02-01 00:51:12.000000', 'temperatura', 125.0000, 'ºC'),
	(346748, 145, '2015-02-01 00:51:13.000000', 'temperatura', 769.0000, 'ºC'),
	(346749, 145, '2015-02-01 00:51:14.000000', 'temperatura', 1070.0000, 'ºC'),
	(346750, 145, '2015-02-01 00:51:15.000000', 'temperatura', 645.0000, 'ºC'),
	(346751, 145, '2015-02-01 00:51:16.000000', 'temperatura', 15.0000, 'ºC'),
	(346752, 145, '2015-02-01 00:51:17.000000', 'temperatura', 538.0000, 'ºC'),
	(346753, 145, '2015-02-01 00:51:18.000000', 'temperatura', 247.0000, 'ºC'),
	(346754, 145, '2015-02-01 00:51:19.000000', 'temperatura', 822.0000, 'ºC'),
	(346755, 145, '2015-02-01 00:51:20.000000', 'temperatura', 970.0000, 'ºC'),
	(346756, 145, '2015-02-01 00:51:21.000000', 'temperatura', 1185.0000, 'ºC'),
	(346757, 145, '2015-02-01 00:51:22.000000', 'temperatura', 613.0000, 'ºC'),
	(346758, 145, '2015-02-01 00:51:23.000000', 'temperatura', 712.0000, 'ºC'),
	(346759, 145, '2015-02-01 00:51:24.000000', 'temperatura', 520.0000, 'ºC'),
	(346760, 145, '2015-02-01 00:51:25.000000', 'temperatura', 465.0000, 'ºC'),
	(346761, 145, '2015-02-01 00:51:26.000000', 'temperatura', 767.0000, 'ºC'),
	(346762, 145, '2015-02-01 00:51:27.000000', 'temperatura', 38.0000, 'ºC'),
	(346763, 145, '2015-02-01 00:51:28.000000', 'temperatura', 293.0000, 'ºC'),
	(346764, 145, '2015-02-01 00:51:29.000000', 'temperatura', 148.0000, 'ºC'),
	(346765, 145, '2015-02-01 00:51:30.000000', 'temperatura', 1064.0000, 'ºC'),
	(346766, 145, '2015-02-01 00:51:31.000000', 'temperatura', 77.0000, 'ºC'),
	(346767, 145, '2015-02-01 00:51:32.000000', 'temperatura', 794.0000, 'ºC'),
	(346768, 145, '2015-02-01 00:51:33.000000', 'temperatura', 139.0000, 'ºC'),
	(346769, 145, '2015-02-01 00:51:34.000000', 'temperatura', 711.0000, 'ºC'),
	(346770, 145, '2015-02-01 00:51:35.000000', 'temperatura', 740.0000, 'ºC'),
	(346771, 145, '2015-02-01 00:51:36.000000', 'temperatura', 368.0000, 'ºC'),
	(346772, 145, '2015-02-01 00:51:37.000000', 'temperatura', 819.0000, 'ºC'),
	(346773, 145, '2015-02-01 00:51:38.000000', 'temperatura', 591.0000, 'ºC'),
	(346774, 145, '2015-02-01 00:51:39.000000', 'temperatura', 500.0000, 'ºC'),
	(346775, 145, '2015-02-01 00:51:40.000000', 'temperatura', 728.0000, 'ºC'),
	(346776, 145, '2015-02-01 00:51:41.000000', 'temperatura', 938.0000, 'ºC'),
	(346777, 145, '2015-02-01 00:51:42.000000', 'temperatura', 107.0000, 'ºC'),
	(346778, 145, '2015-02-01 00:51:43.000000', 'temperatura', 122.0000, 'ºC'),
	(346779, 145, '2015-02-01 00:51:44.000000', 'temperatura', 290.0000, 'ºC'),
	(346780, 145, '2015-02-01 00:51:45.000000', 'temperatura', 1086.0000, 'ºC'),
	(346781, 145, '2015-02-01 00:51:46.000000', 'temperatura', 957.0000, 'ºC'),
	(346782, 145, '2015-02-01 00:51:47.000000', 'temperatura', 330.0000, 'ºC'),
	(346783, 145, '2015-02-01 00:51:48.000000', 'temperatura', 1177.0000, 'ºC'),
	(346784, 145, '2015-02-01 00:51:49.000000', 'temperatura', 97.0000, 'ºC'),
	(346785, 145, '2015-02-01 00:51:50.000000', 'temperatura', 553.0000, 'ºC'),
	(346786, 145, '2015-02-01 00:51:51.000000', 'temperatura', 74.0000, 'ºC'),
	(346787, 145, '2015-02-01 00:51:52.000000', 'temperatura', 1111.0000, 'ºC'),
	(346788, 145, '2015-02-01 00:51:53.000000', 'temperatura', 534.0000, 'ºC'),
	(346789, 145, '2015-02-01 00:51:54.000000', 'temperatura', 540.0000, 'ºC'),
	(346790, 145, '2015-02-01 00:51:55.000000', 'temperatura', 1097.0000, 'ºC'),
	(346791, 145, '2015-02-01 00:51:56.000000', 'temperatura', 264.0000, 'ºC'),
	(346792, 145, '2015-02-01 00:51:57.000000', 'temperatura', 430.0000, 'ºC'),
	(346793, 145, '2015-02-01 00:51:58.000000', 'temperatura', 158.0000, 'ºC'),
	(346794, 145, '2015-02-01 00:51:59.000000', 'temperatura', 703.0000, 'ºC'),
	(346795, 145, '2015-02-01 00:52:00.000000', 'temperatura', 639.0000, 'ºC'),
	(346796, 145, '2015-02-01 00:52:01.000000', 'temperatura', 1086.0000, 'ºC'),
	(346797, 145, '2015-02-01 00:52:02.000000', 'temperatura', 1115.0000, 'ºC'),
	(346798, 145, '2015-02-01 00:52:03.000000', 'temperatura', 1119.0000, 'ºC'),
	(346799, 145, '2015-02-01 00:52:04.000000', 'temperatura', 1047.0000, 'ºC'),
	(346800, 145, '2015-02-01 00:52:05.000000', 'temperatura', 681.0000, 'ºC'),
	(346801, 145, '2015-02-01 00:52:06.000000', 'temperatura', 265.0000, 'ºC'),
	(346802, 145, '2015-02-01 00:52:07.000000', 'temperatura', 483.0000, 'ºC'),
	(346803, 145, '2015-02-01 00:52:08.000000', 'temperatura', 420.0000, 'ºC'),
	(346804, 145, '2015-02-01 00:52:09.000000', 'temperatura', 653.0000, 'ºC'),
	(346805, 145, '2015-02-01 00:52:10.000000', 'temperatura', 804.0000, 'ºC'),
	(346806, 145, '2015-02-01 00:52:11.000000', 'temperatura', 860.0000, 'ºC'),
	(346807, 145, '2015-02-01 00:52:12.000000', 'temperatura', 690.0000, 'ºC'),
	(346808, 145, '2015-02-01 00:52:13.000000', 'temperatura', 870.0000, 'ºC'),
	(346809, 145, '2015-02-01 00:52:14.000000', 'temperatura', 1081.0000, 'ºC'),
	(346810, 145, '2015-02-01 00:52:15.000000', 'temperatura', 397.0000, 'ºC'),
	(346811, 145, '2015-02-01 00:52:16.000000', 'temperatura', 1143.0000, 'ºC'),
	(346812, 145, '2015-02-01 00:52:17.000000', 'temperatura', 922.0000, 'ºC'),
	(346813, 145, '2015-02-01 00:52:18.000000', 'temperatura', 1182.0000, 'ºC'),
	(346814, 145, '2015-02-01 00:52:19.000000', 'temperatura', 743.0000, 'ºC'),
	(346815, 145, '2015-02-01 00:52:20.000000', 'temperatura', 170.0000, 'ºC'),
	(346816, 145, '2015-02-01 00:52:21.000000', 'temperatura', 1023.0000, 'ºC'),
	(346817, 145, '2015-02-01 00:52:22.000000', 'temperatura', 1007.0000, 'ºC'),
	(346818, 145, '2015-02-01 00:52:23.000000', 'temperatura', 764.0000, 'ºC'),
	(346819, 145, '2015-02-01 00:52:24.000000', 'temperatura', 798.0000, 'ºC'),
	(346820, 145, '2015-02-01 00:52:25.000000', 'temperatura', 500.0000, 'ºC'),
	(346821, 145, '2015-02-01 00:52:26.000000', 'temperatura', 109.0000, 'ºC'),
	(346822, 145, '2015-02-01 00:52:27.000000', 'temperatura', 242.0000, 'ºC'),
	(346823, 145, '2015-02-01 00:52:28.000000', 'temperatura', 885.0000, 'ºC'),
	(346824, 145, '2015-02-01 00:52:29.000000', 'temperatura', 100.0000, 'ºC'),
	(346825, 145, '2015-02-01 00:52:30.000000', 'temperatura', 247.0000, 'ºC'),
	(346826, 145, '2015-02-01 00:52:31.000000', 'temperatura', 933.0000, 'ºC'),
	(346827, 145, '2015-02-01 00:52:32.000000', 'temperatura', 325.0000, 'ºC'),
	(346828, 145, '2015-02-01 00:52:33.000000', 'temperatura', 28.0000, 'ºC'),
	(346829, 145, '2015-02-01 00:52:34.000000', 'temperatura', 364.0000, 'ºC'),
	(346830, 145, '2015-02-01 00:52:35.000000', 'temperatura', 537.0000, 'ºC'),
	(346831, 145, '2015-02-01 00:52:36.000000', 'temperatura', 394.0000, 'ºC'),
	(346832, 145, '2015-02-01 00:52:37.000000', 'temperatura', 360.0000, 'ºC'),
	(346833, 145, '2015-02-01 00:52:38.000000', 'temperatura', 617.0000, 'ºC'),
	(346834, 145, '2015-02-01 00:52:39.000000', 'temperatura', 808.0000, 'ºC'),
	(346835, 145, '2015-02-01 00:52:40.000000', 'temperatura', 986.0000, 'ºC'),
	(346836, 145, '2015-02-01 00:52:41.000000', 'temperatura', 109.0000, 'ºC'),
	(346837, 145, '2015-02-01 00:52:42.000000', 'temperatura', 1185.0000, 'ºC'),
	(346838, 145, '2015-02-01 00:52:43.000000', 'temperatura', 800.0000, 'ºC'),
	(346839, 145, '2015-02-01 00:52:44.000000', 'temperatura', 446.0000, 'ºC'),
	(346840, 145, '2015-02-01 00:52:45.000000', 'temperatura', 1031.0000, 'ºC'),
	(346841, 145, '2015-02-01 00:52:46.000000', 'temperatura', 218.0000, 'ºC'),
	(346842, 145, '2015-02-01 00:52:47.000000', 'temperatura', 398.0000, 'ºC'),
	(346843, 145, '2015-02-01 00:52:48.000000', 'temperatura', 137.0000, 'ºC'),
	(346844, 145, '2015-02-01 00:52:49.000000', 'temperatura', 692.0000, 'ºC'),
	(346845, 145, '2015-02-01 00:52:50.000000', 'temperatura', 649.0000, 'ºC'),
	(346846, 145, '2015-02-01 00:52:51.000000', 'temperatura', 1168.0000, 'ºC'),
	(346847, 145, '2015-02-01 00:52:52.000000', 'temperatura', 294.0000, 'ºC'),
	(346848, 145, '2015-02-01 00:52:53.000000', 'temperatura', 367.0000, 'ºC'),
	(346849, 145, '2015-02-01 00:52:54.000000', 'temperatura', 955.0000, 'ºC'),
	(346850, 145, '2015-02-01 00:52:55.000000', 'temperatura', 73.0000, 'ºC'),
	(346851, 145, '2015-02-01 00:52:56.000000', 'temperatura', 1102.0000, 'ºC'),
	(346852, 145, '2015-02-01 00:52:57.000000', 'temperatura', 491.0000, 'ºC'),
	(346853, 145, '2015-02-01 00:52:58.000000', 'temperatura', 347.0000, 'ºC'),
	(346854, 145, '2015-02-01 00:52:59.000000', 'temperatura', 265.0000, 'ºC'),
	(346855, 145, '2015-02-01 00:53:00.000000', 'temperatura', 283.0000, 'ºC'),
	(346856, 145, '2015-02-01 00:53:01.000000', 'temperatura', 621.0000, 'ºC'),
	(346857, 145, '2015-02-01 00:53:02.000000', 'temperatura', 1056.0000, 'ºC'),
	(346858, 145, '2015-02-01 00:53:03.000000', 'temperatura', 1020.0000, 'ºC'),
	(346859, 145, '2015-02-01 00:53:04.000000', 'temperatura', 731.0000, 'ºC'),
	(346860, 145, '2015-02-01 00:53:05.000000', 'temperatura', 595.0000, 'ºC'),
	(346861, 145, '2015-02-01 00:53:06.000000', 'temperatura', 784.0000, 'ºC'),
	(346862, 145, '2015-02-01 00:53:07.000000', 'temperatura', 936.0000, 'ºC'),
	(346863, 145, '2015-02-01 00:53:08.000000', 'temperatura', 1128.0000, 'ºC'),
	(346864, 145, '2015-02-01 00:53:09.000000', 'temperatura', 434.0000, 'ºC'),
	(346865, 145, '2015-02-01 00:53:10.000000', 'temperatura', 1186.0000, 'ºC'),
	(346866, 145, '2015-02-01 00:53:11.000000', 'temperatura', 1029.0000, 'ºC'),
	(346867, 145, '2015-02-01 00:53:12.000000', 'temperatura', 388.0000, 'ºC'),
	(346868, 145, '2015-02-01 00:53:13.000000', 'temperatura', 53.0000, 'ºC'),
	(346869, 145, '2015-02-01 00:53:14.000000', 'temperatura', 299.0000, 'ºC'),
	(346870, 145, '2015-02-01 00:53:15.000000', 'temperatura', 140.0000, 'ºC'),
	(346871, 145, '2015-02-01 00:53:16.000000', 'temperatura', 1001.0000, 'ºC'),
	(346872, 145, '2015-02-01 00:53:17.000000', 'temperatura', 985.0000, 'ºC'),
	(346873, 145, '2015-02-01 00:53:18.000000', 'temperatura', 723.0000, 'ºC'),
	(346874, 145, '2015-02-01 00:53:19.000000', 'temperatura', 662.0000, 'ºC'),
	(346875, 145, '2015-02-01 00:53:20.000000', 'temperatura', 1141.0000, 'ºC'),
	(346876, 145, '2015-02-01 00:53:21.000000', 'temperatura', 120.0000, 'ºC'),
	(346877, 145, '2015-02-01 00:53:22.000000', 'temperatura', 778.0000, 'ºC'),
	(346878, 145, '2015-02-01 00:53:23.000000', 'temperatura', 1131.0000, 'ºC'),
	(346879, 145, '2015-02-01 00:53:24.000000', 'temperatura', 920.0000, 'ºC'),
	(346880, 145, '2015-02-01 00:53:25.000000', 'temperatura', 8.0000, 'ºC'),
	(346881, 145, '2015-02-01 00:53:26.000000', 'temperatura', 882.0000, 'ºC'),
	(346882, 145, '2015-02-01 00:53:27.000000', 'temperatura', 784.0000, 'ºC'),
	(346883, 145, '2015-02-01 00:53:28.000000', 'temperatura', 75.0000, 'ºC'),
	(346884, 145, '2015-02-01 00:53:29.000000', 'temperatura', 426.0000, 'ºC'),
	(346885, 145, '2015-02-01 00:53:30.000000', 'temperatura', 702.0000, 'ºC'),
	(346886, 145, '2015-02-01 00:53:31.000000', 'temperatura', 1034.0000, 'ºC'),
	(346887, 145, '2015-02-01 00:53:32.000000', 'temperatura', 663.0000, 'ºC'),
	(346888, 145, '2015-02-01 00:53:33.000000', 'temperatura', 213.0000, 'ºC'),
	(346889, 145, '2015-02-01 00:53:34.000000', 'temperatura', 279.0000, 'ºC'),
	(346890, 145, '2015-02-01 00:53:35.000000', 'temperatura', 757.0000, 'ºC'),
	(346891, 145, '2015-02-01 00:53:36.000000', 'temperatura', 547.0000, 'ºC'),
	(346892, 145, '2015-02-01 00:53:37.000000', 'temperatura', 465.0000, 'ºC'),
	(346893, 145, '2015-02-01 00:53:38.000000', 'temperatura', 685.0000, 'ºC'),
	(346894, 145, '2015-02-01 00:53:39.000000', 'temperatura', 830.0000, 'ºC'),
	(346895, 145, '2015-02-01 00:53:40.000000', 'temperatura', 897.0000, 'ºC'),
	(346896, 145, '2015-02-01 00:53:41.000000', 'temperatura', 793.0000, 'ºC'),
	(346897, 145, '2015-02-01 00:53:42.000000', 'temperatura', 76.0000, 'ºC'),
	(346898, 145, '2015-02-01 00:53:43.000000', 'temperatura', 403.0000, 'ºC'),
	(346899, 145, '2015-02-01 00:53:44.000000', 'temperatura', 587.0000, 'ºC'),
	(346900, 145, '2015-02-01 00:53:45.000000', 'temperatura', 527.0000, 'ºC'),
	(346901, 145, '2015-02-01 00:53:46.000000', 'temperatura', 875.0000, 'ºC'),
	(346902, 145, '2015-02-01 00:53:47.000000', 'temperatura', 392.0000, 'ºC'),
	(346903, 145, '2015-02-01 00:53:48.000000', 'temperatura', 535.0000, 'ºC'),
	(346904, 145, '2015-02-01 00:53:49.000000', 'temperatura', 302.0000, 'ºC'),
	(346905, 145, '2015-02-01 00:53:50.000000', 'temperatura', 1103.0000, 'ºC'),
	(346906, 145, '2015-02-01 00:53:51.000000', 'temperatura', 1009.0000, 'ºC'),
	(346907, 145, '2015-02-01 00:53:52.000000', 'temperatura', 536.0000, 'ºC'),
	(346908, 145, '2015-02-01 00:53:53.000000', 'temperatura', 853.0000, 'ºC'),
	(346909, 145, '2015-02-01 00:53:54.000000', 'temperatura', 259.0000, 'ºC'),
	(346910, 145, '2015-02-01 00:53:55.000000', 'temperatura', 1135.0000, 'ºC'),
	(346911, 145, '2015-02-01 00:53:56.000000', 'temperatura', 99.0000, 'ºC'),
	(346912, 145, '2015-02-01 00:53:57.000000', 'temperatura', 692.0000, 'ºC'),
	(346913, 145, '2015-02-01 00:53:58.000000', 'temperatura', 764.0000, 'ºC'),
	(346914, 145, '2015-02-01 00:53:59.000000', 'temperatura', 546.0000, 'ºC'),
	(346915, 145, '2015-02-01 00:54:00.000000', 'temperatura', 435.0000, 'ºC'),
	(346916, 145, '2015-02-01 00:54:01.000000', 'temperatura', 538.0000, 'ºC'),
	(346917, 145, '2015-02-01 00:54:02.000000', 'temperatura', 188.0000, 'ºC'),
	(346918, 145, '2015-02-01 00:54:03.000000', 'temperatura', 525.0000, 'ºC'),
	(346919, 145, '2015-02-01 00:54:04.000000', 'temperatura', 860.0000, 'ºC'),
	(346920, 145, '2015-02-01 00:54:05.000000', 'temperatura', 328.0000, 'ºC'),
	(346921, 145, '2015-02-01 00:54:06.000000', 'temperatura', 260.0000, 'ºC'),
	(346922, 145, '2015-02-01 00:54:07.000000', 'temperatura', 316.0000, 'ºC'),
	(346923, 145, '2015-02-01 00:54:08.000000', 'temperatura', 801.0000, 'ºC'),
	(346924, 145, '2015-02-01 00:54:09.000000', 'temperatura', 658.0000, 'ºC'),
	(346925, 145, '2015-02-01 00:54:10.000000', 'temperatura', 887.0000, 'ºC'),
	(346926, 145, '2015-02-01 00:54:11.000000', 'temperatura', 61.0000, 'ºC'),
	(346927, 145, '2015-02-01 00:54:12.000000', 'temperatura', 46.0000, 'ºC'),
	(346928, 145, '2015-02-01 00:54:13.000000', 'temperatura', 48.0000, 'ºC'),
	(346929, 145, '2015-02-01 00:54:14.000000', 'temperatura', 100.0000, 'ºC'),
	(346930, 145, '2015-02-01 00:54:15.000000', 'temperatura', 357.0000, 'ºC'),
	(346931, 145, '2015-02-01 00:54:16.000000', 'temperatura', 287.0000, 'ºC'),
	(346932, 145, '2015-02-01 00:54:17.000000', 'temperatura', 363.0000, 'ºC'),
	(346933, 145, '2015-02-01 00:54:18.000000', 'temperatura', 956.0000, 'ºC'),
	(346934, 145, '2015-02-01 00:54:19.000000', 'temperatura', 92.0000, 'ºC'),
	(346935, 145, '2015-02-01 00:54:20.000000', 'temperatura', 1193.0000, 'ºC'),
	(346936, 145, '2015-02-01 00:54:21.000000', 'temperatura', 889.0000, 'ºC'),
	(346937, 145, '2015-02-01 00:54:22.000000', 'temperatura', 867.0000, 'ºC'),
	(346938, 145, '2015-02-01 00:54:23.000000', 'temperatura', 467.0000, 'ºC'),
	(346939, 145, '2015-02-01 00:54:24.000000', 'temperatura', 936.0000, 'ºC'),
	(346940, 145, '2015-02-01 00:54:25.000000', 'temperatura', 877.0000, 'ºC'),
	(346941, 145, '2015-02-01 00:54:26.000000', 'temperatura', 381.0000, 'ºC'),
	(346942, 145, '2015-02-01 00:54:27.000000', 'temperatura', 472.0000, 'ºC'),
	(346943, 145, '2015-02-01 00:54:28.000000', 'temperatura', 19.0000, 'ºC'),
	(346944, 145, '2015-02-01 00:54:29.000000', 'temperatura', 1081.0000, 'ºC'),
	(346945, 145, '2015-02-01 00:54:30.000000', 'temperatura', 547.0000, 'ºC'),
	(346946, 145, '2015-02-01 00:54:31.000000', 'temperatura', 693.0000, 'ºC'),
	(346947, 145, '2015-02-01 00:54:32.000000', 'temperatura', 626.0000, 'ºC'),
	(346948, 145, '2015-02-01 00:54:33.000000', 'temperatura', 1050.0000, 'ºC'),
	(346949, 145, '2015-02-01 00:54:34.000000', 'temperatura', 971.0000, 'ºC'),
	(346950, 145, '2015-02-01 00:54:35.000000', 'temperatura', 509.0000, 'ºC'),
	(346951, 145, '2015-02-01 00:54:36.000000', 'temperatura', 830.0000, 'ºC'),
	(346952, 145, '2015-02-01 00:54:37.000000', 'temperatura', 222.0000, 'ºC'),
	(346953, 145, '2015-02-01 00:54:38.000000', 'temperatura', 1022.0000, 'ºC'),
	(346954, 145, '2015-02-01 00:54:39.000000', 'temperatura', 846.0000, 'ºC'),
	(346955, 145, '2015-02-01 00:54:40.000000', 'temperatura', 1161.0000, 'ºC'),
	(346956, 145, '2015-02-01 00:54:41.000000', 'temperatura', 871.0000, 'ºC'),
	(346957, 145, '2015-02-01 00:54:42.000000', 'temperatura', 870.0000, 'ºC'),
	(346958, 145, '2015-02-01 00:54:43.000000', 'temperatura', 537.0000, 'ºC'),
	(346959, 145, '2015-02-01 00:54:44.000000', 'temperatura', 78.0000, 'ºC'),
	(346960, 145, '2015-02-01 00:54:45.000000', 'temperatura', 1180.0000, 'ºC'),
	(346961, 145, '2015-02-01 00:54:46.000000', 'temperatura', 866.0000, 'ºC'),
	(346962, 145, '2015-02-01 00:54:47.000000', 'temperatura', 791.0000, 'ºC'),
	(346963, 145, '2015-02-01 00:54:48.000000', 'temperatura', 158.0000, 'ºC'),
	(346964, 145, '2015-02-01 00:54:49.000000', 'temperatura', 818.0000, 'ºC'),
	(346965, 145, '2015-02-01 00:54:50.000000', 'temperatura', 16.0000, 'ºC'),
	(346966, 145, '2015-02-01 00:54:51.000000', 'temperatura', 28.0000, 'ºC'),
	(346967, 145, '2015-02-01 00:54:52.000000', 'temperatura', 89.0000, 'ºC'),
	(346968, 145, '2015-02-01 00:54:53.000000', 'temperatura', 364.0000, 'ºC'),
	(346969, 145, '2015-02-01 00:54:54.000000', 'temperatura', 353.0000, 'ºC'),
	(346970, 145, '2015-02-01 00:54:55.000000', 'temperatura', 675.0000, 'ºC'),
	(346971, 145, '2015-02-01 00:54:56.000000', 'temperatura', 1115.0000, 'ºC'),
	(346972, 145, '2015-02-01 00:54:57.000000', 'temperatura', 1152.0000, 'ºC'),
	(346973, 145, '2015-02-01 00:54:58.000000', 'temperatura', 16.0000, 'ºC'),
	(346974, 145, '2015-02-01 00:54:59.000000', 'temperatura', 222.0000, 'ºC'),
	(346975, 145, '2015-02-01 00:55:00.000000', 'temperatura', 1064.0000, 'ºC'),
	(346976, 145, '2015-02-01 00:55:01.000000', 'temperatura', 1052.0000, 'ºC'),
	(346977, 145, '2015-02-01 00:55:02.000000', 'temperatura', 872.0000, 'ºC'),
	(346978, 145, '2015-02-01 00:55:03.000000', 'temperatura', 3.0000, 'ºC'),
	(346979, 145, '2015-02-01 00:55:04.000000', 'temperatura', 1002.0000, 'ºC'),
	(346980, 145, '2015-02-01 00:55:05.000000', 'temperatura', 198.0000, 'ºC'),
	(346981, 145, '2015-02-01 00:55:06.000000', 'temperatura', 387.0000, 'ºC'),
	(346982, 145, '2015-02-01 00:55:07.000000', 'temperatura', 139.0000, 'ºC'),
	(346983, 145, '2015-02-01 00:55:08.000000', 'temperatura', 736.0000, 'ºC'),
	(346984, 145, '2015-02-01 00:55:09.000000', 'temperatura', 863.0000, 'ºC'),
	(346985, 145, '2015-02-01 00:55:10.000000', 'temperatura', 907.0000, 'ºC'),
	(346986, 145, '2015-02-01 00:55:11.000000', 'temperatura', 748.0000, 'ºC'),
	(346987, 145, '2015-02-01 00:55:12.000000', 'temperatura', 1019.0000, 'ºC'),
	(346988, 145, '2015-02-01 00:55:13.000000', 'temperatura', 449.0000, 'ºC'),
	(346989, 145, '2015-02-01 00:55:14.000000', 'temperatura', 391.0000, 'ºC'),
	(346990, 145, '2015-02-01 00:55:15.000000', 'temperatura', 609.0000, 'ºC'),
	(346991, 145, '2015-02-01 00:55:16.000000', 'temperatura', 672.0000, 'ºC'),
	(346992, 145, '2015-02-01 00:55:17.000000', 'temperatura', 334.0000, 'ºC'),
	(346993, 145, '2015-02-01 00:55:18.000000', 'temperatura', 853.0000, 'ºC'),
	(346994, 145, '2015-02-01 00:55:19.000000', 'temperatura', 864.0000, 'ºC'),
	(346995, 145, '2015-02-01 00:55:20.000000', 'temperatura', 560.0000, 'ºC'),
	(346996, 145, '2015-02-01 00:55:21.000000', 'temperatura', 210.0000, 'ºC'),
	(346997, 145, '2015-02-01 00:55:22.000000', 'temperatura', 570.0000, 'ºC'),
	(346998, 145, '2015-02-01 00:55:23.000000', 'temperatura', 1021.0000, 'ºC'),
	(346999, 145, '2015-02-01 00:55:24.000000', 'temperatura', 995.0000, 'ºC'),
	(347000, 145, '2015-02-01 00:55:25.000000', 'temperatura', 712.0000, 'ºC'),
	(347001, 145, '2015-02-01 00:55:26.000000', 'temperatura', 575.0000, 'ºC'),
	(347002, 145, '2015-02-01 00:55:27.000000', 'temperatura', 740.0000, 'ºC'),
	(347003, 145, '2015-02-01 00:55:28.000000', 'temperatura', 776.0000, 'ºC'),
	(347004, 145, '2015-02-01 00:55:29.000000', 'temperatura', 462.0000, 'ºC'),
	(347005, 145, '2015-02-01 00:55:30.000000', 'temperatura', 1179.0000, 'ºC'),
	(347006, 145, '2015-02-01 00:55:31.000000', 'temperatura', 912.0000, 'ºC'),
	(347007, 145, '2015-02-01 00:55:32.000000', 'temperatura', 1024.0000, 'ºC'),
	(347008, 145, '2015-02-01 00:55:33.000000', 'temperatura', 1182.0000, 'ºC'),
	(347009, 145, '2015-02-01 00:55:34.000000', 'temperatura', 440.0000, 'ºC'),
	(347010, 145, '2015-02-01 00:55:35.000000', 'temperatura', 1052.0000, 'ºC'),
	(347011, 145, '2015-02-01 00:55:36.000000', 'temperatura', 343.0000, 'ºC'),
	(347012, 145, '2015-02-01 00:55:37.000000', 'temperatura', 958.0000, 'ºC'),
	(347013, 145, '2015-02-01 00:55:38.000000', 'temperatura', 161.0000, 'ºC'),
	(347014, 145, '2015-02-01 00:55:39.000000', 'temperatura', 334.0000, 'ºC'),
	(347015, 145, '2015-02-01 00:55:40.000000', 'temperatura', 1187.0000, 'ºC'),
	(347016, 145, '2015-02-01 00:55:41.000000', 'temperatura', 134.0000, 'ºC'),
	(347017, 145, '2015-02-01 00:55:42.000000', 'temperatura', 708.0000, 'ºC'),
	(347018, 145, '2015-02-01 00:55:43.000000', 'temperatura', 741.0000, 'ºC'),
	(347019, 145, '2015-02-01 00:55:44.000000', 'temperatura', 378.0000, 'ºC'),
	(347020, 145, '2015-02-01 00:55:45.000000', 'temperatura', 870.0000, 'ºC'),
	(347021, 145, '2015-02-01 00:55:46.000000', 'temperatura', 814.0000, 'ºC'),
	(347022, 145, '2015-02-01 00:55:47.000000', 'temperatura', 262.0000, 'ºC'),
	(347023, 145, '2015-02-01 00:55:48.000000', 'temperatura', 68.0000, 'ºC'),
	(347024, 145, '2015-02-01 00:55:49.000000', 'temperatura', 754.0000, 'ºC'),
	(347025, 145, '2015-02-01 00:55:50.000000', 'temperatura', 1166.0000, 'ºC'),
	(347026, 145, '2015-02-01 00:55:51.000000', 'temperatura', 1168.0000, 'ºC'),
	(347027, 145, '2015-02-01 00:55:52.000000', 'temperatura', 1142.0000, 'ºC'),
	(347028, 145, '2015-02-01 00:55:53.000000', 'temperatura', 1007.0000, 'ºC'),
	(347029, 145, '2015-02-01 00:55:54.000000', 'temperatura', 410.0000, 'ºC'),
	(347030, 145, '2015-02-01 00:55:55.000000', 'temperatura', 231.0000, 'ºC'),
	(347031, 145, '2015-02-01 00:55:56.000000', 'temperatura', 1125.0000, 'ºC'),
	(347032, 145, '2015-02-01 00:55:57.000000', 'temperatura', 131.0000, 'ºC'),
	(347033, 145, '2015-02-01 00:55:58.000000', 'temperatura', 882.0000, 'ºC'),
	(347034, 145, '2015-02-01 00:55:59.000000', 'temperatura', 416.0000, 'ºC'),
	(347035, 145, '2015-02-01 00:56:00.000000', 'temperatura', 634.0000, 'ºC'),
	(347036, 145, '2015-02-01 00:56:01.000000', 'temperatura', 722.0000, 'ºC'),
	(347037, 145, '2015-02-01 00:56:02.000000', 'temperatura', 509.0000, 'ºC'),
	(347038, 145, '2015-02-01 00:56:03.000000', 'temperatura', 382.0000, 'ºC'),
	(347039, 145, '2015-02-01 00:56:04.000000', 'temperatura', 380.0000, 'ºC'),
	(347040, 145, '2015-02-01 00:56:05.000000', 'temperatura', 756.0000, 'ºC'),
	(347041, 145, '2015-02-01 00:56:06.000000', 'temperatura', 241.0000, 'ºC'),
	(347042, 145, '2015-02-01 00:56:07.000000', 'temperatura', 136.0000, 'ºC'),
	(347043, 145, '2015-02-01 00:56:08.000000', 'temperatura', 1160.0000, 'ºC'),
	(347044, 145, '2015-02-01 00:56:09.000000', 'temperatura', 593.0000, 'ºC'),
	(347045, 145, '2015-02-01 00:56:10.000000', 'temperatura', 684.0000, 'ºC'),
	(347046, 145, '2015-02-01 00:56:11.000000', 'temperatura', 440.0000, 'ºC'),
	(347047, 145, '2015-02-01 00:56:12.000000', 'temperatura', 151.0000, 'ºC'),
	(347048, 145, '2015-02-01 00:56:13.000000', 'temperatura', 633.0000, 'ºC'),
	(347049, 145, '2015-02-01 00:56:14.000000', 'temperatura', 312.0000, 'ºC'),
	(347050, 145, '2015-02-01 00:56:15.000000', 'temperatura', 861.0000, 'ºC'),
	(347051, 145, '2015-02-01 00:56:16.000000', 'temperatura', 971.0000, 'ºC'),
	(347052, 145, '2015-02-01 00:56:17.000000', 'temperatura', 1071.0000, 'ºC'),
	(347053, 145, '2015-02-01 00:56:18.000000', 'temperatura', 45.0000, 'ºC'),
	(347054, 145, '2015-02-01 00:56:19.000000', 'temperatura', 613.0000, 'ºC'),
	(347055, 145, '2015-02-01 00:56:20.000000', 'temperatura', 530.0000, 'ºC'),
	(347056, 145, '2015-02-01 00:56:21.000000', 'temperatura', 810.0000, 'ºC'),
	(347057, 145, '2015-02-01 00:56:22.000000', 'temperatura', 63.0000, 'ºC'),
	(347058, 145, '2015-02-01 00:56:23.000000', 'temperatura', 285.0000, 'ºC'),
	(347059, 145, '2015-02-01 00:56:24.000000', 'temperatura', 36.0000, 'ºC'),
	(347060, 145, '2015-02-01 00:56:25.000000', 'temperatura', 527.0000, 'ºC'),
	(347061, 145, '2015-02-01 00:56:26.000000', 'temperatura', 126.0000, 'ºC'),
	(347062, 145, '2015-02-01 00:56:27.000000', 'temperatura', 248.0000, 'ºC'),
	(347063, 145, '2015-02-01 00:56:28.000000', 'temperatura', 865.0000, 'ºC'),
	(347064, 145, '2015-02-01 00:56:29.000000', 'temperatura', 1179.0000, 'ºC'),
	(347065, 145, '2015-02-01 00:56:30.000000', 'temperatura', 903.0000, 'ºC'),
	(347066, 145, '2015-02-01 00:56:31.000000', 'temperatura', 979.0000, 'ºC'),
	(347067, 145, '2015-02-01 00:56:32.000000', 'temperatura', 985.0000, 'ºC'),
	(347068, 145, '2015-02-01 00:56:33.000000', 'temperatura', 791.0000, 'ºC'),
	(347069, 145, '2015-02-01 00:56:34.000000', 'temperatura', 998.0000, 'ºC'),
	(347070, 145, '2015-02-01 00:56:35.000000', 'temperatura', 219.0000, 'ºC'),
	(347071, 145, '2015-02-01 00:56:36.000000', 'temperatura', 502.0000, 'ºC'),
	(347072, 145, '2015-02-01 00:56:37.000000', 'temperatura', 653.0000, 'ºC'),
	(347073, 145, '2015-02-01 00:56:38.000000', 'temperatura', 560.0000, 'ºC'),
	(347074, 145, '2015-02-01 00:56:39.000000', 'temperatura', 839.0000, 'ºC'),
	(347075, 145, '2015-02-01 00:56:40.000000', 'temperatura', 117.0000, 'ºC'),
	(347076, 145, '2015-02-01 00:56:41.000000', 'temperatura', 469.0000, 'ºC'),
	(347077, 145, '2015-02-01 00:56:42.000000', 'temperatura', 792.0000, 'ºC'),
	(347078, 145, '2015-02-01 00:56:43.000000', 'temperatura', 156.0000, 'ºC'),
	(347079, 145, '2015-02-01 00:56:44.000000', 'temperatura', 806.0000, 'ºC'),
	(347080, 145, '2015-02-01 00:56:45.000000', 'temperatura', 1160.0000, 'ºC'),
	(347081, 145, '2015-02-01 00:56:46.000000', 'temperatura', 982.0000, 'ºC'),
	(347082, 145, '2015-02-01 00:56:47.000000', 'temperatura', 229.0000, 'ºC'),
	(347083, 145, '2015-02-01 00:56:48.000000', 'temperatura', 603.0000, 'ºC'),
	(347084, 145, '2015-02-01 00:56:49.000000', 'temperatura', 1126.0000, 'ºC'),
	(347085, 145, '2015-02-01 00:56:50.000000', 'temperatura', 222.0000, 'ºC'),
	(347086, 145, '2015-02-01 00:56:51.000000', 'temperatura', 134.0000, 'ºC'),
	(347087, 145, '2015-02-01 00:56:52.000000', 'temperatura', 5.0000, 'ºC'),
	(347088, 145, '2015-02-01 00:56:53.000000', 'temperatura', 821.0000, 'ºC'),
	(347089, 145, '2015-02-01 00:56:54.000000', 'temperatura', 491.0000, 'ºC'),
	(347090, 145, '2015-02-01 00:56:55.000000', 'temperatura', 1194.0000, 'ºC'),
	(347091, 145, '2015-02-01 00:56:56.000000', 'temperatura', 898.0000, 'ºC'),
	(347092, 145, '2015-02-01 00:56:57.000000', 'temperatura', 906.0000, 'ºC'),
	(347093, 145, '2015-02-01 00:56:58.000000', 'temperatura', 636.0000, 'ºC'),
	(347094, 145, '2015-02-01 00:56:59.000000', 'temperatura', 464.0000, 'ºC'),
	(347095, 145, '2015-02-01 00:57:00.000000', 'temperatura', 412.0000, 'ºC'),
	(347096, 145, '2015-02-01 00:57:01.000000', 'temperatura', 668.0000, 'ºC'),
	(347097, 145, '2015-02-01 00:57:02.000000', 'temperatura', 907.0000, 'ºC'),
	(347098, 145, '2015-02-01 00:57:03.000000', 'temperatura', 131.0000, 'ºC'),
	(347099, 145, '2015-02-01 00:57:04.000000', 'temperatura', 332.0000, 'ºC'),
	(347100, 145, '2015-02-01 00:57:05.000000', 'temperatura', 68.0000, 'ºC'),
	(347101, 145, '2015-02-01 00:57:06.000000', 'temperatura', 547.0000, 'ºC'),
	(347102, 145, '2015-02-01 00:57:07.000000', 'temperatura', 129.0000, 'ºC'),
	(347103, 145, '2015-02-01 00:57:08.000000', 'temperatura', 204.0000, 'ºC'),
	(347104, 145, '2015-02-01 00:57:09.000000', 'temperatura', 636.0000, 'ºC'),
	(347105, 145, '2015-02-01 00:57:10.000000', 'temperatura', 169.0000, 'ºC'),
	(347106, 145, '2015-02-01 00:57:11.000000', 'temperatura', 138.0000, 'ºC'),
	(347107, 145, '2015-02-01 00:57:12.000000', 'temperatura', 183.0000, 'ºC'),
	(347108, 145, '2015-02-01 00:57:13.000000', 'temperatura', 500.0000, 'ºC'),
	(347109, 145, '2015-02-01 00:57:14.000000', 'temperatura', 754.0000, 'ºC'),
	(347110, 145, '2015-02-01 00:57:15.000000', 'temperatura', 1070.0000, 'ºC'),
	(347111, 145, '2015-02-01 00:57:16.000000', 'temperatura', 689.0000, 'ºC'),
	(347112, 145, '2015-02-01 00:57:17.000000', 'temperatura', 233.0000, 'ºC'),
	(347113, 145, '2015-02-01 00:57:18.000000', 'temperatura', 299.0000, 'ºC'),
	(347114, 145, '2015-02-01 00:57:19.000000', 'temperatura', 797.0000, 'ºC'),
	(347115, 145, '2015-02-01 00:57:20.000000', 'temperatura', 689.0000, 'ºC'),
	(347116, 145, '2015-02-01 00:57:21.000000', 'temperatura', 1053.0000, 'ºC'),
	(347117, 145, '2015-02-01 00:57:22.000000', 'temperatura', 799.0000, 'ºC'),
	(347118, 145, '2015-02-01 00:57:23.000000', 'temperatura', 838.0000, 'ºC'),
	(347119, 145, '2015-02-01 00:57:24.000000', 'temperatura', 593.0000, 'ºC'),
	(347120, 145, '2015-02-01 00:57:25.000000', 'temperatura', 453.0000, 'ºC'),
	(347121, 145, '2015-02-01 00:57:26.000000', 'temperatura', 486.0000, 'ºC'),
	(347122, 145, '2015-02-01 00:57:27.000000', 'temperatura', 1071.0000, 'ºC'),
	(347123, 145, '2015-02-01 00:57:28.000000', 'temperatura', 299.0000, 'ºC'),
	(347124, 145, '2015-02-01 00:57:29.000000', 'temperatura', 681.0000, 'ºC'),
	(347125, 145, '2015-02-01 00:57:30.000000', 'temperatura', 111.0000, 'ºC'),
	(347126, 145, '2015-02-01 00:57:31.000000', 'temperatura', 910.0000, 'ºC'),
	(347127, 145, '2015-02-01 00:57:32.000000', 'temperatura', 618.0000, 'ºC'),
	(347128, 145, '2015-02-01 00:57:33.000000', 'temperatura', 359.0000, 'ºC'),
	(347129, 145, '2015-02-01 00:57:34.000000', 'temperatura', 1141.0000, 'ºC'),
	(347130, 145, '2015-02-01 00:57:35.000000', 'temperatura', 1030.0000, 'ºC'),
	(347131, 145, '2015-02-01 00:57:36.000000', 'temperatura', 526.0000, 'ºC'),
	(347132, 145, '2015-02-01 00:57:37.000000', 'temperatura', 741.0000, 'ºC'),
	(347133, 145, '2015-02-01 00:57:38.000000', 'temperatura', 928.0000, 'ºC'),
	(347134, 145, '2015-02-01 00:57:39.000000', 'temperatura', 17.0000, 'ºC');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(347135, 145, '2015-02-01 00:57:40.000000', 'temperatura', 903.0000, 'ºC'),
	(347136, 145, '2015-02-01 00:57:41.000000', 'temperatura', 864.0000, 'ºC'),
	(347137, 145, '2015-02-01 00:57:42.000000', 'temperatura', 412.0000, 'ºC'),
	(347138, 145, '2015-02-01 00:57:43.000000', 'temperatura', 669.0000, 'ºC'),
	(347139, 145, '2015-02-01 00:57:44.000000', 'temperatura', 909.0000, 'ºC'),
	(347140, 145, '2015-02-01 00:57:45.000000', 'temperatura', 137.0000, 'ºC'),
	(347141, 145, '2015-02-01 00:57:46.000000', 'temperatura', 358.0000, 'ºC'),
	(347142, 145, '2015-02-01 00:57:47.000000', 'temperatura', 180.0000, 'ºC'),
	(347143, 145, '2015-02-01 00:57:48.000000', 'temperatura', 1025.0000, 'ºC'),
	(347144, 145, '2015-02-01 00:57:49.000000', 'temperatura', 986.0000, 'ºC'),
	(347145, 145, '2015-02-01 00:57:50.000000', 'temperatura', 656.0000, 'ºC'),
	(347146, 145, '2015-02-01 00:57:51.000000', 'temperatura', 324.0000, 'ºC'),
	(347147, 145, '2015-02-01 00:57:52.000000', 'temperatura', 850.0000, 'ºC'),
	(347148, 145, '2015-02-01 00:57:53.000000', 'temperatura', 879.0000, 'ºC'),
	(347149, 145, '2015-02-01 00:57:54.000000', 'temperatura', 648.0000, 'ºC'),
	(347150, 145, '2015-02-01 00:57:55.000000', 'temperatura', 601.0000, 'ºC'),
	(347151, 145, '2015-02-01 00:57:56.000000', 'temperatura', 1061.0000, 'ºC'),
	(347152, 145, '2015-02-01 00:57:57.000000', 'temperatura', 1104.0000, 'ºC'),
	(347153, 145, '2015-02-01 00:57:58.000000', 'temperatura', 1136.0000, 'ºC'),
	(347154, 145, '2015-02-01 00:57:59.000000', 'temperatura', 1170.0000, 'ºC'),
	(347155, 145, '2015-02-01 00:58:00.000000', 'temperatura', 42.0000, 'ºC'),
	(347156, 145, '2015-02-01 00:58:01.000000', 'temperatura', 302.0000, 'ºC'),
	(347157, 145, '2015-02-01 00:58:02.000000', 'temperatura', 182.0000, 'ºC'),
	(347158, 145, '2015-02-01 00:58:03.000000', 'temperatura', 8.0000, 'ºC'),
	(347159, 145, '2015-02-01 00:58:04.000000', 'temperatura', 691.0000, 'ºC'),
	(347160, 145, '2015-02-01 00:58:05.000000', 'temperatura', 1032.0000, 'ºC'),
	(347161, 145, '2015-02-01 00:58:06.000000', 'temperatura', 686.0000, 'ºC'),
	(347162, 145, '2015-02-01 00:58:07.000000', 'temperatura', 337.0000, 'ºC'),
	(347163, 145, '2015-02-01 00:58:08.000000', 'temperatura', 825.0000, 'ºC'),
	(347164, 145, '2015-02-01 00:58:09.000000', 'temperatura', 717.0000, 'ºC'),
	(347165, 145, '2015-02-01 00:58:10.000000', 'temperatura', 1109.0000, 'ºC'),
	(347166, 145, '2015-02-01 00:58:11.000000', 'temperatura', 996.0000, 'ºC'),
	(347167, 145, '2015-02-01 00:58:12.000000', 'temperatura', 451.0000, 'ºC'),
	(347168, 145, '2015-02-01 00:58:13.000000', 'temperatura', 468.0000, 'ºC'),
	(347169, 145, '2015-02-01 00:58:14.000000', 'temperatura', 988.0000, 'ºC'),
	(347170, 145, '2015-02-01 00:58:15.000000', 'temperatura', 1138.0000, 'ºC'),
	(347171, 145, '2015-02-01 00:58:16.000000', 'temperatura', 324.0000, 'ºC'),
	(347172, 145, '2015-02-01 00:58:17.000000', 'temperatura', 607.0000, 'ºC'),
	(347173, 145, '2015-02-01 00:58:18.000000', 'temperatura', 866.0000, 'ºC'),
	(347174, 145, '2015-02-01 00:58:19.000000', 'temperatura', 106.0000, 'ºC'),
	(347175, 145, '2015-02-01 00:58:20.000000', 'temperatura', 334.0000, 'ºC'),
	(347176, 145, '2015-02-01 00:58:21.000000', 'temperatura', 151.0000, 'ºC'),
	(347177, 145, '2015-02-01 00:58:22.000000', 'temperatura', 955.0000, 'ºC'),
	(347178, 145, '2015-02-01 00:58:23.000000', 'temperatura', 724.0000, 'ºC'),
	(347179, 145, '2015-02-01 00:58:24.000000', 'temperatura', 754.0000, 'ºC'),
	(347180, 145, '2015-02-01 00:58:25.000000', 'temperatura', 397.0000, 'ºC'),
	(347181, 145, '2015-02-01 00:58:26.000000', 'temperatura', 926.0000, 'ºC'),
	(347182, 145, '2015-02-01 00:58:27.000000', 'temperatura', 1038.0000, 'ºC'),
	(347183, 145, '2015-02-01 00:58:28.000000', 'temperatura', 14.0000, 'ºC'),
	(347184, 145, '2015-02-01 00:58:29.000000', 'temperatura', 556.0000, 'ºC'),
	(347185, 145, '2015-02-01 00:58:30.000000', 'temperatura', 337.0000, 'ºC'),
	(347186, 145, '2015-02-01 00:58:31.000000', 'temperatura', 20.0000, 'ºC'),
	(347187, 145, '2015-02-01 00:58:32.000000', 'temperatura', 290.0000, 'ºC'),
	(347188, 145, '2015-02-01 00:58:33.000000', 'temperatura', 188.0000, 'ºC'),
	(347189, 145, '2015-02-01 00:58:34.000000', 'temperatura', 72.0000, 'ºC'),
	(347190, 145, '2015-02-01 00:58:35.000000', 'temperatura', 997.0000, 'ºC'),
	(347191, 145, '2015-02-01 00:58:36.000000', 'temperatura', 1169.0000, 'ºC'),
	(347192, 145, '2015-02-01 00:58:37.000000', 'temperatura', 453.0000, 'ºC'),
	(347193, 145, '2015-02-01 00:58:38.000000', 'temperatura', 1158.0000, 'ºC'),
	(347194, 145, '2015-02-01 00:58:39.000000', 'temperatura', 832.0000, 'ºC'),
	(347195, 145, '2015-02-01 00:58:40.000000', 'temperatura', 687.0000, 'ºC'),
	(347196, 145, '2015-02-01 00:58:41.000000', 'temperatura', 939.0000, 'ºC'),
	(347197, 145, '2015-02-01 00:58:42.000000', 'temperatura', 233.0000, 'ºC'),
	(347198, 145, '2015-02-01 00:58:43.000000', 'temperatura', 749.0000, 'ºC'),
	(347199, 145, '2015-02-01 00:58:44.000000', 'temperatura', 649.0000, 'ºC'),
	(347200, 145, '2015-02-01 00:58:45.000000', 'temperatura', 995.0000, 'ºC'),
	(347201, 145, '2015-02-01 00:58:46.000000', 'temperatura', 632.0000, 'ºC'),
	(347202, 145, '2015-02-01 00:58:47.000000', 'temperatura', 173.0000, 'ºC'),
	(347203, 145, '2015-02-01 00:58:48.000000', 'temperatura', 171.0000, 'ºC'),
	(347204, 145, '2015-02-01 00:58:49.000000', 'temperatura', 335.0000, 'ºC'),
	(347205, 145, '2015-02-01 00:58:50.000000', 'temperatura', 1165.0000, 'ºC'),
	(347206, 145, '2015-02-01 00:58:51.000000', 'temperatura', 20.0000, 'ºC'),
	(347207, 145, '2015-02-01 00:58:52.000000', 'temperatura', 205.0000, 'ºC'),
	(347208, 145, '2015-02-01 00:58:53.000000', 'temperatura', 966.0000, 'ºC'),
	(347209, 145, '2015-02-01 00:58:54.000000', 'temperatura', 613.0000, 'ºC'),
	(347210, 145, '2015-02-01 00:58:55.000000', 'temperatura', 170.0000, 'ºC'),
	(347211, 145, '2015-02-01 00:58:56.000000', 'temperatura', 210.0000, 'ºC'),
	(347212, 145, '2015-02-01 00:58:57.000000', 'temperatura', 540.0000, 'ºC'),
	(347213, 145, '2015-02-01 00:58:58.000000', 'temperatura', 870.0000, 'ºC'),
	(347214, 146, '2015-02-01 00:00:00.000000', 'temperatura', 245.0000, 'ºC'),
	(347215, 146, '2015-02-01 00:00:01.000000', 'temperatura', 233.0000, 'ºC'),
	(347216, 146, '2015-02-01 00:00:02.000000', 'temperatura', 430.0000, 'ºC'),
	(347217, 146, '2015-02-01 00:00:03.000000', 'temperatura', 252.0000, 'ºC'),
	(347218, 146, '2015-02-01 00:00:04.000000', 'temperatura', 1171.0000, 'ºC'),
	(347219, 146, '2015-02-01 00:00:05.000000', 'temperatura', 298.0000, 'ºC'),
	(347220, 146, '2015-02-01 00:00:06.000000', 'temperatura', 379.0000, 'ºC'),
	(347221, 146, '2015-02-01 00:00:07.000000', 'temperatura', 1000.0000, 'ºC'),
	(347222, 146, '2015-02-01 00:00:08.000000', 'temperatura', 266.0000, 'ºC'),
	(347223, 146, '2015-02-01 00:00:09.000000', 'temperatura', 728.0000, 'ºC'),
	(347224, 146, '2015-02-01 00:00:10.000000', 'temperatura', 444.0000, 'ºC'),
	(347225, 146, '2015-02-01 00:00:11.000000', 'temperatura', 36.0000, 'ºC'),
	(347226, 146, '2015-02-01 00:00:12.000000', 'temperatura', 47.0000, 'ºC'),
	(347227, 146, '2015-02-01 00:00:13.000000', 'temperatura', 130.0000, 'ºC'),
	(347228, 146, '2015-02-01 00:00:14.000000', 'temperatura', 510.0000, 'ºC'),
	(347229, 146, '2015-02-01 00:00:15.000000', 'temperatura', 961.0000, 'ºC'),
	(347230, 146, '2015-02-01 00:00:16.000000', 'temperatura', 873.0000, 'ºC'),
	(347231, 146, '2015-02-01 00:00:17.000000', 'temperatura', 284.0000, 'ºC'),
	(347232, 146, '2015-02-01 00:00:18.000000', 'temperatura', 1199.0000, 'ºC'),
	(347233, 146, '2015-02-01 00:00:19.000000', 'temperatura', 346.0000, 'ºC'),
	(347234, 146, '2015-02-01 00:00:20.000000', 'temperatura', 535.0000, 'ºC'),
	(347235, 146, '2015-02-01 00:00:21.000000', 'temperatura', 435.0000, 'ºC'),
	(347236, 146, '2015-02-01 00:00:22.000000', 'temperatura', 571.0000, 'ºC'),
	(347237, 146, '2015-02-01 00:00:23.000000', 'temperatura', 352.0000, 'ºC'),
	(347238, 146, '2015-02-01 00:00:24.000000', 'temperatura', 47.0000, 'ºC'),
	(347239, 146, '2015-02-01 00:00:25.000000', 'temperatura', 381.0000, 'ºC'),
	(347240, 146, '2015-02-01 00:00:26.000000', 'temperatura', 562.0000, 'ºC'),
	(347241, 146, '2015-02-01 00:00:27.000000', 'temperatura', 469.0000, 'ºC'),
	(347242, 146, '2015-02-01 00:00:28.000000', 'temperatura', 659.0000, 'ºC'),
	(347243, 146, '2015-02-01 00:00:29.000000', 'temperatura', 687.0000, 'ºC'),
	(347244, 146, '2015-02-01 00:00:30.000000', 'temperatura', 261.0000, 'ºC'),
	(347245, 146, '2015-02-01 00:00:31.000000', 'temperatura', 443.0000, 'ºC'),
	(347246, 146, '2015-02-01 00:00:32.000000', 'temperatura', 234.0000, 'ºC'),
	(347247, 146, '2015-02-01 00:00:33.000000', 'temperatura', 1042.0000, 'ºC'),
	(347248, 146, '2015-02-01 00:00:34.000000', 'temperatura', 909.0000, 'ºC'),
	(347249, 146, '2015-02-01 00:00:35.000000', 'temperatura', 220.0000, 'ºC'),
	(347250, 146, '2015-02-01 00:00:36.000000', 'temperatura', 774.0000, 'ºC'),
	(347251, 146, '2015-02-01 00:00:37.000000', 'temperatura', 808.0000, 'ºC'),
	(347252, 146, '2015-02-01 00:00:38.000000', 'temperatura', 519.0000, 'ºC'),
	(347253, 146, '2015-02-01 00:00:39.000000', 'temperatura', 170.0000, 'ºC'),
	(347254, 146, '2015-02-01 00:00:40.000000', 'temperatura', 497.0000, 'ºC'),
	(347255, 146, '2015-02-01 00:00:41.000000', 'temperatura', 772.0000, 'ºC'),
	(347256, 146, '2015-02-01 00:00:42.000000', 'temperatura', 1171.0000, 'ºC'),
	(347257, 146, '2015-02-01 00:00:43.000000', 'temperatura', 1139.0000, 'ºC'),
	(347258, 146, '2015-02-01 00:00:44.000000', 'temperatura', 984.0000, 'ºC'),
	(347259, 146, '2015-02-01 00:00:45.000000', 'temperatura', 304.0000, 'ºC'),
	(347260, 146, '2015-02-01 00:00:46.000000', 'temperatura', 970.0000, 'ºC'),
	(347261, 146, '2015-02-01 00:00:47.000000', 'temperatura', 335.0000, 'ºC'),
	(347262, 146, '2015-02-01 00:00:48.000000', 'temperatura', 1165.0000, 'ºC'),
	(347263, 146, '2015-02-01 00:00:49.000000', 'temperatura', 24.0000, 'ºC'),
	(347264, 146, '2015-02-01 00:00:50.000000', 'temperatura', 223.0000, 'ºC'),
	(347265, 146, '2015-02-01 00:00:51.000000', 'temperatura', 1046.0000, 'ºC'),
	(347266, 146, '2015-02-01 00:00:52.000000', 'temperatura', 958.0000, 'ºC'),
	(347267, 146, '2015-02-01 00:00:53.000000', 'temperatura', 455.0000, 'ºC'),
	(347268, 146, '2015-02-01 00:00:54.000000', 'temperatura', 603.0000, 'ºC'),
	(347269, 146, '2015-02-01 00:00:55.000000', 'temperatura', 448.0000, 'ºC'),
	(347270, 146, '2015-02-01 00:00:56.000000', 'temperatura', 431.0000, 'ºC'),
	(347271, 146, '2015-02-01 00:00:57.000000', 'temperatura', 810.0000, 'ºC'),
	(347272, 146, '2015-02-01 00:00:58.000000', 'temperatura', 360.0000, 'ºC'),
	(347273, 146, '2015-02-01 00:00:59.000000', 'temperatura', 571.0000, 'ºC'),
	(347274, 146, '2015-02-01 00:01:00.000000', 'temperatura', 573.0000, 'ºC'),
	(347275, 146, '2015-02-01 00:01:01.000000', 'temperatura', 1154.0000, 'ºC'),
	(347276, 146, '2015-02-01 00:01:02.000000', 'temperatura', 450.0000, 'ºC'),
	(347277, 146, '2015-02-01 00:01:03.000000', 'temperatura', 1191.0000, 'ºC'),
	(347278, 146, '2015-02-01 00:01:04.000000', 'temperatura', 1005.0000, 'ºC'),
	(347279, 146, '2015-02-01 00:01:05.000000', 'temperatura', 251.0000, 'ºC'),
	(347280, 146, '2015-02-01 00:01:06.000000', 'temperatura', 642.0000, 'ºC'),
	(347281, 146, '2015-02-01 00:01:07.000000', 'temperatura', 58.0000, 'ºC'),
	(347282, 146, '2015-02-01 00:01:08.000000', 'temperatura', 764.0000, 'ºC'),
	(347283, 146, '2015-02-01 00:01:09.000000', 'temperatura', 47.0000, 'ºC'),
	(347284, 146, '2015-02-01 00:01:10.000000', 'temperatura', 341.0000, 'ºC'),
	(347285, 146, '2015-02-01 00:01:11.000000', 'temperatura', 368.0000, 'ºC'),
	(347286, 146, '2015-02-01 00:01:12.000000', 'temperatura', 816.0000, 'ºC'),
	(347287, 146, '2015-02-01 00:01:13.000000', 'temperatura', 577.0000, 'ºC'),
	(347288, 146, '2015-02-01 00:01:14.000000', 'temperatura', 439.0000, 'ºC'),
	(347289, 146, '2015-02-01 00:01:15.000000', 'temperatura', 463.0000, 'ºC'),
	(347290, 146, '2015-02-01 00:01:16.000000', 'temperatura', 999.0000, 'ºC'),
	(347291, 146, '2015-02-01 00:01:17.000000', 'temperatura', 7.0000, 'ºC'),
	(347292, 146, '2015-02-01 00:01:18.000000', 'temperatura', 636.0000, 'ºC'),
	(347293, 146, '2015-02-01 00:01:19.000000', 'temperatura', 761.0000, 'ºC'),
	(347294, 146, '2015-02-01 00:01:20.000000', 'temperatura', 698.0000, 'ºC'),
	(347295, 146, '2015-02-01 00:01:21.000000', 'temperatura', 8.0000, 'ºC'),
	(347296, 146, '2015-02-01 00:01:22.000000', 'temperatura', 347.0000, 'ºC'),
	(347297, 146, '2015-02-01 00:01:23.000000', 'temperatura', 511.0000, 'ºC'),
	(347298, 146, '2015-02-01 00:01:24.000000', 'temperatura', 314.0000, 'ºC'),
	(347299, 146, '2015-02-01 00:01:25.000000', 'temperatura', 37.0000, 'ºC'),
	(347300, 146, '2015-02-01 00:01:26.000000', 'temperatura', 443.0000, 'ºC'),
	(347301, 146, '2015-02-01 00:01:27.000000', 'temperatura', 907.0000, 'ºC'),
	(347302, 146, '2015-02-01 00:01:28.000000', 'temperatura', 804.0000, 'ºC'),
	(347303, 146, '2015-02-01 00:01:29.000000', 'temperatura', 99.0000, 'ºC'),
	(347304, 146, '2015-02-01 00:01:30.000000', 'temperatura', 483.0000, 'ºC'),
	(347305, 146, '2015-02-01 00:01:31.000000', 'temperatura', 920.0000, 'ºC'),
	(347306, 146, '2015-02-01 00:01:32.000000', 'temperatura', 749.0000, 'ºC'),
	(347307, 146, '2015-02-01 00:01:33.000000', 'temperatura', 987.0000, 'ºC'),
	(347308, 146, '2015-02-01 00:01:34.000000', 'temperatura', 289.0000, 'ºC'),
	(347309, 146, '2015-02-01 00:01:35.000000', 'temperatura', 883.0000, 'ºC'),
	(347310, 146, '2015-02-01 00:01:36.000000', 'temperatura', 1151.0000, 'ºC'),
	(347311, 146, '2015-02-01 00:01:37.000000', 'temperatura', 703.0000, 'ºC'),
	(347312, 146, '2015-02-01 00:01:38.000000', 'temperatura', 65.0000, 'ºC'),
	(347313, 146, '2015-02-01 00:01:39.000000', 'temperatura', 618.0000, 'ºC'),
	(347314, 146, '2015-02-01 00:01:40.000000', 'temperatura', 492.0000, 'ºC'),
	(347315, 146, '2015-02-01 00:01:41.000000', 'temperatura', 609.0000, 'ºC'),
	(347316, 146, '2015-02-01 00:01:42.000000', 'temperatura', 370.0000, 'ºC'),
	(347317, 146, '2015-02-01 00:01:43.000000', 'temperatura', 24.0000, 'ºC'),
	(347318, 146, '2015-02-01 00:01:44.000000', 'temperatura', 210.0000, 'ºC'),
	(347319, 146, '2015-02-01 00:01:45.000000', 'temperatura', 978.0000, 'ºC'),
	(347320, 146, '2015-02-01 00:01:46.000000', 'temperatura', 662.0000, 'ºC'),
	(347321, 146, '2015-02-01 00:01:47.000000', 'temperatura', 378.0000, 'ºC'),
	(347322, 146, '2015-02-01 00:01:48.000000', 'temperatura', 1101.0000, 'ºC'),
	(347323, 146, '2015-02-01 00:01:49.000000', 'temperatura', 772.0000, 'ºC'),
	(347324, 146, '2015-02-01 00:01:50.000000', 'temperatura', 558.0000, 'ºC'),
	(347325, 146, '2015-02-01 00:01:51.000000', 'temperatura', 473.0000, 'ºC'),
	(347326, 146, '2015-02-01 00:01:52.000000', 'temperatura', 692.0000, 'ºC'),
	(347327, 146, '2015-02-01 00:01:53.000000', 'temperatura', 844.0000, 'ºC'),
	(347328, 146, '2015-02-01 00:01:54.000000', 'temperatura', 941.0000, 'ºC'),
	(347329, 146, '2015-02-01 00:01:55.000000', 'temperatura', 975.0000, 'ºC'),
	(347330, 146, '2015-02-01 00:01:56.000000', 'temperatura', 853.0000, 'ºC'),
	(347331, 146, '2015-02-01 00:01:57.000000', 'temperatura', 139.0000, 'ºC'),
	(347332, 146, '2015-02-01 00:01:58.000000', 'temperatura', 539.0000, 'ºC'),
	(347333, 146, '2015-02-01 00:01:59.000000', 'temperatura', 1078.0000, 'ºC'),
	(347334, 146, '2015-02-01 00:02:00.000000', 'temperatura', 174.0000, 'ºC'),
	(347335, 146, '2015-02-01 00:02:01.000000', 'temperatura', 37.0000, 'ºC'),
	(347336, 146, '2015-02-01 00:02:02.000000', 'temperatura', 863.0000, 'ºC'),
	(347337, 146, '2015-02-01 00:02:03.000000', 'temperatura', 603.0000, 'ºC'),
	(347338, 146, '2015-02-01 00:02:04.000000', 'temperatura', 429.0000, 'ºC'),
	(347339, 146, '2015-02-01 00:02:05.000000', 'temperatura', 337.0000, 'ºC'),
	(347340, 146, '2015-02-01 00:02:06.000000', 'temperatura', 395.0000, 'ºC'),
	(347341, 146, '2015-02-01 00:02:07.000000', 'temperatura', 968.0000, 'ºC'),
	(347342, 146, '2015-02-01 00:02:08.000000', 'temperatura', 53.0000, 'ºC'),
	(347343, 146, '2015-02-01 00:02:09.000000', 'temperatura', 963.0000, 'ºC'),
	(347344, 146, '2015-02-01 00:02:10.000000', 'temperatura', 1055.0000, 'ºC'),
	(347345, 146, '2015-02-01 00:02:11.000000', 'temperatura', 1188.0000, 'ºC'),
	(347346, 146, '2015-02-01 00:02:12.000000', 'temperatura', 375.0000, 'ºC'),
	(347347, 146, '2015-02-01 00:02:13.000000', 'temperatura', 712.0000, 'ºC'),
	(347348, 146, '2015-02-01 00:02:14.000000', 'temperatura', 37.0000, 'ºC'),
	(347349, 146, '2015-02-01 00:02:15.000000', 'temperatura', 449.0000, 'ºC'),
	(347350, 146, '2015-02-01 00:02:16.000000', 'temperatura', 933.0000, 'ºC'),
	(347351, 146, '2015-02-01 00:02:17.000000', 'temperatura', 919.0000, 'ºC'),
	(347352, 146, '2015-02-01 00:02:18.000000', 'temperatura', 598.0000, 'ºC'),
	(347353, 146, '2015-02-01 00:02:19.000000', 'temperatura', 234.0000, 'ºC'),
	(347354, 146, '2015-02-01 00:02:20.000000', 'temperatura', 575.0000, 'ºC'),
	(347355, 146, '2015-02-01 00:02:21.000000', 'temperatura', 972.0000, 'ºC'),
	(347356, 146, '2015-02-01 00:02:22.000000', 'temperatura', 736.0000, 'ºC'),
	(347357, 146, '2015-02-01 00:02:23.000000', 'temperatura', 767.0000, 'ºC'),
	(347358, 146, '2015-02-01 00:02:24.000000', 'temperatura', 425.0000, 'ºC'),
	(347359, 146, '2015-02-01 00:02:25.000000', 'temperatura', 1023.0000, 'ºC'),
	(347360, 146, '2015-02-01 00:02:26.000000', 'temperatura', 244.0000, 'ºC'),
	(347361, 146, '2015-02-01 00:02:27.000000', 'temperatura', 550.0000, 'ºC'),
	(347362, 146, '2015-02-01 00:02:28.000000', 'temperatura', 819.0000, 'ºC'),
	(347363, 146, '2015-02-01 00:02:29.000000', 'temperatura', 44.0000, 'ºC'),
	(347364, 146, '2015-02-01 00:02:30.000000', 'temperatura', 164.0000, 'ºC'),
	(347365, 146, '2015-02-01 00:02:31.000000', 'temperatura', 687.0000, 'ºC'),
	(347366, 146, '2015-02-01 00:02:32.000000', 'temperatura', 543.0000, 'ºC'),
	(347367, 146, '2015-02-01 00:02:33.000000', 'temperatura', 656.0000, 'ºC'),
	(347368, 146, '2015-02-01 00:02:34.000000', 'temperatura', 453.0000, 'ºC'),
	(347369, 146, '2015-02-01 00:02:35.000000', 'temperatura', 297.0000, 'ºC'),
	(347370, 146, '2015-02-01 00:02:36.000000', 'temperatura', 127.0000, 'ºC'),
	(347371, 146, '2015-02-01 00:02:37.000000', 'temperatura', 946.0000, 'ºC'),
	(347372, 146, '2015-02-01 00:02:38.000000', 'temperatura', 746.0000, 'ºC'),
	(347373, 146, '2015-02-01 00:02:39.000000', 'temperatura', 894.0000, 'ºC'),
	(347374, 146, '2015-02-01 00:02:40.000000', 'temperatura', 1034.0000, 'ºC'),
	(347375, 146, '2015-02-01 00:02:41.000000', 'temperatura', 85.0000, 'ºC'),
	(347376, 146, '2015-02-01 00:02:42.000000', 'temperatura', 927.0000, 'ºC'),
	(347377, 146, '2015-02-01 00:02:43.000000', 'temperatura', 778.0000, 'ºC'),
	(347378, 146, '2015-02-01 00:02:44.000000', 'temperatura', 1110.0000, 'ºC'),
	(347379, 146, '2015-02-01 00:02:45.000000', 'temperatura', 818.0000, 'ºC'),
	(347380, 146, '2015-02-01 00:02:46.000000', 'temperatura', 761.0000, 'ºC'),
	(347381, 146, '2015-02-01 00:02:47.000000', 'temperatura', 149.0000, 'ºC'),
	(347382, 146, '2015-02-01 00:02:48.000000', 'temperatura', 866.0000, 'ºC'),
	(347383, 146, '2015-02-01 00:02:49.000000', 'temperatura', 280.0000, 'ºC'),
	(347384, 146, '2015-02-01 00:02:50.000000', 'temperatura', 6.0000, 'ºC'),
	(347385, 146, '2015-02-01 00:02:51.000000', 'temperatura', 388.0000, 'ºC'),
	(347386, 146, '2015-02-01 00:02:52.000000', 'temperatura', 721.0000, 'ºC'),
	(347387, 146, '2015-02-01 00:02:53.000000', 'temperatura', 44.0000, 'ºC'),
	(347388, 146, '2015-02-01 00:02:54.000000', 'temperatura', 455.0000, 'ºC'),
	(347389, 146, '2015-02-01 00:02:55.000000', 'temperatura', 946.0000, 'ºC'),
	(347390, 146, '2015-02-01 00:02:56.000000', 'temperatura', 963.0000, 'ºC'),
	(347391, 146, '2015-02-01 00:02:57.000000', 'temperatura', 777.0000, 'ºC'),
	(347392, 146, '2015-02-01 00:02:58.000000', 'temperatura', 999.0000, 'ºC'),
	(347393, 146, '2015-02-01 00:02:59.000000', 'temperatura', 262.0000, 'ºC'),
	(347394, 146, '2015-02-01 00:03:00.000000', 'temperatura', 713.0000, 'ºC'),
	(347395, 146, '2015-02-01 00:03:01.000000', 'temperatura', 381.0000, 'ºC'),
	(347396, 146, '2015-02-01 00:03:02.000000', 'temperatura', 966.0000, 'ºC'),
	(347397, 146, '2015-02-01 00:03:03.000000', 'temperatura', 88.0000, 'ºC'),
	(347398, 146, '2015-02-01 00:03:04.000000', 'temperatura', 1143.0000, 'ºC'),
	(347399, 146, '2015-02-01 00:03:05.000000', 'temperatura', 649.0000, 'ºC'),
	(347400, 146, '2015-02-01 00:03:06.000000', 'temperatura', 1020.0000, 'ºC'),
	(347401, 146, '2015-02-01 00:03:07.000000', 'temperatura', 751.0000, 'ºC'),
	(347402, 146, '2015-02-01 00:03:08.000000', 'temperatura', 698.0000, 'ºC'),
	(347403, 146, '2015-02-01 00:03:09.000000', 'temperatura', 35.0000, 'ºC'),
	(347404, 146, '2015-02-01 00:03:10.000000', 'temperatura', 483.0000, 'ºC'),
	(347405, 146, '2015-02-01 00:03:11.000000', 'temperatura', 1111.0000, 'ºC'),
	(347406, 146, '2015-02-01 00:03:12.000000', 'temperatura', 507.0000, 'ºC'),
	(347407, 146, '2015-02-01 00:03:13.000000', 'temperatura', 403.0000, 'ºC'),
	(347408, 146, '2015-02-01 00:03:14.000000', 'temperatura', 494.0000, 'ºC'),
	(347409, 146, '2015-02-01 00:03:15.000000', 'temperatura', 62.0000, 'ºC'),
	(347410, 146, '2015-02-01 00:03:16.000000', 'temperatura', 28.0000, 'ºC'),
	(347411, 146, '2015-02-01 00:03:17.000000', 'temperatura', 1155.0000, 'ºC'),
	(347412, 146, '2015-02-01 00:03:18.000000', 'temperatura', 890.0000, 'ºC'),
	(347413, 146, '2015-02-01 00:03:19.000000', 'temperatura', 985.0000, 'ºC'),
	(347414, 146, '2015-02-01 00:03:20.000000', 'temperatura', 1058.0000, 'ºC'),
	(347415, 146, '2015-02-01 00:03:21.000000', 'temperatura', 1136.0000, 'ºC'),
	(347416, 146, '2015-02-01 00:03:22.000000', 'temperatura', 106.0000, 'ºC'),
	(347417, 146, '2015-02-01 00:03:23.000000', 'temperatura', 723.0000, 'ºC'),
	(347418, 146, '2015-02-01 00:03:24.000000', 'temperatura', 896.0000, 'ºC'),
	(347419, 146, '2015-02-01 00:03:25.000000', 'temperatura', 1112.0000, 'ºC'),
	(347420, 146, '2015-02-01 00:03:26.000000', 'temperatura', 471.0000, 'ºC'),
	(347421, 146, '2015-02-01 00:03:27.000000', 'temperatura', 221.0000, 'ºC'),
	(347422, 146, '2015-02-01 00:03:28.000000', 'temperatura', 891.0000, 'ºC'),
	(347423, 146, '2015-02-01 00:03:29.000000', 'temperatura', 195.0000, 'ºC'),
	(347424, 146, '2015-02-01 00:03:30.000000', 'temperatura', 702.0000, 'ºC'),
	(347425, 146, '2015-02-01 00:03:31.000000', 'temperatura', 524.0000, 'ºC'),
	(347426, 146, '2015-02-01 00:03:32.000000', 'temperatura', 514.0000, 'ºC'),
	(347427, 146, '2015-02-01 00:03:33.000000', 'temperatura', 998.0000, 'ºC'),
	(347428, 146, '2015-02-01 00:03:34.000000', 'temperatura', 1048.0000, 'ºC'),
	(347429, 146, '2015-02-01 00:03:35.000000', 'temperatura', 1049.0000, 'ºC'),
	(347430, 146, '2015-02-01 00:03:36.000000', 'temperatura', 901.0000, 'ºC'),
	(347431, 146, '2015-02-01 00:03:37.000000', 'temperatura', 157.0000, 'ºC'),
	(347432, 146, '2015-02-01 00:03:38.000000', 'temperatura', 483.0000, 'ºC'),
	(347433, 146, '2015-02-01 00:03:39.000000', 'temperatura', 743.0000, 'ºC'),
	(347434, 146, '2015-02-01 00:03:40.000000', 'temperatura', 1067.0000, 'ºC'),
	(347435, 146, '2015-02-01 00:03:41.000000', 'temperatura', 708.0000, 'ºC'),
	(347436, 146, '2015-02-01 00:03:42.000000', 'temperatura', 339.0000, 'ºC'),
	(347437, 146, '2015-02-01 00:03:43.000000', 'temperatura', 770.0000, 'ºC'),
	(347438, 146, '2015-02-01 00:03:44.000000', 'temperatura', 435.0000, 'ºC'),
	(347439, 146, '2015-02-01 00:03:45.000000', 'temperatura', 1066.0000, 'ºC'),
	(347440, 146, '2015-02-01 00:03:46.000000', 'temperatura', 425.0000, 'ºC'),
	(347441, 146, '2015-02-01 00:03:47.000000', 'temperatura', 128.0000, 'ºC'),
	(347442, 146, '2015-02-01 00:03:48.000000', 'temperatura', 564.0000, 'ºC'),
	(347443, 146, '2015-02-01 00:03:49.000000', 'temperatura', 37.0000, 'ºC'),
	(347444, 146, '2015-02-01 00:03:50.000000', 'temperatura', 893.0000, 'ºC'),
	(347445, 146, '2015-02-01 00:03:51.000000', 'temperatura', 754.0000, 'ºC'),
	(347446, 146, '2015-02-01 00:03:52.000000', 'temperatura', 1093.0000, 'ºC'),
	(347447, 146, '2015-02-01 00:03:53.000000', 'temperatura', 803.0000, 'ºC'),
	(347448, 146, '2015-02-01 00:03:54.000000', 'temperatura', 734.0000, 'ºC'),
	(347449, 146, '2015-02-01 00:03:55.000000', 'temperatura', 65.0000, 'ºC'),
	(347450, 146, '2015-02-01 00:03:56.000000', 'temperatura', 522.0000, 'ºC'),
	(347451, 146, '2015-02-01 00:03:57.000000', 'temperatura', 15.0000, 'ºC'),
	(347452, 146, '2015-02-01 00:03:58.000000', 'temperatura', 910.0000, 'ºC'),
	(347453, 146, '2015-02-01 00:03:59.000000', 'temperatura', 907.0000, 'ºC'),
	(347454, 146, '2015-02-01 00:04:00.000000', 'temperatura', 604.0000, 'ºC'),
	(347455, 146, '2015-02-01 00:04:01.000000', 'temperatura', 299.0000, 'ºC'),
	(347456, 146, '2015-02-01 00:04:02.000000', 'temperatura', 884.0000, 'ºC'),
	(347457, 146, '2015-02-01 00:04:03.000000', 'temperatura', 1124.0000, 'ºC'),
	(347458, 146, '2015-02-01 00:04:04.000000', 'temperatura', 570.0000, 'ºC'),
	(347459, 146, '2015-02-01 00:04:05.000000', 'temperatura', 677.0000, 'ºC'),
	(347460, 146, '2015-02-01 00:04:06.000000', 'temperatura', 474.0000, 'ºC'),
	(347461, 146, '2015-02-01 00:04:07.000000', 'temperatura', 340.0000, 'ºC'),
	(347462, 146, '2015-02-01 00:04:08.000000', 'temperatura', 280.0000, 'ºC'),
	(347463, 146, '2015-02-01 00:04:09.000000', 'temperatura', 381.0000, 'ºC'),
	(347464, 146, '2015-02-01 00:04:10.000000', 'temperatura', 1063.0000, 'ºC'),
	(347465, 146, '2015-02-01 00:04:11.000000', 'temperatura', 575.0000, 'ºC'),
	(347466, 146, '2015-02-01 00:04:12.000000', 'temperatura', 886.0000, 'ºC'),
	(347467, 146, '2015-02-01 00:04:13.000000', 'temperatura', 303.0000, 'ºC'),
	(347468, 146, '2015-02-01 00:04:14.000000', 'temperatura', 60.0000, 'ºC'),
	(347469, 146, '2015-02-01 00:04:15.000000', 'temperatura', 590.0000, 'ºC'),
	(347470, 146, '2015-02-01 00:04:16.000000', 'temperatura', 373.0000, 'ºC'),
	(347471, 146, '2015-02-01 00:04:17.000000', 'temperatura', 93.0000, 'ºC'),
	(347472, 146, '2015-02-01 00:04:18.000000', 'temperatura', 546.0000, 'ºC'),
	(347473, 146, '2015-02-01 00:04:19.000000', 'temperatura', 53.0000, 'ºC'),
	(347474, 146, '2015-02-01 00:04:20.000000', 'temperatura', 1025.0000, 'ºC'),
	(347475, 146, '2015-02-01 00:04:21.000000', 'temperatura', 169.0000, 'ºC'),
	(347476, 146, '2015-02-01 00:04:22.000000', 'temperatura', 168.0000, 'ºC'),
	(347477, 146, '2015-02-01 00:04:23.000000', 'temperatura', 335.0000, 'ºC'),
	(347478, 146, '2015-02-01 00:04:24.000000', 'temperatura', 1170.0000, 'ºC'),
	(347479, 146, '2015-02-01 00:04:25.000000', 'temperatura', 48.0000, 'ºC'),
	(347480, 146, '2015-02-01 00:04:26.000000', 'temperatura', 329.0000, 'ºC'),
	(347481, 146, '2015-02-01 00:04:27.000000', 'temperatura', 304.0000, 'ºC'),
	(347482, 146, '2015-02-01 00:04:28.000000', 'temperatura', 530.0000, 'ºC'),
	(347483, 146, '2015-02-01 00:04:29.000000', 'temperatura', 539.0000, 'ºC'),
	(347484, 146, '2015-02-01 00:04:30.000000', 'temperatura', 1108.0000, 'ºC'),
	(347485, 146, '2015-02-01 00:04:31.000000', 'temperatura', 322.0000, 'ºC'),
	(347486, 146, '2015-02-01 00:04:32.000000', 'temperatura', 687.0000, 'ºC'),
	(347487, 146, '2015-02-01 00:04:33.000000', 'temperatura', 71.0000, 'ºC'),
	(347488, 146, '2015-02-01 00:04:34.000000', 'temperatura', 694.0000, 'ºC'),
	(347489, 146, '2015-02-01 00:04:35.000000', 'temperatura', 858.0000, 'ºC'),
	(347490, 146, '2015-02-01 00:04:36.000000', 'temperatura', 1007.0000, 'ºC'),
	(347491, 146, '2015-02-01 00:04:37.000000', 'temperatura', 61.0000, 'ºC'),
	(347492, 146, '2015-02-01 00:04:38.000000', 'temperatura', 884.0000, 'ºC'),
	(347493, 146, '2015-02-01 00:04:39.000000', 'temperatura', 637.0000, 'ºC'),
	(347494, 146, '2015-02-01 00:04:40.000000', 'temperatura', 532.0000, 'ºC'),
	(347495, 146, '2015-02-01 00:04:41.000000', 'temperatura', 753.0000, 'ºC'),
	(347496, 146, '2015-02-01 00:04:42.000000', 'temperatura', 969.0000, 'ºC'),
	(347497, 146, '2015-02-01 00:04:43.000000', 'temperatura', 185.0000, 'ºC'),
	(347498, 146, '2015-02-01 00:04:44.000000', 'temperatura', 419.0000, 'ºC'),
	(347499, 146, '2015-02-01 00:04:45.000000', 'temperatura', 340.0000, 'ºC'),
	(347500, 146, '2015-02-01 00:04:46.000000', 'temperatura', 446.0000, 'ºC'),
	(347501, 146, '2015-02-01 00:04:47.000000', 'temperatura', 8.0000, 'ºC'),
	(347502, 146, '2015-02-01 00:04:48.000000', 'temperatura', 1104.0000, 'ºC'),
	(347503, 146, '2015-02-01 00:04:49.000000', 'temperatura', 695.0000, 'ºC'),
	(347504, 146, '2015-02-01 00:04:50.000000', 'temperatura', 162.0000, 'ºC'),
	(347505, 146, '2015-02-01 00:04:51.000000', 'temperatura', 1128.0000, 'ºC'),
	(347506, 146, '2015-02-01 00:04:52.000000', 'temperatura', 356.0000, 'ºC'),
	(347507, 146, '2015-02-01 00:04:53.000000', 'temperatura', 794.0000, 'ºC'),
	(347508, 146, '2015-02-01 00:04:54.000000', 'temperatura', 504.0000, 'ºC'),
	(347509, 146, '2015-02-01 00:04:55.000000', 'temperatura', 138.0000, 'ºC'),
	(347510, 146, '2015-02-01 00:04:56.000000', 'temperatura', 377.0000, 'ºC'),
	(347511, 146, '2015-02-01 00:04:57.000000', 'temperatura', 272.0000, 'ºC'),
	(347512, 146, '2015-02-01 00:04:58.000000', 'temperatura', 228.0000, 'ºC'),
	(347513, 146, '2015-02-01 00:04:59.000000', 'temperatura', 326.0000, 'ºC'),
	(347514, 146, '2015-02-01 00:05:00.000000', 'temperatura', 948.0000, 'ºC'),
	(347515, 146, '2015-02-01 00:05:01.000000', 'temperatura', 161.0000, 'ºC'),
	(347516, 146, '2015-02-01 00:05:02.000000', 'temperatura', 360.0000, 'ºC'),
	(347517, 146, '2015-02-01 00:05:03.000000', 'temperatura', 118.0000, 'ºC'),
	(347518, 146, '2015-02-01 00:05:04.000000', 'temperatura', 709.0000, 'ºC'),
	(347519, 146, '2015-02-01 00:05:05.000000', 'temperatura', 793.0000, 'ºC'),
	(347520, 146, '2015-02-01 00:05:06.000000', 'temperatura', 638.0000, 'ºC'),
	(347521, 146, '2015-02-01 00:05:07.000000', 'temperatura', 810.0000, 'ºC'),
	(347522, 146, '2015-02-01 00:05:08.000000', 'temperatura', 939.0000, 'ºC'),
	(347523, 146, '2015-02-01 00:05:09.000000', 'temperatura', 1066.0000, 'ºC'),
	(347524, 146, '2015-02-01 00:05:10.000000', 'temperatura', 113.0000, 'ºC'),
	(347525, 146, '2015-02-01 00:05:11.000000', 'temperatura', 969.0000, 'ºC'),
	(347526, 146, '2015-02-01 00:05:12.000000', 'temperatura', 905.0000, 'ºC'),
	(347527, 146, '2015-02-01 00:05:13.000000', 'temperatura', 417.0000, 'ºC'),
	(347528, 146, '2015-02-01 00:05:14.000000', 'temperatura', 571.0000, 'ºC'),
	(347529, 146, '2015-02-01 00:05:15.000000', 'temperatura', 405.0000, 'ºC'),
	(347530, 146, '2015-02-01 00:05:16.000000', 'temperatura', 312.0000, 'ºC'),
	(347531, 146, '2015-02-01 00:05:17.000000', 'temperatura', 346.0000, 'ºC'),
	(347532, 146, '2015-02-01 00:05:18.000000', 'temperatura', 793.0000, 'ºC'),
	(347533, 146, '2015-02-01 00:05:19.000000', 'temperatura', 527.0000, 'ºC'),
	(347534, 146, '2015-02-01 00:05:20.000000', 'temperatura', 257.0000, 'ºC'),
	(347535, 146, '2015-02-01 00:05:21.000000', 'temperatura', 903.0000, 'ºC'),
	(347536, 146, '2015-02-01 00:05:22.000000', 'temperatura', 145.0000, 'ºC'),
	(347537, 146, '2015-02-01 00:05:23.000000', 'temperatura', 416.0000, 'ºC'),
	(347538, 146, '2015-02-01 00:05:24.000000', 'temperatura', 445.0000, 'ºC'),
	(347539, 146, '2015-02-01 00:05:25.000000', 'temperatura', 980.0000, 'ºC'),
	(347540, 146, '2015-02-01 00:05:26.000000', 'temperatura', 1162.0000, 'ºC'),
	(347541, 146, '2015-02-01 00:05:27.000000', 'temperatura', 473.0000, 'ºC'),
	(347542, 146, '2015-02-01 00:05:28.000000', 'temperatura', 80.0000, 'ºC'),
	(347543, 146, '2015-02-01 00:05:29.000000', 'temperatura', 180.0000, 'ºC'),
	(347544, 146, '2015-02-01 00:05:30.000000', 'temperatura', 660.0000, 'ºC'),
	(347545, 146, '2015-02-01 00:05:31.000000', 'temperatura', 363.0000, 'ºC'),
	(347546, 146, '2015-02-01 00:05:32.000000', 'temperatura', 1032.0000, 'ºC'),
	(347547, 146, '2015-02-01 00:05:33.000000', 'temperatura', 474.0000, 'ºC'),
	(347548, 146, '2015-02-01 00:05:34.000000', 'temperatura', 475.0000, 'ºC'),
	(347549, 146, '2015-02-01 00:05:35.000000', 'temperatura', 954.0000, 'ºC'),
	(347550, 146, '2015-02-01 00:05:36.000000', 'temperatura', 943.0000, 'ºC'),
	(347551, 146, '2015-02-01 00:05:37.000000', 'temperatura', 655.0000, 'ºC'),
	(347552, 146, '2015-02-01 00:05:38.000000', 'temperatura', 445.0000, 'ºC'),
	(347553, 146, '2015-02-01 00:05:39.000000', 'temperatura', 262.0000, 'ºC'),
	(347554, 146, '2015-02-01 00:05:40.000000', 'temperatura', 1173.0000, 'ºC'),
	(347555, 146, '2015-02-01 00:05:41.000000', 'temperatura', 283.0000, 'ºC'),
	(347556, 146, '2015-02-01 00:05:42.000000', 'temperatura', 294.0000, 'ºC'),
	(347557, 146, '2015-02-01 00:05:43.000000', 'temperatura', 622.0000, 'ºC'),
	(347558, 146, '2015-02-01 00:05:44.000000', 'temperatura', 1030.0000, 'ºC'),
	(347559, 146, '2015-02-01 00:05:45.000000', 'temperatura', 884.0000, 'ºC'),
	(347560, 146, '2015-02-01 00:05:46.000000', 'temperatura', 130.0000, 'ºC'),
	(347561, 146, '2015-02-01 00:05:47.000000', 'temperatura', 399.0000, 'ºC'),
	(347562, 146, '2015-02-01 00:05:48.000000', 'temperatura', 407.0000, 'ºC'),
	(347563, 146, '2015-02-01 00:05:49.000000', 'temperatura', 838.0000, 'ºC'),
	(347564, 146, '2015-02-01 00:05:50.000000', 'temperatura', 569.0000, 'ºC'),
	(347565, 146, '2015-02-01 00:05:51.000000', 'temperatura', 333.0000, 'ºC'),
	(347566, 146, '2015-02-01 00:05:52.000000', 'temperatura', 1157.0000, 'ºC'),
	(347567, 146, '2015-02-01 00:05:53.000000', 'temperatura', 1188.0000, 'ºC'),
	(347568, 146, '2015-02-01 00:05:54.000000', 'temperatura', 67.0000, 'ºC'),
	(347569, 146, '2015-02-01 00:05:55.000000', 'temperatura', 373.0000, 'ºC'),
	(347570, 146, '2015-02-01 00:05:56.000000', 'temperatura', 462.0000, 'ºC'),
	(347571, 146, '2015-02-01 00:05:57.000000', 'temperatura', 1195.0000, 'ºC'),
	(347572, 146, '2015-02-01 00:05:58.000000', 'temperatura', 987.0000, 'ºC'),
	(347573, 146, '2015-02-01 00:05:59.000000', 'temperatura', 150.0000, 'ºC'),
	(347574, 146, '2015-02-01 00:06:00.000000', 'temperatura', 190.0000, 'ºC'),
	(347575, 146, '2015-02-01 00:06:01.000000', 'temperatura', 503.0000, 'ºC'),
	(347576, 146, '2015-02-01 00:06:02.000000', 'temperatura', 743.0000, 'ºC'),
	(347577, 146, '2015-02-01 00:06:03.000000', 'temperatura', 1005.0000, 'ºC'),
	(347578, 146, '2015-02-01 00:06:04.000000', 'temperatura', 398.0000, 'ºC'),
	(347579, 146, '2015-02-01 00:06:05.000000', 'temperatura', 177.0000, 'ºC'),
	(347580, 146, '2015-02-01 00:06:06.000000', 'temperatura', 891.0000, 'ºC'),
	(347581, 146, '2015-02-01 00:06:07.000000', 'temperatura', 324.0000, 'ºC'),
	(347582, 146, '2015-02-01 00:06:08.000000', 'temperatura', 146.0000, 'ºC'),
	(347583, 146, '2015-02-01 00:06:09.000000', 'temperatura', 962.0000, 'ºC'),
	(347584, 146, '2015-02-01 00:06:10.000000', 'temperatura', 769.0000, 'ºC'),
	(347585, 146, '2015-02-01 00:06:11.000000', 'temperatura', 960.0000, 'ºC'),
	(347586, 146, '2015-02-01 00:06:12.000000', 'temperatura', 96.0000, 'ºC'),
	(347587, 146, '2015-02-01 00:06:13.000000', 'temperatura', 1199.0000, 'ºC'),
	(347588, 146, '2015-02-01 00:06:14.000000', 'temperatura', 908.0000, 'ºC'),
	(347589, 146, '2015-02-01 00:06:15.000000', 'temperatura', 941.0000, 'ºC'),
	(347590, 146, '2015-02-01 00:06:16.000000', 'temperatura', 784.0000, 'ºC'),
	(347591, 146, '2015-02-01 00:06:17.000000', 'temperatura', 1095.0000, 'ºC'),
	(347592, 146, '2015-02-01 00:06:18.000000', 'temperatura', 725.0000, 'ºC'),
	(347593, 146, '2015-02-01 00:06:19.000000', 'temperatura', 342.0000, 'ºC'),
	(347594, 146, '2015-02-01 00:06:20.000000', 'temperatura', 734.0000, 'ºC'),
	(347595, 146, '2015-02-01 00:06:21.000000', 'temperatura', 243.0000, 'ºC'),
	(347596, 146, '2015-02-01 00:06:22.000000', 'temperatura', 214.0000, 'ºC'),
	(347597, 146, '2015-02-01 00:06:23.000000', 'temperatura', 343.0000, 'ºC'),
	(347598, 146, '2015-02-01 00:06:24.000000', 'temperatura', 1075.0000, 'ºC'),
	(347599, 146, '2015-02-01 00:06:25.000000', 'temperatura', 743.0000, 'ºC'),
	(347600, 146, '2015-02-01 00:06:26.000000', 'temperatura', 491.0000, 'ºC'),
	(347601, 146, '2015-02-01 00:06:27.000000', 'temperatura', 229.0000, 'ºC'),
	(347602, 146, '2015-02-01 00:06:28.000000', 'temperatura', 870.0000, 'ºC'),
	(347603, 146, '2015-02-01 00:06:29.000000', 'temperatura', 64.0000, 'ºC'),
	(347604, 146, '2015-02-01 00:06:30.000000', 'temperatura', 113.0000, 'ºC'),
	(347605, 146, '2015-02-01 00:06:31.000000', 'temperatura', 371.0000, 'ºC'),
	(347606, 146, '2015-02-01 00:06:32.000000', 'temperatura', 316.0000, 'ºC'),
	(347607, 146, '2015-02-01 00:06:33.000000', 'temperatura', 466.0000, 'ºC'),
	(347608, 146, '2015-02-01 00:06:34.000000', 'temperatura', 185.0000, 'ºC'),
	(347609, 146, '2015-02-01 00:06:35.000000', 'temperatura', 728.0000, 'ºC'),
	(347610, 146, '2015-02-01 00:06:36.000000', 'temperatura', 683.0000, 'ºC'),
	(347611, 146, '2015-02-01 00:06:37.000000', 'temperatura', 34.0000, 'ºC'),
	(347612, 146, '2015-02-01 00:06:38.000000', 'temperatura', 519.0000, 'ºC'),
	(347613, 146, '2015-02-01 00:06:39.000000', 'temperatura', 95.0000, 'ºC'),
	(347614, 146, '2015-02-01 00:06:40.000000', 'temperatura', 117.0000, 'ºC'),
	(347615, 146, '2015-02-01 00:06:41.000000', 'temperatura', 302.0000, 'ºC'),
	(347616, 146, '2015-02-01 00:06:42.000000', 'temperatura', 1159.0000, 'ºC'),
	(347617, 146, '2015-02-01 00:06:43.000000', 'temperatura', 89.0000, 'ºC'),
	(347618, 146, '2015-02-01 00:06:44.000000', 'temperatura', 570.0000, 'ºC'),
	(347619, 146, '2015-02-01 00:06:45.000000', 'temperatura', 184.0000, 'ºC'),
	(347620, 146, '2015-02-01 00:06:46.000000', 'temperatura', 409.0000, 'ºC'),
	(347621, 146, '2015-02-01 00:06:47.000000', 'temperatura', 292.0000, 'ºC'),
	(347622, 146, '2015-02-01 00:06:48.000000', 'temperatura', 235.0000, 'ºC'),
	(347623, 146, '2015-02-01 00:06:49.000000', 'temperatura', 299.0000, 'ºC'),
	(347624, 146, '2015-02-01 00:06:50.000000', 'temperatura', 791.0000, 'ºC'),
	(347625, 146, '2015-02-01 00:06:51.000000', 'temperatura', 659.0000, 'ºC'),
	(347626, 146, '2015-02-01 00:06:52.000000', 'temperatura', 923.0000, 'ºC'),
	(347627, 146, '2015-02-01 00:06:53.000000', 'temperatura', 238.0000, 'ºC'),
	(347628, 146, '2015-02-01 00:06:54.000000', 'temperatura', 823.0000, 'ºC'),
	(347629, 146, '2015-02-01 00:06:55.000000', 'temperatura', 999.0000, 'ºC'),
	(347630, 146, '2015-02-01 00:06:56.000000', 'temperatura', 129.0000, 'ºC'),
	(347631, 146, '2015-02-01 00:06:57.000000', 'temperatura', 46.0000, 'ºC'),
	(347632, 146, '2015-02-01 00:06:58.000000', 'temperatura', 1043.0000, 'ºC'),
	(347633, 146, '2015-02-01 00:06:59.000000', 'temperatura', 278.0000, 'ºC'),
	(347634, 146, '2015-02-01 00:07:00.000000', 'temperatura', 662.0000, 'ºC'),
	(347635, 146, '2015-02-01 00:07:01.000000', 'temperatura', 77.0000, 'ºC'),
	(347636, 146, '2015-02-01 00:07:02.000000', 'temperatura', 797.0000, 'ºC'),
	(347637, 146, '2015-02-01 00:07:03.000000', 'temperatura', 158.0000, 'ºC'),
	(347638, 146, '2015-02-01 00:07:04.000000', 'temperatura', 797.0000, 'ºC'),
	(347639, 146, '2015-02-01 00:07:05.000000', 'temperatura', 1113.0000, 'ºC'),
	(347640, 146, '2015-02-01 00:07:06.000000', 'temperatura', 772.0000, 'ºC'),
	(347641, 146, '2015-02-01 00:07:07.000000', 'temperatura', 523.0000, 'ºC'),
	(347642, 146, '2015-02-01 00:07:08.000000', 'temperatura', 301.0000, 'ºC'),
	(347643, 146, '2015-02-01 00:07:09.000000', 'temperatura', 1136.0000, 'ºC'),
	(347644, 146, '2015-02-01 00:07:10.000000', 'temperatura', 1176.0000, 'ºC'),
	(347645, 146, '2015-02-01 00:07:11.000000', 'temperatura', 74.0000, 'ºC'),
	(347646, 146, '2015-02-01 00:07:12.000000', 'temperatura', 440.0000, 'ºC'),
	(347647, 146, '2015-02-01 00:07:13.000000', 'temperatura', 781.0000, 'ºC'),
	(347648, 146, '2015-02-01 00:07:14.000000', 'temperatura', 183.0000, 'ºC'),
	(347649, 146, '2015-02-01 00:07:15.000000', 'temperatura', 974.0000, 'ºC'),
	(347650, 146, '2015-02-01 00:07:16.000000', 'temperatura', 722.0000, 'ºC'),
	(347651, 146, '2015-02-01 00:07:17.000000', 'temperatura', 690.0000, 'ºC'),
	(347652, 146, '2015-02-01 00:07:18.000000', 'temperatura', 82.0000, 'ºC'),
	(347653, 146, '2015-02-01 00:07:19.000000', 'temperatura', 742.0000, 'ºC'),
	(347654, 146, '2015-02-01 00:07:20.000000', 'temperatura', 1066.0000, 'ºC'),
	(347655, 146, '2015-02-01 00:07:21.000000', 'temperatura', 702.0000, 'ºC'),
	(347656, 146, '2015-02-01 00:07:22.000000', 'temperatura', 314.0000, 'ºC'),
	(347657, 146, '2015-02-01 00:07:23.000000', 'temperatura', 665.0000, 'ºC'),
	(347658, 146, '2015-02-01 00:07:24.000000', 'temperatura', 1183.0000, 'ºC'),
	(347659, 146, '2015-02-01 00:07:25.000000', 'temperatura', 321.0000, 'ºC'),
	(347660, 146, '2015-02-01 00:07:26.000000', 'temperatura', 456.0000, 'ºC'),
	(347661, 146, '2015-02-01 00:07:27.000000', 'temperatura', 116.0000, 'ºC'),
	(347662, 146, '2015-02-01 00:07:28.000000', 'temperatura', 415.0000, 'ºC'),
	(347663, 146, '2015-02-01 00:07:29.000000', 'temperatura', 525.0000, 'ºC'),
	(347664, 146, '2015-02-01 00:07:30.000000', 'temperatura', 180.0000, 'ºC'),
	(347665, 146, '2015-02-01 00:07:31.000000', 'temperatura', 527.0000, 'ºC'),
	(347666, 146, '2015-02-01 00:07:32.000000', 'temperatura', 897.0000, 'ºC'),
	(347667, 146, '2015-02-01 00:07:33.000000', 'temperatura', 502.0000, 'ºC'),
	(347668, 146, '2015-02-01 00:07:34.000000', 'temperatura', 1022.0000, 'ºC'),
	(347669, 146, '2015-02-01 00:07:35.000000', 'temperatura', 2.0000, 'ºC'),
	(347670, 146, '2015-02-01 00:07:36.000000', 'temperatura', 544.0000, 'ºC'),
	(347671, 146, '2015-02-01 00:07:37.000000', 'temperatura', 314.0000, 'ºC'),
	(347672, 146, '2015-02-01 00:07:38.000000', 'temperatura', 1141.0000, 'ºC'),
	(347673, 146, '2015-02-01 00:07:39.000000', 'temperatura', 1161.0000, 'ºC'),
	(347674, 146, '2015-02-01 00:07:40.000000', 'temperatura', 1184.0000, 'ºC'),
	(347675, 146, '2015-02-01 00:07:41.000000', 'temperatura', 38.0000, 'ºC'),
	(347676, 146, '2015-02-01 00:07:42.000000', 'temperatura', 240.0000, 'ºC'),
	(347677, 146, '2015-02-01 00:07:43.000000', 'temperatura', 1083.0000, 'ºC'),
	(347678, 146, '2015-02-01 00:07:44.000000', 'temperatura', 1097.0000, 'ºC'),
	(347679, 146, '2015-02-01 00:07:45.000000', 'temperatura', 1035.0000, 'ºC'),
	(347680, 146, '2015-02-01 00:07:46.000000', 'temperatura', 686.0000, 'ºC'),
	(347681, 146, '2015-02-01 00:07:47.000000', 'temperatura', 324.0000, 'ºC'),
	(347682, 146, '2015-02-01 00:07:48.000000', 'temperatura', 762.0000, 'ºC'),
	(347683, 146, '2015-02-01 00:07:49.000000', 'temperatura', 441.0000, 'ºC'),
	(347684, 146, '2015-02-01 00:07:50.000000', 'temperatura', 1119.0000, 'ºC'),
	(347685, 146, '2015-02-01 00:07:51.000000', 'temperatura', 673.0000, 'ºC'),
	(347686, 146, '2015-02-01 00:07:52.000000', 'temperatura', 9.0000, 'ºC'),
	(347687, 146, '2015-02-01 00:07:53.000000', 'temperatura', 426.0000, 'ºC'),
	(347688, 146, '2015-02-01 00:07:54.000000', 'temperatura', 902.0000, 'ºC'),
	(347689, 146, '2015-02-01 00:07:55.000000', 'temperatura', 833.0000, 'ºC'),
	(347690, 146, '2015-02-01 00:07:56.000000', 'temperatura', 258.0000, 'ºC'),
	(347691, 146, '2015-02-01 00:07:57.000000', 'temperatura', 1193.0000, 'ºC'),
	(347692, 146, '2015-02-01 00:07:58.000000', 'temperatura', 390.0000, 'ºC'),
	(347693, 146, '2015-02-01 00:07:59.000000', 'temperatura', 770.0000, 'ºC'),
	(347694, 146, '2015-02-01 00:08:00.000000', 'temperatura', 284.0000, 'ºC'),
	(347695, 146, '2015-02-01 00:08:01.000000', 'temperatura', 310.0000, 'ºC'),
	(347696, 146, '2015-02-01 00:08:02.000000', 'temperatura', 699.0000, 'ºC'),
	(347697, 146, '2015-02-01 00:08:03.000000', 'temperatura', 166.0000, 'ºC'),
	(347698, 146, '2015-02-01 00:08:04.000000', 'temperatura', 1132.0000, 'ºC'),
	(347699, 146, '2015-02-01 00:08:05.000000', 'temperatura', 363.0000, 'ºC'),
	(347700, 146, '2015-02-01 00:08:06.000000', 'temperatura', 819.0000, 'ºC'),
	(347701, 146, '2015-02-01 00:08:07.000000', 'temperatura', 607.0000, 'ºC'),
	(347702, 146, '2015-02-01 00:08:08.000000', 'temperatura', 578.0000, 'ºC'),
	(347703, 146, '2015-02-01 00:08:09.000000', 'temperatura', 1072.0000, 'ºC'),
	(347704, 146, '2015-02-01 00:08:10.000000', 'temperatura', 23.0000, 'ºC'),
	(347705, 146, '2015-02-01 00:08:11.000000', 'temperatura', 502.0000, 'ºC'),
	(347706, 146, '2015-02-01 00:08:12.000000', 'temperatura', 42.0000, 'ºC'),
	(347707, 146, '2015-02-01 00:08:13.000000', 'temperatura', 1103.0000, 'ºC'),
	(347708, 146, '2015-02-01 00:08:14.000000', 'temperatura', 589.0000, 'ºC'),
	(347709, 146, '2015-02-01 00:08:15.000000', 'temperatura', 838.0000, 'ºC'),
	(347710, 146, '2015-02-01 00:08:16.000000', 'temperatura', 23.0000, 'ºC'),
	(347711, 146, '2015-02-01 00:08:17.000000', 'temperatura', 1.0000, 'ºC'),
	(347712, 146, '2015-02-01 00:08:18.000000', 'temperatura', 1139.0000, 'ºC'),
	(347713, 146, '2015-02-01 00:08:19.000000', 'temperatura', 890.0000, 'ºC'),
	(347714, 146, '2015-02-01 00:08:20.000000', 'temperatura', 1033.0000, 'ºC'),
	(347715, 146, '2015-02-01 00:08:21.000000', 'temperatura', 95.0000, 'ºC'),
	(347716, 146, '2015-02-01 00:08:22.000000', 'temperatura', 978.0000, 'ºC'),
	(347717, 146, '2015-02-01 00:08:23.000000', 'temperatura', 1006.0000, 'ºC'),
	(347718, 146, '2015-02-01 00:08:24.000000', 'temperatura', 896.0000, 'ºC'),
	(347719, 146, '2015-02-01 00:08:25.000000', 'temperatura', 263.0000, 'ºC'),
	(347720, 146, '2015-02-01 00:08:26.000000', 'temperatura', 1027.0000, 'ºC'),
	(347721, 146, '2015-02-01 00:08:27.000000', 'temperatura', 749.0000, 'ºC'),
	(347722, 146, '2015-02-01 00:08:28.000000', 'temperatura', 661.0000, 'ºC'),
	(347723, 146, '2015-02-01 00:08:29.000000', 'temperatura', 1059.0000, 'ºC'),
	(347724, 146, '2015-02-01 00:08:30.000000', 'temperatura', 915.0000, 'ºC'),
	(347725, 146, '2015-02-01 00:08:31.000000', 'temperatura', 195.0000, 'ºC'),
	(347726, 146, '2015-02-01 00:08:32.000000', 'temperatura', 632.0000, 'ºC'),
	(347727, 146, '2015-02-01 00:08:33.000000', 'temperatura', 177.0000, 'ºC'),
	(347728, 146, '2015-02-01 00:08:34.000000', 'temperatura', 187.0000, 'ºC'),
	(347729, 146, '2015-02-01 00:08:35.000000', 'temperatura', 408.0000, 'ºC'),
	(347730, 146, '2015-02-01 00:08:36.000000', 'temperatura', 276.0000, 'ºC'),
	(347731, 146, '2015-02-01 00:08:37.000000', 'temperatura', 156.0000, 'ºC'),
	(347732, 146, '2015-02-01 00:08:38.000000', 'temperatura', 1155.0000, 'ºC'),
	(347733, 146, '2015-02-01 00:08:39.000000', 'temperatura', 507.0000, 'ºC'),
	(347734, 146, '2015-02-01 00:08:40.000000', 'temperatura', 268.0000, 'ºC'),
	(347735, 146, '2015-02-01 00:08:41.000000', 'temperatura', 1022.0000, 'ºC'),
	(347736, 146, '2015-02-01 00:08:42.000000', 'temperatura', 708.0000, 'ºC'),
	(347737, 146, '2015-02-01 00:08:43.000000', 'temperatura', 472.0000, 'ºC'),
	(347738, 146, '2015-02-01 00:08:44.000000', 'temperatura', 237.0000, 'ºC'),
	(347739, 146, '2015-02-01 00:08:45.000000', 'temperatura', 972.0000, 'ºC'),
	(347740, 146, '2015-02-01 00:08:46.000000', 'temperatura', 546.0000, 'ºC'),
	(347741, 146, '2015-02-01 00:08:47.000000', 'temperatura', 1017.0000, 'ºC'),
	(347742, 146, '2015-02-01 00:08:48.000000', 'temperatura', 1047.0000, 'ºC'),
	(347743, 146, '2015-02-01 00:08:49.000000', 'temperatura', 982.0000, 'ºC'),
	(347744, 146, '2015-02-01 00:08:50.000000', 'temperatura', 572.0000, 'ºC'),
	(347745, 146, '2015-02-01 00:08:51.000000', 'temperatura', 1113.0000, 'ºC'),
	(347746, 146, '2015-02-01 00:08:52.000000', 'temperatura', 250.0000, 'ºC'),
	(347747, 146, '2015-02-01 00:08:53.000000', 'temperatura', 311.0000, 'ºC'),
	(347748, 146, '2015-02-01 00:08:54.000000', 'temperatura', 806.0000, 'ºC'),
	(347749, 146, '2015-02-01 00:08:55.000000', 'temperatura', 699.0000, 'ºC'),
	(347750, 146, '2015-02-01 00:08:56.000000', 'temperatura', 1077.0000, 'ºC'),
	(347751, 146, '2015-02-01 00:08:57.000000', 'temperatura', 887.0000, 'ºC'),
	(347752, 146, '2015-02-01 00:08:58.000000', 'temperatura', 4.0000, 'ºC'),
	(347753, 146, '2015-02-01 00:08:59.000000', 'temperatura', 962.0000, 'ºC'),
	(347754, 146, '2015-02-01 00:09:00.000000', 'temperatura', 1195.0000, 'ºC'),
	(347755, 146, '2015-02-01 00:09:01.000000', 'temperatura', 693.0000, 'ºC'),
	(347756, 146, '2015-02-01 00:09:02.000000', 'temperatura', 1078.0000, 'ºC'),
	(347757, 146, '2015-02-01 00:09:03.000000', 'temperatura', 911.0000, 'ºC'),
	(347758, 146, '2015-02-01 00:09:04.000000', 'temperatura', 121.0000, 'ºC'),
	(347759, 146, '2015-02-01 00:09:05.000000', 'temperatura', 274.0000, 'ºC'),
	(347760, 146, '2015-02-01 00:09:06.000000', 'temperatura', 1009.0000, 'ºC'),
	(347761, 146, '2015-02-01 00:09:07.000000', 'temperatura', 623.0000, 'ºC'),
	(347762, 146, '2015-02-01 00:09:08.000000', 'temperatura', 90.0000, 'ºC'),
	(347763, 146, '2015-02-01 00:09:09.000000', 'temperatura', 980.0000, 'ºC'),
	(347764, 146, '2015-02-01 00:09:10.000000', 'temperatura', 1033.0000, 'ºC'),
	(347765, 146, '2015-02-01 00:09:11.000000', 'temperatura', 1022.0000, 'ºC'),
	(347766, 146, '2015-02-01 00:09:12.000000', 'temperatura', 812.0000, 'ºC'),
	(347767, 146, '2015-02-01 00:09:13.000000', 'temperatura', 994.0000, 'ºC'),
	(347768, 146, '2015-02-01 00:09:14.000000', 'temperatura', 136.0000, 'ºC'),
	(347769, 146, '2015-02-01 00:09:15.000000', 'temperatura', 96.0000, 'ºC'),
	(347770, 146, '2015-02-01 00:09:16.000000', 'temperatura', 73.0000, 'ºC'),
	(347771, 146, '2015-02-01 00:09:17.000000', 'temperatura', 79.0000, 'ºC'),
	(347772, 146, '2015-02-01 00:09:18.000000', 'temperatura', 176.0000, 'ºC'),
	(347773, 146, '2015-02-01 00:09:19.000000', 'temperatura', 645.0000, 'ºC'),
	(347774, 146, '2015-02-01 00:09:20.000000', 'temperatura', 296.0000, 'ºC'),
	(347775, 146, '2015-02-01 00:09:21.000000', 'temperatura', 744.0000, 'ºC'),
	(347776, 146, '2015-02-01 00:09:22.000000', 'temperatura', 433.0000, 'ºC'),
	(347777, 146, '2015-02-01 00:09:23.000000', 'temperatura', 1133.0000, 'ºC'),
	(347778, 146, '2015-02-01 00:09:24.000000', 'temperatura', 767.0000, 'ºC'),
	(347779, 146, '2015-02-01 00:09:25.000000', 'temperatura', 436.0000, 'ºC'),
	(347780, 146, '2015-02-01 00:09:26.000000', 'temperatura', 1080.0000, 'ºC'),
	(347781, 146, '2015-02-01 00:09:27.000000', 'temperatura', 494.0000, 'ºC'),
	(347782, 146, '2015-02-01 00:09:28.000000', 'temperatura', 430.0000, 'ºC'),
	(347783, 146, '2015-02-01 00:09:29.000000', 'temperatura', 666.0000, 'ºC'),
	(347784, 146, '2015-02-01 00:09:30.000000', 'temperatura', 842.0000, 'ºC'),
	(347785, 146, '2015-02-01 00:09:31.000000', 'temperatura', 1014.0000, 'ºC'),
	(347786, 146, '2015-02-01 00:09:32.000000', 'temperatura', 144.0000, 'ºC'),
	(347787, 146, '2015-02-01 00:09:33.000000', 'temperatura', 80.0000, 'ºC'),
	(347788, 146, '2015-02-01 00:09:34.000000', 'temperatura', 1166.0000, 'ºC'),
	(347789, 146, '2015-02-01 00:09:35.000000', 'temperatura', 792.0000, 'ºC'),
	(347790, 146, '2015-02-01 00:09:36.000000', 'temperatura', 464.0000, 'ºC'),
	(347791, 146, '2015-02-01 00:09:37.000000', 'temperatura', 1142.0000, 'ºC'),
	(347792, 146, '2015-02-01 00:09:38.000000', 'temperatura', 720.0000, 'ºC'),
	(347793, 146, '2015-02-01 00:09:39.000000', 'temperatura', 176.0000, 'ºC'),
	(347794, 146, '2015-02-01 00:09:40.000000', 'temperatura', 1120.0000, 'ºC'),
	(347795, 146, '2015-02-01 00:09:41.000000', 'temperatura', 270.0000, 'ºC'),
	(347796, 146, '2015-02-01 00:09:42.000000', 'temperatura', 394.0000, 'ºC'),
	(347797, 146, '2015-02-01 00:09:43.000000', 'temperatura', 1158.0000, 'ºC'),
	(347798, 146, '2015-02-01 00:09:44.000000', 'temperatura', 1010.0000, 'ºC'),
	(347799, 146, '2015-02-01 00:09:45.000000', 'temperatura', 377.0000, 'ºC'),
	(347800, 146, '2015-02-01 00:09:46.000000', 'temperatura', 57.0000, 'ºC'),
	(347801, 146, '2015-02-01 00:09:47.000000', 'temperatura', 352.0000, 'ºC'),
	(347802, 146, '2015-02-01 00:09:48.000000', 'temperatura', 389.0000, 'ºC'),
	(347803, 146, '2015-02-01 00:09:49.000000', 'temperatura', 889.0000, 'ºC'),
	(347804, 146, '2015-02-01 00:09:50.000000', 'temperatura', 878.0000, 'ºC'),
	(347805, 146, '2015-02-01 00:09:51.000000', 'temperatura', 524.0000, 'ºC'),
	(347806, 146, '2015-02-01 00:09:52.000000', 'temperatura', 1187.0000, 'ºC'),
	(347807, 146, '2015-02-01 00:09:53.000000', 'temperatura', 764.0000, 'ºC'),
	(347808, 146, '2015-02-01 00:09:54.000000', 'temperatura', 257.0000, 'ºC'),
	(347809, 146, '2015-02-01 00:09:55.000000', 'temperatura', 195.0000, 'ºC'),
	(347810, 146, '2015-02-01 00:09:56.000000', 'temperatura', 207.0000, 'ºC'),
	(347811, 146, '2015-02-01 00:09:57.000000', 'temperatura', 447.0000, 'ºC'),
	(347812, 146, '2015-02-01 00:09:58.000000', 'temperatura', 414.0000, 'ºC'),
	(347813, 146, '2015-02-01 00:09:59.000000', 'temperatura', 731.0000, 'ºC'),
	(347814, 146, '2015-02-01 00:10:00.000000', 'temperatura', 14.0000, 'ºC'),
	(347815, 146, '2015-02-01 00:10:01.000000', 'temperatura', 279.0000, 'ºC'),
	(347816, 146, '2015-02-01 00:10:02.000000', 'temperatura', 152.0000, 'ºC'),
	(347817, 146, '2015-02-01 00:10:03.000000', 'temperatura', 1124.0000, 'ºC'),
	(347818, 146, '2015-02-01 00:10:04.000000', 'temperatura', 362.0000, 'ºC'),
	(347819, 146, '2015-02-01 00:10:05.000000', 'temperatura', 841.0000, 'ºC'),
	(347820, 146, '2015-02-01 00:10:06.000000', 'temperatura', 718.0000, 'ºC'),
	(347821, 146, '2015-02-01 00:10:07.000000', 'temperatura', 1070.0000, 'ºC'),
	(347822, 146, '2015-02-01 00:10:08.000000', 'temperatura', 795.0000, 'ºC'),
	(347823, 146, '2015-02-01 00:10:09.000000', 'temperatura', 766.0000, 'ºC'),
	(347824, 146, '2015-02-01 00:10:10.000000', 'temperatura', 245.0000, 'ºC'),
	(347825, 146, '2015-02-01 00:10:11.000000', 'temperatura', 128.0000, 'ºC'),
	(347826, 146, '2015-02-01 00:10:12.000000', 'temperatura', 1104.0000, 'ºC'),
	(347827, 146, '2015-02-01 00:10:13.000000', 'temperatura', 338.0000, 'ºC'),
	(347828, 146, '2015-02-01 00:10:14.000000', 'temperatura', 779.0000, 'ºC'),
	(347829, 146, '2015-02-01 00:10:15.000000', 'temperatura', 483.0000, 'ºC'),
	(347830, 146, '2015-02-01 00:10:16.000000', 'temperatura', 76.0000, 'ºC'),
	(347831, 146, '2015-02-01 00:10:17.000000', 'temperatura', 131.0000, 'ºC'),
	(347832, 146, '2015-02-01 00:10:18.000000', 'temperatura', 428.0000, 'ºC'),
	(347833, 146, '2015-02-01 00:10:19.000000', 'temperatura', 549.0000, 'ºC'),
	(347834, 146, '2015-02-01 00:10:20.000000', 'temperatura', 259.0000, 'ºC'),
	(347835, 146, '2015-02-01 00:10:21.000000', 'temperatura', 850.0000, 'ºC'),
	(347836, 146, '2015-02-01 00:10:22.000000', 'temperatura', 1075.0000, 'ºC'),
	(347837, 146, '2015-02-01 00:10:23.000000', 'temperatura', 425.0000, 'ºC'),
	(347838, 146, '2015-02-01 00:10:24.000000', 'temperatura', 101.0000, 'ºC'),
	(347839, 146, '2015-02-01 00:10:25.000000', 'temperatura', 429.0000, 'ºC'),
	(347840, 146, '2015-02-01 00:10:26.000000', 'temperatura', 645.0000, 'ºC'),
	(347841, 146, '2015-02-01 00:10:27.000000', 'temperatura', 736.0000, 'ºC'),
	(347842, 146, '2015-02-01 00:10:28.000000', 'temperatura', 547.0000, 'ºC'),
	(347843, 146, '2015-02-01 00:10:29.000000', 'temperatura', 526.0000, 'ºC'),
	(347844, 146, '2015-02-01 00:10:30.000000', 'temperatura', 991.0000, 'ºC'),
	(347845, 146, '2015-02-01 00:10:31.000000', 'temperatura', 979.0000, 'ºC'),
	(347846, 146, '2015-02-01 00:10:32.000000', 'temperatura', 720.0000, 'ºC'),
	(347847, 146, '2015-02-01 00:10:33.000000', 'temperatura', 666.0000, 'ºC'),
	(347848, 146, '2015-02-01 00:10:34.000000', 'temperatura', 1167.0000, 'ºC'),
	(347849, 146, '2015-02-01 00:10:35.000000', 'temperatura', 240.0000, 'ºC'),
	(347850, 146, '2015-02-01 00:10:36.000000', 'temperatura', 100.0000, 'ºC'),
	(347851, 146, '2015-02-01 00:10:37.000000', 'temperatura', 979.0000, 'ºC'),
	(347852, 146, '2015-02-01 00:10:38.000000', 'temperatura', 995.0000, 'ºC'),
	(347853, 146, '2015-02-01 00:10:39.000000', 'temperatura', 840.0000, 'ºC'),
	(347854, 146, '2015-02-01 00:10:40.000000', 'temperatura', 15.0000, 'ºC'),
	(347855, 146, '2015-02-01 00:10:41.000000', 'temperatura', 1154.0000, 'ºC'),
	(347856, 146, '2015-02-01 00:10:42.000000', 'temperatura', 927.0000, 'ºC'),
	(347857, 146, '2015-02-01 00:10:43.000000', 'temperatura', 1175.0000, 'ºC'),
	(347858, 146, '2015-02-01 00:10:44.000000', 'temperatura', 692.0000, 'ºC'),
	(347859, 146, '2015-02-01 00:10:45.000000', 'temperatura', 1137.0000, 'ºC'),
	(347860, 146, '2015-02-01 00:10:46.000000', 'temperatura', 7.0000, 'ºC'),
	(347861, 146, '2015-02-01 00:10:47.000000', 'temperatura', 227.0000, 'ºC'),
	(347862, 146, '2015-02-01 00:10:48.000000', 'temperatura', 1115.0000, 'ºC'),
	(347863, 146, '2015-02-01 00:10:49.000000', 'temperatura', 95.0000, 'ºC'),
	(347864, 146, '2015-02-01 00:10:50.000000', 'temperatura', 728.0000, 'ºC'),
	(347865, 146, '2015-02-01 00:10:51.000000', 'temperatura', 957.0000, 'ºC'),
	(347866, 146, '2015-02-01 00:10:52.000000', 'temperatura', 201.0000, 'ºC'),
	(347867, 146, '2015-02-01 00:10:53.000000', 'temperatura', 536.0000, 'ºC'),
	(347868, 146, '2015-02-01 00:10:54.000000', 'temperatura', 876.0000, 'ºC'),
	(347869, 146, '2015-02-01 00:10:55.000000', 'temperatura', 372.0000, 'ºC'),
	(347870, 146, '2015-02-01 00:10:56.000000', 'temperatura', 434.0000, 'ºC'),
	(347871, 146, '2015-02-01 00:10:57.000000', 'temperatura', 1054.0000, 'ºC'),
	(347872, 146, '2015-02-01 00:10:58.000000', 'temperatura', 368.0000, 'ºC'),
	(347873, 146, '2015-02-01 00:10:59.000000', 'temperatura', 1081.0000, 'ºC'),
	(347874, 146, '2015-02-01 00:11:00.000000', 'temperatura', 699.0000, 'ºC'),
	(347875, 146, '2015-02-01 00:11:01.000000', 'temperatura', 251.0000, 'ºC'),
	(347876, 146, '2015-02-01 00:11:02.000000', 'temperatura', 362.0000, 'ºC'),
	(347877, 146, '2015-02-01 00:11:03.000000', 'temperatura', 1056.0000, 'ºC'),
	(347878, 146, '2015-02-01 00:11:04.000000', 'temperatura', 593.0000, 'ºC'),
	(347879, 146, '2015-02-01 00:11:05.000000', 'temperatura', 998.0000, 'ºC'),
	(347880, 146, '2015-02-01 00:11:06.000000', 'temperatura', 810.0000, 'ºC'),
	(347881, 146, '2015-02-01 00:11:07.000000', 'temperatura', 1059.0000, 'ºC'),
	(347882, 146, '2015-02-01 00:11:08.000000', 'temperatura', 464.0000, 'ºC'),
	(347883, 146, '2015-02-01 00:11:09.000000', 'temperatura', 342.0000, 'ºC'),
	(347884, 146, '2015-02-01 00:11:10.000000', 'temperatura', 320.0000, 'ºC'),
	(347885, 146, '2015-02-01 00:11:11.000000', 'temperatura', 574.0000, 'ºC'),
	(347886, 146, '2015-02-01 00:11:12.000000', 'temperatura', 710.0000, 'ºC'),
	(347887, 146, '2015-02-01 00:11:13.000000', 'temperatura', 628.0000, 'ºC'),
	(347888, 146, '2015-02-01 00:11:14.000000', 'temperatura', 1010.0000, 'ºC'),
	(347889, 146, '2015-02-01 00:11:15.000000', 'temperatura', 769.0000, 'ºC'),
	(347890, 146, '2015-02-01 00:11:16.000000', 'temperatura', 814.0000, 'ºC'),
	(347891, 146, '2015-02-01 00:11:17.000000', 'temperatura', 562.0000, 'ºC'),
	(347892, 146, '2015-02-01 00:11:18.000000', 'temperatura', 369.0000, 'ºC'),
	(347893, 146, '2015-02-01 00:11:19.000000', 'temperatura', 161.0000, 'ºC'),
	(347894, 146, '2015-02-01 00:11:20.000000', 'temperatura', 896.0000, 'ºC'),
	(347895, 146, '2015-02-01 00:11:21.000000', 'temperatura', 399.0000, 'ºC'),
	(347896, 146, '2015-02-01 00:11:22.000000', 'temperatura', 508.0000, 'ºC'),
	(347897, 146, '2015-02-01 00:11:23.000000', 'temperatura', 141.0000, 'ºC'),
	(347898, 146, '2015-02-01 00:11:24.000000', 'temperatura', 383.0000, 'ºC'),
	(347899, 146, '2015-02-01 00:11:25.000000', 'temperatura', 291.0000, 'ºC'),
	(347900, 146, '2015-02-01 00:11:26.000000', 'temperatura', 307.0000, 'ºC'),
	(347901, 146, '2015-02-01 00:11:27.000000', 'temperatura', 661.0000, 'ºC'),
	(347902, 146, '2015-02-01 00:11:28.000000', 'temperatura', 1186.0000, 'ºC'),
	(347903, 146, '2015-02-01 00:11:29.000000', 'temperatura', 345.0000, 'ºC'),
	(347904, 146, '2015-02-01 00:11:30.000000', 'temperatura', 571.0000, 'ºC'),
	(347905, 146, '2015-02-01 00:11:31.000000', 'temperatura', 618.0000, 'ºC'),
	(347906, 146, '2015-02-01 00:11:32.000000', 'temperatura', 178.0000, 'ºC'),
	(347907, 146, '2015-02-01 00:11:33.000000', 'temperatura', 239.0000, 'ºC'),
	(347908, 146, '2015-02-01 00:11:34.000000', 'temperatura', 659.0000, 'ºC'),
	(347909, 146, '2015-02-01 00:11:35.000000', 'temperatura', 179.0000, 'ºC'),
	(347910, 146, '2015-02-01 00:11:36.000000', 'temperatura', 118.0000, 'ºC'),
	(347911, 146, '2015-02-01 00:11:37.000000', 'temperatura', 53.0000, 'ºC'),
	(347912, 146, '2015-02-01 00:11:38.000000', 'temperatura', 1111.0000, 'ºC'),
	(347913, 146, '2015-02-01 00:11:39.000000', 'temperatura', 599.0000, 'ºC'),
	(347914, 146, '2015-02-01 00:11:40.000000', 'temperatura', 863.0000, 'ºC'),
	(347915, 146, '2015-02-01 00:11:41.000000', 'temperatura', 117.0000, 'ºC'),
	(347916, 146, '2015-02-01 00:11:42.000000', 'temperatura', 396.0000, 'ºC'),
	(347917, 146, '2015-02-01 00:11:43.000000', 'temperatura', 432.0000, 'ºC'),
	(347918, 146, '2015-02-01 00:11:44.000000', 'temperatura', 969.0000, 'ºC'),
	(347919, 146, '2015-02-01 00:11:45.000000', 'temperatura', 1153.0000, 'ºC'),
	(347920, 146, '2015-02-01 00:11:46.000000', 'temperatura', 457.0000, 'ºC'),
	(347921, 146, '2015-02-01 00:11:47.000000', 'temperatura', 28.0000, 'ºC'),
	(347922, 146, '2015-02-01 00:11:48.000000', 'temperatura', 1170.0000, 'ºC'),
	(347923, 146, '2015-02-01 00:11:49.000000', 'temperatura', 966.0000, 'ºC'),
	(347924, 146, '2015-02-01 00:11:50.000000', 'temperatura', 118.0000, 'ºC'),
	(347925, 146, '2015-02-01 00:11:51.000000', 'temperatura', 96.0000, 'ºC'),
	(347926, 146, '2015-02-01 00:11:52.000000', 'temperatura', 124.0000, 'ºC'),
	(347927, 146, '2015-02-01 00:11:53.000000', 'temperatura', 334.0000, 'ºC'),
	(347928, 146, '2015-02-01 00:11:54.000000', 'temperatura', 96.0000, 'ºC'),
	(347929, 146, '2015-02-01 00:11:55.000000', 'temperatura', 681.0000, 'ºC'),
	(347930, 146, '2015-02-01 00:11:56.000000', 'temperatura', 717.0000, 'ºC'),
	(347931, 146, '2015-02-01 00:11:57.000000', 'temperatura', 343.0000, 'ºC'),
	(347932, 146, '2015-02-01 00:11:58.000000', 'temperatura', 763.0000, 'ºC'),
	(347933, 146, '2015-02-01 00:11:59.000000', 'temperatura', 387.0000, 'ºC'),
	(347934, 146, '2015-02-01 00:12:00.000000', 'temperatura', 846.0000, 'ºC'),
	(347935, 146, '2015-02-01 00:12:01.000000', 'temperatura', 669.0000, 'ºC'),
	(347936, 146, '2015-02-01 00:12:02.000000', 'temperatura', 807.0000, 'ºC'),
	(347937, 146, '2015-02-01 00:12:03.000000', 'temperatura', 827.0000, 'ºC'),
	(347938, 146, '2015-02-01 00:12:04.000000', 'temperatura', 517.0000, 'ºC'),
	(347939, 146, '2015-02-01 00:12:05.000000', 'temperatura', 104.0000, 'ºC'),
	(347940, 146, '2015-02-01 00:12:06.000000', 'temperatura', 168.0000, 'ºC'),
	(347941, 146, '2015-02-01 00:12:07.000000', 'temperatura', 531.0000, 'ºC'),
	(347942, 146, '2015-02-01 00:12:08.000000', 'temperatura', 952.0000, 'ºC'),
	(347943, 146, '2015-02-01 00:12:09.000000', 'temperatura', 767.0000, 'ºC'),
	(347944, 146, '2015-02-01 00:12:10.000000', 'temperatura', 977.0000, 'ºC'),
	(347945, 146, '2015-02-01 00:12:11.000000', 'temperatura', 188.0000, 'ºC'),
	(347946, 146, '2015-02-01 00:12:12.000000', 'temperatura', 408.0000, 'ºC'),
	(347947, 146, '2015-02-01 00:12:13.000000', 'temperatura', 275.0000, 'ºC'),
	(347948, 146, '2015-02-01 00:12:14.000000', 'temperatura', 153.0000, 'ºC'),
	(347949, 146, '2015-02-01 00:12:15.000000', 'temperatura', 1139.0000, 'ºC'),
	(347950, 146, '2015-02-01 00:12:16.000000', 'temperatura', 439.0000, 'ºC'),
	(347951, 146, '2015-02-01 00:12:17.000000', 'temperatura', 1178.0000, 'ºC'),
	(347952, 146, '2015-02-01 00:12:18.000000', 'temperatura', 973.0000, 'ºC'),
	(347953, 146, '2015-02-01 00:12:19.000000', 'temperatura', 132.0000, 'ºC'),
	(347954, 146, '2015-02-01 00:12:20.000000', 'temperatura', 143.0000, 'ºC'),
	(347955, 146, '2015-02-01 00:12:21.000000', 'temperatura', 318.0000, 'ºC'),
	(347956, 146, '2015-02-01 00:12:22.000000', 'temperatura', 1160.0000, 'ºC'),
	(347957, 146, '2015-02-01 00:12:23.000000', 'temperatura', 46.0000, 'ºC'),
	(347958, 146, '2015-02-01 00:12:24.000000', 'temperatura', 353.0000, 'ºC'),
	(347959, 146, '2015-02-01 00:12:25.000000', 'temperatura', 425.0000, 'ºC'),
	(347960, 146, '2015-02-01 00:12:26.000000', 'temperatura', 1066.0000, 'ºC'),
	(347961, 146, '2015-02-01 00:12:27.000000', 'temperatura', 458.0000, 'ºC'),
	(347962, 146, '2015-02-01 00:12:28.000000', 'temperatura', 290.0000, 'ºC'),
	(347963, 146, '2015-02-01 00:12:29.000000', 'temperatura', 80.0000, 'ºC'),
	(347964, 146, '2015-02-01 00:12:30.000000', 'temperatura', 728.0000, 'ºC'),
	(347965, 146, '2015-02-01 00:12:31.000000', 'temperatura', 999.0000, 'ºC'),
	(347966, 146, '2015-02-01 00:12:32.000000', 'temperatura', 414.0000, 'ºC'),
	(347967, 146, '2015-02-01 00:12:33.000000', 'temperatura', 272.0000, 'ºC'),
	(347968, 146, '2015-02-01 00:12:34.000000', 'temperatura', 119.0000, 'ºC'),
	(347969, 146, '2015-02-01 00:12:35.000000', 'temperatura', 979.0000, 'ºC'),
	(347970, 146, '2015-02-01 00:12:36.000000', 'temperatura', 937.0000, 'ºC'),
	(347971, 146, '2015-02-01 00:12:37.000000', 'temperatura', 549.0000, 'ºC'),
	(347972, 146, '2015-02-01 00:12:38.000000', 'temperatura', 1135.0000, 'ºC'),
	(347973, 146, '2015-02-01 00:12:39.000000', 'temperatura', 427.0000, 'ºC'),
	(347974, 146, '2015-02-01 00:12:40.000000', 'temperatura', 1133.0000, 'ºC'),
	(347975, 146, '2015-02-01 00:12:41.000000', 'temperatura', 785.0000, 'ºC'),
	(347976, 146, '2015-02-01 00:12:42.000000', 'temperatura', 524.0000, 'ºC'),
	(347977, 146, '2015-02-01 00:12:43.000000', 'temperatura', 266.0000, 'ºC'),
	(347978, 146, '2015-02-01 00:12:44.000000', 'temperatura', 957.0000, 'ºC'),
	(347979, 146, '2015-02-01 00:12:45.000000', 'temperatura', 389.0000, 'ºC'),
	(347980, 146, '2015-02-01 00:12:46.000000', 'temperatura', 275.0000, 'ºC'),
	(347981, 146, '2015-02-01 00:12:47.000000', 'temperatura', 207.0000, 'ºC'),
	(347982, 146, '2015-02-01 00:12:48.000000', 'temperatura', 211.0000, 'ºC'),
	(347983, 146, '2015-02-01 00:12:49.000000', 'temperatura', 436.0000, 'ºC'),
	(347984, 146, '2015-02-01 00:12:50.000000', 'temperatura', 346.0000, 'ºC'),
	(347985, 146, '2015-02-01 00:12:51.000000', 'temperatura', 421.0000, 'ºC'),
	(347986, 146, '2015-02-01 00:12:52.000000', 'temperatura', 1070.0000, 'ºC'),
	(347987, 146, '2015-02-01 00:12:53.000000', 'temperatura', 486.0000, 'ºC'),
	(347988, 146, '2015-02-01 00:12:54.000000', 'temperatura', 420.0000, 'ºC'),
	(347989, 146, '2015-02-01 00:12:55.000000', 'temperatura', 645.0000, 'ºC'),
	(347990, 146, '2015-02-01 00:12:56.000000', 'temperatura', 763.0000, 'ºC'),
	(347991, 146, '2015-02-01 00:12:57.000000', 'temperatura', 680.0000, 'ºC'),
	(347992, 146, '2015-02-01 00:12:58.000000', 'temperatura', 1114.0000, 'ºC'),
	(347993, 146, '2015-02-01 00:12:59.000000', 'temperatura', 1128.0000, 'ºC'),
	(347994, 146, '2015-02-01 00:13:00.000000', 'temperatura', 1098.0000, 'ºC'),
	(347995, 146, '2015-02-01 00:13:01.000000', 'temperatura', 908.0000, 'ºC'),
	(347996, 146, '2015-02-01 00:13:02.000000', 'temperatura', 47.0000, 'ºC'),
	(347997, 146, '2015-02-01 00:13:03.000000', 'temperatura', 1113.0000, 'ºC'),
	(347998, 146, '2015-02-01 00:13:04.000000', 'temperatura', 622.0000, 'ºC'),
	(347999, 146, '2015-02-01 00:13:05.000000', 'temperatura', 970.0000, 'ºC'),
	(348000, 146, '2015-02-01 00:13:06.000000', 'temperatura', 588.0000, 'ºC'),
	(348001, 146, '2015-02-01 00:13:07.000000', 'temperatura', 29.0000, 'ºC'),
	(348002, 146, '2015-02-01 00:13:08.000000', 'temperatura', 783.0000, 'ºC'),
	(348003, 146, '2015-02-01 00:13:09.000000', 'temperatura', 227.0000, 'ºC'),
	(348004, 146, '2015-02-01 00:13:10.000000', 'temperatura', 1186.0000, 'ºC'),
	(348005, 146, '2015-02-01 00:13:11.000000', 'temperatura', 451.0000, 'ºC'),
	(348006, 146, '2015-02-01 00:13:12.000000', 'temperatura', 1097.0000, 'ºC'),
	(348007, 146, '2015-02-01 00:13:13.000000', 'temperatura', 534.0000, 'ºC'),
	(348008, 146, '2015-02-01 00:13:14.000000', 'temperatura', 577.0000, 'ºC'),
	(348009, 146, '2015-02-01 00:13:15.000000', 'temperatura', 83.0000, 'ºC'),
	(348010, 146, '2015-02-01 00:13:16.000000', 'temperatura', 1086.0000, 'ºC'),
	(348011, 146, '2015-02-01 00:13:17.000000', 'temperatura', 380.0000, 'ºC'),
	(348012, 146, '2015-02-01 00:13:18.000000', 'temperatura', 1044.0000, 'ºC'),
	(348013, 146, '2015-02-01 00:13:19.000000', 'temperatura', 479.0000, 'ºC'),
	(348014, 146, '2015-02-01 00:13:20.000000', 'temperatura', 465.0000, 'ºC'),
	(348015, 146, '2015-02-01 00:13:21.000000', 'temperatura', 886.0000, 'ºC'),
	(348016, 146, '2015-02-01 00:13:22.000000', 'temperatura', 637.0000, 'ºC'),
	(348017, 146, '2015-02-01 00:13:23.000000', 'temperatura', 526.0000, 'ºC'),
	(348018, 146, '2015-02-01 00:13:24.000000', 'temperatura', 719.0000, 'ºC'),
	(348019, 146, '2015-02-01 00:13:25.000000', 'temperatura', 819.0000, 'ºC'),
	(348020, 146, '2015-02-01 00:13:26.000000', 'temperatura', 737.0000, 'ºC'),
	(348021, 146, '2015-02-01 00:13:27.000000', 'temperatura', 30.0000, 'ºC'),
	(348022, 146, '2015-02-01 00:13:28.000000', 'temperatura', 339.0000, 'ºC'),
	(348023, 146, '2015-02-01 00:13:29.000000', 'temperatura', 404.0000, 'ºC'),
	(348024, 146, '2015-02-01 00:13:30.000000', 'temperatura', 1006.0000, 'ºC'),
	(348025, 146, '2015-02-01 00:13:31.000000', 'temperatura', 217.0000, 'ºC'),
	(348026, 146, '2015-02-01 00:13:32.000000', 'temperatura', 468.0000, 'ºC'),
	(348027, 146, '2015-02-01 00:13:33.000000', 'temperatura', 488.0000, 'ºC'),
	(348028, 146, '2015-02-01 00:13:34.000000', 'temperatura', 1038.0000, 'ºC'),
	(348029, 146, '2015-02-01 00:13:35.000000', 'temperatura', 126.0000, 'ºC'),
	(348030, 146, '2015-02-01 00:13:36.000000', 'temperatura', 1117.0000, 'ºC'),
	(348031, 146, '2015-02-01 00:13:37.000000', 'temperatura', 407.0000, 'ºC'),
	(348032, 146, '2015-02-01 00:13:38.000000', 'temperatura', 1083.0000, 'ºC'),
	(348033, 146, '2015-02-01 00:13:39.000000', 'temperatura', 594.0000, 'ºC'),
	(348034, 146, '2015-02-01 00:13:40.000000', 'temperatura', 924.0000, 'ºC'),
	(348035, 146, '2015-02-01 00:13:41.000000', 'temperatura', 438.0000, 'ºC'),
	(348036, 146, '2015-02-01 00:13:42.000000', 'temperatura', 617.0000, 'ºC'),
	(348037, 146, '2015-02-01 00:13:43.000000', 'temperatura', 573.0000, 'ºC'),
	(348038, 146, '2015-02-01 00:13:44.000000', 'temperatura', 1016.0000, 'ºC'),
	(348039, 146, '2015-02-01 00:13:45.000000', 'temperatura', 961.0000, 'ºC'),
	(348040, 146, '2015-02-01 00:13:46.000000', 'temperatura', 555.0000, 'ºC'),
	(348041, 146, '2015-02-01 00:13:47.000000', 'temperatura', 1094.0000, 'ºC'),
	(348042, 146, '2015-02-01 00:13:48.000000', 'temperatura', 207.0000, 'ºC'),
	(348043, 146, '2015-02-01 00:13:49.000000', 'temperatura', 152.0000, 'ºC'),
	(348044, 146, '2015-02-01 00:13:50.000000', 'temperatura', 139.0000, 'ºC'),
	(348045, 146, '2015-02-01 00:13:51.000000', 'temperatura', 241.0000, 'ºC'),
	(348046, 146, '2015-02-01 00:13:52.000000', 'temperatura', 788.0000, 'ºC'),
	(348047, 146, '2015-02-01 00:13:53.000000', 'temperatura', 819.0000, 'ºC'),
	(348048, 146, '2015-02-01 00:13:54.000000', 'temperatura', 530.0000, 'ºC'),
	(348049, 146, '2015-02-01 00:13:55.000000', 'temperatura', 194.0000, 'ºC'),
	(348050, 146, '2015-02-01 00:13:56.000000', 'temperatura', 580.0000, 'ºC'),
	(348051, 146, '2015-02-01 00:13:57.000000', 'temperatura', 1118.0000, 'ºC'),
	(348052, 146, '2015-02-01 00:13:58.000000', 'temperatura', 250.0000, 'ºC'),
	(348053, 146, '2015-02-01 00:13:59.000000', 'temperatura', 298.0000, 'ºC'),
	(348054, 146, '2015-02-01 00:14:00.000000', 'temperatura', 738.0000, 'ºC'),
	(348055, 146, '2015-02-01 00:14:01.000000', 'temperatura', 397.0000, 'ºC'),
	(348056, 146, '2015-02-01 00:14:02.000000', 'temperatura', 974.0000, 'ºC'),
	(348057, 146, '2015-02-01 00:14:03.000000', 'temperatura', 78.0000, 'ºC'),
	(348058, 146, '2015-02-01 00:14:04.000000', 'temperatura', 1071.0000, 'ºC'),
	(348059, 146, '2015-02-01 00:14:05.000000', 'temperatura', 318.0000, 'ºC'),
	(348060, 146, '2015-02-01 00:14:06.000000', 'temperatura', 780.0000, 'ºC'),
	(348061, 146, '2015-02-01 00:14:07.000000', 'temperatura', 546.0000, 'ºC'),
	(348062, 146, '2015-02-01 00:14:08.000000', 'temperatura', 389.0000, 'ºC'),
	(348063, 146, '2015-02-01 00:14:09.000000', 'temperatura', 310.0000, 'ºC'),
	(348064, 146, '2015-02-01 00:14:10.000000', 'temperatura', 383.0000, 'ºC'),
	(348065, 146, '2015-02-01 00:14:11.000000', 'temperatura', 984.0000, 'ºC'),
	(348066, 146, '2015-02-01 00:14:12.000000', 'temperatura', 172.0000, 'ºC'),
	(348067, 146, '2015-02-01 00:14:13.000000', 'temperatura', 309.0000, 'ºC'),
	(348068, 146, '2015-02-01 00:14:14.000000', 'temperatura', 1031.0000, 'ºC'),
	(348069, 146, '2015-02-01 00:14:15.000000', 'temperatura', 626.0000, 'ºC'),
	(348070, 146, '2015-02-01 00:14:16.000000', 'temperatura', 37.0000, 'ºC'),
	(348071, 146, '2015-02-01 00:14:17.000000', 'temperatura', 710.0000, 'ºC'),
	(348072, 146, '2015-02-01 00:14:18.000000', 'temperatura', 1037.0000, 'ºC'),
	(348073, 146, '2015-02-01 00:14:19.000000', 'temperatura', 658.0000, 'ºC'),
	(348074, 146, '2015-02-01 00:14:20.000000', 'temperatura', 178.0000, 'ºC'),
	(348075, 146, '2015-02-01 00:14:21.000000', 'temperatura', 118.0000, 'ºC'),
	(348076, 146, '2015-02-01 00:14:22.000000', 'temperatura', 54.0000, 'ºC'),
	(348077, 146, '2015-02-01 00:14:23.000000', 'temperatura', 1119.0000, 'ºC'),
	(348078, 146, '2015-02-01 00:14:24.000000', 'temperatura', 633.0000, 'ºC'),
	(348079, 146, '2015-02-01 00:14:25.000000', 'temperatura', 1007.0000, 'ºC'),
	(348080, 146, '2015-02-01 00:14:26.000000', 'temperatura', 737.0000, 'ºC'),
	(348081, 146, '2015-02-01 00:14:27.000000', 'temperatura', 665.0000, 'ºC'),
	(348082, 146, '2015-02-01 00:14:28.000000', 'temperatura', 1116.0000, 'ºC'),
	(348083, 146, '2015-02-01 00:14:29.000000', 'temperatura', 1186.0000, 'ºC'),
	(348084, 146, '2015-02-01 00:14:30.000000', 'temperatura', 181.0000, 'ºC'),
	(348085, 146, '2015-02-01 00:14:31.000000', 'temperatura', 947.0000, 'ºC'),
	(348086, 146, '2015-02-01 00:14:32.000000', 'temperatura', 595.0000, 'ºC'),
	(348087, 146, '2015-02-01 00:14:33.000000', 'temperatura', 132.0000, 'ºC'),
	(348088, 146, '2015-02-01 00:14:34.000000', 'temperatura', 74.0000, 'ºC'),
	(348089, 146, '2015-02-01 00:14:35.000000', 'temperatura', 1177.0000, 'ºC'),
	(348090, 146, '2015-02-01 00:14:36.000000', 'temperatura', 863.0000, 'ºC'),
	(348091, 146, '2015-02-01 00:14:37.000000', 'temperatura', 784.0000, 'ºC'),
	(348092, 146, '2015-02-01 00:14:38.000000', 'temperatura', 132.0000, 'ºC'),
	(348093, 146, '2015-02-01 00:14:39.000000', 'temperatura', 708.0000, 'ºC'),
	(348094, 146, '2015-02-01 00:14:40.000000', 'temperatura', 747.0000, 'ºC'),
	(348095, 146, '2015-02-01 00:14:41.000000', 'temperatura', 409.0000, 'ºC'),
	(348096, 146, '2015-02-01 00:14:42.000000', 'temperatura', 1004.0000, 'ºC'),
	(348097, 146, '2015-02-01 00:14:43.000000', 'temperatura', 192.0000, 'ºC'),
	(348098, 146, '2015-02-01 00:14:44.000000', 'temperatura', 352.0000, 'ºC'),
	(348099, 146, '2015-02-01 00:14:45.000000', 'temperatura', 1184.0000, 'ºC'),
	(348100, 146, '2015-02-01 00:14:46.000000', 'temperatura', 63.0000, 'ºC'),
	(348101, 146, '2015-02-01 00:14:47.000000', 'temperatura', 364.0000, 'ºC'),
	(348102, 146, '2015-02-01 00:14:48.000000', 'temperatura', 431.0000, 'ºC'),
	(348103, 146, '2015-02-01 00:14:49.000000', 'temperatura', 1065.0000, 'ºC'),
	(348104, 146, '2015-02-01 00:14:50.000000', 'temperatura', 430.0000, 'ºC'),
	(348105, 146, '2015-02-01 00:14:51.000000', 'temperatura', 156.0000, 'ºC'),
	(348106, 146, '2015-02-01 00:14:52.000000', 'temperatura', 693.0000, 'ºC'),
	(348107, 146, '2015-02-01 00:14:53.000000', 'temperatura', 597.0000, 'ºC'),
	(348108, 146, '2015-02-01 00:14:54.000000', 'temperatura', 905.0000, 'ºC'),
	(348109, 146, '2015-02-01 00:14:55.000000', 'temperatura', 334.0000, 'ºC'),
	(348110, 146, '2015-02-01 00:14:56.000000', 'temperatura', 157.0000, 'ºC'),
	(348111, 146, '2015-02-01 00:14:57.000000', 'temperatura', 982.0000, 'ºC'),
	(348112, 146, '2015-02-01 00:14:58.000000', 'temperatura', 841.0000, 'ºC'),
	(348113, 146, '2015-02-01 00:14:59.000000', 'temperatura', 58.0000, 'ºC'),
	(348114, 146, '2015-02-01 00:15:00.000000', 'temperatura', 169.0000, 'ºC'),
	(348115, 146, '2015-02-01 00:15:01.000000', 'temperatura', 672.0000, 'ºC'),
	(348116, 146, '2015-02-01 00:15:02.000000', 'temperatura', 452.0000, 'ºC'),
	(348117, 146, '2015-02-01 00:15:03.000000', 'temperatura', 243.0000, 'ºC'),
	(348118, 146, '2015-02-01 00:15:04.000000', 'temperatura', 1062.0000, 'ºC'),
	(348119, 146, '2015-02-01 00:15:05.000000', 'temperatura', 981.0000, 'ºC'),
	(348120, 146, '2015-02-01 00:15:06.000000', 'temperatura', 518.0000, 'ºC'),
	(348121, 146, '2015-02-01 00:15:07.000000', 'temperatura', 848.0000, 'ºC'),
	(348122, 146, '2015-02-01 00:15:08.000000', 'temperatura', 287.0000, 'ºC'),
	(348123, 146, '2015-02-01 00:15:09.000000', 'temperatura', 92.0000, 'ºC'),
	(348124, 146, '2015-02-01 00:15:10.000000', 'temperatura', 799.0000, 'ºC'),
	(348125, 146, '2015-02-01 00:15:11.000000', 'temperatura', 119.0000, 'ºC'),
	(348126, 146, '2015-02-01 00:15:12.000000', 'temperatura', 597.0000, 'ºC'),
	(348127, 146, '2015-02-01 00:15:13.000000', 'temperatura', 230.0000, 'ºC'),
	(348128, 146, '2015-02-01 00:15:14.000000', 'temperatura', 561.0000, 'ºC'),
	(348129, 146, '2015-02-01 00:15:15.000000', 'temperatura', 916.0000, 'ºC'),
	(348130, 146, '2015-02-01 00:15:16.000000', 'temperatura', 498.0000, 'ºC'),
	(348131, 146, '2015-02-01 00:15:17.000000', 'temperatura', 942.0000, 'ºC'),
	(348132, 146, '2015-02-01 00:15:18.000000', 'temperatura', 818.0000, 'ºC'),
	(348133, 146, '2015-02-01 00:15:19.000000', 'temperatura', 61.0000, 'ºC'),
	(348134, 146, '2015-02-01 00:15:20.000000', 'temperatura', 253.0000, 'ºC'),
	(348135, 146, '2015-02-01 00:15:21.000000', 'temperatura', 1083.0000, 'ºC'),
	(348136, 146, '2015-02-01 00:15:22.000000', 'temperatura', 1055.0000, 'ºC'),
	(348137, 146, '2015-02-01 00:15:23.000000', 'temperatura', 827.0000, 'ºC'),
	(348138, 146, '2015-02-01 00:15:24.000000', 'temperatura', 969.0000, 'ºC'),
	(348139, 146, '2015-02-01 00:15:25.000000', 'temperatura', 1165.0000, 'ºC'),
	(348140, 146, '2015-02-01 00:15:26.000000', 'temperatura', 517.0000, 'ºC'),
	(348141, 146, '2015-02-01 00:15:27.000000', 'temperatura', 292.0000, 'ºC'),
	(348142, 146, '2015-02-01 00:15:28.000000', 'temperatura', 1110.0000, 'ºC'),
	(348143, 146, '2015-02-01 00:15:29.000000', 'temperatura', 1076.0000, 'ºC'),
	(348144, 146, '2015-02-01 00:15:30.000000', 'temperatura', 848.0000, 'ºC'),
	(348145, 146, '2015-02-01 00:15:31.000000', 'temperatura', 1014.0000, 'ºC'),
	(348146, 146, '2015-02-01 00:15:32.000000', 'temperatura', 128.0000, 'ºC'),
	(348147, 146, '2015-02-01 00:15:33.000000', 'temperatura', 1197.0000, 'ºC'),
	(348148, 146, '2015-02-01 00:15:34.000000', 'temperatura', 800.0000, 'ºC'),
	(348149, 146, '2015-02-01 00:15:35.000000', 'temperatura', 410.0000, 'ºC'),
	(348150, 146, '2015-02-01 00:15:36.000000', 'temperatura', 849.0000, 'ºC'),
	(348151, 146, '2015-02-01 00:15:37.000000', 'temperatura', 617.0000, 'ºC'),
	(348152, 146, '2015-02-01 00:15:38.000000', 'temperatura', 539.0000, 'ºC'),
	(348153, 146, '2015-02-01 00:15:39.000000', 'temperatura', 844.0000, 'ºC'),
	(348154, 146, '2015-02-01 00:15:40.000000', 'temperatura', 203.0000, 'ºC'),
	(348155, 146, '2015-02-01 00:15:41.000000', 'temperatura', 885.0000, 'ºC'),
	(348156, 146, '2015-02-01 00:15:42.000000', 'temperatura', 214.0000, 'ºC'),
	(348157, 146, '2015-02-01 00:15:43.000000', 'temperatura', 818.0000, 'ºC'),
	(348158, 146, '2015-02-01 00:15:44.000000', 'temperatura', 1049.0000, 'ºC'),
	(348159, 146, '2015-02-01 00:15:45.000000', 'temperatura', 390.0000, 'ºC'),
	(348160, 146, '2015-02-01 00:15:46.000000', 'temperatura', 6.0000, 'ºC'),
	(348161, 146, '2015-02-01 00:15:47.000000', 'temperatura', 58.0000, 'ºC'),
	(348162, 146, '2015-02-01 00:15:48.000000', 'temperatura', 273.0000, 'ºC'),
	(348163, 146, '2015-02-01 00:15:49.000000', 'temperatura', 1191.0000, 'ºC'),
	(348164, 146, '2015-02-01 00:15:50.000000', 'temperatura', 336.0000, 'ºC'),
	(348165, 146, '2015-02-01 00:15:51.000000', 'temperatura', 506.0000, 'ºC'),
	(348166, 146, '2015-02-01 00:15:52.000000', 'temperatura', 324.0000, 'ºC'),
	(348167, 146, '2015-02-01 00:15:53.000000', 'temperatura', 104.0000, 'ºC'),
	(348168, 146, '2015-02-01 00:15:54.000000', 'temperatura', 749.0000, 'ºC'),
	(348169, 146, '2015-02-01 00:15:55.000000', 'temperatura', 1033.0000, 'ºC'),
	(348170, 146, '2015-02-01 00:15:56.000000', 'temperatura', 518.0000, 'ºC'),
	(348171, 146, '2015-02-01 00:15:57.000000', 'temperatura', 690.0000, 'ºC'),
	(348172, 146, '2015-02-01 00:15:58.000000', 'temperatura', 700.0000, 'ºC'),
	(348173, 146, '2015-02-01 00:15:59.000000', 'temperatura', 227.0000, 'ºC'),
	(348174, 146, '2015-02-01 00:16:00.000000', 'temperatura', 237.0000, 'ºC'),
	(348175, 146, '2015-02-01 00:16:01.000000', 'temperatura', 503.0000, 'ºC'),
	(348176, 146, '2015-02-01 00:16:02.000000', 'temperatura', 607.0000, 'ºC'),
	(348177, 146, '2015-02-01 00:16:03.000000', 'temperatura', 326.0000, 'ºC'),
	(348178, 146, '2015-02-01 00:16:04.000000', 'temperatura', 1010.0000, 'ºC'),
	(348179, 146, '2015-02-01 00:16:05.000000', 'temperatura', 470.0000, 'ºC'),
	(348180, 146, '2015-02-01 00:16:06.000000', 'temperatura', 523.0000, 'ºC'),
	(348181, 146, '2015-02-01 00:16:07.000000', 'temperatura', 7.0000, 'ºC'),
	(348182, 146, '2015-02-01 00:16:08.000000', 'temperatura', 863.0000, 'ºC'),
	(348183, 146, '2015-02-01 00:16:09.000000', 'temperatura', 696.0000, 'ºC'),
	(348184, 146, '2015-02-01 00:16:10.000000', 'temperatura', 890.0000, 'ºC'),
	(348185, 146, '2015-02-01 00:16:11.000000', 'temperatura', 1161.0000, 'ºC'),
	(348186, 146, '2015-02-01 00:16:12.000000', 'temperatura', 739.0000, 'ºC'),
	(348187, 146, '2015-02-01 00:16:13.000000', 'temperatura', 212.0000, 'ºC'),
	(348188, 146, '2015-02-01 00:16:14.000000', 'temperatura', 43.0000, 'ºC'),
	(348189, 146, '2015-02-01 00:16:15.000000', 'temperatura', 780.0000, 'ºC'),
	(348190, 146, '2015-02-01 00:16:16.000000', 'temperatura', 170.0000, 'ºC'),
	(348191, 146, '2015-02-01 00:16:17.000000', 'temperatura', 912.0000, 'ºC'),
	(348192, 146, '2015-02-01 00:16:18.000000', 'temperatura', 449.0000, 'ºC'),
	(348193, 146, '2015-02-01 00:16:19.000000', 'temperatura', 712.0000, 'ºC'),
	(348194, 146, '2015-02-01 00:16:20.000000', 'temperatura', 1011.0000, 'ºC'),
	(348195, 146, '2015-02-01 00:16:21.000000', 'temperatura', 522.0000, 'ºC'),
	(348196, 146, '2015-02-01 00:16:22.000000', 'temperatura', 775.0000, 'ºC'),
	(348197, 146, '2015-02-01 00:16:23.000000', 'temperatura', 1112.0000, 'ºC'),
	(348198, 146, '2015-02-01 00:16:24.000000', 'temperatura', 832.0000, 'ºC'),
	(348199, 146, '2015-02-01 00:16:25.000000', 'temperatura', 828.0000, 'ºC'),
	(348200, 146, '2015-02-01 00:16:26.000000', 'temperatura', 443.0000, 'ºC'),
	(348201, 146, '2015-02-01 00:16:27.000000', 'temperatura', 930.0000, 'ºC'),
	(348202, 146, '2015-02-01 00:16:28.000000', 'temperatura', 924.0000, 'ºC'),
	(348203, 146, '2015-02-01 00:16:29.000000', 'temperatura', 628.0000, 'ºC'),
	(348204, 146, '2015-02-01 00:16:30.000000', 'temperatura', 368.0000, 'ºC'),
	(348205, 146, '2015-02-01 00:16:31.000000', 'temperatura', 1159.0000, 'ºC'),
	(348206, 146, '2015-02-01 00:16:32.000000', 'temperatura', 1089.0000, 'ºC'),
	(348207, 146, '2015-02-01 00:16:33.000000', 'temperatura', 769.0000, 'ºC'),
	(348208, 146, '2015-02-01 00:16:34.000000', 'temperatura', 581.0000, 'ºC'),
	(348209, 146, '2015-02-01 00:16:35.000000', 'temperatura', 597.0000, 'ºC'),
	(348210, 146, '2015-02-01 00:16:36.000000', 'temperatura', 42.0000, 'ºC'),
	(348211, 146, '2015-02-01 00:16:37.000000', 'temperatura', 822.0000, 'ºC'),
	(348212, 146, '2015-02-01 00:16:38.000000', 'temperatura', 381.0000, 'ºC'),
	(348213, 146, '2015-02-01 00:16:39.000000', 'temperatura', 642.0000, 'ºC'),
	(348214, 146, '2015-02-01 00:16:40.000000', 'temperatura', 866.0000, 'ºC'),
	(348215, 146, '2015-02-01 00:16:41.000000', 'temperatura', 7.0000, 'ºC'),
	(348216, 146, '2015-02-01 00:16:42.000000', 'temperatura', 1035.0000, 'ºC'),
	(348217, 146, '2015-02-01 00:16:43.000000', 'temperatura', 356.0000, 'ºC'),
	(348218, 146, '2015-02-01 00:16:44.000000', 'temperatura', 1076.0000, 'ºC'),
	(348219, 146, '2015-02-01 00:16:45.000000', 'temperatura', 710.0000, 'ºC'),
	(348220, 146, '2015-02-01 00:16:46.000000', 'temperatura', 323.0000, 'ºC'),
	(348221, 146, '2015-02-01 00:16:47.000000', 'temperatura', 687.0000, 'ºC'),
	(348222, 146, '2015-02-01 00:16:48.000000', 'temperatura', 67.0000, 'ºC'),
	(348223, 146, '2015-02-01 00:16:49.000000', 'temperatura', 675.0000, 'ºC'),
	(348224, 146, '2015-02-01 00:16:50.000000', 'temperatura', 774.0000, 'ºC'),
	(348225, 146, '2015-02-01 00:16:51.000000', 'temperatura', 646.0000, 'ºC'),
	(348226, 146, '2015-02-01 00:16:52.000000', 'temperatura', 910.0000, 'ºC'),
	(348227, 146, '2015-02-01 00:16:53.000000', 'temperatura', 209.0000, 'ºC'),
	(348228, 146, '2015-02-01 00:16:54.000000', 'temperatura', 717.0000, 'ºC'),
	(348229, 146, '2015-02-01 00:16:55.000000', 'temperatura', 558.0000, 'ºC'),
	(348230, 146, '2015-02-01 00:16:56.000000', 'temperatura', 639.0000, 'ºC'),
	(348231, 146, '2015-02-01 00:16:57.000000', 'temperatura', 322.0000, 'ºC'),
	(348232, 146, '2015-02-01 00:16:58.000000', 'temperatura', 892.0000, 'ºC'),
	(348233, 146, '2015-02-01 00:16:59.000000', 'temperatura', 1097.0000, 'ºC'),
	(348234, 146, '2015-02-01 00:17:00.000000', 'temperatura', 408.0000, 'ºC'),
	(348235, 146, '2015-02-01 00:17:01.000000', 'temperatura', 1148.0000, 'ºC'),
	(348236, 146, '2015-02-01 00:17:02.000000', 'temperatura', 918.0000, 'ºC'),
	(348237, 146, '2015-02-01 00:17:03.000000', 'temperatura', 1148.0000, 'ºC'),
	(348238, 146, '2015-02-01 00:17:04.000000', 'temperatura', 584.0000, 'ºC'),
	(348239, 146, '2015-02-01 00:17:05.000000', 'temperatura', 679.0000, 'ºC'),
	(348240, 146, '2015-02-01 00:17:06.000000', 'temperatura', 444.0000, 'ºC'),
	(348241, 146, '2015-02-01 00:17:07.000000', 'temperatura', 181.0000, 'ºC'),
	(348242, 146, '2015-02-01 00:17:08.000000', 'temperatura', 774.0000, 'ºC'),
	(348243, 146, '2015-02-01 00:17:09.000000', 'temperatura', 930.0000, 'ºC'),
	(348244, 146, '2015-02-01 00:17:10.000000', 'temperatura', 1126.0000, 'ºC'),
	(348245, 146, '2015-02-01 00:17:11.000000', 'temperatura', 440.0000, 'ºC'),
	(348246, 146, '2015-02-01 00:17:12.000000', 'temperatura', 24.0000, 'ºC'),
	(348247, 146, '2015-02-01 00:17:13.000000', 'temperatura', 1.0000, 'ºC'),
	(348248, 146, '2015-02-01 00:17:14.000000', 'temperatura', 1133.0000, 'ºC'),
	(348249, 146, '2015-02-01 00:17:15.000000', 'temperatura', 861.0000, 'ºC'),
	(348250, 146, '2015-02-01 00:17:16.000000', 'temperatura', 907.0000, 'ºC'),
	(348251, 146, '2015-02-01 00:17:17.000000', 'temperatura', 752.0000, 'ºC'),
	(348252, 146, '2015-02-01 00:17:18.000000', 'temperatura', 1039.0000, 'ºC'),
	(348253, 146, '2015-02-01 00:17:19.000000', 'temperatura', 538.0000, 'ºC'),
	(348254, 146, '2015-02-01 00:17:20.000000', 'temperatura', 777.0000, 'ºC'),
	(348255, 146, '2015-02-01 00:17:21.000000', 'temperatura', 1070.0000, 'ºC'),
	(348256, 146, '2015-02-01 00:17:22.000000', 'temperatura', 622.0000, 'ºC'),
	(348257, 146, '2015-02-01 00:17:23.000000', 'temperatura', 1097.0000, 'ºC'),
	(348258, 146, '2015-02-01 00:17:24.000000', 'temperatura', 21.0000, 'ºC'),
	(348259, 146, '2015-02-01 00:17:25.000000', 'temperatura', 414.0000, 'ºC'),
	(348260, 146, '2015-02-01 00:17:26.000000', 'temperatura', 808.0000, 'ºC'),
	(348261, 146, '2015-02-01 00:17:27.000000', 'temperatura', 400.0000, 'ºC'),
	(348262, 146, '2015-02-01 00:17:28.000000', 'temperatura', 777.0000, 'ºC'),
	(348263, 146, '2015-02-01 00:17:29.000000', 'temperatura', 285.0000, 'ºC'),
	(348264, 146, '2015-02-01 00:17:30.000000', 'temperatura', 293.0000, 'ºC'),
	(348265, 146, '2015-02-01 00:17:31.000000', 'temperatura', 611.0000, 'ºC'),
	(348266, 146, '2015-02-01 00:17:32.000000', 'temperatura', 977.0000, 'ºC'),
	(348267, 146, '2015-02-01 00:17:33.000000', 'temperatura', 654.0000, 'ºC'),
	(348268, 146, '2015-02-01 00:17:34.000000', 'temperatura', 338.0000, 'ºC'),
	(348269, 146, '2015-02-01 00:17:35.000000', 'temperatura', 931.0000, 'ºC'),
	(348270, 146, '2015-02-01 00:17:36.000000', 'temperatura', 38.0000, 'ºC'),
	(348271, 146, '2015-02-01 00:17:37.000000', 'temperatura', 1000.0000, 'ºC'),
	(348272, 146, '2015-02-01 00:17:38.000000', 'temperatura', 86.0000, 'ºC'),
	(348273, 146, '2015-02-01 00:17:39.000000', 'temperatura', 1032.0000, 'ºC'),
	(348274, 146, '2015-02-01 00:17:40.000000', 'temperatura', 100.0000, 'ºC'),
	(348275, 146, '2015-02-01 00:17:41.000000', 'temperatura', 1004.0000, 'ºC'),
	(348276, 146, '2015-02-01 00:17:42.000000', 'temperatura', 1121.0000, 'ºC'),
	(348277, 146, '2015-02-01 00:17:43.000000', 'temperatura', 196.0000, 'ºC'),
	(348278, 146, '2015-02-01 00:17:44.000000', 'temperatura', 15.0000, 'ºC'),
	(348279, 146, '2015-02-01 00:17:45.000000', 'temperatura', 686.0000, 'ºC'),
	(348280, 146, '2015-02-01 00:17:46.000000', 'temperatura', 988.0000, 'ºC'),
	(348281, 146, '2015-02-01 00:17:47.000000', 'temperatura', 482.0000, 'ºC'),
	(348282, 146, '2015-02-01 00:17:48.000000', 'temperatura', 648.0000, 'ºC'),
	(348283, 146, '2015-02-01 00:17:49.000000', 'temperatura', 595.0000, 'ºC'),
	(348284, 146, '2015-02-01 00:17:50.000000', 'temperatura', 1030.0000, 'ºC'),
	(348285, 146, '2015-02-01 00:17:51.000000', 'temperatura', 965.0000, 'ºC'),
	(348286, 146, '2015-02-01 00:17:52.000000', 'temperatura', 537.0000, 'ºC'),
	(348287, 146, '2015-02-01 00:17:53.000000', 'temperatura', 991.0000, 'ºC'),
	(348288, 146, '2015-02-01 00:17:54.000000', 'temperatura', 946.0000, 'ºC'),
	(348289, 146, '2015-02-01 00:17:55.000000', 'temperatura', 554.0000, 'ºC'),
	(348290, 146, '2015-02-01 00:17:56.000000', 'temperatura', 1135.0000, 'ºC'),
	(348291, 146, '2015-02-01 00:17:57.000000', 'temperatura', 415.0000, 'ºC'),
	(348292, 146, '2015-02-01 00:17:58.000000', 'temperatura', 1067.0000, 'ºC'),
	(348293, 146, '2015-02-01 00:17:59.000000', 'temperatura', 493.0000, 'ºC'),
	(348294, 146, '2015-02-01 00:18:00.000000', 'temperatura', 465.0000, 'ºC'),
	(348295, 146, '2015-02-01 00:18:01.000000', 'temperatura', 847.0000, 'ºC'),
	(348296, 146, '2015-02-01 00:18:02.000000', 'temperatura', 438.0000, 'ºC'),
	(348297, 146, '2015-02-01 00:18:03.000000', 'temperatura', 849.0000, 'ºC'),
	(348298, 146, '2015-02-01 00:18:04.000000', 'temperatura', 531.0000, 'ºC'),
	(348299, 146, '2015-02-01 00:18:05.000000', 'temperatura', 110.0000, 'ºC'),
	(348300, 146, '2015-02-01 00:18:06.000000', 'temperatura', 156.0000, 'ºC'),
	(348301, 146, '2015-02-01 00:18:07.000000', 'temperatura', 453.0000, 'ºC'),
	(348302, 146, '2015-02-01 00:18:08.000000', 'temperatura', 595.0000, 'ºC'),
	(348303, 146, '2015-02-01 00:18:09.000000', 'temperatura', 419.0000, 'ºC'),
	(348304, 146, '2015-02-01 00:18:10.000000', 'temperatura', 311.0000, 'ºC'),
	(348305, 146, '2015-02-01 00:18:11.000000', 'temperatura', 299.0000, 'ºC'),
	(348306, 146, '2015-02-01 00:18:12.000000', 'temperatura', 563.0000, 'ºC'),
	(348307, 146, '2015-02-01 00:18:13.000000', 'temperatura', 718.0000, 'ºC'),
	(348308, 146, '2015-02-01 00:18:14.000000', 'temperatura', 699.0000, 'ºC'),
	(348309, 146, '2015-02-01 00:18:15.000000', 'temperatura', 144.0000, 'ºC'),
	(348310, 146, '2015-02-01 00:18:16.000000', 'temperatura', 1025.0000, 'ºC'),
	(348311, 146, '2015-02-01 00:18:17.000000', 'temperatura', 1091.0000, 'ºC'),
	(348312, 146, '2015-02-01 00:18:18.000000', 'temperatura', 1182.0000, 'ºC'),
	(348313, 146, '2015-02-01 00:18:19.000000', 'temperatura', 236.0000, 'ºC'),
	(348314, 146, '2015-02-01 00:18:20.000000', 'temperatura', 36.0000, 'ºC'),
	(348315, 146, '2015-02-01 00:18:21.000000', 'temperatura', 670.0000, 'ºC'),
	(348316, 146, '2015-02-01 00:18:22.000000', 'temperatura', 843.0000, 'ºC'),
	(348317, 146, '2015-02-01 00:18:23.000000', 'temperatura', 1007.0000, 'ºC'),
	(348318, 146, '2015-02-01 00:18:24.000000', 'temperatura', 105.0000, 'ºC'),
	(348319, 146, '2015-02-01 00:18:25.000000', 'temperatura', 1105.0000, 'ºC'),
	(348320, 146, '2015-02-01 00:18:26.000000', 'temperatura', 409.0000, 'ºC'),
	(348321, 146, '2015-02-01 00:18:27.000000', 'temperatura', 1131.0000, 'ºC'),
	(348322, 146, '2015-02-01 00:18:28.000000', 'temperatura', 829.0000, 'ºC'),
	(348323, 146, '2015-02-01 00:18:29.000000', 'temperatura', 754.0000, 'ºC'),
	(348324, 146, '2015-02-01 00:18:30.000000', 'temperatura', 80.0000, 'ºC'),
	(348325, 146, '2015-02-01 00:18:31.000000', 'temperatura', 542.0000, 'ºC'),
	(348326, 146, '2015-02-01 00:18:32.000000', 'temperatura', 69.0000, 'ºC'),
	(348327, 146, '2015-02-01 00:18:33.000000', 'temperatura', 1120.0000, 'ºC'),
	(348328, 146, '2015-02-01 00:18:34.000000', 'temperatura', 593.0000, 'ºC'),
	(348329, 146, '2015-02-01 00:18:35.000000', 'temperatura', 806.0000, 'ºC'),
	(348330, 146, '2015-02-01 00:18:36.000000', 'temperatura', 1051.0000, 'ºC'),
	(348331, 146, '2015-02-01 00:18:37.000000', 'temperatura', 436.0000, 'ºC'),
	(348332, 146, '2015-02-01 00:18:38.000000', 'temperatura', 230.0000, 'ºC'),
	(348333, 146, '2015-02-01 00:18:39.000000', 'temperatura', 1042.0000, 'ºC'),
	(348334, 146, '2015-02-01 00:18:40.000000', 'temperatura', 918.0000, 'ºC'),
	(348335, 146, '2015-02-01 00:18:41.000000', 'temperatura', 267.0000, 'ºC'),
	(348336, 146, '2015-02-01 00:18:42.000000', 'temperatura', 980.0000, 'ºC'),
	(348337, 146, '2015-02-01 00:18:43.000000', 'temperatura', 501.0000, 'ºC'),
	(348338, 146, '2015-02-01 00:18:44.000000', 'temperatura', 764.0000, 'ºC'),
	(348339, 146, '2015-02-01 00:18:45.000000', 'temperatura', 1117.0000, 'ºC'),
	(348340, 146, '2015-02-01 00:18:46.000000', 'temperatura', 896.0000, 'ºC'),
	(348341, 146, '2015-02-01 00:18:47.000000', 'temperatura', 1129.0000, 'ºC'),
	(348342, 146, '2015-02-01 00:18:48.000000', 'temperatura', 559.0000, 'ºC'),
	(348343, 146, '2015-02-01 00:18:49.000000', 'temperatura', 606.0000, 'ºC'),
	(348344, 146, '2015-02-01 00:18:50.000000', 'temperatura', 156.0000, 'ºC'),
	(348345, 146, '2015-02-01 00:18:51.000000', 'temperatura', 160.0000, 'ºC'),
	(348346, 146, '2015-02-01 00:18:52.000000', 'temperatura', 334.0000, 'ºC'),
	(348347, 146, '2015-02-01 00:18:53.000000', 'temperatura', 1192.0000, 'ºC'),
	(348348, 146, '2015-02-01 00:18:54.000000', 'temperatura', 157.0000, 'ºC'),
	(348349, 146, '2015-02-01 00:18:55.000000', 'temperatura', 809.0000, 'ºC'),
	(348350, 146, '2015-02-01 00:18:56.000000', 'temperatura', 1175.0000, 'ºC'),
	(348351, 146, '2015-02-01 00:18:57.000000', 'temperatura', 1049.0000, 'ºC'),
	(348352, 146, '2015-02-01 00:18:58.000000', 'temperatura', 521.0000, 'ºC'),
	(348353, 146, '2015-02-01 00:18:59.000000', 'temperatura', 656.0000, 'ºC'),
	(348354, 146, '2015-02-01 00:19:00.000000', 'temperatura', 518.0000, 'ºC'),
	(348355, 146, '2015-02-01 00:19:01.000000', 'temperatura', 623.0000, 'ºC'),
	(348356, 146, '2015-02-01 00:19:02.000000', 'temperatura', 360.0000, 'ºC'),
	(348357, 146, '2015-02-01 00:19:03.000000', 'temperatura', 1132.0000, 'ºC'),
	(348358, 146, '2015-02-01 00:19:04.000000', 'temperatura', 980.0000, 'ºC'),
	(348359, 146, '2015-02-01 00:19:05.000000', 'temperatura', 306.0000, 'ºC'),
	(348360, 146, '2015-02-01 00:19:06.000000', 'temperatura', 988.0000, 'ºC'),
	(348361, 146, '2015-02-01 00:19:07.000000', 'temperatura', 424.0000, 'ºC'),
	(348362, 146, '2015-02-01 00:19:08.000000', 'temperatura', 357.0000, 'ºC'),
	(348363, 146, '2015-02-01 00:19:09.000000', 'temperatura', 512.0000, 'ºC'),
	(348364, 146, '2015-02-01 00:19:10.000000', 'temperatura', 289.0000, 'ºC'),
	(348365, 146, '2015-02-01 00:19:11.000000', 'temperatura', 1108.0000, 'ºC'),
	(348366, 146, '2015-02-01 00:19:12.000000', 'temperatura', 1077.0000, 'ºC'),
	(348367, 146, '2015-02-01 00:19:13.000000', 'temperatura', 859.0000, 'ºC'),
	(348368, 146, '2015-02-01 00:19:14.000000', 'temperatura', 1066.0000, 'ºC'),
	(348369, 146, '2015-02-01 00:19:15.000000', 'temperatura', 352.0000, 'ºC'),
	(348370, 146, '2015-02-01 00:19:16.000000', 'temperatura', 961.0000, 'ºC'),
	(348371, 146, '2015-02-01 00:19:17.000000', 'temperatura', 152.0000, 'ºC'),
	(348372, 146, '2015-02-01 00:19:18.000000', 'temperatura', 278.0000, 'ºC'),
	(348373, 146, '2015-02-01 00:19:19.000000', 'temperatura', 934.0000, 'ºC'),
	(348374, 146, '2015-02-01 00:19:20.000000', 'temperatura', 236.0000, 'ºC'),
	(348375, 146, '2015-02-01 00:19:21.000000', 'temperatura', 781.0000, 'ºC'),
	(348376, 146, '2015-02-01 00:19:22.000000', 'temperatura', 795.0000, 'ºC'),
	(348377, 146, '2015-02-01 00:19:23.000000', 'temperatura', 432.0000, 'ºC'),
	(348378, 146, '2015-02-01 00:19:24.000000', 'temperatura', 974.0000, 'ºC'),
	(348379, 146, '2015-02-01 00:19:25.000000', 'temperatura', 1177.0000, 'ºC'),
	(348380, 146, '2015-02-01 00:19:26.000000', 'temperatura', 563.0000, 'ºC'),
	(348381, 146, '2015-02-01 00:19:27.000000', 'temperatura', 486.0000, 'ºC'),
	(348382, 146, '2015-02-01 00:19:28.000000', 'temperatura', 741.0000, 'ºC'),
	(348383, 146, '2015-02-01 00:19:29.000000', 'temperatura', 1046.0000, 'ºC'),
	(348384, 146, '2015-02-01 00:19:30.000000', 'temperatura', 609.0000, 'ºC'),
	(348385, 146, '2015-02-01 00:19:31.000000', 'temperatura', 1105.0000, 'ºC'),
	(348386, 146, '2015-02-01 00:19:32.000000', 'temperatura', 101.0000, 'ºC'),
	(348387, 146, '2015-02-01 00:19:33.000000', 'temperatura', 789.0000, 'ºC'),
	(348388, 146, '2015-02-01 00:19:34.000000', 'temperatura', 41.0000, 'ºC'),
	(348389, 146, '2015-02-01 00:19:35.000000', 'temperatura', 241.0000, 'ºC'),
	(348390, 146, '2015-02-01 00:19:36.000000', 'temperatura', 1082.0000, 'ºC'),
	(348391, 146, '2015-02-01 00:19:37.000000', 'temperatura', 1089.0000, 'ºC'),
	(348392, 146, '2015-02-01 00:19:38.000000', 'temperatura', 1000.0000, 'ºC'),
	(348393, 146, '2015-02-01 00:19:39.000000', 'temperatura', 532.0000, 'ºC'),
	(348394, 146, '2015-02-01 00:19:40.000000', 'temperatura', 859.0000, 'ºC'),
	(348395, 146, '2015-02-01 00:19:41.000000', 'temperatura', 301.0000, 'ºC'),
	(348396, 146, '2015-02-01 00:19:42.000000', 'temperatura', 128.0000, 'ºC'),
	(348397, 146, '2015-02-01 00:19:43.000000', 'temperatura', 940.0000, 'ºC'),
	(348398, 146, '2015-02-01 00:19:44.000000', 'temperatura', 713.0000, 'ºC'),
	(348399, 146, '2015-02-01 00:19:45.000000', 'temperatura', 747.0000, 'ºC'),
	(348400, 146, '2015-02-01 00:19:46.000000', 'temperatura', 396.0000, 'ºC'),
	(348401, 146, '2015-02-01 00:19:47.000000', 'temperatura', 940.0000, 'ºC'),
	(348402, 146, '2015-02-01 00:19:48.000000', 'temperatura', 1113.0000, 'ºC'),
	(348403, 146, '2015-02-01 00:19:49.000000', 'temperatura', 347.0000, 'ºC'),
	(348404, 146, '2015-02-01 00:19:50.000000', 'temperatura', 795.0000, 'ºC'),
	(348405, 146, '2015-02-01 00:19:51.000000', 'temperatura', 536.0000, 'ºC'),
	(348406, 146, '2015-02-01 00:19:52.000000', 'temperatura', 292.0000, 'ºC'),
	(348407, 146, '2015-02-01 00:19:53.000000', 'temperatura', 1056.0000, 'ºC'),
	(348408, 146, '2015-02-01 00:19:54.000000', 'temperatura', 804.0000, 'ºC'),
	(348409, 146, '2015-02-01 00:19:55.000000', 'temperatura', 852.0000, 'ºC'),
	(348410, 146, '2015-02-01 00:19:56.000000', 'temperatura', 648.0000, 'ºC'),
	(348411, 146, '2015-02-01 00:19:57.000000', 'temperatura', 683.0000, 'ºC'),
	(348412, 146, '2015-02-01 00:19:58.000000', 'temperatura', 273.0000, 'ºC'),
	(348413, 146, '2015-02-01 00:19:59.000000', 'temperatura', 516.0000, 'ºC'),
	(348414, 146, '2015-02-01 00:20:00.000000', 'temperatura', 561.0000, 'ºC'),
	(348415, 146, '2015-02-01 00:20:01.000000', 'temperatura', 56.0000, 'ºC'),
	(348416, 146, '2015-02-01 00:20:02.000000', 'temperatura', 999.0000, 'ºC'),
	(348417, 146, '2015-02-01 00:20:03.000000', 'temperatura', 29.0000, 'ºC'),
	(348418, 146, '2015-02-01 00:20:04.000000', 'temperatura', 747.0000, 'ºC'),
	(348419, 146, '2015-02-01 00:20:05.000000', 'temperatura', 51.0000, 'ºC'),
	(348420, 146, '2015-02-01 00:20:06.000000', 'temperatura', 413.0000, 'ºC'),
	(348421, 146, '2015-02-01 00:20:07.000000', 'temperatura', 711.0000, 'ºC'),
	(348422, 146, '2015-02-01 00:20:08.000000', 'temperatura', 1116.0000, 'ºC'),
	(348423, 146, '2015-02-01 00:20:09.000000', 'temperatura', 1050.0000, 'ºC'),
	(348424, 146, '2015-02-01 00:20:10.000000', 'temperatura', 702.0000, 'ºC'),
	(348425, 146, '2015-02-01 00:20:11.000000', 'temperatura', 360.0000, 'ºC'),
	(348426, 146, '2015-02-01 00:20:12.000000', 'temperatura', 893.0000, 'ºC'),
	(348427, 146, '2015-02-01 00:20:13.000000', 'temperatura', 987.0000, 'ºC'),
	(348428, 146, '2015-02-01 00:20:14.000000', 'temperatura', 1055.0000, 'ºC'),
	(348429, 146, '2015-02-01 00:20:15.000000', 'temperatura', 1116.0000, 'ºC'),
	(348430, 146, '2015-02-01 00:20:16.000000', 'temperatura', 15.0000, 'ºC'),
	(348431, 146, '2015-02-01 00:20:17.000000', 'temperatura', 326.0000, 'ºC'),
	(348432, 146, '2015-02-01 00:20:18.000000', 'temperatura', 385.0000, 'ºC'),
	(348433, 146, '2015-02-01 00:20:19.000000', 'temperatura', 947.0000, 'ºC'),
	(348434, 146, '2015-02-01 00:20:20.000000', 'temperatura', 1183.0000, 'ºC'),
	(348435, 146, '2015-02-01 00:20:21.000000', 'temperatura', 674.0000, 'ºC'),
	(348436, 146, '2015-02-01 00:20:22.000000', 'temperatura', 1023.0000, 'ºC'),
	(348437, 146, '2015-02-01 00:20:23.000000', 'temperatura', 692.0000, 'ºC'),
	(348438, 146, '2015-02-01 00:20:24.000000', 'temperatura', 390.0000, 'ºC'),
	(348439, 146, '2015-02-01 00:20:25.000000', 'temperatura', 1075.0000, 'ºC'),
	(348440, 146, '2015-02-01 00:20:26.000000', 'temperatura', 608.0000, 'ºC'),
	(348441, 146, '2015-02-01 00:20:27.000000', 'temperatura', 1014.0000, 'ºC'),
	(348442, 146, '2015-02-01 00:20:28.000000', 'temperatura', 845.0000, 'ºC'),
	(348443, 146, '2015-02-01 00:20:29.000000', 'temperatura', 1184.0000, 'ºC'),
	(348444, 146, '2015-02-01 00:20:30.000000', 'temperatura', 985.0000, 'ºC'),
	(348445, 146, '2015-02-01 00:20:31.000000', 'temperatura', 173.0000, 'ºC'),
	(348446, 146, '2015-02-01 00:20:32.000000', 'temperatura', 313.0000, 'ºC'),
	(348447, 146, '2015-02-01 00:20:33.000000', 'temperatura', 1046.0000, 'ºC'),
	(348448, 146, '2015-02-01 00:20:34.000000', 'temperatura', 691.0000, 'ºC'),
	(348449, 146, '2015-02-01 00:20:35.000000', 'temperatura', 317.0000, 'ºC'),
	(348450, 146, '2015-02-01 00:20:36.000000', 'temperatura', 714.0000, 'ºC'),
	(348451, 146, '2015-02-01 00:20:37.000000', 'temperatura', 218.0000, 'ºC'),
	(348452, 146, '2015-02-01 00:20:38.000000', 'temperatura', 148.0000, 'ºC'),
	(348453, 146, '2015-02-01 00:20:39.000000', 'temperatura', 89.0000, 'ºC'),
	(348454, 146, '2015-02-01 00:20:40.000000', 'temperatura', 1199.0000, 'ºC'),
	(348455, 146, '2015-02-01 00:20:41.000000', 'temperatura', 929.0000, 'ºC'),
	(348456, 146, '2015-02-01 00:20:42.000000', 'temperatura', 1047.0000, 'ºC'),
	(348457, 146, '2015-02-01 00:20:43.000000', 'temperatura', 49.0000, 'ºC'),
	(348458, 146, '2015-02-01 00:20:44.000000', 'temperatura', 707.0000, 'ºC'),
	(348459, 146, '2015-02-01 00:20:45.000000', 'temperatura', 987.0000, 'ºC'),
	(348460, 146, '2015-02-01 00:20:46.000000', 'temperatura', 413.0000, 'ºC'),
	(348461, 146, '2015-02-01 00:20:47.000000', 'temperatura', 306.0000, 'ºC'),
	(348462, 146, '2015-02-01 00:20:48.000000', 'temperatura', 291.0000, 'ºC'),
	(348463, 146, '2015-02-01 00:20:49.000000', 'temperatura', 539.0000, 'ºC'),
	(348464, 146, '2015-02-01 00:20:50.000000', 'temperatura', 622.0000, 'ºC'),
	(348465, 146, '2015-02-01 00:20:51.000000', 'temperatura', 294.0000, 'ºC'),
	(348466, 146, '2015-02-01 00:20:52.000000', 'temperatura', 805.0000, 'ºC'),
	(348467, 146, '2015-02-01 00:20:53.000000', 'temperatura', 744.0000, 'ºC'),
	(348468, 146, '2015-02-01 00:20:54.000000', 'temperatura', 103.0000, 'ºC'),
	(348469, 146, '2015-02-01 00:20:55.000000', 'temperatura', 684.0000, 'ºC'),
	(348470, 146, '2015-02-01 00:20:56.000000', 'temperatura', 712.0000, 'ºC'),
	(348471, 146, '2015-02-01 00:20:57.000000', 'temperatura', 308.0000, 'ºC'),
	(348472, 146, '2015-02-01 00:20:58.000000', 'temperatura', 607.0000, 'ºC'),
	(348473, 146, '2015-02-01 00:20:59.000000', 'temperatura', 909.0000, 'ºC'),
	(348474, 146, '2015-02-01 00:21:00.000000', 'temperatura', 327.0000, 'ºC'),
	(348475, 146, '2015-02-01 00:21:01.000000', 'temperatura', 107.0000, 'ºC'),
	(348476, 146, '2015-02-01 00:21:02.000000', 'temperatura', 756.0000, 'ºC'),
	(348477, 146, '2015-02-01 00:21:03.000000', 'temperatura', 1058.0000, 'ºC'),
	(348478, 146, '2015-02-01 00:21:04.000000', 'temperatura', 621.0000, 'ºC'),
	(348479, 146, '2015-02-01 00:21:05.000000', 'temperatura', 1132.0000, 'ºC'),
	(348480, 146, '2015-02-01 00:21:06.000000', 'temperatura', 198.0000, 'ºC'),
	(348481, 146, '2015-02-01 00:21:07.000000', 'temperatura', 1194.0000, 'ºC'),
	(348482, 146, '2015-02-01 00:21:08.000000', 'temperatura', 577.0000, 'ºC'),
	(348483, 146, '2015-02-01 00:21:09.000000', 'temperatura', 503.0000, 'ºC'),
	(348484, 146, '2015-02-01 00:21:10.000000', 'temperatura', 784.0000, 'ºC'),
	(348485, 146, '2015-02-01 00:21:11.000000', 'temperatura', 11.0000, 'ºC'),
	(348486, 146, '2015-02-01 00:21:12.000000', 'temperatura', 105.0000, 'ºC'),
	(348487, 146, '2015-02-01 00:21:13.000000', 'temperatura', 494.0000, 'ºC'),
	(348488, 146, '2015-02-01 00:21:14.000000', 'temperatura', 952.0000, 'ºC'),
	(348489, 146, '2015-02-01 00:21:15.000000', 'temperatura', 882.0000, 'ºC'),
	(348490, 146, '2015-02-01 00:21:16.000000', 'temperatura', 353.0000, 'ºC'),
	(348491, 146, '2015-02-01 00:21:17.000000', 'temperatura', 319.0000, 'ºC'),
	(348492, 146, '2015-02-01 00:21:18.000000', 'temperatura', 536.0000, 'ºC'),
	(348493, 146, '2015-02-01 00:21:19.000000', 'temperatura', 523.0000, 'ºC'),
	(348494, 146, '2015-02-01 00:21:20.000000', 'temperatura', 1007.0000, 'ºC'),
	(348495, 146, '2015-02-01 00:21:21.000000', 'temperatura', 1068.0000, 'ºC'),
	(348496, 146, '2015-02-01 00:21:22.000000', 'temperatura', 1121.0000, 'ºC'),
	(348497, 146, '2015-02-01 00:21:23.000000', 'temperatura', 1199.0000, 'ºC'),
	(348498, 146, '2015-02-01 00:21:24.000000', 'temperatura', 231.0000, 'ºC'),
	(348499, 146, '2015-02-01 00:21:25.000000', 'temperatura', 1162.0000, 'ºC'),
	(348500, 146, '2015-02-01 00:21:26.000000', 'temperatura', 314.0000, 'ºC'),
	(348501, 146, '2015-02-01 00:21:27.000000', 'temperatura', 488.0000, 'ºC'),
	(348502, 146, '2015-02-01 00:21:28.000000', 'temperatura', 297.0000, 'ºC'),
	(348503, 146, '2015-02-01 00:21:29.000000', 'temperatura', 20.0000, 'ºC'),
	(348504, 146, '2015-02-01 00:21:30.000000', 'temperatura', 412.0000, 'ºC'),
	(348505, 146, '2015-02-01 00:21:31.000000', 'temperatura', 798.0000, 'ºC'),
	(348506, 146, '2015-02-01 00:21:32.000000', 'temperatura', 356.0000, 'ºC'),
	(348507, 146, '2015-02-01 00:21:33.000000', 'temperatura', 587.0000, 'ºC'),
	(348508, 146, '2015-02-01 00:21:34.000000', 'temperatura', 665.0000, 'ºC'),
	(348509, 146, '2015-02-01 00:21:35.000000', 'temperatura', 365.0000, 'ºC'),
	(348510, 146, '2015-02-01 00:21:36.000000', 'temperatura', 1032.0000, 'ºC'),
	(348511, 146, '2015-02-01 00:21:37.000000', 'temperatura', 464.0000, 'ºC'),
	(348512, 146, '2015-02-01 00:21:38.000000', 'temperatura', 426.0000, 'ºC'),
	(348513, 146, '2015-02-01 00:21:39.000000', 'temperatura', 737.0000, 'ºC'),
	(348514, 146, '2015-02-01 00:21:40.000000', 'temperatura', 9.0000, 'ºC'),
	(348515, 146, '2015-02-01 00:21:41.000000', 'temperatura', 233.0000, 'ºC'),
	(348516, 146, '2015-02-01 00:21:42.000000', 'temperatura', 1138.0000, 'ºC'),
	(348517, 146, '2015-02-01 00:21:43.000000', 'temperatura', 193.0000, 'ºC'),
	(348518, 146, '2015-02-01 00:21:44.000000', 'temperatura', 1150.0000, 'ºC'),
	(348519, 146, '2015-02-01 00:21:45.000000', 'temperatura', 374.0000, 'ºC'),
	(348520, 146, '2015-02-01 00:21:46.000000', 'temperatura', 819.0000, 'ºC'),
	(348521, 146, '2015-02-01 00:21:47.000000', 'temperatura', 572.0000, 'ºC'),
	(348522, 146, '2015-02-01 00:21:48.000000', 'temperatura', 404.0000, 'ºC'),
	(348523, 146, '2015-02-01 00:21:49.000000', 'temperatura', 307.0000, 'ºC'),
	(348524, 146, '2015-02-01 00:21:50.000000', 'temperatura', 322.0000, 'ºC'),
	(348525, 146, '2015-02-01 00:21:51.000000', 'temperatura', 690.0000, 'ºC'),
	(348526, 146, '2015-02-01 00:21:52.000000', 'temperatura', 83.0000, 'ºC'),
	(348527, 146, '2015-02-01 00:21:53.000000', 'temperatura', 748.0000, 'ºC'),
	(348528, 146, '2015-02-01 00:21:54.000000', 'temperatura', 1092.0000, 'ºC'),
	(348529, 146, '2015-02-01 00:21:55.000000', 'temperatura', 815.0000, 'ºC'),
	(348530, 146, '2015-02-01 00:21:56.000000', 'temperatura', 799.0000, 'ºC'),
	(348531, 146, '2015-02-01 00:21:57.000000', 'temperatura', 351.0000, 'ºC'),
	(348532, 146, '2015-02-01 00:21:58.000000', 'temperatura', 557.0000, 'ºC'),
	(348533, 146, '2015-02-01 00:21:59.000000', 'temperatura', 533.0000, 'ºC'),
	(348534, 146, '2015-02-01 00:22:00.000000', 'temperatura', 993.0000, 'ºC'),
	(348535, 146, '2015-02-01 00:22:01.000000', 'temperatura', 967.0000, 'ºC'),
	(348536, 146, '2015-02-01 00:22:02.000000', 'temperatura', 659.0000, 'ºC'),
	(348537, 146, '2015-02-01 00:22:03.000000', 'temperatura', 393.0000, 'ºC'),
	(348538, 146, '2015-02-01 00:22:04.000000', 'temperatura', 1190.0000, 'ºC'),
	(348539, 146, '2015-02-01 00:22:05.000000', 'temperatura', 1170.0000, 'ºC'),
	(348540, 146, '2015-02-01 00:22:06.000000', 'temperatura', 1082.0000, 'ºC'),
	(348541, 146, '2015-02-01 00:22:07.000000', 'temperatura', 699.0000, 'ºC'),
	(348542, 146, '2015-02-01 00:22:08.000000', 'temperatura', 249.0000, 'ºC'),
	(348543, 146, '2015-02-01 00:22:09.000000', 'temperatura', 351.0000, 'ºC'),
	(348544, 146, '2015-02-01 00:22:10.000000', 'temperatura', 1008.0000, 'ºC'),
	(348545, 146, '2015-02-01 00:22:11.000000', 'temperatura', 388.0000, 'ºC'),
	(348546, 146, '2015-02-01 00:22:12.000000', 'temperatura', 117.0000, 'ºC'),
	(348547, 146, '2015-02-01 00:22:13.000000', 'temperatura', 620.0000, 'ºC'),
	(348548, 146, '2015-02-01 00:22:14.000000', 'temperatura', 349.0000, 'ºC'),
	(348549, 146, '2015-02-01 00:22:15.000000', 'temperatura', 1087.0000, 'ºC'),
	(348550, 146, '2015-02-01 00:22:16.000000', 'temperatura', 787.0000, 'ºC'),
	(348551, 146, '2015-02-01 00:22:17.000000', 'temperatura', 674.0000, 'ºC'),
	(348552, 146, '2015-02-01 00:22:18.000000', 'temperatura', 1012.0000, 'ºC'),
	(348553, 146, '2015-02-01 00:22:19.000000', 'temperatura', 637.0000, 'ºC'),
	(348554, 146, '2015-02-01 00:22:20.000000', 'temperatura', 149.0000, 'ºC'),
	(348555, 146, '2015-02-01 00:22:21.000000', 'temperatura', 35.0000, 'ºC'),
	(348556, 146, '2015-02-01 00:22:22.000000', 'temperatura', 929.0000, 'ºC'),
	(348557, 146, '2015-02-01 00:22:23.000000', 'temperatura', 942.0000, 'ºC'),
	(348558, 146, '2015-02-01 00:22:24.000000', 'temperatura', 721.0000, 'ºC'),
	(348559, 146, '2015-02-01 00:22:25.000000', 'temperatura', 782.0000, 'ºC'),
	(348560, 146, '2015-02-01 00:22:26.000000', 'temperatura', 548.0000, 'ºC'),
	(348561, 146, '2015-02-01 00:22:27.000000', 'temperatura', 392.0000, 'ºC'),
	(348562, 146, '2015-02-01 00:22:28.000000', 'temperatura', 319.0000, 'ºC'),
	(348563, 146, '2015-02-01 00:22:29.000000', 'temperatura', 419.0000, 'ºC'),
	(348564, 146, '2015-02-01 00:22:30.000000', 'temperatura', 1137.0000, 'ºC'),
	(348565, 146, '2015-02-01 00:22:31.000000', 'temperatura', 829.0000, 'ºC'),
	(348566, 146, '2015-02-01 00:22:32.000000', 'temperatura', 733.0000, 'ºC'),
	(348567, 146, '2015-02-01 00:22:33.000000', 'temperatura', 1180.0000, 'ºC'),
	(348568, 146, '2015-02-01 00:22:34.000000', 'temperatura', 103.0000, 'ºC'),
	(348569, 146, '2015-02-01 00:22:35.000000', 'temperatura', 574.0000, 'ºC'),
	(348570, 146, '2015-02-01 00:22:36.000000', 'temperatura', 161.0000, 'ºC'),
	(348571, 146, '2015-02-01 00:22:37.000000', 'temperatura', 285.0000, 'ºC'),
	(348572, 146, '2015-02-01 00:22:38.000000', 'temperatura', 941.0000, 'ºC'),
	(348573, 146, '2015-02-01 00:22:39.000000', 'temperatura', 249.0000, 'ºC'),
	(348574, 146, '2015-02-01 00:22:40.000000', 'temperatura', 824.0000, 'ºC'),
	(348575, 146, '2015-02-01 00:22:41.000000', 'temperatura', 972.0000, 'ºC'),
	(348576, 146, '2015-02-01 00:22:42.000000', 'temperatura', 1191.0000, 'ºC'),
	(348577, 146, '2015-02-01 00:22:43.000000', 'temperatura', 640.0000, 'ºC'),
	(348578, 146, '2015-02-01 00:22:44.000000', 'temperatura', 825.0000, 'ºC'),
	(348579, 146, '2015-02-01 00:22:45.000000', 'temperatura', 1005.0000, 'ºC'),
	(348580, 146, '2015-02-01 00:22:46.000000', 'temperatura', 153.0000, 'ºC'),
	(348581, 146, '2015-02-01 00:22:47.000000', 'temperatura', 150.0000, 'ºC'),
	(348582, 146, '2015-02-01 00:22:48.000000', 'temperatura', 292.0000, 'ºC'),
	(348583, 146, '2015-02-01 00:22:49.000000', 'temperatura', 1009.0000, 'ºC'),
	(348584, 146, '2015-02-01 00:22:50.000000', 'temperatura', 568.0000, 'ºC'),
	(348585, 146, '2015-02-01 00:22:51.000000', 'temperatura', 1016.0000, 'ºC'),
	(348586, 146, '2015-02-01 00:22:52.000000', 'temperatura', 977.0000, 'ºC'),
	(348587, 146, '2015-02-01 00:22:53.000000', 'temperatura', 635.0000, 'ºC'),
	(348588, 146, '2015-02-01 00:22:54.000000', 'temperatura', 248.0000, 'ºC'),
	(348589, 146, '2015-02-01 00:22:55.000000', 'temperatura', 533.0000, 'ºC'),
	(348590, 146, '2015-02-01 00:22:56.000000', 'temperatura', 720.0000, 'ºC'),
	(348591, 146, '2015-02-01 00:22:57.000000', 'temperatura', 804.0000, 'ºC'),
	(348592, 146, '2015-02-01 00:22:58.000000', 'temperatura', 660.0000, 'ºC'),
	(348593, 146, '2015-02-01 00:22:59.000000', 'temperatura', 889.0000, 'ºC'),
	(348594, 146, '2015-02-01 00:23:00.000000', 'temperatura', 66.0000, 'ºC'),
	(348595, 146, '2015-02-01 00:23:01.000000', 'temperatura', 63.0000, 'ºC'),
	(348596, 146, '2015-02-01 00:23:02.000000', 'temperatura', 116.0000, 'ºC'),
	(348597, 146, '2015-02-01 00:23:03.000000', 'temperatura', 393.0000, 'ºC'),
	(348598, 146, '2015-02-01 00:23:04.000000', 'temperatura', 417.0000, 'ºC'),
	(348599, 146, '2015-02-01 00:23:05.000000', 'temperatura', 908.0000, 'ºC'),
	(348600, 146, '2015-02-01 00:23:06.000000', 'temperatura', 889.0000, 'ºC'),
	(348601, 146, '2015-02-01 00:23:07.000000', 'temperatura', 522.0000, 'ºC'),
	(348602, 146, '2015-02-01 00:23:08.000000', 'temperatura', 1145.0000, 'ºC'),
	(348603, 146, '2015-02-01 00:23:09.000000', 'temperatura', 556.0000, 'ºC'),
	(348604, 146, '2015-02-01 00:23:10.000000', 'temperatura', 547.0000, 'ºC'),
	(348605, 146, '2015-02-01 00:23:11.000000', 'temperatura', 1069.0000, 'ºC'),
	(348606, 146, '2015-02-01 00:23:12.000000', 'temperatura', 105.0000, 'ºC'),
	(348607, 146, '2015-02-01 00:23:13.000000', 'temperatura', 915.0000, 'ºC'),
	(348608, 146, '2015-02-01 00:23:14.000000', 'temperatura', 664.0000, 'ºC'),
	(348609, 146, '2015-02-01 00:23:15.000000', 'temperatura', 575.0000, 'ºC'),
	(348610, 146, '2015-02-01 00:23:16.000000', 'temperatura', 883.0000, 'ºC'),
	(348611, 146, '2015-02-01 00:23:17.000000', 'temperatura', 290.0000, 'ºC'),
	(348612, 146, '2015-02-01 00:23:18.000000', 'temperatura', 2.0000, 'ºC'),
	(348613, 146, '2015-02-01 00:23:19.000000', 'temperatura', 342.0000, 'ºC'),
	(348614, 146, '2015-02-01 00:23:20.000000', 'temperatura', 503.0000, 'ºC'),
	(348615, 146, '2015-02-01 00:23:21.000000', 'temperatura', 290.0000, 'ºC'),
	(348616, 146, '2015-02-01 00:23:22.000000', 'temperatura', 1143.0000, 'ºC'),
	(348617, 146, '2015-02-01 00:23:23.000000', 'temperatura', 44.0000, 'ºC'),
	(348618, 146, '2015-02-01 00:23:24.000000', 'temperatura', 392.0000, 'ºC'),
	(348619, 146, '2015-02-01 00:23:25.000000', 'temperatura', 630.0000, 'ºC'),
	(348620, 146, '2015-02-01 00:23:26.000000', 'temperatura', 772.0000, 'ºC'),
	(348621, 146, '2015-02-01 00:23:27.000000', 'temperatura', 769.0000, 'ºC'),
	(348622, 146, '2015-02-01 00:23:28.000000', 'temperatura', 333.0000, 'ºC'),
	(348623, 146, '2015-02-01 00:23:29.000000', 'temperatura', 556.0000, 'ºC'),
	(348624, 146, '2015-02-01 00:23:30.000000', 'temperatura', 580.0000, 'ºC'),
	(348625, 146, '2015-02-01 00:23:31.000000', 'temperatura', 36.0000, 'ºC'),
	(348626, 146, '2015-02-01 00:23:32.000000', 'temperatura', 840.0000, 'ºC'),
	(348627, 146, '2015-02-01 00:23:33.000000', 'temperatura', 491.0000, 'ºC'),
	(348628, 146, '2015-02-01 00:23:34.000000', 'temperatura', 1137.0000, 'ºC'),
	(348629, 146, '2015-02-01 00:23:35.000000', 'temperatura', 610.0000, 'ºC'),
	(348630, 146, '2015-02-01 00:23:36.000000', 'temperatura', 841.0000, 'ºC'),
	(348631, 146, '2015-02-01 00:23:37.000000', 'temperatura', 1176.0000, 'ºC'),
	(348632, 146, '2015-02-01 00:23:38.000000', 'temperatura', 956.0000, 'ºC'),
	(348633, 146, '2015-02-01 00:23:39.000000', 'temperatura', 53.0000, 'ºC'),
	(348634, 146, '2015-02-01 00:23:40.000000', 'temperatura', 999.0000, 'ºC'),
	(348635, 146, '2015-02-01 00:23:41.000000', 'temperatura', 38.0000, 'ºC'),
	(348636, 146, '2015-02-01 00:23:42.000000', 'temperatura', 790.0000, 'ºC'),
	(348637, 146, '2015-02-01 00:23:43.000000', 'temperatura', 237.0000, 'ºC'),
	(348638, 146, '2015-02-01 00:23:44.000000', 'temperatura', 15.0000, 'ºC'),
	(348639, 146, '2015-02-01 00:23:45.000000', 'temperatura', 566.0000, 'ºC'),
	(348640, 146, '2015-02-01 00:23:46.000000', 'temperatura', 384.0000, 'ºC'),
	(348641, 146, '2015-02-01 00:23:47.000000', 'temperatura', 221.0000, 'ºC'),
	(348642, 146, '2015-02-01 00:23:48.000000', 'temperatura', 1157.0000, 'ºC'),
	(348643, 146, '2015-02-01 00:23:49.000000', 'temperatura', 321.0000, 'ºC'),
	(348644, 146, '2015-02-01 00:23:50.000000', 'temperatura', 533.0000, 'ºC'),
	(348645, 146, '2015-02-01 00:23:51.000000', 'temperatura', 505.0000, 'ºC'),
	(348646, 146, '2015-02-01 00:23:52.000000', 'temperatura', 927.0000, 'ºC'),
	(348647, 146, '2015-02-01 00:23:53.000000', 'temperatura', 719.0000, 'ºC'),
	(348648, 146, '2015-02-01 00:23:54.000000', 'temperatura', 817.0000, 'ºC'),
	(348649, 146, '2015-02-01 00:23:55.000000', 'temperatura', 727.0000, 'ºC'),
	(348650, 146, '2015-02-01 00:23:56.000000', 'temperatura', 1182.0000, 'ºC'),
	(348651, 146, '2015-02-01 00:23:57.000000', 'temperatura', 133.0000, 'ºC'),
	(348652, 146, '2015-02-01 00:23:58.000000', 'temperatura', 717.0000, 'ºC'),
	(348653, 146, '2015-02-01 00:23:59.000000', 'temperatura', 789.0000, 'ºC'),
	(348654, 146, '2015-02-01 00:24:00.000000', 'temperatura', 594.0000, 'ºC'),
	(348655, 146, '2015-02-01 00:24:01.000000', 'temperatura', 604.0000, 'ºC'),
	(348656, 146, '2015-02-01 00:24:02.000000', 'temperatura', 37.0000, 'ºC'),
	(348657, 146, '2015-02-01 00:24:03.000000', 'temperatura', 773.0000, 'ºC'),
	(348658, 146, '2015-02-01 00:24:04.000000', 'temperatura', 155.0000, 'ºC'),
	(348659, 146, '2015-02-01 00:24:05.000000', 'temperatura', 855.0000, 'ºC'),
	(348660, 146, '2015-02-01 00:24:06.000000', 'temperatura', 213.0000, 'ºC'),
	(348661, 146, '2015-02-01 00:24:07.000000', 'temperatura', 901.0000, 'ºC'),
	(348662, 146, '2015-02-01 00:24:08.000000', 'temperatura', 265.0000, 'ºC'),
	(348663, 146, '2015-02-01 00:24:09.000000', 'temperatura', 1022.0000, 'ºC'),
	(348664, 146, '2015-02-01 00:24:10.000000', 'temperatura', 716.0000, 'ºC'),
	(348665, 146, '2015-02-01 00:24:11.000000', 'temperatura', 515.0000, 'ºC'),
	(348666, 146, '2015-02-01 00:24:12.000000', 'temperatura', 427.0000, 'ºC'),
	(348667, 146, '2015-02-01 00:24:13.000000', 'temperatura', 590.0000, 'ºC'),
	(348668, 146, '2015-02-01 00:24:14.000000', 'temperatura', 471.0000, 'ºC'),
	(348669, 146, '2015-02-01 00:24:15.000000', 'temperatura', 586.0000, 'ºC'),
	(348670, 146, '2015-02-01 00:24:16.000000', 'temperatura', 319.0000, 'ºC'),
	(348671, 146, '2015-02-01 00:24:17.000000', 'temperatura', 1034.0000, 'ºC'),
	(348672, 146, '2015-02-01 00:24:18.000000', 'temperatura', 615.0000, 'ºC'),
	(348673, 146, '2015-02-01 00:24:19.000000', 'temperatura', 1175.0000, 'ºC'),
	(348674, 146, '2015-02-01 00:24:20.000000', 'temperatura', 430.0000, 'ºC'),
	(348675, 146, '2015-02-01 00:24:21.000000', 'temperatura', 1025.0000, 'ºC'),
	(348676, 146, '2015-02-01 00:24:22.000000', 'temperatura', 236.0000, 'ºC'),
	(348677, 146, '2015-02-01 00:24:23.000000', 'temperatura', 507.0000, 'ºC'),
	(348678, 146, '2015-02-01 00:24:24.000000', 'temperatura', 626.0000, 'ºC'),
	(348679, 146, '2015-02-01 00:24:25.000000', 'temperatura', 410.0000, 'ºC'),
	(348680, 146, '2015-02-01 00:24:26.000000', 'temperatura', 172.0000, 'ºC'),
	(348681, 146, '2015-02-01 00:24:27.000000', 'temperatura', 832.0000, 'ºC'),
	(348682, 146, '2015-02-01 00:24:28.000000', 'temperatura', 43.0000, 'ºC'),
	(348683, 146, '2015-02-01 00:24:29.000000', 'temperatura', 119.0000, 'ºC'),
	(348684, 146, '2015-02-01 00:24:30.000000', 'temperatura', 466.0000, 'ºC'),
	(348685, 146, '2015-02-01 00:24:31.000000', 'temperatura', 774.0000, 'ºC'),
	(348686, 146, '2015-02-01 00:24:32.000000', 'temperatura', 71.0000, 'ºC'),
	(348687, 146, '2015-02-01 00:24:33.000000', 'temperatura', 433.0000, 'ºC'),
	(348688, 146, '2015-02-01 00:24:34.000000', 'temperatura', 753.0000, 'ºC'),
	(348689, 146, '2015-02-01 00:24:35.000000', 'temperatura', 66.0000, 'ºC'),
	(348690, 146, '2015-02-01 00:24:36.000000', 'temperatura', 471.0000, 'ºC'),
	(348691, 146, '2015-02-01 00:24:37.000000', 'temperatura', 960.0000, 'ºC'),
	(348692, 146, '2015-02-01 00:24:38.000000', 'temperatura', 988.0000, 'ºC'),
	(348693, 146, '2015-02-01 00:24:39.000000', 'temperatura', 860.0000, 'ºC'),
	(348694, 146, '2015-02-01 00:24:40.000000', 'temperatura', 135.0000, 'ºC'),
	(348695, 146, '2015-02-01 00:24:41.000000', 'temperatura', 497.0000, 'ºC'),
	(348696, 146, '2015-02-01 00:24:42.000000', 'temperatura', 878.0000, 'ºC'),
	(348697, 146, '2015-02-01 00:24:43.000000', 'temperatura', 503.0000, 'ºC'),
	(348698, 146, '2015-02-01 00:24:44.000000', 'temperatura', 1079.0000, 'ºC'),
	(348699, 146, '2015-02-01 00:24:45.000000', 'temperatura', 289.0000, 'ºC'),
	(348700, 146, '2015-02-01 00:24:46.000000', 'temperatura', 608.0000, 'ºC'),
	(348701, 146, '2015-02-01 00:24:47.000000', 'temperatura', 972.0000, 'ºC'),
	(348702, 146, '2015-02-01 00:24:48.000000', 'temperatura', 636.0000, 'ºC'),
	(348703, 146, '2015-02-01 00:24:49.000000', 'temperatura', 264.0000, 'ºC'),
	(348704, 146, '2015-02-01 00:24:50.000000', 'temperatura', 612.0000, 'ºC'),
	(348705, 146, '2015-02-01 00:24:51.000000', 'temperatura', 1070.0000, 'ºC'),
	(348706, 146, '2015-02-01 00:24:52.000000', 'temperatura', 1114.0000, 'ºC'),
	(348707, 146, '2015-02-01 00:24:53.000000', 'temperatura', 1160.0000, 'ºC'),
	(348708, 146, '2015-02-01 00:24:54.000000', 'temperatura', 59.0000, 'ºC'),
	(348709, 146, '2015-02-01 00:24:55.000000', 'temperatura', 413.0000, 'ºC'),
	(348710, 146, '2015-02-01 00:24:56.000000', 'temperatura', 692.0000, 'ºC'),
	(348711, 146, '2015-02-01 00:24:57.000000', 'temperatura', 1020.0000, 'ºC'),
	(348712, 146, '2015-02-01 00:24:58.000000', 'temperatura', 623.0000, 'ºC'),
	(348713, 146, '2015-02-01 00:24:59.000000', 'temperatura', 57.0000, 'ºC'),
	(348714, 146, '2015-02-01 00:25:00.000000', 'temperatura', 815.0000, 'ºC'),
	(348715, 146, '2015-02-01 00:25:01.000000', 'temperatura', 305.0000, 'ºC'),
	(348716, 146, '2015-02-01 00:25:02.000000', 'temperatura', 282.0000, 'ºC'),
	(348717, 146, '2015-02-01 00:25:03.000000', 'temperatura', 494.0000, 'ºC'),
	(348718, 146, '2015-02-01 00:25:04.000000', 'temperatura', 424.0000, 'ºC'),
	(348719, 146, '2015-02-01 00:25:05.000000', 'temperatura', 640.0000, 'ºC'),
	(348720, 146, '2015-02-01 00:25:06.000000', 'temperatura', 730.0000, 'ºC'),
	(348721, 146, '2015-02-01 00:25:07.000000', 'temperatura', 528.0000, 'ºC'),
	(348722, 146, '2015-02-01 00:25:08.000000', 'temperatura', 453.0000, 'ºC'),
	(348723, 146, '2015-02-01 00:25:09.000000', 'temperatura', 679.0000, 'ºC'),
	(348724, 146, '2015-02-01 00:25:10.000000', 'temperatura', 836.0000, 'ºC'),
	(348725, 146, '2015-02-01 00:25:11.000000', 'temperatura', 944.0000, 'ºC'),
	(348726, 146, '2015-02-01 00:25:12.000000', 'temperatura', 1014.0000, 'ºC'),
	(348727, 146, '2015-02-01 00:25:13.000000', 'temperatura', 1037.0000, 'ºC'),
	(348728, 146, '2015-02-01 00:25:14.000000', 'temperatura', 943.0000, 'ºC'),
	(348729, 146, '2015-02-01 00:25:15.000000', 'temperatura', 405.0000, 'ºC'),
	(348730, 146, '2015-02-01 00:25:16.000000', 'temperatura', 398.0000, 'ºC'),
	(348731, 146, '2015-02-01 00:25:17.000000', 'temperatura', 775.0000, 'ºC'),
	(348732, 146, '2015-02-01 00:25:18.000000', 'temperatura', 280.0000, 'ºC'),
	(348733, 146, '2015-02-01 00:25:19.000000', 'temperatura', 277.0000, 'ºC'),
	(348734, 146, '2015-02-01 00:25:20.000000', 'temperatura', 546.0000, 'ºC'),
	(348735, 146, '2015-02-01 00:25:21.000000', 'temperatura', 697.0000, 'ºC'),
	(348736, 146, '2015-02-01 00:25:22.000000', 'temperatura', 649.0000, 'ºC'),
	(348737, 146, '2015-02-01 00:25:23.000000', 'temperatura', 1152.0000, 'ºC'),
	(348738, 146, '2015-02-01 00:25:24.000000', 'temperatura', 217.0000, 'ºC'),
	(348739, 146, '2015-02-01 00:25:25.000000', 'temperatura', 29.0000, 'ºC'),
	(348740, 146, '2015-02-01 00:25:26.000000', 'temperatura', 693.0000, 'ºC'),
	(348741, 146, '2015-02-01 00:25:27.000000', 'temperatura', 979.0000, 'ºC'),
	(348742, 146, '2015-02-01 00:25:28.000000', 'temperatura', 417.0000, 'ºC'),
	(348743, 146, '2015-02-01 00:25:29.000000', 'temperatura', 349.0000, 'ºC'),
	(348744, 146, '2015-02-01 00:25:30.000000', 'temperatura', 496.0000, 'ºC'),
	(348745, 146, '2015-02-01 00:25:31.000000', 'temperatura', 230.0000, 'ºC'),
	(348746, 146, '2015-02-01 00:25:32.000000', 'temperatura', 865.0000, 'ºC'),
	(348747, 146, '2015-02-01 00:25:33.000000', 'temperatura', 34.0000, 'ºC'),
	(348748, 146, '2015-02-01 00:25:34.000000', 'temperatura', 1178.0000, 'ºC'),
	(348749, 146, '2015-02-01 00:25:35.000000', 'temperatura', 987.0000, 'ºC'),
	(348750, 146, '2015-02-01 00:25:36.000000', 'temperatura', 202.0000, 'ºC'),
	(348751, 146, '2015-02-01 00:25:37.000000', 'temperatura', 449.0000, 'ºC'),
	(348752, 146, '2015-02-01 00:25:38.000000', 'temperatura', 441.0000, 'ºC'),
	(348753, 146, '2015-02-01 00:25:39.000000', 'temperatura', 858.0000, 'ºC'),
	(348754, 146, '2015-02-01 00:25:40.000000', 'temperatura', 568.0000, 'ºC'),
	(348755, 146, '2015-02-01 00:25:41.000000', 'temperatura', 268.0000, 'ºC'),
	(348756, 146, '2015-02-01 00:25:42.000000', 'temperatura', 835.0000, 'ºC'),
	(348757, 146, '2015-02-01 00:25:43.000000', 'temperatura', 973.0000, 'ºC'),
	(348758, 146, '2015-02-01 00:25:44.000000', 'temperatura', 1160.0000, 'ºC'),
	(348759, 146, '2015-02-01 00:25:45.000000', 'temperatura', 481.0000, 'ºC'),
	(348760, 146, '2015-02-01 00:25:46.000000', 'temperatura', 126.0000, 'ºC'),
	(348761, 146, '2015-02-01 00:25:47.000000', 'temperatura', 386.0000, 'ºC'),
	(348762, 146, '2015-02-01 00:25:48.000000', 'temperatura', 355.0000, 'ºC'),
	(348763, 146, '2015-02-01 00:25:49.000000', 'temperatura', 618.0000, 'ºC'),
	(348764, 146, '2015-02-01 00:25:50.000000', 'temperatura', 823.0000, 'ºC'),
	(348765, 146, '2015-02-01 00:25:51.000000', 'temperatura', 1063.0000, 'ºC'),
	(348766, 146, '2015-02-01 00:25:52.000000', 'temperatura', 445.0000, 'ºC'),
	(348767, 146, '2015-02-01 00:25:53.000000', 'temperatura', 239.0000, 'ºC'),
	(348768, 146, '2015-02-01 00:25:54.000000', 'temperatura', 1057.0000, 'ºC'),
	(348769, 146, '2015-02-01 00:25:55.000000', 'temperatura', 972.0000, 'ºC'),
	(348770, 146, '2015-02-01 00:25:56.000000', 'temperatura', 488.0000, 'ºC'),
	(348771, 146, '2015-02-01 00:25:57.000000', 'temperatura', 724.0000, 'ºC'),
	(348772, 146, '2015-02-01 00:25:58.000000', 'temperatura', 956.0000, 'ºC'),
	(348773, 146, '2015-02-01 00:25:59.000000', 'temperatura', 207.0000, 'ºC'),
	(348774, 146, '2015-02-01 00:26:00.000000', 'temperatura', 570.0000, 'ºC'),
	(348775, 146, '2015-02-01 00:26:01.000000', 'temperatura', 1028.0000, 'ºC'),
	(348776, 146, '2015-02-01 00:26:02.000000', 'temperatura', 1030.0000, 'ºC'),
	(348777, 146, '2015-02-01 00:26:03.000000', 'temperatura', 868.0000, 'ºC'),
	(348778, 146, '2015-02-01 00:26:04.000000', 'temperatura', 50.0000, 'ºC'),
	(348779, 146, '2015-02-01 00:26:05.000000', 'temperatura', 46.0000, 'ºC'),
	(348780, 146, '2015-02-01 00:26:06.000000', 'temperatura', 81.0000, 'ºC'),
	(348781, 146, '2015-02-01 00:26:07.000000', 'temperatura', 267.0000, 'ºC'),
	(348782, 146, '2015-02-01 00:26:08.000000', 'temperatura', 1093.0000, 'ºC'),
	(348783, 146, '2015-02-01 00:26:09.000000', 'temperatura', 1063.0000, 'ºC'),
	(348784, 146, '2015-02-01 00:26:10.000000', 'temperatura', 837.0000, 'ºC'),
	(348785, 146, '2015-02-01 00:26:11.000000', 'temperatura', 995.0000, 'ºC'),
	(348786, 146, '2015-02-01 00:26:12.000000', 'temperatura', 68.0000, 'ºC'),
	(348787, 146, '2015-02-01 00:26:13.000000', 'temperatura', 952.0000, 'ºC'),
	(348788, 146, '2015-02-01 00:26:14.000000', 'temperatura', 958.0000, 'ºC'),
	(348789, 146, '2015-02-01 00:26:15.000000', 'temperatura', 736.0000, 'ºC'),
	(348790, 146, '2015-02-01 00:26:16.000000', 'temperatura', 804.0000, 'ºC'),
	(348791, 146, '2015-02-01 00:26:17.000000', 'temperatura', 615.0000, 'ºC'),
	(348792, 146, '2015-02-01 00:26:18.000000', 'temperatura', 664.0000, 'ºC'),
	(348793, 146, '2015-02-01 00:26:19.000000', 'temperatura', 274.0000, 'ºC'),
	(348794, 146, '2015-02-01 00:26:20.000000', 'temperatura', 580.0000, 'ºC'),
	(348795, 146, '2015-02-01 00:26:21.000000', 'temperatura', 877.0000, 'ºC'),
	(348796, 146, '2015-02-01 00:26:22.000000', 'temperatura', 246.0000, 'ºC'),
	(348797, 146, '2015-02-01 00:26:23.000000', 'temperatura', 998.0000, 'ºC'),
	(348798, 146, '2015-02-01 00:26:24.000000', 'temperatura', 654.0000, 'ºC'),
	(348799, 146, '2015-02-01 00:26:25.000000', 'temperatura', 278.0000, 'ºC'),
	(348800, 146, '2015-02-01 00:26:26.000000', 'temperatura', 626.0000, 'ºC'),
	(348801, 146, '2015-02-01 00:26:27.000000', 'temperatura', 1096.0000, 'ºC'),
	(348802, 146, '2015-02-01 00:26:28.000000', 'temperatura', 3.0000, 'ºC'),
	(348803, 146, '2015-02-01 00:26:29.000000', 'temperatura', 327.0000, 'ºC'),
	(348804, 146, '2015-02-01 00:26:30.000000', 'temperatura', 427.0000, 'ºC'),
	(348805, 146, '2015-02-01 00:26:31.000000', 'temperatura', 1155.0000, 'ºC'),
	(348806, 146, '2015-02-01 00:26:32.000000', 'temperatura', 892.0000, 'ºC'),
	(348807, 146, '2015-02-01 00:26:33.000000', 'temperatura', 998.0000, 'ºC'),
	(348808, 146, '2015-02-01 00:26:34.000000', 'temperatura', 1116.0000, 'ºC'),
	(348809, 146, '2015-02-01 00:26:35.000000', 'temperatura', 183.0000, 'ºC'),
	(348810, 146, '2015-02-01 00:26:36.000000', 'temperatura', 1170.0000, 'ºC'),
	(348811, 146, '2015-02-01 00:26:37.000000', 'temperatura', 502.0000, 'ºC'),
	(348812, 146, '2015-02-01 00:26:38.000000', 'temperatura', 200.0000, 'ºC'),
	(348813, 146, '2015-02-01 00:26:39.000000', 'temperatura', 695.0000, 'ºC'),
	(348814, 146, '2015-02-01 00:26:40.000000', 'temperatura', 477.0000, 'ºC'),
	(348815, 146, '2015-02-01 00:26:41.000000', 'temperatura', 298.0000, 'ºC'),
	(348816, 146, '2015-02-01 00:26:42.000000', 'temperatura', 62.0000, 'ºC'),
	(348817, 146, '2015-02-01 00:26:43.000000', 'temperatura', 615.0000, 'ºC'),
	(348818, 146, '2015-02-01 00:26:44.000000', 'temperatura', 488.0000, 'ºC'),
	(348819, 146, '2015-02-01 00:26:45.000000', 'temperatura', 596.0000, 'ºC'),
	(348820, 146, '2015-02-01 00:26:46.000000', 'temperatura', 317.0000, 'ºC'),
	(348821, 146, '2015-02-01 00:26:47.000000', 'temperatura', 999.0000, 'ºC'),
	(348822, 146, '2015-02-01 00:26:48.000000', 'temperatura', 443.0000, 'ºC'),
	(348823, 146, '2015-02-01 00:26:49.000000', 'temperatura', 419.0000, 'ºC'),
	(348824, 146, '2015-02-01 00:26:50.000000', 'temperatura', 768.0000, 'ºC'),
	(348825, 146, '2015-02-01 00:26:51.000000', 'temperatura', 182.0000, 'ºC'),
	(348826, 146, '2015-02-01 00:26:52.000000', 'temperatura', 1007.0000, 'ºC'),
	(348827, 146, '2015-02-01 00:26:53.000000', 'temperatura', 890.0000, 'ºC'),
	(348828, 146, '2015-02-01 00:26:54.000000', 'temperatura', 227.0000, 'ºC'),
	(348829, 146, '2015-02-01 00:26:55.000000', 'temperatura', 869.0000, 'ºC'),
	(348830, 146, '2015-02-01 00:26:56.000000', 'temperatura', 62.0000, 'ºC'),
	(348831, 146, '2015-02-01 00:26:57.000000', 'temperatura', 106.0000, 'ºC'),
	(348832, 146, '2015-02-01 00:26:58.000000', 'temperatura', 344.0000, 'ºC'),
	(348833, 146, '2015-02-01 00:26:59.000000', 'temperatura', 203.0000, 'ºC'),
	(348834, 146, '2015-02-01 00:27:00.000000', 'temperatura', 1182.0000, 'ºC'),
	(348835, 146, '2015-02-01 00:27:01.000000', 'temperatura', 504.0000, 'ºC'),
	(348836, 146, '2015-02-01 00:27:02.000000', 'temperatura', 172.0000, 'ºC'),
	(348837, 146, '2015-02-01 00:27:03.000000', 'temperatura', 550.0000, 'ºC'),
	(348838, 146, '2015-02-01 00:27:04.000000', 'temperatura', 1036.0000, 'ºC'),
	(348839, 146, '2015-02-01 00:27:05.000000', 'temperatura', 1128.0000, 'ºC'),
	(348840, 146, '2015-02-01 00:27:06.000000', 'temperatura', 131.0000, 'ºC'),
	(348841, 146, '2015-02-01 00:27:07.000000', 'temperatura', 875.0000, 'ºC'),
	(348842, 146, '2015-02-01 00:27:08.000000', 'temperatura', 380.0000, 'ºC'),
	(348843, 146, '2015-02-01 00:27:09.000000', 'temperatura', 478.0000, 'ºC'),
	(348844, 146, '2015-02-01 00:27:10.000000', 'temperatura', 48.0000, 'ºC'),
	(348845, 146, '2015-02-01 00:27:11.000000', 'temperatura', 6.0000, 'ºC'),
	(348846, 146, '2015-02-01 00:27:12.000000', 'temperatura', 1086.0000, 'ºC'),
	(348847, 146, '2015-02-01 00:27:13.000000', 'temperatura', 613.0000, 'ºC'),
	(348848, 146, '2015-02-01 00:27:14.000000', 'temperatura', 1008.0000, 'ºC'),
	(348849, 146, '2015-02-01 00:27:15.000000', 'temperatura', 800.0000, 'ºC'),
	(348850, 146, '2015-02-01 00:27:16.000000', 'temperatura', 976.0000, 'ºC'),
	(348851, 146, '2015-02-01 00:27:17.000000', 'temperatura', 80.0000, 'ºC'),
	(348852, 146, '2015-02-01 00:27:18.000000', 'temperatura', 1075.0000, 'ºC'),
	(348853, 146, '2015-02-01 00:27:19.000000', 'temperatura', 336.0000, 'ºC'),
	(348854, 146, '2015-02-01 00:27:20.000000', 'temperatura', 856.0000, 'ºC'),
	(348855, 146, '2015-02-01 00:27:21.000000', 'temperatura', 872.0000, 'ºC'),
	(348856, 146, '2015-02-01 00:27:22.000000', 'temperatura', 592.0000, 'ºC'),
	(348857, 146, '2015-02-01 00:27:23.000000', 'temperatura', 345.0000, 'ºC'),
	(348858, 146, '2015-02-01 00:27:24.000000', 'temperatura', 1151.0000, 'ºC'),
	(348859, 146, '2015-02-01 00:27:25.000000', 'temperatura', 1119.0000, 'ºC'),
	(348860, 146, '2015-02-01 00:27:26.000000', 'temperatura', 942.0000, 'ºC'),
	(348861, 146, '2015-02-01 00:27:27.000000', 'temperatura', 152.0000, 'ºC'),
	(348862, 146, '2015-02-01 00:27:28.000000', 'temperatura', 336.0000, 'ºC'),
	(348863, 146, '2015-02-01 00:27:29.000000', 'temperatura', 22.0000, 'ºC'),
	(348864, 146, '2015-02-01 00:27:30.000000', 'temperatura', 306.0000, 'ºC'),
	(348865, 146, '2015-02-01 00:27:31.000000', 'temperatura', 264.0000, 'ºC'),
	(348866, 146, '2015-02-01 00:27:32.000000', 'temperatura', 400.0000, 'ºC'),
	(348867, 146, '2015-02-01 00:27:33.000000', 'temperatura', 12.0000, 'ºC'),
	(348868, 146, '2015-02-01 00:27:34.000000', 'temperatura', 59.0000, 'ºC'),
	(348869, 146, '2015-02-01 00:27:35.000000', 'temperatura', 259.0000, 'ºC'),
	(348870, 146, '2015-02-01 00:27:36.000000', 'temperatura', 1118.0000, 'ºC'),
	(348871, 146, '2015-02-01 00:27:37.000000', 'temperatura', 12.0000, 'ºC'),
	(348872, 146, '2015-02-01 00:27:38.000000', 'temperatura', 309.0000, 'ºC'),
	(348873, 146, '2015-02-01 00:27:39.000000', 'temperatura', 310.0000, 'ºC'),
	(348874, 146, '2015-02-01 00:27:40.000000', 'temperatura', 624.0000, 'ºC'),
	(348875, 146, '2015-02-01 00:27:41.000000', 'temperatura', 988.0000, 'ºC'),
	(348876, 146, '2015-02-01 00:27:42.000000', 'temperatura', 669.0000, 'ºC'),
	(348877, 146, '2015-02-01 00:27:43.000000', 'temperatura', 384.0000, 'ºC'),
	(348878, 146, '2015-02-01 00:27:44.000000', 'temperatura', 1111.0000, 'ºC'),
	(348879, 146, '2015-02-01 00:27:45.000000', 'temperatura', 806.0000, 'ºC'),
	(348880, 146, '2015-02-01 00:27:46.000000', 'temperatura', 698.0000, 'ºC'),
	(348881, 146, '2015-02-01 00:27:47.000000', 'temperatura', 1069.0000, 'ºC'),
	(348882, 146, '2015-02-01 00:27:48.000000', 'temperatura', 854.0000, 'ºC'),
	(348883, 146, '2015-02-01 00:27:49.000000', 'temperatura', 1062.0000, 'ºC'),
	(348884, 146, '2015-02-01 00:27:50.000000', 'temperatura', 350.0000, 'ºC'),
	(348885, 146, '2015-02-01 00:27:51.000000', 'temperatura', 965.0000, 'ºC'),
	(348886, 146, '2015-02-01 00:27:52.000000', 'temperatura', 174.0000, 'ºC'),
	(348887, 146, '2015-02-01 00:27:53.000000', 'temperatura', 378.0000, 'ºC'),
	(348888, 146, '2015-02-01 00:27:54.000000', 'temperatura', 167.0000, 'ºC'),
	(348889, 146, '2015-02-01 00:27:55.000000', 'temperatura', 903.0000, 'ºC'),
	(348890, 146, '2015-02-01 00:27:56.000000', 'temperatura', 413.0000, 'ºC'),
	(348891, 146, '2015-02-01 00:27:57.000000', 'temperatura', 556.0000, 'ºC'),
	(348892, 146, '2015-02-01 00:27:58.000000', 'temperatura', 344.0000, 'ºC'),
	(348893, 146, '2015-02-01 00:27:59.000000', 'temperatura', 51.0000, 'ºC'),
	(348894, 146, '2015-02-01 00:28:00.000000', 'temperatura', 425.0000, 'ºC'),
	(348895, 146, '2015-02-01 00:28:01.000000', 'temperatura', 770.0000, 'ºC'),
	(348896, 146, '2015-02-01 00:28:02.000000', 'temperatura', 176.0000, 'ºC'),
	(348897, 146, '2015-02-01 00:28:03.000000', 'temperatura', 969.0000, 'ºC'),
	(348898, 146, '2015-02-01 00:28:04.000000', 'temperatura', 721.0000, 'ºC'),
	(348899, 146, '2015-02-01 00:28:05.000000', 'temperatura', 696.0000, 'ºC'),
	(348900, 146, '2015-02-01 00:28:06.000000', 'temperatura', 120.0000, 'ºC'),
	(348901, 146, '2015-02-01 00:28:07.000000', 'temperatura', 912.0000, 'ºC'),
	(348902, 146, '2015-02-01 00:28:08.000000', 'temperatura', 602.0000, 'ºC'),
	(348903, 146, '2015-02-01 00:28:09.000000', 'temperatura', 272.0000, 'ºC'),
	(348904, 146, '2015-02-01 00:28:10.000000', 'temperatura', 756.0000, 'ºC'),
	(348905, 146, '2015-02-01 00:28:11.000000', 'temperatura', 563.0000, 'ºC'),
	(348906, 146, '2015-02-01 00:28:12.000000', 'temperatura', 549.0000, 'ºC'),
	(348907, 146, '2015-02-01 00:28:13.000000', 'temperatura', 1055.0000, 'ºC'),
	(348908, 146, '2015-02-01 00:28:14.000000', 'temperatura', 27.0000, 'ºC'),
	(348909, 146, '2015-02-01 00:28:15.000000', 'temperatura', 573.0000, 'ºC'),
	(348910, 146, '2015-02-01 00:28:16.000000', 'temperatura', 384.0000, 'ºC'),
	(348911, 146, '2015-02-01 00:28:17.000000', 'temperatura', 202.0000, 'ºC'),
	(348912, 146, '2015-02-01 00:28:18.000000', 'temperatura', 1057.0000, 'ºC'),
	(348913, 146, '2015-02-01 00:28:19.000000', 'temperatura', 1082.0000, 'ºC'),
	(348914, 146, '2015-02-01 00:28:20.000000', 'temperatura', 1036.0000, 'ºC'),
	(348915, 146, '2015-02-01 00:28:21.000000', 'temperatura', 737.0000, 'ºC'),
	(348916, 146, '2015-02-01 00:28:22.000000', 'temperatura', 578.0000, 'ºC'),
	(348917, 146, '2015-02-01 00:28:23.000000', 'temperatura', 680.0000, 'ºC'),
	(348918, 146, '2015-02-01 00:28:24.000000', 'temperatura', 466.0000, 'ºC'),
	(348919, 146, '2015-02-01 00:28:25.000000', 'temperatura', 289.0000, 'ºC'),
	(348920, 146, '2015-02-01 00:28:26.000000', 'temperatura', 48.0000, 'ºC'),
	(348921, 146, '2015-02-01 00:28:27.000000', 'temperatura', 576.0000, 'ºC'),
	(348922, 146, '2015-02-01 00:28:28.000000', 'temperatura', 333.0000, 'ºC'),
	(348923, 146, '2015-02-01 00:28:29.000000', 'temperatura', 1139.0000, 'ºC'),
	(348924, 146, '2015-02-01 00:28:30.000000', 'temperatura', 1097.0000, 'ºC'),
	(348925, 146, '2015-02-01 00:28:31.000000', 'temperatura', 870.0000, 'ºC'),
	(348926, 146, '2015-02-01 00:28:32.000000', 'temperatura', 1057.0000, 'ºC'),
	(348927, 146, '2015-02-01 00:28:33.000000', 'temperatura', 278.0000, 'ºC'),
	(348928, 146, '2015-02-01 00:28:34.000000', 'temperatura', 618.0000, 'ºC'),
	(348929, 146, '2015-02-01 00:28:35.000000', 'temperatura', 1057.0000, 'ºC'),
	(348930, 146, '2015-02-01 00:28:36.000000', 'temperatura', 1029.0000, 'ºC'),
	(348931, 146, '2015-02-01 00:28:37.000000', 'temperatura', 778.0000, 'ºC'),
	(348932, 146, '2015-02-01 00:28:38.000000', 'temperatura', 803.0000, 'ºC'),
	(348933, 146, '2015-02-01 00:28:39.000000', 'temperatura', 480.0000, 'ºC'),
	(348934, 146, '2015-02-01 00:28:40.000000', 'temperatura', 1192.0000, 'ºC'),
	(348935, 146, '2015-02-01 00:28:41.000000', 'temperatura', 921.0000, 'ºC'),
	(348936, 146, '2015-02-01 00:28:42.000000', 'temperatura', 1030.0000, 'ºC'),
	(348937, 146, '2015-02-01 00:28:43.000000', 'temperatura', 1186.0000, 'ºC'),
	(348938, 146, '2015-02-01 00:28:44.000000', 'temperatura', 443.0000, 'ºC'),
	(348939, 146, '2015-02-01 00:28:45.000000', 'temperatura', 1056.0000, 'ºC'),
	(348940, 146, '2015-02-01 00:28:46.000000', 'temperatura', 351.0000, 'ºC'),
	(348941, 146, '2015-02-01 00:28:47.000000', 'temperatura', 988.0000, 'ºC'),
	(348942, 146, '2015-02-01 00:28:48.000000', 'temperatura', 287.0000, 'ºC'),
	(348943, 146, '2015-02-01 00:28:49.000000', 'temperatura', 874.0000, 'ºC'),
	(348944, 146, '2015-02-01 00:28:50.000000', 'temperatura', 1107.0000, 'ºC'),
	(348945, 146, '2015-02-01 00:28:51.000000', 'temperatura', 515.0000, 'ºC'),
	(348946, 146, '2015-02-01 00:28:52.000000', 'temperatura', 455.0000, 'ºC'),
	(348947, 146, '2015-02-01 00:28:53.000000', 'temperatura', 728.0000, 'ºC'),
	(348948, 146, '2015-02-01 00:28:54.000000', 'temperatura', 1079.0000, 'ºC'),
	(348949, 146, '2015-02-01 00:28:55.000000', 'temperatura', 808.0000, 'ºC'),
	(348950, 146, '2015-02-01 00:28:56.000000', 'temperatura', 806.0000, 'ºC'),
	(348951, 146, '2015-02-01 00:28:57.000000', 'temperatura', 406.0000, 'ºC'),
	(348952, 146, '2015-02-01 00:28:58.000000', 'temperatura', 813.0000, 'ºC'),
	(348953, 146, '2015-02-01 00:28:59.000000', 'temperatura', 449.0000, 'ºC'),
	(348954, 146, '2015-02-01 00:29:00.000000', 'temperatura', 1003.0000, 'ºC'),
	(348955, 146, '2015-02-01 00:29:01.000000', 'temperatura', 71.0000, 'ºC'),
	(348956, 146, '2015-02-01 00:29:02.000000', 'temperatura', 946.0000, 'ºC'),
	(348957, 146, '2015-02-01 00:29:03.000000', 'temperatura', 918.0000, 'ºC'),
	(348958, 146, '2015-02-01 00:29:04.000000', 'temperatura', 554.0000, 'ºC'),
	(348959, 146, '2015-02-01 00:29:05.000000', 'temperatura', 15.0000, 'ºC'),
	(348960, 146, '2015-02-01 00:29:06.000000', 'temperatura', 814.0000, 'ºC'),
	(348961, 146, '2015-02-01 00:29:07.000000', 'temperatura', 424.0000, 'ºC'),
	(348962, 146, '2015-02-01 00:29:08.000000', 'temperatura', 880.0000, 'ºC'),
	(348963, 146, '2015-02-01 00:29:09.000000', 'temperatura', 729.0000, 'ºC'),
	(348964, 146, '2015-02-01 00:29:10.000000', 'temperatura', 1006.0000, 'ºC'),
	(348965, 146, '2015-02-01 00:29:11.000000', 'temperatura', 442.0000, 'ºC'),
	(348966, 146, '2015-02-01 00:29:12.000000', 'temperatura', 392.0000, 'ºC'),
	(348967, 146, '2015-02-01 00:29:13.000000', 'temperatura', 634.0000, 'ºC'),
	(348968, 146, '2015-02-01 00:29:14.000000', 'temperatura', 797.0000, 'ºC'),
	(348969, 146, '2015-02-01 00:29:15.000000', 'temperatura', 882.0000, 'ºC'),
	(348970, 146, '2015-02-01 00:29:16.000000', 'temperatura', 821.0000, 'ºC'),
	(348971, 146, '2015-02-01 00:29:17.000000', 'temperatura', 259.0000, 'ºC'),
	(348972, 146, '2015-02-01 00:29:18.000000', 'temperatura', 34.0000, 'ºC'),
	(348973, 146, '2015-02-01 00:29:19.000000', 'temperatura', 593.0000, 'ºC'),
	(348974, 146, '2015-02-01 00:29:20.000000', 'temperatura', 464.0000, 'ºC'),
	(348975, 146, '2015-02-01 00:29:21.000000', 'temperatura', 540.0000, 'ºC'),
	(348976, 146, '2015-02-01 00:29:22.000000', 'temperatura', 111.0000, 'ºC'),
	(348977, 146, '2015-02-01 00:29:23.000000', 'temperatura', 133.0000, 'ºC'),
	(348978, 146, '2015-02-01 00:29:24.000000', 'temperatura', 334.0000, 'ºC'),
	(348979, 146, '2015-02-01 00:29:25.000000', 'temperatura', 71.0000, 'ºC'),
	(348980, 146, '2015-02-01 00:29:26.000000', 'temperatura', 554.0000, 'ºC'),
	(348981, 146, '2015-02-01 00:29:27.000000', 'temperatura', 157.0000, 'ºC'),
	(348982, 146, '2015-02-01 00:29:28.000000', 'temperatura', 323.0000, 'ºC'),
	(348983, 146, '2015-02-01 00:29:29.000000', 'temperatura', 1143.0000, 'ºC'),
	(348984, 146, '2015-02-01 00:29:30.000000', 'temperatura', 1147.0000, 'ºC'),
	(348985, 146, '2015-02-01 00:29:31.000000', 'temperatura', 1108.0000, 'ºC'),
	(348986, 146, '2015-02-01 00:29:32.000000', 'temperatura', 897.0000, 'ºC'),
	(348987, 146, '2015-02-01 00:29:33.000000', 'temperatura', 1162.0000, 'ºC'),
	(348988, 146, '2015-02-01 00:29:34.000000', 'temperatura', 719.0000, 'ºC'),
	(348989, 146, '2015-02-01 00:29:35.000000', 'temperatura', 111.0000, 'ºC'),
	(348990, 146, '2015-02-01 00:29:36.000000', 'temperatura', 800.0000, 'ºC'),
	(348991, 146, '2015-02-01 00:29:37.000000', 'temperatura', 64.0000, 'ºC'),
	(348992, 146, '2015-02-01 00:29:38.000000', 'temperatura', 322.0000, 'ºC'),
	(348993, 146, '2015-02-01 00:29:39.000000', 'temperatura', 220.0000, 'ºC'),
	(348994, 146, '2015-02-01 00:29:40.000000', 'temperatura', 134.0000, 'ºC'),
	(348995, 146, '2015-02-01 00:29:41.000000', 'temperatura', 11.0000, 'ºC'),
	(348996, 146, '2015-02-01 00:29:42.000000', 'temperatura', 852.0000, 'ºC'),
	(348997, 146, '2015-02-01 00:29:43.000000', 'temperatura', 627.0000, 'ºC'),
	(348998, 146, '2015-02-01 00:29:44.000000', 'temperatura', 582.0000, 'ºC'),
	(348999, 146, '2015-02-01 00:29:45.000000', 'temperatura', 1028.0000, 'ºC'),
	(349000, 146, '2015-02-01 00:29:46.000000', 'temperatura', 996.0000, 'ºC'),
	(349001, 146, '2015-02-01 00:29:47.000000', 'temperatura', 697.0000, 'ºC'),
	(349002, 146, '2015-02-01 00:29:48.000000', 'temperatura', 498.0000, 'ºC'),
	(349003, 146, '2015-02-01 00:29:49.000000', 'temperatura', 397.0000, 'ºC'),
	(349004, 146, '2015-02-01 00:29:50.000000', 'temperatura', 493.0000, 'ºC'),
	(349005, 146, '2015-02-01 00:29:51.000000', 'temperatura', 72.0000, 'ºC'),
	(349006, 146, '2015-02-01 00:29:52.000000', 'temperatura', 85.0000, 'ºC'),
	(349007, 146, '2015-02-01 00:29:53.000000', 'temperatura', 208.0000, 'ºC'),
	(349008, 146, '2015-02-01 00:29:54.000000', 'temperatura', 784.0000, 'ºC'),
	(349009, 146, '2015-02-01 00:29:55.000000', 'temperatura', 898.0000, 'ºC'),
	(349010, 146, '2015-02-01 00:29:56.000000', 'temperatura', 938.0000, 'ºC'),
	(349011, 146, '2015-02-01 00:29:57.000000', 'temperatura', 796.0000, 'ºC'),
	(349012, 146, '2015-02-01 00:29:58.000000', 'temperatura', 1165.0000, 'ºC'),
	(349013, 146, '2015-02-01 00:29:59.000000', 'temperatura', 1040.0000, 'ºC'),
	(349014, 146, '2015-02-01 00:30:00.000000', 'temperatura', 505.0000, 'ºC'),
	(349015, 146, '2015-02-01 00:30:01.000000', 'temperatura', 603.0000, 'ºC'),
	(349016, 146, '2015-02-01 00:30:02.000000', 'temperatura', 303.0000, 'ºC'),
	(349017, 146, '2015-02-01 00:30:03.000000', 'temperatura', 908.0000, 'ºC'),
	(349018, 146, '2015-02-01 00:30:04.000000', 'temperatura', 29.0000, 'ºC'),
	(349019, 146, '2015-02-01 00:30:05.000000', 'temperatura', 1023.0000, 'ºC'),
	(349020, 146, '2015-02-01 00:30:06.000000', 'temperatura', 227.0000, 'ºC'),
	(349021, 146, '2015-02-01 00:30:07.000000', 'temperatura', 466.0000, 'ºC'),
	(349022, 146, '2015-02-01 00:30:08.000000', 'temperatura', 452.0000, 'ºC'),
	(349023, 146, '2015-02-01 00:30:09.000000', 'temperatura', 863.0000, 'ºC'),
	(349024, 146, '2015-02-01 00:30:10.000000', 'temperatura', 558.0000, 'ºC'),
	(349025, 146, '2015-02-01 00:30:11.000000', 'temperatura', 200.0000, 'ºC'),
	(349026, 146, '2015-02-01 00:30:12.000000', 'temperatura', 527.0000, 'ºC'),
	(349027, 146, '2015-02-01 00:30:13.000000', 'temperatura', 838.0000, 'ºC'),
	(349028, 146, '2015-02-01 00:30:14.000000', 'temperatura', 208.0000, 'ºC'),
	(349029, 146, '2015-02-01 00:30:15.000000', 'temperatura', 925.0000, 'ºC'),
	(349030, 146, '2015-02-01 00:30:16.000000', 'temperatura', 402.0000, 'ºC'),
	(349031, 146, '2015-02-01 00:30:17.000000', 'temperatura', 434.0000, 'ºC'),
	(349032, 146, '2015-02-01 00:30:18.000000', 'temperatura', 967.0000, 'ºC'),
	(349033, 146, '2015-02-01 00:30:19.000000', 'temperatura', 1134.0000, 'ºC'),
	(349034, 146, '2015-02-01 00:30:20.000000', 'temperatura', 368.0000, 'ºC'),
	(349035, 146, '2015-02-01 00:30:21.000000', 'temperatura', 839.0000, 'ºC'),
	(349036, 146, '2015-02-01 00:30:22.000000', 'temperatura', 692.0000, 'ºC'),
	(349037, 146, '2015-02-01 00:30:23.000000', 'temperatura', 942.0000, 'ºC'),
	(349038, 146, '2015-02-01 00:30:24.000000', 'temperatura', 236.0000, 'ºC'),
	(349039, 146, '2015-02-01 00:30:25.000000', 'temperatura', 756.0000, 'ºC'),
	(349040, 146, '2015-02-01 00:30:26.000000', 'temperatura', 671.0000, 'ºC'),
	(349041, 146, '2015-02-01 00:30:27.000000', 'temperatura', 1088.0000, 'ºC'),
	(349042, 146, '2015-02-01 00:30:28.000000', 'temperatura', 1027.0000, 'ºC'),
	(349043, 146, '2015-02-01 00:30:29.000000', 'temperatura', 671.0000, 'ºC'),
	(349044, 146, '2015-02-01 00:30:30.000000', 'temperatura', 273.0000, 'ºC'),
	(349045, 146, '2015-02-01 00:30:31.000000', 'temperatura', 553.0000, 'ºC'),
	(349046, 146, '2015-02-01 00:30:32.000000', 'temperatura', 749.0000, 'ºC'),
	(349047, 146, '2015-02-01 00:30:33.000000', 'temperatura', 885.0000, 'ºC'),
	(349048, 146, '2015-02-01 00:30:34.000000', 'temperatura', 977.0000, 'ºC'),
	(349049, 146, '2015-02-01 00:30:35.000000', 'temperatura', 1031.0000, 'ºC'),
	(349050, 146, '2015-02-01 00:30:36.000000', 'temperatura', 1025.0000, 'ºC'),
	(349051, 146, '2015-02-01 00:30:37.000000', 'temperatura', 833.0000, 'ºC'),
	(349052, 146, '2015-02-01 00:30:38.000000', 'temperatura', 1090.0000, 'ºC'),
	(349053, 146, '2015-02-01 00:30:39.000000', 'temperatura', 550.0000, 'ºC'),
	(349054, 146, '2015-02-01 00:30:40.000000', 'temperatura', 682.0000, 'ºC'),
	(349055, 146, '2015-02-01 00:30:41.000000', 'temperatura', 560.0000, 'ºC'),
	(349056, 146, '2015-02-01 00:30:42.000000', 'temperatura', 756.0000, 'ºC'),
	(349057, 146, '2015-02-01 00:30:43.000000', 'temperatura', 898.0000, 'ºC'),
	(349058, 146, '2015-02-01 00:30:44.000000', 'temperatura', 1022.0000, 'ºC'),
	(349059, 146, '2015-02-01 00:30:45.000000', 'temperatura', 17.0000, 'ºC'),
	(349060, 146, '2015-02-01 00:30:46.000000', 'temperatura', 618.0000, 'ºC'),
	(349061, 146, '2015-02-01 00:30:47.000000', 'temperatura', 641.0000, 'ºC'),
	(349062, 146, '2015-02-01 00:30:48.000000', 'temperatura', 150.0000, 'ºC'),
	(349063, 146, '2015-02-01 00:30:49.000000', 'temperatura', 28.0000, 'ºC'),
	(349064, 146, '2015-02-01 00:30:50.000000', 'temperatura', 893.0000, 'ºC'),
	(349065, 146, '2015-02-01 00:30:51.000000', 'temperatura', 778.0000, 'ºC'),
	(349066, 146, '2015-02-01 00:30:52.000000', 'temperatura', 13.0000, 'ºC'),
	(349067, 146, '2015-02-01 00:30:53.000000', 'temperatura', 130.0000, 'ºC'),
	(349068, 146, '2015-02-01 00:30:54.000000', 'temperatura', 614.0000, 'ºC'),
	(349069, 146, '2015-02-01 00:30:55.000000', 'temperatura', 281.0000, 'ºC'),
	(349070, 146, '2015-02-01 00:30:56.000000', 'temperatura', 765.0000, 'ºC'),
	(349071, 146, '2015-02-01 00:30:57.000000', 'temperatura', 579.0000, 'ºC'),
	(349072, 146, '2015-02-01 00:30:58.000000', 'temperatura', 601.0000, 'ºC'),
	(349073, 146, '2015-02-01 00:30:59.000000', 'temperatura', 67.0000, 'ºC'),
	(349074, 146, '2015-02-01 00:31:00.000000', 'temperatura', 935.0000, 'ºC'),
	(349075, 146, '2015-02-01 00:31:01.000000', 'temperatura', 874.0000, 'ºC'),
	(349076, 146, '2015-02-01 00:31:02.000000', 'temperatura', 365.0000, 'ºC'),
	(349077, 146, '2015-02-01 00:31:03.000000', 'temperatura', 403.0000, 'ºC'),
	(349078, 146, '2015-02-01 00:31:04.000000', 'temperatura', 919.0000, 'ºC'),
	(349079, 146, '2015-02-01 00:31:05.000000', 'temperatura', 988.0000, 'ºC'),
	(349080, 146, '2015-02-01 00:31:06.000000', 'temperatura', 982.0000, 'ºC'),
	(349081, 146, '2015-02-01 00:31:07.000000', 'temperatura', 749.0000, 'ºC'),
	(349082, 146, '2015-02-01 00:31:08.000000', 'temperatura', 797.0000, 'ºC'),
	(349083, 146, '2015-02-01 00:31:09.000000', 'temperatura', 540.0000, 'ºC'),
	(349084, 146, '2015-02-01 00:31:10.000000', 'temperatura', 310.0000, 'ºC'),
	(349085, 146, '2015-02-01 00:31:11.000000', 'temperatura', 1132.0000, 'ºC'),
	(349086, 146, '2015-02-01 00:31:12.000000', 'temperatura', 1129.0000, 'ºC'),
	(349087, 146, '2015-02-01 00:31:13.000000', 'temperatura', 1050.0000, 'ºC'),
	(349088, 146, '2015-02-01 00:31:14.000000', 'temperatura', 662.0000, 'ºC'),
	(349089, 146, '2015-02-01 00:31:15.000000', 'temperatura', 162.0000, 'ºC'),
	(349090, 146, '2015-02-01 00:31:16.000000', 'temperatura', 25.0000, 'ºC'),
	(349091, 146, '2015-02-01 00:31:17.000000', 'temperatura', 840.0000, 'ºC'),
	(349092, 146, '2015-02-01 00:31:18.000000', 'temperatura', 524.0000, 'ºC'),
	(349093, 146, '2015-02-01 00:31:19.000000', 'temperatura', 102.0000, 'ºC'),
	(349094, 146, '2015-02-01 00:31:20.000000', 'temperatura', 137.0000, 'ºC'),
	(349095, 146, '2015-02-01 00:31:21.000000', 'temperatura', 381.0000, 'ºC'),
	(349096, 146, '2015-02-01 00:31:22.000000', 'temperatura', 294.0000, 'ºC'),
	(349097, 146, '2015-02-01 00:31:23.000000', 'temperatura', 329.0000, 'ºC'),
	(349098, 146, '2015-02-01 00:31:24.000000', 'temperatura', 762.0000, 'ºC'),
	(349099, 146, '2015-02-01 00:31:25.000000', 'temperatura', 424.0000, 'ºC'),
	(349100, 146, '2015-02-01 00:31:26.000000', 'temperatura', 1035.0000, 'ºC'),
	(349101, 146, '2015-02-01 00:31:27.000000', 'temperatura', 301.0000, 'ºC'),
	(349102, 146, '2015-02-01 00:31:28.000000', 'temperatura', 802.0000, 'ºC'),
	(349103, 146, '2015-02-01 00:31:29.000000', 'temperatura', 707.0000, 'ºC'),
	(349104, 146, '2015-02-01 00:31:30.000000', 'temperatura', 1129.0000, 'ºC'),
	(349105, 146, '2015-02-01 00:31:31.000000', 'temperatura', 1127.0000, 'ºC'),
	(349106, 146, '2015-02-01 00:31:32.000000', 'temperatura', 1047.0000, 'ºC'),
	(349107, 146, '2015-02-01 00:31:33.000000', 'temperatura', 654.0000, 'ºC'),
	(349108, 146, '2015-02-01 00:31:34.000000', 'temperatura', 128.0000, 'ºC'),
	(349109, 146, '2015-02-01 00:31:35.000000', 'temperatura', 1081.0000, 'ºC'),
	(349110, 146, '2015-02-01 00:31:36.000000', 'temperatura', 222.0000, 'ºC'),
	(349111, 146, '2015-02-01 00:31:37.000000', 'temperatura', 267.0000, 'ºC'),
	(349112, 146, '2015-02-01 00:31:38.000000', 'temperatura', 669.0000, 'ºC'),
	(349113, 146, '2015-02-01 00:31:39.000000', 'temperatura', 143.0000, 'ºC'),
	(349114, 146, '2015-02-01 00:31:40.000000', 'temperatura', 1112.0000, 'ºC'),
	(349115, 146, '2015-02-01 00:31:41.000000', 'temperatura', 329.0000, 'ºC'),
	(349116, 146, '2015-02-01 00:31:42.000000', 'temperatura', 710.0000, 'ºC'),
	(349117, 146, '2015-02-01 00:31:43.000000', 'temperatura', 163.0000, 'ºC'),
	(349118, 146, '2015-02-01 00:31:44.000000', 'temperatura', 1086.0000, 'ºC'),
	(349119, 146, '2015-02-01 00:31:45.000000', 'temperatura', 142.0000, 'ºC'),
	(349120, 146, '2015-02-01 00:31:46.000000', 'temperatura', 1051.0000, 'ºC'),
	(349121, 146, '2015-02-01 00:31:47.000000', 'temperatura', 30.0000, 'ºC'),
	(349122, 146, '2015-02-01 00:31:48.000000', 'temperatura', 599.0000, 'ºC'),
	(349123, 146, '2015-02-01 00:31:49.000000', 'temperatura', 506.0000, 'ºC'),
	(349124, 146, '2015-02-01 00:31:50.000000', 'temperatura', 733.0000, 'ºC'),
	(349125, 146, '2015-02-01 00:31:51.000000', 'temperatura', 946.0000, 'ºC'),
	(349126, 146, '2015-02-01 00:31:52.000000', 'temperatura', 134.0000, 'ºC'),
	(349127, 146, '2015-02-01 00:31:53.000000', 'temperatura', 232.0000, 'ºC'),
	(349128, 146, '2015-02-01 00:31:54.000000', 'temperatura', 756.0000, 'ºC'),
	(349129, 146, '2015-02-01 00:31:55.000000', 'temperatura', 686.0000, 'ºC'),
	(349130, 146, '2015-02-01 00:31:56.000000', 'temperatura', 1161.0000, 'ºC'),
	(349131, 146, '2015-02-01 00:31:57.000000', 'temperatura', 148.0000, 'ºC'),
	(349132, 146, '2015-02-01 00:31:58.000000', 'temperatura', 857.0000, 'ºC'),
	(349133, 146, '2015-02-01 00:31:59.000000', 'temperatura', 241.0000, 'ºC'),
	(349134, 146, '2015-02-01 00:32:00.000000', 'temperatura', 1037.0000, 'ºC'),
	(349135, 146, '2015-02-01 00:32:01.000000', 'temperatura', 859.0000, 'ºC'),
	(349136, 146, '2015-02-01 00:32:02.000000', 'temperatura', 1187.0000, 'ºC'),
	(349137, 146, '2015-02-01 00:32:03.000000', 'temperatura', 957.0000, 'ºC'),
	(349138, 146, '2015-02-01 00:32:04.000000', 'temperatura', 24.0000, 'ºC'),
	(349139, 146, '2015-02-01 00:32:05.000000', 'temperatura', 849.0000, 'ºC'),
	(349140, 146, '2015-02-01 00:32:06.000000', 'temperatura', 575.0000, 'ºC'),
	(349141, 146, '2015-02-01 00:32:07.000000', 'temperatura', 329.0000, 'ºC'),
	(349142, 146, '2015-02-01 00:32:08.000000', 'temperatura', 1118.0000, 'ºC'),
	(349143, 146, '2015-02-01 00:32:09.000000', 'temperatura', 1006.0000, 'ºC'),
	(349144, 146, '2015-02-01 00:32:10.000000', 'temperatura', 476.0000, 'ºC'),
	(349145, 146, '2015-02-01 00:32:11.000000', 'temperatura', 561.0000, 'ºC'),
	(349146, 146, '2015-02-01 00:32:12.000000', 'temperatura', 179.0000, 'ºC'),
	(349147, 146, '2015-02-01 00:32:13.000000', 'temperatura', 410.0000, 'ºC'),
	(349148, 146, '2015-02-01 00:32:14.000000', 'temperatura', 315.0000, 'ºC'),
	(349149, 146, '2015-02-01 00:32:15.000000', 'temperatura', 347.0000, 'ºC'),
	(349150, 146, '2015-02-01 00:32:16.000000', 'temperatura', 789.0000, 'ºC'),
	(349151, 146, '2015-02-01 00:32:17.000000', 'temperatura', 506.0000, 'ºC'),
	(349152, 146, '2015-02-01 00:32:18.000000', 'temperatura', 163.0000, 'ºC'),
	(349153, 146, '2015-02-01 00:32:19.000000', 'temperatura', 499.0000, 'ºC'),
	(349154, 146, '2015-02-01 00:32:20.000000', 'temperatura', 807.0000, 'ºC'),
	(349155, 146, '2015-02-01 00:32:21.000000', 'temperatura', 137.0000, 'ºC'),
	(349156, 146, '2015-02-01 00:32:22.000000', 'temperatura', 664.0000, 'ºC'),
	(349157, 146, '2015-02-01 00:32:23.000000', 'temperatura', 511.0000, 'ºC'),
	(349158, 146, '2015-02-01 00:32:24.000000', 'temperatura', 564.0000, 'ºC'),
	(349159, 146, '2015-02-01 00:32:25.000000', 'temperatura', 85.0000, 'ºC'),
	(349160, 146, '2015-02-01 00:32:26.000000', 'temperatura', 1136.0000, 'ºC'),
	(349161, 146, '2015-02-01 00:32:27.000000', 'temperatura', 624.0000, 'ºC'),
	(349162, 146, '2015-02-01 00:32:28.000000', 'temperatura', 914.0000, 'ºC'),
	(349163, 146, '2015-02-01 00:32:29.000000', 'temperatura', 296.0000, 'ºC'),
	(349164, 146, '2015-02-01 00:32:30.000000', 'temperatura', 1138.0000, 'ºC'),
	(349165, 146, '2015-02-01 00:32:31.000000', 'temperatura', 3.0000, 'ºC'),
	(349166, 146, '2015-02-01 00:32:32.000000', 'temperatura', 204.0000, 'ºC'),
	(349167, 146, '2015-02-01 00:32:33.000000', 'temperatura', 1010.0000, 'ºC'),
	(349168, 146, '2015-02-01 00:32:34.000000', 'temperatura', 839.0000, 'ºC'),
	(349169, 146, '2015-02-01 00:32:35.000000', 'temperatura', 1163.0000, 'ºC'),
	(349170, 146, '2015-02-01 00:32:36.000000', 'temperatura', 902.0000, 'ºC'),
	(349171, 146, '2015-02-01 00:32:37.000000', 'temperatura', 1021.0000, 'ºC'),
	(349172, 146, '2015-02-01 00:32:38.000000', 'temperatura', 1198.0000, 'ºC'),
	(349173, 146, '2015-02-01 00:32:39.000000', 'temperatura', 527.0000, 'ºC'),
	(349174, 146, '2015-02-01 00:32:40.000000', 'temperatura', 243.0000, 'ºC'),
	(349175, 146, '2015-02-01 00:32:41.000000', 'temperatura', 835.0000, 'ºC'),
	(349176, 146, '2015-02-01 00:32:42.000000', 'temperatura', 1045.0000, 'ºC'),
	(349177, 146, '2015-02-01 00:32:43.000000', 'temperatura', 321.0000, 'ºC'),
	(349178, 146, '2015-02-01 00:32:44.000000', 'temperatura', 869.0000, 'ºC'),
	(349179, 146, '2015-02-01 00:32:45.000000', 'temperatura', 983.0000, 'ºC'),
	(349180, 146, '2015-02-01 00:32:46.000000', 'temperatura', 1110.0000, 'ºC'),
	(349181, 146, '2015-02-01 00:32:47.000000', 'temperatura', 200.0000, 'ºC'),
	(349182, 146, '2015-02-01 00:32:48.000000', 'temperatura', 69.0000, 'ºC'),
	(349183, 146, '2015-02-01 00:32:49.000000', 'temperatura', 947.0000, 'ºC'),
	(349184, 146, '2015-02-01 00:32:50.000000', 'temperatura', 930.0000, 'ºC'),
	(349185, 146, '2015-02-01 00:32:51.000000', 'temperatura', 610.0000, 'ºC'),
	(349186, 146, '2015-02-01 00:32:52.000000', 'temperatura', 257.0000, 'ºC'),
	(349187, 146, '2015-02-01 00:32:53.000000', 'temperatura', 658.0000, 'ºC'),
	(349188, 146, '2015-02-01 00:32:54.000000', 'temperatura', 121.0000, 'ºC'),
	(349189, 146, '2015-02-01 00:32:55.000000', 'temperatura', 1028.0000, 'ºC'),
	(349190, 146, '2015-02-01 00:32:56.000000', 'temperatura', 1179.0000, 'ºC'),
	(349191, 146, '2015-02-01 00:32:57.000000', 'temperatura', 414.0000, 'ºC'),
	(349192, 146, '2015-02-01 00:32:58.000000', 'temperatura', 930.0000, 'ºC'),
	(349193, 146, '2015-02-01 00:32:59.000000', 'temperatura', 1008.0000, 'ºC'),
	(349194, 146, '2015-02-01 00:33:00.000000', 'temperatura', 1052.0000, 'ºC'),
	(349195, 146, '2015-02-01 00:33:01.000000', 'temperatura', 1038.0000, 'ºC'),
	(349196, 146, '2015-02-01 00:33:02.000000', 'temperatura', 832.0000, 'ºC'),
	(349197, 146, '2015-02-01 00:33:03.000000', 'temperatura', 1046.0000, 'ºC'),
	(349198, 146, '2015-02-01 00:33:04.000000', 'temperatura', 337.0000, 'ºC'),
	(349199, 146, '2015-02-01 00:33:05.000000', 'temperatura', 945.0000, 'ºC'),
	(349200, 146, '2015-02-01 00:33:06.000000', 'temperatura', 114.0000, 'ºC'),
	(349201, 146, '2015-02-01 00:33:07.000000', 'temperatura', 135.0000, 'ºC'),
	(349202, 146, '2015-02-01 00:33:08.000000', 'temperatura', 333.0000, 'ºC'),
	(349203, 146, '2015-02-01 00:33:09.000000', 'temperatura', 61.0000, 'ºC'),
	(349204, 146, '2015-02-01 00:33:10.000000', 'temperatura', 507.0000, 'ºC'),
	(349205, 146, '2015-02-01 00:33:11.000000', 'temperatura', 1154.0000, 'ºC'),
	(349206, 146, '2015-02-01 00:33:12.000000', 'temperatura', 649.0000, 'ºC'),
	(349207, 146, '2015-02-01 00:33:13.000000', 'temperatura', 985.0000, 'ºC'),
	(349208, 146, '2015-02-01 00:33:14.000000', 'temperatura', 577.0000, 'ºC'),
	(349209, 146, '2015-02-01 00:33:15.000000', 'temperatura', 1131.0000, 'ºC'),
	(349210, 146, '2015-02-01 00:33:16.000000', 'temperatura', 323.0000, 'ºC'),
	(349211, 146, '2015-02-01 00:33:17.000000', 'temperatura', 625.0000, 'ºC'),
	(349212, 146, '2015-02-01 00:33:18.000000', 'temperatura', 956.0000, 'ºC'),
	(349213, 146, '2015-02-01 00:33:19.000000', 'temperatura', 506.0000, 'ºC'),
	(349214, 146, '2015-02-01 00:33:20.000000', 'temperatura', 862.0000, 'ºC'),
	(349215, 146, '2015-02-01 00:33:21.000000', 'temperatura', 391.0000, 'ºC'),
	(349216, 146, '2015-02-01 00:33:22.000000', 'temperatura', 570.0000, 'ºC'),
	(349217, 146, '2015-02-01 00:33:23.000000', 'temperatura', 478.0000, 'ºC'),
	(349218, 146, '2015-02-01 00:33:24.000000', 'temperatura', 681.0000, 'ºC'),
	(349219, 146, '2015-02-01 00:33:25.000000', 'temperatura', 770.0000, 'ºC'),
	(349220, 146, '2015-02-01 00:33:26.000000', 'temperatura', 608.0000, 'ºC'),
	(349221, 146, '2015-02-01 00:33:27.000000', 'temperatura', 732.0000, 'ºC'),
	(349222, 146, '2015-02-01 00:33:28.000000', 'temperatura', 635.0000, 'ºC'),
	(349223, 146, '2015-02-01 00:33:29.000000', 'temperatura', 982.0000, 'ºC'),
	(349224, 146, '2015-02-01 00:33:30.000000', 'temperatura', 602.0000, 'ºC'),
	(349225, 146, '2015-02-01 00:33:31.000000', 'temperatura', 65.0000, 'ºC'),
	(349226, 146, '2015-02-01 00:33:32.000000', 'temperatura', 922.0000, 'ºC'),
	(349227, 146, '2015-02-01 00:33:33.000000', 'temperatura', 815.0000, 'ºC'),
	(349228, 146, '2015-02-01 00:33:34.000000', 'temperatura', 107.0000, 'ºC'),
	(349229, 146, '2015-02-01 00:33:35.000000', 'temperatura', 491.0000, 'ºC'),
	(349230, 146, '2015-02-01 00:33:36.000000', 'temperatura', 936.0000, 'ºC'),
	(349231, 146, '2015-02-01 00:33:37.000000', 'temperatura', 807.0000, 'ºC'),
	(349232, 146, '2015-02-01 00:33:38.000000', 'temperatura', 29.0000, 'ºC'),
	(349233, 146, '2015-02-01 00:33:39.000000', 'temperatura', 124.0000, 'ºC'),
	(349234, 146, '2015-02-01 00:33:40.000000', 'temperatura', 535.0000, 'ºC'),
	(349235, 146, '2015-02-01 00:33:41.000000', 'temperatura', 1102.0000, 'ºC'),
	(349236, 146, '2015-02-01 00:33:42.000000', 'temperatura', 305.0000, 'ºC'),
	(349237, 146, '2015-02-01 00:33:43.000000', 'temperatura', 622.0000, 'ºC'),
	(349238, 146, '2015-02-01 00:33:44.000000', 'temperatura', 994.0000, 'ºC'),
	(349239, 146, '2015-02-01 00:33:45.000000', 'temperatura', 704.0000, 'ºC'),
	(349240, 146, '2015-02-01 00:33:46.000000', 'temperatura', 540.0000, 'ºC'),
	(349241, 146, '2015-02-01 00:33:47.000000', 'temperatura', 587.0000, 'ºC'),
	(349242, 146, '2015-02-01 00:33:48.000000', 'temperatura', 118.0000, 'ºC'),
	(349243, 146, '2015-02-01 00:33:49.000000', 'temperatura', 27.0000, 'ºC'),
	(349244, 146, '2015-02-01 00:33:50.000000', 'temperatura', 980.0000, 'ºC'),
	(349245, 146, '2015-02-01 00:33:51.000000', 'temperatura', 22.0000, 'ºC'),
	(349246, 146, '2015-02-01 00:33:52.000000', 'temperatura', 770.0000, 'ºC'),
	(349247, 146, '2015-02-01 00:33:53.000000', 'temperatura', 185.0000, 'ºC'),
	(349248, 146, '2015-02-01 00:33:54.000000', 'temperatura', 1014.0000, 'ºC'),
	(349249, 146, '2015-02-01 00:33:55.000000', 'temperatura', 914.0000, 'ºC'),
	(349250, 146, '2015-02-01 00:33:56.000000', 'temperatura', 331.0000, 'ºC'),
	(349251, 146, '2015-02-01 00:33:57.000000', 'temperatura', 111.0000, 'ºC'),
	(349252, 146, '2015-02-01 00:33:58.000000', 'temperatura', 764.0000, 'ºC'),
	(349253, 146, '2015-02-01 00:33:59.000000', 'temperatura', 1085.0000, 'ºC'),
	(349254, 146, '2015-02-01 00:34:00.000000', 'temperatura', 736.0000, 'ºC'),
	(349255, 146, '2015-02-01 00:34:01.000000', 'temperatura', 425.0000, 'ºC'),
	(349256, 146, '2015-02-01 00:34:02.000000', 'temperatura', 1118.0000, 'ºC'),
	(349257, 146, '2015-02-01 00:34:03.000000', 'temperatura', 715.0000, 'ºC'),
	(349258, 146, '2015-02-01 00:34:04.000000', 'temperatura', 221.0000, 'ºC'),
	(349259, 146, '2015-02-01 00:34:05.000000', 'temperatura', 160.0000, 'ºC'),
	(349260, 146, '2015-02-01 00:34:06.000000', 'temperatura', 136.0000, 'ºC'),
	(349261, 146, '2015-02-01 00:34:07.000000', 'temperatura', 202.0000, 'ºC'),
	(349262, 146, '2015-02-01 00:34:08.000000', 'temperatura', 603.0000, 'ºC'),
	(349263, 146, '2015-02-01 00:34:09.000000', 'temperatura', 10.0000, 'ºC'),
	(349264, 146, '2015-02-01 00:34:10.000000', 'temperatura', 643.0000, 'ºC'),
	(349265, 146, '2015-02-01 00:34:11.000000', 'temperatura', 783.0000, 'ºC'),
	(349266, 146, '2015-02-01 00:34:12.000000', 'temperatura', 787.0000, 'ºC'),
	(349267, 146, '2015-02-01 00:34:13.000000', 'temperatura', 388.0000, 'ºC'),
	(349268, 146, '2015-02-01 00:34:14.000000', 'temperatura', 779.0000, 'ºC'),
	(349269, 146, '2015-02-01 00:34:15.000000', 'temperatura', 332.0000, 'ºC'),
	(349270, 146, '2015-02-01 00:34:16.000000', 'temperatura', 523.0000, 'ºC'),
	(349271, 146, '2015-02-01 00:34:17.000000', 'temperatura', 421.0000, 'ºC'),
	(349272, 146, '2015-02-01 00:34:18.000000', 'temperatura', 536.0000, 'ºC'),
	(349273, 146, '2015-02-01 00:34:19.000000', 'temperatura', 219.0000, 'ºC'),
	(349274, 146, '2015-02-01 00:34:20.000000', 'temperatura', 685.0000, 'ºC'),
	(349275, 146, '2015-02-01 00:34:21.000000', 'temperatura', 371.0000, 'ºC'),
	(349276, 146, '2015-02-01 00:34:22.000000', 'temperatura', 998.0000, 'ºC'),
	(349277, 146, '2015-02-01 00:34:23.000000', 'temperatura', 279.0000, 'ºC'),
	(349278, 146, '2015-02-01 00:34:24.000000', 'temperatura', 803.0000, 'ºC'),
	(349279, 146, '2015-02-01 00:34:25.000000', 'temperatura', 775.0000, 'ºC'),
	(349280, 146, '2015-02-01 00:34:26.000000', 'temperatura', 270.0000, 'ºC'),
	(349281, 146, '2015-02-01 00:34:27.000000', 'temperatura', 223.0000, 'ºC'),
	(349282, 146, '2015-02-01 00:34:28.000000', 'temperatura', 308.0000, 'ºC'),
	(349283, 146, '2015-02-01 00:34:29.000000', 'temperatura', 869.0000, 'ºC'),
	(349284, 146, '2015-02-01 00:34:30.000000', 'temperatura', 1023.0000, 'ºC'),
	(349285, 146, '2015-02-01 00:34:31.000000', 'temperatura', 110.0000, 'ºC'),
	(349286, 146, '2015-02-01 00:34:32.000000', 'temperatura', 1080.0000, 'ºC'),
	(349287, 146, '2015-02-01 00:34:33.000000', 'temperatura', 269.0000, 'ºC'),
	(349288, 146, '2015-02-01 00:34:34.000000', 'temperatura', 508.0000, 'ºC'),
	(349289, 146, '2015-02-01 00:34:35.000000', 'temperatura', 533.0000, 'ºC'),
	(349290, 146, '2015-02-01 00:34:36.000000', 'temperatura', 1142.0000, 'ºC'),
	(349291, 146, '2015-02-01 00:34:37.000000', 'temperatura', 510.0000, 'ºC'),
	(349292, 146, '2015-02-01 00:34:38.000000', 'temperatura', 327.0000, 'ºC'),
	(349293, 146, '2015-02-01 00:34:39.000000', 'temperatura', 104.0000, 'ºC'),
	(349294, 146, '2015-02-01 00:34:40.000000', 'temperatura', 742.0000, 'ºC'),
	(349295, 146, '2015-02-01 00:34:41.000000', 'temperatura', 995.0000, 'ºC'),
	(349296, 146, '2015-02-01 00:34:42.000000', 'temperatura', 351.0000, 'ºC'),
	(349297, 146, '2015-02-01 00:34:43.000000', 'temperatura', 1172.0000, 'ºC'),
	(349298, 146, '2015-02-01 00:34:44.000000', 'temperatura', 6.0000, 'ºC'),
	(349299, 146, '2015-02-01 00:34:45.000000', 'temperatura', 117.0000, 'ºC'),
	(349300, 146, '2015-02-01 00:34:46.000000', 'temperatura', 564.0000, 'ºC'),
	(349301, 146, '2015-02-01 00:34:47.000000', 'temperatura', 70.0000, 'ºC'),
	(349302, 146, '2015-02-01 00:34:48.000000', 'temperatura', 1061.0000, 'ºC'),
	(349303, 146, '2015-02-01 00:34:49.000000', 'temperatura', 292.0000, 'ºC'),
	(349304, 146, '2015-02-01 00:34:50.000000', 'temperatura', 679.0000, 'ºC'),
	(349305, 146, '2015-02-01 00:34:51.000000', 'temperatura', 121.0000, 'ºC'),
	(349306, 146, '2015-02-01 00:34:52.000000', 'temperatura', 968.0000, 'ºC'),
	(349307, 146, '2015-02-01 00:34:53.000000', 'temperatura', 878.0000, 'ºC'),
	(349308, 146, '2015-02-01 00:34:54.000000', 'temperatura', 288.0000, 'ºC'),
	(349309, 146, '2015-02-01 00:34:55.000000', 'temperatura', 5.0000, 'ºC'),
	(349310, 146, '2015-02-01 00:34:56.000000', 'temperatura', 362.0000, 'ºC'),
	(349311, 146, '2015-02-01 00:34:57.000000', 'temperatura', 594.0000, 'ºC'),
	(349312, 146, '2015-02-01 00:34:58.000000', 'temperatura', 686.0000, 'ºC'),
	(349313, 146, '2015-02-01 00:34:59.000000', 'temperatura', 448.0000, 'ºC'),
	(349314, 146, '2015-02-01 00:35:00.000000', 'temperatura', 183.0000, 'ºC'),
	(349315, 146, '2015-02-01 00:35:01.000000', 'temperatura', 772.0000, 'ºC'),
	(349316, 146, '2015-02-01 00:35:02.000000', 'temperatura', 911.0000, 'ºC'),
	(349317, 146, '2015-02-01 00:35:03.000000', 'temperatura', 1038.0000, 'ºC'),
	(349318, 146, '2015-02-01 00:35:04.000000', 'temperatura', 58.0000, 'ºC'),
	(349319, 146, '2015-02-01 00:35:05.000000', 'temperatura', 777.0000, 'ºC'),
	(349320, 146, '2015-02-01 00:35:06.000000', 'temperatura', 111.0000, 'ºC'),
	(349321, 146, '2015-02-01 00:35:07.000000', 'temperatura', 626.0000, 'ºC'),
	(349322, 146, '2015-02-01 00:35:08.000000', 'temperatura', 398.0000, 'ºC'),
	(349323, 146, '2015-02-01 00:35:09.000000', 'temperatura', 112.0000, 'ºC'),
	(349324, 146, '2015-02-01 00:35:10.000000', 'temperatura', 567.0000, 'ºC'),
	(349325, 146, '2015-02-01 00:35:11.000000', 'temperatura', 97.0000, 'ºC'),
	(349326, 146, '2015-02-01 00:35:12.000000', 'temperatura', 1187.0000, 'ºC'),
	(349327, 146, '2015-02-01 00:35:13.000000', 'temperatura', 842.0000, 'ºC'),
	(349328, 146, '2015-02-01 00:35:14.000000', 'temperatura', 649.0000, 'ºC'),
	(349329, 146, '2015-02-01 00:35:15.000000', 'temperatura', 720.0000, 'ºC'),
	(349330, 146, '2015-02-01 00:35:16.000000', 'temperatura', 454.0000, 'ºC'),
	(349331, 146, '2015-02-01 00:35:17.000000', 'temperatura', 109.0000, 'ºC'),
	(349332, 146, '2015-02-01 00:35:18.000000', 'temperatura', 386.0000, 'ºC'),
	(349333, 146, '2015-02-01 00:35:19.000000', 'temperatura', 402.0000, 'ºC'),
	(349334, 146, '2015-02-01 00:35:20.000000', 'temperatura', 854.0000, 'ºC'),
	(349335, 146, '2015-02-01 00:35:21.000000', 'temperatura', 666.0000, 'ºC'),
	(349336, 146, '2015-02-01 00:35:22.000000', 'temperatura', 766.0000, 'ºC'),
	(349337, 146, '2015-02-01 00:35:23.000000', 'temperatura', 633.0000, 'ºC'),
	(349338, 146, '2015-02-01 00:35:24.000000', 'temperatura', 866.0000, 'ºC'),
	(349339, 146, '2015-02-01 00:35:25.000000', 'temperatura', 35.0000, 'ºC'),
	(349340, 146, '2015-02-01 00:35:26.000000', 'temperatura', 1175.0000, 'ºC'),
	(349341, 146, '2015-02-01 00:35:27.000000', 'temperatura', 969.0000, 'ºC'),
	(349342, 146, '2015-02-01 00:35:28.000000', 'temperatura', 122.0000, 'ºC'),
	(349343, 146, '2015-02-01 00:35:29.000000', 'temperatura', 103.0000, 'ºC'),
	(349344, 146, '2015-02-01 00:35:30.000000', 'temperatura', 151.0000, 'ºC'),
	(349345, 146, '2015-02-01 00:35:31.000000', 'temperatura', 448.0000, 'ºC'),
	(349346, 146, '2015-02-01 00:35:32.000000', 'temperatura', 585.0000, 'ºC'),
	(349347, 146, '2015-02-01 00:35:33.000000', 'temperatura', 381.0000, 'ºC'),
	(349348, 146, '2015-02-01 00:35:34.000000', 'temperatura', 151.0000, 'ºC'),
	(349349, 146, '2015-02-01 00:35:35.000000', 'temperatura', 814.0000, 'ºC'),
	(349350, 146, '2015-02-01 00:35:36.000000', 'temperatura', 16.0000, 'ºC'),
	(349351, 146, '2015-02-01 00:35:37.000000', 'temperatura', 40.0000, 'ºC'),
	(349352, 146, '2015-02-01 00:35:38.000000', 'temperatura', 151.0000, 'ºC'),
	(349353, 146, '2015-02-01 00:35:39.000000', 'temperatura', 635.0000, 'ºC'),
	(349354, 146, '2015-02-01 00:35:40.000000', 'temperatura', 325.0000, 'ºC'),
	(349355, 146, '2015-02-01 00:35:41.000000', 'temperatura', 918.0000, 'ºC'),
	(349356, 146, '2015-02-01 00:35:42.000000', 'temperatura', 17.0000, 'ºC'),
	(349357, 146, '2015-02-01 00:35:43.000000', 'temperatura', 932.0000, 'ºC'),
	(349358, 146, '2015-02-01 00:35:44.000000', 'temperatura', 1008.0000, 'ºC'),
	(349359, 146, '2015-02-01 00:35:45.000000', 'temperatura', 1045.0000, 'ºC'),
	(349360, 146, '2015-02-01 00:35:46.000000', 'temperatura', 1002.0000, 'ºC'),
	(349361, 146, '2015-02-01 00:35:47.000000', 'temperatura', 677.0000, 'ºC'),
	(349362, 146, '2015-02-01 00:35:48.000000', 'temperatura', 379.0000, 'ºC'),
	(349363, 146, '2015-02-01 00:35:49.000000', 'temperatura', 1063.0000, 'ºC'),
	(349364, 146, '2015-02-01 00:35:50.000000', 'temperatura', 577.0000, 'ºC'),
	(349365, 146, '2015-02-01 00:35:51.000000', 'temperatura', 898.0000, 'ºC'),
	(349366, 146, '2015-02-01 00:35:52.000000', 'temperatura', 361.0000, 'ºC'),
	(349367, 146, '2015-02-01 00:35:53.000000', 'temperatura', 312.0000, 'ºC'),
	(349368, 146, '2015-02-01 00:35:54.000000', 'temperatura', 475.0000, 'ºC'),
	(349369, 146, '2015-02-01 00:35:55.000000', 'temperatura', 242.0000, 'ºC'),
	(349370, 146, '2015-02-01 00:35:56.000000', 'temperatura', 985.0000, 'ºC'),
	(349371, 146, '2015-02-01 00:35:57.000000', 'temperatura', 598.0000, 'ºC'),
	(349372, 146, '2015-02-01 00:35:58.000000', 'temperatura', 35.0000, 'ºC'),
	(349373, 146, '2015-02-01 00:35:59.000000', 'temperatura', 782.0000, 'ºC'),
	(349374, 146, '2015-02-01 00:36:00.000000', 'temperatura', 204.0000, 'ºC'),
	(349375, 146, '2015-02-01 00:36:01.000000', 'temperatura', 1077.0000, 'ºC'),
	(349376, 146, '2015-02-01 00:36:02.000000', 'temperatura', 1172.0000, 'ºC'),
	(349377, 146, '2015-02-01 00:36:03.000000', 'temperatura', 230.0000, 'ºC'),
	(349378, 146, '2015-02-01 00:36:04.000000', 'temperatura', 34.0000, 'ºC'),
	(349379, 146, '2015-02-01 00:36:05.000000', 'temperatura', 681.0000, 'ºC'),
	(349380, 146, '2015-02-01 00:36:06.000000', 'temperatura', 903.0000, 'ºC'),
	(349381, 146, '2015-02-01 00:36:07.000000', 'temperatura', 74.0000, 'ºC'),
	(349382, 146, '2015-02-01 00:36:08.000000', 'temperatura', 61.0000, 'ºC'),
	(349383, 146, '2015-02-01 00:36:09.000000', 'temperatura', 84.0000, 'ºC'),
	(349384, 146, '2015-02-01 00:36:10.000000', 'temperatura', 237.0000, 'ºC'),
	(349385, 146, '2015-02-01 00:36:11.000000', 'temperatura', 934.0000, 'ºC'),
	(349386, 146, '2015-02-01 00:36:12.000000', 'temperatura', 357.0000, 'ºC'),
	(349387, 146, '2015-02-01 00:36:13.000000', 'temperatura', 186.0000, 'ºC'),
	(349388, 146, '2015-02-01 00:36:14.000000', 'temperatura', 1058.0000, 'ºC'),
	(349389, 146, '2015-02-01 00:36:15.000000', 'temperatura', 1133.0000, 'ºC'),
	(349390, 146, '2015-02-01 00:36:16.000000', 'temperatura', 92.0000, 'ºC'),
	(349391, 146, '2015-02-01 00:36:17.000000', 'temperatura', 662.0000, 'ºC'),
	(349392, 146, '2015-02-01 00:36:18.000000', 'temperatura', 635.0000, 'ºC'),
	(349393, 146, '2015-02-01 00:36:19.000000', 'temperatura', 1190.0000, 'ºC'),
	(349394, 146, '2015-02-01 00:36:20.000000', 'temperatura', 443.0000, 'ºC'),
	(349395, 146, '2015-02-01 00:36:21.000000', 'temperatura', 1047.0000, 'ºC'),
	(349396, 146, '2015-02-01 00:36:22.000000', 'temperatura', 305.0000, 'ºC'),
	(349397, 146, '2015-02-01 00:36:23.000000', 'temperatura', 784.0000, 'ºC'),
	(349398, 146, '2015-02-01 00:36:24.000000', 'temperatura', 606.0000, 'ºC'),
	(349399, 146, '2015-02-01 00:36:25.000000', 'temperatura', 678.0000, 'ºC'),
	(349400, 146, '2015-02-01 00:36:26.000000', 'temperatura', 373.0000, 'ºC'),
	(349401, 146, '2015-02-01 00:36:27.000000', 'temperatura', 1031.0000, 'ºC'),
	(349402, 146, '2015-02-01 00:36:28.000000', 'temperatura', 435.0000, 'ºC'),
	(349403, 146, '2015-02-01 00:36:29.000000', 'temperatura', 283.0000, 'ºC'),
	(349404, 146, '2015-02-01 00:36:30.000000', 'temperatura', 113.0000, 'ºC'),
	(349405, 146, '2015-02-01 00:36:31.000000', 'temperatura', 916.0000, 'ºC'),
	(349406, 146, '2015-02-01 00:36:32.000000', 'temperatura', 640.0000, 'ºC'),
	(349407, 146, '2015-02-01 00:36:33.000000', 'temperatura', 452.0000, 'ºC'),
	(349408, 146, '2015-02-01 00:36:34.000000', 'temperatura', 343.0000, 'ºC'),
	(349409, 146, '2015-02-01 00:36:35.000000', 'temperatura', 358.0000, 'ºC'),
	(349410, 146, '2015-02-01 00:36:36.000000', 'temperatura', 762.0000, 'ºC'),
	(349411, 146, '2015-02-01 00:36:37.000000', 'temperatura', 334.0000, 'ºC'),
	(349412, 146, '2015-02-01 00:36:38.000000', 'temperatura', 588.0000, 'ºC'),
	(349413, 146, '2015-02-01 00:36:39.000000', 'temperatura', 736.0000, 'ºC'),
	(349414, 146, '2015-02-01 00:36:40.000000', 'temperatura', 718.0000, 'ºC'),
	(349415, 146, '2015-02-01 00:36:41.000000', 'temperatura', 184.0000, 'ºC'),
	(349416, 146, '2015-02-01 00:36:42.000000', 'temperatura', 1163.0000, 'ºC'),
	(349417, 146, '2015-02-01 00:36:43.000000', 'temperatura', 467.0000, 'ºC'),
	(349418, 146, '2015-02-01 00:36:44.000000', 'temperatura', 46.0000, 'ºC'),
	(349419, 146, '2015-02-01 00:36:45.000000', 'temperatura', 27.0000, 'ºC'),
	(349420, 146, '2015-02-01 00:36:46.000000', 'temperatura', 0.0000, 'ºC'),
	(349421, 146, '2015-02-01 00:36:47.000000', 'temperatura', 1119.0000, 'ºC'),
	(349422, 146, '2015-02-01 00:36:48.000000', 'temperatura', 796.0000, 'ºC'),
	(349423, 146, '2015-02-01 00:36:49.000000', 'temperatura', 621.0000, 'ºC'),
	(349424, 146, '2015-02-01 00:36:50.000000', 'temperatura', 720.0000, 'ºC'),
	(349425, 146, '2015-02-01 00:36:51.000000', 'temperatura', 536.0000, 'ºC'),
	(349426, 146, '2015-02-01 00:36:52.000000', 'temperatura', 521.0000, 'ºC'),
	(349427, 146, '2015-02-01 00:36:53.000000', 'temperatura', 999.0000, 'ºC'),
	(349428, 146, '2015-02-01 00:36:54.000000', 'temperatura', 1032.0000, 'ºC'),
	(349429, 146, '2015-02-01 00:36:55.000000', 'temperatura', 963.0000, 'ºC'),
	(349430, 146, '2015-02-01 00:36:56.000000', 'temperatura', 521.0000, 'ºC'),
	(349431, 146, '2015-02-01 00:36:57.000000', 'temperatura', 916.0000, 'ºC'),
	(349432, 146, '2015-02-01 00:36:58.000000', 'temperatura', 617.0000, 'ºC'),
	(349433, 146, '2015-02-01 00:36:59.000000', 'temperatura', 340.0000, 'ºC'),
	(349434, 146, '2015-02-01 00:37:00.000000', 'temperatura', 1046.0000, 'ºC'),
	(349435, 146, '2015-02-01 00:37:01.000000', 'temperatura', 614.0000, 'ºC'),
	(349436, 146, '2015-02-01 00:37:02.000000', 'temperatura', 1130.0000, 'ºC'),
	(349437, 146, '2015-02-01 00:37:03.000000', 'temperatura', 211.0000, 'ºC'),
	(349438, 146, '2015-02-01 00:37:04.000000', 'temperatura', 64.0000, 'ºC'),
	(349439, 146, '2015-02-01 00:37:05.000000', 'temperatura', 886.0000, 'ºC'),
	(349440, 146, '2015-02-01 00:37:06.000000', 'temperatura', 639.0000, 'ºC'),
	(349441, 146, '2015-02-01 00:37:07.000000', 'temperatura', 539.0000, 'ºC'),
	(349442, 146, '2015-02-01 00:37:08.000000', 'temperatura', 778.0000, 'ºC'),
	(349443, 146, '2015-02-01 00:37:09.000000', 'temperatura', 1073.0000, 'ºC'),
	(349444, 146, '2015-02-01 00:37:10.000000', 'temperatura', 633.0000, 'ºC'),
	(349445, 146, '2015-02-01 00:37:11.000000', 'temperatura', 1144.0000, 'ºC'),
	(349446, 146, '2015-02-01 00:37:12.000000', 'temperatura', 225.0000, 'ºC'),
	(349447, 146, '2015-02-01 00:37:13.000000', 'temperatura', 90.0000, 'ºC'),
	(349448, 146, '2015-02-01 00:37:14.000000', 'temperatura', 977.0000, 'ºC'),
	(349449, 146, '2015-02-01 00:37:15.000000', 'temperatura', 1014.0000, 'ºC'),
	(349450, 146, '2015-02-01 00:37:16.000000', 'temperatura', 941.0000, 'ºC'),
	(349451, 146, '2015-02-01 00:37:17.000000', 'temperatura', 463.0000, 'ºC'),
	(349452, 146, '2015-02-01 00:37:18.000000', 'temperatura', 691.0000, 'ºC'),
	(349453, 146, '2015-02-01 00:37:19.000000', 'temperatura', 869.0000, 'ºC'),
	(349454, 146, '2015-02-01 00:37:20.000000', 'temperatura', 1073.0000, 'ºC'),
	(349455, 146, '2015-02-01 00:37:21.000000', 'temperatura', 358.0000, 'ºC'),
	(349456, 146, '2015-02-01 00:37:22.000000', 'temperatura', 969.0000, 'ºC'),
	(349457, 146, '2015-02-01 00:37:23.000000', 'temperatura', 175.0000, 'ºC'),
	(349458, 146, '2015-02-01 00:37:24.000000', 'temperatura', 367.0000, 'ºC'),
	(349459, 146, '2015-02-01 00:37:25.000000', 'temperatura', 113.0000, 'ºC'),
	(349460, 146, '2015-02-01 00:37:26.000000', 'temperatura', 661.0000, 'ºC'),
	(349461, 146, '2015-02-01 00:37:27.000000', 'temperatura', 567.0000, 'ºC'),
	(349462, 146, '2015-02-01 00:37:28.000000', 'temperatura', 851.0000, 'ºC'),
	(349463, 146, '2015-02-01 00:37:29.000000', 'temperatura', 156.0000, 'ºC'),
	(349464, 146, '2015-02-01 00:37:30.000000', 'temperatura', 629.0000, 'ºC'),
	(349465, 146, '2015-02-01 00:37:31.000000', 'temperatura', 277.0000, 'ºC'),
	(349466, 146, '2015-02-01 00:37:32.000000', 'temperatura', 697.0000, 'ºC'),
	(349467, 146, '2015-02-01 00:37:33.000000', 'temperatura', 255.0000, 'ºC'),
	(349468, 146, '2015-02-01 00:37:34.000000', 'temperatura', 385.0000, 'ºC'),
	(349469, 146, '2015-02-01 00:37:35.000000', 'temperatura', 1160.0000, 'ºC'),
	(349470, 146, '2015-02-01 00:37:36.000000', 'temperatura', 1046.0000, 'ºC'),
	(349471, 146, '2015-02-01 00:37:37.000000', 'temperatura', 552.0000, 'ºC'),
	(349472, 146, '2015-02-01 00:37:38.000000', 'temperatura', 819.0000, 'ºC'),
	(349473, 146, '2015-02-01 00:37:39.000000', 'temperatura', 42.0000, 'ºC'),
	(349474, 146, '2015-02-01 00:37:40.000000', 'temperatura', 155.0000, 'ºC'),
	(349475, 146, '2015-02-01 00:37:41.000000', 'temperatura', 648.0000, 'ºC'),
	(349476, 146, '2015-02-01 00:37:42.000000', 'temperatura', 373.0000, 'ºC'),
	(349477, 146, '2015-02-01 00:37:43.000000', 'temperatura', 1125.0000, 'ºC'),
	(349478, 146, '2015-02-01 00:37:44.000000', 'temperatura', 907.0000, 'ºC'),
	(349479, 146, '2015-02-01 00:37:45.000000', 'temperatura', 1159.0000, 'ºC'),
	(349480, 146, '2015-02-01 00:37:46.000000', 'temperatura', 674.0000, 'ºC'),
	(349481, 146, '2015-02-01 00:37:47.000000', 'temperatura', 1093.0000, 'ºC'),
	(349482, 146, '2015-02-01 00:37:48.000000', 'temperatura', 1046.0000, 'ºC'),
	(349483, 146, '2015-02-01 00:37:49.000000', 'temperatura', 751.0000, 'ºC'),
	(349484, 146, '2015-02-01 00:37:50.000000', 'temperatura', 617.0000, 'ºC'),
	(349485, 146, '2015-02-01 00:37:51.000000', 'temperatura', 831.0000, 'ºC'),
	(349486, 146, '2015-02-01 00:37:52.000000', 'temperatura', 1107.0000, 'ºC'),
	(349487, 146, '2015-02-01 00:37:53.000000', 'temperatura', 643.0000, 'ºC'),
	(349488, 146, '2015-02-01 00:37:54.000000', 'temperatura', 1093.0000, 'ºC'),
	(349489, 146, '2015-02-01 00:37:55.000000', 'temperatura', 1136.0000, 'ºC'),
	(349490, 146, '2015-02-01 00:37:56.000000', 'temperatura', 1.0000, 'ºC'),
	(349491, 146, '2015-02-01 00:37:57.000000', 'temperatura', 197.0000, 'ºC'),
	(349492, 146, '2015-02-01 00:37:58.000000', 'temperatura', 984.0000, 'ºC'),
	(349493, 146, '2015-02-01 00:37:59.000000', 'temperatura', 727.0000, 'ºC'),
	(349494, 146, '2015-02-01 00:38:00.000000', 'temperatura', 685.0000, 'ºC'),
	(349495, 146, '2015-02-01 00:38:01.000000', 'temperatura', 43.0000, 'ºC'),
	(349496, 146, '2015-02-01 00:38:02.000000', 'temperatura', 560.0000, 'ºC'),
	(349497, 146, '2015-02-01 00:38:03.000000', 'temperatura', 273.0000, 'ºC'),
	(349498, 146, '2015-02-01 00:38:04.000000', 'temperatura', 887.0000, 'ºC'),
	(349499, 146, '2015-02-01 00:38:05.000000', 'temperatura', 16.0000, 'ºC'),
	(349500, 146, '2015-02-01 00:38:06.000000', 'temperatura', 1020.0000, 'ºC'),
	(349501, 146, '2015-02-01 00:38:07.000000', 'temperatura', 253.0000, 'ºC'),
	(349502, 146, '2015-02-01 00:38:08.000000', 'temperatura', 604.0000, 'ºC'),
	(349503, 146, '2015-02-01 00:38:09.000000', 'temperatura', 1060.0000, 'ºC'),
	(349504, 146, '2015-02-01 00:38:10.000000', 'temperatura', 1090.0000, 'ºC'),
	(349505, 146, '2015-02-01 00:38:11.000000', 'temperatura', 1069.0000, 'ºC'),
	(349506, 146, '2015-02-01 00:38:12.000000', 'temperatura', 878.0000, 'ºC'),
	(349507, 146, '2015-02-01 00:38:13.000000', 'temperatura', 1181.0000, 'ºC'),
	(349508, 146, '2015-02-01 00:38:14.000000', 'temperatura', 871.0000, 'ºC'),
	(349509, 146, '2015-02-01 00:38:15.000000', 'temperatura', 813.0000, 'ºC'),
	(349510, 146, '2015-02-01 00:38:16.000000', 'temperatura', 254.0000, 'ºC'),
	(349511, 146, '2015-02-01 00:38:17.000000', 'temperatura', 32.0000, 'ºC'),
	(349512, 146, '2015-02-01 00:38:18.000000', 'temperatura', 598.0000, 'ºC'),
	(349513, 146, '2015-02-01 00:38:19.000000', 'temperatura', 493.0000, 'ºC'),
	(349514, 146, '2015-02-01 00:38:20.000000', 'temperatura', 671.0000, 'ºC'),
	(349515, 146, '2015-02-01 00:38:21.000000', 'temperatura', 677.0000, 'ºC'),
	(349516, 146, '2015-02-01 00:38:22.000000', 'temperatura', 174.0000, 'ºC'),
	(349517, 146, '2015-02-01 00:38:23.000000', 'temperatura', 37.0000, 'ºC'),
	(349518, 146, '2015-02-01 00:38:24.000000', 'temperatura', 863.0000, 'ºC'),
	(349519, 146, '2015-02-01 00:38:25.000000', 'temperatura', 605.0000, 'ºC'),
	(349520, 146, '2015-02-01 00:38:26.000000', 'temperatura', 436.0000, 'ºC'),
	(349521, 146, '2015-02-01 00:38:27.000000', 'temperatura', 365.0000, 'ºC'),
	(349522, 146, '2015-02-01 00:38:28.000000', 'temperatura', 518.0000, 'ºC'),
	(349523, 146, '2015-02-01 00:38:29.000000', 'temperatura', 297.0000, 'ºC'),
	(349524, 146, '2015-02-01 00:38:30.000000', 'temperatura', 1130.0000, 'ºC'),
	(349525, 146, '2015-02-01 00:38:31.000000', 'temperatura', 1159.0000, 'ºC'),
	(349526, 146, '2015-02-01 00:38:32.000000', 'temperatura', 5.0000, 'ºC'),
	(349527, 146, '2015-02-01 00:38:33.000000', 'temperatura', 150.0000, 'ºC'),
	(349528, 146, '2015-02-01 00:38:34.000000', 'temperatura', 733.0000, 'ºC'),
	(349529, 146, '2015-02-01 00:38:35.000000', 'temperatura', 818.0000, 'ºC'),
	(349530, 146, '2015-02-01 00:38:36.000000', 'temperatura', 689.0000, 'ºC'),
	(349531, 146, '2015-02-01 00:38:37.000000', 'temperatura', 993.0000, 'ºC'),
	(349532, 146, '2015-02-01 00:38:38.000000', 'temperatura', 498.0000, 'ºC'),
	(349533, 146, '2015-02-01 00:38:39.000000', 'temperatura', 714.0000, 'ºC'),
	(349534, 146, '2015-02-01 00:38:40.000000', 'temperatura', 874.0000, 'ºC'),
	(349535, 146, '2015-02-01 00:38:41.000000', 'temperatura', 1029.0000, 'ºC'),
	(349536, 146, '2015-02-01 00:38:42.000000', 'temperatura', 123.0000, 'ºC'),
	(349537, 146, '2015-02-01 00:38:43.000000', 'temperatura', 1129.0000, 'ºC'),
	(349538, 146, '2015-02-01 00:38:44.000000', 'temperatura', 475.0000, 'ºC'),
	(349539, 146, '2015-02-01 00:38:45.000000', 'temperatura', 191.0000, 'ºC'),
	(349540, 146, '2015-02-01 00:38:46.000000', 'temperatura', 727.0000, 'ºC'),
	(349541, 146, '2015-02-01 00:38:47.000000', 'temperatura', 666.0000, 'ºC'),
	(349542, 146, '2015-02-01 00:38:48.000000', 'temperatura', 1148.0000, 'ºC'),
	(349543, 146, '2015-02-01 00:38:49.000000', 'temperatura', 144.0000, 'ºC'),
	(349544, 146, '2015-02-01 00:38:50.000000', 'temperatura', 877.0000, 'ºC'),
	(349545, 146, '2015-02-01 00:38:51.000000', 'temperatura', 354.0000, 'ºC'),
	(349546, 146, '2015-02-01 00:38:52.000000', 'temperatura', 340.0000, 'ºC'),
	(349547, 146, '2015-02-01 00:38:53.000000', 'temperatura', 639.0000, 'ºC'),
	(349548, 146, '2015-02-01 00:38:54.000000', 'temperatura', 975.0000, 'ºC'),
	(349549, 146, '2015-02-01 00:38:55.000000', 'temperatura', 559.0000, 'ºC'),
	(349550, 146, '2015-02-01 00:38:56.000000', 'temperatura', 1071.0000, 'ºC'),
	(349551, 146, '2015-02-01 00:38:57.000000', 'temperatura', 76.0000, 'ºC'),
	(349552, 146, '2015-02-01 00:38:58.000000', 'temperatura', 767.0000, 'ºC'),
	(349553, 146, '2015-02-01 00:38:59.000000', 'temperatura', 8.0000, 'ºC'),
	(349554, 146, '2015-02-01 00:39:00.000000', 'temperatura', 141.0000, 'ºC'),
	(349555, 146, '2015-02-01 00:39:01.000000', 'temperatura', 683.0000, 'ºC'),
	(349556, 146, '2015-02-01 00:39:02.000000', 'temperatura', 590.0000, 'ºC'),
	(349557, 146, '2015-02-01 00:39:03.000000', 'temperatura', 902.0000, 'ºC'),
	(349558, 146, '2015-02-01 00:39:04.000000', 'temperatura', 339.0000, 'ºC'),
	(349559, 146, '2015-02-01 00:39:05.000000', 'temperatura', 190.0000, 'ºC'),
	(349560, 146, '2015-02-01 00:39:06.000000', 'temperatura', 1132.0000, 'ºC'),
	(349561, 146, '2015-02-01 00:39:07.000000', 'temperatura', 293.0000, 'ºC'),
	(349562, 146, '2015-02-01 00:39:08.000000', 'temperatura', 468.0000, 'ºC'),
	(349563, 146, '2015-02-01 00:39:09.000000', 'temperatura', 264.0000, 'ºC'),
	(349564, 146, '2015-02-01 00:39:10.000000', 'temperatura', 1115.0000, 'ºC'),
	(349565, 146, '2015-02-01 00:39:11.000000', 'temperatura', 1185.0000, 'ºC'),
	(349566, 146, '2015-02-01 00:39:12.000000', 'temperatura', 179.0000, 'ºC'),
	(349567, 146, '2015-02-01 00:39:13.000000', 'temperatura', 939.0000, 'ºC'),
	(349568, 146, '2015-02-01 00:39:14.000000', 'temperatura', 561.0000, 'ºC'),
	(349569, 146, '2015-02-01 00:39:15.000000', 'temperatura', 1186.0000, 'ºC'),
	(349570, 146, '2015-02-01 00:39:16.000000', 'temperatura', 650.0000, 'ºC'),
	(349571, 146, '2015-02-01 00:39:17.000000', 'temperatura', 892.0000, 'ºC'),
	(349572, 146, '2015-02-01 00:39:18.000000', 'temperatura', 112.0000, 'ºC'),
	(349573, 146, '2015-02-01 00:39:19.000000', 'temperatura', 283.0000, 'ºC'),
	(349574, 146, '2015-02-01 00:39:20.000000', 'temperatura', 1081.0000, 'ºC'),
	(349575, 146, '2015-02-01 00:39:21.000000', 'temperatura', 953.0000, 'ºC'),
	(349576, 146, '2015-02-01 00:39:22.000000', 'temperatura', 326.0000, 'ºC'),
	(349577, 146, '2015-02-01 00:39:23.000000', 'temperatura', 1172.0000, 'ºC'),
	(349578, 146, '2015-02-01 00:39:24.000000', 'temperatura', 81.0000, 'ºC'),
	(349579, 146, '2015-02-01 00:39:25.000000', 'temperatura', 490.0000, 'ºC'),
	(349580, 146, '2015-02-01 00:39:26.000000', 'temperatura', 1007.0000, 'ºC'),
	(349581, 146, '2015-02-01 00:39:27.000000', 'temperatura', 1165.0000, 'ºC'),
	(349582, 146, '2015-02-01 00:39:28.000000', 'temperatura', 405.0000, 'ºC'),
	(349583, 146, '2015-02-01 00:39:29.000000', 'temperatura', 932.0000, 'ºC'),
	(349584, 146, '2015-02-01 00:39:30.000000', 'temperatura', 1044.0000, 'ºC'),
	(349585, 146, '2015-02-01 00:39:31.000000', 'temperatura', 24.0000, 'ºC'),
	(349586, 146, '2015-02-01 00:39:32.000000', 'temperatura', 587.0000, 'ºC'),
	(349587, 146, '2015-02-01 00:39:33.000000', 'temperatura', 467.0000, 'ºC'),
	(349588, 146, '2015-02-01 00:39:34.000000', 'temperatura', 571.0000, 'ºC'),
	(349589, 146, '2015-02-01 00:39:35.000000', 'temperatura', 256.0000, 'ºC'),
	(349590, 146, '2015-02-01 00:39:36.000000', 'temperatura', 768.0000, 'ºC'),
	(349591, 146, '2015-02-01 00:39:37.000000', 'temperatura', 673.0000, 'ºC'),
	(349592, 146, '2015-02-01 00:39:38.000000', 'temperatura', 1062.0000, 'ºC'),
	(349593, 146, '2015-02-01 00:39:39.000000', 'temperatura', 891.0000, 'ºC'),
	(349594, 146, '2015-02-01 00:39:40.000000', 'temperatura', 69.0000, 'ºC'),
	(349595, 146, '2015-02-01 00:39:41.000000', 'temperatura', 74.0000, 'ºC'),
	(349596, 146, '2015-02-01 00:39:42.000000', 'temperatura', 162.0000, 'ºC'),
	(349597, 146, '2015-02-01 00:39:43.000000', 'temperatura', 591.0000, 'ºC'),
	(349598, 146, '2015-02-01 00:39:44.000000', 'temperatura', 68.0000, 'ºC'),
	(349599, 146, '2015-02-01 00:39:45.000000', 'temperatura', 968.0000, 'ºC'),
	(349600, 146, '2015-02-01 00:39:46.000000', 'temperatura', 1036.0000, 'ºC'),
	(349601, 146, '2015-02-01 00:39:47.000000', 'temperatura', 1078.0000, 'ºC'),
	(349602, 146, '2015-02-01 00:39:48.000000', 'temperatura', 1083.0000, 'ºC'),
	(349603, 146, '2015-02-01 00:39:49.000000', 'temperatura', 981.0000, 'ºC'),
	(349604, 146, '2015-02-01 00:39:50.000000', 'temperatura', 457.0000, 'ºC'),
	(349605, 146, '2015-02-01 00:39:51.000000', 'temperatura', 541.0000, 'ºC'),
	(349606, 146, '2015-02-01 00:39:52.000000', 'temperatura', 135.0000, 'ºC'),
	(349607, 146, '2015-02-01 00:39:53.000000', 'temperatura', 251.0000, 'ºC'),
	(349608, 146, '2015-02-01 00:39:54.000000', 'temperatura', 853.0000, 'ºC'),
	(349609, 146, '2015-02-01 00:39:55.000000', 'temperatura', 1111.0000, 'ºC'),
	(349610, 146, '2015-02-01 00:39:56.000000', 'temperatura', 597.0000, 'ºC'),
	(349611, 146, '2015-02-01 00:39:57.000000', 'temperatura', 854.0000, 'ºC'),
	(349612, 146, '2015-02-01 00:39:58.000000', 'temperatura', 78.0000, 'ºC'),
	(349613, 146, '2015-02-01 00:39:59.000000', 'temperatura', 228.0000, 'ºC'),
	(349614, 146, '2015-02-01 00:40:00.000000', 'temperatura', 905.0000, 'ºC'),
	(349615, 146, '2015-02-01 00:40:01.000000', 'temperatura', 244.0000, 'ºC'),
	(349616, 146, '2015-02-01 00:40:02.000000', 'temperatura', 903.0000, 'ºC'),
	(349617, 146, '2015-02-01 00:40:03.000000', 'temperatura', 184.0000, 'ºC'),
	(349618, 146, '2015-02-01 00:40:04.000000', 'temperatura', 612.0000, 'ºC'),
	(349619, 146, '2015-02-01 00:40:05.000000', 'temperatura', 108.0000, 'ºC'),
	(349620, 146, '2015-02-01 00:40:06.000000', 'temperatura', 1103.0000, 'ºC'),
	(349621, 146, '2015-02-01 00:40:07.000000', 'temperatura', 393.0000, 'ºC'),
	(349622, 146, '2015-02-01 00:40:08.000000', 'temperatura', 1055.0000, 'ºC'),
	(349623, 146, '2015-02-01 00:40:09.000000', 'temperatura', 497.0000, 'ºC'),
	(349624, 146, '2015-02-01 00:40:10.000000', 'temperatura', 523.0000, 'ºC'),
	(349625, 146, '2015-02-01 00:40:11.000000', 'temperatura', 1121.0000, 'ºC'),
	(349626, 146, '2015-02-01 00:40:12.000000', 'temperatura', 438.0000, 'ºC'),
	(349627, 146, '2015-02-01 00:40:13.000000', 'temperatura', 26.0000, 'ºC'),
	(349628, 146, '2015-02-01 00:40:14.000000', 'temperatura', 16.0000, 'ºC'),
	(349629, 146, '2015-02-01 00:40:15.000000', 'temperatura', 2.0000, 'ºC'),
	(349630, 146, '2015-02-01 00:40:16.000000', 'temperatura', 1162.0000, 'ºC'),
	(349631, 146, '2015-02-01 00:40:17.000000', 'temperatura', 1004.0000, 'ºC'),
	(349632, 146, '2015-02-01 00:40:18.000000', 'temperatura', 334.0000, 'ºC'),
	(349633, 146, '2015-02-01 00:40:19.000000', 'temperatura', 1057.0000, 'ºC'),
	(349634, 146, '2015-02-01 00:40:20.000000', 'temperatura', 687.0000, 'ºC'),
	(349635, 146, '2015-02-01 00:40:21.000000', 'temperatura', 265.0000, 'ºC'),
	(349636, 146, '2015-02-01 00:40:22.000000', 'temperatura', 464.0000, 'ºC'),
	(349637, 146, '2015-02-01 00:40:23.000000', 'temperatura', 326.0000, 'ºC'),
	(349638, 146, '2015-02-01 00:40:24.000000', 'temperatura', 239.0000, 'ºC'),
	(349639, 146, '2015-02-01 00:40:25.000000', 'temperatura', 217.0000, 'ºC'),
	(349640, 146, '2015-02-01 00:40:26.000000', 'temperatura', 367.0000, 'ºC'),
	(349641, 146, '2015-02-01 00:40:27.000000', 'temperatura', 1185.0000, 'ºC'),
	(349642, 146, '2015-02-01 00:40:28.000000', 'temperatura', 26.0000, 'ºC'),
	(349643, 146, '2015-02-01 00:40:29.000000', 'temperatura', 176.0000, 'ºC'),
	(349644, 146, '2015-02-01 00:40:30.000000', 'temperatura', 803.0000, 'ºC'),
	(349645, 146, '2015-02-01 00:40:31.000000', 'temperatura', 1088.0000, 'ºC'),
	(349646, 146, '2015-02-01 00:40:32.000000', 'temperatura', 632.0000, 'ºC'),
	(349647, 146, '2015-02-01 00:40:33.000000', 'temperatura', 1095.0000, 'ºC'),
	(349648, 146, '2015-02-01 00:40:34.000000', 'temperatura', 1181.0000, 'ºC'),
	(349649, 146, '2015-02-01 00:40:35.000000', 'temperatura', 221.0000, 'ºC'),
	(349650, 146, '2015-02-01 00:40:36.000000', 'temperatura', 1162.0000, 'ºC'),
	(349651, 146, '2015-02-01 00:40:37.000000', 'temperatura', 348.0000, 'ºC'),
	(349652, 146, '2015-02-01 00:40:38.000000', 'temperatura', 655.0000, 'ºC'),
	(349653, 146, '2015-02-01 00:40:39.000000', 'temperatura', 1030.0000, 'ºC'),
	(349654, 146, '2015-02-01 00:40:40.000000', 'temperatura', 784.0000, 'ºC'),
	(349655, 146, '2015-02-01 00:40:41.000000', 'temperatura', 832.0000, 'ºC'),
	(349656, 146, '2015-02-01 00:40:42.000000', 'temperatura', 608.0000, 'ºC'),
	(349657, 146, '2015-02-01 00:40:43.000000', 'temperatura', 545.0000, 'ºC'),
	(349658, 146, '2015-02-01 00:40:44.000000', 'temperatura', 900.0000, 'ºC'),
	(349659, 146, '2015-02-01 00:40:45.000000', 'temperatura', 467.0000, 'ºC'),
	(349660, 146, '2015-02-01 00:40:46.000000', 'temperatura', 835.0000, 'ºC'),
	(349661, 146, '2015-02-01 00:40:47.000000', 'temperatura', 376.0000, 'ºC'),
	(349662, 146, '2015-02-01 00:40:48.000000', 'temperatura', 575.0000, 'ºC'),
	(349663, 146, '2015-02-01 00:40:49.000000', 'temperatura', 548.0000, 'ºC'),
	(349664, 146, '2015-02-01 00:40:50.000000', 'temperatura', 1015.0000, 'ºC'),
	(349665, 146, '2015-02-01 00:40:51.000000', 'temperatura', 1033.0000, 'ºC'),
	(349666, 146, '2015-02-01 00:40:52.000000', 'temperatura', 918.0000, 'ºC'),
	(349667, 146, '2015-02-01 00:40:53.000000', 'temperatura', 291.0000, 'ºC'),
	(349668, 146, '2015-02-01 00:40:54.000000', 'temperatura', 1101.0000, 'ºC'),
	(349669, 146, '2015-02-01 00:40:55.000000', 'temperatura', 1033.0000, 'ºC'),
	(349670, 146, '2015-02-01 00:40:56.000000', 'temperatura', 663.0000, 'ºC'),
	(349671, 146, '2015-02-01 00:40:57.000000', 'temperatura', 215.0000, 'ºC'),
	(349672, 146, '2015-02-01 00:40:58.000000', 'temperatura', 287.0000, 'ºC'),
	(349673, 146, '2015-02-01 00:40:59.000000', 'temperatura', 790.0000, 'ºC'),
	(349674, 146, '2015-02-01 00:41:00.000000', 'temperatura', 691.0000, 'ºC'),
	(349675, 146, '2015-02-01 00:41:01.000000', 'temperatura', 1085.0000, 'ºC'),
	(349676, 146, '2015-02-01 00:41:02.000000', 'temperatura', 953.0000, 'ºC'),
	(349677, 146, '2015-02-01 00:41:03.000000', 'temperatura', 310.0000, 'ºC'),
	(349678, 146, '2015-02-01 00:41:04.000000', 'temperatura', 1090.0000, 'ºC'),
	(349679, 146, '2015-02-01 00:41:05.000000', 'temperatura', 920.0000, 'ºC'),
	(349680, 146, '2015-02-01 00:41:06.000000', 'temperatura', 130.0000, 'ºC'),
	(349681, 146, '2015-02-01 00:41:07.000000', 'temperatura', 292.0000, 'ºC'),
	(349682, 146, '2015-02-01 00:41:08.000000', 'temperatura', 1068.0000, 'ºC'),
	(349683, 146, '2015-02-01 00:41:09.000000', 'temperatura', 868.0000, 'ºC'),
	(349684, 146, '2015-02-01 00:41:10.000000', 'temperatura', 1134.0000, 'ºC'),
	(349685, 146, '2015-02-01 00:41:11.000000', 'temperatura', 667.0000, 'ºC'),
	(349686, 146, '2015-02-01 00:41:12.000000', 'temperatura', 1135.0000, 'ºC'),
	(349687, 146, '2015-02-01 00:41:13.000000', 'temperatura', 75.0000, 'ºC'),
	(349688, 146, '2015-02-01 00:41:14.000000', 'temperatura', 570.0000, 'ºC'),
	(349689, 146, '2015-02-01 00:41:15.000000', 'temperatura', 223.0000, 'ºC'),
	(349690, 146, '2015-02-01 00:41:16.000000', 'temperatura', 608.0000, 'ºC'),
	(349691, 146, '2015-02-01 00:41:17.000000', 'temperatura', 1169.0000, 'ºC'),
	(349692, 146, '2015-02-01 00:41:18.000000', 'temperatura', 422.0000, 'ºC'),
	(349693, 146, '2015-02-01 00:41:19.000000', 'temperatura', 1006.0000, 'ºC'),
	(349694, 146, '2015-02-01 00:41:20.000000', 'temperatura', 161.0000, 'ºC'),
	(349695, 146, '2015-02-01 00:41:21.000000', 'temperatura', 189.0000, 'ºC'),
	(349696, 146, '2015-02-01 00:41:22.000000', 'temperatura', 463.0000, 'ºC'),
	(349697, 146, '2015-02-01 00:41:23.000000', 'temperatura', 548.0000, 'ºC'),
	(349698, 146, '2015-02-01 00:41:24.000000', 'temperatura', 154.0000, 'ºC'),
	(349699, 146, '2015-02-01 00:41:25.000000', 'temperatura', 323.0000, 'ºC'),
	(349700, 146, '2015-02-01 00:41:26.000000', 'temperatura', 1154.0000, 'ºC'),
	(349701, 146, '2015-02-01 00:41:27.000000', 'temperatura', 0.0000, 'ºC'),
	(349702, 146, '2015-02-01 00:41:28.000000', 'temperatura', 141.0000, 'ºC'),
	(349703, 146, '2015-02-01 00:41:29.000000', 'temperatura', 705.0000, 'ºC'),
	(349704, 146, '2015-02-01 00:41:30.000000', 'temperatura', 703.0000, 'ºC'),
	(349705, 146, '2015-02-01 00:41:31.000000', 'temperatura', 202.0000, 'ºC'),
	(349706, 146, '2015-02-01 00:41:32.000000', 'temperatura', 98.0000, 'ºC'),
	(349707, 146, '2015-02-01 00:41:33.000000', 'temperatura', 1086.0000, 'ºC'),
	(349708, 146, '2015-02-01 00:41:34.000000', 'temperatura', 337.0000, 'ºC'),
	(349709, 146, '2015-02-01 00:41:35.000000', 'temperatura', 827.0000, 'ºC'),
	(349710, 146, '2015-02-01 00:41:36.000000', 'temperatura', 724.0000, 'ºC'),
	(349711, 146, '2015-02-01 00:41:37.000000', 'temperatura', 1140.0000, 'ºC'),
	(349712, 146, '2015-02-01 00:41:38.000000', 'temperatura', 1127.0000, 'ºC'),
	(349713, 146, '2015-02-01 00:41:39.000000', 'temperatura', 1015.0000, 'ºC'),
	(349714, 146, '2015-02-01 00:41:40.000000', 'temperatura', 494.0000, 'ºC'),
	(349715, 146, '2015-02-01 00:41:41.000000', 'temperatura', 628.0000, 'ºC'),
	(349716, 146, '2015-02-01 00:41:42.000000', 'temperatura', 458.0000, 'ºC'),
	(349717, 146, '2015-02-01 00:41:43.000000', 'temperatura', 406.0000, 'ºC'),
	(349718, 146, '2015-02-01 00:41:44.000000', 'temperatura', 657.0000, 'ºC'),
	(349719, 146, '2015-02-01 00:41:45.000000', 'temperatura', 868.0000, 'ºC'),
	(349720, 146, '2015-02-01 00:41:46.000000', 'temperatura', 1168.0000, 'ºC'),
	(349721, 146, '2015-02-01 00:41:47.000000', 'temperatura', 836.0000, 'ºC'),
	(349722, 146, '2015-02-01 00:41:48.000000', 'temperatura', 676.0000, 'ºC'),
	(349723, 146, '2015-02-01 00:41:49.000000', 'temperatura', 873.0000, 'ºC'),
	(349724, 146, '2015-02-01 00:41:50.000000', 'temperatura', 1137.0000, 'ºC'),
	(349725, 146, '2015-02-01 00:41:51.000000', 'temperatura', 669.0000, 'ºC'),
	(349726, 146, '2015-02-01 00:41:52.000000', 'temperatura', 1133.0000, 'ºC'),
	(349727, 146, '2015-02-01 00:41:53.000000', 'temperatura', 60.0000, 'ºC'),
	(349728, 146, '2015-02-01 00:41:54.000000', 'temperatura', 500.0000, 'ºC'),
	(349729, 146, '2015-02-01 00:41:55.000000', 'temperatura', 1121.0000, 'ºC'),
	(349730, 146, '2015-02-01 00:41:56.000000', 'temperatura', 507.0000, 'ºC'),
	(349731, 146, '2015-02-01 00:41:57.000000', 'temperatura', 374.0000, 'ºC'),
	(349732, 146, '2015-02-01 00:41:58.000000', 'temperatura', 346.0000, 'ºC'),
	(349733, 146, '2015-02-01 00:41:59.000000', 'temperatura', 608.0000, 'ºC'),
	(349734, 146, '2015-02-01 00:42:00.000000', 'temperatura', 802.0000, 'ºC'),
	(349735, 146, '2015-02-01 00:42:01.000000', 'temperatura', 989.0000, 'ºC'),
	(349736, 146, '2015-02-01 00:42:02.000000', 'temperatura', 140.0000, 'ºC'),
	(349737, 146, '2015-02-01 00:42:03.000000', 'temperatura', 131.0000, 'ºC'),
	(349738, 146, '2015-02-01 00:42:04.000000', 'temperatura', 235.0000, 'ºC'),
	(349739, 146, '2015-02-01 00:42:05.000000', 'temperatura', 784.0000, 'ºC'),
	(349740, 146, '2015-02-01 00:42:06.000000', 'temperatura', 817.0000, 'ºC'),
	(349741, 146, '2015-02-01 00:42:07.000000', 'temperatura', 532.0000, 'ºC'),
	(349742, 146, '2015-02-01 00:42:08.000000', 'temperatura', 211.0000, 'ºC'),
	(349743, 146, '2015-02-01 00:42:09.000000', 'temperatura', 657.0000, 'ºC'),
	(349744, 146, '2015-02-01 00:42:10.000000', 'temperatura', 256.0000, 'ºC'),
	(349745, 146, '2015-02-01 00:42:11.000000', 'temperatura', 506.0000, 'ºC'),
	(349746, 146, '2015-02-01 00:42:12.000000', 'temperatura', 565.0000, 'ºC'),
	(349747, 146, '2015-02-01 00:42:13.000000', 'temperatura', 108.0000, 'ºC'),
	(349748, 146, '2015-02-01 00:42:14.000000', 'temperatura', 44.0000, 'ºC'),
	(349749, 146, '2015-02-01 00:42:15.000000', 'temperatura', 1099.0000, 'ºC'),
	(349750, 146, '2015-02-01 00:42:16.000000', 'temperatura', 561.0000, 'ºC'),
	(349751, 146, '2015-02-01 00:42:17.000000', 'temperatura', 709.0000, 'ºC'),
	(349752, 146, '2015-02-01 00:42:18.000000', 'temperatura', 665.0000, 'ºC'),
	(349753, 146, '2015-02-01 00:42:19.000000', 'temperatura', 1195.0000, 'ºC'),
	(349754, 146, '2015-02-01 00:42:20.000000', 'temperatura', 384.0000, 'ºC'),
	(349755, 146, '2015-02-01 00:42:21.000000', 'temperatura', 734.0000, 'ºC'),
	(349756, 146, '2015-02-01 00:42:22.000000', 'temperatura', 117.0000, 'ºC'),
	(349757, 146, '2015-02-01 00:42:23.000000', 'temperatura', 786.0000, 'ºC'),
	(349758, 146, '2015-02-01 00:42:24.000000', 'temperatura', 1178.0000, 'ºC'),
	(349759, 146, '2015-02-01 00:42:25.000000', 'temperatura', 1132.0000, 'ºC'),
	(349760, 146, '2015-02-01 00:42:26.000000', 'temperatura', 926.0000, 'ºC'),
	(349761, 146, '2015-02-01 00:42:27.000000', 'temperatura', 35.0000, 'ºC'),
	(349762, 146, '2015-02-01 00:42:28.000000', 'temperatura', 996.0000, 'ºC'),
	(349763, 146, '2015-02-01 00:42:29.000000', 'temperatura', 76.0000, 'ºC'),
	(349764, 146, '2015-02-01 00:42:30.000000', 'temperatura', 991.0000, 'ºC'),
	(349765, 146, '2015-02-01 00:42:31.000000', 'temperatura', 1130.0000, 'ºC'),
	(349766, 146, '2015-02-01 00:42:32.000000', 'temperatura', 277.0000, 'ºC'),
	(349767, 146, '2015-02-01 00:42:33.000000', 'temperatura', 396.0000, 'ºC'),
	(349768, 146, '2015-02-01 00:42:34.000000', 'temperatura', 1151.0000, 'ºC'),
	(349769, 146, '2015-02-01 00:42:35.000000', 'temperatura', 965.0000, 'ºC'),
	(349770, 146, '2015-02-01 00:42:36.000000', 'temperatura', 174.0000, 'ºC'),
	(349771, 146, '2015-02-01 00:42:37.000000', 'temperatura', 376.0000, 'ºC'),
	(349772, 146, '2015-02-01 00:42:38.000000', 'temperatura', 158.0000, 'ºC'),
	(349773, 146, '2015-02-01 00:42:39.000000', 'temperatura', 860.0000, 'ºC'),
	(349774, 146, '2015-02-01 00:42:40.000000', 'temperatura', 230.0000, 'ºC'),
	(349775, 146, '2015-02-01 00:42:41.000000', 'temperatura', 969.0000, 'ºC'),
	(349776, 146, '2015-02-01 00:42:42.000000', 'temperatura', 554.0000, 'ºC'),
	(349777, 146, '2015-02-01 00:42:43.000000', 'temperatura', 1066.0000, 'ºC'),
	(349778, 146, '2015-02-01 00:42:44.000000', 'temperatura', 67.0000, 'ºC'),
	(349779, 146, '2015-02-01 00:42:45.000000', 'temperatura', 736.0000, 'ºC'),
	(349780, 146, '2015-02-01 00:42:46.000000', 'temperatura', 1081.0000, 'ºC'),
	(349781, 146, '2015-02-01 00:42:47.000000', 'temperatura', 799.0000, 'ºC'),
	(349782, 146, '2015-02-01 00:42:48.000000', 'temperatura', 753.0000, 'ºC'),
	(349783, 146, '2015-02-01 00:42:49.000000', 'temperatura', 168.0000, 'ºC'),
	(349784, 146, '2015-02-01 00:42:50.000000', 'temperatura', 981.0000, 'ºC'),
	(349785, 146, '2015-02-01 00:42:51.000000', 'temperatura', 801.0000, 'ºC'),
	(349786, 146, '2015-02-01 00:42:52.000000', 'temperatura', 1061.0000, 'ºC'),
	(349787, 146, '2015-02-01 00:42:53.000000', 'temperatura', 506.0000, 'ºC'),
	(349788, 146, '2015-02-01 00:42:54.000000', 'temperatura', 545.0000, 'ºC'),
	(349789, 146, '2015-02-01 00:42:55.000000', 'temperatura', 8.0000, 'ºC'),
	(349790, 146, '2015-02-01 00:42:56.000000', 'temperatura', 805.0000, 'ºC'),
	(349791, 146, '2015-02-01 00:42:57.000000', 'temperatura', 400.0000, 'ºC'),
	(349792, 146, '2015-02-01 00:42:58.000000', 'temperatura', 787.0000, 'ºC'),
	(349793, 146, '2015-02-01 00:42:59.000000', 'temperatura', 336.0000, 'ºC'),
	(349794, 146, '2015-02-01 00:43:00.000000', 'temperatura', 517.0000, 'ºC'),
	(349795, 146, '2015-02-01 00:43:01.000000', 'temperatura', 380.0000, 'ºC'),
	(349796, 146, '2015-02-01 00:43:02.000000', 'temperatura', 348.0000, 'ºC'),
	(349797, 146, '2015-02-01 00:43:03.000000', 'temperatura', 599.0000, 'ºC'),
	(349798, 146, '2015-02-01 00:43:04.000000', 'temperatura', 755.0000, 'ºC'),
	(349799, 146, '2015-02-01 00:43:05.000000', 'temperatura', 777.0000, 'ºC'),
	(349800, 146, '2015-02-01 00:43:06.000000', 'temperatura', 420.0000, 'ºC'),
	(349801, 146, '2015-02-01 00:43:07.000000', 'temperatura', 971.0000, 'ºC'),
	(349802, 146, '2015-02-01 00:43:08.000000', 'temperatura', 1195.0000, 'ºC'),
	(349803, 146, '2015-02-01 00:43:09.000000', 'temperatura', 660.0000, 'ºC'),
	(349804, 146, '2015-02-01 00:43:10.000000', 'temperatura', 918.0000, 'ºC'),
	(349805, 146, '2015-02-01 00:43:11.000000', 'temperatura', 210.0000, 'ºC'),
	(349806, 146, '2015-02-01 00:43:12.000000', 'temperatura', 698.0000, 'ºC'),
	(349807, 146, '2015-02-01 00:43:13.000000', 'temperatura', 459.0000, 'ºC'),
	(349808, 146, '2015-02-01 00:43:14.000000', 'temperatura', 200.0000, 'ºC'),
	(349809, 146, '2015-02-01 00:43:15.000000', 'temperatura', 824.0000, 'ºC'),
	(349810, 146, '2015-02-01 00:43:16.000000', 'temperatura', 1119.0000, 'ºC'),
	(349811, 146, '2015-02-01 00:43:17.000000', 'temperatura', 727.0000, 'ºC'),
	(349812, 146, '2015-02-01 00:43:18.000000', 'temperatura', 276.0000, 'ºC'),
	(349813, 146, '2015-02-01 00:43:19.000000', 'temperatura', 399.0000, 'ºC'),
	(349814, 146, '2015-02-01 00:43:20.000000', 'temperatura', 1168.0000, 'ºC'),
	(349815, 146, '2015-02-01 00:43:21.000000', 'temperatura', 1044.0000, 'ºC'),
	(349816, 146, '2015-02-01 00:43:22.000000', 'temperatura', 515.0000, 'ºC'),
	(349817, 146, '2015-02-01 00:43:23.000000', 'temperatura', 643.0000, 'ºC'),
	(349818, 146, '2015-02-01 00:43:24.000000', 'temperatura', 471.0000, 'ºC'),
	(349819, 146, '2015-02-01 00:43:25.000000', 'temperatura', 429.0000, 'ºC'),
	(349820, 146, '2015-02-01 00:43:26.000000', 'temperatura', 730.0000, 'ºC'),
	(349821, 146, '2015-02-01 00:43:27.000000', 'temperatura', 1162.0000, 'ºC'),
	(349822, 146, '2015-02-01 00:43:28.000000', 'temperatura', 23.0000, 'ºC'),
	(349823, 146, '2015-02-01 00:43:29.000000', 'temperatura', 229.0000, 'ºC'),
	(349824, 146, '2015-02-01 00:43:30.000000', 'temperatura', 1078.0000, 'ºC'),
	(349825, 146, '2015-02-01 00:43:31.000000', 'temperatura', 1101.0000, 'ºC'),
	(349826, 146, '2015-02-01 00:43:32.000000', 'temperatura', 1073.0000, 'ºC'),
	(349827, 146, '2015-02-01 00:43:33.000000', 'temperatura', 862.0000, 'ºC'),
	(349828, 146, '2015-02-01 00:43:34.000000', 'temperatura', 1090.0000, 'ºC'),
	(349829, 146, '2015-02-01 00:43:35.000000', 'temperatura', 463.0000, 'ºC'),
	(349830, 146, '2015-02-01 00:43:36.000000', 'temperatura', 249.0000, 'ºC'),
	(349831, 146, '2015-02-01 00:43:37.000000', 'temperatura', 1057.0000, 'ºC'),
	(349832, 146, '2015-02-01 00:43:38.000000', 'temperatura', 935.0000, 'ºC'),
	(349833, 146, '2015-02-01 00:43:39.000000', 'temperatura', 307.0000, 'ºC'),
	(349834, 146, '2015-02-01 00:43:40.000000', 'temperatura', 1130.0000, 'ºC'),
	(349835, 146, '2015-02-01 00:43:41.000000', 'temperatura', 1127.0000, 'ºC'),
	(349836, 146, '2015-02-01 00:43:42.000000', 'temperatura', 1049.0000, 'ºC'),
	(349837, 146, '2015-02-01 00:43:43.000000', 'temperatura', 663.0000, 'ºC'),
	(349838, 146, '2015-02-01 00:43:44.000000', 'temperatura', 167.0000, 'ºC'),
	(349839, 146, '2015-02-01 00:43:45.000000', 'temperatura', 49.0000, 'ºC'),
	(349840, 146, '2015-02-01 00:43:46.000000', 'temperatura', 944.0000, 'ºC'),
	(349841, 146, '2015-02-01 00:43:47.000000', 'temperatura', 972.0000, 'ºC'),
	(349842, 146, '2015-02-01 00:43:48.000000', 'temperatura', 830.0000, 'ºC'),
	(349843, 146, '2015-02-01 00:43:49.000000', 'temperatura', 33.0000, 'ºC'),
	(349844, 146, '2015-02-01 00:43:50.000000', 'temperatura', 77.0000, 'ºC'),
	(349845, 146, '2015-02-01 00:43:51.000000', 'temperatura', 286.0000, 'ºC'),
	(349846, 146, '2015-02-01 00:43:52.000000', 'temperatura', 0.0000, 'ºC'),
	(349847, 146, '2015-02-01 00:43:53.000000', 'temperatura', 341.0000, 'ºC'),
	(349848, 146, '2015-02-01 00:43:54.000000', 'temperatura', 506.0000, 'ºC'),
	(349849, 146, '2015-02-01 00:43:55.000000', 'temperatura', 309.0000, 'ºC'),
	(349850, 146, '2015-02-01 00:43:56.000000', 'temperatura', 26.0000, 'ºC'),
	(349851, 146, '2015-02-01 00:43:57.000000', 'temperatura', 405.0000, 'ºC'),
	(349852, 146, '2015-02-01 00:43:58.000000', 'temperatura', 747.0000, 'ºC'),
	(349853, 146, '2015-02-01 00:43:59.000000', 'temperatura', 120.0000, 'ºC'),
	(349854, 146, '2015-02-01 00:44:00.000000', 'temperatura', 760.0000, 'ºC'),
	(349855, 146, '2015-02-01 00:44:01.000000', 'temperatura', 1040.0000, 'ºC'),
	(349856, 146, '2015-02-01 00:44:02.000000', 'temperatura', 520.0000, 'ºC'),
	(349857, 146, '2015-02-01 00:44:03.000000', 'temperatura', 680.0000, 'ºC'),
	(349858, 146, '2015-02-01 00:44:04.000000', 'temperatura', 643.0000, 'ºC'),
	(349859, 146, '2015-02-01 00:44:05.000000', 'temperatura', 1172.0000, 'ºC'),
	(349860, 146, '2015-02-01 00:44:06.000000', 'temperatura', 334.0000, 'ºC'),
	(349861, 146, '2015-02-01 00:44:07.000000', 'temperatura', 555.0000, 'ºC'),
	(349862, 146, '2015-02-01 00:44:08.000000', 'temperatura', 572.0000, 'ºC'),
	(349863, 146, '2015-02-01 00:44:09.000000', 'temperatura', 1197.0000, 'ºC'),
	(349864, 146, '2015-02-01 00:44:10.000000', 'temperatura', 669.0000, 'ºC'),
	(349865, 146, '2015-02-01 00:44:11.000000', 'temperatura', 956.0000, 'ºC'),
	(349866, 146, '2015-02-01 00:44:12.000000', 'temperatura', 373.0000, 'ºC'),
	(349867, 146, '2015-02-01 00:44:13.000000', 'temperatura', 199.0000, 'ºC'),
	(349868, 146, '2015-02-01 00:44:14.000000', 'temperatura', 1074.0000, 'ºC'),
	(349869, 146, '2015-02-01 00:44:15.000000', 'temperatura', 1174.0000, 'ºC'),
	(349870, 146, '2015-02-01 00:44:16.000000', 'temperatura', 250.0000, 'ºC'),
	(349871, 146, '2015-02-01 00:44:17.000000', 'temperatura', 126.0000, 'ºC'),
	(349872, 146, '2015-02-01 00:44:18.000000', 'temperatura', 1079.0000, 'ºC'),
	(349873, 146, '2015-02-01 00:44:19.000000', 'temperatura', 221.0000, 'ºC'),
	(349874, 146, '2015-02-01 00:44:20.000000', 'temperatura', 269.0000, 'ºC'),
	(349875, 146, '2015-02-01 00:44:21.000000', 'temperatura', 680.0000, 'ºC'),
	(349876, 146, '2015-02-01 00:44:22.000000', 'temperatura', 195.0000, 'ºC'),
	(349877, 146, '2015-02-01 00:44:23.000000', 'temperatura', 133.0000, 'ºC'),
	(349878, 146, '2015-02-01 00:44:24.000000', 'temperatura', 83.0000, 'ºC'),
	(349879, 146, '2015-02-01 00:44:25.000000', 'temperatura', 14.0000, 'ºC'),
	(349880, 146, '2015-02-01 00:44:26.000000', 'temperatura', 1023.0000, 'ºC'),
	(349881, 146, '2015-02-01 00:44:27.000000', 'temperatura', 274.0000, 'ºC'),
	(349882, 146, '2015-02-01 00:44:28.000000', 'temperatura', 700.0000, 'ºC'),
	(349883, 146, '2015-02-01 00:44:29.000000', 'temperatura', 281.0000, 'ºC'),
	(349884, 146, '2015-02-01 00:44:30.000000', 'temperatura', 504.0000, 'ºC'),
	(349885, 146, '2015-02-01 00:44:31.000000', 'temperatura', 476.0000, 'ºC'),
	(349886, 146, '2015-02-01 00:44:32.000000', 'temperatura', 871.0000, 'ºC'),
	(349887, 146, '2015-02-01 00:44:33.000000', 'temperatura', 525.0000, 'ºC'),
	(349888, 146, '2015-02-01 00:44:34.000000', 'temperatura', 13.0000, 'ºC'),
	(349889, 146, '2015-02-01 00:44:35.000000', 'temperatura', 889.0000, 'ºC'),
	(349890, 146, '2015-02-01 00:44:36.000000', 'temperatura', 810.0000, 'ºC'),
	(349891, 146, '2015-02-01 00:44:37.000000', 'temperatura', 180.0000, 'ºC'),
	(349892, 146, '2015-02-01 00:44:38.000000', 'temperatura', 872.0000, 'ºC'),
	(349893, 146, '2015-02-01 00:44:39.000000', 'temperatura', 221.0000, 'ºC'),
	(349894, 146, '2015-02-01 00:44:40.000000', 'temperatura', 888.0000, 'ºC'),
	(349895, 146, '2015-02-01 00:44:41.000000', 'temperatura', 180.0000, 'ºC'),
	(349896, 146, '2015-02-01 00:44:42.000000', 'temperatura', 635.0000, 'ºC'),
	(349897, 146, '2015-02-01 00:44:43.000000', 'temperatura', 238.0000, 'ºC'),
	(349898, 146, '2015-02-01 00:44:44.000000', 'temperatura', 482.0000, 'ºC'),
	(349899, 146, '2015-02-01 00:44:45.000000', 'temperatura', 499.0000, 'ºC'),
	(349900, 146, '2015-02-01 00:44:46.000000', 'temperatura', 1050.0000, 'ºC'),
	(349901, 146, '2015-02-01 00:44:47.000000', 'temperatura', 152.0000, 'ºC'),
	(349902, 146, '2015-02-01 00:44:48.000000', 'temperatura', 10.0000, 'ºC'),
	(349903, 146, '2015-02-01 00:44:49.000000', 'temperatura', 797.0000, 'ºC'),
	(349904, 146, '2015-02-01 00:44:50.000000', 'temperatura', 355.0000, 'ºC'),
	(349905, 146, '2015-02-01 00:44:51.000000', 'temperatura', 585.0000, 'ºC'),
	(349906, 146, '2015-02-01 00:44:52.000000', 'temperatura', 661.0000, 'ºC'),
	(349907, 146, '2015-02-01 00:44:53.000000', 'temperatura', 350.0000, 'ºC'),
	(349908, 146, '2015-02-01 00:44:54.000000', 'temperatura', 965.0000, 'ºC'),
	(349909, 146, '2015-02-01 00:44:55.000000', 'temperatura', 178.0000, 'ºC'),
	(349910, 146, '2015-02-01 00:44:56.000000', 'temperatura', 397.0000, 'ºC'),
	(349911, 146, '2015-02-01 00:44:57.000000', 'temperatura', 249.0000, 'ºC'),
	(349912, 146, '2015-02-01 00:44:58.000000', 'temperatura', 57.0000, 'ºC'),
	(349913, 146, '2015-02-01 00:44:59.000000', 'temperatura', 738.0000, 'ºC'),
	(349914, 146, '2015-02-01 00:45:00.000000', 'temperatura', 1118.0000, 'ºC'),
	(349915, 146, '2015-02-01 00:45:01.000000', 'temperatura', 977.0000, 'ºC'),
	(349916, 146, '2015-02-01 00:45:02.000000', 'temperatura', 333.0000, 'ºC'),
	(349917, 146, '2015-02-01 00:45:03.000000', 'temperatura', 1135.0000, 'ºC'),
	(349918, 146, '2015-02-01 00:45:04.000000', 'temperatura', 1076.0000, 'ºC'),
	(349919, 146, '2015-02-01 00:45:05.000000', 'temperatura', 776.0000, 'ºC'),
	(349920, 146, '2015-02-01 00:45:06.000000', 'temperatura', 651.0000, 'ºC'),
	(349921, 146, '2015-02-01 00:45:07.000000', 'temperatura', 928.0000, 'ºC'),
	(349922, 146, '2015-02-01 00:45:08.000000', 'temperatura', 288.0000, 'ºC'),
	(349923, 146, '2015-02-01 00:45:09.000000', 'temperatura', 1058.0000, 'ºC'),
	(349924, 146, '2015-02-01 00:45:10.000000', 'temperatura', 823.0000, 'ºC'),
	(349925, 146, '2015-02-01 00:45:11.000000', 'temperatura', 944.0000, 'ºC'),
	(349926, 146, '2015-02-01 00:45:12.000000', 'temperatura', 1050.0000, 'ºC'),
	(349927, 146, '2015-02-01 00:45:13.000000', 'temperatura', 21.0000, 'ºC'),
	(349928, 146, '2015-02-01 00:45:14.000000', 'temperatura', 552.0000, 'ºC'),
	(349929, 146, '2015-02-01 00:45:15.000000', 'temperatura', 300.0000, 'ºC'),
	(349930, 146, '2015-02-01 00:45:16.000000', 'temperatura', 1044.0000, 'ºC'),
	(349931, 146, '2015-02-01 00:45:17.000000', 'temperatura', 720.0000, 'ºC'),
	(349932, 146, '2015-02-01 00:45:18.000000', 'temperatura', 467.0000, 'ºC'),
	(349933, 146, '2015-02-01 00:45:19.000000', 'temperatura', 176.0000, 'ºC'),
	(349934, 146, '2015-02-01 00:45:20.000000', 'temperatura', 680.0000, 'ºC'),
	(349935, 146, '2015-02-01 00:45:21.000000', 'temperatura', 471.0000, 'ºC'),
	(349936, 146, '2015-02-01 00:45:22.000000', 'temperatura', 318.0000, 'ºC'),
	(349937, 146, '2015-02-01 00:45:23.000000', 'temperatura', 176.0000, 'ºC'),
	(349938, 146, '2015-02-01 00:45:24.000000', 'temperatura', 1128.0000, 'ºC'),
	(349939, 146, '2015-02-01 00:45:25.000000', 'temperatura', 312.0000, 'ºC'),
	(349940, 146, '2015-02-01 00:45:26.000000', 'temperatura', 575.0000, 'ºC'),
	(349941, 146, '2015-02-01 00:45:27.000000', 'temperatura', 738.0000, 'ºC'),
	(349942, 146, '2015-02-01 00:45:28.000000', 'temperatura', 769.0000, 'ºC'),
	(349943, 146, '2015-02-01 00:45:29.000000', 'temperatura', 429.0000, 'ºC'),
	(349944, 146, '2015-02-01 00:45:30.000000', 'temperatura', 1040.0000, 'ºC'),
	(349945, 146, '2015-02-01 00:45:31.000000', 'temperatura', 313.0000, 'ºC'),
	(349946, 146, '2015-02-01 00:45:32.000000', 'temperatura', 844.0000, 'ºC'),
	(349947, 146, '2015-02-01 00:45:33.000000', 'temperatura', 884.0000, 'ºC'),
	(349948, 146, '2015-02-01 00:45:34.000000', 'temperatura', 687.0000, 'ºC'),
	(349949, 146, '2015-02-01 00:45:35.000000', 'temperatura', 784.0000, 'ºC'),
	(349950, 146, '2015-02-01 00:45:36.000000', 'temperatura', 661.0000, 'ºC'),
	(349951, 146, '2015-02-01 00:45:37.000000', 'temperatura', 952.0000, 'ºC'),
	(349952, 146, '2015-02-01 00:45:38.000000', 'temperatura', 377.0000, 'ºC'),
	(349953, 146, '2015-02-01 00:45:39.000000', 'temperatura', 229.0000, 'ºC'),
	(349954, 146, '2015-02-01 00:45:40.000000', 'temperatura', 17.0000, 'ºC'),
	(349955, 146, '2015-02-01 00:45:41.000000', 'temperatura', 599.0000, 'ºC'),
	(349956, 146, '2015-02-01 00:45:42.000000', 'temperatura', 541.0000, 'ºC'),
	(349957, 146, '2015-02-01 00:45:43.000000', 'temperatura', 912.0000, 'ºC'),
	(349958, 146, '2015-02-01 00:45:44.000000', 'temperatura', 534.0000, 'ºC'),
	(349959, 146, '2015-02-01 00:45:45.000000', 'temperatura', 1138.0000, 'ºC'),
	(349960, 146, '2015-02-01 00:45:46.000000', 'temperatura', 487.0000, 'ºC'),
	(349961, 146, '2015-02-01 00:45:47.000000', 'temperatura', 222.0000, 'ºC'),
	(349962, 146, '2015-02-01 00:45:48.000000', 'temperatura', 849.0000, 'ºC'),
	(349963, 146, '2015-02-01 00:45:49.000000', 'temperatura', 1179.0000, 'ºC'),
	(349964, 146, '2015-02-01 00:45:50.000000', 'temperatura', 950.0000, 'ºC'),
	(349965, 146, '2015-02-01 00:45:51.000000', 'temperatura', 13.0000, 'ºC'),
	(349966, 146, '2015-02-01 00:45:52.000000', 'temperatura', 817.0000, 'ºC'),
	(349967, 146, '2015-02-01 00:45:53.000000', 'temperatura', 447.0000, 'ºC'),
	(349968, 146, '2015-02-01 00:45:54.000000', 'temperatura', 983.0000, 'ºC'),
	(349969, 146, '2015-02-01 00:45:55.000000', 'temperatura', 1174.0000, 'ºC'),
	(349970, 146, '2015-02-01 00:45:56.000000', 'temperatura', 524.0000, 'ºC'),
	(349971, 146, '2015-02-01 00:45:57.000000', 'temperatura', 295.0000, 'ºC'),
	(349972, 146, '2015-02-01 00:45:58.000000', 'temperatura', 1106.0000, 'ºC'),
	(349973, 146, '2015-02-01 00:45:59.000000', 'temperatura', 1044.0000, 'ºC'),
	(349974, 146, '2015-02-01 00:46:00.000000', 'temperatura', 702.0000, 'ºC'),
	(349975, 146, '2015-02-01 00:46:01.000000', 'temperatura', 379.0000, 'ºC'),
	(349976, 146, '2015-02-01 00:46:02.000000', 'temperatura', 990.0000, 'ºC'),
	(349977, 146, '2015-02-01 00:46:03.000000', 'temperatura', 215.0000, 'ºC'),
	(349978, 146, '2015-02-01 00:46:04.000000', 'temperatura', 505.0000, 'ºC'),
	(349979, 146, '2015-02-01 00:46:05.000000', 'temperatura', 682.0000, 'ºC'),
	(349980, 146, '2015-02-01 00:46:06.000000', 'temperatura', 694.0000, 'ºC'),
	(349981, 146, '2015-02-01 00:46:07.000000', 'temperatura', 225.0000, 'ºC'),
	(349982, 146, '2015-02-01 00:46:08.000000', 'temperatura', 244.0000, 'ºC'),
	(349983, 146, '2015-02-01 00:46:09.000000', 'temperatura', 544.0000, 'ºC'),
	(349984, 146, '2015-02-01 00:46:10.000000', 'temperatura', 789.0000, 'ºC'),
	(349985, 146, '2015-02-01 00:46:11.000000', 'temperatura', 1114.0000, 'ºC'),
	(349986, 146, '2015-02-01 00:46:12.000000', 'temperatura', 805.0000, 'ºC'),
	(349987, 146, '2015-02-01 00:46:13.000000', 'temperatura', 683.0000, 'ºC'),
	(349988, 146, '2015-02-01 00:46:14.000000', 'temperatura', 1001.0000, 'ºC'),
	(349989, 146, '2015-02-01 00:46:15.000000', 'temperatura', 558.0000, 'ºC'),
	(349990, 146, '2015-02-01 00:46:16.000000', 'temperatura', 984.0000, 'ºC'),
	(349991, 146, '2015-02-01 00:46:17.000000', 'temperatura', 849.0000, 'ºC'),
	(349992, 146, '2015-02-01 00:46:18.000000', 'temperatura', 93.0000, 'ºC'),
	(349993, 146, '2015-02-01 00:46:19.000000', 'temperatura', 317.0000, 'ºC'),
	(349994, 146, '2015-02-01 00:46:20.000000', 'temperatura', 107.0000, 'ºC'),
	(349995, 146, '2015-02-01 00:46:21.000000', 'temperatura', 786.0000, 'ºC'),
	(349996, 146, '2015-02-01 00:46:22.000000', 'temperatura', 10.0000, 'ºC'),
	(349997, 146, '2015-02-01 00:46:23.000000', 'temperatura', 91.0000, 'ºC'),
	(349998, 146, '2015-02-01 00:46:24.000000', 'temperatura', 426.0000, 'ºC'),
	(349999, 146, '2015-02-01 00:46:25.000000', 'temperatura', 659.0000, 'ºC'),
	(350000, 146, '2015-02-01 00:46:26.000000', 'temperatura', 818.0000, 'ºC'),
	(350001, 146, '2015-02-01 00:46:27.000000', 'temperatura', 912.0000, 'ºC'),
	(350002, 146, '2015-02-01 00:46:28.000000', 'temperatura', 907.0000, 'ºC'),
	(350003, 146, '2015-02-01 00:46:29.000000', 'temperatura', 601.0000, 'ºC'),
	(350004, 146, '2015-02-01 00:46:30.000000', 'temperatura', 282.0000, 'ºC'),
	(350005, 146, '2015-02-01 00:46:31.000000', 'temperatura', 807.0000, 'ºC'),
	(350006, 146, '2015-02-01 00:46:32.000000', 'temperatura', 790.0000, 'ºC'),
	(350007, 146, '2015-02-01 00:46:33.000000', 'temperatura', 331.0000, 'ºC'),
	(350008, 146, '2015-02-01 00:46:34.000000', 'temperatura', 487.0000, 'ºC'),
	(350009, 146, '2015-02-01 00:46:35.000000', 'temperatura', 240.0000, 'ºC'),
	(350010, 146, '2015-02-01 00:46:36.000000', 'temperatura', 939.0000, 'ºC'),
	(350011, 146, '2015-02-01 00:46:37.000000', 'temperatura', 375.0000, 'ºC'),
	(350012, 146, '2015-02-01 00:46:38.000000', 'temperatura', 260.0000, 'ºC'),
	(350013, 146, '2015-02-01 00:46:39.000000', 'temperatura', 174.0000, 'ºC'),
	(350014, 146, '2015-02-01 00:46:40.000000', 'temperatura', 90.0000, 'ºC'),
	(350015, 146, '2015-02-01 00:46:41.000000', 'temperatura', 1127.0000, 'ºC'),
	(350016, 146, '2015-02-01 00:46:42.000000', 'temperatura', 569.0000, 'ºC'),
	(350017, 146, '2015-02-01 00:46:43.000000', 'temperatura', 663.0000, 'ºC'),
	(350018, 146, '2015-02-01 00:46:44.000000', 'temperatura', 409.0000, 'ºC'),
	(350019, 146, '2015-02-01 00:46:45.000000', 'temperatura', 56.0000, 'ºC'),
	(350020, 146, '2015-02-01 00:46:46.000000', 'temperatura', 252.0000, 'ºC'),
	(350021, 146, '2015-02-01 00:46:47.000000', 'temperatura', 1095.0000, 'ºC'),
	(350022, 146, '2015-02-01 00:46:48.000000', 'temperatura', 1120.0000, 'ºC'),
	(350023, 146, '2015-02-01 00:46:49.000000', 'temperatura', 1115.0000, 'ºC'),
	(350024, 146, '2015-02-01 00:46:50.000000', 'temperatura', 1017.0000, 'ºC'),
	(350025, 146, '2015-02-01 00:46:51.000000', 'temperatura', 539.0000, 'ºC'),
	(350026, 146, '2015-02-01 00:46:52.000000', 'temperatura', 846.0000, 'ºC'),
	(350027, 146, '2015-02-01 00:46:53.000000', 'temperatura', 212.0000, 'ºC'),
	(350028, 146, '2015-02-01 00:46:54.000000', 'temperatura', 924.0000, 'ºC'),
	(350029, 146, '2015-02-01 00:46:55.000000', 'temperatura', 385.0000, 'ºC'),
	(350030, 146, '2015-02-01 00:46:56.000000', 'temperatura', 351.0000, 'ºC'),
	(350031, 146, '2015-02-01 00:46:57.000000', 'temperatura', 602.0000, 'ºC'),
	(350032, 146, '2015-02-01 00:46:58.000000', 'temperatura', 759.0000, 'ºC'),
	(350033, 146, '2015-02-01 00:46:59.000000', 'temperatura', 786.0000, 'ºC'),
	(350034, 146, '2015-02-01 00:47:00.000000', 'temperatura', 456.0000, 'ºC'),
	(350035, 146, '2015-02-01 00:47:01.000000', 'temperatura', 1123.0000, 'ºC'),
	(350036, 146, '2015-02-01 00:47:02.000000', 'temperatura', 646.0000, 'ºC'),
	(350037, 146, '2015-02-01 00:47:03.000000', 'temperatura', 1063.0000, 'ºC'),
	(350038, 146, '2015-02-01 00:47:04.000000', 'temperatura', 979.0000, 'ºC'),
	(350039, 146, '2015-02-01 00:47:05.000000', 'temperatura', 503.0000, 'ºC'),
	(350040, 146, '2015-02-01 00:47:06.000000', 'temperatura', 780.0000, 'ºC'),
	(350041, 146, '2015-02-01 00:47:07.000000', 'temperatura', 1190.0000, 'ºC'),
	(350042, 146, '2015-02-01 00:47:08.000000', 'temperatura', 11.0000, 'ºC'),
	(350043, 146, '2015-02-01 00:47:09.000000', 'temperatura', 84.0000, 'ºC'),
	(350044, 146, '2015-02-01 00:47:10.000000', 'temperatura', 388.0000, 'ºC'),
	(350045, 146, '2015-02-01 00:47:11.000000', 'temperatura', 489.0000, 'ºC'),
	(350046, 146, '2015-02-01 00:47:12.000000', 'temperatura', 80.0000, 'ºC'),
	(350047, 146, '2015-02-01 00:47:13.000000', 'temperatura', 135.0000, 'ºC'),
	(350048, 146, '2015-02-01 00:47:14.000000', 'temperatura', 436.0000, 'ºC'),
	(350049, 146, '2015-02-01 00:47:15.000000', 'temperatura', 575.0000, 'ºC'),
	(350050, 146, '2015-02-01 00:47:16.000000', 'temperatura', 368.0000, 'ºC'),
	(350051, 146, '2015-02-01 00:47:17.000000', 'temperatura', 116.0000, 'ºC'),
	(350052, 146, '2015-02-01 00:47:18.000000', 'temperatura', 678.0000, 'ºC'),
	(350053, 146, '2015-02-01 00:47:19.000000', 'temperatura', 639.0000, 'ºC'),
	(350054, 146, '2015-02-01 00:47:20.000000', 'temperatura', 1163.0000, 'ºC'),
	(350055, 146, '2015-02-01 00:47:21.000000', 'temperatura', 296.0000, 'ºC'),
	(350056, 146, '2015-02-01 00:47:22.000000', 'temperatura', 395.0000, 'ºC'),
	(350057, 146, '2015-02-01 00:47:23.000000', 'temperatura', 1087.0000, 'ºC'),
	(350058, 146, '2015-02-01 00:47:24.000000', 'temperatura', 649.0000, 'ºC'),
	(350059, 146, '2015-02-01 00:47:25.000000', 'temperatura', 1183.0000, 'ºC'),
	(350060, 146, '2015-02-01 00:47:26.000000', 'temperatura', 372.0000, 'ºC'),
	(350061, 146, '2015-02-01 00:47:27.000000', 'temperatura', 710.0000, 'ºC'),
	(350062, 146, '2015-02-01 00:47:28.000000', 'temperatura', 35.0000, 'ºC'),
	(350063, 146, '2015-02-01 00:47:29.000000', 'temperatura', 443.0000, 'ºC'),
	(350064, 146, '2015-02-01 00:47:30.000000', 'temperatura', 913.0000, 'ºC'),
	(350065, 146, '2015-02-01 00:47:31.000000', 'temperatura', 834.0000, 'ºC'),
	(350066, 146, '2015-02-01 00:47:32.000000', 'temperatura', 235.0000, 'ºC'),
	(350067, 146, '2015-02-01 00:47:33.000000', 'temperatura', 1070.0000, 'ºC'),
	(350068, 146, '2015-02-01 00:47:34.000000', 'temperatura', 1049.0000, 'ºC'),
	(350069, 146, '2015-02-01 00:47:35.000000', 'temperatura', 832.0000, 'ºC'),
	(350070, 146, '2015-02-01 00:47:36.000000', 'temperatura', 1016.0000, 'ºC'),
	(350071, 146, '2015-02-01 00:47:37.000000', 'temperatura', 185.0000, 'ºC'),
	(350072, 146, '2015-02-01 00:47:38.000000', 'temperatura', 278.0000, 'ºC'),
	(350073, 146, '2015-02-01 00:47:39.000000', 'temperatura', 836.0000, 'ºC'),
	(350074, 146, '2015-02-01 00:47:40.000000', 'temperatura', 946.0000, 'ºC'),
	(350075, 146, '2015-02-01 00:47:41.000000', 'temperatura', 1020.0000, 'ºC'),
	(350076, 146, '2015-02-01 00:47:42.000000', 'temperatura', 1065.0000, 'ºC'),
	(350077, 146, '2015-02-01 00:47:43.000000', 'temperatura', 1064.0000, 'ºC'),
	(350078, 146, '2015-02-01 00:47:44.000000', 'temperatura', 926.0000, 'ºC'),
	(350079, 146, '2015-02-01 00:47:45.000000', 'temperatura', 240.0000, 'ºC'),
	(350080, 146, '2015-02-01 00:47:46.000000', 'temperatura', 821.0000, 'ºC'),
	(350081, 146, '2015-02-01 00:47:47.000000', 'temperatura', 984.0000, 'ºC'),
	(350082, 146, '2015-02-01 00:47:48.000000', 'temperatura', 60.0000, 'ºC'),
	(350083, 146, '2015-02-01 00:47:49.000000', 'temperatura', 947.0000, 'ºC'),
	(350084, 146, '2015-02-01 00:47:50.000000', 'temperatura', 958.0000, 'ºC'),
	(350085, 146, '2015-02-01 00:47:51.000000', 'temperatura', 746.0000, 'ºC'),
	(350086, 146, '2015-02-01 00:47:52.000000', 'temperatura', 858.0000, 'ºC'),
	(350087, 146, '2015-02-01 00:47:53.000000', 'temperatura', 851.0000, 'ºC'),
	(350088, 146, '2015-02-01 00:47:54.000000', 'temperatura', 482.0000, 'ºC'),
	(350089, 146, '2015-02-01 00:47:55.000000', 'temperatura', 1058.0000, 'ºC'),
	(350090, 146, '2015-02-01 00:47:56.000000', 'temperatura', 244.0000, 'ºC'),
	(350091, 146, '2015-02-01 00:47:57.000000', 'temperatura', 445.0000, 'ºC'),
	(350092, 146, '2015-02-01 00:47:58.000000', 'temperatura', 295.0000, 'ºC'),
	(350093, 146, '2015-02-01 00:47:59.000000', 'temperatura', 141.0000, 'ºC'),
	(350094, 146, '2015-02-01 00:48:00.000000', 'temperatura', 1019.0000, 'ºC'),
	(350095, 146, '2015-02-01 00:48:01.000000', 'temperatura', 1075.0000, 'ºC'),
	(350096, 146, '2015-02-01 00:48:02.000000', 'temperatura', 1115.0000, 'ºC'),
	(350097, 146, '2015-02-01 00:48:03.000000', 'temperatura', 1154.0000, 'ºC'),
	(350098, 146, '2015-02-01 00:48:04.000000', 'temperatura', 22.0000, 'ºC'),
	(350099, 146, '2015-02-01 00:48:05.000000', 'temperatura', 251.0000, 'ºC'),
	(350100, 146, '2015-02-01 00:48:06.000000', 'temperatura', 1189.0000, 'ºC'),
	(350101, 146, '2015-02-01 00:48:07.000000', 'temperatura', 393.0000, 'ºC'),
	(350102, 146, '2015-02-01 00:48:08.000000', 'temperatura', 800.0000, 'ºC'),
	(350103, 146, '2015-02-01 00:48:09.000000', 'temperatura', 421.0000, 'ºC'),
	(350104, 146, '2015-02-01 00:48:10.000000', 'temperatura', 904.0000, 'ºC'),
	(350105, 146, '2015-02-01 00:48:11.000000', 'temperatura', 857.0000, 'ºC'),
	(350106, 146, '2015-02-01 00:48:12.000000', 'temperatura', 375.0000, 'ºC'),
	(350107, 146, '2015-02-01 00:48:13.000000', 'temperatura', 506.0000, 'ºC'),
	(350108, 146, '2015-02-01 00:48:14.000000', 'temperatura', 203.0000, 'ºC'),
	(350109, 146, '2015-02-01 00:48:15.000000', 'temperatura', 699.0000, 'ºC'),
	(350110, 146, '2015-02-01 00:48:16.000000', 'temperatura', 487.0000, 'ºC'),
	(350111, 146, '2015-02-01 00:48:17.000000', 'temperatura', 338.0000, 'ºC'),
	(350112, 146, '2015-02-01 00:48:18.000000', 'temperatura', 231.0000, 'ºC'),
	(350113, 146, '2015-02-01 00:48:19.000000', 'temperatura', 139.0000, 'ºC'),
	(350114, 146, '2015-02-01 00:48:20.000000', 'temperatura', 4.0000, 'ºC'),
	(350115, 146, '2015-02-01 00:48:21.000000', 'temperatura', 805.0000, 'ºC'),
	(350116, 146, '2015-02-01 00:48:22.000000', 'temperatura', 413.0000, 'ºC'),
	(350117, 146, '2015-02-01 00:48:23.000000', 'temperatura', 849.0000, 'ºC'),
	(350118, 146, '2015-02-01 00:48:24.000000', 'temperatura', 608.0000, 'ºC'),
	(350119, 146, '2015-02-01 00:48:25.000000', 'temperatura', 491.0000, 'ºC'),
	(350120, 146, '2015-02-01 00:48:26.000000', 'temperatura', 634.0000, 'ºC'),
	(350121, 146, '2015-02-01 00:48:27.000000', 'temperatura', 496.0000, 'ºC'),
	(350122, 146, '2015-02-01 00:48:28.000000', 'temperatura', 581.0000, 'ºC'),
	(350123, 146, '2015-02-01 00:48:29.000000', 'temperatura', 215.0000, 'ºC'),
	(350124, 146, '2015-02-01 00:48:30.000000', 'temperatura', 535.0000, 'ºC'),
	(350125, 146, '2015-02-01 00:48:31.000000', 'temperatura', 831.0000, 'ºC'),
	(350126, 146, '2015-02-01 00:48:32.000000', 'temperatura', 147.0000, 'ºC'),
	(350127, 146, '2015-02-01 00:48:33.000000', 'temperatura', 646.0000, 'ºC'),
	(350128, 146, '2015-02-01 00:48:34.000000', 'temperatura', 387.0000, 'ºC'),
	(350129, 146, '2015-02-01 00:48:35.000000', 'temperatura', 0.0000, 'ºC'),
	(350130, 146, '2015-02-01 00:48:36.000000', 'temperatura', 36.0000, 'ºC'),
	(350131, 146, '2015-02-01 00:48:37.000000', 'temperatura', 183.0000, 'ºC'),
	(350132, 146, '2015-02-01 00:48:38.000000', 'temperatura', 809.0000, 'ºC'),
	(350133, 146, '2015-02-01 00:48:39.000000', 'temperatura', 1094.0000, 'ºC'),
	(350134, 146, '2015-02-01 00:48:40.000000', 'temperatura', 643.0000, 'ºC'),
	(350135, 146, '2015-02-01 00:48:41.000000', 'temperatura', 1136.0000, 'ºC'),
	(350136, 146, '2015-02-01 00:48:42.000000', 'temperatura', 152.0000, 'ºC'),
	(350137, 146, '2015-02-01 00:48:43.000000', 'temperatura', 951.0000, 'ºC'),
	(350138, 146, '2015-02-01 00:48:44.000000', 'temperatura', 698.0000, 'ºC'),
	(350139, 146, '2015-02-01 00:48:45.000000', 'temperatura', 639.0000, 'ºC'),
	(350140, 146, '2015-02-01 00:48:46.000000', 'temperatura', 1102.0000, 'ºC'),
	(350141, 146, '2015-02-01 00:48:47.000000', 'temperatura', 1194.0000, 'ºC'),
	(350142, 146, '2015-02-01 00:48:48.000000', 'temperatura', 262.0000, 'ºC'),
	(350143, 146, '2015-02-01 00:48:49.000000', 'temperatura', 129.0000, 'ºC'),
	(350144, 146, '2015-02-01 00:48:50.000000', 'temperatura', 1058.0000, 'ºC'),
	(350145, 146, '2015-02-01 00:48:51.000000', 'temperatura', 106.0000, 'ºC'),
	(350146, 146, '2015-02-01 00:48:52.000000', 'temperatura', 954.0000, 'ºC'),
	(350147, 146, '2015-02-01 00:48:53.000000', 'temperatura', 855.0000, 'ºC'),
	(350148, 146, '2015-02-01 00:48:54.000000', 'temperatura', 214.0000, 'ºC'),
	(350149, 146, '2015-02-01 00:48:55.000000', 'temperatura', 904.0000, 'ºC'),
	(350150, 146, '2015-02-01 00:48:56.000000', 'temperatura', 278.0000, 'ºC'),
	(350151, 146, '2015-02-01 00:48:57.000000', 'temperatura', 1077.0000, 'ºC'),
	(350152, 146, '2015-02-01 00:48:58.000000', 'temperatura', 953.0000, 'ºC'),
	(350153, 146, '2015-02-01 00:48:59.000000', 'temperatura', 336.0000, 'ºC'),
	(350154, 146, '2015-02-01 00:49:00.000000', 'temperatura', 20.0000, 'ºC'),
	(350155, 146, '2015-02-01 00:49:01.000000', 'temperatura', 291.0000, 'ºC'),
	(350156, 146, '2015-02-01 00:49:02.000000', 'temperatura', 198.0000, 'ºC'),
	(350157, 146, '2015-02-01 00:49:03.000000', 'temperatura', 118.0000, 'ºC'),
	(350158, 146, '2015-02-01 00:49:04.000000', 'temperatura', 1193.0000, 'ºC'),
	(350159, 146, '2015-02-01 00:49:05.000000', 'temperatura', 815.0000, 'ºC'),
	(350160, 146, '2015-02-01 00:49:06.000000', 'temperatura', 496.0000, 'ºC'),
	(350161, 146, '2015-02-01 00:49:07.000000', 'temperatura', 34.0000, 'ºC'),
	(350162, 146, '2015-02-01 00:49:08.000000', 'temperatura', 1082.0000, 'ºC'),
	(350163, 146, '2015-02-01 00:49:09.000000', 'temperatura', 508.0000, 'ºC'),
	(350164, 146, '2015-02-01 00:49:10.000000', 'temperatura', 494.0000, 'ºC'),
	(350165, 146, '2015-02-01 00:49:11.000000', 'temperatura', 946.0000, 'ºC'),
	(350166, 146, '2015-02-01 00:49:12.000000', 'temperatura', 848.0000, 'ºC'),
	(350167, 146, '2015-02-01 00:49:13.000000', 'temperatura', 203.0000, 'ºC'),
	(350168, 146, '2015-02-01 00:49:14.000000', 'temperatura', 873.0000, 'ºC'),
	(350169, 146, '2015-02-01 00:49:15.000000', 'temperatura', 155.0000, 'ºC'),
	(350170, 146, '2015-02-01 00:49:16.000000', 'temperatura', 559.0000, 'ºC'),
	(350171, 146, '2015-02-01 00:49:17.000000', 'temperatura', 1127.0000, 'ºC'),
	(350172, 146, '2015-02-01 00:49:18.000000', 'temperatura', 360.0000, 'ºC'),
	(350173, 146, '2015-02-01 00:49:19.000000', 'temperatura', 819.0000, 'ºC'),
	(350174, 146, '2015-02-01 00:49:20.000000', 'temperatura', 615.0000, 'ºC'),
	(350175, 146, '2015-02-01 00:49:21.000000', 'temperatura', 618.0000, 'ºC'),
	(350176, 146, '2015-02-01 00:49:22.000000', 'temperatura', 44.0000, 'ºC'),
	(350177, 146, '2015-02-01 00:49:23.000000', 'temperatura', 770.0000, 'ºC'),
	(350178, 146, '2015-02-01 00:49:24.000000', 'temperatura', 117.0000, 'ºC'),
	(350179, 146, '2015-02-01 00:49:25.000000', 'temperatura', 675.0000, 'ºC'),
	(350180, 146, '2015-02-01 00:49:26.000000', 'temperatura', 624.0000, 'ºC'),
	(350181, 146, '2015-02-01 00:49:27.000000', 'temperatura', 1096.0000, 'ºC'),
	(350182, 146, '2015-02-01 00:49:28.000000', 'temperatura', 8.0000, 'ºC'),
	(350183, 146, '2015-02-01 00:49:29.000000', 'temperatura', 352.0000, 'ºC'),
	(350184, 146, '2015-02-01 00:49:30.000000', 'temperatura', 539.0000, 'ºC'),
	(350185, 146, '2015-02-01 00:49:31.000000', 'temperatura', 439.0000, 'ºC'),
	(350186, 146, '2015-02-01 00:49:32.000000', 'temperatura', 577.0000, 'ºC'),
	(350187, 146, '2015-02-01 00:49:33.000000', 'temperatura', 369.0000, 'ºC'),
	(350188, 146, '2015-02-01 00:49:34.000000', 'temperatura', 114.0000, 'ºC'),
	(350189, 146, '2015-02-01 00:49:35.000000', 'temperatura', 665.0000, 'ºC'),
	(350190, 146, '2015-02-01 00:49:36.000000', 'temperatura', 582.0000, 'ºC'),
	(350191, 146, '2015-02-01 00:49:37.000000', 'temperatura', 916.0000, 'ºC'),
	(350192, 146, '2015-02-01 00:49:38.000000', 'temperatura', 433.0000, 'ºC'),
	(350193, 146, '2015-02-01 00:49:39.000000', 'temperatura', 617.0000, 'ºC'),
	(350194, 146, '2015-02-01 00:49:40.000000', 'temperatura', 589.0000, 'ºC'),
	(350195, 146, '2015-02-01 00:49:41.000000', 'temperatura', 1096.0000, 'ºC'),
	(350196, 146, '2015-02-01 00:49:42.000000', 'temperatura', 110.0000, 'ºC'),
	(350197, 146, '2015-02-01 00:49:43.000000', 'temperatura', 864.0000, 'ºC'),
	(350198, 146, '2015-02-01 00:49:44.000000', 'temperatura', 389.0000, 'ºC'),
	(350199, 146, '2015-02-01 00:49:45.000000', 'temperatura', 553.0000, 'ºC'),
	(350200, 146, '2015-02-01 00:49:46.000000', 'temperatura', 398.0000, 'ºC'),
	(350201, 146, '2015-02-01 00:49:47.000000', 'temperatura', 332.0000, 'ºC'),
	(350202, 146, '2015-02-01 00:49:48.000000', 'temperatura', 469.0000, 'ºC'),
	(350203, 146, '2015-02-01 00:49:49.000000', 'temperatura', 147.0000, 'ºC'),
	(350204, 146, '2015-02-01 00:49:50.000000', 'temperatura', 530.0000, 'ºC'),
	(350205, 146, '2015-02-01 00:49:51.000000', 'temperatura', 1010.0000, 'ºC'),
	(350206, 146, '2015-02-01 00:49:52.000000', 'temperatura', 1058.0000, 'ºC'),
	(350207, 146, '2015-02-01 00:49:53.000000', 'temperatura', 1062.0000, 'ºC'),
	(350208, 146, '2015-02-01 00:49:54.000000', 'temperatura', 935.0000, 'ºC'),
	(350209, 146, '2015-02-01 00:49:55.000000', 'temperatura', 291.0000, 'ºC'),
	(350210, 146, '2015-02-01 00:49:56.000000', 'temperatura', 1049.0000, 'ºC'),
	(350211, 146, '2015-02-01 00:49:57.000000', 'temperatura', 772.0000, 'ºC'),
	(350212, 146, '2015-02-01 00:49:58.000000', 'temperatura', 715.0000, 'ºC'),
	(350213, 146, '2015-02-01 00:49:59.000000', 'temperatura', 61.0000, 'ºC'),
	(350214, 146, '2015-02-01 00:50:00.000000', 'temperatura', 558.0000, 'ºC'),
	(350215, 146, '2015-02-01 00:50:01.000000', 'temperatura', 210.0000, 'ºC'),
	(350216, 146, '2015-02-01 00:50:02.000000', 'temperatura', 576.0000, 'ºC'),
	(350217, 146, '2015-02-01 00:50:03.000000', 'temperatura', 1052.0000, 'ºC'),
	(350218, 146, '2015-02-01 00:50:04.000000', 'temperatura', 1131.0000, 'ºC'),
	(350219, 146, '2015-02-01 00:50:05.000000', 'temperatura', 97.0000, 'ºC'),
	(350220, 146, '2015-02-01 00:50:06.000000', 'temperatura', 696.0000, 'ºC'),
	(350221, 146, '2015-02-01 00:50:07.000000', 'temperatura', 789.0000, 'ºC'),
	(350222, 146, '2015-02-01 00:50:08.000000', 'temperatura', 659.0000, 'ºC'),
	(350223, 146, '2015-02-01 00:50:09.000000', 'temperatura', 926.0000, 'ºC'),
	(350224, 146, '2015-02-01 00:50:10.000000', 'temperatura', 255.0000, 'ºC'),
	(350225, 146, '2015-02-01 00:50:11.000000', 'temperatura', 896.0000, 'ºC'),
	(350226, 146, '2015-02-01 00:50:12.000000', 'temperatura', 115.0000, 'ºC'),
	(350227, 146, '2015-02-01 00:50:13.000000', 'temperatura', 287.0000, 'ºC'),
	(350228, 146, '2015-02-01 00:50:14.000000', 'temperatura', 1090.0000, 'ºC'),
	(350229, 146, '2015-02-01 00:50:15.000000', 'temperatura', 990.0000, 'ºC'),
	(350230, 146, '2015-02-01 00:50:16.000000', 'temperatura', 483.0000, 'ºC'),
	(350231, 146, '2015-02-01 00:50:17.000000', 'temperatura', 643.0000, 'ºC'),
	(350232, 146, '2015-02-01 00:50:18.000000', 'temperatura', 567.0000, 'ºC'),
	(350233, 146, '2015-02-01 00:50:19.000000', 'temperatura', 905.0000, 'ºC'),
	(350234, 146, '2015-02-01 00:50:20.000000', 'temperatura', 427.0000, 'ºC'),
	(350235, 146, '2015-02-01 00:50:21.000000', 'temperatura', 618.0000, 'ºC'),
	(350236, 146, '2015-02-01 00:50:22.000000', 'temperatura', 610.0000, 'ºC'),
	(350237, 146, '2015-02-01 00:50:23.000000', 'temperatura', 1197.0000, 'ºC'),
	(350238, 146, '2015-02-01 00:50:24.000000', 'temperatura', 555.0000, 'ºC'),
	(350239, 146, '2015-02-01 00:50:25.000000', 'temperatura', 386.0000, 'ºC'),
	(350240, 146, '2015-02-01 00:50:26.000000', 'temperatura', 264.0000, 'ºC'),
	(350241, 146, '2015-02-01 00:50:27.000000', 'temperatura', 162.0000, 'ºC'),
	(350242, 146, '2015-02-01 00:50:28.000000', 'temperatura', 18.0000, 'ºC'),
	(350243, 146, '2015-02-01 00:50:29.000000', 'temperatura', 804.0000, 'ºC'),
	(350244, 146, '2015-02-01 00:50:30.000000', 'temperatura', 368.0000, 'ºC'),
	(350245, 146, '2015-02-01 00:50:31.000000', 'temperatura', 628.0000, 'ºC'),
	(350246, 146, '2015-02-01 00:50:32.000000', 'temperatura', 836.0000, 'ºC'),
	(350247, 146, '2015-02-01 00:50:33.000000', 'temperatura', 1097.0000, 'ºC'),
	(350248, 146, '2015-02-01 00:50:34.000000', 'temperatura', 577.0000, 'ºC'),
	(350249, 146, '2015-02-01 00:50:35.000000', 'temperatura', 794.0000, 'ºC'),
	(350250, 146, '2015-02-01 00:50:36.000000', 'temperatura', 1040.0000, 'ºC'),
	(350251, 146, '2015-02-01 00:50:37.000000', 'temperatura', 417.0000, 'ºC'),
	(350252, 146, '2015-02-01 00:50:38.000000', 'temperatura', 165.0000, 'ºC'),
	(350253, 146, '2015-02-01 00:50:39.000000', 'temperatura', 774.0000, 'ºC'),
	(350254, 146, '2015-02-01 00:50:40.000000', 'temperatura', 976.0000, 'ºC'),
	(350255, 146, '2015-02-01 00:50:41.000000', 'temperatura', 160.0000, 'ºC'),
	(350256, 146, '2015-02-01 00:50:42.000000', 'temperatura', 272.0000, 'ºC'),
	(350257, 146, '2015-02-01 00:50:43.000000', 'temperatura', 882.0000, 'ºC'),
	(350258, 146, '2015-02-01 00:50:44.000000', 'temperatura', 1195.0000, 'ºC'),
	(350259, 146, '2015-02-01 00:50:45.000000', 'temperatura', 929.0000, 'ºC'),
	(350260, 146, '2015-02-01 00:50:46.000000', 'temperatura', 1061.0000, 'ºC'),
	(350261, 146, '2015-02-01 00:50:47.000000', 'temperatura', 119.0000, 'ºC'),
	(350262, 146, '2015-02-01 00:50:48.000000', 'temperatura', 1013.0000, 'ºC'),
	(350263, 146, '2015-02-01 00:50:49.000000', 'temperatura', 1108.0000, 'ºC'),
	(350264, 146, '2015-02-01 00:50:50.000000', 'temperatura', 102.0000, 'ºC'),
	(350265, 146, '2015-02-01 00:50:51.000000', 'temperatura', 785.0000, 'ºC'),
	(350266, 146, '2015-02-01 00:50:52.000000', 'temperatura', 18.0000, 'ºC'),
	(350267, 146, '2015-02-01 00:50:53.000000', 'temperatura', 139.0000, 'ºC'),
	(350268, 146, '2015-02-01 00:50:54.000000', 'temperatura', 639.0000, 'ºC'),
	(350269, 146, '2015-02-01 00:50:55.000000', 'temperatura', 381.0000, 'ºC'),
	(350270, 146, '2015-02-01 00:50:56.000000', 'temperatura', 1186.0000, 'ºC'),
	(350271, 146, '2015-02-01 00:50:57.000000', 'temperatura', 1189.0000, 'ºC'),
	(350272, 146, '2015-02-01 00:50:58.000000', 'temperatura', 1185.0000, 'ºC'),
	(350273, 146, '2015-02-01 00:50:59.000000', 'temperatura', 1160.0000, 'ºC'),
	(350274, 146, '2015-02-01 00:51:00.000000', 'temperatura', 1045.0000, 'ºC'),
	(350275, 146, '2015-02-01 00:51:01.000000', 'temperatura', 546.0000, 'ºC'),
	(350276, 146, '2015-02-01 00:51:02.000000', 'temperatura', 796.0000, 'ºC'),
	(350277, 146, '2015-02-01 00:51:03.000000', 'temperatura', 1141.0000, 'ºC'),
	(350278, 146, '2015-02-01 00:51:04.000000', 'temperatura', 918.0000, 'ºC'),
	(350279, 146, '2015-02-01 00:51:05.000000', 'temperatura', 1167.0000, 'ºC'),
	(350280, 146, '2015-02-01 00:51:06.000000', 'temperatura', 682.0000, 'ºC'),
	(350281, 146, '2015-02-01 00:51:07.000000', 'temperatura', 1111.0000, 'ºC'),
	(350282, 146, '2015-02-01 00:51:08.000000', 'temperatura', 1111.0000, 'ºC'),
	(350283, 146, '2015-02-01 00:51:09.000000', 'temperatura', 1019.0000, 'ºC'),
	(350284, 146, '2015-02-01 00:51:10.000000', 'temperatura', 563.0000, 'ºC'),
	(350285, 146, '2015-02-01 00:51:11.000000', 'temperatura', 960.0000, 'ºC'),
	(350286, 146, '2015-02-01 00:51:12.000000', 'temperatura', 709.0000, 'ºC'),
	(350287, 146, '2015-02-01 00:51:13.000000', 'temperatura', 666.0000, 'ºC'),
	(350288, 146, '2015-02-01 00:51:14.000000', 'temperatura', 3.0000, 'ºC'),
	(350289, 146, '2015-02-01 00:51:15.000000', 'temperatura', 420.0000, 'ºC'),
	(350290, 146, '2015-02-01 00:51:16.000000', 'temperatura', 891.0000, 'ºC'),
	(350291, 146, '2015-02-01 00:51:17.000000', 'temperatura', 796.0000, 'ºC'),
	(350292, 146, '2015-02-01 00:51:18.000000', 'temperatura', 106.0000, 'ºC'),
	(350293, 146, '2015-02-01 00:51:19.000000', 'temperatura', 542.0000, 'ºC'),
	(350294, 146, '2015-02-01 00:51:20.000000', 'temperatura', 1193.0000, 'ºC'),
	(350295, 146, '2015-02-01 00:51:21.000000', 'temperatura', 740.0000, 'ºC'),
	(350296, 146, '2015-02-01 00:51:22.000000', 'temperatura', 120.0000, 'ºC'),
	(350297, 146, '2015-02-01 00:51:23.000000', 'temperatura', 782.0000, 'ºC'),
	(350298, 146, '2015-02-01 00:51:24.000000', 'temperatura', 1149.0000, 'ºC'),
	(350299, 146, '2015-02-01 00:51:25.000000', 'temperatura', 999.0000, 'ºC'),
	(350300, 146, '2015-02-01 00:51:26.000000', 'temperatura', 349.0000, 'ºC'),
	(350301, 146, '2015-02-01 00:51:27.000000', 'temperatura', 1147.0000, 'ºC'),
	(350302, 146, '2015-02-01 00:51:28.000000', 'temperatura', 1089.0000, 'ºC'),
	(350303, 146, '2015-02-01 00:51:29.000000', 'temperatura', 803.0000, 'ºC'),
	(350304, 146, '2015-02-01 00:51:30.000000', 'temperatura', 752.0000, 'ºC'),
	(350305, 146, '2015-02-01 00:51:31.000000', 'temperatura', 149.0000, 'ºC'),
	(350306, 146, '2015-02-01 00:51:32.000000', 'temperatura', 891.0000, 'ºC'),
	(350307, 146, '2015-02-01 00:51:33.000000', 'temperatura', 408.0000, 'ºC'),
	(350308, 146, '2015-02-01 00:51:34.000000', 'temperatura', 567.0000, 'ºC'),
	(350309, 146, '2015-02-01 00:51:35.000000', 'temperatura', 413.0000, 'ºC'),
	(350310, 146, '2015-02-01 00:51:36.000000', 'temperatura', 364.0000, 'ºC'),
	(350311, 146, '2015-02-01 00:51:37.000000', 'temperatura', 583.0000, 'ºC'),
	(350312, 146, '2015-02-01 00:51:38.000000', 'temperatura', 623.0000, 'ºC'),
	(350313, 146, '2015-02-01 00:51:39.000000', 'temperatura', 166.0000, 'ºC'),
	(350314, 146, '2015-02-01 00:51:40.000000', 'temperatura', 160.0000, 'ºC'),
	(350315, 146, '2015-02-01 00:51:41.000000', 'temperatura', 303.0000, 'ºC'),
	(350316, 146, '2015-02-01 00:51:42.000000', 'temperatura', 1038.0000, 'ºC'),
	(350317, 146, '2015-02-01 00:51:43.000000', 'temperatura', 679.0000, 'ºC'),
	(350318, 146, '2015-02-01 00:51:44.000000', 'temperatura', 284.0000, 'ºC'),
	(350319, 146, '2015-02-01 00:51:45.000000', 'temperatura', 582.0000, 'ºC'),
	(350320, 146, '2015-02-01 00:51:46.000000', 'temperatura', 857.0000, 'ºC'),
	(350321, 146, '2015-02-01 00:51:47.000000', 'temperatura', 140.0000, 'ºC'),
	(350322, 146, '2015-02-01 00:51:48.000000', 'temperatura', 529.0000, 'ºC'),
	(350323, 146, '2015-02-01 00:51:49.000000', 'temperatura', 1027.0000, 'ºC'),
	(350324, 146, '2015-02-01 00:51:50.000000', 'temperatura', 1148.0000, 'ºC'),
	(350325, 146, '2015-02-01 00:51:51.000000', 'temperatura', 260.0000, 'ºC'),
	(350326, 146, '2015-02-01 00:51:52.000000', 'temperatura', 255.0000, 'ºC'),
	(350327, 146, '2015-02-01 00:51:53.000000', 'temperatura', 495.0000, 'ºC'),
	(350328, 146, '2015-02-01 00:51:54.000000', 'temperatura', 512.0000, 'ºC'),
	(350329, 146, '2015-02-01 00:51:55.000000', 'temperatura', 1074.0000, 'ºC'),
	(350330, 146, '2015-02-01 00:51:56.000000', 'temperatura', 235.0000, 'ºC'),
	(350331, 146, '2015-02-01 00:51:57.000000', 'temperatura', 355.0000, 'ºC'),
	(350332, 146, '2015-02-01 00:51:58.000000', 'temperatura', 1071.0000, 'ºC'),
	(350333, 146, '2015-02-01 00:51:59.000000', 'temperatura', 691.0000, 'ºC'),
	(350334, 146, '2015-02-01 00:52:00.000000', 'temperatura', 243.0000, 'ºC'),
	(350335, 146, '2015-02-01 00:52:01.000000', 'temperatura', 343.0000, 'ºC'),
	(350336, 146, '2015-02-01 00:52:02.000000', 'temperatura', 984.0000, 'ºC'),
	(350337, 146, '2015-02-01 00:52:03.000000', 'temperatura', 291.0000, 'ºC'),
	(350338, 146, '2015-02-01 00:52:04.000000', 'temperatura', 906.0000, 'ºC'),
	(350339, 146, '2015-02-01 00:52:05.000000', 'temperatura', 55.0000, 'ºC'),
	(350340, 146, '2015-02-01 00:52:06.000000', 'temperatura', 1157.0000, 'ºC'),
	(350341, 146, '2015-02-01 00:52:07.000000', 'temperatura', 823.0000, 'ºC'),
	(350342, 146, '2015-02-01 00:52:08.000000', 'temperatura', 644.0000, 'ºC'),
	(350343, 146, '2015-02-01 00:52:09.000000', 'temperatura', 753.0000, 'ºC'),
	(350344, 146, '2015-02-01 00:52:10.000000', 'temperatura', 632.0000, 'ºC'),
	(350345, 146, '2015-02-01 00:52:11.000000', 'temperatura', 901.0000, 'ºC'),
	(350346, 146, '2015-02-01 00:52:12.000000', 'temperatura', 209.0000, 'ºC'),
	(350347, 146, '2015-02-01 00:52:13.000000', 'temperatura', 743.0000, 'ºC'),
	(350348, 146, '2015-02-01 00:52:14.000000', 'temperatura', 689.0000, 'ºC'),
	(350349, 146, '2015-02-01 00:52:15.000000', 'temperatura', 16.0000, 'ºC'),
	(350350, 146, '2015-02-01 00:52:16.000000', 'temperatura', 415.0000, 'ºC'),
	(350351, 146, '2015-02-01 00:52:17.000000', 'temperatura', 827.0000, 'ºC'),
	(350352, 146, '2015-02-01 00:52:18.000000', 'temperatura', 492.0000, 'ºC'),
	(350353, 146, '2015-02-01 00:52:19.000000', 'temperatura', 1179.0000, 'ºC'),
	(350354, 146, '2015-02-01 00:52:20.000000', 'temperatura', 819.0000, 'ºC'),
	(350355, 146, '2015-02-01 00:52:21.000000', 'temperatura', 557.0000, 'ºC'),
	(350356, 146, '2015-02-01 00:52:22.000000', 'temperatura', 328.0000, 'ºC'),
	(350357, 146, '2015-02-01 00:52:23.000000', 'temperatura', 1172.0000, 'ºC'),
	(350358, 146, '2015-02-01 00:52:24.000000', 'temperatura', 77.0000, 'ºC'),
	(350359, 146, '2015-02-01 00:52:25.000000', 'temperatura', 470.0000, 'ºC'),
	(350360, 146, '2015-02-01 00:52:26.000000', 'temperatura', 921.0000, 'ºC'),
	(350361, 146, '2015-02-01 00:52:27.000000', 'temperatura', 792.0000, 'ºC'),
	(350362, 146, '2015-02-01 00:52:28.000000', 'temperatura', 1197.0000, 'ºC'),
	(350363, 146, '2015-02-01 00:52:29.000000', 'temperatura', 12.0000, 'ºC'),
	(350364, 146, '2015-02-01 00:52:30.000000', 'temperatura', 70.0000, 'ºC'),
	(350365, 146, '2015-02-01 00:52:31.000000', 'temperatura', 315.0000, 'ºC'),
	(350366, 146, '2015-02-01 00:52:32.000000', 'temperatura', 165.0000, 'ºC'),
	(350367, 146, '2015-02-01 00:52:33.000000', 'temperatura', 1080.0000, 'ºC'),
	(350368, 146, '2015-02-01 00:52:34.000000', 'temperatura', 107.0000, 'ºC'),
	(350369, 146, '2015-02-01 00:52:35.000000', 'temperatura', 894.0000, 'ºC'),
	(350370, 146, '2015-02-01 00:52:36.000000', 'temperatura', 551.0000, 'ºC'),
	(350371, 146, '2015-02-01 00:52:37.000000', 'temperatura', 72.0000, 'ºC'),
	(350372, 146, '2015-02-01 00:52:38.000000', 'temperatura', 1108.0000, 'ºC'),
	(350373, 146, '2015-02-01 00:52:39.000000', 'temperatura', 526.0000, 'ºC'),
	(350374, 146, '2015-02-01 00:52:40.000000', 'temperatura', 504.0000, 'ºC'),
	(350375, 146, '2015-02-01 00:52:41.000000', 'temperatura', 944.0000, 'ºC'),
	(350376, 146, '2015-02-01 00:52:42.000000', 'temperatura', 808.0000, 'ºC'),
	(350377, 146, '2015-02-01 00:52:43.000000', 'temperatura', 7.0000, 'ºC'),
	(350378, 146, '2015-02-01 00:52:44.000000', 'temperatura', 14.0000, 'ºC'),
	(350379, 146, '2015-02-01 00:52:45.000000', 'temperatura', 49.0000, 'ºC'),
	(350380, 146, '2015-02-01 00:52:46.000000', 'temperatura', 204.0000, 'ºC'),
	(350381, 146, '2015-02-01 00:52:47.000000', 'temperatura', 872.0000, 'ºC'),
	(350382, 146, '2015-02-01 00:52:48.000000', 'temperatura', 148.0000, 'ºC'),
	(350383, 146, '2015-02-01 00:52:49.000000', 'temperatura', 525.0000, 'ºC'),
	(350384, 146, '2015-02-01 00:52:50.000000', 'temperatura', 981.0000, 'ºC'),
	(350385, 146, '2015-02-01 00:52:51.000000', 'temperatura', 931.0000, 'ºC'),
	(350386, 146, '2015-02-01 00:52:52.000000', 'temperatura', 514.0000, 'ºC'),
	(350387, 146, '2015-02-01 00:52:53.000000', 'temperatura', 976.0000, 'ºC'),
	(350388, 146, '2015-02-01 00:52:54.000000', 'temperatura', 937.0000, 'ºC'),
	(350389, 146, '2015-02-01 00:52:55.000000', 'temperatura', 558.0000, 'ºC'),
	(350390, 146, '2015-02-01 00:52:56.000000', 'temperatura', 1182.0000, 'ºC'),
	(350391, 146, '2015-02-01 00:52:57.000000', 'temperatura', 635.0000, 'ºC'),
	(350392, 146, '2015-02-01 00:52:58.000000', 'temperatura', 831.0000, 'ºC'),
	(350393, 146, '2015-02-01 00:52:59.000000', 'temperatura', 1050.0000, 'ºC'),
	(350394, 146, '2015-02-01 00:53:00.000000', 'temperatura', 358.0000, 'ºC'),
	(350395, 146, '2015-02-01 00:53:01.000000', 'temperatura', 1038.0000, 'ºC'),
	(350396, 146, '2015-02-01 00:53:02.000000', 'temperatura', 520.0000, 'ºC'),
	(350397, 146, '2015-02-01 00:53:03.000000', 'temperatura', 684.0000, 'ºC'),
	(350398, 146, '2015-02-01 00:53:04.000000', 'temperatura', 663.0000, 'ºC'),
	(350399, 146, '2015-02-01 00:53:05.000000', 'temperatura', 62.0000, 'ºC'),
	(350400, 146, '2015-02-01 00:53:06.000000', 'temperatura', 722.0000, 'ºC'),
	(350401, 146, '2015-02-01 00:53:07.000000', 'temperatura', 1024.0000, 'ºC'),
	(350402, 146, '2015-02-01 00:53:08.000000', 'temperatura', 554.0000, 'ºC'),
	(350403, 146, '2015-02-01 00:53:09.000000', 'temperatura', 900.0000, 'ºC'),
	(350404, 146, '2015-02-01 00:53:10.000000', 'temperatura', 439.0000, 'ºC'),
	(350405, 146, '2015-02-01 00:53:11.000000', 'temperatura', 695.0000, 'ºC'),
	(350406, 146, '2015-02-01 00:53:12.000000', 'temperatura', 958.0000, 'ºC'),
	(350407, 146, '2015-02-01 00:53:13.000000', 'temperatura', 304.0000, 'ºC'),
	(350408, 146, '2015-02-01 00:53:14.000000', 'temperatura', 1048.0000, 'ºC'),
	(350409, 146, '2015-02-01 00:53:15.000000', 'temperatura', 729.0000, 'ºC'),
	(350410, 146, '2015-02-01 00:53:16.000000', 'temperatura', 501.0000, 'ºC'),
	(350411, 146, '2015-02-01 00:53:17.000000', 'temperatura', 320.0000, 'ºC'),
	(350412, 146, '2015-02-01 00:53:18.000000', 'temperatura', 96.0000, 'ºC'),
	(350413, 146, '2015-02-01 00:53:19.000000', 'temperatura', 719.0000, 'ºC'),
	(350414, 146, '2015-02-01 00:53:20.000000', 'temperatura', 909.0000, 'ºC'),
	(350415, 146, '2015-02-01 00:53:21.000000', 'temperatura', 1189.0000, 'ºC'),
	(350416, 146, '2015-02-01 00:53:22.000000', 'temperatura', 817.0000, 'ºC'),
	(350417, 146, '2015-02-01 00:53:23.000000', 'temperatura', 519.0000, 'ºC'),
	(350418, 146, '2015-02-01 00:53:24.000000', 'temperatura', 146.0000, 'ºC'),
	(350419, 146, '2015-02-01 00:53:25.000000', 'temperatura', 373.0000, 'ºC'),
	(350420, 146, '2015-02-01 00:53:26.000000', 'temperatura', 228.0000, 'ºC'),
	(350421, 146, '2015-02-01 00:53:27.000000', 'temperatura', 22.0000, 'ºC'),
	(350422, 146, '2015-02-01 00:53:28.000000', 'temperatura', 627.0000, 'ºC'),
	(350423, 146, '2015-02-01 00:53:29.000000', 'temperatura', 667.0000, 'ºC'),
	(350424, 146, '2015-02-01 00:53:30.000000', 'temperatura', 255.0000, 'ºC'),
	(350425, 146, '2015-02-01 00:53:31.000000', 'temperatura', 476.0000, 'ºC'),
	(350426, 146, '2015-02-01 00:53:32.000000', 'temperatura', 415.0000, 'ºC'),
	(350427, 146, '2015-02-01 00:53:33.000000', 'temperatura', 647.0000, 'ºC'),
	(350428, 146, '2015-02-01 00:53:34.000000', 'temperatura', 791.0000, 'ºC'),
	(350429, 146, '2015-02-01 00:53:35.000000', 'temperatura', 813.0000, 'ºC'),
	(350430, 146, '2015-02-01 00:53:36.000000', 'temperatura', 493.0000, 'ºC'),
	(350431, 146, '2015-02-01 00:53:37.000000', 'temperatura', 29.0000, 'ºC'),
	(350432, 146, '2015-02-01 00:53:38.000000', 'temperatura', 1064.0000, 'ºC'),
	(350433, 146, '2015-02-01 00:53:39.000000', 'temperatura', 436.0000, 'ºC'),
	(350434, 146, '2015-02-01 00:53:40.000000', 'temperatura', 186.0000, 'ºC'),
	(350435, 146, '2015-02-01 00:53:41.000000', 'temperatura', 823.0000, 'ºC'),
	(350436, 146, '2015-02-01 00:53:42.000000', 'temperatura', 1157.0000, 'ºC'),
	(350437, 146, '2015-02-01 00:53:43.000000', 'temperatura', 917.0000, 'ºC'),
	(350438, 146, '2015-02-01 00:53:44.000000', 'temperatura', 1116.0000, 'ºC'),
	(350439, 146, '2015-02-01 00:53:45.000000', 'temperatura', 429.0000, 'ºC'),
	(350440, 146, '2015-02-01 00:53:46.000000', 'temperatura', 1196.0000, 'ºC'),
	(350441, 146, '2015-02-01 00:53:47.000000', 'temperatura', 1093.0000, 'ºC'),
	(350442, 146, '2015-02-01 00:53:48.000000', 'temperatura', 680.0000, 'ºC'),
	(350443, 146, '2015-02-01 00:53:49.000000', 'temperatura', 120.0000, 'ºC'),
	(350444, 146, '2015-02-01 00:53:50.000000', 'temperatura', 962.0000, 'ºC'),
	(350445, 146, '2015-02-01 00:53:51.000000', 'temperatura', 848.0000, 'ºC'),
	(350446, 146, '2015-02-01 00:53:52.000000', 'temperatura', 154.0000, 'ºC'),
	(350447, 146, '2015-02-01 00:53:53.000000', 'temperatura', 629.0000, 'ºC'),
	(350448, 146, '2015-02-01 00:53:54.000000', 'temperatura', 283.0000, 'ºC'),
	(350449, 146, '2015-02-01 00:53:55.000000', 'temperatura', 727.0000, 'ºC'),
	(350450, 146, '2015-02-01 00:53:56.000000', 'temperatura', 387.0000, 'ºC'),
	(350451, 146, '2015-02-01 00:53:57.000000', 'temperatura', 954.0000, 'ºC'),
	(350452, 146, '2015-02-01 00:53:58.000000', 'temperatura', 10.0000, 'ºC'),
	(350453, 146, '2015-02-01 00:53:59.000000', 'temperatura', 789.0000, 'ºC'),
	(350454, 146, '2015-02-01 00:54:00.000000', 'temperatura', 314.0000, 'ºC'),
	(350455, 146, '2015-02-01 00:54:01.000000', 'temperatura', 406.0000, 'ºC'),
	(350456, 146, '2015-02-01 00:54:02.000000', 'temperatura', 1089.0000, 'ºC'),
	(350457, 146, '2015-02-01 00:54:03.000000', 'temperatura', 625.0000, 'ºC'),
	(350458, 146, '2015-02-01 00:54:04.000000', 'temperatura', 1059.0000, 'ºC'),
	(350459, 146, '2015-02-01 00:54:05.000000', 'temperatura', 1022.0000, 'ºC'),
	(350460, 146, '2015-02-01 00:54:06.000000', 'temperatura', 731.0000, 'ºC'),
	(350461, 146, '2015-02-01 00:54:07.000000', 'temperatura', 591.0000, 'ºC'),
	(350462, 146, '2015-02-01 00:54:08.000000', 'temperatura', 764.0000, 'ºC'),
	(350463, 146, '2015-02-01 00:54:09.000000', 'temperatura', 845.0000, 'ºC'),
	(350464, 146, '2015-02-01 00:54:10.000000', 'temperatura', 733.0000, 'ºC'),
	(350465, 146, '2015-02-01 00:54:11.000000', 'temperatura', 1132.0000, 'ºC'),
	(350466, 146, '2015-02-01 00:54:12.000000', 'temperatura', 1061.0000, 'ºC'),
	(350467, 146, '2015-02-01 00:54:13.000000', 'temperatura', 710.0000, 'ºC'),
	(350468, 146, '2015-02-01 00:54:14.000000', 'temperatura', 369.0000, 'ºC'),
	(350469, 146, '2015-02-01 00:54:15.000000', 'temperatura', 915.0000, 'ºC'),
	(350470, 146, '2015-02-01 00:54:16.000000', 'temperatura', 1069.0000, 'ºC'),
	(350471, 146, '2015-02-01 00:54:17.000000', 'temperatura', 200.0000, 'ºC'),
	(350472, 146, '2015-02-01 00:54:18.000000', 'temperatura', 193.0000, 'ºC'),
	(350473, 146, '2015-02-01 00:54:19.000000', 'temperatura', 367.0000, 'ºC'),
	(350474, 146, '2015-02-01 00:54:20.000000', 'temperatura', 57.0000, 'ºC'),
	(350475, 146, '2015-02-01 00:54:21.000000', 'temperatura', 382.0000, 'ºC'),
	(350476, 146, '2015-02-01 00:54:22.000000', 'temperatura', 541.0000, 'ºC'),
	(350477, 146, '2015-02-01 00:54:23.000000', 'temperatura', 361.0000, 'ºC'),
	(350478, 146, '2015-02-01 00:54:24.000000', 'temperatura', 181.0000, 'ºC'),
	(350479, 146, '2015-02-01 00:54:25.000000', 'temperatura', 1021.0000, 'ºC'),
	(350480, 146, '2015-02-01 00:54:26.000000', 'temperatura', 962.0000, 'ºC'),
	(350481, 146, '2015-02-01 00:54:27.000000', 'temperatura', 548.0000, 'ºC'),
	(350482, 146, '2015-02-01 00:54:28.000000', 'temperatura', 1055.0000, 'ºC'),
	(350483, 146, '2015-02-01 00:54:29.000000', 'temperatura', 31.0000, 'ºC'),
	(350484, 146, '2015-02-01 00:54:30.000000', 'temperatura', 589.0000, 'ºC'),
	(350485, 146, '2015-02-01 00:54:31.000000', 'temperatura', 453.0000, 'ºC'),
	(350486, 146, '2015-02-01 00:54:32.000000', 'temperatura', 499.0000, 'ºC'),
	(350487, 146, '2015-02-01 00:54:33.000000', 'temperatura', 1137.0000, 'ºC'),
	(350488, 146, '2015-02-01 00:54:34.000000', 'temperatura', 589.0000, 'ºC'),
	(350489, 146, '2015-02-01 00:54:35.000000', 'temperatura', 733.0000, 'ºC'),
	(350490, 146, '2015-02-01 00:54:36.000000', 'temperatura', 701.0000, 'ºC'),
	(350491, 146, '2015-02-01 00:54:37.000000', 'temperatura', 104.0000, 'ºC'),
	(350492, 146, '2015-02-01 00:54:38.000000', 'temperatura', 818.0000, 'ºC'),
	(350493, 146, '2015-02-01 00:54:39.000000', 'temperatura', 180.0000, 'ºC'),
	(350494, 146, '2015-02-01 00:54:40.000000', 'temperatura', 847.0000, 'ºC'),
	(350495, 146, '2015-02-01 00:54:41.000000', 'temperatura', 95.0000, 'ºC'),
	(350496, 146, '2015-02-01 00:54:42.000000', 'temperatura', 336.0000, 'ºC'),
	(350497, 146, '2015-02-01 00:54:43.000000', 'temperatura', 193.0000, 'ºC'),
	(350498, 146, '2015-02-01 00:54:44.000000', 'temperatura', 1158.0000, 'ºC'),
	(350499, 146, '2015-02-01 00:54:45.000000', 'temperatura', 412.0000, 'ºC'),
	(350500, 146, '2015-02-01 00:54:46.000000', 'temperatura', 987.0000, 'ºC'),
	(350501, 146, '2015-02-01 00:54:47.000000', 'temperatura', 100.0000, 'ºC'),
	(350502, 146, '2015-02-01 00:54:48.000000', 'temperatura', 1138.0000, 'ºC'),
	(350503, 146, '2015-02-01 00:54:49.000000', 'temperatura', 593.0000, 'ºC'),
	(350504, 146, '2015-02-01 00:54:50.000000', 'temperatura', 749.0000, 'ºC'),
	(350505, 146, '2015-02-01 00:54:51.000000', 'temperatura', 768.0000, 'ºC'),
	(350506, 146, '2015-02-01 00:54:52.000000', 'temperatura', 394.0000, 'ºC'),
	(350507, 146, '2015-02-01 00:54:53.000000', 'temperatura', 866.0000, 'ºC'),
	(350508, 146, '2015-02-01 00:54:54.000000', 'temperatura', 749.0000, 'ºC'),
	(350509, 146, '2015-02-01 00:54:55.000000', 'temperatura', 1149.0000, 'ºC'),
	(350510, 146, '2015-02-01 00:54:56.000000', 'temperatura', 1095.0000, 'ºC'),
	(350511, 146, '2015-02-01 00:54:57.000000', 'temperatura', 831.0000, 'ºC'),
	(350512, 146, '2015-02-01 00:54:58.000000', 'temperatura', 869.0000, 'ºC'),
	(350513, 146, '2015-02-01 00:54:59.000000', 'temperatura', 655.0000, 'ºC'),
	(350514, 146, '2015-02-01 00:55:00.000000', 'temperatura', 667.0000, 'ºC'),
	(350515, 146, '2015-02-01 00:55:01.000000', 'temperatura', 170.0000, 'ºC'),
	(350516, 146, '2015-02-01 00:55:02.000000', 'temperatura', 52.0000, 'ºC'),
	(350517, 146, '2015-02-01 00:55:03.000000', 'temperatura', 949.0000, 'ºC'),
	(350518, 146, '2015-02-01 00:55:04.000000', 'temperatura', 988.0000, 'ºC'),
	(350519, 146, '2015-02-01 00:55:05.000000', 'temperatura', 895.0000, 'ºC'),
	(350520, 146, '2015-02-01 00:55:06.000000', 'temperatura', 312.0000, 'ºC'),
	(350521, 146, '2015-02-01 00:55:07.000000', 'temperatura', 75.0000, 'ºC'),
	(350522, 146, '2015-02-01 00:55:08.000000', 'temperatura', 638.0000, 'ºC'),
	(350523, 146, '2015-02-01 00:55:09.000000', 'temperatura', 565.0000, 'ºC'),
	(350524, 146, '2015-02-01 00:55:10.000000', 'temperatura', 911.0000, 'ºC'),
	(350525, 146, '2015-02-01 00:55:11.000000', 'temperatura', 462.0000, 'ºC'),
	(350526, 146, '2015-02-01 00:55:12.000000', 'temperatura', 779.0000, 'ºC'),
	(350527, 146, '2015-02-01 00:55:13.000000', 'temperatura', 109.0000, 'ºC'),
	(350528, 146, '2015-02-01 00:55:14.000000', 'temperatura', 610.0000, 'ºC'),
	(350529, 146, '2015-02-01 00:55:15.000000', 'temperatura', 322.0000, 'ºC'),
	(350530, 146, '2015-02-01 00:55:16.000000', 'temperatura', 980.0000, 'ºC'),
	(350531, 146, '2015-02-01 00:55:17.000000', 'temperatura', 334.0000, 'ºC'),
	(350532, 146, '2015-02-01 00:55:18.000000', 'temperatura', 1133.0000, 'ºC'),
	(350533, 146, '2015-02-01 00:55:19.000000', 'temperatura', 1060.0000, 'ºC'),
	(350534, 146, '2015-02-01 00:55:20.000000', 'temperatura', 704.0000, 'ºC'),
	(350535, 146, '2015-02-01 00:55:21.000000', 'temperatura', 338.0000, 'ºC'),
	(350536, 146, '2015-02-01 00:55:22.000000', 'temperatura', 780.0000, 'ºC'),
	(350537, 146, '2015-02-01 00:55:23.000000', 'temperatura', 487.0000, 'ºC'),
	(350538, 146, '2015-02-01 00:55:24.000000', 'temperatura', 95.0000, 'ºC'),
	(350539, 146, '2015-02-01 00:55:25.000000', 'temperatura', 213.0000, 'ºC'),
	(350540, 146, '2015-02-01 00:55:26.000000', 'temperatura', 779.0000, 'ºC'),
	(350541, 146, '2015-02-01 00:55:27.000000', 'temperatura', 860.0000, 'ºC'),
	(350542, 146, '2015-02-01 00:55:28.000000', 'temperatura', 764.0000, 'ºC'),
	(350543, 146, '2015-02-01 00:55:29.000000', 'temperatura', 39.0000, 'ºC'),
	(350544, 146, '2015-02-01 00:55:30.000000', 'temperatura', 303.0000, 'ºC'),
	(350545, 146, '2015-02-01 00:55:31.000000', 'temperatura', 201.0000, 'ºC'),
	(350546, 146, '2015-02-01 00:55:32.000000', 'temperatura', 94.0000, 'ºC'),
	(350547, 146, '2015-02-01 00:55:33.000000', 'temperatura', 1070.0000, 'ºC'),
	(350548, 146, '2015-02-01 00:55:34.000000', 'temperatura', 266.0000, 'ºC'),
	(350549, 146, '2015-02-01 00:55:35.000000', 'temperatura', 520.0000, 'ºC'),
	(350550, 146, '2015-02-01 00:55:36.000000', 'temperatura', 605.0000, 'ºC'),
	(350551, 146, '2015-02-01 00:55:37.000000', 'temperatura', 265.0000, 'ºC'),
	(350552, 146, '2015-02-01 00:55:38.000000', 'temperatura', 708.0000, 'ºC'),
	(350553, 146, '2015-02-01 00:55:39.000000', 'temperatura', 348.0000, 'ºC'),
	(350554, 146, '2015-02-01 00:55:40.000000', 'temperatura', 816.0000, 'ºC'),
	(350555, 146, '2015-02-01 00:55:41.000000', 'temperatura', 636.0000, 'ºC'),
	(350556, 146, '2015-02-01 00:55:42.000000', 'temperatura', 731.0000, 'ºC'),
	(350557, 146, '2015-02-01 00:55:43.000000', 'temperatura', 547.0000, 'ºC'),
	(350558, 146, '2015-02-01 00:55:44.000000', 'temperatura', 545.0000, 'ºC'),
	(350559, 146, '2015-02-01 00:55:45.000000', 'temperatura', 1085.0000, 'ºC'),
	(350560, 146, '2015-02-01 00:55:46.000000', 'temperatura', 189.0000, 'ºC'),
	(350561, 146, '2015-02-01 00:55:47.000000', 'temperatura', 89.0000, 'ºC'),
	(350562, 146, '2015-02-01 00:55:48.000000', 'temperatura', 1080.0000, 'ºC'),
	(350563, 146, '2015-02-01 00:55:49.000000', 'temperatura', 335.0000, 'ºC'),
	(350564, 146, '2015-02-01 00:55:50.000000', 'temperatura', 834.0000, 'ºC'),
	(350565, 146, '2015-02-01 00:55:51.000000', 'temperatura', 764.0000, 'ºC'),
	(350566, 146, '2015-02-01 00:55:52.000000', 'temperatura', 121.0000, 'ºC'),
	(350567, 146, '2015-02-01 00:55:53.000000', 'temperatura', 715.0000, 'ºC'),
	(350568, 146, '2015-02-01 00:55:54.000000', 'temperatura', 809.0000, 'ºC'),
	(350569, 146, '2015-02-01 00:55:55.000000', 'temperatura', 701.0000, 'ºC'),
	(350570, 146, '2015-02-01 00:55:56.000000', 'temperatura', 1079.0000, 'ºC'),
	(350571, 146, '2015-02-01 00:55:57.000000', 'temperatura', 893.0000, 'ºC'),
	(350572, 146, '2015-02-01 00:55:58.000000', 'temperatura', 28.0000, 'ºC'),
	(350573, 146, '2015-02-01 00:55:59.000000', 'temperatura', 1060.0000, 'ºC'),
	(350574, 146, '2015-02-01 00:56:00.000000', 'temperatura', 417.0000, 'ºC'),
	(350575, 146, '2015-02-01 00:56:01.000000', 'temperatura', 104.0000, 'ºC'),
	(350576, 146, '2015-02-01 00:56:02.000000', 'temperatura', 470.0000, 'ºC'),
	(350577, 146, '2015-02-01 00:56:03.000000', 'temperatura', 840.0000, 'ºC'),
	(350578, 146, '2015-02-01 00:56:04.000000', 'temperatura', 389.0000, 'ºC'),
	(350579, 146, '2015-02-01 00:56:05.000000', 'temperatura', 627.0000, 'ºC'),
	(350580, 146, '2015-02-01 00:56:06.000000', 'temperatura', 769.0000, 'ºC'),
	(350581, 146, '2015-02-01 00:56:07.000000', 'temperatura', 762.0000, 'ºC'),
	(350582, 146, '2015-02-01 00:56:08.000000', 'temperatura', 303.0000, 'ºC'),
	(350583, 146, '2015-02-01 00:56:09.000000', 'temperatura', 430.0000, 'ºC'),
	(350584, 146, '2015-02-01 00:56:10.000000', 'temperatura', 43.0000, 'ºC'),
	(350585, 146, '2015-02-01 00:56:11.000000', 'temperatura', 125.0000, 'ºC'),
	(350586, 146, '2015-02-01 00:56:12.000000', 'temperatura', 498.0000, 'ºC'),
	(350587, 146, '2015-02-01 00:56:13.000000', 'temperatura', 914.0000, 'ºC'),
	(350588, 146, '2015-02-01 00:56:14.000000', 'temperatura', 677.0000, 'ºC'),
	(350589, 146, '2015-02-01 00:56:15.000000', 'temperatura', 643.0000, 'ºC'),
	(350590, 146, '2015-02-01 00:56:16.000000', 'temperatura', 1184.0000, 'ºC'),
	(350591, 146, '2015-02-01 00:56:17.000000', 'temperatura', 390.0000, 'ºC'),
	(350592, 146, '2015-02-01 00:56:18.000000', 'temperatura', 801.0000, 'ºC'),
	(350593, 146, '2015-02-01 00:56:19.000000', 'temperatura', 434.0000, 'ºC'),
	(350594, 146, '2015-02-01 00:56:20.000000', 'temperatura', 966.0000, 'ºC'),
	(350595, 146, '2015-02-01 00:56:21.000000', 'temperatura', 1132.0000, 'ºC'),
	(350596, 146, '2015-02-01 00:56:22.000000', 'temperatura', 360.0000, 'ºC'),
	(350597, 146, '2015-02-01 00:56:23.000000', 'temperatura', 807.0000, 'ºC'),
	(350598, 146, '2015-02-01 00:56:24.000000', 'temperatura', 552.0000, 'ºC'),
	(350599, 146, '2015-02-01 00:56:25.000000', 'temperatura', 342.0000, 'ºC'),
	(350600, 146, '2015-02-01 00:56:26.000000', 'temperatura', 54.0000, 'ºC'),
	(350601, 146, '2015-02-01 00:56:27.000000', 'temperatura', 445.0000, 'ºC'),
	(350602, 146, '2015-02-01 00:56:28.000000', 'temperatura', 862.0000, 'ºC'),
	(350603, 146, '2015-02-01 00:56:29.000000', 'temperatura', 577.0000, 'ºC'),
	(350604, 146, '2015-02-01 00:56:30.000000', 'temperatura', 298.0000, 'ºC'),
	(350605, 146, '2015-02-01 00:56:31.000000', 'temperatura', 959.0000, 'ºC'),
	(350606, 146, '2015-02-01 00:56:32.000000', 'temperatura', 301.0000, 'ºC'),
	(350607, 146, '2015-02-01 00:56:33.000000', 'temperatura', 1030.0000, 'ºC'),
	(350608, 146, '2015-02-01 00:56:34.000000', 'temperatura', 646.0000, 'ºC'),
	(350609, 146, '2015-02-01 00:56:35.000000', 'temperatura', 141.0000, 'ºC'),
	(350610, 146, '2015-02-01 00:56:36.000000', 'temperatura', 1167.0000, 'ºC'),
	(350611, 146, '2015-02-01 00:56:37.000000', 'temperatura', 613.0000, 'ºC'),
	(350612, 146, '2015-02-01 00:56:38.000000', 'temperatura', 763.0000, 'ºC'),
	(350613, 146, '2015-02-01 00:56:39.000000', 'temperatura', 776.0000, 'ºC'),
	(350614, 146, '2015-02-01 00:56:40.000000', 'temperatura', 394.0000, 'ºC'),
	(350615, 146, '2015-02-01 00:56:41.000000', 'temperatura', 842.0000, 'ºC'),
	(350616, 146, '2015-02-01 00:56:42.000000', 'temperatura', 629.0000, 'ºC'),
	(350617, 146, '2015-02-01 00:56:43.000000', 'temperatura', 621.0000, 'ºC'),
	(350618, 146, '2015-02-01 00:56:44.000000', 'temperatura', 15.0000, 'ºC'),
	(350619, 146, '2015-02-01 00:56:45.000000', 'temperatura', 615.0000, 'ºC'),
	(350620, 146, '2015-02-01 00:56:46.000000', 'temperatura', 632.0000, 'ºC'),
	(350621, 146, '2015-02-01 00:56:47.000000', 'temperatura', 113.0000, 'ºC'),
	(350622, 146, '2015-02-01 00:56:48.000000', 'temperatura', 1069.0000, 'ºC'),
	(350623, 146, '2015-02-01 00:56:49.000000', 'temperatura', 207.0000, 'ºC'),
	(350624, 146, '2015-02-01 00:56:50.000000', 'temperatura', 230.0000, 'ºC'),
	(350625, 146, '2015-02-01 00:56:51.000000', 'temperatura', 529.0000, 'ºC'),
	(350626, 146, '2015-02-01 00:56:52.000000', 'temperatura', 757.0000, 'ºC'),
	(350627, 146, '2015-02-01 00:56:53.000000', 'temperatura', 997.0000, 'ºC'),
	(350628, 146, '2015-02-01 00:56:54.000000', 'temperatura', 316.0000, 'ºC'),
	(350629, 146, '2015-02-01 00:56:55.000000', 'temperatura', 987.0000, 'ºC'),
	(350630, 146, '2015-02-01 00:56:56.000000', 'temperatura', 389.0000, 'ºC'),
	(350631, 146, '2015-02-01 00:56:57.000000', 'temperatura', 183.0000, 'ºC'),
	(350632, 146, '2015-02-01 00:56:58.000000', 'temperatura', 948.0000, 'ºC'),
	(350633, 146, '2015-02-01 00:56:59.000000', 'temperatura', 592.0000, 'ºC'),
	(350634, 146, '2015-02-01 00:57:00.000000', 'temperatura', 118.0000, 'ºC'),
	(350635, 146, '2015-02-01 00:57:01.000000', 'temperatura', 14.0000, 'ºC'),
	(350636, 146, '2015-02-01 00:57:02.000000', 'temperatura', 918.0000, 'ºC'),
	(350637, 146, '2015-02-01 00:57:03.000000', 'temperatura', 948.0000, 'ºC'),
	(350638, 146, '2015-02-01 00:57:04.000000', 'temperatura', 784.0000, 'ºC'),
	(350639, 146, '2015-02-01 00:57:05.000000', 'temperatura', 1080.0000, 'ºC'),
	(350640, 146, '2015-02-01 00:57:06.000000', 'temperatura', 647.0000, 'ºC'),
	(350641, 146, '2015-02-01 00:57:07.000000', 'temperatura', 1195.0000, 'ºC'),
	(350642, 146, '2015-02-01 00:57:08.000000', 'temperatura', 436.0000, 'ºC'),
	(350643, 146, '2015-02-01 00:57:09.000000', 'temperatura', 996.0000, 'ºC'),
	(350644, 146, '2015-02-01 00:57:10.000000', 'temperatura', 71.0000, 'ºC'),
	(350645, 146, '2015-02-01 00:57:11.000000', 'temperatura', 967.0000, 'ºC'),
	(350646, 146, '2015-02-01 00:57:12.000000', 'temperatura', 1022.0000, 'ºC'),
	(350647, 146, '2015-02-01 00:57:13.000000', 'temperatura', 1012.0000, 'ºC'),
	(350648, 146, '2015-02-01 00:57:14.000000', 'temperatura', 794.0000, 'ºC'),
	(350649, 146, '2015-02-01 00:57:15.000000', 'temperatura', 936.0000, 'ºC'),
	(350650, 146, '2015-02-01 00:57:16.000000', 'temperatura', 1097.0000, 'ºC'),
	(350651, 146, '2015-02-01 00:57:17.000000', 'temperatura', 279.0000, 'ºC'),
	(350652, 146, '2015-02-01 00:57:18.000000', 'temperatura', 502.0000, 'ºC'),
	(350653, 146, '2015-02-01 00:57:19.000000', 'temperatura', 474.0000, 'ºC'),
	(350654, 146, '2015-02-01 00:57:20.000000', 'temperatura', 867.0000, 'ºC'),
	(350655, 146, '2015-02-01 00:57:21.000000', 'temperatura', 512.0000, 'ºC'),
	(350656, 146, '2015-02-01 00:57:22.000000', 'temperatura', 1159.0000, 'ºC'),
	(350657, 146, '2015-02-01 00:57:23.000000', 'temperatura', 659.0000, 'ºC'),
	(350658, 146, '2015-02-01 00:57:24.000000', 'temperatura', 1018.0000, 'ºC'),
	(350659, 146, '2015-02-01 00:57:25.000000', 'temperatura', 714.0000, 'ºC'),
	(350660, 146, '2015-02-01 00:57:26.000000', 'temperatura', 516.0000, 'ºC'),
	(350661, 146, '2015-02-01 00:57:27.000000', 'temperatura', 438.0000, 'ºC'),
	(350662, 146, '2015-02-01 00:57:28.000000', 'temperatura', 643.0000, 'ºC'),
	(350663, 146, '2015-02-01 00:57:29.000000', 'temperatura', 702.0000, 'ºC'),
	(350664, 146, '2015-02-01 00:57:30.000000', 'temperatura', 380.0000, 'ºC'),
	(350665, 146, '2015-02-01 00:57:31.000000', 'temperatura', 996.0000, 'ºC'),
	(350666, 146, '2015-02-01 00:57:32.000000', 'temperatura', 239.0000, 'ºC'),
	(350667, 146, '2015-02-01 00:57:33.000000', 'temperatura', 608.0000, 'ºC'),
	(350668, 146, '2015-02-01 00:57:34.000000', 'temperatura', 1123.0000, 'ºC'),
	(350669, 146, '2015-02-01 00:57:35.000000', 'temperatura', 192.0000, 'ºC'),
	(350670, 146, '2015-02-01 00:57:36.000000', 'temperatura', 1193.0000, 'ºC'),
	(350671, 146, '2015-02-01 00:57:37.000000', 'temperatura', 588.0000, 'ºC'),
	(350672, 146, '2015-02-01 00:57:38.000000', 'temperatura', 562.0000, 'ºC'),
	(350673, 146, '2015-02-01 00:57:39.000000', 'temperatura', 1045.0000, 'ºC'),
	(350674, 146, '2015-02-01 00:57:40.000000', 'temperatura', 1139.0000, 'ºC'),
	(350675, 146, '2015-02-01 00:57:41.000000', 'temperatura', 163.0000, 'ºC'),
	(350676, 146, '2015-02-01 00:57:42.000000', 'temperatura', 999.0000, 'ºC'),
	(350677, 146, '2015-02-01 00:57:43.000000', 'temperatura', 904.0000, 'ºC'),
	(350678, 146, '2015-02-01 00:57:44.000000', 'temperatura', 324.0000, 'ºC'),
	(350679, 146, '2015-02-01 00:57:45.000000', 'temperatura', 108.0000, 'ºC'),
	(350680, 146, '2015-02-01 00:57:46.000000', 'temperatura', 768.0000, 'ºC'),
	(350681, 146, '2015-02-01 00:57:47.000000', 'temperatura', 1117.0000, 'ºC'),
	(350682, 146, '2015-02-01 00:57:48.000000', 'temperatura', 882.0000, 'ºC'),
	(350683, 146, '2015-02-01 00:57:49.000000', 'temperatura', 1058.0000, 'ºC'),
	(350684, 146, '2015-02-01 00:57:50.000000', 'temperatura', 247.0000, 'ºC'),
	(350685, 146, '2015-02-01 00:57:51.000000', 'temperatura', 462.0000, 'ºC'),
	(350686, 146, '2015-02-01 00:57:52.000000', 'temperatura', 369.0000, 'ºC'),
	(350687, 146, '2015-02-01 00:57:53.000000', 'temperatura', 458.0000, 'ºC'),
	(350688, 146, '2015-02-01 00:57:54.000000', 'temperatura', 1183.0000, 'ºC'),
	(350689, 146, '2015-02-01 00:57:55.000000', 'temperatura', 944.0000, 'ºC'),
	(350690, 146, '2015-02-01 00:57:56.000000', 'temperatura', 1172.0000, 'ºC'),
	(350691, 146, '2015-02-01 00:57:57.000000', 'temperatura', 625.0000, 'ºC'),
	(350692, 146, '2015-02-01 00:57:58.000000', 'temperatura', 813.0000, 'ºC'),
	(350693, 146, '2015-02-01 00:57:59.000000', 'temperatura', 988.0000, 'ºC'),
	(350694, 146, '2015-02-01 00:58:00.000000', 'temperatura', 102.0000, 'ºC'),
	(350695, 146, '2015-02-01 00:58:01.000000', 'temperatura', 1146.0000, 'ºC'),
	(350696, 146, '2015-02-01 00:58:02.000000', 'temperatura', 623.0000, 'ºC'),
	(350697, 146, '2015-02-01 00:58:03.000000', 'temperatura', 880.0000, 'ºC'),
	(350698, 146, '2015-02-01 00:58:04.000000', 'temperatura', 130.0000, 'ºC'),
	(350699, 146, '2015-02-01 00:58:05.000000', 'temperatura', 411.0000, 'ºC'),
	(350700, 146, '2015-02-01 00:58:06.000000', 'temperatura', 467.0000, 'ºC'),
	(350701, 146, '2015-02-01 00:58:07.000000', 'temperatura', 1100.0000, 'ºC'),
	(350702, 146, '2015-02-01 00:58:08.000000', 'temperatura', 500.0000, 'ºC'),
	(350703, 146, '2015-02-01 00:58:09.000000', 'temperatura', 403.0000, 'ºC'),
	(350704, 146, '2015-02-01 00:58:10.000000', 'temperatura', 514.0000, 'ºC'),
	(350705, 146, '2015-02-01 00:58:11.000000', 'temperatura', 161.0000, 'ºC'),
	(350706, 146, '2015-02-01 00:58:12.000000', 'temperatura', 463.0000, 'ºC'),
	(350707, 146, '2015-02-01 00:58:13.000000', 'temperatura', 633.0000, 'ºC'),
	(350708, 146, '2015-02-01 00:58:14.000000', 'temperatura', 574.0000, 'ºC'),
	(350709, 146, '2015-02-01 00:58:15.000000', 'temperatura', 975.0000, 'ºC'),
	(350710, 146, '2015-02-01 00:58:16.000000', 'temperatura', 753.0000, 'ºC'),
	(350711, 146, '2015-02-01 00:58:17.000000', 'temperatura', 839.0000, 'ºC'),
	(350712, 146, '2015-02-01 00:58:18.000000', 'temperatura', 735.0000, 'ºC'),
	(350713, 146, '2015-02-01 00:58:19.000000', 'temperatura', 1161.0000, 'ºC'),
	(350714, 146, '2015-02-01 00:58:20.000000', 'temperatura', 1198.0000, 'ºC'),
	(350715, 146, '2015-02-01 00:58:21.000000', 'temperatura', 111.0000, 'ºC'),
	(350716, 146, '2015-02-01 00:58:22.000000', 'temperatura', 559.0000, 'ºC'),
	(350717, 146, '2015-02-01 00:58:23.000000', 'temperatura', 64.0000, 'ºC'),
	(350718, 146, '2015-02-01 00:58:24.000000', 'temperatura', 1044.0000, 'ºC'),
	(350719, 146, '2015-02-01 00:58:25.000000', 'temperatura', 227.0000, 'ºC'),
	(350720, 146, '2015-02-01 00:58:26.000000', 'temperatura', 402.0000, 'ºC'),
	(350721, 146, '2015-02-01 00:58:27.000000', 'temperatura', 131.0000, 'ºC'),
	(350722, 146, '2015-02-01 00:58:28.000000', 'temperatura', 650.0000, 'ºC'),
	(350723, 146, '2015-02-01 00:58:29.000000', 'temperatura', 457.0000, 'ºC'),
	(350724, 146, '2015-02-01 00:58:30.000000', 'temperatura', 337.0000, 'ºC'),
	(350725, 146, '2015-02-01 00:58:31.000000', 'temperatura', 313.0000, 'ºC'),
	(350726, 146, '2015-02-01 00:58:32.000000', 'temperatura', 555.0000, 'ºC'),
	(350727, 146, '2015-02-01 00:58:33.000000', 'temperatura', 637.0000, 'ºC'),
	(350728, 146, '2015-02-01 00:58:34.000000', 'temperatura', 321.0000, 'ºC'),
	(350729, 146, '2015-02-01 00:58:35.000000', 'temperatura', 892.0000, 'ºC'),
	(350730, 146, '2015-02-01 00:58:36.000000', 'temperatura', 1098.0000, 'ºC'),
	(350731, 146, '2015-02-01 00:58:37.000000', 'temperatura', 416.0000, 'ºC'),
	(350732, 146, '2015-02-01 00:58:38.000000', 'temperatura', 1184.0000, 'ºC'),
	(350733, 146, '2015-02-01 00:58:39.000000', 'temperatura', 1075.0000, 'ºC'),
	(350734, 146, '2015-02-01 00:58:40.000000', 'temperatura', 624.0000, 'ºC'),
	(350735, 146, '2015-02-01 00:58:41.000000', 'temperatura', 1094.0000, 'ºC'),
	(350736, 146, '2015-02-01 00:58:42.000000', 'temperatura', 1197.0000, 'ºC'),
	(350737, 146, '2015-02-01 00:58:43.000000', 'temperatura', 305.0000, 'ºC'),
	(350738, 146, '2015-02-01 00:58:44.000000', 'temperatura', 335.0000, 'ºC'),
	(350739, 146, '2015-02-01 00:58:45.000000', 'temperatura', 759.0000, 'ºC'),
	(350740, 146, '2015-02-01 00:58:46.000000', 'temperatura', 390.0000, 'ºC'),
	(350741, 146, '2015-02-01 00:58:47.000000', 'temperatura', 874.0000, 'ºC'),
	(350742, 146, '2015-02-01 00:58:48.000000', 'temperatura', 801.0000, 'ºC'),
	(350743, 146, '2015-02-01 00:58:49.000000', 'temperatura', 184.0000, 'ºC'),
	(350744, 146, '2015-02-01 00:58:50.000000', 'temperatura', 918.0000, 'ºC'),
	(350745, 146, '2015-02-01 00:58:51.000000', 'temperatura', 437.0000, 'ºC'),
	(350746, 146, '2015-02-01 00:58:52.000000', 'temperatura', 633.0000, 'ºC'),
	(350747, 146, '2015-02-01 00:58:53.000000', 'temperatura', 655.0000, 'ºC'),
	(350748, 146, '2015-02-01 00:58:54.000000', 'temperatura', 175.0000, 'ºC'),
	(350749, 146, '2015-02-01 00:58:55.000000', 'temperatura', 111.0000, 'ºC'),
	(350750, 146, '2015-02-01 00:58:56.000000', 'temperatura', 29.0000, 'ºC'),
	(350751, 146, '2015-02-01 00:58:57.000000', 'temperatura', 1015.0000, 'ºC'),
	(350752, 146, '2015-02-01 00:58:58.000000', 'temperatura', 189.0000, 'ºC'),
	(350753, 146, '2015-02-01 00:58:59.000000', 'temperatura', 300.0000, 'ºC'),
	(350754, 146, '2015-02-01 00:59:00.000000', 'temperatura', 932.0000, 'ºC'),
	(350755, 146, '2015-02-01 00:59:01.000000', 'temperatura', 163.0000, 'ºC'),
	(350756, 146, '2015-02-01 00:59:02.000000', 'temperatura', 418.0000, 'ºC'),
	(350757, 146, '2015-02-01 00:59:03.000000', 'temperatura', 403.0000, 'ºC'),
	(350758, 146, '2015-02-01 00:59:04.000000', 'temperatura', 759.0000, 'ºC'),
	(350759, 146, '2015-02-01 00:59:05.000000', 'temperatura', 188.0000, 'ºC'),
	(350760, 146, '2015-02-01 00:59:06.000000', 'temperatura', 1065.0000, 'ºC'),
	(350761, 146, '2015-02-01 00:59:07.000000', 'temperatura', 1161.0000, 'ºC'),
	(350762, 146, '2015-02-01 00:59:08.000000', 'temperatura', 212.0000, 'ºC'),
	(350763, 146, '2015-02-01 00:59:09.000000', 'temperatura', 1174.0000, 'ºC'),
	(350764, 146, '2015-02-01 00:59:10.000000', 'temperatura', 437.0000, 'ºC'),
	(350765, 146, '2015-02-01 00:59:11.000000', 'temperatura', 1064.0000, 'ºC'),
	(350766, 146, '2015-02-01 00:59:12.000000', 'temperatura', 409.0000, 'ºC'),
	(350767, 146, '2015-02-01 00:59:13.000000', 'temperatura', 55.0000, 'ºC'),
	(350768, 146, '2015-02-01 00:59:14.000000', 'temperatura', 246.0000, 'ºC'),
	(350769, 146, '2015-02-01 00:59:15.000000', 'temperatura', 1066.0000, 'ºC'),
	(350770, 146, '2015-02-01 00:59:16.000000', 'temperatura', 992.0000, 'ºC'),
	(350771, 146, '2015-02-01 00:59:17.000000', 'temperatura', 563.0000, 'ºC'),
	(350772, 146, '2015-02-01 00:59:18.000000', 'temperatura', 1039.0000, 'ºC'),
	(350773, 146, '2015-02-01 00:59:19.000000', 'temperatura', 1106.0000, 'ºC'),
	(350774, 146, '2015-02-01 00:59:20.000000', 'temperatura', 14.0000, 'ºC'),
	(350775, 146, '2015-02-01 00:59:21.000000', 'temperatura', 351.0000, 'ºC'),
	(350776, 146, '2015-02-01 00:59:22.000000', 'temperatura', 516.0000, 'ºC'),
	(350777, 146, '2015-02-01 00:59:23.000000', 'temperatura', 326.0000, 'ºC'),
	(350778, 146, '2015-02-01 00:59:24.000000', 'temperatura', 84.0000, 'ºC'),
	(350779, 146, '2015-02-01 00:59:25.000000', 'temperatura', 642.0000, 'ºC'),
	(350780, 146, '2015-02-01 00:59:26.000000', 'temperatura', 556.0000, 'ºC'),
	(350781, 146, '2015-02-01 00:59:27.000000', 'temperatura', 858.0000, 'ºC'),
	(350782, 146, '2015-02-01 00:59:28.000000', 'temperatura', 220.0000, 'ºC'),
	(350783, 146, '2015-02-01 00:59:29.000000', 'temperatura', 927.0000, 'ºC'),
	(350784, 146, '2015-02-01 00:59:30.000000', 'temperatura', 375.0000, 'ºC'),
	(350785, 146, '2015-02-01 00:59:31.000000', 'temperatura', 293.0000, 'ºC'),
	(350786, 146, '2015-02-01 00:59:32.000000', 'temperatura', 344.0000, 'ºC'),
	(350787, 146, '2015-02-01 00:59:33.000000', 'temperatura', 840.0000, 'ºC'),
	(350788, 146, '2015-02-01 00:59:34.000000', 'temperatura', 768.0000, 'ºC'),
	(350789, 146, '2015-02-01 00:59:35.000000', 'temperatura', 119.0000, 'ºC'),
	(350790, 146, '2015-02-01 00:59:36.000000', 'temperatura', 694.0000, 'ºC'),
	(350791, 146, '2015-02-01 00:59:37.000000', 'temperatura', 711.0000, 'ºC'),
	(350792, 146, '2015-02-01 00:59:38.000000', 'temperatura', 275.0000, 'ºC'),
	(350793, 146, '2015-02-01 00:59:39.000000', 'temperatura', 441.0000, 'ºC'),
	(350794, 146, '2015-02-01 00:59:40.000000', 'temperatura', 179.0000, 'ºC'),
	(350795, 146, '2015-02-01 00:59:41.000000', 'temperatura', 776.0000, 'ºC'),
	(350796, 146, '2015-02-01 00:59:42.000000', 'temperatura', 941.0000, 'ºC'),
	(350797, 146, '2015-02-01 00:59:43.000000', 'temperatura', 1177.0000, 'ºC'),
	(350798, 146, '2015-02-01 00:59:44.000000', 'temperatura', 663.0000, 'ºC'),
	(350799, 146, '2015-02-01 00:59:45.000000', 'temperatura', 983.0000, 'ºC'),
	(350800, 146, '2015-02-01 00:59:46.000000', 'temperatura', 527.0000, 'ºC'),
	(350801, 146, '2015-02-01 00:59:47.000000', 'temperatura', 888.0000, 'ºC'),
	(350802, 146, '2015-02-01 00:59:48.000000', 'temperatura', 461.0000, 'ºC'),
	(350803, 146, '2015-02-01 00:59:49.000000', 'temperatura', 839.0000, 'ºC'),
	(350804, 146, '2015-02-01 00:59:50.000000', 'temperatura', 414.0000, 'ºC'),
	(350805, 146, '2015-02-01 00:59:51.000000', 'temperatura', 752.0000, 'ºC'),
	(350806, 146, '2015-02-01 00:59:52.000000', 'temperatura', 120.0000, 'ºC'),
	(350807, 146, '2015-02-01 00:59:53.000000', 'temperatura', 743.0000, 'ºC'),
	(350808, 146, '2015-02-01 00:59:54.000000', 'temperatura', 958.0000, 'ºC'),
	(350809, 146, '2015-02-01 00:59:55.000000', 'temperatura', 161.0000, 'ºC'),
	(350810, 146, '2015-02-01 00:59:56.000000', 'temperatura', 332.0000, 'ºC'),
	(350811, 146, '2015-02-01 00:59:57.000000', 'temperatura', 1176.0000, 'ºC'),
	(350812, 146, '2015-02-01 00:59:58.000000', 'temperatura', 84.0000, 'ºC'),
	(350813, 146, '2015-02-01 00:59:59.000000', 'temperatura', 494.0000, 'ºC'),
	(350814, 146, '2015-02-01 01:00:00.000000', 'temperatura', 1018.0000, 'ºC'),
	(350815, 146, '2015-02-01 01:00:01.000000', 'temperatura', 11.0000, 'ºC'),
	(350816, 146, '2015-02-01 01:00:02.000000', 'temperatura', 598.0000, 'ºC'),
	(350817, 146, '2015-02-01 01:00:03.000000', 'temperatura', 558.0000, 'ºC'),
	(350818, 146, '2015-02-01 01:00:04.000000', 'temperatura', 996.0000, 'ºC'),
	(350819, 146, '2015-02-01 01:00:05.000000', 'temperatura', 909.0000, 'ºC'),
	(350820, 146, '2015-02-01 01:00:06.000000', 'temperatura', 354.0000, 'ºC'),
	(350821, 146, '2015-02-01 01:00:07.000000', 'temperatura', 247.0000, 'ºC'),
	(350822, 146, '2015-02-01 01:00:08.000000', 'temperatura', 170.0000, 'ºC'),
	(350823, 146, '2015-02-01 01:00:09.000000', 'temperatura', 112.0000, 'ºC'),
	(350824, 146, '2015-02-01 01:00:10.000000', 'temperatura', 48.0000, 'ºC'),
	(350825, 146, '2015-02-01 01:00:11.000000', 'temperatura', 1104.0000, 'ºC'),
	(350826, 146, '2015-02-01 01:00:12.000000', 'temperatura', 579.0000, 'ºC'),
	(350827, 146, '2015-02-01 01:00:13.000000', 'temperatura', 784.0000, 'ºC'),
	(350828, 146, '2015-02-01 01:00:14.000000', 'temperatura', 981.0000, 'ºC'),
	(350829, 146, '2015-02-01 01:00:15.000000', 'temperatura', 155.0000, 'ºC'),
	(350830, 146, '2015-02-01 01:00:16.000000', 'temperatura', 232.0000, 'ºC'),
	(350831, 146, '2015-02-01 01:00:17.000000', 'temperatura', 695.0000, 'ºC'),
	(350832, 146, '2015-02-01 01:00:18.000000', 'temperatura', 381.0000, 'ºC'),
	(350833, 146, '2015-02-01 01:00:19.000000', 'temperatura', 1018.0000, 'ºC'),
	(350834, 146, '2015-02-01 01:00:20.000000', 'temperatura', 350.0000, 'ºC'),
	(350835, 146, '2015-02-01 01:00:21.000000', 'temperatura', 1095.0000, 'ºC'),
	(350836, 146, '2015-02-01 01:00:22.000000', 'temperatura', 827.0000, 'ºC'),
	(350837, 146, '2015-02-01 01:00:23.000000', 'temperatura', 850.0000, 'ºC'),
	(350838, 146, '2015-02-01 01:00:24.000000', 'temperatura', 569.0000, 'ºC'),
	(350839, 146, '2015-02-01 01:00:25.000000', 'temperatura', 298.0000, 'ºC'),
	(350840, 146, '2015-02-01 01:00:26.000000', 'temperatura', 981.0000, 'ºC'),
	(350841, 146, '2015-02-01 01:00:27.000000', 'temperatura', 413.0000, 'ºC'),
	(350842, 146, '2015-02-01 01:00:28.000000', 'temperatura', 322.0000, 'ºC'),
	(350843, 146, '2015-02-01 01:00:29.000000', 'temperatura', 369.0000, 'ºC'),
	(350844, 146, '2015-02-01 01:00:30.000000', 'temperatura', 883.0000, 'ºC'),
	(350845, 146, '2015-02-01 01:00:31.000000', 'temperatura', 906.0000, 'ºC'),
	(350846, 146, '2015-02-01 01:00:32.000000', 'temperatura', 683.0000, 'ºC'),
	(350847, 146, '2015-02-01 01:00:33.000000', 'temperatura', 697.0000, 'ºC'),
	(350848, 146, '2015-02-01 01:00:34.000000', 'temperatura', 235.0000, 'ºC'),
	(350849, 146, '2015-02-01 01:00:35.000000', 'temperatura', 284.0000, 'ºC'),
	(350850, 146, '2015-02-01 01:00:36.000000', 'temperatura', 715.0000, 'ºC'),
	(350851, 146, '2015-02-01 01:00:37.000000', 'temperatura', 326.0000, 'ºC'),
	(350852, 146, '2015-02-01 01:00:38.000000', 'temperatura', 684.0000, 'ºC'),
	(350853, 146, '2015-02-01 01:00:39.000000', 'temperatura', 43.0000, 'ºC'),
	(350854, 146, '2015-02-01 01:00:40.000000', 'temperatura', 561.0000, 'ºC'),
	(350855, 146, '2015-02-01 01:00:41.000000', 'temperatura', 279.0000, 'ºC'),
	(350856, 146, '2015-02-01 01:00:42.000000', 'temperatura', 913.0000, 'ºC'),
	(350857, 146, '2015-02-01 01:00:43.000000', 'temperatura', 129.0000, 'ºC'),
	(350858, 146, '2015-02-01 01:00:44.000000', 'temperatura', 306.0000, 'ºC'),
	(350859, 146, '2015-02-01 01:00:45.000000', 'temperatura', 1141.0000, 'ºC'),
	(350860, 146, '2015-02-01 01:00:46.000000', 'temperatura', 1190.0000, 'ºC'),
	(350861, 146, '2015-02-01 01:00:47.000000', 'temperatura', 125.0000, 'ºC'),
	(350862, 146, '2015-02-01 01:00:48.000000', 'temperatura', 658.0000, 'ºC'),
	(350863, 146, '2015-02-01 01:00:49.000000', 'temperatura', 514.0000, 'ºC'),
	(350864, 146, '2015-02-01 01:00:50.000000', 'temperatura', 596.0000, 'ºC'),
	(350865, 146, '2015-02-01 01:00:51.000000', 'temperatura', 238.0000, 'ºC'),
	(350866, 146, '2015-02-01 01:00:52.000000', 'temperatura', 603.0000, 'ºC'),
	(350867, 146, '2015-02-01 01:00:53.000000', 'temperatura', 1102.0000, 'ºC'),
	(350868, 146, '2015-02-01 01:00:54.000000', 'temperatura', 101.0000, 'ºC'),
	(350869, 146, '2015-02-01 01:00:55.000000', 'temperatura', 801.0000, 'ºC'),
	(350870, 146, '2015-02-01 01:00:56.000000', 'temperatura', 104.0000, 'ºC'),
	(350871, 146, '2015-02-01 01:00:57.000000', 'temperatura', 514.0000, 'ºC'),
	(350872, 146, '2015-02-01 01:00:58.000000', 'temperatura', 1060.0000, 'ºC'),
	(350873, 146, '2015-02-01 01:00:59.000000', 'temperatura', 157.0000, 'ºC'),
	(350874, 146, '2015-02-01 01:01:00.000000', 'temperatura', 8.0000, 'ºC'),
	(350875, 146, '2015-02-01 01:01:01.000000', 'temperatura', 770.0000, 'ºC'),
	(350876, 146, '2015-02-01 01:01:02.000000', 'temperatura', 226.0000, 'ºC'),
	(350877, 146, '2015-02-01 01:01:03.000000', 'temperatura', 22.0000, 'ºC'),
	(350878, 146, '2015-02-01 01:01:04.000000', 'temperatura', 630.0000, 'ºC'),
	(350879, 146, '2015-02-01 01:01:05.000000', 'temperatura', 686.0000, 'ºC'),
	(350880, 146, '2015-02-01 01:01:06.000000', 'temperatura', 339.0000, 'ºC'),
	(350881, 146, '2015-02-01 01:01:07.000000', 'temperatura', 839.0000, 'ºC'),
	(350882, 146, '2015-02-01 01:01:08.000000', 'temperatura', 776.0000, 'ºC'),
	(350883, 146, '2015-02-01 01:01:09.000000', 'temperatura', 165.0000, 'ºC'),
	(350884, 146, '2015-02-01 01:01:10.000000', 'temperatura', 898.0000, 'ºC'),
	(350885, 146, '2015-02-01 01:01:11.000000', 'temperatura', 396.0000, 'ºC'),
	(350886, 146, '2015-02-01 01:01:12.000000', 'temperatura', 485.0000, 'ºC'),
	(350887, 146, '2015-02-01 01:01:13.000000', 'temperatura', 36.0000, 'ºC'),
	(350888, 146, '2015-02-01 01:01:14.000000', 'temperatura', 1128.0000, 'ºC'),
	(350889, 146, '2015-02-01 01:01:15.000000', 'temperatura', 733.0000, 'ºC'),
	(350890, 146, '2015-02-01 01:01:16.000000', 'temperatura', 282.0000, 'ºC'),
	(350891, 146, '2015-02-01 01:01:17.000000', 'temperatura', 410.0000, 'ºC'),
	(350892, 146, '2015-02-01 01:01:18.000000', 'temperatura', 6.0000, 'ºC'),
	(350893, 146, '2015-02-01 01:01:19.000000', 'temperatura', 1198.0000, 'ºC'),
	(350894, 146, '2015-02-01 01:01:20.000000', 'temperatura', 1172.0000, 'ºC'),
	(350895, 146, '2015-02-01 01:01:21.000000', 'temperatura', 1068.0000, 'ºC'),
	(350896, 146, '2015-02-01 01:01:22.000000', 'temperatura', 622.0000, 'ºC'),
	(350897, 146, '2015-02-01 01:01:23.000000', 'temperatura', 1109.0000, 'ºC'),
	(350898, 146, '2015-02-01 01:01:24.000000', 'temperatura', 79.0000, 'ºC'),
	(350899, 146, '2015-02-01 01:01:25.000000', 'temperatura', 668.0000, 'ºC'),
	(350900, 146, '2015-02-01 01:01:26.000000', 'temperatura', 705.0000, 'ºC'),
	(350901, 146, '2015-02-01 01:01:27.000000', 'temperatura', 319.0000, 'ºC'),
	(350902, 146, '2015-02-01 01:01:28.000000', 'temperatura', 680.0000, 'ºC'),
	(350903, 146, '2015-02-01 01:01:29.000000', 'temperatura', 46.0000, 'ºC'),
	(350904, 146, '2015-02-01 01:01:30.000000', 'temperatura', 587.0000, 'ºC'),
	(350905, 146, '2015-02-01 01:01:31.000000', 'temperatura', 401.0000, 'ºC'),
	(350906, 146, '2015-02-01 01:01:32.000000', 'temperatura', 245.0000, 'ºC'),
	(350907, 146, '2015-02-01 01:01:33.000000', 'temperatura', 20.0000, 'ºC'),
	(350908, 146, '2015-02-01 01:01:34.000000', 'temperatura', 565.0000, 'ºC'),
	(350909, 146, '2015-02-01 01:01:35.000000', 'temperatura', 368.0000, 'ºC'),
	(350910, 146, '2015-02-01 01:01:36.000000', 'temperatura', 144.0000, 'ºC'),
	(350911, 146, '2015-02-01 01:01:37.000000', 'temperatura', 818.0000, 'ºC'),
	(350912, 146, '2015-02-01 01:01:38.000000', 'temperatura', 57.0000, 'ºC'),
	(350913, 146, '2015-02-01 01:01:39.000000', 'temperatura', 232.0000, 'ºC'),
	(350914, 146, '2015-02-01 01:01:40.000000', 'temperatura', 988.0000, 'ºC'),
	(350915, 146, '2015-02-01 01:01:41.000000', 'temperatura', 644.0000, 'ºC'),
	(350916, 146, '2015-02-01 01:01:42.000000', 'temperatura', 255.0000, 'ºC'),
	(350917, 146, '2015-02-01 01:01:43.000000', 'temperatura', 547.0000, 'ºC'),
	(350918, 146, '2015-02-01 01:01:44.000000', 'temperatura', 771.0000, 'ºC'),
	(350919, 146, '2015-02-01 01:01:45.000000', 'temperatura', 1014.0000, 'ºC'),
	(350920, 146, '2015-02-01 01:01:46.000000', 'temperatura', 357.0000, 'ºC'),
	(350921, 146, '2015-02-01 01:01:47.000000', 'temperatura', 1144.0000, 'ºC'),
	(350922, 146, '2015-02-01 01:01:48.000000', 'temperatura', 1050.0000, 'ºC'),
	(350923, 146, '2015-02-01 01:01:49.000000', 'temperatura', 619.0000, 'ºC'),
	(350924, 146, '2015-02-01 01:01:50.000000', 'temperatura', 1144.0000, 'ºC'),
	(350925, 146, '2015-02-01 01:01:51.000000', 'temperatura', 264.0000, 'ºC'),
	(350926, 146, '2015-02-01 01:01:52.000000', 'temperatura', 288.0000, 'ºC'),
	(350927, 146, '2015-02-01 01:01:53.000000', 'temperatura', 647.0000, 'ºC'),
	(350928, 146, '2015-02-01 01:01:54.000000', 'temperatura', 1172.0000, 'ºC'),
	(350929, 146, '2015-02-01 01:01:55.000000', 'temperatura', 318.0000, 'ºC'),
	(350930, 146, '2015-02-01 01:01:56.000000', 'temperatura', 478.0000, 'ºC'),
	(350931, 146, '2015-02-01 01:01:57.000000', 'temperatura', 234.0000, 'ºC'),
	(350932, 146, '2015-02-01 01:01:58.000000', 'temperatura', 938.0000, 'ºC'),
	(350933, 146, '2015-02-01 01:01:59.000000', 'temperatura', 387.0000, 'ºC'),
	(350934, 146, '2015-02-01 01:02:00.000000', 'temperatura', 324.0000, 'ºC'),
	(350935, 146, '2015-02-01 01:02:01.000000', 'temperatura', 459.0000, 'ºC'),
	(350936, 146, '2015-02-01 01:02:02.000000', 'temperatura', 125.0000, 'ºC'),
	(350937, 146, '2015-02-01 01:02:03.000000', 'temperatura', 446.0000, 'ºC'),
	(350938, 146, '2015-02-01 01:02:04.000000', 'temperatura', 657.0000, 'ºC'),
	(350939, 146, '2015-02-01 01:02:05.000000', 'temperatura', 747.0000, 'ºC'),
	(350940, 146, '2015-02-01 01:02:06.000000', 'temperatura', 566.0000, 'ºC'),
	(350941, 146, '2015-02-01 01:02:07.000000', 'temperatura', 588.0000, 'ºC'),
	(350942, 146, '2015-02-01 01:02:08.000000', 'temperatura', 43.0000, 'ºC'),
	(350943, 146, '2015-02-01 01:02:09.000000', 'temperatura', 852.0000, 'ºC'),
	(350944, 146, '2015-02-01 01:02:10.000000', 'temperatura', 533.0000, 'ºC'),
	(350945, 146, '2015-02-01 01:02:11.000000', 'temperatura', 109.0000, 'ºC'),
	(350946, 146, '2015-02-01 01:02:12.000000', 'temperatura', 144.0000, 'ºC'),
	(350947, 146, '2015-02-01 01:02:13.000000', 'temperatura', 397.0000, 'ºC'),
	(350948, 146, '2015-02-01 01:02:14.000000', 'temperatura', 350.0000, 'ºC'),
	(350949, 146, '2015-02-01 01:02:15.000000', 'temperatura', 563.0000, 'ºC'),
	(350950, 146, '2015-02-01 01:02:16.000000', 'temperatura', 563.0000, 'ºC'),
	(350951, 146, '2015-02-01 01:02:17.000000', 'temperatura', 1127.0000, 'ºC'),
	(350952, 146, '2015-02-01 01:02:18.000000', 'temperatura', 348.0000, 'ºC'),
	(350953, 146, '2015-02-01 01:02:19.000000', 'temperatura', 758.0000, 'ºC'),
	(350954, 146, '2015-02-01 01:02:20.000000', 'temperatura', 349.0000, 'ºC'),
	(350955, 146, '2015-02-01 01:02:21.000000', 'temperatura', 670.0000, 'ºC'),
	(350956, 146, '2015-02-01 01:02:22.000000', 'temperatura', 1104.0000, 'ºC'),
	(350957, 146, '2015-02-01 01:02:23.000000', 'temperatura', 1109.0000, 'ºC'),
	(350958, 146, '2015-02-01 01:02:24.000000', 'temperatura', 1033.0000, 'ºC'),
	(350959, 146, '2015-02-01 01:02:25.000000', 'temperatura', 641.0000, 'ºC'),
	(350960, 146, '2015-02-01 01:02:26.000000', 'temperatura', 107.0000, 'ºC'),
	(350961, 146, '2015-02-01 01:02:27.000000', 'temperatura', 1013.0000, 'ºC'),
	(350962, 146, '2015-02-01 01:02:28.000000', 'temperatura', 1142.0000, 'ºC'),
	(350963, 146, '2015-02-01 01:02:29.000000', 'temperatura', 274.0000, 'ºC'),
	(350964, 146, '2015-02-01 01:02:30.000000', 'temperatura', 342.0000, 'ºC'),
	(350965, 146, '2015-02-01 01:02:31.000000', 'temperatura', 889.0000, 'ºC'),
	(350966, 146, '2015-02-01 01:02:32.000000', 'temperatura', 1019.0000, 'ºC'),
	(350967, 146, '2015-02-01 01:02:33.000000', 'temperatura', 28.0000, 'ºC'),
	(350968, 146, '2015-02-01 01:02:34.000000', 'temperatura', 684.0000, 'ºC'),
	(350969, 146, '2015-02-01 01:02:35.000000', 'temperatura', 938.0000, 'ºC'),
	(350970, 146, '2015-02-01 01:02:36.000000', 'temperatura', 238.0000, 'ºC'),
	(350971, 146, '2015-02-01 01:02:37.000000', 'temperatura', 777.0000, 'ºC'),
	(350972, 146, '2015-02-01 01:02:38.000000', 'temperatura', 769.0000, 'ºC'),
	(350973, 146, '2015-02-01 01:02:39.000000', 'temperatura', 318.0000, 'ºC'),
	(350974, 146, '2015-02-01 01:02:40.000000', 'temperatura', 482.0000, 'ºC'),
	(350975, 146, '2015-02-01 01:02:41.000000', 'temperatura', 256.0000, 'ºC'),
	(350976, 146, '2015-02-01 01:02:42.000000', 'temperatura', 1035.0000, 'ºC'),
	(350977, 146, '2015-02-01 01:02:43.000000', 'temperatura', 806.0000, 'ºC'),
	(350978, 146, '2015-02-01 01:02:44.000000', 'temperatura', 929.0000, 'ºC'),
	(350979, 146, '2015-02-01 01:02:45.000000', 'temperatura', 1024.0000, 'ºC'),
	(350980, 146, '2015-02-01 01:02:46.000000', 'temperatura', 1134.0000, 'ºC'),
	(350981, 146, '2015-02-01 01:02:47.000000', 'temperatura', 198.0000, 'ºC'),
	(350982, 146, '2015-02-01 01:02:48.000000', 'temperatura', 1191.0000, 'ºC'),
	(350983, 146, '2015-02-01 01:02:49.000000', 'temperatura', 559.0000, 'ºC'),
	(350984, 146, '2015-02-01 01:02:50.000000', 'temperatura', 421.0000, 'ºC'),
	(350985, 146, '2015-02-01 01:02:51.000000', 'temperatura', 432.0000, 'ºC'),
	(350986, 146, '2015-02-01 01:02:52.000000', 'temperatura', 897.0000, 'ºC'),
	(350987, 146, '2015-02-01 01:02:53.000000', 'temperatura', 791.0000, 'ºC'),
	(350988, 146, '2015-02-01 01:02:54.000000', 'temperatura', 63.0000, 'ºC'),
	(350989, 146, '2015-02-01 01:02:55.000000', 'temperatura', 342.0000, 'ºC'),
	(350990, 146, '2015-02-01 01:02:56.000000', 'temperatura', 322.0000, 'ºC'),
	(350991, 146, '2015-02-01 01:02:57.000000', 'temperatura', 583.0000, 'ºC'),
	(350992, 146, '2015-02-01 01:02:58.000000', 'temperatura', 752.0000, 'ºC'),
	(350993, 146, '2015-02-01 01:02:59.000000', 'temperatura', 812.0000, 'ºC'),
	(350994, 146, '2015-02-01 01:03:00.000000', 'temperatura', 603.0000, 'ºC'),
	(350995, 146, '2015-02-01 01:03:01.000000', 'temperatura', 580.0000, 'ºC'),
	(350996, 146, '2015-02-01 01:03:02.000000', 'temperatura', 1091.0000, 'ºC'),
	(350997, 146, '2015-02-01 01:03:03.000000', 'temperatura', 116.0000, 'ºC'),
	(350998, 146, '2015-02-01 01:03:04.000000', 'temperatura', 908.0000, 'ºC'),
	(350999, 146, '2015-02-01 01:03:05.000000', 'temperatura', 594.0000, 'ºC'),
	(351000, 146, '2015-02-01 01:03:06.000000', 'temperatura', 245.0000, 'ºC'),
	(351001, 146, '2015-02-01 01:03:07.000000', 'temperatura', 645.0000, 'ºC'),
	(351002, 146, '2015-02-01 01:03:08.000000', 'temperatura', 90.0000, 'ºC'),
	(351003, 146, '2015-02-01 01:03:09.000000', 'temperatura', 916.0000, 'ºC'),
	(351004, 146, '2015-02-01 01:03:10.000000', 'temperatura', 712.0000, 'ºC'),
	(351005, 146, '2015-02-01 01:03:11.000000', 'temperatura', 809.0000, 'ºC'),
	(351006, 146, '2015-02-01 01:03:12.000000', 'temperatura', 712.0000, 'ºC'),
	(351007, 146, '2015-02-01 01:03:13.000000', 'temperatura', 1133.0000, 'ºC'),
	(351008, 146, '2015-02-01 01:03:14.000000', 'temperatura', 1128.0000, 'ºC'),
	(351009, 146, '2015-02-01 01:03:15.000000', 'temperatura', 1043.0000, 'ºC'),
	(351010, 146, '2015-02-01 01:03:16.000000', 'temperatura', 632.0000, 'ºC'),
	(351011, 146, '2015-02-01 01:03:17.000000', 'temperatura', 30.0000, 'ºC'),
	(351012, 146, '2015-02-01 01:03:18.000000', 'temperatura', 655.0000, 'ºC'),
	(351013, 146, '2015-02-01 01:03:19.000000', 'temperatura', 784.0000, 'ºC'),
	(351014, 146, '2015-02-01 01:03:20.000000', 'temperatura', 755.0000, 'ºC'),
	(351015, 146, '2015-02-01 01:03:21.000000', 'temperatura', 225.0000, 'ºC'),
	(351016, 146, '2015-02-01 01:03:22.000000', 'temperatura', 61.0000, 'ºC'),
	(351017, 146, '2015-02-01 01:03:23.000000', 'temperatura', 831.0000, 'ºC'),
	(351018, 146, '2015-02-01 01:03:24.000000', 'temperatura', 373.0000, 'ºC'),
	(351019, 146, '2015-02-01 01:03:25.000000', 'temperatura', 573.0000, 'ºC'),
	(351020, 146, '2015-02-01 01:03:26.000000', 'temperatura', 546.0000, 'ºC'),
	(351021, 146, '2015-02-01 01:03:27.000000', 'temperatura', 1013.0000, 'ºC'),
	(351022, 146, '2015-02-01 01:03:28.000000', 'temperatura', 1025.0000, 'ºC'),
	(351023, 146, '2015-02-01 01:03:29.000000', 'temperatura', 889.0000, 'ºC'),
	(351024, 146, '2015-02-01 01:03:30.000000', 'temperatura', 168.0000, 'ºC'),
	(351025, 146, '2015-02-01 01:03:31.000000', 'temperatura', 576.0000, 'ºC'),
	(351026, 146, '2015-02-01 01:03:32.000000', 'temperatura', 1176.0000, 'ºC'),
	(351027, 146, '2015-02-01 01:03:33.000000', 'temperatura', 554.0000, 'ºC'),
	(351028, 146, '2015-02-01 01:03:34.000000', 'temperatura', 441.0000, 'ºC'),
	(351029, 146, '2015-02-01 01:03:35.000000', 'temperatura', 545.0000, 'ºC'),
	(351030, 146, '2015-02-01 01:03:36.000000', 'temperatura', 200.0000, 'ºC'),
	(351031, 146, '2015-02-01 01:03:37.000000', 'temperatura', 568.0000, 'ºC'),
	(351032, 146, '2015-02-01 01:03:38.000000', 'temperatura', 1039.0000, 'ºC'),
	(351033, 146, '2015-02-01 01:03:39.000000', 'temperatura', 1093.0000, 'ºC'),
	(351034, 146, '2015-02-01 01:03:40.000000', 'temperatura', 1147.0000, 'ºC'),
	(351035, 146, '2015-02-01 01:03:41.000000', 'temperatura', 58.0000, 'ºC'),
	(351036, 146, '2015-02-01 01:03:42.000000', 'temperatura', 449.0000, 'ºC'),
	(351037, 146, '2015-02-01 01:03:43.000000', 'temperatura', 870.0000, 'ºC'),
	(351038, 146, '2015-02-01 01:03:44.000000', 'temperatura', 603.0000, 'ºC'),
	(351039, 146, '2015-02-01 01:03:45.000000', 'temperatura', 407.0000, 'ºC'),
	(351040, 146, '2015-02-01 01:03:46.000000', 'temperatura', 225.0000, 'ºC'),
	(351041, 146, '2015-02-01 01:03:47.000000', 'temperatura', 1106.0000, 'ºC'),
	(351042, 102, '2015-01-15 00:00:00.000000', 'consum', 0.0211, 'lps'),
	(351043, 102, '2015-01-15 00:00:01.000000', 'consum', 0.0215, 'lps'),
	(351044, 102, '2015-01-15 00:00:02.000000', 'consum', 0.0210, 'lps'),
	(351045, 102, '2015-01-15 00:00:03.000000', 'consum', 0.0214, 'lps'),
	(351046, 102, '2015-01-15 00:00:04.000000', 'consum', 0.0214, 'lps'),
	(351047, 102, '2015-01-15 00:00:05.000000', 'consum', 0.0217, 'lps'),
	(351048, 102, '2015-01-15 00:00:06.000000', 'consum', 0.0213, 'lps'),
	(351049, 102, '2015-01-15 00:00:07.000000', 'consum', 0.0215, 'lps'),
	(351050, 102, '2015-01-15 00:00:08.000000', 'consum', 0.0215, 'lps'),
	(351051, 102, '2015-01-15 00:00:09.000000', 'consum', 0.0213, 'lps'),
	(351052, 102, '2015-01-15 00:00:10.000000', 'consum', 0.0211, 'lps'),
	(351053, 102, '2015-01-15 00:00:11.000000', 'consum', 0.0215, 'lps'),
	(351054, 102, '2015-01-15 00:00:12.000000', 'consum', 0.0215, 'lps'),
	(351055, 102, '2015-01-15 00:00:13.000000', 'consum', 0.0218, 'lps'),
	(351056, 102, '2015-01-15 00:00:14.000000', 'consum', 0.0218, 'lps'),
	(351057, 102, '2015-01-15 00:00:15.000000', 'consum', 0.0216, 'lps'),
	(351058, 102, '2015-01-15 00:00:16.000000', 'consum', 0.0218, 'lps'),
	(351059, 102, '2015-01-15 00:00:17.000000', 'consum', 0.0211, 'lps'),
	(351060, 102, '2015-01-15 00:00:18.000000', 'consum', 0.0213, 'lps'),
	(351061, 102, '2015-01-15 00:00:19.000000', 'consum', 0.0212, 'lps'),
	(351062, 102, '2015-01-15 00:00:20.000000', 'consum', 0.0210, 'lps'),
	(351063, 102, '2015-01-15 00:00:21.000000', 'consum', 0.0214, 'lps'),
	(351064, 102, '2015-01-15 00:00:22.000000', 'consum', 0.0213, 'lps'),
	(351065, 102, '2015-01-15 00:00:23.000000', 'consum', 0.0213, 'lps'),
	(351066, 102, '2015-01-15 00:00:24.000000', 'consum', 0.0216, 'lps'),
	(351067, 102, '2015-01-15 00:00:25.000000', 'consum', 0.0212, 'lps'),
	(351068, 102, '2015-01-15 00:00:26.000000', 'consum', 0.0212, 'lps'),
	(351069, 102, '2015-01-15 00:00:27.000000', 'consum', 0.0213, 'lps'),
	(351070, 102, '2015-01-15 00:00:28.000000', 'consum', 0.0211, 'lps'),
	(351071, 102, '2015-01-15 00:00:29.000000', 'consum', 0.0217, 'lps'),
	(351072, 102, '2015-01-15 00:00:30.000000', 'consum', 0.0214, 'lps'),
	(351073, 102, '2015-01-15 00:00:31.000000', 'consum', 0.0219, 'lps'),
	(351074, 102, '2015-01-15 00:00:32.000000', 'consum', 0.0211, 'lps'),
	(351075, 102, '2015-01-15 00:00:33.000000', 'consum', 0.0211, 'lps'),
	(351076, 102, '2015-01-15 00:00:34.000000', 'consum', 0.0210, 'lps'),
	(351077, 102, '2015-01-15 00:00:35.000000', 'consum', 0.0217, 'lps'),
	(351078, 102, '2015-01-15 00:00:36.000000', 'consum', 0.0218, 'lps'),
	(351079, 102, '2015-01-15 00:00:37.000000', 'consum', 0.0219, 'lps'),
	(351080, 102, '2015-01-15 00:00:38.000000', 'consum', 0.0210, 'lps'),
	(351081, 102, '2015-01-15 00:00:39.000000', 'consum', 0.0216, 'lps'),
	(351082, 102, '2015-01-15 00:00:40.000000', 'consum', 0.0218, 'lps'),
	(351083, 102, '2015-01-15 00:00:41.000000', 'consum', 0.0215, 'lps'),
	(351084, 102, '2015-01-15 00:00:42.000000', 'consum', 0.0219, 'lps'),
	(351085, 102, '2015-01-15 00:00:43.000000', 'consum', 0.0211, 'lps'),
	(351086, 102, '2015-01-15 00:00:44.000000', 'consum', 0.0211, 'lps'),
	(351087, 102, '2015-01-15 00:00:45.000000', 'consum', 0.0210, 'lps'),
	(351088, 102, '2015-01-15 00:00:46.000000', 'consum', 0.0219, 'lps'),
	(351089, 102, '2015-01-15 00:00:47.000000', 'consum', 0.0213, 'lps'),
	(351090, 102, '2015-01-15 00:00:48.000000', 'consum', 0.0219, 'lps'),
	(351091, 102, '2015-01-15 00:00:49.000000', 'consum', 0.0218, 'lps'),
	(351092, 102, '2015-01-15 00:00:50.000000', 'consum', 0.0215, 'lps'),
	(351093, 102, '2015-01-15 00:00:51.000000', 'consum', 0.0210, 'lps'),
	(351094, 102, '2015-01-15 00:00:52.000000', 'consum', 0.0214, 'lps'),
	(351095, 102, '2015-01-15 00:00:53.000000', 'consum', 0.0213, 'lps'),
	(351096, 102, '2015-01-15 00:00:54.000000', 'consum', 0.0211, 'lps'),
	(351097, 102, '2015-01-15 00:00:55.000000', 'consum', 0.0217, 'lps'),
	(351098, 102, '2015-01-15 00:00:56.000000', 'consum', 0.0212, 'lps'),
	(351099, 102, '2015-01-15 00:00:57.000000', 'consum', 0.0210, 'lps'),
	(351100, 102, '2015-01-15 00:00:58.000000', 'consum', 0.0214, 'lps'),
	(351101, 102, '2015-01-15 00:00:59.000000', 'consum', 0.0212, 'lps'),
	(351102, 102, '2015-01-15 00:01:00.000000', 'consum', 0.0219, 'lps'),
	(351103, 102, '2015-01-15 00:01:01.000000', 'consum', 0.0219, 'lps'),
	(351104, 102, '2015-01-15 00:01:02.000000', 'consum', 0.0218, 'lps'),
	(351105, 102, '2015-01-15 00:01:03.000000', 'consum', 0.0212, 'lps'),
	(351106, 102, '2015-01-15 00:01:04.000000', 'consum', 0.0218, 'lps'),
	(351107, 102, '2015-01-15 00:01:05.000000', 'consum', 0.0212, 'lps'),
	(351108, 102, '2015-01-15 00:01:06.000000', 'consum', 0.0219, 'lps'),
	(351109, 102, '2015-01-15 00:01:07.000000', 'consum', 0.0210, 'lps'),
	(351110, 102, '2015-01-15 00:01:08.000000', 'consum', 0.0214, 'lps'),
	(351111, 102, '2015-01-15 00:01:09.000000', 'consum', 0.0211, 'lps'),
	(351112, 102, '2015-01-15 00:01:10.000000', 'consum', 0.0211, 'lps'),
	(351113, 102, '2015-01-15 00:01:11.000000', 'consum', 0.0214, 'lps'),
	(351114, 102, '2015-01-15 00:01:12.000000', 'consum', 0.0215, 'lps'),
	(351115, 102, '2015-01-15 00:01:13.000000', 'consum', 0.0217, 'lps'),
	(351116, 102, '2015-01-15 00:01:14.000000', 'consum', 0.0210, 'lps'),
	(351117, 102, '2015-01-15 00:01:15.000000', 'consum', 0.0218, 'lps'),
	(351118, 102, '2015-01-15 00:01:16.000000', 'consum', 0.0213, 'lps'),
	(351119, 102, '2015-01-15 00:01:17.000000', 'consum', 0.0211, 'lps'),
	(351120, 102, '2015-01-15 00:01:18.000000', 'consum', 0.0215, 'lps'),
	(351121, 102, '2015-01-15 00:01:19.000000', 'consum', 0.0213, 'lps'),
	(351122, 102, '2015-01-15 00:01:20.000000', 'consum', 0.0211, 'lps'),
	(351123, 102, '2015-01-15 00:01:21.000000', 'consum', 0.0217, 'lps'),
	(351124, 102, '2015-01-15 00:01:22.000000', 'consum', 0.0210, 'lps'),
	(351125, 102, '2015-01-15 00:01:23.000000', 'consum', 0.0211, 'lps'),
	(351126, 102, '2015-01-15 00:01:24.000000', 'consum', 0.0215, 'lps'),
	(351127, 102, '2015-01-15 00:01:25.000000', 'consum', 0.0215, 'lps'),
	(351128, 102, '2015-01-15 00:01:26.000000', 'consum', 0.0218, 'lps'),
	(351129, 102, '2015-01-15 00:01:27.000000', 'consum', 0.0216, 'lps'),
	(351130, 102, '2015-01-15 00:01:28.000000', 'consum', 0.0217, 'lps'),
	(351131, 102, '2015-01-15 00:01:29.000000', 'consum', 0.0218, 'lps'),
	(351132, 102, '2015-01-15 00:01:30.000000', 'consum', 0.0210, 'lps'),
	(351133, 102, '2015-01-15 00:01:31.000000', 'consum', 0.0218, 'lps'),
	(351134, 102, '2015-01-15 00:01:32.000000', 'consum', 0.0217, 'lps'),
	(351135, 102, '2015-01-15 00:01:33.000000', 'consum', 0.0215, 'lps'),
	(351136, 102, '2015-01-15 00:01:34.000000', 'consum', 0.0212, 'lps'),
	(351137, 102, '2015-01-15 00:01:35.000000', 'consum', 0.0215, 'lps'),
	(351138, 102, '2015-01-15 00:01:36.000000', 'consum', 0.0212, 'lps'),
	(351139, 102, '2015-01-15 00:01:37.000000', 'consum', 0.0216, 'lps'),
	(351140, 102, '2015-01-15 00:01:38.000000', 'consum', 0.0212, 'lps'),
	(351141, 102, '2015-01-15 00:01:39.000000', 'consum', 0.0212, 'lps'),
	(351142, 102, '2015-01-15 00:01:40.000000', 'consum', 0.0215, 'lps'),
	(351143, 102, '2015-01-15 00:01:41.000000', 'consum', 0.0210, 'lps'),
	(351144, 102, '2015-01-15 00:01:42.000000', 'consum', 0.0217, 'lps'),
	(351145, 102, '2015-01-15 00:01:43.000000', 'consum', 0.0214, 'lps'),
	(351146, 102, '2015-01-15 00:01:44.000000', 'consum', 0.0218, 'lps'),
	(351147, 102, '2015-01-15 00:01:45.000000', 'consum', 0.0219, 'lps'),
	(351148, 102, '2015-01-15 00:01:46.000000', 'consum', 0.0211, 'lps'),
	(351149, 102, '2015-01-15 00:01:47.000000', 'consum', 0.0219, 'lps'),
	(351150, 102, '2015-01-15 00:01:48.000000', 'consum', 0.0211, 'lps'),
	(351151, 102, '2015-01-15 00:01:49.000000', 'consum', 0.0211, 'lps'),
	(351152, 102, '2015-01-15 00:01:50.000000', 'consum', 0.0211, 'lps'),
	(351153, 102, '2015-01-15 00:01:51.000000', 'consum', 0.0214, 'lps'),
	(351154, 102, '2015-01-15 00:01:52.000000', 'consum', 0.0215, 'lps'),
	(351155, 102, '2015-01-15 00:01:53.000000', 'consum', 0.0216, 'lps'),
	(351156, 102, '2015-01-15 00:01:54.000000', 'consum', 0.0215, 'lps'),
	(351157, 102, '2015-01-15 00:01:55.000000', 'consum', 0.0219, 'lps'),
	(351158, 102, '2015-01-15 00:01:56.000000', 'consum', 0.0217, 'lps'),
	(351159, 102, '2015-01-15 00:01:57.000000', 'consum', 0.0211, 'lps'),
	(351160, 102, '2015-01-15 00:01:58.000000', 'consum', 0.0215, 'lps'),
	(351161, 102, '2015-01-15 00:01:59.000000', 'consum', 0.0210, 'lps'),
	(351162, 102, '2015-01-15 00:02:00.000000', 'consum', 0.0216, 'lps'),
	(351163, 102, '2015-01-15 00:02:01.000000', 'consum', 0.0210, 'lps'),
	(351164, 102, '2015-01-15 00:02:02.000000', 'consum', 0.0215, 'lps'),
	(351165, 102, '2015-01-15 00:02:03.000000', 'consum', 0.0213, 'lps'),
	(351166, 102, '2015-01-15 00:02:04.000000', 'consum', 0.0212, 'lps'),
	(351167, 102, '2015-01-15 00:02:05.000000', 'consum', 0.0219, 'lps'),
	(351168, 102, '2015-01-15 00:02:06.000000', 'consum', 0.0211, 'lps'),
	(351169, 102, '2015-01-15 00:02:07.000000', 'consum', 0.0218, 'lps'),
	(351170, 102, '2015-01-15 00:02:08.000000', 'consum', 0.0218, 'lps'),
	(351171, 102, '2015-01-15 00:02:09.000000', 'consum', 0.0214, 'lps'),
	(351172, 102, '2015-01-15 00:02:10.000000', 'consum', 0.0210, 'lps'),
	(351173, 102, '2015-01-15 00:02:11.000000', 'consum', 0.0216, 'lps'),
	(351174, 102, '2015-01-15 00:02:12.000000', 'consum', 0.0210, 'lps'),
	(351175, 102, '2015-01-15 00:02:13.000000', 'consum', 0.0214, 'lps'),
	(351176, 102, '2015-01-15 00:02:14.000000', 'consum', 0.0210, 'lps'),
	(351177, 102, '2015-01-15 00:02:15.000000', 'consum', 0.0210, 'lps'),
	(351178, 102, '2015-01-15 00:02:16.000000', 'consum', 0.0219, 'lps'),
	(351179, 102, '2015-01-15 00:02:17.000000', 'consum', 0.0218, 'lps'),
	(351180, 102, '2015-01-15 00:02:18.000000', 'consum', 0.0210, 'lps'),
	(351181, 102, '2015-01-15 00:02:19.000000', 'consum', 0.0218, 'lps'),
	(351182, 102, '2015-01-15 00:02:20.000000', 'consum', 0.0212, 'lps'),
	(351183, 102, '2015-01-15 00:02:21.000000', 'consum', 0.0216, 'lps'),
	(351184, 102, '2015-01-15 00:02:22.000000', 'consum', 0.0216, 'lps'),
	(351185, 102, '2015-01-15 00:02:23.000000', 'consum', 0.0219, 'lps'),
	(351186, 102, '2015-01-15 00:02:24.000000', 'consum', 0.0211, 'lps'),
	(351187, 102, '2015-01-15 00:02:25.000000', 'consum', 0.0216, 'lps'),
	(351188, 102, '2015-01-15 00:02:26.000000', 'consum', 0.0219, 'lps'),
	(351189, 102, '2015-01-15 00:02:27.000000', 'consum', 0.0216, 'lps'),
	(351190, 102, '2015-01-15 00:02:28.000000', 'consum', 0.0213, 'lps'),
	(351191, 102, '2015-01-15 00:02:29.000000', 'consum', 0.0219, 'lps'),
	(351192, 102, '2015-01-15 00:02:30.000000', 'consum', 0.0215, 'lps'),
	(351193, 102, '2015-01-15 00:02:31.000000', 'consum', 0.0218, 'lps'),
	(351194, 102, '2015-01-15 00:02:32.000000', 'consum', 0.0217, 'lps'),
	(351195, 102, '2015-01-15 00:02:33.000000', 'consum', 0.0210, 'lps'),
	(351196, 102, '2015-01-15 00:02:34.000000', 'consum', 0.0210, 'lps'),
	(351197, 102, '2015-01-15 00:02:35.000000', 'consum', 0.0212, 'lps'),
	(351198, 102, '2015-01-15 00:02:36.000000', 'consum', 0.0218, 'lps'),
	(351199, 102, '2015-01-15 00:02:37.000000', 'consum', 0.0216, 'lps'),
	(351200, 102, '2015-01-15 00:02:38.000000', 'consum', 0.0217, 'lps'),
	(351201, 102, '2015-01-15 00:02:39.000000', 'consum', 0.0215, 'lps'),
	(351202, 102, '2015-01-15 00:02:40.000000', 'consum', 0.0217, 'lps'),
	(351203, 102, '2015-01-15 00:02:41.000000', 'consum', 0.0211, 'lps'),
	(351204, 102, '2015-01-15 00:02:42.000000', 'consum', 0.0214, 'lps'),
	(351205, 102, '2015-01-15 00:02:43.000000', 'consum', 0.0216, 'lps'),
	(351206, 102, '2015-01-15 00:02:44.000000', 'consum', 0.0219, 'lps'),
	(351207, 102, '2015-01-15 00:02:45.000000', 'consum', 0.0218, 'lps'),
	(351208, 102, '2015-01-15 00:02:46.000000', 'consum', 0.0212, 'lps'),
	(351209, 102, '2015-01-15 00:02:47.000000', 'consum', 0.0217, 'lps'),
	(351210, 102, '2015-01-15 00:02:48.000000', 'consum', 0.0211, 'lps'),
	(351211, 102, '2015-01-15 00:02:49.000000', 'consum', 0.0215, 'lps'),
	(351212, 102, '2015-01-15 00:02:50.000000', 'consum', 0.0211, 'lps'),
	(351213, 102, '2015-01-15 00:02:51.000000', 'consum', 0.0212, 'lps'),
	(351214, 102, '2015-01-15 00:02:52.000000', 'consum', 0.0215, 'lps'),
	(351215, 102, '2015-01-15 00:02:53.000000', 'consum', 0.0210, 'lps'),
	(351216, 102, '2015-01-15 00:02:54.000000', 'consum', 0.0217, 'lps'),
	(351217, 102, '2015-01-15 00:02:55.000000', 'consum', 0.0216, 'lps'),
	(351218, 102, '2015-01-15 00:02:56.000000', 'consum', 0.0219, 'lps'),
	(351219, 102, '2015-01-15 00:02:57.000000', 'consum', 0.0218, 'lps'),
	(351220, 102, '2015-01-15 00:02:58.000000', 'consum', 0.0213, 'lps'),
	(351221, 102, '2015-01-15 00:02:59.000000', 'consum', 0.0212, 'lps'),
	(351222, 102, '2015-01-15 00:03:00.000000', 'consum', 0.0210, 'lps'),
	(351223, 102, '2015-01-15 00:03:01.000000', 'consum', 0.0216, 'lps'),
	(351224, 102, '2015-01-15 00:03:02.000000', 'consum', 0.0212, 'lps'),
	(351225, 102, '2015-01-15 00:03:03.000000', 'consum', 0.0212, 'lps'),
	(351226, 102, '2015-01-15 00:03:04.000000', 'consum', 0.0212, 'lps'),
	(351227, 102, '2015-01-15 00:03:05.000000', 'consum', 0.0215, 'lps'),
	(351228, 102, '2015-01-15 00:03:06.000000', 'consum', 0.0211, 'lps'),
	(351229, 102, '2015-01-15 00:03:07.000000', 'consum', 0.0218, 'lps'),
	(351230, 102, '2015-01-15 00:03:08.000000', 'consum', 0.0210, 'lps'),
	(351231, 102, '2015-01-15 00:03:09.000000', 'consum', 0.0216, 'lps'),
	(351232, 102, '2015-01-15 00:03:10.000000', 'consum', 0.0212, 'lps'),
	(351233, 102, '2015-01-15 00:03:11.000000', 'consum', 0.0212, 'lps'),
	(351234, 102, '2015-01-15 00:03:12.000000', 'consum', 0.0213, 'lps'),
	(351235, 102, '2015-01-15 00:03:13.000000', 'consum', 0.0219, 'lps'),
	(351236, 102, '2015-01-15 00:03:14.000000', 'consum', 0.0216, 'lps'),
	(351237, 102, '2015-01-15 00:03:15.000000', 'consum', 0.0214, 'lps'),
	(351238, 102, '2015-01-15 00:03:16.000000', 'consum', 0.0211, 'lps'),
	(351239, 102, '2015-01-15 00:03:17.000000', 'consum', 0.0215, 'lps'),
	(351240, 102, '2015-01-15 00:03:18.000000', 'consum', 0.0212, 'lps'),
	(351241, 102, '2015-01-15 00:03:19.000000', 'consum', 0.0214, 'lps'),
	(351242, 102, '2015-01-15 00:03:20.000000', 'consum', 0.0217, 'lps'),
	(351243, 102, '2015-01-15 00:03:21.000000', 'consum', 0.0213, 'lps'),
	(351244, 102, '2015-01-15 00:03:22.000000', 'consum', 0.0214, 'lps'),
	(351245, 102, '2015-01-15 00:03:23.000000', 'consum', 0.0210, 'lps'),
	(351246, 102, '2015-01-15 00:03:24.000000', 'consum', 0.0219, 'lps'),
	(351247, 102, '2015-01-15 00:03:25.000000', 'consum', 0.0215, 'lps'),
	(351248, 102, '2015-01-15 00:03:26.000000', 'consum', 0.0211, 'lps'),
	(351249, 102, '2015-01-15 00:03:27.000000', 'consum', 0.0219, 'lps'),
	(351250, 102, '2015-01-15 00:03:28.000000', 'consum', 0.0213, 'lps'),
	(351251, 102, '2015-01-15 00:03:29.000000', 'consum', 0.0210, 'lps'),
	(351252, 102, '2015-01-15 00:03:30.000000', 'consum', 0.0212, 'lps'),
	(351253, 102, '2015-01-15 00:03:31.000000', 'consum', 0.0219, 'lps'),
	(351254, 102, '2015-01-15 00:03:32.000000', 'consum', 0.0210, 'lps'),
	(351255, 102, '2015-01-15 00:03:33.000000', 'consum', 0.0215, 'lps'),
	(351256, 102, '2015-01-15 00:03:34.000000', 'consum', 0.0213, 'lps'),
	(351257, 102, '2015-01-15 00:03:35.000000', 'consum', 0.0211, 'lps'),
	(351258, 102, '2015-01-15 00:03:36.000000', 'consum', 0.0216, 'lps'),
	(351259, 102, '2015-01-15 00:03:37.000000', 'consum', 0.0217, 'lps'),
	(351260, 102, '2015-01-15 00:03:38.000000', 'consum', 0.0219, 'lps'),
	(351261, 102, '2015-01-15 00:03:39.000000', 'consum', 0.0214, 'lps'),
	(351262, 102, '2015-01-15 00:03:40.000000', 'consum', 0.0215, 'lps'),
	(351263, 102, '2015-01-15 00:03:41.000000', 'consum', 0.0212, 'lps'),
	(351264, 102, '2015-01-15 00:03:42.000000', 'consum', 0.0217, 'lps'),
	(351265, 102, '2015-01-15 00:03:43.000000', 'consum', 0.0218, 'lps'),
	(351266, 102, '2015-01-15 00:03:44.000000', 'consum', 0.0218, 'lps'),
	(351267, 102, '2015-01-15 00:03:45.000000', 'consum', 0.0219, 'lps'),
	(351268, 102, '2015-01-15 00:03:46.000000', 'consum', 0.0212, 'lps'),
	(351269, 102, '2015-01-15 00:03:47.000000', 'consum', 0.0214, 'lps'),
	(351270, 102, '2015-01-15 00:03:48.000000', 'consum', 0.0214, 'lps'),
	(351271, 102, '2015-01-15 00:03:49.000000', 'consum', 0.0219, 'lps'),
	(351272, 102, '2015-01-15 00:03:50.000000', 'consum', 0.0212, 'lps'),
	(351273, 102, '2015-01-15 00:03:51.000000', 'consum', 0.0214, 'lps'),
	(351274, 102, '2015-01-15 00:03:52.000000', 'consum', 0.0214, 'lps'),
	(351275, 102, '2015-01-15 00:03:53.000000', 'consum', 0.0218, 'lps'),
	(351276, 102, '2015-01-15 00:03:54.000000', 'consum', 0.0217, 'lps'),
	(351277, 102, '2015-01-15 00:03:55.000000', 'consum', 0.0213, 'lps'),
	(351278, 102, '2015-01-15 00:03:56.000000', 'consum', 0.0215, 'lps'),
	(351279, 102, '2015-01-15 00:03:57.000000', 'consum', 0.0214, 'lps'),
	(351280, 102, '2015-01-15 00:03:58.000000', 'consum', 0.0218, 'lps'),
	(351281, 102, '2015-01-15 00:03:59.000000', 'consum', 0.0217, 'lps'),
	(351282, 102, '2015-01-15 00:04:00.000000', 'consum', 0.0211, 'lps'),
	(351283, 102, '2015-01-15 00:04:01.000000', 'consum', 0.0215, 'lps'),
	(351284, 102, '2015-01-15 00:04:02.000000', 'consum', 0.0213, 'lps'),
	(351285, 102, '2015-01-15 00:04:03.000000', 'consum', 0.0219, 'lps'),
	(351286, 102, '2015-01-15 00:04:04.000000', 'consum', 0.0219, 'lps'),
	(351287, 102, '2015-01-15 00:04:05.000000', 'consum', 0.0215, 'lps'),
	(351288, 102, '2015-01-15 00:04:06.000000', 'consum', 0.0212, 'lps'),
	(351289, 102, '2015-01-15 00:04:07.000000', 'consum', 0.0213, 'lps'),
	(351290, 102, '2015-01-15 00:04:08.000000', 'consum', 0.0210, 'lps'),
	(351291, 102, '2015-01-15 00:04:09.000000', 'consum', 0.0210, 'lps'),
	(351292, 102, '2015-01-15 00:04:10.000000', 'consum', 0.0211, 'lps'),
	(351293, 102, '2015-01-15 00:04:11.000000', 'consum', 0.0215, 'lps'),
	(351294, 102, '2015-01-15 00:04:12.000000', 'consum', 0.0212, 'lps'),
	(351295, 102, '2015-01-15 00:04:13.000000', 'consum', 0.0217, 'lps'),
	(351296, 102, '2015-01-15 00:04:14.000000', 'consum', 0.0211, 'lps'),
	(351297, 102, '2015-01-15 00:04:15.000000', 'consum', 0.0212, 'lps'),
	(351298, 102, '2015-01-15 00:04:16.000000', 'consum', 0.0210, 'lps'),
	(351299, 102, '2015-01-15 00:04:17.000000', 'consum', 0.0214, 'lps'),
	(351300, 102, '2015-01-15 00:04:18.000000', 'consum', 0.0210, 'lps'),
	(351301, 102, '2015-01-15 00:04:19.000000', 'consum', 0.0210, 'lps'),
	(351302, 102, '2015-01-15 00:04:20.000000', 'consum', 0.0211, 'lps'),
	(351303, 102, '2015-01-15 00:04:21.000000', 'consum', 0.0213, 'lps'),
	(351304, 102, '2015-01-15 00:04:22.000000', 'consum', 0.0212, 'lps'),
	(351305, 102, '2015-01-15 00:04:23.000000', 'consum', 0.0210, 'lps'),
	(351306, 102, '2015-01-15 00:04:24.000000', 'consum', 0.0218, 'lps'),
	(351307, 102, '2015-01-15 00:04:25.000000', 'consum', 0.0211, 'lps'),
	(351308, 102, '2015-01-15 00:04:26.000000', 'consum', 0.0218, 'lps'),
	(351309, 102, '2015-01-15 00:04:27.000000', 'consum', 0.0210, 'lps'),
	(351310, 102, '2015-01-15 00:04:28.000000', 'consum', 0.0216, 'lps'),
	(351311, 102, '2015-01-15 00:04:29.000000', 'consum', 0.0210, 'lps'),
	(351312, 102, '2015-01-15 00:04:30.000000', 'consum', 0.0213, 'lps'),
	(351313, 102, '2015-01-15 00:04:31.000000', 'consum', 0.0215, 'lps'),
	(351314, 102, '2015-01-15 00:04:32.000000', 'consum', 0.0216, 'lps'),
	(351315, 102, '2015-01-15 00:04:33.000000', 'consum', 0.0214, 'lps'),
	(351316, 102, '2015-01-15 00:04:34.000000', 'consum', 0.0215, 'lps'),
	(351317, 102, '2015-01-15 00:04:35.000000', 'consum', 0.0211, 'lps'),
	(351318, 102, '2015-01-15 00:04:36.000000', 'consum', 0.0211, 'lps'),
	(351319, 102, '2015-01-15 00:04:37.000000', 'consum', 0.0212, 'lps'),
	(351320, 102, '2015-01-15 00:04:38.000000', 'consum', 0.0210, 'lps'),
	(351321, 102, '2015-01-15 00:04:39.000000', 'consum', 0.0214, 'lps'),
	(351322, 102, '2015-01-15 00:04:40.000000', 'consum', 0.0219, 'lps'),
	(351323, 102, '2015-01-15 00:04:41.000000', 'consum', 0.0215, 'lps'),
	(351324, 102, '2015-01-15 00:04:42.000000', 'consum', 0.0219, 'lps'),
	(351325, 102, '2015-01-15 00:04:43.000000', 'consum', 0.0212, 'lps'),
	(351326, 102, '2015-01-15 00:04:44.000000', 'consum', 0.0211, 'lps'),
	(351327, 102, '2015-01-15 00:04:45.000000', 'consum', 0.0218, 'lps'),
	(351328, 102, '2015-01-15 00:04:46.000000', 'consum', 0.0211, 'lps'),
	(351329, 102, '2015-01-15 00:04:47.000000', 'consum', 0.0218, 'lps'),
	(351330, 102, '2015-01-15 00:04:48.000000', 'consum', 0.0211, 'lps'),
	(351331, 102, '2015-01-15 00:04:49.000000', 'consum', 0.0210, 'lps'),
	(351332, 102, '2015-01-15 00:04:50.000000', 'consum', 0.0218, 'lps'),
	(351333, 102, '2015-01-15 00:04:51.000000', 'consum', 0.0211, 'lps'),
	(351334, 102, '2015-01-15 00:04:52.000000', 'consum', 0.0210, 'lps'),
	(351335, 102, '2015-01-15 00:04:53.000000', 'consum', 0.0219, 'lps'),
	(351336, 102, '2015-01-15 00:04:54.000000', 'consum', 0.0215, 'lps'),
	(351337, 102, '2015-01-15 00:04:55.000000', 'consum', 0.0210, 'lps'),
	(351338, 102, '2015-01-15 00:04:56.000000', 'consum', 0.0214, 'lps'),
	(351339, 102, '2015-01-15 00:04:57.000000', 'consum', 0.0212, 'lps'),
	(351340, 102, '2015-01-15 00:04:58.000000', 'consum', 0.0216, 'lps'),
	(351341, 102, '2015-01-15 00:04:59.000000', 'consum', 0.0216, 'lps'),
	(351342, 102, '2015-01-15 00:05:00.000000', 'consum', 0.0213, 'lps'),
	(351343, 102, '2015-01-15 00:05:01.000000', 'consum', 0.0218, 'lps'),
	(351344, 102, '2015-01-15 00:05:02.000000', 'consum', 0.0210, 'lps'),
	(351345, 102, '2015-01-15 00:05:03.000000', 'consum', 0.0217, 'lps'),
	(351346, 102, '2015-01-15 00:05:04.000000', 'consum', 0.0217, 'lps'),
	(351347, 102, '2015-01-15 00:05:05.000000', 'consum', 0.0215, 'lps'),
	(351348, 102, '2015-01-15 00:05:06.000000', 'consum', 0.0215, 'lps'),
	(351349, 102, '2015-01-15 00:05:07.000000', 'consum', 0.0210, 'lps'),
	(351350, 102, '2015-01-15 00:05:08.000000', 'consum', 0.0215, 'lps'),
	(351351, 102, '2015-01-15 00:05:09.000000', 'consum', 0.0215, 'lps'),
	(351352, 102, '2015-01-15 00:05:10.000000', 'consum', 0.0210, 'lps'),
	(351353, 102, '2015-01-15 00:05:11.000000', 'consum', 0.0217, 'lps'),
	(351354, 102, '2015-01-15 00:05:12.000000', 'consum', 0.0214, 'lps'),
	(351355, 102, '2015-01-15 00:05:13.000000', 'consum', 0.0211, 'lps'),
	(351356, 102, '2015-01-15 00:05:14.000000', 'consum', 0.0213, 'lps'),
	(351357, 102, '2015-01-15 00:05:15.000000', 'consum', 0.0214, 'lps'),
	(351358, 102, '2015-01-15 00:05:16.000000', 'consum', 0.0212, 'lps'),
	(351359, 102, '2015-01-15 00:05:17.000000', 'consum', 0.0219, 'lps'),
	(351360, 102, '2015-01-15 00:05:18.000000', 'consum', 0.0219, 'lps'),
	(351361, 102, '2015-01-15 00:05:19.000000', 'consum', 0.0216, 'lps'),
	(351362, 102, '2015-01-15 00:05:20.000000', 'consum', 0.0217, 'lps'),
	(351363, 102, '2015-01-15 00:05:21.000000', 'consum', 0.0215, 'lps'),
	(351364, 102, '2015-01-15 00:05:22.000000', 'consum', 0.0216, 'lps'),
	(351365, 102, '2015-01-15 00:05:23.000000', 'consum', 0.0217, 'lps'),
	(351366, 102, '2015-01-15 00:05:24.000000', 'consum', 0.0217, 'lps'),
	(351367, 102, '2015-01-15 00:05:25.000000', 'consum', 0.0212, 'lps'),
	(351368, 102, '2015-01-15 00:05:26.000000', 'consum', 0.0212, 'lps'),
	(351369, 102, '2015-01-15 00:05:27.000000', 'consum', 0.0212, 'lps'),
	(351370, 102, '2015-01-15 00:05:28.000000', 'consum', 0.0215, 'lps'),
	(351371, 102, '2015-01-15 00:05:29.000000', 'consum', 0.0219, 'lps'),
	(351372, 102, '2015-01-15 00:05:30.000000', 'consum', 0.0219, 'lps'),
	(351373, 102, '2015-01-15 00:05:31.000000', 'consum', 0.0212, 'lps'),
	(351374, 102, '2015-01-15 00:05:32.000000', 'consum', 0.0212, 'lps'),
	(351375, 102, '2015-01-15 00:05:33.000000', 'consum', 0.0215, 'lps'),
	(351376, 102, '2015-01-15 00:05:34.000000', 'consum', 0.0210, 'lps'),
	(351377, 102, '2015-01-15 00:05:35.000000', 'consum', 0.0214, 'lps'),
	(351378, 102, '2015-01-15 00:05:36.000000', 'consum', 0.0211, 'lps'),
	(351379, 102, '2015-01-15 00:05:37.000000', 'consum', 0.0213, 'lps'),
	(351380, 102, '2015-01-15 00:05:38.000000', 'consum', 0.0211, 'lps'),
	(351381, 102, '2015-01-15 00:05:39.000000', 'consum', 0.0210, 'lps'),
	(351382, 102, '2015-01-15 00:05:40.000000', 'consum', 0.0215, 'lps'),
	(351383, 102, '2015-01-15 00:05:41.000000', 'consum', 0.0215, 'lps'),
	(351384, 102, '2015-01-15 00:05:42.000000', 'consum', 0.0210, 'lps'),
	(351385, 102, '2015-01-15 00:05:43.000000', 'consum', 0.0218, 'lps'),
	(351386, 102, '2015-01-15 00:05:44.000000', 'consum', 0.0218, 'lps'),
	(351387, 102, '2015-01-15 00:05:45.000000', 'consum', 0.0217, 'lps'),
	(351388, 102, '2015-01-15 00:05:46.000000', 'consum', 0.0210, 'lps'),
	(351389, 102, '2015-01-15 00:05:47.000000', 'consum', 0.0212, 'lps'),
	(351390, 102, '2015-01-15 00:05:48.000000', 'consum', 0.0211, 'lps'),
	(351391, 102, '2015-01-15 00:05:49.000000', 'consum', 0.0218, 'lps'),
	(351392, 102, '2015-01-15 00:05:50.000000', 'consum', 0.0219, 'lps'),
	(351393, 102, '2015-01-15 00:05:51.000000', 'consum', 0.0211, 'lps'),
	(351394, 102, '2015-01-15 00:05:52.000000', 'consum', 0.0210, 'lps'),
	(351395, 102, '2015-01-15 00:05:53.000000', 'consum', 0.0216, 'lps'),
	(351396, 102, '2015-01-15 00:05:54.000000', 'consum', 0.0212, 'lps'),
	(351397, 102, '2015-01-15 00:05:55.000000', 'consum', 0.0212, 'lps'),
	(351398, 102, '2015-01-15 00:05:56.000000', 'consum', 0.0214, 'lps'),
	(351399, 102, '2015-01-15 00:05:57.000000', 'consum', 0.0213, 'lps'),
	(351400, 102, '2015-01-15 00:05:58.000000', 'consum', 0.0214, 'lps'),
	(351401, 102, '2015-01-15 00:05:59.000000', 'consum', 0.0211, 'lps'),
	(351402, 102, '2015-01-15 00:06:00.000000', 'consum', 0.0216, 'lps'),
	(351403, 102, '2015-01-15 00:06:01.000000', 'consum', 0.0217, 'lps'),
	(351404, 102, '2015-01-15 00:06:02.000000', 'consum', 0.0217, 'lps'),
	(351405, 102, '2015-01-15 00:06:03.000000', 'consum', 0.0214, 'lps'),
	(351406, 102, '2015-01-15 00:06:04.000000', 'consum', 0.0211, 'lps'),
	(351407, 102, '2015-01-15 00:06:05.000000', 'consum', 0.0215, 'lps'),
	(351408, 102, '2015-01-15 00:06:06.000000', 'consum', 0.0219, 'lps'),
	(351409, 102, '2015-01-15 00:06:07.000000', 'consum', 0.0212, 'lps'),
	(351410, 102, '2015-01-15 00:06:08.000000', 'consum', 0.0215, 'lps'),
	(351411, 102, '2015-01-15 00:06:09.000000', 'consum', 0.0210, 'lps'),
	(351412, 102, '2015-01-15 00:06:10.000000', 'consum', 0.0215, 'lps'),
	(351413, 102, '2015-01-15 00:06:11.000000', 'consum', 0.0215, 'lps'),
	(351414, 102, '2015-01-15 00:06:12.000000', 'consum', 0.0212, 'lps'),
	(351415, 102, '2015-01-15 00:06:13.000000', 'consum', 0.0213, 'lps'),
	(351416, 102, '2015-01-15 00:06:14.000000', 'consum', 0.0211, 'lps'),
	(351417, 102, '2015-01-15 00:06:15.000000', 'consum', 0.0216, 'lps'),
	(351418, 102, '2015-01-15 00:06:16.000000', 'consum', 0.0217, 'lps'),
	(351419, 102, '2015-01-15 00:06:17.000000', 'consum', 0.0218, 'lps'),
	(351420, 102, '2015-01-15 00:06:18.000000', 'consum', 0.0210, 'lps'),
	(351421, 102, '2015-01-15 00:06:19.000000', 'consum', 0.0217, 'lps'),
	(351422, 102, '2015-01-15 00:06:20.000000', 'consum', 0.0213, 'lps'),
	(351423, 102, '2015-01-15 00:06:21.000000', 'consum', 0.0215, 'lps'),
	(351424, 102, '2015-01-15 00:06:22.000000', 'consum', 0.0217, 'lps'),
	(351425, 102, '2015-01-15 00:06:23.000000', 'consum', 0.0210, 'lps'),
	(351426, 102, '2015-01-15 00:06:24.000000', 'consum', 0.0219, 'lps'),
	(351427, 102, '2015-01-15 00:06:25.000000', 'consum', 0.0215, 'lps'),
	(351428, 102, '2015-01-15 00:06:26.000000', 'consum', 0.0210, 'lps'),
	(351429, 102, '2015-01-15 00:06:27.000000', 'consum', 0.0215, 'lps'),
	(351430, 102, '2015-01-15 00:06:28.000000', 'consum', 0.0213, 'lps'),
	(351431, 102, '2015-01-15 00:06:29.000000', 'consum', 0.0214, 'lps'),
	(351432, 102, '2015-01-15 00:06:30.000000', 'consum', 0.0211, 'lps'),
	(351433, 102, '2015-01-15 00:06:31.000000', 'consum', 0.0213, 'lps'),
	(351434, 102, '2015-01-15 00:06:32.000000', 'consum', 0.0213, 'lps'),
	(351435, 102, '2015-01-15 00:06:33.000000', 'consum', 0.0215, 'lps'),
	(351436, 102, '2015-01-15 00:06:34.000000', 'consum', 0.0217, 'lps'),
	(351437, 102, '2015-01-15 00:06:35.000000', 'consum', 0.0210, 'lps'),
	(351438, 102, '2015-01-15 00:06:36.000000', 'consum', 0.0219, 'lps'),
	(351439, 102, '2015-01-15 00:06:37.000000', 'consum', 0.0214, 'lps'),
	(351440, 102, '2015-01-15 00:06:38.000000', 'consum', 0.0216, 'lps'),
	(351441, 102, '2015-01-15 00:06:39.000000', 'consum', 0.0218, 'lps'),
	(351442, 102, '2015-01-15 00:06:40.000000', 'consum', 0.0211, 'lps'),
	(351443, 102, '2015-01-15 00:06:41.000000', 'consum', 0.0214, 'lps'),
	(351444, 102, '2015-01-15 00:06:42.000000', 'consum', 0.0218, 'lps'),
	(351445, 102, '2015-01-15 00:06:43.000000', 'consum', 0.0216, 'lps'),
	(351446, 102, '2015-01-15 00:06:44.000000', 'consum', 0.0217, 'lps'),
	(351447, 102, '2015-01-15 00:06:45.000000', 'consum', 0.0216, 'lps'),
	(351448, 102, '2015-01-15 00:06:46.000000', 'consum', 0.0211, 'lps'),
	(351449, 102, '2015-01-15 00:06:47.000000', 'consum', 0.0217, 'lps'),
	(351450, 102, '2015-01-15 00:06:48.000000', 'consum', 0.0213, 'lps'),
	(351451, 102, '2015-01-15 00:06:49.000000', 'consum', 0.0215, 'lps'),
	(351452, 102, '2015-01-15 00:06:50.000000', 'consum', 0.0215, 'lps'),
	(351453, 102, '2015-01-15 00:06:51.000000', 'consum', 0.0212, 'lps'),
	(351454, 102, '2015-01-15 00:06:52.000000', 'consum', 0.0214, 'lps'),
	(351455, 102, '2015-01-15 00:06:53.000000', 'consum', 0.0214, 'lps'),
	(351456, 102, '2015-01-15 00:06:54.000000', 'consum', 0.0211, 'lps'),
	(351457, 102, '2015-01-15 00:06:55.000000', 'consum', 0.0212, 'lps'),
	(351458, 102, '2015-01-15 00:06:56.000000', 'consum', 0.0218, 'lps'),
	(351459, 102, '2015-01-15 00:06:57.000000', 'consum', 0.0214, 'lps'),
	(351460, 102, '2015-01-15 00:06:58.000000', 'consum', 0.0217, 'lps'),
	(351461, 102, '2015-01-15 00:06:59.000000', 'consum', 0.0214, 'lps'),
	(351462, 102, '2015-01-15 00:07:00.000000', 'consum', 0.0211, 'lps'),
	(351463, 102, '2015-01-15 00:07:01.000000', 'consum', 0.0211, 'lps'),
	(351464, 102, '2015-01-15 00:07:02.000000', 'consum', 0.0215, 'lps'),
	(351465, 102, '2015-01-15 00:07:03.000000', 'consum', 0.0219, 'lps'),
	(351466, 102, '2015-01-15 00:07:04.000000', 'consum', 0.0213, 'lps'),
	(351467, 102, '2015-01-15 00:07:05.000000', 'consum', 0.0218, 'lps'),
	(351468, 102, '2015-01-15 00:07:06.000000', 'consum', 0.0212, 'lps'),
	(351469, 102, '2015-01-15 00:07:07.000000', 'consum', 0.0216, 'lps'),
	(351470, 102, '2015-01-15 00:07:08.000000', 'consum', 0.0215, 'lps'),
	(351471, 102, '2015-01-15 00:07:09.000000', 'consum', 0.0218, 'lps'),
	(351472, 102, '2015-01-15 00:07:10.000000', 'consum', 0.0215, 'lps'),
	(351473, 102, '2015-01-15 00:07:11.000000', 'consum', 0.0213, 'lps'),
	(351474, 102, '2015-01-15 00:07:12.000000', 'consum', 0.0211, 'lps'),
	(351475, 102, '2015-01-15 00:07:13.000000', 'consum', 0.0217, 'lps'),
	(351476, 102, '2015-01-15 00:07:14.000000', 'consum', 0.0210, 'lps'),
	(351477, 102, '2015-01-15 00:07:15.000000', 'consum', 0.0210, 'lps'),
	(351478, 102, '2015-01-15 00:07:16.000000', 'consum', 0.0211, 'lps'),
	(351479, 102, '2015-01-15 00:07:17.000000', 'consum', 0.0217, 'lps'),
	(351480, 102, '2015-01-15 00:07:18.000000', 'consum', 0.0219, 'lps'),
	(351481, 102, '2015-01-15 00:07:19.000000', 'consum', 0.0217, 'lps'),
	(351482, 102, '2015-01-15 00:07:20.000000', 'consum', 0.0219, 'lps'),
	(351483, 102, '2015-01-15 00:07:21.000000', 'consum', 0.0212, 'lps'),
	(351484, 102, '2015-01-15 00:07:22.000000', 'consum', 0.0214, 'lps'),
	(351485, 102, '2015-01-15 00:07:23.000000', 'consum', 0.0213, 'lps'),
	(351486, 102, '2015-01-15 00:07:24.000000', 'consum', 0.0217, 'lps'),
	(351487, 102, '2015-01-15 00:07:25.000000', 'consum', 0.0215, 'lps'),
	(351488, 102, '2015-01-15 00:07:26.000000', 'consum', 0.0215, 'lps'),
	(351489, 102, '2015-01-15 00:07:27.000000', 'consum', 0.0211, 'lps'),
	(351490, 102, '2015-01-15 00:07:28.000000', 'consum', 0.0219, 'lps'),
	(351491, 102, '2015-01-15 00:07:29.000000', 'consum', 0.0215, 'lps'),
	(351492, 102, '2015-01-15 00:07:30.000000', 'consum', 0.0215, 'lps'),
	(351493, 102, '2015-01-15 00:07:31.000000', 'consum', 0.0213, 'lps'),
	(351494, 102, '2015-01-15 00:07:32.000000', 'consum', 0.0210, 'lps'),
	(351495, 102, '2015-01-15 00:07:33.000000', 'consum', 0.0212, 'lps'),
	(351496, 102, '2015-01-15 00:07:34.000000', 'consum', 0.0219, 'lps'),
	(351497, 102, '2015-01-15 00:07:35.000000', 'consum', 0.0210, 'lps'),
	(351498, 102, '2015-01-15 00:07:36.000000', 'consum', 0.0214, 'lps'),
	(351499, 102, '2015-01-15 00:07:37.000000', 'consum', 0.0211, 'lps'),
	(351500, 102, '2015-01-15 00:07:38.000000', 'consum', 0.0212, 'lps'),
	(351501, 102, '2015-01-15 00:07:39.000000', 'consum', 0.0217, 'lps'),
	(351502, 102, '2015-01-15 00:07:40.000000', 'consum', 0.0210, 'lps'),
	(351503, 102, '2015-01-15 00:07:41.000000', 'consum', 0.0211, 'lps'),
	(351504, 102, '2015-01-15 00:07:42.000000', 'consum', 0.0216, 'lps'),
	(351505, 102, '2015-01-15 00:07:43.000000', 'consum', 0.0214, 'lps'),
	(351506, 102, '2015-01-15 00:07:44.000000', 'consum', 0.0216, 'lps'),
	(351507, 102, '2015-01-15 00:07:45.000000', 'consum', 0.0218, 'lps'),
	(351508, 102, '2015-01-15 00:07:46.000000', 'consum', 0.0213, 'lps'),
	(351509, 102, '2015-01-15 00:07:47.000000', 'consum', 0.0213, 'lps'),
	(351510, 102, '2015-01-15 00:07:48.000000', 'consum', 0.0214, 'lps'),
	(351511, 102, '2015-01-15 00:07:49.000000', 'consum', 0.0211, 'lps'),
	(351512, 102, '2015-01-15 00:07:50.000000', 'consum', 0.0216, 'lps'),
	(351513, 102, '2015-01-15 00:07:51.000000', 'consum', 0.0218, 'lps'),
	(351514, 102, '2015-01-15 00:07:52.000000', 'consum', 0.0211, 'lps'),
	(351515, 102, '2015-01-15 00:07:53.000000', 'consum', 0.0213, 'lps'),
	(351516, 102, '2015-01-15 00:07:54.000000', 'consum', 0.0211, 'lps'),
	(351517, 102, '2015-01-15 00:07:55.000000', 'consum', 0.0219, 'lps'),
	(351518, 102, '2015-01-15 00:07:56.000000', 'consum', 0.0219, 'lps'),
	(351519, 102, '2015-01-15 00:07:57.000000', 'consum', 0.0210, 'lps'),
	(351520, 102, '2015-01-15 00:07:58.000000', 'consum', 0.0212, 'lps'),
	(351521, 102, '2015-01-15 00:07:59.000000', 'consum', 0.0211, 'lps'),
	(351522, 102, '2015-01-15 00:08:00.000000', 'consum', 0.0211, 'lps'),
	(351523, 102, '2015-01-15 00:08:01.000000', 'consum', 0.0211, 'lps'),
	(351524, 102, '2015-01-15 00:08:02.000000', 'consum', 0.0213, 'lps'),
	(351525, 102, '2015-01-15 00:08:03.000000', 'consum', 0.0213, 'lps'),
	(351526, 102, '2015-01-15 00:08:04.000000', 'consum', 0.0216, 'lps'),
	(351527, 102, '2015-01-15 00:08:05.000000', 'consum', 0.0211, 'lps'),
	(351528, 102, '2015-01-15 00:08:06.000000', 'consum', 0.0218, 'lps'),
	(351529, 102, '2015-01-15 00:08:07.000000', 'consum', 0.0217, 'lps'),
	(351530, 102, '2015-01-15 00:08:08.000000', 'consum', 0.0214, 'lps'),
	(351531, 102, '2015-01-15 00:08:09.000000', 'consum', 0.0216, 'lps'),
	(351532, 102, '2015-01-15 00:08:10.000000', 'consum', 0.0211, 'lps'),
	(351533, 102, '2015-01-15 00:08:11.000000', 'consum', 0.0218, 'lps'),
	(351534, 102, '2015-01-15 00:08:12.000000', 'consum', 0.0216, 'lps'),
	(351535, 102, '2015-01-15 00:08:13.000000', 'consum', 0.0215, 'lps'),
	(351536, 102, '2015-01-15 00:08:14.000000', 'consum', 0.0219, 'lps'),
	(351537, 102, '2015-01-15 00:08:15.000000', 'consum', 0.0212, 'lps'),
	(351538, 102, '2015-01-15 00:08:16.000000', 'consum', 0.0210, 'lps'),
	(351539, 102, '2015-01-15 00:08:17.000000', 'consum', 0.0217, 'lps'),
	(351540, 102, '2015-01-15 00:08:18.000000', 'consum', 0.0216, 'lps'),
	(351541, 102, '2015-01-15 00:08:19.000000', 'consum', 0.0210, 'lps'),
	(351542, 102, '2015-01-15 00:08:20.000000', 'consum', 0.0211, 'lps'),
	(351543, 102, '2015-01-15 00:08:21.000000', 'consum', 0.0216, 'lps'),
	(351544, 102, '2015-01-15 00:08:22.000000', 'consum', 0.0217, 'lps'),
	(351545, 102, '2015-01-15 00:08:23.000000', 'consum', 0.0216, 'lps'),
	(351546, 102, '2015-01-15 00:08:24.000000', 'consum', 0.0212, 'lps'),
	(351547, 102, '2015-01-15 00:08:25.000000', 'consum', 0.0213, 'lps'),
	(351548, 102, '2015-01-15 00:08:26.000000', 'consum', 0.0218, 'lps'),
	(351549, 102, '2015-01-15 00:08:27.000000', 'consum', 0.0212, 'lps'),
	(351550, 102, '2015-01-15 00:08:28.000000', 'consum', 0.0217, 'lps'),
	(351551, 102, '2015-01-15 00:08:29.000000', 'consum', 0.0219, 'lps'),
	(351552, 102, '2015-01-15 00:08:30.000000', 'consum', 0.0216, 'lps'),
	(351553, 102, '2015-01-15 00:08:31.000000', 'consum', 0.0214, 'lps'),
	(351554, 102, '2015-01-15 00:08:32.000000', 'consum', 0.0219, 'lps'),
	(351555, 102, '2015-01-15 00:08:33.000000', 'consum', 0.0217, 'lps'),
	(351556, 102, '2015-01-15 00:08:34.000000', 'consum', 0.0219, 'lps'),
	(351557, 102, '2015-01-15 00:08:35.000000', 'consum', 0.0212, 'lps'),
	(351558, 102, '2015-01-15 00:08:36.000000', 'consum', 0.0216, 'lps'),
	(351559, 102, '2015-01-15 00:08:37.000000', 'consum', 0.0212, 'lps'),
	(351560, 102, '2015-01-15 00:08:38.000000', 'consum', 0.0214, 'lps'),
	(351561, 102, '2015-01-15 00:08:39.000000', 'consum', 0.0213, 'lps'),
	(351562, 102, '2015-01-15 00:08:40.000000', 'consum', 0.0212, 'lps'),
	(351563, 102, '2015-01-15 00:08:41.000000', 'consum', 0.0215, 'lps'),
	(351564, 102, '2015-01-15 00:08:42.000000', 'consum', 0.0219, 'lps'),
	(351565, 102, '2015-01-15 00:08:43.000000', 'consum', 0.0218, 'lps'),
	(351566, 102, '2015-01-15 00:08:44.000000', 'consum', 0.0215, 'lps'),
	(351567, 102, '2015-01-15 00:08:45.000000', 'consum', 0.0211, 'lps'),
	(351568, 102, '2015-01-15 00:08:46.000000', 'consum', 0.0219, 'lps'),
	(351569, 102, '2015-01-15 00:08:47.000000', 'consum', 0.0212, 'lps'),
	(351570, 102, '2015-01-15 00:08:48.000000', 'consum', 0.0215, 'lps'),
	(351571, 102, '2015-01-15 00:08:49.000000', 'consum', 0.0210, 'lps'),
	(351572, 102, '2015-01-15 00:08:50.000000', 'consum', 0.0216, 'lps'),
	(351573, 102, '2015-01-15 00:08:51.000000', 'consum', 0.0219, 'lps'),
	(351574, 102, '2015-01-15 00:08:52.000000', 'consum', 0.0217, 'lps'),
	(351575, 102, '2015-01-15 00:08:53.000000', 'consum', 0.0210, 'lps'),
	(351576, 102, '2015-01-15 00:08:54.000000', 'consum', 0.0219, 'lps'),
	(351577, 102, '2015-01-15 00:08:55.000000', 'consum', 0.0215, 'lps'),
	(351578, 102, '2015-01-15 00:08:56.000000', 'consum', 0.0210, 'lps'),
	(351579, 102, '2015-01-15 00:08:57.000000', 'consum', 0.0215, 'lps'),
	(351580, 102, '2015-01-15 00:08:58.000000', 'consum', 0.0216, 'lps'),
	(351581, 102, '2015-01-15 00:08:59.000000', 'consum', 0.0213, 'lps'),
	(351582, 102, '2015-01-15 00:09:00.000000', 'consum', 0.0218, 'lps'),
	(351583, 102, '2015-01-15 00:09:01.000000', 'consum', 0.0213, 'lps'),
	(351584, 102, '2015-01-15 00:09:02.000000', 'consum', 0.0213, 'lps'),
	(351585, 102, '2015-01-15 00:09:03.000000', 'consum', 0.0214, 'lps'),
	(351586, 102, '2015-01-15 00:09:04.000000', 'consum', 0.0211, 'lps'),
	(351587, 102, '2015-01-15 00:09:05.000000', 'consum', 0.0215, 'lps'),
	(351588, 102, '2015-01-15 00:09:06.000000', 'consum', 0.0210, 'lps'),
	(351589, 102, '2015-01-15 00:09:07.000000', 'consum', 0.0217, 'lps'),
	(351590, 102, '2015-01-15 00:09:08.000000', 'consum', 0.0214, 'lps'),
	(351591, 102, '2015-01-15 00:09:09.000000', 'consum', 0.0212, 'lps'),
	(351592, 102, '2015-01-15 00:09:10.000000', 'consum', 0.0217, 'lps'),
	(351593, 102, '2015-01-15 00:09:11.000000', 'consum', 0.0211, 'lps'),
	(351594, 102, '2015-01-15 00:09:12.000000', 'consum', 0.0215, 'lps'),
	(351595, 102, '2015-01-15 00:09:13.000000', 'consum', 0.0210, 'lps'),
	(351596, 102, '2015-01-15 00:09:14.000000', 'consum', 0.0215, 'lps'),
	(351597, 102, '2015-01-15 00:09:15.000000', 'consum', 0.0218, 'lps'),
	(351598, 102, '2015-01-15 00:09:16.000000', 'consum', 0.0215, 'lps'),
	(351599, 102, '2015-01-15 00:09:17.000000', 'consum', 0.0210, 'lps'),
	(351600, 102, '2015-01-15 00:09:18.000000', 'consum', 0.0215, 'lps'),
	(351601, 102, '2015-01-15 00:09:19.000000', 'consum', 0.0218, 'lps'),
	(351602, 102, '2015-01-15 00:09:20.000000', 'consum', 0.0213, 'lps'),
	(351603, 102, '2015-01-15 00:09:21.000000', 'consum', 0.0214, 'lps'),
	(351604, 102, '2015-01-15 00:09:22.000000', 'consum', 0.0219, 'lps'),
	(351605, 102, '2015-01-15 00:09:23.000000', 'consum', 0.0213, 'lps'),
	(351606, 102, '2015-01-15 00:09:24.000000', 'consum', 0.0210, 'lps'),
	(351607, 102, '2015-01-15 00:09:25.000000', 'consum', 0.0212, 'lps'),
	(351608, 102, '2015-01-15 00:09:26.000000', 'consum', 0.0218, 'lps'),
	(351609, 102, '2015-01-15 00:09:27.000000', 'consum', 0.0217, 'lps'),
	(351610, 102, '2015-01-15 00:09:28.000000', 'consum', 0.0210, 'lps'),
	(351611, 102, '2015-01-15 00:09:29.000000', 'consum', 0.0210, 'lps'),
	(351612, 102, '2015-01-15 00:09:30.000000', 'consum', 0.0219, 'lps'),
	(351613, 102, '2015-01-15 00:09:31.000000', 'consum', 0.0214, 'lps'),
	(351614, 102, '2015-01-15 00:09:32.000000', 'consum', 0.0217, 'lps'),
	(351615, 102, '2015-01-15 00:09:33.000000', 'consum', 0.0213, 'lps'),
	(351616, 102, '2015-01-15 00:09:34.000000', 'consum', 0.0214, 'lps'),
	(351617, 102, '2015-01-15 00:09:35.000000', 'consum', 0.0213, 'lps'),
	(351618, 102, '2015-01-15 00:09:36.000000', 'consum', 0.0212, 'lps'),
	(351619, 102, '2015-01-15 00:09:37.000000', 'consum', 0.0212, 'lps'),
	(351620, 102, '2015-01-15 00:09:38.000000', 'consum', 0.0214, 'lps'),
	(351621, 102, '2015-01-15 00:09:39.000000', 'consum', 0.0213, 'lps'),
	(351622, 102, '2015-01-15 00:09:40.000000', 'consum', 0.0213, 'lps'),
	(351623, 102, '2015-01-15 00:09:41.000000', 'consum', 0.0218, 'lps'),
	(351624, 102, '2015-01-15 00:09:42.000000', 'consum', 0.0212, 'lps'),
	(351625, 102, '2015-01-15 00:09:43.000000', 'consum', 0.0214, 'lps'),
	(351626, 102, '2015-01-15 00:09:44.000000', 'consum', 0.0217, 'lps'),
	(351627, 102, '2015-01-15 00:09:45.000000', 'consum', 0.0211, 'lps'),
	(351628, 102, '2015-01-15 00:09:46.000000', 'consum', 0.0215, 'lps'),
	(351629, 102, '2015-01-15 00:09:47.000000', 'consum', 0.0213, 'lps'),
	(351630, 102, '2015-01-15 00:09:48.000000', 'consum', 0.0219, 'lps'),
	(351631, 102, '2015-01-15 00:09:49.000000', 'consum', 0.0217, 'lps'),
	(351632, 102, '2015-01-15 00:09:50.000000', 'consum', 0.0210, 'lps'),
	(351633, 102, '2015-01-15 00:09:51.000000', 'consum', 0.0219, 'lps'),
	(351634, 102, '2015-01-15 00:09:52.000000', 'consum', 0.0216, 'lps'),
	(351635, 102, '2015-01-15 00:09:53.000000', 'consum', 0.0212, 'lps'),
	(351636, 102, '2015-01-15 00:09:54.000000', 'consum', 0.0215, 'lps'),
	(351637, 102, '2015-01-15 00:09:55.000000', 'consum', 0.0219, 'lps'),
	(351638, 102, '2015-01-15 00:09:56.000000', 'consum', 0.0218, 'lps'),
	(351639, 102, '2015-01-15 00:09:57.000000', 'consum', 0.0215, 'lps'),
	(351640, 102, '2015-01-15 00:09:58.000000', 'consum', 0.0212, 'lps'),
	(351641, 102, '2015-01-15 00:09:59.000000', 'consum', 0.0215, 'lps'),
	(351642, 102, '2015-01-15 00:10:00.000000', 'consum', 0.0210, 'lps'),
	(351643, 102, '2015-01-15 00:10:01.000000', 'consum', 0.0214, 'lps'),
	(351644, 102, '2015-01-15 00:10:02.000000', 'consum', 0.0211, 'lps'),
	(351645, 102, '2015-01-15 00:10:03.000000', 'consum', 0.0216, 'lps'),
	(351646, 102, '2015-01-15 00:10:04.000000', 'consum', 0.0214, 'lps'),
	(351647, 102, '2015-01-15 00:10:05.000000', 'consum', 0.0215, 'lps'),
	(351648, 102, '2015-01-15 00:10:06.000000', 'consum', 0.0211, 'lps'),
	(351649, 102, '2015-01-15 00:10:07.000000', 'consum', 0.0211, 'lps'),
	(351650, 102, '2015-01-15 00:10:08.000000', 'consum', 0.0214, 'lps'),
	(351651, 102, '2015-01-15 00:10:09.000000', 'consum', 0.0215, 'lps'),
	(351652, 102, '2015-01-15 00:10:10.000000', 'consum', 0.0216, 'lps'),
	(351653, 102, '2015-01-15 00:10:11.000000', 'consum', 0.0215, 'lps'),
	(351654, 102, '2015-01-15 00:10:12.000000', 'consum', 0.0219, 'lps'),
	(351655, 102, '2015-01-15 00:10:13.000000', 'consum', 0.0218, 'lps'),
	(351656, 102, '2015-01-15 00:10:14.000000', 'consum', 0.0213, 'lps'),
	(351657, 102, '2015-01-15 00:10:15.000000', 'consum', 0.0210, 'lps'),
	(351658, 102, '2015-01-15 00:10:16.000000', 'consum', 0.0215, 'lps'),
	(351659, 102, '2015-01-15 00:10:17.000000', 'consum', 0.0214, 'lps'),
	(351660, 102, '2015-01-15 00:10:18.000000', 'consum', 0.0217, 'lps'),
	(351661, 102, '2015-01-15 00:10:19.000000', 'consum', 0.0214, 'lps'),
	(351662, 102, '2015-01-15 00:10:20.000000', 'consum', 0.0219, 'lps'),
	(351663, 102, '2015-01-15 00:10:21.000000', 'consum', 0.0214, 'lps'),
	(351664, 102, '2015-01-15 00:10:22.000000', 'consum', 0.0211, 'lps'),
	(351665, 102, '2015-01-15 00:10:23.000000', 'consum', 0.0214, 'lps'),
	(351666, 102, '2015-01-15 00:10:24.000000', 'consum', 0.0218, 'lps'),
	(351667, 102, '2015-01-15 00:10:25.000000', 'consum', 0.0218, 'lps'),
	(351668, 102, '2015-01-15 00:10:26.000000', 'consum', 0.0219, 'lps'),
	(351669, 102, '2015-01-15 00:10:27.000000', 'consum', 0.0219, 'lps'),
	(351670, 102, '2015-01-15 00:10:28.000000', 'consum', 0.0219, 'lps'),
	(351671, 102, '2015-01-15 00:10:29.000000', 'consum', 0.0217, 'lps'),
	(351672, 102, '2015-01-15 00:10:30.000000', 'consum', 0.0219, 'lps'),
	(351673, 102, '2015-01-15 00:10:31.000000', 'consum', 0.0216, 'lps'),
	(351674, 102, '2015-01-15 00:10:32.000000', 'consum', 0.0214, 'lps'),
	(351675, 102, '2015-01-15 00:10:33.000000', 'consum', 0.0212, 'lps'),
	(351676, 102, '2015-01-15 00:10:34.000000', 'consum', 0.0210, 'lps'),
	(351677, 102, '2015-01-15 00:10:35.000000', 'consum', 0.0212, 'lps'),
	(351678, 102, '2015-01-15 00:10:36.000000', 'consum', 0.0213, 'lps'),
	(351679, 102, '2015-01-15 00:10:37.000000', 'consum', 0.0217, 'lps'),
	(351680, 102, '2015-01-15 00:10:38.000000', 'consum', 0.0216, 'lps'),
	(351681, 102, '2015-01-15 00:10:39.000000', 'consum', 0.0210, 'lps'),
	(351682, 102, '2015-01-15 00:10:40.000000', 'consum', 0.0211, 'lps'),
	(351683, 102, '2015-01-15 00:10:41.000000', 'consum', 0.0219, 'lps'),
	(351684, 102, '2015-01-15 00:10:42.000000', 'consum', 0.0219, 'lps'),
	(351685, 102, '2015-01-15 00:10:43.000000', 'consum', 0.0211, 'lps'),
	(351686, 102, '2015-01-15 00:10:44.000000', 'consum', 0.0217, 'lps'),
	(351687, 102, '2015-01-15 00:10:45.000000', 'consum', 0.0214, 'lps'),
	(351688, 102, '2015-01-15 00:10:46.000000', 'consum', 0.0218, 'lps'),
	(351689, 102, '2015-01-15 00:10:47.000000', 'consum', 0.0211, 'lps'),
	(351690, 102, '2015-01-15 00:10:48.000000', 'consum', 0.0211, 'lps'),
	(351691, 102, '2015-01-15 00:10:49.000000', 'consum', 0.0212, 'lps'),
	(351692, 102, '2015-01-15 00:10:50.000000', 'consum', 0.0217, 'lps'),
	(351693, 102, '2015-01-15 00:10:51.000000', 'consum', 0.0218, 'lps'),
	(351694, 102, '2015-01-15 00:10:52.000000', 'consum', 0.0210, 'lps'),
	(351695, 102, '2015-01-15 00:10:53.000000', 'consum', 0.0217, 'lps'),
	(351696, 102, '2015-01-15 00:10:54.000000', 'consum', 0.0217, 'lps'),
	(351697, 102, '2015-01-15 00:10:55.000000', 'consum', 0.0212, 'lps'),
	(351698, 102, '2015-01-15 00:10:56.000000', 'consum', 0.0211, 'lps'),
	(351699, 102, '2015-01-15 00:10:57.000000', 'consum', 0.0210, 'lps'),
	(351700, 102, '2015-01-15 00:10:58.000000', 'consum', 0.0215, 'lps'),
	(351701, 102, '2015-01-15 00:10:59.000000', 'consum', 0.0218, 'lps'),
	(351702, 102, '2015-01-15 00:11:00.000000', 'consum', 0.0216, 'lps'),
	(351703, 102, '2015-01-15 00:11:01.000000', 'consum', 0.0214, 'lps'),
	(351704, 102, '2015-01-15 00:11:02.000000', 'consum', 0.0212, 'lps'),
	(351705, 102, '2015-01-15 00:11:03.000000', 'consum', 0.0219, 'lps'),
	(351706, 102, '2015-01-15 00:11:04.000000', 'consum', 0.0210, 'lps'),
	(351707, 102, '2015-01-15 00:11:05.000000', 'consum', 0.0214, 'lps'),
	(351708, 102, '2015-01-15 00:11:06.000000', 'consum', 0.0219, 'lps'),
	(351709, 102, '2015-01-15 00:11:07.000000', 'consum', 0.0214, 'lps'),
	(351710, 102, '2015-01-15 00:11:08.000000', 'consum', 0.0213, 'lps'),
	(351711, 102, '2015-01-15 00:11:09.000000', 'consum', 0.0215, 'lps'),
	(351712, 102, '2015-01-15 00:11:10.000000', 'consum', 0.0217, 'lps'),
	(351713, 102, '2015-01-15 00:11:11.000000', 'consum', 0.0219, 'lps'),
	(351714, 102, '2015-01-15 00:11:12.000000', 'consum', 0.0216, 'lps'),
	(351715, 102, '2015-01-15 00:11:13.000000', 'consum', 0.0214, 'lps'),
	(351716, 102, '2015-01-15 00:11:14.000000', 'consum', 0.0212, 'lps'),
	(351717, 102, '2015-01-15 00:11:15.000000', 'consum', 0.0210, 'lps'),
	(351718, 102, '2015-01-15 00:11:16.000000', 'consum', 0.0215, 'lps'),
	(351719, 102, '2015-01-15 00:11:17.000000', 'consum', 0.0213, 'lps'),
	(351720, 102, '2015-01-15 00:11:18.000000', 'consum', 0.0212, 'lps'),
	(351721, 102, '2015-01-15 00:11:19.000000', 'consum', 0.0210, 'lps'),
	(351722, 102, '2015-01-15 00:11:20.000000', 'consum', 0.0216, 'lps'),
	(351723, 102, '2015-01-15 00:11:21.000000', 'consum', 0.0212, 'lps'),
	(351724, 102, '2015-01-15 00:11:22.000000', 'consum', 0.0210, 'lps'),
	(351725, 102, '2015-01-15 00:11:23.000000', 'consum', 0.0215, 'lps'),
	(351726, 102, '2015-01-15 00:11:24.000000', 'consum', 0.0216, 'lps'),
	(351727, 102, '2015-01-15 00:11:25.000000', 'consum', 0.0214, 'lps'),
	(351728, 102, '2015-01-15 00:11:26.000000', 'consum', 0.0212, 'lps'),
	(351729, 102, '2015-01-15 00:11:27.000000', 'consum', 0.0210, 'lps'),
	(351730, 102, '2015-01-15 00:11:28.000000', 'consum', 0.0212, 'lps'),
	(351731, 102, '2015-01-15 00:11:29.000000', 'consum', 0.0213, 'lps'),
	(351732, 102, '2015-01-15 00:11:30.000000', 'consum', 0.0210, 'lps'),
	(351733, 102, '2015-01-15 00:11:31.000000', 'consum', 0.0213, 'lps'),
	(351734, 102, '2015-01-15 00:11:32.000000', 'consum', 0.0212, 'lps'),
	(351735, 102, '2015-01-15 00:11:33.000000', 'consum', 0.0215, 'lps'),
	(351736, 102, '2015-01-15 00:11:34.000000', 'consum', 0.0217, 'lps'),
	(351737, 102, '2015-01-15 00:11:35.000000', 'consum', 0.0210, 'lps'),
	(351738, 102, '2015-01-15 00:11:36.000000', 'consum', 0.0211, 'lps'),
	(351739, 102, '2015-01-15 00:11:37.000000', 'consum', 0.0216, 'lps'),
	(351740, 102, '2015-01-15 00:11:38.000000', 'consum', 0.0218, 'lps'),
	(351741, 102, '2015-01-15 00:11:39.000000', 'consum', 0.0213, 'lps'),
	(351742, 102, '2015-01-15 00:11:40.000000', 'consum', 0.0210, 'lps'),
	(351743, 102, '2015-01-15 00:11:41.000000', 'consum', 0.0214, 'lps'),
	(351744, 102, '2015-01-15 00:11:42.000000', 'consum', 0.0217, 'lps'),
	(351745, 102, '2015-01-15 00:11:43.000000', 'consum', 0.0215, 'lps'),
	(351746, 102, '2015-01-15 00:11:44.000000', 'consum', 0.0215, 'lps'),
	(351747, 102, '2015-01-15 00:11:45.000000', 'consum', 0.0219, 'lps'),
	(351748, 102, '2015-01-15 00:11:46.000000', 'consum', 0.0212, 'lps'),
	(351749, 102, '2015-01-15 00:11:47.000000', 'consum', 0.0215, 'lps'),
	(351750, 102, '2015-01-15 00:11:48.000000', 'consum', 0.0218, 'lps'),
	(351751, 102, '2015-01-15 00:11:49.000000', 'consum', 0.0217, 'lps'),
	(351752, 102, '2015-01-15 00:11:50.000000', 'consum', 0.0212, 'lps'),
	(351753, 102, '2015-01-15 00:11:51.000000', 'consum', 0.0218, 'lps'),
	(351754, 102, '2015-01-15 00:11:52.000000', 'consum', 0.0213, 'lps'),
	(351755, 102, '2015-01-15 00:11:53.000000', 'consum', 0.0214, 'lps'),
	(351756, 102, '2015-01-15 00:11:54.000000', 'consum', 0.0213, 'lps'),
	(351757, 102, '2015-01-15 00:11:55.000000', 'consum', 0.0210, 'lps'),
	(351758, 102, '2015-01-15 00:11:56.000000', 'consum', 0.0215, 'lps'),
	(351759, 102, '2015-01-15 00:11:57.000000', 'consum', 0.0213, 'lps'),
	(351760, 102, '2015-01-15 00:11:58.000000', 'consum', 0.0210, 'lps'),
	(351761, 102, '2015-01-15 00:11:59.000000', 'consum', 0.0214, 'lps'),
	(351762, 102, '2015-01-15 00:12:00.000000', 'consum', 0.0218, 'lps'),
	(351763, 102, '2015-01-15 00:12:01.000000', 'consum', 0.0217, 'lps'),
	(351764, 102, '2015-01-15 00:12:02.000000', 'consum', 0.0214, 'lps'),
	(351765, 102, '2015-01-15 00:12:03.000000', 'consum', 0.0211, 'lps'),
	(351766, 102, '2015-01-15 00:12:04.000000', 'consum', 0.0211, 'lps'),
	(351767, 102, '2015-01-15 00:12:05.000000', 'consum', 0.0212, 'lps'),
	(351768, 102, '2015-01-15 00:12:06.000000', 'consum', 0.0218, 'lps'),
	(351769, 102, '2015-01-15 00:12:07.000000', 'consum', 0.0216, 'lps'),
	(351770, 102, '2015-01-15 00:12:08.000000', 'consum', 0.0215, 'lps'),
	(351771, 102, '2015-01-15 00:12:09.000000', 'consum', 0.0218, 'lps'),
	(351772, 102, '2015-01-15 00:12:10.000000', 'consum', 0.0215, 'lps'),
	(351773, 102, '2015-01-15 00:12:11.000000', 'consum', 0.0212, 'lps'),
	(351774, 102, '2015-01-15 00:12:12.000000', 'consum', 0.0217, 'lps'),
	(351775, 102, '2015-01-15 00:12:13.000000', 'consum', 0.0217, 'lps'),
	(351776, 102, '2015-01-15 00:12:14.000000', 'consum', 0.0217, 'lps'),
	(351777, 102, '2015-01-15 00:12:15.000000', 'consum', 0.0214, 'lps'),
	(351778, 102, '2015-01-15 00:12:16.000000', 'consum', 0.0211, 'lps'),
	(351779, 102, '2015-01-15 00:12:17.000000', 'consum', 0.0213, 'lps'),
	(351780, 102, '2015-01-15 00:12:18.000000', 'consum', 0.0210, 'lps'),
	(351781, 102, '2015-01-15 00:12:19.000000', 'consum', 0.0213, 'lps'),
	(351782, 102, '2015-01-15 00:12:20.000000', 'consum', 0.0215, 'lps'),
	(351783, 102, '2015-01-15 00:12:21.000000', 'consum', 0.0218, 'lps'),
	(351784, 102, '2015-01-15 00:12:22.000000', 'consum', 0.0214, 'lps'),
	(351785, 102, '2015-01-15 00:12:23.000000', 'consum', 0.0215, 'lps'),
	(351786, 102, '2015-01-15 00:12:24.000000', 'consum', 0.0214, 'lps'),
	(351787, 102, '2015-01-15 00:12:25.000000', 'consum', 0.0217, 'lps'),
	(351788, 102, '2015-01-15 00:12:26.000000', 'consum', 0.0213, 'lps'),
	(351789, 102, '2015-01-15 00:12:27.000000', 'consum', 0.0214, 'lps'),
	(351790, 102, '2015-01-15 00:12:28.000000', 'consum', 0.0212, 'lps'),
	(351791, 102, '2015-01-15 00:12:29.000000', 'consum', 0.0210, 'lps'),
	(351792, 102, '2015-01-15 00:12:30.000000', 'consum', 0.0215, 'lps'),
	(351793, 102, '2015-01-15 00:12:31.000000', 'consum', 0.0216, 'lps'),
	(351794, 102, '2015-01-15 00:12:32.000000', 'consum', 0.0215, 'lps'),
	(351795, 102, '2015-01-15 00:12:33.000000', 'consum', 0.0219, 'lps'),
	(351796, 102, '2015-01-15 00:12:34.000000', 'consum', 0.0217, 'lps'),
	(351797, 102, '2015-01-15 00:12:35.000000', 'consum', 0.0211, 'lps'),
	(351798, 102, '2015-01-15 00:12:36.000000', 'consum', 0.0214, 'lps'),
	(351799, 102, '2015-01-15 00:12:37.000000', 'consum', 0.0218, 'lps'),
	(351800, 102, '2015-01-15 00:12:38.000000', 'consum', 0.0218, 'lps'),
	(351801, 102, '2015-01-15 00:12:39.000000', 'consum', 0.0215, 'lps'),
	(351802, 102, '2015-01-15 00:12:40.000000', 'consum', 0.0211, 'lps'),
	(351803, 102, '2015-01-15 00:12:41.000000', 'consum', 0.0212, 'lps'),
	(351804, 102, '2015-01-15 00:12:42.000000', 'consum', 0.0218, 'lps'),
	(351805, 102, '2015-01-15 00:12:43.000000', 'consum', 0.0214, 'lps'),
	(351806, 102, '2015-01-15 00:12:44.000000', 'consum', 0.0215, 'lps'),
	(351807, 102, '2015-01-15 00:12:45.000000', 'consum', 0.0213, 'lps'),
	(351808, 102, '2015-01-15 00:12:46.000000', 'consum', 0.0211, 'lps'),
	(351809, 102, '2015-01-15 00:12:47.000000', 'consum', 0.0215, 'lps'),
	(351810, 102, '2015-01-15 00:12:48.000000', 'consum', 0.0216, 'lps'),
	(351811, 102, '2015-01-15 00:12:49.000000', 'consum', 0.0213, 'lps'),
	(351812, 102, '2015-01-15 00:12:50.000000', 'consum', 0.0210, 'lps'),
	(351813, 102, '2015-01-15 00:12:51.000000', 'consum', 0.0219, 'lps'),
	(351814, 102, '2015-01-15 00:12:52.000000', 'consum', 0.0217, 'lps'),
	(351815, 102, '2015-01-15 00:12:53.000000', 'consum', 0.0217, 'lps'),
	(351816, 102, '2015-01-15 00:12:54.000000', 'consum', 0.0217, 'lps'),
	(351817, 102, '2015-01-15 00:12:55.000000', 'consum', 0.0215, 'lps'),
	(351818, 102, '2015-01-15 00:12:56.000000', 'consum', 0.0212, 'lps'),
	(351819, 102, '2015-01-15 00:12:57.000000', 'consum', 0.0216, 'lps'),
	(351820, 102, '2015-01-15 00:12:58.000000', 'consum', 0.0215, 'lps'),
	(351821, 102, '2015-01-15 00:12:59.000000', 'consum', 0.0216, 'lps'),
	(351822, 102, '2015-01-15 00:13:00.000000', 'consum', 0.0218, 'lps'),
	(351823, 102, '2015-01-15 00:13:01.000000', 'consum', 0.0219, 'lps'),
	(351824, 102, '2015-01-15 00:13:02.000000', 'consum', 0.0215, 'lps'),
	(351825, 102, '2015-01-15 00:13:03.000000', 'consum', 0.0218, 'lps'),
	(351826, 102, '2015-01-15 00:13:04.000000', 'consum', 0.0213, 'lps'),
	(351827, 102, '2015-01-15 00:13:05.000000', 'consum', 0.0213, 'lps'),
	(351828, 102, '2015-01-15 00:13:06.000000', 'consum', 0.0214, 'lps'),
	(351829, 102, '2015-01-15 00:13:07.000000', 'consum', 0.0215, 'lps'),
	(351830, 102, '2015-01-15 00:13:08.000000', 'consum', 0.0211, 'lps'),
	(351831, 102, '2015-01-15 00:13:09.000000', 'consum', 0.0210, 'lps'),
	(351832, 102, '2015-01-15 00:13:10.000000', 'consum', 0.0218, 'lps'),
	(351833, 102, '2015-01-15 00:13:11.000000', 'consum', 0.0210, 'lps'),
	(351834, 102, '2015-01-15 00:13:12.000000', 'consum', 0.0218, 'lps'),
	(351835, 102, '2015-01-15 00:13:13.000000', 'consum', 0.0210, 'lps'),
	(351836, 102, '2015-01-15 00:13:14.000000', 'consum', 0.0217, 'lps'),
	(351837, 102, '2015-01-15 00:13:15.000000', 'consum', 0.0213, 'lps'),
	(351838, 102, '2015-01-15 00:13:16.000000', 'consum', 0.0217, 'lps'),
	(351839, 102, '2015-01-15 00:13:17.000000', 'consum', 0.0218, 'lps'),
	(351840, 102, '2015-01-15 00:13:18.000000', 'consum', 0.0216, 'lps'),
	(351841, 102, '2015-01-15 00:13:19.000000', 'consum', 0.0219, 'lps'),
	(351842, 102, '2015-01-15 00:13:20.000000', 'consum', 0.0215, 'lps'),
	(351843, 102, '2015-01-15 00:13:21.000000', 'consum', 0.0211, 'lps'),
	(351844, 102, '2015-01-15 00:13:22.000000', 'consum', 0.0219, 'lps'),
	(351845, 102, '2015-01-15 00:13:23.000000', 'consum', 0.0212, 'lps'),
	(351846, 102, '2015-01-15 00:13:24.000000', 'consum', 0.0215, 'lps'),
	(351847, 102, '2015-01-15 00:13:25.000000', 'consum', 0.0218, 'lps'),
	(351848, 102, '2015-01-15 00:13:26.000000', 'consum', 0.0216, 'lps'),
	(351849, 102, '2015-01-15 00:13:27.000000', 'consum', 0.0216, 'lps'),
	(351850, 102, '2015-01-15 00:13:28.000000', 'consum', 0.0213, 'lps'),
	(351851, 102, '2015-01-15 00:13:29.000000', 'consum', 0.0217, 'lps'),
	(351852, 102, '2015-01-15 00:13:30.000000', 'consum', 0.0216, 'lps'),
	(351853, 102, '2015-01-15 00:13:31.000000', 'consum', 0.0210, 'lps'),
	(351854, 102, '2015-01-15 00:13:32.000000', 'consum', 0.0214, 'lps'),
	(351855, 102, '2015-01-15 00:13:33.000000', 'consum', 0.0218, 'lps'),
	(351856, 102, '2015-01-15 00:13:34.000000', 'consum', 0.0218, 'lps'),
	(351857, 102, '2015-01-15 00:13:35.000000', 'consum', 0.0216, 'lps'),
	(351858, 102, '2015-01-15 00:13:36.000000', 'consum', 0.0219, 'lps'),
	(351859, 102, '2015-01-15 00:13:37.000000', 'consum', 0.0217, 'lps'),
	(351860, 102, '2015-01-15 00:13:38.000000', 'consum', 0.0210, 'lps'),
	(351861, 102, '2015-01-15 00:13:39.000000', 'consum', 0.0217, 'lps'),
	(351862, 102, '2015-01-15 00:13:40.000000', 'consum', 0.0218, 'lps'),
	(351863, 102, '2015-01-15 00:13:41.000000', 'consum', 0.0210, 'lps'),
	(351864, 102, '2015-01-15 00:13:42.000000', 'consum', 0.0215, 'lps'),
	(351865, 102, '2015-01-15 00:13:43.000000', 'consum', 0.0216, 'lps'),
	(351866, 102, '2015-01-15 00:13:44.000000', 'consum', 0.0213, 'lps'),
	(351867, 102, '2015-01-15 00:13:45.000000', 'consum', 0.0211, 'lps'),
	(351868, 102, '2015-01-15 00:13:46.000000', 'consum', 0.0214, 'lps'),
	(351869, 102, '2015-01-15 00:13:47.000000', 'consum', 0.0210, 'lps'),
	(351870, 102, '2015-01-15 00:13:48.000000', 'consum', 0.0217, 'lps'),
	(351871, 102, '2015-01-15 00:13:49.000000', 'consum', 0.0214, 'lps'),
	(351872, 102, '2015-01-15 00:13:50.000000', 'consum', 0.0211, 'lps'),
	(351873, 102, '2015-01-15 00:13:51.000000', 'consum', 0.0215, 'lps'),
	(351874, 102, '2015-01-15 00:13:52.000000', 'consum', 0.0212, 'lps'),
	(351875, 102, '2015-01-15 00:13:53.000000', 'consum', 0.0214, 'lps'),
	(351876, 102, '2015-01-15 00:13:54.000000', 'consum', 0.0213, 'lps'),
	(351877, 102, '2015-01-15 00:13:55.000000', 'consum', 0.0215, 'lps'),
	(351878, 102, '2015-01-15 00:13:56.000000', 'consum', 0.0218, 'lps'),
	(351879, 102, '2015-01-15 00:13:57.000000', 'consum', 0.0217, 'lps'),
	(351880, 102, '2015-01-15 00:13:58.000000', 'consum', 0.0218, 'lps'),
	(351881, 102, '2015-01-15 00:13:59.000000', 'consum', 0.0210, 'lps'),
	(351882, 102, '2015-01-15 00:14:00.000000', 'consum', 0.0217, 'lps'),
	(351883, 102, '2015-01-15 00:14:01.000000', 'consum', 0.0217, 'lps'),
	(351884, 102, '2015-01-15 00:14:02.000000', 'consum', 0.0212, 'lps'),
	(351885, 102, '2015-01-15 00:14:03.000000', 'consum', 0.0211, 'lps'),
	(351886, 102, '2015-01-15 00:14:04.000000', 'consum', 0.0218, 'lps'),
	(351887, 102, '2015-01-15 00:14:05.000000', 'consum', 0.0219, 'lps'),
	(351888, 102, '2015-01-15 00:14:06.000000', 'consum', 0.0212, 'lps'),
	(351889, 102, '2015-01-15 00:14:07.000000', 'consum', 0.0211, 'lps'),
	(351890, 102, '2015-01-15 00:14:08.000000', 'consum', 0.0210, 'lps'),
	(351891, 102, '2015-01-15 00:14:09.000000', 'consum', 0.0217, 'lps'),
	(351892, 102, '2015-01-15 00:14:10.000000', 'consum', 0.0216, 'lps'),
	(351893, 102, '2015-01-15 00:14:11.000000', 'consum', 0.0210, 'lps'),
	(351894, 102, '2015-01-15 00:14:12.000000', 'consum', 0.0213, 'lps'),
	(351895, 102, '2015-01-15 00:14:13.000000', 'consum', 0.0214, 'lps'),
	(351896, 102, '2015-01-15 00:14:14.000000', 'consum', 0.0212, 'lps'),
	(351897, 102, '2015-01-15 00:14:15.000000', 'consum', 0.0210, 'lps'),
	(351898, 102, '2015-01-15 00:14:16.000000', 'consum', 0.0213, 'lps'),
	(351899, 102, '2015-01-15 00:14:17.000000', 'consum', 0.0215, 'lps'),
	(351900, 102, '2015-01-15 00:14:18.000000', 'consum', 0.0216, 'lps'),
	(351901, 102, '2015-01-15 00:14:19.000000', 'consum', 0.0217, 'lps'),
	(351902, 102, '2015-01-15 00:14:20.000000', 'consum', 0.0219, 'lps'),
	(351903, 102, '2015-01-15 00:14:21.000000', 'consum', 0.0212, 'lps'),
	(351904, 102, '2015-01-15 00:14:22.000000', 'consum', 0.0214, 'lps'),
	(351905, 102, '2015-01-15 00:14:23.000000', 'consum', 0.0215, 'lps'),
	(351906, 102, '2015-01-15 00:14:24.000000', 'consum', 0.0213, 'lps'),
	(351907, 102, '2015-01-15 00:14:25.000000', 'consum', 0.0212, 'lps'),
	(351908, 102, '2015-01-15 00:14:26.000000', 'consum', 0.0219, 'lps'),
	(351909, 102, '2015-01-15 00:14:27.000000', 'consum', 0.0210, 'lps'),
	(351910, 102, '2015-01-15 00:14:28.000000', 'consum', 0.0215, 'lps'),
	(351911, 102, '2015-01-15 00:14:29.000000', 'consum', 0.0215, 'lps'),
	(351912, 102, '2015-01-15 00:14:30.000000', 'consum', 0.0211, 'lps'),
	(351913, 102, '2015-01-15 00:14:31.000000', 'consum', 0.0211, 'lps'),
	(351914, 102, '2015-01-15 00:14:32.000000', 'consum', 0.0212, 'lps'),
	(351915, 102, '2015-01-15 00:14:33.000000', 'consum', 0.0217, 'lps'),
	(351916, 102, '2015-01-15 00:14:34.000000', 'consum', 0.0211, 'lps'),
	(351917, 102, '2015-01-15 00:14:35.000000', 'consum', 0.0214, 'lps'),
	(351918, 102, '2015-01-15 00:14:36.000000', 'consum', 0.0219, 'lps'),
	(351919, 102, '2015-01-15 00:14:37.000000', 'consum', 0.0210, 'lps'),
	(351920, 102, '2015-01-15 00:14:38.000000', 'consum', 0.0217, 'lps'),
	(351921, 102, '2015-01-15 00:14:39.000000', 'consum', 0.0214, 'lps'),
	(351922, 102, '2015-01-15 00:14:40.000000', 'consum', 0.0218, 'lps'),
	(351923, 102, '2015-01-15 00:14:41.000000', 'consum', 0.0211, 'lps'),
	(351924, 102, '2015-01-15 00:14:42.000000', 'consum', 0.0211, 'lps'),
	(351925, 102, '2015-01-15 00:14:43.000000', 'consum', 0.0211, 'lps'),
	(351926, 102, '2015-01-15 00:14:44.000000', 'consum', 0.0211, 'lps'),
	(351927, 102, '2015-01-15 00:14:45.000000', 'consum', 0.0215, 'lps'),
	(351928, 102, '2015-01-15 00:14:46.000000', 'consum', 0.0212, 'lps'),
	(351929, 102, '2015-01-15 00:14:47.000000', 'consum', 0.0215, 'lps'),
	(351930, 102, '2015-01-15 00:14:48.000000', 'consum', 0.0212, 'lps'),
	(351931, 102, '2015-01-15 00:14:49.000000', 'consum', 0.0212, 'lps'),
	(351932, 102, '2015-01-15 00:14:50.000000', 'consum', 0.0217, 'lps'),
	(351933, 102, '2015-01-15 00:14:51.000000', 'consum', 0.0219, 'lps'),
	(351934, 102, '2015-01-15 00:14:52.000000', 'consum', 0.0213, 'lps'),
	(351935, 102, '2015-01-15 00:14:53.000000', 'consum', 0.0217, 'lps'),
	(351936, 102, '2015-01-15 00:14:54.000000', 'consum', 0.0210, 'lps'),
	(351937, 102, '2015-01-15 00:14:55.000000', 'consum', 0.0217, 'lps'),
	(351938, 102, '2015-01-15 00:14:56.000000', 'consum', 0.0217, 'lps'),
	(351939, 102, '2015-01-15 00:14:57.000000', 'consum', 0.0213, 'lps'),
	(351940, 102, '2015-01-15 00:14:58.000000', 'consum', 0.0217, 'lps'),
	(351941, 102, '2015-01-15 00:14:59.000000', 'consum', 0.0214, 'lps'),
	(351942, 102, '2015-01-15 00:15:00.000000', 'consum', 0.0219, 'lps'),
	(351943, 102, '2015-01-15 00:15:01.000000', 'consum', 0.0215, 'lps'),
	(351944, 102, '2015-01-15 00:15:02.000000', 'consum', 0.0217, 'lps'),
	(351945, 102, '2015-01-15 00:15:03.000000', 'consum', 0.0211, 'lps'),
	(351946, 102, '2015-01-15 00:15:04.000000', 'consum', 0.0215, 'lps'),
	(351947, 102, '2015-01-15 00:15:05.000000', 'consum', 0.0214, 'lps'),
	(351948, 102, '2015-01-15 00:15:06.000000', 'consum', 0.0215, 'lps'),
	(351949, 102, '2015-01-15 00:15:07.000000', 'consum', 0.0211, 'lps'),
	(351950, 102, '2015-01-15 00:15:08.000000', 'consum', 0.0214, 'lps'),
	(351951, 102, '2015-01-15 00:15:09.000000', 'consum', 0.0215, 'lps'),
	(351952, 102, '2015-01-15 00:15:10.000000', 'consum', 0.0216, 'lps'),
	(351953, 102, '2015-01-15 00:15:11.000000', 'consum', 0.0215, 'lps'),
	(351954, 102, '2015-01-15 00:15:12.000000', 'consum', 0.0216, 'lps'),
	(351955, 102, '2015-01-15 00:15:13.000000', 'consum', 0.0218, 'lps'),
	(351956, 102, '2015-01-15 00:15:14.000000', 'consum', 0.0212, 'lps'),
	(351957, 102, '2015-01-15 00:15:15.000000', 'consum', 0.0215, 'lps'),
	(351958, 102, '2015-01-15 00:15:16.000000', 'consum', 0.0212, 'lps'),
	(351959, 102, '2015-01-15 00:15:17.000000', 'consum', 0.0214, 'lps'),
	(351960, 102, '2015-01-15 00:15:18.000000', 'consum', 0.0213, 'lps'),
	(351961, 102, '2015-01-15 00:15:19.000000', 'consum', 0.0213, 'lps'),
	(351962, 102, '2015-01-15 00:15:20.000000', 'consum', 0.0219, 'lps'),
	(351963, 102, '2015-01-15 00:15:21.000000', 'consum', 0.0217, 'lps'),
	(351964, 102, '2015-01-15 00:15:22.000000', 'consum', 0.0216, 'lps'),
	(351965, 102, '2015-01-15 00:15:23.000000', 'consum', 0.0219, 'lps'),
	(351966, 102, '2015-01-15 00:15:24.000000', 'consum', 0.0219, 'lps'),
	(351967, 102, '2015-01-15 00:15:25.000000', 'consum', 0.0210, 'lps'),
	(351968, 102, '2015-01-15 00:15:26.000000', 'consum', 0.0210, 'lps'),
	(351969, 102, '2015-01-15 00:15:27.000000', 'consum', 0.0213, 'lps'),
	(351970, 102, '2015-01-15 00:15:28.000000', 'consum', 0.0217, 'lps'),
	(351971, 102, '2015-01-15 00:15:29.000000', 'consum', 0.0215, 'lps'),
	(351972, 102, '2015-01-15 00:15:30.000000', 'consum', 0.0213, 'lps'),
	(351973, 102, '2015-01-15 00:15:31.000000', 'consum', 0.0212, 'lps'),
	(351974, 102, '2015-01-15 00:15:32.000000', 'consum', 0.0210, 'lps'),
	(351975, 102, '2015-01-15 00:15:33.000000', 'consum', 0.0216, 'lps'),
	(351976, 102, '2015-01-15 00:15:34.000000', 'consum', 0.0212, 'lps'),
	(351977, 102, '2015-01-15 00:15:35.000000', 'consum', 0.0211, 'lps'),
	(351978, 102, '2015-01-15 00:15:36.000000', 'consum', 0.0219, 'lps'),
	(351979, 102, '2015-01-15 00:15:37.000000', 'consum', 0.0215, 'lps'),
	(351980, 102, '2015-01-15 00:15:38.000000', 'consum', 0.0217, 'lps'),
	(351981, 102, '2015-01-15 00:15:39.000000', 'consum', 0.0219, 'lps'),
	(351982, 102, '2015-01-15 00:15:40.000000', 'consum', 0.0217, 'lps'),
	(351983, 102, '2015-01-15 00:15:41.000000', 'consum', 0.0218, 'lps'),
	(351984, 102, '2015-01-15 00:15:42.000000', 'consum', 0.0219, 'lps'),
	(351985, 102, '2015-01-15 00:15:43.000000', 'consum', 0.0211, 'lps'),
	(351986, 102, '2015-01-15 00:15:44.000000', 'consum', 0.0210, 'lps'),
	(351987, 102, '2015-01-15 00:15:45.000000', 'consum', 0.0217, 'lps'),
	(351988, 102, '2015-01-15 00:15:46.000000', 'consum', 0.0215, 'lps'),
	(351989, 102, '2015-01-15 00:15:47.000000', 'consum', 0.0217, 'lps'),
	(351990, 102, '2015-01-15 00:15:48.000000', 'consum', 0.0218, 'lps'),
	(351991, 102, '2015-01-15 00:15:49.000000', 'consum', 0.0219, 'lps'),
	(351992, 102, '2015-01-15 00:15:50.000000', 'consum', 0.0211, 'lps'),
	(351993, 102, '2015-01-15 00:15:51.000000', 'consum', 0.0218, 'lps'),
	(351994, 102, '2015-01-15 00:15:52.000000', 'consum', 0.0218, 'lps'),
	(351995, 102, '2015-01-15 00:15:53.000000', 'consum', 0.0217, 'lps'),
	(351996, 102, '2015-01-15 00:15:54.000000', 'consum', 0.0212, 'lps'),
	(351997, 102, '2015-01-15 00:15:55.000000', 'consum', 0.0219, 'lps'),
	(351998, 102, '2015-01-15 00:15:56.000000', 'consum', 0.0219, 'lps'),
	(351999, 102, '2015-01-15 00:15:57.000000', 'consum', 0.0218, 'lps'),
	(352000, 102, '2015-01-15 00:15:58.000000', 'consum', 0.0215, 'lps'),
	(352001, 102, '2015-01-15 00:15:59.000000', 'consum', 0.0211, 'lps'),
	(352002, 102, '2015-01-15 00:16:00.000000', 'consum', 0.0219, 'lps'),
	(352003, 102, '2015-01-15 00:16:01.000000', 'consum', 0.0215, 'lps'),
	(352004, 102, '2015-01-15 00:16:02.000000', 'consum', 0.0218, 'lps'),
	(352005, 102, '2015-01-15 00:16:03.000000', 'consum', 0.0217, 'lps'),
	(352006, 102, '2015-01-15 00:16:04.000000', 'consum', 0.0211, 'lps'),
	(352007, 102, '2015-01-15 00:16:05.000000', 'consum', 0.0214, 'lps'),
	(352008, 102, '2015-01-15 00:16:06.000000', 'consum', 0.0217, 'lps'),
	(352009, 102, '2015-01-15 00:16:07.000000', 'consum', 0.0214, 'lps'),
	(352010, 102, '2015-01-15 00:16:08.000000', 'consum', 0.0210, 'lps'),
	(352011, 102, '2015-01-15 00:16:09.000000', 'consum', 0.0216, 'lps'),
	(352012, 102, '2015-01-15 00:16:10.000000', 'consum', 0.0212, 'lps'),
	(352013, 102, '2015-01-15 00:16:11.000000', 'consum', 0.0213, 'lps'),
	(352014, 102, '2015-01-15 00:16:12.000000', 'consum', 0.0219, 'lps'),
	(352015, 102, '2015-01-15 00:16:13.000000', 'consum', 0.0217, 'lps'),
	(352016, 102, '2015-01-15 00:16:14.000000', 'consum', 0.0219, 'lps'),
	(352017, 102, '2015-01-15 00:16:15.000000', 'consum', 0.0216, 'lps'),
	(352018, 102, '2015-01-15 00:16:16.000000', 'consum', 0.0211, 'lps'),
	(352019, 102, '2015-01-15 00:16:17.000000', 'consum', 0.0210, 'lps'),
	(352020, 102, '2015-01-15 00:16:18.000000', 'consum', 0.0215, 'lps'),
	(352021, 102, '2015-01-15 00:16:19.000000', 'consum', 0.0216, 'lps'),
	(352022, 102, '2015-01-15 00:16:20.000000', 'consum', 0.0215, 'lps'),
	(352023, 102, '2015-01-15 00:16:21.000000', 'consum', 0.0219, 'lps'),
	(352024, 102, '2015-01-15 00:16:22.000000', 'consum', 0.0212, 'lps'),
	(352025, 102, '2015-01-15 00:16:23.000000', 'consum', 0.0210, 'lps'),
	(352026, 102, '2015-01-15 00:16:24.000000', 'consum', 0.0218, 'lps'),
	(352027, 102, '2015-01-15 00:16:25.000000', 'consum', 0.0218, 'lps'),
	(352028, 102, '2015-01-15 00:16:26.000000', 'consum', 0.0219, 'lps'),
	(352029, 102, '2015-01-15 00:16:27.000000', 'consum', 0.0211, 'lps'),
	(352030, 102, '2015-01-15 00:16:28.000000', 'consum', 0.0210, 'lps'),
	(352031, 102, '2015-01-15 00:16:29.000000', 'consum', 0.0216, 'lps'),
	(352032, 102, '2015-01-15 00:16:30.000000', 'consum', 0.0212, 'lps'),
	(352033, 102, '2015-01-15 00:16:31.000000', 'consum', 0.0212, 'lps'),
	(352034, 102, '2015-01-15 00:16:32.000000', 'consum', 0.0213, 'lps'),
	(352035, 102, '2015-01-15 00:16:33.000000', 'consum', 0.0210, 'lps'),
	(352036, 102, '2015-01-15 00:16:34.000000', 'consum', 0.0213, 'lps'),
	(352037, 102, '2015-01-15 00:16:35.000000', 'consum', 0.0216, 'lps'),
	(352038, 102, '2015-01-15 00:16:36.000000', 'consum', 0.0219, 'lps'),
	(352039, 102, '2015-01-15 00:16:37.000000', 'consum', 0.0219, 'lps'),
	(352040, 102, '2015-01-15 00:16:38.000000', 'consum', 0.0210, 'lps'),
	(352041, 102, '2015-01-15 00:16:39.000000', 'consum', 0.0212, 'lps'),
	(352042, 102, '2015-01-15 00:16:40.000000', 'consum', 0.0211, 'lps'),
	(352043, 102, '2015-01-15 00:16:41.000000', 'consum', 0.0218, 'lps'),
	(352044, 102, '2015-01-15 00:16:42.000000', 'consum', 0.0217, 'lps'),
	(352045, 102, '2015-01-15 00:16:43.000000', 'consum', 0.0213, 'lps'),
	(352046, 102, '2015-01-15 00:16:44.000000', 'consum', 0.0213, 'lps'),
	(352047, 102, '2015-01-15 00:16:45.000000', 'consum', 0.0218, 'lps'),
	(352048, 102, '2015-01-15 00:16:46.000000', 'consum', 0.0212, 'lps'),
	(352049, 102, '2015-01-15 00:16:47.000000', 'consum', 0.0214, 'lps'),
	(352050, 102, '2015-01-15 00:16:48.000000', 'consum', 0.0215, 'lps'),
	(352051, 102, '2015-01-15 00:16:49.000000', 'consum', 0.0213, 'lps'),
	(352052, 102, '2015-01-15 00:16:50.000000', 'consum', 0.0211, 'lps'),
	(352053, 102, '2015-01-15 00:16:51.000000', 'consum', 0.0217, 'lps'),
	(352054, 102, '2015-01-15 00:16:52.000000', 'consum', 0.0214, 'lps'),
	(352055, 102, '2015-01-15 00:16:53.000000', 'consum', 0.0210, 'lps'),
	(352056, 102, '2015-01-15 00:16:54.000000', 'consum', 0.0215, 'lps'),
	(352057, 102, '2015-01-15 00:16:55.000000', 'consum', 0.0218, 'lps'),
	(352058, 102, '2015-01-15 00:16:56.000000', 'consum', 0.0215, 'lps'),
	(352059, 102, '2015-01-15 00:16:57.000000', 'consum', 0.0210, 'lps'),
	(352060, 102, '2015-01-15 00:16:58.000000', 'consum', 0.0217, 'lps'),
	(352061, 102, '2015-01-15 00:16:59.000000', 'consum', 0.0217, 'lps'),
	(352062, 102, '2015-01-15 00:17:00.000000', 'consum', 0.0212, 'lps'),
	(352063, 102, '2015-01-15 00:17:01.000000', 'consum', 0.0210, 'lps'),
	(352064, 102, '2015-01-15 00:17:02.000000', 'consum', 0.0213, 'lps'),
	(352065, 102, '2015-01-15 00:17:03.000000', 'consum', 0.0216, 'lps'),
	(352066, 102, '2015-01-15 00:17:04.000000', 'consum', 0.0211, 'lps'),
	(352067, 102, '2015-01-15 00:17:05.000000', 'consum', 0.0210, 'lps'),
	(352068, 102, '2015-01-15 00:17:06.000000', 'consum', 0.0216, 'lps'),
	(352069, 102, '2015-01-15 00:17:07.000000', 'consum', 0.0212, 'lps'),
	(352070, 102, '2015-01-15 00:17:08.000000', 'consum', 0.0210, 'lps'),
	(352071, 102, '2015-01-15 00:17:09.000000', 'consum', 0.0216, 'lps'),
	(352072, 102, '2015-01-15 00:17:10.000000', 'consum', 0.0211, 'lps'),
	(352073, 102, '2015-01-15 00:17:11.000000', 'consum', 0.0215, 'lps'),
	(352074, 102, '2015-01-15 00:17:12.000000', 'consum', 0.0214, 'lps'),
	(352075, 102, '2015-01-15 00:17:13.000000', 'consum', 0.0217, 'lps'),
	(352076, 102, '2015-01-15 00:17:14.000000', 'consum', 0.0210, 'lps'),
	(352077, 102, '2015-01-15 00:17:15.000000', 'consum', 0.0212, 'lps'),
	(352078, 102, '2015-01-15 00:17:16.000000', 'consum', 0.0211, 'lps'),
	(352079, 102, '2015-01-15 00:17:17.000000', 'consum', 0.0210, 'lps'),
	(352080, 102, '2015-01-15 00:17:18.000000', 'consum', 0.0215, 'lps'),
	(352081, 102, '2015-01-15 00:17:19.000000', 'consum', 0.0215, 'lps'),
	(352082, 102, '2015-01-15 00:17:20.000000', 'consum', 0.0210, 'lps'),
	(352083, 102, '2015-01-15 00:17:21.000000', 'consum', 0.0217, 'lps'),
	(352084, 102, '2015-01-15 00:17:22.000000', 'consum', 0.0213, 'lps'),
	(352085, 102, '2015-01-15 00:17:23.000000', 'consum', 0.0218, 'lps'),
	(352086, 102, '2015-01-15 00:17:24.000000', 'consum', 0.0218, 'lps'),
	(352087, 102, '2015-01-15 00:17:25.000000', 'consum', 0.0219, 'lps'),
	(352088, 102, '2015-01-15 00:17:26.000000', 'consum', 0.0213, 'lps'),
	(352089, 102, '2015-01-15 00:17:27.000000', 'consum', 0.0215, 'lps'),
	(352090, 102, '2015-01-15 00:17:28.000000', 'consum', 0.0218, 'lps'),
	(352091, 102, '2015-01-15 00:17:29.000000', 'consum', 0.0214, 'lps'),
	(352092, 102, '2015-01-15 00:17:30.000000', 'consum', 0.0217, 'lps'),
	(352093, 102, '2015-01-15 00:17:31.000000', 'consum', 0.0213, 'lps'),
	(352094, 102, '2015-01-15 00:17:32.000000', 'consum', 0.0213, 'lps'),
	(352095, 102, '2015-01-15 00:17:33.000000', 'consum', 0.0219, 'lps'),
	(352096, 102, '2015-01-15 00:17:34.000000', 'consum', 0.0217, 'lps'),
	(352097, 102, '2015-01-15 00:17:35.000000', 'consum', 0.0210, 'lps'),
	(352098, 102, '2015-01-15 00:17:36.000000', 'consum', 0.0216, 'lps'),
	(352099, 102, '2015-01-15 00:17:37.000000', 'consum', 0.0211, 'lps'),
	(352100, 102, '2015-01-15 00:17:38.000000', 'consum', 0.0210, 'lps'),
	(352101, 102, '2015-01-15 00:17:39.000000', 'consum', 0.0216, 'lps'),
	(352102, 102, '2015-01-15 00:17:40.000000', 'consum', 0.0210, 'lps'),
	(352103, 102, '2015-01-15 00:17:41.000000', 'consum', 0.0213, 'lps'),
	(352104, 102, '2015-01-15 00:17:42.000000', 'consum', 0.0215, 'lps'),
	(352105, 102, '2015-01-15 00:17:43.000000', 'consum', 0.0218, 'lps'),
	(352106, 102, '2015-01-15 00:17:44.000000', 'consum', 0.0215, 'lps'),
	(352107, 102, '2015-01-15 00:17:45.000000', 'consum', 0.0219, 'lps'),
	(352108, 102, '2015-01-15 00:17:46.000000', 'consum', 0.0213, 'lps'),
	(352109, 102, '2015-01-15 00:17:47.000000', 'consum', 0.0217, 'lps'),
	(352110, 102, '2015-01-15 00:17:48.000000', 'consum', 0.0219, 'lps'),
	(352111, 102, '2015-01-15 00:17:49.000000', 'consum', 0.0213, 'lps'),
	(352112, 102, '2015-01-15 00:17:50.000000', 'consum', 0.0217, 'lps'),
	(352113, 102, '2015-01-15 00:17:51.000000', 'consum', 0.0216, 'lps'),
	(352114, 102, '2015-01-15 00:17:52.000000', 'consum', 0.0210, 'lps'),
	(352115, 102, '2015-01-15 00:17:53.000000', 'consum', 0.0213, 'lps'),
	(352116, 102, '2015-01-15 00:17:54.000000', 'consum', 0.0214, 'lps'),
	(352117, 102, '2015-01-15 00:17:55.000000', 'consum', 0.0211, 'lps'),
	(352118, 102, '2015-01-15 00:17:56.000000', 'consum', 0.0216, 'lps'),
	(352119, 102, '2015-01-15 00:17:57.000000', 'consum', 0.0215, 'lps'),
	(352120, 102, '2015-01-15 00:17:58.000000', 'consum', 0.0210, 'lps'),
	(352121, 102, '2015-01-15 00:17:59.000000', 'consum', 0.0214, 'lps'),
	(352122, 102, '2015-01-15 00:18:00.000000', 'consum', 0.0212, 'lps'),
	(352123, 102, '2015-01-15 00:18:01.000000', 'consum', 0.0217, 'lps'),
	(352124, 102, '2015-01-15 00:18:02.000000', 'consum', 0.0219, 'lps'),
	(352125, 102, '2015-01-15 00:18:03.000000', 'consum', 0.0217, 'lps'),
	(352126, 102, '2015-01-15 00:18:04.000000', 'consum', 0.0216, 'lps'),
	(352127, 102, '2015-01-15 00:18:05.000000', 'consum', 0.0219, 'lps'),
	(352128, 102, '2015-01-15 00:18:06.000000', 'consum', 0.0218, 'lps'),
	(352129, 102, '2015-01-15 00:18:07.000000', 'consum', 0.0215, 'lps'),
	(352130, 102, '2015-01-15 00:18:08.000000', 'consum', 0.0210, 'lps'),
	(352131, 102, '2015-01-15 00:18:09.000000', 'consum', 0.0215, 'lps'),
	(352132, 102, '2015-01-15 00:18:10.000000', 'consum', 0.0217, 'lps'),
	(352133, 102, '2015-01-15 00:18:11.000000', 'consum', 0.0211, 'lps'),
	(352134, 102, '2015-01-15 00:18:12.000000', 'consum', 0.0215, 'lps'),
	(352135, 102, '2015-01-15 00:18:13.000000', 'consum', 0.0212, 'lps'),
	(352136, 102, '2015-01-15 00:18:14.000000', 'consum', 0.0215, 'lps'),
	(352137, 102, '2015-01-15 00:18:15.000000', 'consum', 0.0210, 'lps'),
	(352138, 102, '2015-01-15 00:18:16.000000', 'consum', 0.0214, 'lps'),
	(352139, 102, '2015-01-15 00:18:17.000000', 'consum', 0.0213, 'lps'),
	(352140, 102, '2015-01-15 00:18:18.000000', 'consum', 0.0211, 'lps'),
	(352141, 102, '2015-01-15 00:18:19.000000', 'consum', 0.0218, 'lps'),
	(352142, 102, '2015-01-15 00:18:20.000000', 'consum', 0.0218, 'lps'),
	(352143, 102, '2015-01-15 00:18:21.000000', 'consum', 0.0215, 'lps'),
	(352144, 102, '2015-01-15 00:18:22.000000', 'consum', 0.0214, 'lps'),
	(352145, 102, '2015-01-15 00:18:23.000000', 'consum', 0.0214, 'lps'),
	(352146, 102, '2015-01-15 00:18:24.000000', 'consum', 0.0217, 'lps'),
	(352147, 102, '2015-01-15 00:18:25.000000', 'consum', 0.0214, 'lps'),
	(352148, 102, '2015-01-15 00:18:26.000000', 'consum', 0.0210, 'lps'),
	(352149, 102, '2015-01-15 00:18:27.000000', 'consum', 0.0218, 'lps'),
	(352150, 102, '2015-01-15 00:18:28.000000', 'consum', 0.0210, 'lps'),
	(352151, 102, '2015-01-15 00:18:29.000000', 'consum', 0.0216, 'lps'),
	(352152, 102, '2015-01-15 00:18:30.000000', 'consum', 0.0212, 'lps'),
	(352153, 102, '2015-01-15 00:18:31.000000', 'consum', 0.0214, 'lps'),
	(352154, 102, '2015-01-15 00:18:32.000000', 'consum', 0.0214, 'lps'),
	(352155, 102, '2015-01-15 00:18:33.000000', 'consum', 0.0216, 'lps'),
	(352156, 102, '2015-01-15 00:18:34.000000', 'consum', 0.0210, 'lps'),
	(352157, 102, '2015-01-15 00:18:35.000000', 'consum', 0.0213, 'lps'),
	(352158, 102, '2015-01-15 00:18:36.000000', 'consum', 0.0217, 'lps'),
	(352159, 102, '2015-01-15 00:18:37.000000', 'consum', 0.0215, 'lps'),
	(352160, 102, '2015-01-15 00:18:38.000000', 'consum', 0.0217, 'lps'),
	(352161, 102, '2015-01-15 00:18:39.000000', 'consum', 0.0218, 'lps'),
	(352162, 102, '2015-01-15 00:18:40.000000', 'consum', 0.0219, 'lps'),
	(352163, 102, '2015-01-15 00:18:41.000000', 'consum', 0.0212, 'lps'),
	(352164, 102, '2015-01-15 00:18:42.000000', 'consum', 0.0214, 'lps'),
	(352165, 102, '2015-01-15 00:18:43.000000', 'consum', 0.0214, 'lps'),
	(352166, 102, '2015-01-15 00:18:44.000000', 'consum', 0.0210, 'lps'),
	(352167, 102, '2015-01-15 00:18:45.000000', 'consum', 0.0217, 'lps'),
	(352168, 102, '2015-01-15 00:18:46.000000', 'consum', 0.0215, 'lps'),
	(352169, 102, '2015-01-15 00:18:47.000000', 'consum', 0.0215, 'lps'),
	(352170, 102, '2015-01-15 00:18:48.000000', 'consum', 0.0211, 'lps'),
	(352171, 102, '2015-01-15 00:18:49.000000', 'consum', 0.0210, 'lps'),
	(352172, 102, '2015-01-15 00:18:50.000000', 'consum', 0.0219, 'lps'),
	(352173, 102, '2015-01-15 00:18:51.000000', 'consum', 0.0214, 'lps'),
	(352174, 102, '2015-01-15 00:18:52.000000', 'consum', 0.0212, 'lps'),
	(352175, 102, '2015-01-15 00:18:53.000000', 'consum', 0.0219, 'lps'),
	(352176, 102, '2015-01-15 00:18:54.000000', 'consum', 0.0212, 'lps'),
	(352177, 102, '2015-01-15 00:18:55.000000', 'consum', 0.0213, 'lps'),
	(352178, 102, '2015-01-15 00:18:56.000000', 'consum', 0.0217, 'lps'),
	(352179, 102, '2015-01-15 00:18:57.000000', 'consum', 0.0218, 'lps'),
	(352180, 102, '2015-01-15 00:18:58.000000', 'consum', 0.0218, 'lps'),
	(352181, 102, '2015-01-15 00:18:59.000000', 'consum', 0.0219, 'lps'),
	(352182, 102, '2015-01-15 00:19:00.000000', 'consum', 0.0211, 'lps'),
	(352183, 102, '2015-01-15 00:19:01.000000', 'consum', 0.0219, 'lps'),
	(352184, 102, '2015-01-15 00:19:02.000000', 'consum', 0.0214, 'lps'),
	(352185, 102, '2015-01-15 00:19:03.000000', 'consum', 0.0212, 'lps'),
	(352186, 102, '2015-01-15 00:19:04.000000', 'consum', 0.0219, 'lps'),
	(352187, 102, '2015-01-15 00:19:05.000000', 'consum', 0.0217, 'lps'),
	(352188, 102, '2015-01-15 00:19:06.000000', 'consum', 0.0210, 'lps'),
	(352189, 102, '2015-01-15 00:19:07.000000', 'consum', 0.0211, 'lps'),
	(352190, 102, '2015-01-15 00:19:08.000000', 'consum', 0.0213, 'lps'),
	(352191, 102, '2015-01-15 00:19:09.000000', 'consum', 0.0214, 'lps'),
	(352192, 102, '2015-01-15 00:19:10.000000', 'consum', 0.0212, 'lps'),
	(352193, 102, '2015-01-15 00:19:11.000000', 'consum', 0.0210, 'lps'),
	(352194, 102, '2015-01-15 00:19:12.000000', 'consum', 0.0212, 'lps'),
	(352195, 102, '2015-01-15 00:19:13.000000', 'consum', 0.0210, 'lps'),
	(352196, 102, '2015-01-15 00:19:14.000000', 'consum', 0.0213, 'lps'),
	(352197, 102, '2015-01-15 00:19:15.000000', 'consum', 0.0219, 'lps'),
	(352198, 102, '2015-01-15 00:19:16.000000', 'consum', 0.0216, 'lps'),
	(352199, 102, '2015-01-15 00:19:17.000000', 'consum', 0.0212, 'lps'),
	(352200, 102, '2015-01-15 00:19:18.000000', 'consum', 0.0212, 'lps'),
	(352201, 102, '2015-01-15 00:19:19.000000', 'consum', 0.0214, 'lps'),
	(352202, 102, '2015-01-15 00:19:20.000000', 'consum', 0.0216, 'lps'),
	(352203, 102, '2015-01-15 00:19:21.000000', 'consum', 0.0219, 'lps'),
	(352204, 102, '2015-01-15 00:19:22.000000', 'consum', 0.0219, 'lps'),
	(352205, 102, '2015-01-15 00:19:23.000000', 'consum', 0.0215, 'lps'),
	(352206, 102, '2015-01-15 00:19:24.000000', 'consum', 0.0210, 'lps'),
	(352207, 102, '2015-01-15 00:19:25.000000', 'consum', 0.0214, 'lps'),
	(352208, 102, '2015-01-15 00:19:26.000000', 'consum', 0.0212, 'lps'),
	(352209, 102, '2015-01-15 00:19:27.000000', 'consum', 0.0210, 'lps'),
	(352210, 102, '2015-01-15 00:19:28.000000', 'consum', 0.0213, 'lps'),
	(352211, 102, '2015-01-15 00:19:29.000000', 'consum', 0.0216, 'lps'),
	(352212, 102, '2015-01-15 00:19:30.000000', 'consum', 0.0212, 'lps'),
	(352213, 102, '2015-01-15 00:19:31.000000', 'consum', 0.0210, 'lps'),
	(352214, 102, '2015-01-15 00:19:32.000000', 'consum', 0.0216, 'lps'),
	(352215, 102, '2015-01-15 00:19:33.000000', 'consum', 0.0210, 'lps'),
	(352216, 102, '2015-01-15 00:19:34.000000', 'consum', 0.0211, 'lps'),
	(352217, 102, '2015-01-15 00:19:35.000000', 'consum', 0.0218, 'lps'),
	(352218, 102, '2015-01-15 00:19:36.000000', 'consum', 0.0216, 'lps'),
	(352219, 102, '2015-01-15 00:19:37.000000', 'consum', 0.0219, 'lps'),
	(352220, 102, '2015-01-15 00:19:38.000000', 'consum', 0.0215, 'lps'),
	(352221, 102, '2015-01-15 00:19:39.000000', 'consum', 0.0218, 'lps'),
	(352222, 102, '2015-01-15 00:19:40.000000', 'consum', 0.0215, 'lps'),
	(352223, 102, '2015-01-15 00:19:41.000000', 'consum', 0.0214, 'lps'),
	(352224, 102, '2015-01-15 00:19:42.000000', 'consum', 0.0214, 'lps'),
	(352225, 102, '2015-01-15 00:19:43.000000', 'consum', 0.0211, 'lps'),
	(352226, 102, '2015-01-15 00:19:44.000000', 'consum', 0.0212, 'lps'),
	(352227, 102, '2015-01-15 00:19:45.000000', 'consum', 0.0215, 'lps'),
	(352228, 102, '2015-01-15 00:19:46.000000', 'consum', 0.0213, 'lps'),
	(352229, 102, '2015-01-15 00:19:47.000000', 'consum', 0.0211, 'lps'),
	(352230, 102, '2015-01-15 00:19:48.000000', 'consum', 0.0214, 'lps'),
	(352231, 102, '2015-01-15 00:19:49.000000', 'consum', 0.0217, 'lps'),
	(352232, 102, '2015-01-15 00:19:50.000000', 'consum', 0.0215, 'lps'),
	(352233, 102, '2015-01-15 00:19:51.000000', 'consum', 0.0214, 'lps'),
	(352234, 102, '2015-01-15 00:19:52.000000', 'consum', 0.0215, 'lps'),
	(352235, 102, '2015-01-15 00:19:53.000000', 'consum', 0.0215, 'lps'),
	(352236, 102, '2015-01-15 00:19:54.000000', 'consum', 0.0210, 'lps'),
	(352237, 102, '2015-01-15 00:19:55.000000', 'consum', 0.0214, 'lps'),
	(352238, 102, '2015-01-15 00:19:56.000000', 'consum', 0.0211, 'lps'),
	(352239, 102, '2015-01-15 00:19:57.000000', 'consum', 0.0214, 'lps'),
	(352240, 102, '2015-01-15 00:19:58.000000', 'consum', 0.0217, 'lps'),
	(352241, 102, '2015-01-15 00:19:59.000000', 'consum', 0.0212, 'lps'),
	(352242, 102, '2015-01-15 00:20:00.000000', 'consum', 0.0213, 'lps'),
	(352243, 102, '2015-01-15 00:20:01.000000', 'consum', 0.0217, 'lps'),
	(352244, 102, '2015-01-15 00:20:02.000000', 'consum', 0.0216, 'lps'),
	(352245, 102, '2015-01-15 00:20:03.000000', 'consum', 0.0218, 'lps'),
	(352246, 102, '2015-01-15 00:20:04.000000', 'consum', 0.0215, 'lps'),
	(352247, 102, '2015-01-15 00:20:05.000000', 'consum', 0.0211, 'lps'),
	(352248, 102, '2015-01-15 00:20:06.000000', 'consum', 0.0213, 'lps'),
	(352249, 102, '2015-01-15 00:20:07.000000', 'consum', 0.0219, 'lps'),
	(352250, 102, '2015-01-15 00:20:08.000000', 'consum', 0.0216, 'lps'),
	(352251, 102, '2015-01-15 00:20:09.000000', 'consum', 0.0215, 'lps'),
	(352252, 102, '2015-01-15 00:20:10.000000', 'consum', 0.0215, 'lps'),
	(352253, 102, '2015-01-15 00:20:11.000000', 'consum', 0.0213, 'lps'),
	(352254, 102, '2015-01-15 00:20:12.000000', 'consum', 0.0212, 'lps'),
	(352255, 102, '2015-01-15 00:20:13.000000', 'consum', 0.0219, 'lps'),
	(352256, 102, '2015-01-15 00:20:14.000000', 'consum', 0.0210, 'lps'),
	(352257, 102, '2015-01-15 00:20:15.000000', 'consum', 0.0213, 'lps'),
	(352258, 102, '2015-01-15 00:20:16.000000', 'consum', 0.0218, 'lps'),
	(352259, 102, '2015-01-15 00:20:17.000000', 'consum', 0.0219, 'lps'),
	(352260, 102, '2015-01-15 00:20:18.000000', 'consum', 0.0213, 'lps'),
	(352261, 102, '2015-01-15 00:20:19.000000', 'consum', 0.0218, 'lps'),
	(352262, 102, '2015-01-15 00:20:20.000000', 'consum', 0.0213, 'lps'),
	(352263, 102, '2015-01-15 00:20:21.000000', 'consum', 0.0219, 'lps'),
	(352264, 102, '2015-01-15 00:20:22.000000', 'consum', 0.0216, 'lps'),
	(352265, 102, '2015-01-15 00:20:23.000000', 'consum', 0.0215, 'lps'),
	(352266, 102, '2015-01-15 00:20:24.000000', 'consum', 0.0217, 'lps'),
	(352267, 102, '2015-01-15 00:20:25.000000', 'consum', 0.0212, 'lps'),
	(352268, 102, '2015-01-15 00:20:26.000000', 'consum', 0.0218, 'lps'),
	(352269, 102, '2015-01-15 00:20:27.000000', 'consum', 0.0216, 'lps'),
	(352270, 102, '2015-01-15 00:20:28.000000', 'consum', 0.0216, 'lps'),
	(352271, 102, '2015-01-15 00:20:29.000000', 'consum', 0.0213, 'lps'),
	(352272, 102, '2015-01-15 00:20:30.000000', 'consum', 0.0217, 'lps'),
	(352273, 102, '2015-01-15 00:20:31.000000', 'consum', 0.0217, 'lps'),
	(352274, 102, '2015-01-15 00:20:32.000000', 'consum', 0.0213, 'lps'),
	(352275, 102, '2015-01-15 00:20:33.000000', 'consum', 0.0216, 'lps'),
	(352276, 102, '2015-01-15 00:20:34.000000', 'consum', 0.0211, 'lps'),
	(352277, 102, '2015-01-15 00:20:35.000000', 'consum', 0.0218, 'lps'),
	(352278, 102, '2015-01-15 00:20:36.000000', 'consum', 0.0219, 'lps'),
	(352279, 102, '2015-01-15 00:20:37.000000', 'consum', 0.0210, 'lps'),
	(352280, 102, '2015-01-15 00:20:38.000000', 'consum', 0.0213, 'lps'),
	(352281, 102, '2015-01-15 00:20:39.000000', 'consum', 0.0214, 'lps'),
	(352282, 102, '2015-01-15 00:20:40.000000', 'consum', 0.0212, 'lps'),
	(352283, 102, '2015-01-15 00:20:41.000000', 'consum', 0.0211, 'lps'),
	(352284, 102, '2015-01-15 00:20:42.000000', 'consum', 0.0219, 'lps'),
	(352285, 102, '2015-01-15 00:20:43.000000', 'consum', 0.0211, 'lps'),
	(352286, 102, '2015-01-15 00:20:44.000000', 'consum', 0.0211, 'lps'),
	(352287, 102, '2015-01-15 00:20:45.000000', 'consum', 0.0219, 'lps'),
	(352288, 102, '2015-01-15 00:20:46.000000', 'consum', 0.0215, 'lps'),
	(352289, 102, '2015-01-15 00:20:47.000000', 'consum', 0.0216, 'lps'),
	(352290, 102, '2015-01-15 00:20:48.000000', 'consum', 0.0218, 'lps'),
	(352291, 102, '2015-01-15 00:20:49.000000', 'consum', 0.0213, 'lps'),
	(352292, 102, '2015-01-15 00:20:50.000000', 'consum', 0.0212, 'lps'),
	(352293, 102, '2015-01-15 00:20:51.000000', 'consum', 0.0210, 'lps'),
	(352294, 102, '2015-01-15 00:20:52.000000', 'consum', 0.0213, 'lps'),
	(352295, 102, '2015-01-15 00:20:53.000000', 'consum', 0.0216, 'lps'),
	(352296, 102, '2015-01-15 00:20:54.000000', 'consum', 0.0211, 'lps'),
	(352297, 102, '2015-01-15 00:20:55.000000', 'consum', 0.0218, 'lps'),
	(352298, 102, '2015-01-15 00:20:56.000000', 'consum', 0.0216, 'lps'),
	(352299, 102, '2015-01-15 00:20:57.000000', 'consum', 0.0217, 'lps'),
	(352300, 102, '2015-01-15 00:20:58.000000', 'consum', 0.0219, 'lps'),
	(352301, 102, '2015-01-15 00:20:59.000000', 'consum', 0.0213, 'lps'),
	(352302, 102, '2015-01-15 00:21:00.000000', 'consum', 0.0217, 'lps'),
	(352303, 102, '2015-01-15 00:21:01.000000', 'consum', 0.0218, 'lps'),
	(352304, 102, '2015-01-15 00:21:02.000000', 'consum', 0.0217, 'lps'),
	(352305, 102, '2015-01-15 00:21:03.000000', 'consum', 0.0214, 'lps'),
	(352306, 102, '2015-01-15 00:21:04.000000', 'consum', 0.0211, 'lps'),
	(352307, 102, '2015-01-15 00:21:05.000000', 'consum', 0.0212, 'lps'),
	(352308, 102, '2015-01-15 00:21:06.000000', 'consum', 0.0218, 'lps'),
	(352309, 102, '2015-01-15 00:21:07.000000', 'consum', 0.0216, 'lps'),
	(352310, 102, '2015-01-15 00:21:08.000000', 'consum', 0.0215, 'lps'),
	(352311, 102, '2015-01-15 00:21:09.000000', 'consum', 0.0217, 'lps'),
	(352312, 102, '2015-01-15 00:21:10.000000', 'consum', 0.0211, 'lps'),
	(352313, 102, '2015-01-15 00:21:11.000000', 'consum', 0.0214, 'lps'),
	(352314, 102, '2015-01-15 00:21:12.000000', 'consum', 0.0217, 'lps'),
	(352315, 102, '2015-01-15 00:21:13.000000', 'consum', 0.0214, 'lps'),
	(352316, 102, '2015-01-15 00:21:14.000000', 'consum', 0.0219, 'lps'),
	(352317, 102, '2015-01-15 00:21:15.000000', 'consum', 0.0212, 'lps'),
	(352318, 102, '2015-01-15 00:21:16.000000', 'consum', 0.0216, 'lps'),
	(352319, 102, '2015-01-15 00:21:17.000000', 'consum', 0.0212, 'lps'),
	(352320, 102, '2015-01-15 00:21:18.000000', 'consum', 0.0214, 'lps'),
	(352321, 102, '2015-01-15 00:21:19.000000', 'consum', 0.0214, 'lps'),
	(352322, 102, '2015-01-15 00:21:20.000000', 'consum', 0.0219, 'lps'),
	(352323, 102, '2015-01-15 00:21:21.000000', 'consum', 0.0211, 'lps'),
	(352324, 102, '2015-01-15 00:21:22.000000', 'consum', 0.0212, 'lps'),
	(352325, 102, '2015-01-15 00:21:23.000000', 'consum', 0.0217, 'lps'),
	(352326, 102, '2015-01-15 00:21:24.000000', 'consum', 0.0218, 'lps'),
	(352327, 102, '2015-01-15 00:21:25.000000', 'consum', 0.0219, 'lps'),
	(352328, 102, '2015-01-15 00:21:26.000000', 'consum', 0.0211, 'lps'),
	(352329, 102, '2015-01-15 00:21:27.000000', 'consum', 0.0218, 'lps'),
	(352330, 102, '2015-01-15 00:21:28.000000', 'consum', 0.0218, 'lps'),
	(352331, 102, '2015-01-15 00:21:29.000000', 'consum', 0.0215, 'lps'),
	(352332, 102, '2015-01-15 00:21:30.000000', 'consum', 0.0214, 'lps'),
	(352333, 102, '2015-01-15 00:21:31.000000', 'consum', 0.0217, 'lps'),
	(352334, 102, '2015-01-15 00:21:32.000000', 'consum', 0.0210, 'lps'),
	(352335, 102, '2015-01-15 00:21:33.000000', 'consum', 0.0210, 'lps'),
	(352336, 102, '2015-01-15 00:21:34.000000', 'consum', 0.0211, 'lps'),
	(352337, 102, '2015-01-15 00:21:35.000000', 'consum', 0.0217, 'lps'),
	(352338, 102, '2015-01-15 00:21:36.000000', 'consum', 0.0212, 'lps'),
	(352339, 102, '2015-01-15 00:21:37.000000', 'consum', 0.0210, 'lps'),
	(352340, 102, '2015-01-15 00:21:38.000000', 'consum', 0.0215, 'lps'),
	(352341, 102, '2015-01-15 00:21:39.000000', 'consum', 0.0213, 'lps'),
	(352342, 102, '2015-01-15 00:21:40.000000', 'consum', 0.0212, 'lps'),
	(352343, 102, '2015-01-15 00:21:41.000000', 'consum', 0.0219, 'lps'),
	(352344, 102, '2015-01-15 00:21:42.000000', 'consum', 0.0213, 'lps'),
	(352345, 102, '2015-01-15 00:21:43.000000', 'consum', 0.0216, 'lps'),
	(352346, 102, '2015-01-15 00:21:44.000000', 'consum', 0.0212, 'lps'),
	(352347, 102, '2015-01-15 00:21:45.000000', 'consum', 0.0212, 'lps'),
	(352348, 102, '2015-01-15 00:21:46.000000', 'consum', 0.0216, 'lps'),
	(352349, 102, '2015-01-15 00:21:47.000000', 'consum', 0.0214, 'lps'),
	(352350, 102, '2015-01-15 00:21:48.000000', 'consum', 0.0212, 'lps'),
	(352351, 102, '2015-01-15 00:21:49.000000', 'consum', 0.0210, 'lps'),
	(352352, 102, '2015-01-15 00:21:50.000000', 'consum', 0.0212, 'lps'),
	(352353, 102, '2015-01-15 00:21:51.000000', 'consum', 0.0212, 'lps'),
	(352354, 102, '2015-01-15 00:21:52.000000', 'consum', 0.0214, 'lps'),
	(352355, 102, '2015-01-15 00:21:53.000000', 'consum', 0.0216, 'lps'),
	(352356, 102, '2015-01-15 00:21:54.000000', 'consum', 0.0219, 'lps'),
	(352357, 102, '2015-01-15 00:21:55.000000', 'consum', 0.0218, 'lps'),
	(352358, 102, '2015-01-15 00:21:56.000000', 'consum', 0.0211, 'lps'),
	(352359, 102, '2015-01-15 00:21:57.000000', 'consum', 0.0214, 'lps'),
	(352360, 102, '2015-01-15 00:21:58.000000', 'consum', 0.0217, 'lps'),
	(352361, 102, '2015-01-15 00:21:59.000000', 'consum', 0.0211, 'lps'),
	(352362, 102, '2015-01-15 00:22:00.000000', 'consum', 0.0217, 'lps'),
	(352363, 102, '2015-01-15 00:22:01.000000', 'consum', 0.0213, 'lps'),
	(352364, 102, '2015-01-15 00:22:02.000000', 'consum', 0.0213, 'lps'),
	(352365, 102, '2015-01-15 00:22:03.000000', 'consum', 0.0218, 'lps'),
	(352366, 102, '2015-01-15 00:22:04.000000', 'consum', 0.0219, 'lps'),
	(352367, 102, '2015-01-15 00:22:05.000000', 'consum', 0.0214, 'lps'),
	(352368, 102, '2015-01-15 00:22:06.000000', 'consum', 0.0214, 'lps'),
	(352369, 102, '2015-01-15 00:22:07.000000', 'consum', 0.0216, 'lps'),
	(352370, 102, '2015-01-15 00:22:08.000000', 'consum', 0.0210, 'lps'),
	(352371, 102, '2015-01-15 00:22:09.000000', 'consum', 0.0214, 'lps'),
	(352372, 102, '2015-01-15 00:22:10.000000', 'consum', 0.0218, 'lps'),
	(352373, 102, '2015-01-15 00:22:11.000000', 'consum', 0.0210, 'lps'),
	(352374, 102, '2015-01-15 00:22:12.000000', 'consum', 0.0218, 'lps'),
	(352375, 102, '2015-01-15 00:22:13.000000', 'consum', 0.0219, 'lps'),
	(352376, 102, '2015-01-15 00:22:14.000000', 'consum', 0.0213, 'lps'),
	(352377, 102, '2015-01-15 00:22:15.000000', 'consum', 0.0219, 'lps'),
	(352378, 102, '2015-01-15 00:22:16.000000', 'consum', 0.0214, 'lps'),
	(352379, 102, '2015-01-15 00:22:17.000000', 'consum', 0.0213, 'lps'),
	(352380, 102, '2015-01-15 00:22:18.000000', 'consum', 0.0216, 'lps'),
	(352381, 102, '2015-01-15 00:22:19.000000', 'consum', 0.0212, 'lps'),
	(352382, 102, '2015-01-15 00:22:20.000000', 'consum', 0.0211, 'lps'),
	(352383, 102, '2015-01-15 00:22:21.000000', 'consum', 0.0210, 'lps'),
	(352384, 102, '2015-01-15 00:22:22.000000', 'consum', 0.0217, 'lps'),
	(352385, 102, '2015-01-15 00:22:23.000000', 'consum', 0.0216, 'lps'),
	(352386, 102, '2015-01-15 00:22:24.000000', 'consum', 0.0211, 'lps'),
	(352387, 102, '2015-01-15 00:22:25.000000', 'consum', 0.0214, 'lps'),
	(352388, 102, '2015-01-15 00:22:26.000000', 'consum', 0.0211, 'lps'),
	(352389, 102, '2015-01-15 00:22:27.000000', 'consum', 0.0211, 'lps'),
	(352390, 102, '2015-01-15 00:22:28.000000', 'consum', 0.0214, 'lps'),
	(352391, 102, '2015-01-15 00:22:29.000000', 'consum', 0.0217, 'lps'),
	(352392, 102, '2015-01-15 00:22:30.000000', 'consum', 0.0214, 'lps'),
	(352393, 102, '2015-01-15 00:22:31.000000', 'consum', 0.0211, 'lps'),
	(352394, 102, '2015-01-15 00:22:32.000000', 'consum', 0.0212, 'lps'),
	(352395, 102, '2015-01-15 00:22:33.000000', 'consum', 0.0217, 'lps'),
	(352396, 102, '2015-01-15 00:22:34.000000', 'consum', 0.0211, 'lps'),
	(352397, 102, '2015-01-15 00:22:35.000000', 'consum', 0.0215, 'lps'),
	(352398, 102, '2015-01-15 00:22:36.000000', 'consum', 0.0210, 'lps'),
	(352399, 102, '2015-01-15 00:22:37.000000', 'consum', 0.0219, 'lps'),
	(352400, 102, '2015-01-15 00:22:38.000000', 'consum', 0.0212, 'lps'),
	(352401, 102, '2015-01-15 00:22:39.000000', 'consum', 0.0214, 'lps'),
	(352402, 102, '2015-01-15 00:22:40.000000', 'consum', 0.0215, 'lps'),
	(352403, 102, '2015-01-15 00:22:41.000000', 'consum', 0.0213, 'lps'),
	(352404, 102, '2015-01-15 00:22:42.000000', 'consum', 0.0219, 'lps'),
	(352405, 102, '2015-01-15 00:22:43.000000', 'consum', 0.0219, 'lps'),
	(352406, 102, '2015-01-15 00:22:44.000000', 'consum', 0.0218, 'lps'),
	(352407, 102, '2015-01-15 00:22:45.000000', 'consum', 0.0212, 'lps'),
	(352408, 102, '2015-01-15 00:22:46.000000', 'consum', 0.0216, 'lps'),
	(352409, 102, '2015-01-15 00:22:47.000000', 'consum', 0.0215, 'lps'),
	(352410, 102, '2015-01-15 00:22:48.000000', 'consum', 0.0216, 'lps'),
	(352411, 102, '2015-01-15 00:22:49.000000', 'consum', 0.0217, 'lps'),
	(352412, 102, '2015-01-15 00:22:50.000000', 'consum', 0.0217, 'lps'),
	(352413, 102, '2015-01-15 00:22:51.000000', 'consum', 0.0215, 'lps'),
	(352414, 102, '2015-01-15 00:22:52.000000', 'consum', 0.0215, 'lps'),
	(352415, 102, '2015-01-15 00:22:53.000000', 'consum', 0.0212, 'lps'),
	(352416, 102, '2015-01-15 00:22:54.000000', 'consum', 0.0214, 'lps'),
	(352417, 102, '2015-01-15 00:22:55.000000', 'consum', 0.0213, 'lps'),
	(352418, 102, '2015-01-15 00:22:56.000000', 'consum', 0.0214, 'lps'),
	(352419, 102, '2015-01-15 00:22:57.000000', 'consum', 0.0212, 'lps'),
	(352420, 102, '2015-01-15 00:22:58.000000', 'consum', 0.0219, 'lps'),
	(352421, 102, '2015-01-15 00:22:59.000000', 'consum', 0.0217, 'lps'),
	(352422, 102, '2015-01-15 00:23:00.000000', 'consum', 0.0212, 'lps'),
	(352423, 102, '2015-01-15 00:23:01.000000', 'consum', 0.0217, 'lps'),
	(352424, 102, '2015-01-15 00:23:02.000000', 'consum', 0.0211, 'lps'),
	(352425, 102, '2015-01-15 00:23:03.000000', 'consum', 0.0214, 'lps'),
	(352426, 102, '2015-01-15 00:23:04.000000', 'consum', 0.0219, 'lps'),
	(352427, 102, '2015-01-15 00:23:05.000000', 'consum', 0.0213, 'lps'),
	(352428, 102, '2015-01-15 00:23:06.000000', 'consum', 0.0219, 'lps'),
	(352429, 102, '2015-01-15 00:23:07.000000', 'consum', 0.0216, 'lps'),
	(352430, 102, '2015-01-15 00:23:08.000000', 'consum', 0.0212, 'lps'),
	(352431, 102, '2015-01-15 00:23:09.000000', 'consum', 0.0212, 'lps'),
	(352432, 102, '2015-01-15 00:23:10.000000', 'consum', 0.0215, 'lps'),
	(352433, 102, '2015-01-15 00:23:11.000000', 'consum', 0.0212, 'lps'),
	(352434, 102, '2015-01-15 00:23:12.000000', 'consum', 0.0213, 'lps'),
	(352435, 102, '2015-01-15 00:23:13.000000', 'consum', 0.0219, 'lps'),
	(352436, 102, '2015-01-15 00:23:14.000000', 'consum', 0.0219, 'lps'),
	(352437, 102, '2015-01-15 00:23:15.000000', 'consum', 0.0217, 'lps'),
	(352438, 102, '2015-01-15 00:23:16.000000', 'consum', 0.0211, 'lps'),
	(352439, 102, '2015-01-15 00:23:17.000000', 'consum', 0.0211, 'lps'),
	(352440, 102, '2015-01-15 00:23:18.000000', 'consum', 0.0214, 'lps'),
	(352441, 102, '2015-01-15 00:23:19.000000', 'consum', 0.0219, 'lps'),
	(352442, 102, '2015-01-15 00:23:20.000000', 'consum', 0.0211, 'lps'),
	(352443, 102, '2015-01-15 00:23:21.000000', 'consum', 0.0218, 'lps'),
	(352444, 102, '2015-01-15 00:23:22.000000', 'consum', 0.0219, 'lps'),
	(352445, 102, '2015-01-15 00:23:23.000000', 'consum', 0.0210, 'lps'),
	(352446, 102, '2015-01-15 00:23:24.000000', 'consum', 0.0214, 'lps'),
	(352447, 102, '2015-01-15 00:23:25.000000', 'consum', 0.0211, 'lps'),
	(352448, 102, '2015-01-15 00:23:26.000000', 'consum', 0.0215, 'lps'),
	(352449, 102, '2015-01-15 00:23:27.000000', 'consum', 0.0210, 'lps'),
	(352450, 102, '2015-01-15 00:23:28.000000', 'consum', 0.0216, 'lps'),
	(352451, 102, '2015-01-15 00:23:29.000000', 'consum', 0.0211, 'lps'),
	(352452, 102, '2015-01-15 00:23:30.000000', 'consum', 0.0219, 'lps'),
	(352453, 102, '2015-01-15 00:23:31.000000', 'consum', 0.0212, 'lps'),
	(352454, 102, '2015-01-15 00:23:32.000000', 'consum', 0.0211, 'lps'),
	(352455, 102, '2015-01-15 00:23:33.000000', 'consum', 0.0213, 'lps'),
	(352456, 102, '2015-01-15 00:23:34.000000', 'consum', 0.0219, 'lps'),
	(352457, 102, '2015-01-15 00:23:35.000000', 'consum', 0.0218, 'lps'),
	(352458, 102, '2015-01-15 00:23:36.000000', 'consum', 0.0215, 'lps'),
	(352459, 102, '2015-01-15 00:23:37.000000', 'consum', 0.0211, 'lps'),
	(352460, 102, '2015-01-15 00:23:38.000000', 'consum', 0.0219, 'lps'),
	(352461, 102, '2015-01-15 00:23:39.000000', 'consum', 0.0215, 'lps'),
	(352462, 102, '2015-01-15 00:23:40.000000', 'consum', 0.0219, 'lps'),
	(352463, 102, '2015-01-15 00:23:41.000000', 'consum', 0.0218, 'lps'),
	(352464, 102, '2015-01-15 00:23:42.000000', 'consum', 0.0212, 'lps'),
	(352465, 102, '2015-01-15 00:23:43.000000', 'consum', 0.0210, 'lps'),
	(352466, 102, '2015-01-15 00:23:44.000000', 'consum', 0.0213, 'lps'),
	(352467, 102, '2015-01-15 00:23:45.000000', 'consum', 0.0217, 'lps'),
	(352468, 102, '2015-01-15 00:23:46.000000', 'consum', 0.0216, 'lps'),
	(352469, 102, '2015-01-15 00:23:47.000000', 'consum', 0.0211, 'lps'),
	(352470, 102, '2015-01-15 00:23:48.000000', 'consum', 0.0216, 'lps'),
	(352471, 102, '2015-01-15 00:23:49.000000', 'consum', 0.0219, 'lps'),
	(352472, 102, '2015-01-15 00:23:50.000000', 'consum', 0.0217, 'lps'),
	(352473, 102, '2015-01-15 00:23:51.000000', 'consum', 0.0218, 'lps'),
	(352474, 102, '2015-01-15 00:23:52.000000', 'consum', 0.0218, 'lps'),
	(352475, 102, '2015-01-15 00:23:53.000000', 'consum', 0.0219, 'lps'),
	(352476, 102, '2015-01-15 00:23:54.000000', 'consum', 0.0219, 'lps'),
	(352477, 102, '2015-01-15 00:23:55.000000', 'consum', 0.0219, 'lps'),
	(352478, 102, '2015-01-15 00:23:56.000000', 'consum', 0.0217, 'lps'),
	(352479, 102, '2015-01-15 00:23:57.000000', 'consum', 0.0219, 'lps'),
	(352480, 102, '2015-01-15 00:23:58.000000', 'consum', 0.0216, 'lps'),
	(352481, 102, '2015-01-15 00:23:59.000000', 'consum', 0.0212, 'lps'),
	(352482, 102, '2015-01-15 00:24:00.000000', 'consum', 0.0213, 'lps'),
	(352483, 102, '2015-01-15 00:24:01.000000', 'consum', 0.0219, 'lps'),
	(352484, 102, '2015-01-15 00:24:02.000000', 'consum', 0.0216, 'lps'),
	(352485, 102, '2015-01-15 00:24:03.000000', 'consum', 0.0215, 'lps'),
	(352486, 102, '2015-01-15 00:24:04.000000', 'consum', 0.0217, 'lps'),
	(352487, 102, '2015-01-15 00:24:05.000000', 'consum', 0.0218, 'lps'),
	(352488, 102, '2015-01-15 00:24:06.000000', 'consum', 0.0212, 'lps'),
	(352489, 102, '2015-01-15 00:24:07.000000', 'consum', 0.0218, 'lps'),
	(352490, 102, '2015-01-15 00:24:08.000000', 'consum', 0.0211, 'lps'),
	(352491, 102, '2015-01-15 00:24:09.000000', 'consum', 0.0213, 'lps'),
	(352492, 102, '2015-01-15 00:24:10.000000', 'consum', 0.0214, 'lps'),
	(352493, 102, '2015-01-15 00:24:11.000000', 'consum', 0.0211, 'lps'),
	(352494, 102, '2015-01-15 00:24:12.000000', 'consum', 0.0214, 'lps'),
	(352495, 102, '2015-01-15 00:24:13.000000', 'consum', 0.0218, 'lps'),
	(352496, 102, '2015-01-15 00:24:14.000000', 'consum', 0.0217, 'lps'),
	(352497, 102, '2015-01-15 00:24:15.000000', 'consum', 0.0214, 'lps'),
	(352498, 102, '2015-01-15 00:24:16.000000', 'consum', 0.0217, 'lps'),
	(352499, 102, '2015-01-15 00:24:17.000000', 'consum', 0.0212, 'lps'),
	(352500, 102, '2015-01-15 00:24:18.000000', 'consum', 0.0212, 'lps'),
	(352501, 102, '2015-01-15 00:24:19.000000', 'consum', 0.0214, 'lps'),
	(352502, 102, '2015-01-15 00:24:20.000000', 'consum', 0.0215, 'lps'),
	(352503, 102, '2015-01-15 00:24:21.000000', 'consum', 0.0211, 'lps'),
	(352504, 102, '2015-01-15 00:24:22.000000', 'consum', 0.0212, 'lps'),
	(352505, 102, '2015-01-15 00:24:23.000000', 'consum', 0.0216, 'lps'),
	(352506, 102, '2015-01-15 00:24:24.000000', 'consum', 0.0217, 'lps'),
	(352507, 102, '2015-01-15 00:24:25.000000', 'consum', 0.0215, 'lps'),
	(352508, 102, '2015-01-15 00:24:26.000000', 'consum', 0.0218, 'lps'),
	(352509, 102, '2015-01-15 00:24:27.000000', 'consum', 0.0212, 'lps'),
	(352510, 102, '2015-01-15 00:24:28.000000', 'consum', 0.0218, 'lps'),
	(352511, 102, '2015-01-15 00:24:29.000000', 'consum', 0.0213, 'lps'),
	(352512, 102, '2015-01-15 00:24:30.000000', 'consum', 0.0212, 'lps'),
	(352513, 102, '2015-01-15 00:24:31.000000', 'consum', 0.0210, 'lps'),
	(352514, 102, '2015-01-15 00:24:32.000000', 'consum', 0.0217, 'lps'),
	(352515, 102, '2015-01-15 00:24:33.000000', 'consum', 0.0214, 'lps'),
	(352516, 102, '2015-01-15 00:24:34.000000', 'consum', 0.0212, 'lps'),
	(352517, 102, '2015-01-15 00:24:35.000000', 'consum', 0.0215, 'lps'),
	(352518, 102, '2015-01-15 00:24:36.000000', 'consum', 0.0213, 'lps'),
	(352519, 102, '2015-01-15 00:24:37.000000', 'consum', 0.0218, 'lps'),
	(352520, 102, '2015-01-15 00:24:38.000000', 'consum', 0.0214, 'lps'),
	(352521, 102, '2015-01-15 00:24:39.000000', 'consum', 0.0216, 'lps'),
	(352522, 102, '2015-01-15 00:24:40.000000', 'consum', 0.0216, 'lps'),
	(352523, 102, '2015-01-15 00:24:41.000000', 'consum', 0.0214, 'lps'),
	(352524, 102, '2015-01-15 00:24:42.000000', 'consum', 0.0213, 'lps'),
	(352525, 102, '2015-01-15 00:24:43.000000', 'consum', 0.0211, 'lps'),
	(352526, 102, '2015-01-15 00:24:44.000000', 'consum', 0.0210, 'lps'),
	(352527, 102, '2015-01-15 00:24:45.000000', 'consum', 0.0215, 'lps'),
	(352528, 102, '2015-01-15 00:24:46.000000', 'consum', 0.0216, 'lps'),
	(352529, 102, '2015-01-15 00:24:47.000000', 'consum', 0.0215, 'lps'),
	(352530, 102, '2015-01-15 00:24:48.000000', 'consum', 0.0218, 'lps'),
	(352531, 102, '2015-01-15 00:24:49.000000', 'consum', 0.0214, 'lps'),
	(352532, 102, '2015-01-15 00:24:50.000000', 'consum', 0.0218, 'lps'),
	(352533, 102, '2015-01-15 00:24:51.000000', 'consum', 0.0217, 'lps'),
	(352534, 102, '2015-01-15 00:24:52.000000', 'consum', 0.0211, 'lps'),
	(352535, 102, '2015-01-15 00:24:53.000000', 'consum', 0.0214, 'lps'),
	(352536, 102, '2015-01-15 00:24:54.000000', 'consum', 0.0218, 'lps'),
	(352537, 102, '2015-01-15 00:24:55.000000', 'consum', 0.0210, 'lps'),
	(352538, 102, '2015-01-15 00:24:56.000000', 'consum', 0.0218, 'lps'),
	(352539, 102, '2015-01-15 00:24:57.000000', 'consum', 0.0217, 'lps'),
	(352540, 102, '2015-01-15 00:24:58.000000', 'consum', 0.0213, 'lps'),
	(352541, 102, '2015-01-15 00:24:59.000000', 'consum', 0.0215, 'lps'),
	(352542, 102, '2015-01-15 00:25:00.000000', 'consum', 0.0214, 'lps'),
	(352543, 102, '2015-01-15 00:25:01.000000', 'consum', 0.0217, 'lps'),
	(352544, 102, '2015-01-15 00:25:02.000000', 'consum', 0.0214, 'lps'),
	(352545, 102, '2015-01-15 00:25:03.000000', 'consum', 0.0211, 'lps'),
	(352546, 102, '2015-01-15 00:25:04.000000', 'consum', 0.0210, 'lps'),
	(352547, 102, '2015-01-15 00:25:05.000000', 'consum', 0.0210, 'lps'),
	(352548, 102, '2015-01-15 00:25:06.000000', 'consum', 0.0212, 'lps'),
	(352549, 102, '2015-01-15 00:25:07.000000', 'consum', 0.0218, 'lps'),
	(352550, 102, '2015-01-15 00:25:08.000000', 'consum', 0.0217, 'lps'),
	(352551, 102, '2015-01-15 00:25:09.000000', 'consum', 0.0210, 'lps'),
	(352552, 102, '2015-01-15 00:25:10.000000', 'consum', 0.0210, 'lps'),
	(352553, 102, '2015-01-15 00:25:11.000000', 'consum', 0.0218, 'lps'),
	(352554, 102, '2015-01-15 00:25:12.000000', 'consum', 0.0213, 'lps'),
	(352555, 102, '2015-01-15 00:25:13.000000', 'consum', 0.0211, 'lps'),
	(352556, 102, '2015-01-15 00:25:14.000000', 'consum', 0.0217, 'lps'),
	(352557, 102, '2015-01-15 00:25:15.000000', 'consum', 0.0214, 'lps'),
	(352558, 102, '2015-01-15 00:25:16.000000', 'consum', 0.0219, 'lps'),
	(352559, 102, '2015-01-15 00:25:17.000000', 'consum', 0.0211, 'lps'),
	(352560, 102, '2015-01-15 00:25:18.000000', 'consum', 0.0210, 'lps'),
	(352561, 102, '2015-01-15 00:25:19.000000', 'consum', 0.0215, 'lps'),
	(352562, 102, '2015-01-15 00:25:20.000000', 'consum', 0.0218, 'lps'),
	(352563, 102, '2015-01-15 00:25:21.000000', 'consum', 0.0217, 'lps'),
	(352564, 102, '2015-01-15 00:25:22.000000', 'consum', 0.0218, 'lps'),
	(352565, 102, '2015-01-15 00:25:23.000000', 'consum', 0.0211, 'lps'),
	(352566, 102, '2015-01-15 00:25:24.000000', 'consum', 0.0210, 'lps'),
	(352567, 102, '2015-01-15 00:25:25.000000', 'consum', 0.0216, 'lps'),
	(352568, 102, '2015-01-15 00:25:26.000000', 'consum', 0.0214, 'lps'),
	(352569, 102, '2015-01-15 00:25:27.000000', 'consum', 0.0213, 'lps'),
	(352570, 102, '2015-01-15 00:25:28.000000', 'consum', 0.0212, 'lps'),
	(352571, 102, '2015-01-15 00:25:29.000000', 'consum', 0.0211, 'lps'),
	(352572, 102, '2015-01-15 00:25:30.000000', 'consum', 0.0219, 'lps'),
	(352573, 102, '2015-01-15 00:25:31.000000', 'consum', 0.0211, 'lps'),
	(352574, 102, '2015-01-15 00:25:32.000000', 'consum', 0.0212, 'lps'),
	(352575, 102, '2015-01-15 00:25:33.000000', 'consum', 0.0216, 'lps'),
	(352576, 102, '2015-01-15 00:25:34.000000', 'consum', 0.0216, 'lps'),
	(352577, 102, '2015-01-15 00:25:35.000000', 'consum', 0.0211, 'lps'),
	(352578, 102, '2015-01-15 00:25:36.000000', 'consum', 0.0217, 'lps'),
	(352579, 102, '2015-01-15 00:25:37.000000', 'consum', 0.0213, 'lps'),
	(352580, 102, '2015-01-15 00:25:38.000000', 'consum', 0.0216, 'lps'),
	(352581, 102, '2015-01-15 00:25:39.000000', 'consum', 0.0211, 'lps'),
	(352582, 102, '2015-01-15 00:25:40.000000', 'consum', 0.0219, 'lps'),
	(352583, 102, '2015-01-15 00:25:41.000000', 'consum', 0.0211, 'lps'),
	(352584, 102, '2015-01-15 00:25:42.000000', 'consum', 0.0211, 'lps'),
	(352585, 102, '2015-01-15 00:25:43.000000', 'consum', 0.0219, 'lps'),
	(352586, 102, '2015-01-15 00:25:44.000000', 'consum', 0.0216, 'lps'),
	(352587, 102, '2015-01-15 00:25:45.000000', 'consum', 0.0210, 'lps'),
	(352588, 102, '2015-01-15 00:25:46.000000', 'consum', 0.0213, 'lps'),
	(352589, 102, '2015-01-15 00:25:47.000000', 'consum', 0.0218, 'lps'),
	(352590, 102, '2015-01-15 00:25:48.000000', 'consum', 0.0219, 'lps'),
	(352591, 102, '2015-01-15 00:25:49.000000', 'consum', 0.0212, 'lps'),
	(352592, 102, '2015-01-15 00:25:50.000000', 'consum', 0.0215, 'lps'),
	(352593, 102, '2015-01-15 00:25:51.000000', 'consum', 0.0219, 'lps'),
	(352594, 102, '2015-01-15 00:25:52.000000', 'consum', 0.0210, 'lps'),
	(352595, 102, '2015-01-15 00:25:53.000000', 'consum', 0.0215, 'lps'),
	(352596, 102, '2015-01-15 00:25:54.000000', 'consum', 0.0215, 'lps'),
	(352597, 102, '2015-01-15 00:25:55.000000', 'consum', 0.0212, 'lps'),
	(352598, 102, '2015-01-15 00:25:56.000000', 'consum', 0.0215, 'lps'),
	(352599, 102, '2015-01-15 00:25:57.000000', 'consum', 0.0210, 'lps'),
	(352600, 102, '2015-01-15 00:25:58.000000', 'consum', 0.0215, 'lps'),
	(352601, 102, '2015-01-15 00:25:59.000000', 'consum', 0.0216, 'lps'),
	(352602, 102, '2015-01-15 00:26:00.000000', 'consum', 0.0215, 'lps'),
	(352603, 102, '2015-01-15 00:26:01.000000', 'consum', 0.0216, 'lps'),
	(352604, 102, '2015-01-15 00:26:02.000000', 'consum', 0.0217, 'lps'),
	(352605, 102, '2015-01-15 00:26:03.000000', 'consum', 0.0218, 'lps'),
	(352606, 102, '2015-01-15 00:26:04.000000', 'consum', 0.0217, 'lps'),
	(352607, 102, '2015-01-15 00:26:05.000000', 'consum', 0.0214, 'lps'),
	(352608, 102, '2015-01-15 00:26:06.000000', 'consum', 0.0210, 'lps'),
	(352609, 102, '2015-01-15 00:26:07.000000', 'consum', 0.0216, 'lps'),
	(352610, 102, '2015-01-15 00:26:08.000000', 'consum', 0.0213, 'lps'),
	(352611, 102, '2015-01-15 00:26:09.000000', 'consum', 0.0218, 'lps'),
	(352612, 102, '2015-01-15 00:26:10.000000', 'consum', 0.0210, 'lps'),
	(352613, 102, '2015-01-15 00:26:11.000000', 'consum', 0.0219, 'lps'),
	(352614, 102, '2015-01-15 00:26:12.000000', 'consum', 0.0212, 'lps'),
	(352615, 102, '2015-01-15 00:26:13.000000', 'consum', 0.0216, 'lps'),
	(352616, 102, '2015-01-15 00:26:14.000000', 'consum', 0.0212, 'lps'),
	(352617, 102, '2015-01-15 00:26:15.000000', 'consum', 0.0216, 'lps'),
	(352618, 102, '2015-01-15 00:26:16.000000', 'consum', 0.0212, 'lps'),
	(352619, 102, '2015-01-15 00:26:17.000000', 'consum', 0.0212, 'lps'),
	(352620, 102, '2015-01-15 00:26:18.000000', 'consum', 0.0216, 'lps'),
	(352621, 102, '2015-01-15 00:26:19.000000', 'consum', 0.0214, 'lps'),
	(352622, 102, '2015-01-15 00:26:20.000000', 'consum', 0.0214, 'lps'),
	(352623, 102, '2015-01-15 00:26:21.000000', 'consum', 0.0219, 'lps'),
	(352624, 102, '2015-01-15 00:26:22.000000', 'consum', 0.0214, 'lps'),
	(352625, 102, '2015-01-15 00:26:23.000000', 'consum', 0.0211, 'lps'),
	(352626, 102, '2015-01-15 00:26:24.000000', 'consum', 0.0215, 'lps'),
	(352627, 102, '2015-01-15 00:26:25.000000', 'consum', 0.0214, 'lps'),
	(352628, 102, '2015-01-15 00:26:26.000000', 'consum', 0.0213, 'lps'),
	(352629, 102, '2015-01-15 00:26:27.000000', 'consum', 0.0214, 'lps'),
	(352630, 102, '2015-01-15 00:26:28.000000', 'consum', 0.0213, 'lps'),
	(352631, 102, '2015-01-15 00:26:29.000000', 'consum', 0.0211, 'lps'),
	(352632, 102, '2015-01-15 00:26:30.000000', 'consum', 0.0218, 'lps'),
	(352633, 102, '2015-01-15 00:26:31.000000', 'consum', 0.0219, 'lps'),
	(352634, 102, '2015-01-15 00:26:32.000000', 'consum', 0.0211, 'lps'),
	(352635, 102, '2015-01-15 00:26:33.000000', 'consum', 0.0216, 'lps'),
	(352636, 102, '2015-01-15 00:26:34.000000', 'consum', 0.0211, 'lps'),
	(352637, 102, '2015-01-15 00:26:35.000000', 'consum', 0.0215, 'lps'),
	(352638, 102, '2015-01-15 00:26:36.000000', 'consum', 0.0214, 'lps'),
	(352639, 102, '2015-01-15 00:26:37.000000', 'consum', 0.0214, 'lps'),
	(352640, 102, '2015-01-15 00:26:38.000000', 'consum', 0.0219, 'lps'),
	(352641, 102, '2015-01-15 00:26:39.000000', 'consum', 0.0212, 'lps'),
	(352642, 102, '2015-01-15 00:26:40.000000', 'consum', 0.0213, 'lps'),
	(352643, 102, '2015-01-15 00:26:41.000000', 'consum', 0.0212, 'lps'),
	(352644, 102, '2015-01-15 00:26:42.000000', 'consum', 0.0219, 'lps'),
	(352645, 102, '2015-01-15 00:26:43.000000', 'consum', 0.0211, 'lps'),
	(352646, 102, '2015-01-15 00:26:44.000000', 'consum', 0.0216, 'lps'),
	(352647, 102, '2015-01-15 00:26:45.000000', 'consum', 0.0211, 'lps'),
	(352648, 102, '2015-01-15 00:26:46.000000', 'consum', 0.0216, 'lps'),
	(352649, 102, '2015-01-15 00:26:47.000000', 'consum', 0.0216, 'lps'),
	(352650, 102, '2015-01-15 00:26:48.000000', 'consum', 0.0212, 'lps'),
	(352651, 102, '2015-01-15 00:26:49.000000', 'consum', 0.0214, 'lps'),
	(352652, 102, '2015-01-15 00:26:50.000000', 'consum', 0.0213, 'lps'),
	(352653, 102, '2015-01-15 00:26:51.000000', 'consum', 0.0213, 'lps'),
	(352654, 102, '2015-01-15 00:26:52.000000', 'consum', 0.0218, 'lps'),
	(352655, 102, '2015-01-15 00:26:53.000000', 'consum', 0.0213, 'lps'),
	(352656, 102, '2015-01-15 00:26:54.000000', 'consum', 0.0210, 'lps'),
	(352657, 102, '2015-01-15 00:26:55.000000', 'consum', 0.0213, 'lps'),
	(352658, 102, '2015-01-15 00:26:56.000000', 'consum', 0.0215, 'lps'),
	(352659, 102, '2015-01-15 00:26:57.000000', 'consum', 0.0214, 'lps'),
	(352660, 102, '2015-01-15 00:26:58.000000', 'consum', 0.0218, 'lps'),
	(352661, 102, '2015-01-15 00:26:59.000000', 'consum', 0.0218, 'lps'),
	(352662, 102, '2015-01-15 00:27:00.000000', 'consum', 0.0216, 'lps'),
	(352663, 102, '2015-01-15 00:27:01.000000', 'consum', 0.0216, 'lps'),
	(352664, 102, '2015-01-15 00:27:02.000000', 'consum', 0.0215, 'lps'),
	(352665, 102, '2015-01-15 00:27:03.000000', 'consum', 0.0216, 'lps'),
	(352666, 102, '2015-01-15 00:27:04.000000', 'consum', 0.0216, 'lps'),
	(352667, 102, '2015-01-15 00:27:05.000000', 'consum', 0.0213, 'lps'),
	(352668, 102, '2015-01-15 00:27:06.000000', 'consum', 0.0215, 'lps'),
	(352669, 102, '2015-01-15 00:27:07.000000', 'consum', 0.0219, 'lps'),
	(352670, 102, '2015-01-15 00:27:08.000000', 'consum', 0.0219, 'lps'),
	(352671, 102, '2015-01-15 00:27:09.000000', 'consum', 0.0210, 'lps'),
	(352672, 102, '2015-01-15 00:27:10.000000', 'consum', 0.0211, 'lps'),
	(352673, 102, '2015-01-15 00:27:11.000000', 'consum', 0.0217, 'lps'),
	(352674, 102, '2015-01-15 00:27:12.000000', 'consum', 0.0211, 'lps'),
	(352675, 102, '2015-01-15 00:27:13.000000', 'consum', 0.0214, 'lps'),
	(352676, 102, '2015-01-15 00:27:14.000000', 'consum', 0.0219, 'lps'),
	(352677, 102, '2015-01-15 00:27:15.000000', 'consum', 0.0214, 'lps'),
	(352678, 102, '2015-01-15 00:27:16.000000', 'consum', 0.0211, 'lps'),
	(352679, 102, '2015-01-15 00:27:17.000000', 'consum', 0.0215, 'lps'),
	(352680, 102, '2015-01-15 00:27:18.000000', 'consum', 0.0212, 'lps'),
	(352681, 102, '2015-01-15 00:27:19.000000', 'consum', 0.0214, 'lps'),
	(352682, 102, '2015-01-15 00:27:20.000000', 'consum', 0.0215, 'lps'),
	(352683, 102, '2015-01-15 00:27:21.000000', 'consum', 0.0216, 'lps'),
	(352684, 102, '2015-01-15 00:27:22.000000', 'consum', 0.0214, 'lps'),
	(352685, 102, '2015-01-15 00:27:23.000000', 'consum', 0.0211, 'lps'),
	(352686, 102, '2015-01-15 00:27:24.000000', 'consum', 0.0216, 'lps'),
	(352687, 102, '2015-01-15 00:27:25.000000', 'consum', 0.0217, 'lps'),
	(352688, 102, '2015-01-15 00:27:26.000000', 'consum', 0.0217, 'lps'),
	(352689, 102, '2015-01-15 00:27:27.000000', 'consum', 0.0216, 'lps'),
	(352690, 102, '2015-01-15 00:27:28.000000', 'consum', 0.0211, 'lps'),
	(352691, 102, '2015-01-15 00:27:29.000000', 'consum', 0.0214, 'lps'),
	(352692, 102, '2015-01-15 00:27:30.000000', 'consum', 0.0218, 'lps'),
	(352693, 102, '2015-01-15 00:27:31.000000', 'consum', 0.0210, 'lps'),
	(352694, 102, '2015-01-15 00:27:32.000000', 'consum', 0.0217, 'lps'),
	(352695, 102, '2015-01-15 00:27:33.000000', 'consum', 0.0213, 'lps'),
	(352696, 102, '2015-01-15 00:27:34.000000', 'consum', 0.0214, 'lps'),
	(352697, 102, '2015-01-15 00:27:35.000000', 'consum', 0.0213, 'lps'),
	(352698, 102, '2015-01-15 00:27:36.000000', 'consum', 0.0213, 'lps'),
	(352699, 102, '2015-01-15 00:27:37.000000', 'consum', 0.0218, 'lps'),
	(352700, 102, '2015-01-15 00:27:38.000000', 'consum', 0.0212, 'lps'),
	(352701, 102, '2015-01-15 00:27:39.000000', 'consum', 0.0214, 'lps'),
	(352702, 102, '2015-01-15 00:27:40.000000', 'consum', 0.0218, 'lps'),
	(352703, 102, '2015-01-15 00:27:41.000000', 'consum', 0.0215, 'lps'),
	(352704, 102, '2015-01-15 00:27:42.000000', 'consum', 0.0213, 'lps'),
	(352705, 102, '2015-01-15 00:27:43.000000', 'consum', 0.0211, 'lps'),
	(352706, 102, '2015-01-15 00:27:44.000000', 'consum', 0.0216, 'lps'),
	(352707, 102, '2015-01-15 00:27:45.000000', 'consum', 0.0217, 'lps'),
	(352708, 102, '2015-01-15 00:27:46.000000', 'consum', 0.0216, 'lps'),
	(352709, 102, '2015-01-15 00:27:47.000000', 'consum', 0.0212, 'lps'),
	(352710, 102, '2015-01-15 00:27:48.000000', 'consum', 0.0211, 'lps'),
	(352711, 102, '2015-01-15 00:27:49.000000', 'consum', 0.0212, 'lps'),
	(352712, 102, '2015-01-15 00:27:50.000000', 'consum', 0.0214, 'lps'),
	(352713, 102, '2015-01-15 00:27:51.000000', 'consum', 0.0218, 'lps'),
	(352714, 102, '2015-01-15 00:27:52.000000', 'consum', 0.0217, 'lps'),
	(352715, 102, '2015-01-15 00:27:53.000000', 'consum', 0.0213, 'lps'),
	(352716, 102, '2015-01-15 00:27:54.000000', 'consum', 0.0214, 'lps'),
	(352717, 102, '2015-01-15 00:27:55.000000', 'consum', 0.0211, 'lps'),
	(352718, 102, '2015-01-15 00:27:56.000000', 'consum', 0.0214, 'lps'),
	(352719, 102, '2015-01-15 00:27:57.000000', 'consum', 0.0218, 'lps'),
	(352720, 102, '2015-01-15 00:27:58.000000', 'consum', 0.0217, 'lps'),
	(352721, 102, '2015-01-15 00:27:59.000000', 'consum', 0.0214, 'lps'),
	(352722, 102, '2015-01-15 00:28:00.000000', 'consum', 0.0217, 'lps'),
	(352723, 102, '2015-01-15 00:28:01.000000', 'consum', 0.0213, 'lps'),
	(352724, 102, '2015-01-15 00:28:02.000000', 'consum', 0.0214, 'lps'),
	(352725, 102, '2015-01-15 00:28:03.000000', 'consum', 0.0214, 'lps'),
	(352726, 102, '2015-01-15 00:28:04.000000', 'consum', 0.0217, 'lps'),
	(352727, 102, '2015-01-15 00:28:05.000000', 'consum', 0.0214, 'lps'),
	(352728, 102, '2015-01-15 00:28:06.000000', 'consum', 0.0211, 'lps'),
	(352729, 102, '2015-01-15 00:28:07.000000', 'consum', 0.0214, 'lps'),
	(352730, 102, '2015-01-15 00:28:08.000000', 'consum', 0.0216, 'lps'),
	(352731, 102, '2015-01-15 00:28:09.000000', 'consum', 0.0210, 'lps'),
	(352732, 102, '2015-01-15 00:28:10.000000', 'consum', 0.0213, 'lps'),
	(352733, 102, '2015-01-15 00:28:11.000000', 'consum', 0.0215, 'lps'),
	(352734, 102, '2015-01-15 00:28:12.000000', 'consum', 0.0217, 'lps'),
	(352735, 102, '2015-01-15 00:28:13.000000', 'consum', 0.0210, 'lps'),
	(352736, 102, '2015-01-15 00:28:14.000000', 'consum', 0.0218, 'lps'),
	(352737, 102, '2015-01-15 00:28:15.000000', 'consum', 0.0212, 'lps'),
	(352738, 102, '2015-01-15 00:28:16.000000', 'consum', 0.0216, 'lps'),
	(352739, 102, '2015-01-15 00:28:17.000000', 'consum', 0.0213, 'lps'),
	(352740, 102, '2015-01-15 00:28:18.000000', 'consum', 0.0218, 'lps'),
	(352741, 102, '2015-01-15 00:28:19.000000', 'consum', 0.0212, 'lps'),
	(352742, 102, '2015-01-15 00:28:20.000000', 'consum', 0.0216, 'lps'),
	(352743, 102, '2015-01-15 00:28:21.000000', 'consum', 0.0213, 'lps'),
	(352744, 102, '2015-01-15 00:28:22.000000', 'consum', 0.0211, 'lps'),
	(352745, 102, '2015-01-15 00:28:23.000000', 'consum', 0.0213, 'lps'),
	(352746, 102, '2015-01-15 00:28:24.000000', 'consum', 0.0214, 'lps'),
	(352747, 102, '2015-01-15 00:28:25.000000', 'consum', 0.0213, 'lps'),
	(352748, 102, '2015-01-15 00:28:26.000000', 'consum', 0.0211, 'lps'),
	(352749, 102, '2015-01-15 00:28:27.000000', 'consum', 0.0217, 'lps'),
	(352750, 102, '2015-01-15 00:28:28.000000', 'consum', 0.0211, 'lps'),
	(352751, 102, '2015-01-15 00:28:29.000000', 'consum', 0.0216, 'lps'),
	(352752, 102, '2015-01-15 00:28:30.000000', 'consum', 0.0218, 'lps'),
	(352753, 102, '2015-01-15 00:28:31.000000', 'consum', 0.0213, 'lps'),
	(352754, 102, '2015-01-15 00:28:32.000000', 'consum', 0.0211, 'lps'),
	(352755, 102, '2015-01-15 00:28:33.000000', 'consum', 0.0216, 'lps'),
	(352756, 102, '2015-01-15 00:28:34.000000', 'consum', 0.0216, 'lps'),
	(352757, 102, '2015-01-15 00:28:35.000000', 'consum', 0.0214, 'lps'),
	(352758, 102, '2015-01-15 00:28:36.000000', 'consum', 0.0213, 'lps'),
	(352759, 102, '2015-01-15 00:28:37.000000', 'consum', 0.0215, 'lps'),
	(352760, 102, '2015-01-15 00:28:38.000000', 'consum', 0.0215, 'lps'),
	(352761, 102, '2015-01-15 00:28:39.000000', 'consum', 0.0210, 'lps'),
	(352762, 102, '2015-01-15 00:28:40.000000', 'consum', 0.0217, 'lps'),
	(352763, 102, '2015-01-15 00:28:41.000000', 'consum', 0.0216, 'lps'),
	(352764, 102, '2015-01-15 00:28:42.000000', 'consum', 0.0219, 'lps'),
	(352765, 102, '2015-01-15 00:28:43.000000', 'consum', 0.0218, 'lps'),
	(352766, 102, '2015-01-15 00:28:44.000000', 'consum', 0.0211, 'lps'),
	(352767, 102, '2015-01-15 00:28:45.000000', 'consum', 0.0213, 'lps'),
	(352768, 102, '2015-01-15 00:28:46.000000', 'consum', 0.0213, 'lps'),
	(352769, 102, '2015-01-15 00:28:47.000000', 'consum', 0.0217, 'lps'),
	(352770, 102, '2015-01-15 00:28:48.000000', 'consum', 0.0215, 'lps'),
	(352771, 102, '2015-01-15 00:28:49.000000', 'consum', 0.0214, 'lps'),
	(352772, 102, '2015-01-15 00:28:50.000000', 'consum', 0.0215, 'lps'),
	(352773, 102, '2015-01-15 00:28:51.000000', 'consum', 0.0213, 'lps'),
	(352774, 102, '2015-01-15 00:28:52.000000', 'consum', 0.0213, 'lps'),
	(352775, 102, '2015-01-15 00:28:53.000000', 'consum', 0.0215, 'lps'),
	(352776, 102, '2015-01-15 00:28:54.000000', 'consum', 0.0219, 'lps'),
	(352777, 102, '2015-01-15 00:28:55.000000', 'consum', 0.0218, 'lps'),
	(352778, 102, '2015-01-15 00:28:56.000000', 'consum', 0.0213, 'lps'),
	(352779, 102, '2015-01-15 00:28:57.000000', 'consum', 0.0211, 'lps'),
	(352780, 102, '2015-01-15 00:28:58.000000', 'consum', 0.0217, 'lps'),
	(352781, 102, '2015-01-15 00:28:59.000000', 'consum', 0.0211, 'lps'),
	(352782, 102, '2015-01-15 00:29:00.000000', 'consum', 0.0215, 'lps'),
	(352783, 102, '2015-01-15 00:29:01.000000', 'consum', 0.0213, 'lps'),
	(352784, 102, '2015-01-15 00:29:02.000000', 'consum', 0.0211, 'lps'),
	(352785, 102, '2015-01-15 00:29:03.000000', 'consum', 0.0215, 'lps'),
	(352786, 102, '2015-01-15 00:29:04.000000', 'consum', 0.0213, 'lps'),
	(352787, 102, '2015-01-15 00:29:05.000000', 'consum', 0.0210, 'lps'),
	(352788, 102, '2015-01-15 00:29:06.000000', 'consum', 0.0213, 'lps'),
	(352789, 102, '2015-01-15 00:29:07.000000', 'consum', 0.0215, 'lps'),
	(352790, 102, '2015-01-15 00:29:08.000000', 'consum', 0.0215, 'lps'),
	(352791, 102, '2015-01-15 00:29:09.000000', 'consum', 0.0211, 'lps'),
	(352792, 102, '2015-01-15 00:29:10.000000', 'consum', 0.0210, 'lps'),
	(352793, 102, '2015-01-15 00:29:11.000000', 'consum', 0.0217, 'lps'),
	(352794, 102, '2015-01-15 00:29:12.000000', 'consum', 0.0218, 'lps'),
	(352795, 102, '2015-01-15 00:29:13.000000', 'consum', 0.0219, 'lps'),
	(352796, 102, '2015-01-15 00:29:14.000000', 'consum', 0.0211, 'lps'),
	(352797, 102, '2015-01-15 00:29:15.000000', 'consum', 0.0217, 'lps'),
	(352798, 102, '2015-01-15 00:29:16.000000', 'consum', 0.0212, 'lps'),
	(352799, 102, '2015-01-15 00:29:17.000000', 'consum', 0.0211, 'lps'),
	(352800, 102, '2015-01-15 00:29:18.000000', 'consum', 0.0210, 'lps'),
	(352801, 102, '2015-01-15 00:29:19.000000', 'consum', 0.0217, 'lps'),
	(352802, 102, '2015-01-15 00:29:20.000000', 'consum', 0.0217, 'lps'),
	(352803, 102, '2015-01-15 00:29:21.000000', 'consum', 0.0212, 'lps'),
	(352804, 102, '2015-01-15 00:29:22.000000', 'consum', 0.0211, 'lps'),
	(352805, 102, '2015-01-15 00:29:23.000000', 'consum', 0.0210, 'lps'),
	(352806, 102, '2015-01-15 00:29:24.000000', 'consum', 0.0215, 'lps'),
	(352807, 102, '2015-01-15 00:29:25.000000', 'consum', 0.0217, 'lps'),
	(352808, 102, '2015-01-15 00:29:26.000000', 'consum', 0.0218, 'lps'),
	(352809, 102, '2015-01-15 00:29:27.000000', 'consum', 0.0212, 'lps'),
	(352810, 102, '2015-01-15 00:29:28.000000', 'consum', 0.0218, 'lps'),
	(352811, 102, '2015-01-15 00:29:29.000000', 'consum', 0.0211, 'lps'),
	(352812, 102, '2015-01-15 00:29:30.000000', 'consum', 0.0214, 'lps'),
	(352813, 102, '2015-01-15 00:29:31.000000', 'consum', 0.0217, 'lps'),
	(352814, 102, '2015-01-15 00:29:32.000000', 'consum', 0.0214, 'lps'),
	(352815, 102, '2015-01-15 00:29:33.000000', 'consum', 0.0219, 'lps'),
	(352816, 102, '2015-01-15 00:29:34.000000', 'consum', 0.0212, 'lps'),
	(352817, 102, '2015-01-15 00:29:35.000000', 'consum', 0.0213, 'lps'),
	(352818, 102, '2015-01-15 00:29:36.000000', 'consum', 0.0210, 'lps'),
	(352819, 102, '2015-01-15 00:29:37.000000', 'consum', 0.0211, 'lps'),
	(352820, 102, '2015-01-15 00:29:38.000000', 'consum', 0.0217, 'lps'),
	(352821, 102, '2015-01-15 00:29:39.000000', 'consum', 0.0213, 'lps'),
	(352822, 102, '2015-01-15 00:29:40.000000', 'consum', 0.0215, 'lps'),
	(352823, 102, '2015-01-15 00:29:41.000000', 'consum', 0.0217, 'lps'),
	(352824, 102, '2015-01-15 00:29:42.000000', 'consum', 0.0218, 'lps'),
	(352825, 102, '2015-01-15 00:29:43.000000', 'consum', 0.0219, 'lps'),
	(352826, 102, '2015-01-15 00:29:44.000000', 'consum', 0.0211, 'lps'),
	(352827, 102, '2015-01-15 00:29:45.000000', 'consum', 0.0218, 'lps'),
	(352828, 102, '2015-01-15 00:29:46.000000', 'consum', 0.0217, 'lps'),
	(352829, 102, '2015-01-15 00:29:47.000000', 'consum', 0.0211, 'lps'),
	(352830, 102, '2015-01-15 00:29:48.000000', 'consum', 0.0218, 'lps'),
	(352831, 102, '2015-01-15 00:29:49.000000', 'consum', 0.0214, 'lps'),
	(352832, 102, '2015-01-15 00:29:50.000000', 'consum', 0.0217, 'lps'),
	(352833, 102, '2015-01-15 00:29:51.000000', 'consum', 0.0214, 'lps'),
	(352834, 102, '2015-01-15 00:29:52.000000', 'consum', 0.0218, 'lps'),
	(352835, 102, '2015-01-15 00:29:53.000000', 'consum', 0.0219, 'lps'),
	(352836, 102, '2015-01-15 00:29:54.000000', 'consum', 0.0213, 'lps'),
	(352837, 102, '2015-01-15 00:29:55.000000', 'consum', 0.0219, 'lps'),
	(352838, 102, '2015-01-15 00:29:56.000000', 'consum', 0.0214, 'lps'),
	(352839, 102, '2015-01-15 00:29:57.000000', 'consum', 0.0214, 'lps'),
	(352840, 102, '2015-01-15 00:29:58.000000', 'consum', 0.0218, 'lps'),
	(352841, 102, '2015-01-15 00:29:59.000000', 'consum', 0.0217, 'lps'),
	(352842, 102, '2015-01-15 00:30:00.000000', 'consum', 0.0214, 'lps'),
	(352843, 102, '2015-01-15 00:30:01.000000', 'consum', 0.0218, 'lps'),
	(352844, 102, '2015-01-15 00:30:02.000000', 'consum', 0.0217, 'lps'),
	(352845, 102, '2015-01-15 00:30:03.000000', 'consum', 0.0215, 'lps'),
	(352846, 102, '2015-01-15 00:30:04.000000', 'consum', 0.0213, 'lps'),
	(352847, 102, '2015-01-15 00:30:05.000000', 'consum', 0.0211, 'lps'),
	(352848, 102, '2015-01-15 00:30:06.000000', 'consum', 0.0216, 'lps'),
	(352849, 102, '2015-01-15 00:30:07.000000', 'consum', 0.0219, 'lps'),
	(352850, 102, '2015-01-15 00:30:08.000000', 'consum', 0.0216, 'lps'),
	(352851, 102, '2015-01-15 00:30:09.000000', 'consum', 0.0215, 'lps'),
	(352852, 102, '2015-01-15 00:30:10.000000', 'consum', 0.0217, 'lps'),
	(352853, 102, '2015-01-15 00:30:11.000000', 'consum', 0.0210, 'lps'),
	(352854, 102, '2015-01-15 00:30:12.000000', 'consum', 0.0211, 'lps'),
	(352855, 102, '2015-01-15 00:30:13.000000', 'consum', 0.0213, 'lps'),
	(352856, 102, '2015-01-15 00:30:14.000000', 'consum', 0.0214, 'lps'),
	(352857, 102, '2015-01-15 00:30:15.000000', 'consum', 0.0211, 'lps'),
	(352858, 102, '2015-01-15 00:30:16.000000', 'consum', 0.0213, 'lps'),
	(352859, 102, '2015-01-15 00:30:17.000000', 'consum', 0.0213, 'lps'),
	(352860, 102, '2015-01-15 00:30:18.000000', 'consum', 0.0218, 'lps'),
	(352861, 102, '2015-01-15 00:30:19.000000', 'consum', 0.0212, 'lps'),
	(352862, 102, '2015-01-15 00:30:20.000000', 'consum', 0.0215, 'lps'),
	(352863, 102, '2015-01-15 00:30:21.000000', 'consum', 0.0219, 'lps'),
	(352864, 102, '2015-01-15 00:30:22.000000', 'consum', 0.0212, 'lps'),
	(352865, 102, '2015-01-15 00:30:23.000000', 'consum', 0.0211, 'lps'),
	(352866, 102, '2015-01-15 00:30:24.000000', 'consum', 0.0211, 'lps'),
	(352867, 102, '2015-01-15 00:30:25.000000', 'consum', 0.0214, 'lps'),
	(352868, 102, '2015-01-15 00:30:26.000000', 'consum', 0.0218, 'lps'),
	(352869, 102, '2015-01-15 00:30:27.000000', 'consum', 0.0219, 'lps'),
	(352870, 102, '2015-01-15 00:30:28.000000', 'consum', 0.0210, 'lps'),
	(352871, 102, '2015-01-15 00:30:29.000000', 'consum', 0.0213, 'lps'),
	(352872, 102, '2015-01-15 00:30:30.000000', 'consum', 0.0217, 'lps'),
	(352873, 102, '2015-01-15 00:30:31.000000', 'consum', 0.0216, 'lps'),
	(352874, 102, '2015-01-15 00:30:32.000000', 'consum', 0.0211, 'lps'),
	(352875, 102, '2015-01-15 00:30:33.000000', 'consum', 0.0218, 'lps'),
	(352876, 102, '2015-01-15 00:30:34.000000', 'consum', 0.0215, 'lps'),
	(352877, 102, '2015-01-15 00:30:35.000000', 'consum', 0.0214, 'lps'),
	(352878, 102, '2015-01-15 00:30:36.000000', 'consum', 0.0213, 'lps'),
	(352879, 102, '2015-01-15 00:30:37.000000', 'consum', 0.0214, 'lps'),
	(352880, 102, '2015-01-15 00:30:38.000000', 'consum', 0.0212, 'lps'),
	(352881, 102, '2015-01-15 00:30:39.000000', 'consum', 0.0218, 'lps'),
	(352882, 102, '2015-01-15 00:30:40.000000', 'consum', 0.0213, 'lps'),
	(352883, 102, '2015-01-15 00:30:41.000000', 'consum', 0.0214, 'lps'),
	(352884, 102, '2015-01-15 00:30:42.000000', 'consum', 0.0219, 'lps'),
	(352885, 102, '2015-01-15 00:30:43.000000', 'consum', 0.0215, 'lps'),
	(352886, 102, '2015-01-15 00:30:44.000000', 'consum', 0.0217, 'lps'),
	(352887, 102, '2015-01-15 00:30:45.000000', 'consum', 0.0211, 'lps'),
	(352888, 102, '2015-01-15 00:30:46.000000', 'consum', 0.0216, 'lps'),
	(352889, 102, '2015-01-15 00:30:47.000000', 'consum', 0.0217, 'lps'),
	(352890, 102, '2015-01-15 00:30:48.000000', 'consum', 0.0217, 'lps'),
	(352891, 102, '2015-01-15 00:30:49.000000', 'consum', 0.0216, 'lps'),
	(352892, 102, '2015-01-15 00:30:50.000000', 'consum', 0.0210, 'lps'),
	(352893, 102, '2015-01-15 00:30:51.000000', 'consum', 0.0210, 'lps'),
	(352894, 102, '2015-01-15 00:30:52.000000', 'consum', 0.0213, 'lps'),
	(352895, 102, '2015-01-15 00:30:53.000000', 'consum', 0.0214, 'lps'),
	(352896, 102, '2015-01-15 00:30:54.000000', 'consum', 0.0211, 'lps'),
	(352897, 102, '2015-01-15 00:30:55.000000', 'consum', 0.0212, 'lps'),
	(352898, 102, '2015-01-15 00:30:56.000000', 'consum', 0.0211, 'lps'),
	(352899, 102, '2015-01-15 00:30:57.000000', 'consum', 0.0217, 'lps'),
	(352900, 102, '2015-01-15 00:30:58.000000', 'consum', 0.0215, 'lps'),
	(352901, 102, '2015-01-15 00:30:59.000000', 'consum', 0.0212, 'lps'),
	(352902, 102, '2015-01-15 00:31:00.000000', 'consum', 0.0216, 'lps'),
	(352903, 102, '2015-01-15 00:31:01.000000', 'consum', 0.0214, 'lps'),
	(352904, 102, '2015-01-15 00:31:02.000000', 'consum', 0.0213, 'lps'),
	(352905, 102, '2015-01-15 00:31:03.000000', 'consum', 0.0215, 'lps'),
	(352906, 102, '2015-01-15 00:31:04.000000', 'consum', 0.0218, 'lps'),
	(352907, 102, '2015-01-15 00:31:05.000000', 'consum', 0.0212, 'lps'),
	(352908, 102, '2015-01-15 00:31:06.000000', 'consum', 0.0217, 'lps'),
	(352909, 102, '2015-01-15 00:31:07.000000', 'consum', 0.0218, 'lps'),
	(352910, 102, '2015-01-15 00:31:08.000000', 'consum', 0.0212, 'lps'),
	(352911, 102, '2015-01-15 00:31:09.000000', 'consum', 0.0216, 'lps'),
	(352912, 102, '2015-01-15 00:31:10.000000', 'consum', 0.0214, 'lps'),
	(352913, 102, '2015-01-15 00:31:11.000000', 'consum', 0.0213, 'lps'),
	(352914, 102, '2015-01-15 00:31:12.000000', 'consum', 0.0215, 'lps'),
	(352915, 102, '2015-01-15 00:31:13.000000', 'consum', 0.0216, 'lps'),
	(352916, 102, '2015-01-15 00:31:14.000000', 'consum', 0.0213, 'lps'),
	(352917, 102, '2015-01-15 00:31:15.000000', 'consum', 0.0219, 'lps'),
	(352918, 102, '2015-01-15 00:31:16.000000', 'consum', 0.0214, 'lps'),
	(352919, 102, '2015-01-15 00:31:17.000000', 'consum', 0.0217, 'lps'),
	(352920, 102, '2015-01-15 00:31:18.000000', 'consum', 0.0214, 'lps'),
	(352921, 102, '2015-01-15 00:31:19.000000', 'consum', 0.0216, 'lps'),
	(352922, 102, '2015-01-15 00:31:20.000000', 'consum', 0.0212, 'lps'),
	(352923, 102, '2015-01-15 00:31:21.000000', 'consum', 0.0211, 'lps'),
	(352924, 102, '2015-01-15 00:31:22.000000', 'consum', 0.0210, 'lps'),
	(352925, 102, '2015-01-15 00:31:23.000000', 'consum', 0.0218, 'lps'),
	(352926, 102, '2015-01-15 00:31:24.000000', 'consum', 0.0212, 'lps'),
	(352927, 102, '2015-01-15 00:31:25.000000', 'consum', 0.0215, 'lps'),
	(352928, 102, '2015-01-15 00:31:26.000000', 'consum', 0.0210, 'lps'),
	(352929, 102, '2015-01-15 00:31:27.000000', 'consum', 0.0215, 'lps'),
	(352930, 102, '2015-01-15 00:31:28.000000', 'consum', 0.0217, 'lps'),
	(352931, 102, '2015-01-15 00:31:29.000000', 'consum', 0.0218, 'lps'),
	(352932, 102, '2015-01-15 00:31:30.000000', 'consum', 0.0212, 'lps'),
	(352933, 102, '2015-01-15 00:31:31.000000', 'consum', 0.0216, 'lps'),
	(352934, 102, '2015-01-15 00:31:32.000000', 'consum', 0.0216, 'lps'),
	(352935, 102, '2015-01-15 00:31:33.000000', 'consum', 0.0212, 'lps'),
	(352936, 102, '2015-01-15 00:31:34.000000', 'consum', 0.0211, 'lps'),
	(352937, 102, '2015-01-15 00:31:35.000000', 'consum', 0.0212, 'lps'),
	(352938, 102, '2015-01-15 00:31:36.000000', 'consum', 0.0217, 'lps'),
	(352939, 102, '2015-01-15 00:31:37.000000', 'consum', 0.0210, 'lps'),
	(352940, 102, '2015-01-15 00:31:38.000000', 'consum', 0.0218, 'lps'),
	(352941, 102, '2015-01-15 00:31:39.000000', 'consum', 0.0211, 'lps'),
	(352942, 102, '2015-01-15 00:31:40.000000', 'consum', 0.0210, 'lps'),
	(352943, 102, '2015-01-15 00:31:41.000000', 'consum', 0.0217, 'lps'),
	(352944, 102, '2015-01-15 00:31:42.000000', 'consum', 0.0218, 'lps'),
	(352945, 102, '2015-01-15 00:31:43.000000', 'consum', 0.0218, 'lps'),
	(352946, 102, '2015-01-15 00:31:44.000000', 'consum', 0.0217, 'lps'),
	(352947, 102, '2015-01-15 00:31:45.000000', 'consum', 0.0211, 'lps'),
	(352948, 102, '2015-01-15 00:31:46.000000', 'consum', 0.0215, 'lps'),
	(352949, 102, '2015-01-15 00:31:47.000000', 'consum', 0.0213, 'lps'),
	(352950, 102, '2015-01-15 00:31:48.000000', 'consum', 0.0218, 'lps'),
	(352951, 102, '2015-01-15 00:31:49.000000', 'consum', 0.0213, 'lps'),
	(352952, 102, '2015-01-15 00:31:50.000000', 'consum', 0.0212, 'lps'),
	(352953, 102, '2015-01-15 00:31:51.000000', 'consum', 0.0210, 'lps'),
	(352954, 102, '2015-01-15 00:31:52.000000', 'consum', 0.0216, 'lps'),
	(352955, 102, '2015-01-15 00:31:53.000000', 'consum', 0.0210, 'lps'),
	(352956, 102, '2015-01-15 00:31:54.000000', 'consum', 0.0213, 'lps'),
	(352957, 102, '2015-01-15 00:31:55.000000', 'consum', 0.0216, 'lps'),
	(352958, 102, '2015-01-15 00:31:56.000000', 'consum', 0.0219, 'lps'),
	(352959, 102, '2015-01-15 00:31:57.000000', 'consum', 0.0219, 'lps'),
	(352960, 102, '2015-01-15 00:31:58.000000', 'consum', 0.0219, 'lps'),
	(352961, 102, '2015-01-15 00:31:59.000000', 'consum', 0.0216, 'lps'),
	(352962, 102, '2015-01-15 00:32:00.000000', 'consum', 0.0215, 'lps'),
	(352963, 102, '2015-01-15 00:32:01.000000', 'consum', 0.0216, 'lps'),
	(352964, 102, '2015-01-15 00:32:02.000000', 'consum', 0.0215, 'lps'),
	(352965, 102, '2015-01-15 00:32:03.000000', 'consum', 0.0210, 'lps'),
	(352966, 102, '2015-01-15 00:32:04.000000', 'consum', 0.0214, 'lps'),
	(352967, 102, '2015-01-15 00:32:05.000000', 'consum', 0.0219, 'lps'),
	(352968, 102, '2015-01-15 00:32:06.000000', 'consum', 0.0214, 'lps'),
	(352969, 102, '2015-01-15 00:32:07.000000', 'consum', 0.0214, 'lps'),
	(352970, 102, '2015-01-15 00:32:08.000000', 'consum', 0.0219, 'lps'),
	(352971, 102, '2015-01-15 00:32:09.000000', 'consum', 0.0214, 'lps'),
	(352972, 102, '2015-01-15 00:32:10.000000', 'consum', 0.0213, 'lps'),
	(352973, 102, '2015-01-15 00:32:11.000000', 'consum', 0.0216, 'lps'),
	(352974, 102, '2015-01-15 00:32:12.000000', 'consum', 0.0218, 'lps'),
	(352975, 102, '2015-01-15 00:32:13.000000', 'consum', 0.0213, 'lps'),
	(352976, 102, '2015-01-15 00:32:14.000000', 'consum', 0.0210, 'lps'),
	(352977, 102, '2015-01-15 00:32:15.000000', 'consum', 0.0212, 'lps'),
	(352978, 102, '2015-01-15 00:32:16.000000', 'consum', 0.0212, 'lps'),
	(352979, 102, '2015-01-15 00:32:17.000000', 'consum', 0.0215, 'lps'),
	(352980, 102, '2015-01-15 00:32:18.000000', 'consum', 0.0210, 'lps'),
	(352981, 102, '2015-01-15 00:32:19.000000', 'consum', 0.0215, 'lps'),
	(352982, 102, '2015-01-15 00:32:20.000000', 'consum', 0.0215, 'lps'),
	(352983, 102, '2015-01-15 00:32:21.000000', 'consum', 0.0210, 'lps'),
	(352984, 102, '2015-01-15 00:32:22.000000', 'consum', 0.0215, 'lps'),
	(352985, 102, '2015-01-15 00:32:23.000000', 'consum', 0.0215, 'lps'),
	(352986, 102, '2015-01-15 00:32:24.000000', 'consum', 0.0210, 'lps'),
	(352987, 102, '2015-01-15 00:32:25.000000', 'consum', 0.0217, 'lps'),
	(352988, 102, '2015-01-15 00:32:26.000000', 'consum', 0.0215, 'lps'),
	(352989, 102, '2015-01-15 00:32:27.000000', 'consum', 0.0214, 'lps'),
	(352990, 102, '2015-01-15 00:32:28.000000', 'consum', 0.0216, 'lps'),
	(352991, 102, '2015-01-15 00:32:29.000000', 'consum', 0.0218, 'lps'),
	(352992, 102, '2015-01-15 00:32:30.000000', 'consum', 0.0214, 'lps'),
	(352993, 102, '2015-01-15 00:32:31.000000', 'consum', 0.0214, 'lps'),
	(352994, 102, '2015-01-15 00:32:32.000000', 'consum', 0.0218, 'lps'),
	(352995, 102, '2015-01-15 00:32:33.000000', 'consum', 0.0211, 'lps'),
	(352996, 102, '2015-01-15 00:32:34.000000', 'consum', 0.0210, 'lps'),
	(352997, 102, '2015-01-15 00:32:35.000000', 'consum', 0.0219, 'lps'),
	(352998, 102, '2015-01-15 00:32:36.000000', 'consum', 0.0215, 'lps'),
	(352999, 102, '2015-01-15 00:32:37.000000', 'consum', 0.0218, 'lps'),
	(353000, 102, '2015-01-15 00:32:38.000000', 'consum', 0.0218, 'lps'),
	(353001, 102, '2015-01-15 00:32:39.000000', 'consum', 0.0213, 'lps'),
	(353002, 102, '2015-01-15 00:32:40.000000', 'consum', 0.0213, 'lps'),
	(353003, 102, '2015-01-15 00:32:41.000000', 'consum', 0.0217, 'lps'),
	(353004, 102, '2015-01-15 00:32:42.000000', 'consum', 0.0218, 'lps'),
	(353005, 102, '2015-01-15 00:32:43.000000', 'consum', 0.0218, 'lps'),
	(353006, 102, '2015-01-15 00:32:44.000000', 'consum', 0.0218, 'lps'),
	(353007, 102, '2015-01-15 00:32:45.000000', 'consum', 0.0215, 'lps'),
	(353008, 102, '2015-01-15 00:32:46.000000', 'consum', 0.0210, 'lps'),
	(353009, 102, '2015-01-15 00:32:47.000000', 'consum', 0.0216, 'lps'),
	(353010, 102, '2015-01-15 00:32:48.000000', 'consum', 0.0210, 'lps'),
	(353011, 102, '2015-01-15 00:32:49.000000', 'consum', 0.0214, 'lps'),
	(353012, 102, '2015-01-15 00:32:50.000000', 'consum', 0.0212, 'lps'),
	(353013, 102, '2015-01-15 00:32:51.000000', 'consum', 0.0217, 'lps'),
	(353014, 102, '2015-01-15 00:32:52.000000', 'consum', 0.0218, 'lps'),
	(353015, 102, '2015-01-15 00:32:53.000000', 'consum', 0.0219, 'lps'),
	(353016, 102, '2015-01-15 00:32:54.000000', 'consum', 0.0212, 'lps'),
	(353017, 102, '2015-01-15 00:32:55.000000', 'consum', 0.0215, 'lps'),
	(353018, 102, '2015-01-15 00:32:56.000000', 'consum', 0.0210, 'lps'),
	(353019, 102, '2015-01-15 00:32:57.000000', 'consum', 0.0213, 'lps'),
	(353020, 102, '2015-01-15 00:32:58.000000', 'consum', 0.0217, 'lps'),
	(353021, 102, '2015-01-15 00:32:59.000000', 'consum', 0.0217, 'lps'),
	(353022, 102, '2015-01-15 00:33:00.000000', 'consum', 0.0213, 'lps'),
	(353023, 102, '2015-01-15 00:33:01.000000', 'consum', 0.0217, 'lps'),
	(353024, 102, '2015-01-15 00:33:02.000000', 'consum', 0.0216, 'lps'),
	(353025, 102, '2015-01-15 00:33:03.000000', 'consum', 0.0210, 'lps'),
	(353026, 102, '2015-01-15 00:33:04.000000', 'consum', 0.0210, 'lps'),
	(353027, 102, '2015-01-15 00:33:05.000000', 'consum', 0.0211, 'lps'),
	(353028, 102, '2015-01-15 00:33:06.000000', 'consum', 0.0216, 'lps'),
	(353029, 102, '2015-01-15 00:33:07.000000', 'consum', 0.0216, 'lps'),
	(353030, 102, '2015-01-15 00:33:08.000000', 'consum', 0.0216, 'lps'),
	(353031, 102, '2015-01-15 00:33:09.000000', 'consum', 0.0219, 'lps'),
	(353032, 102, '2015-01-15 00:33:10.000000', 'consum', 0.0219, 'lps'),
	(353033, 102, '2015-01-15 00:33:11.000000', 'consum', 0.0216, 'lps'),
	(353034, 102, '2015-01-15 00:33:12.000000', 'consum', 0.0217, 'lps'),
	(353035, 102, '2015-01-15 00:33:13.000000', 'consum', 0.0217, 'lps'),
	(353036, 102, '2015-01-15 00:33:14.000000', 'consum', 0.0214, 'lps'),
	(353037, 102, '2015-01-15 00:33:15.000000', 'consum', 0.0219, 'lps'),
	(353038, 102, '2015-01-15 00:33:16.000000', 'consum', 0.0215, 'lps'),
	(353039, 102, '2015-01-15 00:33:17.000000', 'consum', 0.0217, 'lps'),
	(353040, 102, '2015-01-15 00:33:18.000000', 'consum', 0.0219, 'lps'),
	(353041, 102, '2015-01-15 00:33:19.000000', 'consum', 0.0216, 'lps'),
	(353042, 102, '2015-01-15 00:33:20.000000', 'consum', 0.0211, 'lps'),
	(353043, 102, '2015-01-15 00:33:21.000000', 'consum', 0.0211, 'lps'),
	(353044, 102, '2015-01-15 00:33:22.000000', 'consum', 0.0212, 'lps'),
	(353045, 102, '2015-01-15 00:33:23.000000', 'consum', 0.0216, 'lps'),
	(353046, 102, '2015-01-15 00:33:24.000000', 'consum', 0.0215, 'lps'),
	(353047, 102, '2015-01-15 00:33:25.000000', 'consum', 0.0218, 'lps'),
	(353048, 102, '2015-01-15 00:33:26.000000', 'consum', 0.0216, 'lps'),
	(353049, 102, '2015-01-15 00:33:27.000000', 'consum', 0.0216, 'lps'),
	(353050, 102, '2015-01-15 00:33:28.000000', 'consum', 0.0213, 'lps'),
	(353051, 102, '2015-01-15 00:33:29.000000', 'consum', 0.0217, 'lps'),
	(353052, 102, '2015-01-15 00:33:30.000000', 'consum', 0.0217, 'lps'),
	(353053, 102, '2015-01-15 00:33:31.000000', 'consum', 0.0213, 'lps'),
	(353054, 102, '2015-01-15 00:33:32.000000', 'consum', 0.0214, 'lps'),
	(353055, 102, '2015-01-15 00:33:33.000000', 'consum', 0.0214, 'lps'),
	(353056, 102, '2015-01-15 00:33:34.000000', 'consum', 0.0216, 'lps'),
	(353057, 102, '2015-01-15 00:33:35.000000', 'consum', 0.0219, 'lps'),
	(353058, 102, '2015-01-15 00:33:36.000000', 'consum', 0.0218, 'lps'),
	(353059, 102, '2015-01-15 00:33:37.000000', 'consum', 0.0213, 'lps'),
	(353060, 102, '2015-01-15 00:33:38.000000', 'consum', 0.0212, 'lps'),
	(353061, 102, '2015-01-15 00:33:39.000000', 'consum', 0.0219, 'lps'),
	(353062, 102, '2015-01-15 00:33:40.000000', 'consum', 0.0213, 'lps'),
	(353063, 102, '2015-01-15 00:33:41.000000', 'consum', 0.0218, 'lps'),
	(353064, 102, '2015-01-15 00:33:42.000000', 'consum', 0.0219, 'lps'),
	(353065, 102, '2015-01-15 00:33:43.000000', 'consum', 0.0213, 'lps'),
	(353066, 102, '2015-01-15 00:33:44.000000', 'consum', 0.0217, 'lps'),
	(353067, 102, '2015-01-15 00:33:45.000000', 'consum', 0.0217, 'lps'),
	(353068, 102, '2015-01-15 00:33:46.000000', 'consum', 0.0217, 'lps'),
	(353069, 102, '2015-01-15 00:33:47.000000', 'consum', 0.0212, 'lps'),
	(353070, 102, '2015-01-15 00:33:48.000000', 'consum', 0.0210, 'lps'),
	(353071, 102, '2015-01-15 00:33:49.000000', 'consum', 0.0213, 'lps'),
	(353072, 102, '2015-01-15 00:33:50.000000', 'consum', 0.0217, 'lps'),
	(353073, 102, '2015-01-15 00:33:51.000000', 'consum', 0.0216, 'lps'),
	(353074, 102, '2015-01-15 00:33:52.000000', 'consum', 0.0219, 'lps'),
	(353075, 102, '2015-01-15 00:33:53.000000', 'consum', 0.0218, 'lps'),
	(353076, 102, '2015-01-15 00:33:54.000000', 'consum', 0.0214, 'lps'),
	(353077, 102, '2015-01-15 00:33:55.000000', 'consum', 0.0215, 'lps'),
	(353078, 102, '2015-01-15 00:33:56.000000', 'consum', 0.0214, 'lps'),
	(353079, 102, '2015-01-15 00:33:57.000000', 'consum', 0.0214, 'lps'),
	(353080, 102, '2015-01-15 00:33:58.000000', 'consum', 0.0219, 'lps'),
	(353081, 102, '2015-01-15 00:33:59.000000', 'consum', 0.0214, 'lps'),
	(353082, 102, '2015-01-15 00:34:00.000000', 'consum', 0.0212, 'lps'),
	(353083, 102, '2015-01-15 00:34:01.000000', 'consum', 0.0211, 'lps'),
	(353084, 102, '2015-01-15 00:34:02.000000', 'consum', 0.0217, 'lps'),
	(353085, 102, '2015-01-15 00:34:03.000000', 'consum', 0.0213, 'lps'),
	(353086, 102, '2015-01-15 00:34:04.000000', 'consum', 0.0215, 'lps'),
	(353087, 102, '2015-01-15 00:34:05.000000', 'consum', 0.0218, 'lps'),
	(353088, 102, '2015-01-15 00:34:06.000000', 'consum', 0.0212, 'lps'),
	(353089, 102, '2015-01-15 00:34:07.000000', 'consum', 0.0210, 'lps'),
	(353090, 102, '2015-01-15 00:34:08.000000', 'consum', 0.0213, 'lps'),
	(353091, 102, '2015-01-15 00:34:09.000000', 'consum', 0.0214, 'lps'),
	(353092, 102, '2015-01-15 00:34:10.000000', 'consum', 0.0213, 'lps'),
	(353093, 102, '2015-01-15 00:34:11.000000', 'consum', 0.0215, 'lps'),
	(353094, 102, '2015-01-15 00:34:12.000000', 'consum', 0.0214, 'lps'),
	(353095, 102, '2015-01-15 00:34:13.000000', 'consum', 0.0218, 'lps'),
	(353096, 102, '2015-01-15 00:34:14.000000', 'consum', 0.0217, 'lps'),
	(353097, 102, '2015-01-15 00:34:15.000000', 'consum', 0.0213, 'lps'),
	(353098, 102, '2015-01-15 00:34:16.000000', 'consum', 0.0212, 'lps'),
	(353099, 102, '2015-01-15 00:34:17.000000', 'consum', 0.0213, 'lps'),
	(353100, 102, '2015-01-15 00:34:18.000000', 'consum', 0.0218, 'lps'),
	(353101, 102, '2015-01-15 00:34:19.000000', 'consum', 0.0212, 'lps'),
	(353102, 102, '2015-01-15 00:34:20.000000', 'consum', 0.0215, 'lps'),
	(353103, 102, '2015-01-15 00:34:21.000000', 'consum', 0.0219, 'lps'),
	(353104, 102, '2015-01-15 00:34:22.000000', 'consum', 0.0214, 'lps'),
	(353105, 102, '2015-01-15 00:34:23.000000', 'consum', 0.0210, 'lps'),
	(353106, 102, '2015-01-15 00:34:24.000000', 'consum', 0.0211, 'lps'),
	(353107, 102, '2015-01-15 00:34:25.000000', 'consum', 0.0215, 'lps'),
	(353108, 102, '2015-01-15 00:34:26.000000', 'consum', 0.0211, 'lps'),
	(353109, 102, '2015-01-15 00:34:27.000000', 'consum', 0.0212, 'lps'),
	(353110, 102, '2015-01-15 00:34:28.000000', 'consum', 0.0216, 'lps'),
	(353111, 102, '2015-01-15 00:34:29.000000', 'consum', 0.0216, 'lps'),
	(353112, 102, '2015-01-15 00:34:30.000000', 'consum', 0.0210, 'lps'),
	(353113, 102, '2015-01-15 00:34:31.000000', 'consum', 0.0215, 'lps'),
	(353114, 102, '2015-01-15 00:34:32.000000', 'consum', 0.0215, 'lps'),
	(353115, 102, '2015-01-15 00:34:33.000000', 'consum', 0.0210, 'lps'),
	(353116, 102, '2015-01-15 00:34:34.000000', 'consum', 0.0216, 'lps'),
	(353117, 102, '2015-01-15 00:34:35.000000', 'consum', 0.0219, 'lps'),
	(353118, 102, '2015-01-15 00:34:36.000000', 'consum', 0.0216, 'lps'),
	(353119, 102, '2015-01-15 00:34:37.000000', 'consum', 0.0217, 'lps'),
	(353120, 102, '2015-01-15 00:34:38.000000', 'consum', 0.0214, 'lps'),
	(353121, 102, '2015-01-15 00:34:39.000000', 'consum', 0.0213, 'lps'),
	(353122, 102, '2015-01-15 00:34:40.000000', 'consum', 0.0210, 'lps'),
	(353123, 102, '2015-01-15 00:34:41.000000', 'consum', 0.0214, 'lps'),
	(353124, 102, '2015-01-15 00:34:42.000000', 'consum', 0.0219, 'lps'),
	(353125, 102, '2015-01-15 00:34:43.000000', 'consum', 0.0215, 'lps'),
	(353126, 102, '2015-01-15 00:34:44.000000', 'consum', 0.0219, 'lps'),
	(353127, 102, '2015-01-15 00:34:45.000000', 'consum', 0.0212, 'lps'),
	(353128, 102, '2015-01-15 00:34:46.000000', 'consum', 0.0210, 'lps'),
	(353129, 102, '2015-01-15 00:34:47.000000', 'consum', 0.0217, 'lps'),
	(353130, 102, '2015-01-15 00:34:48.000000', 'consum', 0.0215, 'lps'),
	(353131, 102, '2015-01-15 00:34:49.000000', 'consum', 0.0216, 'lps'),
	(353132, 102, '2015-01-15 00:34:50.000000', 'consum', 0.0213, 'lps'),
	(353133, 102, '2015-01-15 00:34:51.000000', 'consum', 0.0216, 'lps'),
	(353134, 102, '2015-01-15 00:34:52.000000', 'consum', 0.0215, 'lps'),
	(353135, 102, '2015-01-15 00:34:53.000000', 'consum', 0.0218, 'lps'),
	(353136, 102, '2015-01-15 00:34:54.000000', 'consum', 0.0212, 'lps'),
	(353137, 102, '2015-01-15 00:34:55.000000', 'consum', 0.0219, 'lps'),
	(353138, 102, '2015-01-15 00:34:56.000000', 'consum', 0.0219, 'lps'),
	(353139, 102, '2015-01-15 00:34:57.000000', 'consum', 0.0217, 'lps'),
	(353140, 102, '2015-01-15 00:34:58.000000', 'consum', 0.0210, 'lps'),
	(353141, 102, '2015-01-15 00:34:59.000000', 'consum', 0.0218, 'lps'),
	(353142, 102, '2015-01-15 00:35:00.000000', 'consum', 0.0212, 'lps'),
	(353143, 102, '2015-01-15 00:35:01.000000', 'consum', 0.0217, 'lps'),
	(353144, 102, '2015-01-15 00:35:02.000000', 'consum', 0.0218, 'lps'),
	(353145, 102, '2015-01-15 00:35:03.000000', 'consum', 0.0211, 'lps'),
	(353146, 102, '2015-01-15 00:35:04.000000', 'consum', 0.0212, 'lps'),
	(353147, 102, '2015-01-15 00:35:05.000000', 'consum', 0.0216, 'lps'),
	(353148, 102, '2015-01-15 00:35:06.000000', 'consum', 0.0215, 'lps'),
	(353149, 102, '2015-01-15 00:35:07.000000', 'consum', 0.0216, 'lps'),
	(353150, 102, '2015-01-15 00:35:08.000000', 'consum', 0.0218, 'lps'),
	(353151, 102, '2015-01-15 00:35:09.000000', 'consum', 0.0213, 'lps'),
	(353152, 102, '2015-01-15 00:35:10.000000', 'consum', 0.0211, 'lps'),
	(353153, 102, '2015-01-15 00:35:11.000000', 'consum', 0.0216, 'lps'),
	(353154, 102, '2015-01-15 00:35:12.000000', 'consum', 0.0217, 'lps'),
	(353155, 102, '2015-01-15 00:35:13.000000', 'consum', 0.0210, 'lps'),
	(353156, 102, '2015-01-15 00:35:14.000000', 'consum', 0.0218, 'lps'),
	(353157, 102, '2015-01-15 00:35:15.000000', 'consum', 0.0219, 'lps'),
	(353158, 102, '2015-01-15 00:35:16.000000', 'consum', 0.0211, 'lps'),
	(353159, 102, '2015-01-15 00:35:17.000000', 'consum', 0.0212, 'lps'),
	(353160, 102, '2015-01-15 00:35:18.000000', 'consum', 0.0214, 'lps'),
	(353161, 102, '2015-01-15 00:35:19.000000', 'consum', 0.0216, 'lps'),
	(353162, 102, '2015-01-15 00:35:20.000000', 'consum', 0.0219, 'lps'),
	(353163, 102, '2015-01-15 00:35:21.000000', 'consum', 0.0217, 'lps'),
	(353164, 102, '2015-01-15 00:35:22.000000', 'consum', 0.0219, 'lps'),
	(353165, 102, '2015-01-15 00:35:23.000000', 'consum', 0.0215, 'lps'),
	(353166, 102, '2015-01-15 00:35:24.000000', 'consum', 0.0217, 'lps'),
	(353167, 102, '2015-01-15 00:35:25.000000', 'consum', 0.0212, 'lps'),
	(353168, 102, '2015-01-15 00:35:26.000000', 'consum', 0.0210, 'lps'),
	(353169, 102, '2015-01-15 00:35:27.000000', 'consum', 0.0214, 'lps'),
	(353170, 102, '2015-01-15 00:35:28.000000', 'consum', 0.0219, 'lps'),
	(353171, 102, '2015-01-15 00:35:29.000000', 'consum', 0.0216, 'lps'),
	(353172, 102, '2015-01-15 00:35:30.000000', 'consum', 0.0211, 'lps'),
	(353173, 102, '2015-01-15 00:35:31.000000', 'consum', 0.0210, 'lps'),
	(353174, 102, '2015-01-15 00:35:32.000000', 'consum', 0.0216, 'lps'),
	(353175, 102, '2015-01-15 00:35:33.000000', 'consum', 0.0211, 'lps'),
	(353176, 102, '2015-01-15 00:35:34.000000', 'consum', 0.0217, 'lps'),
	(353177, 102, '2015-01-15 00:35:35.000000', 'consum', 0.0214, 'lps'),
	(353178, 102, '2015-01-15 00:35:36.000000', 'consum', 0.0210, 'lps'),
	(353179, 102, '2015-01-15 00:35:37.000000', 'consum', 0.0216, 'lps'),
	(353180, 102, '2015-01-15 00:35:38.000000', 'consum', 0.0212, 'lps'),
	(353181, 102, '2015-01-15 00:35:39.000000', 'consum', 0.0212, 'lps'),
	(353182, 102, '2015-01-15 00:35:40.000000', 'consum', 0.0213, 'lps'),
	(353183, 102, '2015-01-15 00:35:41.000000', 'consum', 0.0210, 'lps'),
	(353184, 102, '2015-01-15 00:35:42.000000', 'consum', 0.0210, 'lps'),
	(353185, 102, '2015-01-15 00:35:43.000000', 'consum', 0.0212, 'lps'),
	(353186, 102, '2015-01-15 00:35:44.000000', 'consum', 0.0219, 'lps'),
	(353187, 102, '2015-01-15 00:35:45.000000', 'consum', 0.0210, 'lps'),
	(353188, 102, '2015-01-15 00:35:46.000000', 'consum', 0.0214, 'lps'),
	(353189, 102, '2015-01-15 00:35:47.000000', 'consum', 0.0212, 'lps'),
	(353190, 102, '2015-01-15 00:35:48.000000', 'consum', 0.0217, 'lps'),
	(353191, 102, '2015-01-15 00:35:49.000000', 'consum', 0.0218, 'lps'),
	(353192, 102, '2015-01-15 00:35:50.000000', 'consum', 0.0210, 'lps'),
	(353193, 102, '2015-01-15 00:35:51.000000', 'consum', 0.0218, 'lps'),
	(353194, 102, '2015-01-15 00:35:52.000000', 'consum', 0.0211, 'lps'),
	(353195, 102, '2015-01-15 00:35:53.000000', 'consum', 0.0211, 'lps'),
	(353196, 102, '2015-01-15 00:35:54.000000', 'consum', 0.0213, 'lps'),
	(353197, 102, '2015-01-15 00:35:55.000000', 'consum', 0.0214, 'lps'),
	(353198, 102, '2015-01-15 00:35:56.000000', 'consum', 0.0211, 'lps'),
	(353199, 102, '2015-01-15 00:35:57.000000', 'consum', 0.0211, 'lps'),
	(353200, 102, '2015-01-15 00:35:58.000000', 'consum', 0.0214, 'lps'),
	(353201, 102, '2015-01-15 00:35:59.000000', 'consum', 0.0216, 'lps'),
	(353202, 102, '2015-01-15 00:36:00.000000', 'consum', 0.0218, 'lps'),
	(353203, 102, '2015-01-15 00:36:01.000000', 'consum', 0.0215, 'lps'),
	(353204, 102, '2015-01-15 00:36:02.000000', 'consum', 0.0210, 'lps'),
	(353205, 102, '2015-01-15 00:36:03.000000', 'consum', 0.0214, 'lps'),
	(353206, 102, '2015-01-15 00:36:04.000000', 'consum', 0.0214, 'lps'),
	(353207, 102, '2015-01-15 00:36:05.000000', 'consum', 0.0216, 'lps'),
	(353208, 102, '2015-01-15 00:36:06.000000', 'consum', 0.0211, 'lps'),
	(353209, 102, '2015-01-15 00:36:07.000000', 'consum', 0.0216, 'lps'),
	(353210, 102, '2015-01-15 00:36:08.000000', 'consum', 0.0217, 'lps'),
	(353211, 102, '2015-01-15 00:36:09.000000', 'consum', 0.0217, 'lps'),
	(353212, 102, '2015-01-15 00:36:10.000000', 'consum', 0.0217, 'lps'),
	(353213, 102, '2015-01-15 00:36:11.000000', 'consum', 0.0213, 'lps'),
	(353214, 102, '2015-01-15 00:36:12.000000', 'consum', 0.0213, 'lps'),
	(353215, 102, '2015-01-15 00:36:13.000000', 'consum', 0.0219, 'lps'),
	(353216, 102, '2015-01-15 00:36:14.000000', 'consum', 0.0214, 'lps'),
	(353217, 102, '2015-01-15 00:36:15.000000', 'consum', 0.0215, 'lps'),
	(353218, 102, '2015-01-15 00:36:16.000000', 'consum', 0.0211, 'lps'),
	(353219, 102, '2015-01-15 00:36:17.000000', 'consum', 0.0212, 'lps'),
	(353220, 102, '2015-01-15 00:36:18.000000', 'consum', 0.0219, 'lps'),
	(353221, 102, '2015-01-15 00:36:19.000000', 'consum', 0.0210, 'lps'),
	(353222, 102, '2015-01-15 00:36:20.000000', 'consum', 0.0212, 'lps'),
	(353223, 102, '2015-01-15 00:36:21.000000', 'consum', 0.0210, 'lps'),
	(353224, 102, '2015-01-15 00:36:22.000000', 'consum', 0.0214, 'lps'),
	(353225, 102, '2015-01-15 00:36:23.000000', 'consum', 0.0210, 'lps'),
	(353226, 102, '2015-01-15 00:36:24.000000', 'consum', 0.0211, 'lps'),
	(353227, 102, '2015-01-15 00:36:25.000000', 'consum', 0.0216, 'lps'),
	(353228, 102, '2015-01-15 00:36:26.000000', 'consum', 0.0217, 'lps'),
	(353229, 102, '2015-01-15 00:36:27.000000', 'consum', 0.0219, 'lps'),
	(353230, 102, '2015-01-15 00:36:28.000000', 'consum', 0.0211, 'lps'),
	(353231, 102, '2015-01-15 00:36:29.000000', 'consum', 0.0210, 'lps'),
	(353232, 102, '2015-01-15 00:36:30.000000', 'consum', 0.0217, 'lps'),
	(353233, 102, '2015-01-15 00:36:31.000000', 'consum', 0.0218, 'lps'),
	(353234, 102, '2015-01-15 00:36:32.000000', 'consum', 0.0217, 'lps'),
	(353235, 102, '2015-01-15 00:36:33.000000', 'consum', 0.0214, 'lps'),
	(353236, 102, '2015-01-15 00:36:34.000000', 'consum', 0.0218, 'lps'),
	(353237, 102, '2015-01-15 00:36:35.000000', 'consum', 0.0210, 'lps'),
	(353238, 102, '2015-01-15 00:36:36.000000', 'consum', 0.0215, 'lps'),
	(353239, 102, '2015-01-15 00:36:37.000000', 'consum', 0.0215, 'lps'),
	(353240, 102, '2015-01-15 00:36:38.000000', 'consum', 0.0211, 'lps'),
	(353241, 102, '2015-01-15 00:36:39.000000', 'consum', 0.0211, 'lps'),
	(353242, 102, '2015-01-15 00:36:40.000000', 'consum', 0.0212, 'lps'),
	(353243, 102, '2015-01-15 00:36:41.000000', 'consum', 0.0216, 'lps'),
	(353244, 102, '2015-01-15 00:36:42.000000', 'consum', 0.0215, 'lps'),
	(353245, 102, '2015-01-15 00:36:43.000000', 'consum', 0.0216, 'lps'),
	(353246, 102, '2015-01-15 00:36:44.000000', 'consum', 0.0218, 'lps'),
	(353247, 102, '2015-01-15 00:36:45.000000', 'consum', 0.0214, 'lps'),
	(353248, 102, '2015-01-15 00:36:46.000000', 'consum', 0.0214, 'lps'),
	(353249, 102, '2015-01-15 00:36:47.000000', 'consum', 0.0218, 'lps'),
	(353250, 102, '2015-01-15 00:36:48.000000', 'consum', 0.0211, 'lps'),
	(353251, 102, '2015-01-15 00:36:49.000000', 'consum', 0.0211, 'lps'),
	(353252, 102, '2015-01-15 00:36:50.000000', 'consum', 0.0212, 'lps'),
	(353253, 102, '2015-01-15 00:36:51.000000', 'consum', 0.0218, 'lps'),
	(353254, 102, '2015-01-15 00:36:52.000000', 'consum', 0.0212, 'lps'),
	(353255, 102, '2015-01-15 00:36:53.000000', 'consum', 0.0219, 'lps'),
	(353256, 102, '2015-01-15 00:36:54.000000', 'consum', 0.0219, 'lps'),
	(353257, 102, '2015-01-15 00:36:55.000000', 'consum', 0.0217, 'lps'),
	(353258, 102, '2015-01-15 00:36:56.000000', 'consum', 0.0211, 'lps'),
	(353259, 102, '2015-01-15 00:36:57.000000', 'consum', 0.0214, 'lps'),
	(353260, 102, '2015-01-15 00:36:58.000000', 'consum', 0.0219, 'lps'),
	(353261, 102, '2015-01-15 00:36:59.000000', 'consum', 0.0213, 'lps'),
	(353262, 102, '2015-01-15 00:37:00.000000', 'consum', 0.0218, 'lps'),
	(353263, 102, '2015-01-15 00:37:01.000000', 'consum', 0.0213, 'lps'),
	(353264, 102, '2015-01-15 00:37:02.000000', 'consum', 0.0212, 'lps'),
	(353265, 102, '2015-01-15 00:37:03.000000', 'consum', 0.0210, 'lps'),
	(353266, 102, '2015-01-15 00:37:04.000000', 'consum', 0.0216, 'lps'),
	(353267, 102, '2015-01-15 00:37:05.000000', 'consum', 0.0218, 'lps'),
	(353268, 102, '2015-01-15 00:37:06.000000', 'consum', 0.0212, 'lps'),
	(353269, 102, '2015-01-15 00:37:07.000000', 'consum', 0.0218, 'lps'),
	(353270, 102, '2015-01-15 00:37:08.000000', 'consum', 0.0216, 'lps'),
	(353271, 102, '2015-01-15 00:37:09.000000', 'consum', 0.0215, 'lps'),
	(353272, 102, '2015-01-15 00:37:10.000000', 'consum', 0.0210, 'lps'),
	(353273, 102, '2015-01-15 00:37:11.000000', 'consum', 0.0212, 'lps'),
	(353274, 102, '2015-01-15 00:37:12.000000', 'consum', 0.0211, 'lps'),
	(353275, 102, '2015-01-15 00:37:13.000000', 'consum', 0.0219, 'lps'),
	(353276, 102, '2015-01-15 00:37:14.000000', 'consum', 0.0214, 'lps'),
	(353277, 102, '2015-01-15 00:37:15.000000', 'consum', 0.0211, 'lps'),
	(353278, 102, '2015-01-15 00:37:16.000000', 'consum', 0.0214, 'lps'),
	(353279, 102, '2015-01-15 00:37:17.000000', 'consum', 0.0219, 'lps'),
	(353280, 102, '2015-01-15 00:37:18.000000', 'consum', 0.0213, 'lps'),
	(353281, 102, '2015-01-15 00:37:19.000000', 'consum', 0.0218, 'lps'),
	(353282, 102, '2015-01-15 00:37:20.000000', 'consum', 0.0210, 'lps'),
	(353283, 102, '2015-01-15 00:37:21.000000', 'consum', 0.0218, 'lps'),
	(353284, 102, '2015-01-15 00:37:22.000000', 'consum', 0.0212, 'lps'),
	(353285, 102, '2015-01-15 00:37:23.000000', 'consum', 0.0215, 'lps'),
	(353286, 102, '2015-01-15 00:37:24.000000', 'consum', 0.0219, 'lps'),
	(353287, 102, '2015-01-15 00:37:25.000000', 'consum', 0.0210, 'lps'),
	(353288, 102, '2015-01-15 00:37:26.000000', 'consum', 0.0214, 'lps'),
	(353289, 102, '2015-01-15 00:37:27.000000', 'consum', 0.0211, 'lps'),
	(353290, 102, '2015-01-15 00:37:28.000000', 'consum', 0.0212, 'lps'),
	(353291, 102, '2015-01-15 00:37:29.000000', 'consum', 0.0219, 'lps'),
	(353292, 102, '2015-01-15 00:37:30.000000', 'consum', 0.0217, 'lps'),
	(353293, 102, '2015-01-15 00:37:31.000000', 'consum', 0.0211, 'lps'),
	(353294, 102, '2015-01-15 00:37:32.000000', 'consum', 0.0215, 'lps'),
	(353295, 102, '2015-01-15 00:37:33.000000', 'consum', 0.0214, 'lps'),
	(353296, 102, '2015-01-15 00:37:34.000000', 'consum', 0.0212, 'lps'),
	(353297, 102, '2015-01-15 00:37:35.000000', 'consum', 0.0211, 'lps'),
	(353298, 102, '2015-01-15 00:37:36.000000', 'consum', 0.0217, 'lps'),
	(353299, 102, '2015-01-15 00:37:37.000000', 'consum', 0.0213, 'lps'),
	(353300, 102, '2015-01-15 00:37:38.000000', 'consum', 0.0214, 'lps'),
	(353301, 102, '2015-01-15 00:37:39.000000', 'consum', 0.0212, 'lps'),
	(353302, 102, '2015-01-15 00:37:40.000000', 'consum', 0.0210, 'lps'),
	(353303, 102, '2015-01-15 00:37:41.000000', 'consum', 0.0215, 'lps'),
	(353304, 102, '2015-01-15 00:37:42.000000', 'consum', 0.0215, 'lps'),
	(353305, 102, '2015-01-15 00:37:43.000000', 'consum', 0.0210, 'lps'),
	(353306, 102, '2015-01-15 00:37:44.000000', 'consum', 0.0213, 'lps'),
	(353307, 102, '2015-01-15 00:37:45.000000', 'consum', 0.0219, 'lps'),
	(353308, 102, '2015-01-15 00:37:46.000000', 'consum', 0.0217, 'lps'),
	(353309, 102, '2015-01-15 00:37:47.000000', 'consum', 0.0216, 'lps'),
	(353310, 102, '2015-01-15 00:37:48.000000', 'consum', 0.0218, 'lps'),
	(353311, 102, '2015-01-15 00:37:49.000000', 'consum', 0.0216, 'lps'),
	(353312, 102, '2015-01-15 00:37:50.000000', 'consum', 0.0213, 'lps'),
	(353313, 102, '2015-01-15 00:37:51.000000', 'consum', 0.0210, 'lps'),
	(353314, 102, '2015-01-15 00:37:52.000000', 'consum', 0.0213, 'lps'),
	(353315, 102, '2015-01-15 00:37:53.000000', 'consum', 0.0214, 'lps'),
	(353316, 102, '2015-01-15 00:37:54.000000', 'consum', 0.0211, 'lps'),
	(353317, 102, '2015-01-15 00:37:55.000000', 'consum', 0.0213, 'lps'),
	(353318, 102, '2015-01-15 00:37:56.000000', 'consum', 0.0214, 'lps'),
	(353319, 102, '2015-01-15 00:37:57.000000', 'consum', 0.0211, 'lps'),
	(353320, 102, '2015-01-15 00:37:58.000000', 'consum', 0.0215, 'lps'),
	(353321, 102, '2015-01-15 00:37:59.000000', 'consum', 0.0212, 'lps'),
	(353322, 102, '2015-01-15 00:38:00.000000', 'consum', 0.0216, 'lps'),
	(353323, 102, '2015-01-15 00:38:01.000000', 'consum', 0.0213, 'lps'),
	(353324, 102, '2015-01-15 00:38:02.000000', 'consum', 0.0210, 'lps'),
	(353325, 102, '2015-01-15 00:38:03.000000', 'consum', 0.0219, 'lps'),
	(353326, 102, '2015-01-15 00:38:04.000000', 'consum', 0.0218, 'lps'),
	(353327, 102, '2015-01-15 00:38:05.000000', 'consum', 0.0211, 'lps'),
	(353328, 102, '2015-01-15 00:38:06.000000', 'consum', 0.0214, 'lps'),
	(353329, 102, '2015-01-15 00:38:07.000000', 'consum', 0.0217, 'lps'),
	(353330, 102, '2015-01-15 00:38:08.000000', 'consum', 0.0213, 'lps'),
	(353331, 102, '2015-01-15 00:38:09.000000', 'consum', 0.0216, 'lps'),
	(353332, 102, '2015-01-15 00:38:10.000000', 'consum', 0.0210, 'lps'),
	(353333, 102, '2015-01-15 00:38:11.000000', 'consum', 0.0212, 'lps'),
	(353334, 102, '2015-01-15 00:38:12.000000', 'consum', 0.0219, 'lps'),
	(353335, 102, '2015-01-15 00:38:13.000000', 'consum', 0.0212, 'lps'),
	(353336, 102, '2015-01-15 00:38:14.000000', 'consum', 0.0215, 'lps'),
	(353337, 102, '2015-01-15 00:38:15.000000', 'consum', 0.0216, 'lps'),
	(353338, 102, '2015-01-15 00:38:16.000000', 'consum', 0.0219, 'lps'),
	(353339, 102, '2015-01-15 00:38:17.000000', 'consum', 0.0215, 'lps'),
	(353340, 102, '2015-01-15 00:38:18.000000', 'consum', 0.0219, 'lps'),
	(353341, 102, '2015-01-15 00:38:19.000000', 'consum', 0.0212, 'lps'),
	(353342, 102, '2015-01-15 00:38:20.000000', 'consum', 0.0213, 'lps'),
	(353343, 102, '2015-01-15 00:38:21.000000', 'consum', 0.0219, 'lps'),
	(353344, 102, '2015-01-15 00:38:22.000000', 'consum', 0.0217, 'lps'),
	(353345, 102, '2015-01-15 00:38:23.000000', 'consum', 0.0216, 'lps'),
	(353346, 102, '2015-01-15 00:38:24.000000', 'consum', 0.0213, 'lps'),
	(353347, 102, '2015-01-15 00:38:25.000000', 'consum', 0.0217, 'lps'),
	(353348, 102, '2015-01-15 00:38:26.000000', 'consum', 0.0216, 'lps'),
	(353349, 102, '2015-01-15 00:38:27.000000', 'consum', 0.0218, 'lps'),
	(353350, 102, '2015-01-15 00:38:28.000000', 'consum', 0.0213, 'lps'),
	(353351, 102, '2015-01-15 00:38:29.000000', 'consum', 0.0212, 'lps'),
	(353352, 102, '2015-01-15 00:38:30.000000', 'consum', 0.0210, 'lps'),
	(353353, 102, '2015-01-15 00:38:31.000000', 'consum', 0.0214, 'lps'),
	(353354, 102, '2015-01-15 00:38:32.000000', 'consum', 0.0211, 'lps'),
	(353355, 102, '2015-01-15 00:38:33.000000', 'consum', 0.0212, 'lps'),
	(353356, 102, '2015-01-15 00:38:34.000000', 'consum', 0.0210, 'lps'),
	(353357, 102, '2015-01-15 00:38:35.000000', 'consum', 0.0216, 'lps'),
	(353358, 102, '2015-01-15 00:38:36.000000', 'consum', 0.0218, 'lps'),
	(353359, 102, '2015-01-15 00:38:37.000000', 'consum', 0.0212, 'lps'),
	(353360, 102, '2015-01-15 00:38:38.000000', 'consum', 0.0218, 'lps'),
	(353361, 102, '2015-01-15 00:38:39.000000', 'consum', 0.0216, 'lps'),
	(353362, 102, '2015-01-15 00:38:40.000000', 'consum', 0.0215, 'lps'),
	(353363, 102, '2015-01-15 00:38:41.000000', 'consum', 0.0218, 'lps'),
	(353364, 102, '2015-01-15 00:38:42.000000', 'consum', 0.0214, 'lps'),
	(353365, 102, '2015-01-15 00:38:43.000000', 'consum', 0.0215, 'lps'),
	(353366, 102, '2015-01-15 00:38:44.000000', 'consum', 0.0217, 'lps'),
	(353367, 102, '2015-01-15 00:38:45.000000', 'consum', 0.0219, 'lps'),
	(353368, 102, '2015-01-15 00:38:46.000000', 'consum', 0.0213, 'lps'),
	(353369, 102, '2015-01-15 00:38:47.000000', 'consum', 0.0211, 'lps'),
	(353370, 102, '2015-01-15 00:38:48.000000', 'consum', 0.0215, 'lps'),
	(353371, 102, '2015-01-15 00:38:49.000000', 'consum', 0.0211, 'lps'),
	(353372, 102, '2015-01-15 00:38:50.000000', 'consum', 0.0212, 'lps'),
	(353373, 102, '2015-01-15 00:38:51.000000', 'consum', 0.0218, 'lps'),
	(353374, 102, '2015-01-15 00:38:52.000000', 'consum', 0.0215, 'lps'),
	(353375, 102, '2015-01-15 00:38:53.000000', 'consum', 0.0213, 'lps'),
	(353376, 102, '2015-01-15 00:38:54.000000', 'consum', 0.0217, 'lps'),
	(353377, 102, '2015-01-15 00:38:55.000000', 'consum', 0.0219, 'lps'),
	(353378, 102, '2015-01-15 00:38:56.000000', 'consum', 0.0214, 'lps'),
	(353379, 102, '2015-01-15 00:38:57.000000', 'consum', 0.0214, 'lps'),
	(353380, 102, '2015-01-15 00:38:58.000000', 'consum', 0.0218, 'lps'),
	(353381, 102, '2015-01-15 00:38:59.000000', 'consum', 0.0210, 'lps'),
	(353382, 102, '2015-01-15 00:39:00.000000', 'consum', 0.0216, 'lps'),
	(353383, 102, '2015-01-15 00:39:01.000000', 'consum', 0.0212, 'lps'),
	(353384, 102, '2015-01-15 00:39:02.000000', 'consum', 0.0210, 'lps'),
	(353385, 102, '2015-01-15 00:39:03.000000', 'consum', 0.0215, 'lps'),
	(353386, 102, '2015-01-15 00:39:04.000000', 'consum', 0.0214, 'lps'),
	(353387, 102, '2015-01-15 00:39:05.000000', 'consum', 0.0216, 'lps'),
	(353388, 102, '2015-01-15 00:39:06.000000', 'consum', 0.0217, 'lps'),
	(353389, 102, '2015-01-15 00:39:07.000000', 'consum', 0.0219, 'lps'),
	(353390, 102, '2015-01-15 00:39:08.000000', 'consum', 0.0216, 'lps'),
	(353391, 102, '2015-01-15 00:39:09.000000', 'consum', 0.0213, 'lps'),
	(353392, 102, '2015-01-15 00:39:10.000000', 'consum', 0.0218, 'lps'),
	(353393, 102, '2015-01-15 00:39:11.000000', 'consum', 0.0212, 'lps'),
	(353394, 102, '2015-01-15 00:39:12.000000', 'consum', 0.0216, 'lps'),
	(353395, 102, '2015-01-15 00:39:13.000000', 'consum', 0.0212, 'lps'),
	(353396, 102, '2015-01-15 00:39:14.000000', 'consum', 0.0215, 'lps'),
	(353397, 102, '2015-01-15 00:39:15.000000', 'consum', 0.0210, 'lps'),
	(353398, 102, '2015-01-15 00:39:16.000000', 'consum', 0.0215, 'lps'),
	(353399, 102, '2015-01-15 00:39:17.000000', 'consum', 0.0213, 'lps'),
	(353400, 102, '2015-01-15 00:39:18.000000', 'consum', 0.0214, 'lps'),
	(353401, 102, '2015-01-15 00:39:19.000000', 'consum', 0.0210, 'lps'),
	(353402, 102, '2015-01-15 00:39:20.000000', 'consum', 0.0218, 'lps'),
	(353403, 102, '2015-01-15 00:39:21.000000', 'consum', 0.0219, 'lps'),
	(353404, 102, '2015-01-15 00:39:22.000000', 'consum', 0.0213, 'lps'),
	(353405, 102, '2015-01-15 00:39:23.000000', 'consum', 0.0216, 'lps'),
	(353406, 102, '2015-01-15 00:39:24.000000', 'consum', 0.0215, 'lps'),
	(353407, 102, '2015-01-15 00:39:25.000000', 'consum', 0.0216, 'lps'),
	(353408, 102, '2015-01-15 00:39:26.000000', 'consum', 0.0217, 'lps'),
	(353409, 102, '2015-01-15 00:39:27.000000', 'consum', 0.0216, 'lps'),
	(353410, 102, '2015-01-15 00:39:28.000000', 'consum', 0.0212, 'lps'),
	(353411, 102, '2015-01-15 00:39:29.000000', 'consum', 0.0219, 'lps'),
	(353412, 102, '2015-01-15 00:39:30.000000', 'consum', 0.0210, 'lps'),
	(353413, 102, '2015-01-15 00:39:31.000000', 'consum', 0.0216, 'lps'),
	(353414, 102, '2015-01-15 00:39:32.000000', 'consum', 0.0219, 'lps'),
	(353415, 102, '2015-01-15 00:39:33.000000', 'consum', 0.0218, 'lps'),
	(353416, 102, '2015-01-15 00:39:34.000000', 'consum', 0.0213, 'lps'),
	(353417, 102, '2015-01-15 00:39:35.000000', 'consum', 0.0213, 'lps'),
	(353418, 102, '2015-01-15 00:39:36.000000', 'consum', 0.0214, 'lps'),
	(353419, 102, '2015-01-15 00:39:37.000000', 'consum', 0.0214, 'lps'),
	(353420, 102, '2015-01-15 00:39:38.000000', 'consum', 0.0218, 'lps'),
	(353421, 102, '2015-01-15 00:39:39.000000', 'consum', 0.0217, 'lps'),
	(353422, 102, '2015-01-15 00:39:40.000000', 'consum', 0.0211, 'lps'),
	(353423, 102, '2015-01-15 00:39:41.000000', 'consum', 0.0216, 'lps'),
	(353424, 102, '2015-01-15 00:39:42.000000', 'consum', 0.0216, 'lps'),
	(353425, 102, '2015-01-15 00:39:43.000000', 'consum', 0.0213, 'lps'),
	(353426, 102, '2015-01-15 00:39:44.000000', 'consum', 0.0219, 'lps'),
	(353427, 102, '2015-01-15 00:39:45.000000', 'consum', 0.0217, 'lps'),
	(353428, 102, '2015-01-15 00:39:46.000000', 'consum', 0.0217, 'lps'),
	(353429, 102, '2015-01-15 00:39:47.000000', 'consum', 0.0215, 'lps'),
	(353430, 102, '2015-01-15 00:39:48.000000', 'consum', 0.0213, 'lps'),
	(353431, 102, '2015-01-15 00:39:49.000000', 'consum', 0.0213, 'lps'),
	(353432, 102, '2015-01-15 00:39:50.000000', 'consum', 0.0217, 'lps'),
	(353433, 102, '2015-01-15 00:39:51.000000', 'consum', 0.0216, 'lps'),
	(353434, 102, '2015-01-15 00:39:52.000000', 'consum', 0.0210, 'lps'),
	(353435, 102, '2015-01-15 00:39:53.000000', 'consum', 0.0211, 'lps'),
	(353436, 102, '2015-01-15 00:39:54.000000', 'consum', 0.0217, 'lps'),
	(353437, 102, '2015-01-15 00:39:55.000000', 'consum', 0.0212, 'lps'),
	(353438, 102, '2015-01-15 00:39:56.000000', 'consum', 0.0211, 'lps'),
	(353439, 102, '2015-01-15 00:39:57.000000', 'consum', 0.0218, 'lps'),
	(353440, 102, '2015-01-15 00:39:58.000000', 'consum', 0.0219, 'lps'),
	(353441, 102, '2015-01-15 00:39:59.000000', 'consum', 0.0212, 'lps'),
	(353442, 102, '2015-01-15 00:40:00.000000', 'consum', 0.0213, 'lps'),
	(353443, 102, '2015-01-15 00:40:01.000000', 'consum', 0.0219, 'lps'),
	(353444, 102, '2015-01-15 00:40:02.000000', 'consum', 0.0216, 'lps'),
	(353445, 102, '2015-01-15 00:40:03.000000', 'consum', 0.0216, 'lps'),
	(353446, 102, '2015-01-15 00:40:04.000000', 'consum', 0.0211, 'lps'),
	(353447, 102, '2015-01-15 00:40:05.000000', 'consum', 0.0216, 'lps'),
	(353448, 102, '2015-01-15 00:40:06.000000', 'consum', 0.0210, 'lps'),
	(353449, 102, '2015-01-15 00:40:07.000000', 'consum', 0.0210, 'lps'),
	(353450, 102, '2015-01-15 00:40:08.000000', 'consum', 0.0210, 'lps'),
	(353451, 102, '2015-01-15 00:40:09.000000', 'consum', 0.0210, 'lps'),
	(353452, 102, '2015-01-15 00:40:10.000000', 'consum', 0.0213, 'lps'),
	(353453, 102, '2015-01-15 00:40:11.000000', 'consum', 0.0213, 'lps'),
	(353454, 102, '2015-01-15 00:40:12.000000', 'consum', 0.0217, 'lps'),
	(353455, 102, '2015-01-15 00:40:13.000000', 'consum', 0.0218, 'lps'),
	(353456, 102, '2015-01-15 00:40:14.000000', 'consum', 0.0218, 'lps'),
	(353457, 102, '2015-01-15 00:40:15.000000', 'consum', 0.0215, 'lps'),
	(353458, 102, '2015-01-15 00:40:16.000000', 'consum', 0.0213, 'lps'),
	(353459, 102, '2015-01-15 00:40:17.000000', 'consum', 0.0211, 'lps'),
	(353460, 102, '2015-01-15 00:40:18.000000', 'consum', 0.0216, 'lps'),
	(353461, 102, '2015-01-15 00:40:19.000000', 'consum', 0.0217, 'lps'),
	(353462, 102, '2015-01-15 00:40:20.000000', 'consum', 0.0217, 'lps'),
	(353463, 102, '2015-01-15 00:40:21.000000', 'consum', 0.0214, 'lps'),
	(353464, 102, '2015-01-15 00:40:22.000000', 'consum', 0.0210, 'lps'),
	(353465, 102, '2015-01-15 00:40:23.000000', 'consum', 0.0210, 'lps'),
	(353466, 102, '2015-01-15 00:40:24.000000', 'consum', 0.0218, 'lps'),
	(353467, 102, '2015-01-15 00:40:25.000000', 'consum', 0.0219, 'lps'),
	(353468, 102, '2015-01-15 00:40:26.000000', 'consum', 0.0215, 'lps'),
	(353469, 102, '2015-01-15 00:40:27.000000', 'consum', 0.0219, 'lps'),
	(353470, 102, '2015-01-15 00:40:28.000000', 'consum', 0.0211, 'lps'),
	(353471, 102, '2015-01-15 00:40:29.000000', 'consum', 0.0217, 'lps'),
	(353472, 102, '2015-01-15 00:40:30.000000', 'consum', 0.0211, 'lps'),
	(353473, 102, '2015-01-15 00:40:31.000000', 'consum', 0.0217, 'lps'),
	(353474, 102, '2015-01-15 00:40:32.000000', 'consum', 0.0213, 'lps'),
	(353475, 102, '2015-01-15 00:40:33.000000', 'consum', 0.0212, 'lps'),
	(353476, 102, '2015-01-15 00:40:34.000000', 'consum', 0.0211, 'lps'),
	(353477, 102, '2015-01-15 00:40:35.000000', 'consum', 0.0211, 'lps'),
	(353478, 102, '2015-01-15 00:40:36.000000', 'consum', 0.0211, 'lps'),
	(353479, 102, '2015-01-15 00:40:37.000000', 'consum', 0.0211, 'lps'),
	(353480, 102, '2015-01-15 00:40:38.000000', 'consum', 0.0216, 'lps'),
	(353481, 102, '2015-01-15 00:40:39.000000', 'consum', 0.0215, 'lps'),
	(353482, 102, '2015-01-15 00:40:40.000000', 'consum', 0.0218, 'lps'),
	(353483, 102, '2015-01-15 00:40:41.000000', 'consum', 0.0215, 'lps'),
	(353484, 102, '2015-01-15 00:40:42.000000', 'consum', 0.0214, 'lps'),
	(353485, 102, '2015-01-15 00:40:43.000000', 'consum', 0.0214, 'lps'),
	(353486, 102, '2015-01-15 00:40:44.000000', 'consum', 0.0218, 'lps'),
	(353487, 102, '2015-01-15 00:40:45.000000', 'consum', 0.0217, 'lps'),
	(353488, 102, '2015-01-15 00:40:46.000000', 'consum', 0.0214, 'lps'),
	(353489, 102, '2015-01-15 00:40:47.000000', 'consum', 0.0218, 'lps'),
	(353490, 102, '2015-01-15 00:40:48.000000', 'consum', 0.0219, 'lps'),
	(353491, 102, '2015-01-15 00:40:49.000000', 'consum', 0.0211, 'lps'),
	(353492, 102, '2015-01-15 00:40:50.000000', 'consum', 0.0210, 'lps'),
	(353493, 102, '2015-01-15 00:40:51.000000', 'consum', 0.0215, 'lps'),
	(353494, 102, '2015-01-15 00:40:52.000000', 'consum', 0.0215, 'lps'),
	(353495, 102, '2015-01-15 00:40:53.000000', 'consum', 0.0211, 'lps'),
	(353496, 102, '2015-01-15 00:40:54.000000', 'consum', 0.0213, 'lps'),
	(353497, 102, '2015-01-15 00:40:55.000000', 'consum', 0.0219, 'lps'),
	(353498, 102, '2015-01-15 00:40:56.000000', 'consum', 0.0218, 'lps'),
	(353499, 102, '2015-01-15 00:40:57.000000', 'consum', 0.0214, 'lps'),
	(353500, 102, '2015-01-15 00:40:58.000000', 'consum', 0.0217, 'lps'),
	(353501, 102, '2015-01-15 00:40:59.000000', 'consum', 0.0211, 'lps'),
	(353502, 102, '2015-01-15 00:41:00.000000', 'consum', 0.0215, 'lps'),
	(353503, 102, '2015-01-15 00:41:01.000000', 'consum', 0.0213, 'lps'),
	(353504, 102, '2015-01-15 00:41:02.000000', 'consum', 0.0211, 'lps'),
	(353505, 102, '2015-01-15 00:41:03.000000', 'consum', 0.0217, 'lps'),
	(353506, 102, '2015-01-15 00:41:04.000000', 'consum', 0.0212, 'lps'),
	(353507, 102, '2015-01-15 00:41:05.000000', 'consum', 0.0211, 'lps'),
	(353508, 102, '2015-01-15 00:41:06.000000', 'consum', 0.0218, 'lps'),
	(353509, 102, '2015-01-15 00:41:07.000000', 'consum', 0.0217, 'lps'),
	(353510, 102, '2015-01-15 00:41:08.000000', 'consum', 0.0213, 'lps'),
	(353511, 102, '2015-01-15 00:41:09.000000', 'consum', 0.0215, 'lps'),
	(353512, 102, '2015-01-15 00:41:10.000000', 'consum', 0.0215, 'lps'),
	(353513, 102, '2015-01-15 00:41:11.000000', 'consum', 0.0212, 'lps'),
	(353514, 102, '2015-01-15 00:41:12.000000', 'consum', 0.0217, 'lps'),
	(353515, 102, '2015-01-15 00:41:13.000000', 'consum', 0.0217, 'lps'),
	(353516, 102, '2015-01-15 00:41:14.000000', 'consum', 0.0215, 'lps'),
	(353517, 102, '2015-01-15 00:41:15.000000', 'consum', 0.0213, 'lps'),
	(353518, 102, '2015-01-15 00:41:16.000000', 'consum', 0.0212, 'lps'),
	(353519, 102, '2015-01-15 00:41:17.000000', 'consum', 0.0212, 'lps'),
	(353520, 102, '2015-01-15 00:41:18.000000', 'consum', 0.0212, 'lps'),
	(353521, 102, '2015-01-15 00:41:19.000000', 'consum', 0.0215, 'lps'),
	(353522, 102, '2015-01-15 00:41:20.000000', 'consum', 0.0211, 'lps'),
	(353523, 102, '2015-01-15 00:41:21.000000', 'consum', 0.0218, 'lps'),
	(353524, 102, '2015-01-15 00:41:22.000000', 'consum', 0.0210, 'lps'),
	(353525, 102, '2015-01-15 00:41:23.000000', 'consum', 0.0215, 'lps'),
	(353526, 102, '2015-01-15 00:41:24.000000', 'consum', 0.0214, 'lps'),
	(353527, 102, '2015-01-15 00:41:25.000000', 'consum', 0.0216, 'lps'),
	(353528, 102, '2015-01-15 00:41:26.000000', 'consum', 0.0211, 'lps'),
	(353529, 102, '2015-01-15 00:41:27.000000', 'consum', 0.0216, 'lps'),
	(353530, 102, '2015-01-15 00:41:28.000000', 'consum', 0.0210, 'lps'),
	(353531, 102, '2015-01-15 00:41:29.000000', 'consum', 0.0219, 'lps'),
	(353532, 102, '2015-01-15 00:41:30.000000', 'consum', 0.0217, 'lps'),
	(353533, 102, '2015-01-15 00:41:31.000000', 'consum', 0.0219, 'lps'),
	(353534, 102, '2015-01-15 00:41:32.000000', 'consum', 0.0214, 'lps'),
	(353535, 102, '2015-01-15 00:41:33.000000', 'consum', 0.0216, 'lps'),
	(353536, 102, '2015-01-15 00:41:34.000000', 'consum', 0.0215, 'lps'),
	(353537, 102, '2015-01-15 00:41:35.000000', 'consum', 0.0219, 'lps'),
	(353538, 102, '2015-01-15 00:41:36.000000', 'consum', 0.0218, 'lps'),
	(353539, 102, '2015-01-15 00:41:37.000000', 'consum', 0.0217, 'lps'),
	(353540, 102, '2015-01-15 00:41:38.000000', 'consum', 0.0210, 'lps'),
	(353541, 102, '2015-01-15 00:41:39.000000', 'consum', 0.0219, 'lps'),
	(353542, 102, '2015-01-15 00:41:40.000000', 'consum', 0.0218, 'lps'),
	(353543, 102, '2015-01-15 00:41:41.000000', 'consum', 0.0210, 'lps'),
	(353544, 102, '2015-01-15 00:41:42.000000', 'consum', 0.0219, 'lps'),
	(353545, 102, '2015-01-15 00:41:43.000000', 'consum', 0.0215, 'lps'),
	(353546, 102, '2015-01-15 00:41:44.000000', 'consum', 0.0210, 'lps'),
	(353547, 102, '2015-01-15 00:41:45.000000', 'consum', 0.0216, 'lps'),
	(353548, 102, '2015-01-15 00:41:46.000000', 'consum', 0.0211, 'lps'),
	(353549, 102, '2015-01-15 00:41:47.000000', 'consum', 0.0216, 'lps'),
	(353550, 102, '2015-01-15 00:41:48.000000', 'consum', 0.0219, 'lps'),
	(353551, 102, '2015-01-15 00:41:49.000000', 'consum', 0.0215, 'lps'),
	(353552, 102, '2015-01-15 00:41:50.000000', 'consum', 0.0218, 'lps'),
	(353553, 102, '2015-01-15 00:41:51.000000', 'consum', 0.0217, 'lps'),
	(353554, 102, '2015-01-15 00:41:52.000000', 'consum', 0.0211, 'lps'),
	(353555, 102, '2015-01-15 00:41:53.000000', 'consum', 0.0216, 'lps'),
	(353556, 102, '2015-01-15 00:41:54.000000', 'consum', 0.0217, 'lps'),
	(353557, 102, '2015-01-15 00:41:55.000000', 'consum', 0.0218, 'lps'),
	(353558, 102, '2015-01-15 00:41:56.000000', 'consum', 0.0218, 'lps'),
	(353559, 102, '2015-01-15 00:41:57.000000', 'consum', 0.0219, 'lps'),
	(353560, 102, '2015-01-15 00:41:58.000000', 'consum', 0.0219, 'lps'),
	(353561, 102, '2015-01-15 00:41:59.000000', 'consum', 0.0210, 'lps'),
	(353562, 102, '2015-01-15 00:42:00.000000', 'consum', 0.0215, 'lps'),
	(353563, 102, '2015-01-15 00:42:01.000000', 'consum', 0.0213, 'lps'),
	(353564, 102, '2015-01-15 00:42:02.000000', 'consum', 0.0211, 'lps'),
	(353565, 102, '2015-01-15 00:42:03.000000', 'consum', 0.0219, 'lps'),
	(353566, 102, '2015-01-15 00:42:04.000000', 'consum', 0.0219, 'lps'),
	(353567, 102, '2015-01-15 00:42:05.000000', 'consum', 0.0210, 'lps'),
	(353568, 102, '2015-01-15 00:42:06.000000', 'consum', 0.0215, 'lps'),
	(353569, 102, '2015-01-15 00:42:07.000000', 'consum', 0.0216, 'lps'),
	(353570, 102, '2015-01-15 00:42:08.000000', 'consum', 0.0212, 'lps'),
	(353571, 102, '2015-01-15 00:42:09.000000', 'consum', 0.0216, 'lps'),
	(353572, 102, '2015-01-15 00:42:10.000000', 'consum', 0.0213, 'lps'),
	(353573, 102, '2015-01-15 00:42:11.000000', 'consum', 0.0218, 'lps'),
	(353574, 102, '2015-01-15 00:42:12.000000', 'consum', 0.0212, 'lps'),
	(353575, 102, '2015-01-15 00:42:13.000000', 'consum', 0.0214, 'lps'),
	(353576, 102, '2015-01-15 00:42:14.000000', 'consum', 0.0216, 'lps'),
	(353577, 102, '2015-01-15 00:42:15.000000', 'consum', 0.0210, 'lps'),
	(353578, 102, '2015-01-15 00:42:16.000000', 'consum', 0.0210, 'lps'),
	(353579, 102, '2015-01-15 00:42:17.000000', 'consum', 0.0211, 'lps'),
	(353580, 102, '2015-01-15 00:42:18.000000', 'consum', 0.0216, 'lps'),
	(353581, 102, '2015-01-15 00:42:19.000000', 'consum', 0.0216, 'lps'),
	(353582, 102, '2015-01-15 00:42:20.000000', 'consum', 0.0215, 'lps'),
	(353583, 102, '2015-01-15 00:42:21.000000', 'consum', 0.0216, 'lps'),
	(353584, 102, '2015-01-15 00:42:22.000000', 'consum', 0.0216, 'lps'),
	(353585, 102, '2015-01-15 00:42:23.000000', 'consum', 0.0211, 'lps'),
	(353586, 102, '2015-01-15 00:42:24.000000', 'consum', 0.0217, 'lps'),
	(353587, 102, '2015-01-15 00:42:25.000000', 'consum', 0.0215, 'lps'),
	(353588, 102, '2015-01-15 00:42:26.000000', 'consum', 0.0214, 'lps'),
	(353589, 102, '2015-01-15 00:42:27.000000', 'consum', 0.0215, 'lps'),
	(353590, 102, '2015-01-15 00:42:28.000000', 'consum', 0.0214, 'lps'),
	(353591, 102, '2015-01-15 00:42:29.000000', 'consum', 0.0214, 'lps'),
	(353592, 102, '2015-01-15 00:42:30.000000', 'consum', 0.0219, 'lps'),
	(353593, 102, '2015-01-15 00:42:31.000000', 'consum', 0.0215, 'lps'),
	(353594, 102, '2015-01-15 00:42:32.000000', 'consum', 0.0219, 'lps'),
	(353595, 102, '2015-01-15 00:42:33.000000', 'consum', 0.0211, 'lps'),
	(353596, 102, '2015-01-15 00:42:34.000000', 'consum', 0.0216, 'lps'),
	(353597, 102, '2015-01-15 00:42:35.000000', 'consum', 0.0217, 'lps'),
	(353598, 102, '2015-01-15 00:42:36.000000', 'consum', 0.0218, 'lps'),
	(353599, 102, '2015-01-15 00:42:37.000000', 'consum', 0.0219, 'lps'),
	(353600, 102, '2015-01-15 00:42:38.000000', 'consum', 0.0213, 'lps'),
	(353601, 102, '2015-01-15 00:42:39.000000', 'consum', 0.0210, 'lps'),
	(353602, 102, '2015-01-15 00:42:40.000000', 'consum', 0.0219, 'lps'),
	(353603, 102, '2015-01-15 00:42:41.000000', 'consum', 0.0218, 'lps'),
	(353604, 102, '2015-01-15 00:42:42.000000', 'consum', 0.0212, 'lps'),
	(353605, 102, '2015-01-15 00:42:43.000000', 'consum', 0.0216, 'lps'),
	(353606, 102, '2015-01-15 00:42:44.000000', 'consum', 0.0216, 'lps'),
	(353607, 102, '2015-01-15 00:42:45.000000', 'consum', 0.0210, 'lps'),
	(353608, 102, '2015-01-15 00:42:46.000000', 'consum', 0.0213, 'lps'),
	(353609, 102, '2015-01-15 00:42:47.000000', 'consum', 0.0216, 'lps'),
	(353610, 102, '2015-01-15 00:42:48.000000', 'consum', 0.0211, 'lps'),
	(353611, 102, '2015-01-15 00:42:49.000000', 'consum', 0.0217, 'lps'),
	(353612, 102, '2015-01-15 00:42:50.000000', 'consum', 0.0213, 'lps'),
	(353613, 102, '2015-01-15 00:42:51.000000', 'consum', 0.0214, 'lps'),
	(353614, 102, '2015-01-15 00:42:52.000000', 'consum', 0.0211, 'lps'),
	(353615, 102, '2015-01-15 00:42:53.000000', 'consum', 0.0215, 'lps'),
	(353616, 102, '2015-01-15 00:42:54.000000', 'consum', 0.0211, 'lps'),
	(353617, 102, '2015-01-15 00:42:55.000000', 'consum', 0.0210, 'lps'),
	(353618, 102, '2015-01-15 00:42:56.000000', 'consum', 0.0210, 'lps'),
	(353619, 102, '2015-01-15 00:42:57.000000', 'consum', 0.0218, 'lps'),
	(353620, 102, '2015-01-15 00:42:58.000000', 'consum', 0.0211, 'lps'),
	(353621, 102, '2015-01-15 00:42:59.000000', 'consum', 0.0211, 'lps'),
	(353622, 102, '2015-01-15 00:43:00.000000', 'consum', 0.0213, 'lps'),
	(353623, 102, '2015-01-15 00:43:01.000000', 'consum', 0.0214, 'lps'),
	(353624, 102, '2015-01-15 00:43:02.000000', 'consum', 0.0210, 'lps'),
	(353625, 102, '2015-01-15 00:43:03.000000', 'consum', 0.0211, 'lps'),
	(353626, 102, '2015-01-15 00:43:04.000000', 'consum', 0.0212, 'lps'),
	(353627, 102, '2015-01-15 00:43:05.000000', 'consum', 0.0219, 'lps'),
	(353628, 102, '2015-01-15 00:43:06.000000', 'consum', 0.0217, 'lps'),
	(353629, 102, '2015-01-15 00:43:07.000000', 'consum', 0.0211, 'lps'),
	(353630, 102, '2015-01-15 00:43:08.000000', 'consum', 0.0216, 'lps'),
	(353631, 102, '2015-01-15 00:43:09.000000', 'consum', 0.0216, 'lps'),
	(353632, 102, '2015-01-15 00:43:10.000000', 'consum', 0.0214, 'lps'),
	(353633, 102, '2015-01-15 00:43:11.000000', 'consum', 0.0212, 'lps'),
	(353634, 102, '2015-01-15 00:43:12.000000', 'consum', 0.0216, 'lps'),
	(353635, 102, '2015-01-15 00:43:13.000000', 'consum', 0.0216, 'lps'),
	(353636, 102, '2015-01-15 00:43:14.000000', 'consum', 0.0212, 'lps'),
	(353637, 102, '2015-01-15 00:43:15.000000', 'consum', 0.0215, 'lps'),
	(353638, 102, '2015-01-15 00:43:16.000000', 'consum', 0.0217, 'lps'),
	(353639, 102, '2015-01-15 00:43:17.000000', 'consum', 0.0210, 'lps'),
	(353640, 102, '2015-01-15 00:43:18.000000', 'consum', 0.0210, 'lps'),
	(353641, 102, '2015-01-15 00:43:19.000000', 'consum', 0.0211, 'lps'),
	(353642, 102, '2015-01-15 00:43:20.000000', 'consum', 0.0216, 'lps'),
	(353643, 102, '2015-01-15 00:43:21.000000', 'consum', 0.0216, 'lps'),
	(353644, 102, '2015-01-15 00:43:22.000000', 'consum', 0.0212, 'lps'),
	(353645, 102, '2015-01-15 00:43:23.000000', 'consum', 0.0213, 'lps'),
	(353646, 102, '2015-01-15 00:43:24.000000', 'consum', 0.0210, 'lps'),
	(353647, 102, '2015-01-15 00:43:25.000000', 'consum', 0.0212, 'lps'),
	(353648, 102, '2015-01-15 00:43:26.000000', 'consum', 0.0219, 'lps'),
	(353649, 102, '2015-01-15 00:43:27.000000', 'consum', 0.0210, 'lps'),
	(353650, 102, '2015-01-15 00:43:28.000000', 'consum', 0.0213, 'lps'),
	(353651, 102, '2015-01-15 00:43:29.000000', 'consum', 0.0215, 'lps'),
	(353652, 102, '2015-01-15 00:43:30.000000', 'consum', 0.0216, 'lps'),
	(353653, 102, '2015-01-15 00:43:31.000000', 'consum', 0.0218, 'lps'),
	(353654, 102, '2015-01-15 00:43:32.000000', 'consum', 0.0219, 'lps'),
	(353655, 102, '2015-01-15 00:43:33.000000', 'consum', 0.0215, 'lps'),
	(353656, 102, '2015-01-15 00:43:34.000000', 'consum', 0.0216, 'lps'),
	(353657, 102, '2015-01-15 00:43:35.000000', 'consum', 0.0218, 'lps'),
	(353658, 102, '2015-01-15 00:43:36.000000', 'consum', 0.0213, 'lps'),
	(353659, 102, '2015-01-15 00:43:37.000000', 'consum', 0.0219, 'lps'),
	(353660, 102, '2015-01-15 00:43:38.000000', 'consum', 0.0217, 'lps'),
	(353661, 102, '2015-01-15 00:43:39.000000', 'consum', 0.0217, 'lps'),
	(353662, 102, '2015-01-15 00:43:40.000000', 'consum', 0.0216, 'lps'),
	(353663, 102, '2015-01-15 00:43:41.000000', 'consum', 0.0210, 'lps'),
	(353664, 102, '2015-01-15 00:43:42.000000', 'consum', 0.0210, 'lps'),
	(353665, 102, '2015-01-15 00:43:43.000000', 'consum', 0.0213, 'lps'),
	(353666, 102, '2015-01-15 00:43:44.000000', 'consum', 0.0214, 'lps'),
	(353667, 102, '2015-01-15 00:43:45.000000', 'consum', 0.0213, 'lps'),
	(353668, 102, '2015-01-15 00:43:46.000000', 'consum', 0.0213, 'lps'),
	(353669, 102, '2015-01-15 00:43:47.000000', 'consum', 0.0216, 'lps'),
	(353670, 102, '2015-01-15 00:43:48.000000', 'consum', 0.0211, 'lps'),
	(353671, 102, '2015-01-15 00:43:49.000000', 'consum', 0.0217, 'lps'),
	(353672, 102, '2015-01-15 00:43:50.000000', 'consum', 0.0211, 'lps'),
	(353673, 102, '2015-01-15 00:43:51.000000', 'consum', 0.0218, 'lps'),
	(353674, 102, '2015-01-15 00:43:52.000000', 'consum', 0.0214, 'lps'),
	(353675, 102, '2015-01-15 00:43:53.000000', 'consum', 0.0218, 'lps'),
	(353676, 102, '2015-01-15 00:43:54.000000', 'consum', 0.0210, 'lps'),
	(353677, 102, '2015-01-15 00:43:55.000000', 'consum', 0.0214, 'lps'),
	(353678, 102, '2015-01-15 00:43:56.000000', 'consum', 0.0212, 'lps'),
	(353679, 102, '2015-01-15 00:43:57.000000', 'consum', 0.0219, 'lps'),
	(353680, 102, '2015-01-15 00:43:58.000000', 'consum', 0.0218, 'lps'),
	(353681, 102, '2015-01-15 00:43:59.000000', 'consum', 0.0213, 'lps'),
	(353682, 102, '2015-01-15 00:44:00.000000', 'consum', 0.0211, 'lps'),
	(353683, 102, '2015-01-15 00:44:01.000000', 'consum', 0.0217, 'lps'),
	(353684, 102, '2015-01-15 00:44:02.000000', 'consum', 0.0213, 'lps'),
	(353685, 102, '2015-01-15 00:44:03.000000', 'consum', 0.0216, 'lps'),
	(353686, 102, '2015-01-15 00:44:04.000000', 'consum', 0.0210, 'lps'),
	(353687, 102, '2015-01-15 00:44:05.000000', 'consum', 0.0214, 'lps'),
	(353688, 102, '2015-01-15 00:44:06.000000', 'consum', 0.0219, 'lps'),
	(353689, 102, '2015-01-15 00:44:07.000000', 'consum', 0.0214, 'lps'),
	(353690, 102, '2015-01-15 00:44:08.000000', 'consum', 0.0214, 'lps'),
	(353691, 102, '2015-01-15 00:44:09.000000', 'consum', 0.0218, 'lps'),
	(353692, 102, '2015-01-15 00:44:10.000000', 'consum', 0.0219, 'lps'),
	(353693, 102, '2015-01-15 00:44:11.000000', 'consum', 0.0210, 'lps'),
	(353694, 102, '2015-01-15 00:44:12.000000', 'consum', 0.0215, 'lps'),
	(353695, 102, '2015-01-15 00:44:13.000000', 'consum', 0.0215, 'lps'),
	(353696, 102, '2015-01-15 00:44:14.000000', 'consum', 0.0212, 'lps'),
	(353697, 102, '2015-01-15 00:44:15.000000', 'consum', 0.0216, 'lps'),
	(353698, 102, '2015-01-15 00:44:16.000000', 'consum', 0.0215, 'lps'),
	(353699, 102, '2015-01-15 00:44:17.000000', 'consum', 0.0216, 'lps'),
	(353700, 102, '2015-01-15 00:44:18.000000', 'consum', 0.0217, 'lps'),
	(353701, 102, '2015-01-15 00:44:19.000000', 'consum', 0.0216, 'lps'),
	(353702, 102, '2015-01-15 00:44:20.000000', 'consum', 0.0210, 'lps'),
	(353703, 102, '2015-01-15 00:44:21.000000', 'consum', 0.0214, 'lps'),
	(353704, 102, '2015-01-15 00:44:22.000000', 'consum', 0.0219, 'lps'),
	(353705, 102, '2015-01-15 00:44:23.000000', 'consum', 0.0212, 'lps'),
	(353706, 102, '2015-01-15 00:44:24.000000', 'consum', 0.0215, 'lps'),
	(353707, 102, '2015-01-15 00:44:25.000000', 'consum', 0.0218, 'lps'),
	(353708, 102, '2015-01-15 00:44:26.000000', 'consum', 0.0217, 'lps'),
	(353709, 102, '2015-01-15 00:44:27.000000', 'consum', 0.0213, 'lps'),
	(353710, 102, '2015-01-15 00:44:28.000000', 'consum', 0.0214, 'lps'),
	(353711, 102, '2015-01-15 00:44:29.000000', 'consum', 0.0210, 'lps'),
	(353712, 102, '2015-01-15 00:44:30.000000', 'consum', 0.0218, 'lps'),
	(353713, 102, '2015-01-15 00:44:31.000000', 'consum', 0.0213, 'lps'),
	(353714, 102, '2015-01-15 00:44:32.000000', 'consum', 0.0211, 'lps'),
	(353715, 102, '2015-01-15 00:44:33.000000', 'consum', 0.0217, 'lps'),
	(353716, 102, '2015-01-15 00:44:34.000000', 'consum', 0.0212, 'lps'),
	(353717, 102, '2015-01-15 00:44:35.000000', 'consum', 0.0218, 'lps'),
	(353718, 102, '2015-01-15 00:44:36.000000', 'consum', 0.0214, 'lps'),
	(353719, 102, '2015-01-15 00:44:37.000000', 'consum', 0.0219, 'lps'),
	(353720, 102, '2015-01-15 00:44:38.000000', 'consum', 0.0213, 'lps'),
	(353721, 102, '2015-01-15 00:44:39.000000', 'consum', 0.0217, 'lps'),
	(353722, 102, '2015-01-15 00:44:40.000000', 'consum', 0.0215, 'lps'),
	(353723, 102, '2015-01-15 00:44:41.000000', 'consum', 0.0217, 'lps'),
	(353724, 102, '2015-01-15 00:44:42.000000', 'consum', 0.0219, 'lps'),
	(353725, 102, '2015-01-15 00:44:43.000000', 'consum', 0.0214, 'lps'),
	(353726, 102, '2015-01-15 00:44:44.000000', 'consum', 0.0216, 'lps'),
	(353727, 102, '2015-01-15 00:44:45.000000', 'consum', 0.0216, 'lps'),
	(353728, 102, '2015-01-15 00:44:46.000000', 'consum', 0.0211, 'lps'),
	(353729, 102, '2015-01-15 00:44:47.000000', 'consum', 0.0211, 'lps'),
	(353730, 102, '2015-01-15 00:44:48.000000', 'consum', 0.0219, 'lps'),
	(353731, 102, '2015-01-15 00:44:49.000000', 'consum', 0.0215, 'lps'),
	(353732, 102, '2015-01-15 00:44:50.000000', 'consum', 0.0210, 'lps'),
	(353733, 102, '2015-01-15 00:44:51.000000', 'consum', 0.0214, 'lps'),
	(353734, 102, '2015-01-15 00:44:52.000000', 'consum', 0.0210, 'lps'),
	(353735, 102, '2015-01-15 00:44:53.000000', 'consum', 0.0219, 'lps'),
	(353736, 102, '2015-01-15 00:44:54.000000', 'consum', 0.0214, 'lps'),
	(353737, 102, '2015-01-15 00:44:55.000000', 'consum', 0.0213, 'lps'),
	(353738, 102, '2015-01-15 00:44:56.000000', 'consum', 0.0216, 'lps'),
	(353739, 102, '2015-01-15 00:44:57.000000', 'consum', 0.0211, 'lps'),
	(353740, 102, '2015-01-15 00:44:58.000000', 'consum', 0.0215, 'lps'),
	(353741, 102, '2015-01-15 00:44:59.000000', 'consum', 0.0214, 'lps'),
	(353742, 102, '2015-01-15 00:45:00.000000', 'consum', 0.0216, 'lps'),
	(353743, 102, '2015-01-15 00:45:01.000000', 'consum', 0.0218, 'lps'),
	(353744, 102, '2015-01-15 00:45:02.000000', 'consum', 0.0213, 'lps'),
	(353745, 102, '2015-01-15 00:45:03.000000', 'consum', 0.0211, 'lps'),
	(353746, 102, '2015-01-15 00:45:04.000000', 'consum', 0.0218, 'lps'),
	(353747, 102, '2015-01-15 00:45:05.000000', 'consum', 0.0216, 'lps'),
	(353748, 102, '2015-01-15 00:45:06.000000', 'consum', 0.0218, 'lps'),
	(353749, 102, '2015-01-15 00:45:07.000000', 'consum', 0.0212, 'lps'),
	(353750, 102, '2015-01-15 00:45:08.000000', 'consum', 0.0214, 'lps'),
	(353751, 102, '2015-01-15 00:45:09.000000', 'consum', 0.0218, 'lps'),
	(353752, 102, '2015-01-15 00:45:10.000000', 'consum', 0.0215, 'lps'),
	(353753, 102, '2015-01-15 00:45:11.000000', 'consum', 0.0214, 'lps'),
	(353754, 102, '2015-01-15 00:45:12.000000', 'consum', 0.0213, 'lps'),
	(353755, 102, '2015-01-15 00:45:13.000000', 'consum', 0.0216, 'lps'),
	(353756, 102, '2015-01-15 00:45:14.000000', 'consum', 0.0212, 'lps'),
	(353757, 102, '2015-01-15 00:45:15.000000', 'consum', 0.0212, 'lps'),
	(353758, 102, '2015-01-15 00:45:16.000000', 'consum', 0.0213, 'lps'),
	(353759, 102, '2015-01-15 00:45:17.000000', 'consum', 0.0210, 'lps'),
	(353760, 102, '2015-01-15 00:45:18.000000', 'consum', 0.0210, 'lps'),
	(353761, 102, '2015-01-15 00:45:19.000000', 'consum', 0.0211, 'lps'),
	(353762, 102, '2015-01-15 00:45:20.000000', 'consum', 0.0217, 'lps'),
	(353763, 102, '2015-01-15 00:45:21.000000', 'consum', 0.0213, 'lps'),
	(353764, 102, '2015-01-15 00:45:22.000000', 'consum', 0.0212, 'lps'),
	(353765, 102, '2015-01-15 00:45:23.000000', 'consum', 0.0214, 'lps'),
	(353766, 102, '2015-01-15 00:45:24.000000', 'consum', 0.0214, 'lps'),
	(353767, 102, '2015-01-15 00:45:25.000000', 'consum', 0.0218, 'lps'),
	(353768, 102, '2015-01-15 00:45:26.000000', 'consum', 0.0217, 'lps'),
	(353769, 102, '2015-01-15 00:45:27.000000', 'consum', 0.0213, 'lps'),
	(353770, 102, '2015-01-15 00:45:28.000000', 'consum', 0.0215, 'lps'),
	(353771, 102, '2015-01-15 00:45:29.000000', 'consum', 0.0218, 'lps'),
	(353772, 102, '2015-01-15 00:45:30.000000', 'consum', 0.0213, 'lps'),
	(353773, 102, '2015-01-15 00:45:31.000000', 'consum', 0.0211, 'lps'),
	(353774, 102, '2015-01-15 00:45:32.000000', 'consum', 0.0217, 'lps'),
	(353775, 102, '2015-01-15 00:45:33.000000', 'consum', 0.0213, 'lps'),
	(353776, 102, '2015-01-15 00:45:34.000000', 'consum', 0.0212, 'lps'),
	(353777, 102, '2015-01-15 00:45:35.000000', 'consum', 0.0215, 'lps'),
	(353778, 102, '2015-01-15 00:45:36.000000', 'consum', 0.0219, 'lps'),
	(353779, 102, '2015-01-15 00:45:37.000000', 'consum', 0.0211, 'lps'),
	(353780, 102, '2015-01-15 00:45:38.000000', 'consum', 0.0218, 'lps'),
	(353781, 102, '2015-01-15 00:45:39.000000', 'consum', 0.0217, 'lps'),
	(353782, 102, '2015-01-15 00:45:40.000000', 'consum', 0.0211, 'lps'),
	(353783, 102, '2015-01-15 00:45:41.000000', 'consum', 0.0214, 'lps'),
	(353784, 102, '2015-01-15 00:45:42.000000', 'consum', 0.0217, 'lps'),
	(353785, 102, '2015-01-15 00:45:43.000000', 'consum', 0.0213, 'lps'),
	(353786, 102, '2015-01-15 00:45:44.000000', 'consum', 0.0216, 'lps'),
	(353787, 102, '2015-01-15 00:45:45.000000', 'consum', 0.0211, 'lps'),
	(353788, 102, '2015-01-15 00:45:46.000000', 'consum', 0.0218, 'lps'),
	(353789, 102, '2015-01-15 00:45:47.000000', 'consum', 0.0217, 'lps'),
	(353790, 102, '2015-01-15 00:45:48.000000', 'consum', 0.0210, 'lps'),
	(353791, 102, '2015-01-15 00:45:49.000000', 'consum', 0.0212, 'lps'),
	(353792, 102, '2015-01-15 00:45:50.000000', 'consum', 0.0219, 'lps'),
	(353793, 102, '2015-01-15 00:45:51.000000', 'consum', 0.0219, 'lps'),
	(353794, 102, '2015-01-15 00:45:52.000000', 'consum', 0.0210, 'lps'),
	(353795, 102, '2015-01-15 00:45:53.000000', 'consum', 0.0215, 'lps'),
	(353796, 102, '2015-01-15 00:45:54.000000', 'consum', 0.0212, 'lps'),
	(353797, 102, '2015-01-15 00:45:55.000000', 'consum', 0.0217, 'lps'),
	(353798, 102, '2015-01-15 00:45:56.000000', 'consum', 0.0211, 'lps'),
	(353799, 102, '2015-01-15 00:45:57.000000', 'consum', 0.0213, 'lps'),
	(353800, 102, '2015-01-15 00:45:58.000000', 'consum', 0.0211, 'lps'),
	(353801, 102, '2015-01-15 00:45:59.000000', 'consum', 0.0210, 'lps'),
	(353802, 102, '2015-01-15 00:46:00.000000', 'consum', 0.0215, 'lps'),
	(353803, 102, '2015-01-15 00:46:01.000000', 'consum', 0.0215, 'lps'),
	(353804, 102, '2015-01-15 00:46:02.000000', 'consum', 0.0213, 'lps'),
	(353805, 102, '2015-01-15 00:46:03.000000', 'consum', 0.0210, 'lps'),
	(353806, 102, '2015-01-15 00:46:04.000000', 'consum', 0.0211, 'lps'),
	(353807, 102, '2015-01-15 00:46:05.000000', 'consum', 0.0215, 'lps'),
	(353808, 102, '2015-01-15 00:46:06.000000', 'consum', 0.0212, 'lps'),
	(353809, 102, '2015-01-15 00:46:07.000000', 'consum', 0.0215, 'lps'),
	(353810, 102, '2015-01-15 00:46:08.000000', 'consum', 0.0211, 'lps'),
	(353811, 102, '2015-01-15 00:46:09.000000', 'consum', 0.0211, 'lps'),
	(353812, 102, '2015-01-15 00:46:10.000000', 'consum', 0.0212, 'lps'),
	(353813, 102, '2015-01-15 00:46:11.000000', 'consum', 0.0218, 'lps'),
	(353814, 102, '2015-01-15 00:46:12.000000', 'consum', 0.0215, 'lps'),
	(353815, 102, '2015-01-15 00:46:13.000000', 'consum', 0.0212, 'lps'),
	(353816, 102, '2015-01-15 00:46:14.000000', 'consum', 0.0216, 'lps'),
	(353817, 102, '2015-01-15 00:46:15.000000', 'consum', 0.0214, 'lps'),
	(353818, 102, '2015-01-15 00:46:16.000000', 'consum', 0.0210, 'lps'),
	(353819, 102, '2015-01-15 00:46:17.000000', 'consum', 0.0212, 'lps'),
	(353820, 102, '2015-01-15 00:46:18.000000', 'consum', 0.0210, 'lps'),
	(353821, 102, '2015-01-15 00:46:19.000000', 'consum', 0.0212, 'lps'),
	(353822, 102, '2015-01-15 00:46:20.000000', 'consum', 0.0211, 'lps'),
	(353823, 102, '2015-01-15 00:46:21.000000', 'consum', 0.0211, 'lps'),
	(353824, 102, '2015-01-15 00:46:22.000000', 'consum', 0.0211, 'lps'),
	(353825, 102, '2015-01-15 00:46:23.000000', 'consum', 0.0212, 'lps'),
	(353826, 102, '2015-01-15 00:46:24.000000', 'consum', 0.0217, 'lps'),
	(353827, 102, '2015-01-15 00:46:25.000000', 'consum', 0.0211, 'lps'),
	(353828, 102, '2015-01-15 00:46:26.000000', 'consum', 0.0213, 'lps'),
	(353829, 102, '2015-01-15 00:46:27.000000', 'consum', 0.0212, 'lps'),
	(353830, 102, '2015-01-15 00:46:28.000000', 'consum', 0.0212, 'lps'),
	(353831, 102, '2015-01-15 00:46:29.000000', 'consum', 0.0214, 'lps'),
	(353832, 102, '2015-01-15 00:46:30.000000', 'consum', 0.0215, 'lps'),
	(353833, 102, '2015-01-15 00:46:31.000000', 'consum', 0.0212, 'lps'),
	(353834, 102, '2015-01-15 00:46:32.000000', 'consum', 0.0217, 'lps'),
	(353835, 102, '2015-01-15 00:46:33.000000', 'consum', 0.0219, 'lps'),
	(353836, 102, '2015-01-15 00:46:34.000000', 'consum', 0.0216, 'lps'),
	(353837, 102, '2015-01-15 00:46:35.000000', 'consum', 0.0214, 'lps'),
	(353838, 102, '2015-01-15 00:46:36.000000', 'consum', 0.0210, 'lps'),
	(353839, 102, '2015-01-15 00:46:37.000000', 'consum', 0.0218, 'lps'),
	(353840, 102, '2015-01-15 00:46:38.000000', 'consum', 0.0219, 'lps'),
	(353841, 102, '2015-01-15 00:46:39.000000', 'consum', 0.0215, 'lps'),
	(353842, 102, '2015-01-15 00:46:40.000000', 'consum', 0.0219, 'lps'),
	(353843, 102, '2015-01-15 00:46:41.000000', 'consum', 0.0218, 'lps'),
	(353844, 102, '2015-01-15 00:46:42.000000', 'consum', 0.0213, 'lps'),
	(353845, 102, '2015-01-15 00:46:43.000000', 'consum', 0.0214, 'lps'),
	(353846, 102, '2015-01-15 00:46:44.000000', 'consum', 0.0210, 'lps'),
	(353847, 102, '2015-01-15 00:46:45.000000', 'consum', 0.0211, 'lps'),
	(353848, 102, '2015-01-15 00:46:46.000000', 'consum', 0.0212, 'lps'),
	(353849, 102, '2015-01-15 00:46:47.000000', 'consum', 0.0210, 'lps'),
	(353850, 102, '2015-01-15 00:46:48.000000', 'consum', 0.0213, 'lps'),
	(353851, 102, '2015-01-15 00:46:49.000000', 'consum', 0.0215, 'lps'),
	(353852, 102, '2015-01-15 00:46:50.000000', 'consum', 0.0216, 'lps'),
	(353853, 102, '2015-01-15 00:46:51.000000', 'consum', 0.0217, 'lps'),
	(353854, 102, '2015-01-15 00:46:52.000000', 'consum', 0.0217, 'lps'),
	(353855, 102, '2015-01-15 00:46:53.000000', 'consum', 0.0213, 'lps'),
	(353856, 102, '2015-01-15 00:46:54.000000', 'consum', 0.0214, 'lps'),
	(353857, 102, '2015-01-15 00:46:55.000000', 'consum', 0.0214, 'lps'),
	(353858, 102, '2015-01-15 00:46:56.000000', 'consum', 0.0216, 'lps'),
	(353859, 102, '2015-01-15 00:46:57.000000', 'consum', 0.0218, 'lps'),
	(353860, 102, '2015-01-15 00:46:58.000000', 'consum', 0.0212, 'lps'),
	(353861, 102, '2015-01-15 00:46:59.000000', 'consum', 0.0216, 'lps'),
	(353862, 102, '2015-01-15 00:47:00.000000', 'consum', 0.0216, 'lps'),
	(353863, 102, '2015-01-15 00:47:01.000000', 'consum', 0.0212, 'lps'),
	(353864, 102, '2015-01-15 00:47:02.000000', 'consum', 0.0212, 'lps'),
	(353865, 102, '2015-01-15 00:47:03.000000', 'consum', 0.0214, 'lps'),
	(353866, 102, '2015-01-15 00:47:04.000000', 'consum', 0.0215, 'lps'),
	(353867, 102, '2015-01-15 00:47:05.000000', 'consum', 0.0213, 'lps'),
	(353868, 102, '2015-01-15 00:47:06.000000', 'consum', 0.0212, 'lps'),
	(353869, 102, '2015-01-15 00:47:07.000000', 'consum', 0.0211, 'lps'),
	(353870, 102, '2015-01-15 00:47:08.000000', 'consum', 0.0218, 'lps'),
	(353871, 102, '2015-01-15 00:47:09.000000', 'consum', 0.0218, 'lps'),
	(353872, 102, '2015-01-15 00:47:10.000000', 'consum', 0.0215, 'lps'),
	(353873, 102, '2015-01-15 00:47:11.000000', 'consum', 0.0211, 'lps'),
	(353874, 102, '2015-01-15 00:47:12.000000', 'consum', 0.0213, 'lps'),
	(353875, 102, '2015-01-15 00:47:13.000000', 'consum', 0.0212, 'lps'),
	(353876, 102, '2015-01-15 00:47:14.000000', 'consum', 0.0212, 'lps'),
	(353877, 102, '2015-01-15 00:47:15.000000', 'consum', 0.0215, 'lps'),
	(353878, 102, '2015-01-15 00:47:16.000000', 'consum', 0.0218, 'lps'),
	(353879, 102, '2015-01-15 00:47:17.000000', 'consum', 0.0218, 'lps'),
	(353880, 102, '2015-01-15 00:47:18.000000', 'consum', 0.0215, 'lps'),
	(353881, 102, '2015-01-15 00:47:19.000000', 'consum', 0.0211, 'lps'),
	(353882, 102, '2015-01-15 00:47:20.000000', 'consum', 0.0219, 'lps'),
	(353883, 102, '2015-01-15 00:47:21.000000', 'consum', 0.0213, 'lps'),
	(353884, 102, '2015-01-15 00:47:22.000000', 'consum', 0.0218, 'lps'),
	(353885, 102, '2015-01-15 00:47:23.000000', 'consum', 0.0214, 'lps'),
	(353886, 102, '2015-01-15 00:47:24.000000', 'consum', 0.0214, 'lps'),
	(353887, 102, '2015-01-15 00:47:25.000000', 'consum', 0.0219, 'lps'),
	(353888, 102, '2015-01-15 00:47:26.000000', 'consum', 0.0216, 'lps'),
	(353889, 102, '2015-01-15 00:47:27.000000', 'consum', 0.0211, 'lps'),
	(353890, 102, '2015-01-15 00:47:28.000000', 'consum', 0.0218, 'lps'),
	(353891, 102, '2015-01-15 00:47:29.000000', 'consum', 0.0219, 'lps'),
	(353892, 102, '2015-01-15 00:47:30.000000', 'consum', 0.0210, 'lps'),
	(353893, 102, '2015-01-15 00:47:31.000000', 'consum', 0.0212, 'lps'),
	(353894, 102, '2015-01-15 00:47:32.000000', 'consum', 0.0211, 'lps'),
	(353895, 102, '2015-01-15 00:47:33.000000', 'consum', 0.0210, 'lps'),
	(353896, 102, '2015-01-15 00:47:34.000000', 'consum', 0.0219, 'lps'),
	(353897, 102, '2015-01-15 00:47:35.000000', 'consum', 0.0215, 'lps'),
	(353898, 102, '2015-01-15 00:47:36.000000', 'consum', 0.0218, 'lps'),
	(353899, 102, '2015-01-15 00:47:37.000000', 'consum', 0.0217, 'lps'),
	(353900, 102, '2015-01-15 00:47:38.000000', 'consum', 0.0212, 'lps'),
	(353901, 102, '2015-01-15 00:47:39.000000', 'consum', 0.0210, 'lps'),
	(353902, 102, '2015-01-15 00:47:40.000000', 'consum', 0.0212, 'lps'),
	(353903, 102, '2015-01-15 00:47:41.000000', 'consum', 0.0213, 'lps'),
	(353904, 102, '2015-01-15 00:47:42.000000', 'consum', 0.0218, 'lps'),
	(353905, 102, '2015-01-15 00:47:43.000000', 'consum', 0.0212, 'lps'),
	(353906, 102, '2015-01-15 00:47:44.000000', 'consum', 0.0218, 'lps'),
	(353907, 102, '2015-01-15 00:47:45.000000', 'consum', 0.0215, 'lps'),
	(353908, 102, '2015-01-15 00:47:46.000000', 'consum', 0.0218, 'lps'),
	(353909, 102, '2015-01-15 00:47:47.000000', 'consum', 0.0219, 'lps'),
	(353910, 102, '2015-01-15 00:47:48.000000', 'consum', 0.0211, 'lps'),
	(353911, 102, '2015-01-15 00:47:49.000000', 'consum', 0.0217, 'lps'),
	(353912, 102, '2015-01-15 00:47:50.000000', 'consum', 0.0215, 'lps'),
	(353913, 102, '2015-01-15 00:47:51.000000', 'consum', 0.0214, 'lps'),
	(353914, 102, '2015-01-15 00:47:52.000000', 'consum', 0.0215, 'lps'),
	(353915, 102, '2015-01-15 00:47:53.000000', 'consum', 0.0213, 'lps'),
	(353916, 102, '2015-01-15 00:47:54.000000', 'consum', 0.0210, 'lps'),
	(353917, 102, '2015-01-15 00:47:55.000000', 'consum', 0.0211, 'lps'),
	(353918, 102, '2015-01-15 00:47:56.000000', 'consum', 0.0217, 'lps'),
	(353919, 102, '2015-01-15 00:47:57.000000', 'consum', 0.0213, 'lps'),
	(353920, 102, '2015-01-15 00:47:58.000000', 'consum', 0.0213, 'lps'),
	(353921, 102, '2015-01-15 00:47:59.000000', 'consum', 0.0216, 'lps'),
	(353922, 102, '2015-01-15 00:48:00.000000', 'consum', 0.0214, 'lps'),
	(353923, 102, '2015-01-15 00:48:01.000000', 'consum', 0.0211, 'lps'),
	(353924, 102, '2015-01-15 00:48:02.000000', 'consum', 0.0212, 'lps'),
	(353925, 102, '2015-01-15 00:48:03.000000', 'consum', 0.0219, 'lps'),
	(353926, 102, '2015-01-15 00:48:04.000000', 'consum', 0.0217, 'lps'),
	(353927, 102, '2015-01-15 00:48:05.000000', 'consum', 0.0212, 'lps'),
	(353928, 102, '2015-01-15 00:48:06.000000', 'consum', 0.0219, 'lps'),
	(353929, 102, '2015-01-15 00:48:07.000000', 'consum', 0.0218, 'lps'),
	(353930, 102, '2015-01-15 00:48:08.000000', 'consum', 0.0212, 'lps'),
	(353931, 102, '2015-01-15 00:48:09.000000', 'consum', 0.0218, 'lps'),
	(353932, 102, '2015-01-15 00:48:10.000000', 'consum', 0.0215, 'lps'),
	(353933, 102, '2015-01-15 00:48:11.000000', 'consum', 0.0212, 'lps'),
	(353934, 102, '2015-01-15 00:48:12.000000', 'consum', 0.0215, 'lps'),
	(353935, 102, '2015-01-15 00:48:13.000000', 'consum', 0.0211, 'lps'),
	(353936, 102, '2015-01-15 00:48:14.000000', 'consum', 0.0210, 'lps'),
	(353937, 102, '2015-01-15 00:48:15.000000', 'consum', 0.0218, 'lps'),
	(353938, 102, '2015-01-15 00:48:16.000000', 'consum', 0.0210, 'lps'),
	(353939, 102, '2015-01-15 00:48:17.000000', 'consum', 0.0214, 'lps'),
	(353940, 102, '2015-01-15 00:48:18.000000', 'consum', 0.0214, 'lps'),
	(353941, 102, '2015-01-15 00:48:19.000000', 'consum', 0.0218, 'lps'),
	(353942, 102, '2015-01-15 00:48:20.000000', 'consum', 0.0210, 'lps'),
	(353943, 102, '2015-01-15 00:48:21.000000', 'consum', 0.0215, 'lps'),
	(353944, 102, '2015-01-15 00:48:22.000000', 'consum', 0.0217, 'lps'),
	(353945, 102, '2015-01-15 00:48:23.000000', 'consum', 0.0219, 'lps'),
	(353946, 102, '2015-01-15 00:48:24.000000', 'consum', 0.0216, 'lps'),
	(353947, 102, '2015-01-15 00:48:25.000000', 'consum', 0.0211, 'lps'),
	(353948, 102, '2015-01-15 00:48:26.000000', 'consum', 0.0217, 'lps'),
	(353949, 102, '2015-01-15 00:48:27.000000', 'consum', 0.0213, 'lps'),
	(353950, 102, '2015-01-15 00:48:28.000000', 'consum', 0.0216, 'lps'),
	(353951, 102, '2015-01-15 00:48:29.000000', 'consum', 0.0210, 'lps'),
	(353952, 102, '2015-01-15 00:48:30.000000', 'consum', 0.0213, 'lps'),
	(353953, 102, '2015-01-15 00:48:31.000000', 'consum', 0.0215, 'lps'),
	(353954, 102, '2015-01-15 00:48:32.000000', 'consum', 0.0215, 'lps'),
	(353955, 102, '2015-01-15 00:48:33.000000', 'consum', 0.0212, 'lps'),
	(353956, 102, '2015-01-15 00:48:34.000000', 'consum', 0.0216, 'lps'),
	(353957, 102, '2015-01-15 00:48:35.000000', 'consum', 0.0215, 'lps'),
	(353958, 102, '2015-01-15 00:48:36.000000', 'consum', 0.0215, 'lps'),
	(353959, 102, '2015-01-15 00:48:37.000000', 'consum', 0.0212, 'lps'),
	(353960, 102, '2015-01-15 00:48:38.000000', 'consum', 0.0216, 'lps'),
	(353961, 102, '2015-01-15 00:48:39.000000', 'consum', 0.0213, 'lps'),
	(353962, 102, '2015-01-15 00:48:40.000000', 'consum', 0.0210, 'lps'),
	(353963, 102, '2015-01-15 00:48:41.000000', 'consum', 0.0219, 'lps'),
	(353964, 102, '2015-01-15 00:48:42.000000', 'consum', 0.0218, 'lps'),
	(353965, 102, '2015-01-15 00:48:43.000000', 'consum', 0.0213, 'lps'),
	(353966, 102, '2015-01-15 00:48:44.000000', 'consum', 0.0211, 'lps'),
	(353967, 102, '2015-01-15 00:48:45.000000', 'consum', 0.0215, 'lps'),
	(353968, 102, '2015-01-15 00:48:46.000000', 'consum', 0.0214, 'lps'),
	(353969, 102, '2015-01-15 00:48:47.000000', 'consum', 0.0216, 'lps'),
	(353970, 102, '2015-01-15 00:48:48.000000', 'consum', 0.0219, 'lps'),
	(353971, 102, '2015-01-15 00:48:49.000000', 'consum', 0.0215, 'lps'),
	(353972, 102, '2015-01-15 00:48:50.000000', 'consum', 0.0219, 'lps'),
	(353973, 102, '2015-01-15 00:48:51.000000', 'consum', 0.0210, 'lps'),
	(353974, 102, '2015-01-15 00:48:52.000000', 'consum', 0.0216, 'lps'),
	(353975, 102, '2015-01-15 00:48:53.000000', 'consum', 0.0219, 'lps'),
	(353976, 102, '2015-01-15 00:48:54.000000', 'consum', 0.0217, 'lps'),
	(353977, 102, '2015-01-15 00:48:55.000000', 'consum', 0.0210, 'lps'),
	(353978, 102, '2015-01-15 00:48:56.000000', 'consum', 0.0210, 'lps'),
	(353979, 102, '2015-01-15 00:48:57.000000', 'consum', 0.0219, 'lps'),
	(353980, 102, '2015-01-15 00:48:58.000000', 'consum', 0.0217, 'lps'),
	(353981, 102, '2015-01-15 00:48:59.000000', 'consum', 0.0218, 'lps'),
	(353982, 102, '2015-01-15 00:49:00.000000', 'consum', 0.0211, 'lps'),
	(353983, 102, '2015-01-15 00:49:01.000000', 'consum', 0.0219, 'lps'),
	(353984, 102, '2015-01-15 00:49:02.000000', 'consum', 0.0211, 'lps'),
	(353985, 102, '2015-01-15 00:49:03.000000', 'consum', 0.0212, 'lps'),
	(353986, 102, '2015-01-15 00:49:04.000000', 'consum', 0.0217, 'lps'),
	(353987, 102, '2015-01-15 00:49:05.000000', 'consum', 0.0219, 'lps'),
	(353988, 102, '2015-01-15 00:49:06.000000', 'consum', 0.0214, 'lps'),
	(353989, 102, '2015-01-15 00:49:07.000000', 'consum', 0.0213, 'lps'),
	(353990, 102, '2015-01-15 00:49:08.000000', 'consum', 0.0215, 'lps'),
	(353991, 102, '2015-01-15 00:49:09.000000', 'consum', 0.0218, 'lps'),
	(353992, 102, '2015-01-15 00:49:10.000000', 'consum', 0.0212, 'lps'),
	(353993, 102, '2015-01-15 00:49:11.000000', 'consum', 0.0217, 'lps'),
	(353994, 102, '2015-01-15 00:49:12.000000', 'consum', 0.0212, 'lps'),
	(353995, 102, '2015-01-15 00:49:13.000000', 'consum', 0.0218, 'lps'),
	(353996, 102, '2015-01-15 00:49:14.000000', 'consum', 0.0216, 'lps'),
	(353997, 102, '2015-01-15 00:49:15.000000', 'consum', 0.0215, 'lps'),
	(353998, 102, '2015-01-15 00:49:16.000000', 'consum', 0.0217, 'lps'),
	(353999, 102, '2015-01-15 00:49:17.000000', 'consum', 0.0213, 'lps'),
	(354000, 102, '2015-01-15 00:49:18.000000', 'consum', 0.0212, 'lps'),
	(354001, 102, '2015-01-15 00:49:19.000000', 'consum', 0.0214, 'lps'),
	(354002, 102, '2015-01-15 00:49:20.000000', 'consum', 0.0214, 'lps'),
	(354003, 102, '2015-01-15 00:49:21.000000', 'consum', 0.0216, 'lps'),
	(354004, 102, '2015-01-15 00:49:22.000000', 'consum', 0.0211, 'lps'),
	(354005, 102, '2015-01-15 00:49:23.000000', 'consum', 0.0216, 'lps'),
	(354006, 102, '2015-01-15 00:49:24.000000', 'consum', 0.0216, 'lps'),
	(354007, 102, '2015-01-15 00:49:25.000000', 'consum', 0.0215, 'lps'),
	(354008, 102, '2015-01-15 00:49:26.000000', 'consum', 0.0218, 'lps'),
	(354009, 102, '2015-01-15 00:49:27.000000', 'consum', 0.0213, 'lps'),
	(354010, 102, '2015-01-15 00:49:28.000000', 'consum', 0.0212, 'lps'),
	(354011, 102, '2015-01-15 00:49:29.000000', 'consum', 0.0211, 'lps'),
	(354012, 102, '2015-01-15 00:49:30.000000', 'consum', 0.0218, 'lps'),
	(354013, 102, '2015-01-15 00:49:31.000000', 'consum', 0.0210, 'lps'),
	(354014, 102, '2015-01-15 00:49:32.000000', 'consum', 0.0217, 'lps'),
	(354015, 102, '2015-01-15 00:49:33.000000', 'consum', 0.0214, 'lps'),
	(354016, 102, '2015-01-15 00:49:34.000000', 'consum', 0.0211, 'lps'),
	(354017, 102, '2015-01-15 00:49:35.000000', 'consum', 0.0212, 'lps'),
	(354018, 102, '2015-01-15 00:49:36.000000', 'consum', 0.0217, 'lps'),
	(354019, 102, '2015-01-15 00:49:37.000000', 'consum', 0.0212, 'lps'),
	(354020, 102, '2015-01-15 00:49:38.000000', 'consum', 0.0219, 'lps'),
	(354021, 102, '2015-01-15 00:49:39.000000', 'consum', 0.0217, 'lps'),
	(354022, 102, '2015-01-15 00:49:40.000000', 'consum', 0.0211, 'lps'),
	(354023, 102, '2015-01-15 00:49:41.000000', 'consum', 0.0213, 'lps'),
	(354024, 102, '2015-01-15 00:49:42.000000', 'consum', 0.0214, 'lps'),
	(354025, 102, '2015-01-15 00:49:43.000000', 'consum', 0.0210, 'lps'),
	(354026, 102, '2015-01-15 00:49:44.000000', 'consum', 0.0219, 'lps'),
	(354027, 102, '2015-01-15 00:49:45.000000', 'consum', 0.0216, 'lps'),
	(354028, 102, '2015-01-15 00:49:46.000000', 'consum', 0.0211, 'lps'),
	(354029, 102, '2015-01-15 00:49:47.000000', 'consum', 0.0210, 'lps'),
	(354030, 102, '2015-01-15 00:49:48.000000', 'consum', 0.0215, 'lps'),
	(354031, 102, '2015-01-15 00:49:49.000000', 'consum', 0.0217, 'lps'),
	(354032, 102, '2015-01-15 00:49:50.000000', 'consum', 0.0219, 'lps'),
	(354033, 102, '2015-01-15 00:49:51.000000', 'consum', 0.0215, 'lps'),
	(354034, 102, '2015-01-15 00:49:52.000000', 'consum', 0.0217, 'lps'),
	(354035, 102, '2015-01-15 00:49:53.000000', 'consum', 0.0213, 'lps'),
	(354036, 102, '2015-01-15 00:49:54.000000', 'consum', 0.0215, 'lps'),
	(354037, 102, '2015-01-15 00:49:55.000000', 'consum', 0.0215, 'lps'),
	(354038, 102, '2015-01-15 00:49:56.000000', 'consum', 0.0212, 'lps'),
	(354039, 102, '2015-01-15 00:49:57.000000', 'consum', 0.0215, 'lps'),
	(354040, 102, '2015-01-15 00:49:58.000000', 'consum', 0.0211, 'lps'),
	(354041, 102, '2015-01-15 00:49:59.000000', 'consum', 0.0210, 'lps'),
	(354042, 102, '2015-01-15 00:50:00.000000', 'consum', 0.0217, 'lps'),
	(354043, 102, '2015-01-15 00:50:01.000000', 'consum', 0.0214, 'lps'),
	(354044, 102, '2015-01-15 00:50:02.000000', 'consum', 0.0212, 'lps'),
	(354045, 102, '2015-01-15 00:50:03.000000', 'consum', 0.0219, 'lps'),
	(354046, 102, '2015-01-15 00:50:04.000000', 'consum', 0.0211, 'lps'),
	(354047, 102, '2015-01-15 00:50:05.000000', 'consum', 0.0215, 'lps'),
	(354048, 102, '2015-01-15 00:50:06.000000', 'consum', 0.0213, 'lps'),
	(354049, 102, '2015-01-15 00:50:07.000000', 'consum', 0.0210, 'lps'),
	(354050, 102, '2015-01-15 00:50:08.000000', 'consum', 0.0213, 'lps'),
	(354051, 102, '2015-01-15 00:50:09.000000', 'consum', 0.0213, 'lps'),
	(354052, 102, '2015-01-15 00:50:10.000000', 'consum', 0.0210, 'lps'),
	(354053, 102, '2015-01-15 00:50:11.000000', 'consum', 0.0218, 'lps'),
	(354054, 102, '2015-01-15 00:50:12.000000', 'consum', 0.0214, 'lps'),
	(354055, 102, '2015-01-15 00:50:13.000000', 'consum', 0.0215, 'lps'),
	(354056, 102, '2015-01-15 00:50:14.000000', 'consum', 0.0213, 'lps'),
	(354057, 102, '2015-01-15 00:50:15.000000', 'consum', 0.0211, 'lps'),
	(354058, 102, '2015-01-15 00:50:16.000000', 'consum', 0.0215, 'lps'),
	(354059, 102, '2015-01-15 00:50:17.000000', 'consum', 0.0215, 'lps'),
	(354060, 102, '2015-01-15 00:50:18.000000', 'consum', 0.0218, 'lps'),
	(354061, 102, '2015-01-15 00:50:19.000000', 'consum', 0.0218, 'lps'),
	(354062, 102, '2015-01-15 00:50:20.000000', 'consum', 0.0214, 'lps'),
	(354063, 102, '2015-01-15 00:50:21.000000', 'consum', 0.0219, 'lps'),
	(354064, 102, '2015-01-15 00:50:22.000000', 'consum', 0.0213, 'lps'),
	(354065, 102, '2015-01-15 00:50:23.000000', 'consum', 0.0216, 'lps'),
	(354066, 102, '2015-01-15 00:50:24.000000', 'consum', 0.0214, 'lps'),
	(354067, 102, '2015-01-15 00:50:25.000000', 'consum', 0.0212, 'lps'),
	(354068, 102, '2015-01-15 00:50:26.000000', 'consum', 0.0219, 'lps'),
	(354069, 102, '2015-01-15 00:50:27.000000', 'consum', 0.0210, 'lps'),
	(354070, 102, '2015-01-15 00:50:28.000000', 'consum', 0.0213, 'lps'),
	(354071, 102, '2015-01-15 00:50:29.000000', 'consum', 0.0213, 'lps'),
	(354072, 102, '2015-01-15 00:50:30.000000', 'consum', 0.0210, 'lps'),
	(354073, 102, '2015-01-15 00:50:31.000000', 'consum', 0.0219, 'lps'),
	(354074, 102, '2015-01-15 00:50:32.000000', 'consum', 0.0216, 'lps'),
	(354075, 102, '2015-01-15 00:50:33.000000', 'consum', 0.0214, 'lps'),
	(354076, 102, '2015-01-15 00:50:34.000000', 'consum', 0.0214, 'lps'),
	(354077, 102, '2015-01-15 00:50:35.000000', 'consum', 0.0218, 'lps'),
	(354078, 102, '2015-01-15 00:50:36.000000', 'consum', 0.0216, 'lps'),
	(354079, 102, '2015-01-15 00:50:37.000000', 'consum', 0.0217, 'lps'),
	(354080, 102, '2015-01-15 00:50:38.000000', 'consum', 0.0210, 'lps'),
	(354081, 102, '2015-01-15 00:50:39.000000', 'consum', 0.0218, 'lps'),
	(354082, 102, '2015-01-15 00:50:40.000000', 'consum', 0.0210, 'lps'),
	(354083, 102, '2015-01-15 00:50:41.000000', 'consum', 0.0217, 'lps'),
	(354084, 102, '2015-01-15 00:50:42.000000', 'consum', 0.0216, 'lps'),
	(354085, 102, '2015-01-15 00:50:43.000000', 'consum', 0.0210, 'lps'),
	(354086, 102, '2015-01-15 00:50:44.000000', 'consum', 0.0213, 'lps'),
	(354087, 102, '2015-01-15 00:50:45.000000', 'consum', 0.0213, 'lps'),
	(354088, 102, '2015-01-15 00:50:46.000000', 'consum', 0.0210, 'lps'),
	(354089, 102, '2015-01-15 00:50:47.000000', 'consum', 0.0219, 'lps'),
	(354090, 102, '2015-01-15 00:50:48.000000', 'consum', 0.0217, 'lps'),
	(354091, 102, '2015-01-15 00:50:49.000000', 'consum', 0.0218, 'lps'),
	(354092, 102, '2015-01-15 00:50:50.000000', 'consum', 0.0218, 'lps'),
	(354093, 102, '2015-01-15 00:50:51.000000', 'consum', 0.0217, 'lps'),
	(354094, 102, '2015-01-15 00:50:52.000000', 'consum', 0.0214, 'lps'),
	(354095, 102, '2015-01-15 00:50:53.000000', 'consum', 0.0216, 'lps'),
	(354096, 102, '2015-01-15 00:50:54.000000', 'consum', 0.0212, 'lps'),
	(354097, 102, '2015-01-15 00:50:55.000000', 'consum', 0.0211, 'lps'),
	(354098, 102, '2015-01-15 00:50:56.000000', 'consum', 0.0217, 'lps'),
	(354099, 102, '2015-01-15 00:50:57.000000', 'consum', 0.0216, 'lps'),
	(354100, 102, '2015-01-15 00:50:58.000000', 'consum', 0.0218, 'lps'),
	(354101, 102, '2015-01-15 00:50:59.000000', 'consum', 0.0212, 'lps'),
	(354102, 102, '2015-01-15 00:51:00.000000', 'consum', 0.0219, 'lps'),
	(354103, 102, '2015-01-15 00:51:01.000000', 'consum', 0.0219, 'lps'),
	(354104, 102, '2015-01-15 00:51:02.000000', 'consum', 0.0216, 'lps'),
	(354105, 102, '2015-01-15 00:51:03.000000', 'consum', 0.0217, 'lps'),
	(354106, 102, '2015-01-15 00:51:04.000000', 'consum', 0.0215, 'lps'),
	(354107, 102, '2015-01-15 00:51:05.000000', 'consum', 0.0214, 'lps'),
	(354108, 102, '2015-01-15 00:51:06.000000', 'consum', 0.0216, 'lps'),
	(354109, 102, '2015-01-15 00:51:07.000000', 'consum', 0.0211, 'lps'),
	(354110, 102, '2015-01-15 00:51:08.000000', 'consum', 0.0214, 'lps'),
	(354111, 102, '2015-01-15 00:51:09.000000', 'consum', 0.0210, 'lps'),
	(354112, 102, '2015-01-15 00:51:10.000000', 'consum', 0.0219, 'lps'),
	(354113, 102, '2015-01-15 00:51:11.000000', 'consum', 0.0213, 'lps'),
	(354114, 102, '2015-01-15 00:51:12.000000', 'consum', 0.0211, 'lps'),
	(354115, 102, '2015-01-15 00:51:13.000000', 'consum', 0.0216, 'lps'),
	(354116, 102, '2015-01-15 00:51:14.000000', 'consum', 0.0218, 'lps'),
	(354117, 102, '2015-01-15 00:51:15.000000', 'consum', 0.0213, 'lps'),
	(354118, 102, '2015-01-15 00:51:16.000000', 'consum', 0.0219, 'lps'),
	(354119, 102, '2015-01-15 00:51:17.000000', 'consum', 0.0217, 'lps'),
	(354120, 102, '2015-01-15 00:51:18.000000', 'consum', 0.0211, 'lps'),
	(354121, 102, '2015-01-15 00:51:19.000000', 'consum', 0.0213, 'lps'),
	(354122, 102, '2015-01-15 00:51:20.000000', 'consum', 0.0211, 'lps'),
	(354123, 102, '2015-01-15 00:51:21.000000', 'consum', 0.0216, 'lps'),
	(354124, 102, '2015-01-15 00:51:22.000000', 'consum', 0.0219, 'lps'),
	(354125, 102, '2015-01-15 00:51:23.000000', 'consum', 0.0219, 'lps'),
	(354126, 102, '2015-01-15 00:51:24.000000', 'consum', 0.0217, 'lps'),
	(354127, 102, '2015-01-15 00:51:25.000000', 'consum', 0.0210, 'lps'),
	(354128, 102, '2015-01-15 00:51:26.000000', 'consum', 0.0218, 'lps'),
	(354129, 102, '2015-01-15 00:51:27.000000', 'consum', 0.0210, 'lps'),
	(354130, 102, '2015-01-15 00:51:28.000000', 'consum', 0.0216, 'lps'),
	(354131, 102, '2015-01-15 00:51:29.000000', 'consum', 0.0219, 'lps'),
	(354132, 102, '2015-01-15 00:51:30.000000', 'consum', 0.0210, 'lps'),
	(354133, 102, '2015-01-15 00:51:31.000000', 'consum', 0.0212, 'lps'),
	(354134, 102, '2015-01-15 00:51:32.000000', 'consum', 0.0211, 'lps'),
	(354135, 102, '2015-01-15 00:51:33.000000', 'consum', 0.0210, 'lps'),
	(354136, 102, '2015-01-15 00:51:34.000000', 'consum', 0.0218, 'lps'),
	(354137, 102, '2015-01-15 00:51:35.000000', 'consum', 0.0210, 'lps'),
	(354138, 102, '2015-01-15 00:51:36.000000', 'consum', 0.0218, 'lps'),
	(354139, 102, '2015-01-15 00:51:37.000000', 'consum', 0.0211, 'lps'),
	(354140, 102, '2015-01-15 00:51:38.000000', 'consum', 0.0211, 'lps'),
	(354141, 102, '2015-01-15 00:51:39.000000', 'consum', 0.0213, 'lps'),
	(354142, 102, '2015-01-15 00:51:40.000000', 'consum', 0.0214, 'lps'),
	(354143, 102, '2015-01-15 00:51:41.000000', 'consum', 0.0219, 'lps'),
	(354144, 102, '2015-01-15 00:51:42.000000', 'consum', 0.0212, 'lps'),
	(354145, 102, '2015-01-15 00:51:43.000000', 'consum', 0.0215, 'lps'),
	(354146, 102, '2015-01-15 00:51:44.000000', 'consum', 0.0211, 'lps'),
	(354147, 102, '2015-01-15 00:51:45.000000', 'consum', 0.0211, 'lps'),
	(354148, 102, '2015-01-15 00:51:46.000000', 'consum', 0.0213, 'lps'),
	(354149, 102, '2015-01-15 00:51:47.000000', 'consum', 0.0210, 'lps'),
	(354150, 102, '2015-01-15 00:51:48.000000', 'consum', 0.0211, 'lps'),
	(354151, 102, '2015-01-15 00:51:49.000000', 'consum', 0.0215, 'lps'),
	(354152, 102, '2015-01-15 00:51:50.000000', 'consum', 0.0215, 'lps'),
	(354153, 102, '2015-01-15 00:51:51.000000', 'consum', 0.0219, 'lps'),
	(354154, 102, '2015-01-15 00:51:52.000000', 'consum', 0.0213, 'lps'),
	(354155, 102, '2015-01-15 00:51:53.000000', 'consum', 0.0217, 'lps'),
	(354156, 102, '2015-01-15 00:51:54.000000', 'consum', 0.0216, 'lps'),
	(354157, 102, '2015-01-15 00:51:55.000000', 'consum', 0.0210, 'lps'),
	(354158, 102, '2015-01-15 00:51:56.000000', 'consum', 0.0210, 'lps'),
	(354159, 102, '2015-01-15 00:51:57.000000', 'consum', 0.0214, 'lps'),
	(354160, 102, '2015-01-15 00:51:58.000000', 'consum', 0.0210, 'lps'),
	(354161, 102, '2015-01-15 00:51:59.000000', 'consum', 0.0218, 'lps'),
	(354162, 102, '2015-01-15 00:52:00.000000', 'consum', 0.0218, 'lps'),
	(354163, 102, '2015-01-15 00:52:01.000000', 'consum', 0.0210, 'lps'),
	(354164, 102, '2015-01-15 00:52:02.000000', 'consum', 0.0214, 'lps'),
	(354165, 102, '2015-01-15 00:52:03.000000', 'consum', 0.0212, 'lps'),
	(354166, 102, '2015-01-15 00:52:04.000000', 'consum', 0.0210, 'lps'),
	(354167, 102, '2015-01-15 00:52:05.000000', 'consum', 0.0213, 'lps'),
	(354168, 102, '2015-01-15 00:52:06.000000', 'consum', 0.0217, 'lps'),
	(354169, 102, '2015-01-15 00:52:07.000000', 'consum', 0.0216, 'lps'),
	(354170, 102, '2015-01-15 00:52:08.000000', 'consum', 0.0217, 'lps'),
	(354171, 102, '2015-01-15 00:52:09.000000', 'consum', 0.0211, 'lps'),
	(354172, 102, '2015-01-15 00:52:10.000000', 'consum', 0.0212, 'lps'),
	(354173, 102, '2015-01-15 00:52:11.000000', 'consum', 0.0218, 'lps'),
	(354174, 102, '2015-01-15 00:52:12.000000', 'consum', 0.0214, 'lps'),
	(354175, 102, '2015-01-15 00:52:13.000000', 'consum', 0.0219, 'lps'),
	(354176, 102, '2015-01-15 00:52:14.000000', 'consum', 0.0211, 'lps'),
	(354177, 102, '2015-01-15 00:52:15.000000', 'consum', 0.0219, 'lps'),
	(354178, 102, '2015-01-15 00:52:16.000000', 'consum', 0.0214, 'lps'),
	(354179, 102, '2015-01-15 00:52:17.000000', 'consum', 0.0213, 'lps'),
	(354180, 102, '2015-01-15 00:52:18.000000', 'consum', 0.0212, 'lps'),
	(354181, 102, '2015-01-15 00:52:19.000000', 'consum', 0.0211, 'lps'),
	(354182, 102, '2015-01-15 00:52:20.000000', 'consum', 0.0219, 'lps'),
	(354183, 102, '2015-01-15 00:52:21.000000', 'consum', 0.0215, 'lps'),
	(354184, 102, '2015-01-15 00:52:22.000000', 'consum', 0.0219, 'lps'),
	(354185, 102, '2015-01-15 00:52:23.000000', 'consum', 0.0218, 'lps'),
	(354186, 102, '2015-01-15 00:52:24.000000', 'consum', 0.0216, 'lps'),
	(354187, 102, '2015-01-15 00:52:25.000000', 'consum', 0.0215, 'lps'),
	(354188, 102, '2015-01-15 00:52:26.000000', 'consum', 0.0210, 'lps'),
	(354189, 102, '2015-01-15 00:52:27.000000', 'consum', 0.0213, 'lps'),
	(354190, 102, '2015-01-15 00:52:28.000000', 'consum', 0.0217, 'lps'),
	(354191, 102, '2015-01-15 00:52:29.000000', 'consum', 0.0215, 'lps'),
	(354192, 102, '2015-01-15 00:52:30.000000', 'consum', 0.0215, 'lps'),
	(354193, 102, '2015-01-15 00:52:31.000000', 'consum', 0.0210, 'lps'),
	(354194, 102, '2015-01-15 00:52:32.000000', 'consum', 0.0217, 'lps'),
	(354195, 102, '2015-01-15 00:52:33.000000', 'consum', 0.0216, 'lps'),
	(354196, 102, '2015-01-15 00:52:34.000000', 'consum', 0.0218, 'lps'),
	(354197, 102, '2015-01-15 00:52:35.000000', 'consum', 0.0212, 'lps'),
	(354198, 102, '2015-01-15 00:52:36.000000', 'consum', 0.0219, 'lps'),
	(354199, 102, '2015-01-15 00:52:37.000000', 'consum', 0.0219, 'lps'),
	(354200, 102, '2015-01-15 00:52:38.000000', 'consum', 0.0219, 'lps'),
	(354201, 102, '2015-01-15 00:52:39.000000', 'consum', 0.0217, 'lps'),
	(354202, 102, '2015-01-15 00:52:40.000000', 'consum', 0.0211, 'lps'),
	(354203, 102, '2015-01-15 00:52:41.000000', 'consum', 0.0211, 'lps'),
	(354204, 102, '2015-01-15 00:52:42.000000', 'consum', 0.0216, 'lps'),
	(354205, 102, '2015-01-15 00:52:43.000000', 'consum', 0.0216, 'lps'),
	(354206, 102, '2015-01-15 00:52:44.000000', 'consum', 0.0211, 'lps'),
	(354207, 102, '2015-01-15 00:52:45.000000', 'consum', 0.0219, 'lps'),
	(354208, 102, '2015-01-15 00:52:46.000000', 'consum', 0.0211, 'lps'),
	(354209, 102, '2015-01-15 00:52:47.000000', 'consum', 0.0211, 'lps'),
	(354210, 102, '2015-01-15 00:52:48.000000', 'consum', 0.0212, 'lps'),
	(354211, 102, '2015-01-15 00:52:49.000000', 'consum', 0.0218, 'lps'),
	(354212, 102, '2015-01-15 00:52:50.000000', 'consum', 0.0213, 'lps'),
	(354213, 102, '2015-01-15 00:52:51.000000', 'consum', 0.0214, 'lps'),
	(354214, 102, '2015-01-15 00:52:52.000000', 'consum', 0.0219, 'lps'),
	(354215, 102, '2015-01-15 00:52:53.000000', 'consum', 0.0216, 'lps'),
	(354216, 102, '2015-01-15 00:52:54.000000', 'consum', 0.0213, 'lps'),
	(354217, 102, '2015-01-15 00:52:55.000000', 'consum', 0.0216, 'lps'),
	(354218, 102, '2015-01-15 00:52:56.000000', 'consum', 0.0214, 'lps'),
	(354219, 102, '2015-01-15 00:52:57.000000', 'consum', 0.0211, 'lps'),
	(354220, 102, '2015-01-15 00:52:58.000000', 'consum', 0.0215, 'lps'),
	(354221, 102, '2015-01-15 00:52:59.000000', 'consum', 0.0214, 'lps'),
	(354222, 102, '2015-01-15 00:53:00.000000', 'consum', 0.0212, 'lps'),
	(354223, 102, '2015-01-15 00:53:01.000000', 'consum', 0.0210, 'lps'),
	(354224, 102, '2015-01-15 00:53:02.000000', 'consum', 0.0216, 'lps'),
	(354225, 102, '2015-01-15 00:53:03.000000', 'consum', 0.0218, 'lps'),
	(354226, 102, '2015-01-15 00:53:04.000000', 'consum', 0.0215, 'lps'),
	(354227, 102, '2015-01-15 00:53:05.000000', 'consum', 0.0211, 'lps'),
	(354228, 102, '2015-01-15 00:53:06.000000', 'consum', 0.0210, 'lps'),
	(354229, 102, '2015-01-15 00:53:07.000000', 'consum', 0.0216, 'lps'),
	(354230, 102, '2015-01-15 00:53:08.000000', 'consum', 0.0213, 'lps'),
	(354231, 102, '2015-01-15 00:53:09.000000', 'consum', 0.0217, 'lps'),
	(354232, 102, '2015-01-15 00:53:10.000000', 'consum', 0.0215, 'lps'),
	(354233, 102, '2015-01-15 00:53:11.000000', 'consum', 0.0213, 'lps'),
	(354234, 102, '2015-01-15 00:53:12.000000', 'consum', 0.0213, 'lps'),
	(354235, 102, '2015-01-15 00:53:13.000000', 'consum', 0.0215, 'lps'),
	(354236, 102, '2015-01-15 00:53:14.000000', 'consum', 0.0217, 'lps'),
	(354237, 102, '2015-01-15 00:53:15.000000', 'consum', 0.0213, 'lps'),
	(354238, 102, '2015-01-15 00:53:16.000000', 'consum', 0.0211, 'lps'),
	(354239, 102, '2015-01-15 00:53:17.000000', 'consum', 0.0218, 'lps'),
	(354240, 102, '2015-01-15 00:53:18.000000', 'consum', 0.0219, 'lps'),
	(354241, 102, '2015-01-15 00:53:19.000000', 'consum', 0.0219, 'lps'),
	(354242, 102, '2015-01-15 00:53:20.000000', 'consum', 0.0218, 'lps'),
	(354243, 102, '2015-01-15 00:53:21.000000', 'consum', 0.0212, 'lps'),
	(354244, 102, '2015-01-15 00:53:22.000000', 'consum', 0.0210, 'lps'),
	(354245, 102, '2015-01-15 00:53:23.000000', 'consum', 0.0213, 'lps'),
	(354246, 102, '2015-01-15 00:53:24.000000', 'consum', 0.0216, 'lps'),
	(354247, 102, '2015-01-15 00:53:25.000000', 'consum', 0.0210, 'lps'),
	(354248, 102, '2015-01-15 00:53:26.000000', 'consum', 0.0212, 'lps'),
	(354249, 102, '2015-01-15 00:53:27.000000', 'consum', 0.0212, 'lps'),
	(354250, 102, '2015-01-15 00:53:28.000000', 'consum', 0.0212, 'lps'),
	(354251, 102, '2015-01-15 00:53:29.000000', 'consum', 0.0216, 'lps'),
	(354252, 102, '2015-01-15 00:53:30.000000', 'consum', 0.0215, 'lps'),
	(354253, 102, '2015-01-15 00:53:31.000000', 'consum', 0.0218, 'lps'),
	(354254, 102, '2015-01-15 00:53:32.000000', 'consum', 0.0214, 'lps'),
	(354255, 102, '2015-01-15 00:53:33.000000', 'consum', 0.0216, 'lps'),
	(354256, 102, '2015-01-15 00:53:34.000000', 'consum', 0.0219, 'lps'),
	(354257, 102, '2015-01-15 00:53:35.000000', 'consum', 0.0210, 'lps'),
	(354258, 102, '2015-01-15 00:53:36.000000', 'consum', 0.0210, 'lps'),
	(354259, 102, '2015-01-15 00:53:37.000000', 'consum', 0.0211, 'lps'),
	(354260, 102, '2015-01-15 00:53:38.000000', 'consum', 0.0215, 'lps'),
	(354261, 102, '2015-01-15 00:53:39.000000', 'consum', 0.0213, 'lps'),
	(354262, 102, '2015-01-15 00:53:40.000000', 'consum', 0.0212, 'lps'),
	(354263, 102, '2015-01-15 00:53:41.000000', 'consum', 0.0211, 'lps'),
	(354264, 102, '2015-01-15 00:53:42.000000', 'consum', 0.0219, 'lps'),
	(354265, 102, '2015-01-15 00:53:43.000000', 'consum', 0.0211, 'lps'),
	(354266, 102, '2015-01-15 00:53:44.000000', 'consum', 0.0218, 'lps'),
	(354267, 102, '2015-01-15 00:53:45.000000', 'consum', 0.0210, 'lps'),
	(354268, 102, '2015-01-15 00:53:46.000000', 'consum', 0.0217, 'lps'),
	(354269, 102, '2015-01-15 00:53:47.000000', 'consum', 0.0212, 'lps'),
	(354270, 102, '2015-01-15 00:53:48.000000', 'consum', 0.0213, 'lps'),
	(354271, 102, '2015-01-15 00:53:49.000000', 'consum', 0.0219, 'lps'),
	(354272, 102, '2015-01-15 00:53:50.000000', 'consum', 0.0216, 'lps'),
	(354273, 102, '2015-01-15 00:53:51.000000', 'consum', 0.0213, 'lps'),
	(354274, 102, '2015-01-15 00:53:52.000000', 'consum', 0.0219, 'lps'),
	(354275, 102, '2015-01-15 00:53:53.000000', 'consum', 0.0215, 'lps'),
	(354276, 102, '2015-01-15 00:53:54.000000', 'consum', 0.0211, 'lps'),
	(354277, 102, '2015-01-15 00:53:55.000000', 'consum', 0.0218, 'lps'),
	(354278, 102, '2015-01-15 00:53:56.000000', 'consum', 0.0218, 'lps'),
	(354279, 102, '2015-01-15 00:53:57.000000', 'consum', 0.0218, 'lps'),
	(354280, 102, '2015-01-15 00:53:58.000000', 'consum', 0.0214, 'lps'),
	(354281, 102, '2015-01-15 00:53:59.000000', 'consum', 0.0219, 'lps'),
	(354282, 102, '2015-01-15 00:54:00.000000', 'consum', 0.0211, 'lps'),
	(354283, 102, '2015-01-15 00:54:01.000000', 'consum', 0.0218, 'lps'),
	(354284, 102, '2015-01-15 00:54:02.000000', 'consum', 0.0218, 'lps'),
	(354285, 102, '2015-01-15 00:54:03.000000', 'consum', 0.0215, 'lps'),
	(354286, 102, '2015-01-15 00:54:04.000000', 'consum', 0.0214, 'lps'),
	(354287, 102, '2015-01-15 00:54:05.000000', 'consum', 0.0213, 'lps'),
	(354288, 102, '2015-01-15 00:54:06.000000', 'consum', 0.0213, 'lps'),
	(354289, 102, '2015-01-15 00:54:07.000000', 'consum', 0.0218, 'lps'),
	(354290, 102, '2015-01-15 00:54:08.000000', 'consum', 0.0210, 'lps'),
	(354291, 102, '2015-01-15 00:54:09.000000', 'consum', 0.0219, 'lps'),
	(354292, 102, '2015-01-15 00:54:10.000000', 'consum', 0.0213, 'lps'),
	(354293, 102, '2015-01-15 00:54:11.000000', 'consum', 0.0211, 'lps'),
	(354294, 102, '2015-01-15 00:54:12.000000', 'consum', 0.0217, 'lps'),
	(354295, 102, '2015-01-15 00:54:13.000000', 'consum', 0.0211, 'lps'),
	(354296, 102, '2015-01-15 00:54:14.000000', 'consum', 0.0214, 'lps'),
	(354297, 102, '2015-01-15 00:54:15.000000', 'consum', 0.0219, 'lps'),
	(354298, 102, '2015-01-15 00:54:16.000000', 'consum', 0.0213, 'lps'),
	(354299, 102, '2015-01-15 00:54:17.000000', 'consum', 0.0217, 'lps'),
	(354300, 102, '2015-01-15 00:54:18.000000', 'consum', 0.0219, 'lps'),
	(354301, 102, '2015-01-15 00:54:19.000000', 'consum', 0.0212, 'lps'),
	(354302, 102, '2015-01-15 00:54:20.000000', 'consum', 0.0214, 'lps'),
	(354303, 102, '2015-01-15 00:54:21.000000', 'consum', 0.0214, 'lps'),
	(354304, 102, '2015-01-15 00:54:22.000000', 'consum', 0.0211, 'lps'),
	(354305, 102, '2015-01-15 00:54:23.000000', 'consum', 0.0212, 'lps'),
	(354306, 102, '2015-01-15 00:54:24.000000', 'consum', 0.0217, 'lps'),
	(354307, 102, '2015-01-15 00:54:25.000000', 'consum', 0.0219, 'lps'),
	(354308, 102, '2015-01-15 00:54:26.000000', 'consum', 0.0216, 'lps'),
	(354309, 102, '2015-01-15 00:54:27.000000', 'consum', 0.0214, 'lps'),
	(354310, 102, '2015-01-15 00:54:28.000000', 'consum', 0.0213, 'lps'),
	(354311, 102, '2015-01-15 00:54:29.000000', 'consum', 0.0214, 'lps'),
	(354312, 102, '2015-01-15 00:54:30.000000', 'consum', 0.0219, 'lps'),
	(354313, 102, '2015-01-15 00:54:31.000000', 'consum', 0.0217, 'lps'),
	(354314, 102, '2015-01-15 00:54:32.000000', 'consum', 0.0215, 'lps'),
	(354315, 102, '2015-01-15 00:54:33.000000', 'consum', 0.0215, 'lps'),
	(354316, 102, '2015-01-15 00:54:34.000000', 'consum', 0.0212, 'lps'),
	(354317, 102, '2015-01-15 00:54:35.000000', 'consum', 0.0217, 'lps'),
	(354318, 102, '2015-01-15 00:54:36.000000', 'consum', 0.0216, 'lps'),
	(354319, 102, '2015-01-15 00:54:37.000000', 'consum', 0.0212, 'lps'),
	(354320, 102, '2015-01-15 00:54:38.000000', 'consum', 0.0213, 'lps'),
	(354321, 102, '2015-01-15 00:54:39.000000', 'consum', 0.0217, 'lps'),
	(354322, 102, '2015-01-15 00:54:40.000000', 'consum', 0.0216, 'lps'),
	(354323, 102, '2015-01-15 00:54:41.000000', 'consum', 0.0212, 'lps'),
	(354324, 102, '2015-01-15 00:54:42.000000', 'consum', 0.0210, 'lps'),
	(354325, 102, '2015-01-15 00:54:43.000000', 'consum', 0.0215, 'lps'),
	(354326, 102, '2015-01-15 00:54:44.000000', 'consum', 0.0216, 'lps'),
	(354327, 102, '2015-01-15 00:54:45.000000', 'consum', 0.0216, 'lps'),
	(354328, 102, '2015-01-15 00:54:46.000000', 'consum', 0.0211, 'lps'),
	(354329, 102, '2015-01-15 00:54:47.000000', 'consum', 0.0219, 'lps'),
	(354330, 102, '2015-01-15 00:54:48.000000', 'consum', 0.0211, 'lps'),
	(354331, 102, '2015-01-15 00:54:49.000000', 'consum', 0.0217, 'lps'),
	(354332, 102, '2015-01-15 00:54:50.000000', 'consum', 0.0215, 'lps'),
	(354333, 102, '2015-01-15 00:54:51.000000', 'consum', 0.0212, 'lps'),
	(354334, 102, '2015-01-15 00:54:52.000000', 'consum', 0.0217, 'lps'),
	(354335, 102, '2015-01-15 00:54:53.000000', 'consum', 0.0218, 'lps'),
	(354336, 102, '2015-01-15 00:54:54.000000', 'consum', 0.0211, 'lps'),
	(354337, 102, '2015-01-15 00:54:55.000000', 'consum', 0.0212, 'lps'),
	(354338, 102, '2015-01-15 00:54:56.000000', 'consum', 0.0218, 'lps'),
	(354339, 102, '2015-01-15 00:54:57.000000', 'consum', 0.0212, 'lps'),
	(354340, 102, '2015-01-15 00:54:58.000000', 'consum', 0.0218, 'lps'),
	(354341, 102, '2015-01-15 00:54:59.000000', 'consum', 0.0214, 'lps'),
	(354342, 102, '2015-01-15 00:55:00.000000', 'consum', 0.0217, 'lps'),
	(354343, 102, '2015-01-15 00:55:01.000000', 'consum', 0.0215, 'lps'),
	(354344, 102, '2015-01-15 00:55:02.000000', 'consum', 0.0214, 'lps'),
	(354345, 102, '2015-01-15 00:55:03.000000', 'consum', 0.0217, 'lps'),
	(354346, 102, '2015-01-15 00:55:04.000000', 'consum', 0.0211, 'lps'),
	(354347, 102, '2015-01-15 00:55:05.000000', 'consum', 0.0213, 'lps'),
	(354348, 102, '2015-01-15 00:55:06.000000', 'consum', 0.0216, 'lps'),
	(354349, 102, '2015-01-15 00:55:07.000000', 'consum', 0.0210, 'lps'),
	(354350, 102, '2015-01-15 00:55:08.000000', 'consum', 0.0212, 'lps'),
	(354351, 102, '2015-01-15 00:55:09.000000', 'consum', 0.0210, 'lps'),
	(354352, 102, '2015-01-15 00:55:10.000000', 'consum', 0.0215, 'lps'),
	(354353, 102, '2015-01-15 00:55:11.000000', 'consum', 0.0214, 'lps'),
	(354354, 102, '2015-01-15 00:55:12.000000', 'consum', 0.0214, 'lps'),
	(354355, 102, '2015-01-15 00:55:13.000000', 'consum', 0.0212, 'lps'),
	(354356, 102, '2015-01-15 00:55:14.000000', 'consum', 0.0219, 'lps'),
	(354357, 102, '2015-01-15 00:55:15.000000', 'consum', 0.0218, 'lps'),
	(354358, 102, '2015-01-15 00:55:16.000000', 'consum', 0.0215, 'lps'),
	(354359, 102, '2015-01-15 00:55:17.000000', 'consum', 0.0212, 'lps'),
	(354360, 102, '2015-01-15 00:55:18.000000', 'consum', 0.0216, 'lps'),
	(354361, 102, '2015-01-15 00:55:19.000000', 'consum', 0.0214, 'lps'),
	(354362, 102, '2015-01-15 00:55:20.000000', 'consum', 0.0211, 'lps'),
	(354363, 102, '2015-01-15 00:55:21.000000', 'consum', 0.0215, 'lps'),
	(354364, 102, '2015-01-15 00:55:22.000000', 'consum', 0.0212, 'lps'),
	(354365, 102, '2015-01-15 00:55:23.000000', 'consum', 0.0215, 'lps'),
	(354366, 102, '2015-01-15 00:55:24.000000', 'consum', 0.0211, 'lps'),
	(354367, 102, '2015-01-15 00:55:25.000000', 'consum', 0.0218, 'lps'),
	(354368, 102, '2015-01-15 00:55:26.000000', 'consum', 0.0210, 'lps'),
	(354369, 102, '2015-01-15 00:55:27.000000', 'consum', 0.0218, 'lps'),
	(354370, 102, '2015-01-15 00:55:28.000000', 'consum', 0.0218, 'lps'),
	(354371, 102, '2015-01-15 00:55:29.000000', 'consum', 0.0215, 'lps'),
	(354372, 102, '2015-01-15 00:55:30.000000', 'consum', 0.0214, 'lps'),
	(354373, 102, '2015-01-15 00:55:31.000000', 'consum', 0.0214, 'lps'),
	(354374, 102, '2015-01-15 00:55:32.000000', 'consum', 0.0210, 'lps'),
	(354375, 102, '2015-01-15 00:55:33.000000', 'consum', 0.0217, 'lps'),
	(354376, 102, '2015-01-15 00:55:34.000000', 'consum', 0.0216, 'lps'),
	(354377, 102, '2015-01-15 00:55:35.000000', 'consum', 0.0218, 'lps'),
	(354378, 102, '2015-01-15 00:55:36.000000', 'consum', 0.0215, 'lps'),
	(354379, 102, '2015-01-15 00:55:37.000000', 'consum', 0.0219, 'lps'),
	(354380, 102, '2015-01-15 00:55:38.000000', 'consum', 0.0213, 'lps'),
	(354381, 102, '2015-01-15 00:55:39.000000', 'consum', 0.0216, 'lps'),
	(354382, 102, '2015-01-15 00:55:40.000000', 'consum', 0.0211, 'lps'),
	(354383, 102, '2015-01-15 00:55:41.000000', 'consum', 0.0219, 'lps'),
	(354384, 102, '2015-01-15 00:55:42.000000', 'consum', 0.0210, 'lps'),
	(354385, 102, '2015-01-15 00:55:43.000000', 'consum', 0.0216, 'lps'),
	(354386, 102, '2015-01-15 00:55:44.000000', 'consum', 0.0211, 'lps'),
	(354387, 102, '2015-01-15 00:55:45.000000', 'consum', 0.0215, 'lps'),
	(354388, 102, '2015-01-15 00:55:46.000000', 'consum', 0.0214, 'lps'),
	(354389, 102, '2015-01-15 00:55:47.000000', 'consum', 0.0215, 'lps'),
	(354390, 102, '2015-01-15 00:55:48.000000', 'consum', 0.0212, 'lps'),
	(354391, 102, '2015-01-15 00:55:49.000000', 'consum', 0.0216, 'lps'),
	(354392, 102, '2015-01-15 00:55:50.000000', 'consum', 0.0215, 'lps'),
	(354393, 102, '2015-01-15 00:55:51.000000', 'consum', 0.0218, 'lps'),
	(354394, 102, '2015-01-15 00:55:52.000000', 'consum', 0.0215, 'lps'),
	(354395, 102, '2015-01-15 00:55:53.000000', 'consum', 0.0213, 'lps'),
	(354396, 102, '2015-01-15 00:55:54.000000', 'consum', 0.0218, 'lps'),
	(354397, 102, '2015-01-15 00:55:55.000000', 'consum', 0.0211, 'lps'),
	(354398, 102, '2015-01-15 00:55:56.000000', 'consum', 0.0212, 'lps'),
	(354399, 102, '2015-01-15 00:55:57.000000', 'consum', 0.0216, 'lps'),
	(354400, 102, '2015-01-15 00:55:58.000000', 'consum', 0.0217, 'lps'),
	(354401, 102, '2015-01-15 00:55:59.000000', 'consum', 0.0218, 'lps'),
	(354402, 102, '2015-01-15 00:56:00.000000', 'consum', 0.0219, 'lps'),
	(354403, 102, '2015-01-15 00:56:01.000000', 'consum', 0.0211, 'lps'),
	(354404, 102, '2015-01-15 00:56:02.000000', 'consum', 0.0219, 'lps'),
	(354405, 102, '2015-01-15 00:56:03.000000', 'consum', 0.0213, 'lps'),
	(354406, 102, '2015-01-15 00:56:04.000000', 'consum', 0.0216, 'lps'),
	(354407, 102, '2015-01-15 00:56:05.000000', 'consum', 0.0213, 'lps'),
	(354408, 102, '2015-01-15 00:56:06.000000', 'consum', 0.0216, 'lps'),
	(354409, 102, '2015-01-15 00:56:07.000000', 'consum', 0.0214, 'lps'),
	(354410, 102, '2015-01-15 00:56:08.000000', 'consum', 0.0212, 'lps'),
	(354411, 102, '2015-01-15 00:56:09.000000', 'consum', 0.0217, 'lps'),
	(354412, 102, '2015-01-15 00:56:10.000000', 'consum', 0.0210, 'lps'),
	(354413, 102, '2015-01-15 00:56:11.000000', 'consum', 0.0211, 'lps'),
	(354414, 102, '2015-01-15 00:56:12.000000', 'consum', 0.0216, 'lps'),
	(354415, 102, '2015-01-15 00:56:13.000000', 'consum', 0.0219, 'lps'),
	(354416, 102, '2015-01-15 00:56:14.000000', 'consum', 0.0214, 'lps'),
	(354417, 102, '2015-01-15 00:56:15.000000', 'consum', 0.0214, 'lps'),
	(354418, 102, '2015-01-15 00:56:16.000000', 'consum', 0.0218, 'lps'),
	(354419, 102, '2015-01-15 00:56:17.000000', 'consum', 0.0211, 'lps'),
	(354420, 102, '2015-01-15 00:56:18.000000', 'consum', 0.0211, 'lps'),
	(354421, 102, '2015-01-15 00:56:19.000000', 'consum', 0.0213, 'lps'),
	(354422, 102, '2015-01-15 00:56:20.000000', 'consum', 0.0211, 'lps'),
	(354423, 102, '2015-01-15 00:56:21.000000', 'consum', 0.0218, 'lps'),
	(354424, 102, '2015-01-15 00:56:22.000000', 'consum', 0.0216, 'lps'),
	(354425, 102, '2015-01-15 00:56:23.000000', 'consum', 0.0218, 'lps'),
	(354426, 102, '2015-01-15 00:56:24.000000', 'consum', 0.0213, 'lps'),
	(354427, 102, '2015-01-15 00:56:25.000000', 'consum', 0.0210, 'lps'),
	(354428, 102, '2015-01-15 00:56:26.000000', 'consum', 0.0214, 'lps'),
	(354429, 102, '2015-01-15 00:56:27.000000', 'consum', 0.0218, 'lps'),
	(354430, 102, '2015-01-15 00:56:28.000000', 'consum', 0.0211, 'lps'),
	(354431, 102, '2015-01-15 00:56:29.000000', 'consum', 0.0219, 'lps'),
	(354432, 102, '2015-01-15 00:56:30.000000', 'consum', 0.0215, 'lps'),
	(354433, 102, '2015-01-15 00:56:31.000000', 'consum', 0.0217, 'lps'),
	(354434, 102, '2015-01-15 00:56:32.000000', 'consum', 0.0219, 'lps'),
	(354435, 102, '2015-01-15 00:56:33.000000', 'consum', 0.0214, 'lps'),
	(354436, 102, '2015-01-15 00:56:34.000000', 'consum', 0.0216, 'lps'),
	(354437, 102, '2015-01-15 00:56:35.000000', 'consum', 0.0216, 'lps'),
	(354438, 102, '2015-01-15 00:56:36.000000', 'consum', 0.0215, 'lps'),
	(354439, 102, '2015-01-15 00:56:37.000000', 'consum', 0.0218, 'lps'),
	(354440, 102, '2015-01-15 00:56:38.000000', 'consum', 0.0215, 'lps'),
	(354441, 102, '2015-01-15 00:56:39.000000', 'consum', 0.0210, 'lps'),
	(354442, 102, '2015-01-15 00:56:40.000000', 'consum', 0.0216, 'lps'),
	(354443, 102, '2015-01-15 00:56:41.000000', 'consum', 0.0213, 'lps'),
	(354444, 102, '2015-01-15 00:56:42.000000', 'consum', 0.0214, 'lps'),
	(354445, 102, '2015-01-15 00:56:43.000000', 'consum', 0.0213, 'lps'),
	(354446, 102, '2015-01-15 00:56:44.000000', 'consum', 0.0212, 'lps'),
	(354447, 102, '2015-01-15 00:56:45.000000', 'consum', 0.0214, 'lps'),
	(354448, 102, '2015-01-15 00:56:46.000000', 'consum', 0.0213, 'lps'),
	(354449, 102, '2015-01-15 00:56:47.000000', 'consum', 0.0215, 'lps'),
	(354450, 102, '2015-01-15 00:56:48.000000', 'consum', 0.0217, 'lps'),
	(354451, 102, '2015-01-15 00:56:49.000000', 'consum', 0.0210, 'lps'),
	(354452, 102, '2015-01-15 00:56:50.000000', 'consum', 0.0218, 'lps'),
	(354453, 102, '2015-01-15 00:56:51.000000', 'consum', 0.0210, 'lps'),
	(354454, 102, '2015-01-15 00:56:52.000000', 'consum', 0.0218, 'lps'),
	(354455, 102, '2015-01-15 00:56:53.000000', 'consum', 0.0212, 'lps'),
	(354456, 102, '2015-01-15 00:56:54.000000', 'consum', 0.0213, 'lps'),
	(354457, 102, '2015-01-15 00:56:55.000000', 'consum', 0.0213, 'lps'),
	(354458, 102, '2015-01-15 00:56:56.000000', 'consum', 0.0214, 'lps'),
	(354459, 102, '2015-01-15 00:56:57.000000', 'consum', 0.0214, 'lps'),
	(354460, 102, '2015-01-15 00:56:58.000000', 'consum', 0.0217, 'lps'),
	(354461, 102, '2015-01-15 00:56:59.000000', 'consum', 0.0212, 'lps'),
	(354462, 102, '2015-01-15 00:57:00.000000', 'consum', 0.0212, 'lps'),
	(354463, 102, '2015-01-15 00:57:01.000000', 'consum', 0.0215, 'lps'),
	(354464, 102, '2015-01-15 00:57:02.000000', 'consum', 0.0216, 'lps'),
	(354465, 102, '2015-01-15 00:57:03.000000', 'consum', 0.0219, 'lps'),
	(354466, 102, '2015-01-15 00:57:04.000000', 'consum', 0.0216, 'lps'),
	(354467, 102, '2015-01-15 00:57:05.000000', 'consum', 0.0215, 'lps'),
	(354468, 102, '2015-01-15 00:57:06.000000', 'consum', 0.0218, 'lps'),
	(354469, 102, '2015-01-15 00:57:07.000000', 'consum', 0.0215, 'lps'),
	(354470, 102, '2015-01-15 00:57:08.000000', 'consum', 0.0211, 'lps'),
	(354471, 102, '2015-01-15 00:57:09.000000', 'consum', 0.0219, 'lps'),
	(354472, 102, '2015-01-15 00:57:10.000000', 'consum', 0.0213, 'lps'),
	(354473, 102, '2015-01-15 00:57:11.000000', 'consum', 0.0219, 'lps'),
	(354474, 102, '2015-01-15 00:57:12.000000', 'consum', 0.0215, 'lps'),
	(354475, 102, '2015-01-15 00:57:13.000000', 'consum', 0.0219, 'lps'),
	(354476, 102, '2015-01-15 00:57:14.000000', 'consum', 0.0210, 'lps'),
	(354477, 102, '2015-01-15 00:57:15.000000', 'consum', 0.0215, 'lps'),
	(354478, 102, '2015-01-15 00:57:16.000000', 'consum', 0.0214, 'lps'),
	(354479, 102, '2015-01-15 00:57:17.000000', 'consum', 0.0215, 'lps'),
	(354480, 102, '2015-01-15 00:57:18.000000', 'consum', 0.0213, 'lps'),
	(354481, 102, '2015-01-15 00:57:19.000000', 'consum', 0.0211, 'lps'),
	(354482, 102, '2015-01-15 00:57:20.000000', 'consum', 0.0217, 'lps'),
	(354483, 102, '2015-01-15 00:57:21.000000', 'consum', 0.0212, 'lps'),
	(354484, 102, '2015-01-15 00:57:22.000000', 'consum', 0.0210, 'lps'),
	(354485, 102, '2015-01-15 00:57:23.000000', 'consum', 0.0213, 'lps'),
	(354486, 102, '2015-01-15 00:57:24.000000', 'consum', 0.0214, 'lps'),
	(354487, 102, '2015-01-15 00:57:25.000000', 'consum', 0.0214, 'lps'),
	(354488, 102, '2015-01-15 00:57:26.000000', 'consum', 0.0210, 'lps'),
	(354489, 102, '2015-01-15 00:57:27.000000', 'consum', 0.0216, 'lps'),
	(354490, 102, '2015-01-15 00:57:28.000000', 'consum', 0.0219, 'lps'),
	(354491, 102, '2015-01-15 00:57:29.000000', 'consum', 0.0210, 'lps'),
	(354492, 102, '2015-01-15 00:57:30.000000', 'consum', 0.0211, 'lps'),
	(354493, 102, '2015-01-15 00:57:31.000000', 'consum', 0.0216, 'lps'),
	(354494, 102, '2015-01-15 00:57:32.000000', 'consum', 0.0210, 'lps'),
	(354495, 102, '2015-01-15 00:57:33.000000', 'consum', 0.0219, 'lps'),
	(354496, 102, '2015-01-15 00:57:34.000000', 'consum', 0.0218, 'lps'),
	(354497, 102, '2015-01-15 00:57:35.000000', 'consum', 0.0211, 'lps'),
	(354498, 102, '2015-01-15 00:57:36.000000', 'consum', 0.0214, 'lps'),
	(354499, 102, '2015-01-15 00:57:37.000000', 'consum', 0.0216, 'lps'),
	(354500, 102, '2015-01-15 00:57:38.000000', 'consum', 0.0211, 'lps'),
	(354501, 102, '2015-01-15 00:57:39.000000', 'consum', 0.0214, 'lps'),
	(354502, 102, '2015-01-15 00:57:40.000000', 'consum', 0.0210, 'lps'),
	(354503, 102, '2015-01-15 00:57:41.000000', 'consum', 0.0218, 'lps'),
	(354504, 102, '2015-01-15 00:57:42.000000', 'consum', 0.0210, 'lps'),
	(354505, 102, '2015-01-15 00:57:43.000000', 'consum', 0.0216, 'lps'),
	(354506, 102, '2015-01-15 00:57:44.000000', 'consum', 0.0211, 'lps'),
	(354507, 102, '2015-01-15 00:57:45.000000', 'consum', 0.0216, 'lps'),
	(354508, 102, '2015-01-15 00:57:46.000000', 'consum', 0.0210, 'lps'),
	(354509, 102, '2015-01-15 00:57:47.000000', 'consum', 0.0210, 'lps'),
	(354510, 102, '2015-01-15 00:57:48.000000', 'consum', 0.0212, 'lps'),
	(354511, 102, '2015-01-15 00:57:49.000000', 'consum', 0.0219, 'lps'),
	(354512, 102, '2015-01-15 00:57:50.000000', 'consum', 0.0212, 'lps'),
	(354513, 102, '2015-01-15 00:57:51.000000', 'consum', 0.0213, 'lps'),
	(354514, 102, '2015-01-15 00:57:52.000000', 'consum', 0.0217, 'lps'),
	(354515, 102, '2015-01-15 00:57:53.000000', 'consum', 0.0219, 'lps'),
	(354516, 102, '2015-01-15 00:57:54.000000', 'consum', 0.0213, 'lps'),
	(354517, 102, '2015-01-15 00:57:55.000000', 'consum', 0.0218, 'lps'),
	(354518, 102, '2015-01-15 00:57:56.000000', 'consum', 0.0214, 'lps'),
	(354519, 102, '2015-01-15 00:57:57.000000', 'consum', 0.0216, 'lps'),
	(354520, 102, '2015-01-15 00:57:58.000000', 'consum', 0.0216, 'lps'),
	(354521, 102, '2015-01-15 00:57:59.000000', 'consum', 0.0214, 'lps'),
	(354522, 102, '2015-01-15 00:58:00.000000', 'consum', 0.0213, 'lps'),
	(354523, 102, '2015-01-15 00:58:01.000000', 'consum', 0.0212, 'lps'),
	(354524, 102, '2015-01-15 00:58:02.000000', 'consum', 0.0214, 'lps'),
	(354525, 102, '2015-01-15 00:58:03.000000', 'consum', 0.0215, 'lps'),
	(354526, 102, '2015-01-15 00:58:04.000000', 'consum', 0.0210, 'lps'),
	(354527, 102, '2015-01-15 00:58:05.000000', 'consum', 0.0218, 'lps'),
	(354528, 102, '2015-01-15 00:58:06.000000', 'consum', 0.0211, 'lps'),
	(354529, 102, '2015-01-15 00:58:07.000000', 'consum', 0.0213, 'lps'),
	(354530, 102, '2015-01-15 00:58:08.000000', 'consum', 0.0219, 'lps'),
	(354531, 102, '2015-01-15 00:58:09.000000', 'consum', 0.0219, 'lps'),
	(354532, 102, '2015-01-15 00:58:10.000000', 'consum', 0.0218, 'lps'),
	(354533, 102, '2015-01-15 00:58:11.000000', 'consum', 0.0212, 'lps'),
	(354534, 102, '2015-01-15 00:58:12.000000', 'consum', 0.0219, 'lps'),
	(354535, 102, '2015-01-15 00:58:13.000000', 'consum', 0.0216, 'lps'),
	(354536, 102, '2015-01-15 00:58:14.000000', 'consum', 0.0216, 'lps'),
	(354537, 102, '2015-01-15 00:58:15.000000', 'consum', 0.0213, 'lps'),
	(354538, 102, '2015-01-15 00:58:16.000000', 'consum', 0.0215, 'lps'),
	(354539, 102, '2015-01-15 00:58:17.000000', 'consum', 0.0218, 'lps'),
	(354540, 102, '2015-01-15 00:58:18.000000', 'consum', 0.0217, 'lps'),
	(354541, 102, '2015-01-15 00:58:19.000000', 'consum', 0.0211, 'lps'),
	(354542, 102, '2015-01-15 00:58:20.000000', 'consum', 0.0214, 'lps'),
	(354543, 102, '2015-01-15 00:58:21.000000', 'consum', 0.0216, 'lps'),
	(354544, 102, '2015-01-15 00:58:22.000000', 'consum', 0.0219, 'lps'),
	(354545, 102, '2015-01-15 00:58:23.000000', 'consum', 0.0219, 'lps'),
	(354546, 102, '2015-01-15 00:58:24.000000', 'consum', 0.0218, 'lps'),
	(354547, 102, '2015-01-15 00:58:25.000000', 'consum', 0.0214, 'lps'),
	(354548, 102, '2015-01-15 00:58:26.000000', 'consum', 0.0217, 'lps'),
	(354549, 102, '2015-01-15 00:58:27.000000', 'consum', 0.0213, 'lps'),
	(354550, 102, '2015-01-15 00:58:28.000000', 'consum', 0.0216, 'lps'),
	(354551, 102, '2015-01-15 00:58:29.000000', 'consum', 0.0211, 'lps'),
	(354552, 102, '2015-01-15 00:58:30.000000', 'consum', 0.0219, 'lps'),
	(354553, 102, '2015-01-15 00:58:31.000000', 'consum', 0.0211, 'lps'),
	(354554, 102, '2015-01-15 00:58:32.000000', 'consum', 0.0210, 'lps'),
	(354555, 102, '2015-01-15 00:58:33.000000', 'consum', 0.0218, 'lps'),
	(354556, 102, '2015-01-15 00:58:34.000000', 'consum', 0.0210, 'lps'),
	(354557, 102, '2015-01-15 00:58:35.000000', 'consum', 0.0216, 'lps'),
	(354558, 102, '2015-01-15 00:58:36.000000', 'consum', 0.0211, 'lps'),
	(354559, 102, '2015-01-15 00:58:37.000000', 'consum', 0.0219, 'lps'),
	(354560, 102, '2015-01-15 00:58:38.000000', 'consum', 0.0210, 'lps'),
	(354561, 102, '2015-01-15 00:58:39.000000', 'consum', 0.0216, 'lps'),
	(354562, 102, '2015-01-15 00:58:40.000000', 'consum', 0.0210, 'lps'),
	(354563, 102, '2015-01-15 00:58:41.000000', 'consum', 0.0214, 'lps'),
	(354564, 102, '2015-01-15 00:58:42.000000', 'consum', 0.0210, 'lps'),
	(354565, 102, '2015-01-15 00:58:43.000000', 'consum', 0.0218, 'lps'),
	(354566, 102, '2015-01-15 00:58:44.000000', 'consum', 0.0211, 'lps'),
	(354567, 102, '2015-01-15 00:58:45.000000', 'consum', 0.0211, 'lps'),
	(354568, 102, '2015-01-15 00:58:46.000000', 'consum', 0.0211, 'lps'),
	(354569, 102, '2015-01-15 00:58:47.000000', 'consum', 0.0214, 'lps'),
	(354570, 102, '2015-01-15 00:58:48.000000', 'consum', 0.0218, 'lps'),
	(354571, 102, '2015-01-15 00:58:49.000000', 'consum', 0.0219, 'lps'),
	(354572, 102, '2015-01-15 00:58:50.000000', 'consum', 0.0211, 'lps'),
	(354573, 102, '2015-01-15 00:58:51.000000', 'consum', 0.0217, 'lps'),
	(354574, 102, '2015-01-15 00:58:52.000000', 'consum', 0.0212, 'lps'),
	(354575, 102, '2015-01-15 00:58:53.000000', 'consum', 0.0210, 'lps'),
	(354576, 102, '2015-01-15 00:58:54.000000', 'consum', 0.0214, 'lps'),
	(354577, 102, '2015-01-15 00:58:55.000000', 'consum', 0.0213, 'lps'),
	(354578, 102, '2015-01-15 00:58:56.000000', 'consum', 0.0211, 'lps'),
	(354579, 102, '2015-01-15 00:58:57.000000', 'consum', 0.0219, 'lps'),
	(354580, 102, '2015-01-15 00:58:58.000000', 'consum', 0.0213, 'lps'),
	(354581, 102, '2015-01-15 00:58:59.000000', 'consum', 0.0217, 'lps'),
	(354582, 102, '2015-01-15 00:59:00.000000', 'consum', 0.0215, 'lps'),
	(354583, 102, '2015-01-15 00:59:01.000000', 'consum', 0.0215, 'lps'),
	(354584, 102, '2015-01-15 00:59:02.000000', 'consum', 0.0211, 'lps'),
	(354585, 102, '2015-01-15 00:59:03.000000', 'consum', 0.0219, 'lps'),
	(354586, 102, '2015-01-15 00:59:04.000000', 'consum', 0.0213, 'lps'),
	(354587, 102, '2015-01-15 00:59:05.000000', 'consum', 0.0217, 'lps'),
	(354588, 102, '2015-01-15 00:59:06.000000', 'consum', 0.0210, 'lps'),
	(354589, 102, '2015-01-15 00:59:07.000000', 'consum', 0.0216, 'lps'),
	(354590, 102, '2015-01-15 00:59:08.000000', 'consum', 0.0213, 'lps'),
	(354591, 102, '2015-01-15 00:59:09.000000', 'consum', 0.0218, 'lps'),
	(354592, 102, '2015-01-15 00:59:10.000000', 'consum', 0.0219, 'lps'),
	(354593, 102, '2015-01-15 00:59:11.000000', 'consum', 0.0212, 'lps'),
	(354594, 102, '2015-01-15 00:59:12.000000', 'consum', 0.0213, 'lps'),
	(354595, 102, '2015-01-15 00:59:13.000000', 'consum', 0.0211, 'lps'),
	(354596, 102, '2015-01-15 00:59:14.000000', 'consum', 0.0214, 'lps'),
	(354597, 102, '2015-01-15 00:59:15.000000', 'consum', 0.0219, 'lps'),
	(354598, 102, '2015-01-15 00:59:16.000000', 'consum', 0.0212, 'lps'),
	(354599, 102, '2015-01-15 00:59:17.000000', 'consum', 0.0216, 'lps'),
	(354600, 102, '2015-01-15 00:59:18.000000', 'consum', 0.0213, 'lps'),
	(354601, 102, '2015-01-15 00:59:19.000000', 'consum', 0.0219, 'lps'),
	(354602, 102, '2015-01-15 00:59:20.000000', 'consum', 0.0217, 'lps'),
	(354603, 102, '2015-01-15 00:59:21.000000', 'consum', 0.0219, 'lps'),
	(354604, 102, '2015-01-15 00:59:22.000000', 'consum', 0.0213, 'lps'),
	(354605, 102, '2015-01-15 00:59:23.000000', 'consum', 0.0211, 'lps'),
	(354606, 102, '2015-01-15 00:59:24.000000', 'consum', 0.0213, 'lps'),
	(354607, 102, '2015-01-15 00:59:25.000000', 'consum', 0.0216, 'lps'),
	(354608, 102, '2015-01-15 00:59:26.000000', 'consum', 0.0219, 'lps'),
	(354609, 102, '2015-01-15 00:59:27.000000', 'consum', 0.0218, 'lps'),
	(354610, 102, '2015-01-15 00:59:28.000000', 'consum', 0.0214, 'lps'),
	(354611, 102, '2015-01-15 00:59:29.000000', 'consum', 0.0215, 'lps'),
	(354612, 102, '2015-01-15 00:59:30.000000', 'consum', 0.0215, 'lps'),
	(354613, 102, '2015-01-15 00:59:31.000000', 'consum', 0.0219, 'lps'),
	(354614, 102, '2015-01-15 00:59:32.000000', 'consum', 0.0219, 'lps'),
	(354615, 102, '2015-01-15 00:59:33.000000', 'consum', 0.0211, 'lps'),
	(354616, 102, '2015-01-15 00:59:34.000000', 'consum', 0.0219, 'lps'),
	(354617, 102, '2015-01-15 00:59:35.000000', 'consum', 0.0213, 'lps'),
	(354618, 102, '2015-01-15 00:59:36.000000', 'consum', 0.0216, 'lps'),
	(354619, 102, '2015-01-15 00:59:37.000000', 'consum', 0.0213, 'lps'),
	(354620, 102, '2015-01-15 00:59:38.000000', 'consum', 0.0217, 'lps'),
	(354621, 102, '2015-01-15 00:59:39.000000', 'consum', 0.0216, 'lps'),
	(354622, 102, '2015-01-15 00:59:40.000000', 'consum', 0.0210, 'lps'),
	(354623, 102, '2015-01-15 00:59:41.000000', 'consum', 0.0214, 'lps'),
	(354624, 102, '2015-01-15 00:59:42.000000', 'consum', 0.0219, 'lps'),
	(354625, 102, '2015-01-15 00:59:43.000000', 'consum', 0.0214, 'lps'),
	(354626, 102, '2015-01-15 00:59:44.000000', 'consum', 0.0213, 'lps'),
	(354627, 102, '2015-01-15 00:59:45.000000', 'consum', 0.0213, 'lps'),
	(354628, 102, '2015-01-15 00:59:46.000000', 'consum', 0.0219, 'lps'),
	(354629, 102, '2015-01-15 00:59:47.000000', 'consum', 0.0214, 'lps'),
	(354630, 102, '2015-01-15 00:59:48.000000', 'consum', 0.0215, 'lps'),
	(354631, 102, '2015-01-15 00:59:49.000000', 'consum', 0.0212, 'lps'),
	(354632, 102, '2015-01-15 00:59:50.000000', 'consum', 0.0218, 'lps'),
	(354633, 102, '2015-01-15 00:59:51.000000', 'consum', 0.0215, 'lps'),
	(354634, 102, '2015-01-15 00:59:52.000000', 'consum', 0.0218, 'lps'),
	(354635, 102, '2015-01-15 00:59:53.000000', 'consum', 0.0219, 'lps'),
	(354636, 102, '2015-01-15 00:59:54.000000', 'consum', 0.0210, 'lps'),
	(354637, 102, '2015-01-15 00:59:55.000000', 'consum', 0.0213, 'lps'),
	(354638, 102, '2015-01-15 00:59:56.000000', 'consum', 0.0218, 'lps'),
	(354639, 102, '2015-01-15 00:59:57.000000', 'consum', 0.0219, 'lps'),
	(354640, 102, '2015-01-15 00:59:58.000000', 'consum', 0.0214, 'lps'),
	(354641, 102, '2015-01-15 00:59:59.000000', 'consum', 0.0210, 'lps'),
	(354642, 102, '2015-01-15 01:00:00.000000', 'consum', 0.0211, 'lps'),
	(354643, 102, '2015-01-15 01:00:01.000000', 'consum', 0.0216, 'lps'),
	(354644, 102, '2015-01-15 01:00:02.000000', 'consum', 0.0218, 'lps'),
	(354645, 102, '2015-01-15 01:00:03.000000', 'consum', 0.0210, 'lps'),
	(354646, 102, '2015-01-15 01:00:04.000000', 'consum', 0.0218, 'lps'),
	(354647, 102, '2015-01-15 01:00:05.000000', 'consum', 0.0219, 'lps'),
	(354648, 102, '2015-01-15 01:00:06.000000', 'consum', 0.0212, 'lps'),
	(354649, 102, '2015-01-15 01:00:07.000000', 'consum', 0.0213, 'lps'),
	(354650, 102, '2015-01-15 01:00:08.000000', 'consum', 0.0211, 'lps'),
	(354651, 102, '2015-01-15 01:00:09.000000', 'consum', 0.0214, 'lps'),
	(354652, 102, '2015-01-15 01:00:10.000000', 'consum', 0.0218, 'lps'),
	(354653, 102, '2015-01-15 01:00:11.000000', 'consum', 0.0219, 'lps'),
	(354654, 102, '2015-01-15 01:00:12.000000', 'consum', 0.0211, 'lps'),
	(354655, 102, '2015-01-15 01:00:13.000000', 'consum', 0.0210, 'lps'),
	(354656, 102, '2015-01-15 01:00:14.000000', 'consum', 0.0218, 'lps'),
	(354657, 102, '2015-01-15 01:00:15.000000', 'consum', 0.0219, 'lps'),
	(354658, 102, '2015-01-15 01:00:16.000000', 'consum', 0.0213, 'lps'),
	(354659, 102, '2015-01-15 01:00:17.000000', 'consum', 0.0216, 'lps'),
	(354660, 102, '2015-01-15 01:00:18.000000', 'consum', 0.0213, 'lps'),
	(354661, 102, '2015-01-15 01:00:19.000000', 'consum', 0.0218, 'lps'),
	(354662, 102, '2015-01-15 01:00:20.000000', 'consum', 0.0212, 'lps'),
	(354663, 102, '2015-01-15 01:00:21.000000', 'consum', 0.0214, 'lps'),
	(354664, 102, '2015-01-15 01:00:22.000000', 'consum', 0.0217, 'lps'),
	(354665, 102, '2015-01-15 01:00:23.000000', 'consum', 0.0211, 'lps'),
	(354666, 102, '2015-01-15 01:00:24.000000', 'consum', 0.0217, 'lps'),
	(354667, 102, '2015-01-15 01:00:25.000000', 'consum', 0.0213, 'lps'),
	(354668, 102, '2015-01-15 01:00:26.000000', 'consum', 0.0212, 'lps'),
	(354669, 102, '2015-01-15 01:00:27.000000', 'consum', 0.0213, 'lps'),
	(354670, 102, '2015-01-15 01:00:28.000000', 'consum', 0.0210, 'lps'),
	(354671, 102, '2015-01-15 01:00:29.000000', 'consum', 0.0211, 'lps'),
	(354672, 102, '2015-01-15 01:00:30.000000', 'consum', 0.0215, 'lps'),
	(354673, 102, '2015-01-15 01:00:31.000000', 'consum', 0.0215, 'lps'),
	(354674, 102, '2015-01-15 01:00:32.000000', 'consum', 0.0217, 'lps'),
	(354675, 102, '2015-01-15 01:00:33.000000', 'consum', 0.0211, 'lps'),
	(354676, 102, '2015-01-15 01:00:34.000000', 'consum', 0.0217, 'lps'),
	(354677, 102, '2015-01-15 01:00:35.000000', 'consum', 0.0210, 'lps'),
	(354678, 102, '2015-01-15 01:00:36.000000', 'consum', 0.0210, 'lps'),
	(354679, 102, '2015-01-15 01:00:37.000000', 'consum', 0.0210, 'lps'),
	(354680, 102, '2015-01-15 01:00:38.000000', 'consum', 0.0211, 'lps'),
	(354681, 102, '2015-01-15 01:00:39.000000', 'consum', 0.0215, 'lps'),
	(354682, 102, '2015-01-15 01:00:40.000000', 'consum', 0.0212, 'lps'),
	(354683, 102, '2015-01-15 01:00:41.000000', 'consum', 0.0217, 'lps'),
	(354684, 102, '2015-01-15 01:00:42.000000', 'consum', 0.0211, 'lps'),
	(354685, 102, '2015-01-15 01:00:43.000000', 'consum', 0.0213, 'lps'),
	(354686, 102, '2015-01-15 01:00:44.000000', 'consum', 0.0212, 'lps'),
	(354687, 102, '2015-01-15 01:00:45.000000', 'consum', 0.0211, 'lps'),
	(354688, 102, '2015-01-15 01:00:46.000000', 'consum', 0.0211, 'lps'),
	(354689, 102, '2015-01-15 01:00:47.000000', 'consum', 0.0211, 'lps'),
	(354690, 102, '2015-01-15 01:00:48.000000', 'consum', 0.0215, 'lps'),
	(354691, 102, '2015-01-15 01:00:49.000000', 'consum', 0.0219, 'lps'),
	(354692, 102, '2015-01-15 01:00:50.000000', 'consum', 0.0212, 'lps'),
	(354693, 102, '2015-01-15 01:00:51.000000', 'consum', 0.0215, 'lps'),
	(354694, 102, '2015-01-15 01:00:52.000000', 'consum', 0.0218, 'lps'),
	(354695, 102, '2015-01-15 01:00:53.000000', 'consum', 0.0215, 'lps'),
	(354696, 102, '2015-01-15 01:00:54.000000', 'consum', 0.0210, 'lps'),
	(354697, 102, '2015-01-15 01:00:55.000000', 'consum', 0.0218, 'lps'),
	(354698, 102, '2015-01-15 01:00:56.000000', 'consum', 0.0211, 'lps'),
	(354699, 102, '2015-01-15 01:00:57.000000', 'consum', 0.0210, 'lps'),
	(354700, 102, '2015-01-15 01:00:58.000000', 'consum', 0.0218, 'lps'),
	(354701, 102, '2015-01-15 01:00:59.000000', 'consum', 0.0212, 'lps'),
	(354702, 102, '2015-01-15 01:01:00.000000', 'consum', 0.0217, 'lps'),
	(354703, 102, '2015-01-15 01:01:01.000000', 'consum', 0.0217, 'lps'),
	(354704, 102, '2015-01-15 01:01:02.000000', 'consum', 0.0216, 'lps'),
	(354705, 102, '2015-01-15 01:01:03.000000', 'consum', 0.0210, 'lps'),
	(354706, 102, '2015-01-15 01:01:04.000000', 'consum', 0.0210, 'lps'),
	(354707, 102, '2015-01-15 01:01:05.000000', 'consum', 0.0213, 'lps'),
	(354708, 102, '2015-01-15 01:01:06.000000', 'consum', 0.0214, 'lps'),
	(354709, 102, '2015-01-15 01:01:07.000000', 'consum', 0.0212, 'lps'),
	(354710, 102, '2015-01-15 01:01:08.000000', 'consum', 0.0210, 'lps'),
	(354711, 102, '2015-01-15 01:01:09.000000', 'consum', 0.0212, 'lps'),
	(354712, 102, '2015-01-15 01:01:10.000000', 'consum', 0.0213, 'lps'),
	(354713, 102, '2015-01-15 01:01:11.000000', 'consum', 0.0218, 'lps'),
	(354714, 102, '2015-01-15 01:01:12.000000', 'consum', 0.0214, 'lps'),
	(354715, 102, '2015-01-15 01:01:13.000000', 'consum', 0.0213, 'lps'),
	(354716, 102, '2015-01-15 01:01:14.000000', 'consum', 0.0214, 'lps'),
	(354717, 102, '2015-01-15 01:01:15.000000', 'consum', 0.0213, 'lps'),
	(354718, 102, '2015-01-15 01:01:16.000000', 'consum', 0.0214, 'lps'),
	(354719, 102, '2015-01-15 01:01:17.000000', 'consum', 0.0212, 'lps'),
	(354720, 102, '2015-01-15 01:01:18.000000', 'consum', 0.0219, 'lps'),
	(354721, 102, '2015-01-15 01:01:19.000000', 'consum', 0.0210, 'lps'),
	(354722, 102, '2015-01-15 01:01:20.000000', 'consum', 0.0212, 'lps'),
	(354723, 102, '2015-01-15 01:01:21.000000', 'consum', 0.0213, 'lps'),
	(354724, 102, '2015-01-15 01:01:22.000000', 'consum', 0.0218, 'lps'),
	(354725, 102, '2015-01-15 01:01:23.000000', 'consum', 0.0210, 'lps'),
	(354726, 102, '2015-01-15 01:01:24.000000', 'consum', 0.0216, 'lps'),
	(354727, 102, '2015-01-15 01:01:25.000000', 'consum', 0.0211, 'lps'),
	(354728, 102, '2015-01-15 01:01:26.000000', 'consum', 0.0217, 'lps'),
	(354729, 102, '2015-01-15 01:01:27.000000', 'consum', 0.0212, 'lps'),
	(354730, 102, '2015-01-15 01:01:28.000000', 'consum', 0.0211, 'lps'),
	(354731, 102, '2015-01-15 01:01:29.000000', 'consum', 0.0219, 'lps'),
	(354732, 102, '2015-01-15 01:01:30.000000', 'consum', 0.0211, 'lps'),
	(354733, 102, '2015-01-15 01:01:31.000000', 'consum', 0.0218, 'lps'),
	(354734, 102, '2015-01-15 01:01:32.000000', 'consum', 0.0210, 'lps'),
	(354735, 102, '2015-01-15 01:01:33.000000', 'consum', 0.0214, 'lps'),
	(354736, 102, '2015-01-15 01:01:34.000000', 'consum', 0.0211, 'lps'),
	(354737, 102, '2015-01-15 01:01:35.000000', 'consum', 0.0213, 'lps'),
	(354738, 102, '2015-01-15 01:01:36.000000', 'consum', 0.0213, 'lps'),
	(354739, 102, '2015-01-15 01:01:37.000000', 'consum', 0.0216, 'lps'),
	(354740, 102, '2015-01-15 01:01:38.000000', 'consum', 0.0210, 'lps'),
	(354741, 102, '2015-01-15 01:01:39.000000', 'consum', 0.0214, 'lps'),
	(354742, 102, '2015-01-15 01:01:40.000000', 'consum', 0.0212, 'lps'),
	(354743, 102, '2015-01-15 01:01:41.000000', 'consum', 0.0216, 'lps'),
	(354744, 102, '2015-01-15 01:01:42.000000', 'consum', 0.0216, 'lps'),
	(354745, 102, '2015-01-15 01:01:43.000000', 'consum', 0.0211, 'lps'),
	(354746, 102, '2015-01-15 01:01:44.000000', 'consum', 0.0210, 'lps'),
	(354747, 102, '2015-01-15 01:01:45.000000', 'consum', 0.0215, 'lps'),
	(354748, 102, '2015-01-15 01:01:46.000000', 'consum', 0.0218, 'lps'),
	(354749, 102, '2015-01-15 01:01:47.000000', 'consum', 0.0215, 'lps'),
	(354750, 102, '2015-01-15 01:01:48.000000', 'consum', 0.0219, 'lps'),
	(354751, 102, '2015-01-15 01:01:49.000000', 'consum', 0.0212, 'lps'),
	(354752, 102, '2015-01-15 01:01:50.000000', 'consum', 0.0215, 'lps'),
	(354753, 102, '2015-01-15 01:01:51.000000', 'consum', 0.0210, 'lps'),
	(354754, 102, '2015-01-15 01:01:52.000000', 'consum', 0.0215, 'lps'),
	(354755, 102, '2015-01-15 01:01:53.000000', 'consum', 0.0215, 'lps'),
	(354756, 102, '2015-01-15 01:01:54.000000', 'consum', 0.0211, 'lps'),
	(354757, 102, '2015-01-15 01:01:55.000000', 'consum', 0.0211, 'lps'),
	(354758, 102, '2015-01-15 01:01:56.000000', 'consum', 0.0213, 'lps'),
	(354759, 102, '2015-01-15 01:01:57.000000', 'consum', 0.0213, 'lps'),
	(354760, 102, '2015-01-15 01:01:58.000000', 'consum', 0.0218, 'lps'),
	(354761, 102, '2015-01-15 01:01:59.000000', 'consum', 0.0219, 'lps'),
	(354762, 102, '2015-01-15 01:02:00.000000', 'consum', 0.0211, 'lps'),
	(354763, 102, '2015-01-15 01:02:01.000000', 'consum', 0.0218, 'lps'),
	(354764, 102, '2015-01-15 01:02:02.000000', 'consum', 0.0217, 'lps'),
	(354765, 102, '2015-01-15 01:02:03.000000', 'consum', 0.0214, 'lps'),
	(354766, 102, '2015-01-15 01:02:04.000000', 'consum', 0.0217, 'lps'),
	(354767, 102, '2015-01-15 01:02:05.000000', 'consum', 0.0213, 'lps'),
	(354768, 102, '2015-01-15 01:02:06.000000', 'consum', 0.0214, 'lps'),
	(354769, 102, '2015-01-15 01:02:07.000000', 'consum', 0.0213, 'lps'),
	(354770, 102, '2015-01-15 01:02:08.000000', 'consum', 0.0214, 'lps'),
	(354771, 102, '2015-01-15 01:02:09.000000', 'consum', 0.0213, 'lps'),
	(354772, 102, '2015-01-15 01:02:10.000000', 'consum', 0.0210, 'lps'),
	(354773, 102, '2015-01-15 01:02:11.000000', 'consum', 0.0214, 'lps'),
	(354774, 102, '2015-01-15 01:02:12.000000', 'consum', 0.0210, 'lps'),
	(354775, 102, '2015-01-15 01:02:13.000000', 'consum', 0.0210, 'lps'),
	(354776, 102, '2015-01-15 01:02:14.000000', 'consum', 0.0219, 'lps'),
	(354777, 102, '2015-01-15 01:02:15.000000', 'consum', 0.0216, 'lps'),
	(354778, 102, '2015-01-15 01:02:16.000000', 'consum', 0.0213, 'lps'),
	(354779, 102, '2015-01-15 01:02:17.000000', 'consum', 0.0218, 'lps'),
	(354780, 102, '2015-01-15 01:02:18.000000', 'consum', 0.0210, 'lps'),
	(354781, 102, '2015-01-15 01:02:19.000000', 'consum', 0.0216, 'lps'),
	(354782, 102, '2015-01-15 01:02:20.000000', 'consum', 0.0212, 'lps'),
	(354783, 102, '2015-01-15 01:02:21.000000', 'consum', 0.0214, 'lps'),
	(354784, 102, '2015-01-15 01:02:22.000000', 'consum', 0.0213, 'lps'),
	(354785, 102, '2015-01-15 01:02:23.000000', 'consum', 0.0212, 'lps'),
	(354786, 102, '2015-01-15 01:02:24.000000', 'consum', 0.0212, 'lps'),
	(354787, 102, '2015-01-15 01:02:25.000000', 'consum', 0.0214, 'lps'),
	(354788, 102, '2015-01-15 01:02:26.000000', 'consum', 0.0217, 'lps'),
	(354789, 102, '2015-01-15 01:02:27.000000', 'consum', 0.0213, 'lps'),
	(354790, 102, '2015-01-15 01:02:28.000000', 'consum', 0.0215, 'lps'),
	(354791, 102, '2015-01-15 01:02:29.000000', 'consum', 0.0214, 'lps'),
	(354792, 102, '2015-01-15 01:02:30.000000', 'consum', 0.0217, 'lps'),
	(354793, 102, '2015-01-15 01:02:31.000000', 'consum', 0.0211, 'lps'),
	(354794, 102, '2015-01-15 01:02:32.000000', 'consum', 0.0217, 'lps'),
	(354795, 102, '2015-01-15 01:02:33.000000', 'consum', 0.0211, 'lps'),
	(354796, 102, '2015-01-15 01:02:34.000000', 'consum', 0.0216, 'lps'),
	(354797, 102, '2015-01-15 01:02:35.000000', 'consum', 0.0217, 'lps'),
	(354798, 102, '2015-01-15 01:02:36.000000', 'consum', 0.0216, 'lps'),
	(354799, 102, '2015-01-15 01:02:37.000000', 'consum', 0.0210, 'lps'),
	(354800, 102, '2015-01-15 01:02:38.000000', 'consum', 0.0211, 'lps'),
	(354801, 102, '2015-01-15 01:02:39.000000', 'consum', 0.0217, 'lps'),
	(354802, 102, '2015-01-15 01:02:40.000000', 'consum', 0.0214, 'lps'),
	(354803, 102, '2015-01-15 01:02:41.000000', 'consum', 0.0218, 'lps'),
	(354804, 102, '2015-01-15 01:02:42.000000', 'consum', 0.0217, 'lps'),
	(354805, 102, '2015-01-15 01:02:43.000000', 'consum', 0.0213, 'lps'),
	(354806, 102, '2015-01-15 01:02:44.000000', 'consum', 0.0212, 'lps'),
	(354807, 102, '2015-01-15 01:02:45.000000', 'consum', 0.0215, 'lps'),
	(354808, 102, '2015-01-15 01:02:46.000000', 'consum', 0.0218, 'lps'),
	(354809, 102, '2015-01-15 01:02:47.000000', 'consum', 0.0216, 'lps'),
	(354810, 102, '2015-01-15 01:02:48.000000', 'consum', 0.0218, 'lps'),
	(354811, 102, '2015-01-15 01:02:49.000000', 'consum', 0.0210, 'lps'),
	(354812, 102, '2015-01-15 01:02:50.000000', 'consum', 0.0218, 'lps'),
	(354813, 102, '2015-01-15 01:02:51.000000', 'consum', 0.0210, 'lps'),
	(354814, 102, '2015-01-15 01:02:52.000000', 'consum', 0.0216, 'lps'),
	(354815, 102, '2015-01-15 01:02:53.000000', 'consum', 0.0211, 'lps'),
	(354816, 102, '2015-01-15 01:02:54.000000', 'consum', 0.0217, 'lps'),
	(354817, 102, '2015-01-15 01:02:55.000000', 'consum', 0.0213, 'lps'),
	(354818, 102, '2015-01-15 01:02:56.000000', 'consum', 0.0212, 'lps'),
	(354819, 102, '2015-01-15 01:02:57.000000', 'consum', 0.0214, 'lps'),
	(354820, 102, '2015-01-15 01:02:58.000000', 'consum', 0.0216, 'lps'),
	(354821, 102, '2015-01-15 01:02:59.000000', 'consum', 0.0216, 'lps'),
	(354822, 102, '2015-01-15 01:03:00.000000', 'consum', 0.0212, 'lps'),
	(354823, 102, '2015-01-15 01:03:01.000000', 'consum', 0.0215, 'lps'),
	(354824, 102, '2015-01-15 01:03:02.000000', 'consum', 0.0218, 'lps'),
	(354825, 102, '2015-01-15 01:03:03.000000', 'consum', 0.0214, 'lps'),
	(354826, 102, '2015-01-15 01:03:04.000000', 'consum', 0.0217, 'lps'),
	(354827, 102, '2015-01-15 01:03:05.000000', 'consum', 0.0215, 'lps'),
	(354828, 102, '2015-01-15 01:03:06.000000', 'consum', 0.0214, 'lps'),
	(354829, 102, '2015-01-15 01:03:07.000000', 'consum', 0.0216, 'lps'),
	(354830, 102, '2015-01-15 01:03:08.000000', 'consum', 0.0219, 'lps'),
	(354831, 102, '2015-01-15 01:03:09.000000', 'consum', 0.0218, 'lps'),
	(354832, 102, '2015-01-15 01:03:10.000000', 'consum', 0.0212, 'lps'),
	(354833, 102, '2015-01-15 01:03:11.000000', 'consum', 0.0218, 'lps'),
	(354834, 102, '2015-01-15 01:03:12.000000', 'consum', 0.0212, 'lps'),
	(354835, 102, '2015-01-15 01:03:13.000000', 'consum', 0.0218, 'lps'),
	(354836, 102, '2015-01-15 01:03:14.000000', 'consum', 0.0214, 'lps'),
	(354837, 102, '2015-01-15 01:03:15.000000', 'consum', 0.0218, 'lps'),
	(354838, 102, '2015-01-15 01:03:16.000000', 'consum', 0.0217, 'lps'),
	(354839, 102, '2015-01-15 01:03:17.000000', 'consum', 0.0213, 'lps'),
	(354840, 102, '2015-01-15 01:03:18.000000', 'consum', 0.0216, 'lps'),
	(354841, 102, '2015-01-15 01:03:19.000000', 'consum', 0.0219, 'lps'),
	(354842, 102, '2015-01-15 01:03:20.000000', 'consum', 0.0217, 'lps'),
	(354843, 102, '2015-01-15 01:03:21.000000', 'consum', 0.0217, 'lps'),
	(354844, 102, '2015-01-15 01:03:22.000000', 'consum', 0.0218, 'lps'),
	(354845, 102, '2015-01-15 01:03:23.000000', 'consum', 0.0217, 'lps'),
	(354846, 102, '2015-01-15 01:03:24.000000', 'consum', 0.0212, 'lps'),
	(354847, 102, '2015-01-15 01:03:25.000000', 'consum', 0.0211, 'lps'),
	(354848, 102, '2015-01-15 01:03:26.000000', 'consum', 0.0218, 'lps'),
	(354849, 102, '2015-01-15 01:03:27.000000', 'consum', 0.0219, 'lps'),
	(354850, 102, '2015-01-15 01:03:28.000000', 'consum', 0.0219, 'lps'),
	(354851, 102, '2015-01-15 01:03:29.000000', 'consum', 0.0219, 'lps'),
	(354852, 102, '2015-01-15 01:03:30.000000', 'consum', 0.0218, 'lps'),
	(354853, 102, '2015-01-15 01:03:31.000000', 'consum', 0.0215, 'lps'),
	(354854, 102, '2015-01-15 01:03:32.000000', 'consum', 0.0213, 'lps'),
	(354855, 102, '2015-01-15 01:03:33.000000', 'consum', 0.0219, 'lps'),
	(354856, 102, '2015-01-15 01:03:34.000000', 'consum', 0.0216, 'lps'),
	(354857, 102, '2015-01-15 01:03:35.000000', 'consum', 0.0214, 'lps'),
	(354858, 102, '2015-01-15 01:03:36.000000', 'consum', 0.0212, 'lps'),
	(354859, 102, '2015-01-15 01:03:37.000000', 'consum', 0.0211, 'lps'),
	(354860, 102, '2015-01-15 01:03:38.000000', 'consum', 0.0217, 'lps'),
	(354861, 102, '2015-01-15 01:03:39.000000', 'consum', 0.0213, 'lps'),
	(354862, 102, '2015-01-15 01:03:40.000000', 'consum', 0.0216, 'lps'),
	(354863, 102, '2015-01-15 01:03:41.000000', 'consum', 0.0210, 'lps'),
	(354864, 102, '2015-01-15 01:03:42.000000', 'consum', 0.0211, 'lps'),
	(354865, 102, '2015-01-15 01:03:43.000000', 'consum', 0.0219, 'lps'),
	(354866, 102, '2015-01-15 01:03:44.000000', 'consum', 0.0210, 'lps'),
	(354867, 102, '2015-01-15 01:03:45.000000', 'consum', 0.0215, 'lps'),
	(354868, 102, '2015-01-15 01:03:46.000000', 'consum', 0.0217, 'lps'),
	(354869, 102, '2015-01-15 01:03:47.000000', 'consum', 0.0218, 'lps'),
	(354870, 102, '2015-01-15 01:03:48.000000', 'consum', 0.0210, 'lps'),
	(354871, 102, '2015-01-15 01:03:49.000000', 'consum', 0.0215, 'lps'),
	(354872, 102, '2015-01-15 01:03:50.000000', 'consum', 0.0216, 'lps'),
	(354873, 102, '2015-01-15 01:03:51.000000', 'consum', 0.0216, 'lps'),
	(354874, 102, '2015-01-15 01:03:52.000000', 'consum', 0.0211, 'lps'),
	(354875, 102, '2015-01-15 01:03:53.000000', 'consum', 0.0210, 'lps'),
	(354876, 102, '2015-01-15 01:03:54.000000', 'consum', 0.0215, 'lps'),
	(354877, 102, '2015-01-15 01:03:55.000000', 'consum', 0.0216, 'lps'),
	(354878, 102, '2015-01-15 01:03:56.000000', 'consum', 0.0217, 'lps'),
	(354879, 102, '2015-01-15 01:03:57.000000', 'consum', 0.0218, 'lps'),
	(354880, 102, '2015-01-15 01:03:58.000000', 'consum', 0.0217, 'lps'),
	(354881, 102, '2015-01-15 01:03:59.000000', 'consum', 0.0213, 'lps'),
	(354882, 102, '2015-01-15 01:04:00.000000', 'consum', 0.0212, 'lps'),
	(354883, 102, '2015-01-15 01:04:01.000000', 'consum', 0.0214, 'lps'),
	(354884, 102, '2015-01-15 01:04:02.000000', 'consum', 0.0213, 'lps'),
	(354885, 102, '2015-01-15 01:04:03.000000', 'consum', 0.0215, 'lps'),
	(354886, 102, '2015-01-15 01:04:04.000000', 'consum', 0.0215, 'lps'),
	(354887, 102, '2015-01-15 01:04:05.000000', 'consum', 0.0219, 'lps'),
	(354888, 102, '2015-01-15 01:04:06.000000', 'consum', 0.0213, 'lps'),
	(354889, 102, '2015-01-15 01:04:07.000000', 'consum', 0.0219, 'lps'),
	(354890, 102, '2015-01-15 01:04:08.000000', 'consum', 0.0216, 'lps'),
	(354891, 102, '2015-01-15 01:04:09.000000', 'consum', 0.0212, 'lps'),
	(354892, 102, '2015-01-15 01:04:10.000000', 'consum', 0.0212, 'lps'),
	(354893, 102, '2015-01-15 01:04:11.000000', 'consum', 0.0213, 'lps'),
	(354894, 102, '2015-01-15 01:04:12.000000', 'consum', 0.0213, 'lps'),
	(354895, 102, '2015-01-15 01:04:13.000000', 'consum', 0.0216, 'lps'),
	(354896, 102, '2015-01-15 01:04:14.000000', 'consum', 0.0212, 'lps'),
	(354897, 102, '2015-01-15 01:04:15.000000', 'consum', 0.0212, 'lps'),
	(354898, 102, '2015-01-15 01:04:16.000000', 'consum', 0.0214, 'lps'),
	(354899, 102, '2015-01-15 01:04:17.000000', 'consum', 0.0213, 'lps'),
	(354900, 102, '2015-01-15 01:04:18.000000', 'consum', 0.0213, 'lps'),
	(354901, 102, '2015-01-15 01:04:19.000000', 'consum', 0.0218, 'lps'),
	(354902, 102, '2015-01-15 01:04:20.000000', 'consum', 0.0211, 'lps'),
	(354903, 102, '2015-01-15 01:04:21.000000', 'consum', 0.0211, 'lps'),
	(354904, 102, '2015-01-15 01:04:22.000000', 'consum', 0.0211, 'lps'),
	(354905, 102, '2015-01-15 01:04:23.000000', 'consum', 0.0215, 'lps'),
	(354906, 102, '2015-01-15 01:04:24.000000', 'consum', 0.0211, 'lps'),
	(354907, 102, '2015-01-15 01:04:25.000000', 'consum', 0.0213, 'lps'),
	(354908, 102, '2015-01-15 01:04:26.000000', 'consum', 0.0210, 'lps'),
	(354909, 102, '2015-01-15 01:04:27.000000', 'consum', 0.0214, 'lps'),
	(354910, 102, '2015-01-15 01:04:28.000000', 'consum', 0.0210, 'lps'),
	(354911, 102, '2015-01-15 01:04:29.000000', 'consum', 0.0218, 'lps'),
	(354912, 102, '2015-01-15 01:04:30.000000', 'consum', 0.0212, 'lps'),
	(354913, 102, '2015-01-15 01:04:31.000000', 'consum', 0.0217, 'lps'),
	(354914, 102, '2015-01-15 01:04:32.000000', 'consum', 0.0218, 'lps'),
	(354915, 102, '2015-01-15 01:04:33.000000', 'consum', 0.0218, 'lps'),
	(354916, 102, '2015-01-15 01:04:34.000000', 'consum', 0.0218, 'lps'),
	(354917, 102, '2015-01-15 01:04:35.000000', 'consum', 0.0217, 'lps'),
	(354918, 102, '2015-01-15 01:04:36.000000', 'consum', 0.0210, 'lps'),
	(354919, 102, '2015-01-15 01:04:37.000000', 'consum', 0.0219, 'lps'),
	(354920, 102, '2015-01-15 01:04:38.000000', 'consum', 0.0217, 'lps'),
	(354921, 102, '2015-01-15 01:04:39.000000', 'consum', 0.0210, 'lps'),
	(354922, 102, '2015-01-15 01:04:40.000000', 'consum', 0.0217, 'lps'),
	(354923, 102, '2015-01-15 01:04:41.000000', 'consum', 0.0217, 'lps'),
	(354924, 102, '2015-01-15 01:04:42.000000', 'consum', 0.0215, 'lps'),
	(354925, 102, '2015-01-15 01:04:43.000000', 'consum', 0.0215, 'lps'),
	(354926, 102, '2015-01-15 01:04:44.000000', 'consum', 0.0211, 'lps'),
	(354927, 102, '2015-01-15 01:04:45.000000', 'consum', 0.0218, 'lps'),
	(354928, 102, '2015-01-15 01:04:46.000000', 'consum', 0.0217, 'lps'),
	(354929, 102, '2015-01-15 01:04:47.000000', 'consum', 0.0214, 'lps'),
	(354930, 102, '2015-01-15 01:04:48.000000', 'consum', 0.0210, 'lps'),
	(354931, 102, '2015-01-15 01:04:49.000000', 'consum', 0.0219, 'lps'),
	(354932, 102, '2015-01-15 01:04:50.000000', 'consum', 0.0214, 'lps'),
	(354933, 102, '2015-01-15 01:04:51.000000', 'consum', 0.0212, 'lps'),
	(354934, 102, '2015-01-15 01:04:52.000000', 'consum', 0.0212, 'lps'),
	(354935, 102, '2015-01-15 01:04:53.000000', 'consum', 0.0212, 'lps'),
	(354936, 102, '2015-01-15 01:04:54.000000', 'consum', 0.0213, 'lps'),
	(354937, 102, '2015-01-15 01:04:55.000000', 'consum', 0.0213, 'lps'),
	(354938, 102, '2015-01-15 01:04:56.000000', 'consum', 0.0214, 'lps'),
	(354939, 102, '2015-01-15 01:04:57.000000', 'consum', 0.0211, 'lps'),
	(354940, 102, '2015-01-15 01:04:58.000000', 'consum', 0.0213, 'lps'),
	(354941, 102, '2015-01-15 01:04:59.000000', 'consum', 0.0213, 'lps'),
	(354942, 102, '2015-01-15 01:05:00.000000', 'consum', 0.0216, 'lps'),
	(354943, 102, '2015-01-15 01:05:01.000000', 'consum', 0.0212, 'lps'),
	(354944, 102, '2015-01-15 01:05:02.000000', 'consum', 0.0211, 'lps'),
	(354945, 102, '2015-01-15 01:05:03.000000', 'consum', 0.0218, 'lps'),
	(354946, 102, '2015-01-15 01:05:04.000000', 'consum', 0.0211, 'lps'),
	(354947, 102, '2015-01-15 01:05:05.000000', 'consum', 0.0212, 'lps'),
	(354948, 102, '2015-01-15 01:05:06.000000', 'consum', 0.0214, 'lps'),
	(354949, 102, '2015-01-15 01:05:07.000000', 'consum', 0.0218, 'lps'),
	(354950, 102, '2015-01-15 01:05:08.000000', 'consum', 0.0218, 'lps'),
	(354951, 102, '2015-01-15 01:05:09.000000', 'consum', 0.0216, 'lps'),
	(354952, 102, '2015-01-15 01:05:10.000000', 'consum', 0.0216, 'lps'),
	(354953, 102, '2015-01-15 01:05:11.000000', 'consum', 0.0212, 'lps'),
	(354954, 102, '2015-01-15 01:05:12.000000', 'consum', 0.0214, 'lps'),
	(354955, 102, '2015-01-15 01:05:13.000000', 'consum', 0.0215, 'lps'),
	(354956, 102, '2015-01-15 01:05:14.000000', 'consum', 0.0215, 'lps'),
	(354957, 102, '2015-01-15 01:05:15.000000', 'consum', 0.0218, 'lps'),
	(354958, 102, '2015-01-15 01:05:16.000000', 'consum', 0.0217, 'lps'),
	(354959, 102, '2015-01-15 01:05:17.000000', 'consum', 0.0210, 'lps'),
	(354960, 102, '2015-01-15 01:05:18.000000', 'consum', 0.0219, 'lps'),
	(354961, 102, '2015-01-15 01:05:19.000000', 'consum', 0.0214, 'lps'),
	(354962, 102, '2015-01-15 01:05:20.000000', 'consum', 0.0217, 'lps'),
	(354963, 102, '2015-01-15 01:05:21.000000', 'consum', 0.0211, 'lps'),
	(354964, 102, '2015-01-15 01:05:22.000000', 'consum', 0.0217, 'lps'),
	(354965, 102, '2015-01-15 01:05:23.000000', 'consum', 0.0212, 'lps'),
	(354966, 102, '2015-01-15 01:05:24.000000', 'consum', 0.0211, 'lps'),
	(354967, 102, '2015-01-15 01:05:25.000000', 'consum', 0.0218, 'lps'),
	(354968, 102, '2015-01-15 01:05:26.000000', 'consum', 0.0218, 'lps'),
	(354969, 102, '2015-01-15 01:05:27.000000', 'consum', 0.0216, 'lps'),
	(354970, 102, '2015-01-15 01:05:28.000000', 'consum', 0.0216, 'lps'),
	(354971, 102, '2015-01-15 01:05:29.000000', 'consum', 0.0211, 'lps'),
	(354972, 102, '2015-01-15 01:05:30.000000', 'consum', 0.0211, 'lps'),
	(354973, 102, '2015-01-15 01:05:31.000000', 'consum', 0.0211, 'lps'),
	(354974, 102, '2015-01-15 01:05:32.000000', 'consum', 0.0212, 'lps'),
	(354975, 102, '2015-01-15 01:05:33.000000', 'consum', 0.0216, 'lps'),
	(354976, 102, '2015-01-15 01:05:34.000000', 'consum', 0.0217, 'lps'),
	(354977, 102, '2015-01-15 01:05:35.000000', 'consum', 0.0219, 'lps'),
	(354978, 102, '2015-01-15 01:05:36.000000', 'consum', 0.0211, 'lps'),
	(354979, 102, '2015-01-15 01:05:37.000000', 'consum', 0.0211, 'lps'),
	(354980, 102, '2015-01-15 01:05:38.000000', 'consum', 0.0210, 'lps'),
	(354981, 102, '2015-01-15 01:05:39.000000', 'consum', 0.0217, 'lps'),
	(354982, 102, '2015-01-15 01:05:40.000000', 'consum', 0.0215, 'lps'),
	(354983, 102, '2015-01-15 01:05:41.000000', 'consum', 0.0217, 'lps'),
	(354984, 102, '2015-01-15 01:05:42.000000', 'consum', 0.0218, 'lps'),
	(354985, 102, '2015-01-15 01:05:43.000000', 'consum', 0.0211, 'lps'),
	(354986, 102, '2015-01-15 01:05:44.000000', 'consum', 0.0212, 'lps'),
	(354987, 102, '2015-01-15 01:05:45.000000', 'consum', 0.0219, 'lps'),
	(354988, 102, '2015-01-15 01:05:46.000000', 'consum', 0.0218, 'lps'),
	(354989, 102, '2015-01-15 01:05:47.000000', 'consum', 0.0213, 'lps'),
	(354990, 102, '2015-01-15 01:05:48.000000', 'consum', 0.0213, 'lps'),
	(354991, 102, '2015-01-15 01:05:49.000000', 'consum', 0.0214, 'lps'),
	(354992, 102, '2015-01-15 01:05:50.000000', 'consum', 0.0212, 'lps'),
	(354993, 102, '2015-01-15 01:05:51.000000', 'consum', 0.0210, 'lps'),
	(354994, 102, '2015-01-15 01:05:52.000000', 'consum', 0.0215, 'lps'),
	(354995, 102, '2015-01-15 01:05:53.000000', 'consum', 0.0215, 'lps'),
	(354996, 102, '2015-01-15 01:05:54.000000', 'consum', 0.0212, 'lps'),
	(354997, 102, '2015-01-15 01:05:55.000000', 'consum', 0.0213, 'lps'),
	(354998, 102, '2015-01-15 01:05:56.000000', 'consum', 0.0212, 'lps'),
	(354999, 102, '2015-01-15 01:05:57.000000', 'consum', 0.0219, 'lps'),
	(355000, 102, '2015-01-15 01:05:58.000000', 'consum', 0.0211, 'lps'),
	(355001, 102, '2015-01-15 01:05:59.000000', 'consum', 0.0218, 'lps'),
	(355002, 102, '2015-01-15 01:06:00.000000', 'consum', 0.0216, 'lps'),
	(355003, 102, '2015-01-15 01:06:01.000000', 'consum', 0.0217, 'lps'),
	(355004, 102, '2015-01-15 01:06:02.000000', 'consum', 0.0218, 'lps'),
	(355005, 102, '2015-01-15 01:06:03.000000', 'consum', 0.0211, 'lps'),
	(355006, 102, '2015-01-15 01:06:04.000000', 'consum', 0.0210, 'lps'),
	(355007, 102, '2015-01-15 01:06:05.000000', 'consum', 0.0219, 'lps'),
	(355008, 102, '2015-01-15 01:06:06.000000', 'consum', 0.0213, 'lps'),
	(355009, 102, '2015-01-15 01:06:07.000000', 'consum', 0.0210, 'lps'),
	(355010, 102, '2015-01-15 01:06:08.000000', 'consum', 0.0211, 'lps'),
	(355011, 102, '2015-01-15 01:06:09.000000', 'consum', 0.0215, 'lps'),
	(355012, 102, '2015-01-15 01:06:10.000000', 'consum', 0.0213, 'lps'),
	(355013, 102, '2015-01-15 01:06:11.000000', 'consum', 0.0211, 'lps'),
	(355014, 102, '2015-01-15 01:06:12.000000', 'consum', 0.0214, 'lps'),
	(355015, 102, '2015-01-15 01:06:13.000000', 'consum', 0.0210, 'lps'),
	(355016, 102, '2015-01-15 01:06:14.000000', 'consum', 0.0217, 'lps'),
	(355017, 102, '2015-01-15 01:06:15.000000', 'consum', 0.0218, 'lps'),
	(355018, 102, '2015-01-15 01:06:16.000000', 'consum', 0.0218, 'lps'),
	(355019, 102, '2015-01-15 01:06:17.000000', 'consum', 0.0215, 'lps'),
	(355020, 102, '2015-01-15 01:06:18.000000', 'consum', 0.0213, 'lps'),
	(355021, 102, '2015-01-15 01:06:19.000000', 'consum', 0.0219, 'lps'),
	(355022, 102, '2015-01-15 01:06:20.000000', 'consum', 0.0218, 'lps'),
	(355023, 102, '2015-01-15 01:06:21.000000', 'consum', 0.0215, 'lps'),
	(355024, 102, '2015-01-15 01:06:22.000000', 'consum', 0.0219, 'lps'),
	(355025, 102, '2015-01-15 01:06:23.000000', 'consum', 0.0213, 'lps'),
	(355026, 102, '2015-01-15 01:06:24.000000', 'consum', 0.0218, 'lps'),
	(355027, 102, '2015-01-15 01:06:25.000000', 'consum', 0.0211, 'lps'),
	(355028, 102, '2015-01-15 01:06:26.000000', 'consum', 0.0211, 'lps'),
	(355029, 102, '2015-01-15 01:06:27.000000', 'consum', 0.0215, 'lps'),
	(355030, 102, '2015-01-15 01:06:28.000000', 'consum', 0.0210, 'lps'),
	(355031, 102, '2015-01-15 01:06:29.000000', 'consum', 0.0214, 'lps'),
	(355032, 102, '2015-01-15 01:06:30.000000', 'consum', 0.0214, 'lps'),
	(355033, 102, '2015-01-15 01:06:31.000000', 'consum', 0.0216, 'lps'),
	(355034, 102, '2015-01-15 01:06:32.000000', 'consum', 0.0210, 'lps'),
	(355035, 102, '2015-01-15 01:06:33.000000', 'consum', 0.0214, 'lps'),
	(355036, 102, '2015-01-15 01:06:34.000000', 'consum', 0.0210, 'lps'),
	(355037, 102, '2015-01-15 01:06:35.000000', 'consum', 0.0216, 'lps'),
	(355038, 102, '2015-01-15 01:06:36.000000', 'consum', 0.0214, 'lps'),
	(355039, 102, '2015-01-15 01:06:37.000000', 'consum', 0.0211, 'lps'),
	(355040, 102, '2015-01-15 01:06:38.000000', 'consum', 0.0212, 'lps'),
	(355041, 102, '2015-01-15 01:06:39.000000', 'consum', 0.0210, 'lps'),
	(355042, 102, '2015-01-15 01:06:40.000000', 'consum', 0.0215, 'lps'),
	(355043, 102, '2015-01-15 01:06:41.000000', 'consum', 0.0216, 'lps'),
	(355044, 102, '2015-01-15 01:06:42.000000', 'consum', 0.0216, 'lps'),
	(355045, 102, '2015-01-15 01:06:43.000000', 'consum', 0.0211, 'lps'),
	(355046, 102, '2015-01-15 01:06:44.000000', 'consum', 0.0217, 'lps'),
	(355047, 102, '2015-01-15 01:06:45.000000', 'consum', 0.0212, 'lps'),
	(355048, 102, '2015-01-15 01:06:46.000000', 'consum', 0.0218, 'lps'),
	(355049, 102, '2015-01-15 01:06:47.000000', 'consum', 0.0218, 'lps'),
	(355050, 102, '2015-01-15 01:06:48.000000', 'consum', 0.0215, 'lps'),
	(355051, 102, '2015-01-15 01:06:49.000000', 'consum', 0.0213, 'lps'),
	(355052, 102, '2015-01-15 01:06:50.000000', 'consum', 0.0219, 'lps'),
	(355053, 102, '2015-01-15 01:06:51.000000', 'consum', 0.0216, 'lps'),
	(355054, 102, '2015-01-15 01:06:52.000000', 'consum', 0.0214, 'lps'),
	(355055, 102, '2015-01-15 01:06:53.000000', 'consum', 0.0215, 'lps'),
	(355056, 102, '2015-01-15 01:06:54.000000', 'consum', 0.0211, 'lps'),
	(355057, 102, '2015-01-15 01:06:55.000000', 'consum', 0.0219, 'lps'),
	(355058, 102, '2015-01-15 01:06:56.000000', 'consum', 0.0215, 'lps'),
	(355059, 102, '2015-01-15 01:06:57.000000', 'consum', 0.0216, 'lps'),
	(355060, 102, '2015-01-15 01:06:58.000000', 'consum', 0.0215, 'lps'),
	(355061, 102, '2015-01-15 01:06:59.000000', 'consum', 0.0219, 'lps'),
	(355062, 102, '2015-01-15 01:07:00.000000', 'consum', 0.0212, 'lps'),
	(355063, 102, '2015-01-15 01:07:01.000000', 'consum', 0.0214, 'lps'),
	(355064, 102, '2015-01-15 01:07:02.000000', 'consum', 0.0211, 'lps'),
	(355065, 102, '2015-01-15 01:07:03.000000', 'consum', 0.0216, 'lps'),
	(355066, 102, '2015-01-15 01:07:04.000000', 'consum', 0.0217, 'lps'),
	(355067, 102, '2015-01-15 01:07:05.000000', 'consum', 0.0217, 'lps'),
	(355068, 102, '2015-01-15 01:07:06.000000', 'consum', 0.0215, 'lps'),
	(355069, 102, '2015-01-15 01:07:07.000000', 'consum', 0.0216, 'lps'),
	(355070, 102, '2015-01-15 01:07:08.000000', 'consum', 0.0212, 'lps'),
	(355071, 102, '2015-01-15 01:07:09.000000', 'consum', 0.0215, 'lps'),
	(355072, 102, '2015-01-15 01:07:10.000000', 'consum', 0.0219, 'lps'),
	(355073, 102, '2015-01-15 01:07:11.000000', 'consum', 0.0212, 'lps'),
	(355074, 102, '2015-01-15 01:07:12.000000', 'consum', 0.0212, 'lps'),
	(355075, 102, '2015-01-15 01:07:13.000000', 'consum', 0.0216, 'lps'),
	(355076, 102, '2015-01-15 01:07:14.000000', 'consum', 0.0214, 'lps'),
	(355077, 102, '2015-01-15 01:07:15.000000', 'consum', 0.0211, 'lps'),
	(355078, 102, '2015-01-15 01:07:16.000000', 'consum', 0.0216, 'lps'),
	(355079, 102, '2015-01-15 01:07:17.000000', 'consum', 0.0217, 'lps'),
	(355080, 102, '2015-01-15 01:07:18.000000', 'consum', 0.0217, 'lps'),
	(355081, 102, '2015-01-15 01:07:19.000000', 'consum', 0.0214, 'lps'),
	(355082, 102, '2015-01-15 01:07:20.000000', 'consum', 0.0212, 'lps'),
	(355083, 102, '2015-01-15 01:07:21.000000', 'consum', 0.0216, 'lps'),
	(355084, 102, '2015-01-15 01:07:22.000000', 'consum', 0.0214, 'lps'),
	(355085, 102, '2015-01-15 01:07:23.000000', 'consum', 0.0213, 'lps'),
	(355086, 102, '2015-01-15 01:07:24.000000', 'consum', 0.0214, 'lps'),
	(355087, 102, '2015-01-15 01:07:25.000000', 'consum', 0.0210, 'lps'),
	(355088, 102, '2015-01-15 01:07:26.000000', 'consum', 0.0210, 'lps'),
	(355089, 102, '2015-01-15 01:07:27.000000', 'consum', 0.0211, 'lps'),
	(355090, 102, '2015-01-15 01:07:28.000000', 'consum', 0.0214, 'lps'),
	(355091, 102, '2015-01-15 01:07:29.000000', 'consum', 0.0210, 'lps'),
	(355092, 102, '2015-01-15 01:07:30.000000', 'consum', 0.0215, 'lps'),
	(355093, 102, '2015-01-15 01:07:31.000000', 'consum', 0.0218, 'lps'),
	(355094, 102, '2015-01-15 01:07:32.000000', 'consum', 0.0216, 'lps'),
	(355095, 102, '2015-01-15 01:07:33.000000', 'consum', 0.0214, 'lps'),
	(355096, 102, '2015-01-15 01:07:34.000000', 'consum', 0.0212, 'lps'),
	(355097, 102, '2015-01-15 01:07:35.000000', 'consum', 0.0211, 'lps'),
	(355098, 102, '2015-01-15 01:07:36.000000', 'consum', 0.0210, 'lps'),
	(355099, 102, '2015-01-15 01:07:37.000000', 'consum', 0.0215, 'lps'),
	(355100, 102, '2015-01-15 01:07:38.000000', 'consum', 0.0215, 'lps'),
	(355101, 102, '2015-01-15 01:07:39.000000', 'consum', 0.0213, 'lps'),
	(355102, 102, '2015-01-15 01:07:40.000000', 'consum', 0.0210, 'lps'),
	(355103, 102, '2015-01-15 01:07:41.000000', 'consum', 0.0211, 'lps'),
	(355104, 102, '2015-01-15 01:07:42.000000', 'consum', 0.0216, 'lps'),
	(355105, 102, '2015-01-15 01:07:43.000000', 'consum', 0.0216, 'lps'),
	(355106, 102, '2015-01-15 01:07:44.000000', 'consum', 0.0215, 'lps'),
	(355107, 102, '2015-01-15 01:07:45.000000', 'consum', 0.0217, 'lps'),
	(355108, 102, '2015-01-15 01:07:46.000000', 'consum', 0.0219, 'lps'),
	(355109, 102, '2015-01-15 01:07:47.000000', 'consum', 0.0217, 'lps'),
	(355110, 102, '2015-01-15 01:07:48.000000', 'consum', 0.0218, 'lps'),
	(355111, 102, '2015-01-15 01:07:49.000000', 'consum', 0.0219, 'lps'),
	(355112, 102, '2015-01-15 01:07:50.000000', 'consum', 0.0211, 'lps'),
	(355113, 102, '2015-01-15 01:07:51.000000', 'consum', 0.0218, 'lps'),
	(355114, 102, '2015-01-15 01:07:52.000000', 'consum', 0.0218, 'lps'),
	(355115, 102, '2015-01-15 01:07:53.000000', 'consum', 0.0219, 'lps'),
	(355116, 102, '2015-01-15 01:07:54.000000', 'consum', 0.0219, 'lps'),
	(355117, 102, '2015-01-15 01:07:55.000000', 'consum', 0.0217, 'lps'),
	(355118, 102, '2015-01-15 01:07:56.000000', 'consum', 0.0210, 'lps'),
	(355119, 102, '2015-01-15 01:07:57.000000', 'consum', 0.0218, 'lps'),
	(355120, 102, '2015-01-15 01:07:58.000000', 'consum', 0.0212, 'lps'),
	(355121, 102, '2015-01-15 01:07:59.000000', 'consum', 0.0217, 'lps'),
	(355122, 102, '2015-01-15 01:08:00.000000', 'consum', 0.0217, 'lps'),
	(355123, 102, '2015-01-15 01:08:01.000000', 'consum', 0.0217, 'lps'),
	(355124, 102, '2015-01-15 01:08:02.000000', 'consum', 0.0215, 'lps'),
	(355125, 102, '2015-01-15 01:08:03.000000', 'consum', 0.0213, 'lps'),
	(355126, 102, '2015-01-15 01:08:04.000000', 'consum', 0.0210, 'lps'),
	(355127, 102, '2015-01-15 01:08:05.000000', 'consum', 0.0214, 'lps'),
	(355128, 102, '2015-01-15 01:08:06.000000', 'consum', 0.0218, 'lps'),
	(355129, 102, '2015-01-15 01:08:07.000000', 'consum', 0.0219, 'lps'),
	(355130, 102, '2015-01-15 01:08:08.000000', 'consum', 0.0211, 'lps'),
	(355131, 102, '2015-01-15 01:08:09.000000', 'consum', 0.0217, 'lps'),
	(355132, 102, '2015-01-15 01:08:10.000000', 'consum', 0.0214, 'lps'),
	(355133, 102, '2015-01-15 01:08:11.000000', 'consum', 0.0211, 'lps'),
	(355134, 102, '2015-01-15 01:08:12.000000', 'consum', 0.0214, 'lps'),
	(355135, 102, '2015-01-15 01:08:13.000000', 'consum', 0.0217, 'lps'),
	(355136, 102, '2015-01-15 01:08:14.000000', 'consum', 0.0212, 'lps'),
	(355137, 102, '2015-01-15 01:08:15.000000', 'consum', 0.0210, 'lps'),
	(355138, 102, '2015-01-15 01:08:16.000000', 'consum', 0.0214, 'lps'),
	(355139, 102, '2015-01-15 01:08:17.000000', 'consum', 0.0213, 'lps'),
	(355140, 102, '2015-01-15 01:08:18.000000', 'consum', 0.0211, 'lps'),
	(355141, 102, '2015-01-15 01:08:19.000000', 'consum', 0.0216, 'lps'),
	(355142, 102, '2015-01-15 01:08:20.000000', 'consum', 0.0218, 'lps'),
	(355143, 102, '2015-01-15 01:08:21.000000', 'consum', 0.0214, 'lps'),
	(355144, 102, '2015-01-15 01:08:22.000000', 'consum', 0.0218, 'lps'),
	(355145, 102, '2015-01-15 01:08:23.000000', 'consum', 0.0216, 'lps'),
	(355146, 102, '2015-01-15 01:08:24.000000', 'consum', 0.0216, 'lps'),
	(355147, 102, '2015-01-15 01:08:25.000000', 'consum', 0.0212, 'lps'),
	(355148, 102, '2015-01-15 01:08:26.000000', 'consum', 0.0215, 'lps'),
	(355149, 102, '2015-01-15 01:08:27.000000', 'consum', 0.0210, 'lps'),
	(355150, 102, '2015-01-15 01:08:28.000000', 'consum', 0.0213, 'lps'),
	(355151, 102, '2015-01-15 01:08:29.000000', 'consum', 0.0217, 'lps'),
	(355152, 102, '2015-01-15 01:08:30.000000', 'consum', 0.0214, 'lps'),
	(355153, 102, '2015-01-15 01:08:31.000000', 'consum', 0.0212, 'lps'),
	(355154, 102, '2015-01-15 01:08:32.000000', 'consum', 0.0218, 'lps'),
	(355155, 102, '2015-01-15 01:08:33.000000', 'consum', 0.0213, 'lps'),
	(355156, 102, '2015-01-15 01:08:34.000000', 'consum', 0.0210, 'lps'),
	(355157, 102, '2015-01-15 01:08:35.000000', 'consum', 0.0215, 'lps'),
	(355158, 102, '2015-01-15 01:08:36.000000', 'consum', 0.0214, 'lps'),
	(355159, 102, '2015-01-15 01:08:37.000000', 'consum', 0.0217, 'lps'),
	(355160, 102, '2015-01-15 01:08:38.000000', 'consum', 0.0211, 'lps'),
	(355161, 102, '2015-01-15 01:08:39.000000', 'consum', 0.0214, 'lps'),
	(355162, 102, '2015-01-15 01:08:40.000000', 'consum', 0.0210, 'lps'),
	(355163, 102, '2015-01-15 01:08:41.000000', 'consum', 0.0219, 'lps'),
	(355164, 102, '2015-01-15 01:08:42.000000', 'consum', 0.0214, 'lps'),
	(355165, 102, '2015-01-15 01:08:43.000000', 'consum', 0.0215, 'lps'),
	(355166, 102, '2015-01-15 01:08:44.000000', 'consum', 0.0214, 'lps'),
	(355167, 102, '2015-01-15 01:08:45.000000', 'consum', 0.0215, 'lps'),
	(355168, 102, '2015-01-15 01:08:46.000000', 'consum', 0.0212, 'lps'),
	(355169, 102, '2015-01-15 01:08:47.000000', 'consum', 0.0215, 'lps'),
	(355170, 102, '2015-01-15 01:08:48.000000', 'consum', 0.0210, 'lps'),
	(355171, 102, '2015-01-15 01:08:49.000000', 'consum', 0.0214, 'lps'),
	(355172, 102, '2015-01-15 01:08:50.000000', 'consum', 0.0214, 'lps'),
	(355173, 102, '2015-01-15 01:08:51.000000', 'consum', 0.0216, 'lps'),
	(355174, 102, '2015-01-15 01:08:52.000000', 'consum', 0.0218, 'lps'),
	(355175, 102, '2015-01-15 01:08:53.000000', 'consum', 0.0215, 'lps'),
	(355176, 102, '2015-01-15 01:08:54.000000', 'consum', 0.0211, 'lps'),
	(355177, 102, '2015-01-15 01:08:55.000000', 'consum', 0.0218, 'lps'),
	(355178, 102, '2015-01-15 01:08:56.000000', 'consum', 0.0211, 'lps'),
	(355179, 102, '2015-01-15 01:08:57.000000', 'consum', 0.0218, 'lps'),
	(355180, 102, '2015-01-15 01:08:58.000000', 'consum', 0.0210, 'lps'),
	(355181, 102, '2015-01-15 01:08:59.000000', 'consum', 0.0216, 'lps'),
	(355182, 102, '2015-01-15 01:09:00.000000', 'consum', 0.0211, 'lps'),
	(355183, 102, '2015-01-15 01:09:01.000000', 'consum', 0.0217, 'lps'),
	(355184, 102, '2015-01-15 01:09:02.000000', 'consum', 0.0214, 'lps'),
	(355185, 102, '2015-01-15 01:09:03.000000', 'consum', 0.0218, 'lps'),
	(355186, 102, '2015-01-15 01:09:04.000000', 'consum', 0.0217, 'lps'),
	(355187, 102, '2015-01-15 01:09:05.000000', 'consum', 0.0214, 'lps'),
	(355188, 102, '2015-01-15 01:09:06.000000', 'consum', 0.0219, 'lps'),
	(355189, 102, '2015-01-15 01:09:07.000000', 'consum', 0.0215, 'lps'),
	(355190, 102, '2015-01-15 01:09:08.000000', 'consum', 0.0219, 'lps'),
	(355191, 102, '2015-01-15 01:09:09.000000', 'consum', 0.0217, 'lps'),
	(355192, 102, '2015-01-15 01:09:10.000000', 'consum', 0.0211, 'lps'),
	(355193, 102, '2015-01-15 01:09:11.000000', 'consum', 0.0215, 'lps'),
	(355194, 102, '2015-01-15 01:09:12.000000', 'consum', 0.0211, 'lps'),
	(355195, 102, '2015-01-15 01:09:13.000000', 'consum', 0.0219, 'lps'),
	(355196, 102, '2015-01-15 01:09:14.000000', 'consum', 0.0216, 'lps'),
	(355197, 102, '2015-01-15 01:09:15.000000', 'consum', 0.0211, 'lps'),
	(355198, 102, '2015-01-15 01:09:16.000000', 'consum', 0.0218, 'lps'),
	(355199, 102, '2015-01-15 01:09:17.000000', 'consum', 0.0216, 'lps'),
	(355200, 102, '2015-01-15 01:09:18.000000', 'consum', 0.0219, 'lps'),
	(355201, 102, '2015-01-15 01:09:19.000000', 'consum', 0.0216, 'lps'),
	(355202, 102, '2015-01-15 01:09:20.000000', 'consum', 0.0214, 'lps'),
	(355203, 102, '2015-01-15 01:09:21.000000', 'consum', 0.0215, 'lps'),
	(355204, 102, '2015-01-15 01:09:22.000000', 'consum', 0.0210, 'lps'),
	(355205, 102, '2015-01-15 01:09:23.000000', 'consum', 0.0216, 'lps'),
	(355206, 102, '2015-01-15 01:09:24.000000', 'consum', 0.0210, 'lps'),
	(355207, 102, '2015-01-15 01:09:25.000000', 'consum', 0.0213, 'lps'),
	(355208, 102, '2015-01-15 01:09:26.000000', 'consum', 0.0216, 'lps'),
	(355209, 102, '2015-01-15 01:09:27.000000', 'consum', 0.0213, 'lps'),
	(355210, 102, '2015-01-15 01:09:28.000000', 'consum', 0.0216, 'lps'),
	(355211, 102, '2015-01-15 01:09:29.000000', 'consum', 0.0212, 'lps'),
	(355212, 102, '2015-01-15 01:09:30.000000', 'consum', 0.0213, 'lps'),
	(355213, 102, '2015-01-15 01:09:31.000000', 'consum', 0.0217, 'lps'),
	(355214, 102, '2015-01-15 01:09:32.000000', 'consum', 0.0219, 'lps'),
	(355215, 102, '2015-01-15 01:09:33.000000', 'consum', 0.0212, 'lps'),
	(355216, 102, '2015-01-15 01:09:34.000000', 'consum', 0.0215, 'lps'),
	(355217, 102, '2015-01-15 01:09:35.000000', 'consum', 0.0210, 'lps'),
	(355218, 102, '2015-01-15 01:09:36.000000', 'consum', 0.0214, 'lps'),
	(355219, 102, '2015-01-15 01:09:37.000000', 'consum', 0.0210, 'lps'),
	(355220, 102, '2015-01-15 01:09:38.000000', 'consum', 0.0211, 'lps'),
	(355221, 102, '2015-01-15 01:09:39.000000', 'consum', 0.0213, 'lps'),
	(355222, 102, '2015-01-15 01:09:40.000000', 'consum', 0.0215, 'lps'),
	(355223, 102, '2015-01-15 01:09:41.000000', 'consum', 0.0215, 'lps'),
	(355224, 102, '2015-01-15 01:09:42.000000', 'consum', 0.0219, 'lps'),
	(355225, 102, '2015-01-15 01:09:43.000000', 'consum', 0.0213, 'lps'),
	(355226, 102, '2015-01-15 01:09:44.000000', 'consum', 0.0216, 'lps'),
	(355227, 102, '2015-01-15 01:09:45.000000', 'consum', 0.0213, 'lps'),
	(355228, 102, '2015-01-15 01:09:46.000000', 'consum', 0.0217, 'lps'),
	(355229, 102, '2015-01-15 01:09:47.000000', 'consum', 0.0217, 'lps'),
	(355230, 102, '2015-01-15 01:09:48.000000', 'consum', 0.0212, 'lps'),
	(355231, 102, '2015-01-15 01:09:49.000000', 'consum', 0.0213, 'lps'),
	(355232, 102, '2015-01-15 01:09:50.000000', 'consum', 0.0219, 'lps'),
	(355233, 102, '2015-01-15 01:09:51.000000', 'consum', 0.0216, 'lps'),
	(355234, 102, '2015-01-15 01:09:52.000000', 'consum', 0.0215, 'lps'),
	(355235, 102, '2015-01-15 01:09:53.000000', 'consum', 0.0214, 'lps'),
	(355236, 102, '2015-01-15 01:09:54.000000', 'consum', 0.0218, 'lps'),
	(355237, 102, '2015-01-15 01:09:55.000000', 'consum', 0.0210, 'lps'),
	(355238, 102, '2015-01-15 01:09:56.000000', 'consum', 0.0214, 'lps'),
	(355239, 102, '2015-01-15 01:09:57.000000', 'consum', 0.0210, 'lps'),
	(355240, 102, '2015-01-15 01:09:58.000000', 'consum', 0.0210, 'lps'),
	(355241, 102, '2015-01-15 01:09:59.000000', 'consum', 0.0219, 'lps'),
	(355242, 102, '2015-01-15 01:10:00.000000', 'consum', 0.0217, 'lps'),
	(355243, 102, '2015-01-15 01:10:01.000000', 'consum', 0.0217, 'lps'),
	(355244, 102, '2015-01-15 01:10:02.000000', 'consum', 0.0216, 'lps'),
	(355245, 102, '2015-01-15 01:10:03.000000', 'consum', 0.0210, 'lps'),
	(355246, 102, '2015-01-15 01:10:04.000000', 'consum', 0.0212, 'lps'),
	(355247, 102, '2015-01-15 01:10:05.000000', 'consum', 0.0210, 'lps'),
	(355248, 102, '2015-01-15 01:10:06.000000', 'consum', 0.0215, 'lps'),
	(355249, 102, '2015-01-15 01:10:07.000000', 'consum', 0.0214, 'lps'),
	(355250, 102, '2015-01-15 01:10:08.000000', 'consum', 0.0216, 'lps'),
	(355251, 102, '2015-01-15 01:10:09.000000', 'consum', 0.0219, 'lps'),
	(355252, 102, '2015-01-15 01:10:10.000000', 'consum', 0.0219, 'lps'),
	(355253, 102, '2015-01-15 01:10:11.000000', 'consum', 0.0217, 'lps'),
	(355254, 102, '2015-01-15 01:10:12.000000', 'consum', 0.0210, 'lps'),
	(355255, 102, '2015-01-15 01:10:13.000000', 'consum', 0.0219, 'lps'),
	(355256, 102, '2015-01-15 01:10:14.000000', 'consum', 0.0214, 'lps'),
	(355257, 102, '2015-01-15 01:10:15.000000', 'consum', 0.0216, 'lps'),
	(355258, 102, '2015-01-15 01:10:16.000000', 'consum', 0.0218, 'lps'),
	(355259, 102, '2015-01-15 01:10:17.000000', 'consum', 0.0213, 'lps'),
	(355260, 102, '2015-01-15 01:10:18.000000', 'consum', 0.0211, 'lps'),
	(355261, 102, '2015-01-15 01:10:19.000000', 'consum', 0.0218, 'lps'),
	(355262, 102, '2015-01-15 01:10:20.000000', 'consum', 0.0218, 'lps'),
	(355263, 102, '2015-01-15 01:10:21.000000', 'consum', 0.0217, 'lps'),
	(355264, 102, '2015-01-15 01:10:22.000000', 'consum', 0.0211, 'lps'),
	(355265, 102, '2015-01-15 01:10:23.000000', 'consum', 0.0214, 'lps'),
	(355266, 102, '2015-01-15 01:10:24.000000', 'consum', 0.0210, 'lps'),
	(355267, 102, '2015-01-15 01:10:25.000000', 'consum', 0.0215, 'lps'),
	(355268, 102, '2015-01-15 01:10:26.000000', 'consum', 0.0215, 'lps'),
	(355269, 102, '2015-01-15 01:10:27.000000', 'consum', 0.0213, 'lps'),
	(355270, 102, '2015-01-15 01:10:28.000000', 'consum', 0.0219, 'lps'),
	(355271, 102, '2015-01-15 01:10:29.000000', 'consum', 0.0216, 'lps'),
	(355272, 102, '2015-01-15 01:10:30.000000', 'consum', 0.0212, 'lps'),
	(355273, 102, '2015-01-15 01:10:31.000000', 'consum', 0.0216, 'lps'),
	(355274, 102, '2015-01-15 01:10:32.000000', 'consum', 0.0213, 'lps'),
	(355275, 102, '2015-01-15 01:10:33.000000', 'consum', 0.0217, 'lps'),
	(355276, 102, '2015-01-15 01:10:34.000000', 'consum', 0.0215, 'lps'),
	(355277, 102, '2015-01-15 01:10:35.000000', 'consum', 0.0215, 'lps'),
	(355278, 102, '2015-01-15 01:10:36.000000', 'consum', 0.0212, 'lps'),
	(355279, 102, '2015-01-15 01:10:37.000000', 'consum', 0.0215, 'lps'),
	(355280, 102, '2015-01-15 01:10:38.000000', 'consum', 0.0210, 'lps'),
	(355281, 102, '2015-01-15 01:10:39.000000', 'consum', 0.0213, 'lps'),
	(355282, 102, '2015-01-15 01:10:40.000000', 'consum', 0.0217, 'lps'),
	(355283, 102, '2015-01-15 01:10:41.000000', 'consum', 0.0217, 'lps'),
	(355284, 102, '2015-01-15 01:10:42.000000', 'consum', 0.0214, 'lps'),
	(355285, 102, '2015-01-15 01:10:43.000000', 'consum', 0.0212, 'lps'),
	(355286, 102, '2015-01-15 01:10:44.000000', 'consum', 0.0215, 'lps'),
	(355287, 102, '2015-01-15 01:10:45.000000', 'consum', 0.0213, 'lps'),
	(355288, 102, '2015-01-15 01:10:46.000000', 'consum', 0.0218, 'lps'),
	(355289, 102, '2015-01-15 01:10:47.000000', 'consum', 0.0213, 'lps'),
	(355290, 102, '2015-01-15 01:10:48.000000', 'consum', 0.0211, 'lps'),
	(355291, 102, '2015-01-15 01:10:49.000000', 'consum', 0.0218, 'lps'),
	(355292, 102, '2015-01-15 01:10:50.000000', 'consum', 0.0217, 'lps'),
	(355293, 102, '2015-01-15 01:10:51.000000', 'consum', 0.0210, 'lps'),
	(355294, 102, '2015-01-15 01:10:52.000000', 'consum', 0.0218, 'lps'),
	(355295, 102, '2015-01-15 01:10:53.000000', 'consum', 0.0213, 'lps'),
	(355296, 102, '2015-01-15 01:10:54.000000', 'consum', 0.0211, 'lps'),
	(355297, 102, '2015-01-15 01:10:55.000000', 'consum', 0.0218, 'lps'),
	(355298, 102, '2015-01-15 01:10:56.000000', 'consum', 0.0216, 'lps'),
	(355299, 102, '2015-01-15 01:10:57.000000', 'consum', 0.0218, 'lps'),
	(355300, 102, '2015-01-15 01:10:58.000000', 'consum', 0.0211, 'lps'),
	(355301, 102, '2015-01-15 01:10:59.000000', 'consum', 0.0212, 'lps'),
	(355302, 102, '2015-01-15 01:11:00.000000', 'consum', 0.0217, 'lps'),
	(355303, 102, '2015-01-15 01:11:01.000000', 'consum', 0.0211, 'lps'),
	(355304, 102, '2015-01-15 01:11:02.000000', 'consum', 0.0214, 'lps'),
	(355305, 102, '2015-01-15 01:11:03.000000', 'consum', 0.0216, 'lps'),
	(355306, 102, '2015-01-15 01:11:04.000000', 'consum', 0.0218, 'lps'),
	(355307, 102, '2015-01-15 01:11:05.000000', 'consum', 0.0213, 'lps'),
	(355308, 102, '2015-01-15 01:11:06.000000', 'consum', 0.0211, 'lps'),
	(355309, 102, '2015-01-15 01:11:07.000000', 'consum', 0.0218, 'lps'),
	(355310, 102, '2015-01-15 01:11:08.000000', 'consum', 0.0217, 'lps'),
	(355311, 102, '2015-01-15 01:11:09.000000', 'consum', 0.0211, 'lps'),
	(355312, 102, '2015-01-15 01:11:10.000000', 'consum', 0.0213, 'lps'),
	(355313, 102, '2015-01-15 01:11:11.000000', 'consum', 0.0212, 'lps'),
	(355314, 102, '2015-01-15 01:11:12.000000', 'consum', 0.0214, 'lps'),
	(355315, 102, '2015-01-15 01:11:13.000000', 'consum', 0.0212, 'lps'),
	(355316, 102, '2015-01-15 01:11:14.000000', 'consum', 0.0210, 'lps'),
	(355317, 102, '2015-01-15 01:11:15.000000', 'consum', 0.0215, 'lps'),
	(355318, 102, '2015-01-15 01:11:16.000000', 'consum', 0.0214, 'lps'),
	(355319, 102, '2015-01-15 01:11:17.000000', 'consum', 0.0218, 'lps'),
	(355320, 102, '2015-01-15 01:11:18.000000', 'consum', 0.0219, 'lps'),
	(355321, 102, '2015-01-15 01:11:19.000000', 'consum', 0.0218, 'lps'),
	(355322, 102, '2015-01-15 01:11:20.000000', 'consum', 0.0216, 'lps'),
	(355323, 102, '2015-01-15 01:11:21.000000', 'consum', 0.0217, 'lps'),
	(355324, 102, '2015-01-15 01:11:22.000000', 'consum', 0.0215, 'lps'),
	(355325, 102, '2015-01-15 01:11:23.000000', 'consum', 0.0215, 'lps'),
	(355326, 102, '2015-01-15 01:11:24.000000', 'consum', 0.0211, 'lps'),
	(355327, 102, '2015-01-15 01:11:25.000000', 'consum', 0.0210, 'lps'),
	(355328, 102, '2015-01-15 01:11:26.000000', 'consum', 0.0210, 'lps'),
	(355329, 102, '2015-01-15 01:11:27.000000', 'consum', 0.0218, 'lps'),
	(355330, 102, '2015-01-15 01:11:28.000000', 'consum', 0.0212, 'lps'),
	(355331, 102, '2015-01-15 01:11:29.000000', 'consum', 0.0214, 'lps'),
	(355332, 102, '2015-01-15 01:11:30.000000', 'consum', 0.0216, 'lps'),
	(355333, 102, '2015-01-15 01:11:31.000000', 'consum', 0.0217, 'lps'),
	(355334, 102, '2015-01-15 01:11:32.000000', 'consum', 0.0219, 'lps'),
	(355335, 102, '2015-01-15 01:11:33.000000', 'consum', 0.0215, 'lps'),
	(355336, 102, '2015-01-15 01:11:34.000000', 'consum', 0.0219, 'lps'),
	(355337, 102, '2015-01-15 01:11:35.000000', 'consum', 0.0218, 'lps'),
	(355338, 102, '2015-01-15 01:11:36.000000', 'consum', 0.0213, 'lps'),
	(355339, 102, '2015-01-15 01:11:37.000000', 'consum', 0.0214, 'lps'),
	(355340, 102, '2015-01-15 01:11:38.000000', 'consum', 0.0211, 'lps'),
	(355341, 102, '2015-01-15 01:11:39.000000', 'consum', 0.0211, 'lps'),
	(355342, 102, '2015-01-15 01:11:40.000000', 'consum', 0.0216, 'lps'),
	(355343, 102, '2015-01-15 01:11:41.000000', 'consum', 0.0215, 'lps'),
	(355344, 102, '2015-01-15 01:11:42.000000', 'consum', 0.0218, 'lps'),
	(355345, 102, '2015-01-15 01:11:43.000000', 'consum', 0.0215, 'lps'),
	(355346, 102, '2015-01-15 01:11:44.000000', 'consum', 0.0214, 'lps'),
	(355347, 102, '2015-01-15 01:11:45.000000', 'consum', 0.0212, 'lps'),
	(355348, 102, '2015-01-15 01:11:46.000000', 'consum', 0.0212, 'lps'),
	(355349, 102, '2015-01-15 01:11:47.000000', 'consum', 0.0213, 'lps'),
	(355350, 102, '2015-01-15 01:11:48.000000', 'consum', 0.0210, 'lps'),
	(355351, 102, '2015-01-15 01:11:49.000000', 'consum', 0.0213, 'lps'),
	(355352, 102, '2015-01-15 01:11:50.000000', 'consum', 0.0215, 'lps'),
	(355353, 102, '2015-01-15 01:11:51.000000', 'consum', 0.0217, 'lps'),
	(355354, 102, '2015-01-15 01:11:52.000000', 'consum', 0.0210, 'lps'),
	(355355, 102, '2015-01-15 01:11:53.000000', 'consum', 0.0210, 'lps'),
	(355356, 102, '2015-01-15 01:11:54.000000', 'consum', 0.0211, 'lps'),
	(355357, 102, '2015-01-15 01:11:55.000000', 'consum', 0.0214, 'lps'),
	(355358, 102, '2015-01-15 01:11:56.000000', 'consum', 0.0219, 'lps'),
	(355359, 102, '2015-01-15 01:11:57.000000', 'consum', 0.0211, 'lps'),
	(355360, 102, '2015-01-15 01:11:58.000000', 'consum', 0.0211, 'lps'),
	(355361, 102, '2015-01-15 01:11:59.000000', 'consum', 0.0211, 'lps'),
	(355362, 102, '2015-01-15 01:12:00.000000', 'consum', 0.0212, 'lps'),
	(355363, 102, '2015-01-15 01:12:01.000000', 'consum', 0.0218, 'lps'),
	(355364, 102, '2015-01-15 01:12:02.000000', 'consum', 0.0216, 'lps'),
	(355365, 102, '2015-01-15 01:12:03.000000', 'consum', 0.0217, 'lps'),
	(355366, 102, '2015-01-15 01:12:04.000000', 'consum', 0.0219, 'lps'),
	(355367, 102, '2015-01-15 01:12:05.000000', 'consum', 0.0211, 'lps'),
	(355368, 102, '2015-01-15 01:12:06.000000', 'consum', 0.0210, 'lps'),
	(355369, 102, '2015-01-15 01:12:07.000000', 'consum', 0.0217, 'lps'),
	(355370, 102, '2015-01-15 01:12:08.000000', 'consum', 0.0214, 'lps'),
	(355371, 102, '2015-01-15 01:12:09.000000', 'consum', 0.0211, 'lps'),
	(355372, 102, '2015-01-15 01:12:10.000000', 'consum', 0.0214, 'lps'),
	(355373, 102, '2015-01-15 01:12:11.000000', 'consum', 0.0216, 'lps'),
	(355374, 102, '2015-01-15 01:12:12.000000', 'consum', 0.0219, 'lps'),
	(355375, 102, '2015-01-15 01:12:13.000000', 'consum', 0.0217, 'lps'),
	(355376, 102, '2015-01-15 01:12:14.000000', 'consum', 0.0218, 'lps'),
	(355377, 102, '2015-01-15 01:12:15.000000', 'consum', 0.0219, 'lps'),
	(355378, 102, '2015-01-15 01:12:16.000000', 'consum', 0.0213, 'lps'),
	(355379, 102, '2015-01-15 01:12:17.000000', 'consum', 0.0218, 'lps'),
	(355380, 102, '2015-01-15 01:12:18.000000', 'consum', 0.0212, 'lps'),
	(355381, 102, '2015-01-15 01:12:19.000000', 'consum', 0.0217, 'lps'),
	(355382, 102, '2015-01-15 01:12:20.000000', 'consum', 0.0219, 'lps'),
	(355383, 102, '2015-01-15 01:12:21.000000', 'consum', 0.0213, 'lps'),
	(355384, 102, '2015-01-15 01:12:22.000000', 'consum', 0.0219, 'lps'),
	(355385, 102, '2015-01-15 01:12:23.000000', 'consum', 0.0219, 'lps'),
	(355386, 102, '2015-01-15 01:12:24.000000', 'consum', 0.0216, 'lps'),
	(355387, 102, '2015-01-15 01:12:25.000000', 'consum', 0.0214, 'lps'),
	(355388, 102, '2015-01-15 01:12:26.000000', 'consum', 0.0214, 'lps'),
	(355389, 102, '2015-01-15 01:12:27.000000', 'consum', 0.0217, 'lps'),
	(355390, 102, '2015-01-15 01:12:28.000000', 'consum', 0.0215, 'lps'),
	(355391, 102, '2015-01-15 01:12:29.000000', 'consum', 0.0215, 'lps'),
	(355392, 102, '2015-01-15 01:12:30.000000', 'consum', 0.0211, 'lps'),
	(355393, 102, '2015-01-15 01:12:31.000000', 'consum', 0.0210, 'lps'),
	(355394, 102, '2015-01-15 01:12:32.000000', 'consum', 0.0218, 'lps'),
	(355395, 102, '2015-01-15 01:12:33.000000', 'consum', 0.0211, 'lps'),
	(355396, 102, '2015-01-15 01:12:34.000000', 'consum', 0.0210, 'lps'),
	(355397, 102, '2015-01-15 01:12:35.000000', 'consum', 0.0219, 'lps'),
	(355398, 102, '2015-01-15 01:12:36.000000', 'consum', 0.0215, 'lps'),
	(355399, 102, '2015-01-15 01:12:37.000000', 'consum', 0.0216, 'lps'),
	(355400, 102, '2015-01-15 01:12:38.000000', 'consum', 0.0218, 'lps'),
	(355401, 102, '2015-01-15 01:12:39.000000', 'consum', 0.0214, 'lps'),
	(355402, 102, '2015-01-15 01:12:40.000000', 'consum', 0.0215, 'lps'),
	(355403, 102, '2015-01-15 01:12:41.000000', 'consum', 0.0215, 'lps'),
	(355404, 102, '2015-01-15 01:12:42.000000', 'consum', 0.0218, 'lps'),
	(355405, 102, '2015-01-15 01:12:43.000000', 'consum', 0.0219, 'lps'),
	(355406, 102, '2015-01-15 01:12:44.000000', 'consum', 0.0218, 'lps'),
	(355407, 102, '2015-01-15 01:12:45.000000', 'consum', 0.0216, 'lps'),
	(355408, 102, '2015-01-15 01:12:46.000000', 'consum', 0.0216, 'lps'),
	(355409, 102, '2015-01-15 01:12:47.000000', 'consum', 0.0213, 'lps'),
	(355410, 102, '2015-01-15 01:12:48.000000', 'consum', 0.0216, 'lps'),
	(355411, 102, '2015-01-15 01:12:49.000000', 'consum', 0.0213, 'lps'),
	(355412, 102, '2015-01-15 01:12:50.000000', 'consum', 0.0216, 'lps'),
	(355413, 102, '2015-01-15 01:12:51.000000', 'consum', 0.0211, 'lps'),
	(355414, 102, '2015-01-15 01:12:52.000000', 'consum', 0.0219, 'lps'),
	(355415, 102, '2015-01-15 01:12:53.000000', 'consum', 0.0212, 'lps'),
	(355416, 102, '2015-01-15 01:12:54.000000', 'consum', 0.0214, 'lps'),
	(355417, 102, '2015-01-15 01:12:55.000000', 'consum', 0.0214, 'lps'),
	(355418, 102, '2015-01-15 01:12:56.000000', 'consum', 0.0210, 'lps'),
	(355419, 102, '2015-01-15 01:12:57.000000', 'consum', 0.0217, 'lps'),
	(355420, 102, '2015-01-15 01:12:58.000000', 'consum', 0.0216, 'lps'),
	(355421, 102, '2015-01-15 01:12:59.000000', 'consum', 0.0210, 'lps'),
	(355422, 102, '2015-01-15 01:13:00.000000', 'consum', 0.0212, 'lps'),
	(355423, 102, '2015-01-15 01:13:01.000000', 'consum', 0.0219, 'lps'),
	(355424, 102, '2015-01-15 01:13:02.000000', 'consum', 0.0210, 'lps'),
	(355425, 102, '2015-01-15 01:13:03.000000', 'consum', 0.0215, 'lps'),
	(355426, 102, '2015-01-15 01:13:04.000000', 'consum', 0.0216, 'lps'),
	(355427, 102, '2015-01-15 01:13:05.000000', 'consum', 0.0213, 'lps'),
	(355428, 102, '2015-01-15 01:13:06.000000', 'consum', 0.0217, 'lps'),
	(355429, 102, '2015-01-15 01:13:07.000000', 'consum', 0.0216, 'lps'),
	(355430, 102, '2015-01-15 01:13:08.000000', 'consum', 0.0212, 'lps'),
	(355431, 102, '2015-01-15 01:13:09.000000', 'consum', 0.0213, 'lps'),
	(355432, 123, '2015-01-15 00:00:00.000000', 'consum', 0.0214, 'lps'),
	(355433, 123, '2015-01-15 00:00:01.000000', 'consum', 0.0219, 'lps'),
	(355434, 123, '2015-01-15 00:00:02.000000', 'consum', 0.0221, 'lps'),
	(355435, 123, '2015-01-15 00:00:03.000000', 'consum', 0.0215, 'lps'),
	(355436, 123, '2015-01-15 00:00:04.000000', 'consum', 0.0212, 'lps'),
	(355437, 123, '2015-01-15 00:00:05.000000', 'consum', 0.0219, 'lps'),
	(355438, 123, '2015-01-15 00:00:06.000000', 'consum', 0.0215, 'lps'),
	(355439, 123, '2015-01-15 00:00:07.000000', 'consum', 0.0220, 'lps'),
	(355440, 123, '2015-01-15 00:00:08.000000', 'consum', 0.0219, 'lps'),
	(355441, 123, '2015-01-15 00:00:09.000000', 'consum', 0.0215, 'lps'),
	(355442, 123, '2015-01-15 00:00:10.000000', 'consum', 0.0219, 'lps'),
	(355443, 123, '2015-01-15 00:00:11.000000', 'consum', 0.0219, 'lps'),
	(355444, 123, '2015-01-15 00:00:12.000000', 'consum', 0.0217, 'lps'),
	(355445, 123, '2015-01-15 00:00:13.000000', 'consum', 0.0219, 'lps'),
	(355446, 123, '2015-01-15 00:00:14.000000', 'consum', 0.0221, 'lps'),
	(355447, 123, '2015-01-15 00:00:15.000000', 'consum', 0.0214, 'lps'),
	(355448, 123, '2015-01-15 00:00:16.000000', 'consum', 0.0211, 'lps'),
	(355449, 123, '2015-01-15 00:00:17.000000', 'consum', 0.0214, 'lps'),
	(355450, 123, '2015-01-15 00:00:18.000000', 'consum', 0.0215, 'lps'),
	(355451, 123, '2015-01-15 00:00:19.000000', 'consum', 0.0210, 'lps'),
	(355452, 123, '2015-01-15 00:00:20.000000', 'consum', 0.0210, 'lps'),
	(355453, 123, '2015-01-15 00:00:21.000000', 'consum', 0.0211, 'lps'),
	(355454, 123, '2015-01-15 00:00:22.000000', 'consum', 0.0214, 'lps'),
	(355455, 123, '2015-01-15 00:00:23.000000', 'consum', 0.0216, 'lps'),
	(355456, 123, '2015-01-15 00:00:24.000000', 'consum', 0.0215, 'lps'),
	(355457, 123, '2015-01-15 00:00:25.000000', 'consum', 0.0217, 'lps'),
	(355458, 123, '2015-01-15 00:00:26.000000', 'consum', 0.0221, 'lps'),
	(355459, 123, '2015-01-15 00:00:27.000000', 'consum', 0.0219, 'lps'),
	(355460, 123, '2015-01-15 00:00:28.000000', 'consum', 0.0211, 'lps'),
	(355461, 123, '2015-01-15 00:00:29.000000', 'consum', 0.0214, 'lps'),
	(355462, 123, '2015-01-15 00:00:30.000000', 'consum', 0.0214, 'lps'),
	(355463, 123, '2015-01-15 00:00:31.000000', 'consum', 0.0219, 'lps'),
	(355464, 123, '2015-01-15 00:00:32.000000', 'consum', 0.0220, 'lps'),
	(355465, 123, '2015-01-15 00:00:33.000000', 'consum', 0.0220, 'lps'),
	(355466, 123, '2015-01-15 00:00:34.000000', 'consum', 0.0218, 'lps'),
	(355467, 123, '2015-01-15 00:00:35.000000', 'consum', 0.0210, 'lps'),
	(355468, 123, '2015-01-15 00:00:36.000000', 'consum', 0.0221, 'lps'),
	(355469, 123, '2015-01-15 00:00:37.000000', 'consum', 0.0218, 'lps'),
	(355470, 123, '2015-01-15 00:00:38.000000', 'consum', 0.0217, 'lps'),
	(355471, 123, '2015-01-15 00:00:39.000000', 'consum', 0.0221, 'lps'),
	(355472, 123, '2015-01-15 00:00:40.000000', 'consum', 0.0211, 'lps'),
	(355473, 123, '2015-01-15 00:00:41.000000', 'consum', 0.0217, 'lps'),
	(355474, 123, '2015-01-15 00:00:42.000000', 'consum', 0.0219, 'lps'),
	(355475, 123, '2015-01-15 00:00:43.000000', 'consum', 0.0221, 'lps'),
	(355476, 123, '2015-01-15 00:00:44.000000', 'consum', 0.0215, 'lps'),
	(355477, 123, '2015-01-15 00:00:45.000000', 'consum', 0.0215, 'lps'),
	(355478, 123, '2015-01-15 00:00:46.000000', 'consum', 0.0221, 'lps'),
	(355479, 123, '2015-01-15 00:00:47.000000', 'consum', 0.0213, 'lps'),
	(355480, 123, '2015-01-15 00:00:48.000000', 'consum', 0.0219, 'lps'),
	(355481, 123, '2015-01-15 00:00:49.000000', 'consum', 0.0211, 'lps'),
	(355482, 123, '2015-01-15 00:00:50.000000', 'consum', 0.0210, 'lps'),
	(355483, 123, '2015-01-15 00:00:51.000000', 'consum', 0.0221, 'lps'),
	(355484, 123, '2015-01-15 00:00:52.000000', 'consum', 0.0219, 'lps'),
	(355485, 123, '2015-01-15 00:00:53.000000', 'consum', 0.0221, 'lps'),
	(355486, 123, '2015-01-15 00:00:54.000000', 'consum', 0.0216, 'lps'),
	(355487, 123, '2015-01-15 00:00:55.000000', 'consum', 0.0216, 'lps'),
	(355488, 123, '2015-01-15 00:00:56.000000', 'consum', 0.0214, 'lps'),
	(355489, 123, '2015-01-15 00:00:57.000000', 'consum', 0.0211, 'lps'),
	(355490, 123, '2015-01-15 00:00:58.000000', 'consum', 0.0216, 'lps'),
	(355491, 123, '2015-01-15 00:00:59.000000', 'consum', 0.0213, 'lps'),
	(355492, 123, '2015-01-15 00:01:00.000000', 'consum', 0.0220, 'lps'),
	(355493, 123, '2015-01-15 00:01:01.000000', 'consum', 0.0214, 'lps'),
	(355494, 123, '2015-01-15 00:01:02.000000', 'consum', 0.0215, 'lps'),
	(355495, 123, '2015-01-15 00:01:03.000000', 'consum', 0.0211, 'lps'),
	(355496, 123, '2015-01-15 00:01:04.000000', 'consum', 0.0211, 'lps'),
	(355497, 123, '2015-01-15 00:01:05.000000', 'consum', 0.0214, 'lps'),
	(355498, 123, '2015-01-15 00:01:06.000000', 'consum', 0.0213, 'lps'),
	(355499, 123, '2015-01-15 00:01:07.000000', 'consum', 0.0214, 'lps'),
	(355500, 123, '2015-01-15 00:01:08.000000', 'consum', 0.0211, 'lps'),
	(355501, 123, '2015-01-15 00:01:09.000000', 'consum', 0.0215, 'lps'),
	(355502, 123, '2015-01-15 00:01:10.000000', 'consum', 0.0211, 'lps'),
	(355503, 123, '2015-01-15 00:01:11.000000', 'consum', 0.0221, 'lps'),
	(355504, 123, '2015-01-15 00:01:12.000000', 'consum', 0.0214, 'lps'),
	(355505, 123, '2015-01-15 00:01:13.000000', 'consum', 0.0212, 'lps'),
	(355506, 123, '2015-01-15 00:01:14.000000', 'consum', 0.0220, 'lps'),
	(355507, 123, '2015-01-15 00:01:15.000000', 'consum', 0.0219, 'lps'),
	(355508, 123, '2015-01-15 00:01:16.000000', 'consum', 0.0212, 'lps'),
	(355509, 123, '2015-01-15 00:01:17.000000', 'consum', 0.0219, 'lps'),
	(355510, 123, '2015-01-15 00:01:18.000000', 'consum', 0.0214, 'lps'),
	(355511, 123, '2015-01-15 00:01:19.000000', 'consum', 0.0216, 'lps'),
	(355512, 123, '2015-01-15 00:01:20.000000', 'consum', 0.0214, 'lps'),
	(355513, 123, '2015-01-15 00:01:21.000000', 'consum', 0.0212, 'lps'),
	(355514, 123, '2015-01-15 00:01:22.000000', 'consum', 0.0221, 'lps'),
	(355515, 123, '2015-01-15 00:01:23.000000', 'consum', 0.0214, 'lps'),
	(355516, 123, '2015-01-15 00:01:24.000000', 'consum', 0.0218, 'lps'),
	(355517, 123, '2015-01-15 00:01:25.000000', 'consum', 0.0217, 'lps'),
	(355518, 123, '2015-01-15 00:01:26.000000', 'consum', 0.0221, 'lps'),
	(355519, 123, '2015-01-15 00:01:27.000000', 'consum', 0.0210, 'lps'),
	(355520, 123, '2015-01-15 00:01:28.000000', 'consum', 0.0212, 'lps'),
	(355521, 123, '2015-01-15 00:01:29.000000', 'consum', 0.0220, 'lps'),
	(355522, 123, '2015-01-15 00:01:30.000000', 'consum', 0.0219, 'lps'),
	(355523, 123, '2015-01-15 00:01:31.000000', 'consum', 0.0214, 'lps'),
	(355524, 123, '2015-01-15 00:01:32.000000', 'consum', 0.0214, 'lps'),
	(355525, 123, '2015-01-15 00:01:33.000000', 'consum', 0.0217, 'lps'),
	(355526, 123, '2015-01-15 00:01:34.000000', 'consum', 0.0212, 'lps'),
	(355527, 123, '2015-01-15 00:01:35.000000', 'consum', 0.0210, 'lps'),
	(355528, 123, '2015-01-15 00:01:36.000000', 'consum', 0.0217, 'lps'),
	(355529, 123, '2015-01-15 00:01:37.000000', 'consum', 0.0211, 'lps'),
	(355530, 123, '2015-01-15 00:01:38.000000', 'consum', 0.0218, 'lps'),
	(355531, 123, '2015-01-15 00:01:39.000000', 'consum', 0.0213, 'lps'),
	(355532, 123, '2015-01-15 00:01:40.000000', 'consum', 0.0210, 'lps'),
	(355533, 123, '2015-01-15 00:01:41.000000', 'consum', 0.0216, 'lps'),
	(355534, 123, '2015-01-15 00:01:42.000000', 'consum', 0.0217, 'lps'),
	(355535, 123, '2015-01-15 00:01:43.000000', 'consum', 0.0216, 'lps'),
	(355536, 123, '2015-01-15 00:01:44.000000', 'consum', 0.0218, 'lps'),
	(355537, 123, '2015-01-15 00:01:45.000000', 'consum', 0.0219, 'lps'),
	(355538, 123, '2015-01-15 00:01:46.000000', 'consum', 0.0220, 'lps'),
	(355539, 123, '2015-01-15 00:01:47.000000', 'consum', 0.0210, 'lps'),
	(355540, 123, '2015-01-15 00:01:48.000000', 'consum', 0.0218, 'lps'),
	(355541, 123, '2015-01-15 00:01:49.000000', 'consum', 0.0214, 'lps'),
	(355542, 123, '2015-01-15 00:01:50.000000', 'consum', 0.0219, 'lps'),
	(355543, 123, '2015-01-15 00:01:51.000000', 'consum', 0.0217, 'lps'),
	(355544, 123, '2015-01-15 00:01:52.000000', 'consum', 0.0219, 'lps'),
	(355545, 123, '2015-01-15 00:01:53.000000', 'consum', 0.0212, 'lps'),
	(355546, 123, '2015-01-15 00:01:54.000000', 'consum', 0.0219, 'lps'),
	(355547, 123, '2015-01-15 00:01:55.000000', 'consum', 0.0211, 'lps'),
	(355548, 123, '2015-01-15 00:01:56.000000', 'consum', 0.0214, 'lps'),
	(355549, 123, '2015-01-15 00:01:57.000000', 'consum', 0.0214, 'lps'),
	(355550, 123, '2015-01-15 00:01:58.000000', 'consum', 0.0220, 'lps'),
	(355551, 123, '2015-01-15 00:01:59.000000', 'consum', 0.0210, 'lps'),
	(355552, 123, '2015-01-15 00:02:00.000000', 'consum', 0.0218, 'lps'),
	(355553, 123, '2015-01-15 00:02:01.000000', 'consum', 0.0216, 'lps'),
	(355554, 123, '2015-01-15 00:02:02.000000', 'consum', 0.0215, 'lps'),
	(355555, 123, '2015-01-15 00:02:03.000000', 'consum', 0.0216, 'lps'),
	(355556, 123, '2015-01-15 00:02:04.000000', 'consum', 0.0214, 'lps'),
	(355557, 123, '2015-01-15 00:02:05.000000', 'consum', 0.0213, 'lps'),
	(355558, 123, '2015-01-15 00:02:06.000000', 'consum', 0.0213, 'lps'),
	(355559, 123, '2015-01-15 00:02:07.000000', 'consum', 0.0216, 'lps'),
	(355560, 123, '2015-01-15 00:02:08.000000', 'consum', 0.0219, 'lps'),
	(355561, 123, '2015-01-15 00:02:09.000000', 'consum', 0.0216, 'lps'),
	(355562, 123, '2015-01-15 00:02:10.000000', 'consum', 0.0213, 'lps'),
	(355563, 123, '2015-01-15 00:02:11.000000', 'consum', 0.0217, 'lps'),
	(355564, 123, '2015-01-15 00:02:12.000000', 'consum', 0.0214, 'lps'),
	(355565, 123, '2015-01-15 00:02:13.000000', 'consum', 0.0220, 'lps'),
	(355566, 123, '2015-01-15 00:02:14.000000', 'consum', 0.0214, 'lps'),
	(355567, 123, '2015-01-15 00:02:15.000000', 'consum', 0.0212, 'lps'),
	(355568, 123, '2015-01-15 00:02:16.000000', 'consum', 0.0220, 'lps'),
	(355569, 123, '2015-01-15 00:02:17.000000', 'consum', 0.0220, 'lps'),
	(355570, 123, '2015-01-15 00:02:18.000000', 'consum', 0.0219, 'lps'),
	(355571, 123, '2015-01-15 00:02:19.000000', 'consum', 0.0212, 'lps'),
	(355572, 123, '2015-01-15 00:02:20.000000', 'consum', 0.0218, 'lps'),
	(355573, 123, '2015-01-15 00:02:21.000000', 'consum', 0.0210, 'lps'),
	(355574, 123, '2015-01-15 00:02:22.000000', 'consum', 0.0219, 'lps'),
	(355575, 123, '2015-01-15 00:02:23.000000', 'consum', 0.0211, 'lps'),
	(355576, 123, '2015-01-15 00:02:24.000000', 'consum', 0.0221, 'lps'),
	(355577, 123, '2015-01-15 00:02:25.000000', 'consum', 0.0216, 'lps'),
	(355578, 123, '2015-01-15 00:02:26.000000', 'consum', 0.0210, 'lps'),
	(355579, 123, '2015-01-15 00:02:27.000000', 'consum', 0.0213, 'lps'),
	(355580, 123, '2015-01-15 00:02:28.000000', 'consum', 0.0213, 'lps'),
	(355581, 123, '2015-01-15 00:02:29.000000', 'consum', 0.0220, 'lps'),
	(355582, 123, '2015-01-15 00:02:30.000000', 'consum', 0.0213, 'lps'),
	(355583, 123, '2015-01-15 00:02:31.000000', 'consum', 0.0219, 'lps'),
	(355584, 123, '2015-01-15 00:02:32.000000', 'consum', 0.0211, 'lps'),
	(355585, 123, '2015-01-15 00:02:33.000000', 'consum', 0.0211, 'lps'),
	(355586, 123, '2015-01-15 00:02:34.000000', 'consum', 0.0214, 'lps'),
	(355587, 123, '2015-01-15 00:02:35.000000', 'consum', 0.0215, 'lps'),
	(355588, 123, '2015-01-15 00:02:36.000000', 'consum', 0.0213, 'lps'),
	(355589, 123, '2015-01-15 00:02:37.000000', 'consum', 0.0221, 'lps'),
	(355590, 123, '2015-01-15 00:02:38.000000', 'consum', 0.0220, 'lps'),
	(355591, 123, '2015-01-15 00:02:39.000000', 'consum', 0.0218, 'lps'),
	(355592, 123, '2015-01-15 00:02:40.000000', 'consum', 0.0220, 'lps'),
	(355593, 123, '2015-01-15 00:02:41.000000', 'consum', 0.0212, 'lps'),
	(355594, 123, '2015-01-15 00:02:42.000000', 'consum', 0.0213, 'lps'),
	(355595, 123, '2015-01-15 00:02:43.000000', 'consum', 0.0210, 'lps'),
	(355596, 123, '2015-01-15 00:02:44.000000', 'consum', 0.0212, 'lps'),
	(355597, 123, '2015-01-15 00:02:45.000000', 'consum', 0.0219, 'lps'),
	(355598, 123, '2015-01-15 00:02:46.000000', 'consum', 0.0216, 'lps'),
	(355599, 123, '2015-01-15 00:02:47.000000', 'consum', 0.0213, 'lps'),
	(355600, 123, '2015-01-15 00:02:48.000000', 'consum', 0.0221, 'lps'),
	(355601, 123, '2015-01-15 00:02:49.000000', 'consum', 0.0217, 'lps'),
	(355602, 123, '2015-01-15 00:02:50.000000', 'consum', 0.0216, 'lps'),
	(355603, 123, '2015-01-15 00:02:51.000000', 'consum', 0.0219, 'lps'),
	(355604, 123, '2015-01-15 00:02:52.000000', 'consum', 0.0213, 'lps'),
	(355605, 123, '2015-01-15 00:02:53.000000', 'consum', 0.0221, 'lps'),
	(355606, 123, '2015-01-15 00:02:54.000000', 'consum', 0.0211, 'lps'),
	(355607, 123, '2015-01-15 00:02:55.000000', 'consum', 0.0216, 'lps'),
	(355608, 123, '2015-01-15 00:02:56.000000', 'consum', 0.0216, 'lps'),
	(355609, 123, '2015-01-15 00:02:57.000000', 'consum', 0.0220, 'lps'),
	(355610, 123, '2015-01-15 00:02:58.000000', 'consum', 0.0218, 'lps'),
	(355611, 123, '2015-01-15 00:02:59.000000', 'consum', 0.0210, 'lps'),
	(355612, 123, '2015-01-15 00:03:00.000000', 'consum', 0.0220, 'lps'),
	(355613, 123, '2015-01-15 00:03:01.000000', 'consum', 0.0216, 'lps'),
	(355614, 123, '2015-01-15 00:03:02.000000', 'consum', 0.0221, 'lps'),
	(355615, 123, '2015-01-15 00:03:03.000000', 'consum', 0.0213, 'lps'),
	(355616, 123, '2015-01-15 00:03:04.000000', 'consum', 0.0217, 'lps'),
	(355617, 123, '2015-01-15 00:03:05.000000', 'consum', 0.0211, 'lps'),
	(355618, 123, '2015-01-15 00:03:06.000000', 'consum', 0.0219, 'lps'),
	(355619, 123, '2015-01-15 00:03:07.000000', 'consum', 0.0216, 'lps'),
	(355620, 123, '2015-01-15 00:03:08.000000', 'consum', 0.0213, 'lps'),
	(355621, 123, '2015-01-15 00:03:09.000000', 'consum', 0.0219, 'lps'),
	(355622, 123, '2015-01-15 00:03:10.000000', 'consum', 0.0212, 'lps'),
	(355623, 123, '2015-01-15 00:03:11.000000', 'consum', 0.0219, 'lps'),
	(355624, 123, '2015-01-15 00:03:12.000000', 'consum', 0.0212, 'lps'),
	(355625, 123, '2015-01-15 00:03:13.000000', 'consum', 0.0217, 'lps'),
	(355626, 123, '2015-01-15 00:03:14.000000', 'consum', 0.0216, 'lps'),
	(355627, 123, '2015-01-15 00:03:15.000000', 'consum', 0.0218, 'lps'),
	(355628, 123, '2015-01-15 00:03:16.000000', 'consum', 0.0220, 'lps'),
	(355629, 123, '2015-01-15 00:03:17.000000', 'consum', 0.0212, 'lps'),
	(355630, 123, '2015-01-15 00:03:18.000000', 'consum', 0.0215, 'lps'),
	(355631, 123, '2015-01-15 00:03:19.000000', 'consum', 0.0216, 'lps'),
	(355632, 123, '2015-01-15 00:03:20.000000', 'consum', 0.0216, 'lps'),
	(355633, 123, '2015-01-15 00:03:21.000000', 'consum', 0.0220, 'lps'),
	(355634, 123, '2015-01-15 00:03:22.000000', 'consum', 0.0220, 'lps'),
	(355635, 123, '2015-01-15 00:03:23.000000', 'consum', 0.0218, 'lps'),
	(355636, 123, '2015-01-15 00:03:24.000000', 'consum', 0.0210, 'lps'),
	(355637, 123, '2015-01-15 00:03:25.000000', 'consum', 0.0211, 'lps'),
	(355638, 123, '2015-01-15 00:03:26.000000', 'consum', 0.0214, 'lps'),
	(355639, 123, '2015-01-15 00:03:27.000000', 'consum', 0.0216, 'lps'),
	(355640, 123, '2015-01-15 00:03:28.000000', 'consum', 0.0215, 'lps'),
	(355641, 123, '2015-01-15 00:03:29.000000', 'consum', 0.0220, 'lps'),
	(355642, 123, '2015-01-15 00:03:30.000000', 'consum', 0.0210, 'lps'),
	(355643, 123, '2015-01-15 00:03:31.000000', 'consum', 0.0218, 'lps'),
	(355644, 123, '2015-01-15 00:03:32.000000', 'consum', 0.0211, 'lps'),
	(355645, 123, '2015-01-15 00:03:33.000000', 'consum', 0.0216, 'lps'),
	(355646, 123, '2015-01-15 00:03:34.000000', 'consum', 0.0213, 'lps'),
	(355647, 123, '2015-01-15 00:03:35.000000', 'consum', 0.0219, 'lps'),
	(355648, 123, '2015-01-15 00:03:36.000000', 'consum', 0.0213, 'lps'),
	(355649, 123, '2015-01-15 00:03:37.000000', 'consum', 0.0219, 'lps'),
	(355650, 123, '2015-01-15 00:03:38.000000', 'consum', 0.0214, 'lps'),
	(355651, 123, '2015-01-15 00:03:39.000000', 'consum', 0.0214, 'lps'),
	(355652, 123, '2015-01-15 00:03:40.000000', 'consum', 0.0219, 'lps'),
	(355653, 123, '2015-01-15 00:03:41.000000', 'consum', 0.0217, 'lps'),
	(355654, 123, '2015-01-15 00:03:42.000000', 'consum', 0.0221, 'lps'),
	(355655, 123, '2015-01-15 00:03:43.000000', 'consum', 0.0221, 'lps'),
	(355656, 123, '2015-01-15 00:03:44.000000', 'consum', 0.0218, 'lps'),
	(355657, 123, '2015-01-15 00:03:45.000000', 'consum', 0.0220, 'lps'),
	(355658, 123, '2015-01-15 00:03:46.000000', 'consum', 0.0210, 'lps'),
	(355659, 123, '2015-01-15 00:03:47.000000', 'consum', 0.0219, 'lps'),
	(355660, 123, '2015-01-15 00:03:48.000000', 'consum', 0.0218, 'lps'),
	(355661, 123, '2015-01-15 00:03:49.000000', 'consum', 0.0210, 'lps'),
	(355662, 123, '2015-01-15 00:03:50.000000', 'consum', 0.0214, 'lps'),
	(355663, 123, '2015-01-15 00:03:51.000000', 'consum', 0.0216, 'lps'),
	(355664, 123, '2015-01-15 00:03:52.000000', 'consum', 0.0217, 'lps'),
	(355665, 123, '2015-01-15 00:03:53.000000', 'consum', 0.0216, 'lps'),
	(355666, 123, '2015-01-15 00:03:54.000000', 'consum', 0.0220, 'lps'),
	(355667, 123, '2015-01-15 00:03:55.000000', 'consum', 0.0219, 'lps'),
	(355668, 123, '2015-01-15 00:03:56.000000', 'consum', 0.0212, 'lps'),
	(355669, 123, '2015-01-15 00:03:57.000000', 'consum', 0.0220, 'lps'),
	(355670, 123, '2015-01-15 00:03:58.000000', 'consum', 0.0217, 'lps'),
	(355671, 123, '2015-01-15 00:03:59.000000', 'consum', 0.0217, 'lps'),
	(355672, 123, '2015-01-15 00:04:00.000000', 'consum', 0.0211, 'lps'),
	(355673, 123, '2015-01-15 00:04:01.000000', 'consum', 0.0220, 'lps'),
	(355674, 123, '2015-01-15 00:04:02.000000', 'consum', 0.0221, 'lps'),
	(355675, 123, '2015-01-15 00:04:03.000000', 'consum', 0.0211, 'lps'),
	(355676, 123, '2015-01-15 00:04:04.000000', 'consum', 0.0221, 'lps'),
	(355677, 123, '2015-01-15 00:04:05.000000', 'consum', 0.0212, 'lps'),
	(355678, 123, '2015-01-15 00:04:06.000000', 'consum', 0.0211, 'lps'),
	(355679, 123, '2015-01-15 00:04:07.000000', 'consum', 0.0221, 'lps'),
	(355680, 123, '2015-01-15 00:04:08.000000', 'consum', 0.0213, 'lps'),
	(355681, 123, '2015-01-15 00:04:09.000000', 'consum', 0.0220, 'lps'),
	(355682, 123, '2015-01-15 00:04:10.000000', 'consum', 0.0215, 'lps'),
	(355683, 123, '2015-01-15 00:04:11.000000', 'consum', 0.0216, 'lps'),
	(355684, 123, '2015-01-15 00:04:12.000000', 'consum', 0.0213, 'lps'),
	(355685, 123, '2015-01-15 00:04:13.000000', 'consum', 0.0210, 'lps'),
	(355686, 123, '2015-01-15 00:04:14.000000', 'consum', 0.0213, 'lps'),
	(355687, 123, '2015-01-15 00:04:15.000000', 'consum', 0.0213, 'lps'),
	(355688, 123, '2015-01-15 00:04:16.000000', 'consum', 0.0218, 'lps'),
	(355689, 123, '2015-01-15 00:04:17.000000', 'consum', 0.0217, 'lps'),
	(355690, 123, '2015-01-15 00:04:18.000000', 'consum', 0.0220, 'lps'),
	(355691, 123, '2015-01-15 00:04:19.000000', 'consum', 0.0215, 'lps'),
	(355692, 123, '2015-01-15 00:04:20.000000', 'consum', 0.0220, 'lps'),
	(355693, 123, '2015-01-15 00:04:21.000000', 'consum', 0.0219, 'lps'),
	(355694, 123, '2015-01-15 00:04:22.000000', 'consum', 0.0216, 'lps'),
	(355695, 123, '2015-01-15 00:04:23.000000', 'consum', 0.0214, 'lps'),
	(355696, 123, '2015-01-15 00:04:24.000000', 'consum', 0.0212, 'lps'),
	(355697, 123, '2015-01-15 00:04:25.000000', 'consum', 0.0221, 'lps'),
	(355698, 123, '2015-01-15 00:04:26.000000', 'consum', 0.0213, 'lps'),
	(355699, 123, '2015-01-15 00:04:27.000000', 'consum', 0.0215, 'lps'),
	(355700, 123, '2015-01-15 00:04:28.000000', 'consum', 0.0212, 'lps'),
	(355701, 123, '2015-01-15 00:04:29.000000', 'consum', 0.0221, 'lps'),
	(355702, 123, '2015-01-15 00:04:30.000000', 'consum', 0.0212, 'lps'),
	(355703, 123, '2015-01-15 00:04:31.000000', 'consum', 0.0221, 'lps'),
	(355704, 123, '2015-01-15 00:04:32.000000', 'consum', 0.0214, 'lps'),
	(355705, 123, '2015-01-15 00:04:33.000000', 'consum', 0.0220, 'lps'),
	(355706, 123, '2015-01-15 00:04:34.000000', 'consum', 0.0214, 'lps'),
	(355707, 123, '2015-01-15 00:04:35.000000', 'consum', 0.0211, 'lps'),
	(355708, 123, '2015-01-15 00:04:36.000000', 'consum', 0.0217, 'lps'),
	(355709, 123, '2015-01-15 00:04:37.000000', 'consum', 0.0219, 'lps'),
	(355710, 123, '2015-01-15 00:04:38.000000', 'consum', 0.0211, 'lps'),
	(355711, 123, '2015-01-15 00:04:39.000000', 'consum', 0.0212, 'lps'),
	(355712, 123, '2015-01-15 00:04:40.000000', 'consum', 0.0216, 'lps'),
	(355713, 123, '2015-01-15 00:04:41.000000', 'consum', 0.0211, 'lps'),
	(355714, 123, '2015-01-15 00:04:42.000000', 'consum', 0.0220, 'lps'),
	(355715, 123, '2015-01-15 00:04:43.000000', 'consum', 0.0212, 'lps'),
	(355716, 123, '2015-01-15 00:04:44.000000', 'consum', 0.0212, 'lps'),
	(355717, 123, '2015-01-15 00:04:45.000000', 'consum', 0.0214, 'lps'),
	(355718, 123, '2015-01-15 00:04:46.000000', 'consum', 0.0212, 'lps'),
	(355719, 123, '2015-01-15 00:04:47.000000', 'consum', 0.0211, 'lps'),
	(355720, 123, '2015-01-15 00:04:48.000000', 'consum', 0.0221, 'lps'),
	(355721, 123, '2015-01-15 00:04:49.000000', 'consum', 0.0215, 'lps'),
	(355722, 123, '2015-01-15 00:04:50.000000', 'consum', 0.0215, 'lps'),
	(355723, 123, '2015-01-15 00:04:51.000000', 'consum', 0.0221, 'lps'),
	(355724, 123, '2015-01-15 00:04:52.000000', 'consum', 0.0212, 'lps'),
	(355725, 123, '2015-01-15 00:04:53.000000', 'consum', 0.0212, 'lps'),
	(355726, 123, '2015-01-15 00:04:54.000000', 'consum', 0.0216, 'lps'),
	(355727, 123, '2015-01-15 00:04:55.000000', 'consum', 0.0210, 'lps'),
	(355728, 123, '2015-01-15 00:04:56.000000', 'consum', 0.0217, 'lps'),
	(355729, 123, '2015-01-15 00:04:57.000000', 'consum', 0.0220, 'lps'),
	(355730, 123, '2015-01-15 00:04:58.000000', 'consum', 0.0216, 'lps'),
	(355731, 123, '2015-01-15 00:04:59.000000', 'consum', 0.0221, 'lps'),
	(355732, 123, '2015-01-15 00:05:00.000000', 'consum', 0.0213, 'lps'),
	(355733, 123, '2015-01-15 00:05:01.000000', 'consum', 0.0214, 'lps'),
	(355734, 123, '2015-01-15 00:05:02.000000', 'consum', 0.0213, 'lps'),
	(355735, 123, '2015-01-15 00:05:03.000000', 'consum', 0.0210, 'lps'),
	(355736, 123, '2015-01-15 00:05:04.000000', 'consum', 0.0216, 'lps'),
	(355737, 123, '2015-01-15 00:05:05.000000', 'consum', 0.0216, 'lps'),
	(355738, 123, '2015-01-15 00:05:06.000000', 'consum', 0.0210, 'lps'),
	(355739, 123, '2015-01-15 00:05:07.000000', 'consum', 0.0215, 'lps'),
	(355740, 123, '2015-01-15 00:05:08.000000', 'consum', 0.0213, 'lps'),
	(355741, 123, '2015-01-15 00:05:09.000000', 'consum', 0.0210, 'lps'),
	(355742, 123, '2015-01-15 00:05:10.000000', 'consum', 0.0213, 'lps'),
	(355743, 123, '2015-01-15 00:05:11.000000', 'consum', 0.0212, 'lps'),
	(355744, 123, '2015-01-15 00:05:12.000000', 'consum', 0.0213, 'lps'),
	(355745, 123, '2015-01-15 00:05:13.000000', 'consum', 0.0220, 'lps'),
	(355746, 123, '2015-01-15 00:05:14.000000', 'consum', 0.0217, 'lps'),
	(355747, 123, '2015-01-15 00:05:15.000000', 'consum', 0.0213, 'lps'),
	(355748, 123, '2015-01-15 00:05:16.000000', 'consum', 0.0219, 'lps'),
	(355749, 123, '2015-01-15 00:05:17.000000', 'consum', 0.0210, 'lps'),
	(355750, 123, '2015-01-15 00:05:18.000000', 'consum', 0.0221, 'lps'),
	(355751, 123, '2015-01-15 00:05:19.000000', 'consum', 0.0216, 'lps'),
	(355752, 123, '2015-01-15 00:05:20.000000', 'consum', 0.0220, 'lps'),
	(355753, 123, '2015-01-15 00:05:21.000000', 'consum', 0.0219, 'lps'),
	(355754, 123, '2015-01-15 00:05:22.000000', 'consum', 0.0214, 'lps'),
	(355755, 123, '2015-01-15 00:05:23.000000', 'consum', 0.0214, 'lps'),
	(355756, 123, '2015-01-15 00:05:24.000000', 'consum', 0.0217, 'lps'),
	(355757, 123, '2015-01-15 00:05:25.000000', 'consum', 0.0212, 'lps'),
	(355758, 123, '2015-01-15 00:05:26.000000', 'consum', 0.0211, 'lps'),
	(355759, 123, '2015-01-15 00:05:27.000000', 'consum', 0.0211, 'lps'),
	(355760, 123, '2015-01-15 00:05:28.000000', 'consum', 0.0210, 'lps'),
	(355761, 123, '2015-01-15 00:05:29.000000', 'consum', 0.0220, 'lps'),
	(355762, 123, '2015-01-15 00:05:30.000000', 'consum', 0.0214, 'lps'),
	(355763, 123, '2015-01-15 00:05:31.000000', 'consum', 0.0210, 'lps'),
	(355764, 123, '2015-01-15 00:05:32.000000', 'consum', 0.0211, 'lps'),
	(355765, 123, '2015-01-15 00:05:33.000000', 'consum', 0.0218, 'lps'),
	(355766, 123, '2015-01-15 00:05:34.000000', 'consum', 0.0220, 'lps'),
	(355767, 123, '2015-01-15 00:05:35.000000', 'consum', 0.0215, 'lps'),
	(355768, 123, '2015-01-15 00:05:36.000000', 'consum', 0.0218, 'lps'),
	(355769, 123, '2015-01-15 00:05:37.000000', 'consum', 0.0210, 'lps'),
	(355770, 123, '2015-01-15 00:05:38.000000', 'consum', 0.0210, 'lps'),
	(355771, 123, '2015-01-15 00:05:39.000000', 'consum', 0.0210, 'lps'),
	(355772, 123, '2015-01-15 00:05:40.000000', 'consum', 0.0212, 'lps'),
	(355773, 123, '2015-01-15 00:05:41.000000', 'consum', 0.0220, 'lps'),
	(355774, 123, '2015-01-15 00:05:42.000000', 'consum', 0.0221, 'lps'),
	(355775, 123, '2015-01-15 00:05:43.000000', 'consum', 0.0220, 'lps'),
	(355776, 123, '2015-01-15 00:05:44.000000', 'consum', 0.0218, 'lps'),
	(355777, 123, '2015-01-15 00:05:45.000000', 'consum', 0.0219, 'lps'),
	(355778, 123, '2015-01-15 00:05:46.000000', 'consum', 0.0210, 'lps'),
	(355779, 123, '2015-01-15 00:05:47.000000', 'consum', 0.0218, 'lps'),
	(355780, 123, '2015-01-15 00:05:48.000000', 'consum', 0.0213, 'lps'),
	(355781, 123, '2015-01-15 00:05:49.000000', 'consum', 0.0215, 'lps'),
	(355782, 123, '2015-01-15 00:05:50.000000', 'consum', 0.0215, 'lps'),
	(355783, 123, '2015-01-15 00:05:51.000000', 'consum', 0.0218, 'lps'),
	(355784, 123, '2015-01-15 00:05:52.000000', 'consum', 0.0215, 'lps'),
	(355785, 123, '2015-01-15 00:05:53.000000', 'consum', 0.0220, 'lps'),
	(355786, 123, '2015-01-15 00:05:54.000000', 'consum', 0.0213, 'lps'),
	(355787, 123, '2015-01-15 00:05:55.000000', 'consum', 0.0217, 'lps'),
	(355788, 123, '2015-01-15 00:05:56.000000', 'consum', 0.0215, 'lps'),
	(355789, 123, '2015-01-15 00:05:57.000000', 'consum', 0.0215, 'lps'),
	(355790, 123, '2015-01-15 00:05:58.000000', 'consum', 0.0218, 'lps'),
	(355791, 123, '2015-01-15 00:05:59.000000', 'consum', 0.0214, 'lps'),
	(355792, 123, '2015-01-15 00:06:00.000000', 'consum', 0.0218, 'lps'),
	(355793, 123, '2015-01-15 00:06:01.000000', 'consum', 0.0212, 'lps'),
	(355794, 123, '2015-01-15 00:06:02.000000', 'consum', 0.0210, 'lps'),
	(355795, 123, '2015-01-15 00:06:03.000000', 'consum', 0.0215, 'lps'),
	(355796, 123, '2015-01-15 00:06:04.000000', 'consum', 0.0213, 'lps'),
	(355797, 123, '2015-01-15 00:06:05.000000', 'consum', 0.0212, 'lps'),
	(355798, 123, '2015-01-15 00:06:06.000000', 'consum', 0.0211, 'lps'),
	(355799, 123, '2015-01-15 00:06:07.000000', 'consum', 0.0220, 'lps'),
	(355800, 123, '2015-01-15 00:06:08.000000', 'consum', 0.0221, 'lps'),
	(355801, 123, '2015-01-15 00:06:09.000000', 'consum', 0.0211, 'lps'),
	(355802, 123, '2015-01-15 00:06:10.000000', 'consum', 0.0221, 'lps'),
	(355803, 123, '2015-01-15 00:06:11.000000', 'consum', 0.0213, 'lps'),
	(355804, 123, '2015-01-15 00:06:12.000000', 'consum', 0.0217, 'lps'),
	(355805, 123, '2015-01-15 00:06:13.000000', 'consum', 0.0212, 'lps'),
	(355806, 123, '2015-01-15 00:06:14.000000', 'consum', 0.0212, 'lps'),
	(355807, 123, '2015-01-15 00:06:15.000000', 'consum', 0.0215, 'lps'),
	(355808, 123, '2015-01-15 00:06:16.000000', 'consum', 0.0215, 'lps'),
	(355809, 123, '2015-01-15 00:06:17.000000', 'consum', 0.0210, 'lps'),
	(355810, 123, '2015-01-15 00:06:18.000000', 'consum', 0.0220, 'lps'),
	(355811, 123, '2015-01-15 00:06:19.000000', 'consum', 0.0214, 'lps'),
	(355812, 123, '2015-01-15 00:06:20.000000', 'consum', 0.0211, 'lps'),
	(355813, 123, '2015-01-15 00:06:21.000000', 'consum', 0.0215, 'lps'),
	(355814, 123, '2015-01-15 00:06:22.000000', 'consum', 0.0219, 'lps'),
	(355815, 123, '2015-01-15 00:06:23.000000', 'consum', 0.0219, 'lps'),
	(355816, 123, '2015-01-15 00:06:24.000000', 'consum', 0.0217, 'lps'),
	(355817, 123, '2015-01-15 00:06:25.000000', 'consum', 0.0217, 'lps'),
	(355818, 123, '2015-01-15 00:06:26.000000', 'consum', 0.0215, 'lps'),
	(355819, 123, '2015-01-15 00:06:27.000000', 'consum', 0.0212, 'lps'),
	(355820, 123, '2015-01-15 00:06:28.000000', 'consum', 0.0218, 'lps'),
	(355821, 123, '2015-01-15 00:06:29.000000', 'consum', 0.0210, 'lps'),
	(355822, 123, '2015-01-15 00:06:30.000000', 'consum', 0.0210, 'lps'),
	(355823, 123, '2015-01-15 00:06:31.000000', 'consum', 0.0210, 'lps'),
	(355824, 123, '2015-01-15 00:06:32.000000', 'consum', 0.0221, 'lps'),
	(355825, 123, '2015-01-15 00:06:33.000000', 'consum', 0.0218, 'lps'),
	(355826, 123, '2015-01-15 00:06:34.000000', 'consum', 0.0218, 'lps'),
	(355827, 123, '2015-01-15 00:06:35.000000', 'consum', 0.0213, 'lps'),
	(355828, 123, '2015-01-15 00:06:36.000000', 'consum', 0.0213, 'lps'),
	(355829, 123, '2015-01-15 00:06:37.000000', 'consum', 0.0219, 'lps'),
	(355830, 123, '2015-01-15 00:06:38.000000', 'consum', 0.0211, 'lps'),
	(355831, 123, '2015-01-15 00:06:39.000000', 'consum', 0.0212, 'lps'),
	(355832, 123, '2015-01-15 00:06:40.000000', 'consum', 0.0218, 'lps'),
	(355833, 123, '2015-01-15 00:06:41.000000', 'consum', 0.0218, 'lps'),
	(355834, 123, '2015-01-15 00:06:42.000000', 'consum', 0.0217, 'lps'),
	(355835, 123, '2015-01-15 00:06:43.000000', 'consum', 0.0221, 'lps'),
	(355836, 123, '2015-01-15 00:06:44.000000', 'consum', 0.0221, 'lps'),
	(355837, 123, '2015-01-15 00:06:45.000000', 'consum', 0.0221, 'lps'),
	(355838, 123, '2015-01-15 00:06:46.000000', 'consum', 0.0220, 'lps'),
	(355839, 123, '2015-01-15 00:06:47.000000', 'consum', 0.0217, 'lps'),
	(355840, 123, '2015-01-15 00:06:48.000000', 'consum', 0.0214, 'lps'),
	(355841, 123, '2015-01-15 00:06:49.000000', 'consum', 0.0221, 'lps'),
	(355842, 123, '2015-01-15 00:06:50.000000', 'consum', 0.0219, 'lps'),
	(355843, 123, '2015-01-15 00:06:51.000000', 'consum', 0.0220, 'lps'),
	(355844, 123, '2015-01-15 00:06:52.000000', 'consum', 0.0210, 'lps'),
	(355845, 123, '2015-01-15 00:06:53.000000', 'consum', 0.0217, 'lps'),
	(355846, 123, '2015-01-15 00:06:54.000000', 'consum', 0.0220, 'lps'),
	(355847, 123, '2015-01-15 00:06:55.000000', 'consum', 0.0217, 'lps'),
	(355848, 123, '2015-01-15 00:06:56.000000', 'consum', 0.0217, 'lps'),
	(355849, 123, '2015-01-15 00:06:57.000000', 'consum', 0.0210, 'lps'),
	(355850, 123, '2015-01-15 00:06:58.000000', 'consum', 0.0215, 'lps'),
	(355851, 123, '2015-01-15 00:06:59.000000', 'consum', 0.0221, 'lps'),
	(355852, 123, '2015-01-15 00:07:00.000000', 'consum', 0.0217, 'lps'),
	(355853, 123, '2015-01-15 00:07:01.000000', 'consum', 0.0212, 'lps'),
	(355854, 123, '2015-01-15 00:07:02.000000', 'consum', 0.0211, 'lps'),
	(355855, 123, '2015-01-15 00:07:03.000000', 'consum', 0.0210, 'lps'),
	(355856, 123, '2015-01-15 00:07:04.000000', 'consum', 0.0221, 'lps'),
	(355857, 123, '2015-01-15 00:07:05.000000', 'consum', 0.0215, 'lps'),
	(355858, 123, '2015-01-15 00:07:06.000000', 'consum', 0.0214, 'lps'),
	(355859, 123, '2015-01-15 00:07:07.000000', 'consum', 0.0218, 'lps'),
	(355860, 123, '2015-01-15 00:07:08.000000', 'consum', 0.0215, 'lps'),
	(355861, 123, '2015-01-15 00:07:09.000000', 'consum', 0.0210, 'lps'),
	(355862, 123, '2015-01-15 00:07:10.000000', 'consum', 0.0219, 'lps'),
	(355863, 123, '2015-01-15 00:07:11.000000', 'consum', 0.0220, 'lps'),
	(355864, 123, '2015-01-15 00:07:12.000000', 'consum', 0.0220, 'lps'),
	(355865, 123, '2015-01-15 00:07:13.000000', 'consum', 0.0220, 'lps'),
	(355866, 123, '2015-01-15 00:07:14.000000', 'consum', 0.0220, 'lps'),
	(355867, 123, '2015-01-15 00:07:15.000000', 'consum', 0.0216, 'lps'),
	(355868, 123, '2015-01-15 00:07:16.000000', 'consum', 0.0210, 'lps'),
	(355869, 123, '2015-01-15 00:07:17.000000', 'consum', 0.0217, 'lps'),
	(355870, 123, '2015-01-15 00:07:18.000000', 'consum', 0.0210, 'lps'),
	(355871, 123, '2015-01-15 00:07:19.000000', 'consum', 0.0214, 'lps'),
	(355872, 123, '2015-01-15 00:07:20.000000', 'consum', 0.0219, 'lps'),
	(355873, 123, '2015-01-15 00:07:21.000000', 'consum', 0.0221, 'lps'),
	(355874, 123, '2015-01-15 00:07:22.000000', 'consum', 0.0211, 'lps'),
	(355875, 123, '2015-01-15 00:07:23.000000', 'consum', 0.0221, 'lps'),
	(355876, 123, '2015-01-15 00:07:24.000000', 'consum', 0.0214, 'lps'),
	(355877, 123, '2015-01-15 00:07:25.000000', 'consum', 0.0211, 'lps'),
	(355878, 123, '2015-01-15 00:07:26.000000', 'consum', 0.0213, 'lps'),
	(355879, 123, '2015-01-15 00:07:27.000000', 'consum', 0.0211, 'lps'),
	(355880, 123, '2015-01-15 00:07:28.000000', 'consum', 0.0219, 'lps'),
	(355881, 123, '2015-01-15 00:07:29.000000', 'consum', 0.0218, 'lps'),
	(355882, 123, '2015-01-15 00:07:30.000000', 'consum', 0.0212, 'lps'),
	(355883, 123, '2015-01-15 00:07:31.000000', 'consum', 0.0220, 'lps'),
	(355884, 123, '2015-01-15 00:07:32.000000', 'consum', 0.0219, 'lps'),
	(355885, 123, '2015-01-15 00:07:33.000000', 'consum', 0.0212, 'lps'),
	(355886, 123, '2015-01-15 00:07:34.000000', 'consum', 0.0216, 'lps'),
	(355887, 123, '2015-01-15 00:07:35.000000', 'consum', 0.0212, 'lps'),
	(355888, 123, '2015-01-15 00:07:36.000000', 'consum', 0.0216, 'lps'),
	(355889, 123, '2015-01-15 00:07:37.000000', 'consum', 0.0210, 'lps'),
	(355890, 123, '2015-01-15 00:07:38.000000', 'consum', 0.0216, 'lps'),
	(355891, 123, '2015-01-15 00:07:39.000000', 'consum', 0.0216, 'lps'),
	(355892, 123, '2015-01-15 00:07:40.000000', 'consum', 0.0211, 'lps'),
	(355893, 123, '2015-01-15 00:07:41.000000', 'consum', 0.0221, 'lps'),
	(355894, 123, '2015-01-15 00:07:42.000000', 'consum', 0.0216, 'lps'),
	(355895, 123, '2015-01-15 00:07:43.000000', 'consum', 0.0221, 'lps'),
	(355896, 123, '2015-01-15 00:07:44.000000', 'consum', 0.0220, 'lps'),
	(355897, 123, '2015-01-15 00:07:45.000000', 'consum', 0.0217, 'lps'),
	(355898, 123, '2015-01-15 00:07:46.000000', 'consum', 0.0216, 'lps'),
	(355899, 123, '2015-01-15 00:07:47.000000', 'consum', 0.0221, 'lps'),
	(355900, 123, '2015-01-15 00:07:48.000000', 'consum', 0.0210, 'lps'),
	(355901, 123, '2015-01-15 00:07:49.000000', 'consum', 0.0213, 'lps'),
	(355902, 123, '2015-01-15 00:07:50.000000', 'consum', 0.0212, 'lps'),
	(355903, 123, '2015-01-15 00:07:51.000000', 'consum', 0.0212, 'lps'),
	(355904, 123, '2015-01-15 00:07:52.000000', 'consum', 0.0215, 'lps'),
	(355905, 123, '2015-01-15 00:07:53.000000', 'consum', 0.0217, 'lps'),
	(355906, 123, '2015-01-15 00:07:54.000000', 'consum', 0.0217, 'lps'),
	(355907, 123, '2015-01-15 00:07:55.000000', 'consum', 0.0216, 'lps'),
	(355908, 123, '2015-01-15 00:07:56.000000', 'consum', 0.0217, 'lps'),
	(355909, 123, '2015-01-15 00:07:57.000000', 'consum', 0.0215, 'lps'),
	(355910, 123, '2015-01-15 00:07:58.000000', 'consum', 0.0217, 'lps'),
	(355911, 123, '2015-01-15 00:07:59.000000', 'consum', 0.0217, 'lps'),
	(355912, 123, '2015-01-15 00:08:00.000000', 'consum', 0.0214, 'lps'),
	(355913, 123, '2015-01-15 00:08:01.000000', 'consum', 0.0220, 'lps'),
	(355914, 123, '2015-01-15 00:08:02.000000', 'consum', 0.0214, 'lps'),
	(355915, 123, '2015-01-15 00:08:03.000000', 'consum', 0.0213, 'lps'),
	(355916, 123, '2015-01-15 00:08:04.000000', 'consum', 0.0211, 'lps'),
	(355917, 123, '2015-01-15 00:08:05.000000', 'consum', 0.0218, 'lps'),
	(355918, 123, '2015-01-15 00:08:06.000000', 'consum', 0.0211, 'lps'),
	(355919, 123, '2015-01-15 00:08:07.000000', 'consum', 0.0219, 'lps'),
	(355920, 123, '2015-01-15 00:08:08.000000', 'consum', 0.0213, 'lps'),
	(355921, 123, '2015-01-15 00:08:09.000000', 'consum', 0.0212, 'lps'),
	(355922, 123, '2015-01-15 00:08:10.000000', 'consum', 0.0213, 'lps'),
	(355923, 123, '2015-01-15 00:08:11.000000', 'consum', 0.0220, 'lps'),
	(355924, 123, '2015-01-15 00:08:12.000000', 'consum', 0.0214, 'lps'),
	(355925, 123, '2015-01-15 00:08:13.000000', 'consum', 0.0212, 'lps'),
	(355926, 123, '2015-01-15 00:08:14.000000', 'consum', 0.0219, 'lps'),
	(355927, 123, '2015-01-15 00:08:15.000000', 'consum', 0.0216, 'lps'),
	(355928, 123, '2015-01-15 00:08:16.000000', 'consum', 0.0214, 'lps'),
	(355929, 123, '2015-01-15 00:08:17.000000', 'consum', 0.0211, 'lps'),
	(355930, 123, '2015-01-15 00:08:18.000000', 'consum', 0.0215, 'lps'),
	(355931, 123, '2015-01-15 00:08:19.000000', 'consum', 0.0220, 'lps'),
	(355932, 123, '2015-01-15 00:08:20.000000', 'consum', 0.0212, 'lps'),
	(355933, 123, '2015-01-15 00:08:21.000000', 'consum', 0.0214, 'lps'),
	(355934, 123, '2015-01-15 00:08:22.000000', 'consum', 0.0214, 'lps'),
	(355935, 123, '2015-01-15 00:08:23.000000', 'consum', 0.0217, 'lps'),
	(355936, 123, '2015-01-15 00:08:24.000000', 'consum', 0.0221, 'lps'),
	(355937, 123, '2015-01-15 00:08:25.000000', 'consum', 0.0221, 'lps'),
	(355938, 123, '2015-01-15 00:08:26.000000', 'consum', 0.0210, 'lps'),
	(355939, 123, '2015-01-15 00:08:27.000000', 'consum', 0.0213, 'lps'),
	(355940, 123, '2015-01-15 00:08:28.000000', 'consum', 0.0214, 'lps'),
	(355941, 123, '2015-01-15 00:08:29.000000', 'consum', 0.0211, 'lps'),
	(355942, 123, '2015-01-15 00:08:30.000000', 'consum', 0.0213, 'lps'),
	(355943, 123, '2015-01-15 00:08:31.000000', 'consum', 0.0211, 'lps'),
	(355944, 123, '2015-01-15 00:08:32.000000', 'consum', 0.0219, 'lps'),
	(355945, 123, '2015-01-15 00:08:33.000000', 'consum', 0.0217, 'lps'),
	(355946, 123, '2015-01-15 00:08:34.000000', 'consum', 0.0219, 'lps'),
	(355947, 123, '2015-01-15 00:08:35.000000', 'consum', 0.0221, 'lps'),
	(355948, 123, '2015-01-15 00:08:36.000000', 'consum', 0.0213, 'lps'),
	(355949, 123, '2015-01-15 00:08:37.000000', 'consum', 0.0218, 'lps'),
	(355950, 123, '2015-01-15 00:08:38.000000', 'consum', 0.0217, 'lps'),
	(355951, 123, '2015-01-15 00:08:39.000000', 'consum', 0.0212, 'lps'),
	(355952, 123, '2015-01-15 00:08:40.000000', 'consum', 0.0221, 'lps'),
	(355953, 123, '2015-01-15 00:08:41.000000', 'consum', 0.0214, 'lps'),
	(355954, 123, '2015-01-15 00:08:42.000000', 'consum', 0.0221, 'lps'),
	(355955, 123, '2015-01-15 00:08:43.000000', 'consum', 0.0217, 'lps'),
	(355956, 123, '2015-01-15 00:08:44.000000', 'consum', 0.0214, 'lps'),
	(355957, 123, '2015-01-15 00:08:45.000000', 'consum', 0.0219, 'lps'),
	(355958, 123, '2015-01-15 00:08:46.000000', 'consum', 0.0210, 'lps'),
	(355959, 123, '2015-01-15 00:08:47.000000', 'consum', 0.0218, 'lps'),
	(355960, 123, '2015-01-15 00:08:48.000000', 'consum', 0.0216, 'lps'),
	(355961, 123, '2015-01-15 00:08:49.000000', 'consum', 0.0215, 'lps'),
	(355962, 123, '2015-01-15 00:08:50.000000', 'consum', 0.0220, 'lps'),
	(355963, 123, '2015-01-15 00:08:51.000000', 'consum', 0.0219, 'lps'),
	(355964, 123, '2015-01-15 00:08:52.000000', 'consum', 0.0213, 'lps'),
	(355965, 123, '2015-01-15 00:08:53.000000', 'consum', 0.0212, 'lps'),
	(355966, 123, '2015-01-15 00:08:54.000000', 'consum', 0.0210, 'lps'),
	(355967, 123, '2015-01-15 00:08:55.000000', 'consum', 0.0219, 'lps'),
	(355968, 123, '2015-01-15 00:08:56.000000', 'consum', 0.0219, 'lps'),
	(355969, 123, '2015-01-15 00:08:57.000000', 'consum', 0.0216, 'lps'),
	(355970, 123, '2015-01-15 00:08:58.000000', 'consum', 0.0214, 'lps'),
	(355971, 123, '2015-01-15 00:08:59.000000', 'consum', 0.0212, 'lps'),
	(355972, 123, '2015-01-15 00:09:00.000000', 'consum', 0.0220, 'lps'),
	(355973, 123, '2015-01-15 00:09:01.000000', 'consum', 0.0220, 'lps'),
	(355974, 123, '2015-01-15 00:09:02.000000', 'consum', 0.0218, 'lps'),
	(355975, 123, '2015-01-15 00:09:03.000000', 'consum', 0.0220, 'lps'),
	(355976, 123, '2015-01-15 00:09:04.000000', 'consum', 0.0214, 'lps'),
	(355977, 123, '2015-01-15 00:09:05.000000', 'consum', 0.0213, 'lps'),
	(355978, 123, '2015-01-15 00:09:06.000000', 'consum', 0.0214, 'lps'),
	(355979, 123, '2015-01-15 00:09:07.000000', 'consum', 0.0210, 'lps'),
	(355980, 123, '2015-01-15 00:09:08.000000', 'consum', 0.0210, 'lps'),
	(355981, 123, '2015-01-15 00:09:09.000000', 'consum', 0.0210, 'lps'),
	(355982, 123, '2015-01-15 00:09:10.000000', 'consum', 0.0211, 'lps'),
	(355983, 123, '2015-01-15 00:09:11.000000', 'consum', 0.0214, 'lps'),
	(355984, 123, '2015-01-15 00:09:12.000000', 'consum', 0.0217, 'lps'),
	(355985, 123, '2015-01-15 00:09:13.000000', 'consum', 0.0210, 'lps'),
	(355986, 123, '2015-01-15 00:09:14.000000', 'consum', 0.0212, 'lps'),
	(355987, 123, '2015-01-15 00:09:15.000000', 'consum', 0.0219, 'lps'),
	(355988, 123, '2015-01-15 00:09:16.000000', 'consum', 0.0217, 'lps'),
	(355989, 123, '2015-01-15 00:09:17.000000', 'consum', 0.0217, 'lps'),
	(355990, 123, '2015-01-15 00:09:18.000000', 'consum', 0.0213, 'lps'),
	(355991, 123, '2015-01-15 00:09:19.000000', 'consum', 0.0217, 'lps'),
	(355992, 123, '2015-01-15 00:09:20.000000', 'consum', 0.0213, 'lps'),
	(355993, 123, '2015-01-15 00:09:21.000000', 'consum', 0.0215, 'lps'),
	(355994, 123, '2015-01-15 00:09:22.000000', 'consum', 0.0214, 'lps'),
	(355995, 123, '2015-01-15 00:09:23.000000', 'consum', 0.0216, 'lps'),
	(355996, 123, '2015-01-15 00:09:24.000000', 'consum', 0.0215, 'lps'),
	(355997, 123, '2015-01-15 00:09:25.000000', 'consum', 0.0217, 'lps'),
	(355998, 123, '2015-01-15 00:09:26.000000', 'consum', 0.0218, 'lps'),
	(355999, 123, '2015-01-15 00:09:27.000000', 'consum', 0.0218, 'lps'),
	(356000, 123, '2015-01-15 00:09:28.000000', 'consum', 0.0214, 'lps'),
	(356001, 123, '2015-01-15 00:09:29.000000', 'consum', 0.0217, 'lps'),
	(356002, 123, '2015-01-15 00:09:30.000000', 'consum', 0.0211, 'lps'),
	(356003, 123, '2015-01-15 00:09:31.000000', 'consum', 0.0220, 'lps'),
	(356004, 123, '2015-01-15 00:09:32.000000', 'consum', 0.0220, 'lps'),
	(356005, 123, '2015-01-15 00:09:33.000000', 'consum', 0.0219, 'lps'),
	(356006, 123, '2015-01-15 00:09:34.000000', 'consum', 0.0214, 'lps'),
	(356007, 123, '2015-01-15 00:09:35.000000', 'consum', 0.0214, 'lps'),
	(356008, 123, '2015-01-15 00:09:36.000000', 'consum', 0.0219, 'lps'),
	(356009, 123, '2015-01-15 00:09:37.000000', 'consum', 0.0218, 'lps'),
	(356010, 123, '2015-01-15 00:09:38.000000', 'consum', 0.0212, 'lps'),
	(356011, 123, '2015-01-15 00:09:39.000000', 'consum', 0.0219, 'lps'),
	(356012, 123, '2015-01-15 00:09:40.000000', 'consum', 0.0216, 'lps'),
	(356013, 123, '2015-01-15 00:09:41.000000', 'consum', 0.0211, 'lps'),
	(356014, 123, '2015-01-15 00:09:42.000000', 'consum', 0.0212, 'lps'),
	(356015, 123, '2015-01-15 00:09:43.000000', 'consum', 0.0216, 'lps'),
	(356016, 123, '2015-01-15 00:09:44.000000', 'consum', 0.0212, 'lps'),
	(356017, 123, '2015-01-15 00:09:45.000000', 'consum', 0.0214, 'lps'),
	(356018, 123, '2015-01-15 00:09:46.000000', 'consum', 0.0211, 'lps'),
	(356019, 123, '2015-01-15 00:09:47.000000', 'consum', 0.0217, 'lps'),
	(356020, 123, '2015-01-15 00:09:48.000000', 'consum', 0.0218, 'lps'),
	(356021, 123, '2015-01-15 00:09:49.000000', 'consum', 0.0216, 'lps'),
	(356022, 123, '2015-01-15 00:09:50.000000', 'consum', 0.0219, 'lps'),
	(356023, 123, '2015-01-15 00:09:51.000000', 'consum', 0.0212, 'lps'),
	(356024, 123, '2015-01-15 00:09:52.000000', 'consum', 0.0217, 'lps'),
	(356025, 123, '2015-01-15 00:09:53.000000', 'consum', 0.0216, 'lps'),
	(356026, 123, '2015-01-15 00:09:54.000000', 'consum', 0.0210, 'lps'),
	(356027, 123, '2015-01-15 00:09:55.000000', 'consum', 0.0213, 'lps'),
	(356028, 123, '2015-01-15 00:09:56.000000', 'consum', 0.0217, 'lps'),
	(356029, 123, '2015-01-15 00:09:57.000000', 'consum', 0.0210, 'lps'),
	(356030, 123, '2015-01-15 00:09:58.000000', 'consum', 0.0213, 'lps'),
	(356031, 123, '2015-01-15 00:09:59.000000', 'consum', 0.0213, 'lps'),
	(356032, 123, '2015-01-15 00:10:00.000000', 'consum', 0.0217, 'lps'),
	(356033, 123, '2015-01-15 00:10:01.000000', 'consum', 0.0214, 'lps'),
	(356034, 123, '2015-01-15 00:10:02.000000', 'consum', 0.0220, 'lps'),
	(356035, 123, '2015-01-15 00:10:03.000000', 'consum', 0.0211, 'lps'),
	(356036, 123, '2015-01-15 00:10:04.000000', 'consum', 0.0213, 'lps'),
	(356037, 123, '2015-01-15 00:10:05.000000', 'consum', 0.0221, 'lps'),
	(356038, 123, '2015-01-15 00:10:06.000000', 'consum', 0.0219, 'lps'),
	(356039, 123, '2015-01-15 00:10:07.000000', 'consum', 0.0213, 'lps'),
	(356040, 123, '2015-01-15 00:10:08.000000', 'consum', 0.0221, 'lps'),
	(356041, 123, '2015-01-15 00:10:09.000000', 'consum', 0.0220, 'lps'),
	(356042, 123, '2015-01-15 00:10:10.000000', 'consum', 0.0215, 'lps'),
	(356043, 123, '2015-01-15 00:10:11.000000', 'consum', 0.0217, 'lps'),
	(356044, 123, '2015-01-15 00:10:12.000000', 'consum', 0.0218, 'lps'),
	(356045, 123, '2015-01-15 00:10:13.000000', 'consum', 0.0217, 'lps'),
	(356046, 123, '2015-01-15 00:10:14.000000', 'consum', 0.0210, 'lps'),
	(356047, 123, '2015-01-15 00:10:15.000000', 'consum', 0.0214, 'lps'),
	(356048, 123, '2015-01-15 00:10:16.000000', 'consum', 0.0217, 'lps'),
	(356049, 123, '2015-01-15 00:10:17.000000', 'consum', 0.0211, 'lps'),
	(356050, 123, '2015-01-15 00:10:18.000000', 'consum', 0.0218, 'lps'),
	(356051, 123, '2015-01-15 00:10:19.000000', 'consum', 0.0212, 'lps'),
	(356052, 123, '2015-01-15 00:10:20.000000', 'consum', 0.0210, 'lps'),
	(356053, 123, '2015-01-15 00:10:21.000000', 'consum', 0.0215, 'lps'),
	(356054, 123, '2015-01-15 00:10:22.000000', 'consum', 0.0213, 'lps'),
	(356055, 123, '2015-01-15 00:10:23.000000', 'consum', 0.0220, 'lps'),
	(356056, 123, '2015-01-15 00:10:24.000000', 'consum', 0.0216, 'lps'),
	(356057, 123, '2015-01-15 00:10:25.000000', 'consum', 0.0210, 'lps'),
	(356058, 123, '2015-01-15 00:10:26.000000', 'consum', 0.0218, 'lps'),
	(356059, 123, '2015-01-15 00:10:27.000000', 'consum', 0.0214, 'lps'),
	(356060, 123, '2015-01-15 00:10:28.000000', 'consum', 0.0220, 'lps'),
	(356061, 123, '2015-01-15 00:10:29.000000', 'consum', 0.0212, 'lps'),
	(356062, 123, '2015-01-15 00:10:30.000000', 'consum', 0.0216, 'lps'),
	(356063, 123, '2015-01-15 00:10:31.000000', 'consum', 0.0219, 'lps'),
	(356064, 123, '2015-01-15 00:10:32.000000', 'consum', 0.0215, 'lps'),
	(356065, 123, '2015-01-15 00:10:33.000000', 'consum', 0.0210, 'lps'),
	(356066, 123, '2015-01-15 00:10:34.000000', 'consum', 0.0217, 'lps'),
	(356067, 123, '2015-01-15 00:10:35.000000', 'consum', 0.0211, 'lps'),
	(356068, 123, '2015-01-15 00:10:36.000000', 'consum', 0.0219, 'lps'),
	(356069, 123, '2015-01-15 00:10:37.000000', 'consum', 0.0215, 'lps'),
	(356070, 123, '2015-01-15 00:10:38.000000', 'consum', 0.0219, 'lps'),
	(356071, 123, '2015-01-15 00:10:39.000000', 'consum', 0.0220, 'lps'),
	(356072, 123, '2015-01-15 00:10:40.000000', 'consum', 0.0221, 'lps'),
	(356073, 123, '2015-01-15 00:10:41.000000', 'consum', 0.0221, 'lps'),
	(356074, 123, '2015-01-15 00:10:42.000000', 'consum', 0.0210, 'lps'),
	(356075, 123, '2015-01-15 00:10:43.000000', 'consum', 0.0215, 'lps'),
	(356076, 123, '2015-01-15 00:10:44.000000', 'consum', 0.0210, 'lps'),
	(356077, 123, '2015-01-15 00:10:45.000000', 'consum', 0.0220, 'lps'),
	(356078, 123, '2015-01-15 00:10:46.000000', 'consum', 0.0213, 'lps'),
	(356079, 123, '2015-01-15 00:10:47.000000', 'consum', 0.0218, 'lps'),
	(356080, 123, '2015-01-15 00:10:48.000000', 'consum', 0.0219, 'lps'),
	(356081, 123, '2015-01-15 00:10:49.000000', 'consum', 0.0220, 'lps'),
	(356082, 123, '2015-01-15 00:10:50.000000', 'consum', 0.0220, 'lps'),
	(356083, 123, '2015-01-15 00:10:51.000000', 'consum', 0.0218, 'lps'),
	(356084, 123, '2015-01-15 00:10:52.000000', 'consum', 0.0221, 'lps'),
	(356085, 123, '2015-01-15 00:10:53.000000', 'consum', 0.0216, 'lps'),
	(356086, 123, '2015-01-15 00:10:54.000000', 'consum', 0.0221, 'lps'),
	(356087, 123, '2015-01-15 00:10:55.000000', 'consum', 0.0213, 'lps'),
	(356088, 123, '2015-01-15 00:10:56.000000', 'consum', 0.0216, 'lps'),
	(356089, 123, '2015-01-15 00:10:57.000000', 'consum', 0.0218, 'lps'),
	(356090, 123, '2015-01-15 00:10:58.000000', 'consum', 0.0219, 'lps'),
	(356091, 123, '2015-01-15 00:10:59.000000', 'consum', 0.0211, 'lps'),
	(356092, 123, '2015-01-15 00:11:00.000000', 'consum', 0.0211, 'lps'),
	(356093, 123, '2015-01-15 00:11:01.000000', 'consum', 0.0214, 'lps'),
	(356094, 123, '2015-01-15 00:11:02.000000', 'consum', 0.0216, 'lps'),
	(356095, 123, '2015-01-15 00:11:03.000000', 'consum', 0.0216, 'lps'),
	(356096, 123, '2015-01-15 00:11:04.000000', 'consum', 0.0210, 'lps'),
	(356097, 123, '2015-01-15 00:11:05.000000', 'consum', 0.0216, 'lps'),
	(356098, 123, '2015-01-15 00:11:06.000000', 'consum', 0.0217, 'lps'),
	(356099, 123, '2015-01-15 00:11:07.000000', 'consum', 0.0216, 'lps'),
	(356100, 123, '2015-01-15 00:11:08.000000', 'consum', 0.0218, 'lps'),
	(356101, 123, '2015-01-15 00:11:09.000000', 'consum', 0.0221, 'lps'),
	(356102, 123, '2015-01-15 00:11:10.000000', 'consum', 0.0219, 'lps'),
	(356103, 123, '2015-01-15 00:11:11.000000', 'consum', 0.0211, 'lps'),
	(356104, 123, '2015-01-15 00:11:12.000000', 'consum', 0.0210, 'lps'),
	(356105, 123, '2015-01-15 00:11:13.000000', 'consum', 0.0221, 'lps'),
	(356106, 123, '2015-01-15 00:11:14.000000', 'consum', 0.0217, 'lps'),
	(356107, 123, '2015-01-15 00:11:15.000000', 'consum', 0.0212, 'lps'),
	(356108, 123, '2015-01-15 00:11:16.000000', 'consum', 0.0213, 'lps'),
	(356109, 123, '2015-01-15 00:11:17.000000', 'consum', 0.0217, 'lps'),
	(356110, 123, '2015-01-15 00:11:18.000000', 'consum', 0.0212, 'lps'),
	(356111, 123, '2015-01-15 00:11:19.000000', 'consum', 0.0215, 'lps'),
	(356112, 123, '2015-01-15 00:11:20.000000', 'consum', 0.0215, 'lps'),
	(356113, 123, '2015-01-15 00:11:21.000000', 'consum', 0.0221, 'lps'),
	(356114, 123, '2015-01-15 00:11:22.000000', 'consum', 0.0213, 'lps'),
	(356115, 123, '2015-01-15 00:11:23.000000', 'consum', 0.0219, 'lps'),
	(356116, 123, '2015-01-15 00:11:24.000000', 'consum', 0.0212, 'lps'),
	(356117, 123, '2015-01-15 00:11:25.000000', 'consum', 0.0214, 'lps'),
	(356118, 123, '2015-01-15 00:11:26.000000', 'consum', 0.0213, 'lps'),
	(356119, 123, '2015-01-15 00:11:27.000000', 'consum', 0.0215, 'lps'),
	(356120, 123, '2015-01-15 00:11:28.000000', 'consum', 0.0213, 'lps'),
	(356121, 123, '2015-01-15 00:11:29.000000', 'consum', 0.0211, 'lps'),
	(356122, 123, '2015-01-15 00:11:30.000000', 'consum', 0.0219, 'lps'),
	(356123, 123, '2015-01-15 00:11:31.000000', 'consum', 0.0218, 'lps'),
	(356124, 123, '2015-01-15 00:11:32.000000', 'consum', 0.0210, 'lps'),
	(356125, 123, '2015-01-15 00:11:33.000000', 'consum', 0.0210, 'lps'),
	(356126, 123, '2015-01-15 00:11:34.000000', 'consum', 0.0211, 'lps'),
	(356127, 123, '2015-01-15 00:11:35.000000', 'consum', 0.0217, 'lps'),
	(356128, 123, '2015-01-15 00:11:36.000000', 'consum', 0.0217, 'lps'),
	(356129, 123, '2015-01-15 00:11:37.000000', 'consum', 0.0211, 'lps'),
	(356130, 123, '2015-01-15 00:11:38.000000', 'consum', 0.0220, 'lps'),
	(356131, 123, '2015-01-15 00:11:39.000000', 'consum', 0.0221, 'lps'),
	(356132, 123, '2015-01-15 00:11:40.000000', 'consum', 0.0213, 'lps'),
	(356133, 123, '2015-01-15 00:11:41.000000', 'consum', 0.0214, 'lps'),
	(356134, 123, '2015-01-15 00:11:42.000000', 'consum', 0.0210, 'lps'),
	(356135, 123, '2015-01-15 00:11:43.000000', 'consum', 0.0210, 'lps'),
	(356136, 123, '2015-01-15 00:11:44.000000', 'consum', 0.0211, 'lps'),
	(356137, 123, '2015-01-15 00:11:45.000000', 'consum', 0.0215, 'lps'),
	(356138, 123, '2015-01-15 00:11:46.000000', 'consum', 0.0210, 'lps'),
	(356139, 123, '2015-01-15 00:11:47.000000', 'consum', 0.0218, 'lps'),
	(356140, 123, '2015-01-15 00:11:48.000000', 'consum', 0.0213, 'lps'),
	(356141, 123, '2015-01-15 00:11:49.000000', 'consum', 0.0216, 'lps'),
	(356142, 123, '2015-01-15 00:11:50.000000', 'consum', 0.0217, 'lps'),
	(356143, 123, '2015-01-15 00:11:51.000000', 'consum', 0.0216, 'lps'),
	(356144, 123, '2015-01-15 00:11:52.000000', 'consum', 0.0221, 'lps'),
	(356145, 123, '2015-01-15 00:11:53.000000', 'consum', 0.0210, 'lps'),
	(356146, 123, '2015-01-15 00:11:54.000000', 'consum', 0.0213, 'lps'),
	(356147, 123, '2015-01-15 00:11:55.000000', 'consum', 0.0213, 'lps'),
	(356148, 123, '2015-01-15 00:11:56.000000', 'consum', 0.0218, 'lps'),
	(356149, 123, '2015-01-15 00:11:57.000000', 'consum', 0.0218, 'lps'),
	(356150, 123, '2015-01-15 00:11:58.000000', 'consum', 0.0215, 'lps'),
	(356151, 123, '2015-01-15 00:11:59.000000', 'consum', 0.0212, 'lps'),
	(356152, 123, '2015-01-15 00:12:00.000000', 'consum', 0.0217, 'lps'),
	(356153, 123, '2015-01-15 00:12:01.000000', 'consum', 0.0216, 'lps'),
	(356154, 123, '2015-01-15 00:12:02.000000', 'consum', 0.0221, 'lps'),
	(356155, 123, '2015-01-15 00:12:03.000000', 'consum', 0.0210, 'lps'),
	(356156, 123, '2015-01-15 00:12:04.000000', 'consum', 0.0212, 'lps'),
	(356157, 123, '2015-01-15 00:12:05.000000', 'consum', 0.0220, 'lps'),
	(356158, 123, '2015-01-15 00:12:06.000000', 'consum', 0.0219, 'lps'),
	(356159, 123, '2015-01-15 00:12:07.000000', 'consum', 0.0215, 'lps'),
	(356160, 123, '2015-01-15 00:12:08.000000', 'consum', 0.0221, 'lps'),
	(356161, 123, '2015-01-15 00:12:09.000000', 'consum', 0.0215, 'lps'),
	(356162, 123, '2015-01-15 00:12:10.000000', 'consum', 0.0213, 'lps'),
	(356163, 123, '2015-01-15 00:12:11.000000', 'consum', 0.0210, 'lps'),
	(356164, 123, '2015-01-15 00:12:12.000000', 'consum', 0.0213, 'lps'),
	(356165, 123, '2015-01-15 00:12:13.000000', 'consum', 0.0216, 'lps'),
	(356166, 123, '2015-01-15 00:12:14.000000', 'consum', 0.0216, 'lps'),
	(356167, 123, '2015-01-15 00:12:15.000000', 'consum', 0.0214, 'lps'),
	(356168, 123, '2015-01-15 00:12:16.000000', 'consum', 0.0211, 'lps'),
	(356169, 123, '2015-01-15 00:12:17.000000', 'consum', 0.0216, 'lps'),
	(356170, 123, '2015-01-15 00:12:18.000000', 'consum', 0.0214, 'lps'),
	(356171, 123, '2015-01-15 00:12:19.000000', 'consum', 0.0210, 'lps'),
	(356172, 123, '2015-01-15 00:12:20.000000', 'consum', 0.0213, 'lps'),
	(356173, 123, '2015-01-15 00:12:21.000000', 'consum', 0.0211, 'lps'),
	(356174, 123, '2015-01-15 00:12:22.000000', 'consum', 0.0221, 'lps'),
	(356175, 123, '2015-01-15 00:12:23.000000', 'consum', 0.0211, 'lps'),
	(356176, 123, '2015-01-15 00:12:24.000000', 'consum', 0.0210, 'lps'),
	(356177, 123, '2015-01-15 00:12:25.000000', 'consum', 0.0219, 'lps'),
	(356178, 123, '2015-01-15 00:12:26.000000', 'consum', 0.0221, 'lps'),
	(356179, 123, '2015-01-15 00:12:27.000000', 'consum', 0.0212, 'lps'),
	(356180, 123, '2015-01-15 00:12:28.000000', 'consum', 0.0213, 'lps'),
	(356181, 123, '2015-01-15 00:12:29.000000', 'consum', 0.0220, 'lps'),
	(356182, 123, '2015-01-15 00:12:30.000000', 'consum', 0.0215, 'lps'),
	(356183, 123, '2015-01-15 00:12:31.000000', 'consum', 0.0218, 'lps'),
	(356184, 123, '2015-01-15 00:12:32.000000', 'consum', 0.0213, 'lps'),
	(356185, 123, '2015-01-15 00:12:33.000000', 'consum', 0.0210, 'lps'),
	(356186, 123, '2015-01-15 00:12:34.000000', 'consum', 0.0217, 'lps'),
	(356187, 123, '2015-01-15 00:12:35.000000', 'consum', 0.0220, 'lps'),
	(356188, 123, '2015-01-15 00:12:36.000000', 'consum', 0.0217, 'lps'),
	(356189, 123, '2015-01-15 00:12:37.000000', 'consum', 0.0216, 'lps'),
	(356190, 123, '2015-01-15 00:12:38.000000', 'consum', 0.0218, 'lps'),
	(356191, 123, '2015-01-15 00:12:39.000000', 'consum', 0.0220, 'lps'),
	(356192, 123, '2015-01-15 00:12:40.000000', 'consum', 0.0214, 'lps'),
	(356193, 123, '2015-01-15 00:12:41.000000', 'consum', 0.0212, 'lps'),
	(356194, 123, '2015-01-15 00:12:42.000000', 'consum', 0.0220, 'lps'),
	(356195, 123, '2015-01-15 00:12:43.000000', 'consum', 0.0217, 'lps'),
	(356196, 123, '2015-01-15 00:12:44.000000', 'consum', 0.0215, 'lps'),
	(356197, 123, '2015-01-15 00:12:45.000000', 'consum', 0.0217, 'lps'),
	(356198, 123, '2015-01-15 00:12:46.000000', 'consum', 0.0219, 'lps'),
	(356199, 123, '2015-01-15 00:12:47.000000', 'consum', 0.0220, 'lps'),
	(356200, 123, '2015-01-15 00:12:48.000000', 'consum', 0.0210, 'lps'),
	(356201, 123, '2015-01-15 00:12:49.000000', 'consum', 0.0219, 'lps'),
	(356202, 123, '2015-01-15 00:12:50.000000', 'consum', 0.0218, 'lps'),
	(356203, 123, '2015-01-15 00:12:51.000000', 'consum', 0.0212, 'lps'),
	(356204, 123, '2015-01-15 00:12:52.000000', 'consum', 0.0219, 'lps'),
	(356205, 123, '2015-01-15 00:12:53.000000', 'consum', 0.0215, 'lps'),
	(356206, 123, '2015-01-15 00:12:54.000000', 'consum', 0.0210, 'lps'),
	(356207, 123, '2015-01-15 00:12:55.000000', 'consum', 0.0217, 'lps'),
	(356208, 123, '2015-01-15 00:12:56.000000', 'consum', 0.0220, 'lps'),
	(356209, 123, '2015-01-15 00:12:57.000000', 'consum', 0.0219, 'lps'),
	(356210, 123, '2015-01-15 00:12:58.000000', 'consum', 0.0211, 'lps'),
	(356211, 123, '2015-01-15 00:12:59.000000', 'consum', 0.0212, 'lps'),
	(356212, 123, '2015-01-15 00:13:00.000000', 'consum', 0.0218, 'lps'),
	(356213, 123, '2015-01-15 00:13:01.000000', 'consum', 0.0210, 'lps'),
	(356214, 123, '2015-01-15 00:13:02.000000', 'consum', 0.0211, 'lps'),
	(356215, 123, '2015-01-15 00:13:03.000000', 'consum', 0.0216, 'lps'),
	(356216, 123, '2015-01-15 00:13:04.000000', 'consum', 0.0211, 'lps'),
	(356217, 123, '2015-01-15 00:13:05.000000', 'consum', 0.0210, 'lps'),
	(356218, 123, '2015-01-15 00:13:06.000000', 'consum', 0.0218, 'lps'),
	(356219, 123, '2015-01-15 00:13:07.000000', 'consum', 0.0215, 'lps'),
	(356220, 123, '2015-01-15 00:13:08.000000', 'consum', 0.0213, 'lps'),
	(356221, 123, '2015-01-15 00:13:09.000000', 'consum', 0.0211, 'lps'),
	(356222, 123, '2015-01-15 00:13:10.000000', 'consum', 0.0218, 'lps'),
	(356223, 123, '2015-01-15 00:13:11.000000', 'consum', 0.0212, 'lps'),
	(356224, 123, '2015-01-15 00:13:12.000000', 'consum', 0.0220, 'lps'),
	(356225, 123, '2015-01-15 00:13:13.000000', 'consum', 0.0219, 'lps'),
	(356226, 123, '2015-01-15 00:13:14.000000', 'consum', 0.0211, 'lps'),
	(356227, 123, '2015-01-15 00:13:15.000000', 'consum', 0.0215, 'lps'),
	(356228, 123, '2015-01-15 00:13:16.000000', 'consum', 0.0219, 'lps'),
	(356229, 123, '2015-01-15 00:13:17.000000', 'consum', 0.0216, 'lps'),
	(356230, 123, '2015-01-15 00:13:18.000000', 'consum', 0.0216, 'lps'),
	(356231, 123, '2015-01-15 00:13:19.000000', 'consum', 0.0220, 'lps'),
	(356232, 123, '2015-01-15 00:13:20.000000', 'consum', 0.0219, 'lps'),
	(356233, 123, '2015-01-15 00:13:21.000000', 'consum', 0.0214, 'lps'),
	(356234, 123, '2015-01-15 00:13:22.000000', 'consum', 0.0215, 'lps'),
	(356235, 123, '2015-01-15 00:13:23.000000', 'consum', 0.0211, 'lps'),
	(356236, 123, '2015-01-15 00:13:24.000000', 'consum', 0.0211, 'lps'),
	(356237, 123, '2015-01-15 00:13:25.000000', 'consum', 0.0214, 'lps'),
	(356238, 123, '2015-01-15 00:13:26.000000', 'consum', 0.0217, 'lps'),
	(356239, 123, '2015-01-15 00:13:27.000000', 'consum', 0.0219, 'lps'),
	(356240, 123, '2015-01-15 00:13:28.000000', 'consum', 0.0211, 'lps'),
	(356241, 123, '2015-01-15 00:13:29.000000', 'consum', 0.0212, 'lps'),
	(356242, 123, '2015-01-15 00:13:30.000000', 'consum', 0.0216, 'lps'),
	(356243, 123, '2015-01-15 00:13:31.000000', 'consum', 0.0213, 'lps'),
	(356244, 123, '2015-01-15 00:13:32.000000', 'consum', 0.0220, 'lps'),
	(356245, 123, '2015-01-15 00:13:33.000000', 'consum', 0.0216, 'lps'),
	(356246, 123, '2015-01-15 00:13:34.000000', 'consum', 0.0210, 'lps'),
	(356247, 123, '2015-01-15 00:13:35.000000', 'consum', 0.0215, 'lps'),
	(356248, 123, '2015-01-15 00:13:36.000000', 'consum', 0.0211, 'lps'),
	(356249, 123, '2015-01-15 00:13:37.000000', 'consum', 0.0215, 'lps'),
	(356250, 123, '2015-01-15 00:13:38.000000', 'consum', 0.0218, 'lps'),
	(356251, 123, '2015-01-15 00:13:39.000000', 'consum', 0.0213, 'lps'),
	(356252, 123, '2015-01-15 00:13:40.000000', 'consum', 0.0212, 'lps'),
	(356253, 123, '2015-01-15 00:13:41.000000', 'consum', 0.0214, 'lps'),
	(356254, 123, '2015-01-15 00:13:42.000000', 'consum', 0.0212, 'lps'),
	(356255, 123, '2015-01-15 00:13:43.000000', 'consum', 0.0219, 'lps'),
	(356256, 123, '2015-01-15 00:13:44.000000', 'consum', 0.0215, 'lps'),
	(356257, 123, '2015-01-15 00:13:45.000000', 'consum', 0.0219, 'lps'),
	(356258, 123, '2015-01-15 00:13:46.000000', 'consum', 0.0216, 'lps'),
	(356259, 123, '2015-01-15 00:13:47.000000', 'consum', 0.0213, 'lps'),
	(356260, 123, '2015-01-15 00:13:48.000000', 'consum', 0.0220, 'lps'),
	(356261, 123, '2015-01-15 00:13:49.000000', 'consum', 0.0216, 'lps'),
	(356262, 123, '2015-01-15 00:13:50.000000', 'consum', 0.0221, 'lps'),
	(356263, 123, '2015-01-15 00:13:51.000000', 'consum', 0.0210, 'lps'),
	(356264, 123, '2015-01-15 00:13:52.000000', 'consum', 0.0217, 'lps'),
	(356265, 123, '2015-01-15 00:13:53.000000', 'consum', 0.0221, 'lps'),
	(356266, 123, '2015-01-15 00:13:54.000000', 'consum', 0.0210, 'lps'),
	(356267, 123, '2015-01-15 00:13:55.000000', 'consum', 0.0210, 'lps'),
	(356268, 123, '2015-01-15 00:13:56.000000', 'consum', 0.0214, 'lps'),
	(356269, 123, '2015-01-15 00:13:57.000000', 'consum', 0.0216, 'lps'),
	(356270, 123, '2015-01-15 00:13:58.000000', 'consum', 0.0218, 'lps'),
	(356271, 123, '2015-01-15 00:13:59.000000', 'consum', 0.0210, 'lps'),
	(356272, 123, '2015-01-15 00:14:00.000000', 'consum', 0.0221, 'lps'),
	(356273, 123, '2015-01-15 00:14:01.000000', 'consum', 0.0216, 'lps'),
	(356274, 123, '2015-01-15 00:14:02.000000', 'consum', 0.0210, 'lps'),
	(356275, 123, '2015-01-15 00:14:03.000000', 'consum', 0.0217, 'lps'),
	(356276, 123, '2015-01-15 00:14:04.000000', 'consum', 0.0210, 'lps'),
	(356277, 123, '2015-01-15 00:14:05.000000', 'consum', 0.0214, 'lps'),
	(356278, 123, '2015-01-15 00:14:06.000000', 'consum', 0.0217, 'lps'),
	(356279, 123, '2015-01-15 00:14:07.000000', 'consum', 0.0210, 'lps'),
	(356280, 123, '2015-01-15 00:14:08.000000', 'consum', 0.0215, 'lps'),
	(356281, 123, '2015-01-15 00:14:09.000000', 'consum', 0.0210, 'lps'),
	(356282, 123, '2015-01-15 00:14:10.000000', 'consum', 0.0218, 'lps'),
	(356283, 123, '2015-01-15 00:14:11.000000', 'consum', 0.0216, 'lps'),
	(356284, 123, '2015-01-15 00:14:12.000000', 'consum', 0.0215, 'lps'),
	(356285, 123, '2015-01-15 00:14:13.000000', 'consum', 0.0217, 'lps'),
	(356286, 123, '2015-01-15 00:14:14.000000', 'consum', 0.0219, 'lps'),
	(356287, 123, '2015-01-15 00:14:15.000000', 'consum', 0.0212, 'lps'),
	(356288, 123, '2015-01-15 00:14:16.000000', 'consum', 0.0216, 'lps'),
	(356289, 123, '2015-01-15 00:14:17.000000', 'consum', 0.0211, 'lps'),
	(356290, 123, '2015-01-15 00:14:18.000000', 'consum', 0.0210, 'lps'),
	(356291, 123, '2015-01-15 00:14:19.000000', 'consum', 0.0220, 'lps'),
	(356292, 123, '2015-01-15 00:14:20.000000', 'consum', 0.0213, 'lps'),
	(356293, 123, '2015-01-15 00:14:21.000000', 'consum', 0.0219, 'lps'),
	(356294, 123, '2015-01-15 00:14:22.000000', 'consum', 0.0210, 'lps'),
	(356295, 123, '2015-01-15 00:14:23.000000', 'consum', 0.0221, 'lps'),
	(356296, 123, '2015-01-15 00:14:24.000000', 'consum', 0.0218, 'lps'),
	(356297, 123, '2015-01-15 00:14:25.000000', 'consum', 0.0216, 'lps'),
	(356298, 123, '2015-01-15 00:14:26.000000', 'consum', 0.0217, 'lps'),
	(356299, 123, '2015-01-15 00:14:27.000000', 'consum', 0.0214, 'lps'),
	(356300, 123, '2015-01-15 00:14:28.000000', 'consum', 0.0211, 'lps'),
	(356301, 123, '2015-01-15 00:14:29.000000', 'consum', 0.0217, 'lps'),
	(356302, 123, '2015-01-15 00:14:30.000000', 'consum', 0.0218, 'lps'),
	(356303, 123, '2015-01-15 00:14:31.000000', 'consum', 0.0215, 'lps'),
	(356304, 123, '2015-01-15 00:14:32.000000', 'consum', 0.0214, 'lps'),
	(356305, 123, '2015-01-15 00:14:33.000000', 'consum', 0.0213, 'lps'),
	(356306, 123, '2015-01-15 00:14:34.000000', 'consum', 0.0215, 'lps'),
	(356307, 123, '2015-01-15 00:14:35.000000', 'consum', 0.0216, 'lps'),
	(356308, 123, '2015-01-15 00:14:36.000000', 'consum', 0.0212, 'lps'),
	(356309, 123, '2015-01-15 00:14:37.000000', 'consum', 0.0213, 'lps'),
	(356310, 123, '2015-01-15 00:14:38.000000', 'consum', 0.0220, 'lps'),
	(356311, 123, '2015-01-15 00:14:39.000000', 'consum', 0.0216, 'lps'),
	(356312, 123, '2015-01-15 00:14:40.000000', 'consum', 0.0211, 'lps'),
	(356313, 123, '2015-01-15 00:14:41.000000', 'consum', 0.0219, 'lps'),
	(356314, 123, '2015-01-15 00:14:42.000000', 'consum', 0.0219, 'lps'),
	(356315, 123, '2015-01-15 00:14:43.000000', 'consum', 0.0214, 'lps'),
	(356316, 123, '2015-01-15 00:14:44.000000', 'consum', 0.0216, 'lps'),
	(356317, 123, '2015-01-15 00:14:45.000000', 'consum', 0.0218, 'lps'),
	(356318, 123, '2015-01-15 00:14:46.000000', 'consum', 0.0221, 'lps'),
	(356319, 123, '2015-01-15 00:14:47.000000', 'consum', 0.0215, 'lps'),
	(356320, 123, '2015-01-15 00:14:48.000000', 'consum', 0.0217, 'lps'),
	(356321, 123, '2015-01-15 00:14:49.000000', 'consum', 0.0219, 'lps'),
	(356322, 123, '2015-01-15 00:14:50.000000', 'consum', 0.0210, 'lps'),
	(356323, 123, '2015-01-15 00:14:51.000000', 'consum', 0.0218, 'lps'),
	(356324, 123, '2015-01-15 00:14:52.000000', 'consum', 0.0217, 'lps'),
	(356325, 123, '2015-01-15 00:14:53.000000', 'consum', 0.0220, 'lps'),
	(356326, 123, '2015-01-15 00:14:54.000000', 'consum', 0.0217, 'lps'),
	(356327, 123, '2015-01-15 00:14:55.000000', 'consum', 0.0215, 'lps'),
	(356328, 123, '2015-01-15 00:14:56.000000', 'consum', 0.0216, 'lps'),
	(356329, 123, '2015-01-15 00:14:57.000000', 'consum', 0.0212, 'lps'),
	(356330, 123, '2015-01-15 00:14:58.000000', 'consum', 0.0215, 'lps'),
	(356331, 123, '2015-01-15 00:14:59.000000', 'consum', 0.0216, 'lps'),
	(356332, 123, '2015-01-15 00:15:00.000000', 'consum', 0.0216, 'lps'),
	(356333, 123, '2015-01-15 00:15:01.000000', 'consum', 0.0211, 'lps'),
	(356334, 123, '2015-01-15 00:15:02.000000', 'consum', 0.0221, 'lps'),
	(356335, 123, '2015-01-15 00:15:03.000000', 'consum', 0.0212, 'lps'),
	(356336, 123, '2015-01-15 00:15:04.000000', 'consum', 0.0214, 'lps'),
	(356337, 123, '2015-01-15 00:15:05.000000', 'consum', 0.0210, 'lps'),
	(356338, 123, '2015-01-15 00:15:06.000000', 'consum', 0.0213, 'lps'),
	(356339, 123, '2015-01-15 00:15:07.000000', 'consum', 0.0214, 'lps'),
	(356340, 123, '2015-01-15 00:15:08.000000', 'consum', 0.0218, 'lps'),
	(356341, 123, '2015-01-15 00:15:09.000000', 'consum', 0.0218, 'lps'),
	(356342, 123, '2015-01-15 00:15:10.000000', 'consum', 0.0215, 'lps'),
	(356343, 123, '2015-01-15 00:15:11.000000', 'consum', 0.0221, 'lps'),
	(356344, 123, '2015-01-15 00:15:12.000000', 'consum', 0.0215, 'lps'),
	(356345, 123, '2015-01-15 00:15:13.000000', 'consum', 0.0213, 'lps'),
	(356346, 123, '2015-01-15 00:15:14.000000', 'consum', 0.0210, 'lps'),
	(356347, 123, '2015-01-15 00:15:15.000000', 'consum', 0.0216, 'lps'),
	(356348, 123, '2015-01-15 00:15:16.000000', 'consum', 0.0217, 'lps'),
	(356349, 123, '2015-01-15 00:15:17.000000', 'consum', 0.0215, 'lps'),
	(356350, 123, '2015-01-15 00:15:18.000000', 'consum', 0.0213, 'lps'),
	(356351, 123, '2015-01-15 00:15:19.000000', 'consum', 0.0213, 'lps'),
	(356352, 123, '2015-01-15 00:15:20.000000', 'consum', 0.0214, 'lps'),
	(356353, 123, '2015-01-15 00:15:21.000000', 'consum', 0.0210, 'lps'),
	(356354, 123, '2015-01-15 00:15:22.000000', 'consum', 0.0221, 'lps'),
	(356355, 123, '2015-01-15 00:15:23.000000', 'consum', 0.0221, 'lps'),
	(356356, 123, '2015-01-15 00:15:24.000000', 'consum', 0.0218, 'lps'),
	(356357, 123, '2015-01-15 00:15:25.000000', 'consum', 0.0220, 'lps'),
	(356358, 123, '2015-01-15 00:15:26.000000', 'consum', 0.0211, 'lps'),
	(356359, 123, '2015-01-15 00:15:27.000000', 'consum', 0.0220, 'lps'),
	(356360, 123, '2015-01-15 00:15:28.000000', 'consum', 0.0221, 'lps'),
	(356361, 123, '2015-01-15 00:15:29.000000', 'consum', 0.0211, 'lps'),
	(356362, 123, '2015-01-15 00:15:30.000000', 'consum', 0.0218, 'lps'),
	(356363, 123, '2015-01-15 00:15:31.000000', 'consum', 0.0214, 'lps'),
	(356364, 123, '2015-01-15 00:15:32.000000', 'consum', 0.0216, 'lps'),
	(356365, 123, '2015-01-15 00:15:33.000000', 'consum', 0.0216, 'lps'),
	(356366, 123, '2015-01-15 00:15:34.000000', 'consum', 0.0211, 'lps'),
	(356367, 123, '2015-01-15 00:15:35.000000', 'consum', 0.0220, 'lps'),
	(356368, 123, '2015-01-15 00:15:36.000000', 'consum', 0.0213, 'lps'),
	(356369, 123, '2015-01-15 00:15:37.000000', 'consum', 0.0218, 'lps'),
	(356370, 123, '2015-01-15 00:15:38.000000', 'consum', 0.0216, 'lps'),
	(356371, 123, '2015-01-15 00:15:39.000000', 'consum', 0.0216, 'lps'),
	(356372, 123, '2015-01-15 00:15:40.000000', 'consum', 0.0211, 'lps'),
	(356373, 123, '2015-01-15 00:15:41.000000', 'consum', 0.0211, 'lps'),
	(356374, 123, '2015-01-15 00:15:42.000000', 'consum', 0.0210, 'lps'),
	(356375, 123, '2015-01-15 00:15:43.000000', 'consum', 0.0211, 'lps'),
	(356376, 123, '2015-01-15 00:15:44.000000', 'consum', 0.0213, 'lps'),
	(356377, 123, '2015-01-15 00:15:45.000000', 'consum', 0.0210, 'lps'),
	(356378, 123, '2015-01-15 00:15:46.000000', 'consum', 0.0216, 'lps'),
	(356379, 123, '2015-01-15 00:15:47.000000', 'consum', 0.0216, 'lps'),
	(356380, 123, '2015-01-15 00:15:48.000000', 'consum', 0.0221, 'lps'),
	(356381, 123, '2015-01-15 00:15:49.000000', 'consum', 0.0214, 'lps'),
	(356382, 123, '2015-01-15 00:15:50.000000', 'consum', 0.0221, 'lps'),
	(356383, 123, '2015-01-15 00:15:51.000000', 'consum', 0.0219, 'lps'),
	(356384, 123, '2015-01-15 00:15:52.000000', 'consum', 0.0220, 'lps'),
	(356385, 123, '2015-01-15 00:15:53.000000', 'consum', 0.0210, 'lps'),
	(356386, 123, '2015-01-15 00:15:54.000000', 'consum', 0.0216, 'lps'),
	(356387, 123, '2015-01-15 00:15:55.000000', 'consum', 0.0216, 'lps'),
	(356388, 123, '2015-01-15 00:15:56.000000', 'consum', 0.0211, 'lps'),
	(356389, 123, '2015-01-15 00:15:57.000000', 'consum', 0.0210, 'lps'),
	(356390, 123, '2015-01-15 00:15:58.000000', 'consum', 0.0219, 'lps'),
	(356391, 123, '2015-01-15 00:15:59.000000', 'consum', 0.0220, 'lps'),
	(356392, 123, '2015-01-15 00:16:00.000000', 'consum', 0.0210, 'lps'),
	(356393, 123, '2015-01-15 00:16:01.000000', 'consum', 0.0217, 'lps'),
	(356394, 123, '2015-01-15 00:16:02.000000', 'consum', 0.0221, 'lps'),
	(356395, 123, '2015-01-15 00:16:03.000000', 'consum', 0.0218, 'lps'),
	(356396, 123, '2015-01-15 00:16:04.000000', 'consum', 0.0221, 'lps'),
	(356397, 123, '2015-01-15 00:16:05.000000', 'consum', 0.0217, 'lps'),
	(356398, 123, '2015-01-15 00:16:06.000000', 'consum', 0.0211, 'lps'),
	(356399, 123, '2015-01-15 00:16:07.000000', 'consum', 0.0218, 'lps'),
	(356400, 123, '2015-01-15 00:16:08.000000', 'consum', 0.0211, 'lps'),
	(356401, 123, '2015-01-15 00:16:09.000000', 'consum', 0.0217, 'lps'),
	(356402, 123, '2015-01-15 00:16:10.000000', 'consum', 0.0217, 'lps'),
	(356403, 123, '2015-01-15 00:16:11.000000', 'consum', 0.0213, 'lps'),
	(356404, 123, '2015-01-15 00:16:12.000000', 'consum', 0.0218, 'lps'),
	(356405, 123, '2015-01-15 00:16:13.000000', 'consum', 0.0216, 'lps'),
	(356406, 123, '2015-01-15 00:16:14.000000', 'consum', 0.0216, 'lps'),
	(356407, 123, '2015-01-15 00:16:15.000000', 'consum', 0.0213, 'lps'),
	(356408, 123, '2015-01-15 00:16:16.000000', 'consum', 0.0217, 'lps'),
	(356409, 123, '2015-01-15 00:16:17.000000', 'consum', 0.0213, 'lps'),
	(356410, 123, '2015-01-15 00:16:18.000000', 'consum', 0.0219, 'lps'),
	(356411, 123, '2015-01-15 00:16:19.000000', 'consum', 0.0219, 'lps'),
	(356412, 123, '2015-01-15 00:16:20.000000', 'consum', 0.0218, 'lps'),
	(356413, 123, '2015-01-15 00:16:21.000000', 'consum', 0.0213, 'lps'),
	(356414, 123, '2015-01-15 00:16:22.000000', 'consum', 0.0211, 'lps'),
	(356415, 123, '2015-01-15 00:16:23.000000', 'consum', 0.0221, 'lps'),
	(356416, 123, '2015-01-15 00:16:24.000000', 'consum', 0.0213, 'lps'),
	(356417, 123, '2015-01-15 00:16:25.000000', 'consum', 0.0216, 'lps'),
	(356418, 123, '2015-01-15 00:16:26.000000', 'consum', 0.0219, 'lps'),
	(356419, 123, '2015-01-15 00:16:27.000000', 'consum', 0.0213, 'lps'),
	(356420, 123, '2015-01-15 00:16:28.000000', 'consum', 0.0210, 'lps'),
	(356421, 123, '2015-01-15 00:16:29.000000', 'consum', 0.0215, 'lps'),
	(356422, 123, '2015-01-15 00:16:30.000000', 'consum', 0.0212, 'lps'),
	(356423, 123, '2015-01-15 00:16:31.000000', 'consum', 0.0216, 'lps'),
	(356424, 123, '2015-01-15 00:16:32.000000', 'consum', 0.0221, 'lps'),
	(356425, 123, '2015-01-15 00:16:33.000000', 'consum', 0.0214, 'lps'),
	(356426, 123, '2015-01-15 00:16:34.000000', 'consum', 0.0220, 'lps'),
	(356427, 123, '2015-01-15 00:16:35.000000', 'consum', 0.0213, 'lps'),
	(356428, 123, '2015-01-15 00:16:36.000000', 'consum', 0.0218, 'lps'),
	(356429, 123, '2015-01-15 00:16:37.000000', 'consum', 0.0217, 'lps'),
	(356430, 123, '2015-01-15 00:16:38.000000', 'consum', 0.0210, 'lps'),
	(356431, 123, '2015-01-15 00:16:39.000000', 'consum', 0.0212, 'lps'),
	(356432, 123, '2015-01-15 00:16:40.000000', 'consum', 0.0210, 'lps'),
	(356433, 123, '2015-01-15 00:16:41.000000', 'consum', 0.0217, 'lps'),
	(356434, 123, '2015-01-15 00:16:42.000000', 'consum', 0.0219, 'lps'),
	(356435, 123, '2015-01-15 00:16:43.000000', 'consum', 0.0212, 'lps'),
	(356436, 123, '2015-01-15 00:16:44.000000', 'consum', 0.0218, 'lps'),
	(356437, 123, '2015-01-15 00:16:45.000000', 'consum', 0.0219, 'lps'),
	(356438, 123, '2015-01-15 00:16:46.000000', 'consum', 0.0219, 'lps'),
	(356439, 123, '2015-01-15 00:16:47.000000', 'consum', 0.0216, 'lps'),
	(356440, 123, '2015-01-15 00:16:48.000000', 'consum', 0.0214, 'lps'),
	(356441, 123, '2015-01-15 00:16:49.000000', 'consum', 0.0211, 'lps'),
	(356442, 123, '2015-01-15 00:16:50.000000', 'consum', 0.0217, 'lps'),
	(356443, 123, '2015-01-15 00:16:51.000000', 'consum', 0.0218, 'lps'),
	(356444, 123, '2015-01-15 00:16:52.000000', 'consum', 0.0217, 'lps'),
	(356445, 123, '2015-01-15 00:16:53.000000', 'consum', 0.0221, 'lps'),
	(356446, 123, '2015-01-15 00:16:54.000000', 'consum', 0.0210, 'lps'),
	(356447, 123, '2015-01-15 00:16:55.000000', 'consum', 0.0213, 'lps'),
	(356448, 123, '2015-01-15 00:16:56.000000', 'consum', 0.0214, 'lps'),
	(356449, 123, '2015-01-15 00:16:57.000000', 'consum', 0.0219, 'lps'),
	(356450, 123, '2015-01-15 00:16:58.000000', 'consum', 0.0210, 'lps'),
	(356451, 123, '2015-01-15 00:16:59.000000', 'consum', 0.0220, 'lps'),
	(356452, 123, '2015-01-15 00:17:00.000000', 'consum', 0.0212, 'lps'),
	(356453, 123, '2015-01-15 00:17:01.000000', 'consum', 0.0213, 'lps'),
	(356454, 123, '2015-01-15 00:17:02.000000', 'consum', 0.0219, 'lps'),
	(356455, 123, '2015-01-15 00:17:03.000000', 'consum', 0.0213, 'lps'),
	(356456, 123, '2015-01-15 00:17:04.000000', 'consum', 0.0220, 'lps'),
	(356457, 123, '2015-01-15 00:17:05.000000', 'consum', 0.0214, 'lps'),
	(356458, 123, '2015-01-15 00:17:06.000000', 'consum', 0.0216, 'lps'),
	(356459, 123, '2015-01-15 00:17:07.000000', 'consum', 0.0215, 'lps'),
	(356460, 123, '2015-01-15 00:17:08.000000', 'consum', 0.0218, 'lps'),
	(356461, 123, '2015-01-15 00:17:09.000000', 'consum', 0.0211, 'lps'),
	(356462, 123, '2015-01-15 00:17:10.000000', 'consum', 0.0217, 'lps'),
	(356463, 123, '2015-01-15 00:17:11.000000', 'consum', 0.0217, 'lps'),
	(356464, 123, '2015-01-15 00:17:12.000000', 'consum', 0.0212, 'lps'),
	(356465, 123, '2015-01-15 00:17:13.000000', 'consum', 0.0212, 'lps'),
	(356466, 123, '2015-01-15 00:17:14.000000', 'consum', 0.0215, 'lps'),
	(356467, 123, '2015-01-15 00:17:15.000000', 'consum', 0.0218, 'lps'),
	(356468, 123, '2015-01-15 00:17:16.000000', 'consum', 0.0211, 'lps'),
	(356469, 123, '2015-01-15 00:17:17.000000', 'consum', 0.0215, 'lps'),
	(356470, 123, '2015-01-15 00:17:18.000000', 'consum', 0.0219, 'lps'),
	(356471, 123, '2015-01-15 00:17:19.000000', 'consum', 0.0219, 'lps'),
	(356472, 123, '2015-01-15 00:17:20.000000', 'consum', 0.0214, 'lps'),
	(356473, 123, '2015-01-15 00:17:21.000000', 'consum', 0.0219, 'lps'),
	(356474, 123, '2015-01-15 00:17:22.000000', 'consum', 0.0217, 'lps'),
	(356475, 123, '2015-01-15 00:17:23.000000', 'consum', 0.0218, 'lps'),
	(356476, 123, '2015-01-15 00:17:24.000000', 'consum', 0.0219, 'lps'),
	(356477, 123, '2015-01-15 00:17:25.000000', 'consum', 0.0219, 'lps'),
	(356478, 123, '2015-01-15 00:17:26.000000', 'consum', 0.0216, 'lps'),
	(356479, 123, '2015-01-15 00:17:27.000000', 'consum', 0.0214, 'lps'),
	(356480, 123, '2015-01-15 00:17:28.000000', 'consum', 0.0211, 'lps'),
	(356481, 123, '2015-01-15 00:17:29.000000', 'consum', 0.0218, 'lps'),
	(356482, 123, '2015-01-15 00:17:30.000000', 'consum', 0.0212, 'lps'),
	(356483, 123, '2015-01-15 00:17:31.000000', 'consum', 0.0221, 'lps'),
	(356484, 123, '2015-01-15 00:17:32.000000', 'consum', 0.0212, 'lps'),
	(356485, 123, '2015-01-15 00:17:33.000000', 'consum', 0.0211, 'lps'),
	(356486, 123, '2015-01-15 00:17:34.000000', 'consum', 0.0219, 'lps'),
	(356487, 123, '2015-01-15 00:17:35.000000', 'consum', 0.0218, 'lps'),
	(356488, 123, '2015-01-15 00:17:36.000000', 'consum', 0.0212, 'lps'),
	(356489, 123, '2015-01-15 00:17:37.000000', 'consum', 0.0210, 'lps'),
	(356490, 123, '2015-01-15 00:17:38.000000', 'consum', 0.0214, 'lps'),
	(356491, 123, '2015-01-15 00:17:39.000000', 'consum', 0.0221, 'lps'),
	(356492, 123, '2015-01-15 00:17:40.000000', 'consum', 0.0215, 'lps'),
	(356493, 123, '2015-01-15 00:17:41.000000', 'consum', 0.0214, 'lps'),
	(356494, 123, '2015-01-15 00:17:42.000000', 'consum', 0.0215, 'lps'),
	(356495, 123, '2015-01-15 00:17:43.000000', 'consum', 0.0215, 'lps'),
	(356496, 123, '2015-01-15 00:17:44.000000', 'consum', 0.0217, 'lps'),
	(356497, 123, '2015-01-15 00:17:45.000000', 'consum', 0.0220, 'lps'),
	(356498, 123, '2015-01-15 00:17:46.000000', 'consum', 0.0216, 'lps'),
	(356499, 123, '2015-01-15 00:17:47.000000', 'consum', 0.0211, 'lps'),
	(356500, 123, '2015-01-15 00:17:48.000000', 'consum', 0.0220, 'lps'),
	(356501, 123, '2015-01-15 00:17:49.000000', 'consum', 0.0212, 'lps'),
	(356502, 123, '2015-01-15 00:17:50.000000', 'consum', 0.0212, 'lps'),
	(356503, 123, '2015-01-15 00:17:51.000000', 'consum', 0.0215, 'lps'),
	(356504, 123, '2015-01-15 00:17:52.000000', 'consum', 0.0218, 'lps'),
	(356505, 123, '2015-01-15 00:17:53.000000', 'consum', 0.0210, 'lps'),
	(356506, 123, '2015-01-15 00:17:54.000000', 'consum', 0.0211, 'lps'),
	(356507, 123, '2015-01-15 00:17:55.000000', 'consum', 0.0218, 'lps'),
	(356508, 123, '2015-01-15 00:17:56.000000', 'consum', 0.0221, 'lps'),
	(356509, 123, '2015-01-15 00:17:57.000000', 'consum', 0.0219, 'lps'),
	(356510, 123, '2015-01-15 00:17:58.000000', 'consum', 0.0220, 'lps'),
	(356511, 123, '2015-01-15 00:17:59.000000', 'consum', 0.0211, 'lps'),
	(356512, 123, '2015-01-15 00:18:00.000000', 'consum', 0.0211, 'lps'),
	(356513, 123, '2015-01-15 00:18:01.000000', 'consum', 0.0213, 'lps'),
	(356514, 123, '2015-01-15 00:18:02.000000', 'consum', 0.0220, 'lps'),
	(356515, 123, '2015-01-15 00:18:03.000000', 'consum', 0.0218, 'lps'),
	(356516, 123, '2015-01-15 00:18:04.000000', 'consum', 0.0219, 'lps'),
	(356517, 123, '2015-01-15 00:18:05.000000', 'consum', 0.0219, 'lps'),
	(356518, 123, '2015-01-15 00:18:06.000000', 'consum', 0.0215, 'lps'),
	(356519, 123, '2015-01-15 00:18:07.000000', 'consum', 0.0211, 'lps'),
	(356520, 123, '2015-01-15 00:18:08.000000', 'consum', 0.0211, 'lps'),
	(356521, 123, '2015-01-15 00:18:09.000000', 'consum', 0.0214, 'lps'),
	(356522, 123, '2015-01-15 00:18:10.000000', 'consum', 0.0215, 'lps'),
	(356523, 123, '2015-01-15 00:18:11.000000', 'consum', 0.0213, 'lps'),
	(356524, 123, '2015-01-15 00:18:12.000000', 'consum', 0.0211, 'lps'),
	(356525, 123, '2015-01-15 00:18:13.000000', 'consum', 0.0215, 'lps'),
	(356526, 123, '2015-01-15 00:18:14.000000', 'consum', 0.0212, 'lps'),
	(356527, 123, '2015-01-15 00:18:15.000000', 'consum', 0.0217, 'lps'),
	(356528, 123, '2015-01-15 00:18:16.000000', 'consum', 0.0216, 'lps'),
	(356529, 123, '2015-01-15 00:18:17.000000', 'consum', 0.0218, 'lps'),
	(356530, 123, '2015-01-15 00:18:18.000000', 'consum', 0.0221, 'lps'),
	(356531, 123, '2015-01-15 00:18:19.000000', 'consum', 0.0216, 'lps'),
	(356532, 123, '2015-01-15 00:18:20.000000', 'consum', 0.0219, 'lps'),
	(356533, 123, '2015-01-15 00:18:21.000000', 'consum', 0.0213, 'lps'),
	(356534, 123, '2015-01-15 00:18:22.000000', 'consum', 0.0214, 'lps'),
	(356535, 123, '2015-01-15 00:18:23.000000', 'consum', 0.0218, 'lps'),
	(356536, 123, '2015-01-15 00:18:24.000000', 'consum', 0.0216, 'lps'),
	(356537, 123, '2015-01-15 00:18:25.000000', 'consum', 0.0216, 'lps'),
	(356538, 123, '2015-01-15 00:18:26.000000', 'consum', 0.0211, 'lps'),
	(356539, 123, '2015-01-15 00:18:27.000000', 'consum', 0.0210, 'lps'),
	(356540, 123, '2015-01-15 00:18:28.000000', 'consum', 0.0220, 'lps'),
	(356541, 123, '2015-01-15 00:18:29.000000', 'consum', 0.0213, 'lps'),
	(356542, 123, '2015-01-15 00:18:30.000000', 'consum', 0.0217, 'lps'),
	(356543, 123, '2015-01-15 00:18:31.000000', 'consum', 0.0213, 'lps'),
	(356544, 123, '2015-01-15 00:18:32.000000', 'consum', 0.0217, 'lps'),
	(356545, 123, '2015-01-15 00:18:33.000000', 'consum', 0.0212, 'lps'),
	(356546, 123, '2015-01-15 00:18:34.000000', 'consum', 0.0214, 'lps'),
	(356547, 123, '2015-01-15 00:18:35.000000', 'consum', 0.0221, 'lps'),
	(356548, 123, '2015-01-15 00:18:36.000000', 'consum', 0.0221, 'lps'),
	(356549, 123, '2015-01-15 00:18:37.000000', 'consum', 0.0217, 'lps'),
	(356550, 123, '2015-01-15 00:18:38.000000', 'consum', 0.0216, 'lps'),
	(356551, 123, '2015-01-15 00:18:39.000000', 'consum', 0.0218, 'lps'),
	(356552, 123, '2015-01-15 00:18:40.000000', 'consum', 0.0220, 'lps'),
	(356553, 123, '2015-01-15 00:18:41.000000', 'consum', 0.0214, 'lps'),
	(356554, 123, '2015-01-15 00:18:42.000000', 'consum', 0.0211, 'lps'),
	(356555, 123, '2015-01-15 00:18:43.000000', 'consum', 0.0214, 'lps'),
	(356556, 123, '2015-01-15 00:18:44.000000', 'consum', 0.0218, 'lps'),
	(356557, 123, '2015-01-15 00:18:45.000000', 'consum', 0.0214, 'lps'),
	(356558, 123, '2015-01-15 00:18:46.000000', 'consum', 0.0217, 'lps'),
	(356559, 123, '2015-01-15 00:18:47.000000', 'consum', 0.0220, 'lps'),
	(356560, 123, '2015-01-15 00:18:48.000000', 'consum', 0.0219, 'lps'),
	(356561, 123, '2015-01-15 00:18:49.000000', 'consum', 0.0213, 'lps'),
	(356562, 123, '2015-01-15 00:18:50.000000', 'consum', 0.0211, 'lps'),
	(356563, 123, '2015-01-15 00:18:51.000000', 'consum', 0.0216, 'lps'),
	(356564, 123, '2015-01-15 00:18:52.000000', 'consum', 0.0215, 'lps'),
	(356565, 123, '2015-01-15 00:18:53.000000', 'consum', 0.0218, 'lps'),
	(356566, 123, '2015-01-15 00:18:54.000000', 'consum', 0.0213, 'lps'),
	(356567, 123, '2015-01-15 00:18:55.000000', 'consum', 0.0212, 'lps'),
	(356568, 123, '2015-01-15 00:18:56.000000', 'consum', 0.0210, 'lps'),
	(356569, 123, '2015-01-15 00:18:57.000000', 'consum', 0.0218, 'lps'),
	(356570, 123, '2015-01-15 00:18:58.000000', 'consum', 0.0215, 'lps'),
	(356571, 123, '2015-01-15 00:18:59.000000', 'consum', 0.0213, 'lps'),
	(356572, 123, '2015-01-15 00:19:00.000000', 'consum', 0.0221, 'lps'),
	(356573, 123, '2015-01-15 00:19:01.000000', 'consum', 0.0220, 'lps'),
	(356574, 123, '2015-01-15 00:19:02.000000', 'consum', 0.0217, 'lps'),
	(356575, 123, '2015-01-15 00:19:03.000000', 'consum', 0.0213, 'lps'),
	(356576, 123, '2015-01-15 00:19:04.000000', 'consum', 0.0217, 'lps'),
	(356577, 123, '2015-01-15 00:19:05.000000', 'consum', 0.0211, 'lps'),
	(356578, 123, '2015-01-15 00:19:06.000000', 'consum', 0.0220, 'lps'),
	(356579, 123, '2015-01-15 00:19:07.000000', 'consum', 0.0210, 'lps'),
	(356580, 123, '2015-01-15 00:19:08.000000', 'consum', 0.0215, 'lps'),
	(356581, 123, '2015-01-15 00:19:09.000000', 'consum', 0.0212, 'lps'),
	(356582, 123, '2015-01-15 00:19:10.000000', 'consum', 0.0220, 'lps'),
	(356583, 123, '2015-01-15 00:19:11.000000', 'consum', 0.0215, 'lps'),
	(356584, 123, '2015-01-15 00:19:12.000000', 'consum', 0.0218, 'lps'),
	(356585, 123, '2015-01-15 00:19:13.000000', 'consum', 0.0211, 'lps'),
	(356586, 123, '2015-01-15 00:19:14.000000', 'consum', 0.0218, 'lps'),
	(356587, 123, '2015-01-15 00:19:15.000000', 'consum', 0.0210, 'lps'),
	(356588, 123, '2015-01-15 00:19:16.000000', 'consum', 0.0221, 'lps'),
	(356589, 123, '2015-01-15 00:19:17.000000', 'consum', 0.0221, 'lps'),
	(356590, 123, '2015-01-15 00:19:18.000000', 'consum', 0.0217, 'lps'),
	(356591, 123, '2015-01-15 00:19:19.000000', 'consum', 0.0215, 'lps'),
	(356592, 123, '2015-01-15 00:19:20.000000', 'consum', 0.0213, 'lps'),
	(356593, 123, '2015-01-15 00:19:21.000000', 'consum', 0.0221, 'lps'),
	(356594, 123, '2015-01-15 00:19:22.000000', 'consum', 0.0210, 'lps'),
	(356595, 123, '2015-01-15 00:19:23.000000', 'consum', 0.0215, 'lps'),
	(356596, 123, '2015-01-15 00:19:24.000000', 'consum', 0.0211, 'lps'),
	(356597, 123, '2015-01-15 00:19:25.000000', 'consum', 0.0214, 'lps'),
	(356598, 123, '2015-01-15 00:19:26.000000', 'consum', 0.0214, 'lps'),
	(356599, 123, '2015-01-15 00:19:27.000000', 'consum', 0.0220, 'lps'),
	(356600, 123, '2015-01-15 00:19:28.000000', 'consum', 0.0221, 'lps'),
	(356601, 123, '2015-01-15 00:19:29.000000', 'consum', 0.0215, 'lps'),
	(356602, 123, '2015-01-15 00:19:30.000000', 'consum', 0.0213, 'lps'),
	(356603, 123, '2015-01-15 00:19:31.000000', 'consum', 0.0211, 'lps'),
	(356604, 123, '2015-01-15 00:19:32.000000', 'consum', 0.0218, 'lps'),
	(356605, 123, '2015-01-15 00:19:33.000000', 'consum', 0.0213, 'lps'),
	(356606, 123, '2015-01-15 00:19:34.000000', 'consum', 0.0213, 'lps'),
	(356607, 123, '2015-01-15 00:19:35.000000', 'consum', 0.0216, 'lps'),
	(356608, 123, '2015-01-15 00:19:36.000000', 'consum', 0.0220, 'lps'),
	(356609, 123, '2015-01-15 00:19:37.000000', 'consum', 0.0218, 'lps'),
	(356610, 123, '2015-01-15 00:19:38.000000', 'consum', 0.0221, 'lps'),
	(356611, 123, '2015-01-15 00:19:39.000000', 'consum', 0.0215, 'lps'),
	(356612, 123, '2015-01-15 00:19:40.000000', 'consum', 0.0217, 'lps'),
	(356613, 123, '2015-01-15 00:19:41.000000', 'consum', 0.0219, 'lps'),
	(356614, 123, '2015-01-15 00:19:42.000000', 'consum', 0.0210, 'lps'),
	(356615, 123, '2015-01-15 00:19:43.000000', 'consum', 0.0219, 'lps'),
	(356616, 123, '2015-01-15 00:19:44.000000', 'consum', 0.0218, 'lps'),
	(356617, 123, '2015-01-15 00:19:45.000000', 'consum', 0.0212, 'lps'),
	(356618, 123, '2015-01-15 00:19:46.000000', 'consum', 0.0221, 'lps'),
	(356619, 123, '2015-01-15 00:19:47.000000', 'consum', 0.0212, 'lps'),
	(356620, 123, '2015-01-15 00:19:48.000000', 'consum', 0.0213, 'lps'),
	(356621, 123, '2015-01-15 00:19:49.000000', 'consum', 0.0217, 'lps'),
	(356622, 123, '2015-01-15 00:19:50.000000', 'consum', 0.0213, 'lps'),
	(356623, 123, '2015-01-15 00:19:51.000000', 'consum', 0.0218, 'lps'),
	(356624, 123, '2015-01-15 00:19:52.000000', 'consum', 0.0215, 'lps'),
	(356625, 123, '2015-01-15 00:19:53.000000', 'consum', 0.0215, 'lps'),
	(356626, 123, '2015-01-15 00:19:54.000000', 'consum', 0.0217, 'lps'),
	(356627, 123, '2015-01-15 00:19:55.000000', 'consum', 0.0219, 'lps'),
	(356628, 123, '2015-01-15 00:19:56.000000', 'consum', 0.0221, 'lps'),
	(356629, 123, '2015-01-15 00:19:57.000000', 'consum', 0.0217, 'lps'),
	(356630, 123, '2015-01-15 00:19:58.000000', 'consum', 0.0213, 'lps'),
	(356631, 123, '2015-01-15 00:19:59.000000', 'consum', 0.0217, 'lps'),
	(356632, 123, '2015-01-15 00:20:00.000000', 'consum', 0.0212, 'lps'),
	(356633, 123, '2015-01-15 00:20:01.000000', 'consum', 0.0211, 'lps'),
	(356634, 123, '2015-01-15 00:20:02.000000', 'consum', 0.0221, 'lps'),
	(356635, 123, '2015-01-15 00:20:03.000000', 'consum', 0.0215, 'lps'),
	(356636, 123, '2015-01-15 00:20:04.000000', 'consum', 0.0216, 'lps'),
	(356637, 123, '2015-01-15 00:20:05.000000', 'consum', 0.0213, 'lps'),
	(356638, 123, '2015-01-15 00:20:06.000000', 'consum', 0.0218, 'lps'),
	(356639, 123, '2015-01-15 00:20:07.000000', 'consum', 0.0217, 'lps'),
	(356640, 123, '2015-01-15 00:20:08.000000', 'consum', 0.0210, 'lps'),
	(356641, 123, '2015-01-15 00:20:09.000000', 'consum', 0.0216, 'lps'),
	(356642, 123, '2015-01-15 00:20:10.000000', 'consum', 0.0214, 'lps'),
	(356643, 123, '2015-01-15 00:20:11.000000', 'consum', 0.0215, 'lps'),
	(356644, 123, '2015-01-15 00:20:12.000000', 'consum', 0.0211, 'lps'),
	(356645, 123, '2015-01-15 00:20:13.000000', 'consum', 0.0212, 'lps'),
	(356646, 123, '2015-01-15 00:20:14.000000', 'consum', 0.0216, 'lps'),
	(356647, 123, '2015-01-15 00:20:15.000000', 'consum', 0.0211, 'lps'),
	(356648, 123, '2015-01-15 00:20:16.000000', 'consum', 0.0211, 'lps'),
	(356649, 123, '2015-01-15 00:20:17.000000', 'consum', 0.0214, 'lps'),
	(356650, 123, '2015-01-15 00:20:18.000000', 'consum', 0.0213, 'lps'),
	(356651, 123, '2015-01-15 00:20:19.000000', 'consum', 0.0215, 'lps'),
	(356652, 123, '2015-01-15 00:20:20.000000', 'consum', 0.0214, 'lps'),
	(356653, 123, '2015-01-15 00:20:21.000000', 'consum', 0.0213, 'lps'),
	(356654, 123, '2015-01-15 00:20:22.000000', 'consum', 0.0217, 'lps'),
	(356655, 123, '2015-01-15 00:20:23.000000', 'consum', 0.0211, 'lps'),
	(356656, 123, '2015-01-15 00:20:24.000000', 'consum', 0.0219, 'lps'),
	(356657, 123, '2015-01-15 00:20:25.000000', 'consum', 0.0218, 'lps'),
	(356658, 123, '2015-01-15 00:20:26.000000', 'consum', 0.0210, 'lps'),
	(356659, 123, '2015-01-15 00:20:27.000000', 'consum', 0.0211, 'lps'),
	(356660, 123, '2015-01-15 00:20:28.000000', 'consum', 0.0217, 'lps'),
	(356661, 123, '2015-01-15 00:20:29.000000', 'consum', 0.0216, 'lps'),
	(356662, 123, '2015-01-15 00:20:30.000000', 'consum', 0.0210, 'lps'),
	(356663, 123, '2015-01-15 00:20:31.000000', 'consum', 0.0216, 'lps'),
	(356664, 123, '2015-01-15 00:20:32.000000', 'consum', 0.0216, 'lps'),
	(356665, 123, '2015-01-15 00:20:33.000000', 'consum', 0.0210, 'lps'),
	(356666, 123, '2015-01-15 00:20:34.000000', 'consum', 0.0216, 'lps'),
	(356667, 123, '2015-01-15 00:20:35.000000', 'consum', 0.0217, 'lps'),
	(356668, 123, '2015-01-15 00:20:36.000000', 'consum', 0.0214, 'lps'),
	(356669, 123, '2015-01-15 00:20:37.000000', 'consum', 0.0212, 'lps'),
	(356670, 123, '2015-01-15 00:20:38.000000', 'consum', 0.0221, 'lps'),
	(356671, 123, '2015-01-15 00:20:39.000000', 'consum', 0.0220, 'lps'),
	(356672, 123, '2015-01-15 00:20:40.000000', 'consum', 0.0219, 'lps'),
	(356673, 123, '2015-01-15 00:20:41.000000', 'consum', 0.0214, 'lps'),
	(356674, 123, '2015-01-15 00:20:42.000000', 'consum', 0.0213, 'lps'),
	(356675, 123, '2015-01-15 00:20:43.000000', 'consum', 0.0213, 'lps'),
	(356676, 123, '2015-01-15 00:20:44.000000', 'consum', 0.0219, 'lps'),
	(356677, 123, '2015-01-15 00:20:45.000000', 'consum', 0.0211, 'lps'),
	(356678, 123, '2015-01-15 00:20:46.000000', 'consum', 0.0212, 'lps'),
	(356679, 123, '2015-01-15 00:20:47.000000', 'consum', 0.0217, 'lps'),
	(356680, 123, '2015-01-15 00:20:48.000000', 'consum', 0.0214, 'lps'),
	(356681, 123, '2015-01-15 00:20:49.000000', 'consum', 0.0212, 'lps'),
	(356682, 123, '2015-01-15 00:20:50.000000', 'consum', 0.0218, 'lps'),
	(356683, 123, '2015-01-15 00:20:51.000000', 'consum', 0.0212, 'lps'),
	(356684, 123, '2015-01-15 00:20:52.000000', 'consum', 0.0217, 'lps'),
	(356685, 123, '2015-01-15 00:20:53.000000', 'consum', 0.0218, 'lps'),
	(356686, 123, '2015-01-15 00:20:54.000000', 'consum', 0.0216, 'lps'),
	(356687, 123, '2015-01-15 00:20:55.000000', 'consum', 0.0218, 'lps'),
	(356688, 123, '2015-01-15 00:20:56.000000', 'consum', 0.0220, 'lps'),
	(356689, 123, '2015-01-15 00:20:57.000000', 'consum', 0.0214, 'lps'),
	(356690, 123, '2015-01-15 00:20:58.000000', 'consum', 0.0210, 'lps'),
	(356691, 123, '2015-01-15 00:20:59.000000', 'consum', 0.0212, 'lps'),
	(356692, 123, '2015-01-15 00:21:00.000000', 'consum', 0.0219, 'lps'),
	(356693, 123, '2015-01-15 00:21:01.000000', 'consum', 0.0214, 'lps'),
	(356694, 123, '2015-01-15 00:21:02.000000', 'consum', 0.0214, 'lps'),
	(356695, 123, '2015-01-15 00:21:03.000000', 'consum', 0.0210, 'lps'),
	(356696, 123, '2015-01-15 00:21:04.000000', 'consum', 0.0220, 'lps'),
	(356697, 123, '2015-01-15 00:21:05.000000', 'consum', 0.0212, 'lps'),
	(356698, 123, '2015-01-15 00:21:06.000000', 'consum', 0.0214, 'lps'),
	(356699, 123, '2015-01-15 00:21:07.000000', 'consum', 0.0212, 'lps'),
	(356700, 123, '2015-01-15 00:21:08.000000', 'consum', 0.0210, 'lps'),
	(356701, 123, '2015-01-15 00:21:09.000000', 'consum', 0.0215, 'lps'),
	(356702, 123, '2015-01-15 00:21:10.000000', 'consum', 0.0213, 'lps'),
	(356703, 123, '2015-01-15 00:21:11.000000', 'consum', 0.0221, 'lps'),
	(356704, 123, '2015-01-15 00:21:12.000000', 'consum', 0.0211, 'lps'),
	(356705, 123, '2015-01-15 00:21:13.000000', 'consum', 0.0217, 'lps'),
	(356706, 123, '2015-01-15 00:21:14.000000', 'consum', 0.0219, 'lps'),
	(356707, 123, '2015-01-15 00:21:15.000000', 'consum', 0.0220, 'lps'),
	(356708, 123, '2015-01-15 00:21:16.000000', 'consum', 0.0212, 'lps'),
	(356709, 123, '2015-01-15 00:21:17.000000', 'consum', 0.0215, 'lps'),
	(356710, 123, '2015-01-15 00:21:18.000000', 'consum', 0.0217, 'lps'),
	(356711, 123, '2015-01-15 00:21:19.000000', 'consum', 0.0219, 'lps'),
	(356712, 123, '2015-01-15 00:21:20.000000', 'consum', 0.0212, 'lps'),
	(356713, 123, '2015-01-15 00:21:21.000000', 'consum', 0.0215, 'lps'),
	(356714, 123, '2015-01-15 00:21:22.000000', 'consum', 0.0218, 'lps'),
	(356715, 123, '2015-01-15 00:21:23.000000', 'consum', 0.0212, 'lps'),
	(356716, 123, '2015-01-15 00:21:24.000000', 'consum', 0.0220, 'lps'),
	(356717, 123, '2015-01-15 00:21:25.000000', 'consum', 0.0218, 'lps'),
	(356718, 123, '2015-01-15 00:21:26.000000', 'consum', 0.0210, 'lps'),
	(356719, 123, '2015-01-15 00:21:27.000000', 'consum', 0.0220, 'lps'),
	(356720, 123, '2015-01-15 00:21:28.000000', 'consum', 0.0213, 'lps'),
	(356721, 123, '2015-01-15 00:21:29.000000', 'consum', 0.0220, 'lps'),
	(356722, 123, '2015-01-15 00:21:30.000000', 'consum', 0.0215, 'lps'),
	(356723, 123, '2015-01-15 00:21:31.000000', 'consum', 0.0218, 'lps'),
	(356724, 123, '2015-01-15 00:21:32.000000', 'consum', 0.0213, 'lps'),
	(356725, 123, '2015-01-15 00:21:33.000000', 'consum', 0.0214, 'lps'),
	(356726, 123, '2015-01-15 00:21:34.000000', 'consum', 0.0220, 'lps'),
	(356727, 123, '2015-01-15 00:21:35.000000', 'consum', 0.0214, 'lps'),
	(356728, 123, '2015-01-15 00:21:36.000000', 'consum', 0.0211, 'lps'),
	(356729, 123, '2015-01-15 00:21:37.000000', 'consum', 0.0215, 'lps'),
	(356730, 123, '2015-01-15 00:21:38.000000', 'consum', 0.0221, 'lps'),
	(356731, 123, '2015-01-15 00:21:39.000000', 'consum', 0.0214, 'lps'),
	(356732, 123, '2015-01-15 00:21:40.000000', 'consum', 0.0211, 'lps'),
	(356733, 123, '2015-01-15 00:21:41.000000', 'consum', 0.0215, 'lps'),
	(356734, 123, '2015-01-15 00:21:42.000000', 'consum', 0.0210, 'lps'),
	(356735, 123, '2015-01-15 00:21:43.000000', 'consum', 0.0220, 'lps'),
	(356736, 123, '2015-01-15 00:21:44.000000', 'consum', 0.0210, 'lps'),
	(356737, 123, '2015-01-15 00:21:45.000000', 'consum', 0.0215, 'lps'),
	(356738, 123, '2015-01-15 00:21:46.000000', 'consum', 0.0215, 'lps'),
	(356739, 123, '2015-01-15 00:21:47.000000', 'consum', 0.0219, 'lps'),
	(356740, 123, '2015-01-15 00:21:48.000000', 'consum', 0.0216, 'lps'),
	(356741, 123, '2015-01-15 00:21:49.000000', 'consum', 0.0213, 'lps'),
	(356742, 123, '2015-01-15 00:21:50.000000', 'consum', 0.0219, 'lps'),
	(356743, 123, '2015-01-15 00:21:51.000000', 'consum', 0.0213, 'lps'),
	(356744, 123, '2015-01-15 00:21:52.000000', 'consum', 0.0220, 'lps'),
	(356745, 123, '2015-01-15 00:21:53.000000', 'consum', 0.0215, 'lps'),
	(356746, 123, '2015-01-15 00:21:54.000000', 'consum', 0.0217, 'lps'),
	(356747, 123, '2015-01-15 00:21:55.000000', 'consum', 0.0221, 'lps'),
	(356748, 123, '2015-01-15 00:21:56.000000', 'consum', 0.0221, 'lps'),
	(356749, 123, '2015-01-15 00:21:57.000000', 'consum', 0.0221, 'lps'),
	(356750, 123, '2015-01-15 00:21:58.000000', 'consum', 0.0218, 'lps'),
	(356751, 123, '2015-01-15 00:21:59.000000', 'consum', 0.0217, 'lps'),
	(356752, 123, '2015-01-15 00:22:00.000000', 'consum', 0.0212, 'lps'),
	(356753, 123, '2015-01-15 00:22:01.000000', 'consum', 0.0221, 'lps'),
	(356754, 123, '2015-01-15 00:22:02.000000', 'consum', 0.0212, 'lps'),
	(356755, 123, '2015-01-15 00:22:03.000000', 'consum', 0.0211, 'lps'),
	(356756, 123, '2015-01-15 00:22:04.000000', 'consum', 0.0220, 'lps'),
	(356757, 123, '2015-01-15 00:22:05.000000', 'consum', 0.0212, 'lps'),
	(356758, 123, '2015-01-15 00:22:06.000000', 'consum', 0.0215, 'lps'),
	(356759, 123, '2015-01-15 00:22:07.000000', 'consum', 0.0217, 'lps'),
	(356760, 123, '2015-01-15 00:22:08.000000', 'consum', 0.0219, 'lps'),
	(356761, 123, '2015-01-15 00:22:09.000000', 'consum', 0.0211, 'lps'),
	(356762, 123, '2015-01-15 00:22:10.000000', 'consum', 0.0212, 'lps'),
	(356763, 123, '2015-01-15 00:22:11.000000', 'consum', 0.0216, 'lps'),
	(356764, 123, '2015-01-15 00:22:12.000000', 'consum', 0.0210, 'lps'),
	(356765, 123, '2015-01-15 00:22:13.000000', 'consum', 0.0219, 'lps'),
	(356766, 123, '2015-01-15 00:22:14.000000', 'consum', 0.0220, 'lps'),
	(356767, 123, '2015-01-15 00:22:15.000000', 'consum', 0.0210, 'lps'),
	(356768, 123, '2015-01-15 00:22:16.000000', 'consum', 0.0215, 'lps'),
	(356769, 123, '2015-01-15 00:22:17.000000', 'consum', 0.0213, 'lps'),
	(356770, 123, '2015-01-15 00:22:18.000000', 'consum', 0.0210, 'lps'),
	(356771, 123, '2015-01-15 00:22:19.000000', 'consum', 0.0213, 'lps'),
	(356772, 123, '2015-01-15 00:22:20.000000', 'consum', 0.0214, 'lps'),
	(356773, 123, '2015-01-15 00:22:21.000000', 'consum', 0.0220, 'lps'),
	(356774, 123, '2015-01-15 00:22:22.000000', 'consum', 0.0214, 'lps'),
	(356775, 123, '2015-01-15 00:22:23.000000', 'consum', 0.0211, 'lps'),
	(356776, 123, '2015-01-15 00:22:24.000000', 'consum', 0.0218, 'lps'),
	(356777, 123, '2015-01-15 00:22:25.000000', 'consum', 0.0212, 'lps'),
	(356778, 123, '2015-01-15 00:22:26.000000', 'consum', 0.0217, 'lps'),
	(356779, 123, '2015-01-15 00:22:27.000000', 'consum', 0.0219, 'lps'),
	(356780, 123, '2015-01-15 00:22:28.000000', 'consum', 0.0210, 'lps'),
	(356781, 123, '2015-01-15 00:22:29.000000', 'consum', 0.0217, 'lps'),
	(356782, 123, '2015-01-15 00:22:30.000000', 'consum', 0.0212, 'lps'),
	(356783, 123, '2015-01-15 00:22:31.000000', 'consum', 0.0221, 'lps'),
	(356784, 123, '2015-01-15 00:22:32.000000', 'consum', 0.0212, 'lps'),
	(356785, 123, '2015-01-15 00:22:33.000000', 'consum', 0.0212, 'lps'),
	(356786, 123, '2015-01-15 00:22:34.000000', 'consum', 0.0212, 'lps'),
	(356787, 123, '2015-01-15 00:22:35.000000', 'consum', 0.0218, 'lps'),
	(356788, 123, '2015-01-15 00:22:36.000000', 'consum', 0.0220, 'lps'),
	(356789, 123, '2015-01-15 00:22:37.000000', 'consum', 0.0212, 'lps'),
	(356790, 123, '2015-01-15 00:22:38.000000', 'consum', 0.0216, 'lps'),
	(356791, 123, '2015-01-15 00:22:39.000000', 'consum', 0.0211, 'lps'),
	(356792, 123, '2015-01-15 00:22:40.000000', 'consum', 0.0221, 'lps'),
	(356793, 123, '2015-01-15 00:22:41.000000', 'consum', 0.0215, 'lps'),
	(356794, 123, '2015-01-15 00:22:42.000000', 'consum', 0.0215, 'lps'),
	(356795, 123, '2015-01-15 00:22:43.000000', 'consum', 0.0219, 'lps'),
	(356796, 123, '2015-01-15 00:22:44.000000', 'consum', 0.0217, 'lps'),
	(356797, 123, '2015-01-15 00:22:45.000000', 'consum', 0.0218, 'lps'),
	(356798, 123, '2015-01-15 00:22:46.000000', 'consum', 0.0219, 'lps'),
	(356799, 123, '2015-01-15 00:22:47.000000', 'consum', 0.0219, 'lps'),
	(356800, 123, '2015-01-15 00:22:48.000000', 'consum', 0.0215, 'lps'),
	(356801, 123, '2015-01-15 00:22:49.000000', 'consum', 0.0211, 'lps'),
	(356802, 123, '2015-01-15 00:22:50.000000', 'consum', 0.0211, 'lps'),
	(356803, 123, '2015-01-15 00:22:51.000000', 'consum', 0.0213, 'lps'),
	(356804, 123, '2015-01-15 00:22:52.000000', 'consum', 0.0211, 'lps'),
	(356805, 123, '2015-01-15 00:22:53.000000', 'consum', 0.0217, 'lps'),
	(356806, 123, '2015-01-15 00:22:54.000000', 'consum', 0.0220, 'lps'),
	(356807, 123, '2015-01-15 00:22:55.000000', 'consum', 0.0216, 'lps'),
	(356808, 123, '2015-01-15 00:22:56.000000', 'consum', 0.0211, 'lps'),
	(356809, 123, '2015-01-15 00:22:57.000000', 'consum', 0.0220, 'lps'),
	(356810, 123, '2015-01-15 00:22:58.000000', 'consum', 0.0221, 'lps'),
	(356811, 123, '2015-01-15 00:22:59.000000', 'consum', 0.0211, 'lps'),
	(356812, 123, '2015-01-15 00:23:00.000000', 'consum', 0.0220, 'lps'),
	(356813, 123, '2015-01-15 00:23:01.000000', 'consum', 0.0211, 'lps'),
	(356814, 123, '2015-01-15 00:23:02.000000', 'consum', 0.0221, 'lps'),
	(356815, 123, '2015-01-15 00:23:03.000000', 'consum', 0.0212, 'lps'),
	(356816, 123, '2015-01-15 00:23:04.000000', 'consum', 0.0212, 'lps'),
	(356817, 123, '2015-01-15 00:23:05.000000', 'consum', 0.0216, 'lps'),
	(356818, 123, '2015-01-15 00:23:06.000000', 'consum', 0.0220, 'lps'),
	(356819, 123, '2015-01-15 00:23:07.000000', 'consum', 0.0219, 'lps'),
	(356820, 123, '2015-01-15 00:23:08.000000', 'consum', 0.0216, 'lps'),
	(356821, 123, '2015-01-15 00:23:09.000000', 'consum', 0.0210, 'lps'),
	(356822, 123, '2015-01-15 00:23:10.000000', 'consum', 0.0219, 'lps'),
	(356823, 123, '2015-01-15 00:23:11.000000', 'consum', 0.0218, 'lps'),
	(356824, 123, '2015-01-15 00:23:12.000000', 'consum', 0.0214, 'lps'),
	(356825, 123, '2015-01-15 00:23:13.000000', 'consum', 0.0216, 'lps'),
	(356826, 123, '2015-01-15 00:23:14.000000', 'consum', 0.0217, 'lps'),
	(356827, 123, '2015-01-15 00:23:15.000000', 'consum', 0.0217, 'lps'),
	(356828, 123, '2015-01-15 00:23:16.000000', 'consum', 0.0210, 'lps'),
	(356829, 123, '2015-01-15 00:23:17.000000', 'consum', 0.0213, 'lps'),
	(356830, 123, '2015-01-15 00:23:18.000000', 'consum', 0.0213, 'lps'),
	(356831, 123, '2015-01-15 00:23:19.000000', 'consum', 0.0220, 'lps'),
	(356832, 123, '2015-01-15 00:23:20.000000', 'consum', 0.0213, 'lps'),
	(356833, 123, '2015-01-15 00:23:21.000000', 'consum', 0.0218, 'lps'),
	(356834, 123, '2015-01-15 00:23:22.000000', 'consum', 0.0221, 'lps'),
	(356835, 123, '2015-01-15 00:23:23.000000', 'consum', 0.0216, 'lps'),
	(356836, 123, '2015-01-15 00:23:24.000000', 'consum', 0.0221, 'lps'),
	(356837, 123, '2015-01-15 00:23:25.000000', 'consum', 0.0221, 'lps'),
	(356838, 123, '2015-01-15 00:23:26.000000', 'consum', 0.0211, 'lps'),
	(356839, 123, '2015-01-15 00:23:27.000000', 'consum', 0.0219, 'lps'),
	(356840, 123, '2015-01-15 00:23:28.000000', 'consum', 0.0214, 'lps'),
	(356841, 123, '2015-01-15 00:23:29.000000', 'consum', 0.0218, 'lps'),
	(356842, 123, '2015-01-15 00:23:30.000000', 'consum', 0.0213, 'lps'),
	(356843, 123, '2015-01-15 00:23:31.000000', 'consum', 0.0215, 'lps'),
	(356844, 123, '2015-01-15 00:23:32.000000', 'consum', 0.0216, 'lps'),
	(356845, 123, '2015-01-15 00:23:33.000000', 'consum', 0.0211, 'lps'),
	(356846, 123, '2015-01-15 00:23:34.000000', 'consum', 0.0210, 'lps'),
	(356847, 123, '2015-01-15 00:23:35.000000', 'consum', 0.0219, 'lps'),
	(356848, 123, '2015-01-15 00:23:36.000000', 'consum', 0.0210, 'lps'),
	(356849, 123, '2015-01-15 00:23:37.000000', 'consum', 0.0218, 'lps'),
	(356850, 123, '2015-01-15 00:23:38.000000', 'consum', 0.0213, 'lps'),
	(356851, 123, '2015-01-15 00:23:39.000000', 'consum', 0.0213, 'lps'),
	(356852, 123, '2015-01-15 00:23:40.000000', 'consum', 0.0218, 'lps'),
	(356853, 123, '2015-01-15 00:23:41.000000', 'consum', 0.0218, 'lps'),
	(356854, 123, '2015-01-15 00:23:42.000000', 'consum', 0.0215, 'lps'),
	(356855, 123, '2015-01-15 00:23:43.000000', 'consum', 0.0210, 'lps'),
	(356856, 123, '2015-01-15 00:23:44.000000', 'consum', 0.0220, 'lps'),
	(356857, 123, '2015-01-15 00:23:45.000000', 'consum', 0.0211, 'lps'),
	(356858, 123, '2015-01-15 00:23:46.000000', 'consum', 0.0221, 'lps'),
	(356859, 123, '2015-01-15 00:23:47.000000', 'consum', 0.0214, 'lps'),
	(356860, 123, '2015-01-15 00:23:48.000000', 'consum', 0.0221, 'lps'),
	(356861, 123, '2015-01-15 00:23:49.000000', 'consum', 0.0221, 'lps'),
	(356862, 123, '2015-01-15 00:23:50.000000', 'consum', 0.0217, 'lps'),
	(356863, 123, '2015-01-15 00:23:51.000000', 'consum', 0.0215, 'lps'),
	(356864, 123, '2015-01-15 00:23:52.000000', 'consum', 0.0214, 'lps'),
	(356865, 123, '2015-01-15 00:23:53.000000', 'consum', 0.0215, 'lps'),
	(356866, 123, '2015-01-15 00:23:54.000000', 'consum', 0.0211, 'lps'),
	(356867, 123, '2015-01-15 00:23:55.000000', 'consum', 0.0212, 'lps'),
	(356868, 123, '2015-01-15 00:23:56.000000', 'consum', 0.0217, 'lps'),
	(356869, 123, '2015-01-15 00:23:57.000000', 'consum', 0.0215, 'lps'),
	(356870, 123, '2015-01-15 00:23:58.000000', 'consum', 0.0214, 'lps'),
	(356871, 123, '2015-01-15 00:23:59.000000', 'consum', 0.0218, 'lps'),
	(356872, 123, '2015-01-15 00:24:00.000000', 'consum', 0.0213, 'lps'),
	(356873, 123, '2015-01-15 00:24:01.000000', 'consum', 0.0213, 'lps'),
	(356874, 123, '2015-01-15 00:24:02.000000', 'consum', 0.0216, 'lps'),
	(356875, 123, '2015-01-15 00:24:03.000000', 'consum', 0.0220, 'lps'),
	(356876, 123, '2015-01-15 00:24:04.000000', 'consum', 0.0221, 'lps'),
	(356877, 123, '2015-01-15 00:24:05.000000', 'consum', 0.0220, 'lps'),
	(356878, 123, '2015-01-15 00:24:06.000000', 'consum', 0.0216, 'lps'),
	(356879, 123, '2015-01-15 00:24:07.000000', 'consum', 0.0210, 'lps'),
	(356880, 123, '2015-01-15 00:24:08.000000', 'consum', 0.0219, 'lps'),
	(356881, 123, '2015-01-15 00:24:09.000000', 'consum', 0.0218, 'lps'),
	(356882, 123, '2015-01-15 00:24:10.000000', 'consum', 0.0213, 'lps'),
	(356883, 123, '2015-01-15 00:24:11.000000', 'consum', 0.0212, 'lps'),
	(356884, 123, '2015-01-15 00:24:12.000000', 'consum', 0.0211, 'lps'),
	(356885, 123, '2015-01-15 00:24:13.000000', 'consum', 0.0221, 'lps'),
	(356886, 123, '2015-01-15 00:24:14.000000', 'consum', 0.0214, 'lps'),
	(356887, 123, '2015-01-15 00:24:15.000000', 'consum', 0.0211, 'lps'),
	(356888, 123, '2015-01-15 00:24:16.000000', 'consum', 0.0215, 'lps'),
	(356889, 123, '2015-01-15 00:24:17.000000', 'consum', 0.0220, 'lps'),
	(356890, 123, '2015-01-15 00:24:18.000000', 'consum', 0.0211, 'lps'),
	(356891, 123, '2015-01-15 00:24:19.000000', 'consum', 0.0210, 'lps'),
	(356892, 123, '2015-01-15 00:24:20.000000', 'consum', 0.0219, 'lps'),
	(356893, 123, '2015-01-15 00:24:21.000000', 'consum', 0.0220, 'lps'),
	(356894, 123, '2015-01-15 00:24:22.000000', 'consum', 0.0211, 'lps'),
	(356895, 123, '2015-01-15 00:24:23.000000', 'consum', 0.0219, 'lps'),
	(356896, 123, '2015-01-15 00:24:24.000000', 'consum', 0.0219, 'lps'),
	(356897, 123, '2015-01-15 00:24:25.000000', 'consum', 0.0214, 'lps'),
	(356898, 123, '2015-01-15 00:24:26.000000', 'consum', 0.0218, 'lps'),
	(356899, 123, '2015-01-15 00:24:27.000000', 'consum', 0.0212, 'lps'),
	(356900, 123, '2015-01-15 00:24:28.000000', 'consum', 0.0210, 'lps'),
	(356901, 123, '2015-01-15 00:24:29.000000', 'consum', 0.0215, 'lps'),
	(356902, 123, '2015-01-15 00:24:30.000000', 'consum', 0.0212, 'lps'),
	(356903, 123, '2015-01-15 00:24:31.000000', 'consum', 0.0216, 'lps'),
	(356904, 123, '2015-01-15 00:24:32.000000', 'consum', 0.0214, 'lps'),
	(356905, 123, '2015-01-15 00:24:33.000000', 'consum', 0.0221, 'lps'),
	(356906, 123, '2015-01-15 00:24:34.000000', 'consum', 0.0220, 'lps'),
	(356907, 123, '2015-01-15 00:24:35.000000', 'consum', 0.0213, 'lps'),
	(356908, 123, '2015-01-15 00:24:36.000000', 'consum', 0.0219, 'lps'),
	(356909, 123, '2015-01-15 00:24:37.000000', 'consum', 0.0212, 'lps'),
	(356910, 123, '2015-01-15 00:24:38.000000', 'consum', 0.0218, 'lps'),
	(356911, 123, '2015-01-15 00:24:39.000000', 'consum', 0.0221, 'lps'),
	(356912, 123, '2015-01-15 00:24:40.000000', 'consum', 0.0217, 'lps'),
	(356913, 123, '2015-01-15 00:24:41.000000', 'consum', 0.0214, 'lps'),
	(356914, 123, '2015-01-15 00:24:42.000000', 'consum', 0.0220, 'lps'),
	(356915, 123, '2015-01-15 00:24:43.000000', 'consum', 0.0213, 'lps'),
	(356916, 123, '2015-01-15 00:24:44.000000', 'consum', 0.0220, 'lps'),
	(356917, 123, '2015-01-15 00:24:45.000000', 'consum', 0.0217, 'lps'),
	(356918, 123, '2015-01-15 00:24:46.000000', 'consum', 0.0215, 'lps'),
	(356919, 123, '2015-01-15 00:24:47.000000', 'consum', 0.0213, 'lps'),
	(356920, 123, '2015-01-15 00:24:48.000000', 'consum', 0.0211, 'lps'),
	(356921, 123, '2015-01-15 00:24:49.000000', 'consum', 0.0219, 'lps'),
	(356922, 123, '2015-01-15 00:24:50.000000', 'consum', 0.0216, 'lps'),
	(356923, 123, '2015-01-15 00:24:51.000000', 'consum', 0.0215, 'lps'),
	(356924, 123, '2015-01-15 00:24:52.000000', 'consum', 0.0217, 'lps'),
	(356925, 123, '2015-01-15 00:24:53.000000', 'consum', 0.0217, 'lps'),
	(356926, 123, '2015-01-15 00:24:54.000000', 'consum', 0.0214, 'lps'),
	(356927, 123, '2015-01-15 00:24:55.000000', 'consum', 0.0219, 'lps'),
	(356928, 123, '2015-01-15 00:24:56.000000', 'consum', 0.0210, 'lps'),
	(356929, 123, '2015-01-15 00:24:57.000000', 'consum', 0.0220, 'lps'),
	(356930, 123, '2015-01-15 00:24:58.000000', 'consum', 0.0212, 'lps'),
	(356931, 123, '2015-01-15 00:24:59.000000', 'consum', 0.0215, 'lps'),
	(356932, 123, '2015-01-15 00:25:00.000000', 'consum', 0.0215, 'lps'),
	(356933, 123, '2015-01-15 00:25:01.000000', 'consum', 0.0211, 'lps'),
	(356934, 123, '2015-01-15 00:25:02.000000', 'consum', 0.0210, 'lps'),
	(356935, 123, '2015-01-15 00:25:03.000000', 'consum', 0.0220, 'lps'),
	(356936, 123, '2015-01-15 00:25:04.000000', 'consum', 0.0212, 'lps'),
	(356937, 123, '2015-01-15 00:25:05.000000', 'consum', 0.0213, 'lps'),
	(356938, 123, '2015-01-15 00:25:06.000000', 'consum', 0.0210, 'lps'),
	(356939, 123, '2015-01-15 00:25:07.000000', 'consum', 0.0213, 'lps'),
	(356940, 123, '2015-01-15 00:25:08.000000', 'consum', 0.0212, 'lps'),
	(356941, 123, '2015-01-15 00:25:09.000000', 'consum', 0.0213, 'lps'),
	(356942, 123, '2015-01-15 00:25:10.000000', 'consum', 0.0218, 'lps'),
	(356943, 123, '2015-01-15 00:25:11.000000', 'consum', 0.0220, 'lps'),
	(356944, 123, '2015-01-15 00:25:12.000000', 'consum', 0.0211, 'lps'),
	(356945, 123, '2015-01-15 00:25:13.000000', 'consum', 0.0220, 'lps'),
	(356946, 123, '2015-01-15 00:25:14.000000', 'consum', 0.0210, 'lps'),
	(356947, 123, '2015-01-15 00:25:15.000000', 'consum', 0.0218, 'lps'),
	(356948, 123, '2015-01-15 00:25:16.000000', 'consum', 0.0212, 'lps'),
	(356949, 123, '2015-01-15 00:25:17.000000', 'consum', 0.0210, 'lps'),
	(356950, 123, '2015-01-15 00:25:18.000000', 'consum', 0.0215, 'lps'),
	(356951, 123, '2015-01-15 00:25:19.000000', 'consum', 0.0211, 'lps'),
	(356952, 123, '2015-01-15 00:25:20.000000', 'consum', 0.0216, 'lps'),
	(356953, 123, '2015-01-15 00:25:21.000000', 'consum', 0.0210, 'lps'),
	(356954, 123, '2015-01-15 00:25:22.000000', 'consum', 0.0216, 'lps'),
	(356955, 123, '2015-01-15 00:25:23.000000', 'consum', 0.0220, 'lps'),
	(356956, 123, '2015-01-15 00:25:24.000000', 'consum', 0.0216, 'lps'),
	(356957, 123, '2015-01-15 00:25:25.000000', 'consum', 0.0212, 'lps'),
	(356958, 123, '2015-01-15 00:25:26.000000', 'consum', 0.0213, 'lps'),
	(356959, 123, '2015-01-15 00:25:27.000000', 'consum', 0.0220, 'lps'),
	(356960, 123, '2015-01-15 00:25:28.000000', 'consum', 0.0216, 'lps'),
	(356961, 123, '2015-01-15 00:25:29.000000', 'consum', 0.0210, 'lps'),
	(356962, 123, '2015-01-15 00:25:30.000000', 'consum', 0.0218, 'lps'),
	(356963, 123, '2015-01-15 00:25:31.000000', 'consum', 0.0215, 'lps'),
	(356964, 123, '2015-01-15 00:25:32.000000', 'consum', 0.0212, 'lps'),
	(356965, 123, '2015-01-15 00:25:33.000000', 'consum', 0.0215, 'lps'),
	(356966, 123, '2015-01-15 00:25:34.000000', 'consum', 0.0217, 'lps'),
	(356967, 123, '2015-01-15 00:25:35.000000', 'consum', 0.0220, 'lps'),
	(356968, 123, '2015-01-15 00:25:36.000000', 'consum', 0.0216, 'lps'),
	(356969, 123, '2015-01-15 00:25:37.000000', 'consum', 0.0211, 'lps'),
	(356970, 123, '2015-01-15 00:25:38.000000', 'consum', 0.0220, 'lps'),
	(356971, 123, '2015-01-15 00:25:39.000000', 'consum', 0.0210, 'lps'),
	(356972, 123, '2015-01-15 00:25:40.000000', 'consum', 0.0218, 'lps'),
	(356973, 123, '2015-01-15 00:25:41.000000', 'consum', 0.0212, 'lps'),
	(356974, 123, '2015-01-15 00:25:42.000000', 'consum', 0.0211, 'lps'),
	(356975, 123, '2015-01-15 00:25:43.000000', 'consum', 0.0210, 'lps'),
	(356976, 123, '2015-01-15 00:25:44.000000', 'consum', 0.0218, 'lps'),
	(356977, 123, '2015-01-15 00:25:45.000000', 'consum', 0.0216, 'lps'),
	(356978, 123, '2015-01-15 00:25:46.000000', 'consum', 0.0216, 'lps'),
	(356979, 123, '2015-01-15 00:25:47.000000', 'consum', 0.0212, 'lps'),
	(356980, 123, '2015-01-15 00:25:48.000000', 'consum', 0.0213, 'lps'),
	(356981, 123, '2015-01-15 00:25:49.000000', 'consum', 0.0218, 'lps'),
	(356982, 123, '2015-01-15 00:25:50.000000', 'consum', 0.0220, 'lps'),
	(356983, 123, '2015-01-15 00:25:51.000000', 'consum', 0.0210, 'lps'),
	(356984, 123, '2015-01-15 00:25:52.000000', 'consum', 0.0218, 'lps'),
	(356985, 123, '2015-01-15 00:25:53.000000', 'consum', 0.0213, 'lps'),
	(356986, 123, '2015-01-15 00:25:54.000000', 'consum', 0.0216, 'lps'),
	(356987, 123, '2015-01-15 00:25:55.000000', 'consum', 0.0219, 'lps'),
	(356988, 123, '2015-01-15 00:25:56.000000', 'consum', 0.0212, 'lps'),
	(356989, 123, '2015-01-15 00:25:57.000000', 'consum', 0.0217, 'lps'),
	(356990, 123, '2015-01-15 00:25:58.000000', 'consum', 0.0218, 'lps'),
	(356991, 123, '2015-01-15 00:25:59.000000', 'consum', 0.0214, 'lps'),
	(356992, 123, '2015-01-15 00:26:00.000000', 'consum', 0.0221, 'lps'),
	(356993, 123, '2015-01-15 00:26:01.000000', 'consum', 0.0217, 'lps'),
	(356994, 123, '2015-01-15 00:26:02.000000', 'consum', 0.0213, 'lps'),
	(356995, 123, '2015-01-15 00:26:03.000000', 'consum', 0.0217, 'lps'),
	(356996, 123, '2015-01-15 00:26:04.000000', 'consum', 0.0213, 'lps'),
	(356997, 123, '2015-01-15 00:26:05.000000', 'consum', 0.0215, 'lps'),
	(356998, 123, '2015-01-15 00:26:06.000000', 'consum', 0.0215, 'lps'),
	(356999, 123, '2015-01-15 00:26:07.000000', 'consum', 0.0220, 'lps'),
	(357000, 123, '2015-01-15 00:26:08.000000', 'consum', 0.0210, 'lps'),
	(357001, 123, '2015-01-15 00:26:09.000000', 'consum', 0.0218, 'lps'),
	(357002, 123, '2015-01-15 00:26:10.000000', 'consum', 0.0211, 'lps'),
	(357003, 123, '2015-01-15 00:26:11.000000', 'consum', 0.0219, 'lps'),
	(357004, 123, '2015-01-15 00:26:12.000000', 'consum', 0.0215, 'lps'),
	(357005, 123, '2015-01-15 00:26:13.000000', 'consum', 0.0210, 'lps'),
	(357006, 123, '2015-01-15 00:26:14.000000', 'consum', 0.0216, 'lps'),
	(357007, 123, '2015-01-15 00:26:15.000000', 'consum', 0.0220, 'lps'),
	(357008, 123, '2015-01-15 00:26:16.000000', 'consum', 0.0219, 'lps'),
	(357009, 123, '2015-01-15 00:26:17.000000', 'consum', 0.0213, 'lps'),
	(357010, 123, '2015-01-15 00:26:18.000000', 'consum', 0.0221, 'lps'),
	(357011, 123, '2015-01-15 00:26:19.000000', 'consum', 0.0220, 'lps'),
	(357012, 123, '2015-01-15 00:26:20.000000', 'consum', 0.0217, 'lps'),
	(357013, 123, '2015-01-15 00:26:21.000000', 'consum', 0.0214, 'lps'),
	(357014, 123, '2015-01-15 00:26:22.000000', 'consum', 0.0212, 'lps'),
	(357015, 123, '2015-01-15 00:26:23.000000', 'consum', 0.0219, 'lps'),
	(357016, 123, '2015-01-15 00:26:24.000000', 'consum', 0.0213, 'lps'),
	(357017, 123, '2015-01-15 00:26:25.000000', 'consum', 0.0210, 'lps'),
	(357018, 123, '2015-01-15 00:26:26.000000', 'consum', 0.0214, 'lps'),
	(357019, 123, '2015-01-15 00:26:27.000000', 'consum', 0.0218, 'lps'),
	(357020, 123, '2015-01-15 00:26:28.000000', 'consum', 0.0217, 'lps'),
	(357021, 123, '2015-01-15 00:26:29.000000', 'consum', 0.0219, 'lps'),
	(357022, 123, '2015-01-15 00:26:30.000000', 'consum', 0.0212, 'lps'),
	(357023, 123, '2015-01-15 00:26:31.000000', 'consum', 0.0215, 'lps'),
	(357024, 123, '2015-01-15 00:26:32.000000', 'consum', 0.0218, 'lps'),
	(357025, 123, '2015-01-15 00:26:33.000000', 'consum', 0.0214, 'lps'),
	(357026, 123, '2015-01-15 00:26:34.000000', 'consum', 0.0215, 'lps'),
	(357027, 123, '2015-01-15 00:26:35.000000', 'consum', 0.0214, 'lps'),
	(357028, 123, '2015-01-15 00:26:36.000000', 'consum', 0.0214, 'lps'),
	(357029, 123, '2015-01-15 00:26:37.000000', 'consum', 0.0220, 'lps'),
	(357030, 123, '2015-01-15 00:26:38.000000', 'consum', 0.0212, 'lps'),
	(357031, 123, '2015-01-15 00:26:39.000000', 'consum', 0.0215, 'lps'),
	(357032, 123, '2015-01-15 00:26:40.000000', 'consum', 0.0219, 'lps'),
	(357033, 123, '2015-01-15 00:26:41.000000', 'consum', 0.0213, 'lps'),
	(357034, 123, '2015-01-15 00:26:42.000000', 'consum', 0.0214, 'lps'),
	(357035, 123, '2015-01-15 00:26:43.000000', 'consum', 0.0221, 'lps'),
	(357036, 123, '2015-01-15 00:26:44.000000', 'consum', 0.0216, 'lps'),
	(357037, 123, '2015-01-15 00:26:45.000000', 'consum', 0.0219, 'lps'),
	(357038, 123, '2015-01-15 00:26:46.000000', 'consum', 0.0215, 'lps'),
	(357039, 123, '2015-01-15 00:26:47.000000', 'consum', 0.0219, 'lps'),
	(357040, 123, '2015-01-15 00:26:48.000000', 'consum', 0.0217, 'lps'),
	(357041, 123, '2015-01-15 00:26:49.000000', 'consum', 0.0218, 'lps'),
	(357042, 123, '2015-01-15 00:26:50.000000', 'consum', 0.0218, 'lps'),
	(357043, 123, '2015-01-15 00:26:51.000000', 'consum', 0.0216, 'lps'),
	(357044, 123, '2015-01-15 00:26:52.000000', 'consum', 0.0217, 'lps'),
	(357045, 123, '2015-01-15 00:26:53.000000', 'consum', 0.0212, 'lps'),
	(357046, 123, '2015-01-15 00:26:54.000000', 'consum', 0.0215, 'lps'),
	(357047, 123, '2015-01-15 00:26:55.000000', 'consum', 0.0217, 'lps'),
	(357048, 123, '2015-01-15 00:26:56.000000', 'consum', 0.0218, 'lps'),
	(357049, 123, '2015-01-15 00:26:57.000000', 'consum', 0.0216, 'lps'),
	(357050, 123, '2015-01-15 00:26:58.000000', 'consum', 0.0217, 'lps'),
	(357051, 123, '2015-01-15 00:26:59.000000', 'consum', 0.0216, 'lps'),
	(357052, 123, '2015-01-15 00:27:00.000000', 'consum', 0.0219, 'lps'),
	(357053, 123, '2015-01-15 00:27:01.000000', 'consum', 0.0214, 'lps'),
	(357054, 123, '2015-01-15 00:27:02.000000', 'consum', 0.0216, 'lps'),
	(357055, 123, '2015-01-15 00:27:03.000000', 'consum', 0.0215, 'lps'),
	(357056, 123, '2015-01-15 00:27:04.000000', 'consum', 0.0219, 'lps'),
	(357057, 123, '2015-01-15 00:27:05.000000', 'consum', 0.0216, 'lps'),
	(357058, 123, '2015-01-15 00:27:06.000000', 'consum', 0.0215, 'lps'),
	(357059, 123, '2015-01-15 00:27:07.000000', 'consum', 0.0217, 'lps'),
	(357060, 123, '2015-01-15 00:27:08.000000', 'consum', 0.0218, 'lps'),
	(357061, 123, '2015-01-15 00:27:09.000000', 'consum', 0.0219, 'lps'),
	(357062, 123, '2015-01-15 00:27:10.000000', 'consum', 0.0220, 'lps'),
	(357063, 123, '2015-01-15 00:27:11.000000', 'consum', 0.0221, 'lps'),
	(357064, 123, '2015-01-15 00:27:12.000000', 'consum', 0.0211, 'lps'),
	(357065, 123, '2015-01-15 00:27:13.000000', 'consum', 0.0219, 'lps'),
	(357066, 123, '2015-01-15 00:27:14.000000', 'consum', 0.0216, 'lps'),
	(357067, 123, '2015-01-15 00:27:15.000000', 'consum', 0.0212, 'lps'),
	(357068, 123, '2015-01-15 00:27:16.000000', 'consum', 0.0214, 'lps'),
	(357069, 123, '2015-01-15 00:27:17.000000', 'consum', 0.0212, 'lps'),
	(357070, 123, '2015-01-15 00:27:18.000000', 'consum', 0.0221, 'lps'),
	(357071, 123, '2015-01-15 00:27:19.000000', 'consum', 0.0213, 'lps'),
	(357072, 123, '2015-01-15 00:27:20.000000', 'consum', 0.0215, 'lps'),
	(357073, 123, '2015-01-15 00:27:21.000000', 'consum', 0.0217, 'lps'),
	(357074, 123, '2015-01-15 00:27:22.000000', 'consum', 0.0218, 'lps'),
	(357075, 123, '2015-01-15 00:27:23.000000', 'consum', 0.0216, 'lps'),
	(357076, 123, '2015-01-15 00:27:24.000000', 'consum', 0.0217, 'lps'),
	(357077, 123, '2015-01-15 00:27:25.000000', 'consum', 0.0215, 'lps'),
	(357078, 123, '2015-01-15 00:27:26.000000', 'consum', 0.0215, 'lps'),
	(357079, 123, '2015-01-15 00:27:27.000000', 'consum', 0.0219, 'lps'),
	(357080, 123, '2015-01-15 00:27:28.000000', 'consum', 0.0218, 'lps'),
	(357081, 123, '2015-01-15 00:27:29.000000', 'consum', 0.0212, 'lps'),
	(357082, 123, '2015-01-15 00:27:30.000000', 'consum', 0.0210, 'lps'),
	(357083, 123, '2015-01-15 00:27:31.000000', 'consum', 0.0214, 'lps'),
	(357084, 123, '2015-01-15 00:27:32.000000', 'consum', 0.0220, 'lps'),
	(357085, 123, '2015-01-15 00:27:33.000000', 'consum', 0.0210, 'lps'),
	(357086, 123, '2015-01-15 00:27:34.000000', 'consum', 0.0217, 'lps'),
	(357087, 123, '2015-01-15 00:27:35.000000', 'consum', 0.0212, 'lps'),
	(357088, 123, '2015-01-15 00:27:36.000000', 'consum', 0.0221, 'lps'),
	(357089, 123, '2015-01-15 00:27:37.000000', 'consum', 0.0211, 'lps'),
	(357090, 123, '2015-01-15 00:27:38.000000', 'consum', 0.0218, 'lps'),
	(357091, 123, '2015-01-15 00:27:39.000000', 'consum', 0.0215, 'lps'),
	(357092, 123, '2015-01-15 00:27:40.000000', 'consum', 0.0220, 'lps'),
	(357093, 123, '2015-01-15 00:27:41.000000', 'consum', 0.0210, 'lps'),
	(357094, 123, '2015-01-15 00:27:42.000000', 'consum', 0.0217, 'lps'),
	(357095, 123, '2015-01-15 00:27:43.000000', 'consum', 0.0211, 'lps'),
	(357096, 123, '2015-01-15 00:27:44.000000', 'consum', 0.0219, 'lps'),
	(357097, 123, '2015-01-15 00:27:45.000000', 'consum', 0.0216, 'lps'),
	(357098, 123, '2015-01-15 00:27:46.000000', 'consum', 0.0212, 'lps'),
	(357099, 123, '2015-01-15 00:27:47.000000', 'consum', 0.0217, 'lps'),
	(357100, 123, '2015-01-15 00:27:48.000000', 'consum', 0.0214, 'lps'),
	(357101, 123, '2015-01-15 00:27:49.000000', 'consum', 0.0210, 'lps'),
	(357102, 123, '2015-01-15 00:27:50.000000', 'consum', 0.0212, 'lps'),
	(357103, 123, '2015-01-15 00:27:51.000000', 'consum', 0.0218, 'lps'),
	(357104, 123, '2015-01-15 00:27:52.000000', 'consum', 0.0211, 'lps'),
	(357105, 123, '2015-01-15 00:27:53.000000', 'consum', 0.0212, 'lps'),
	(357106, 123, '2015-01-15 00:27:54.000000', 'consum', 0.0221, 'lps'),
	(357107, 123, '2015-01-15 00:27:55.000000', 'consum', 0.0211, 'lps'),
	(357108, 123, '2015-01-15 00:27:56.000000', 'consum', 0.0219, 'lps'),
	(357109, 123, '2015-01-15 00:27:57.000000', 'consum', 0.0214, 'lps'),
	(357110, 123, '2015-01-15 00:27:58.000000', 'consum', 0.0217, 'lps'),
	(357111, 123, '2015-01-15 00:27:59.000000', 'consum', 0.0220, 'lps'),
	(357112, 123, '2015-01-15 00:28:00.000000', 'consum', 0.0215, 'lps'),
	(357113, 123, '2015-01-15 00:28:01.000000', 'consum', 0.0218, 'lps'),
	(357114, 123, '2015-01-15 00:28:02.000000', 'consum', 0.0211, 'lps'),
	(357115, 123, '2015-01-15 00:28:03.000000', 'consum', 0.0216, 'lps'),
	(357116, 123, '2015-01-15 00:28:04.000000', 'consum', 0.0214, 'lps'),
	(357117, 123, '2015-01-15 00:28:05.000000', 'consum', 0.0210, 'lps'),
	(357118, 123, '2015-01-15 00:28:06.000000', 'consum', 0.0214, 'lps'),
	(357119, 123, '2015-01-15 00:28:07.000000', 'consum', 0.0216, 'lps'),
	(357120, 123, '2015-01-15 00:28:08.000000', 'consum', 0.0216, 'lps'),
	(357121, 123, '2015-01-15 00:28:09.000000', 'consum', 0.0212, 'lps'),
	(357122, 123, '2015-01-15 00:28:10.000000', 'consum', 0.0214, 'lps'),
	(357123, 123, '2015-01-15 00:28:11.000000', 'consum', 0.0212, 'lps'),
	(357124, 123, '2015-01-15 00:28:12.000000', 'consum', 0.0221, 'lps'),
	(357125, 123, '2015-01-15 00:28:13.000000', 'consum', 0.0212, 'lps'),
	(357126, 123, '2015-01-15 00:28:14.000000', 'consum', 0.0210, 'lps'),
	(357127, 123, '2015-01-15 00:28:15.000000', 'consum', 0.0218, 'lps'),
	(357128, 123, '2015-01-15 00:28:16.000000', 'consum', 0.0216, 'lps'),
	(357129, 123, '2015-01-15 00:28:17.000000', 'consum', 0.0214, 'lps'),
	(357130, 123, '2015-01-15 00:28:18.000000', 'consum', 0.0211, 'lps'),
	(357131, 123, '2015-01-15 00:28:19.000000', 'consum', 0.0219, 'lps'),
	(357132, 123, '2015-01-15 00:28:20.000000', 'consum', 0.0213, 'lps'),
	(357133, 123, '2015-01-15 00:28:21.000000', 'consum', 0.0212, 'lps'),
	(357134, 123, '2015-01-15 00:28:22.000000', 'consum', 0.0212, 'lps'),
	(357135, 123, '2015-01-15 00:28:23.000000', 'consum', 0.0214, 'lps'),
	(357136, 123, '2015-01-15 00:28:24.000000', 'consum', 0.0211, 'lps'),
	(357137, 123, '2015-01-15 00:28:25.000000', 'consum', 0.0218, 'lps'),
	(357138, 123, '2015-01-15 00:28:26.000000', 'consum', 0.0211, 'lps'),
	(357139, 123, '2015-01-15 00:28:27.000000', 'consum', 0.0216, 'lps'),
	(357140, 123, '2015-01-15 00:28:28.000000', 'consum', 0.0213, 'lps'),
	(357141, 123, '2015-01-15 00:28:29.000000', 'consum', 0.0220, 'lps'),
	(357142, 123, '2015-01-15 00:28:30.000000', 'consum', 0.0213, 'lps'),
	(357143, 123, '2015-01-15 00:28:31.000000', 'consum', 0.0221, 'lps'),
	(357144, 123, '2015-01-15 00:28:32.000000', 'consum', 0.0220, 'lps'),
	(357145, 123, '2015-01-15 00:28:33.000000', 'consum', 0.0215, 'lps'),
	(357146, 123, '2015-01-15 00:28:34.000000', 'consum', 0.0217, 'lps'),
	(357147, 123, '2015-01-15 00:28:35.000000', 'consum', 0.0219, 'lps'),
	(357148, 123, '2015-01-15 00:28:36.000000', 'consum', 0.0211, 'lps'),
	(357149, 123, '2015-01-15 00:28:37.000000', 'consum', 0.0211, 'lps'),
	(357150, 123, '2015-01-15 00:28:38.000000', 'consum', 0.0215, 'lps'),
	(357151, 123, '2015-01-15 00:28:39.000000', 'consum', 0.0221, 'lps'),
	(357152, 123, '2015-01-15 00:28:40.000000', 'consum', 0.0212, 'lps'),
	(357153, 123, '2015-01-15 00:28:41.000000', 'consum', 0.0210, 'lps'),
	(357154, 123, '2015-01-15 00:28:42.000000', 'consum', 0.0220, 'lps'),
	(357155, 123, '2015-01-15 00:28:43.000000', 'consum', 0.0213, 'lps'),
	(357156, 123, '2015-01-15 00:28:44.000000', 'consum', 0.0217, 'lps'),
	(357157, 123, '2015-01-15 00:28:45.000000', 'consum', 0.0215, 'lps'),
	(357158, 123, '2015-01-15 00:28:46.000000', 'consum', 0.0214, 'lps'),
	(357159, 123, '2015-01-15 00:28:47.000000', 'consum', 0.0213, 'lps'),
	(357160, 123, '2015-01-15 00:28:48.000000', 'consum', 0.0217, 'lps'),
	(357161, 123, '2015-01-15 00:28:49.000000', 'consum', 0.0210, 'lps'),
	(357162, 123, '2015-01-15 00:28:50.000000', 'consum', 0.0216, 'lps'),
	(357163, 123, '2015-01-15 00:28:51.000000', 'consum', 0.0213, 'lps'),
	(357164, 123, '2015-01-15 00:28:52.000000', 'consum', 0.0210, 'lps'),
	(357165, 123, '2015-01-15 00:28:53.000000', 'consum', 0.0214, 'lps'),
	(357166, 123, '2015-01-15 00:28:54.000000', 'consum', 0.0219, 'lps'),
	(357167, 123, '2015-01-15 00:28:55.000000', 'consum', 0.0219, 'lps'),
	(357168, 123, '2015-01-15 00:28:56.000000', 'consum', 0.0218, 'lps'),
	(357169, 123, '2015-01-15 00:28:57.000000', 'consum', 0.0211, 'lps'),
	(357170, 123, '2015-01-15 00:28:58.000000', 'consum', 0.0215, 'lps'),
	(357171, 123, '2015-01-15 00:28:59.000000', 'consum', 0.0210, 'lps'),
	(357172, 123, '2015-01-15 00:29:00.000000', 'consum', 0.0220, 'lps'),
	(357173, 123, '2015-01-15 00:29:01.000000', 'consum', 0.0213, 'lps'),
	(357174, 123, '2015-01-15 00:29:02.000000', 'consum', 0.0217, 'lps'),
	(357175, 123, '2015-01-15 00:29:03.000000', 'consum', 0.0212, 'lps'),
	(357176, 123, '2015-01-15 00:29:04.000000', 'consum', 0.0214, 'lps'),
	(357177, 123, '2015-01-15 00:29:05.000000', 'consum', 0.0213, 'lps'),
	(357178, 123, '2015-01-15 00:29:06.000000', 'consum', 0.0212, 'lps'),
	(357179, 123, '2015-01-15 00:29:07.000000', 'consum', 0.0213, 'lps'),
	(357180, 123, '2015-01-15 00:29:08.000000', 'consum', 0.0220, 'lps'),
	(357181, 123, '2015-01-15 00:29:09.000000', 'consum', 0.0216, 'lps'),
	(357182, 123, '2015-01-15 00:29:10.000000', 'consum', 0.0210, 'lps'),
	(357183, 123, '2015-01-15 00:29:11.000000', 'consum', 0.0216, 'lps'),
	(357184, 123, '2015-01-15 00:29:12.000000', 'consum', 0.0216, 'lps'),
	(357185, 123, '2015-01-15 00:29:13.000000', 'consum', 0.0221, 'lps'),
	(357186, 123, '2015-01-15 00:29:14.000000', 'consum', 0.0215, 'lps'),
	(357187, 123, '2015-01-15 00:29:15.000000', 'consum', 0.0212, 'lps'),
	(357188, 123, '2015-01-15 00:29:16.000000', 'consum', 0.0219, 'lps'),
	(357189, 123, '2015-01-15 00:29:17.000000', 'consum', 0.0212, 'lps'),
	(357190, 123, '2015-01-15 00:29:18.000000', 'consum', 0.0219, 'lps'),
	(357191, 123, '2015-01-15 00:29:19.000000', 'consum', 0.0211, 'lps'),
	(357192, 123, '2015-01-15 00:29:20.000000', 'consum', 0.0214, 'lps'),
	(357193, 123, '2015-01-15 00:29:21.000000', 'consum', 0.0215, 'lps'),
	(357194, 123, '2015-01-15 00:29:22.000000', 'consum', 0.0213, 'lps'),
	(357195, 123, '2015-01-15 00:29:23.000000', 'consum', 0.0210, 'lps'),
	(357196, 123, '2015-01-15 00:29:24.000000', 'consum', 0.0213, 'lps'),
	(357197, 123, '2015-01-15 00:29:25.000000', 'consum', 0.0212, 'lps'),
	(357198, 123, '2015-01-15 00:29:26.000000', 'consum', 0.0211, 'lps'),
	(357199, 123, '2015-01-15 00:29:27.000000', 'consum', 0.0221, 'lps'),
	(357200, 123, '2015-01-15 00:29:28.000000', 'consum', 0.0217, 'lps'),
	(357201, 123, '2015-01-15 00:29:29.000000', 'consum', 0.0211, 'lps'),
	(357202, 123, '2015-01-15 00:29:30.000000', 'consum', 0.0217, 'lps'),
	(357203, 123, '2015-01-15 00:29:31.000000', 'consum', 0.0219, 'lps'),
	(357204, 123, '2015-01-15 00:29:32.000000', 'consum', 0.0213, 'lps'),
	(357205, 123, '2015-01-15 00:29:33.000000', 'consum', 0.0219, 'lps'),
	(357206, 123, '2015-01-15 00:29:34.000000', 'consum', 0.0212, 'lps'),
	(357207, 123, '2015-01-15 00:29:35.000000', 'consum', 0.0220, 'lps'),
	(357208, 123, '2015-01-15 00:29:36.000000', 'consum', 0.0215, 'lps'),
	(357209, 123, '2015-01-15 00:29:37.000000', 'consum', 0.0218, 'lps'),
	(357210, 123, '2015-01-15 00:29:38.000000', 'consum', 0.0214, 'lps'),
	(357211, 123, '2015-01-15 00:29:39.000000', 'consum', 0.0217, 'lps'),
	(357212, 123, '2015-01-15 00:29:40.000000', 'consum', 0.0210, 'lps'),
	(357213, 123, '2015-01-15 00:29:41.000000', 'consum', 0.0215, 'lps'),
	(357214, 123, '2015-01-15 00:29:42.000000', 'consum', 0.0220, 'lps'),
	(357215, 123, '2015-01-15 00:29:43.000000', 'consum', 0.0213, 'lps'),
	(357216, 123, '2015-01-15 00:29:44.000000', 'consum', 0.0217, 'lps'),
	(357217, 123, '2015-01-15 00:29:45.000000', 'consum', 0.0213, 'lps'),
	(357218, 123, '2015-01-15 00:29:46.000000', 'consum', 0.0217, 'lps'),
	(357219, 123, '2015-01-15 00:29:47.000000', 'consum', 0.0214, 'lps'),
	(357220, 123, '2015-01-15 00:29:48.000000', 'consum', 0.0219, 'lps'),
	(357221, 123, '2015-01-15 00:29:49.000000', 'consum', 0.0219, 'lps'),
	(357222, 123, '2015-01-15 00:29:50.000000', 'consum', 0.0215, 'lps'),
	(357223, 123, '2015-01-15 00:29:51.000000', 'consum', 0.0212, 'lps'),
	(357224, 123, '2015-01-15 00:29:52.000000', 'consum', 0.0217, 'lps'),
	(357225, 123, '2015-01-15 00:29:53.000000', 'consum', 0.0213, 'lps'),
	(357226, 123, '2015-01-15 00:29:54.000000', 'consum', 0.0219, 'lps'),
	(357227, 123, '2015-01-15 00:29:55.000000', 'consum', 0.0212, 'lps'),
	(357228, 123, '2015-01-15 00:29:56.000000', 'consum', 0.0214, 'lps'),
	(357229, 123, '2015-01-15 00:29:57.000000', 'consum', 0.0214, 'lps'),
	(357230, 123, '2015-01-15 00:29:58.000000', 'consum', 0.0216, 'lps'),
	(357231, 123, '2015-01-15 00:29:59.000000', 'consum', 0.0220, 'lps'),
	(357232, 123, '2015-01-15 00:30:00.000000', 'consum', 0.0217, 'lps'),
	(357233, 123, '2015-01-15 00:30:01.000000', 'consum', 0.0216, 'lps'),
	(357234, 123, '2015-01-15 00:30:02.000000', 'consum', 0.0220, 'lps'),
	(357235, 123, '2015-01-15 00:30:03.000000', 'consum', 0.0217, 'lps'),
	(357236, 123, '2015-01-15 00:30:04.000000', 'consum', 0.0216, 'lps'),
	(357237, 123, '2015-01-15 00:30:05.000000', 'consum', 0.0218, 'lps'),
	(357238, 123, '2015-01-15 00:30:06.000000', 'consum', 0.0220, 'lps'),
	(357239, 123, '2015-01-15 00:30:07.000000', 'consum', 0.0213, 'lps'),
	(357240, 123, '2015-01-15 00:30:08.000000', 'consum', 0.0220, 'lps'),
	(357241, 123, '2015-01-15 00:30:09.000000', 'consum', 0.0214, 'lps'),
	(357242, 123, '2015-01-15 00:30:10.000000', 'consum', 0.0212, 'lps'),
	(357243, 123, '2015-01-15 00:30:11.000000', 'consum', 0.0210, 'lps'),
	(357244, 123, '2015-01-15 00:30:12.000000', 'consum', 0.0214, 'lps'),
	(357245, 123, '2015-01-15 00:30:13.000000', 'consum', 0.0221, 'lps'),
	(357246, 123, '2015-01-15 00:30:14.000000', 'consum', 0.0215, 'lps'),
	(357247, 123, '2015-01-15 00:30:15.000000', 'consum', 0.0216, 'lps'),
	(357248, 123, '2015-01-15 00:30:16.000000', 'consum', 0.0211, 'lps'),
	(357249, 123, '2015-01-15 00:30:17.000000', 'consum', 0.0212, 'lps'),
	(357250, 123, '2015-01-15 00:30:18.000000', 'consum', 0.0218, 'lps'),
	(357251, 123, '2015-01-15 00:30:19.000000', 'consum', 0.0220, 'lps'),
	(357252, 123, '2015-01-15 00:30:20.000000', 'consum', 0.0212, 'lps'),
	(357253, 123, '2015-01-15 00:30:21.000000', 'consum', 0.0213, 'lps'),
	(357254, 123, '2015-01-15 00:30:22.000000', 'consum', 0.0219, 'lps'),
	(357255, 123, '2015-01-15 00:30:23.000000', 'consum', 0.0213, 'lps'),
	(357256, 123, '2015-01-15 00:30:24.000000', 'consum', 0.0220, 'lps'),
	(357257, 123, '2015-01-15 00:30:25.000000', 'consum', 0.0215, 'lps'),
	(357258, 123, '2015-01-15 00:30:26.000000', 'consum', 0.0217, 'lps'),
	(357259, 123, '2015-01-15 00:30:27.000000', 'consum', 0.0219, 'lps'),
	(357260, 123, '2015-01-15 00:30:28.000000', 'consum', 0.0210, 'lps'),
	(357261, 123, '2015-01-15 00:30:29.000000', 'consum', 0.0221, 'lps'),
	(357262, 123, '2015-01-15 00:30:30.000000', 'consum', 0.0215, 'lps'),
	(357263, 123, '2015-01-15 00:30:31.000000', 'consum', 0.0218, 'lps'),
	(357264, 123, '2015-01-15 00:30:32.000000', 'consum', 0.0210, 'lps'),
	(357265, 123, '2015-01-15 00:30:33.000000', 'consum', 0.0221, 'lps'),
	(357266, 123, '2015-01-15 00:30:34.000000', 'consum', 0.0218, 'lps'),
	(357267, 123, '2015-01-15 00:30:35.000000', 'consum', 0.0216, 'lps'),
	(357268, 123, '2015-01-15 00:30:36.000000', 'consum', 0.0217, 'lps'),
	(357269, 123, '2015-01-15 00:30:37.000000', 'consum', 0.0217, 'lps'),
	(357270, 123, '2015-01-15 00:30:38.000000', 'consum', 0.0212, 'lps'),
	(357271, 123, '2015-01-15 00:30:39.000000', 'consum', 0.0212, 'lps'),
	(357272, 123, '2015-01-15 00:30:40.000000', 'consum', 0.0213, 'lps'),
	(357273, 123, '2015-01-15 00:30:41.000000', 'consum', 0.0221, 'lps'),
	(357274, 123, '2015-01-15 00:30:42.000000', 'consum', 0.0221, 'lps'),
	(357275, 123, '2015-01-15 00:30:43.000000', 'consum', 0.0210, 'lps'),
	(357276, 123, '2015-01-15 00:30:44.000000', 'consum', 0.0211, 'lps'),
	(357277, 123, '2015-01-15 00:30:45.000000', 'consum', 0.0217, 'lps'),
	(357278, 123, '2015-01-15 00:30:46.000000', 'consum', 0.0218, 'lps'),
	(357279, 123, '2015-01-15 00:30:47.000000', 'consum', 0.0219, 'lps'),
	(357280, 123, '2015-01-15 00:30:48.000000', 'consum', 0.0219, 'lps'),
	(357281, 123, '2015-01-15 00:30:49.000000', 'consum', 0.0215, 'lps'),
	(357282, 123, '2015-01-15 00:30:50.000000', 'consum', 0.0220, 'lps'),
	(357283, 123, '2015-01-15 00:30:51.000000', 'consum', 0.0221, 'lps'),
	(357284, 123, '2015-01-15 00:30:52.000000', 'consum', 0.0213, 'lps'),
	(357285, 123, '2015-01-15 00:30:53.000000', 'consum', 0.0216, 'lps'),
	(357286, 123, '2015-01-15 00:30:54.000000', 'consum', 0.0218, 'lps'),
	(357287, 123, '2015-01-15 00:30:55.000000', 'consum', 0.0211, 'lps'),
	(357288, 123, '2015-01-15 00:30:56.000000', 'consum', 0.0216, 'lps'),
	(357289, 123, '2015-01-15 00:30:57.000000', 'consum', 0.0213, 'lps'),
	(357290, 123, '2015-01-15 00:30:58.000000', 'consum', 0.0219, 'lps'),
	(357291, 123, '2015-01-15 00:30:59.000000', 'consum', 0.0221, 'lps'),
	(357292, 123, '2015-01-15 00:31:00.000000', 'consum', 0.0217, 'lps'),
	(357293, 123, '2015-01-15 00:31:01.000000', 'consum', 0.0210, 'lps'),
	(357294, 123, '2015-01-15 00:31:02.000000', 'consum', 0.0215, 'lps'),
	(357295, 123, '2015-01-15 00:31:03.000000', 'consum', 0.0211, 'lps'),
	(357296, 123, '2015-01-15 00:31:04.000000', 'consum', 0.0215, 'lps'),
	(357297, 123, '2015-01-15 00:31:05.000000', 'consum', 0.0218, 'lps'),
	(357298, 123, '2015-01-15 00:31:06.000000', 'consum', 0.0211, 'lps'),
	(357299, 123, '2015-01-15 00:31:07.000000', 'consum', 0.0215, 'lps'),
	(357300, 123, '2015-01-15 00:31:08.000000', 'consum', 0.0221, 'lps'),
	(357301, 123, '2015-01-15 00:31:09.000000', 'consum', 0.0213, 'lps'),
	(357302, 123, '2015-01-15 00:31:10.000000', 'consum', 0.0219, 'lps'),
	(357303, 123, '2015-01-15 00:31:11.000000', 'consum', 0.0210, 'lps'),
	(357304, 123, '2015-01-15 00:31:12.000000', 'consum', 0.0219, 'lps'),
	(357305, 123, '2015-01-15 00:31:13.000000', 'consum', 0.0220, 'lps'),
	(357306, 123, '2015-01-15 00:31:14.000000', 'consum', 0.0211, 'lps'),
	(357307, 123, '2015-01-15 00:31:15.000000', 'consum', 0.0210, 'lps'),
	(357308, 123, '2015-01-15 00:31:16.000000', 'consum', 0.0216, 'lps'),
	(357309, 123, '2015-01-15 00:31:17.000000', 'consum', 0.0219, 'lps'),
	(357310, 123, '2015-01-15 00:31:18.000000', 'consum', 0.0212, 'lps'),
	(357311, 123, '2015-01-15 00:31:19.000000', 'consum', 0.0218, 'lps'),
	(357312, 123, '2015-01-15 00:31:20.000000', 'consum', 0.0221, 'lps'),
	(357313, 123, '2015-01-15 00:31:21.000000', 'consum', 0.0217, 'lps'),
	(357314, 123, '2015-01-15 00:31:22.000000', 'consum', 0.0211, 'lps'),
	(357315, 123, '2015-01-15 00:31:23.000000', 'consum', 0.0219, 'lps'),
	(357316, 123, '2015-01-15 00:31:24.000000', 'consum', 0.0219, 'lps'),
	(357317, 123, '2015-01-15 00:31:25.000000', 'consum', 0.0215, 'lps'),
	(357318, 123, '2015-01-15 00:31:26.000000', 'consum', 0.0219, 'lps'),
	(357319, 123, '2015-01-15 00:31:27.000000', 'consum', 0.0216, 'lps'),
	(357320, 123, '2015-01-15 00:31:28.000000', 'consum', 0.0213, 'lps'),
	(357321, 123, '2015-01-15 00:31:29.000000', 'consum', 0.0210, 'lps'),
	(357322, 123, '2015-01-15 00:31:30.000000', 'consum', 0.0214, 'lps'),
	(357323, 123, '2015-01-15 00:31:31.000000', 'consum', 0.0216, 'lps'),
	(357324, 123, '2015-01-15 00:31:32.000000', 'consum', 0.0219, 'lps'),
	(357325, 123, '2015-01-15 00:31:33.000000', 'consum', 0.0213, 'lps'),
	(357326, 123, '2015-01-15 00:31:34.000000', 'consum', 0.0221, 'lps'),
	(357327, 123, '2015-01-15 00:31:35.000000', 'consum', 0.0210, 'lps'),
	(357328, 123, '2015-01-15 00:31:36.000000', 'consum', 0.0214, 'lps'),
	(357329, 123, '2015-01-15 00:31:37.000000', 'consum', 0.0216, 'lps'),
	(357330, 123, '2015-01-15 00:31:38.000000', 'consum', 0.0217, 'lps'),
	(357331, 123, '2015-01-15 00:31:39.000000', 'consum', 0.0216, 'lps'),
	(357332, 123, '2015-01-15 00:31:40.000000', 'consum', 0.0221, 'lps'),
	(357333, 123, '2015-01-15 00:31:41.000000', 'consum', 0.0211, 'lps'),
	(357334, 123, '2015-01-15 00:31:42.000000', 'consum', 0.0217, 'lps'),
	(357335, 123, '2015-01-15 00:31:43.000000', 'consum', 0.0219, 'lps'),
	(357336, 123, '2015-01-15 00:31:44.000000', 'consum', 0.0211, 'lps'),
	(357337, 123, '2015-01-15 00:31:45.000000', 'consum', 0.0214, 'lps'),
	(357338, 123, '2015-01-15 00:31:46.000000', 'consum', 0.0213, 'lps'),
	(357339, 123, '2015-01-15 00:31:47.000000', 'consum', 0.0216, 'lps'),
	(357340, 123, '2015-01-15 00:31:48.000000', 'consum', 0.0220, 'lps'),
	(357341, 123, '2015-01-15 00:31:49.000000', 'consum', 0.0219, 'lps'),
	(357342, 123, '2015-01-15 00:31:50.000000', 'consum', 0.0212, 'lps'),
	(357343, 123, '2015-01-15 00:31:51.000000', 'consum', 0.0220, 'lps'),
	(357344, 123, '2015-01-15 00:31:52.000000', 'consum', 0.0216, 'lps'),
	(357345, 123, '2015-01-15 00:31:53.000000', 'consum', 0.0210, 'lps'),
	(357346, 123, '2015-01-15 00:31:54.000000', 'consum', 0.0219, 'lps'),
	(357347, 123, '2015-01-15 00:31:55.000000', 'consum', 0.0219, 'lps'),
	(357348, 123, '2015-01-15 00:31:56.000000', 'consum', 0.0214, 'lps'),
	(357349, 123, '2015-01-15 00:31:57.000000', 'consum', 0.0218, 'lps'),
	(357350, 123, '2015-01-15 00:31:58.000000', 'consum', 0.0214, 'lps'),
	(357351, 123, '2015-01-15 00:31:59.000000', 'consum', 0.0216, 'lps'),
	(357352, 123, '2015-01-15 00:32:00.000000', 'consum', 0.0220, 'lps'),
	(357353, 123, '2015-01-15 00:32:01.000000', 'consum', 0.0216, 'lps'),
	(357354, 123, '2015-01-15 00:32:02.000000', 'consum', 0.0210, 'lps'),
	(357355, 123, '2015-01-15 00:32:03.000000', 'consum', 0.0219, 'lps'),
	(357356, 123, '2015-01-15 00:32:04.000000', 'consum', 0.0217, 'lps'),
	(357357, 123, '2015-01-15 00:32:05.000000', 'consum', 0.0221, 'lps'),
	(357358, 123, '2015-01-15 00:32:06.000000', 'consum', 0.0220, 'lps'),
	(357359, 123, '2015-01-15 00:32:07.000000', 'consum', 0.0217, 'lps'),
	(357360, 123, '2015-01-15 00:32:08.000000', 'consum', 0.0215, 'lps'),
	(357361, 123, '2015-01-15 00:32:09.000000', 'consum', 0.0214, 'lps'),
	(357362, 123, '2015-01-15 00:32:10.000000', 'consum', 0.0215, 'lps'),
	(357363, 123, '2015-01-15 00:32:11.000000', 'consum', 0.0214, 'lps'),
	(357364, 123, '2015-01-15 00:32:12.000000', 'consum', 0.0213, 'lps'),
	(357365, 123, '2015-01-15 00:32:13.000000', 'consum', 0.0214, 'lps'),
	(357366, 123, '2015-01-15 00:32:14.000000', 'consum', 0.0210, 'lps'),
	(357367, 123, '2015-01-15 00:32:15.000000', 'consum', 0.0212, 'lps'),
	(357368, 123, '2015-01-15 00:32:16.000000', 'consum', 0.0220, 'lps'),
	(357369, 123, '2015-01-15 00:32:17.000000', 'consum', 0.0220, 'lps'),
	(357370, 123, '2015-01-15 00:32:18.000000', 'consum', 0.0216, 'lps'),
	(357371, 123, '2015-01-15 00:32:19.000000', 'consum', 0.0211, 'lps'),
	(357372, 123, '2015-01-15 00:32:20.000000', 'consum', 0.0221, 'lps'),
	(357373, 123, '2015-01-15 00:32:21.000000', 'consum', 0.0214, 'lps'),
	(357374, 123, '2015-01-15 00:32:22.000000', 'consum', 0.0212, 'lps'),
	(357375, 123, '2015-01-15 00:32:23.000000', 'consum', 0.0218, 'lps'),
	(357376, 123, '2015-01-15 00:32:24.000000', 'consum', 0.0219, 'lps'),
	(357377, 123, '2015-01-15 00:32:25.000000', 'consum', 0.0211, 'lps'),
	(357378, 123, '2015-01-15 00:32:26.000000', 'consum', 0.0221, 'lps'),
	(357379, 123, '2015-01-15 00:32:27.000000', 'consum', 0.0217, 'lps'),
	(357380, 123, '2015-01-15 00:32:28.000000', 'consum', 0.0213, 'lps'),
	(357381, 123, '2015-01-15 00:32:29.000000', 'consum', 0.0218, 'lps'),
	(357382, 123, '2015-01-15 00:32:30.000000', 'consum', 0.0215, 'lps'),
	(357383, 123, '2015-01-15 00:32:31.000000', 'consum', 0.0212, 'lps'),
	(357384, 123, '2015-01-15 00:32:32.000000', 'consum', 0.0216, 'lps'),
	(357385, 123, '2015-01-15 00:32:33.000000', 'consum', 0.0211, 'lps'),
	(357386, 123, '2015-01-15 00:32:34.000000', 'consum', 0.0210, 'lps'),
	(357387, 123, '2015-01-15 00:32:35.000000', 'consum', 0.0221, 'lps'),
	(357388, 123, '2015-01-15 00:32:36.000000', 'consum', 0.0215, 'lps'),
	(357389, 123, '2015-01-15 00:32:37.000000', 'consum', 0.0217, 'lps'),
	(357390, 123, '2015-01-15 00:32:38.000000', 'consum', 0.0217, 'lps'),
	(357391, 123, '2015-01-15 00:32:39.000000', 'consum', 0.0211, 'lps'),
	(357392, 123, '2015-01-15 00:32:40.000000', 'consum', 0.0218, 'lps'),
	(357393, 123, '2015-01-15 00:32:41.000000', 'consum', 0.0215, 'lps'),
	(357394, 123, '2015-01-15 00:32:42.000000', 'consum', 0.0221, 'lps'),
	(357395, 123, '2015-01-15 00:32:43.000000', 'consum', 0.0213, 'lps'),
	(357396, 123, '2015-01-15 00:32:44.000000', 'consum', 0.0220, 'lps'),
	(357397, 123, '2015-01-15 00:32:45.000000', 'consum', 0.0213, 'lps'),
	(357398, 123, '2015-01-15 00:32:46.000000', 'consum', 0.0210, 'lps'),
	(357399, 123, '2015-01-15 00:32:47.000000', 'consum', 0.0213, 'lps'),
	(357400, 123, '2015-01-15 00:32:48.000000', 'consum', 0.0214, 'lps'),
	(357401, 123, '2015-01-15 00:32:49.000000', 'consum', 0.0219, 'lps'),
	(357402, 123, '2015-01-15 00:32:50.000000', 'consum', 0.0211, 'lps'),
	(357403, 123, '2015-01-15 00:32:51.000000', 'consum', 0.0210, 'lps'),
	(357404, 123, '2015-01-15 00:32:52.000000', 'consum', 0.0221, 'lps'),
	(357405, 123, '2015-01-15 00:32:53.000000', 'consum', 0.0219, 'lps'),
	(357406, 123, '2015-01-15 00:32:54.000000', 'consum', 0.0220, 'lps'),
	(357407, 123, '2015-01-15 00:32:55.000000', 'consum', 0.0221, 'lps'),
	(357408, 123, '2015-01-15 00:32:56.000000', 'consum', 0.0214, 'lps'),
	(357409, 123, '2015-01-15 00:32:57.000000', 'consum', 0.0220, 'lps'),
	(357410, 123, '2015-01-15 00:32:58.000000', 'consum', 0.0211, 'lps'),
	(357411, 123, '2015-01-15 00:32:59.000000', 'consum', 0.0221, 'lps'),
	(357412, 123, '2015-01-15 00:33:00.000000', 'consum', 0.0218, 'lps'),
	(357413, 123, '2015-01-15 00:33:01.000000', 'consum', 0.0215, 'lps'),
	(357414, 123, '2015-01-15 00:33:02.000000', 'consum', 0.0213, 'lps'),
	(357415, 123, '2015-01-15 00:33:03.000000', 'consum', 0.0221, 'lps'),
	(357416, 123, '2015-01-15 00:33:04.000000', 'consum', 0.0210, 'lps'),
	(357417, 123, '2015-01-15 00:33:05.000000', 'consum', 0.0214, 'lps'),
	(357418, 123, '2015-01-15 00:33:06.000000', 'consum', 0.0219, 'lps'),
	(357419, 123, '2015-01-15 00:33:07.000000', 'consum', 0.0218, 'lps'),
	(357420, 123, '2015-01-15 00:33:08.000000', 'consum', 0.0213, 'lps'),
	(357421, 123, '2015-01-15 00:33:09.000000', 'consum', 0.0213, 'lps'),
	(357422, 123, '2015-01-15 00:33:10.000000', 'consum', 0.0216, 'lps'),
	(357423, 123, '2015-01-15 00:33:11.000000', 'consum', 0.0221, 'lps'),
	(357424, 123, '2015-01-15 00:33:12.000000', 'consum', 0.0211, 'lps'),
	(357425, 123, '2015-01-15 00:33:13.000000', 'consum', 0.0219, 'lps'),
	(357426, 123, '2015-01-15 00:33:14.000000', 'consum', 0.0215, 'lps'),
	(357427, 123, '2015-01-15 00:33:15.000000', 'consum', 0.0219, 'lps'),
	(357428, 123, '2015-01-15 00:33:16.000000', 'consum', 0.0219, 'lps'),
	(357429, 123, '2015-01-15 00:33:17.000000', 'consum', 0.0218, 'lps'),
	(357430, 123, '2015-01-15 00:33:18.000000', 'consum', 0.0210, 'lps'),
	(357431, 123, '2015-01-15 00:33:19.000000', 'consum', 0.0221, 'lps'),
	(357432, 123, '2015-01-15 00:33:20.000000', 'consum', 0.0219, 'lps'),
	(357433, 123, '2015-01-15 00:33:21.000000', 'consum', 0.0221, 'lps'),
	(357434, 123, '2015-01-15 00:33:22.000000', 'consum', 0.0217, 'lps'),
	(357435, 123, '2015-01-15 00:33:23.000000', 'consum', 0.0212, 'lps'),
	(357436, 123, '2015-01-15 00:33:24.000000', 'consum', 0.0211, 'lps'),
	(357437, 123, '2015-01-15 00:33:25.000000', 'consum', 0.0210, 'lps'),
	(357438, 123, '2015-01-15 00:33:26.000000', 'consum', 0.0221, 'lps'),
	(357439, 123, '2015-01-15 00:33:27.000000', 'consum', 0.0217, 'lps'),
	(357440, 123, '2015-01-15 00:33:28.000000', 'consum', 0.0210, 'lps'),
	(357441, 123, '2015-01-15 00:33:29.000000', 'consum', 0.0215, 'lps'),
	(357442, 123, '2015-01-15 00:33:30.000000', 'consum', 0.0211, 'lps'),
	(357443, 123, '2015-01-15 00:33:31.000000', 'consum', 0.0212, 'lps'),
	(357444, 123, '2015-01-15 00:33:32.000000', 'consum', 0.0219, 'lps'),
	(357445, 123, '2015-01-15 00:33:33.000000', 'consum', 0.0212, 'lps'),
	(357446, 123, '2015-01-15 00:33:34.000000', 'consum', 0.0217, 'lps'),
	(357447, 123, '2015-01-15 00:33:35.000000', 'consum', 0.0217, 'lps'),
	(357448, 123, '2015-01-15 00:33:36.000000', 'consum', 0.0214, 'lps'),
	(357449, 123, '2015-01-15 00:33:37.000000', 'consum', 0.0219, 'lps'),
	(357450, 123, '2015-01-15 00:33:38.000000', 'consum', 0.0219, 'lps'),
	(357451, 123, '2015-01-15 00:33:39.000000', 'consum', 0.0216, 'lps'),
	(357452, 123, '2015-01-15 00:33:40.000000', 'consum', 0.0215, 'lps'),
	(357453, 123, '2015-01-15 00:33:41.000000', 'consum', 0.0216, 'lps'),
	(357454, 123, '2015-01-15 00:33:42.000000', 'consum', 0.0216, 'lps'),
	(357455, 123, '2015-01-15 00:33:43.000000', 'consum', 0.0221, 'lps'),
	(357456, 123, '2015-01-15 00:33:44.000000', 'consum', 0.0212, 'lps'),
	(357457, 123, '2015-01-15 00:33:45.000000', 'consum', 0.0210, 'lps'),
	(357458, 123, '2015-01-15 00:33:46.000000', 'consum', 0.0218, 'lps'),
	(357459, 123, '2015-01-15 00:33:47.000000', 'consum', 0.0212, 'lps'),
	(357460, 123, '2015-01-15 00:33:48.000000', 'consum', 0.0210, 'lps'),
	(357461, 123, '2015-01-15 00:33:49.000000', 'consum', 0.0218, 'lps'),
	(357462, 123, '2015-01-15 00:33:50.000000', 'consum', 0.0214, 'lps'),
	(357463, 123, '2015-01-15 00:33:51.000000', 'consum', 0.0218, 'lps'),
	(357464, 123, '2015-01-15 00:33:52.000000', 'consum', 0.0213, 'lps'),
	(357465, 123, '2015-01-15 00:33:53.000000', 'consum', 0.0216, 'lps'),
	(357466, 123, '2015-01-15 00:33:54.000000', 'consum', 0.0219, 'lps'),
	(357467, 123, '2015-01-15 00:33:55.000000', 'consum', 0.0212, 'lps'),
	(357468, 123, '2015-01-15 00:33:56.000000', 'consum', 0.0219, 'lps'),
	(357469, 123, '2015-01-15 00:33:57.000000', 'consum', 0.0215, 'lps'),
	(357470, 123, '2015-01-15 00:33:58.000000', 'consum', 0.0218, 'lps'),
	(357471, 123, '2015-01-15 00:33:59.000000', 'consum', 0.0212, 'lps'),
	(357472, 123, '2015-01-15 00:34:00.000000', 'consum', 0.0221, 'lps'),
	(357473, 123, '2015-01-15 00:34:01.000000', 'consum', 0.0213, 'lps'),
	(357474, 123, '2015-01-15 00:34:02.000000', 'consum', 0.0217, 'lps'),
	(357475, 123, '2015-01-15 00:34:03.000000', 'consum', 0.0210, 'lps'),
	(357476, 123, '2015-01-15 00:34:04.000000', 'consum', 0.0216, 'lps'),
	(357477, 123, '2015-01-15 00:34:05.000000', 'consum', 0.0216, 'lps'),
	(357478, 123, '2015-01-15 00:34:06.000000', 'consum', 0.0220, 'lps'),
	(357479, 123, '2015-01-15 00:34:07.000000', 'consum', 0.0220, 'lps'),
	(357480, 123, '2015-01-15 00:34:08.000000', 'consum', 0.0219, 'lps'),
	(357481, 123, '2015-01-15 00:34:09.000000', 'consum', 0.0211, 'lps'),
	(357482, 123, '2015-01-15 00:34:10.000000', 'consum', 0.0216, 'lps'),
	(357483, 123, '2015-01-15 00:34:11.000000', 'consum', 0.0210, 'lps'),
	(357484, 123, '2015-01-15 00:34:12.000000', 'consum', 0.0219, 'lps'),
	(357485, 123, '2015-01-15 00:34:13.000000', 'consum', 0.0219, 'lps'),
	(357486, 123, '2015-01-15 00:34:14.000000', 'consum', 0.0215, 'lps'),
	(357487, 123, '2015-01-15 00:34:15.000000', 'consum', 0.0221, 'lps'),
	(357488, 123, '2015-01-15 00:34:16.000000', 'consum', 0.0215, 'lps'),
	(357489, 123, '2015-01-15 00:34:17.000000', 'consum', 0.0216, 'lps'),
	(357490, 123, '2015-01-15 00:34:18.000000', 'consum', 0.0211, 'lps'),
	(357491, 123, '2015-01-15 00:34:19.000000', 'consum', 0.0221, 'lps'),
	(357492, 123, '2015-01-15 00:34:20.000000', 'consum', 0.0217, 'lps'),
	(357493, 123, '2015-01-15 00:34:21.000000', 'consum', 0.0210, 'lps'),
	(357494, 123, '2015-01-15 00:34:22.000000', 'consum', 0.0216, 'lps'),
	(357495, 123, '2015-01-15 00:34:23.000000', 'consum', 0.0216, 'lps'),
	(357496, 123, '2015-01-15 00:34:24.000000', 'consum', 0.0211, 'lps'),
	(357497, 123, '2015-01-15 00:34:25.000000', 'consum', 0.0210, 'lps'),
	(357498, 123, '2015-01-15 00:34:26.000000', 'consum', 0.0220, 'lps'),
	(357499, 123, '2015-01-15 00:34:27.000000', 'consum', 0.0212, 'lps'),
	(357500, 123, '2015-01-15 00:34:28.000000', 'consum', 0.0215, 'lps'),
	(357501, 123, '2015-01-15 00:34:29.000000', 'consum', 0.0216, 'lps'),
	(357502, 123, '2015-01-15 00:34:30.000000', 'consum', 0.0216, 'lps'),
	(357503, 123, '2015-01-15 00:34:31.000000', 'consum', 0.0221, 'lps'),
	(357504, 123, '2015-01-15 00:34:32.000000', 'consum', 0.0210, 'lps'),
	(357505, 123, '2015-01-15 00:34:33.000000', 'consum', 0.0215, 'lps'),
	(357506, 123, '2015-01-15 00:34:34.000000', 'consum', 0.0211, 'lps'),
	(357507, 123, '2015-01-15 00:34:35.000000', 'consum', 0.0215, 'lps'),
	(357508, 123, '2015-01-15 00:34:36.000000', 'consum', 0.0217, 'lps'),
	(357509, 123, '2015-01-15 00:34:37.000000', 'consum', 0.0219, 'lps'),
	(357510, 123, '2015-01-15 00:34:38.000000', 'consum', 0.0210, 'lps'),
	(357511, 123, '2015-01-15 00:34:39.000000', 'consum', 0.0210, 'lps'),
	(357512, 123, '2015-01-15 00:34:40.000000', 'consum', 0.0221, 'lps'),
	(357513, 123, '2015-01-15 00:34:41.000000', 'consum', 0.0219, 'lps'),
	(357514, 123, '2015-01-15 00:34:42.000000', 'consum', 0.0211, 'lps'),
	(357515, 123, '2015-01-15 00:34:43.000000', 'consum', 0.0210, 'lps'),
	(357516, 123, '2015-01-15 00:34:44.000000', 'consum', 0.0220, 'lps'),
	(357517, 123, '2015-01-15 00:34:45.000000', 'consum', 0.0214, 'lps'),
	(357518, 123, '2015-01-15 00:34:46.000000', 'consum', 0.0212, 'lps'),
	(357519, 123, '2015-01-15 00:34:47.000000', 'consum', 0.0219, 'lps'),
	(357520, 123, '2015-01-15 00:34:48.000000', 'consum', 0.0214, 'lps'),
	(357521, 123, '2015-01-15 00:34:49.000000', 'consum', 0.0216, 'lps'),
	(357522, 123, '2015-01-15 00:34:50.000000', 'consum', 0.0218, 'lps'),
	(357523, 123, '2015-01-15 00:34:51.000000', 'consum', 0.0218, 'lps'),
	(357524, 123, '2015-01-15 00:34:52.000000', 'consum', 0.0217, 'lps'),
	(357525, 123, '2015-01-15 00:34:53.000000', 'consum', 0.0218, 'lps'),
	(357526, 123, '2015-01-15 00:34:54.000000', 'consum', 0.0220, 'lps'),
	(357527, 123, '2015-01-15 00:34:55.000000', 'consum', 0.0214, 'lps'),
	(357528, 123, '2015-01-15 00:34:56.000000', 'consum', 0.0211, 'lps'),
	(357529, 123, '2015-01-15 00:34:57.000000', 'consum', 0.0216, 'lps'),
	(357530, 123, '2015-01-15 00:34:58.000000', 'consum', 0.0214, 'lps'),
	(357531, 123, '2015-01-15 00:34:59.000000', 'consum', 0.0212, 'lps'),
	(357532, 123, '2015-01-15 00:35:00.000000', 'consum', 0.0219, 'lps'),
	(357533, 123, '2015-01-15 00:35:01.000000', 'consum', 0.0216, 'lps'),
	(357534, 123, '2015-01-15 00:35:02.000000', 'consum', 0.0214, 'lps'),
	(357535, 123, '2015-01-15 00:35:03.000000', 'consum', 0.0211, 'lps'),
	(357536, 123, '2015-01-15 00:35:04.000000', 'consum', 0.0216, 'lps'),
	(357537, 123, '2015-01-15 00:35:05.000000', 'consum', 0.0215, 'lps'),
	(357538, 123, '2015-01-15 00:35:06.000000', 'consum', 0.0215, 'lps'),
	(357539, 123, '2015-01-15 00:35:07.000000', 'consum', 0.0219, 'lps'),
	(357540, 123, '2015-01-15 00:35:08.000000', 'consum', 0.0220, 'lps'),
	(357541, 123, '2015-01-15 00:35:09.000000', 'consum', 0.0221, 'lps'),
	(357542, 123, '2015-01-15 00:35:10.000000', 'consum', 0.0221, 'lps'),
	(357543, 123, '2015-01-15 00:35:11.000000', 'consum', 0.0212, 'lps'),
	(357544, 123, '2015-01-15 00:35:12.000000', 'consum', 0.0221, 'lps'),
	(357545, 123, '2015-01-15 00:35:13.000000', 'consum', 0.0213, 'lps'),
	(357546, 123, '2015-01-15 00:35:14.000000', 'consum', 0.0217, 'lps'),
	(357547, 123, '2015-01-15 00:35:15.000000', 'consum', 0.0210, 'lps'),
	(357548, 123, '2015-01-15 00:35:16.000000', 'consum', 0.0214, 'lps'),
	(357549, 123, '2015-01-15 00:35:17.000000', 'consum', 0.0219, 'lps'),
	(357550, 123, '2015-01-15 00:35:18.000000', 'consum', 0.0221, 'lps'),
	(357551, 123, '2015-01-15 00:35:19.000000', 'consum', 0.0214, 'lps'),
	(357552, 123, '2015-01-15 00:35:20.000000', 'consum', 0.0211, 'lps'),
	(357553, 123, '2015-01-15 00:35:21.000000', 'consum', 0.0215, 'lps'),
	(357554, 123, '2015-01-15 00:35:22.000000', 'consum', 0.0218, 'lps'),
	(357555, 123, '2015-01-15 00:35:23.000000', 'consum', 0.0214, 'lps'),
	(357556, 123, '2015-01-15 00:35:24.000000', 'consum', 0.0218, 'lps'),
	(357557, 123, '2015-01-15 00:35:25.000000', 'consum', 0.0215, 'lps'),
	(357558, 123, '2015-01-15 00:35:26.000000', 'consum', 0.0210, 'lps'),
	(357559, 123, '2015-01-15 00:35:27.000000', 'consum', 0.0220, 'lps'),
	(357560, 123, '2015-01-15 00:35:28.000000', 'consum', 0.0211, 'lps'),
	(357561, 123, '2015-01-15 00:35:29.000000', 'consum', 0.0210, 'lps'),
	(357562, 123, '2015-01-15 00:35:30.000000', 'consum', 0.0219, 'lps'),
	(357563, 123, '2015-01-15 00:35:31.000000', 'consum', 0.0218, 'lps'),
	(357564, 123, '2015-01-15 00:35:32.000000', 'consum', 0.0215, 'lps'),
	(357565, 123, '2015-01-15 00:35:33.000000', 'consum', 0.0220, 'lps'),
	(357566, 123, '2015-01-15 00:35:34.000000', 'consum', 0.0212, 'lps'),
	(357567, 123, '2015-01-15 00:35:35.000000', 'consum', 0.0215, 'lps'),
	(357568, 123, '2015-01-15 00:35:36.000000', 'consum', 0.0217, 'lps'),
	(357569, 123, '2015-01-15 00:35:37.000000', 'consum', 0.0218, 'lps'),
	(357570, 123, '2015-01-15 00:35:38.000000', 'consum', 0.0219, 'lps'),
	(357571, 123, '2015-01-15 00:35:39.000000', 'consum', 0.0219, 'lps'),
	(357572, 123, '2015-01-15 00:35:40.000000', 'consum', 0.0216, 'lps'),
	(357573, 123, '2015-01-15 00:35:41.000000', 'consum', 0.0215, 'lps'),
	(357574, 123, '2015-01-15 00:35:42.000000', 'consum', 0.0216, 'lps'),
	(357575, 123, '2015-01-15 00:35:43.000000', 'consum', 0.0213, 'lps'),
	(357576, 123, '2015-01-15 00:35:44.000000', 'consum', 0.0220, 'lps'),
	(357577, 123, '2015-01-15 00:35:45.000000', 'consum', 0.0216, 'lps'),
	(357578, 123, '2015-01-15 00:35:46.000000', 'consum', 0.0210, 'lps'),
	(357579, 123, '2015-01-15 00:35:47.000000', 'consum', 0.0215, 'lps'),
	(357580, 123, '2015-01-15 00:35:48.000000', 'consum', 0.0211, 'lps'),
	(357581, 123, '2015-01-15 00:35:49.000000', 'consum', 0.0212, 'lps'),
	(357582, 123, '2015-01-15 00:35:50.000000', 'consum', 0.0220, 'lps'),
	(357583, 123, '2015-01-15 00:35:51.000000', 'consum', 0.0217, 'lps'),
	(357584, 123, '2015-01-15 00:35:52.000000', 'consum', 0.0215, 'lps'),
	(357585, 123, '2015-01-15 00:35:53.000000', 'consum', 0.0214, 'lps'),
	(357586, 123, '2015-01-15 00:35:54.000000', 'consum', 0.0218, 'lps'),
	(357587, 123, '2015-01-15 00:35:55.000000', 'consum', 0.0215, 'lps'),
	(357588, 123, '2015-01-15 00:35:56.000000', 'consum', 0.0211, 'lps'),
	(357589, 123, '2015-01-15 00:35:57.000000', 'consum', 0.0211, 'lps'),
	(357590, 123, '2015-01-15 00:35:58.000000', 'consum', 0.0213, 'lps'),
	(357591, 123, '2015-01-15 00:35:59.000000', 'consum', 0.0210, 'lps'),
	(357592, 123, '2015-01-15 00:36:00.000000', 'consum', 0.0213, 'lps'),
	(357593, 123, '2015-01-15 00:36:01.000000', 'consum', 0.0214, 'lps'),
	(357594, 123, '2015-01-15 00:36:02.000000', 'consum', 0.0211, 'lps'),
	(357595, 123, '2015-01-15 00:36:03.000000', 'consum', 0.0213, 'lps'),
	(357596, 123, '2015-01-15 00:36:04.000000', 'consum', 0.0210, 'lps'),
	(357597, 123, '2015-01-15 00:36:05.000000', 'consum', 0.0215, 'lps'),
	(357598, 123, '2015-01-15 00:36:06.000000', 'consum', 0.0212, 'lps'),
	(357599, 123, '2015-01-15 00:36:07.000000', 'consum', 0.0217, 'lps'),
	(357600, 123, '2015-01-15 00:36:08.000000', 'consum', 0.0214, 'lps'),
	(357601, 123, '2015-01-15 00:36:09.000000', 'consum', 0.0221, 'lps'),
	(357602, 123, '2015-01-15 00:36:10.000000', 'consum', 0.0219, 'lps'),
	(357603, 123, '2015-01-15 00:36:11.000000', 'consum', 0.0210, 'lps'),
	(357604, 123, '2015-01-15 00:36:12.000000', 'consum', 0.0218, 'lps'),
	(357605, 123, '2015-01-15 00:36:13.000000', 'consum', 0.0216, 'lps'),
	(357606, 123, '2015-01-15 00:36:14.000000', 'consum', 0.0216, 'lps'),
	(357607, 123, '2015-01-15 00:36:15.000000', 'consum', 0.0210, 'lps'),
	(357608, 123, '2015-01-15 00:36:16.000000', 'consum', 0.0218, 'lps'),
	(357609, 123, '2015-01-15 00:36:17.000000', 'consum', 0.0214, 'lps'),
	(357610, 123, '2015-01-15 00:36:18.000000', 'consum', 0.0218, 'lps'),
	(357611, 123, '2015-01-15 00:36:19.000000', 'consum', 0.0214, 'lps'),
	(357612, 123, '2015-01-15 00:36:20.000000', 'consum', 0.0219, 'lps'),
	(357613, 123, '2015-01-15 00:36:21.000000', 'consum', 0.0218, 'lps'),
	(357614, 123, '2015-01-15 00:36:22.000000', 'consum', 0.0213, 'lps'),
	(357615, 123, '2015-01-15 00:36:23.000000', 'consum', 0.0213, 'lps'),
	(357616, 123, '2015-01-15 00:36:24.000000', 'consum', 0.0215, 'lps'),
	(357617, 123, '2015-01-15 00:36:25.000000', 'consum', 0.0214, 'lps'),
	(357618, 123, '2015-01-15 00:36:26.000000', 'consum', 0.0217, 'lps'),
	(357619, 123, '2015-01-15 00:36:27.000000', 'consum', 0.0210, 'lps'),
	(357620, 123, '2015-01-15 00:36:28.000000', 'consum', 0.0214, 'lps'),
	(357621, 123, '2015-01-15 00:36:29.000000', 'consum', 0.0219, 'lps'),
	(357622, 123, '2015-01-15 00:36:30.000000', 'consum', 0.0218, 'lps'),
	(357623, 123, '2015-01-15 00:36:31.000000', 'consum', 0.0210, 'lps'),
	(357624, 123, '2015-01-15 00:36:32.000000', 'consum', 0.0213, 'lps'),
	(357625, 123, '2015-01-15 00:36:33.000000', 'consum', 0.0214, 'lps'),
	(357626, 123, '2015-01-15 00:36:34.000000', 'consum', 0.0221, 'lps'),
	(357627, 123, '2015-01-15 00:36:35.000000', 'consum', 0.0218, 'lps'),
	(357628, 123, '2015-01-15 00:36:36.000000', 'consum', 0.0217, 'lps'),
	(357629, 123, '2015-01-15 00:36:37.000000', 'consum', 0.0211, 'lps'),
	(357630, 123, '2015-01-15 00:36:38.000000', 'consum', 0.0216, 'lps'),
	(357631, 123, '2015-01-15 00:36:39.000000', 'consum', 0.0216, 'lps'),
	(357632, 123, '2015-01-15 00:36:40.000000', 'consum', 0.0210, 'lps'),
	(357633, 123, '2015-01-15 00:36:41.000000', 'consum', 0.0218, 'lps'),
	(357634, 123, '2015-01-15 00:36:42.000000', 'consum', 0.0214, 'lps'),
	(357635, 123, '2015-01-15 00:36:43.000000', 'consum', 0.0217, 'lps'),
	(357636, 123, '2015-01-15 00:36:44.000000', 'consum', 0.0221, 'lps'),
	(357637, 123, '2015-01-15 00:36:45.000000', 'consum', 0.0220, 'lps'),
	(357638, 123, '2015-01-15 00:36:46.000000', 'consum', 0.0215, 'lps'),
	(357639, 123, '2015-01-15 00:36:47.000000', 'consum', 0.0219, 'lps'),
	(357640, 123, '2015-01-15 00:36:48.000000', 'consum', 0.0216, 'lps'),
	(357641, 123, '2015-01-15 00:36:49.000000', 'consum', 0.0213, 'lps'),
	(357642, 123, '2015-01-15 00:36:50.000000', 'consum', 0.0218, 'lps'),
	(357643, 123, '2015-01-15 00:36:51.000000', 'consum', 0.0220, 'lps'),
	(357644, 123, '2015-01-15 00:36:52.000000', 'consum', 0.0211, 'lps'),
	(357645, 123, '2015-01-15 00:36:53.000000', 'consum', 0.0212, 'lps'),
	(357646, 123, '2015-01-15 00:36:54.000000', 'consum', 0.0215, 'lps'),
	(357647, 123, '2015-01-15 00:36:55.000000', 'consum', 0.0219, 'lps'),
	(357648, 123, '2015-01-15 00:36:56.000000', 'consum', 0.0216, 'lps'),
	(357649, 123, '2015-01-15 00:36:57.000000', 'consum', 0.0214, 'lps'),
	(357650, 123, '2015-01-15 00:36:58.000000', 'consum', 0.0211, 'lps'),
	(357651, 123, '2015-01-15 00:36:59.000000', 'consum', 0.0216, 'lps'),
	(357652, 123, '2015-01-15 00:37:00.000000', 'consum', 0.0213, 'lps'),
	(357653, 123, '2015-01-15 00:37:01.000000', 'consum', 0.0220, 'lps'),
	(357654, 123, '2015-01-15 00:37:02.000000', 'consum', 0.0215, 'lps'),
	(357655, 123, '2015-01-15 00:37:03.000000', 'consum', 0.0219, 'lps'),
	(357656, 123, '2015-01-15 00:37:04.000000', 'consum', 0.0216, 'lps'),
	(357657, 123, '2015-01-15 00:37:05.000000', 'consum', 0.0214, 'lps'),
	(357658, 123, '2015-01-15 00:37:06.000000', 'consum', 0.0213, 'lps'),
	(357659, 123, '2015-01-15 00:37:07.000000', 'consum', 0.0213, 'lps'),
	(357660, 123, '2015-01-15 00:37:08.000000', 'consum', 0.0216, 'lps'),
	(357661, 123, '2015-01-15 00:37:09.000000', 'consum', 0.0219, 'lps'),
	(357662, 123, '2015-01-15 00:37:10.000000', 'consum', 0.0214, 'lps'),
	(357663, 123, '2015-01-15 00:37:11.000000', 'consum', 0.0216, 'lps'),
	(357664, 123, '2015-01-15 00:37:12.000000', 'consum', 0.0216, 'lps'),
	(357665, 123, '2015-01-15 00:37:13.000000', 'consum', 0.0213, 'lps'),
	(357666, 123, '2015-01-15 00:37:14.000000', 'consum', 0.0216, 'lps'),
	(357667, 123, '2015-01-15 00:37:15.000000', 'consum', 0.0211, 'lps'),
	(357668, 123, '2015-01-15 00:37:16.000000', 'consum', 0.0218, 'lps'),
	(357669, 123, '2015-01-15 00:37:17.000000', 'consum', 0.0212, 'lps'),
	(357670, 123, '2015-01-15 00:37:18.000000', 'consum', 0.0210, 'lps'),
	(357671, 123, '2015-01-15 00:37:19.000000', 'consum', 0.0216, 'lps'),
	(357672, 123, '2015-01-15 00:37:20.000000', 'consum', 0.0217, 'lps'),
	(357673, 123, '2015-01-15 00:37:21.000000', 'consum', 0.0217, 'lps'),
	(357674, 123, '2015-01-15 00:37:22.000000', 'consum', 0.0211, 'lps'),
	(357675, 123, '2015-01-15 00:37:23.000000', 'consum', 0.0217, 'lps'),
	(357676, 123, '2015-01-15 00:37:24.000000', 'consum', 0.0221, 'lps'),
	(357677, 123, '2015-01-15 00:37:25.000000', 'consum', 0.0219, 'lps'),
	(357678, 123, '2015-01-15 00:37:26.000000', 'consum', 0.0221, 'lps'),
	(357679, 123, '2015-01-15 00:37:27.000000', 'consum', 0.0217, 'lps'),
	(357680, 123, '2015-01-15 00:37:28.000000', 'consum', 0.0213, 'lps'),
	(357681, 123, '2015-01-15 00:37:29.000000', 'consum', 0.0214, 'lps'),
	(357682, 123, '2015-01-15 00:37:30.000000', 'consum', 0.0211, 'lps'),
	(357683, 123, '2015-01-15 00:37:31.000000', 'consum', 0.0217, 'lps'),
	(357684, 123, '2015-01-15 00:37:32.000000', 'consum', 0.0219, 'lps'),
	(357685, 123, '2015-01-15 00:37:33.000000', 'consum', 0.0221, 'lps'),
	(357686, 123, '2015-01-15 00:37:34.000000', 'consum', 0.0213, 'lps'),
	(357687, 123, '2015-01-15 00:37:35.000000', 'consum', 0.0216, 'lps'),
	(357688, 123, '2015-01-15 00:37:36.000000', 'consum', 0.0221, 'lps'),
	(357689, 123, '2015-01-15 00:37:37.000000', 'consum', 0.0211, 'lps'),
	(357690, 123, '2015-01-15 00:37:38.000000', 'consum', 0.0220, 'lps'),
	(357691, 123, '2015-01-15 00:37:39.000000', 'consum', 0.0210, 'lps'),
	(357692, 123, '2015-01-15 00:37:40.000000', 'consum', 0.0217, 'lps'),
	(357693, 123, '2015-01-15 00:37:41.000000', 'consum', 0.0210, 'lps'),
	(357694, 123, '2015-01-15 00:37:42.000000', 'consum', 0.0212, 'lps'),
	(357695, 123, '2015-01-15 00:37:43.000000', 'consum', 0.0221, 'lps'),
	(357696, 123, '2015-01-15 00:37:44.000000', 'consum', 0.0212, 'lps'),
	(357697, 123, '2015-01-15 00:37:45.000000', 'consum', 0.0212, 'lps'),
	(357698, 123, '2015-01-15 00:37:46.000000', 'consum', 0.0212, 'lps'),
	(357699, 123, '2015-01-15 00:37:47.000000', 'consum', 0.0215, 'lps'),
	(357700, 123, '2015-01-15 00:37:48.000000', 'consum', 0.0219, 'lps'),
	(357701, 123, '2015-01-15 00:37:49.000000', 'consum', 0.0218, 'lps'),
	(357702, 123, '2015-01-15 00:37:50.000000', 'consum', 0.0221, 'lps'),
	(357703, 123, '2015-01-15 00:37:51.000000', 'consum', 0.0217, 'lps'),
	(357704, 123, '2015-01-15 00:37:52.000000', 'consum', 0.0211, 'lps'),
	(357705, 123, '2015-01-15 00:37:53.000000', 'consum', 0.0221, 'lps'),
	(357706, 123, '2015-01-15 00:37:54.000000', 'consum', 0.0216, 'lps'),
	(357707, 123, '2015-01-15 00:37:55.000000', 'consum', 0.0218, 'lps'),
	(357708, 123, '2015-01-15 00:37:56.000000', 'consum', 0.0219, 'lps'),
	(357709, 123, '2015-01-15 00:37:57.000000', 'consum', 0.0220, 'lps'),
	(357710, 123, '2015-01-15 00:37:58.000000', 'consum', 0.0220, 'lps'),
	(357711, 123, '2015-01-15 00:37:59.000000', 'consum', 0.0221, 'lps'),
	(357712, 123, '2015-01-15 00:38:00.000000', 'consum', 0.0213, 'lps'),
	(357713, 123, '2015-01-15 00:38:01.000000', 'consum', 0.0214, 'lps'),
	(357714, 123, '2015-01-15 00:38:02.000000', 'consum', 0.0220, 'lps'),
	(357715, 123, '2015-01-15 00:38:03.000000', 'consum', 0.0214, 'lps'),
	(357716, 123, '2015-01-15 00:38:04.000000', 'consum', 0.0214, 'lps'),
	(357717, 123, '2015-01-15 00:38:05.000000', 'consum', 0.0217, 'lps'),
	(357718, 123, '2015-01-15 00:38:06.000000', 'consum', 0.0221, 'lps'),
	(357719, 123, '2015-01-15 00:38:07.000000', 'consum', 0.0220, 'lps'),
	(357720, 123, '2015-01-15 00:38:08.000000', 'consum', 0.0217, 'lps'),
	(357721, 123, '2015-01-15 00:38:09.000000', 'consum', 0.0215, 'lps'),
	(357722, 123, '2015-01-15 00:38:10.000000', 'consum', 0.0216, 'lps'),
	(357723, 123, '2015-01-15 00:38:11.000000', 'consum', 0.0212, 'lps'),
	(357724, 123, '2015-01-15 00:38:12.000000', 'consum', 0.0214, 'lps'),
	(357725, 123, '2015-01-15 00:38:13.000000', 'consum', 0.0213, 'lps'),
	(357726, 123, '2015-01-15 00:38:14.000000', 'consum', 0.0213, 'lps'),
	(357727, 123, '2015-01-15 00:38:15.000000', 'consum', 0.0216, 'lps'),
	(357728, 123, '2015-01-15 00:38:16.000000', 'consum', 0.0221, 'lps'),
	(357729, 123, '2015-01-15 00:38:17.000000', 'consum', 0.0212, 'lps'),
	(357730, 123, '2015-01-15 00:38:18.000000', 'consum', 0.0212, 'lps'),
	(357731, 123, '2015-01-15 00:38:19.000000', 'consum', 0.0215, 'lps'),
	(357732, 123, '2015-01-15 00:38:20.000000', 'consum', 0.0215, 'lps'),
	(357733, 123, '2015-01-15 00:38:21.000000', 'consum', 0.0210, 'lps'),
	(357734, 123, '2015-01-15 00:38:22.000000', 'consum', 0.0218, 'lps'),
	(357735, 123, '2015-01-15 00:38:23.000000', 'consum', 0.0214, 'lps'),
	(357736, 123, '2015-01-15 00:38:24.000000', 'consum', 0.0220, 'lps'),
	(357737, 123, '2015-01-15 00:38:25.000000', 'consum', 0.0213, 'lps'),
	(357738, 123, '2015-01-15 00:38:26.000000', 'consum', 0.0220, 'lps'),
	(357739, 123, '2015-01-15 00:38:27.000000', 'consum', 0.0216, 'lps'),
	(357740, 123, '2015-01-15 00:38:28.000000', 'consum', 0.0212, 'lps'),
	(357741, 123, '2015-01-15 00:38:29.000000', 'consum', 0.0211, 'lps'),
	(357742, 123, '2015-01-15 00:38:30.000000', 'consum', 0.0210, 'lps'),
	(357743, 123, '2015-01-15 00:38:31.000000', 'consum', 0.0210, 'lps'),
	(357744, 123, '2015-01-15 00:38:32.000000', 'consum', 0.0210, 'lps'),
	(357745, 123, '2015-01-15 00:38:33.000000', 'consum', 0.0221, 'lps'),
	(357746, 123, '2015-01-15 00:38:34.000000', 'consum', 0.0217, 'lps'),
	(357747, 123, '2015-01-15 00:38:35.000000', 'consum', 0.0212, 'lps'),
	(357748, 123, '2015-01-15 00:38:36.000000', 'consum', 0.0211, 'lps'),
	(357749, 123, '2015-01-15 00:38:37.000000', 'consum', 0.0211, 'lps'),
	(357750, 123, '2015-01-15 00:38:38.000000', 'consum', 0.0212, 'lps'),
	(357751, 123, '2015-01-15 00:38:39.000000', 'consum', 0.0219, 'lps'),
	(357752, 123, '2015-01-15 00:38:40.000000', 'consum', 0.0213, 'lps'),
	(357753, 123, '2015-01-15 00:38:41.000000', 'consum', 0.0210, 'lps'),
	(357754, 123, '2015-01-15 00:38:42.000000', 'consum', 0.0214, 'lps'),
	(357755, 123, '2015-01-15 00:38:43.000000', 'consum', 0.0217, 'lps'),
	(357756, 123, '2015-01-15 00:38:44.000000', 'consum', 0.0211, 'lps'),
	(357757, 123, '2015-01-15 00:38:45.000000', 'consum', 0.0219, 'lps'),
	(357758, 123, '2015-01-15 00:38:46.000000', 'consum', 0.0215, 'lps'),
	(357759, 123, '2015-01-15 00:38:47.000000', 'consum', 0.0220, 'lps'),
	(357760, 123, '2015-01-15 00:38:48.000000', 'consum', 0.0211, 'lps'),
	(357761, 123, '2015-01-15 00:38:49.000000', 'consum', 0.0219, 'lps'),
	(357762, 123, '2015-01-15 00:38:50.000000', 'consum', 0.0217, 'lps'),
	(357763, 123, '2015-01-15 00:38:51.000000', 'consum', 0.0220, 'lps'),
	(357764, 123, '2015-01-15 00:38:52.000000', 'consum', 0.0215, 'lps'),
	(357765, 123, '2015-01-15 00:38:53.000000', 'consum', 0.0219, 'lps'),
	(357766, 123, '2015-01-15 00:38:54.000000', 'consum', 0.0216, 'lps'),
	(357767, 123, '2015-01-15 00:38:55.000000', 'consum', 0.0214, 'lps'),
	(357768, 123, '2015-01-15 00:38:56.000000', 'consum', 0.0210, 'lps'),
	(357769, 123, '2015-01-15 00:38:57.000000', 'consum', 0.0212, 'lps'),
	(357770, 123, '2015-01-15 00:38:58.000000', 'consum', 0.0210, 'lps'),
	(357771, 123, '2015-01-15 00:38:59.000000', 'consum', 0.0217, 'lps'),
	(357772, 123, '2015-01-15 00:39:00.000000', 'consum', 0.0219, 'lps'),
	(357773, 123, '2015-01-15 00:39:01.000000', 'consum', 0.0212, 'lps'),
	(357774, 123, '2015-01-15 00:39:02.000000', 'consum', 0.0215, 'lps'),
	(357775, 123, '2015-01-15 00:39:03.000000', 'consum', 0.0220, 'lps'),
	(357776, 123, '2015-01-15 00:39:04.000000', 'consum', 0.0210, 'lps'),
	(357777, 123, '2015-01-15 00:39:05.000000', 'consum', 0.0217, 'lps'),
	(357778, 123, '2015-01-15 00:39:06.000000', 'consum', 0.0220, 'lps'),
	(357779, 123, '2015-01-15 00:39:07.000000', 'consum', 0.0215, 'lps'),
	(357780, 123, '2015-01-15 00:39:08.000000', 'consum', 0.0219, 'lps'),
	(357781, 123, '2015-01-15 00:39:09.000000', 'consum', 0.0214, 'lps'),
	(357782, 123, '2015-01-15 00:39:10.000000', 'consum', 0.0219, 'lps'),
	(357783, 123, '2015-01-15 00:39:11.000000', 'consum', 0.0216, 'lps'),
	(357784, 123, '2015-01-15 00:39:12.000000', 'consum', 0.0216, 'lps'),
	(357785, 123, '2015-01-15 00:39:13.000000', 'consum', 0.0210, 'lps'),
	(357786, 123, '2015-01-15 00:39:14.000000', 'consum', 0.0217, 'lps'),
	(357787, 123, '2015-01-15 00:39:15.000000', 'consum', 0.0211, 'lps'),
	(357788, 123, '2015-01-15 00:39:16.000000', 'consum', 0.0215, 'lps'),
	(357789, 123, '2015-01-15 00:39:17.000000', 'consum', 0.0210, 'lps'),
	(357790, 123, '2015-01-15 00:39:18.000000', 'consum', 0.0219, 'lps'),
	(357791, 123, '2015-01-15 00:39:19.000000', 'consum', 0.0220, 'lps'),
	(357792, 123, '2015-01-15 00:39:20.000000', 'consum', 0.0219, 'lps'),
	(357793, 123, '2015-01-15 00:39:21.000000', 'consum', 0.0216, 'lps'),
	(357794, 123, '2015-01-15 00:39:22.000000', 'consum', 0.0214, 'lps'),
	(357795, 123, '2015-01-15 00:39:23.000000', 'consum', 0.0213, 'lps'),
	(357796, 123, '2015-01-15 00:39:24.000000', 'consum', 0.0211, 'lps'),
	(357797, 123, '2015-01-15 00:39:25.000000', 'consum', 0.0219, 'lps'),
	(357798, 123, '2015-01-15 00:39:26.000000', 'consum', 0.0217, 'lps'),
	(357799, 123, '2015-01-15 00:39:27.000000', 'consum', 0.0218, 'lps'),
	(357800, 123, '2015-01-15 00:39:28.000000', 'consum', 0.0216, 'lps'),
	(357801, 123, '2015-01-15 00:39:29.000000', 'consum', 0.0218, 'lps'),
	(357802, 123, '2015-01-15 00:39:30.000000', 'consum', 0.0221, 'lps'),
	(357803, 123, '2015-01-15 00:39:31.000000', 'consum', 0.0216, 'lps'),
	(357804, 123, '2015-01-15 00:39:32.000000', 'consum', 0.0221, 'lps'),
	(357805, 123, '2015-01-15 00:39:33.000000', 'consum', 0.0211, 'lps'),
	(357806, 123, '2015-01-15 00:39:34.000000', 'consum', 0.0218, 'lps'),
	(357807, 123, '2015-01-15 00:39:35.000000', 'consum', 0.0212, 'lps'),
	(357808, 123, '2015-01-15 00:39:36.000000', 'consum', 0.0220, 'lps'),
	(357809, 123, '2015-01-15 00:39:37.000000', 'consum', 0.0219, 'lps'),
	(357810, 123, '2015-01-15 00:39:38.000000', 'consum', 0.0214, 'lps'),
	(357811, 123, '2015-01-15 00:39:39.000000', 'consum', 0.0216, 'lps'),
	(357812, 123, '2015-01-15 00:39:40.000000', 'consum', 0.0217, 'lps'),
	(357813, 123, '2015-01-15 00:39:41.000000', 'consum', 0.0213, 'lps'),
	(357814, 123, '2015-01-15 00:39:42.000000', 'consum', 0.0218, 'lps'),
	(357815, 123, '2015-01-15 00:39:43.000000', 'consum', 0.0217, 'lps'),
	(357816, 123, '2015-01-15 00:39:44.000000', 'consum', 0.0221, 'lps'),
	(357817, 123, '2015-01-15 00:39:45.000000', 'consum', 0.0219, 'lps'),
	(357818, 123, '2015-01-15 00:39:46.000000', 'consum', 0.0212, 'lps'),
	(357819, 123, '2015-01-15 00:39:47.000000', 'consum', 0.0217, 'lps'),
	(357820, 123, '2015-01-15 00:39:48.000000', 'consum', 0.0214, 'lps'),
	(357821, 123, '2015-01-15 00:39:49.000000', 'consum', 0.0211, 'lps'),
	(357822, 123, '2015-01-15 00:39:50.000000', 'consum', 0.0214, 'lps'),
	(357823, 123, '2015-01-15 00:39:51.000000', 'consum', 0.0217, 'lps'),
	(357824, 123, '2015-01-15 00:39:52.000000', 'consum', 0.0211, 'lps'),
	(357825, 123, '2015-01-15 00:39:53.000000', 'consum', 0.0217, 'lps'),
	(357826, 123, '2015-01-15 00:39:54.000000', 'consum', 0.0217, 'lps'),
	(357827, 123, '2015-01-15 00:39:55.000000', 'consum', 0.0213, 'lps'),
	(357828, 123, '2015-01-15 00:39:56.000000', 'consum', 0.0218, 'lps'),
	(357829, 123, '2015-01-15 00:39:57.000000', 'consum', 0.0217, 'lps'),
	(357830, 123, '2015-01-15 00:39:58.000000', 'consum', 0.0211, 'lps'),
	(357831, 123, '2015-01-15 00:39:59.000000', 'consum', 0.0216, 'lps'),
	(357832, 123, '2015-01-15 00:40:00.000000', 'consum', 0.0216, 'lps'),
	(357833, 123, '2015-01-15 00:40:01.000000', 'consum', 0.0219, 'lps'),
	(357834, 123, '2015-01-15 00:40:02.000000', 'consum', 0.0216, 'lps'),
	(357835, 123, '2015-01-15 00:40:03.000000', 'consum', 0.0215, 'lps'),
	(357836, 123, '2015-01-15 00:40:04.000000', 'consum', 0.0215, 'lps'),
	(357837, 123, '2015-01-15 00:40:05.000000', 'consum', 0.0210, 'lps'),
	(357838, 123, '2015-01-15 00:40:06.000000', 'consum', 0.0219, 'lps'),
	(357839, 123, '2015-01-15 00:40:07.000000', 'consum', 0.0218, 'lps'),
	(357840, 123, '2015-01-15 00:40:08.000000', 'consum', 0.0212, 'lps'),
	(357841, 123, '2015-01-15 00:40:09.000000', 'consum', 0.0219, 'lps'),
	(357842, 123, '2015-01-15 00:40:10.000000', 'consum', 0.0214, 'lps'),
	(357843, 123, '2015-01-15 00:40:11.000000', 'consum', 0.0217, 'lps'),
	(357844, 123, '2015-01-15 00:40:12.000000', 'consum', 0.0221, 'lps'),
	(357845, 123, '2015-01-15 00:40:13.000000', 'consum', 0.0221, 'lps'),
	(357846, 123, '2015-01-15 00:40:14.000000', 'consum', 0.0210, 'lps'),
	(357847, 123, '2015-01-15 00:40:15.000000', 'consum', 0.0210, 'lps'),
	(357848, 123, '2015-01-15 00:40:16.000000', 'consum', 0.0213, 'lps'),
	(357849, 123, '2015-01-15 00:40:17.000000', 'consum', 0.0213, 'lps'),
	(357850, 123, '2015-01-15 00:40:18.000000', 'consum', 0.0217, 'lps'),
	(357851, 123, '2015-01-15 00:40:19.000000', 'consum', 0.0211, 'lps'),
	(357852, 123, '2015-01-15 00:40:20.000000', 'consum', 0.0221, 'lps'),
	(357853, 123, '2015-01-15 00:40:21.000000', 'consum', 0.0212, 'lps'),
	(357854, 123, '2015-01-15 00:40:22.000000', 'consum', 0.0212, 'lps'),
	(357855, 123, '2015-01-15 00:40:23.000000', 'consum', 0.0216, 'lps'),
	(357856, 123, '2015-01-15 00:40:24.000000', 'consum', 0.0211, 'lps'),
	(357857, 123, '2015-01-15 00:40:25.000000', 'consum', 0.0220, 'lps'),
	(357858, 123, '2015-01-15 00:40:26.000000', 'consum', 0.0221, 'lps'),
	(357859, 123, '2015-01-15 00:40:27.000000', 'consum', 0.0213, 'lps'),
	(357860, 123, '2015-01-15 00:40:28.000000', 'consum', 0.0218, 'lps'),
	(357861, 123, '2015-01-15 00:40:29.000000', 'consum', 0.0216, 'lps'),
	(357862, 123, '2015-01-15 00:40:30.000000', 'consum', 0.0215, 'lps'),
	(357863, 123, '2015-01-15 00:40:31.000000', 'consum', 0.0220, 'lps'),
	(357864, 123, '2015-01-15 00:40:32.000000', 'consum', 0.0218, 'lps'),
	(357865, 123, '2015-01-15 00:40:33.000000', 'consum', 0.0212, 'lps'),
	(357866, 123, '2015-01-15 00:40:34.000000', 'consum', 0.0220, 'lps'),
	(357867, 123, '2015-01-15 00:40:35.000000', 'consum', 0.0219, 'lps'),
	(357868, 123, '2015-01-15 00:40:36.000000', 'consum', 0.0211, 'lps'),
	(357869, 123, '2015-01-15 00:40:37.000000', 'consum', 0.0212, 'lps'),
	(357870, 123, '2015-01-15 00:40:38.000000', 'consum', 0.0221, 'lps'),
	(357871, 123, '2015-01-15 00:40:39.000000', 'consum', 0.0221, 'lps'),
	(357872, 123, '2015-01-15 00:40:40.000000', 'consum', 0.0211, 'lps'),
	(357873, 123, '2015-01-15 00:40:41.000000', 'consum', 0.0215, 'lps'),
	(357874, 123, '2015-01-15 00:40:42.000000', 'consum', 0.0212, 'lps'),
	(357875, 123, '2015-01-15 00:40:43.000000', 'consum', 0.0217, 'lps'),
	(357876, 123, '2015-01-15 00:40:44.000000', 'consum', 0.0213, 'lps'),
	(357877, 123, '2015-01-15 00:40:45.000000', 'consum', 0.0219, 'lps'),
	(357878, 123, '2015-01-15 00:40:46.000000', 'consum', 0.0210, 'lps'),
	(357879, 123, '2015-01-15 00:40:47.000000', 'consum', 0.0220, 'lps'),
	(357880, 123, '2015-01-15 00:40:48.000000', 'consum', 0.0211, 'lps'),
	(357881, 123, '2015-01-15 00:40:49.000000', 'consum', 0.0212, 'lps'),
	(357882, 123, '2015-01-15 00:40:50.000000', 'consum', 0.0215, 'lps'),
	(357883, 123, '2015-01-15 00:40:51.000000', 'consum', 0.0219, 'lps'),
	(357884, 123, '2015-01-15 00:40:52.000000', 'consum', 0.0215, 'lps'),
	(357885, 123, '2015-01-15 00:40:53.000000', 'consum', 0.0210, 'lps'),
	(357886, 123, '2015-01-15 00:40:54.000000', 'consum', 0.0219, 'lps'),
	(357887, 123, '2015-01-15 00:40:55.000000', 'consum', 0.0219, 'lps'),
	(357888, 123, '2015-01-15 00:40:56.000000', 'consum', 0.0219, 'lps'),
	(357889, 123, '2015-01-15 00:40:57.000000', 'consum', 0.0214, 'lps'),
	(357890, 123, '2015-01-15 00:40:58.000000', 'consum', 0.0216, 'lps'),
	(357891, 123, '2015-01-15 00:40:59.000000', 'consum', 0.0216, 'lps'),
	(357892, 123, '2015-01-15 00:41:00.000000', 'consum', 0.0211, 'lps'),
	(357893, 123, '2015-01-15 00:41:01.000000', 'consum', 0.0210, 'lps'),
	(357894, 123, '2015-01-15 00:41:02.000000', 'consum', 0.0219, 'lps'),
	(357895, 123, '2015-01-15 00:41:03.000000', 'consum', 0.0220, 'lps'),
	(357896, 123, '2015-01-15 00:41:04.000000', 'consum', 0.0210, 'lps'),
	(357897, 123, '2015-01-15 00:41:05.000000', 'consum', 0.0216, 'lps'),
	(357898, 123, '2015-01-15 00:41:06.000000', 'consum', 0.0218, 'lps'),
	(357899, 123, '2015-01-15 00:41:07.000000', 'consum', 0.0220, 'lps'),
	(357900, 123, '2015-01-15 00:41:08.000000', 'consum', 0.0211, 'lps'),
	(357901, 123, '2015-01-15 00:41:09.000000', 'consum', 0.0211, 'lps'),
	(357902, 123, '2015-01-15 00:41:10.000000', 'consum', 0.0211, 'lps'),
	(357903, 123, '2015-01-15 00:41:11.000000', 'consum', 0.0214, 'lps'),
	(357904, 123, '2015-01-15 00:41:12.000000', 'consum', 0.0215, 'lps'),
	(357905, 123, '2015-01-15 00:41:13.000000', 'consum', 0.0212, 'lps'),
	(357906, 123, '2015-01-15 00:41:14.000000', 'consum', 0.0217, 'lps'),
	(357907, 123, '2015-01-15 00:41:15.000000', 'consum', 0.0216, 'lps'),
	(357908, 123, '2015-01-15 00:41:16.000000', 'consum', 0.0221, 'lps'),
	(357909, 123, '2015-01-15 00:41:17.000000', 'consum', 0.0212, 'lps'),
	(357910, 123, '2015-01-15 00:41:18.000000', 'consum', 0.0220, 'lps'),
	(357911, 123, '2015-01-15 00:41:19.000000', 'consum', 0.0221, 'lps'),
	(357912, 123, '2015-01-15 00:41:20.000000', 'consum', 0.0213, 'lps'),
	(357913, 123, '2015-01-15 00:41:21.000000', 'consum', 0.0214, 'lps'),
	(357914, 123, '2015-01-15 00:41:22.000000', 'consum', 0.0221, 'lps'),
	(357915, 123, '2015-01-15 00:41:23.000000', 'consum', 0.0217, 'lps'),
	(357916, 123, '2015-01-15 00:41:24.000000', 'consum', 0.0213, 'lps'),
	(357917, 123, '2015-01-15 00:41:25.000000', 'consum', 0.0217, 'lps'),
	(357918, 123, '2015-01-15 00:41:26.000000', 'consum', 0.0214, 'lps'),
	(357919, 123, '2015-01-15 00:41:27.000000', 'consum', 0.0221, 'lps'),
	(357920, 123, '2015-01-15 00:41:28.000000', 'consum', 0.0216, 'lps'),
	(357921, 123, '2015-01-15 00:41:29.000000', 'consum', 0.0221, 'lps'),
	(357922, 123, '2015-01-15 00:41:30.000000', 'consum', 0.0212, 'lps'),
	(357923, 123, '2015-01-15 00:41:31.000000', 'consum', 0.0221, 'lps'),
	(357924, 123, '2015-01-15 00:41:32.000000', 'consum', 0.0212, 'lps'),
	(357925, 123, '2015-01-15 00:41:33.000000', 'consum', 0.0211, 'lps'),
	(357926, 123, '2015-01-15 00:41:34.000000', 'consum', 0.0220, 'lps'),
	(357927, 123, '2015-01-15 00:41:35.000000', 'consum', 0.0213, 'lps'),
	(357928, 123, '2015-01-15 00:41:36.000000', 'consum', 0.0216, 'lps'),
	(357929, 123, '2015-01-15 00:41:37.000000', 'consum', 0.0211, 'lps'),
	(357930, 123, '2015-01-15 00:41:38.000000', 'consum', 0.0219, 'lps'),
	(357931, 123, '2015-01-15 00:41:39.000000', 'consum', 0.0216, 'lps'),
	(357932, 123, '2015-01-15 00:41:40.000000', 'consum', 0.0213, 'lps'),
	(357933, 123, '2015-01-15 00:41:41.000000', 'consum', 0.0221, 'lps'),
	(357934, 123, '2015-01-15 00:41:42.000000', 'consum', 0.0220, 'lps'),
	(357935, 123, '2015-01-15 00:41:43.000000', 'consum', 0.0216, 'lps'),
	(357936, 123, '2015-01-15 00:41:44.000000', 'consum', 0.0221, 'lps'),
	(357937, 123, '2015-01-15 00:41:45.000000', 'consum', 0.0212, 'lps'),
	(357938, 123, '2015-01-15 00:41:46.000000', 'consum', 0.0213, 'lps'),
	(357939, 123, '2015-01-15 00:41:47.000000', 'consum', 0.0217, 'lps'),
	(357940, 123, '2015-01-15 00:41:48.000000', 'consum', 0.0213, 'lps'),
	(357941, 123, '2015-01-15 00:41:49.000000', 'consum', 0.0217, 'lps'),
	(357942, 123, '2015-01-15 00:41:50.000000', 'consum', 0.0214, 'lps'),
	(357943, 123, '2015-01-15 00:41:51.000000', 'consum', 0.0220, 'lps'),
	(357944, 123, '2015-01-15 00:41:52.000000', 'consum', 0.0211, 'lps'),
	(357945, 123, '2015-01-15 00:41:53.000000', 'consum', 0.0211, 'lps'),
	(357946, 123, '2015-01-15 00:41:54.000000', 'consum', 0.0213, 'lps'),
	(357947, 123, '2015-01-15 00:41:55.000000', 'consum', 0.0211, 'lps'),
	(357948, 123, '2015-01-15 00:41:56.000000', 'consum', 0.0219, 'lps'),
	(357949, 123, '2015-01-15 00:41:57.000000', 'consum', 0.0216, 'lps'),
	(357950, 123, '2015-01-15 00:41:58.000000', 'consum', 0.0213, 'lps'),
	(357951, 123, '2015-01-15 00:41:59.000000', 'consum', 0.0210, 'lps'),
	(357952, 123, '2015-01-15 00:42:00.000000', 'consum', 0.0210, 'lps'),
	(357953, 123, '2015-01-15 00:42:01.000000', 'consum', 0.0211, 'lps'),
	(357954, 123, '2015-01-15 00:42:02.000000', 'consum', 0.0217, 'lps'),
	(357955, 123, '2015-01-15 00:42:03.000000', 'consum', 0.0220, 'lps'),
	(357956, 123, '2015-01-15 00:42:04.000000', 'consum', 0.0214, 'lps'),
	(357957, 123, '2015-01-15 00:42:05.000000', 'consum', 0.0211, 'lps'),
	(357958, 123, '2015-01-15 00:42:06.000000', 'consum', 0.0215, 'lps'),
	(357959, 123, '2015-01-15 00:42:07.000000', 'consum', 0.0221, 'lps'),
	(357960, 123, '2015-01-15 00:42:08.000000', 'consum', 0.0214, 'lps'),
	(357961, 123, '2015-01-15 00:42:09.000000', 'consum', 0.0210, 'lps'),
	(357962, 123, '2015-01-15 00:42:10.000000', 'consum', 0.0221, 'lps'),
	(357963, 123, '2015-01-15 00:42:11.000000', 'consum', 0.0217, 'lps'),
	(357964, 123, '2015-01-15 00:42:12.000000', 'consum', 0.0214, 'lps'),
	(357965, 123, '2015-01-15 00:42:13.000000', 'consum', 0.0220, 'lps'),
	(357966, 123, '2015-01-15 00:42:14.000000', 'consum', 0.0215, 'lps'),
	(357967, 123, '2015-01-15 00:42:15.000000', 'consum', 0.0218, 'lps'),
	(357968, 123, '2015-01-15 00:42:16.000000', 'consum', 0.0210, 'lps'),
	(357969, 123, '2015-01-15 00:42:17.000000', 'consum', 0.0211, 'lps'),
	(357970, 123, '2015-01-15 00:42:18.000000', 'consum', 0.0216, 'lps'),
	(357971, 123, '2015-01-15 00:42:19.000000', 'consum', 0.0212, 'lps'),
	(357972, 123, '2015-01-15 00:42:20.000000', 'consum', 0.0215, 'lps'),
	(357973, 123, '2015-01-15 00:42:21.000000', 'consum', 0.0220, 'lps'),
	(357974, 123, '2015-01-15 00:42:22.000000', 'consum', 0.0218, 'lps'),
	(357975, 123, '2015-01-15 00:42:23.000000', 'consum', 0.0211, 'lps'),
	(357976, 123, '2015-01-15 00:42:24.000000', 'consum', 0.0216, 'lps'),
	(357977, 123, '2015-01-15 00:42:25.000000', 'consum', 0.0213, 'lps'),
	(357978, 123, '2015-01-15 00:42:26.000000', 'consum', 0.0218, 'lps'),
	(357979, 123, '2015-01-15 00:42:27.000000', 'consum', 0.0218, 'lps'),
	(357980, 123, '2015-01-15 00:42:28.000000', 'consum', 0.0214, 'lps'),
	(357981, 123, '2015-01-15 00:42:29.000000', 'consum', 0.0219, 'lps'),
	(357982, 123, '2015-01-15 00:42:30.000000', 'consum', 0.0219, 'lps'),
	(357983, 123, '2015-01-15 00:42:31.000000', 'consum', 0.0218, 'lps'),
	(357984, 123, '2015-01-15 00:42:32.000000', 'consum', 0.0221, 'lps'),
	(357985, 123, '2015-01-15 00:42:33.000000', 'consum', 0.0217, 'lps'),
	(357986, 123, '2015-01-15 00:42:34.000000', 'consum', 0.0216, 'lps'),
	(357987, 123, '2015-01-15 00:42:35.000000', 'consum', 0.0216, 'lps'),
	(357988, 123, '2015-01-15 00:42:36.000000', 'consum', 0.0214, 'lps'),
	(357989, 123, '2015-01-15 00:42:37.000000', 'consum', 0.0211, 'lps'),
	(357990, 123, '2015-01-15 00:42:38.000000', 'consum', 0.0214, 'lps'),
	(357991, 123, '2015-01-15 00:42:39.000000', 'consum', 0.0218, 'lps'),
	(357992, 123, '2015-01-15 00:42:40.000000', 'consum', 0.0213, 'lps'),
	(357993, 123, '2015-01-15 00:42:41.000000', 'consum', 0.0215, 'lps'),
	(357994, 123, '2015-01-15 00:42:42.000000', 'consum', 0.0212, 'lps'),
	(357995, 123, '2015-01-15 00:42:43.000000', 'consum', 0.0220, 'lps'),
	(357996, 123, '2015-01-15 00:42:44.000000', 'consum', 0.0218, 'lps'),
	(357997, 123, '2015-01-15 00:42:45.000000', 'consum', 0.0219, 'lps'),
	(357998, 123, '2015-01-15 00:42:46.000000', 'consum', 0.0218, 'lps'),
	(357999, 123, '2015-01-15 00:42:47.000000', 'consum', 0.0214, 'lps'),
	(358000, 123, '2015-01-15 00:42:48.000000', 'consum', 0.0219, 'lps'),
	(358001, 123, '2015-01-15 00:42:49.000000', 'consum', 0.0220, 'lps'),
	(358002, 123, '2015-01-15 00:42:50.000000', 'consum', 0.0221, 'lps'),
	(358003, 123, '2015-01-15 00:42:51.000000', 'consum', 0.0212, 'lps'),
	(358004, 123, '2015-01-15 00:42:52.000000', 'consum', 0.0212, 'lps'),
	(358005, 123, '2015-01-15 00:42:53.000000', 'consum', 0.0212, 'lps'),
	(358006, 123, '2015-01-15 00:42:54.000000', 'consum', 0.0217, 'lps'),
	(358007, 123, '2015-01-15 00:42:55.000000', 'consum', 0.0217, 'lps'),
	(358008, 123, '2015-01-15 00:42:56.000000', 'consum', 0.0221, 'lps'),
	(358009, 123, '2015-01-15 00:42:57.000000', 'consum', 0.0211, 'lps'),
	(358010, 123, '2015-01-15 00:42:58.000000', 'consum', 0.0219, 'lps'),
	(358011, 123, '2015-01-15 00:42:59.000000', 'consum', 0.0215, 'lps'),
	(358012, 123, '2015-01-15 00:43:00.000000', 'consum', 0.0210, 'lps'),
	(358013, 123, '2015-01-15 00:43:01.000000', 'consum', 0.0218, 'lps'),
	(358014, 123, '2015-01-15 00:43:02.000000', 'consum', 0.0217, 'lps'),
	(358015, 123, '2015-01-15 00:43:03.000000', 'consum', 0.0220, 'lps'),
	(358016, 123, '2015-01-15 00:43:04.000000', 'consum', 0.0215, 'lps'),
	(358017, 123, '2015-01-15 00:43:05.000000', 'consum', 0.0219, 'lps'),
	(358018, 123, '2015-01-15 00:43:06.000000', 'consum', 0.0218, 'lps'),
	(358019, 123, '2015-01-15 00:43:07.000000', 'consum', 0.0220, 'lps'),
	(358020, 123, '2015-01-15 00:43:08.000000', 'consum', 0.0214, 'lps'),
	(358021, 123, '2015-01-15 00:43:09.000000', 'consum', 0.0214, 'lps'),
	(358022, 123, '2015-01-15 00:43:10.000000', 'consum', 0.0216, 'lps'),
	(358023, 123, '2015-01-15 00:43:11.000000', 'consum', 0.0219, 'lps'),
	(358024, 123, '2015-01-15 00:43:12.000000', 'consum', 0.0212, 'lps'),
	(358025, 123, '2015-01-15 00:43:13.000000', 'consum', 0.0217, 'lps'),
	(358026, 123, '2015-01-15 00:43:14.000000', 'consum', 0.0215, 'lps'),
	(358027, 123, '2015-01-15 00:43:15.000000', 'consum', 0.0217, 'lps'),
	(358028, 123, '2015-01-15 00:43:16.000000', 'consum', 0.0217, 'lps'),
	(358029, 123, '2015-01-15 00:43:17.000000', 'consum', 0.0214, 'lps'),
	(358030, 123, '2015-01-15 00:43:18.000000', 'consum', 0.0210, 'lps'),
	(358031, 123, '2015-01-15 00:43:19.000000', 'consum', 0.0210, 'lps'),
	(358032, 123, '2015-01-15 00:43:20.000000', 'consum', 0.0210, 'lps'),
	(358033, 123, '2015-01-15 00:43:21.000000', 'consum', 0.0221, 'lps'),
	(358034, 123, '2015-01-15 00:43:22.000000', 'consum', 0.0218, 'lps'),
	(358035, 123, '2015-01-15 00:43:23.000000', 'consum', 0.0218, 'lps'),
	(358036, 123, '2015-01-15 00:43:24.000000', 'consum', 0.0213, 'lps'),
	(358037, 123, '2015-01-15 00:43:25.000000', 'consum', 0.0213, 'lps'),
	(358038, 123, '2015-01-15 00:43:26.000000', 'consum', 0.0216, 'lps'),
	(358039, 123, '2015-01-15 00:43:27.000000', 'consum', 0.0218, 'lps'),
	(358040, 123, '2015-01-15 00:43:28.000000', 'consum', 0.0212, 'lps'),
	(358041, 123, '2015-01-15 00:43:29.000000', 'consum', 0.0221, 'lps'),
	(358042, 123, '2015-01-15 00:43:30.000000', 'consum', 0.0220, 'lps'),
	(358043, 123, '2015-01-15 00:43:31.000000', 'consum', 0.0219, 'lps'),
	(358044, 123, '2015-01-15 00:43:32.000000', 'consum', 0.0210, 'lps'),
	(358045, 123, '2015-01-15 00:43:33.000000', 'consum', 0.0210, 'lps'),
	(358046, 123, '2015-01-15 00:43:34.000000', 'consum', 0.0221, 'lps'),
	(358047, 123, '2015-01-15 00:43:35.000000', 'consum', 0.0218, 'lps'),
	(358048, 123, '2015-01-15 00:43:36.000000', 'consum', 0.0219, 'lps'),
	(358049, 123, '2015-01-15 00:43:37.000000', 'consum', 0.0217, 'lps'),
	(358050, 123, '2015-01-15 00:43:38.000000', 'consum', 0.0218, 'lps'),
	(358051, 123, '2015-01-15 00:43:39.000000', 'consum', 0.0218, 'lps'),
	(358052, 123, '2015-01-15 00:43:40.000000', 'consum', 0.0213, 'lps'),
	(358053, 123, '2015-01-15 00:43:41.000000', 'consum', 0.0214, 'lps'),
	(358054, 123, '2015-01-15 00:43:42.000000', 'consum', 0.0210, 'lps'),
	(358055, 123, '2015-01-15 00:43:43.000000', 'consum', 0.0220, 'lps'),
	(358056, 123, '2015-01-15 00:43:44.000000', 'consum', 0.0216, 'lps'),
	(358057, 123, '2015-01-15 00:43:45.000000', 'consum', 0.0210, 'lps'),
	(358058, 123, '2015-01-15 00:43:46.000000', 'consum', 0.0217, 'lps'),
	(358059, 123, '2015-01-15 00:43:47.000000', 'consum', 0.0211, 'lps'),
	(358060, 123, '2015-01-15 00:43:48.000000', 'consum', 0.0216, 'lps'),
	(358061, 123, '2015-01-15 00:43:49.000000', 'consum', 0.0216, 'lps'),
	(358062, 123, '2015-01-15 00:43:50.000000', 'consum', 0.0220, 'lps'),
	(358063, 123, '2015-01-15 00:43:51.000000', 'consum', 0.0221, 'lps'),
	(358064, 123, '2015-01-15 00:43:52.000000', 'consum', 0.0212, 'lps'),
	(358065, 123, '2015-01-15 00:43:53.000000', 'consum', 0.0211, 'lps'),
	(358066, 123, '2015-01-15 00:43:54.000000', 'consum', 0.0210, 'lps'),
	(358067, 123, '2015-01-15 00:43:55.000000', 'consum', 0.0219, 'lps'),
	(358068, 123, '2015-01-15 00:43:56.000000', 'consum', 0.0221, 'lps'),
	(358069, 123, '2015-01-15 00:43:57.000000', 'consum', 0.0212, 'lps'),
	(358070, 123, '2015-01-15 00:43:58.000000', 'consum', 0.0214, 'lps'),
	(358071, 123, '2015-01-15 00:43:59.000000', 'consum', 0.0221, 'lps'),
	(358072, 123, '2015-01-15 00:44:00.000000', 'consum', 0.0221, 'lps'),
	(358073, 123, '2015-01-15 00:44:01.000000', 'consum', 0.0217, 'lps'),
	(358074, 123, '2015-01-15 00:44:02.000000', 'consum', 0.0216, 'lps'),
	(358075, 123, '2015-01-15 00:44:03.000000', 'consum', 0.0218, 'lps'),
	(358076, 123, '2015-01-15 00:44:04.000000', 'consum', 0.0221, 'lps'),
	(358077, 123, '2015-01-15 00:44:05.000000', 'consum', 0.0219, 'lps'),
	(358078, 123, '2015-01-15 00:44:06.000000', 'consum', 0.0211, 'lps'),
	(358079, 123, '2015-01-15 00:44:07.000000', 'consum', 0.0210, 'lps'),
	(358080, 123, '2015-01-15 00:44:08.000000', 'consum', 0.0219, 'lps'),
	(358081, 123, '2015-01-15 00:44:09.000000', 'consum', 0.0221, 'lps'),
	(358082, 123, '2015-01-15 00:44:10.000000', 'consum', 0.0214, 'lps'),
	(358083, 123, '2015-01-15 00:44:11.000000', 'consum', 0.0220, 'lps'),
	(358084, 123, '2015-01-15 00:44:12.000000', 'consum', 0.0214, 'lps'),
	(358085, 123, '2015-01-15 00:44:13.000000', 'consum', 0.0211, 'lps'),
	(358086, 123, '2015-01-15 00:44:14.000000', 'consum', 0.0217, 'lps'),
	(358087, 123, '2015-01-15 00:44:15.000000', 'consum', 0.0220, 'lps'),
	(358088, 123, '2015-01-15 00:44:16.000000', 'consum', 0.0214, 'lps'),
	(358089, 123, '2015-01-15 00:44:17.000000', 'consum', 0.0213, 'lps'),
	(358090, 123, '2015-01-15 00:44:18.000000', 'consum', 0.0212, 'lps'),
	(358091, 123, '2015-01-15 00:44:19.000000', 'consum', 0.0212, 'lps'),
	(358092, 123, '2015-01-15 00:44:20.000000', 'consum', 0.0213, 'lps'),
	(358093, 123, '2015-01-15 00:44:21.000000', 'consum', 0.0221, 'lps'),
	(358094, 123, '2015-01-15 00:44:22.000000', 'consum', 0.0219, 'lps'),
	(358095, 123, '2015-01-15 00:44:23.000000', 'consum', 0.0212, 'lps'),
	(358096, 123, '2015-01-15 00:44:24.000000', 'consum', 0.0219, 'lps'),
	(358097, 123, '2015-01-15 00:44:25.000000', 'consum', 0.0212, 'lps'),
	(358098, 123, '2015-01-15 00:44:26.000000', 'consum', 0.0216, 'lps'),
	(358099, 123, '2015-01-15 00:44:27.000000', 'consum', 0.0210, 'lps'),
	(358100, 123, '2015-01-15 00:44:28.000000', 'consum', 0.0216, 'lps'),
	(358101, 123, '2015-01-15 00:44:29.000000', 'consum', 0.0216, 'lps'),
	(358102, 123, '2015-01-15 00:44:30.000000', 'consum', 0.0213, 'lps'),
	(358103, 123, '2015-01-15 00:44:31.000000', 'consum', 0.0221, 'lps'),
	(358104, 123, '2015-01-15 00:44:32.000000', 'consum', 0.0217, 'lps'),
	(358105, 123, '2015-01-15 00:44:33.000000', 'consum', 0.0213, 'lps'),
	(358106, 123, '2015-01-15 00:44:34.000000', 'consum', 0.0218, 'lps'),
	(358107, 123, '2015-01-15 00:44:35.000000', 'consum', 0.0219, 'lps'),
	(358108, 123, '2015-01-15 00:44:36.000000', 'consum', 0.0218, 'lps'),
	(358109, 123, '2015-01-15 00:44:37.000000', 'consum', 0.0211, 'lps'),
	(358110, 123, '2015-01-15 00:44:38.000000', 'consum', 0.0215, 'lps'),
	(358111, 123, '2015-01-15 00:44:39.000000', 'consum', 0.0210, 'lps'),
	(358112, 123, '2015-01-15 00:44:40.000000', 'consum', 0.0217, 'lps'),
	(358113, 123, '2015-01-15 00:44:41.000000', 'consum', 0.0212, 'lps'),
	(358114, 123, '2015-01-15 00:44:42.000000', 'consum', 0.0212, 'lps'),
	(358115, 123, '2015-01-15 00:44:43.000000', 'consum', 0.0215, 'lps'),
	(358116, 123, '2015-01-15 00:44:44.000000', 'consum', 0.0216, 'lps'),
	(358117, 123, '2015-01-15 00:44:45.000000', 'consum', 0.0214, 'lps'),
	(358118, 123, '2015-01-15 00:44:46.000000', 'consum', 0.0214, 'lps'),
	(358119, 123, '2015-01-15 00:44:47.000000', 'consum', 0.0219, 'lps'),
	(358120, 123, '2015-01-15 00:44:48.000000', 'consum', 0.0219, 'lps'),
	(358121, 123, '2015-01-15 00:44:49.000000', 'consum', 0.0216, 'lps'),
	(358122, 123, '2015-01-15 00:44:50.000000', 'consum', 0.0212, 'lps'),
	(358123, 123, '2015-01-15 00:44:51.000000', 'consum', 0.0217, 'lps'),
	(358124, 123, '2015-01-15 00:44:52.000000', 'consum', 0.0213, 'lps'),
	(358125, 123, '2015-01-15 00:44:53.000000', 'consum', 0.0216, 'lps'),
	(358126, 123, '2015-01-15 00:44:54.000000', 'consum', 0.0220, 'lps'),
	(358127, 123, '2015-01-15 00:44:55.000000', 'consum', 0.0219, 'lps'),
	(358128, 123, '2015-01-15 00:44:56.000000', 'consum', 0.0215, 'lps'),
	(358129, 123, '2015-01-15 00:44:57.000000', 'consum', 0.0219, 'lps'),
	(358130, 123, '2015-01-15 00:44:58.000000', 'consum', 0.0218, 'lps'),
	(358131, 123, '2015-01-15 00:44:59.000000', 'consum', 0.0221, 'lps'),
	(358132, 123, '2015-01-15 00:45:00.000000', 'consum', 0.0220, 'lps'),
	(358133, 123, '2015-01-15 00:45:01.000000', 'consum', 0.0213, 'lps'),
	(358134, 123, '2015-01-15 00:45:02.000000', 'consum', 0.0218, 'lps'),
	(358135, 123, '2015-01-15 00:45:03.000000', 'consum', 0.0221, 'lps'),
	(358136, 123, '2015-01-15 00:45:04.000000', 'consum', 0.0218, 'lps'),
	(358137, 123, '2015-01-15 00:45:05.000000', 'consum', 0.0216, 'lps'),
	(358138, 123, '2015-01-15 00:45:06.000000', 'consum', 0.0219, 'lps'),
	(358139, 123, '2015-01-15 00:45:07.000000', 'consum', 0.0210, 'lps'),
	(358140, 123, '2015-01-15 00:45:08.000000', 'consum', 0.0221, 'lps'),
	(358141, 123, '2015-01-15 00:45:09.000000', 'consum', 0.0218, 'lps'),
	(358142, 123, '2015-01-15 00:45:10.000000', 'consum', 0.0215, 'lps'),
	(358143, 123, '2015-01-15 00:45:11.000000', 'consum', 0.0213, 'lps'),
	(358144, 123, '2015-01-15 00:45:12.000000', 'consum', 0.0212, 'lps'),
	(358145, 123, '2015-01-15 00:45:13.000000', 'consum', 0.0211, 'lps'),
	(358146, 123, '2015-01-15 00:45:14.000000', 'consum', 0.0219, 'lps'),
	(358147, 123, '2015-01-15 00:45:15.000000', 'consum', 0.0218, 'lps'),
	(358148, 123, '2015-01-15 00:45:16.000000', 'consum', 0.0213, 'lps'),
	(358149, 123, '2015-01-15 00:45:17.000000', 'consum', 0.0214, 'lps'),
	(358150, 123, '2015-01-15 00:45:18.000000', 'consum', 0.0210, 'lps'),
	(358151, 123, '2015-01-15 00:45:19.000000', 'consum', 0.0210, 'lps'),
	(358152, 123, '2015-01-15 00:45:20.000000', 'consum', 0.0221, 'lps'),
	(358153, 123, '2015-01-15 00:45:21.000000', 'consum', 0.0218, 'lps'),
	(358154, 123, '2015-01-15 00:45:22.000000', 'consum', 0.0217, 'lps'),
	(358155, 123, '2015-01-15 00:45:23.000000', 'consum', 0.0221, 'lps'),
	(358156, 123, '2015-01-15 00:45:24.000000', 'consum', 0.0210, 'lps'),
	(358157, 123, '2015-01-15 00:45:25.000000', 'consum', 0.0211, 'lps'),
	(358158, 123, '2015-01-15 00:45:26.000000', 'consum', 0.0219, 'lps'),
	(358159, 123, '2015-01-15 00:45:27.000000', 'consum', 0.0213, 'lps'),
	(358160, 123, '2015-01-15 00:45:28.000000', 'consum', 0.0212, 'lps'),
	(358161, 123, '2015-01-15 00:45:29.000000', 'consum', 0.0212, 'lps'),
	(358162, 123, '2015-01-15 00:45:30.000000', 'consum', 0.0214, 'lps'),
	(358163, 123, '2015-01-15 00:45:31.000000', 'consum', 0.0212, 'lps'),
	(358164, 123, '2015-01-15 00:45:32.000000', 'consum', 0.0220, 'lps'),
	(358165, 123, '2015-01-15 00:45:33.000000', 'consum', 0.0219, 'lps'),
	(358166, 123, '2015-01-15 00:45:34.000000', 'consum', 0.0214, 'lps'),
	(358167, 123, '2015-01-15 00:45:35.000000', 'consum', 0.0215, 'lps'),
	(358168, 123, '2015-01-15 00:45:36.000000', 'consum', 0.0211, 'lps'),
	(358169, 123, '2015-01-15 00:45:37.000000', 'consum', 0.0211, 'lps'),
	(358170, 123, '2015-01-15 00:45:38.000000', 'consum', 0.0214, 'lps'),
	(358171, 123, '2015-01-15 00:45:39.000000', 'consum', 0.0216, 'lps'),
	(358172, 123, '2015-01-15 00:45:40.000000', 'consum', 0.0215, 'lps'),
	(358173, 123, '2015-01-15 00:45:41.000000', 'consum', 0.0219, 'lps'),
	(358174, 123, '2015-01-15 00:45:42.000000', 'consum', 0.0218, 'lps'),
	(358175, 123, '2015-01-15 00:45:43.000000', 'consum', 0.0221, 'lps'),
	(358176, 123, '2015-01-15 00:45:44.000000', 'consum', 0.0219, 'lps'),
	(358177, 123, '2015-01-15 00:45:45.000000', 'consum', 0.0211, 'lps'),
	(358178, 123, '2015-01-15 00:45:46.000000', 'consum', 0.0211, 'lps'),
	(358179, 123, '2015-01-15 00:45:47.000000', 'consum', 0.0214, 'lps'),
	(358180, 123, '2015-01-15 00:45:48.000000', 'consum', 0.0213, 'lps'),
	(358181, 123, '2015-01-15 00:45:49.000000', 'consum', 0.0215, 'lps'),
	(358182, 123, '2015-01-15 00:45:50.000000', 'consum', 0.0213, 'lps'),
	(358183, 123, '2015-01-15 00:45:51.000000', 'consum', 0.0214, 'lps'),
	(358184, 123, '2015-01-15 00:45:52.000000', 'consum', 0.0218, 'lps'),
	(358185, 123, '2015-01-15 00:45:53.000000', 'consum', 0.0215, 'lps'),
	(358186, 123, '2015-01-15 00:45:54.000000', 'consum', 0.0213, 'lps'),
	(358187, 123, '2015-01-15 00:45:55.000000', 'consum', 0.0220, 'lps'),
	(358188, 123, '2015-01-15 00:45:56.000000', 'consum', 0.0216, 'lps'),
	(358189, 123, '2015-01-15 00:45:57.000000', 'consum', 0.0211, 'lps'),
	(358190, 123, '2015-01-15 00:45:58.000000', 'consum', 0.0220, 'lps'),
	(358191, 123, '2015-01-15 00:45:59.000000', 'consum', 0.0220, 'lps'),
	(358192, 123, '2015-01-15 00:46:00.000000', 'consum', 0.0210, 'lps'),
	(358193, 123, '2015-01-15 00:46:01.000000', 'consum', 0.0216, 'lps'),
	(358194, 123, '2015-01-15 00:46:02.000000', 'consum', 0.0214, 'lps'),
	(358195, 123, '2015-01-15 00:46:03.000000', 'consum', 0.0214, 'lps'),
	(358196, 123, '2015-01-15 00:46:04.000000', 'consum', 0.0216, 'lps'),
	(358197, 123, '2015-01-15 00:46:05.000000', 'consum', 0.0220, 'lps'),
	(358198, 123, '2015-01-15 00:46:06.000000', 'consum', 0.0217, 'lps'),
	(358199, 123, '2015-01-15 00:46:07.000000', 'consum', 0.0217, 'lps'),
	(358200, 123, '2015-01-15 00:46:08.000000', 'consum', 0.0210, 'lps'),
	(358201, 123, '2015-01-15 00:46:09.000000', 'consum', 0.0216, 'lps'),
	(358202, 123, '2015-01-15 00:46:10.000000', 'consum', 0.0215, 'lps'),
	(358203, 123, '2015-01-15 00:46:11.000000', 'consum', 0.0216, 'lps'),
	(358204, 123, '2015-01-15 00:46:12.000000', 'consum', 0.0216, 'lps'),
	(358205, 123, '2015-01-15 00:46:13.000000', 'consum', 0.0221, 'lps'),
	(358206, 123, '2015-01-15 00:46:14.000000', 'consum', 0.0213, 'lps'),
	(358207, 123, '2015-01-15 00:46:15.000000', 'consum', 0.0217, 'lps'),
	(358208, 123, '2015-01-15 00:46:16.000000', 'consum', 0.0210, 'lps'),
	(358209, 123, '2015-01-15 00:46:17.000000', 'consum', 0.0213, 'lps'),
	(358210, 123, '2015-01-15 00:46:18.000000', 'consum', 0.0215, 'lps'),
	(358211, 123, '2015-01-15 00:46:19.000000', 'consum', 0.0213, 'lps'),
	(358212, 123, '2015-01-15 00:46:20.000000', 'consum', 0.0213, 'lps'),
	(358213, 123, '2015-01-15 00:46:21.000000', 'consum', 0.0214, 'lps'),
	(358214, 123, '2015-01-15 00:46:22.000000', 'consum', 0.0221, 'lps'),
	(358215, 123, '2015-01-15 00:46:23.000000', 'consum', 0.0219, 'lps'),
	(358216, 123, '2015-01-15 00:46:24.000000', 'consum', 0.0220, 'lps'),
	(358217, 123, '2015-01-15 00:46:25.000000', 'consum', 0.0212, 'lps'),
	(358218, 123, '2015-01-15 00:46:26.000000', 'consum', 0.0213, 'lps'),
	(358219, 123, '2015-01-15 00:46:27.000000', 'consum', 0.0219, 'lps'),
	(358220, 123, '2015-01-15 00:46:28.000000', 'consum', 0.0212, 'lps'),
	(358221, 123, '2015-01-15 00:46:29.000000', 'consum', 0.0217, 'lps'),
	(358222, 123, '2015-01-15 00:46:30.000000', 'consum', 0.0215, 'lps'),
	(358223, 123, '2015-01-15 00:46:31.000000', 'consum', 0.0215, 'lps'),
	(358224, 123, '2015-01-15 00:46:32.000000', 'consum', 0.0221, 'lps'),
	(358225, 123, '2015-01-15 00:46:33.000000', 'consum', 0.0214, 'lps'),
	(358226, 123, '2015-01-15 00:46:34.000000', 'consum', 0.0210, 'lps'),
	(358227, 123, '2015-01-15 00:46:35.000000', 'consum', 0.0212, 'lps'),
	(358228, 123, '2015-01-15 00:46:36.000000', 'consum', 0.0220, 'lps'),
	(358229, 123, '2015-01-15 00:46:37.000000', 'consum', 0.0219, 'lps'),
	(358230, 123, '2015-01-15 00:46:38.000000', 'consum', 0.0214, 'lps'),
	(358231, 123, '2015-01-15 00:46:39.000000', 'consum', 0.0213, 'lps'),
	(358232, 123, '2015-01-15 00:46:40.000000', 'consum', 0.0216, 'lps'),
	(358233, 123, '2015-01-15 00:46:41.000000', 'consum', 0.0219, 'lps'),
	(358234, 123, '2015-01-15 00:46:42.000000', 'consum', 0.0212, 'lps'),
	(358235, 123, '2015-01-15 00:46:43.000000', 'consum', 0.0217, 'lps'),
	(358236, 123, '2015-01-15 00:46:44.000000', 'consum', 0.0218, 'lps'),
	(358237, 123, '2015-01-15 00:46:45.000000', 'consum', 0.0215, 'lps'),
	(358238, 123, '2015-01-15 00:46:46.000000', 'consum', 0.0211, 'lps'),
	(358239, 123, '2015-01-15 00:46:47.000000', 'consum', 0.0213, 'lps'),
	(358240, 123, '2015-01-15 00:46:48.000000', 'consum', 0.0210, 'lps'),
	(358241, 123, '2015-01-15 00:46:49.000000', 'consum', 0.0213, 'lps'),
	(358242, 123, '2015-01-15 00:46:50.000000', 'consum', 0.0216, 'lps'),
	(358243, 123, '2015-01-15 00:46:51.000000', 'consum', 0.0219, 'lps'),
	(358244, 123, '2015-01-15 00:46:52.000000', 'consum', 0.0212, 'lps'),
	(358245, 123, '2015-01-15 00:46:53.000000', 'consum', 0.0218, 'lps'),
	(358246, 123, '2015-01-15 00:46:54.000000', 'consum', 0.0210, 'lps'),
	(358247, 123, '2015-01-15 00:46:55.000000', 'consum', 0.0220, 'lps'),
	(358248, 123, '2015-01-15 00:46:56.000000', 'consum', 0.0212, 'lps'),
	(358249, 123, '2015-01-15 00:46:57.000000', 'consum', 0.0217, 'lps'),
	(358250, 123, '2015-01-15 00:46:58.000000', 'consum', 0.0213, 'lps'),
	(358251, 123, '2015-01-15 00:46:59.000000', 'consum', 0.0216, 'lps'),
	(358252, 123, '2015-01-15 00:47:00.000000', 'consum', 0.0219, 'lps'),
	(358253, 123, '2015-01-15 00:47:01.000000', 'consum', 0.0215, 'lps'),
	(358254, 123, '2015-01-15 00:47:02.000000', 'consum', 0.0218, 'lps'),
	(358255, 123, '2015-01-15 00:47:03.000000', 'consum', 0.0214, 'lps'),
	(358256, 123, '2015-01-15 00:47:04.000000', 'consum', 0.0219, 'lps'),
	(358257, 123, '2015-01-15 00:47:05.000000', 'consum', 0.0221, 'lps'),
	(358258, 123, '2015-01-15 00:47:06.000000', 'consum', 0.0212, 'lps'),
	(358259, 123, '2015-01-15 00:47:07.000000', 'consum', 0.0211, 'lps'),
	(358260, 123, '2015-01-15 00:47:08.000000', 'consum', 0.0211, 'lps'),
	(358261, 123, '2015-01-15 00:47:09.000000', 'consum', 0.0211, 'lps'),
	(358262, 123, '2015-01-15 00:47:10.000000', 'consum', 0.0215, 'lps'),
	(358263, 123, '2015-01-15 00:47:11.000000', 'consum', 0.0219, 'lps'),
	(358264, 123, '2015-01-15 00:47:12.000000', 'consum', 0.0219, 'lps'),
	(358265, 123, '2015-01-15 00:47:13.000000', 'consum', 0.0214, 'lps'),
	(358266, 123, '2015-01-15 00:47:14.000000', 'consum', 0.0216, 'lps'),
	(358267, 123, '2015-01-15 00:47:15.000000', 'consum', 0.0216, 'lps'),
	(358268, 123, '2015-01-15 00:47:16.000000', 'consum', 0.0211, 'lps'),
	(358269, 123, '2015-01-15 00:47:17.000000', 'consum', 0.0221, 'lps'),
	(358270, 123, '2015-01-15 00:47:18.000000', 'consum', 0.0214, 'lps'),
	(358271, 123, '2015-01-15 00:47:19.000000', 'consum', 0.0220, 'lps'),
	(358272, 123, '2015-01-15 00:47:20.000000', 'consum', 0.0216, 'lps'),
	(358273, 123, '2015-01-15 00:47:21.000000', 'consum', 0.0220, 'lps'),
	(358274, 123, '2015-01-15 00:47:22.000000', 'consum', 0.0219, 'lps'),
	(358275, 123, '2015-01-15 00:47:23.000000', 'consum', 0.0212, 'lps'),
	(358276, 123, '2015-01-15 00:47:24.000000', 'consum', 0.0218, 'lps'),
	(358277, 123, '2015-01-15 00:47:25.000000', 'consum', 0.0220, 'lps'),
	(358278, 123, '2015-01-15 00:47:26.000000', 'consum', 0.0215, 'lps'),
	(358279, 123, '2015-01-15 00:47:27.000000', 'consum', 0.0214, 'lps'),
	(358280, 123, '2015-01-15 00:47:28.000000', 'consum', 0.0219, 'lps'),
	(358281, 123, '2015-01-15 00:47:29.000000', 'consum', 0.0217, 'lps'),
	(358282, 123, '2015-01-15 00:47:30.000000', 'consum', 0.0219, 'lps'),
	(358283, 123, '2015-01-15 00:47:31.000000', 'consum', 0.0221, 'lps'),
	(358284, 123, '2015-01-15 00:47:32.000000', 'consum', 0.0216, 'lps'),
	(358285, 123, '2015-01-15 00:47:33.000000', 'consum', 0.0218, 'lps'),
	(358286, 123, '2015-01-15 00:47:34.000000', 'consum', 0.0220, 'lps'),
	(358287, 123, '2015-01-15 00:47:35.000000', 'consum', 0.0215, 'lps'),
	(358288, 123, '2015-01-15 00:47:36.000000', 'consum', 0.0216, 'lps'),
	(358289, 123, '2015-01-15 00:47:37.000000', 'consum', 0.0214, 'lps'),
	(358290, 123, '2015-01-15 00:47:38.000000', 'consum', 0.0211, 'lps'),
	(358291, 123, '2015-01-15 00:47:39.000000', 'consum', 0.0216, 'lps'),
	(358292, 123, '2015-01-15 00:47:40.000000', 'consum', 0.0214, 'lps'),
	(358293, 123, '2015-01-15 00:47:41.000000', 'consum', 0.0212, 'lps'),
	(358294, 123, '2015-01-15 00:47:42.000000', 'consum', 0.0210, 'lps'),
	(358295, 123, '2015-01-15 00:47:43.000000', 'consum', 0.0215, 'lps'),
	(358296, 123, '2015-01-15 00:47:44.000000', 'consum', 0.0211, 'lps'),
	(358297, 123, '2015-01-15 00:47:45.000000', 'consum', 0.0212, 'lps'),
	(358298, 123, '2015-01-15 00:47:46.000000', 'consum', 0.0219, 'lps'),
	(358299, 123, '2015-01-15 00:47:47.000000', 'consum', 0.0214, 'lps'),
	(358300, 123, '2015-01-15 00:47:48.000000', 'consum', 0.0216, 'lps'),
	(358301, 123, '2015-01-15 00:47:49.000000', 'consum', 0.0217, 'lps'),
	(358302, 123, '2015-01-15 00:47:50.000000', 'consum', 0.0215, 'lps'),
	(358303, 123, '2015-01-15 00:47:51.000000', 'consum', 0.0214, 'lps'),
	(358304, 123, '2015-01-15 00:47:52.000000', 'consum', 0.0216, 'lps'),
	(358305, 123, '2015-01-15 00:47:53.000000', 'consum', 0.0215, 'lps'),
	(358306, 123, '2015-01-15 00:47:54.000000', 'consum', 0.0217, 'lps'),
	(358307, 123, '2015-01-15 00:47:55.000000', 'consum', 0.0221, 'lps'),
	(358308, 123, '2015-01-15 00:47:56.000000', 'consum', 0.0219, 'lps'),
	(358309, 123, '2015-01-15 00:47:57.000000', 'consum', 0.0221, 'lps'),
	(358310, 123, '2015-01-15 00:47:58.000000', 'consum', 0.0217, 'lps'),
	(358311, 123, '2015-01-15 00:47:59.000000', 'consum', 0.0211, 'lps'),
	(358312, 123, '2015-01-15 00:48:00.000000', 'consum', 0.0220, 'lps'),
	(358313, 123, '2015-01-15 00:48:01.000000', 'consum', 0.0220, 'lps'),
	(358314, 123, '2015-01-15 00:48:02.000000', 'consum', 0.0220, 'lps'),
	(358315, 123, '2015-01-15 00:48:03.000000', 'consum', 0.0218, 'lps'),
	(358316, 123, '2015-01-15 00:48:04.000000', 'consum', 0.0210, 'lps'),
	(358317, 123, '2015-01-15 00:48:05.000000', 'consum', 0.0210, 'lps'),
	(358318, 123, '2015-01-15 00:48:06.000000', 'consum', 0.0211, 'lps'),
	(358319, 123, '2015-01-15 00:48:07.000000', 'consum', 0.0213, 'lps'),
	(358320, 123, '2015-01-15 00:48:08.000000', 'consum', 0.0213, 'lps'),
	(358321, 123, '2015-01-15 00:48:09.000000', 'consum', 0.0216, 'lps'),
	(358322, 123, '2015-01-15 00:48:10.000000', 'consum', 0.0221, 'lps'),
	(358323, 123, '2015-01-15 00:48:11.000000', 'consum', 0.0211, 'lps'),
	(358324, 123, '2015-01-15 00:48:12.000000', 'consum', 0.0219, 'lps'),
	(358325, 123, '2015-01-15 00:48:13.000000', 'consum', 0.0215, 'lps'),
	(358326, 123, '2015-01-15 00:48:14.000000', 'consum', 0.0220, 'lps'),
	(358327, 123, '2015-01-15 00:48:15.000000', 'consum', 0.0211, 'lps'),
	(358328, 123, '2015-01-15 00:48:16.000000', 'consum', 0.0210, 'lps'),
	(358329, 123, '2015-01-15 00:48:17.000000', 'consum', 0.0218, 'lps'),
	(358330, 123, '2015-01-15 00:48:18.000000', 'consum', 0.0213, 'lps'),
	(358331, 123, '2015-01-15 00:48:19.000000', 'consum', 0.0215, 'lps'),
	(358332, 123, '2015-01-15 00:48:20.000000', 'consum', 0.0216, 'lps'),
	(358333, 123, '2015-01-15 00:48:21.000000', 'consum', 0.0214, 'lps'),
	(358334, 123, '2015-01-15 00:48:22.000000', 'consum', 0.0213, 'lps'),
	(358335, 123, '2015-01-15 00:48:23.000000', 'consum', 0.0211, 'lps'),
	(358336, 123, '2015-01-15 00:48:24.000000', 'consum', 0.0220, 'lps'),
	(358337, 123, '2015-01-15 00:48:25.000000', 'consum', 0.0220, 'lps'),
	(358338, 123, '2015-01-15 00:48:26.000000', 'consum', 0.0218, 'lps'),
	(358339, 123, '2015-01-15 00:48:27.000000', 'consum', 0.0221, 'lps'),
	(358340, 123, '2015-01-15 00:48:28.000000', 'consum', 0.0218, 'lps'),
	(358341, 123, '2015-01-15 00:48:29.000000', 'consum', 0.0217, 'lps'),
	(358342, 123, '2015-01-15 00:48:30.000000', 'consum', 0.0221, 'lps'),
	(358343, 123, '2015-01-15 00:48:31.000000', 'consum', 0.0210, 'lps'),
	(358344, 123, '2015-01-15 00:48:32.000000', 'consum', 0.0213, 'lps'),
	(358345, 123, '2015-01-15 00:48:33.000000', 'consum', 0.0215, 'lps'),
	(358346, 123, '2015-01-15 00:48:34.000000', 'consum', 0.0213, 'lps'),
	(358347, 123, '2015-01-15 00:48:35.000000', 'consum', 0.0221, 'lps'),
	(358348, 123, '2015-01-15 00:48:36.000000', 'consum', 0.0211, 'lps'),
	(358349, 123, '2015-01-15 00:48:37.000000', 'consum', 0.0218, 'lps'),
	(358350, 123, '2015-01-15 00:48:38.000000', 'consum', 0.0211, 'lps'),
	(358351, 123, '2015-01-15 00:48:39.000000', 'consum', 0.0214, 'lps'),
	(358352, 123, '2015-01-15 00:48:40.000000', 'consum', 0.0218, 'lps'),
	(358353, 123, '2015-01-15 00:48:41.000000', 'consum', 0.0214, 'lps'),
	(358354, 123, '2015-01-15 00:48:42.000000', 'consum', 0.0218, 'lps'),
	(358355, 123, '2015-01-15 00:48:43.000000', 'consum', 0.0213, 'lps'),
	(358356, 123, '2015-01-15 00:48:44.000000', 'consum', 0.0216, 'lps'),
	(358357, 123, '2015-01-15 00:48:45.000000', 'consum', 0.0220, 'lps'),
	(358358, 123, '2015-01-15 00:48:46.000000', 'consum', 0.0217, 'lps'),
	(358359, 123, '2015-01-15 00:48:47.000000', 'consum', 0.0214, 'lps'),
	(358360, 123, '2015-01-15 00:48:48.000000', 'consum', 0.0213, 'lps'),
	(358361, 123, '2015-01-15 00:48:49.000000', 'consum', 0.0212, 'lps'),
	(358362, 123, '2015-01-15 00:48:50.000000', 'consum', 0.0210, 'lps'),
	(358363, 123, '2015-01-15 00:48:51.000000', 'consum', 0.0216, 'lps'),
	(358364, 123, '2015-01-15 00:48:52.000000', 'consum', 0.0217, 'lps'),
	(358365, 123, '2015-01-15 00:48:53.000000', 'consum', 0.0214, 'lps'),
	(358366, 123, '2015-01-15 00:48:54.000000', 'consum', 0.0213, 'lps'),
	(358367, 123, '2015-01-15 00:48:55.000000', 'consum', 0.0210, 'lps'),
	(358368, 123, '2015-01-15 00:48:56.000000', 'consum', 0.0217, 'lps'),
	(358369, 123, '2015-01-15 00:48:57.000000', 'consum', 0.0219, 'lps'),
	(358370, 123, '2015-01-15 00:48:58.000000', 'consum', 0.0213, 'lps'),
	(358371, 123, '2015-01-15 00:48:59.000000', 'consum', 0.0219, 'lps'),
	(358372, 123, '2015-01-15 00:49:00.000000', 'consum', 0.0213, 'lps'),
	(358373, 123, '2015-01-15 00:49:01.000000', 'consum', 0.0212, 'lps'),
	(358374, 123, '2015-01-15 00:49:02.000000', 'consum', 0.0221, 'lps'),
	(358375, 123, '2015-01-15 00:49:03.000000', 'consum', 0.0213, 'lps'),
	(358376, 123, '2015-01-15 00:49:04.000000', 'consum', 0.0217, 'lps'),
	(358377, 123, '2015-01-15 00:49:05.000000', 'consum', 0.0211, 'lps'),
	(358378, 123, '2015-01-15 00:49:06.000000', 'consum', 0.0220, 'lps'),
	(358379, 123, '2015-01-15 00:49:07.000000', 'consum', 0.0210, 'lps'),
	(358380, 123, '2015-01-15 00:49:08.000000', 'consum', 0.0217, 'lps'),
	(358381, 123, '2015-01-15 00:49:09.000000', 'consum', 0.0220, 'lps'),
	(358382, 123, '2015-01-15 00:49:10.000000', 'consum', 0.0218, 'lps'),
	(358383, 123, '2015-01-15 00:49:11.000000', 'consum', 0.0219, 'lps'),
	(358384, 123, '2015-01-15 00:49:12.000000', 'consum', 0.0219, 'lps'),
	(358385, 123, '2015-01-15 00:49:13.000000', 'consum', 0.0216, 'lps'),
	(358386, 123, '2015-01-15 00:49:14.000000', 'consum', 0.0214, 'lps'),
	(358387, 123, '2015-01-15 00:49:15.000000', 'consum', 0.0213, 'lps'),
	(358388, 123, '2015-01-15 00:49:16.000000', 'consum', 0.0213, 'lps'),
	(358389, 123, '2015-01-15 00:49:17.000000', 'consum', 0.0217, 'lps'),
	(358390, 123, '2015-01-15 00:49:18.000000', 'consum', 0.0211, 'lps'),
	(358391, 123, '2015-01-15 00:49:19.000000', 'consum', 0.0218, 'lps'),
	(358392, 123, '2015-01-15 00:49:20.000000', 'consum', 0.0211, 'lps'),
	(358393, 123, '2015-01-15 00:49:21.000000', 'consum', 0.0217, 'lps'),
	(358394, 123, '2015-01-15 00:49:22.000000', 'consum', 0.0219, 'lps'),
	(358395, 123, '2015-01-15 00:49:23.000000', 'consum', 0.0221, 'lps'),
	(358396, 123, '2015-01-15 00:49:24.000000', 'consum', 0.0215, 'lps'),
	(358397, 123, '2015-01-15 00:49:25.000000', 'consum', 0.0215, 'lps'),
	(358398, 123, '2015-01-15 00:49:26.000000', 'consum', 0.0220, 'lps'),
	(358399, 123, '2015-01-15 00:49:27.000000', 'consum', 0.0220, 'lps'),
	(358400, 123, '2015-01-15 00:49:28.000000', 'consum', 0.0220, 'lps'),
	(358401, 123, '2015-01-15 00:49:29.000000', 'consum', 0.0218, 'lps'),
	(358402, 123, '2015-01-15 00:49:30.000000', 'consum', 0.0221, 'lps'),
	(358403, 123, '2015-01-15 00:49:31.000000', 'consum', 0.0218, 'lps'),
	(358404, 123, '2015-01-15 00:49:32.000000', 'consum', 0.0217, 'lps'),
	(358405, 123, '2015-01-15 00:49:33.000000', 'consum', 0.0212, 'lps'),
	(358406, 123, '2015-01-15 00:49:34.000000', 'consum', 0.0220, 'lps'),
	(358407, 123, '2015-01-15 00:49:35.000000', 'consum', 0.0219, 'lps'),
	(358408, 123, '2015-01-15 00:49:36.000000', 'consum', 0.0215, 'lps'),
	(358409, 123, '2015-01-15 00:49:37.000000', 'consum', 0.0220, 'lps'),
	(358410, 123, '2015-01-15 00:49:38.000000', 'consum', 0.0220, 'lps'),
	(358411, 123, '2015-01-15 00:49:39.000000', 'consum', 0.0220, 'lps'),
	(358412, 123, '2015-01-15 00:49:40.000000', 'consum', 0.0217, 'lps'),
	(358413, 123, '2015-01-15 00:49:41.000000', 'consum', 0.0215, 'lps'),
	(358414, 123, '2015-01-15 00:49:42.000000', 'consum', 0.0216, 'lps'),
	(358415, 123, '2015-01-15 00:49:43.000000', 'consum', 0.0213, 'lps'),
	(358416, 123, '2015-01-15 00:49:44.000000', 'consum', 0.0218, 'lps'),
	(358417, 123, '2015-01-15 00:49:45.000000', 'consum', 0.0220, 'lps'),
	(358418, 123, '2015-01-15 00:49:46.000000', 'consum', 0.0211, 'lps'),
	(358419, 123, '2015-01-15 00:49:47.000000', 'consum', 0.0221, 'lps'),
	(358420, 123, '2015-01-15 00:49:48.000000', 'consum', 0.0214, 'lps'),
	(358421, 123, '2015-01-15 00:49:49.000000', 'consum', 0.0221, 'lps'),
	(358422, 123, '2015-01-15 00:49:50.000000', 'consum', 0.0218, 'lps'),
	(358423, 123, '2015-01-15 00:49:51.000000', 'consum', 0.0219, 'lps'),
	(358424, 123, '2015-01-15 00:49:52.000000', 'consum', 0.0218, 'lps'),
	(358425, 123, '2015-01-15 00:49:53.000000', 'consum', 0.0212, 'lps'),
	(358426, 123, '2015-01-15 00:49:54.000000', 'consum', 0.0220, 'lps'),
	(358427, 123, '2015-01-15 00:49:55.000000', 'consum', 0.0219, 'lps'),
	(358428, 123, '2015-01-15 00:49:56.000000', 'consum', 0.0215, 'lps'),
	(358429, 123, '2015-01-15 00:49:57.000000', 'consum', 0.0220, 'lps'),
	(358430, 123, '2015-01-15 00:49:58.000000', 'consum', 0.0220, 'lps'),
	(358431, 123, '2015-01-15 00:49:59.000000', 'consum', 0.0219, 'lps'),
	(358432, 123, '2015-01-15 00:50:00.000000', 'consum', 0.0216, 'lps'),
	(358433, 123, '2015-01-15 00:50:01.000000', 'consum', 0.0211, 'lps'),
	(358434, 123, '2015-01-15 00:50:02.000000', 'consum', 0.0210, 'lps'),
	(358435, 123, '2015-01-15 00:50:03.000000', 'consum', 0.0218, 'lps'),
	(358436, 123, '2015-01-15 00:50:04.000000', 'consum', 0.0214, 'lps'),
	(358437, 123, '2015-01-15 00:50:05.000000', 'consum', 0.0219, 'lps'),
	(358438, 123, '2015-01-15 00:50:06.000000', 'consum', 0.0220, 'lps'),
	(358439, 123, '2015-01-15 00:50:07.000000', 'consum', 0.0210, 'lps'),
	(358440, 123, '2015-01-15 00:50:08.000000', 'consum', 0.0216, 'lps'),
	(358441, 123, '2015-01-15 00:50:09.000000', 'consum', 0.0218, 'lps'),
	(358442, 123, '2015-01-15 00:50:10.000000', 'consum', 0.0221, 'lps'),
	(358443, 123, '2015-01-15 00:50:11.000000', 'consum', 0.0219, 'lps'),
	(358444, 123, '2015-01-15 00:50:12.000000', 'consum', 0.0219, 'lps'),
	(358445, 123, '2015-01-15 00:50:13.000000', 'consum', 0.0217, 'lps'),
	(358446, 123, '2015-01-15 00:50:14.000000', 'consum', 0.0218, 'lps'),
	(358447, 123, '2015-01-15 00:50:15.000000', 'consum', 0.0220, 'lps'),
	(358448, 123, '2015-01-15 00:50:16.000000', 'consum', 0.0210, 'lps'),
	(358449, 123, '2015-01-15 00:50:17.000000', 'consum', 0.0219, 'lps'),
	(358450, 123, '2015-01-15 00:50:18.000000', 'consum', 0.0217, 'lps'),
	(358451, 123, '2015-01-15 00:50:19.000000', 'consum', 0.0218, 'lps'),
	(358452, 123, '2015-01-15 00:50:20.000000', 'consum', 0.0220, 'lps'),
	(358453, 123, '2015-01-15 00:50:21.000000', 'consum', 0.0211, 'lps'),
	(358454, 123, '2015-01-15 00:50:22.000000', 'consum', 0.0210, 'lps'),
	(358455, 123, '2015-01-15 00:50:23.000000', 'consum', 0.0221, 'lps'),
	(358456, 123, '2015-01-15 00:50:24.000000', 'consum', 0.0218, 'lps'),
	(358457, 123, '2015-01-15 00:50:25.000000', 'consum', 0.0217, 'lps'),
	(358458, 123, '2015-01-15 00:50:26.000000', 'consum', 0.0219, 'lps'),
	(358459, 123, '2015-01-15 00:50:27.000000', 'consum', 0.0214, 'lps'),
	(358460, 123, '2015-01-15 00:50:28.000000', 'consum', 0.0213, 'lps'),
	(358461, 123, '2015-01-15 00:50:29.000000', 'consum', 0.0214, 'lps'),
	(358462, 123, '2015-01-15 00:50:30.000000', 'consum', 0.0221, 'lps'),
	(358463, 123, '2015-01-15 00:50:31.000000', 'consum', 0.0219, 'lps'),
	(358464, 123, '2015-01-15 00:50:32.000000', 'consum', 0.0210, 'lps'),
	(358465, 123, '2015-01-15 00:50:33.000000', 'consum', 0.0217, 'lps'),
	(358466, 123, '2015-01-15 00:50:34.000000', 'consum', 0.0213, 'lps'),
	(358467, 123, '2015-01-15 00:50:35.000000', 'consum', 0.0216, 'lps'),
	(358468, 123, '2015-01-15 00:50:36.000000', 'consum', 0.0221, 'lps'),
	(358469, 123, '2015-01-15 00:50:37.000000', 'consum', 0.0221, 'lps'),
	(358470, 123, '2015-01-15 00:50:38.000000', 'consum', 0.0219, 'lps'),
	(358471, 123, '2015-01-15 00:50:39.000000', 'consum', 0.0213, 'lps'),
	(358472, 123, '2015-01-15 00:50:40.000000', 'consum', 0.0221, 'lps'),
	(358473, 123, '2015-01-15 00:50:41.000000', 'consum', 0.0219, 'lps'),
	(358474, 123, '2015-01-15 00:50:42.000000', 'consum', 0.0213, 'lps'),
	(358475, 123, '2015-01-15 00:50:43.000000', 'consum', 0.0220, 'lps'),
	(358476, 123, '2015-01-15 00:50:44.000000', 'consum', 0.0215, 'lps'),
	(358477, 123, '2015-01-15 00:50:45.000000', 'consum', 0.0220, 'lps'),
	(358478, 123, '2015-01-15 00:50:46.000000', 'consum', 0.0210, 'lps'),
	(358479, 123, '2015-01-15 00:50:47.000000', 'consum', 0.0217, 'lps'),
	(358480, 123, '2015-01-15 00:50:48.000000', 'consum', 0.0221, 'lps'),
	(358481, 123, '2015-01-15 00:50:49.000000', 'consum', 0.0210, 'lps'),
	(358482, 123, '2015-01-15 00:50:50.000000', 'consum', 0.0212, 'lps'),
	(358483, 123, '2015-01-15 00:50:51.000000', 'consum', 0.0210, 'lps'),
	(358484, 123, '2015-01-15 00:50:52.000000', 'consum', 0.0214, 'lps'),
	(358485, 123, '2015-01-15 00:50:53.000000', 'consum', 0.0219, 'lps'),
	(358486, 123, '2015-01-15 00:50:54.000000', 'consum', 0.0210, 'lps'),
	(358487, 123, '2015-01-15 00:50:55.000000', 'consum', 0.0217, 'lps'),
	(358488, 123, '2015-01-15 00:50:56.000000', 'consum', 0.0211, 'lps'),
	(358489, 123, '2015-01-15 00:50:57.000000', 'consum', 0.0220, 'lps'),
	(358490, 123, '2015-01-15 00:50:58.000000', 'consum', 0.0219, 'lps'),
	(358491, 123, '2015-01-15 00:50:59.000000', 'consum', 0.0213, 'lps'),
	(358492, 123, '2015-01-15 00:51:00.000000', 'consum', 0.0221, 'lps'),
	(358493, 123, '2015-01-15 00:51:01.000000', 'consum', 0.0211, 'lps'),
	(358494, 123, '2015-01-15 00:51:02.000000', 'consum', 0.0219, 'lps'),
	(358495, 123, '2015-01-15 00:51:03.000000', 'consum', 0.0214, 'lps'),
	(358496, 123, '2015-01-15 00:51:04.000000', 'consum', 0.0217, 'lps'),
	(358497, 123, '2015-01-15 00:51:05.000000', 'consum', 0.0211, 'lps'),
	(358498, 123, '2015-01-15 00:51:06.000000', 'consum', 0.0215, 'lps'),
	(358499, 123, '2015-01-15 00:51:07.000000', 'consum', 0.0212, 'lps'),
	(358500, 123, '2015-01-15 00:51:08.000000', 'consum', 0.0216, 'lps'),
	(358501, 123, '2015-01-15 00:51:09.000000', 'consum', 0.0210, 'lps'),
	(358502, 123, '2015-01-15 00:51:10.000000', 'consum', 0.0218, 'lps'),
	(358503, 123, '2015-01-15 00:51:11.000000', 'consum', 0.0215, 'lps'),
	(358504, 123, '2015-01-15 00:51:12.000000', 'consum', 0.0212, 'lps'),
	(358505, 123, '2015-01-15 00:51:13.000000', 'consum', 0.0216, 'lps'),
	(358506, 123, '2015-01-15 00:51:14.000000', 'consum', 0.0210, 'lps'),
	(358507, 123, '2015-01-15 00:51:15.000000', 'consum', 0.0218, 'lps'),
	(358508, 123, '2015-01-15 00:51:16.000000', 'consum', 0.0216, 'lps'),
	(358509, 123, '2015-01-15 00:51:17.000000', 'consum', 0.0213, 'lps'),
	(358510, 123, '2015-01-15 00:51:18.000000', 'consum', 0.0211, 'lps'),
	(358511, 123, '2015-01-15 00:51:19.000000', 'consum', 0.0217, 'lps'),
	(358512, 123, '2015-01-15 00:51:20.000000', 'consum', 0.0218, 'lps'),
	(358513, 123, '2015-01-15 00:51:21.000000', 'consum', 0.0218, 'lps'),
	(358514, 123, '2015-01-15 00:51:22.000000', 'consum', 0.0213, 'lps'),
	(358515, 123, '2015-01-15 00:51:23.000000', 'consum', 0.0215, 'lps'),
	(358516, 123, '2015-01-15 00:51:24.000000', 'consum', 0.0213, 'lps'),
	(358517, 123, '2015-01-15 00:51:25.000000', 'consum', 0.0210, 'lps'),
	(358518, 123, '2015-01-15 00:51:26.000000', 'consum', 0.0215, 'lps'),
	(358519, 123, '2015-01-15 00:51:27.000000', 'consum', 0.0221, 'lps'),
	(358520, 123, '2015-01-15 00:51:28.000000', 'consum', 0.0217, 'lps'),
	(358521, 123, '2015-01-15 00:51:29.000000', 'consum', 0.0210, 'lps'),
	(358522, 123, '2015-01-15 00:51:30.000000', 'consum', 0.0214, 'lps'),
	(358523, 123, '2015-01-15 00:51:31.000000', 'consum', 0.0220, 'lps'),
	(358524, 123, '2015-01-15 00:51:32.000000', 'consum', 0.0210, 'lps'),
	(358525, 123, '2015-01-15 00:51:33.000000', 'consum', 0.0220, 'lps'),
	(358526, 123, '2015-01-15 00:51:34.000000', 'consum', 0.0221, 'lps'),
	(358527, 123, '2015-01-15 00:51:35.000000', 'consum', 0.0213, 'lps'),
	(358528, 123, '2015-01-15 00:51:36.000000', 'consum', 0.0215, 'lps'),
	(358529, 123, '2015-01-15 00:51:37.000000', 'consum', 0.0217, 'lps'),
	(358530, 123, '2015-01-15 00:51:38.000000', 'consum', 0.0218, 'lps'),
	(358531, 123, '2015-01-15 00:51:39.000000', 'consum', 0.0219, 'lps'),
	(358532, 123, '2015-01-15 00:51:40.000000', 'consum', 0.0219, 'lps'),
	(358533, 123, '2015-01-15 00:51:41.000000', 'consum', 0.0215, 'lps'),
	(358534, 123, '2015-01-15 00:51:42.000000', 'consum', 0.0211, 'lps'),
	(358535, 123, '2015-01-15 00:51:43.000000', 'consum', 0.0212, 'lps'),
	(358536, 123, '2015-01-15 00:51:44.000000', 'consum', 0.0216, 'lps'),
	(358537, 123, '2015-01-15 00:51:45.000000', 'consum', 0.0212, 'lps'),
	(358538, 123, '2015-01-15 00:51:46.000000', 'consum', 0.0214, 'lps'),
	(358539, 123, '2015-01-15 00:51:47.000000', 'consum', 0.0213, 'lps'),
	(358540, 123, '2015-01-15 00:51:48.000000', 'consum', 0.0212, 'lps'),
	(358541, 123, '2015-01-15 00:51:49.000000', 'consum', 0.0212, 'lps'),
	(358542, 123, '2015-01-15 00:51:50.000000', 'consum', 0.0215, 'lps'),
	(358543, 123, '2015-01-15 00:51:51.000000', 'consum', 0.0218, 'lps'),
	(358544, 123, '2015-01-15 00:51:52.000000', 'consum', 0.0211, 'lps'),
	(358545, 123, '2015-01-15 00:51:53.000000', 'consum', 0.0215, 'lps'),
	(358546, 123, '2015-01-15 00:51:54.000000', 'consum', 0.0210, 'lps'),
	(358547, 123, '2015-01-15 00:51:55.000000', 'consum', 0.0219, 'lps'),
	(358548, 123, '2015-01-15 00:51:56.000000', 'consum', 0.0221, 'lps'),
	(358549, 123, '2015-01-15 00:51:57.000000', 'consum', 0.0215, 'lps'),
	(358550, 123, '2015-01-15 00:51:58.000000', 'consum', 0.0212, 'lps'),
	(358551, 123, '2015-01-15 00:51:59.000000', 'consum', 0.0220, 'lps'),
	(358552, 123, '2015-01-15 00:52:00.000000', 'consum', 0.0217, 'lps'),
	(358553, 123, '2015-01-15 00:52:01.000000', 'consum', 0.0216, 'lps'),
	(358554, 123, '2015-01-15 00:52:02.000000', 'consum', 0.0220, 'lps'),
	(358555, 123, '2015-01-15 00:52:03.000000', 'consum', 0.0219, 'lps'),
	(358556, 123, '2015-01-15 00:52:04.000000', 'consum', 0.0213, 'lps'),
	(358557, 123, '2015-01-15 00:52:05.000000', 'consum', 0.0210, 'lps'),
	(358558, 123, '2015-01-15 00:52:06.000000', 'consum', 0.0213, 'lps'),
	(358559, 123, '2015-01-15 00:52:07.000000', 'consum', 0.0215, 'lps'),
	(358560, 123, '2015-01-15 00:52:08.000000', 'consum', 0.0216, 'lps'),
	(358561, 123, '2015-01-15 00:52:09.000000', 'consum', 0.0210, 'lps'),
	(358562, 123, '2015-01-15 00:52:10.000000', 'consum', 0.0219, 'lps'),
	(358563, 123, '2015-01-15 00:52:11.000000', 'consum', 0.0219, 'lps'),
	(358564, 123, '2015-01-15 00:52:12.000000', 'consum', 0.0217, 'lps'),
	(358565, 123, '2015-01-15 00:52:13.000000', 'consum', 0.0220, 'lps'),
	(358566, 123, '2015-01-15 00:52:14.000000', 'consum', 0.0213, 'lps'),
	(358567, 123, '2015-01-15 00:52:15.000000', 'consum', 0.0220, 'lps'),
	(358568, 123, '2015-01-15 00:52:16.000000', 'consum', 0.0215, 'lps'),
	(358569, 123, '2015-01-15 00:52:17.000000', 'consum', 0.0217, 'lps'),
	(358570, 123, '2015-01-15 00:52:18.000000', 'consum', 0.0218, 'lps'),
	(358571, 123, '2015-01-15 00:52:19.000000', 'consum', 0.0218, 'lps'),
	(358572, 123, '2015-01-15 00:52:20.000000', 'consum', 0.0217, 'lps'),
	(358573, 123, '2015-01-15 00:52:21.000000', 'consum', 0.0219, 'lps'),
	(358574, 123, '2015-01-15 00:52:22.000000', 'consum', 0.0211, 'lps'),
	(358575, 123, '2015-01-15 00:52:23.000000', 'consum', 0.0211, 'lps'),
	(358576, 123, '2015-01-15 00:52:24.000000', 'consum', 0.0214, 'lps'),
	(358577, 123, '2015-01-15 00:52:25.000000', 'consum', 0.0215, 'lps'),
	(358578, 123, '2015-01-15 00:52:26.000000', 'consum', 0.0213, 'lps'),
	(358579, 123, '2015-01-15 00:52:27.000000', 'consum', 0.0220, 'lps'),
	(358580, 123, '2015-01-15 00:52:28.000000', 'consum', 0.0218, 'lps'),
	(358581, 123, '2015-01-15 00:52:29.000000', 'consum', 0.0221, 'lps'),
	(358582, 123, '2015-01-15 00:52:30.000000', 'consum', 0.0215, 'lps'),
	(358583, 123, '2015-01-15 00:52:31.000000', 'consum', 0.0214, 'lps'),
	(358584, 123, '2015-01-15 00:52:32.000000', 'consum', 0.0215, 'lps'),
	(358585, 123, '2015-01-15 00:52:33.000000', 'consum', 0.0212, 'lps'),
	(358586, 123, '2015-01-15 00:52:34.000000', 'consum', 0.0217, 'lps'),
	(358587, 123, '2015-01-15 00:52:35.000000', 'consum', 0.0215, 'lps'),
	(358588, 123, '2015-01-15 00:52:36.000000', 'consum', 0.0215, 'lps'),
	(358589, 123, '2015-01-15 00:52:37.000000', 'consum', 0.0219, 'lps'),
	(358590, 123, '2015-01-15 00:52:38.000000', 'consum', 0.0218, 'lps'),
	(358591, 123, '2015-01-15 00:52:39.000000', 'consum', 0.0212, 'lps'),
	(358592, 123, '2015-01-15 00:52:40.000000', 'consum', 0.0219, 'lps'),
	(358593, 123, '2015-01-15 00:52:41.000000', 'consum', 0.0215, 'lps'),
	(358594, 123, '2015-01-15 00:52:42.000000', 'consum', 0.0221, 'lps'),
	(358595, 123, '2015-01-15 00:52:43.000000', 'consum', 0.0212, 'lps'),
	(358596, 123, '2015-01-15 00:52:44.000000', 'consum', 0.0214, 'lps'),
	(358597, 123, '2015-01-15 00:52:45.000000', 'consum', 0.0214, 'lps'),
	(358598, 123, '2015-01-15 00:52:46.000000', 'consum', 0.0216, 'lps'),
	(358599, 123, '2015-01-15 00:52:47.000000', 'consum', 0.0215, 'lps'),
	(358600, 123, '2015-01-15 00:52:48.000000', 'consum', 0.0220, 'lps'),
	(358601, 123, '2015-01-15 00:52:49.000000', 'consum', 0.0221, 'lps'),
	(358602, 123, '2015-01-15 00:52:50.000000', 'consum', 0.0210, 'lps'),
	(358603, 123, '2015-01-15 00:52:51.000000', 'consum', 0.0215, 'lps'),
	(358604, 123, '2015-01-15 00:52:52.000000', 'consum', 0.0211, 'lps'),
	(358605, 123, '2015-01-15 00:52:53.000000', 'consum', 0.0211, 'lps'),
	(358606, 123, '2015-01-15 00:52:54.000000', 'consum', 0.0215, 'lps'),
	(358607, 123, '2015-01-15 00:52:55.000000', 'consum', 0.0218, 'lps'),
	(358608, 123, '2015-01-15 00:52:56.000000', 'consum', 0.0213, 'lps'),
	(358609, 123, '2015-01-15 00:52:57.000000', 'consum', 0.0212, 'lps'),
	(358610, 123, '2015-01-15 00:52:58.000000', 'consum', 0.0213, 'lps'),
	(358611, 123, '2015-01-15 00:52:59.000000', 'consum', 0.0218, 'lps'),
	(358612, 123, '2015-01-15 00:53:00.000000', 'consum', 0.0216, 'lps'),
	(358613, 123, '2015-01-15 00:53:01.000000', 'consum', 0.0219, 'lps'),
	(358614, 123, '2015-01-15 00:53:02.000000', 'consum', 0.0214, 'lps'),
	(358615, 123, '2015-01-15 00:53:03.000000', 'consum', 0.0215, 'lps'),
	(358616, 123, '2015-01-15 00:53:04.000000', 'consum', 0.0211, 'lps'),
	(358617, 123, '2015-01-15 00:53:05.000000', 'consum', 0.0213, 'lps'),
	(358618, 123, '2015-01-15 00:53:06.000000', 'consum', 0.0212, 'lps'),
	(358619, 123, '2015-01-15 00:53:07.000000', 'consum', 0.0212, 'lps'),
	(358620, 123, '2015-01-15 00:53:08.000000', 'consum', 0.0214, 'lps'),
	(358621, 123, '2015-01-15 00:53:09.000000', 'consum', 0.0210, 'lps'),
	(358622, 123, '2015-01-15 00:53:10.000000', 'consum', 0.0214, 'lps'),
	(358623, 123, '2015-01-15 00:53:11.000000', 'consum', 0.0217, 'lps'),
	(358624, 123, '2015-01-15 00:53:12.000000', 'consum', 0.0211, 'lps'),
	(358625, 123, '2015-01-15 00:53:13.000000', 'consum', 0.0216, 'lps'),
	(358626, 123, '2015-01-15 00:53:14.000000', 'consum', 0.0214, 'lps'),
	(358627, 123, '2015-01-15 00:53:15.000000', 'consum', 0.0212, 'lps'),
	(358628, 123, '2015-01-15 00:53:16.000000', 'consum', 0.0210, 'lps'),
	(358629, 123, '2015-01-15 00:53:17.000000', 'consum', 0.0217, 'lps'),
	(358630, 123, '2015-01-15 00:53:18.000000', 'consum', 0.0221, 'lps'),
	(358631, 123, '2015-01-15 00:53:19.000000', 'consum', 0.0220, 'lps'),
	(358632, 123, '2015-01-15 00:53:20.000000', 'consum', 0.0215, 'lps'),
	(358633, 123, '2015-01-15 00:53:21.000000', 'consum', 0.0220, 'lps'),
	(358634, 123, '2015-01-15 00:53:22.000000', 'consum', 0.0218, 'lps'),
	(358635, 123, '2015-01-15 00:53:23.000000', 'consum', 0.0210, 'lps'),
	(358636, 123, '2015-01-15 00:53:24.000000', 'consum', 0.0210, 'lps'),
	(358637, 123, '2015-01-15 00:53:25.000000', 'consum', 0.0213, 'lps'),
	(358638, 123, '2015-01-15 00:53:26.000000', 'consum', 0.0210, 'lps'),
	(358639, 123, '2015-01-15 00:53:27.000000', 'consum', 0.0216, 'lps'),
	(358640, 123, '2015-01-15 00:53:28.000000', 'consum', 0.0216, 'lps'),
	(358641, 123, '2015-01-15 00:53:29.000000', 'consum', 0.0212, 'lps'),
	(358642, 123, '2015-01-15 00:53:30.000000', 'consum', 0.0213, 'lps'),
	(358643, 123, '2015-01-15 00:53:31.000000', 'consum', 0.0218, 'lps'),
	(358644, 123, '2015-01-15 00:53:32.000000', 'consum', 0.0219, 'lps'),
	(358645, 123, '2015-01-15 00:53:33.000000', 'consum', 0.0218, 'lps'),
	(358646, 123, '2015-01-15 00:53:34.000000', 'consum', 0.0212, 'lps'),
	(358647, 123, '2015-01-15 00:53:35.000000', 'consum', 0.0220, 'lps'),
	(358648, 123, '2015-01-15 00:53:36.000000', 'consum', 0.0219, 'lps'),
	(358649, 123, '2015-01-15 00:53:37.000000', 'consum', 0.0214, 'lps'),
	(358650, 123, '2015-01-15 00:53:38.000000', 'consum', 0.0217, 'lps'),
	(358651, 123, '2015-01-15 00:53:39.000000', 'consum', 0.0220, 'lps'),
	(358652, 123, '2015-01-15 00:53:40.000000', 'consum', 0.0215, 'lps'),
	(358653, 123, '2015-01-15 00:53:41.000000', 'consum', 0.0217, 'lps'),
	(358654, 123, '2015-01-15 00:53:42.000000', 'consum', 0.0219, 'lps'),
	(358655, 123, '2015-01-15 00:53:43.000000', 'consum', 0.0212, 'lps'),
	(358656, 123, '2015-01-15 00:53:44.000000', 'consum', 0.0217, 'lps'),
	(358657, 123, '2015-01-15 00:53:45.000000', 'consum', 0.0214, 'lps'),
	(358658, 123, '2015-01-15 00:53:46.000000', 'consum', 0.0210, 'lps'),
	(358659, 123, '2015-01-15 00:53:47.000000', 'consum', 0.0221, 'lps'),
	(358660, 123, '2015-01-15 00:53:48.000000', 'consum', 0.0220, 'lps'),
	(358661, 123, '2015-01-15 00:53:49.000000', 'consum', 0.0214, 'lps'),
	(358662, 123, '2015-01-15 00:53:50.000000', 'consum', 0.0213, 'lps'),
	(358663, 123, '2015-01-15 00:53:51.000000', 'consum', 0.0214, 'lps'),
	(358664, 123, '2015-01-15 00:53:52.000000', 'consum', 0.0221, 'lps'),
	(358665, 123, '2015-01-15 00:53:53.000000', 'consum', 0.0216, 'lps'),
	(358666, 123, '2015-01-15 00:53:54.000000', 'consum', 0.0221, 'lps'),
	(358667, 123, '2015-01-15 00:53:55.000000', 'consum', 0.0210, 'lps'),
	(358668, 123, '2015-01-15 00:53:56.000000', 'consum', 0.0216, 'lps'),
	(358669, 123, '2015-01-15 00:53:57.000000', 'consum', 0.0217, 'lps'),
	(358670, 123, '2015-01-15 00:53:58.000000', 'consum', 0.0214, 'lps'),
	(358671, 123, '2015-01-15 00:53:59.000000', 'consum', 0.0211, 'lps'),
	(358672, 123, '2015-01-15 00:54:00.000000', 'consum', 0.0214, 'lps'),
	(358673, 123, '2015-01-15 00:54:01.000000', 'consum', 0.0215, 'lps'),
	(358674, 123, '2015-01-15 00:54:02.000000', 'consum', 0.0210, 'lps'),
	(358675, 123, '2015-01-15 00:54:03.000000', 'consum', 0.0210, 'lps'),
	(358676, 123, '2015-01-15 00:54:04.000000', 'consum', 0.0221, 'lps'),
	(358677, 123, '2015-01-15 00:54:05.000000', 'consum', 0.0219, 'lps'),
	(358678, 123, '2015-01-15 00:54:06.000000', 'consum', 0.0210, 'lps'),
	(358679, 123, '2015-01-15 00:54:07.000000', 'consum', 0.0221, 'lps'),
	(358680, 123, '2015-01-15 00:54:08.000000', 'consum', 0.0215, 'lps'),
	(358681, 123, '2015-01-15 00:54:09.000000', 'consum', 0.0218, 'lps'),
	(358682, 123, '2015-01-15 00:54:10.000000', 'consum', 0.0220, 'lps'),
	(358683, 123, '2015-01-15 00:54:11.000000', 'consum', 0.0213, 'lps'),
	(358684, 123, '2015-01-15 00:54:12.000000', 'consum', 0.0220, 'lps'),
	(358685, 123, '2015-01-15 00:54:13.000000', 'consum', 0.0217, 'lps'),
	(358686, 123, '2015-01-15 00:54:14.000000', 'consum', 0.0215, 'lps'),
	(358687, 123, '2015-01-15 00:54:15.000000', 'consum', 0.0212, 'lps'),
	(358688, 123, '2015-01-15 00:54:16.000000', 'consum', 0.0219, 'lps'),
	(358689, 123, '2015-01-15 00:54:17.000000', 'consum', 0.0214, 'lps'),
	(358690, 123, '2015-01-15 00:54:18.000000', 'consum', 0.0213, 'lps'),
	(358691, 123, '2015-01-15 00:54:19.000000', 'consum', 0.0216, 'lps'),
	(358692, 123, '2015-01-15 00:54:20.000000', 'consum', 0.0219, 'lps'),
	(358693, 123, '2015-01-15 00:54:21.000000', 'consum', 0.0215, 'lps'),
	(358694, 123, '2015-01-15 00:54:22.000000', 'consum', 0.0217, 'lps'),
	(358695, 123, '2015-01-15 00:54:23.000000', 'consum', 0.0221, 'lps'),
	(358696, 123, '2015-01-15 00:54:24.000000', 'consum', 0.0221, 'lps'),
	(358697, 123, '2015-01-15 00:54:25.000000', 'consum', 0.0218, 'lps'),
	(358698, 123, '2015-01-15 00:54:26.000000', 'consum', 0.0218, 'lps'),
	(358699, 123, '2015-01-15 00:54:27.000000', 'consum', 0.0215, 'lps'),
	(358700, 123, '2015-01-15 00:54:28.000000', 'consum', 0.0211, 'lps'),
	(358701, 123, '2015-01-15 00:54:29.000000', 'consum', 0.0211, 'lps'),
	(358702, 123, '2015-01-15 00:54:30.000000', 'consum', 0.0215, 'lps'),
	(358703, 123, '2015-01-15 00:54:31.000000', 'consum', 0.0219, 'lps'),
	(358704, 123, '2015-01-15 00:54:32.000000', 'consum', 0.0216, 'lps'),
	(358705, 123, '2015-01-15 00:54:33.000000', 'consum', 0.0214, 'lps'),
	(358706, 123, '2015-01-15 00:54:34.000000', 'consum', 0.0214, 'lps'),
	(358707, 123, '2015-01-15 00:54:35.000000', 'consum', 0.0219, 'lps'),
	(358708, 123, '2015-01-15 00:54:36.000000', 'consum', 0.0220, 'lps'),
	(358709, 123, '2015-01-15 00:54:37.000000', 'consum', 0.0221, 'lps'),
	(358710, 123, '2015-01-15 00:54:38.000000', 'consum', 0.0212, 'lps'),
	(358711, 123, '2015-01-15 00:54:39.000000', 'consum', 0.0212, 'lps'),
	(358712, 123, '2015-01-15 00:54:40.000000', 'consum', 0.0215, 'lps'),
	(358713, 123, '2015-01-15 00:54:41.000000', 'consum', 0.0217, 'lps'),
	(358714, 123, '2015-01-15 00:54:42.000000', 'consum', 0.0217, 'lps'),
	(358715, 123, '2015-01-15 00:54:43.000000', 'consum', 0.0214, 'lps'),
	(358716, 123, '2015-01-15 00:54:44.000000', 'consum', 0.0219, 'lps'),
	(358717, 123, '2015-01-15 00:54:45.000000', 'consum', 0.0210, 'lps'),
	(358718, 123, '2015-01-15 00:54:46.000000', 'consum', 0.0220, 'lps'),
	(358719, 123, '2015-01-15 00:54:47.000000', 'consum', 0.0210, 'lps'),
	(358720, 123, '2015-01-15 00:54:48.000000', 'consum', 0.0220, 'lps'),
	(358721, 123, '2015-01-15 00:54:49.000000', 'consum', 0.0210, 'lps'),
	(358722, 123, '2015-01-15 00:54:50.000000', 'consum', 0.0217, 'lps'),
	(358723, 123, '2015-01-15 00:54:51.000000', 'consum', 0.0220, 'lps'),
	(358724, 123, '2015-01-15 00:54:52.000000', 'consum', 0.0218, 'lps'),
	(358725, 123, '2015-01-15 00:54:53.000000', 'consum', 0.0220, 'lps'),
	(358726, 123, '2015-01-15 00:54:54.000000', 'consum', 0.0211, 'lps'),
	(358727, 123, '2015-01-15 00:54:55.000000', 'consum', 0.0221, 'lps'),
	(358728, 123, '2015-01-15 00:54:56.000000', 'consum', 0.0216, 'lps'),
	(358729, 123, '2015-01-15 00:54:57.000000', 'consum', 0.0219, 'lps'),
	(358730, 123, '2015-01-15 00:54:58.000000', 'consum', 0.0212, 'lps'),
	(358731, 123, '2015-01-15 00:54:59.000000', 'consum', 0.0219, 'lps'),
	(358732, 123, '2015-01-15 00:55:00.000000', 'consum', 0.0212, 'lps'),
	(358733, 123, '2015-01-15 00:55:01.000000', 'consum', 0.0218, 'lps'),
	(358734, 123, '2015-01-15 00:55:02.000000', 'consum', 0.0220, 'lps'),
	(358735, 123, '2015-01-15 00:55:03.000000', 'consum', 0.0215, 'lps'),
	(358736, 123, '2015-01-15 00:55:04.000000', 'consum', 0.0214, 'lps'),
	(358737, 123, '2015-01-15 00:55:05.000000', 'consum', 0.0217, 'lps'),
	(358738, 123, '2015-01-15 00:55:06.000000', 'consum', 0.0221, 'lps'),
	(358739, 123, '2015-01-15 00:55:07.000000', 'consum', 0.0221, 'lps'),
	(358740, 123, '2015-01-15 00:55:08.000000', 'consum', 0.0220, 'lps'),
	(358741, 123, '2015-01-15 00:55:09.000000', 'consum', 0.0215, 'lps'),
	(358742, 123, '2015-01-15 00:55:10.000000', 'consum', 0.0218, 'lps'),
	(358743, 123, '2015-01-15 00:55:11.000000', 'consum', 0.0211, 'lps'),
	(358744, 123, '2015-01-15 00:55:12.000000', 'consum', 0.0216, 'lps'),
	(358745, 123, '2015-01-15 00:55:13.000000', 'consum', 0.0215, 'lps'),
	(358746, 123, '2015-01-15 00:55:14.000000', 'consum', 0.0215, 'lps'),
	(358747, 123, '2015-01-15 00:55:15.000000', 'consum', 0.0219, 'lps'),
	(358748, 123, '2015-01-15 00:55:16.000000', 'consum', 0.0220, 'lps'),
	(358749, 123, '2015-01-15 00:55:17.000000', 'consum', 0.0220, 'lps'),
	(358750, 123, '2015-01-15 00:55:18.000000', 'consum', 0.0219, 'lps'),
	(358751, 123, '2015-01-15 00:55:19.000000', 'consum', 0.0212, 'lps'),
	(358752, 123, '2015-01-15 00:55:20.000000', 'consum', 0.0218, 'lps'),
	(358753, 123, '2015-01-15 00:55:21.000000', 'consum', 0.0220, 'lps'),
	(358754, 123, '2015-01-15 00:55:22.000000', 'consum', 0.0212, 'lps'),
	(358755, 123, '2015-01-15 00:55:23.000000', 'consum', 0.0216, 'lps'),
	(358756, 123, '2015-01-15 00:55:24.000000', 'consum', 0.0221, 'lps'),
	(358757, 123, '2015-01-15 00:55:25.000000', 'consum', 0.0212, 'lps'),
	(358758, 123, '2015-01-15 00:55:26.000000', 'consum', 0.0211, 'lps'),
	(358759, 123, '2015-01-15 00:55:27.000000', 'consum', 0.0221, 'lps'),
	(358760, 123, '2015-01-15 00:55:28.000000', 'consum', 0.0214, 'lps'),
	(358761, 123, '2015-01-15 00:55:29.000000', 'consum', 0.0212, 'lps'),
	(358762, 123, '2015-01-15 00:55:30.000000', 'consum', 0.0220, 'lps'),
	(358763, 123, '2015-01-15 00:55:31.000000', 'consum', 0.0219, 'lps'),
	(358764, 123, '2015-01-15 00:55:32.000000', 'consum', 0.0214, 'lps'),
	(358765, 123, '2015-01-15 00:55:33.000000', 'consum', 0.0214, 'lps'),
	(358766, 123, '2015-01-15 00:55:34.000000', 'consum', 0.0221, 'lps'),
	(358767, 123, '2015-01-15 00:55:35.000000', 'consum', 0.0215, 'lps'),
	(358768, 123, '2015-01-15 00:55:36.000000', 'consum', 0.0217, 'lps'),
	(358769, 123, '2015-01-15 00:55:37.000000', 'consum', 0.0219, 'lps'),
	(358770, 123, '2015-01-15 00:55:38.000000', 'consum', 0.0221, 'lps'),
	(358771, 123, '2015-01-15 00:55:39.000000', 'consum', 0.0213, 'lps'),
	(358772, 123, '2015-01-15 00:55:40.000000', 'consum', 0.0218, 'lps'),
	(358773, 123, '2015-01-15 00:55:41.000000', 'consum', 0.0216, 'lps'),
	(358774, 123, '2015-01-15 00:55:42.000000', 'consum', 0.0219, 'lps'),
	(358775, 123, '2015-01-15 00:55:43.000000', 'consum', 0.0212, 'lps'),
	(358776, 123, '2015-01-15 00:55:44.000000', 'consum', 0.0218, 'lps'),
	(358777, 123, '2015-01-15 00:55:45.000000', 'consum', 0.0221, 'lps'),
	(358778, 123, '2015-01-15 00:55:46.000000', 'consum', 0.0219, 'lps'),
	(358779, 123, '2015-01-15 00:55:47.000000', 'consum', 0.0210, 'lps'),
	(358780, 123, '2015-01-15 00:55:48.000000', 'consum', 0.0217, 'lps'),
	(358781, 123, '2015-01-15 00:55:49.000000', 'consum', 0.0212, 'lps'),
	(358782, 123, '2015-01-15 00:55:50.000000', 'consum', 0.0212, 'lps'),
	(358783, 123, '2015-01-15 00:55:51.000000', 'consum', 0.0215, 'lps'),
	(358784, 123, '2015-01-15 00:55:52.000000', 'consum', 0.0215, 'lps'),
	(358785, 123, '2015-01-15 00:55:53.000000', 'consum', 0.0220, 'lps'),
	(358786, 123, '2015-01-15 00:55:54.000000', 'consum', 0.0211, 'lps'),
	(358787, 123, '2015-01-15 00:55:55.000000', 'consum', 0.0210, 'lps'),
	(358788, 123, '2015-01-15 00:55:56.000000', 'consum', 0.0221, 'lps'),
	(358789, 123, '2015-01-15 00:55:57.000000', 'consum', 0.0215, 'lps'),
	(358790, 123, '2015-01-15 00:55:58.000000', 'consum', 0.0215, 'lps'),
	(358791, 123, '2015-01-15 00:55:59.000000', 'consum', 0.0210, 'lps'),
	(358792, 123, '2015-01-15 00:56:00.000000', 'consum', 0.0217, 'lps'),
	(358793, 123, '2015-01-15 00:56:01.000000', 'consum', 0.0211, 'lps'),
	(358794, 123, '2015-01-15 00:56:02.000000', 'consum', 0.0218, 'lps'),
	(358795, 123, '2015-01-15 00:56:03.000000', 'consum', 0.0210, 'lps'),
	(358796, 123, '2015-01-15 00:56:04.000000', 'consum', 0.0211, 'lps'),
	(358797, 123, '2015-01-15 00:56:05.000000', 'consum', 0.0217, 'lps'),
	(358798, 123, '2015-01-15 00:56:06.000000', 'consum', 0.0217, 'lps'),
	(358799, 123, '2015-01-15 00:56:07.000000', 'consum', 0.0214, 'lps'),
	(358800, 123, '2015-01-15 00:56:08.000000', 'consum', 0.0211, 'lps'),
	(358801, 123, '2015-01-15 00:56:09.000000', 'consum', 0.0213, 'lps'),
	(358802, 123, '2015-01-15 00:56:10.000000', 'consum', 0.0210, 'lps'),
	(358803, 123, '2015-01-15 00:56:11.000000', 'consum', 0.0216, 'lps'),
	(358804, 123, '2015-01-15 00:56:12.000000', 'consum', 0.0216, 'lps'),
	(358805, 123, '2015-01-15 00:56:13.000000', 'consum', 0.0220, 'lps'),
	(358806, 123, '2015-01-15 00:56:14.000000', 'consum', 0.0221, 'lps'),
	(358807, 123, '2015-01-15 00:56:15.000000', 'consum', 0.0211, 'lps'),
	(358808, 123, '2015-01-15 00:56:16.000000', 'consum', 0.0220, 'lps'),
	(358809, 123, '2015-01-15 00:56:17.000000', 'consum', 0.0210, 'lps'),
	(358810, 123, '2015-01-15 00:56:18.000000', 'consum', 0.0215, 'lps'),
	(358811, 123, '2015-01-15 00:56:19.000000', 'consum', 0.0210, 'lps'),
	(358812, 123, '2015-01-15 00:56:20.000000', 'consum', 0.0220, 'lps'),
	(358813, 123, '2015-01-15 00:56:21.000000', 'consum', 0.0214, 'lps'),
	(358814, 123, '2015-01-15 00:56:22.000000', 'consum', 0.0210, 'lps'),
	(358815, 123, '2015-01-15 00:56:23.000000', 'consum', 0.0213, 'lps'),
	(358816, 123, '2015-01-15 00:56:24.000000', 'consum', 0.0211, 'lps'),
	(358817, 123, '2015-01-15 00:56:25.000000', 'consum', 0.0219, 'lps'),
	(358818, 123, '2015-01-15 00:56:26.000000', 'consum', 0.0218, 'lps'),
	(358819, 123, '2015-01-15 00:56:27.000000', 'consum', 0.0212, 'lps'),
	(358820, 123, '2015-01-15 00:56:28.000000', 'consum', 0.0220, 'lps'),
	(358821, 123, '2015-01-15 00:56:29.000000', 'consum', 0.0220, 'lps'),
	(358822, 123, '2015-01-15 00:56:30.000000', 'consum', 0.0217, 'lps'),
	(358823, 123, '2015-01-15 00:56:31.000000', 'consum', 0.0217, 'lps'),
	(358824, 123, '2015-01-15 00:56:32.000000', 'consum', 0.0211, 'lps'),
	(358825, 123, '2015-01-15 00:56:33.000000', 'consum', 0.0220, 'lps'),
	(358826, 123, '2015-01-15 00:56:34.000000', 'consum', 0.0219, 'lps'),
	(358827, 123, '2015-01-15 00:56:35.000000', 'consum', 0.0216, 'lps'),
	(358828, 123, '2015-01-15 00:56:36.000000', 'consum', 0.0211, 'lps'),
	(358829, 123, '2015-01-15 00:56:37.000000', 'consum', 0.0210, 'lps'),
	(358830, 123, '2015-01-15 00:56:38.000000', 'consum', 0.0219, 'lps'),
	(358831, 123, '2015-01-15 00:56:39.000000', 'consum', 0.0220, 'lps'),
	(358832, 123, '2015-01-15 00:56:40.000000', 'consum', 0.0219, 'lps'),
	(358833, 123, '2015-01-15 00:56:41.000000', 'consum', 0.0217, 'lps'),
	(358834, 123, '2015-01-15 00:56:42.000000', 'consum', 0.0219, 'lps'),
	(358835, 123, '2015-01-15 00:56:43.000000', 'consum', 0.0210, 'lps'),
	(358836, 123, '2015-01-15 00:56:44.000000', 'consum', 0.0220, 'lps'),
	(358837, 123, '2015-01-15 00:56:45.000000', 'consum', 0.0211, 'lps'),
	(358838, 123, '2015-01-15 00:56:46.000000', 'consum', 0.0210, 'lps'),
	(358839, 123, '2015-01-15 00:56:47.000000', 'consum', 0.0221, 'lps'),
	(358840, 123, '2015-01-15 00:56:48.000000', 'consum', 0.0217, 'lps'),
	(358841, 123, '2015-01-15 00:56:49.000000', 'consum', 0.0212, 'lps'),
	(358842, 123, '2015-01-15 00:56:50.000000', 'consum', 0.0213, 'lps'),
	(358843, 123, '2015-01-15 00:56:51.000000', 'consum', 0.0218, 'lps'),
	(358844, 123, '2015-01-15 00:56:52.000000', 'consum', 0.0220, 'lps'),
	(358845, 123, '2015-01-15 00:56:53.000000', 'consum', 0.0221, 'lps'),
	(358846, 123, '2015-01-15 00:56:54.000000', 'consum', 0.0213, 'lps'),
	(358847, 123, '2015-01-15 00:56:55.000000', 'consum', 0.0217, 'lps'),
	(358848, 123, '2015-01-15 00:56:56.000000', 'consum', 0.0210, 'lps'),
	(358849, 123, '2015-01-15 00:56:57.000000', 'consum', 0.0216, 'lps'),
	(358850, 123, '2015-01-15 00:56:58.000000', 'consum', 0.0215, 'lps'),
	(358851, 123, '2015-01-15 00:56:59.000000', 'consum', 0.0218, 'lps'),
	(358852, 123, '2015-01-15 00:57:00.000000', 'consum', 0.0210, 'lps'),
	(358853, 123, '2015-01-15 00:57:01.000000', 'consum', 0.0213, 'lps'),
	(358854, 123, '2015-01-15 00:57:02.000000', 'consum', 0.0214, 'lps'),
	(358855, 123, '2015-01-15 00:57:03.000000', 'consum', 0.0210, 'lps'),
	(358856, 123, '2015-01-15 00:57:04.000000', 'consum', 0.0220, 'lps'),
	(358857, 123, '2015-01-15 00:57:05.000000', 'consum', 0.0214, 'lps'),
	(358858, 123, '2015-01-15 00:57:06.000000', 'consum', 0.0210, 'lps'),
	(358859, 123, '2015-01-15 00:57:07.000000', 'consum', 0.0212, 'lps'),
	(358860, 123, '2015-01-15 00:57:08.000000', 'consum', 0.0210, 'lps'),
	(358861, 123, '2015-01-15 00:57:09.000000', 'consum', 0.0217, 'lps'),
	(358862, 123, '2015-01-15 00:57:10.000000', 'consum', 0.0220, 'lps'),
	(358863, 123, '2015-01-15 00:57:11.000000', 'consum', 0.0218, 'lps'),
	(358864, 123, '2015-01-15 00:57:12.000000', 'consum', 0.0218, 'lps'),
	(358865, 123, '2015-01-15 00:57:13.000000', 'consum', 0.0215, 'lps'),
	(358866, 123, '2015-01-15 00:57:14.000000', 'consum', 0.0211, 'lps'),
	(358867, 123, '2015-01-15 00:57:15.000000', 'consum', 0.0211, 'lps'),
	(358868, 123, '2015-01-15 00:57:16.000000', 'consum', 0.0213, 'lps'),
	(358869, 123, '2015-01-15 00:57:17.000000', 'consum', 0.0211, 'lps'),
	(358870, 123, '2015-01-15 00:57:18.000000', 'consum', 0.0217, 'lps'),
	(358871, 123, '2015-01-15 00:57:19.000000', 'consum', 0.0221, 'lps'),
	(358872, 123, '2015-01-15 00:57:20.000000', 'consum', 0.0219, 'lps'),
	(358873, 123, '2015-01-15 00:57:21.000000', 'consum', 0.0210, 'lps'),
	(358874, 123, '2015-01-15 00:57:22.000000', 'consum', 0.0221, 'lps'),
	(358875, 123, '2015-01-15 00:57:23.000000', 'consum', 0.0216, 'lps'),
	(358876, 123, '2015-01-15 00:57:24.000000', 'consum', 0.0218, 'lps'),
	(358877, 123, '2015-01-15 00:57:25.000000', 'consum', 0.0212, 'lps'),
	(358878, 123, '2015-01-15 00:57:26.000000', 'consum', 0.0219, 'lps'),
	(358879, 123, '2015-01-15 00:57:27.000000', 'consum', 0.0212, 'lps'),
	(358880, 123, '2015-01-15 00:57:28.000000', 'consum', 0.0219, 'lps'),
	(358881, 123, '2015-01-15 00:57:29.000000', 'consum', 0.0212, 'lps'),
	(358882, 123, '2015-01-15 00:57:30.000000', 'consum', 0.0216, 'lps'),
	(358883, 123, '2015-01-15 00:57:31.000000', 'consum', 0.0213, 'lps'),
	(358884, 123, '2015-01-15 00:57:32.000000', 'consum', 0.0221, 'lps'),
	(358885, 123, '2015-01-15 00:57:33.000000', 'consum', 0.0218, 'lps'),
	(358886, 123, '2015-01-15 00:57:34.000000', 'consum', 0.0219, 'lps'),
	(358887, 123, '2015-01-15 00:57:35.000000', 'consum', 0.0221, 'lps'),
	(358888, 123, '2015-01-15 00:57:36.000000', 'consum', 0.0211, 'lps'),
	(358889, 123, '2015-01-15 00:57:37.000000', 'consum', 0.0221, 'lps'),
	(358890, 123, '2015-01-15 00:57:38.000000', 'consum', 0.0215, 'lps'),
	(358891, 123, '2015-01-15 00:57:39.000000', 'consum', 0.0213, 'lps'),
	(358892, 123, '2015-01-15 00:57:40.000000', 'consum', 0.0211, 'lps'),
	(358893, 123, '2015-01-15 00:57:41.000000', 'consum', 0.0217, 'lps'),
	(358894, 123, '2015-01-15 00:57:42.000000', 'consum', 0.0218, 'lps'),
	(358895, 123, '2015-01-15 00:57:43.000000', 'consum', 0.0221, 'lps'),
	(358896, 123, '2015-01-15 00:57:44.000000', 'consum', 0.0214, 'lps'),
	(358897, 123, '2015-01-15 00:57:45.000000', 'consum', 0.0212, 'lps'),
	(358898, 123, '2015-01-15 00:57:46.000000', 'consum', 0.0219, 'lps'),
	(358899, 123, '2015-01-15 00:57:47.000000', 'consum', 0.0215, 'lps'),
	(358900, 123, '2015-01-15 00:57:48.000000', 'consum', 0.0219, 'lps'),
	(358901, 123, '2015-01-15 00:57:49.000000', 'consum', 0.0216, 'lps'),
	(358902, 123, '2015-01-15 00:57:50.000000', 'consum', 0.0215, 'lps'),
	(358903, 123, '2015-01-15 00:57:51.000000', 'consum', 0.0217, 'lps'),
	(358904, 123, '2015-01-15 00:57:52.000000', 'consum', 0.0219, 'lps'),
	(358905, 123, '2015-01-15 00:57:53.000000', 'consum', 0.0210, 'lps'),
	(358906, 123, '2015-01-15 00:57:54.000000', 'consum', 0.0221, 'lps'),
	(358907, 123, '2015-01-15 00:57:55.000000', 'consum', 0.0218, 'lps'),
	(358908, 123, '2015-01-15 00:57:56.000000', 'consum', 0.0217, 'lps'),
	(358909, 123, '2015-01-15 00:57:57.000000', 'consum', 0.0211, 'lps'),
	(358910, 123, '2015-01-15 00:57:58.000000', 'consum', 0.0218, 'lps'),
	(358911, 123, '2015-01-15 00:57:59.000000', 'consum', 0.0221, 'lps'),
	(358912, 123, '2015-01-15 00:58:00.000000', 'consum', 0.0220, 'lps'),
	(358913, 123, '2015-01-15 00:58:01.000000', 'consum', 0.0214, 'lps'),
	(358914, 123, '2015-01-15 00:58:02.000000', 'consum', 0.0212, 'lps'),
	(358915, 123, '2015-01-15 00:58:03.000000', 'consum', 0.0221, 'lps'),
	(358916, 123, '2015-01-15 00:58:04.000000', 'consum', 0.0212, 'lps'),
	(358917, 123, '2015-01-15 00:58:05.000000', 'consum', 0.0212, 'lps'),
	(358918, 123, '2015-01-15 00:58:06.000000', 'consum', 0.0215, 'lps'),
	(358919, 123, '2015-01-15 00:58:07.000000', 'consum', 0.0217, 'lps'),
	(358920, 123, '2015-01-15 00:58:08.000000', 'consum', 0.0217, 'lps'),
	(358921, 123, '2015-01-15 00:58:09.000000', 'consum', 0.0214, 'lps'),
	(358922, 123, '2015-01-15 00:58:10.000000', 'consum', 0.0220, 'lps'),
	(358923, 123, '2015-01-15 00:58:11.000000', 'consum', 0.0212, 'lps'),
	(358924, 123, '2015-01-15 00:58:12.000000', 'consum', 0.0215, 'lps'),
	(358925, 123, '2015-01-15 00:58:13.000000', 'consum', 0.0218, 'lps'),
	(358926, 123, '2015-01-15 00:58:14.000000', 'consum', 0.0210, 'lps'),
	(358927, 123, '2015-01-15 00:58:15.000000', 'consum', 0.0213, 'lps'),
	(358928, 123, '2015-01-15 00:58:16.000000', 'consum', 0.0210, 'lps'),
	(358929, 123, '2015-01-15 00:58:17.000000', 'consum', 0.0217, 'lps'),
	(358930, 123, '2015-01-15 00:58:18.000000', 'consum', 0.0220, 'lps'),
	(358931, 123, '2015-01-15 00:58:19.000000', 'consum', 0.0216, 'lps'),
	(358932, 123, '2015-01-15 00:58:20.000000', 'consum', 0.0211, 'lps'),
	(358933, 123, '2015-01-15 00:58:21.000000', 'consum', 0.0210, 'lps'),
	(358934, 123, '2015-01-15 00:58:22.000000', 'consum', 0.0218, 'lps'),
	(358935, 123, '2015-01-15 00:58:23.000000', 'consum', 0.0214, 'lps'),
	(358936, 123, '2015-01-15 00:58:24.000000', 'consum', 0.0221, 'lps'),
	(358937, 123, '2015-01-15 00:58:25.000000', 'consum', 0.0215, 'lps'),
	(358938, 123, '2015-01-15 00:58:26.000000', 'consum', 0.0215, 'lps'),
	(358939, 123, '2015-01-15 00:58:27.000000', 'consum', 0.0220, 'lps'),
	(358940, 123, '2015-01-15 00:58:28.000000', 'consum', 0.0211, 'lps'),
	(358941, 123, '2015-01-15 00:58:29.000000', 'consum', 0.0210, 'lps'),
	(358942, 123, '2015-01-15 00:58:30.000000', 'consum', 0.0220, 'lps'),
	(358943, 123, '2015-01-15 00:58:31.000000', 'consum', 0.0213, 'lps'),
	(358944, 123, '2015-01-15 00:58:32.000000', 'consum', 0.0217, 'lps'),
	(358945, 123, '2015-01-15 00:58:33.000000', 'consum', 0.0213, 'lps'),
	(358946, 123, '2015-01-15 00:58:34.000000', 'consum', 0.0215, 'lps'),
	(358947, 123, '2015-01-15 00:58:35.000000', 'consum', 0.0217, 'lps'),
	(358948, 123, '2015-01-15 00:58:36.000000', 'consum', 0.0216, 'lps'),
	(358949, 123, '2015-01-15 00:58:37.000000', 'consum', 0.0219, 'lps'),
	(358950, 123, '2015-01-15 00:58:38.000000', 'consum', 0.0216, 'lps'),
	(358951, 123, '2015-01-15 00:58:39.000000', 'consum', 0.0213, 'lps'),
	(358952, 123, '2015-01-15 00:58:40.000000', 'consum', 0.0217, 'lps'),
	(358953, 123, '2015-01-15 00:58:41.000000', 'consum', 0.0216, 'lps'),
	(358954, 123, '2015-01-15 00:58:42.000000', 'consum', 0.0218, 'lps'),
	(358955, 123, '2015-01-15 00:58:43.000000', 'consum', 0.0220, 'lps'),
	(358956, 123, '2015-01-15 00:58:44.000000', 'consum', 0.0215, 'lps'),
	(358957, 123, '2015-01-15 00:58:45.000000', 'consum', 0.0214, 'lps'),
	(358958, 123, '2015-01-15 00:58:46.000000', 'consum', 0.0217, 'lps'),
	(358959, 123, '2015-01-15 00:58:47.000000', 'consum', 0.0219, 'lps'),
	(358960, 123, '2015-01-15 00:58:48.000000', 'consum', 0.0214, 'lps'),
	(358961, 123, '2015-01-15 00:58:49.000000', 'consum', 0.0215, 'lps'),
	(358962, 123, '2015-01-15 00:58:50.000000', 'consum', 0.0210, 'lps'),
	(358963, 123, '2015-01-15 00:58:51.000000', 'consum', 0.0210, 'lps'),
	(358964, 123, '2015-01-15 00:58:52.000000', 'consum', 0.0210, 'lps'),
	(358965, 123, '2015-01-15 00:58:53.000000', 'consum', 0.0210, 'lps'),
	(358966, 123, '2015-01-15 00:58:54.000000', 'consum', 0.0211, 'lps'),
	(358967, 123, '2015-01-15 00:58:55.000000', 'consum', 0.0213, 'lps'),
	(358968, 123, '2015-01-15 00:58:56.000000', 'consum', 0.0213, 'lps'),
	(358969, 123, '2015-01-15 00:58:57.000000', 'consum', 0.0217, 'lps'),
	(358970, 123, '2015-01-15 00:58:58.000000', 'consum', 0.0213, 'lps'),
	(358971, 123, '2015-01-15 00:58:59.000000', 'consum', 0.0215, 'lps'),
	(358972, 123, '2015-01-15 00:59:00.000000', 'consum', 0.0214, 'lps'),
	(358973, 123, '2015-01-15 00:59:01.000000', 'consum', 0.0217, 'lps'),
	(358974, 123, '2015-01-15 00:59:02.000000', 'consum', 0.0221, 'lps'),
	(358975, 123, '2015-01-15 00:59:03.000000', 'consum', 0.0219, 'lps'),
	(358976, 123, '2015-01-15 00:59:04.000000', 'consum', 0.0213, 'lps'),
	(358977, 123, '2015-01-15 00:59:05.000000', 'consum', 0.0220, 'lps'),
	(358978, 123, '2015-01-15 00:59:06.000000', 'consum', 0.0218, 'lps'),
	(358979, 123, '2015-01-15 00:59:07.000000', 'consum', 0.0220, 'lps'),
	(358980, 123, '2015-01-15 00:59:08.000000', 'consum', 0.0212, 'lps'),
	(358981, 123, '2015-01-15 00:59:09.000000', 'consum', 0.0215, 'lps'),
	(358982, 123, '2015-01-15 00:59:10.000000', 'consum', 0.0216, 'lps'),
	(358983, 123, '2015-01-15 00:59:11.000000', 'consum', 0.0213, 'lps'),
	(358984, 123, '2015-01-15 00:59:12.000000', 'consum', 0.0220, 'lps'),
	(358985, 123, '2015-01-15 00:59:13.000000', 'consum', 0.0217, 'lps'),
	(358986, 123, '2015-01-15 00:59:14.000000', 'consum', 0.0214, 'lps'),
	(358987, 123, '2015-01-15 00:59:15.000000', 'consum', 0.0211, 'lps'),
	(358988, 123, '2015-01-15 00:59:16.000000', 'consum', 0.0215, 'lps'),
	(358989, 123, '2015-01-15 00:59:17.000000', 'consum', 0.0221, 'lps'),
	(358990, 123, '2015-01-15 00:59:18.000000', 'consum', 0.0212, 'lps'),
	(358991, 123, '2015-01-15 00:59:19.000000', 'consum', 0.0215, 'lps'),
	(358992, 123, '2015-01-15 00:59:20.000000', 'consum', 0.0214, 'lps'),
	(358993, 123, '2015-01-15 00:59:21.000000', 'consum', 0.0217, 'lps'),
	(358994, 123, '2015-01-15 00:59:22.000000', 'consum', 0.0221, 'lps'),
	(358995, 123, '2015-01-15 00:59:23.000000', 'consum', 0.0211, 'lps'),
	(358996, 123, '2015-01-15 00:59:24.000000', 'consum', 0.0216, 'lps'),
	(358997, 123, '2015-01-15 00:59:25.000000', 'consum', 0.0214, 'lps'),
	(358998, 123, '2015-01-15 00:59:26.000000', 'consum', 0.0212, 'lps'),
	(358999, 123, '2015-01-15 00:59:27.000000', 'consum', 0.0219, 'lps'),
	(359000, 123, '2015-01-15 00:59:28.000000', 'consum', 0.0216, 'lps'),
	(359001, 123, '2015-01-15 00:59:29.000000', 'consum', 0.0212, 'lps'),
	(359002, 123, '2015-01-15 00:59:30.000000', 'consum', 0.0217, 'lps'),
	(359003, 123, '2015-01-15 00:59:31.000000', 'consum', 0.0213, 'lps'),
	(359004, 123, '2015-01-15 00:59:32.000000', 'consum', 0.0219, 'lps'),
	(359005, 123, '2015-01-15 00:59:33.000000', 'consum', 0.0221, 'lps'),
	(359006, 123, '2015-01-15 00:59:34.000000', 'consum', 0.0217, 'lps'),
	(359007, 123, '2015-01-15 00:59:35.000000', 'consum', 0.0210, 'lps'),
	(359008, 123, '2015-01-15 00:59:36.000000', 'consum', 0.0212, 'lps'),
	(359009, 123, '2015-01-15 00:59:37.000000', 'consum', 0.0210, 'lps'),
	(359010, 123, '2015-01-15 00:59:38.000000', 'consum', 0.0216, 'lps'),
	(359011, 123, '2015-01-15 00:59:39.000000', 'consum', 0.0218, 'lps'),
	(359012, 123, '2015-01-15 00:59:40.000000', 'consum', 0.0220, 'lps'),
	(359013, 123, '2015-01-15 00:59:41.000000', 'consum', 0.0213, 'lps'),
	(359014, 123, '2015-01-15 00:59:42.000000', 'consum', 0.0219, 'lps'),
	(359015, 123, '2015-01-15 00:59:43.000000', 'consum', 0.0210, 'lps'),
	(359016, 123, '2015-01-15 00:59:44.000000', 'consum', 0.0220, 'lps'),
	(359017, 123, '2015-01-15 00:59:45.000000', 'consum', 0.0213, 'lps'),
	(359018, 123, '2015-01-15 00:59:46.000000', 'consum', 0.0220, 'lps'),
	(359019, 123, '2015-01-15 00:59:47.000000', 'consum', 0.0215, 'lps'),
	(359020, 123, '2015-01-15 00:59:48.000000', 'consum', 0.0219, 'lps'),
	(359021, 123, '2015-01-15 00:59:49.000000', 'consum', 0.0215, 'lps'),
	(359022, 123, '2015-01-15 00:59:50.000000', 'consum', 0.0221, 'lps'),
	(359023, 123, '2015-01-15 00:59:51.000000', 'consum', 0.0216, 'lps'),
	(359024, 123, '2015-01-15 00:59:52.000000', 'consum', 0.0220, 'lps'),
	(359025, 123, '2015-01-15 00:59:53.000000', 'consum', 0.0217, 'lps'),
	(359026, 123, '2015-01-15 00:59:54.000000', 'consum', 0.0215, 'lps'),
	(359027, 123, '2015-01-15 00:59:55.000000', 'consum', 0.0213, 'lps'),
	(359028, 123, '2015-01-15 00:59:56.000000', 'consum', 0.0213, 'lps'),
	(359029, 123, '2015-01-15 00:59:57.000000', 'consum', 0.0214, 'lps'),
	(359030, 123, '2015-01-15 00:59:58.000000', 'consum', 0.0210, 'lps'),
	(359031, 123, '2015-01-15 00:59:59.000000', 'consum', 0.0211, 'lps'),
	(359032, 123, '2015-01-15 01:00:00.000000', 'consum', 0.0214, 'lps'),
	(359033, 123, '2015-01-15 01:00:01.000000', 'consum', 0.0215, 'lps'),
	(359034, 123, '2015-01-15 01:00:02.000000', 'consum', 0.0211, 'lps'),
	(359035, 123, '2015-01-15 01:00:03.000000', 'consum', 0.0215, 'lps'),
	(359036, 123, '2015-01-15 01:00:04.000000', 'consum', 0.0219, 'lps'),
	(359037, 123, '2015-01-15 01:00:05.000000', 'consum', 0.0218, 'lps'),
	(359038, 123, '2015-01-15 01:00:06.000000', 'consum', 0.0210, 'lps'),
	(359039, 123, '2015-01-15 01:00:07.000000', 'consum', 0.0212, 'lps'),
	(359040, 123, '2015-01-15 01:00:08.000000', 'consum', 0.0218, 'lps'),
	(359041, 123, '2015-01-15 01:00:09.000000', 'consum', 0.0211, 'lps'),
	(359042, 123, '2015-01-15 01:00:10.000000', 'consum', 0.0213, 'lps'),
	(359043, 123, '2015-01-15 01:00:11.000000', 'consum', 0.0214, 'lps'),
	(359044, 123, '2015-01-15 01:00:12.000000', 'consum', 0.0219, 'lps'),
	(359045, 123, '2015-01-15 01:00:13.000000', 'consum', 0.0220, 'lps'),
	(359046, 123, '2015-01-15 01:00:14.000000', 'consum', 0.0220, 'lps'),
	(359047, 123, '2015-01-15 01:00:15.000000', 'consum', 0.0221, 'lps'),
	(359048, 123, '2015-01-15 01:00:16.000000', 'consum', 0.0212, 'lps'),
	(359049, 123, '2015-01-15 01:00:17.000000', 'consum', 0.0212, 'lps'),
	(359050, 123, '2015-01-15 01:00:18.000000', 'consum', 0.0214, 'lps'),
	(359051, 123, '2015-01-15 01:00:19.000000', 'consum', 0.0211, 'lps'),
	(359052, 123, '2015-01-15 01:00:20.000000', 'consum', 0.0216, 'lps'),
	(359053, 123, '2015-01-15 01:00:21.000000', 'consum', 0.0213, 'lps'),
	(359054, 123, '2015-01-15 01:00:22.000000', 'consum', 0.0219, 'lps'),
	(359055, 123, '2015-01-15 01:00:23.000000', 'consum', 0.0213, 'lps'),
	(359056, 123, '2015-01-15 01:00:24.000000', 'consum', 0.0220, 'lps'),
	(359057, 123, '2015-01-15 01:00:25.000000', 'consum', 0.0215, 'lps'),
	(359058, 123, '2015-01-15 01:00:26.000000', 'consum', 0.0219, 'lps'),
	(359059, 123, '2015-01-15 01:00:27.000000', 'consum', 0.0218, 'lps'),
	(359060, 123, '2015-01-15 01:00:28.000000', 'consum', 0.0210, 'lps'),
	(359061, 123, '2015-01-15 01:00:29.000000', 'consum', 0.0210, 'lps'),
	(359062, 123, '2015-01-15 01:00:30.000000', 'consum', 0.0212, 'lps'),
	(359063, 123, '2015-01-15 01:00:31.000000', 'consum', 0.0219, 'lps'),
	(359064, 123, '2015-01-15 01:00:32.000000', 'consum', 0.0213, 'lps'),
	(359065, 123, '2015-01-15 01:00:33.000000', 'consum', 0.0211, 'lps'),
	(359066, 123, '2015-01-15 01:00:34.000000', 'consum', 0.0221, 'lps'),
	(359067, 123, '2015-01-15 01:00:35.000000', 'consum', 0.0212, 'lps'),
	(359068, 123, '2015-01-15 01:00:36.000000', 'consum', 0.0212, 'lps'),
	(359069, 123, '2015-01-15 01:00:37.000000', 'consum', 0.0214, 'lps'),
	(359070, 123, '2015-01-15 01:00:38.000000', 'consum', 0.0212, 'lps'),
	(359071, 123, '2015-01-15 01:00:39.000000', 'consum', 0.0220, 'lps'),
	(359072, 123, '2015-01-15 01:00:40.000000', 'consum', 0.0218, 'lps'),
	(359073, 123, '2015-01-15 01:00:41.000000', 'consum', 0.0211, 'lps'),
	(359074, 123, '2015-01-15 01:00:42.000000', 'consum', 0.0216, 'lps'),
	(359075, 123, '2015-01-15 01:00:43.000000', 'consum', 0.0212, 'lps'),
	(359076, 123, '2015-01-15 01:00:44.000000', 'consum', 0.0213, 'lps'),
	(359077, 123, '2015-01-15 01:00:45.000000', 'consum', 0.0210, 'lps'),
	(359078, 123, '2015-01-15 01:00:46.000000', 'consum', 0.0212, 'lps'),
	(359079, 123, '2015-01-15 01:00:47.000000', 'consum', 0.0220, 'lps'),
	(359080, 123, '2015-01-15 01:00:48.000000', 'consum', 0.0218, 'lps'),
	(359081, 123, '2015-01-15 01:00:49.000000', 'consum', 0.0210, 'lps'),
	(359082, 123, '2015-01-15 01:00:50.000000', 'consum', 0.0220, 'lps'),
	(359083, 123, '2015-01-15 01:00:51.000000', 'consum', 0.0215, 'lps'),
	(359084, 123, '2015-01-15 01:00:52.000000', 'consum', 0.0217, 'lps'),
	(359085, 123, '2015-01-15 01:00:53.000000', 'consum', 0.0220, 'lps'),
	(359086, 123, '2015-01-15 01:00:54.000000', 'consum', 0.0214, 'lps'),
	(359087, 123, '2015-01-15 01:00:55.000000', 'consum', 0.0211, 'lps'),
	(359088, 123, '2015-01-15 01:00:56.000000', 'consum', 0.0218, 'lps'),
	(359089, 123, '2015-01-15 01:00:57.000000', 'consum', 0.0221, 'lps'),
	(359090, 123, '2015-01-15 01:00:58.000000', 'consum', 0.0219, 'lps'),
	(359091, 123, '2015-01-15 01:00:59.000000', 'consum', 0.0211, 'lps'),
	(359092, 123, '2015-01-15 01:01:00.000000', 'consum', 0.0213, 'lps'),
	(359093, 123, '2015-01-15 01:01:01.000000', 'consum', 0.0220, 'lps'),
	(359094, 123, '2015-01-15 01:01:02.000000', 'consum', 0.0216, 'lps'),
	(359095, 123, '2015-01-15 01:01:03.000000', 'consum', 0.0212, 'lps'),
	(359096, 123, '2015-01-15 01:01:04.000000', 'consum', 0.0215, 'lps'),
	(359097, 123, '2015-01-15 01:01:05.000000', 'consum', 0.0218, 'lps'),
	(359098, 123, '2015-01-15 01:01:06.000000', 'consum', 0.0213, 'lps'),
	(359099, 123, '2015-01-15 01:01:07.000000', 'consum', 0.0210, 'lps'),
	(359100, 123, '2015-01-15 01:01:08.000000', 'consum', 0.0215, 'lps'),
	(359101, 123, '2015-01-15 01:01:09.000000', 'consum', 0.0213, 'lps'),
	(359102, 123, '2015-01-15 01:01:10.000000', 'consum', 0.0221, 'lps'),
	(359103, 123, '2015-01-15 01:01:11.000000', 'consum', 0.0219, 'lps'),
	(359104, 123, '2015-01-15 01:01:12.000000', 'consum', 0.0212, 'lps'),
	(359105, 123, '2015-01-15 01:01:13.000000', 'consum', 0.0217, 'lps'),
	(359106, 123, '2015-01-15 01:01:14.000000', 'consum', 0.0216, 'lps'),
	(359107, 123, '2015-01-15 01:01:15.000000', 'consum', 0.0219, 'lps'),
	(359108, 123, '2015-01-15 01:01:16.000000', 'consum', 0.0214, 'lps'),
	(359109, 123, '2015-01-15 01:01:17.000000', 'consum', 0.0215, 'lps'),
	(359110, 123, '2015-01-15 01:01:18.000000', 'consum', 0.0214, 'lps'),
	(359111, 123, '2015-01-15 01:01:19.000000', 'consum', 0.0212, 'lps'),
	(359112, 123, '2015-01-15 01:01:20.000000', 'consum', 0.0212, 'lps'),
	(359113, 123, '2015-01-15 01:01:21.000000', 'consum', 0.0212, 'lps'),
	(359114, 123, '2015-01-15 01:01:22.000000', 'consum', 0.0213, 'lps'),
	(359115, 123, '2015-01-15 01:01:23.000000', 'consum', 0.0221, 'lps'),
	(359116, 123, '2015-01-15 01:01:24.000000', 'consum', 0.0211, 'lps'),
	(359117, 123, '2015-01-15 01:01:25.000000', 'consum', 0.0215, 'lps'),
	(359118, 123, '2015-01-15 01:01:26.000000', 'consum', 0.0211, 'lps'),
	(359119, 123, '2015-01-15 01:01:27.000000', 'consum', 0.0212, 'lps'),
	(359120, 123, '2015-01-15 01:01:28.000000', 'consum', 0.0217, 'lps'),
	(359121, 123, '2015-01-15 01:01:29.000000', 'consum', 0.0217, 'lps'),
	(359122, 123, '2015-01-15 01:01:30.000000', 'consum', 0.0212, 'lps'),
	(359123, 123, '2015-01-15 01:01:31.000000', 'consum', 0.0213, 'lps'),
	(359124, 123, '2015-01-15 01:01:32.000000', 'consum', 0.0216, 'lps'),
	(359125, 123, '2015-01-15 01:01:33.000000', 'consum', 0.0211, 'lps'),
	(359126, 123, '2015-01-15 01:01:34.000000', 'consum', 0.0219, 'lps'),
	(359127, 123, '2015-01-15 01:01:35.000000', 'consum', 0.0216, 'lps'),
	(359128, 123, '2015-01-15 01:01:36.000000', 'consum', 0.0216, 'lps'),
	(359129, 123, '2015-01-15 01:01:37.000000', 'consum', 0.0211, 'lps'),
	(359130, 123, '2015-01-15 01:01:38.000000', 'consum', 0.0219, 'lps'),
	(359131, 123, '2015-01-15 01:01:39.000000', 'consum', 0.0218, 'lps'),
	(359132, 123, '2015-01-15 01:01:40.000000', 'consum', 0.0210, 'lps'),
	(359133, 123, '2015-01-15 01:01:41.000000', 'consum', 0.0213, 'lps'),
	(359134, 123, '2015-01-15 01:01:42.000000', 'consum', 0.0212, 'lps'),
	(359135, 123, '2015-01-15 01:01:43.000000', 'consum', 0.0212, 'lps'),
	(359136, 123, '2015-01-15 01:01:44.000000', 'consum', 0.0215, 'lps'),
	(359137, 123, '2015-01-15 01:01:45.000000', 'consum', 0.0216, 'lps'),
	(359138, 123, '2015-01-15 01:01:46.000000', 'consum', 0.0213, 'lps'),
	(359139, 123, '2015-01-15 01:01:47.000000', 'consum', 0.0210, 'lps'),
	(359140, 123, '2015-01-15 01:01:48.000000', 'consum', 0.0211, 'lps'),
	(359141, 123, '2015-01-15 01:01:49.000000', 'consum', 0.0215, 'lps'),
	(359142, 123, '2015-01-15 01:01:50.000000', 'consum', 0.0210, 'lps'),
	(359143, 123, '2015-01-15 01:01:51.000000', 'consum', 0.0218, 'lps'),
	(359144, 123, '2015-01-15 01:01:52.000000', 'consum', 0.0213, 'lps'),
	(359145, 123, '2015-01-15 01:01:53.000000', 'consum', 0.0217, 'lps'),
	(359146, 123, '2015-01-15 01:01:54.000000', 'consum', 0.0212, 'lps'),
	(359147, 123, '2015-01-15 01:01:55.000000', 'consum', 0.0212, 'lps'),
	(359148, 123, '2015-01-15 01:01:56.000000', 'consum', 0.0214, 'lps'),
	(359149, 123, '2015-01-15 01:01:57.000000', 'consum', 0.0213, 'lps'),
	(359150, 123, '2015-01-15 01:01:58.000000', 'consum', 0.0215, 'lps'),
	(359151, 123, '2015-01-15 01:01:59.000000', 'consum', 0.0211, 'lps'),
	(359152, 123, '2015-01-15 01:02:00.000000', 'consum', 0.0214, 'lps'),
	(359153, 123, '2015-01-15 01:02:01.000000', 'consum', 0.0216, 'lps'),
	(359154, 123, '2015-01-15 01:02:02.000000', 'consum', 0.0217, 'lps'),
	(359155, 123, '2015-01-15 01:02:03.000000', 'consum', 0.0214, 'lps'),
	(359156, 123, '2015-01-15 01:02:04.000000', 'consum', 0.0212, 'lps'),
	(359157, 123, '2015-01-15 01:02:05.000000', 'consum', 0.0220, 'lps'),
	(359158, 123, '2015-01-15 01:02:06.000000', 'consum', 0.0218, 'lps'),
	(359159, 123, '2015-01-15 01:02:07.000000', 'consum', 0.0210, 'lps'),
	(359160, 123, '2015-01-15 01:02:08.000000', 'consum', 0.0220, 'lps'),
	(359161, 123, '2015-01-15 01:02:09.000000', 'consum', 0.0215, 'lps'),
	(359162, 123, '2015-01-15 01:02:10.000000', 'consum', 0.0214, 'lps'),
	(359163, 123, '2015-01-15 01:02:11.000000', 'consum', 0.0219, 'lps'),
	(359164, 123, '2015-01-15 01:02:12.000000', 'consum', 0.0219, 'lps'),
	(359165, 123, '2015-01-15 01:02:13.000000', 'consum', 0.0216, 'lps'),
	(359166, 123, '2015-01-15 01:02:14.000000', 'consum', 0.0215, 'lps'),
	(359167, 123, '2015-01-15 01:02:15.000000', 'consum', 0.0215, 'lps'),
	(359168, 123, '2015-01-15 01:02:16.000000', 'consum', 0.0219, 'lps'),
	(359169, 123, '2015-01-15 01:02:17.000000', 'consum', 0.0220, 'lps'),
	(359170, 123, '2015-01-15 01:02:18.000000', 'consum', 0.0221, 'lps'),
	(359171, 123, '2015-01-15 01:02:19.000000', 'consum', 0.0221, 'lps'),
	(359172, 123, '2015-01-15 01:02:20.000000', 'consum', 0.0210, 'lps'),
	(359173, 123, '2015-01-15 01:02:21.000000', 'consum', 0.0215, 'lps'),
	(359174, 123, '2015-01-15 01:02:22.000000', 'consum', 0.0220, 'lps'),
	(359175, 123, '2015-01-15 01:02:23.000000', 'consum', 0.0213, 'lps'),
	(359176, 123, '2015-01-15 01:02:24.000000', 'consum', 0.0218, 'lps'),
	(359177, 123, '2015-01-15 01:02:25.000000', 'consum', 0.0218, 'lps'),
	(359178, 123, '2015-01-15 01:02:26.000000', 'consum', 0.0213, 'lps'),
	(359179, 123, '2015-01-15 01:02:27.000000', 'consum', 0.0213, 'lps'),
	(359180, 123, '2015-01-15 01:02:28.000000', 'consum', 0.0219, 'lps'),
	(359181, 123, '2015-01-15 01:02:29.000000', 'consum', 0.0211, 'lps'),
	(359182, 123, '2015-01-15 01:02:30.000000', 'consum', 0.0211, 'lps'),
	(359183, 123, '2015-01-15 01:02:31.000000', 'consum', 0.0215, 'lps'),
	(359184, 123, '2015-01-15 01:02:32.000000', 'consum', 0.0218, 'lps'),
	(359185, 123, '2015-01-15 01:02:33.000000', 'consum', 0.0213, 'lps'),
	(359186, 123, '2015-01-15 01:02:34.000000', 'consum', 0.0215, 'lps'),
	(359187, 123, '2015-01-15 01:02:35.000000', 'consum', 0.0213, 'lps'),
	(359188, 123, '2015-01-15 01:02:36.000000', 'consum', 0.0210, 'lps'),
	(359189, 123, '2015-01-15 01:02:37.000000', 'consum', 0.0214, 'lps'),
	(359190, 123, '2015-01-15 01:02:38.000000', 'consum', 0.0220, 'lps'),
	(359191, 123, '2015-01-15 01:02:39.000000', 'consum', 0.0212, 'lps'),
	(359192, 123, '2015-01-15 01:02:40.000000', 'consum', 0.0214, 'lps'),
	(359193, 123, '2015-01-15 01:02:41.000000', 'consum', 0.0211, 'lps'),
	(359194, 123, '2015-01-15 01:02:42.000000', 'consum', 0.0215, 'lps'),
	(359195, 123, '2015-01-15 01:02:43.000000', 'consum', 0.0211, 'lps'),
	(359196, 123, '2015-01-15 01:02:44.000000', 'consum', 0.0211, 'lps'),
	(359197, 123, '2015-01-15 01:02:45.000000', 'consum', 0.0212, 'lps'),
	(359198, 123, '2015-01-15 01:02:46.000000', 'consum', 0.0218, 'lps'),
	(359199, 123, '2015-01-15 01:02:47.000000', 'consum', 0.0220, 'lps'),
	(359200, 123, '2015-01-15 01:02:48.000000', 'consum', 0.0214, 'lps'),
	(359201, 123, '2015-01-15 01:02:49.000000', 'consum', 0.0214, 'lps'),
	(359202, 123, '2015-01-15 01:02:50.000000', 'consum', 0.0216, 'lps'),
	(359203, 123, '2015-01-15 01:02:51.000000', 'consum', 0.0217, 'lps'),
	(359204, 123, '2015-01-15 01:02:52.000000', 'consum', 0.0215, 'lps'),
	(359205, 123, '2015-01-15 01:02:53.000000', 'consum', 0.0216, 'lps'),
	(359206, 123, '2015-01-15 01:02:54.000000', 'consum', 0.0215, 'lps'),
	(359207, 123, '2015-01-15 01:02:55.000000', 'consum', 0.0215, 'lps'),
	(359208, 123, '2015-01-15 01:02:56.000000', 'consum', 0.0219, 'lps'),
	(359209, 123, '2015-01-15 01:02:57.000000', 'consum', 0.0219, 'lps'),
	(359210, 123, '2015-01-15 01:02:58.000000', 'consum', 0.0214, 'lps'),
	(359211, 123, '2015-01-15 01:02:59.000000', 'consum', 0.0219, 'lps'),
	(359212, 123, '2015-01-15 01:03:00.000000', 'consum', 0.0217, 'lps'),
	(359213, 123, '2015-01-15 01:03:01.000000', 'consum', 0.0219, 'lps'),
	(359214, 123, '2015-01-15 01:03:02.000000', 'consum', 0.0212, 'lps'),
	(359215, 123, '2015-01-15 01:03:03.000000', 'consum', 0.0217, 'lps'),
	(359216, 123, '2015-01-15 01:03:04.000000', 'consum', 0.0216, 'lps'),
	(359217, 123, '2015-01-15 01:03:05.000000', 'consum', 0.0217, 'lps'),
	(359218, 123, '2015-01-15 01:03:06.000000', 'consum', 0.0218, 'lps'),
	(359219, 123, '2015-01-15 01:03:07.000000', 'consum', 0.0219, 'lps'),
	(359220, 123, '2015-01-15 01:03:08.000000', 'consum', 0.0216, 'lps'),
	(359221, 123, '2015-01-15 01:03:09.000000', 'consum', 0.0215, 'lps'),
	(359222, 123, '2015-01-15 01:03:10.000000', 'consum', 0.0219, 'lps'),
	(359223, 123, '2015-01-15 01:03:11.000000', 'consum', 0.0214, 'lps'),
	(359224, 123, '2015-01-15 01:03:12.000000', 'consum', 0.0216, 'lps'),
	(359225, 123, '2015-01-15 01:03:13.000000', 'consum', 0.0217, 'lps'),
	(359226, 123, '2015-01-15 01:03:14.000000', 'consum', 0.0216, 'lps'),
	(359227, 123, '2015-01-15 01:03:15.000000', 'consum', 0.0220, 'lps'),
	(359228, 123, '2015-01-15 01:03:16.000000', 'consum', 0.0217, 'lps'),
	(359229, 123, '2015-01-15 01:03:17.000000', 'consum', 0.0215, 'lps'),
	(359230, 123, '2015-01-15 01:03:18.000000', 'consum', 0.0215, 'lps'),
	(359231, 123, '2015-01-15 01:03:19.000000', 'consum', 0.0220, 'lps'),
	(359232, 123, '2015-01-15 01:03:20.000000', 'consum', 0.0210, 'lps'),
	(359233, 123, '2015-01-15 01:03:21.000000', 'consum', 0.0215, 'lps'),
	(359234, 123, '2015-01-15 01:03:22.000000', 'consum', 0.0213, 'lps'),
	(359235, 123, '2015-01-15 01:03:23.000000', 'consum', 0.0221, 'lps'),
	(359236, 123, '2015-01-15 01:03:24.000000', 'consum', 0.0221, 'lps'),
	(359237, 123, '2015-01-15 01:03:25.000000', 'consum', 0.0210, 'lps'),
	(359238, 123, '2015-01-15 01:03:26.000000', 'consum', 0.0214, 'lps'),
	(359239, 123, '2015-01-15 01:03:27.000000', 'consum', 0.0218, 'lps'),
	(359240, 123, '2015-01-15 01:03:28.000000', 'consum', 0.0215, 'lps'),
	(359241, 123, '2015-01-15 01:03:29.000000', 'consum', 0.0212, 'lps'),
	(359242, 123, '2015-01-15 01:03:30.000000', 'consum', 0.0218, 'lps'),
	(359243, 123, '2015-01-15 01:03:31.000000', 'consum', 0.0221, 'lps'),
	(359244, 123, '2015-01-15 01:03:32.000000', 'consum', 0.0215, 'lps'),
	(359245, 123, '2015-01-15 01:03:33.000000', 'consum', 0.0216, 'lps'),
	(359246, 123, '2015-01-15 01:03:34.000000', 'consum', 0.0214, 'lps'),
	(359247, 123, '2015-01-15 01:03:35.000000', 'consum', 0.0212, 'lps'),
	(359248, 123, '2015-01-15 01:03:36.000000', 'consum', 0.0220, 'lps'),
	(359249, 123, '2015-01-15 01:03:37.000000', 'consum', 0.0217, 'lps'),
	(359250, 123, '2015-01-15 01:03:38.000000', 'consum', 0.0216, 'lps'),
	(359251, 123, '2015-01-15 01:03:39.000000', 'consum', 0.0220, 'lps'),
	(359252, 123, '2015-01-15 01:03:40.000000', 'consum', 0.0219, 'lps'),
	(359253, 123, '2015-01-15 01:03:41.000000', 'consum', 0.0214, 'lps'),
	(359254, 123, '2015-01-15 01:03:42.000000', 'consum', 0.0214, 'lps'),
	(359255, 123, '2015-01-15 01:03:43.000000', 'consum', 0.0221, 'lps'),
	(359256, 123, '2015-01-15 01:03:44.000000', 'consum', 0.0216, 'lps'),
	(359257, 123, '2015-01-15 01:03:45.000000', 'consum', 0.0218, 'lps'),
	(359258, 123, '2015-01-15 01:03:46.000000', 'consum', 0.0221, 'lps'),
	(359259, 123, '2015-01-15 01:03:47.000000', 'consum', 0.0218, 'lps'),
	(359260, 123, '2015-01-15 01:03:48.000000', 'consum', 0.0216, 'lps'),
	(359261, 123, '2015-01-15 01:03:49.000000', 'consum', 0.0215, 'lps'),
	(359262, 123, '2015-01-15 01:03:50.000000', 'consum', 0.0221, 'lps'),
	(359263, 123, '2015-01-15 01:03:51.000000', 'consum', 0.0213, 'lps'),
	(359264, 123, '2015-01-15 01:03:52.000000', 'consum', 0.0217, 'lps'),
	(359265, 123, '2015-01-15 01:03:53.000000', 'consum', 0.0212, 'lps'),
	(359266, 123, '2015-01-15 01:03:54.000000', 'consum', 0.0211, 'lps'),
	(359267, 123, '2015-01-15 01:03:55.000000', 'consum', 0.0221, 'lps'),
	(359268, 123, '2015-01-15 01:03:56.000000', 'consum', 0.0213, 'lps'),
	(359269, 123, '2015-01-15 01:03:57.000000', 'consum', 0.0220, 'lps'),
	(359270, 123, '2015-01-15 01:03:58.000000', 'consum', 0.0212, 'lps'),
	(359271, 123, '2015-01-15 01:03:59.000000', 'consum', 0.0217, 'lps'),
	(359272, 123, '2015-01-15 01:04:00.000000', 'consum', 0.0216, 'lps'),
	(359273, 123, '2015-01-15 01:04:01.000000', 'consum', 0.0219, 'lps'),
	(359274, 123, '2015-01-15 01:04:02.000000', 'consum', 0.0215, 'lps'),
	(359275, 123, '2015-01-15 01:04:03.000000', 'consum', 0.0217, 'lps'),
	(359276, 123, '2015-01-15 01:04:04.000000', 'consum', 0.0210, 'lps'),
	(359277, 123, '2015-01-15 01:04:05.000000', 'consum', 0.0210, 'lps'),
	(359278, 123, '2015-01-15 01:04:06.000000', 'consum', 0.0213, 'lps'),
	(359279, 123, '2015-01-15 01:04:07.000000', 'consum', 0.0215, 'lps'),
	(359280, 123, '2015-01-15 01:04:08.000000', 'consum', 0.0211, 'lps'),
	(359281, 123, '2015-01-15 01:04:09.000000', 'consum', 0.0214, 'lps'),
	(359282, 123, '2015-01-15 01:04:10.000000', 'consum', 0.0217, 'lps'),
	(359283, 123, '2015-01-15 01:04:11.000000', 'consum', 0.0219, 'lps'),
	(359284, 123, '2015-01-15 01:04:12.000000', 'consum', 0.0212, 'lps'),
	(359285, 123, '2015-01-15 01:04:13.000000', 'consum', 0.0218, 'lps'),
	(359286, 123, '2015-01-15 01:04:14.000000', 'consum', 0.0219, 'lps'),
	(359287, 123, '2015-01-15 01:04:15.000000', 'consum', 0.0218, 'lps'),
	(359288, 123, '2015-01-15 01:04:16.000000', 'consum', 0.0214, 'lps'),
	(359289, 123, '2015-01-15 01:04:17.000000', 'consum', 0.0216, 'lps'),
	(359290, 123, '2015-01-15 01:04:18.000000', 'consum', 0.0218, 'lps'),
	(359291, 123, '2015-01-15 01:04:19.000000', 'consum', 0.0220, 'lps'),
	(359292, 123, '2015-01-15 01:04:20.000000', 'consum', 0.0212, 'lps'),
	(359293, 123, '2015-01-15 01:04:21.000000', 'consum', 0.0217, 'lps'),
	(359294, 123, '2015-01-15 01:04:22.000000', 'consum', 0.0213, 'lps'),
	(359295, 123, '2015-01-15 01:04:23.000000', 'consum', 0.0218, 'lps'),
	(359296, 123, '2015-01-15 01:04:24.000000', 'consum', 0.0219, 'lps'),
	(359297, 123, '2015-01-15 01:04:25.000000', 'consum', 0.0216, 'lps'),
	(359298, 123, '2015-01-15 01:04:26.000000', 'consum', 0.0216, 'lps'),
	(359299, 123, '2015-01-15 01:04:27.000000', 'consum', 0.0221, 'lps'),
	(359300, 123, '2015-01-15 01:04:28.000000', 'consum', 0.0212, 'lps'),
	(359301, 123, '2015-01-15 01:04:29.000000', 'consum', 0.0212, 'lps'),
	(359302, 123, '2015-01-15 01:04:30.000000', 'consum', 0.0215, 'lps'),
	(359303, 123, '2015-01-15 01:04:31.000000', 'consum', 0.0216, 'lps'),
	(359304, 123, '2015-01-15 01:04:32.000000', 'consum', 0.0216, 'lps'),
	(359305, 123, '2015-01-15 01:04:33.000000', 'consum', 0.0210, 'lps'),
	(359306, 123, '2015-01-15 01:04:34.000000', 'consum', 0.0214, 'lps'),
	(359307, 123, '2015-01-15 01:04:35.000000', 'consum', 0.0210, 'lps'),
	(359308, 123, '2015-01-15 01:04:36.000000', 'consum', 0.0220, 'lps'),
	(359309, 123, '2015-01-15 01:04:37.000000', 'consum', 0.0214, 'lps'),
	(359310, 123, '2015-01-15 01:04:38.000000', 'consum', 0.0212, 'lps'),
	(359311, 123, '2015-01-15 01:04:39.000000', 'consum', 0.0219, 'lps'),
	(359312, 123, '2015-01-15 01:04:40.000000', 'consum', 0.0216, 'lps'),
	(359313, 123, '2015-01-15 01:04:41.000000', 'consum', 0.0214, 'lps'),
	(359314, 123, '2015-01-15 01:04:42.000000', 'consum', 0.0221, 'lps'),
	(359315, 123, '2015-01-15 01:04:43.000000', 'consum', 0.0221, 'lps'),
	(359316, 123, '2015-01-15 01:04:44.000000', 'consum', 0.0219, 'lps'),
	(359317, 123, '2015-01-15 01:04:45.000000', 'consum', 0.0211, 'lps'),
	(359318, 123, '2015-01-15 01:04:46.000000', 'consum', 0.0214, 'lps'),
	(359319, 123, '2015-01-15 01:04:47.000000', 'consum', 0.0213, 'lps'),
	(359320, 123, '2015-01-15 01:04:48.000000', 'consum', 0.0213, 'lps'),
	(359321, 123, '2015-01-15 01:04:49.000000', 'consum', 0.0216, 'lps'),
	(359322, 123, '2015-01-15 01:04:50.000000', 'consum', 0.0220, 'lps'),
	(359323, 123, '2015-01-15 01:04:51.000000', 'consum', 0.0218, 'lps'),
	(359324, 123, '2015-01-15 01:04:52.000000', 'consum', 0.0220, 'lps'),
	(359325, 123, '2015-01-15 01:04:53.000000', 'consum', 0.0212, 'lps'),
	(359326, 123, '2015-01-15 01:04:54.000000', 'consum', 0.0217, 'lps'),
	(359327, 123, '2015-01-15 01:04:55.000000', 'consum', 0.0213, 'lps'),
	(359328, 123, '2015-01-15 01:04:56.000000', 'consum', 0.0217, 'lps'),
	(359329, 123, '2015-01-15 01:04:57.000000', 'consum', 0.0213, 'lps'),
	(359330, 123, '2015-01-15 01:04:58.000000', 'consum', 0.0219, 'lps'),
	(359331, 123, '2015-01-15 01:04:59.000000', 'consum', 0.0219, 'lps'),
	(359332, 123, '2015-01-15 01:05:00.000000', 'consum', 0.0216, 'lps'),
	(359333, 123, '2015-01-15 01:05:01.000000', 'consum', 0.0213, 'lps'),
	(359334, 123, '2015-01-15 01:05:02.000000', 'consum', 0.0220, 'lps'),
	(359335, 123, '2015-01-15 01:05:03.000000', 'consum', 0.0218, 'lps'),
	(359336, 123, '2015-01-15 01:05:04.000000', 'consum', 0.0218, 'lps'),
	(359337, 123, '2015-01-15 01:05:05.000000', 'consum', 0.0213, 'lps'),
	(359338, 123, '2015-01-15 01:05:06.000000', 'consum', 0.0216, 'lps'),
	(359339, 123, '2015-01-15 01:05:07.000000', 'consum', 0.0221, 'lps'),
	(359340, 123, '2015-01-15 01:05:08.000000', 'consum', 0.0210, 'lps'),
	(359341, 123, '2015-01-15 01:05:09.000000', 'consum', 0.0212, 'lps'),
	(359342, 123, '2015-01-15 01:05:10.000000', 'consum', 0.0221, 'lps'),
	(359343, 123, '2015-01-15 01:05:11.000000', 'consum', 0.0210, 'lps'),
	(359344, 123, '2015-01-15 01:05:12.000000', 'consum', 0.0216, 'lps'),
	(359345, 123, '2015-01-15 01:05:13.000000', 'consum', 0.0218, 'lps'),
	(359346, 123, '2015-01-15 01:05:14.000000', 'consum', 0.0218, 'lps'),
	(359347, 123, '2015-01-15 01:05:15.000000', 'consum', 0.0213, 'lps'),
	(359348, 123, '2015-01-15 01:05:16.000000', 'consum', 0.0216, 'lps'),
	(359349, 123, '2015-01-15 01:05:17.000000', 'consum', 0.0217, 'lps'),
	(359350, 123, '2015-01-15 01:05:18.000000', 'consum', 0.0216, 'lps'),
	(359351, 123, '2015-01-15 01:05:19.000000', 'consum', 0.0221, 'lps'),
	(359352, 123, '2015-01-15 01:05:20.000000', 'consum', 0.0212, 'lps'),
	(359353, 123, '2015-01-15 01:05:21.000000', 'consum', 0.0212, 'lps'),
	(359354, 123, '2015-01-15 01:05:22.000000', 'consum', 0.0212, 'lps'),
	(359355, 123, '2015-01-15 01:05:23.000000', 'consum', 0.0218, 'lps'),
	(359356, 123, '2015-01-15 01:05:24.000000', 'consum', 0.0217, 'lps'),
	(359357, 123, '2015-01-15 01:05:25.000000', 'consum', 0.0210, 'lps'),
	(359358, 123, '2015-01-15 01:05:26.000000', 'consum', 0.0212, 'lps'),
	(359359, 123, '2015-01-15 01:05:27.000000', 'consum', 0.0210, 'lps'),
	(359360, 123, '2015-01-15 01:05:28.000000', 'consum', 0.0216, 'lps'),
	(359361, 123, '2015-01-15 01:05:29.000000', 'consum', 0.0219, 'lps'),
	(359362, 123, '2015-01-15 01:05:30.000000', 'consum', 0.0211, 'lps'),
	(359363, 123, '2015-01-15 01:05:31.000000', 'consum', 0.0214, 'lps'),
	(359364, 123, '2015-01-15 01:05:32.000000', 'consum', 0.0217, 'lps'),
	(359365, 123, '2015-01-15 01:05:33.000000', 'consum', 0.0220, 'lps'),
	(359366, 123, '2015-01-15 01:05:34.000000', 'consum', 0.0216, 'lps'),
	(359367, 123, '2015-01-15 01:05:35.000000', 'consum', 0.0211, 'lps'),
	(359368, 123, '2015-01-15 01:05:36.000000', 'consum', 0.0210, 'lps'),
	(359369, 123, '2015-01-15 01:05:37.000000', 'consum', 0.0220, 'lps'),
	(359370, 123, '2015-01-15 01:05:38.000000', 'consum', 0.0211, 'lps'),
	(359371, 123, '2015-01-15 01:05:39.000000', 'consum', 0.0212, 'lps'),
	(359372, 123, '2015-01-15 01:05:40.000000', 'consum', 0.0216, 'lps'),
	(359373, 123, '2015-01-15 01:05:41.000000', 'consum', 0.0221, 'lps'),
	(359374, 123, '2015-01-15 01:05:42.000000', 'consum', 0.0213, 'lps'),
	(359375, 123, '2015-01-15 01:05:43.000000', 'consum', 0.0214, 'lps'),
	(359376, 123, '2015-01-15 01:05:44.000000', 'consum', 0.0212, 'lps'),
	(359377, 123, '2015-01-15 01:05:45.000000', 'consum', 0.0221, 'lps'),
	(359378, 123, '2015-01-15 01:05:46.000000', 'consum', 0.0210, 'lps'),
	(359379, 123, '2015-01-15 01:05:47.000000', 'consum', 0.0216, 'lps'),
	(359380, 123, '2015-01-15 01:05:48.000000', 'consum', 0.0215, 'lps'),
	(359381, 123, '2015-01-15 01:05:49.000000', 'consum', 0.0216, 'lps'),
	(359382, 123, '2015-01-15 01:05:50.000000', 'consum', 0.0216, 'lps'),
	(359383, 123, '2015-01-15 01:05:51.000000', 'consum', 0.0210, 'lps'),
	(359384, 123, '2015-01-15 01:05:52.000000', 'consum', 0.0217, 'lps'),
	(359385, 123, '2015-01-15 01:05:53.000000', 'consum', 0.0220, 'lps'),
	(359386, 123, '2015-01-15 01:05:54.000000', 'consum', 0.0216, 'lps'),
	(359387, 123, '2015-01-15 01:05:55.000000', 'consum', 0.0210, 'lps'),
	(359388, 123, '2015-01-15 01:05:56.000000', 'consum', 0.0217, 'lps'),
	(359389, 123, '2015-01-15 01:05:57.000000', 'consum', 0.0220, 'lps'),
	(359390, 123, '2015-01-15 01:05:58.000000', 'consum', 0.0218, 'lps'),
	(359391, 123, '2015-01-15 01:05:59.000000', 'consum', 0.0218, 'lps'),
	(359392, 123, '2015-01-15 01:06:00.000000', 'consum', 0.0215, 'lps'),
	(359393, 123, '2015-01-15 01:06:01.000000', 'consum', 0.0211, 'lps'),
	(359394, 123, '2015-01-15 01:06:02.000000', 'consum', 0.0214, 'lps'),
	(359395, 123, '2015-01-15 01:06:03.000000', 'consum', 0.0214, 'lps'),
	(359396, 123, '2015-01-15 01:06:04.000000', 'consum', 0.0220, 'lps'),
	(359397, 123, '2015-01-15 01:06:05.000000', 'consum', 0.0211, 'lps'),
	(359398, 123, '2015-01-15 01:06:06.000000', 'consum', 0.0221, 'lps'),
	(359399, 123, '2015-01-15 01:06:07.000000', 'consum', 0.0216, 'lps'),
	(359400, 123, '2015-01-15 01:06:08.000000', 'consum', 0.0221, 'lps'),
	(359401, 123, '2015-01-15 01:06:09.000000', 'consum', 0.0210, 'lps'),
	(359402, 123, '2015-01-15 01:06:10.000000', 'consum', 0.0213, 'lps'),
	(359403, 123, '2015-01-15 01:06:11.000000', 'consum', 0.0214, 'lps'),
	(359404, 123, '2015-01-15 01:06:12.000000', 'consum', 0.0221, 'lps'),
	(359405, 123, '2015-01-15 01:06:13.000000', 'consum', 0.0218, 'lps'),
	(359406, 123, '2015-01-15 01:06:14.000000', 'consum', 0.0215, 'lps'),
	(359407, 123, '2015-01-15 01:06:15.000000', 'consum', 0.0215, 'lps'),
	(359408, 123, '2015-01-15 01:06:16.000000', 'consum', 0.0217, 'lps'),
	(359409, 123, '2015-01-15 01:06:17.000000', 'consum', 0.0210, 'lps'),
	(359410, 123, '2015-01-15 01:06:18.000000', 'consum', 0.0211, 'lps'),
	(359411, 123, '2015-01-15 01:06:19.000000', 'consum', 0.0218, 'lps'),
	(359412, 123, '2015-01-15 01:06:20.000000', 'consum', 0.0212, 'lps'),
	(359413, 123, '2015-01-15 01:06:21.000000', 'consum', 0.0219, 'lps'),
	(359414, 123, '2015-01-15 01:06:22.000000', 'consum', 0.0213, 'lps'),
	(359415, 123, '2015-01-15 01:06:23.000000', 'consum', 0.0213, 'lps'),
	(359416, 123, '2015-01-15 01:06:24.000000', 'consum', 0.0214, 'lps'),
	(359417, 123, '2015-01-15 01:06:25.000000', 'consum', 0.0212, 'lps'),
	(359418, 123, '2015-01-15 01:06:26.000000', 'consum', 0.0221, 'lps'),
	(359419, 123, '2015-01-15 01:06:27.000000', 'consum', 0.0221, 'lps'),
	(359420, 123, '2015-01-15 01:06:28.000000', 'consum', 0.0211, 'lps'),
	(359421, 123, '2015-01-15 01:06:29.000000', 'consum', 0.0219, 'lps'),
	(359422, 123, '2015-01-15 01:06:30.000000', 'consum', 0.0215, 'lps'),
	(359423, 123, '2015-01-15 01:06:31.000000', 'consum', 0.0221, 'lps'),
	(359424, 123, '2015-01-15 01:06:32.000000', 'consum', 0.0213, 'lps'),
	(359425, 123, '2015-01-15 01:06:33.000000', 'consum', 0.0218, 'lps'),
	(359426, 123, '2015-01-15 01:06:34.000000', 'consum', 0.0216, 'lps'),
	(359427, 123, '2015-01-15 01:06:35.000000', 'consum', 0.0219, 'lps'),
	(359428, 123, '2015-01-15 01:06:36.000000', 'consum', 0.0210, 'lps'),
	(359429, 123, '2015-01-15 01:06:37.000000', 'consum', 0.0211, 'lps'),
	(359430, 123, '2015-01-15 01:06:38.000000', 'consum', 0.0214, 'lps'),
	(359431, 123, '2015-01-15 01:06:39.000000', 'consum', 0.0216, 'lps'),
	(359432, 123, '2015-01-15 01:06:40.000000', 'consum', 0.0218, 'lps'),
	(359433, 123, '2015-01-15 01:06:41.000000', 'consum', 0.0217, 'lps'),
	(359434, 123, '2015-01-15 01:06:42.000000', 'consum', 0.0212, 'lps'),
	(359435, 123, '2015-01-15 01:06:43.000000', 'consum', 0.0213, 'lps'),
	(359436, 123, '2015-01-15 01:06:44.000000', 'consum', 0.0217, 'lps'),
	(359437, 123, '2015-01-15 01:06:45.000000', 'consum', 0.0213, 'lps'),
	(359438, 123, '2015-01-15 01:06:46.000000', 'consum', 0.0217, 'lps'),
	(359439, 123, '2015-01-15 01:06:47.000000', 'consum', 0.0213, 'lps'),
	(359440, 123, '2015-01-15 01:06:48.000000', 'consum', 0.0215, 'lps'),
	(359441, 123, '2015-01-15 01:06:49.000000', 'consum', 0.0214, 'lps'),
	(359442, 124, '2015-01-15 00:00:00.000000', 'consum', 0.0230, 'lps'),
	(359443, 124, '2015-01-15 00:00:01.000000', 'consum', 0.0228, 'lps'),
	(359444, 124, '2015-01-15 00:00:02.000000', 'consum', 0.0216, 'lps'),
	(359445, 124, '2015-01-15 00:00:03.000000', 'consum', 0.0211, 'lps'),
	(359446, 124, '2015-01-15 00:00:04.000000', 'consum', 0.0218, 'lps'),
	(359447, 124, '2015-01-15 00:00:05.000000', 'consum', 0.0226, 'lps'),
	(359448, 124, '2015-01-15 00:00:06.000000', 'consum', 0.0221, 'lps'),
	(359449, 124, '2015-01-15 00:00:07.000000', 'consum', 0.0220, 'lps'),
	(359450, 124, '2015-01-15 00:00:08.000000', 'consum', 0.0228, 'lps'),
	(359451, 124, '2015-01-15 00:00:09.000000', 'consum', 0.0227, 'lps'),
	(359452, 124, '2015-01-15 00:00:10.000000', 'consum', 0.0218, 'lps'),
	(359453, 124, '2015-01-15 00:00:11.000000', 'consum', 0.0220, 'lps'),
	(359454, 124, '2015-01-15 00:00:12.000000', 'consum', 0.0215, 'lps'),
	(359455, 124, '2015-01-15 00:00:13.000000', 'consum', 0.0227, 'lps'),
	(359456, 124, '2015-01-15 00:00:14.000000', 'consum', 0.0217, 'lps'),
	(359457, 124, '2015-01-15 00:00:15.000000', 'consum', 0.0215, 'lps'),
	(359458, 124, '2015-01-15 00:00:16.000000', 'consum', 0.0214, 'lps'),
	(359459, 124, '2015-01-15 00:00:17.000000', 'consum', 0.0216, 'lps'),
	(359460, 124, '2015-01-15 00:00:18.000000', 'consum', 0.0228, 'lps'),
	(359461, 124, '2015-01-15 00:00:19.000000', 'consum', 0.0217, 'lps'),
	(359462, 124, '2015-01-15 00:00:20.000000', 'consum', 0.0215, 'lps'),
	(359463, 124, '2015-01-15 00:00:21.000000', 'consum', 0.0213, 'lps'),
	(359464, 124, '2015-01-15 00:00:22.000000', 'consum', 0.0211, 'lps'),
	(359465, 124, '2015-01-15 00:00:23.000000', 'consum', 0.0227, 'lps'),
	(359466, 124, '2015-01-15 00:00:24.000000', 'consum', 0.0226, 'lps'),
	(359467, 124, '2015-01-15 00:00:25.000000', 'consum', 0.0218, 'lps'),
	(359468, 124, '2015-01-15 00:00:26.000000', 'consum', 0.0226, 'lps'),
	(359469, 124, '2015-01-15 00:00:27.000000', 'consum', 0.0223, 'lps'),
	(359470, 124, '2015-01-15 00:00:28.000000', 'consum', 0.0227, 'lps'),
	(359471, 124, '2015-01-15 00:00:29.000000', 'consum', 0.0212, 'lps'),
	(359472, 124, '2015-01-15 00:00:30.000000', 'consum', 0.0213, 'lps'),
	(359473, 124, '2015-01-15 00:00:31.000000', 'consum', 0.0219, 'lps'),
	(359474, 124, '2015-01-15 00:00:32.000000', 'consum', 0.0223, 'lps'),
	(359475, 124, '2015-01-15 00:00:33.000000', 'consum', 0.0230, 'lps'),
	(359476, 124, '2015-01-15 00:00:34.000000', 'consum', 0.0225, 'lps'),
	(359477, 124, '2015-01-15 00:00:35.000000', 'consum', 0.0226, 'lps'),
	(359478, 124, '2015-01-15 00:00:36.000000', 'consum', 0.0226, 'lps'),
	(359479, 124, '2015-01-15 00:00:37.000000', 'consum', 0.0217, 'lps'),
	(359480, 124, '2015-01-15 00:00:38.000000', 'consum', 0.0222, 'lps'),
	(359481, 124, '2015-01-15 00:00:39.000000', 'consum', 0.0225, 'lps'),
	(359482, 124, '2015-01-15 00:00:40.000000', 'consum', 0.0229, 'lps'),
	(359483, 124, '2015-01-15 00:00:41.000000', 'consum', 0.0217, 'lps'),
	(359484, 124, '2015-01-15 00:00:42.000000', 'consum', 0.0212, 'lps'),
	(359485, 124, '2015-01-15 00:00:43.000000', 'consum', 0.0220, 'lps'),
	(359486, 124, '2015-01-15 00:00:44.000000', 'consum', 0.0231, 'lps'),
	(359487, 124, '2015-01-15 00:00:45.000000', 'consum', 0.0219, 'lps'),
	(359488, 124, '2015-01-15 00:00:46.000000', 'consum', 0.0216, 'lps'),
	(359489, 124, '2015-01-15 00:00:47.000000', 'consum', 0.0215, 'lps'),
	(359490, 124, '2015-01-15 00:00:48.000000', 'consum', 0.0217, 'lps'),
	(359491, 124, '2015-01-15 00:00:49.000000', 'consum', 0.0231, 'lps'),
	(359492, 124, '2015-01-15 00:00:50.000000', 'consum', 0.0228, 'lps'),
	(359493, 124, '2015-01-15 00:00:51.000000', 'consum', 0.0217, 'lps'),
	(359494, 124, '2015-01-15 00:00:52.000000', 'consum', 0.0214, 'lps'),
	(359495, 124, '2015-01-15 00:00:53.000000', 'consum', 0.0211, 'lps'),
	(359496, 124, '2015-01-15 00:00:54.000000', 'consum', 0.0222, 'lps'),
	(359497, 124, '2015-01-15 00:00:55.000000', 'consum', 0.0223, 'lps'),
	(359498, 124, '2015-01-15 00:00:56.000000', 'consum', 0.0217, 'lps'),
	(359499, 124, '2015-01-15 00:00:57.000000', 'consum', 0.0229, 'lps'),
	(359500, 124, '2015-01-15 00:00:58.000000', 'consum', 0.0217, 'lps'),
	(359501, 124, '2015-01-15 00:00:59.000000', 'consum', 0.0214, 'lps'),
	(359502, 124, '2015-01-15 00:01:00.000000', 'consum', 0.0229, 'lps'),
	(359503, 124, '2015-01-15 00:01:01.000000', 'consum', 0.0228, 'lps'),
	(359504, 124, '2015-01-15 00:01:02.000000', 'consum', 0.0222, 'lps'),
	(359505, 124, '2015-01-15 00:01:03.000000', 'consum', 0.0218, 'lps'),
	(359506, 124, '2015-01-15 00:01:04.000000', 'consum', 0.0212, 'lps'),
	(359507, 124, '2015-01-15 00:01:05.000000', 'consum', 0.0220, 'lps'),
	(359508, 124, '2015-01-15 00:01:06.000000', 'consum', 0.0231, 'lps'),
	(359509, 124, '2015-01-15 00:01:07.000000', 'consum', 0.0221, 'lps'),
	(359510, 124, '2015-01-15 00:01:08.000000', 'consum', 0.0226, 'lps'),
	(359511, 124, '2015-01-15 00:01:09.000000', 'consum', 0.0212, 'lps'),
	(359512, 124, '2015-01-15 00:01:10.000000', 'consum', 0.0215, 'lps'),
	(359513, 124, '2015-01-15 00:01:11.000000', 'consum', 0.0229, 'lps'),
	(359514, 124, '2015-01-15 00:01:12.000000', 'consum', 0.0226, 'lps'),
	(359515, 124, '2015-01-15 00:01:13.000000', 'consum', 0.0211, 'lps'),
	(359516, 124, '2015-01-15 00:01:14.000000', 'consum', 0.0211, 'lps'),
	(359517, 124, '2015-01-15 00:01:15.000000', 'consum', 0.0212, 'lps'),
	(359518, 124, '2015-01-15 00:01:16.000000', 'consum', 0.0220, 'lps'),
	(359519, 124, '2015-01-15 00:01:17.000000', 'consum', 0.0210, 'lps'),
	(359520, 124, '2015-01-15 00:01:18.000000', 'consum', 0.0223, 'lps'),
	(359521, 124, '2015-01-15 00:01:19.000000', 'consum', 0.0211, 'lps'),
	(359522, 124, '2015-01-15 00:01:20.000000', 'consum', 0.0219, 'lps'),
	(359523, 124, '2015-01-15 00:01:21.000000', 'consum', 0.0230, 'lps'),
	(359524, 124, '2015-01-15 00:01:22.000000', 'consum', 0.0219, 'lps'),
	(359525, 124, '2015-01-15 00:01:23.000000', 'consum', 0.0217, 'lps'),
	(359526, 124, '2015-01-15 00:01:24.000000', 'consum', 0.0218, 'lps'),
	(359527, 124, '2015-01-15 00:01:25.000000', 'consum', 0.0228, 'lps'),
	(359528, 124, '2015-01-15 00:01:26.000000', 'consum', 0.0214, 'lps'),
	(359529, 124, '2015-01-15 00:01:27.000000', 'consum', 0.0218, 'lps'),
	(359530, 124, '2015-01-15 00:01:28.000000', 'consum', 0.0215, 'lps'),
	(359531, 124, '2015-01-15 00:01:29.000000', 'consum', 0.0213, 'lps'),
	(359532, 124, '2015-01-15 00:01:30.000000', 'consum', 0.0212, 'lps'),
	(359533, 124, '2015-01-15 00:01:31.000000', 'consum', 0.0210, 'lps'),
	(359534, 124, '2015-01-15 00:01:32.000000', 'consum', 0.0227, 'lps'),
	(359535, 124, '2015-01-15 00:01:33.000000', 'consum', 0.0231, 'lps'),
	(359536, 124, '2015-01-15 00:01:34.000000', 'consum', 0.0218, 'lps'),
	(359537, 124, '2015-01-15 00:01:35.000000', 'consum', 0.0211, 'lps'),
	(359538, 124, '2015-01-15 00:01:36.000000', 'consum', 0.0214, 'lps'),
	(359539, 124, '2015-01-15 00:01:37.000000', 'consum', 0.0227, 'lps'),
	(359540, 124, '2015-01-15 00:01:38.000000', 'consum', 0.0218, 'lps'),
	(359541, 124, '2015-01-15 00:01:39.000000', 'consum', 0.0219, 'lps'),
	(359542, 124, '2015-01-15 00:01:40.000000', 'consum', 0.0211, 'lps'),
	(359543, 124, '2015-01-15 00:01:41.000000', 'consum', 0.0212, 'lps'),
	(359544, 124, '2015-01-15 00:01:42.000000', 'consum', 0.0218, 'lps'),
	(359545, 124, '2015-01-15 00:01:43.000000', 'consum', 0.0223, 'lps'),
	(359546, 124, '2015-01-15 00:01:44.000000', 'consum', 0.0228, 'lps'),
	(359547, 124, '2015-01-15 00:01:45.000000', 'consum', 0.0216, 'lps'),
	(359548, 124, '2015-01-15 00:01:46.000000', 'consum', 0.0231, 'lps'),
	(359549, 124, '2015-01-15 00:01:47.000000', 'consum', 0.0230, 'lps'),
	(359550, 124, '2015-01-15 00:01:48.000000', 'consum', 0.0227, 'lps'),
	(359551, 124, '2015-01-15 00:01:49.000000', 'consum', 0.0212, 'lps'),
	(359552, 124, '2015-01-15 00:01:50.000000', 'consum', 0.0216, 'lps'),
	(359553, 124, '2015-01-15 00:01:51.000000', 'consum', 0.0211, 'lps'),
	(359554, 124, '2015-01-15 00:01:52.000000', 'consum', 0.0220, 'lps'),
	(359555, 124, '2015-01-15 00:01:53.000000', 'consum', 0.0212, 'lps'),
	(359556, 124, '2015-01-15 00:01:54.000000', 'consum', 0.0214, 'lps'),
	(359557, 124, '2015-01-15 00:01:55.000000', 'consum', 0.0222, 'lps'),
	(359558, 124, '2015-01-15 00:01:56.000000', 'consum', 0.0216, 'lps'),
	(359559, 124, '2015-01-15 00:01:57.000000', 'consum', 0.0227, 'lps'),
	(359560, 124, '2015-01-15 00:01:58.000000', 'consum', 0.0211, 'lps'),
	(359561, 124, '2015-01-15 00:01:59.000000', 'consum', 0.0229, 'lps'),
	(359562, 124, '2015-01-15 00:02:00.000000', 'consum', 0.0214, 'lps'),
	(359563, 124, '2015-01-15 00:02:01.000000', 'consum', 0.0220, 'lps'),
	(359564, 124, '2015-01-15 00:02:02.000000', 'consum', 0.0224, 'lps'),
	(359565, 124, '2015-01-15 00:02:03.000000', 'consum', 0.0230, 'lps'),
	(359566, 124, '2015-01-15 00:02:04.000000', 'consum', 0.0225, 'lps'),
	(359567, 124, '2015-01-15 00:02:05.000000', 'consum', 0.0225, 'lps'),
	(359568, 124, '2015-01-15 00:02:06.000000', 'consum', 0.0217, 'lps'),
	(359569, 124, '2015-01-15 00:02:07.000000', 'consum', 0.0224, 'lps'),
	(359570, 124, '2015-01-15 00:02:08.000000', 'consum', 0.0216, 'lps'),
	(359571, 124, '2015-01-15 00:02:09.000000', 'consum', 0.0220, 'lps'),
	(359572, 124, '2015-01-15 00:02:10.000000', 'consum', 0.0222, 'lps'),
	(359573, 124, '2015-01-15 00:02:11.000000', 'consum', 0.0218, 'lps'),
	(359574, 124, '2015-01-15 00:02:12.000000', 'consum', 0.0212, 'lps'),
	(359575, 124, '2015-01-15 00:02:13.000000', 'consum', 0.0220, 'lps'),
	(359576, 124, '2015-01-15 00:02:14.000000', 'consum', 0.0210, 'lps'),
	(359577, 124, '2015-01-15 00:02:15.000000', 'consum', 0.0226, 'lps'),
	(359578, 124, '2015-01-15 00:02:16.000000', 'consum', 0.0224, 'lps'),
	(359579, 124, '2015-01-15 00:02:17.000000', 'consum', 0.0231, 'lps'),
	(359580, 124, '2015-01-15 00:02:18.000000', 'consum', 0.0229, 'lps'),
	(359581, 124, '2015-01-15 00:02:19.000000', 'consum', 0.0221, 'lps'),
	(359582, 124, '2015-01-15 00:02:20.000000', 'consum', 0.0229, 'lps'),
	(359583, 124, '2015-01-15 00:02:21.000000', 'consum', 0.0210, 'lps'),
	(359584, 124, '2015-01-15 00:02:22.000000', 'consum', 0.0217, 'lps'),
	(359585, 124, '2015-01-15 00:02:23.000000', 'consum', 0.0226, 'lps'),
	(359586, 124, '2015-01-15 00:02:24.000000', 'consum', 0.0225, 'lps'),
	(359587, 124, '2015-01-15 00:02:25.000000', 'consum', 0.0216, 'lps'),
	(359588, 124, '2015-01-15 00:02:26.000000', 'consum', 0.0218, 'lps'),
	(359589, 124, '2015-01-15 00:02:27.000000', 'consum', 0.0211, 'lps'),
	(359590, 124, '2015-01-15 00:02:28.000000', 'consum', 0.0213, 'lps'),
	(359591, 124, '2015-01-15 00:02:29.000000', 'consum', 0.0224, 'lps'),
	(359592, 124, '2015-01-15 00:02:30.000000', 'consum', 0.0225, 'lps'),
	(359593, 124, '2015-01-15 00:02:31.000000', 'consum', 0.0223, 'lps'),
	(359594, 124, '2015-01-15 00:02:32.000000', 'consum', 0.0210, 'lps'),
	(359595, 124, '2015-01-15 00:02:33.000000', 'consum', 0.0214, 'lps'),
	(359596, 124, '2015-01-15 00:02:34.000000', 'consum', 0.0210, 'lps'),
	(359597, 124, '2015-01-15 00:02:35.000000', 'consum', 0.0219, 'lps'),
	(359598, 124, '2015-01-15 00:02:36.000000', 'consum', 0.0213, 'lps'),
	(359599, 124, '2015-01-15 00:02:37.000000', 'consum', 0.0221, 'lps'),
	(359600, 124, '2015-01-15 00:02:38.000000', 'consum', 0.0211, 'lps'),
	(359601, 124, '2015-01-15 00:02:39.000000', 'consum', 0.0226, 'lps'),
	(359602, 124, '2015-01-15 00:02:40.000000', 'consum', 0.0221, 'lps'),
	(359603, 124, '2015-01-15 00:02:41.000000', 'consum', 0.0220, 'lps'),
	(359604, 124, '2015-01-15 00:02:42.000000', 'consum', 0.0226, 'lps'),
	(359605, 124, '2015-01-15 00:02:43.000000', 'consum', 0.0215, 'lps'),
	(359606, 124, '2015-01-15 00:02:44.000000', 'consum', 0.0213, 'lps'),
	(359607, 124, '2015-01-15 00:02:45.000000', 'consum', 0.0230, 'lps'),
	(359608, 124, '2015-01-15 00:02:46.000000', 'consum', 0.0213, 'lps'),
	(359609, 124, '2015-01-15 00:02:47.000000', 'consum', 0.0210, 'lps'),
	(359610, 124, '2015-01-15 00:02:48.000000', 'consum', 0.0223, 'lps'),
	(359611, 124, '2015-01-15 00:02:49.000000', 'consum', 0.0210, 'lps'),
	(359612, 124, '2015-01-15 00:02:50.000000', 'consum', 0.0216, 'lps'),
	(359613, 124, '2015-01-15 00:02:51.000000', 'consum', 0.0216, 'lps'),
	(359614, 124, '2015-01-15 00:02:52.000000', 'consum', 0.0226, 'lps'),
	(359615, 124, '2015-01-15 00:02:53.000000', 'consum', 0.0227, 'lps'),
	(359616, 124, '2015-01-15 00:02:54.000000', 'consum', 0.0228, 'lps'),
	(359617, 124, '2015-01-15 00:02:55.000000', 'consum', 0.0224, 'lps'),
	(359618, 124, '2015-01-15 00:02:56.000000', 'consum', 0.0229, 'lps'),
	(359619, 124, '2015-01-15 00:02:57.000000', 'consum', 0.0221, 'lps'),
	(359620, 124, '2015-01-15 00:02:58.000000', 'consum', 0.0227, 'lps'),
	(359621, 124, '2015-01-15 00:02:59.000000', 'consum', 0.0220, 'lps'),
	(359622, 124, '2015-01-15 00:03:00.000000', 'consum', 0.0230, 'lps'),
	(359623, 124, '2015-01-15 00:03:01.000000', 'consum', 0.0215, 'lps'),
	(359624, 124, '2015-01-15 00:03:02.000000', 'consum', 0.0221, 'lps'),
	(359625, 124, '2015-01-15 00:03:03.000000', 'consum', 0.0228, 'lps'),
	(359626, 124, '2015-01-15 00:03:04.000000', 'consum', 0.0224, 'lps'),
	(359627, 124, '2015-01-15 00:03:05.000000', 'consum', 0.0227, 'lps'),
	(359628, 124, '2015-01-15 00:03:06.000000', 'consum', 0.0230, 'lps'),
	(359629, 124, '2015-01-15 00:03:07.000000', 'consum', 0.0215, 'lps'),
	(359630, 124, '2015-01-15 00:03:08.000000', 'consum', 0.0222, 'lps'),
	(359631, 124, '2015-01-15 00:03:09.000000', 'consum', 0.0211, 'lps'),
	(359632, 124, '2015-01-15 00:03:10.000000', 'consum', 0.0225, 'lps'),
	(359633, 124, '2015-01-15 00:03:11.000000', 'consum', 0.0215, 'lps'),
	(359634, 124, '2015-01-15 00:03:12.000000', 'consum', 0.0211, 'lps'),
	(359635, 124, '2015-01-15 00:03:13.000000', 'consum', 0.0222, 'lps'),
	(359636, 124, '2015-01-15 00:03:14.000000', 'consum', 0.0226, 'lps'),
	(359637, 124, '2015-01-15 00:03:15.000000', 'consum', 0.0229, 'lps'),
	(359638, 124, '2015-01-15 00:03:16.000000', 'consum', 0.0217, 'lps'),
	(359639, 124, '2015-01-15 00:03:17.000000', 'consum', 0.0210, 'lps'),
	(359640, 124, '2015-01-15 00:03:18.000000', 'consum', 0.0210, 'lps'),
	(359641, 124, '2015-01-15 00:03:19.000000', 'consum', 0.0213, 'lps'),
	(359642, 124, '2015-01-15 00:03:20.000000', 'consum', 0.0225, 'lps'),
	(359643, 124, '2015-01-15 00:03:21.000000', 'consum', 0.0230, 'lps'),
	(359644, 124, '2015-01-15 00:03:22.000000', 'consum', 0.0224, 'lps'),
	(359645, 124, '2015-01-15 00:03:23.000000', 'consum', 0.0219, 'lps'),
	(359646, 124, '2015-01-15 00:03:24.000000', 'consum', 0.0213, 'lps'),
	(359647, 124, '2015-01-15 00:03:25.000000', 'consum', 0.0220, 'lps'),
	(359648, 124, '2015-01-15 00:03:26.000000', 'consum', 0.0210, 'lps'),
	(359649, 124, '2015-01-15 00:03:27.000000', 'consum', 0.0222, 'lps'),
	(359650, 124, '2015-01-15 00:03:28.000000', 'consum', 0.0226, 'lps'),
	(359651, 124, '2015-01-15 00:03:29.000000', 'consum', 0.0213, 'lps'),
	(359652, 124, '2015-01-15 00:03:30.000000', 'consum', 0.0221, 'lps'),
	(359653, 124, '2015-01-15 00:03:31.000000', 'consum', 0.0211, 'lps'),
	(359654, 124, '2015-01-15 00:03:32.000000', 'consum', 0.0226, 'lps'),
	(359655, 124, '2015-01-15 00:03:33.000000', 'consum', 0.0223, 'lps'),
	(359656, 124, '2015-01-15 00:03:34.000000', 'consum', 0.0226, 'lps'),
	(359657, 124, '2015-01-15 00:03:35.000000', 'consum', 0.0229, 'lps'),
	(359658, 124, '2015-01-15 00:03:36.000000', 'consum', 0.0214, 'lps'),
	(359659, 124, '2015-01-15 00:03:37.000000', 'consum', 0.0217, 'lps'),
	(359660, 124, '2015-01-15 00:03:38.000000', 'consum', 0.0214, 'lps'),
	(359661, 124, '2015-01-15 00:03:39.000000', 'consum', 0.0229, 'lps'),
	(359662, 124, '2015-01-15 00:03:40.000000', 'consum', 0.0229, 'lps'),
	(359663, 124, '2015-01-15 00:03:41.000000', 'consum', 0.0225, 'lps'),
	(359664, 124, '2015-01-15 00:03:42.000000', 'consum', 0.0230, 'lps'),
	(359665, 124, '2015-01-15 00:03:43.000000', 'consum', 0.0219, 'lps'),
	(359666, 124, '2015-01-15 00:03:44.000000', 'consum', 0.0220, 'lps'),
	(359667, 124, '2015-01-15 00:03:45.000000', 'consum', 0.0212, 'lps'),
	(359668, 124, '2015-01-15 00:03:46.000000', 'consum', 0.0213, 'lps'),
	(359669, 124, '2015-01-15 00:03:47.000000', 'consum', 0.0216, 'lps'),
	(359670, 124, '2015-01-15 00:03:48.000000', 'consum', 0.0213, 'lps'),
	(359671, 124, '2015-01-15 00:03:49.000000', 'consum', 0.0229, 'lps'),
	(359672, 124, '2015-01-15 00:03:50.000000', 'consum', 0.0230, 'lps'),
	(359673, 124, '2015-01-15 00:03:51.000000', 'consum', 0.0210, 'lps'),
	(359674, 124, '2015-01-15 00:03:52.000000', 'consum', 0.0218, 'lps'),
	(359675, 124, '2015-01-15 00:03:53.000000', 'consum', 0.0225, 'lps'),
	(359676, 124, '2015-01-15 00:03:54.000000', 'consum', 0.0221, 'lps'),
	(359677, 124, '2015-01-15 00:03:55.000000', 'consum', 0.0218, 'lps'),
	(359678, 124, '2015-01-15 00:03:56.000000', 'consum', 0.0218, 'lps'),
	(359679, 124, '2015-01-15 00:03:57.000000', 'consum', 0.0229, 'lps'),
	(359680, 124, '2015-01-15 00:03:58.000000', 'consum', 0.0212, 'lps'),
	(359681, 124, '2015-01-15 00:03:59.000000', 'consum', 0.0231, 'lps'),
	(359682, 124, '2015-01-15 00:04:00.000000', 'consum', 0.0220, 'lps'),
	(359683, 124, '2015-01-15 00:04:01.000000', 'consum', 0.0219, 'lps'),
	(359684, 124, '2015-01-15 00:04:02.000000', 'consum', 0.0224, 'lps'),
	(359685, 124, '2015-01-15 00:04:03.000000', 'consum', 0.0213, 'lps'),
	(359686, 124, '2015-01-15 00:04:04.000000', 'consum', 0.0226, 'lps'),
	(359687, 124, '2015-01-15 00:04:05.000000', 'consum', 0.0214, 'lps'),
	(359688, 124, '2015-01-15 00:04:06.000000', 'consum', 0.0228, 'lps'),
	(359689, 124, '2015-01-15 00:04:07.000000', 'consum', 0.0223, 'lps'),
	(359690, 124, '2015-01-15 00:04:08.000000', 'consum', 0.0222, 'lps'),
	(359691, 124, '2015-01-15 00:04:09.000000', 'consum', 0.0229, 'lps'),
	(359692, 124, '2015-01-15 00:04:10.000000', 'consum', 0.0228, 'lps'),
	(359693, 124, '2015-01-15 00:04:11.000000', 'consum', 0.0219, 'lps'),
	(359694, 124, '2015-01-15 00:04:12.000000', 'consum', 0.0224, 'lps'),
	(359695, 124, '2015-01-15 00:04:13.000000', 'consum', 0.0210, 'lps'),
	(359696, 124, '2015-01-15 00:04:14.000000', 'consum', 0.0211, 'lps'),
	(359697, 124, '2015-01-15 00:04:15.000000', 'consum', 0.0218, 'lps'),
	(359698, 124, '2015-01-15 00:04:16.000000', 'consum', 0.0226, 'lps'),
	(359699, 124, '2015-01-15 00:04:17.000000', 'consum', 0.0220, 'lps'),
	(359700, 124, '2015-01-15 00:04:18.000000', 'consum', 0.0215, 'lps'),
	(359701, 124, '2015-01-15 00:04:19.000000', 'consum', 0.0227, 'lps'),
	(359702, 124, '2015-01-15 00:04:20.000000', 'consum', 0.0216, 'lps'),
	(359703, 124, '2015-01-15 00:04:21.000000', 'consum', 0.0231, 'lps'),
	(359704, 124, '2015-01-15 00:04:22.000000', 'consum', 0.0230, 'lps'),
	(359705, 124, '2015-01-15 00:04:23.000000', 'consum', 0.0229, 'lps'),
	(359706, 124, '2015-01-15 00:04:24.000000', 'consum', 0.0221, 'lps'),
	(359707, 124, '2015-01-15 00:04:25.000000', 'consum', 0.0210, 'lps'),
	(359708, 124, '2015-01-15 00:04:26.000000', 'consum', 0.0221, 'lps'),
	(359709, 124, '2015-01-15 00:04:27.000000', 'consum', 0.0220, 'lps'),
	(359710, 124, '2015-01-15 00:04:28.000000', 'consum', 0.0227, 'lps'),
	(359711, 124, '2015-01-15 00:04:29.000000', 'consum', 0.0224, 'lps'),
	(359712, 124, '2015-01-15 00:04:30.000000', 'consum', 0.0227, 'lps'),
	(359713, 124, '2015-01-15 00:04:31.000000', 'consum', 0.0231, 'lps'),
	(359714, 124, '2015-01-15 00:04:32.000000', 'consum', 0.0221, 'lps'),
	(359715, 124, '2015-01-15 00:04:33.000000', 'consum', 0.0226, 'lps'),
	(359716, 124, '2015-01-15 00:04:34.000000', 'consum', 0.0212, 'lps'),
	(359717, 124, '2015-01-15 00:04:35.000000', 'consum', 0.0218, 'lps'),
	(359718, 124, '2015-01-15 00:04:36.000000', 'consum', 0.0220, 'lps'),
	(359719, 124, '2015-01-15 00:04:37.000000', 'consum', 0.0215, 'lps'),
	(359720, 124, '2015-01-15 00:04:38.000000', 'consum', 0.0228, 'lps'),
	(359721, 124, '2015-01-15 00:04:39.000000', 'consum', 0.0220, 'lps'),
	(359722, 124, '2015-01-15 00:04:40.000000', 'consum', 0.0229, 'lps'),
	(359723, 124, '2015-01-15 00:04:41.000000', 'consum', 0.0229, 'lps'),
	(359724, 124, '2015-01-15 00:04:42.000000', 'consum', 0.0228, 'lps'),
	(359725, 124, '2015-01-15 00:04:43.000000', 'consum', 0.0223, 'lps'),
	(359726, 124, '2015-01-15 00:04:44.000000', 'consum', 0.0219, 'lps'),
	(359727, 124, '2015-01-15 00:04:45.000000', 'consum', 0.0217, 'lps'),
	(359728, 124, '2015-01-15 00:04:46.000000', 'consum', 0.0217, 'lps'),
	(359729, 124, '2015-01-15 00:04:47.000000', 'consum', 0.0228, 'lps'),
	(359730, 124, '2015-01-15 00:04:48.000000', 'consum', 0.0210, 'lps'),
	(359731, 124, '2015-01-15 00:04:49.000000', 'consum', 0.0224, 'lps'),
	(359732, 124, '2015-01-15 00:04:50.000000', 'consum', 0.0217, 'lps'),
	(359733, 124, '2015-01-15 00:04:51.000000', 'consum', 0.0222, 'lps'),
	(359734, 124, '2015-01-15 00:04:52.000000', 'consum', 0.0227, 'lps'),
	(359735, 124, '2015-01-15 00:04:53.000000', 'consum', 0.0218, 'lps'),
	(359736, 124, '2015-01-15 00:04:54.000000', 'consum', 0.0222, 'lps'),
	(359737, 124, '2015-01-15 00:04:55.000000', 'consum', 0.0225, 'lps'),
	(359738, 124, '2015-01-15 00:04:56.000000', 'consum', 0.0227, 'lps'),
	(359739, 124, '2015-01-15 00:04:57.000000', 'consum', 0.0229, 'lps'),
	(359740, 124, '2015-01-15 00:04:58.000000', 'consum', 0.0211, 'lps'),
	(359741, 124, '2015-01-15 00:04:59.000000', 'consum', 0.0224, 'lps'),
	(359742, 124, '2015-01-15 00:05:00.000000', 'consum', 0.0212, 'lps'),
	(359743, 124, '2015-01-15 00:05:01.000000', 'consum', 0.0222, 'lps'),
	(359744, 124, '2015-01-15 00:05:02.000000', 'consum', 0.0219, 'lps'),
	(359745, 124, '2015-01-15 00:05:03.000000', 'consum', 0.0219, 'lps'),
	(359746, 124, '2015-01-15 00:05:04.000000', 'consum', 0.0231, 'lps'),
	(359747, 124, '2015-01-15 00:05:05.000000', 'consum', 0.0221, 'lps'),
	(359748, 124, '2015-01-15 00:05:06.000000', 'consum', 0.0224, 'lps'),
	(359749, 124, '2015-01-15 00:05:07.000000', 'consum', 0.0227, 'lps'),
	(359750, 124, '2015-01-15 00:05:08.000000', 'consum', 0.0231, 'lps'),
	(359751, 124, '2015-01-15 00:05:09.000000', 'consum', 0.0222, 'lps'),
	(359752, 124, '2015-01-15 00:05:10.000000', 'consum', 0.0231, 'lps'),
	(359753, 124, '2015-01-15 00:05:11.000000', 'consum', 0.0210, 'lps'),
	(359754, 124, '2015-01-15 00:05:12.000000', 'consum', 0.0213, 'lps'),
	(359755, 124, '2015-01-15 00:05:13.000000', 'consum', 0.0226, 'lps'),
	(359756, 124, '2015-01-15 00:05:14.000000', 'consum', 0.0215, 'lps'),
	(359757, 124, '2015-01-15 00:05:15.000000', 'consum', 0.0230, 'lps'),
	(359758, 124, '2015-01-15 00:05:16.000000', 'consum', 0.0210, 'lps'),
	(359759, 124, '2015-01-15 00:05:17.000000', 'consum', 0.0216, 'lps'),
	(359760, 124, '2015-01-15 00:05:18.000000', 'consum', 0.0218, 'lps'),
	(359761, 124, '2015-01-15 00:05:19.000000', 'consum', 0.0231, 'lps'),
	(359762, 124, '2015-01-15 00:05:20.000000', 'consum', 0.0228, 'lps'),
	(359763, 124, '2015-01-15 00:05:21.000000', 'consum', 0.0215, 'lps'),
	(359764, 124, '2015-01-15 00:05:22.000000', 'consum', 0.0225, 'lps'),
	(359765, 124, '2015-01-15 00:05:23.000000', 'consum', 0.0226, 'lps'),
	(359766, 124, '2015-01-15 00:05:24.000000', 'consum', 0.0226, 'lps'),
	(359767, 124, '2015-01-15 00:05:25.000000', 'consum', 0.0218, 'lps'),
	(359768, 124, '2015-01-15 00:05:26.000000', 'consum', 0.0227, 'lps'),
	(359769, 124, '2015-01-15 00:05:27.000000', 'consum', 0.0226, 'lps'),
	(359770, 124, '2015-01-15 00:05:28.000000', 'consum', 0.0219, 'lps'),
	(359771, 124, '2015-01-15 00:05:29.000000', 'consum', 0.0229, 'lps'),
	(359772, 124, '2015-01-15 00:05:30.000000', 'consum', 0.0213, 'lps'),
	(359773, 124, '2015-01-15 00:05:31.000000', 'consum', 0.0211, 'lps'),
	(359774, 124, '2015-01-15 00:05:32.000000', 'consum', 0.0228, 'lps'),
	(359775, 124, '2015-01-15 00:05:33.000000', 'consum', 0.0212, 'lps'),
	(359776, 124, '2015-01-15 00:05:34.000000', 'consum', 0.0230, 'lps'),
	(359777, 124, '2015-01-15 00:05:35.000000', 'consum', 0.0216, 'lps'),
	(359778, 124, '2015-01-15 00:05:36.000000', 'consum', 0.0225, 'lps'),
	(359779, 124, '2015-01-15 00:05:37.000000', 'consum', 0.0224, 'lps'),
	(359780, 124, '2015-01-15 00:05:38.000000', 'consum', 0.0213, 'lps'),
	(359781, 124, '2015-01-15 00:05:39.000000', 'consum', 0.0228, 'lps'),
	(359782, 124, '2015-01-15 00:05:40.000000', 'consum', 0.0227, 'lps'),
	(359783, 124, '2015-01-15 00:05:41.000000', 'consum', 0.0217, 'lps'),
	(359784, 124, '2015-01-15 00:05:42.000000', 'consum', 0.0217, 'lps'),
	(359785, 124, '2015-01-15 00:05:43.000000', 'consum', 0.0223, 'lps'),
	(359786, 124, '2015-01-15 00:05:44.000000', 'consum', 0.0210, 'lps'),
	(359787, 124, '2015-01-15 00:05:45.000000', 'consum', 0.0219, 'lps'),
	(359788, 124, '2015-01-15 00:05:46.000000', 'consum', 0.0230, 'lps'),
	(359789, 124, '2015-01-15 00:05:47.000000', 'consum', 0.0220, 'lps'),
	(359790, 124, '2015-01-15 00:05:48.000000', 'consum', 0.0222, 'lps'),
	(359791, 124, '2015-01-15 00:05:49.000000', 'consum', 0.0216, 'lps'),
	(359792, 124, '2015-01-15 00:05:50.000000', 'consum', 0.0229, 'lps'),
	(359793, 124, '2015-01-15 00:05:51.000000', 'consum', 0.0220, 'lps'),
	(359794, 124, '2015-01-15 00:05:52.000000', 'consum', 0.0226, 'lps'),
	(359795, 124, '2015-01-15 00:05:53.000000', 'consum', 0.0214, 'lps'),
	(359796, 124, '2015-01-15 00:05:54.000000', 'consum', 0.0230, 'lps'),
	(359797, 124, '2015-01-15 00:05:55.000000', 'consum', 0.0210, 'lps'),
	(359798, 124, '2015-01-15 00:05:56.000000', 'consum', 0.0215, 'lps'),
	(359799, 124, '2015-01-15 00:05:57.000000', 'consum', 0.0216, 'lps'),
	(359800, 124, '2015-01-15 00:05:58.000000', 'consum', 0.0223, 'lps'),
	(359801, 124, '2015-01-15 00:05:59.000000', 'consum', 0.0214, 'lps'),
	(359802, 124, '2015-01-15 00:06:00.000000', 'consum', 0.0213, 'lps'),
	(359803, 124, '2015-01-15 00:06:01.000000', 'consum', 0.0215, 'lps'),
	(359804, 124, '2015-01-15 00:06:02.000000', 'consum', 0.0228, 'lps'),
	(359805, 124, '2015-01-15 00:06:03.000000', 'consum', 0.0218, 'lps'),
	(359806, 124, '2015-01-15 00:06:04.000000', 'consum', 0.0216, 'lps'),
	(359807, 124, '2015-01-15 00:06:05.000000', 'consum', 0.0220, 'lps'),
	(359808, 124, '2015-01-15 00:06:06.000000', 'consum', 0.0218, 'lps'),
	(359809, 124, '2015-01-15 00:06:07.000000', 'consum', 0.0222, 'lps'),
	(359810, 124, '2015-01-15 00:06:08.000000', 'consum', 0.0222, 'lps'),
	(359811, 124, '2015-01-15 00:06:09.000000', 'consum', 0.0216, 'lps'),
	(359812, 124, '2015-01-15 00:06:10.000000', 'consum', 0.0225, 'lps'),
	(359813, 124, '2015-01-15 00:06:11.000000', 'consum', 0.0222, 'lps'),
	(359814, 124, '2015-01-15 00:06:12.000000', 'consum', 0.0226, 'lps'),
	(359815, 124, '2015-01-15 00:06:13.000000', 'consum', 0.0231, 'lps'),
	(359816, 124, '2015-01-15 00:06:14.000000', 'consum', 0.0224, 'lps'),
	(359817, 124, '2015-01-15 00:06:15.000000', 'consum', 0.0217, 'lps'),
	(359818, 124, '2015-01-15 00:06:16.000000', 'consum', 0.0227, 'lps'),
	(359819, 124, '2015-01-15 00:06:17.000000', 'consum', 0.0230, 'lps'),
	(359820, 124, '2015-01-15 00:06:18.000000', 'consum', 0.0214, 'lps'),
	(359821, 124, '2015-01-15 00:06:19.000000', 'consum', 0.0217, 'lps'),
	(359822, 124, '2015-01-15 00:06:20.000000', 'consum', 0.0211, 'lps'),
	(359823, 124, '2015-01-15 00:06:21.000000', 'consum', 0.0215, 'lps'),
	(359824, 124, '2015-01-15 00:06:22.000000', 'consum', 0.0213, 'lps'),
	(359825, 124, '2015-01-15 00:06:23.000000', 'consum', 0.0210, 'lps'),
	(359826, 124, '2015-01-15 00:06:24.000000', 'consum', 0.0225, 'lps'),
	(359827, 124, '2015-01-15 00:06:25.000000', 'consum', 0.0217, 'lps'),
	(359828, 124, '2015-01-15 00:06:26.000000', 'consum', 0.0221, 'lps'),
	(359829, 124, '2015-01-15 00:06:27.000000', 'consum', 0.0225, 'lps'),
	(359830, 124, '2015-01-15 00:06:28.000000', 'consum', 0.0229, 'lps'),
	(359831, 124, '2015-01-15 00:06:29.000000', 'consum', 0.0216, 'lps'),
	(359832, 124, '2015-01-15 00:06:30.000000', 'consum', 0.0228, 'lps'),
	(359833, 124, '2015-01-15 00:06:31.000000', 'consum', 0.0218, 'lps'),
	(359834, 124, '2015-01-15 00:06:32.000000', 'consum', 0.0219, 'lps'),
	(359835, 124, '2015-01-15 00:06:33.000000', 'consum', 0.0210, 'lps'),
	(359836, 124, '2015-01-15 00:06:34.000000', 'consum', 0.0228, 'lps'),
	(359837, 124, '2015-01-15 00:06:35.000000', 'consum', 0.0231, 'lps'),
	(359838, 124, '2015-01-15 00:06:36.000000', 'consum', 0.0221, 'lps'),
	(359839, 124, '2015-01-15 00:06:37.000000', 'consum', 0.0223, 'lps'),
	(359840, 124, '2015-01-15 00:06:38.000000', 'consum', 0.0219, 'lps'),
	(359841, 124, '2015-01-15 00:06:39.000000', 'consum', 0.0220, 'lps'),
	(359842, 124, '2015-01-15 00:06:40.000000', 'consum', 0.0230, 'lps'),
	(359843, 124, '2015-01-15 00:06:41.000000', 'consum', 0.0218, 'lps'),
	(359844, 124, '2015-01-15 00:06:42.000000', 'consum', 0.0210, 'lps'),
	(359845, 124, '2015-01-15 00:06:43.000000', 'consum', 0.0231, 'lps'),
	(359846, 124, '2015-01-15 00:06:44.000000', 'consum', 0.0226, 'lps'),
	(359847, 124, '2015-01-15 00:06:45.000000', 'consum', 0.0227, 'lps'),
	(359848, 124, '2015-01-15 00:06:46.000000', 'consum', 0.0227, 'lps'),
	(359849, 124, '2015-01-15 00:06:47.000000', 'consum', 0.0221, 'lps'),
	(359850, 124, '2015-01-15 00:06:48.000000', 'consum', 0.0213, 'lps'),
	(359851, 124, '2015-01-15 00:06:49.000000', 'consum', 0.0218, 'lps'),
	(359852, 124, '2015-01-15 00:06:50.000000', 'consum', 0.0217, 'lps'),
	(359853, 124, '2015-01-15 00:06:51.000000', 'consum', 0.0221, 'lps'),
	(359854, 124, '2015-01-15 00:06:52.000000', 'consum', 0.0224, 'lps'),
	(359855, 124, '2015-01-15 00:06:53.000000', 'consum', 0.0224, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(359856, 124, '2015-01-15 00:06:54.000000', 'consum', 0.0218, 'lps'),
	(359857, 124, '2015-01-15 00:06:55.000000', 'consum', 0.0228, 'lps'),
	(359858, 124, '2015-01-15 00:06:56.000000', 'consum', 0.0211, 'lps'),
	(359859, 124, '2015-01-15 00:06:57.000000', 'consum', 0.0230, 'lps'),
	(359860, 124, '2015-01-15 00:06:58.000000', 'consum', 0.0217, 'lps'),
	(359861, 124, '2015-01-15 00:06:59.000000', 'consum', 0.0228, 'lps'),
	(359862, 124, '2015-01-15 00:07:00.000000', 'consum', 0.0217, 'lps'),
	(359863, 124, '2015-01-15 00:07:01.000000', 'consum', 0.0211, 'lps'),
	(359864, 124, '2015-01-15 00:07:02.000000', 'consum', 0.0216, 'lps'),
	(359865, 124, '2015-01-15 00:07:03.000000', 'consum', 0.0216, 'lps'),
	(359866, 124, '2015-01-15 00:07:04.000000', 'consum', 0.0223, 'lps'),
	(359867, 124, '2015-01-15 00:07:05.000000', 'consum', 0.0215, 'lps'),
	(359868, 124, '2015-01-15 00:07:06.000000', 'consum', 0.0216, 'lps'),
	(359869, 124, '2015-01-15 00:07:07.000000', 'consum', 0.0228, 'lps'),
	(359870, 124, '2015-01-15 00:07:08.000000', 'consum', 0.0215, 'lps'),
	(359871, 124, '2015-01-15 00:07:09.000000', 'consum', 0.0225, 'lps'),
	(359872, 124, '2015-01-15 00:07:10.000000', 'consum', 0.0225, 'lps'),
	(359873, 124, '2015-01-15 00:07:11.000000', 'consum', 0.0220, 'lps'),
	(359874, 124, '2015-01-15 00:07:12.000000', 'consum', 0.0217, 'lps'),
	(359875, 124, '2015-01-15 00:07:13.000000', 'consum', 0.0216, 'lps'),
	(359876, 124, '2015-01-15 00:07:14.000000', 'consum', 0.0217, 'lps'),
	(359877, 124, '2015-01-15 00:07:15.000000', 'consum', 0.0231, 'lps'),
	(359878, 124, '2015-01-15 00:07:16.000000', 'consum', 0.0225, 'lps'),
	(359879, 124, '2015-01-15 00:07:17.000000', 'consum', 0.0223, 'lps'),
	(359880, 124, '2015-01-15 00:07:18.000000', 'consum', 0.0210, 'lps'),
	(359881, 124, '2015-01-15 00:07:19.000000', 'consum', 0.0214, 'lps'),
	(359882, 124, '2015-01-15 00:07:20.000000', 'consum', 0.0210, 'lps'),
	(359883, 124, '2015-01-15 00:07:21.000000', 'consum', 0.0219, 'lps'),
	(359884, 124, '2015-01-15 00:07:22.000000', 'consum', 0.0212, 'lps'),
	(359885, 124, '2015-01-15 00:07:23.000000', 'consum', 0.0215, 'lps'),
	(359886, 124, '2015-01-15 00:07:24.000000', 'consum', 0.0229, 'lps'),
	(359887, 124, '2015-01-15 00:07:25.000000', 'consum', 0.0223, 'lps'),
	(359888, 124, '2015-01-15 00:07:26.000000', 'consum', 0.0221, 'lps'),
	(359889, 124, '2015-01-15 00:07:27.000000', 'consum', 0.0228, 'lps'),
	(359890, 124, '2015-01-15 00:07:28.000000', 'consum', 0.0221, 'lps'),
	(359891, 124, '2015-01-15 00:07:29.000000', 'consum', 0.0213, 'lps'),
	(359892, 124, '2015-01-15 00:07:30.000000', 'consum', 0.0213, 'lps'),
	(359893, 124, '2015-01-15 00:07:31.000000', 'consum', 0.0217, 'lps'),
	(359894, 124, '2015-01-15 00:07:32.000000', 'consum', 0.0217, 'lps'),
	(359895, 124, '2015-01-15 00:07:33.000000', 'consum', 0.0221, 'lps'),
	(359896, 124, '2015-01-15 00:07:34.000000', 'consum', 0.0226, 'lps'),
	(359897, 124, '2015-01-15 00:07:35.000000', 'consum', 0.0212, 'lps'),
	(359898, 124, '2015-01-15 00:07:36.000000', 'consum', 0.0215, 'lps'),
	(359899, 124, '2015-01-15 00:07:37.000000', 'consum', 0.0229, 'lps'),
	(359900, 124, '2015-01-15 00:07:38.000000', 'consum', 0.0225, 'lps'),
	(359901, 124, '2015-01-15 00:07:39.000000', 'consum', 0.0228, 'lps'),
	(359902, 124, '2015-01-15 00:07:40.000000', 'consum', 0.0212, 'lps'),
	(359903, 124, '2015-01-15 00:07:41.000000', 'consum', 0.0231, 'lps'),
	(359904, 124, '2015-01-15 00:07:42.000000', 'consum', 0.0222, 'lps'),
	(359905, 124, '2015-01-15 00:07:43.000000', 'consum', 0.0229, 'lps'),
	(359906, 124, '2015-01-15 00:07:44.000000', 'consum', 0.0227, 'lps'),
	(359907, 124, '2015-01-15 00:07:45.000000', 'consum', 0.0218, 'lps'),
	(359908, 124, '2015-01-15 00:07:46.000000', 'consum', 0.0218, 'lps'),
	(359909, 124, '2015-01-15 00:07:47.000000', 'consum', 0.0228, 'lps'),
	(359910, 124, '2015-01-15 00:07:48.000000', 'consum', 0.0231, 'lps'),
	(359911, 124, '2015-01-15 00:07:49.000000', 'consum', 0.0217, 'lps'),
	(359912, 124, '2015-01-15 00:07:50.000000', 'consum', 0.0228, 'lps'),
	(359913, 124, '2015-01-15 00:07:51.000000', 'consum', 0.0212, 'lps'),
	(359914, 124, '2015-01-15 00:07:52.000000', 'consum', 0.0212, 'lps'),
	(359915, 124, '2015-01-15 00:07:53.000000', 'consum', 0.0215, 'lps'),
	(359916, 124, '2015-01-15 00:07:54.000000', 'consum', 0.0228, 'lps'),
	(359917, 124, '2015-01-15 00:07:55.000000', 'consum', 0.0219, 'lps'),
	(359918, 124, '2015-01-15 00:07:56.000000', 'consum', 0.0225, 'lps'),
	(359919, 124, '2015-01-15 00:07:57.000000', 'consum', 0.0212, 'lps'),
	(359920, 124, '2015-01-15 00:07:58.000000', 'consum', 0.0221, 'lps'),
	(359921, 124, '2015-01-15 00:07:59.000000', 'consum', 0.0215, 'lps'),
	(359922, 124, '2015-01-15 00:08:00.000000', 'consum', 0.0226, 'lps'),
	(359923, 124, '2015-01-15 00:08:01.000000', 'consum', 0.0210, 'lps'),
	(359924, 124, '2015-01-15 00:08:02.000000', 'consum', 0.0227, 'lps'),
	(359925, 124, '2015-01-15 00:08:03.000000', 'consum', 0.0230, 'lps'),
	(359926, 124, '2015-01-15 00:08:04.000000', 'consum', 0.0214, 'lps'),
	(359927, 124, '2015-01-15 00:08:05.000000', 'consum', 0.0217, 'lps'),
	(359928, 124, '2015-01-15 00:08:06.000000', 'consum', 0.0212, 'lps'),
	(359929, 124, '2015-01-15 00:08:07.000000', 'consum', 0.0222, 'lps'),
	(359930, 124, '2015-01-15 00:08:08.000000', 'consum', 0.0221, 'lps'),
	(359931, 124, '2015-01-15 00:08:09.000000', 'consum', 0.0229, 'lps'),
	(359932, 124, '2015-01-15 00:08:10.000000', 'consum', 0.0227, 'lps'),
	(359933, 124, '2015-01-15 00:08:11.000000', 'consum', 0.0218, 'lps'),
	(359934, 124, '2015-01-15 00:08:12.000000', 'consum', 0.0223, 'lps'),
	(359935, 124, '2015-01-15 00:08:13.000000', 'consum', 0.0228, 'lps'),
	(359936, 124, '2015-01-15 00:08:14.000000', 'consum', 0.0219, 'lps'),
	(359937, 124, '2015-01-15 00:08:15.000000', 'consum', 0.0223, 'lps'),
	(359938, 124, '2015-01-15 00:08:16.000000', 'consum', 0.0224, 'lps'),
	(359939, 124, '2015-01-15 00:08:17.000000', 'consum', 0.0223, 'lps'),
	(359940, 124, '2015-01-15 00:08:18.000000', 'consum', 0.0210, 'lps'),
	(359941, 124, '2015-01-15 00:08:19.000000', 'consum', 0.0217, 'lps'),
	(359942, 124, '2015-01-15 00:08:20.000000', 'consum', 0.0221, 'lps'),
	(359943, 124, '2015-01-15 00:08:21.000000', 'consum', 0.0225, 'lps'),
	(359944, 124, '2015-01-15 00:08:22.000000', 'consum', 0.0231, 'lps'),
	(359945, 124, '2015-01-15 00:08:23.000000', 'consum', 0.0227, 'lps'),
	(359946, 124, '2015-01-15 00:08:24.000000', 'consum', 0.0211, 'lps'),
	(359947, 124, '2015-01-15 00:08:25.000000', 'consum', 0.0230, 'lps'),
	(359948, 124, '2015-01-15 00:08:26.000000', 'consum', 0.0219, 'lps'),
	(359949, 124, '2015-01-15 00:08:27.000000', 'consum', 0.0216, 'lps'),
	(359950, 124, '2015-01-15 00:08:28.000000', 'consum', 0.0216, 'lps'),
	(359951, 124, '2015-01-15 00:08:29.000000', 'consum', 0.0221, 'lps'),
	(359952, 124, '2015-01-15 00:08:30.000000', 'consum', 0.0224, 'lps'),
	(359953, 124, '2015-01-15 00:08:31.000000', 'consum', 0.0226, 'lps'),
	(359954, 124, '2015-01-15 00:08:32.000000', 'consum', 0.0227, 'lps'),
	(359955, 124, '2015-01-15 00:08:33.000000', 'consum', 0.0224, 'lps'),
	(359956, 124, '2015-01-15 00:08:34.000000', 'consum', 0.0230, 'lps'),
	(359957, 124, '2015-01-15 00:08:35.000000', 'consum', 0.0223, 'lps'),
	(359958, 124, '2015-01-15 00:08:36.000000', 'consum', 0.0216, 'lps'),
	(359959, 124, '2015-01-15 00:08:37.000000', 'consum', 0.0224, 'lps'),
	(359960, 124, '2015-01-15 00:08:38.000000', 'consum', 0.0219, 'lps'),
	(359961, 124, '2015-01-15 00:08:39.000000', 'consum', 0.0214, 'lps'),
	(359962, 124, '2015-01-15 00:08:40.000000', 'consum', 0.0226, 'lps'),
	(359963, 124, '2015-01-15 00:08:41.000000', 'consum', 0.0210, 'lps'),
	(359964, 124, '2015-01-15 00:08:42.000000', 'consum', 0.0229, 'lps'),
	(359965, 124, '2015-01-15 00:08:43.000000', 'consum', 0.0220, 'lps'),
	(359966, 124, '2015-01-15 00:08:44.000000', 'consum', 0.0222, 'lps'),
	(359967, 124, '2015-01-15 00:08:45.000000', 'consum', 0.0222, 'lps'),
	(359968, 124, '2015-01-15 00:08:46.000000', 'consum', 0.0231, 'lps'),
	(359969, 124, '2015-01-15 00:08:47.000000', 'consum', 0.0215, 'lps'),
	(359970, 124, '2015-01-15 00:08:48.000000', 'consum', 0.0218, 'lps'),
	(359971, 124, '2015-01-15 00:08:49.000000', 'consum', 0.0211, 'lps'),
	(359972, 124, '2015-01-15 00:08:50.000000', 'consum', 0.0212, 'lps'),
	(359973, 124, '2015-01-15 00:08:51.000000', 'consum', 0.0221, 'lps'),
	(359974, 124, '2015-01-15 00:08:52.000000', 'consum', 0.0214, 'lps'),
	(359975, 124, '2015-01-15 00:08:53.000000', 'consum', 0.0218, 'lps'),
	(359976, 124, '2015-01-15 00:08:54.000000', 'consum', 0.0216, 'lps'),
	(359977, 124, '2015-01-15 00:08:55.000000', 'consum', 0.0218, 'lps'),
	(359978, 124, '2015-01-15 00:08:56.000000', 'consum', 0.0211, 'lps'),
	(359979, 124, '2015-01-15 00:08:57.000000', 'consum', 0.0211, 'lps'),
	(359980, 124, '2015-01-15 00:08:58.000000', 'consum', 0.0215, 'lps'),
	(359981, 124, '2015-01-15 00:08:59.000000', 'consum', 0.0230, 'lps'),
	(359982, 124, '2015-01-15 00:09:00.000000', 'consum', 0.0229, 'lps'),
	(359983, 124, '2015-01-15 00:09:01.000000', 'consum', 0.0225, 'lps'),
	(359984, 124, '2015-01-15 00:09:02.000000', 'consum', 0.0227, 'lps'),
	(359985, 124, '2015-01-15 00:09:03.000000', 'consum', 0.0229, 'lps'),
	(359986, 124, '2015-01-15 00:09:04.000000', 'consum', 0.0231, 'lps'),
	(359987, 124, '2015-01-15 00:09:05.000000', 'consum', 0.0216, 'lps'),
	(359988, 124, '2015-01-15 00:09:06.000000', 'consum', 0.0222, 'lps'),
	(359989, 124, '2015-01-15 00:09:07.000000', 'consum', 0.0229, 'lps'),
	(359990, 124, '2015-01-15 00:09:08.000000', 'consum', 0.0226, 'lps'),
	(359991, 124, '2015-01-15 00:09:09.000000', 'consum', 0.0212, 'lps'),
	(359992, 124, '2015-01-15 00:09:10.000000', 'consum', 0.0216, 'lps'),
	(359993, 124, '2015-01-15 00:09:11.000000', 'consum', 0.0213, 'lps'),
	(359994, 124, '2015-01-15 00:09:12.000000', 'consum', 0.0228, 'lps'),
	(359995, 124, '2015-01-15 00:09:13.000000', 'consum', 0.0225, 'lps'),
	(359996, 124, '2015-01-15 00:09:14.000000', 'consum', 0.0211, 'lps'),
	(359997, 124, '2015-01-15 00:09:15.000000', 'consum', 0.0215, 'lps'),
	(359998, 124, '2015-01-15 00:09:16.000000', 'consum', 0.0212, 'lps'),
	(359999, 124, '2015-01-15 00:09:17.000000', 'consum', 0.0226, 'lps'),
	(360000, 124, '2015-01-15 00:09:18.000000', 'consum', 0.0217, 'lps'),
	(360001, 124, '2015-01-15 00:09:19.000000', 'consum', 0.0220, 'lps'),
	(360002, 124, '2015-01-15 00:09:20.000000', 'consum', 0.0218, 'lps'),
	(360003, 124, '2015-01-15 00:09:21.000000', 'consum', 0.0220, 'lps'),
	(360004, 124, '2015-01-15 00:09:22.000000', 'consum', 0.0214, 'lps'),
	(360005, 124, '2015-01-15 00:09:23.000000', 'consum', 0.0225, 'lps'),
	(360006, 124, '2015-01-15 00:09:24.000000', 'consum', 0.0226, 'lps'),
	(360007, 124, '2015-01-15 00:09:25.000000', 'consum', 0.0227, 'lps'),
	(360008, 124, '2015-01-15 00:09:26.000000', 'consum', 0.0224, 'lps'),
	(360009, 124, '2015-01-15 00:09:27.000000', 'consum', 0.0230, 'lps'),
	(360010, 124, '2015-01-15 00:09:28.000000', 'consum', 0.0224, 'lps'),
	(360011, 124, '2015-01-15 00:09:29.000000', 'consum', 0.0221, 'lps'),
	(360012, 124, '2015-01-15 00:09:30.000000', 'consum', 0.0223, 'lps'),
	(360013, 124, '2015-01-15 00:09:31.000000', 'consum', 0.0221, 'lps'),
	(360014, 124, '2015-01-15 00:09:32.000000', 'consum', 0.0228, 'lps'),
	(360015, 124, '2015-01-15 00:09:33.000000', 'consum', 0.0222, 'lps'),
	(360016, 124, '2015-01-15 00:09:34.000000', 'consum', 0.0217, 'lps'),
	(360017, 124, '2015-01-15 00:09:35.000000', 'consum', 0.0230, 'lps'),
	(360018, 124, '2015-01-15 00:09:36.000000', 'consum', 0.0223, 'lps'),
	(360019, 124, '2015-01-15 00:09:37.000000', 'consum', 0.0217, 'lps'),
	(360020, 124, '2015-01-15 00:09:38.000000', 'consum', 0.0229, 'lps'),
	(360021, 124, '2015-01-15 00:09:39.000000', 'consum', 0.0218, 'lps'),
	(360022, 124, '2015-01-15 00:09:40.000000', 'consum', 0.0214, 'lps'),
	(360023, 124, '2015-01-15 00:09:41.000000', 'consum', 0.0228, 'lps'),
	(360024, 124, '2015-01-15 00:09:42.000000', 'consum', 0.0225, 'lps'),
	(360025, 124, '2015-01-15 00:09:43.000000', 'consum', 0.0230, 'lps'),
	(360026, 124, '2015-01-15 00:09:44.000000', 'consum', 0.0223, 'lps'),
	(360027, 124, '2015-01-15 00:09:45.000000', 'consum', 0.0213, 'lps'),
	(360028, 124, '2015-01-15 00:09:46.000000', 'consum', 0.0211, 'lps'),
	(360029, 124, '2015-01-15 00:09:47.000000', 'consum', 0.0228, 'lps'),
	(360030, 124, '2015-01-15 00:09:48.000000', 'consum', 0.0211, 'lps'),
	(360031, 124, '2015-01-15 00:09:49.000000', 'consum', 0.0226, 'lps'),
	(360032, 124, '2015-01-15 00:09:50.000000', 'consum', 0.0222, 'lps'),
	(360033, 124, '2015-01-15 00:09:51.000000', 'consum', 0.0223, 'lps'),
	(360034, 124, '2015-01-15 00:09:52.000000', 'consum', 0.0217, 'lps'),
	(360035, 124, '2015-01-15 00:09:53.000000', 'consum', 0.0230, 'lps'),
	(360036, 124, '2015-01-15 00:09:54.000000', 'consum', 0.0224, 'lps'),
	(360037, 124, '2015-01-15 00:09:55.000000', 'consum', 0.0221, 'lps'),
	(360038, 124, '2015-01-15 00:09:56.000000', 'consum', 0.0224, 'lps'),
	(360039, 124, '2015-01-15 00:09:57.000000', 'consum', 0.0222, 'lps'),
	(360040, 124, '2015-01-15 00:09:58.000000', 'consum', 0.0210, 'lps'),
	(360041, 124, '2015-01-15 00:09:59.000000', 'consum', 0.0215, 'lps'),
	(360042, 124, '2015-01-15 00:10:00.000000', 'consum', 0.0217, 'lps'),
	(360043, 124, '2015-01-15 00:10:01.000000', 'consum', 0.0229, 'lps'),
	(360044, 124, '2015-01-15 00:10:02.000000', 'consum', 0.0220, 'lps'),
	(360045, 124, '2015-01-15 00:10:03.000000', 'consum', 0.0222, 'lps'),
	(360046, 124, '2015-01-15 00:10:04.000000', 'consum', 0.0222, 'lps'),
	(360047, 124, '2015-01-15 00:10:05.000000', 'consum', 0.0211, 'lps'),
	(360048, 124, '2015-01-15 00:10:06.000000', 'consum', 0.0223, 'lps'),
	(360049, 124, '2015-01-15 00:10:07.000000', 'consum', 0.0230, 'lps'),
	(360050, 124, '2015-01-15 00:10:08.000000', 'consum', 0.0226, 'lps'),
	(360051, 124, '2015-01-15 00:10:09.000000', 'consum', 0.0211, 'lps'),
	(360052, 124, '2015-01-15 00:10:10.000000', 'consum', 0.0210, 'lps'),
	(360053, 124, '2015-01-15 00:10:11.000000', 'consum', 0.0231, 'lps'),
	(360054, 124, '2015-01-15 00:10:12.000000', 'consum', 0.0228, 'lps'),
	(360055, 124, '2015-01-15 00:10:13.000000', 'consum', 0.0214, 'lps'),
	(360056, 124, '2015-01-15 00:10:14.000000', 'consum', 0.0222, 'lps'),
	(360057, 124, '2015-01-15 00:10:15.000000', 'consum', 0.0212, 'lps'),
	(360058, 124, '2015-01-15 00:10:16.000000', 'consum', 0.0230, 'lps'),
	(360059, 124, '2015-01-15 00:10:17.000000', 'consum', 0.0216, 'lps'),
	(360060, 124, '2015-01-15 00:10:18.000000', 'consum', 0.0223, 'lps'),
	(360061, 124, '2015-01-15 00:10:19.000000', 'consum', 0.0215, 'lps'),
	(360062, 124, '2015-01-15 00:10:20.000000', 'consum', 0.0219, 'lps'),
	(360063, 124, '2015-01-15 00:10:21.000000', 'consum', 0.0220, 'lps'),
	(360064, 124, '2015-01-15 00:10:22.000000', 'consum', 0.0210, 'lps'),
	(360065, 124, '2015-01-15 00:10:23.000000', 'consum', 0.0225, 'lps'),
	(360066, 124, '2015-01-15 00:10:24.000000', 'consum', 0.0218, 'lps'),
	(360067, 124, '2015-01-15 00:10:25.000000', 'consum', 0.0230, 'lps'),
	(360068, 124, '2015-01-15 00:10:26.000000', 'consum', 0.0219, 'lps'),
	(360069, 124, '2015-01-15 00:10:27.000000', 'consum', 0.0218, 'lps'),
	(360070, 124, '2015-01-15 00:10:28.000000', 'consum', 0.0223, 'lps'),
	(360071, 124, '2015-01-15 00:10:29.000000', 'consum', 0.0231, 'lps'),
	(360072, 124, '2015-01-15 00:10:30.000000', 'consum', 0.0212, 'lps'),
	(360073, 124, '2015-01-15 00:10:31.000000', 'consum', 0.0220, 'lps'),
	(360074, 124, '2015-01-15 00:10:32.000000', 'consum', 0.0212, 'lps'),
	(360075, 124, '2015-01-15 00:10:33.000000', 'consum', 0.0211, 'lps'),
	(360076, 124, '2015-01-15 00:10:34.000000', 'consum', 0.0231, 'lps'),
	(360077, 124, '2015-01-15 00:10:35.000000', 'consum', 0.0227, 'lps'),
	(360078, 124, '2015-01-15 00:10:36.000000', 'consum', 0.0230, 'lps'),
	(360079, 124, '2015-01-15 00:10:37.000000', 'consum', 0.0216, 'lps'),
	(360080, 124, '2015-01-15 00:10:38.000000', 'consum', 0.0227, 'lps'),
	(360081, 124, '2015-01-15 00:10:39.000000', 'consum', 0.0210, 'lps'),
	(360082, 124, '2015-01-15 00:10:40.000000', 'consum', 0.0225, 'lps'),
	(360083, 124, '2015-01-15 00:10:41.000000', 'consum', 0.0219, 'lps'),
	(360084, 124, '2015-01-15 00:10:42.000000', 'consum', 0.0211, 'lps'),
	(360085, 124, '2015-01-15 00:10:43.000000', 'consum', 0.0231, 'lps'),
	(360086, 124, '2015-01-15 00:10:44.000000', 'consum', 0.0224, 'lps'),
	(360087, 124, '2015-01-15 00:10:45.000000', 'consum', 0.0217, 'lps'),
	(360088, 124, '2015-01-15 00:10:46.000000', 'consum', 0.0227, 'lps'),
	(360089, 124, '2015-01-15 00:10:47.000000', 'consum', 0.0230, 'lps'),
	(360090, 124, '2015-01-15 00:10:48.000000', 'consum', 0.0214, 'lps'),
	(360091, 124, '2015-01-15 00:10:49.000000', 'consum', 0.0216, 'lps'),
	(360092, 124, '2015-01-15 00:10:50.000000', 'consum', 0.0228, 'lps'),
	(360093, 124, '2015-01-15 00:10:51.000000', 'consum', 0.0215, 'lps'),
	(360094, 124, '2015-01-15 00:10:52.000000', 'consum', 0.0228, 'lps'),
	(360095, 124, '2015-01-15 00:10:53.000000', 'consum', 0.0217, 'lps'),
	(360096, 124, '2015-01-15 00:10:54.000000', 'consum', 0.0213, 'lps'),
	(360097, 124, '2015-01-15 00:10:55.000000', 'consum', 0.0230, 'lps'),
	(360098, 124, '2015-01-15 00:10:56.000000', 'consum', 0.0211, 'lps'),
	(360099, 124, '2015-01-15 00:10:57.000000', 'consum', 0.0221, 'lps'),
	(360100, 124, '2015-01-15 00:10:58.000000', 'consum', 0.0217, 'lps'),
	(360101, 124, '2015-01-15 00:10:59.000000', 'consum', 0.0216, 'lps'),
	(360102, 124, '2015-01-15 00:11:00.000000', 'consum', 0.0217, 'lps'),
	(360103, 124, '2015-01-15 00:11:01.000000', 'consum', 0.0227, 'lps'),
	(360104, 124, '2015-01-15 00:11:02.000000', 'consum', 0.0210, 'lps'),
	(360105, 124, '2015-01-15 00:11:03.000000', 'consum', 0.0224, 'lps'),
	(360106, 124, '2015-01-15 00:11:04.000000', 'consum', 0.0216, 'lps'),
	(360107, 124, '2015-01-15 00:11:05.000000', 'consum', 0.0222, 'lps'),
	(360108, 124, '2015-01-15 00:11:06.000000', 'consum', 0.0229, 'lps'),
	(360109, 124, '2015-01-15 00:11:07.000000', 'consum', 0.0227, 'lps'),
	(360110, 124, '2015-01-15 00:11:08.000000', 'consum', 0.0214, 'lps'),
	(360111, 124, '2015-01-15 00:11:09.000000', 'consum', 0.0225, 'lps'),
	(360112, 124, '2015-01-15 00:11:10.000000', 'consum', 0.0229, 'lps'),
	(360113, 124, '2015-01-15 00:11:11.000000', 'consum', 0.0216, 'lps'),
	(360114, 124, '2015-01-15 00:11:12.000000', 'consum', 0.0228, 'lps'),
	(360115, 124, '2015-01-15 00:11:13.000000', 'consum', 0.0218, 'lps'),
	(360116, 124, '2015-01-15 00:11:14.000000', 'consum', 0.0219, 'lps'),
	(360117, 124, '2015-01-15 00:11:15.000000', 'consum', 0.0229, 'lps'),
	(360118, 124, '2015-01-15 00:11:16.000000', 'consum', 0.0213, 'lps'),
	(360119, 124, '2015-01-15 00:11:17.000000', 'consum', 0.0213, 'lps'),
	(360120, 124, '2015-01-15 00:11:18.000000', 'consum', 0.0214, 'lps'),
	(360121, 124, '2015-01-15 00:11:19.000000', 'consum', 0.0224, 'lps'),
	(360122, 124, '2015-01-15 00:11:20.000000', 'consum', 0.0226, 'lps'),
	(360123, 124, '2015-01-15 00:11:21.000000', 'consum', 0.0224, 'lps'),
	(360124, 124, '2015-01-15 00:11:22.000000', 'consum', 0.0211, 'lps'),
	(360125, 124, '2015-01-15 00:11:23.000000', 'consum', 0.0216, 'lps'),
	(360126, 124, '2015-01-15 00:11:24.000000', 'consum', 0.0215, 'lps'),
	(360127, 124, '2015-01-15 00:11:25.000000', 'consum', 0.0220, 'lps'),
	(360128, 124, '2015-01-15 00:11:26.000000', 'consum', 0.0225, 'lps'),
	(360129, 124, '2015-01-15 00:11:27.000000', 'consum', 0.0230, 'lps'),
	(360130, 124, '2015-01-15 00:11:28.000000', 'consum', 0.0222, 'lps'),
	(360131, 124, '2015-01-15 00:11:29.000000', 'consum', 0.0231, 'lps'),
	(360132, 124, '2015-01-15 00:11:30.000000', 'consum', 0.0217, 'lps'),
	(360133, 124, '2015-01-15 00:11:31.000000', 'consum', 0.0224, 'lps'),
	(360134, 124, '2015-01-15 00:11:32.000000', 'consum', 0.0214, 'lps'),
	(360135, 124, '2015-01-15 00:11:33.000000', 'consum', 0.0213, 'lps'),
	(360136, 124, '2015-01-15 00:11:34.000000', 'consum', 0.0214, 'lps'),
	(360137, 124, '2015-01-15 00:11:35.000000', 'consum', 0.0222, 'lps'),
	(360138, 124, '2015-01-15 00:11:36.000000', 'consum', 0.0216, 'lps'),
	(360139, 124, '2015-01-15 00:11:37.000000', 'consum', 0.0223, 'lps'),
	(360140, 124, '2015-01-15 00:11:38.000000', 'consum', 0.0215, 'lps'),
	(360141, 124, '2015-01-15 00:11:39.000000', 'consum', 0.0220, 'lps'),
	(360142, 124, '2015-01-15 00:11:40.000000', 'consum', 0.0222, 'lps'),
	(360143, 124, '2015-01-15 00:11:41.000000', 'consum', 0.0217, 'lps'),
	(360144, 124, '2015-01-15 00:11:42.000000', 'consum', 0.0231, 'lps'),
	(360145, 124, '2015-01-15 00:11:43.000000', 'consum', 0.0230, 'lps'),
	(360146, 124, '2015-01-15 00:11:44.000000', 'consum', 0.0225, 'lps'),
	(360147, 124, '2015-01-15 00:11:45.000000', 'consum', 0.0224, 'lps'),
	(360148, 124, '2015-01-15 00:11:46.000000', 'consum', 0.0215, 'lps'),
	(360149, 124, '2015-01-15 00:11:47.000000', 'consum', 0.0214, 'lps'),
	(360150, 124, '2015-01-15 00:11:48.000000', 'consum', 0.0215, 'lps'),
	(360151, 124, '2015-01-15 00:11:49.000000', 'consum', 0.0223, 'lps'),
	(360152, 124, '2015-01-15 00:11:50.000000', 'consum', 0.0216, 'lps'),
	(360153, 124, '2015-01-15 00:11:51.000000', 'consum', 0.0225, 'lps'),
	(360154, 124, '2015-01-15 00:11:52.000000', 'consum', 0.0223, 'lps'),
	(360155, 124, '2015-01-15 00:11:53.000000', 'consum', 0.0231, 'lps'),
	(360156, 124, '2015-01-15 00:11:54.000000', 'consum', 0.0212, 'lps'),
	(360157, 124, '2015-01-15 00:11:55.000000', 'consum', 0.0221, 'lps'),
	(360158, 124, '2015-01-15 00:11:56.000000', 'consum', 0.0215, 'lps'),
	(360159, 124, '2015-01-15 00:11:57.000000', 'consum', 0.0227, 'lps'),
	(360160, 124, '2015-01-15 00:11:58.000000', 'consum', 0.0214, 'lps'),
	(360161, 124, '2015-01-15 00:11:59.000000', 'consum', 0.0222, 'lps'),
	(360162, 124, '2015-01-15 00:12:00.000000', 'consum', 0.0215, 'lps'),
	(360163, 124, '2015-01-15 00:12:01.000000', 'consum', 0.0222, 'lps'),
	(360164, 124, '2015-01-15 00:12:02.000000', 'consum', 0.0210, 'lps'),
	(360165, 124, '2015-01-15 00:12:03.000000', 'consum', 0.0219, 'lps'),
	(360166, 124, '2015-01-15 00:12:04.000000', 'consum', 0.0213, 'lps'),
	(360167, 124, '2015-01-15 00:12:05.000000', 'consum', 0.0220, 'lps'),
	(360168, 124, '2015-01-15 00:12:06.000000', 'consum', 0.0230, 'lps'),
	(360169, 124, '2015-01-15 00:12:07.000000', 'consum', 0.0212, 'lps'),
	(360170, 124, '2015-01-15 00:12:08.000000', 'consum', 0.0229, 'lps'),
	(360171, 124, '2015-01-15 00:12:09.000000', 'consum', 0.0231, 'lps'),
	(360172, 124, '2015-01-15 00:12:10.000000', 'consum', 0.0214, 'lps'),
	(360173, 124, '2015-01-15 00:12:11.000000', 'consum', 0.0212, 'lps'),
	(360174, 124, '2015-01-15 00:12:12.000000', 'consum', 0.0211, 'lps'),
	(360175, 124, '2015-01-15 00:12:13.000000', 'consum', 0.0229, 'lps'),
	(360176, 124, '2015-01-15 00:12:14.000000', 'consum', 0.0217, 'lps'),
	(360177, 124, '2015-01-15 00:12:15.000000', 'consum', 0.0231, 'lps'),
	(360178, 124, '2015-01-15 00:12:16.000000', 'consum', 0.0231, 'lps'),
	(360179, 124, '2015-01-15 00:12:17.000000', 'consum', 0.0228, 'lps'),
	(360180, 124, '2015-01-15 00:12:18.000000', 'consum', 0.0216, 'lps'),
	(360181, 124, '2015-01-15 00:12:19.000000', 'consum', 0.0230, 'lps'),
	(360182, 124, '2015-01-15 00:12:20.000000', 'consum', 0.0228, 'lps'),
	(360183, 124, '2015-01-15 00:12:21.000000', 'consum', 0.0218, 'lps'),
	(360184, 124, '2015-01-15 00:12:22.000000', 'consum', 0.0218, 'lps'),
	(360185, 124, '2015-01-15 00:12:23.000000', 'consum', 0.0228, 'lps'),
	(360186, 124, '2015-01-15 00:12:24.000000', 'consum', 0.0211, 'lps'),
	(360187, 124, '2015-01-15 00:12:25.000000', 'consum', 0.0227, 'lps'),
	(360188, 124, '2015-01-15 00:12:26.000000', 'consum', 0.0227, 'lps'),
	(360189, 124, '2015-01-15 00:12:27.000000', 'consum', 0.0224, 'lps'),
	(360190, 124, '2015-01-15 00:12:28.000000', 'consum', 0.0227, 'lps'),
	(360191, 124, '2015-01-15 00:12:29.000000', 'consum', 0.0231, 'lps'),
	(360192, 124, '2015-01-15 00:12:30.000000', 'consum', 0.0221, 'lps'),
	(360193, 124, '2015-01-15 00:12:31.000000', 'consum', 0.0223, 'lps'),
	(360194, 124, '2015-01-15 00:12:32.000000', 'consum', 0.0222, 'lps'),
	(360195, 124, '2015-01-15 00:12:33.000000', 'consum', 0.0211, 'lps'),
	(360196, 124, '2015-01-15 00:12:34.000000', 'consum', 0.0222, 'lps'),
	(360197, 124, '2015-01-15 00:12:35.000000', 'consum', 0.0225, 'lps'),
	(360198, 124, '2015-01-15 00:12:36.000000', 'consum', 0.0227, 'lps'),
	(360199, 124, '2015-01-15 00:12:37.000000', 'consum', 0.0229, 'lps'),
	(360200, 124, '2015-01-15 00:12:38.000000', 'consum', 0.0230, 'lps'),
	(360201, 124, '2015-01-15 00:12:39.000000', 'consum', 0.0212, 'lps'),
	(360202, 124, '2015-01-15 00:12:40.000000', 'consum', 0.0224, 'lps'),
	(360203, 124, '2015-01-15 00:12:41.000000', 'consum', 0.0230, 'lps'),
	(360204, 124, '2015-01-15 00:12:42.000000', 'consum', 0.0226, 'lps'),
	(360205, 124, '2015-01-15 00:12:43.000000', 'consum', 0.0210, 'lps'),
	(360206, 124, '2015-01-15 00:12:44.000000', 'consum', 0.0227, 'lps'),
	(360207, 124, '2015-01-15 00:12:45.000000', 'consum', 0.0229, 'lps'),
	(360208, 124, '2015-01-15 00:12:46.000000', 'consum', 0.0231, 'lps'),
	(360209, 124, '2015-01-15 00:12:47.000000', 'consum', 0.0215, 'lps'),
	(360210, 124, '2015-01-15 00:12:48.000000', 'consum', 0.0219, 'lps'),
	(360211, 124, '2015-01-15 00:12:49.000000', 'consum', 0.0215, 'lps'),
	(360212, 124, '2015-01-15 00:12:50.000000', 'consum', 0.0211, 'lps'),
	(360213, 124, '2015-01-15 00:12:51.000000', 'consum', 0.0223, 'lps'),
	(360214, 124, '2015-01-15 00:12:52.000000', 'consum', 0.0229, 'lps'),
	(360215, 124, '2015-01-15 00:12:53.000000', 'consum', 0.0220, 'lps'),
	(360216, 124, '2015-01-15 00:12:54.000000', 'consum', 0.0226, 'lps'),
	(360217, 124, '2015-01-15 00:12:55.000000', 'consum', 0.0216, 'lps'),
	(360218, 124, '2015-01-15 00:12:56.000000', 'consum', 0.0214, 'lps'),
	(360219, 124, '2015-01-15 00:12:57.000000', 'consum', 0.0213, 'lps'),
	(360220, 124, '2015-01-15 00:12:58.000000', 'consum', 0.0212, 'lps'),
	(360221, 124, '2015-01-15 00:12:59.000000', 'consum', 0.0215, 'lps'),
	(360222, 124, '2015-01-15 00:13:00.000000', 'consum', 0.0226, 'lps'),
	(360223, 124, '2015-01-15 00:13:01.000000', 'consum', 0.0212, 'lps'),
	(360224, 124, '2015-01-15 00:13:02.000000', 'consum', 0.0216, 'lps'),
	(360225, 124, '2015-01-15 00:13:03.000000', 'consum', 0.0211, 'lps'),
	(360226, 124, '2015-01-15 00:13:04.000000', 'consum', 0.0218, 'lps'),
	(360227, 124, '2015-01-15 00:13:05.000000', 'consum', 0.0229, 'lps'),
	(360228, 124, '2015-01-15 00:13:06.000000', 'consum', 0.0215, 'lps'),
	(360229, 124, '2015-01-15 00:13:07.000000', 'consum', 0.0223, 'lps'),
	(360230, 124, '2015-01-15 00:13:08.000000', 'consum', 0.0217, 'lps'),
	(360231, 124, '2015-01-15 00:13:09.000000', 'consum', 0.0226, 'lps'),
	(360232, 124, '2015-01-15 00:13:10.000000', 'consum', 0.0226, 'lps'),
	(360233, 124, '2015-01-15 00:13:11.000000', 'consum', 0.0222, 'lps'),
	(360234, 124, '2015-01-15 00:13:12.000000', 'consum', 0.0221, 'lps'),
	(360235, 124, '2015-01-15 00:13:13.000000', 'consum', 0.0229, 'lps'),
	(360236, 124, '2015-01-15 00:13:14.000000', 'consum', 0.0229, 'lps'),
	(360237, 124, '2015-01-15 00:13:15.000000', 'consum', 0.0226, 'lps'),
	(360238, 124, '2015-01-15 00:13:16.000000', 'consum', 0.0214, 'lps'),
	(360239, 124, '2015-01-15 00:13:17.000000', 'consum', 0.0225, 'lps'),
	(360240, 124, '2015-01-15 00:13:18.000000', 'consum', 0.0229, 'lps'),
	(360241, 124, '2015-01-15 00:13:19.000000', 'consum', 0.0218, 'lps'),
	(360242, 124, '2015-01-15 00:13:20.000000', 'consum', 0.0215, 'lps'),
	(360243, 124, '2015-01-15 00:13:21.000000', 'consum', 0.0231, 'lps'),
	(360244, 124, '2015-01-15 00:13:22.000000', 'consum', 0.0216, 'lps'),
	(360245, 124, '2015-01-15 00:13:23.000000', 'consum', 0.0220, 'lps'),
	(360246, 124, '2015-01-15 00:13:24.000000', 'consum', 0.0222, 'lps'),
	(360247, 124, '2015-01-15 00:13:25.000000', 'consum', 0.0219, 'lps'),
	(360248, 124, '2015-01-15 00:13:26.000000', 'consum', 0.0220, 'lps'),
	(360249, 124, '2015-01-15 00:13:27.000000', 'consum', 0.0231, 'lps'),
	(360250, 124, '2015-01-15 00:13:28.000000', 'consum', 0.0219, 'lps'),
	(360251, 124, '2015-01-15 00:13:29.000000', 'consum', 0.0217, 'lps'),
	(360252, 124, '2015-01-15 00:13:30.000000', 'consum', 0.0216, 'lps'),
	(360253, 124, '2015-01-15 00:13:31.000000', 'consum', 0.0222, 'lps'),
	(360254, 124, '2015-01-15 00:13:32.000000', 'consum', 0.0230, 'lps'),
	(360255, 124, '2015-01-15 00:13:33.000000', 'consum', 0.0210, 'lps'),
	(360256, 124, '2015-01-15 00:13:34.000000', 'consum', 0.0214, 'lps'),
	(360257, 124, '2015-01-15 00:13:35.000000', 'consum', 0.0230, 'lps'),
	(360258, 124, '2015-01-15 00:13:36.000000', 'consum', 0.0211, 'lps'),
	(360259, 124, '2015-01-15 00:13:37.000000', 'consum', 0.0223, 'lps'),
	(360260, 124, '2015-01-15 00:13:38.000000', 'consum', 0.0228, 'lps'),
	(360261, 124, '2015-01-15 00:13:39.000000', 'consum', 0.0217, 'lps'),
	(360262, 124, '2015-01-15 00:13:40.000000', 'consum', 0.0215, 'lps'),
	(360263, 124, '2015-01-15 00:13:41.000000', 'consum', 0.0214, 'lps'),
	(360264, 124, '2015-01-15 00:13:42.000000', 'consum', 0.0213, 'lps'),
	(360265, 124, '2015-01-15 00:13:43.000000', 'consum', 0.0217, 'lps'),
	(360266, 124, '2015-01-15 00:13:44.000000', 'consum', 0.0211, 'lps'),
	(360267, 124, '2015-01-15 00:13:45.000000', 'consum', 0.0218, 'lps'),
	(360268, 124, '2015-01-15 00:13:46.000000', 'consum', 0.0227, 'lps'),
	(360269, 124, '2015-01-15 00:13:47.000000', 'consum', 0.0226, 'lps'),
	(360270, 124, '2015-01-15 00:13:48.000000', 'consum', 0.0217, 'lps'),
	(360271, 124, '2015-01-15 00:13:49.000000', 'consum', 0.0221, 'lps'),
	(360272, 124, '2015-01-15 00:13:50.000000', 'consum', 0.0220, 'lps'),
	(360273, 124, '2015-01-15 00:13:51.000000', 'consum', 0.0230, 'lps'),
	(360274, 124, '2015-01-15 00:13:52.000000', 'consum', 0.0213, 'lps'),
	(360275, 124, '2015-01-15 00:13:53.000000', 'consum', 0.0231, 'lps'),
	(360276, 124, '2015-01-15 00:13:54.000000', 'consum', 0.0219, 'lps'),
	(360277, 124, '2015-01-15 00:13:55.000000', 'consum', 0.0213, 'lps'),
	(360278, 124, '2015-01-15 00:13:56.000000', 'consum', 0.0223, 'lps'),
	(360279, 124, '2015-01-15 00:13:57.000000', 'consum', 0.0221, 'lps'),
	(360280, 124, '2015-01-15 00:13:58.000000', 'consum', 0.0229, 'lps'),
	(360281, 124, '2015-01-15 00:13:59.000000', 'consum', 0.0227, 'lps'),
	(360282, 124, '2015-01-15 00:14:00.000000', 'consum', 0.0216, 'lps'),
	(360283, 124, '2015-01-15 00:14:01.000000', 'consum', 0.0213, 'lps'),
	(360284, 124, '2015-01-15 00:14:02.000000', 'consum', 0.0230, 'lps'),
	(360285, 124, '2015-01-15 00:14:03.000000', 'consum', 0.0212, 'lps'),
	(360286, 124, '2015-01-15 00:14:04.000000', 'consum', 0.0228, 'lps'),
	(360287, 124, '2015-01-15 00:14:05.000000', 'consum', 0.0229, 'lps'),
	(360288, 124, '2015-01-15 00:14:06.000000', 'consum', 0.0230, 'lps'),
	(360289, 124, '2015-01-15 00:14:07.000000', 'consum', 0.0230, 'lps'),
	(360290, 124, '2015-01-15 00:14:08.000000', 'consum', 0.0229, 'lps'),
	(360291, 124, '2015-01-15 00:14:09.000000', 'consum', 0.0222, 'lps'),
	(360292, 124, '2015-01-15 00:14:10.000000', 'consum', 0.0215, 'lps'),
	(360293, 124, '2015-01-15 00:14:11.000000', 'consum', 0.0223, 'lps'),
	(360294, 124, '2015-01-15 00:14:12.000000', 'consum', 0.0216, 'lps'),
	(360295, 124, '2015-01-15 00:14:13.000000', 'consum', 0.0225, 'lps'),
	(360296, 124, '2015-01-15 00:14:14.000000', 'consum', 0.0220, 'lps'),
	(360297, 124, '2015-01-15 00:14:15.000000', 'consum', 0.0218, 'lps'),
	(360298, 124, '2015-01-15 00:14:16.000000', 'consum', 0.0218, 'lps'),
	(360299, 124, '2015-01-15 00:14:17.000000', 'consum', 0.0227, 'lps'),
	(360300, 124, '2015-01-15 00:14:18.000000', 'consum', 0.0228, 'lps'),
	(360301, 124, '2015-01-15 00:14:19.000000', 'consum', 0.0226, 'lps'),
	(360302, 124, '2015-01-15 00:14:20.000000', 'consum', 0.0214, 'lps'),
	(360303, 124, '2015-01-15 00:14:21.000000', 'consum', 0.0227, 'lps'),
	(360304, 124, '2015-01-15 00:14:22.000000', 'consum', 0.0218, 'lps'),
	(360305, 124, '2015-01-15 00:14:23.000000', 'consum', 0.0222, 'lps'),
	(360306, 124, '2015-01-15 00:14:24.000000', 'consum', 0.0224, 'lps'),
	(360307, 124, '2015-01-15 00:14:25.000000', 'consum', 0.0224, 'lps'),
	(360308, 124, '2015-01-15 00:14:26.000000', 'consum', 0.0214, 'lps'),
	(360309, 124, '2015-01-15 00:14:27.000000', 'consum', 0.0212, 'lps'),
	(360310, 124, '2015-01-15 00:14:28.000000', 'consum', 0.0230, 'lps'),
	(360311, 124, '2015-01-15 00:14:29.000000', 'consum', 0.0217, 'lps'),
	(360312, 124, '2015-01-15 00:14:30.000000', 'consum', 0.0231, 'lps'),
	(360313, 124, '2015-01-15 00:14:31.000000', 'consum', 0.0227, 'lps'),
	(360314, 124, '2015-01-15 00:14:32.000000', 'consum', 0.0211, 'lps'),
	(360315, 124, '2015-01-15 00:14:33.000000', 'consum', 0.0231, 'lps'),
	(360316, 124, '2015-01-15 00:14:34.000000', 'consum', 0.0226, 'lps'),
	(360317, 124, '2015-01-15 00:14:35.000000', 'consum', 0.0226, 'lps'),
	(360318, 124, '2015-01-15 00:14:36.000000', 'consum', 0.0220, 'lps'),
	(360319, 124, '2015-01-15 00:14:37.000000', 'consum', 0.0215, 'lps'),
	(360320, 124, '2015-01-15 00:14:38.000000', 'consum', 0.0225, 'lps'),
	(360321, 124, '2015-01-15 00:14:39.000000', 'consum', 0.0226, 'lps'),
	(360322, 124, '2015-01-15 00:14:40.000000', 'consum', 0.0226, 'lps'),
	(360323, 124, '2015-01-15 00:14:41.000000', 'consum', 0.0219, 'lps'),
	(360324, 124, '2015-01-15 00:14:42.000000', 'consum', 0.0231, 'lps'),
	(360325, 124, '2015-01-15 00:14:43.000000', 'consum', 0.0221, 'lps'),
	(360326, 124, '2015-01-15 00:14:44.000000', 'consum', 0.0225, 'lps'),
	(360327, 124, '2015-01-15 00:14:45.000000', 'consum', 0.0229, 'lps'),
	(360328, 124, '2015-01-15 00:14:46.000000', 'consum', 0.0216, 'lps'),
	(360329, 124, '2015-01-15 00:14:47.000000', 'consum', 0.0230, 'lps'),
	(360330, 124, '2015-01-15 00:14:48.000000', 'consum', 0.0224, 'lps'),
	(360331, 124, '2015-01-15 00:14:49.000000', 'consum', 0.0222, 'lps'),
	(360332, 124, '2015-01-15 00:14:50.000000', 'consum', 0.0228, 'lps'),
	(360333, 124, '2015-01-15 00:14:51.000000', 'consum', 0.0221, 'lps'),
	(360334, 124, '2015-01-15 00:14:52.000000', 'consum', 0.0213, 'lps'),
	(360335, 124, '2015-01-15 00:14:53.000000', 'consum', 0.0213, 'lps'),
	(360336, 124, '2015-01-15 00:14:54.000000', 'consum', 0.0217, 'lps'),
	(360337, 124, '2015-01-15 00:14:55.000000', 'consum', 0.0215, 'lps'),
	(360338, 124, '2015-01-15 00:14:56.000000', 'consum', 0.0214, 'lps'),
	(360339, 124, '2015-01-15 00:14:57.000000', 'consum', 0.0215, 'lps'),
	(360340, 124, '2015-01-15 00:14:58.000000', 'consum', 0.0223, 'lps'),
	(360341, 124, '2015-01-15 00:14:59.000000', 'consum', 0.0215, 'lps'),
	(360342, 124, '2015-01-15 00:15:00.000000', 'consum', 0.0221, 'lps'),
	(360343, 124, '2015-01-15 00:15:01.000000', 'consum', 0.0229, 'lps'),
	(360344, 124, '2015-01-15 00:15:02.000000', 'consum', 0.0230, 'lps'),
	(360345, 124, '2015-01-15 00:15:03.000000', 'consum', 0.0229, 'lps'),
	(360346, 124, '2015-01-15 00:15:04.000000', 'consum', 0.0223, 'lps'),
	(360347, 124, '2015-01-15 00:15:05.000000', 'consum', 0.0218, 'lps'),
	(360348, 124, '2015-01-15 00:15:06.000000', 'consum', 0.0210, 'lps'),
	(360349, 124, '2015-01-15 00:15:07.000000', 'consum', 0.0212, 'lps'),
	(360350, 124, '2015-01-15 00:15:08.000000', 'consum', 0.0220, 'lps'),
	(360351, 124, '2015-01-15 00:15:09.000000', 'consum', 0.0230, 'lps'),
	(360352, 124, '2015-01-15 00:15:10.000000', 'consum', 0.0217, 'lps'),
	(360353, 124, '2015-01-15 00:15:11.000000', 'consum', 0.0230, 'lps'),
	(360354, 124, '2015-01-15 00:15:12.000000', 'consum', 0.0224, 'lps'),
	(360355, 124, '2015-01-15 00:15:13.000000', 'consum', 0.0218, 'lps'),
	(360356, 124, '2015-01-15 00:15:14.000000', 'consum', 0.0230, 'lps'),
	(360357, 124, '2015-01-15 00:15:15.000000', 'consum', 0.0221, 'lps'),
	(360358, 124, '2015-01-15 00:15:16.000000', 'consum', 0.0229, 'lps'),
	(360359, 124, '2015-01-15 00:15:17.000000', 'consum', 0.0226, 'lps'),
	(360360, 124, '2015-01-15 00:15:18.000000', 'consum', 0.0212, 'lps'),
	(360361, 124, '2015-01-15 00:15:19.000000', 'consum', 0.0216, 'lps'),
	(360362, 124, '2015-01-15 00:15:20.000000', 'consum', 0.0212, 'lps'),
	(360363, 124, '2015-01-15 00:15:21.000000', 'consum', 0.0225, 'lps'),
	(360364, 124, '2015-01-15 00:15:22.000000', 'consum', 0.0213, 'lps'),
	(360365, 124, '2015-01-15 00:15:23.000000', 'consum', 0.0224, 'lps'),
	(360366, 124, '2015-01-15 00:15:24.000000', 'consum', 0.0229, 'lps'),
	(360367, 124, '2015-01-15 00:15:25.000000', 'consum', 0.0220, 'lps'),
	(360368, 124, '2015-01-15 00:15:26.000000', 'consum', 0.0223, 'lps'),
	(360369, 124, '2015-01-15 00:15:27.000000', 'consum', 0.0226, 'lps'),
	(360370, 124, '2015-01-15 00:15:28.000000', 'consum', 0.0230, 'lps'),
	(360371, 124, '2015-01-15 00:15:29.000000', 'consum', 0.0219, 'lps'),
	(360372, 124, '2015-01-15 00:15:30.000000', 'consum', 0.0215, 'lps'),
	(360373, 124, '2015-01-15 00:15:31.000000', 'consum', 0.0210, 'lps'),
	(360374, 124, '2015-01-15 00:15:32.000000', 'consum', 0.0219, 'lps'),
	(360375, 124, '2015-01-15 00:15:33.000000', 'consum', 0.0231, 'lps'),
	(360376, 124, '2015-01-15 00:15:34.000000', 'consum', 0.0223, 'lps'),
	(360377, 124, '2015-01-15 00:15:35.000000', 'consum', 0.0211, 'lps'),
	(360378, 124, '2015-01-15 00:15:36.000000', 'consum', 0.0221, 'lps'),
	(360379, 124, '2015-01-15 00:15:37.000000', 'consum', 0.0218, 'lps'),
	(360380, 124, '2015-01-15 00:15:38.000000', 'consum', 0.0216, 'lps'),
	(360381, 124, '2015-01-15 00:15:39.000000', 'consum', 0.0220, 'lps'),
	(360382, 124, '2015-01-15 00:15:40.000000', 'consum', 0.0220, 'lps'),
	(360383, 124, '2015-01-15 00:15:41.000000', 'consum', 0.0228, 'lps'),
	(360384, 124, '2015-01-15 00:15:42.000000', 'consum', 0.0227, 'lps'),
	(360385, 124, '2015-01-15 00:15:43.000000', 'consum', 0.0221, 'lps'),
	(360386, 124, '2015-01-15 00:15:44.000000', 'consum', 0.0215, 'lps'),
	(360387, 124, '2015-01-15 00:15:45.000000', 'consum', 0.0222, 'lps'),
	(360388, 124, '2015-01-15 00:15:46.000000', 'consum', 0.0213, 'lps'),
	(360389, 124, '2015-01-15 00:15:47.000000', 'consum', 0.0231, 'lps'),
	(360390, 124, '2015-01-15 00:15:48.000000', 'consum', 0.0221, 'lps'),
	(360391, 124, '2015-01-15 00:15:49.000000', 'consum', 0.0224, 'lps'),
	(360392, 124, '2015-01-15 00:15:50.000000', 'consum', 0.0224, 'lps'),
	(360393, 124, '2015-01-15 00:15:51.000000', 'consum', 0.0217, 'lps'),
	(360394, 124, '2015-01-15 00:15:52.000000', 'consum', 0.0225, 'lps'),
	(360395, 124, '2015-01-15 00:15:53.000000', 'consum', 0.0221, 'lps'),
	(360396, 124, '2015-01-15 00:15:54.000000', 'consum', 0.0223, 'lps'),
	(360397, 124, '2015-01-15 00:15:55.000000', 'consum', 0.0217, 'lps'),
	(360398, 124, '2015-01-15 00:15:56.000000', 'consum', 0.0230, 'lps'),
	(360399, 124, '2015-01-15 00:15:57.000000', 'consum', 0.0221, 'lps'),
	(360400, 124, '2015-01-15 00:15:58.000000', 'consum', 0.0231, 'lps'),
	(360401, 124, '2015-01-15 00:15:59.000000', 'consum', 0.0215, 'lps'),
	(360402, 124, '2015-01-15 00:16:00.000000', 'consum', 0.0215, 'lps'),
	(360403, 124, '2015-01-15 00:16:01.000000', 'consum', 0.0220, 'lps'),
	(360404, 124, '2015-01-15 00:16:02.000000', 'consum', 0.0225, 'lps'),
	(360405, 124, '2015-01-15 00:16:03.000000', 'consum', 0.0212, 'lps'),
	(360406, 124, '2015-01-15 00:16:04.000000', 'consum', 0.0220, 'lps'),
	(360407, 124, '2015-01-15 00:16:05.000000', 'consum', 0.0210, 'lps'),
	(360408, 124, '2015-01-15 00:16:06.000000', 'consum', 0.0226, 'lps'),
	(360409, 124, '2015-01-15 00:16:07.000000', 'consum', 0.0225, 'lps'),
	(360410, 124, '2015-01-15 00:16:08.000000', 'consum', 0.0212, 'lps'),
	(360411, 124, '2015-01-15 00:16:09.000000', 'consum', 0.0222, 'lps'),
	(360412, 124, '2015-01-15 00:16:10.000000', 'consum', 0.0221, 'lps'),
	(360413, 124, '2015-01-15 00:16:11.000000', 'consum', 0.0227, 'lps'),
	(360414, 124, '2015-01-15 00:16:12.000000', 'consum', 0.0220, 'lps'),
	(360415, 124, '2015-01-15 00:16:13.000000', 'consum', 0.0210, 'lps'),
	(360416, 124, '2015-01-15 00:16:14.000000', 'consum', 0.0222, 'lps'),
	(360417, 124, '2015-01-15 00:16:15.000000', 'consum', 0.0230, 'lps'),
	(360418, 124, '2015-01-15 00:16:16.000000', 'consum', 0.0229, 'lps'),
	(360419, 124, '2015-01-15 00:16:17.000000', 'consum', 0.0222, 'lps'),
	(360420, 124, '2015-01-15 00:16:18.000000', 'consum', 0.0214, 'lps'),
	(360421, 124, '2015-01-15 00:16:19.000000', 'consum', 0.0215, 'lps'),
	(360422, 124, '2015-01-15 00:16:20.000000', 'consum', 0.0226, 'lps'),
	(360423, 124, '2015-01-15 00:16:21.000000', 'consum', 0.0231, 'lps'),
	(360424, 124, '2015-01-15 00:16:22.000000', 'consum', 0.0224, 'lps'),
	(360425, 124, '2015-01-15 00:16:23.000000', 'consum', 0.0219, 'lps'),
	(360426, 124, '2015-01-15 00:16:24.000000', 'consum', 0.0212, 'lps'),
	(360427, 124, '2015-01-15 00:16:25.000000', 'consum', 0.0216, 'lps'),
	(360428, 124, '2015-01-15 00:16:26.000000', 'consum', 0.0213, 'lps'),
	(360429, 124, '2015-01-15 00:16:27.000000', 'consum', 0.0230, 'lps'),
	(360430, 124, '2015-01-15 00:16:28.000000', 'consum', 0.0214, 'lps'),
	(360431, 124, '2015-01-15 00:16:29.000000', 'consum', 0.0215, 'lps'),
	(360432, 124, '2015-01-15 00:16:30.000000', 'consum', 0.0224, 'lps'),
	(360433, 124, '2015-01-15 00:16:31.000000', 'consum', 0.0222, 'lps'),
	(360434, 124, '2015-01-15 00:16:32.000000', 'consum', 0.0227, 'lps'),
	(360435, 124, '2015-01-15 00:16:33.000000', 'consum', 0.0216, 'lps'),
	(360436, 124, '2015-01-15 00:16:34.000000', 'consum', 0.0213, 'lps'),
	(360437, 124, '2015-01-15 00:16:35.000000', 'consum', 0.0229, 'lps'),
	(360438, 124, '2015-01-15 00:16:36.000000', 'consum', 0.0231, 'lps'),
	(360439, 124, '2015-01-15 00:16:37.000000', 'consum', 0.0213, 'lps'),
	(360440, 124, '2015-01-15 00:16:38.000000', 'consum', 0.0230, 'lps'),
	(360441, 124, '2015-01-15 00:16:39.000000', 'consum', 0.0211, 'lps'),
	(360442, 124, '2015-01-15 00:16:40.000000', 'consum', 0.0223, 'lps'),
	(360443, 124, '2015-01-15 00:16:41.000000', 'consum', 0.0229, 'lps'),
	(360444, 124, '2015-01-15 00:16:42.000000', 'consum', 0.0221, 'lps'),
	(360445, 124, '2015-01-15 00:16:43.000000', 'consum', 0.0231, 'lps'),
	(360446, 124, '2015-01-15 00:16:44.000000', 'consum', 0.0218, 'lps'),
	(360447, 124, '2015-01-15 00:16:45.000000', 'consum', 0.0229, 'lps'),
	(360448, 124, '2015-01-15 00:16:46.000000', 'consum', 0.0217, 'lps'),
	(360449, 124, '2015-01-15 00:16:47.000000', 'consum', 0.0231, 'lps'),
	(360450, 124, '2015-01-15 00:16:48.000000', 'consum', 0.0228, 'lps'),
	(360451, 124, '2015-01-15 00:16:49.000000', 'consum', 0.0217, 'lps'),
	(360452, 124, '2015-01-15 00:16:50.000000', 'consum', 0.0214, 'lps'),
	(360453, 124, '2015-01-15 00:16:51.000000', 'consum', 0.0211, 'lps'),
	(360454, 124, '2015-01-15 00:16:52.000000', 'consum', 0.0223, 'lps'),
	(360455, 124, '2015-01-15 00:16:53.000000', 'consum', 0.0228, 'lps'),
	(360456, 124, '2015-01-15 00:16:54.000000', 'consum', 0.0220, 'lps'),
	(360457, 124, '2015-01-15 00:16:55.000000', 'consum', 0.0227, 'lps'),
	(360458, 124, '2015-01-15 00:16:56.000000', 'consum', 0.0221, 'lps'),
	(360459, 124, '2015-01-15 00:16:57.000000', 'consum', 0.0216, 'lps'),
	(360460, 124, '2015-01-15 00:16:58.000000', 'consum', 0.0228, 'lps'),
	(360461, 124, '2015-01-15 00:16:59.000000', 'consum', 0.0217, 'lps'),
	(360462, 124, '2015-01-15 00:17:00.000000', 'consum', 0.0212, 'lps'),
	(360463, 124, '2015-01-15 00:17:01.000000', 'consum', 0.0224, 'lps'),
	(360464, 124, '2015-01-15 00:17:02.000000', 'consum', 0.0230, 'lps'),
	(360465, 124, '2015-01-15 00:17:03.000000', 'consum', 0.0226, 'lps'),
	(360466, 124, '2015-01-15 00:17:04.000000', 'consum', 0.0229, 'lps'),
	(360467, 124, '2015-01-15 00:17:05.000000', 'consum', 0.0213, 'lps'),
	(360468, 124, '2015-01-15 00:17:06.000000', 'consum', 0.0213, 'lps'),
	(360469, 124, '2015-01-15 00:17:07.000000', 'consum', 0.0218, 'lps'),
	(360470, 124, '2015-01-15 00:17:08.000000', 'consum', 0.0216, 'lps'),
	(360471, 124, '2015-01-15 00:17:09.000000', 'consum', 0.0220, 'lps'),
	(360472, 124, '2015-01-15 00:17:10.000000', 'consum', 0.0220, 'lps'),
	(360473, 124, '2015-01-15 00:17:11.000000', 'consum', 0.0228, 'lps'),
	(360474, 124, '2015-01-15 00:17:12.000000', 'consum', 0.0228, 'lps'),
	(360475, 124, '2015-01-15 00:17:13.000000', 'consum', 0.0223, 'lps'),
	(360476, 124, '2015-01-15 00:17:14.000000', 'consum', 0.0222, 'lps'),
	(360477, 124, '2015-01-15 00:17:15.000000', 'consum', 0.0230, 'lps'),
	(360478, 124, '2015-01-15 00:17:16.000000', 'consum', 0.0212, 'lps'),
	(360479, 124, '2015-01-15 00:17:17.000000', 'consum', 0.0223, 'lps'),
	(360480, 124, '2015-01-15 00:17:18.000000', 'consum', 0.0228, 'lps'),
	(360481, 124, '2015-01-15 00:17:19.000000', 'consum', 0.0217, 'lps'),
	(360482, 124, '2015-01-15 00:17:20.000000', 'consum', 0.0212, 'lps'),
	(360483, 124, '2015-01-15 00:17:21.000000', 'consum', 0.0223, 'lps'),
	(360484, 124, '2015-01-15 00:17:22.000000', 'consum', 0.0224, 'lps'),
	(360485, 124, '2015-01-15 00:17:23.000000', 'consum', 0.0220, 'lps'),
	(360486, 124, '2015-01-15 00:17:24.000000', 'consum', 0.0217, 'lps'),
	(360487, 124, '2015-01-15 00:17:25.000000', 'consum', 0.0216, 'lps'),
	(360488, 124, '2015-01-15 00:17:26.000000', 'consum', 0.0218, 'lps'),
	(360489, 124, '2015-01-15 00:17:27.000000', 'consum', 0.0211, 'lps'),
	(360490, 124, '2015-01-15 00:17:28.000000', 'consum', 0.0216, 'lps'),
	(360491, 124, '2015-01-15 00:17:29.000000', 'consum', 0.0215, 'lps'),
	(360492, 124, '2015-01-15 00:17:30.000000', 'consum', 0.0218, 'lps'),
	(360493, 124, '2015-01-15 00:17:31.000000', 'consum', 0.0213, 'lps'),
	(360494, 124, '2015-01-15 00:17:32.000000', 'consum', 0.0224, 'lps'),
	(360495, 124, '2015-01-15 00:17:33.000000', 'consum', 0.0228, 'lps'),
	(360496, 124, '2015-01-15 00:17:34.000000', 'consum', 0.0212, 'lps'),
	(360497, 124, '2015-01-15 00:17:35.000000', 'consum', 0.0213, 'lps'),
	(360498, 124, '2015-01-15 00:17:36.000000', 'consum', 0.0218, 'lps'),
	(360499, 124, '2015-01-15 00:17:37.000000', 'consum', 0.0221, 'lps'),
	(360500, 124, '2015-01-15 00:17:38.000000', 'consum', 0.0220, 'lps'),
	(360501, 124, '2015-01-15 00:17:39.000000', 'consum', 0.0227, 'lps'),
	(360502, 124, '2015-01-15 00:17:40.000000', 'consum', 0.0222, 'lps'),
	(360503, 124, '2015-01-15 00:17:41.000000', 'consum', 0.0217, 'lps'),
	(360504, 124, '2015-01-15 00:17:42.000000', 'consum', 0.0211, 'lps'),
	(360505, 124, '2015-01-15 00:17:43.000000', 'consum', 0.0218, 'lps'),
	(360506, 124, '2015-01-15 00:17:44.000000', 'consum', 0.0226, 'lps'),
	(360507, 124, '2015-01-15 00:17:45.000000', 'consum', 0.0223, 'lps'),
	(360508, 124, '2015-01-15 00:17:46.000000', 'consum', 0.0226, 'lps'),
	(360509, 124, '2015-01-15 00:17:47.000000', 'consum', 0.0228, 'lps'),
	(360510, 124, '2015-01-15 00:17:48.000000', 'consum', 0.0212, 'lps'),
	(360511, 124, '2015-01-15 00:17:49.000000', 'consum', 0.0230, 'lps'),
	(360512, 124, '2015-01-15 00:17:50.000000', 'consum', 0.0215, 'lps'),
	(360513, 124, '2015-01-15 00:17:51.000000', 'consum', 0.0221, 'lps'),
	(360514, 124, '2015-01-15 00:17:52.000000', 'consum', 0.0230, 'lps'),
	(360515, 124, '2015-01-15 00:17:53.000000', 'consum', 0.0210, 'lps'),
	(360516, 124, '2015-01-15 00:17:54.000000', 'consum', 0.0216, 'lps'),
	(360517, 124, '2015-01-15 00:17:55.000000', 'consum', 0.0217, 'lps'),
	(360518, 124, '2015-01-15 00:17:56.000000', 'consum', 0.0231, 'lps'),
	(360519, 124, '2015-01-15 00:17:57.000000', 'consum', 0.0227, 'lps'),
	(360520, 124, '2015-01-15 00:17:58.000000', 'consum', 0.0212, 'lps'),
	(360521, 124, '2015-01-15 00:17:59.000000', 'consum', 0.0213, 'lps'),
	(360522, 124, '2015-01-15 00:18:00.000000', 'consum', 0.0219, 'lps'),
	(360523, 124, '2015-01-15 00:18:01.000000', 'consum', 0.0225, 'lps'),
	(360524, 124, '2015-01-15 00:18:02.000000', 'consum', 0.0214, 'lps'),
	(360525, 124, '2015-01-15 00:18:03.000000', 'consum', 0.0231, 'lps'),
	(360526, 124, '2015-01-15 00:18:04.000000', 'consum', 0.0216, 'lps'),
	(360527, 124, '2015-01-15 00:18:05.000000', 'consum', 0.0222, 'lps'),
	(360528, 124, '2015-01-15 00:18:06.000000', 'consum', 0.0229, 'lps'),
	(360529, 124, '2015-01-15 00:18:07.000000', 'consum', 0.0227, 'lps'),
	(360530, 124, '2015-01-15 00:18:08.000000', 'consum', 0.0217, 'lps'),
	(360531, 124, '2015-01-15 00:18:09.000000', 'consum', 0.0216, 'lps'),
	(360532, 124, '2015-01-15 00:18:10.000000', 'consum', 0.0219, 'lps'),
	(360533, 124, '2015-01-15 00:18:11.000000', 'consum', 0.0217, 'lps'),
	(360534, 124, '2015-01-15 00:18:12.000000', 'consum', 0.0220, 'lps'),
	(360535, 124, '2015-01-15 00:18:13.000000', 'consum', 0.0214, 'lps'),
	(360536, 124, '2015-01-15 00:18:14.000000', 'consum', 0.0225, 'lps'),
	(360537, 124, '2015-01-15 00:18:15.000000', 'consum', 0.0227, 'lps'),
	(360538, 124, '2015-01-15 00:18:16.000000', 'consum', 0.0228, 'lps'),
	(360539, 124, '2015-01-15 00:18:17.000000', 'consum', 0.0228, 'lps'),
	(360540, 124, '2015-01-15 00:18:18.000000', 'consum', 0.0227, 'lps'),
	(360541, 124, '2015-01-15 00:18:19.000000', 'consum', 0.0217, 'lps'),
	(360542, 124, '2015-01-15 00:18:20.000000', 'consum', 0.0217, 'lps'),
	(360543, 124, '2015-01-15 00:18:21.000000', 'consum', 0.0224, 'lps'),
	(360544, 124, '2015-01-15 00:18:22.000000', 'consum', 0.0217, 'lps'),
	(360545, 124, '2015-01-15 00:18:23.000000', 'consum', 0.0227, 'lps'),
	(360546, 124, '2015-01-15 00:18:24.000000', 'consum', 0.0227, 'lps'),
	(360547, 124, '2015-01-15 00:18:25.000000', 'consum', 0.0226, 'lps'),
	(360548, 124, '2015-01-15 00:18:26.000000', 'consum', 0.0215, 'lps'),
	(360549, 124, '2015-01-15 00:18:27.000000', 'consum', 0.0210, 'lps'),
	(360550, 124, '2015-01-15 00:18:28.000000', 'consum', 0.0220, 'lps'),
	(360551, 124, '2015-01-15 00:18:29.000000', 'consum', 0.0213, 'lps'),
	(360552, 124, '2015-01-15 00:18:30.000000', 'consum', 0.0220, 'lps'),
	(360553, 124, '2015-01-15 00:18:31.000000', 'consum', 0.0230, 'lps'),
	(360554, 124, '2015-01-15 00:18:32.000000', 'consum', 0.0215, 'lps'),
	(360555, 124, '2015-01-15 00:18:33.000000', 'consum', 0.0220, 'lps'),
	(360556, 124, '2015-01-15 00:18:34.000000', 'consum', 0.0224, 'lps'),
	(360557, 124, '2015-01-15 00:18:35.000000', 'consum', 0.0226, 'lps'),
	(360558, 124, '2015-01-15 00:18:36.000000', 'consum', 0.0226, 'lps'),
	(360559, 124, '2015-01-15 00:18:37.000000', 'consum', 0.0220, 'lps'),
	(360560, 124, '2015-01-15 00:18:38.000000', 'consum', 0.0211, 'lps'),
	(360561, 124, '2015-01-15 00:18:39.000000', 'consum', 0.0211, 'lps'),
	(360562, 124, '2015-01-15 00:18:40.000000', 'consum', 0.0213, 'lps'),
	(360563, 124, '2015-01-15 00:18:41.000000', 'consum', 0.0221, 'lps'),
	(360564, 124, '2015-01-15 00:18:42.000000', 'consum', 0.0213, 'lps'),
	(360565, 124, '2015-01-15 00:18:43.000000', 'consum', 0.0213, 'lps'),
	(360566, 124, '2015-01-15 00:18:44.000000', 'consum', 0.0216, 'lps'),
	(360567, 124, '2015-01-15 00:18:45.000000', 'consum', 0.0231, 'lps'),
	(360568, 124, '2015-01-15 00:18:46.000000', 'consum', 0.0213, 'lps'),
	(360569, 124, '2015-01-15 00:18:47.000000', 'consum', 0.0225, 'lps'),
	(360570, 124, '2015-01-15 00:18:48.000000', 'consum', 0.0212, 'lps'),
	(360571, 124, '2015-01-15 00:18:49.000000', 'consum', 0.0221, 'lps'),
	(360572, 124, '2015-01-15 00:18:50.000000', 'consum', 0.0216, 'lps'),
	(360573, 124, '2015-01-15 00:18:51.000000', 'consum', 0.0227, 'lps'),
	(360574, 124, '2015-01-15 00:18:52.000000', 'consum', 0.0212, 'lps'),
	(360575, 124, '2015-01-15 00:18:53.000000', 'consum', 0.0215, 'lps'),
	(360576, 124, '2015-01-15 00:18:54.000000', 'consum', 0.0229, 'lps'),
	(360577, 124, '2015-01-15 00:18:55.000000', 'consum', 0.0222, 'lps'),
	(360578, 124, '2015-01-15 00:18:56.000000', 'consum', 0.0216, 'lps'),
	(360579, 124, '2015-01-15 00:18:57.000000', 'consum', 0.0224, 'lps'),
	(360580, 124, '2015-01-15 00:18:58.000000', 'consum', 0.0221, 'lps'),
	(360581, 124, '2015-01-15 00:18:59.000000', 'consum', 0.0222, 'lps'),
	(360582, 124, '2015-01-15 00:19:00.000000', 'consum', 0.0215, 'lps'),
	(360583, 124, '2015-01-15 00:19:01.000000', 'consum', 0.0222, 'lps'),
	(360584, 124, '2015-01-15 00:19:02.000000', 'consum', 0.0231, 'lps'),
	(360585, 124, '2015-01-15 00:19:03.000000', 'consum', 0.0217, 'lps'),
	(360586, 124, '2015-01-15 00:19:04.000000', 'consum', 0.0227, 'lps'),
	(360587, 124, '2015-01-15 00:19:05.000000', 'consum', 0.0230, 'lps'),
	(360588, 124, '2015-01-15 00:19:06.000000', 'consum', 0.0215, 'lps'),
	(360589, 124, '2015-01-15 00:19:07.000000', 'consum', 0.0220, 'lps'),
	(360590, 124, '2015-01-15 00:19:08.000000', 'consum', 0.0222, 'lps'),
	(360591, 124, '2015-01-15 00:19:09.000000', 'consum', 0.0220, 'lps'),
	(360592, 124, '2015-01-15 00:19:10.000000', 'consum', 0.0224, 'lps'),
	(360593, 124, '2015-01-15 00:19:11.000000', 'consum', 0.0226, 'lps'),
	(360594, 124, '2015-01-15 00:19:12.000000', 'consum', 0.0230, 'lps'),
	(360595, 124, '2015-01-15 00:19:13.000000', 'consum', 0.0217, 'lps'),
	(360596, 124, '2015-01-15 00:19:14.000000', 'consum', 0.0229, 'lps'),
	(360597, 124, '2015-01-15 00:19:15.000000', 'consum', 0.0219, 'lps'),
	(360598, 124, '2015-01-15 00:19:16.000000', 'consum', 0.0218, 'lps'),
	(360599, 124, '2015-01-15 00:19:17.000000', 'consum', 0.0227, 'lps'),
	(360600, 124, '2015-01-15 00:19:18.000000', 'consum', 0.0225, 'lps'),
	(360601, 124, '2015-01-15 00:19:19.000000', 'consum', 0.0216, 'lps'),
	(360602, 124, '2015-01-15 00:19:20.000000', 'consum', 0.0214, 'lps'),
	(360603, 124, '2015-01-15 00:19:21.000000', 'consum', 0.0212, 'lps'),
	(360604, 124, '2015-01-15 00:19:22.000000', 'consum', 0.0231, 'lps'),
	(360605, 124, '2015-01-15 00:19:23.000000', 'consum', 0.0222, 'lps'),
	(360606, 124, '2015-01-15 00:19:24.000000', 'consum', 0.0228, 'lps'),
	(360607, 124, '2015-01-15 00:19:25.000000', 'consum', 0.0222, 'lps'),
	(360608, 124, '2015-01-15 00:19:26.000000', 'consum', 0.0218, 'lps'),
	(360609, 124, '2015-01-15 00:19:27.000000', 'consum', 0.0212, 'lps'),
	(360610, 124, '2015-01-15 00:19:28.000000', 'consum', 0.0219, 'lps'),
	(360611, 124, '2015-01-15 00:19:29.000000', 'consum', 0.0229, 'lps'),
	(360612, 124, '2015-01-15 00:19:30.000000', 'consum', 0.0214, 'lps'),
	(360613, 124, '2015-01-15 00:19:31.000000', 'consum', 0.0214, 'lps'),
	(360614, 124, '2015-01-15 00:19:32.000000', 'consum', 0.0220, 'lps'),
	(360615, 124, '2015-01-15 00:19:33.000000', 'consum', 0.0225, 'lps'),
	(360616, 124, '2015-01-15 00:19:34.000000', 'consum', 0.0211, 'lps'),
	(360617, 124, '2015-01-15 00:19:35.000000', 'consum', 0.0218, 'lps'),
	(360618, 124, '2015-01-15 00:19:36.000000', 'consum', 0.0222, 'lps'),
	(360619, 124, '2015-01-15 00:19:37.000000', 'consum', 0.0224, 'lps'),
	(360620, 124, '2015-01-15 00:19:38.000000', 'consum', 0.0225, 'lps'),
	(360621, 124, '2015-01-15 00:19:39.000000', 'consum', 0.0222, 'lps'),
	(360622, 124, '2015-01-15 00:19:40.000000', 'consum', 0.0222, 'lps'),
	(360623, 124, '2015-01-15 00:19:41.000000', 'consum', 0.0216, 'lps'),
	(360624, 124, '2015-01-15 00:19:42.000000', 'consum', 0.0226, 'lps'),
	(360625, 124, '2015-01-15 00:19:43.000000', 'consum', 0.0230, 'lps'),
	(360626, 124, '2015-01-15 00:19:44.000000', 'consum', 0.0217, 'lps'),
	(360627, 124, '2015-01-15 00:19:45.000000', 'consum', 0.0230, 'lps'),
	(360628, 124, '2015-01-15 00:19:46.000000', 'consum', 0.0223, 'lps'),
	(360629, 124, '2015-01-15 00:19:47.000000', 'consum', 0.0215, 'lps'),
	(360630, 124, '2015-01-15 00:19:48.000000', 'consum', 0.0218, 'lps'),
	(360631, 124, '2015-01-15 00:19:49.000000', 'consum', 0.0215, 'lps'),
	(360632, 124, '2015-01-15 00:19:50.000000', 'consum', 0.0213, 'lps'),
	(360633, 124, '2015-01-15 00:19:51.000000', 'consum', 0.0230, 'lps'),
	(360634, 124, '2015-01-15 00:19:52.000000', 'consum', 0.0216, 'lps'),
	(360635, 124, '2015-01-15 00:19:53.000000', 'consum', 0.0222, 'lps'),
	(360636, 124, '2015-01-15 00:19:54.000000', 'consum', 0.0231, 'lps'),
	(360637, 124, '2015-01-15 00:19:55.000000', 'consum', 0.0214, 'lps'),
	(360638, 124, '2015-01-15 00:19:56.000000', 'consum', 0.0213, 'lps'),
	(360639, 124, '2015-01-15 00:19:57.000000', 'consum', 0.0212, 'lps'),
	(360640, 124, '2015-01-15 00:19:58.000000', 'consum', 0.0211, 'lps'),
	(360641, 124, '2015-01-15 00:19:59.000000', 'consum', 0.0211, 'lps'),
	(360642, 124, '2015-01-15 00:20:00.000000', 'consum', 0.0211, 'lps'),
	(360643, 124, '2015-01-15 00:20:01.000000', 'consum', 0.0214, 'lps'),
	(360644, 124, '2015-01-15 00:20:02.000000', 'consum', 0.0228, 'lps'),
	(360645, 124, '2015-01-15 00:20:03.000000', 'consum', 0.0220, 'lps'),
	(360646, 124, '2015-01-15 00:20:04.000000', 'consum', 0.0229, 'lps'),
	(360647, 124, '2015-01-15 00:20:05.000000', 'consum', 0.0231, 'lps'),
	(360648, 124, '2015-01-15 00:20:06.000000', 'consum', 0.0217, 'lps'),
	(360649, 124, '2015-01-15 00:20:07.000000', 'consum', 0.0226, 'lps'),
	(360650, 124, '2015-01-15 00:20:08.000000', 'consum', 0.0224, 'lps'),
	(360651, 124, '2015-01-15 00:20:09.000000', 'consum', 0.0211, 'lps'),
	(360652, 124, '2015-01-15 00:20:10.000000', 'consum', 0.0217, 'lps'),
	(360653, 124, '2015-01-15 00:20:11.000000', 'consum', 0.0219, 'lps'),
	(360654, 124, '2015-01-15 00:20:12.000000', 'consum', 0.0216, 'lps'),
	(360655, 124, '2015-01-15 00:20:13.000000', 'consum', 0.0211, 'lps'),
	(360656, 124, '2015-01-15 00:20:14.000000', 'consum', 0.0221, 'lps'),
	(360657, 124, '2015-01-15 00:20:15.000000', 'consum', 0.0219, 'lps'),
	(360658, 124, '2015-01-15 00:20:16.000000', 'consum', 0.0220, 'lps'),
	(360659, 124, '2015-01-15 00:20:17.000000', 'consum', 0.0215, 'lps'),
	(360660, 124, '2015-01-15 00:20:18.000000', 'consum', 0.0224, 'lps'),
	(360661, 124, '2015-01-15 00:20:19.000000', 'consum', 0.0222, 'lps'),
	(360662, 124, '2015-01-15 00:20:20.000000', 'consum', 0.0230, 'lps'),
	(360663, 124, '2015-01-15 00:20:21.000000', 'consum', 0.0230, 'lps'),
	(360664, 124, '2015-01-15 00:20:22.000000', 'consum', 0.0229, 'lps'),
	(360665, 124, '2015-01-15 00:20:23.000000', 'consum', 0.0221, 'lps'),
	(360666, 124, '2015-01-15 00:20:24.000000', 'consum', 0.0210, 'lps'),
	(360667, 124, '2015-01-15 00:20:25.000000', 'consum', 0.0223, 'lps'),
	(360668, 124, '2015-01-15 00:20:26.000000', 'consum', 0.0231, 'lps'),
	(360669, 124, '2015-01-15 00:20:27.000000', 'consum', 0.0230, 'lps'),
	(360670, 124, '2015-01-15 00:20:28.000000', 'consum', 0.0229, 'lps'),
	(360671, 124, '2015-01-15 00:20:29.000000', 'consum', 0.0220, 'lps'),
	(360672, 124, '2015-01-15 00:20:30.000000', 'consum', 0.0227, 'lps'),
	(360673, 124, '2015-01-15 00:20:31.000000', 'consum', 0.0220, 'lps'),
	(360674, 124, '2015-01-15 00:20:32.000000', 'consum', 0.0212, 'lps'),
	(360675, 124, '2015-01-15 00:20:33.000000', 'consum', 0.0210, 'lps'),
	(360676, 124, '2015-01-15 00:20:34.000000', 'consum', 0.0228, 'lps'),
	(360677, 124, '2015-01-15 00:20:35.000000', 'consum', 0.0211, 'lps'),
	(360678, 124, '2015-01-15 00:20:36.000000', 'consum', 0.0230, 'lps'),
	(360679, 124, '2015-01-15 00:20:37.000000', 'consum', 0.0217, 'lps'),
	(360680, 124, '2015-01-15 00:20:38.000000', 'consum', 0.0229, 'lps'),
	(360681, 124, '2015-01-15 00:20:39.000000', 'consum', 0.0218, 'lps'),
	(360682, 124, '2015-01-15 00:20:40.000000', 'consum', 0.0215, 'lps'),
	(360683, 124, '2015-01-15 00:20:41.000000', 'consum', 0.0211, 'lps'),
	(360684, 124, '2015-01-15 00:20:42.000000', 'consum', 0.0223, 'lps'),
	(360685, 124, '2015-01-15 00:20:43.000000', 'consum', 0.0227, 'lps'),
	(360686, 124, '2015-01-15 00:20:44.000000', 'consum', 0.0215, 'lps'),
	(360687, 124, '2015-01-15 00:20:45.000000', 'consum', 0.0229, 'lps'),
	(360688, 124, '2015-01-15 00:20:46.000000', 'consum', 0.0222, 'lps'),
	(360689, 124, '2015-01-15 00:20:47.000000', 'consum', 0.0217, 'lps'),
	(360690, 124, '2015-01-15 00:20:48.000000', 'consum', 0.0228, 'lps'),
	(360691, 124, '2015-01-15 00:20:49.000000', 'consum', 0.0214, 'lps'),
	(360692, 124, '2015-01-15 00:20:50.000000', 'consum', 0.0223, 'lps'),
	(360693, 124, '2015-01-15 00:20:51.000000', 'consum', 0.0218, 'lps'),
	(360694, 124, '2015-01-15 00:20:52.000000', 'consum', 0.0212, 'lps'),
	(360695, 124, '2015-01-15 00:20:53.000000', 'consum', 0.0218, 'lps'),
	(360696, 124, '2015-01-15 00:20:54.000000', 'consum', 0.0221, 'lps'),
	(360697, 124, '2015-01-15 00:20:55.000000', 'consum', 0.0219, 'lps'),
	(360698, 124, '2015-01-15 00:20:56.000000', 'consum', 0.0222, 'lps'),
	(360699, 124, '2015-01-15 00:20:57.000000', 'consum', 0.0221, 'lps'),
	(360700, 124, '2015-01-15 00:20:58.000000', 'consum', 0.0230, 'lps'),
	(360701, 124, '2015-01-15 00:20:59.000000', 'consum', 0.0213, 'lps'),
	(360702, 124, '2015-01-15 00:21:00.000000', 'consum', 0.0230, 'lps'),
	(360703, 124, '2015-01-15 00:21:01.000000', 'consum', 0.0212, 'lps'),
	(360704, 124, '2015-01-15 00:21:02.000000', 'consum', 0.0230, 'lps'),
	(360705, 124, '2015-01-15 00:21:03.000000', 'consum', 0.0215, 'lps'),
	(360706, 124, '2015-01-15 00:21:04.000000', 'consum', 0.0218, 'lps'),
	(360707, 124, '2015-01-15 00:21:05.000000', 'consum', 0.0214, 'lps'),
	(360708, 124, '2015-01-15 00:21:06.000000', 'consum', 0.0228, 'lps'),
	(360709, 124, '2015-01-15 00:21:07.000000', 'consum', 0.0225, 'lps'),
	(360710, 124, '2015-01-15 00:21:08.000000', 'consum', 0.0230, 'lps'),
	(360711, 124, '2015-01-15 00:21:09.000000', 'consum', 0.0224, 'lps'),
	(360712, 124, '2015-01-15 00:21:10.000000', 'consum', 0.0218, 'lps'),
	(360713, 124, '2015-01-15 00:21:11.000000', 'consum', 0.0230, 'lps'),
	(360714, 124, '2015-01-15 00:21:12.000000', 'consum', 0.0222, 'lps'),
	(360715, 124, '2015-01-15 00:21:13.000000', 'consum', 0.0231, 'lps'),
	(360716, 124, '2015-01-15 00:21:14.000000', 'consum', 0.0212, 'lps'),
	(360717, 124, '2015-01-15 00:21:15.000000', 'consum', 0.0226, 'lps'),
	(360718, 124, '2015-01-15 00:21:16.000000', 'consum', 0.0217, 'lps'),
	(360719, 124, '2015-01-15 00:21:17.000000', 'consum', 0.0221, 'lps'),
	(360720, 124, '2015-01-15 00:21:18.000000', 'consum', 0.0222, 'lps'),
	(360721, 124, '2015-01-15 00:21:19.000000', 'consum', 0.0214, 'lps'),
	(360722, 124, '2015-01-15 00:21:20.000000', 'consum', 0.0217, 'lps'),
	(360723, 124, '2015-01-15 00:21:21.000000', 'consum', 0.0211, 'lps'),
	(360724, 124, '2015-01-15 00:21:22.000000', 'consum', 0.0215, 'lps'),
	(360725, 124, '2015-01-15 00:21:23.000000', 'consum', 0.0213, 'lps'),
	(360726, 124, '2015-01-15 00:21:24.000000', 'consum', 0.0210, 'lps'),
	(360727, 124, '2015-01-15 00:21:25.000000', 'consum', 0.0222, 'lps'),
	(360728, 124, '2015-01-15 00:21:26.000000', 'consum', 0.0229, 'lps'),
	(360729, 124, '2015-01-15 00:21:27.000000', 'consum', 0.0225, 'lps'),
	(360730, 124, '2015-01-15 00:21:28.000000', 'consum', 0.0226, 'lps'),
	(360731, 124, '2015-01-15 00:21:29.000000', 'consum', 0.0226, 'lps'),
	(360732, 124, '2015-01-15 00:21:30.000000', 'consum', 0.0221, 'lps'),
	(360733, 124, '2015-01-15 00:21:31.000000', 'consum', 0.0216, 'lps'),
	(360734, 124, '2015-01-15 00:21:32.000000', 'consum', 0.0228, 'lps'),
	(360735, 124, '2015-01-15 00:21:33.000000', 'consum', 0.0219, 'lps'),
	(360736, 124, '2015-01-15 00:21:34.000000', 'consum', 0.0221, 'lps'),
	(360737, 124, '2015-01-15 00:21:35.000000', 'consum', 0.0220, 'lps'),
	(360738, 124, '2015-01-15 00:21:36.000000', 'consum', 0.0224, 'lps'),
	(360739, 124, '2015-01-15 00:21:37.000000', 'consum', 0.0231, 'lps'),
	(360740, 124, '2015-01-15 00:21:38.000000', 'consum', 0.0228, 'lps'),
	(360741, 124, '2015-01-15 00:21:39.000000', 'consum', 0.0215, 'lps'),
	(360742, 124, '2015-01-15 00:21:40.000000', 'consum', 0.0227, 'lps'),
	(360743, 124, '2015-01-15 00:21:41.000000', 'consum', 0.0216, 'lps'),
	(360744, 124, '2015-01-15 00:21:42.000000', 'consum', 0.0210, 'lps'),
	(360745, 124, '2015-01-15 00:21:43.000000', 'consum', 0.0215, 'lps'),
	(360746, 124, '2015-01-15 00:21:44.000000', 'consum', 0.0211, 'lps'),
	(360747, 124, '2015-01-15 00:21:45.000000', 'consum', 0.0225, 'lps'),
	(360748, 124, '2015-01-15 00:21:46.000000', 'consum', 0.0216, 'lps'),
	(360749, 124, '2015-01-15 00:21:47.000000', 'consum', 0.0218, 'lps'),
	(360750, 124, '2015-01-15 00:21:48.000000', 'consum', 0.0211, 'lps'),
	(360751, 124, '2015-01-15 00:21:49.000000', 'consum', 0.0213, 'lps'),
	(360752, 124, '2015-01-15 00:21:50.000000', 'consum', 0.0221, 'lps'),
	(360753, 124, '2015-01-15 00:21:51.000000', 'consum', 0.0215, 'lps'),
	(360754, 124, '2015-01-15 00:21:52.000000', 'consum', 0.0225, 'lps'),
	(360755, 124, '2015-01-15 00:21:53.000000', 'consum', 0.0225, 'lps'),
	(360756, 124, '2015-01-15 00:21:54.000000', 'consum', 0.0217, 'lps'),
	(360757, 124, '2015-01-15 00:21:55.000000', 'consum', 0.0225, 'lps'),
	(360758, 124, '2015-01-15 00:21:56.000000', 'consum', 0.0218, 'lps'),
	(360759, 124, '2015-01-15 00:21:57.000000', 'consum', 0.0229, 'lps'),
	(360760, 124, '2015-01-15 00:21:58.000000', 'consum', 0.0215, 'lps'),
	(360761, 124, '2015-01-15 00:21:59.000000', 'consum', 0.0223, 'lps'),
	(360762, 124, '2015-01-15 00:22:00.000000', 'consum', 0.0217, 'lps'),
	(360763, 124, '2015-01-15 00:22:01.000000', 'consum', 0.0228, 'lps'),
	(360764, 124, '2015-01-15 00:22:02.000000', 'consum', 0.0213, 'lps'),
	(360765, 124, '2015-01-15 00:22:03.000000', 'consum', 0.0215, 'lps'),
	(360766, 124, '2015-01-15 00:22:04.000000', 'consum', 0.0228, 'lps'),
	(360767, 124, '2015-01-15 00:22:05.000000', 'consum', 0.0220, 'lps'),
	(360768, 124, '2015-01-15 00:22:06.000000', 'consum', 0.0228, 'lps'),
	(360769, 124, '2015-01-15 00:22:07.000000', 'consum', 0.0227, 'lps'),
	(360770, 124, '2015-01-15 00:22:08.000000', 'consum', 0.0218, 'lps'),
	(360771, 124, '2015-01-15 00:22:09.000000', 'consum', 0.0222, 'lps'),
	(360772, 124, '2015-01-15 00:22:10.000000', 'consum', 0.0226, 'lps'),
	(360773, 124, '2015-01-15 00:22:11.000000', 'consum', 0.0231, 'lps'),
	(360774, 124, '2015-01-15 00:22:12.000000', 'consum', 0.0226, 'lps'),
	(360775, 124, '2015-01-15 00:22:13.000000', 'consum', 0.0224, 'lps'),
	(360776, 124, '2015-01-15 00:22:14.000000', 'consum', 0.0213, 'lps'),
	(360777, 124, '2015-01-15 00:22:15.000000', 'consum', 0.0229, 'lps'),
	(360778, 124, '2015-01-15 00:22:16.000000', 'consum', 0.0227, 'lps'),
	(360779, 124, '2015-01-15 00:22:17.000000', 'consum', 0.0218, 'lps'),
	(360780, 124, '2015-01-15 00:22:18.000000', 'consum', 0.0221, 'lps'),
	(360781, 124, '2015-01-15 00:22:19.000000', 'consum', 0.0221, 'lps'),
	(360782, 124, '2015-01-15 00:22:20.000000', 'consum', 0.0230, 'lps'),
	(360783, 124, '2015-01-15 00:22:21.000000', 'consum', 0.0212, 'lps'),
	(360784, 124, '2015-01-15 00:22:22.000000', 'consum', 0.0228, 'lps'),
	(360785, 124, '2015-01-15 00:22:23.000000', 'consum', 0.0230, 'lps'),
	(360786, 124, '2015-01-15 00:22:24.000000', 'consum', 0.0231, 'lps'),
	(360787, 124, '2015-01-15 00:22:25.000000', 'consum', 0.0215, 'lps'),
	(360788, 124, '2015-01-15 00:22:26.000000', 'consum', 0.0214, 'lps'),
	(360789, 124, '2015-01-15 00:22:27.000000', 'consum', 0.0218, 'lps'),
	(360790, 124, '2015-01-15 00:22:28.000000', 'consum', 0.0215, 'lps'),
	(360791, 124, '2015-01-15 00:22:29.000000', 'consum', 0.0210, 'lps'),
	(360792, 124, '2015-01-15 00:22:30.000000', 'consum', 0.0218, 'lps'),
	(360793, 124, '2015-01-15 00:22:31.000000', 'consum', 0.0231, 'lps'),
	(360794, 124, '2015-01-15 00:22:32.000000', 'consum', 0.0224, 'lps'),
	(360795, 124, '2015-01-15 00:22:33.000000', 'consum', 0.0217, 'lps'),
	(360796, 124, '2015-01-15 00:22:34.000000', 'consum', 0.0227, 'lps'),
	(360797, 124, '2015-01-15 00:22:35.000000', 'consum', 0.0228, 'lps'),
	(360798, 124, '2015-01-15 00:22:36.000000', 'consum', 0.0230, 'lps'),
	(360799, 124, '2015-01-15 00:22:37.000000', 'consum', 0.0211, 'lps'),
	(360800, 124, '2015-01-15 00:22:38.000000', 'consum', 0.0224, 'lps'),
	(360801, 124, '2015-01-15 00:22:39.000000', 'consum', 0.0230, 'lps'),
	(360802, 124, '2015-01-15 00:22:40.000000', 'consum', 0.0226, 'lps'),
	(360803, 124, '2015-01-15 00:22:41.000000', 'consum', 0.0229, 'lps'),
	(360804, 124, '2015-01-15 00:22:42.000000', 'consum', 0.0216, 'lps'),
	(360805, 124, '2015-01-15 00:22:43.000000', 'consum', 0.0225, 'lps'),
	(360806, 124, '2015-01-15 00:22:44.000000', 'consum', 0.0226, 'lps'),
	(360807, 124, '2015-01-15 00:22:45.000000', 'consum', 0.0224, 'lps'),
	(360808, 124, '2015-01-15 00:22:46.000000', 'consum', 0.0230, 'lps'),
	(360809, 124, '2015-01-15 00:22:47.000000', 'consum', 0.0225, 'lps'),
	(360810, 124, '2015-01-15 00:22:48.000000', 'consum', 0.0225, 'lps'),
	(360811, 124, '2015-01-15 00:22:49.000000', 'consum', 0.0218, 'lps'),
	(360812, 124, '2015-01-15 00:22:50.000000', 'consum', 0.0229, 'lps'),
	(360813, 124, '2015-01-15 00:22:51.000000', 'consum', 0.0214, 'lps'),
	(360814, 124, '2015-01-15 00:22:52.000000', 'consum', 0.0217, 'lps'),
	(360815, 124, '2015-01-15 00:22:53.000000', 'consum', 0.0211, 'lps'),
	(360816, 124, '2015-01-15 00:22:54.000000', 'consum', 0.0219, 'lps'),
	(360817, 124, '2015-01-15 00:22:55.000000', 'consum', 0.0229, 'lps'),
	(360818, 124, '2015-01-15 00:22:56.000000', 'consum', 0.0213, 'lps'),
	(360819, 124, '2015-01-15 00:22:57.000000', 'consum', 0.0211, 'lps'),
	(360820, 124, '2015-01-15 00:22:58.000000', 'consum', 0.0228, 'lps'),
	(360821, 124, '2015-01-15 00:22:59.000000', 'consum', 0.0211, 'lps'),
	(360822, 124, '2015-01-15 00:23:00.000000', 'consum', 0.0227, 'lps'),
	(360823, 124, '2015-01-15 00:23:01.000000', 'consum', 0.0228, 'lps'),
	(360824, 124, '2015-01-15 00:23:02.000000', 'consum', 0.0227, 'lps'),
	(360825, 124, '2015-01-15 00:23:03.000000', 'consum', 0.0217, 'lps'),
	(360826, 124, '2015-01-15 00:23:04.000000', 'consum', 0.0220, 'lps'),
	(360827, 124, '2015-01-15 00:23:05.000000', 'consum', 0.0216, 'lps'),
	(360828, 124, '2015-01-15 00:23:06.000000', 'consum', 0.0212, 'lps'),
	(360829, 124, '2015-01-15 00:23:07.000000', 'consum', 0.0225, 'lps'),
	(360830, 124, '2015-01-15 00:23:08.000000', 'consum', 0.0214, 'lps'),
	(360831, 124, '2015-01-15 00:23:09.000000', 'consum', 0.0229, 'lps'),
	(360832, 124, '2015-01-15 00:23:10.000000', 'consum', 0.0228, 'lps'),
	(360833, 124, '2015-01-15 00:23:11.000000', 'consum', 0.0219, 'lps'),
	(360834, 124, '2015-01-15 00:23:12.000000', 'consum', 0.0225, 'lps'),
	(360835, 124, '2015-01-15 00:23:13.000000', 'consum', 0.0213, 'lps'),
	(360836, 124, '2015-01-15 00:23:14.000000', 'consum', 0.0225, 'lps'),
	(360837, 124, '2015-01-15 00:23:15.000000', 'consum', 0.0210, 'lps'),
	(360838, 124, '2015-01-15 00:23:16.000000', 'consum', 0.0231, 'lps'),
	(360839, 124, '2015-01-15 00:23:17.000000', 'consum', 0.0229, 'lps'),
	(360840, 124, '2015-01-15 00:23:18.000000', 'consum', 0.0221, 'lps'),
	(360841, 124, '2015-01-15 00:23:19.000000', 'consum', 0.0230, 'lps'),
	(360842, 124, '2015-01-15 00:23:20.000000', 'consum', 0.0213, 'lps'),
	(360843, 124, '2015-01-15 00:23:21.000000', 'consum', 0.0210, 'lps'),
	(360844, 124, '2015-01-15 00:23:22.000000', 'consum', 0.0223, 'lps'),
	(360845, 124, '2015-01-15 00:23:23.000000', 'consum', 0.0229, 'lps'),
	(360846, 124, '2015-01-15 00:23:24.000000', 'consum', 0.0226, 'lps'),
	(360847, 124, '2015-01-15 00:23:25.000000', 'consum', 0.0231, 'lps'),
	(360848, 124, '2015-01-15 00:23:26.000000', 'consum', 0.0223, 'lps'),
	(360849, 124, '2015-01-15 00:23:27.000000', 'consum', 0.0212, 'lps'),
	(360850, 124, '2015-01-15 00:23:28.000000', 'consum', 0.0225, 'lps'),
	(360851, 124, '2015-01-15 00:23:29.000000', 'consum', 0.0213, 'lps'),
	(360852, 124, '2015-01-15 00:23:30.000000', 'consum', 0.0227, 'lps'),
	(360853, 124, '2015-01-15 00:23:31.000000', 'consum', 0.0219, 'lps'),
	(360854, 124, '2015-01-15 00:23:32.000000', 'consum', 0.0225, 'lps'),
	(360855, 124, '2015-01-15 00:23:33.000000', 'consum', 0.0217, 'lps'),
	(360856, 124, '2015-01-15 00:23:34.000000', 'consum', 0.0222, 'lps'),
	(360857, 124, '2015-01-15 00:23:35.000000', 'consum', 0.0227, 'lps'),
	(360858, 124, '2015-01-15 00:23:36.000000', 'consum', 0.0215, 'lps'),
	(360859, 124, '2015-01-15 00:23:37.000000', 'consum', 0.0231, 'lps'),
	(360860, 124, '2015-01-15 00:23:38.000000', 'consum', 0.0211, 'lps'),
	(360861, 124, '2015-01-15 00:23:39.000000', 'consum', 0.0219, 'lps'),
	(360862, 124, '2015-01-15 00:23:40.000000', 'consum', 0.0230, 'lps'),
	(360863, 124, '2015-01-15 00:23:41.000000', 'consum', 0.0216, 'lps'),
	(360864, 124, '2015-01-15 00:23:42.000000', 'consum', 0.0226, 'lps'),
	(360865, 124, '2015-01-15 00:23:43.000000', 'consum', 0.0226, 'lps'),
	(360866, 124, '2015-01-15 00:23:44.000000', 'consum', 0.0224, 'lps'),
	(360867, 124, '2015-01-15 00:23:45.000000', 'consum', 0.0231, 'lps'),
	(360868, 124, '2015-01-15 00:23:46.000000', 'consum', 0.0228, 'lps'),
	(360869, 124, '2015-01-15 00:23:47.000000', 'consum', 0.0217, 'lps'),
	(360870, 124, '2015-01-15 00:23:48.000000', 'consum', 0.0213, 'lps'),
	(360871, 124, '2015-01-15 00:23:49.000000', 'consum', 0.0226, 'lps'),
	(360872, 124, '2015-01-15 00:23:50.000000', 'consum', 0.0217, 'lps'),
	(360873, 124, '2015-01-15 00:23:51.000000', 'consum', 0.0219, 'lps'),
	(360874, 124, '2015-01-15 00:23:52.000000', 'consum', 0.0214, 'lps'),
	(360875, 124, '2015-01-15 00:23:53.000000', 'consum', 0.0225, 'lps'),
	(360876, 124, '2015-01-15 00:23:54.000000', 'consum', 0.0228, 'lps'),
	(360877, 124, '2015-01-15 00:23:55.000000', 'consum', 0.0212, 'lps'),
	(360878, 124, '2015-01-15 00:23:56.000000', 'consum', 0.0210, 'lps'),
	(360879, 124, '2015-01-15 00:23:57.000000', 'consum', 0.0226, 'lps'),
	(360880, 124, '2015-01-15 00:23:58.000000', 'consum', 0.0225, 'lps'),
	(360881, 124, '2015-01-15 00:23:59.000000', 'consum', 0.0216, 'lps'),
	(360882, 124, '2015-01-15 00:24:00.000000', 'consum', 0.0217, 'lps'),
	(360883, 124, '2015-01-15 00:24:01.000000', 'consum', 0.0228, 'lps'),
	(360884, 124, '2015-01-15 00:24:02.000000', 'consum', 0.0212, 'lps'),
	(360885, 124, '2015-01-15 00:24:03.000000', 'consum', 0.0213, 'lps'),
	(360886, 124, '2015-01-15 00:24:04.000000', 'consum', 0.0217, 'lps'),
	(360887, 124, '2015-01-15 00:24:05.000000', 'consum', 0.0215, 'lps'),
	(360888, 124, '2015-01-15 00:24:06.000000', 'consum', 0.0214, 'lps'),
	(360889, 124, '2015-01-15 00:24:07.000000', 'consum', 0.0218, 'lps'),
	(360890, 124, '2015-01-15 00:24:08.000000', 'consum', 0.0214, 'lps'),
	(360891, 124, '2015-01-15 00:24:09.000000', 'consum', 0.0230, 'lps'),
	(360892, 124, '2015-01-15 00:24:10.000000', 'consum', 0.0230, 'lps'),
	(360893, 124, '2015-01-15 00:24:11.000000', 'consum', 0.0210, 'lps'),
	(360894, 124, '2015-01-15 00:24:12.000000', 'consum', 0.0213, 'lps'),
	(360895, 124, '2015-01-15 00:24:13.000000', 'consum', 0.0227, 'lps'),
	(360896, 124, '2015-01-15 00:24:14.000000', 'consum', 0.0221, 'lps'),
	(360897, 124, '2015-01-15 00:24:15.000000', 'consum', 0.0212, 'lps'),
	(360898, 124, '2015-01-15 00:24:16.000000', 'consum', 0.0211, 'lps'),
	(360899, 124, '2015-01-15 00:24:17.000000', 'consum', 0.0210, 'lps'),
	(360900, 124, '2015-01-15 00:24:18.000000', 'consum', 0.0227, 'lps'),
	(360901, 124, '2015-01-15 00:24:19.000000', 'consum', 0.0210, 'lps'),
	(360902, 124, '2015-01-15 00:24:20.000000', 'consum', 0.0225, 'lps'),
	(360903, 124, '2015-01-15 00:24:21.000000', 'consum', 0.0218, 'lps'),
	(360904, 124, '2015-01-15 00:24:22.000000', 'consum', 0.0230, 'lps'),
	(360905, 124, '2015-01-15 00:24:23.000000', 'consum', 0.0220, 'lps'),
	(360906, 124, '2015-01-15 00:24:24.000000', 'consum', 0.0221, 'lps'),
	(360907, 124, '2015-01-15 00:24:25.000000', 'consum', 0.0212, 'lps'),
	(360908, 124, '2015-01-15 00:24:26.000000', 'consum', 0.0212, 'lps'),
	(360909, 124, '2015-01-15 00:24:27.000000', 'consum', 0.0213, 'lps'),
	(360910, 124, '2015-01-15 00:24:28.000000', 'consum', 0.0219, 'lps'),
	(360911, 124, '2015-01-15 00:24:29.000000', 'consum', 0.0224, 'lps'),
	(360912, 124, '2015-01-15 00:24:30.000000', 'consum', 0.0211, 'lps'),
	(360913, 124, '2015-01-15 00:24:31.000000', 'consum', 0.0216, 'lps'),
	(360914, 124, '2015-01-15 00:24:32.000000', 'consum', 0.0216, 'lps'),
	(360915, 124, '2015-01-15 00:24:33.000000', 'consum', 0.0225, 'lps'),
	(360916, 124, '2015-01-15 00:24:34.000000', 'consum', 0.0221, 'lps'),
	(360917, 124, '2015-01-15 00:24:35.000000', 'consum', 0.0220, 'lps'),
	(360918, 124, '2015-01-15 00:24:36.000000', 'consum', 0.0227, 'lps'),
	(360919, 124, '2015-01-15 00:24:37.000000', 'consum', 0.0223, 'lps'),
	(360920, 124, '2015-01-15 00:24:38.000000', 'consum', 0.0224, 'lps'),
	(360921, 124, '2015-01-15 00:24:39.000000', 'consum', 0.0218, 'lps'),
	(360922, 124, '2015-01-15 00:24:40.000000', 'consum', 0.0231, 'lps'),
	(360923, 124, '2015-01-15 00:24:41.000000', 'consum', 0.0225, 'lps'),
	(360924, 124, '2015-01-15 00:24:42.000000', 'consum', 0.0224, 'lps'),
	(360925, 124, '2015-01-15 00:24:43.000000', 'consum', 0.0213, 'lps'),
	(360926, 124, '2015-01-15 00:24:44.000000', 'consum', 0.0226, 'lps'),
	(360927, 124, '2015-01-15 00:24:45.000000', 'consum', 0.0216, 'lps'),
	(360928, 124, '2015-01-15 00:24:46.000000', 'consum', 0.0216, 'lps'),
	(360929, 124, '2015-01-15 00:24:47.000000', 'consum', 0.0222, 'lps'),
	(360930, 124, '2015-01-15 00:24:48.000000', 'consum', 0.0229, 'lps'),
	(360931, 124, '2015-01-15 00:24:49.000000', 'consum', 0.0226, 'lps'),
	(360932, 124, '2015-01-15 00:24:50.000000', 'consum', 0.0210, 'lps'),
	(360933, 124, '2015-01-15 00:24:51.000000', 'consum', 0.0231, 'lps'),
	(360934, 124, '2015-01-15 00:24:52.000000', 'consum', 0.0227, 'lps'),
	(360935, 124, '2015-01-15 00:24:53.000000', 'consum', 0.0212, 'lps'),
	(360936, 124, '2015-01-15 00:24:54.000000', 'consum', 0.0212, 'lps'),
	(360937, 124, '2015-01-15 00:24:55.000000', 'consum', 0.0214, 'lps'),
	(360938, 124, '2015-01-15 00:24:56.000000', 'consum', 0.0225, 'lps'),
	(360939, 124, '2015-01-15 00:24:57.000000', 'consum', 0.0228, 'lps'),
	(360940, 124, '2015-01-15 00:24:58.000000', 'consum', 0.0211, 'lps'),
	(360941, 124, '2015-01-15 00:24:59.000000', 'consum', 0.0229, 'lps'),
	(360942, 124, '2015-01-15 00:25:00.000000', 'consum', 0.0214, 'lps'),
	(360943, 124, '2015-01-15 00:25:01.000000', 'consum', 0.0217, 'lps'),
	(360944, 124, '2015-01-15 00:25:02.000000', 'consum', 0.0213, 'lps'),
	(360945, 124, '2015-01-15 00:25:03.000000', 'consum', 0.0227, 'lps'),
	(360946, 124, '2015-01-15 00:25:04.000000', 'consum', 0.0221, 'lps'),
	(360947, 124, '2015-01-15 00:25:05.000000', 'consum', 0.0213, 'lps'),
	(360948, 124, '2015-01-15 00:25:06.000000', 'consum', 0.0214, 'lps'),
	(360949, 124, '2015-01-15 00:25:07.000000', 'consum', 0.0222, 'lps'),
	(360950, 124, '2015-01-15 00:25:08.000000', 'consum', 0.0214, 'lps'),
	(360951, 124, '2015-01-15 00:25:09.000000', 'consum', 0.0215, 'lps'),
	(360952, 124, '2015-01-15 00:25:10.000000', 'consum', 0.0227, 'lps'),
	(360953, 124, '2015-01-15 00:25:11.000000', 'consum', 0.0212, 'lps'),
	(360954, 124, '2015-01-15 00:25:12.000000', 'consum', 0.0214, 'lps'),
	(360955, 124, '2015-01-15 00:25:13.000000', 'consum', 0.0223, 'lps'),
	(360956, 124, '2015-01-15 00:25:14.000000', 'consum', 0.0220, 'lps'),
	(360957, 124, '2015-01-15 00:25:15.000000', 'consum', 0.0220, 'lps'),
	(360958, 124, '2015-01-15 00:25:16.000000', 'consum', 0.0211, 'lps'),
	(360959, 124, '2015-01-15 00:25:17.000000', 'consum', 0.0227, 'lps'),
	(360960, 124, '2015-01-15 00:25:18.000000', 'consum', 0.0226, 'lps'),
	(360961, 124, '2015-01-15 00:25:19.000000', 'consum', 0.0220, 'lps'),
	(360962, 124, '2015-01-15 00:25:20.000000', 'consum', 0.0212, 'lps'),
	(360963, 124, '2015-01-15 00:25:21.000000', 'consum', 0.0213, 'lps'),
	(360964, 124, '2015-01-15 00:25:22.000000', 'consum', 0.0220, 'lps'),
	(360965, 124, '2015-01-15 00:25:23.000000', 'consum', 0.0231, 'lps'),
	(360966, 124, '2015-01-15 00:25:24.000000', 'consum', 0.0216, 'lps'),
	(360967, 124, '2015-01-15 00:25:25.000000', 'consum', 0.0223, 'lps'),
	(360968, 124, '2015-01-15 00:25:26.000000', 'consum', 0.0216, 'lps'),
	(360969, 124, '2015-01-15 00:25:27.000000', 'consum', 0.0220, 'lps'),
	(360970, 124, '2015-01-15 00:25:28.000000', 'consum', 0.0220, 'lps'),
	(360971, 124, '2015-01-15 00:25:29.000000', 'consum', 0.0230, 'lps'),
	(360972, 124, '2015-01-15 00:25:30.000000', 'consum', 0.0217, 'lps'),
	(360973, 124, '2015-01-15 00:25:31.000000', 'consum', 0.0230, 'lps'),
	(360974, 124, '2015-01-15 00:25:32.000000', 'consum', 0.0224, 'lps'),
	(360975, 124, '2015-01-15 00:25:33.000000', 'consum', 0.0222, 'lps'),
	(360976, 124, '2015-01-15 00:25:34.000000', 'consum', 0.0225, 'lps'),
	(360977, 124, '2015-01-15 00:25:35.000000', 'consum', 0.0227, 'lps'),
	(360978, 124, '2015-01-15 00:25:36.000000', 'consum', 0.0230, 'lps'),
	(360979, 124, '2015-01-15 00:25:37.000000', 'consum', 0.0214, 'lps'),
	(360980, 124, '2015-01-15 00:25:38.000000', 'consum', 0.0215, 'lps'),
	(360981, 124, '2015-01-15 00:25:39.000000', 'consum', 0.0225, 'lps'),
	(360982, 124, '2015-01-15 00:25:40.000000', 'consum', 0.0224, 'lps'),
	(360983, 124, '2015-01-15 00:25:41.000000', 'consum', 0.0216, 'lps'),
	(360984, 124, '2015-01-15 00:25:42.000000', 'consum', 0.0220, 'lps'),
	(360985, 124, '2015-01-15 00:25:43.000000', 'consum', 0.0222, 'lps'),
	(360986, 124, '2015-01-15 00:25:44.000000', 'consum', 0.0217, 'lps'),
	(360987, 124, '2015-01-15 00:25:45.000000', 'consum', 0.0211, 'lps'),
	(360988, 124, '2015-01-15 00:25:46.000000', 'consum', 0.0214, 'lps'),
	(360989, 124, '2015-01-15 00:25:47.000000', 'consum', 0.0228, 'lps'),
	(360990, 124, '2015-01-15 00:25:48.000000', 'consum', 0.0225, 'lps'),
	(360991, 124, '2015-01-15 00:25:49.000000', 'consum', 0.0229, 'lps'),
	(360992, 124, '2015-01-15 00:25:50.000000', 'consum', 0.0216, 'lps'),
	(360993, 124, '2015-01-15 00:25:51.000000', 'consum', 0.0226, 'lps'),
	(360994, 124, '2015-01-15 00:25:52.000000', 'consum', 0.0231, 'lps'),
	(360995, 124, '2015-01-15 00:25:53.000000', 'consum', 0.0224, 'lps'),
	(360996, 124, '2015-01-15 00:25:54.000000', 'consum', 0.0215, 'lps'),
	(360997, 124, '2015-01-15 00:25:55.000000', 'consum', 0.0215, 'lps'),
	(360998, 124, '2015-01-15 00:25:56.000000', 'consum', 0.0223, 'lps'),
	(360999, 124, '2015-01-15 00:25:57.000000', 'consum', 0.0216, 'lps'),
	(361000, 124, '2015-01-15 00:25:58.000000', 'consum', 0.0224, 'lps'),
	(361001, 124, '2015-01-15 00:25:59.000000', 'consum', 0.0218, 'lps'),
	(361002, 124, '2015-01-15 00:26:00.000000', 'consum', 0.0229, 'lps'),
	(361003, 124, '2015-01-15 00:26:01.000000', 'consum', 0.0215, 'lps'),
	(361004, 124, '2015-01-15 00:26:02.000000', 'consum', 0.0225, 'lps'),
	(361005, 124, '2015-01-15 00:26:03.000000', 'consum', 0.0225, 'lps'),
	(361006, 124, '2015-01-15 00:26:04.000000', 'consum', 0.0219, 'lps'),
	(361007, 124, '2015-01-15 00:26:05.000000', 'consum', 0.0212, 'lps'),
	(361008, 124, '2015-01-15 00:26:06.000000', 'consum', 0.0214, 'lps'),
	(361009, 124, '2015-01-15 00:26:07.000000', 'consum', 0.0224, 'lps'),
	(361010, 124, '2015-01-15 00:26:08.000000', 'consum', 0.0226, 'lps'),
	(361011, 124, '2015-01-15 00:26:09.000000', 'consum', 0.0225, 'lps'),
	(361012, 124, '2015-01-15 00:26:10.000000', 'consum', 0.0215, 'lps'),
	(361013, 124, '2015-01-15 00:26:11.000000', 'consum', 0.0213, 'lps'),
	(361014, 124, '2015-01-15 00:26:12.000000', 'consum', 0.0231, 'lps'),
	(361015, 124, '2015-01-15 00:26:13.000000', 'consum', 0.0220, 'lps'),
	(361016, 124, '2015-01-15 00:26:14.000000', 'consum', 0.0217, 'lps'),
	(361017, 124, '2015-01-15 00:26:15.000000', 'consum', 0.0218, 'lps'),
	(361018, 124, '2015-01-15 00:26:16.000000', 'consum', 0.0228, 'lps'),
	(361019, 124, '2015-01-15 00:26:17.000000', 'consum', 0.0211, 'lps'),
	(361020, 124, '2015-01-15 00:26:18.000000', 'consum', 0.0228, 'lps'),
	(361021, 124, '2015-01-15 00:26:19.000000', 'consum', 0.0211, 'lps'),
	(361022, 124, '2015-01-15 00:26:20.000000', 'consum', 0.0225, 'lps'),
	(361023, 124, '2015-01-15 00:26:21.000000', 'consum', 0.0215, 'lps'),
	(361024, 124, '2015-01-15 00:26:22.000000', 'consum', 0.0216, 'lps'),
	(361025, 124, '2015-01-15 00:26:23.000000', 'consum', 0.0225, 'lps'),
	(361026, 124, '2015-01-15 00:26:24.000000', 'consum', 0.0225, 'lps'),
	(361027, 124, '2015-01-15 00:26:25.000000', 'consum', 0.0215, 'lps'),
	(361028, 124, '2015-01-15 00:26:26.000000', 'consum', 0.0214, 'lps'),
	(361029, 124, '2015-01-15 00:26:27.000000', 'consum', 0.0217, 'lps'),
	(361030, 124, '2015-01-15 00:26:28.000000', 'consum', 0.0231, 'lps'),
	(361031, 124, '2015-01-15 00:26:29.000000', 'consum', 0.0229, 'lps'),
	(361032, 124, '2015-01-15 00:26:30.000000', 'consum', 0.0223, 'lps'),
	(361033, 124, '2015-01-15 00:26:31.000000', 'consum', 0.0216, 'lps'),
	(361034, 124, '2015-01-15 00:26:32.000000', 'consum', 0.0224, 'lps'),
	(361035, 124, '2015-01-15 00:26:33.000000', 'consum', 0.0221, 'lps'),
	(361036, 124, '2015-01-15 00:26:34.000000', 'consum', 0.0220, 'lps'),
	(361037, 124, '2015-01-15 00:26:35.000000', 'consum', 0.0231, 'lps'),
	(361038, 124, '2015-01-15 00:26:36.000000', 'consum', 0.0216, 'lps'),
	(361039, 124, '2015-01-15 00:26:37.000000', 'consum', 0.0222, 'lps'),
	(361040, 124, '2015-01-15 00:26:38.000000', 'consum', 0.0211, 'lps'),
	(361041, 124, '2015-01-15 00:26:39.000000', 'consum', 0.0222, 'lps'),
	(361042, 124, '2015-01-15 00:26:40.000000', 'consum', 0.0222, 'lps'),
	(361043, 124, '2015-01-15 00:26:41.000000', 'consum', 0.0215, 'lps'),
	(361044, 124, '2015-01-15 00:26:42.000000', 'consum', 0.0219, 'lps'),
	(361045, 124, '2015-01-15 00:26:43.000000', 'consum', 0.0219, 'lps'),
	(361046, 124, '2015-01-15 00:26:44.000000', 'consum', 0.0230, 'lps'),
	(361047, 124, '2015-01-15 00:26:45.000000', 'consum', 0.0218, 'lps'),
	(361048, 124, '2015-01-15 00:26:46.000000', 'consum', 0.0210, 'lps'),
	(361049, 124, '2015-01-15 00:26:47.000000', 'consum', 0.0210, 'lps'),
	(361050, 124, '2015-01-15 00:26:48.000000', 'consum', 0.0212, 'lps'),
	(361051, 124, '2015-01-15 00:26:49.000000', 'consum', 0.0219, 'lps'),
	(361052, 124, '2015-01-15 00:26:50.000000', 'consum', 0.0227, 'lps'),
	(361053, 124, '2015-01-15 00:26:51.000000', 'consum', 0.0225, 'lps'),
	(361054, 124, '2015-01-15 00:26:52.000000', 'consum', 0.0210, 'lps'),
	(361055, 124, '2015-01-15 00:26:53.000000', 'consum', 0.0213, 'lps'),
	(361056, 124, '2015-01-15 00:26:54.000000', 'consum', 0.0224, 'lps'),
	(361057, 124, '2015-01-15 00:26:55.000000', 'consum', 0.0226, 'lps'),
	(361058, 124, '2015-01-15 00:26:56.000000', 'consum', 0.0227, 'lps'),
	(361059, 124, '2015-01-15 00:26:57.000000', 'consum', 0.0226, 'lps'),
	(361060, 124, '2015-01-15 00:26:58.000000', 'consum', 0.0217, 'lps'),
	(361061, 124, '2015-01-15 00:26:59.000000', 'consum', 0.0220, 'lps'),
	(361062, 124, '2015-01-15 00:27:00.000000', 'consum', 0.0218, 'lps'),
	(361063, 124, '2015-01-15 00:27:01.000000', 'consum', 0.0218, 'lps'),
	(361064, 124, '2015-01-15 00:27:02.000000', 'consum', 0.0228, 'lps'),
	(361065, 124, '2015-01-15 00:27:03.000000', 'consum', 0.0213, 'lps'),
	(361066, 124, '2015-01-15 00:27:04.000000', 'consum', 0.0212, 'lps'),
	(361067, 124, '2015-01-15 00:27:05.000000', 'consum', 0.0212, 'lps'),
	(361068, 124, '2015-01-15 00:27:06.000000', 'consum', 0.0217, 'lps'),
	(361069, 124, '2015-01-15 00:27:07.000000', 'consum', 0.0216, 'lps'),
	(361070, 124, '2015-01-15 00:27:08.000000', 'consum', 0.0218, 'lps'),
	(361071, 124, '2015-01-15 00:27:09.000000', 'consum', 0.0213, 'lps'),
	(361072, 124, '2015-01-15 00:27:10.000000', 'consum', 0.0221, 'lps'),
	(361073, 124, '2015-01-15 00:27:11.000000', 'consum', 0.0216, 'lps'),
	(361074, 124, '2015-01-15 00:27:12.000000', 'consum', 0.0226, 'lps'),
	(361075, 124, '2015-01-15 00:27:13.000000', 'consum', 0.0230, 'lps'),
	(361076, 124, '2015-01-15 00:27:14.000000', 'consum', 0.0217, 'lps'),
	(361077, 124, '2015-01-15 00:27:15.000000', 'consum', 0.0231, 'lps'),
	(361078, 124, '2015-01-15 00:27:16.000000', 'consum', 0.0229, 'lps'),
	(361079, 124, '2015-01-15 00:27:17.000000', 'consum', 0.0221, 'lps'),
	(361080, 124, '2015-01-15 00:27:18.000000', 'consum', 0.0228, 'lps'),
	(361081, 124, '2015-01-15 00:27:19.000000', 'consum', 0.0227, 'lps'),
	(361082, 124, '2015-01-15 00:27:20.000000', 'consum', 0.0217, 'lps'),
	(361083, 124, '2015-01-15 00:27:21.000000', 'consum', 0.0217, 'lps'),
	(361084, 124, '2015-01-15 00:27:22.000000', 'consum', 0.0223, 'lps'),
	(361085, 124, '2015-01-15 00:27:23.000000', 'consum', 0.0211, 'lps'),
	(361086, 124, '2015-01-15 00:27:24.000000', 'consum', 0.0222, 'lps'),
	(361087, 124, '2015-01-15 00:27:25.000000', 'consum', 0.0223, 'lps'),
	(361088, 124, '2015-01-15 00:27:26.000000', 'consum', 0.0218, 'lps'),
	(361089, 124, '2015-01-15 00:27:27.000000', 'consum', 0.0213, 'lps'),
	(361090, 124, '2015-01-15 00:27:28.000000', 'consum', 0.0221, 'lps'),
	(361091, 124, '2015-01-15 00:27:29.000000', 'consum', 0.0214, 'lps'),
	(361092, 124, '2015-01-15 00:27:30.000000', 'consum', 0.0220, 'lps'),
	(361093, 124, '2015-01-15 00:27:31.000000', 'consum', 0.0227, 'lps'),
	(361094, 124, '2015-01-15 00:27:32.000000', 'consum', 0.0221, 'lps'),
	(361095, 124, '2015-01-15 00:27:33.000000', 'consum', 0.0213, 'lps'),
	(361096, 124, '2015-01-15 00:27:34.000000', 'consum', 0.0215, 'lps'),
	(361097, 124, '2015-01-15 00:27:35.000000', 'consum', 0.0227, 'lps'),
	(361098, 124, '2015-01-15 00:27:36.000000', 'consum', 0.0213, 'lps'),
	(361099, 124, '2015-01-15 00:27:37.000000', 'consum', 0.0217, 'lps'),
	(361100, 124, '2015-01-15 00:27:38.000000', 'consum', 0.0218, 'lps'),
	(361101, 124, '2015-01-15 00:27:39.000000', 'consum', 0.0228, 'lps'),
	(361102, 124, '2015-01-15 00:27:40.000000', 'consum', 0.0211, 'lps'),
	(361103, 124, '2015-01-15 00:27:41.000000', 'consum', 0.0228, 'lps'),
	(361104, 124, '2015-01-15 00:27:42.000000', 'consum', 0.0230, 'lps'),
	(361105, 124, '2015-01-15 00:27:43.000000', 'consum', 0.0215, 'lps'),
	(361106, 124, '2015-01-15 00:27:44.000000', 'consum', 0.0217, 'lps'),
	(361107, 124, '2015-01-15 00:27:45.000000', 'consum', 0.0211, 'lps'),
	(361108, 124, '2015-01-15 00:27:46.000000', 'consum', 0.0215, 'lps'),
	(361109, 124, '2015-01-15 00:27:47.000000', 'consum', 0.0210, 'lps'),
	(361110, 124, '2015-01-15 00:27:48.000000', 'consum', 0.0218, 'lps'),
	(361111, 124, '2015-01-15 00:27:49.000000', 'consum', 0.0229, 'lps'),
	(361112, 124, '2015-01-15 00:27:50.000000', 'consum', 0.0216, 'lps'),
	(361113, 124, '2015-01-15 00:27:51.000000', 'consum', 0.0228, 'lps'),
	(361114, 124, '2015-01-15 00:27:52.000000', 'consum', 0.0217, 'lps'),
	(361115, 124, '2015-01-15 00:27:53.000000', 'consum', 0.0215, 'lps'),
	(361116, 124, '2015-01-15 00:27:54.000000', 'consum', 0.0212, 'lps'),
	(361117, 124, '2015-01-15 00:27:55.000000', 'consum', 0.0226, 'lps'),
	(361118, 124, '2015-01-15 00:27:56.000000', 'consum', 0.0222, 'lps'),
	(361119, 124, '2015-01-15 00:27:57.000000', 'consum', 0.0221, 'lps'),
	(361120, 124, '2015-01-15 00:27:58.000000', 'consum', 0.0228, 'lps'),
	(361121, 124, '2015-01-15 00:27:59.000000', 'consum', 0.0225, 'lps'),
	(361122, 124, '2015-01-15 00:28:00.000000', 'consum', 0.0231, 'lps'),
	(361123, 124, '2015-01-15 00:28:01.000000', 'consum', 0.0228, 'lps'),
	(361124, 124, '2015-01-15 00:28:02.000000', 'consum', 0.0214, 'lps'),
	(361125, 124, '2015-01-15 00:28:03.000000', 'consum', 0.0219, 'lps'),
	(361126, 124, '2015-01-15 00:28:04.000000', 'consum', 0.0225, 'lps'),
	(361127, 124, '2015-01-15 00:28:05.000000', 'consum', 0.0212, 'lps'),
	(361128, 124, '2015-01-15 00:28:06.000000', 'consum', 0.0222, 'lps'),
	(361129, 124, '2015-01-15 00:28:07.000000', 'consum', 0.0220, 'lps'),
	(361130, 124, '2015-01-15 00:28:08.000000', 'consum', 0.0224, 'lps'),
	(361131, 124, '2015-01-15 00:28:09.000000', 'consum', 0.0229, 'lps'),
	(361132, 124, '2015-01-15 00:28:10.000000', 'consum', 0.0219, 'lps'),
	(361133, 124, '2015-01-15 00:28:11.000000', 'consum', 0.0219, 'lps'),
	(361134, 124, '2015-01-15 00:28:12.000000', 'consum', 0.0230, 'lps'),
	(361135, 124, '2015-01-15 00:28:13.000000', 'consum', 0.0217, 'lps'),
	(361136, 124, '2015-01-15 00:28:14.000000', 'consum', 0.0210, 'lps'),
	(361137, 124, '2015-01-15 00:28:15.000000', 'consum', 0.0230, 'lps'),
	(361138, 124, '2015-01-15 00:28:16.000000', 'consum', 0.0224, 'lps'),
	(361139, 124, '2015-01-15 00:28:17.000000', 'consum', 0.0218, 'lps'),
	(361140, 124, '2015-01-15 00:28:18.000000', 'consum', 0.0212, 'lps'),
	(361141, 124, '2015-01-15 00:28:19.000000', 'consum', 0.0217, 'lps'),
	(361142, 124, '2015-01-15 00:28:20.000000', 'consum', 0.0219, 'lps'),
	(361143, 124, '2015-01-15 00:28:21.000000', 'consum', 0.0214, 'lps'),
	(361144, 124, '2015-01-15 00:28:22.000000', 'consum', 0.0222, 'lps'),
	(361145, 124, '2015-01-15 00:28:23.000000', 'consum', 0.0218, 'lps'),
	(361146, 124, '2015-01-15 00:28:24.000000', 'consum', 0.0211, 'lps'),
	(361147, 124, '2015-01-15 00:28:25.000000', 'consum', 0.0217, 'lps'),
	(361148, 124, '2015-01-15 00:28:26.000000', 'consum', 0.0219, 'lps'),
	(361149, 124, '2015-01-15 00:28:27.000000', 'consum', 0.0212, 'lps'),
	(361150, 124, '2015-01-15 00:28:28.000000', 'consum', 0.0216, 'lps'),
	(361151, 124, '2015-01-15 00:28:29.000000', 'consum', 0.0213, 'lps'),
	(361152, 124, '2015-01-15 00:28:30.000000', 'consum', 0.0230, 'lps'),
	(361153, 124, '2015-01-15 00:28:31.000000', 'consum', 0.0214, 'lps'),
	(361154, 124, '2015-01-15 00:28:32.000000', 'consum', 0.0212, 'lps'),
	(361155, 124, '2015-01-15 00:28:33.000000', 'consum', 0.0210, 'lps'),
	(361156, 124, '2015-01-15 00:28:34.000000', 'consum', 0.0226, 'lps'),
	(361157, 124, '2015-01-15 00:28:35.000000', 'consum', 0.0223, 'lps'),
	(361158, 124, '2015-01-15 00:28:36.000000', 'consum', 0.0230, 'lps'),
	(361159, 124, '2015-01-15 00:28:37.000000', 'consum', 0.0225, 'lps'),
	(361160, 124, '2015-01-15 00:28:38.000000', 'consum', 0.0225, 'lps'),
	(361161, 124, '2015-01-15 00:28:39.000000', 'consum', 0.0221, 'lps'),
	(361162, 124, '2015-01-15 00:28:40.000000', 'consum', 0.0220, 'lps'),
	(361163, 124, '2015-01-15 00:28:41.000000', 'consum', 0.0227, 'lps'),
	(361164, 124, '2015-01-15 00:28:42.000000', 'consum', 0.0221, 'lps'),
	(361165, 124, '2015-01-15 00:28:43.000000', 'consum', 0.0216, 'lps'),
	(361166, 124, '2015-01-15 00:28:44.000000', 'consum', 0.0230, 'lps'),
	(361167, 124, '2015-01-15 00:28:45.000000', 'consum', 0.0225, 'lps'),
	(361168, 124, '2015-01-15 00:28:46.000000', 'consum', 0.0224, 'lps'),
	(361169, 124, '2015-01-15 00:28:47.000000', 'consum', 0.0216, 'lps'),
	(361170, 124, '2015-01-15 00:28:48.000000', 'consum', 0.0220, 'lps'),
	(361171, 124, '2015-01-15 00:28:49.000000', 'consum', 0.0222, 'lps'),
	(361172, 124, '2015-01-15 00:28:50.000000', 'consum', 0.0216, 'lps'),
	(361173, 124, '2015-01-15 00:28:51.000000', 'consum', 0.0225, 'lps'),
	(361174, 124, '2015-01-15 00:28:52.000000', 'consum', 0.0227, 'lps'),
	(361175, 124, '2015-01-15 00:28:53.000000', 'consum', 0.0226, 'lps'),
	(361176, 124, '2015-01-15 00:28:54.000000', 'consum', 0.0219, 'lps'),
	(361177, 124, '2015-01-15 00:28:55.000000', 'consum', 0.0228, 'lps'),
	(361178, 124, '2015-01-15 00:28:56.000000', 'consum', 0.0210, 'lps'),
	(361179, 124, '2015-01-15 00:28:57.000000', 'consum', 0.0220, 'lps'),
	(361180, 124, '2015-01-15 00:28:58.000000', 'consum', 0.0218, 'lps'),
	(361181, 124, '2015-01-15 00:28:59.000000', 'consum', 0.0222, 'lps'),
	(361182, 124, '2015-01-15 00:29:00.000000', 'consum', 0.0223, 'lps'),
	(361183, 124, '2015-01-15 00:29:01.000000', 'consum', 0.0217, 'lps'),
	(361184, 124, '2015-01-15 00:29:02.000000', 'consum', 0.0229, 'lps'),
	(361185, 124, '2015-01-15 00:29:03.000000', 'consum', 0.0217, 'lps'),
	(361186, 124, '2015-01-15 00:29:04.000000', 'consum', 0.0211, 'lps'),
	(361187, 124, '2015-01-15 00:29:05.000000', 'consum', 0.0218, 'lps'),
	(361188, 124, '2015-01-15 00:29:06.000000', 'consum', 0.0224, 'lps'),
	(361189, 124, '2015-01-15 00:29:07.000000', 'consum', 0.0213, 'lps'),
	(361190, 124, '2015-01-15 00:29:08.000000', 'consum', 0.0228, 'lps'),
	(361191, 124, '2015-01-15 00:29:09.000000', 'consum', 0.0225, 'lps'),
	(361192, 124, '2015-01-15 00:29:10.000000', 'consum', 0.0231, 'lps'),
	(361193, 124, '2015-01-15 00:29:11.000000', 'consum', 0.0227, 'lps'),
	(361194, 124, '2015-01-15 00:29:12.000000', 'consum', 0.0210, 'lps'),
	(361195, 124, '2015-01-15 00:29:13.000000', 'consum', 0.0226, 'lps'),
	(361196, 124, '2015-01-15 00:29:14.000000', 'consum', 0.0226, 'lps'),
	(361197, 124, '2015-01-15 00:29:15.000000', 'consum', 0.0219, 'lps'),
	(361198, 124, '2015-01-15 00:29:16.000000', 'consum', 0.0231, 'lps'),
	(361199, 124, '2015-01-15 00:29:17.000000', 'consum', 0.0222, 'lps'),
	(361200, 124, '2015-01-15 00:29:18.000000', 'consum', 0.0231, 'lps'),
	(361201, 124, '2015-01-15 00:29:19.000000', 'consum', 0.0212, 'lps'),
	(361202, 124, '2015-01-15 00:29:20.000000', 'consum', 0.0222, 'lps'),
	(361203, 124, '2015-01-15 00:29:21.000000', 'consum', 0.0222, 'lps'),
	(361204, 124, '2015-01-15 00:29:22.000000', 'consum', 0.0212, 'lps'),
	(361205, 124, '2015-01-15 00:29:23.000000', 'consum', 0.0229, 'lps'),
	(361206, 124, '2015-01-15 00:29:24.000000', 'consum', 0.0213, 'lps'),
	(361207, 124, '2015-01-15 00:29:25.000000', 'consum', 0.0211, 'lps'),
	(361208, 124, '2015-01-15 00:29:26.000000', 'consum', 0.0228, 'lps'),
	(361209, 124, '2015-01-15 00:29:27.000000', 'consum', 0.0230, 'lps'),
	(361210, 124, '2015-01-15 00:29:28.000000', 'consum', 0.0215, 'lps'),
	(361211, 124, '2015-01-15 00:29:29.000000', 'consum', 0.0217, 'lps'),
	(361212, 124, '2015-01-15 00:29:30.000000', 'consum', 0.0231, 'lps'),
	(361213, 124, '2015-01-15 00:29:31.000000', 'consum', 0.0231, 'lps'),
	(361214, 124, '2015-01-15 00:29:32.000000', 'consum', 0.0229, 'lps'),
	(361215, 124, '2015-01-15 00:29:33.000000', 'consum', 0.0219, 'lps'),
	(361216, 124, '2015-01-15 00:29:34.000000', 'consum', 0.0219, 'lps'),
	(361217, 124, '2015-01-15 00:29:35.000000', 'consum', 0.0210, 'lps'),
	(361218, 124, '2015-01-15 00:29:36.000000', 'consum', 0.0228, 'lps'),
	(361219, 124, '2015-01-15 00:29:37.000000', 'consum', 0.0211, 'lps'),
	(361220, 124, '2015-01-15 00:29:38.000000', 'consum', 0.0227, 'lps'),
	(361221, 124, '2015-01-15 00:29:39.000000', 'consum', 0.0225, 'lps'),
	(361222, 124, '2015-01-15 00:29:40.000000', 'consum', 0.0214, 'lps'),
	(361223, 124, '2015-01-15 00:29:41.000000', 'consum', 0.0228, 'lps'),
	(361224, 124, '2015-01-15 00:29:42.000000', 'consum', 0.0222, 'lps'),
	(361225, 124, '2015-01-15 00:29:43.000000', 'consum', 0.0217, 'lps'),
	(361226, 124, '2015-01-15 00:29:44.000000', 'consum', 0.0210, 'lps'),
	(361227, 124, '2015-01-15 00:29:45.000000', 'consum', 0.0212, 'lps'),
	(361228, 124, '2015-01-15 00:29:46.000000', 'consum', 0.0220, 'lps'),
	(361229, 124, '2015-01-15 00:29:47.000000', 'consum', 0.0230, 'lps'),
	(361230, 124, '2015-01-15 00:29:48.000000', 'consum', 0.0218, 'lps'),
	(361231, 124, '2015-01-15 00:29:49.000000', 'consum', 0.0213, 'lps'),
	(361232, 124, '2015-01-15 00:29:50.000000', 'consum', 0.0220, 'lps'),
	(361233, 124, '2015-01-15 00:29:51.000000', 'consum', 0.0210, 'lps'),
	(361234, 124, '2015-01-15 00:29:52.000000', 'consum', 0.0225, 'lps'),
	(361235, 124, '2015-01-15 00:29:53.000000', 'consum', 0.0218, 'lps'),
	(361236, 124, '2015-01-15 00:29:54.000000', 'consum', 0.0230, 'lps'),
	(361237, 124, '2015-01-15 00:29:55.000000', 'consum', 0.0218, 'lps'),
	(361238, 124, '2015-01-15 00:29:56.000000', 'consum', 0.0211, 'lps'),
	(361239, 124, '2015-01-15 00:29:57.000000', 'consum', 0.0217, 'lps'),
	(361240, 124, '2015-01-15 00:29:58.000000', 'consum', 0.0218, 'lps'),
	(361241, 124, '2015-01-15 00:29:59.000000', 'consum', 0.0230, 'lps'),
	(361242, 124, '2015-01-15 00:30:00.000000', 'consum', 0.0221, 'lps'),
	(361243, 124, '2015-01-15 00:30:01.000000', 'consum', 0.0229, 'lps'),
	(361244, 124, '2015-01-15 00:30:02.000000', 'consum', 0.0228, 'lps'),
	(361245, 124, '2015-01-15 00:30:03.000000', 'consum', 0.0220, 'lps'),
	(361246, 124, '2015-01-15 00:30:04.000000', 'consum', 0.0228, 'lps'),
	(361247, 124, '2015-01-15 00:30:05.000000', 'consum', 0.0229, 'lps'),
	(361248, 124, '2015-01-15 00:30:06.000000', 'consum', 0.0230, 'lps'),
	(361249, 124, '2015-01-15 00:30:07.000000', 'consum', 0.0231, 'lps'),
	(361250, 124, '2015-01-15 00:30:08.000000', 'consum', 0.0211, 'lps'),
	(361251, 124, '2015-01-15 00:30:09.000000', 'consum', 0.0220, 'lps'),
	(361252, 124, '2015-01-15 00:30:10.000000', 'consum', 0.0212, 'lps'),
	(361253, 124, '2015-01-15 00:30:11.000000', 'consum', 0.0213, 'lps'),
	(361254, 124, '2015-01-15 00:30:12.000000', 'consum', 0.0219, 'lps'),
	(361255, 124, '2015-01-15 00:30:13.000000', 'consum', 0.0224, 'lps'),
	(361256, 124, '2015-01-15 00:30:14.000000', 'consum', 0.0211, 'lps'),
	(361257, 124, '2015-01-15 00:30:15.000000', 'consum', 0.0219, 'lps'),
	(361258, 124, '2015-01-15 00:30:16.000000', 'consum', 0.0228, 'lps'),
	(361259, 124, '2015-01-15 00:30:17.000000', 'consum', 0.0229, 'lps'),
	(361260, 124, '2015-01-15 00:30:18.000000', 'consum', 0.0210, 'lps'),
	(361261, 124, '2015-01-15 00:30:19.000000', 'consum', 0.0220, 'lps'),
	(361262, 124, '2015-01-15 00:30:20.000000', 'consum', 0.0214, 'lps'),
	(361263, 124, '2015-01-15 00:30:21.000000', 'consum', 0.0222, 'lps'),
	(361264, 124, '2015-01-15 00:30:22.000000', 'consum', 0.0217, 'lps'),
	(361265, 124, '2015-01-15 00:30:23.000000', 'consum', 0.0210, 'lps'),
	(361266, 124, '2015-01-15 00:30:24.000000', 'consum', 0.0231, 'lps'),
	(361267, 124, '2015-01-15 00:30:25.000000', 'consum', 0.0229, 'lps'),
	(361268, 124, '2015-01-15 00:30:26.000000', 'consum', 0.0218, 'lps'),
	(361269, 124, '2015-01-15 00:30:27.000000', 'consum', 0.0219, 'lps'),
	(361270, 124, '2015-01-15 00:30:28.000000', 'consum', 0.0230, 'lps'),
	(361271, 124, '2015-01-15 00:30:29.000000', 'consum', 0.0219, 'lps'),
	(361272, 124, '2015-01-15 00:30:30.000000', 'consum', 0.0215, 'lps'),
	(361273, 124, '2015-01-15 00:30:31.000000', 'consum', 0.0230, 'lps'),
	(361274, 124, '2015-01-15 00:30:32.000000', 'consum', 0.0210, 'lps'),
	(361275, 124, '2015-01-15 00:30:33.000000', 'consum', 0.0216, 'lps'),
	(361276, 124, '2015-01-15 00:30:34.000000', 'consum', 0.0220, 'lps'),
	(361277, 124, '2015-01-15 00:30:35.000000', 'consum', 0.0220, 'lps'),
	(361278, 124, '2015-01-15 00:30:36.000000', 'consum', 0.0228, 'lps'),
	(361279, 124, '2015-01-15 00:30:37.000000', 'consum', 0.0230, 'lps'),
	(361280, 124, '2015-01-15 00:30:38.000000', 'consum', 0.0231, 'lps'),
	(361281, 124, '2015-01-15 00:30:39.000000', 'consum', 0.0212, 'lps'),
	(361282, 124, '2015-01-15 00:30:40.000000', 'consum', 0.0226, 'lps'),
	(361283, 124, '2015-01-15 00:30:41.000000', 'consum', 0.0217, 'lps'),
	(361284, 124, '2015-01-15 00:30:42.000000', 'consum', 0.0219, 'lps'),
	(361285, 124, '2015-01-15 00:30:43.000000', 'consum', 0.0212, 'lps'),
	(361286, 124, '2015-01-15 00:30:44.000000', 'consum', 0.0216, 'lps'),
	(361287, 124, '2015-01-15 00:30:45.000000', 'consum', 0.0214, 'lps'),
	(361288, 124, '2015-01-15 00:30:46.000000', 'consum', 0.0231, 'lps'),
	(361289, 124, '2015-01-15 00:30:47.000000', 'consum', 0.0219, 'lps'),
	(361290, 124, '2015-01-15 00:30:48.000000', 'consum', 0.0214, 'lps'),
	(361291, 124, '2015-01-15 00:30:49.000000', 'consum', 0.0227, 'lps'),
	(361292, 124, '2015-01-15 00:30:50.000000', 'consum', 0.0216, 'lps'),
	(361293, 124, '2015-01-15 00:30:51.000000', 'consum', 0.0211, 'lps'),
	(361294, 124, '2015-01-15 00:30:52.000000', 'consum', 0.0222, 'lps'),
	(361295, 124, '2015-01-15 00:30:53.000000', 'consum', 0.0220, 'lps'),
	(361296, 124, '2015-01-15 00:30:54.000000', 'consum', 0.0228, 'lps'),
	(361297, 124, '2015-01-15 00:30:55.000000', 'consum', 0.0223, 'lps'),
	(361298, 124, '2015-01-15 00:30:56.000000', 'consum', 0.0225, 'lps'),
	(361299, 124, '2015-01-15 00:30:57.000000', 'consum', 0.0222, 'lps'),
	(361300, 124, '2015-01-15 00:30:58.000000', 'consum', 0.0225, 'lps'),
	(361301, 124, '2015-01-15 00:30:59.000000', 'consum', 0.0227, 'lps'),
	(361302, 124, '2015-01-15 00:31:00.000000', 'consum', 0.0231, 'lps'),
	(361303, 124, '2015-01-15 00:31:01.000000', 'consum', 0.0221, 'lps'),
	(361304, 124, '2015-01-15 00:31:02.000000', 'consum', 0.0225, 'lps'),
	(361305, 124, '2015-01-15 00:31:03.000000', 'consum', 0.0229, 'lps'),
	(361306, 124, '2015-01-15 00:31:04.000000', 'consum', 0.0217, 'lps'),
	(361307, 124, '2015-01-15 00:31:05.000000', 'consum', 0.0211, 'lps'),
	(361308, 124, '2015-01-15 00:31:06.000000', 'consum', 0.0214, 'lps'),
	(361309, 124, '2015-01-15 00:31:07.000000', 'consum', 0.0230, 'lps'),
	(361310, 124, '2015-01-15 00:31:08.000000', 'consum', 0.0210, 'lps'),
	(361311, 124, '2015-01-15 00:31:09.000000', 'consum', 0.0216, 'lps'),
	(361312, 124, '2015-01-15 00:31:10.000000', 'consum', 0.0219, 'lps'),
	(361313, 124, '2015-01-15 00:31:11.000000', 'consum', 0.0214, 'lps'),
	(361314, 124, '2015-01-15 00:31:12.000000', 'consum', 0.0227, 'lps'),
	(361315, 124, '2015-01-15 00:31:13.000000', 'consum', 0.0219, 'lps'),
	(361316, 124, '2015-01-15 00:31:14.000000', 'consum', 0.0223, 'lps'),
	(361317, 124, '2015-01-15 00:31:15.000000', 'consum', 0.0229, 'lps'),
	(361318, 124, '2015-01-15 00:31:16.000000', 'consum', 0.0221, 'lps'),
	(361319, 124, '2015-01-15 00:31:17.000000', 'consum', 0.0210, 'lps'),
	(361320, 124, '2015-01-15 00:31:18.000000', 'consum', 0.0223, 'lps'),
	(361321, 124, '2015-01-15 00:31:19.000000', 'consum', 0.0229, 'lps'),
	(361322, 124, '2015-01-15 00:31:20.000000', 'consum', 0.0223, 'lps'),
	(361323, 124, '2015-01-15 00:31:21.000000', 'consum', 0.0218, 'lps'),
	(361324, 124, '2015-01-15 00:31:22.000000', 'consum', 0.0214, 'lps'),
	(361325, 124, '2015-01-15 00:31:23.000000', 'consum', 0.0225, 'lps'),
	(361326, 124, '2015-01-15 00:31:24.000000', 'consum', 0.0210, 'lps'),
	(361327, 124, '2015-01-15 00:31:25.000000', 'consum', 0.0210, 'lps'),
	(361328, 124, '2015-01-15 00:31:26.000000', 'consum', 0.0230, 'lps'),
	(361329, 124, '2015-01-15 00:31:27.000000', 'consum', 0.0224, 'lps'),
	(361330, 124, '2015-01-15 00:31:28.000000', 'consum', 0.0221, 'lps'),
	(361331, 124, '2015-01-15 00:31:29.000000', 'consum', 0.0223, 'lps'),
	(361332, 124, '2015-01-15 00:31:30.000000', 'consum', 0.0222, 'lps'),
	(361333, 124, '2015-01-15 00:31:31.000000', 'consum', 0.0231, 'lps'),
	(361334, 124, '2015-01-15 00:31:32.000000', 'consum', 0.0211, 'lps'),
	(361335, 124, '2015-01-15 00:31:33.000000', 'consum', 0.0222, 'lps'),
	(361336, 124, '2015-01-15 00:31:34.000000', 'consum', 0.0220, 'lps'),
	(361337, 124, '2015-01-15 00:31:35.000000', 'consum', 0.0228, 'lps'),
	(361338, 124, '2015-01-15 00:31:36.000000', 'consum', 0.0224, 'lps'),
	(361339, 124, '2015-01-15 00:31:37.000000', 'consum', 0.0226, 'lps'),
	(361340, 124, '2015-01-15 00:31:38.000000', 'consum', 0.0228, 'lps'),
	(361341, 124, '2015-01-15 00:31:39.000000', 'consum', 0.0210, 'lps'),
	(361342, 124, '2015-01-15 00:31:40.000000', 'consum', 0.0222, 'lps'),
	(361343, 124, '2015-01-15 00:31:41.000000', 'consum', 0.0224, 'lps'),
	(361344, 124, '2015-01-15 00:31:42.000000', 'consum', 0.0224, 'lps'),
	(361345, 124, '2015-01-15 00:31:43.000000', 'consum', 0.0218, 'lps'),
	(361346, 124, '2015-01-15 00:31:44.000000', 'consum', 0.0228, 'lps'),
	(361347, 124, '2015-01-15 00:31:45.000000', 'consum', 0.0210, 'lps'),
	(361348, 124, '2015-01-15 00:31:46.000000', 'consum', 0.0223, 'lps'),
	(361349, 124, '2015-01-15 00:31:47.000000', 'consum', 0.0231, 'lps'),
	(361350, 124, '2015-01-15 00:31:48.000000', 'consum', 0.0210, 'lps'),
	(361351, 124, '2015-01-15 00:31:49.000000', 'consum', 0.0216, 'lps'),
	(361352, 124, '2015-01-15 00:31:50.000000', 'consum', 0.0219, 'lps'),
	(361353, 124, '2015-01-15 00:31:51.000000', 'consum', 0.0214, 'lps'),
	(361354, 124, '2015-01-15 00:31:52.000000', 'consum', 0.0225, 'lps'),
	(361355, 124, '2015-01-15 00:31:53.000000', 'consum', 0.0229, 'lps'),
	(361356, 124, '2015-01-15 00:31:54.000000', 'consum', 0.0215, 'lps'),
	(361357, 124, '2015-01-15 00:31:55.000000', 'consum', 0.0225, 'lps'),
	(361358, 124, '2015-01-15 00:31:56.000000', 'consum', 0.0224, 'lps'),
	(361359, 124, '2015-01-15 00:31:57.000000', 'consum', 0.0215, 'lps'),
	(361360, 124, '2015-01-15 00:31:58.000000', 'consum', 0.0217, 'lps'),
	(361361, 124, '2015-01-15 00:31:59.000000', 'consum', 0.0230, 'lps'),
	(361362, 124, '2015-01-15 00:32:00.000000', 'consum', 0.0224, 'lps'),
	(361363, 124, '2015-01-15 00:32:01.000000', 'consum', 0.0221, 'lps'),
	(361364, 124, '2015-01-15 00:32:02.000000', 'consum', 0.0223, 'lps'),
	(361365, 124, '2015-01-15 00:32:03.000000', 'consum', 0.0221, 'lps'),
	(361366, 124, '2015-01-15 00:32:04.000000', 'consum', 0.0226, 'lps'),
	(361367, 124, '2015-01-15 00:32:05.000000', 'consum', 0.0216, 'lps'),
	(361368, 124, '2015-01-15 00:32:06.000000', 'consum', 0.0211, 'lps'),
	(361369, 124, '2015-01-15 00:32:07.000000', 'consum', 0.0221, 'lps'),
	(361370, 124, '2015-01-15 00:32:08.000000', 'consum', 0.0220, 'lps'),
	(361371, 124, '2015-01-15 00:32:09.000000', 'consum', 0.0226, 'lps'),
	(361372, 124, '2015-01-15 00:32:10.000000', 'consum', 0.0217, 'lps'),
	(361373, 124, '2015-01-15 00:32:11.000000', 'consum', 0.0217, 'lps'),
	(361374, 124, '2015-01-15 00:32:12.000000', 'consum', 0.0227, 'lps'),
	(361375, 124, '2015-01-15 00:32:13.000000', 'consum', 0.0210, 'lps'),
	(361376, 124, '2015-01-15 00:32:14.000000', 'consum', 0.0223, 'lps'),
	(361377, 124, '2015-01-15 00:32:15.000000', 'consum', 0.0212, 'lps'),
	(361378, 124, '2015-01-15 00:32:16.000000', 'consum', 0.0226, 'lps'),
	(361379, 124, '2015-01-15 00:32:17.000000', 'consum', 0.0216, 'lps'),
	(361380, 124, '2015-01-15 00:32:18.000000', 'consum', 0.0216, 'lps'),
	(361381, 124, '2015-01-15 00:32:19.000000', 'consum', 0.0223, 'lps'),
	(361382, 124, '2015-01-15 00:32:20.000000', 'consum', 0.0212, 'lps'),
	(361383, 124, '2015-01-15 00:32:21.000000', 'consum', 0.0227, 'lps'),
	(361384, 124, '2015-01-15 00:32:22.000000', 'consum', 0.0224, 'lps'),
	(361385, 124, '2015-01-15 00:32:23.000000', 'consum', 0.0227, 'lps'),
	(361386, 124, '2015-01-15 00:32:24.000000', 'consum', 0.0211, 'lps'),
	(361387, 124, '2015-01-15 00:32:25.000000', 'consum', 0.0231, 'lps'),
	(361388, 124, '2015-01-15 00:32:26.000000', 'consum', 0.0223, 'lps'),
	(361389, 124, '2015-01-15 00:32:27.000000', 'consum', 0.0213, 'lps'),
	(361390, 124, '2015-01-15 00:32:28.000000', 'consum', 0.0210, 'lps'),
	(361391, 124, '2015-01-15 00:32:29.000000', 'consum', 0.0223, 'lps'),
	(361392, 124, '2015-01-15 00:32:30.000000', 'consum', 0.0231, 'lps'),
	(361393, 124, '2015-01-15 00:32:31.000000', 'consum', 0.0211, 'lps'),
	(361394, 124, '2015-01-15 00:32:32.000000', 'consum', 0.0218, 'lps'),
	(361395, 124, '2015-01-15 00:32:33.000000', 'consum', 0.0227, 'lps'),
	(361396, 124, '2015-01-15 00:32:34.000000', 'consum', 0.0226, 'lps'),
	(361397, 124, '2015-01-15 00:32:35.000000', 'consum', 0.0217, 'lps'),
	(361398, 124, '2015-01-15 00:32:36.000000', 'consum', 0.0221, 'lps'),
	(361399, 124, '2015-01-15 00:32:37.000000', 'consum', 0.0220, 'lps'),
	(361400, 124, '2015-01-15 00:32:38.000000', 'consum', 0.0229, 'lps'),
	(361401, 124, '2015-01-15 00:32:39.000000', 'consum', 0.0231, 'lps'),
	(361402, 124, '2015-01-15 00:32:40.000000', 'consum', 0.0216, 'lps'),
	(361403, 124, '2015-01-15 00:32:41.000000', 'consum', 0.0219, 'lps'),
	(361404, 124, '2015-01-15 00:32:42.000000', 'consum', 0.0215, 'lps'),
	(361405, 124, '2015-01-15 00:32:43.000000', 'consum', 0.0231, 'lps'),
	(361406, 124, '2015-01-15 00:32:44.000000', 'consum', 0.0215, 'lps'),
	(361407, 124, '2015-01-15 00:32:45.000000', 'consum', 0.0213, 'lps'),
	(361408, 124, '2015-01-15 00:32:46.000000', 'consum', 0.0213, 'lps'),
	(361409, 124, '2015-01-15 00:32:47.000000', 'consum', 0.0216, 'lps'),
	(361410, 124, '2015-01-15 00:32:48.000000', 'consum', 0.0231, 'lps'),
	(361411, 124, '2015-01-15 00:32:49.000000', 'consum', 0.0231, 'lps'),
	(361412, 124, '2015-01-15 00:32:50.000000', 'consum', 0.0231, 'lps'),
	(361413, 124, '2015-01-15 00:32:51.000000', 'consum', 0.0230, 'lps'),
	(361414, 124, '2015-01-15 00:32:52.000000', 'consum', 0.0226, 'lps'),
	(361415, 124, '2015-01-15 00:32:53.000000', 'consum', 0.0210, 'lps'),
	(361416, 124, '2015-01-15 00:32:54.000000', 'consum', 0.0229, 'lps'),
	(361417, 124, '2015-01-15 00:32:55.000000', 'consum', 0.0215, 'lps'),
	(361418, 124, '2015-01-15 00:32:56.000000', 'consum', 0.0225, 'lps'),
	(361419, 124, '2015-01-15 00:32:57.000000', 'consum', 0.0225, 'lps'),
	(361420, 124, '2015-01-15 00:32:58.000000', 'consum', 0.0217, 'lps'),
	(361421, 124, '2015-01-15 00:32:59.000000', 'consum', 0.0224, 'lps'),
	(361422, 124, '2015-01-15 00:33:00.000000', 'consum', 0.0217, 'lps'),
	(361423, 124, '2015-01-15 00:33:01.000000', 'consum', 0.0226, 'lps'),
	(361424, 124, '2015-01-15 00:33:02.000000', 'consum', 0.0223, 'lps'),
	(361425, 124, '2015-01-15 00:33:03.000000', 'consum', 0.0230, 'lps'),
	(361426, 124, '2015-01-15 00:33:04.000000', 'consum', 0.0226, 'lps'),
	(361427, 124, '2015-01-15 00:33:05.000000', 'consum', 0.0211, 'lps'),
	(361428, 124, '2015-01-15 00:33:06.000000', 'consum', 0.0230, 'lps'),
	(361429, 124, '2015-01-15 00:33:07.000000', 'consum', 0.0223, 'lps'),
	(361430, 124, '2015-01-15 00:33:08.000000', 'consum', 0.0213, 'lps'),
	(361431, 124, '2015-01-15 00:33:09.000000', 'consum', 0.0211, 'lps'),
	(361432, 124, '2015-01-15 00:33:10.000000', 'consum', 0.0228, 'lps'),
	(361433, 124, '2015-01-15 00:33:11.000000', 'consum', 0.0210, 'lps'),
	(361434, 124, '2015-01-15 00:33:12.000000', 'consum', 0.0220, 'lps'),
	(361435, 124, '2015-01-15 00:33:13.000000', 'consum', 0.0218, 'lps'),
	(361436, 124, '2015-01-15 00:33:14.000000', 'consum', 0.0219, 'lps'),
	(361437, 124, '2015-01-15 00:33:15.000000', 'consum', 0.0210, 'lps'),
	(361438, 124, '2015-01-15 00:33:16.000000', 'consum', 0.0226, 'lps'),
	(361439, 124, '2015-01-15 00:33:17.000000', 'consum', 0.0226, 'lps'),
	(361440, 124, '2015-01-15 00:33:18.000000', 'consum', 0.0222, 'lps'),
	(361441, 124, '2015-01-15 00:33:19.000000', 'consum', 0.0221, 'lps'),
	(361442, 124, '2015-01-15 00:33:20.000000', 'consum', 0.0228, 'lps'),
	(361443, 124, '2015-01-15 00:33:21.000000', 'consum', 0.0226, 'lps'),
	(361444, 124, '2015-01-15 00:33:22.000000', 'consum', 0.0213, 'lps'),
	(361445, 124, '2015-01-15 00:33:23.000000', 'consum', 0.0220, 'lps'),
	(361446, 124, '2015-01-15 00:33:24.000000', 'consum', 0.0210, 'lps'),
	(361447, 124, '2015-01-15 00:33:25.000000', 'consum', 0.0225, 'lps'),
	(361448, 124, '2015-01-15 00:33:26.000000', 'consum', 0.0217, 'lps'),
	(361449, 124, '2015-01-15 00:33:27.000000', 'consum', 0.0222, 'lps'),
	(361450, 124, '2015-01-15 00:33:28.000000', 'consum', 0.0229, 'lps'),
	(361451, 124, '2015-01-15 00:33:29.000000', 'consum', 0.0227, 'lps'),
	(361452, 124, '2015-01-15 00:33:30.000000', 'consum', 0.0213, 'lps'),
	(361453, 124, '2015-01-15 00:33:31.000000', 'consum', 0.0221, 'lps'),
	(361454, 124, '2015-01-15 00:33:32.000000', 'consum', 0.0210, 'lps'),
	(361455, 124, '2015-01-15 00:33:33.000000', 'consum', 0.0225, 'lps'),
	(361456, 124, '2015-01-15 00:33:34.000000', 'consum', 0.0216, 'lps'),
	(361457, 124, '2015-01-15 00:33:35.000000', 'consum', 0.0221, 'lps'),
	(361458, 124, '2015-01-15 00:33:36.000000', 'consum', 0.0224, 'lps'),
	(361459, 124, '2015-01-15 00:33:37.000000', 'consum', 0.0226, 'lps'),
	(361460, 124, '2015-01-15 00:33:38.000000', 'consum', 0.0226, 'lps'),
	(361461, 124, '2015-01-15 00:33:39.000000', 'consum', 0.0219, 'lps'),
	(361462, 124, '2015-01-15 00:33:40.000000', 'consum', 0.0230, 'lps'),
	(361463, 124, '2015-01-15 00:33:41.000000', 'consum', 0.0220, 'lps'),
	(361464, 124, '2015-01-15 00:33:42.000000', 'consum', 0.0221, 'lps'),
	(361465, 124, '2015-01-15 00:33:43.000000', 'consum', 0.0215, 'lps'),
	(361466, 124, '2015-01-15 00:33:44.000000', 'consum', 0.0222, 'lps'),
	(361467, 124, '2015-01-15 00:33:45.000000', 'consum', 0.0211, 'lps'),
	(361468, 124, '2015-01-15 00:33:46.000000', 'consum', 0.0224, 'lps'),
	(361469, 124, '2015-01-15 00:33:47.000000', 'consum', 0.0211, 'lps'),
	(361470, 124, '2015-01-15 00:33:48.000000', 'consum', 0.0218, 'lps'),
	(361471, 124, '2015-01-15 00:33:49.000000', 'consum', 0.0224, 'lps'),
	(361472, 124, '2015-01-15 00:33:50.000000', 'consum', 0.0212, 'lps'),
	(361473, 124, '2015-01-15 00:33:51.000000', 'consum', 0.0223, 'lps'),
	(361474, 124, '2015-01-15 00:33:52.000000', 'consum', 0.0224, 'lps'),
	(361475, 124, '2015-01-15 00:33:53.000000', 'consum', 0.0221, 'lps'),
	(361476, 124, '2015-01-15 00:33:54.000000', 'consum', 0.0224, 'lps'),
	(361477, 124, '2015-01-15 00:33:55.000000', 'consum', 0.0226, 'lps'),
	(361478, 124, '2015-01-15 00:33:56.000000', 'consum', 0.0228, 'lps'),
	(361479, 124, '2015-01-15 00:33:57.000000', 'consum', 0.0229, 'lps'),
	(361480, 124, '2015-01-15 00:33:58.000000', 'consum', 0.0229, 'lps'),
	(361481, 124, '2015-01-15 00:33:59.000000', 'consum', 0.0225, 'lps'),
	(361482, 124, '2015-01-15 00:34:00.000000', 'consum', 0.0230, 'lps'),
	(361483, 124, '2015-01-15 00:34:01.000000', 'consum', 0.0220, 'lps'),
	(361484, 124, '2015-01-15 00:34:02.000000', 'consum', 0.0223, 'lps'),
	(361485, 124, '2015-01-15 00:34:03.000000', 'consum', 0.0222, 'lps'),
	(361486, 124, '2015-01-15 00:34:04.000000', 'consum', 0.0212, 'lps'),
	(361487, 124, '2015-01-15 00:34:05.000000', 'consum', 0.0228, 'lps'),
	(361488, 124, '2015-01-15 00:34:06.000000', 'consum', 0.0228, 'lps'),
	(361489, 124, '2015-01-15 00:34:07.000000', 'consum', 0.0226, 'lps'),
	(361490, 124, '2015-01-15 00:34:08.000000', 'consum', 0.0213, 'lps'),
	(361491, 124, '2015-01-15 00:34:09.000000', 'consum', 0.0221, 'lps'),
	(361492, 124, '2015-01-15 00:34:10.000000', 'consum', 0.0215, 'lps'),
	(361493, 124, '2015-01-15 00:34:11.000000', 'consum', 0.0224, 'lps'),
	(361494, 124, '2015-01-15 00:34:12.000000', 'consum', 0.0221, 'lps'),
	(361495, 124, '2015-01-15 00:34:13.000000', 'consum', 0.0224, 'lps'),
	(361496, 124, '2015-01-15 00:34:14.000000', 'consum', 0.0226, 'lps'),
	(361497, 124, '2015-01-15 00:34:15.000000', 'consum', 0.0228, 'lps'),
	(361498, 124, '2015-01-15 00:34:16.000000', 'consum', 0.0227, 'lps'),
	(361499, 124, '2015-01-15 00:34:17.000000', 'consum', 0.0220, 'lps'),
	(361500, 124, '2015-01-15 00:34:18.000000', 'consum', 0.0212, 'lps'),
	(361501, 124, '2015-01-15 00:34:19.000000', 'consum', 0.0210, 'lps'),
	(361502, 124, '2015-01-15 00:34:20.000000', 'consum', 0.0229, 'lps'),
	(361503, 124, '2015-01-15 00:34:21.000000', 'consum', 0.0218, 'lps'),
	(361504, 124, '2015-01-15 00:34:22.000000', 'consum', 0.0212, 'lps'),
	(361505, 124, '2015-01-15 00:34:23.000000', 'consum', 0.0222, 'lps'),
	(361506, 124, '2015-01-15 00:34:24.000000', 'consum', 0.0219, 'lps'),
	(361507, 124, '2015-01-15 00:34:25.000000', 'consum', 0.0218, 'lps'),
	(361508, 124, '2015-01-15 00:34:26.000000', 'consum', 0.0226, 'lps'),
	(361509, 124, '2015-01-15 00:34:27.000000', 'consum', 0.0222, 'lps'),
	(361510, 124, '2015-01-15 00:34:28.000000', 'consum', 0.0224, 'lps'),
	(361511, 124, '2015-01-15 00:34:29.000000', 'consum', 0.0220, 'lps'),
	(361512, 124, '2015-01-15 00:34:30.000000', 'consum', 0.0219, 'lps'),
	(361513, 124, '2015-01-15 00:34:31.000000', 'consum', 0.0224, 'lps'),
	(361514, 124, '2015-01-15 00:34:32.000000', 'consum', 0.0210, 'lps'),
	(361515, 124, '2015-01-15 00:34:33.000000', 'consum', 0.0212, 'lps'),
	(361516, 124, '2015-01-15 00:34:34.000000', 'consum', 0.0222, 'lps'),
	(361517, 124, '2015-01-15 00:34:35.000000', 'consum', 0.0218, 'lps'),
	(361518, 124, '2015-01-15 00:34:36.000000', 'consum', 0.0217, 'lps'),
	(361519, 124, '2015-01-15 00:34:37.000000', 'consum', 0.0221, 'lps'),
	(361520, 124, '2015-01-15 00:34:38.000000', 'consum', 0.0224, 'lps'),
	(361521, 124, '2015-01-15 00:34:39.000000', 'consum', 0.0225, 'lps'),
	(361522, 124, '2015-01-15 00:34:40.000000', 'consum', 0.0221, 'lps'),
	(361523, 124, '2015-01-15 00:34:41.000000', 'consum', 0.0220, 'lps'),
	(361524, 124, '2015-01-15 00:34:42.000000', 'consum', 0.0227, 'lps'),
	(361525, 124, '2015-01-15 00:34:43.000000', 'consum', 0.0224, 'lps'),
	(361526, 124, '2015-01-15 00:34:44.000000', 'consum', 0.0229, 'lps'),
	(361527, 124, '2015-01-15 00:34:45.000000', 'consum', 0.0219, 'lps'),
	(361528, 124, '2015-01-15 00:34:46.000000', 'consum', 0.0219, 'lps'),
	(361529, 124, '2015-01-15 00:34:47.000000', 'consum', 0.0230, 'lps'),
	(361530, 124, '2015-01-15 00:34:48.000000', 'consum', 0.0218, 'lps'),
	(361531, 124, '2015-01-15 00:34:49.000000', 'consum', 0.0213, 'lps'),
	(361532, 124, '2015-01-15 00:34:50.000000', 'consum', 0.0224, 'lps'),
	(361533, 124, '2015-01-15 00:34:51.000000', 'consum', 0.0228, 'lps'),
	(361534, 124, '2015-01-15 00:34:52.000000', 'consum', 0.0212, 'lps'),
	(361535, 124, '2015-01-15 00:34:53.000000', 'consum', 0.0214, 'lps'),
	(361536, 124, '2015-01-15 00:34:54.000000', 'consum', 0.0221, 'lps'),
	(361537, 124, '2015-01-15 00:34:55.000000', 'consum', 0.0212, 'lps'),
	(361538, 124, '2015-01-15 00:34:56.000000', 'consum', 0.0229, 'lps'),
	(361539, 124, '2015-01-15 00:34:57.000000', 'consum', 0.0211, 'lps'),
	(361540, 124, '2015-01-15 00:34:58.000000', 'consum', 0.0227, 'lps'),
	(361541, 124, '2015-01-15 00:34:59.000000', 'consum', 0.0226, 'lps'),
	(361542, 124, '2015-01-15 00:35:00.000000', 'consum', 0.0217, 'lps'),
	(361543, 124, '2015-01-15 00:35:01.000000', 'consum', 0.0219, 'lps'),
	(361544, 124, '2015-01-15 00:35:02.000000', 'consum', 0.0212, 'lps'),
	(361545, 124, '2015-01-15 00:35:03.000000', 'consum', 0.0215, 'lps'),
	(361546, 124, '2015-01-15 00:35:04.000000', 'consum', 0.0210, 'lps'),
	(361547, 124, '2015-01-15 00:35:05.000000', 'consum', 0.0214, 'lps'),
	(361548, 124, '2015-01-15 00:35:06.000000', 'consum', 0.0212, 'lps'),
	(361549, 124, '2015-01-15 00:35:07.000000', 'consum', 0.0230, 'lps'),
	(361550, 124, '2015-01-15 00:35:08.000000', 'consum', 0.0216, 'lps'),
	(361551, 124, '2015-01-15 00:35:09.000000', 'consum', 0.0224, 'lps'),
	(361552, 124, '2015-01-15 00:35:10.000000', 'consum', 0.0218, 'lps'),
	(361553, 124, '2015-01-15 00:35:11.000000', 'consum', 0.0210, 'lps'),
	(361554, 124, '2015-01-15 00:35:12.000000', 'consum', 0.0231, 'lps'),
	(361555, 124, '2015-01-15 00:35:13.000000', 'consum', 0.0228, 'lps'),
	(361556, 124, '2015-01-15 00:35:14.000000', 'consum', 0.0215, 'lps'),
	(361557, 124, '2015-01-15 00:35:15.000000', 'consum', 0.0225, 'lps'),
	(361558, 124, '2015-01-15 00:35:16.000000', 'consum', 0.0228, 'lps'),
	(361559, 124, '2015-01-15 00:35:17.000000', 'consum', 0.0211, 'lps'),
	(361560, 124, '2015-01-15 00:35:18.000000', 'consum', 0.0228, 'lps'),
	(361561, 124, '2015-01-15 00:35:19.000000', 'consum', 0.0229, 'lps'),
	(361562, 124, '2015-01-15 00:35:20.000000', 'consum', 0.0210, 'lps'),
	(361563, 124, '2015-01-15 00:35:21.000000', 'consum', 0.0221, 'lps'),
	(361564, 124, '2015-01-15 00:35:22.000000', 'consum', 0.0219, 'lps'),
	(361565, 124, '2015-01-15 00:35:23.000000', 'consum', 0.0222, 'lps'),
	(361566, 124, '2015-01-15 00:35:24.000000', 'consum', 0.0223, 'lps'),
	(361567, 124, '2015-01-15 00:35:25.000000', 'consum', 0.0218, 'lps'),
	(361568, 124, '2015-01-15 00:35:26.000000', 'consum', 0.0210, 'lps'),
	(361569, 124, '2015-01-15 00:35:27.000000', 'consum', 0.0230, 'lps'),
	(361570, 124, '2015-01-15 00:35:28.000000', 'consum', 0.0223, 'lps'),
	(361571, 124, '2015-01-15 00:35:29.000000', 'consum', 0.0216, 'lps'),
	(361572, 124, '2015-01-15 00:35:30.000000', 'consum', 0.0225, 'lps'),
	(361573, 124, '2015-01-15 00:35:31.000000', 'consum', 0.0223, 'lps'),
	(361574, 124, '2015-01-15 00:35:32.000000', 'consum', 0.0231, 'lps'),
	(361575, 124, '2015-01-15 00:35:33.000000', 'consum', 0.0211, 'lps'),
	(361576, 124, '2015-01-15 00:35:34.000000', 'consum', 0.0217, 'lps'),
	(361577, 124, '2015-01-15 00:35:35.000000', 'consum', 0.0221, 'lps'),
	(361578, 124, '2015-01-15 00:35:36.000000', 'consum', 0.0223, 'lps'),
	(361579, 124, '2015-01-15 00:35:37.000000', 'consum', 0.0222, 'lps'),
	(361580, 124, '2015-01-15 00:35:38.000000', 'consum', 0.0229, 'lps'),
	(361581, 124, '2015-01-15 00:35:39.000000', 'consum', 0.0226, 'lps'),
	(361582, 124, '2015-01-15 00:35:40.000000', 'consum', 0.0211, 'lps'),
	(361583, 124, '2015-01-15 00:35:41.000000', 'consum', 0.0212, 'lps'),
	(361584, 124, '2015-01-15 00:35:42.000000', 'consum', 0.0218, 'lps'),
	(361585, 124, '2015-01-15 00:35:43.000000', 'consum', 0.0223, 'lps'),
	(361586, 124, '2015-01-15 00:35:44.000000', 'consum', 0.0229, 'lps'),
	(361587, 124, '2015-01-15 00:35:45.000000', 'consum', 0.0223, 'lps'),
	(361588, 124, '2015-01-15 00:35:46.000000', 'consum', 0.0216, 'lps'),
	(361589, 124, '2015-01-15 00:35:47.000000', 'consum', 0.0225, 'lps'),
	(361590, 124, '2015-01-15 00:35:48.000000', 'consum', 0.0225, 'lps'),
	(361591, 124, '2015-01-15 00:35:49.000000', 'consum', 0.0218, 'lps'),
	(361592, 124, '2015-01-15 00:35:50.000000', 'consum', 0.0229, 'lps'),
	(361593, 124, '2015-01-15 00:35:51.000000', 'consum', 0.0212, 'lps'),
	(361594, 124, '2015-01-15 00:35:52.000000', 'consum', 0.0210, 'lps'),
	(361595, 124, '2015-01-15 00:35:53.000000', 'consum', 0.0224, 'lps'),
	(361596, 124, '2015-01-15 00:35:54.000000', 'consum', 0.0215, 'lps'),
	(361597, 124, '2015-01-15 00:35:55.000000', 'consum', 0.0215, 'lps'),
	(361598, 124, '2015-01-15 00:35:56.000000', 'consum', 0.0221, 'lps'),
	(361599, 124, '2015-01-15 00:35:57.000000', 'consum', 0.0227, 'lps'),
	(361600, 124, '2015-01-15 00:35:58.000000', 'consum', 0.0221, 'lps'),
	(361601, 124, '2015-01-15 00:35:59.000000', 'consum', 0.0213, 'lps'),
	(361602, 124, '2015-01-15 00:36:00.000000', 'consum', 0.0214, 'lps'),
	(361603, 124, '2015-01-15 00:36:01.000000', 'consum', 0.0221, 'lps'),
	(361604, 124, '2015-01-15 00:36:02.000000', 'consum', 0.0211, 'lps'),
	(361605, 124, '2015-01-15 00:36:03.000000', 'consum', 0.0224, 'lps'),
	(361606, 124, '2015-01-15 00:36:04.000000', 'consum', 0.0214, 'lps'),
	(361607, 124, '2015-01-15 00:36:05.000000', 'consum', 0.0211, 'lps'),
	(361608, 124, '2015-01-15 00:36:06.000000', 'consum', 0.0223, 'lps'),
	(361609, 124, '2015-01-15 00:36:07.000000', 'consum', 0.0229, 'lps'),
	(361610, 124, '2015-01-15 00:36:08.000000', 'consum', 0.0225, 'lps'),
	(361611, 124, '2015-01-15 00:36:09.000000', 'consum', 0.0227, 'lps'),
	(361612, 124, '2015-01-15 00:36:10.000000', 'consum', 0.0230, 'lps'),
	(361613, 124, '2015-01-15 00:36:11.000000', 'consum', 0.0214, 'lps'),
	(361614, 124, '2015-01-15 00:36:12.000000', 'consum', 0.0216, 'lps'),
	(361615, 124, '2015-01-15 00:36:13.000000', 'consum', 0.0228, 'lps'),
	(361616, 124, '2015-01-15 00:36:14.000000', 'consum', 0.0216, 'lps'),
	(361617, 124, '2015-01-15 00:36:15.000000', 'consum', 0.0230, 'lps'),
	(361618, 124, '2015-01-15 00:36:16.000000', 'consum', 0.0228, 'lps'),
	(361619, 124, '2015-01-15 00:36:17.000000', 'consum', 0.0219, 'lps'),
	(361620, 124, '2015-01-15 00:36:18.000000', 'consum', 0.0221, 'lps'),
	(361621, 124, '2015-01-15 00:36:19.000000', 'consum', 0.0218, 'lps'),
	(361622, 124, '2015-01-15 00:36:20.000000', 'consum', 0.0218, 'lps'),
	(361623, 124, '2015-01-15 00:36:21.000000', 'consum', 0.0225, 'lps'),
	(361624, 124, '2015-01-15 00:36:22.000000', 'consum', 0.0217, 'lps'),
	(361625, 124, '2015-01-15 00:36:23.000000', 'consum', 0.0222, 'lps'),
	(361626, 124, '2015-01-15 00:36:24.000000', 'consum', 0.0230, 'lps'),
	(361627, 124, '2015-01-15 00:36:25.000000', 'consum', 0.0230, 'lps'),
	(361628, 124, '2015-01-15 00:36:26.000000', 'consum', 0.0229, 'lps'),
	(361629, 124, '2015-01-15 00:36:27.000000', 'consum', 0.0225, 'lps'),
	(361630, 124, '2015-01-15 00:36:28.000000', 'consum', 0.0227, 'lps'),
	(361631, 124, '2015-01-15 00:36:29.000000', 'consum', 0.0228, 'lps'),
	(361632, 124, '2015-01-15 00:36:30.000000', 'consum', 0.0227, 'lps'),
	(361633, 124, '2015-01-15 00:36:31.000000', 'consum', 0.0221, 'lps'),
	(361634, 124, '2015-01-15 00:36:32.000000', 'consum', 0.0214, 'lps'),
	(361635, 124, '2015-01-15 00:36:33.000000', 'consum', 0.0218, 'lps'),
	(361636, 124, '2015-01-15 00:36:34.000000', 'consum', 0.0218, 'lps'),
	(361637, 124, '2015-01-15 00:36:35.000000', 'consum', 0.0227, 'lps'),
	(361638, 124, '2015-01-15 00:36:36.000000', 'consum', 0.0227, 'lps'),
	(361639, 124, '2015-01-15 00:36:37.000000', 'consum', 0.0224, 'lps'),
	(361640, 124, '2015-01-15 00:36:38.000000', 'consum', 0.0229, 'lps'),
	(361641, 124, '2015-01-15 00:36:39.000000', 'consum', 0.0218, 'lps'),
	(361642, 124, '2015-01-15 00:36:40.000000', 'consum', 0.0217, 'lps'),
	(361643, 124, '2015-01-15 00:36:41.000000', 'consum', 0.0219, 'lps'),
	(361644, 124, '2015-01-15 00:36:42.000000', 'consum', 0.0213, 'lps'),
	(361645, 124, '2015-01-15 00:36:43.000000', 'consum', 0.0223, 'lps'),
	(361646, 124, '2015-01-15 00:36:44.000000', 'consum', 0.0221, 'lps'),
	(361647, 124, '2015-01-15 00:36:45.000000', 'consum', 0.0225, 'lps'),
	(361648, 124, '2015-01-15 00:36:46.000000', 'consum', 0.0210, 'lps'),
	(361649, 124, '2015-01-15 00:36:47.000000', 'consum', 0.0229, 'lps'),
	(361650, 124, '2015-01-15 00:36:48.000000', 'consum', 0.0220, 'lps'),
	(361651, 124, '2015-01-15 00:36:49.000000', 'consum', 0.0223, 'lps'),
	(361652, 124, '2015-01-15 00:36:50.000000', 'consum', 0.0227, 'lps'),
	(361653, 124, '2015-01-15 00:36:51.000000', 'consum', 0.0231, 'lps'),
	(361654, 124, '2015-01-15 00:36:52.000000', 'consum', 0.0222, 'lps'),
	(361655, 124, '2015-01-15 00:36:53.000000', 'consum', 0.0231, 'lps'),
	(361656, 124, '2015-01-15 00:36:54.000000', 'consum', 0.0214, 'lps'),
	(361657, 124, '2015-01-15 00:36:55.000000', 'consum', 0.0210, 'lps'),
	(361658, 124, '2015-01-15 00:36:56.000000', 'consum', 0.0221, 'lps'),
	(361659, 124, '2015-01-15 00:36:57.000000', 'consum', 0.0222, 'lps'),
	(361660, 124, '2015-01-15 00:36:58.000000', 'consum', 0.0214, 'lps'),
	(361661, 124, '2015-01-15 00:36:59.000000', 'consum', 0.0216, 'lps'),
	(361662, 124, '2015-01-15 00:37:00.000000', 'consum', 0.0229, 'lps'),
	(361663, 124, '2015-01-15 00:37:01.000000', 'consum', 0.0222, 'lps'),
	(361664, 124, '2015-01-15 00:37:02.000000', 'consum', 0.0213, 'lps'),
	(361665, 124, '2015-01-15 00:37:03.000000', 'consum', 0.0212, 'lps'),
	(361666, 124, '2015-01-15 00:37:04.000000', 'consum', 0.0210, 'lps'),
	(361667, 124, '2015-01-15 00:37:05.000000', 'consum', 0.0227, 'lps'),
	(361668, 124, '2015-01-15 00:37:06.000000', 'consum', 0.0231, 'lps'),
	(361669, 124, '2015-01-15 00:37:07.000000', 'consum', 0.0219, 'lps'),
	(361670, 124, '2015-01-15 00:37:08.000000', 'consum', 0.0214, 'lps'),
	(361671, 124, '2015-01-15 00:37:09.000000', 'consum', 0.0226, 'lps'),
	(361672, 124, '2015-01-15 00:37:10.000000', 'consum', 0.0213, 'lps'),
	(361673, 124, '2015-01-15 00:37:11.000000', 'consum', 0.0222, 'lps'),
	(361674, 124, '2015-01-15 00:37:12.000000', 'consum', 0.0216, 'lps'),
	(361675, 124, '2015-01-15 00:37:13.000000', 'consum', 0.0225, 'lps'),
	(361676, 124, '2015-01-15 00:37:14.000000', 'consum', 0.0227, 'lps'),
	(361677, 124, '2015-01-15 00:37:15.000000', 'consum', 0.0225, 'lps'),
	(361678, 124, '2015-01-15 00:37:16.000000', 'consum', 0.0215, 'lps'),
	(361679, 124, '2015-01-15 00:37:17.000000', 'consum', 0.0213, 'lps'),
	(361680, 124, '2015-01-15 00:37:18.000000', 'consum', 0.0211, 'lps'),
	(361681, 124, '2015-01-15 00:37:19.000000', 'consum', 0.0226, 'lps'),
	(361682, 124, '2015-01-15 00:37:20.000000', 'consum', 0.0224, 'lps'),
	(361683, 124, '2015-01-15 00:37:21.000000', 'consum', 0.0210, 'lps'),
	(361684, 124, '2015-01-15 00:37:22.000000', 'consum', 0.0212, 'lps'),
	(361685, 124, '2015-01-15 00:37:23.000000', 'consum', 0.0219, 'lps'),
	(361686, 124, '2015-01-15 00:37:24.000000', 'consum', 0.0230, 'lps'),
	(361687, 124, '2015-01-15 00:37:25.000000', 'consum', 0.0215, 'lps'),
	(361688, 124, '2015-01-15 00:37:26.000000', 'consum', 0.0220, 'lps'),
	(361689, 124, '2015-01-15 00:37:27.000000', 'consum', 0.0223, 'lps'),
	(361690, 124, '2015-01-15 00:37:28.000000', 'consum', 0.0225, 'lps'),
	(361691, 124, '2015-01-15 00:37:29.000000', 'consum', 0.0224, 'lps'),
	(361692, 124, '2015-01-15 00:37:30.000000', 'consum', 0.0215, 'lps'),
	(361693, 124, '2015-01-15 00:37:31.000000', 'consum', 0.0214, 'lps'),
	(361694, 124, '2015-01-15 00:37:32.000000', 'consum', 0.0217, 'lps'),
	(361695, 124, '2015-01-15 00:37:33.000000', 'consum', 0.0212, 'lps'),
	(361696, 124, '2015-01-15 00:37:34.000000', 'consum', 0.0219, 'lps'),
	(361697, 124, '2015-01-15 00:37:35.000000', 'consum', 0.0228, 'lps'),
	(361698, 124, '2015-01-15 00:37:36.000000', 'consum', 0.0229, 'lps'),
	(361699, 124, '2015-01-15 00:37:37.000000', 'consum', 0.0230, 'lps'),
	(361700, 124, '2015-01-15 00:37:38.000000', 'consum', 0.0210, 'lps'),
	(361701, 124, '2015-01-15 00:37:39.000000', 'consum', 0.0215, 'lps'),
	(361702, 124, '2015-01-15 00:37:40.000000', 'consum', 0.0215, 'lps'),
	(361703, 124, '2015-01-15 00:37:41.000000', 'consum', 0.0219, 'lps'),
	(361704, 124, '2015-01-15 00:37:42.000000', 'consum', 0.0218, 'lps'),
	(361705, 124, '2015-01-15 00:37:43.000000', 'consum', 0.0223, 'lps'),
	(361706, 124, '2015-01-15 00:37:44.000000', 'consum', 0.0228, 'lps'),
	(361707, 124, '2015-01-15 00:37:45.000000', 'consum', 0.0221, 'lps'),
	(361708, 124, '2015-01-15 00:37:46.000000', 'consum', 0.0211, 'lps'),
	(361709, 124, '2015-01-15 00:37:47.000000', 'consum', 0.0225, 'lps'),
	(361710, 124, '2015-01-15 00:37:48.000000', 'consum', 0.0218, 'lps'),
	(361711, 124, '2015-01-15 00:37:49.000000', 'consum', 0.0229, 'lps'),
	(361712, 124, '2015-01-15 00:37:50.000000', 'consum', 0.0214, 'lps'),
	(361713, 124, '2015-01-15 00:37:51.000000', 'consum', 0.0216, 'lps'),
	(361714, 124, '2015-01-15 00:37:52.000000', 'consum', 0.0229, 'lps'),
	(361715, 124, '2015-01-15 00:37:53.000000', 'consum', 0.0224, 'lps'),
	(361716, 124, '2015-01-15 00:37:54.000000', 'consum', 0.0222, 'lps'),
	(361717, 124, '2015-01-15 00:37:55.000000', 'consum', 0.0228, 'lps'),
	(361718, 124, '2015-01-15 00:37:56.000000', 'consum', 0.0222, 'lps'),
	(361719, 124, '2015-01-15 00:37:57.000000', 'consum', 0.0217, 'lps'),
	(361720, 124, '2015-01-15 00:37:58.000000', 'consum', 0.0210, 'lps'),
	(361721, 124, '2015-01-15 00:37:59.000000', 'consum', 0.0210, 'lps'),
	(361722, 124, '2015-01-15 00:38:00.000000', 'consum', 0.0210, 'lps'),
	(361723, 124, '2015-01-15 00:38:01.000000', 'consum', 0.0210, 'lps'),
	(361724, 124, '2015-01-15 00:38:02.000000', 'consum', 0.0213, 'lps'),
	(361725, 124, '2015-01-15 00:38:03.000000', 'consum', 0.0226, 'lps'),
	(361726, 124, '2015-01-15 00:38:04.000000', 'consum', 0.0213, 'lps'),
	(361727, 124, '2015-01-15 00:38:05.000000', 'consum', 0.0221, 'lps'),
	(361728, 124, '2015-01-15 00:38:06.000000', 'consum', 0.0215, 'lps'),
	(361729, 124, '2015-01-15 00:38:07.000000', 'consum', 0.0222, 'lps'),
	(361730, 124, '2015-01-15 00:38:08.000000', 'consum', 0.0213, 'lps'),
	(361731, 124, '2015-01-15 00:38:09.000000', 'consum', 0.0212, 'lps'),
	(361732, 124, '2015-01-15 00:38:10.000000', 'consum', 0.0210, 'lps'),
	(361733, 124, '2015-01-15 00:38:11.000000', 'consum', 0.0229, 'lps'),
	(361734, 124, '2015-01-15 00:38:12.000000', 'consum', 0.0215, 'lps'),
	(361735, 124, '2015-01-15 00:38:13.000000', 'consum', 0.0225, 'lps'),
	(361736, 124, '2015-01-15 00:38:14.000000', 'consum', 0.0224, 'lps'),
	(361737, 124, '2015-01-15 00:38:15.000000', 'consum', 0.0214, 'lps'),
	(361738, 124, '2015-01-15 00:38:16.000000', 'consum', 0.0231, 'lps'),
	(361739, 124, '2015-01-15 00:38:17.000000', 'consum', 0.0217, 'lps'),
	(361740, 124, '2015-01-15 00:38:18.000000', 'consum', 0.0224, 'lps'),
	(361741, 124, '2015-01-15 00:38:19.000000', 'consum', 0.0219, 'lps'),
	(361742, 124, '2015-01-15 00:38:20.000000', 'consum', 0.0212, 'lps'),
	(361743, 124, '2015-01-15 00:38:21.000000', 'consum', 0.0217, 'lps'),
	(361744, 124, '2015-01-15 00:38:22.000000', 'consum', 0.0216, 'lps'),
	(361745, 124, '2015-01-15 00:38:23.000000', 'consum', 0.0221, 'lps'),
	(361746, 124, '2015-01-15 00:38:24.000000', 'consum', 0.0225, 'lps'),
	(361747, 124, '2015-01-15 00:38:25.000000', 'consum', 0.0230, 'lps'),
	(361748, 124, '2015-01-15 00:38:26.000000', 'consum', 0.0221, 'lps'),
	(361749, 124, '2015-01-15 00:38:27.000000', 'consum', 0.0230, 'lps'),
	(361750, 124, '2015-01-15 00:38:28.000000', 'consum', 0.0210, 'lps'),
	(361751, 124, '2015-01-15 00:38:29.000000', 'consum', 0.0216, 'lps'),
	(361752, 124, '2015-01-15 00:38:30.000000', 'consum', 0.0220, 'lps'),
	(361753, 124, '2015-01-15 00:38:31.000000', 'consum', 0.0218, 'lps'),
	(361754, 124, '2015-01-15 00:38:32.000000', 'consum', 0.0224, 'lps'),
	(361755, 124, '2015-01-15 00:38:33.000000', 'consum', 0.0210, 'lps'),
	(361756, 124, '2015-01-15 00:38:34.000000', 'consum', 0.0213, 'lps'),
	(361757, 124, '2015-01-15 00:38:35.000000', 'consum', 0.0225, 'lps'),
	(361758, 124, '2015-01-15 00:38:36.000000', 'consum', 0.0210, 'lps'),
	(361759, 124, '2015-01-15 00:38:37.000000', 'consum', 0.0211, 'lps'),
	(361760, 124, '2015-01-15 00:38:38.000000', 'consum', 0.0214, 'lps'),
	(361761, 124, '2015-01-15 00:38:39.000000', 'consum', 0.0226, 'lps'),
	(361762, 124, '2015-01-15 00:38:40.000000', 'consum', 0.0215, 'lps'),
	(361763, 124, '2015-01-15 00:38:41.000000', 'consum', 0.0229, 'lps'),
	(361764, 124, '2015-01-15 00:38:42.000000', 'consum', 0.0227, 'lps'),
	(361765, 124, '2015-01-15 00:38:43.000000', 'consum', 0.0214, 'lps'),
	(361766, 124, '2015-01-15 00:38:44.000000', 'consum', 0.0227, 'lps'),
	(361767, 124, '2015-01-15 00:38:45.000000', 'consum', 0.0214, 'lps'),
	(361768, 124, '2015-01-15 00:38:46.000000', 'consum', 0.0226, 'lps'),
	(361769, 124, '2015-01-15 00:38:47.000000', 'consum', 0.0211, 'lps'),
	(361770, 124, '2015-01-15 00:38:48.000000', 'consum', 0.0213, 'lps'),
	(361771, 124, '2015-01-15 00:38:49.000000', 'consum', 0.0222, 'lps'),
	(361772, 124, '2015-01-15 00:38:50.000000', 'consum', 0.0219, 'lps'),
	(361773, 124, '2015-01-15 00:38:51.000000', 'consum', 0.0219, 'lps'),
	(361774, 124, '2015-01-15 00:38:52.000000', 'consum', 0.0227, 'lps'),
	(361775, 124, '2015-01-15 00:38:53.000000', 'consum', 0.0226, 'lps'),
	(361776, 124, '2015-01-15 00:38:54.000000', 'consum', 0.0216, 'lps'),
	(361777, 124, '2015-01-15 00:38:55.000000', 'consum', 0.0215, 'lps'),
	(361778, 124, '2015-01-15 00:38:56.000000', 'consum', 0.0219, 'lps'),
	(361779, 124, '2015-01-15 00:38:57.000000', 'consum', 0.0216, 'lps'),
	(361780, 124, '2015-01-15 00:38:58.000000', 'consum', 0.0215, 'lps'),
	(361781, 124, '2015-01-15 00:38:59.000000', 'consum', 0.0217, 'lps'),
	(361782, 124, '2015-01-15 00:39:00.000000', 'consum', 0.0230, 'lps'),
	(361783, 124, '2015-01-15 00:39:01.000000', 'consum', 0.0223, 'lps'),
	(361784, 124, '2015-01-15 00:39:02.000000', 'consum', 0.0215, 'lps'),
	(361785, 124, '2015-01-15 00:39:03.000000', 'consum', 0.0221, 'lps'),
	(361786, 124, '2015-01-15 00:39:04.000000', 'consum', 0.0227, 'lps'),
	(361787, 124, '2015-01-15 00:39:05.000000', 'consum', 0.0217, 'lps'),
	(361788, 124, '2015-01-15 00:39:06.000000', 'consum', 0.0218, 'lps'),
	(361789, 124, '2015-01-15 00:39:07.000000', 'consum', 0.0227, 'lps'),
	(361790, 124, '2015-01-15 00:39:08.000000', 'consum', 0.0231, 'lps'),
	(361791, 124, '2015-01-15 00:39:09.000000', 'consum', 0.0218, 'lps'),
	(361792, 124, '2015-01-15 00:39:10.000000', 'consum', 0.0210, 'lps'),
	(361793, 124, '2015-01-15 00:39:11.000000', 'consum', 0.0211, 'lps'),
	(361794, 124, '2015-01-15 00:39:12.000000', 'consum', 0.0212, 'lps'),
	(361795, 124, '2015-01-15 00:39:13.000000', 'consum', 0.0221, 'lps'),
	(361796, 124, '2015-01-15 00:39:14.000000', 'consum', 0.0214, 'lps'),
	(361797, 124, '2015-01-15 00:39:15.000000', 'consum', 0.0219, 'lps'),
	(361798, 124, '2015-01-15 00:39:16.000000', 'consum', 0.0221, 'lps'),
	(361799, 124, '2015-01-15 00:39:17.000000', 'consum', 0.0218, 'lps'),
	(361800, 124, '2015-01-15 00:39:18.000000', 'consum', 0.0215, 'lps'),
	(361801, 124, '2015-01-15 00:39:19.000000', 'consum', 0.0212, 'lps'),
	(361802, 124, '2015-01-15 00:39:20.000000', 'consum', 0.0227, 'lps'),
	(361803, 124, '2015-01-15 00:39:21.000000', 'consum', 0.0225, 'lps'),
	(361804, 124, '2015-01-15 00:39:22.000000', 'consum', 0.0212, 'lps'),
	(361805, 124, '2015-01-15 00:39:23.000000', 'consum', 0.0219, 'lps'),
	(361806, 124, '2015-01-15 00:39:24.000000', 'consum', 0.0229, 'lps'),
	(361807, 124, '2015-01-15 00:39:25.000000', 'consum', 0.0210, 'lps'),
	(361808, 124, '2015-01-15 00:39:26.000000', 'consum', 0.0222, 'lps'),
	(361809, 124, '2015-01-15 00:39:27.000000', 'consum', 0.0226, 'lps'),
	(361810, 124, '2015-01-15 00:39:28.000000', 'consum', 0.0231, 'lps'),
	(361811, 124, '2015-01-15 00:39:29.000000', 'consum', 0.0222, 'lps'),
	(361812, 124, '2015-01-15 00:39:30.000000', 'consum', 0.0210, 'lps'),
	(361813, 124, '2015-01-15 00:39:31.000000', 'consum', 0.0218, 'lps'),
	(361814, 124, '2015-01-15 00:39:32.000000', 'consum', 0.0228, 'lps'),
	(361815, 124, '2015-01-15 00:39:33.000000', 'consum', 0.0210, 'lps'),
	(361816, 124, '2015-01-15 00:39:34.000000', 'consum', 0.0222, 'lps'),
	(361817, 124, '2015-01-15 00:39:35.000000', 'consum', 0.0229, 'lps'),
	(361818, 124, '2015-01-15 00:39:36.000000', 'consum', 0.0223, 'lps'),
	(361819, 124, '2015-01-15 00:39:37.000000', 'consum', 0.0218, 'lps'),
	(361820, 124, '2015-01-15 00:39:38.000000', 'consum', 0.0212, 'lps'),
	(361821, 124, '2015-01-15 00:39:39.000000', 'consum', 0.0219, 'lps'),
	(361822, 124, '2015-01-15 00:39:40.000000', 'consum', 0.0228, 'lps'),
	(361823, 124, '2015-01-15 00:39:41.000000', 'consum', 0.0227, 'lps'),
	(361824, 124, '2015-01-15 00:39:42.000000', 'consum', 0.0223, 'lps'),
	(361825, 124, '2015-01-15 00:39:43.000000', 'consum', 0.0223, 'lps'),
	(361826, 124, '2015-01-15 00:39:44.000000', 'consum', 0.0214, 'lps'),
	(361827, 124, '2015-01-15 00:39:45.000000', 'consum', 0.0213, 'lps'),
	(361828, 124, '2015-01-15 00:39:46.000000', 'consum', 0.0216, 'lps'),
	(361829, 124, '2015-01-15 00:39:47.000000', 'consum', 0.0228, 'lps'),
	(361830, 124, '2015-01-15 00:39:48.000000', 'consum', 0.0219, 'lps'),
	(361831, 124, '2015-01-15 00:39:49.000000', 'consum', 0.0222, 'lps'),
	(361832, 124, '2015-01-15 00:39:50.000000', 'consum', 0.0223, 'lps'),
	(361833, 124, '2015-01-15 00:39:51.000000', 'consum', 0.0219, 'lps'),
	(361834, 124, '2015-01-15 00:39:52.000000', 'consum', 0.0213, 'lps'),
	(361835, 124, '2015-01-15 00:39:53.000000', 'consum', 0.0224, 'lps'),
	(361836, 124, '2015-01-15 00:39:54.000000', 'consum', 0.0225, 'lps'),
	(361837, 124, '2015-01-15 00:39:55.000000', 'consum', 0.0222, 'lps'),
	(361838, 124, '2015-01-15 00:39:56.000000', 'consum', 0.0225, 'lps'),
	(361839, 124, '2015-01-15 00:39:57.000000', 'consum', 0.0228, 'lps'),
	(361840, 124, '2015-01-15 00:39:58.000000', 'consum', 0.0210, 'lps'),
	(361841, 124, '2015-01-15 00:39:59.000000', 'consum', 0.0223, 'lps'),
	(361842, 124, '2015-01-15 00:40:00.000000', 'consum', 0.0230, 'lps'),
	(361843, 124, '2015-01-15 00:40:01.000000', 'consum', 0.0229, 'lps'),
	(361844, 124, '2015-01-15 00:40:02.000000', 'consum', 0.0224, 'lps'),
	(361845, 124, '2015-01-15 00:40:03.000000', 'consum', 0.0223, 'lps'),
	(361846, 124, '2015-01-15 00:40:04.000000', 'consum', 0.0212, 'lps'),
	(361847, 124, '2015-01-15 00:40:05.000000', 'consum', 0.0226, 'lps'),
	(361848, 124, '2015-01-15 00:40:06.000000', 'consum', 0.0219, 'lps'),
	(361849, 124, '2015-01-15 00:40:07.000000', 'consum', 0.0229, 'lps'),
	(361850, 124, '2015-01-15 00:40:08.000000', 'consum', 0.0212, 'lps'),
	(361851, 124, '2015-01-15 00:40:09.000000', 'consum', 0.0230, 'lps'),
	(361852, 124, '2015-01-15 00:40:10.000000', 'consum', 0.0218, 'lps'),
	(361853, 124, '2015-01-15 00:40:11.000000', 'consum', 0.0212, 'lps'),
	(361854, 124, '2015-01-15 00:40:12.000000', 'consum', 0.0217, 'lps'),
	(361855, 124, '2015-01-15 00:40:13.000000', 'consum', 0.0220, 'lps'),
	(361856, 124, '2015-01-15 00:40:14.000000', 'consum', 0.0215, 'lps'),
	(361857, 124, '2015-01-15 00:40:15.000000', 'consum', 0.0227, 'lps'),
	(361858, 124, '2015-01-15 00:40:16.000000', 'consum', 0.0214, 'lps'),
	(361859, 124, '2015-01-15 00:40:17.000000', 'consum', 0.0223, 'lps'),
	(361860, 124, '2015-01-15 00:40:18.000000', 'consum', 0.0222, 'lps'),
	(361861, 124, '2015-01-15 00:40:19.000000', 'consum', 0.0229, 'lps'),
	(361862, 124, '2015-01-15 00:40:20.000000', 'consum', 0.0224, 'lps'),
	(361863, 124, '2015-01-15 00:40:21.000000', 'consum', 0.0227, 'lps'),
	(361864, 124, '2015-01-15 00:40:22.000000', 'consum', 0.0231, 'lps'),
	(361865, 124, '2015-01-15 00:40:23.000000', 'consum', 0.0222, 'lps'),
	(361866, 124, '2015-01-15 00:40:24.000000', 'consum', 0.0228, 'lps'),
	(361867, 124, '2015-01-15 00:40:25.000000', 'consum', 0.0221, 'lps'),
	(361868, 124, '2015-01-15 00:40:26.000000', 'consum', 0.0212, 'lps'),
	(361869, 124, '2015-01-15 00:40:27.000000', 'consum', 0.0229, 'lps'),
	(361870, 124, '2015-01-15 00:40:28.000000', 'consum', 0.0214, 'lps'),
	(361871, 124, '2015-01-15 00:40:29.000000', 'consum', 0.0218, 'lps'),
	(361872, 124, '2015-01-15 00:40:30.000000', 'consum', 0.0214, 'lps'),
	(361873, 124, '2015-01-15 00:40:31.000000', 'consum', 0.0210, 'lps'),
	(361874, 124, '2015-01-15 00:40:32.000000', 'consum', 0.0218, 'lps'),
	(361875, 124, '2015-01-15 00:40:33.000000', 'consum', 0.0228, 'lps'),
	(361876, 124, '2015-01-15 00:40:34.000000', 'consum', 0.0212, 'lps'),
	(361877, 124, '2015-01-15 00:40:35.000000', 'consum', 0.0211, 'lps'),
	(361878, 124, '2015-01-15 00:40:36.000000', 'consum', 0.0230, 'lps'),
	(361879, 124, '2015-01-15 00:40:37.000000', 'consum', 0.0218, 'lps'),
	(361880, 124, '2015-01-15 00:40:38.000000', 'consum', 0.0215, 'lps'),
	(361881, 124, '2015-01-15 00:40:39.000000', 'consum', 0.0211, 'lps'),
	(361882, 124, '2015-01-15 00:40:40.000000', 'consum', 0.0224, 'lps'),
	(361883, 124, '2015-01-15 00:40:41.000000', 'consum', 0.0210, 'lps'),
	(361884, 124, '2015-01-15 00:40:42.000000', 'consum', 0.0211, 'lps'),
	(361885, 124, '2015-01-15 00:40:43.000000', 'consum', 0.0218, 'lps'),
	(361886, 124, '2015-01-15 00:40:44.000000', 'consum', 0.0223, 'lps'),
	(361887, 124, '2015-01-15 00:40:45.000000', 'consum', 0.0210, 'lps'),
	(361888, 124, '2015-01-15 00:40:46.000000', 'consum', 0.0216, 'lps'),
	(361889, 124, '2015-01-15 00:40:47.000000', 'consum', 0.0218, 'lps'),
	(361890, 124, '2015-01-15 00:40:48.000000', 'consum', 0.0231, 'lps'),
	(361891, 124, '2015-01-15 00:40:49.000000', 'consum', 0.0228, 'lps'),
	(361892, 124, '2015-01-15 00:40:50.000000', 'consum', 0.0215, 'lps'),
	(361893, 124, '2015-01-15 00:40:51.000000', 'consum', 0.0226, 'lps'),
	(361894, 124, '2015-01-15 00:40:52.000000', 'consum', 0.0230, 'lps'),
	(361895, 124, '2015-01-15 00:40:53.000000', 'consum', 0.0217, 'lps'),
	(361896, 124, '2015-01-15 00:40:54.000000', 'consum', 0.0210, 'lps'),
	(361897, 124, '2015-01-15 00:40:55.000000', 'consum', 0.0213, 'lps'),
	(361898, 124, '2015-01-15 00:40:56.000000', 'consum', 0.0223, 'lps'),
	(361899, 124, '2015-01-15 00:40:57.000000', 'consum', 0.0223, 'lps'),
	(361900, 124, '2015-01-15 00:40:58.000000', 'consum', 0.0217, 'lps'),
	(361901, 124, '2015-01-15 00:40:59.000000', 'consum', 0.0225, 'lps'),
	(361902, 124, '2015-01-15 00:41:00.000000', 'consum', 0.0223, 'lps'),
	(361903, 124, '2015-01-15 00:41:01.000000', 'consum', 0.0228, 'lps'),
	(361904, 124, '2015-01-15 00:41:02.000000', 'consum', 0.0217, 'lps'),
	(361905, 124, '2015-01-15 00:41:03.000000', 'consum', 0.0214, 'lps'),
	(361906, 124, '2015-01-15 00:41:04.000000', 'consum', 0.0211, 'lps'),
	(361907, 124, '2015-01-15 00:41:05.000000', 'consum', 0.0223, 'lps'),
	(361908, 124, '2015-01-15 00:41:06.000000', 'consum', 0.0231, 'lps'),
	(361909, 124, '2015-01-15 00:41:07.000000', 'consum', 0.0230, 'lps'),
	(361910, 124, '2015-01-15 00:41:08.000000', 'consum', 0.0225, 'lps'),
	(361911, 124, '2015-01-15 00:41:09.000000', 'consum', 0.0227, 'lps'),
	(361912, 124, '2015-01-15 00:41:10.000000', 'consum', 0.0229, 'lps'),
	(361913, 124, '2015-01-15 00:41:11.000000', 'consum', 0.0231, 'lps'),
	(361914, 124, '2015-01-15 00:41:12.000000', 'consum', 0.0217, 'lps'),
	(361915, 124, '2015-01-15 00:41:13.000000', 'consum', 0.0224, 'lps'),
	(361916, 124, '2015-01-15 00:41:14.000000', 'consum', 0.0216, 'lps'),
	(361917, 124, '2015-01-15 00:41:15.000000', 'consum', 0.0222, 'lps'),
	(361918, 124, '2015-01-15 00:41:16.000000', 'consum', 0.0228, 'lps'),
	(361919, 124, '2015-01-15 00:41:17.000000', 'consum', 0.0223, 'lps'),
	(361920, 124, '2015-01-15 00:41:18.000000', 'consum', 0.0220, 'lps'),
	(361921, 124, '2015-01-15 00:41:19.000000', 'consum', 0.0223, 'lps'),
	(361922, 124, '2015-01-15 00:41:20.000000', 'consum', 0.0221, 'lps'),
	(361923, 124, '2015-01-15 00:41:21.000000', 'consum', 0.0229, 'lps'),
	(361924, 124, '2015-01-15 00:41:22.000000', 'consum', 0.0228, 'lps'),
	(361925, 124, '2015-01-15 00:41:23.000000', 'consum', 0.0222, 'lps'),
	(361926, 124, '2015-01-15 00:41:24.000000', 'consum', 0.0215, 'lps'),
	(361927, 124, '2015-01-15 00:41:25.000000', 'consum', 0.0223, 'lps'),
	(361928, 124, '2015-01-15 00:41:26.000000', 'consum', 0.0215, 'lps'),
	(361929, 124, '2015-01-15 00:41:27.000000', 'consum', 0.0217, 'lps'),
	(361930, 124, '2015-01-15 00:41:28.000000', 'consum', 0.0210, 'lps'),
	(361931, 124, '2015-01-15 00:41:29.000000', 'consum', 0.0211, 'lps'),
	(361932, 124, '2015-01-15 00:41:30.000000', 'consum', 0.0218, 'lps'),
	(361933, 124, '2015-01-15 00:41:31.000000', 'consum', 0.0223, 'lps'),
	(361934, 124, '2015-01-15 00:41:32.000000', 'consum', 0.0210, 'lps'),
	(361935, 124, '2015-01-15 00:41:33.000000', 'consum', 0.0214, 'lps'),
	(361936, 124, '2015-01-15 00:41:34.000000', 'consum', 0.0229, 'lps'),
	(361937, 124, '2015-01-15 00:41:35.000000', 'consum', 0.0227, 'lps'),
	(361938, 124, '2015-01-15 00:41:36.000000', 'consum', 0.0219, 'lps'),
	(361939, 124, '2015-01-15 00:41:37.000000', 'consum', 0.0224, 'lps'),
	(361940, 124, '2015-01-15 00:41:38.000000', 'consum', 0.0210, 'lps'),
	(361941, 124, '2015-01-15 00:41:39.000000', 'consum', 0.0213, 'lps'),
	(361942, 124, '2015-01-15 00:41:40.000000', 'consum', 0.0226, 'lps'),
	(361943, 124, '2015-01-15 00:41:41.000000', 'consum', 0.0214, 'lps'),
	(361944, 124, '2015-01-15 00:41:42.000000', 'consum', 0.0225, 'lps'),
	(361945, 124, '2015-01-15 00:41:43.000000', 'consum', 0.0211, 'lps'),
	(361946, 124, '2015-01-15 00:41:44.000000', 'consum', 0.0211, 'lps'),
	(361947, 124, '2015-01-15 00:41:45.000000', 'consum', 0.0215, 'lps'),
	(361948, 124, '2015-01-15 00:41:46.000000', 'consum', 0.0210, 'lps'),
	(361949, 124, '2015-01-15 00:41:47.000000', 'consum', 0.0215, 'lps'),
	(361950, 124, '2015-01-15 00:41:48.000000', 'consum', 0.0216, 'lps'),
	(361951, 124, '2015-01-15 00:41:49.000000', 'consum', 0.0226, 'lps'),
	(361952, 124, '2015-01-15 00:41:50.000000', 'consum', 0.0227, 'lps'),
	(361953, 124, '2015-01-15 00:41:51.000000', 'consum', 0.0228, 'lps'),
	(361954, 124, '2015-01-15 00:41:52.000000', 'consum', 0.0227, 'lps'),
	(361955, 124, '2015-01-15 00:41:53.000000', 'consum', 0.0218, 'lps'),
	(361956, 124, '2015-01-15 00:41:54.000000', 'consum', 0.0221, 'lps'),
	(361957, 124, '2015-01-15 00:41:55.000000', 'consum', 0.0221, 'lps'),
	(361958, 124, '2015-01-15 00:41:56.000000', 'consum', 0.0211, 'lps'),
	(361959, 124, '2015-01-15 00:41:57.000000', 'consum', 0.0228, 'lps'),
	(361960, 124, '2015-01-15 00:41:58.000000', 'consum', 0.0229, 'lps'),
	(361961, 124, '2015-01-15 00:41:59.000000', 'consum', 0.0229, 'lps'),
	(361962, 124, '2015-01-15 00:42:00.000000', 'consum', 0.0225, 'lps'),
	(361963, 124, '2015-01-15 00:42:01.000000', 'consum', 0.0231, 'lps'),
	(361964, 124, '2015-01-15 00:42:02.000000', 'consum', 0.0226, 'lps'),
	(361965, 124, '2015-01-15 00:42:03.000000', 'consum', 0.0227, 'lps'),
	(361966, 124, '2015-01-15 00:42:04.000000', 'consum', 0.0226, 'lps'),
	(361967, 124, '2015-01-15 00:42:05.000000', 'consum', 0.0218, 'lps'),
	(361968, 124, '2015-01-15 00:42:06.000000', 'consum', 0.0222, 'lps'),
	(361969, 124, '2015-01-15 00:42:07.000000', 'consum', 0.0227, 'lps'),
	(361970, 124, '2015-01-15 00:42:08.000000', 'consum', 0.0213, 'lps'),
	(361971, 124, '2015-01-15 00:42:09.000000', 'consum', 0.0220, 'lps'),
	(361972, 124, '2015-01-15 00:42:10.000000', 'consum', 0.0228, 'lps'),
	(361973, 124, '2015-01-15 00:42:11.000000', 'consum', 0.0228, 'lps'),
	(361974, 124, '2015-01-15 00:42:12.000000', 'consum', 0.0225, 'lps'),
	(361975, 124, '2015-01-15 00:42:13.000000', 'consum', 0.0229, 'lps'),
	(361976, 124, '2015-01-15 00:42:14.000000', 'consum', 0.0220, 'lps'),
	(361977, 124, '2015-01-15 00:42:15.000000', 'consum', 0.0222, 'lps'),
	(361978, 124, '2015-01-15 00:42:16.000000', 'consum', 0.0222, 'lps'),
	(361979, 124, '2015-01-15 00:42:17.000000', 'consum', 0.0211, 'lps'),
	(361980, 124, '2015-01-15 00:42:18.000000', 'consum', 0.0223, 'lps'),
	(361981, 124, '2015-01-15 00:42:19.000000', 'consum', 0.0230, 'lps'),
	(361982, 124, '2015-01-15 00:42:20.000000', 'consum', 0.0227, 'lps'),
	(361983, 124, '2015-01-15 00:42:21.000000', 'consum', 0.0215, 'lps'),
	(361984, 124, '2015-01-15 00:42:22.000000', 'consum', 0.0226, 'lps'),
	(361985, 124, '2015-01-15 00:42:23.000000', 'consum', 0.0211, 'lps'),
	(361986, 124, '2015-01-15 00:42:24.000000', 'consum', 0.0231, 'lps'),
	(361987, 124, '2015-01-15 00:42:25.000000', 'consum', 0.0227, 'lps'),
	(361988, 124, '2015-01-15 00:42:26.000000', 'consum', 0.0231, 'lps'),
	(361989, 124, '2015-01-15 00:42:27.000000', 'consum', 0.0220, 'lps'),
	(361990, 124, '2015-01-15 00:42:28.000000', 'consum', 0.0222, 'lps'),
	(361991, 124, '2015-01-15 00:42:29.000000', 'consum', 0.0216, 'lps'),
	(361992, 124, '2015-01-15 00:42:30.000000', 'consum', 0.0225, 'lps'),
	(361993, 124, '2015-01-15 00:42:31.000000', 'consum', 0.0227, 'lps'),
	(361994, 124, '2015-01-15 00:42:32.000000', 'consum', 0.0226, 'lps'),
	(361995, 124, '2015-01-15 00:42:33.000000', 'consum', 0.0217, 'lps'),
	(361996, 124, '2015-01-15 00:42:34.000000', 'consum', 0.0222, 'lps'),
	(361997, 124, '2015-01-15 00:42:35.000000', 'consum', 0.0225, 'lps'),
	(361998, 124, '2015-01-15 00:42:36.000000', 'consum', 0.0229, 'lps'),
	(361999, 124, '2015-01-15 00:42:37.000000', 'consum', 0.0216, 'lps'),
	(362000, 124, '2015-01-15 00:42:38.000000', 'consum', 0.0227, 'lps'),
	(362001, 124, '2015-01-15 00:42:39.000000', 'consum', 0.0214, 'lps'),
	(362002, 124, '2015-01-15 00:42:40.000000', 'consum', 0.0220, 'lps'),
	(362003, 124, '2015-01-15 00:42:41.000000', 'consum', 0.0229, 'lps'),
	(362004, 124, '2015-01-15 00:42:42.000000', 'consum', 0.0230, 'lps'),
	(362005, 124, '2015-01-15 00:42:43.000000', 'consum', 0.0211, 'lps'),
	(362006, 124, '2015-01-15 00:42:44.000000', 'consum', 0.0219, 'lps'),
	(362007, 124, '2015-01-15 00:42:45.000000', 'consum', 0.0211, 'lps'),
	(362008, 124, '2015-01-15 00:42:46.000000', 'consum', 0.0212, 'lps'),
	(362009, 124, '2015-01-15 00:42:47.000000', 'consum', 0.0214, 'lps'),
	(362010, 124, '2015-01-15 00:42:48.000000', 'consum', 0.0228, 'lps'),
	(362011, 124, '2015-01-15 00:42:49.000000', 'consum', 0.0220, 'lps'),
	(362012, 124, '2015-01-15 00:42:50.000000', 'consum', 0.0228, 'lps'),
	(362013, 124, '2015-01-15 00:42:51.000000', 'consum', 0.0228, 'lps'),
	(362014, 124, '2015-01-15 00:42:52.000000', 'consum', 0.0223, 'lps'),
	(362015, 124, '2015-01-15 00:42:53.000000', 'consum', 0.0221, 'lps'),
	(362016, 124, '2015-01-15 00:42:54.000000', 'consum', 0.0228, 'lps'),
	(362017, 124, '2015-01-15 00:42:55.000000', 'consum', 0.0223, 'lps'),
	(362018, 124, '2015-01-15 00:42:56.000000', 'consum', 0.0219, 'lps'),
	(362019, 124, '2015-01-15 00:42:57.000000', 'consum', 0.0220, 'lps'),
	(362020, 124, '2015-01-15 00:42:58.000000', 'consum', 0.0211, 'lps'),
	(362021, 124, '2015-01-15 00:42:59.000000', 'consum', 0.0229, 'lps'),
	(362022, 124, '2015-01-15 00:43:00.000000', 'consum', 0.0215, 'lps'),
	(362023, 124, '2015-01-15 00:43:01.000000', 'consum', 0.0222, 'lps'),
	(362024, 124, '2015-01-15 00:43:02.000000', 'consum', 0.0210, 'lps'),
	(362025, 124, '2015-01-15 00:43:03.000000', 'consum', 0.0218, 'lps'),
	(362026, 124, '2015-01-15 00:43:04.000000', 'consum', 0.0231, 'lps'),
	(362027, 124, '2015-01-15 00:43:05.000000', 'consum', 0.0227, 'lps'),
	(362028, 124, '2015-01-15 00:43:06.000000', 'consum', 0.0229, 'lps'),
	(362029, 124, '2015-01-15 00:43:07.000000', 'consum', 0.0210, 'lps'),
	(362030, 124, '2015-01-15 00:43:08.000000', 'consum', 0.0222, 'lps'),
	(362031, 124, '2015-01-15 00:43:09.000000', 'consum', 0.0226, 'lps'),
	(362032, 124, '2015-01-15 00:43:10.000000', 'consum', 0.0212, 'lps'),
	(362033, 124, '2015-01-15 00:43:11.000000', 'consum', 0.0213, 'lps'),
	(362034, 124, '2015-01-15 00:43:12.000000', 'consum', 0.0223, 'lps'),
	(362035, 124, '2015-01-15 00:43:13.000000', 'consum', 0.0221, 'lps'),
	(362036, 124, '2015-01-15 00:43:14.000000', 'consum', 0.0227, 'lps'),
	(362037, 124, '2015-01-15 00:43:15.000000', 'consum', 0.0217, 'lps'),
	(362038, 124, '2015-01-15 00:43:16.000000', 'consum', 0.0216, 'lps'),
	(362039, 124, '2015-01-15 00:43:17.000000', 'consum', 0.0222, 'lps'),
	(362040, 124, '2015-01-15 00:43:18.000000', 'consum', 0.0227, 'lps'),
	(362041, 124, '2015-01-15 00:43:19.000000', 'consum', 0.0219, 'lps'),
	(362042, 124, '2015-01-15 00:43:20.000000', 'consum', 0.0225, 'lps'),
	(362043, 124, '2015-01-15 00:43:21.000000', 'consum', 0.0216, 'lps'),
	(362044, 124, '2015-01-15 00:43:22.000000', 'consum', 0.0217, 'lps'),
	(362045, 124, '2015-01-15 00:43:23.000000', 'consum', 0.0226, 'lps'),
	(362046, 124, '2015-01-15 00:43:24.000000', 'consum', 0.0227, 'lps'),
	(362047, 124, '2015-01-15 00:43:25.000000', 'consum', 0.0223, 'lps'),
	(362048, 124, '2015-01-15 00:43:26.000000', 'consum', 0.0228, 'lps'),
	(362049, 124, '2015-01-15 00:43:27.000000', 'consum', 0.0216, 'lps'),
	(362050, 124, '2015-01-15 00:43:28.000000', 'consum', 0.0231, 'lps'),
	(362051, 124, '2015-01-15 00:43:29.000000', 'consum', 0.0230, 'lps'),
	(362052, 124, '2015-01-15 00:43:30.000000', 'consum', 0.0227, 'lps'),
	(362053, 124, '2015-01-15 00:43:31.000000', 'consum', 0.0212, 'lps'),
	(362054, 124, '2015-01-15 00:43:32.000000', 'consum', 0.0213, 'lps'),
	(362055, 124, '2015-01-15 00:43:33.000000', 'consum', 0.0220, 'lps'),
	(362056, 124, '2015-01-15 00:43:34.000000', 'consum', 0.0210, 'lps'),
	(362057, 124, '2015-01-15 00:43:35.000000', 'consum', 0.0222, 'lps'),
	(362058, 124, '2015-01-15 00:43:36.000000', 'consum', 0.0229, 'lps'),
	(362059, 124, '2015-01-15 00:43:37.000000', 'consum', 0.0223, 'lps'),
	(362060, 124, '2015-01-15 00:43:38.000000', 'consum', 0.0221, 'lps'),
	(362061, 124, '2015-01-15 00:43:39.000000', 'consum', 0.0227, 'lps'),
	(362062, 124, '2015-01-15 00:43:40.000000', 'consum', 0.0216, 'lps'),
	(362063, 124, '2015-01-15 00:43:41.000000', 'consum', 0.0212, 'lps'),
	(362064, 124, '2015-01-15 00:43:42.000000', 'consum', 0.0223, 'lps'),
	(362065, 124, '2015-01-15 00:43:43.000000', 'consum', 0.0227, 'lps'),
	(362066, 124, '2015-01-15 00:43:44.000000', 'consum', 0.0211, 'lps'),
	(362067, 124, '2015-01-15 00:43:45.000000', 'consum', 0.0230, 'lps'),
	(362068, 124, '2015-01-15 00:43:46.000000', 'consum', 0.0222, 'lps'),
	(362069, 124, '2015-01-15 00:43:47.000000', 'consum', 0.0210, 'lps'),
	(362070, 124, '2015-01-15 00:43:48.000000', 'consum', 0.0220, 'lps'),
	(362071, 124, '2015-01-15 00:43:49.000000', 'consum', 0.0214, 'lps'),
	(362072, 124, '2015-01-15 00:43:50.000000', 'consum', 0.0224, 'lps'),
	(362073, 124, '2015-01-15 00:43:51.000000', 'consum', 0.0224, 'lps'),
	(362074, 124, '2015-01-15 00:43:52.000000', 'consum', 0.0218, 'lps'),
	(362075, 124, '2015-01-15 00:43:53.000000', 'consum', 0.0228, 'lps'),
	(362076, 124, '2015-01-15 00:43:54.000000', 'consum', 0.0211, 'lps'),
	(362077, 124, '2015-01-15 00:43:55.000000', 'consum', 0.0228, 'lps'),
	(362078, 124, '2015-01-15 00:43:56.000000', 'consum', 0.0211, 'lps'),
	(362079, 124, '2015-01-15 00:43:57.000000', 'consum', 0.0225, 'lps'),
	(362080, 124, '2015-01-15 00:43:58.000000', 'consum', 0.0218, 'lps'),
	(362081, 124, '2015-01-15 00:43:59.000000', 'consum', 0.0227, 'lps'),
	(362082, 124, '2015-01-15 00:44:00.000000', 'consum', 0.0228, 'lps'),
	(362083, 124, '2015-01-15 00:44:01.000000', 'consum', 0.0227, 'lps'),
	(362084, 124, '2015-01-15 00:44:02.000000', 'consum', 0.0220, 'lps'),
	(362085, 124, '2015-01-15 00:44:03.000000', 'consum', 0.0210, 'lps'),
	(362086, 124, '2015-01-15 00:44:04.000000', 'consum', 0.0224, 'lps'),
	(362087, 124, '2015-01-15 00:44:05.000000', 'consum', 0.0215, 'lps'),
	(362088, 124, '2015-01-15 00:44:06.000000', 'consum', 0.0213, 'lps'),
	(362089, 124, '2015-01-15 00:44:07.000000', 'consum', 0.0214, 'lps'),
	(362090, 124, '2015-01-15 00:44:08.000000', 'consum', 0.0219, 'lps'),
	(362091, 124, '2015-01-15 00:44:09.000000', 'consum', 0.0224, 'lps'),
	(362092, 124, '2015-01-15 00:44:10.000000', 'consum', 0.0231, 'lps'),
	(362093, 124, '2015-01-15 00:44:11.000000', 'consum', 0.0227, 'lps'),
	(362094, 124, '2015-01-15 00:44:12.000000', 'consum', 0.0212, 'lps'),
	(362095, 124, '2015-01-15 00:44:13.000000', 'consum', 0.0214, 'lps'),
	(362096, 124, '2015-01-15 00:44:14.000000', 'consum', 0.0226, 'lps'),
	(362097, 124, '2015-01-15 00:44:15.000000', 'consum', 0.0231, 'lps'),
	(362098, 124, '2015-01-15 00:44:16.000000', 'consum', 0.0227, 'lps'),
	(362099, 124, '2015-01-15 00:44:17.000000', 'consum', 0.0229, 'lps'),
	(362100, 124, '2015-01-15 00:44:18.000000', 'consum', 0.0212, 'lps'),
	(362101, 124, '2015-01-15 00:44:19.000000', 'consum', 0.0231, 'lps'),
	(362102, 124, '2015-01-15 00:44:20.000000', 'consum', 0.0221, 'lps'),
	(362103, 124, '2015-01-15 00:44:21.000000', 'consum', 0.0226, 'lps'),
	(362104, 124, '2015-01-15 00:44:22.000000', 'consum', 0.0210, 'lps'),
	(362105, 124, '2015-01-15 00:44:23.000000', 'consum', 0.0210, 'lps'),
	(362106, 124, '2015-01-15 00:44:24.000000', 'consum', 0.0230, 'lps'),
	(362107, 124, '2015-01-15 00:44:25.000000', 'consum', 0.0225, 'lps'),
	(362108, 124, '2015-01-15 00:44:26.000000', 'consum', 0.0226, 'lps'),
	(362109, 124, '2015-01-15 00:44:27.000000', 'consum', 0.0221, 'lps'),
	(362110, 124, '2015-01-15 00:44:28.000000', 'consum', 0.0219, 'lps'),
	(362111, 124, '2015-01-15 00:44:29.000000', 'consum', 0.0220, 'lps'),
	(362112, 124, '2015-01-15 00:44:30.000000', 'consum', 0.0215, 'lps'),
	(362113, 124, '2015-01-15 00:44:31.000000', 'consum', 0.0224, 'lps'),
	(362114, 124, '2015-01-15 00:44:32.000000', 'consum', 0.0224, 'lps'),
	(362115, 124, '2015-01-15 00:44:33.000000', 'consum', 0.0214, 'lps'),
	(362116, 124, '2015-01-15 00:44:34.000000', 'consum', 0.0213, 'lps'),
	(362117, 124, '2015-01-15 00:44:35.000000', 'consum', 0.0211, 'lps'),
	(362118, 124, '2015-01-15 00:44:36.000000', 'consum', 0.0229, 'lps'),
	(362119, 124, '2015-01-15 00:44:37.000000', 'consum', 0.0214, 'lps'),
	(362120, 124, '2015-01-15 00:44:38.000000', 'consum', 0.0220, 'lps'),
	(362121, 124, '2015-01-15 00:44:39.000000', 'consum', 0.0224, 'lps'),
	(362122, 124, '2015-01-15 00:44:40.000000', 'consum', 0.0229, 'lps'),
	(362123, 124, '2015-01-15 00:44:41.000000', 'consum', 0.0221, 'lps'),
	(362124, 124, '2015-01-15 00:44:42.000000', 'consum', 0.0230, 'lps'),
	(362125, 124, '2015-01-15 00:44:43.000000', 'consum', 0.0211, 'lps'),
	(362126, 124, '2015-01-15 00:44:44.000000', 'consum', 0.0223, 'lps'),
	(362127, 124, '2015-01-15 00:44:45.000000', 'consum', 0.0228, 'lps'),
	(362128, 124, '2015-01-15 00:44:46.000000', 'consum', 0.0216, 'lps'),
	(362129, 124, '2015-01-15 00:44:47.000000', 'consum', 0.0231, 'lps'),
	(362130, 124, '2015-01-15 00:44:48.000000', 'consum', 0.0211, 'lps'),
	(362131, 124, '2015-01-15 00:44:49.000000', 'consum', 0.0220, 'lps'),
	(362132, 124, '2015-01-15 00:44:50.000000', 'consum', 0.0210, 'lps'),
	(362133, 124, '2015-01-15 00:44:51.000000', 'consum', 0.0225, 'lps'),
	(362134, 124, '2015-01-15 00:44:52.000000', 'consum', 0.0219, 'lps'),
	(362135, 124, '2015-01-15 00:44:53.000000', 'consum', 0.0210, 'lps'),
	(362136, 124, '2015-01-15 00:44:54.000000', 'consum', 0.0228, 'lps'),
	(362137, 124, '2015-01-15 00:44:55.000000', 'consum', 0.0212, 'lps'),
	(362138, 124, '2015-01-15 00:44:56.000000', 'consum', 0.0231, 'lps'),
	(362139, 124, '2015-01-15 00:44:57.000000', 'consum', 0.0224, 'lps'),
	(362140, 124, '2015-01-15 00:44:58.000000', 'consum', 0.0216, 'lps'),
	(362141, 124, '2015-01-15 00:44:59.000000', 'consum', 0.0219, 'lps'),
	(362142, 124, '2015-01-15 00:45:00.000000', 'consum', 0.0217, 'lps'),
	(362143, 124, '2015-01-15 00:45:01.000000', 'consum', 0.0217, 'lps'),
	(362144, 124, '2015-01-15 00:45:02.000000', 'consum', 0.0224, 'lps'),
	(362145, 124, '2015-01-15 00:45:03.000000', 'consum', 0.0218, 'lps'),
	(362146, 124, '2015-01-15 00:45:04.000000', 'consum', 0.0228, 'lps'),
	(362147, 124, '2015-01-15 00:45:05.000000', 'consum', 0.0211, 'lps'),
	(362148, 124, '2015-01-15 00:45:06.000000', 'consum', 0.0227, 'lps'),
	(362149, 124, '2015-01-15 00:45:07.000000', 'consum', 0.0228, 'lps'),
	(362150, 124, '2015-01-15 00:45:08.000000', 'consum', 0.0228, 'lps'),
	(362151, 124, '2015-01-15 00:45:09.000000', 'consum', 0.0222, 'lps'),
	(362152, 124, '2015-01-15 00:45:10.000000', 'consum', 0.0218, 'lps'),
	(362153, 124, '2015-01-15 00:45:11.000000', 'consum', 0.0216, 'lps'),
	(362154, 124, '2015-01-15 00:45:12.000000', 'consum', 0.0215, 'lps'),
	(362155, 124, '2015-01-15 00:45:13.000000', 'consum', 0.0216, 'lps'),
	(362156, 124, '2015-01-15 00:45:14.000000', 'consum', 0.0228, 'lps'),
	(362157, 124, '2015-01-15 00:45:15.000000', 'consum', 0.0214, 'lps'),
	(362158, 124, '2015-01-15 00:45:16.000000', 'consum', 0.0223, 'lps'),
	(362159, 124, '2015-01-15 00:45:17.000000', 'consum', 0.0220, 'lps'),
	(362160, 124, '2015-01-15 00:45:18.000000', 'consum', 0.0222, 'lps'),
	(362161, 124, '2015-01-15 00:45:19.000000', 'consum', 0.0218, 'lps'),
	(362162, 124, '2015-01-15 00:45:20.000000', 'consum', 0.0216, 'lps'),
	(362163, 124, '2015-01-15 00:45:21.000000', 'consum', 0.0216, 'lps'),
	(362164, 124, '2015-01-15 00:45:22.000000', 'consum', 0.0223, 'lps'),
	(362165, 124, '2015-01-15 00:45:23.000000', 'consum', 0.0212, 'lps'),
	(362166, 124, '2015-01-15 00:45:24.000000', 'consum', 0.0226, 'lps'),
	(362167, 124, '2015-01-15 00:45:25.000000', 'consum', 0.0217, 'lps'),
	(362168, 124, '2015-01-15 00:45:26.000000', 'consum', 0.0220, 'lps'),
	(362169, 124, '2015-01-15 00:45:27.000000', 'consum', 0.0216, 'lps'),
	(362170, 124, '2015-01-15 00:45:28.000000', 'consum', 0.0213, 'lps'),
	(362171, 124, '2015-01-15 00:45:29.000000', 'consum', 0.0229, 'lps'),
	(362172, 124, '2015-01-15 00:45:30.000000', 'consum', 0.0228, 'lps'),
	(362173, 124, '2015-01-15 00:45:31.000000', 'consum', 0.0224, 'lps'),
	(362174, 124, '2015-01-15 00:45:32.000000', 'consum', 0.0226, 'lps'),
	(362175, 124, '2015-01-15 00:45:33.000000', 'consum', 0.0228, 'lps'),
	(362176, 124, '2015-01-15 00:45:34.000000', 'consum', 0.0228, 'lps'),
	(362177, 124, '2015-01-15 00:45:35.000000', 'consum', 0.0227, 'lps'),
	(362178, 124, '2015-01-15 00:45:36.000000', 'consum', 0.0217, 'lps'),
	(362179, 124, '2015-01-15 00:45:37.000000', 'consum', 0.0219, 'lps'),
	(362180, 124, '2015-01-15 00:45:38.000000', 'consum', 0.0211, 'lps'),
	(362181, 124, '2015-01-15 00:45:39.000000', 'consum', 0.0213, 'lps'),
	(362182, 124, '2015-01-15 00:45:40.000000', 'consum', 0.0221, 'lps'),
	(362183, 124, '2015-01-15 00:45:41.000000', 'consum', 0.0212, 'lps'),
	(362184, 124, '2015-01-15 00:45:42.000000', 'consum', 0.0230, 'lps'),
	(362185, 124, '2015-01-15 00:45:43.000000', 'consum', 0.0220, 'lps'),
	(362186, 124, '2015-01-15 00:45:44.000000', 'consum', 0.0219, 'lps'),
	(362187, 124, '2015-01-15 00:45:45.000000', 'consum', 0.0228, 'lps'),
	(362188, 124, '2015-01-15 00:45:46.000000', 'consum', 0.0228, 'lps'),
	(362189, 124, '2015-01-15 00:45:47.000000', 'consum', 0.0225, 'lps'),
	(362190, 124, '2015-01-15 00:45:48.000000', 'consum', 0.0231, 'lps'),
	(362191, 124, '2015-01-15 00:45:49.000000', 'consum', 0.0226, 'lps'),
	(362192, 124, '2015-01-15 00:45:50.000000', 'consum', 0.0226, 'lps'),
	(362193, 124, '2015-01-15 00:45:51.000000', 'consum', 0.0223, 'lps'),
	(362194, 124, '2015-01-15 00:45:52.000000', 'consum', 0.0226, 'lps'),
	(362195, 124, '2015-01-15 00:45:53.000000', 'consum', 0.0230, 'lps'),
	(362196, 124, '2015-01-15 00:45:54.000000', 'consum', 0.0219, 'lps'),
	(362197, 124, '2015-01-15 00:45:55.000000', 'consum', 0.0219, 'lps'),
	(362198, 124, '2015-01-15 00:45:56.000000', 'consum', 0.0228, 'lps'),
	(362199, 124, '2015-01-15 00:45:57.000000', 'consum', 0.0228, 'lps'),
	(362200, 124, '2015-01-15 00:45:58.000000', 'consum', 0.0226, 'lps'),
	(362201, 124, '2015-01-15 00:45:59.000000', 'consum', 0.0212, 'lps'),
	(362202, 124, '2015-01-15 00:46:00.000000', 'consum', 0.0220, 'lps'),
	(362203, 124, '2015-01-15 00:46:01.000000', 'consum', 0.0231, 'lps'),
	(362204, 124, '2015-01-15 00:46:02.000000', 'consum', 0.0218, 'lps'),
	(362205, 124, '2015-01-15 00:46:03.000000', 'consum', 0.0210, 'lps'),
	(362206, 124, '2015-01-15 00:46:04.000000', 'consum', 0.0230, 'lps'),
	(362207, 124, '2015-01-15 00:46:05.000000', 'consum', 0.0221, 'lps'),
	(362208, 124, '2015-01-15 00:46:06.000000', 'consum', 0.0229, 'lps'),
	(362209, 124, '2015-01-15 00:46:07.000000', 'consum', 0.0230, 'lps'),
	(362210, 124, '2015-01-15 00:46:08.000000', 'consum', 0.0210, 'lps'),
	(362211, 124, '2015-01-15 00:46:09.000000', 'consum', 0.0213, 'lps'),
	(362212, 124, '2015-01-15 00:46:10.000000', 'consum', 0.0229, 'lps'),
	(362213, 124, '2015-01-15 00:46:11.000000', 'consum', 0.0231, 'lps'),
	(362214, 124, '2015-01-15 00:46:12.000000', 'consum', 0.0212, 'lps'),
	(362215, 124, '2015-01-15 00:46:13.000000', 'consum', 0.0223, 'lps'),
	(362216, 124, '2015-01-15 00:46:14.000000', 'consum', 0.0225, 'lps'),
	(362217, 124, '2015-01-15 00:46:15.000000', 'consum', 0.0227, 'lps'),
	(362218, 124, '2015-01-15 00:46:16.000000', 'consum', 0.0227, 'lps'),
	(362219, 124, '2015-01-15 00:46:17.000000', 'consum', 0.0224, 'lps'),
	(362220, 124, '2015-01-15 00:46:18.000000', 'consum', 0.0227, 'lps'),
	(362221, 124, '2015-01-15 00:46:19.000000', 'consum', 0.0212, 'lps'),
	(362222, 124, '2015-01-15 00:46:20.000000', 'consum', 0.0213, 'lps'),
	(362223, 124, '2015-01-15 00:46:21.000000', 'consum', 0.0219, 'lps'),
	(362224, 124, '2015-01-15 00:46:22.000000', 'consum', 0.0226, 'lps'),
	(362225, 124, '2015-01-15 00:46:23.000000', 'consum', 0.0217, 'lps'),
	(362226, 124, '2015-01-15 00:46:24.000000', 'consum', 0.0221, 'lps'),
	(362227, 124, '2015-01-15 00:46:25.000000', 'consum', 0.0221, 'lps'),
	(362228, 124, '2015-01-15 00:46:26.000000', 'consum', 0.0212, 'lps'),
	(362229, 124, '2015-01-15 00:46:27.000000', 'consum', 0.0211, 'lps'),
	(362230, 124, '2015-01-15 00:46:28.000000', 'consum', 0.0229, 'lps'),
	(362231, 124, '2015-01-15 00:46:29.000000', 'consum', 0.0216, 'lps'),
	(362232, 124, '2015-01-15 00:46:30.000000', 'consum', 0.0225, 'lps'),
	(362233, 124, '2015-01-15 00:46:31.000000', 'consum', 0.0226, 'lps'),
	(362234, 124, '2015-01-15 00:46:32.000000', 'consum', 0.0224, 'lps'),
	(362235, 124, '2015-01-15 00:46:33.000000', 'consum', 0.0211, 'lps'),
	(362236, 124, '2015-01-15 00:46:34.000000', 'consum', 0.0217, 'lps'),
	(362237, 124, '2015-01-15 00:46:35.000000', 'consum', 0.0220, 'lps'),
	(362238, 124, '2015-01-15 00:46:36.000000', 'consum', 0.0219, 'lps'),
	(362239, 124, '2015-01-15 00:46:37.000000', 'consum', 0.0222, 'lps'),
	(362240, 124, '2015-01-15 00:46:38.000000', 'consum', 0.0225, 'lps'),
	(362241, 124, '2015-01-15 00:46:39.000000', 'consum', 0.0227, 'lps'),
	(362242, 124, '2015-01-15 00:46:40.000000', 'consum', 0.0227, 'lps'),
	(362243, 124, '2015-01-15 00:46:41.000000', 'consum', 0.0222, 'lps'),
	(362244, 124, '2015-01-15 00:46:42.000000', 'consum', 0.0219, 'lps'),
	(362245, 124, '2015-01-15 00:46:43.000000', 'consum', 0.0219, 'lps'),
	(362246, 124, '2015-01-15 00:46:44.000000', 'consum', 0.0228, 'lps'),
	(362247, 124, '2015-01-15 00:46:45.000000', 'consum', 0.0230, 'lps'),
	(362248, 124, '2015-01-15 00:46:46.000000', 'consum', 0.0215, 'lps'),
	(362249, 124, '2015-01-15 00:46:47.000000', 'consum', 0.0217, 'lps'),
	(362250, 124, '2015-01-15 00:46:48.000000', 'consum', 0.0229, 'lps'),
	(362251, 124, '2015-01-15 00:46:49.000000', 'consum', 0.0222, 'lps'),
	(362252, 124, '2015-01-15 00:46:50.000000', 'consum', 0.0212, 'lps'),
	(362253, 124, '2015-01-15 00:46:51.000000', 'consum', 0.0228, 'lps'),
	(362254, 124, '2015-01-15 00:46:52.000000', 'consum', 0.0227, 'lps'),
	(362255, 124, '2015-01-15 00:46:53.000000', 'consum', 0.0221, 'lps'),
	(362256, 124, '2015-01-15 00:46:54.000000', 'consum', 0.0213, 'lps'),
	(362257, 124, '2015-01-15 00:46:55.000000', 'consum', 0.0216, 'lps'),
	(362258, 124, '2015-01-15 00:46:56.000000', 'consum', 0.0229, 'lps'),
	(362259, 124, '2015-01-15 00:46:57.000000', 'consum', 0.0224, 'lps'),
	(362260, 124, '2015-01-15 00:46:58.000000', 'consum', 0.0224, 'lps'),
	(362261, 124, '2015-01-15 00:46:59.000000', 'consum', 0.0216, 'lps'),
	(362262, 124, '2015-01-15 00:47:00.000000', 'consum', 0.0221, 'lps'),
	(362263, 124, '2015-01-15 00:47:01.000000', 'consum', 0.0225, 'lps'),
	(362264, 124, '2015-01-15 00:47:02.000000', 'consum', 0.0210, 'lps'),
	(362265, 124, '2015-01-15 00:47:03.000000', 'consum', 0.0210, 'lps'),
	(362266, 124, '2015-01-15 00:47:04.000000', 'consum', 0.0230, 'lps'),
	(362267, 124, '2015-01-15 00:47:05.000000', 'consum', 0.0225, 'lps'),
	(362268, 124, '2015-01-15 00:47:06.000000', 'consum', 0.0223, 'lps'),
	(362269, 124, '2015-01-15 00:47:07.000000', 'consum', 0.0229, 'lps'),
	(362270, 124, '2015-01-15 00:47:08.000000', 'consum', 0.0226, 'lps'),
	(362271, 124, '2015-01-15 00:47:09.000000', 'consum', 0.0210, 'lps'),
	(362272, 124, '2015-01-15 00:47:10.000000', 'consum', 0.0228, 'lps'),
	(362273, 124, '2015-01-15 00:47:11.000000', 'consum', 0.0214, 'lps'),
	(362274, 124, '2015-01-15 00:47:12.000000', 'consum', 0.0220, 'lps'),
	(362275, 124, '2015-01-15 00:47:13.000000', 'consum', 0.0227, 'lps'),
	(362276, 124, '2015-01-15 00:47:14.000000', 'consum', 0.0220, 'lps'),
	(362277, 124, '2015-01-15 00:47:15.000000', 'consum', 0.0210, 'lps'),
	(362278, 124, '2015-01-15 00:47:16.000000', 'consum', 0.0226, 'lps'),
	(362279, 124, '2015-01-15 00:47:17.000000', 'consum', 0.0226, 'lps'),
	(362280, 124, '2015-01-15 00:47:18.000000', 'consum', 0.0217, 'lps'),
	(362281, 124, '2015-01-15 00:47:19.000000', 'consum', 0.0220, 'lps'),
	(362282, 124, '2015-01-15 00:47:20.000000', 'consum', 0.0218, 'lps'),
	(362283, 124, '2015-01-15 00:47:21.000000', 'consum', 0.0222, 'lps'),
	(362284, 124, '2015-01-15 00:47:22.000000', 'consum', 0.0224, 'lps'),
	(362285, 124, '2015-01-15 00:47:23.000000', 'consum', 0.0221, 'lps'),
	(362286, 124, '2015-01-15 00:47:24.000000', 'consum', 0.0225, 'lps'),
	(362287, 124, '2015-01-15 00:47:25.000000', 'consum', 0.0229, 'lps'),
	(362288, 124, '2015-01-15 00:47:26.000000', 'consum', 0.0219, 'lps'),
	(362289, 124, '2015-01-15 00:47:27.000000', 'consum', 0.0218, 'lps'),
	(362290, 124, '2015-01-15 00:47:28.000000', 'consum', 0.0223, 'lps'),
	(362291, 124, '2015-01-15 00:47:29.000000', 'consum', 0.0231, 'lps'),
	(362292, 124, '2015-01-15 00:47:30.000000', 'consum', 0.0211, 'lps'),
	(362293, 124, '2015-01-15 00:47:31.000000', 'consum', 0.0216, 'lps'),
	(362294, 124, '2015-01-15 00:47:32.000000', 'consum', 0.0218, 'lps'),
	(362295, 124, '2015-01-15 00:47:33.000000', 'consum', 0.0210, 'lps'),
	(362296, 124, '2015-01-15 00:47:34.000000', 'consum', 0.0230, 'lps'),
	(362297, 124, '2015-01-15 00:47:35.000000', 'consum', 0.0221, 'lps'),
	(362298, 124, '2015-01-15 00:47:36.000000', 'consum', 0.0227, 'lps'),
	(362299, 124, '2015-01-15 00:47:37.000000', 'consum', 0.0221, 'lps'),
	(362300, 124, '2015-01-15 00:47:38.000000', 'consum', 0.0215, 'lps'),
	(362301, 124, '2015-01-15 00:47:39.000000', 'consum', 0.0226, 'lps'),
	(362302, 124, '2015-01-15 00:47:40.000000', 'consum', 0.0228, 'lps'),
	(362303, 124, '2015-01-15 00:47:41.000000', 'consum', 0.0231, 'lps'),
	(362304, 124, '2015-01-15 00:47:42.000000', 'consum', 0.0217, 'lps'),
	(362305, 124, '2015-01-15 00:47:43.000000', 'consum', 0.0229, 'lps'),
	(362306, 124, '2015-01-15 00:47:44.000000', 'consum', 0.0218, 'lps'),
	(362307, 124, '2015-01-15 00:47:45.000000', 'consum', 0.0216, 'lps'),
	(362308, 124, '2015-01-15 00:47:46.000000', 'consum', 0.0215, 'lps'),
	(362309, 124, '2015-01-15 00:47:47.000000', 'consum', 0.0218, 'lps'),
	(362310, 124, '2015-01-15 00:47:48.000000', 'consum', 0.0215, 'lps'),
	(362311, 124, '2015-01-15 00:47:49.000000', 'consum', 0.0212, 'lps'),
	(362312, 124, '2015-01-15 00:47:50.000000', 'consum', 0.0225, 'lps'),
	(362313, 124, '2015-01-15 00:47:51.000000', 'consum', 0.0214, 'lps'),
	(362314, 124, '2015-01-15 00:47:52.000000', 'consum', 0.0228, 'lps'),
	(362315, 124, '2015-01-15 00:47:53.000000', 'consum', 0.0223, 'lps'),
	(362316, 124, '2015-01-15 00:47:54.000000', 'consum', 0.0220, 'lps'),
	(362317, 124, '2015-01-15 00:47:55.000000', 'consum', 0.0223, 'lps'),
	(362318, 124, '2015-01-15 00:47:56.000000', 'consum', 0.0222, 'lps'),
	(362319, 124, '2015-01-15 00:47:57.000000', 'consum', 0.0212, 'lps'),
	(362320, 124, '2015-01-15 00:47:58.000000', 'consum', 0.0226, 'lps'),
	(362321, 124, '2015-01-15 00:47:59.000000', 'consum', 0.0219, 'lps'),
	(362322, 124, '2015-01-15 00:48:00.000000', 'consum', 0.0231, 'lps'),
	(362323, 124, '2015-01-15 00:48:01.000000', 'consum', 0.0221, 'lps'),
	(362324, 124, '2015-01-15 00:48:02.000000', 'consum', 0.0227, 'lps'),
	(362325, 124, '2015-01-15 00:48:03.000000', 'consum', 0.0217, 'lps'),
	(362326, 124, '2015-01-15 00:48:04.000000', 'consum', 0.0216, 'lps'),
	(362327, 124, '2015-01-15 00:48:05.000000', 'consum', 0.0221, 'lps'),
	(362328, 124, '2015-01-15 00:48:06.000000', 'consum', 0.0224, 'lps'),
	(362329, 124, '2015-01-15 00:48:07.000000', 'consum', 0.0226, 'lps'),
	(362330, 124, '2015-01-15 00:48:08.000000', 'consum', 0.0225, 'lps'),
	(362331, 124, '2015-01-15 00:48:09.000000', 'consum', 0.0217, 'lps'),
	(362332, 124, '2015-01-15 00:48:10.000000', 'consum', 0.0223, 'lps'),
	(362333, 124, '2015-01-15 00:48:11.000000', 'consum', 0.0210, 'lps'),
	(362334, 124, '2015-01-15 00:48:12.000000', 'consum', 0.0216, 'lps'),
	(362335, 124, '2015-01-15 00:48:13.000000', 'consum', 0.0220, 'lps'),
	(362336, 124, '2015-01-15 00:48:14.000000', 'consum', 0.0217, 'lps'),
	(362337, 124, '2015-01-15 00:48:15.000000', 'consum', 0.0217, 'lps'),
	(362338, 124, '2015-01-15 00:48:16.000000', 'consum', 0.0226, 'lps'),
	(362339, 124, '2015-01-15 00:48:17.000000', 'consum', 0.0224, 'lps'),
	(362340, 124, '2015-01-15 00:48:18.000000', 'consum', 0.0211, 'lps'),
	(362341, 124, '2015-01-15 00:48:19.000000', 'consum', 0.0219, 'lps'),
	(362342, 124, '2015-01-15 00:48:20.000000', 'consum', 0.0229, 'lps'),
	(362343, 124, '2015-01-15 00:48:21.000000', 'consum', 0.0212, 'lps'),
	(362344, 124, '2015-01-15 00:48:22.000000', 'consum', 0.0230, 'lps'),
	(362345, 124, '2015-01-15 00:48:23.000000', 'consum', 0.0218, 'lps'),
	(362346, 124, '2015-01-15 00:48:24.000000', 'consum', 0.0210, 'lps'),
	(362347, 124, '2015-01-15 00:48:25.000000', 'consum', 0.0211, 'lps'),
	(362348, 124, '2015-01-15 00:48:26.000000', 'consum', 0.0215, 'lps'),
	(362349, 124, '2015-01-15 00:48:27.000000', 'consum', 0.0231, 'lps'),
	(362350, 124, '2015-01-15 00:48:28.000000', 'consum', 0.0212, 'lps'),
	(362351, 124, '2015-01-15 00:48:29.000000', 'consum', 0.0225, 'lps'),
	(362352, 124, '2015-01-15 00:48:30.000000', 'consum', 0.0215, 'lps'),
	(362353, 124, '2015-01-15 00:48:31.000000', 'consum', 0.0211, 'lps'),
	(362354, 124, '2015-01-15 00:48:32.000000', 'consum', 0.0224, 'lps'),
	(362355, 124, '2015-01-15 00:48:33.000000', 'consum', 0.0211, 'lps'),
	(362356, 124, '2015-01-15 00:48:34.000000', 'consum', 0.0216, 'lps'),
	(362357, 124, '2015-01-15 00:48:35.000000', 'consum', 0.0217, 'lps'),
	(362358, 124, '2015-01-15 00:48:36.000000', 'consum', 0.0226, 'lps'),
	(362359, 124, '2015-01-15 00:48:37.000000', 'consum', 0.0228, 'lps'),
	(362360, 124, '2015-01-15 00:48:38.000000', 'consum', 0.0229, 'lps'),
	(362361, 124, '2015-01-15 00:48:39.000000', 'consum', 0.0228, 'lps'),
	(362362, 124, '2015-01-15 00:48:40.000000', 'consum', 0.0222, 'lps'),
	(362363, 124, '2015-01-15 00:48:41.000000', 'consum', 0.0216, 'lps'),
	(362364, 124, '2015-01-15 00:48:42.000000', 'consum', 0.0225, 'lps'),
	(362365, 124, '2015-01-15 00:48:43.000000', 'consum', 0.0226, 'lps'),
	(362366, 124, '2015-01-15 00:48:44.000000', 'consum', 0.0225, 'lps'),
	(362367, 124, '2015-01-15 00:48:45.000000', 'consum', 0.0212, 'lps'),
	(362368, 124, '2015-01-15 00:48:46.000000', 'consum', 0.0221, 'lps'),
	(362369, 124, '2015-01-15 00:48:47.000000', 'consum', 0.0217, 'lps'),
	(362370, 124, '2015-01-15 00:48:48.000000', 'consum', 0.0213, 'lps'),
	(362371, 124, '2015-01-15 00:48:49.000000', 'consum', 0.0225, 'lps'),
	(362372, 124, '2015-01-15 00:48:50.000000', 'consum', 0.0212, 'lps'),
	(362373, 124, '2015-01-15 00:48:51.000000', 'consum', 0.0219, 'lps'),
	(362374, 124, '2015-01-15 00:48:52.000000', 'consum', 0.0226, 'lps'),
	(362375, 124, '2015-01-15 00:48:53.000000', 'consum', 0.0220, 'lps'),
	(362376, 124, '2015-01-15 00:48:54.000000', 'consum', 0.0214, 'lps'),
	(362377, 124, '2015-01-15 00:48:55.000000', 'consum', 0.0221, 'lps'),
	(362378, 124, '2015-01-15 00:48:56.000000', 'consum', 0.0210, 'lps'),
	(362379, 124, '2015-01-15 00:48:57.000000', 'consum', 0.0220, 'lps'),
	(362380, 124, '2015-01-15 00:48:58.000000', 'consum', 0.0218, 'lps'),
	(362381, 124, '2015-01-15 00:48:59.000000', 'consum', 0.0219, 'lps'),
	(362382, 124, '2015-01-15 00:49:00.000000', 'consum', 0.0212, 'lps'),
	(362383, 124, '2015-01-15 00:49:01.000000', 'consum', 0.0214, 'lps'),
	(362384, 124, '2015-01-15 00:49:02.000000', 'consum', 0.0225, 'lps'),
	(362385, 124, '2015-01-15 00:49:03.000000', 'consum', 0.0228, 'lps'),
	(362386, 124, '2015-01-15 00:49:04.000000', 'consum', 0.0213, 'lps'),
	(362387, 124, '2015-01-15 00:49:05.000000', 'consum', 0.0213, 'lps'),
	(362388, 124, '2015-01-15 00:49:06.000000', 'consum', 0.0218, 'lps'),
	(362389, 124, '2015-01-15 00:49:07.000000', 'consum', 0.0220, 'lps'),
	(362390, 124, '2015-01-15 00:49:08.000000', 'consum', 0.0214, 'lps'),
	(362391, 124, '2015-01-15 00:49:09.000000', 'consum', 0.0224, 'lps'),
	(362392, 124, '2015-01-15 00:49:10.000000', 'consum', 0.0225, 'lps'),
	(362393, 124, '2015-01-15 00:49:11.000000', 'consum', 0.0221, 'lps'),
	(362394, 124, '2015-01-15 00:49:12.000000', 'consum', 0.0221, 'lps'),
	(362395, 124, '2015-01-15 00:49:13.000000', 'consum', 0.0210, 'lps'),
	(362396, 124, '2015-01-15 00:49:14.000000', 'consum', 0.0221, 'lps'),
	(362397, 124, '2015-01-15 00:49:15.000000', 'consum', 0.0222, 'lps'),
	(362398, 124, '2015-01-15 00:49:16.000000', 'consum', 0.0213, 'lps'),
	(362399, 124, '2015-01-15 00:49:17.000000', 'consum', 0.0215, 'lps'),
	(362400, 124, '2015-01-15 00:49:18.000000', 'consum', 0.0224, 'lps'),
	(362401, 124, '2015-01-15 00:49:19.000000', 'consum', 0.0222, 'lps'),
	(362402, 124, '2015-01-15 00:49:20.000000', 'consum', 0.0228, 'lps'),
	(362403, 124, '2015-01-15 00:49:21.000000', 'consum', 0.0221, 'lps'),
	(362404, 124, '2015-01-15 00:49:22.000000', 'consum', 0.0213, 'lps'),
	(362405, 124, '2015-01-15 00:49:23.000000', 'consum', 0.0212, 'lps'),
	(362406, 124, '2015-01-15 00:49:24.000000', 'consum', 0.0211, 'lps'),
	(362407, 124, '2015-01-15 00:49:25.000000', 'consum', 0.0211, 'lps'),
	(362408, 124, '2015-01-15 00:49:26.000000', 'consum', 0.0212, 'lps'),
	(362409, 124, '2015-01-15 00:49:27.000000', 'consum', 0.0217, 'lps'),
	(362410, 124, '2015-01-15 00:49:28.000000', 'consum', 0.0219, 'lps'),
	(362411, 124, '2015-01-15 00:49:29.000000', 'consum', 0.0211, 'lps'),
	(362412, 124, '2015-01-15 00:49:30.000000', 'consum', 0.0212, 'lps'),
	(362413, 124, '2015-01-15 00:49:31.000000', 'consum', 0.0216, 'lps'),
	(362414, 124, '2015-01-15 00:49:32.000000', 'consum', 0.0213, 'lps'),
	(362415, 124, '2015-01-15 00:49:33.000000', 'consum', 0.0229, 'lps'),
	(362416, 124, '2015-01-15 00:49:34.000000', 'consum', 0.0210, 'lps'),
	(362417, 124, '2015-01-15 00:49:35.000000', 'consum', 0.0220, 'lps'),
	(362418, 124, '2015-01-15 00:49:36.000000', 'consum', 0.0217, 'lps'),
	(362419, 124, '2015-01-15 00:49:37.000000', 'consum', 0.0214, 'lps'),
	(362420, 124, '2015-01-15 00:49:38.000000', 'consum', 0.0210, 'lps'),
	(362421, 124, '2015-01-15 00:49:39.000000', 'consum', 0.0218, 'lps'),
	(362422, 124, '2015-01-15 00:49:40.000000', 'consum', 0.0210, 'lps'),
	(362423, 124, '2015-01-15 00:49:41.000000', 'consum', 0.0230, 'lps'),
	(362424, 124, '2015-01-15 00:49:42.000000', 'consum', 0.0222, 'lps'),
	(362425, 124, '2015-01-15 00:49:43.000000', 'consum', 0.0211, 'lps'),
	(362426, 124, '2015-01-15 00:49:44.000000', 'consum', 0.0223, 'lps'),
	(362427, 124, '2015-01-15 00:49:45.000000', 'consum', 0.0228, 'lps'),
	(362428, 124, '2015-01-15 00:49:46.000000', 'consum', 0.0218, 'lps'),
	(362429, 124, '2015-01-15 00:49:47.000000', 'consum', 0.0219, 'lps'),
	(362430, 124, '2015-01-15 00:49:48.000000', 'consum', 0.0230, 'lps'),
	(362431, 124, '2015-01-15 00:49:49.000000', 'consum', 0.0218, 'lps'),
	(362432, 124, '2015-01-15 00:49:50.000000', 'consum', 0.0213, 'lps'),
	(362433, 124, '2015-01-15 00:49:51.000000', 'consum', 0.0224, 'lps'),
	(362434, 124, '2015-01-15 00:49:52.000000', 'consum', 0.0226, 'lps'),
	(362435, 124, '2015-01-15 00:49:53.000000', 'consum', 0.0226, 'lps'),
	(362436, 124, '2015-01-15 00:49:54.000000', 'consum', 0.0221, 'lps'),
	(362437, 124, '2015-01-15 00:49:55.000000', 'consum', 0.0217, 'lps'),
	(362438, 124, '2015-01-15 00:49:56.000000', 'consum', 0.0214, 'lps'),
	(362439, 124, '2015-01-15 00:49:57.000000', 'consum', 0.0210, 'lps'),
	(362440, 124, '2015-01-15 00:49:58.000000', 'consum', 0.0221, 'lps'),
	(362441, 124, '2015-01-15 00:49:59.000000', 'consum', 0.0222, 'lps'),
	(362442, 124, '2015-01-15 00:50:00.000000', 'consum', 0.0216, 'lps'),
	(362443, 124, '2015-01-15 00:50:01.000000', 'consum', 0.0227, 'lps'),
	(362444, 124, '2015-01-15 00:50:02.000000', 'consum', 0.0231, 'lps'),
	(362445, 124, '2015-01-15 00:50:03.000000', 'consum', 0.0223, 'lps'),
	(362446, 124, '2015-01-15 00:50:04.000000', 'consum', 0.0210, 'lps'),
	(362447, 124, '2015-01-15 00:50:05.000000', 'consum', 0.0218, 'lps'),
	(362448, 124, '2015-01-15 00:50:06.000000', 'consum', 0.0229, 'lps'),
	(362449, 124, '2015-01-15 00:50:07.000000', 'consum', 0.0216, 'lps'),
	(362450, 124, '2015-01-15 00:50:08.000000', 'consum', 0.0227, 'lps'),
	(362451, 124, '2015-01-15 00:50:09.000000', 'consum', 0.0213, 'lps'),
	(362452, 124, '2015-01-15 00:50:10.000000', 'consum', 0.0217, 'lps'),
	(362453, 124, '2015-01-15 00:50:11.000000', 'consum', 0.0213, 'lps'),
	(362454, 124, '2015-01-15 00:50:12.000000', 'consum', 0.0229, 'lps'),
	(362455, 124, '2015-01-15 00:50:13.000000', 'consum', 0.0228, 'lps'),
	(362456, 124, '2015-01-15 00:50:14.000000', 'consum', 0.0222, 'lps'),
	(362457, 124, '2015-01-15 00:50:15.000000', 'consum', 0.0218, 'lps'),
	(362458, 124, '2015-01-15 00:50:16.000000', 'consum', 0.0213, 'lps'),
	(362459, 124, '2015-01-15 00:50:17.000000', 'consum', 0.0224, 'lps'),
	(362460, 124, '2015-01-15 00:50:18.000000', 'consum', 0.0230, 'lps'),
	(362461, 124, '2015-01-15 00:50:19.000000', 'consum', 0.0221, 'lps'),
	(362462, 124, '2015-01-15 00:50:20.000000', 'consum', 0.0227, 'lps'),
	(362463, 124, '2015-01-15 00:50:21.000000', 'consum', 0.0221, 'lps'),
	(362464, 124, '2015-01-15 00:50:22.000000', 'consum', 0.0214, 'lps'),
	(362465, 124, '2015-01-15 00:50:23.000000', 'consum', 0.0219, 'lps'),
	(362466, 124, '2015-01-15 00:50:24.000000', 'consum', 0.0223, 'lps'),
	(362467, 124, '2015-01-15 00:50:25.000000', 'consum', 0.0225, 'lps'),
	(362468, 124, '2015-01-15 00:50:26.000000', 'consum', 0.0223, 'lps'),
	(362469, 124, '2015-01-15 00:50:27.000000', 'consum', 0.0212, 'lps'),
	(362470, 124, '2015-01-15 00:50:28.000000', 'consum', 0.0222, 'lps'),
	(362471, 124, '2015-01-15 00:50:29.000000', 'consum', 0.0224, 'lps'),
	(362472, 124, '2015-01-15 00:50:30.000000', 'consum', 0.0219, 'lps'),
	(362473, 124, '2015-01-15 00:50:31.000000', 'consum', 0.0215, 'lps'),
	(362474, 124, '2015-01-15 00:50:32.000000', 'consum', 0.0230, 'lps'),
	(362475, 124, '2015-01-15 00:50:33.000000', 'consum', 0.0228, 'lps'),
	(362476, 124, '2015-01-15 00:50:34.000000', 'consum', 0.0219, 'lps'),
	(362477, 124, '2015-01-15 00:50:35.000000', 'consum', 0.0222, 'lps'),
	(362478, 124, '2015-01-15 00:50:36.000000', 'consum', 0.0225, 'lps'),
	(362479, 124, '2015-01-15 00:50:37.000000', 'consum', 0.0224, 'lps'),
	(362480, 124, '2015-01-15 00:50:38.000000', 'consum', 0.0216, 'lps'),
	(362481, 124, '2015-01-15 00:50:39.000000', 'consum', 0.0222, 'lps'),
	(362482, 124, '2015-01-15 00:50:40.000000', 'consum', 0.0228, 'lps'),
	(362483, 124, '2015-01-15 00:50:41.000000', 'consum', 0.0222, 'lps'),
	(362484, 124, '2015-01-15 00:50:42.000000', 'consum', 0.0215, 'lps'),
	(362485, 124, '2015-01-15 00:50:43.000000', 'consum', 0.0221, 'lps'),
	(362486, 124, '2015-01-15 00:50:44.000000', 'consum', 0.0227, 'lps'),
	(362487, 124, '2015-01-15 00:50:45.000000', 'consum', 0.0221, 'lps'),
	(362488, 124, '2015-01-15 00:50:46.000000', 'consum', 0.0214, 'lps'),
	(362489, 124, '2015-01-15 00:50:47.000000', 'consum', 0.0220, 'lps'),
	(362490, 124, '2015-01-15 00:50:48.000000', 'consum', 0.0227, 'lps'),
	(362491, 124, '2015-01-15 00:50:49.000000', 'consum', 0.0221, 'lps'),
	(362492, 124, '2015-01-15 00:50:50.000000', 'consum', 0.0214, 'lps'),
	(362493, 124, '2015-01-15 00:50:51.000000', 'consum', 0.0222, 'lps'),
	(362494, 124, '2015-01-15 00:50:52.000000', 'consum', 0.0212, 'lps'),
	(362495, 124, '2015-01-15 00:50:53.000000', 'consum', 0.0231, 'lps'),
	(362496, 124, '2015-01-15 00:50:54.000000', 'consum', 0.0218, 'lps'),
	(362497, 124, '2015-01-15 00:50:55.000000', 'consum', 0.0212, 'lps'),
	(362498, 124, '2015-01-15 00:50:56.000000', 'consum', 0.0219, 'lps'),
	(362499, 124, '2015-01-15 00:50:57.000000', 'consum', 0.0228, 'lps'),
	(362500, 124, '2015-01-15 00:50:58.000000', 'consum', 0.0227, 'lps'),
	(362501, 124, '2015-01-15 00:50:59.000000', 'consum', 0.0222, 'lps'),
	(362502, 124, '2015-01-15 00:51:00.000000', 'consum', 0.0220, 'lps'),
	(362503, 124, '2015-01-15 00:51:01.000000', 'consum', 0.0225, 'lps'),
	(362504, 124, '2015-01-15 00:51:02.000000', 'consum', 0.0230, 'lps'),
	(362505, 124, '2015-01-15 00:51:03.000000', 'consum', 0.0225, 'lps'),
	(362506, 124, '2015-01-15 00:51:04.000000', 'consum', 0.0222, 'lps'),
	(362507, 124, '2015-01-15 00:51:05.000000', 'consum', 0.0229, 'lps'),
	(362508, 124, '2015-01-15 00:51:06.000000', 'consum', 0.0225, 'lps'),
	(362509, 124, '2015-01-15 00:51:07.000000', 'consum', 0.0226, 'lps'),
	(362510, 124, '2015-01-15 00:51:08.000000', 'consum', 0.0224, 'lps'),
	(362511, 124, '2015-01-15 00:51:09.000000', 'consum', 0.0212, 'lps'),
	(362512, 124, '2015-01-15 00:51:10.000000', 'consum', 0.0220, 'lps'),
	(362513, 124, '2015-01-15 00:51:11.000000', 'consum', 0.0212, 'lps'),
	(362514, 124, '2015-01-15 00:51:12.000000', 'consum', 0.0214, 'lps'),
	(362515, 124, '2015-01-15 00:51:13.000000', 'consum', 0.0225, 'lps'),
	(362516, 124, '2015-01-15 00:51:14.000000', 'consum', 0.0229, 'lps'),
	(362517, 124, '2015-01-15 00:51:15.000000', 'consum', 0.0215, 'lps'),
	(362518, 124, '2015-01-15 00:51:16.000000', 'consum', 0.0225, 'lps'),
	(362519, 124, '2015-01-15 00:51:17.000000', 'consum', 0.0224, 'lps'),
	(362520, 124, '2015-01-15 00:51:18.000000', 'consum', 0.0215, 'lps'),
	(362521, 124, '2015-01-15 00:51:19.000000', 'consum', 0.0215, 'lps'),
	(362522, 124, '2015-01-15 00:51:20.000000', 'consum', 0.0223, 'lps'),
	(362523, 124, '2015-01-15 00:51:21.000000', 'consum', 0.0213, 'lps'),
	(362524, 124, '2015-01-15 00:51:22.000000', 'consum', 0.0211, 'lps'),
	(362525, 124, '2015-01-15 00:51:23.000000', 'consum', 0.0229, 'lps'),
	(362526, 124, '2015-01-15 00:51:24.000000', 'consum', 0.0215, 'lps'),
	(362527, 124, '2015-01-15 00:51:25.000000', 'consum', 0.0222, 'lps'),
	(362528, 124, '2015-01-15 00:51:26.000000', 'consum', 0.0212, 'lps'),
	(362529, 124, '2015-01-15 00:51:27.000000', 'consum', 0.0228, 'lps'),
	(362530, 124, '2015-01-15 00:51:28.000000', 'consum', 0.0230, 'lps'),
	(362531, 124, '2015-01-15 00:51:29.000000', 'consum', 0.0213, 'lps'),
	(362532, 124, '2015-01-15 00:51:30.000000', 'consum', 0.0230, 'lps'),
	(362533, 124, '2015-01-15 00:51:31.000000', 'consum', 0.0214, 'lps'),
	(362534, 124, '2015-01-15 00:51:32.000000', 'consum', 0.0213, 'lps'),
	(362535, 124, '2015-01-15 00:51:33.000000', 'consum', 0.0214, 'lps'),
	(362536, 124, '2015-01-15 00:51:34.000000', 'consum', 0.0222, 'lps'),
	(362537, 124, '2015-01-15 00:51:35.000000', 'consum', 0.0212, 'lps'),
	(362538, 124, '2015-01-15 00:51:36.000000', 'consum', 0.0210, 'lps'),
	(362539, 124, '2015-01-15 00:51:37.000000', 'consum', 0.0224, 'lps'),
	(362540, 124, '2015-01-15 00:51:38.000000', 'consum', 0.0213, 'lps'),
	(362541, 124, '2015-01-15 00:51:39.000000', 'consum', 0.0231, 'lps'),
	(362542, 124, '2015-01-15 00:51:40.000000', 'consum', 0.0216, 'lps'),
	(362543, 124, '2015-01-15 00:51:41.000000', 'consum', 0.0222, 'lps'),
	(362544, 124, '2015-01-15 00:51:42.000000', 'consum', 0.0231, 'lps'),
	(362545, 124, '2015-01-15 00:51:43.000000', 'consum', 0.0214, 'lps'),
	(362546, 124, '2015-01-15 00:51:44.000000', 'consum', 0.0212, 'lps'),
	(362547, 124, '2015-01-15 00:51:45.000000', 'consum', 0.0231, 'lps'),
	(362548, 124, '2015-01-15 00:51:46.000000', 'consum', 0.0221, 'lps'),
	(362549, 124, '2015-01-15 00:51:47.000000', 'consum', 0.0223, 'lps'),
	(362550, 124, '2015-01-15 00:51:48.000000', 'consum', 0.0222, 'lps'),
	(362551, 124, '2015-01-15 00:51:49.000000', 'consum', 0.0210, 'lps'),
	(362552, 124, '2015-01-15 00:51:50.000000', 'consum', 0.0219, 'lps'),
	(362553, 124, '2015-01-15 00:51:51.000000', 'consum', 0.0212, 'lps'),
	(362554, 124, '2015-01-15 00:51:52.000000', 'consum', 0.0214, 'lps'),
	(362555, 124, '2015-01-15 00:51:53.000000', 'consum', 0.0227, 'lps'),
	(362556, 124, '2015-01-15 00:51:54.000000', 'consum', 0.0214, 'lps'),
	(362557, 124, '2015-01-15 00:51:55.000000', 'consum', 0.0226, 'lps'),
	(362558, 124, '2015-01-15 00:51:56.000000', 'consum', 0.0213, 'lps'),
	(362559, 124, '2015-01-15 00:51:57.000000', 'consum', 0.0222, 'lps'),
	(362560, 124, '2015-01-15 00:51:58.000000', 'consum', 0.0215, 'lps'),
	(362561, 124, '2015-01-15 00:51:59.000000', 'consum', 0.0222, 'lps'),
	(362562, 124, '2015-01-15 00:52:00.000000', 'consum', 0.0214, 'lps'),
	(362563, 124, '2015-01-15 00:52:01.000000', 'consum', 0.0214, 'lps'),
	(362564, 124, '2015-01-15 00:52:02.000000', 'consum', 0.0219, 'lps'),
	(362565, 124, '2015-01-15 00:52:03.000000', 'consum', 0.0224, 'lps'),
	(362566, 124, '2015-01-15 00:52:04.000000', 'consum', 0.0228, 'lps'),
	(362567, 124, '2015-01-15 00:52:05.000000', 'consum', 0.0215, 'lps'),
	(362568, 124, '2015-01-15 00:52:06.000000', 'consum', 0.0225, 'lps'),
	(362569, 124, '2015-01-15 00:52:07.000000', 'consum', 0.0226, 'lps'),
	(362570, 124, '2015-01-15 00:52:08.000000', 'consum', 0.0225, 'lps'),
	(362571, 124, '2015-01-15 00:52:09.000000', 'consum', 0.0217, 'lps'),
	(362572, 124, '2015-01-15 00:52:10.000000', 'consum', 0.0221, 'lps'),
	(362573, 124, '2015-01-15 00:52:11.000000', 'consum', 0.0223, 'lps'),
	(362574, 124, '2015-01-15 00:52:12.000000', 'consum', 0.0221, 'lps'),
	(362575, 124, '2015-01-15 00:52:13.000000', 'consum', 0.0228, 'lps'),
	(362576, 124, '2015-01-15 00:52:14.000000', 'consum', 0.0221, 'lps'),
	(362577, 124, '2015-01-15 00:52:15.000000', 'consum', 0.0212, 'lps'),
	(362578, 124, '2015-01-15 00:52:16.000000', 'consum', 0.0230, 'lps'),
	(362579, 124, '2015-01-15 00:52:17.000000', 'consum', 0.0217, 'lps'),
	(362580, 124, '2015-01-15 00:52:18.000000', 'consum', 0.0229, 'lps'),
	(362581, 124, '2015-01-15 00:52:19.000000', 'consum', 0.0221, 'lps'),
	(362582, 124, '2015-01-15 00:52:20.000000', 'consum', 0.0229, 'lps'),
	(362583, 124, '2015-01-15 00:52:21.000000', 'consum', 0.0229, 'lps'),
	(362584, 124, '2015-01-15 00:52:22.000000', 'consum', 0.0227, 'lps'),
	(362585, 124, '2015-01-15 00:52:23.000000', 'consum', 0.0216, 'lps'),
	(362586, 124, '2015-01-15 00:52:24.000000', 'consum', 0.0212, 'lps'),
	(362587, 124, '2015-01-15 00:52:25.000000', 'consum', 0.0226, 'lps'),
	(362588, 124, '2015-01-15 00:52:26.000000', 'consum', 0.0218, 'lps'),
	(362589, 124, '2015-01-15 00:52:27.000000', 'consum', 0.0222, 'lps'),
	(362590, 124, '2015-01-15 00:52:28.000000', 'consum', 0.0227, 'lps'),
	(362591, 124, '2015-01-15 00:52:29.000000', 'consum', 0.0216, 'lps'),
	(362592, 124, '2015-01-15 00:52:30.000000', 'consum', 0.0231, 'lps'),
	(362593, 124, '2015-01-15 00:52:31.000000', 'consum', 0.0231, 'lps'),
	(362594, 124, '2015-01-15 00:52:32.000000', 'consum', 0.0231, 'lps'),
	(362595, 124, '2015-01-15 00:52:33.000000', 'consum', 0.0231, 'lps'),
	(362596, 124, '2015-01-15 00:52:34.000000', 'consum', 0.0231, 'lps'),
	(362597, 124, '2015-01-15 00:52:35.000000', 'consum', 0.0230, 'lps'),
	(362598, 124, '2015-01-15 00:52:36.000000', 'consum', 0.0224, 'lps'),
	(362599, 124, '2015-01-15 00:52:37.000000', 'consum', 0.0220, 'lps'),
	(362600, 124, '2015-01-15 00:52:38.000000', 'consum', 0.0221, 'lps'),
	(362601, 124, '2015-01-15 00:52:39.000000', 'consum', 0.0211, 'lps'),
	(362602, 124, '2015-01-15 00:52:40.000000', 'consum', 0.0226, 'lps'),
	(362603, 124, '2015-01-15 00:52:41.000000', 'consum', 0.0224, 'lps'),
	(362604, 124, '2015-01-15 00:52:42.000000', 'consum', 0.0231, 'lps'),
	(362605, 124, '2015-01-15 00:52:43.000000', 'consum', 0.0230, 'lps'),
	(362606, 124, '2015-01-15 00:52:44.000000', 'consum', 0.0225, 'lps'),
	(362607, 124, '2015-01-15 00:52:45.000000', 'consum', 0.0225, 'lps'),
	(362608, 124, '2015-01-15 00:52:46.000000', 'consum', 0.0219, 'lps'),
	(362609, 124, '2015-01-15 00:52:47.000000', 'consum', 0.0211, 'lps'),
	(362610, 124, '2015-01-15 00:52:48.000000', 'consum', 0.0210, 'lps'),
	(362611, 124, '2015-01-15 00:52:49.000000', 'consum', 0.0231, 'lps'),
	(362612, 124, '2015-01-15 00:52:50.000000', 'consum', 0.0226, 'lps'),
	(362613, 124, '2015-01-15 00:52:51.000000', 'consum', 0.0230, 'lps'),
	(362614, 124, '2015-01-15 00:52:52.000000', 'consum', 0.0217, 'lps'),
	(362615, 124, '2015-01-15 00:52:53.000000', 'consum', 0.0228, 'lps'),
	(362616, 124, '2015-01-15 00:52:54.000000', 'consum', 0.0213, 'lps'),
	(362617, 124, '2015-01-15 00:52:55.000000', 'consum', 0.0218, 'lps'),
	(362618, 124, '2015-01-15 00:52:56.000000', 'consum', 0.0218, 'lps'),
	(362619, 124, '2015-01-15 00:52:57.000000', 'consum', 0.0226, 'lps'),
	(362620, 124, '2015-01-15 00:52:58.000000', 'consum', 0.0223, 'lps'),
	(362621, 124, '2015-01-15 00:52:59.000000', 'consum', 0.0227, 'lps'),
	(362622, 124, '2015-01-15 00:53:00.000000', 'consum', 0.0215, 'lps'),
	(362623, 124, '2015-01-15 00:53:01.000000', 'consum', 0.0225, 'lps'),
	(362624, 124, '2015-01-15 00:53:02.000000', 'consum', 0.0228, 'lps'),
	(362625, 124, '2015-01-15 00:53:03.000000', 'consum', 0.0213, 'lps'),
	(362626, 124, '2015-01-15 00:53:04.000000', 'consum', 0.0213, 'lps'),
	(362627, 124, '2015-01-15 00:53:05.000000', 'consum', 0.0219, 'lps'),
	(362628, 124, '2015-01-15 00:53:06.000000', 'consum', 0.0223, 'lps'),
	(362629, 124, '2015-01-15 00:53:07.000000', 'consum', 0.0226, 'lps'),
	(362630, 124, '2015-01-15 00:53:08.000000', 'consum', 0.0230, 'lps'),
	(362631, 124, '2015-01-15 00:53:09.000000', 'consum', 0.0217, 'lps'),
	(362632, 124, '2015-01-15 00:53:10.000000', 'consum', 0.0210, 'lps'),
	(362633, 124, '2015-01-15 00:53:11.000000', 'consum', 0.0211, 'lps'),
	(362634, 124, '2015-01-15 00:53:12.000000', 'consum', 0.0215, 'lps'),
	(362635, 124, '2015-01-15 00:53:13.000000', 'consum', 0.0231, 'lps'),
	(362636, 124, '2015-01-15 00:53:14.000000', 'consum', 0.0215, 'lps'),
	(362637, 124, '2015-01-15 00:53:15.000000', 'consum', 0.0217, 'lps'),
	(362638, 124, '2015-01-15 00:53:16.000000', 'consum', 0.0229, 'lps'),
	(362639, 124, '2015-01-15 00:53:17.000000', 'consum', 0.0220, 'lps'),
	(362640, 124, '2015-01-15 00:53:18.000000', 'consum', 0.0223, 'lps'),
	(362641, 124, '2015-01-15 00:53:19.000000', 'consum', 0.0225, 'lps'),
	(362642, 124, '2015-01-15 00:53:20.000000', 'consum', 0.0224, 'lps'),
	(362643, 124, '2015-01-15 00:53:21.000000', 'consum', 0.0214, 'lps'),
	(362644, 124, '2015-01-15 00:53:22.000000', 'consum', 0.0211, 'lps'),
	(362645, 124, '2015-01-15 00:53:23.000000', 'consum', 0.0227, 'lps'),
	(362646, 124, '2015-01-15 00:53:24.000000', 'consum', 0.0225, 'lps'),
	(362647, 124, '2015-01-15 00:53:25.000000', 'consum', 0.0212, 'lps'),
	(362648, 124, '2015-01-15 00:53:26.000000', 'consum', 0.0218, 'lps'),
	(362649, 124, '2015-01-15 00:53:27.000000', 'consum', 0.0223, 'lps'),
	(362650, 124, '2015-01-15 00:53:28.000000', 'consum', 0.0231, 'lps'),
	(362651, 124, '2015-01-15 00:53:29.000000', 'consum', 0.0230, 'lps'),
	(362652, 124, '2015-01-15 00:53:30.000000', 'consum', 0.0226, 'lps'),
	(362653, 124, '2015-01-15 00:53:31.000000', 'consum', 0.0230, 'lps'),
	(362654, 124, '2015-01-15 00:53:32.000000', 'consum', 0.0218, 'lps'),
	(362655, 124, '2015-01-15 00:53:33.000000', 'consum', 0.0214, 'lps'),
	(362656, 124, '2015-01-15 00:53:34.000000', 'consum', 0.0226, 'lps'),
	(362657, 124, '2015-01-15 00:53:35.000000', 'consum', 0.0216, 'lps'),
	(362658, 124, '2015-01-15 00:53:36.000000', 'consum', 0.0213, 'lps'),
	(362659, 124, '2015-01-15 00:53:37.000000', 'consum', 0.0228, 'lps'),
	(362660, 124, '2015-01-15 00:53:38.000000', 'consum', 0.0228, 'lps'),
	(362661, 124, '2015-01-15 00:53:39.000000', 'consum', 0.0222, 'lps'),
	(362662, 124, '2015-01-15 00:53:40.000000', 'consum', 0.0218, 'lps'),
	(362663, 124, '2015-01-15 00:53:41.000000', 'consum', 0.0213, 'lps'),
	(362664, 124, '2015-01-15 00:53:42.000000', 'consum', 0.0224, 'lps'),
	(362665, 124, '2015-01-15 00:53:43.000000', 'consum', 0.0227, 'lps'),
	(362666, 124, '2015-01-15 00:53:44.000000', 'consum', 0.0211, 'lps'),
	(362667, 124, '2015-01-15 00:53:45.000000', 'consum', 0.0231, 'lps'),
	(362668, 124, '2015-01-15 00:53:46.000000', 'consum', 0.0222, 'lps'),
	(362669, 124, '2015-01-15 00:53:47.000000', 'consum', 0.0231, 'lps'),
	(362670, 124, '2015-01-15 00:53:48.000000', 'consum', 0.0215, 'lps'),
	(362671, 124, '2015-01-15 00:53:49.000000', 'consum', 0.0214, 'lps'),
	(362672, 124, '2015-01-15 00:53:50.000000', 'consum', 0.0217, 'lps'),
	(362673, 124, '2015-01-15 00:53:51.000000', 'consum', 0.0213, 'lps'),
	(362674, 124, '2015-01-15 00:53:52.000000', 'consum', 0.0226, 'lps'),
	(362675, 124, '2015-01-15 00:53:53.000000', 'consum', 0.0215, 'lps'),
	(362676, 124, '2015-01-15 00:53:54.000000', 'consum', 0.0210, 'lps'),
	(362677, 124, '2015-01-15 00:53:55.000000', 'consum', 0.0218, 'lps'),
	(362678, 124, '2015-01-15 00:53:56.000000', 'consum', 0.0230, 'lps'),
	(362679, 124, '2015-01-15 00:53:57.000000', 'consum', 0.0219, 'lps'),
	(362680, 124, '2015-01-15 00:53:58.000000', 'consum', 0.0218, 'lps'),
	(362681, 124, '2015-01-15 00:53:59.000000', 'consum', 0.0221, 'lps'),
	(362682, 124, '2015-01-15 00:54:00.000000', 'consum', 0.0222, 'lps'),
	(362683, 124, '2015-01-15 00:54:01.000000', 'consum', 0.0215, 'lps'),
	(362684, 124, '2015-01-15 00:54:02.000000', 'consum', 0.0220, 'lps'),
	(362685, 124, '2015-01-15 00:54:03.000000', 'consum', 0.0225, 'lps'),
	(362686, 124, '2015-01-15 00:54:04.000000', 'consum', 0.0211, 'lps'),
	(362687, 124, '2015-01-15 00:54:05.000000', 'consum', 0.0213, 'lps'),
	(362688, 124, '2015-01-15 00:54:06.000000', 'consum', 0.0222, 'lps'),
	(362689, 124, '2015-01-15 00:54:07.000000', 'consum', 0.0220, 'lps'),
	(362690, 124, '2015-01-15 00:54:08.000000', 'consum', 0.0224, 'lps'),
	(362691, 124, '2015-01-15 00:54:09.000000', 'consum', 0.0228, 'lps'),
	(362692, 124, '2015-01-15 00:54:10.000000', 'consum', 0.0213, 'lps'),
	(362693, 124, '2015-01-15 00:54:11.000000', 'consum', 0.0218, 'lps'),
	(362694, 124, '2015-01-15 00:54:12.000000', 'consum', 0.0220, 'lps'),
	(362695, 124, '2015-01-15 00:54:13.000000', 'consum', 0.0215, 'lps'),
	(362696, 124, '2015-01-15 00:54:14.000000', 'consum', 0.0226, 'lps'),
	(362697, 124, '2015-01-15 00:54:15.000000', 'consum', 0.0211, 'lps'),
	(362698, 124, '2015-01-15 00:54:16.000000', 'consum', 0.0210, 'lps'),
	(362699, 124, '2015-01-15 00:54:17.000000', 'consum', 0.0231, 'lps'),
	(362700, 124, '2015-01-15 00:54:18.000000', 'consum', 0.0227, 'lps'),
	(362701, 124, '2015-01-15 00:54:19.000000', 'consum', 0.0231, 'lps'),
	(362702, 124, '2015-01-15 00:54:20.000000', 'consum', 0.0222, 'lps'),
	(362703, 124, '2015-01-15 00:54:21.000000', 'consum', 0.0228, 'lps'),
	(362704, 124, '2015-01-15 00:54:22.000000', 'consum', 0.0221, 'lps'),
	(362705, 124, '2015-01-15 00:54:23.000000', 'consum', 0.0210, 'lps'),
	(362706, 124, '2015-01-15 00:54:24.000000', 'consum', 0.0223, 'lps'),
	(362707, 124, '2015-01-15 00:54:25.000000', 'consum', 0.0231, 'lps'),
	(362708, 124, '2015-01-15 00:54:26.000000', 'consum', 0.0210, 'lps'),
	(362709, 124, '2015-01-15 00:54:27.000000', 'consum', 0.0215, 'lps'),
	(362710, 124, '2015-01-15 00:54:28.000000', 'consum', 0.0212, 'lps'),
	(362711, 124, '2015-01-15 00:54:29.000000', 'consum', 0.0230, 'lps'),
	(362712, 124, '2015-01-15 00:54:30.000000', 'consum', 0.0215, 'lps'),
	(362713, 124, '2015-01-15 00:54:31.000000', 'consum', 0.0219, 'lps'),
	(362714, 124, '2015-01-15 00:54:32.000000', 'consum', 0.0218, 'lps'),
	(362715, 124, '2015-01-15 00:54:33.000000', 'consum', 0.0224, 'lps'),
	(362716, 124, '2015-01-15 00:54:34.000000', 'consum', 0.0214, 'lps'),
	(362717, 124, '2015-01-15 00:54:35.000000', 'consum', 0.0231, 'lps'),
	(362718, 124, '2015-01-15 00:54:36.000000', 'consum', 0.0214, 'lps'),
	(362719, 124, '2015-01-15 00:54:37.000000', 'consum', 0.0212, 'lps'),
	(362720, 124, '2015-01-15 00:54:38.000000', 'consum', 0.0210, 'lps'),
	(362721, 124, '2015-01-15 00:54:39.000000', 'consum', 0.0225, 'lps'),
	(362722, 124, '2015-01-15 00:54:40.000000', 'consum', 0.0220, 'lps'),
	(362723, 124, '2015-01-15 00:54:41.000000', 'consum', 0.0214, 'lps'),
	(362724, 124, '2015-01-15 00:54:42.000000', 'consum', 0.0222, 'lps'),
	(362725, 124, '2015-01-15 00:54:43.000000', 'consum', 0.0214, 'lps'),
	(362726, 124, '2015-01-15 00:54:44.000000', 'consum', 0.0217, 'lps'),
	(362727, 124, '2015-01-15 00:54:45.000000', 'consum', 0.0213, 'lps'),
	(362728, 124, '2015-01-15 00:54:46.000000', 'consum', 0.0227, 'lps'),
	(362729, 124, '2015-01-15 00:54:47.000000', 'consum', 0.0219, 'lps'),
	(362730, 124, '2015-01-15 00:54:48.000000', 'consum', 0.0228, 'lps'),
	(362731, 124, '2015-01-15 00:54:49.000000', 'consum', 0.0228, 'lps'),
	(362732, 124, '2015-01-15 00:54:50.000000', 'consum', 0.0225, 'lps'),
	(362733, 124, '2015-01-15 00:54:51.000000', 'consum', 0.0211, 'lps'),
	(362734, 124, '2015-01-15 00:54:52.000000', 'consum', 0.0214, 'lps'),
	(362735, 124, '2015-01-15 00:54:53.000000', 'consum', 0.0227, 'lps'),
	(362736, 124, '2015-01-15 00:54:54.000000', 'consum', 0.0219, 'lps'),
	(362737, 124, '2015-01-15 00:54:55.000000', 'consum', 0.0223, 'lps'),
	(362738, 124, '2015-01-15 00:54:56.000000', 'consum', 0.0230, 'lps'),
	(362739, 124, '2015-01-15 00:54:57.000000', 'consum', 0.0226, 'lps'),
	(362740, 124, '2015-01-15 00:54:58.000000', 'consum', 0.0230, 'lps'),
	(362741, 124, '2015-01-15 00:54:59.000000', 'consum', 0.0220, 'lps'),
	(362742, 124, '2015-01-15 00:55:00.000000', 'consum', 0.0224, 'lps'),
	(362743, 124, '2015-01-15 00:55:01.000000', 'consum', 0.0226, 'lps'),
	(362744, 124, '2015-01-15 00:55:02.000000', 'consum', 0.0228, 'lps'),
	(362745, 124, '2015-01-15 00:55:03.000000', 'consum', 0.0228, 'lps'),
	(362746, 124, '2015-01-15 00:55:04.000000', 'consum', 0.0225, 'lps'),
	(362747, 124, '2015-01-15 00:55:05.000000', 'consum', 0.0211, 'lps'),
	(362748, 124, '2015-01-15 00:55:06.000000', 'consum', 0.0215, 'lps'),
	(362749, 124, '2015-01-15 00:55:07.000000', 'consum', 0.0231, 'lps'),
	(362750, 124, '2015-01-15 00:55:08.000000', 'consum', 0.0211, 'lps'),
	(362751, 124, '2015-01-15 00:55:09.000000', 'consum', 0.0221, 'lps'),
	(362752, 124, '2015-01-15 00:55:10.000000', 'consum', 0.0217, 'lps'),
	(362753, 124, '2015-01-15 00:55:11.000000', 'consum', 0.0215, 'lps'),
	(362754, 124, '2015-01-15 00:55:12.000000', 'consum', 0.0213, 'lps'),
	(362755, 124, '2015-01-15 00:55:13.000000', 'consum', 0.0211, 'lps'),
	(362756, 124, '2015-01-15 00:55:14.000000', 'consum', 0.0228, 'lps'),
	(362757, 124, '2015-01-15 00:55:15.000000', 'consum', 0.0230, 'lps'),
	(362758, 124, '2015-01-15 00:55:16.000000', 'consum', 0.0215, 'lps'),
	(362759, 124, '2015-01-15 00:55:17.000000', 'consum', 0.0217, 'lps'),
	(362760, 124, '2015-01-15 00:55:18.000000', 'consum', 0.0211, 'lps'),
	(362761, 124, '2015-01-15 00:55:19.000000', 'consum', 0.0215, 'lps'),
	(362762, 124, '2015-01-15 00:55:20.000000', 'consum', 0.0212, 'lps'),
	(362763, 124, '2015-01-15 00:55:21.000000', 'consum', 0.0227, 'lps'),
	(362764, 124, '2015-01-15 00:55:22.000000', 'consum', 0.0225, 'lps'),
	(362765, 124, '2015-01-15 00:55:23.000000', 'consum', 0.0211, 'lps'),
	(362766, 124, '2015-01-15 00:55:24.000000', 'consum', 0.0213, 'lps'),
	(362767, 124, '2015-01-15 00:55:25.000000', 'consum', 0.0224, 'lps'),
	(362768, 124, '2015-01-15 00:55:26.000000', 'consum', 0.0228, 'lps'),
	(362769, 124, '2015-01-15 00:55:27.000000', 'consum', 0.0215, 'lps'),
	(362770, 124, '2015-01-15 00:55:28.000000', 'consum', 0.0224, 'lps'),
	(362771, 124, '2015-01-15 00:55:29.000000', 'consum', 0.0223, 'lps'),
	(362772, 124, '2015-01-15 00:55:30.000000', 'consum', 0.0210, 'lps'),
	(362773, 124, '2015-01-15 00:55:31.000000', 'consum', 0.0215, 'lps'),
	(362774, 124, '2015-01-15 00:55:32.000000', 'consum', 0.0214, 'lps'),
	(362775, 124, '2015-01-15 00:55:33.000000', 'consum', 0.0214, 'lps'),
	(362776, 124, '2015-01-15 00:55:34.000000', 'consum', 0.0221, 'lps'),
	(362777, 124, '2015-01-15 00:55:35.000000', 'consum', 0.0230, 'lps'),
	(362778, 124, '2015-01-15 00:55:36.000000', 'consum', 0.0212, 'lps'),
	(362779, 124, '2015-01-15 00:55:37.000000', 'consum', 0.0226, 'lps'),
	(362780, 124, '2015-01-15 00:55:38.000000', 'consum', 0.0219, 'lps'),
	(362781, 124, '2015-01-15 00:55:39.000000', 'consum', 0.0231, 'lps'),
	(362782, 124, '2015-01-15 00:55:40.000000', 'consum', 0.0220, 'lps'),
	(362783, 124, '2015-01-15 00:55:41.000000', 'consum', 0.0219, 'lps'),
	(362784, 124, '2015-01-15 00:55:42.000000', 'consum', 0.0225, 'lps'),
	(362785, 124, '2015-01-15 00:55:43.000000', 'consum', 0.0217, 'lps'),
	(362786, 124, '2015-01-15 00:55:44.000000', 'consum', 0.0222, 'lps'),
	(362787, 124, '2015-01-15 00:55:45.000000', 'consum', 0.0225, 'lps'),
	(362788, 124, '2015-01-15 00:55:46.000000', 'consum', 0.0231, 'lps'),
	(362789, 124, '2015-01-15 00:55:47.000000', 'consum', 0.0223, 'lps'),
	(362790, 124, '2015-01-15 00:55:48.000000', 'consum', 0.0216, 'lps'),
	(362791, 124, '2015-01-15 00:55:49.000000', 'consum', 0.0222, 'lps'),
	(362792, 124, '2015-01-15 00:55:50.000000', 'consum', 0.0229, 'lps'),
	(362793, 124, '2015-01-15 00:55:51.000000', 'consum', 0.0225, 'lps'),
	(362794, 124, '2015-01-15 00:55:52.000000', 'consum', 0.0231, 'lps'),
	(362795, 124, '2015-01-15 00:55:53.000000', 'consum', 0.0224, 'lps'),
	(362796, 124, '2015-01-15 00:55:54.000000', 'consum', 0.0220, 'lps'),
	(362797, 124, '2015-01-15 00:55:55.000000', 'consum', 0.0217, 'lps'),
	(362798, 124, '2015-01-15 00:55:56.000000', 'consum', 0.0217, 'lps'),
	(362799, 124, '2015-01-15 00:55:57.000000', 'consum', 0.0225, 'lps'),
	(362800, 124, '2015-01-15 00:55:58.000000', 'consum', 0.0218, 'lps'),
	(362801, 124, '2015-01-15 00:55:59.000000', 'consum', 0.0229, 'lps'),
	(362802, 124, '2015-01-15 00:56:00.000000', 'consum', 0.0215, 'lps'),
	(362803, 124, '2015-01-15 00:56:01.000000', 'consum', 0.0225, 'lps'),
	(362804, 124, '2015-01-15 00:56:02.000000', 'consum', 0.0223, 'lps'),
	(362805, 124, '2015-01-15 00:56:03.000000', 'consum', 0.0210, 'lps'),
	(362806, 124, '2015-01-15 00:56:04.000000', 'consum', 0.0214, 'lps'),
	(362807, 124, '2015-01-15 00:56:05.000000', 'consum', 0.0210, 'lps'),
	(362808, 124, '2015-01-15 00:56:06.000000', 'consum', 0.0221, 'lps'),
	(362809, 124, '2015-01-15 00:56:07.000000', 'consum', 0.0221, 'lps'),
	(362810, 124, '2015-01-15 00:56:08.000000', 'consum', 0.0212, 'lps'),
	(362811, 124, '2015-01-15 00:56:09.000000', 'consum', 0.0231, 'lps'),
	(362812, 124, '2015-01-15 00:56:10.000000', 'consum', 0.0222, 'lps'),
	(362813, 124, '2015-01-15 00:56:11.000000', 'consum', 0.0228, 'lps'),
	(362814, 124, '2015-01-15 00:56:12.000000', 'consum', 0.0223, 'lps'),
	(362815, 124, '2015-01-15 00:56:13.000000', 'consum', 0.0221, 'lps'),
	(362816, 124, '2015-01-15 00:56:14.000000', 'consum', 0.0224, 'lps'),
	(362817, 124, '2015-01-15 00:56:15.000000', 'consum', 0.0228, 'lps'),
	(362818, 124, '2015-01-15 00:56:16.000000', 'consum', 0.0213, 'lps'),
	(362819, 124, '2015-01-15 00:56:17.000000', 'consum', 0.0216, 'lps'),
	(362820, 124, '2015-01-15 00:56:18.000000', 'consum', 0.0210, 'lps'),
	(362821, 124, '2015-01-15 00:56:19.000000', 'consum', 0.0216, 'lps'),
	(362822, 124, '2015-01-15 00:56:20.000000', 'consum', 0.0216, 'lps'),
	(362823, 124, '2015-01-15 00:56:21.000000', 'consum', 0.0223, 'lps'),
	(362824, 124, '2015-01-15 00:56:22.000000', 'consum', 0.0213, 'lps'),
	(362825, 124, '2015-01-15 00:56:23.000000', 'consum', 0.0210, 'lps'),
	(362826, 124, '2015-01-15 00:56:24.000000', 'consum', 0.0222, 'lps'),
	(362827, 124, '2015-01-15 00:56:25.000000', 'consum', 0.0228, 'lps'),
	(362828, 124, '2015-01-15 00:56:26.000000', 'consum', 0.0218, 'lps'),
	(362829, 124, '2015-01-15 00:56:27.000000', 'consum', 0.0220, 'lps'),
	(362830, 124, '2015-01-15 00:56:28.000000', 'consum', 0.0216, 'lps'),
	(362831, 124, '2015-01-15 00:56:29.000000', 'consum', 0.0230, 'lps'),
	(362832, 124, '2015-01-15 00:56:30.000000', 'consum', 0.0226, 'lps'),
	(362833, 124, '2015-01-15 00:56:31.000000', 'consum', 0.0231, 'lps'),
	(362834, 124, '2015-01-15 00:56:32.000000', 'consum', 0.0223, 'lps'),
	(362835, 124, '2015-01-15 00:56:33.000000', 'consum', 0.0214, 'lps'),
	(362836, 124, '2015-01-15 00:56:34.000000', 'consum', 0.0213, 'lps'),
	(362837, 124, '2015-01-15 00:56:35.000000', 'consum', 0.0211, 'lps'),
	(362838, 124, '2015-01-15 00:56:36.000000', 'consum', 0.0210, 'lps'),
	(362839, 124, '2015-01-15 00:56:37.000000', 'consum', 0.0227, 'lps'),
	(362840, 124, '2015-01-15 00:56:38.000000', 'consum', 0.0230, 'lps'),
	(362841, 124, '2015-01-15 00:56:39.000000', 'consum', 0.0217, 'lps'),
	(362842, 124, '2015-01-15 00:56:40.000000', 'consum', 0.0229, 'lps'),
	(362843, 124, '2015-01-15 00:56:41.000000', 'consum', 0.0216, 'lps'),
	(362844, 124, '2015-01-15 00:56:42.000000', 'consum', 0.0229, 'lps'),
	(362845, 124, '2015-01-15 00:56:43.000000', 'consum', 0.0224, 'lps'),
	(362846, 124, '2015-01-15 00:56:44.000000', 'consum', 0.0220, 'lps'),
	(362847, 124, '2015-01-15 00:56:45.000000', 'consum', 0.0222, 'lps'),
	(362848, 124, '2015-01-15 00:56:46.000000', 'consum', 0.0215, 'lps'),
	(362849, 124, '2015-01-15 00:56:47.000000', 'consum', 0.0225, 'lps'),
	(362850, 124, '2015-01-15 00:56:48.000000', 'consum', 0.0223, 'lps'),
	(362851, 124, '2015-01-15 00:56:49.000000', 'consum', 0.0211, 'lps'),
	(362852, 124, '2015-01-15 00:56:50.000000', 'consum', 0.0218, 'lps'),
	(362853, 124, '2015-01-15 00:56:51.000000', 'consum', 0.0229, 'lps'),
	(362854, 124, '2015-01-15 00:56:52.000000', 'consum', 0.0213, 'lps'),
	(362855, 124, '2015-01-15 00:56:53.000000', 'consum', 0.0213, 'lps'),
	(362856, 124, '2015-01-15 00:56:54.000000', 'consum', 0.0217, 'lps'),
	(362857, 124, '2015-01-15 00:56:55.000000', 'consum', 0.0216, 'lps'),
	(362858, 124, '2015-01-15 00:56:56.000000', 'consum', 0.0219, 'lps'),
	(362859, 124, '2015-01-15 00:56:57.000000', 'consum', 0.0216, 'lps'),
	(362860, 124, '2015-01-15 00:56:58.000000', 'consum', 0.0214, 'lps'),
	(362861, 124, '2015-01-15 00:56:59.000000', 'consum', 0.0213, 'lps'),
	(362862, 124, '2015-01-15 00:57:00.000000', 'consum', 0.0212, 'lps'),
	(362863, 124, '2015-01-15 00:57:01.000000', 'consum', 0.0211, 'lps'),
	(362864, 124, '2015-01-15 00:57:02.000000', 'consum', 0.0211, 'lps'),
	(362865, 124, '2015-01-15 00:57:03.000000', 'consum', 0.0210, 'lps'),
	(362866, 124, '2015-01-15 00:57:04.000000', 'consum', 0.0231, 'lps'),
	(362867, 124, '2015-01-15 00:57:05.000000', 'consum', 0.0227, 'lps'),
	(362868, 124, '2015-01-15 00:57:06.000000', 'consum', 0.0213, 'lps'),
	(362869, 124, '2015-01-15 00:57:07.000000', 'consum', 0.0216, 'lps'),
	(362870, 124, '2015-01-15 00:57:08.000000', 'consum', 0.0210, 'lps'),
	(362871, 124, '2015-01-15 00:57:09.000000', 'consum', 0.0216, 'lps'),
	(362872, 124, '2015-01-15 00:57:10.000000', 'consum', 0.0216, 'lps'),
	(362873, 124, '2015-01-15 00:57:11.000000', 'consum', 0.0223, 'lps'),
	(362874, 124, '2015-01-15 00:57:12.000000', 'consum', 0.0216, 'lps'),
	(362875, 124, '2015-01-15 00:57:13.000000', 'consum', 0.0220, 'lps'),
	(362876, 124, '2015-01-15 00:57:14.000000', 'consum', 0.0223, 'lps'),
	(362877, 124, '2015-01-15 00:57:15.000000', 'consum', 0.0221, 'lps'),
	(362878, 124, '2015-01-15 00:57:16.000000', 'consum', 0.0229, 'lps'),
	(362879, 124, '2015-01-15 00:57:17.000000', 'consum', 0.0227, 'lps'),
	(362880, 124, '2015-01-15 00:57:18.000000', 'consum', 0.0218, 'lps'),
	(362881, 124, '2015-01-15 00:57:19.000000', 'consum', 0.0221, 'lps'),
	(362882, 124, '2015-01-15 00:57:20.000000', 'consum', 0.0218, 'lps'),
	(362883, 124, '2015-01-15 00:57:21.000000', 'consum', 0.0217, 'lps'),
	(362884, 124, '2015-01-15 00:57:22.000000', 'consum', 0.0223, 'lps'),
	(362885, 124, '2015-01-15 00:57:23.000000', 'consum', 0.0210, 'lps'),
	(362886, 124, '2015-01-15 00:57:24.000000', 'consum', 0.0214, 'lps'),
	(362887, 124, '2015-01-15 00:57:25.000000', 'consum', 0.0210, 'lps'),
	(362888, 124, '2015-01-15 00:57:26.000000', 'consum', 0.0221, 'lps'),
	(362889, 124, '2015-01-15 00:57:27.000000', 'consum', 0.0222, 'lps'),
	(362890, 124, '2015-01-15 00:57:28.000000', 'consum', 0.0213, 'lps'),
	(362891, 124, '2015-01-15 00:57:29.000000', 'consum', 0.0215, 'lps'),
	(362892, 124, '2015-01-15 00:57:30.000000', 'consum', 0.0223, 'lps'),
	(362893, 124, '2015-01-15 00:57:31.000000', 'consum', 0.0220, 'lps'),
	(362894, 124, '2015-01-15 00:57:32.000000', 'consum', 0.0220, 'lps'),
	(362895, 124, '2015-01-15 00:57:33.000000', 'consum', 0.0230, 'lps'),
	(362896, 124, '2015-01-15 00:57:34.000000', 'consum', 0.0216, 'lps'),
	(362897, 124, '2015-01-15 00:57:35.000000', 'consum', 0.0222, 'lps'),
	(362898, 124, '2015-01-15 00:57:36.000000', 'consum', 0.0211, 'lps'),
	(362899, 124, '2015-01-15 00:57:37.000000', 'consum', 0.0221, 'lps'),
	(362900, 124, '2015-01-15 00:57:38.000000', 'consum', 0.0218, 'lps'),
	(362901, 124, '2015-01-15 00:57:39.000000', 'consum', 0.0219, 'lps'),
	(362902, 124, '2015-01-15 00:57:40.000000', 'consum', 0.0211, 'lps'),
	(362903, 124, '2015-01-15 00:57:41.000000', 'consum', 0.0211, 'lps'),
	(362904, 124, '2015-01-15 00:57:42.000000', 'consum', 0.0211, 'lps'),
	(362905, 124, '2015-01-15 00:57:43.000000', 'consum', 0.0211, 'lps'),
	(362906, 124, '2015-01-15 00:57:44.000000', 'consum', 0.0214, 'lps'),
	(362907, 124, '2015-01-15 00:57:45.000000', 'consum', 0.0226, 'lps'),
	(362908, 124, '2015-01-15 00:57:46.000000', 'consum', 0.0214, 'lps'),
	(362909, 124, '2015-01-15 00:57:47.000000', 'consum', 0.0226, 'lps'),
	(362910, 124, '2015-01-15 00:57:48.000000', 'consum', 0.0213, 'lps'),
	(362911, 124, '2015-01-15 00:57:49.000000', 'consum', 0.0219, 'lps'),
	(362912, 124, '2015-01-15 00:57:50.000000', 'consum', 0.0226, 'lps'),
	(362913, 124, '2015-01-15 00:57:51.000000', 'consum', 0.0220, 'lps'),
	(362914, 124, '2015-01-15 00:57:52.000000', 'consum', 0.0214, 'lps'),
	(362915, 124, '2015-01-15 00:57:53.000000', 'consum', 0.0222, 'lps'),
	(362916, 124, '2015-01-15 00:57:54.000000', 'consum', 0.0213, 'lps'),
	(362917, 124, '2015-01-15 00:57:55.000000', 'consum', 0.0211, 'lps'),
	(362918, 124, '2015-01-15 00:57:56.000000', 'consum', 0.0229, 'lps'),
	(362919, 124, '2015-01-15 00:57:57.000000', 'consum', 0.0215, 'lps'),
	(362920, 124, '2015-01-15 00:57:58.000000', 'consum', 0.0220, 'lps'),
	(362921, 124, '2015-01-15 00:57:59.000000', 'consum', 0.0227, 'lps'),
	(362922, 124, '2015-01-15 00:58:00.000000', 'consum', 0.0219, 'lps'),
	(362923, 124, '2015-01-15 00:58:01.000000', 'consum', 0.0229, 'lps'),
	(362924, 124, '2015-01-15 00:58:02.000000', 'consum', 0.0211, 'lps'),
	(362925, 124, '2015-01-15 00:58:03.000000', 'consum', 0.0227, 'lps'),
	(362926, 124, '2015-01-15 00:58:04.000000', 'consum', 0.0224, 'lps'),
	(362927, 124, '2015-01-15 00:58:05.000000', 'consum', 0.0229, 'lps'),
	(362928, 124, '2015-01-15 00:58:06.000000', 'consum', 0.0222, 'lps'),
	(362929, 124, '2015-01-15 00:58:07.000000', 'consum', 0.0212, 'lps'),
	(362930, 124, '2015-01-15 00:58:08.000000', 'consum', 0.0228, 'lps'),
	(362931, 124, '2015-01-15 00:58:09.000000', 'consum', 0.0231, 'lps'),
	(362932, 124, '2015-01-15 00:58:10.000000', 'consum', 0.0215, 'lps'),
	(362933, 124, '2015-01-15 00:58:11.000000', 'consum', 0.0217, 'lps'),
	(362934, 124, '2015-01-15 00:58:12.000000', 'consum', 0.0231, 'lps'),
	(362935, 124, '2015-01-15 00:58:13.000000', 'consum', 0.0230, 'lps'),
	(362936, 124, '2015-01-15 00:58:14.000000', 'consum', 0.0222, 'lps'),
	(362937, 124, '2015-01-15 00:58:15.000000', 'consum', 0.0213, 'lps'),
	(362938, 124, '2015-01-15 00:58:16.000000', 'consum', 0.0213, 'lps'),
	(362939, 124, '2015-01-15 00:58:17.000000', 'consum', 0.0215, 'lps'),
	(362940, 124, '2015-01-15 00:58:18.000000', 'consum', 0.0225, 'lps'),
	(362941, 124, '2015-01-15 00:58:19.000000', 'consum', 0.0226, 'lps'),
	(362942, 124, '2015-01-15 00:58:20.000000', 'consum', 0.0226, 'lps'),
	(362943, 124, '2015-01-15 00:58:21.000000', 'consum', 0.0221, 'lps'),
	(362944, 124, '2015-01-15 00:58:22.000000', 'consum', 0.0214, 'lps'),
	(362945, 124, '2015-01-15 00:58:23.000000', 'consum', 0.0223, 'lps'),
	(362946, 124, '2015-01-15 00:58:24.000000', 'consum', 0.0217, 'lps'),
	(362947, 124, '2015-01-15 00:58:25.000000', 'consum', 0.0230, 'lps'),
	(362948, 124, '2015-01-15 00:58:26.000000', 'consum', 0.0222, 'lps'),
	(362949, 124, '2015-01-15 00:58:27.000000', 'consum', 0.0210, 'lps'),
	(362950, 124, '2015-01-15 00:58:28.000000', 'consum', 0.0218, 'lps'),
	(362951, 124, '2015-01-15 00:58:29.000000', 'consum', 0.0229, 'lps'),
	(362952, 124, '2015-01-15 00:58:30.000000', 'consum', 0.0215, 'lps'),
	(362953, 124, '2015-01-15 00:58:31.000000', 'consum', 0.0223, 'lps'),
	(362954, 124, '2015-01-15 00:58:32.000000', 'consum', 0.0216, 'lps'),
	(362955, 124, '2015-01-15 00:58:33.000000', 'consum', 0.0224, 'lps'),
	(362956, 124, '2015-01-15 00:58:34.000000', 'consum', 0.0217, 'lps'),
	(362957, 124, '2015-01-15 00:58:35.000000', 'consum', 0.0225, 'lps'),
	(362958, 124, '2015-01-15 00:58:36.000000', 'consum', 0.0221, 'lps'),
	(362959, 124, '2015-01-15 00:58:37.000000', 'consum', 0.0222, 'lps'),
	(362960, 124, '2015-01-15 00:58:38.000000', 'consum', 0.0215, 'lps'),
	(362961, 124, '2015-01-15 00:58:39.000000', 'consum', 0.0220, 'lps'),
	(362962, 124, '2015-01-15 00:58:40.000000', 'consum', 0.0223, 'lps'),
	(362963, 124, '2015-01-15 00:58:41.000000', 'consum', 0.0223, 'lps'),
	(362964, 124, '2015-01-15 00:58:42.000000', 'consum', 0.0214, 'lps'),
	(362965, 124, '2015-01-15 00:58:43.000000', 'consum', 0.0213, 'lps'),
	(362966, 124, '2015-01-15 00:58:44.000000', 'consum', 0.0213, 'lps'),
	(362967, 124, '2015-01-15 00:58:45.000000', 'consum', 0.0216, 'lps'),
	(362968, 124, '2015-01-15 00:58:46.000000', 'consum', 0.0213, 'lps'),
	(362969, 124, '2015-01-15 00:58:47.000000', 'consum', 0.0226, 'lps'),
	(362970, 124, '2015-01-15 00:58:48.000000', 'consum', 0.0217, 'lps'),
	(362971, 124, '2015-01-15 00:58:49.000000', 'consum', 0.0218, 'lps'),
	(362972, 124, '2015-01-15 00:58:50.000000', 'consum', 0.0211, 'lps'),
	(362973, 124, '2015-01-15 00:58:51.000000', 'consum', 0.0210, 'lps'),
	(362974, 124, '2015-01-15 00:58:52.000000', 'consum', 0.0229, 'lps'),
	(362975, 124, '2015-01-15 00:58:53.000000', 'consum', 0.0218, 'lps'),
	(362976, 124, '2015-01-15 00:58:54.000000', 'consum', 0.0216, 'lps'),
	(362977, 124, '2015-01-15 00:58:55.000000', 'consum', 0.0218, 'lps'),
	(362978, 124, '2015-01-15 00:58:56.000000', 'consum', 0.0210, 'lps'),
	(362979, 124, '2015-01-15 00:58:57.000000', 'consum', 0.0231, 'lps'),
	(362980, 124, '2015-01-15 00:58:58.000000', 'consum', 0.0228, 'lps'),
	(362981, 124, '2015-01-15 00:58:59.000000', 'consum', 0.0217, 'lps'),
	(362982, 124, '2015-01-15 00:59:00.000000', 'consum', 0.0210, 'lps'),
	(362983, 124, '2015-01-15 00:59:01.000000', 'consum', 0.0214, 'lps'),
	(362984, 124, '2015-01-15 00:59:02.000000', 'consum', 0.0229, 'lps'),
	(362985, 124, '2015-01-15 00:59:03.000000', 'consum', 0.0227, 'lps'),
	(362986, 124, '2015-01-15 00:59:04.000000', 'consum', 0.0219, 'lps'),
	(362987, 124, '2015-01-15 00:59:05.000000', 'consum', 0.0226, 'lps'),
	(362988, 124, '2015-01-15 00:59:06.000000', 'consum', 0.0218, 'lps'),
	(362989, 124, '2015-01-15 00:59:07.000000', 'consum', 0.0225, 'lps'),
	(362990, 124, '2015-01-15 00:59:08.000000', 'consum', 0.0218, 'lps'),
	(362991, 124, '2015-01-15 00:59:09.000000', 'consum', 0.0226, 'lps'),
	(362992, 124, '2015-01-15 00:59:10.000000', 'consum', 0.0222, 'lps'),
	(362993, 124, '2015-01-15 00:59:11.000000', 'consum', 0.0223, 'lps'),
	(362994, 124, '2015-01-15 00:59:12.000000', 'consum', 0.0216, 'lps'),
	(362995, 124, '2015-01-15 00:59:13.000000', 'consum', 0.0224, 'lps'),
	(362996, 124, '2015-01-15 00:59:14.000000', 'consum', 0.0218, 'lps'),
	(362997, 124, '2015-01-15 00:59:15.000000', 'consum', 0.0230, 'lps'),
	(362998, 124, '2015-01-15 00:59:16.000000', 'consum', 0.0220, 'lps'),
	(362999, 124, '2015-01-15 00:59:17.000000', 'consum', 0.0223, 'lps'),
	(363000, 124, '2015-01-15 00:59:18.000000', 'consum', 0.0223, 'lps'),
	(363001, 124, '2015-01-15 00:59:19.000000', 'consum', 0.0215, 'lps'),
	(363002, 124, '2015-01-15 00:59:20.000000', 'consum', 0.0220, 'lps'),
	(363003, 124, '2015-01-15 00:59:21.000000', 'consum', 0.0222, 'lps'),
	(363004, 124, '2015-01-15 00:59:22.000000', 'consum', 0.0219, 'lps'),
	(363005, 124, '2015-01-15 00:59:23.000000', 'consum', 0.0220, 'lps'),
	(363006, 124, '2015-01-15 00:59:24.000000', 'consum', 0.0211, 'lps'),
	(363007, 124, '2015-01-15 00:59:25.000000', 'consum', 0.0229, 'lps'),
	(363008, 124, '2015-01-15 00:59:26.000000', 'consum', 0.0215, 'lps'),
	(363009, 124, '2015-01-15 00:59:27.000000', 'consum', 0.0220, 'lps'),
	(363010, 124, '2015-01-15 00:59:28.000000', 'consum', 0.0226, 'lps'),
	(363011, 124, '2015-01-15 00:59:29.000000', 'consum', 0.0218, 'lps'),
	(363012, 124, '2015-01-15 00:59:30.000000', 'consum', 0.0221, 'lps'),
	(363013, 124, '2015-01-15 00:59:31.000000', 'consum', 0.0223, 'lps'),
	(363014, 124, '2015-01-15 00:59:32.000000', 'consum', 0.0219, 'lps'),
	(363015, 124, '2015-01-15 00:59:33.000000', 'consum', 0.0216, 'lps'),
	(363016, 124, '2015-01-15 00:59:34.000000', 'consum', 0.0213, 'lps'),
	(363017, 124, '2015-01-15 00:59:35.000000', 'consum', 0.0228, 'lps'),
	(363018, 124, '2015-01-15 00:59:36.000000', 'consum', 0.0229, 'lps'),
	(363019, 124, '2015-01-15 00:59:37.000000', 'consum', 0.0227, 'lps'),
	(363020, 124, '2015-01-15 00:59:38.000000', 'consum', 0.0217, 'lps'),
	(363021, 124, '2015-01-15 00:59:39.000000', 'consum', 0.0215, 'lps'),
	(363022, 124, '2015-01-15 00:59:40.000000', 'consum', 0.0217, 'lps'),
	(363023, 124, '2015-01-15 00:59:41.000000', 'consum', 0.0230, 'lps'),
	(363024, 124, '2015-01-15 00:59:42.000000', 'consum', 0.0223, 'lps'),
	(363025, 124, '2015-01-15 00:59:43.000000', 'consum', 0.0216, 'lps'),
	(363026, 124, '2015-01-15 00:59:44.000000', 'consum', 0.0222, 'lps'),
	(363027, 124, '2015-01-15 00:59:45.000000', 'consum', 0.0210, 'lps'),
	(363028, 124, '2015-01-15 00:59:46.000000', 'consum', 0.0220, 'lps'),
	(363029, 124, '2015-01-15 00:59:47.000000', 'consum', 0.0214, 'lps'),
	(363030, 124, '2015-01-15 00:59:48.000000', 'consum', 0.0222, 'lps'),
	(363031, 124, '2015-01-15 00:59:49.000000', 'consum', 0.0216, 'lps'),
	(363032, 124, '2015-01-15 00:59:50.000000', 'consum', 0.0226, 'lps'),
	(363033, 124, '2015-01-15 00:59:51.000000', 'consum', 0.0230, 'lps'),
	(363034, 124, '2015-01-15 00:59:52.000000', 'consum', 0.0217, 'lps'),
	(363035, 124, '2015-01-15 00:59:53.000000', 'consum', 0.0230, 'lps'),
	(363036, 124, '2015-01-15 00:59:54.000000', 'consum', 0.0225, 'lps'),
	(363037, 124, '2015-01-15 00:59:55.000000', 'consum', 0.0226, 'lps'),
	(363038, 124, '2015-01-15 00:59:56.000000', 'consum', 0.0224, 'lps'),
	(363039, 124, '2015-01-15 00:59:57.000000', 'consum', 0.0231, 'lps'),
	(363040, 124, '2015-01-15 00:59:58.000000', 'consum', 0.0230, 'lps'),
	(363041, 124, '2015-01-15 00:59:59.000000', 'consum', 0.0225, 'lps'),
	(363042, 124, '2015-01-15 01:00:00.000000', 'consum', 0.0225, 'lps'),
	(363043, 124, '2015-01-15 01:00:01.000000', 'consum', 0.0219, 'lps'),
	(363044, 124, '2015-01-15 01:00:02.000000', 'consum', 0.0231, 'lps'),
	(363045, 124, '2015-01-15 01:00:03.000000', 'consum', 0.0223, 'lps'),
	(363046, 124, '2015-01-15 01:00:04.000000', 'consum', 0.0215, 'lps'),
	(363047, 124, '2015-01-15 01:00:05.000000', 'consum', 0.0217, 'lps'),
	(363048, 124, '2015-01-15 01:00:06.000000', 'consum', 0.0230, 'lps'),
	(363049, 124, '2015-01-15 01:00:07.000000', 'consum', 0.0223, 'lps'),
	(363050, 124, '2015-01-15 01:00:08.000000', 'consum', 0.0217, 'lps'),
	(363051, 124, '2015-01-15 01:00:09.000000', 'consum', 0.0226, 'lps'),
	(363052, 124, '2015-01-15 01:00:10.000000', 'consum', 0.0228, 'lps'),
	(363053, 124, '2015-01-15 01:00:11.000000', 'consum', 0.0228, 'lps'),
	(363054, 124, '2015-01-15 01:00:12.000000', 'consum', 0.0225, 'lps'),
	(363055, 124, '2015-01-15 01:00:13.000000', 'consum', 0.0230, 'lps'),
	(363056, 124, '2015-01-15 01:00:14.000000', 'consum', 0.0223, 'lps'),
	(363057, 124, '2015-01-15 01:00:15.000000', 'consum', 0.0216, 'lps'),
	(363058, 124, '2015-01-15 01:00:16.000000', 'consum', 0.0224, 'lps'),
	(363059, 124, '2015-01-15 01:00:17.000000', 'consum', 0.0218, 'lps'),
	(363060, 124, '2015-01-15 01:00:18.000000', 'consum', 0.0228, 'lps'),
	(363061, 124, '2015-01-15 01:00:19.000000', 'consum', 0.0214, 'lps'),
	(363062, 124, '2015-01-15 01:00:20.000000', 'consum', 0.0218, 'lps'),
	(363063, 124, '2015-01-15 01:00:21.000000', 'consum', 0.0216, 'lps'),
	(363064, 124, '2015-01-15 01:00:22.000000', 'consum', 0.0217, 'lps'),
	(363065, 124, '2015-01-15 01:00:23.000000', 'consum', 0.0226, 'lps'),
	(363066, 124, '2015-01-15 01:00:24.000000', 'consum', 0.0226, 'lps'),
	(363067, 124, '2015-01-15 01:00:25.000000', 'consum', 0.0223, 'lps'),
	(363068, 124, '2015-01-15 01:00:26.000000', 'consum', 0.0225, 'lps'),
	(363069, 124, '2015-01-15 01:00:27.000000', 'consum', 0.0226, 'lps'),
	(363070, 124, '2015-01-15 01:00:28.000000', 'consum', 0.0223, 'lps'),
	(363071, 124, '2015-01-15 01:00:29.000000', 'consum', 0.0227, 'lps'),
	(363072, 124, '2015-01-15 01:00:30.000000', 'consum', 0.0211, 'lps'),
	(363073, 124, '2015-01-15 01:00:31.000000', 'consum', 0.0210, 'lps'),
	(363074, 124, '2015-01-15 01:00:32.000000', 'consum', 0.0229, 'lps'),
	(363075, 124, '2015-01-15 01:00:33.000000', 'consum', 0.0219, 'lps'),
	(363076, 124, '2015-01-15 01:00:34.000000', 'consum', 0.0219, 'lps'),
	(363077, 124, '2015-01-15 01:00:35.000000', 'consum', 0.0230, 'lps'),
	(363078, 124, '2015-01-15 01:00:36.000000', 'consum', 0.0216, 'lps'),
	(363079, 124, '2015-01-15 01:00:37.000000', 'consum', 0.0226, 'lps'),
	(363080, 124, '2015-01-15 01:00:38.000000', 'consum', 0.0229, 'lps'),
	(363081, 124, '2015-01-15 01:00:39.000000', 'consum', 0.0212, 'lps'),
	(363082, 124, '2015-01-15 01:00:40.000000', 'consum', 0.0228, 'lps'),
	(363083, 124, '2015-01-15 01:00:41.000000', 'consum', 0.0210, 'lps'),
	(363084, 124, '2015-01-15 01:00:42.000000', 'consum', 0.0219, 'lps'),
	(363085, 124, '2015-01-15 01:00:43.000000', 'consum', 0.0213, 'lps'),
	(363086, 124, '2015-01-15 01:00:44.000000', 'consum', 0.0223, 'lps'),
	(363087, 124, '2015-01-15 01:00:45.000000', 'consum', 0.0219, 'lps'),
	(363088, 124, '2015-01-15 01:00:46.000000', 'consum', 0.0217, 'lps'),
	(363089, 124, '2015-01-15 01:00:47.000000', 'consum', 0.0220, 'lps'),
	(363090, 124, '2015-01-15 01:00:48.000000', 'consum', 0.0215, 'lps'),
	(363091, 124, '2015-01-15 01:00:49.000000', 'consum', 0.0229, 'lps'),
	(363092, 124, '2015-01-15 01:00:50.000000', 'consum', 0.0226, 'lps'),
	(363093, 124, '2015-01-15 01:00:51.000000', 'consum', 0.0211, 'lps'),
	(363094, 124, '2015-01-15 01:00:52.000000', 'consum', 0.0210, 'lps'),
	(363095, 124, '2015-01-15 01:00:53.000000', 'consum', 0.0210, 'lps'),
	(363096, 124, '2015-01-15 01:00:54.000000', 'consum', 0.0210, 'lps'),
	(363097, 124, '2015-01-15 01:00:55.000000', 'consum', 0.0212, 'lps'),
	(363098, 124, '2015-01-15 01:00:56.000000', 'consum', 0.0217, 'lps'),
	(363099, 124, '2015-01-15 01:00:57.000000', 'consum', 0.0219, 'lps'),
	(363100, 124, '2015-01-15 01:00:58.000000', 'consum', 0.0212, 'lps'),
	(363101, 124, '2015-01-15 01:00:59.000000', 'consum', 0.0217, 'lps'),
	(363102, 124, '2015-01-15 01:01:00.000000', 'consum', 0.0216, 'lps'),
	(363103, 124, '2015-01-15 01:01:01.000000', 'consum', 0.0220, 'lps'),
	(363104, 124, '2015-01-15 01:01:02.000000', 'consum', 0.0219, 'lps'),
	(363105, 124, '2015-01-15 01:01:03.000000', 'consum', 0.0226, 'lps'),
	(363106, 124, '2015-01-15 01:01:04.000000', 'consum', 0.0221, 'lps'),
	(363107, 124, '2015-01-15 01:01:05.000000', 'consum', 0.0215, 'lps'),
	(363108, 124, '2015-01-15 01:01:06.000000', 'consum', 0.0224, 'lps'),
	(363109, 124, '2015-01-15 01:01:07.000000', 'consum', 0.0222, 'lps'),
	(363110, 124, '2015-01-15 01:01:08.000000', 'consum', 0.0230, 'lps'),
	(363111, 124, '2015-01-15 01:01:09.000000', 'consum', 0.0230, 'lps'),
	(363112, 124, '2015-01-15 01:01:10.000000', 'consum', 0.0230, 'lps'),
	(363113, 124, '2015-01-15 01:01:11.000000', 'consum', 0.0226, 'lps'),
	(363114, 124, '2015-01-15 01:01:12.000000', 'consum', 0.0210, 'lps'),
	(363115, 124, '2015-01-15 01:01:13.000000', 'consum', 0.0228, 'lps'),
	(363116, 124, '2015-01-15 01:01:14.000000', 'consum', 0.0212, 'lps'),
	(363117, 124, '2015-01-15 01:01:15.000000', 'consum', 0.0212, 'lps'),
	(363118, 124, '2015-01-15 01:01:16.000000', 'consum', 0.0212, 'lps'),
	(363119, 124, '2015-01-15 01:01:17.000000', 'consum', 0.0217, 'lps'),
	(363120, 124, '2015-01-15 01:01:18.000000', 'consum', 0.0218, 'lps'),
	(363121, 124, '2015-01-15 01:01:19.000000', 'consum', 0.0226, 'lps'),
	(363122, 124, '2015-01-15 01:01:20.000000', 'consum', 0.0226, 'lps'),
	(363123, 124, '2015-01-15 01:01:21.000000', 'consum', 0.0219, 'lps'),
	(363124, 124, '2015-01-15 01:01:22.000000', 'consum', 0.0229, 'lps'),
	(363125, 124, '2015-01-15 01:01:23.000000', 'consum', 0.0212, 'lps'),
	(363126, 124, '2015-01-15 01:01:24.000000', 'consum', 0.0229, 'lps'),
	(363127, 124, '2015-01-15 01:01:25.000000', 'consum', 0.0214, 'lps'),
	(363128, 124, '2015-01-15 01:01:26.000000', 'consum', 0.0216, 'lps'),
	(363129, 124, '2015-01-15 01:01:27.000000', 'consum', 0.0231, 'lps'),
	(363130, 124, '2015-01-15 01:01:28.000000', 'consum', 0.0228, 'lps'),
	(363131, 124, '2015-01-15 01:01:29.000000', 'consum', 0.0217, 'lps'),
	(363132, 124, '2015-01-15 01:01:30.000000', 'consum', 0.0214, 'lps'),
	(363133, 124, '2015-01-15 01:01:31.000000', 'consum', 0.0229, 'lps'),
	(363134, 124, '2015-01-15 01:01:32.000000', 'consum', 0.0230, 'lps'),
	(363135, 124, '2015-01-15 01:01:33.000000', 'consum', 0.0230, 'lps'),
	(363136, 124, '2015-01-15 01:01:34.000000', 'consum', 0.0230, 'lps'),
	(363137, 124, '2015-01-15 01:01:35.000000', 'consum', 0.0229, 'lps'),
	(363138, 124, '2015-01-15 01:01:36.000000', 'consum', 0.0223, 'lps'),
	(363139, 124, '2015-01-15 01:01:37.000000', 'consum', 0.0216, 'lps'),
	(363140, 124, '2015-01-15 01:01:38.000000', 'consum', 0.0227, 'lps'),
	(363141, 124, '2015-01-15 01:01:39.000000', 'consum', 0.0231, 'lps'),
	(363142, 124, '2015-01-15 01:01:40.000000', 'consum', 0.0222, 'lps'),
	(363143, 124, '2015-01-15 01:01:41.000000', 'consum', 0.0228, 'lps'),
	(363144, 124, '2015-01-15 01:01:42.000000', 'consum', 0.0221, 'lps'),
	(363145, 124, '2015-01-15 01:01:43.000000', 'consum', 0.0212, 'lps'),
	(363146, 124, '2015-01-15 01:01:44.000000', 'consum', 0.0210, 'lps'),
	(363147, 124, '2015-01-15 01:01:45.000000', 'consum', 0.0224, 'lps'),
	(363148, 124, '2015-01-15 01:01:46.000000', 'consum', 0.0217, 'lps'),
	(363149, 124, '2015-01-15 01:01:47.000000', 'consum', 0.0225, 'lps'),
	(363150, 124, '2015-01-15 01:01:48.000000', 'consum', 0.0219, 'lps'),
	(363151, 124, '2015-01-15 01:01:49.000000', 'consum', 0.0211, 'lps'),
	(363152, 124, '2015-01-15 01:01:50.000000', 'consum', 0.0210, 'lps'),
	(363153, 124, '2015-01-15 01:01:51.000000', 'consum', 0.0229, 'lps'),
	(363154, 124, '2015-01-15 01:01:52.000000', 'consum', 0.0217, 'lps'),
	(363155, 124, '2015-01-15 01:01:53.000000', 'consum', 0.0213, 'lps'),
	(363156, 124, '2015-01-15 01:01:54.000000', 'consum', 0.0225, 'lps'),
	(363157, 124, '2015-01-15 01:01:55.000000', 'consum', 0.0211, 'lps'),
	(363158, 124, '2015-01-15 01:01:56.000000', 'consum', 0.0215, 'lps'),
	(363159, 124, '2015-01-15 01:01:57.000000', 'consum', 0.0211, 'lps'),
	(363160, 124, '2015-01-15 01:01:58.000000', 'consum', 0.0221, 'lps'),
	(363161, 124, '2015-01-15 01:01:59.000000', 'consum', 0.0221, 'lps'),
	(363162, 124, '2015-01-15 01:02:00.000000', 'consum', 0.0230, 'lps'),
	(363163, 124, '2015-01-15 01:02:01.000000', 'consum', 0.0213, 'lps'),
	(363164, 124, '2015-01-15 01:02:02.000000', 'consum', 0.0211, 'lps'),
	(363165, 124, '2015-01-15 01:02:03.000000', 'consum', 0.0225, 'lps'),
	(363166, 124, '2015-01-15 01:02:04.000000', 'consum', 0.0220, 'lps'),
	(363167, 124, '2015-01-15 01:02:05.000000', 'consum', 0.0214, 'lps'),
	(363168, 124, '2015-01-15 01:02:06.000000', 'consum', 0.0222, 'lps'),
	(363169, 124, '2015-01-15 01:02:07.000000', 'consum', 0.0213, 'lps'),
	(363170, 124, '2015-01-15 01:02:08.000000', 'consum', 0.0213, 'lps'),
	(363171, 124, '2015-01-15 01:02:09.000000', 'consum', 0.0217, 'lps'),
	(363172, 124, '2015-01-15 01:02:10.000000', 'consum', 0.0214, 'lps'),
	(363173, 124, '2015-01-15 01:02:11.000000', 'consum', 0.0210, 'lps'),
	(363174, 124, '2015-01-15 01:02:12.000000', 'consum', 0.0221, 'lps'),
	(363175, 124, '2015-01-15 01:02:13.000000', 'consum', 0.0221, 'lps'),
	(363176, 124, '2015-01-15 01:02:14.000000', 'consum', 0.0231, 'lps'),
	(363177, 124, '2015-01-15 01:02:15.000000', 'consum', 0.0218, 'lps'),
	(363178, 124, '2015-01-15 01:02:16.000000', 'consum', 0.0229, 'lps'),
	(363179, 124, '2015-01-15 01:02:17.000000', 'consum', 0.0219, 'lps'),
	(363180, 124, '2015-01-15 01:02:18.000000', 'consum', 0.0218, 'lps'),
	(363181, 124, '2015-01-15 01:02:19.000000', 'consum', 0.0222, 'lps'),
	(363182, 124, '2015-01-15 01:02:20.000000', 'consum', 0.0228, 'lps'),
	(363183, 124, '2015-01-15 01:02:21.000000', 'consum', 0.0219, 'lps'),
	(363184, 124, '2015-01-15 01:02:22.000000', 'consum', 0.0222, 'lps'),
	(363185, 124, '2015-01-15 01:02:23.000000', 'consum', 0.0223, 'lps'),
	(363186, 124, '2015-01-15 01:02:24.000000', 'consum', 0.0217, 'lps'),
	(363187, 124, '2015-01-15 01:02:25.000000', 'consum', 0.0228, 'lps'),
	(363188, 124, '2015-01-15 01:02:26.000000', 'consum', 0.0215, 'lps'),
	(363189, 124, '2015-01-15 01:02:27.000000', 'consum', 0.0226, 'lps'),
	(363190, 124, '2015-01-15 01:02:28.000000', 'consum', 0.0210, 'lps'),
	(363191, 124, '2015-01-15 01:02:29.000000', 'consum', 0.0225, 'lps'),
	(363192, 124, '2015-01-15 01:02:30.000000', 'consum', 0.0223, 'lps'),
	(363193, 124, '2015-01-15 01:02:31.000000', 'consum', 0.0230, 'lps'),
	(363194, 124, '2015-01-15 01:02:32.000000', 'consum', 0.0226, 'lps'),
	(363195, 124, '2015-01-15 01:02:33.000000', 'consum', 0.0211, 'lps'),
	(363196, 124, '2015-01-15 01:02:34.000000', 'consum', 0.0231, 'lps'),
	(363197, 124, '2015-01-15 01:02:35.000000', 'consum', 0.0223, 'lps'),
	(363198, 124, '2015-01-15 01:02:36.000000', 'consum', 0.0216, 'lps'),
	(363199, 124, '2015-01-15 01:02:37.000000', 'consum', 0.0223, 'lps'),
	(363200, 124, '2015-01-15 01:02:38.000000', 'consum', 0.0212, 'lps'),
	(363201, 124, '2015-01-15 01:02:39.000000', 'consum', 0.0228, 'lps'),
	(363202, 124, '2015-01-15 01:02:40.000000', 'consum', 0.0228, 'lps'),
	(363203, 124, '2015-01-15 01:02:41.000000', 'consum', 0.0224, 'lps'),
	(363204, 124, '2015-01-15 01:02:42.000000', 'consum', 0.0227, 'lps'),
	(363205, 124, '2015-01-15 01:02:43.000000', 'consum', 0.0230, 'lps'),
	(363206, 124, '2015-01-15 01:02:44.000000', 'consum', 0.0218, 'lps'),
	(363207, 124, '2015-01-15 01:02:45.000000', 'consum', 0.0231, 'lps'),
	(363208, 124, '2015-01-15 01:02:46.000000', 'consum', 0.0229, 'lps'),
	(363209, 124, '2015-01-15 01:02:47.000000', 'consum', 0.0219, 'lps'),
	(363210, 124, '2015-01-15 01:02:48.000000', 'consum', 0.0219, 'lps'),
	(363211, 124, '2015-01-15 01:02:49.000000', 'consum', 0.0231, 'lps'),
	(363212, 124, '2015-01-15 01:02:50.000000', 'consum', 0.0222, 'lps'),
	(363213, 124, '2015-01-15 01:02:51.000000', 'consum', 0.0229, 'lps'),
	(363214, 124, '2015-01-15 01:02:52.000000', 'consum', 0.0227, 'lps'),
	(363215, 124, '2015-01-15 01:02:53.000000', 'consum', 0.0214, 'lps'),
	(363216, 124, '2015-01-15 01:02:54.000000', 'consum', 0.0225, 'lps'),
	(363217, 124, '2015-01-15 01:02:55.000000', 'consum', 0.0230, 'lps'),
	(363218, 124, '2015-01-15 01:02:56.000000', 'consum', 0.0222, 'lps'),
	(363219, 124, '2015-01-15 01:02:57.000000', 'consum', 0.0210, 'lps'),
	(363220, 124, '2015-01-15 01:02:58.000000', 'consum', 0.0220, 'lps'),
	(363221, 124, '2015-01-15 01:02:59.000000', 'consum', 0.0216, 'lps'),
	(363222, 124, '2015-01-15 01:03:00.000000', 'consum', 0.0231, 'lps'),
	(363223, 124, '2015-01-15 01:03:01.000000', 'consum', 0.0231, 'lps'),
	(363224, 124, '2015-01-15 01:03:02.000000', 'consum', 0.0210, 'lps'),
	(363225, 124, '2015-01-15 01:03:03.000000', 'consum', 0.0212, 'lps'),
	(363226, 124, '2015-01-15 01:03:04.000000', 'consum', 0.0221, 'lps'),
	(363227, 124, '2015-01-15 01:03:05.000000', 'consum', 0.0215, 'lps'),
	(363228, 124, '2015-01-15 01:03:06.000000', 'consum', 0.0226, 'lps'),
	(363229, 124, '2015-01-15 01:03:07.000000', 'consum', 0.0230, 'lps'),
	(363230, 124, '2015-01-15 01:03:08.000000', 'consum', 0.0220, 'lps'),
	(363231, 124, '2015-01-15 01:03:09.000000', 'consum', 0.0222, 'lps'),
	(363232, 124, '2015-01-15 01:03:10.000000', 'consum', 0.0217, 'lps'),
	(363233, 124, '2015-01-15 01:03:11.000000', 'consum', 0.0211, 'lps'),
	(363234, 124, '2015-01-15 01:03:12.000000', 'consum', 0.0218, 'lps'),
	(363235, 124, '2015-01-15 01:03:13.000000', 'consum', 0.0224, 'lps'),
	(363236, 124, '2015-01-15 01:03:14.000000', 'consum', 0.0212, 'lps'),
	(363237, 124, '2015-01-15 01:03:15.000000', 'consum', 0.0223, 'lps'),
	(363238, 124, '2015-01-15 01:03:16.000000', 'consum', 0.0227, 'lps'),
	(363239, 124, '2015-01-15 01:03:17.000000', 'consum', 0.0213, 'lps'),
	(363240, 124, '2015-01-15 01:03:18.000000', 'consum', 0.0219, 'lps'),
	(363241, 124, '2015-01-15 01:03:19.000000', 'consum', 0.0224, 'lps'),
	(363242, 124, '2015-01-15 01:03:20.000000', 'consum', 0.0210, 'lps'),
	(363243, 124, '2015-01-15 01:03:21.000000', 'consum', 0.0211, 'lps'),
	(363244, 124, '2015-01-15 01:03:22.000000', 'consum', 0.0215, 'lps'),
	(363245, 124, '2015-01-15 01:03:23.000000', 'consum', 0.0213, 'lps'),
	(363246, 124, '2015-01-15 01:03:24.000000', 'consum', 0.0210, 'lps'),
	(363247, 124, '2015-01-15 01:03:25.000000', 'consum', 0.0221, 'lps'),
	(363248, 124, '2015-01-15 01:03:26.000000', 'consum', 0.0223, 'lps'),
	(363249, 124, '2015-01-15 01:03:27.000000', 'consum', 0.0219, 'lps'),
	(363250, 124, '2015-01-15 01:03:28.000000', 'consum', 0.0219, 'lps'),
	(363251, 124, '2015-01-15 01:03:29.000000', 'consum', 0.0228, 'lps'),
	(363252, 124, '2015-01-15 01:03:30.000000', 'consum', 0.0230, 'lps'),
	(363253, 124, '2015-01-15 01:03:31.000000', 'consum', 0.0214, 'lps'),
	(363254, 124, '2015-01-15 01:03:32.000000', 'consum', 0.0212, 'lps'),
	(363255, 124, '2015-01-15 01:03:33.000000', 'consum', 0.0230, 'lps'),
	(363256, 124, '2015-01-15 01:03:34.000000', 'consum', 0.0217, 'lps'),
	(363257, 124, '2015-01-15 01:03:35.000000', 'consum', 0.0228, 'lps'),
	(363258, 124, '2015-01-15 01:03:36.000000', 'consum', 0.0216, 'lps'),
	(363259, 124, '2015-01-15 01:03:37.000000', 'consum', 0.0228, 'lps'),
	(363260, 124, '2015-01-15 01:03:38.000000', 'consum', 0.0218, 'lps'),
	(363261, 124, '2015-01-15 01:03:39.000000', 'consum', 0.0217, 'lps'),
	(363262, 124, '2015-01-15 01:03:40.000000', 'consum', 0.0224, 'lps'),
	(363263, 124, '2015-01-15 01:03:41.000000', 'consum', 0.0214, 'lps'),
	(363264, 124, '2015-01-15 01:03:42.000000', 'consum', 0.0213, 'lps'),
	(363265, 124, '2015-01-15 01:03:43.000000', 'consum', 0.0211, 'lps'),
	(363266, 124, '2015-01-15 01:03:44.000000', 'consum', 0.0230, 'lps'),
	(363267, 124, '2015-01-15 01:03:45.000000', 'consum', 0.0220, 'lps'),
	(363268, 124, '2015-01-15 01:03:46.000000', 'consum', 0.0221, 'lps'),
	(363269, 124, '2015-01-15 01:03:47.000000', 'consum', 0.0213, 'lps'),
	(363270, 124, '2015-01-15 01:03:48.000000', 'consum', 0.0217, 'lps'),
	(363271, 124, '2015-01-15 01:03:49.000000', 'consum', 0.0215, 'lps'),
	(363272, 124, '2015-01-15 01:03:50.000000', 'consum', 0.0211, 'lps'),
	(363273, 124, '2015-01-15 01:03:51.000000', 'consum', 0.0225, 'lps'),
	(363274, 124, '2015-01-15 01:03:52.000000', 'consum', 0.0214, 'lps'),
	(363275, 124, '2015-01-15 01:03:53.000000', 'consum', 0.0210, 'lps'),
	(363276, 124, '2015-01-15 01:03:54.000000', 'consum', 0.0221, 'lps'),
	(363277, 124, '2015-01-15 01:03:55.000000', 'consum', 0.0221, 'lps'),
	(363278, 124, '2015-01-15 01:03:56.000000', 'consum', 0.0212, 'lps'),
	(363279, 124, '2015-01-15 01:03:57.000000', 'consum', 0.0229, 'lps'),
	(363280, 124, '2015-01-15 01:03:58.000000', 'consum', 0.0211, 'lps'),
	(363281, 124, '2015-01-15 01:03:59.000000', 'consum', 0.0227, 'lps'),
	(363282, 124, '2015-01-15 01:04:00.000000', 'consum', 0.0224, 'lps'),
	(363283, 124, '2015-01-15 01:04:01.000000', 'consum', 0.0231, 'lps'),
	(363284, 124, '2015-01-15 01:04:02.000000', 'consum', 0.0231, 'lps'),
	(363285, 124, '2015-01-15 01:04:03.000000', 'consum', 0.0229, 'lps'),
	(363286, 124, '2015-01-15 01:04:04.000000', 'consum', 0.0219, 'lps'),
	(363287, 124, '2015-01-15 01:04:05.000000', 'consum', 0.0223, 'lps'),
	(363288, 124, '2015-01-15 01:04:06.000000', 'consum', 0.0224, 'lps'),
	(363289, 124, '2015-01-15 01:04:07.000000', 'consum', 0.0221, 'lps'),
	(363290, 124, '2015-01-15 01:04:08.000000', 'consum', 0.0222, 'lps'),
	(363291, 124, '2015-01-15 01:04:09.000000', 'consum', 0.0218, 'lps'),
	(363292, 124, '2015-01-15 01:04:10.000000', 'consum', 0.0212, 'lps'),
	(363293, 124, '2015-01-15 01:04:11.000000', 'consum', 0.0219, 'lps'),
	(363294, 124, '2015-01-15 01:04:12.000000', 'consum', 0.0226, 'lps'),
	(363295, 124, '2015-01-15 01:04:13.000000', 'consum', 0.0220, 'lps'),
	(363296, 124, '2015-01-15 01:04:14.000000', 'consum', 0.0215, 'lps'),
	(363297, 124, '2015-01-15 01:04:15.000000', 'consum', 0.0227, 'lps'),
	(363298, 124, '2015-01-15 01:04:16.000000', 'consum', 0.0213, 'lps'),
	(363299, 124, '2015-01-15 01:04:17.000000', 'consum', 0.0219, 'lps'),
	(363300, 124, '2015-01-15 01:04:18.000000', 'consum', 0.0226, 'lps'),
	(363301, 124, '2015-01-15 01:04:19.000000', 'consum', 0.0220, 'lps'),
	(363302, 124, '2015-01-15 01:04:20.000000', 'consum', 0.0210, 'lps'),
	(363303, 124, '2015-01-15 01:04:21.000000', 'consum', 0.0227, 'lps'),
	(363304, 124, '2015-01-15 01:04:22.000000', 'consum', 0.0229, 'lps'),
	(363305, 124, '2015-01-15 01:04:23.000000', 'consum', 0.0231, 'lps'),
	(363306, 124, '2015-01-15 01:04:24.000000', 'consum', 0.0214, 'lps'),
	(363307, 124, '2015-01-15 01:04:25.000000', 'consum', 0.0212, 'lps'),
	(363308, 124, '2015-01-15 01:04:26.000000', 'consum', 0.0230, 'lps'),
	(363309, 124, '2015-01-15 01:04:27.000000', 'consum', 0.0215, 'lps'),
	(363310, 124, '2015-01-15 01:04:28.000000', 'consum', 0.0223, 'lps'),
	(363311, 124, '2015-01-15 01:04:29.000000', 'consum', 0.0215, 'lps'),
	(363312, 124, '2015-01-15 01:04:30.000000', 'consum', 0.0218, 'lps'),
	(363313, 124, '2015-01-15 01:04:31.000000', 'consum', 0.0214, 'lps'),
	(363314, 124, '2015-01-15 01:04:32.000000', 'consum', 0.0229, 'lps'),
	(363315, 124, '2015-01-15 01:04:33.000000', 'consum', 0.0227, 'lps'),
	(363316, 124, '2015-01-15 01:04:34.000000', 'consum', 0.0216, 'lps'),
	(363317, 124, '2015-01-15 01:04:35.000000', 'consum', 0.0211, 'lps'),
	(363318, 124, '2015-01-15 01:04:36.000000', 'consum', 0.0222, 'lps'),
	(363319, 124, '2015-01-15 01:04:37.000000', 'consum', 0.0222, 'lps'),
	(363320, 124, '2015-01-15 01:04:38.000000', 'consum', 0.0214, 'lps'),
	(363321, 124, '2015-01-15 01:04:39.000000', 'consum', 0.0215, 'lps'),
	(363322, 124, '2015-01-15 01:04:40.000000', 'consum', 0.0222, 'lps'),
	(363323, 124, '2015-01-15 01:04:41.000000', 'consum', 0.0212, 'lps'),
	(363324, 124, '2015-01-15 01:04:42.000000', 'consum', 0.0228, 'lps'),
	(363325, 124, '2015-01-15 01:04:43.000000', 'consum', 0.0230, 'lps'),
	(363326, 124, '2015-01-15 01:04:44.000000', 'consum', 0.0211, 'lps'),
	(363327, 124, '2015-01-15 01:04:45.000000', 'consum', 0.0222, 'lps'),
	(363328, 124, '2015-01-15 01:04:46.000000', 'consum', 0.0223, 'lps'),
	(363329, 124, '2015-01-15 01:04:47.000000', 'consum', 0.0218, 'lps'),
	(363330, 124, '2015-01-15 01:04:48.000000', 'consum', 0.0213, 'lps'),
	(363331, 124, '2015-01-15 01:04:49.000000', 'consum', 0.0222, 'lps'),
	(363332, 124, '2015-01-15 01:04:50.000000', 'consum', 0.0220, 'lps'),
	(363333, 124, '2015-01-15 01:04:51.000000', 'consum', 0.0222, 'lps'),
	(363334, 124, '2015-01-15 01:04:52.000000', 'consum', 0.0219, 'lps'),
	(363335, 124, '2015-01-15 01:04:53.000000', 'consum', 0.0218, 'lps'),
	(363336, 124, '2015-01-15 01:04:54.000000', 'consum', 0.0224, 'lps'),
	(363337, 124, '2015-01-15 01:04:55.000000', 'consum', 0.0215, 'lps'),
	(363338, 124, '2015-01-15 01:04:56.000000', 'consum', 0.0212, 'lps'),
	(363339, 124, '2015-01-15 01:04:57.000000', 'consum', 0.0229, 'lps'),
	(363340, 124, '2015-01-15 01:04:58.000000', 'consum', 0.0211, 'lps'),
	(363341, 124, '2015-01-15 01:04:59.000000', 'consum', 0.0225, 'lps'),
	(363342, 124, '2015-01-15 01:05:00.000000', 'consum', 0.0218, 'lps'),
	(363343, 124, '2015-01-15 01:05:01.000000', 'consum', 0.0226, 'lps'),
	(363344, 124, '2015-01-15 01:05:02.000000', 'consum', 0.0223, 'lps'),
	(363345, 124, '2015-01-15 01:05:03.000000', 'consum', 0.0229, 'lps'),
	(363346, 124, '2015-01-15 01:05:04.000000', 'consum', 0.0222, 'lps'),
	(363347, 124, '2015-01-15 01:05:05.000000', 'consum', 0.0214, 'lps'),
	(363348, 124, '2015-01-15 01:05:06.000000', 'consum', 0.0214, 'lps'),
	(363349, 124, '2015-01-15 01:05:07.000000', 'consum', 0.0219, 'lps'),
	(363350, 124, '2015-01-15 01:05:08.000000', 'consum', 0.0222, 'lps'),
	(363351, 124, '2015-01-15 01:05:09.000000', 'consum', 0.0219, 'lps'),
	(363352, 124, '2015-01-15 01:05:10.000000', 'consum', 0.0223, 'lps'),
	(363353, 124, '2015-01-15 01:05:11.000000', 'consum', 0.0226, 'lps'),
	(363354, 124, '2015-01-15 01:05:12.000000', 'consum', 0.0231, 'lps'),
	(363355, 124, '2015-01-15 01:05:13.000000', 'consum', 0.0222, 'lps'),
	(363356, 124, '2015-01-15 01:05:14.000000', 'consum', 0.0230, 'lps'),
	(363357, 124, '2015-01-15 01:05:15.000000', 'consum', 0.0230, 'lps'),
	(363358, 124, '2015-01-15 01:05:16.000000', 'consum', 0.0227, 'lps'),
	(363359, 124, '2015-01-15 01:05:17.000000', 'consum', 0.0214, 'lps'),
	(363360, 124, '2015-01-15 01:05:18.000000', 'consum', 0.0223, 'lps'),
	(363361, 124, '2015-01-15 01:05:19.000000', 'consum', 0.0220, 'lps'),
	(363362, 124, '2015-01-15 01:05:20.000000', 'consum', 0.0221, 'lps'),
	(363363, 124, '2015-01-15 01:05:21.000000', 'consum', 0.0216, 'lps'),
	(363364, 124, '2015-01-15 01:05:22.000000', 'consum', 0.0226, 'lps'),
	(363365, 124, '2015-01-15 01:05:23.000000', 'consum', 0.0230, 'lps'),
	(363366, 124, '2015-01-15 01:05:24.000000', 'consum', 0.0220, 'lps'),
	(363367, 124, '2015-01-15 01:05:25.000000', 'consum', 0.0219, 'lps'),
	(363368, 124, '2015-01-15 01:05:26.000000', 'consum', 0.0229, 'lps'),
	(363369, 124, '2015-01-15 01:05:27.000000', 'consum', 0.0211, 'lps'),
	(363370, 124, '2015-01-15 01:05:28.000000', 'consum', 0.0224, 'lps'),
	(363371, 124, '2015-01-15 01:05:29.000000', 'consum', 0.0211, 'lps'),
	(363372, 124, '2015-01-15 01:05:30.000000', 'consum', 0.0219, 'lps'),
	(363373, 124, '2015-01-15 01:05:31.000000', 'consum', 0.0231, 'lps'),
	(363374, 124, '2015-01-15 01:05:32.000000', 'consum', 0.0224, 'lps'),
	(363375, 124, '2015-01-15 01:05:33.000000', 'consum', 0.0214, 'lps'),
	(363376, 124, '2015-01-15 01:05:34.000000', 'consum', 0.0212, 'lps'),
	(363377, 124, '2015-01-15 01:05:35.000000', 'consum', 0.0210, 'lps'),
	(363378, 124, '2015-01-15 01:05:36.000000', 'consum', 0.0225, 'lps'),
	(363379, 124, '2015-01-15 01:05:37.000000', 'consum', 0.0219, 'lps'),
	(363380, 124, '2015-01-15 01:05:38.000000', 'consum', 0.0210, 'lps'),
	(363381, 124, '2015-01-15 01:05:39.000000', 'consum', 0.0228, 'lps'),
	(363382, 124, '2015-01-15 01:05:40.000000', 'consum', 0.0212, 'lps'),
	(363383, 124, '2015-01-15 01:05:41.000000', 'consum', 0.0213, 'lps'),
	(363384, 124, '2015-01-15 01:05:42.000000', 'consum', 0.0216, 'lps'),
	(363385, 124, '2015-01-15 01:05:43.000000', 'consum', 0.0213, 'lps'),
	(363386, 124, '2015-01-15 01:05:44.000000', 'consum', 0.0228, 'lps'),
	(363387, 124, '2015-01-15 01:05:45.000000', 'consum', 0.0225, 'lps'),
	(363388, 124, '2015-01-15 01:05:46.000000', 'consum', 0.0210, 'lps'),
	(363389, 124, '2015-01-15 01:05:47.000000', 'consum', 0.0230, 'lps'),
	(363390, 124, '2015-01-15 01:05:48.000000', 'consum', 0.0224, 'lps'),
	(363391, 124, '2015-01-15 01:05:49.000000', 'consum', 0.0222, 'lps'),
	(363392, 124, '2015-01-15 01:05:50.000000', 'consum', 0.0228, 'lps'),
	(363393, 124, '2015-01-15 01:05:51.000000', 'consum', 0.0219, 'lps'),
	(363394, 124, '2015-01-15 01:05:52.000000', 'consum', 0.0222, 'lps'),
	(363395, 124, '2015-01-15 01:05:53.000000', 'consum', 0.0225, 'lps'),
	(363396, 124, '2015-01-15 01:05:54.000000', 'consum', 0.0226, 'lps'),
	(363397, 124, '2015-01-15 01:05:55.000000', 'consum', 0.0223, 'lps'),
	(363398, 124, '2015-01-15 01:05:56.000000', 'consum', 0.0226, 'lps'),
	(363399, 124, '2015-01-15 01:05:57.000000', 'consum', 0.0230, 'lps'),
	(363400, 124, '2015-01-15 01:05:58.000000', 'consum', 0.0221, 'lps'),
	(363401, 124, '2015-01-15 01:05:59.000000', 'consum', 0.0226, 'lps'),
	(363402, 124, '2015-01-15 01:06:00.000000', 'consum', 0.0213, 'lps'),
	(363403, 124, '2015-01-15 01:06:01.000000', 'consum', 0.0223, 'lps'),
	(363404, 124, '2015-01-15 01:06:02.000000', 'consum', 0.0222, 'lps'),
	(363405, 124, '2015-01-15 01:06:03.000000', 'consum', 0.0210, 'lps'),
	(363406, 124, '2015-01-15 01:06:04.000000', 'consum', 0.0217, 'lps'),
	(363407, 124, '2015-01-15 01:06:05.000000', 'consum', 0.0222, 'lps'),
	(363408, 124, '2015-01-15 01:06:06.000000', 'consum', 0.0231, 'lps'),
	(363409, 124, '2015-01-15 01:06:07.000000', 'consum', 0.0211, 'lps'),
	(363410, 124, '2015-01-15 01:06:08.000000', 'consum', 0.0218, 'lps'),
	(363411, 124, '2015-01-15 01:06:09.000000', 'consum', 0.0228, 'lps'),
	(363412, 124, '2015-01-15 01:06:10.000000', 'consum', 0.0231, 'lps'),
	(363413, 124, '2015-01-15 01:06:11.000000', 'consum', 0.0218, 'lps'),
	(363414, 124, '2015-01-15 01:06:12.000000', 'consum', 0.0230, 'lps'),
	(363415, 124, '2015-01-15 01:06:13.000000', 'consum', 0.0221, 'lps'),
	(363416, 124, '2015-01-15 01:06:14.000000', 'consum', 0.0228, 'lps'),
	(363417, 124, '2015-01-15 01:06:15.000000', 'consum', 0.0225, 'lps'),
	(363418, 124, '2015-01-15 01:06:16.000000', 'consum', 0.0210, 'lps'),
	(363419, 124, '2015-01-15 01:06:17.000000', 'consum', 0.0231, 'lps'),
	(363420, 124, '2015-01-15 01:06:18.000000', 'consum', 0.0226, 'lps'),
	(363421, 124, '2015-01-15 01:06:19.000000', 'consum', 0.0230, 'lps'),
	(363422, 124, '2015-01-15 01:06:20.000000', 'consum', 0.0216, 'lps'),
	(363423, 124, '2015-01-15 01:06:21.000000', 'consum', 0.0227, 'lps'),
	(363424, 124, '2015-01-15 01:06:22.000000', 'consum', 0.0231, 'lps'),
	(363425, 124, '2015-01-15 01:06:23.000000', 'consum', 0.0223, 'lps'),
	(363426, 124, '2015-01-15 01:06:24.000000', 'consum', 0.0212, 'lps'),
	(363427, 124, '2015-01-15 01:06:25.000000', 'consum', 0.0225, 'lps'),
	(363428, 124, '2015-01-15 01:06:26.000000', 'consum', 0.0214, 'lps'),
	(363429, 124, '2015-01-15 01:06:27.000000', 'consum', 0.0230, 'lps'),
	(363430, 124, '2015-01-15 01:06:28.000000', 'consum', 0.0231, 'lps'),
	(363431, 124, '2015-01-15 01:06:29.000000', 'consum', 0.0213, 'lps'),
	(363432, 124, '2015-01-15 01:06:30.000000', 'consum', 0.0226, 'lps'),
	(363433, 124, '2015-01-15 01:06:31.000000', 'consum', 0.0217, 'lps'),
	(363434, 124, '2015-01-15 01:06:32.000000', 'consum', 0.0219, 'lps'),
	(363435, 124, '2015-01-15 01:06:33.000000', 'consum', 0.0213, 'lps'),
	(363436, 124, '2015-01-15 01:06:34.000000', 'consum', 0.0220, 'lps'),
	(363437, 124, '2015-01-15 01:06:35.000000', 'consum', 0.0229, 'lps'),
	(363438, 124, '2015-01-15 01:06:36.000000', 'consum', 0.0212, 'lps'),
	(363439, 124, '2015-01-15 01:06:37.000000', 'consum', 0.0228, 'lps'),
	(363440, 124, '2015-01-15 01:06:38.000000', 'consum', 0.0230, 'lps'),
	(363441, 124, '2015-01-15 01:06:39.000000', 'consum', 0.0213, 'lps'),
	(363442, 124, '2015-01-15 01:06:40.000000', 'consum', 0.0230, 'lps'),
	(363443, 124, '2015-01-15 01:06:41.000000', 'consum', 0.0215, 'lps'),
	(363444, 124, '2015-01-15 01:06:42.000000', 'consum', 0.0220, 'lps'),
	(363445, 124, '2015-01-15 01:06:43.000000', 'consum', 0.0222, 'lps'),
	(363446, 124, '2015-01-15 01:06:44.000000', 'consum', 0.0221, 'lps'),
	(363447, 124, '2015-01-15 01:06:45.000000', 'consum', 0.0228, 'lps'),
	(363448, 124, '2015-01-15 01:06:46.000000', 'consum', 0.0223, 'lps'),
	(363449, 124, '2015-01-15 01:06:47.000000', 'consum', 0.0223, 'lps'),
	(363450, 124, '2015-01-15 01:06:48.000000', 'consum', 0.0215, 'lps'),
	(363451, 124, '2015-01-15 01:06:49.000000', 'consum', 0.0218, 'lps'),
	(363452, 124, '2015-01-15 01:06:50.000000', 'consum', 0.0215, 'lps'),
	(363453, 124, '2015-01-15 01:06:51.000000', 'consum', 0.0210, 'lps'),
	(363454, 124, '2015-01-15 01:06:52.000000', 'consum', 0.0218, 'lps'),
	(363455, 124, '2015-01-15 01:06:53.000000', 'consum', 0.0229, 'lps'),
	(363456, 124, '2015-01-15 01:06:54.000000', 'consum', 0.0213, 'lps'),
	(363457, 124, '2015-01-15 01:06:55.000000', 'consum', 0.0216, 'lps'),
	(363458, 124, '2015-01-15 01:06:56.000000', 'consum', 0.0230, 'lps'),
	(363459, 124, '2015-01-15 01:06:57.000000', 'consum', 0.0227, 'lps'),
	(363460, 124, '2015-01-15 01:06:58.000000', 'consum', 0.0212, 'lps'),
	(363461, 124, '2015-01-15 01:06:59.000000', 'consum', 0.0214, 'lps'),
	(363462, 124, '2015-01-15 01:07:00.000000', 'consum', 0.0226, 'lps'),
	(363463, 124, '2015-01-15 01:07:01.000000', 'consum', 0.0212, 'lps'),
	(363464, 124, '2015-01-15 01:07:02.000000', 'consum', 0.0215, 'lps'),
	(363465, 124, '2015-01-15 01:07:03.000000', 'consum', 0.0229, 'lps'),
	(363466, 124, '2015-01-15 01:07:04.000000', 'consum', 0.0224, 'lps'),
	(363467, 124, '2015-01-15 01:07:05.000000', 'consum', 0.0223, 'lps'),
	(363468, 124, '2015-01-15 01:07:06.000000', 'consum', 0.0211, 'lps'),
	(363469, 124, '2015-01-15 01:07:07.000000', 'consum', 0.0223, 'lps'),
	(363470, 124, '2015-01-15 01:07:08.000000', 'consum', 0.0228, 'lps'),
	(363471, 124, '2015-01-15 01:07:09.000000', 'consum', 0.0216, 'lps'),
	(363472, 124, '2015-01-15 01:07:10.000000', 'consum', 0.0230, 'lps'),
	(363473, 124, '2015-01-15 01:07:11.000000', 'consum', 0.0227, 'lps'),
	(363474, 124, '2015-01-15 01:07:12.000000', 'consum', 0.0214, 'lps'),
	(363475, 124, '2015-01-15 01:07:13.000000', 'consum', 0.0225, 'lps'),
	(363476, 124, '2015-01-15 01:07:14.000000', 'consum', 0.0227, 'lps'),
	(363477, 124, '2015-01-15 01:07:15.000000', 'consum', 0.0231, 'lps'),
	(363478, 124, '2015-01-15 01:07:16.000000', 'consum', 0.0220, 'lps'),
	(363479, 124, '2015-01-15 01:07:17.000000', 'consum', 0.0219, 'lps'),
	(363480, 124, '2015-01-15 01:07:18.000000', 'consum', 0.0224, 'lps'),
	(363481, 124, '2015-01-15 01:07:19.000000', 'consum', 0.0212, 'lps'),
	(363482, 124, '2015-01-15 01:07:20.000000', 'consum', 0.0221, 'lps'),
	(363483, 124, '2015-01-15 01:07:21.000000', 'consum', 0.0215, 'lps'),
	(363484, 124, '2015-01-15 01:07:22.000000', 'consum', 0.0224, 'lps'),
	(363485, 124, '2015-01-15 01:07:23.000000', 'consum', 0.0224, 'lps'),
	(363486, 124, '2015-01-15 01:07:24.000000', 'consum', 0.0216, 'lps'),
	(363487, 124, '2015-01-15 01:07:25.000000', 'consum', 0.0219, 'lps'),
	(363488, 124, '2015-01-15 01:07:26.000000', 'consum', 0.0217, 'lps'),
	(363489, 124, '2015-01-15 01:07:27.000000', 'consum', 0.0218, 'lps'),
	(363490, 124, '2015-01-15 01:07:28.000000', 'consum', 0.0210, 'lps'),
	(363491, 124, '2015-01-15 01:07:29.000000', 'consum', 0.0227, 'lps'),
	(363492, 124, '2015-01-15 01:07:30.000000', 'consum', 0.0231, 'lps'),
	(363493, 124, '2015-01-15 01:07:31.000000', 'consum', 0.0218, 'lps'),
	(363494, 124, '2015-01-15 01:07:32.000000', 'consum', 0.0213, 'lps'),
	(363495, 124, '2015-01-15 01:07:33.000000', 'consum', 0.0223, 'lps'),
	(363496, 124, '2015-01-15 01:07:34.000000', 'consum', 0.0221, 'lps'),
	(363497, 124, '2015-01-15 01:07:35.000000', 'consum', 0.0228, 'lps'),
	(363498, 124, '2015-01-15 01:07:36.000000', 'consum', 0.0224, 'lps'),
	(363499, 124, '2015-01-15 01:07:37.000000', 'consum', 0.0224, 'lps'),
	(363500, 124, '2015-01-15 01:07:38.000000', 'consum', 0.0218, 'lps'),
	(363501, 124, '2015-01-15 01:07:39.000000', 'consum', 0.0231, 'lps'),
	(363502, 124, '2015-01-15 01:07:40.000000', 'consum', 0.0227, 'lps'),
	(363503, 124, '2015-01-15 01:07:41.000000', 'consum', 0.0231, 'lps'),
	(363504, 124, '2015-01-15 01:07:42.000000', 'consum', 0.0222, 'lps'),
	(363505, 124, '2015-01-15 01:07:43.000000', 'consum', 0.0227, 'lps'),
	(363506, 124, '2015-01-15 01:07:44.000000', 'consum', 0.0215, 'lps'),
	(363507, 124, '2015-01-15 01:07:45.000000', 'consum', 0.0228, 'lps'),
	(363508, 124, '2015-01-15 01:07:46.000000', 'consum', 0.0220, 'lps'),
	(363509, 124, '2015-01-15 01:07:47.000000', 'consum', 0.0229, 'lps'),
	(363510, 124, '2015-01-15 01:07:48.000000', 'consum', 0.0210, 'lps'),
	(363511, 124, '2015-01-15 01:07:49.000000', 'consum', 0.0219, 'lps'),
	(363512, 124, '2015-01-15 01:07:50.000000', 'consum', 0.0210, 'lps'),
	(363513, 124, '2015-01-15 01:07:51.000000', 'consum', 0.0229, 'lps'),
	(363514, 124, '2015-01-15 01:07:52.000000', 'consum', 0.0217, 'lps'),
	(363515, 124, '2015-01-15 01:07:53.000000', 'consum', 0.0213, 'lps'),
	(363516, 124, '2015-01-15 01:07:54.000000', 'consum', 0.0224, 'lps'),
	(363517, 124, '2015-01-15 01:07:55.000000', 'consum', 0.0227, 'lps'),
	(363518, 124, '2015-01-15 01:07:56.000000', 'consum', 0.0231, 'lps'),
	(363519, 124, '2015-01-15 01:07:57.000000', 'consum', 0.0223, 'lps'),
	(363520, 124, '2015-01-15 01:07:58.000000', 'consum', 0.0212, 'lps'),
	(363521, 124, '2015-01-15 01:07:59.000000', 'consum', 0.0223, 'lps'),
	(363522, 124, '2015-01-15 01:08:00.000000', 'consum', 0.0227, 'lps'),
	(363523, 124, '2015-01-15 01:08:01.000000', 'consum', 0.0213, 'lps'),
	(363524, 124, '2015-01-15 01:08:02.000000', 'consum', 0.0216, 'lps'),
	(363525, 124, '2015-01-15 01:08:03.000000', 'consum', 0.0213, 'lps'),
	(363526, 124, '2015-01-15 01:08:04.000000', 'consum', 0.0227, 'lps'),
	(363527, 124, '2015-01-15 01:08:05.000000', 'consum', 0.0222, 'lps'),
	(363528, 124, '2015-01-15 01:08:06.000000', 'consum', 0.0218, 'lps'),
	(363529, 124, '2015-01-15 01:08:07.000000', 'consum', 0.0215, 'lps'),
	(363530, 124, '2015-01-15 01:08:08.000000', 'consum', 0.0214, 'lps'),
	(363531, 124, '2015-01-15 01:08:09.000000', 'consum', 0.0213, 'lps'),
	(363532, 124, '2015-01-15 01:08:10.000000', 'consum', 0.0213, 'lps'),
	(363533, 124, '2015-01-15 01:08:11.000000', 'consum', 0.0217, 'lps'),
	(363534, 124, '2015-01-15 01:08:12.000000', 'consum', 0.0214, 'lps'),
	(363535, 124, '2015-01-15 01:08:13.000000', 'consum', 0.0230, 'lps'),
	(363536, 124, '2015-01-15 01:08:14.000000', 'consum', 0.0212, 'lps'),
	(363537, 124, '2015-01-15 01:08:15.000000', 'consum', 0.0225, 'lps'),
	(363538, 124, '2015-01-15 01:08:16.000000', 'consum', 0.0212, 'lps'),
	(363539, 124, '2015-01-15 01:08:17.000000', 'consum', 0.0223, 'lps'),
	(363540, 124, '2015-01-15 01:08:18.000000', 'consum', 0.0225, 'lps'),
	(363541, 124, '2015-01-15 01:08:19.000000', 'consum', 0.0222, 'lps'),
	(363542, 124, '2015-01-15 01:08:20.000000', 'consum', 0.0228, 'lps'),
	(363543, 124, '2015-01-15 01:08:21.000000', 'consum', 0.0219, 'lps'),
	(363544, 124, '2015-01-15 01:08:22.000000', 'consum', 0.0224, 'lps'),
	(363545, 124, '2015-01-15 01:08:23.000000', 'consum', 0.0210, 'lps'),
	(363546, 124, '2015-01-15 01:08:24.000000', 'consum', 0.0213, 'lps'),
	(363547, 124, '2015-01-15 01:08:25.000000', 'consum', 0.0226, 'lps'),
	(363548, 124, '2015-01-15 01:08:26.000000', 'consum', 0.0214, 'lps'),
	(363549, 124, '2015-01-15 01:08:27.000000', 'consum', 0.0225, 'lps'),
	(363550, 124, '2015-01-15 01:08:28.000000', 'consum', 0.0211, 'lps'),
	(363551, 124, '2015-01-15 01:08:29.000000', 'consum', 0.0213, 'lps'),
	(363552, 124, '2015-01-15 01:08:30.000000', 'consum', 0.0222, 'lps'),
	(363553, 124, '2015-01-15 01:08:31.000000', 'consum', 0.0218, 'lps'),
	(363554, 124, '2015-01-15 01:08:32.000000', 'consum', 0.0213, 'lps'),
	(363555, 124, '2015-01-15 01:08:33.000000', 'consum', 0.0225, 'lps'),
	(363556, 124, '2015-01-15 01:08:34.000000', 'consum', 0.0211, 'lps'),
	(363557, 124, '2015-01-15 01:08:35.000000', 'consum', 0.0214, 'lps'),
	(363558, 124, '2015-01-15 01:08:36.000000', 'consum', 0.0229, 'lps'),
	(363559, 124, '2015-01-15 01:08:37.000000', 'consum', 0.0228, 'lps'),
	(363560, 124, '2015-01-15 01:08:38.000000', 'consum', 0.0219, 'lps'),
	(363561, 124, '2015-01-15 01:08:39.000000', 'consum', 0.0223, 'lps'),
	(363562, 124, '2015-01-15 01:08:40.000000', 'consum', 0.0229, 'lps'),
	(363563, 124, '2015-01-15 01:08:41.000000', 'consum', 0.0220, 'lps'),
	(363564, 124, '2015-01-15 01:08:42.000000', 'consum', 0.0225, 'lps'),
	(363565, 124, '2015-01-15 01:08:43.000000', 'consum', 0.0214, 'lps'),
	(363566, 124, '2015-01-15 01:08:44.000000', 'consum', 0.0231, 'lps'),
	(363567, 124, '2015-01-15 01:08:45.000000', 'consum', 0.0212, 'lps'),
	(363568, 124, '2015-01-15 01:08:46.000000', 'consum', 0.0224, 'lps'),
	(363569, 124, '2015-01-15 01:08:47.000000', 'consum', 0.0231, 'lps'),
	(363570, 124, '2015-01-15 01:08:48.000000', 'consum', 0.0231, 'lps'),
	(363571, 124, '2015-01-15 01:08:49.000000', 'consum', 0.0227, 'lps'),
	(363572, 124, '2015-01-15 01:08:50.000000', 'consum', 0.0214, 'lps'),
	(363573, 124, '2015-01-15 01:08:51.000000', 'consum', 0.0221, 'lps'),
	(363574, 124, '2015-01-15 01:08:52.000000', 'consum', 0.0212, 'lps'),
	(363575, 124, '2015-01-15 01:08:53.000000', 'consum', 0.0210, 'lps'),
	(363576, 124, '2015-01-15 01:08:54.000000', 'consum', 0.0225, 'lps'),
	(363577, 124, '2015-01-15 01:08:55.000000', 'consum', 0.0220, 'lps'),
	(363578, 124, '2015-01-15 01:08:56.000000', 'consum', 0.0213, 'lps'),
	(363579, 124, '2015-01-15 01:08:57.000000', 'consum', 0.0221, 'lps'),
	(363580, 124, '2015-01-15 01:08:58.000000', 'consum', 0.0210, 'lps'),
	(363581, 124, '2015-01-15 01:08:59.000000', 'consum', 0.0221, 'lps'),
	(363582, 124, '2015-01-15 01:09:00.000000', 'consum', 0.0225, 'lps'),
	(363583, 124, '2015-01-15 01:09:01.000000', 'consum', 0.0227, 'lps'),
	(363584, 124, '2015-01-15 01:09:02.000000', 'consum', 0.0228, 'lps'),
	(363585, 124, '2015-01-15 01:09:03.000000', 'consum', 0.0230, 'lps'),
	(363586, 124, '2015-01-15 01:09:04.000000', 'consum', 0.0213, 'lps'),
	(363587, 124, '2015-01-15 01:09:05.000000', 'consum', 0.0230, 'lps'),
	(363588, 124, '2015-01-15 01:09:06.000000', 'consum', 0.0214, 'lps'),
	(363589, 124, '2015-01-15 01:09:07.000000', 'consum', 0.0215, 'lps'),
	(363590, 124, '2015-01-15 01:09:08.000000', 'consum', 0.0223, 'lps'),
	(363591, 124, '2015-01-15 01:09:09.000000', 'consum', 0.0216, 'lps'),
	(363592, 124, '2015-01-15 01:09:10.000000', 'consum', 0.0223, 'lps'),
	(363593, 124, '2015-01-15 01:09:11.000000', 'consum', 0.0213, 'lps'),
	(363594, 124, '2015-01-15 01:09:12.000000', 'consum', 0.0210, 'lps'),
	(363595, 124, '2015-01-15 01:09:13.000000', 'consum', 0.0222, 'lps'),
	(363596, 124, '2015-01-15 01:09:14.000000', 'consum', 0.0225, 'lps'),
	(363597, 124, '2015-01-15 01:09:15.000000', 'consum', 0.0230, 'lps'),
	(363598, 124, '2015-01-15 01:09:16.000000', 'consum', 0.0223, 'lps'),
	(363599, 124, '2015-01-15 01:09:17.000000', 'consum', 0.0213, 'lps'),
	(363600, 124, '2015-01-15 01:09:18.000000', 'consum', 0.0210, 'lps'),
	(363601, 124, '2015-01-15 01:09:19.000000', 'consum', 0.0222, 'lps'),
	(363602, 124, '2015-01-15 01:09:20.000000', 'consum', 0.0228, 'lps'),
	(363603, 124, '2015-01-15 01:09:21.000000', 'consum', 0.0222, 'lps'),
	(363604, 124, '2015-01-15 01:09:22.000000', 'consum', 0.0215, 'lps'),
	(363605, 124, '2015-01-15 01:09:23.000000', 'consum', 0.0220, 'lps'),
	(363606, 124, '2015-01-15 01:09:24.000000', 'consum', 0.0225, 'lps'),
	(363607, 124, '2015-01-15 01:09:25.000000', 'consum', 0.0212, 'lps'),
	(363608, 124, '2015-01-15 01:09:26.000000', 'consum', 0.0220, 'lps'),
	(363609, 124, '2015-01-15 01:09:27.000000', 'consum', 0.0231, 'lps'),
	(363610, 124, '2015-01-15 01:09:28.000000', 'consum', 0.0219, 'lps'),
	(363611, 124, '2015-01-15 01:09:29.000000', 'consum', 0.0215, 'lps'),
	(363612, 124, '2015-01-15 01:09:30.000000', 'consum', 0.0230, 'lps'),
	(363613, 124, '2015-01-15 01:09:31.000000', 'consum', 0.0231, 'lps'),
	(363614, 124, '2015-01-15 01:09:32.000000', 'consum', 0.0211, 'lps'),
	(363615, 124, '2015-01-15 01:09:33.000000', 'consum', 0.0220, 'lps'),
	(363616, 124, '2015-01-15 01:09:34.000000', 'consum', 0.0213, 'lps'),
	(363617, 124, '2015-01-15 01:09:35.000000', 'consum', 0.0217, 'lps'),
	(363618, 124, '2015-01-15 01:09:36.000000', 'consum', 0.0215, 'lps'),
	(363619, 124, '2015-01-15 01:09:37.000000', 'consum', 0.0214, 'lps'),
	(363620, 124, '2015-01-15 01:09:38.000000', 'consum', 0.0215, 'lps'),
	(363621, 124, '2015-01-15 01:09:39.000000', 'consum', 0.0223, 'lps'),
	(363622, 124, '2015-01-15 01:09:40.000000', 'consum', 0.0217, 'lps'),
	(363623, 124, '2015-01-15 01:09:41.000000', 'consum', 0.0228, 'lps'),
	(363624, 124, '2015-01-15 01:09:42.000000', 'consum', 0.0214, 'lps'),
	(363625, 124, '2015-01-15 01:09:43.000000', 'consum', 0.0221, 'lps'),
	(363626, 124, '2015-01-15 01:09:44.000000', 'consum', 0.0231, 'lps'),
	(363627, 124, '2015-01-15 01:09:45.000000', 'consum', 0.0218, 'lps'),
	(363628, 124, '2015-01-15 01:09:46.000000', 'consum', 0.0230, 'lps'),
	(363629, 124, '2015-01-15 01:09:47.000000', 'consum', 0.0221, 'lps'),
	(363630, 124, '2015-01-15 01:09:48.000000', 'consum', 0.0226, 'lps'),
	(363631, 124, '2015-01-15 01:09:49.000000', 'consum', 0.0216, 'lps'),
	(363632, 124, '2015-01-15 01:09:50.000000', 'consum', 0.0213, 'lps'),
	(363633, 124, '2015-01-15 01:09:51.000000', 'consum', 0.0228, 'lps'),
	(363634, 124, '2015-01-15 01:09:52.000000', 'consum', 0.0228, 'lps'),
	(363635, 124, '2015-01-15 01:09:53.000000', 'consum', 0.0222, 'lps'),
	(363636, 124, '2015-01-15 01:09:54.000000', 'consum', 0.0217, 'lps'),
	(363637, 124, '2015-01-15 01:09:55.000000', 'consum', 0.0210, 'lps'),
	(363638, 124, '2015-01-15 01:09:56.000000', 'consum', 0.0210, 'lps'),
	(363639, 124, '2015-01-15 01:09:57.000000', 'consum', 0.0213, 'lps'),
	(363640, 124, '2015-01-15 01:09:58.000000', 'consum', 0.0227, 'lps'),
	(363641, 124, '2015-01-15 01:09:59.000000', 'consum', 0.0217, 'lps'),
	(363642, 124, '2015-01-15 01:10:00.000000', 'consum', 0.0217, 'lps'),
	(363643, 124, '2015-01-15 01:10:01.000000', 'consum', 0.0226, 'lps'),
	(363644, 124, '2015-01-15 01:10:02.000000', 'consum', 0.0225, 'lps'),
	(363645, 124, '2015-01-15 01:10:03.000000', 'consum', 0.0217, 'lps'),
	(363646, 124, '2015-01-15 01:10:04.000000', 'consum', 0.0221, 'lps'),
	(363647, 124, '2015-01-15 01:10:05.000000', 'consum', 0.0223, 'lps'),
	(363648, 124, '2015-01-15 01:10:06.000000', 'consum', 0.0219, 'lps'),
	(363649, 124, '2015-01-15 01:10:07.000000', 'consum', 0.0219, 'lps'),
	(363650, 124, '2015-01-15 01:10:08.000000', 'consum', 0.0229, 'lps'),
	(363651, 124, '2015-01-15 01:10:09.000000', 'consum', 0.0213, 'lps'),
	(363652, 124, '2015-01-15 01:10:10.000000', 'consum', 0.0210, 'lps'),
	(363653, 124, '2015-01-15 01:10:11.000000', 'consum', 0.0226, 'lps'),
	(363654, 124, '2015-01-15 01:10:12.000000', 'consum', 0.0221, 'lps'),
	(363655, 124, '2015-01-15 01:10:13.000000', 'consum', 0.0221, 'lps'),
	(363656, 124, '2015-01-15 01:10:14.000000', 'consum', 0.0210, 'lps'),
	(363657, 124, '2015-01-15 01:10:15.000000', 'consum', 0.0222, 'lps'),
	(363658, 124, '2015-01-15 01:10:16.000000', 'consum', 0.0224, 'lps'),
	(363659, 124, '2015-01-15 01:10:17.000000', 'consum', 0.0225, 'lps'),
	(363660, 124, '2015-01-15 01:10:18.000000', 'consum', 0.0222, 'lps'),
	(363661, 124, '2015-01-15 01:10:19.000000', 'consum', 0.0226, 'lps'),
	(363662, 124, '2015-01-15 01:10:20.000000', 'consum', 0.0231, 'lps'),
	(363663, 124, '2015-01-15 01:10:21.000000', 'consum', 0.0224, 'lps'),
	(363664, 124, '2015-01-15 01:10:22.000000', 'consum', 0.0216, 'lps'),
	(363665, 124, '2015-01-15 01:10:23.000000', 'consum', 0.0222, 'lps'),
	(363666, 124, '2015-01-15 01:10:24.000000', 'consum', 0.0230, 'lps'),
	(363667, 124, '2015-01-15 01:10:25.000000', 'consum', 0.0210, 'lps'),
	(363668, 124, '2015-01-15 01:10:26.000000', 'consum', 0.0214, 'lps'),
	(363669, 124, '2015-01-15 01:10:27.000000', 'consum', 0.0210, 'lps'),
	(363670, 124, '2015-01-15 01:10:28.000000', 'consum', 0.0221, 'lps'),
	(363671, 124, '2015-01-15 01:10:29.000000', 'consum', 0.0219, 'lps'),
	(363672, 124, '2015-01-15 01:10:30.000000', 'consum', 0.0224, 'lps'),
	(363673, 124, '2015-01-15 01:10:31.000000', 'consum', 0.0210, 'lps'),
	(363674, 124, '2015-01-15 01:10:32.000000', 'consum', 0.0210, 'lps'),
	(363675, 124, '2015-01-15 01:10:33.000000', 'consum', 0.0212, 'lps'),
	(363676, 124, '2015-01-15 01:10:34.000000', 'consum', 0.0221, 'lps'),
	(363677, 124, '2015-01-15 01:10:35.000000', 'consum', 0.0215, 'lps'),
	(363678, 124, '2015-01-15 01:10:36.000000', 'consum', 0.0223, 'lps'),
	(363679, 124, '2015-01-15 01:10:37.000000', 'consum', 0.0217, 'lps'),
	(363680, 124, '2015-01-15 01:10:38.000000', 'consum', 0.0231, 'lps'),
	(363681, 124, '2015-01-15 01:10:39.000000', 'consum', 0.0226, 'lps'),
	(363682, 124, '2015-01-15 01:10:40.000000', 'consum', 0.0227, 'lps'),
	(363683, 124, '2015-01-15 01:10:41.000000', 'consum', 0.0226, 'lps'),
	(363684, 124, '2015-01-15 01:10:42.000000', 'consum', 0.0217, 'lps'),
	(363685, 124, '2015-01-15 01:10:43.000000', 'consum', 0.0218, 'lps'),
	(363686, 124, '2015-01-15 01:10:44.000000', 'consum', 0.0211, 'lps'),
	(363687, 124, '2015-01-15 01:10:45.000000', 'consum', 0.0212, 'lps'),
	(363688, 124, '2015-01-15 01:10:46.000000', 'consum', 0.0218, 'lps'),
	(363689, 124, '2015-01-15 01:10:47.000000', 'consum', 0.0221, 'lps'),
	(363690, 124, '2015-01-15 01:10:48.000000', 'consum', 0.0222, 'lps'),
	(363691, 124, '2015-01-15 01:10:49.000000', 'consum', 0.0213, 'lps'),
	(363692, 124, '2015-01-15 01:10:50.000000', 'consum', 0.0212, 'lps'),
	(363693, 124, '2015-01-15 01:10:51.000000', 'consum', 0.0212, 'lps'),
	(363694, 124, '2015-01-15 01:10:52.000000', 'consum', 0.0215, 'lps'),
	(363695, 124, '2015-01-15 01:10:53.000000', 'consum', 0.0229, 'lps'),
	(363696, 124, '2015-01-15 01:10:54.000000', 'consum', 0.0224, 'lps'),
	(363697, 124, '2015-01-15 01:10:55.000000', 'consum', 0.0224, 'lps'),
	(363698, 124, '2015-01-15 01:10:56.000000', 'consum', 0.0216, 'lps'),
	(363699, 124, '2015-01-15 01:10:57.000000', 'consum', 0.0221, 'lps'),
	(363700, 124, '2015-01-15 01:10:58.000000', 'consum', 0.0225, 'lps'),
	(363701, 124, '2015-01-15 01:10:59.000000', 'consum', 0.0210, 'lps'),
	(363702, 124, '2015-01-15 01:11:00.000000', 'consum', 0.0210, 'lps'),
	(363703, 124, '2015-01-15 01:11:01.000000', 'consum', 0.0212, 'lps'),
	(363704, 124, '2015-01-15 01:11:02.000000', 'consum', 0.0217, 'lps'),
	(363705, 124, '2015-01-15 01:11:03.000000', 'consum', 0.0217, 'lps'),
	(363706, 124, '2015-01-15 01:11:04.000000', 'consum', 0.0227, 'lps'),
	(363707, 124, '2015-01-15 01:11:05.000000', 'consum', 0.0229, 'lps'),
	(363708, 124, '2015-01-15 01:11:06.000000', 'consum', 0.0210, 'lps'),
	(363709, 124, '2015-01-15 01:11:07.000000', 'consum', 0.0222, 'lps'),
	(363710, 124, '2015-01-15 01:11:08.000000', 'consum', 0.0226, 'lps'),
	(363711, 124, '2015-01-15 01:11:09.000000', 'consum', 0.0210, 'lps'),
	(363712, 124, '2015-01-15 01:11:10.000000', 'consum', 0.0227, 'lps'),
	(363713, 124, '2015-01-15 01:11:11.000000', 'consum', 0.0230, 'lps'),
	(363714, 124, '2015-01-15 01:11:12.000000', 'consum', 0.0214, 'lps'),
	(363715, 124, '2015-01-15 01:11:13.000000', 'consum', 0.0216, 'lps'),
	(363716, 124, '2015-01-15 01:11:14.000000', 'consum', 0.0227, 'lps'),
	(363717, 124, '2015-01-15 01:11:15.000000', 'consum', 0.0214, 'lps'),
	(363718, 124, '2015-01-15 01:11:16.000000', 'consum', 0.0222, 'lps'),
	(363719, 124, '2015-01-15 01:11:17.000000', 'consum', 0.0217, 'lps'),
	(363720, 124, '2015-01-15 01:11:18.000000', 'consum', 0.0228, 'lps'),
	(363721, 124, '2015-01-15 01:11:19.000000', 'consum', 0.0215, 'lps'),
	(363722, 124, '2015-01-15 01:11:20.000000', 'consum', 0.0225, 'lps'),
	(363723, 124, '2015-01-15 01:11:21.000000', 'consum', 0.0228, 'lps'),
	(363724, 124, '2015-01-15 01:11:22.000000', 'consum', 0.0210, 'lps'),
	(363725, 124, '2015-01-15 01:11:23.000000', 'consum', 0.0221, 'lps'),
	(363726, 124, '2015-01-15 01:11:24.000000', 'consum', 0.0224, 'lps'),
	(363727, 124, '2015-01-15 01:11:25.000000', 'consum', 0.0225, 'lps'),
	(363728, 124, '2015-01-15 01:11:26.000000', 'consum', 0.0221, 'lps'),
	(363729, 124, '2015-01-15 01:11:27.000000', 'consum', 0.0220, 'lps'),
	(363730, 124, '2015-01-15 01:11:28.000000', 'consum', 0.0229, 'lps'),
	(363731, 124, '2015-01-15 01:11:29.000000', 'consum', 0.0210, 'lps'),
	(363732, 124, '2015-01-15 01:11:30.000000', 'consum', 0.0220, 'lps'),
	(363733, 124, '2015-01-15 01:11:31.000000', 'consum', 0.0215, 'lps'),
	(363734, 124, '2015-01-15 01:11:32.000000', 'consum', 0.0226, 'lps'),
	(363735, 124, '2015-01-15 01:11:33.000000', 'consum', 0.0211, 'lps'),
	(363736, 124, '2015-01-15 01:11:34.000000', 'consum', 0.0213, 'lps'),
	(363737, 124, '2015-01-15 01:11:35.000000', 'consum', 0.0223, 'lps'),
	(363738, 124, '2015-01-15 01:11:36.000000', 'consum', 0.0220, 'lps'),
	(363739, 124, '2015-01-15 01:11:37.000000', 'consum', 0.0223, 'lps'),
	(363740, 124, '2015-01-15 01:11:38.000000', 'consum', 0.0225, 'lps'),
	(363741, 124, '2015-01-15 01:11:39.000000', 'consum', 0.0224, 'lps'),
	(363742, 124, '2015-01-15 01:11:40.000000', 'consum', 0.0212, 'lps'),
	(363743, 124, '2015-01-15 01:11:41.000000', 'consum', 0.0222, 'lps'),
	(363744, 124, '2015-01-15 01:11:42.000000', 'consum', 0.0219, 'lps'),
	(363745, 124, '2015-01-15 01:11:43.000000', 'consum', 0.0222, 'lps'),
	(363746, 124, '2015-01-15 01:11:44.000000', 'consum', 0.0222, 'lps'),
	(363747, 124, '2015-01-15 01:11:45.000000', 'consum', 0.0213, 'lps'),
	(363748, 124, '2015-01-15 01:11:46.000000', 'consum', 0.0211, 'lps'),
	(363749, 124, '2015-01-15 01:11:47.000000', 'consum', 0.0228, 'lps'),
	(363750, 124, '2015-01-15 01:11:48.000000', 'consum', 0.0212, 'lps'),
	(363751, 124, '2015-01-15 01:11:49.000000', 'consum', 0.0230, 'lps'),
	(363752, 124, '2015-01-15 01:11:50.000000', 'consum', 0.0215, 'lps'),
	(363753, 124, '2015-01-15 01:11:51.000000', 'consum', 0.0223, 'lps'),
	(363754, 124, '2015-01-15 01:11:52.000000', 'consum', 0.0214, 'lps'),
	(363755, 124, '2015-01-15 01:11:53.000000', 'consum', 0.0216, 'lps'),
	(363756, 124, '2015-01-15 01:11:54.000000', 'consum', 0.0229, 'lps'),
	(363757, 124, '2015-01-15 01:11:55.000000', 'consum', 0.0218, 'lps'),
	(363758, 124, '2015-01-15 01:11:56.000000', 'consum', 0.0218, 'lps'),
	(363759, 124, '2015-01-15 01:11:57.000000', 'consum', 0.0228, 'lps'),
	(363760, 124, '2015-01-15 01:11:58.000000', 'consum', 0.0229, 'lps'),
	(363761, 124, '2015-01-15 01:11:59.000000', 'consum', 0.0231, 'lps'),
	(363762, 124, '2015-01-15 01:12:00.000000', 'consum', 0.0214, 'lps'),
	(363763, 124, '2015-01-15 01:12:01.000000', 'consum', 0.0213, 'lps'),
	(363764, 124, '2015-01-15 01:12:02.000000', 'consum', 0.0214, 'lps'),
	(363765, 124, '2015-01-15 01:12:03.000000', 'consum', 0.0219, 'lps'),
	(363766, 124, '2015-01-15 01:12:04.000000', 'consum', 0.0223, 'lps'),
	(363767, 124, '2015-01-15 01:12:05.000000', 'consum', 0.0228, 'lps'),
	(363768, 124, '2015-01-15 01:12:06.000000', 'consum', 0.0215, 'lps'),
	(363769, 124, '2015-01-15 01:12:07.000000', 'consum', 0.0228, 'lps'),
	(363770, 124, '2015-01-15 01:12:08.000000', 'consum', 0.0220, 'lps'),
	(363771, 124, '2015-01-15 01:12:09.000000', 'consum', 0.0227, 'lps'),
	(363772, 124, '2015-01-15 01:12:10.000000', 'consum', 0.0224, 'lps'),
	(363773, 124, '2015-01-15 01:12:11.000000', 'consum', 0.0227, 'lps'),
	(363774, 124, '2015-01-15 01:12:12.000000', 'consum', 0.0231, 'lps'),
	(363775, 124, '2015-01-15 01:12:13.000000', 'consum', 0.0221, 'lps'),
	(363776, 124, '2015-01-15 01:12:14.000000', 'consum', 0.0224, 'lps'),
	(363777, 124, '2015-01-15 01:12:15.000000', 'consum', 0.0228, 'lps'),
	(363778, 124, '2015-01-15 01:12:16.000000', 'consum', 0.0212, 'lps'),
	(363779, 124, '2015-01-15 01:12:17.000000', 'consum', 0.0212, 'lps'),
	(363780, 124, '2015-01-15 01:12:18.000000', 'consum', 0.0212, 'lps'),
	(363781, 124, '2015-01-15 01:12:19.000000', 'consum', 0.0218, 'lps'),
	(363782, 124, '2015-01-15 01:12:20.000000', 'consum', 0.0221, 'lps'),
	(363783, 124, '2015-01-15 01:12:21.000000', 'consum', 0.0218, 'lps'),
	(363784, 124, '2015-01-15 01:12:22.000000', 'consum', 0.0220, 'lps'),
	(363785, 124, '2015-01-15 01:12:23.000000', 'consum', 0.0212, 'lps'),
	(363786, 124, '2015-01-15 01:12:24.000000', 'consum', 0.0212, 'lps'),
	(363787, 124, '2015-01-15 01:12:25.000000', 'consum', 0.0217, 'lps'),
	(363788, 124, '2015-01-15 01:12:26.000000', 'consum', 0.0216, 'lps'),
	(363789, 124, '2015-01-15 01:12:27.000000', 'consum', 0.0221, 'lps'),
	(363790, 124, '2015-01-15 01:12:28.000000', 'consum', 0.0224, 'lps'),
	(363791, 124, '2015-01-15 01:12:29.000000', 'consum', 0.0226, 'lps'),
	(363792, 124, '2015-01-15 01:12:30.000000', 'consum', 0.0226, 'lps'),
	(363793, 124, '2015-01-15 01:12:31.000000', 'consum', 0.0221, 'lps'),
	(363794, 124, '2015-01-15 01:12:32.000000', 'consum', 0.0218, 'lps'),
	(363795, 124, '2015-01-15 01:12:33.000000', 'consum', 0.0217, 'lps'),
	(363796, 124, '2015-01-15 01:12:34.000000', 'consum', 0.0220, 'lps'),
	(363797, 124, '2015-01-15 01:12:35.000000', 'consum', 0.0218, 'lps'),
	(363798, 124, '2015-01-15 01:12:36.000000', 'consum', 0.0222, 'lps'),
	(363799, 124, '2015-01-15 01:12:37.000000', 'consum', 0.0225, 'lps'),
	(363800, 124, '2015-01-15 01:12:38.000000', 'consum', 0.0228, 'lps'),
	(363801, 124, '2015-01-15 01:12:39.000000', 'consum', 0.0211, 'lps'),
	(363802, 124, '2015-01-15 01:12:40.000000', 'consum', 0.0229, 'lps'),
	(363803, 124, '2015-01-15 01:12:41.000000', 'consum', 0.0212, 'lps'),
	(363804, 124, '2015-01-15 01:12:42.000000', 'consum', 0.0229, 'lps'),
	(363805, 124, '2015-01-15 01:12:43.000000', 'consum', 0.0210, 'lps'),
	(363806, 124, '2015-01-15 01:12:44.000000', 'consum', 0.0223, 'lps'),
	(363807, 124, '2015-01-15 01:12:45.000000', 'consum', 0.0230, 'lps'),
	(363808, 124, '2015-01-15 01:12:46.000000', 'consum', 0.0226, 'lps'),
	(363809, 124, '2015-01-15 01:12:47.000000', 'consum', 0.0230, 'lps'),
	(363810, 124, '2015-01-15 01:12:48.000000', 'consum', 0.0220, 'lps'),
	(363811, 124, '2015-01-15 01:12:49.000000', 'consum', 0.0222, 'lps'),
	(363812, 124, '2015-01-15 01:12:50.000000', 'consum', 0.0218, 'lps'),
	(363813, 124, '2015-01-15 01:12:51.000000', 'consum', 0.0215, 'lps'),
	(363814, 124, '2015-01-15 01:12:52.000000', 'consum', 0.0213, 'lps'),
	(363815, 124, '2015-01-15 01:12:53.000000', 'consum', 0.0231, 'lps'),
	(363816, 124, '2015-01-15 01:12:54.000000', 'consum', 0.0217, 'lps'),
	(363817, 124, '2015-01-15 01:12:55.000000', 'consum', 0.0230, 'lps'),
	(363818, 124, '2015-01-15 01:12:56.000000', 'consum', 0.0222, 'lps'),
	(363819, 124, '2015-01-15 01:12:57.000000', 'consum', 0.0230, 'lps'),
	(363820, 124, '2015-01-15 01:12:58.000000', 'consum', 0.0212, 'lps'),
	(363821, 124, '2015-01-15 01:12:59.000000', 'consum', 0.0226, 'lps'),
	(363822, 124, '2015-01-15 01:13:00.000000', 'consum', 0.0219, 'lps'),
	(363823, 124, '2015-01-15 01:13:01.000000', 'consum', 0.0229, 'lps'),
	(363824, 124, '2015-01-15 01:13:02.000000', 'consum', 0.0212, 'lps'),
	(363825, 124, '2015-01-15 01:13:03.000000', 'consum', 0.0231, 'lps'),
	(363826, 124, '2015-01-15 01:13:04.000000', 'consum', 0.0220, 'lps'),
	(363827, 124, '2015-01-15 01:13:05.000000', 'consum', 0.0218, 'lps'),
	(363828, 124, '2015-01-15 01:13:06.000000', 'consum', 0.0223, 'lps'),
	(363829, 124, '2015-01-15 01:13:07.000000', 'consum', 0.0227, 'lps'),
	(363830, 124, '2015-01-15 01:13:08.000000', 'consum', 0.0215, 'lps'),
	(363831, 124, '2015-01-15 01:13:09.000000', 'consum', 0.0229, 'lps'),
	(363832, 124, '2015-01-15 01:13:10.000000', 'consum', 0.0223, 'lps'),
	(363833, 124, '2015-01-15 01:13:11.000000', 'consum', 0.0217, 'lps'),
	(363834, 124, '2015-01-15 01:13:12.000000', 'consum', 0.0229, 'lps'),
	(363835, 124, '2015-01-15 01:13:13.000000', 'consum', 0.0218, 'lps'),
	(363836, 124, '2015-01-15 01:13:14.000000', 'consum', 0.0218, 'lps'),
	(363837, 124, '2015-01-15 01:13:15.000000', 'consum', 0.0224, 'lps'),
	(363838, 124, '2015-01-15 01:13:16.000000', 'consum', 0.0215, 'lps'),
	(363839, 124, '2015-01-15 01:13:17.000000', 'consum', 0.0215, 'lps'),
	(363840, 124, '2015-01-15 01:13:18.000000', 'consum', 0.0218, 'lps'),
	(363841, 124, '2015-01-15 01:13:19.000000', 'consum', 0.0216, 'lps'),
	(363842, 124, '2015-01-15 01:13:20.000000', 'consum', 0.0217, 'lps'),
	(363843, 124, '2015-01-15 01:13:21.000000', 'consum', 0.0227, 'lps'),
	(363844, 124, '2015-01-15 01:13:22.000000', 'consum', 0.0230, 'lps'),
	(363845, 124, '2015-01-15 01:13:23.000000', 'consum', 0.0215, 'lps'),
	(363846, 124, '2015-01-15 01:13:24.000000', 'consum', 0.0220, 'lps'),
	(363847, 124, '2015-01-15 01:13:25.000000', 'consum', 0.0225, 'lps'),
	(363848, 124, '2015-01-15 01:13:26.000000', 'consum', 0.0210, 'lps'),
	(363849, 124, '2015-01-15 01:13:27.000000', 'consum', 0.0211, 'lps'),
	(363850, 124, '2015-01-15 01:13:28.000000', 'consum', 0.0216, 'lps'),
	(363851, 124, '2015-01-15 01:13:29.000000', 'consum', 0.0216, 'lps'),
	(363852, 124, '2015-01-15 01:13:30.000000', 'consum', 0.0221, 'lps'),
	(363853, 124, '2015-01-15 01:13:31.000000', 'consum', 0.0227, 'lps'),
	(363854, 124, '2015-01-15 01:13:32.000000', 'consum', 0.0219, 'lps'),
	(363855, 124, '2015-01-15 01:13:33.000000', 'consum', 0.0225, 'lps'),
	(363856, 124, '2015-01-15 01:13:34.000000', 'consum', 0.0216, 'lps'),
	(363857, 124, '2015-01-15 01:13:35.000000', 'consum', 0.0217, 'lps'),
	(363858, 124, '2015-01-15 01:13:36.000000', 'consum', 0.0228, 'lps'),
	(363859, 124, '2015-01-15 01:13:37.000000', 'consum', 0.0212, 'lps'),
	(363860, 124, '2015-01-15 01:13:38.000000', 'consum', 0.0212, 'lps'),
	(363861, 124, '2015-01-15 01:13:39.000000', 'consum', 0.0212, 'lps'),
	(363862, 124, '2015-01-15 01:13:40.000000', 'consum', 0.0215, 'lps'),
	(363863, 124, '2015-01-15 01:13:41.000000', 'consum', 0.0231, 'lps'),
	(363864, 124, '2015-01-15 01:13:42.000000', 'consum', 0.0210, 'lps'),
	(363865, 124, '2015-01-15 01:13:43.000000', 'consum', 0.0216, 'lps'),
	(363866, 124, '2015-01-15 01:13:44.000000', 'consum', 0.0217, 'lps'),
	(363867, 124, '2015-01-15 01:13:45.000000', 'consum', 0.0228, 'lps'),
	(363868, 124, '2015-01-15 01:13:46.000000', 'consum', 0.0214, 'lps'),
	(363869, 124, '2015-01-15 01:13:47.000000', 'consum', 0.0220, 'lps'),
	(363870, 124, '2015-01-15 01:13:48.000000', 'consum', 0.0226, 'lps'),
	(363871, 124, '2015-01-15 01:13:49.000000', 'consum', 0.0219, 'lps'),
	(363872, 124, '2015-01-15 01:13:50.000000', 'consum', 0.0228, 'lps'),
	(363873, 124, '2015-01-15 01:13:51.000000', 'consum', 0.0230, 'lps'),
	(363874, 124, '2015-01-15 01:13:52.000000', 'consum', 0.0211, 'lps'),
	(363875, 124, '2015-01-15 01:13:53.000000', 'consum', 0.0222, 'lps'),
	(363876, 124, '2015-01-15 01:13:54.000000', 'consum', 0.0225, 'lps'),
	(363877, 124, '2015-01-15 01:13:55.000000', 'consum', 0.0227, 'lps'),
	(363878, 124, '2015-01-15 01:13:56.000000', 'consum', 0.0227, 'lps'),
	(363879, 124, '2015-01-15 01:13:57.000000', 'consum', 0.0224, 'lps'),
	(363880, 124, '2015-01-15 01:13:58.000000', 'consum', 0.0231, 'lps'),
	(363881, 124, '2015-01-15 01:13:59.000000', 'consum', 0.0228, 'lps'),
	(363882, 124, '2015-01-15 01:14:00.000000', 'consum', 0.0214, 'lps'),
	(363883, 124, '2015-01-15 01:14:01.000000', 'consum', 0.0223, 'lps'),
	(363884, 124, '2015-01-15 01:14:02.000000', 'consum', 0.0220, 'lps'),
	(363885, 124, '2015-01-15 01:14:03.000000', 'consum', 0.0221, 'lps'),
	(363886, 124, '2015-01-15 01:14:04.000000', 'consum', 0.0213, 'lps'),
	(363887, 124, '2015-01-15 01:14:05.000000', 'consum', 0.0214, 'lps'),
	(363888, 124, '2015-01-15 01:14:06.000000', 'consum', 0.0223, 'lps'),
	(363889, 124, '2015-01-15 01:14:07.000000', 'consum', 0.0219, 'lps'),
	(363890, 124, '2015-01-15 01:14:08.000000', 'consum', 0.0215, 'lps'),
	(363891, 124, '2015-01-15 01:14:09.000000', 'consum', 0.0210, 'lps'),
	(363892, 124, '2015-01-15 01:14:10.000000', 'consum', 0.0216, 'lps'),
	(363893, 124, '2015-01-15 01:14:11.000000', 'consum', 0.0217, 'lps'),
	(363894, 124, '2015-01-15 01:14:12.000000', 'consum', 0.0230, 'lps'),
	(363895, 124, '2015-01-15 01:14:13.000000', 'consum', 0.0222, 'lps'),
	(363896, 124, '2015-01-15 01:14:14.000000', 'consum', 0.0213, 'lps'),
	(363897, 124, '2015-01-15 01:14:15.000000', 'consum', 0.0231, 'lps'),
	(363898, 124, '2015-01-15 01:14:16.000000', 'consum', 0.0220, 'lps'),
	(363899, 124, '2015-01-15 01:14:17.000000', 'consum', 0.0221, 'lps'),
	(363900, 124, '2015-01-15 01:14:18.000000', 'consum', 0.0213, 'lps'),
	(363901, 124, '2015-01-15 01:14:19.000000', 'consum', 0.0212, 'lps'),
	(363902, 124, '2015-01-15 01:14:20.000000', 'consum', 0.0213, 'lps'),
	(363903, 124, '2015-01-15 01:14:21.000000', 'consum', 0.0220, 'lps'),
	(363904, 124, '2015-01-15 01:14:22.000000', 'consum', 0.0231, 'lps'),
	(363905, 124, '2015-01-15 01:14:23.000000', 'consum', 0.0218, 'lps'),
	(363906, 124, '2015-01-15 01:14:24.000000', 'consum', 0.0211, 'lps'),
	(363907, 124, '2015-01-15 01:14:25.000000', 'consum', 0.0211, 'lps'),
	(363908, 124, '2015-01-15 01:14:26.000000', 'consum', 0.0214, 'lps'),
	(363909, 124, '2015-01-15 01:14:27.000000', 'consum', 0.0227, 'lps'),
	(363910, 124, '2015-01-15 01:14:28.000000', 'consum', 0.0217, 'lps'),
	(363911, 124, '2015-01-15 01:14:29.000000', 'consum', 0.0217, 'lps'),
	(363912, 124, '2015-01-15 01:14:30.000000', 'consum', 0.0226, 'lps'),
	(363913, 124, '2015-01-15 01:14:31.000000', 'consum', 0.0223, 'lps'),
	(363914, 124, '2015-01-15 01:14:32.000000', 'consum', 0.0230, 'lps'),
	(363915, 124, '2015-01-15 01:14:33.000000', 'consum', 0.0227, 'lps'),
	(363916, 124, '2015-01-15 01:14:34.000000', 'consum', 0.0214, 'lps'),
	(363917, 124, '2015-01-15 01:14:35.000000', 'consum', 0.0221, 'lps'),
	(363918, 124, '2015-01-15 01:14:36.000000', 'consum', 0.0210, 'lps'),
	(363919, 124, '2015-01-15 01:14:37.000000', 'consum', 0.0222, 'lps'),
	(363920, 124, '2015-01-15 01:14:38.000000', 'consum', 0.0226, 'lps'),
	(363921, 124, '2015-01-15 01:14:39.000000', 'consum', 0.0210, 'lps'),
	(363922, 124, '2015-01-15 01:14:40.000000', 'consum', 0.0228, 'lps'),
	(363923, 124, '2015-01-15 01:14:41.000000', 'consum', 0.0214, 'lps'),
	(363924, 124, '2015-01-15 01:14:42.000000', 'consum', 0.0220, 'lps'),
	(363925, 124, '2015-01-15 01:14:43.000000', 'consum', 0.0227, 'lps'),
	(363926, 124, '2015-01-15 01:14:44.000000', 'consum', 0.0223, 'lps'),
	(363927, 124, '2015-01-15 01:14:45.000000', 'consum', 0.0224, 'lps'),
	(363928, 124, '2015-01-15 01:14:46.000000', 'consum', 0.0217, 'lps'),
	(363929, 124, '2015-01-15 01:14:47.000000', 'consum', 0.0227, 'lps'),
	(363930, 124, '2015-01-15 01:14:48.000000', 'consum', 0.0229, 'lps'),
	(363931, 124, '2015-01-15 01:14:49.000000', 'consum', 0.0211, 'lps'),
	(363932, 124, '2015-01-15 01:14:50.000000', 'consum', 0.0227, 'lps'),
	(363933, 124, '2015-01-15 01:14:51.000000', 'consum', 0.0224, 'lps'),
	(363934, 124, '2015-01-15 01:14:52.000000', 'consum', 0.0231, 'lps'),
	(363935, 124, '2015-01-15 01:14:53.000000', 'consum', 0.0229, 'lps'),
	(363936, 124, '2015-01-15 01:14:54.000000', 'consum', 0.0219, 'lps'),
	(363937, 124, '2015-01-15 01:14:55.000000', 'consum', 0.0221, 'lps'),
	(363938, 124, '2015-01-15 01:14:56.000000', 'consum', 0.0218, 'lps'),
	(363939, 124, '2015-01-15 01:14:57.000000', 'consum', 0.0219, 'lps'),
	(363940, 124, '2015-01-15 01:14:58.000000', 'consum', 0.0228, 'lps'),
	(363941, 124, '2015-01-15 01:14:59.000000', 'consum', 0.0230, 'lps'),
	(363942, 124, '2015-01-15 01:15:00.000000', 'consum', 0.0213, 'lps'),
	(363943, 124, '2015-01-15 01:15:01.000000', 'consum', 0.0211, 'lps'),
	(363944, 124, '2015-01-15 01:15:02.000000', 'consum', 0.0228, 'lps'),
	(363945, 124, '2015-01-15 01:15:03.000000', 'consum', 0.0231, 'lps'),
	(363946, 124, '2015-01-15 01:15:04.000000', 'consum', 0.0219, 'lps'),
	(363947, 124, '2015-01-15 01:15:05.000000', 'consum', 0.0215, 'lps'),
	(363948, 124, '2015-01-15 01:15:06.000000', 'consum', 0.0210, 'lps'),
	(363949, 124, '2015-01-15 01:15:07.000000', 'consum', 0.0214, 'lps'),
	(363950, 124, '2015-01-15 01:15:08.000000', 'consum', 0.0230, 'lps'),
	(363951, 124, '2015-01-15 01:15:09.000000', 'consum', 0.0213, 'lps'),
	(363952, 124, '2015-01-15 01:15:10.000000', 'consum', 0.0229, 'lps'),
	(363953, 124, '2015-01-15 01:15:11.000000', 'consum', 0.0212, 'lps'),
	(363954, 124, '2015-01-15 01:15:12.000000', 'consum', 0.0226, 'lps'),
	(363955, 124, '2015-01-15 01:15:13.000000', 'consum', 0.0219, 'lps'),
	(363956, 124, '2015-01-15 01:15:14.000000', 'consum', 0.0229, 'lps'),
	(363957, 124, '2015-01-15 01:15:15.000000', 'consum', 0.0215, 'lps'),
	(363958, 124, '2015-01-15 01:15:16.000000', 'consum', 0.0222, 'lps'),
	(363959, 124, '2015-01-15 01:15:17.000000', 'consum', 0.0211, 'lps'),
	(363960, 124, '2015-01-15 01:15:18.000000', 'consum', 0.0224, 'lps'),
	(363961, 124, '2015-01-15 01:15:19.000000', 'consum', 0.0212, 'lps'),
	(363962, 124, '2015-01-15 01:15:20.000000', 'consum', 0.0222, 'lps'),
	(363963, 124, '2015-01-15 01:15:21.000000', 'consum', 0.0221, 'lps'),
	(363964, 124, '2015-01-15 01:15:22.000000', 'consum', 0.0231, 'lps'),
	(363965, 124, '2015-01-15 01:15:23.000000', 'consum', 0.0213, 'lps'),
	(363966, 124, '2015-01-15 01:15:24.000000', 'consum', 0.0210, 'lps'),
	(363967, 124, '2015-01-15 01:15:25.000000', 'consum', 0.0222, 'lps'),
	(363968, 124, '2015-01-15 01:15:26.000000', 'consum', 0.0227, 'lps'),
	(363969, 124, '2015-01-15 01:15:27.000000', 'consum', 0.0216, 'lps'),
	(363970, 124, '2015-01-15 01:15:28.000000', 'consum', 0.0213, 'lps'),
	(363971, 124, '2015-01-15 01:15:29.000000', 'consum', 0.0227, 'lps'),
	(363972, 124, '2015-01-15 01:15:30.000000', 'consum', 0.0219, 'lps'),
	(363973, 124, '2015-01-15 01:15:31.000000', 'consum', 0.0230, 'lps'),
	(363974, 124, '2015-01-15 01:15:32.000000', 'consum', 0.0215, 'lps'),
	(363975, 124, '2015-01-15 01:15:33.000000', 'consum', 0.0221, 'lps'),
	(363976, 124, '2015-01-15 01:15:34.000000', 'consum', 0.0228, 'lps'),
	(363977, 124, '2015-01-15 01:15:35.000000', 'consum', 0.0223, 'lps'),
	(363978, 124, '2015-01-15 01:15:36.000000', 'consum', 0.0223, 'lps'),
	(363979, 124, '2015-01-15 01:15:37.000000', 'consum', 0.0215, 'lps'),
	(363980, 124, '2015-01-15 01:15:38.000000', 'consum', 0.0218, 'lps'),
	(363981, 124, '2015-01-15 01:15:39.000000', 'consum', 0.0215, 'lps'),
	(363982, 124, '2015-01-15 01:15:40.000000', 'consum', 0.0210, 'lps'),
	(363983, 124, '2015-01-15 01:15:41.000000', 'consum', 0.0219, 'lps'),
	(363984, 124, '2015-01-15 01:15:42.000000', 'consum', 0.0211, 'lps'),
	(363985, 124, '2015-01-15 01:15:43.000000', 'consum', 0.0210, 'lps'),
	(363986, 124, '2015-01-15 01:15:44.000000', 'consum', 0.0210, 'lps'),
	(363987, 124, '2015-01-15 01:15:45.000000', 'consum', 0.0230, 'lps'),
	(363988, 124, '2015-01-15 01:15:46.000000', 'consum', 0.0222, 'lps'),
	(363989, 124, '2015-01-15 01:15:47.000000', 'consum', 0.0211, 'lps'),
	(363990, 124, '2015-01-15 01:15:48.000000', 'consum', 0.0224, 'lps'),
	(363991, 124, '2015-01-15 01:15:49.000000', 'consum', 0.0212, 'lps'),
	(363992, 124, '2015-01-15 01:15:50.000000', 'consum', 0.0221, 'lps'),
	(363993, 124, '2015-01-15 01:15:51.000000', 'consum', 0.0214, 'lps'),
	(363994, 124, '2015-01-15 01:15:52.000000', 'consum', 0.0223, 'lps'),
	(363995, 124, '2015-01-15 01:15:53.000000', 'consum', 0.0217, 'lps'),
	(363996, 124, '2015-01-15 01:15:54.000000', 'consum', 0.0228, 'lps'),
	(363997, 124, '2015-01-15 01:15:55.000000', 'consum', 0.0213, 'lps'),
	(363998, 124, '2015-01-15 01:15:56.000000', 'consum', 0.0215, 'lps'),
	(363999, 124, '2015-01-15 01:15:57.000000', 'consum', 0.0227, 'lps'),
	(364000, 124, '2015-01-15 01:15:58.000000', 'consum', 0.0213, 'lps'),
	(364001, 124, '2015-01-15 01:15:59.000000', 'consum', 0.0219, 'lps'),
	(364002, 124, '2015-01-15 01:16:00.000000', 'consum', 0.0227, 'lps'),
	(364003, 124, '2015-01-15 01:16:01.000000', 'consum', 0.0221, 'lps'),
	(364004, 124, '2015-01-15 01:16:02.000000', 'consum', 0.0217, 'lps'),
	(364005, 124, '2015-01-15 01:16:03.000000', 'consum', 0.0212, 'lps'),
	(364006, 124, '2015-01-15 01:16:04.000000', 'consum', 0.0223, 'lps'),
	(364007, 124, '2015-01-15 01:16:05.000000', 'consum', 0.0223, 'lps'),
	(364008, 124, '2015-01-15 01:16:06.000000', 'consum', 0.0214, 'lps'),
	(364009, 124, '2015-01-15 01:16:07.000000', 'consum', 0.0213, 'lps'),
	(364010, 124, '2015-01-15 01:16:08.000000', 'consum', 0.0213, 'lps'),
	(364011, 124, '2015-01-15 01:16:09.000000', 'consum', 0.0218, 'lps'),
	(364012, 124, '2015-01-15 01:16:10.000000', 'consum', 0.0220, 'lps'),
	(364013, 124, '2015-01-15 01:16:11.000000', 'consum', 0.0216, 'lps'),
	(364014, 124, '2015-01-15 01:16:12.000000', 'consum', 0.0231, 'lps'),
	(364015, 124, '2015-01-15 01:16:13.000000', 'consum', 0.0211, 'lps'),
	(364016, 124, '2015-01-15 01:16:14.000000', 'consum', 0.0216, 'lps'),
	(364017, 124, '2015-01-15 01:16:15.000000', 'consum', 0.0215, 'lps'),
	(364018, 124, '2015-01-15 01:16:16.000000', 'consum', 0.0220, 'lps'),
	(364019, 124, '2015-01-15 01:16:17.000000', 'consum', 0.0222, 'lps'),
	(364020, 124, '2015-01-15 01:16:18.000000', 'consum', 0.0219, 'lps'),
	(364021, 124, '2015-01-15 01:16:19.000000', 'consum', 0.0217, 'lps'),
	(364022, 124, '2015-01-15 01:16:20.000000', 'consum', 0.0222, 'lps'),
	(364023, 124, '2015-01-15 01:16:21.000000', 'consum', 0.0224, 'lps'),
	(364024, 124, '2015-01-15 01:16:22.000000', 'consum', 0.0226, 'lps'),
	(364025, 124, '2015-01-15 01:16:23.000000', 'consum', 0.0224, 'lps'),
	(364026, 124, '2015-01-15 01:16:24.000000', 'consum', 0.0231, 'lps'),
	(364027, 124, '2015-01-15 01:16:25.000000', 'consum', 0.0211, 'lps'),
	(364028, 124, '2015-01-15 01:16:26.000000', 'consum', 0.0217, 'lps'),
	(364029, 124, '2015-01-15 01:16:27.000000', 'consum', 0.0219, 'lps'),
	(364030, 124, '2015-01-15 01:16:28.000000', 'consum', 0.0213, 'lps'),
	(364031, 124, '2015-01-15 01:16:29.000000', 'consum', 0.0223, 'lps'),
	(364032, 124, '2015-01-15 01:16:30.000000', 'consum', 0.0219, 'lps'),
	(364033, 124, '2015-01-15 01:16:31.000000', 'consum', 0.0220, 'lps'),
	(364034, 124, '2015-01-15 01:16:32.000000', 'consum', 0.0210, 'lps'),
	(364035, 124, '2015-01-15 01:16:33.000000', 'consum', 0.0226, 'lps'),
	(364036, 124, '2015-01-15 01:16:34.000000', 'consum', 0.0224, 'lps'),
	(364037, 124, '2015-01-15 01:16:35.000000', 'consum', 0.0211, 'lps'),
	(364038, 124, '2015-01-15 01:16:36.000000', 'consum', 0.0217, 'lps'),
	(364039, 124, '2015-01-15 01:16:37.000000', 'consum', 0.0221, 'lps'),
	(364040, 124, '2015-01-15 01:16:38.000000', 'consum', 0.0221, 'lps'),
	(364041, 124, '2015-01-15 01:16:39.000000', 'consum', 0.0211, 'lps'),
	(364042, 124, '2015-01-15 01:16:40.000000', 'consum', 0.0226, 'lps'),
	(364043, 124, '2015-01-15 01:16:41.000000', 'consum', 0.0222, 'lps'),
	(364044, 124, '2015-01-15 01:16:42.000000', 'consum', 0.0221, 'lps'),
	(364045, 124, '2015-01-15 01:16:43.000000', 'consum', 0.0210, 'lps'),
	(364046, 124, '2015-01-15 01:16:44.000000', 'consum', 0.0222, 'lps'),
	(364047, 124, '2015-01-15 01:16:45.000000', 'consum', 0.0227, 'lps'),
	(364048, 124, '2015-01-15 01:16:46.000000', 'consum', 0.0216, 'lps'),
	(364049, 124, '2015-01-15 01:16:47.000000', 'consum', 0.0231, 'lps'),
	(364050, 124, '2015-01-15 01:16:48.000000', 'consum', 0.0231, 'lps'),
	(364051, 124, '2015-01-15 01:16:49.000000', 'consum', 0.0211, 'lps'),
	(364052, 124, '2015-01-15 01:16:50.000000', 'consum', 0.0218, 'lps'),
	(364053, 124, '2015-01-15 01:16:51.000000', 'consum', 0.0227, 'lps'),
	(364054, 124, '2015-01-15 01:16:52.000000', 'consum', 0.0227, 'lps'),
	(364055, 124, '2015-01-15 01:16:53.000000', 'consum', 0.0222, 'lps'),
	(364056, 124, '2015-01-15 01:16:54.000000', 'consum', 0.0219, 'lps'),
	(364057, 124, '2015-01-15 01:16:55.000000', 'consum', 0.0218, 'lps'),
	(364058, 124, '2015-01-15 01:16:56.000000', 'consum', 0.0225, 'lps'),
	(364059, 124, '2015-01-15 01:16:57.000000', 'consum', 0.0216, 'lps'),
	(364060, 124, '2015-01-15 01:16:58.000000', 'consum', 0.0216, 'lps'),
	(364061, 124, '2015-01-15 01:16:59.000000', 'consum', 0.0225, 'lps'),
	(364062, 124, '2015-01-15 01:17:00.000000', 'consum', 0.0225, 'lps'),
	(364063, 124, '2015-01-15 01:17:01.000000', 'consum', 0.0217, 'lps'),
	(364064, 124, '2015-01-15 01:17:02.000000', 'consum', 0.0224, 'lps'),
	(364065, 124, '2015-01-15 01:17:03.000000', 'consum', 0.0214, 'lps'),
	(364066, 124, '2015-01-15 01:17:04.000000', 'consum', 0.0211, 'lps'),
	(364067, 124, '2015-01-15 01:17:05.000000', 'consum', 0.0224, 'lps'),
	(364068, 124, '2015-01-15 01:17:06.000000', 'consum', 0.0213, 'lps'),
	(364069, 124, '2015-01-15 01:17:07.000000', 'consum', 0.0228, 'lps'),
	(364070, 124, '2015-01-15 01:17:08.000000', 'consum', 0.0225, 'lps'),
	(364071, 124, '2015-01-15 01:17:09.000000', 'consum', 0.0231, 'lps'),
	(364072, 124, '2015-01-15 01:17:10.000000', 'consum', 0.0227, 'lps'),
	(364073, 124, '2015-01-15 01:17:11.000000', 'consum', 0.0231, 'lps'),
	(364074, 124, '2015-01-15 01:17:12.000000', 'consum', 0.0221, 'lps'),
	(364075, 124, '2015-01-15 01:17:13.000000', 'consum', 0.0225, 'lps'),
	(364076, 124, '2015-01-15 01:17:14.000000', 'consum', 0.0210, 'lps'),
	(364077, 124, '2015-01-15 01:17:15.000000', 'consum', 0.0231, 'lps'),
	(364078, 124, '2015-01-15 01:17:16.000000', 'consum', 0.0225, 'lps'),
	(364079, 124, '2015-01-15 01:17:17.000000', 'consum', 0.0224, 'lps'),
	(364080, 124, '2015-01-15 01:17:18.000000', 'consum', 0.0214, 'lps'),
	(364081, 124, '2015-01-15 01:17:19.000000', 'consum', 0.0210, 'lps'),
	(364082, 124, '2015-01-15 01:17:20.000000', 'consum', 0.0219, 'lps'),
	(364083, 124, '2015-01-15 01:17:21.000000', 'consum', 0.0214, 'lps'),
	(364084, 124, '2015-01-15 01:17:22.000000', 'consum', 0.0225, 'lps'),
	(364085, 124, '2015-01-15 01:17:23.000000', 'consum', 0.0228, 'lps'),
	(364086, 124, '2015-01-15 01:17:24.000000', 'consum', 0.0214, 'lps'),
	(364087, 124, '2015-01-15 01:17:25.000000', 'consum', 0.0219, 'lps'),
	(364088, 124, '2015-01-15 01:17:26.000000', 'consum', 0.0221, 'lps'),
	(364089, 124, '2015-01-15 01:17:27.000000', 'consum', 0.0216, 'lps'),
	(364090, 124, '2015-01-15 01:17:28.000000', 'consum', 0.0230, 'lps'),
	(364091, 124, '2015-01-15 01:17:29.000000', 'consum', 0.0225, 'lps'),
	(364092, 124, '2015-01-15 01:17:30.000000', 'consum', 0.0227, 'lps'),
	(364093, 124, '2015-01-15 01:17:31.000000', 'consum', 0.0229, 'lps'),
	(364094, 124, '2015-01-15 01:17:32.000000', 'consum', 0.0230, 'lps'),
	(364095, 124, '2015-01-15 01:17:33.000000', 'consum', 0.0212, 'lps'),
	(364096, 124, '2015-01-15 01:17:34.000000', 'consum', 0.0225, 'lps'),
	(364097, 124, '2015-01-15 01:17:35.000000', 'consum', 0.0212, 'lps'),
	(364098, 124, '2015-01-15 01:17:36.000000', 'consum', 0.0223, 'lps'),
	(364099, 124, '2015-01-15 01:17:37.000000', 'consum', 0.0224, 'lps'),
	(364100, 124, '2015-01-15 01:17:38.000000', 'consum', 0.0218, 'lps'),
	(364101, 124, '2015-01-15 01:17:39.000000', 'consum', 0.0229, 'lps'),
	(364102, 124, '2015-01-15 01:17:40.000000', 'consum', 0.0219, 'lps'),
	(364103, 124, '2015-01-15 01:17:41.000000', 'consum', 0.0220, 'lps'),
	(364104, 124, '2015-01-15 01:17:42.000000', 'consum', 0.0212, 'lps'),
	(364105, 124, '2015-01-15 01:17:43.000000', 'consum', 0.0210, 'lps'),
	(364106, 124, '2015-01-15 01:17:44.000000', 'consum', 0.0227, 'lps'),
	(364107, 124, '2015-01-15 01:17:45.000000', 'consum', 0.0228, 'lps'),
	(364108, 124, '2015-01-15 01:17:46.000000', 'consum', 0.0231, 'lps'),
	(364109, 124, '2015-01-15 01:17:47.000000', 'consum', 0.0215, 'lps'),
	(364110, 124, '2015-01-15 01:17:48.000000', 'consum', 0.0218, 'lps'),
	(364111, 124, '2015-01-15 01:17:49.000000', 'consum', 0.0211, 'lps'),
	(364112, 124, '2015-01-15 01:17:50.000000', 'consum', 0.0215, 'lps'),
	(364113, 124, '2015-01-15 01:17:51.000000', 'consum', 0.0211, 'lps'),
	(364114, 124, '2015-01-15 01:17:52.000000', 'consum', 0.0223, 'lps'),
	(364115, 124, '2015-01-15 01:17:53.000000', 'consum', 0.0227, 'lps'),
	(364116, 124, '2015-01-15 01:17:54.000000', 'consum', 0.0213, 'lps'),
	(364117, 124, '2015-01-15 01:17:55.000000', 'consum', 0.0217, 'lps'),
	(364118, 124, '2015-01-15 01:17:56.000000', 'consum', 0.0214, 'lps'),
	(364119, 124, '2015-01-15 01:17:57.000000', 'consum', 0.0231, 'lps'),
	(364120, 124, '2015-01-15 01:17:58.000000', 'consum', 0.0216, 'lps'),
	(364121, 124, '2015-01-15 01:17:59.000000', 'consum', 0.0223, 'lps'),
	(364122, 124, '2015-01-15 01:18:00.000000', 'consum', 0.0214, 'lps'),
	(364123, 124, '2015-01-15 01:18:01.000000', 'consum', 0.0213, 'lps'),
	(364124, 124, '2015-01-15 01:18:02.000000', 'consum', 0.0212, 'lps'),
	(364125, 124, '2015-01-15 01:18:03.000000', 'consum', 0.0212, 'lps'),
	(364126, 124, '2015-01-15 01:18:04.000000', 'consum', 0.0214, 'lps'),
	(364127, 124, '2015-01-15 01:18:05.000000', 'consum', 0.0223, 'lps'),
	(364128, 124, '2015-01-15 01:18:06.000000', 'consum', 0.0221, 'lps'),
	(364129, 124, '2015-01-15 01:18:07.000000', 'consum', 0.0224, 'lps'),
	(364130, 124, '2015-01-15 01:18:08.000000', 'consum', 0.0229, 'lps'),
	(364131, 124, '2015-01-15 01:18:09.000000', 'consum', 0.0218, 'lps'),
	(364132, 124, '2015-01-15 01:18:10.000000', 'consum', 0.0217, 'lps'),
	(364133, 124, '2015-01-15 01:18:11.000000', 'consum', 0.0220, 'lps'),
	(364134, 124, '2015-01-15 01:18:12.000000', 'consum', 0.0218, 'lps'),
	(364135, 124, '2015-01-15 01:18:13.000000', 'consum', 0.0221, 'lps'),
	(364136, 124, '2015-01-15 01:18:14.000000', 'consum', 0.0221, 'lps'),
	(364137, 124, '2015-01-15 01:18:15.000000', 'consum', 0.0230, 'lps'),
	(364138, 124, '2015-01-15 01:18:16.000000', 'consum', 0.0211, 'lps'),
	(364139, 124, '2015-01-15 01:18:17.000000', 'consum', 0.0222, 'lps'),
	(364140, 124, '2015-01-15 01:18:18.000000', 'consum', 0.0224, 'lps'),
	(364141, 124, '2015-01-15 01:18:19.000000', 'consum', 0.0222, 'lps'),
	(364142, 124, '2015-01-15 01:18:20.000000', 'consum', 0.0229, 'lps'),
	(364143, 124, '2015-01-15 01:18:21.000000', 'consum', 0.0223, 'lps'),
	(364144, 124, '2015-01-15 01:18:22.000000', 'consum', 0.0221, 'lps'),
	(364145, 124, '2015-01-15 01:18:23.000000', 'consum', 0.0226, 'lps'),
	(364146, 124, '2015-01-15 01:18:24.000000', 'consum', 0.0215, 'lps'),
	(364147, 124, '2015-01-15 01:18:25.000000', 'consum', 0.0210, 'lps'),
	(364148, 124, '2015-01-15 01:18:26.000000', 'consum', 0.0218, 'lps'),
	(364149, 124, '2015-01-15 01:18:27.000000', 'consum', 0.0228, 'lps'),
	(364150, 124, '2015-01-15 01:18:28.000000', 'consum', 0.0211, 'lps'),
	(364151, 124, '2015-01-15 01:18:29.000000', 'consum', 0.0225, 'lps'),
	(364152, 124, '2015-01-15 01:18:30.000000', 'consum', 0.0219, 'lps'),
	(364153, 124, '2015-01-15 01:18:31.000000', 'consum', 0.0231, 'lps'),
	(364154, 124, '2015-01-15 01:18:32.000000', 'consum', 0.0224, 'lps'),
	(364155, 124, '2015-01-15 01:18:33.000000', 'consum', 0.0216, 'lps'),
	(364156, 124, '2015-01-15 01:18:34.000000', 'consum', 0.0221, 'lps'),
	(364157, 124, '2015-01-15 01:18:35.000000', 'consum', 0.0225, 'lps'),
	(364158, 124, '2015-01-15 01:18:36.000000', 'consum', 0.0211, 'lps'),
	(364159, 124, '2015-01-15 01:18:37.000000', 'consum', 0.0212, 'lps'),
	(364160, 124, '2015-01-15 01:18:38.000000', 'consum', 0.0217, 'lps'),
	(364161, 124, '2015-01-15 01:18:39.000000', 'consum', 0.0220, 'lps'),
	(364162, 124, '2015-01-15 01:18:40.000000', 'consum', 0.0217, 'lps'),
	(364163, 124, '2015-01-15 01:18:41.000000', 'consum', 0.0215, 'lps'),
	(364164, 124, '2015-01-15 01:18:42.000000', 'consum', 0.0213, 'lps'),
	(364165, 124, '2015-01-15 01:18:43.000000', 'consum', 0.0212, 'lps'),
	(364166, 124, '2015-01-15 01:18:44.000000', 'consum', 0.0211, 'lps'),
	(364167, 124, '2015-01-15 01:18:45.000000', 'consum', 0.0212, 'lps'),
	(364168, 124, '2015-01-15 01:18:46.000000', 'consum', 0.0215, 'lps'),
	(364169, 124, '2015-01-15 01:18:47.000000', 'consum', 0.0228, 'lps'),
	(364170, 124, '2015-01-15 01:18:48.000000', 'consum', 0.0222, 'lps'),
	(364171, 124, '2015-01-15 01:18:49.000000', 'consum', 0.0217, 'lps'),
	(364172, 124, '2015-01-15 01:18:50.000000', 'consum', 0.0210, 'lps'),
	(364173, 124, '2015-01-15 01:18:51.000000', 'consum', 0.0230, 'lps'),
	(364174, 124, '2015-01-15 01:18:52.000000', 'consum', 0.0226, 'lps'),
	(364175, 124, '2015-01-15 01:18:53.000000', 'consum', 0.0230, 'lps'),
	(364176, 124, '2015-01-15 01:18:54.000000', 'consum', 0.0217, 'lps'),
	(364177, 124, '2015-01-15 01:18:55.000000', 'consum', 0.0230, 'lps'),
	(364178, 124, '2015-01-15 01:18:56.000000', 'consum', 0.0225, 'lps'),
	(364179, 124, '2015-01-15 01:18:57.000000', 'consum', 0.0226, 'lps'),
	(364180, 124, '2015-01-15 01:18:58.000000', 'consum', 0.0222, 'lps'),
	(364181, 124, '2015-01-15 01:18:59.000000', 'consum', 0.0225, 'lps'),
	(364182, 124, '2015-01-15 01:19:00.000000', 'consum', 0.0226, 'lps'),
	(364183, 124, '2015-01-15 01:19:01.000000', 'consum', 0.0223, 'lps'),
	(364184, 124, '2015-01-15 01:19:02.000000', 'consum', 0.0229, 'lps'),
	(364185, 124, '2015-01-15 01:19:03.000000', 'consum', 0.0222, 'lps'),
	(364186, 124, '2015-01-15 01:19:04.000000', 'consum', 0.0215, 'lps'),
	(364187, 124, '2015-01-15 01:19:05.000000', 'consum', 0.0221, 'lps'),
	(364188, 124, '2015-01-15 01:19:06.000000', 'consum', 0.0230, 'lps'),
	(364189, 124, '2015-01-15 01:19:07.000000', 'consum', 0.0210, 'lps'),
	(364190, 124, '2015-01-15 01:19:08.000000', 'consum', 0.0216, 'lps'),
	(364191, 124, '2015-01-15 01:19:09.000000', 'consum', 0.0218, 'lps'),
	(364192, 124, '2015-01-15 01:19:10.000000', 'consum', 0.0212, 'lps'),
	(364193, 124, '2015-01-15 01:19:11.000000', 'consum', 0.0218, 'lps'),
	(364194, 124, '2015-01-15 01:19:12.000000', 'consum', 0.0222, 'lps'),
	(364195, 124, '2015-01-15 01:19:13.000000', 'consum', 0.0224, 'lps'),
	(364196, 124, '2015-01-15 01:19:14.000000', 'consum', 0.0222, 'lps'),
	(364197, 124, '2015-01-15 01:19:15.000000', 'consum', 0.0230, 'lps'),
	(364198, 124, '2015-01-15 01:19:16.000000', 'consum', 0.0229, 'lps'),
	(364199, 124, '2015-01-15 01:19:17.000000', 'consum', 0.0223, 'lps'),
	(364200, 124, '2015-01-15 01:19:18.000000', 'consum', 0.0217, 'lps'),
	(364201, 124, '2015-01-15 01:19:19.000000', 'consum', 0.0210, 'lps'),
	(364202, 124, '2015-01-15 01:19:20.000000', 'consum', 0.0231, 'lps'),
	(364203, 124, '2015-01-15 01:19:21.000000', 'consum', 0.0229, 'lps'),
	(364204, 124, '2015-01-15 01:19:22.000000', 'consum', 0.0220, 'lps'),
	(364205, 124, '2015-01-15 01:19:23.000000', 'consum', 0.0227, 'lps'),
	(364206, 124, '2015-01-15 01:19:24.000000', 'consum', 0.0220, 'lps'),
	(364207, 124, '2015-01-15 01:19:25.000000', 'consum', 0.0210, 'lps'),
	(364208, 124, '2015-01-15 01:19:26.000000', 'consum', 0.0223, 'lps'),
	(364209, 124, '2015-01-15 01:19:27.000000', 'consum', 0.0212, 'lps'),
	(364210, 124, '2015-01-15 01:19:28.000000', 'consum', 0.0226, 'lps'),
	(364211, 124, '2015-01-15 01:19:29.000000', 'consum', 0.0219, 'lps'),
	(364212, 124, '2015-01-15 01:19:30.000000', 'consum', 0.0230, 'lps'),
	(364213, 124, '2015-01-15 01:19:31.000000', 'consum', 0.0215, 'lps'),
	(364214, 124, '2015-01-15 01:19:32.000000', 'consum', 0.0221, 'lps'),
	(364215, 124, '2015-01-15 01:19:33.000000', 'consum', 0.0230, 'lps'),
	(364216, 124, '2015-01-15 01:19:34.000000', 'consum', 0.0211, 'lps'),
	(364217, 124, '2015-01-15 01:19:35.000000', 'consum', 0.0221, 'lps'),
	(364218, 124, '2015-01-15 01:19:36.000000', 'consum', 0.0217, 'lps'),
	(364219, 124, '2015-01-15 01:19:37.000000', 'consum', 0.0215, 'lps'),
	(364220, 124, '2015-01-15 01:19:38.000000', 'consum', 0.0213, 'lps'),
	(364221, 124, '2015-01-15 01:19:39.000000', 'consum', 0.0210, 'lps'),
	(364222, 124, '2015-01-15 01:19:40.000000', 'consum', 0.0225, 'lps'),
	(364223, 124, '2015-01-15 01:19:41.000000', 'consum', 0.0221, 'lps'),
	(364224, 124, '2015-01-15 01:19:42.000000', 'consum', 0.0219, 'lps'),
	(364225, 124, '2015-01-15 01:19:43.000000', 'consum', 0.0222, 'lps'),
	(364226, 124, '2015-01-15 01:19:44.000000', 'consum', 0.0221, 'lps'),
	(364227, 124, '2015-01-15 01:19:45.000000', 'consum', 0.0210, 'lps'),
	(364228, 124, '2015-01-15 01:19:46.000000', 'consum', 0.0218, 'lps'),
	(364229, 124, '2015-01-15 01:19:47.000000', 'consum', 0.0210, 'lps'),
	(364230, 124, '2015-01-15 01:19:48.000000', 'consum', 0.0228, 'lps'),
	(364231, 124, '2015-01-15 01:19:49.000000', 'consum', 0.0211, 'lps'),
	(364232, 124, '2015-01-15 01:19:50.000000', 'consum', 0.0230, 'lps'),
	(364233, 124, '2015-01-15 01:19:51.000000', 'consum', 0.0219, 'lps'),
	(364234, 124, '2015-01-15 01:19:52.000000', 'consum', 0.0215, 'lps'),
	(364235, 124, '2015-01-15 01:19:53.000000', 'consum', 0.0212, 'lps'),
	(364236, 124, '2015-01-15 01:19:54.000000', 'consum', 0.0225, 'lps'),
	(364237, 124, '2015-01-15 01:19:55.000000', 'consum', 0.0213, 'lps'),
	(364238, 124, '2015-01-15 01:19:56.000000', 'consum', 0.0226, 'lps'),
	(364239, 124, '2015-01-15 01:19:57.000000', 'consum', 0.0216, 'lps'),
	(364240, 124, '2015-01-15 01:19:58.000000', 'consum', 0.0212, 'lps'),
	(364241, 124, '2015-01-15 01:19:59.000000', 'consum', 0.0226, 'lps'),
	(364242, 124, '2015-01-15 01:20:00.000000', 'consum', 0.0216, 'lps'),
	(364243, 124, '2015-01-15 01:20:01.000000', 'consum', 0.0217, 'lps'),
	(364244, 124, '2015-01-15 01:20:02.000000', 'consum', 0.0228, 'lps'),
	(364245, 124, '2015-01-15 01:20:03.000000', 'consum', 0.0211, 'lps'),
	(364246, 124, '2015-01-15 01:20:04.000000', 'consum', 0.0229, 'lps'),
	(364247, 124, '2015-01-15 01:20:05.000000', 'consum', 0.0213, 'lps'),
	(364248, 124, '2015-01-15 01:20:06.000000', 'consum', 0.0216, 'lps'),
	(364249, 124, '2015-01-15 01:20:07.000000', 'consum', 0.0228, 'lps'),
	(364250, 124, '2015-01-15 01:20:08.000000', 'consum', 0.0217, 'lps'),
	(364251, 124, '2015-01-15 01:20:09.000000', 'consum', 0.0212, 'lps'),
	(364252, 124, '2015-01-15 01:20:10.000000', 'consum', 0.0224, 'lps'),
	(364253, 124, '2015-01-15 01:20:11.000000', 'consum', 0.0231, 'lps'),
	(364254, 124, '2015-01-15 01:20:12.000000', 'consum', 0.0231, 'lps'),
	(364255, 124, '2015-01-15 01:20:13.000000', 'consum', 0.0227, 'lps'),
	(364256, 124, '2015-01-15 01:20:14.000000', 'consum', 0.0212, 'lps'),
	(364257, 124, '2015-01-15 01:20:15.000000', 'consum', 0.0214, 'lps'),
	(364258, 124, '2015-01-15 01:20:16.000000', 'consum', 0.0225, 'lps'),
	(364259, 124, '2015-01-15 01:20:17.000000', 'consum', 0.0228, 'lps'),
	(364260, 124, '2015-01-15 01:20:18.000000', 'consum', 0.0213, 'lps'),
	(364261, 124, '2015-01-15 01:20:19.000000', 'consum', 0.0216, 'lps'),
	(364262, 124, '2015-01-15 01:20:20.000000', 'consum', 0.0230, 'lps'),
	(364263, 124, '2015-01-15 01:20:21.000000', 'consum', 0.0226, 'lps'),
	(364264, 124, '2015-01-15 01:20:22.000000', 'consum', 0.0231, 'lps'),
	(364265, 124, '2015-01-15 01:20:23.000000', 'consum', 0.0223, 'lps'),
	(364266, 124, '2015-01-15 01:20:24.000000', 'consum', 0.0215, 'lps'),
	(364267, 124, '2015-01-15 01:20:25.000000', 'consum', 0.0217, 'lps'),
	(364268, 124, '2015-01-15 01:20:26.000000', 'consum', 0.0230, 'lps'),
	(364269, 124, '2015-01-15 01:20:27.000000', 'consum', 0.0224, 'lps'),
	(364270, 124, '2015-01-15 01:20:28.000000', 'consum', 0.0221, 'lps'),
	(364271, 124, '2015-01-15 01:20:29.000000', 'consum', 0.0222, 'lps'),
	(364272, 124, '2015-01-15 01:20:30.000000', 'consum', 0.0218, 'lps'),
	(364273, 124, '2015-01-15 01:20:31.000000', 'consum', 0.0213, 'lps'),
	(364274, 124, '2015-01-15 01:20:32.000000', 'consum', 0.0224, 'lps'),
	(364275, 124, '2015-01-15 01:20:33.000000', 'consum', 0.0228, 'lps'),
	(364276, 124, '2015-01-15 01:20:34.000000', 'consum', 0.0215, 'lps'),
	(364277, 124, '2015-01-15 01:20:35.000000', 'consum', 0.0226, 'lps'),
	(364278, 124, '2015-01-15 01:20:36.000000', 'consum', 0.0229, 'lps'),
	(364279, 124, '2015-01-15 01:20:37.000000', 'consum', 0.0216, 'lps'),
	(364280, 124, '2015-01-15 01:20:38.000000', 'consum', 0.0228, 'lps'),
	(364281, 124, '2015-01-15 01:20:39.000000', 'consum', 0.0218, 'lps'),
	(364282, 124, '2015-01-15 01:20:40.000000', 'consum', 0.0215, 'lps'),
	(364283, 124, '2015-01-15 01:20:41.000000', 'consum', 0.0213, 'lps'),
	(364284, 124, '2015-01-15 01:20:42.000000', 'consum', 0.0212, 'lps'),
	(364285, 124, '2015-01-15 01:20:43.000000', 'consum', 0.0211, 'lps'),
	(364286, 124, '2015-01-15 01:20:44.000000', 'consum', 0.0210, 'lps'),
	(364287, 124, '2015-01-15 01:20:45.000000', 'consum', 0.0228, 'lps'),
	(364288, 124, '2015-01-15 01:20:46.000000', 'consum', 0.0214, 'lps'),
	(364289, 124, '2015-01-15 01:20:47.000000', 'consum', 0.0221, 'lps'),
	(364290, 124, '2015-01-15 01:20:48.000000', 'consum', 0.0231, 'lps'),
	(364291, 124, '2015-01-15 01:20:49.000000', 'consum', 0.0215, 'lps'),
	(364292, 124, '2015-01-15 01:20:50.000000', 'consum', 0.0216, 'lps'),
	(364293, 124, '2015-01-15 01:20:51.000000', 'consum', 0.0227, 'lps'),
	(364294, 124, '2015-01-15 01:20:52.000000', 'consum', 0.0213, 'lps'),
	(364295, 124, '2015-01-15 01:20:53.000000', 'consum', 0.0217, 'lps'),
	(364296, 124, '2015-01-15 01:20:54.000000', 'consum', 0.0216, 'lps'),
	(364297, 124, '2015-01-15 01:20:55.000000', 'consum', 0.0217, 'lps'),
	(364298, 124, '2015-01-15 01:20:56.000000', 'consum', 0.0229, 'lps'),
	(364299, 124, '2015-01-15 01:20:57.000000', 'consum', 0.0218, 'lps'),
	(364300, 124, '2015-01-15 01:20:58.000000', 'consum', 0.0214, 'lps'),
	(364301, 124, '2015-01-15 01:20:59.000000', 'consum', 0.0229, 'lps'),
	(364302, 124, '2015-01-15 01:21:00.000000', 'consum', 0.0226, 'lps'),
	(364303, 124, '2015-01-15 01:21:01.000000', 'consum', 0.0213, 'lps'),
	(364304, 124, '2015-01-15 01:21:02.000000', 'consum', 0.0223, 'lps'),
	(364305, 124, '2015-01-15 01:21:03.000000', 'consum', 0.0221, 'lps'),
	(364306, 124, '2015-01-15 01:21:04.000000', 'consum', 0.0227, 'lps'),
	(364307, 124, '2015-01-15 01:21:05.000000', 'consum', 0.0217, 'lps'),
	(364308, 124, '2015-01-15 01:21:06.000000', 'consum', 0.0216, 'lps'),
	(364309, 124, '2015-01-15 01:21:07.000000', 'consum', 0.0221, 'lps'),
	(364310, 124, '2015-01-15 01:21:08.000000', 'consum', 0.0226, 'lps'),
	(364311, 124, '2015-01-15 01:21:09.000000', 'consum', 0.0213, 'lps'),
	(364312, 124, '2015-01-15 01:21:10.000000', 'consum', 0.0220, 'lps'),
	(364313, 124, '2015-01-15 01:21:11.000000', 'consum', 0.0231, 'lps'),
	(364314, 124, '2015-01-15 01:21:12.000000', 'consum', 0.0220, 'lps'),
	(364315, 124, '2015-01-15 01:21:13.000000', 'consum', 0.0219, 'lps'),
	(364316, 124, '2015-01-15 01:21:14.000000', 'consum', 0.0226, 'lps'),
	(364317, 124, '2015-01-15 01:21:15.000000', 'consum', 0.0219, 'lps'),
	(364318, 124, '2015-01-15 01:21:16.000000', 'consum', 0.0228, 'lps'),
	(364319, 124, '2015-01-15 01:21:17.000000', 'consum', 0.0229, 'lps'),
	(364320, 124, '2015-01-15 01:21:18.000000', 'consum', 0.0231, 'lps'),
	(364321, 124, '2015-01-15 01:21:19.000000', 'consum', 0.0213, 'lps'),
	(364322, 124, '2015-01-15 01:21:20.000000', 'consum', 0.0229, 'lps'),
	(364323, 124, '2015-01-15 01:21:21.000000', 'consum', 0.0231, 'lps'),
	(364324, 124, '2015-01-15 01:21:22.000000', 'consum', 0.0212, 'lps'),
	(364325, 124, '2015-01-15 01:21:23.000000', 'consum', 0.0226, 'lps'),
	(364326, 124, '2015-01-15 01:21:24.000000', 'consum', 0.0218, 'lps'),
	(364327, 124, '2015-01-15 01:21:25.000000', 'consum', 0.0224, 'lps'),
	(364328, 124, '2015-01-15 01:21:26.000000', 'consum', 0.0214, 'lps'),
	(364329, 124, '2015-01-15 01:21:27.000000', 'consum', 0.0231, 'lps'),
	(364330, 124, '2015-01-15 01:21:28.000000', 'consum', 0.0216, 'lps'),
	(364331, 124, '2015-01-15 01:21:29.000000', 'consum', 0.0222, 'lps'),
	(364332, 124, '2015-01-15 01:21:30.000000', 'consum', 0.0229, 'lps'),
	(364333, 124, '2015-01-15 01:21:31.000000', 'consum', 0.0226, 'lps'),
	(364334, 124, '2015-01-15 01:21:32.000000', 'consum', 0.0210, 'lps'),
	(364335, 124, '2015-01-15 01:21:33.000000', 'consum', 0.0231, 'lps'),
	(364336, 124, '2015-01-15 01:21:34.000000', 'consum', 0.0227, 'lps'),
	(364337, 124, '2015-01-15 01:21:35.000000', 'consum', 0.0230, 'lps'),
	(364338, 124, '2015-01-15 01:21:36.000000', 'consum', 0.0218, 'lps'),
	(364339, 124, '2015-01-15 01:21:37.000000', 'consum', 0.0211, 'lps'),
	(364340, 124, '2015-01-15 01:21:38.000000', 'consum', 0.0213, 'lps'),
	(364341, 124, '2015-01-15 01:21:39.000000', 'consum', 0.0225, 'lps'),
	(364342, 124, '2015-01-15 01:21:40.000000', 'consum', 0.0211, 'lps'),
	(364343, 124, '2015-01-15 01:21:41.000000', 'consum', 0.0212, 'lps'),
	(364344, 124, '2015-01-15 01:21:42.000000', 'consum', 0.0218, 'lps'),
	(364345, 124, '2015-01-15 01:21:43.000000', 'consum', 0.0222, 'lps'),
	(364346, 124, '2015-01-15 01:21:44.000000', 'consum', 0.0226, 'lps'),
	(364347, 124, '2015-01-15 01:21:45.000000', 'consum', 0.0230, 'lps'),
	(364348, 124, '2015-01-15 01:21:46.000000', 'consum', 0.0221, 'lps'),
	(364349, 124, '2015-01-15 01:21:47.000000', 'consum', 0.0225, 'lps'),
	(364350, 124, '2015-01-15 01:21:48.000000', 'consum', 0.0230, 'lps'),
	(364351, 124, '2015-01-15 01:21:49.000000', 'consum', 0.0223, 'lps'),
	(364352, 124, '2015-01-15 01:21:50.000000', 'consum', 0.0215, 'lps'),
	(364353, 124, '2015-01-15 01:21:51.000000', 'consum', 0.0219, 'lps'),
	(364354, 124, '2015-01-15 01:21:52.000000', 'consum', 0.0217, 'lps'),
	(364355, 124, '2015-01-15 01:21:53.000000', 'consum', 0.0218, 'lps'),
	(364356, 124, '2015-01-15 01:21:54.000000', 'consum', 0.0229, 'lps'),
	(364357, 124, '2015-01-15 01:21:55.000000', 'consum', 0.0218, 'lps'),
	(364358, 124, '2015-01-15 01:21:56.000000', 'consum', 0.0212, 'lps'),
	(364359, 124, '2015-01-15 01:21:57.000000', 'consum', 0.0222, 'lps'),
	(364360, 124, '2015-01-15 01:21:58.000000', 'consum', 0.0218, 'lps'),
	(364361, 124, '2015-01-15 01:21:59.000000', 'consum', 0.0217, 'lps'),
	(364362, 124, '2015-01-15 01:22:00.000000', 'consum', 0.0222, 'lps'),
	(364363, 124, '2015-01-15 01:22:01.000000', 'consum', 0.0227, 'lps'),
	(364364, 124, '2015-01-15 01:22:02.000000', 'consum', 0.0217, 'lps'),
	(364365, 124, '2015-01-15 01:22:03.000000', 'consum', 0.0214, 'lps'),
	(364366, 124, '2015-01-15 01:22:04.000000', 'consum', 0.0212, 'lps'),
	(364367, 124, '2015-01-15 01:22:05.000000', 'consum', 0.0230, 'lps'),
	(364368, 124, '2015-01-15 01:22:06.000000', 'consum', 0.0217, 'lps'),
	(364369, 124, '2015-01-15 01:22:07.000000', 'consum', 0.0228, 'lps'),
	(364370, 124, '2015-01-15 01:22:08.000000', 'consum', 0.0214, 'lps'),
	(364371, 124, '2015-01-15 01:22:09.000000', 'consum', 0.0220, 'lps'),
	(364372, 124, '2015-01-15 01:22:10.000000', 'consum', 0.0227, 'lps'),
	(364373, 124, '2015-01-15 01:22:11.000000', 'consum', 0.0221, 'lps'),
	(364374, 124, '2015-01-15 01:22:12.000000', 'consum', 0.0215, 'lps'),
	(364375, 124, '2015-01-15 01:22:13.000000', 'consum', 0.0225, 'lps'),
	(364376, 124, '2015-01-15 01:22:14.000000', 'consum', 0.0227, 'lps'),
	(364377, 124, '2015-01-15 01:22:15.000000', 'consum', 0.0226, 'lps'),
	(364378, 124, '2015-01-15 01:22:16.000000', 'consum', 0.0218, 'lps'),
	(364379, 124, '2015-01-15 01:22:17.000000', 'consum', 0.0224, 'lps'),
	(364380, 124, '2015-01-15 01:22:18.000000', 'consum', 0.0212, 'lps'),
	(364381, 124, '2015-01-15 01:22:19.000000', 'consum', 0.0223, 'lps'),
	(364382, 124, '2015-01-15 01:22:20.000000', 'consum', 0.0227, 'lps'),
	(364383, 124, '2015-01-15 01:22:21.000000', 'consum', 0.0214, 'lps'),
	(364384, 124, '2015-01-15 01:22:22.000000', 'consum', 0.0220, 'lps'),
	(364385, 124, '2015-01-15 01:22:23.000000', 'consum', 0.0228, 'lps'),
	(364386, 124, '2015-01-15 01:22:24.000000', 'consum', 0.0227, 'lps'),
	(364387, 124, '2015-01-15 01:22:25.000000', 'consum', 0.0220, 'lps'),
	(364388, 124, '2015-01-15 01:22:26.000000', 'consum', 0.0231, 'lps'),
	(364389, 124, '2015-01-15 01:22:27.000000', 'consum', 0.0221, 'lps'),
	(364390, 124, '2015-01-15 01:22:28.000000', 'consum', 0.0223, 'lps'),
	(364391, 124, '2015-01-15 01:22:29.000000', 'consum', 0.0220, 'lps'),
	(364392, 124, '2015-01-15 01:22:30.000000', 'consum', 0.0221, 'lps'),
	(364393, 124, '2015-01-15 01:22:31.000000', 'consum', 0.0216, 'lps'),
	(364394, 124, '2015-01-15 01:22:32.000000', 'consum', 0.0229, 'lps'),
	(364395, 124, '2015-01-15 01:22:33.000000', 'consum', 0.0223, 'lps'),
	(364396, 124, '2015-01-15 01:22:34.000000', 'consum', 0.0216, 'lps'),
	(364397, 124, '2015-01-15 01:22:35.000000', 'consum', 0.0223, 'lps'),
	(364398, 124, '2015-01-15 01:22:36.000000', 'consum', 0.0215, 'lps'),
	(364399, 124, '2015-01-15 01:22:37.000000', 'consum', 0.0220, 'lps'),
	(364400, 124, '2015-01-15 01:22:38.000000', 'consum', 0.0223, 'lps'),
	(364401, 124, '2015-01-15 01:22:39.000000', 'consum', 0.0222, 'lps'),
	(364402, 124, '2015-01-15 01:22:40.000000', 'consum', 0.0211, 'lps'),
	(364403, 124, '2015-01-15 01:22:41.000000', 'consum', 0.0225, 'lps'),
	(364404, 124, '2015-01-15 01:22:42.000000', 'consum', 0.0214, 'lps'),
	(364405, 124, '2015-01-15 01:22:43.000000', 'consum', 0.0210, 'lps'),
	(364406, 124, '2015-01-15 01:22:44.000000', 'consum', 0.0218, 'lps'),
	(364407, 124, '2015-01-15 01:22:45.000000', 'consum', 0.0229, 'lps'),
	(364408, 124, '2015-01-15 01:22:46.000000', 'consum', 0.0214, 'lps'),
	(364409, 124, '2015-01-15 01:22:47.000000', 'consum', 0.0218, 'lps'),
	(364410, 124, '2015-01-15 01:22:48.000000', 'consum', 0.0218, 'lps'),
	(364411, 124, '2015-01-15 01:22:49.000000', 'consum', 0.0224, 'lps'),
	(364412, 124, '2015-01-15 01:22:50.000000', 'consum', 0.0213, 'lps'),
	(364413, 124, '2015-01-15 01:22:51.000000', 'consum', 0.0230, 'lps'),
	(364414, 124, '2015-01-15 01:22:52.000000', 'consum', 0.0213, 'lps'),
	(364415, 124, '2015-01-15 01:22:53.000000', 'consum', 0.0230, 'lps'),
	(364416, 124, '2015-01-15 01:22:54.000000', 'consum', 0.0216, 'lps'),
	(364417, 124, '2015-01-15 01:22:55.000000', 'consum', 0.0223, 'lps'),
	(364418, 124, '2015-01-15 01:22:56.000000', 'consum', 0.0212, 'lps'),
	(364419, 124, '2015-01-15 01:22:57.000000', 'consum', 0.0227, 'lps'),
	(364420, 124, '2015-01-15 01:22:58.000000', 'consum', 0.0225, 'lps'),
	(364421, 124, '2015-01-15 01:22:59.000000', 'consum', 0.0212, 'lps'),
	(364422, 124, '2015-01-15 01:23:00.000000', 'consum', 0.0217, 'lps'),
	(364423, 124, '2015-01-15 01:23:01.000000', 'consum', 0.0220, 'lps'),
	(364424, 124, '2015-01-15 01:23:02.000000', 'consum', 0.0216, 'lps'),
	(364425, 124, '2015-01-15 01:23:03.000000', 'consum', 0.0213, 'lps'),
	(364426, 124, '2015-01-15 01:23:04.000000', 'consum', 0.0226, 'lps'),
	(364427, 124, '2015-01-15 01:23:05.000000', 'consum', 0.0218, 'lps'),
	(364428, 124, '2015-01-15 01:23:06.000000', 'consum', 0.0222, 'lps'),
	(364429, 124, '2015-01-15 01:23:07.000000', 'consum', 0.0224, 'lps'),
	(364430, 124, '2015-01-15 01:23:08.000000', 'consum', 0.0226, 'lps'),
	(364431, 124, '2015-01-15 01:23:09.000000', 'consum', 0.0224, 'lps'),
	(364432, 124, '2015-01-15 01:23:10.000000', 'consum', 0.0212, 'lps'),
	(364433, 124, '2015-01-15 01:23:11.000000', 'consum', 0.0224, 'lps'),
	(364434, 124, '2015-01-15 01:23:12.000000', 'consum', 0.0227, 'lps'),
	(364435, 124, '2015-01-15 01:23:13.000000', 'consum', 0.0212, 'lps'),
	(364436, 124, '2015-01-15 01:23:14.000000', 'consum', 0.0214, 'lps'),
	(364437, 124, '2015-01-15 01:23:15.000000', 'consum', 0.0223, 'lps'),
	(364438, 124, '2015-01-15 01:23:16.000000', 'consum', 0.0221, 'lps'),
	(364439, 124, '2015-01-15 01:23:17.000000', 'consum', 0.0228, 'lps'),
	(364440, 124, '2015-01-15 01:23:18.000000', 'consum', 0.0221, 'lps'),
	(364441, 124, '2015-01-15 01:23:19.000000', 'consum', 0.0211, 'lps'),
	(364442, 124, '2015-01-15 01:23:20.000000', 'consum', 0.0228, 'lps'),
	(364443, 124, '2015-01-15 01:23:21.000000', 'consum', 0.0210, 'lps'),
	(364444, 124, '2015-01-15 01:23:22.000000', 'consum', 0.0220, 'lps'),
	(364445, 124, '2015-01-15 01:23:23.000000', 'consum', 0.0217, 'lps'),
	(364446, 124, '2015-01-15 01:23:24.000000', 'consum', 0.0216, 'lps'),
	(364447, 124, '2015-01-15 01:23:25.000000', 'consum', 0.0221, 'lps'),
	(364448, 124, '2015-01-15 01:23:26.000000', 'consum', 0.0226, 'lps'),
	(364449, 124, '2015-01-15 01:23:27.000000', 'consum', 0.0212, 'lps'),
	(364450, 124, '2015-01-15 01:23:28.000000', 'consum', 0.0219, 'lps'),
	(364451, 124, '2015-01-15 01:23:29.000000', 'consum', 0.0226, 'lps'),
	(364452, 124, '2015-01-15 01:23:30.000000', 'consum', 0.0218, 'lps'),
	(364453, 124, '2015-01-15 01:23:31.000000', 'consum', 0.0227, 'lps'),
	(364454, 124, '2015-01-15 01:23:32.000000', 'consum', 0.0225, 'lps'),
	(364455, 124, '2015-01-15 01:23:33.000000', 'consum', 0.0212, 'lps'),
	(364456, 124, '2015-01-15 01:23:34.000000', 'consum', 0.0220, 'lps'),
	(364457, 124, '2015-01-15 01:23:35.000000', 'consum', 0.0211, 'lps'),
	(364458, 124, '2015-01-15 01:23:36.000000', 'consum', 0.0229, 'lps'),
	(364459, 124, '2015-01-15 01:23:37.000000', 'consum', 0.0214, 'lps'),
	(364460, 124, '2015-01-15 01:23:38.000000', 'consum', 0.0216, 'lps'),
	(364461, 124, '2015-01-15 01:23:39.000000', 'consum', 0.0230, 'lps'),
	(364462, 124, '2015-01-15 01:23:40.000000', 'consum', 0.0226, 'lps'),
	(364463, 124, '2015-01-15 01:23:41.000000', 'consum', 0.0210, 'lps'),
	(364464, 124, '2015-01-15 01:23:42.000000', 'consum', 0.0227, 'lps'),
	(364465, 124, '2015-01-15 01:23:43.000000', 'consum', 0.0229, 'lps'),
	(364466, 124, '2015-01-15 01:23:44.000000', 'consum', 0.0212, 'lps'),
	(364467, 124, '2015-01-15 01:23:45.000000', 'consum', 0.0231, 'lps'),
	(364468, 124, '2015-01-15 01:23:46.000000', 'consum', 0.0219, 'lps'),
	(364469, 124, '2015-01-15 01:23:47.000000', 'consum', 0.0214, 'lps'),
	(364470, 124, '2015-01-15 01:23:48.000000', 'consum', 0.0225, 'lps'),
	(364471, 124, '2015-01-15 01:23:49.000000', 'consum', 0.0210, 'lps'),
	(364472, 124, '2015-01-15 01:23:50.000000', 'consum', 0.0210, 'lps'),
	(364473, 124, '2015-01-15 01:23:51.000000', 'consum', 0.0230, 'lps'),
	(364474, 124, '2015-01-15 01:23:52.000000', 'consum', 0.0225, 'lps'),
	(364475, 124, '2015-01-15 01:23:53.000000', 'consum', 0.0223, 'lps'),
	(364476, 124, '2015-01-15 01:23:54.000000', 'consum', 0.0231, 'lps'),
	(364477, 124, '2015-01-15 01:23:55.000000', 'consum', 0.0211, 'lps'),
	(364478, 124, '2015-01-15 01:23:56.000000', 'consum', 0.0217, 'lps'),
	(364479, 124, '2015-01-15 01:23:57.000000', 'consum', 0.0221, 'lps'),
	(364480, 124, '2015-01-15 01:23:58.000000', 'consum', 0.0222, 'lps'),
	(364481, 124, '2015-01-15 01:23:59.000000', 'consum', 0.0215, 'lps'),
	(364482, 124, '2015-01-15 01:24:00.000000', 'consum', 0.0223, 'lps'),
	(364483, 124, '2015-01-15 01:24:01.000000', 'consum', 0.0218, 'lps'),
	(364484, 124, '2015-01-15 01:24:02.000000', 'consum', 0.0231, 'lps'),
	(364485, 124, '2015-01-15 01:24:03.000000', 'consum', 0.0227, 'lps'),
	(364486, 124, '2015-01-15 01:24:04.000000', 'consum', 0.0231, 'lps'),
	(364487, 124, '2015-01-15 01:24:05.000000', 'consum', 0.0221, 'lps'),
	(364488, 124, '2015-01-15 01:24:06.000000', 'consum', 0.0225, 'lps'),
	(364489, 124, '2015-01-15 01:24:07.000000', 'consum', 0.0229, 'lps'),
	(364490, 124, '2015-01-15 01:24:08.000000', 'consum', 0.0218, 'lps'),
	(364491, 124, '2015-01-15 01:24:09.000000', 'consum', 0.0214, 'lps'),
	(364492, 124, '2015-01-15 01:24:10.000000', 'consum', 0.0231, 'lps'),
	(364493, 124, '2015-01-15 01:24:11.000000', 'consum', 0.0213, 'lps'),
	(364494, 124, '2015-01-15 01:24:12.000000', 'consum', 0.0228, 'lps'),
	(364495, 124, '2015-01-15 01:24:13.000000', 'consum', 0.0226, 'lps'),
	(364496, 124, '2015-01-15 01:24:14.000000', 'consum', 0.0216, 'lps'),
	(364497, 124, '2015-01-15 01:24:15.000000', 'consum', 0.0215, 'lps'),
	(364498, 124, '2015-01-15 01:24:16.000000', 'consum', 0.0215, 'lps'),
	(364499, 124, '2015-01-15 01:24:17.000000', 'consum', 0.0223, 'lps'),
	(364500, 124, '2015-01-15 01:24:18.000000', 'consum', 0.0215, 'lps'),
	(364501, 124, '2015-01-15 01:24:19.000000', 'consum', 0.0220, 'lps'),
	(364502, 124, '2015-01-15 01:24:20.000000', 'consum', 0.0224, 'lps'),
	(364503, 124, '2015-01-15 01:24:21.000000', 'consum', 0.0228, 'lps'),
	(364504, 124, '2015-01-15 01:24:22.000000', 'consum', 0.0215, 'lps'),
	(364505, 124, '2015-01-15 01:24:23.000000', 'consum', 0.0225, 'lps'),
	(364506, 124, '2015-01-15 01:24:24.000000', 'consum', 0.0225, 'lps'),
	(364507, 124, '2015-01-15 01:24:25.000000', 'consum', 0.0218, 'lps'),
	(364508, 124, '2015-01-15 01:24:26.000000', 'consum', 0.0228, 'lps'),
	(364509, 124, '2015-01-15 01:24:27.000000', 'consum', 0.0210, 'lps'),
	(364510, 124, '2015-01-15 01:24:28.000000', 'consum', 0.0223, 'lps'),
	(364511, 124, '2015-01-15 01:24:29.000000', 'consum', 0.0231, 'lps'),
	(364512, 124, '2015-01-15 01:24:30.000000', 'consum', 0.0211, 'lps'),
	(364513, 124, '2015-01-15 01:24:31.000000', 'consum', 0.0217, 'lps'),
	(364514, 124, '2015-01-15 01:24:32.000000', 'consum', 0.0222, 'lps'),
	(364515, 124, '2015-01-15 01:24:33.000000', 'consum', 0.0228, 'lps'),
	(364516, 124, '2015-01-15 01:24:34.000000', 'consum', 0.0222, 'lps'),
	(364517, 124, '2015-01-15 01:24:35.000000', 'consum', 0.0214, 'lps'),
	(364518, 124, '2015-01-15 01:24:36.000000', 'consum', 0.0215, 'lps'),
	(364519, 124, '2015-01-15 01:24:37.000000', 'consum', 0.0226, 'lps'),
	(364520, 124, '2015-01-15 01:24:38.000000', 'consum', 0.0210, 'lps'),
	(364521, 124, '2015-01-15 01:24:39.000000', 'consum', 0.0229, 'lps'),
	(364522, 124, '2015-01-15 01:24:40.000000', 'consum', 0.0218, 'lps'),
	(364523, 124, '2015-01-15 01:24:41.000000', 'consum', 0.0213, 'lps'),
	(364524, 124, '2015-01-15 01:24:42.000000', 'consum', 0.0224, 'lps'),
	(364525, 124, '2015-01-15 01:24:43.000000', 'consum', 0.0229, 'lps'),
	(364526, 124, '2015-01-15 01:24:44.000000', 'consum', 0.0220, 'lps'),
	(364527, 124, '2015-01-15 01:24:45.000000', 'consum', 0.0224, 'lps'),
	(364528, 124, '2015-01-15 01:24:46.000000', 'consum', 0.0227, 'lps'),
	(364529, 124, '2015-01-15 01:24:47.000000', 'consum', 0.0212, 'lps'),
	(364530, 124, '2015-01-15 01:24:48.000000', 'consum', 0.0214, 'lps'),
	(364531, 124, '2015-01-15 01:24:49.000000', 'consum', 0.0224, 'lps'),
	(364532, 124, '2015-01-15 01:24:50.000000', 'consum', 0.0223, 'lps'),
	(364533, 124, '2015-01-15 01:24:51.000000', 'consum', 0.0213, 'lps'),
	(364534, 124, '2015-01-15 01:24:52.000000', 'consum', 0.0230, 'lps'),
	(364535, 124, '2015-01-15 01:24:53.000000', 'consum', 0.0213, 'lps'),
	(364536, 124, '2015-01-15 01:24:54.000000', 'consum', 0.0231, 'lps'),
	(364537, 124, '2015-01-15 01:24:55.000000', 'consum', 0.0217, 'lps'),
	(364538, 124, '2015-01-15 01:24:56.000000', 'consum', 0.0230, 'lps'),
	(364539, 124, '2015-01-15 01:24:57.000000', 'consum', 0.0222, 'lps'),
	(364540, 124, '2015-01-15 01:24:58.000000', 'consum', 0.0212, 'lps'),
	(364541, 124, '2015-01-15 01:24:59.000000', 'consum', 0.0226, 'lps'),
	(364542, 124, '2015-01-15 01:25:00.000000', 'consum', 0.0219, 'lps'),
	(364543, 124, '2015-01-15 01:25:01.000000', 'consum', 0.0231, 'lps'),
	(364544, 124, '2015-01-15 01:25:02.000000', 'consum', 0.0220, 'lps'),
	(364545, 124, '2015-01-15 01:25:03.000000', 'consum', 0.0221, 'lps'),
	(364546, 124, '2015-01-15 01:25:04.000000', 'consum', 0.0213, 'lps'),
	(364547, 124, '2015-01-15 01:25:05.000000', 'consum', 0.0215, 'lps'),
	(364548, 124, '2015-01-15 01:25:06.000000', 'consum', 0.0228, 'lps'),
	(364549, 124, '2015-01-15 01:25:07.000000', 'consum', 0.0217, 'lps'),
	(364550, 124, '2015-01-15 01:25:08.000000', 'consum', 0.0216, 'lps'),
	(364551, 124, '2015-01-15 01:25:09.000000', 'consum', 0.0219, 'lps'),
	(364552, 124, '2015-01-15 01:25:10.000000', 'consum', 0.0216, 'lps'),
	(364553, 124, '2015-01-15 01:25:11.000000', 'consum', 0.0212, 'lps'),
	(364554, 124, '2015-01-15 01:25:12.000000', 'consum', 0.0226, 'lps'),
	(364555, 124, '2015-01-15 01:25:13.000000', 'consum', 0.0220, 'lps'),
	(364556, 124, '2015-01-15 01:25:14.000000', 'consum', 0.0210, 'lps'),
	(364557, 124, '2015-01-15 01:25:15.000000', 'consum', 0.0225, 'lps'),
	(364558, 124, '2015-01-15 01:25:16.000000', 'consum', 0.0218, 'lps'),
	(364559, 124, '2015-01-15 01:25:17.000000', 'consum', 0.0229, 'lps'),
	(364560, 124, '2015-01-15 01:25:18.000000', 'consum', 0.0215, 'lps'),
	(364561, 124, '2015-01-15 01:25:19.000000', 'consum', 0.0223, 'lps'),
	(364562, 124, '2015-01-15 01:25:20.000000', 'consum', 0.0218, 'lps'),
	(364563, 124, '2015-01-15 01:25:21.000000', 'consum', 0.0211, 'lps'),
	(364564, 124, '2015-01-15 01:25:22.000000', 'consum', 0.0211, 'lps'),
	(364565, 124, '2015-01-15 01:25:23.000000', 'consum', 0.0214, 'lps'),
	(364566, 124, '2015-01-15 01:25:24.000000', 'consum', 0.0227, 'lps'),
	(364567, 124, '2015-01-15 01:25:25.000000', 'consum', 0.0220, 'lps'),
	(364568, 124, '2015-01-15 01:25:26.000000', 'consum', 0.0229, 'lps'),
	(364569, 124, '2015-01-15 01:25:27.000000', 'consum', 0.0231, 'lps'),
	(364570, 124, '2015-01-15 01:25:28.000000', 'consum', 0.0216, 'lps'),
	(364571, 124, '2015-01-15 01:25:29.000000', 'consum', 0.0223, 'lps'),
	(364572, 124, '2015-01-15 01:25:30.000000', 'consum', 0.0211, 'lps'),
	(364573, 124, '2015-01-15 01:25:31.000000', 'consum', 0.0220, 'lps'),
	(364574, 124, '2015-01-15 01:25:32.000000', 'consum', 0.0213, 'lps'),
	(364575, 124, '2015-01-15 01:25:33.000000', 'consum', 0.0218, 'lps'),
	(364576, 124, '2015-01-15 01:25:34.000000', 'consum', 0.0219, 'lps'),
	(364577, 124, '2015-01-15 01:25:35.000000', 'consum', 0.0210, 'lps'),
	(364578, 124, '2015-01-15 01:25:36.000000', 'consum', 0.0226, 'lps'),
	(364579, 124, '2015-01-15 01:25:37.000000', 'consum', 0.0228, 'lps'),
	(364580, 124, '2015-01-15 01:25:38.000000', 'consum', 0.0227, 'lps'),
	(364581, 124, '2015-01-15 01:25:39.000000', 'consum', 0.0221, 'lps'),
	(364582, 124, '2015-01-15 01:25:40.000000', 'consum', 0.0214, 'lps'),
	(364583, 124, '2015-01-15 01:25:41.000000', 'consum', 0.0218, 'lps'),
	(364584, 124, '2015-01-15 01:25:42.000000', 'consum', 0.0217, 'lps'),
	(364585, 124, '2015-01-15 01:25:43.000000', 'consum', 0.0220, 'lps'),
	(364586, 124, '2015-01-15 01:25:44.000000', 'consum', 0.0219, 'lps'),
	(364587, 124, '2015-01-15 01:25:45.000000', 'consum', 0.0227, 'lps'),
	(364588, 124, '2015-01-15 01:25:46.000000', 'consum', 0.0223, 'lps'),
	(364589, 124, '2015-01-15 01:25:47.000000', 'consum', 0.0225, 'lps'),
	(364590, 124, '2015-01-15 01:25:48.000000', 'consum', 0.0223, 'lps'),
	(364591, 124, '2015-01-15 01:25:49.000000', 'consum', 0.0210, 'lps'),
	(364592, 124, '2015-01-15 01:25:50.000000', 'consum', 0.0215, 'lps'),
	(364593, 124, '2015-01-15 01:25:51.000000', 'consum', 0.0213, 'lps'),
	(364594, 124, '2015-01-15 01:25:52.000000', 'consum', 0.0231, 'lps'),
	(364595, 124, '2015-01-15 01:25:53.000000', 'consum', 0.0222, 'lps'),
	(364596, 124, '2015-01-15 01:25:54.000000', 'consum', 0.0227, 'lps'),
	(364597, 124, '2015-01-15 01:25:55.000000', 'consum', 0.0216, 'lps'),
	(364598, 124, '2015-01-15 01:25:56.000000', 'consum', 0.0211, 'lps'),
	(364599, 124, '2015-01-15 01:25:57.000000', 'consum', 0.0220, 'lps'),
	(364600, 124, '2015-01-15 01:25:58.000000', 'consum', 0.0214, 'lps'),
	(364601, 124, '2015-01-15 01:25:59.000000', 'consum', 0.0221, 'lps'),
	(364602, 124, '2015-01-15 01:26:00.000000', 'consum', 0.0231, 'lps'),
	(364603, 124, '2015-01-15 01:26:01.000000', 'consum', 0.0219, 'lps'),
	(364604, 124, '2015-01-15 01:26:02.000000', 'consum', 0.0212, 'lps'),
	(364605, 124, '2015-01-15 01:26:03.000000', 'consum', 0.0216, 'lps'),
	(364606, 124, '2015-01-15 01:26:04.000000', 'consum', 0.0211, 'lps'),
	(364607, 124, '2015-01-15 01:26:05.000000', 'consum', 0.0222, 'lps'),
	(364608, 124, '2015-01-15 01:26:06.000000', 'consum', 0.0225, 'lps'),
	(364609, 124, '2015-01-15 01:26:07.000000', 'consum', 0.0224, 'lps'),
	(364610, 124, '2015-01-15 01:26:08.000000', 'consum', 0.0215, 'lps'),
	(364611, 124, '2015-01-15 01:26:09.000000', 'consum', 0.0213, 'lps'),
	(364612, 124, '2015-01-15 01:26:10.000000', 'consum', 0.0213, 'lps'),
	(364613, 124, '2015-01-15 01:26:11.000000', 'consum', 0.0216, 'lps'),
	(364614, 124, '2015-01-15 01:26:12.000000', 'consum', 0.0211, 'lps'),
	(364615, 124, '2015-01-15 01:26:13.000000', 'consum', 0.0217, 'lps'),
	(364616, 124, '2015-01-15 01:26:14.000000', 'consum', 0.0220, 'lps'),
	(364617, 124, '2015-01-15 01:26:15.000000', 'consum', 0.0217, 'lps'),
	(364618, 124, '2015-01-15 01:26:16.000000', 'consum', 0.0217, 'lps'),
	(364619, 124, '2015-01-15 01:26:17.000000', 'consum', 0.0225, 'lps'),
	(364620, 124, '2015-01-15 01:26:18.000000', 'consum', 0.0219, 'lps'),
	(364621, 124, '2015-01-15 01:26:19.000000', 'consum', 0.0211, 'lps'),
	(364622, 124, '2015-01-15 01:26:20.000000', 'consum', 0.0211, 'lps'),
	(364623, 124, '2015-01-15 01:26:21.000000', 'consum', 0.0211, 'lps'),
	(364624, 124, '2015-01-15 01:26:22.000000', 'consum', 0.0213, 'lps'),
	(364625, 124, '2015-01-15 01:26:23.000000', 'consum', 0.0225, 'lps'),
	(364626, 124, '2015-01-15 01:26:24.000000', 'consum', 0.0229, 'lps'),
	(364627, 124, '2015-01-15 01:26:25.000000', 'consum', 0.0219, 'lps'),
	(364628, 124, '2015-01-15 01:26:26.000000', 'consum', 0.0218, 'lps'),
	(364629, 124, '2015-01-15 01:26:27.000000', 'consum', 0.0225, 'lps'),
	(364630, 124, '2015-01-15 01:26:28.000000', 'consum', 0.0219, 'lps'),
	(364631, 124, '2015-01-15 01:26:29.000000', 'consum', 0.0229, 'lps'),
	(364632, 124, '2015-01-15 01:26:30.000000', 'consum', 0.0215, 'lps'),
	(364633, 124, '2015-01-15 01:26:31.000000', 'consum', 0.0222, 'lps'),
	(364634, 124, '2015-01-15 01:26:32.000000', 'consum', 0.0214, 'lps'),
	(364635, 124, '2015-01-15 01:26:33.000000', 'consum', 0.0213, 'lps'),
	(364636, 124, '2015-01-15 01:26:34.000000', 'consum', 0.0213, 'lps'),
	(364637, 124, '2015-01-15 01:26:35.000000', 'consum', 0.0220, 'lps'),
	(364638, 124, '2015-01-15 01:26:36.000000', 'consum', 0.0227, 'lps'),
	(364639, 124, '2015-01-15 01:26:37.000000', 'consum', 0.0220, 'lps'),
	(364640, 124, '2015-01-15 01:26:38.000000', 'consum', 0.0212, 'lps'),
	(364641, 124, '2015-01-15 01:26:39.000000', 'consum', 0.0212, 'lps'),
	(364642, 124, '2015-01-15 01:26:40.000000', 'consum', 0.0213, 'lps'),
	(364643, 124, '2015-01-15 01:26:41.000000', 'consum', 0.0222, 'lps'),
	(364644, 124, '2015-01-15 01:26:42.000000', 'consum', 0.0216, 'lps'),
	(364645, 124, '2015-01-15 01:26:43.000000', 'consum', 0.0227, 'lps'),
	(364646, 124, '2015-01-15 01:26:44.000000', 'consum', 0.0212, 'lps'),
	(364647, 124, '2015-01-15 01:26:45.000000', 'consum', 0.0211, 'lps'),
	(364648, 124, '2015-01-15 01:26:46.000000', 'consum', 0.0211, 'lps'),
	(364649, 124, '2015-01-15 01:26:47.000000', 'consum', 0.0213, 'lps'),
	(364650, 124, '2015-01-15 01:26:48.000000', 'consum', 0.0222, 'lps'),
	(364651, 124, '2015-01-15 01:26:49.000000', 'consum', 0.0216, 'lps'),
	(364652, 124, '2015-01-15 01:26:50.000000', 'consum', 0.0226, 'lps'),
	(364653, 124, '2015-01-15 01:26:51.000000', 'consum', 0.0231, 'lps'),
	(364654, 124, '2015-01-15 01:26:52.000000', 'consum', 0.0222, 'lps'),
	(364655, 124, '2015-01-15 01:26:53.000000', 'consum', 0.0228, 'lps'),
	(364656, 124, '2015-01-15 01:26:54.000000', 'consum', 0.0223, 'lps'),
	(364657, 124, '2015-01-15 01:26:55.000000', 'consum', 0.0222, 'lps'),
	(364658, 124, '2015-01-15 01:26:56.000000', 'consum', 0.0229, 'lps'),
	(364659, 124, '2015-01-15 01:26:57.000000', 'consum', 0.0225, 'lps'),
	(364660, 124, '2015-01-15 01:26:58.000000', 'consum', 0.0231, 'lps'),
	(364661, 124, '2015-01-15 01:26:59.000000', 'consum', 0.0223, 'lps'),
	(364662, 124, '2015-01-15 01:27:00.000000', 'consum', 0.0216, 'lps'),
	(364663, 124, '2015-01-15 01:27:01.000000', 'consum', 0.0223, 'lps'),
	(364664, 124, '2015-01-15 01:27:02.000000', 'consum', 0.0212, 'lps'),
	(364665, 124, '2015-01-15 01:27:03.000000', 'consum', 0.0225, 'lps'),
	(364666, 124, '2015-01-15 01:27:04.000000', 'consum', 0.0213, 'lps'),
	(364667, 124, '2015-01-15 01:27:05.000000', 'consum', 0.0227, 'lps'),
	(364668, 124, '2015-01-15 01:27:06.000000', 'consum', 0.0220, 'lps'),
	(364669, 124, '2015-01-15 01:27:07.000000', 'consum', 0.0230, 'lps'),
	(364670, 124, '2015-01-15 01:27:08.000000', 'consum', 0.0214, 'lps'),
	(364671, 124, '2015-01-15 01:27:09.000000', 'consum', 0.0214, 'lps'),
	(364672, 124, '2015-01-15 01:27:10.000000', 'consum', 0.0220, 'lps'),
	(364673, 124, '2015-01-15 01:27:11.000000', 'consum', 0.0225, 'lps'),
	(364674, 124, '2015-01-15 01:27:12.000000', 'consum', 0.0213, 'lps'),
	(364675, 124, '2015-01-15 01:27:13.000000', 'consum', 0.0225, 'lps'),
	(364676, 124, '2015-01-15 01:27:14.000000', 'consum', 0.0231, 'lps'),
	(364677, 124, '2015-01-15 01:27:15.000000', 'consum', 0.0228, 'lps'),
	(364678, 124, '2015-01-15 01:27:16.000000', 'consum', 0.0215, 'lps'),
	(364679, 124, '2015-01-15 01:27:17.000000', 'consum', 0.0224, 'lps'),
	(364680, 124, '2015-01-15 01:27:18.000000', 'consum', 0.0224, 'lps'),
	(364681, 124, '2015-01-15 01:27:19.000000', 'consum', 0.0217, 'lps'),
	(364682, 124, '2015-01-15 01:27:20.000000', 'consum', 0.0226, 'lps'),
	(364683, 124, '2015-01-15 01:27:21.000000', 'consum', 0.0225, 'lps'),
	(364684, 124, '2015-01-15 01:27:22.000000', 'consum', 0.0216, 'lps'),
	(364685, 124, '2015-01-15 01:27:23.000000', 'consum', 0.0215, 'lps'),
	(364686, 124, '2015-01-15 01:27:24.000000', 'consum', 0.0220, 'lps'),
	(364687, 124, '2015-01-15 01:27:25.000000', 'consum', 0.0224, 'lps'),
	(364688, 124, '2015-01-15 01:27:26.000000', 'consum', 0.0226, 'lps'),
	(364689, 124, '2015-01-15 01:27:27.000000', 'consum', 0.0229, 'lps'),
	(364690, 124, '2015-01-15 01:27:28.000000', 'consum', 0.0211, 'lps'),
	(364691, 124, '2015-01-15 01:27:29.000000', 'consum', 0.0224, 'lps'),
	(364692, 124, '2015-01-15 01:27:30.000000', 'consum', 0.0211, 'lps'),
	(364693, 124, '2015-01-15 01:27:31.000000', 'consum', 0.0221, 'lps'),
	(364694, 124, '2015-01-15 01:27:32.000000', 'consum', 0.0216, 'lps'),
	(364695, 124, '2015-01-15 01:27:33.000000', 'consum', 0.0229, 'lps'),
	(364696, 124, '2015-01-15 01:27:34.000000', 'consum', 0.0223, 'lps'),
	(364697, 124, '2015-01-15 01:27:35.000000', 'consum', 0.0217, 'lps'),
	(364698, 124, '2015-01-15 01:27:36.000000', 'consum', 0.0230, 'lps'),
	(364699, 124, '2015-01-15 01:27:37.000000', 'consum', 0.0222, 'lps'),
	(364700, 124, '2015-01-15 01:27:38.000000', 'consum', 0.0210, 'lps'),
	(364701, 124, '2015-01-15 01:27:39.000000', 'consum', 0.0218, 'lps'),
	(364702, 124, '2015-01-15 01:27:40.000000', 'consum', 0.0229, 'lps'),
	(364703, 124, '2015-01-15 01:27:41.000000', 'consum', 0.0217, 'lps'),
	(364704, 124, '2015-01-15 01:27:42.000000', 'consum', 0.0231, 'lps'),
	(364705, 124, '2015-01-15 01:27:43.000000', 'consum', 0.0228, 'lps'),
	(364706, 124, '2015-01-15 01:27:44.000000', 'consum', 0.0215, 'lps'),
	(364707, 124, '2015-01-15 01:27:45.000000', 'consum', 0.0227, 'lps'),
	(364708, 124, '2015-01-15 01:27:46.000000', 'consum', 0.0215, 'lps'),
	(364709, 124, '2015-01-15 01:27:47.000000', 'consum', 0.0226, 'lps'),
	(364710, 124, '2015-01-15 01:27:48.000000', 'consum', 0.0212, 'lps'),
	(364711, 124, '2015-01-15 01:27:49.000000', 'consum', 0.0216, 'lps'),
	(364712, 124, '2015-01-15 01:27:50.000000', 'consum', 0.0211, 'lps'),
	(364713, 124, '2015-01-15 01:27:51.000000', 'consum', 0.0220, 'lps'),
	(364714, 124, '2015-01-15 01:27:52.000000', 'consum', 0.0213, 'lps'),
	(364715, 124, '2015-01-15 01:27:53.000000', 'consum', 0.0216, 'lps'),
	(364716, 124, '2015-01-15 01:27:54.000000', 'consum', 0.0213, 'lps'),
	(364717, 124, '2015-01-15 01:27:55.000000', 'consum', 0.0226, 'lps'),
	(364718, 124, '2015-01-15 01:27:56.000000', 'consum', 0.0218, 'lps'),
	(364719, 124, '2015-01-15 01:27:57.000000', 'consum', 0.0223, 'lps'),
	(364720, 124, '2015-01-15 01:27:58.000000', 'consum', 0.0210, 'lps'),
	(364721, 124, '2015-01-15 01:27:59.000000', 'consum', 0.0213, 'lps'),
	(364722, 124, '2015-01-15 01:28:00.000000', 'consum', 0.0228, 'lps'),
	(364723, 124, '2015-01-15 01:28:01.000000', 'consum', 0.0223, 'lps'),
	(364724, 124, '2015-01-15 01:28:02.000000', 'consum', 0.0223, 'lps'),
	(364725, 124, '2015-01-15 01:28:03.000000', 'consum', 0.0216, 'lps'),
	(364726, 124, '2015-01-15 01:28:04.000000', 'consum', 0.0221, 'lps'),
	(364727, 124, '2015-01-15 01:28:05.000000', 'consum', 0.0224, 'lps'),
	(364728, 124, '2015-01-15 01:28:06.000000', 'consum', 0.0228, 'lps'),
	(364729, 124, '2015-01-15 01:28:07.000000', 'consum', 0.0215, 'lps'),
	(364730, 124, '2015-01-15 01:28:08.000000', 'consum', 0.0223, 'lps'),
	(364731, 124, '2015-01-15 01:28:09.000000', 'consum', 0.0216, 'lps'),
	(364732, 124, '2015-01-15 01:28:10.000000', 'consum', 0.0226, 'lps'),
	(364733, 124, '2015-01-15 01:28:11.000000', 'consum', 0.0230, 'lps'),
	(364734, 124, '2015-01-15 01:28:12.000000', 'consum', 0.0215, 'lps'),
	(364735, 124, '2015-01-15 01:28:13.000000', 'consum', 0.0222, 'lps'),
	(364736, 124, '2015-01-15 01:28:14.000000', 'consum', 0.0211, 'lps'),
	(364737, 124, '2015-01-15 01:28:15.000000', 'consum', 0.0224, 'lps'),
	(364738, 124, '2015-01-15 01:28:16.000000', 'consum', 0.0213, 'lps'),
	(364739, 124, '2015-01-15 01:28:17.000000', 'consum', 0.0225, 'lps'),
	(364740, 124, '2015-01-15 01:28:18.000000', 'consum', 0.0212, 'lps'),
	(364741, 124, '2015-01-15 01:28:19.000000', 'consum', 0.0218, 'lps'),
	(364742, 124, '2015-01-15 01:28:20.000000', 'consum', 0.0222, 'lps'),
	(364743, 124, '2015-01-15 01:28:21.000000', 'consum', 0.0225, 'lps'),
	(364744, 124, '2015-01-15 01:28:22.000000', 'consum', 0.0229, 'lps'),
	(364745, 124, '2015-01-15 01:28:23.000000', 'consum', 0.0217, 'lps'),
	(364746, 124, '2015-01-15 01:28:24.000000', 'consum', 0.0210, 'lps'),
	(364747, 124, '2015-01-15 01:28:25.000000', 'consum', 0.0210, 'lps'),
	(364748, 124, '2015-01-15 01:28:26.000000', 'consum', 0.0211, 'lps'),
	(364749, 124, '2015-01-15 01:28:27.000000', 'consum', 0.0214, 'lps'),
	(364750, 124, '2015-01-15 01:28:28.000000', 'consum', 0.0228, 'lps'),
	(364751, 124, '2015-01-15 01:28:29.000000', 'consum', 0.0223, 'lps'),
	(364752, 124, '2015-01-15 01:28:30.000000', 'consum', 0.0223, 'lps'),
	(364753, 124, '2015-01-15 01:28:31.000000', 'consum', 0.0213, 'lps'),
	(364754, 124, '2015-01-15 01:28:32.000000', 'consum', 0.0231, 'lps'),
	(364755, 124, '2015-01-15 01:28:33.000000', 'consum', 0.0217, 'lps'),
	(364756, 124, '2015-01-15 01:28:34.000000', 'consum', 0.0229, 'lps'),
	(364757, 124, '2015-01-15 01:28:35.000000', 'consum', 0.0220, 'lps'),
	(364758, 124, '2015-01-15 01:28:36.000000', 'consum', 0.0222, 'lps'),
	(364759, 124, '2015-01-15 01:28:37.000000', 'consum', 0.0218, 'lps'),
	(364760, 124, '2015-01-15 01:28:38.000000', 'consum', 0.0215, 'lps'),
	(364761, 124, '2015-01-15 01:28:39.000000', 'consum', 0.0211, 'lps'),
	(364762, 124, '2015-01-15 01:28:40.000000', 'consum', 0.0222, 'lps'),
	(364763, 124, '2015-01-15 01:28:41.000000', 'consum', 0.0225, 'lps'),
	(364764, 124, '2015-01-15 01:28:42.000000', 'consum', 0.0228, 'lps'),
	(364765, 124, '2015-01-15 01:28:43.000000', 'consum', 0.0210, 'lps'),
	(364766, 124, '2015-01-15 01:28:44.000000', 'consum', 0.0222, 'lps'),
	(364767, 124, '2015-01-15 01:28:45.000000', 'consum', 0.0229, 'lps'),
	(364768, 124, '2015-01-15 01:28:46.000000', 'consum', 0.0225, 'lps'),
	(364769, 124, '2015-01-15 01:28:47.000000', 'consum', 0.0228, 'lps'),
	(364770, 124, '2015-01-15 01:28:48.000000', 'consum', 0.0212, 'lps'),
	(364771, 124, '2015-01-15 01:28:49.000000', 'consum', 0.0211, 'lps'),
	(364772, 124, '2015-01-15 01:28:50.000000', 'consum', 0.0211, 'lps'),
	(364773, 124, '2015-01-15 01:28:51.000000', 'consum', 0.0211, 'lps'),
	(364774, 124, '2015-01-15 01:28:52.000000', 'consum', 0.0213, 'lps'),
	(364775, 124, '2015-01-15 01:28:53.000000', 'consum', 0.0224, 'lps'),
	(364776, 124, '2015-01-15 01:28:54.000000', 'consum', 0.0227, 'lps'),
	(364777, 124, '2015-01-15 01:28:55.000000', 'consum', 0.0210, 'lps'),
	(364778, 124, '2015-01-15 01:28:56.000000', 'consum', 0.0227, 'lps'),
	(364779, 124, '2015-01-15 01:28:57.000000', 'consum', 0.0226, 'lps'),
	(364780, 124, '2015-01-15 01:28:58.000000', 'consum', 0.0219, 'lps'),
	(364781, 124, '2015-01-15 01:28:59.000000', 'consum', 0.0231, 'lps'),
	(364782, 124, '2015-01-15 01:29:00.000000', 'consum', 0.0221, 'lps'),
	(364783, 124, '2015-01-15 01:29:01.000000', 'consum', 0.0226, 'lps'),
	(364784, 124, '2015-01-15 01:29:02.000000', 'consum', 0.0213, 'lps'),
	(364785, 124, '2015-01-15 01:29:03.000000', 'consum', 0.0221, 'lps'),
	(364786, 124, '2015-01-15 01:29:04.000000', 'consum', 0.0213, 'lps'),
	(364787, 124, '2015-01-15 01:29:05.000000', 'consum', 0.0214, 'lps'),
	(364788, 124, '2015-01-15 01:29:06.000000', 'consum', 0.0223, 'lps'),
	(364789, 124, '2015-01-15 01:29:07.000000', 'consum', 0.0221, 'lps'),
	(364790, 124, '2015-01-15 01:29:08.000000', 'consum', 0.0223, 'lps'),
	(364791, 124, '2015-01-15 01:29:09.000000', 'consum', 0.0221, 'lps'),
	(364792, 124, '2015-01-15 01:29:10.000000', 'consum', 0.0226, 'lps'),
	(364793, 124, '2015-01-15 01:29:11.000000', 'consum', 0.0216, 'lps'),
	(364794, 124, '2015-01-15 01:29:12.000000', 'consum', 0.0212, 'lps'),
	(364795, 124, '2015-01-15 01:29:13.000000', 'consum', 0.0225, 'lps'),
	(364796, 124, '2015-01-15 01:29:14.000000', 'consum', 0.0216, 'lps'),
	(364797, 124, '2015-01-15 01:29:15.000000', 'consum', 0.0216, 'lps'),
	(364798, 124, '2015-01-15 01:29:16.000000', 'consum', 0.0221, 'lps'),
	(364799, 124, '2015-01-15 01:29:17.000000', 'consum', 0.0225, 'lps'),
	(364800, 124, '2015-01-15 01:29:18.000000', 'consum', 0.0230, 'lps'),
	(364801, 124, '2015-01-15 01:29:19.000000', 'consum', 0.0222, 'lps'),
	(364802, 124, '2015-01-15 01:29:20.000000', 'consum', 0.0212, 'lps'),
	(364803, 124, '2015-01-15 01:29:21.000000', 'consum', 0.0227, 'lps'),
	(364804, 124, '2015-01-15 01:29:22.000000', 'consum', 0.0224, 'lps'),
	(364805, 124, '2015-01-15 01:29:23.000000', 'consum', 0.0228, 'lps'),
	(364806, 124, '2015-01-15 01:29:24.000000', 'consum', 0.0216, 'lps'),
	(364807, 124, '2015-01-15 01:29:25.000000', 'consum', 0.0229, 'lps'),
	(364808, 124, '2015-01-15 01:29:26.000000', 'consum', 0.0223, 'lps'),
	(364809, 124, '2015-01-15 01:29:27.000000', 'consum', 0.0216, 'lps'),
	(364810, 124, '2015-01-15 01:29:28.000000', 'consum', 0.0225, 'lps'),
	(364811, 124, '2015-01-15 01:29:29.000000', 'consum', 0.0222, 'lps'),
	(364812, 124, '2015-01-15 01:29:30.000000', 'consum', 0.0227, 'lps'),
	(364813, 124, '2015-01-15 01:29:31.000000', 'consum', 0.0215, 'lps'),
	(364814, 124, '2015-01-15 01:29:32.000000', 'consum', 0.0229, 'lps'),
	(364815, 124, '2015-01-15 01:29:33.000000', 'consum', 0.0224, 'lps'),
	(364816, 124, '2015-01-15 01:29:34.000000', 'consum', 0.0226, 'lps'),
	(364817, 124, '2015-01-15 01:29:35.000000', 'consum', 0.0223, 'lps'),
	(364818, 124, '2015-01-15 01:29:36.000000', 'consum', 0.0230, 'lps'),
	(364819, 124, '2015-01-15 01:29:37.000000', 'consum', 0.0228, 'lps'),
	(364820, 124, '2015-01-15 01:29:38.000000', 'consum', 0.0219, 'lps'),
	(364821, 124, '2015-01-15 01:29:39.000000', 'consum', 0.0224, 'lps'),
	(364822, 124, '2015-01-15 01:29:40.000000', 'consum', 0.0210, 'lps'),
	(364823, 124, '2015-01-15 01:29:41.000000', 'consum', 0.0210, 'lps'),
	(364824, 124, '2015-01-15 01:29:42.000000', 'consum', 0.0211, 'lps'),
	(364825, 124, '2015-01-15 01:29:43.000000', 'consum', 0.0214, 'lps'),
	(364826, 124, '2015-01-15 01:29:44.000000', 'consum', 0.0229, 'lps'),
	(364827, 124, '2015-01-15 01:29:45.000000', 'consum', 0.0229, 'lps'),
	(364828, 124, '2015-01-15 01:29:46.000000', 'consum', 0.0227, 'lps'),
	(364829, 124, '2015-01-15 01:29:47.000000', 'consum', 0.0216, 'lps'),
	(364830, 124, '2015-01-15 01:29:48.000000', 'consum', 0.0211, 'lps'),
	(364831, 124, '2015-01-15 01:29:49.000000', 'consum', 0.0217, 'lps'),
	(364832, 124, '2015-01-15 01:29:50.000000', 'consum', 0.0224, 'lps'),
	(364833, 124, '2015-01-15 01:29:51.000000', 'consum', 0.0216, 'lps'),
	(364834, 124, '2015-01-15 01:29:52.000000', 'consum', 0.0218, 'lps'),
	(364835, 124, '2015-01-15 01:29:53.000000', 'consum', 0.0212, 'lps'),
	(364836, 124, '2015-01-15 01:29:54.000000', 'consum', 0.0220, 'lps'),
	(364837, 124, '2015-01-15 01:29:55.000000', 'consum', 0.0230, 'lps'),
	(364838, 124, '2015-01-15 01:29:56.000000', 'consum', 0.0215, 'lps'),
	(364839, 124, '2015-01-15 01:29:57.000000', 'consum', 0.0218, 'lps'),
	(364840, 124, '2015-01-15 01:29:58.000000', 'consum', 0.0214, 'lps'),
	(364841, 124, '2015-01-15 01:29:59.000000', 'consum', 0.0229, 'lps'),
	(364842, 124, '2015-01-15 01:30:00.000000', 'consum', 0.0228, 'lps'),
	(364843, 124, '2015-01-15 01:30:01.000000', 'consum', 0.0220, 'lps'),
	(364844, 124, '2015-01-15 01:30:02.000000', 'consum', 0.0228, 'lps'),
	(364845, 124, '2015-01-15 01:30:03.000000', 'consum', 0.0226, 'lps'),
	(364846, 124, '2015-01-15 01:30:04.000000', 'consum', 0.0216, 'lps'),
	(364847, 124, '2015-01-15 01:30:05.000000', 'consum', 0.0216, 'lps'),
	(364848, 124, '2015-01-15 01:30:06.000000', 'consum', 0.0220, 'lps'),
	(364849, 124, '2015-01-15 01:30:07.000000', 'consum', 0.0222, 'lps'),
	(364850, 124, '2015-01-15 01:30:08.000000', 'consum', 0.0219, 'lps'),
	(364851, 124, '2015-01-15 01:30:09.000000', 'consum', 0.0218, 'lps'),
	(364852, 124, '2015-01-15 01:30:10.000000', 'consum', 0.0225, 'lps'),
	(364853, 124, '2015-01-15 01:30:11.000000', 'consum', 0.0217, 'lps'),
	(364854, 124, '2015-01-15 01:30:12.000000', 'consum', 0.0224, 'lps'),
	(364855, 124, '2015-01-15 01:30:13.000000', 'consum', 0.0215, 'lps'),
	(364856, 124, '2015-01-15 01:30:14.000000', 'consum', 0.0214, 'lps'),
	(364857, 124, '2015-01-15 01:30:15.000000', 'consum', 0.0217, 'lps'),
	(364858, 124, '2015-01-15 01:30:16.000000', 'consum', 0.0212, 'lps'),
	(364859, 124, '2015-01-15 01:30:17.000000', 'consum', 0.0219, 'lps'),
	(364860, 124, '2015-01-15 01:30:18.000000', 'consum', 0.0229, 'lps'),
	(364861, 124, '2015-01-15 01:30:19.000000', 'consum', 0.0212, 'lps'),
	(364862, 124, '2015-01-15 01:30:20.000000', 'consum', 0.0229, 'lps'),
	(364863, 124, '2015-01-15 01:30:21.000000', 'consum', 0.0210, 'lps'),
	(364864, 124, '2015-01-15 01:30:22.000000', 'consum', 0.0220, 'lps'),
	(364865, 124, '2015-01-15 01:30:23.000000', 'consum', 0.0219, 'lps'),
	(364866, 124, '2015-01-15 01:30:24.000000', 'consum', 0.0223, 'lps'),
	(364867, 124, '2015-01-15 01:30:25.000000', 'consum', 0.0228, 'lps'),
	(364868, 124, '2015-01-15 01:30:26.000000', 'consum', 0.0219, 'lps'),
	(364869, 124, '2015-01-15 01:30:27.000000', 'consum', 0.0221, 'lps'),
	(364870, 124, '2015-01-15 01:30:28.000000', 'consum', 0.0217, 'lps'),
	(364871, 124, '2015-01-15 01:30:29.000000', 'consum', 0.0211, 'lps'),
	(364872, 124, '2015-01-15 01:30:30.000000', 'consum', 0.0217, 'lps'),
	(364873, 124, '2015-01-15 01:30:31.000000', 'consum', 0.0220, 'lps'),
	(364874, 124, '2015-01-15 01:30:32.000000', 'consum', 0.0219, 'lps'),
	(364875, 124, '2015-01-15 01:30:33.000000', 'consum', 0.0225, 'lps'),
	(364876, 124, '2015-01-15 01:30:34.000000', 'consum', 0.0215, 'lps'),
	(364877, 124, '2015-01-15 01:30:35.000000', 'consum', 0.0210, 'lps'),
	(364878, 124, '2015-01-15 01:30:36.000000', 'consum', 0.0219, 'lps'),
	(364879, 124, '2015-01-15 01:30:37.000000', 'consum', 0.0211, 'lps'),
	(364880, 124, '2015-01-15 01:30:38.000000', 'consum', 0.0210, 'lps'),
	(364881, 124, '2015-01-15 01:30:39.000000', 'consum', 0.0210, 'lps'),
	(364882, 124, '2015-01-15 01:30:40.000000', 'consum', 0.0230, 'lps'),
	(364883, 124, '2015-01-15 01:30:41.000000', 'consum', 0.0221, 'lps'),
	(364884, 124, '2015-01-15 01:30:42.000000', 'consum', 0.0231, 'lps'),
	(364885, 124, '2015-01-15 01:30:43.000000', 'consum', 0.0216, 'lps'),
	(364886, 124, '2015-01-15 01:30:44.000000', 'consum', 0.0221, 'lps'),
	(364887, 124, '2015-01-15 01:30:45.000000', 'consum', 0.0224, 'lps'),
	(364888, 124, '2015-01-15 01:30:46.000000', 'consum', 0.0226, 'lps'),
	(364889, 124, '2015-01-15 01:30:47.000000', 'consum', 0.0227, 'lps'),
	(364890, 124, '2015-01-15 01:30:48.000000', 'consum', 0.0223, 'lps'),
	(364891, 124, '2015-01-15 01:30:49.000000', 'consum', 0.0228, 'lps'),
	(364892, 124, '2015-01-15 01:30:50.000000', 'consum', 0.0216, 'lps'),
	(364893, 124, '2015-01-15 01:30:51.000000', 'consum', 0.0230, 'lps'),
	(364894, 124, '2015-01-15 01:30:52.000000', 'consum', 0.0226, 'lps'),
	(364895, 124, '2015-01-15 01:30:53.000000', 'consum', 0.0210, 'lps'),
	(364896, 124, '2015-01-15 01:30:54.000000', 'consum', 0.0228, 'lps'),
	(364897, 124, '2015-01-15 01:30:55.000000', 'consum', 0.0214, 'lps'),
	(364898, 124, '2015-01-15 01:30:56.000000', 'consum', 0.0220, 'lps'),
	(364899, 124, '2015-01-15 01:30:57.000000', 'consum', 0.0226, 'lps'),
	(364900, 124, '2015-01-15 01:30:58.000000', 'consum', 0.0216, 'lps'),
	(364901, 124, '2015-01-15 01:30:59.000000', 'consum', 0.0217, 'lps'),
	(364902, 124, '2015-01-15 01:31:00.000000', 'consum', 0.0225, 'lps'),
	(364903, 124, '2015-01-15 01:31:01.000000', 'consum', 0.0220, 'lps'),
	(364904, 124, '2015-01-15 01:31:02.000000', 'consum', 0.0218, 'lps'),
	(364905, 124, '2015-01-15 01:31:03.000000', 'consum', 0.0219, 'lps'),
	(364906, 124, '2015-01-15 01:31:04.000000', 'consum', 0.0231, 'lps'),
	(364907, 124, '2015-01-15 01:31:05.000000', 'consum', 0.0224, 'lps'),
	(364908, 124, '2015-01-15 01:31:06.000000', 'consum', 0.0218, 'lps'),
	(364909, 124, '2015-01-15 01:31:07.000000', 'consum', 0.0229, 'lps'),
	(364910, 124, '2015-01-15 01:31:08.000000', 'consum', 0.0218, 'lps'),
	(364911, 124, '2015-01-15 01:31:09.000000', 'consum', 0.0212, 'lps'),
	(364912, 124, '2015-01-15 01:31:10.000000', 'consum', 0.0220, 'lps'),
	(364913, 124, '2015-01-15 01:31:11.000000', 'consum', 0.0212, 'lps'),
	(364914, 124, '2015-01-15 01:31:12.000000', 'consum', 0.0213, 'lps'),
	(364915, 124, '2015-01-15 01:31:13.000000', 'consum', 0.0217, 'lps'),
	(364916, 124, '2015-01-15 01:31:14.000000', 'consum', 0.0216, 'lps'),
	(364917, 124, '2015-01-15 01:31:15.000000', 'consum', 0.0221, 'lps'),
	(364918, 124, '2015-01-15 01:31:16.000000', 'consum', 0.0222, 'lps'),
	(364919, 124, '2015-01-15 01:31:17.000000', 'consum', 0.0218, 'lps'),
	(364920, 124, '2015-01-15 01:31:18.000000', 'consum', 0.0213, 'lps'),
	(364921, 124, '2015-01-15 01:31:19.000000', 'consum', 0.0222, 'lps'),
	(364922, 124, '2015-01-15 01:31:20.000000', 'consum', 0.0220, 'lps'),
	(364923, 124, '2015-01-15 01:31:21.000000', 'consum', 0.0223, 'lps'),
	(364924, 124, '2015-01-15 01:31:22.000000', 'consum', 0.0226, 'lps'),
	(364925, 124, '2015-01-15 01:31:23.000000', 'consum', 0.0226, 'lps'),
	(364926, 124, '2015-01-15 01:31:24.000000', 'consum', 0.0223, 'lps'),
	(364927, 124, '2015-01-15 01:31:25.000000', 'consum', 0.0228, 'lps'),
	(364928, 124, '2015-01-15 01:31:26.000000', 'consum', 0.0218, 'lps'),
	(364929, 124, '2015-01-15 01:31:27.000000', 'consum', 0.0217, 'lps'),
	(364930, 124, '2015-01-15 01:31:28.000000', 'consum', 0.0224, 'lps'),
	(364931, 124, '2015-01-15 01:31:29.000000', 'consum', 0.0214, 'lps'),
	(364932, 124, '2015-01-15 01:31:30.000000', 'consum', 0.0210, 'lps'),
	(364933, 124, '2015-01-15 01:31:31.000000', 'consum', 0.0222, 'lps'),
	(364934, 124, '2015-01-15 01:31:32.000000', 'consum', 0.0224, 'lps'),
	(364935, 124, '2015-01-15 01:31:33.000000', 'consum', 0.0223, 'lps'),
	(364936, 124, '2015-01-15 01:31:34.000000', 'consum', 0.0213, 'lps'),
	(364937, 124, '2015-01-15 01:31:35.000000', 'consum', 0.0228, 'lps'),
	(364938, 124, '2015-01-15 01:31:36.000000', 'consum', 0.0226, 'lps'),
	(364939, 124, '2015-01-15 01:31:37.000000', 'consum', 0.0214, 'lps'),
	(364940, 124, '2015-01-15 01:31:38.000000', 'consum', 0.0225, 'lps'),
	(364941, 124, '2015-01-15 01:31:39.000000', 'consum', 0.0210, 'lps'),
	(364942, 124, '2015-01-15 01:31:40.000000', 'consum', 0.0231, 'lps'),
	(364943, 124, '2015-01-15 01:31:41.000000', 'consum', 0.0226, 'lps'),
	(364944, 124, '2015-01-15 01:31:42.000000', 'consum', 0.0229, 'lps'),
	(364945, 124, '2015-01-15 01:31:43.000000', 'consum', 0.0215, 'lps'),
	(364946, 124, '2015-01-15 01:31:44.000000', 'consum', 0.0222, 'lps'),
	(364947, 124, '2015-01-15 01:31:45.000000', 'consum', 0.0210, 'lps'),
	(364948, 124, '2015-01-15 01:31:46.000000', 'consum', 0.0219, 'lps'),
	(364949, 124, '2015-01-15 01:31:47.000000', 'consum', 0.0212, 'lps'),
	(364950, 124, '2015-01-15 01:31:48.000000', 'consum', 0.0217, 'lps'),
	(364951, 124, '2015-01-15 01:31:49.000000', 'consum', 0.0215, 'lps'),
	(364952, 124, '2015-01-15 01:31:50.000000', 'consum', 0.0214, 'lps'),
	(364953, 124, '2015-01-15 01:31:51.000000', 'consum', 0.0215, 'lps'),
	(364954, 124, '2015-01-15 01:31:52.000000', 'consum', 0.0226, 'lps'),
	(364955, 124, '2015-01-15 01:31:53.000000', 'consum', 0.0210, 'lps'),
	(364956, 124, '2015-01-15 01:31:54.000000', 'consum', 0.0226, 'lps'),
	(364957, 124, '2015-01-15 01:31:55.000000', 'consum', 0.0226, 'lps'),
	(364958, 124, '2015-01-15 01:31:56.000000', 'consum', 0.0221, 'lps'),
	(364959, 124, '2015-01-15 01:31:57.000000', 'consum', 0.0218, 'lps'),
	(364960, 124, '2015-01-15 01:31:58.000000', 'consum', 0.0218, 'lps'),
	(364961, 124, '2015-01-15 01:31:59.000000', 'consum', 0.0226, 'lps'),
	(364962, 124, '2015-01-15 01:32:00.000000', 'consum', 0.0222, 'lps'),
	(364963, 124, '2015-01-15 01:32:01.000000', 'consum', 0.0225, 'lps'),
	(364964, 124, '2015-01-15 01:32:02.000000', 'consum', 0.0225, 'lps'),
	(364965, 124, '2015-01-15 01:32:03.000000', 'consum', 0.0218, 'lps'),
	(364966, 124, '2015-01-15 01:32:04.000000', 'consum', 0.0230, 'lps'),
	(364967, 124, '2015-01-15 01:32:05.000000', 'consum', 0.0219, 'lps'),
	(364968, 124, '2015-01-15 01:32:06.000000', 'consum', 0.0220, 'lps'),
	(364969, 124, '2015-01-15 01:32:07.000000', 'consum', 0.0231, 'lps'),
	(364970, 124, '2015-01-15 01:32:08.000000', 'consum', 0.0219, 'lps'),
	(364971, 124, '2015-01-15 01:32:09.000000', 'consum', 0.0217, 'lps'),
	(364972, 124, '2015-01-15 01:32:10.000000', 'consum', 0.0216, 'lps'),
	(364973, 124, '2015-01-15 01:32:11.000000', 'consum', 0.0221, 'lps'),
	(364974, 124, '2015-01-15 01:32:12.000000', 'consum', 0.0225, 'lps'),
	(364975, 124, '2015-01-15 01:32:13.000000', 'consum', 0.0210, 'lps'),
	(364976, 124, '2015-01-15 01:32:14.000000', 'consum', 0.0231, 'lps'),
	(364977, 124, '2015-01-15 01:32:15.000000', 'consum', 0.0228, 'lps'),
	(364978, 124, '2015-01-15 01:32:16.000000', 'consum', 0.0217, 'lps'),
	(364979, 124, '2015-01-15 01:32:17.000000', 'consum', 0.0211, 'lps'),
	(364980, 124, '2015-01-15 01:32:18.000000', 'consum', 0.0218, 'lps'),
	(364981, 124, '2015-01-15 01:32:19.000000', 'consum', 0.0224, 'lps'),
	(364982, 124, '2015-01-15 01:32:20.000000', 'consum', 0.0213, 'lps'),
	(364983, 124, '2015-01-15 01:32:21.000000', 'consum', 0.0229, 'lps'),
	(364984, 124, '2015-01-15 01:32:22.000000', 'consum', 0.0230, 'lps'),
	(364985, 124, '2015-01-15 01:32:23.000000', 'consum', 0.0211, 'lps'),
	(364986, 124, '2015-01-15 01:32:24.000000', 'consum', 0.0219, 'lps'),
	(364987, 124, '2015-01-15 01:32:25.000000', 'consum', 0.0229, 'lps'),
	(364988, 124, '2015-01-15 01:32:26.000000', 'consum', 0.0216, 'lps'),
	(364989, 124, '2015-01-15 01:32:27.000000', 'consum', 0.0224, 'lps'),
	(364990, 124, '2015-01-15 01:32:28.000000', 'consum', 0.0221, 'lps'),
	(364991, 124, '2015-01-15 01:32:29.000000', 'consum', 0.0221, 'lps'),
	(364992, 124, '2015-01-15 01:32:30.000000', 'consum', 0.0211, 'lps'),
	(364993, 124, '2015-01-15 01:32:31.000000', 'consum', 0.0227, 'lps'),
	(364994, 124, '2015-01-15 01:32:32.000000', 'consum', 0.0226, 'lps'),
	(364995, 124, '2015-01-15 01:32:33.000000', 'consum', 0.0218, 'lps'),
	(364996, 124, '2015-01-15 01:32:34.000000', 'consum', 0.0223, 'lps'),
	(364997, 124, '2015-01-15 01:32:35.000000', 'consum', 0.0210, 'lps'),
	(364998, 124, '2015-01-15 01:32:36.000000', 'consum', 0.0215, 'lps'),
	(364999, 124, '2015-01-15 01:32:37.000000', 'consum', 0.0213, 'lps'),
	(365000, 124, '2015-01-15 01:32:38.000000', 'consum', 0.0211, 'lps'),
	(365001, 124, '2015-01-15 01:32:39.000000', 'consum', 0.0230, 'lps'),
	(365002, 124, '2015-01-15 01:32:40.000000', 'consum', 0.0217, 'lps'),
	(365003, 124, '2015-01-15 01:32:41.000000', 'consum', 0.0228, 'lps'),
	(365004, 124, '2015-01-15 01:32:42.000000', 'consum', 0.0217, 'lps'),
	(365005, 124, '2015-01-15 01:32:43.000000', 'consum', 0.0210, 'lps'),
	(365006, 124, '2015-01-15 01:32:44.000000', 'consum', 0.0213, 'lps'),
	(365007, 124, '2015-01-15 01:32:45.000000', 'consum', 0.0227, 'lps'),
	(365008, 124, '2015-01-15 01:32:46.000000', 'consum', 0.0220, 'lps'),
	(365009, 124, '2015-01-15 01:32:47.000000', 'consum', 0.0229, 'lps'),
	(365010, 124, '2015-01-15 01:32:48.000000', 'consum', 0.0213, 'lps'),
	(365011, 124, '2015-01-15 01:32:49.000000', 'consum', 0.0211, 'lps'),
	(365012, 124, '2015-01-15 01:32:50.000000', 'consum', 0.0227, 'lps'),
	(365013, 124, '2015-01-15 01:32:51.000000', 'consum', 0.0228, 'lps'),
	(365014, 124, '2015-01-15 01:32:52.000000', 'consum', 0.0226, 'lps'),
	(365015, 124, '2015-01-15 01:32:53.000000', 'consum', 0.0215, 'lps'),
	(365016, 124, '2015-01-15 01:32:54.000000', 'consum', 0.0231, 'lps'),
	(365017, 124, '2015-01-15 01:32:55.000000', 'consum', 0.0212, 'lps'),
	(365018, 124, '2015-01-15 01:32:56.000000', 'consum', 0.0226, 'lps'),
	(365019, 124, '2015-01-15 01:32:57.000000', 'consum', 0.0217, 'lps'),
	(365020, 124, '2015-01-15 01:32:58.000000', 'consum', 0.0218, 'lps'),
	(365021, 124, '2015-01-15 01:32:59.000000', 'consum', 0.0229, 'lps'),
	(365022, 124, '2015-01-15 01:33:00.000000', 'consum', 0.0215, 'lps'),
	(365023, 124, '2015-01-15 01:33:01.000000', 'consum', 0.0224, 'lps'),
	(365024, 124, '2015-01-15 01:33:02.000000', 'consum', 0.0222, 'lps'),
	(365025, 124, '2015-01-15 01:33:03.000000', 'consum', 0.0227, 'lps'),
	(365026, 124, '2015-01-15 01:33:04.000000', 'consum', 0.0216, 'lps'),
	(365027, 124, '2015-01-15 01:33:05.000000', 'consum', 0.0214, 'lps'),
	(365028, 124, '2015-01-15 01:33:06.000000', 'consum', 0.0231, 'lps'),
	(365029, 124, '2015-01-15 01:33:07.000000', 'consum', 0.0219, 'lps'),
	(365030, 124, '2015-01-15 01:33:08.000000', 'consum', 0.0212, 'lps'),
	(365031, 124, '2015-01-15 01:33:09.000000', 'consum', 0.0215, 'lps'),
	(365032, 124, '2015-01-15 01:33:10.000000', 'consum', 0.0231, 'lps'),
	(365033, 124, '2015-01-15 01:33:11.000000', 'consum', 0.0213, 'lps'),
	(365034, 124, '2015-01-15 01:33:12.000000', 'consum', 0.0228, 'lps'),
	(365035, 124, '2015-01-15 01:33:13.000000', 'consum', 0.0224, 'lps'),
	(365036, 124, '2015-01-15 01:33:14.000000', 'consum', 0.0229, 'lps'),
	(365037, 124, '2015-01-15 01:33:15.000000', 'consum', 0.0219, 'lps'),
	(365038, 124, '2015-01-15 01:33:16.000000', 'consum', 0.0221, 'lps'),
	(365039, 124, '2015-01-15 01:33:17.000000', 'consum', 0.0218, 'lps'),
	(365040, 124, '2015-01-15 01:33:18.000000', 'consum', 0.0215, 'lps'),
	(365041, 124, '2015-01-15 01:33:19.000000', 'consum', 0.0211, 'lps'),
	(365042, 124, '2015-01-15 01:33:20.000000', 'consum', 0.0224, 'lps'),
	(365043, 124, '2015-01-15 01:33:21.000000', 'consum', 0.0211, 'lps'),
	(365044, 124, '2015-01-15 01:33:22.000000', 'consum', 0.0218, 'lps'),
	(365045, 124, '2015-01-15 01:33:23.000000', 'consum', 0.0226, 'lps'),
	(365046, 124, '2015-01-15 01:33:24.000000', 'consum', 0.0222, 'lps'),
	(365047, 124, '2015-01-15 01:33:25.000000', 'consum', 0.0222, 'lps'),
	(365048, 124, '2015-01-15 01:33:26.000000', 'consum', 0.0212, 'lps'),
	(365049, 124, '2015-01-15 01:33:27.000000', 'consum', 0.0229, 'lps'),
	(365050, 124, '2015-01-15 01:33:28.000000', 'consum', 0.0213, 'lps'),
	(365051, 124, '2015-01-15 01:33:29.000000', 'consum', 0.0211, 'lps'),
	(365052, 124, '2015-01-15 01:33:30.000000', 'consum', 0.0230, 'lps'),
	(365053, 124, '2015-01-15 01:33:31.000000', 'consum', 0.0219, 'lps'),
	(365054, 124, '2015-01-15 01:33:32.000000', 'consum', 0.0218, 'lps'),
	(365055, 124, '2015-01-15 01:33:33.000000', 'consum', 0.0222, 'lps'),
	(365056, 124, '2015-01-15 01:33:34.000000', 'consum', 0.0224, 'lps'),
	(365057, 124, '2015-01-15 01:33:35.000000', 'consum', 0.0224, 'lps'),
	(365058, 124, '2015-01-15 01:33:36.000000', 'consum', 0.0215, 'lps'),
	(365059, 124, '2015-01-15 01:33:37.000000', 'consum', 0.0216, 'lps'),
	(365060, 124, '2015-01-15 01:33:38.000000', 'consum', 0.0228, 'lps'),
	(365061, 124, '2015-01-15 01:33:39.000000', 'consum', 0.0213, 'lps'),
	(365062, 124, '2015-01-15 01:33:40.000000', 'consum', 0.0217, 'lps'),
	(365063, 124, '2015-01-15 01:33:41.000000', 'consum', 0.0215, 'lps'),
	(365064, 124, '2015-01-15 01:33:42.000000', 'consum', 0.0215, 'lps'),
	(365065, 124, '2015-01-15 01:33:43.000000', 'consum', 0.0218, 'lps'),
	(365066, 124, '2015-01-15 01:33:44.000000', 'consum', 0.0215, 'lps'),
	(365067, 124, '2015-01-15 01:33:45.000000', 'consum', 0.0210, 'lps'),
	(365068, 124, '2015-01-15 01:33:46.000000', 'consum', 0.0218, 'lps'),
	(365069, 124, '2015-01-15 01:33:47.000000', 'consum', 0.0230, 'lps'),
	(365070, 124, '2015-01-15 01:33:48.000000', 'consum', 0.0218, 'lps'),
	(365071, 124, '2015-01-15 01:33:49.000000', 'consum', 0.0212, 'lps'),
	(365072, 124, '2015-01-15 01:33:50.000000', 'consum', 0.0219, 'lps'),
	(365073, 124, '2015-01-15 01:33:51.000000', 'consum', 0.0227, 'lps'),
	(365074, 124, '2015-01-15 01:33:52.000000', 'consum', 0.0227, 'lps'),
	(365075, 124, '2015-01-15 01:33:53.000000', 'consum', 0.0219, 'lps'),
	(365076, 124, '2015-01-15 01:33:54.000000', 'consum', 0.0229, 'lps'),
	(365077, 124, '2015-01-15 01:33:55.000000', 'consum', 0.0213, 'lps'),
	(365078, 124, '2015-01-15 01:33:56.000000', 'consum', 0.0211, 'lps'),
	(365079, 124, '2015-01-15 01:33:57.000000', 'consum', 0.0229, 'lps'),
	(365080, 124, '2015-01-15 01:33:58.000000', 'consum', 0.0214, 'lps'),
	(365081, 124, '2015-01-15 01:33:59.000000', 'consum', 0.0217, 'lps'),
	(365082, 124, '2015-01-15 01:34:00.000000', 'consum', 0.0211, 'lps'),
	(365083, 124, '2015-01-15 01:34:01.000000', 'consum', 0.0218, 'lps'),
	(365084, 124, '2015-01-15 01:34:02.000000', 'consum', 0.0225, 'lps'),
	(365085, 124, '2015-01-15 01:34:03.000000', 'consum', 0.0216, 'lps'),
	(365086, 124, '2015-01-15 01:34:04.000000', 'consum', 0.0218, 'lps'),
	(365087, 124, '2015-01-15 01:34:05.000000', 'consum', 0.0211, 'lps'),
	(365088, 124, '2015-01-15 01:34:06.000000', 'consum', 0.0215, 'lps'),
	(365089, 124, '2015-01-15 01:34:07.000000', 'consum', 0.0230, 'lps'),
	(365090, 124, '2015-01-15 01:34:08.000000', 'consum', 0.0210, 'lps'),
	(365091, 124, '2015-01-15 01:34:09.000000', 'consum', 0.0216, 'lps'),
	(365092, 124, '2015-01-15 01:34:10.000000', 'consum', 0.0217, 'lps'),
	(365093, 124, '2015-01-15 01:34:11.000000', 'consum', 0.0229, 'lps'),
	(365094, 124, '2015-01-15 01:34:12.000000', 'consum', 0.0217, 'lps'),
	(365095, 124, '2015-01-15 01:34:13.000000', 'consum', 0.0213, 'lps'),
	(365096, 124, '2015-01-15 01:34:14.000000', 'consum', 0.0226, 'lps'),
	(365097, 124, '2015-01-15 01:34:15.000000', 'consum', 0.0216, 'lps'),
	(365098, 124, '2015-01-15 01:34:16.000000', 'consum', 0.0212, 'lps'),
	(365099, 124, '2015-01-15 01:34:17.000000', 'consum', 0.0226, 'lps'),
	(365100, 124, '2015-01-15 01:34:18.000000', 'consum', 0.0216, 'lps'),
	(365101, 124, '2015-01-15 01:34:19.000000', 'consum', 0.0217, 'lps'),
	(365102, 124, '2015-01-15 01:34:20.000000', 'consum', 0.0227, 'lps'),
	(365103, 124, '2015-01-15 01:34:21.000000', 'consum', 0.0229, 'lps'),
	(365104, 124, '2015-01-15 01:34:22.000000', 'consum', 0.0210, 'lps'),
	(365105, 124, '2015-01-15 01:34:23.000000', 'consum', 0.0219, 'lps'),
	(365106, 124, '2015-01-15 01:34:24.000000', 'consum', 0.0213, 'lps'),
	(365107, 124, '2015-01-15 01:34:25.000000', 'consum', 0.0219, 'lps'),
	(365108, 124, '2015-01-15 01:34:26.000000', 'consum', 0.0224, 'lps'),
	(365109, 124, '2015-01-15 01:34:27.000000', 'consum', 0.0210, 'lps'),
	(365110, 124, '2015-01-15 01:34:28.000000', 'consum', 0.0211, 'lps'),
	(365111, 124, '2015-01-15 01:34:29.000000', 'consum', 0.0217, 'lps'),
	(365112, 124, '2015-01-15 01:34:30.000000', 'consum', 0.0220, 'lps'),
	(365113, 124, '2015-01-15 01:34:31.000000', 'consum', 0.0217, 'lps'),
	(365114, 124, '2015-01-15 01:34:32.000000', 'consum', 0.0215, 'lps'),
	(365115, 124, '2015-01-15 01:34:33.000000', 'consum', 0.0214, 'lps'),
	(365116, 124, '2015-01-15 01:34:34.000000', 'consum', 0.0216, 'lps'),
	(365117, 124, '2015-01-15 01:34:35.000000', 'consum', 0.0230, 'lps'),
	(365118, 124, '2015-01-15 01:34:36.000000', 'consum', 0.0226, 'lps'),
	(365119, 124, '2015-01-15 01:34:37.000000', 'consum', 0.0230, 'lps'),
	(365120, 124, '2015-01-15 01:34:38.000000', 'consum', 0.0217, 'lps'),
	(365121, 124, '2015-01-15 01:34:39.000000', 'consum', 0.0230, 'lps'),
	(365122, 124, '2015-01-15 01:34:40.000000', 'consum', 0.0225, 'lps'),
	(365123, 124, '2015-01-15 01:34:41.000000', 'consum', 0.0227, 'lps'),
	(365124, 124, '2015-01-15 01:34:42.000000', 'consum', 0.0226, 'lps'),
	(365125, 124, '2015-01-15 01:34:43.000000', 'consum', 0.0217, 'lps'),
	(365126, 124, '2015-01-15 01:34:44.000000', 'consum', 0.0221, 'lps'),
	(365127, 124, '2015-01-15 01:34:45.000000', 'consum', 0.0222, 'lps'),
	(365128, 124, '2015-01-15 01:34:46.000000', 'consum', 0.0217, 'lps'),
	(365129, 124, '2015-01-15 01:34:47.000000', 'consum', 0.0230, 'lps'),
	(365130, 124, '2015-01-15 01:34:48.000000', 'consum', 0.0225, 'lps'),
	(365131, 124, '2015-01-15 01:34:49.000000', 'consum', 0.0224, 'lps'),
	(365132, 124, '2015-01-15 01:34:50.000000', 'consum', 0.0214, 'lps'),
	(365133, 124, '2015-01-15 01:34:51.000000', 'consum', 0.0212, 'lps'),
	(365134, 124, '2015-01-15 01:34:52.000000', 'consum', 0.0231, 'lps'),
	(365135, 124, '2015-01-15 01:34:53.000000', 'consum', 0.0219, 'lps'),
	(365136, 124, '2015-01-15 01:34:54.000000', 'consum', 0.0217, 'lps'),
	(365137, 124, '2015-01-15 01:34:55.000000', 'consum', 0.0217, 'lps'),
	(365138, 124, '2015-01-15 01:34:56.000000', 'consum', 0.0223, 'lps'),
	(365139, 124, '2015-01-15 01:34:57.000000', 'consum', 0.0210, 'lps'),
	(365140, 124, '2015-01-15 01:34:58.000000', 'consum', 0.0219, 'lps'),
	(365141, 124, '2015-01-15 01:34:59.000000', 'consum', 0.0231, 'lps'),
	(365142, 124, '2015-01-15 01:35:00.000000', 'consum', 0.0225, 'lps'),
	(365143, 124, '2015-01-15 01:35:01.000000', 'consum', 0.0220, 'lps'),
	(365144, 124, '2015-01-15 01:35:02.000000', 'consum', 0.0218, 'lps'),
	(365145, 124, '2015-01-15 01:35:03.000000', 'consum', 0.0221, 'lps'),
	(365146, 124, '2015-01-15 01:35:04.000000', 'consum', 0.0220, 'lps'),
	(365147, 124, '2015-01-15 01:35:05.000000', 'consum', 0.0225, 'lps'),
	(365148, 124, '2015-01-15 01:35:06.000000', 'consum', 0.0213, 'lps'),
	(365149, 124, '2015-01-15 01:35:07.000000', 'consum', 0.0224, 'lps'),
	(365150, 124, '2015-01-15 01:35:08.000000', 'consum', 0.0229, 'lps'),
	(365151, 124, '2015-01-15 01:35:09.000000', 'consum', 0.0217, 'lps'),
	(365152, 124, '2015-01-15 01:35:10.000000', 'consum', 0.0212, 'lps'),
	(365153, 124, '2015-01-15 01:35:11.000000', 'consum', 0.0222, 'lps'),
	(365154, 124, '2015-01-15 01:35:12.000000', 'consum', 0.0221, 'lps'),
	(365155, 124, '2015-01-15 01:35:13.000000', 'consum', 0.0229, 'lps'),
	(365156, 124, '2015-01-15 01:35:14.000000', 'consum', 0.0227, 'lps'),
	(365157, 124, '2015-01-15 01:35:15.000000', 'consum', 0.0219, 'lps'),
	(365158, 124, '2015-01-15 01:35:16.000000', 'consum', 0.0224, 'lps'),
	(365159, 124, '2015-01-15 01:35:17.000000', 'consum', 0.0210, 'lps'),
	(365160, 124, '2015-01-15 01:35:18.000000', 'consum', 0.0212, 'lps'),
	(365161, 124, '2015-01-15 01:35:19.000000', 'consum', 0.0222, 'lps'),
	(365162, 124, '2015-01-15 01:35:20.000000', 'consum', 0.0218, 'lps'),
	(365163, 124, '2015-01-15 01:35:21.000000', 'consum', 0.0218, 'lps'),
	(365164, 124, '2015-01-15 01:35:22.000000', 'consum', 0.0223, 'lps'),
	(365165, 124, '2015-01-15 01:35:23.000000', 'consum', 0.0230, 'lps'),
	(365166, 124, '2015-01-15 01:35:24.000000', 'consum', 0.0230, 'lps'),
	(365167, 124, '2015-01-15 01:35:25.000000', 'consum', 0.0227, 'lps'),
	(365168, 124, '2015-01-15 01:35:26.000000', 'consum', 0.0212, 'lps'),
	(365169, 124, '2015-01-15 01:35:27.000000', 'consum', 0.0214, 'lps'),
	(365170, 124, '2015-01-15 01:35:28.000000', 'consum', 0.0226, 'lps'),
	(365171, 124, '2015-01-15 01:35:29.000000', 'consum', 0.0214, 'lps'),
	(365172, 124, '2015-01-15 01:35:30.000000', 'consum', 0.0223, 'lps'),
	(365173, 124, '2015-01-15 01:35:31.000000', 'consum', 0.0220, 'lps'),
	(365174, 124, '2015-01-15 01:35:32.000000', 'consum', 0.0224, 'lps'),
	(365175, 124, '2015-01-15 01:35:33.000000', 'consum', 0.0228, 'lps'),
	(365176, 124, '2015-01-15 01:35:34.000000', 'consum', 0.0214, 'lps'),
	(365177, 124, '2015-01-15 01:35:35.000000', 'consum', 0.0220, 'lps'),
	(365178, 124, '2015-01-15 01:35:36.000000', 'consum', 0.0228, 'lps'),
	(365179, 124, '2015-01-15 01:35:37.000000', 'consum', 0.0227, 'lps'),
	(365180, 124, '2015-01-15 01:35:38.000000', 'consum', 0.0218, 'lps'),
	(365181, 124, '2015-01-15 01:35:39.000000', 'consum', 0.0222, 'lps'),
	(365182, 124, '2015-01-15 01:35:40.000000', 'consum', 0.0222, 'lps'),
	(365183, 124, '2015-01-15 01:35:41.000000', 'consum', 0.0216, 'lps'),
	(365184, 124, '2015-01-15 01:35:42.000000', 'consum', 0.0224, 'lps'),
	(365185, 124, '2015-01-15 01:35:43.000000', 'consum', 0.0220, 'lps'),
	(365186, 124, '2015-01-15 01:35:44.000000', 'consum', 0.0219, 'lps'),
	(365187, 124, '2015-01-15 01:35:45.000000', 'consum', 0.0227, 'lps'),
	(365188, 124, '2015-01-15 01:35:46.000000', 'consum', 0.0221, 'lps'),
	(365189, 124, '2015-01-15 01:35:47.000000', 'consum', 0.0217, 'lps'),
	(365190, 124, '2015-01-15 01:35:48.000000', 'consum', 0.0210, 'lps'),
	(365191, 124, '2015-01-15 01:35:49.000000', 'consum', 0.0213, 'lps'),
	(365192, 124, '2015-01-15 01:35:50.000000', 'consum', 0.0227, 'lps'),
	(365193, 124, '2015-01-15 01:35:51.000000', 'consum', 0.0219, 'lps'),
	(365194, 124, '2015-01-15 01:35:52.000000', 'consum', 0.0228, 'lps'),
	(365195, 124, '2015-01-15 01:35:53.000000', 'consum', 0.0231, 'lps'),
	(365196, 124, '2015-01-15 01:35:54.000000', 'consum', 0.0214, 'lps'),
	(365197, 124, '2015-01-15 01:35:55.000000', 'consum', 0.0214, 'lps'),
	(365198, 124, '2015-01-15 01:35:56.000000', 'consum', 0.0216, 'lps'),
	(365199, 124, '2015-01-15 01:35:57.000000', 'consum', 0.0210, 'lps'),
	(365200, 124, '2015-01-15 01:35:58.000000', 'consum', 0.0212, 'lps'),
	(365201, 124, '2015-01-15 01:35:59.000000', 'consum', 0.0220, 'lps'),
	(365202, 124, '2015-01-15 01:36:00.000000', 'consum', 0.0213, 'lps'),
	(365203, 124, '2015-01-15 01:36:01.000000', 'consum', 0.0215, 'lps'),
	(365204, 124, '2015-01-15 01:36:02.000000', 'consum', 0.0229, 'lps'),
	(365205, 124, '2015-01-15 01:36:03.000000', 'consum', 0.0222, 'lps'),
	(365206, 124, '2015-01-15 01:36:04.000000', 'consum', 0.0213, 'lps'),
	(365207, 124, '2015-01-15 01:36:05.000000', 'consum', 0.0213, 'lps'),
	(365208, 124, '2015-01-15 01:36:06.000000', 'consum', 0.0218, 'lps'),
	(365209, 124, '2015-01-15 01:36:07.000000', 'consum', 0.0217, 'lps'),
	(365210, 124, '2015-01-15 01:36:08.000000', 'consum', 0.0224, 'lps'),
	(365211, 124, '2015-01-15 01:36:09.000000', 'consum', 0.0213, 'lps'),
	(365212, 124, '2015-01-15 01:36:10.000000', 'consum', 0.0226, 'lps'),
	(365213, 124, '2015-01-15 01:36:11.000000', 'consum', 0.0219, 'lps'),
	(365214, 124, '2015-01-15 01:36:12.000000', 'consum', 0.0227, 'lps'),
	(365215, 124, '2015-01-15 01:36:13.000000', 'consum', 0.0224, 'lps'),
	(365216, 124, '2015-01-15 01:36:14.000000', 'consum', 0.0229, 'lps'),
	(365217, 124, '2015-01-15 01:36:15.000000', 'consum', 0.0222, 'lps'),
	(365218, 124, '2015-01-15 01:36:16.000000', 'consum', 0.0212, 'lps'),
	(365219, 124, '2015-01-15 01:36:17.000000', 'consum', 0.0229, 'lps'),
	(365220, 124, '2015-01-15 01:36:18.000000', 'consum', 0.0211, 'lps'),
	(365221, 124, '2015-01-15 01:36:19.000000', 'consum', 0.0223, 'lps'),
	(365222, 124, '2015-01-15 01:36:20.000000', 'consum', 0.0229, 'lps'),
	(365223, 124, '2015-01-15 01:36:21.000000', 'consum', 0.0222, 'lps'),
	(365224, 124, '2015-01-15 01:36:22.000000', 'consum', 0.0216, 'lps'),
	(365225, 124, '2015-01-15 01:36:23.000000', 'consum', 0.0225, 'lps'),
	(365226, 124, '2015-01-15 01:36:24.000000', 'consum', 0.0222, 'lps'),
	(365227, 124, '2015-01-15 01:36:25.000000', 'consum', 0.0228, 'lps'),
	(365228, 124, '2015-01-15 01:36:26.000000', 'consum', 0.0221, 'lps'),
	(365229, 124, '2015-01-15 01:36:27.000000', 'consum', 0.0231, 'lps'),
	(365230, 124, '2015-01-15 01:36:28.000000', 'consum', 0.0219, 'lps'),
	(365231, 124, '2015-01-15 01:36:29.000000', 'consum', 0.0214, 'lps'),
	(365232, 124, '2015-01-15 01:36:30.000000', 'consum', 0.0227, 'lps'),
	(365233, 124, '2015-01-15 01:36:31.000000', 'consum', 0.0216, 'lps'),
	(365234, 124, '2015-01-15 01:36:32.000000', 'consum', 0.0213, 'lps'),
	(365235, 124, '2015-01-15 01:36:33.000000', 'consum', 0.0229, 'lps'),
	(365236, 124, '2015-01-15 01:36:34.000000', 'consum', 0.0230, 'lps'),
	(365237, 124, '2015-01-15 01:36:35.000000', 'consum', 0.0230, 'lps'),
	(365238, 124, '2015-01-15 01:36:36.000000', 'consum', 0.0229, 'lps'),
	(365239, 124, '2015-01-15 01:36:37.000000', 'consum', 0.0222, 'lps'),
	(365240, 124, '2015-01-15 01:36:38.000000', 'consum', 0.0217, 'lps'),
	(365241, 124, '2015-01-15 01:36:39.000000', 'consum', 0.0228, 'lps'),
	(365242, 124, '2015-01-15 01:36:40.000000', 'consum', 0.0216, 'lps'),
	(365243, 124, '2015-01-15 01:36:41.000000', 'consum', 0.0228, 'lps'),
	(365244, 124, '2015-01-15 01:36:42.000000', 'consum', 0.0219, 'lps'),
	(365245, 124, '2015-01-15 01:36:43.000000', 'consum', 0.0223, 'lps'),
	(365246, 124, '2015-01-15 01:36:44.000000', 'consum', 0.0226, 'lps'),
	(365247, 124, '2015-01-15 01:36:45.000000', 'consum', 0.0230, 'lps'),
	(365248, 124, '2015-01-15 01:36:46.000000', 'consum', 0.0220, 'lps'),
	(365249, 124, '2015-01-15 01:36:47.000000', 'consum', 0.0221, 'lps'),
	(365250, 124, '2015-01-15 01:36:48.000000', 'consum', 0.0216, 'lps'),
	(365251, 124, '2015-01-15 01:36:49.000000', 'consum', 0.0226, 'lps'),
	(365252, 124, '2015-01-15 01:36:50.000000', 'consum', 0.0229, 'lps'),
	(365253, 124, '2015-01-15 01:36:51.000000', 'consum', 0.0216, 'lps'),
	(365254, 124, '2015-01-15 01:36:52.000000', 'consum', 0.0225, 'lps'),
	(365255, 124, '2015-01-15 01:36:53.000000', 'consum', 0.0223, 'lps'),
	(365256, 124, '2015-01-15 01:36:54.000000', 'consum', 0.0229, 'lps'),
	(365257, 124, '2015-01-15 01:36:55.000000', 'consum', 0.0226, 'lps'),
	(365258, 124, '2015-01-15 01:36:56.000000', 'consum', 0.0210, 'lps'),
	(365259, 124, '2015-01-15 01:36:57.000000', 'consum', 0.0231, 'lps'),
	(365260, 124, '2015-01-15 01:36:58.000000', 'consum', 0.0224, 'lps'),
	(365261, 124, '2015-01-15 01:36:59.000000', 'consum', 0.0220, 'lps'),
	(365262, 124, '2015-01-15 01:37:00.000000', 'consum', 0.0216, 'lps'),
	(365263, 124, '2015-01-15 01:37:01.000000', 'consum', 0.0211, 'lps'),
	(365264, 124, '2015-01-15 01:37:02.000000', 'consum', 0.0222, 'lps'),
	(365265, 124, '2015-01-15 01:37:03.000000', 'consum', 0.0220, 'lps'),
	(365266, 124, '2015-01-15 01:37:04.000000', 'consum', 0.0227, 'lps'),
	(365267, 124, '2015-01-15 01:37:05.000000', 'consum', 0.0221, 'lps'),
	(365268, 124, '2015-01-15 01:37:06.000000', 'consum', 0.0215, 'lps'),
	(365269, 124, '2015-01-15 01:37:07.000000', 'consum', 0.0225, 'lps'),
	(365270, 124, '2015-01-15 01:37:08.000000', 'consum', 0.0227, 'lps'),
	(365271, 124, '2015-01-15 01:37:09.000000', 'consum', 0.0229, 'lps'),
	(365272, 124, '2015-01-15 01:37:10.000000', 'consum', 0.0210, 'lps'),
	(365273, 124, '2015-01-15 01:37:11.000000', 'consum', 0.0220, 'lps'),
	(365274, 124, '2015-01-15 01:37:12.000000', 'consum', 0.0217, 'lps'),
	(365275, 124, '2015-01-15 01:37:13.000000', 'consum', 0.0216, 'lps'),
	(365276, 124, '2015-01-15 01:37:14.000000', 'consum', 0.0219, 'lps'),
	(365277, 124, '2015-01-15 01:37:15.000000', 'consum', 0.0213, 'lps'),
	(365278, 124, '2015-01-15 01:37:16.000000', 'consum', 0.0224, 'lps'),
	(365279, 124, '2015-01-15 01:37:17.000000', 'consum', 0.0225, 'lps'),
	(365280, 124, '2015-01-15 01:37:18.000000', 'consum', 0.0224, 'lps'),
	(365281, 124, '2015-01-15 01:37:19.000000', 'consum', 0.0214, 'lps'),
	(365282, 124, '2015-01-15 01:37:20.000000', 'consum', 0.0231, 'lps'),
	(365283, 124, '2015-01-15 01:37:21.000000', 'consum', 0.0214, 'lps'),
	(365284, 124, '2015-01-15 01:37:22.000000', 'consum', 0.0212, 'lps'),
	(365285, 124, '2015-01-15 01:37:23.000000', 'consum', 0.0210, 'lps'),
	(365286, 124, '2015-01-15 01:37:24.000000', 'consum', 0.0224, 'lps'),
	(365287, 124, '2015-01-15 01:37:25.000000', 'consum', 0.0216, 'lps'),
	(365288, 124, '2015-01-15 01:37:26.000000', 'consum', 0.0221, 'lps'),
	(365289, 124, '2015-01-15 01:37:27.000000', 'consum', 0.0224, 'lps'),
	(365290, 124, '2015-01-15 01:37:28.000000', 'consum', 0.0225, 'lps'),
	(365291, 124, '2015-01-15 01:37:29.000000', 'consum', 0.0224, 'lps'),
	(365292, 124, '2015-01-15 01:37:30.000000', 'consum', 0.0212, 'lps'),
	(365293, 124, '2015-01-15 01:37:31.000000', 'consum', 0.0224, 'lps'),
	(365294, 124, '2015-01-15 01:37:32.000000', 'consum', 0.0229, 'lps'),
	(365295, 124, '2015-01-15 01:37:33.000000', 'consum', 0.0222, 'lps'),
	(365296, 124, '2015-01-15 01:37:34.000000', 'consum', 0.0211, 'lps'),
	(365297, 124, '2015-01-15 01:37:35.000000', 'consum', 0.0223, 'lps'),
	(365298, 124, '2015-01-15 01:37:36.000000', 'consum', 0.0228, 'lps'),
	(365299, 124, '2015-01-15 01:37:37.000000', 'consum', 0.0220, 'lps'),
	(365300, 124, '2015-01-15 01:37:38.000000', 'consum', 0.0227, 'lps'),
	(365301, 124, '2015-01-15 01:37:39.000000', 'consum', 0.0223, 'lps'),
	(365302, 124, '2015-01-15 01:37:40.000000', 'consum', 0.0222, 'lps'),
	(365303, 124, '2015-01-15 01:37:41.000000', 'consum', 0.0211, 'lps'),
	(365304, 124, '2015-01-15 01:37:42.000000', 'consum', 0.0222, 'lps'),
	(365305, 124, '2015-01-15 01:37:43.000000', 'consum', 0.0226, 'lps'),
	(365306, 124, '2015-01-15 01:37:44.000000', 'consum', 0.0211, 'lps'),
	(365307, 124, '2015-01-15 01:37:45.000000', 'consum', 0.0211, 'lps'),
	(365308, 124, '2015-01-15 01:37:46.000000', 'consum', 0.0214, 'lps'),
	(365309, 124, '2015-01-15 01:37:47.000000', 'consum', 0.0224, 'lps'),
	(365310, 124, '2015-01-15 01:37:48.000000', 'consum', 0.0227, 'lps'),
	(365311, 124, '2015-01-15 01:37:49.000000', 'consum', 0.0229, 'lps'),
	(365312, 124, '2015-01-15 01:37:50.000000', 'consum', 0.0211, 'lps'),
	(365313, 124, '2015-01-15 01:37:51.000000', 'consum', 0.0223, 'lps'),
	(365314, 124, '2015-01-15 01:37:52.000000', 'consum', 0.0231, 'lps'),
	(365315, 124, '2015-01-15 01:37:53.000000', 'consum', 0.0211, 'lps'),
	(365316, 124, '2015-01-15 01:37:54.000000', 'consum', 0.0218, 'lps'),
	(365317, 124, '2015-01-15 01:37:55.000000', 'consum', 0.0227, 'lps'),
	(365318, 124, '2015-01-15 01:37:56.000000', 'consum', 0.0226, 'lps'),
	(365319, 124, '2015-01-15 01:37:57.000000', 'consum', 0.0219, 'lps'),
	(365320, 124, '2015-01-15 01:37:58.000000', 'consum', 0.0229, 'lps'),
	(365321, 124, '2015-01-15 01:37:59.000000', 'consum', 0.0211, 'lps'),
	(365322, 124, '2015-01-15 01:38:00.000000', 'consum', 0.0226, 'lps'),
	(365323, 124, '2015-01-15 01:38:01.000000', 'consum', 0.0220, 'lps'),
	(365324, 124, '2015-01-15 01:38:02.000000', 'consum', 0.0213, 'lps'),
	(365325, 124, '2015-01-15 01:38:03.000000', 'consum', 0.0217, 'lps'),
	(365326, 124, '2015-01-15 01:38:04.000000', 'consum', 0.0214, 'lps'),
	(365327, 124, '2015-01-15 01:38:05.000000', 'consum', 0.0210, 'lps'),
	(365328, 124, '2015-01-15 01:38:06.000000', 'consum', 0.0221, 'lps'),
	(365329, 124, '2015-01-15 01:38:07.000000', 'consum', 0.0221, 'lps'),
	(365330, 124, '2015-01-15 01:38:08.000000', 'consum', 0.0231, 'lps'),
	(365331, 124, '2015-01-15 01:38:09.000000', 'consum', 0.0220, 'lps'),
	(365332, 124, '2015-01-15 01:38:10.000000', 'consum', 0.0216, 'lps'),
	(365333, 124, '2015-01-15 01:38:11.000000', 'consum', 0.0214, 'lps'),
	(365334, 124, '2015-01-15 01:38:12.000000', 'consum', 0.0231, 'lps'),
	(365335, 125, '2015-01-15 00:00:00.000000', 'consum', 0.0216, 'lps'),
	(365336, 125, '2015-01-15 00:00:01.000000', 'consum', 0.0214, 'lps'),
	(365337, 125, '2015-01-15 00:00:02.000000', 'consum', 0.0210, 'lps'),
	(365338, 125, '2015-01-15 00:00:03.000000', 'consum', 0.0217, 'lps'),
	(365339, 125, '2015-01-15 00:00:04.000000', 'consum', 0.0213, 'lps'),
	(365340, 125, '2015-01-15 00:00:05.000000', 'consum', 0.0219, 'lps'),
	(365341, 125, '2015-01-15 00:00:06.000000', 'consum', 0.0214, 'lps'),
	(365342, 125, '2015-01-15 00:00:07.000000', 'consum', 0.0220, 'lps'),
	(365343, 125, '2015-01-15 00:00:08.000000', 'consum', 0.0213, 'lps'),
	(365344, 125, '2015-01-15 00:00:09.000000', 'consum', 0.0213, 'lps'),
	(365345, 125, '2015-01-15 00:00:10.000000', 'consum', 0.0217, 'lps'),
	(365346, 125, '2015-01-15 00:00:11.000000', 'consum', 0.0220, 'lps'),
	(365347, 125, '2015-01-15 00:00:12.000000', 'consum', 0.0220, 'lps'),
	(365348, 125, '2015-01-15 00:00:13.000000', 'consum', 0.0215, 'lps'),
	(365349, 125, '2015-01-15 00:00:14.000000', 'consum', 0.0222, 'lps'),
	(365350, 125, '2015-01-15 00:00:15.000000', 'consum', 0.0222, 'lps'),
	(365351, 125, '2015-01-15 00:00:16.000000', 'consum', 0.0218, 'lps'),
	(365352, 125, '2015-01-15 00:00:17.000000', 'consum', 0.0214, 'lps'),
	(365353, 125, '2015-01-15 00:00:18.000000', 'consum', 0.0225, 'lps'),
	(365354, 125, '2015-01-15 00:00:19.000000', 'consum', 0.0223, 'lps'),
	(365355, 125, '2015-01-15 00:00:20.000000', 'consum', 0.0212, 'lps'),
	(365356, 125, '2015-01-15 00:00:21.000000', 'consum', 0.0218, 'lps'),
	(365357, 125, '2015-01-15 00:00:22.000000', 'consum', 0.0225, 'lps'),
	(365358, 125, '2015-01-15 00:00:23.000000', 'consum', 0.0226, 'lps'),
	(365359, 125, '2015-01-15 00:00:24.000000', 'consum', 0.0215, 'lps'),
	(365360, 125, '2015-01-15 00:00:25.000000', 'consum', 0.0220, 'lps'),
	(365361, 125, '2015-01-15 00:00:26.000000', 'consum', 0.0210, 'lps'),
	(365362, 125, '2015-01-15 00:00:27.000000', 'consum', 0.0216, 'lps'),
	(365363, 125, '2015-01-15 00:00:28.000000', 'consum', 0.0224, 'lps'),
	(365364, 125, '2015-01-15 00:00:29.000000', 'consum', 0.0212, 'lps'),
	(365365, 125, '2015-01-15 00:00:30.000000', 'consum', 0.0214, 'lps'),
	(365366, 125, '2015-01-15 00:00:31.000000', 'consum', 0.0221, 'lps'),
	(365367, 125, '2015-01-15 00:00:32.000000', 'consum', 0.0220, 'lps'),
	(365368, 125, '2015-01-15 00:00:33.000000', 'consum', 0.0212, 'lps'),
	(365369, 125, '2015-01-15 00:00:34.000000', 'consum', 0.0222, 'lps'),
	(365370, 125, '2015-01-15 00:00:35.000000', 'consum', 0.0214, 'lps'),
	(365371, 125, '2015-01-15 00:00:36.000000', 'consum', 0.0212, 'lps'),
	(365372, 125, '2015-01-15 00:00:37.000000', 'consum', 0.0226, 'lps'),
	(365373, 125, '2015-01-15 00:00:38.000000', 'consum', 0.0215, 'lps'),
	(365374, 125, '2015-01-15 00:00:39.000000', 'consum', 0.0224, 'lps'),
	(365375, 125, '2015-01-15 00:00:40.000000', 'consum', 0.0212, 'lps'),
	(365376, 125, '2015-01-15 00:00:41.000000', 'consum', 0.0212, 'lps'),
	(365377, 125, '2015-01-15 00:00:42.000000', 'consum', 0.0216, 'lps'),
	(365378, 125, '2015-01-15 00:00:43.000000', 'consum', 0.0216, 'lps'),
	(365379, 125, '2015-01-15 00:00:44.000000', 'consum', 0.0225, 'lps'),
	(365380, 125, '2015-01-15 00:00:45.000000', 'consum', 0.0213, 'lps'),
	(365381, 125, '2015-01-15 00:00:46.000000', 'consum', 0.0217, 'lps'),
	(365382, 125, '2015-01-15 00:00:47.000000', 'consum', 0.0220, 'lps'),
	(365383, 125, '2015-01-15 00:00:48.000000', 'consum', 0.0222, 'lps'),
	(365384, 125, '2015-01-15 00:00:49.000000', 'consum', 0.0224, 'lps'),
	(365385, 125, '2015-01-15 00:00:50.000000', 'consum', 0.0210, 'lps'),
	(365386, 125, '2015-01-15 00:00:51.000000', 'consum', 0.0220, 'lps'),
	(365387, 125, '2015-01-15 00:00:52.000000', 'consum', 0.0225, 'lps'),
	(365388, 125, '2015-01-15 00:00:53.000000', 'consum', 0.0222, 'lps'),
	(365389, 125, '2015-01-15 00:00:54.000000', 'consum', 0.0225, 'lps'),
	(365390, 125, '2015-01-15 00:00:55.000000', 'consum', 0.0217, 'lps'),
	(365391, 125, '2015-01-15 00:00:56.000000', 'consum', 0.0217, 'lps'),
	(365392, 125, '2015-01-15 00:00:57.000000', 'consum', 0.0223, 'lps'),
	(365393, 125, '2015-01-15 00:00:58.000000', 'consum', 0.0222, 'lps'),
	(365394, 125, '2015-01-15 00:00:59.000000', 'consum', 0.0214, 'lps'),
	(365395, 125, '2015-01-15 00:01:00.000000', 'consum', 0.0210, 'lps'),
	(365396, 125, '2015-01-15 00:01:01.000000', 'consum', 0.0218, 'lps'),
	(365397, 125, '2015-01-15 00:01:02.000000', 'consum', 0.0214, 'lps'),
	(365398, 125, '2015-01-15 00:01:03.000000', 'consum', 0.0226, 'lps'),
	(365399, 125, '2015-01-15 00:01:04.000000', 'consum', 0.0225, 'lps'),
	(365400, 125, '2015-01-15 00:01:05.000000', 'consum', 0.0222, 'lps'),
	(365401, 125, '2015-01-15 00:01:06.000000', 'consum', 0.0226, 'lps'),
	(365402, 125, '2015-01-15 00:01:07.000000', 'consum', 0.0218, 'lps'),
	(365403, 125, '2015-01-15 00:01:08.000000', 'consum', 0.0223, 'lps'),
	(365404, 125, '2015-01-15 00:01:09.000000', 'consum', 0.0216, 'lps'),
	(365405, 125, '2015-01-15 00:01:10.000000', 'consum', 0.0216, 'lps'),
	(365406, 125, '2015-01-15 00:01:11.000000', 'consum', 0.0226, 'lps'),
	(365407, 125, '2015-01-15 00:01:12.000000', 'consum', 0.0220, 'lps'),
	(365408, 125, '2015-01-15 00:01:13.000000', 'consum', 0.0211, 'lps'),
	(365409, 125, '2015-01-15 00:01:14.000000', 'consum', 0.0222, 'lps'),
	(365410, 125, '2015-01-15 00:01:15.000000', 'consum', 0.0214, 'lps'),
	(365411, 125, '2015-01-15 00:01:16.000000', 'consum', 0.0213, 'lps'),
	(365412, 125, '2015-01-15 00:01:17.000000', 'consum', 0.0214, 'lps'),
	(365413, 125, '2015-01-15 00:01:18.000000', 'consum', 0.0222, 'lps'),
	(365414, 125, '2015-01-15 00:01:19.000000', 'consum', 0.0223, 'lps'),
	(365415, 125, '2015-01-15 00:01:20.000000', 'consum', 0.0225, 'lps'),
	(365416, 125, '2015-01-15 00:01:21.000000', 'consum', 0.0210, 'lps'),
	(365417, 125, '2015-01-15 00:01:22.000000', 'consum', 0.0215, 'lps'),
	(365418, 125, '2015-01-15 00:01:23.000000', 'consum', 0.0222, 'lps'),
	(365419, 125, '2015-01-15 00:01:24.000000', 'consum', 0.0218, 'lps'),
	(365420, 125, '2015-01-15 00:01:25.000000', 'consum', 0.0217, 'lps'),
	(365421, 125, '2015-01-15 00:01:26.000000', 'consum', 0.0220, 'lps'),
	(365422, 125, '2015-01-15 00:01:27.000000', 'consum', 0.0221, 'lps'),
	(365423, 125, '2015-01-15 00:01:28.000000', 'consum', 0.0221, 'lps'),
	(365424, 125, '2015-01-15 00:01:29.000000', 'consum', 0.0215, 'lps'),
	(365425, 125, '2015-01-15 00:01:30.000000', 'consum', 0.0218, 'lps'),
	(365426, 125, '2015-01-15 00:01:31.000000', 'consum', 0.0220, 'lps'),
	(365427, 125, '2015-01-15 00:01:32.000000', 'consum', 0.0221, 'lps'),
	(365428, 125, '2015-01-15 00:01:33.000000', 'consum', 0.0217, 'lps'),
	(365429, 125, '2015-01-15 00:01:34.000000', 'consum', 0.0211, 'lps'),
	(365430, 125, '2015-01-15 00:01:35.000000', 'consum', 0.0214, 'lps'),
	(365431, 125, '2015-01-15 00:01:36.000000', 'consum', 0.0224, 'lps'),
	(365432, 125, '2015-01-15 00:01:37.000000', 'consum', 0.0221, 'lps'),
	(365433, 125, '2015-01-15 00:01:38.000000', 'consum', 0.0224, 'lps'),
	(365434, 125, '2015-01-15 00:01:39.000000', 'consum', 0.0213, 'lps'),
	(365435, 125, '2015-01-15 00:01:40.000000', 'consum', 0.0216, 'lps'),
	(365436, 125, '2015-01-15 00:01:41.000000', 'consum', 0.0214, 'lps'),
	(365437, 125, '2015-01-15 00:01:42.000000', 'consum', 0.0215, 'lps'),
	(365438, 125, '2015-01-15 00:01:43.000000', 'consum', 0.0224, 'lps'),
	(365439, 125, '2015-01-15 00:01:44.000000', 'consum', 0.0212, 'lps'),
	(365440, 125, '2015-01-15 00:01:45.000000', 'consum', 0.0214, 'lps'),
	(365441, 125, '2015-01-15 00:01:46.000000', 'consum', 0.0225, 'lps'),
	(365442, 125, '2015-01-15 00:01:47.000000', 'consum', 0.0222, 'lps'),
	(365443, 125, '2015-01-15 00:01:48.000000', 'consum', 0.0224, 'lps'),
	(365444, 125, '2015-01-15 00:01:49.000000', 'consum', 0.0210, 'lps'),
	(365445, 125, '2015-01-15 00:01:50.000000', 'consum', 0.0219, 'lps'),
	(365446, 125, '2015-01-15 00:01:51.000000', 'consum', 0.0222, 'lps'),
	(365447, 125, '2015-01-15 00:01:52.000000', 'consum', 0.0210, 'lps'),
	(365448, 125, '2015-01-15 00:01:53.000000', 'consum', 0.0224, 'lps'),
	(365449, 125, '2015-01-15 00:01:54.000000', 'consum', 0.0212, 'lps'),
	(365450, 125, '2015-01-15 00:01:55.000000', 'consum', 0.0214, 'lps'),
	(365451, 125, '2015-01-15 00:01:56.000000', 'consum', 0.0222, 'lps'),
	(365452, 125, '2015-01-15 00:01:57.000000', 'consum', 0.0210, 'lps'),
	(365453, 125, '2015-01-15 00:01:58.000000', 'consum', 0.0225, 'lps'),
	(365454, 125, '2015-01-15 00:01:59.000000', 'consum', 0.0217, 'lps'),
	(365455, 125, '2015-01-15 00:02:00.000000', 'consum', 0.0217, 'lps'),
	(365456, 125, '2015-01-15 00:02:01.000000', 'consum', 0.0210, 'lps'),
	(365457, 125, '2015-01-15 00:02:02.000000', 'consum', 0.0221, 'lps'),
	(365458, 125, '2015-01-15 00:02:03.000000', 'consum', 0.0214, 'lps'),
	(365459, 125, '2015-01-15 00:02:04.000000', 'consum', 0.0215, 'lps'),
	(365460, 125, '2015-01-15 00:02:05.000000', 'consum', 0.0223, 'lps'),
	(365461, 125, '2015-01-15 00:02:06.000000', 'consum', 0.0226, 'lps'),
	(365462, 125, '2015-01-15 00:02:07.000000', 'consum', 0.0220, 'lps'),
	(365463, 125, '2015-01-15 00:02:08.000000', 'consum', 0.0211, 'lps'),
	(365464, 125, '2015-01-15 00:02:09.000000', 'consum', 0.0221, 'lps'),
	(365465, 125, '2015-01-15 00:02:10.000000', 'consum', 0.0211, 'lps'),
	(365466, 125, '2015-01-15 00:02:11.000000', 'consum', 0.0216, 'lps'),
	(365467, 125, '2015-01-15 00:02:12.000000', 'consum', 0.0222, 'lps'),
	(365468, 125, '2015-01-15 00:02:13.000000', 'consum', 0.0217, 'lps'),
	(365469, 125, '2015-01-15 00:02:14.000000', 'consum', 0.0225, 'lps'),
	(365470, 125, '2015-01-15 00:02:15.000000', 'consum', 0.0216, 'lps'),
	(365471, 125, '2015-01-15 00:02:16.000000', 'consum', 0.0214, 'lps'),
	(365472, 125, '2015-01-15 00:02:17.000000', 'consum', 0.0226, 'lps'),
	(365473, 125, '2015-01-15 00:02:18.000000', 'consum', 0.0213, 'lps'),
	(365474, 125, '2015-01-15 00:02:19.000000', 'consum', 0.0210, 'lps'),
	(365475, 125, '2015-01-15 00:02:20.000000', 'consum', 0.0219, 'lps'),
	(365476, 125, '2015-01-15 00:02:21.000000', 'consum', 0.0222, 'lps'),
	(365477, 125, '2015-01-15 00:02:22.000000', 'consum', 0.0226, 'lps'),
	(365478, 125, '2015-01-15 00:02:23.000000', 'consum', 0.0220, 'lps'),
	(365479, 125, '2015-01-15 00:02:24.000000', 'consum', 0.0214, 'lps'),
	(365480, 125, '2015-01-15 00:02:25.000000', 'consum', 0.0216, 'lps'),
	(365481, 125, '2015-01-15 00:02:26.000000', 'consum', 0.0210, 'lps'),
	(365482, 125, '2015-01-15 00:02:27.000000', 'consum', 0.0213, 'lps'),
	(365483, 125, '2015-01-15 00:02:28.000000', 'consum', 0.0223, 'lps'),
	(365484, 125, '2015-01-15 00:02:29.000000', 'consum', 0.0216, 'lps'),
	(365485, 125, '2015-01-15 00:02:30.000000', 'consum', 0.0220, 'lps'),
	(365486, 125, '2015-01-15 00:02:31.000000', 'consum', 0.0225, 'lps'),
	(365487, 125, '2015-01-15 00:02:32.000000', 'consum', 0.0222, 'lps'),
	(365488, 125, '2015-01-15 00:02:33.000000', 'consum', 0.0224, 'lps'),
	(365489, 125, '2015-01-15 00:02:34.000000', 'consum', 0.0213, 'lps'),
	(365490, 125, '2015-01-15 00:02:35.000000', 'consum', 0.0215, 'lps'),
	(365491, 125, '2015-01-15 00:02:36.000000', 'consum', 0.0226, 'lps'),
	(365492, 125, '2015-01-15 00:02:37.000000', 'consum', 0.0226, 'lps'),
	(365493, 125, '2015-01-15 00:02:38.000000', 'consum', 0.0210, 'lps'),
	(365494, 125, '2015-01-15 00:02:39.000000', 'consum', 0.0212, 'lps'),
	(365495, 125, '2015-01-15 00:02:40.000000', 'consum', 0.0221, 'lps'),
	(365496, 125, '2015-01-15 00:02:41.000000', 'consum', 0.0225, 'lps'),
	(365497, 125, '2015-01-15 00:02:42.000000', 'consum', 0.0220, 'lps'),
	(365498, 125, '2015-01-15 00:02:43.000000', 'consum', 0.0214, 'lps'),
	(365499, 125, '2015-01-15 00:02:44.000000', 'consum', 0.0219, 'lps'),
	(365500, 125, '2015-01-15 00:02:45.000000', 'consum', 0.0211, 'lps'),
	(365501, 125, '2015-01-15 00:02:46.000000', 'consum', 0.0219, 'lps'),
	(365502, 125, '2015-01-15 00:02:47.000000', 'consum', 0.0221, 'lps'),
	(365503, 125, '2015-01-15 00:02:48.000000', 'consum', 0.0219, 'lps'),
	(365504, 125, '2015-01-15 00:02:49.000000', 'consum', 0.0222, 'lps'),
	(365505, 125, '2015-01-15 00:02:50.000000', 'consum', 0.0213, 'lps'),
	(365506, 125, '2015-01-15 00:02:51.000000', 'consum', 0.0220, 'lps'),
	(365507, 125, '2015-01-15 00:02:52.000000', 'consum', 0.0220, 'lps'),
	(365508, 125, '2015-01-15 00:02:53.000000', 'consum', 0.0211, 'lps'),
	(365509, 125, '2015-01-15 00:02:54.000000', 'consum', 0.0219, 'lps'),
	(365510, 125, '2015-01-15 00:02:55.000000', 'consum', 0.0221, 'lps'),
	(365511, 125, '2015-01-15 00:02:56.000000', 'consum', 0.0221, 'lps'),
	(365512, 125, '2015-01-15 00:02:57.000000', 'consum', 0.0214, 'lps'),
	(365513, 125, '2015-01-15 00:02:58.000000', 'consum', 0.0213, 'lps'),
	(365514, 125, '2015-01-15 00:02:59.000000', 'consum', 0.0217, 'lps'),
	(365515, 125, '2015-01-15 00:03:00.000000', 'consum', 0.0216, 'lps'),
	(365516, 125, '2015-01-15 00:03:01.000000', 'consum', 0.0223, 'lps'),
	(365517, 125, '2015-01-15 00:03:02.000000', 'consum', 0.0222, 'lps'),
	(365518, 125, '2015-01-15 00:03:03.000000', 'consum', 0.0213, 'lps'),
	(365519, 125, '2015-01-15 00:03:04.000000', 'consum', 0.0224, 'lps'),
	(365520, 125, '2015-01-15 00:03:05.000000', 'consum', 0.0222, 'lps'),
	(365521, 125, '2015-01-15 00:03:06.000000', 'consum', 0.0212, 'lps'),
	(365522, 125, '2015-01-15 00:03:07.000000', 'consum', 0.0219, 'lps'),
	(365523, 125, '2015-01-15 00:03:08.000000', 'consum', 0.0216, 'lps'),
	(365524, 125, '2015-01-15 00:03:09.000000', 'consum', 0.0211, 'lps'),
	(365525, 125, '2015-01-15 00:03:10.000000', 'consum', 0.0217, 'lps'),
	(365526, 125, '2015-01-15 00:03:11.000000', 'consum', 0.0223, 'lps'),
	(365527, 125, '2015-01-15 00:03:12.000000', 'consum', 0.0220, 'lps'),
	(365528, 125, '2015-01-15 00:03:13.000000', 'consum', 0.0223, 'lps'),
	(365529, 125, '2015-01-15 00:03:14.000000', 'consum', 0.0213, 'lps'),
	(365530, 125, '2015-01-15 00:03:15.000000', 'consum', 0.0221, 'lps'),
	(365531, 125, '2015-01-15 00:03:16.000000', 'consum', 0.0220, 'lps'),
	(365532, 125, '2015-01-15 00:03:17.000000', 'consum', 0.0211, 'lps'),
	(365533, 125, '2015-01-15 00:03:18.000000', 'consum', 0.0222, 'lps'),
	(365534, 125, '2015-01-15 00:03:19.000000', 'consum', 0.0214, 'lps'),
	(365535, 125, '2015-01-15 00:03:20.000000', 'consum', 0.0212, 'lps'),
	(365536, 125, '2015-01-15 00:03:21.000000', 'consum', 0.0210, 'lps'),
	(365537, 125, '2015-01-15 00:03:22.000000', 'consum', 0.0222, 'lps'),
	(365538, 125, '2015-01-15 00:03:23.000000', 'consum', 0.0217, 'lps'),
	(365539, 125, '2015-01-15 00:03:24.000000', 'consum', 0.0212, 'lps'),
	(365540, 125, '2015-01-15 00:03:25.000000', 'consum', 0.0214, 'lps'),
	(365541, 125, '2015-01-15 00:03:26.000000', 'consum', 0.0210, 'lps'),
	(365542, 125, '2015-01-15 00:03:27.000000', 'consum', 0.0216, 'lps'),
	(365543, 125, '2015-01-15 00:03:28.000000', 'consum', 0.0223, 'lps'),
	(365544, 125, '2015-01-15 00:03:29.000000', 'consum', 0.0221, 'lps'),
	(365545, 125, '2015-01-15 00:03:30.000000', 'consum', 0.0213, 'lps'),
	(365546, 125, '2015-01-15 00:03:31.000000', 'consum', 0.0224, 'lps'),
	(365547, 125, '2015-01-15 00:03:32.000000', 'consum', 0.0220, 'lps'),
	(365548, 125, '2015-01-15 00:03:33.000000', 'consum', 0.0219, 'lps'),
	(365549, 125, '2015-01-15 00:03:34.000000', 'consum', 0.0210, 'lps'),
	(365550, 125, '2015-01-15 00:03:35.000000', 'consum', 0.0216, 'lps'),
	(365551, 125, '2015-01-15 00:03:36.000000', 'consum', 0.0222, 'lps'),
	(365552, 125, '2015-01-15 00:03:37.000000', 'consum', 0.0219, 'lps'),
	(365553, 125, '2015-01-15 00:03:38.000000', 'consum', 0.0220, 'lps'),
	(365554, 125, '2015-01-15 00:03:39.000000', 'consum', 0.0216, 'lps'),
	(365555, 125, '2015-01-15 00:03:40.000000', 'consum', 0.0212, 'lps'),
	(365556, 125, '2015-01-15 00:03:41.000000', 'consum', 0.0221, 'lps'),
	(365557, 125, '2015-01-15 00:03:42.000000', 'consum', 0.0222, 'lps'),
	(365558, 125, '2015-01-15 00:03:43.000000', 'consum', 0.0222, 'lps'),
	(365559, 125, '2015-01-15 00:03:44.000000', 'consum', 0.0216, 'lps'),
	(365560, 125, '2015-01-15 00:03:45.000000', 'consum', 0.0224, 'lps'),
	(365561, 125, '2015-01-15 00:03:46.000000', 'consum', 0.0212, 'lps'),
	(365562, 125, '2015-01-15 00:03:47.000000', 'consum', 0.0210, 'lps'),
	(365563, 125, '2015-01-15 00:03:48.000000', 'consum', 0.0222, 'lps'),
	(365564, 125, '2015-01-15 00:03:49.000000', 'consum', 0.0218, 'lps'),
	(365565, 125, '2015-01-15 00:03:50.000000', 'consum', 0.0216, 'lps'),
	(365566, 125, '2015-01-15 00:03:51.000000', 'consum', 0.0217, 'lps'),
	(365567, 125, '2015-01-15 00:03:52.000000', 'consum', 0.0226, 'lps'),
	(365568, 125, '2015-01-15 00:03:53.000000', 'consum', 0.0220, 'lps'),
	(365569, 125, '2015-01-15 00:03:54.000000', 'consum', 0.0213, 'lps'),
	(365570, 125, '2015-01-15 00:03:55.000000', 'consum', 0.0212, 'lps'),
	(365571, 125, '2015-01-15 00:03:56.000000', 'consum', 0.0210, 'lps'),
	(365572, 125, '2015-01-15 00:03:57.000000', 'consum', 0.0224, 'lps'),
	(365573, 125, '2015-01-15 00:03:58.000000', 'consum', 0.0211, 'lps'),
	(365574, 125, '2015-01-15 00:03:59.000000', 'consum', 0.0210, 'lps'),
	(365575, 125, '2015-01-15 00:04:00.000000', 'consum', 0.0221, 'lps'),
	(365576, 125, '2015-01-15 00:04:01.000000', 'consum', 0.0216, 'lps'),
	(365577, 125, '2015-01-15 00:04:02.000000', 'consum', 0.0226, 'lps'),
	(365578, 125, '2015-01-15 00:04:03.000000', 'consum', 0.0221, 'lps'),
	(365579, 125, '2015-01-15 00:04:04.000000', 'consum', 0.0215, 'lps'),
	(365580, 125, '2015-01-15 00:04:05.000000', 'consum', 0.0221, 'lps'),
	(365581, 125, '2015-01-15 00:04:06.000000', 'consum', 0.0216, 'lps'),
	(365582, 125, '2015-01-15 00:04:07.000000', 'consum', 0.0223, 'lps'),
	(365583, 125, '2015-01-15 00:04:08.000000', 'consum', 0.0226, 'lps'),
	(365584, 125, '2015-01-15 00:04:09.000000', 'consum', 0.0215, 'lps'),
	(365585, 125, '2015-01-15 00:04:10.000000', 'consum', 0.0222, 'lps'),
	(365586, 125, '2015-01-15 00:04:11.000000', 'consum', 0.0220, 'lps'),
	(365587, 125, '2015-01-15 00:04:12.000000', 'consum', 0.0226, 'lps'),
	(365588, 125, '2015-01-15 00:04:13.000000', 'consum', 0.0225, 'lps'),
	(365589, 125, '2015-01-15 00:04:14.000000', 'consum', 0.0223, 'lps'),
	(365590, 125, '2015-01-15 00:04:15.000000', 'consum', 0.0213, 'lps'),
	(365591, 125, '2015-01-15 00:04:16.000000', 'consum', 0.0220, 'lps'),
	(365592, 125, '2015-01-15 00:04:17.000000', 'consum', 0.0219, 'lps'),
	(365593, 125, '2015-01-15 00:04:18.000000', 'consum', 0.0225, 'lps'),
	(365594, 125, '2015-01-15 00:04:19.000000', 'consum', 0.0224, 'lps'),
	(365595, 125, '2015-01-15 00:04:20.000000', 'consum', 0.0217, 'lps'),
	(365596, 125, '2015-01-15 00:04:21.000000', 'consum', 0.0221, 'lps'),
	(365597, 125, '2015-01-15 00:04:22.000000', 'consum', 0.0226, 'lps'),
	(365598, 125, '2015-01-15 00:04:23.000000', 'consum', 0.0210, 'lps'),
	(365599, 125, '2015-01-15 00:04:24.000000', 'consum', 0.0212, 'lps'),
	(365600, 125, '2015-01-15 00:04:25.000000', 'consum', 0.0219, 'lps'),
	(365601, 125, '2015-01-15 00:04:26.000000', 'consum', 0.0215, 'lps'),
	(365602, 125, '2015-01-15 00:04:27.000000', 'consum', 0.0226, 'lps'),
	(365603, 125, '2015-01-15 00:04:28.000000', 'consum', 0.0226, 'lps'),
	(365604, 125, '2015-01-15 00:04:29.000000', 'consum', 0.0223, 'lps'),
	(365605, 125, '2015-01-15 00:04:30.000000', 'consum', 0.0212, 'lps'),
	(365606, 125, '2015-01-15 00:04:31.000000', 'consum', 0.0214, 'lps'),
	(365607, 125, '2015-01-15 00:04:32.000000', 'consum', 0.0210, 'lps'),
	(365608, 125, '2015-01-15 00:04:33.000000', 'consum', 0.0215, 'lps'),
	(365609, 125, '2015-01-15 00:04:34.000000', 'consum', 0.0219, 'lps'),
	(365610, 125, '2015-01-15 00:04:35.000000', 'consum', 0.0225, 'lps'),
	(365611, 125, '2015-01-15 00:04:36.000000', 'consum', 0.0222, 'lps'),
	(365612, 125, '2015-01-15 00:04:37.000000', 'consum', 0.0211, 'lps'),
	(365613, 125, '2015-01-15 00:04:38.000000', 'consum', 0.0213, 'lps'),
	(365614, 125, '2015-01-15 00:04:39.000000', 'consum', 0.0222, 'lps'),
	(365615, 125, '2015-01-15 00:04:40.000000', 'consum', 0.0226, 'lps'),
	(365616, 125, '2015-01-15 00:04:41.000000', 'consum', 0.0223, 'lps'),
	(365617, 125, '2015-01-15 00:04:42.000000', 'consum', 0.0210, 'lps'),
	(365618, 125, '2015-01-15 00:04:43.000000', 'consum', 0.0221, 'lps'),
	(365619, 125, '2015-01-15 00:04:44.000000', 'consum', 0.0217, 'lps'),
	(365620, 125, '2015-01-15 00:04:45.000000', 'consum', 0.0211, 'lps'),
	(365621, 125, '2015-01-15 00:04:46.000000', 'consum', 0.0212, 'lps'),
	(365622, 125, '2015-01-15 00:04:47.000000', 'consum', 0.0216, 'lps'),
	(365623, 125, '2015-01-15 00:04:48.000000', 'consum', 0.0218, 'lps'),
	(365624, 125, '2015-01-15 00:04:49.000000', 'consum', 0.0217, 'lps'),
	(365625, 125, '2015-01-15 00:04:50.000000', 'consum', 0.0221, 'lps'),
	(365626, 125, '2015-01-15 00:04:51.000000', 'consum', 0.0212, 'lps'),
	(365627, 125, '2015-01-15 00:04:52.000000', 'consum', 0.0218, 'lps'),
	(365628, 125, '2015-01-15 00:04:53.000000', 'consum', 0.0213, 'lps'),
	(365629, 125, '2015-01-15 00:04:54.000000', 'consum', 0.0219, 'lps'),
	(365630, 125, '2015-01-15 00:04:55.000000', 'consum', 0.0210, 'lps'),
	(365631, 125, '2015-01-15 00:04:56.000000', 'consum', 0.0218, 'lps'),
	(365632, 125, '2015-01-15 00:04:57.000000', 'consum', 0.0217, 'lps'),
	(365633, 125, '2015-01-15 00:04:58.000000', 'consum', 0.0221, 'lps'),
	(365634, 125, '2015-01-15 00:04:59.000000', 'consum', 0.0211, 'lps'),
	(365635, 125, '2015-01-15 00:05:00.000000', 'consum', 0.0215, 'lps'),
	(365636, 125, '2015-01-15 00:05:01.000000', 'consum', 0.0216, 'lps'),
	(365637, 125, '2015-01-15 00:05:02.000000', 'consum', 0.0210, 'lps'),
	(365638, 125, '2015-01-15 00:05:03.000000', 'consum', 0.0225, 'lps'),
	(365639, 125, '2015-01-15 00:05:04.000000', 'consum', 0.0220, 'lps'),
	(365640, 125, '2015-01-15 00:05:05.000000', 'consum', 0.0213, 'lps'),
	(365641, 125, '2015-01-15 00:05:06.000000', 'consum', 0.0215, 'lps'),
	(365642, 125, '2015-01-15 00:05:07.000000', 'consum', 0.0225, 'lps'),
	(365643, 125, '2015-01-15 00:05:08.000000', 'consum', 0.0218, 'lps'),
	(365644, 125, '2015-01-15 00:05:09.000000', 'consum', 0.0225, 'lps'),
	(365645, 125, '2015-01-15 00:05:10.000000', 'consum', 0.0212, 'lps'),
	(365646, 125, '2015-01-15 00:05:11.000000', 'consum', 0.0223, 'lps'),
	(365647, 125, '2015-01-15 00:05:12.000000', 'consum', 0.0221, 'lps'),
	(365648, 125, '2015-01-15 00:05:13.000000', 'consum', 0.0225, 'lps'),
	(365649, 125, '2015-01-15 00:05:14.000000', 'consum', 0.0218, 'lps'),
	(365650, 125, '2015-01-15 00:05:15.000000', 'consum', 0.0223, 'lps'),
	(365651, 125, '2015-01-15 00:05:16.000000', 'consum', 0.0216, 'lps'),
	(365652, 125, '2015-01-15 00:05:17.000000', 'consum', 0.0221, 'lps'),
	(365653, 125, '2015-01-15 00:05:18.000000', 'consum', 0.0211, 'lps'),
	(365654, 125, '2015-01-15 00:05:19.000000', 'consum', 0.0215, 'lps'),
	(365655, 125, '2015-01-15 00:05:20.000000', 'consum', 0.0219, 'lps'),
	(365656, 125, '2015-01-15 00:05:21.000000', 'consum', 0.0224, 'lps'),
	(365657, 125, '2015-01-15 00:05:22.000000', 'consum', 0.0217, 'lps'),
	(365658, 125, '2015-01-15 00:05:23.000000', 'consum', 0.0222, 'lps'),
	(365659, 125, '2015-01-15 00:05:24.000000', 'consum', 0.0214, 'lps'),
	(365660, 125, '2015-01-15 00:05:25.000000', 'consum', 0.0211, 'lps'),
	(365661, 125, '2015-01-15 00:05:26.000000', 'consum', 0.0223, 'lps'),
	(365662, 125, '2015-01-15 00:05:27.000000', 'consum', 0.0220, 'lps'),
	(365663, 125, '2015-01-15 00:05:28.000000', 'consum', 0.0223, 'lps'),
	(365664, 125, '2015-01-15 00:05:29.000000', 'consum', 0.0212, 'lps'),
	(365665, 125, '2015-01-15 00:05:30.000000', 'consum', 0.0213, 'lps'),
	(365666, 125, '2015-01-15 00:05:31.000000', 'consum', 0.0220, 'lps'),
	(365667, 125, '2015-01-15 00:05:32.000000', 'consum', 0.0218, 'lps'),
	(365668, 125, '2015-01-15 00:05:33.000000', 'consum', 0.0221, 'lps'),
	(365669, 125, '2015-01-15 00:05:34.000000', 'consum', 0.0226, 'lps'),
	(365670, 125, '2015-01-15 00:05:35.000000', 'consum', 0.0223, 'lps'),
	(365671, 125, '2015-01-15 00:05:36.000000', 'consum', 0.0226, 'lps'),
	(365672, 125, '2015-01-15 00:05:37.000000', 'consum', 0.0220, 'lps'),
	(365673, 125, '2015-01-15 00:05:38.000000', 'consum', 0.0226, 'lps'),
	(365674, 125, '2015-01-15 00:05:39.000000', 'consum', 0.0213, 'lps'),
	(365675, 125, '2015-01-15 00:05:40.000000', 'consum', 0.0225, 'lps'),
	(365676, 125, '2015-01-15 00:05:41.000000', 'consum', 0.0211, 'lps'),
	(365677, 125, '2015-01-15 00:05:42.000000', 'consum', 0.0220, 'lps'),
	(365678, 125, '2015-01-15 00:05:43.000000', 'consum', 0.0223, 'lps'),
	(365679, 125, '2015-01-15 00:05:44.000000', 'consum', 0.0212, 'lps'),
	(365680, 125, '2015-01-15 00:05:45.000000', 'consum', 0.0217, 'lps'),
	(365681, 125, '2015-01-15 00:05:46.000000', 'consum', 0.0221, 'lps'),
	(365682, 125, '2015-01-15 00:05:47.000000', 'consum', 0.0211, 'lps'),
	(365683, 125, '2015-01-15 00:05:48.000000', 'consum', 0.0217, 'lps'),
	(365684, 125, '2015-01-15 00:05:49.000000', 'consum', 0.0226, 'lps'),
	(365685, 125, '2015-01-15 00:05:50.000000', 'consum', 0.0218, 'lps'),
	(365686, 125, '2015-01-15 00:05:51.000000', 'consum', 0.0218, 'lps'),
	(365687, 125, '2015-01-15 00:05:52.000000', 'consum', 0.0226, 'lps'),
	(365688, 125, '2015-01-15 00:05:53.000000', 'consum', 0.0217, 'lps'),
	(365689, 125, '2015-01-15 00:05:54.000000', 'consum', 0.0214, 'lps'),
	(365690, 125, '2015-01-15 00:05:55.000000', 'consum', 0.0210, 'lps'),
	(365691, 125, '2015-01-15 00:05:56.000000', 'consum', 0.0214, 'lps'),
	(365692, 125, '2015-01-15 00:05:57.000000', 'consum', 0.0214, 'lps'),
	(365693, 125, '2015-01-15 00:05:58.000000', 'consum', 0.0219, 'lps'),
	(365694, 125, '2015-01-15 00:05:59.000000', 'consum', 0.0210, 'lps'),
	(365695, 125, '2015-01-15 00:06:00.000000', 'consum', 0.0216, 'lps'),
	(365696, 125, '2015-01-15 00:06:01.000000', 'consum', 0.0225, 'lps'),
	(365697, 125, '2015-01-15 00:06:02.000000', 'consum', 0.0216, 'lps'),
	(365698, 125, '2015-01-15 00:06:03.000000', 'consum', 0.0212, 'lps'),
	(365699, 125, '2015-01-15 00:06:04.000000', 'consum', 0.0221, 'lps'),
	(365700, 125, '2015-01-15 00:06:05.000000', 'consum', 0.0226, 'lps'),
	(365701, 125, '2015-01-15 00:06:06.000000', 'consum', 0.0221, 'lps'),
	(365702, 125, '2015-01-15 00:06:07.000000', 'consum', 0.0219, 'lps'),
	(365703, 125, '2015-01-15 00:06:08.000000', 'consum', 0.0224, 'lps'),
	(365704, 125, '2015-01-15 00:06:09.000000', 'consum', 0.0217, 'lps'),
	(365705, 125, '2015-01-15 00:06:10.000000', 'consum', 0.0223, 'lps'),
	(365706, 125, '2015-01-15 00:06:11.000000', 'consum', 0.0221, 'lps'),
	(365707, 125, '2015-01-15 00:06:12.000000', 'consum', 0.0225, 'lps'),
	(365708, 125, '2015-01-15 00:06:13.000000', 'consum', 0.0220, 'lps'),
	(365709, 125, '2015-01-15 00:06:14.000000', 'consum', 0.0216, 'lps'),
	(365710, 125, '2015-01-15 00:06:15.000000', 'consum', 0.0211, 'lps'),
	(365711, 125, '2015-01-15 00:06:16.000000', 'consum', 0.0213, 'lps'),
	(365712, 125, '2015-01-15 00:06:17.000000', 'consum', 0.0224, 'lps'),
	(365713, 125, '2015-01-15 00:06:18.000000', 'consum', 0.0221, 'lps'),
	(365714, 125, '2015-01-15 00:06:19.000000', 'consum', 0.0224, 'lps'),
	(365715, 125, '2015-01-15 00:06:20.000000', 'consum', 0.0214, 'lps'),
	(365716, 125, '2015-01-15 00:06:21.000000', 'consum', 0.0221, 'lps'),
	(365717, 125, '2015-01-15 00:06:22.000000', 'consum', 0.0219, 'lps'),
	(365718, 125, '2015-01-15 00:06:23.000000', 'consum', 0.0222, 'lps'),
	(365719, 125, '2015-01-15 00:06:24.000000', 'consum', 0.0210, 'lps'),
	(365720, 125, '2015-01-15 00:06:25.000000', 'consum', 0.0211, 'lps'),
	(365721, 125, '2015-01-15 00:06:26.000000', 'consum', 0.0212, 'lps'),
	(365722, 125, '2015-01-15 00:06:27.000000', 'consum', 0.0219, 'lps'),
	(365723, 125, '2015-01-15 00:06:28.000000', 'consum', 0.0214, 'lps'),
	(365724, 125, '2015-01-15 00:06:29.000000', 'consum', 0.0223, 'lps'),
	(365725, 125, '2015-01-15 00:06:30.000000', 'consum', 0.0226, 'lps'),
	(365726, 125, '2015-01-15 00:06:31.000000', 'consum', 0.0221, 'lps'),
	(365727, 125, '2015-01-15 00:06:32.000000', 'consum', 0.0214, 'lps'),
	(365728, 125, '2015-01-15 00:06:33.000000', 'consum', 0.0217, 'lps'),
	(365729, 125, '2015-01-15 00:06:34.000000', 'consum', 0.0216, 'lps'),
	(365730, 125, '2015-01-15 00:06:35.000000', 'consum', 0.0221, 'lps'),
	(365731, 125, '2015-01-15 00:06:36.000000', 'consum', 0.0213, 'lps'),
	(365732, 125, '2015-01-15 00:06:37.000000', 'consum', 0.0224, 'lps'),
	(365733, 125, '2015-01-15 00:06:38.000000', 'consum', 0.0223, 'lps'),
	(365734, 125, '2015-01-15 00:06:39.000000', 'consum', 0.0218, 'lps'),
	(365735, 125, '2015-01-15 00:06:40.000000', 'consum', 0.0226, 'lps'),
	(365736, 125, '2015-01-15 00:06:41.000000', 'consum', 0.0216, 'lps'),
	(365737, 125, '2015-01-15 00:06:42.000000', 'consum', 0.0211, 'lps'),
	(365738, 125, '2015-01-15 00:06:43.000000', 'consum', 0.0211, 'lps'),
	(365739, 125, '2015-01-15 00:06:44.000000', 'consum', 0.0216, 'lps'),
	(365740, 125, '2015-01-15 00:06:45.000000', 'consum', 0.0221, 'lps'),
	(365741, 125, '2015-01-15 00:06:46.000000', 'consum', 0.0211, 'lps'),
	(365742, 125, '2015-01-15 00:06:47.000000', 'consum', 0.0216, 'lps'),
	(365743, 125, '2015-01-15 00:06:48.000000', 'consum', 0.0221, 'lps'),
	(365744, 125, '2015-01-15 00:06:49.000000', 'consum', 0.0214, 'lps'),
	(365745, 125, '2015-01-15 00:06:50.000000', 'consum', 0.0212, 'lps'),
	(365746, 125, '2015-01-15 00:06:51.000000', 'consum', 0.0212, 'lps'),
	(365747, 125, '2015-01-15 00:06:52.000000', 'consum', 0.0212, 'lps'),
	(365748, 125, '2015-01-15 00:06:53.000000', 'consum', 0.0217, 'lps'),
	(365749, 125, '2015-01-15 00:06:54.000000', 'consum', 0.0221, 'lps'),
	(365750, 125, '2015-01-15 00:06:55.000000', 'consum', 0.0211, 'lps'),
	(365751, 125, '2015-01-15 00:06:56.000000', 'consum', 0.0216, 'lps'),
	(365752, 125, '2015-01-15 00:06:57.000000', 'consum', 0.0220, 'lps'),
	(365753, 125, '2015-01-15 00:06:58.000000', 'consum', 0.0226, 'lps'),
	(365754, 125, '2015-01-15 00:06:59.000000', 'consum', 0.0211, 'lps'),
	(365755, 125, '2015-01-15 00:07:00.000000', 'consum', 0.0218, 'lps'),
	(365756, 125, '2015-01-15 00:07:01.000000', 'consum', 0.0214, 'lps'),
	(365757, 125, '2015-01-15 00:07:02.000000', 'consum', 0.0223, 'lps'),
	(365758, 125, '2015-01-15 00:07:03.000000', 'consum', 0.0214, 'lps'),
	(365759, 125, '2015-01-15 00:07:04.000000', 'consum', 0.0223, 'lps'),
	(365760, 125, '2015-01-15 00:07:05.000000', 'consum', 0.0212, 'lps'),
	(365761, 125, '2015-01-15 00:07:06.000000', 'consum', 0.0215, 'lps'),
	(365762, 125, '2015-01-15 00:07:07.000000', 'consum', 0.0215, 'lps'),
	(365763, 125, '2015-01-15 00:07:08.000000', 'consum', 0.0221, 'lps'),
	(365764, 125, '2015-01-15 00:07:09.000000', 'consum', 0.0215, 'lps'),
	(365765, 125, '2015-01-15 00:07:10.000000', 'consum', 0.0218, 'lps'),
	(365766, 125, '2015-01-15 00:07:11.000000', 'consum', 0.0219, 'lps'),
	(365767, 125, '2015-01-15 00:07:12.000000', 'consum', 0.0215, 'lps'),
	(365768, 125, '2015-01-15 00:07:13.000000', 'consum', 0.0224, 'lps'),
	(365769, 125, '2015-01-15 00:07:14.000000', 'consum', 0.0215, 'lps'),
	(365770, 125, '2015-01-15 00:07:15.000000', 'consum', 0.0210, 'lps'),
	(365771, 125, '2015-01-15 00:07:16.000000', 'consum', 0.0215, 'lps'),
	(365772, 125, '2015-01-15 00:07:17.000000', 'consum', 0.0216, 'lps'),
	(365773, 125, '2015-01-15 00:07:18.000000', 'consum', 0.0225, 'lps'),
	(365774, 125, '2015-01-15 00:07:19.000000', 'consum', 0.0219, 'lps'),
	(365775, 125, '2015-01-15 00:07:20.000000', 'consum', 0.0225, 'lps'),
	(365776, 125, '2015-01-15 00:07:21.000000', 'consum', 0.0210, 'lps'),
	(365777, 125, '2015-01-15 00:07:22.000000', 'consum', 0.0217, 'lps'),
	(365778, 125, '2015-01-15 00:07:23.000000', 'consum', 0.0210, 'lps'),
	(365779, 125, '2015-01-15 00:07:24.000000', 'consum', 0.0224, 'lps'),
	(365780, 125, '2015-01-15 00:07:25.000000', 'consum', 0.0211, 'lps'),
	(365781, 125, '2015-01-15 00:07:26.000000', 'consum', 0.0210, 'lps'),
	(365782, 125, '2015-01-15 00:07:27.000000', 'consum', 0.0225, 'lps'),
	(365783, 125, '2015-01-15 00:07:28.000000', 'consum', 0.0218, 'lps'),
	(365784, 125, '2015-01-15 00:07:29.000000', 'consum', 0.0220, 'lps'),
	(365785, 125, '2015-01-15 00:07:30.000000', 'consum', 0.0221, 'lps'),
	(365786, 125, '2015-01-15 00:07:31.000000', 'consum', 0.0219, 'lps'),
	(365787, 125, '2015-01-15 00:07:32.000000', 'consum', 0.0221, 'lps'),
	(365788, 125, '2015-01-15 00:07:33.000000', 'consum', 0.0220, 'lps'),
	(365789, 125, '2015-01-15 00:07:34.000000', 'consum', 0.0214, 'lps'),
	(365790, 125, '2015-01-15 00:07:35.000000', 'consum', 0.0214, 'lps'),
	(365791, 125, '2015-01-15 00:07:36.000000', 'consum', 0.0221, 'lps'),
	(365792, 125, '2015-01-15 00:07:37.000000', 'consum', 0.0220, 'lps'),
	(365793, 125, '2015-01-15 00:07:38.000000', 'consum', 0.0210, 'lps'),
	(365794, 125, '2015-01-15 00:07:39.000000', 'consum', 0.0213, 'lps'),
	(365795, 125, '2015-01-15 00:07:40.000000', 'consum', 0.0210, 'lps'),
	(365796, 125, '2015-01-15 00:07:41.000000', 'consum', 0.0219, 'lps'),
	(365797, 125, '2015-01-15 00:07:42.000000', 'consum', 0.0220, 'lps'),
	(365798, 125, '2015-01-15 00:07:43.000000', 'consum', 0.0218, 'lps'),
	(365799, 125, '2015-01-15 00:07:44.000000', 'consum', 0.0218, 'lps'),
	(365800, 125, '2015-01-15 00:07:45.000000', 'consum', 0.0211, 'lps'),
	(365801, 125, '2015-01-15 00:07:46.000000', 'consum', 0.0210, 'lps'),
	(365802, 125, '2015-01-15 00:07:47.000000', 'consum', 0.0222, 'lps'),
	(365803, 125, '2015-01-15 00:07:48.000000', 'consum', 0.0221, 'lps'),
	(365804, 125, '2015-01-15 00:07:49.000000', 'consum', 0.0213, 'lps'),
	(365805, 125, '2015-01-15 00:07:50.000000', 'consum', 0.0224, 'lps'),
	(365806, 125, '2015-01-15 00:07:51.000000', 'consum', 0.0223, 'lps'),
	(365807, 125, '2015-01-15 00:07:52.000000', 'consum', 0.0217, 'lps'),
	(365808, 125, '2015-01-15 00:07:53.000000', 'consum', 0.0224, 'lps'),
	(365809, 125, '2015-01-15 00:07:54.000000', 'consum', 0.0225, 'lps'),
	(365810, 125, '2015-01-15 00:07:55.000000', 'consum', 0.0225, 'lps'),
	(365811, 125, '2015-01-15 00:07:56.000000', 'consum', 0.0226, 'lps'),
	(365812, 125, '2015-01-15 00:07:57.000000', 'consum', 0.0211, 'lps'),
	(365813, 125, '2015-01-15 00:07:58.000000', 'consum', 0.0217, 'lps'),
	(365814, 125, '2015-01-15 00:07:59.000000', 'consum', 0.0211, 'lps'),
	(365815, 125, '2015-01-15 00:08:00.000000', 'consum', 0.0210, 'lps'),
	(365816, 125, '2015-01-15 00:08:01.000000', 'consum', 0.0226, 'lps'),
	(365817, 125, '2015-01-15 00:08:02.000000', 'consum', 0.0220, 'lps'),
	(365818, 125, '2015-01-15 00:08:03.000000', 'consum', 0.0213, 'lps'),
	(365819, 125, '2015-01-15 00:08:04.000000', 'consum', 0.0215, 'lps'),
	(365820, 125, '2015-01-15 00:08:05.000000', 'consum', 0.0224, 'lps'),
	(365821, 125, '2015-01-15 00:08:06.000000', 'consum', 0.0213, 'lps'),
	(365822, 125, '2015-01-15 00:08:07.000000', 'consum', 0.0220, 'lps'),
	(365823, 125, '2015-01-15 00:08:08.000000', 'consum', 0.0217, 'lps'),
	(365824, 125, '2015-01-15 00:08:09.000000', 'consum', 0.0217, 'lps'),
	(365825, 125, '2015-01-15 00:08:10.000000', 'consum', 0.0225, 'lps'),
	(365826, 125, '2015-01-15 00:08:11.000000', 'consum', 0.0211, 'lps'),
	(365827, 125, '2015-01-15 00:08:12.000000', 'consum', 0.0223, 'lps'),
	(365828, 125, '2015-01-15 00:08:13.000000', 'consum', 0.0223, 'lps'),
	(365829, 125, '2015-01-15 00:08:14.000000', 'consum', 0.0217, 'lps'),
	(365830, 125, '2015-01-15 00:08:15.000000', 'consum', 0.0224, 'lps'),
	(365831, 125, '2015-01-15 00:08:16.000000', 'consum', 0.0211, 'lps'),
	(365832, 125, '2015-01-15 00:08:17.000000', 'consum', 0.0221, 'lps'),
	(365833, 125, '2015-01-15 00:08:18.000000', 'consum', 0.0214, 'lps'),
	(365834, 125, '2015-01-15 00:08:19.000000', 'consum', 0.0215, 'lps'),
	(365835, 125, '2015-01-15 00:08:20.000000', 'consum', 0.0224, 'lps'),
	(365836, 125, '2015-01-15 00:08:21.000000', 'consum', 0.0212, 'lps'),
	(365837, 125, '2015-01-15 00:08:22.000000', 'consum', 0.0214, 'lps'),
	(365838, 125, '2015-01-15 00:08:23.000000', 'consum', 0.0222, 'lps'),
	(365839, 125, '2015-01-15 00:08:24.000000', 'consum', 0.0210, 'lps'),
	(365840, 125, '2015-01-15 00:08:25.000000', 'consum', 0.0224, 'lps'),
	(365841, 125, '2015-01-15 00:08:26.000000', 'consum', 0.0213, 'lps'),
	(365842, 125, '2015-01-15 00:08:27.000000', 'consum', 0.0216, 'lps'),
	(365843, 125, '2015-01-15 00:08:28.000000', 'consum', 0.0214, 'lps'),
	(365844, 125, '2015-01-15 00:08:29.000000', 'consum', 0.0215, 'lps'),
	(365845, 125, '2015-01-15 00:08:30.000000', 'consum', 0.0224, 'lps'),
	(365846, 125, '2015-01-15 00:08:31.000000', 'consum', 0.0212, 'lps'),
	(365847, 125, '2015-01-15 00:08:32.000000', 'consum', 0.0214, 'lps'),
	(365848, 125, '2015-01-15 00:08:33.000000', 'consum', 0.0226, 'lps'),
	(365849, 125, '2015-01-15 00:08:34.000000', 'consum', 0.0210, 'lps'),
	(365850, 125, '2015-01-15 00:08:35.000000', 'consum', 0.0211, 'lps'),
	(365851, 125, '2015-01-15 00:08:36.000000', 'consum', 0.0218, 'lps'),
	(365852, 125, '2015-01-15 00:08:37.000000', 'consum', 0.0214, 'lps'),
	(365853, 125, '2015-01-15 00:08:38.000000', 'consum', 0.0221, 'lps'),
	(365854, 125, '2015-01-15 00:08:39.000000', 'consum', 0.0221, 'lps'),
	(365855, 125, '2015-01-15 00:08:40.000000', 'consum', 0.0215, 'lps'),
	(365856, 125, '2015-01-15 00:08:41.000000', 'consum', 0.0218, 'lps'),
	(365857, 125, '2015-01-15 00:08:42.000000', 'consum', 0.0218, 'lps'),
	(365858, 125, '2015-01-15 00:08:43.000000', 'consum', 0.0210, 'lps'),
	(365859, 125, '2015-01-15 00:08:44.000000', 'consum', 0.0221, 'lps'),
	(365860, 125, '2015-01-15 00:08:45.000000', 'consum', 0.0216, 'lps'),
	(365861, 125, '2015-01-15 00:08:46.000000', 'consum', 0.0221, 'lps'),
	(365862, 125, '2015-01-15 00:08:47.000000', 'consum', 0.0217, 'lps'),
	(365863, 125, '2015-01-15 00:08:48.000000', 'consum', 0.0210, 'lps'),
	(365864, 125, '2015-01-15 00:08:49.000000', 'consum', 0.0223, 'lps'),
	(365865, 125, '2015-01-15 00:08:50.000000', 'consum', 0.0224, 'lps'),
	(365866, 125, '2015-01-15 00:08:51.000000', 'consum', 0.0226, 'lps'),
	(365867, 125, '2015-01-15 00:08:52.000000', 'consum', 0.0215, 'lps'),
	(365868, 125, '2015-01-15 00:08:53.000000', 'consum', 0.0221, 'lps'),
	(365869, 125, '2015-01-15 00:08:54.000000', 'consum', 0.0215, 'lps'),
	(365870, 125, '2015-01-15 00:08:55.000000', 'consum', 0.0219, 'lps'),
	(365871, 125, '2015-01-15 00:08:56.000000', 'consum', 0.0226, 'lps'),
	(365872, 125, '2015-01-15 00:08:57.000000', 'consum', 0.0210, 'lps'),
	(365873, 125, '2015-01-15 00:08:58.000000', 'consum', 0.0216, 'lps'),
	(365874, 125, '2015-01-15 00:08:59.000000', 'consum', 0.0224, 'lps'),
	(365875, 125, '2015-01-15 00:09:00.000000', 'consum', 0.0211, 'lps'),
	(365876, 125, '2015-01-15 00:09:01.000000', 'consum', 0.0226, 'lps'),
	(365877, 125, '2015-01-15 00:09:02.000000', 'consum', 0.0217, 'lps'),
	(365878, 125, '2015-01-15 00:09:03.000000', 'consum', 0.0213, 'lps'),
	(365879, 125, '2015-01-15 00:09:04.000000', 'consum', 0.0225, 'lps'),
	(365880, 125, '2015-01-15 00:09:05.000000', 'consum', 0.0224, 'lps'),
	(365881, 125, '2015-01-15 00:09:06.000000', 'consum', 0.0218, 'lps'),
	(365882, 125, '2015-01-15 00:09:07.000000', 'consum', 0.0226, 'lps'),
	(365883, 125, '2015-01-15 00:09:08.000000', 'consum', 0.0213, 'lps'),
	(365884, 125, '2015-01-15 00:09:09.000000', 'consum', 0.0215, 'lps'),
	(365885, 125, '2015-01-15 00:09:10.000000', 'consum', 0.0226, 'lps'),
	(365886, 125, '2015-01-15 00:09:11.000000', 'consum', 0.0222, 'lps'),
	(365887, 125, '2015-01-15 00:09:12.000000', 'consum', 0.0223, 'lps'),
	(365888, 125, '2015-01-15 00:09:13.000000', 'consum', 0.0225, 'lps'),
	(365889, 125, '2015-01-15 00:09:14.000000', 'consum', 0.0211, 'lps'),
	(365890, 125, '2015-01-15 00:09:15.000000', 'consum', 0.0222, 'lps'),
	(365891, 125, '2015-01-15 00:09:16.000000', 'consum', 0.0215, 'lps'),
	(365892, 125, '2015-01-15 00:09:17.000000', 'consum', 0.0219, 'lps'),
	(365893, 125, '2015-01-15 00:09:18.000000', 'consum', 0.0224, 'lps'),
	(365894, 125, '2015-01-15 00:09:19.000000', 'consum', 0.0220, 'lps'),
	(365895, 125, '2015-01-15 00:09:20.000000', 'consum', 0.0219, 'lps'),
	(365896, 125, '2015-01-15 00:09:21.000000', 'consum', 0.0225, 'lps'),
	(365897, 125, '2015-01-15 00:09:22.000000', 'consum', 0.0223, 'lps'),
	(365898, 125, '2015-01-15 00:09:23.000000', 'consum', 0.0216, 'lps'),
	(365899, 125, '2015-01-15 00:09:24.000000', 'consum', 0.0219, 'lps'),
	(365900, 125, '2015-01-15 00:09:25.000000', 'consum', 0.0218, 'lps'),
	(365901, 125, '2015-01-15 00:09:26.000000', 'consum', 0.0225, 'lps'),
	(365902, 125, '2015-01-15 00:09:27.000000', 'consum', 0.0210, 'lps'),
	(365903, 125, '2015-01-15 00:09:28.000000', 'consum', 0.0219, 'lps'),
	(365904, 125, '2015-01-15 00:09:29.000000', 'consum', 0.0218, 'lps'),
	(365905, 125, '2015-01-15 00:09:30.000000', 'consum', 0.0226, 'lps'),
	(365906, 125, '2015-01-15 00:09:31.000000', 'consum', 0.0216, 'lps'),
	(365907, 125, '2015-01-15 00:09:32.000000', 'consum', 0.0224, 'lps'),
	(365908, 125, '2015-01-15 00:09:33.000000', 'consum', 0.0213, 'lps'),
	(365909, 125, '2015-01-15 00:09:34.000000', 'consum', 0.0218, 'lps'),
	(365910, 125, '2015-01-15 00:09:35.000000', 'consum', 0.0222, 'lps'),
	(365911, 125, '2015-01-15 00:09:36.000000', 'consum', 0.0215, 'lps'),
	(365912, 125, '2015-01-15 00:09:37.000000', 'consum', 0.0216, 'lps'),
	(365913, 125, '2015-01-15 00:09:38.000000', 'consum', 0.0226, 'lps'),
	(365914, 125, '2015-01-15 00:09:39.000000', 'consum', 0.0221, 'lps'),
	(365915, 125, '2015-01-15 00:09:40.000000', 'consum', 0.0219, 'lps'),
	(365916, 125, '2015-01-15 00:09:41.000000', 'consum', 0.0221, 'lps'),
	(365917, 125, '2015-01-15 00:09:42.000000', 'consum', 0.0223, 'lps'),
	(365918, 125, '2015-01-15 00:09:43.000000', 'consum', 0.0210, 'lps'),
	(365919, 125, '2015-01-15 00:09:44.000000', 'consum', 0.0220, 'lps'),
	(365920, 125, '2015-01-15 00:09:45.000000', 'consum', 0.0226, 'lps'),
	(365921, 125, '2015-01-15 00:09:46.000000', 'consum', 0.0212, 'lps'),
	(365922, 125, '2015-01-15 00:09:47.000000', 'consum', 0.0224, 'lps'),
	(365923, 125, '2015-01-15 00:09:48.000000', 'consum', 0.0220, 'lps'),
	(365924, 125, '2015-01-15 00:09:49.000000', 'consum', 0.0222, 'lps'),
	(365925, 125, '2015-01-15 00:09:50.000000', 'consum', 0.0221, 'lps'),
	(365926, 125, '2015-01-15 00:09:51.000000', 'consum', 0.0215, 'lps'),
	(365927, 125, '2015-01-15 00:09:52.000000', 'consum', 0.0216, 'lps'),
	(365928, 125, '2015-01-15 00:09:53.000000', 'consum', 0.0211, 'lps'),
	(365929, 125, '2015-01-15 00:09:54.000000', 'consum', 0.0215, 'lps'),
	(365930, 125, '2015-01-15 00:09:55.000000', 'consum', 0.0217, 'lps'),
	(365931, 125, '2015-01-15 00:09:56.000000', 'consum', 0.0211, 'lps'),
	(365932, 125, '2015-01-15 00:09:57.000000', 'consum', 0.0210, 'lps'),
	(365933, 125, '2015-01-15 00:09:58.000000', 'consum', 0.0211, 'lps'),
	(365934, 125, '2015-01-15 00:09:59.000000', 'consum', 0.0212, 'lps'),
	(365935, 125, '2015-01-15 00:10:00.000000', 'consum', 0.0221, 'lps'),
	(365936, 125, '2015-01-15 00:10:01.000000', 'consum', 0.0224, 'lps'),
	(365937, 125, '2015-01-15 00:10:02.000000', 'consum', 0.0215, 'lps'),
	(365938, 125, '2015-01-15 00:10:03.000000', 'consum', 0.0211, 'lps'),
	(365939, 125, '2015-01-15 00:10:04.000000', 'consum', 0.0216, 'lps'),
	(365940, 125, '2015-01-15 00:10:05.000000', 'consum', 0.0220, 'lps'),
	(365941, 125, '2015-01-15 00:10:06.000000', 'consum', 0.0210, 'lps'),
	(365942, 125, '2015-01-15 00:10:07.000000', 'consum', 0.0214, 'lps'),
	(365943, 125, '2015-01-15 00:10:08.000000', 'consum', 0.0214, 'lps'),
	(365944, 125, '2015-01-15 00:10:09.000000', 'consum', 0.0220, 'lps'),
	(365945, 125, '2015-01-15 00:10:10.000000', 'consum', 0.0214, 'lps'),
	(365946, 125, '2015-01-15 00:10:11.000000', 'consum', 0.0218, 'lps'),
	(365947, 125, '2015-01-15 00:10:12.000000', 'consum', 0.0219, 'lps'),
	(365948, 125, '2015-01-15 00:10:13.000000', 'consum', 0.0214, 'lps'),
	(365949, 125, '2015-01-15 00:10:14.000000', 'consum', 0.0223, 'lps'),
	(365950, 125, '2015-01-15 00:10:15.000000', 'consum', 0.0210, 'lps'),
	(365951, 125, '2015-01-15 00:10:16.000000', 'consum', 0.0222, 'lps'),
	(365952, 125, '2015-01-15 00:10:17.000000', 'consum', 0.0220, 'lps'),
	(365953, 125, '2015-01-15 00:10:18.000000', 'consum', 0.0226, 'lps'),
	(365954, 125, '2015-01-15 00:10:19.000000', 'consum', 0.0210, 'lps'),
	(365955, 125, '2015-01-15 00:10:20.000000', 'consum', 0.0214, 'lps'),
	(365956, 125, '2015-01-15 00:10:21.000000', 'consum', 0.0210, 'lps'),
	(365957, 125, '2015-01-15 00:10:22.000000', 'consum', 0.0219, 'lps'),
	(365958, 125, '2015-01-15 00:10:23.000000', 'consum', 0.0222, 'lps'),
	(365959, 125, '2015-01-15 00:10:24.000000', 'consum', 0.0225, 'lps'),
	(365960, 125, '2015-01-15 00:10:25.000000', 'consum', 0.0218, 'lps'),
	(365961, 125, '2015-01-15 00:10:26.000000', 'consum', 0.0219, 'lps'),
	(365962, 125, '2015-01-15 00:10:27.000000', 'consum', 0.0215, 'lps'),
	(365963, 125, '2015-01-15 00:10:28.000000', 'consum', 0.0211, 'lps'),
	(365964, 125, '2015-01-15 00:10:29.000000', 'consum', 0.0215, 'lps'),
	(365965, 125, '2015-01-15 00:10:30.000000', 'consum', 0.0215, 'lps'),
	(365966, 125, '2015-01-15 00:10:31.000000', 'consum', 0.0221, 'lps'),
	(365967, 125, '2015-01-15 00:10:32.000000', 'consum', 0.0215, 'lps'),
	(365968, 125, '2015-01-15 00:10:33.000000', 'consum', 0.0223, 'lps'),
	(365969, 125, '2015-01-15 00:10:34.000000', 'consum', 0.0223, 'lps'),
	(365970, 125, '2015-01-15 00:10:35.000000', 'consum', 0.0220, 'lps'),
	(365971, 125, '2015-01-15 00:10:36.000000', 'consum', 0.0223, 'lps'),
	(365972, 125, '2015-01-15 00:10:37.000000', 'consum', 0.0210, 'lps'),
	(365973, 125, '2015-01-15 00:10:38.000000', 'consum', 0.0224, 'lps'),
	(365974, 125, '2015-01-15 00:10:39.000000', 'consum', 0.0210, 'lps'),
	(365975, 125, '2015-01-15 00:10:40.000000', 'consum', 0.0220, 'lps'),
	(365976, 125, '2015-01-15 00:10:41.000000', 'consum', 0.0226, 'lps'),
	(365977, 125, '2015-01-15 00:10:42.000000', 'consum', 0.0225, 'lps'),
	(365978, 125, '2015-01-15 00:10:43.000000', 'consum', 0.0224, 'lps'),
	(365979, 125, '2015-01-15 00:10:44.000000', 'consum', 0.0215, 'lps'),
	(365980, 125, '2015-01-15 00:10:45.000000', 'consum', 0.0213, 'lps'),
	(365981, 125, '2015-01-15 00:10:46.000000', 'consum', 0.0210, 'lps'),
	(365982, 125, '2015-01-15 00:10:47.000000', 'consum', 0.0219, 'lps'),
	(365983, 125, '2015-01-15 00:10:48.000000', 'consum', 0.0220, 'lps'),
	(365984, 125, '2015-01-15 00:10:49.000000', 'consum', 0.0219, 'lps'),
	(365985, 125, '2015-01-15 00:10:50.000000', 'consum', 0.0226, 'lps'),
	(365986, 125, '2015-01-15 00:10:51.000000', 'consum', 0.0210, 'lps'),
	(365987, 125, '2015-01-15 00:10:52.000000', 'consum', 0.0216, 'lps'),
	(365988, 125, '2015-01-15 00:10:53.000000', 'consum', 0.0221, 'lps'),
	(365989, 125, '2015-01-15 00:10:54.000000', 'consum', 0.0213, 'lps'),
	(365990, 125, '2015-01-15 00:10:55.000000', 'consum', 0.0211, 'lps'),
	(365991, 125, '2015-01-15 00:10:56.000000', 'consum', 0.0222, 'lps'),
	(365992, 125, '2015-01-15 00:10:57.000000', 'consum', 0.0216, 'lps'),
	(365993, 125, '2015-01-15 00:10:58.000000', 'consum', 0.0222, 'lps'),
	(365994, 125, '2015-01-15 00:10:59.000000', 'consum', 0.0219, 'lps'),
	(365995, 125, '2015-01-15 00:11:00.000000', 'consum', 0.0220, 'lps'),
	(365996, 125, '2015-01-15 00:11:01.000000', 'consum', 0.0217, 'lps'),
	(365997, 125, '2015-01-15 00:11:02.000000', 'consum', 0.0214, 'lps'),
	(365998, 125, '2015-01-15 00:11:03.000000', 'consum', 0.0210, 'lps'),
	(365999, 125, '2015-01-15 00:11:04.000000', 'consum', 0.0216, 'lps'),
	(366000, 125, '2015-01-15 00:11:05.000000', 'consum', 0.0225, 'lps'),
	(366001, 125, '2015-01-15 00:11:06.000000', 'consum', 0.0214, 'lps'),
	(366002, 125, '2015-01-15 00:11:07.000000', 'consum', 0.0218, 'lps'),
	(366003, 125, '2015-01-15 00:11:08.000000', 'consum', 0.0225, 'lps'),
	(366004, 125, '2015-01-15 00:11:09.000000', 'consum', 0.0210, 'lps'),
	(366005, 125, '2015-01-15 00:11:10.000000', 'consum', 0.0217, 'lps'),
	(366006, 125, '2015-01-15 00:11:11.000000', 'consum', 0.0211, 'lps'),
	(366007, 125, '2015-01-15 00:11:12.000000', 'consum', 0.0213, 'lps'),
	(366008, 125, '2015-01-15 00:11:13.000000', 'consum', 0.0221, 'lps'),
	(366009, 125, '2015-01-15 00:11:14.000000', 'consum', 0.0221, 'lps'),
	(366010, 125, '2015-01-15 00:11:15.000000', 'consum', 0.0215, 'lps'),
	(366011, 125, '2015-01-15 00:11:16.000000', 'consum', 0.0222, 'lps'),
	(366012, 125, '2015-01-15 00:11:17.000000', 'consum', 0.0219, 'lps'),
	(366013, 125, '2015-01-15 00:11:18.000000', 'consum', 0.0221, 'lps'),
	(366014, 125, '2015-01-15 00:11:19.000000', 'consum', 0.0222, 'lps'),
	(366015, 125, '2015-01-15 00:11:20.000000', 'consum', 0.0218, 'lps'),
	(366016, 125, '2015-01-15 00:11:21.000000', 'consum', 0.0215, 'lps'),
	(366017, 125, '2015-01-15 00:11:22.000000', 'consum', 0.0213, 'lps'),
	(366018, 125, '2015-01-15 00:11:23.000000', 'consum', 0.0226, 'lps'),
	(366019, 125, '2015-01-15 00:11:24.000000', 'consum', 0.0213, 'lps'),
	(366020, 125, '2015-01-15 00:11:25.000000', 'consum', 0.0214, 'lps'),
	(366021, 125, '2015-01-15 00:11:26.000000', 'consum', 0.0220, 'lps'),
	(366022, 125, '2015-01-15 00:11:27.000000', 'consum', 0.0213, 'lps'),
	(366023, 125, '2015-01-15 00:11:28.000000', 'consum', 0.0215, 'lps'),
	(366024, 125, '2015-01-15 00:11:29.000000', 'consum', 0.0210, 'lps'),
	(366025, 125, '2015-01-15 00:11:30.000000', 'consum', 0.0211, 'lps'),
	(366026, 125, '2015-01-15 00:11:31.000000', 'consum', 0.0215, 'lps'),
	(366027, 125, '2015-01-15 00:11:32.000000', 'consum', 0.0214, 'lps'),
	(366028, 125, '2015-01-15 00:11:33.000000', 'consum', 0.0218, 'lps'),
	(366029, 125, '2015-01-15 00:11:34.000000', 'consum', 0.0221, 'lps'),
	(366030, 125, '2015-01-15 00:11:35.000000', 'consum', 0.0225, 'lps'),
	(366031, 125, '2015-01-15 00:11:36.000000', 'consum', 0.0217, 'lps'),
	(366032, 125, '2015-01-15 00:11:37.000000', 'consum', 0.0217, 'lps'),
	(366033, 125, '2015-01-15 00:11:38.000000', 'consum', 0.0226, 'lps'),
	(366034, 125, '2015-01-15 00:11:39.000000', 'consum', 0.0219, 'lps'),
	(366035, 125, '2015-01-15 00:11:40.000000', 'consum', 0.0224, 'lps'),
	(366036, 125, '2015-01-15 00:11:41.000000', 'consum', 0.0218, 'lps'),
	(366037, 125, '2015-01-15 00:11:42.000000', 'consum', 0.0210, 'lps'),
	(366038, 125, '2015-01-15 00:11:43.000000', 'consum', 0.0220, 'lps'),
	(366039, 125, '2015-01-15 00:11:44.000000', 'consum', 0.0226, 'lps'),
	(366040, 125, '2015-01-15 00:11:45.000000', 'consum', 0.0226, 'lps'),
	(366041, 125, '2015-01-15 00:11:46.000000', 'consum', 0.0211, 'lps'),
	(366042, 125, '2015-01-15 00:11:47.000000', 'consum', 0.0217, 'lps'),
	(366043, 125, '2015-01-15 00:11:48.000000', 'consum', 0.0224, 'lps'),
	(366044, 125, '2015-01-15 00:11:49.000000', 'consum', 0.0210, 'lps'),
	(366045, 125, '2015-01-15 00:11:50.000000', 'consum', 0.0218, 'lps'),
	(366046, 125, '2015-01-15 00:11:51.000000', 'consum', 0.0217, 'lps'),
	(366047, 125, '2015-01-15 00:11:52.000000', 'consum', 0.0221, 'lps'),
	(366048, 125, '2015-01-15 00:11:53.000000', 'consum', 0.0211, 'lps'),
	(366049, 125, '2015-01-15 00:11:54.000000', 'consum', 0.0218, 'lps'),
	(366050, 125, '2015-01-15 00:11:55.000000', 'consum', 0.0213, 'lps'),
	(366051, 125, '2015-01-15 00:11:56.000000', 'consum', 0.0218, 'lps'),
	(366052, 125, '2015-01-15 00:11:57.000000', 'consum', 0.0223, 'lps'),
	(366053, 125, '2015-01-15 00:11:58.000000', 'consum', 0.0220, 'lps'),
	(366054, 125, '2015-01-15 00:11:59.000000', 'consum', 0.0220, 'lps'),
	(366055, 125, '2015-01-15 00:12:00.000000', 'consum', 0.0213, 'lps'),
	(366056, 125, '2015-01-15 00:12:01.000000', 'consum', 0.0214, 'lps'),
	(366057, 125, '2015-01-15 00:12:02.000000', 'consum', 0.0223, 'lps'),
	(366058, 125, '2015-01-15 00:12:03.000000', 'consum', 0.0210, 'lps'),
	(366059, 125, '2015-01-15 00:12:04.000000', 'consum', 0.0223, 'lps'),
	(366060, 125, '2015-01-15 00:12:05.000000', 'consum', 0.0225, 'lps'),
	(366061, 125, '2015-01-15 00:12:06.000000', 'consum', 0.0210, 'lps'),
	(366062, 125, '2015-01-15 00:12:07.000000', 'consum', 0.0219, 'lps'),
	(366063, 125, '2015-01-15 00:12:08.000000', 'consum', 0.0221, 'lps'),
	(366064, 125, '2015-01-15 00:12:09.000000', 'consum', 0.0220, 'lps'),
	(366065, 125, '2015-01-15 00:12:10.000000', 'consum', 0.0212, 'lps'),
	(366066, 125, '2015-01-15 00:12:11.000000', 'consum', 0.0224, 'lps'),
	(366067, 125, '2015-01-15 00:12:12.000000', 'consum', 0.0224, 'lps'),
	(366068, 125, '2015-01-15 00:12:13.000000', 'consum', 0.0221, 'lps'),
	(366069, 125, '2015-01-15 00:12:14.000000', 'consum', 0.0224, 'lps'),
	(366070, 125, '2015-01-15 00:12:15.000000', 'consum', 0.0215, 'lps'),
	(366071, 125, '2015-01-15 00:12:16.000000', 'consum', 0.0210, 'lps'),
	(366072, 125, '2015-01-15 00:12:17.000000', 'consum', 0.0211, 'lps'),
	(366073, 125, '2015-01-15 00:12:18.000000', 'consum', 0.0216, 'lps'),
	(366074, 125, '2015-01-15 00:12:19.000000', 'consum', 0.0223, 'lps'),
	(366075, 125, '2015-01-15 00:12:20.000000', 'consum', 0.0221, 'lps'),
	(366076, 125, '2015-01-15 00:12:21.000000', 'consum', 0.0225, 'lps'),
	(366077, 125, '2015-01-15 00:12:22.000000', 'consum', 0.0221, 'lps'),
	(366078, 125, '2015-01-15 00:12:23.000000', 'consum', 0.0218, 'lps'),
	(366079, 125, '2015-01-15 00:12:24.000000', 'consum', 0.0219, 'lps'),
	(366080, 125, '2015-01-15 00:12:25.000000', 'consum', 0.0214, 'lps'),
	(366081, 125, '2015-01-15 00:12:26.000000', 'consum', 0.0222, 'lps'),
	(366082, 125, '2015-01-15 00:12:27.000000', 'consum', 0.0224, 'lps'),
	(366083, 125, '2015-01-15 00:12:28.000000', 'consum', 0.0211, 'lps'),
	(366084, 125, '2015-01-15 00:12:29.000000', 'consum', 0.0223, 'lps'),
	(366085, 125, '2015-01-15 00:12:30.000000', 'consum', 0.0222, 'lps'),
	(366086, 125, '2015-01-15 00:12:31.000000', 'consum', 0.0213, 'lps'),
	(366087, 125, '2015-01-15 00:12:32.000000', 'consum', 0.0223, 'lps'),
	(366088, 125, '2015-01-15 00:12:33.000000', 'consum', 0.0215, 'lps'),
	(366089, 125, '2015-01-15 00:12:34.000000', 'consum', 0.0214, 'lps'),
	(366090, 125, '2015-01-15 00:12:35.000000', 'consum', 0.0215, 'lps'),
	(366091, 125, '2015-01-15 00:12:36.000000', 'consum', 0.0224, 'lps'),
	(366092, 125, '2015-01-15 00:12:37.000000', 'consum', 0.0214, 'lps'),
	(366093, 125, '2015-01-15 00:12:38.000000', 'consum', 0.0223, 'lps'),
	(366094, 125, '2015-01-15 00:12:39.000000', 'consum', 0.0212, 'lps'),
	(366095, 125, '2015-01-15 00:12:40.000000', 'consum', 0.0216, 'lps'),
	(366096, 125, '2015-01-15 00:12:41.000000', 'consum', 0.0216, 'lps'),
	(366097, 125, '2015-01-15 00:12:42.000000', 'consum', 0.0224, 'lps'),
	(366098, 125, '2015-01-15 00:12:43.000000', 'consum', 0.0210, 'lps'),
	(366099, 125, '2015-01-15 00:12:44.000000', 'consum', 0.0220, 'lps'),
	(366100, 125, '2015-01-15 00:12:45.000000', 'consum', 0.0212, 'lps'),
	(366101, 125, '2015-01-15 00:12:46.000000', 'consum', 0.0222, 'lps'),
	(366102, 125, '2015-01-15 00:12:47.000000', 'consum', 0.0215, 'lps'),
	(366103, 125, '2015-01-15 00:12:48.000000', 'consum', 0.0214, 'lps'),
	(366104, 125, '2015-01-15 00:12:49.000000', 'consum', 0.0218, 'lps'),
	(366105, 125, '2015-01-15 00:12:50.000000', 'consum', 0.0219, 'lps'),
	(366106, 125, '2015-01-15 00:12:51.000000', 'consum', 0.0214, 'lps'),
	(366107, 125, '2015-01-15 00:12:52.000000', 'consum', 0.0223, 'lps'),
	(366108, 125, '2015-01-15 00:12:53.000000', 'consum', 0.0212, 'lps'),
	(366109, 125, '2015-01-15 00:12:54.000000', 'consum', 0.0214, 'lps'),
	(366110, 125, '2015-01-15 00:12:55.000000', 'consum', 0.0225, 'lps'),
	(366111, 125, '2015-01-15 00:12:56.000000', 'consum', 0.0222, 'lps'),
	(366112, 125, '2015-01-15 00:12:57.000000', 'consum', 0.0211, 'lps'),
	(366113, 125, '2015-01-15 00:12:58.000000', 'consum', 0.0212, 'lps'),
	(366114, 125, '2015-01-15 00:12:59.000000', 'consum', 0.0219, 'lps'),
	(366115, 125, '2015-01-15 00:13:00.000000', 'consum', 0.0215, 'lps'),
	(366116, 125, '2015-01-15 00:13:01.000000', 'consum', 0.0223, 'lps'),
	(366117, 125, '2015-01-15 00:13:02.000000', 'consum', 0.0212, 'lps'),
	(366118, 125, '2015-01-15 00:13:03.000000', 'consum', 0.0213, 'lps'),
	(366119, 125, '2015-01-15 00:13:04.000000', 'consum', 0.0220, 'lps'),
	(366120, 125, '2015-01-15 00:13:05.000000', 'consum', 0.0220, 'lps'),
	(366121, 125, '2015-01-15 00:13:06.000000', 'consum', 0.0211, 'lps'),
	(366122, 125, '2015-01-15 00:13:07.000000', 'consum', 0.0220, 'lps'),
	(366123, 125, '2015-01-15 00:13:08.000000', 'consum', 0.0223, 'lps'),
	(366124, 125, '2015-01-15 00:13:09.000000', 'consum', 0.0214, 'lps'),
	(366125, 125, '2015-01-15 00:13:10.000000', 'consum', 0.0222, 'lps'),
	(366126, 125, '2015-01-15 00:13:11.000000', 'consum', 0.0226, 'lps'),
	(366127, 125, '2015-01-15 00:13:12.000000', 'consum', 0.0220, 'lps'),
	(366128, 125, '2015-01-15 00:13:13.000000', 'consum', 0.0214, 'lps'),
	(366129, 125, '2015-01-15 00:13:14.000000', 'consum', 0.0217, 'lps'),
	(366130, 125, '2015-01-15 00:13:15.000000', 'consum', 0.0216, 'lps'),
	(366131, 125, '2015-01-15 00:13:16.000000', 'consum', 0.0219, 'lps'),
	(366132, 125, '2015-01-15 00:13:17.000000', 'consum', 0.0222, 'lps'),
	(366133, 125, '2015-01-15 00:13:18.000000', 'consum', 0.0210, 'lps'),
	(366134, 125, '2015-01-15 00:13:19.000000', 'consum', 0.0223, 'lps'),
	(366135, 125, '2015-01-15 00:13:20.000000', 'consum', 0.0224, 'lps'),
	(366136, 125, '2015-01-15 00:13:21.000000', 'consum', 0.0226, 'lps'),
	(366137, 125, '2015-01-15 00:13:22.000000', 'consum', 0.0215, 'lps'),
	(366138, 125, '2015-01-15 00:13:23.000000', 'consum', 0.0223, 'lps'),
	(366139, 125, '2015-01-15 00:13:24.000000', 'consum', 0.0225, 'lps'),
	(366140, 125, '2015-01-15 00:13:25.000000', 'consum', 0.0214, 'lps'),
	(366141, 125, '2015-01-15 00:13:26.000000', 'consum', 0.0220, 'lps'),
	(366142, 125, '2015-01-15 00:13:27.000000', 'consum', 0.0213, 'lps'),
	(366143, 125, '2015-01-15 00:13:28.000000', 'consum', 0.0213, 'lps'),
	(366144, 125, '2015-01-15 00:13:29.000000', 'consum', 0.0217, 'lps'),
	(366145, 125, '2015-01-15 00:13:30.000000', 'consum', 0.0218, 'lps'),
	(366146, 125, '2015-01-15 00:13:31.000000', 'consum', 0.0212, 'lps'),
	(366147, 125, '2015-01-15 00:13:32.000000', 'consum', 0.0212, 'lps'),
	(366148, 125, '2015-01-15 00:13:33.000000', 'consum', 0.0217, 'lps'),
	(366149, 125, '2015-01-15 00:13:34.000000', 'consum', 0.0224, 'lps'),
	(366150, 125, '2015-01-15 00:13:35.000000', 'consum', 0.0222, 'lps'),
	(366151, 125, '2015-01-15 00:13:36.000000', 'consum', 0.0214, 'lps'),
	(366152, 125, '2015-01-15 00:13:37.000000', 'consum', 0.0212, 'lps'),
	(366153, 125, '2015-01-15 00:13:38.000000', 'consum', 0.0223, 'lps'),
	(366154, 125, '2015-01-15 00:13:39.000000', 'consum', 0.0218, 'lps'),
	(366155, 125, '2015-01-15 00:13:40.000000', 'consum', 0.0212, 'lps'),
	(366156, 125, '2015-01-15 00:13:41.000000', 'consum', 0.0213, 'lps'),
	(366157, 125, '2015-01-15 00:13:42.000000', 'consum', 0.0221, 'lps'),
	(366158, 125, '2015-01-15 00:13:43.000000', 'consum', 0.0223, 'lps'),
	(366159, 125, '2015-01-15 00:13:44.000000', 'consum', 0.0223, 'lps'),
	(366160, 125, '2015-01-15 00:13:45.000000', 'consum', 0.0223, 'lps'),
	(366161, 125, '2015-01-15 00:13:46.000000', 'consum', 0.0216, 'lps'),
	(366162, 125, '2015-01-15 00:13:47.000000', 'consum', 0.0221, 'lps'),
	(366163, 125, '2015-01-15 00:13:48.000000', 'consum', 0.0213, 'lps'),
	(366164, 125, '2015-01-15 00:13:49.000000', 'consum', 0.0211, 'lps'),
	(366165, 125, '2015-01-15 00:13:50.000000', 'consum', 0.0223, 'lps'),
	(366166, 125, '2015-01-15 00:13:51.000000', 'consum', 0.0220, 'lps'),
	(366167, 125, '2015-01-15 00:13:52.000000', 'consum', 0.0222, 'lps'),
	(366168, 125, '2015-01-15 00:13:53.000000', 'consum', 0.0224, 'lps'),
	(366169, 125, '2015-01-15 00:13:54.000000', 'consum', 0.0210, 'lps'),
	(366170, 125, '2015-01-15 00:13:55.000000', 'consum', 0.0220, 'lps'),
	(366171, 125, '2015-01-15 00:13:56.000000', 'consum', 0.0225, 'lps'),
	(366172, 125, '2015-01-15 00:13:57.000000', 'consum', 0.0222, 'lps'),
	(366173, 125, '2015-01-15 00:13:58.000000', 'consum', 0.0210, 'lps'),
	(366174, 125, '2015-01-15 00:13:59.000000', 'consum', 0.0224, 'lps'),
	(366175, 125, '2015-01-15 00:14:00.000000', 'consum', 0.0215, 'lps'),
	(366176, 125, '2015-01-15 00:14:01.000000', 'consum', 0.0225, 'lps'),
	(366177, 125, '2015-01-15 00:14:02.000000', 'consum', 0.0221, 'lps'),
	(366178, 125, '2015-01-15 00:14:03.000000', 'consum', 0.0219, 'lps'),
	(366179, 125, '2015-01-15 00:14:04.000000', 'consum', 0.0224, 'lps'),
	(366180, 125, '2015-01-15 00:14:05.000000', 'consum', 0.0217, 'lps'),
	(366181, 125, '2015-01-15 00:14:06.000000', 'consum', 0.0223, 'lps'),
	(366182, 125, '2015-01-15 00:14:07.000000', 'consum', 0.0219, 'lps'),
	(366183, 125, '2015-01-15 00:14:08.000000', 'consum', 0.0217, 'lps'),
	(366184, 125, '2015-01-15 00:14:09.000000', 'consum', 0.0220, 'lps'),
	(366185, 125, '2015-01-15 00:14:10.000000', 'consum', 0.0222, 'lps'),
	(366186, 125, '2015-01-15 00:14:11.000000', 'consum', 0.0223, 'lps'),
	(366187, 125, '2015-01-15 00:14:12.000000', 'consum', 0.0223, 'lps'),
	(366188, 125, '2015-01-15 00:14:13.000000', 'consum', 0.0220, 'lps'),
	(366189, 125, '2015-01-15 00:14:14.000000', 'consum', 0.0221, 'lps'),
	(366190, 125, '2015-01-15 00:14:15.000000', 'consum', 0.0219, 'lps'),
	(366191, 125, '2015-01-15 00:14:16.000000', 'consum', 0.0221, 'lps'),
	(366192, 125, '2015-01-15 00:14:17.000000', 'consum', 0.0222, 'lps'),
	(366193, 125, '2015-01-15 00:14:18.000000', 'consum', 0.0220, 'lps'),
	(366194, 125, '2015-01-15 00:14:19.000000', 'consum', 0.0225, 'lps'),
	(366195, 125, '2015-01-15 00:14:20.000000', 'consum', 0.0222, 'lps'),
	(366196, 125, '2015-01-15 00:14:21.000000', 'consum', 0.0225, 'lps'),
	(366197, 125, '2015-01-15 00:14:22.000000', 'consum', 0.0215, 'lps'),
	(366198, 125, '2015-01-15 00:14:23.000000', 'consum', 0.0210, 'lps'),
	(366199, 125, '2015-01-15 00:14:24.000000', 'consum', 0.0211, 'lps'),
	(366200, 125, '2015-01-15 00:14:25.000000', 'consum', 0.0216, 'lps'),
	(366201, 125, '2015-01-15 00:14:26.000000', 'consum', 0.0219, 'lps'),
	(366202, 125, '2015-01-15 00:14:27.000000', 'consum', 0.0222, 'lps'),
	(366203, 125, '2015-01-15 00:14:28.000000', 'consum', 0.0225, 'lps'),
	(366204, 125, '2015-01-15 00:14:29.000000', 'consum', 0.0217, 'lps'),
	(366205, 125, '2015-01-15 00:14:30.000000', 'consum', 0.0219, 'lps'),
	(366206, 125, '2015-01-15 00:14:31.000000', 'consum', 0.0214, 'lps'),
	(366207, 125, '2015-01-15 00:14:32.000000', 'consum', 0.0224, 'lps'),
	(366208, 125, '2015-01-15 00:14:33.000000', 'consum', 0.0215, 'lps'),
	(366209, 125, '2015-01-15 00:14:34.000000', 'consum', 0.0212, 'lps'),
	(366210, 125, '2015-01-15 00:14:35.000000', 'consum', 0.0224, 'lps'),
	(366211, 125, '2015-01-15 00:14:36.000000', 'consum', 0.0222, 'lps'),
	(366212, 125, '2015-01-15 00:14:37.000000', 'consum', 0.0213, 'lps'),
	(366213, 125, '2015-01-15 00:14:38.000000', 'consum', 0.0224, 'lps'),
	(366214, 125, '2015-01-15 00:14:39.000000', 'consum', 0.0222, 'lps'),
	(366215, 125, '2015-01-15 00:14:40.000000', 'consum', 0.0225, 'lps'),
	(366216, 125, '2015-01-15 00:14:41.000000', 'consum', 0.0215, 'lps'),
	(366217, 125, '2015-01-15 00:14:42.000000', 'consum', 0.0210, 'lps'),
	(366218, 125, '2015-01-15 00:14:43.000000', 'consum', 0.0213, 'lps'),
	(366219, 125, '2015-01-15 00:14:44.000000', 'consum', 0.0210, 'lps'),
	(366220, 125, '2015-01-15 00:14:45.000000', 'consum', 0.0215, 'lps'),
	(366221, 125, '2015-01-15 00:14:46.000000', 'consum', 0.0220, 'lps'),
	(366222, 125, '2015-01-15 00:14:47.000000', 'consum', 0.0213, 'lps'),
	(366223, 125, '2015-01-15 00:14:48.000000', 'consum', 0.0212, 'lps'),
	(366224, 125, '2015-01-15 00:14:49.000000', 'consum', 0.0211, 'lps'),
	(366225, 125, '2015-01-15 00:14:50.000000', 'consum', 0.0211, 'lps'),
	(366226, 125, '2015-01-15 00:14:51.000000', 'consum', 0.0213, 'lps'),
	(366227, 125, '2015-01-15 00:14:52.000000', 'consum', 0.0222, 'lps'),
	(366228, 125, '2015-01-15 00:14:53.000000', 'consum', 0.0212, 'lps'),
	(366229, 125, '2015-01-15 00:14:54.000000', 'consum', 0.0218, 'lps'),
	(366230, 125, '2015-01-15 00:14:55.000000', 'consum', 0.0211, 'lps'),
	(366231, 125, '2015-01-15 00:14:56.000000', 'consum', 0.0225, 'lps'),
	(366232, 125, '2015-01-15 00:14:57.000000', 'consum', 0.0212, 'lps'),
	(366233, 125, '2015-01-15 00:14:58.000000', 'consum', 0.0212, 'lps'),
	(366234, 125, '2015-01-15 00:14:59.000000', 'consum', 0.0216, 'lps'),
	(366235, 125, '2015-01-15 00:15:00.000000', 'consum', 0.0216, 'lps'),
	(366236, 125, '2015-01-15 00:15:01.000000', 'consum', 0.0222, 'lps'),
	(366237, 125, '2015-01-15 00:15:02.000000', 'consum', 0.0219, 'lps'),
	(366238, 125, '2015-01-15 00:15:03.000000', 'consum', 0.0221, 'lps'),
	(366239, 125, '2015-01-15 00:15:04.000000', 'consum', 0.0222, 'lps'),
	(366240, 125, '2015-01-15 00:15:05.000000', 'consum', 0.0219, 'lps'),
	(366241, 125, '2015-01-15 00:15:06.000000', 'consum', 0.0219, 'lps'),
	(366242, 125, '2015-01-15 00:15:07.000000', 'consum', 0.0214, 'lps'),
	(366243, 125, '2015-01-15 00:15:08.000000', 'consum', 0.0220, 'lps'),
	(366244, 125, '2015-01-15 00:15:09.000000', 'consum', 0.0213, 'lps'),
	(366245, 125, '2015-01-15 00:15:10.000000', 'consum', 0.0213, 'lps'),
	(366246, 125, '2015-01-15 00:15:11.000000', 'consum', 0.0218, 'lps'),
	(366247, 125, '2015-01-15 00:15:12.000000', 'consum', 0.0223, 'lps'),
	(366248, 125, '2015-01-15 00:15:13.000000', 'consum', 0.0217, 'lps'),
	(366249, 125, '2015-01-15 00:15:14.000000', 'consum', 0.0225, 'lps'),
	(366250, 125, '2015-01-15 00:15:15.000000', 'consum', 0.0212, 'lps'),
	(366251, 125, '2015-01-15 00:15:16.000000', 'consum', 0.0211, 'lps'),
	(366252, 125, '2015-01-15 00:15:17.000000', 'consum', 0.0211, 'lps'),
	(366253, 125, '2015-01-15 00:15:18.000000', 'consum', 0.0210, 'lps'),
	(366254, 125, '2015-01-15 00:15:19.000000', 'consum', 0.0223, 'lps'),
	(366255, 125, '2015-01-15 00:15:20.000000', 'consum', 0.0211, 'lps'),
	(366256, 125, '2015-01-15 00:15:21.000000', 'consum', 0.0225, 'lps'),
	(366257, 125, '2015-01-15 00:15:22.000000', 'consum', 0.0217, 'lps'),
	(366258, 125, '2015-01-15 00:15:23.000000', 'consum', 0.0216, 'lps'),
	(366259, 125, '2015-01-15 00:15:24.000000', 'consum', 0.0218, 'lps'),
	(366260, 125, '2015-01-15 00:15:25.000000', 'consum', 0.0217, 'lps'),
	(366261, 125, '2015-01-15 00:15:26.000000', 'consum', 0.0221, 'lps'),
	(366262, 125, '2015-01-15 00:15:27.000000', 'consum', 0.0211, 'lps'),
	(366263, 125, '2015-01-15 00:15:28.000000', 'consum', 0.0216, 'lps'),
	(366264, 125, '2015-01-15 00:15:29.000000', 'consum', 0.0223, 'lps'),
	(366265, 125, '2015-01-15 00:15:30.000000', 'consum', 0.0221, 'lps'),
	(366266, 125, '2015-01-15 00:15:31.000000', 'consum', 0.0211, 'lps'),
	(366267, 125, '2015-01-15 00:15:32.000000', 'consum', 0.0215, 'lps'),
	(366268, 125, '2015-01-15 00:15:33.000000', 'consum', 0.0216, 'lps'),
	(366269, 125, '2015-01-15 00:15:34.000000', 'consum', 0.0226, 'lps'),
	(366270, 125, '2015-01-15 00:15:35.000000', 'consum', 0.0222, 'lps'),
	(366271, 125, '2015-01-15 00:15:36.000000', 'consum', 0.0223, 'lps'),
	(366272, 125, '2015-01-15 00:15:37.000000', 'consum', 0.0220, 'lps'),
	(366273, 125, '2015-01-15 00:15:38.000000', 'consum', 0.0222, 'lps'),
	(366274, 125, '2015-01-15 00:15:39.000000', 'consum', 0.0225, 'lps'),
	(366275, 125, '2015-01-15 00:15:40.000000', 'consum', 0.0217, 'lps'),
	(366276, 125, '2015-01-15 00:15:41.000000', 'consum', 0.0216, 'lps'),
	(366277, 125, '2015-01-15 00:15:42.000000', 'consum', 0.0217, 'lps'),
	(366278, 125, '2015-01-15 00:15:43.000000', 'consum', 0.0214, 'lps'),
	(366279, 125, '2015-01-15 00:15:44.000000', 'consum', 0.0225, 'lps'),
	(366280, 125, '2015-01-15 00:15:45.000000', 'consum', 0.0221, 'lps'),
	(366281, 125, '2015-01-15 00:15:46.000000', 'consum', 0.0223, 'lps'),
	(366282, 125, '2015-01-15 00:15:47.000000', 'consum', 0.0224, 'lps'),
	(366283, 125, '2015-01-15 00:15:48.000000', 'consum', 0.0223, 'lps'),
	(366284, 125, '2015-01-15 00:15:49.000000', 'consum', 0.0219, 'lps'),
	(366285, 125, '2015-01-15 00:15:50.000000', 'consum', 0.0216, 'lps'),
	(366286, 125, '2015-01-15 00:15:51.000000', 'consum', 0.0213, 'lps'),
	(366287, 125, '2015-01-15 00:15:52.000000', 'consum', 0.0225, 'lps'),
	(366288, 125, '2015-01-15 00:15:53.000000', 'consum', 0.0226, 'lps'),
	(366289, 125, '2015-01-15 00:15:54.000000', 'consum', 0.0211, 'lps'),
	(366290, 125, '2015-01-15 00:15:55.000000', 'consum', 0.0219, 'lps'),
	(366291, 125, '2015-01-15 00:15:56.000000', 'consum', 0.0217, 'lps'),
	(366292, 125, '2015-01-15 00:15:57.000000', 'consum', 0.0221, 'lps'),
	(366293, 125, '2015-01-15 00:15:58.000000', 'consum', 0.0225, 'lps'),
	(366294, 125, '2015-01-15 00:15:59.000000', 'consum', 0.0219, 'lps'),
	(366295, 125, '2015-01-15 00:16:00.000000', 'consum', 0.0211, 'lps'),
	(366296, 125, '2015-01-15 00:16:01.000000', 'consum', 0.0223, 'lps'),
	(366297, 125, '2015-01-15 00:16:02.000000', 'consum', 0.0221, 'lps'),
	(366298, 125, '2015-01-15 00:16:03.000000', 'consum', 0.0226, 'lps'),
	(366299, 125, '2015-01-15 00:16:04.000000', 'consum', 0.0223, 'lps'),
	(366300, 125, '2015-01-15 00:16:05.000000', 'consum', 0.0210, 'lps'),
	(366301, 125, '2015-01-15 00:16:06.000000', 'consum', 0.0223, 'lps'),
	(366302, 125, '2015-01-15 00:16:07.000000', 'consum', 0.0223, 'lps'),
	(366303, 125, '2015-01-15 00:16:08.000000', 'consum', 0.0222, 'lps'),
	(366304, 125, '2015-01-15 00:16:09.000000', 'consum', 0.0213, 'lps'),
	(366305, 125, '2015-01-15 00:16:10.000000', 'consum', 0.0223, 'lps'),
	(366306, 125, '2015-01-15 00:16:11.000000', 'consum', 0.0216, 'lps'),
	(366307, 125, '2015-01-15 00:16:12.000000', 'consum', 0.0217, 'lps'),
	(366308, 125, '2015-01-15 00:16:13.000000', 'consum', 0.0212, 'lps'),
	(366309, 125, '2015-01-15 00:16:14.000000', 'consum', 0.0214, 'lps'),
	(366310, 125, '2015-01-15 00:16:15.000000', 'consum', 0.0226, 'lps'),
	(366311, 125, '2015-01-15 00:16:16.000000', 'consum', 0.0213, 'lps'),
	(366312, 125, '2015-01-15 00:16:17.000000', 'consum', 0.0225, 'lps'),
	(366313, 125, '2015-01-15 00:16:18.000000', 'consum', 0.0210, 'lps'),
	(366314, 125, '2015-01-15 00:16:19.000000', 'consum', 0.0215, 'lps'),
	(366315, 125, '2015-01-15 00:16:20.000000', 'consum', 0.0218, 'lps'),
	(366316, 125, '2015-01-15 00:16:21.000000', 'consum', 0.0221, 'lps'),
	(366317, 125, '2015-01-15 00:16:22.000000', 'consum', 0.0223, 'lps'),
	(366318, 125, '2015-01-15 00:16:23.000000', 'consum', 0.0224, 'lps'),
	(366319, 125, '2015-01-15 00:16:24.000000', 'consum', 0.0226, 'lps'),
	(366320, 125, '2015-01-15 00:16:25.000000', 'consum', 0.0216, 'lps'),
	(366321, 125, '2015-01-15 00:16:26.000000', 'consum', 0.0226, 'lps'),
	(366322, 125, '2015-01-15 00:16:27.000000', 'consum', 0.0223, 'lps'),
	(366323, 125, '2015-01-15 00:16:28.000000', 'consum', 0.0225, 'lps'),
	(366324, 125, '2015-01-15 00:16:29.000000', 'consum', 0.0215, 'lps'),
	(366325, 125, '2015-01-15 00:16:30.000000', 'consum', 0.0224, 'lps'),
	(366326, 125, '2015-01-15 00:16:31.000000', 'consum', 0.0213, 'lps'),
	(366327, 125, '2015-01-15 00:16:32.000000', 'consum', 0.0217, 'lps'),
	(366328, 125, '2015-01-15 00:16:33.000000', 'consum', 0.0221, 'lps'),
	(366329, 125, '2015-01-15 00:16:34.000000', 'consum', 0.0212, 'lps'),
	(366330, 125, '2015-01-15 00:16:35.000000', 'consum', 0.0218, 'lps'),
	(366331, 125, '2015-01-15 00:16:36.000000', 'consum', 0.0212, 'lps'),
	(366332, 125, '2015-01-15 00:16:37.000000', 'consum', 0.0214, 'lps'),
	(366333, 125, '2015-01-15 00:16:38.000000', 'consum', 0.0225, 'lps'),
	(366334, 125, '2015-01-15 00:16:39.000000', 'consum', 0.0221, 'lps'),
	(366335, 125, '2015-01-15 00:16:40.000000', 'consum', 0.0221, 'lps'),
	(366336, 125, '2015-01-15 00:16:41.000000', 'consum', 0.0216, 'lps'),
	(366337, 125, '2015-01-15 00:16:42.000000', 'consum', 0.0223, 'lps'),
	(366338, 125, '2015-01-15 00:16:43.000000', 'consum', 0.0226, 'lps'),
	(366339, 125, '2015-01-15 00:16:44.000000', 'consum', 0.0217, 'lps'),
	(366340, 125, '2015-01-15 00:16:45.000000', 'consum', 0.0213, 'lps'),
	(366341, 125, '2015-01-15 00:16:46.000000', 'consum', 0.0224, 'lps'),
	(366342, 125, '2015-01-15 00:16:47.000000', 'consum', 0.0220, 'lps'),
	(366343, 125, '2015-01-15 00:16:48.000000', 'consum', 0.0216, 'lps'),
	(366344, 125, '2015-01-15 00:16:49.000000', 'consum', 0.0213, 'lps'),
	(366345, 125, '2015-01-15 00:16:50.000000', 'consum', 0.0223, 'lps'),
	(366346, 125, '2015-01-15 00:16:51.000000', 'consum', 0.0216, 'lps'),
	(366347, 125, '2015-01-15 00:16:52.000000', 'consum', 0.0221, 'lps'),
	(366348, 125, '2015-01-15 00:16:53.000000', 'consum', 0.0210, 'lps'),
	(366349, 125, '2015-01-15 00:16:54.000000', 'consum', 0.0212, 'lps'),
	(366350, 125, '2015-01-15 00:16:55.000000', 'consum', 0.0220, 'lps'),
	(366351, 125, '2015-01-15 00:16:56.000000', 'consum', 0.0220, 'lps'),
	(366352, 125, '2015-01-15 00:16:57.000000', 'consum', 0.0213, 'lps'),
	(366353, 125, '2015-01-15 00:16:58.000000', 'consum', 0.0213, 'lps'),
	(366354, 125, '2015-01-15 00:16:59.000000', 'consum', 0.0216, 'lps'),
	(366355, 125, '2015-01-15 00:17:00.000000', 'consum', 0.0216, 'lps'),
	(366356, 125, '2015-01-15 00:17:01.000000', 'consum', 0.0223, 'lps'),
	(366357, 125, '2015-01-15 00:17:02.000000', 'consum', 0.0221, 'lps'),
	(366358, 125, '2015-01-15 00:17:03.000000', 'consum', 0.0211, 'lps'),
	(366359, 125, '2015-01-15 00:17:04.000000', 'consum', 0.0217, 'lps'),
	(366360, 125, '2015-01-15 00:17:05.000000', 'consum', 0.0226, 'lps'),
	(366361, 125, '2015-01-15 00:17:06.000000', 'consum', 0.0220, 'lps'),
	(366362, 125, '2015-01-15 00:17:07.000000', 'consum', 0.0226, 'lps'),
	(366363, 125, '2015-01-15 00:17:08.000000', 'consum', 0.0212, 'lps'),
	(366364, 125, '2015-01-15 00:17:09.000000', 'consum', 0.0221, 'lps'),
	(366365, 125, '2015-01-15 00:17:10.000000', 'consum', 0.0211, 'lps'),
	(366366, 125, '2015-01-15 00:17:11.000000', 'consum', 0.0217, 'lps'),
	(366367, 125, '2015-01-15 00:17:12.000000', 'consum', 0.0224, 'lps'),
	(366368, 125, '2015-01-15 00:17:13.000000', 'consum', 0.0210, 'lps'),
	(366369, 125, '2015-01-15 00:17:14.000000', 'consum', 0.0221, 'lps'),
	(366370, 125, '2015-01-15 00:17:15.000000', 'consum', 0.0212, 'lps'),
	(366371, 125, '2015-01-15 00:17:16.000000', 'consum', 0.0221, 'lps'),
	(366372, 125, '2015-01-15 00:17:17.000000', 'consum', 0.0225, 'lps'),
	(366373, 125, '2015-01-15 00:17:18.000000', 'consum', 0.0218, 'lps'),
	(366374, 125, '2015-01-15 00:17:19.000000', 'consum', 0.0222, 'lps'),
	(366375, 125, '2015-01-15 00:17:20.000000', 'consum', 0.0215, 'lps'),
	(366376, 125, '2015-01-15 00:17:21.000000', 'consum', 0.0216, 'lps'),
	(366377, 125, '2015-01-15 00:17:22.000000', 'consum', 0.0226, 'lps'),
	(366378, 125, '2015-01-15 00:17:23.000000', 'consum', 0.0220, 'lps'),
	(366379, 125, '2015-01-15 00:17:24.000000', 'consum', 0.0213, 'lps'),
	(366380, 125, '2015-01-15 00:17:25.000000', 'consum', 0.0213, 'lps'),
	(366381, 125, '2015-01-15 00:17:26.000000', 'consum', 0.0216, 'lps'),
	(366382, 125, '2015-01-15 00:17:27.000000', 'consum', 0.0213, 'lps'),
	(366383, 125, '2015-01-15 00:17:28.000000', 'consum', 0.0226, 'lps'),
	(366384, 125, '2015-01-15 00:17:29.000000', 'consum', 0.0213, 'lps'),
	(366385, 125, '2015-01-15 00:17:30.000000', 'consum', 0.0211, 'lps'),
	(366386, 125, '2015-01-15 00:17:31.000000', 'consum', 0.0222, 'lps'),
	(366387, 125, '2015-01-15 00:17:32.000000', 'consum', 0.0219, 'lps'),
	(366388, 125, '2015-01-15 00:17:33.000000', 'consum', 0.0219, 'lps'),
	(366389, 125, '2015-01-15 00:17:34.000000', 'consum', 0.0213, 'lps'),
	(366390, 125, '2015-01-15 00:17:35.000000', 'consum', 0.0212, 'lps'),
	(366391, 125, '2015-01-15 00:17:36.000000', 'consum', 0.0214, 'lps'),
	(366392, 125, '2015-01-15 00:17:37.000000', 'consum', 0.0224, 'lps'),
	(366393, 125, '2015-01-15 00:17:38.000000', 'consum', 0.0215, 'lps'),
	(366394, 125, '2015-01-15 00:17:39.000000', 'consum', 0.0214, 'lps'),
	(366395, 125, '2015-01-15 00:17:40.000000', 'consum', 0.0215, 'lps'),
	(366396, 125, '2015-01-15 00:17:41.000000', 'consum', 0.0221, 'lps'),
	(366397, 125, '2015-01-15 00:17:42.000000', 'consum', 0.0220, 'lps'),
	(366398, 125, '2015-01-15 00:17:43.000000', 'consum', 0.0226, 'lps'),
	(366399, 125, '2015-01-15 00:17:44.000000', 'consum', 0.0226, 'lps'),
	(366400, 125, '2015-01-15 00:17:45.000000', 'consum', 0.0224, 'lps'),
	(366401, 125, '2015-01-15 00:17:46.000000', 'consum', 0.0218, 'lps'),
	(366402, 125, '2015-01-15 00:17:47.000000', 'consum', 0.0223, 'lps'),
	(366403, 125, '2015-01-15 00:17:48.000000', 'consum', 0.0219, 'lps'),
	(366404, 125, '2015-01-15 00:17:49.000000', 'consum', 0.0216, 'lps'),
	(366405, 125, '2015-01-15 00:17:50.000000', 'consum', 0.0214, 'lps'),
	(366406, 125, '2015-01-15 00:17:51.000000', 'consum', 0.0214, 'lps'),
	(366407, 125, '2015-01-15 00:17:52.000000', 'consum', 0.0217, 'lps'),
	(366408, 125, '2015-01-15 00:17:53.000000', 'consum', 0.0218, 'lps'),
	(366409, 125, '2015-01-15 00:17:54.000000', 'consum', 0.0211, 'lps'),
	(366410, 125, '2015-01-15 00:17:55.000000', 'consum', 0.0225, 'lps'),
	(366411, 125, '2015-01-15 00:17:56.000000', 'consum', 0.0217, 'lps'),
	(366412, 125, '2015-01-15 00:17:57.000000', 'consum', 0.0215, 'lps'),
	(366413, 125, '2015-01-15 00:17:58.000000', 'consum', 0.0217, 'lps'),
	(366414, 125, '2015-01-15 00:17:59.000000', 'consum', 0.0213, 'lps'),
	(366415, 125, '2015-01-15 00:18:00.000000', 'consum', 0.0222, 'lps'),
	(366416, 125, '2015-01-15 00:18:01.000000', 'consum', 0.0225, 'lps'),
	(366417, 125, '2015-01-15 00:18:02.000000', 'consum', 0.0218, 'lps'),
	(366418, 125, '2015-01-15 00:18:03.000000', 'consum', 0.0223, 'lps'),
	(366419, 125, '2015-01-15 00:18:04.000000', 'consum', 0.0216, 'lps'),
	(366420, 125, '2015-01-15 00:18:05.000000', 'consum', 0.0219, 'lps'),
	(366421, 125, '2015-01-15 00:18:06.000000', 'consum', 0.0221, 'lps'),
	(366422, 125, '2015-01-15 00:18:07.000000', 'consum', 0.0221, 'lps'),
	(366423, 125, '2015-01-15 00:18:08.000000', 'consum', 0.0214, 'lps'),
	(366424, 125, '2015-01-15 00:18:09.000000', 'consum', 0.0215, 'lps'),
	(366425, 125, '2015-01-15 00:18:10.000000', 'consum', 0.0225, 'lps'),
	(366426, 125, '2015-01-15 00:18:11.000000', 'consum', 0.0217, 'lps'),
	(366427, 125, '2015-01-15 00:18:12.000000', 'consum', 0.0219, 'lps'),
	(366428, 125, '2015-01-15 00:18:13.000000', 'consum', 0.0219, 'lps'),
	(366429, 125, '2015-01-15 00:18:14.000000', 'consum', 0.0210, 'lps'),
	(366430, 125, '2015-01-15 00:18:15.000000', 'consum', 0.0220, 'lps'),
	(366431, 125, '2015-01-15 00:18:16.000000', 'consum', 0.0223, 'lps'),
	(366432, 125, '2015-01-15 00:18:17.000000', 'consum', 0.0213, 'lps'),
	(366433, 125, '2015-01-15 00:18:18.000000', 'consum', 0.0219, 'lps'),
	(366434, 125, '2015-01-15 00:18:19.000000', 'consum', 0.0214, 'lps'),
	(366435, 125, '2015-01-15 00:18:20.000000', 'consum', 0.0222, 'lps'),
	(366436, 125, '2015-01-15 00:18:21.000000', 'consum', 0.0224, 'lps'),
	(366437, 125, '2015-01-15 00:18:22.000000', 'consum', 0.0226, 'lps'),
	(366438, 125, '2015-01-15 00:18:23.000000', 'consum', 0.0216, 'lps'),
	(366439, 125, '2015-01-15 00:18:24.000000', 'consum', 0.0226, 'lps'),
	(366440, 125, '2015-01-15 00:18:25.000000', 'consum', 0.0223, 'lps'),
	(366441, 125, '2015-01-15 00:18:26.000000', 'consum', 0.0225, 'lps'),
	(366442, 125, '2015-01-15 00:18:27.000000', 'consum', 0.0216, 'lps'),
	(366443, 125, '2015-01-15 00:18:28.000000', 'consum', 0.0226, 'lps'),
	(366444, 125, '2015-01-15 00:18:29.000000', 'consum', 0.0222, 'lps'),
	(366445, 125, '2015-01-15 00:18:30.000000', 'consum', 0.0224, 'lps'),
	(366446, 125, '2015-01-15 00:18:31.000000', 'consum', 0.0225, 'lps'),
	(366447, 125, '2015-01-15 00:18:32.000000', 'consum', 0.0211, 'lps'),
	(366448, 125, '2015-01-15 00:18:33.000000', 'consum', 0.0223, 'lps'),
	(366449, 125, '2015-01-15 00:18:34.000000', 'consum', 0.0222, 'lps'),
	(366450, 125, '2015-01-15 00:18:35.000000', 'consum', 0.0214, 'lps'),
	(366451, 125, '2015-01-15 00:18:36.000000', 'consum', 0.0210, 'lps'),
	(366452, 125, '2015-01-15 00:18:37.000000', 'consum', 0.0217, 'lps'),
	(366453, 125, '2015-01-15 00:18:38.000000', 'consum', 0.0212, 'lps'),
	(366454, 125, '2015-01-15 00:18:39.000000', 'consum', 0.0215, 'lps'),
	(366455, 125, '2015-01-15 00:18:40.000000', 'consum', 0.0214, 'lps'),
	(366456, 125, '2015-01-15 00:18:41.000000', 'consum', 0.0213, 'lps'),
	(366457, 125, '2015-01-15 00:18:42.000000', 'consum', 0.0214, 'lps'),
	(366458, 125, '2015-01-15 00:18:43.000000', 'consum', 0.0223, 'lps'),
	(366459, 125, '2015-01-15 00:18:44.000000', 'consum', 0.0211, 'lps'),
	(366460, 125, '2015-01-15 00:18:45.000000', 'consum', 0.0212, 'lps'),
	(366461, 125, '2015-01-15 00:18:46.000000', 'consum', 0.0216, 'lps'),
	(366462, 125, '2015-01-15 00:18:47.000000', 'consum', 0.0219, 'lps'),
	(366463, 125, '2015-01-15 00:18:48.000000', 'consum', 0.0219, 'lps'),
	(366464, 125, '2015-01-15 00:18:49.000000', 'consum', 0.0214, 'lps'),
	(366465, 125, '2015-01-15 00:18:50.000000', 'consum', 0.0219, 'lps'),
	(366466, 125, '2015-01-15 00:18:51.000000', 'consum', 0.0226, 'lps'),
	(366467, 125, '2015-01-15 00:18:52.000000', 'consum', 0.0211, 'lps'),
	(366468, 125, '2015-01-15 00:18:53.000000', 'consum', 0.0221, 'lps'),
	(366469, 125, '2015-01-15 00:18:54.000000', 'consum', 0.0210, 'lps'),
	(366470, 125, '2015-01-15 00:18:55.000000', 'consum', 0.0211, 'lps'),
	(366471, 125, '2015-01-15 00:18:56.000000', 'consum', 0.0216, 'lps'),
	(366472, 125, '2015-01-15 00:18:57.000000', 'consum', 0.0222, 'lps'),
	(366473, 125, '2015-01-15 00:18:58.000000', 'consum', 0.0219, 'lps'),
	(366474, 125, '2015-01-15 00:18:59.000000', 'consum', 0.0218, 'lps'),
	(366475, 125, '2015-01-15 00:19:00.000000', 'consum', 0.0222, 'lps'),
	(366476, 125, '2015-01-15 00:19:01.000000', 'consum', 0.0214, 'lps'),
	(366477, 125, '2015-01-15 00:19:02.000000', 'consum', 0.0210, 'lps'),
	(366478, 125, '2015-01-15 00:19:03.000000', 'consum', 0.0218, 'lps'),
	(366479, 125, '2015-01-15 00:19:04.000000', 'consum', 0.0214, 'lps'),
	(366480, 125, '2015-01-15 00:19:05.000000', 'consum', 0.0223, 'lps'),
	(366481, 125, '2015-01-15 00:19:06.000000', 'consum', 0.0214, 'lps'),
	(366482, 125, '2015-01-15 00:19:07.000000', 'consum', 0.0226, 'lps'),
	(366483, 125, '2015-01-15 00:19:08.000000', 'consum', 0.0225, 'lps'),
	(366484, 125, '2015-01-15 00:19:09.000000', 'consum', 0.0222, 'lps'),
	(366485, 125, '2015-01-15 00:19:10.000000', 'consum', 0.0210, 'lps'),
	(366486, 125, '2015-01-15 00:19:11.000000', 'consum', 0.0225, 'lps'),
	(366487, 125, '2015-01-15 00:19:12.000000', 'consum', 0.0218, 'lps'),
	(366488, 125, '2015-01-15 00:19:13.000000', 'consum', 0.0224, 'lps'),
	(366489, 125, '2015-01-15 00:19:14.000000', 'consum', 0.0220, 'lps'),
	(366490, 125, '2015-01-15 00:19:15.000000', 'consum', 0.0218, 'lps'),
	(366491, 125, '2015-01-15 00:19:16.000000', 'consum', 0.0220, 'lps'),
	(366492, 125, '2015-01-15 00:19:17.000000', 'consum', 0.0220, 'lps'),
	(366493, 125, '2015-01-15 00:19:18.000000', 'consum', 0.0212, 'lps'),
	(366494, 125, '2015-01-15 00:19:19.000000', 'consum', 0.0210, 'lps'),
	(366495, 125, '2015-01-15 00:19:20.000000', 'consum', 0.0220, 'lps'),
	(366496, 125, '2015-01-15 00:19:21.000000', 'consum', 0.0212, 'lps'),
	(366497, 125, '2015-01-15 00:19:22.000000', 'consum', 0.0222, 'lps'),
	(366498, 125, '2015-01-15 00:19:23.000000', 'consum', 0.0213, 'lps'),
	(366499, 125, '2015-01-15 00:19:24.000000', 'consum', 0.0226, 'lps'),
	(366500, 125, '2015-01-15 00:19:25.000000', 'consum', 0.0210, 'lps'),
	(366501, 125, '2015-01-15 00:19:26.000000', 'consum', 0.0217, 'lps'),
	(366502, 125, '2015-01-15 00:19:27.000000', 'consum', 0.0211, 'lps'),
	(366503, 125, '2015-01-15 00:19:28.000000', 'consum', 0.0213, 'lps'),
	(366504, 125, '2015-01-15 00:19:29.000000', 'consum', 0.0220, 'lps'),
	(366505, 125, '2015-01-15 00:19:30.000000', 'consum', 0.0220, 'lps'),
	(366506, 125, '2015-01-15 00:19:31.000000', 'consum', 0.0214, 'lps'),
	(366507, 125, '2015-01-15 00:19:32.000000', 'consum', 0.0215, 'lps'),
	(366508, 125, '2015-01-15 00:19:33.000000', 'consum', 0.0223, 'lps'),
	(366509, 125, '2015-01-15 00:19:34.000000', 'consum', 0.0212, 'lps'),
	(366510, 125, '2015-01-15 00:19:35.000000', 'consum', 0.0213, 'lps'),
	(366511, 125, '2015-01-15 00:19:36.000000', 'consum', 0.0221, 'lps'),
	(366512, 125, '2015-01-15 00:19:37.000000', 'consum', 0.0223, 'lps'),
	(366513, 125, '2015-01-15 00:19:38.000000', 'consum', 0.0226, 'lps'),
	(366514, 125, '2015-01-15 00:19:39.000000', 'consum', 0.0216, 'lps'),
	(366515, 125, '2015-01-15 00:19:40.000000', 'consum', 0.0226, 'lps'),
	(366516, 125, '2015-01-15 00:19:41.000000', 'consum', 0.0221, 'lps'),
	(366517, 125, '2015-01-15 00:19:42.000000', 'consum', 0.0220, 'lps'),
	(366518, 125, '2015-01-15 00:19:43.000000', 'consum', 0.0211, 'lps'),
	(366519, 125, '2015-01-15 00:19:44.000000', 'consum', 0.0218, 'lps'),
	(366520, 125, '2015-01-15 00:19:45.000000', 'consum', 0.0215, 'lps'),
	(366521, 125, '2015-01-15 00:19:46.000000', 'consum', 0.0210, 'lps'),
	(366522, 125, '2015-01-15 00:19:47.000000', 'consum', 0.0211, 'lps'),
	(366523, 125, '2015-01-15 00:19:48.000000', 'consum', 0.0216, 'lps'),
	(366524, 125, '2015-01-15 00:19:49.000000', 'consum', 0.0222, 'lps'),
	(366525, 125, '2015-01-15 00:19:50.000000', 'consum', 0.0220, 'lps'),
	(366526, 125, '2015-01-15 00:19:51.000000', 'consum', 0.0221, 'lps'),
	(366527, 125, '2015-01-15 00:19:52.000000', 'consum', 0.0221, 'lps'),
	(366528, 125, '2015-01-15 00:19:53.000000', 'consum', 0.0215, 'lps'),
	(366529, 125, '2015-01-15 00:19:54.000000', 'consum', 0.0221, 'lps'),
	(366530, 125, '2015-01-15 00:19:55.000000', 'consum', 0.0214, 'lps'),
	(366531, 125, '2015-01-15 00:19:56.000000', 'consum', 0.0214, 'lps'),
	(366532, 125, '2015-01-15 00:19:57.000000', 'consum', 0.0221, 'lps'),
	(366533, 125, '2015-01-15 00:19:58.000000', 'consum', 0.0219, 'lps'),
	(366534, 125, '2015-01-15 00:19:59.000000', 'consum', 0.0222, 'lps'),
	(366535, 125, '2015-01-15 00:20:00.000000', 'consum', 0.0211, 'lps'),
	(366536, 125, '2015-01-15 00:20:01.000000', 'consum', 0.0212, 'lps'),
	(366537, 125, '2015-01-15 00:20:02.000000', 'consum', 0.0217, 'lps'),
	(366538, 125, '2015-01-15 00:20:03.000000', 'consum', 0.0222, 'lps'),
	(366539, 125, '2015-01-15 00:20:04.000000', 'consum', 0.0216, 'lps'),
	(366540, 125, '2015-01-15 00:20:05.000000', 'consum', 0.0222, 'lps'),
	(366541, 125, '2015-01-15 00:20:06.000000', 'consum', 0.0217, 'lps'),
	(366542, 125, '2015-01-15 00:20:07.000000', 'consum', 0.0225, 'lps'),
	(366543, 125, '2015-01-15 00:20:08.000000', 'consum', 0.0217, 'lps'),
	(366544, 125, '2015-01-15 00:20:09.000000', 'consum', 0.0216, 'lps'),
	(366545, 125, '2015-01-15 00:20:10.000000', 'consum', 0.0218, 'lps'),
	(366546, 125, '2015-01-15 00:20:11.000000', 'consum', 0.0215, 'lps'),
	(366547, 125, '2015-01-15 00:20:12.000000', 'consum', 0.0212, 'lps'),
	(366548, 125, '2015-01-15 00:20:13.000000', 'consum', 0.0222, 'lps'),
	(366549, 125, '2015-01-15 00:20:14.000000', 'consum', 0.0215, 'lps'),
	(366550, 125, '2015-01-15 00:20:15.000000', 'consum', 0.0216, 'lps'),
	(366551, 125, '2015-01-15 00:20:16.000000', 'consum', 0.0210, 'lps'),
	(366552, 125, '2015-01-15 00:20:17.000000', 'consum', 0.0225, 'lps'),
	(366553, 125, '2015-01-15 00:20:18.000000', 'consum', 0.0216, 'lps'),
	(366554, 125, '2015-01-15 00:20:19.000000', 'consum', 0.0215, 'lps'),
	(366555, 125, '2015-01-15 00:20:20.000000', 'consum', 0.0216, 'lps'),
	(366556, 125, '2015-01-15 00:20:21.000000', 'consum', 0.0211, 'lps'),
	(366557, 125, '2015-01-15 00:20:22.000000', 'consum', 0.0211, 'lps'),
	(366558, 125, '2015-01-15 00:20:23.000000', 'consum', 0.0214, 'lps'),
	(366559, 125, '2015-01-15 00:20:24.000000', 'consum', 0.0212, 'lps'),
	(366560, 125, '2015-01-15 00:20:25.000000', 'consum', 0.0226, 'lps'),
	(366561, 125, '2015-01-15 00:20:26.000000', 'consum', 0.0215, 'lps'),
	(366562, 125, '2015-01-15 00:20:27.000000', 'consum', 0.0222, 'lps'),
	(366563, 125, '2015-01-15 00:20:28.000000', 'consum', 0.0221, 'lps'),
	(366564, 125, '2015-01-15 00:20:29.000000', 'consum', 0.0212, 'lps'),
	(366565, 125, '2015-01-15 00:20:30.000000', 'consum', 0.0223, 'lps'),
	(366566, 125, '2015-01-15 00:20:31.000000', 'consum', 0.0217, 'lps'),
	(366567, 125, '2015-01-15 00:20:32.000000', 'consum', 0.0224, 'lps'),
	(366568, 125, '2015-01-15 00:20:33.000000', 'consum', 0.0210, 'lps'),
	(366569, 125, '2015-01-15 00:20:34.000000', 'consum', 0.0220, 'lps'),
	(366570, 125, '2015-01-15 00:20:35.000000', 'consum', 0.0210, 'lps'),
	(366571, 125, '2015-01-15 00:20:36.000000', 'consum', 0.0212, 'lps'),
	(366572, 125, '2015-01-15 00:20:37.000000', 'consum', 0.0222, 'lps'),
	(366573, 125, '2015-01-15 00:20:38.000000', 'consum', 0.0211, 'lps'),
	(366574, 125, '2015-01-15 00:20:39.000000', 'consum', 0.0217, 'lps'),
	(366575, 125, '2015-01-15 00:20:40.000000', 'consum', 0.0223, 'lps'),
	(366576, 125, '2015-01-15 00:20:41.000000', 'consum', 0.0221, 'lps'),
	(366577, 125, '2015-01-15 00:20:42.000000', 'consum', 0.0211, 'lps'),
	(366578, 125, '2015-01-15 00:20:43.000000', 'consum', 0.0217, 'lps'),
	(366579, 125, '2015-01-15 00:20:44.000000', 'consum', 0.0210, 'lps'),
	(366580, 125, '2015-01-15 00:20:45.000000', 'consum', 0.0220, 'lps'),
	(366581, 125, '2015-01-15 00:20:46.000000', 'consum', 0.0211, 'lps'),
	(366582, 125, '2015-01-15 00:20:47.000000', 'consum', 0.0220, 'lps'),
	(366583, 125, '2015-01-15 00:20:48.000000', 'consum', 0.0221, 'lps'),
	(366584, 125, '2015-01-15 00:20:49.000000', 'consum', 0.0220, 'lps'),
	(366585, 125, '2015-01-15 00:20:50.000000', 'consum', 0.0226, 'lps'),
	(366586, 125, '2015-01-15 00:20:51.000000', 'consum', 0.0212, 'lps'),
	(366587, 125, '2015-01-15 00:20:52.000000', 'consum', 0.0224, 'lps'),
	(366588, 125, '2015-01-15 00:20:53.000000', 'consum', 0.0221, 'lps'),
	(366589, 125, '2015-01-15 00:20:54.000000', 'consum', 0.0226, 'lps'),
	(366590, 125, '2015-01-15 00:20:55.000000', 'consum', 0.0224, 'lps'),
	(366591, 125, '2015-01-15 00:20:56.000000', 'consum', 0.0215, 'lps'),
	(366592, 125, '2015-01-15 00:20:57.000000', 'consum', 0.0226, 'lps'),
	(366593, 125, '2015-01-15 00:20:58.000000', 'consum', 0.0226, 'lps'),
	(366594, 125, '2015-01-15 00:20:59.000000', 'consum', 0.0210, 'lps'),
	(366595, 125, '2015-01-15 00:21:00.000000', 'consum', 0.0211, 'lps'),
	(366596, 125, '2015-01-15 00:21:01.000000', 'consum', 0.0217, 'lps'),
	(366597, 125, '2015-01-15 00:21:02.000000', 'consum', 0.0224, 'lps'),
	(366598, 125, '2015-01-15 00:21:03.000000', 'consum', 0.0224, 'lps'),
	(366599, 125, '2015-01-15 00:21:04.000000', 'consum', 0.0224, 'lps'),
	(366600, 125, '2015-01-15 00:21:05.000000', 'consum', 0.0219, 'lps'),
	(366601, 125, '2015-01-15 00:21:06.000000', 'consum', 0.0216, 'lps'),
	(366602, 125, '2015-01-15 00:21:07.000000', 'consum', 0.0211, 'lps'),
	(366603, 125, '2015-01-15 00:21:08.000000', 'consum', 0.0215, 'lps'),
	(366604, 125, '2015-01-15 00:21:09.000000', 'consum', 0.0216, 'lps'),
	(366605, 125, '2015-01-15 00:21:10.000000', 'consum', 0.0210, 'lps'),
	(366606, 125, '2015-01-15 00:21:11.000000', 'consum', 0.0225, 'lps'),
	(366607, 125, '2015-01-15 00:21:12.000000', 'consum', 0.0218, 'lps'),
	(366608, 125, '2015-01-15 00:21:13.000000', 'consum', 0.0221, 'lps'),
	(366609, 125, '2015-01-15 00:21:14.000000', 'consum', 0.0226, 'lps'),
	(366610, 125, '2015-01-15 00:21:15.000000', 'consum', 0.0221, 'lps'),
	(366611, 125, '2015-01-15 00:21:16.000000', 'consum', 0.0221, 'lps'),
	(366612, 125, '2015-01-15 00:21:17.000000', 'consum', 0.0214, 'lps'),
	(366613, 125, '2015-01-15 00:21:18.000000', 'consum', 0.0213, 'lps'),
	(366614, 125, '2015-01-15 00:21:19.000000', 'consum', 0.0213, 'lps'),
	(366615, 125, '2015-01-15 00:21:20.000000', 'consum', 0.0217, 'lps'),
	(366616, 125, '2015-01-15 00:21:21.000000', 'consum', 0.0222, 'lps'),
	(366617, 125, '2015-01-15 00:21:22.000000', 'consum', 0.0212, 'lps'),
	(366618, 125, '2015-01-15 00:21:23.000000', 'consum', 0.0220, 'lps'),
	(366619, 125, '2015-01-15 00:21:24.000000', 'consum', 0.0221, 'lps'),
	(366620, 125, '2015-01-15 00:21:25.000000', 'consum', 0.0220, 'lps'),
	(366621, 125, '2015-01-15 00:21:26.000000', 'consum', 0.0225, 'lps'),
	(366622, 125, '2015-01-15 00:21:27.000000', 'consum', 0.0224, 'lps'),
	(366623, 125, '2015-01-15 00:21:28.000000', 'consum', 0.0216, 'lps'),
	(366624, 125, '2015-01-15 00:21:29.000000', 'consum', 0.0216, 'lps'),
	(366625, 125, '2015-01-15 00:21:30.000000', 'consum', 0.0223, 'lps'),
	(366626, 125, '2015-01-15 00:21:31.000000', 'consum', 0.0225, 'lps'),
	(366627, 125, '2015-01-15 00:21:32.000000', 'consum', 0.0212, 'lps'),
	(366628, 125, '2015-01-15 00:21:33.000000', 'consum', 0.0210, 'lps'),
	(366629, 125, '2015-01-15 00:21:34.000000', 'consum', 0.0219, 'lps'),
	(366630, 125, '2015-01-15 00:21:35.000000', 'consum', 0.0223, 'lps'),
	(366631, 125, '2015-01-15 00:21:36.000000', 'consum', 0.0215, 'lps'),
	(366632, 125, '2015-01-15 00:21:37.000000', 'consum', 0.0213, 'lps'),
	(366633, 125, '2015-01-15 00:21:38.000000', 'consum', 0.0226, 'lps'),
	(366634, 125, '2015-01-15 00:21:39.000000', 'consum', 0.0215, 'lps'),
	(366635, 125, '2015-01-15 00:21:40.000000', 'consum', 0.0222, 'lps'),
	(366636, 125, '2015-01-15 00:21:41.000000', 'consum', 0.0221, 'lps'),
	(366637, 125, '2015-01-15 00:21:42.000000', 'consum', 0.0213, 'lps'),
	(366638, 125, '2015-01-15 00:21:43.000000', 'consum', 0.0211, 'lps'),
	(366639, 125, '2015-01-15 00:21:44.000000', 'consum', 0.0223, 'lps'),
	(366640, 125, '2015-01-15 00:21:45.000000', 'consum', 0.0222, 'lps'),
	(366641, 125, '2015-01-15 00:21:46.000000', 'consum', 0.0215, 'lps'),
	(366642, 125, '2015-01-15 00:21:47.000000', 'consum', 0.0214, 'lps'),
	(366643, 125, '2015-01-15 00:21:48.000000', 'consum', 0.0218, 'lps'),
	(366644, 125, '2015-01-15 00:21:49.000000', 'consum', 0.0221, 'lps'),
	(366645, 125, '2015-01-15 00:21:50.000000', 'consum', 0.0223, 'lps'),
	(366646, 125, '2015-01-15 00:21:51.000000', 'consum', 0.0225, 'lps'),
	(366647, 125, '2015-01-15 00:21:52.000000', 'consum', 0.0215, 'lps'),
	(366648, 125, '2015-01-15 00:21:53.000000', 'consum', 0.0225, 'lps'),
	(366649, 125, '2015-01-15 00:21:54.000000', 'consum', 0.0218, 'lps'),
	(366650, 125, '2015-01-15 00:21:55.000000', 'consum', 0.0222, 'lps'),
	(366651, 125, '2015-01-15 00:21:56.000000', 'consum', 0.0214, 'lps'),
	(366652, 125, '2015-01-15 00:21:57.000000', 'consum', 0.0211, 'lps'),
	(366653, 125, '2015-01-15 00:21:58.000000', 'consum', 0.0220, 'lps'),
	(366654, 125, '2015-01-15 00:21:59.000000', 'consum', 0.0224, 'lps'),
	(366655, 125, '2015-01-15 00:22:00.000000', 'consum', 0.0216, 'lps'),
	(366656, 125, '2015-01-15 00:22:01.000000', 'consum', 0.0217, 'lps'),
	(366657, 125, '2015-01-15 00:22:02.000000', 'consum', 0.0211, 'lps'),
	(366658, 125, '2015-01-15 00:22:03.000000', 'consum', 0.0212, 'lps'),
	(366659, 125, '2015-01-15 00:22:04.000000', 'consum', 0.0219, 'lps'),
	(366660, 125, '2015-01-15 00:22:05.000000', 'consum', 0.0212, 'lps'),
	(366661, 125, '2015-01-15 00:22:06.000000', 'consum', 0.0212, 'lps'),
	(366662, 125, '2015-01-15 00:22:07.000000', 'consum', 0.0213, 'lps'),
	(366663, 125, '2015-01-15 00:22:08.000000', 'consum', 0.0222, 'lps'),
	(366664, 125, '2015-01-15 00:22:09.000000', 'consum', 0.0226, 'lps'),
	(366665, 125, '2015-01-15 00:22:10.000000', 'consum', 0.0222, 'lps'),
	(366666, 125, '2015-01-15 00:22:11.000000', 'consum', 0.0220, 'lps'),
	(366667, 125, '2015-01-15 00:22:12.000000', 'consum', 0.0226, 'lps'),
	(366668, 125, '2015-01-15 00:22:13.000000', 'consum', 0.0211, 'lps'),
	(366669, 125, '2015-01-15 00:22:14.000000', 'consum', 0.0218, 'lps'),
	(366670, 125, '2015-01-15 00:22:15.000000', 'consum', 0.0214, 'lps'),
	(366671, 125, '2015-01-15 00:22:16.000000', 'consum', 0.0225, 'lps'),
	(366672, 125, '2015-01-15 00:22:17.000000', 'consum', 0.0220, 'lps'),
	(366673, 125, '2015-01-15 00:22:18.000000', 'consum', 0.0217, 'lps'),
	(366674, 125, '2015-01-15 00:22:19.000000', 'consum', 0.0214, 'lps'),
	(366675, 125, '2015-01-15 00:22:20.000000', 'consum', 0.0210, 'lps'),
	(366676, 125, '2015-01-15 00:22:21.000000', 'consum', 0.0216, 'lps'),
	(366677, 125, '2015-01-15 00:22:22.000000', 'consum', 0.0223, 'lps'),
	(366678, 125, '2015-01-15 00:22:23.000000', 'consum', 0.0225, 'lps'),
	(366679, 125, '2015-01-15 00:22:24.000000', 'consum', 0.0211, 'lps'),
	(366680, 125, '2015-01-15 00:22:25.000000', 'consum', 0.0221, 'lps'),
	(366681, 125, '2015-01-15 00:22:26.000000', 'consum', 0.0213, 'lps'),
	(366682, 125, '2015-01-15 00:22:27.000000', 'consum', 0.0226, 'lps'),
	(366683, 125, '2015-01-15 00:22:28.000000', 'consum', 0.0215, 'lps'),
	(366684, 125, '2015-01-15 00:22:29.000000', 'consum', 0.0221, 'lps'),
	(366685, 125, '2015-01-15 00:22:30.000000', 'consum', 0.0215, 'lps'),
	(366686, 125, '2015-01-15 00:22:31.000000', 'consum', 0.0222, 'lps'),
	(366687, 125, '2015-01-15 00:22:32.000000', 'consum', 0.0221, 'lps'),
	(366688, 125, '2015-01-15 00:22:33.000000', 'consum', 0.0212, 'lps'),
	(366689, 125, '2015-01-15 00:22:34.000000', 'consum', 0.0221, 'lps'),
	(366690, 125, '2015-01-15 00:22:35.000000', 'consum', 0.0211, 'lps'),
	(366691, 125, '2015-01-15 00:22:36.000000', 'consum', 0.0214, 'lps'),
	(366692, 125, '2015-01-15 00:22:37.000000', 'consum', 0.0212, 'lps'),
	(366693, 125, '2015-01-15 00:22:38.000000', 'consum', 0.0210, 'lps'),
	(366694, 125, '2015-01-15 00:22:39.000000', 'consum', 0.0220, 'lps'),
	(366695, 125, '2015-01-15 00:22:40.000000', 'consum', 0.0211, 'lps'),
	(366696, 125, '2015-01-15 00:22:41.000000', 'consum', 0.0220, 'lps'),
	(366697, 125, '2015-01-15 00:22:42.000000', 'consum', 0.0224, 'lps'),
	(366698, 125, '2015-01-15 00:22:43.000000', 'consum', 0.0217, 'lps'),
	(366699, 125, '2015-01-15 00:22:44.000000', 'consum', 0.0218, 'lps'),
	(366700, 125, '2015-01-15 00:22:45.000000', 'consum', 0.0213, 'lps'),
	(366701, 125, '2015-01-15 00:22:46.000000', 'consum', 0.0220, 'lps'),
	(366702, 125, '2015-01-15 00:22:47.000000', 'consum', 0.0216, 'lps'),
	(366703, 125, '2015-01-15 00:22:48.000000', 'consum', 0.0213, 'lps'),
	(366704, 125, '2015-01-15 00:22:49.000000', 'consum', 0.0221, 'lps'),
	(366705, 125, '2015-01-15 00:22:50.000000', 'consum', 0.0225, 'lps'),
	(366706, 125, '2015-01-15 00:22:51.000000', 'consum', 0.0217, 'lps'),
	(366707, 125, '2015-01-15 00:22:52.000000', 'consum', 0.0217, 'lps'),
	(366708, 125, '2015-01-15 00:22:53.000000', 'consum', 0.0226, 'lps'),
	(366709, 125, '2015-01-15 00:22:54.000000', 'consum', 0.0220, 'lps'),
	(366710, 125, '2015-01-15 00:22:55.000000', 'consum', 0.0210, 'lps'),
	(366711, 125, '2015-01-15 00:22:56.000000', 'consum', 0.0213, 'lps'),
	(366712, 125, '2015-01-15 00:22:57.000000', 'consum', 0.0211, 'lps'),
	(366713, 125, '2015-01-15 00:22:58.000000', 'consum', 0.0222, 'lps'),
	(366714, 125, '2015-01-15 00:22:59.000000', 'consum', 0.0217, 'lps'),
	(366715, 125, '2015-01-15 00:23:00.000000', 'consum', 0.0210, 'lps'),
	(366716, 125, '2015-01-15 00:23:01.000000', 'consum', 0.0221, 'lps'),
	(366717, 125, '2015-01-15 00:23:02.000000', 'consum', 0.0218, 'lps'),
	(366718, 125, '2015-01-15 00:23:03.000000', 'consum', 0.0215, 'lps'),
	(366719, 125, '2015-01-15 00:23:04.000000', 'consum', 0.0213, 'lps'),
	(366720, 125, '2015-01-15 00:23:05.000000', 'consum', 0.0225, 'lps'),
	(366721, 125, '2015-01-15 00:23:06.000000', 'consum', 0.0226, 'lps'),
	(366722, 125, '2015-01-15 00:23:07.000000', 'consum', 0.0213, 'lps'),
	(366723, 125, '2015-01-15 00:23:08.000000', 'consum', 0.0212, 'lps'),
	(366724, 125, '2015-01-15 00:23:09.000000', 'consum', 0.0212, 'lps'),
	(366725, 125, '2015-01-15 00:23:10.000000', 'consum', 0.0213, 'lps'),
	(366726, 125, '2015-01-15 00:23:11.000000', 'consum', 0.0219, 'lps'),
	(366727, 125, '2015-01-15 00:23:12.000000', 'consum', 0.0211, 'lps'),
	(366728, 125, '2015-01-15 00:23:13.000000', 'consum', 0.0224, 'lps'),
	(366729, 125, '2015-01-15 00:23:14.000000', 'consum', 0.0211, 'lps'),
	(366730, 125, '2015-01-15 00:23:15.000000', 'consum', 0.0225, 'lps'),
	(366731, 125, '2015-01-15 00:23:16.000000', 'consum', 0.0212, 'lps'),
	(366732, 125, '2015-01-15 00:23:17.000000', 'consum', 0.0212, 'lps'),
	(366733, 125, '2015-01-15 00:23:18.000000', 'consum', 0.0215, 'lps'),
	(366734, 125, '2015-01-15 00:23:19.000000', 'consum', 0.0211, 'lps'),
	(366735, 125, '2015-01-15 00:23:20.000000', 'consum', 0.0218, 'lps'),
	(366736, 125, '2015-01-15 00:23:21.000000', 'consum', 0.0213, 'lps'),
	(366737, 125, '2015-01-15 00:23:22.000000', 'consum', 0.0218, 'lps'),
	(366738, 125, '2015-01-15 00:23:23.000000', 'consum', 0.0224, 'lps'),
	(366739, 125, '2015-01-15 00:23:24.000000', 'consum', 0.0225, 'lps'),
	(366740, 125, '2015-01-15 00:23:25.000000', 'consum', 0.0224, 'lps'),
	(366741, 125, '2015-01-15 00:23:26.000000', 'consum', 0.0220, 'lps'),
	(366742, 125, '2015-01-15 00:23:27.000000', 'consum', 0.0219, 'lps'),
	(366743, 125, '2015-01-15 00:23:28.000000', 'consum', 0.0223, 'lps'),
	(366744, 125, '2015-01-15 00:23:29.000000', 'consum', 0.0217, 'lps'),
	(366745, 125, '2015-01-15 00:23:30.000000', 'consum', 0.0221, 'lps'),
	(366746, 125, '2015-01-15 00:23:31.000000', 'consum', 0.0213, 'lps'),
	(366747, 125, '2015-01-15 00:23:32.000000', 'consum', 0.0226, 'lps'),
	(366748, 125, '2015-01-15 00:23:33.000000', 'consum', 0.0212, 'lps'),
	(366749, 125, '2015-01-15 00:23:34.000000', 'consum', 0.0223, 'lps'),
	(366750, 125, '2015-01-15 00:23:35.000000', 'consum', 0.0220, 'lps'),
	(366751, 125, '2015-01-15 00:23:36.000000', 'consum', 0.0221, 'lps'),
	(366752, 125, '2015-01-15 00:23:37.000000', 'consum', 0.0217, 'lps'),
	(366753, 125, '2015-01-15 00:23:38.000000', 'consum', 0.0213, 'lps'),
	(366754, 125, '2015-01-15 00:23:39.000000', 'consum', 0.0220, 'lps'),
	(366755, 125, '2015-01-15 00:23:40.000000', 'consum', 0.0220, 'lps'),
	(366756, 125, '2015-01-15 00:23:41.000000', 'consum', 0.0215, 'lps'),
	(366757, 125, '2015-01-15 00:23:42.000000', 'consum', 0.0220, 'lps'),
	(366758, 125, '2015-01-15 00:23:43.000000', 'consum', 0.0212, 'lps'),
	(366759, 125, '2015-01-15 00:23:44.000000', 'consum', 0.0223, 'lps'),
	(366760, 125, '2015-01-15 00:23:45.000000', 'consum', 0.0219, 'lps'),
	(366761, 125, '2015-01-15 00:23:46.000000', 'consum', 0.0217, 'lps'),
	(366762, 125, '2015-01-15 00:23:47.000000', 'consum', 0.0220, 'lps'),
	(366763, 125, '2015-01-15 00:23:48.000000', 'consum', 0.0223, 'lps'),
	(366764, 125, '2015-01-15 00:23:49.000000', 'consum', 0.0226, 'lps'),
	(366765, 125, '2015-01-15 00:23:50.000000', 'consum', 0.0220, 'lps'),
	(366766, 125, '2015-01-15 00:23:51.000000', 'consum', 0.0210, 'lps'),
	(366767, 125, '2015-01-15 00:23:52.000000', 'consum', 0.0215, 'lps'),
	(366768, 125, '2015-01-15 00:23:53.000000', 'consum', 0.0219, 'lps'),
	(366769, 125, '2015-01-15 00:23:54.000000', 'consum', 0.0225, 'lps'),
	(366770, 125, '2015-01-15 00:23:55.000000', 'consum', 0.0221, 'lps'),
	(366771, 125, '2015-01-15 00:23:56.000000', 'consum', 0.0224, 'lps'),
	(366772, 125, '2015-01-15 00:23:57.000000', 'consum', 0.0211, 'lps'),
	(366773, 125, '2015-01-15 00:23:58.000000', 'consum', 0.0224, 'lps'),
	(366774, 125, '2015-01-15 00:23:59.000000', 'consum', 0.0211, 'lps'),
	(366775, 125, '2015-01-15 00:24:00.000000', 'consum', 0.0223, 'lps'),
	(366776, 125, '2015-01-15 00:24:01.000000', 'consum', 0.0222, 'lps'),
	(366777, 125, '2015-01-15 00:24:02.000000', 'consum', 0.0214, 'lps'),
	(366778, 125, '2015-01-15 00:24:03.000000', 'consum', 0.0212, 'lps'),
	(366779, 125, '2015-01-15 00:24:04.000000', 'consum', 0.0210, 'lps'),
	(366780, 125, '2015-01-15 00:24:05.000000', 'consum', 0.0220, 'lps'),
	(366781, 125, '2015-01-15 00:24:06.000000', 'consum', 0.0226, 'lps'),
	(366782, 125, '2015-01-15 00:24:07.000000', 'consum', 0.0210, 'lps'),
	(366783, 125, '2015-01-15 00:24:08.000000', 'consum', 0.0215, 'lps'),
	(366784, 125, '2015-01-15 00:24:09.000000', 'consum', 0.0218, 'lps'),
	(366785, 125, '2015-01-15 00:24:10.000000', 'consum', 0.0219, 'lps'),
	(366786, 125, '2015-01-15 00:24:11.000000', 'consum', 0.0212, 'lps'),
	(366787, 125, '2015-01-15 00:24:12.000000', 'consum', 0.0213, 'lps'),
	(366788, 125, '2015-01-15 00:24:13.000000', 'consum', 0.0219, 'lps'),
	(366789, 125, '2015-01-15 00:24:14.000000', 'consum', 0.0213, 'lps'),
	(366790, 125, '2015-01-15 00:24:15.000000', 'consum', 0.0216, 'lps'),
	(366791, 125, '2015-01-15 00:24:16.000000', 'consum', 0.0212, 'lps'),
	(366792, 125, '2015-01-15 00:24:17.000000', 'consum', 0.0221, 'lps'),
	(366793, 125, '2015-01-15 00:24:18.000000', 'consum', 0.0224, 'lps'),
	(366794, 125, '2015-01-15 00:24:19.000000', 'consum', 0.0215, 'lps'),
	(366795, 125, '2015-01-15 00:24:20.000000', 'consum', 0.0210, 'lps'),
	(366796, 125, '2015-01-15 00:24:21.000000', 'consum', 0.0212, 'lps'),
	(366797, 125, '2015-01-15 00:24:22.000000', 'consum', 0.0219, 'lps'),
	(366798, 125, '2015-01-15 00:24:23.000000', 'consum', 0.0217, 'lps'),
	(366799, 125, '2015-01-15 00:24:24.000000', 'consum', 0.0219, 'lps'),
	(366800, 125, '2015-01-15 00:24:25.000000', 'consum', 0.0216, 'lps'),
	(366801, 125, '2015-01-15 00:24:26.000000', 'consum', 0.0213, 'lps'),
	(366802, 125, '2015-01-15 00:24:27.000000', 'consum', 0.0210, 'lps'),
	(366803, 125, '2015-01-15 00:24:28.000000', 'consum', 0.0217, 'lps'),
	(366804, 125, '2015-01-15 00:24:29.000000', 'consum', 0.0212, 'lps'),
	(366805, 125, '2015-01-15 00:24:30.000000', 'consum', 0.0216, 'lps'),
	(366806, 125, '2015-01-15 00:24:31.000000', 'consum', 0.0216, 'lps'),
	(366807, 125, '2015-01-15 00:24:32.000000', 'consum', 0.0222, 'lps'),
	(366808, 125, '2015-01-15 00:24:33.000000', 'consum', 0.0220, 'lps'),
	(366809, 125, '2015-01-15 00:24:34.000000', 'consum', 0.0223, 'lps'),
	(366810, 125, '2015-01-15 00:24:35.000000', 'consum', 0.0213, 'lps'),
	(366811, 125, '2015-01-15 00:24:36.000000', 'consum', 0.0221, 'lps'),
	(366812, 125, '2015-01-15 00:24:37.000000', 'consum', 0.0223, 'lps'),
	(366813, 125, '2015-01-15 00:24:38.000000', 'consum', 0.0223, 'lps'),
	(366814, 125, '2015-01-15 00:24:39.000000', 'consum', 0.0219, 'lps'),
	(366815, 125, '2015-01-15 00:24:40.000000', 'consum', 0.0219, 'lps'),
	(366816, 125, '2015-01-15 00:24:41.000000', 'consum', 0.0212, 'lps'),
	(366817, 125, '2015-01-15 00:24:42.000000', 'consum', 0.0210, 'lps'),
	(366818, 125, '2015-01-15 00:24:43.000000', 'consum', 0.0222, 'lps'),
	(366819, 125, '2015-01-15 00:24:44.000000', 'consum', 0.0220, 'lps'),
	(366820, 125, '2015-01-15 00:24:45.000000', 'consum', 0.0223, 'lps'),
	(366821, 125, '2015-01-15 00:24:46.000000', 'consum', 0.0212, 'lps'),
	(366822, 125, '2015-01-15 00:24:47.000000', 'consum', 0.0214, 'lps'),
	(366823, 125, '2015-01-15 00:24:48.000000', 'consum', 0.0210, 'lps'),
	(366824, 125, '2015-01-15 00:24:49.000000', 'consum', 0.0216, 'lps'),
	(366825, 125, '2015-01-15 00:24:50.000000', 'consum', 0.0223, 'lps'),
	(366826, 125, '2015-01-15 00:24:51.000000', 'consum', 0.0222, 'lps'),
	(366827, 125, '2015-01-15 00:24:52.000000', 'consum', 0.0213, 'lps'),
	(366828, 125, '2015-01-15 00:24:53.000000', 'consum', 0.0226, 'lps'),
	(366829, 125, '2015-01-15 00:24:54.000000', 'consum', 0.0213, 'lps'),
	(366830, 125, '2015-01-15 00:24:55.000000', 'consum', 0.0211, 'lps'),
	(366831, 125, '2015-01-15 00:24:56.000000', 'consum', 0.0223, 'lps'),
	(366832, 125, '2015-01-15 00:24:57.000000', 'consum', 0.0221, 'lps'),
	(366833, 125, '2015-01-15 00:24:58.000000', 'consum', 0.0226, 'lps'),
	(366834, 125, '2015-01-15 00:24:59.000000', 'consum', 0.0226, 'lps'),
	(366835, 125, '2015-01-15 00:25:00.000000', 'consum', 0.0226, 'lps'),
	(366836, 125, '2015-01-15 00:25:01.000000', 'consum', 0.0225, 'lps'),
	(366837, 125, '2015-01-15 00:25:02.000000', 'consum', 0.0220, 'lps'),
	(366838, 125, '2015-01-15 00:25:03.000000', 'consum', 0.0216, 'lps'),
	(366839, 125, '2015-01-15 00:25:04.000000', 'consum', 0.0210, 'lps'),
	(366840, 125, '2015-01-15 00:25:05.000000', 'consum', 0.0210, 'lps'),
	(366841, 125, '2015-01-15 00:25:06.000000', 'consum', 0.0211, 'lps'),
	(366842, 125, '2015-01-15 00:25:07.000000', 'consum', 0.0216, 'lps'),
	(366843, 125, '2015-01-15 00:25:08.000000', 'consum', 0.0219, 'lps'),
	(366844, 125, '2015-01-15 00:25:09.000000', 'consum', 0.0221, 'lps'),
	(366845, 125, '2015-01-15 00:25:10.000000', 'consum', 0.0223, 'lps'),
	(366846, 125, '2015-01-15 00:25:11.000000', 'consum', 0.0210, 'lps'),
	(366847, 125, '2015-01-15 00:25:12.000000', 'consum', 0.0219, 'lps'),
	(366848, 125, '2015-01-15 00:25:13.000000', 'consum', 0.0222, 'lps'),
	(366849, 125, '2015-01-15 00:25:14.000000', 'consum', 0.0225, 'lps'),
	(366850, 125, '2015-01-15 00:25:15.000000', 'consum', 0.0217, 'lps'),
	(366851, 125, '2015-01-15 00:25:16.000000', 'consum', 0.0217, 'lps'),
	(366852, 125, '2015-01-15 00:25:17.000000', 'consum', 0.0210, 'lps'),
	(366853, 125, '2015-01-15 00:25:18.000000', 'consum', 0.0221, 'lps'),
	(366854, 125, '2015-01-15 00:25:19.000000', 'consum', 0.0214, 'lps'),
	(366855, 125, '2015-01-15 00:25:20.000000', 'consum', 0.0214, 'lps'),
	(366856, 125, '2015-01-15 00:25:21.000000', 'consum', 0.0218, 'lps'),
	(366857, 125, '2015-01-15 00:25:22.000000', 'consum', 0.0224, 'lps'),
	(366858, 125, '2015-01-15 00:25:23.000000', 'consum', 0.0220, 'lps'),
	(366859, 125, '2015-01-15 00:25:24.000000', 'consum', 0.0218, 'lps'),
	(366860, 125, '2015-01-15 00:25:25.000000', 'consum', 0.0223, 'lps'),
	(366861, 125, '2015-01-15 00:25:26.000000', 'consum', 0.0218, 'lps'),
	(366862, 125, '2015-01-15 00:25:27.000000', 'consum', 0.0226, 'lps'),
	(366863, 125, '2015-01-15 00:25:28.000000', 'consum', 0.0218, 'lps'),
	(366864, 125, '2015-01-15 00:25:29.000000', 'consum', 0.0217, 'lps'),
	(366865, 125, '2015-01-15 00:25:30.000000', 'consum', 0.0220, 'lps'),
	(366866, 125, '2015-01-15 00:25:31.000000', 'consum', 0.0226, 'lps'),
	(366867, 125, '2015-01-15 00:25:32.000000', 'consum', 0.0225, 'lps'),
	(366868, 125, '2015-01-15 00:25:33.000000', 'consum', 0.0222, 'lps'),
	(366869, 125, '2015-01-15 00:25:34.000000', 'consum', 0.0225, 'lps'),
	(366870, 125, '2015-01-15 00:25:35.000000', 'consum', 0.0214, 'lps'),
	(366871, 125, '2015-01-15 00:25:36.000000', 'consum', 0.0221, 'lps'),
	(366872, 125, '2015-01-15 00:25:37.000000', 'consum', 0.0217, 'lps'),
	(366873, 125, '2015-01-15 00:25:38.000000', 'consum', 0.0216, 'lps'),
	(366874, 125, '2015-01-15 00:25:39.000000', 'consum', 0.0217, 'lps'),
	(366875, 125, '2015-01-15 00:25:40.000000', 'consum', 0.0211, 'lps'),
	(366876, 125, '2015-01-15 00:25:41.000000', 'consum', 0.0213, 'lps'),
	(366877, 125, '2015-01-15 00:25:42.000000', 'consum', 0.0223, 'lps'),
	(366878, 125, '2015-01-15 00:25:43.000000', 'consum', 0.0215, 'lps'),
	(366879, 125, '2015-01-15 00:25:44.000000', 'consum', 0.0212, 'lps'),
	(366880, 125, '2015-01-15 00:25:45.000000', 'consum', 0.0223, 'lps'),
	(366881, 125, '2015-01-15 00:25:46.000000', 'consum', 0.0221, 'lps'),
	(366882, 125, '2015-01-15 00:25:47.000000', 'consum', 0.0224, 'lps'),
	(366883, 125, '2015-01-15 00:25:48.000000', 'consum', 0.0214, 'lps'),
	(366884, 125, '2015-01-15 00:25:49.000000', 'consum', 0.0223, 'lps'),
	(366885, 125, '2015-01-15 00:25:50.000000', 'consum', 0.0213, 'lps'),
	(366886, 125, '2015-01-15 00:25:51.000000', 'consum', 0.0220, 'lps'),
	(366887, 125, '2015-01-15 00:25:52.000000', 'consum', 0.0217, 'lps'),
	(366888, 125, '2015-01-15 00:25:53.000000', 'consum', 0.0214, 'lps'),
	(366889, 125, '2015-01-15 00:25:54.000000', 'consum', 0.0212, 'lps'),
	(366890, 125, '2015-01-15 00:25:55.000000', 'consum', 0.0226, 'lps'),
	(366891, 125, '2015-01-15 00:25:56.000000', 'consum', 0.0215, 'lps'),
	(366892, 125, '2015-01-15 00:25:57.000000', 'consum', 0.0221, 'lps'),
	(366893, 125, '2015-01-15 00:25:58.000000', 'consum', 0.0216, 'lps'),
	(366894, 125, '2015-01-15 00:25:59.000000', 'consum', 0.0226, 'lps'),
	(366895, 125, '2015-01-15 00:26:00.000000', 'consum', 0.0221, 'lps'),
	(366896, 125, '2015-01-15 00:26:01.000000', 'consum', 0.0218, 'lps'),
	(366897, 125, '2015-01-15 00:26:02.000000', 'consum', 0.0216, 'lps'),
	(366898, 125, '2015-01-15 00:26:03.000000', 'consum', 0.0219, 'lps'),
	(366899, 125, '2015-01-15 00:26:04.000000', 'consum', 0.0218, 'lps'),
	(366900, 125, '2015-01-15 00:26:05.000000', 'consum', 0.0225, 'lps'),
	(366901, 125, '2015-01-15 00:26:06.000000', 'consum', 0.0212, 'lps'),
	(366902, 125, '2015-01-15 00:26:07.000000', 'consum', 0.0223, 'lps'),
	(366903, 125, '2015-01-15 00:26:08.000000', 'consum', 0.0221, 'lps'),
	(366904, 125, '2015-01-15 00:26:09.000000', 'consum', 0.0225, 'lps'),
	(366905, 125, '2015-01-15 00:26:10.000000', 'consum', 0.0217, 'lps'),
	(366906, 125, '2015-01-15 00:26:11.000000', 'consum', 0.0219, 'lps'),
	(366907, 125, '2015-01-15 00:26:12.000000', 'consum', 0.0216, 'lps'),
	(366908, 125, '2015-01-15 00:26:13.000000', 'consum', 0.0216, 'lps'),
	(366909, 125, '2015-01-15 00:26:14.000000', 'consum', 0.0223, 'lps'),
	(366910, 125, '2015-01-15 00:26:15.000000', 'consum', 0.0223, 'lps'),
	(366911, 125, '2015-01-15 00:26:16.000000', 'consum', 0.0219, 'lps'),
	(366912, 125, '2015-01-15 00:26:17.000000', 'consum', 0.0216, 'lps'),
	(366913, 125, '2015-01-15 00:26:18.000000', 'consum', 0.0212, 'lps'),
	(366914, 125, '2015-01-15 00:26:19.000000', 'consum', 0.0221, 'lps'),
	(366915, 125, '2015-01-15 00:26:20.000000', 'consum', 0.0210, 'lps'),
	(366916, 125, '2015-01-15 00:26:21.000000', 'consum', 0.0211, 'lps'),
	(366917, 125, '2015-01-15 00:26:22.000000', 'consum', 0.0214, 'lps'),
	(366918, 125, '2015-01-15 00:26:23.000000', 'consum', 0.0212, 'lps'),
	(366919, 125, '2015-01-15 00:26:24.000000', 'consum', 0.0225, 'lps'),
	(366920, 125, '2015-01-15 00:26:25.000000', 'consum', 0.0211, 'lps'),
	(366921, 125, '2015-01-15 00:26:26.000000', 'consum', 0.0222, 'lps'),
	(366922, 125, '2015-01-15 00:26:27.000000', 'consum', 0.0215, 'lps'),
	(366923, 125, '2015-01-15 00:26:28.000000', 'consum', 0.0217, 'lps'),
	(366924, 125, '2015-01-15 00:26:29.000000', 'consum', 0.0212, 'lps'),
	(366925, 125, '2015-01-15 00:26:30.000000', 'consum', 0.0218, 'lps'),
	(366926, 125, '2015-01-15 00:26:31.000000', 'consum', 0.0226, 'lps'),
	(366927, 125, '2015-01-15 00:26:32.000000', 'consum', 0.0216, 'lps'),
	(366928, 125, '2015-01-15 00:26:33.000000', 'consum', 0.0211, 'lps'),
	(366929, 125, '2015-01-15 00:26:34.000000', 'consum', 0.0215, 'lps'),
	(366930, 125, '2015-01-15 00:26:35.000000', 'consum', 0.0213, 'lps'),
	(366931, 125, '2015-01-15 00:26:36.000000', 'consum', 0.0211, 'lps'),
	(366932, 125, '2015-01-15 00:26:37.000000', 'consum', 0.0225, 'lps'),
	(366933, 125, '2015-01-15 00:26:38.000000', 'consum', 0.0213, 'lps'),
	(366934, 125, '2015-01-15 00:26:39.000000', 'consum', 0.0215, 'lps'),
	(366935, 125, '2015-01-15 00:26:40.000000', 'consum', 0.0211, 'lps'),
	(366936, 125, '2015-01-15 00:26:41.000000', 'consum', 0.0216, 'lps'),
	(366937, 125, '2015-01-15 00:26:42.000000', 'consum', 0.0219, 'lps'),
	(366938, 125, '2015-01-15 00:26:43.000000', 'consum', 0.0222, 'lps'),
	(366939, 125, '2015-01-15 00:26:44.000000', 'consum', 0.0225, 'lps'),
	(366940, 125, '2015-01-15 00:26:45.000000', 'consum', 0.0218, 'lps'),
	(366941, 125, '2015-01-15 00:26:46.000000', 'consum', 0.0222, 'lps'),
	(366942, 125, '2015-01-15 00:26:47.000000', 'consum', 0.0214, 'lps'),
	(366943, 125, '2015-01-15 00:26:48.000000', 'consum', 0.0211, 'lps'),
	(366944, 125, '2015-01-15 00:26:49.000000', 'consum', 0.0219, 'lps'),
	(366945, 125, '2015-01-15 00:26:50.000000', 'consum', 0.0220, 'lps'),
	(366946, 125, '2015-01-15 00:26:51.000000', 'consum', 0.0217, 'lps'),
	(366947, 125, '2015-01-15 00:26:52.000000', 'consum', 0.0213, 'lps'),
	(366948, 125, '2015-01-15 00:26:53.000000', 'consum', 0.0222, 'lps'),
	(366949, 125, '2015-01-15 00:26:54.000000', 'consum', 0.0210, 'lps'),
	(366950, 125, '2015-01-15 00:26:55.000000', 'consum', 0.0210, 'lps'),
	(366951, 125, '2015-01-15 00:26:56.000000', 'consum', 0.0210, 'lps'),
	(366952, 125, '2015-01-15 00:26:57.000000', 'consum', 0.0211, 'lps'),
	(366953, 125, '2015-01-15 00:26:58.000000', 'consum', 0.0215, 'lps'),
	(366954, 125, '2015-01-15 00:26:59.000000', 'consum', 0.0216, 'lps'),
	(366955, 125, '2015-01-15 00:27:00.000000', 'consum', 0.0210, 'lps'),
	(366956, 125, '2015-01-15 00:27:01.000000', 'consum', 0.0226, 'lps'),
	(366957, 125, '2015-01-15 00:27:02.000000', 'consum', 0.0223, 'lps'),
	(366958, 125, '2015-01-15 00:27:03.000000', 'consum', 0.0210, 'lps'),
	(366959, 125, '2015-01-15 00:27:04.000000', 'consum', 0.0222, 'lps'),
	(366960, 125, '2015-01-15 00:27:05.000000', 'consum', 0.0218, 'lps'),
	(366961, 125, '2015-01-15 00:27:06.000000', 'consum', 0.0216, 'lps'),
	(366962, 125, '2015-01-15 00:27:07.000000', 'consum', 0.0217, 'lps'),
	(366963, 125, '2015-01-15 00:27:08.000000', 'consum', 0.0211, 'lps'),
	(366964, 125, '2015-01-15 00:27:09.000000', 'consum', 0.0210, 'lps'),
	(366965, 125, '2015-01-15 00:27:10.000000', 'consum', 0.0223, 'lps'),
	(366966, 125, '2015-01-15 00:27:11.000000', 'consum', 0.0226, 'lps'),
	(366967, 125, '2015-01-15 00:27:12.000000', 'consum', 0.0218, 'lps'),
	(366968, 125, '2015-01-15 00:27:13.000000', 'consum', 0.0220, 'lps'),
	(366969, 125, '2015-01-15 00:27:14.000000', 'consum', 0.0219, 'lps'),
	(366970, 125, '2015-01-15 00:27:15.000000', 'consum', 0.0210, 'lps'),
	(366971, 125, '2015-01-15 00:27:16.000000', 'consum', 0.0216, 'lps'),
	(366972, 125, '2015-01-15 00:27:17.000000', 'consum', 0.0222, 'lps'),
	(366973, 125, '2015-01-15 00:27:18.000000', 'consum', 0.0219, 'lps'),
	(366974, 125, '2015-01-15 00:27:19.000000', 'consum', 0.0218, 'lps'),
	(366975, 125, '2015-01-15 00:27:20.000000', 'consum', 0.0224, 'lps'),
	(366976, 125, '2015-01-15 00:27:21.000000', 'consum', 0.0225, 'lps'),
	(366977, 125, '2015-01-15 00:27:22.000000', 'consum', 0.0224, 'lps'),
	(366978, 125, '2015-01-15 00:27:23.000000', 'consum', 0.0221, 'lps'),
	(366979, 125, '2015-01-15 00:27:24.000000', 'consum', 0.0223, 'lps'),
	(366980, 125, '2015-01-15 00:27:25.000000', 'consum', 0.0224, 'lps'),
	(366981, 125, '2015-01-15 00:27:26.000000', 'consum', 0.0225, 'lps'),
	(366982, 125, '2015-01-15 00:27:27.000000', 'consum', 0.0210, 'lps'),
	(366983, 125, '2015-01-15 00:27:28.000000', 'consum', 0.0218, 'lps'),
	(366984, 125, '2015-01-15 00:27:29.000000', 'consum', 0.0216, 'lps'),
	(366985, 125, '2015-01-15 00:27:30.000000', 'consum', 0.0215, 'lps'),
	(366986, 125, '2015-01-15 00:27:31.000000', 'consum', 0.0220, 'lps'),
	(366987, 125, '2015-01-15 00:27:32.000000', 'consum', 0.0211, 'lps'),
	(366988, 125, '2015-01-15 00:27:33.000000', 'consum', 0.0219, 'lps'),
	(366989, 125, '2015-01-15 00:27:34.000000', 'consum', 0.0217, 'lps'),
	(366990, 125, '2015-01-15 00:27:35.000000', 'consum', 0.0221, 'lps'),
	(366991, 125, '2015-01-15 00:27:36.000000', 'consum', 0.0212, 'lps'),
	(366992, 125, '2015-01-15 00:27:37.000000', 'consum', 0.0218, 'lps'),
	(366993, 125, '2015-01-15 00:27:38.000000', 'consum', 0.0211, 'lps'),
	(366994, 125, '2015-01-15 00:27:39.000000', 'consum', 0.0210, 'lps'),
	(366995, 125, '2015-01-15 00:27:40.000000', 'consum', 0.0223, 'lps'),
	(366996, 125, '2015-01-15 00:27:41.000000', 'consum', 0.0225, 'lps'),
	(366997, 125, '2015-01-15 00:27:42.000000', 'consum', 0.0214, 'lps'),
	(366998, 125, '2015-01-15 00:27:43.000000', 'consum', 0.0220, 'lps'),
	(366999, 125, '2015-01-15 00:27:44.000000', 'consum', 0.0213, 'lps'),
	(367000, 125, '2015-01-15 00:27:45.000000', 'consum', 0.0214, 'lps'),
	(367001, 125, '2015-01-15 00:27:46.000000', 'consum', 0.0222, 'lps'),
	(367002, 125, '2015-01-15 00:27:47.000000', 'consum', 0.0225, 'lps'),
	(367003, 125, '2015-01-15 00:27:48.000000', 'consum', 0.0214, 'lps'),
	(367004, 125, '2015-01-15 00:27:49.000000', 'consum', 0.0219, 'lps'),
	(367005, 125, '2015-01-15 00:27:50.000000', 'consum', 0.0211, 'lps'),
	(367006, 125, '2015-01-15 00:27:51.000000', 'consum', 0.0224, 'lps'),
	(367007, 125, '2015-01-15 00:27:52.000000', 'consum', 0.0224, 'lps'),
	(367008, 125, '2015-01-15 00:27:53.000000', 'consum', 0.0223, 'lps'),
	(367009, 125, '2015-01-15 00:27:54.000000', 'consum', 0.0218, 'lps'),
	(367010, 125, '2015-01-15 00:27:55.000000', 'consum', 0.0225, 'lps'),
	(367011, 125, '2015-01-15 00:27:56.000000', 'consum', 0.0213, 'lps'),
	(367012, 125, '2015-01-15 00:27:57.000000', 'consum', 0.0213, 'lps'),
	(367013, 125, '2015-01-15 00:27:58.000000', 'consum', 0.0217, 'lps'),
	(367014, 125, '2015-01-15 00:27:59.000000', 'consum', 0.0221, 'lps'),
	(367015, 125, '2015-01-15 00:28:00.000000', 'consum', 0.0210, 'lps'),
	(367016, 125, '2015-01-15 00:28:01.000000', 'consum', 0.0213, 'lps'),
	(367017, 125, '2015-01-15 00:28:02.000000', 'consum', 0.0223, 'lps'),
	(367018, 125, '2015-01-15 00:28:03.000000', 'consum', 0.0216, 'lps'),
	(367019, 125, '2015-01-15 00:28:04.000000', 'consum', 0.0220, 'lps'),
	(367020, 125, '2015-01-15 00:28:05.000000', 'consum', 0.0210, 'lps'),
	(367021, 125, '2015-01-15 00:28:06.000000', 'consum', 0.0211, 'lps'),
	(367022, 125, '2015-01-15 00:28:07.000000', 'consum', 0.0219, 'lps'),
	(367023, 125, '2015-01-15 00:28:08.000000', 'consum', 0.0216, 'lps'),
	(367024, 125, '2015-01-15 00:28:09.000000', 'consum', 0.0215, 'lps'),
	(367025, 125, '2015-01-15 00:28:10.000000', 'consum', 0.0218, 'lps'),
	(367026, 125, '2015-01-15 00:28:11.000000', 'consum', 0.0216, 'lps'),
	(367027, 125, '2015-01-15 00:28:12.000000', 'consum', 0.0219, 'lps'),
	(367028, 125, '2015-01-15 00:28:13.000000', 'consum', 0.0220, 'lps'),
	(367029, 125, '2015-01-15 00:28:14.000000', 'consum', 0.0215, 'lps'),
	(367030, 125, '2015-01-15 00:28:15.000000', 'consum', 0.0224, 'lps'),
	(367031, 125, '2015-01-15 00:28:16.000000', 'consum', 0.0215, 'lps'),
	(367032, 125, '2015-01-15 00:28:17.000000', 'consum', 0.0226, 'lps'),
	(367033, 125, '2015-01-15 00:28:18.000000', 'consum', 0.0223, 'lps'),
	(367034, 125, '2015-01-15 00:28:19.000000', 'consum', 0.0213, 'lps'),
	(367035, 125, '2015-01-15 00:28:20.000000', 'consum', 0.0220, 'lps'),
	(367036, 125, '2015-01-15 00:28:21.000000', 'consum', 0.0219, 'lps'),
	(367037, 125, '2015-01-15 00:28:22.000000', 'consum', 0.0225, 'lps'),
	(367038, 125, '2015-01-15 00:28:23.000000', 'consum', 0.0225, 'lps'),
	(367039, 125, '2015-01-15 00:28:24.000000', 'consum', 0.0221, 'lps'),
	(367040, 125, '2015-01-15 00:28:25.000000', 'consum', 0.0224, 'lps'),
	(367041, 125, '2015-01-15 00:28:26.000000', 'consum', 0.0211, 'lps'),
	(367042, 125, '2015-01-15 00:28:27.000000', 'consum', 0.0223, 'lps'),
	(367043, 125, '2015-01-15 00:28:28.000000', 'consum', 0.0225, 'lps'),
	(367044, 125, '2015-01-15 00:28:29.000000', 'consum', 0.0212, 'lps'),
	(367045, 125, '2015-01-15 00:28:30.000000', 'consum', 0.0224, 'lps'),
	(367046, 125, '2015-01-15 00:28:31.000000', 'consum', 0.0224, 'lps'),
	(367047, 125, '2015-01-15 00:28:32.000000', 'consum', 0.0222, 'lps'),
	(367048, 125, '2015-01-15 00:28:33.000000', 'consum', 0.0212, 'lps'),
	(367049, 125, '2015-01-15 00:28:34.000000', 'consum', 0.0220, 'lps'),
	(367050, 125, '2015-01-15 00:28:35.000000', 'consum', 0.0219, 'lps'),
	(367051, 125, '2015-01-15 00:28:36.000000', 'consum', 0.0226, 'lps'),
	(367052, 125, '2015-01-15 00:28:37.000000', 'consum', 0.0211, 'lps'),
	(367053, 125, '2015-01-15 00:28:38.000000', 'consum', 0.0218, 'lps'),
	(367054, 125, '2015-01-15 00:28:39.000000', 'consum', 0.0216, 'lps'),
	(367055, 125, '2015-01-15 00:28:40.000000', 'consum', 0.0218, 'lps'),
	(367056, 125, '2015-01-15 00:28:41.000000', 'consum', 0.0212, 'lps'),
	(367057, 125, '2015-01-15 00:28:42.000000', 'consum', 0.0214, 'lps'),
	(367058, 125, '2015-01-15 00:28:43.000000', 'consum', 0.0224, 'lps'),
	(367059, 125, '2015-01-15 00:28:44.000000', 'consum', 0.0216, 'lps'),
	(367060, 125, '2015-01-15 00:28:45.000000', 'consum', 0.0218, 'lps'),
	(367061, 125, '2015-01-15 00:28:46.000000', 'consum', 0.0216, 'lps'),
	(367062, 125, '2015-01-15 00:28:47.000000', 'consum', 0.0214, 'lps'),
	(367063, 125, '2015-01-15 00:28:48.000000', 'consum', 0.0213, 'lps'),
	(367064, 125, '2015-01-15 00:28:49.000000', 'consum', 0.0213, 'lps'),
	(367065, 125, '2015-01-15 00:28:50.000000', 'consum', 0.0219, 'lps'),
	(367066, 125, '2015-01-15 00:28:51.000000', 'consum', 0.0210, 'lps'),
	(367067, 125, '2015-01-15 00:28:52.000000', 'consum', 0.0217, 'lps'),
	(367068, 125, '2015-01-15 00:28:53.000000', 'consum', 0.0213, 'lps'),
	(367069, 125, '2015-01-15 00:28:54.000000', 'consum', 0.0223, 'lps'),
	(367070, 125, '2015-01-15 00:28:55.000000', 'consum', 0.0214, 'lps'),
	(367071, 125, '2015-01-15 00:28:56.000000', 'consum', 0.0225, 'lps'),
	(367072, 125, '2015-01-15 00:28:57.000000', 'consum', 0.0223, 'lps'),
	(367073, 125, '2015-01-15 00:28:58.000000', 'consum', 0.0213, 'lps'),
	(367074, 125, '2015-01-15 00:28:59.000000', 'consum', 0.0222, 'lps'),
	(367075, 125, '2015-01-15 00:29:00.000000', 'consum', 0.0226, 'lps'),
	(367076, 125, '2015-01-15 00:29:01.000000', 'consum', 0.0222, 'lps'),
	(367077, 125, '2015-01-15 00:29:02.000000', 'consum', 0.0223, 'lps'),
	(367078, 125, '2015-01-15 00:29:03.000000', 'consum', 0.0220, 'lps'),
	(367079, 125, '2015-01-15 00:29:04.000000', 'consum', 0.0222, 'lps'),
	(367080, 125, '2015-01-15 00:29:05.000000', 'consum', 0.0224, 'lps'),
	(367081, 125, '2015-01-15 00:29:06.000000', 'consum', 0.0212, 'lps'),
	(367082, 125, '2015-01-15 00:29:07.000000', 'consum', 0.0226, 'lps'),
	(367083, 125, '2015-01-15 00:29:08.000000', 'consum', 0.0220, 'lps'),
	(367084, 125, '2015-01-15 00:29:09.000000', 'consum', 0.0213, 'lps'),
	(367085, 125, '2015-01-15 00:29:10.000000', 'consum', 0.0210, 'lps'),
	(367086, 125, '2015-01-15 00:29:11.000000', 'consum', 0.0219, 'lps'),
	(367087, 125, '2015-01-15 00:29:12.000000', 'consum', 0.0221, 'lps'),
	(367088, 125, '2015-01-15 00:29:13.000000', 'consum', 0.0220, 'lps'),
	(367089, 125, '2015-01-15 00:29:14.000000', 'consum', 0.0213, 'lps'),
	(367090, 125, '2015-01-15 00:29:15.000000', 'consum', 0.0211, 'lps'),
	(367091, 125, '2015-01-15 00:29:16.000000', 'consum', 0.0224, 'lps'),
	(367092, 125, '2015-01-15 00:29:17.000000', 'consum', 0.0210, 'lps'),
	(367093, 125, '2015-01-15 00:29:18.000000', 'consum', 0.0217, 'lps'),
	(367094, 125, '2015-01-15 00:29:19.000000', 'consum', 0.0214, 'lps'),
	(367095, 125, '2015-01-15 00:29:20.000000', 'consum', 0.0226, 'lps'),
	(367096, 125, '2015-01-15 00:29:21.000000', 'consum', 0.0211, 'lps'),
	(367097, 125, '2015-01-15 00:29:22.000000', 'consum', 0.0217, 'lps'),
	(367098, 125, '2015-01-15 00:29:23.000000', 'consum', 0.0224, 'lps'),
	(367099, 125, '2015-01-15 00:29:24.000000', 'consum', 0.0211, 'lps'),
	(367100, 125, '2015-01-15 00:29:25.000000', 'consum', 0.0223, 'lps'),
	(367101, 125, '2015-01-15 00:29:26.000000', 'consum', 0.0221, 'lps'),
	(367102, 125, '2015-01-15 00:29:27.000000', 'consum', 0.0212, 'lps'),
	(367103, 125, '2015-01-15 00:29:28.000000', 'consum', 0.0222, 'lps'),
	(367104, 125, '2015-01-15 00:29:29.000000', 'consum', 0.0211, 'lps'),
	(367105, 125, '2015-01-15 00:29:30.000000', 'consum', 0.0213, 'lps'),
	(367106, 125, '2015-01-15 00:29:31.000000', 'consum', 0.0224, 'lps'),
	(367107, 125, '2015-01-15 00:29:32.000000', 'consum', 0.0218, 'lps'),
	(367108, 125, '2015-01-15 00:29:33.000000', 'consum', 0.0211, 'lps'),
	(367109, 125, '2015-01-15 00:29:34.000000', 'consum', 0.0223, 'lps'),
	(367110, 125, '2015-01-15 00:29:35.000000', 'consum', 0.0223, 'lps'),
	(367111, 125, '2015-01-15 00:29:36.000000', 'consum', 0.0220, 'lps'),
	(367112, 125, '2015-01-15 00:29:37.000000', 'consum', 0.0220, 'lps'),
	(367113, 125, '2015-01-15 00:29:38.000000', 'consum', 0.0214, 'lps'),
	(367114, 125, '2015-01-15 00:29:39.000000', 'consum', 0.0216, 'lps'),
	(367115, 125, '2015-01-15 00:29:40.000000', 'consum', 0.0213, 'lps'),
	(367116, 125, '2015-01-15 00:29:41.000000', 'consum', 0.0224, 'lps'),
	(367117, 125, '2015-01-15 00:29:42.000000', 'consum', 0.0222, 'lps'),
	(367118, 125, '2015-01-15 00:29:43.000000', 'consum', 0.0213, 'lps'),
	(367119, 125, '2015-01-15 00:29:44.000000', 'consum', 0.0220, 'lps'),
	(367120, 125, '2015-01-15 00:29:45.000000', 'consum', 0.0218, 'lps'),
	(367121, 125, '2015-01-15 00:29:46.000000', 'consum', 0.0223, 'lps'),
	(367122, 125, '2015-01-15 00:29:47.000000', 'consum', 0.0216, 'lps'),
	(367123, 125, '2015-01-15 00:29:48.000000', 'consum', 0.0219, 'lps'),
	(367124, 125, '2015-01-15 00:29:49.000000', 'consum', 0.0220, 'lps'),
	(367125, 125, '2015-01-15 00:29:50.000000', 'consum', 0.0217, 'lps'),
	(367126, 125, '2015-01-15 00:29:51.000000', 'consum', 0.0214, 'lps'),
	(367127, 125, '2015-01-15 00:29:52.000000', 'consum', 0.0210, 'lps'),
	(367128, 125, '2015-01-15 00:29:53.000000', 'consum', 0.0214, 'lps'),
	(367129, 125, '2015-01-15 00:29:54.000000', 'consum', 0.0215, 'lps'),
	(367130, 125, '2015-01-15 00:29:55.000000', 'consum', 0.0222, 'lps'),
	(367131, 125, '2015-01-15 00:29:56.000000', 'consum', 0.0224, 'lps'),
	(367132, 125, '2015-01-15 00:29:57.000000', 'consum', 0.0225, 'lps'),
	(367133, 125, '2015-01-15 00:29:58.000000', 'consum', 0.0211, 'lps'),
	(367134, 125, '2015-01-15 00:29:59.000000', 'consum', 0.0221, 'lps'),
	(367135, 125, '2015-01-15 00:30:00.000000', 'consum', 0.0213, 'lps'),
	(367136, 125, '2015-01-15 00:30:01.000000', 'consum', 0.0210, 'lps'),
	(367137, 125, '2015-01-15 00:30:02.000000', 'consum', 0.0219, 'lps'),
	(367138, 125, '2015-01-15 00:30:03.000000', 'consum', 0.0220, 'lps'),
	(367139, 125, '2015-01-15 00:30:04.000000', 'consum', 0.0217, 'lps'),
	(367140, 125, '2015-01-15 00:30:05.000000', 'consum', 0.0217, 'lps'),
	(367141, 125, '2015-01-15 00:30:06.000000', 'consum', 0.0225, 'lps'),
	(367142, 125, '2015-01-15 00:30:07.000000', 'consum', 0.0214, 'lps'),
	(367143, 125, '2015-01-15 00:30:08.000000', 'consum', 0.0217, 'lps'),
	(367144, 125, '2015-01-15 00:30:09.000000', 'consum', 0.0219, 'lps'),
	(367145, 125, '2015-01-15 00:30:10.000000', 'consum', 0.0215, 'lps'),
	(367146, 125, '2015-01-15 00:30:11.000000', 'consum', 0.0212, 'lps'),
	(367147, 125, '2015-01-15 00:30:12.000000', 'consum', 0.0219, 'lps'),
	(367148, 125, '2015-01-15 00:30:13.000000', 'consum', 0.0215, 'lps'),
	(367149, 125, '2015-01-15 00:30:14.000000', 'consum', 0.0210, 'lps'),
	(367150, 125, '2015-01-15 00:30:15.000000', 'consum', 0.0212, 'lps'),
	(367151, 125, '2015-01-15 00:30:16.000000', 'consum', 0.0220, 'lps'),
	(367152, 125, '2015-01-15 00:30:17.000000', 'consum', 0.0222, 'lps'),
	(367153, 125, '2015-01-15 00:30:18.000000', 'consum', 0.0224, 'lps'),
	(367154, 125, '2015-01-15 00:30:19.000000', 'consum', 0.0212, 'lps'),
	(367155, 125, '2015-01-15 00:30:20.000000', 'consum', 0.0210, 'lps'),
	(367156, 125, '2015-01-15 00:30:21.000000', 'consum', 0.0221, 'lps'),
	(367157, 125, '2015-01-15 00:30:22.000000', 'consum', 0.0216, 'lps'),
	(367158, 125, '2015-01-15 00:30:23.000000', 'consum', 0.0225, 'lps'),
	(367159, 125, '2015-01-15 00:30:24.000000', 'consum', 0.0215, 'lps'),
	(367160, 125, '2015-01-15 00:30:25.000000', 'consum', 0.0226, 'lps'),
	(367161, 125, '2015-01-15 00:30:26.000000', 'consum', 0.0222, 'lps'),
	(367162, 125, '2015-01-15 00:30:27.000000', 'consum', 0.0225, 'lps'),
	(367163, 125, '2015-01-15 00:30:28.000000', 'consum', 0.0215, 'lps'),
	(367164, 125, '2015-01-15 00:30:29.000000', 'consum', 0.0224, 'lps'),
	(367165, 125, '2015-01-15 00:30:30.000000', 'consum', 0.0214, 'lps'),
	(367166, 125, '2015-01-15 00:30:31.000000', 'consum', 0.0224, 'lps'),
	(367167, 125, '2015-01-15 00:30:32.000000', 'consum', 0.0218, 'lps'),
	(367168, 125, '2015-01-15 00:30:33.000000', 'consum', 0.0223, 'lps'),
	(367169, 125, '2015-01-15 00:30:34.000000', 'consum', 0.0220, 'lps'),
	(367170, 125, '2015-01-15 00:30:35.000000', 'consum', 0.0220, 'lps'),
	(367171, 125, '2015-01-15 00:30:36.000000', 'consum', 0.0212, 'lps'),
	(367172, 125, '2015-01-15 00:30:37.000000', 'consum', 0.0225, 'lps'),
	(367173, 125, '2015-01-15 00:30:38.000000', 'consum', 0.0213, 'lps'),
	(367174, 125, '2015-01-15 00:30:39.000000', 'consum', 0.0216, 'lps'),
	(367175, 125, '2015-01-15 00:30:40.000000', 'consum', 0.0213, 'lps'),
	(367176, 125, '2015-01-15 00:30:41.000000', 'consum', 0.0224, 'lps'),
	(367177, 125, '2015-01-15 00:30:42.000000', 'consum', 0.0223, 'lps'),
	(367178, 125, '2015-01-15 00:30:43.000000', 'consum', 0.0214, 'lps'),
	(367179, 125, '2015-01-15 00:30:44.000000', 'consum', 0.0210, 'lps'),
	(367180, 125, '2015-01-15 00:30:45.000000', 'consum', 0.0214, 'lps'),
	(367181, 125, '2015-01-15 00:30:46.000000', 'consum', 0.0213, 'lps'),
	(367182, 125, '2015-01-15 00:30:47.000000', 'consum', 0.0213, 'lps'),
	(367183, 125, '2015-01-15 00:30:48.000000', 'consum', 0.0218, 'lps'),
	(367184, 125, '2015-01-15 00:30:49.000000', 'consum', 0.0224, 'lps'),
	(367185, 125, '2015-01-15 00:30:50.000000', 'consum', 0.0222, 'lps'),
	(367186, 125, '2015-01-15 00:30:51.000000', 'consum', 0.0211, 'lps'),
	(367187, 125, '2015-01-15 00:30:52.000000', 'consum', 0.0213, 'lps'),
	(367188, 125, '2015-01-15 00:30:53.000000', 'consum', 0.0225, 'lps'),
	(367189, 125, '2015-01-15 00:30:54.000000', 'consum', 0.0223, 'lps'),
	(367190, 125, '2015-01-15 00:30:55.000000', 'consum', 0.0213, 'lps'),
	(367191, 125, '2015-01-15 00:30:56.000000', 'consum', 0.0221, 'lps'),
	(367192, 125, '2015-01-15 00:30:57.000000', 'consum', 0.0222, 'lps'),
	(367193, 125, '2015-01-15 00:30:58.000000', 'consum', 0.0219, 'lps'),
	(367194, 125, '2015-01-15 00:30:59.000000', 'consum', 0.0223, 'lps'),
	(367195, 125, '2015-01-15 00:31:00.000000', 'consum', 0.0212, 'lps'),
	(367196, 125, '2015-01-15 00:31:01.000000', 'consum', 0.0215, 'lps'),
	(367197, 125, '2015-01-15 00:31:02.000000', 'consum', 0.0215, 'lps'),
	(367198, 125, '2015-01-15 00:31:03.000000', 'consum', 0.0217, 'lps'),
	(367199, 125, '2015-01-15 00:31:04.000000', 'consum', 0.0217, 'lps'),
	(367200, 125, '2015-01-15 00:31:05.000000', 'consum', 0.0224, 'lps'),
	(367201, 125, '2015-01-15 00:31:06.000000', 'consum', 0.0224, 'lps'),
	(367202, 125, '2015-01-15 00:31:07.000000', 'consum', 0.0222, 'lps'),
	(367203, 125, '2015-01-15 00:31:08.000000', 'consum', 0.0214, 'lps'),
	(367204, 125, '2015-01-15 00:31:09.000000', 'consum', 0.0225, 'lps'),
	(367205, 125, '2015-01-15 00:31:10.000000', 'consum', 0.0224, 'lps'),
	(367206, 125, '2015-01-15 00:31:11.000000', 'consum', 0.0219, 'lps'),
	(367207, 125, '2015-01-15 00:31:12.000000', 'consum', 0.0214, 'lps'),
	(367208, 125, '2015-01-15 00:31:13.000000', 'consum', 0.0222, 'lps'),
	(367209, 125, '2015-01-15 00:31:14.000000', 'consum', 0.0222, 'lps'),
	(367210, 125, '2015-01-15 00:31:15.000000', 'consum', 0.0220, 'lps'),
	(367211, 125, '2015-01-15 00:31:16.000000', 'consum', 0.0224, 'lps'),
	(367212, 125, '2015-01-15 00:31:17.000000', 'consum', 0.0216, 'lps'),
	(367213, 125, '2015-01-15 00:31:18.000000', 'consum', 0.0214, 'lps'),
	(367214, 125, '2015-01-15 00:31:19.000000', 'consum', 0.0212, 'lps'),
	(367215, 125, '2015-01-15 00:31:20.000000', 'consum', 0.0225, 'lps'),
	(367216, 125, '2015-01-15 00:31:21.000000', 'consum', 0.0214, 'lps'),
	(367217, 125, '2015-01-15 00:31:22.000000', 'consum', 0.0217, 'lps'),
	(367218, 125, '2015-01-15 00:31:23.000000', 'consum', 0.0220, 'lps'),
	(367219, 125, '2015-01-15 00:31:24.000000', 'consum', 0.0219, 'lps'),
	(367220, 125, '2015-01-15 00:31:25.000000', 'consum', 0.0226, 'lps'),
	(367221, 125, '2015-01-15 00:31:26.000000', 'consum', 0.0213, 'lps'),
	(367222, 125, '2015-01-15 00:31:27.000000', 'consum', 0.0212, 'lps'),
	(367223, 125, '2015-01-15 00:31:28.000000', 'consum', 0.0211, 'lps'),
	(367224, 125, '2015-01-15 00:31:29.000000', 'consum', 0.0226, 'lps'),
	(367225, 125, '2015-01-15 00:31:30.000000', 'consum', 0.0221, 'lps'),
	(367226, 125, '2015-01-15 00:31:31.000000', 'consum', 0.0218, 'lps'),
	(367227, 125, '2015-01-15 00:31:32.000000', 'consum', 0.0218, 'lps'),
	(367228, 125, '2015-01-15 00:31:33.000000', 'consum', 0.0225, 'lps'),
	(367229, 125, '2015-01-15 00:31:34.000000', 'consum', 0.0210, 'lps'),
	(367230, 125, '2015-01-15 00:31:35.000000', 'consum', 0.0216, 'lps'),
	(367231, 125, '2015-01-15 00:31:36.000000', 'consum', 0.0223, 'lps'),
	(367232, 125, '2015-01-15 00:31:37.000000', 'consum', 0.0225, 'lps'),
	(367233, 125, '2015-01-15 00:31:38.000000', 'consum', 0.0211, 'lps'),
	(367234, 125, '2015-01-15 00:31:39.000000', 'consum', 0.0222, 'lps'),
	(367235, 125, '2015-01-15 00:31:40.000000', 'consum', 0.0216, 'lps'),
	(367236, 125, '2015-01-15 00:31:41.000000', 'consum', 0.0221, 'lps'),
	(367237, 125, '2015-01-15 00:31:42.000000', 'consum', 0.0214, 'lps'),
	(367238, 125, '2015-01-15 00:31:43.000000', 'consum', 0.0216, 'lps'),
	(367239, 125, '2015-01-15 00:31:44.000000', 'consum', 0.0211, 'lps'),
	(367240, 125, '2015-01-15 00:31:45.000000', 'consum', 0.0215, 'lps'),
	(367241, 125, '2015-01-15 00:31:46.000000', 'consum', 0.0214, 'lps'),
	(367242, 125, '2015-01-15 00:31:47.000000', 'consum', 0.0218, 'lps'),
	(367243, 125, '2015-01-15 00:31:48.000000', 'consum', 0.0219, 'lps'),
	(367244, 125, '2015-01-15 00:31:49.000000', 'consum', 0.0216, 'lps'),
	(367245, 125, '2015-01-15 00:31:50.000000', 'consum', 0.0212, 'lps'),
	(367246, 125, '2015-01-15 00:31:51.000000', 'consum', 0.0221, 'lps'),
	(367247, 125, '2015-01-15 00:31:52.000000', 'consum', 0.0223, 'lps'),
	(367248, 125, '2015-01-15 00:31:53.000000', 'consum', 0.0210, 'lps'),
	(367249, 125, '2015-01-15 00:31:54.000000', 'consum', 0.0224, 'lps'),
	(367250, 125, '2015-01-15 00:31:55.000000', 'consum', 0.0211, 'lps'),
	(367251, 125, '2015-01-15 00:31:56.000000', 'consum', 0.0226, 'lps'),
	(367252, 125, '2015-01-15 00:31:57.000000', 'consum', 0.0219, 'lps'),
	(367253, 125, '2015-01-15 00:31:58.000000', 'consum', 0.0224, 'lps'),
	(367254, 125, '2015-01-15 00:31:59.000000', 'consum', 0.0218, 'lps'),
	(367255, 125, '2015-01-15 00:32:00.000000', 'consum', 0.0226, 'lps'),
	(367256, 125, '2015-01-15 00:32:01.000000', 'consum', 0.0215, 'lps'),
	(367257, 125, '2015-01-15 00:32:02.000000', 'consum', 0.0224, 'lps'),
	(367258, 125, '2015-01-15 00:32:03.000000', 'consum', 0.0212, 'lps'),
	(367259, 125, '2015-01-15 00:32:04.000000', 'consum', 0.0214, 'lps'),
	(367260, 125, '2015-01-15 00:32:05.000000', 'consum', 0.0223, 'lps'),
	(367261, 125, '2015-01-15 00:32:06.000000', 'consum', 0.0215, 'lps'),
	(367262, 125, '2015-01-15 00:32:07.000000', 'consum', 0.0214, 'lps'),
	(367263, 125, '2015-01-15 00:32:08.000000', 'consum', 0.0213, 'lps'),
	(367264, 125, '2015-01-15 00:32:09.000000', 'consum', 0.0213, 'lps'),
	(367265, 125, '2015-01-15 00:32:10.000000', 'consum', 0.0219, 'lps'),
	(367266, 125, '2015-01-15 00:32:11.000000', 'consum', 0.0213, 'lps'),
	(367267, 125, '2015-01-15 00:32:12.000000', 'consum', 0.0215, 'lps'),
	(367268, 125, '2015-01-15 00:32:13.000000', 'consum', 0.0225, 'lps'),
	(367269, 125, '2015-01-15 00:32:14.000000', 'consum', 0.0220, 'lps'),
	(367270, 125, '2015-01-15 00:32:15.000000', 'consum', 0.0215, 'lps'),
	(367271, 125, '2015-01-15 00:32:16.000000', 'consum', 0.0223, 'lps'),
	(367272, 125, '2015-01-15 00:32:17.000000', 'consum', 0.0226, 'lps'),
	(367273, 125, '2015-01-15 00:32:18.000000', 'consum', 0.0217, 'lps'),
	(367274, 125, '2015-01-15 00:32:19.000000', 'consum', 0.0214, 'lps'),
	(367275, 125, '2015-01-15 00:32:20.000000', 'consum', 0.0211, 'lps'),
	(367276, 125, '2015-01-15 00:32:21.000000', 'consum', 0.0219, 'lps'),
	(367277, 125, '2015-01-15 00:32:22.000000', 'consum', 0.0219, 'lps'),
	(367278, 125, '2015-01-15 00:32:23.000000', 'consum', 0.0210, 'lps'),
	(367279, 125, '2015-01-15 00:32:24.000000', 'consum', 0.0220, 'lps'),
	(367280, 125, '2015-01-15 00:32:25.000000', 'consum', 0.0211, 'lps'),
	(367281, 125, '2015-01-15 00:32:26.000000', 'consum', 0.0216, 'lps'),
	(367282, 125, '2015-01-15 00:32:27.000000', 'consum', 0.0224, 'lps'),
	(367283, 125, '2015-01-15 00:32:28.000000', 'consum', 0.0226, 'lps'),
	(367284, 125, '2015-01-15 00:32:29.000000', 'consum', 0.0214, 'lps'),
	(367285, 125, '2015-01-15 00:32:30.000000', 'consum', 0.0216, 'lps'),
	(367286, 125, '2015-01-15 00:32:31.000000', 'consum', 0.0214, 'lps'),
	(367287, 125, '2015-01-15 00:32:32.000000', 'consum', 0.0211, 'lps'),
	(367288, 125, '2015-01-15 00:32:33.000000', 'consum', 0.0219, 'lps'),
	(367289, 125, '2015-01-15 00:32:34.000000', 'consum', 0.0222, 'lps'),
	(367290, 125, '2015-01-15 00:32:35.000000', 'consum', 0.0224, 'lps'),
	(367291, 125, '2015-01-15 00:32:36.000000', 'consum', 0.0210, 'lps'),
	(367292, 125, '2015-01-15 00:32:37.000000', 'consum', 0.0218, 'lps'),
	(367293, 125, '2015-01-15 00:32:38.000000', 'consum', 0.0220, 'lps'),
	(367294, 125, '2015-01-15 00:32:39.000000', 'consum', 0.0218, 'lps'),
	(367295, 125, '2015-01-15 00:32:40.000000', 'consum', 0.0219, 'lps'),
	(367296, 125, '2015-01-15 00:32:41.000000', 'consum', 0.0214, 'lps'),
	(367297, 125, '2015-01-15 00:32:42.000000', 'consum', 0.0224, 'lps'),
	(367298, 125, '2015-01-15 00:32:43.000000', 'consum', 0.0215, 'lps'),
	(367299, 125, '2015-01-15 00:32:44.000000', 'consum', 0.0210, 'lps'),
	(367300, 125, '2015-01-15 00:32:45.000000', 'consum', 0.0212, 'lps'),
	(367301, 125, '2015-01-15 00:32:46.000000', 'consum', 0.0221, 'lps'),
	(367302, 125, '2015-01-15 00:32:47.000000', 'consum', 0.0210, 'lps'),
	(367303, 125, '2015-01-15 00:32:48.000000', 'consum', 0.0226, 'lps'),
	(367304, 125, '2015-01-15 00:32:49.000000', 'consum', 0.0223, 'lps'),
	(367305, 125, '2015-01-15 00:32:50.000000', 'consum', 0.0213, 'lps'),
	(367306, 125, '2015-01-15 00:32:51.000000', 'consum', 0.0219, 'lps'),
	(367307, 125, '2015-01-15 00:32:52.000000', 'consum', 0.0214, 'lps'),
	(367308, 125, '2015-01-15 00:32:53.000000', 'consum', 0.0219, 'lps'),
	(367309, 125, '2015-01-15 00:32:54.000000', 'consum', 0.0212, 'lps'),
	(367310, 125, '2015-01-15 00:32:55.000000', 'consum', 0.0224, 'lps'),
	(367311, 125, '2015-01-15 00:32:56.000000', 'consum', 0.0225, 'lps'),
	(367312, 125, '2015-01-15 00:32:57.000000', 'consum', 0.0224, 'lps'),
	(367313, 125, '2015-01-15 00:32:58.000000', 'consum', 0.0222, 'lps'),
	(367314, 125, '2015-01-15 00:32:59.000000', 'consum', 0.0226, 'lps'),
	(367315, 125, '2015-01-15 00:33:00.000000', 'consum', 0.0221, 'lps'),
	(367316, 125, '2015-01-15 00:33:01.000000', 'consum', 0.0218, 'lps'),
	(367317, 125, '2015-01-15 00:33:02.000000', 'consum', 0.0217, 'lps'),
	(367318, 125, '2015-01-15 00:33:03.000000', 'consum', 0.0220, 'lps'),
	(367319, 125, '2015-01-15 00:33:04.000000', 'consum', 0.0226, 'lps'),
	(367320, 125, '2015-01-15 00:33:05.000000', 'consum', 0.0224, 'lps'),
	(367321, 125, '2015-01-15 00:33:06.000000', 'consum', 0.0216, 'lps'),
	(367322, 125, '2015-01-15 00:33:07.000000', 'consum', 0.0214, 'lps'),
	(367323, 125, '2015-01-15 00:33:08.000000', 'consum', 0.0212, 'lps'),
	(367324, 125, '2015-01-15 00:33:09.000000', 'consum', 0.0211, 'lps'),
	(367325, 125, '2015-01-15 00:33:10.000000', 'consum', 0.0211, 'lps'),
	(367326, 125, '2015-01-15 00:33:11.000000', 'consum', 0.0226, 'lps'),
	(367327, 125, '2015-01-15 00:33:12.000000', 'consum', 0.0221, 'lps'),
	(367328, 125, '2015-01-15 00:33:13.000000', 'consum', 0.0219, 'lps'),
	(367329, 125, '2015-01-15 00:33:14.000000', 'consum', 0.0221, 'lps'),
	(367330, 125, '2015-01-15 00:33:15.000000', 'consum', 0.0223, 'lps'),
	(367331, 125, '2015-01-15 00:33:16.000000', 'consum', 0.0226, 'lps'),
	(367332, 125, '2015-01-15 00:33:17.000000', 'consum', 0.0215, 'lps'),
	(367333, 125, '2015-01-15 00:33:18.000000', 'consum', 0.0222, 'lps'),
	(367334, 125, '2015-01-15 00:33:19.000000', 'consum', 0.0222, 'lps'),
	(367335, 125, '2015-01-15 00:33:20.000000', 'consum', 0.0219, 'lps'),
	(367336, 125, '2015-01-15 00:33:21.000000', 'consum', 0.0217, 'lps'),
	(367337, 125, '2015-01-15 00:33:22.000000', 'consum', 0.0221, 'lps'),
	(367338, 125, '2015-01-15 00:33:23.000000', 'consum', 0.0210, 'lps'),
	(367339, 125, '2015-01-15 00:33:24.000000', 'consum', 0.0210, 'lps'),
	(367340, 125, '2015-01-15 00:33:25.000000', 'consum', 0.0226, 'lps'),
	(367341, 125, '2015-01-15 00:33:26.000000', 'consum', 0.0226, 'lps'),
	(367342, 125, '2015-01-15 00:33:27.000000', 'consum', 0.0225, 'lps'),
	(367343, 125, '2015-01-15 00:33:28.000000', 'consum', 0.0220, 'lps'),
	(367344, 125, '2015-01-15 00:33:29.000000', 'consum', 0.0215, 'lps'),
	(367345, 125, '2015-01-15 00:33:30.000000', 'consum', 0.0222, 'lps'),
	(367346, 125, '2015-01-15 00:33:31.000000', 'consum', 0.0224, 'lps'),
	(367347, 125, '2015-01-15 00:33:32.000000', 'consum', 0.0225, 'lps'),
	(367348, 125, '2015-01-15 00:33:33.000000', 'consum', 0.0210, 'lps'),
	(367349, 125, '2015-01-15 00:33:34.000000', 'consum', 0.0217, 'lps'),
	(367350, 125, '2015-01-15 00:33:35.000000', 'consum', 0.0212, 'lps'),
	(367351, 125, '2015-01-15 00:33:36.000000', 'consum', 0.0215, 'lps'),
	(367352, 125, '2015-01-15 00:33:37.000000', 'consum', 0.0215, 'lps'),
	(367353, 125, '2015-01-15 00:33:38.000000', 'consum', 0.0220, 'lps'),
	(367354, 125, '2015-01-15 00:33:39.000000', 'consum', 0.0211, 'lps'),
	(367355, 125, '2015-01-15 00:33:40.000000', 'consum', 0.0218, 'lps'),
	(367356, 125, '2015-01-15 00:33:41.000000', 'consum', 0.0215, 'lps'),
	(367357, 125, '2015-01-15 00:33:42.000000', 'consum', 0.0210, 'lps'),
	(367358, 125, '2015-01-15 00:33:43.000000', 'consum', 0.0212, 'lps'),
	(367359, 125, '2015-01-15 00:33:44.000000', 'consum', 0.0220, 'lps'),
	(367360, 125, '2015-01-15 00:33:45.000000', 'consum', 0.0221, 'lps'),
	(367361, 125, '2015-01-15 00:33:46.000000', 'consum', 0.0221, 'lps'),
	(367362, 125, '2015-01-15 00:33:47.000000', 'consum', 0.0212, 'lps'),
	(367363, 125, '2015-01-15 00:33:48.000000', 'consum', 0.0222, 'lps'),
	(367364, 125, '2015-01-15 00:33:49.000000', 'consum', 0.0216, 'lps'),
	(367365, 125, '2015-01-15 00:33:50.000000', 'consum', 0.0221, 'lps'),
	(367366, 125, '2015-01-15 00:33:51.000000', 'consum', 0.0214, 'lps'),
	(367367, 125, '2015-01-15 00:33:52.000000', 'consum', 0.0215, 'lps'),
	(367368, 125, '2015-01-15 00:33:53.000000', 'consum', 0.0221, 'lps'),
	(367369, 125, '2015-01-15 00:33:54.000000', 'consum', 0.0216, 'lps'),
	(367370, 125, '2015-01-15 00:33:55.000000', 'consum', 0.0226, 'lps'),
	(367371, 125, '2015-01-15 00:33:56.000000', 'consum', 0.0223, 'lps'),
	(367372, 125, '2015-01-15 00:33:57.000000', 'consum', 0.0210, 'lps'),
	(367373, 125, '2015-01-15 00:33:58.000000', 'consum', 0.0221, 'lps'),
	(367374, 125, '2015-01-15 00:33:59.000000', 'consum', 0.0217, 'lps'),
	(367375, 125, '2015-01-15 00:34:00.000000', 'consum', 0.0211, 'lps'),
	(367376, 125, '2015-01-15 00:34:01.000000', 'consum', 0.0210, 'lps'),
	(367377, 125, '2015-01-15 00:34:02.000000', 'consum', 0.0210, 'lps'),
	(367378, 125, '2015-01-15 00:34:03.000000', 'consum', 0.0226, 'lps'),
	(367379, 125, '2015-01-15 00:34:04.000000', 'consum', 0.0223, 'lps'),
	(367380, 125, '2015-01-15 00:34:05.000000', 'consum', 0.0212, 'lps'),
	(367381, 125, '2015-01-15 00:34:06.000000', 'consum', 0.0215, 'lps'),
	(367382, 125, '2015-01-15 00:34:07.000000', 'consum', 0.0211, 'lps'),
	(367383, 125, '2015-01-15 00:34:08.000000', 'consum', 0.0217, 'lps'),
	(367384, 125, '2015-01-15 00:34:09.000000', 'consum', 0.0225, 'lps'),
	(367385, 125, '2015-01-15 00:34:10.000000', 'consum', 0.0215, 'lps'),
	(367386, 125, '2015-01-15 00:34:11.000000', 'consum', 0.0225, 'lps'),
	(367387, 125, '2015-01-15 00:34:12.000000', 'consum', 0.0217, 'lps'),
	(367388, 125, '2015-01-15 00:34:13.000000', 'consum', 0.0218, 'lps'),
	(367389, 125, '2015-01-15 00:34:14.000000', 'consum', 0.0214, 'lps'),
	(367390, 125, '2015-01-15 00:34:15.000000', 'consum', 0.0222, 'lps'),
	(367391, 125, '2015-01-15 00:34:16.000000', 'consum', 0.0224, 'lps'),
	(367392, 125, '2015-01-15 00:34:17.000000', 'consum', 0.0210, 'lps'),
	(367393, 125, '2015-01-15 00:34:18.000000', 'consum', 0.0220, 'lps'),
	(367394, 125, '2015-01-15 00:34:19.000000', 'consum', 0.0211, 'lps'),
	(367395, 125, '2015-01-15 00:34:20.000000', 'consum', 0.0217, 'lps'),
	(367396, 125, '2015-01-15 00:34:21.000000', 'consum', 0.0210, 'lps'),
	(367397, 125, '2015-01-15 00:34:22.000000', 'consum', 0.0223, 'lps'),
	(367398, 125, '2015-01-15 00:34:23.000000', 'consum', 0.0226, 'lps'),
	(367399, 125, '2015-01-15 00:34:24.000000', 'consum', 0.0217, 'lps'),
	(367400, 125, '2015-01-15 00:34:25.000000', 'consum', 0.0212, 'lps'),
	(367401, 125, '2015-01-15 00:34:26.000000', 'consum', 0.0219, 'lps'),
	(367402, 125, '2015-01-15 00:34:27.000000', 'consum', 0.0216, 'lps'),
	(367403, 125, '2015-01-15 00:34:28.000000', 'consum', 0.0214, 'lps'),
	(367404, 125, '2015-01-15 00:34:29.000000', 'consum', 0.0210, 'lps'),
	(367405, 125, '2015-01-15 00:34:30.000000', 'consum', 0.0215, 'lps'),
	(367406, 125, '2015-01-15 00:34:31.000000', 'consum', 0.0218, 'lps'),
	(367407, 125, '2015-01-15 00:34:32.000000', 'consum', 0.0221, 'lps'),
	(367408, 125, '2015-01-15 00:34:33.000000', 'consum', 0.0222, 'lps'),
	(367409, 125, '2015-01-15 00:34:34.000000', 'consum', 0.0221, 'lps'),
	(367410, 125, '2015-01-15 00:34:35.000000', 'consum', 0.0214, 'lps'),
	(367411, 125, '2015-01-15 00:34:36.000000', 'consum', 0.0214, 'lps'),
	(367412, 125, '2015-01-15 00:34:37.000000', 'consum', 0.0220, 'lps'),
	(367413, 125, '2015-01-15 00:34:38.000000', 'consum', 0.0215, 'lps'),
	(367414, 125, '2015-01-15 00:34:39.000000', 'consum', 0.0220, 'lps'),
	(367415, 125, '2015-01-15 00:34:40.000000', 'consum', 0.0214, 'lps'),
	(367416, 125, '2015-01-15 00:34:41.000000', 'consum', 0.0216, 'lps'),
	(367417, 125, '2015-01-15 00:34:42.000000', 'consum', 0.0210, 'lps'),
	(367418, 125, '2015-01-15 00:34:43.000000', 'consum', 0.0211, 'lps'),
	(367419, 125, '2015-01-15 00:34:44.000000', 'consum', 0.0217, 'lps'),
	(367420, 125, '2015-01-15 00:34:45.000000', 'consum', 0.0224, 'lps'),
	(367421, 125, '2015-01-15 00:34:46.000000', 'consum', 0.0210, 'lps'),
	(367422, 125, '2015-01-15 00:34:47.000000', 'consum', 0.0220, 'lps'),
	(367423, 125, '2015-01-15 00:34:48.000000', 'consum', 0.0224, 'lps'),
	(367424, 125, '2015-01-15 00:34:49.000000', 'consum', 0.0217, 'lps'),
	(367425, 125, '2015-01-15 00:34:50.000000', 'consum', 0.0220, 'lps'),
	(367426, 125, '2015-01-15 00:34:51.000000', 'consum', 0.0223, 'lps'),
	(367427, 125, '2015-01-15 00:34:52.000000', 'consum', 0.0213, 'lps'),
	(367428, 125, '2015-01-15 00:34:53.000000', 'consum', 0.0220, 'lps'),
	(367429, 125, '2015-01-15 00:34:54.000000', 'consum', 0.0218, 'lps'),
	(367430, 125, '2015-01-15 00:34:55.000000', 'consum', 0.0219, 'lps'),
	(367431, 125, '2015-01-15 00:34:56.000000', 'consum', 0.0214, 'lps'),
	(367432, 125, '2015-01-15 00:34:57.000000', 'consum', 0.0221, 'lps'),
	(367433, 125, '2015-01-15 00:34:58.000000', 'consum', 0.0219, 'lps'),
	(367434, 125, '2015-01-15 00:34:59.000000', 'consum', 0.0223, 'lps'),
	(367435, 125, '2015-01-15 00:35:00.000000', 'consum', 0.0216, 'lps'),
	(367436, 125, '2015-01-15 00:35:01.000000', 'consum', 0.0219, 'lps'),
	(367437, 125, '2015-01-15 00:35:02.000000', 'consum', 0.0219, 'lps'),
	(367438, 125, '2015-01-15 00:35:03.000000', 'consum', 0.0213, 'lps'),
	(367439, 125, '2015-01-15 00:35:04.000000', 'consum', 0.0216, 'lps'),
	(367440, 125, '2015-01-15 00:35:05.000000', 'consum', 0.0214, 'lps'),
	(367441, 125, '2015-01-15 00:35:06.000000', 'consum', 0.0213, 'lps'),
	(367442, 125, '2015-01-15 00:35:07.000000', 'consum', 0.0214, 'lps'),
	(367443, 125, '2015-01-15 00:35:08.000000', 'consum', 0.0220, 'lps'),
	(367444, 125, '2015-01-15 00:35:09.000000', 'consum', 0.0217, 'lps'),
	(367445, 125, '2015-01-15 00:35:10.000000', 'consum', 0.0213, 'lps'),
	(367446, 125, '2015-01-15 00:35:11.000000', 'consum', 0.0222, 'lps'),
	(367447, 125, '2015-01-15 00:35:12.000000', 'consum', 0.0210, 'lps'),
	(367448, 125, '2015-01-15 00:35:13.000000', 'consum', 0.0226, 'lps'),
	(367449, 125, '2015-01-15 00:35:14.000000', 'consum', 0.0222, 'lps'),
	(367450, 125, '2015-01-15 00:35:15.000000', 'consum', 0.0223, 'lps'),
	(367451, 125, '2015-01-15 00:35:16.000000', 'consum', 0.0224, 'lps'),
	(367452, 125, '2015-01-15 00:35:17.000000', 'consum', 0.0223, 'lps'),
	(367453, 125, '2015-01-15 00:35:18.000000', 'consum', 0.0219, 'lps'),
	(367454, 125, '2015-01-15 00:35:19.000000', 'consum', 0.0214, 'lps'),
	(367455, 125, '2015-01-15 00:35:20.000000', 'consum', 0.0219, 'lps'),
	(367456, 125, '2015-01-15 00:35:21.000000', 'consum', 0.0213, 'lps'),
	(367457, 125, '2015-01-15 00:35:22.000000', 'consum', 0.0213, 'lps'),
	(367458, 125, '2015-01-15 00:35:23.000000', 'consum', 0.0219, 'lps'),
	(367459, 125, '2015-01-15 00:35:24.000000', 'consum', 0.0211, 'lps'),
	(367460, 125, '2015-01-15 00:35:25.000000', 'consum', 0.0225, 'lps'),
	(367461, 125, '2015-01-15 00:35:26.000000', 'consum', 0.0211, 'lps'),
	(367462, 125, '2015-01-15 00:35:27.000000', 'consum', 0.0224, 'lps'),
	(367463, 125, '2015-01-15 00:35:28.000000', 'consum', 0.0224, 'lps'),
	(367464, 125, '2015-01-15 00:35:29.000000', 'consum', 0.0223, 'lps'),
	(367465, 125, '2015-01-15 00:35:30.000000', 'consum', 0.0218, 'lps'),
	(367466, 125, '2015-01-15 00:35:31.000000', 'consum', 0.0226, 'lps'),
	(367467, 125, '2015-01-15 00:35:32.000000', 'consum', 0.0217, 'lps'),
	(367468, 125, '2015-01-15 00:35:33.000000', 'consum', 0.0212, 'lps'),
	(367469, 125, '2015-01-15 00:35:34.000000', 'consum', 0.0218, 'lps'),
	(367470, 125, '2015-01-15 00:35:35.000000', 'consum', 0.0211, 'lps'),
	(367471, 125, '2015-01-15 00:35:36.000000', 'consum', 0.0224, 'lps'),
	(367472, 125, '2015-01-15 00:35:37.000000', 'consum', 0.0210, 'lps'),
	(367473, 125, '2015-01-15 00:35:38.000000', 'consum', 0.0220, 'lps'),
	(367474, 125, '2015-01-15 00:35:39.000000', 'consum', 0.0225, 'lps'),
	(367475, 125, '2015-01-15 00:35:40.000000', 'consum', 0.0224, 'lps'),
	(367476, 125, '2015-01-15 00:35:41.000000', 'consum', 0.0216, 'lps'),
	(367477, 125, '2015-01-15 00:35:42.000000', 'consum', 0.0215, 'lps'),
	(367478, 125, '2015-01-15 00:35:43.000000', 'consum', 0.0218, 'lps'),
	(367479, 125, '2015-01-15 00:35:44.000000', 'consum', 0.0218, 'lps'),
	(367480, 125, '2015-01-15 00:35:45.000000', 'consum', 0.0211, 'lps'),
	(367481, 125, '2015-01-15 00:35:46.000000', 'consum', 0.0223, 'lps'),
	(367482, 125, '2015-01-15 00:35:47.000000', 'consum', 0.0224, 'lps'),
	(367483, 125, '2015-01-15 00:35:48.000000', 'consum', 0.0223, 'lps'),
	(367484, 125, '2015-01-15 00:35:49.000000', 'consum', 0.0218, 'lps'),
	(367485, 125, '2015-01-15 00:35:50.000000', 'consum', 0.0211, 'lps'),
	(367486, 125, '2015-01-15 00:35:51.000000', 'consum', 0.0226, 'lps'),
	(367487, 125, '2015-01-15 00:35:52.000000', 'consum', 0.0219, 'lps'),
	(367488, 125, '2015-01-15 00:35:53.000000', 'consum', 0.0223, 'lps'),
	(367489, 125, '2015-01-15 00:35:54.000000', 'consum', 0.0215, 'lps'),
	(367490, 125, '2015-01-15 00:35:55.000000', 'consum', 0.0215, 'lps'),
	(367491, 125, '2015-01-15 00:35:56.000000', 'consum', 0.0221, 'lps'),
	(367492, 125, '2015-01-15 00:35:57.000000', 'consum', 0.0218, 'lps'),
	(367493, 125, '2015-01-15 00:35:58.000000', 'consum', 0.0214, 'lps'),
	(367494, 125, '2015-01-15 00:35:59.000000', 'consum', 0.0225, 'lps'),
	(367495, 125, '2015-01-15 00:36:00.000000', 'consum', 0.0222, 'lps'),
	(367496, 125, '2015-01-15 00:36:01.000000', 'consum', 0.0211, 'lps'),
	(367497, 125, '2015-01-15 00:36:02.000000', 'consum', 0.0210, 'lps'),
	(367498, 125, '2015-01-15 00:36:03.000000', 'consum', 0.0226, 'lps'),
	(367499, 125, '2015-01-15 00:36:04.000000', 'consum', 0.0224, 'lps'),
	(367500, 125, '2015-01-15 00:36:05.000000', 'consum', 0.0216, 'lps'),
	(367501, 125, '2015-01-15 00:36:06.000000', 'consum', 0.0216, 'lps'),
	(367502, 125, '2015-01-15 00:36:07.000000', 'consum', 0.0221, 'lps'),
	(367503, 125, '2015-01-15 00:36:08.000000', 'consum', 0.0212, 'lps'),
	(367504, 125, '2015-01-15 00:36:09.000000', 'consum', 0.0224, 'lps'),
	(367505, 125, '2015-01-15 00:36:10.000000', 'consum', 0.0221, 'lps'),
	(367506, 125, '2015-01-15 00:36:11.000000', 'consum', 0.0223, 'lps'),
	(367507, 125, '2015-01-15 00:36:12.000000', 'consum', 0.0210, 'lps'),
	(367508, 125, '2015-01-15 00:36:13.000000', 'consum', 0.0222, 'lps'),
	(367509, 125, '2015-01-15 00:36:14.000000', 'consum', 0.0221, 'lps'),
	(367510, 125, '2015-01-15 00:36:15.000000', 'consum', 0.0212, 'lps'),
	(367511, 125, '2015-01-15 00:36:16.000000', 'consum', 0.0221, 'lps'),
	(367512, 125, '2015-01-15 00:36:17.000000', 'consum', 0.0225, 'lps'),
	(367513, 125, '2015-01-15 00:36:18.000000', 'consum', 0.0217, 'lps'),
	(367514, 125, '2015-01-15 00:36:19.000000', 'consum', 0.0219, 'lps'),
	(367515, 125, '2015-01-15 00:36:20.000000', 'consum', 0.0217, 'lps'),
	(367516, 125, '2015-01-15 00:36:21.000000', 'consum', 0.0219, 'lps'),
	(367517, 125, '2015-01-15 00:36:22.000000', 'consum', 0.0219, 'lps'),
	(367518, 125, '2015-01-15 00:36:23.000000', 'consum', 0.0226, 'lps'),
	(367519, 125, '2015-01-15 00:36:24.000000', 'consum', 0.0212, 'lps'),
	(367520, 125, '2015-01-15 00:36:25.000000', 'consum', 0.0223, 'lps'),
	(367521, 125, '2015-01-15 00:36:26.000000', 'consum', 0.0220, 'lps'),
	(367522, 125, '2015-01-15 00:36:27.000000', 'consum', 0.0222, 'lps'),
	(367523, 125, '2015-01-15 00:36:28.000000', 'consum', 0.0223, 'lps'),
	(367524, 125, '2015-01-15 00:36:29.000000', 'consum', 0.0224, 'lps'),
	(367525, 125, '2015-01-15 00:36:30.000000', 'consum', 0.0224, 'lps'),
	(367526, 125, '2015-01-15 00:36:31.000000', 'consum', 0.0220, 'lps'),
	(367527, 125, '2015-01-15 00:36:32.000000', 'consum', 0.0220, 'lps'),
	(367528, 125, '2015-01-15 00:36:33.000000', 'consum', 0.0213, 'lps'),
	(367529, 125, '2015-01-15 00:36:34.000000', 'consum', 0.0211, 'lps'),
	(367530, 125, '2015-01-15 00:36:35.000000', 'consum', 0.0223, 'lps'),
	(367531, 125, '2015-01-15 00:36:36.000000', 'consum', 0.0223, 'lps'),
	(367532, 125, '2015-01-15 00:36:37.000000', 'consum', 0.0220, 'lps'),
	(367533, 125, '2015-01-15 00:36:38.000000', 'consum', 0.0219, 'lps'),
	(367534, 125, '2015-01-15 00:36:39.000000', 'consum', 0.0226, 'lps'),
	(367535, 125, '2015-01-15 00:36:40.000000', 'consum', 0.0214, 'lps'),
	(367536, 125, '2015-01-15 00:36:41.000000', 'consum', 0.0214, 'lps'),
	(367537, 125, '2015-01-15 00:36:42.000000', 'consum', 0.0221, 'lps'),
	(367538, 125, '2015-01-15 00:36:43.000000', 'consum', 0.0220, 'lps'),
	(367539, 125, '2015-01-15 00:36:44.000000', 'consum', 0.0211, 'lps'),
	(367540, 125, '2015-01-15 00:36:45.000000', 'consum', 0.0219, 'lps'),
	(367541, 125, '2015-01-15 00:36:46.000000', 'consum', 0.0219, 'lps'),
	(367542, 125, '2015-01-15 00:36:47.000000', 'consum', 0.0213, 'lps'),
	(367543, 125, '2015-01-15 00:36:48.000000', 'consum', 0.0214, 'lps'),
	(367544, 125, '2015-01-15 00:36:49.000000', 'consum', 0.0220, 'lps'),
	(367545, 125, '2015-01-15 00:36:50.000000', 'consum', 0.0215, 'lps'),
	(367546, 125, '2015-01-15 00:36:51.000000', 'consum', 0.0224, 'lps'),
	(367547, 125, '2015-01-15 00:36:52.000000', 'consum', 0.0213, 'lps'),
	(367548, 125, '2015-01-15 00:36:53.000000', 'consum', 0.0217, 'lps'),
	(367549, 125, '2015-01-15 00:36:54.000000', 'consum', 0.0220, 'lps'),
	(367550, 125, '2015-01-15 00:36:55.000000', 'consum', 0.0222, 'lps'),
	(367551, 125, '2015-01-15 00:36:56.000000', 'consum', 0.0223, 'lps'),
	(367552, 125, '2015-01-15 00:36:57.000000', 'consum', 0.0224, 'lps'),
	(367553, 125, '2015-01-15 00:36:58.000000', 'consum', 0.0222, 'lps'),
	(367554, 125, '2015-01-15 00:36:59.000000', 'consum', 0.0212, 'lps'),
	(367555, 125, '2015-01-15 00:37:00.000000', 'consum', 0.0220, 'lps'),
	(367556, 125, '2015-01-15 00:37:01.000000', 'consum', 0.0218, 'lps'),
	(367557, 125, '2015-01-15 00:37:02.000000', 'consum', 0.0223, 'lps'),
	(367558, 125, '2015-01-15 00:37:03.000000', 'consum', 0.0217, 'lps'),
	(367559, 125, '2015-01-15 00:37:04.000000', 'consum', 0.0222, 'lps'),
	(367560, 125, '2015-01-15 00:37:05.000000', 'consum', 0.0215, 'lps'),
	(367561, 125, '2015-01-15 00:37:06.000000', 'consum', 0.0217, 'lps'),
	(367562, 125, '2015-01-15 00:37:07.000000', 'consum', 0.0215, 'lps'),
	(367563, 125, '2015-01-15 00:37:08.000000', 'consum', 0.0214, 'lps'),
	(367564, 125, '2015-01-15 00:37:09.000000', 'consum', 0.0216, 'lps'),
	(367565, 125, '2015-01-15 00:37:10.000000', 'consum', 0.0213, 'lps'),
	(367566, 125, '2015-01-15 00:37:11.000000', 'consum', 0.0221, 'lps'),
	(367567, 125, '2015-01-15 00:37:12.000000', 'consum', 0.0225, 'lps'),
	(367568, 125, '2015-01-15 00:37:13.000000', 'consum', 0.0220, 'lps'),
	(367569, 125, '2015-01-15 00:37:14.000000', 'consum', 0.0212, 'lps'),
	(367570, 125, '2015-01-15 00:37:15.000000', 'consum', 0.0225, 'lps'),
	(367571, 125, '2015-01-15 00:37:16.000000', 'consum', 0.0212, 'lps'),
	(367572, 125, '2015-01-15 00:37:17.000000', 'consum', 0.0210, 'lps'),
	(367573, 125, '2015-01-15 00:37:18.000000', 'consum', 0.0223, 'lps'),
	(367574, 125, '2015-01-15 00:37:19.000000', 'consum', 0.0225, 'lps'),
	(367575, 125, '2015-01-15 00:37:20.000000', 'consum', 0.0226, 'lps'),
	(367576, 125, '2015-01-15 00:37:21.000000', 'consum', 0.0215, 'lps'),
	(367577, 125, '2015-01-15 00:37:22.000000', 'consum', 0.0220, 'lps'),
	(367578, 125, '2015-01-15 00:37:23.000000', 'consum', 0.0211, 'lps'),
	(367579, 125, '2015-01-15 00:37:24.000000', 'consum', 0.0221, 'lps'),
	(367580, 125, '2015-01-15 00:37:25.000000', 'consum', 0.0210, 'lps'),
	(367581, 125, '2015-01-15 00:37:26.000000', 'consum', 0.0211, 'lps'),
	(367582, 125, '2015-01-15 00:37:27.000000', 'consum', 0.0214, 'lps'),
	(367583, 125, '2015-01-15 00:37:28.000000', 'consum', 0.0213, 'lps'),
	(367584, 125, '2015-01-15 00:37:29.000000', 'consum', 0.0215, 'lps'),
	(367585, 125, '2015-01-15 00:37:30.000000', 'consum', 0.0223, 'lps'),
	(367586, 125, '2015-01-15 00:37:31.000000', 'consum', 0.0212, 'lps'),
	(367587, 125, '2015-01-15 00:37:32.000000', 'consum', 0.0213, 'lps'),
	(367588, 125, '2015-01-15 00:37:33.000000', 'consum', 0.0222, 'lps'),
	(367589, 125, '2015-01-15 00:37:34.000000', 'consum', 0.0211, 'lps'),
	(367590, 125, '2015-01-15 00:37:35.000000', 'consum', 0.0214, 'lps'),
	(367591, 125, '2015-01-15 00:37:36.000000', 'consum', 0.0211, 'lps'),
	(367592, 125, '2015-01-15 00:37:37.000000', 'consum', 0.0220, 'lps'),
	(367593, 125, '2015-01-15 00:37:38.000000', 'consum', 0.0223, 'lps'),
	(367594, 125, '2015-01-15 00:37:39.000000', 'consum', 0.0212, 'lps'),
	(367595, 125, '2015-01-15 00:37:40.000000', 'consum', 0.0216, 'lps'),
	(367596, 125, '2015-01-15 00:37:41.000000', 'consum', 0.0216, 'lps'),
	(367597, 125, '2015-01-15 00:37:42.000000', 'consum', 0.0223, 'lps'),
	(367598, 125, '2015-01-15 00:37:43.000000', 'consum', 0.0226, 'lps'),
	(367599, 125, '2015-01-15 00:37:44.000000', 'consum', 0.0214, 'lps'),
	(367600, 125, '2015-01-15 00:37:45.000000', 'consum', 0.0220, 'lps'),
	(367601, 125, '2015-01-15 00:37:46.000000', 'consum', 0.0211, 'lps'),
	(367602, 125, '2015-01-15 00:37:47.000000', 'consum', 0.0220, 'lps'),
	(367603, 125, '2015-01-15 00:37:48.000000', 'consum', 0.0225, 'lps'),
	(367604, 125, '2015-01-15 00:37:49.000000', 'consum', 0.0221, 'lps'),
	(367605, 125, '2015-01-15 00:37:50.000000', 'consum', 0.0220, 'lps'),
	(367606, 125, '2015-01-15 00:37:51.000000', 'consum', 0.0212, 'lps'),
	(367607, 125, '2015-01-15 00:37:52.000000', 'consum', 0.0225, 'lps'),
	(367608, 125, '2015-01-15 00:37:53.000000', 'consum', 0.0210, 'lps'),
	(367609, 125, '2015-01-15 00:37:54.000000', 'consum', 0.0219, 'lps'),
	(367610, 125, '2015-01-15 00:37:55.000000', 'consum', 0.0220, 'lps'),
	(367611, 125, '2015-01-15 00:37:56.000000', 'consum', 0.0215, 'lps'),
	(367612, 125, '2015-01-15 00:37:57.000000', 'consum', 0.0224, 'lps'),
	(367613, 125, '2015-01-15 00:37:58.000000', 'consum', 0.0214, 'lps'),
	(367614, 125, '2015-01-15 00:37:59.000000', 'consum', 0.0223, 'lps'),
	(367615, 125, '2015-01-15 00:38:00.000000', 'consum', 0.0211, 'lps'),
	(367616, 125, '2015-01-15 00:38:01.000000', 'consum', 0.0213, 'lps'),
	(367617, 125, '2015-01-15 00:38:02.000000', 'consum', 0.0222, 'lps'),
	(367618, 125, '2015-01-15 00:38:03.000000', 'consum', 0.0212, 'lps'),
	(367619, 125, '2015-01-15 00:38:04.000000', 'consum', 0.0217, 'lps'),
	(367620, 125, '2015-01-15 00:38:05.000000', 'consum', 0.0221, 'lps'),
	(367621, 125, '2015-01-15 00:38:06.000000', 'consum', 0.0210, 'lps'),
	(367622, 125, '2015-01-15 00:38:07.000000', 'consum', 0.0213, 'lps'),
	(367623, 125, '2015-01-15 00:38:08.000000', 'consum', 0.0226, 'lps'),
	(367624, 125, '2015-01-15 00:38:09.000000', 'consum', 0.0214, 'lps'),
	(367625, 125, '2015-01-15 00:38:10.000000', 'consum', 0.0218, 'lps'),
	(367626, 125, '2015-01-15 00:38:11.000000', 'consum', 0.0219, 'lps'),
	(367627, 125, '2015-01-15 00:38:12.000000', 'consum', 0.0213, 'lps'),
	(367628, 125, '2015-01-15 00:38:13.000000', 'consum', 0.0219, 'lps'),
	(367629, 125, '2015-01-15 00:38:14.000000', 'consum', 0.0211, 'lps'),
	(367630, 125, '2015-01-15 00:38:15.000000', 'consum', 0.0220, 'lps'),
	(367631, 125, '2015-01-15 00:38:16.000000', 'consum', 0.0210, 'lps'),
	(367632, 125, '2015-01-15 00:38:17.000000', 'consum', 0.0214, 'lps'),
	(367633, 125, '2015-01-15 00:38:18.000000', 'consum', 0.0214, 'lps'),
	(367634, 125, '2015-01-15 00:38:19.000000', 'consum', 0.0216, 'lps'),
	(367635, 125, '2015-01-15 00:38:20.000000', 'consum', 0.0214, 'lps'),
	(367636, 125, '2015-01-15 00:38:21.000000', 'consum', 0.0213, 'lps'),
	(367637, 125, '2015-01-15 00:38:22.000000', 'consum', 0.0213, 'lps'),
	(367638, 125, '2015-01-15 00:38:23.000000', 'consum', 0.0214, 'lps'),
	(367639, 125, '2015-01-15 00:38:24.000000', 'consum', 0.0225, 'lps'),
	(367640, 125, '2015-01-15 00:38:25.000000', 'consum', 0.0222, 'lps'),
	(367641, 125, '2015-01-15 00:38:26.000000', 'consum', 0.0224, 'lps'),
	(367642, 125, '2015-01-15 00:38:27.000000', 'consum', 0.0213, 'lps'),
	(367643, 125, '2015-01-15 00:38:28.000000', 'consum', 0.0214, 'lps'),
	(367644, 125, '2015-01-15 00:38:29.000000', 'consum', 0.0224, 'lps'),
	(367645, 125, '2015-01-15 00:38:30.000000', 'consum', 0.0215, 'lps'),
	(367646, 125, '2015-01-15 00:38:31.000000', 'consum', 0.0213, 'lps'),
	(367647, 125, '2015-01-15 00:38:32.000000', 'consum', 0.0211, 'lps'),
	(367648, 125, '2015-01-15 00:38:33.000000', 'consum', 0.0221, 'lps'),
	(367649, 125, '2015-01-15 00:38:34.000000', 'consum', 0.0210, 'lps'),
	(367650, 125, '2015-01-15 00:38:35.000000', 'consum', 0.0215, 'lps'),
	(367651, 125, '2015-01-15 00:38:36.000000', 'consum', 0.0218, 'lps'),
	(367652, 125, '2015-01-15 00:38:37.000000', 'consum', 0.0219, 'lps'),
	(367653, 125, '2015-01-15 00:38:38.000000', 'consum', 0.0215, 'lps'),
	(367654, 125, '2015-01-15 00:38:39.000000', 'consum', 0.0210, 'lps'),
	(367655, 125, '2015-01-15 00:38:40.000000', 'consum', 0.0210, 'lps'),
	(367656, 125, '2015-01-15 00:38:41.000000', 'consum', 0.0210, 'lps'),
	(367657, 125, '2015-01-15 00:38:42.000000', 'consum', 0.0211, 'lps'),
	(367658, 125, '2015-01-15 00:38:43.000000', 'consum', 0.0217, 'lps'),
	(367659, 125, '2015-01-15 00:38:44.000000', 'consum', 0.0224, 'lps'),
	(367660, 125, '2015-01-15 00:38:45.000000', 'consum', 0.0226, 'lps'),
	(367661, 125, '2015-01-15 00:38:46.000000', 'consum', 0.0214, 'lps'),
	(367662, 125, '2015-01-15 00:38:47.000000', 'consum', 0.0215, 'lps'),
	(367663, 125, '2015-01-15 00:38:48.000000', 'consum', 0.0226, 'lps'),
	(367664, 125, '2015-01-15 00:38:49.000000', 'consum', 0.0222, 'lps'),
	(367665, 125, '2015-01-15 00:38:50.000000', 'consum', 0.0224, 'lps'),
	(367666, 125, '2015-01-15 00:38:51.000000', 'consum', 0.0212, 'lps'),
	(367667, 125, '2015-01-15 00:38:52.000000', 'consum', 0.0212, 'lps'),
	(367668, 125, '2015-01-15 00:38:53.000000', 'consum', 0.0213, 'lps'),
	(367669, 125, '2015-01-15 00:38:54.000000', 'consum', 0.0220, 'lps'),
	(367670, 125, '2015-01-15 00:38:55.000000', 'consum', 0.0217, 'lps'),
	(367671, 125, '2015-01-15 00:38:56.000000', 'consum', 0.0215, 'lps'),
	(367672, 125, '2015-01-15 00:38:57.000000', 'consum', 0.0217, 'lps'),
	(367673, 125, '2015-01-15 00:38:58.000000', 'consum', 0.0213, 'lps'),
	(367674, 125, '2015-01-15 00:38:59.000000', 'consum', 0.0220, 'lps'),
	(367675, 125, '2015-01-15 00:39:00.000000', 'consum', 0.0216, 'lps'),
	(367676, 125, '2015-01-15 00:39:01.000000', 'consum', 0.0214, 'lps'),
	(367677, 125, '2015-01-15 00:39:02.000000', 'consum', 0.0211, 'lps'),
	(367678, 125, '2015-01-15 00:39:03.000000', 'consum', 0.0219, 'lps'),
	(367679, 125, '2015-01-15 00:39:04.000000', 'consum', 0.0220, 'lps'),
	(367680, 125, '2015-01-15 00:39:05.000000', 'consum', 0.0215, 'lps'),
	(367681, 125, '2015-01-15 00:39:06.000000', 'consum', 0.0221, 'lps'),
	(367682, 125, '2015-01-15 00:39:07.000000', 'consum', 0.0220, 'lps'),
	(367683, 125, '2015-01-15 00:39:08.000000', 'consum', 0.0225, 'lps'),
	(367684, 125, '2015-01-15 00:39:09.000000', 'consum', 0.0222, 'lps'),
	(367685, 125, '2015-01-15 00:39:10.000000', 'consum', 0.0224, 'lps'),
	(367686, 125, '2015-01-15 00:39:11.000000', 'consum', 0.0213, 'lps'),
	(367687, 125, '2015-01-15 00:39:12.000000', 'consum', 0.0215, 'lps'),
	(367688, 125, '2015-01-15 00:39:13.000000', 'consum', 0.0210, 'lps'),
	(367689, 125, '2015-01-15 00:39:14.000000', 'consum', 0.0214, 'lps'),
	(367690, 125, '2015-01-15 00:39:15.000000', 'consum', 0.0212, 'lps'),
	(367691, 125, '2015-01-15 00:39:16.000000', 'consum', 0.0225, 'lps'),
	(367692, 125, '2015-01-15 00:39:17.000000', 'consum', 0.0210, 'lps'),
	(367693, 125, '2015-01-15 00:39:18.000000', 'consum', 0.0220, 'lps'),
	(367694, 125, '2015-01-15 00:39:19.000000', 'consum', 0.0223, 'lps'),
	(367695, 125, '2015-01-15 00:39:20.000000', 'consum', 0.0213, 'lps'),
	(367696, 125, '2015-01-15 00:39:21.000000', 'consum', 0.0220, 'lps'),
	(367697, 125, '2015-01-15 00:39:22.000000', 'consum', 0.0220, 'lps'),
	(367698, 125, '2015-01-15 00:39:23.000000', 'consum', 0.0212, 'lps'),
	(367699, 125, '2015-01-15 00:39:24.000000', 'consum', 0.0223, 'lps'),
	(367700, 125, '2015-01-15 00:39:25.000000', 'consum', 0.0222, 'lps'),
	(367701, 125, '2015-01-15 00:39:26.000000', 'consum', 0.0211, 'lps'),
	(367702, 125, '2015-01-15 00:39:27.000000', 'consum', 0.0214, 'lps'),
	(367703, 125, '2015-01-15 00:39:28.000000', 'consum', 0.0226, 'lps'),
	(367704, 125, '2015-01-15 00:39:29.000000', 'consum', 0.0212, 'lps'),
	(367705, 125, '2015-01-15 00:39:30.000000', 'consum', 0.0224, 'lps'),
	(367706, 125, '2015-01-15 00:39:31.000000', 'consum', 0.0223, 'lps'),
	(367707, 125, '2015-01-15 00:39:32.000000', 'consum', 0.0217, 'lps'),
	(367708, 125, '2015-01-15 00:39:33.000000', 'consum', 0.0225, 'lps'),
	(367709, 125, '2015-01-15 00:39:34.000000', 'consum', 0.0212, 'lps'),
	(367710, 125, '2015-01-15 00:39:35.000000', 'consum', 0.0225, 'lps'),
	(367711, 125, '2015-01-15 00:39:36.000000', 'consum', 0.0211, 'lps'),
	(367712, 125, '2015-01-15 00:39:37.000000', 'consum', 0.0225, 'lps'),
	(367713, 125, '2015-01-15 00:39:38.000000', 'consum', 0.0212, 'lps'),
	(367714, 125, '2015-01-15 00:39:39.000000', 'consum', 0.0210, 'lps'),
	(367715, 125, '2015-01-15 00:39:40.000000', 'consum', 0.0222, 'lps'),
	(367716, 125, '2015-01-15 00:39:41.000000', 'consum', 0.0218, 'lps'),
	(367717, 125, '2015-01-15 00:39:42.000000', 'consum', 0.0217, 'lps'),
	(367718, 125, '2015-01-15 00:39:43.000000', 'consum', 0.0222, 'lps'),
	(367719, 125, '2015-01-15 00:39:44.000000', 'consum', 0.0214, 'lps'),
	(367720, 125, '2015-01-15 00:39:45.000000', 'consum', 0.0213, 'lps'),
	(367721, 125, '2015-01-15 00:39:46.000000', 'consum', 0.0213, 'lps'),
	(367722, 125, '2015-01-15 00:39:47.000000', 'consum', 0.0217, 'lps'),
	(367723, 125, '2015-01-15 00:39:48.000000', 'consum', 0.0218, 'lps'),
	(367724, 125, '2015-01-15 00:39:49.000000', 'consum', 0.0215, 'lps'),
	(367725, 125, '2015-01-15 00:39:50.000000', 'consum', 0.0211, 'lps'),
	(367726, 125, '2015-01-15 00:39:51.000000', 'consum', 0.0218, 'lps'),
	(367727, 125, '2015-01-15 00:39:52.000000', 'consum', 0.0214, 'lps'),
	(367728, 125, '2015-01-15 00:39:53.000000', 'consum', 0.0222, 'lps'),
	(367729, 125, '2015-01-15 00:39:54.000000', 'consum', 0.0223, 'lps'),
	(367730, 125, '2015-01-15 00:39:55.000000', 'consum', 0.0225, 'lps'),
	(367731, 125, '2015-01-15 00:39:56.000000', 'consum', 0.0211, 'lps'),
	(367732, 125, '2015-01-15 00:39:57.000000', 'consum', 0.0222, 'lps'),
	(367733, 125, '2015-01-15 00:39:58.000000', 'consum', 0.0215, 'lps'),
	(367734, 125, '2015-01-15 00:39:59.000000', 'consum', 0.0218, 'lps'),
	(367735, 125, '2015-01-15 00:40:00.000000', 'consum', 0.0219, 'lps'),
	(367736, 125, '2015-01-15 00:40:01.000000', 'consum', 0.0213, 'lps'),
	(367737, 125, '2015-01-15 00:40:02.000000', 'consum', 0.0216, 'lps'),
	(367738, 125, '2015-01-15 00:40:03.000000', 'consum', 0.0213, 'lps'),
	(367739, 125, '2015-01-15 00:40:04.000000', 'consum', 0.0211, 'lps'),
	(367740, 125, '2015-01-15 00:40:05.000000', 'consum', 0.0220, 'lps'),
	(367741, 125, '2015-01-15 00:40:06.000000', 'consum', 0.0225, 'lps'),
	(367742, 125, '2015-01-15 00:40:07.000000', 'consum', 0.0223, 'lps'),
	(367743, 125, '2015-01-15 00:40:08.000000', 'consum', 0.0211, 'lps'),
	(367744, 125, '2015-01-15 00:40:09.000000', 'consum', 0.0212, 'lps'),
	(367745, 125, '2015-01-15 00:40:10.000000', 'consum', 0.0216, 'lps'),
	(367746, 125, '2015-01-15 00:40:11.000000', 'consum', 0.0220, 'lps'),
	(367747, 125, '2015-01-15 00:40:12.000000', 'consum', 0.0225, 'lps'),
	(367748, 125, '2015-01-15 00:40:13.000000', 'consum', 0.0223, 'lps'),
	(367749, 125, '2015-01-15 00:40:14.000000', 'consum', 0.0211, 'lps'),
	(367750, 125, '2015-01-15 00:40:15.000000', 'consum', 0.0213, 'lps'),
	(367751, 125, '2015-01-15 00:40:16.000000', 'consum', 0.0223, 'lps'),
	(367752, 125, '2015-01-15 00:40:17.000000', 'consum', 0.0215, 'lps'),
	(367753, 125, '2015-01-15 00:40:18.000000', 'consum', 0.0211, 'lps'),
	(367754, 125, '2015-01-15 00:40:19.000000', 'consum', 0.0219, 'lps'),
	(367755, 125, '2015-01-15 00:40:20.000000', 'consum', 0.0220, 'lps'),
	(367756, 125, '2015-01-15 00:40:21.000000', 'consum', 0.0214, 'lps'),
	(367757, 125, '2015-01-15 00:40:22.000000', 'consum', 0.0219, 'lps'),
	(367758, 125, '2015-01-15 00:40:23.000000', 'consum', 0.0211, 'lps'),
	(367759, 125, '2015-01-15 00:40:24.000000', 'consum', 0.0219, 'lps'),
	(367760, 125, '2015-01-15 00:40:25.000000', 'consum', 0.0222, 'lps'),
	(367761, 125, '2015-01-15 00:40:26.000000', 'consum', 0.0224, 'lps'),
	(367762, 125, '2015-01-15 00:40:27.000000', 'consum', 0.0213, 'lps'),
	(367763, 125, '2015-01-15 00:40:28.000000', 'consum', 0.0215, 'lps'),
	(367764, 125, '2015-01-15 00:40:29.000000', 'consum', 0.0212, 'lps'),
	(367765, 125, '2015-01-15 00:40:30.000000', 'consum', 0.0220, 'lps'),
	(367766, 125, '2015-01-15 00:40:31.000000', 'consum', 0.0222, 'lps'),
	(367767, 125, '2015-01-15 00:40:32.000000', 'consum', 0.0222, 'lps'),
	(367768, 125, '2015-01-15 00:40:33.000000', 'consum', 0.0218, 'lps'),
	(367769, 125, '2015-01-15 00:40:34.000000', 'consum', 0.0214, 'lps'),
	(367770, 125, '2015-01-15 00:40:35.000000', 'consum', 0.0223, 'lps'),
	(367771, 125, '2015-01-15 00:40:36.000000', 'consum', 0.0213, 'lps'),
	(367772, 125, '2015-01-15 00:40:37.000000', 'consum', 0.0222, 'lps'),
	(367773, 125, '2015-01-15 00:40:38.000000', 'consum', 0.0225, 'lps'),
	(367774, 125, '2015-01-15 00:40:39.000000', 'consum', 0.0219, 'lps'),
	(367775, 125, '2015-01-15 00:40:40.000000', 'consum', 0.0225, 'lps'),
	(367776, 125, '2015-01-15 00:40:41.000000', 'consum', 0.0223, 'lps'),
	(367777, 125, '2015-01-15 00:40:42.000000', 'consum', 0.0217, 'lps'),
	(367778, 125, '2015-01-15 00:40:43.000000', 'consum', 0.0221, 'lps'),
	(367779, 125, '2015-01-15 00:40:44.000000', 'consum', 0.0210, 'lps'),
	(367780, 125, '2015-01-15 00:40:45.000000', 'consum', 0.0213, 'lps'),
	(367781, 125, '2015-01-15 00:40:46.000000', 'consum', 0.0210, 'lps'),
	(367782, 125, '2015-01-15 00:40:47.000000', 'consum', 0.0217, 'lps'),
	(367783, 125, '2015-01-15 00:40:48.000000', 'consum', 0.0210, 'lps'),
	(367784, 125, '2015-01-15 00:40:49.000000', 'consum', 0.0223, 'lps'),
	(367785, 125, '2015-01-15 00:40:50.000000', 'consum', 0.0224, 'lps'),
	(367786, 125, '2015-01-15 00:40:51.000000', 'consum', 0.0210, 'lps'),
	(367787, 125, '2015-01-15 00:40:52.000000', 'consum', 0.0220, 'lps'),
	(367788, 125, '2015-01-15 00:40:53.000000', 'consum', 0.0210, 'lps'),
	(367789, 125, '2015-01-15 00:40:54.000000', 'consum', 0.0212, 'lps'),
	(367790, 125, '2015-01-15 00:40:55.000000', 'consum', 0.0222, 'lps'),
	(367791, 125, '2015-01-15 00:40:56.000000', 'consum', 0.0214, 'lps'),
	(367792, 125, '2015-01-15 00:40:57.000000', 'consum', 0.0212, 'lps'),
	(367793, 125, '2015-01-15 00:40:58.000000', 'consum', 0.0226, 'lps'),
	(367794, 125, '2015-01-15 00:40:59.000000', 'consum', 0.0217, 'lps'),
	(367795, 125, '2015-01-15 00:41:00.000000', 'consum', 0.0213, 'lps'),
	(367796, 125, '2015-01-15 00:41:01.000000', 'consum', 0.0224, 'lps'),
	(367797, 125, '2015-01-15 00:41:02.000000', 'consum', 0.0218, 'lps'),
	(367798, 125, '2015-01-15 00:41:03.000000', 'consum', 0.0224, 'lps'),
	(367799, 125, '2015-01-15 00:41:04.000000', 'consum', 0.0226, 'lps'),
	(367800, 125, '2015-01-15 00:41:05.000000', 'consum', 0.0211, 'lps'),
	(367801, 125, '2015-01-15 00:41:06.000000', 'consum', 0.0220, 'lps'),
	(367802, 125, '2015-01-15 00:41:07.000000', 'consum', 0.0224, 'lps'),
	(367803, 125, '2015-01-15 00:41:08.000000', 'consum', 0.0214, 'lps'),
	(367804, 125, '2015-01-15 00:41:09.000000', 'consum', 0.0225, 'lps'),
	(367805, 125, '2015-01-15 00:41:10.000000', 'consum', 0.0224, 'lps'),
	(367806, 125, '2015-01-15 00:41:11.000000', 'consum', 0.0216, 'lps'),
	(367807, 125, '2015-01-15 00:41:12.000000', 'consum', 0.0217, 'lps'),
	(367808, 125, '2015-01-15 00:41:13.000000', 'consum', 0.0211, 'lps'),
	(367809, 125, '2015-01-15 00:41:14.000000', 'consum', 0.0210, 'lps'),
	(367810, 125, '2015-01-15 00:41:15.000000', 'consum', 0.0223, 'lps'),
	(367811, 125, '2015-01-15 00:41:16.000000', 'consum', 0.0211, 'lps'),
	(367812, 125, '2015-01-15 00:41:17.000000', 'consum', 0.0226, 'lps'),
	(367813, 125, '2015-01-15 00:41:18.000000', 'consum', 0.0220, 'lps'),
	(367814, 125, '2015-01-15 00:41:19.000000', 'consum', 0.0213, 'lps'),
	(367815, 125, '2015-01-15 00:41:20.000000', 'consum', 0.0212, 'lps'),
	(367816, 125, '2015-01-15 00:41:21.000000', 'consum', 0.0211, 'lps'),
	(367817, 125, '2015-01-15 00:41:22.000000', 'consum', 0.0226, 'lps'),
	(367818, 125, '2015-01-15 00:41:23.000000', 'consum', 0.0220, 'lps'),
	(367819, 125, '2015-01-15 00:41:24.000000', 'consum', 0.0213, 'lps'),
	(367820, 125, '2015-01-15 00:41:25.000000', 'consum', 0.0212, 'lps'),
	(367821, 125, '2015-01-15 00:41:26.000000', 'consum', 0.0211, 'lps'),
	(367822, 125, '2015-01-15 00:41:27.000000', 'consum', 0.0210, 'lps'),
	(367823, 125, '2015-01-15 00:41:28.000000', 'consum', 0.0226, 'lps'),
	(367824, 125, '2015-01-15 00:41:29.000000', 'consum', 0.0221, 'lps'),
	(367825, 125, '2015-01-15 00:41:30.000000', 'consum', 0.0219, 'lps'),
	(367826, 125, '2015-01-15 00:41:31.000000', 'consum', 0.0220, 'lps'),
	(367827, 125, '2015-01-15 00:41:32.000000', 'consum', 0.0216, 'lps'),
	(367828, 125, '2015-01-15 00:41:33.000000', 'consum', 0.0211, 'lps'),
	(367829, 125, '2015-01-15 00:41:34.000000', 'consum', 0.0214, 'lps'),
	(367830, 125, '2015-01-15 00:41:35.000000', 'consum', 0.0210, 'lps'),
	(367831, 125, '2015-01-15 00:41:36.000000', 'consum', 0.0215, 'lps'),
	(367832, 125, '2015-01-15 00:41:37.000000', 'consum', 0.0219, 'lps'),
	(367833, 125, '2015-01-15 00:41:38.000000', 'consum', 0.0225, 'lps'),
	(367834, 125, '2015-01-15 00:41:39.000000', 'consum', 0.0225, 'lps'),
	(367835, 125, '2015-01-15 00:41:40.000000', 'consum', 0.0221, 'lps'),
	(367836, 125, '2015-01-15 00:41:41.000000', 'consum', 0.0223, 'lps'),
	(367837, 125, '2015-01-15 00:41:42.000000', 'consum', 0.0210, 'lps'),
	(367838, 125, '2015-01-15 00:41:43.000000', 'consum', 0.0219, 'lps'),
	(367839, 125, '2015-01-15 00:41:44.000000', 'consum', 0.0222, 'lps'),
	(367840, 125, '2015-01-15 00:41:45.000000', 'consum', 0.0226, 'lps'),
	(367841, 125, '2015-01-15 00:41:46.000000', 'consum', 0.0220, 'lps'),
	(367842, 125, '2015-01-15 00:41:47.000000', 'consum', 0.0214, 'lps'),
	(367843, 125, '2015-01-15 00:41:48.000000', 'consum', 0.0215, 'lps'),
	(367844, 125, '2015-01-15 00:41:49.000000', 'consum', 0.0225, 'lps'),
	(367845, 125, '2015-01-15 00:41:50.000000', 'consum', 0.0220, 'lps'),
	(367846, 125, '2015-01-15 00:41:51.000000', 'consum', 0.0215, 'lps'),
	(367847, 125, '2015-01-15 00:41:52.000000', 'consum', 0.0224, 'lps'),
	(367848, 125, '2015-01-15 00:41:53.000000', 'consum', 0.0212, 'lps'),
	(367849, 125, '2015-01-15 00:41:54.000000', 'consum', 0.0213, 'lps'),
	(367850, 125, '2015-01-15 00:41:55.000000', 'consum', 0.0220, 'lps'),
	(367851, 125, '2015-01-15 00:41:56.000000', 'consum', 0.0216, 'lps'),
	(367852, 125, '2015-01-15 00:41:57.000000', 'consum', 0.0213, 'lps'),
	(367853, 125, '2015-01-15 00:41:58.000000', 'consum', 0.0224, 'lps'),
	(367854, 125, '2015-01-15 00:41:59.000000', 'consum', 0.0219, 'lps'),
	(367855, 125, '2015-01-15 00:42:00.000000', 'consum', 0.0214, 'lps'),
	(367856, 125, '2015-01-15 00:42:01.000000', 'consum', 0.0222, 'lps'),
	(367857, 125, '2015-01-15 00:42:02.000000', 'consum', 0.0223, 'lps'),
	(367858, 125, '2015-01-15 00:42:03.000000', 'consum', 0.0225, 'lps'),
	(367859, 125, '2015-01-15 00:42:04.000000', 'consum', 0.0211, 'lps'),
	(367860, 125, '2015-01-15 00:42:05.000000', 'consum', 0.0220, 'lps'),
	(367861, 125, '2015-01-15 00:42:06.000000', 'consum', 0.0224, 'lps'),
	(367862, 125, '2015-01-15 00:42:07.000000', 'consum', 0.0215, 'lps'),
	(367863, 125, '2015-01-15 00:42:08.000000', 'consum', 0.0212, 'lps'),
	(367864, 125, '2015-01-15 00:42:09.000000', 'consum', 0.0221, 'lps'),
	(367865, 125, '2015-01-15 00:42:10.000000', 'consum', 0.0225, 'lps'),
	(367866, 125, '2015-01-15 00:42:11.000000', 'consum', 0.0221, 'lps'),
	(367867, 125, '2015-01-15 00:42:12.000000', 'consum', 0.0218, 'lps'),
	(367868, 125, '2015-01-15 00:42:13.000000', 'consum', 0.0219, 'lps'),
	(367869, 125, '2015-01-15 00:42:14.000000', 'consum', 0.0212, 'lps'),
	(367870, 125, '2015-01-15 00:42:15.000000', 'consum', 0.0213, 'lps'),
	(367871, 125, '2015-01-15 00:42:16.000000', 'consum', 0.0221, 'lps'),
	(367872, 125, '2015-01-15 00:42:17.000000', 'consum', 0.0220, 'lps'),
	(367873, 125, '2015-01-15 00:42:18.000000', 'consum', 0.0212, 'lps'),
	(367874, 125, '2015-01-15 00:42:19.000000', 'consum', 0.0223, 'lps'),
	(367875, 125, '2015-01-15 00:42:20.000000', 'consum', 0.0220, 'lps'),
	(367876, 125, '2015-01-15 00:42:21.000000', 'consum', 0.0220, 'lps'),
	(367877, 125, '2015-01-15 00:42:22.000000', 'consum', 0.0215, 'lps'),
	(367878, 125, '2015-01-15 00:42:23.000000', 'consum', 0.0221, 'lps'),
	(367879, 125, '2015-01-15 00:42:24.000000', 'consum', 0.0216, 'lps'),
	(367880, 125, '2015-01-15 00:42:25.000000', 'consum', 0.0210, 'lps'),
	(367881, 125, '2015-01-15 00:42:26.000000', 'consum', 0.0224, 'lps'),
	(367882, 125, '2015-01-15 00:42:27.000000', 'consum', 0.0214, 'lps'),
	(367883, 125, '2015-01-15 00:42:28.000000', 'consum', 0.0223, 'lps'),
	(367884, 125, '2015-01-15 00:42:29.000000', 'consum', 0.0212, 'lps'),
	(367885, 125, '2015-01-15 00:42:30.000000', 'consum', 0.0216, 'lps'),
	(367886, 125, '2015-01-15 00:42:31.000000', 'consum', 0.0216, 'lps'),
	(367887, 125, '2015-01-15 00:42:32.000000', 'consum', 0.0222, 'lps'),
	(367888, 125, '2015-01-15 00:42:33.000000', 'consum', 0.0218, 'lps'),
	(367889, 125, '2015-01-15 00:42:34.000000', 'consum', 0.0213, 'lps'),
	(367890, 125, '2015-01-15 00:42:35.000000', 'consum', 0.0222, 'lps'),
	(367891, 125, '2015-01-15 00:42:36.000000', 'consum', 0.0210, 'lps'),
	(367892, 125, '2015-01-15 00:42:37.000000', 'consum', 0.0226, 'lps'),
	(367893, 125, '2015-01-15 00:42:38.000000', 'consum', 0.0223, 'lps'),
	(367894, 125, '2015-01-15 00:42:39.000000', 'consum', 0.0211, 'lps'),
	(367895, 125, '2015-01-15 00:42:40.000000', 'consum', 0.0226, 'lps'),
	(367896, 125, '2015-01-15 00:42:41.000000', 'consum', 0.0220, 'lps'),
	(367897, 125, '2015-01-15 00:42:42.000000', 'consum', 0.0211, 'lps'),
	(367898, 125, '2015-01-15 00:42:43.000000', 'consum', 0.0222, 'lps'),
	(367899, 125, '2015-01-15 00:42:44.000000', 'consum', 0.0215, 'lps'),
	(367900, 125, '2015-01-15 00:42:45.000000', 'consum', 0.0217, 'lps'),
	(367901, 125, '2015-01-15 00:42:46.000000', 'consum', 0.0212, 'lps'),
	(367902, 125, '2015-01-15 00:42:47.000000', 'consum', 0.0220, 'lps'),
	(367903, 125, '2015-01-15 00:42:48.000000', 'consum', 0.0217, 'lps'),
	(367904, 125, '2015-01-15 00:42:49.000000', 'consum', 0.0215, 'lps'),
	(367905, 125, '2015-01-15 00:42:50.000000', 'consum', 0.0216, 'lps'),
	(367906, 125, '2015-01-15 00:42:51.000000', 'consum', 0.0224, 'lps'),
	(367907, 125, '2015-01-15 00:42:52.000000', 'consum', 0.0213, 'lps'),
	(367908, 125, '2015-01-15 00:42:53.000000', 'consum', 0.0218, 'lps'),
	(367909, 125, '2015-01-15 00:42:54.000000', 'consum', 0.0223, 'lps'),
	(367910, 125, '2015-01-15 00:42:55.000000', 'consum', 0.0218, 'lps'),
	(367911, 125, '2015-01-15 00:42:56.000000', 'consum', 0.0210, 'lps'),
	(367912, 125, '2015-01-15 00:42:57.000000', 'consum', 0.0222, 'lps'),
	(367913, 125, '2015-01-15 00:42:58.000000', 'consum', 0.0217, 'lps'),
	(367914, 125, '2015-01-15 00:42:59.000000', 'consum', 0.0213, 'lps'),
	(367915, 125, '2015-01-15 00:43:00.000000', 'consum', 0.0220, 'lps'),
	(367916, 125, '2015-01-15 00:43:01.000000', 'consum', 0.0217, 'lps'),
	(367917, 125, '2015-01-15 00:43:02.000000', 'consum', 0.0216, 'lps'),
	(367918, 125, '2015-01-15 00:43:03.000000', 'consum', 0.0220, 'lps'),
	(367919, 125, '2015-01-15 00:43:04.000000', 'consum', 0.0225, 'lps'),
	(367920, 125, '2015-01-15 00:43:05.000000', 'consum', 0.0221, 'lps'),
	(367921, 125, '2015-01-15 00:43:06.000000', 'consum', 0.0219, 'lps'),
	(367922, 125, '2015-01-15 00:43:07.000000', 'consum', 0.0224, 'lps'),
	(367923, 125, '2015-01-15 00:43:08.000000', 'consum', 0.0221, 'lps'),
	(367924, 125, '2015-01-15 00:43:09.000000', 'consum', 0.0224, 'lps'),
	(367925, 125, '2015-01-15 00:43:10.000000', 'consum', 0.0213, 'lps'),
	(367926, 125, '2015-01-15 00:43:11.000000', 'consum', 0.0218, 'lps'),
	(367927, 125, '2015-01-15 00:43:12.000000', 'consum', 0.0224, 'lps'),
	(367928, 125, '2015-01-15 00:43:13.000000', 'consum', 0.0222, 'lps'),
	(367929, 125, '2015-01-15 00:43:14.000000', 'consum', 0.0211, 'lps'),
	(367930, 125, '2015-01-15 00:43:15.000000', 'consum', 0.0212, 'lps'),
	(367931, 125, '2015-01-15 00:43:16.000000', 'consum', 0.0219, 'lps'),
	(367932, 125, '2015-01-15 00:43:17.000000', 'consum', 0.0216, 'lps'),
	(367933, 125, '2015-01-15 00:43:18.000000', 'consum', 0.0213, 'lps'),
	(367934, 125, '2015-01-15 00:43:19.000000', 'consum', 0.0224, 'lps'),
	(367935, 125, '2015-01-15 00:43:20.000000', 'consum', 0.0222, 'lps'),
	(367936, 125, '2015-01-15 00:43:21.000000', 'consum', 0.0212, 'lps'),
	(367937, 125, '2015-01-15 00:43:22.000000', 'consum', 0.0216, 'lps'),
	(367938, 125, '2015-01-15 00:43:23.000000', 'consum', 0.0217, 'lps'),
	(367939, 125, '2015-01-15 00:43:24.000000', 'consum', 0.0214, 'lps'),
	(367940, 125, '2015-01-15 00:43:25.000000', 'consum', 0.0224, 'lps'),
	(367941, 125, '2015-01-15 00:43:26.000000', 'consum', 0.0217, 'lps'),
	(367942, 125, '2015-01-15 00:43:27.000000', 'consum', 0.0220, 'lps'),
	(367943, 125, '2015-01-15 00:43:28.000000', 'consum', 0.0221, 'lps'),
	(367944, 125, '2015-01-15 00:43:29.000000', 'consum', 0.0222, 'lps'),
	(367945, 125, '2015-01-15 00:43:30.000000', 'consum', 0.0218, 'lps'),
	(367946, 125, '2015-01-15 00:43:31.000000', 'consum', 0.0214, 'lps'),
	(367947, 125, '2015-01-15 00:43:32.000000', 'consum', 0.0226, 'lps'),
	(367948, 125, '2015-01-15 00:43:33.000000', 'consum', 0.0210, 'lps'),
	(367949, 125, '2015-01-15 00:43:34.000000', 'consum', 0.0215, 'lps'),
	(367950, 125, '2015-01-15 00:43:35.000000', 'consum', 0.0218, 'lps'),
	(367951, 125, '2015-01-15 00:43:36.000000', 'consum', 0.0218, 'lps'),
	(367952, 125, '2015-01-15 00:43:37.000000', 'consum', 0.0211, 'lps'),
	(367953, 125, '2015-01-15 00:43:38.000000', 'consum', 0.0210, 'lps'),
	(367954, 125, '2015-01-15 00:43:39.000000', 'consum', 0.0221, 'lps'),
	(367955, 125, '2015-01-15 00:43:40.000000', 'consum', 0.0215, 'lps'),
	(367956, 125, '2015-01-15 00:43:41.000000', 'consum', 0.0219, 'lps'),
	(367957, 125, '2015-01-15 00:43:42.000000', 'consum', 0.0223, 'lps'),
	(367958, 125, '2015-01-15 00:43:43.000000', 'consum', 0.0217, 'lps'),
	(367959, 125, '2015-01-15 00:43:44.000000', 'consum', 0.0224, 'lps'),
	(367960, 125, '2015-01-15 00:43:45.000000', 'consum', 0.0223, 'lps'),
	(367961, 125, '2015-01-15 00:43:46.000000', 'consum', 0.0220, 'lps'),
	(367962, 125, '2015-01-15 00:43:47.000000', 'consum', 0.0218, 'lps'),
	(367963, 125, '2015-01-15 00:43:48.000000', 'consum', 0.0220, 'lps'),
	(367964, 125, '2015-01-15 00:43:49.000000', 'consum', 0.0220, 'lps'),
	(367965, 125, '2015-01-15 00:43:50.000000', 'consum', 0.0213, 'lps'),
	(367966, 125, '2015-01-15 00:43:51.000000', 'consum', 0.0214, 'lps'),
	(367967, 125, '2015-01-15 00:43:52.000000', 'consum', 0.0220, 'lps'),
	(367968, 125, '2015-01-15 00:43:53.000000', 'consum', 0.0214, 'lps'),
	(367969, 125, '2015-01-15 00:43:54.000000', 'consum', 0.0218, 'lps'),
	(367970, 125, '2015-01-15 00:43:55.000000', 'consum', 0.0222, 'lps'),
	(367971, 125, '2015-01-15 00:43:56.000000', 'consum', 0.0211, 'lps'),
	(367972, 125, '2015-01-15 00:43:57.000000', 'consum', 0.0214, 'lps'),
	(367973, 125, '2015-01-15 00:43:58.000000', 'consum', 0.0211, 'lps'),
	(367974, 125, '2015-01-15 00:43:59.000000', 'consum', 0.0219, 'lps'),
	(367975, 125, '2015-01-15 00:44:00.000000', 'consum', 0.0220, 'lps'),
	(367976, 125, '2015-01-15 00:44:01.000000', 'consum', 0.0216, 'lps'),
	(367977, 125, '2015-01-15 00:44:02.000000', 'consum', 0.0211, 'lps'),
	(367978, 125, '2015-01-15 00:44:03.000000', 'consum', 0.0214, 'lps'),
	(367979, 125, '2015-01-15 00:44:04.000000', 'consum', 0.0226, 'lps'),
	(367980, 125, '2015-01-15 00:44:05.000000', 'consum', 0.0212, 'lps'),
	(367981, 125, '2015-01-15 00:44:06.000000', 'consum', 0.0221, 'lps'),
	(367982, 125, '2015-01-15 00:44:07.000000', 'consum', 0.0212, 'lps'),
	(367983, 125, '2015-01-15 00:44:08.000000', 'consum', 0.0220, 'lps'),
	(367984, 125, '2015-01-15 00:44:09.000000', 'consum', 0.0221, 'lps'),
	(367985, 125, '2015-01-15 00:44:10.000000', 'consum', 0.0218, 'lps'),
	(367986, 125, '2015-01-15 00:44:11.000000', 'consum', 0.0216, 'lps'),
	(367987, 125, '2015-01-15 00:44:12.000000', 'consum', 0.0218, 'lps'),
	(367988, 125, '2015-01-15 00:44:13.000000', 'consum', 0.0215, 'lps'),
	(367989, 125, '2015-01-15 00:44:14.000000', 'consum', 0.0210, 'lps'),
	(367990, 125, '2015-01-15 00:44:15.000000', 'consum', 0.0213, 'lps'),
	(367991, 125, '2015-01-15 00:44:16.000000', 'consum', 0.0210, 'lps'),
	(367992, 125, '2015-01-15 00:44:17.000000', 'consum', 0.0218, 'lps'),
	(367993, 125, '2015-01-15 00:44:18.000000', 'consum', 0.0216, 'lps'),
	(367994, 125, '2015-01-15 00:44:19.000000', 'consum', 0.0218, 'lps'),
	(367995, 125, '2015-01-15 00:44:20.000000', 'consum', 0.0215, 'lps'),
	(367996, 125, '2015-01-15 00:44:21.000000', 'consum', 0.0212, 'lps'),
	(367997, 125, '2015-01-15 00:44:22.000000', 'consum', 0.0222, 'lps'),
	(367998, 125, '2015-01-15 00:44:23.000000', 'consum', 0.0212, 'lps'),
	(367999, 125, '2015-01-15 00:44:24.000000', 'consum', 0.0219, 'lps'),
	(368000, 125, '2015-01-15 00:44:25.000000', 'consum', 0.0216, 'lps'),
	(368001, 125, '2015-01-15 00:44:26.000000', 'consum', 0.0214, 'lps'),
	(368002, 125, '2015-01-15 00:44:27.000000', 'consum', 0.0212, 'lps'),
	(368003, 125, '2015-01-15 00:44:28.000000', 'consum', 0.0226, 'lps'),
	(368004, 125, '2015-01-15 00:44:29.000000', 'consum', 0.0215, 'lps'),
	(368005, 125, '2015-01-15 00:44:30.000000', 'consum', 0.0223, 'lps'),
	(368006, 125, '2015-01-15 00:44:31.000000', 'consum', 0.0226, 'lps'),
	(368007, 125, '2015-01-15 00:44:32.000000', 'consum', 0.0217, 'lps'),
	(368008, 125, '2015-01-15 00:44:33.000000', 'consum', 0.0214, 'lps'),
	(368009, 125, '2015-01-15 00:44:34.000000', 'consum', 0.0211, 'lps'),
	(368010, 125, '2015-01-15 00:44:35.000000', 'consum', 0.0222, 'lps'),
	(368011, 125, '2015-01-15 00:44:36.000000', 'consum', 0.0214, 'lps'),
	(368012, 125, '2015-01-15 00:44:37.000000', 'consum', 0.0212, 'lps'),
	(368013, 125, '2015-01-15 00:44:38.000000', 'consum', 0.0224, 'lps'),
	(368014, 125, '2015-01-15 00:44:39.000000', 'consum', 0.0226, 'lps'),
	(368015, 125, '2015-01-15 00:44:40.000000', 'consum', 0.0214, 'lps'),
	(368016, 125, '2015-01-15 00:44:41.000000', 'consum', 0.0215, 'lps'),
	(368017, 125, '2015-01-15 00:44:42.000000', 'consum', 0.0223, 'lps'),
	(368018, 125, '2015-01-15 00:44:43.000000', 'consum', 0.0212, 'lps'),
	(368019, 125, '2015-01-15 00:44:44.000000', 'consum', 0.0215, 'lps'),
	(368020, 125, '2015-01-15 00:44:45.000000', 'consum', 0.0211, 'lps'),
	(368021, 125, '2015-01-15 00:44:46.000000', 'consum', 0.0220, 'lps'),
	(368022, 125, '2015-01-15 00:44:47.000000', 'consum', 0.0222, 'lps'),
	(368023, 125, '2015-01-15 00:44:48.000000', 'consum', 0.0224, 'lps'),
	(368024, 125, '2015-01-15 00:44:49.000000', 'consum', 0.0211, 'lps'),
	(368025, 125, '2015-01-15 00:44:50.000000', 'consum', 0.0224, 'lps'),
	(368026, 125, '2015-01-15 00:44:51.000000', 'consum', 0.0226, 'lps'),
	(368027, 125, '2015-01-15 00:44:52.000000', 'consum', 0.0213, 'lps'),
	(368028, 125, '2015-01-15 00:44:53.000000', 'consum', 0.0212, 'lps'),
	(368029, 125, '2015-01-15 00:44:54.000000', 'consum', 0.0213, 'lps'),
	(368030, 125, '2015-01-15 00:44:55.000000', 'consum', 0.0218, 'lps'),
	(368031, 125, '2015-01-15 00:44:56.000000', 'consum', 0.0210, 'lps'),
	(368032, 125, '2015-01-15 00:44:57.000000', 'consum', 0.0218, 'lps'),
	(368033, 125, '2015-01-15 00:44:58.000000', 'consum', 0.0218, 'lps'),
	(368034, 125, '2015-01-15 00:44:59.000000', 'consum', 0.0226, 'lps'),
	(368035, 125, '2015-01-15 00:45:00.000000', 'consum', 0.0214, 'lps'),
	(368036, 125, '2015-01-15 00:45:01.000000', 'consum', 0.0217, 'lps'),
	(368037, 125, '2015-01-15 00:45:02.000000', 'consum', 0.0215, 'lps'),
	(368038, 125, '2015-01-15 00:45:03.000000', 'consum', 0.0215, 'lps'),
	(368039, 125, '2015-01-15 00:45:04.000000', 'consum', 0.0221, 'lps'),
	(368040, 125, '2015-01-15 00:45:05.000000', 'consum', 0.0217, 'lps'),
	(368041, 125, '2015-01-15 00:45:06.000000', 'consum', 0.0212, 'lps'),
	(368042, 125, '2015-01-15 00:45:07.000000', 'consum', 0.0218, 'lps'),
	(368043, 125, '2015-01-15 00:45:08.000000', 'consum', 0.0225, 'lps'),
	(368044, 125, '2015-01-15 00:45:09.000000', 'consum', 0.0211, 'lps'),
	(368045, 125, '2015-01-15 00:45:10.000000', 'consum', 0.0223, 'lps'),
	(368046, 125, '2015-01-15 00:45:11.000000', 'consum', 0.0221, 'lps'),
	(368047, 125, '2015-01-15 00:45:12.000000', 'consum', 0.0210, 'lps'),
	(368048, 125, '2015-01-15 00:45:13.000000', 'consum', 0.0226, 'lps'),
	(368049, 125, '2015-01-15 00:45:14.000000', 'consum', 0.0226, 'lps'),
	(368050, 125, '2015-01-15 00:45:15.000000', 'consum', 0.0224, 'lps'),
	(368051, 125, '2015-01-15 00:45:16.000000', 'consum', 0.0217, 'lps'),
	(368052, 125, '2015-01-15 00:45:17.000000', 'consum', 0.0218, 'lps'),
	(368053, 125, '2015-01-15 00:45:18.000000', 'consum', 0.0214, 'lps'),
	(368054, 125, '2015-01-15 00:45:19.000000', 'consum', 0.0222, 'lps'),
	(368055, 125, '2015-01-15 00:45:20.000000', 'consum', 0.0224, 'lps'),
	(368056, 125, '2015-01-15 00:45:21.000000', 'consum', 0.0226, 'lps'),
	(368057, 125, '2015-01-15 00:45:22.000000', 'consum', 0.0218, 'lps'),
	(368058, 125, '2015-01-15 00:45:23.000000', 'consum', 0.0218, 'lps'),
	(368059, 125, '2015-01-15 00:45:24.000000', 'consum', 0.0211, 'lps'),
	(368060, 125, '2015-01-15 00:45:25.000000', 'consum', 0.0226, 'lps'),
	(368061, 125, '2015-01-15 00:45:26.000000', 'consum', 0.0219, 'lps'),
	(368062, 125, '2015-01-15 00:45:27.000000', 'consum', 0.0225, 'lps'),
	(368063, 125, '2015-01-15 00:45:28.000000', 'consum', 0.0223, 'lps'),
	(368064, 125, '2015-01-15 00:45:29.000000', 'consum', 0.0214, 'lps'),
	(368065, 125, '2015-01-15 00:45:30.000000', 'consum', 0.0224, 'lps'),
	(368066, 125, '2015-01-15 00:45:31.000000', 'consum', 0.0217, 'lps'),
	(368067, 125, '2015-01-15 00:45:32.000000', 'consum', 0.0223, 'lps'),
	(368068, 125, '2015-01-15 00:45:33.000000', 'consum', 0.0221, 'lps'),
	(368069, 125, '2015-01-15 00:45:34.000000', 'consum', 0.0226, 'lps'),
	(368070, 125, '2015-01-15 00:45:35.000000', 'consum', 0.0225, 'lps'),
	(368071, 125, '2015-01-15 00:45:36.000000', 'consum', 0.0220, 'lps'),
	(368072, 125, '2015-01-15 00:45:37.000000', 'consum', 0.0215, 'lps'),
	(368073, 125, '2015-01-15 00:45:38.000000', 'consum', 0.0221, 'lps'),
	(368074, 125, '2015-01-15 00:45:39.000000', 'consum', 0.0218, 'lps'),
	(368075, 125, '2015-01-15 00:45:40.000000', 'consum', 0.0216, 'lps'),
	(368076, 125, '2015-01-15 00:45:41.000000', 'consum', 0.0218, 'lps'),
	(368077, 125, '2015-01-15 00:45:42.000000', 'consum', 0.0214, 'lps'),
	(368078, 125, '2015-01-15 00:45:43.000000', 'consum', 0.0222, 'lps'),
	(368079, 125, '2015-01-15 00:45:44.000000', 'consum', 0.0211, 'lps'),
	(368080, 125, '2015-01-15 00:45:45.000000', 'consum', 0.0213, 'lps'),
	(368081, 125, '2015-01-15 00:45:46.000000', 'consum', 0.0221, 'lps'),
	(368082, 125, '2015-01-15 00:45:47.000000', 'consum', 0.0223, 'lps'),
	(368083, 125, '2015-01-15 00:45:48.000000', 'consum', 0.0224, 'lps'),
	(368084, 125, '2015-01-15 00:45:49.000000', 'consum', 0.0226, 'lps'),
	(368085, 125, '2015-01-15 00:45:50.000000', 'consum', 0.0212, 'lps'),
	(368086, 125, '2015-01-15 00:45:51.000000', 'consum', 0.0210, 'lps'),
	(368087, 125, '2015-01-15 00:45:52.000000', 'consum', 0.0221, 'lps'),
	(368088, 125, '2015-01-15 00:45:53.000000', 'consum', 0.0213, 'lps'),
	(368089, 125, '2015-01-15 00:45:54.000000', 'consum', 0.0212, 'lps'),
	(368090, 125, '2015-01-15 00:45:55.000000', 'consum', 0.0225, 'lps'),
	(368091, 125, '2015-01-15 00:45:56.000000', 'consum', 0.0214, 'lps'),
	(368092, 125, '2015-01-15 00:45:57.000000', 'consum', 0.0219, 'lps'),
	(368093, 125, '2015-01-15 00:45:58.000000', 'consum', 0.0226, 'lps'),
	(368094, 125, '2015-01-15 00:45:59.000000', 'consum', 0.0212, 'lps'),
	(368095, 125, '2015-01-15 00:46:00.000000', 'consum', 0.0225, 'lps'),
	(368096, 125, '2015-01-15 00:46:01.000000', 'consum', 0.0212, 'lps'),
	(368097, 125, '2015-01-15 00:46:02.000000', 'consum', 0.0226, 'lps'),
	(368098, 125, '2015-01-15 00:46:03.000000', 'consum', 0.0215, 'lps'),
	(368099, 125, '2015-01-15 00:46:04.000000', 'consum', 0.0223, 'lps'),
	(368100, 125, '2015-01-15 00:46:05.000000', 'consum', 0.0224, 'lps'),
	(368101, 125, '2015-01-15 00:46:06.000000', 'consum', 0.0211, 'lps'),
	(368102, 125, '2015-01-15 00:46:07.000000', 'consum', 0.0222, 'lps'),
	(368103, 125, '2015-01-15 00:46:08.000000', 'consum', 0.0216, 'lps'),
	(368104, 125, '2015-01-15 00:46:09.000000', 'consum', 0.0222, 'lps'),
	(368105, 125, '2015-01-15 00:46:10.000000', 'consum', 0.0217, 'lps'),
	(368106, 125, '2015-01-15 00:46:11.000000', 'consum', 0.0226, 'lps'),
	(368107, 125, '2015-01-15 00:46:12.000000', 'consum', 0.0221, 'lps'),
	(368108, 125, '2015-01-15 00:46:13.000000', 'consum', 0.0216, 'lps'),
	(368109, 125, '2015-01-15 00:46:14.000000', 'consum', 0.0224, 'lps'),
	(368110, 125, '2015-01-15 00:46:15.000000', 'consum', 0.0214, 'lps'),
	(368111, 125, '2015-01-15 00:46:16.000000', 'consum', 0.0221, 'lps'),
	(368112, 125, '2015-01-15 00:46:17.000000', 'consum', 0.0221, 'lps'),
	(368113, 125, '2015-01-15 00:46:18.000000', 'consum', 0.0213, 'lps'),
	(368114, 125, '2015-01-15 00:46:19.000000', 'consum', 0.0210, 'lps'),
	(368115, 125, '2015-01-15 00:46:20.000000', 'consum', 0.0221, 'lps'),
	(368116, 125, '2015-01-15 00:46:21.000000', 'consum', 0.0212, 'lps'),
	(368117, 125, '2015-01-15 00:46:22.000000', 'consum', 0.0221, 'lps'),
	(368118, 125, '2015-01-15 00:46:23.000000', 'consum', 0.0225, 'lps'),
	(368119, 125, '2015-01-15 00:46:24.000000', 'consum', 0.0219, 'lps'),
	(368120, 125, '2015-01-15 00:46:25.000000', 'consum', 0.0226, 'lps'),
	(368121, 125, '2015-01-15 00:46:26.000000', 'consum', 0.0216, 'lps'),
	(368122, 125, '2015-01-15 00:46:27.000000', 'consum', 0.0223, 'lps'),
	(368123, 125, '2015-01-15 00:46:28.000000', 'consum', 0.0225, 'lps'),
	(368124, 125, '2015-01-15 00:46:29.000000', 'consum', 0.0212, 'lps'),
	(368125, 125, '2015-01-15 00:46:30.000000', 'consum', 0.0212, 'lps'),
	(368126, 125, '2015-01-15 00:46:31.000000', 'consum', 0.0212, 'lps'),
	(368127, 125, '2015-01-15 00:46:32.000000', 'consum', 0.0217, 'lps'),
	(368128, 125, '2015-01-15 00:46:33.000000', 'consum', 0.0221, 'lps'),
	(368129, 125, '2015-01-15 00:46:34.000000', 'consum', 0.0211, 'lps'),
	(368130, 125, '2015-01-15 00:46:35.000000', 'consum', 0.0215, 'lps'),
	(368131, 125, '2015-01-15 00:46:36.000000', 'consum', 0.0216, 'lps'),
	(368132, 125, '2015-01-15 00:46:37.000000', 'consum', 0.0225, 'lps'),
	(368133, 125, '2015-01-15 00:46:38.000000', 'consum', 0.0216, 'lps'),
	(368134, 125, '2015-01-15 00:46:39.000000', 'consum', 0.0213, 'lps'),
	(368135, 125, '2015-01-15 00:46:40.000000', 'consum', 0.0225, 'lps'),
	(368136, 125, '2015-01-15 00:46:41.000000', 'consum', 0.0226, 'lps'),
	(368137, 125, '2015-01-15 00:46:42.000000', 'consum', 0.0226, 'lps'),
	(368138, 125, '2015-01-15 00:46:43.000000', 'consum', 0.0211, 'lps'),
	(368139, 125, '2015-01-15 00:46:44.000000', 'consum', 0.0217, 'lps'),
	(368140, 125, '2015-01-15 00:46:45.000000', 'consum', 0.0226, 'lps'),
	(368141, 125, '2015-01-15 00:46:46.000000', 'consum', 0.0217, 'lps'),
	(368142, 125, '2015-01-15 00:46:47.000000', 'consum', 0.0215, 'lps'),
	(368143, 125, '2015-01-15 00:46:48.000000', 'consum', 0.0215, 'lps'),
	(368144, 125, '2015-01-15 00:46:49.000000', 'consum', 0.0222, 'lps'),
	(368145, 125, '2015-01-15 00:46:50.000000', 'consum', 0.0222, 'lps'),
	(368146, 125, '2015-01-15 00:46:51.000000', 'consum', 0.0217, 'lps'),
	(368147, 125, '2015-01-15 00:46:52.000000', 'consum', 0.0210, 'lps'),
	(368148, 125, '2015-01-15 00:46:53.000000', 'consum', 0.0223, 'lps'),
	(368149, 125, '2015-01-15 00:46:54.000000', 'consum', 0.0222, 'lps'),
	(368150, 125, '2015-01-15 00:46:55.000000', 'consum', 0.0218, 'lps'),
	(368151, 125, '2015-01-15 00:46:56.000000', 'consum', 0.0213, 'lps'),
	(368152, 125, '2015-01-15 00:46:57.000000', 'consum', 0.0218, 'lps'),
	(368153, 125, '2015-01-15 00:46:58.000000', 'consum', 0.0225, 'lps'),
	(368154, 125, '2015-01-15 00:46:59.000000', 'consum', 0.0210, 'lps'),
	(368155, 125, '2015-01-15 00:47:00.000000', 'consum', 0.0218, 'lps'),
	(368156, 125, '2015-01-15 00:47:01.000000', 'consum', 0.0217, 'lps'),
	(368157, 125, '2015-01-15 00:47:02.000000', 'consum', 0.0222, 'lps'),
	(368158, 125, '2015-01-15 00:47:03.000000', 'consum', 0.0214, 'lps'),
	(368159, 125, '2015-01-15 00:47:04.000000', 'consum', 0.0213, 'lps'),
	(368160, 125, '2015-01-15 00:47:05.000000', 'consum', 0.0212, 'lps'),
	(368161, 125, '2015-01-15 00:47:06.000000', 'consum', 0.0212, 'lps'),
	(368162, 125, '2015-01-15 00:47:07.000000', 'consum', 0.0216, 'lps'),
	(368163, 125, '2015-01-15 00:47:08.000000', 'consum', 0.0216, 'lps'),
	(368164, 125, '2015-01-15 00:47:09.000000', 'consum', 0.0224, 'lps'),
	(368165, 125, '2015-01-15 00:47:10.000000', 'consum', 0.0213, 'lps'),
	(368166, 125, '2015-01-15 00:47:11.000000', 'consum', 0.0214, 'lps'),
	(368167, 125, '2015-01-15 00:47:12.000000', 'consum', 0.0222, 'lps'),
	(368168, 125, '2015-01-15 00:47:13.000000', 'consum', 0.0224, 'lps'),
	(368169, 125, '2015-01-15 00:47:14.000000', 'consum', 0.0226, 'lps'),
	(368170, 125, '2015-01-15 00:47:15.000000', 'consum', 0.0217, 'lps'),
	(368171, 125, '2015-01-15 00:47:16.000000', 'consum', 0.0214, 'lps'),
	(368172, 125, '2015-01-15 00:47:17.000000', 'consum', 0.0211, 'lps'),
	(368173, 125, '2015-01-15 00:47:18.000000', 'consum', 0.0220, 'lps'),
	(368174, 125, '2015-01-15 00:47:19.000000', 'consum', 0.0221, 'lps'),
	(368175, 125, '2015-01-15 00:47:20.000000', 'consum', 0.0221, 'lps'),
	(368176, 125, '2015-01-15 00:47:21.000000', 'consum', 0.0213, 'lps'),
	(368177, 125, '2015-01-15 00:47:22.000000', 'consum', 0.0213, 'lps'),
	(368178, 125, '2015-01-15 00:47:23.000000', 'consum', 0.0213, 'lps'),
	(368179, 125, '2015-01-15 00:47:24.000000', 'consum', 0.0219, 'lps'),
	(368180, 125, '2015-01-15 00:47:25.000000', 'consum', 0.0214, 'lps'),
	(368181, 125, '2015-01-15 00:47:26.000000', 'consum', 0.0217, 'lps'),
	(368182, 125, '2015-01-15 00:47:27.000000', 'consum', 0.0219, 'lps'),
	(368183, 125, '2015-01-15 00:47:28.000000', 'consum', 0.0216, 'lps'),
	(368184, 125, '2015-01-15 00:47:29.000000', 'consum', 0.0213, 'lps'),
	(368185, 125, '2015-01-15 00:47:30.000000', 'consum', 0.0224, 'lps'),
	(368186, 125, '2015-01-15 00:47:31.000000', 'consum', 0.0220, 'lps'),
	(368187, 125, '2015-01-15 00:47:32.000000', 'consum', 0.0219, 'lps'),
	(368188, 125, '2015-01-15 00:47:33.000000', 'consum', 0.0210, 'lps'),
	(368189, 125, '2015-01-15 00:47:34.000000', 'consum', 0.0217, 'lps'),
	(368190, 125, '2015-01-15 00:47:35.000000', 'consum', 0.0213, 'lps'),
	(368191, 125, '2015-01-15 00:47:36.000000', 'consum', 0.0221, 'lps'),
	(368192, 125, '2015-01-15 00:47:37.000000', 'consum', 0.0221, 'lps'),
	(368193, 125, '2015-01-15 00:47:38.000000', 'consum', 0.0217, 'lps'),
	(368194, 125, '2015-01-15 00:47:39.000000', 'consum', 0.0212, 'lps'),
	(368195, 125, '2015-01-15 00:47:40.000000', 'consum', 0.0216, 'lps'),
	(368196, 125, '2015-01-15 00:47:41.000000', 'consum', 0.0218, 'lps'),
	(368197, 125, '2015-01-15 00:47:42.000000', 'consum', 0.0217, 'lps'),
	(368198, 125, '2015-01-15 00:47:43.000000', 'consum', 0.0220, 'lps'),
	(368199, 125, '2015-01-15 00:47:44.000000', 'consum', 0.0222, 'lps'),
	(368200, 125, '2015-01-15 00:47:45.000000', 'consum', 0.0224, 'lps'),
	(368201, 125, '2015-01-15 00:47:46.000000', 'consum', 0.0210, 'lps'),
	(368202, 125, '2015-01-15 00:47:47.000000', 'consum', 0.0221, 'lps'),
	(368203, 125, '2015-01-15 00:47:48.000000', 'consum', 0.0212, 'lps'),
	(368204, 125, '2015-01-15 00:47:49.000000', 'consum', 0.0224, 'lps'),
	(368205, 125, '2015-01-15 00:47:50.000000', 'consum', 0.0222, 'lps'),
	(368206, 125, '2015-01-15 00:47:51.000000', 'consum', 0.0211, 'lps'),
	(368207, 125, '2015-01-15 00:47:52.000000', 'consum', 0.0215, 'lps'),
	(368208, 125, '2015-01-15 00:47:53.000000', 'consum', 0.0215, 'lps'),
	(368209, 125, '2015-01-15 00:47:54.000000', 'consum', 0.0220, 'lps'),
	(368210, 125, '2015-01-15 00:47:55.000000', 'consum', 0.0214, 'lps'),
	(368211, 125, '2015-01-15 00:47:56.000000', 'consum', 0.0214, 'lps'),
	(368212, 125, '2015-01-15 00:47:57.000000', 'consum', 0.0221, 'lps'),
	(368213, 125, '2015-01-15 00:47:58.000000', 'consum', 0.0219, 'lps'),
	(368214, 125, '2015-01-15 00:47:59.000000', 'consum', 0.0222, 'lps'),
	(368215, 125, '2015-01-15 00:48:00.000000', 'consum', 0.0210, 'lps'),
	(368216, 125, '2015-01-15 00:48:01.000000', 'consum', 0.0210, 'lps'),
	(368217, 125, '2015-01-15 00:48:02.000000', 'consum', 0.0211, 'lps'),
	(368218, 125, '2015-01-15 00:48:03.000000', 'consum', 0.0215, 'lps'),
	(368219, 125, '2015-01-15 00:48:04.000000', 'consum', 0.0215, 'lps'),
	(368220, 125, '2015-01-15 00:48:05.000000', 'consum', 0.0219, 'lps'),
	(368221, 125, '2015-01-15 00:48:06.000000', 'consum', 0.0224, 'lps'),
	(368222, 125, '2015-01-15 00:48:07.000000', 'consum', 0.0221, 'lps'),
	(368223, 125, '2015-01-15 00:48:08.000000', 'consum', 0.0221, 'lps'),
	(368224, 125, '2015-01-15 00:48:09.000000', 'consum', 0.0217, 'lps'),
	(368225, 125, '2015-01-15 00:48:10.000000', 'consum', 0.0211, 'lps'),
	(368226, 125, '2015-01-15 00:48:11.000000', 'consum', 0.0213, 'lps'),
	(368227, 125, '2015-01-15 00:48:12.000000', 'consum', 0.0221, 'lps'),
	(368228, 125, '2015-01-15 00:48:13.000000', 'consum', 0.0223, 'lps'),
	(368229, 125, '2015-01-15 00:48:14.000000', 'consum', 0.0224, 'lps'),
	(368230, 125, '2015-01-15 00:48:15.000000', 'consum', 0.0224, 'lps'),
	(368231, 125, '2015-01-15 00:48:16.000000', 'consum', 0.0224, 'lps'),
	(368232, 125, '2015-01-15 00:48:17.000000', 'consum', 0.0222, 'lps'),
	(368233, 125, '2015-01-15 00:48:18.000000', 'consum', 0.0212, 'lps'),
	(368234, 125, '2015-01-15 00:48:19.000000', 'consum', 0.0218, 'lps'),
	(368235, 125, '2015-01-15 00:48:20.000000', 'consum', 0.0212, 'lps'),
	(368236, 125, '2015-01-15 00:48:21.000000', 'consum', 0.0211, 'lps'),
	(368237, 125, '2015-01-15 00:48:22.000000', 'consum', 0.0225, 'lps'),
	(368238, 125, '2015-01-15 00:48:23.000000', 'consum', 0.0217, 'lps'),
	(368239, 125, '2015-01-15 00:48:24.000000', 'consum', 0.0217, 'lps'),
	(368240, 125, '2015-01-15 00:48:25.000000', 'consum', 0.0224, 'lps'),
	(368241, 125, '2015-01-15 00:48:26.000000', 'consum', 0.0225, 'lps'),
	(368242, 125, '2015-01-15 00:48:27.000000', 'consum', 0.0212, 'lps'),
	(368243, 125, '2015-01-15 00:48:28.000000', 'consum', 0.0224, 'lps'),
	(368244, 125, '2015-01-15 00:48:29.000000', 'consum', 0.0224, 'lps'),
	(368245, 125, '2015-01-15 00:48:30.000000', 'consum', 0.0220, 'lps'),
	(368246, 125, '2015-01-15 00:48:31.000000', 'consum', 0.0218, 'lps'),
	(368247, 125, '2015-01-15 00:48:32.000000', 'consum', 0.0223, 'lps'),
	(368248, 125, '2015-01-15 00:48:33.000000', 'consum', 0.0215, 'lps'),
	(368249, 125, '2015-01-15 00:48:34.000000', 'consum', 0.0214, 'lps'),
	(368250, 125, '2015-01-15 00:48:35.000000', 'consum', 0.0218, 'lps'),
	(368251, 125, '2015-01-15 00:48:36.000000', 'consum', 0.0219, 'lps'),
	(368252, 125, '2015-01-15 00:48:37.000000', 'consum', 0.0213, 'lps'),
	(368253, 125, '2015-01-15 00:48:38.000000', 'consum', 0.0219, 'lps'),
	(368254, 125, '2015-01-15 00:48:39.000000', 'consum', 0.0226, 'lps'),
	(368255, 125, '2015-01-15 00:48:40.000000', 'consum', 0.0215, 'lps'),
	(368256, 125, '2015-01-15 00:48:41.000000', 'consum', 0.0223, 'lps'),
	(368257, 125, '2015-01-15 00:48:42.000000', 'consum', 0.0224, 'lps'),
	(368258, 125, '2015-01-15 00:48:43.000000', 'consum', 0.0223, 'lps'),
	(368259, 125, '2015-01-15 00:48:44.000000', 'consum', 0.0220, 'lps'),
	(368260, 125, '2015-01-15 00:48:45.000000', 'consum', 0.0220, 'lps'),
	(368261, 125, '2015-01-15 00:48:46.000000', 'consum', 0.0214, 'lps'),
	(368262, 125, '2015-01-15 00:48:47.000000', 'consum', 0.0219, 'lps'),
	(368263, 125, '2015-01-15 00:48:48.000000', 'consum', 0.0224, 'lps'),
	(368264, 125, '2015-01-15 00:48:49.000000', 'consum', 0.0219, 'lps'),
	(368265, 125, '2015-01-15 00:48:50.000000', 'consum', 0.0213, 'lps'),
	(368266, 125, '2015-01-15 00:48:51.000000', 'consum', 0.0216, 'lps'),
	(368267, 125, '2015-01-15 00:48:52.000000', 'consum', 0.0213, 'lps'),
	(368268, 125, '2015-01-15 00:48:53.000000', 'consum', 0.0210, 'lps'),
	(368269, 125, '2015-01-15 00:48:54.000000', 'consum', 0.0217, 'lps'),
	(368270, 125, '2015-01-15 00:48:55.000000', 'consum', 0.0211, 'lps'),
	(368271, 125, '2015-01-15 00:48:56.000000', 'consum', 0.0212, 'lps'),
	(368272, 125, '2015-01-15 00:48:57.000000', 'consum', 0.0219, 'lps'),
	(368273, 125, '2015-01-15 00:48:58.000000', 'consum', 0.0216, 'lps'),
	(368274, 125, '2015-01-15 00:48:59.000000', 'consum', 0.0211, 'lps'),
	(368275, 125, '2015-01-15 00:49:00.000000', 'consum', 0.0217, 'lps'),
	(368276, 125, '2015-01-15 00:49:01.000000', 'consum', 0.0226, 'lps'),
	(368277, 125, '2015-01-15 00:49:02.000000', 'consum', 0.0218, 'lps'),
	(368278, 125, '2015-01-15 00:49:03.000000', 'consum', 0.0219, 'lps'),
	(368279, 125, '2015-01-15 00:49:04.000000', 'consum', 0.0214, 'lps'),
	(368280, 125, '2015-01-15 00:49:05.000000', 'consum', 0.0221, 'lps'),
	(368281, 125, '2015-01-15 00:49:06.000000', 'consum', 0.0221, 'lps'),
	(368282, 125, '2015-01-15 00:49:07.000000', 'consum', 0.0216, 'lps'),
	(368283, 125, '2015-01-15 00:49:08.000000', 'consum', 0.0226, 'lps'),
	(368284, 125, '2015-01-15 00:49:09.000000', 'consum', 0.0218, 'lps'),
	(368285, 125, '2015-01-15 00:49:10.000000', 'consum', 0.0219, 'lps'),
	(368286, 125, '2015-01-15 00:49:11.000000', 'consum', 0.0215, 'lps'),
	(368287, 125, '2015-01-15 00:49:12.000000', 'consum', 0.0224, 'lps'),
	(368288, 125, '2015-01-15 00:49:13.000000', 'consum', 0.0217, 'lps'),
	(368289, 125, '2015-01-15 00:49:14.000000', 'consum', 0.0222, 'lps'),
	(368290, 125, '2015-01-15 00:49:15.000000', 'consum', 0.0213, 'lps'),
	(368291, 125, '2015-01-15 00:49:16.000000', 'consum', 0.0224, 'lps'),
	(368292, 125, '2015-01-15 00:49:17.000000', 'consum', 0.0222, 'lps'),
	(368293, 125, '2015-01-15 00:49:18.000000', 'consum', 0.0212, 'lps'),
	(368294, 125, '2015-01-15 00:49:19.000000', 'consum', 0.0216, 'lps'),
	(368295, 125, '2015-01-15 00:49:20.000000', 'consum', 0.0219, 'lps'),
	(368296, 125, '2015-01-15 00:49:21.000000', 'consum', 0.0219, 'lps'),
	(368297, 125, '2015-01-15 00:49:22.000000', 'consum', 0.0214, 'lps'),
	(368298, 125, '2015-01-15 00:49:23.000000', 'consum', 0.0221, 'lps'),
	(368299, 125, '2015-01-15 00:49:24.000000', 'consum', 0.0220, 'lps'),
	(368300, 125, '2015-01-15 00:49:25.000000', 'consum', 0.0225, 'lps'),
	(368301, 125, '2015-01-15 00:49:26.000000', 'consum', 0.0222, 'lps'),
	(368302, 125, '2015-01-15 00:49:27.000000', 'consum', 0.0210, 'lps'),
	(368303, 125, '2015-01-15 00:49:28.000000', 'consum', 0.0223, 'lps'),
	(368304, 125, '2015-01-15 00:49:29.000000', 'consum', 0.0224, 'lps'),
	(368305, 125, '2015-01-15 00:49:30.000000', 'consum', 0.0211, 'lps'),
	(368306, 125, '2015-01-15 00:49:31.000000', 'consum', 0.0222, 'lps'),
	(368307, 125, '2015-01-15 00:49:32.000000', 'consum', 0.0215, 'lps'),
	(368308, 125, '2015-01-15 00:49:33.000000', 'consum', 0.0218, 'lps'),
	(368309, 125, '2015-01-15 00:49:34.000000', 'consum', 0.0220, 'lps'),
	(368310, 125, '2015-01-15 00:49:35.000000', 'consum', 0.0218, 'lps'),
	(368311, 125, '2015-01-15 00:49:36.000000', 'consum', 0.0220, 'lps'),
	(368312, 125, '2015-01-15 00:49:37.000000', 'consum', 0.0220, 'lps'),
	(368313, 125, '2015-01-15 00:49:38.000000', 'consum', 0.0212, 'lps'),
	(368314, 125, '2015-01-15 00:49:39.000000', 'consum', 0.0210, 'lps'),
	(368315, 125, '2015-01-15 00:49:40.000000', 'consum', 0.0221, 'lps'),
	(368316, 125, '2015-01-15 00:49:41.000000', 'consum', 0.0212, 'lps'),
	(368317, 125, '2015-01-15 00:49:42.000000', 'consum', 0.0225, 'lps'),
	(368318, 125, '2015-01-15 00:49:43.000000', 'consum', 0.0210, 'lps'),
	(368319, 125, '2015-01-15 00:49:44.000000', 'consum', 0.0215, 'lps'),
	(368320, 125, '2015-01-15 00:49:45.000000', 'consum', 0.0222, 'lps'),
	(368321, 125, '2015-01-15 00:49:46.000000', 'consum', 0.0219, 'lps'),
	(368322, 125, '2015-01-15 00:49:47.000000', 'consum', 0.0219, 'lps'),
	(368323, 125, '2015-01-15 00:49:48.000000', 'consum', 0.0212, 'lps'),
	(368324, 125, '2015-01-15 00:49:49.000000', 'consum', 0.0211, 'lps'),
	(368325, 125, '2015-01-15 00:49:50.000000', 'consum', 0.0225, 'lps'),
	(368326, 125, '2015-01-15 00:49:51.000000', 'consum', 0.0216, 'lps'),
	(368327, 125, '2015-01-15 00:49:52.000000', 'consum', 0.0211, 'lps'),
	(368328, 125, '2015-01-15 00:49:53.000000', 'consum', 0.0214, 'lps'),
	(368329, 125, '2015-01-15 00:49:54.000000', 'consum', 0.0213, 'lps'),
	(368330, 125, '2015-01-15 00:49:55.000000', 'consum', 0.0211, 'lps'),
	(368331, 125, '2015-01-15 00:49:56.000000', 'consum', 0.0223, 'lps'),
	(368332, 125, '2015-01-15 00:49:57.000000', 'consum', 0.0223, 'lps'),
	(368333, 125, '2015-01-15 00:49:58.000000', 'consum', 0.0221, 'lps'),
	(368334, 125, '2015-01-15 00:49:59.000000', 'consum', 0.0224, 'lps'),
	(368335, 125, '2015-01-15 00:50:00.000000', 'consum', 0.0212, 'lps'),
	(368336, 125, '2015-01-15 00:50:01.000000', 'consum', 0.0216, 'lps'),
	(368337, 125, '2015-01-15 00:50:02.000000', 'consum', 0.0214, 'lps'),
	(368338, 125, '2015-01-15 00:50:03.000000', 'consum', 0.0215, 'lps'),
	(368339, 125, '2015-01-15 00:50:04.000000', 'consum', 0.0222, 'lps'),
	(368340, 125, '2015-01-15 00:50:05.000000', 'consum', 0.0222, 'lps'),
	(368341, 125, '2015-01-15 00:50:06.000000', 'consum', 0.0216, 'lps'),
	(368342, 125, '2015-01-15 00:50:07.000000', 'consum', 0.0224, 'lps'),
	(368343, 125, '2015-01-15 00:50:08.000000', 'consum', 0.0226, 'lps'),
	(368344, 125, '2015-01-15 00:50:09.000000', 'consum', 0.0216, 'lps'),
	(368345, 125, '2015-01-15 00:50:10.000000', 'consum', 0.0211, 'lps'),
	(368346, 125, '2015-01-15 00:50:11.000000', 'consum', 0.0212, 'lps'),
	(368347, 125, '2015-01-15 00:50:12.000000', 'consum', 0.0220, 'lps'),
	(368348, 125, '2015-01-15 00:50:13.000000', 'consum', 0.0219, 'lps'),
	(368349, 125, '2015-01-15 00:50:14.000000', 'consum', 0.0210, 'lps'),
	(368350, 125, '2015-01-15 00:50:15.000000', 'consum', 0.0215, 'lps'),
	(368351, 125, '2015-01-15 00:50:16.000000', 'consum', 0.0221, 'lps'),
	(368352, 125, '2015-01-15 00:50:17.000000', 'consum', 0.0214, 'lps'),
	(368353, 125, '2015-01-15 00:50:18.000000', 'consum', 0.0216, 'lps'),
	(368354, 125, '2015-01-15 00:50:19.000000', 'consum', 0.0210, 'lps'),
	(368355, 125, '2015-01-15 00:50:20.000000', 'consum', 0.0212, 'lps'),
	(368356, 125, '2015-01-15 00:50:21.000000', 'consum', 0.0220, 'lps'),
	(368357, 125, '2015-01-15 00:50:22.000000', 'consum', 0.0220, 'lps'),
	(368358, 125, '2015-01-15 00:50:23.000000', 'consum', 0.0212, 'lps'),
	(368359, 125, '2015-01-15 00:50:24.000000', 'consum', 0.0211, 'lps'),
	(368360, 125, '2015-01-15 00:50:25.000000', 'consum', 0.0223, 'lps'),
	(368361, 125, '2015-01-15 00:50:26.000000', 'consum', 0.0224, 'lps'),
	(368362, 125, '2015-01-15 00:50:27.000000', 'consum', 0.0225, 'lps'),
	(368363, 125, '2015-01-15 00:50:28.000000', 'consum', 0.0226, 'lps'),
	(368364, 125, '2015-01-15 00:50:29.000000', 'consum', 0.0213, 'lps'),
	(368365, 125, '2015-01-15 00:50:30.000000', 'consum', 0.0226, 'lps'),
	(368366, 125, '2015-01-15 00:50:31.000000', 'consum', 0.0214, 'lps'),
	(368367, 125, '2015-01-15 00:50:32.000000', 'consum', 0.0215, 'lps'),
	(368368, 125, '2015-01-15 00:50:33.000000', 'consum', 0.0223, 'lps'),
	(368369, 125, '2015-01-15 00:50:34.000000', 'consum', 0.0212, 'lps'),
	(368370, 125, '2015-01-15 00:50:35.000000', 'consum', 0.0216, 'lps'),
	(368371, 125, '2015-01-15 00:50:36.000000', 'consum', 0.0218, 'lps'),
	(368372, 125, '2015-01-15 00:50:37.000000', 'consum', 0.0213, 'lps'),
	(368373, 125, '2015-01-15 00:50:38.000000', 'consum', 0.0220, 'lps'),
	(368374, 125, '2015-01-15 00:50:39.000000', 'consum', 0.0216, 'lps'),
	(368375, 125, '2015-01-15 00:50:40.000000', 'consum', 0.0226, 'lps'),
	(368376, 125, '2015-01-15 00:50:41.000000', 'consum', 0.0225, 'lps'),
	(368377, 125, '2015-01-15 00:50:42.000000', 'consum', 0.0218, 'lps'),
	(368378, 125, '2015-01-15 00:50:43.000000', 'consum', 0.0223, 'lps'),
	(368379, 125, '2015-01-15 00:50:44.000000', 'consum', 0.0219, 'lps'),
	(368380, 125, '2015-01-15 00:50:45.000000', 'consum', 0.0216, 'lps'),
	(368381, 125, '2015-01-15 00:50:46.000000', 'consum', 0.0212, 'lps'),
	(368382, 125, '2015-01-15 00:50:47.000000', 'consum', 0.0219, 'lps'),
	(368383, 125, '2015-01-15 00:50:48.000000', 'consum', 0.0215, 'lps'),
	(368384, 125, '2015-01-15 00:50:49.000000', 'consum', 0.0211, 'lps'),
	(368385, 125, '2015-01-15 00:50:50.000000', 'consum', 0.0218, 'lps'),
	(368386, 125, '2015-01-15 00:50:51.000000', 'consum', 0.0210, 'lps'),
	(368387, 125, '2015-01-15 00:50:52.000000', 'consum', 0.0224, 'lps'),
	(368388, 125, '2015-01-15 00:50:53.000000', 'consum', 0.0212, 'lps'),
	(368389, 125, '2015-01-15 00:50:54.000000', 'consum', 0.0213, 'lps'),
	(368390, 125, '2015-01-15 00:50:55.000000', 'consum', 0.0220, 'lps'),
	(368391, 125, '2015-01-15 00:50:56.000000', 'consum', 0.0219, 'lps'),
	(368392, 125, '2015-01-15 00:50:57.000000', 'consum', 0.0222, 'lps'),
	(368393, 125, '2015-01-15 00:50:58.000000', 'consum', 0.0210, 'lps'),
	(368394, 125, '2015-01-15 00:50:59.000000', 'consum', 0.0224, 'lps'),
	(368395, 125, '2015-01-15 00:51:00.000000', 'consum', 0.0216, 'lps'),
	(368396, 125, '2015-01-15 00:51:01.000000', 'consum', 0.0213, 'lps'),
	(368397, 125, '2015-01-15 00:51:02.000000', 'consum', 0.0224, 'lps'),
	(368398, 125, '2015-01-15 00:51:03.000000', 'consum', 0.0223, 'lps'),
	(368399, 125, '2015-01-15 00:51:04.000000', 'consum', 0.0215, 'lps'),
	(368400, 125, '2015-01-15 00:51:05.000000', 'consum', 0.0213, 'lps'),
	(368401, 125, '2015-01-15 00:51:06.000000', 'consum', 0.0213, 'lps'),
	(368402, 125, '2015-01-15 00:51:07.000000', 'consum', 0.0213, 'lps'),
	(368403, 125, '2015-01-15 00:51:08.000000', 'consum', 0.0220, 'lps'),
	(368404, 125, '2015-01-15 00:51:09.000000', 'consum', 0.0215, 'lps'),
	(368405, 125, '2015-01-15 00:51:10.000000', 'consum', 0.0222, 'lps'),
	(368406, 125, '2015-01-15 00:51:11.000000', 'consum', 0.0221, 'lps'),
	(368407, 125, '2015-01-15 00:51:12.000000', 'consum', 0.0215, 'lps'),
	(368408, 125, '2015-01-15 00:51:13.000000', 'consum', 0.0217, 'lps'),
	(368409, 125, '2015-01-15 00:51:14.000000', 'consum', 0.0216, 'lps'),
	(368410, 125, '2015-01-15 00:51:15.000000', 'consum', 0.0217, 'lps'),
	(368411, 125, '2015-01-15 00:51:16.000000', 'consum', 0.0212, 'lps'),
	(368412, 125, '2015-01-15 00:51:17.000000', 'consum', 0.0217, 'lps'),
	(368413, 125, '2015-01-15 00:51:18.000000', 'consum', 0.0220, 'lps'),
	(368414, 125, '2015-01-15 00:51:19.000000', 'consum', 0.0223, 'lps'),
	(368415, 125, '2015-01-15 00:51:20.000000', 'consum', 0.0212, 'lps'),
	(368416, 125, '2015-01-15 00:51:21.000000', 'consum', 0.0216, 'lps'),
	(368417, 125, '2015-01-15 00:51:22.000000', 'consum', 0.0216, 'lps'),
	(368418, 125, '2015-01-15 00:51:23.000000', 'consum', 0.0224, 'lps'),
	(368419, 125, '2015-01-15 00:51:24.000000', 'consum', 0.0212, 'lps'),
	(368420, 125, '2015-01-15 00:51:25.000000', 'consum', 0.0211, 'lps'),
	(368421, 125, '2015-01-15 00:51:26.000000', 'consum', 0.0210, 'lps'),
	(368422, 125, '2015-01-15 00:51:27.000000', 'consum', 0.0226, 'lps'),
	(368423, 125, '2015-01-15 00:51:28.000000', 'consum', 0.0223, 'lps'),
	(368424, 125, '2015-01-15 00:51:29.000000', 'consum', 0.0226, 'lps'),
	(368425, 125, '2015-01-15 00:51:30.000000', 'consum', 0.0220, 'lps'),
	(368426, 125, '2015-01-15 00:51:31.000000', 'consum', 0.0226, 'lps'),
	(368427, 125, '2015-01-15 00:51:32.000000', 'consum', 0.0212, 'lps'),
	(368428, 125, '2015-01-15 00:51:33.000000', 'consum', 0.0224, 'lps'),
	(368429, 125, '2015-01-15 00:51:34.000000', 'consum', 0.0221, 'lps'),
	(368430, 125, '2015-01-15 00:51:35.000000', 'consum', 0.0225, 'lps'),
	(368431, 125, '2015-01-15 00:51:36.000000', 'consum', 0.0220, 'lps'),
	(368432, 125, '2015-01-15 00:51:37.000000', 'consum', 0.0213, 'lps'),
	(368433, 125, '2015-01-15 00:51:38.000000', 'consum', 0.0214, 'lps'),
	(368434, 125, '2015-01-15 00:51:39.000000', 'consum', 0.0219, 'lps'),
	(368435, 125, '2015-01-15 00:51:40.000000', 'consum', 0.0213, 'lps'),
	(368436, 125, '2015-01-15 00:51:41.000000', 'consum', 0.0214, 'lps'),
	(368437, 125, '2015-01-15 00:51:42.000000', 'consum', 0.0224, 'lps'),
	(368438, 125, '2015-01-15 00:51:43.000000', 'consum', 0.0214, 'lps'),
	(368439, 125, '2015-01-15 00:51:44.000000', 'consum', 0.0224, 'lps'),
	(368440, 125, '2015-01-15 00:51:45.000000', 'consum', 0.0217, 'lps'),
	(368441, 125, '2015-01-15 00:51:46.000000', 'consum', 0.0220, 'lps'),
	(368442, 125, '2015-01-15 00:51:47.000000', 'consum', 0.0223, 'lps'),
	(368443, 125, '2015-01-15 00:51:48.000000', 'consum', 0.0213, 'lps'),
	(368444, 125, '2015-01-15 00:51:49.000000', 'consum', 0.0221, 'lps'),
	(368445, 125, '2015-01-15 00:51:50.000000', 'consum', 0.0221, 'lps'),
	(368446, 125, '2015-01-15 00:51:51.000000', 'consum', 0.0218, 'lps'),
	(368447, 125, '2015-01-15 00:51:52.000000', 'consum', 0.0215, 'lps'),
	(368448, 125, '2015-01-15 00:51:53.000000', 'consum', 0.0213, 'lps'),
	(368449, 125, '2015-01-15 00:51:54.000000', 'consum', 0.0211, 'lps'),
	(368450, 125, '2015-01-15 00:51:55.000000', 'consum', 0.0222, 'lps'),
	(368451, 125, '2015-01-15 00:51:56.000000', 'consum', 0.0218, 'lps'),
	(368452, 125, '2015-01-15 00:51:57.000000', 'consum', 0.0215, 'lps'),
	(368453, 125, '2015-01-15 00:51:58.000000', 'consum', 0.0212, 'lps'),
	(368454, 125, '2015-01-15 00:51:59.000000', 'consum', 0.0221, 'lps'),
	(368455, 125, '2015-01-15 00:52:00.000000', 'consum', 0.0211, 'lps'),
	(368456, 125, '2015-01-15 00:52:01.000000', 'consum', 0.0214, 'lps'),
	(368457, 125, '2015-01-15 00:52:02.000000', 'consum', 0.0211, 'lps'),
	(368458, 125, '2015-01-15 00:52:03.000000', 'consum', 0.0220, 'lps'),
	(368459, 125, '2015-01-15 00:52:04.000000', 'consum', 0.0225, 'lps'),
	(368460, 125, '2015-01-15 00:52:05.000000', 'consum', 0.0221, 'lps'),
	(368461, 125, '2015-01-15 00:52:06.000000', 'consum', 0.0221, 'lps'),
	(368462, 125, '2015-01-15 00:52:07.000000', 'consum', 0.0216, 'lps'),
	(368463, 125, '2015-01-15 00:52:08.000000', 'consum', 0.0222, 'lps'),
	(368464, 125, '2015-01-15 00:52:09.000000', 'consum', 0.0218, 'lps'),
	(368465, 125, '2015-01-15 00:52:10.000000', 'consum', 0.0218, 'lps'),
	(368466, 125, '2015-01-15 00:52:11.000000', 'consum', 0.0223, 'lps'),
	(368467, 125, '2015-01-15 00:52:12.000000', 'consum', 0.0220, 'lps'),
	(368468, 125, '2015-01-15 00:52:13.000000', 'consum', 0.0219, 'lps'),
	(368469, 125, '2015-01-15 00:52:14.000000', 'consum', 0.0210, 'lps'),
	(368470, 125, '2015-01-15 00:52:15.000000', 'consum', 0.0216, 'lps'),
	(368471, 125, '2015-01-15 00:52:16.000000', 'consum', 0.0223, 'lps'),
	(368472, 125, '2015-01-15 00:52:17.000000', 'consum', 0.0223, 'lps'),
	(368473, 125, '2015-01-15 00:52:18.000000', 'consum', 0.0221, 'lps'),
	(368474, 125, '2015-01-15 00:52:19.000000', 'consum', 0.0225, 'lps'),
	(368475, 125, '2015-01-15 00:52:20.000000', 'consum', 0.0220, 'lps'),
	(368476, 125, '2015-01-15 00:52:21.000000', 'consum', 0.0216, 'lps'),
	(368477, 125, '2015-01-15 00:52:22.000000', 'consum', 0.0226, 'lps'),
	(368478, 125, '2015-01-15 00:52:23.000000', 'consum', 0.0222, 'lps'),
	(368479, 125, '2015-01-15 00:52:24.000000', 'consum', 0.0221, 'lps'),
	(368480, 125, '2015-01-15 00:52:25.000000', 'consum', 0.0212, 'lps'),
	(368481, 125, '2015-01-15 00:52:26.000000', 'consum', 0.0223, 'lps'),
	(368482, 125, '2015-01-15 00:52:27.000000', 'consum', 0.0220, 'lps'),
	(368483, 125, '2015-01-15 00:52:28.000000', 'consum', 0.0221, 'lps'),
	(368484, 125, '2015-01-15 00:52:29.000000', 'consum', 0.0220, 'lps'),
	(368485, 125, '2015-01-15 00:52:30.000000', 'consum', 0.0225, 'lps'),
	(368486, 125, '2015-01-15 00:52:31.000000', 'consum', 0.0221, 'lps'),
	(368487, 125, '2015-01-15 00:52:32.000000', 'consum', 0.0222, 'lps'),
	(368488, 125, '2015-01-15 00:52:33.000000', 'consum', 0.0219, 'lps'),
	(368489, 125, '2015-01-15 00:52:34.000000', 'consum', 0.0219, 'lps'),
	(368490, 125, '2015-01-15 00:52:35.000000', 'consum', 0.0214, 'lps'),
	(368491, 125, '2015-01-15 00:52:36.000000', 'consum', 0.0220, 'lps'),
	(368492, 125, '2015-01-15 00:52:37.000000', 'consum', 0.0213, 'lps'),
	(368493, 125, '2015-01-15 00:52:38.000000', 'consum', 0.0214, 'lps'),
	(368494, 125, '2015-01-15 00:52:39.000000', 'consum', 0.0221, 'lps'),
	(368495, 125, '2015-01-15 00:52:40.000000', 'consum', 0.0220, 'lps'),
	(368496, 125, '2015-01-15 00:52:41.000000', 'consum', 0.0212, 'lps'),
	(368497, 125, '2015-01-15 00:52:42.000000', 'consum', 0.0223, 'lps'),
	(368498, 125, '2015-01-15 00:52:43.000000', 'consum', 0.0217, 'lps'),
	(368499, 125, '2015-01-15 00:52:44.000000', 'consum', 0.0226, 'lps'),
	(368500, 125, '2015-01-15 00:52:45.000000', 'consum', 0.0217, 'lps'),
	(368501, 125, '2015-01-15 00:52:46.000000', 'consum', 0.0216, 'lps'),
	(368502, 125, '2015-01-15 00:52:47.000000', 'consum', 0.0220, 'lps'),
	(368503, 125, '2015-01-15 00:52:48.000000', 'consum', 0.0223, 'lps'),
	(368504, 125, '2015-01-15 00:52:49.000000', 'consum', 0.0212, 'lps'),
	(368505, 125, '2015-01-15 00:52:50.000000', 'consum', 0.0214, 'lps'),
	(368506, 125, '2015-01-15 00:52:51.000000', 'consum', 0.0211, 'lps'),
	(368507, 125, '2015-01-15 00:52:52.000000', 'consum', 0.0218, 'lps'),
	(368508, 125, '2015-01-15 00:52:53.000000', 'consum', 0.0216, 'lps'),
	(368509, 125, '2015-01-15 00:52:54.000000', 'consum', 0.0217, 'lps'),
	(368510, 125, '2015-01-15 00:52:55.000000', 'consum', 0.0225, 'lps'),
	(368511, 125, '2015-01-15 00:52:56.000000', 'consum', 0.0213, 'lps'),
	(368512, 125, '2015-01-15 00:52:57.000000', 'consum', 0.0214, 'lps'),
	(368513, 125, '2015-01-15 00:52:58.000000', 'consum', 0.0221, 'lps'),
	(368514, 125, '2015-01-15 00:52:59.000000', 'consum', 0.0219, 'lps'),
	(368515, 125, '2015-01-15 00:53:00.000000', 'consum', 0.0223, 'lps'),
	(368516, 125, '2015-01-15 00:53:01.000000', 'consum', 0.0213, 'lps'),
	(368517, 125, '2015-01-15 00:53:02.000000', 'consum', 0.0222, 'lps'),
	(368518, 125, '2015-01-15 00:53:03.000000', 'consum', 0.0225, 'lps'),
	(368519, 125, '2015-01-15 00:53:04.000000', 'consum', 0.0219, 'lps'),
	(368520, 125, '2015-01-15 00:53:05.000000', 'consum', 0.0210, 'lps'),
	(368521, 125, '2015-01-15 00:53:06.000000', 'consum', 0.0216, 'lps'),
	(368522, 125, '2015-01-15 00:53:07.000000', 'consum', 0.0223, 'lps'),
	(368523, 125, '2015-01-15 00:53:08.000000', 'consum', 0.0226, 'lps'),
	(368524, 125, '2015-01-15 00:53:09.000000', 'consum', 0.0215, 'lps'),
	(368525, 125, '2015-01-15 00:53:10.000000', 'consum', 0.0222, 'lps'),
	(368526, 125, '2015-01-15 00:53:11.000000', 'consum', 0.0223, 'lps'),
	(368527, 125, '2015-01-15 00:53:12.000000', 'consum', 0.0223, 'lps'),
	(368528, 125, '2015-01-15 00:53:13.000000', 'consum', 0.0217, 'lps'),
	(368529, 125, '2015-01-15 00:53:14.000000', 'consum', 0.0226, 'lps'),
	(368530, 125, '2015-01-15 00:53:15.000000', 'consum', 0.0217, 'lps'),
	(368531, 125, '2015-01-15 00:53:16.000000', 'consum', 0.0213, 'lps'),
	(368532, 125, '2015-01-15 00:53:17.000000', 'consum', 0.0223, 'lps'),
	(368533, 125, '2015-01-15 00:53:18.000000', 'consum', 0.0215, 'lps'),
	(368534, 125, '2015-01-15 00:53:19.000000', 'consum', 0.0213, 'lps'),
	(368535, 125, '2015-01-15 00:53:20.000000', 'consum', 0.0213, 'lps'),
	(368536, 125, '2015-01-15 00:53:21.000000', 'consum', 0.0214, 'lps'),
	(368537, 125, '2015-01-15 00:53:22.000000', 'consum', 0.0223, 'lps'),
	(368538, 125, '2015-01-15 00:53:23.000000', 'consum', 0.0213, 'lps'),
	(368539, 125, '2015-01-15 00:53:24.000000', 'consum', 0.0219, 'lps'),
	(368540, 125, '2015-01-15 00:53:25.000000', 'consum', 0.0211, 'lps'),
	(368541, 125, '2015-01-15 00:53:26.000000', 'consum', 0.0224, 'lps'),
	(368542, 125, '2015-01-15 00:53:27.000000', 'consum', 0.0210, 'lps'),
	(368543, 125, '2015-01-15 00:53:28.000000', 'consum', 0.0221, 'lps'),
	(368544, 125, '2015-01-15 00:53:29.000000', 'consum', 0.0211, 'lps'),
	(368545, 125, '2015-01-15 00:53:30.000000', 'consum', 0.0219, 'lps'),
	(368546, 125, '2015-01-15 00:53:31.000000', 'consum', 0.0218, 'lps'),
	(368547, 125, '2015-01-15 00:53:32.000000', 'consum', 0.0222, 'lps'),
	(368548, 125, '2015-01-15 00:53:33.000000', 'consum', 0.0214, 'lps'),
	(368549, 125, '2015-01-15 00:53:34.000000', 'consum', 0.0211, 'lps'),
	(368550, 125, '2015-01-15 00:53:35.000000', 'consum', 0.0222, 'lps'),
	(368551, 125, '2015-01-15 00:53:36.000000', 'consum', 0.0213, 'lps'),
	(368552, 125, '2015-01-15 00:53:37.000000', 'consum', 0.0210, 'lps'),
	(368553, 125, '2015-01-15 00:53:38.000000', 'consum', 0.0217, 'lps'),
	(368554, 125, '2015-01-15 00:53:39.000000', 'consum', 0.0213, 'lps'),
	(368555, 125, '2015-01-15 00:53:40.000000', 'consum', 0.0219, 'lps'),
	(368556, 125, '2015-01-15 00:53:41.000000', 'consum', 0.0215, 'lps'),
	(368557, 125, '2015-01-15 00:53:42.000000', 'consum', 0.0226, 'lps'),
	(368558, 125, '2015-01-15 00:53:43.000000', 'consum', 0.0225, 'lps'),
	(368559, 125, '2015-01-15 00:53:44.000000', 'consum', 0.0220, 'lps'),
	(368560, 125, '2015-01-15 00:53:45.000000', 'consum', 0.0213, 'lps'),
	(368561, 125, '2015-01-15 00:53:46.000000', 'consum', 0.0215, 'lps'),
	(368562, 125, '2015-01-15 00:53:47.000000', 'consum', 0.0225, 'lps'),
	(368563, 125, '2015-01-15 00:53:48.000000', 'consum', 0.0222, 'lps'),
	(368564, 125, '2015-01-15 00:53:49.000000', 'consum', 0.0224, 'lps'),
	(368565, 125, '2015-01-15 00:53:50.000000', 'consum', 0.0212, 'lps'),
	(368566, 125, '2015-01-15 00:53:51.000000', 'consum', 0.0211, 'lps'),
	(368567, 125, '2015-01-15 00:53:52.000000', 'consum', 0.0211, 'lps'),
	(368568, 125, '2015-01-15 00:53:53.000000', 'consum', 0.0212, 'lps'),
	(368569, 125, '2015-01-15 00:53:54.000000', 'consum', 0.0216, 'lps'),
	(368570, 125, '2015-01-15 00:53:55.000000', 'consum', 0.0220, 'lps'),
	(368571, 125, '2015-01-15 00:53:56.000000', 'consum', 0.0223, 'lps'),
	(368572, 125, '2015-01-15 00:53:57.000000', 'consum', 0.0212, 'lps'),
	(368573, 125, '2015-01-15 00:53:58.000000', 'consum', 0.0216, 'lps'),
	(368574, 125, '2015-01-15 00:53:59.000000', 'consum', 0.0220, 'lps'),
	(368575, 125, '2015-01-15 00:54:00.000000', 'consum', 0.0222, 'lps'),
	(368576, 125, '2015-01-15 00:54:01.000000', 'consum', 0.0223, 'lps'),
	(368577, 125, '2015-01-15 00:54:02.000000', 'consum', 0.0224, 'lps'),
	(368578, 125, '2015-01-15 00:54:03.000000', 'consum', 0.0223, 'lps'),
	(368579, 125, '2015-01-15 00:54:04.000000', 'consum', 0.0218, 'lps'),
	(368580, 125, '2015-01-15 00:54:05.000000', 'consum', 0.0210, 'lps'),
	(368581, 125, '2015-01-15 00:54:06.000000', 'consum', 0.0222, 'lps'),
	(368582, 125, '2015-01-15 00:54:07.000000', 'consum', 0.0217, 'lps'),
	(368583, 125, '2015-01-15 00:54:08.000000', 'consum', 0.0212, 'lps'),
	(368584, 125, '2015-01-15 00:54:09.000000', 'consum', 0.0214, 'lps'),
	(368585, 125, '2015-01-15 00:54:10.000000', 'consum', 0.0225, 'lps'),
	(368586, 125, '2015-01-15 00:54:11.000000', 'consum', 0.0224, 'lps'),
	(368587, 125, '2015-01-15 00:54:12.000000', 'consum', 0.0220, 'lps'),
	(368588, 125, '2015-01-15 00:54:13.000000', 'consum', 0.0215, 'lps'),
	(368589, 125, '2015-01-15 00:54:14.000000', 'consum', 0.0226, 'lps'),
	(368590, 125, '2015-01-15 00:54:15.000000', 'consum', 0.0222, 'lps'),
	(368591, 125, '2015-01-15 00:54:16.000000', 'consum', 0.0221, 'lps'),
	(368592, 125, '2015-01-15 00:54:17.000000', 'consum', 0.0216, 'lps'),
	(368593, 125, '2015-01-15 00:54:18.000000', 'consum', 0.0223, 'lps'),
	(368594, 125, '2015-01-15 00:54:19.000000', 'consum', 0.0223, 'lps'),
	(368595, 125, '2015-01-15 00:54:20.000000', 'consum', 0.0220, 'lps'),
	(368596, 125, '2015-01-15 00:54:21.000000', 'consum', 0.0223, 'lps'),
	(368597, 125, '2015-01-15 00:54:22.000000', 'consum', 0.0211, 'lps'),
	(368598, 125, '2015-01-15 00:54:23.000000', 'consum', 0.0225, 'lps'),
	(368599, 125, '2015-01-15 00:54:24.000000', 'consum', 0.0217, 'lps'),
	(368600, 125, '2015-01-15 00:54:25.000000', 'consum', 0.0216, 'lps'),
	(368601, 125, '2015-01-15 00:54:26.000000', 'consum', 0.0221, 'lps'),
	(368602, 125, '2015-01-15 00:54:27.000000', 'consum', 0.0212, 'lps'),
	(368603, 125, '2015-01-15 00:54:28.000000', 'consum', 0.0222, 'lps'),
	(368604, 125, '2015-01-15 00:54:29.000000', 'consum', 0.0212, 'lps'),
	(368605, 125, '2015-01-15 00:54:30.000000', 'consum', 0.0218, 'lps'),
	(368606, 125, '2015-01-15 00:54:31.000000', 'consum', 0.0211, 'lps'),
	(368607, 125, '2015-01-15 00:54:32.000000', 'consum', 0.0210, 'lps'),
	(368608, 125, '2015-01-15 00:54:33.000000', 'consum', 0.0222, 'lps'),
	(368609, 125, '2015-01-15 00:54:34.000000', 'consum', 0.0221, 'lps'),
	(368610, 125, '2015-01-15 00:54:35.000000', 'consum', 0.0213, 'lps'),
	(368611, 125, '2015-01-15 00:54:36.000000', 'consum', 0.0226, 'lps'),
	(368612, 125, '2015-01-15 00:54:37.000000', 'consum', 0.0213, 'lps'),
	(368613, 125, '2015-01-15 00:54:38.000000', 'consum', 0.0212, 'lps'),
	(368614, 125, '2015-01-15 00:54:39.000000', 'consum', 0.0211, 'lps'),
	(368615, 125, '2015-01-15 00:54:40.000000', 'consum', 0.0226, 'lps'),
	(368616, 125, '2015-01-15 00:54:41.000000', 'consum', 0.0218, 'lps'),
	(368617, 125, '2015-01-15 00:54:42.000000', 'consum', 0.0221, 'lps'),
	(368618, 125, '2015-01-15 00:54:43.000000', 'consum', 0.0226, 'lps'),
	(368619, 125, '2015-01-15 00:54:44.000000', 'consum', 0.0221, 'lps'),
	(368620, 125, '2015-01-15 00:54:45.000000', 'consum', 0.0218, 'lps'),
	(368621, 125, '2015-01-15 00:54:46.000000', 'consum', 0.0218, 'lps'),
	(368622, 125, '2015-01-15 00:54:47.000000', 'consum', 0.0226, 'lps'),
	(368623, 125, '2015-01-15 00:54:48.000000', 'consum', 0.0214, 'lps'),
	(368624, 125, '2015-01-15 00:54:49.000000', 'consum', 0.0217, 'lps'),
	(368625, 125, '2015-01-15 00:54:50.000000', 'consum', 0.0218, 'lps'),
	(368626, 125, '2015-01-15 00:54:51.000000', 'consum', 0.0211, 'lps'),
	(368627, 125, '2015-01-15 00:54:52.000000', 'consum', 0.0226, 'lps'),
	(368628, 125, '2015-01-15 00:54:53.000000', 'consum', 0.0221, 'lps'),
	(368629, 125, '2015-01-15 00:54:54.000000', 'consum', 0.0218, 'lps'),
	(368630, 125, '2015-01-15 00:54:55.000000', 'consum', 0.0216, 'lps'),
	(368631, 125, '2015-01-15 00:54:56.000000', 'consum', 0.0218, 'lps'),
	(368632, 125, '2015-01-15 00:54:57.000000', 'consum', 0.0215, 'lps'),
	(368633, 125, '2015-01-15 00:54:58.000000', 'consum', 0.0212, 'lps'),
	(368634, 125, '2015-01-15 00:54:59.000000', 'consum', 0.0224, 'lps'),
	(368635, 125, '2015-01-15 00:55:00.000000', 'consum', 0.0222, 'lps'),
	(368636, 125, '2015-01-15 00:55:01.000000', 'consum', 0.0211, 'lps'),
	(368637, 125, '2015-01-15 00:55:02.000000', 'consum', 0.0213, 'lps'),
	(368638, 125, '2015-01-15 00:55:03.000000', 'consum', 0.0224, 'lps'),
	(368639, 125, '2015-01-15 00:55:04.000000', 'consum', 0.0221, 'lps'),
	(368640, 125, '2015-01-15 00:55:05.000000', 'consum', 0.0223, 'lps'),
	(368641, 125, '2015-01-15 00:55:06.000000', 'consum', 0.0223, 'lps'),
	(368642, 125, '2015-01-15 00:55:07.000000', 'consum', 0.0222, 'lps'),
	(368643, 125, '2015-01-15 00:55:08.000000', 'consum', 0.0216, 'lps'),
	(368644, 125, '2015-01-15 00:55:09.000000', 'consum', 0.0220, 'lps'),
	(368645, 125, '2015-01-15 00:55:10.000000', 'consum', 0.0225, 'lps'),
	(368646, 125, '2015-01-15 00:55:11.000000', 'consum', 0.0220, 'lps'),
	(368647, 125, '2015-01-15 00:55:12.000000', 'consum', 0.0218, 'lps'),
	(368648, 125, '2015-01-15 00:55:13.000000', 'consum', 0.0219, 'lps'),
	(368649, 125, '2015-01-15 00:55:14.000000', 'consum', 0.0216, 'lps'),
	(368650, 125, '2015-01-15 00:55:15.000000', 'consum', 0.0213, 'lps'),
	(368651, 125, '2015-01-15 00:55:16.000000', 'consum', 0.0225, 'lps'),
	(368652, 125, '2015-01-15 00:55:17.000000', 'consum', 0.0224, 'lps'),
	(368653, 125, '2015-01-15 00:55:18.000000', 'consum', 0.0221, 'lps'),
	(368654, 125, '2015-01-15 00:55:19.000000', 'consum', 0.0223, 'lps'),
	(368655, 125, '2015-01-15 00:55:20.000000', 'consum', 0.0210, 'lps'),
	(368656, 125, '2015-01-15 00:55:21.000000', 'consum', 0.0220, 'lps'),
	(368657, 125, '2015-01-15 00:55:22.000000', 'consum', 0.0226, 'lps'),
	(368658, 125, '2015-01-15 00:55:23.000000', 'consum', 0.0211, 'lps'),
	(368659, 125, '2015-01-15 00:55:24.000000', 'consum', 0.0220, 'lps'),
	(368660, 125, '2015-01-15 00:55:25.000000', 'consum', 0.0220, 'lps'),
	(368661, 125, '2015-01-15 00:55:26.000000', 'consum', 0.0217, 'lps'),
	(368662, 125, '2015-01-15 00:55:27.000000', 'consum', 0.0213, 'lps'),
	(368663, 125, '2015-01-15 00:55:28.000000', 'consum', 0.0223, 'lps'),
	(368664, 125, '2015-01-15 00:55:29.000000', 'consum', 0.0215, 'lps'),
	(368665, 125, '2015-01-15 00:55:30.000000', 'consum', 0.0215, 'lps'),
	(368666, 125, '2015-01-15 00:55:31.000000', 'consum', 0.0219, 'lps'),
	(368667, 125, '2015-01-15 00:55:32.000000', 'consum', 0.0222, 'lps'),
	(368668, 125, '2015-01-15 00:55:33.000000', 'consum', 0.0212, 'lps'),
	(368669, 125, '2015-01-15 00:55:34.000000', 'consum', 0.0216, 'lps'),
	(368670, 125, '2015-01-15 00:55:35.000000', 'consum', 0.0219, 'lps'),
	(368671, 125, '2015-01-15 00:55:36.000000', 'consum', 0.0220, 'lps'),
	(368672, 125, '2015-01-15 00:55:37.000000', 'consum', 0.0216, 'lps'),
	(368673, 125, '2015-01-15 00:55:38.000000', 'consum', 0.0210, 'lps'),
	(368674, 125, '2015-01-15 00:55:39.000000', 'consum', 0.0212, 'lps'),
	(368675, 125, '2015-01-15 00:55:40.000000', 'consum', 0.0220, 'lps'),
	(368676, 125, '2015-01-15 00:55:41.000000', 'consum', 0.0220, 'lps'),
	(368677, 125, '2015-01-15 00:55:42.000000', 'consum', 0.0213, 'lps'),
	(368678, 125, '2015-01-15 00:55:43.000000', 'consum', 0.0212, 'lps'),
	(368679, 125, '2015-01-15 00:55:44.000000', 'consum', 0.0213, 'lps'),
	(368680, 125, '2015-01-15 00:55:45.000000', 'consum', 0.0217, 'lps'),
	(368681, 125, '2015-01-15 00:55:46.000000', 'consum', 0.0220, 'lps'),
	(368682, 125, '2015-01-15 00:55:47.000000', 'consum', 0.0224, 'lps'),
	(368683, 125, '2015-01-15 00:55:48.000000', 'consum', 0.0216, 'lps'),
	(368684, 125, '2015-01-15 00:55:49.000000', 'consum', 0.0217, 'lps'),
	(368685, 125, '2015-01-15 00:55:50.000000', 'consum', 0.0211, 'lps'),
	(368686, 125, '2015-01-15 00:55:51.000000', 'consum', 0.0226, 'lps'),
	(368687, 125, '2015-01-15 00:55:52.000000', 'consum', 0.0220, 'lps'),
	(368688, 125, '2015-01-15 00:55:53.000000', 'consum', 0.0211, 'lps'),
	(368689, 125, '2015-01-15 00:55:54.000000', 'consum', 0.0220, 'lps'),
	(368690, 125, '2015-01-15 00:55:55.000000', 'consum', 0.0222, 'lps'),
	(368691, 125, '2015-01-15 00:55:56.000000', 'consum', 0.0225, 'lps'),
	(368692, 125, '2015-01-15 00:55:57.000000', 'consum', 0.0217, 'lps'),
	(368693, 125, '2015-01-15 00:55:58.000000', 'consum', 0.0218, 'lps'),
	(368694, 125, '2015-01-15 00:55:59.000000', 'consum', 0.0212, 'lps'),
	(368695, 125, '2015-01-15 00:56:00.000000', 'consum', 0.0215, 'lps'),
	(368696, 125, '2015-01-15 00:56:01.000000', 'consum', 0.0226, 'lps'),
	(368697, 125, '2015-01-15 00:56:02.000000', 'consum', 0.0210, 'lps'),
	(368698, 125, '2015-01-15 00:56:03.000000', 'consum', 0.0212, 'lps'),
	(368699, 125, '2015-01-15 00:56:04.000000', 'consum', 0.0221, 'lps'),
	(368700, 125, '2015-01-15 00:56:05.000000', 'consum', 0.0210, 'lps'),
	(368701, 125, '2015-01-15 00:56:06.000000', 'consum', 0.0226, 'lps'),
	(368702, 125, '2015-01-15 00:56:07.000000', 'consum', 0.0225, 'lps'),
	(368703, 125, '2015-01-15 00:56:08.000000', 'consum', 0.0221, 'lps'),
	(368704, 125, '2015-01-15 00:56:09.000000', 'consum', 0.0218, 'lps'),
	(368705, 125, '2015-01-15 00:56:10.000000', 'consum', 0.0219, 'lps'),
	(368706, 125, '2015-01-15 00:56:11.000000', 'consum', 0.0213, 'lps'),
	(368707, 125, '2015-01-15 00:56:12.000000', 'consum', 0.0217, 'lps'),
	(368708, 125, '2015-01-15 00:56:13.000000', 'consum', 0.0219, 'lps'),
	(368709, 125, '2015-01-15 00:56:14.000000', 'consum', 0.0216, 'lps'),
	(368710, 125, '2015-01-15 00:56:15.000000', 'consum', 0.0216, 'lps'),
	(368711, 125, '2015-01-15 00:56:16.000000', 'consum', 0.0224, 'lps'),
	(368712, 125, '2015-01-15 00:56:17.000000', 'consum', 0.0225, 'lps'),
	(368713, 125, '2015-01-15 00:56:18.000000', 'consum', 0.0210, 'lps'),
	(368714, 125, '2015-01-15 00:56:19.000000', 'consum', 0.0216, 'lps'),
	(368715, 125, '2015-01-15 00:56:20.000000', 'consum', 0.0222, 'lps'),
	(368716, 125, '2015-01-15 00:56:21.000000', 'consum', 0.0221, 'lps'),
	(368717, 125, '2015-01-15 00:56:22.000000', 'consum', 0.0211, 'lps'),
	(368718, 125, '2015-01-15 00:56:23.000000', 'consum', 0.0216, 'lps'),
	(368719, 125, '2015-01-15 00:56:24.000000', 'consum', 0.0220, 'lps'),
	(368720, 125, '2015-01-15 00:56:25.000000', 'consum', 0.0210, 'lps'),
	(368721, 125, '2015-01-15 00:56:26.000000', 'consum', 0.0213, 'lps'),
	(368722, 125, '2015-01-15 00:56:27.000000', 'consum', 0.0210, 'lps'),
	(368723, 125, '2015-01-15 00:56:28.000000', 'consum', 0.0217, 'lps'),
	(368724, 125, '2015-01-15 00:56:29.000000', 'consum', 0.0213, 'lps'),
	(368725, 125, '2015-01-15 00:56:30.000000', 'consum', 0.0221, 'lps'),
	(368726, 125, '2015-01-15 00:56:31.000000', 'consum', 0.0221, 'lps'),
	(368727, 125, '2015-01-15 00:56:32.000000', 'consum', 0.0216, 'lps'),
	(368728, 125, '2015-01-15 00:56:33.000000', 'consum', 0.0226, 'lps'),
	(368729, 125, '2015-01-15 00:56:34.000000', 'consum', 0.0220, 'lps'),
	(368730, 125, '2015-01-15 00:56:35.000000', 'consum', 0.0212, 'lps'),
	(368731, 125, '2015-01-15 00:56:36.000000', 'consum', 0.0225, 'lps'),
	(368732, 125, '2015-01-15 00:56:37.000000', 'consum', 0.0211, 'lps'),
	(368733, 125, '2015-01-15 00:56:38.000000', 'consum', 0.0222, 'lps'),
	(368734, 125, '2015-01-15 00:56:39.000000', 'consum', 0.0215, 'lps'),
	(368735, 125, '2015-01-15 00:56:40.000000', 'consum', 0.0216, 'lps'),
	(368736, 125, '2015-01-15 00:56:41.000000', 'consum', 0.0210, 'lps'),
	(368737, 125, '2015-01-15 00:56:42.000000', 'consum', 0.0210, 'lps'),
	(368738, 125, '2015-01-15 00:56:43.000000', 'consum', 0.0226, 'lps'),
	(368739, 125, '2015-01-15 00:56:44.000000', 'consum', 0.0222, 'lps'),
	(368740, 125, '2015-01-15 00:56:45.000000', 'consum', 0.0222, 'lps'),
	(368741, 125, '2015-01-15 00:56:46.000000', 'consum', 0.0220, 'lps'),
	(368742, 125, '2015-01-15 00:56:47.000000', 'consum', 0.0224, 'lps'),
	(368743, 125, '2015-01-15 00:56:48.000000', 'consum', 0.0217, 'lps'),
	(368744, 125, '2015-01-15 00:56:49.000000', 'consum', 0.0218, 'lps'),
	(368745, 125, '2015-01-15 00:56:50.000000', 'consum', 0.0215, 'lps'),
	(368746, 125, '2015-01-15 00:56:51.000000', 'consum', 0.0212, 'lps'),
	(368747, 125, '2015-01-15 00:56:52.000000', 'consum', 0.0221, 'lps'),
	(368748, 125, '2015-01-15 00:56:53.000000', 'consum', 0.0224, 'lps'),
	(368749, 125, '2015-01-15 00:56:54.000000', 'consum', 0.0217, 'lps'),
	(368750, 125, '2015-01-15 00:56:55.000000', 'consum', 0.0218, 'lps'),
	(368751, 125, '2015-01-15 00:56:56.000000', 'consum', 0.0214, 'lps'),
	(368752, 125, '2015-01-15 00:56:57.000000', 'consum', 0.0224, 'lps'),
	(368753, 125, '2015-01-15 00:56:58.000000', 'consum', 0.0217, 'lps'),
	(368754, 125, '2015-01-15 00:56:59.000000', 'consum', 0.0220, 'lps'),
	(368755, 125, '2015-01-15 00:57:00.000000', 'consum', 0.0222, 'lps'),
	(368756, 125, '2015-01-15 00:57:01.000000', 'consum', 0.0225, 'lps'),
	(368757, 125, '2015-01-15 00:57:02.000000', 'consum', 0.0216, 'lps'),
	(368758, 125, '2015-01-15 00:57:03.000000', 'consum', 0.0213, 'lps'),
	(368759, 125, '2015-01-15 00:57:04.000000', 'consum', 0.0226, 'lps'),
	(368760, 125, '2015-01-15 00:57:05.000000', 'consum', 0.0210, 'lps'),
	(368761, 125, '2015-01-15 00:57:06.000000', 'consum', 0.0216, 'lps'),
	(368762, 125, '2015-01-15 00:57:07.000000', 'consum', 0.0224, 'lps'),
	(368763, 125, '2015-01-15 00:57:08.000000', 'consum', 0.0210, 'lps'),
	(368764, 125, '2015-01-15 00:57:09.000000', 'consum', 0.0220, 'lps'),
	(368765, 125, '2015-01-15 00:57:10.000000', 'consum', 0.0226, 'lps'),
	(368766, 125, '2015-01-15 00:57:11.000000', 'consum', 0.0211, 'lps'),
	(368767, 125, '2015-01-15 00:57:12.000000', 'consum', 0.0217, 'lps'),
	(368768, 125, '2015-01-15 00:57:13.000000', 'consum', 0.0211, 'lps'),
	(368769, 125, '2015-01-15 00:57:14.000000', 'consum', 0.0210, 'lps'),
	(368770, 125, '2015-01-15 00:57:15.000000', 'consum', 0.0223, 'lps'),
	(368771, 125, '2015-01-15 00:57:16.000000', 'consum', 0.0226, 'lps'),
	(368772, 125, '2015-01-15 00:57:17.000000', 'consum', 0.0218, 'lps'),
	(368773, 125, '2015-01-15 00:57:18.000000', 'consum', 0.0219, 'lps'),
	(368774, 125, '2015-01-15 00:57:19.000000', 'consum', 0.0215, 'lps'),
	(368775, 125, '2015-01-15 00:57:20.000000', 'consum', 0.0226, 'lps'),
	(368776, 125, '2015-01-15 00:57:21.000000', 'consum', 0.0223, 'lps'),
	(368777, 125, '2015-01-15 00:57:22.000000', 'consum', 0.0212, 'lps'),
	(368778, 125, '2015-01-15 00:57:23.000000', 'consum', 0.0215, 'lps'),
	(368779, 125, '2015-01-15 00:57:24.000000', 'consum', 0.0212, 'lps'),
	(368780, 125, '2015-01-15 00:57:25.000000', 'consum', 0.0223, 'lps'),
	(368781, 125, '2015-01-15 00:57:26.000000', 'consum', 0.0217, 'lps'),
	(368782, 125, '2015-01-15 00:57:27.000000', 'consum', 0.0226, 'lps'),
	(368783, 125, '2015-01-15 00:57:28.000000', 'consum', 0.0219, 'lps'),
	(368784, 125, '2015-01-15 00:57:29.000000', 'consum', 0.0223, 'lps'),
	(368785, 125, '2015-01-15 00:57:30.000000', 'consum', 0.0214, 'lps'),
	(368786, 125, '2015-01-15 00:57:31.000000', 'consum', 0.0225, 'lps'),
	(368787, 125, '2015-01-15 00:57:32.000000', 'consum', 0.0222, 'lps'),
	(368788, 125, '2015-01-15 00:57:33.000000', 'consum', 0.0210, 'lps'),
	(368789, 125, '2015-01-15 00:57:34.000000', 'consum', 0.0210, 'lps'),
	(368790, 125, '2015-01-15 00:57:35.000000', 'consum', 0.0210, 'lps'),
	(368791, 125, '2015-01-15 00:57:36.000000', 'consum', 0.0225, 'lps'),
	(368792, 125, '2015-01-15 00:57:37.000000', 'consum', 0.0218, 'lps'),
	(368793, 125, '2015-01-15 00:57:38.000000', 'consum', 0.0223, 'lps'),
	(368794, 125, '2015-01-15 00:57:39.000000', 'consum', 0.0215, 'lps'),
	(368795, 125, '2015-01-15 00:57:40.000000', 'consum', 0.0217, 'lps'),
	(368796, 125, '2015-01-15 00:57:41.000000', 'consum', 0.0213, 'lps'),
	(368797, 125, '2015-01-15 00:57:42.000000', 'consum', 0.0219, 'lps'),
	(368798, 125, '2015-01-15 00:57:43.000000', 'consum', 0.0214, 'lps'),
	(368799, 125, '2015-01-15 00:57:44.000000', 'consum', 0.0219, 'lps'),
	(368800, 125, '2015-01-15 00:57:45.000000', 'consum', 0.0212, 'lps'),
	(368801, 125, '2015-01-15 00:57:46.000000', 'consum', 0.0225, 'lps'),
	(368802, 125, '2015-01-15 00:57:47.000000', 'consum', 0.0212, 'lps'),
	(368803, 125, '2015-01-15 00:57:48.000000', 'consum', 0.0211, 'lps'),
	(368804, 125, '2015-01-15 00:57:49.000000', 'consum', 0.0226, 'lps'),
	(368805, 125, '2015-01-15 00:57:50.000000', 'consum', 0.0219, 'lps'),
	(368806, 125, '2015-01-15 00:57:51.000000', 'consum', 0.0223, 'lps'),
	(368807, 125, '2015-01-15 00:57:52.000000', 'consum', 0.0215, 'lps'),
	(368808, 125, '2015-01-15 00:57:53.000000', 'consum', 0.0215, 'lps'),
	(368809, 125, '2015-01-15 00:57:54.000000', 'consum', 0.0220, 'lps'),
	(368810, 125, '2015-01-15 00:57:55.000000', 'consum', 0.0210, 'lps'),
	(368811, 125, '2015-01-15 00:57:56.000000', 'consum', 0.0215, 'lps'),
	(368812, 125, '2015-01-15 00:57:57.000000', 'consum', 0.0217, 'lps'),
	(368813, 125, '2015-01-15 00:57:58.000000', 'consum', 0.0216, 'lps'),
	(368814, 125, '2015-01-15 00:57:59.000000', 'consum', 0.0218, 'lps'),
	(368815, 125, '2015-01-15 00:58:00.000000', 'consum', 0.0216, 'lps'),
	(368816, 125, '2015-01-15 00:58:01.000000', 'consum', 0.0216, 'lps'),
	(368817, 125, '2015-01-15 00:58:02.000000', 'consum', 0.0223, 'lps'),
	(368818, 125, '2015-01-15 00:58:03.000000', 'consum', 0.0222, 'lps'),
	(368819, 125, '2015-01-15 00:58:04.000000', 'consum', 0.0216, 'lps'),
	(368820, 125, '2015-01-15 00:58:05.000000', 'consum', 0.0220, 'lps'),
	(368821, 125, '2015-01-15 00:58:06.000000', 'consum', 0.0225, 'lps'),
	(368822, 125, '2015-01-15 00:58:07.000000', 'consum', 0.0221, 'lps'),
	(368823, 125, '2015-01-15 00:58:08.000000', 'consum', 0.0223, 'lps'),
	(368824, 125, '2015-01-15 00:58:09.000000', 'consum', 0.0224, 'lps'),
	(368825, 125, '2015-01-15 00:58:10.000000', 'consum', 0.0226, 'lps'),
	(368826, 125, '2015-01-15 00:58:11.000000', 'consum', 0.0214, 'lps'),
	(368827, 125, '2015-01-15 00:58:12.000000', 'consum', 0.0215, 'lps'),
	(368828, 125, '2015-01-15 00:58:13.000000', 'consum', 0.0226, 'lps'),
	(368829, 125, '2015-01-15 00:58:14.000000', 'consum', 0.0224, 'lps'),
	(368830, 125, '2015-01-15 00:58:15.000000', 'consum', 0.0216, 'lps'),
	(368831, 125, '2015-01-15 00:58:16.000000', 'consum', 0.0215, 'lps'),
	(368832, 125, '2015-01-15 00:58:17.000000', 'consum', 0.0216, 'lps'),
	(368833, 125, '2015-01-15 00:58:18.000000', 'consum', 0.0226, 'lps'),
	(368834, 125, '2015-01-15 00:58:19.000000', 'consum', 0.0221, 'lps'),
	(368835, 125, '2015-01-15 00:58:20.000000', 'consum', 0.0218, 'lps'),
	(368836, 125, '2015-01-15 00:58:21.000000', 'consum', 0.0216, 'lps'),
	(368837, 125, '2015-01-15 00:58:22.000000', 'consum', 0.0216, 'lps'),
	(368838, 125, '2015-01-15 00:58:23.000000', 'consum', 0.0224, 'lps'),
	(368839, 125, '2015-01-15 00:58:24.000000', 'consum', 0.0210, 'lps'),
	(368840, 125, '2015-01-15 00:58:25.000000', 'consum', 0.0222, 'lps'),
	(368841, 125, '2015-01-15 00:58:26.000000', 'consum', 0.0219, 'lps'),
	(368842, 125, '2015-01-15 00:58:27.000000', 'consum', 0.0217, 'lps'),
	(368843, 125, '2015-01-15 00:58:28.000000', 'consum', 0.0220, 'lps'),
	(368844, 125, '2015-01-15 00:58:29.000000', 'consum', 0.0223, 'lps'),
	(368845, 125, '2015-01-15 00:58:30.000000', 'consum', 0.0210, 'lps'),
	(368846, 125, '2015-01-15 00:58:31.000000', 'consum', 0.0222, 'lps'),
	(368847, 125, '2015-01-15 00:58:32.000000', 'consum', 0.0221, 'lps'),
	(368848, 125, '2015-01-15 00:58:33.000000', 'consum', 0.0213, 'lps'),
	(368849, 125, '2015-01-15 00:58:34.000000', 'consum', 0.0210, 'lps'),
	(368850, 125, '2015-01-15 00:58:35.000000', 'consum', 0.0219, 'lps'),
	(368851, 125, '2015-01-15 00:58:36.000000', 'consum', 0.0220, 'lps'),
	(368852, 125, '2015-01-15 00:58:37.000000', 'consum', 0.0217, 'lps'),
	(368853, 125, '2015-01-15 00:58:38.000000', 'consum', 0.0217, 'lps'),
	(368854, 125, '2015-01-15 00:58:39.000000', 'consum', 0.0224, 'lps'),
	(368855, 125, '2015-01-15 00:58:40.000000', 'consum', 0.0226, 'lps'),
	(368856, 125, '2015-01-15 00:58:41.000000', 'consum', 0.0215, 'lps'),
	(368857, 125, '2015-01-15 00:58:42.000000', 'consum', 0.0221, 'lps'),
	(368858, 125, '2015-01-15 00:58:43.000000', 'consum', 0.0215, 'lps'),
	(368859, 125, '2015-01-15 00:58:44.000000', 'consum', 0.0221, 'lps'),
	(368860, 125, '2015-01-15 00:58:45.000000', 'consum', 0.0218, 'lps'),
	(368861, 125, '2015-01-15 00:58:46.000000', 'consum', 0.0216, 'lps'),
	(368862, 125, '2015-01-15 00:58:47.000000', 'consum', 0.0215, 'lps'),
	(368863, 125, '2015-01-15 00:58:48.000000', 'consum', 0.0219, 'lps'),
	(368864, 125, '2015-01-15 00:58:49.000000', 'consum', 0.0225, 'lps'),
	(368865, 125, '2015-01-15 00:58:50.000000', 'consum', 0.0225, 'lps'),
	(368866, 125, '2015-01-15 00:58:51.000000', 'consum', 0.0221, 'lps'),
	(368867, 125, '2015-01-15 00:58:52.000000', 'consum', 0.0221, 'lps'),
	(368868, 125, '2015-01-15 00:58:53.000000', 'consum', 0.0217, 'lps'),
	(368869, 125, '2015-01-15 00:58:54.000000', 'consum', 0.0212, 'lps'),
	(368870, 125, '2015-01-15 00:58:55.000000', 'consum', 0.0218, 'lps'),
	(368871, 125, '2015-01-15 00:58:56.000000', 'consum', 0.0224, 'lps'),
	(368872, 125, '2015-01-15 00:58:57.000000', 'consum', 0.0226, 'lps'),
	(368873, 125, '2015-01-15 00:58:58.000000', 'consum', 0.0213, 'lps'),
	(368874, 125, '2015-01-15 00:58:59.000000', 'consum', 0.0211, 'lps'),
	(368875, 125, '2015-01-15 00:59:00.000000', 'consum', 0.0222, 'lps'),
	(368876, 125, '2015-01-15 00:59:01.000000', 'consum', 0.0220, 'lps'),
	(368877, 125, '2015-01-15 00:59:02.000000', 'consum', 0.0223, 'lps'),
	(368878, 125, '2015-01-15 00:59:03.000000', 'consum', 0.0210, 'lps'),
	(368879, 125, '2015-01-15 00:59:04.000000', 'consum', 0.0223, 'lps'),
	(368880, 125, '2015-01-15 00:59:05.000000', 'consum', 0.0224, 'lps'),
	(368881, 125, '2015-01-15 00:59:06.000000', 'consum', 0.0225, 'lps'),
	(368882, 125, '2015-01-15 00:59:07.000000', 'consum', 0.0212, 'lps'),
	(368883, 125, '2015-01-15 00:59:08.000000', 'consum', 0.0223, 'lps'),
	(368884, 125, '2015-01-15 00:59:09.000000', 'consum', 0.0220, 'lps'),
	(368885, 125, '2015-01-15 00:59:10.000000', 'consum', 0.0223, 'lps'),
	(368886, 125, '2015-01-15 00:59:11.000000', 'consum', 0.0212, 'lps'),
	(368887, 125, '2015-01-15 00:59:12.000000', 'consum', 0.0216, 'lps'),
	(368888, 125, '2015-01-15 00:59:13.000000', 'consum', 0.0215, 'lps'),
	(368889, 125, '2015-01-15 00:59:14.000000', 'consum', 0.0221, 'lps'),
	(368890, 125, '2015-01-15 00:59:15.000000', 'consum', 0.0213, 'lps'),
	(368891, 125, '2015-01-15 00:59:16.000000', 'consum', 0.0226, 'lps'),
	(368892, 125, '2015-01-15 00:59:17.000000', 'consum', 0.0217, 'lps'),
	(368893, 125, '2015-01-15 00:59:18.000000', 'consum', 0.0212, 'lps'),
	(368894, 125, '2015-01-15 00:59:19.000000', 'consum', 0.0217, 'lps'),
	(368895, 125, '2015-01-15 00:59:20.000000', 'consum', 0.0223, 'lps'),
	(368896, 125, '2015-01-15 00:59:21.000000', 'consum', 0.0220, 'lps'),
	(368897, 125, '2015-01-15 00:59:22.000000', 'consum', 0.0221, 'lps'),
	(368898, 125, '2015-01-15 00:59:23.000000', 'consum', 0.0219, 'lps'),
	(368899, 125, '2015-01-15 00:59:24.000000', 'consum', 0.0222, 'lps'),
	(368900, 125, '2015-01-15 00:59:25.000000', 'consum', 0.0211, 'lps'),
	(368901, 125, '2015-01-15 00:59:26.000000', 'consum', 0.0215, 'lps'),
	(368902, 125, '2015-01-15 00:59:27.000000', 'consum', 0.0212, 'lps'),
	(368903, 125, '2015-01-15 00:59:28.000000', 'consum', 0.0224, 'lps'),
	(368904, 125, '2015-01-15 00:59:29.000000', 'consum', 0.0224, 'lps'),
	(368905, 125, '2015-01-15 00:59:30.000000', 'consum', 0.0221, 'lps'),
	(368906, 125, '2015-01-15 00:59:31.000000', 'consum', 0.0223, 'lps'),
	(368907, 125, '2015-01-15 00:59:32.000000', 'consum', 0.0226, 'lps'),
	(368908, 125, '2015-01-15 00:59:33.000000', 'consum', 0.0217, 'lps'),
	(368909, 125, '2015-01-15 00:59:34.000000', 'consum', 0.0216, 'lps'),
	(368910, 125, '2015-01-15 00:59:35.000000', 'consum', 0.0217, 'lps'),
	(368911, 125, '2015-01-15 00:59:36.000000', 'consum', 0.0210, 'lps'),
	(368912, 125, '2015-01-15 00:59:37.000000', 'consum', 0.0226, 'lps'),
	(368913, 125, '2015-01-15 00:59:38.000000', 'consum', 0.0222, 'lps'),
	(368914, 125, '2015-01-15 00:59:39.000000', 'consum', 0.0221, 'lps'),
	(368915, 125, '2015-01-15 00:59:40.000000', 'consum', 0.0212, 'lps'),
	(368916, 125, '2015-01-15 00:59:41.000000', 'consum', 0.0224, 'lps'),
	(368917, 125, '2015-01-15 00:59:42.000000', 'consum', 0.0224, 'lps'),
	(368918, 125, '2015-01-15 00:59:43.000000', 'consum', 0.0220, 'lps'),
	(368919, 125, '2015-01-15 00:59:44.000000', 'consum', 0.0219, 'lps'),
	(368920, 125, '2015-01-15 00:59:45.000000', 'consum', 0.0224, 'lps'),
	(368921, 125, '2015-01-15 00:59:46.000000', 'consum', 0.0220, 'lps'),
	(368922, 125, '2015-01-15 00:59:47.000000', 'consum', 0.0220, 'lps'),
	(368923, 125, '2015-01-15 00:59:48.000000', 'consum', 0.0213, 'lps'),
	(368924, 125, '2015-01-15 00:59:49.000000', 'consum', 0.0213, 'lps'),
	(368925, 125, '2015-01-15 00:59:50.000000', 'consum', 0.0215, 'lps'),
	(368926, 125, '2015-01-15 00:59:51.000000', 'consum', 0.0211, 'lps'),
	(368927, 125, '2015-01-15 00:59:52.000000', 'consum', 0.0216, 'lps'),
	(368928, 125, '2015-01-15 00:59:53.000000', 'consum', 0.0221, 'lps'),
	(368929, 125, '2015-01-15 00:59:54.000000', 'consum', 0.0213, 'lps'),
	(368930, 125, '2015-01-15 00:59:55.000000', 'consum', 0.0226, 'lps'),
	(368931, 125, '2015-01-15 00:59:56.000000', 'consum', 0.0214, 'lps'),
	(368932, 125, '2015-01-15 00:59:57.000000', 'consum', 0.0215, 'lps'),
	(368933, 125, '2015-01-15 00:59:58.000000', 'consum', 0.0225, 'lps'),
	(368934, 125, '2015-01-15 00:59:59.000000', 'consum', 0.0220, 'lps'),
	(368935, 125, '2015-01-15 01:00:00.000000', 'consum', 0.0215, 'lps'),
	(368936, 125, '2015-01-15 01:00:01.000000', 'consum', 0.0222, 'lps'),
	(368937, 125, '2015-01-15 01:00:02.000000', 'consum', 0.0223, 'lps'),
	(368938, 125, '2015-01-15 01:00:03.000000', 'consum', 0.0221, 'lps'),
	(368939, 125, '2015-01-15 01:00:04.000000', 'consum', 0.0212, 'lps'),
	(368940, 125, '2015-01-15 01:00:05.000000', 'consum', 0.0220, 'lps'),
	(368941, 125, '2015-01-15 01:00:06.000000', 'consum', 0.0219, 'lps'),
	(368942, 125, '2015-01-15 01:00:07.000000', 'consum', 0.0210, 'lps'),
	(368943, 125, '2015-01-15 01:00:08.000000', 'consum', 0.0215, 'lps'),
	(368944, 125, '2015-01-15 01:00:09.000000', 'consum', 0.0222, 'lps'),
	(368945, 125, '2015-01-15 01:00:10.000000', 'consum', 0.0219, 'lps'),
	(368946, 125, '2015-01-15 01:00:11.000000', 'consum', 0.0220, 'lps'),
	(368947, 125, '2015-01-15 01:00:12.000000', 'consum', 0.0218, 'lps'),
	(368948, 125, '2015-01-15 01:00:13.000000', 'consum', 0.0218, 'lps'),
	(368949, 125, '2015-01-15 01:00:14.000000', 'consum', 0.0211, 'lps'),
	(368950, 125, '2015-01-15 01:00:15.000000', 'consum', 0.0224, 'lps'),
	(368951, 125, '2015-01-15 01:00:16.000000', 'consum', 0.0226, 'lps'),
	(368952, 125, '2015-01-15 01:00:17.000000', 'consum', 0.0216, 'lps'),
	(368953, 125, '2015-01-15 01:00:18.000000', 'consum', 0.0211, 'lps'),
	(368954, 125, '2015-01-15 01:00:19.000000', 'consum', 0.0212, 'lps'),
	(368955, 125, '2015-01-15 01:00:20.000000', 'consum', 0.0218, 'lps'),
	(368956, 125, '2015-01-15 01:00:21.000000', 'consum', 0.0212, 'lps'),
	(368957, 125, '2015-01-15 01:00:22.000000', 'consum', 0.0215, 'lps'),
	(368958, 125, '2015-01-15 01:00:23.000000', 'consum', 0.0226, 'lps'),
	(368959, 125, '2015-01-15 01:00:24.000000', 'consum', 0.0210, 'lps'),
	(368960, 125, '2015-01-15 01:00:25.000000', 'consum', 0.0214, 'lps'),
	(368961, 125, '2015-01-15 01:00:26.000000', 'consum', 0.0214, 'lps'),
	(368962, 125, '2015-01-15 01:00:27.000000', 'consum', 0.0217, 'lps'),
	(368963, 125, '2015-01-15 01:00:28.000000', 'consum', 0.0216, 'lps'),
	(368964, 125, '2015-01-15 01:00:29.000000', 'consum', 0.0219, 'lps'),
	(368965, 125, '2015-01-15 01:00:30.000000', 'consum', 0.0220, 'lps'),
	(368966, 125, '2015-01-15 01:00:31.000000', 'consum', 0.0218, 'lps'),
	(368967, 125, '2015-01-15 01:00:32.000000', 'consum', 0.0222, 'lps'),
	(368968, 125, '2015-01-15 01:00:33.000000', 'consum', 0.0210, 'lps'),
	(368969, 125, '2015-01-15 01:00:34.000000', 'consum', 0.0226, 'lps'),
	(368970, 125, '2015-01-15 01:00:35.000000', 'consum', 0.0221, 'lps'),
	(368971, 125, '2015-01-15 01:00:36.000000', 'consum', 0.0217, 'lps'),
	(368972, 125, '2015-01-15 01:00:37.000000', 'consum', 0.0213, 'lps'),
	(368973, 125, '2015-01-15 01:00:38.000000', 'consum', 0.0223, 'lps'),
	(368974, 125, '2015-01-15 01:00:39.000000', 'consum', 0.0216, 'lps'),
	(368975, 125, '2015-01-15 01:00:40.000000', 'consum', 0.0216, 'lps'),
	(368976, 125, '2015-01-15 01:00:41.000000', 'consum', 0.0226, 'lps'),
	(368977, 125, '2015-01-15 01:00:42.000000', 'consum', 0.0219, 'lps'),
	(368978, 125, '2015-01-15 01:00:43.000000', 'consum', 0.0225, 'lps'),
	(368979, 125, '2015-01-15 01:00:44.000000', 'consum', 0.0223, 'lps'),
	(368980, 125, '2015-01-15 01:00:45.000000', 'consum', 0.0216, 'lps'),
	(368981, 125, '2015-01-15 01:00:46.000000', 'consum', 0.0217, 'lps'),
	(368982, 125, '2015-01-15 01:00:47.000000', 'consum', 0.0211, 'lps'),
	(368983, 125, '2015-01-15 01:00:48.000000', 'consum', 0.0210, 'lps'),
	(368984, 125, '2015-01-15 01:00:49.000000', 'consum', 0.0224, 'lps'),
	(368985, 125, '2015-01-15 01:00:50.000000', 'consum', 0.0215, 'lps'),
	(368986, 125, '2015-01-15 01:00:51.000000', 'consum', 0.0211, 'lps'),
	(368987, 125, '2015-01-15 01:00:52.000000', 'consum', 0.0216, 'lps'),
	(368988, 125, '2015-01-15 01:00:53.000000', 'consum', 0.0220, 'lps'),
	(368989, 125, '2015-01-15 01:00:54.000000', 'consum', 0.0225, 'lps'),
	(368990, 125, '2015-01-15 01:00:55.000000', 'consum', 0.0223, 'lps'),
	(368991, 125, '2015-01-15 01:00:56.000000', 'consum', 0.0214, 'lps'),
	(368992, 125, '2015-01-15 01:00:57.000000', 'consum', 0.0223, 'lps'),
	(368993, 125, '2015-01-15 01:00:58.000000', 'consum', 0.0214, 'lps'),
	(368994, 125, '2015-01-15 01:00:59.000000', 'consum', 0.0225, 'lps'),
	(368995, 125, '2015-01-15 01:01:00.000000', 'consum', 0.0223, 'lps'),
	(368996, 125, '2015-01-15 01:01:01.000000', 'consum', 0.0212, 'lps'),
	(368997, 125, '2015-01-15 01:01:02.000000', 'consum', 0.0215, 'lps'),
	(368998, 125, '2015-01-15 01:01:03.000000', 'consum', 0.0212, 'lps'),
	(368999, 125, '2015-01-15 01:01:04.000000', 'consum', 0.0226, 'lps'),
	(369000, 125, '2015-01-15 01:01:05.000000', 'consum', 0.0213, 'lps'),
	(369001, 125, '2015-01-15 01:01:06.000000', 'consum', 0.0212, 'lps'),
	(369002, 125, '2015-01-15 01:01:07.000000', 'consum', 0.0213, 'lps'),
	(369003, 125, '2015-01-15 01:01:08.000000', 'consum', 0.0217, 'lps'),
	(369004, 125, '2015-01-15 01:01:09.000000', 'consum', 0.0222, 'lps'),
	(369005, 125, '2015-01-15 01:01:10.000000', 'consum', 0.0214, 'lps'),
	(369006, 125, '2015-01-15 01:01:11.000000', 'consum', 0.0211, 'lps'),
	(369007, 125, '2015-01-15 01:01:12.000000', 'consum', 0.0221, 'lps'),
	(369008, 125, '2015-01-15 01:01:13.000000', 'consum', 0.0212, 'lps'),
	(369009, 125, '2015-01-15 01:01:14.000000', 'consum', 0.0221, 'lps'),
	(369010, 125, '2015-01-15 01:01:15.000000', 'consum', 0.0225, 'lps'),
	(369011, 125, '2015-01-15 01:01:16.000000', 'consum', 0.0221, 'lps'),
	(369012, 125, '2015-01-15 01:01:17.000000', 'consum', 0.0219, 'lps'),
	(369013, 125, '2015-01-15 01:01:18.000000', 'consum', 0.0221, 'lps'),
	(369014, 125, '2015-01-15 01:01:19.000000', 'consum', 0.0222, 'lps'),
	(369015, 125, '2015-01-15 01:01:20.000000', 'consum', 0.0219, 'lps'),
	(369016, 125, '2015-01-15 01:01:21.000000', 'consum', 0.0220, 'lps'),
	(369017, 125, '2015-01-15 01:01:22.000000', 'consum', 0.0216, 'lps'),
	(369018, 125, '2015-01-15 01:01:23.000000', 'consum', 0.0213, 'lps'),
	(369019, 125, '2015-01-15 01:01:24.000000', 'consum', 0.0223, 'lps'),
	(369020, 125, '2015-01-15 01:01:25.000000', 'consum', 0.0215, 'lps'),
	(369021, 125, '2015-01-15 01:01:26.000000', 'consum', 0.0215, 'lps'),
	(369022, 125, '2015-01-15 01:01:27.000000', 'consum', 0.0220, 'lps'),
	(369023, 125, '2015-01-15 01:01:28.000000', 'consum', 0.0211, 'lps'),
	(369024, 125, '2015-01-15 01:01:29.000000', 'consum', 0.0218, 'lps'),
	(369025, 125, '2015-01-15 01:01:30.000000', 'consum', 0.0215, 'lps'),
	(369026, 125, '2015-01-15 01:01:31.000000', 'consum', 0.0212, 'lps'),
	(369027, 125, '2015-01-15 01:01:32.000000', 'consum', 0.0222, 'lps'),
	(369028, 125, '2015-01-15 01:01:33.000000', 'consum', 0.0215, 'lps'),
	(369029, 125, '2015-01-15 01:01:34.000000', 'consum', 0.0215, 'lps'),
	(369030, 125, '2015-01-15 01:01:35.000000', 'consum', 0.0222, 'lps'),
	(369031, 125, '2015-01-15 01:01:36.000000', 'consum', 0.0219, 'lps'),
	(369032, 125, '2015-01-15 01:01:37.000000', 'consum', 0.0219, 'lps'),
	(369033, 125, '2015-01-15 01:01:38.000000', 'consum', 0.0211, 'lps'),
	(369034, 125, '2015-01-15 01:01:39.000000', 'consum', 0.0225, 'lps'),
	(369035, 125, '2015-01-15 01:01:40.000000', 'consum', 0.0213, 'lps'),
	(369036, 125, '2015-01-15 01:01:41.000000', 'consum', 0.0213, 'lps'),
	(369037, 125, '2015-01-15 01:01:42.000000', 'consum', 0.0219, 'lps'),
	(369038, 125, '2015-01-15 01:01:43.000000', 'consum', 0.0213, 'lps'),
	(369039, 125, '2015-01-15 01:01:44.000000', 'consum', 0.0214, 'lps'),
	(369040, 125, '2015-01-15 01:01:45.000000', 'consum', 0.0222, 'lps'),
	(369041, 125, '2015-01-15 01:01:46.000000', 'consum', 0.0223, 'lps'),
	(369042, 125, '2015-01-15 01:01:47.000000', 'consum', 0.0223, 'lps'),
	(369043, 125, '2015-01-15 01:01:48.000000', 'consum', 0.0218, 'lps'),
	(369044, 125, '2015-01-15 01:01:49.000000', 'consum', 0.0213, 'lps'),
	(369045, 125, '2015-01-15 01:01:50.000000', 'consum', 0.0220, 'lps'),
	(369046, 125, '2015-01-15 01:01:51.000000', 'consum', 0.0215, 'lps'),
	(369047, 125, '2015-01-15 01:01:52.000000', 'consum', 0.0223, 'lps'),
	(369048, 125, '2015-01-15 01:01:53.000000', 'consum', 0.0211, 'lps'),
	(369049, 125, '2015-01-15 01:01:54.000000', 'consum', 0.0226, 'lps'),
	(369050, 125, '2015-01-15 01:01:55.000000', 'consum', 0.0221, 'lps'),
	(369051, 125, '2015-01-15 01:01:56.000000', 'consum', 0.0215, 'lps'),
	(369052, 125, '2015-01-15 01:01:57.000000', 'consum', 0.0219, 'lps'),
	(369053, 125, '2015-01-15 01:01:58.000000', 'consum', 0.0210, 'lps'),
	(369054, 125, '2015-01-15 01:01:59.000000', 'consum', 0.0215, 'lps'),
	(369055, 125, '2015-01-15 01:02:00.000000', 'consum', 0.0220, 'lps'),
	(369056, 125, '2015-01-15 01:02:01.000000', 'consum', 0.0210, 'lps'),
	(369057, 125, '2015-01-15 01:02:02.000000', 'consum', 0.0215, 'lps'),
	(369058, 125, '2015-01-15 01:02:03.000000', 'consum', 0.0217, 'lps'),
	(369059, 125, '2015-01-15 01:02:04.000000', 'consum', 0.0215, 'lps'),
	(369060, 125, '2015-01-15 01:02:05.000000', 'consum', 0.0214, 'lps'),
	(369061, 125, '2015-01-15 01:02:06.000000', 'consum', 0.0218, 'lps'),
	(369062, 125, '2015-01-15 01:02:07.000000', 'consum', 0.0219, 'lps'),
	(369063, 125, '2015-01-15 01:02:08.000000', 'consum', 0.0215, 'lps'),
	(369064, 125, '2015-01-15 01:02:09.000000', 'consum', 0.0226, 'lps'),
	(369065, 125, '2015-01-15 01:02:10.000000', 'consum', 0.0223, 'lps'),
	(369066, 125, '2015-01-15 01:02:11.000000', 'consum', 0.0213, 'lps'),
	(369067, 125, '2015-01-15 01:02:12.000000', 'consum', 0.0219, 'lps'),
	(369068, 125, '2015-01-15 01:02:13.000000', 'consum', 0.0214, 'lps'),
	(369069, 125, '2015-01-15 01:02:14.000000', 'consum', 0.0221, 'lps'),
	(369070, 125, '2015-01-15 01:02:15.000000', 'consum', 0.0218, 'lps'),
	(369071, 125, '2015-01-15 01:02:16.000000', 'consum', 0.0219, 'lps'),
	(369072, 125, '2015-01-15 01:02:17.000000', 'consum', 0.0212, 'lps'),
	(369073, 125, '2015-01-15 01:02:18.000000', 'consum', 0.0212, 'lps'),
	(369074, 125, '2015-01-15 01:02:19.000000', 'consum', 0.0214, 'lps'),
	(369075, 125, '2015-01-15 01:02:20.000000', 'consum', 0.0223, 'lps'),
	(369076, 125, '2015-01-15 01:02:21.000000', 'consum', 0.0212, 'lps'),
	(369077, 125, '2015-01-15 01:02:22.000000', 'consum', 0.0218, 'lps'),
	(369078, 125, '2015-01-15 01:02:23.000000', 'consum', 0.0210, 'lps'),
	(369079, 125, '2015-01-15 01:02:24.000000', 'consum', 0.0222, 'lps'),
	(369080, 125, '2015-01-15 01:02:25.000000', 'consum', 0.0218, 'lps'),
	(369081, 125, '2015-01-15 01:02:26.000000', 'consum', 0.0215, 'lps'),
	(369082, 125, '2015-01-15 01:02:27.000000', 'consum', 0.0212, 'lps'),
	(369083, 125, '2015-01-15 01:02:28.000000', 'consum', 0.0223, 'lps'),
	(369084, 125, '2015-01-15 01:02:29.000000', 'consum', 0.0217, 'lps'),
	(369085, 125, '2015-01-15 01:02:30.000000', 'consum', 0.0225, 'lps'),
	(369086, 125, '2015-01-15 01:02:31.000000', 'consum', 0.0213, 'lps'),
	(369087, 125, '2015-01-15 01:02:32.000000', 'consum', 0.0213, 'lps'),
	(369088, 125, '2015-01-15 01:02:33.000000', 'consum', 0.0217, 'lps'),
	(369089, 125, '2015-01-15 01:02:34.000000', 'consum', 0.0220, 'lps'),
	(369090, 125, '2015-01-15 01:02:35.000000', 'consum', 0.0224, 'lps'),
	(369091, 125, '2015-01-15 01:02:36.000000', 'consum', 0.0216, 'lps'),
	(369092, 125, '2015-01-15 01:02:37.000000', 'consum', 0.0216, 'lps'),
	(369093, 125, '2015-01-15 01:02:38.000000', 'consum', 0.0220, 'lps'),
	(369094, 125, '2015-01-15 01:02:39.000000', 'consum', 0.0210, 'lps'),
	(369095, 125, '2015-01-15 01:02:40.000000', 'consum', 0.0215, 'lps'),
	(369096, 125, '2015-01-15 01:02:41.000000', 'consum', 0.0218, 'lps'),
	(369097, 125, '2015-01-15 01:02:42.000000', 'consum', 0.0219, 'lps'),
	(369098, 125, '2015-01-15 01:02:43.000000', 'consum', 0.0216, 'lps'),
	(369099, 125, '2015-01-15 01:02:44.000000', 'consum', 0.0211, 'lps'),
	(369100, 125, '2015-01-15 01:02:45.000000', 'consum', 0.0215, 'lps'),
	(369101, 125, '2015-01-15 01:02:46.000000', 'consum', 0.0214, 'lps'),
	(369102, 125, '2015-01-15 01:02:47.000000', 'consum', 0.0217, 'lps'),
	(369103, 125, '2015-01-15 01:02:48.000000', 'consum', 0.0218, 'lps'),
	(369104, 125, '2015-01-15 01:02:49.000000', 'consum', 0.0213, 'lps'),
	(369105, 125, '2015-01-15 01:02:50.000000', 'consum', 0.0216, 'lps'),
	(369106, 125, '2015-01-15 01:02:51.000000', 'consum', 0.0214, 'lps'),
	(369107, 125, '2015-01-15 01:02:52.000000', 'consum', 0.0215, 'lps'),
	(369108, 125, '2015-01-15 01:02:53.000000', 'consum', 0.0221, 'lps'),
	(369109, 125, '2015-01-15 01:02:54.000000', 'consum', 0.0219, 'lps'),
	(369110, 125, '2015-01-15 01:02:55.000000', 'consum', 0.0221, 'lps'),
	(369111, 125, '2015-01-15 01:02:56.000000', 'consum', 0.0222, 'lps'),
	(369112, 125, '2015-01-15 01:02:57.000000', 'consum', 0.0220, 'lps'),
	(369113, 125, '2015-01-15 01:02:58.000000', 'consum', 0.0226, 'lps'),
	(369114, 125, '2015-01-15 01:02:59.000000', 'consum', 0.0210, 'lps'),
	(369115, 125, '2015-01-15 01:03:00.000000', 'consum', 0.0211, 'lps'),
	(369116, 125, '2015-01-15 01:03:01.000000', 'consum', 0.0215, 'lps'),
	(369117, 125, '2015-01-15 01:03:02.000000', 'consum', 0.0218, 'lps'),
	(369118, 125, '2015-01-15 01:03:03.000000', 'consum', 0.0219, 'lps'),
	(369119, 125, '2015-01-15 01:03:04.000000', 'consum', 0.0215, 'lps'),
	(369120, 125, '2015-01-15 01:03:05.000000', 'consum', 0.0225, 'lps'),
	(369121, 125, '2015-01-15 01:03:06.000000', 'consum', 0.0220, 'lps'),
	(369122, 125, '2015-01-15 01:03:07.000000', 'consum', 0.0216, 'lps'),
	(369123, 125, '2015-01-15 01:03:08.000000', 'consum', 0.0226, 'lps'),
	(369124, 125, '2015-01-15 01:03:09.000000', 'consum', 0.0221, 'lps'),
	(369125, 125, '2015-01-15 01:03:10.000000', 'consum', 0.0217, 'lps'),
	(369126, 125, '2015-01-15 01:03:11.000000', 'consum', 0.0215, 'lps'),
	(369127, 125, '2015-01-15 01:03:12.000000', 'consum', 0.0212, 'lps'),
	(369128, 125, '2015-01-15 01:03:13.000000', 'consum', 0.0223, 'lps'),
	(369129, 125, '2015-01-15 01:03:14.000000', 'consum', 0.0220, 'lps'),
	(369130, 125, '2015-01-15 01:03:15.000000', 'consum', 0.0222, 'lps'),
	(369131, 125, '2015-01-15 01:03:16.000000', 'consum', 0.0222, 'lps'),
	(369132, 125, '2015-01-15 01:03:17.000000', 'consum', 0.0220, 'lps'),
	(369133, 125, '2015-01-15 01:03:18.000000', 'consum', 0.0221, 'lps'),
	(369134, 125, '2015-01-15 01:03:19.000000', 'consum', 0.0221, 'lps'),
	(369135, 125, '2015-01-15 01:03:20.000000', 'consum', 0.0214, 'lps'),
	(369136, 125, '2015-01-15 01:03:21.000000', 'consum', 0.0214, 'lps'),
	(369137, 125, '2015-01-15 01:03:22.000000', 'consum', 0.0218, 'lps'),
	(369138, 125, '2015-01-15 01:03:23.000000', 'consum', 0.0223, 'lps'),
	(369139, 125, '2015-01-15 01:03:24.000000', 'consum', 0.0216, 'lps'),
	(369140, 125, '2015-01-15 01:03:25.000000', 'consum', 0.0218, 'lps'),
	(369141, 125, '2015-01-15 01:03:26.000000', 'consum', 0.0218, 'lps'),
	(369142, 125, '2015-01-15 01:03:27.000000', 'consum', 0.0224, 'lps'),
	(369143, 125, '2015-01-15 01:03:28.000000', 'consum', 0.0223, 'lps'),
	(369144, 125, '2015-01-15 01:03:29.000000', 'consum', 0.0216, 'lps'),
	(369145, 125, '2015-01-15 01:03:30.000000', 'consum', 0.0218, 'lps'),
	(369146, 125, '2015-01-15 01:03:31.000000', 'consum', 0.0218, 'lps'),
	(369147, 125, '2015-01-15 01:03:32.000000', 'consum', 0.0226, 'lps'),
	(369148, 125, '2015-01-15 01:03:33.000000', 'consum', 0.0217, 'lps'),
	(369149, 125, '2015-01-15 01:03:34.000000', 'consum', 0.0213, 'lps'),
	(369150, 125, '2015-01-15 01:03:35.000000', 'consum', 0.0221, 'lps'),
	(369151, 125, '2015-01-15 01:03:36.000000', 'consum', 0.0223, 'lps'),
	(369152, 125, '2015-01-15 01:03:37.000000', 'consum', 0.0225, 'lps'),
	(369153, 125, '2015-01-15 01:03:38.000000', 'consum', 0.0214, 'lps'),
	(369154, 125, '2015-01-15 01:03:39.000000', 'consum', 0.0218, 'lps'),
	(369155, 125, '2015-01-15 01:03:40.000000', 'consum', 0.0220, 'lps'),
	(369156, 125, '2015-01-15 01:03:41.000000', 'consum', 0.0222, 'lps'),
	(369157, 125, '2015-01-15 01:03:42.000000', 'consum', 0.0222, 'lps'),
	(369158, 125, '2015-01-15 01:03:43.000000', 'consum', 0.0218, 'lps'),
	(369159, 125, '2015-01-15 01:03:44.000000', 'consum', 0.0214, 'lps'),
	(369160, 125, '2015-01-15 01:03:45.000000', 'consum', 0.0225, 'lps'),
	(369161, 125, '2015-01-15 01:03:46.000000', 'consum', 0.0220, 'lps'),
	(369162, 125, '2015-01-15 01:03:47.000000', 'consum', 0.0219, 'lps'),
	(369163, 125, '2015-01-15 01:03:48.000000', 'consum', 0.0222, 'lps'),
	(369164, 125, '2015-01-15 01:03:49.000000', 'consum', 0.0213, 'lps'),
	(369165, 125, '2015-01-15 01:03:50.000000', 'consum', 0.0221, 'lps'),
	(369166, 125, '2015-01-15 01:03:51.000000', 'consum', 0.0224, 'lps'),
	(369167, 125, '2015-01-15 01:03:52.000000', 'consum', 0.0212, 'lps'),
	(369168, 125, '2015-01-15 01:03:53.000000', 'consum', 0.0214, 'lps'),
	(369169, 125, '2015-01-15 01:03:54.000000', 'consum', 0.0225, 'lps'),
	(369170, 125, '2015-01-15 01:03:55.000000', 'consum', 0.0223, 'lps'),
	(369171, 125, '2015-01-15 01:03:56.000000', 'consum', 0.0213, 'lps'),
	(369172, 125, '2015-01-15 01:03:57.000000', 'consum', 0.0221, 'lps'),
	(369173, 125, '2015-01-15 01:03:58.000000', 'consum', 0.0223, 'lps'),
	(369174, 125, '2015-01-15 01:03:59.000000', 'consum', 0.0223, 'lps'),
	(369175, 125, '2015-01-15 01:04:00.000000', 'consum', 0.0221, 'lps'),
	(369176, 125, '2015-01-15 01:04:01.000000', 'consum', 0.0226, 'lps'),
	(369177, 125, '2015-01-15 01:04:02.000000', 'consum', 0.0225, 'lps'),
	(369178, 125, '2015-01-15 01:04:03.000000', 'consum', 0.0220, 'lps'),
	(369179, 125, '2015-01-15 01:04:04.000000', 'consum', 0.0215, 'lps'),
	(369180, 125, '2015-01-15 01:04:05.000000', 'consum', 0.0221, 'lps'),
	(369181, 125, '2015-01-15 01:04:06.000000', 'consum', 0.0217, 'lps'),
	(369182, 125, '2015-01-15 01:04:07.000000', 'consum', 0.0212, 'lps'),
	(369183, 125, '2015-01-15 01:04:08.000000', 'consum', 0.0218, 'lps'),
	(369184, 125, '2015-01-15 01:04:09.000000', 'consum', 0.0210, 'lps'),
	(369185, 125, '2015-01-15 01:04:10.000000', 'consum', 0.0222, 'lps'),
	(369186, 125, '2015-01-15 01:04:11.000000', 'consum', 0.0217, 'lps'),
	(369187, 125, '2015-01-15 01:04:12.000000', 'consum', 0.0210, 'lps'),
	(369188, 125, '2015-01-15 01:04:13.000000', 'consum', 0.0224, 'lps'),
	(369189, 125, '2015-01-15 01:04:14.000000', 'consum', 0.0214, 'lps'),
	(369190, 125, '2015-01-15 01:04:15.000000', 'consum', 0.0223, 'lps'),
	(369191, 125, '2015-01-15 01:04:16.000000', 'consum', 0.0226, 'lps'),
	(369192, 125, '2015-01-15 01:04:17.000000', 'consum', 0.0221, 'lps'),
	(369193, 125, '2015-01-15 01:04:18.000000', 'consum', 0.0217, 'lps'),
	(369194, 125, '2015-01-15 01:04:19.000000', 'consum', 0.0212, 'lps'),
	(369195, 125, '2015-01-15 01:04:20.000000', 'consum', 0.0215, 'lps'),
	(369196, 125, '2015-01-15 01:04:21.000000', 'consum', 0.0215, 'lps'),
	(369197, 125, '2015-01-15 01:04:22.000000', 'consum', 0.0219, 'lps'),
	(369198, 125, '2015-01-15 01:04:23.000000', 'consum', 0.0222, 'lps'),
	(369199, 125, '2015-01-15 01:04:24.000000', 'consum', 0.0226, 'lps'),
	(369200, 125, '2015-01-15 01:04:25.000000', 'consum', 0.0224, 'lps'),
	(369201, 125, '2015-01-15 01:04:26.000000', 'consum', 0.0213, 'lps'),
	(369202, 125, '2015-01-15 01:04:27.000000', 'consum', 0.0219, 'lps'),
	(369203, 125, '2015-01-15 01:04:28.000000', 'consum', 0.0212, 'lps'),
	(369204, 125, '2015-01-15 01:04:29.000000', 'consum', 0.0211, 'lps'),
	(369205, 125, '2015-01-15 01:04:30.000000', 'consum', 0.0224, 'lps'),
	(369206, 125, '2015-01-15 01:04:31.000000', 'consum', 0.0213, 'lps'),
	(369207, 125, '2015-01-15 01:04:32.000000', 'consum', 0.0214, 'lps'),
	(369208, 125, '2015-01-15 01:04:33.000000', 'consum', 0.0223, 'lps'),
	(369209, 125, '2015-01-15 01:04:34.000000', 'consum', 0.0212, 'lps'),
	(369210, 125, '2015-01-15 01:04:35.000000', 'consum', 0.0218, 'lps'),
	(369211, 125, '2015-01-15 01:04:36.000000', 'consum', 0.0224, 'lps'),
	(369212, 125, '2015-01-15 01:04:37.000000', 'consum', 0.0224, 'lps'),
	(369213, 125, '2015-01-15 01:04:38.000000', 'consum', 0.0222, 'lps'),
	(369214, 125, '2015-01-15 01:04:39.000000', 'consum', 0.0212, 'lps'),
	(369215, 125, '2015-01-15 01:04:40.000000', 'consum', 0.0216, 'lps'),
	(369216, 125, '2015-01-15 01:04:41.000000', 'consum', 0.0220, 'lps'),
	(369217, 125, '2015-01-15 01:04:42.000000', 'consum', 0.0225, 'lps'),
	(369218, 125, '2015-01-15 01:04:43.000000', 'consum', 0.0220, 'lps'),
	(369219, 125, '2015-01-15 01:04:44.000000', 'consum', 0.0217, 'lps'),
	(369220, 125, '2015-01-15 01:04:45.000000', 'consum', 0.0214, 'lps'),
	(369221, 125, '2015-01-15 01:04:46.000000', 'consum', 0.0212, 'lps'),
	(369222, 125, '2015-01-15 01:04:47.000000', 'consum', 0.0223, 'lps'),
	(369223, 125, '2015-01-15 01:04:48.000000', 'consum', 0.0219, 'lps'),
	(369224, 125, '2015-01-15 01:04:49.000000', 'consum', 0.0216, 'lps'),
	(369225, 125, '2015-01-15 01:04:50.000000', 'consum', 0.0216, 'lps'),
	(369226, 125, '2015-01-15 01:04:51.000000', 'consum', 0.0220, 'lps'),
	(369227, 125, '2015-01-15 01:04:52.000000', 'consum', 0.0226, 'lps'),
	(369228, 125, '2015-01-15 01:04:53.000000', 'consum', 0.0225, 'lps'),
	(369229, 125, '2015-01-15 01:04:54.000000', 'consum', 0.0223, 'lps'),
	(369230, 125, '2015-01-15 01:04:55.000000', 'consum', 0.0211, 'lps'),
	(369231, 125, '2015-01-15 01:04:56.000000', 'consum', 0.0211, 'lps'),
	(369232, 125, '2015-01-15 01:04:57.000000', 'consum', 0.0212, 'lps'),
	(369233, 125, '2015-01-15 01:04:58.000000', 'consum', 0.0218, 'lps'),
	(369234, 125, '2015-01-15 01:04:59.000000', 'consum', 0.0210, 'lps'),
	(369235, 125, '2015-01-15 01:05:00.000000', 'consum', 0.0220, 'lps'),
	(369236, 125, '2015-01-15 01:05:01.000000', 'consum', 0.0210, 'lps'),
	(369237, 125, '2015-01-15 01:05:02.000000', 'consum', 0.0215, 'lps'),
	(369238, 125, '2015-01-15 01:05:03.000000', 'consum', 0.0219, 'lps'),
	(369239, 125, '2015-01-15 01:05:04.000000', 'consum', 0.0223, 'lps'),
	(369240, 125, '2015-01-15 01:05:05.000000', 'consum', 0.0214, 'lps'),
	(369241, 125, '2015-01-15 01:05:06.000000', 'consum', 0.0211, 'lps'),
	(369242, 125, '2015-01-15 01:05:07.000000', 'consum', 0.0219, 'lps'),
	(369243, 125, '2015-01-15 01:05:08.000000', 'consum', 0.0218, 'lps'),
	(369244, 125, '2015-01-15 01:05:09.000000', 'consum', 0.0223, 'lps'),
	(369245, 125, '2015-01-15 01:05:10.000000', 'consum', 0.0216, 'lps'),
	(369246, 125, '2015-01-15 01:05:11.000000', 'consum', 0.0220, 'lps'),
	(369247, 125, '2015-01-15 01:05:12.000000', 'consum', 0.0226, 'lps'),
	(369248, 125, '2015-01-15 01:05:13.000000', 'consum', 0.0210, 'lps'),
	(369249, 125, '2015-01-15 01:05:14.000000', 'consum', 0.0215, 'lps'),
	(369250, 125, '2015-01-15 01:05:15.000000', 'consum', 0.0215, 'lps'),
	(369251, 125, '2015-01-15 01:05:16.000000', 'consum', 0.0222, 'lps'),
	(369252, 125, '2015-01-15 01:05:17.000000', 'consum', 0.0223, 'lps'),
	(369253, 125, '2015-01-15 01:05:18.000000', 'consum', 0.0223, 'lps'),
	(369254, 125, '2015-01-15 01:05:19.000000', 'consum', 0.0217, 'lps'),
	(369255, 125, '2015-01-15 01:05:20.000000', 'consum', 0.0224, 'lps'),
	(369256, 125, '2015-01-15 01:05:21.000000', 'consum', 0.0225, 'lps'),
	(369257, 125, '2015-01-15 01:05:22.000000', 'consum', 0.0210, 'lps'),
	(369258, 125, '2015-01-15 01:05:23.000000', 'consum', 0.0218, 'lps'),
	(369259, 125, '2015-01-15 01:05:24.000000', 'consum', 0.0216, 'lps'),
	(369260, 125, '2015-01-15 01:05:25.000000', 'consum', 0.0215, 'lps'),
	(369261, 125, '2015-01-15 01:05:26.000000', 'consum', 0.0220, 'lps'),
	(369262, 125, '2015-01-15 01:05:27.000000', 'consum', 0.0210, 'lps'),
	(369263, 125, '2015-01-15 01:05:28.000000', 'consum', 0.0216, 'lps'),
	(369264, 125, '2015-01-15 01:05:29.000000', 'consum', 0.0222, 'lps'),
	(369265, 125, '2015-01-15 01:05:30.000000', 'consum', 0.0218, 'lps'),
	(369266, 125, '2015-01-15 01:05:31.000000', 'consum', 0.0214, 'lps'),
	(369267, 125, '2015-01-15 01:05:32.000000', 'consum', 0.0224, 'lps'),
	(369268, 125, '2015-01-15 01:05:33.000000', 'consum', 0.0217, 'lps'),
	(369269, 125, '2015-01-15 01:05:34.000000', 'consum', 0.0221, 'lps'),
	(369270, 125, '2015-01-15 01:05:35.000000', 'consum', 0.0210, 'lps'),
	(369271, 125, '2015-01-15 01:05:36.000000', 'consum', 0.0211, 'lps'),
	(369272, 125, '2015-01-15 01:05:37.000000', 'consum', 0.0217, 'lps'),
	(369273, 125, '2015-01-15 01:05:38.000000', 'consum', 0.0210, 'lps'),
	(369274, 125, '2015-01-15 01:05:39.000000', 'consum', 0.0221, 'lps'),
	(369275, 125, '2015-01-15 01:05:40.000000', 'consum', 0.0214, 'lps'),
	(369276, 125, '2015-01-15 01:05:41.000000', 'consum', 0.0217, 'lps'),
	(369277, 125, '2015-01-15 01:05:42.000000', 'consum', 0.0217, 'lps'),
	(369278, 125, '2015-01-15 01:05:43.000000', 'consum', 0.0224, 'lps'),
	(369279, 125, '2015-01-15 01:05:44.000000', 'consum', 0.0225, 'lps'),
	(369280, 125, '2015-01-15 01:05:45.000000', 'consum', 0.0211, 'lps'),
	(369281, 125, '2015-01-15 01:05:46.000000', 'consum', 0.0220, 'lps'),
	(369282, 125, '2015-01-15 01:05:47.000000', 'consum', 0.0225, 'lps'),
	(369283, 125, '2015-01-15 01:05:48.000000', 'consum', 0.0221, 'lps'),
	(369284, 125, '2015-01-15 01:05:49.000000', 'consum', 0.0222, 'lps'),
	(369285, 125, '2015-01-15 01:05:50.000000', 'consum', 0.0220, 'lps'),
	(369286, 125, '2015-01-15 01:05:51.000000', 'consum', 0.0225, 'lps'),
	(369287, 125, '2015-01-15 01:05:52.000000', 'consum', 0.0219, 'lps'),
	(369288, 125, '2015-01-15 01:05:53.000000', 'consum', 0.0211, 'lps'),
	(369289, 125, '2015-01-15 01:05:54.000000', 'consum', 0.0221, 'lps'),
	(369290, 125, '2015-01-15 01:05:55.000000', 'consum', 0.0213, 'lps'),
	(369291, 125, '2015-01-15 01:05:56.000000', 'consum', 0.0211, 'lps'),
	(369292, 125, '2015-01-15 01:05:57.000000', 'consum', 0.0221, 'lps'),
	(369293, 125, '2015-01-15 01:05:58.000000', 'consum', 0.0212, 'lps'),
	(369294, 125, '2015-01-15 01:05:59.000000', 'consum', 0.0223, 'lps'),
	(369295, 125, '2015-01-15 01:06:00.000000', 'consum', 0.0219, 'lps'),
	(369296, 125, '2015-01-15 01:06:01.000000', 'consum', 0.0215, 'lps'),
	(369297, 125, '2015-01-15 01:06:02.000000', 'consum', 0.0210, 'lps'),
	(369298, 125, '2015-01-15 01:06:03.000000', 'consum', 0.0213, 'lps'),
	(369299, 125, '2015-01-15 01:06:04.000000', 'consum', 0.0226, 'lps'),
	(369300, 125, '2015-01-15 01:06:05.000000', 'consum', 0.0215, 'lps'),
	(369301, 125, '2015-01-15 01:06:06.000000', 'consum', 0.0218, 'lps'),
	(369302, 125, '2015-01-15 01:06:07.000000', 'consum', 0.0219, 'lps'),
	(369303, 125, '2015-01-15 01:06:08.000000', 'consum', 0.0213, 'lps'),
	(369304, 125, '2015-01-15 01:06:09.000000', 'consum', 0.0217, 'lps'),
	(369305, 125, '2015-01-15 01:06:10.000000', 'consum', 0.0221, 'lps'),
	(369306, 125, '2015-01-15 01:06:11.000000', 'consum', 0.0226, 'lps'),
	(369307, 125, '2015-01-15 01:06:12.000000', 'consum', 0.0224, 'lps'),
	(369308, 125, '2015-01-15 01:06:13.000000', 'consum', 0.0214, 'lps'),
	(369309, 125, '2015-01-15 01:06:14.000000', 'consum', 0.0222, 'lps'),
	(369310, 125, '2015-01-15 01:06:15.000000', 'consum', 0.0224, 'lps'),
	(369311, 125, '2015-01-15 01:06:16.000000', 'consum', 0.0212, 'lps'),
	(369312, 125, '2015-01-15 01:06:17.000000', 'consum', 0.0212, 'lps'),
	(369313, 125, '2015-01-15 01:06:18.000000', 'consum', 0.0216, 'lps'),
	(369314, 125, '2015-01-15 01:06:19.000000', 'consum', 0.0216, 'lps'),
	(369315, 125, '2015-01-15 01:06:20.000000', 'consum', 0.0221, 'lps'),
	(369316, 125, '2015-01-15 01:06:21.000000', 'consum', 0.0215, 'lps'),
	(369317, 125, '2015-01-15 01:06:22.000000', 'consum', 0.0220, 'lps'),
	(369318, 125, '2015-01-15 01:06:23.000000', 'consum', 0.0210, 'lps'),
	(369319, 125, '2015-01-15 01:06:24.000000', 'consum', 0.0215, 'lps'),
	(369320, 125, '2015-01-15 01:06:25.000000', 'consum', 0.0217, 'lps'),
	(369321, 125, '2015-01-15 01:06:26.000000', 'consum', 0.0213, 'lps'),
	(369322, 125, '2015-01-15 01:06:27.000000', 'consum', 0.0224, 'lps'),
	(369323, 125, '2015-01-15 01:06:28.000000', 'consum', 0.0220, 'lps'),
	(369324, 125, '2015-01-15 01:06:29.000000', 'consum', 0.0219, 'lps'),
	(369325, 125, '2015-01-15 01:06:30.000000', 'consum', 0.0225, 'lps'),
	(369326, 125, '2015-01-15 01:06:31.000000', 'consum', 0.0223, 'lps'),
	(369327, 125, '2015-01-15 01:06:32.000000', 'consum', 0.0215, 'lps'),
	(369328, 125, '2015-01-15 01:06:33.000000', 'consum', 0.0212, 'lps'),
	(369329, 125, '2015-01-15 01:06:34.000000', 'consum', 0.0222, 'lps'),
	(369330, 125, '2015-01-15 01:06:35.000000', 'consum', 0.0215, 'lps'),
	(369331, 125, '2015-01-15 01:06:36.000000', 'consum', 0.0216, 'lps'),
	(369332, 125, '2015-01-15 01:06:37.000000', 'consum', 0.0210, 'lps'),
	(369333, 125, '2015-01-15 01:06:38.000000', 'consum', 0.0226, 'lps'),
	(369334, 125, '2015-01-15 01:06:39.000000', 'consum', 0.0223, 'lps'),
	(369335, 125, '2015-01-15 01:06:40.000000', 'consum', 0.0225, 'lps'),
	(369336, 125, '2015-01-15 01:06:41.000000', 'consum', 0.0215, 'lps'),
	(369337, 125, '2015-01-15 01:06:42.000000', 'consum', 0.0226, 'lps'),
	(369338, 125, '2015-01-15 01:06:43.000000', 'consum', 0.0221, 'lps'),
	(369339, 125, '2015-01-15 01:06:44.000000', 'consum', 0.0219, 'lps'),
	(369340, 125, '2015-01-15 01:06:45.000000', 'consum', 0.0220, 'lps'),
	(369341, 125, '2015-01-15 01:06:46.000000', 'consum', 0.0219, 'lps'),
	(369342, 125, '2015-01-15 01:06:47.000000', 'consum', 0.0226, 'lps'),
	(369343, 125, '2015-01-15 01:06:48.000000', 'consum', 0.0210, 'lps'),
	(369344, 125, '2015-01-15 01:06:49.000000', 'consum', 0.0216, 'lps'),
	(369345, 125, '2015-01-15 01:06:50.000000', 'consum', 0.0224, 'lps'),
	(369346, 125, '2015-01-15 01:06:51.000000', 'consum', 0.0212, 'lps'),
	(369347, 125, '2015-01-15 01:06:52.000000', 'consum', 0.0212, 'lps'),
	(369348, 125, '2015-01-15 01:06:53.000000', 'consum', 0.0215, 'lps'),
	(369349, 125, '2015-01-15 01:06:54.000000', 'consum', 0.0210, 'lps'),
	(369350, 125, '2015-01-15 01:06:55.000000', 'consum', 0.0213, 'lps'),
	(369351, 125, '2015-01-15 01:06:56.000000', 'consum', 0.0225, 'lps'),
	(369352, 125, '2015-01-15 01:06:57.000000', 'consum', 0.0211, 'lps'),
	(369353, 125, '2015-01-15 01:06:58.000000', 'consum', 0.0222, 'lps'),
	(369354, 125, '2015-01-15 01:06:59.000000', 'consum', 0.0215, 'lps'),
	(369355, 125, '2015-01-15 01:07:00.000000', 'consum', 0.0218, 'lps'),
	(369356, 125, '2015-01-15 01:07:01.000000', 'consum', 0.0217, 'lps'),
	(369357, 125, '2015-01-15 01:07:02.000000', 'consum', 0.0221, 'lps'),
	(369358, 125, '2015-01-15 01:07:03.000000', 'consum', 0.0210, 'lps'),
	(369359, 125, '2015-01-15 01:07:04.000000', 'consum', 0.0213, 'lps'),
	(369360, 125, '2015-01-15 01:07:05.000000', 'consum', 0.0210, 'lps'),
	(369361, 125, '2015-01-15 01:07:06.000000', 'consum', 0.0216, 'lps'),
	(369362, 125, '2015-01-15 01:07:07.000000', 'consum', 0.0225, 'lps'),
	(369363, 125, '2015-01-15 01:07:08.000000', 'consum', 0.0216, 'lps'),
	(369364, 125, '2015-01-15 01:07:09.000000', 'consum', 0.0211, 'lps'),
	(369365, 125, '2015-01-15 01:07:10.000000', 'consum', 0.0214, 'lps'),
	(369366, 125, '2015-01-15 01:07:11.000000', 'consum', 0.0212, 'lps'),
	(369367, 125, '2015-01-15 01:07:12.000000', 'consum', 0.0225, 'lps'),
	(369368, 125, '2015-01-15 01:07:13.000000', 'consum', 0.0213, 'lps'),
	(369369, 125, '2015-01-15 01:07:14.000000', 'consum', 0.0212, 'lps'),
	(369370, 125, '2015-01-15 01:07:15.000000', 'consum', 0.0212, 'lps'),
	(369371, 125, '2015-01-15 01:07:16.000000', 'consum', 0.0215, 'lps'),
	(369372, 125, '2015-01-15 01:07:17.000000', 'consum', 0.0214, 'lps'),
	(369373, 125, '2015-01-15 01:07:18.000000', 'consum', 0.0213, 'lps'),
	(369374, 125, '2015-01-15 01:07:19.000000', 'consum', 0.0213, 'lps'),
	(369375, 125, '2015-01-15 01:07:20.000000', 'consum', 0.0216, 'lps'),
	(369376, 125, '2015-01-15 01:07:21.000000', 'consum', 0.0216, 'lps'),
	(369377, 125, '2015-01-15 01:07:22.000000', 'consum', 0.0221, 'lps'),
	(369378, 125, '2015-01-15 01:07:23.000000', 'consum', 0.0214, 'lps'),
	(369379, 125, '2015-01-15 01:07:24.000000', 'consum', 0.0216, 'lps'),
	(369380, 125, '2015-01-15 01:07:25.000000', 'consum', 0.0226, 'lps'),
	(369381, 125, '2015-01-15 01:07:26.000000', 'consum', 0.0224, 'lps'),
	(369382, 125, '2015-01-15 01:07:27.000000', 'consum', 0.0215, 'lps'),
	(369383, 125, '2015-01-15 01:07:28.000000', 'consum', 0.0210, 'lps'),
	(369384, 125, '2015-01-15 01:07:29.000000', 'consum', 0.0214, 'lps'),
	(369385, 125, '2015-01-15 01:07:30.000000', 'consum', 0.0213, 'lps'),
	(369386, 125, '2015-01-15 01:07:31.000000', 'consum', 0.0212, 'lps'),
	(369387, 125, '2015-01-15 01:07:32.000000', 'consum', 0.0212, 'lps'),
	(369388, 125, '2015-01-15 01:07:33.000000', 'consum', 0.0217, 'lps'),
	(369389, 125, '2015-01-15 01:07:34.000000', 'consum', 0.0220, 'lps'),
	(369390, 125, '2015-01-15 01:07:35.000000', 'consum', 0.0223, 'lps'),
	(369391, 125, '2015-01-15 01:07:36.000000', 'consum', 0.0226, 'lps'),
	(369392, 125, '2015-01-15 01:07:37.000000', 'consum', 0.0221, 'lps'),
	(369393, 125, '2015-01-15 01:07:38.000000', 'consum', 0.0218, 'lps'),
	(369394, 125, '2015-01-15 01:07:39.000000', 'consum', 0.0214, 'lps'),
	(369395, 125, '2015-01-15 01:07:40.000000', 'consum', 0.0210, 'lps'),
	(369396, 125, '2015-01-15 01:07:41.000000', 'consum', 0.0214, 'lps'),
	(369397, 125, '2015-01-15 01:07:42.000000', 'consum', 0.0212, 'lps'),
	(369398, 125, '2015-01-15 01:07:43.000000', 'consum', 0.0225, 'lps'),
	(369399, 125, '2015-01-15 01:07:44.000000', 'consum', 0.0212, 'lps'),
	(369400, 125, '2015-01-15 01:07:45.000000', 'consum', 0.0226, 'lps'),
	(369401, 125, '2015-01-15 01:07:46.000000', 'consum', 0.0218, 'lps'),
	(369402, 125, '2015-01-15 01:07:47.000000', 'consum', 0.0218, 'lps'),
	(369403, 125, '2015-01-15 01:07:48.000000', 'consum', 0.0212, 'lps'),
	(369404, 125, '2015-01-15 01:07:49.000000', 'consum', 0.0211, 'lps'),
	(369405, 125, '2015-01-15 01:07:50.000000', 'consum', 0.0210, 'lps'),
	(369406, 125, '2015-01-15 01:07:51.000000', 'consum', 0.0224, 'lps'),
	(369407, 125, '2015-01-15 01:07:52.000000', 'consum', 0.0211, 'lps'),
	(369408, 125, '2015-01-15 01:07:53.000000', 'consum', 0.0210, 'lps'),
	(369409, 125, '2015-01-15 01:07:54.000000', 'consum', 0.0224, 'lps'),
	(369410, 125, '2015-01-15 01:07:55.000000', 'consum', 0.0213, 'lps'),
	(369411, 125, '2015-01-15 01:07:56.000000', 'consum', 0.0217, 'lps'),
	(369412, 125, '2015-01-15 01:07:57.000000', 'consum', 0.0219, 'lps'),
	(369413, 125, '2015-01-15 01:07:58.000000', 'consum', 0.0217, 'lps'),
	(369414, 125, '2015-01-15 01:07:59.000000', 'consum', 0.0221, 'lps'),
	(369415, 125, '2015-01-15 01:08:00.000000', 'consum', 0.0210, 'lps'),
	(369416, 125, '2015-01-15 01:08:01.000000', 'consum', 0.0210, 'lps'),
	(369417, 125, '2015-01-15 01:08:02.000000', 'consum', 0.0226, 'lps'),
	(369418, 125, '2015-01-15 01:08:03.000000', 'consum', 0.0224, 'lps'),
	(369419, 125, '2015-01-15 01:08:04.000000', 'consum', 0.0217, 'lps'),
	(369420, 125, '2015-01-15 01:08:05.000000', 'consum', 0.0218, 'lps'),
	(369421, 125, '2015-01-15 01:08:06.000000', 'consum', 0.0213, 'lps'),
	(369422, 125, '2015-01-15 01:08:07.000000', 'consum', 0.0217, 'lps'),
	(369423, 125, '2015-01-15 01:08:08.000000', 'consum', 0.0222, 'lps'),
	(369424, 125, '2015-01-15 01:08:09.000000', 'consum', 0.0214, 'lps'),
	(369425, 125, '2015-01-15 01:08:10.000000', 'consum', 0.0210, 'lps'),
	(369426, 125, '2015-01-15 01:08:11.000000', 'consum', 0.0217, 'lps'),
	(369427, 125, '2015-01-15 01:08:12.000000', 'consum', 0.0213, 'lps'),
	(369428, 125, '2015-01-15 01:08:13.000000', 'consum', 0.0221, 'lps'),
	(369429, 125, '2015-01-15 01:08:14.000000', 'consum', 0.0222, 'lps'),
	(369430, 125, '2015-01-15 01:08:15.000000', 'consum', 0.0219, 'lps'),
	(369431, 125, '2015-01-15 01:08:16.000000', 'consum', 0.0219, 'lps'),
	(369432, 125, '2015-01-15 01:08:17.000000', 'consum', 0.0212, 'lps'),
	(369433, 125, '2015-01-15 01:08:18.000000', 'consum', 0.0211, 'lps'),
	(369434, 125, '2015-01-15 01:08:19.000000', 'consum', 0.0225, 'lps'),
	(369435, 125, '2015-01-15 01:08:20.000000', 'consum', 0.0213, 'lps'),
	(369436, 125, '2015-01-15 01:08:21.000000', 'consum', 0.0218, 'lps'),
	(369437, 125, '2015-01-15 01:08:22.000000', 'consum', 0.0225, 'lps'),
	(369438, 125, '2015-01-15 01:08:23.000000', 'consum', 0.0226, 'lps'),
	(369439, 125, '2015-01-15 01:08:24.000000', 'consum', 0.0213, 'lps'),
	(369440, 125, '2015-01-15 01:08:25.000000', 'consum', 0.0226, 'lps'),
	(369441, 125, '2015-01-15 01:08:26.000000', 'consum', 0.0216, 'lps'),
	(369442, 125, '2015-01-15 01:08:27.000000', 'consum', 0.0226, 'lps'),
	(369443, 125, '2015-01-15 01:08:28.000000', 'consum', 0.0221, 'lps'),
	(369444, 125, '2015-01-15 01:08:29.000000', 'consum', 0.0219, 'lps'),
	(369445, 125, '2015-01-15 01:08:30.000000', 'consum', 0.0222, 'lps'),
	(369446, 125, '2015-01-15 01:08:31.000000', 'consum', 0.0210, 'lps'),
	(369447, 125, '2015-01-15 01:08:32.000000', 'consum', 0.0224, 'lps'),
	(369448, 125, '2015-01-15 01:08:33.000000', 'consum', 0.0214, 'lps'),
	(369449, 125, '2015-01-15 01:08:34.000000', 'consum', 0.0222, 'lps'),
	(369450, 125, '2015-01-15 01:08:35.000000', 'consum', 0.0225, 'lps'),
	(369451, 125, '2015-01-15 01:08:36.000000', 'consum', 0.0214, 'lps'),
	(369452, 125, '2015-01-15 01:08:37.000000', 'consum', 0.0221, 'lps'),
	(369453, 125, '2015-01-15 01:08:38.000000', 'consum', 0.0217, 'lps'),
	(369454, 125, '2015-01-15 01:08:39.000000', 'consum', 0.0216, 'lps'),
	(369455, 125, '2015-01-15 01:08:40.000000', 'consum', 0.0216, 'lps'),
	(369456, 125, '2015-01-15 01:08:41.000000', 'consum', 0.0224, 'lps'),
	(369457, 125, '2015-01-15 01:08:42.000000', 'consum', 0.0226, 'lps'),
	(369458, 125, '2015-01-15 01:08:43.000000', 'consum', 0.0218, 'lps'),
	(369459, 125, '2015-01-15 01:08:44.000000', 'consum', 0.0216, 'lps'),
	(369460, 125, '2015-01-15 01:08:45.000000', 'consum', 0.0220, 'lps'),
	(369461, 125, '2015-01-15 01:08:46.000000', 'consum', 0.0224, 'lps'),
	(369462, 125, '2015-01-15 01:08:47.000000', 'consum', 0.0215, 'lps'),
	(369463, 125, '2015-01-15 01:08:48.000000', 'consum', 0.0213, 'lps'),
	(369464, 125, '2015-01-15 01:08:49.000000', 'consum', 0.0226, 'lps'),
	(369465, 125, '2015-01-15 01:08:50.000000', 'consum', 0.0212, 'lps'),
	(369466, 125, '2015-01-15 01:08:51.000000', 'consum', 0.0210, 'lps'),
	(369467, 125, '2015-01-15 01:08:52.000000', 'consum', 0.0218, 'lps'),
	(369468, 125, '2015-01-15 01:08:53.000000', 'consum', 0.0217, 'lps'),
	(369469, 125, '2015-01-15 01:08:54.000000', 'consum', 0.0224, 'lps'),
	(369470, 125, '2015-01-15 01:08:55.000000', 'consum', 0.0224, 'lps'),
	(369471, 125, '2015-01-15 01:08:56.000000', 'consum', 0.0221, 'lps'),
	(369472, 125, '2015-01-15 01:08:57.000000', 'consum', 0.0224, 'lps'),
	(369473, 125, '2015-01-15 01:08:58.000000', 'consum', 0.0214, 'lps'),
	(369474, 125, '2015-01-15 01:08:59.000000', 'consum', 0.0222, 'lps'),
	(369475, 125, '2015-01-15 01:09:00.000000', 'consum', 0.0225, 'lps'),
	(369476, 125, '2015-01-15 01:09:01.000000', 'consum', 0.0214, 'lps'),
	(369477, 125, '2015-01-15 01:09:02.000000', 'consum', 0.0221, 'lps'),
	(369478, 125, '2015-01-15 01:09:03.000000', 'consum', 0.0220, 'lps'),
	(369479, 125, '2015-01-15 01:09:04.000000', 'consum', 0.0212, 'lps'),
	(369480, 125, '2015-01-15 01:09:05.000000', 'consum', 0.0222, 'lps'),
	(369481, 125, '2015-01-15 01:09:06.000000', 'consum', 0.0215, 'lps'),
	(369482, 125, '2015-01-15 01:09:07.000000', 'consum', 0.0215, 'lps'),
	(369483, 125, '2015-01-15 01:09:08.000000', 'consum', 0.0222, 'lps'),
	(369484, 125, '2015-01-15 01:09:09.000000', 'consum', 0.0222, 'lps'),
	(369485, 125, '2015-01-15 01:09:10.000000', 'consum', 0.0216, 'lps'),
	(369486, 125, '2015-01-15 01:09:11.000000', 'consum', 0.0221, 'lps'),
	(369487, 125, '2015-01-15 01:09:12.000000', 'consum', 0.0216, 'lps'),
	(369488, 125, '2015-01-15 01:09:13.000000', 'consum', 0.0224, 'lps'),
	(369489, 125, '2015-01-15 01:09:14.000000', 'consum', 0.0212, 'lps'),
	(369490, 125, '2015-01-15 01:09:15.000000', 'consum', 0.0210, 'lps'),
	(369491, 125, '2015-01-15 01:09:16.000000', 'consum', 0.0221, 'lps'),
	(369492, 125, '2015-01-15 01:09:17.000000', 'consum', 0.0217, 'lps'),
	(369493, 125, '2015-01-15 01:09:18.000000', 'consum', 0.0212, 'lps'),
	(369494, 125, '2015-01-15 01:09:19.000000', 'consum', 0.0218, 'lps'),
	(369495, 125, '2015-01-15 01:09:20.000000', 'consum', 0.0224, 'lps'),
	(369496, 125, '2015-01-15 01:09:21.000000', 'consum', 0.0226, 'lps'),
	(369497, 125, '2015-01-15 01:09:22.000000', 'consum', 0.0212, 'lps'),
	(369498, 125, '2015-01-15 01:09:23.000000', 'consum', 0.0222, 'lps'),
	(369499, 125, '2015-01-15 01:09:24.000000', 'consum', 0.0217, 'lps'),
	(369500, 125, '2015-01-15 01:09:25.000000', 'consum', 0.0224, 'lps'),
	(369501, 125, '2015-01-15 01:09:26.000000', 'consum', 0.0226, 'lps'),
	(369502, 125, '2015-01-15 01:09:27.000000', 'consum', 0.0215, 'lps'),
	(369503, 125, '2015-01-15 01:09:28.000000', 'consum', 0.0220, 'lps'),
	(369504, 125, '2015-01-15 01:09:29.000000', 'consum', 0.0211, 'lps'),
	(369505, 125, '2015-01-15 01:09:30.000000', 'consum', 0.0219, 'lps'),
	(369506, 125, '2015-01-15 01:09:31.000000', 'consum', 0.0220, 'lps'),
	(369507, 125, '2015-01-15 01:09:32.000000', 'consum', 0.0217, 'lps'),
	(369508, 125, '2015-01-15 01:09:33.000000', 'consum', 0.0216, 'lps'),
	(369509, 125, '2015-01-15 01:09:34.000000', 'consum', 0.0217, 'lps'),
	(369510, 125, '2015-01-15 01:09:35.000000', 'consum', 0.0212, 'lps'),
	(369511, 125, '2015-01-15 01:09:36.000000', 'consum', 0.0218, 'lps'),
	(369512, 125, '2015-01-15 01:09:37.000000', 'consum', 0.0211, 'lps'),
	(369513, 125, '2015-01-15 01:09:38.000000', 'consum', 0.0223, 'lps'),
	(369514, 125, '2015-01-15 01:09:39.000000', 'consum', 0.0221, 'lps'),
	(369515, 125, '2015-01-15 01:09:40.000000', 'consum', 0.0211, 'lps'),
	(369516, 125, '2015-01-15 01:09:41.000000', 'consum', 0.0216, 'lps'),
	(369517, 125, '2015-01-15 01:09:42.000000', 'consum', 0.0221, 'lps'),
	(369518, 125, '2015-01-15 01:09:43.000000', 'consum', 0.0214, 'lps'),
	(369519, 125, '2015-01-15 01:09:44.000000', 'consum', 0.0216, 'lps'),
	(369520, 125, '2015-01-15 01:09:45.000000', 'consum', 0.0210, 'lps'),
	(369521, 125, '2015-01-15 01:09:46.000000', 'consum', 0.0226, 'lps'),
	(369522, 125, '2015-01-15 01:09:47.000000', 'consum', 0.0224, 'lps'),
	(369523, 125, '2015-01-15 01:09:48.000000', 'consum', 0.0213, 'lps'),
	(369524, 125, '2015-01-15 01:09:49.000000', 'consum', 0.0217, 'lps'),
	(369525, 125, '2015-01-15 01:09:50.000000', 'consum', 0.0221, 'lps'),
	(369526, 125, '2015-01-15 01:09:51.000000', 'consum', 0.0212, 'lps'),
	(369527, 125, '2015-01-15 01:09:52.000000', 'consum', 0.0219, 'lps'),
	(369528, 125, '2015-01-15 01:09:53.000000', 'consum', 0.0216, 'lps'),
	(369529, 125, '2015-01-15 01:09:54.000000', 'consum', 0.0214, 'lps'),
	(369530, 125, '2015-01-15 01:09:55.000000', 'consum', 0.0212, 'lps'),
	(369531, 125, '2015-01-15 01:09:56.000000', 'consum', 0.0225, 'lps'),
	(369532, 125, '2015-01-15 01:09:57.000000', 'consum', 0.0212, 'lps'),
	(369533, 125, '2015-01-15 01:09:58.000000', 'consum', 0.0226, 'lps'),
	(369534, 125, '2015-01-15 01:09:59.000000', 'consum', 0.0216, 'lps'),
	(369535, 125, '2015-01-15 01:10:00.000000', 'consum', 0.0210, 'lps'),
	(369536, 125, '2015-01-15 01:10:01.000000', 'consum', 0.0210, 'lps'),
	(369537, 125, '2015-01-15 01:10:02.000000', 'consum', 0.0226, 'lps'),
	(369538, 125, '2015-01-15 01:10:03.000000', 'consum', 0.0222, 'lps'),
	(369539, 125, '2015-01-15 01:10:04.000000', 'consum', 0.0225, 'lps'),
	(369540, 125, '2015-01-15 01:10:05.000000', 'consum', 0.0215, 'lps'),
	(369541, 125, '2015-01-15 01:10:06.000000', 'consum', 0.0226, 'lps'),
	(369542, 125, '2015-01-15 01:10:07.000000', 'consum', 0.0224, 'lps'),
	(369543, 125, '2015-01-15 01:10:08.000000', 'consum', 0.0214, 'lps'),
	(369544, 125, '2015-01-15 01:10:09.000000', 'consum', 0.0224, 'lps'),
	(369545, 125, '2015-01-15 01:10:10.000000', 'consum', 0.0218, 'lps'),
	(369546, 125, '2015-01-15 01:10:11.000000', 'consum', 0.0223, 'lps'),
	(369547, 125, '2015-01-15 01:10:12.000000', 'consum', 0.0219, 'lps'),
	(369548, 125, '2015-01-15 01:10:13.000000', 'consum', 0.0217, 'lps'),
	(369549, 125, '2015-01-15 01:10:14.000000', 'consum', 0.0217, 'lps'),
	(369550, 125, '2015-01-15 01:10:15.000000', 'consum', 0.0210, 'lps'),
	(369551, 125, '2015-01-15 01:10:16.000000', 'consum', 0.0223, 'lps'),
	(369552, 125, '2015-01-15 01:10:17.000000', 'consum', 0.0224, 'lps'),
	(369553, 125, '2015-01-15 01:10:18.000000', 'consum', 0.0223, 'lps'),
	(369554, 125, '2015-01-15 01:10:19.000000', 'consum', 0.0217, 'lps'),
	(369555, 125, '2015-01-15 01:10:20.000000', 'consum', 0.0225, 'lps'),
	(369556, 125, '2015-01-15 01:10:21.000000', 'consum', 0.0212, 'lps'),
	(369557, 125, '2015-01-15 01:10:22.000000', 'consum', 0.0211, 'lps'),
	(369558, 125, '2015-01-15 01:10:23.000000', 'consum', 0.0210, 'lps'),
	(369559, 125, '2015-01-15 01:10:24.000000', 'consum', 0.0224, 'lps'),
	(369560, 125, '2015-01-15 01:10:25.000000', 'consum', 0.0213, 'lps'),
	(369561, 125, '2015-01-15 01:10:26.000000', 'consum', 0.0215, 'lps'),
	(369562, 125, '2015-01-15 01:10:27.000000', 'consum', 0.0211, 'lps'),
	(369563, 125, '2015-01-15 01:10:28.000000', 'consum', 0.0217, 'lps'),
	(369564, 125, '2015-01-15 01:10:29.000000', 'consum', 0.0224, 'lps'),
	(369565, 125, '2015-01-15 01:10:30.000000', 'consum', 0.0210, 'lps'),
	(369566, 125, '2015-01-15 01:10:31.000000', 'consum', 0.0218, 'lps'),
	(369567, 125, '2015-01-15 01:10:32.000000', 'consum', 0.0217, 'lps'),
	(369568, 125, '2015-01-15 01:10:33.000000', 'consum', 0.0220, 'lps'),
	(369569, 125, '2015-01-15 01:10:34.000000', 'consum', 0.0226, 'lps'),
	(369570, 125, '2015-01-15 01:10:35.000000', 'consum', 0.0223, 'lps'),
	(369571, 125, '2015-01-15 01:10:36.000000', 'consum', 0.0212, 'lps'),
	(369572, 125, '2015-01-15 01:10:37.000000', 'consum', 0.0217, 'lps'),
	(369573, 125, '2015-01-15 01:10:38.000000', 'consum', 0.0220, 'lps'),
	(369574, 125, '2015-01-15 01:10:39.000000', 'consum', 0.0224, 'lps'),
	(369575, 125, '2015-01-15 01:10:40.000000', 'consum', 0.0216, 'lps'),
	(369576, 125, '2015-01-15 01:10:41.000000', 'consum', 0.0216, 'lps'),
	(369577, 125, '2015-01-15 01:10:42.000000', 'consum', 0.0222, 'lps'),
	(369578, 125, '2015-01-15 01:10:43.000000', 'consum', 0.0217, 'lps'),
	(369579, 125, '2015-01-15 01:10:44.000000', 'consum', 0.0213, 'lps'),
	(369580, 125, '2015-01-15 01:10:45.000000', 'consum', 0.0218, 'lps'),
	(369581, 125, '2015-01-15 01:10:46.000000', 'consum', 0.0226, 'lps'),
	(369582, 125, '2015-01-15 01:10:47.000000', 'consum', 0.0214, 'lps'),
	(369583, 125, '2015-01-15 01:10:48.000000', 'consum', 0.0217, 'lps'),
	(369584, 125, '2015-01-15 01:10:49.000000', 'consum', 0.0218, 'lps'),
	(369585, 125, '2015-01-15 01:10:50.000000', 'consum', 0.0211, 'lps'),
	(369586, 125, '2015-01-15 01:10:51.000000', 'consum', 0.0224, 'lps'),
	(369587, 125, '2015-01-15 01:10:52.000000', 'consum', 0.0213, 'lps'),
	(369588, 125, '2015-01-15 01:10:53.000000', 'consum', 0.0215, 'lps'),
	(369589, 125, '2015-01-15 01:10:54.000000', 'consum', 0.0210, 'lps'),
	(369590, 125, '2015-01-15 01:10:55.000000', 'consum', 0.0213, 'lps'),
	(369591, 125, '2015-01-15 01:10:56.000000', 'consum', 0.0224, 'lps'),
	(369592, 125, '2015-01-15 01:10:57.000000', 'consum', 0.0223, 'lps'),
	(369593, 125, '2015-01-15 01:10:58.000000', 'consum', 0.0215, 'lps'),
	(369594, 125, '2015-01-15 01:10:59.000000', 'consum', 0.0215, 'lps'),
	(369595, 125, '2015-01-15 01:11:00.000000', 'consum', 0.0221, 'lps'),
	(369596, 125, '2015-01-15 01:11:01.000000', 'consum', 0.0214, 'lps'),
	(369597, 125, '2015-01-15 01:11:02.000000', 'consum', 0.0215, 'lps'),
	(369598, 125, '2015-01-15 01:11:03.000000', 'consum', 0.0226, 'lps'),
	(369599, 125, '2015-01-15 01:11:04.000000', 'consum', 0.0222, 'lps'),
	(369600, 125, '2015-01-15 01:11:05.000000', 'consum', 0.0221, 'lps'),
	(369601, 125, '2015-01-15 01:11:06.000000', 'consum', 0.0215, 'lps'),
	(369602, 125, '2015-01-15 01:11:07.000000', 'consum', 0.0218, 'lps'),
	(369603, 125, '2015-01-15 01:11:08.000000', 'consum', 0.0220, 'lps'),
	(369604, 125, '2015-01-15 01:11:09.000000', 'consum', 0.0219, 'lps'),
	(369605, 125, '2015-01-15 01:11:10.000000', 'consum', 0.0224, 'lps'),
	(369606, 125, '2015-01-15 01:11:11.000000', 'consum', 0.0220, 'lps'),
	(369607, 125, '2015-01-15 01:11:12.000000', 'consum', 0.0221, 'lps'),
	(369608, 125, '2015-01-15 01:11:13.000000', 'consum', 0.0217, 'lps'),
	(369609, 125, '2015-01-15 01:11:14.000000', 'consum', 0.0211, 'lps'),
	(369610, 125, '2015-01-15 01:11:15.000000', 'consum', 0.0214, 'lps'),
	(369611, 125, '2015-01-15 01:11:16.000000', 'consum', 0.0211, 'lps'),
	(369612, 125, '2015-01-15 01:11:17.000000', 'consum', 0.0219, 'lps'),
	(369613, 125, '2015-01-15 01:11:18.000000', 'consum', 0.0217, 'lps'),
	(369614, 125, '2015-01-15 01:11:19.000000', 'consum', 0.0220, 'lps'),
	(369615, 125, '2015-01-15 01:11:20.000000', 'consum', 0.0221, 'lps'),
	(369616, 125, '2015-01-15 01:11:21.000000', 'consum', 0.0219, 'lps'),
	(369617, 125, '2015-01-15 01:11:22.000000', 'consum', 0.0224, 'lps'),
	(369618, 125, '2015-01-15 01:11:23.000000', 'consum', 0.0220, 'lps'),
	(369619, 125, '2015-01-15 01:11:24.000000', 'consum', 0.0220, 'lps'),
	(369620, 125, '2015-01-15 01:11:25.000000', 'consum', 0.0210, 'lps'),
	(369621, 125, '2015-01-15 01:11:26.000000', 'consum', 0.0215, 'lps'),
	(369622, 125, '2015-01-15 01:11:27.000000', 'consum', 0.0220, 'lps'),
	(369623, 125, '2015-01-15 01:11:28.000000', 'consum', 0.0210, 'lps'),
	(369624, 125, '2015-01-15 01:11:29.000000', 'consum', 0.0215, 'lps'),
	(369625, 125, '2015-01-15 01:11:30.000000', 'consum', 0.0217, 'lps'),
	(369626, 125, '2015-01-15 01:11:31.000000', 'consum', 0.0216, 'lps'),
	(369627, 125, '2015-01-15 01:11:32.000000', 'consum', 0.0219, 'lps'),
	(369628, 125, '2015-01-15 01:11:33.000000', 'consum', 0.0220, 'lps'),
	(369629, 125, '2015-01-15 01:11:34.000000', 'consum', 0.0217, 'lps'),
	(369630, 125, '2015-01-15 01:11:35.000000', 'consum', 0.0215, 'lps'),
	(369631, 125, '2015-01-15 01:11:36.000000', 'consum', 0.0215, 'lps'),
	(369632, 125, '2015-01-15 01:11:37.000000', 'consum', 0.0222, 'lps'),
	(369633, 125, '2015-01-15 01:11:38.000000', 'consum', 0.0219, 'lps'),
	(369634, 125, '2015-01-15 01:11:39.000000', 'consum', 0.0221, 'lps'),
	(369635, 125, '2015-01-15 01:11:40.000000', 'consum', 0.0219, 'lps'),
	(369636, 125, '2015-01-15 01:11:41.000000', 'consum', 0.0224, 'lps'),
	(369637, 125, '2015-01-15 01:11:42.000000', 'consum', 0.0219, 'lps'),
	(369638, 125, '2015-01-15 01:11:43.000000', 'consum', 0.0213, 'lps'),
	(369639, 125, '2015-01-15 01:11:44.000000', 'consum', 0.0218, 'lps'),
	(369640, 125, '2015-01-15 01:11:45.000000', 'consum', 0.0223, 'lps'),
	(369641, 125, '2015-01-15 01:11:46.000000', 'consum', 0.0218, 'lps'),
	(369642, 125, '2015-01-15 01:11:47.000000', 'consum', 0.0213, 'lps'),
	(369643, 125, '2015-01-15 01:11:48.000000', 'consum', 0.0217, 'lps'),
	(369644, 125, '2015-01-15 01:11:49.000000', 'consum', 0.0222, 'lps'),
	(369645, 125, '2015-01-15 01:11:50.000000', 'consum', 0.0212, 'lps'),
	(369646, 125, '2015-01-15 01:11:51.000000', 'consum', 0.0221, 'lps'),
	(369647, 125, '2015-01-15 01:11:52.000000', 'consum', 0.0223, 'lps'),
	(369648, 125, '2015-01-15 01:11:53.000000', 'consum', 0.0211, 'lps'),
	(369649, 125, '2015-01-15 01:11:54.000000', 'consum', 0.0225, 'lps'),
	(369650, 125, '2015-01-15 01:11:55.000000', 'consum', 0.0214, 'lps'),
	(369651, 125, '2015-01-15 01:11:56.000000', 'consum', 0.0222, 'lps'),
	(369652, 125, '2015-01-15 01:11:57.000000', 'consum', 0.0225, 'lps'),
	(369653, 125, '2015-01-15 01:11:58.000000', 'consum', 0.0214, 'lps'),
	(369654, 125, '2015-01-15 01:11:59.000000', 'consum', 0.0221, 'lps'),
	(369655, 125, '2015-01-15 01:12:00.000000', 'consum', 0.0220, 'lps'),
	(369656, 125, '2015-01-15 01:12:01.000000', 'consum', 0.0226, 'lps'),
	(369657, 125, '2015-01-15 01:12:02.000000', 'consum', 0.0225, 'lps'),
	(369658, 125, '2015-01-15 01:12:03.000000', 'consum', 0.0223, 'lps'),
	(369659, 125, '2015-01-15 01:12:04.000000', 'consum', 0.0214, 'lps'),
	(369660, 125, '2015-01-15 01:12:05.000000', 'consum', 0.0224, 'lps'),
	(369661, 125, '2015-01-15 01:12:06.000000', 'consum', 0.0216, 'lps'),
	(369662, 125, '2015-01-15 01:12:07.000000', 'consum', 0.0218, 'lps'),
	(369663, 125, '2015-01-15 01:12:08.000000', 'consum', 0.0215, 'lps'),
	(369664, 125, '2015-01-15 01:12:09.000000', 'consum', 0.0211, 'lps'),
	(369665, 125, '2015-01-15 01:12:10.000000', 'consum', 0.0219, 'lps'),
	(369666, 125, '2015-01-15 01:12:11.000000', 'consum', 0.0216, 'lps'),
	(369667, 125, '2015-01-15 01:12:12.000000', 'consum', 0.0215, 'lps'),
	(369668, 125, '2015-01-15 01:12:13.000000', 'consum', 0.0217, 'lps'),
	(369669, 125, '2015-01-15 01:12:14.000000', 'consum', 0.0214, 'lps'),
	(369670, 125, '2015-01-15 01:12:15.000000', 'consum', 0.0225, 'lps'),
	(369671, 125, '2015-01-15 01:12:16.000000', 'consum', 0.0222, 'lps'),
	(369672, 125, '2015-01-15 01:12:17.000000', 'consum', 0.0212, 'lps'),
	(369673, 125, '2015-01-15 01:12:18.000000', 'consum', 0.0215, 'lps'),
	(369674, 125, '2015-01-15 01:12:19.000000', 'consum', 0.0213, 'lps'),
	(369675, 125, '2015-01-15 01:12:20.000000', 'consum', 0.0212, 'lps'),
	(369676, 125, '2015-01-15 01:12:21.000000', 'consum', 0.0226, 'lps'),
	(369677, 125, '2015-01-15 01:12:22.000000', 'consum', 0.0217, 'lps'),
	(369678, 125, '2015-01-15 01:12:23.000000', 'consum', 0.0214, 'lps'),
	(369679, 125, '2015-01-15 01:12:24.000000', 'consum', 0.0225, 'lps'),
	(369680, 125, '2015-01-15 01:12:25.000000', 'consum', 0.0225, 'lps'),
	(369681, 125, '2015-01-15 01:12:26.000000', 'consum', 0.0221, 'lps'),
	(369682, 125, '2015-01-15 01:12:27.000000', 'consum', 0.0223, 'lps'),
	(369683, 125, '2015-01-15 01:12:28.000000', 'consum', 0.0226, 'lps'),
	(369684, 125, '2015-01-15 01:12:29.000000', 'consum', 0.0216, 'lps'),
	(369685, 125, '2015-01-15 01:12:30.000000', 'consum', 0.0225, 'lps'),
	(369686, 125, '2015-01-15 01:12:31.000000', 'consum', 0.0219, 'lps'),
	(369687, 125, '2015-01-15 01:12:32.000000', 'consum', 0.0226, 'lps'),
	(369688, 125, '2015-01-15 01:12:33.000000', 'consum', 0.0212, 'lps'),
	(369689, 125, '2015-01-15 01:12:34.000000', 'consum', 0.0224, 'lps'),
	(369690, 125, '2015-01-15 01:12:35.000000', 'consum', 0.0223, 'lps'),
	(369691, 125, '2015-01-15 01:12:36.000000', 'consum', 0.0218, 'lps'),
	(369692, 125, '2015-01-15 01:12:37.000000', 'consum', 0.0212, 'lps'),
	(369693, 125, '2015-01-15 01:12:38.000000', 'consum', 0.0213, 'lps'),
	(369694, 125, '2015-01-15 01:12:39.000000', 'consum', 0.0219, 'lps'),
	(369695, 125, '2015-01-15 01:12:40.000000', 'consum', 0.0213, 'lps'),
	(369696, 125, '2015-01-15 01:12:41.000000', 'consum', 0.0217, 'lps'),
	(369697, 125, '2015-01-15 01:12:42.000000', 'consum', 0.0217, 'lps'),
	(369698, 125, '2015-01-15 01:12:43.000000', 'consum', 0.0224, 'lps'),
	(369699, 125, '2015-01-15 01:12:44.000000', 'consum', 0.0210, 'lps'),
	(369700, 125, '2015-01-15 01:12:45.000000', 'consum', 0.0220, 'lps'),
	(369701, 125, '2015-01-15 01:12:46.000000', 'consum', 0.0225, 'lps'),
	(369702, 125, '2015-01-15 01:12:47.000000', 'consum', 0.0222, 'lps'),
	(369703, 125, '2015-01-15 01:12:48.000000', 'consum', 0.0225, 'lps'),
	(369704, 125, '2015-01-15 01:12:49.000000', 'consum', 0.0217, 'lps'),
	(369705, 125, '2015-01-15 01:12:50.000000', 'consum', 0.0218, 'lps'),
	(369706, 125, '2015-01-15 01:12:51.000000', 'consum', 0.0210, 'lps'),
	(369707, 125, '2015-01-15 01:12:52.000000', 'consum', 0.0220, 'lps'),
	(369708, 125, '2015-01-15 01:12:53.000000', 'consum', 0.0212, 'lps'),
	(369709, 125, '2015-01-15 01:12:54.000000', 'consum', 0.0224, 'lps'),
	(369710, 125, '2015-01-15 01:12:55.000000', 'consum', 0.0224, 'lps'),
	(369711, 125, '2015-01-15 01:12:56.000000', 'consum', 0.0221, 'lps'),
	(369712, 125, '2015-01-15 01:12:57.000000', 'consum', 0.0222, 'lps'),
	(369713, 125, '2015-01-15 01:12:58.000000', 'consum', 0.0222, 'lps'),
	(369714, 125, '2015-01-15 01:12:59.000000', 'consum', 0.0219, 'lps'),
	(369715, 125, '2015-01-15 01:13:00.000000', 'consum', 0.0218, 'lps'),
	(369716, 125, '2015-01-15 01:13:01.000000', 'consum', 0.0224, 'lps'),
	(369717, 125, '2015-01-15 01:13:02.000000', 'consum', 0.0221, 'lps'),
	(369718, 125, '2015-01-15 01:13:03.000000', 'consum', 0.0222, 'lps'),
	(369719, 125, '2015-01-15 01:13:04.000000', 'consum', 0.0224, 'lps'),
	(369720, 125, '2015-01-15 01:13:05.000000', 'consum', 0.0226, 'lps'),
	(369721, 125, '2015-01-15 01:13:06.000000', 'consum', 0.0217, 'lps'),
	(369722, 125, '2015-01-15 01:13:07.000000', 'consum', 0.0211, 'lps'),
	(369723, 125, '2015-01-15 01:13:08.000000', 'consum', 0.0212, 'lps'),
	(369724, 125, '2015-01-15 01:13:09.000000', 'consum', 0.0217, 'lps'),
	(369725, 125, '2015-01-15 01:13:10.000000', 'consum', 0.0222, 'lps'),
	(369726, 125, '2015-01-15 01:13:11.000000', 'consum', 0.0215, 'lps'),
	(369727, 125, '2015-01-15 01:13:12.000000', 'consum', 0.0216, 'lps'),
	(369728, 125, '2015-01-15 01:13:13.000000', 'consum', 0.0225, 'lps'),
	(369729, 125, '2015-01-15 01:13:14.000000', 'consum', 0.0216, 'lps'),
	(369730, 125, '2015-01-15 01:13:15.000000', 'consum', 0.0215, 'lps'),
	(369731, 125, '2015-01-15 01:13:16.000000', 'consum', 0.0216, 'lps'),
	(369732, 125, '2015-01-15 01:13:17.000000', 'consum', 0.0225, 'lps'),
	(369733, 125, '2015-01-15 01:13:18.000000', 'consum', 0.0216, 'lps'),
	(369734, 125, '2015-01-15 01:13:19.000000', 'consum', 0.0215, 'lps'),
	(369735, 125, '2015-01-15 01:13:20.000000', 'consum', 0.0215, 'lps'),
	(369736, 125, '2015-01-15 01:13:21.000000', 'consum', 0.0219, 'lps'),
	(369737, 125, '2015-01-15 01:13:22.000000', 'consum', 0.0210, 'lps'),
	(369738, 125, '2015-01-15 01:13:23.000000', 'consum', 0.0214, 'lps'),
	(369739, 125, '2015-01-15 01:13:24.000000', 'consum', 0.0216, 'lps'),
	(369740, 125, '2015-01-15 01:13:25.000000', 'consum', 0.0212, 'lps'),
	(369741, 125, '2015-01-15 01:13:26.000000', 'consum', 0.0219, 'lps'),
	(369742, 125, '2015-01-15 01:13:27.000000', 'consum', 0.0217, 'lps'),
	(369743, 125, '2015-01-15 01:13:28.000000', 'consum', 0.0217, 'lps'),
	(369744, 125, '2015-01-15 01:13:29.000000', 'consum', 0.0224, 'lps'),
	(369745, 125, '2015-01-15 01:13:30.000000', 'consum', 0.0225, 'lps'),
	(369746, 125, '2015-01-15 01:13:31.000000', 'consum', 0.0225, 'lps'),
	(369747, 125, '2015-01-15 01:13:32.000000', 'consum', 0.0210, 'lps'),
	(369748, 125, '2015-01-15 01:13:33.000000', 'consum', 0.0214, 'lps'),
	(369749, 125, '2015-01-15 01:13:34.000000', 'consum', 0.0216, 'lps'),
	(369750, 125, '2015-01-15 01:13:35.000000', 'consum', 0.0226, 'lps'),
	(369751, 125, '2015-01-15 01:13:36.000000', 'consum', 0.0224, 'lps'),
	(369752, 125, '2015-01-15 01:13:37.000000', 'consum', 0.0216, 'lps'),
	(369753, 125, '2015-01-15 01:13:38.000000', 'consum', 0.0214, 'lps'),
	(369754, 125, '2015-01-15 01:13:39.000000', 'consum', 0.0211, 'lps'),
	(369755, 125, '2015-01-15 01:13:40.000000', 'consum', 0.0222, 'lps'),
	(369756, 125, '2015-01-15 01:13:41.000000', 'consum', 0.0215, 'lps'),
	(369757, 125, '2015-01-15 01:13:42.000000', 'consum', 0.0218, 'lps'),
	(369758, 125, '2015-01-15 01:13:43.000000', 'consum', 0.0219, 'lps'),
	(369759, 125, '2015-01-15 01:13:44.000000', 'consum', 0.0213, 'lps'),
	(369760, 125, '2015-01-15 01:13:45.000000', 'consum', 0.0216, 'lps'),
	(369761, 125, '2015-01-15 01:13:46.000000', 'consum', 0.0214, 'lps'),
	(369762, 125, '2015-01-15 01:13:47.000000', 'consum', 0.0215, 'lps'),
	(369763, 125, '2015-01-15 01:13:48.000000', 'consum', 0.0222, 'lps'),
	(369764, 125, '2015-01-15 01:13:49.000000', 'consum', 0.0221, 'lps'),
	(369765, 125, '2015-01-15 01:13:50.000000', 'consum', 0.0212, 'lps'),
	(369766, 125, '2015-01-15 01:13:51.000000', 'consum', 0.0222, 'lps'),
	(369767, 125, '2015-01-15 01:13:52.000000', 'consum', 0.0212, 'lps'),
	(369768, 125, '2015-01-15 01:13:53.000000', 'consum', 0.0220, 'lps'),
	(369769, 125, '2015-01-15 01:13:54.000000', 'consum', 0.0222, 'lps'),
	(369770, 125, '2015-01-15 01:13:55.000000', 'consum', 0.0223, 'lps'),
	(369771, 125, '2015-01-15 01:13:56.000000', 'consum', 0.0221, 'lps'),
	(369772, 125, '2015-01-15 01:13:57.000000', 'consum', 0.0211, 'lps'),
	(369773, 125, '2015-01-15 01:13:58.000000', 'consum', 0.0215, 'lps'),
	(369774, 125, '2015-01-15 01:13:59.000000', 'consum', 0.0215, 'lps'),
	(369775, 125, '2015-01-15 01:14:00.000000', 'consum', 0.0221, 'lps'),
	(369776, 125, '2015-01-15 01:14:01.000000', 'consum', 0.0217, 'lps'),
	(369777, 125, '2015-01-15 01:14:02.000000', 'consum', 0.0212, 'lps'),
	(369778, 125, '2015-01-15 01:14:03.000000', 'consum', 0.0217, 'lps'),
	(369779, 125, '2015-01-15 01:14:04.000000', 'consum', 0.0222, 'lps'),
	(369780, 125, '2015-01-15 01:14:05.000000', 'consum', 0.0215, 'lps'),
	(369781, 125, '2015-01-15 01:14:06.000000', 'consum', 0.0219, 'lps'),
	(369782, 125, '2015-01-15 01:14:07.000000', 'consum', 0.0220, 'lps'),
	(369783, 125, '2015-01-15 01:14:08.000000', 'consum', 0.0219, 'lps'),
	(369784, 125, '2015-01-15 01:14:09.000000', 'consum', 0.0210, 'lps'),
	(369785, 125, '2015-01-15 01:14:10.000000', 'consum', 0.0214, 'lps'),
	(369786, 125, '2015-01-15 01:14:11.000000', 'consum', 0.0217, 'lps'),
	(369787, 125, '2015-01-15 01:14:12.000000', 'consum', 0.0215, 'lps'),
	(369788, 125, '2015-01-15 01:14:13.000000', 'consum', 0.0213, 'lps'),
	(369789, 125, '2015-01-15 01:14:14.000000', 'consum', 0.0213, 'lps'),
	(369790, 125, '2015-01-15 01:14:15.000000', 'consum', 0.0218, 'lps'),
	(369791, 125, '2015-01-15 01:14:16.000000', 'consum', 0.0221, 'lps'),
	(369792, 125, '2015-01-15 01:14:17.000000', 'consum', 0.0225, 'lps'),
	(369793, 125, '2015-01-15 01:14:18.000000', 'consum', 0.0220, 'lps'),
	(369794, 125, '2015-01-15 01:14:19.000000', 'consum', 0.0214, 'lps'),
	(369795, 125, '2015-01-15 01:14:20.000000', 'consum', 0.0217, 'lps'),
	(369796, 125, '2015-01-15 01:14:21.000000', 'consum', 0.0219, 'lps'),
	(369797, 125, '2015-01-15 01:14:22.000000', 'consum', 0.0215, 'lps'),
	(369798, 125, '2015-01-15 01:14:23.000000', 'consum', 0.0226, 'lps'),
	(369799, 125, '2015-01-15 01:14:24.000000', 'consum', 0.0224, 'lps'),
	(369800, 125, '2015-01-15 01:14:25.000000', 'consum', 0.0218, 'lps'),
	(369801, 125, '2015-01-15 01:14:26.000000', 'consum', 0.0222, 'lps'),
	(369802, 125, '2015-01-15 01:14:27.000000', 'consum', 0.0216, 'lps'),
	(369803, 125, '2015-01-15 01:14:28.000000', 'consum', 0.0218, 'lps'),
	(369804, 125, '2015-01-15 01:14:29.000000', 'consum', 0.0218, 'lps'),
	(369805, 125, '2015-01-15 01:14:30.000000', 'consum', 0.0226, 'lps'),
	(369806, 125, '2015-01-15 01:14:31.000000', 'consum', 0.0217, 'lps'),
	(369807, 125, '2015-01-15 01:14:32.000000', 'consum', 0.0214, 'lps'),
	(369808, 125, '2015-01-15 01:14:33.000000', 'consum', 0.0210, 'lps'),
	(369809, 125, '2015-01-15 01:14:34.000000', 'consum', 0.0215, 'lps'),
	(369810, 125, '2015-01-15 01:14:35.000000', 'consum', 0.0220, 'lps'),
	(369811, 125, '2015-01-15 01:14:36.000000', 'consum', 0.0210, 'lps'),
	(369812, 125, '2015-01-15 01:14:37.000000', 'consum', 0.0214, 'lps'),
	(369813, 125, '2015-01-15 01:14:38.000000', 'consum', 0.0215, 'lps'),
	(369814, 125, '2015-01-15 01:14:39.000000', 'consum', 0.0223, 'lps'),
	(369815, 125, '2015-01-15 01:14:40.000000', 'consum', 0.0210, 'lps'),
	(369816, 125, '2015-01-15 01:14:41.000000', 'consum', 0.0224, 'lps'),
	(369817, 125, '2015-01-15 01:14:42.000000', 'consum', 0.0211, 'lps'),
	(369818, 125, '2015-01-15 01:14:43.000000', 'consum', 0.0223, 'lps'),
	(369819, 125, '2015-01-15 01:14:44.000000', 'consum', 0.0222, 'lps'),
	(369820, 125, '2015-01-15 01:14:45.000000', 'consum', 0.0215, 'lps'),
	(369821, 125, '2015-01-15 01:14:46.000000', 'consum', 0.0216, 'lps'),
	(369822, 125, '2015-01-15 01:14:47.000000', 'consum', 0.0224, 'lps'),
	(369823, 125, '2015-01-15 01:14:48.000000', 'consum', 0.0212, 'lps'),
	(369824, 125, '2015-01-15 01:14:49.000000', 'consum', 0.0212, 'lps'),
	(369825, 125, '2015-01-15 01:14:50.000000', 'consum', 0.0216, 'lps'),
	(369826, 125, '2015-01-15 01:14:51.000000', 'consum', 0.0215, 'lps'),
	(369827, 125, '2015-01-15 01:14:52.000000', 'consum', 0.0218, 'lps'),
	(369828, 125, '2015-01-15 01:14:53.000000', 'consum', 0.0220, 'lps'),
	(369829, 125, '2015-01-15 01:14:54.000000', 'consum', 0.0219, 'lps'),
	(369830, 125, '2015-01-15 01:14:55.000000', 'consum', 0.0225, 'lps'),
	(369831, 125, '2015-01-15 01:14:56.000000', 'consum', 0.0225, 'lps'),
	(369832, 125, '2015-01-15 01:14:57.000000', 'consum', 0.0221, 'lps'),
	(369833, 125, '2015-01-15 01:14:58.000000', 'consum', 0.0224, 'lps'),
	(369834, 125, '2015-01-15 01:14:59.000000', 'consum', 0.0213, 'lps'),
	(369835, 125, '2015-01-15 01:15:00.000000', 'consum', 0.0217, 'lps'),
	(369836, 125, '2015-01-15 01:15:01.000000', 'consum', 0.0217, 'lps'),
	(369837, 125, '2015-01-15 01:15:02.000000', 'consum', 0.0211, 'lps'),
	(369838, 125, '2015-01-15 01:15:03.000000', 'consum', 0.0225, 'lps'),
	(369839, 125, '2015-01-15 01:15:04.000000', 'consum', 0.0218, 'lps'),
	(369840, 125, '2015-01-15 01:15:05.000000', 'consum', 0.0220, 'lps'),
	(369841, 125, '2015-01-15 01:15:06.000000', 'consum', 0.0220, 'lps'),
	(369842, 125, '2015-01-15 01:15:07.000000', 'consum', 0.0213, 'lps'),
	(369843, 125, '2015-01-15 01:15:08.000000', 'consum', 0.0215, 'lps'),
	(369844, 125, '2015-01-15 01:15:09.000000', 'consum', 0.0224, 'lps'),
	(369845, 125, '2015-01-15 01:15:10.000000', 'consum', 0.0216, 'lps'),
	(369846, 125, '2015-01-15 01:15:11.000000', 'consum', 0.0215, 'lps'),
	(369847, 125, '2015-01-15 01:15:12.000000', 'consum', 0.0219, 'lps'),
	(369848, 125, '2015-01-15 01:15:13.000000', 'consum', 0.0222, 'lps'),
	(369849, 125, '2015-01-15 01:15:14.000000', 'consum', 0.0210, 'lps'),
	(369850, 125, '2015-01-15 01:15:15.000000', 'consum', 0.0226, 'lps'),
	(369851, 125, '2015-01-15 01:15:16.000000', 'consum', 0.0222, 'lps'),
	(369852, 125, '2015-01-15 01:15:17.000000', 'consum', 0.0224, 'lps'),
	(369853, 125, '2015-01-15 01:15:18.000000', 'consum', 0.0226, 'lps'),
	(369854, 125, '2015-01-15 01:15:19.000000', 'consum', 0.0216, 'lps'),
	(369855, 125, '2015-01-15 01:15:20.000000', 'consum', 0.0226, 'lps'),
	(369856, 125, '2015-01-15 01:15:21.000000', 'consum', 0.0221, 'lps'),
	(369857, 125, '2015-01-15 01:15:22.000000', 'consum', 0.0219, 'lps'),
	(369858, 125, '2015-01-15 01:15:23.000000', 'consum', 0.0222, 'lps'),
	(369859, 125, '2015-01-15 01:15:24.000000', 'consum', 0.0226, 'lps'),
	(369860, 125, '2015-01-15 01:15:25.000000', 'consum', 0.0222, 'lps'),
	(369861, 125, '2015-01-15 01:15:26.000000', 'consum', 0.0220, 'lps'),
	(369862, 125, '2015-01-15 01:15:27.000000', 'consum', 0.0210, 'lps'),
	(369863, 125, '2015-01-15 01:15:28.000000', 'consum', 0.0215, 'lps'),
	(369864, 125, '2015-01-15 01:15:29.000000', 'consum', 0.0216, 'lps'),
	(369865, 125, '2015-01-15 01:15:30.000000', 'consum', 0.0210, 'lps'),
	(369866, 125, '2015-01-15 01:15:31.000000', 'consum', 0.0226, 'lps'),
	(369867, 125, '2015-01-15 01:15:32.000000', 'consum', 0.0224, 'lps'),
	(369868, 125, '2015-01-15 01:15:33.000000', 'consum', 0.0215, 'lps'),
	(369869, 125, '2015-01-15 01:15:34.000000', 'consum', 0.0211, 'lps'),
	(369870, 125, '2015-01-15 01:15:35.000000', 'consum', 0.0217, 'lps'),
	(369871, 125, '2015-01-15 01:15:36.000000', 'consum', 0.0226, 'lps'),
	(369872, 125, '2015-01-15 01:15:37.000000', 'consum', 0.0217, 'lps'),
	(369873, 125, '2015-01-15 01:15:38.000000', 'consum', 0.0214, 'lps'),
	(369874, 125, '2015-01-15 01:15:39.000000', 'consum', 0.0210, 'lps'),
	(369875, 125, '2015-01-15 01:15:40.000000', 'consum', 0.0216, 'lps'),
	(369876, 125, '2015-01-15 01:15:41.000000', 'consum', 0.0222, 'lps'),
	(369877, 125, '2015-01-15 01:15:42.000000', 'consum', 0.0219, 'lps'),
	(369878, 125, '2015-01-15 01:15:43.000000', 'consum', 0.0222, 'lps'),
	(369879, 125, '2015-01-15 01:15:44.000000', 'consum', 0.0224, 'lps'),
	(369880, 125, '2015-01-15 01:15:45.000000', 'consum', 0.0210, 'lps'),
	(369881, 125, '2015-01-15 01:15:46.000000', 'consum', 0.0222, 'lps'),
	(369882, 125, '2015-01-15 01:15:47.000000', 'consum', 0.0217, 'lps'),
	(369883, 125, '2015-01-15 01:15:48.000000', 'consum', 0.0210, 'lps'),
	(369884, 125, '2015-01-15 01:15:49.000000', 'consum', 0.0223, 'lps'),
	(369885, 125, '2015-01-15 01:15:50.000000', 'consum', 0.0210, 'lps'),
	(369886, 125, '2015-01-15 01:15:51.000000', 'consum', 0.0220, 'lps'),
	(369887, 125, '2015-01-15 01:15:52.000000', 'consum', 0.0211, 'lps'),
	(369888, 125, '2015-01-15 01:15:53.000000', 'consum', 0.0217, 'lps'),
	(369889, 125, '2015-01-15 01:15:54.000000', 'consum', 0.0211, 'lps'),
	(369890, 125, '2015-01-15 01:15:55.000000', 'consum', 0.0212, 'lps'),
	(369891, 125, '2015-01-15 01:15:56.000000', 'consum', 0.0216, 'lps'),
	(369892, 125, '2015-01-15 01:15:57.000000', 'consum', 0.0218, 'lps'),
	(369893, 125, '2015-01-15 01:15:58.000000', 'consum', 0.0213, 'lps'),
	(369894, 125, '2015-01-15 01:15:59.000000', 'consum', 0.0222, 'lps'),
	(369895, 125, '2015-01-15 01:16:00.000000', 'consum', 0.0224, 'lps'),
	(369896, 125, '2015-01-15 01:16:01.000000', 'consum', 0.0213, 'lps'),
	(369897, 125, '2015-01-15 01:16:02.000000', 'consum', 0.0215, 'lps'),
	(369898, 125, '2015-01-15 01:16:03.000000', 'consum', 0.0212, 'lps'),
	(369899, 125, '2015-01-15 01:16:04.000000', 'consum', 0.0222, 'lps'),
	(369900, 125, '2015-01-15 01:16:05.000000', 'consum', 0.0215, 'lps'),
	(369901, 125, '2015-01-15 01:16:06.000000', 'consum', 0.0215, 'lps'),
	(369902, 125, '2015-01-15 01:16:07.000000', 'consum', 0.0221, 'lps'),
	(369903, 125, '2015-01-15 01:16:08.000000', 'consum', 0.0216, 'lps'),
	(369904, 125, '2015-01-15 01:16:09.000000', 'consum', 0.0223, 'lps'),
	(369905, 125, '2015-01-15 01:16:10.000000', 'consum', 0.0225, 'lps'),
	(369906, 125, '2015-01-15 01:16:11.000000', 'consum', 0.0214, 'lps'),
	(369907, 125, '2015-01-15 01:16:12.000000', 'consum', 0.0220, 'lps'),
	(369908, 125, '2015-01-15 01:16:13.000000', 'consum', 0.0212, 'lps'),
	(369909, 125, '2015-01-15 01:16:14.000000', 'consum', 0.0226, 'lps'),
	(369910, 125, '2015-01-15 01:16:15.000000', 'consum', 0.0215, 'lps'),
	(369911, 125, '2015-01-15 01:16:16.000000', 'consum', 0.0224, 'lps'),
	(369912, 125, '2015-01-15 01:16:17.000000', 'consum', 0.0212, 'lps'),
	(369913, 125, '2015-01-15 01:16:18.000000', 'consum', 0.0215, 'lps'),
	(369914, 125, '2015-01-15 01:16:19.000000', 'consum', 0.0226, 'lps'),
	(369915, 125, '2015-01-15 01:16:20.000000', 'consum', 0.0210, 'lps'),
	(369916, 125, '2015-01-15 01:16:21.000000', 'consum', 0.0214, 'lps'),
	(369917, 125, '2015-01-15 01:16:22.000000', 'consum', 0.0214, 'lps'),
	(369918, 125, '2015-01-15 01:16:23.000000', 'consum', 0.0218, 'lps'),
	(369919, 125, '2015-01-15 01:16:24.000000', 'consum', 0.0220, 'lps'),
	(369920, 125, '2015-01-15 01:16:25.000000', 'consum', 0.0222, 'lps'),
	(369921, 125, '2015-01-15 01:16:26.000000', 'consum', 0.0223, 'lps'),
	(369922, 125, '2015-01-15 01:16:27.000000', 'consum', 0.0220, 'lps'),
	(369923, 125, '2015-01-15 01:16:28.000000', 'consum', 0.0224, 'lps'),
	(369924, 125, '2015-01-15 01:16:29.000000', 'consum', 0.0214, 'lps'),
	(369925, 125, '2015-01-15 01:16:30.000000', 'consum', 0.0224, 'lps'),
	(369926, 125, '2015-01-15 01:16:31.000000', 'consum', 0.0216, 'lps'),
	(369927, 125, '2015-01-15 01:16:32.000000', 'consum', 0.0217, 'lps'),
	(369928, 125, '2015-01-15 01:16:33.000000', 'consum', 0.0210, 'lps'),
	(369929, 125, '2015-01-15 01:16:34.000000', 'consum', 0.0223, 'lps'),
	(369930, 125, '2015-01-15 01:16:35.000000', 'consum', 0.0226, 'lps'),
	(369931, 125, '2015-01-15 01:16:36.000000', 'consum', 0.0215, 'lps'),
	(369932, 125, '2015-01-15 01:16:37.000000', 'consum', 0.0222, 'lps'),
	(369933, 125, '2015-01-15 01:16:38.000000', 'consum', 0.0223, 'lps'),
	(369934, 125, '2015-01-15 01:16:39.000000', 'consum', 0.0223, 'lps'),
	(369935, 125, '2015-01-15 01:16:40.000000', 'consum', 0.0218, 'lps'),
	(369936, 125, '2015-01-15 01:16:41.000000', 'consum', 0.0214, 'lps'),
	(369937, 125, '2015-01-15 01:16:42.000000', 'consum', 0.0221, 'lps'),
	(369938, 125, '2015-01-15 01:16:43.000000', 'consum', 0.0218, 'lps'),
	(369939, 125, '2015-01-15 01:16:44.000000', 'consum', 0.0220, 'lps'),
	(369940, 125, '2015-01-15 01:16:45.000000', 'consum', 0.0218, 'lps'),
	(369941, 125, '2015-01-15 01:16:46.000000', 'consum', 0.0223, 'lps'),
	(369942, 125, '2015-01-15 01:16:47.000000', 'consum', 0.0217, 'lps'),
	(369943, 125, '2015-01-15 01:16:48.000000', 'consum', 0.0221, 'lps'),
	(369944, 125, '2015-01-15 01:16:49.000000', 'consum', 0.0211, 'lps'),
	(369945, 125, '2015-01-15 01:16:50.000000', 'consum', 0.0219, 'lps'),
	(369946, 125, '2015-01-15 01:16:51.000000', 'consum', 0.0217, 'lps'),
	(369947, 125, '2015-01-15 01:16:52.000000', 'consum', 0.0220, 'lps'),
	(369948, 125, '2015-01-15 01:16:53.000000', 'consum', 0.0221, 'lps'),
	(369949, 125, '2015-01-15 01:16:54.000000', 'consum', 0.0218, 'lps'),
	(369950, 125, '2015-01-15 01:16:55.000000', 'consum', 0.0218, 'lps'),
	(369951, 125, '2015-01-15 01:16:56.000000', 'consum', 0.0210, 'lps'),
	(369952, 125, '2015-01-15 01:16:57.000000', 'consum', 0.0219, 'lps'),
	(369953, 125, '2015-01-15 01:16:58.000000', 'consum', 0.0223, 'lps'),
	(369954, 125, '2015-01-15 01:16:59.000000', 'consum', 0.0213, 'lps'),
	(369955, 125, '2015-01-15 01:17:00.000000', 'consum', 0.0220, 'lps'),
	(369956, 125, '2015-01-15 01:17:01.000000', 'consum', 0.0220, 'lps'),
	(369957, 125, '2015-01-15 01:17:02.000000', 'consum', 0.0213, 'lps'),
	(369958, 125, '2015-01-15 01:17:03.000000', 'consum', 0.0211, 'lps'),
	(369959, 125, '2015-01-15 01:17:04.000000', 'consum', 0.0226, 'lps'),
	(369960, 125, '2015-01-15 01:17:05.000000', 'consum', 0.0217, 'lps'),
	(369961, 125, '2015-01-15 01:17:06.000000', 'consum', 0.0215, 'lps'),
	(369962, 125, '2015-01-15 01:17:07.000000', 'consum', 0.0215, 'lps'),
	(369963, 125, '2015-01-15 01:17:08.000000', 'consum', 0.0222, 'lps'),
	(369964, 125, '2015-01-15 01:17:09.000000', 'consum', 0.0220, 'lps'),
	(369965, 125, '2015-01-15 01:17:10.000000', 'consum', 0.0225, 'lps'),
	(369966, 125, '2015-01-15 01:17:11.000000', 'consum', 0.0221, 'lps'),
	(369967, 125, '2015-01-15 01:17:12.000000', 'consum', 0.0219, 'lps'),
	(369968, 125, '2015-01-15 01:17:13.000000', 'consum', 0.0223, 'lps'),
	(369969, 125, '2015-01-15 01:17:14.000000', 'consum', 0.0216, 'lps'),
	(369970, 125, '2015-01-15 01:17:15.000000', 'consum', 0.0217, 'lps'),
	(369971, 125, '2015-01-15 01:17:16.000000', 'consum', 0.0212, 'lps'),
	(369972, 125, '2015-01-15 01:17:17.000000', 'consum', 0.0218, 'lps'),
	(369973, 125, '2015-01-15 01:17:18.000000', 'consum', 0.0224, 'lps'),
	(369974, 125, '2015-01-15 01:17:19.000000', 'consum', 0.0225, 'lps'),
	(369975, 125, '2015-01-15 01:17:20.000000', 'consum', 0.0226, 'lps'),
	(369976, 125, '2015-01-15 01:17:21.000000', 'consum', 0.0211, 'lps'),
	(369977, 125, '2015-01-15 01:17:22.000000', 'consum', 0.0217, 'lps'),
	(369978, 125, '2015-01-15 01:17:23.000000', 'consum', 0.0210, 'lps'),
	(369979, 125, '2015-01-15 01:17:24.000000', 'consum', 0.0223, 'lps'),
	(369980, 125, '2015-01-15 01:17:25.000000', 'consum', 0.0223, 'lps'),
	(369981, 125, '2015-01-15 01:17:26.000000', 'consum', 0.0219, 'lps'),
	(369982, 125, '2015-01-15 01:17:27.000000', 'consum', 0.0217, 'lps'),
	(369983, 125, '2015-01-15 01:17:28.000000', 'consum', 0.0218, 'lps'),
	(369984, 125, '2015-01-15 01:17:29.000000', 'consum', 0.0214, 'lps'),
	(369985, 125, '2015-01-15 01:17:30.000000', 'consum', 0.0222, 'lps'),
	(369986, 125, '2015-01-15 01:17:31.000000', 'consum', 0.0224, 'lps'),
	(369987, 125, '2015-01-15 01:17:32.000000', 'consum', 0.0212, 'lps'),
	(369988, 125, '2015-01-15 01:17:33.000000', 'consum', 0.0210, 'lps'),
	(369989, 125, '2015-01-15 01:17:34.000000', 'consum', 0.0224, 'lps'),
	(369990, 125, '2015-01-15 01:17:35.000000', 'consum', 0.0211, 'lps'),
	(369991, 125, '2015-01-15 01:17:36.000000', 'consum', 0.0225, 'lps'),
	(369992, 125, '2015-01-15 01:17:37.000000', 'consum', 0.0216, 'lps'),
	(369993, 125, '2015-01-15 01:17:38.000000', 'consum', 0.0213, 'lps'),
	(369994, 125, '2015-01-15 01:17:39.000000', 'consum', 0.0222, 'lps'),
	(369995, 125, '2015-01-15 01:17:40.000000', 'consum', 0.0211, 'lps'),
	(369996, 125, '2015-01-15 01:17:41.000000', 'consum', 0.0215, 'lps'),
	(369997, 125, '2015-01-15 01:17:42.000000', 'consum', 0.0216, 'lps'),
	(369998, 125, '2015-01-15 01:17:43.000000', 'consum', 0.0223, 'lps'),
	(369999, 125, '2015-01-15 01:17:44.000000', 'consum', 0.0225, 'lps'),
	(370000, 125, '2015-01-15 01:17:45.000000', 'consum', 0.0213, 'lps'),
	(370001, 125, '2015-01-15 01:17:46.000000', 'consum', 0.0212, 'lps'),
	(370002, 125, '2015-01-15 01:17:47.000000', 'consum', 0.0213, 'lps'),
	(370003, 125, '2015-01-15 01:17:48.000000', 'consum', 0.0218, 'lps'),
	(370004, 125, '2015-01-15 01:17:49.000000', 'consum', 0.0225, 'lps'),
	(370005, 125, '2015-01-15 01:17:50.000000', 'consum', 0.0211, 'lps'),
	(370006, 125, '2015-01-15 01:17:51.000000', 'consum', 0.0222, 'lps'),
	(370007, 125, '2015-01-15 01:17:52.000000', 'consum', 0.0217, 'lps'),
	(370008, 125, '2015-01-15 01:17:53.000000', 'consum', 0.0210, 'lps'),
	(370009, 125, '2015-01-15 01:17:54.000000', 'consum', 0.0222, 'lps'),
	(370010, 125, '2015-01-15 01:17:55.000000', 'consum', 0.0219, 'lps'),
	(370011, 125, '2015-01-15 01:17:56.000000', 'consum', 0.0221, 'lps'),
	(370012, 125, '2015-01-15 01:17:57.000000', 'consum', 0.0223, 'lps'),
	(370013, 125, '2015-01-15 01:17:58.000000', 'consum', 0.0223, 'lps'),
	(370014, 125, '2015-01-15 01:17:59.000000', 'consum', 0.0219, 'lps'),
	(370015, 125, '2015-01-15 01:18:00.000000', 'consum', 0.0216, 'lps'),
	(370016, 125, '2015-01-15 01:18:01.000000', 'consum', 0.0214, 'lps'),
	(370017, 125, '2015-01-15 01:18:02.000000', 'consum', 0.0214, 'lps'),
	(370018, 125, '2015-01-15 01:18:03.000000', 'consum', 0.0219, 'lps'),
	(370019, 125, '2015-01-15 01:18:04.000000', 'consum', 0.0224, 'lps'),
	(370020, 125, '2015-01-15 01:18:05.000000', 'consum', 0.0219, 'lps'),
	(370021, 125, '2015-01-15 01:18:06.000000', 'consum', 0.0215, 'lps'),
	(370022, 125, '2015-01-15 01:18:07.000000', 'consum', 0.0226, 'lps'),
	(370023, 125, '2015-01-15 01:18:08.000000', 'consum', 0.0225, 'lps'),
	(370024, 125, '2015-01-15 01:18:09.000000', 'consum', 0.0221, 'lps'),
	(370025, 125, '2015-01-15 01:18:10.000000', 'consum', 0.0218, 'lps'),
	(370026, 125, '2015-01-15 01:18:11.000000', 'consum', 0.0219, 'lps'),
	(370027, 125, '2015-01-15 01:18:12.000000', 'consum', 0.0214, 'lps'),
	(370028, 125, '2015-01-15 01:18:13.000000', 'consum', 0.0220, 'lps'),
	(370029, 125, '2015-01-15 01:18:14.000000', 'consum', 0.0213, 'lps'),
	(370030, 125, '2015-01-15 01:18:15.000000', 'consum', 0.0214, 'lps'),
	(370031, 125, '2015-01-15 01:18:16.000000', 'consum', 0.0221, 'lps'),
	(370032, 125, '2015-01-15 01:18:17.000000', 'consum', 0.0218, 'lps'),
	(370033, 125, '2015-01-15 01:18:18.000000', 'consum', 0.0219, 'lps'),
	(370034, 125, '2015-01-15 01:18:19.000000', 'consum', 0.0215, 'lps'),
	(370035, 125, '2015-01-15 01:18:20.000000', 'consum', 0.0226, 'lps'),
	(370036, 125, '2015-01-15 01:18:21.000000', 'consum', 0.0222, 'lps'),
	(370037, 125, '2015-01-15 01:18:22.000000', 'consum', 0.0226, 'lps'),
	(370038, 125, '2015-01-15 01:18:23.000000', 'consum', 0.0217, 'lps'),
	(370039, 125, '2015-01-15 01:18:24.000000', 'consum', 0.0215, 'lps'),
	(370040, 125, '2015-01-15 01:18:25.000000', 'consum', 0.0216, 'lps'),
	(370041, 125, '2015-01-15 01:18:26.000000', 'consum', 0.0226, 'lps'),
	(370042, 125, '2015-01-15 01:18:27.000000', 'consum', 0.0221, 'lps'),
	(370043, 125, '2015-01-15 01:18:28.000000', 'consum', 0.0218, 'lps'),
	(370044, 125, '2015-01-15 01:18:29.000000', 'consum', 0.0218, 'lps'),
	(370045, 125, '2015-01-15 01:18:30.000000', 'consum', 0.0224, 'lps'),
	(370046, 125, '2015-01-15 01:18:31.000000', 'consum', 0.0224, 'lps'),
	(370047, 125, '2015-01-15 01:18:32.000000', 'consum', 0.0221, 'lps'),
	(370048, 125, '2015-01-15 01:18:33.000000', 'consum', 0.0225, 'lps'),
	(370049, 125, '2015-01-15 01:18:34.000000', 'consum', 0.0216, 'lps'),
	(370050, 125, '2015-01-15 01:18:35.000000', 'consum', 0.0214, 'lps'),
	(370051, 125, '2015-01-15 01:18:36.000000', 'consum', 0.0213, 'lps'),
	(370052, 125, '2015-01-15 01:18:37.000000', 'consum', 0.0214, 'lps'),
	(370053, 125, '2015-01-15 01:18:38.000000', 'consum', 0.0220, 'lps'),
	(370054, 125, '2015-01-15 01:18:39.000000', 'consum', 0.0215, 'lps'),
	(370055, 125, '2015-01-15 01:18:40.000000', 'consum', 0.0224, 'lps'),
	(370056, 125, '2015-01-15 01:18:41.000000', 'consum', 0.0213, 'lps'),
	(370057, 125, '2015-01-15 01:18:42.000000', 'consum', 0.0218, 'lps'),
	(370058, 125, '2015-01-15 01:18:43.000000', 'consum', 0.0225, 'lps'),
	(370059, 125, '2015-01-15 01:18:44.000000', 'consum', 0.0212, 'lps'),
	(370060, 125, '2015-01-15 01:18:45.000000', 'consum', 0.0224, 'lps'),
	(370061, 125, '2015-01-15 01:18:46.000000', 'consum', 0.0225, 'lps'),
	(370062, 125, '2015-01-15 01:18:47.000000', 'consum', 0.0224, 'lps'),
	(370063, 125, '2015-01-15 01:18:48.000000', 'consum', 0.0221, 'lps'),
	(370064, 125, '2015-01-15 01:18:49.000000', 'consum', 0.0221, 'lps'),
	(370065, 125, '2015-01-15 01:18:50.000000', 'consum', 0.0216, 'lps'),
	(370066, 125, '2015-01-15 01:18:51.000000', 'consum', 0.0224, 'lps'),
	(370067, 125, '2015-01-15 01:18:52.000000', 'consum', 0.0211, 'lps'),
	(370068, 125, '2015-01-15 01:18:53.000000', 'consum', 0.0210, 'lps'),
	(370069, 125, '2015-01-15 01:18:54.000000', 'consum', 0.0223, 'lps'),
	(370070, 125, '2015-01-15 01:18:55.000000', 'consum', 0.0226, 'lps'),
	(370071, 125, '2015-01-15 01:18:56.000000', 'consum', 0.0218, 'lps'),
	(370072, 125, '2015-01-15 01:18:57.000000', 'consum', 0.0218, 'lps'),
	(370073, 125, '2015-01-15 01:18:58.000000', 'consum', 0.0211, 'lps'),
	(370074, 125, '2015-01-15 01:18:59.000000', 'consum', 0.0223, 'lps'),
	(370075, 125, '2015-01-15 01:19:00.000000', 'consum', 0.0223, 'lps'),
	(370076, 125, '2015-01-15 01:19:01.000000', 'consum', 0.0219, 'lps'),
	(370077, 125, '2015-01-15 01:19:02.000000', 'consum', 0.0219, 'lps'),
	(370078, 125, '2015-01-15 01:19:03.000000', 'consum', 0.0225, 'lps'),
	(370079, 125, '2015-01-15 01:19:04.000000', 'consum', 0.0225, 'lps'),
	(370080, 125, '2015-01-15 01:19:05.000000', 'consum', 0.0226, 'lps'),
	(370081, 125, '2015-01-15 01:19:06.000000', 'consum', 0.0211, 'lps'),
	(370082, 125, '2015-01-15 01:19:07.000000', 'consum', 0.0218, 'lps'),
	(370083, 125, '2015-01-15 01:19:08.000000', 'consum', 0.0213, 'lps'),
	(370084, 125, '2015-01-15 01:19:09.000000', 'consum', 0.0220, 'lps'),
	(370085, 125, '2015-01-15 01:19:10.000000', 'consum', 0.0216, 'lps'),
	(370086, 125, '2015-01-15 01:19:11.000000', 'consum', 0.0211, 'lps'),
	(370087, 125, '2015-01-15 01:19:12.000000', 'consum', 0.0213, 'lps'),
	(370088, 125, '2015-01-15 01:19:13.000000', 'consum', 0.0222, 'lps'),
	(370089, 125, '2015-01-15 01:19:14.000000', 'consum', 0.0211, 'lps'),
	(370090, 125, '2015-01-15 01:19:15.000000', 'consum', 0.0216, 'lps'),
	(370091, 125, '2015-01-15 01:19:16.000000', 'consum', 0.0217, 'lps'),
	(370092, 125, '2015-01-15 01:19:17.000000', 'consum', 0.0212, 'lps'),
	(370093, 125, '2015-01-15 01:19:18.000000', 'consum', 0.0216, 'lps'),
	(370094, 125, '2015-01-15 01:19:19.000000', 'consum', 0.0219, 'lps'),
	(370095, 125, '2015-01-15 01:19:20.000000', 'consum', 0.0219, 'lps'),
	(370096, 125, '2015-01-15 01:19:21.000000', 'consum', 0.0213, 'lps'),
	(370097, 125, '2015-01-15 01:19:22.000000', 'consum', 0.0214, 'lps'),
	(370098, 125, '2015-01-15 01:19:23.000000', 'consum', 0.0221, 'lps'),
	(370099, 125, '2015-01-15 01:19:24.000000', 'consum', 0.0219, 'lps'),
	(370100, 125, '2015-01-15 01:19:25.000000', 'consum', 0.0224, 'lps'),
	(370101, 125, '2015-01-15 01:19:26.000000', 'consum', 0.0220, 'lps'),
	(370102, 125, '2015-01-15 01:19:27.000000', 'consum', 0.0217, 'lps'),
	(370103, 125, '2015-01-15 01:19:28.000000', 'consum', 0.0214, 'lps'),
	(370104, 125, '2015-01-15 01:19:29.000000', 'consum', 0.0211, 'lps'),
	(370105, 125, '2015-01-15 01:19:30.000000', 'consum', 0.0222, 'lps'),
	(370106, 125, '2015-01-15 01:19:31.000000', 'consum', 0.0215, 'lps'),
	(370107, 125, '2015-01-15 01:19:32.000000', 'consum', 0.0218, 'lps'),
	(370108, 125, '2015-01-15 01:19:33.000000', 'consum', 0.0217, 'lps'),
	(370109, 125, '2015-01-15 01:19:34.000000', 'consum', 0.0220, 'lps'),
	(370110, 125, '2015-01-15 01:19:35.000000', 'consum', 0.0225, 'lps'),
	(370111, 125, '2015-01-15 01:19:36.000000', 'consum', 0.0220, 'lps'),
	(370112, 125, '2015-01-15 01:19:37.000000', 'consum', 0.0217, 'lps'),
	(370113, 125, '2015-01-15 01:19:38.000000', 'consum', 0.0213, 'lps'),
	(370114, 125, '2015-01-15 01:19:39.000000', 'consum', 0.0222, 'lps'),
	(370115, 125, '2015-01-15 01:19:40.000000', 'consum', 0.0213, 'lps'),
	(370116, 125, '2015-01-15 01:19:41.000000', 'consum', 0.0222, 'lps'),
	(370117, 125, '2015-01-15 01:19:42.000000', 'consum', 0.0211, 'lps'),
	(370118, 125, '2015-01-15 01:19:43.000000', 'consum', 0.0215, 'lps'),
	(370119, 125, '2015-01-15 01:19:44.000000', 'consum', 0.0215, 'lps'),
	(370120, 125, '2015-01-15 01:19:45.000000', 'consum', 0.0218, 'lps'),
	(370121, 125, '2015-01-15 01:19:46.000000', 'consum', 0.0220, 'lps'),
	(370122, 125, '2015-01-15 01:19:47.000000', 'consum', 0.0221, 'lps'),
	(370123, 125, '2015-01-15 01:19:48.000000', 'consum', 0.0218, 'lps'),
	(370124, 125, '2015-01-15 01:19:49.000000', 'consum', 0.0215, 'lps'),
	(370125, 125, '2015-01-15 01:19:50.000000', 'consum', 0.0213, 'lps'),
	(370126, 125, '2015-01-15 01:19:51.000000', 'consum', 0.0211, 'lps'),
	(370127, 125, '2015-01-15 01:19:52.000000', 'consum', 0.0224, 'lps'),
	(370128, 125, '2015-01-15 01:19:53.000000', 'consum', 0.0225, 'lps'),
	(370129, 125, '2015-01-15 01:19:54.000000', 'consum', 0.0210, 'lps'),
	(370130, 125, '2015-01-15 01:19:55.000000', 'consum', 0.0215, 'lps'),
	(370131, 125, '2015-01-15 01:19:56.000000', 'consum', 0.0221, 'lps'),
	(370132, 125, '2015-01-15 01:19:57.000000', 'consum', 0.0214, 'lps'),
	(370133, 125, '2015-01-15 01:19:58.000000', 'consum', 0.0216, 'lps'),
	(370134, 125, '2015-01-15 01:19:59.000000', 'consum', 0.0211, 'lps'),
	(370135, 125, '2015-01-15 01:20:00.000000', 'consum', 0.0215, 'lps'),
	(370136, 125, '2015-01-15 01:20:01.000000', 'consum', 0.0217, 'lps'),
	(370137, 125, '2015-01-15 01:20:02.000000', 'consum', 0.0211, 'lps'),
	(370138, 125, '2015-01-15 01:20:03.000000', 'consum', 0.0212, 'lps'),
	(370139, 125, '2015-01-15 01:20:04.000000', 'consum', 0.0216, 'lps'),
	(370140, 125, '2015-01-15 01:20:05.000000', 'consum', 0.0219, 'lps'),
	(370141, 125, '2015-01-15 01:20:06.000000', 'consum', 0.0221, 'lps'),
	(370142, 125, '2015-01-15 01:20:07.000000', 'consum', 0.0219, 'lps'),
	(370143, 125, '2015-01-15 01:20:08.000000', 'consum', 0.0225, 'lps'),
	(370144, 125, '2015-01-15 01:20:09.000000', 'consum', 0.0222, 'lps'),
	(370145, 125, '2015-01-15 01:20:10.000000', 'consum', 0.0226, 'lps'),
	(370146, 125, '2015-01-15 01:20:11.000000', 'consum', 0.0219, 'lps'),
	(370147, 125, '2015-01-15 01:20:12.000000', 'consum', 0.0210, 'lps'),
	(370148, 125, '2015-01-15 01:20:13.000000', 'consum', 0.0216, 'lps'),
	(370149, 125, '2015-01-15 01:20:14.000000', 'consum', 0.0225, 'lps'),
	(370150, 125, '2015-01-15 01:20:15.000000', 'consum', 0.0216, 'lps'),
	(370151, 125, '2015-01-15 01:20:16.000000', 'consum', 0.0211, 'lps'),
	(370152, 125, '2015-01-15 01:20:17.000000', 'consum', 0.0217, 'lps'),
	(370153, 125, '2015-01-15 01:20:18.000000', 'consum', 0.0226, 'lps'),
	(370154, 125, '2015-01-15 01:20:19.000000', 'consum', 0.0218, 'lps'),
	(370155, 125, '2015-01-15 01:20:20.000000', 'consum', 0.0218, 'lps'),
	(370156, 125, '2015-01-15 01:20:21.000000', 'consum', 0.0210, 'lps'),
	(370157, 125, '2015-01-15 01:20:22.000000', 'consum', 0.0221, 'lps'),
	(370158, 125, '2015-01-15 01:20:23.000000', 'consum', 0.0213, 'lps'),
	(370159, 125, '2015-01-15 01:20:24.000000', 'consum', 0.0210, 'lps'),
	(370160, 125, '2015-01-15 01:20:25.000000', 'consum', 0.0218, 'lps'),
	(370161, 125, '2015-01-15 01:20:26.000000', 'consum', 0.0217, 'lps'),
	(370162, 125, '2015-01-15 01:20:27.000000', 'consum', 0.0223, 'lps'),
	(370163, 125, '2015-01-15 01:20:28.000000', 'consum', 0.0221, 'lps'),
	(370164, 125, '2015-01-15 01:20:29.000000', 'consum', 0.0226, 'lps'),
	(370165, 125, '2015-01-15 01:20:30.000000', 'consum', 0.0223, 'lps'),
	(370166, 125, '2015-01-15 01:20:31.000000', 'consum', 0.0211, 'lps'),
	(370167, 125, '2015-01-15 01:20:32.000000', 'consum', 0.0226, 'lps'),
	(370168, 125, '2015-01-15 01:20:33.000000', 'consum', 0.0221, 'lps'),
	(370169, 125, '2015-01-15 01:20:34.000000', 'consum', 0.0219, 'lps'),
	(370170, 125, '2015-01-15 01:20:35.000000', 'consum', 0.0220, 'lps'),
	(370171, 125, '2015-01-15 01:20:36.000000', 'consum', 0.0217, 'lps'),
	(370172, 125, '2015-01-15 01:20:37.000000', 'consum', 0.0214, 'lps'),
	(370173, 125, '2015-01-15 01:20:38.000000', 'consum', 0.0211, 'lps'),
	(370174, 125, '2015-01-15 01:20:39.000000', 'consum', 0.0221, 'lps'),
	(370175, 125, '2015-01-15 01:20:40.000000', 'consum', 0.0212, 'lps'),
	(370176, 125, '2015-01-15 01:20:41.000000', 'consum', 0.0222, 'lps'),
	(370177, 125, '2015-01-15 01:20:42.000000', 'consum', 0.0213, 'lps'),
	(370178, 125, '2015-01-15 01:20:43.000000', 'consum', 0.0223, 'lps'),
	(370179, 125, '2015-01-15 01:20:44.000000', 'consum', 0.0218, 'lps'),
	(370180, 125, '2015-01-15 01:20:45.000000', 'consum', 0.0225, 'lps'),
	(370181, 125, '2015-01-15 01:20:46.000000', 'consum', 0.0213, 'lps'),
	(370182, 125, '2015-01-15 01:20:47.000000', 'consum', 0.0213, 'lps'),
	(370183, 125, '2015-01-15 01:20:48.000000', 'consum', 0.0215, 'lps'),
	(370184, 125, '2015-01-15 01:20:49.000000', 'consum', 0.0212, 'lps'),
	(370185, 125, '2015-01-15 01:20:50.000000', 'consum', 0.0221, 'lps'),
	(370186, 125, '2015-01-15 01:20:51.000000', 'consum', 0.0224, 'lps'),
	(370187, 125, '2015-01-15 01:20:52.000000', 'consum', 0.0217, 'lps'),
	(370188, 125, '2015-01-15 01:20:53.000000', 'consum', 0.0219, 'lps'),
	(370189, 125, '2015-01-15 01:20:54.000000', 'consum', 0.0218, 'lps'),
	(370190, 125, '2015-01-15 01:20:55.000000', 'consum', 0.0224, 'lps'),
	(370191, 125, '2015-01-15 01:20:56.000000', 'consum', 0.0222, 'lps'),
	(370192, 125, '2015-01-15 01:20:57.000000', 'consum', 0.0212, 'lps'),
	(370193, 125, '2015-01-15 01:20:58.000000', 'consum', 0.0219, 'lps'),
	(370194, 125, '2015-01-15 01:20:59.000000', 'consum', 0.0214, 'lps'),
	(370195, 125, '2015-01-15 01:21:00.000000', 'consum', 0.0221, 'lps'),
	(370196, 125, '2015-01-15 01:21:01.000000', 'consum', 0.0221, 'lps'),
	(370197, 125, '2015-01-15 01:21:02.000000', 'consum', 0.0215, 'lps'),
	(370198, 125, '2015-01-15 01:21:03.000000', 'consum', 0.0221, 'lps'),
	(370199, 125, '2015-01-15 01:21:04.000000', 'consum', 0.0213, 'lps'),
	(370200, 125, '2015-01-15 01:21:05.000000', 'consum', 0.0213, 'lps'),
	(370201, 125, '2015-01-15 01:21:06.000000', 'consum', 0.0215, 'lps'),
	(370202, 125, '2015-01-15 01:21:07.000000', 'consum', 0.0211, 'lps'),
	(370203, 125, '2015-01-15 01:21:08.000000', 'consum', 0.0218, 'lps'),
	(370204, 125, '2015-01-15 01:21:09.000000', 'consum', 0.0215, 'lps'),
	(370205, 125, '2015-01-15 01:21:10.000000', 'consum', 0.0225, 'lps'),
	(370206, 125, '2015-01-15 01:21:11.000000', 'consum', 0.0219, 'lps'),
	(370207, 125, '2015-01-15 01:21:12.000000', 'consum', 0.0214, 'lps'),
	(370208, 125, '2015-01-15 01:21:13.000000', 'consum', 0.0218, 'lps'),
	(370209, 125, '2015-01-15 01:21:14.000000', 'consum', 0.0223, 'lps'),
	(370210, 125, '2015-01-15 01:21:15.000000', 'consum', 0.0217, 'lps'),
	(370211, 125, '2015-01-15 01:21:16.000000', 'consum', 0.0223, 'lps'),
	(370212, 125, '2015-01-15 01:21:17.000000', 'consum', 0.0222, 'lps'),
	(370213, 125, '2015-01-15 01:21:18.000000', 'consum', 0.0215, 'lps'),
	(370214, 125, '2015-01-15 01:21:19.000000', 'consum', 0.0217, 'lps'),
	(370215, 125, '2015-01-15 01:21:20.000000', 'consum', 0.0213, 'lps'),
	(370216, 125, '2015-01-15 01:21:21.000000', 'consum', 0.0220, 'lps'),
	(370217, 125, '2015-01-15 01:21:22.000000', 'consum', 0.0220, 'lps'),
	(370218, 125, '2015-01-15 01:21:23.000000', 'consum', 0.0212, 'lps'),
	(370219, 125, '2015-01-15 01:21:24.000000', 'consum', 0.0224, 'lps'),
	(370220, 125, '2015-01-15 01:21:25.000000', 'consum', 0.0223, 'lps'),
	(370221, 125, '2015-01-15 01:21:26.000000', 'consum', 0.0217, 'lps'),
	(370222, 125, '2015-01-15 01:21:27.000000', 'consum', 0.0223, 'lps'),
	(370223, 125, '2015-01-15 01:21:28.000000', 'consum', 0.0223, 'lps'),
	(370224, 125, '2015-01-15 01:21:29.000000', 'consum', 0.0216, 'lps'),
	(370225, 125, '2015-01-15 01:21:30.000000', 'consum', 0.0220, 'lps'),
	(370226, 125, '2015-01-15 01:21:31.000000', 'consum', 0.0225, 'lps'),
	(370227, 125, '2015-01-15 01:21:32.000000', 'consum', 0.0222, 'lps'),
	(370228, 125, '2015-01-15 01:21:33.000000', 'consum', 0.0226, 'lps'),
	(370229, 125, '2015-01-15 01:21:34.000000', 'consum', 0.0219, 'lps'),
	(370230, 125, '2015-01-15 01:21:35.000000', 'consum', 0.0210, 'lps'),
	(370231, 125, '2015-01-15 01:21:36.000000', 'consum', 0.0216, 'lps'),
	(370232, 125, '2015-01-15 01:21:37.000000', 'consum', 0.0222, 'lps'),
	(370233, 125, '2015-01-15 01:21:38.000000', 'consum', 0.0221, 'lps'),
	(370234, 125, '2015-01-15 01:21:39.000000', 'consum', 0.0211, 'lps'),
	(370235, 125, '2015-01-15 01:21:40.000000', 'consum', 0.0216, 'lps'),
	(370236, 125, '2015-01-15 01:21:41.000000', 'consum', 0.0220, 'lps'),
	(370237, 125, '2015-01-15 01:21:42.000000', 'consum', 0.0211, 'lps'),
	(370238, 125, '2015-01-15 01:21:43.000000', 'consum', 0.0217, 'lps'),
	(370239, 125, '2015-01-15 01:21:44.000000', 'consum', 0.0225, 'lps'),
	(370240, 125, '2015-01-15 01:21:45.000000', 'consum', 0.0216, 'lps'),
	(370241, 125, '2015-01-15 01:21:46.000000', 'consum', 0.0212, 'lps'),
	(370242, 125, '2015-01-15 01:21:47.000000', 'consum', 0.0220, 'lps'),
	(370243, 125, '2015-01-15 01:21:48.000000', 'consum', 0.0221, 'lps'),
	(370244, 125, '2015-01-15 01:21:49.000000', 'consum', 0.0216, 'lps'),
	(370245, 125, '2015-01-15 01:21:50.000000', 'consum', 0.0226, 'lps'),
	(370246, 125, '2015-01-15 01:21:51.000000', 'consum', 0.0221, 'lps'),
	(370247, 125, '2015-01-15 01:21:52.000000', 'consum', 0.0216, 'lps'),
	(370248, 125, '2015-01-15 01:21:53.000000', 'consum', 0.0225, 'lps'),
	(370249, 125, '2015-01-15 01:21:54.000000', 'consum', 0.0215, 'lps'),
	(370250, 125, '2015-01-15 01:21:55.000000', 'consum', 0.0210, 'lps'),
	(370251, 125, '2015-01-15 01:21:56.000000', 'consum', 0.0210, 'lps'),
	(370252, 125, '2015-01-15 01:21:57.000000', 'consum', 0.0212, 'lps'),
	(370253, 125, '2015-01-15 01:21:58.000000', 'consum', 0.0222, 'lps'),
	(370254, 125, '2015-01-15 01:21:59.000000', 'consum', 0.0214, 'lps'),
	(370255, 125, '2015-01-15 01:22:00.000000', 'consum', 0.0226, 'lps'),
	(370256, 125, '2015-01-15 01:22:01.000000', 'consum', 0.0212, 'lps'),
	(370257, 125, '2015-01-15 01:22:02.000000', 'consum', 0.0224, 'lps'),
	(370258, 125, '2015-01-15 01:22:03.000000', 'consum', 0.0225, 'lps'),
	(370259, 125, '2015-01-15 01:22:04.000000', 'consum', 0.0225, 'lps'),
	(370260, 125, '2015-01-15 01:22:05.000000', 'consum', 0.0222, 'lps'),
	(370261, 125, '2015-01-15 01:22:06.000000', 'consum', 0.0210, 'lps'),
	(370262, 125, '2015-01-15 01:22:07.000000', 'consum', 0.0223, 'lps'),
	(370263, 125, '2015-01-15 01:22:08.000000', 'consum', 0.0210, 'lps'),
	(370264, 125, '2015-01-15 01:22:09.000000', 'consum', 0.0223, 'lps'),
	(370265, 125, '2015-01-15 01:22:10.000000', 'consum', 0.0223, 'lps'),
	(370266, 125, '2015-01-15 01:22:11.000000', 'consum', 0.0220, 'lps'),
	(370267, 125, '2015-01-15 01:22:12.000000', 'consum', 0.0222, 'lps'),
	(370268, 125, '2015-01-15 01:22:13.000000', 'consum', 0.0225, 'lps'),
	(370269, 125, '2015-01-15 01:22:14.000000', 'consum', 0.0214, 'lps'),
	(370270, 125, '2015-01-15 01:22:15.000000', 'consum', 0.0219, 'lps'),
	(370271, 125, '2015-01-15 01:22:16.000000', 'consum', 0.0226, 'lps'),
	(370272, 125, '2015-01-15 01:22:17.000000', 'consum', 0.0213, 'lps'),
	(370273, 125, '2015-01-15 01:22:18.000000', 'consum', 0.0211, 'lps'),
	(370274, 125, '2015-01-15 01:22:19.000000', 'consum', 0.0226, 'lps'),
	(370275, 125, '2015-01-15 01:22:20.000000', 'consum', 0.0218, 'lps'),
	(370276, 125, '2015-01-15 01:22:21.000000', 'consum', 0.0218, 'lps'),
	(370277, 125, '2015-01-15 01:22:22.000000', 'consum', 0.0210, 'lps'),
	(370278, 125, '2015-01-15 01:22:23.000000', 'consum', 0.0220, 'lps'),
	(370279, 125, '2015-01-15 01:22:24.000000', 'consum', 0.0212, 'lps'),
	(370280, 125, '2015-01-15 01:22:25.000000', 'consum', 0.0224, 'lps'),
	(370281, 125, '2015-01-15 01:22:26.000000', 'consum', 0.0223, 'lps'),
	(370282, 125, '2015-01-15 01:22:27.000000', 'consum', 0.0217, 'lps'),
	(370283, 125, '2015-01-15 01:22:28.000000', 'consum', 0.0224, 'lps'),
	(370284, 125, '2015-01-15 01:22:29.000000', 'consum', 0.0226, 'lps'),
	(370285, 125, '2015-01-15 01:22:30.000000', 'consum', 0.0214, 'lps'),
	(370286, 125, '2015-01-15 01:22:31.000000', 'consum', 0.0215, 'lps'),
	(370287, 125, '2015-01-15 01:22:32.000000', 'consum', 0.0224, 'lps'),
	(370288, 125, '2015-01-15 01:22:33.000000', 'consum', 0.0215, 'lps'),
	(370289, 125, '2015-01-15 01:22:34.000000', 'consum', 0.0211, 'lps'),
	(370290, 125, '2015-01-15 01:22:35.000000', 'consum', 0.0215, 'lps'),
	(370291, 125, '2015-01-15 01:22:36.000000', 'consum', 0.0217, 'lps'),
	(370292, 125, '2015-01-15 01:22:37.000000', 'consum', 0.0212, 'lps'),
	(370293, 125, '2015-01-15 01:22:38.000000', 'consum', 0.0218, 'lps'),
	(370294, 125, '2015-01-15 01:22:39.000000', 'consum', 0.0226, 'lps'),
	(370295, 125, '2015-01-15 01:22:40.000000', 'consum', 0.0215, 'lps'),
	(370296, 125, '2015-01-15 01:22:41.000000', 'consum', 0.0222, 'lps'),
	(370297, 125, '2015-01-15 01:22:42.000000', 'consum', 0.0221, 'lps'),
	(370298, 125, '2015-01-15 01:22:43.000000', 'consum', 0.0215, 'lps'),
	(370299, 125, '2015-01-15 01:22:44.000000', 'consum', 0.0218, 'lps'),
	(370300, 125, '2015-01-15 01:22:45.000000', 'consum', 0.0218, 'lps'),
	(370301, 125, '2015-01-15 01:22:46.000000', 'consum', 0.0226, 'lps'),
	(370302, 125, '2015-01-15 01:22:47.000000', 'consum', 0.0214, 'lps'),
	(370303, 125, '2015-01-15 01:22:48.000000', 'consum', 0.0220, 'lps'),
	(370304, 125, '2015-01-15 01:22:49.000000', 'consum', 0.0213, 'lps'),
	(370305, 125, '2015-01-15 01:22:50.000000', 'consum', 0.0213, 'lps'),
	(370306, 125, '2015-01-15 01:22:51.000000', 'consum', 0.0215, 'lps'),
	(370307, 125, '2015-01-15 01:22:52.000000', 'consum', 0.0226, 'lps'),
	(370308, 125, '2015-01-15 01:22:53.000000', 'consum', 0.0224, 'lps'),
	(370309, 125, '2015-01-15 01:22:54.000000', 'consum', 0.0216, 'lps'),
	(370310, 125, '2015-01-15 01:22:55.000000', 'consum', 0.0215, 'lps'),
	(370311, 125, '2015-01-15 01:22:56.000000', 'consum', 0.0219, 'lps'),
	(370312, 125, '2015-01-15 01:22:57.000000', 'consum', 0.0224, 'lps'),
	(370313, 125, '2015-01-15 01:22:58.000000', 'consum', 0.0221, 'lps'),
	(370314, 125, '2015-01-15 01:22:59.000000', 'consum', 0.0221, 'lps'),
	(370315, 125, '2015-01-15 01:23:00.000000', 'consum', 0.0215, 'lps'),
	(370316, 125, '2015-01-15 01:23:01.000000', 'consum', 0.0222, 'lps'),
	(370317, 125, '2015-01-15 01:23:02.000000', 'consum', 0.0219, 'lps'),
	(370318, 125, '2015-01-15 01:23:03.000000', 'consum', 0.0221, 'lps'),
	(370319, 125, '2015-01-15 01:23:04.000000', 'consum', 0.0221, 'lps'),
	(370320, 125, '2015-01-15 01:23:05.000000', 'consum', 0.0214, 'lps'),
	(370321, 125, '2015-01-15 01:23:06.000000', 'consum', 0.0217, 'lps'),
	(370322, 125, '2015-01-15 01:23:07.000000', 'consum', 0.0214, 'lps'),
	(370323, 125, '2015-01-15 01:23:08.000000', 'consum', 0.0226, 'lps'),
	(370324, 125, '2015-01-15 01:23:09.000000', 'consum', 0.0211, 'lps'),
	(370325, 125, '2015-01-15 01:23:10.000000', 'consum', 0.0219, 'lps'),
	(370326, 125, '2015-01-15 01:23:11.000000', 'consum', 0.0216, 'lps'),
	(370327, 125, '2015-01-15 01:23:12.000000', 'consum', 0.0217, 'lps'),
	(370328, 125, '2015-01-15 01:23:13.000000', 'consum', 0.0225, 'lps'),
	(370329, 125, '2015-01-15 01:23:14.000000', 'consum', 0.0215, 'lps'),
	(370330, 125, '2015-01-15 01:23:15.000000', 'consum', 0.0226, 'lps'),
	(370331, 125, '2015-01-15 01:23:16.000000', 'consum', 0.0223, 'lps'),
	(370332, 125, '2015-01-15 01:23:17.000000', 'consum', 0.0211, 'lps'),
	(370333, 125, '2015-01-15 01:23:18.000000', 'consum', 0.0226, 'lps'),
	(370334, 125, '2015-01-15 01:23:19.000000', 'consum', 0.0219, 'lps'),
	(370335, 125, '2015-01-15 01:23:20.000000', 'consum', 0.0225, 'lps'),
	(370336, 125, '2015-01-15 01:23:21.000000', 'consum', 0.0224, 'lps'),
	(370337, 125, '2015-01-15 01:23:22.000000', 'consum', 0.0218, 'lps'),
	(370338, 125, '2015-01-15 01:23:23.000000', 'consum', 0.0225, 'lps'),
	(370339, 125, '2015-01-15 01:23:24.000000', 'consum', 0.0212, 'lps'),
	(370340, 125, '2015-01-15 01:23:25.000000', 'consum', 0.0226, 'lps'),
	(370341, 125, '2015-01-15 01:23:26.000000', 'consum', 0.0215, 'lps'),
	(370342, 125, '2015-01-15 01:23:27.000000', 'consum', 0.0224, 'lps'),
	(370343, 125, '2015-01-15 01:23:28.000000', 'consum', 0.0213, 'lps'),
	(370344, 125, '2015-01-15 01:23:29.000000', 'consum', 0.0217, 'lps'),
	(370345, 125, '2015-01-15 01:23:30.000000', 'consum', 0.0219, 'lps'),
	(370346, 125, '2015-01-15 01:23:31.000000', 'consum', 0.0218, 'lps'),
	(370347, 125, '2015-01-15 01:23:32.000000', 'consum', 0.0222, 'lps'),
	(370348, 125, '2015-01-15 01:23:33.000000', 'consum', 0.0215, 'lps'),
	(370349, 125, '2015-01-15 01:23:34.000000', 'consum', 0.0214, 'lps'),
	(370350, 125, '2015-01-15 01:23:35.000000', 'consum', 0.0219, 'lps'),
	(370351, 125, '2015-01-15 01:23:36.000000', 'consum', 0.0223, 'lps'),
	(370352, 125, '2015-01-15 01:23:37.000000', 'consum', 0.0215, 'lps'),
	(370353, 125, '2015-01-15 01:23:38.000000', 'consum', 0.0213, 'lps'),
	(370354, 125, '2015-01-15 01:23:39.000000', 'consum', 0.0211, 'lps'),
	(370355, 125, '2015-01-15 01:23:40.000000', 'consum', 0.0223, 'lps'),
	(370356, 125, '2015-01-15 01:23:41.000000', 'consum', 0.0224, 'lps'),
	(370357, 125, '2015-01-15 01:23:42.000000', 'consum', 0.0223, 'lps'),
	(370358, 125, '2015-01-15 01:23:43.000000', 'consum', 0.0219, 'lps'),
	(370359, 125, '2015-01-15 01:23:44.000000', 'consum', 0.0213, 'lps'),
	(370360, 125, '2015-01-15 01:23:45.000000', 'consum', 0.0218, 'lps'),
	(370361, 125, '2015-01-15 01:23:46.000000', 'consum', 0.0226, 'lps'),
	(370362, 125, '2015-01-15 01:23:47.000000', 'consum', 0.0212, 'lps'),
	(370363, 125, '2015-01-15 01:23:48.000000', 'consum', 0.0225, 'lps'),
	(370364, 125, '2015-01-15 01:23:49.000000', 'consum', 0.0213, 'lps'),
	(370365, 125, '2015-01-15 01:23:50.000000', 'consum', 0.0215, 'lps'),
	(370366, 125, '2015-01-15 01:23:51.000000', 'consum', 0.0224, 'lps'),
	(370367, 125, '2015-01-15 01:23:52.000000', 'consum', 0.0216, 'lps'),
	(370368, 125, '2015-01-15 01:23:53.000000', 'consum', 0.0216, 'lps'),
	(370369, 125, '2015-01-15 01:23:54.000000', 'consum', 0.0221, 'lps'),
	(370370, 125, '2015-01-15 01:23:55.000000', 'consum', 0.0215, 'lps'),
	(370371, 125, '2015-01-15 01:23:56.000000', 'consum', 0.0217, 'lps'),
	(370372, 125, '2015-01-15 01:23:57.000000', 'consum', 0.0216, 'lps'),
	(370373, 125, '2015-01-15 01:23:58.000000', 'consum', 0.0221, 'lps'),
	(370374, 125, '2015-01-15 01:23:59.000000', 'consum', 0.0210, 'lps'),
	(370375, 125, '2015-01-15 01:24:00.000000', 'consum', 0.0212, 'lps'),
	(370376, 125, '2015-01-15 01:24:01.000000', 'consum', 0.0223, 'lps'),
	(370377, 125, '2015-01-15 01:24:02.000000', 'consum', 0.0218, 'lps'),
	(370378, 125, '2015-01-15 01:24:03.000000', 'consum', 0.0210, 'lps'),
	(370379, 125, '2015-01-15 01:24:04.000000', 'consum', 0.0222, 'lps'),
	(370380, 125, '2015-01-15 01:24:05.000000', 'consum', 0.0217, 'lps'),
	(370381, 125, '2015-01-15 01:24:06.000000', 'consum', 0.0213, 'lps'),
	(370382, 125, '2015-01-15 01:24:07.000000', 'consum', 0.0220, 'lps'),
	(370383, 125, '2015-01-15 01:24:08.000000', 'consum', 0.0217, 'lps'),
	(370384, 125, '2015-01-15 01:24:09.000000', 'consum', 0.0214, 'lps'),
	(370385, 125, '2015-01-15 01:24:10.000000', 'consum', 0.0211, 'lps'),
	(370386, 125, '2015-01-15 01:24:11.000000', 'consum', 0.0220, 'lps'),
	(370387, 125, '2015-01-15 01:24:12.000000', 'consum', 0.0224, 'lps'),
	(370388, 125, '2015-01-15 01:24:13.000000', 'consum', 0.0218, 'lps'),
	(370389, 125, '2015-01-15 01:24:14.000000', 'consum', 0.0225, 'lps'),
	(370390, 125, '2015-01-15 01:24:15.000000', 'consum', 0.0211, 'lps'),
	(370391, 125, '2015-01-15 01:24:16.000000', 'consum', 0.0220, 'lps'),
	(370392, 125, '2015-01-15 01:24:17.000000', 'consum', 0.0224, 'lps'),
	(370393, 125, '2015-01-15 01:24:18.000000', 'consum', 0.0217, 'lps'),
	(370394, 125, '2015-01-15 01:24:19.000000', 'consum', 0.0220, 'lps'),
	(370395, 125, '2015-01-15 01:24:20.000000', 'consum', 0.0223, 'lps'),
	(370396, 125, '2015-01-15 01:24:21.000000', 'consum', 0.0210, 'lps'),
	(370397, 125, '2015-01-15 01:24:22.000000', 'consum', 0.0225, 'lps'),
	(370398, 125, '2015-01-15 01:24:23.000000', 'consum', 0.0217, 'lps'),
	(370399, 125, '2015-01-15 01:24:24.000000', 'consum', 0.0215, 'lps'),
	(370400, 125, '2015-01-15 01:24:25.000000', 'consum', 0.0218, 'lps'),
	(370401, 125, '2015-01-15 01:24:26.000000', 'consum', 0.0217, 'lps'),
	(370402, 125, '2015-01-15 01:24:27.000000', 'consum', 0.0223, 'lps'),
	(370403, 125, '2015-01-15 01:24:28.000000', 'consum', 0.0220, 'lps'),
	(370404, 125, '2015-01-15 01:24:29.000000', 'consum', 0.0219, 'lps'),
	(370405, 125, '2015-01-15 01:24:30.000000', 'consum', 0.0212, 'lps'),
	(370406, 125, '2015-01-15 01:24:31.000000', 'consum', 0.0225, 'lps'),
	(370407, 125, '2015-01-15 01:24:32.000000', 'consum', 0.0212, 'lps'),
	(370408, 125, '2015-01-15 01:24:33.000000', 'consum', 0.0226, 'lps'),
	(370409, 125, '2015-01-15 01:24:34.000000', 'consum', 0.0216, 'lps'),
	(370410, 125, '2015-01-15 01:24:35.000000', 'consum', 0.0211, 'lps'),
	(370411, 125, '2015-01-15 01:24:36.000000', 'consum', 0.0214, 'lps'),
	(370412, 125, '2015-01-15 01:24:37.000000', 'consum', 0.0211, 'lps'),
	(370413, 125, '2015-01-15 01:24:38.000000', 'consum', 0.0220, 'lps'),
	(370414, 125, '2015-01-15 01:24:39.000000', 'consum', 0.0225, 'lps'),
	(370415, 125, '2015-01-15 01:24:40.000000', 'consum', 0.0222, 'lps'),
	(370416, 125, '2015-01-15 01:24:41.000000', 'consum', 0.0224, 'lps'),
	(370417, 125, '2015-01-15 01:24:42.000000', 'consum', 0.0211, 'lps'),
	(370418, 125, '2015-01-15 01:24:43.000000', 'consum', 0.0225, 'lps'),
	(370419, 125, '2015-01-15 01:24:44.000000', 'consum', 0.0215, 'lps'),
	(370420, 125, '2015-01-15 01:24:45.000000', 'consum', 0.0223, 'lps'),
	(370421, 125, '2015-01-15 01:24:46.000000', 'consum', 0.0210, 'lps'),
	(370422, 125, '2015-01-15 01:24:47.000000', 'consum', 0.0222, 'lps'),
	(370423, 125, '2015-01-15 01:24:48.000000', 'consum', 0.0218, 'lps'),
	(370424, 125, '2015-01-15 01:24:49.000000', 'consum', 0.0216, 'lps'),
	(370425, 125, '2015-01-15 01:24:50.000000', 'consum', 0.0214, 'lps'),
	(370426, 125, '2015-01-15 01:24:51.000000', 'consum', 0.0216, 'lps'),
	(370427, 125, '2015-01-15 01:24:52.000000', 'consum', 0.0226, 'lps'),
	(370428, 125, '2015-01-15 01:24:53.000000', 'consum', 0.0220, 'lps'),
	(370429, 125, '2015-01-15 01:24:54.000000', 'consum', 0.0216, 'lps'),
	(370430, 125, '2015-01-15 01:24:55.000000', 'consum', 0.0226, 'lps'),
	(370431, 125, '2015-01-15 01:24:56.000000', 'consum', 0.0222, 'lps'),
	(370432, 125, '2015-01-15 01:24:57.000000', 'consum', 0.0221, 'lps'),
	(370433, 125, '2015-01-15 01:24:58.000000', 'consum', 0.0213, 'lps'),
	(370434, 125, '2015-01-15 01:24:59.000000', 'consum', 0.0225, 'lps'),
	(370435, 125, '2015-01-15 01:25:00.000000', 'consum', 0.0212, 'lps'),
	(370436, 125, '2015-01-15 01:25:01.000000', 'consum', 0.0223, 'lps'),
	(370437, 125, '2015-01-15 01:25:02.000000', 'consum', 0.0222, 'lps'),
	(370438, 125, '2015-01-15 01:25:03.000000', 'consum', 0.0211, 'lps'),
	(370439, 125, '2015-01-15 01:25:04.000000', 'consum', 0.0217, 'lps'),
	(370440, 125, '2015-01-15 01:25:05.000000', 'consum', 0.0223, 'lps'),
	(370441, 125, '2015-01-15 01:25:06.000000', 'consum', 0.0219, 'lps'),
	(370442, 125, '2015-01-15 01:25:07.000000', 'consum', 0.0220, 'lps'),
	(370443, 125, '2015-01-15 01:25:08.000000', 'consum', 0.0213, 'lps'),
	(370444, 125, '2015-01-15 01:25:09.000000', 'consum', 0.0216, 'lps'),
	(370445, 125, '2015-01-15 01:25:10.000000', 'consum', 0.0212, 'lps'),
	(370446, 125, '2015-01-15 01:25:11.000000', 'consum', 0.0221, 'lps'),
	(370447, 125, '2015-01-15 01:25:12.000000', 'consum', 0.0223, 'lps'),
	(370448, 125, '2015-01-15 01:25:13.000000', 'consum', 0.0210, 'lps'),
	(370449, 125, '2015-01-15 01:25:14.000000', 'consum', 0.0221, 'lps'),
	(370450, 125, '2015-01-15 01:25:15.000000', 'consum', 0.0216, 'lps'),
	(370451, 125, '2015-01-15 01:25:16.000000', 'consum', 0.0223, 'lps'),
	(370452, 125, '2015-01-15 01:25:17.000000', 'consum', 0.0224, 'lps'),
	(370453, 125, '2015-01-15 01:25:18.000000', 'consum', 0.0226, 'lps'),
	(370454, 125, '2015-01-15 01:25:19.000000', 'consum', 0.0213, 'lps'),
	(370455, 125, '2015-01-15 01:25:20.000000', 'consum', 0.0213, 'lps'),
	(370456, 125, '2015-01-15 01:25:21.000000', 'consum', 0.0214, 'lps'),
	(370457, 125, '2015-01-15 01:25:22.000000', 'consum', 0.0223, 'lps'),
	(370458, 125, '2015-01-15 01:25:23.000000', 'consum', 0.0211, 'lps'),
	(370459, 125, '2015-01-15 01:25:24.000000', 'consum', 0.0211, 'lps'),
	(370460, 125, '2015-01-15 01:25:25.000000', 'consum', 0.0214, 'lps'),
	(370461, 125, '2015-01-15 01:25:26.000000', 'consum', 0.0226, 'lps'),
	(370462, 125, '2015-01-15 01:25:27.000000', 'consum', 0.0226, 'lps'),
	(370463, 125, '2015-01-15 01:25:28.000000', 'consum', 0.0210, 'lps'),
	(370464, 125, '2015-01-15 01:25:29.000000', 'consum', 0.0214, 'lps'),
	(370465, 125, '2015-01-15 01:25:30.000000', 'consum', 0.0213, 'lps'),
	(370466, 125, '2015-01-15 01:25:31.000000', 'consum', 0.0211, 'lps'),
	(370467, 125, '2015-01-15 01:25:32.000000', 'consum', 0.0210, 'lps'),
	(370468, 125, '2015-01-15 01:25:33.000000', 'consum', 0.0224, 'lps'),
	(370469, 125, '2015-01-15 01:25:34.000000', 'consum', 0.0212, 'lps'),
	(370470, 125, '2015-01-15 01:25:35.000000', 'consum', 0.0214, 'lps'),
	(370471, 125, '2015-01-15 01:25:36.000000', 'consum', 0.0222, 'lps'),
	(370472, 125, '2015-01-15 01:25:37.000000', 'consum', 0.0210, 'lps'),
	(370473, 125, '2015-01-15 01:25:38.000000', 'consum', 0.0225, 'lps'),
	(370474, 125, '2015-01-15 01:25:39.000000', 'consum', 0.0217, 'lps'),
	(370475, 125, '2015-01-15 01:25:40.000000', 'consum', 0.0216, 'lps'),
	(370476, 125, '2015-01-15 01:25:41.000000', 'consum', 0.0222, 'lps'),
	(370477, 125, '2015-01-15 01:25:42.000000', 'consum', 0.0217, 'lps'),
	(370478, 125, '2015-01-15 01:25:43.000000', 'consum', 0.0226, 'lps'),
	(370479, 125, '2015-01-15 01:25:44.000000', 'consum', 0.0219, 'lps'),
	(370480, 125, '2015-01-15 01:25:45.000000', 'consum', 0.0223, 'lps'),
	(370481, 125, '2015-01-15 01:25:46.000000', 'consum', 0.0217, 'lps'),
	(370482, 125, '2015-01-15 01:25:47.000000', 'consum', 0.0221, 'lps'),
	(370483, 125, '2015-01-15 01:25:48.000000', 'consum', 0.0210, 'lps'),
	(370484, 125, '2015-01-15 01:25:49.000000', 'consum', 0.0211, 'lps'),
	(370485, 125, '2015-01-15 01:25:50.000000', 'consum', 0.0216, 'lps'),
	(370486, 125, '2015-01-15 01:25:51.000000', 'consum', 0.0219, 'lps'),
	(370487, 125, '2015-01-15 01:25:52.000000', 'consum', 0.0221, 'lps'),
	(370488, 125, '2015-01-15 01:25:53.000000', 'consum', 0.0222, 'lps'),
	(370489, 125, '2015-01-15 01:25:54.000000', 'consum', 0.0219, 'lps'),
	(370490, 125, '2015-01-15 01:25:55.000000', 'consum', 0.0220, 'lps'),
	(370491, 125, '2015-01-15 01:25:56.000000', 'consum', 0.0218, 'lps'),
	(370492, 125, '2015-01-15 01:25:57.000000', 'consum', 0.0219, 'lps'),
	(370493, 125, '2015-01-15 01:25:58.000000', 'consum', 0.0217, 'lps'),
	(370494, 125, '2015-01-15 01:25:59.000000', 'consum', 0.0216, 'lps'),
	(370495, 125, '2015-01-15 01:26:00.000000', 'consum', 0.0218, 'lps'),
	(370496, 125, '2015-01-15 01:26:01.000000', 'consum', 0.0218, 'lps'),
	(370497, 125, '2015-01-15 01:26:02.000000', 'consum', 0.0210, 'lps'),
	(370498, 125, '2015-01-15 01:26:03.000000', 'consum', 0.0219, 'lps'),
	(370499, 125, '2015-01-15 01:26:04.000000', 'consum', 0.0223, 'lps'),
	(370500, 125, '2015-01-15 01:26:05.000000', 'consum', 0.0216, 'lps'),
	(370501, 125, '2015-01-15 01:26:06.000000', 'consum', 0.0216, 'lps'),
	(370502, 125, '2015-01-15 01:26:07.000000', 'consum', 0.0223, 'lps'),
	(370503, 125, '2015-01-15 01:26:08.000000', 'consum', 0.0222, 'lps'),
	(370504, 125, '2015-01-15 01:26:09.000000', 'consum', 0.0218, 'lps'),
	(370505, 125, '2015-01-15 01:26:10.000000', 'consum', 0.0211, 'lps'),
	(370506, 125, '2015-01-15 01:26:11.000000', 'consum', 0.0210, 'lps'),
	(370507, 125, '2015-01-15 01:26:12.000000', 'consum', 0.0225, 'lps'),
	(370508, 125, '2015-01-15 01:26:13.000000', 'consum', 0.0216, 'lps'),
	(370509, 125, '2015-01-15 01:26:14.000000', 'consum', 0.0215, 'lps'),
	(370510, 125, '2015-01-15 01:26:15.000000', 'consum', 0.0217, 'lps'),
	(370511, 125, '2015-01-15 01:26:16.000000', 'consum', 0.0213, 'lps'),
	(370512, 125, '2015-01-15 01:26:17.000000', 'consum', 0.0220, 'lps'),
	(370513, 125, '2015-01-15 01:26:18.000000', 'consum', 0.0219, 'lps'),
	(370514, 125, '2015-01-15 01:26:19.000000', 'consum', 0.0224, 'lps'),
	(370515, 125, '2015-01-15 01:26:20.000000', 'consum', 0.0220, 'lps'),
	(370516, 125, '2015-01-15 01:26:21.000000', 'consum', 0.0219, 'lps'),
	(370517, 125, '2015-01-15 01:26:22.000000', 'consum', 0.0226, 'lps'),
	(370518, 125, '2015-01-15 01:26:23.000000', 'consum', 0.0211, 'lps'),
	(370519, 125, '2015-01-15 01:26:24.000000', 'consum', 0.0220, 'lps'),
	(370520, 125, '2015-01-15 01:26:25.000000', 'consum', 0.0223, 'lps'),
	(370521, 125, '2015-01-15 01:26:26.000000', 'consum', 0.0212, 'lps'),
	(370522, 125, '2015-01-15 01:26:27.000000', 'consum', 0.0215, 'lps'),
	(370523, 125, '2015-01-15 01:26:28.000000', 'consum', 0.0211, 'lps'),
	(370524, 125, '2015-01-15 01:26:29.000000', 'consum', 0.0217, 'lps'),
	(370525, 125, '2015-01-15 01:26:30.000000', 'consum', 0.0226, 'lps'),
	(370526, 125, '2015-01-15 01:26:31.000000', 'consum', 0.0218, 'lps'),
	(370527, 125, '2015-01-15 01:26:32.000000', 'consum', 0.0221, 'lps'),
	(370528, 125, '2015-01-15 01:26:33.000000', 'consum', 0.0223, 'lps'),
	(370529, 125, '2015-01-15 01:26:34.000000', 'consum', 0.0226, 'lps'),
	(370530, 125, '2015-01-15 01:26:35.000000', 'consum', 0.0220, 'lps'),
	(370531, 125, '2015-01-15 01:26:36.000000', 'consum', 0.0226, 'lps'),
	(370532, 125, '2015-01-15 01:26:37.000000', 'consum', 0.0212, 'lps'),
	(370533, 125, '2015-01-15 01:26:38.000000', 'consum', 0.0222, 'lps'),
	(370534, 125, '2015-01-15 01:26:39.000000', 'consum', 0.0214, 'lps'),
	(370535, 125, '2015-01-15 01:26:40.000000', 'consum', 0.0212, 'lps'),
	(370536, 125, '2015-01-15 01:26:41.000000', 'consum', 0.0226, 'lps'),
	(370537, 125, '2015-01-15 01:26:42.000000', 'consum', 0.0216, 'lps'),
	(370538, 125, '2015-01-15 01:26:43.000000', 'consum', 0.0211, 'lps'),
	(370539, 125, '2015-01-15 01:26:44.000000', 'consum', 0.0214, 'lps'),
	(370540, 125, '2015-01-15 01:26:45.000000', 'consum', 0.0211, 'lps'),
	(370541, 125, '2015-01-15 01:26:46.000000', 'consum', 0.0221, 'lps'),
	(370542, 125, '2015-01-15 01:26:47.000000', 'consum', 0.0211, 'lps'),
	(370543, 125, '2015-01-15 01:26:48.000000', 'consum', 0.0215, 'lps'),
	(370544, 125, '2015-01-15 01:26:49.000000', 'consum', 0.0218, 'lps'),
	(370545, 125, '2015-01-15 01:26:50.000000', 'consum', 0.0216, 'lps'),
	(370546, 125, '2015-01-15 01:26:51.000000', 'consum', 0.0219, 'lps'),
	(370547, 125, '2015-01-15 01:26:52.000000', 'consum', 0.0222, 'lps'),
	(370548, 125, '2015-01-15 01:26:53.000000', 'consum', 0.0223, 'lps'),
	(370549, 125, '2015-01-15 01:26:54.000000', 'consum', 0.0222, 'lps'),
	(370550, 125, '2015-01-15 01:26:55.000000', 'consum', 0.0215, 'lps'),
	(370551, 125, '2015-01-15 01:26:56.000000', 'consum', 0.0219, 'lps'),
	(370552, 125, '2015-01-15 01:26:57.000000', 'consum', 0.0221, 'lps'),
	(370553, 125, '2015-01-15 01:26:58.000000', 'consum', 0.0221, 'lps'),
	(370554, 125, '2015-01-15 01:26:59.000000', 'consum', 0.0215, 'lps'),
	(370555, 125, '2015-01-15 01:27:00.000000', 'consum', 0.0221, 'lps'),
	(370556, 125, '2015-01-15 01:27:01.000000', 'consum', 0.0217, 'lps'),
	(370557, 125, '2015-01-15 01:27:02.000000', 'consum', 0.0212, 'lps'),
	(370558, 125, '2015-01-15 01:27:03.000000', 'consum', 0.0217, 'lps'),
	(370559, 125, '2015-01-15 01:27:04.000000', 'consum', 0.0221, 'lps'),
	(370560, 125, '2015-01-15 01:27:05.000000', 'consum', 0.0213, 'lps'),
	(370561, 125, '2015-01-15 01:27:06.000000', 'consum', 0.0226, 'lps'),
	(370562, 125, '2015-01-15 01:27:07.000000', 'consum', 0.0212, 'lps'),
	(370563, 125, '2015-01-15 01:27:08.000000', 'consum', 0.0225, 'lps'),
	(370564, 125, '2015-01-15 01:27:09.000000', 'consum', 0.0213, 'lps'),
	(370565, 125, '2015-01-15 01:27:10.000000', 'consum', 0.0213, 'lps'),
	(370566, 125, '2015-01-15 01:27:11.000000', 'consum', 0.0217, 'lps'),
	(370567, 125, '2015-01-15 01:27:12.000000', 'consum', 0.0219, 'lps'),
	(370568, 125, '2015-01-15 01:27:13.000000', 'consum', 0.0219, 'lps'),
	(370569, 125, '2015-01-15 01:27:14.000000', 'consum', 0.0210, 'lps'),
	(370570, 125, '2015-01-15 01:27:15.000000', 'consum', 0.0218, 'lps'),
	(370571, 125, '2015-01-15 01:27:16.000000', 'consum', 0.0217, 'lps'),
	(370572, 125, '2015-01-15 01:27:17.000000', 'consum', 0.0222, 'lps'),
	(370573, 125, '2015-01-15 01:27:18.000000', 'consum', 0.0214, 'lps'),
	(370574, 125, '2015-01-15 01:27:19.000000', 'consum', 0.0213, 'lps'),
	(370575, 125, '2015-01-15 01:27:20.000000', 'consum', 0.0214, 'lps'),
	(370576, 125, '2015-01-15 01:27:21.000000', 'consum', 0.0222, 'lps'),
	(370577, 125, '2015-01-15 01:27:22.000000', 'consum', 0.0224, 'lps'),
	(370578, 125, '2015-01-15 01:27:23.000000', 'consum', 0.0210, 'lps'),
	(370579, 125, '2015-01-15 01:27:24.000000', 'consum', 0.0218, 'lps'),
	(370580, 125, '2015-01-15 01:27:25.000000', 'consum', 0.0219, 'lps'),
	(370581, 125, '2015-01-15 01:27:26.000000', 'consum', 0.0213, 'lps'),
	(370582, 125, '2015-01-15 01:27:27.000000', 'consum', 0.0216, 'lps'),
	(370583, 125, '2015-01-15 01:27:28.000000', 'consum', 0.0214, 'lps'),
	(370584, 125, '2015-01-15 01:27:29.000000', 'consum', 0.0212, 'lps'),
	(370585, 125, '2015-01-15 01:27:30.000000', 'consum', 0.0225, 'lps'),
	(370586, 125, '2015-01-15 01:27:31.000000', 'consum', 0.0212, 'lps'),
	(370587, 125, '2015-01-15 01:27:32.000000', 'consum', 0.0212, 'lps'),
	(370588, 125, '2015-01-15 01:27:33.000000', 'consum', 0.0211, 'lps'),
	(370589, 125, '2015-01-15 01:27:34.000000', 'consum', 0.0212, 'lps'),
	(370590, 125, '2015-01-15 01:27:35.000000', 'consum', 0.0216, 'lps'),
	(370591, 125, '2015-01-15 01:27:36.000000', 'consum', 0.0218, 'lps'),
	(370592, 125, '2015-01-15 01:27:37.000000', 'consum', 0.0215, 'lps'),
	(370593, 125, '2015-01-15 01:27:38.000000', 'consum', 0.0210, 'lps'),
	(370594, 125, '2015-01-15 01:27:39.000000', 'consum', 0.0213, 'lps'),
	(370595, 125, '2015-01-15 01:27:40.000000', 'consum', 0.0226, 'lps'),
	(370596, 125, '2015-01-15 01:27:41.000000', 'consum', 0.0215, 'lps'),
	(370597, 125, '2015-01-15 01:27:42.000000', 'consum', 0.0221, 'lps'),
	(370598, 125, '2015-01-15 01:27:43.000000', 'consum', 0.0218, 'lps'),
	(370599, 125, '2015-01-15 01:27:44.000000', 'consum', 0.0215, 'lps'),
	(370600, 125, '2015-01-15 01:27:45.000000', 'consum', 0.0211, 'lps'),
	(370601, 125, '2015-01-15 01:27:46.000000', 'consum', 0.0216, 'lps'),
	(370602, 125, '2015-01-15 01:27:47.000000', 'consum', 0.0224, 'lps'),
	(370603, 125, '2015-01-15 01:27:48.000000', 'consum', 0.0210, 'lps'),
	(370604, 125, '2015-01-15 01:27:49.000000', 'consum', 0.0219, 'lps'),
	(370605, 125, '2015-01-15 01:27:50.000000', 'consum', 0.0224, 'lps'),
	(370606, 125, '2015-01-15 01:27:51.000000', 'consum', 0.0217, 'lps'),
	(370607, 125, '2015-01-15 01:27:52.000000', 'consum', 0.0222, 'lps'),
	(370608, 125, '2015-01-15 01:27:53.000000', 'consum', 0.0215, 'lps'),
	(370609, 125, '2015-01-15 01:27:54.000000', 'consum', 0.0216, 'lps'),
	(370610, 125, '2015-01-15 01:27:55.000000', 'consum', 0.0224, 'lps'),
	(370611, 125, '2015-01-15 01:27:56.000000', 'consum', 0.0214, 'lps'),
	(370612, 125, '2015-01-15 01:27:57.000000', 'consum', 0.0223, 'lps'),
	(370613, 125, '2015-01-15 01:27:58.000000', 'consum', 0.0213, 'lps'),
	(370614, 125, '2015-01-15 01:27:59.000000', 'consum', 0.0221, 'lps'),
	(370615, 125, '2015-01-15 01:28:00.000000', 'consum', 0.0221, 'lps'),
	(370616, 125, '2015-01-15 01:28:01.000000', 'consum', 0.0218, 'lps'),
	(370617, 125, '2015-01-15 01:28:02.000000', 'consum', 0.0215, 'lps'),
	(370618, 125, '2015-01-15 01:28:03.000000', 'consum', 0.0212, 'lps'),
	(370619, 125, '2015-01-15 01:28:04.000000', 'consum', 0.0221, 'lps'),
	(370620, 125, '2015-01-15 01:28:05.000000', 'consum', 0.0210, 'lps'),
	(370621, 125, '2015-01-15 01:28:06.000000', 'consum', 0.0210, 'lps'),
	(370622, 125, '2015-01-15 01:28:07.000000', 'consum', 0.0211, 'lps'),
	(370623, 125, '2015-01-15 01:28:08.000000', 'consum', 0.0215, 'lps'),
	(370624, 125, '2015-01-15 01:28:09.000000', 'consum', 0.0214, 'lps'),
	(370625, 125, '2015-01-15 01:28:10.000000', 'consum', 0.0217, 'lps'),
	(370626, 125, '2015-01-15 01:28:11.000000', 'consum', 0.0218, 'lps'),
	(370627, 125, '2015-01-15 01:28:12.000000', 'consum', 0.0226, 'lps'),
	(370628, 125, '2015-01-15 01:28:13.000000', 'consum', 0.0218, 'lps'),
	(370629, 125, '2015-01-15 01:28:14.000000', 'consum', 0.0220, 'lps'),
	(370630, 125, '2015-01-15 01:28:15.000000', 'consum', 0.0220, 'lps'),
	(370631, 125, '2015-01-15 01:28:16.000000', 'consum', 0.0214, 'lps'),
	(370632, 125, '2015-01-15 01:28:17.000000', 'consum', 0.0216, 'lps'),
	(370633, 125, '2015-01-15 01:28:18.000000', 'consum', 0.0211, 'lps'),
	(370634, 125, '2015-01-15 01:28:19.000000', 'consum', 0.0214, 'lps'),
	(370635, 125, '2015-01-15 01:28:20.000000', 'consum', 0.0213, 'lps'),
	(370636, 125, '2015-01-15 01:28:21.000000', 'consum', 0.0213, 'lps'),
	(370637, 125, '2015-01-15 01:28:22.000000', 'consum', 0.0218, 'lps'),
	(370638, 125, '2015-01-15 01:28:23.000000', 'consum', 0.0222, 'lps'),
	(370639, 125, '2015-01-15 01:28:24.000000', 'consum', 0.0214, 'lps'),
	(370640, 125, '2015-01-15 01:28:25.000000', 'consum', 0.0210, 'lps'),
	(370641, 125, '2015-01-15 01:28:26.000000', 'consum', 0.0218, 'lps'),
	(370642, 125, '2015-01-15 01:28:27.000000', 'consum', 0.0216, 'lps'),
	(370643, 125, '2015-01-15 01:28:28.000000', 'consum', 0.0217, 'lps'),
	(370644, 125, '2015-01-15 01:28:29.000000', 'consum', 0.0210, 'lps'),
	(370645, 125, '2015-01-15 01:28:30.000000', 'consum', 0.0224, 'lps'),
	(370646, 125, '2015-01-15 01:28:31.000000', 'consum', 0.0212, 'lps'),
	(370647, 125, '2015-01-15 01:28:32.000000', 'consum', 0.0212, 'lps'),
	(370648, 125, '2015-01-15 01:28:33.000000', 'consum', 0.0216, 'lps'),
	(370649, 125, '2015-01-15 01:28:34.000000', 'consum', 0.0217, 'lps'),
	(370650, 125, '2015-01-15 01:28:35.000000', 'consum', 0.0211, 'lps'),
	(370651, 125, '2015-01-15 01:28:36.000000', 'consum', 0.0210, 'lps'),
	(370652, 125, '2015-01-15 01:28:37.000000', 'consum', 0.0224, 'lps'),
	(370653, 125, '2015-01-15 01:28:38.000000', 'consum', 0.0212, 'lps'),
	(370654, 125, '2015-01-15 01:28:39.000000', 'consum', 0.0212, 'lps'),
	(370655, 125, '2015-01-15 01:28:40.000000', 'consum', 0.0217, 'lps'),
	(370656, 125, '2015-01-15 01:28:41.000000', 'consum', 0.0220, 'lps'),
	(370657, 125, '2015-01-15 01:28:42.000000', 'consum', 0.0223, 'lps'),
	(370658, 125, '2015-01-15 01:28:43.000000', 'consum', 0.0213, 'lps'),
	(370659, 125, '2015-01-15 01:28:44.000000', 'consum', 0.0221, 'lps'),
	(370660, 125, '2015-01-15 01:28:45.000000', 'consum', 0.0221, 'lps'),
	(370661, 125, '2015-01-15 01:28:46.000000', 'consum', 0.0215, 'lps'),
	(370662, 125, '2015-01-15 01:28:47.000000', 'consum', 0.0220, 'lps'),
	(370663, 125, '2015-01-15 01:28:48.000000', 'consum', 0.0211, 'lps'),
	(370664, 125, '2015-01-15 01:28:49.000000', 'consum', 0.0219, 'lps'),
	(370665, 125, '2015-01-15 01:28:50.000000', 'consum', 0.0217, 'lps'),
	(370666, 125, '2015-01-15 01:28:51.000000', 'consum', 0.0222, 'lps'),
	(370667, 125, '2015-01-15 01:28:52.000000', 'consum', 0.0214, 'lps'),
	(370668, 125, '2015-01-15 01:28:53.000000', 'consum', 0.0213, 'lps'),
	(370669, 125, '2015-01-15 01:28:54.000000', 'consum', 0.0213, 'lps'),
	(370670, 125, '2015-01-15 01:28:55.000000', 'consum', 0.0218, 'lps'),
	(370671, 125, '2015-01-15 01:28:56.000000', 'consum', 0.0224, 'lps'),
	(370672, 125, '2015-01-15 01:28:57.000000', 'consum', 0.0221, 'lps'),
	(370673, 125, '2015-01-15 01:28:58.000000', 'consum', 0.0226, 'lps'),
	(370674, 125, '2015-01-15 01:28:59.000000', 'consum', 0.0222, 'lps'),
	(370675, 125, '2015-01-15 01:29:00.000000', 'consum', 0.0224, 'lps'),
	(370676, 125, '2015-01-15 01:29:01.000000', 'consum', 0.0225, 'lps'),
	(370677, 125, '2015-01-15 01:29:02.000000', 'consum', 0.0210, 'lps'),
	(370678, 125, '2015-01-15 01:29:03.000000', 'consum', 0.0219, 'lps'),
	(370679, 125, '2015-01-15 01:29:04.000000', 'consum', 0.0219, 'lps'),
	(370680, 125, '2015-01-15 01:29:05.000000', 'consum', 0.0214, 'lps'),
	(370681, 125, '2015-01-15 01:29:06.000000', 'consum', 0.0219, 'lps'),
	(370682, 125, '2015-01-15 01:29:07.000000', 'consum', 0.0225, 'lps'),
	(370683, 125, '2015-01-15 01:29:08.000000', 'consum', 0.0226, 'lps'),
	(370684, 125, '2015-01-15 01:29:09.000000', 'consum', 0.0212, 'lps'),
	(370685, 125, '2015-01-15 01:29:10.000000', 'consum', 0.0224, 'lps'),
	(370686, 125, '2015-01-15 01:29:11.000000', 'consum', 0.0224, 'lps'),
	(370687, 125, '2015-01-15 01:29:12.000000', 'consum', 0.0221, 'lps'),
	(370688, 125, '2015-01-15 01:29:13.000000', 'consum', 0.0223, 'lps'),
	(370689, 125, '2015-01-15 01:29:14.000000', 'consum', 0.0226, 'lps'),
	(370690, 125, '2015-01-15 01:29:15.000000', 'consum', 0.0218, 'lps'),
	(370691, 125, '2015-01-15 01:29:16.000000', 'consum', 0.0219, 'lps'),
	(370692, 125, '2015-01-15 01:29:17.000000', 'consum', 0.0213, 'lps'),
	(370693, 125, '2015-01-15 01:29:18.000000', 'consum', 0.0217, 'lps'),
	(370694, 125, '2015-01-15 01:29:19.000000', 'consum', 0.0221, 'lps'),
	(370695, 125, '2015-01-15 01:29:20.000000', 'consum', 0.0225, 'lps'),
	(370696, 125, '2015-01-15 01:29:21.000000', 'consum', 0.0218, 'lps'),
	(370697, 125, '2015-01-15 01:29:22.000000', 'consum', 0.0223, 'lps'),
	(370698, 125, '2015-01-15 01:29:23.000000', 'consum', 0.0216, 'lps'),
	(370699, 125, '2015-01-15 01:29:24.000000', 'consum', 0.0220, 'lps'),
	(370700, 125, '2015-01-15 01:29:25.000000', 'consum', 0.0210, 'lps'),
	(370701, 125, '2015-01-15 01:29:26.000000', 'consum', 0.0211, 'lps'),
	(370702, 125, '2015-01-15 01:29:27.000000', 'consum', 0.0218, 'lps'),
	(370703, 125, '2015-01-15 01:29:28.000000', 'consum', 0.0215, 'lps'),
	(370704, 125, '2015-01-15 01:29:29.000000', 'consum', 0.0226, 'lps'),
	(370705, 125, '2015-01-15 01:29:30.000000', 'consum', 0.0226, 'lps'),
	(370706, 125, '2015-01-15 01:29:31.000000', 'consum', 0.0210, 'lps'),
	(370707, 125, '2015-01-15 01:29:32.000000', 'consum', 0.0210, 'lps'),
	(370708, 125, '2015-01-15 01:29:33.000000', 'consum', 0.0214, 'lps'),
	(370709, 125, '2015-01-15 01:29:34.000000', 'consum', 0.0212, 'lps'),
	(370710, 125, '2015-01-15 01:29:35.000000', 'consum', 0.0210, 'lps'),
	(370711, 125, '2015-01-15 01:29:36.000000', 'consum', 0.0221, 'lps'),
	(370712, 125, '2015-01-15 01:29:37.000000', 'consum', 0.0213, 'lps'),
	(370713, 125, '2015-01-15 01:29:38.000000', 'consum', 0.0210, 'lps'),
	(370714, 125, '2015-01-15 01:29:39.000000', 'consum', 0.0218, 'lps'),
	(370715, 125, '2015-01-15 01:29:40.000000', 'consum', 0.0218, 'lps'),
	(370716, 125, '2015-01-15 01:29:41.000000', 'consum', 0.0224, 'lps'),
	(370717, 125, '2015-01-15 01:29:42.000000', 'consum', 0.0224, 'lps'),
	(370718, 125, '2015-01-15 01:29:43.000000', 'consum', 0.0222, 'lps'),
	(370719, 125, '2015-01-15 01:29:44.000000', 'consum', 0.0213, 'lps'),
	(370720, 125, '2015-01-15 01:29:45.000000', 'consum', 0.0222, 'lps'),
	(370721, 125, '2015-01-15 01:29:46.000000', 'consum', 0.0212, 'lps'),
	(370722, 125, '2015-01-15 01:29:47.000000', 'consum', 0.0218, 'lps'),
	(370723, 125, '2015-01-15 01:29:48.000000', 'consum', 0.0210, 'lps'),
	(370724, 125, '2015-01-15 01:29:49.000000', 'consum', 0.0220, 'lps'),
	(370725, 125, '2015-01-15 01:29:50.000000', 'consum', 0.0211, 'lps'),
	(370726, 125, '2015-01-15 01:29:51.000000', 'consum', 0.0217, 'lps'),
	(370727, 125, '2015-01-15 01:29:52.000000', 'consum', 0.0211, 'lps'),
	(370728, 125, '2015-01-15 01:29:53.000000', 'consum', 0.0226, 'lps'),
	(370729, 125, '2015-01-15 01:29:54.000000', 'consum', 0.0220, 'lps'),
	(370730, 125, '2015-01-15 01:29:55.000000', 'consum', 0.0214, 'lps'),
	(370731, 125, '2015-01-15 01:29:56.000000', 'consum', 0.0218, 'lps'),
	(370732, 125, '2015-01-15 01:29:57.000000', 'consum', 0.0223, 'lps'),
	(370733, 125, '2015-01-15 01:29:58.000000', 'consum', 0.0214, 'lps'),
	(370734, 125, '2015-01-15 01:29:59.000000', 'consum', 0.0210, 'lps'),
	(370735, 125, '2015-01-15 01:30:00.000000', 'consum', 0.0215, 'lps'),
	(370736, 125, '2015-01-15 01:30:01.000000', 'consum', 0.0217, 'lps'),
	(370737, 125, '2015-01-15 01:30:02.000000', 'consum', 0.0216, 'lps'),
	(370738, 125, '2015-01-15 01:30:03.000000', 'consum', 0.0218, 'lps'),
	(370739, 125, '2015-01-15 01:30:04.000000', 'consum', 0.0216, 'lps'),
	(370740, 125, '2015-01-15 01:30:05.000000', 'consum', 0.0217, 'lps'),
	(370741, 125, '2015-01-15 01:30:06.000000', 'consum', 0.0212, 'lps'),
	(370742, 125, '2015-01-15 01:30:07.000000', 'consum', 0.0214, 'lps'),
	(370743, 125, '2015-01-15 01:30:08.000000', 'consum', 0.0226, 'lps'),
	(370744, 125, '2015-01-15 01:30:09.000000', 'consum', 0.0211, 'lps'),
	(370745, 125, '2015-01-15 01:30:10.000000', 'consum', 0.0219, 'lps'),
	(370746, 125, '2015-01-15 01:30:11.000000', 'consum', 0.0216, 'lps'),
	(370747, 125, '2015-01-15 01:30:12.000000', 'consum', 0.0213, 'lps'),
	(370748, 125, '2015-01-15 01:30:13.000000', 'consum', 0.0225, 'lps'),
	(370749, 125, '2015-01-15 01:30:14.000000', 'consum', 0.0224, 'lps'),
	(370750, 125, '2015-01-15 01:30:15.000000', 'consum', 0.0220, 'lps'),
	(370751, 125, '2015-01-15 01:30:16.000000', 'consum', 0.0216, 'lps'),
	(370752, 125, '2015-01-15 01:30:17.000000', 'consum', 0.0213, 'lps'),
	(370753, 125, '2015-01-15 01:30:18.000000', 'consum', 0.0226, 'lps'),
	(370754, 125, '2015-01-15 01:30:19.000000', 'consum', 0.0211, 'lps'),
	(370755, 125, '2015-01-15 01:30:20.000000', 'consum', 0.0221, 'lps'),
	(370756, 125, '2015-01-15 01:30:21.000000', 'consum', 0.0226, 'lps'),
	(370757, 125, '2015-01-15 01:30:22.000000', 'consum', 0.0226, 'lps'),
	(370758, 125, '2015-01-15 01:30:23.000000', 'consum', 0.0226, 'lps'),
	(370759, 125, '2015-01-15 01:30:24.000000', 'consum', 0.0224, 'lps'),
	(370760, 125, '2015-01-15 01:30:25.000000', 'consum', 0.0214, 'lps'),
	(370761, 125, '2015-01-15 01:30:26.000000', 'consum', 0.0226, 'lps'),
	(370762, 125, '2015-01-15 01:30:27.000000', 'consum', 0.0224, 'lps'),
	(370763, 125, '2015-01-15 01:30:28.000000', 'consum', 0.0217, 'lps'),
	(370764, 125, '2015-01-15 01:30:29.000000', 'consum', 0.0222, 'lps'),
	(370765, 125, '2015-01-15 01:30:30.000000', 'consum', 0.0216, 'lps'),
	(370766, 125, '2015-01-15 01:30:31.000000', 'consum', 0.0221, 'lps'),
	(370767, 125, '2015-01-15 01:30:32.000000', 'consum', 0.0211, 'lps'),
	(370768, 125, '2015-01-15 01:30:33.000000', 'consum', 0.0219, 'lps'),
	(370769, 125, '2015-01-15 01:30:34.000000', 'consum', 0.0216, 'lps'),
	(370770, 125, '2015-01-15 01:30:35.000000', 'consum', 0.0214, 'lps'),
	(370771, 125, '2015-01-15 01:30:36.000000', 'consum', 0.0213, 'lps'),
	(370772, 125, '2015-01-15 01:30:37.000000', 'consum', 0.0212, 'lps'),
	(370773, 125, '2015-01-15 01:30:38.000000', 'consum', 0.0212, 'lps'),
	(370774, 125, '2015-01-15 01:30:39.000000', 'consum', 0.0215, 'lps'),
	(370775, 125, '2015-01-15 01:30:40.000000', 'consum', 0.0214, 'lps'),
	(370776, 125, '2015-01-15 01:30:41.000000', 'consum', 0.0214, 'lps'),
	(370777, 125, '2015-01-15 01:30:42.000000', 'consum', 0.0220, 'lps'),
	(370778, 125, '2015-01-15 01:30:43.000000', 'consum', 0.0214, 'lps'),
	(370779, 125, '2015-01-15 01:30:44.000000', 'consum', 0.0218, 'lps'),
	(370780, 125, '2015-01-15 01:30:45.000000', 'consum', 0.0219, 'lps'),
	(370781, 125, '2015-01-15 01:30:46.000000', 'consum', 0.0216, 'lps'),
	(370782, 125, '2015-01-15 01:30:47.000000', 'consum', 0.0214, 'lps'),
	(370783, 125, '2015-01-15 01:30:48.000000', 'consum', 0.0214, 'lps'),
	(370784, 125, '2015-01-15 01:30:49.000000', 'consum', 0.0218, 'lps'),
	(370785, 125, '2015-01-15 01:30:50.000000', 'consum', 0.0220, 'lps'),
	(370786, 125, '2015-01-15 01:30:51.000000', 'consum', 0.0222, 'lps'),
	(370787, 125, '2015-01-15 01:30:52.000000', 'consum', 0.0221, 'lps'),
	(370788, 125, '2015-01-15 01:30:53.000000', 'consum', 0.0213, 'lps'),
	(370789, 125, '2015-01-15 01:30:54.000000', 'consum', 0.0225, 'lps'),
	(370790, 125, '2015-01-15 01:30:55.000000', 'consum', 0.0211, 'lps'),
	(370791, 125, '2015-01-15 01:30:56.000000', 'consum', 0.0222, 'lps'),
	(370792, 125, '2015-01-15 01:30:57.000000', 'consum', 0.0217, 'lps'),
	(370793, 125, '2015-01-15 01:30:58.000000', 'consum', 0.0210, 'lps'),
	(370794, 125, '2015-01-15 01:30:59.000000', 'consum', 0.0221, 'lps'),
	(370795, 125, '2015-01-15 01:31:00.000000', 'consum', 0.0217, 'lps'),
	(370796, 125, '2015-01-15 01:31:01.000000', 'consum', 0.0212, 'lps'),
	(370797, 125, '2015-01-15 01:31:02.000000', 'consum', 0.0215, 'lps'),
	(370798, 125, '2015-01-15 01:31:03.000000', 'consum', 0.0213, 'lps'),
	(370799, 125, '2015-01-15 01:31:04.000000', 'consum', 0.0213, 'lps'),
	(370800, 125, '2015-01-15 01:31:05.000000', 'consum', 0.0213, 'lps'),
	(370801, 125, '2015-01-15 01:31:06.000000', 'consum', 0.0217, 'lps'),
	(370802, 125, '2015-01-15 01:31:07.000000', 'consum', 0.0220, 'lps'),
	(370803, 125, '2015-01-15 01:31:08.000000', 'consum', 0.0220, 'lps'),
	(370804, 125, '2015-01-15 01:31:09.000000', 'consum', 0.0217, 'lps'),
	(370805, 125, '2015-01-15 01:31:10.000000', 'consum', 0.0215, 'lps'),
	(370806, 125, '2015-01-15 01:31:11.000000', 'consum', 0.0215, 'lps'),
	(370807, 125, '2015-01-15 01:31:12.000000', 'consum', 0.0220, 'lps'),
	(370808, 125, '2015-01-15 01:31:13.000000', 'consum', 0.0213, 'lps'),
	(370809, 125, '2015-01-15 01:31:14.000000', 'consum', 0.0211, 'lps'),
	(370810, 125, '2015-01-15 01:31:15.000000', 'consum', 0.0222, 'lps'),
	(370811, 125, '2015-01-15 01:31:16.000000', 'consum', 0.0220, 'lps'),
	(370812, 125, '2015-01-15 01:31:17.000000', 'consum', 0.0221, 'lps'),
	(370813, 125, '2015-01-15 01:31:18.000000', 'consum', 0.0220, 'lps'),
	(370814, 125, '2015-01-15 01:31:19.000000', 'consum', 0.0212, 'lps'),
	(370815, 125, '2015-01-15 01:31:20.000000', 'consum', 0.0222, 'lps'),
	(370816, 125, '2015-01-15 01:31:21.000000', 'consum', 0.0216, 'lps'),
	(370817, 125, '2015-01-15 01:31:22.000000', 'consum', 0.0220, 'lps'),
	(370818, 125, '2015-01-15 01:31:23.000000', 'consum', 0.0225, 'lps'),
	(370819, 125, '2015-01-15 01:31:24.000000', 'consum', 0.0221, 'lps'),
	(370820, 125, '2015-01-15 01:31:25.000000', 'consum', 0.0221, 'lps'),
	(370821, 125, '2015-01-15 01:31:26.000000', 'consum', 0.0215, 'lps'),
	(370822, 125, '2015-01-15 01:31:27.000000', 'consum', 0.0222, 'lps'),
	(370823, 125, '2015-01-15 01:31:28.000000', 'consum', 0.0220, 'lps'),
	(370824, 125, '2015-01-15 01:31:29.000000', 'consum', 0.0225, 'lps'),
	(370825, 125, '2015-01-15 01:31:30.000000', 'consum', 0.0222, 'lps'),
	(370826, 125, '2015-01-15 01:31:31.000000', 'consum', 0.0224, 'lps'),
	(370827, 125, '2015-01-15 01:31:32.000000', 'consum', 0.0210, 'lps'),
	(370828, 125, '2015-01-15 01:31:33.000000', 'consum', 0.0221, 'lps'),
	(370829, 125, '2015-01-15 01:31:34.000000', 'consum', 0.0214, 'lps'),
	(370830, 125, '2015-01-15 01:31:35.000000', 'consum', 0.0214, 'lps'),
	(370831, 125, '2015-01-15 01:31:36.000000', 'consum', 0.0220, 'lps'),
	(370832, 125, '2015-01-15 01:31:37.000000', 'consum', 0.0215, 'lps'),
	(370833, 125, '2015-01-15 01:31:38.000000', 'consum', 0.0221, 'lps'),
	(370834, 125, '2015-01-15 01:31:39.000000', 'consum', 0.0218, 'lps'),
	(370835, 125, '2015-01-15 01:31:40.000000', 'consum', 0.0215, 'lps'),
	(370836, 125, '2015-01-15 01:31:41.000000', 'consum', 0.0214, 'lps'),
	(370837, 125, '2015-01-15 01:31:42.000000', 'consum', 0.0215, 'lps'),
	(370838, 125, '2015-01-15 01:31:43.000000', 'consum', 0.0225, 'lps'),
	(370839, 125, '2015-01-15 01:31:44.000000', 'consum', 0.0219, 'lps'),
	(370840, 125, '2015-01-15 01:31:45.000000', 'consum', 0.0211, 'lps'),
	(370841, 125, '2015-01-15 01:31:46.000000', 'consum', 0.0222, 'lps'),
	(370842, 125, '2015-01-15 01:31:47.000000', 'consum', 0.0217, 'lps'),
	(370843, 125, '2015-01-15 01:31:48.000000', 'consum', 0.0225, 'lps'),
	(370844, 125, '2015-01-15 01:31:49.000000', 'consum', 0.0213, 'lps'),
	(370845, 125, '2015-01-15 01:31:50.000000', 'consum', 0.0216, 'lps'),
	(370846, 125, '2015-01-15 01:31:51.000000', 'consum', 0.0212, 'lps'),
	(370847, 125, '2015-01-15 01:31:52.000000', 'consum', 0.0222, 'lps'),
	(370848, 125, '2015-01-15 01:31:53.000000', 'consum', 0.0211, 'lps'),
	(370849, 125, '2015-01-15 01:31:54.000000', 'consum', 0.0215, 'lps'),
	(370850, 125, '2015-01-15 01:31:55.000000', 'consum', 0.0215, 'lps'),
	(370851, 125, '2015-01-15 01:31:56.000000', 'consum', 0.0223, 'lps'),
	(370852, 125, '2015-01-15 01:31:57.000000', 'consum', 0.0224, 'lps'),
	(370853, 125, '2015-01-15 01:31:58.000000', 'consum', 0.0224, 'lps'),
	(370854, 125, '2015-01-15 01:31:59.000000', 'consum', 0.0222, 'lps'),
	(370855, 125, '2015-01-15 01:32:00.000000', 'consum', 0.0213, 'lps'),
	(370856, 125, '2015-01-15 01:32:01.000000', 'consum', 0.0221, 'lps'),
	(370857, 125, '2015-01-15 01:32:02.000000', 'consum', 0.0225, 'lps'),
	(370858, 125, '2015-01-15 01:32:03.000000', 'consum', 0.0216, 'lps'),
	(370859, 125, '2015-01-15 01:32:04.000000', 'consum', 0.0211, 'lps'),
	(370860, 125, '2015-01-15 01:32:05.000000', 'consum', 0.0218, 'lps'),
	(370861, 125, '2015-01-15 01:32:06.000000', 'consum', 0.0214, 'lps'),
	(370862, 125, '2015-01-15 01:32:07.000000', 'consum', 0.0220, 'lps'),
	(370863, 125, '2015-01-15 01:32:08.000000', 'consum', 0.0218, 'lps'),
	(370864, 125, '2015-01-15 01:32:09.000000', 'consum', 0.0220, 'lps'),
	(370865, 125, '2015-01-15 01:32:10.000000', 'consum', 0.0217, 'lps'),
	(370866, 125, '2015-01-15 01:32:11.000000', 'consum', 0.0217, 'lps'),
	(370867, 125, '2015-01-15 01:32:12.000000', 'consum', 0.0225, 'lps'),
	(370868, 125, '2015-01-15 01:32:13.000000', 'consum', 0.0214, 'lps'),
	(370869, 125, '2015-01-15 01:32:14.000000', 'consum', 0.0221, 'lps'),
	(370870, 125, '2015-01-15 01:32:15.000000', 'consum', 0.0217, 'lps'),
	(370871, 125, '2015-01-15 01:32:16.000000', 'consum', 0.0212, 'lps'),
	(370872, 125, '2015-01-15 01:32:17.000000', 'consum', 0.0218, 'lps'),
	(370873, 125, '2015-01-15 01:32:18.000000', 'consum', 0.0212, 'lps'),
	(370874, 125, '2015-01-15 01:32:19.000000', 'consum', 0.0211, 'lps'),
	(370875, 125, '2015-01-15 01:32:20.000000', 'consum', 0.0226, 'lps'),
	(370876, 125, '2015-01-15 01:32:21.000000', 'consum', 0.0222, 'lps'),
	(370877, 125, '2015-01-15 01:32:22.000000', 'consum', 0.0221, 'lps'),
	(370878, 125, '2015-01-15 01:32:23.000000', 'consum', 0.0213, 'lps'),
	(370879, 125, '2015-01-15 01:32:24.000000', 'consum', 0.0226, 'lps'),
	(370880, 125, '2015-01-15 01:32:25.000000', 'consum', 0.0214, 'lps'),
	(370881, 125, '2015-01-15 01:32:26.000000', 'consum', 0.0218, 'lps'),
	(370882, 125, '2015-01-15 01:32:27.000000', 'consum', 0.0221, 'lps'),
	(370883, 125, '2015-01-15 01:32:28.000000', 'consum', 0.0224, 'lps'),
	(370884, 125, '2015-01-15 01:32:29.000000', 'consum', 0.0215, 'lps'),
	(370885, 125, '2015-01-15 01:32:30.000000', 'consum', 0.0210, 'lps'),
	(370886, 125, '2015-01-15 01:32:31.000000', 'consum', 0.0211, 'lps'),
	(370887, 125, '2015-01-15 01:32:32.000000', 'consum', 0.0215, 'lps'),
	(370888, 125, '2015-01-15 01:32:33.000000', 'consum', 0.0218, 'lps'),
	(370889, 125, '2015-01-15 01:32:34.000000', 'consum', 0.0217, 'lps'),
	(370890, 125, '2015-01-15 01:32:35.000000', 'consum', 0.0220, 'lps'),
	(370891, 125, '2015-01-15 01:32:36.000000', 'consum', 0.0224, 'lps'),
	(370892, 125, '2015-01-15 01:32:37.000000', 'consum', 0.0217, 'lps'),
	(370893, 125, '2015-01-15 01:32:38.000000', 'consum', 0.0221, 'lps'),
	(370894, 125, '2015-01-15 01:32:39.000000', 'consum', 0.0225, 'lps'),
	(370895, 125, '2015-01-15 01:32:40.000000', 'consum', 0.0221, 'lps'),
	(370896, 125, '2015-01-15 01:32:41.000000', 'consum', 0.0219, 'lps'),
	(370897, 125, '2015-01-15 01:32:42.000000', 'consum', 0.0224, 'lps'),
	(370898, 125, '2015-01-15 01:32:43.000000', 'consum', 0.0217, 'lps'),
	(370899, 125, '2015-01-15 01:32:44.000000', 'consum', 0.0223, 'lps'),
	(370900, 125, '2015-01-15 01:32:45.000000', 'consum', 0.0219, 'lps'),
	(370901, 125, '2015-01-15 01:32:46.000000', 'consum', 0.0217, 'lps'),
	(370902, 125, '2015-01-15 01:32:47.000000', 'consum', 0.0217, 'lps'),
	(370903, 125, '2015-01-15 01:32:48.000000', 'consum', 0.0224, 'lps'),
	(370904, 125, '2015-01-15 01:32:49.000000', 'consum', 0.0210, 'lps'),
	(370905, 125, '2015-01-15 01:32:50.000000', 'consum', 0.0218, 'lps'),
	(370906, 125, '2015-01-15 01:32:51.000000', 'consum', 0.0219, 'lps'),
	(370907, 125, '2015-01-15 01:32:52.000000', 'consum', 0.0215, 'lps'),
	(370908, 125, '2015-01-15 01:32:53.000000', 'consum', 0.0224, 'lps'),
	(370909, 125, '2015-01-15 01:32:54.000000', 'consum', 0.0216, 'lps'),
	(370910, 125, '2015-01-15 01:32:55.000000', 'consum', 0.0216, 'lps'),
	(370911, 125, '2015-01-15 01:32:56.000000', 'consum', 0.0220, 'lps'),
	(370912, 125, '2015-01-15 01:32:57.000000', 'consum', 0.0210, 'lps'),
	(370913, 125, '2015-01-15 01:32:58.000000', 'consum', 0.0213, 'lps'),
	(370914, 125, '2015-01-15 01:32:59.000000', 'consum', 0.0224, 'lps'),
	(370915, 125, '2015-01-15 01:33:00.000000', 'consum', 0.0224, 'lps'),
	(370916, 125, '2015-01-15 01:33:01.000000', 'consum', 0.0219, 'lps'),
	(370917, 125, '2015-01-15 01:33:02.000000', 'consum', 0.0216, 'lps'),
	(370918, 125, '2015-01-15 01:33:03.000000', 'consum', 0.0214, 'lps'),
	(370919, 125, '2015-01-15 01:33:04.000000', 'consum', 0.0210, 'lps'),
	(370920, 125, '2015-01-15 01:33:05.000000', 'consum', 0.0218, 'lps'),
	(370921, 125, '2015-01-15 01:33:06.000000', 'consum', 0.0215, 'lps'),
	(370922, 125, '2015-01-15 01:33:07.000000', 'consum', 0.0213, 'lps'),
	(370923, 125, '2015-01-15 01:33:08.000000', 'consum', 0.0211, 'lps'),
	(370924, 125, '2015-01-15 01:33:09.000000', 'consum', 0.0222, 'lps'),
	(370925, 125, '2015-01-15 01:33:10.000000', 'consum', 0.0216, 'lps'),
	(370926, 125, '2015-01-15 01:33:11.000000', 'consum', 0.0220, 'lps'),
	(370927, 125, '2015-01-15 01:33:12.000000', 'consum', 0.0212, 'lps'),
	(370928, 125, '2015-01-15 01:33:13.000000', 'consum', 0.0223, 'lps'),
	(370929, 125, '2015-01-15 01:33:14.000000', 'consum', 0.0218, 'lps'),
	(370930, 125, '2015-01-15 01:33:15.000000', 'consum', 0.0212, 'lps'),
	(370931, 125, '2015-01-15 01:33:16.000000', 'consum', 0.0213, 'lps'),
	(370932, 125, '2015-01-15 01:33:17.000000', 'consum', 0.0220, 'lps'),
	(370933, 125, '2015-01-15 01:33:18.000000', 'consum', 0.0219, 'lps'),
	(370934, 125, '2015-01-15 01:33:19.000000', 'consum', 0.0226, 'lps'),
	(370935, 125, '2015-01-15 01:33:20.000000', 'consum', 0.0213, 'lps'),
	(370936, 125, '2015-01-15 01:33:21.000000', 'consum', 0.0225, 'lps'),
	(370937, 125, '2015-01-15 01:33:22.000000', 'consum', 0.0212, 'lps'),
	(370938, 125, '2015-01-15 01:33:23.000000', 'consum', 0.0225, 'lps'),
	(370939, 125, '2015-01-15 01:33:24.000000', 'consum', 0.0214, 'lps'),
	(370940, 125, '2015-01-15 01:33:25.000000', 'consum', 0.0216, 'lps'),
	(370941, 125, '2015-01-15 01:33:26.000000', 'consum', 0.0213, 'lps'),
	(370942, 125, '2015-01-15 01:33:27.000000', 'consum', 0.0224, 'lps'),
	(370943, 125, '2015-01-15 01:33:28.000000', 'consum', 0.0220, 'lps'),
	(370944, 125, '2015-01-15 01:33:29.000000', 'consum', 0.0220, 'lps'),
	(370945, 125, '2015-01-15 01:33:30.000000', 'consum', 0.0213, 'lps'),
	(370946, 125, '2015-01-15 01:33:31.000000', 'consum', 0.0214, 'lps'),
	(370947, 125, '2015-01-15 01:33:32.000000', 'consum', 0.0219, 'lps'),
	(370948, 125, '2015-01-15 01:33:33.000000', 'consum', 0.0226, 'lps'),
	(370949, 125, '2015-01-15 01:33:34.000000', 'consum', 0.0215, 'lps'),
	(370950, 125, '2015-01-15 01:33:35.000000', 'consum', 0.0219, 'lps'),
	(370951, 125, '2015-01-15 01:33:36.000000', 'consum', 0.0226, 'lps'),
	(370952, 125, '2015-01-15 01:33:37.000000', 'consum', 0.0213, 'lps'),
	(370953, 125, '2015-01-15 01:33:38.000000', 'consum', 0.0211, 'lps'),
	(370954, 125, '2015-01-15 01:33:39.000000', 'consum', 0.0224, 'lps'),
	(370955, 125, '2015-01-15 01:33:40.000000', 'consum', 0.0224, 'lps'),
	(370956, 125, '2015-01-15 01:33:41.000000', 'consum', 0.0225, 'lps'),
	(370957, 125, '2015-01-15 01:33:42.000000', 'consum', 0.0223, 'lps'),
	(370958, 125, '2015-01-15 01:33:43.000000', 'consum', 0.0216, 'lps'),
	(370959, 125, '2015-01-15 01:33:44.000000', 'consum', 0.0216, 'lps'),
	(370960, 125, '2015-01-15 01:33:45.000000', 'consum', 0.0223, 'lps'),
	(370961, 125, '2015-01-15 01:33:46.000000', 'consum', 0.0223, 'lps'),
	(370962, 125, '2015-01-15 01:33:47.000000', 'consum', 0.0221, 'lps'),
	(370963, 125, '2015-01-15 01:33:48.000000', 'consum', 0.0210, 'lps'),
	(370964, 125, '2015-01-15 01:33:49.000000', 'consum', 0.0211, 'lps'),
	(370965, 125, '2015-01-15 01:33:50.000000', 'consum', 0.0217, 'lps'),
	(370966, 125, '2015-01-15 01:33:51.000000', 'consum', 0.0223, 'lps'),
	(370967, 125, '2015-01-15 01:33:52.000000', 'consum', 0.0222, 'lps'),
	(370968, 125, '2015-01-15 01:33:53.000000', 'consum', 0.0214, 'lps'),
	(370969, 125, '2015-01-15 01:33:54.000000', 'consum', 0.0212, 'lps'),
	(370970, 125, '2015-01-15 01:33:55.000000', 'consum', 0.0223, 'lps'),
	(370971, 125, '2015-01-15 01:33:56.000000', 'consum', 0.0222, 'lps'),
	(370972, 125, '2015-01-15 01:33:57.000000', 'consum', 0.0212, 'lps'),
	(370973, 125, '2015-01-15 01:33:58.000000', 'consum', 0.0221, 'lps'),
	(370974, 125, '2015-01-15 01:33:59.000000', 'consum', 0.0225, 'lps'),
	(370975, 125, '2015-01-15 01:34:00.000000', 'consum', 0.0219, 'lps'),
	(370976, 125, '2015-01-15 01:34:01.000000', 'consum', 0.0225, 'lps'),
	(370977, 125, '2015-01-15 01:34:02.000000', 'consum', 0.0226, 'lps'),
	(370978, 125, '2015-01-15 01:34:03.000000', 'consum', 0.0211, 'lps'),
	(370979, 125, '2015-01-15 01:34:04.000000', 'consum', 0.0220, 'lps'),
	(370980, 125, '2015-01-15 01:34:05.000000', 'consum', 0.0223, 'lps'),
	(370981, 125, '2015-01-15 01:34:06.000000', 'consum', 0.0210, 'lps'),
	(370982, 125, '2015-01-15 01:34:07.000000', 'consum', 0.0225, 'lps'),
	(370983, 125, '2015-01-15 01:34:08.000000', 'consum', 0.0216, 'lps'),
	(370984, 125, '2015-01-15 01:34:09.000000', 'consum', 0.0213, 'lps'),
	(370985, 125, '2015-01-15 01:34:10.000000', 'consum', 0.0226, 'lps'),
	(370986, 125, '2015-01-15 01:34:11.000000', 'consum', 0.0214, 'lps'),
	(370987, 125, '2015-01-15 01:34:12.000000', 'consum', 0.0217, 'lps'),
	(370988, 125, '2015-01-15 01:34:13.000000', 'consum', 0.0214, 'lps'),
	(370989, 125, '2015-01-15 01:34:14.000000', 'consum', 0.0212, 'lps'),
	(370990, 125, '2015-01-15 01:34:15.000000', 'consum', 0.0223, 'lps'),
	(370991, 125, '2015-01-15 01:34:16.000000', 'consum', 0.0221, 'lps'),
	(370992, 125, '2015-01-15 01:34:17.000000', 'consum', 0.0210, 'lps'),
	(370993, 125, '2015-01-15 01:34:18.000000', 'consum', 0.0211, 'lps'),
	(370994, 125, '2015-01-15 01:34:19.000000', 'consum', 0.0215, 'lps'),
	(370995, 125, '2015-01-15 01:34:20.000000', 'consum', 0.0217, 'lps'),
	(370996, 125, '2015-01-15 01:34:21.000000', 'consum', 0.0211, 'lps'),
	(370997, 125, '2015-01-15 01:34:22.000000', 'consum', 0.0213, 'lps'),
	(370998, 125, '2015-01-15 01:34:23.000000', 'consum', 0.0221, 'lps'),
	(370999, 125, '2015-01-15 01:34:24.000000', 'consum', 0.0223, 'lps'),
	(371000, 125, '2015-01-15 01:34:25.000000', 'consum', 0.0224, 'lps'),
	(371001, 125, '2015-01-15 01:34:26.000000', 'consum', 0.0211, 'lps'),
	(371002, 125, '2015-01-15 01:34:27.000000', 'consum', 0.0222, 'lps'),
	(371003, 125, '2015-01-15 01:34:28.000000', 'consum', 0.0216, 'lps'),
	(371004, 125, '2015-01-15 01:34:29.000000', 'consum', 0.0224, 'lps'),
	(371005, 125, '2015-01-15 01:34:30.000000', 'consum', 0.0210, 'lps'),
	(371006, 125, '2015-01-15 01:34:31.000000', 'consum', 0.0219, 'lps'),
	(371007, 125, '2015-01-15 01:34:32.000000', 'consum', 0.0224, 'lps'),
	(371008, 125, '2015-01-15 01:34:33.000000', 'consum', 0.0217, 'lps'),
	(371009, 125, '2015-01-15 01:34:34.000000', 'consum', 0.0221, 'lps'),
	(371010, 125, '2015-01-15 01:34:35.000000', 'consum', 0.0211, 'lps'),
	(371011, 125, '2015-01-15 01:34:36.000000', 'consum', 0.0214, 'lps'),
	(371012, 125, '2015-01-15 01:34:37.000000', 'consum', 0.0213, 'lps'),
	(371013, 125, '2015-01-15 01:34:38.000000', 'consum', 0.0214, 'lps'),
	(371014, 125, '2015-01-15 01:34:39.000000', 'consum', 0.0221, 'lps'),
	(371015, 125, '2015-01-15 01:34:40.000000', 'consum', 0.0217, 'lps'),
	(371016, 125, '2015-01-15 01:34:41.000000', 'consum', 0.0216, 'lps'),
	(371017, 125, '2015-01-15 01:34:42.000000', 'consum', 0.0218, 'lps'),
	(371018, 125, '2015-01-15 01:34:43.000000', 'consum', 0.0215, 'lps'),
	(371019, 125, '2015-01-15 01:34:44.000000', 'consum', 0.0211, 'lps'),
	(371020, 125, '2015-01-15 01:34:45.000000', 'consum', 0.0219, 'lps'),
	(371021, 125, '2015-01-15 01:34:46.000000', 'consum', 0.0219, 'lps'),
	(371022, 125, '2015-01-15 01:34:47.000000', 'consum', 0.0226, 'lps'),
	(371023, 125, '2015-01-15 01:34:48.000000', 'consum', 0.0213, 'lps'),
	(371024, 125, '2015-01-15 01:34:49.000000', 'consum', 0.0214, 'lps'),
	(371025, 125, '2015-01-15 01:34:50.000000', 'consum', 0.0218, 'lps'),
	(371026, 125, '2015-01-15 01:34:51.000000', 'consum', 0.0224, 'lps'),
	(371027, 125, '2015-01-15 01:34:52.000000', 'consum', 0.0222, 'lps'),
	(371028, 125, '2015-01-15 01:34:53.000000', 'consum', 0.0211, 'lps'),
	(371029, 125, '2015-01-15 01:34:54.000000', 'consum', 0.0214, 'lps'),
	(371030, 125, '2015-01-15 01:34:55.000000', 'consum', 0.0211, 'lps'),
	(371031, 125, '2015-01-15 01:34:56.000000', 'consum', 0.0219, 'lps'),
	(371032, 125, '2015-01-15 01:34:57.000000', 'consum', 0.0221, 'lps'),
	(371033, 125, '2015-01-15 01:34:58.000000', 'consum', 0.0219, 'lps'),
	(371034, 125, '2015-01-15 01:34:59.000000', 'consum', 0.0224, 'lps'),
	(371035, 125, '2015-01-15 01:35:00.000000', 'consum', 0.0220, 'lps'),
	(371036, 126, '2015-01-15 00:00:00.000000', 'consum', 0.0213, 'lps'),
	(371037, 126, '2015-01-15 00:00:01.000000', 'consum', 0.0218, 'lps'),
	(371038, 126, '2015-01-15 00:00:02.000000', 'consum', 0.0223, 'lps'),
	(371039, 126, '2015-01-15 00:00:03.000000', 'consum', 0.0211, 'lps'),
	(371040, 126, '2015-01-15 00:00:04.000000', 'consum', 0.0215, 'lps'),
	(371041, 126, '2015-01-15 00:00:05.000000', 'consum', 0.0215, 'lps'),
	(371042, 126, '2015-01-15 00:00:06.000000', 'consum', 0.0218, 'lps'),
	(371043, 126, '2015-01-15 00:00:07.000000', 'consum', 0.0218, 'lps'),
	(371044, 126, '2015-01-15 00:00:08.000000', 'consum', 0.0226, 'lps'),
	(371045, 126, '2015-01-15 00:00:09.000000', 'consum', 0.0228, 'lps'),
	(371046, 126, '2015-01-15 00:00:10.000000', 'consum', 0.0215, 'lps'),
	(371047, 126, '2015-01-15 00:00:11.000000', 'consum', 0.0219, 'lps'),
	(371048, 126, '2015-01-15 00:00:12.000000', 'consum', 0.0222, 'lps'),
	(371049, 126, '2015-01-15 00:00:13.000000', 'consum', 0.0226, 'lps'),
	(371050, 126, '2015-01-15 00:00:14.000000', 'consum', 0.0214, 'lps'),
	(371051, 126, '2015-01-15 00:00:15.000000', 'consum', 0.0220, 'lps'),
	(371052, 126, '2015-01-15 00:00:16.000000', 'consum', 0.0211, 'lps'),
	(371053, 126, '2015-01-15 00:00:17.000000', 'consum', 0.0222, 'lps'),
	(371054, 126, '2015-01-15 00:00:18.000000', 'consum', 0.0211, 'lps'),
	(371055, 126, '2015-01-15 00:00:19.000000', 'consum', 0.0216, 'lps'),
	(371056, 126, '2015-01-15 00:00:20.000000', 'consum', 0.0221, 'lps'),
	(371057, 126, '2015-01-15 00:00:21.000000', 'consum', 0.0228, 'lps'),
	(371058, 126, '2015-01-15 00:00:22.000000', 'consum', 0.0210, 'lps'),
	(371059, 126, '2015-01-15 00:00:23.000000', 'consum', 0.0215, 'lps'),
	(371060, 126, '2015-01-15 00:00:24.000000', 'consum', 0.0214, 'lps'),
	(371061, 126, '2015-01-15 00:00:25.000000', 'consum', 0.0215, 'lps'),
	(371062, 126, '2015-01-15 00:00:26.000000', 'consum', 0.0224, 'lps'),
	(371063, 126, '2015-01-15 00:00:27.000000', 'consum', 0.0228, 'lps'),
	(371064, 126, '2015-01-15 00:00:28.000000', 'consum', 0.0220, 'lps'),
	(371065, 126, '2015-01-15 00:00:29.000000', 'consum', 0.0227, 'lps'),
	(371066, 126, '2015-01-15 00:00:30.000000', 'consum', 0.0227, 'lps'),
	(371067, 126, '2015-01-15 00:00:31.000000', 'consum', 0.0226, 'lps'),
	(371068, 126, '2015-01-15 00:00:32.000000', 'consum', 0.0218, 'lps'),
	(371069, 126, '2015-01-15 00:00:33.000000', 'consum', 0.0225, 'lps'),
	(371070, 126, '2015-01-15 00:00:34.000000', 'consum', 0.0222, 'lps'),
	(371071, 126, '2015-01-15 00:00:35.000000', 'consum', 0.0224, 'lps'),
	(371072, 126, '2015-01-15 00:00:36.000000', 'consum', 0.0226, 'lps'),
	(371073, 126, '2015-01-15 00:00:37.000000', 'consum', 0.0212, 'lps'),
	(371074, 126, '2015-01-15 00:00:38.000000', 'consum', 0.0211, 'lps'),
	(371075, 126, '2015-01-15 00:00:39.000000', 'consum', 0.0211, 'lps'),
	(371076, 126, '2015-01-15 00:00:40.000000', 'consum', 0.0228, 'lps'),
	(371077, 126, '2015-01-15 00:00:41.000000', 'consum', 0.0225, 'lps'),
	(371078, 126, '2015-01-15 00:00:42.000000', 'consum', 0.0228, 'lps'),
	(371079, 126, '2015-01-15 00:00:43.000000', 'consum', 0.0220, 'lps'),
	(371080, 126, '2015-01-15 00:00:44.000000', 'consum', 0.0226, 'lps'),
	(371081, 126, '2015-01-15 00:00:45.000000', 'consum', 0.0221, 'lps'),
	(371082, 126, '2015-01-15 00:00:46.000000', 'consum', 0.0218, 'lps'),
	(371083, 126, '2015-01-15 00:00:47.000000', 'consum', 0.0219, 'lps'),
	(371084, 126, '2015-01-15 00:00:48.000000', 'consum', 0.0212, 'lps'),
	(371085, 126, '2015-01-15 00:00:49.000000', 'consum', 0.0211, 'lps'),
	(371086, 126, '2015-01-15 00:00:50.000000', 'consum', 0.0211, 'lps'),
	(371087, 126, '2015-01-15 00:00:51.000000', 'consum', 0.0210, 'lps'),
	(371088, 126, '2015-01-15 00:00:52.000000', 'consum', 0.0227, 'lps'),
	(371089, 126, '2015-01-15 00:00:53.000000', 'consum', 0.0221, 'lps'),
	(371090, 126, '2015-01-15 00:00:54.000000', 'consum', 0.0216, 'lps'),
	(371091, 126, '2015-01-15 00:00:55.000000', 'consum', 0.0223, 'lps'),
	(371092, 126, '2015-01-15 00:00:56.000000', 'consum', 0.0220, 'lps'),
	(371093, 126, '2015-01-15 00:00:57.000000', 'consum', 0.0224, 'lps'),
	(371094, 126, '2015-01-15 00:00:58.000000', 'consum', 0.0212, 'lps'),
	(371095, 126, '2015-01-15 00:00:59.000000', 'consum', 0.0215, 'lps'),
	(371096, 126, '2015-01-15 00:01:00.000000', 'consum', 0.0210, 'lps'),
	(371097, 126, '2015-01-15 00:01:01.000000', 'consum', 0.0214, 'lps'),
	(371098, 126, '2015-01-15 00:01:02.000000', 'consum', 0.0211, 'lps'),
	(371099, 126, '2015-01-15 00:01:03.000000', 'consum', 0.0222, 'lps'),
	(371100, 126, '2015-01-15 00:01:04.000000', 'consum', 0.0212, 'lps'),
	(371101, 126, '2015-01-15 00:01:05.000000', 'consum', 0.0223, 'lps'),
	(371102, 126, '2015-01-15 00:01:06.000000', 'consum', 0.0212, 'lps'),
	(371103, 126, '2015-01-15 00:01:07.000000', 'consum', 0.0220, 'lps'),
	(371104, 126, '2015-01-15 00:01:08.000000', 'consum', 0.0217, 'lps'),
	(371105, 126, '2015-01-15 00:01:09.000000', 'consum', 0.0213, 'lps'),
	(371106, 126, '2015-01-15 00:01:10.000000', 'consum', 0.0226, 'lps'),
	(371107, 126, '2015-01-15 00:01:11.000000', 'consum', 0.0222, 'lps'),
	(371108, 126, '2015-01-15 00:01:12.000000', 'consum', 0.0223, 'lps'),
	(371109, 126, '2015-01-15 00:01:13.000000', 'consum', 0.0223, 'lps'),
	(371110, 126, '2015-01-15 00:01:14.000000', 'consum', 0.0216, 'lps'),
	(371111, 126, '2015-01-15 00:01:15.000000', 'consum', 0.0220, 'lps'),
	(371112, 126, '2015-01-15 00:01:16.000000', 'consum', 0.0224, 'lps'),
	(371113, 126, '2015-01-15 00:01:17.000000', 'consum', 0.0212, 'lps'),
	(371114, 126, '2015-01-15 00:01:18.000000', 'consum', 0.0217, 'lps'),
	(371115, 126, '2015-01-15 00:01:19.000000', 'consum', 0.0221, 'lps'),
	(371116, 126, '2015-01-15 00:01:20.000000', 'consum', 0.0226, 'lps'),
	(371117, 126, '2015-01-15 00:01:21.000000', 'consum', 0.0217, 'lps'),
	(371118, 126, '2015-01-15 00:01:22.000000', 'consum', 0.0219, 'lps'),
	(371119, 126, '2015-01-15 00:01:23.000000', 'consum', 0.0214, 'lps'),
	(371120, 126, '2015-01-15 00:01:24.000000', 'consum', 0.0221, 'lps'),
	(371121, 126, '2015-01-15 00:01:25.000000', 'consum', 0.0216, 'lps'),
	(371122, 126, '2015-01-15 00:01:26.000000', 'consum', 0.0227, 'lps'),
	(371123, 126, '2015-01-15 00:01:27.000000', 'consum', 0.0222, 'lps'),
	(371124, 126, '2015-01-15 00:01:28.000000', 'consum', 0.0217, 'lps'),
	(371125, 126, '2015-01-15 00:01:29.000000', 'consum', 0.0212, 'lps'),
	(371126, 126, '2015-01-15 00:01:30.000000', 'consum', 0.0219, 'lps'),
	(371127, 126, '2015-01-15 00:01:31.000000', 'consum', 0.0211, 'lps'),
	(371128, 126, '2015-01-15 00:01:32.000000', 'consum', 0.0226, 'lps'),
	(371129, 126, '2015-01-15 00:01:33.000000', 'consum', 0.0228, 'lps'),
	(371130, 126, '2015-01-15 00:01:34.000000', 'consum', 0.0218, 'lps'),
	(371131, 126, '2015-01-15 00:01:35.000000', 'consum', 0.0216, 'lps'),
	(371132, 126, '2015-01-15 00:01:36.000000', 'consum', 0.0214, 'lps'),
	(371133, 126, '2015-01-15 00:01:37.000000', 'consum', 0.0213, 'lps'),
	(371134, 126, '2015-01-15 00:01:38.000000', 'consum', 0.0212, 'lps'),
	(371135, 126, '2015-01-15 00:01:39.000000', 'consum', 0.0213, 'lps'),
	(371136, 126, '2015-01-15 00:01:40.000000', 'consum', 0.0221, 'lps'),
	(371137, 126, '2015-01-15 00:01:41.000000', 'consum', 0.0219, 'lps'),
	(371138, 126, '2015-01-15 00:01:42.000000', 'consum', 0.0221, 'lps'),
	(371139, 126, '2015-01-15 00:01:43.000000', 'consum', 0.0220, 'lps'),
	(371140, 126, '2015-01-15 00:01:44.000000', 'consum', 0.0210, 'lps'),
	(371141, 126, '2015-01-15 00:01:45.000000', 'consum', 0.0216, 'lps'),
	(371142, 126, '2015-01-15 00:01:46.000000', 'consum', 0.0223, 'lps'),
	(371143, 126, '2015-01-15 00:01:47.000000', 'consum', 0.0219, 'lps'),
	(371144, 126, '2015-01-15 00:01:48.000000', 'consum', 0.0215, 'lps'),
	(371145, 126, '2015-01-15 00:01:49.000000', 'consum', 0.0227, 'lps'),
	(371146, 126, '2015-01-15 00:01:50.000000', 'consum', 0.0225, 'lps'),
	(371147, 126, '2015-01-15 00:01:51.000000', 'consum', 0.0217, 'lps'),
	(371148, 126, '2015-01-15 00:01:52.000000', 'consum', 0.0219, 'lps'),
	(371149, 126, '2015-01-15 00:01:53.000000', 'consum', 0.0215, 'lps'),
	(371150, 126, '2015-01-15 00:01:54.000000', 'consum', 0.0226, 'lps'),
	(371151, 126, '2015-01-15 00:01:55.000000', 'consum', 0.0222, 'lps'),
	(371152, 126, '2015-01-15 00:01:56.000000', 'consum', 0.0219, 'lps'),
	(371153, 126, '2015-01-15 00:01:57.000000', 'consum', 0.0222, 'lps'),
	(371154, 126, '2015-01-15 00:01:58.000000', 'consum', 0.0225, 'lps'),
	(371155, 126, '2015-01-15 00:01:59.000000', 'consum', 0.0210, 'lps'),
	(371156, 126, '2015-01-15 00:02:00.000000', 'consum', 0.0222, 'lps'),
	(371157, 126, '2015-01-15 00:02:01.000000', 'consum', 0.0214, 'lps'),
	(371158, 126, '2015-01-15 00:02:02.000000', 'consum', 0.0212, 'lps'),
	(371159, 126, '2015-01-15 00:02:03.000000', 'consum', 0.0211, 'lps'),
	(371160, 126, '2015-01-15 00:02:04.000000', 'consum', 0.0226, 'lps'),
	(371161, 126, '2015-01-15 00:02:05.000000', 'consum', 0.0214, 'lps'),
	(371162, 126, '2015-01-15 00:02:06.000000', 'consum', 0.0220, 'lps'),
	(371163, 126, '2015-01-15 00:02:07.000000', 'consum', 0.0228, 'lps'),
	(371164, 126, '2015-01-15 00:02:08.000000', 'consum', 0.0214, 'lps'),
	(371165, 126, '2015-01-15 00:02:09.000000', 'consum', 0.0216, 'lps'),
	(371166, 126, '2015-01-15 00:02:10.000000', 'consum', 0.0227, 'lps'),
	(371167, 126, '2015-01-15 00:02:11.000000', 'consum', 0.0221, 'lps'),
	(371168, 126, '2015-01-15 00:02:12.000000', 'consum', 0.0213, 'lps'),
	(371169, 126, '2015-01-15 00:02:13.000000', 'consum', 0.0211, 'lps'),
	(371170, 126, '2015-01-15 00:02:14.000000', 'consum', 0.0226, 'lps'),
	(371171, 126, '2015-01-15 00:02:15.000000', 'consum', 0.0212, 'lps'),
	(371172, 126, '2015-01-15 00:02:16.000000', 'consum', 0.0211, 'lps'),
	(371173, 126, '2015-01-15 00:02:17.000000', 'consum', 0.0228, 'lps'),
	(371174, 126, '2015-01-15 00:02:18.000000', 'consum', 0.0223, 'lps'),
	(371175, 126, '2015-01-15 00:02:19.000000', 'consum', 0.0220, 'lps'),
	(371176, 126, '2015-01-15 00:02:20.000000', 'consum', 0.0220, 'lps'),
	(371177, 126, '2015-01-15 00:02:21.000000', 'consum', 0.0215, 'lps'),
	(371178, 126, '2015-01-15 00:02:22.000000', 'consum', 0.0222, 'lps'),
	(371179, 126, '2015-01-15 00:02:23.000000', 'consum', 0.0220, 'lps'),
	(371180, 126, '2015-01-15 00:02:24.000000', 'consum', 0.0224, 'lps'),
	(371181, 126, '2015-01-15 00:02:25.000000', 'consum', 0.0212, 'lps'),
	(371182, 126, '2015-01-15 00:02:26.000000', 'consum', 0.0216, 'lps'),
	(371183, 126, '2015-01-15 00:02:27.000000', 'consum', 0.0215, 'lps'),
	(371184, 126, '2015-01-15 00:02:28.000000', 'consum', 0.0217, 'lps'),
	(371185, 126, '2015-01-15 00:02:29.000000', 'consum', 0.0213, 'lps'),
	(371186, 126, '2015-01-15 00:02:30.000000', 'consum', 0.0224, 'lps'),
	(371187, 126, '2015-01-15 00:02:31.000000', 'consum', 0.0214, 'lps'),
	(371188, 126, '2015-01-15 00:02:32.000000', 'consum', 0.0226, 'lps'),
	(371189, 126, '2015-01-15 00:02:33.000000', 'consum', 0.0222, 'lps'),
	(371190, 126, '2015-01-15 00:02:34.000000', 'consum', 0.0221, 'lps'),
	(371191, 126, '2015-01-15 00:02:35.000000', 'consum', 0.0213, 'lps'),
	(371192, 126, '2015-01-15 00:02:36.000000', 'consum', 0.0211, 'lps'),
	(371193, 126, '2015-01-15 00:02:37.000000', 'consum', 0.0226, 'lps'),
	(371194, 126, '2015-01-15 00:02:38.000000', 'consum', 0.0211, 'lps'),
	(371195, 126, '2015-01-15 00:02:39.000000', 'consum', 0.0224, 'lps'),
	(371196, 126, '2015-01-15 00:02:40.000000', 'consum', 0.0220, 'lps'),
	(371197, 126, '2015-01-15 00:02:41.000000', 'consum', 0.0218, 'lps'),
	(371198, 126, '2015-01-15 00:02:42.000000', 'consum', 0.0223, 'lps'),
	(371199, 126, '2015-01-15 00:02:43.000000', 'consum', 0.0214, 'lps'),
	(371200, 126, '2015-01-15 00:02:44.000000', 'consum', 0.0226, 'lps'),
	(371201, 126, '2015-01-15 00:02:45.000000', 'consum', 0.0225, 'lps'),
	(371202, 126, '2015-01-15 00:02:46.000000', 'consum', 0.0215, 'lps'),
	(371203, 126, '2015-01-15 00:02:47.000000', 'consum', 0.0212, 'lps'),
	(371204, 126, '2015-01-15 00:02:48.000000', 'consum', 0.0225, 'lps'),
	(371205, 126, '2015-01-15 00:02:49.000000', 'consum', 0.0223, 'lps'),
	(371206, 126, '2015-01-15 00:02:50.000000', 'consum', 0.0212, 'lps'),
	(371207, 126, '2015-01-15 00:02:51.000000', 'consum', 0.0220, 'lps'),
	(371208, 126, '2015-01-15 00:02:52.000000', 'consum', 0.0216, 'lps'),
	(371209, 126, '2015-01-15 00:02:53.000000', 'consum', 0.0211, 'lps'),
	(371210, 126, '2015-01-15 00:02:54.000000', 'consum', 0.0218, 'lps'),
	(371211, 126, '2015-01-15 00:02:55.000000', 'consum', 0.0227, 'lps'),
	(371212, 126, '2015-01-15 00:02:56.000000', 'consum', 0.0215, 'lps'),
	(371213, 126, '2015-01-15 00:02:57.000000', 'consum', 0.0220, 'lps'),
	(371214, 126, '2015-01-15 00:02:58.000000', 'consum', 0.0210, 'lps'),
	(371215, 126, '2015-01-15 00:02:59.000000', 'consum', 0.0219, 'lps'),
	(371216, 126, '2015-01-15 00:03:00.000000', 'consum', 0.0216, 'lps'),
	(371217, 126, '2015-01-15 00:03:01.000000', 'consum', 0.0215, 'lps'),
	(371218, 126, '2015-01-15 00:03:02.000000', 'consum', 0.0219, 'lps'),
	(371219, 126, '2015-01-15 00:03:03.000000', 'consum', 0.0219, 'lps'),
	(371220, 126, '2015-01-15 00:03:04.000000', 'consum', 0.0227, 'lps'),
	(371221, 126, '2015-01-15 00:03:05.000000', 'consum', 0.0214, 'lps'),
	(371222, 126, '2015-01-15 00:03:06.000000', 'consum', 0.0219, 'lps'),
	(371223, 126, '2015-01-15 00:03:07.000000', 'consum', 0.0221, 'lps'),
	(371224, 126, '2015-01-15 00:03:08.000000', 'consum', 0.0222, 'lps'),
	(371225, 126, '2015-01-15 00:03:09.000000', 'consum', 0.0218, 'lps'),
	(371226, 126, '2015-01-15 00:03:10.000000', 'consum', 0.0213, 'lps'),
	(371227, 126, '2015-01-15 00:03:11.000000', 'consum', 0.0219, 'lps'),
	(371228, 126, '2015-01-15 00:03:12.000000', 'consum', 0.0212, 'lps'),
	(371229, 126, '2015-01-15 00:03:13.000000', 'consum', 0.0210, 'lps'),
	(371230, 126, '2015-01-15 00:03:14.000000', 'consum', 0.0226, 'lps'),
	(371231, 126, '2015-01-15 00:03:15.000000', 'consum', 0.0214, 'lps'),
	(371232, 126, '2015-01-15 00:03:16.000000', 'consum', 0.0219, 'lps'),
	(371233, 126, '2015-01-15 00:03:17.000000', 'consum', 0.0226, 'lps'),
	(371234, 126, '2015-01-15 00:03:18.000000', 'consum', 0.0225, 'lps'),
	(371235, 126, '2015-01-15 00:03:19.000000', 'consum', 0.0221, 'lps'),
	(371236, 126, '2015-01-15 00:03:20.000000', 'consum', 0.0217, 'lps'),
	(371237, 126, '2015-01-15 00:03:21.000000', 'consum', 0.0213, 'lps'),
	(371238, 126, '2015-01-15 00:03:22.000000', 'consum', 0.0225, 'lps'),
	(371239, 126, '2015-01-15 00:03:23.000000', 'consum', 0.0218, 'lps'),
	(371240, 126, '2015-01-15 00:03:24.000000', 'consum', 0.0226, 'lps'),
	(371241, 126, '2015-01-15 00:03:25.000000', 'consum', 0.0227, 'lps'),
	(371242, 126, '2015-01-15 00:03:26.000000', 'consum', 0.0212, 'lps'),
	(371243, 126, '2015-01-15 00:03:27.000000', 'consum', 0.0223, 'lps'),
	(371244, 126, '2015-01-15 00:03:28.000000', 'consum', 0.0215, 'lps'),
	(371245, 126, '2015-01-15 00:03:29.000000', 'consum', 0.0213, 'lps'),
	(371246, 126, '2015-01-15 00:03:30.000000', 'consum', 0.0210, 'lps'),
	(371247, 126, '2015-01-15 00:03:31.000000', 'consum', 0.0224, 'lps'),
	(371248, 126, '2015-01-15 00:03:32.000000', 'consum', 0.0221, 'lps'),
	(371249, 126, '2015-01-15 00:03:33.000000', 'consum', 0.0226, 'lps'),
	(371250, 126, '2015-01-15 00:03:34.000000', 'consum', 0.0217, 'lps'),
	(371251, 126, '2015-01-15 00:03:35.000000', 'consum', 0.0216, 'lps'),
	(371252, 126, '2015-01-15 00:03:36.000000', 'consum', 0.0218, 'lps'),
	(371253, 126, '2015-01-15 00:03:37.000000', 'consum', 0.0217, 'lps'),
	(371254, 126, '2015-01-15 00:03:38.000000', 'consum', 0.0220, 'lps'),
	(371255, 126, '2015-01-15 00:03:39.000000', 'consum', 0.0219, 'lps'),
	(371256, 126, '2015-01-15 00:03:40.000000', 'consum', 0.0226, 'lps'),
	(371257, 126, '2015-01-15 00:03:41.000000', 'consum', 0.0226, 'lps'),
	(371258, 126, '2015-01-15 00:03:42.000000', 'consum', 0.0225, 'lps'),
	(371259, 126, '2015-01-15 00:03:43.000000', 'consum', 0.0219, 'lps'),
	(371260, 126, '2015-01-15 00:03:44.000000', 'consum', 0.0211, 'lps'),
	(371261, 126, '2015-01-15 00:03:45.000000', 'consum', 0.0226, 'lps'),
	(371262, 126, '2015-01-15 00:03:46.000000', 'consum', 0.0211, 'lps'),
	(371263, 126, '2015-01-15 00:03:47.000000', 'consum', 0.0223, 'lps'),
	(371264, 126, '2015-01-15 00:03:48.000000', 'consum', 0.0215, 'lps'),
	(371265, 126, '2015-01-15 00:03:49.000000', 'consum', 0.0214, 'lps'),
	(371266, 126, '2015-01-15 00:03:50.000000', 'consum', 0.0219, 'lps'),
	(371267, 126, '2015-01-15 00:03:51.000000', 'consum', 0.0225, 'lps'),
	(371268, 126, '2015-01-15 00:03:52.000000', 'consum', 0.0218, 'lps'),
	(371269, 126, '2015-01-15 00:03:53.000000', 'consum', 0.0224, 'lps'),
	(371270, 126, '2015-01-15 00:03:54.000000', 'consum', 0.0220, 'lps'),
	(371271, 126, '2015-01-15 00:03:55.000000', 'consum', 0.0217, 'lps'),
	(371272, 126, '2015-01-15 00:03:56.000000', 'consum', 0.0217, 'lps'),
	(371273, 126, '2015-01-15 00:03:57.000000', 'consum', 0.0225, 'lps'),
	(371274, 126, '2015-01-15 00:03:58.000000', 'consum', 0.0228, 'lps'),
	(371275, 126, '2015-01-15 00:03:59.000000', 'consum', 0.0214, 'lps'),
	(371276, 126, '2015-01-15 00:04:00.000000', 'consum', 0.0217, 'lps'),
	(371277, 126, '2015-01-15 00:04:01.000000', 'consum', 0.0212, 'lps'),
	(371278, 126, '2015-01-15 00:04:02.000000', 'consum', 0.0219, 'lps'),
	(371279, 126, '2015-01-15 00:04:03.000000', 'consum', 0.0210, 'lps'),
	(371280, 126, '2015-01-15 00:04:04.000000', 'consum', 0.0224, 'lps'),
	(371281, 126, '2015-01-15 00:04:05.000000', 'consum', 0.0221, 'lps'),
	(371282, 126, '2015-01-15 00:04:06.000000', 'consum', 0.0226, 'lps'),
	(371283, 126, '2015-01-15 00:04:07.000000', 'consum', 0.0220, 'lps'),
	(371284, 126, '2015-01-15 00:04:08.000000', 'consum', 0.0211, 'lps'),
	(371285, 126, '2015-01-15 00:04:09.000000', 'consum', 0.0224, 'lps'),
	(371286, 126, '2015-01-15 00:04:10.000000', 'consum', 0.0218, 'lps'),
	(371287, 126, '2015-01-15 00:04:11.000000', 'consum', 0.0212, 'lps'),
	(371288, 126, '2015-01-15 00:04:12.000000', 'consum', 0.0213, 'lps'),
	(371289, 126, '2015-01-15 00:04:13.000000', 'consum', 0.0218, 'lps'),
	(371290, 126, '2015-01-15 00:04:14.000000', 'consum', 0.0225, 'lps'),
	(371291, 126, '2015-01-15 00:04:15.000000', 'consum', 0.0225, 'lps'),
	(371292, 126, '2015-01-15 00:04:16.000000', 'consum', 0.0219, 'lps'),
	(371293, 126, '2015-01-15 00:04:17.000000', 'consum', 0.0210, 'lps'),
	(371294, 126, '2015-01-15 00:04:18.000000', 'consum', 0.0221, 'lps'),
	(371295, 126, '2015-01-15 00:04:19.000000', 'consum', 0.0211, 'lps'),
	(371296, 126, '2015-01-15 00:04:20.000000', 'consum', 0.0220, 'lps'),
	(371297, 126, '2015-01-15 00:04:21.000000', 'consum', 0.0217, 'lps'),
	(371298, 126, '2015-01-15 00:04:22.000000', 'consum', 0.0217, 'lps'),
	(371299, 126, '2015-01-15 00:04:23.000000', 'consum', 0.0226, 'lps'),
	(371300, 126, '2015-01-15 00:04:24.000000', 'consum', 0.0210, 'lps'),
	(371301, 126, '2015-01-15 00:04:25.000000', 'consum', 0.0222, 'lps'),
	(371302, 126, '2015-01-15 00:04:26.000000', 'consum', 0.0214, 'lps'),
	(371303, 126, '2015-01-15 00:04:27.000000', 'consum', 0.0213, 'lps'),
	(371304, 126, '2015-01-15 00:04:28.000000', 'consum', 0.0212, 'lps'),
	(371305, 126, '2015-01-15 00:04:29.000000', 'consum', 0.0214, 'lps'),
	(371306, 126, '2015-01-15 00:04:30.000000', 'consum', 0.0225, 'lps'),
	(371307, 126, '2015-01-15 00:04:31.000000', 'consum', 0.0213, 'lps'),
	(371308, 126, '2015-01-15 00:04:32.000000', 'consum', 0.0221, 'lps'),
	(371309, 126, '2015-01-15 00:04:33.000000', 'consum', 0.0219, 'lps'),
	(371310, 126, '2015-01-15 00:04:34.000000', 'consum', 0.0223, 'lps'),
	(371311, 126, '2015-01-15 00:04:35.000000', 'consum', 0.0227, 'lps'),
	(371312, 126, '2015-01-15 00:04:36.000000', 'consum', 0.0221, 'lps'),
	(371313, 126, '2015-01-15 00:04:37.000000', 'consum', 0.0214, 'lps'),
	(371314, 126, '2015-01-15 00:04:38.000000', 'consum', 0.0215, 'lps'),
	(371315, 126, '2015-01-15 00:04:39.000000', 'consum', 0.0223, 'lps'),
	(371316, 126, '2015-01-15 00:04:40.000000', 'consum', 0.0222, 'lps'),
	(371317, 126, '2015-01-15 00:04:41.000000', 'consum', 0.0213, 'lps'),
	(371318, 126, '2015-01-15 00:04:42.000000', 'consum', 0.0228, 'lps'),
	(371319, 126, '2015-01-15 00:04:43.000000', 'consum', 0.0213, 'lps'),
	(371320, 126, '2015-01-15 00:04:44.000000', 'consum', 0.0213, 'lps'),
	(371321, 126, '2015-01-15 00:04:45.000000', 'consum', 0.0214, 'lps'),
	(371322, 126, '2015-01-15 00:04:46.000000', 'consum', 0.0224, 'lps'),
	(371323, 126, '2015-01-15 00:04:47.000000', 'consum', 0.0210, 'lps'),
	(371324, 126, '2015-01-15 00:04:48.000000', 'consum', 0.0226, 'lps'),
	(371325, 126, '2015-01-15 00:04:49.000000', 'consum', 0.0216, 'lps'),
	(371326, 126, '2015-01-15 00:04:50.000000', 'consum', 0.0210, 'lps'),
	(371327, 126, '2015-01-15 00:04:51.000000', 'consum', 0.0212, 'lps'),
	(371328, 126, '2015-01-15 00:04:52.000000', 'consum', 0.0220, 'lps'),
	(371329, 126, '2015-01-15 00:04:53.000000', 'consum', 0.0215, 'lps'),
	(371330, 126, '2015-01-15 00:04:54.000000', 'consum', 0.0225, 'lps'),
	(371331, 126, '2015-01-15 00:04:55.000000', 'consum', 0.0215, 'lps'),
	(371332, 126, '2015-01-15 00:04:56.000000', 'consum', 0.0210, 'lps'),
	(371333, 126, '2015-01-15 00:04:57.000000', 'consum', 0.0216, 'lps'),
	(371334, 126, '2015-01-15 00:04:58.000000', 'consum', 0.0218, 'lps'),
	(371335, 126, '2015-01-15 00:04:59.000000', 'consum', 0.0216, 'lps'),
	(371336, 126, '2015-01-15 00:05:00.000000', 'consum', 0.0216, 'lps'),
	(371337, 126, '2015-01-15 00:05:01.000000', 'consum', 0.0221, 'lps'),
	(371338, 126, '2015-01-15 00:05:02.000000', 'consum', 0.0228, 'lps'),
	(371339, 126, '2015-01-15 00:05:03.000000', 'consum', 0.0212, 'lps'),
	(371340, 126, '2015-01-15 00:05:04.000000', 'consum', 0.0223, 'lps'),
	(371341, 126, '2015-01-15 00:05:05.000000', 'consum', 0.0214, 'lps'),
	(371342, 126, '2015-01-15 00:05:06.000000', 'consum', 0.0210, 'lps'),
	(371343, 126, '2015-01-15 00:05:07.000000', 'consum', 0.0217, 'lps'),
	(371344, 126, '2015-01-15 00:05:08.000000', 'consum', 0.0225, 'lps'),
	(371345, 126, '2015-01-15 00:05:09.000000', 'consum', 0.0227, 'lps'),
	(371346, 126, '2015-01-15 00:05:10.000000', 'consum', 0.0214, 'lps'),
	(371347, 126, '2015-01-15 00:05:11.000000', 'consum', 0.0216, 'lps'),
	(371348, 126, '2015-01-15 00:05:12.000000', 'consum', 0.0210, 'lps'),
	(371349, 126, '2015-01-15 00:05:13.000000', 'consum', 0.0213, 'lps'),
	(371350, 126, '2015-01-15 00:05:14.000000', 'consum', 0.0224, 'lps'),
	(371351, 126, '2015-01-15 00:05:15.000000', 'consum', 0.0214, 'lps'),
	(371352, 126, '2015-01-15 00:05:16.000000', 'consum', 0.0228, 'lps'),
	(371353, 126, '2015-01-15 00:05:17.000000', 'consum', 0.0210, 'lps'),
	(371354, 126, '2015-01-15 00:05:18.000000', 'consum', 0.0215, 'lps'),
	(371355, 126, '2015-01-15 00:05:19.000000', 'consum', 0.0218, 'lps'),
	(371356, 126, '2015-01-15 00:05:20.000000', 'consum', 0.0214, 'lps'),
	(371357, 126, '2015-01-15 00:05:21.000000', 'consum', 0.0225, 'lps'),
	(371358, 126, '2015-01-15 00:05:22.000000', 'consum', 0.0218, 'lps'),
	(371359, 126, '2015-01-15 00:05:23.000000', 'consum', 0.0225, 'lps'),
	(371360, 126, '2015-01-15 00:05:24.000000', 'consum', 0.0222, 'lps'),
	(371361, 126, '2015-01-15 00:05:25.000000', 'consum', 0.0228, 'lps'),
	(371362, 126, '2015-01-15 00:05:26.000000', 'consum', 0.0226, 'lps'),
	(371363, 126, '2015-01-15 00:05:27.000000', 'consum', 0.0218, 'lps'),
	(371364, 126, '2015-01-15 00:05:28.000000', 'consum', 0.0222, 'lps'),
	(371365, 126, '2015-01-15 00:05:29.000000', 'consum', 0.0227, 'lps'),
	(371366, 126, '2015-01-15 00:05:30.000000', 'consum', 0.0223, 'lps'),
	(371367, 126, '2015-01-15 00:05:31.000000', 'consum', 0.0222, 'lps'),
	(371368, 126, '2015-01-15 00:05:32.000000', 'consum', 0.0213, 'lps'),
	(371369, 126, '2015-01-15 00:05:33.000000', 'consum', 0.0228, 'lps'),
	(371370, 126, '2015-01-15 00:05:34.000000', 'consum', 0.0215, 'lps'),
	(371371, 126, '2015-01-15 00:05:35.000000', 'consum', 0.0219, 'lps'),
	(371372, 126, '2015-01-15 00:05:36.000000', 'consum', 0.0221, 'lps'),
	(371373, 126, '2015-01-15 00:05:37.000000', 'consum', 0.0221, 'lps'),
	(371374, 126, '2015-01-15 00:05:38.000000', 'consum', 0.0213, 'lps'),
	(371375, 126, '2015-01-15 00:05:39.000000', 'consum', 0.0212, 'lps'),
	(371376, 126, '2015-01-15 00:05:40.000000', 'consum', 0.0213, 'lps'),
	(371377, 126, '2015-01-15 00:05:41.000000', 'consum', 0.0216, 'lps'),
	(371378, 126, '2015-01-15 00:05:42.000000', 'consum', 0.0215, 'lps'),
	(371379, 126, '2015-01-15 00:05:43.000000', 'consum', 0.0216, 'lps'),
	(371380, 126, '2015-01-15 00:05:44.000000', 'consum', 0.0226, 'lps'),
	(371381, 126, '2015-01-15 00:05:45.000000', 'consum', 0.0217, 'lps'),
	(371382, 126, '2015-01-15 00:05:46.000000', 'consum', 0.0216, 'lps'),
	(371383, 126, '2015-01-15 00:05:47.000000', 'consum', 0.0219, 'lps'),
	(371384, 126, '2015-01-15 00:05:48.000000', 'consum', 0.0218, 'lps'),
	(371385, 126, '2015-01-15 00:05:49.000000', 'consum', 0.0223, 'lps'),
	(371386, 126, '2015-01-15 00:05:50.000000', 'consum', 0.0212, 'lps'),
	(371387, 126, '2015-01-15 00:05:51.000000', 'consum', 0.0222, 'lps'),
	(371388, 126, '2015-01-15 00:05:52.000000', 'consum', 0.0227, 'lps'),
	(371389, 126, '2015-01-15 00:05:53.000000', 'consum', 0.0221, 'lps'),
	(371390, 126, '2015-01-15 00:05:54.000000', 'consum', 0.0213, 'lps'),
	(371391, 126, '2015-01-15 00:05:55.000000', 'consum', 0.0211, 'lps'),
	(371392, 126, '2015-01-15 00:05:56.000000', 'consum', 0.0225, 'lps'),
	(371393, 126, '2015-01-15 00:05:57.000000', 'consum', 0.0227, 'lps'),
	(371394, 126, '2015-01-15 00:05:58.000000', 'consum', 0.0213, 'lps'),
	(371395, 126, '2015-01-15 00:05:59.000000', 'consum', 0.0214, 'lps'),
	(371396, 126, '2015-01-15 00:06:00.000000', 'consum', 0.0219, 'lps'),
	(371397, 126, '2015-01-15 00:06:01.000000', 'consum', 0.0226, 'lps'),
	(371398, 126, '2015-01-15 00:06:02.000000', 'consum', 0.0225, 'lps'),
	(371399, 126, '2015-01-15 00:06:03.000000', 'consum', 0.0219, 'lps'),
	(371400, 126, '2015-01-15 00:06:04.000000', 'consum', 0.0227, 'lps'),
	(371401, 126, '2015-01-15 00:06:05.000000', 'consum', 0.0213, 'lps'),
	(371402, 126, '2015-01-15 00:06:06.000000', 'consum', 0.0212, 'lps'),
	(371403, 126, '2015-01-15 00:06:07.000000', 'consum', 0.0214, 'lps'),
	(371404, 126, '2015-01-15 00:06:08.000000', 'consum', 0.0223, 'lps'),
	(371405, 126, '2015-01-15 00:06:09.000000', 'consum', 0.0223, 'lps'),
	(371406, 126, '2015-01-15 00:06:10.000000', 'consum', 0.0221, 'lps'),
	(371407, 126, '2015-01-15 00:06:11.000000', 'consum', 0.0224, 'lps'),
	(371408, 126, '2015-01-15 00:06:12.000000', 'consum', 0.0211, 'lps'),
	(371409, 126, '2015-01-15 00:06:13.000000', 'consum', 0.0213, 'lps'),
	(371410, 126, '2015-01-15 00:06:14.000000', 'consum', 0.0220, 'lps'),
	(371411, 126, '2015-01-15 00:06:15.000000', 'consum', 0.0216, 'lps'),
	(371412, 126, '2015-01-15 00:06:16.000000', 'consum', 0.0228, 'lps'),
	(371413, 126, '2015-01-15 00:06:17.000000', 'consum', 0.0227, 'lps'),
	(371414, 126, '2015-01-15 00:06:18.000000', 'consum', 0.0223, 'lps'),
	(371415, 126, '2015-01-15 00:06:19.000000', 'consum', 0.0223, 'lps'),
	(371416, 126, '2015-01-15 00:06:20.000000', 'consum', 0.0217, 'lps'),
	(371417, 126, '2015-01-15 00:06:21.000000', 'consum', 0.0225, 'lps'),
	(371418, 126, '2015-01-15 00:06:22.000000', 'consum', 0.0226, 'lps'),
	(371419, 126, '2015-01-15 00:06:23.000000', 'consum', 0.0226, 'lps'),
	(371420, 126, '2015-01-15 00:06:24.000000', 'consum', 0.0224, 'lps'),
	(371421, 126, '2015-01-15 00:06:25.000000', 'consum', 0.0214, 'lps'),
	(371422, 126, '2015-01-15 00:06:26.000000', 'consum', 0.0225, 'lps'),
	(371423, 126, '2015-01-15 00:06:27.000000', 'consum', 0.0219, 'lps'),
	(371424, 126, '2015-01-15 00:06:28.000000', 'consum', 0.0210, 'lps'),
	(371425, 126, '2015-01-15 00:06:29.000000', 'consum', 0.0222, 'lps'),
	(371426, 126, '2015-01-15 00:06:30.000000', 'consum', 0.0214, 'lps'),
	(371427, 126, '2015-01-15 00:06:31.000000', 'consum', 0.0214, 'lps'),
	(371428, 126, '2015-01-15 00:06:32.000000', 'consum', 0.0219, 'lps'),
	(371429, 126, '2015-01-15 00:06:33.000000', 'consum', 0.0225, 'lps'),
	(371430, 126, '2015-01-15 00:06:34.000000', 'consum', 0.0221, 'lps'),
	(371431, 126, '2015-01-15 00:06:35.000000', 'consum', 0.0221, 'lps'),
	(371432, 126, '2015-01-15 00:06:36.000000', 'consum', 0.0214, 'lps'),
	(371433, 126, '2015-01-15 00:06:37.000000', 'consum', 0.0216, 'lps'),
	(371434, 126, '2015-01-15 00:06:38.000000', 'consum', 0.0210, 'lps'),
	(371435, 126, '2015-01-15 00:06:39.000000', 'consum', 0.0212, 'lps'),
	(371436, 126, '2015-01-15 00:06:40.000000', 'consum', 0.0219, 'lps'),
	(371437, 126, '2015-01-15 00:06:41.000000', 'consum', 0.0211, 'lps'),
	(371438, 126, '2015-01-15 00:06:42.000000', 'consum', 0.0225, 'lps'),
	(371439, 126, '2015-01-15 00:06:43.000000', 'consum', 0.0228, 'lps'),
	(371440, 126, '2015-01-15 00:06:44.000000', 'consum', 0.0215, 'lps'),
	(371441, 126, '2015-01-15 00:06:45.000000', 'consum', 0.0223, 'lps'),
	(371442, 126, '2015-01-15 00:06:46.000000', 'consum', 0.0220, 'lps'),
	(371443, 126, '2015-01-15 00:06:47.000000', 'consum', 0.0222, 'lps'),
	(371444, 126, '2015-01-15 00:06:48.000000', 'consum', 0.0221, 'lps'),
	(371445, 126, '2015-01-15 00:06:49.000000', 'consum', 0.0211, 'lps'),
	(371446, 126, '2015-01-15 00:06:50.000000', 'consum', 0.0219, 'lps'),
	(371447, 126, '2015-01-15 00:06:51.000000', 'consum', 0.0215, 'lps'),
	(371448, 126, '2015-01-15 00:06:52.000000', 'consum', 0.0228, 'lps'),
	(371449, 126, '2015-01-15 00:06:53.000000', 'consum', 0.0227, 'lps'),
	(371450, 126, '2015-01-15 00:06:54.000000', 'consum', 0.0222, 'lps'),
	(371451, 126, '2015-01-15 00:06:55.000000', 'consum', 0.0221, 'lps'),
	(371452, 126, '2015-01-15 00:06:56.000000', 'consum', 0.0212, 'lps'),
	(371453, 126, '2015-01-15 00:06:57.000000', 'consum', 0.0223, 'lps'),
	(371454, 126, '2015-01-15 00:06:58.000000', 'consum', 0.0215, 'lps'),
	(371455, 126, '2015-01-15 00:06:59.000000', 'consum', 0.0213, 'lps'),
	(371456, 126, '2015-01-15 00:07:00.000000', 'consum', 0.0214, 'lps'),
	(371457, 126, '2015-01-15 00:07:01.000000', 'consum', 0.0218, 'lps'),
	(371458, 126, '2015-01-15 00:07:02.000000', 'consum', 0.0220, 'lps'),
	(371459, 126, '2015-01-15 00:07:03.000000', 'consum', 0.0218, 'lps'),
	(371460, 126, '2015-01-15 00:07:04.000000', 'consum', 0.0221, 'lps'),
	(371461, 126, '2015-01-15 00:07:05.000000', 'consum', 0.0221, 'lps'),
	(371462, 126, '2015-01-15 00:07:06.000000', 'consum', 0.0215, 'lps'),
	(371463, 126, '2015-01-15 00:07:07.000000', 'consum', 0.0220, 'lps'),
	(371464, 126, '2015-01-15 00:07:08.000000', 'consum', 0.0227, 'lps'),
	(371465, 126, '2015-01-15 00:07:09.000000', 'consum', 0.0226, 'lps'),
	(371466, 126, '2015-01-15 00:07:10.000000', 'consum', 0.0221, 'lps'),
	(371467, 126, '2015-01-15 00:07:11.000000', 'consum', 0.0219, 'lps'),
	(371468, 126, '2015-01-15 00:07:12.000000', 'consum', 0.0221, 'lps'),
	(371469, 126, '2015-01-15 00:07:13.000000', 'consum', 0.0219, 'lps'),
	(371470, 126, '2015-01-15 00:07:14.000000', 'consum', 0.0223, 'lps'),
	(371471, 126, '2015-01-15 00:07:15.000000', 'consum', 0.0211, 'lps'),
	(371472, 126, '2015-01-15 00:07:16.000000', 'consum', 0.0215, 'lps'),
	(371473, 126, '2015-01-15 00:07:17.000000', 'consum', 0.0213, 'lps'),
	(371474, 126, '2015-01-15 00:07:18.000000', 'consum', 0.0211, 'lps'),
	(371475, 126, '2015-01-15 00:07:19.000000', 'consum', 0.0227, 'lps'),
	(371476, 126, '2015-01-15 00:07:20.000000', 'consum', 0.0215, 'lps'),
	(371477, 126, '2015-01-15 00:07:21.000000', 'consum', 0.0223, 'lps'),
	(371478, 126, '2015-01-15 00:07:22.000000', 'consum', 0.0221, 'lps'),
	(371479, 126, '2015-01-15 00:07:23.000000', 'consum', 0.0227, 'lps'),
	(371480, 126, '2015-01-15 00:07:24.000000', 'consum', 0.0224, 'lps'),
	(371481, 126, '2015-01-15 00:07:25.000000', 'consum', 0.0213, 'lps'),
	(371482, 126, '2015-01-15 00:07:26.000000', 'consum', 0.0221, 'lps'),
	(371483, 126, '2015-01-15 00:07:27.000000', 'consum', 0.0216, 'lps'),
	(371484, 126, '2015-01-15 00:07:28.000000', 'consum', 0.0210, 'lps'),
	(371485, 126, '2015-01-15 00:07:29.000000', 'consum', 0.0228, 'lps'),
	(371486, 126, '2015-01-15 00:07:30.000000', 'consum', 0.0224, 'lps'),
	(371487, 126, '2015-01-15 00:07:31.000000', 'consum', 0.0210, 'lps'),
	(371488, 126, '2015-01-15 00:07:32.000000', 'consum', 0.0226, 'lps'),
	(371489, 126, '2015-01-15 00:07:33.000000', 'consum', 0.0214, 'lps'),
	(371490, 126, '2015-01-15 00:07:34.000000', 'consum', 0.0220, 'lps'),
	(371491, 126, '2015-01-15 00:07:35.000000', 'consum', 0.0212, 'lps'),
	(371492, 126, '2015-01-15 00:07:36.000000', 'consum', 0.0227, 'lps'),
	(371493, 126, '2015-01-15 00:07:37.000000', 'consum', 0.0213, 'lps'),
	(371494, 126, '2015-01-15 00:07:38.000000', 'consum', 0.0215, 'lps'),
	(371495, 126, '2015-01-15 00:07:39.000000', 'consum', 0.0223, 'lps'),
	(371496, 126, '2015-01-15 00:07:40.000000', 'consum', 0.0226, 'lps'),
	(371497, 126, '2015-01-15 00:07:41.000000', 'consum', 0.0212, 'lps'),
	(371498, 126, '2015-01-15 00:07:42.000000', 'consum', 0.0228, 'lps'),
	(371499, 126, '2015-01-15 00:07:43.000000', 'consum', 0.0220, 'lps'),
	(371500, 126, '2015-01-15 00:07:44.000000', 'consum', 0.0223, 'lps'),
	(371501, 126, '2015-01-15 00:07:45.000000', 'consum', 0.0211, 'lps'),
	(371502, 126, '2015-01-15 00:07:46.000000', 'consum', 0.0212, 'lps'),
	(371503, 126, '2015-01-15 00:07:47.000000', 'consum', 0.0217, 'lps'),
	(371504, 126, '2015-01-15 00:07:48.000000', 'consum', 0.0220, 'lps'),
	(371505, 126, '2015-01-15 00:07:49.000000', 'consum', 0.0222, 'lps'),
	(371506, 126, '2015-01-15 00:07:50.000000', 'consum', 0.0219, 'lps'),
	(371507, 126, '2015-01-15 00:07:51.000000', 'consum', 0.0223, 'lps'),
	(371508, 126, '2015-01-15 00:07:52.000000', 'consum', 0.0228, 'lps'),
	(371509, 126, '2015-01-15 00:07:53.000000', 'consum', 0.0223, 'lps'),
	(371510, 126, '2015-01-15 00:07:54.000000', 'consum', 0.0221, 'lps'),
	(371511, 126, '2015-01-15 00:07:55.000000', 'consum', 0.0228, 'lps'),
	(371512, 126, '2015-01-15 00:07:56.000000', 'consum', 0.0210, 'lps'),
	(371513, 126, '2015-01-15 00:07:57.000000', 'consum', 0.0213, 'lps'),
	(371514, 126, '2015-01-15 00:07:58.000000', 'consum', 0.0225, 'lps'),
	(371515, 126, '2015-01-15 00:07:59.000000', 'consum', 0.0221, 'lps'),
	(371516, 126, '2015-01-15 00:08:00.000000', 'consum', 0.0221, 'lps'),
	(371517, 126, '2015-01-15 00:08:01.000000', 'consum', 0.0212, 'lps'),
	(371518, 126, '2015-01-15 00:08:02.000000', 'consum', 0.0225, 'lps'),
	(371519, 126, '2015-01-15 00:08:03.000000', 'consum', 0.0224, 'lps'),
	(371520, 126, '2015-01-15 00:08:04.000000', 'consum', 0.0215, 'lps'),
	(371521, 126, '2015-01-15 00:08:05.000000', 'consum', 0.0213, 'lps'),
	(371522, 126, '2015-01-15 00:08:06.000000', 'consum', 0.0228, 'lps'),
	(371523, 126, '2015-01-15 00:08:07.000000', 'consum', 0.0218, 'lps'),
	(371524, 126, '2015-01-15 00:08:08.000000', 'consum', 0.0216, 'lps'),
	(371525, 126, '2015-01-15 00:08:09.000000', 'consum', 0.0214, 'lps'),
	(371526, 126, '2015-01-15 00:08:10.000000', 'consum', 0.0215, 'lps'),
	(371527, 126, '2015-01-15 00:08:11.000000', 'consum', 0.0222, 'lps'),
	(371528, 126, '2015-01-15 00:08:12.000000', 'consum', 0.0217, 'lps'),
	(371529, 126, '2015-01-15 00:08:13.000000', 'consum', 0.0211, 'lps'),
	(371530, 126, '2015-01-15 00:08:14.000000', 'consum', 0.0214, 'lps'),
	(371531, 126, '2015-01-15 00:08:15.000000', 'consum', 0.0226, 'lps'),
	(371532, 126, '2015-01-15 00:08:16.000000', 'consum', 0.0222, 'lps'),
	(371533, 126, '2015-01-15 00:08:17.000000', 'consum', 0.0224, 'lps'),
	(371534, 126, '2015-01-15 00:08:18.000000', 'consum', 0.0225, 'lps'),
	(371535, 126, '2015-01-15 00:08:19.000000', 'consum', 0.0224, 'lps'),
	(371536, 126, '2015-01-15 00:08:20.000000', 'consum', 0.0215, 'lps'),
	(371537, 126, '2015-01-15 00:08:21.000000', 'consum', 0.0213, 'lps'),
	(371538, 126, '2015-01-15 00:08:22.000000', 'consum', 0.0211, 'lps'),
	(371539, 126, '2015-01-15 00:08:23.000000', 'consum', 0.0225, 'lps'),
	(371540, 126, '2015-01-15 00:08:24.000000', 'consum', 0.0224, 'lps'),
	(371541, 126, '2015-01-15 00:08:25.000000', 'consum', 0.0218, 'lps'),
	(371542, 126, '2015-01-15 00:08:26.000000', 'consum', 0.0226, 'lps'),
	(371543, 126, '2015-01-15 00:08:27.000000', 'consum', 0.0211, 'lps'),
	(371544, 126, '2015-01-15 00:08:28.000000', 'consum', 0.0222, 'lps'),
	(371545, 126, '2015-01-15 00:08:29.000000', 'consum', 0.0213, 'lps'),
	(371546, 126, '2015-01-15 00:08:30.000000', 'consum', 0.0228, 'lps'),
	(371547, 126, '2015-01-15 00:08:31.000000', 'consum', 0.0216, 'lps'),
	(371548, 126, '2015-01-15 00:08:32.000000', 'consum', 0.0226, 'lps'),
	(371549, 126, '2015-01-15 00:08:33.000000', 'consum', 0.0212, 'lps'),
	(371550, 126, '2015-01-15 00:08:34.000000', 'consum', 0.0212, 'lps'),
	(371551, 126, '2015-01-15 00:08:35.000000', 'consum', 0.0212, 'lps'),
	(371552, 126, '2015-01-15 00:08:36.000000', 'consum', 0.0218, 'lps'),
	(371553, 126, '2015-01-15 00:08:37.000000', 'consum', 0.0225, 'lps'),
	(371554, 126, '2015-01-15 00:08:38.000000', 'consum', 0.0224, 'lps'),
	(371555, 126, '2015-01-15 00:08:39.000000', 'consum', 0.0217, 'lps'),
	(371556, 126, '2015-01-15 00:08:40.000000', 'consum', 0.0220, 'lps'),
	(371557, 126, '2015-01-15 00:08:41.000000', 'consum', 0.0221, 'lps'),
	(371558, 126, '2015-01-15 00:08:42.000000', 'consum', 0.0216, 'lps'),
	(371559, 126, '2015-01-15 00:08:43.000000', 'consum', 0.0228, 'lps'),
	(371560, 126, '2015-01-15 00:08:44.000000', 'consum', 0.0224, 'lps'),
	(371561, 126, '2015-01-15 00:08:45.000000', 'consum', 0.0227, 'lps'),
	(371562, 126, '2015-01-15 00:08:46.000000', 'consum', 0.0216, 'lps'),
	(371563, 126, '2015-01-15 00:08:47.000000', 'consum', 0.0228, 'lps'),
	(371564, 126, '2015-01-15 00:08:48.000000', 'consum', 0.0224, 'lps'),
	(371565, 126, '2015-01-15 00:08:49.000000', 'consum', 0.0227, 'lps'),
	(371566, 126, '2015-01-15 00:08:50.000000', 'consum', 0.0217, 'lps'),
	(371567, 126, '2015-01-15 00:08:51.000000', 'consum', 0.0213, 'lps'),
	(371568, 126, '2015-01-15 00:08:52.000000', 'consum', 0.0224, 'lps'),
	(371569, 126, '2015-01-15 00:08:53.000000', 'consum', 0.0215, 'lps'),
	(371570, 126, '2015-01-15 00:08:54.000000', 'consum', 0.0212, 'lps'),
	(371571, 126, '2015-01-15 00:08:55.000000', 'consum', 0.0226, 'lps'),
	(371572, 126, '2015-01-15 00:08:56.000000', 'consum', 0.0226, 'lps'),
	(371573, 126, '2015-01-15 00:08:57.000000', 'consum', 0.0224, 'lps'),
	(371574, 126, '2015-01-15 00:08:58.000000', 'consum', 0.0214, 'lps'),
	(371575, 126, '2015-01-15 00:08:59.000000', 'consum', 0.0225, 'lps'),
	(371576, 126, '2015-01-15 00:09:00.000000', 'consum', 0.0218, 'lps'),
	(371577, 126, '2015-01-15 00:09:01.000000', 'consum', 0.0223, 'lps'),
	(371578, 126, '2015-01-15 00:09:02.000000', 'consum', 0.0212, 'lps'),
	(371579, 126, '2015-01-15 00:09:03.000000', 'consum', 0.0222, 'lps'),
	(371580, 126, '2015-01-15 00:09:04.000000', 'consum', 0.0226, 'lps'),
	(371581, 126, '2015-01-15 00:09:05.000000', 'consum', 0.0216, 'lps'),
	(371582, 126, '2015-01-15 00:09:06.000000', 'consum', 0.0214, 'lps'),
	(371583, 126, '2015-01-15 00:09:07.000000', 'consum', 0.0228, 'lps'),
	(371584, 126, '2015-01-15 00:09:08.000000', 'consum', 0.0216, 'lps'),
	(371585, 126, '2015-01-15 00:09:09.000000', 'consum', 0.0221, 'lps'),
	(371586, 126, '2015-01-15 00:09:10.000000', 'consum', 0.0211, 'lps'),
	(371587, 126, '2015-01-15 00:09:11.000000', 'consum', 0.0220, 'lps'),
	(371588, 126, '2015-01-15 00:09:12.000000', 'consum', 0.0222, 'lps'),
	(371589, 126, '2015-01-15 00:09:13.000000', 'consum', 0.0218, 'lps'),
	(371590, 126, '2015-01-15 00:09:14.000000', 'consum', 0.0218, 'lps'),
	(371591, 126, '2015-01-15 00:09:15.000000', 'consum', 0.0223, 'lps'),
	(371592, 126, '2015-01-15 00:09:16.000000', 'consum', 0.0217, 'lps'),
	(371593, 126, '2015-01-15 00:09:17.000000', 'consum', 0.0223, 'lps'),
	(371594, 126, '2015-01-15 00:09:18.000000', 'consum', 0.0216, 'lps'),
	(371595, 126, '2015-01-15 00:09:19.000000', 'consum', 0.0222, 'lps'),
	(371596, 126, '2015-01-15 00:09:20.000000', 'consum', 0.0216, 'lps'),
	(371597, 126, '2015-01-15 00:09:21.000000', 'consum', 0.0221, 'lps'),
	(371598, 126, '2015-01-15 00:09:22.000000', 'consum', 0.0210, 'lps'),
	(371599, 126, '2015-01-15 00:09:23.000000', 'consum', 0.0217, 'lps'),
	(371600, 126, '2015-01-15 00:09:24.000000', 'consum', 0.0224, 'lps'),
	(371601, 126, '2015-01-15 00:09:25.000000', 'consum', 0.0224, 'lps'),
	(371602, 126, '2015-01-15 00:09:26.000000', 'consum', 0.0218, 'lps'),
	(371603, 126, '2015-01-15 00:09:27.000000', 'consum', 0.0210, 'lps'),
	(371604, 126, '2015-01-15 00:09:28.000000', 'consum', 0.0222, 'lps'),
	(371605, 126, '2015-01-15 00:09:29.000000', 'consum', 0.0216, 'lps'),
	(371606, 126, '2015-01-15 00:09:30.000000', 'consum', 0.0223, 'lps'),
	(371607, 126, '2015-01-15 00:09:31.000000', 'consum', 0.0217, 'lps'),
	(371608, 126, '2015-01-15 00:09:32.000000', 'consum', 0.0228, 'lps'),
	(371609, 126, '2015-01-15 00:09:33.000000', 'consum', 0.0224, 'lps'),
	(371610, 126, '2015-01-15 00:09:34.000000', 'consum', 0.0223, 'lps'),
	(371611, 126, '2015-01-15 00:09:35.000000', 'consum', 0.0218, 'lps'),
	(371612, 126, '2015-01-15 00:09:36.000000', 'consum', 0.0210, 'lps'),
	(371613, 126, '2015-01-15 00:09:37.000000', 'consum', 0.0224, 'lps'),
	(371614, 126, '2015-01-15 00:09:38.000000', 'consum', 0.0223, 'lps'),
	(371615, 126, '2015-01-15 00:09:39.000000', 'consum', 0.0214, 'lps'),
	(371616, 126, '2015-01-15 00:09:40.000000', 'consum', 0.0210, 'lps'),
	(371617, 126, '2015-01-15 00:09:41.000000', 'consum', 0.0219, 'lps'),
	(371618, 126, '2015-01-15 00:09:42.000000', 'consum', 0.0215, 'lps'),
	(371619, 126, '2015-01-15 00:09:43.000000', 'consum', 0.0211, 'lps'),
	(371620, 126, '2015-01-15 00:09:44.000000', 'consum', 0.0217, 'lps'),
	(371621, 126, '2015-01-15 00:09:45.000000', 'consum', 0.0225, 'lps'),
	(371622, 126, '2015-01-15 00:09:46.000000', 'consum', 0.0228, 'lps'),
	(371623, 126, '2015-01-15 00:09:47.000000', 'consum', 0.0214, 'lps'),
	(371624, 126, '2015-01-15 00:09:48.000000', 'consum', 0.0217, 'lps'),
	(371625, 126, '2015-01-15 00:09:49.000000', 'consum', 0.0214, 'lps'),
	(371626, 126, '2015-01-15 00:09:50.000000', 'consum', 0.0210, 'lps'),
	(371627, 126, '2015-01-15 00:09:51.000000', 'consum', 0.0219, 'lps'),
	(371628, 126, '2015-01-15 00:09:52.000000', 'consum', 0.0217, 'lps'),
	(371629, 126, '2015-01-15 00:09:53.000000', 'consum', 0.0218, 'lps'),
	(371630, 126, '2015-01-15 00:09:54.000000', 'consum', 0.0210, 'lps'),
	(371631, 126, '2015-01-15 00:09:55.000000', 'consum', 0.0225, 'lps'),
	(371632, 126, '2015-01-15 00:09:56.000000', 'consum', 0.0211, 'lps'),
	(371633, 126, '2015-01-15 00:09:57.000000', 'consum', 0.0226, 'lps'),
	(371634, 126, '2015-01-15 00:09:58.000000', 'consum', 0.0213, 'lps'),
	(371635, 126, '2015-01-15 00:09:59.000000', 'consum', 0.0215, 'lps'),
	(371636, 126, '2015-01-15 00:10:00.000000', 'consum', 0.0225, 'lps'),
	(371637, 126, '2015-01-15 00:10:01.000000', 'consum', 0.0213, 'lps'),
	(371638, 126, '2015-01-15 00:10:02.000000', 'consum', 0.0221, 'lps'),
	(371639, 126, '2015-01-15 00:10:03.000000', 'consum', 0.0216, 'lps'),
	(371640, 126, '2015-01-15 00:10:04.000000', 'consum', 0.0210, 'lps'),
	(371641, 126, '2015-01-15 00:10:05.000000', 'consum', 0.0211, 'lps'),
	(371642, 126, '2015-01-15 00:10:06.000000', 'consum', 0.0213, 'lps'),
	(371643, 126, '2015-01-15 00:10:07.000000', 'consum', 0.0225, 'lps'),
	(371644, 126, '2015-01-15 00:10:08.000000', 'consum', 0.0217, 'lps'),
	(371645, 126, '2015-01-15 00:10:09.000000', 'consum', 0.0221, 'lps'),
	(371646, 126, '2015-01-15 00:10:10.000000', 'consum', 0.0223, 'lps'),
	(371647, 126, '2015-01-15 00:10:11.000000', 'consum', 0.0226, 'lps'),
	(371648, 126, '2015-01-15 00:10:12.000000', 'consum', 0.0212, 'lps'),
	(371649, 126, '2015-01-15 00:10:13.000000', 'consum', 0.0213, 'lps'),
	(371650, 126, '2015-01-15 00:10:14.000000', 'consum', 0.0218, 'lps'),
	(371651, 126, '2015-01-15 00:10:15.000000', 'consum', 0.0223, 'lps'),
	(371652, 126, '2015-01-15 00:10:16.000000', 'consum', 0.0212, 'lps'),
	(371653, 126, '2015-01-15 00:10:17.000000', 'consum', 0.0223, 'lps'),
	(371654, 126, '2015-01-15 00:10:18.000000', 'consum', 0.0228, 'lps'),
	(371655, 126, '2015-01-15 00:10:19.000000', 'consum', 0.0223, 'lps'),
	(371656, 126, '2015-01-15 00:10:20.000000', 'consum', 0.0222, 'lps'),
	(371657, 126, '2015-01-15 00:10:21.000000', 'consum', 0.0212, 'lps'),
	(371658, 126, '2015-01-15 00:10:22.000000', 'consum', 0.0222, 'lps'),
	(371659, 126, '2015-01-15 00:10:23.000000', 'consum', 0.0210, 'lps'),
	(371660, 126, '2015-01-15 00:10:24.000000', 'consum', 0.0211, 'lps'),
	(371661, 126, '2015-01-15 00:10:25.000000', 'consum', 0.0214, 'lps'),
	(371662, 126, '2015-01-15 00:10:26.000000', 'consum', 0.0212, 'lps'),
	(371663, 126, '2015-01-15 00:10:27.000000', 'consum', 0.0225, 'lps'),
	(371664, 126, '2015-01-15 00:10:28.000000', 'consum', 0.0221, 'lps'),
	(371665, 126, '2015-01-15 00:10:29.000000', 'consum', 0.0224, 'lps'),
	(371666, 126, '2015-01-15 00:10:30.000000', 'consum', 0.0226, 'lps'),
	(371667, 126, '2015-01-15 00:10:31.000000', 'consum', 0.0212, 'lps'),
	(371668, 126, '2015-01-15 00:10:32.000000', 'consum', 0.0228, 'lps'),
	(371669, 126, '2015-01-15 00:10:33.000000', 'consum', 0.0218, 'lps'),
	(371670, 126, '2015-01-15 00:10:34.000000', 'consum', 0.0216, 'lps'),
	(371671, 126, '2015-01-15 00:10:35.000000', 'consum', 0.0216, 'lps'),
	(371672, 126, '2015-01-15 00:10:36.000000', 'consum', 0.0221, 'lps'),
	(371673, 126, '2015-01-15 00:10:37.000000', 'consum', 0.0211, 'lps'),
	(371674, 126, '2015-01-15 00:10:38.000000', 'consum', 0.0221, 'lps'),
	(371675, 126, '2015-01-15 00:10:39.000000', 'consum', 0.0223, 'lps'),
	(371676, 126, '2015-01-15 00:10:40.000000', 'consum', 0.0225, 'lps'),
	(371677, 126, '2015-01-15 00:10:41.000000', 'consum', 0.0227, 'lps'),
	(371678, 126, '2015-01-15 00:10:42.000000', 'consum', 0.0213, 'lps'),
	(371679, 126, '2015-01-15 00:10:43.000000', 'consum', 0.0212, 'lps'),
	(371680, 126, '2015-01-15 00:10:44.000000', 'consum', 0.0210, 'lps'),
	(371681, 126, '2015-01-15 00:10:45.000000', 'consum', 0.0224, 'lps'),
	(371682, 126, '2015-01-15 00:10:46.000000', 'consum', 0.0225, 'lps'),
	(371683, 126, '2015-01-15 00:10:47.000000', 'consum', 0.0225, 'lps'),
	(371684, 126, '2015-01-15 00:10:48.000000', 'consum', 0.0219, 'lps'),
	(371685, 126, '2015-01-15 00:10:49.000000', 'consum', 0.0210, 'lps'),
	(371686, 126, '2015-01-15 00:10:50.000000', 'consum', 0.0222, 'lps'),
	(371687, 126, '2015-01-15 00:10:51.000000', 'consum', 0.0212, 'lps'),
	(371688, 126, '2015-01-15 00:10:52.000000', 'consum', 0.0225, 'lps'),
	(371689, 126, '2015-01-15 00:10:53.000000', 'consum', 0.0222, 'lps'),
	(371690, 126, '2015-01-15 00:10:54.000000', 'consum', 0.0225, 'lps'),
	(371691, 126, '2015-01-15 00:10:55.000000', 'consum', 0.0210, 'lps'),
	(371692, 126, '2015-01-15 00:10:56.000000', 'consum', 0.0223, 'lps'),
	(371693, 126, '2015-01-15 00:10:57.000000', 'consum', 0.0218, 'lps'),
	(371694, 126, '2015-01-15 00:10:58.000000', 'consum', 0.0212, 'lps'),
	(371695, 126, '2015-01-15 00:10:59.000000', 'consum', 0.0215, 'lps'),
	(371696, 126, '2015-01-15 00:11:00.000000', 'consum', 0.0212, 'lps'),
	(371697, 126, '2015-01-15 00:11:01.000000', 'consum', 0.0224, 'lps'),
	(371698, 126, '2015-01-15 00:11:02.000000', 'consum', 0.0219, 'lps'),
	(371699, 126, '2015-01-15 00:11:03.000000', 'consum', 0.0211, 'lps'),
	(371700, 126, '2015-01-15 00:11:04.000000', 'consum', 0.0226, 'lps'),
	(371701, 126, '2015-01-15 00:11:05.000000', 'consum', 0.0213, 'lps'),
	(371702, 126, '2015-01-15 00:11:06.000000', 'consum', 0.0216, 'lps'),
	(371703, 126, '2015-01-15 00:11:07.000000', 'consum', 0.0214, 'lps'),
	(371704, 126, '2015-01-15 00:11:08.000000', 'consum', 0.0210, 'lps'),
	(371705, 126, '2015-01-15 00:11:09.000000', 'consum', 0.0217, 'lps'),
	(371706, 126, '2015-01-15 00:11:10.000000', 'consum', 0.0228, 'lps'),
	(371707, 126, '2015-01-15 00:11:11.000000', 'consum', 0.0222, 'lps'),
	(371708, 126, '2015-01-15 00:11:12.000000', 'consum', 0.0214, 'lps'),
	(371709, 126, '2015-01-15 00:11:13.000000', 'consum', 0.0217, 'lps'),
	(371710, 126, '2015-01-15 00:11:14.000000', 'consum', 0.0215, 'lps'),
	(371711, 126, '2015-01-15 00:11:15.000000', 'consum', 0.0214, 'lps'),
	(371712, 126, '2015-01-15 00:11:16.000000', 'consum', 0.0213, 'lps'),
	(371713, 126, '2015-01-15 00:11:17.000000', 'consum', 0.0216, 'lps'),
	(371714, 126, '2015-01-15 00:11:18.000000', 'consum', 0.0214, 'lps'),
	(371715, 126, '2015-01-15 00:11:19.000000', 'consum', 0.0228, 'lps'),
	(371716, 126, '2015-01-15 00:11:20.000000', 'consum', 0.0213, 'lps'),
	(371717, 126, '2015-01-15 00:11:21.000000', 'consum', 0.0212, 'lps'),
	(371718, 126, '2015-01-15 00:11:22.000000', 'consum', 0.0227, 'lps'),
	(371719, 126, '2015-01-15 00:11:23.000000', 'consum', 0.0215, 'lps'),
	(371720, 126, '2015-01-15 00:11:24.000000', 'consum', 0.0223, 'lps'),
	(371721, 126, '2015-01-15 00:11:25.000000', 'consum', 0.0224, 'lps'),
	(371722, 126, '2015-01-15 00:11:26.000000', 'consum', 0.0222, 'lps'),
	(371723, 126, '2015-01-15 00:11:27.000000', 'consum', 0.0211, 'lps'),
	(371724, 126, '2015-01-15 00:11:28.000000', 'consum', 0.0214, 'lps'),
	(371725, 126, '2015-01-15 00:11:29.000000', 'consum', 0.0211, 'lps'),
	(371726, 126, '2015-01-15 00:11:30.000000', 'consum', 0.0223, 'lps'),
	(371727, 126, '2015-01-15 00:11:31.000000', 'consum', 0.0213, 'lps'),
	(371728, 126, '2015-01-15 00:11:32.000000', 'consum', 0.0226, 'lps'),
	(371729, 126, '2015-01-15 00:11:33.000000', 'consum', 0.0224, 'lps'),
	(371730, 126, '2015-01-15 00:11:34.000000', 'consum', 0.0212, 'lps'),
	(371731, 126, '2015-01-15 00:11:35.000000', 'consum', 0.0219, 'lps'),
	(371732, 126, '2015-01-15 00:11:36.000000', 'consum', 0.0228, 'lps'),
	(371733, 126, '2015-01-15 00:11:37.000000', 'consum', 0.0219, 'lps'),
	(371734, 126, '2015-01-15 00:11:38.000000', 'consum', 0.0219, 'lps'),
	(371735, 126, '2015-01-15 00:11:39.000000', 'consum', 0.0227, 'lps'),
	(371736, 126, '2015-01-15 00:11:40.000000', 'consum', 0.0215, 'lps'),
	(371737, 126, '2015-01-15 00:11:41.000000', 'consum', 0.0219, 'lps'),
	(371738, 126, '2015-01-15 00:11:42.000000', 'consum', 0.0224, 'lps'),
	(371739, 126, '2015-01-15 00:11:43.000000', 'consum', 0.0217, 'lps'),
	(371740, 126, '2015-01-15 00:11:44.000000', 'consum', 0.0219, 'lps'),
	(371741, 126, '2015-01-15 00:11:45.000000', 'consum', 0.0217, 'lps'),
	(371742, 126, '2015-01-15 00:11:46.000000', 'consum', 0.0220, 'lps'),
	(371743, 126, '2015-01-15 00:11:47.000000', 'consum', 0.0220, 'lps'),
	(371744, 126, '2015-01-15 00:11:48.000000', 'consum', 0.0213, 'lps'),
	(371745, 126, '2015-01-15 00:11:49.000000', 'consum', 0.0212, 'lps'),
	(371746, 126, '2015-01-15 00:11:50.000000', 'consum', 0.0214, 'lps'),
	(371747, 126, '2015-01-15 00:11:51.000000', 'consum', 0.0224, 'lps'),
	(371748, 126, '2015-01-15 00:11:52.000000', 'consum', 0.0211, 'lps'),
	(371749, 126, '2015-01-15 00:11:53.000000', 'consum', 0.0211, 'lps'),
	(371750, 126, '2015-01-15 00:11:54.000000', 'consum', 0.0213, 'lps'),
	(371751, 126, '2015-01-15 00:11:55.000000', 'consum', 0.0220, 'lps'),
	(371752, 126, '2015-01-15 00:11:56.000000', 'consum', 0.0217, 'lps'),
	(371753, 126, '2015-01-15 00:11:57.000000', 'consum', 0.0215, 'lps'),
	(371754, 126, '2015-01-15 00:11:58.000000', 'consum', 0.0213, 'lps'),
	(371755, 126, '2015-01-15 00:11:59.000000', 'consum', 0.0211, 'lps'),
	(371756, 126, '2015-01-15 00:12:00.000000', 'consum', 0.0226, 'lps'),
	(371757, 126, '2015-01-15 00:12:01.000000', 'consum', 0.0213, 'lps'),
	(371758, 126, '2015-01-15 00:12:02.000000', 'consum', 0.0213, 'lps'),
	(371759, 126, '2015-01-15 00:12:03.000000', 'consum', 0.0219, 'lps'),
	(371760, 126, '2015-01-15 00:12:04.000000', 'consum', 0.0226, 'lps'),
	(371761, 126, '2015-01-15 00:12:05.000000', 'consum', 0.0228, 'lps'),
	(371762, 126, '2015-01-15 00:12:06.000000', 'consum', 0.0212, 'lps'),
	(371763, 126, '2015-01-15 00:12:07.000000', 'consum', 0.0226, 'lps'),
	(371764, 126, '2015-01-15 00:12:08.000000', 'consum', 0.0225, 'lps'),
	(371765, 126, '2015-01-15 00:12:09.000000', 'consum', 0.0219, 'lps'),
	(371766, 126, '2015-01-15 00:12:10.000000', 'consum', 0.0213, 'lps'),
	(371767, 126, '2015-01-15 00:12:11.000000', 'consum', 0.0214, 'lps'),
	(371768, 126, '2015-01-15 00:12:12.000000', 'consum', 0.0223, 'lps'),
	(371769, 126, '2015-01-15 00:12:13.000000', 'consum', 0.0224, 'lps'),
	(371770, 126, '2015-01-15 00:12:14.000000', 'consum', 0.0225, 'lps'),
	(371771, 126, '2015-01-15 00:12:15.000000', 'consum', 0.0222, 'lps'),
	(371772, 126, '2015-01-15 00:12:16.000000', 'consum', 0.0225, 'lps'),
	(371773, 126, '2015-01-15 00:12:17.000000', 'consum', 0.0211, 'lps'),
	(371774, 126, '2015-01-15 00:12:18.000000', 'consum', 0.0211, 'lps'),
	(371775, 126, '2015-01-15 00:12:19.000000', 'consum', 0.0213, 'lps'),
	(371776, 126, '2015-01-15 00:12:20.000000', 'consum', 0.0222, 'lps'),
	(371777, 126, '2015-01-15 00:12:21.000000', 'consum', 0.0222, 'lps'),
	(371778, 126, '2015-01-15 00:12:22.000000', 'consum', 0.0217, 'lps'),
	(371779, 126, '2015-01-15 00:12:23.000000', 'consum', 0.0210, 'lps'),
	(371780, 126, '2015-01-15 00:12:24.000000', 'consum', 0.0226, 'lps'),
	(371781, 126, '2015-01-15 00:12:25.000000', 'consum', 0.0216, 'lps'),
	(371782, 126, '2015-01-15 00:12:26.000000', 'consum', 0.0211, 'lps'),
	(371783, 126, '2015-01-15 00:12:27.000000', 'consum', 0.0215, 'lps'),
	(371784, 126, '2015-01-15 00:12:28.000000', 'consum', 0.0214, 'lps'),
	(371785, 126, '2015-01-15 00:12:29.000000', 'consum', 0.0218, 'lps'),
	(371786, 126, '2015-01-15 00:12:30.000000', 'consum', 0.0218, 'lps'),
	(371787, 126, '2015-01-15 00:12:31.000000', 'consum', 0.0225, 'lps'),
	(371788, 126, '2015-01-15 00:12:32.000000', 'consum', 0.0226, 'lps'),
	(371789, 126, '2015-01-15 00:12:33.000000', 'consum', 0.0225, 'lps'),
	(371790, 126, '2015-01-15 00:12:34.000000', 'consum', 0.0220, 'lps'),
	(371791, 126, '2015-01-15 00:12:35.000000', 'consum', 0.0213, 'lps'),
	(371792, 126, '2015-01-15 00:12:36.000000', 'consum', 0.0218, 'lps'),
	(371793, 126, '2015-01-15 00:12:37.000000', 'consum', 0.0219, 'lps'),
	(371794, 126, '2015-01-15 00:12:38.000000', 'consum', 0.0215, 'lps'),
	(371795, 126, '2015-01-15 00:12:39.000000', 'consum', 0.0226, 'lps'),
	(371796, 126, '2015-01-15 00:12:40.000000', 'consum', 0.0218, 'lps'),
	(371797, 126, '2015-01-15 00:12:41.000000', 'consum', 0.0221, 'lps'),
	(371798, 126, '2015-01-15 00:12:42.000000', 'consum', 0.0224, 'lps'),
	(371799, 126, '2015-01-15 00:12:43.000000', 'consum', 0.0210, 'lps'),
	(371800, 126, '2015-01-15 00:12:44.000000', 'consum', 0.0226, 'lps'),
	(371801, 126, '2015-01-15 00:12:45.000000', 'consum', 0.0213, 'lps'),
	(371802, 126, '2015-01-15 00:12:46.000000', 'consum', 0.0217, 'lps'),
	(371803, 126, '2015-01-15 00:12:47.000000', 'consum', 0.0217, 'lps'),
	(371804, 126, '2015-01-15 00:12:48.000000', 'consum', 0.0225, 'lps'),
	(371805, 126, '2015-01-15 00:12:49.000000', 'consum', 0.0228, 'lps'),
	(371806, 126, '2015-01-15 00:12:50.000000', 'consum', 0.0214, 'lps'),
	(371807, 126, '2015-01-15 00:12:51.000000', 'consum', 0.0218, 'lps'),
	(371808, 126, '2015-01-15 00:12:52.000000', 'consum', 0.0218, 'lps'),
	(371809, 126, '2015-01-15 00:12:53.000000', 'consum', 0.0228, 'lps'),
	(371810, 126, '2015-01-15 00:12:54.000000', 'consum', 0.0216, 'lps'),
	(371811, 126, '2015-01-15 00:12:55.000000', 'consum', 0.0228, 'lps'),
	(371812, 126, '2015-01-15 00:12:56.000000', 'consum', 0.0224, 'lps'),
	(371813, 126, '2015-01-15 00:12:57.000000', 'consum', 0.0210, 'lps'),
	(371814, 126, '2015-01-15 00:12:58.000000', 'consum', 0.0223, 'lps'),
	(371815, 126, '2015-01-15 00:12:59.000000', 'consum', 0.0219, 'lps'),
	(371816, 126, '2015-01-15 00:13:00.000000', 'consum', 0.0218, 'lps'),
	(371817, 126, '2015-01-15 00:13:01.000000', 'consum', 0.0224, 'lps'),
	(371818, 126, '2015-01-15 00:13:02.000000', 'consum', 0.0216, 'lps'),
	(371819, 126, '2015-01-15 00:13:03.000000', 'consum', 0.0220, 'lps'),
	(371820, 126, '2015-01-15 00:13:04.000000', 'consum', 0.0222, 'lps'),
	(371821, 126, '2015-01-15 00:13:05.000000', 'consum', 0.0224, 'lps'),
	(371822, 126, '2015-01-15 00:13:06.000000', 'consum', 0.0222, 'lps'),
	(371823, 126, '2015-01-15 00:13:07.000000', 'consum', 0.0212, 'lps'),
	(371824, 126, '2015-01-15 00:13:08.000000', 'consum', 0.0220, 'lps'),
	(371825, 126, '2015-01-15 00:13:09.000000', 'consum', 0.0218, 'lps'),
	(371826, 126, '2015-01-15 00:13:10.000000', 'consum', 0.0221, 'lps'),
	(371827, 126, '2015-01-15 00:13:11.000000', 'consum', 0.0221, 'lps'),
	(371828, 126, '2015-01-15 00:13:12.000000', 'consum', 0.0214, 'lps'),
	(371829, 126, '2015-01-15 00:13:13.000000', 'consum', 0.0216, 'lps'),
	(371830, 126, '2015-01-15 00:13:14.000000', 'consum', 0.0227, 'lps'),
	(371831, 126, '2015-01-15 00:13:15.000000', 'consum', 0.0224, 'lps'),
	(371832, 126, '2015-01-15 00:13:16.000000', 'consum', 0.0227, 'lps'),
	(371833, 126, '2015-01-15 00:13:17.000000', 'consum', 0.0217, 'lps'),
	(371834, 126, '2015-01-15 00:13:18.000000', 'consum', 0.0212, 'lps'),
	(371835, 126, '2015-01-15 00:13:19.000000', 'consum', 0.0219, 'lps'),
	(371836, 126, '2015-01-15 00:13:20.000000', 'consum', 0.0213, 'lps'),
	(371837, 126, '2015-01-15 00:13:21.000000', 'consum', 0.0217, 'lps'),
	(371838, 126, '2015-01-15 00:13:22.000000', 'consum', 0.0215, 'lps'),
	(371839, 126, '2015-01-15 00:13:23.000000', 'consum', 0.0216, 'lps'),
	(371840, 126, '2015-01-15 00:13:24.000000', 'consum', 0.0227, 'lps'),
	(371841, 126, '2015-01-15 00:13:25.000000', 'consum', 0.0219, 'lps'),
	(371842, 126, '2015-01-15 00:13:26.000000', 'consum', 0.0223, 'lps'),
	(371843, 126, '2015-01-15 00:13:27.000000', 'consum', 0.0211, 'lps'),
	(371844, 126, '2015-01-15 00:13:28.000000', 'consum', 0.0213, 'lps'),
	(371845, 126, '2015-01-15 00:13:29.000000', 'consum', 0.0223, 'lps'),
	(371846, 126, '2015-01-15 00:13:30.000000', 'consum', 0.0227, 'lps'),
	(371847, 126, '2015-01-15 00:13:31.000000', 'consum', 0.0221, 'lps'),
	(371848, 126, '2015-01-15 00:13:32.000000', 'consum', 0.0213, 'lps'),
	(371849, 126, '2015-01-15 00:13:33.000000', 'consum', 0.0210, 'lps'),
	(371850, 126, '2015-01-15 00:13:34.000000', 'consum', 0.0223, 'lps'),
	(371851, 126, '2015-01-15 00:13:35.000000', 'consum', 0.0219, 'lps'),
	(371852, 126, '2015-01-15 00:13:36.000000', 'consum', 0.0214, 'lps'),
	(371853, 126, '2015-01-15 00:13:37.000000', 'consum', 0.0224, 'lps'),
	(371854, 126, '2015-01-15 00:13:38.000000', 'consum', 0.0211, 'lps'),
	(371855, 126, '2015-01-15 00:13:39.000000', 'consum', 0.0210, 'lps'),
	(371856, 126, '2015-01-15 00:13:40.000000', 'consum', 0.0227, 'lps'),
	(371857, 126, '2015-01-15 00:13:41.000000', 'consum', 0.0220, 'lps'),
	(371858, 126, '2015-01-15 00:13:42.000000', 'consum', 0.0228, 'lps'),
	(371859, 126, '2015-01-15 00:13:43.000000', 'consum', 0.0213, 'lps'),
	(371860, 126, '2015-01-15 00:13:44.000000', 'consum', 0.0228, 'lps'),
	(371861, 126, '2015-01-15 00:13:45.000000', 'consum', 0.0218, 'lps'),
	(371862, 126, '2015-01-15 00:13:46.000000', 'consum', 0.0215, 'lps'),
	(371863, 126, '2015-01-15 00:13:47.000000', 'consum', 0.0211, 'lps'),
	(371864, 126, '2015-01-15 00:13:48.000000', 'consum', 0.0221, 'lps'),
	(371865, 126, '2015-01-15 00:13:49.000000', 'consum', 0.0224, 'lps'),
	(371866, 126, '2015-01-15 00:13:50.000000', 'consum', 0.0226, 'lps'),
	(371867, 126, '2015-01-15 00:13:51.000000', 'consum', 0.0213, 'lps'),
	(371868, 126, '2015-01-15 00:13:52.000000', 'consum', 0.0214, 'lps'),
	(371869, 126, '2015-01-15 00:13:53.000000', 'consum', 0.0223, 'lps'),
	(371870, 126, '2015-01-15 00:13:54.000000', 'consum', 0.0227, 'lps'),
	(371871, 126, '2015-01-15 00:13:55.000000', 'consum', 0.0217, 'lps'),
	(371872, 126, '2015-01-15 00:13:56.000000', 'consum', 0.0212, 'lps'),
	(371873, 126, '2015-01-15 00:13:57.000000', 'consum', 0.0219, 'lps'),
	(371874, 126, '2015-01-15 00:13:58.000000', 'consum', 0.0211, 'lps'),
	(371875, 126, '2015-01-15 00:13:59.000000', 'consum', 0.0228, 'lps'),
	(371876, 126, '2015-01-15 00:14:00.000000', 'consum', 0.0220, 'lps'),
	(371877, 126, '2015-01-15 00:14:01.000000', 'consum', 0.0228, 'lps'),
	(371878, 126, '2015-01-15 00:14:02.000000', 'consum', 0.0213, 'lps'),
	(371879, 126, '2015-01-15 00:14:03.000000', 'consum', 0.0226, 'lps'),
	(371880, 126, '2015-01-15 00:14:04.000000', 'consum', 0.0226, 'lps'),
	(371881, 126, '2015-01-15 00:14:05.000000', 'consum', 0.0222, 'lps'),
	(371882, 126, '2015-01-15 00:14:06.000000', 'consum', 0.0224, 'lps'),
	(371883, 126, '2015-01-15 00:14:07.000000', 'consum', 0.0223, 'lps'),
	(371884, 126, '2015-01-15 00:14:08.000000', 'consum', 0.0217, 'lps'),
	(371885, 126, '2015-01-15 00:14:09.000000', 'consum', 0.0224, 'lps'),
	(371886, 126, '2015-01-15 00:14:10.000000', 'consum', 0.0221, 'lps'),
	(371887, 126, '2015-01-15 00:14:11.000000', 'consum', 0.0224, 'lps'),
	(371888, 126, '2015-01-15 00:14:12.000000', 'consum', 0.0210, 'lps'),
	(371889, 126, '2015-01-15 00:14:13.000000', 'consum', 0.0225, 'lps'),
	(371890, 126, '2015-01-15 00:14:14.000000', 'consum', 0.0227, 'lps'),
	(371891, 126, '2015-01-15 00:14:15.000000', 'consum', 0.0216, 'lps'),
	(371892, 126, '2015-01-15 00:14:16.000000', 'consum', 0.0224, 'lps'),
	(371893, 126, '2015-01-15 00:14:17.000000', 'consum', 0.0226, 'lps'),
	(371894, 126, '2015-01-15 00:14:18.000000', 'consum', 0.0212, 'lps'),
	(371895, 126, '2015-01-15 00:14:19.000000', 'consum', 0.0227, 'lps'),
	(371896, 126, '2015-01-15 00:14:20.000000', 'consum', 0.0214, 'lps'),
	(371897, 126, '2015-01-15 00:14:21.000000', 'consum', 0.0220, 'lps'),
	(371898, 126, '2015-01-15 00:14:22.000000', 'consum', 0.0227, 'lps'),
	(371899, 126, '2015-01-15 00:14:23.000000', 'consum', 0.0227, 'lps'),
	(371900, 126, '2015-01-15 00:14:24.000000', 'consum', 0.0225, 'lps'),
	(371901, 126, '2015-01-15 00:14:25.000000', 'consum', 0.0216, 'lps'),
	(371902, 126, '2015-01-15 00:14:26.000000', 'consum', 0.0216, 'lps'),
	(371903, 126, '2015-01-15 00:14:27.000000', 'consum', 0.0220, 'lps'),
	(371904, 126, '2015-01-15 00:14:28.000000', 'consum', 0.0226, 'lps'),
	(371905, 126, '2015-01-15 00:14:29.000000', 'consum', 0.0220, 'lps'),
	(371906, 126, '2015-01-15 00:14:30.000000', 'consum', 0.0212, 'lps'),
	(371907, 126, '2015-01-15 00:14:31.000000', 'consum', 0.0212, 'lps'),
	(371908, 126, '2015-01-15 00:14:32.000000', 'consum', 0.0212, 'lps'),
	(371909, 126, '2015-01-15 00:14:33.000000', 'consum', 0.0215, 'lps'),
	(371910, 126, '2015-01-15 00:14:34.000000', 'consum', 0.0210, 'lps'),
	(371911, 126, '2015-01-15 00:14:35.000000', 'consum', 0.0216, 'lps'),
	(371912, 126, '2015-01-15 00:14:36.000000', 'consum', 0.0222, 'lps'),
	(371913, 126, '2015-01-15 00:14:37.000000', 'consum', 0.0215, 'lps'),
	(371914, 126, '2015-01-15 00:14:38.000000', 'consum', 0.0219, 'lps'),
	(371915, 126, '2015-01-15 00:14:39.000000', 'consum', 0.0218, 'lps'),
	(371916, 126, '2015-01-15 00:14:40.000000', 'consum', 0.0227, 'lps'),
	(371917, 126, '2015-01-15 00:14:41.000000', 'consum', 0.0215, 'lps'),
	(371918, 126, '2015-01-15 00:14:42.000000', 'consum', 0.0220, 'lps'),
	(371919, 126, '2015-01-15 00:14:43.000000', 'consum', 0.0227, 'lps'),
	(371920, 126, '2015-01-15 00:14:44.000000', 'consum', 0.0226, 'lps'),
	(371921, 126, '2015-01-15 00:14:45.000000', 'consum', 0.0221, 'lps'),
	(371922, 126, '2015-01-15 00:14:46.000000', 'consum', 0.0218, 'lps'),
	(371923, 126, '2015-01-15 00:14:47.000000', 'consum', 0.0219, 'lps'),
	(371924, 126, '2015-01-15 00:14:48.000000', 'consum', 0.0211, 'lps'),
	(371925, 126, '2015-01-15 00:14:49.000000', 'consum', 0.0228, 'lps'),
	(371926, 126, '2015-01-15 00:14:50.000000', 'consum', 0.0220, 'lps'),
	(371927, 126, '2015-01-15 00:14:51.000000', 'consum', 0.0224, 'lps'),
	(371928, 126, '2015-01-15 00:14:52.000000', 'consum', 0.0216, 'lps'),
	(371929, 126, '2015-01-15 00:14:53.000000', 'consum', 0.0214, 'lps'),
	(371930, 126, '2015-01-15 00:14:54.000000', 'consum', 0.0215, 'lps'),
	(371931, 126, '2015-01-15 00:14:55.000000', 'consum', 0.0223, 'lps'),
	(371932, 126, '2015-01-15 00:14:56.000000', 'consum', 0.0221, 'lps'),
	(371933, 126, '2015-01-15 00:14:57.000000', 'consum', 0.0227, 'lps'),
	(371934, 126, '2015-01-15 00:14:58.000000', 'consum', 0.0225, 'lps'),
	(371935, 126, '2015-01-15 00:14:59.000000', 'consum', 0.0215, 'lps'),
	(371936, 126, '2015-01-15 00:15:00.000000', 'consum', 0.0211, 'lps'),
	(371937, 126, '2015-01-15 00:15:01.000000', 'consum', 0.0218, 'lps'),
	(371938, 126, '2015-01-15 00:15:02.000000', 'consum', 0.0211, 'lps'),
	(371939, 126, '2015-01-15 00:15:03.000000', 'consum', 0.0228, 'lps'),
	(371940, 126, '2015-01-15 00:15:04.000000', 'consum', 0.0223, 'lps'),
	(371941, 126, '2015-01-15 00:15:05.000000', 'consum', 0.0221, 'lps'),
	(371942, 126, '2015-01-15 00:15:06.000000', 'consum', 0.0227, 'lps'),
	(371943, 126, '2015-01-15 00:15:07.000000', 'consum', 0.0225, 'lps'),
	(371944, 126, '2015-01-15 00:15:08.000000', 'consum', 0.0216, 'lps'),
	(371945, 126, '2015-01-15 00:15:09.000000', 'consum', 0.0215, 'lps'),
	(371946, 126, '2015-01-15 00:15:10.000000', 'consum', 0.0216, 'lps'),
	(371947, 126, '2015-01-15 00:15:11.000000', 'consum', 0.0225, 'lps'),
	(371948, 126, '2015-01-15 00:15:12.000000', 'consum', 0.0210, 'lps'),
	(371949, 126, '2015-01-15 00:15:13.000000', 'consum', 0.0221, 'lps'),
	(371950, 126, '2015-01-15 00:15:14.000000', 'consum', 0.0212, 'lps'),
	(371951, 126, '2015-01-15 00:15:15.000000', 'consum', 0.0225, 'lps'),
	(371952, 126, '2015-01-15 00:15:16.000000', 'consum', 0.0222, 'lps'),
	(371953, 126, '2015-01-15 00:15:17.000000', 'consum', 0.0225, 'lps'),
	(371954, 126, '2015-01-15 00:15:18.000000', 'consum', 0.0210, 'lps'),
	(371955, 126, '2015-01-15 00:15:19.000000', 'consum', 0.0224, 'lps'),
	(371956, 126, '2015-01-15 00:15:20.000000', 'consum', 0.0223, 'lps'),
	(371957, 126, '2015-01-15 00:15:21.000000', 'consum', 0.0214, 'lps'),
	(371958, 126, '2015-01-15 00:15:22.000000', 'consum', 0.0211, 'lps'),
	(371959, 126, '2015-01-15 00:15:23.000000', 'consum', 0.0222, 'lps'),
	(371960, 126, '2015-01-15 00:15:24.000000', 'consum', 0.0228, 'lps'),
	(371961, 126, '2015-01-15 00:15:25.000000', 'consum', 0.0210, 'lps'),
	(371962, 126, '2015-01-15 00:15:26.000000', 'consum', 0.0214, 'lps'),
	(371963, 126, '2015-01-15 00:15:27.000000', 'consum', 0.0228, 'lps'),
	(371964, 126, '2015-01-15 00:15:28.000000', 'consum', 0.0214, 'lps'),
	(371965, 126, '2015-01-15 00:15:29.000000', 'consum', 0.0216, 'lps'),
	(371966, 126, '2015-01-15 00:15:30.000000', 'consum', 0.0228, 'lps'),
	(371967, 126, '2015-01-15 00:15:31.000000', 'consum', 0.0223, 'lps'),
	(371968, 126, '2015-01-15 00:15:32.000000', 'consum', 0.0223, 'lps'),
	(371969, 126, '2015-01-15 00:15:33.000000', 'consum', 0.0217, 'lps'),
	(371970, 126, '2015-01-15 00:15:34.000000', 'consum', 0.0226, 'lps'),
	(371971, 126, '2015-01-15 00:15:35.000000', 'consum', 0.0214, 'lps'),
	(371972, 126, '2015-01-15 00:15:36.000000', 'consum', 0.0220, 'lps'),
	(371973, 126, '2015-01-15 00:15:37.000000', 'consum', 0.0212, 'lps'),
	(371974, 126, '2015-01-15 00:15:38.000000', 'consum', 0.0225, 'lps'),
	(371975, 126, '2015-01-15 00:15:39.000000', 'consum', 0.0224, 'lps'),
	(371976, 126, '2015-01-15 00:15:40.000000', 'consum', 0.0219, 'lps'),
	(371977, 126, '2015-01-15 00:15:41.000000', 'consum', 0.0210, 'lps'),
	(371978, 126, '2015-01-15 00:15:42.000000', 'consum', 0.0221, 'lps'),
	(371979, 126, '2015-01-15 00:15:43.000000', 'consum', 0.0211, 'lps'),
	(371980, 126, '2015-01-15 00:15:44.000000', 'consum', 0.0218, 'lps'),
	(371981, 126, '2015-01-15 00:15:45.000000', 'consum', 0.0213, 'lps'),
	(371982, 126, '2015-01-15 00:15:46.000000', 'consum', 0.0217, 'lps'),
	(371983, 126, '2015-01-15 00:15:47.000000', 'consum', 0.0218, 'lps'),
	(371984, 126, '2015-01-15 00:15:48.000000', 'consum', 0.0210, 'lps'),
	(371985, 126, '2015-01-15 00:15:49.000000', 'consum', 0.0225, 'lps'),
	(371986, 126, '2015-01-15 00:15:50.000000', 'consum', 0.0211, 'lps'),
	(371987, 126, '2015-01-15 00:15:51.000000', 'consum', 0.0226, 'lps'),
	(371988, 126, '2015-01-15 00:15:52.000000', 'consum', 0.0211, 'lps'),
	(371989, 126, '2015-01-15 00:15:53.000000', 'consum', 0.0225, 'lps'),
	(371990, 126, '2015-01-15 00:15:54.000000', 'consum', 0.0227, 'lps'),
	(371991, 126, '2015-01-15 00:15:55.000000', 'consum', 0.0211, 'lps'),
	(371992, 126, '2015-01-15 00:15:56.000000', 'consum', 0.0221, 'lps'),
	(371993, 126, '2015-01-15 00:15:57.000000', 'consum', 0.0225, 'lps'),
	(371994, 126, '2015-01-15 00:15:58.000000', 'consum', 0.0216, 'lps'),
	(371995, 126, '2015-01-15 00:15:59.000000', 'consum', 0.0214, 'lps'),
	(371996, 126, '2015-01-15 00:16:00.000000', 'consum', 0.0213, 'lps'),
	(371997, 126, '2015-01-15 00:16:01.000000', 'consum', 0.0213, 'lps'),
	(371998, 126, '2015-01-15 00:16:02.000000', 'consum', 0.0216, 'lps'),
	(371999, 126, '2015-01-15 00:16:03.000000', 'consum', 0.0215, 'lps'),
	(372000, 126, '2015-01-15 00:16:04.000000', 'consum', 0.0214, 'lps'),
	(372001, 126, '2015-01-15 00:16:05.000000', 'consum', 0.0217, 'lps'),
	(372002, 126, '2015-01-15 00:16:06.000000', 'consum', 0.0213, 'lps'),
	(372003, 126, '2015-01-15 00:16:07.000000', 'consum', 0.0223, 'lps'),
	(372004, 126, '2015-01-15 00:16:08.000000', 'consum', 0.0210, 'lps'),
	(372005, 126, '2015-01-15 00:16:09.000000', 'consum', 0.0228, 'lps'),
	(372006, 126, '2015-01-15 00:16:10.000000', 'consum', 0.0226, 'lps'),
	(372007, 126, '2015-01-15 00:16:11.000000', 'consum', 0.0217, 'lps'),
	(372008, 126, '2015-01-15 00:16:12.000000', 'consum', 0.0214, 'lps'),
	(372009, 126, '2015-01-15 00:16:13.000000', 'consum', 0.0213, 'lps'),
	(372010, 126, '2015-01-15 00:16:14.000000', 'consum', 0.0212, 'lps'),
	(372011, 126, '2015-01-15 00:16:15.000000', 'consum', 0.0212, 'lps'),
	(372012, 126, '2015-01-15 00:16:16.000000', 'consum', 0.0215, 'lps'),
	(372013, 126, '2015-01-15 00:16:17.000000', 'consum', 0.0228, 'lps'),
	(372014, 126, '2015-01-15 00:16:18.000000', 'consum', 0.0228, 'lps'),
	(372015, 126, '2015-01-15 00:16:19.000000', 'consum', 0.0227, 'lps'),
	(372016, 126, '2015-01-15 00:16:20.000000', 'consum', 0.0223, 'lps'),
	(372017, 126, '2015-01-15 00:16:21.000000', 'consum', 0.0223, 'lps'),
	(372018, 126, '2015-01-15 00:16:22.000000', 'consum', 0.0218, 'lps'),
	(372019, 126, '2015-01-15 00:16:23.000000', 'consum', 0.0211, 'lps'),
	(372020, 126, '2015-01-15 00:16:24.000000', 'consum', 0.0210, 'lps'),
	(372021, 126, '2015-01-15 00:16:25.000000', 'consum', 0.0210, 'lps'),
	(372022, 126, '2015-01-15 00:16:26.000000', 'consum', 0.0227, 'lps'),
	(372023, 126, '2015-01-15 00:16:27.000000', 'consum', 0.0219, 'lps'),
	(372024, 126, '2015-01-15 00:16:28.000000', 'consum', 0.0225, 'lps'),
	(372025, 126, '2015-01-15 00:16:29.000000', 'consum', 0.0222, 'lps'),
	(372026, 126, '2015-01-15 00:16:30.000000', 'consum', 0.0225, 'lps'),
	(372027, 126, '2015-01-15 00:16:31.000000', 'consum', 0.0211, 'lps'),
	(372028, 126, '2015-01-15 00:16:32.000000', 'consum', 0.0225, 'lps'),
	(372029, 126, '2015-01-15 00:16:33.000000', 'consum', 0.0210, 'lps'),
	(372030, 126, '2015-01-15 00:16:34.000000', 'consum', 0.0221, 'lps'),
	(372031, 126, '2015-01-15 00:16:35.000000', 'consum', 0.0211, 'lps'),
	(372032, 126, '2015-01-15 00:16:36.000000', 'consum', 0.0217, 'lps'),
	(372033, 126, '2015-01-15 00:16:37.000000', 'consum', 0.0224, 'lps'),
	(372034, 126, '2015-01-15 00:16:38.000000', 'consum', 0.0222, 'lps'),
	(372035, 126, '2015-01-15 00:16:39.000000', 'consum', 0.0228, 'lps'),
	(372036, 126, '2015-01-15 00:16:40.000000', 'consum', 0.0227, 'lps'),
	(372037, 126, '2015-01-15 00:16:41.000000', 'consum', 0.0223, 'lps'),
	(372038, 126, '2015-01-15 00:16:42.000000', 'consum', 0.0224, 'lps'),
	(372039, 126, '2015-01-15 00:16:43.000000', 'consum', 0.0222, 'lps'),
	(372040, 126, '2015-01-15 00:16:44.000000', 'consum', 0.0227, 'lps'),
	(372041, 126, '2015-01-15 00:16:45.000000', 'consum', 0.0224, 'lps'),
	(372042, 126, '2015-01-15 00:16:46.000000', 'consum', 0.0227, 'lps'),
	(372043, 126, '2015-01-15 00:16:47.000000', 'consum', 0.0218, 'lps'),
	(372044, 126, '2015-01-15 00:16:48.000000', 'consum', 0.0219, 'lps'),
	(372045, 126, '2015-01-15 00:16:49.000000', 'consum', 0.0213, 'lps'),
	(372046, 126, '2015-01-15 00:16:50.000000', 'consum', 0.0216, 'lps'),
	(372047, 126, '2015-01-15 00:16:51.000000', 'consum', 0.0213, 'lps'),
	(372048, 126, '2015-01-15 00:16:52.000000', 'consum', 0.0225, 'lps'),
	(372049, 126, '2015-01-15 00:16:53.000000', 'consum', 0.0218, 'lps'),
	(372050, 126, '2015-01-15 00:16:54.000000', 'consum', 0.0228, 'lps'),
	(372051, 126, '2015-01-15 00:16:55.000000', 'consum', 0.0216, 'lps'),
	(372052, 126, '2015-01-15 00:16:56.000000', 'consum', 0.0228, 'lps'),
	(372053, 126, '2015-01-15 00:16:57.000000', 'consum', 0.0224, 'lps'),
	(372054, 126, '2015-01-15 00:16:58.000000', 'consum', 0.0228, 'lps'),
	(372055, 126, '2015-01-15 00:16:59.000000', 'consum', 0.0220, 'lps'),
	(372056, 126, '2015-01-15 00:17:00.000000', 'consum', 0.0226, 'lps'),
	(372057, 126, '2015-01-15 00:17:01.000000', 'consum', 0.0220, 'lps'),
	(372058, 126, '2015-01-15 00:17:02.000000', 'consum', 0.0216, 'lps'),
	(372059, 126, '2015-01-15 00:17:03.000000', 'consum', 0.0228, 'lps'),
	(372060, 126, '2015-01-15 00:17:04.000000', 'consum', 0.0225, 'lps'),
	(372061, 126, '2015-01-15 00:17:05.000000', 'consum', 0.0213, 'lps'),
	(372062, 126, '2015-01-15 00:17:06.000000', 'consum', 0.0217, 'lps'),
	(372063, 126, '2015-01-15 00:17:07.000000', 'consum', 0.0221, 'lps'),
	(372064, 126, '2015-01-15 00:17:08.000000', 'consum', 0.0222, 'lps'),
	(372065, 126, '2015-01-15 00:17:09.000000', 'consum', 0.0220, 'lps'),
	(372066, 126, '2015-01-15 00:17:10.000000', 'consum', 0.0222, 'lps'),
	(372067, 126, '2015-01-15 00:17:11.000000', 'consum', 0.0224, 'lps'),
	(372068, 126, '2015-01-15 00:17:12.000000', 'consum', 0.0226, 'lps'),
	(372069, 126, '2015-01-15 00:17:13.000000', 'consum', 0.0228, 'lps'),
	(372070, 126, '2015-01-15 00:17:14.000000', 'consum', 0.0214, 'lps'),
	(372071, 126, '2015-01-15 00:17:15.000000', 'consum', 0.0216, 'lps'),
	(372072, 126, '2015-01-15 00:17:16.000000', 'consum', 0.0226, 'lps'),
	(372073, 126, '2015-01-15 00:17:17.000000', 'consum', 0.0216, 'lps'),
	(372074, 126, '2015-01-15 00:17:18.000000', 'consum', 0.0213, 'lps'),
	(372075, 126, '2015-01-15 00:17:19.000000', 'consum', 0.0224, 'lps'),
	(372076, 126, '2015-01-15 00:17:20.000000', 'consum', 0.0215, 'lps'),
	(372077, 126, '2015-01-15 00:17:21.000000', 'consum', 0.0214, 'lps'),
	(372078, 126, '2015-01-15 00:17:22.000000', 'consum', 0.0216, 'lps'),
	(372079, 126, '2015-01-15 00:17:23.000000', 'consum', 0.0227, 'lps'),
	(372080, 126, '2015-01-15 00:17:24.000000', 'consum', 0.0223, 'lps'),
	(372081, 126, '2015-01-15 00:17:25.000000', 'consum', 0.0224, 'lps'),
	(372082, 126, '2015-01-15 00:17:26.000000', 'consum', 0.0220, 'lps'),
	(372083, 126, '2015-01-15 00:17:27.000000', 'consum', 0.0220, 'lps'),
	(372084, 126, '2015-01-15 00:17:28.000000', 'consum', 0.0212, 'lps'),
	(372085, 126, '2015-01-15 00:17:29.000000', 'consum', 0.0228, 'lps'),
	(372086, 126, '2015-01-15 00:17:30.000000', 'consum', 0.0221, 'lps'),
	(372087, 126, '2015-01-15 00:17:31.000000', 'consum', 0.0227, 'lps'),
	(372088, 126, '2015-01-15 00:17:32.000000', 'consum', 0.0227, 'lps'),
	(372089, 126, '2015-01-15 00:17:33.000000', 'consum', 0.0227, 'lps'),
	(372090, 126, '2015-01-15 00:17:34.000000', 'consum', 0.0222, 'lps'),
	(372091, 126, '2015-01-15 00:17:35.000000', 'consum', 0.0222, 'lps'),
	(372092, 126, '2015-01-15 00:17:36.000000', 'consum', 0.0214, 'lps'),
	(372093, 126, '2015-01-15 00:17:37.000000', 'consum', 0.0213, 'lps'),
	(372094, 126, '2015-01-15 00:17:38.000000', 'consum', 0.0213, 'lps'),
	(372095, 126, '2015-01-15 00:17:39.000000', 'consum', 0.0218, 'lps'),
	(372096, 126, '2015-01-15 00:17:40.000000', 'consum', 0.0221, 'lps'),
	(372097, 126, '2015-01-15 00:17:41.000000', 'consum', 0.0224, 'lps'),
	(372098, 126, '2015-01-15 00:17:42.000000', 'consum', 0.0227, 'lps'),
	(372099, 126, '2015-01-15 00:17:43.000000', 'consum', 0.0217, 'lps'),
	(372100, 126, '2015-01-15 00:17:44.000000', 'consum', 0.0211, 'lps'),
	(372101, 126, '2015-01-15 00:17:45.000000', 'consum', 0.0217, 'lps'),
	(372102, 126, '2015-01-15 00:17:46.000000', 'consum', 0.0221, 'lps'),
	(372103, 126, '2015-01-15 00:17:47.000000', 'consum', 0.0228, 'lps'),
	(372104, 126, '2015-01-15 00:17:48.000000', 'consum', 0.0210, 'lps'),
	(372105, 126, '2015-01-15 00:17:49.000000', 'consum', 0.0214, 'lps'),
	(372106, 126, '2015-01-15 00:17:50.000000', 'consum', 0.0212, 'lps'),
	(372107, 126, '2015-01-15 00:17:51.000000', 'consum', 0.0226, 'lps'),
	(372108, 126, '2015-01-15 00:17:52.000000', 'consum', 0.0227, 'lps'),
	(372109, 126, '2015-01-15 00:17:53.000000', 'consum', 0.0228, 'lps'),
	(372110, 126, '2015-01-15 00:17:54.000000', 'consum', 0.0212, 'lps'),
	(372111, 126, '2015-01-15 00:17:55.000000', 'consum', 0.0226, 'lps'),
	(372112, 126, '2015-01-15 00:17:56.000000', 'consum', 0.0224, 'lps'),
	(372113, 126, '2015-01-15 00:17:57.000000', 'consum', 0.0216, 'lps'),
	(372114, 126, '2015-01-15 00:17:58.000000', 'consum', 0.0216, 'lps'),
	(372115, 126, '2015-01-15 00:17:59.000000', 'consum', 0.0225, 'lps'),
	(372116, 126, '2015-01-15 00:18:00.000000', 'consum', 0.0228, 'lps'),
	(372117, 126, '2015-01-15 00:18:01.000000', 'consum', 0.0219, 'lps'),
	(372118, 126, '2015-01-15 00:18:02.000000', 'consum', 0.0219, 'lps'),
	(372119, 126, '2015-01-15 00:18:03.000000', 'consum', 0.0228, 'lps'),
	(372120, 126, '2015-01-15 00:18:04.000000', 'consum', 0.0215, 'lps'),
	(372121, 126, '2015-01-15 00:18:05.000000', 'consum', 0.0221, 'lps'),
	(372122, 126, '2015-01-15 00:18:06.000000', 'consum', 0.0213, 'lps'),
	(372123, 126, '2015-01-15 00:18:07.000000', 'consum', 0.0211, 'lps'),
	(372124, 126, '2015-01-15 00:18:08.000000', 'consum', 0.0226, 'lps'),
	(372125, 126, '2015-01-15 00:18:09.000000', 'consum', 0.0212, 'lps'),
	(372126, 126, '2015-01-15 00:18:10.000000', 'consum', 0.0210, 'lps'),
	(372127, 126, '2015-01-15 00:18:11.000000', 'consum', 0.0222, 'lps'),
	(372128, 126, '2015-01-15 00:18:12.000000', 'consum', 0.0216, 'lps'),
	(372129, 126, '2015-01-15 00:18:13.000000', 'consum', 0.0224, 'lps'),
	(372130, 126, '2015-01-15 00:18:14.000000', 'consum', 0.0225, 'lps'),
	(372131, 126, '2015-01-15 00:18:15.000000', 'consum', 0.0222, 'lps'),
	(372132, 126, '2015-01-15 00:18:16.000000', 'consum', 0.0228, 'lps'),
	(372133, 126, '2015-01-15 00:18:17.000000', 'consum', 0.0227, 'lps'),
	(372134, 126, '2015-01-15 00:18:18.000000', 'consum', 0.0221, 'lps'),
	(372135, 126, '2015-01-15 00:18:19.000000', 'consum', 0.0215, 'lps'),
	(372136, 126, '2015-01-15 00:18:20.000000', 'consum', 0.0221, 'lps'),
	(372137, 126, '2015-01-15 00:18:21.000000', 'consum', 0.0212, 'lps'),
	(372138, 126, '2015-01-15 00:18:22.000000', 'consum', 0.0228, 'lps'),
	(372139, 126, '2015-01-15 00:18:23.000000', 'consum', 0.0216, 'lps'),
	(372140, 126, '2015-01-15 00:18:24.000000', 'consum', 0.0225, 'lps'),
	(372141, 126, '2015-01-15 00:18:25.000000', 'consum', 0.0228, 'lps'),
	(372142, 126, '2015-01-15 00:18:26.000000', 'consum', 0.0221, 'lps'),
	(372143, 126, '2015-01-15 00:18:27.000000', 'consum', 0.0227, 'lps'),
	(372144, 126, '2015-01-15 00:18:28.000000', 'consum', 0.0227, 'lps'),
	(372145, 126, '2015-01-15 00:18:29.000000', 'consum', 0.0225, 'lps'),
	(372146, 126, '2015-01-15 00:18:30.000000', 'consum', 0.0215, 'lps'),
	(372147, 126, '2015-01-15 00:18:31.000000', 'consum', 0.0211, 'lps'),
	(372148, 126, '2015-01-15 00:18:32.000000', 'consum', 0.0220, 'lps'),
	(372149, 126, '2015-01-15 00:18:33.000000', 'consum', 0.0219, 'lps'),
	(372150, 126, '2015-01-15 00:18:34.000000', 'consum', 0.0223, 'lps'),
	(372151, 126, '2015-01-15 00:18:35.000000', 'consum', 0.0213, 'lps'),
	(372152, 126, '2015-01-15 00:18:36.000000', 'consum', 0.0222, 'lps'),
	(372153, 126, '2015-01-15 00:18:37.000000', 'consum', 0.0226, 'lps'),
	(372154, 126, '2015-01-15 00:18:38.000000', 'consum', 0.0215, 'lps'),
	(372155, 126, '2015-01-15 00:18:39.000000', 'consum', 0.0226, 'lps'),
	(372156, 126, '2015-01-15 00:18:40.000000', 'consum', 0.0218, 'lps'),
	(372157, 126, '2015-01-15 00:18:41.000000', 'consum', 0.0221, 'lps'),
	(372158, 126, '2015-01-15 00:18:42.000000', 'consum', 0.0224, 'lps'),
	(372159, 126, '2015-01-15 00:18:43.000000', 'consum', 0.0228, 'lps'),
	(372160, 126, '2015-01-15 00:18:44.000000', 'consum', 0.0220, 'lps'),
	(372161, 126, '2015-01-15 00:18:45.000000', 'consum', 0.0225, 'lps'),
	(372162, 126, '2015-01-15 00:18:46.000000', 'consum', 0.0220, 'lps'),
	(372163, 126, '2015-01-15 00:18:47.000000', 'consum', 0.0213, 'lps'),
	(372164, 126, '2015-01-15 00:18:48.000000', 'consum', 0.0216, 'lps'),
	(372165, 126, '2015-01-15 00:18:49.000000', 'consum', 0.0210, 'lps'),
	(372166, 126, '2015-01-15 00:18:50.000000', 'consum', 0.0215, 'lps'),
	(372167, 126, '2015-01-15 00:18:51.000000', 'consum', 0.0214, 'lps'),
	(372168, 126, '2015-01-15 00:18:52.000000', 'consum', 0.0216, 'lps'),
	(372169, 126, '2015-01-15 00:18:53.000000', 'consum', 0.0227, 'lps'),
	(372170, 126, '2015-01-15 00:18:54.000000', 'consum', 0.0221, 'lps'),
	(372171, 126, '2015-01-15 00:18:55.000000', 'consum', 0.0215, 'lps'),
	(372172, 126, '2015-01-15 00:18:56.000000', 'consum', 0.0222, 'lps'),
	(372173, 126, '2015-01-15 00:18:57.000000', 'consum', 0.0219, 'lps'),
	(372174, 126, '2015-01-15 00:18:58.000000', 'consum', 0.0217, 'lps'),
	(372175, 126, '2015-01-15 00:18:59.000000', 'consum', 0.0219, 'lps'),
	(372176, 126, '2015-01-15 00:19:00.000000', 'consum', 0.0216, 'lps'),
	(372177, 126, '2015-01-15 00:19:01.000000', 'consum', 0.0215, 'lps'),
	(372178, 126, '2015-01-15 00:19:02.000000', 'consum', 0.0218, 'lps'),
	(372179, 126, '2015-01-15 00:19:03.000000', 'consum', 0.0214, 'lps'),
	(372180, 126, '2015-01-15 00:19:04.000000', 'consum', 0.0228, 'lps'),
	(372181, 126, '2015-01-15 00:19:05.000000', 'consum', 0.0228, 'lps'),
	(372182, 126, '2015-01-15 00:19:06.000000', 'consum', 0.0212, 'lps'),
	(372183, 126, '2015-01-15 00:19:07.000000', 'consum', 0.0221, 'lps'),
	(372184, 126, '2015-01-15 00:19:08.000000', 'consum', 0.0222, 'lps'),
	(372185, 126, '2015-01-15 00:19:09.000000', 'consum', 0.0221, 'lps'),
	(372186, 126, '2015-01-15 00:19:10.000000', 'consum', 0.0226, 'lps'),
	(372187, 126, '2015-01-15 00:19:11.000000', 'consum', 0.0221, 'lps'),
	(372188, 126, '2015-01-15 00:19:12.000000', 'consum', 0.0217, 'lps'),
	(372189, 126, '2015-01-15 00:19:13.000000', 'consum', 0.0213, 'lps'),
	(372190, 126, '2015-01-15 00:19:14.000000', 'consum', 0.0221, 'lps'),
	(372191, 126, '2015-01-15 00:19:15.000000', 'consum', 0.0222, 'lps'),
	(372192, 126, '2015-01-15 00:19:16.000000', 'consum', 0.0217, 'lps'),
	(372193, 126, '2015-01-15 00:19:17.000000', 'consum', 0.0227, 'lps'),
	(372194, 126, '2015-01-15 00:19:18.000000', 'consum', 0.0220, 'lps'),
	(372195, 126, '2015-01-15 00:19:19.000000', 'consum', 0.0226, 'lps'),
	(372196, 126, '2015-01-15 00:19:20.000000', 'consum', 0.0225, 'lps'),
	(372197, 126, '2015-01-15 00:19:21.000000', 'consum', 0.0218, 'lps'),
	(372198, 126, '2015-01-15 00:19:22.000000', 'consum', 0.0224, 'lps'),
	(372199, 126, '2015-01-15 00:19:23.000000', 'consum', 0.0218, 'lps'),
	(372200, 126, '2015-01-15 00:19:24.000000', 'consum', 0.0227, 'lps'),
	(372201, 126, '2015-01-15 00:19:25.000000', 'consum', 0.0217, 'lps'),
	(372202, 126, '2015-01-15 00:19:26.000000', 'consum', 0.0210, 'lps'),
	(372203, 126, '2015-01-15 00:19:27.000000', 'consum', 0.0211, 'lps'),
	(372204, 126, '2015-01-15 00:19:28.000000', 'consum', 0.0216, 'lps'),
	(372205, 126, '2015-01-15 00:19:29.000000', 'consum', 0.0217, 'lps'),
	(372206, 126, '2015-01-15 00:19:30.000000', 'consum', 0.0226, 'lps'),
	(372207, 126, '2015-01-15 00:19:31.000000', 'consum', 0.0215, 'lps'),
	(372208, 126, '2015-01-15 00:19:32.000000', 'consum', 0.0223, 'lps'),
	(372209, 126, '2015-01-15 00:19:33.000000', 'consum', 0.0224, 'lps'),
	(372210, 126, '2015-01-15 00:19:34.000000', 'consum', 0.0224, 'lps'),
	(372211, 126, '2015-01-15 00:19:35.000000', 'consum', 0.0218, 'lps'),
	(372212, 126, '2015-01-15 00:19:36.000000', 'consum', 0.0228, 'lps'),
	(372213, 126, '2015-01-15 00:19:37.000000', 'consum', 0.0218, 'lps'),
	(372214, 126, '2015-01-15 00:19:38.000000', 'consum', 0.0217, 'lps'),
	(372215, 126, '2015-01-15 00:19:39.000000', 'consum', 0.0222, 'lps'),
	(372216, 126, '2015-01-15 00:19:40.000000', 'consum', 0.0212, 'lps'),
	(372217, 126, '2015-01-15 00:19:41.000000', 'consum', 0.0222, 'lps'),
	(372218, 126, '2015-01-15 00:19:42.000000', 'consum', 0.0228, 'lps'),
	(372219, 126, '2015-01-15 00:19:43.000000', 'consum', 0.0225, 'lps'),
	(372220, 126, '2015-01-15 00:19:44.000000', 'consum', 0.0211, 'lps'),
	(372221, 126, '2015-01-15 00:19:45.000000', 'consum', 0.0228, 'lps'),
	(372222, 126, '2015-01-15 00:19:46.000000', 'consum', 0.0222, 'lps'),
	(372223, 126, '2015-01-15 00:19:47.000000', 'consum', 0.0217, 'lps'),
	(372224, 126, '2015-01-15 00:19:48.000000', 'consum', 0.0228, 'lps'),
	(372225, 126, '2015-01-15 00:19:49.000000', 'consum', 0.0223, 'lps'),
	(372226, 126, '2015-01-15 00:19:50.000000', 'consum', 0.0222, 'lps'),
	(372227, 126, '2015-01-15 00:19:51.000000', 'consum', 0.0212, 'lps'),
	(372228, 126, '2015-01-15 00:19:52.000000', 'consum', 0.0222, 'lps'),
	(372229, 126, '2015-01-15 00:19:53.000000', 'consum', 0.0225, 'lps'),
	(372230, 126, '2015-01-15 00:19:54.000000', 'consum', 0.0212, 'lps'),
	(372231, 126, '2015-01-15 00:19:55.000000', 'consum', 0.0215, 'lps'),
	(372232, 126, '2015-01-15 00:19:56.000000', 'consum', 0.0210, 'lps'),
	(372233, 126, '2015-01-15 00:19:57.000000', 'consum', 0.0216, 'lps'),
	(372234, 126, '2015-01-15 00:19:58.000000', 'consum', 0.0221, 'lps'),
	(372235, 126, '2015-01-15 00:19:59.000000', 'consum', 0.0228, 'lps'),
	(372236, 126, '2015-01-15 00:20:00.000000', 'consum', 0.0210, 'lps'),
	(372237, 126, '2015-01-15 00:20:01.000000', 'consum', 0.0212, 'lps'),
	(372238, 126, '2015-01-15 00:20:02.000000', 'consum', 0.0223, 'lps'),
	(372239, 126, '2015-01-15 00:20:03.000000', 'consum', 0.0213, 'lps'),
	(372240, 126, '2015-01-15 00:20:04.000000', 'consum', 0.0224, 'lps'),
	(372241, 126, '2015-01-15 00:20:05.000000', 'consum', 0.0214, 'lps'),
	(372242, 126, '2015-01-15 00:20:06.000000', 'consum', 0.0226, 'lps'),
	(372243, 126, '2015-01-15 00:20:07.000000', 'consum', 0.0223, 'lps'),
	(372244, 126, '2015-01-15 00:20:08.000000', 'consum', 0.0226, 'lps'),
	(372245, 126, '2015-01-15 00:20:09.000000', 'consum', 0.0212, 'lps'),
	(372246, 126, '2015-01-15 00:20:10.000000', 'consum', 0.0212, 'lps'),
	(372247, 126, '2015-01-15 00:20:11.000000', 'consum', 0.0213, 'lps'),
	(372248, 126, '2015-01-15 00:20:12.000000', 'consum', 0.0219, 'lps'),
	(372249, 126, '2015-01-15 00:20:13.000000', 'consum', 0.0228, 'lps'),
	(372250, 126, '2015-01-15 00:20:14.000000', 'consum', 0.0217, 'lps'),
	(372251, 126, '2015-01-15 00:20:15.000000', 'consum', 0.0228, 'lps'),
	(372252, 126, '2015-01-15 00:20:16.000000', 'consum', 0.0225, 'lps'),
	(372253, 126, '2015-01-15 00:20:17.000000', 'consum', 0.0213, 'lps'),
	(372254, 126, '2015-01-15 00:20:18.000000', 'consum', 0.0219, 'lps'),
	(372255, 126, '2015-01-15 00:20:19.000000', 'consum', 0.0225, 'lps'),
	(372256, 126, '2015-01-15 00:20:20.000000', 'consum', 0.0222, 'lps'),
	(372257, 126, '2015-01-15 00:20:21.000000', 'consum', 0.0227, 'lps'),
	(372258, 126, '2015-01-15 00:20:22.000000', 'consum', 0.0220, 'lps'),
	(372259, 126, '2015-01-15 00:20:23.000000', 'consum', 0.0227, 'lps'),
	(372260, 126, '2015-01-15 00:20:24.000000', 'consum', 0.0210, 'lps'),
	(372261, 126, '2015-01-15 00:20:25.000000', 'consum', 0.0217, 'lps'),
	(372262, 126, '2015-01-15 00:20:26.000000', 'consum', 0.0224, 'lps'),
	(372263, 126, '2015-01-15 00:20:27.000000', 'consum', 0.0225, 'lps'),
	(372264, 126, '2015-01-15 00:20:28.000000', 'consum', 0.0222, 'lps'),
	(372265, 126, '2015-01-15 00:20:29.000000', 'consum', 0.0228, 'lps'),
	(372266, 126, '2015-01-15 00:20:30.000000', 'consum', 0.0226, 'lps'),
	(372267, 126, '2015-01-15 00:20:31.000000', 'consum', 0.0219, 'lps'),
	(372268, 126, '2015-01-15 00:20:32.000000', 'consum', 0.0223, 'lps'),
	(372269, 126, '2015-01-15 00:20:33.000000', 'consum', 0.0213, 'lps'),
	(372270, 126, '2015-01-15 00:20:34.000000', 'consum', 0.0224, 'lps'),
	(372271, 126, '2015-01-15 00:20:35.000000', 'consum', 0.0214, 'lps'),
	(372272, 126, '2015-01-15 00:20:36.000000', 'consum', 0.0210, 'lps'),
	(372273, 126, '2015-01-15 00:20:37.000000', 'consum', 0.0215, 'lps'),
	(372274, 126, '2015-01-15 00:20:38.000000', 'consum', 0.0216, 'lps'),
	(372275, 126, '2015-01-15 00:20:39.000000', 'consum', 0.0226, 'lps'),
	(372276, 126, '2015-01-15 00:20:40.000000', 'consum', 0.0214, 'lps'),
	(372277, 126, '2015-01-15 00:20:41.000000', 'consum', 0.0221, 'lps'),
	(372278, 126, '2015-01-15 00:20:42.000000', 'consum', 0.0216, 'lps'),
	(372279, 126, '2015-01-15 00:20:43.000000', 'consum', 0.0228, 'lps'),
	(372280, 126, '2015-01-15 00:20:44.000000', 'consum', 0.0223, 'lps'),
	(372281, 126, '2015-01-15 00:20:45.000000', 'consum', 0.0224, 'lps'),
	(372282, 126, '2015-01-15 00:20:46.000000', 'consum', 0.0223, 'lps'),
	(372283, 126, '2015-01-15 00:20:47.000000', 'consum', 0.0212, 'lps'),
	(372284, 126, '2015-01-15 00:20:48.000000', 'consum', 0.0221, 'lps'),
	(372285, 126, '2015-01-15 00:20:49.000000', 'consum', 0.0219, 'lps'),
	(372286, 126, '2015-01-15 00:20:50.000000', 'consum', 0.0225, 'lps'),
	(372287, 126, '2015-01-15 00:20:51.000000', 'consum', 0.0221, 'lps'),
	(372288, 126, '2015-01-15 00:20:52.000000', 'consum', 0.0221, 'lps'),
	(372289, 126, '2015-01-15 00:20:53.000000', 'consum', 0.0211, 'lps'),
	(372290, 126, '2015-01-15 00:20:54.000000', 'consum', 0.0223, 'lps'),
	(372291, 126, '2015-01-15 00:20:55.000000', 'consum', 0.0214, 'lps'),
	(372292, 126, '2015-01-15 00:20:56.000000', 'consum', 0.0228, 'lps'),
	(372293, 126, '2015-01-15 00:20:57.000000', 'consum', 0.0216, 'lps'),
	(372294, 126, '2015-01-15 00:20:58.000000', 'consum', 0.0221, 'lps'),
	(372295, 126, '2015-01-15 00:20:59.000000', 'consum', 0.0211, 'lps'),
	(372296, 126, '2015-01-15 00:21:00.000000', 'consum', 0.0220, 'lps'),
	(372297, 126, '2015-01-15 00:21:01.000000', 'consum', 0.0219, 'lps'),
	(372298, 126, '2015-01-15 00:21:02.000000', 'consum', 0.0227, 'lps'),
	(372299, 126, '2015-01-15 00:21:03.000000', 'consum', 0.0212, 'lps'),
	(372300, 126, '2015-01-15 00:21:04.000000', 'consum', 0.0224, 'lps'),
	(372301, 126, '2015-01-15 00:21:05.000000', 'consum', 0.0217, 'lps'),
	(372302, 126, '2015-01-15 00:21:06.000000', 'consum', 0.0223, 'lps'),
	(372303, 126, '2015-01-15 00:21:07.000000', 'consum', 0.0218, 'lps'),
	(372304, 126, '2015-01-15 00:21:08.000000', 'consum', 0.0210, 'lps'),
	(372305, 126, '2015-01-15 00:21:09.000000', 'consum', 0.0223, 'lps'),
	(372306, 126, '2015-01-15 00:21:10.000000', 'consum', 0.0220, 'lps'),
	(372307, 126, '2015-01-15 00:21:11.000000', 'consum', 0.0221, 'lps'),
	(372308, 126, '2015-01-15 00:21:12.000000', 'consum', 0.0215, 'lps'),
	(372309, 126, '2015-01-15 00:21:13.000000', 'consum', 0.0221, 'lps'),
	(372310, 126, '2015-01-15 00:21:14.000000', 'consum', 0.0215, 'lps'),
	(372311, 126, '2015-01-15 00:21:15.000000', 'consum', 0.0222, 'lps'),
	(372312, 126, '2015-01-15 00:21:16.000000', 'consum', 0.0215, 'lps'),
	(372313, 126, '2015-01-15 00:21:17.000000', 'consum', 0.0219, 'lps'),
	(372314, 126, '2015-01-15 00:21:18.000000', 'consum', 0.0222, 'lps'),
	(372315, 126, '2015-01-15 00:21:19.000000', 'consum', 0.0222, 'lps'),
	(372316, 126, '2015-01-15 00:21:20.000000', 'consum', 0.0219, 'lps'),
	(372317, 126, '2015-01-15 00:21:21.000000', 'consum', 0.0220, 'lps'),
	(372318, 126, '2015-01-15 00:21:22.000000', 'consum', 0.0212, 'lps'),
	(372319, 126, '2015-01-15 00:21:23.000000', 'consum', 0.0210, 'lps'),
	(372320, 126, '2015-01-15 00:21:24.000000', 'consum', 0.0224, 'lps'),
	(372321, 126, '2015-01-15 00:21:25.000000', 'consum', 0.0222, 'lps'),
	(372322, 126, '2015-01-15 00:21:26.000000', 'consum', 0.0211, 'lps'),
	(372323, 126, '2015-01-15 00:21:27.000000', 'consum', 0.0218, 'lps'),
	(372324, 126, '2015-01-15 00:21:28.000000', 'consum', 0.0210, 'lps'),
	(372325, 126, '2015-01-15 00:21:29.000000', 'consum', 0.0225, 'lps'),
	(372326, 126, '2015-01-15 00:21:30.000000', 'consum', 0.0228, 'lps'),
	(372327, 126, '2015-01-15 00:21:31.000000', 'consum', 0.0218, 'lps'),
	(372328, 126, '2015-01-15 00:21:32.000000', 'consum', 0.0214, 'lps'),
	(372329, 126, '2015-01-15 00:21:33.000000', 'consum', 0.0228, 'lps'),
	(372330, 126, '2015-01-15 00:21:34.000000', 'consum', 0.0212, 'lps'),
	(372331, 126, '2015-01-15 00:21:35.000000', 'consum', 0.0225, 'lps'),
	(372332, 126, '2015-01-15 00:21:36.000000', 'consum', 0.0221, 'lps'),
	(372333, 126, '2015-01-15 00:21:37.000000', 'consum', 0.0219, 'lps'),
	(372334, 126, '2015-01-15 00:21:38.000000', 'consum', 0.0225, 'lps'),
	(372335, 126, '2015-01-15 00:21:39.000000', 'consum', 0.0218, 'lps'),
	(372336, 126, '2015-01-15 00:21:40.000000', 'consum', 0.0226, 'lps'),
	(372337, 126, '2015-01-15 00:21:41.000000', 'consum', 0.0211, 'lps'),
	(372338, 126, '2015-01-15 00:21:42.000000', 'consum', 0.0224, 'lps'),
	(372339, 126, '2015-01-15 00:21:43.000000', 'consum', 0.0219, 'lps'),
	(372340, 126, '2015-01-15 00:21:44.000000', 'consum', 0.0215, 'lps'),
	(372341, 126, '2015-01-15 00:21:45.000000', 'consum', 0.0227, 'lps'),
	(372342, 126, '2015-01-15 00:21:46.000000', 'consum', 0.0223, 'lps'),
	(372343, 126, '2015-01-15 00:21:47.000000', 'consum', 0.0223, 'lps'),
	(372344, 126, '2015-01-15 00:21:48.000000', 'consum', 0.0219, 'lps'),
	(372345, 126, '2015-01-15 00:21:49.000000', 'consum', 0.0217, 'lps'),
	(372346, 126, '2015-01-15 00:21:50.000000', 'consum', 0.0218, 'lps'),
	(372347, 126, '2015-01-15 00:21:51.000000', 'consum', 0.0212, 'lps'),
	(372348, 126, '2015-01-15 00:21:52.000000', 'consum', 0.0214, 'lps'),
	(372349, 126, '2015-01-15 00:21:53.000000', 'consum', 0.0224, 'lps'),
	(372350, 126, '2015-01-15 00:21:54.000000', 'consum', 0.0212, 'lps'),
	(372351, 126, '2015-01-15 00:21:55.000000', 'consum', 0.0217, 'lps'),
	(372352, 126, '2015-01-15 00:21:56.000000', 'consum', 0.0219, 'lps'),
	(372353, 126, '2015-01-15 00:21:57.000000', 'consum', 0.0216, 'lps'),
	(372354, 126, '2015-01-15 00:21:58.000000', 'consum', 0.0214, 'lps'),
	(372355, 126, '2015-01-15 00:21:59.000000', 'consum', 0.0214, 'lps'),
	(372356, 126, '2015-01-15 00:22:00.000000', 'consum', 0.0215, 'lps'),
	(372357, 126, '2015-01-15 00:22:01.000000', 'consum', 0.0226, 'lps'),
	(372358, 126, '2015-01-15 00:22:02.000000', 'consum', 0.0218, 'lps'),
	(372359, 126, '2015-01-15 00:22:03.000000', 'consum', 0.0220, 'lps'),
	(372360, 126, '2015-01-15 00:22:04.000000', 'consum', 0.0217, 'lps'),
	(372361, 126, '2015-01-15 00:22:05.000000', 'consum', 0.0215, 'lps'),
	(372362, 126, '2015-01-15 00:22:06.000000', 'consum', 0.0216, 'lps'),
	(372363, 126, '2015-01-15 00:22:07.000000', 'consum', 0.0225, 'lps'),
	(372364, 126, '2015-01-15 00:22:08.000000', 'consum', 0.0228, 'lps'),
	(372365, 126, '2015-01-15 00:22:09.000000', 'consum', 0.0220, 'lps'),
	(372366, 126, '2015-01-15 00:22:10.000000', 'consum', 0.0222, 'lps'),
	(372367, 126, '2015-01-15 00:22:11.000000', 'consum', 0.0225, 'lps'),
	(372368, 126, '2015-01-15 00:22:12.000000', 'consum', 0.0210, 'lps'),
	(372369, 126, '2015-01-15 00:22:13.000000', 'consum', 0.0225, 'lps'),
	(372370, 126, '2015-01-15 00:22:14.000000', 'consum', 0.0226, 'lps'),
	(372371, 126, '2015-01-15 00:22:15.000000', 'consum', 0.0228, 'lps'),
	(372372, 126, '2015-01-15 00:22:16.000000', 'consum', 0.0215, 'lps'),
	(372373, 126, '2015-01-15 00:22:17.000000', 'consum', 0.0217, 'lps'),
	(372374, 126, '2015-01-15 00:22:18.000000', 'consum', 0.0215, 'lps'),
	(372375, 126, '2015-01-15 00:22:19.000000', 'consum', 0.0211, 'lps'),
	(372376, 126, '2015-01-15 00:22:20.000000', 'consum', 0.0222, 'lps'),
	(372377, 126, '2015-01-15 00:22:21.000000', 'consum', 0.0212, 'lps'),
	(372378, 126, '2015-01-15 00:22:22.000000', 'consum', 0.0220, 'lps'),
	(372379, 126, '2015-01-15 00:22:23.000000', 'consum', 0.0216, 'lps'),
	(372380, 126, '2015-01-15 00:22:24.000000', 'consum', 0.0210, 'lps'),
	(372381, 126, '2015-01-15 00:22:25.000000', 'consum', 0.0213, 'lps'),
	(372382, 126, '2015-01-15 00:22:26.000000', 'consum', 0.0226, 'lps'),
	(372383, 126, '2015-01-15 00:22:27.000000', 'consum', 0.0225, 'lps'),
	(372384, 126, '2015-01-15 00:22:28.000000', 'consum', 0.0218, 'lps'),
	(372385, 126, '2015-01-15 00:22:29.000000', 'consum', 0.0224, 'lps'),
	(372386, 126, '2015-01-15 00:22:30.000000', 'consum', 0.0219, 'lps'),
	(372387, 126, '2015-01-15 00:22:31.000000', 'consum', 0.0213, 'lps'),
	(372388, 126, '2015-01-15 00:22:32.000000', 'consum', 0.0220, 'lps'),
	(372389, 126, '2015-01-15 00:22:33.000000', 'consum', 0.0211, 'lps'),
	(372390, 126, '2015-01-15 00:22:34.000000', 'consum', 0.0225, 'lps'),
	(372391, 126, '2015-01-15 00:22:35.000000', 'consum', 0.0224, 'lps'),
	(372392, 126, '2015-01-15 00:22:36.000000', 'consum', 0.0218, 'lps'),
	(372393, 126, '2015-01-15 00:22:37.000000', 'consum', 0.0228, 'lps'),
	(372394, 126, '2015-01-15 00:22:38.000000', 'consum', 0.0218, 'lps'),
	(372395, 126, '2015-01-15 00:22:39.000000', 'consum', 0.0215, 'lps'),
	(372396, 126, '2015-01-15 00:22:40.000000', 'consum', 0.0210, 'lps'),
	(372397, 126, '2015-01-15 00:22:41.000000', 'consum', 0.0217, 'lps'),
	(372398, 126, '2015-01-15 00:22:42.000000', 'consum', 0.0227, 'lps'),
	(372399, 126, '2015-01-15 00:22:43.000000', 'consum', 0.0218, 'lps'),
	(372400, 126, '2015-01-15 00:22:44.000000', 'consum', 0.0218, 'lps'),
	(372401, 126, '2015-01-15 00:22:45.000000', 'consum', 0.0226, 'lps'),
	(372402, 126, '2015-01-15 00:22:46.000000', 'consum', 0.0211, 'lps'),
	(372403, 126, '2015-01-15 00:22:47.000000', 'consum', 0.0224, 'lps'),
	(372404, 126, '2015-01-15 00:22:48.000000', 'consum', 0.0218, 'lps'),
	(372405, 126, '2015-01-15 00:22:49.000000', 'consum', 0.0211, 'lps'),
	(372406, 126, '2015-01-15 00:22:50.000000', 'consum', 0.0212, 'lps'),
	(372407, 126, '2015-01-15 00:22:51.000000', 'consum', 0.0215, 'lps'),
	(372408, 126, '2015-01-15 00:22:52.000000', 'consum', 0.0213, 'lps'),
	(372409, 126, '2015-01-15 00:22:53.000000', 'consum', 0.0227, 'lps'),
	(372410, 126, '2015-01-15 00:22:54.000000', 'consum', 0.0213, 'lps'),
	(372411, 126, '2015-01-15 00:22:55.000000', 'consum', 0.0211, 'lps'),
	(372412, 126, '2015-01-15 00:22:56.000000', 'consum', 0.0227, 'lps'),
	(372413, 126, '2015-01-15 00:22:57.000000', 'consum', 0.0215, 'lps'),
	(372414, 126, '2015-01-15 00:22:58.000000', 'consum', 0.0224, 'lps'),
	(372415, 126, '2015-01-15 00:22:59.000000', 'consum', 0.0225, 'lps'),
	(372416, 126, '2015-01-15 00:23:00.000000', 'consum', 0.0225, 'lps'),
	(372417, 126, '2015-01-15 00:23:01.000000', 'consum', 0.0223, 'lps'),
	(372418, 126, '2015-01-15 00:23:02.000000', 'consum', 0.0228, 'lps'),
	(372419, 126, '2015-01-15 00:23:03.000000', 'consum', 0.0227, 'lps'),
	(372420, 126, '2015-01-15 00:23:04.000000', 'consum', 0.0219, 'lps'),
	(372421, 126, '2015-01-15 00:23:05.000000', 'consum', 0.0225, 'lps'),
	(372422, 126, '2015-01-15 00:23:06.000000', 'consum', 0.0219, 'lps'),
	(372423, 126, '2015-01-15 00:23:07.000000', 'consum', 0.0211, 'lps'),
	(372424, 126, '2015-01-15 00:23:08.000000', 'consum', 0.0226, 'lps'),
	(372425, 126, '2015-01-15 00:23:09.000000', 'consum', 0.0210, 'lps'),
	(372426, 126, '2015-01-15 00:23:10.000000', 'consum', 0.0222, 'lps'),
	(372427, 126, '2015-01-15 00:23:11.000000', 'consum', 0.0212, 'lps'),
	(372428, 126, '2015-01-15 00:23:12.000000', 'consum', 0.0222, 'lps'),
	(372429, 126, '2015-01-15 00:23:13.000000', 'consum', 0.0226, 'lps'),
	(372430, 126, '2015-01-15 00:23:14.000000', 'consum', 0.0219, 'lps'),
	(372431, 126, '2015-01-15 00:23:15.000000', 'consum', 0.0225, 'lps'),
	(372432, 126, '2015-01-15 00:23:16.000000', 'consum', 0.0221, 'lps'),
	(372433, 126, '2015-01-15 00:23:17.000000', 'consum', 0.0219, 'lps'),
	(372434, 126, '2015-01-15 00:23:18.000000', 'consum', 0.0224, 'lps'),
	(372435, 126, '2015-01-15 00:23:19.000000', 'consum', 0.0214, 'lps'),
	(372436, 126, '2015-01-15 00:23:20.000000', 'consum', 0.0227, 'lps'),
	(372437, 126, '2015-01-15 00:23:21.000000', 'consum', 0.0225, 'lps'),
	(372438, 126, '2015-01-15 00:23:22.000000', 'consum', 0.0218, 'lps'),
	(372439, 126, '2015-01-15 00:23:23.000000', 'consum', 0.0222, 'lps'),
	(372440, 126, '2015-01-15 00:23:24.000000', 'consum', 0.0227, 'lps'),
	(372441, 126, '2015-01-15 00:23:25.000000', 'consum', 0.0221, 'lps'),
	(372442, 126, '2015-01-15 00:23:26.000000', 'consum', 0.0215, 'lps'),
	(372443, 126, '2015-01-15 00:23:27.000000', 'consum', 0.0221, 'lps'),
	(372444, 126, '2015-01-15 00:23:28.000000', 'consum', 0.0214, 'lps'),
	(372445, 126, '2015-01-15 00:23:29.000000', 'consum', 0.0214, 'lps'),
	(372446, 126, '2015-01-15 00:23:30.000000', 'consum', 0.0220, 'lps'),
	(372447, 126, '2015-01-15 00:23:31.000000', 'consum', 0.0210, 'lps'),
	(372448, 126, '2015-01-15 00:23:32.000000', 'consum', 0.0218, 'lps'),
	(372449, 126, '2015-01-15 00:23:33.000000', 'consum', 0.0214, 'lps'),
	(372450, 126, '2015-01-15 00:23:34.000000', 'consum', 0.0225, 'lps'),
	(372451, 126, '2015-01-15 00:23:35.000000', 'consum', 0.0216, 'lps'),
	(372452, 126, '2015-01-15 00:23:36.000000', 'consum', 0.0216, 'lps'),
	(372453, 126, '2015-01-15 00:23:37.000000', 'consum', 0.0222, 'lps'),
	(372454, 126, '2015-01-15 00:23:38.000000', 'consum', 0.0215, 'lps'),
	(372455, 126, '2015-01-15 00:23:39.000000', 'consum', 0.0217, 'lps'),
	(372456, 126, '2015-01-15 00:23:40.000000', 'consum', 0.0210, 'lps'),
	(372457, 126, '2015-01-15 00:23:41.000000', 'consum', 0.0211, 'lps'),
	(372458, 126, '2015-01-15 00:23:42.000000', 'consum', 0.0213, 'lps'),
	(372459, 126, '2015-01-15 00:23:43.000000', 'consum', 0.0225, 'lps'),
	(372460, 126, '2015-01-15 00:23:44.000000', 'consum', 0.0220, 'lps'),
	(372461, 126, '2015-01-15 00:23:45.000000', 'consum', 0.0216, 'lps'),
	(372462, 126, '2015-01-15 00:23:46.000000', 'consum', 0.0211, 'lps'),
	(372463, 126, '2015-01-15 00:23:47.000000', 'consum', 0.0217, 'lps'),
	(372464, 126, '2015-01-15 00:23:48.000000', 'consum', 0.0223, 'lps'),
	(372465, 126, '2015-01-15 00:23:49.000000', 'consum', 0.0218, 'lps'),
	(372466, 126, '2015-01-15 00:23:50.000000', 'consum', 0.0227, 'lps'),
	(372467, 126, '2015-01-15 00:23:51.000000', 'consum', 0.0218, 'lps'),
	(372468, 126, '2015-01-15 00:23:52.000000', 'consum', 0.0217, 'lps'),
	(372469, 126, '2015-01-15 00:23:53.000000', 'consum', 0.0220, 'lps'),
	(372470, 126, '2015-01-15 00:23:54.000000', 'consum', 0.0222, 'lps'),
	(372471, 126, '2015-01-15 00:23:55.000000', 'consum', 0.0222, 'lps'),
	(372472, 126, '2015-01-15 00:23:56.000000', 'consum', 0.0215, 'lps'),
	(372473, 126, '2015-01-15 00:23:57.000000', 'consum', 0.0221, 'lps'),
	(372474, 126, '2015-01-15 00:23:58.000000', 'consum', 0.0228, 'lps'),
	(372475, 126, '2015-01-15 00:23:59.000000', 'consum', 0.0211, 'lps'),
	(372476, 126, '2015-01-15 00:24:00.000000', 'consum', 0.0221, 'lps'),
	(372477, 126, '2015-01-15 00:24:01.000000', 'consum', 0.0222, 'lps'),
	(372478, 126, '2015-01-15 00:24:02.000000', 'consum', 0.0218, 'lps'),
	(372479, 126, '2015-01-15 00:24:03.000000', 'consum', 0.0213, 'lps'),
	(372480, 126, '2015-01-15 00:24:04.000000', 'consum', 0.0224, 'lps'),
	(372481, 126, '2015-01-15 00:24:05.000000', 'consum', 0.0214, 'lps'),
	(372482, 126, '2015-01-15 00:24:06.000000', 'consum', 0.0226, 'lps'),
	(372483, 126, '2015-01-15 00:24:07.000000', 'consum', 0.0222, 'lps'),
	(372484, 126, '2015-01-15 00:24:08.000000', 'consum', 0.0221, 'lps'),
	(372485, 126, '2015-01-15 00:24:09.000000', 'consum', 0.0210, 'lps'),
	(372486, 126, '2015-01-15 00:24:10.000000', 'consum', 0.0216, 'lps'),
	(372487, 126, '2015-01-15 00:24:11.000000', 'consum', 0.0220, 'lps'),
	(372488, 126, '2015-01-15 00:24:12.000000', 'consum', 0.0226, 'lps'),
	(372489, 126, '2015-01-15 00:24:13.000000', 'consum', 0.0221, 'lps'),
	(372490, 126, '2015-01-15 00:24:14.000000', 'consum', 0.0220, 'lps'),
	(372491, 126, '2015-01-15 00:24:15.000000', 'consum', 0.0226, 'lps'),
	(372492, 126, '2015-01-15 00:24:16.000000', 'consum', 0.0221, 'lps'),
	(372493, 126, '2015-01-15 00:24:17.000000', 'consum', 0.0217, 'lps'),
	(372494, 126, '2015-01-15 00:24:18.000000', 'consum', 0.0215, 'lps'),
	(372495, 126, '2015-01-15 00:24:19.000000', 'consum', 0.0213, 'lps'),
	(372496, 126, '2015-01-15 00:24:20.000000', 'consum', 0.0228, 'lps'),
	(372497, 126, '2015-01-15 00:24:21.000000', 'consum', 0.0218, 'lps'),
	(372498, 126, '2015-01-15 00:24:22.000000', 'consum', 0.0215, 'lps'),
	(372499, 126, '2015-01-15 00:24:23.000000', 'consum', 0.0212, 'lps'),
	(372500, 126, '2015-01-15 00:24:24.000000', 'consum', 0.0226, 'lps'),
	(372501, 126, '2015-01-15 00:24:25.000000', 'consum', 0.0226, 'lps'),
	(372502, 126, '2015-01-15 00:24:26.000000', 'consum', 0.0223, 'lps'),
	(372503, 126, '2015-01-15 00:24:27.000000', 'consum', 0.0227, 'lps'),
	(372504, 126, '2015-01-15 00:24:28.000000', 'consum', 0.0219, 'lps'),
	(372505, 126, '2015-01-15 00:24:29.000000', 'consum', 0.0222, 'lps'),
	(372506, 126, '2015-01-15 00:24:30.000000', 'consum', 0.0227, 'lps'),
	(372507, 126, '2015-01-15 00:24:31.000000', 'consum', 0.0219, 'lps'),
	(372508, 126, '2015-01-15 00:24:32.000000', 'consum', 0.0224, 'lps'),
	(372509, 126, '2015-01-15 00:24:33.000000', 'consum', 0.0218, 'lps'),
	(372510, 126, '2015-01-15 00:24:34.000000', 'consum', 0.0225, 'lps'),
	(372511, 126, '2015-01-15 00:24:35.000000', 'consum', 0.0225, 'lps'),
	(372512, 126, '2015-01-15 00:24:36.000000', 'consum', 0.0220, 'lps'),
	(372513, 126, '2015-01-15 00:24:37.000000', 'consum', 0.0217, 'lps'),
	(372514, 126, '2015-01-15 00:24:38.000000', 'consum', 0.0216, 'lps'),
	(372515, 126, '2015-01-15 00:24:39.000000', 'consum', 0.0217, 'lps'),
	(372516, 126, '2015-01-15 00:24:40.000000', 'consum', 0.0210, 'lps'),
	(372517, 126, '2015-01-15 00:24:41.000000', 'consum', 0.0228, 'lps'),
	(372518, 126, '2015-01-15 00:24:42.000000', 'consum', 0.0225, 'lps'),
	(372519, 126, '2015-01-15 00:24:43.000000', 'consum', 0.0211, 'lps'),
	(372520, 126, '2015-01-15 00:24:44.000000', 'consum', 0.0210, 'lps'),
	(372521, 126, '2015-01-15 00:24:45.000000', 'consum', 0.0228, 'lps'),
	(372522, 126, '2015-01-15 00:24:46.000000', 'consum', 0.0223, 'lps'),
	(372523, 126, '2015-01-15 00:24:47.000000', 'consum', 0.0220, 'lps'),
	(372524, 126, '2015-01-15 00:24:48.000000', 'consum', 0.0221, 'lps'),
	(372525, 126, '2015-01-15 00:24:49.000000', 'consum', 0.0216, 'lps'),
	(372526, 126, '2015-01-15 00:24:50.000000', 'consum', 0.0227, 'lps'),
	(372527, 126, '2015-01-15 00:24:51.000000', 'consum', 0.0222, 'lps'),
	(372528, 126, '2015-01-15 00:24:52.000000', 'consum', 0.0217, 'lps'),
	(372529, 126, '2015-01-15 00:24:53.000000', 'consum', 0.0212, 'lps'),
	(372530, 126, '2015-01-15 00:24:54.000000', 'consum', 0.0218, 'lps'),
	(372531, 126, '2015-01-15 00:24:55.000000', 'consum', 0.0227, 'lps'),
	(372532, 126, '2015-01-15 00:24:56.000000', 'consum', 0.0214, 'lps'),
	(372533, 126, '2015-01-15 00:24:57.000000', 'consum', 0.0218, 'lps'),
	(372534, 126, '2015-01-15 00:24:58.000000', 'consum', 0.0218, 'lps'),
	(372535, 126, '2015-01-15 00:24:59.000000', 'consum', 0.0227, 'lps'),
	(372536, 126, '2015-01-15 00:25:00.000000', 'consum', 0.0214, 'lps'),
	(372537, 126, '2015-01-15 00:25:01.000000', 'consum', 0.0218, 'lps'),
	(372538, 126, '2015-01-15 00:25:02.000000', 'consum', 0.0220, 'lps'),
	(372539, 126, '2015-01-15 00:25:03.000000', 'consum', 0.0218, 'lps'),
	(372540, 126, '2015-01-15 00:25:04.000000', 'consum', 0.0221, 'lps'),
	(372541, 126, '2015-01-15 00:25:05.000000', 'consum', 0.0222, 'lps'),
	(372542, 126, '2015-01-15 00:25:06.000000', 'consum', 0.0217, 'lps'),
	(372543, 126, '2015-01-15 00:25:07.000000', 'consum', 0.0212, 'lps'),
	(372544, 126, '2015-01-15 00:25:08.000000', 'consum', 0.0217, 'lps'),
	(372545, 126, '2015-01-15 00:25:09.000000', 'consum', 0.0219, 'lps'),
	(372546, 126, '2015-01-15 00:25:10.000000', 'consum', 0.0216, 'lps'),
	(372547, 126, '2015-01-15 00:25:11.000000', 'consum', 0.0216, 'lps'),
	(372548, 126, '2015-01-15 00:25:12.000000', 'consum', 0.0221, 'lps'),
	(372549, 126, '2015-01-15 00:25:13.000000', 'consum', 0.0226, 'lps'),
	(372550, 126, '2015-01-15 00:25:14.000000', 'consum', 0.0223, 'lps'),
	(372551, 126, '2015-01-15 00:25:15.000000', 'consum', 0.0228, 'lps'),
	(372552, 126, '2015-01-15 00:25:16.000000', 'consum', 0.0222, 'lps'),
	(372553, 126, '2015-01-15 00:25:17.000000', 'consum', 0.0215, 'lps'),
	(372554, 126, '2015-01-15 00:25:18.000000', 'consum', 0.0221, 'lps'),
	(372555, 126, '2015-01-15 00:25:19.000000', 'consum', 0.0214, 'lps'),
	(372556, 126, '2015-01-15 00:25:20.000000', 'consum', 0.0213, 'lps'),
	(372557, 126, '2015-01-15 00:25:21.000000', 'consum', 0.0214, 'lps'),
	(372558, 126, '2015-01-15 00:25:22.000000', 'consum', 0.0220, 'lps'),
	(372559, 126, '2015-01-15 00:25:23.000000', 'consum', 0.0212, 'lps'),
	(372560, 126, '2015-01-15 00:25:24.000000', 'consum', 0.0228, 'lps'),
	(372561, 126, '2015-01-15 00:25:25.000000', 'consum', 0.0217, 'lps'),
	(372562, 126, '2015-01-15 00:25:26.000000', 'consum', 0.0212, 'lps'),
	(372563, 126, '2015-01-15 00:25:27.000000', 'consum', 0.0218, 'lps'),
	(372564, 126, '2015-01-15 00:25:28.000000', 'consum', 0.0226, 'lps'),
	(372565, 126, '2015-01-15 00:25:29.000000', 'consum', 0.0210, 'lps'),
	(372566, 126, '2015-01-15 00:25:30.000000', 'consum', 0.0218, 'lps'),
	(372567, 126, '2015-01-15 00:25:31.000000', 'consum', 0.0212, 'lps'),
	(372568, 126, '2015-01-15 00:25:32.000000', 'consum', 0.0214, 'lps'),
	(372569, 126, '2015-01-15 00:25:33.000000', 'consum', 0.0228, 'lps'),
	(372570, 126, '2015-01-15 00:25:34.000000', 'consum', 0.0211, 'lps'),
	(372571, 126, '2015-01-15 00:25:35.000000', 'consum', 0.0217, 'lps'),
	(372572, 126, '2015-01-15 00:25:36.000000', 'consum', 0.0226, 'lps'),
	(372573, 126, '2015-01-15 00:25:37.000000', 'consum', 0.0228, 'lps'),
	(372574, 126, '2015-01-15 00:25:38.000000', 'consum', 0.0218, 'lps'),
	(372575, 126, '2015-01-15 00:25:39.000000', 'consum', 0.0216, 'lps'),
	(372576, 126, '2015-01-15 00:25:40.000000', 'consum', 0.0214, 'lps'),
	(372577, 126, '2015-01-15 00:25:41.000000', 'consum', 0.0211, 'lps'),
	(372578, 126, '2015-01-15 00:25:42.000000', 'consum', 0.0226, 'lps'),
	(372579, 126, '2015-01-15 00:25:43.000000', 'consum', 0.0211, 'lps'),
	(372580, 126, '2015-01-15 00:25:44.000000', 'consum', 0.0222, 'lps'),
	(372581, 126, '2015-01-15 00:25:45.000000', 'consum', 0.0214, 'lps'),
	(372582, 126, '2015-01-15 00:25:46.000000', 'consum', 0.0211, 'lps'),
	(372583, 126, '2015-01-15 00:25:47.000000', 'consum', 0.0224, 'lps'),
	(372584, 126, '2015-01-15 00:25:48.000000', 'consum', 0.0220, 'lps'),
	(372585, 126, '2015-01-15 00:25:49.000000', 'consum', 0.0216, 'lps'),
	(372586, 126, '2015-01-15 00:25:50.000000', 'consum', 0.0214, 'lps'),
	(372587, 126, '2015-01-15 00:25:51.000000', 'consum', 0.0211, 'lps'),
	(372588, 126, '2015-01-15 00:25:52.000000', 'consum', 0.0224, 'lps'),
	(372589, 126, '2015-01-15 00:25:53.000000', 'consum', 0.0219, 'lps'),
	(372590, 126, '2015-01-15 00:25:54.000000', 'consum', 0.0216, 'lps'),
	(372591, 126, '2015-01-15 00:25:55.000000', 'consum', 0.0212, 'lps'),
	(372592, 126, '2015-01-15 00:25:56.000000', 'consum', 0.0222, 'lps'),
	(372593, 126, '2015-01-15 00:25:57.000000', 'consum', 0.0227, 'lps'),
	(372594, 126, '2015-01-15 00:25:58.000000', 'consum', 0.0220, 'lps'),
	(372595, 126, '2015-01-15 00:25:59.000000', 'consum', 0.0211, 'lps'),
	(372596, 126, '2015-01-15 00:26:00.000000', 'consum', 0.0223, 'lps'),
	(372597, 126, '2015-01-15 00:26:01.000000', 'consum', 0.0214, 'lps'),
	(372598, 126, '2015-01-15 00:26:02.000000', 'consum', 0.0212, 'lps'),
	(372599, 126, '2015-01-15 00:26:03.000000', 'consum', 0.0226, 'lps'),
	(372600, 126, '2015-01-15 00:26:04.000000', 'consum', 0.0211, 'lps'),
	(372601, 126, '2015-01-15 00:26:05.000000', 'consum', 0.0222, 'lps'),
	(372602, 126, '2015-01-15 00:26:06.000000', 'consum', 0.0211, 'lps'),
	(372603, 126, '2015-01-15 00:26:07.000000', 'consum', 0.0219, 'lps'),
	(372604, 126, '2015-01-15 00:26:08.000000', 'consum', 0.0214, 'lps'),
	(372605, 126, '2015-01-15 00:26:09.000000', 'consum', 0.0224, 'lps'),
	(372606, 126, '2015-01-15 00:26:10.000000', 'consum', 0.0212, 'lps'),
	(372607, 126, '2015-01-15 00:26:11.000000', 'consum', 0.0214, 'lps'),
	(372608, 126, '2015-01-15 00:26:12.000000', 'consum', 0.0224, 'lps'),
	(372609, 126, '2015-01-15 00:26:13.000000', 'consum', 0.0212, 'lps'),
	(372610, 126, '2015-01-15 00:26:14.000000', 'consum', 0.0219, 'lps'),
	(372611, 126, '2015-01-15 00:26:15.000000', 'consum', 0.0210, 'lps'),
	(372612, 126, '2015-01-15 00:26:16.000000', 'consum', 0.0220, 'lps'),
	(372613, 126, '2015-01-15 00:26:17.000000', 'consum', 0.0225, 'lps'),
	(372614, 126, '2015-01-15 00:26:18.000000', 'consum', 0.0216, 'lps'),
	(372615, 126, '2015-01-15 00:26:19.000000', 'consum', 0.0213, 'lps'),
	(372616, 126, '2015-01-15 00:26:20.000000', 'consum', 0.0211, 'lps'),
	(372617, 126, '2015-01-15 00:26:21.000000', 'consum', 0.0222, 'lps'),
	(372618, 126, '2015-01-15 00:26:22.000000', 'consum', 0.0213, 'lps'),
	(372619, 126, '2015-01-15 00:26:23.000000', 'consum', 0.0228, 'lps'),
	(372620, 126, '2015-01-15 00:26:24.000000', 'consum', 0.0215, 'lps'),
	(372621, 126, '2015-01-15 00:26:25.000000', 'consum', 0.0218, 'lps'),
	(372622, 126, '2015-01-15 00:26:26.000000', 'consum', 0.0217, 'lps'),
	(372623, 126, '2015-01-15 00:26:27.000000', 'consum', 0.0222, 'lps'),
	(372624, 126, '2015-01-15 00:26:28.000000', 'consum', 0.0228, 'lps'),
	(372625, 126, '2015-01-15 00:26:29.000000', 'consum', 0.0211, 'lps'),
	(372626, 126, '2015-01-15 00:26:30.000000', 'consum', 0.0217, 'lps'),
	(372627, 126, '2015-01-15 00:26:31.000000', 'consum', 0.0225, 'lps'),
	(372628, 126, '2015-01-15 00:26:32.000000', 'consum', 0.0227, 'lps'),
	(372629, 126, '2015-01-15 00:26:33.000000', 'consum', 0.0213, 'lps'),
	(372630, 126, '2015-01-15 00:26:34.000000', 'consum', 0.0211, 'lps'),
	(372631, 126, '2015-01-15 00:26:35.000000', 'consum', 0.0225, 'lps'),
	(372632, 126, '2015-01-15 00:26:36.000000', 'consum', 0.0228, 'lps'),
	(372633, 126, '2015-01-15 00:26:37.000000', 'consum', 0.0215, 'lps'),
	(372634, 126, '2015-01-15 00:26:38.000000', 'consum', 0.0219, 'lps'),
	(372635, 126, '2015-01-15 00:26:39.000000', 'consum', 0.0223, 'lps'),
	(372636, 126, '2015-01-15 00:26:40.000000', 'consum', 0.0227, 'lps'),
	(372637, 126, '2015-01-15 00:26:41.000000', 'consum', 0.0221, 'lps'),
	(372638, 126, '2015-01-15 00:26:42.000000', 'consum', 0.0215, 'lps'),
	(372639, 126, '2015-01-15 00:26:43.000000', 'consum', 0.0221, 'lps'),
	(372640, 126, '2015-01-15 00:26:44.000000', 'consum', 0.0210, 'lps'),
	(372641, 126, '2015-01-15 00:26:45.000000', 'consum', 0.0218, 'lps'),
	(372642, 126, '2015-01-15 00:26:46.000000', 'consum', 0.0211, 'lps'),
	(372643, 126, '2015-01-15 00:26:47.000000', 'consum', 0.0211, 'lps'),
	(372644, 126, '2015-01-15 00:26:48.000000', 'consum', 0.0214, 'lps'),
	(372645, 126, '2015-01-15 00:26:49.000000', 'consum', 0.0227, 'lps'),
	(372646, 126, '2015-01-15 00:26:50.000000', 'consum', 0.0227, 'lps'),
	(372647, 126, '2015-01-15 00:26:51.000000', 'consum', 0.0226, 'lps'),
	(372648, 126, '2015-01-15 00:26:52.000000', 'consum', 0.0218, 'lps'),
	(372649, 126, '2015-01-15 00:26:53.000000', 'consum', 0.0224, 'lps'),
	(372650, 126, '2015-01-15 00:26:54.000000', 'consum', 0.0217, 'lps'),
	(372651, 126, '2015-01-15 00:26:55.000000', 'consum', 0.0224, 'lps'),
	(372652, 126, '2015-01-15 00:26:56.000000', 'consum', 0.0220, 'lps'),
	(372653, 126, '2015-01-15 00:26:57.000000', 'consum', 0.0219, 'lps'),
	(372654, 126, '2015-01-15 00:26:58.000000', 'consum', 0.0224, 'lps'),
	(372655, 126, '2015-01-15 00:26:59.000000', 'consum', 0.0218, 'lps'),
	(372656, 126, '2015-01-15 00:27:00.000000', 'consum', 0.0228, 'lps'),
	(372657, 126, '2015-01-15 00:27:01.000000', 'consum', 0.0220, 'lps'),
	(372658, 126, '2015-01-15 00:27:02.000000', 'consum', 0.0226, 'lps'),
	(372659, 126, '2015-01-15 00:27:03.000000', 'consum', 0.0223, 'lps'),
	(372660, 126, '2015-01-15 00:27:04.000000', 'consum', 0.0226, 'lps'),
	(372661, 126, '2015-01-15 00:27:05.000000', 'consum', 0.0214, 'lps'),
	(372662, 126, '2015-01-15 00:27:06.000000', 'consum', 0.0220, 'lps'),
	(372663, 126, '2015-01-15 00:27:07.000000', 'consum', 0.0213, 'lps'),
	(372664, 126, '2015-01-15 00:27:08.000000', 'consum', 0.0212, 'lps'),
	(372665, 126, '2015-01-15 00:27:09.000000', 'consum', 0.0214, 'lps'),
	(372666, 126, '2015-01-15 00:27:10.000000', 'consum', 0.0223, 'lps'),
	(372667, 126, '2015-01-15 00:27:11.000000', 'consum', 0.0224, 'lps'),
	(372668, 126, '2015-01-15 00:27:12.000000', 'consum', 0.0223, 'lps'),
	(372669, 126, '2015-01-15 00:27:13.000000', 'consum', 0.0217, 'lps'),
	(372670, 126, '2015-01-15 00:27:14.000000', 'consum', 0.0223, 'lps'),
	(372671, 126, '2015-01-15 00:27:15.000000', 'consum', 0.0217, 'lps'),
	(372672, 126, '2015-01-15 00:27:16.000000', 'consum', 0.0225, 'lps'),
	(372673, 126, '2015-01-15 00:27:17.000000', 'consum', 0.0210, 'lps'),
	(372674, 126, '2015-01-15 00:27:18.000000', 'consum', 0.0219, 'lps'),
	(372675, 126, '2015-01-15 00:27:19.000000', 'consum', 0.0219, 'lps'),
	(372676, 126, '2015-01-15 00:27:20.000000', 'consum', 0.0211, 'lps'),
	(372677, 126, '2015-01-15 00:27:21.000000', 'consum', 0.0226, 'lps'),
	(372678, 126, '2015-01-15 00:27:22.000000', 'consum', 0.0213, 'lps'),
	(372679, 126, '2015-01-15 00:27:23.000000', 'consum', 0.0214, 'lps'),
	(372680, 126, '2015-01-15 00:27:24.000000', 'consum', 0.0222, 'lps'),
	(372681, 126, '2015-01-15 00:27:25.000000', 'consum', 0.0221, 'lps'),
	(372682, 126, '2015-01-15 00:27:26.000000', 'consum', 0.0210, 'lps'),
	(372683, 126, '2015-01-15 00:27:27.000000', 'consum', 0.0216, 'lps'),
	(372684, 126, '2015-01-15 00:27:28.000000', 'consum', 0.0223, 'lps'),
	(372685, 126, '2015-01-15 00:27:29.000000', 'consum', 0.0218, 'lps'),
	(372686, 126, '2015-01-15 00:27:30.000000', 'consum', 0.0211, 'lps'),
	(372687, 126, '2015-01-15 00:27:31.000000', 'consum', 0.0211, 'lps'),
	(372688, 126, '2015-01-15 00:27:32.000000', 'consum', 0.0211, 'lps'),
	(372689, 126, '2015-01-15 00:27:33.000000', 'consum', 0.0213, 'lps'),
	(372690, 126, '2015-01-15 00:27:34.000000', 'consum', 0.0225, 'lps'),
	(372691, 126, '2015-01-15 00:27:35.000000', 'consum', 0.0218, 'lps'),
	(372692, 126, '2015-01-15 00:27:36.000000', 'consum', 0.0223, 'lps'),
	(372693, 126, '2015-01-15 00:27:37.000000', 'consum', 0.0214, 'lps'),
	(372694, 126, '2015-01-15 00:27:38.000000', 'consum', 0.0212, 'lps'),
	(372695, 126, '2015-01-15 00:27:39.000000', 'consum', 0.0226, 'lps'),
	(372696, 126, '2015-01-15 00:27:40.000000', 'consum', 0.0227, 'lps'),
	(372697, 126, '2015-01-15 00:27:41.000000', 'consum', 0.0227, 'lps'),
	(372698, 126, '2015-01-15 00:27:42.000000', 'consum', 0.0228, 'lps'),
	(372699, 126, '2015-01-15 00:27:43.000000', 'consum', 0.0212, 'lps'),
	(372700, 126, '2015-01-15 00:27:44.000000', 'consum', 0.0225, 'lps'),
	(372701, 126, '2015-01-15 00:27:45.000000', 'consum', 0.0220, 'lps'),
	(372702, 126, '2015-01-15 00:27:46.000000', 'consum', 0.0215, 'lps'),
	(372703, 126, '2015-01-15 00:27:47.000000', 'consum', 0.0224, 'lps'),
	(372704, 126, '2015-01-15 00:27:48.000000', 'consum', 0.0227, 'lps'),
	(372705, 126, '2015-01-15 00:27:49.000000', 'consum', 0.0217, 'lps'),
	(372706, 126, '2015-01-15 00:27:50.000000', 'consum', 0.0215, 'lps'),
	(372707, 126, '2015-01-15 00:27:51.000000', 'consum', 0.0213, 'lps'),
	(372708, 126, '2015-01-15 00:27:52.000000', 'consum', 0.0211, 'lps'),
	(372709, 126, '2015-01-15 00:27:53.000000', 'consum', 0.0223, 'lps'),
	(372710, 126, '2015-01-15 00:27:54.000000', 'consum', 0.0219, 'lps'),
	(372711, 126, '2015-01-15 00:27:55.000000', 'consum', 0.0215, 'lps'),
	(372712, 126, '2015-01-15 00:27:56.000000', 'consum', 0.0227, 'lps'),
	(372713, 126, '2015-01-15 00:27:57.000000', 'consum', 0.0223, 'lps'),
	(372714, 126, '2015-01-15 00:27:58.000000', 'consum', 0.0227, 'lps'),
	(372715, 126, '2015-01-15 00:27:59.000000', 'consum', 0.0216, 'lps'),
	(372716, 126, '2015-01-15 00:28:00.000000', 'consum', 0.0228, 'lps'),
	(372717, 126, '2015-01-15 00:28:01.000000', 'consum', 0.0226, 'lps'),
	(372718, 126, '2015-01-15 00:28:02.000000', 'consum', 0.0215, 'lps'),
	(372719, 126, '2015-01-15 00:28:03.000000', 'consum', 0.0228, 'lps'),
	(372720, 126, '2015-01-15 00:28:04.000000', 'consum', 0.0210, 'lps'),
	(372721, 126, '2015-01-15 00:28:05.000000', 'consum', 0.0211, 'lps'),
	(372722, 126, '2015-01-15 00:28:06.000000', 'consum', 0.0217, 'lps'),
	(372723, 126, '2015-01-15 00:28:07.000000', 'consum', 0.0225, 'lps'),
	(372724, 126, '2015-01-15 00:28:08.000000', 'consum', 0.0225, 'lps'),
	(372725, 126, '2015-01-15 00:28:09.000000', 'consum', 0.0221, 'lps'),
	(372726, 126, '2015-01-15 00:28:10.000000', 'consum', 0.0223, 'lps'),
	(372727, 126, '2015-01-15 00:28:11.000000', 'consum', 0.0221, 'lps'),
	(372728, 126, '2015-01-15 00:28:12.000000', 'consum', 0.0210, 'lps'),
	(372729, 126, '2015-01-15 00:28:13.000000', 'consum', 0.0214, 'lps'),
	(372730, 126, '2015-01-15 00:28:14.000000', 'consum', 0.0211, 'lps'),
	(372731, 126, '2015-01-15 00:28:15.000000', 'consum', 0.0222, 'lps'),
	(372732, 126, '2015-01-15 00:28:16.000000', 'consum', 0.0210, 'lps'),
	(372733, 126, '2015-01-15 00:28:17.000000', 'consum', 0.0215, 'lps'),
	(372734, 126, '2015-01-15 00:28:18.000000', 'consum', 0.0213, 'lps'),
	(372735, 126, '2015-01-15 00:28:19.000000', 'consum', 0.0213, 'lps'),
	(372736, 126, '2015-01-15 00:28:20.000000', 'consum', 0.0217, 'lps'),
	(372737, 126, '2015-01-15 00:28:21.000000', 'consum', 0.0218, 'lps'),
	(372738, 126, '2015-01-15 00:28:22.000000', 'consum', 0.0212, 'lps'),
	(372739, 126, '2015-01-15 00:28:23.000000', 'consum', 0.0212, 'lps'),
	(372740, 126, '2015-01-15 00:28:24.000000', 'consum', 0.0215, 'lps'),
	(372741, 126, '2015-01-15 00:28:25.000000', 'consum', 0.0211, 'lps'),
	(372742, 126, '2015-01-15 00:28:26.000000', 'consum', 0.0218, 'lps'),
	(372743, 126, '2015-01-15 00:28:27.000000', 'consum', 0.0228, 'lps'),
	(372744, 126, '2015-01-15 00:28:28.000000', 'consum', 0.0220, 'lps'),
	(372745, 126, '2015-01-15 00:28:29.000000', 'consum', 0.0228, 'lps'),
	(372746, 126, '2015-01-15 00:28:30.000000', 'consum', 0.0210, 'lps'),
	(372747, 126, '2015-01-15 00:28:31.000000', 'consum', 0.0216, 'lps'),
	(372748, 126, '2015-01-15 00:28:32.000000', 'consum', 0.0221, 'lps'),
	(372749, 126, '2015-01-15 00:28:33.000000', 'consum', 0.0211, 'lps'),
	(372750, 126, '2015-01-15 00:28:34.000000', 'consum', 0.0220, 'lps'),
	(372751, 126, '2015-01-15 00:28:35.000000', 'consum', 0.0221, 'lps'),
	(372752, 126, '2015-01-15 00:28:36.000000', 'consum', 0.0216, 'lps'),
	(372753, 126, '2015-01-15 00:28:37.000000', 'consum', 0.0225, 'lps'),
	(372754, 126, '2015-01-15 00:28:38.000000', 'consum', 0.0210, 'lps'),
	(372755, 126, '2015-01-15 00:28:39.000000', 'consum', 0.0222, 'lps'),
	(372756, 126, '2015-01-15 00:28:40.000000', 'consum', 0.0214, 'lps'),
	(372757, 126, '2015-01-15 00:28:41.000000', 'consum', 0.0214, 'lps'),
	(372758, 126, '2015-01-15 00:28:42.000000', 'consum', 0.0218, 'lps'),
	(372759, 126, '2015-01-15 00:28:43.000000', 'consum', 0.0221, 'lps'),
	(372760, 126, '2015-01-15 00:28:44.000000', 'consum', 0.0222, 'lps'),
	(372761, 126, '2015-01-15 00:28:45.000000', 'consum', 0.0218, 'lps'),
	(372762, 126, '2015-01-15 00:28:46.000000', 'consum', 0.0213, 'lps'),
	(372763, 126, '2015-01-15 00:28:47.000000', 'consum', 0.0223, 'lps'),
	(372764, 126, '2015-01-15 00:28:48.000000', 'consum', 0.0227, 'lps'),
	(372765, 126, '2015-01-15 00:28:49.000000', 'consum', 0.0220, 'lps'),
	(372766, 126, '2015-01-15 00:28:50.000000', 'consum', 0.0227, 'lps'),
	(372767, 126, '2015-01-15 00:28:51.000000', 'consum', 0.0210, 'lps'),
	(372768, 126, '2015-01-15 00:28:52.000000', 'consum', 0.0215, 'lps'),
	(372769, 126, '2015-01-15 00:28:53.000000', 'consum', 0.0217, 'lps'),
	(372770, 126, '2015-01-15 00:28:54.000000', 'consum', 0.0212, 'lps'),
	(372771, 126, '2015-01-15 00:28:55.000000', 'consum', 0.0220, 'lps'),
	(372772, 126, '2015-01-15 00:28:56.000000', 'consum', 0.0214, 'lps'),
	(372773, 126, '2015-01-15 00:28:57.000000', 'consum', 0.0219, 'lps'),
	(372774, 126, '2015-01-15 00:28:58.000000', 'consum', 0.0225, 'lps'),
	(372775, 126, '2015-01-15 00:28:59.000000', 'consum', 0.0222, 'lps'),
	(372776, 126, '2015-01-15 00:29:00.000000', 'consum', 0.0223, 'lps'),
	(372777, 126, '2015-01-15 00:29:01.000000', 'consum', 0.0221, 'lps'),
	(372778, 126, '2015-01-15 00:29:02.000000', 'consum', 0.0228, 'lps'),
	(372779, 126, '2015-01-15 00:29:03.000000', 'consum', 0.0211, 'lps'),
	(372780, 126, '2015-01-15 00:29:04.000000', 'consum', 0.0216, 'lps'),
	(372781, 126, '2015-01-15 00:29:05.000000', 'consum', 0.0222, 'lps'),
	(372782, 126, '2015-01-15 00:29:06.000000', 'consum', 0.0212, 'lps'),
	(372783, 126, '2015-01-15 00:29:07.000000', 'consum', 0.0221, 'lps'),
	(372784, 126, '2015-01-15 00:29:08.000000', 'consum', 0.0225, 'lps'),
	(372785, 126, '2015-01-15 00:29:09.000000', 'consum', 0.0211, 'lps'),
	(372786, 126, '2015-01-15 00:29:10.000000', 'consum', 0.0210, 'lps'),
	(372787, 126, '2015-01-15 00:29:11.000000', 'consum', 0.0226, 'lps'),
	(372788, 126, '2015-01-15 00:29:12.000000', 'consum', 0.0217, 'lps'),
	(372789, 126, '2015-01-15 00:29:13.000000', 'consum', 0.0215, 'lps'),
	(372790, 126, '2015-01-15 00:29:14.000000', 'consum', 0.0212, 'lps'),
	(372791, 126, '2015-01-15 00:29:15.000000', 'consum', 0.0228, 'lps'),
	(372792, 126, '2015-01-15 00:29:16.000000', 'consum', 0.0218, 'lps'),
	(372793, 126, '2015-01-15 00:29:17.000000', 'consum', 0.0214, 'lps'),
	(372794, 126, '2015-01-15 00:29:18.000000', 'consum', 0.0228, 'lps'),
	(372795, 126, '2015-01-15 00:29:19.000000', 'consum', 0.0228, 'lps'),
	(372796, 126, '2015-01-15 00:29:20.000000', 'consum', 0.0210, 'lps'),
	(372797, 126, '2015-01-15 00:29:21.000000', 'consum', 0.0216, 'lps'),
	(372798, 126, '2015-01-15 00:29:22.000000', 'consum', 0.0218, 'lps'),
	(372799, 126, '2015-01-15 00:29:23.000000', 'consum', 0.0216, 'lps'),
	(372800, 126, '2015-01-15 00:29:24.000000', 'consum', 0.0217, 'lps'),
	(372801, 126, '2015-01-15 00:29:25.000000', 'consum', 0.0228, 'lps'),
	(372802, 126, '2015-01-15 00:29:26.000000', 'consum', 0.0222, 'lps'),
	(372803, 126, '2015-01-15 00:29:27.000000', 'consum', 0.0217, 'lps'),
	(372804, 126, '2015-01-15 00:29:28.000000', 'consum', 0.0210, 'lps'),
	(372805, 126, '2015-01-15 00:29:29.000000', 'consum', 0.0227, 'lps'),
	(372806, 126, '2015-01-15 00:29:30.000000', 'consum', 0.0218, 'lps'),
	(372807, 126, '2015-01-15 00:29:31.000000', 'consum', 0.0220, 'lps'),
	(372808, 126, '2015-01-15 00:29:32.000000', 'consum', 0.0216, 'lps'),
	(372809, 126, '2015-01-15 00:29:33.000000', 'consum', 0.0210, 'lps'),
	(372810, 126, '2015-01-15 00:29:34.000000', 'consum', 0.0212, 'lps'),
	(372811, 126, '2015-01-15 00:29:35.000000', 'consum', 0.0223, 'lps'),
	(372812, 126, '2015-01-15 00:29:36.000000', 'consum', 0.0228, 'lps'),
	(372813, 126, '2015-01-15 00:29:37.000000', 'consum', 0.0226, 'lps'),
	(372814, 126, '2015-01-15 00:29:38.000000', 'consum', 0.0218, 'lps'),
	(372815, 126, '2015-01-15 00:29:39.000000', 'consum', 0.0220, 'lps'),
	(372816, 126, '2015-01-15 00:29:40.000000', 'consum', 0.0216, 'lps'),
	(372817, 126, '2015-01-15 00:29:41.000000', 'consum', 0.0213, 'lps'),
	(372818, 126, '2015-01-15 00:29:42.000000', 'consum', 0.0225, 'lps'),
	(372819, 126, '2015-01-15 00:29:43.000000', 'consum', 0.0219, 'lps'),
	(372820, 126, '2015-01-15 00:29:44.000000', 'consum', 0.0213, 'lps'),
	(372821, 126, '2015-01-15 00:29:45.000000', 'consum', 0.0216, 'lps'),
	(372822, 126, '2015-01-15 00:29:46.000000', 'consum', 0.0214, 'lps'),
	(372823, 126, '2015-01-15 00:29:47.000000', 'consum', 0.0211, 'lps'),
	(372824, 126, '2015-01-15 00:29:48.000000', 'consum', 0.0222, 'lps'),
	(372825, 126, '2015-01-15 00:29:49.000000', 'consum', 0.0228, 'lps'),
	(372826, 126, '2015-01-15 00:29:50.000000', 'consum', 0.0210, 'lps'),
	(372827, 126, '2015-01-15 00:29:51.000000', 'consum', 0.0211, 'lps'),
	(372828, 126, '2015-01-15 00:29:52.000000', 'consum', 0.0216, 'lps'),
	(372829, 126, '2015-01-15 00:29:53.000000', 'consum', 0.0219, 'lps'),
	(372830, 126, '2015-01-15 00:29:54.000000', 'consum', 0.0220, 'lps'),
	(372831, 126, '2015-01-15 00:29:55.000000', 'consum', 0.0214, 'lps'),
	(372832, 126, '2015-01-15 00:29:56.000000', 'consum', 0.0218, 'lps'),
	(372833, 126, '2015-01-15 00:29:57.000000', 'consum', 0.0222, 'lps'),
	(372834, 126, '2015-01-15 00:29:58.000000', 'consum', 0.0227, 'lps'),
	(372835, 126, '2015-01-15 00:29:59.000000', 'consum', 0.0221, 'lps'),
	(372836, 126, '2015-01-15 00:30:00.000000', 'consum', 0.0215, 'lps'),
	(372837, 126, '2015-01-15 00:30:01.000000', 'consum', 0.0223, 'lps'),
	(372838, 126, '2015-01-15 00:30:02.000000', 'consum', 0.0222, 'lps'),
	(372839, 126, '2015-01-15 00:30:03.000000', 'consum', 0.0210, 'lps'),
	(372840, 126, '2015-01-15 00:30:04.000000', 'consum', 0.0214, 'lps'),
	(372841, 126, '2015-01-15 00:30:05.000000', 'consum', 0.0210, 'lps'),
	(372842, 126, '2015-01-15 00:30:06.000000', 'consum', 0.0217, 'lps'),
	(372843, 126, '2015-01-15 00:30:07.000000', 'consum', 0.0228, 'lps'),
	(372844, 126, '2015-01-15 00:30:08.000000', 'consum', 0.0224, 'lps'),
	(372845, 126, '2015-01-15 00:30:09.000000', 'consum', 0.0224, 'lps'),
	(372846, 126, '2015-01-15 00:30:10.000000', 'consum', 0.0220, 'lps'),
	(372847, 126, '2015-01-15 00:30:11.000000', 'consum', 0.0218, 'lps'),
	(372848, 126, '2015-01-15 00:30:12.000000', 'consum', 0.0223, 'lps'),
	(372849, 126, '2015-01-15 00:30:13.000000', 'consum', 0.0210, 'lps'),
	(372850, 126, '2015-01-15 00:30:14.000000', 'consum', 0.0213, 'lps'),
	(372851, 126, '2015-01-15 00:30:15.000000', 'consum', 0.0223, 'lps'),
	(372852, 126, '2015-01-15 00:30:16.000000', 'consum', 0.0227, 'lps'),
	(372853, 126, '2015-01-15 00:30:17.000000', 'consum', 0.0222, 'lps'),
	(372854, 126, '2015-01-15 00:30:18.000000', 'consum', 0.0218, 'lps'),
	(372855, 126, '2015-01-15 00:30:19.000000', 'consum', 0.0217, 'lps'),
	(372856, 126, '2015-01-15 00:30:20.000000', 'consum', 0.0218, 'lps'),
	(372857, 126, '2015-01-15 00:30:21.000000', 'consum', 0.0213, 'lps'),
	(372858, 126, '2015-01-15 00:30:22.000000', 'consum', 0.0219, 'lps'),
	(372859, 126, '2015-01-15 00:30:23.000000', 'consum', 0.0226, 'lps'),
	(372860, 126, '2015-01-15 00:30:24.000000', 'consum', 0.0227, 'lps'),
	(372861, 126, '2015-01-15 00:30:25.000000', 'consum', 0.0228, 'lps'),
	(372862, 126, '2015-01-15 00:30:26.000000', 'consum', 0.0212, 'lps'),
	(372863, 126, '2015-01-15 00:30:27.000000', 'consum', 0.0222, 'lps'),
	(372864, 126, '2015-01-15 00:30:28.000000', 'consum', 0.0210, 'lps'),
	(372865, 126, '2015-01-15 00:30:29.000000', 'consum', 0.0212, 'lps'),
	(372866, 126, '2015-01-15 00:30:30.000000', 'consum', 0.0220, 'lps'),
	(372867, 126, '2015-01-15 00:30:31.000000', 'consum', 0.0216, 'lps'),
	(372868, 126, '2015-01-15 00:30:32.000000', 'consum', 0.0213, 'lps'),
	(372869, 126, '2015-01-15 00:30:33.000000', 'consum', 0.0224, 'lps'),
	(372870, 126, '2015-01-15 00:30:34.000000', 'consum', 0.0217, 'lps'),
	(372871, 126, '2015-01-15 00:30:35.000000', 'consum', 0.0222, 'lps'),
	(372872, 126, '2015-01-15 00:30:36.000000', 'consum', 0.0210, 'lps'),
	(372873, 126, '2015-01-15 00:30:37.000000', 'consum', 0.0215, 'lps'),
	(372874, 126, '2015-01-15 00:30:38.000000', 'consum', 0.0214, 'lps'),
	(372875, 126, '2015-01-15 00:30:39.000000', 'consum', 0.0217, 'lps'),
	(372876, 126, '2015-01-15 00:30:40.000000', 'consum', 0.0213, 'lps'),
	(372877, 126, '2015-01-15 00:30:41.000000', 'consum', 0.0225, 'lps'),
	(372878, 126, '2015-01-15 00:30:42.000000', 'consum', 0.0219, 'lps'),
	(372879, 126, '2015-01-15 00:30:43.000000', 'consum', 0.0210, 'lps'),
	(372880, 126, '2015-01-15 00:30:44.000000', 'consum', 0.0221, 'lps'),
	(372881, 126, '2015-01-15 00:30:45.000000', 'consum', 0.0228, 'lps'),
	(372882, 126, '2015-01-15 00:30:46.000000', 'consum', 0.0212, 'lps'),
	(372883, 126, '2015-01-15 00:30:47.000000', 'consum', 0.0224, 'lps'),
	(372884, 126, '2015-01-15 00:30:48.000000', 'consum', 0.0217, 'lps'),
	(372885, 126, '2015-01-15 00:30:49.000000', 'consum', 0.0221, 'lps'),
	(372886, 126, '2015-01-15 00:30:50.000000', 'consum', 0.0226, 'lps'),
	(372887, 126, '2015-01-15 00:30:51.000000', 'consum', 0.0221, 'lps'),
	(372888, 126, '2015-01-15 00:30:52.000000', 'consum', 0.0217, 'lps'),
	(372889, 126, '2015-01-15 00:30:53.000000', 'consum', 0.0211, 'lps'),
	(372890, 126, '2015-01-15 00:30:54.000000', 'consum', 0.0214, 'lps'),
	(372891, 126, '2015-01-15 00:30:55.000000', 'consum', 0.0210, 'lps'),
	(372892, 126, '2015-01-15 00:30:56.000000', 'consum', 0.0216, 'lps'),
	(372893, 126, '2015-01-15 00:30:57.000000', 'consum', 0.0222, 'lps'),
	(372894, 126, '2015-01-15 00:30:58.000000', 'consum', 0.0215, 'lps'),
	(372895, 126, '2015-01-15 00:30:59.000000', 'consum', 0.0218, 'lps'),
	(372896, 126, '2015-01-15 00:31:00.000000', 'consum', 0.0218, 'lps'),
	(372897, 126, '2015-01-15 00:31:01.000000', 'consum', 0.0226, 'lps'),
	(372898, 126, '2015-01-15 00:31:02.000000', 'consum', 0.0228, 'lps'),
	(372899, 126, '2015-01-15 00:31:03.000000', 'consum', 0.0214, 'lps'),
	(372900, 126, '2015-01-15 00:31:04.000000', 'consum', 0.0215, 'lps'),
	(372901, 126, '2015-01-15 00:31:05.000000', 'consum', 0.0225, 'lps'),
	(372902, 126, '2015-01-15 00:31:06.000000', 'consum', 0.0211, 'lps'),
	(372903, 126, '2015-01-15 00:31:07.000000', 'consum', 0.0227, 'lps'),
	(372904, 126, '2015-01-15 00:31:08.000000', 'consum', 0.0217, 'lps'),
	(372905, 126, '2015-01-15 00:31:09.000000', 'consum', 0.0214, 'lps'),
	(372906, 126, '2015-01-15 00:31:10.000000', 'consum', 0.0226, 'lps'),
	(372907, 126, '2015-01-15 00:31:11.000000', 'consum', 0.0225, 'lps'),
	(372908, 126, '2015-01-15 00:31:12.000000', 'consum', 0.0218, 'lps'),
	(372909, 126, '2015-01-15 00:31:13.000000', 'consum', 0.0225, 'lps'),
	(372910, 126, '2015-01-15 00:31:14.000000', 'consum', 0.0222, 'lps'),
	(372911, 126, '2015-01-15 00:31:15.000000', 'consum', 0.0226, 'lps'),
	(372912, 126, '2015-01-15 00:31:16.000000', 'consum', 0.0216, 'lps'),
	(372913, 126, '2015-01-15 00:31:17.000000', 'consum', 0.0213, 'lps'),
	(372914, 126, '2015-01-15 00:31:18.000000', 'consum', 0.0225, 'lps'),
	(372915, 126, '2015-01-15 00:31:19.000000', 'consum', 0.0222, 'lps'),
	(372916, 126, '2015-01-15 00:31:20.000000', 'consum', 0.0223, 'lps'),
	(372917, 126, '2015-01-15 00:31:21.000000', 'consum', 0.0221, 'lps'),
	(372918, 126, '2015-01-15 00:31:22.000000', 'consum', 0.0225, 'lps'),
	(372919, 126, '2015-01-15 00:31:23.000000', 'consum', 0.0215, 'lps'),
	(372920, 126, '2015-01-15 00:31:24.000000', 'consum', 0.0211, 'lps'),
	(372921, 126, '2015-01-15 00:31:25.000000', 'consum', 0.0218, 'lps'),
	(372922, 126, '2015-01-15 00:31:26.000000', 'consum', 0.0211, 'lps'),
	(372923, 126, '2015-01-15 00:31:27.000000', 'consum', 0.0212, 'lps'),
	(372924, 126, '2015-01-15 00:31:28.000000', 'consum', 0.0216, 'lps'),
	(372925, 126, '2015-01-15 00:31:29.000000', 'consum', 0.0214, 'lps'),
	(372926, 126, '2015-01-15 00:31:30.000000', 'consum', 0.0213, 'lps'),
	(372927, 126, '2015-01-15 00:31:31.000000', 'consum', 0.0212, 'lps'),
	(372928, 126, '2015-01-15 00:31:32.000000', 'consum', 0.0213, 'lps'),
	(372929, 126, '2015-01-15 00:31:33.000000', 'consum', 0.0221, 'lps'),
	(372930, 126, '2015-01-15 00:31:34.000000', 'consum', 0.0219, 'lps'),
	(372931, 126, '2015-01-15 00:31:35.000000', 'consum', 0.0221, 'lps'),
	(372932, 126, '2015-01-15 00:31:36.000000', 'consum', 0.0219, 'lps'),
	(372933, 126, '2015-01-15 00:31:37.000000', 'consum', 0.0221, 'lps'),
	(372934, 126, '2015-01-15 00:31:38.000000', 'consum', 0.0222, 'lps'),
	(372935, 126, '2015-01-15 00:31:39.000000', 'consum', 0.0216, 'lps'),
	(372936, 126, '2015-01-15 00:31:40.000000', 'consum', 0.0226, 'lps'),
	(372937, 126, '2015-01-15 00:31:41.000000', 'consum', 0.0216, 'lps'),
	(372938, 126, '2015-01-15 00:31:42.000000', 'consum', 0.0211, 'lps'),
	(372939, 126, '2015-01-15 00:31:43.000000', 'consum', 0.0215, 'lps'),
	(372940, 126, '2015-01-15 00:31:44.000000', 'consum', 0.0214, 'lps'),
	(372941, 126, '2015-01-15 00:31:45.000000', 'consum', 0.0216, 'lps'),
	(372942, 126, '2015-01-15 00:31:46.000000', 'consum', 0.0211, 'lps'),
	(372943, 126, '2015-01-15 00:31:47.000000', 'consum', 0.0215, 'lps'),
	(372944, 126, '2015-01-15 00:31:48.000000', 'consum', 0.0213, 'lps'),
	(372945, 126, '2015-01-15 00:31:49.000000', 'consum', 0.0211, 'lps'),
	(372946, 126, '2015-01-15 00:31:50.000000', 'consum', 0.0223, 'lps'),
	(372947, 126, '2015-01-15 00:31:51.000000', 'consum', 0.0219, 'lps'),
	(372948, 126, '2015-01-15 00:31:52.000000', 'consum', 0.0216, 'lps'),
	(372949, 126, '2015-01-15 00:31:53.000000', 'consum', 0.0214, 'lps'),
	(372950, 126, '2015-01-15 00:31:54.000000', 'consum', 0.0214, 'lps'),
	(372951, 126, '2015-01-15 00:31:55.000000', 'consum', 0.0216, 'lps'),
	(372952, 126, '2015-01-15 00:31:56.000000', 'consum', 0.0210, 'lps'),
	(372953, 126, '2015-01-15 00:31:57.000000', 'consum', 0.0212, 'lps'),
	(372954, 126, '2015-01-15 00:31:58.000000', 'consum', 0.0221, 'lps'),
	(372955, 126, '2015-01-15 00:31:59.000000', 'consum', 0.0221, 'lps'),
	(372956, 126, '2015-01-15 00:32:00.000000', 'consum', 0.0213, 'lps'),
	(372957, 126, '2015-01-15 00:32:01.000000', 'consum', 0.0213, 'lps'),
	(372958, 126, '2015-01-15 00:32:02.000000', 'consum', 0.0215, 'lps'),
	(372959, 126, '2015-01-15 00:32:03.000000', 'consum', 0.0227, 'lps'),
	(372960, 126, '2015-01-15 00:32:04.000000', 'consum', 0.0223, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(372961, 126, '2015-01-15 00:32:05.000000', 'consum', 0.0227, 'lps'),
	(372962, 126, '2015-01-15 00:32:06.000000', 'consum', 0.0215, 'lps'),
	(372963, 126, '2015-01-15 00:32:07.000000', 'consum', 0.0224, 'lps'),
	(372964, 126, '2015-01-15 00:32:08.000000', 'consum', 0.0227, 'lps'),
	(372965, 126, '2015-01-15 00:32:09.000000', 'consum', 0.0216, 'lps'),
	(372966, 126, '2015-01-15 00:32:10.000000', 'consum', 0.0225, 'lps'),
	(372967, 126, '2015-01-15 00:32:11.000000', 'consum', 0.0214, 'lps'),
	(372968, 126, '2015-01-15 00:32:12.000000', 'consum', 0.0221, 'lps'),
	(372969, 126, '2015-01-15 00:32:13.000000', 'consum', 0.0215, 'lps'),
	(372970, 126, '2015-01-15 00:32:14.000000', 'consum', 0.0222, 'lps'),
	(372971, 126, '2015-01-15 00:32:15.000000', 'consum', 0.0216, 'lps'),
	(372972, 126, '2015-01-15 00:32:16.000000', 'consum', 0.0224, 'lps'),
	(372973, 126, '2015-01-15 00:32:17.000000', 'consum', 0.0224, 'lps'),
	(372974, 126, '2015-01-15 00:32:18.000000', 'consum', 0.0222, 'lps'),
	(372975, 126, '2015-01-15 00:32:19.000000', 'consum', 0.0228, 'lps'),
	(372976, 126, '2015-01-15 00:32:20.000000', 'consum', 0.0226, 'lps'),
	(372977, 126, '2015-01-15 00:32:21.000000', 'consum', 0.0217, 'lps'),
	(372978, 126, '2015-01-15 00:32:22.000000', 'consum', 0.0218, 'lps'),
	(372979, 126, '2015-01-15 00:32:23.000000', 'consum', 0.0210, 'lps'),
	(372980, 126, '2015-01-15 00:32:24.000000', 'consum', 0.0226, 'lps'),
	(372981, 126, '2015-01-15 00:32:25.000000', 'consum', 0.0214, 'lps'),
	(372982, 126, '2015-01-15 00:32:26.000000', 'consum', 0.0220, 'lps'),
	(372983, 126, '2015-01-15 00:32:27.000000', 'consum', 0.0210, 'lps'),
	(372984, 126, '2015-01-15 00:32:28.000000', 'consum', 0.0219, 'lps'),
	(372985, 126, '2015-01-15 00:32:29.000000', 'consum', 0.0219, 'lps'),
	(372986, 126, '2015-01-15 00:32:30.000000', 'consum', 0.0225, 'lps'),
	(372987, 126, '2015-01-15 00:32:31.000000', 'consum', 0.0224, 'lps'),
	(372988, 126, '2015-01-15 00:32:32.000000', 'consum', 0.0216, 'lps'),
	(372989, 126, '2015-01-15 00:32:33.000000', 'consum', 0.0218, 'lps'),
	(372990, 126, '2015-01-15 00:32:34.000000', 'consum', 0.0212, 'lps'),
	(372991, 126, '2015-01-15 00:32:35.000000', 'consum', 0.0215, 'lps'),
	(372992, 126, '2015-01-15 00:32:36.000000', 'consum', 0.0228, 'lps'),
	(372993, 126, '2015-01-15 00:32:37.000000', 'consum', 0.0213, 'lps'),
	(372994, 126, '2015-01-15 00:32:38.000000', 'consum', 0.0226, 'lps'),
	(372995, 126, '2015-01-15 00:32:39.000000', 'consum', 0.0225, 'lps'),
	(372996, 126, '2015-01-15 00:32:40.000000', 'consum', 0.0219, 'lps'),
	(372997, 126, '2015-01-15 00:32:41.000000', 'consum', 0.0211, 'lps'),
	(372998, 126, '2015-01-15 00:32:42.000000', 'consum', 0.0225, 'lps'),
	(372999, 126, '2015-01-15 00:32:43.000000', 'consum', 0.0226, 'lps'),
	(373000, 126, '2015-01-15 00:32:44.000000', 'consum', 0.0227, 'lps'),
	(373001, 126, '2015-01-15 00:32:45.000000', 'consum', 0.0226, 'lps'),
	(373002, 126, '2015-01-15 00:32:46.000000', 'consum', 0.0223, 'lps'),
	(373003, 126, '2015-01-15 00:32:47.000000', 'consum', 0.0226, 'lps'),
	(373004, 126, '2015-01-15 00:32:48.000000', 'consum', 0.0216, 'lps'),
	(373005, 126, '2015-01-15 00:32:49.000000', 'consum', 0.0211, 'lps'),
	(373006, 126, '2015-01-15 00:32:50.000000', 'consum', 0.0214, 'lps'),
	(373007, 126, '2015-01-15 00:32:51.000000', 'consum', 0.0211, 'lps'),
	(373008, 126, '2015-01-15 00:32:52.000000', 'consum', 0.0222, 'lps'),
	(373009, 126, '2015-01-15 00:32:53.000000', 'consum', 0.0212, 'lps'),
	(373010, 126, '2015-01-15 00:32:54.000000', 'consum', 0.0223, 'lps'),
	(373011, 126, '2015-01-15 00:32:55.000000', 'consum', 0.0211, 'lps'),
	(373012, 126, '2015-01-15 00:32:56.000000', 'consum', 0.0216, 'lps'),
	(373013, 126, '2015-01-15 00:32:57.000000', 'consum', 0.0220, 'lps'),
	(373014, 126, '2015-01-15 00:32:58.000000', 'consum', 0.0220, 'lps'),
	(373015, 126, '2015-01-15 00:32:59.000000', 'consum', 0.0214, 'lps'),
	(373016, 126, '2015-01-15 00:33:00.000000', 'consum', 0.0217, 'lps'),
	(373017, 126, '2015-01-15 00:33:01.000000', 'consum', 0.0217, 'lps'),
	(373018, 126, '2015-01-15 00:33:02.000000', 'consum', 0.0224, 'lps'),
	(373019, 126, '2015-01-15 00:33:03.000000', 'consum', 0.0219, 'lps'),
	(373020, 126, '2015-01-15 00:33:04.000000', 'consum', 0.0216, 'lps'),
	(373021, 126, '2015-01-15 00:33:05.000000', 'consum', 0.0212, 'lps'),
	(373022, 126, '2015-01-15 00:33:06.000000', 'consum', 0.0223, 'lps'),
	(373023, 126, '2015-01-15 00:33:07.000000', 'consum', 0.0211, 'lps'),
	(373024, 126, '2015-01-15 00:33:08.000000', 'consum', 0.0215, 'lps'),
	(373025, 126, '2015-01-15 00:33:09.000000', 'consum', 0.0213, 'lps'),
	(373026, 126, '2015-01-15 00:33:10.000000', 'consum', 0.0212, 'lps'),
	(373027, 126, '2015-01-15 00:33:11.000000', 'consum', 0.0211, 'lps'),
	(373028, 126, '2015-01-15 00:33:12.000000', 'consum', 0.0210, 'lps'),
	(373029, 126, '2015-01-15 00:33:13.000000', 'consum', 0.0225, 'lps'),
	(373030, 126, '2015-01-15 00:33:14.000000', 'consum', 0.0212, 'lps'),
	(373031, 126, '2015-01-15 00:33:15.000000', 'consum', 0.0213, 'lps'),
	(373032, 126, '2015-01-15 00:33:16.000000', 'consum', 0.0219, 'lps'),
	(373033, 126, '2015-01-15 00:33:17.000000', 'consum', 0.0210, 'lps'),
	(373034, 126, '2015-01-15 00:33:18.000000', 'consum', 0.0221, 'lps'),
	(373035, 126, '2015-01-15 00:33:19.000000', 'consum', 0.0228, 'lps'),
	(373036, 126, '2015-01-15 00:33:20.000000', 'consum', 0.0211, 'lps'),
	(373037, 126, '2015-01-15 00:33:21.000000', 'consum', 0.0218, 'lps'),
	(373038, 126, '2015-01-15 00:33:22.000000', 'consum', 0.0211, 'lps'),
	(373039, 126, '2015-01-15 00:33:23.000000', 'consum', 0.0226, 'lps'),
	(373040, 126, '2015-01-15 00:33:24.000000', 'consum', 0.0215, 'lps'),
	(373041, 126, '2015-01-15 00:33:25.000000', 'consum', 0.0223, 'lps'),
	(373042, 126, '2015-01-15 00:33:26.000000', 'consum', 0.0225, 'lps'),
	(373043, 126, '2015-01-15 00:33:27.000000', 'consum', 0.0228, 'lps'),
	(373044, 126, '2015-01-15 00:33:28.000000', 'consum', 0.0216, 'lps'),
	(373045, 126, '2015-01-15 00:33:29.000000', 'consum', 0.0225, 'lps'),
	(373046, 126, '2015-01-15 00:33:30.000000', 'consum', 0.0212, 'lps'),
	(373047, 126, '2015-01-15 00:33:31.000000', 'consum', 0.0213, 'lps'),
	(373048, 126, '2015-01-15 00:33:32.000000', 'consum', 0.0220, 'lps'),
	(373049, 126, '2015-01-15 00:33:33.000000', 'consum', 0.0212, 'lps'),
	(373050, 126, '2015-01-15 00:33:34.000000', 'consum', 0.0228, 'lps'),
	(373051, 126, '2015-01-15 00:33:35.000000', 'consum', 0.0221, 'lps'),
	(373052, 126, '2015-01-15 00:33:36.000000', 'consum', 0.0228, 'lps'),
	(373053, 126, '2015-01-15 00:33:37.000000', 'consum', 0.0211, 'lps'),
	(373054, 126, '2015-01-15 00:33:38.000000', 'consum', 0.0217, 'lps'),
	(373055, 126, '2015-01-15 00:33:39.000000', 'consum', 0.0227, 'lps'),
	(373056, 126, '2015-01-15 00:33:40.000000', 'consum', 0.0215, 'lps'),
	(373057, 126, '2015-01-15 00:33:41.000000', 'consum', 0.0221, 'lps'),
	(373058, 126, '2015-01-15 00:33:42.000000', 'consum', 0.0216, 'lps'),
	(373059, 126, '2015-01-15 00:33:43.000000', 'consum', 0.0224, 'lps'),
	(373060, 126, '2015-01-15 00:33:44.000000', 'consum', 0.0224, 'lps'),
	(373061, 126, '2015-01-15 00:33:45.000000', 'consum', 0.0221, 'lps'),
	(373062, 126, '2015-01-15 00:33:46.000000', 'consum', 0.0225, 'lps'),
	(373063, 126, '2015-01-15 00:33:47.000000', 'consum', 0.0212, 'lps'),
	(373064, 126, '2015-01-15 00:33:48.000000', 'consum', 0.0216, 'lps'),
	(373065, 126, '2015-01-15 00:33:49.000000', 'consum', 0.0216, 'lps'),
	(373066, 126, '2015-01-15 00:33:50.000000', 'consum', 0.0221, 'lps'),
	(373067, 126, '2015-01-15 00:33:51.000000', 'consum', 0.0228, 'lps'),
	(373068, 126, '2015-01-15 00:33:52.000000', 'consum', 0.0211, 'lps'),
	(373069, 126, '2015-01-15 00:33:53.000000', 'consum', 0.0217, 'lps'),
	(373070, 126, '2015-01-15 00:33:54.000000', 'consum', 0.0225, 'lps'),
	(373071, 126, '2015-01-15 00:33:55.000000', 'consum', 0.0226, 'lps'),
	(373072, 126, '2015-01-15 00:33:56.000000', 'consum', 0.0227, 'lps'),
	(373073, 126, '2015-01-15 00:33:57.000000', 'consum', 0.0210, 'lps'),
	(373074, 126, '2015-01-15 00:33:58.000000', 'consum', 0.0216, 'lps'),
	(373075, 126, '2015-01-15 00:33:59.000000', 'consum', 0.0220, 'lps'),
	(373076, 126, '2015-01-15 00:34:00.000000', 'consum', 0.0225, 'lps'),
	(373077, 126, '2015-01-15 00:34:01.000000', 'consum', 0.0217, 'lps'),
	(373078, 126, '2015-01-15 00:34:02.000000', 'consum', 0.0220, 'lps'),
	(373079, 126, '2015-01-15 00:34:03.000000', 'consum', 0.0220, 'lps'),
	(373080, 126, '2015-01-15 00:34:04.000000', 'consum', 0.0211, 'lps'),
	(373081, 126, '2015-01-15 00:34:05.000000', 'consum', 0.0223, 'lps'),
	(373082, 126, '2015-01-15 00:34:06.000000', 'consum', 0.0216, 'lps'),
	(373083, 126, '2015-01-15 00:34:07.000000', 'consum', 0.0221, 'lps'),
	(373084, 126, '2015-01-15 00:34:08.000000', 'consum', 0.0228, 'lps'),
	(373085, 126, '2015-01-15 00:34:09.000000', 'consum', 0.0211, 'lps'),
	(373086, 126, '2015-01-15 00:34:10.000000', 'consum', 0.0220, 'lps'),
	(373087, 126, '2015-01-15 00:34:11.000000', 'consum', 0.0216, 'lps'),
	(373088, 126, '2015-01-15 00:34:12.000000', 'consum', 0.0213, 'lps'),
	(373089, 126, '2015-01-15 00:34:13.000000', 'consum', 0.0226, 'lps'),
	(373090, 126, '2015-01-15 00:34:14.000000', 'consum', 0.0222, 'lps'),
	(373091, 126, '2015-01-15 00:34:15.000000', 'consum', 0.0226, 'lps'),
	(373092, 126, '2015-01-15 00:34:16.000000', 'consum', 0.0213, 'lps'),
	(373093, 126, '2015-01-15 00:34:17.000000', 'consum', 0.0218, 'lps'),
	(373094, 126, '2015-01-15 00:34:18.000000', 'consum', 0.0222, 'lps'),
	(373095, 126, '2015-01-15 00:34:19.000000', 'consum', 0.0227, 'lps'),
	(373096, 126, '2015-01-15 00:34:20.000000', 'consum', 0.0222, 'lps'),
	(373097, 126, '2015-01-15 00:34:21.000000', 'consum', 0.0219, 'lps'),
	(373098, 126, '2015-01-15 00:34:22.000000', 'consum', 0.0221, 'lps'),
	(373099, 126, '2015-01-15 00:34:23.000000', 'consum', 0.0218, 'lps'),
	(373100, 126, '2015-01-15 00:34:24.000000', 'consum', 0.0217, 'lps'),
	(373101, 126, '2015-01-15 00:34:25.000000', 'consum', 0.0222, 'lps'),
	(373102, 126, '2015-01-15 00:34:26.000000', 'consum', 0.0213, 'lps'),
	(373103, 126, '2015-01-15 00:34:27.000000', 'consum', 0.0225, 'lps'),
	(373104, 126, '2015-01-15 00:34:28.000000', 'consum', 0.0221, 'lps'),
	(373105, 126, '2015-01-15 00:34:29.000000', 'consum', 0.0220, 'lps'),
	(373106, 126, '2015-01-15 00:34:30.000000', 'consum', 0.0227, 'lps'),
	(373107, 126, '2015-01-15 00:34:31.000000', 'consum', 0.0227, 'lps'),
	(373108, 126, '2015-01-15 00:34:32.000000', 'consum', 0.0228, 'lps'),
	(373109, 126, '2015-01-15 00:34:33.000000', 'consum', 0.0211, 'lps'),
	(373110, 126, '2015-01-15 00:34:34.000000', 'consum', 0.0219, 'lps'),
	(373111, 126, '2015-01-15 00:34:35.000000', 'consum', 0.0213, 'lps'),
	(373112, 126, '2015-01-15 00:34:36.000000', 'consum', 0.0217, 'lps'),
	(373113, 126, '2015-01-15 00:34:37.000000', 'consum', 0.0219, 'lps'),
	(373114, 126, '2015-01-15 00:34:38.000000', 'consum', 0.0215, 'lps'),
	(373115, 126, '2015-01-15 00:34:39.000000', 'consum', 0.0227, 'lps'),
	(373116, 126, '2015-01-15 00:34:40.000000', 'consum', 0.0223, 'lps'),
	(373117, 126, '2015-01-15 00:34:41.000000', 'consum', 0.0224, 'lps'),
	(373118, 126, '2015-01-15 00:34:42.000000', 'consum', 0.0225, 'lps'),
	(373119, 126, '2015-01-15 00:34:43.000000', 'consum', 0.0222, 'lps'),
	(373120, 126, '2015-01-15 00:34:44.000000', 'consum', 0.0227, 'lps'),
	(373121, 126, '2015-01-15 00:34:45.000000', 'consum', 0.0223, 'lps'),
	(373122, 126, '2015-01-15 00:34:46.000000', 'consum', 0.0222, 'lps'),
	(373123, 126, '2015-01-15 00:34:47.000000', 'consum', 0.0214, 'lps'),
	(373124, 126, '2015-01-15 00:34:48.000000', 'consum', 0.0213, 'lps'),
	(373125, 126, '2015-01-15 00:34:49.000000', 'consum', 0.0214, 'lps'),
	(373126, 126, '2015-01-15 00:34:50.000000', 'consum', 0.0220, 'lps'),
	(373127, 126, '2015-01-15 00:34:51.000000', 'consum', 0.0210, 'lps'),
	(373128, 126, '2015-01-15 00:34:52.000000', 'consum', 0.0220, 'lps'),
	(373129, 126, '2015-01-15 00:34:53.000000', 'consum', 0.0222, 'lps'),
	(373130, 126, '2015-01-15 00:34:54.000000', 'consum', 0.0220, 'lps'),
	(373131, 126, '2015-01-15 00:34:55.000000', 'consum', 0.0227, 'lps'),
	(373132, 126, '2015-01-15 00:34:56.000000', 'consum', 0.0226, 'lps'),
	(373133, 126, '2015-01-15 00:34:57.000000', 'consum', 0.0222, 'lps'),
	(373134, 126, '2015-01-15 00:34:58.000000', 'consum', 0.0223, 'lps'),
	(373135, 126, '2015-01-15 00:34:59.000000', 'consum', 0.0219, 'lps'),
	(373136, 126, '2015-01-15 00:35:00.000000', 'consum', 0.0215, 'lps'),
	(373137, 126, '2015-01-15 00:35:01.000000', 'consum', 0.0210, 'lps'),
	(373138, 126, '2015-01-15 00:35:02.000000', 'consum', 0.0212, 'lps'),
	(373139, 126, '2015-01-15 00:35:03.000000', 'consum', 0.0223, 'lps'),
	(373140, 126, '2015-01-15 00:35:04.000000', 'consum', 0.0214, 'lps'),
	(373141, 126, '2015-01-15 00:35:05.000000', 'consum', 0.0228, 'lps'),
	(373142, 126, '2015-01-15 00:35:06.000000', 'consum', 0.0213, 'lps'),
	(373143, 126, '2015-01-15 00:35:07.000000', 'consum', 0.0211, 'lps'),
	(373144, 126, '2015-01-15 00:35:08.000000', 'consum', 0.0225, 'lps'),
	(373145, 126, '2015-01-15 00:35:09.000000', 'consum', 0.0225, 'lps'),
	(373146, 126, '2015-01-15 00:35:10.000000', 'consum', 0.0223, 'lps'),
	(373147, 126, '2015-01-15 00:35:11.000000', 'consum', 0.0211, 'lps'),
	(373148, 126, '2015-01-15 00:35:12.000000', 'consum', 0.0213, 'lps'),
	(373149, 126, '2015-01-15 00:35:13.000000', 'consum', 0.0222, 'lps'),
	(373150, 126, '2015-01-15 00:35:14.000000', 'consum', 0.0226, 'lps'),
	(373151, 126, '2015-01-15 00:35:15.000000', 'consum', 0.0214, 'lps'),
	(373152, 126, '2015-01-15 00:35:16.000000', 'consum', 0.0221, 'lps'),
	(373153, 126, '2015-01-15 00:35:17.000000', 'consum', 0.0216, 'lps'),
	(373154, 126, '2015-01-15 00:35:18.000000', 'consum', 0.0227, 'lps'),
	(373155, 126, '2015-01-15 00:35:19.000000', 'consum', 0.0219, 'lps'),
	(373156, 126, '2015-01-15 00:35:20.000000', 'consum', 0.0223, 'lps'),
	(373157, 126, '2015-01-15 00:35:21.000000', 'consum', 0.0211, 'lps'),
	(373158, 126, '2015-01-15 00:35:22.000000', 'consum', 0.0214, 'lps'),
	(373159, 126, '2015-01-15 00:35:23.000000', 'consum', 0.0227, 'lps'),
	(373160, 126, '2015-01-15 00:35:24.000000', 'consum', 0.0226, 'lps'),
	(373161, 126, '2015-01-15 00:35:25.000000', 'consum', 0.0223, 'lps'),
	(373162, 126, '2015-01-15 00:35:26.000000', 'consum', 0.0227, 'lps'),
	(373163, 126, '2015-01-15 00:35:27.000000', 'consum', 0.0217, 'lps'),
	(373164, 126, '2015-01-15 00:35:28.000000', 'consum', 0.0213, 'lps'),
	(373165, 126, '2015-01-15 00:35:29.000000', 'consum', 0.0222, 'lps'),
	(373166, 126, '2015-01-15 00:35:30.000000', 'consum', 0.0226, 'lps'),
	(373167, 126, '2015-01-15 00:35:31.000000', 'consum', 0.0218, 'lps'),
	(373168, 126, '2015-01-15 00:35:32.000000', 'consum', 0.0219, 'lps'),
	(373169, 126, '2015-01-15 00:35:33.000000', 'consum', 0.0215, 'lps'),
	(373170, 126, '2015-01-15 00:35:34.000000', 'consum', 0.0227, 'lps'),
	(373171, 126, '2015-01-15 00:35:35.000000', 'consum', 0.0222, 'lps'),
	(373172, 126, '2015-01-15 00:35:36.000000', 'consum', 0.0222, 'lps'),
	(373173, 126, '2015-01-15 00:35:37.000000', 'consum', 0.0214, 'lps'),
	(373174, 126, '2015-01-15 00:35:38.000000', 'consum', 0.0214, 'lps'),
	(373175, 126, '2015-01-15 00:35:39.000000', 'consum', 0.0219, 'lps'),
	(373176, 126, '2015-01-15 00:35:40.000000', 'consum', 0.0222, 'lps'),
	(373177, 126, '2015-01-15 00:35:41.000000', 'consum', 0.0226, 'lps'),
	(373178, 126, '2015-01-15 00:35:42.000000', 'consum', 0.0218, 'lps'),
	(373179, 126, '2015-01-15 00:35:43.000000', 'consum', 0.0222, 'lps'),
	(373180, 126, '2015-01-15 00:35:44.000000', 'consum', 0.0227, 'lps'),
	(373181, 126, '2015-01-15 00:35:45.000000', 'consum', 0.0221, 'lps'),
	(373182, 126, '2015-01-15 00:35:46.000000', 'consum', 0.0213, 'lps'),
	(373183, 126, '2015-01-15 00:35:47.000000', 'consum', 0.0211, 'lps'),
	(373184, 126, '2015-01-15 00:35:48.000000', 'consum', 0.0226, 'lps'),
	(373185, 126, '2015-01-15 00:35:49.000000', 'consum', 0.0211, 'lps'),
	(373186, 126, '2015-01-15 00:35:50.000000', 'consum', 0.0224, 'lps'),
	(373187, 126, '2015-01-15 00:35:51.000000', 'consum', 0.0221, 'lps'),
	(373188, 126, '2015-01-15 00:35:52.000000', 'consum', 0.0224, 'lps'),
	(373189, 126, '2015-01-15 00:35:53.000000', 'consum', 0.0228, 'lps'),
	(373190, 126, '2015-01-15 00:35:54.000000', 'consum', 0.0222, 'lps'),
	(373191, 126, '2015-01-15 00:35:55.000000', 'consum', 0.0214, 'lps'),
	(373192, 126, '2015-01-15 00:35:56.000000', 'consum', 0.0213, 'lps'),
	(373193, 126, '2015-01-15 00:35:57.000000', 'consum', 0.0215, 'lps'),
	(373194, 126, '2015-01-15 00:35:58.000000', 'consum', 0.0225, 'lps'),
	(373195, 126, '2015-01-15 00:35:59.000000', 'consum', 0.0213, 'lps'),
	(373196, 126, '2015-01-15 00:36:00.000000', 'consum', 0.0221, 'lps'),
	(373197, 126, '2015-01-15 00:36:01.000000', 'consum', 0.0217, 'lps'),
	(373198, 126, '2015-01-15 00:36:02.000000', 'consum', 0.0212, 'lps'),
	(373199, 126, '2015-01-15 00:36:03.000000', 'consum', 0.0218, 'lps'),
	(373200, 126, '2015-01-15 00:36:04.000000', 'consum', 0.0228, 'lps'),
	(373201, 126, '2015-01-15 00:36:05.000000', 'consum', 0.0217, 'lps'),
	(373202, 126, '2015-01-15 00:36:06.000000', 'consum', 0.0210, 'lps'),
	(373203, 126, '2015-01-15 00:36:07.000000', 'consum', 0.0211, 'lps'),
	(373204, 126, '2015-01-15 00:36:08.000000', 'consum', 0.0213, 'lps'),
	(373205, 126, '2015-01-15 00:36:09.000000', 'consum', 0.0222, 'lps'),
	(373206, 126, '2015-01-15 00:36:10.000000', 'consum', 0.0223, 'lps'),
	(373207, 126, '2015-01-15 00:36:11.000000', 'consum', 0.0223, 'lps'),
	(373208, 126, '2015-01-15 00:36:12.000000', 'consum', 0.0215, 'lps'),
	(373209, 126, '2015-01-15 00:36:13.000000', 'consum', 0.0215, 'lps'),
	(373210, 126, '2015-01-15 00:36:14.000000', 'consum', 0.0220, 'lps'),
	(373211, 126, '2015-01-15 00:36:15.000000', 'consum', 0.0228, 'lps'),
	(373212, 126, '2015-01-15 00:36:16.000000', 'consum', 0.0213, 'lps'),
	(373213, 126, '2015-01-15 00:36:17.000000', 'consum', 0.0210, 'lps'),
	(373214, 126, '2015-01-15 00:36:18.000000', 'consum', 0.0222, 'lps'),
	(373215, 126, '2015-01-15 00:36:19.000000', 'consum', 0.0211, 'lps'),
	(373216, 126, '2015-01-15 00:36:20.000000', 'consum', 0.0216, 'lps'),
	(373217, 126, '2015-01-15 00:36:21.000000', 'consum', 0.0222, 'lps'),
	(373218, 126, '2015-01-15 00:36:22.000000', 'consum', 0.0211, 'lps'),
	(373219, 126, '2015-01-15 00:36:23.000000', 'consum', 0.0221, 'lps'),
	(373220, 126, '2015-01-15 00:36:24.000000', 'consum', 0.0224, 'lps'),
	(373221, 126, '2015-01-15 00:36:25.000000', 'consum', 0.0227, 'lps'),
	(373222, 126, '2015-01-15 00:36:26.000000', 'consum', 0.0216, 'lps'),
	(373223, 126, '2015-01-15 00:36:27.000000', 'consum', 0.0228, 'lps'),
	(373224, 126, '2015-01-15 00:36:28.000000', 'consum', 0.0223, 'lps'),
	(373225, 126, '2015-01-15 00:36:29.000000', 'consum', 0.0225, 'lps'),
	(373226, 126, '2015-01-15 00:36:30.000000', 'consum', 0.0227, 'lps'),
	(373227, 126, '2015-01-15 00:36:31.000000', 'consum', 0.0210, 'lps'),
	(373228, 126, '2015-01-15 00:36:32.000000', 'consum', 0.0220, 'lps'),
	(373229, 126, '2015-01-15 00:36:33.000000', 'consum', 0.0220, 'lps'),
	(373230, 126, '2015-01-15 00:36:34.000000', 'consum', 0.0213, 'lps'),
	(373231, 126, '2015-01-15 00:36:35.000000', 'consum', 0.0212, 'lps'),
	(373232, 126, '2015-01-15 00:36:36.000000', 'consum', 0.0214, 'lps'),
	(373233, 126, '2015-01-15 00:36:37.000000', 'consum', 0.0223, 'lps'),
	(373234, 126, '2015-01-15 00:36:38.000000', 'consum', 0.0225, 'lps'),
	(373235, 126, '2015-01-15 00:36:39.000000', 'consum', 0.0210, 'lps'),
	(373236, 126, '2015-01-15 00:36:40.000000', 'consum', 0.0220, 'lps'),
	(373237, 126, '2015-01-15 00:36:41.000000', 'consum', 0.0223, 'lps'),
	(373238, 126, '2015-01-15 00:36:42.000000', 'consum', 0.0210, 'lps'),
	(373239, 126, '2015-01-15 00:36:43.000000', 'consum', 0.0226, 'lps'),
	(373240, 126, '2015-01-15 00:36:44.000000', 'consum', 0.0215, 'lps'),
	(373241, 126, '2015-01-15 00:36:45.000000', 'consum', 0.0227, 'lps'),
	(373242, 126, '2015-01-15 00:36:46.000000', 'consum', 0.0222, 'lps'),
	(373243, 126, '2015-01-15 00:36:47.000000', 'consum', 0.0222, 'lps'),
	(373244, 126, '2015-01-15 00:36:48.000000', 'consum', 0.0214, 'lps'),
	(373245, 126, '2015-01-15 00:36:49.000000', 'consum', 0.0213, 'lps'),
	(373246, 126, '2015-01-15 00:36:50.000000', 'consum', 0.0213, 'lps'),
	(373247, 126, '2015-01-15 00:36:51.000000', 'consum', 0.0219, 'lps'),
	(373248, 126, '2015-01-15 00:36:52.000000', 'consum', 0.0226, 'lps'),
	(373249, 126, '2015-01-15 00:36:53.000000', 'consum', 0.0226, 'lps'),
	(373250, 126, '2015-01-15 00:36:54.000000', 'consum', 0.0225, 'lps'),
	(373251, 126, '2015-01-15 00:36:55.000000', 'consum', 0.0217, 'lps'),
	(373252, 126, '2015-01-15 00:36:56.000000', 'consum', 0.0220, 'lps'),
	(373253, 126, '2015-01-15 00:36:57.000000', 'consum', 0.0219, 'lps'),
	(373254, 126, '2015-01-15 00:36:58.000000', 'consum', 0.0227, 'lps'),
	(373255, 126, '2015-01-15 00:36:59.000000', 'consum', 0.0212, 'lps'),
	(373256, 126, '2015-01-15 00:37:00.000000', 'consum', 0.0226, 'lps'),
	(373257, 126, '2015-01-15 00:37:01.000000', 'consum', 0.0210, 'lps'),
	(373258, 126, '2015-01-15 00:37:02.000000', 'consum', 0.0217, 'lps'),
	(373259, 126, '2015-01-15 00:37:03.000000', 'consum', 0.0227, 'lps'),
	(373260, 126, '2015-01-15 00:37:04.000000', 'consum', 0.0216, 'lps'),
	(373261, 126, '2015-01-15 00:37:05.000000', 'consum', 0.0210, 'lps'),
	(373262, 126, '2015-01-15 00:37:06.000000', 'consum', 0.0213, 'lps'),
	(373263, 126, '2015-01-15 00:37:07.000000', 'consum', 0.0226, 'lps'),
	(373264, 126, '2015-01-15 00:37:08.000000', 'consum', 0.0223, 'lps'),
	(373265, 126, '2015-01-15 00:37:09.000000', 'consum', 0.0210, 'lps'),
	(373266, 126, '2015-01-15 00:37:10.000000', 'consum', 0.0228, 'lps'),
	(373267, 126, '2015-01-15 00:37:11.000000', 'consum', 0.0225, 'lps'),
	(373268, 126, '2015-01-15 00:37:12.000000', 'consum', 0.0213, 'lps'),
	(373269, 126, '2015-01-15 00:37:13.000000', 'consum', 0.0219, 'lps'),
	(373270, 126, '2015-01-15 00:37:14.000000', 'consum', 0.0226, 'lps'),
	(373271, 126, '2015-01-15 00:37:15.000000', 'consum', 0.0224, 'lps'),
	(373272, 126, '2015-01-15 00:37:16.000000', 'consum', 0.0215, 'lps'),
	(373273, 126, '2015-01-15 00:37:17.000000', 'consum', 0.0214, 'lps'),
	(373274, 126, '2015-01-15 00:37:18.000000', 'consum', 0.0213, 'lps'),
	(373275, 126, '2015-01-15 00:37:19.000000', 'consum', 0.0215, 'lps'),
	(373276, 126, '2015-01-15 00:37:20.000000', 'consum', 0.0228, 'lps'),
	(373277, 126, '2015-01-15 00:37:21.000000', 'consum', 0.0227, 'lps'),
	(373278, 126, '2015-01-15 00:37:22.000000', 'consum', 0.0221, 'lps'),
	(373279, 126, '2015-01-15 00:37:23.000000', 'consum', 0.0214, 'lps'),
	(373280, 126, '2015-01-15 00:37:24.000000', 'consum', 0.0218, 'lps'),
	(373281, 126, '2015-01-15 00:37:25.000000', 'consum', 0.0220, 'lps'),
	(373282, 126, '2015-01-15 00:37:26.000000', 'consum', 0.0216, 'lps'),
	(373283, 126, '2015-01-15 00:37:27.000000', 'consum', 0.0211, 'lps'),
	(373284, 126, '2015-01-15 00:37:28.000000', 'consum', 0.0218, 'lps'),
	(373285, 126, '2015-01-15 00:37:29.000000', 'consum', 0.0226, 'lps'),
	(373286, 126, '2015-01-15 00:37:30.000000', 'consum', 0.0228, 'lps'),
	(373287, 126, '2015-01-15 00:37:31.000000', 'consum', 0.0214, 'lps'),
	(373288, 126, '2015-01-15 00:37:32.000000', 'consum', 0.0217, 'lps'),
	(373289, 126, '2015-01-15 00:37:33.000000', 'consum', 0.0211, 'lps'),
	(373290, 126, '2015-01-15 00:37:34.000000', 'consum', 0.0217, 'lps'),
	(373291, 126, '2015-01-15 00:37:35.000000', 'consum', 0.0224, 'lps'),
	(373292, 126, '2015-01-15 00:37:36.000000', 'consum', 0.0219, 'lps'),
	(373293, 126, '2015-01-15 00:37:37.000000', 'consum', 0.0213, 'lps'),
	(373294, 126, '2015-01-15 00:37:38.000000', 'consum', 0.0220, 'lps'),
	(373295, 126, '2015-01-15 00:37:39.000000', 'consum', 0.0213, 'lps'),
	(373296, 126, '2015-01-15 00:37:40.000000', 'consum', 0.0214, 'lps'),
	(373297, 126, '2015-01-15 00:37:41.000000', 'consum', 0.0223, 'lps'),
	(373298, 126, '2015-01-15 00:37:42.000000', 'consum', 0.0224, 'lps'),
	(373299, 126, '2015-01-15 00:37:43.000000', 'consum', 0.0225, 'lps'),
	(373300, 126, '2015-01-15 00:37:44.000000', 'consum', 0.0223, 'lps'),
	(373301, 126, '2015-01-15 00:37:45.000000', 'consum', 0.0211, 'lps'),
	(373302, 126, '2015-01-15 00:37:46.000000', 'consum', 0.0214, 'lps'),
	(373303, 126, '2015-01-15 00:37:47.000000', 'consum', 0.0227, 'lps'),
	(373304, 126, '2015-01-15 00:37:48.000000', 'consum', 0.0228, 'lps'),
	(373305, 126, '2015-01-15 00:37:49.000000', 'consum', 0.0210, 'lps'),
	(373306, 126, '2015-01-15 00:37:50.000000', 'consum', 0.0215, 'lps'),
	(373307, 126, '2015-01-15 00:37:51.000000', 'consum', 0.0217, 'lps'),
	(373308, 126, '2015-01-15 00:37:52.000000', 'consum', 0.0213, 'lps'),
	(373309, 126, '2015-01-15 00:37:53.000000', 'consum', 0.0221, 'lps'),
	(373310, 126, '2015-01-15 00:37:54.000000', 'consum', 0.0219, 'lps'),
	(373311, 126, '2015-01-15 00:37:55.000000', 'consum', 0.0223, 'lps'),
	(373312, 126, '2015-01-15 00:37:56.000000', 'consum', 0.0210, 'lps'),
	(373313, 126, '2015-01-15 00:37:57.000000', 'consum', 0.0210, 'lps'),
	(373314, 126, '2015-01-15 00:37:58.000000', 'consum', 0.0228, 'lps'),
	(373315, 126, '2015-01-15 00:37:59.000000', 'consum', 0.0227, 'lps'),
	(373316, 126, '2015-01-15 00:38:00.000000', 'consum', 0.0223, 'lps'),
	(373317, 126, '2015-01-15 00:38:01.000000', 'consum', 0.0221, 'lps'),
	(373318, 126, '2015-01-15 00:38:02.000000', 'consum', 0.0210, 'lps'),
	(373319, 126, '2015-01-15 00:38:03.000000', 'consum', 0.0217, 'lps'),
	(373320, 126, '2015-01-15 00:38:04.000000', 'consum', 0.0223, 'lps'),
	(373321, 126, '2015-01-15 00:38:05.000000', 'consum', 0.0218, 'lps'),
	(373322, 126, '2015-01-15 00:38:06.000000', 'consum', 0.0228, 'lps'),
	(373323, 126, '2015-01-15 00:38:07.000000', 'consum', 0.0223, 'lps'),
	(373324, 126, '2015-01-15 00:38:08.000000', 'consum', 0.0221, 'lps'),
	(373325, 126, '2015-01-15 00:38:09.000000', 'consum', 0.0227, 'lps'),
	(373326, 126, '2015-01-15 00:38:10.000000', 'consum', 0.0225, 'lps'),
	(373327, 126, '2015-01-15 00:38:11.000000', 'consum', 0.0215, 'lps'),
	(373328, 126, '2015-01-15 00:38:12.000000', 'consum', 0.0211, 'lps'),
	(373329, 126, '2015-01-15 00:38:13.000000', 'consum', 0.0218, 'lps'),
	(373330, 126, '2015-01-15 00:38:14.000000', 'consum', 0.0211, 'lps'),
	(373331, 126, '2015-01-15 00:38:15.000000', 'consum', 0.0228, 'lps'),
	(373332, 126, '2015-01-15 00:38:16.000000', 'consum', 0.0222, 'lps'),
	(373333, 126, '2015-01-15 00:38:17.000000', 'consum', 0.0217, 'lps'),
	(373334, 126, '2015-01-15 00:38:18.000000', 'consum', 0.0211, 'lps'),
	(373335, 126, '2015-01-15 00:38:19.000000', 'consum', 0.0211, 'lps'),
	(373336, 126, '2015-01-15 00:38:20.000000', 'consum', 0.0213, 'lps'),
	(373337, 126, '2015-01-15 00:38:21.000000', 'consum', 0.0225, 'lps'),
	(373338, 126, '2015-01-15 00:38:22.000000', 'consum', 0.0217, 'lps'),
	(373339, 126, '2015-01-15 00:38:23.000000', 'consum', 0.0219, 'lps'),
	(373340, 126, '2015-01-15 00:38:24.000000', 'consum', 0.0215, 'lps'),
	(373341, 126, '2015-01-15 00:38:25.000000', 'consum', 0.0211, 'lps'),
	(373342, 126, '2015-01-15 00:38:26.000000', 'consum', 0.0218, 'lps'),
	(373343, 126, '2015-01-15 00:38:27.000000', 'consum', 0.0211, 'lps'),
	(373344, 126, '2015-01-15 00:38:28.000000', 'consum', 0.0211, 'lps'),
	(373345, 126, '2015-01-15 00:38:29.000000', 'consum', 0.0213, 'lps'),
	(373346, 126, '2015-01-15 00:38:30.000000', 'consum', 0.0223, 'lps'),
	(373347, 126, '2015-01-15 00:38:31.000000', 'consum', 0.0226, 'lps'),
	(373348, 126, '2015-01-15 00:38:32.000000', 'consum', 0.0215, 'lps'),
	(373349, 126, '2015-01-15 00:38:33.000000', 'consum', 0.0226, 'lps'),
	(373350, 126, '2015-01-15 00:38:34.000000', 'consum', 0.0219, 'lps'),
	(373351, 126, '2015-01-15 00:38:35.000000', 'consum', 0.0227, 'lps'),
	(373352, 126, '2015-01-15 00:38:36.000000', 'consum', 0.0212, 'lps'),
	(373353, 126, '2015-01-15 00:38:37.000000', 'consum', 0.0224, 'lps'),
	(373354, 126, '2015-01-15 00:38:38.000000', 'consum', 0.0219, 'lps'),
	(373355, 126, '2015-01-15 00:38:39.000000', 'consum', 0.0214, 'lps'),
	(373356, 126, '2015-01-15 00:38:40.000000', 'consum', 0.0220, 'lps'),
	(373357, 126, '2015-01-15 00:38:41.000000', 'consum', 0.0213, 'lps'),
	(373358, 126, '2015-01-15 00:38:42.000000', 'consum', 0.0215, 'lps'),
	(373359, 126, '2015-01-15 00:38:43.000000', 'consum', 0.0224, 'lps'),
	(373360, 126, '2015-01-15 00:38:44.000000', 'consum', 0.0228, 'lps'),
	(373361, 126, '2015-01-15 00:38:45.000000', 'consum', 0.0219, 'lps'),
	(373362, 126, '2015-01-15 00:38:46.000000', 'consum', 0.0224, 'lps'),
	(373363, 126, '2015-01-15 00:38:47.000000', 'consum', 0.0213, 'lps'),
	(373364, 126, '2015-01-15 00:38:48.000000', 'consum', 0.0224, 'lps'),
	(373365, 126, '2015-01-15 00:38:49.000000', 'consum', 0.0214, 'lps'),
	(373366, 126, '2015-01-15 00:38:50.000000', 'consum', 0.0224, 'lps'),
	(373367, 126, '2015-01-15 00:38:51.000000', 'consum', 0.0214, 'lps'),
	(373368, 126, '2015-01-15 00:38:52.000000', 'consum', 0.0227, 'lps'),
	(373369, 126, '2015-01-15 00:38:53.000000', 'consum', 0.0227, 'lps'),
	(373370, 126, '2015-01-15 00:38:54.000000', 'consum', 0.0226, 'lps'),
	(373371, 126, '2015-01-15 00:38:55.000000', 'consum', 0.0220, 'lps'),
	(373372, 126, '2015-01-15 00:38:56.000000', 'consum', 0.0214, 'lps'),
	(373373, 126, '2015-01-15 00:38:57.000000', 'consum', 0.0218, 'lps'),
	(373374, 126, '2015-01-15 00:38:58.000000', 'consum', 0.0221, 'lps'),
	(373375, 126, '2015-01-15 00:38:59.000000', 'consum', 0.0220, 'lps'),
	(373376, 126, '2015-01-15 00:39:00.000000', 'consum', 0.0227, 'lps'),
	(373377, 126, '2015-01-15 00:39:01.000000', 'consum', 0.0210, 'lps'),
	(373378, 126, '2015-01-15 00:39:02.000000', 'consum', 0.0217, 'lps'),
	(373379, 126, '2015-01-15 00:39:03.000000', 'consum', 0.0227, 'lps'),
	(373380, 126, '2015-01-15 00:39:04.000000', 'consum', 0.0216, 'lps'),
	(373381, 126, '2015-01-15 00:39:05.000000', 'consum', 0.0227, 'lps'),
	(373382, 126, '2015-01-15 00:39:06.000000', 'consum', 0.0221, 'lps'),
	(373383, 126, '2015-01-15 00:39:07.000000', 'consum', 0.0214, 'lps'),
	(373384, 126, '2015-01-15 00:39:08.000000', 'consum', 0.0218, 'lps'),
	(373385, 126, '2015-01-15 00:39:09.000000', 'consum', 0.0217, 'lps'),
	(373386, 126, '2015-01-15 00:39:10.000000', 'consum', 0.0223, 'lps'),
	(373387, 126, '2015-01-15 00:39:11.000000', 'consum', 0.0214, 'lps'),
	(373388, 126, '2015-01-15 00:39:12.000000', 'consum', 0.0214, 'lps'),
	(373389, 126, '2015-01-15 00:39:13.000000', 'consum', 0.0218, 'lps'),
	(373390, 126, '2015-01-15 00:39:14.000000', 'consum', 0.0220, 'lps'),
	(373391, 126, '2015-01-15 00:39:15.000000', 'consum', 0.0217, 'lps'),
	(373392, 126, '2015-01-15 00:39:16.000000', 'consum', 0.0214, 'lps'),
	(373393, 126, '2015-01-15 00:39:17.000000', 'consum', 0.0211, 'lps'),
	(373394, 126, '2015-01-15 00:39:18.000000', 'consum', 0.0221, 'lps'),
	(373395, 126, '2015-01-15 00:39:19.000000', 'consum', 0.0226, 'lps'),
	(373396, 126, '2015-01-15 00:39:20.000000', 'consum', 0.0218, 'lps'),
	(373397, 126, '2015-01-15 00:39:21.000000', 'consum', 0.0221, 'lps'),
	(373398, 126, '2015-01-15 00:39:22.000000', 'consum', 0.0223, 'lps'),
	(373399, 126, '2015-01-15 00:39:23.000000', 'consum', 0.0222, 'lps'),
	(373400, 126, '2015-01-15 00:39:24.000000', 'consum', 0.0214, 'lps'),
	(373401, 126, '2015-01-15 00:39:25.000000', 'consum', 0.0212, 'lps'),
	(373402, 126, '2015-01-15 00:39:26.000000', 'consum', 0.0227, 'lps'),
	(373403, 126, '2015-01-15 00:39:27.000000', 'consum', 0.0215, 'lps'),
	(373404, 126, '2015-01-15 00:39:28.000000', 'consum', 0.0220, 'lps'),
	(373405, 126, '2015-01-15 00:39:29.000000', 'consum', 0.0210, 'lps'),
	(373406, 126, '2015-01-15 00:39:30.000000', 'consum', 0.0218, 'lps'),
	(373407, 126, '2015-01-15 00:39:31.000000', 'consum', 0.0212, 'lps'),
	(373408, 126, '2015-01-15 00:39:32.000000', 'consum', 0.0217, 'lps'),
	(373409, 126, '2015-01-15 00:39:33.000000', 'consum', 0.0219, 'lps'),
	(373410, 126, '2015-01-15 00:39:34.000000', 'consum', 0.0218, 'lps'),
	(373411, 126, '2015-01-15 00:39:35.000000', 'consum', 0.0222, 'lps'),
	(373412, 126, '2015-01-15 00:39:36.000000', 'consum', 0.0228, 'lps'),
	(373413, 126, '2015-01-15 00:39:37.000000', 'consum', 0.0228, 'lps'),
	(373414, 126, '2015-01-15 00:39:38.000000', 'consum', 0.0225, 'lps'),
	(373415, 126, '2015-01-15 00:39:39.000000', 'consum', 0.0212, 'lps'),
	(373416, 126, '2015-01-15 00:39:40.000000', 'consum', 0.0216, 'lps'),
	(373417, 126, '2015-01-15 00:39:41.000000', 'consum', 0.0216, 'lps'),
	(373418, 126, '2015-01-15 00:39:42.000000', 'consum', 0.0223, 'lps'),
	(373419, 126, '2015-01-15 00:39:43.000000', 'consum', 0.0218, 'lps'),
	(373420, 126, '2015-01-15 00:39:44.000000', 'consum', 0.0211, 'lps'),
	(373421, 126, '2015-01-15 00:39:45.000000', 'consum', 0.0212, 'lps'),
	(373422, 126, '2015-01-15 00:39:46.000000', 'consum', 0.0216, 'lps'),
	(373423, 126, '2015-01-15 00:39:47.000000', 'consum', 0.0215, 'lps'),
	(373424, 126, '2015-01-15 00:39:48.000000', 'consum', 0.0218, 'lps'),
	(373425, 126, '2015-01-15 00:39:49.000000', 'consum', 0.0217, 'lps'),
	(373426, 126, '2015-01-15 00:39:50.000000', 'consum', 0.0220, 'lps'),
	(373427, 126, '2015-01-15 00:39:51.000000', 'consum', 0.0222, 'lps'),
	(373428, 126, '2015-01-15 00:39:52.000000', 'consum', 0.0219, 'lps'),
	(373429, 126, '2015-01-15 00:39:53.000000', 'consum', 0.0223, 'lps'),
	(373430, 126, '2015-01-15 00:39:54.000000', 'consum', 0.0228, 'lps'),
	(373431, 126, '2015-01-15 00:39:55.000000', 'consum', 0.0223, 'lps'),
	(373432, 126, '2015-01-15 00:39:56.000000', 'consum', 0.0223, 'lps'),
	(373433, 126, '2015-01-15 00:39:57.000000', 'consum', 0.0216, 'lps'),
	(373434, 126, '2015-01-15 00:39:58.000000', 'consum', 0.0222, 'lps'),
	(373435, 126, '2015-01-15 00:39:59.000000', 'consum', 0.0213, 'lps'),
	(373436, 126, '2015-01-15 00:40:00.000000', 'consum', 0.0227, 'lps'),
	(373437, 126, '2015-01-15 00:40:01.000000', 'consum', 0.0212, 'lps'),
	(373438, 126, '2015-01-15 00:40:02.000000', 'consum', 0.0226, 'lps'),
	(373439, 126, '2015-01-15 00:40:03.000000', 'consum', 0.0228, 'lps'),
	(373440, 126, '2015-01-15 00:40:04.000000', 'consum', 0.0215, 'lps'),
	(373441, 126, '2015-01-15 00:40:05.000000', 'consum', 0.0219, 'lps'),
	(373442, 126, '2015-01-15 00:40:06.000000', 'consum', 0.0221, 'lps'),
	(373443, 126, '2015-01-15 00:40:07.000000', 'consum', 0.0220, 'lps'),
	(373444, 126, '2015-01-15 00:40:08.000000', 'consum', 0.0228, 'lps'),
	(373445, 126, '2015-01-15 00:40:09.000000', 'consum', 0.0215, 'lps'),
	(373446, 126, '2015-01-15 00:40:10.000000', 'consum', 0.0218, 'lps'),
	(373447, 126, '2015-01-15 00:40:11.000000', 'consum', 0.0217, 'lps'),
	(373448, 126, '2015-01-15 00:40:12.000000', 'consum', 0.0222, 'lps'),
	(373449, 126, '2015-01-15 00:40:13.000000', 'consum', 0.0228, 'lps'),
	(373450, 126, '2015-01-15 00:40:14.000000', 'consum', 0.0210, 'lps'),
	(373451, 126, '2015-01-15 00:40:15.000000', 'consum', 0.0214, 'lps'),
	(373452, 126, '2015-01-15 00:40:16.000000', 'consum', 0.0211, 'lps'),
	(373453, 126, '2015-01-15 00:40:17.000000', 'consum', 0.0221, 'lps'),
	(373454, 126, '2015-01-15 00:40:18.000000', 'consum', 0.0225, 'lps'),
	(373455, 126, '2015-01-15 00:40:19.000000', 'consum', 0.0213, 'lps'),
	(373456, 126, '2015-01-15 00:40:20.000000', 'consum', 0.0221, 'lps'),
	(373457, 126, '2015-01-15 00:40:21.000000', 'consum', 0.0217, 'lps'),
	(373458, 126, '2015-01-15 00:40:22.000000', 'consum', 0.0214, 'lps'),
	(373459, 126, '2015-01-15 00:40:23.000000', 'consum', 0.0226, 'lps'),
	(373460, 126, '2015-01-15 00:40:24.000000', 'consum', 0.0224, 'lps'),
	(373461, 126, '2015-01-15 00:40:25.000000', 'consum', 0.0212, 'lps'),
	(373462, 126, '2015-01-15 00:40:26.000000', 'consum', 0.0219, 'lps'),
	(373463, 126, '2015-01-15 00:40:27.000000', 'consum', 0.0227, 'lps'),
	(373464, 126, '2015-01-15 00:40:28.000000', 'consum', 0.0213, 'lps'),
	(373465, 126, '2015-01-15 00:40:29.000000', 'consum', 0.0213, 'lps'),
	(373466, 126, '2015-01-15 00:40:30.000000', 'consum', 0.0215, 'lps'),
	(373467, 126, '2015-01-15 00:40:31.000000', 'consum', 0.0227, 'lps'),
	(373468, 126, '2015-01-15 00:40:32.000000', 'consum', 0.0222, 'lps'),
	(373469, 126, '2015-01-15 00:40:33.000000', 'consum', 0.0219, 'lps'),
	(373470, 126, '2015-01-15 00:40:34.000000', 'consum', 0.0220, 'lps'),
	(373471, 126, '2015-01-15 00:40:35.000000', 'consum', 0.0215, 'lps'),
	(373472, 126, '2015-01-15 00:40:36.000000', 'consum', 0.0225, 'lps'),
	(373473, 126, '2015-01-15 00:40:37.000000', 'consum', 0.0212, 'lps'),
	(373474, 126, '2015-01-15 00:40:38.000000', 'consum', 0.0214, 'lps'),
	(373475, 126, '2015-01-15 00:40:39.000000', 'consum', 0.0223, 'lps'),
	(373476, 126, '2015-01-15 00:40:40.000000', 'consum', 0.0226, 'lps'),
	(373477, 126, '2015-01-15 00:40:41.000000', 'consum', 0.0215, 'lps'),
	(373478, 126, '2015-01-15 00:40:42.000000', 'consum', 0.0226, 'lps'),
	(373479, 126, '2015-01-15 00:40:43.000000', 'consum', 0.0216, 'lps'),
	(373480, 126, '2015-01-15 00:40:44.000000', 'consum', 0.0215, 'lps'),
	(373481, 126, '2015-01-15 00:40:45.000000', 'consum', 0.0214, 'lps'),
	(373482, 126, '2015-01-15 00:40:46.000000', 'consum', 0.0217, 'lps'),
	(373483, 126, '2015-01-15 00:40:47.000000', 'consum', 0.0213, 'lps'),
	(373484, 126, '2015-01-15 00:40:48.000000', 'consum', 0.0224, 'lps'),
	(373485, 126, '2015-01-15 00:40:49.000000', 'consum', 0.0217, 'lps'),
	(373486, 126, '2015-01-15 00:40:50.000000', 'consum', 0.0220, 'lps'),
	(373487, 126, '2015-01-15 00:40:51.000000', 'consum', 0.0220, 'lps'),
	(373488, 126, '2015-01-15 00:40:52.000000', 'consum', 0.0213, 'lps'),
	(373489, 126, '2015-01-15 00:40:53.000000', 'consum', 0.0212, 'lps'),
	(373490, 126, '2015-01-15 00:40:54.000000', 'consum', 0.0213, 'lps'),
	(373491, 126, '2015-01-15 00:40:55.000000', 'consum', 0.0219, 'lps'),
	(373492, 126, '2015-01-15 00:40:56.000000', 'consum', 0.0226, 'lps'),
	(373493, 126, '2015-01-15 00:40:57.000000', 'consum', 0.0227, 'lps'),
	(373494, 126, '2015-01-15 00:40:58.000000', 'consum', 0.0228, 'lps'),
	(373495, 126, '2015-01-15 00:40:59.000000', 'consum', 0.0210, 'lps'),
	(373496, 126, '2015-01-15 00:41:00.000000', 'consum', 0.0213, 'lps'),
	(373497, 126, '2015-01-15 00:41:01.000000', 'consum', 0.0227, 'lps'),
	(373498, 126, '2015-01-15 00:41:02.000000', 'consum', 0.0227, 'lps'),
	(373499, 126, '2015-01-15 00:41:03.000000', 'consum', 0.0210, 'lps'),
	(373500, 126, '2015-01-15 00:41:04.000000', 'consum', 0.0214, 'lps'),
	(373501, 126, '2015-01-15 00:41:05.000000', 'consum', 0.0214, 'lps'),
	(373502, 126, '2015-01-15 00:41:06.000000', 'consum', 0.0218, 'lps'),
	(373503, 126, '2015-01-15 00:41:07.000000', 'consum', 0.0217, 'lps'),
	(373504, 126, '2015-01-15 00:41:08.000000', 'consum', 0.0224, 'lps'),
	(373505, 126, '2015-01-15 00:41:09.000000', 'consum', 0.0220, 'lps'),
	(373506, 126, '2015-01-15 00:41:10.000000', 'consum', 0.0220, 'lps'),
	(373507, 126, '2015-01-15 00:41:11.000000', 'consum', 0.0212, 'lps'),
	(373508, 126, '2015-01-15 00:41:12.000000', 'consum', 0.0211, 'lps'),
	(373509, 126, '2015-01-15 00:41:13.000000', 'consum', 0.0226, 'lps'),
	(373510, 126, '2015-01-15 00:41:14.000000', 'consum', 0.0210, 'lps'),
	(373511, 126, '2015-01-15 00:41:15.000000', 'consum', 0.0222, 'lps'),
	(373512, 126, '2015-01-15 00:41:16.000000', 'consum', 0.0214, 'lps'),
	(373513, 126, '2015-01-15 00:41:17.000000', 'consum', 0.0212, 'lps'),
	(373514, 126, '2015-01-15 00:41:18.000000', 'consum', 0.0210, 'lps'),
	(373515, 126, '2015-01-15 00:41:19.000000', 'consum', 0.0224, 'lps'),
	(373516, 126, '2015-01-15 00:41:20.000000', 'consum', 0.0224, 'lps'),
	(373517, 126, '2015-01-15 00:41:21.000000', 'consum', 0.0217, 'lps'),
	(373518, 126, '2015-01-15 00:41:22.000000', 'consum', 0.0223, 'lps'),
	(373519, 126, '2015-01-15 00:41:23.000000', 'consum', 0.0216, 'lps'),
	(373520, 126, '2015-01-15 00:41:24.000000', 'consum', 0.0221, 'lps'),
	(373521, 126, '2015-01-15 00:41:25.000000', 'consum', 0.0210, 'lps'),
	(373522, 126, '2015-01-15 00:41:26.000000', 'consum', 0.0214, 'lps'),
	(373523, 126, '2015-01-15 00:41:27.000000', 'consum', 0.0213, 'lps'),
	(373524, 126, '2015-01-15 00:41:28.000000', 'consum', 0.0213, 'lps'),
	(373525, 126, '2015-01-15 00:41:29.000000', 'consum', 0.0215, 'lps'),
	(373526, 126, '2015-01-15 00:41:30.000000', 'consum', 0.0210, 'lps'),
	(373527, 126, '2015-01-15 00:41:31.000000', 'consum', 0.0215, 'lps'),
	(373528, 126, '2015-01-15 00:41:32.000000', 'consum', 0.0217, 'lps'),
	(373529, 126, '2015-01-15 00:41:33.000000', 'consum', 0.0212, 'lps'),
	(373530, 126, '2015-01-15 00:41:34.000000', 'consum', 0.0219, 'lps'),
	(373531, 126, '2015-01-15 00:41:35.000000', 'consum', 0.0210, 'lps'),
	(373532, 126, '2015-01-15 00:41:36.000000', 'consum', 0.0220, 'lps'),
	(373533, 126, '2015-01-15 00:41:37.000000', 'consum', 0.0225, 'lps'),
	(373534, 126, '2015-01-15 00:41:38.000000', 'consum', 0.0217, 'lps'),
	(373535, 126, '2015-01-15 00:41:39.000000', 'consum', 0.0219, 'lps'),
	(373536, 126, '2015-01-15 00:41:40.000000', 'consum', 0.0214, 'lps'),
	(373537, 126, '2015-01-15 00:41:41.000000', 'consum', 0.0223, 'lps'),
	(373538, 126, '2015-01-15 00:41:42.000000', 'consum', 0.0224, 'lps'),
	(373539, 126, '2015-01-15 00:41:43.000000', 'consum', 0.0226, 'lps'),
	(373540, 126, '2015-01-15 00:41:44.000000', 'consum', 0.0227, 'lps'),
	(373541, 126, '2015-01-15 00:41:45.000000', 'consum', 0.0228, 'lps'),
	(373542, 126, '2015-01-15 00:41:46.000000', 'consum', 0.0213, 'lps'),
	(373543, 126, '2015-01-15 00:41:47.000000', 'consum', 0.0210, 'lps'),
	(373544, 126, '2015-01-15 00:41:48.000000', 'consum', 0.0219, 'lps'),
	(373545, 126, '2015-01-15 00:41:49.000000', 'consum', 0.0218, 'lps'),
	(373546, 126, '2015-01-15 00:41:50.000000', 'consum', 0.0222, 'lps'),
	(373547, 126, '2015-01-15 00:41:51.000000', 'consum', 0.0212, 'lps'),
	(373548, 126, '2015-01-15 00:41:52.000000', 'consum', 0.0219, 'lps'),
	(373549, 126, '2015-01-15 00:41:53.000000', 'consum', 0.0214, 'lps'),
	(373550, 126, '2015-01-15 00:41:54.000000', 'consum', 0.0220, 'lps'),
	(373551, 126, '2015-01-15 00:41:55.000000', 'consum', 0.0214, 'lps'),
	(373552, 126, '2015-01-15 00:41:56.000000', 'consum', 0.0217, 'lps'),
	(373553, 126, '2015-01-15 00:41:57.000000', 'consum', 0.0215, 'lps'),
	(373554, 126, '2015-01-15 00:41:58.000000', 'consum', 0.0214, 'lps'),
	(373555, 126, '2015-01-15 00:41:59.000000', 'consum', 0.0214, 'lps'),
	(373556, 126, '2015-01-15 00:42:00.000000', 'consum', 0.0220, 'lps'),
	(373557, 126, '2015-01-15 00:42:01.000000', 'consum', 0.0228, 'lps'),
	(373558, 126, '2015-01-15 00:42:02.000000', 'consum', 0.0214, 'lps'),
	(373559, 126, '2015-01-15 00:42:03.000000', 'consum', 0.0216, 'lps'),
	(373560, 126, '2015-01-15 00:42:04.000000', 'consum', 0.0226, 'lps'),
	(373561, 126, '2015-01-15 00:42:05.000000', 'consum', 0.0218, 'lps'),
	(373562, 126, '2015-01-15 00:42:06.000000', 'consum', 0.0221, 'lps'),
	(373563, 126, '2015-01-15 00:42:07.000000', 'consum', 0.0224, 'lps'),
	(373564, 126, '2015-01-15 00:42:08.000000', 'consum', 0.0226, 'lps'),
	(373565, 126, '2015-01-15 00:42:09.000000', 'consum', 0.0211, 'lps'),
	(373566, 126, '2015-01-15 00:42:10.000000', 'consum', 0.0223, 'lps'),
	(373567, 126, '2015-01-15 00:42:11.000000', 'consum', 0.0217, 'lps'),
	(373568, 126, '2015-01-15 00:42:12.000000', 'consum', 0.0224, 'lps'),
	(373569, 126, '2015-01-15 00:42:13.000000', 'consum', 0.0223, 'lps'),
	(373570, 126, '2015-01-15 00:42:14.000000', 'consum', 0.0216, 'lps'),
	(373571, 126, '2015-01-15 00:42:15.000000', 'consum', 0.0219, 'lps'),
	(373572, 126, '2015-01-15 00:42:16.000000', 'consum', 0.0219, 'lps'),
	(373573, 126, '2015-01-15 00:42:17.000000', 'consum', 0.0227, 'lps'),
	(373574, 126, '2015-01-15 00:42:18.000000', 'consum', 0.0212, 'lps'),
	(373575, 126, '2015-01-15 00:42:19.000000', 'consum', 0.0228, 'lps'),
	(373576, 126, '2015-01-15 00:42:20.000000', 'consum', 0.0215, 'lps'),
	(373577, 126, '2015-01-15 00:42:21.000000', 'consum', 0.0223, 'lps'),
	(373578, 126, '2015-01-15 00:42:22.000000', 'consum', 0.0223, 'lps'),
	(373579, 126, '2015-01-15 00:42:23.000000', 'consum', 0.0218, 'lps'),
	(373580, 126, '2015-01-15 00:42:24.000000', 'consum', 0.0211, 'lps'),
	(373581, 126, '2015-01-15 00:42:25.000000', 'consum', 0.0210, 'lps'),
	(373582, 126, '2015-01-15 00:42:26.000000', 'consum', 0.0227, 'lps'),
	(373583, 126, '2015-01-15 00:42:27.000000', 'consum', 0.0218, 'lps'),
	(373584, 126, '2015-01-15 00:42:28.000000', 'consum', 0.0218, 'lps'),
	(373585, 126, '2015-01-15 00:42:29.000000', 'consum', 0.0227, 'lps'),
	(373586, 126, '2015-01-15 00:42:30.000000', 'consum', 0.0213, 'lps'),
	(373587, 126, '2015-01-15 00:42:31.000000', 'consum', 0.0215, 'lps'),
	(373588, 126, '2015-01-15 00:42:32.000000', 'consum', 0.0227, 'lps'),
	(373589, 126, '2015-01-15 00:42:33.000000', 'consum', 0.0221, 'lps'),
	(373590, 126, '2015-01-15 00:42:34.000000', 'consum', 0.0216, 'lps'),
	(373591, 126, '2015-01-15 00:42:35.000000', 'consum', 0.0227, 'lps'),
	(373592, 126, '2015-01-15 00:42:36.000000', 'consum', 0.0218, 'lps'),
	(373593, 126, '2015-01-15 00:42:37.000000', 'consum', 0.0219, 'lps'),
	(373594, 126, '2015-01-15 00:42:38.000000', 'consum', 0.0214, 'lps'),
	(373595, 126, '2015-01-15 00:42:39.000000', 'consum', 0.0223, 'lps'),
	(373596, 126, '2015-01-15 00:42:40.000000', 'consum', 0.0224, 'lps'),
	(373597, 126, '2015-01-15 00:42:41.000000', 'consum', 0.0222, 'lps'),
	(373598, 126, '2015-01-15 00:42:42.000000', 'consum', 0.0211, 'lps'),
	(373599, 126, '2015-01-15 00:42:43.000000', 'consum', 0.0217, 'lps'),
	(373600, 126, '2015-01-15 00:42:44.000000', 'consum', 0.0224, 'lps'),
	(373601, 126, '2015-01-15 00:42:45.000000', 'consum', 0.0221, 'lps'),
	(373602, 126, '2015-01-15 00:42:46.000000', 'consum', 0.0226, 'lps'),
	(373603, 126, '2015-01-15 00:42:47.000000', 'consum', 0.0216, 'lps'),
	(373604, 126, '2015-01-15 00:42:48.000000', 'consum', 0.0213, 'lps'),
	(373605, 126, '2015-01-15 00:42:49.000000', 'consum', 0.0227, 'lps'),
	(373606, 126, '2015-01-15 00:42:50.000000', 'consum', 0.0210, 'lps'),
	(373607, 126, '2015-01-15 00:42:51.000000', 'consum', 0.0217, 'lps'),
	(373608, 126, '2015-01-15 00:42:52.000000', 'consum', 0.0226, 'lps'),
	(373609, 126, '2015-01-15 00:42:53.000000', 'consum', 0.0212, 'lps'),
	(373610, 126, '2015-01-15 00:42:54.000000', 'consum', 0.0213, 'lps'),
	(373611, 126, '2015-01-15 00:42:55.000000', 'consum', 0.0216, 'lps'),
	(373612, 126, '2015-01-15 00:42:56.000000', 'consum', 0.0215, 'lps'),
	(373613, 126, '2015-01-15 00:42:57.000000', 'consum', 0.0218, 'lps'),
	(373614, 126, '2015-01-15 00:42:58.000000', 'consum', 0.0214, 'lps'),
	(373615, 126, '2015-01-15 00:42:59.000000', 'consum', 0.0225, 'lps'),
	(373616, 126, '2015-01-15 00:43:00.000000', 'consum', 0.0217, 'lps'),
	(373617, 126, '2015-01-15 00:43:01.000000', 'consum', 0.0218, 'lps'),
	(373618, 126, '2015-01-15 00:43:02.000000', 'consum', 0.0213, 'lps'),
	(373619, 126, '2015-01-15 00:43:03.000000', 'consum', 0.0221, 'lps'),
	(373620, 126, '2015-01-15 00:43:04.000000', 'consum', 0.0218, 'lps'),
	(373621, 126, '2015-01-15 00:43:05.000000', 'consum', 0.0219, 'lps'),
	(373622, 126, '2015-01-15 00:43:06.000000', 'consum', 0.0212, 'lps'),
	(373623, 126, '2015-01-15 00:43:07.000000', 'consum', 0.0211, 'lps'),
	(373624, 126, '2015-01-15 00:43:08.000000', 'consum', 0.0227, 'lps'),
	(373625, 126, '2015-01-15 00:43:09.000000', 'consum', 0.0220, 'lps'),
	(373626, 126, '2015-01-15 00:43:10.000000', 'consum', 0.0225, 'lps'),
	(373627, 126, '2015-01-15 00:43:11.000000', 'consum', 0.0219, 'lps'),
	(373628, 126, '2015-01-15 00:43:12.000000', 'consum', 0.0211, 'lps'),
	(373629, 126, '2015-01-15 00:43:13.000000', 'consum', 0.0227, 'lps'),
	(373630, 126, '2015-01-15 00:43:14.000000', 'consum', 0.0216, 'lps'),
	(373631, 126, '2015-01-15 00:43:15.000000', 'consum', 0.0227, 'lps'),
	(373632, 126, '2015-01-15 00:43:16.000000', 'consum', 0.0223, 'lps'),
	(373633, 126, '2015-01-15 00:43:17.000000', 'consum', 0.0222, 'lps'),
	(373634, 126, '2015-01-15 00:43:18.000000', 'consum', 0.0213, 'lps'),
	(373635, 126, '2015-01-15 00:43:19.000000', 'consum', 0.0227, 'lps'),
	(373636, 126, '2015-01-15 00:43:20.000000', 'consum', 0.0228, 'lps'),
	(373637, 126, '2015-01-15 00:43:21.000000', 'consum', 0.0214, 'lps'),
	(373638, 126, '2015-01-15 00:43:22.000000', 'consum', 0.0214, 'lps'),
	(373639, 126, '2015-01-15 00:43:23.000000', 'consum', 0.0219, 'lps'),
	(373640, 126, '2015-01-15 00:43:24.000000', 'consum', 0.0225, 'lps'),
	(373641, 126, '2015-01-15 00:43:25.000000', 'consum', 0.0219, 'lps'),
	(373642, 126, '2015-01-15 00:43:26.000000', 'consum', 0.0210, 'lps'),
	(373643, 126, '2015-01-15 00:43:27.000000', 'consum', 0.0224, 'lps'),
	(373644, 126, '2015-01-15 00:43:28.000000', 'consum', 0.0221, 'lps'),
	(373645, 126, '2015-01-15 00:43:29.000000', 'consum', 0.0224, 'lps'),
	(373646, 126, '2015-01-15 00:43:30.000000', 'consum', 0.0211, 'lps'),
	(373647, 126, '2015-01-15 00:43:31.000000', 'consum', 0.0228, 'lps'),
	(373648, 126, '2015-01-15 00:43:32.000000', 'consum', 0.0221, 'lps'),
	(373649, 126, '2015-01-15 00:43:33.000000', 'consum', 0.0211, 'lps'),
	(373650, 126, '2015-01-15 00:43:34.000000', 'consum', 0.0222, 'lps'),
	(373651, 126, '2015-01-15 00:43:35.000000', 'consum', 0.0211, 'lps'),
	(373652, 126, '2015-01-15 00:43:36.000000', 'consum', 0.0217, 'lps'),
	(373653, 126, '2015-01-15 00:43:37.000000', 'consum', 0.0225, 'lps'),
	(373654, 126, '2015-01-15 00:43:38.000000', 'consum', 0.0224, 'lps'),
	(373655, 126, '2015-01-15 00:43:39.000000', 'consum', 0.0217, 'lps'),
	(373656, 126, '2015-01-15 00:43:40.000000', 'consum', 0.0223, 'lps'),
	(373657, 126, '2015-01-15 00:43:41.000000', 'consum', 0.0216, 'lps'),
	(373658, 126, '2015-01-15 00:43:42.000000', 'consum', 0.0220, 'lps'),
	(373659, 126, '2015-01-15 00:43:43.000000', 'consum', 0.0226, 'lps'),
	(373660, 126, '2015-01-15 00:43:44.000000', 'consum', 0.0221, 'lps'),
	(373661, 126, '2015-01-15 00:43:45.000000', 'consum', 0.0217, 'lps'),
	(373662, 126, '2015-01-15 00:43:46.000000', 'consum', 0.0214, 'lps'),
	(373663, 126, '2015-01-15 00:43:47.000000', 'consum', 0.0210, 'lps'),
	(373664, 126, '2015-01-15 00:43:48.000000', 'consum', 0.0215, 'lps'),
	(373665, 126, '2015-01-15 00:43:49.000000', 'consum', 0.0218, 'lps'),
	(373666, 126, '2015-01-15 00:43:50.000000', 'consum', 0.0218, 'lps'),
	(373667, 126, '2015-01-15 00:43:51.000000', 'consum', 0.0224, 'lps'),
	(373668, 126, '2015-01-15 00:43:52.000000', 'consum', 0.0219, 'lps'),
	(373669, 126, '2015-01-15 00:43:53.000000', 'consum', 0.0213, 'lps'),
	(373670, 126, '2015-01-15 00:43:54.000000', 'consum', 0.0219, 'lps'),
	(373671, 126, '2015-01-15 00:43:55.000000', 'consum', 0.0210, 'lps'),
	(373672, 126, '2015-01-15 00:43:56.000000', 'consum', 0.0220, 'lps'),
	(373673, 126, '2015-01-15 00:43:57.000000', 'consum', 0.0222, 'lps'),
	(373674, 126, '2015-01-15 00:43:58.000000', 'consum', 0.0221, 'lps'),
	(373675, 126, '2015-01-15 00:43:59.000000', 'consum', 0.0211, 'lps'),
	(373676, 126, '2015-01-15 00:44:00.000000', 'consum', 0.0221, 'lps'),
	(373677, 126, '2015-01-15 00:44:01.000000', 'consum', 0.0224, 'lps'),
	(373678, 126, '2015-01-15 00:44:02.000000', 'consum', 0.0227, 'lps'),
	(373679, 126, '2015-01-15 00:44:03.000000', 'consum', 0.0218, 'lps'),
	(373680, 126, '2015-01-15 00:44:04.000000', 'consum', 0.0218, 'lps'),
	(373681, 126, '2015-01-15 00:44:05.000000', 'consum', 0.0227, 'lps'),
	(373682, 126, '2015-01-15 00:44:06.000000', 'consum', 0.0215, 'lps'),
	(373683, 126, '2015-01-15 00:44:07.000000', 'consum', 0.0221, 'lps'),
	(373684, 126, '2015-01-15 00:44:08.000000', 'consum', 0.0213, 'lps'),
	(373685, 126, '2015-01-15 00:44:09.000000', 'consum', 0.0213, 'lps'),
	(373686, 126, '2015-01-15 00:44:10.000000', 'consum', 0.0214, 'lps'),
	(373687, 126, '2015-01-15 00:44:11.000000', 'consum', 0.0223, 'lps'),
	(373688, 126, '2015-01-15 00:44:12.000000', 'consum', 0.0224, 'lps'),
	(373689, 126, '2015-01-15 00:44:13.000000', 'consum', 0.0223, 'lps'),
	(373690, 126, '2015-01-15 00:44:14.000000', 'consum', 0.0215, 'lps'),
	(373691, 126, '2015-01-15 00:44:15.000000', 'consum', 0.0214, 'lps'),
	(373692, 126, '2015-01-15 00:44:16.000000', 'consum', 0.0215, 'lps'),
	(373693, 126, '2015-01-15 00:44:17.000000', 'consum', 0.0224, 'lps'),
	(373694, 126, '2015-01-15 00:44:18.000000', 'consum', 0.0228, 'lps'),
	(373695, 126, '2015-01-15 00:44:19.000000', 'consum', 0.0221, 'lps'),
	(373696, 126, '2015-01-15 00:44:20.000000', 'consum', 0.0210, 'lps'),
	(373697, 126, '2015-01-15 00:44:21.000000', 'consum', 0.0218, 'lps'),
	(373698, 126, '2015-01-15 00:44:22.000000', 'consum', 0.0211, 'lps'),
	(373699, 126, '2015-01-15 00:44:23.000000', 'consum', 0.0228, 'lps'),
	(373700, 126, '2015-01-15 00:44:24.000000', 'consum', 0.0223, 'lps'),
	(373701, 126, '2015-01-15 00:44:25.000000', 'consum', 0.0222, 'lps'),
	(373702, 126, '2015-01-15 00:44:26.000000', 'consum', 0.0211, 'lps'),
	(373703, 126, '2015-01-15 00:44:27.000000', 'consum', 0.0219, 'lps'),
	(373704, 126, '2015-01-15 00:44:28.000000', 'consum', 0.0214, 'lps'),
	(373705, 126, '2015-01-15 00:44:29.000000', 'consum', 0.0222, 'lps'),
	(373706, 126, '2015-01-15 00:44:30.000000', 'consum', 0.0220, 'lps'),
	(373707, 126, '2015-01-15 00:44:31.000000', 'consum', 0.0223, 'lps'),
	(373708, 126, '2015-01-15 00:44:32.000000', 'consum', 0.0228, 'lps'),
	(373709, 126, '2015-01-15 00:44:33.000000', 'consum', 0.0225, 'lps'),
	(373710, 126, '2015-01-15 00:44:34.000000', 'consum', 0.0210, 'lps'),
	(373711, 126, '2015-01-15 00:44:35.000000', 'consum', 0.0225, 'lps'),
	(373712, 126, '2015-01-15 00:44:36.000000', 'consum', 0.0227, 'lps'),
	(373713, 126, '2015-01-15 00:44:37.000000', 'consum', 0.0214, 'lps'),
	(373714, 126, '2015-01-15 00:44:38.000000', 'consum', 0.0216, 'lps'),
	(373715, 126, '2015-01-15 00:44:39.000000', 'consum', 0.0228, 'lps'),
	(373716, 126, '2015-01-15 00:44:40.000000', 'consum', 0.0225, 'lps'),
	(373717, 126, '2015-01-15 00:44:41.000000', 'consum', 0.0215, 'lps'),
	(373718, 126, '2015-01-15 00:44:42.000000', 'consum', 0.0210, 'lps'),
	(373719, 126, '2015-01-15 00:44:43.000000', 'consum', 0.0212, 'lps'),
	(373720, 126, '2015-01-15 00:44:44.000000', 'consum', 0.0222, 'lps'),
	(373721, 126, '2015-01-15 00:44:45.000000', 'consum', 0.0224, 'lps'),
	(373722, 126, '2015-01-15 00:44:46.000000', 'consum', 0.0210, 'lps'),
	(373723, 126, '2015-01-15 00:44:47.000000', 'consum', 0.0223, 'lps'),
	(373724, 126, '2015-01-15 00:44:48.000000', 'consum', 0.0219, 'lps'),
	(373725, 126, '2015-01-15 00:44:49.000000', 'consum', 0.0215, 'lps'),
	(373726, 126, '2015-01-15 00:44:50.000000', 'consum', 0.0211, 'lps'),
	(373727, 126, '2015-01-15 00:44:51.000000', 'consum', 0.0217, 'lps'),
	(373728, 126, '2015-01-15 00:44:52.000000', 'consum', 0.0225, 'lps'),
	(373729, 126, '2015-01-15 00:44:53.000000', 'consum', 0.0227, 'lps'),
	(373730, 126, '2015-01-15 00:44:54.000000', 'consum', 0.0213, 'lps'),
	(373731, 126, '2015-01-15 00:44:55.000000', 'consum', 0.0212, 'lps'),
	(373732, 126, '2015-01-15 00:44:56.000000', 'consum', 0.0228, 'lps'),
	(373733, 126, '2015-01-15 00:44:57.000000', 'consum', 0.0222, 'lps'),
	(373734, 126, '2015-01-15 00:44:58.000000', 'consum', 0.0215, 'lps'),
	(373735, 126, '2015-01-15 00:44:59.000000', 'consum', 0.0217, 'lps'),
	(373736, 126, '2015-01-15 00:45:00.000000', 'consum', 0.0213, 'lps'),
	(373737, 126, '2015-01-15 00:45:01.000000', 'consum', 0.0223, 'lps'),
	(373738, 126, '2015-01-15 00:45:02.000000', 'consum', 0.0211, 'lps'),
	(373739, 126, '2015-01-15 00:45:03.000000', 'consum', 0.0214, 'lps'),
	(373740, 126, '2015-01-15 00:45:04.000000', 'consum', 0.0210, 'lps'),
	(373741, 126, '2015-01-15 00:45:05.000000', 'consum', 0.0216, 'lps'),
	(373742, 126, '2015-01-15 00:45:06.000000', 'consum', 0.0223, 'lps'),
	(373743, 126, '2015-01-15 00:45:07.000000', 'consum', 0.0220, 'lps'),
	(373744, 126, '2015-01-15 00:45:08.000000', 'consum', 0.0223, 'lps'),
	(373745, 126, '2015-01-15 00:45:09.000000', 'consum', 0.0223, 'lps'),
	(373746, 126, '2015-01-15 00:45:10.000000', 'consum', 0.0219, 'lps'),
	(373747, 126, '2015-01-15 00:45:11.000000', 'consum', 0.0216, 'lps'),
	(373748, 126, '2015-01-15 00:45:12.000000', 'consum', 0.0215, 'lps'),
	(373749, 126, '2015-01-15 00:45:13.000000', 'consum', 0.0217, 'lps'),
	(373750, 126, '2015-01-15 00:45:14.000000', 'consum', 0.0210, 'lps'),
	(373751, 126, '2015-01-15 00:45:15.000000', 'consum', 0.0228, 'lps'),
	(373752, 126, '2015-01-15 00:45:16.000000', 'consum', 0.0226, 'lps'),
	(373753, 126, '2015-01-15 00:45:17.000000', 'consum', 0.0216, 'lps'),
	(373754, 126, '2015-01-15 00:45:18.000000', 'consum', 0.0210, 'lps'),
	(373755, 126, '2015-01-15 00:45:19.000000', 'consum', 0.0213, 'lps'),
	(373756, 126, '2015-01-15 00:45:20.000000', 'consum', 0.0225, 'lps'),
	(373757, 126, '2015-01-15 00:45:21.000000', 'consum', 0.0221, 'lps'),
	(373758, 126, '2015-01-15 00:45:22.000000', 'consum', 0.0220, 'lps'),
	(373759, 126, '2015-01-15 00:45:23.000000', 'consum', 0.0227, 'lps'),
	(373760, 126, '2015-01-15 00:45:24.000000', 'consum', 0.0210, 'lps'),
	(373761, 126, '2015-01-15 00:45:25.000000', 'consum', 0.0216, 'lps'),
	(373762, 126, '2015-01-15 00:45:26.000000', 'consum', 0.0223, 'lps'),
	(373763, 126, '2015-01-15 00:45:27.000000', 'consum', 0.0218, 'lps'),
	(373764, 126, '2015-01-15 00:45:28.000000', 'consum', 0.0211, 'lps'),
	(373765, 126, '2015-01-15 00:45:29.000000', 'consum', 0.0213, 'lps'),
	(373766, 126, '2015-01-15 00:45:30.000000', 'consum', 0.0219, 'lps'),
	(373767, 126, '2015-01-15 00:45:31.000000', 'consum', 0.0212, 'lps'),
	(373768, 126, '2015-01-15 00:45:32.000000', 'consum', 0.0211, 'lps'),
	(373769, 126, '2015-01-15 00:45:33.000000', 'consum', 0.0228, 'lps'),
	(373770, 126, '2015-01-15 00:45:34.000000', 'consum', 0.0223, 'lps'),
	(373771, 126, '2015-01-15 00:45:35.000000', 'consum', 0.0219, 'lps'),
	(373772, 126, '2015-01-15 00:45:36.000000', 'consum', 0.0217, 'lps'),
	(373773, 126, '2015-01-15 00:45:37.000000', 'consum', 0.0217, 'lps'),
	(373774, 126, '2015-01-15 00:45:38.000000', 'consum', 0.0228, 'lps'),
	(373775, 126, '2015-01-15 00:45:39.000000', 'consum', 0.0220, 'lps'),
	(373776, 126, '2015-01-15 00:45:40.000000', 'consum', 0.0226, 'lps'),
	(373777, 126, '2015-01-15 00:45:41.000000', 'consum', 0.0222, 'lps'),
	(373778, 126, '2015-01-15 00:45:42.000000', 'consum', 0.0224, 'lps'),
	(373779, 126, '2015-01-15 00:45:43.000000', 'consum', 0.0223, 'lps'),
	(373780, 126, '2015-01-15 00:45:44.000000', 'consum', 0.0215, 'lps'),
	(373781, 126, '2015-01-15 00:45:45.000000', 'consum', 0.0218, 'lps'),
	(373782, 126, '2015-01-15 00:45:46.000000', 'consum', 0.0215, 'lps'),
	(373783, 126, '2015-01-15 00:45:47.000000', 'consum', 0.0213, 'lps'),
	(373784, 126, '2015-01-15 00:45:48.000000', 'consum', 0.0227, 'lps'),
	(373785, 126, '2015-01-15 00:45:49.000000', 'consum', 0.0211, 'lps'),
	(373786, 126, '2015-01-15 00:45:50.000000', 'consum', 0.0224, 'lps'),
	(373787, 126, '2015-01-15 00:45:51.000000', 'consum', 0.0217, 'lps'),
	(373788, 126, '2015-01-15 00:45:52.000000', 'consum', 0.0224, 'lps'),
	(373789, 126, '2015-01-15 00:45:53.000000', 'consum', 0.0222, 'lps'),
	(373790, 126, '2015-01-15 00:45:54.000000', 'consum', 0.0226, 'lps'),
	(373791, 126, '2015-01-15 00:45:55.000000', 'consum', 0.0220, 'lps'),
	(373792, 126, '2015-01-15 00:45:56.000000', 'consum', 0.0210, 'lps'),
	(373793, 126, '2015-01-15 00:45:57.000000', 'consum', 0.0221, 'lps'),
	(373794, 126, '2015-01-15 00:45:58.000000', 'consum', 0.0227, 'lps'),
	(373795, 126, '2015-01-15 00:45:59.000000', 'consum', 0.0225, 'lps'),
	(373796, 126, '2015-01-15 00:46:00.000000', 'consum', 0.0216, 'lps'),
	(373797, 126, '2015-01-15 00:46:01.000000', 'consum', 0.0213, 'lps'),
	(373798, 126, '2015-01-15 00:46:02.000000', 'consum', 0.0228, 'lps'),
	(373799, 126, '2015-01-15 00:46:03.000000', 'consum', 0.0216, 'lps'),
	(373800, 126, '2015-01-15 00:46:04.000000', 'consum', 0.0225, 'lps'),
	(373801, 126, '2015-01-15 00:46:05.000000', 'consum', 0.0210, 'lps'),
	(373802, 126, '2015-01-15 00:46:06.000000', 'consum', 0.0220, 'lps'),
	(373803, 126, '2015-01-15 00:46:07.000000', 'consum', 0.0226, 'lps'),
	(373804, 126, '2015-01-15 00:46:08.000000', 'consum', 0.0221, 'lps'),
	(373805, 126, '2015-01-15 00:46:09.000000', 'consum', 0.0217, 'lps'),
	(373806, 126, '2015-01-15 00:46:10.000000', 'consum', 0.0213, 'lps'),
	(373807, 126, '2015-01-15 00:46:11.000000', 'consum', 0.0223, 'lps'),
	(373808, 126, '2015-01-15 00:46:12.000000', 'consum', 0.0227, 'lps'),
	(373809, 126, '2015-01-15 00:46:13.000000', 'consum', 0.0219, 'lps'),
	(373810, 126, '2015-01-15 00:46:14.000000', 'consum', 0.0223, 'lps'),
	(373811, 126, '2015-01-15 00:46:15.000000', 'consum', 0.0213, 'lps'),
	(373812, 126, '2015-01-15 00:46:16.000000', 'consum', 0.0224, 'lps'),
	(373813, 126, '2015-01-15 00:46:17.000000', 'consum', 0.0213, 'lps'),
	(373814, 126, '2015-01-15 00:46:18.000000', 'consum', 0.0224, 'lps'),
	(373815, 126, '2015-01-15 00:46:19.000000', 'consum', 0.0213, 'lps'),
	(373816, 126, '2015-01-15 00:46:20.000000', 'consum', 0.0221, 'lps'),
	(373817, 126, '2015-01-15 00:46:21.000000', 'consum', 0.0219, 'lps'),
	(373818, 126, '2015-01-15 00:46:22.000000', 'consum', 0.0221, 'lps'),
	(373819, 126, '2015-01-15 00:46:23.000000', 'consum', 0.0219, 'lps'),
	(373820, 126, '2015-01-15 00:46:24.000000', 'consum', 0.0224, 'lps'),
	(373821, 126, '2015-01-15 00:46:25.000000', 'consum', 0.0213, 'lps'),
	(373822, 126, '2015-01-15 00:46:26.000000', 'consum', 0.0223, 'lps'),
	(373823, 126, '2015-01-15 00:46:27.000000', 'consum', 0.0212, 'lps'),
	(373824, 126, '2015-01-15 00:46:28.000000', 'consum', 0.0216, 'lps'),
	(373825, 126, '2015-01-15 00:46:29.000000', 'consum', 0.0217, 'lps'),
	(373826, 126, '2015-01-15 00:46:30.000000', 'consum', 0.0227, 'lps'),
	(373827, 126, '2015-01-15 00:46:31.000000', 'consum', 0.0216, 'lps'),
	(373828, 126, '2015-01-15 00:46:32.000000', 'consum', 0.0228, 'lps'),
	(373829, 126, '2015-01-15 00:46:33.000000', 'consum', 0.0227, 'lps'),
	(373830, 126, '2015-01-15 00:46:34.000000', 'consum', 0.0223, 'lps'),
	(373831, 126, '2015-01-15 00:46:35.000000', 'consum', 0.0223, 'lps'),
	(373832, 126, '2015-01-15 00:46:36.000000', 'consum', 0.0219, 'lps'),
	(373833, 126, '2015-01-15 00:46:37.000000', 'consum', 0.0217, 'lps'),
	(373834, 126, '2015-01-15 00:46:38.000000', 'consum', 0.0219, 'lps'),
	(373835, 126, '2015-01-15 00:46:39.000000', 'consum', 0.0214, 'lps'),
	(373836, 126, '2015-01-15 00:46:40.000000', 'consum', 0.0221, 'lps'),
	(373837, 126, '2015-01-15 00:46:41.000000', 'consum', 0.0217, 'lps'),
	(373838, 126, '2015-01-15 00:46:42.000000', 'consum', 0.0210, 'lps'),
	(373839, 126, '2015-01-15 00:46:43.000000', 'consum', 0.0212, 'lps'),
	(373840, 126, '2015-01-15 00:46:44.000000', 'consum', 0.0220, 'lps'),
	(373841, 126, '2015-01-15 00:46:45.000000', 'consum', 0.0215, 'lps'),
	(373842, 126, '2015-01-15 00:46:46.000000', 'consum', 0.0224, 'lps'),
	(373843, 126, '2015-01-15 00:46:47.000000', 'consum', 0.0227, 'lps'),
	(373844, 126, '2015-01-15 00:46:48.000000', 'consum', 0.0216, 'lps'),
	(373845, 126, '2015-01-15 00:46:49.000000', 'consum', 0.0226, 'lps'),
	(373846, 126, '2015-01-15 00:46:50.000000', 'consum', 0.0217, 'lps'),
	(373847, 126, '2015-01-15 00:46:51.000000', 'consum', 0.0215, 'lps'),
	(373848, 126, '2015-01-15 00:46:52.000000', 'consum', 0.0215, 'lps'),
	(373849, 126, '2015-01-15 00:46:53.000000', 'consum', 0.0219, 'lps'),
	(373850, 126, '2015-01-15 00:46:54.000000', 'consum', 0.0222, 'lps'),
	(373851, 126, '2015-01-15 00:46:55.000000', 'consum', 0.0223, 'lps'),
	(373852, 126, '2015-01-15 00:46:56.000000', 'consum', 0.0223, 'lps'),
	(373853, 126, '2015-01-15 00:46:57.000000', 'consum', 0.0215, 'lps'),
	(373854, 126, '2015-01-15 00:46:58.000000', 'consum', 0.0216, 'lps'),
	(373855, 126, '2015-01-15 00:46:59.000000', 'consum', 0.0226, 'lps'),
	(373856, 126, '2015-01-15 00:47:00.000000', 'consum', 0.0217, 'lps'),
	(373857, 126, '2015-01-15 00:47:01.000000', 'consum', 0.0217, 'lps'),
	(373858, 126, '2015-01-15 00:47:02.000000', 'consum', 0.0223, 'lps'),
	(373859, 126, '2015-01-15 00:47:03.000000', 'consum', 0.0217, 'lps'),
	(373860, 126, '2015-01-15 00:47:04.000000', 'consum', 0.0227, 'lps'),
	(373861, 126, '2015-01-15 00:47:05.000000', 'consum', 0.0216, 'lps'),
	(373862, 126, '2015-01-15 00:47:06.000000', 'consum', 0.0211, 'lps'),
	(373863, 126, '2015-01-15 00:47:07.000000', 'consum', 0.0214, 'lps'),
	(373864, 126, '2015-01-15 00:47:08.000000', 'consum', 0.0227, 'lps'),
	(373865, 126, '2015-01-15 00:47:09.000000', 'consum', 0.0226, 'lps'),
	(373866, 126, '2015-01-15 00:47:10.000000', 'consum', 0.0222, 'lps'),
	(373867, 126, '2015-01-15 00:47:11.000000', 'consum', 0.0221, 'lps'),
	(373868, 126, '2015-01-15 00:47:12.000000', 'consum', 0.0211, 'lps'),
	(373869, 126, '2015-01-15 00:47:13.000000', 'consum', 0.0220, 'lps'),
	(373870, 126, '2015-01-15 00:47:14.000000', 'consum', 0.0222, 'lps'),
	(373871, 126, '2015-01-15 00:47:15.000000', 'consum', 0.0219, 'lps'),
	(373872, 126, '2015-01-15 00:47:16.000000', 'consum', 0.0220, 'lps'),
	(373873, 126, '2015-01-15 00:47:17.000000', 'consum', 0.0216, 'lps'),
	(373874, 126, '2015-01-15 00:47:18.000000', 'consum', 0.0211, 'lps'),
	(373875, 126, '2015-01-15 00:47:19.000000', 'consum', 0.0216, 'lps'),
	(373876, 126, '2015-01-15 00:47:20.000000', 'consum', 0.0217, 'lps'),
	(373877, 126, '2015-01-15 00:47:21.000000', 'consum', 0.0228, 'lps'),
	(373878, 126, '2015-01-15 00:47:22.000000', 'consum', 0.0224, 'lps'),
	(373879, 126, '2015-01-15 00:47:23.000000', 'consum', 0.0227, 'lps'),
	(373880, 126, '2015-01-15 00:47:24.000000', 'consum', 0.0213, 'lps'),
	(373881, 126, '2015-01-15 00:47:25.000000', 'consum', 0.0214, 'lps'),
	(373882, 126, '2015-01-15 00:47:26.000000', 'consum', 0.0219, 'lps'),
	(373883, 126, '2015-01-15 00:47:27.000000', 'consum', 0.0227, 'lps'),
	(373884, 126, '2015-01-15 00:47:28.000000', 'consum', 0.0228, 'lps'),
	(373885, 126, '2015-01-15 00:47:29.000000', 'consum', 0.0212, 'lps'),
	(373886, 126, '2015-01-15 00:47:30.000000', 'consum', 0.0222, 'lps'),
	(373887, 126, '2015-01-15 00:47:31.000000', 'consum', 0.0228, 'lps'),
	(373888, 126, '2015-01-15 00:47:32.000000', 'consum', 0.0210, 'lps'),
	(373889, 126, '2015-01-15 00:47:33.000000', 'consum', 0.0210, 'lps'),
	(373890, 126, '2015-01-15 00:47:34.000000', 'consum', 0.0211, 'lps'),
	(373891, 126, '2015-01-15 00:47:35.000000', 'consum', 0.0216, 'lps'),
	(373892, 126, '2015-01-15 00:47:36.000000', 'consum', 0.0220, 'lps'),
	(373893, 126, '2015-01-15 00:47:37.000000', 'consum', 0.0221, 'lps'),
	(373894, 126, '2015-01-15 00:47:38.000000', 'consum', 0.0217, 'lps'),
	(373895, 126, '2015-01-15 00:47:39.000000', 'consum', 0.0212, 'lps'),
	(373896, 126, '2015-01-15 00:47:40.000000', 'consum', 0.0220, 'lps'),
	(373897, 126, '2015-01-15 00:47:41.000000', 'consum', 0.0218, 'lps'),
	(373898, 126, '2015-01-15 00:47:42.000000', 'consum', 0.0219, 'lps'),
	(373899, 126, '2015-01-15 00:47:43.000000', 'consum', 0.0211, 'lps'),
	(373900, 126, '2015-01-15 00:47:44.000000', 'consum', 0.0210, 'lps'),
	(373901, 126, '2015-01-15 00:47:45.000000', 'consum', 0.0224, 'lps'),
	(373902, 126, '2015-01-15 00:47:46.000000', 'consum', 0.0223, 'lps'),
	(373903, 126, '2015-01-15 00:47:47.000000', 'consum', 0.0216, 'lps'),
	(373904, 126, '2015-01-15 00:47:48.000000', 'consum', 0.0220, 'lps'),
	(373905, 126, '2015-01-15 00:47:49.000000', 'consum', 0.0225, 'lps'),
	(373906, 126, '2015-01-15 00:47:50.000000', 'consum', 0.0217, 'lps'),
	(373907, 126, '2015-01-15 00:47:51.000000', 'consum', 0.0218, 'lps'),
	(373908, 126, '2015-01-15 00:47:52.000000', 'consum', 0.0228, 'lps'),
	(373909, 126, '2015-01-15 00:47:53.000000', 'consum', 0.0223, 'lps'),
	(373910, 126, '2015-01-15 00:47:54.000000', 'consum', 0.0220, 'lps'),
	(373911, 126, '2015-01-15 00:47:55.000000', 'consum', 0.0224, 'lps'),
	(373912, 126, '2015-01-15 00:47:56.000000', 'consum', 0.0228, 'lps'),
	(373913, 126, '2015-01-15 00:47:57.000000', 'consum', 0.0223, 'lps'),
	(373914, 126, '2015-01-15 00:47:58.000000', 'consum', 0.0220, 'lps'),
	(373915, 126, '2015-01-15 00:47:59.000000', 'consum', 0.0220, 'lps'),
	(373916, 126, '2015-01-15 00:48:00.000000', 'consum', 0.0214, 'lps'),
	(373917, 126, '2015-01-15 00:48:01.000000', 'consum', 0.0219, 'lps'),
	(373918, 126, '2015-01-15 00:48:02.000000', 'consum', 0.0224, 'lps'),
	(373919, 126, '2015-01-15 00:48:03.000000', 'consum', 0.0218, 'lps'),
	(373920, 126, '2015-01-15 00:48:04.000000', 'consum', 0.0224, 'lps'),
	(373921, 126, '2015-01-15 00:48:05.000000', 'consum', 0.0221, 'lps'),
	(373922, 126, '2015-01-15 00:48:06.000000', 'consum', 0.0221, 'lps'),
	(373923, 126, '2015-01-15 00:48:07.000000', 'consum', 0.0216, 'lps'),
	(373924, 126, '2015-01-15 00:48:08.000000', 'consum', 0.0226, 'lps'),
	(373925, 126, '2015-01-15 00:48:09.000000', 'consum', 0.0216, 'lps'),
	(373926, 126, '2015-01-15 00:48:10.000000', 'consum', 0.0228, 'lps'),
	(373927, 126, '2015-01-15 00:48:11.000000', 'consum', 0.0228, 'lps'),
	(373928, 126, '2015-01-15 00:48:12.000000', 'consum', 0.0226, 'lps'),
	(373929, 126, '2015-01-15 00:48:13.000000', 'consum', 0.0218, 'lps'),
	(373930, 126, '2015-01-15 00:48:14.000000', 'consum', 0.0222, 'lps'),
	(373931, 126, '2015-01-15 00:48:15.000000', 'consum', 0.0226, 'lps'),
	(373932, 126, '2015-01-15 00:48:16.000000', 'consum', 0.0217, 'lps'),
	(373933, 126, '2015-01-15 00:48:17.000000', 'consum', 0.0217, 'lps'),
	(373934, 126, '2015-01-15 00:48:18.000000', 'consum', 0.0223, 'lps'),
	(373935, 126, '2015-01-15 00:48:19.000000', 'consum', 0.0219, 'lps'),
	(373936, 126, '2015-01-15 00:48:20.000000', 'consum', 0.0215, 'lps'),
	(373937, 126, '2015-01-15 00:48:21.000000', 'consum', 0.0210, 'lps'),
	(373938, 126, '2015-01-15 00:48:22.000000', 'consum', 0.0215, 'lps'),
	(373939, 126, '2015-01-15 00:48:23.000000', 'consum', 0.0216, 'lps'),
	(373940, 126, '2015-01-15 00:48:24.000000', 'consum', 0.0226, 'lps'),
	(373941, 126, '2015-01-15 00:48:25.000000', 'consum', 0.0214, 'lps'),
	(373942, 126, '2015-01-15 00:48:26.000000', 'consum', 0.0221, 'lps'),
	(373943, 126, '2015-01-15 00:48:27.000000', 'consum', 0.0214, 'lps'),
	(373944, 126, '2015-01-15 00:48:28.000000', 'consum', 0.0218, 'lps'),
	(373945, 126, '2015-01-15 00:48:29.000000', 'consum', 0.0219, 'lps'),
	(373946, 126, '2015-01-15 00:48:30.000000', 'consum', 0.0213, 'lps'),
	(373947, 126, '2015-01-15 00:48:31.000000', 'consum', 0.0216, 'lps'),
	(373948, 126, '2015-01-15 00:48:32.000000', 'consum', 0.0214, 'lps'),
	(373949, 126, '2015-01-15 00:48:33.000000', 'consum', 0.0211, 'lps'),
	(373950, 126, '2015-01-15 00:48:34.000000', 'consum', 0.0223, 'lps'),
	(373951, 126, '2015-01-15 00:48:35.000000', 'consum', 0.0218, 'lps'),
	(373952, 126, '2015-01-15 00:48:36.000000', 'consum', 0.0228, 'lps'),
	(373953, 126, '2015-01-15 00:48:37.000000', 'consum', 0.0218, 'lps'),
	(373954, 126, '2015-01-15 00:48:38.000000', 'consum', 0.0217, 'lps'),
	(373955, 126, '2015-01-15 00:48:39.000000', 'consum', 0.0223, 'lps'),
	(373956, 126, '2015-01-15 00:48:40.000000', 'consum', 0.0215, 'lps'),
	(373957, 126, '2015-01-15 00:48:41.000000', 'consum', 0.0217, 'lps'),
	(373958, 126, '2015-01-15 00:48:42.000000', 'consum', 0.0210, 'lps'),
	(373959, 126, '2015-01-15 00:48:43.000000', 'consum', 0.0210, 'lps'),
	(373960, 126, '2015-01-15 00:48:44.000000', 'consum', 0.0210, 'lps'),
	(373961, 126, '2015-01-15 00:48:45.000000', 'consum', 0.0228, 'lps'),
	(373962, 126, '2015-01-15 00:48:46.000000', 'consum', 0.0227, 'lps'),
	(373963, 126, '2015-01-15 00:48:47.000000', 'consum', 0.0222, 'lps'),
	(373964, 126, '2015-01-15 00:48:48.000000', 'consum', 0.0218, 'lps'),
	(373965, 126, '2015-01-15 00:48:49.000000', 'consum', 0.0214, 'lps'),
	(373966, 126, '2015-01-15 00:48:50.000000', 'consum', 0.0226, 'lps'),
	(373967, 126, '2015-01-15 00:48:51.000000', 'consum', 0.0223, 'lps'),
	(373968, 126, '2015-01-15 00:48:52.000000', 'consum', 0.0228, 'lps'),
	(373969, 126, '2015-01-15 00:48:53.000000', 'consum', 0.0224, 'lps'),
	(373970, 126, '2015-01-15 00:48:54.000000', 'consum', 0.0224, 'lps'),
	(373971, 126, '2015-01-15 00:48:55.000000', 'consum', 0.0220, 'lps'),
	(373972, 126, '2015-01-15 00:48:56.000000', 'consum', 0.0219, 'lps'),
	(373973, 126, '2015-01-15 00:48:57.000000', 'consum', 0.0227, 'lps'),
	(373974, 126, '2015-01-15 00:48:58.000000', 'consum', 0.0212, 'lps'),
	(373975, 126, '2015-01-15 00:48:59.000000', 'consum', 0.0224, 'lps'),
	(373976, 126, '2015-01-15 00:49:00.000000', 'consum', 0.0218, 'lps'),
	(373977, 126, '2015-01-15 00:49:01.000000', 'consum', 0.0227, 'lps'),
	(373978, 126, '2015-01-15 00:49:02.000000', 'consum', 0.0213, 'lps'),
	(373979, 126, '2015-01-15 00:49:03.000000', 'consum', 0.0215, 'lps'),
	(373980, 126, '2015-01-15 00:49:04.000000', 'consum', 0.0225, 'lps'),
	(373981, 126, '2015-01-15 00:49:05.000000', 'consum', 0.0214, 'lps'),
	(373982, 126, '2015-01-15 00:49:06.000000', 'consum', 0.0225, 'lps'),
	(373983, 126, '2015-01-15 00:49:07.000000', 'consum', 0.0215, 'lps'),
	(373984, 126, '2015-01-15 00:49:08.000000', 'consum', 0.0227, 'lps'),
	(373985, 126, '2015-01-15 00:49:09.000000', 'consum', 0.0227, 'lps'),
	(373986, 126, '2015-01-15 00:49:10.000000', 'consum', 0.0222, 'lps'),
	(373987, 126, '2015-01-15 00:49:11.000000', 'consum', 0.0222, 'lps'),
	(373988, 126, '2015-01-15 00:49:12.000000', 'consum', 0.0213, 'lps'),
	(373989, 126, '2015-01-15 00:49:13.000000', 'consum', 0.0211, 'lps'),
	(373990, 126, '2015-01-15 00:49:14.000000', 'consum', 0.0223, 'lps'),
	(373991, 126, '2015-01-15 00:49:15.000000', 'consum', 0.0215, 'lps'),
	(373992, 126, '2015-01-15 00:49:16.000000', 'consum', 0.0216, 'lps'),
	(373993, 126, '2015-01-15 00:49:17.000000', 'consum', 0.0227, 'lps'),
	(373994, 126, '2015-01-15 00:49:18.000000', 'consum', 0.0219, 'lps'),
	(373995, 126, '2015-01-15 00:49:19.000000', 'consum', 0.0226, 'lps'),
	(373996, 126, '2015-01-15 00:49:20.000000', 'consum', 0.0222, 'lps'),
	(373997, 126, '2015-01-15 00:49:21.000000', 'consum', 0.0226, 'lps'),
	(373998, 126, '2015-01-15 00:49:22.000000', 'consum', 0.0214, 'lps'),
	(373999, 126, '2015-01-15 00:49:23.000000', 'consum', 0.0220, 'lps'),
	(374000, 126, '2015-01-15 00:49:24.000000', 'consum', 0.0211, 'lps'),
	(374001, 126, '2015-01-15 00:49:25.000000', 'consum', 0.0225, 'lps'),
	(374002, 126, '2015-01-15 00:49:26.000000', 'consum', 0.0224, 'lps'),
	(374003, 126, '2015-01-15 00:49:27.000000', 'consum', 0.0216, 'lps'),
	(374004, 126, '2015-01-15 00:49:28.000000', 'consum', 0.0217, 'lps'),
	(374005, 126, '2015-01-15 00:49:29.000000', 'consum', 0.0227, 'lps'),
	(374006, 126, '2015-01-15 00:49:30.000000', 'consum', 0.0216, 'lps'),
	(374007, 126, '2015-01-15 00:49:31.000000', 'consum', 0.0212, 'lps'),
	(374008, 126, '2015-01-15 00:49:32.000000', 'consum', 0.0221, 'lps'),
	(374009, 126, '2015-01-15 00:49:33.000000', 'consum', 0.0222, 'lps'),
	(374010, 126, '2015-01-15 00:49:34.000000', 'consum', 0.0220, 'lps'),
	(374011, 126, '2015-01-15 00:49:35.000000', 'consum', 0.0222, 'lps'),
	(374012, 126, '2015-01-15 00:49:36.000000', 'consum', 0.0224, 'lps'),
	(374013, 126, '2015-01-15 00:49:37.000000', 'consum', 0.0222, 'lps'),
	(374014, 126, '2015-01-15 00:49:38.000000', 'consum', 0.0213, 'lps'),
	(374015, 126, '2015-01-15 00:49:39.000000', 'consum', 0.0224, 'lps'),
	(374016, 126, '2015-01-15 00:49:40.000000', 'consum', 0.0218, 'lps'),
	(374017, 126, '2015-01-15 00:49:41.000000', 'consum', 0.0225, 'lps'),
	(374018, 126, '2015-01-15 00:49:42.000000', 'consum', 0.0226, 'lps'),
	(374019, 126, '2015-01-15 00:49:43.000000', 'consum', 0.0226, 'lps'),
	(374020, 126, '2015-01-15 00:49:44.000000', 'consum', 0.0224, 'lps'),
	(374021, 126, '2015-01-15 00:49:45.000000', 'consum', 0.0211, 'lps'),
	(374022, 126, '2015-01-15 00:49:46.000000', 'consum', 0.0213, 'lps'),
	(374023, 126, '2015-01-15 00:49:47.000000', 'consum', 0.0222, 'lps'),
	(374024, 126, '2015-01-15 00:49:48.000000', 'consum', 0.0223, 'lps'),
	(374025, 126, '2015-01-15 00:49:49.000000', 'consum', 0.0220, 'lps'),
	(374026, 126, '2015-01-15 00:49:50.000000', 'consum', 0.0223, 'lps'),
	(374027, 126, '2015-01-15 00:49:51.000000', 'consum', 0.0226, 'lps'),
	(374028, 126, '2015-01-15 00:49:52.000000', 'consum', 0.0216, 'lps'),
	(374029, 126, '2015-01-15 00:49:53.000000', 'consum', 0.0227, 'lps'),
	(374030, 126, '2015-01-15 00:49:54.000000', 'consum', 0.0220, 'lps'),
	(374031, 126, '2015-01-15 00:49:55.000000', 'consum', 0.0211, 'lps'),
	(374032, 126, '2015-01-15 00:49:56.000000', 'consum', 0.0225, 'lps'),
	(374033, 126, '2015-01-15 00:49:57.000000', 'consum', 0.0224, 'lps'),
	(374034, 126, '2015-01-15 00:49:58.000000', 'consum', 0.0217, 'lps'),
	(374035, 126, '2015-01-15 00:49:59.000000', 'consum', 0.0222, 'lps'),
	(374036, 126, '2015-01-15 00:50:00.000000', 'consum', 0.0213, 'lps'),
	(374037, 126, '2015-01-15 00:50:01.000000', 'consum', 0.0225, 'lps'),
	(374038, 126, '2015-01-15 00:50:02.000000', 'consum', 0.0222, 'lps'),
	(374039, 126, '2015-01-15 00:50:03.000000', 'consum', 0.0224, 'lps'),
	(374040, 126, '2015-01-15 00:50:04.000000', 'consum', 0.0228, 'lps'),
	(374041, 126, '2015-01-15 00:50:05.000000', 'consum', 0.0218, 'lps'),
	(374042, 126, '2015-01-15 00:50:06.000000', 'consum', 0.0217, 'lps'),
	(374043, 126, '2015-01-15 00:50:07.000000', 'consum', 0.0220, 'lps'),
	(374044, 126, '2015-01-15 00:50:08.000000', 'consum', 0.0220, 'lps'),
	(374045, 126, '2015-01-15 00:50:09.000000', 'consum', 0.0212, 'lps'),
	(374046, 126, '2015-01-15 00:50:10.000000', 'consum', 0.0228, 'lps'),
	(374047, 126, '2015-01-15 00:50:11.000000', 'consum', 0.0219, 'lps'),
	(374048, 126, '2015-01-15 00:50:12.000000', 'consum', 0.0222, 'lps'),
	(374049, 126, '2015-01-15 00:50:13.000000', 'consum', 0.0226, 'lps'),
	(374050, 126, '2015-01-15 00:50:14.000000', 'consum', 0.0213, 'lps'),
	(374051, 126, '2015-01-15 00:50:15.000000', 'consum', 0.0217, 'lps'),
	(374052, 126, '2015-01-15 00:50:16.000000', 'consum', 0.0216, 'lps'),
	(374053, 126, '2015-01-15 00:50:17.000000', 'consum', 0.0219, 'lps'),
	(374054, 126, '2015-01-15 00:50:18.000000', 'consum', 0.0218, 'lps'),
	(374055, 126, '2015-01-15 00:50:19.000000', 'consum', 0.0223, 'lps'),
	(374056, 126, '2015-01-15 00:50:20.000000', 'consum', 0.0214, 'lps'),
	(374057, 126, '2015-01-15 00:50:21.000000', 'consum', 0.0210, 'lps'),
	(374058, 126, '2015-01-15 00:50:22.000000', 'consum', 0.0220, 'lps'),
	(374059, 126, '2015-01-15 00:50:23.000000', 'consum', 0.0222, 'lps'),
	(374060, 126, '2015-01-15 00:50:24.000000', 'consum', 0.0221, 'lps'),
	(374061, 126, '2015-01-15 00:50:25.000000', 'consum', 0.0211, 'lps'),
	(374062, 126, '2015-01-15 00:50:26.000000', 'consum', 0.0220, 'lps'),
	(374063, 126, '2015-01-15 00:50:27.000000', 'consum', 0.0218, 'lps'),
	(374064, 126, '2015-01-15 00:50:28.000000', 'consum', 0.0220, 'lps'),
	(374065, 126, '2015-01-15 00:50:29.000000', 'consum', 0.0217, 'lps'),
	(374066, 126, '2015-01-15 00:50:30.000000', 'consum', 0.0218, 'lps'),
	(374067, 126, '2015-01-15 00:50:31.000000', 'consum', 0.0228, 'lps'),
	(374068, 126, '2015-01-15 00:50:32.000000', 'consum', 0.0221, 'lps'),
	(374069, 126, '2015-01-15 00:50:33.000000', 'consum', 0.0228, 'lps'),
	(374070, 126, '2015-01-15 00:50:34.000000', 'consum', 0.0214, 'lps'),
	(374071, 126, '2015-01-15 00:50:35.000000', 'consum', 0.0211, 'lps'),
	(374072, 126, '2015-01-15 00:50:36.000000', 'consum', 0.0225, 'lps'),
	(374073, 126, '2015-01-15 00:50:37.000000', 'consum', 0.0225, 'lps'),
	(374074, 126, '2015-01-15 00:50:38.000000', 'consum', 0.0223, 'lps'),
	(374075, 126, '2015-01-15 00:50:39.000000', 'consum', 0.0210, 'lps'),
	(374076, 126, '2015-01-15 00:50:40.000000', 'consum', 0.0227, 'lps'),
	(374077, 126, '2015-01-15 00:50:41.000000', 'consum', 0.0220, 'lps'),
	(374078, 126, '2015-01-15 00:50:42.000000', 'consum', 0.0228, 'lps'),
	(374079, 126, '2015-01-15 00:50:43.000000', 'consum', 0.0213, 'lps'),
	(374080, 126, '2015-01-15 00:50:44.000000', 'consum', 0.0212, 'lps'),
	(374081, 126, '2015-01-15 00:50:45.000000', 'consum', 0.0212, 'lps'),
	(374082, 126, '2015-01-15 00:50:46.000000', 'consum', 0.0213, 'lps'),
	(374083, 126, '2015-01-15 00:50:47.000000', 'consum', 0.0218, 'lps'),
	(374084, 126, '2015-01-15 00:50:48.000000', 'consum', 0.0224, 'lps'),
	(374085, 126, '2015-01-15 00:50:49.000000', 'consum', 0.0219, 'lps'),
	(374086, 126, '2015-01-15 00:50:50.000000', 'consum', 0.0211, 'lps'),
	(374087, 126, '2015-01-15 00:50:51.000000', 'consum', 0.0228, 'lps'),
	(374088, 126, '2015-01-15 00:50:52.000000', 'consum', 0.0223, 'lps'),
	(374089, 126, '2015-01-15 00:50:53.000000', 'consum', 0.0219, 'lps'),
	(374090, 126, '2015-01-15 00:50:54.000000', 'consum', 0.0218, 'lps'),
	(374091, 126, '2015-01-15 00:50:55.000000', 'consum', 0.0222, 'lps'),
	(374092, 126, '2015-01-15 00:50:56.000000', 'consum', 0.0211, 'lps'),
	(374093, 126, '2015-01-15 00:50:57.000000', 'consum', 0.0214, 'lps'),
	(374094, 126, '2015-01-15 00:50:58.000000', 'consum', 0.0212, 'lps'),
	(374095, 126, '2015-01-15 00:50:59.000000', 'consum', 0.0224, 'lps'),
	(374096, 126, '2015-01-15 00:51:00.000000', 'consum', 0.0220, 'lps'),
	(374097, 126, '2015-01-15 00:51:01.000000', 'consum', 0.0218, 'lps'),
	(374098, 126, '2015-01-15 00:51:02.000000', 'consum', 0.0219, 'lps'),
	(374099, 126, '2015-01-15 00:51:03.000000', 'consum', 0.0214, 'lps'),
	(374100, 126, '2015-01-15 00:51:04.000000', 'consum', 0.0223, 'lps'),
	(374101, 126, '2015-01-15 00:51:05.000000', 'consum', 0.0225, 'lps'),
	(374102, 126, '2015-01-15 00:51:06.000000', 'consum', 0.0225, 'lps'),
	(374103, 126, '2015-01-15 00:51:07.000000', 'consum', 0.0225, 'lps'),
	(374104, 126, '2015-01-15 00:51:08.000000', 'consum', 0.0218, 'lps'),
	(374105, 126, '2015-01-15 00:51:09.000000', 'consum', 0.0226, 'lps'),
	(374106, 126, '2015-01-15 00:51:10.000000', 'consum', 0.0212, 'lps'),
	(374107, 126, '2015-01-15 00:51:11.000000', 'consum', 0.0226, 'lps'),
	(374108, 126, '2015-01-15 00:51:12.000000', 'consum', 0.0210, 'lps'),
	(374109, 126, '2015-01-15 00:51:13.000000', 'consum', 0.0218, 'lps'),
	(374110, 126, '2015-01-15 00:51:14.000000', 'consum', 0.0213, 'lps'),
	(374111, 126, '2015-01-15 00:51:15.000000', 'consum', 0.0220, 'lps'),
	(374112, 126, '2015-01-15 00:51:16.000000', 'consum', 0.0212, 'lps'),
	(374113, 126, '2015-01-15 00:51:17.000000', 'consum', 0.0211, 'lps'),
	(374114, 126, '2015-01-15 00:51:18.000000', 'consum', 0.0211, 'lps'),
	(374115, 126, '2015-01-15 00:51:19.000000', 'consum', 0.0210, 'lps'),
	(374116, 126, '2015-01-15 00:51:20.000000', 'consum', 0.0210, 'lps'),
	(374117, 126, '2015-01-15 00:51:21.000000', 'consum', 0.0211, 'lps'),
	(374118, 126, '2015-01-15 00:51:22.000000', 'consum', 0.0216, 'lps'),
	(374119, 126, '2015-01-15 00:51:23.000000', 'consum', 0.0217, 'lps'),
	(374120, 126, '2015-01-15 00:51:24.000000', 'consum', 0.0228, 'lps'),
	(374121, 126, '2015-01-15 00:51:25.000000', 'consum', 0.0222, 'lps'),
	(374122, 126, '2015-01-15 00:51:26.000000', 'consum', 0.0218, 'lps'),
	(374123, 126, '2015-01-15 00:51:27.000000', 'consum', 0.0215, 'lps'),
	(374124, 126, '2015-01-15 00:51:28.000000', 'consum', 0.0212, 'lps'),
	(374125, 126, '2015-01-15 00:51:29.000000', 'consum', 0.0225, 'lps'),
	(374126, 126, '2015-01-15 00:51:30.000000', 'consum', 0.0219, 'lps'),
	(374127, 126, '2015-01-15 00:51:31.000000', 'consum', 0.0214, 'lps'),
	(374128, 126, '2015-01-15 00:51:32.000000', 'consum', 0.0221, 'lps'),
	(374129, 126, '2015-01-15 00:51:33.000000', 'consum', 0.0215, 'lps'),
	(374130, 126, '2015-01-15 00:51:34.000000', 'consum', 0.0220, 'lps'),
	(374131, 126, '2015-01-15 00:51:35.000000', 'consum', 0.0210, 'lps'),
	(374132, 126, '2015-01-15 00:51:36.000000', 'consum', 0.0216, 'lps'),
	(374133, 126, '2015-01-15 00:51:37.000000', 'consum', 0.0222, 'lps'),
	(374134, 126, '2015-01-15 00:51:38.000000', 'consum', 0.0216, 'lps'),
	(374135, 126, '2015-01-15 00:51:39.000000', 'consum', 0.0225, 'lps'),
	(374136, 126, '2015-01-15 00:51:40.000000', 'consum', 0.0226, 'lps'),
	(374137, 126, '2015-01-15 00:51:41.000000', 'consum', 0.0228, 'lps'),
	(374138, 126, '2015-01-15 00:51:42.000000', 'consum', 0.0213, 'lps'),
	(374139, 126, '2015-01-15 00:51:43.000000', 'consum', 0.0211, 'lps'),
	(374140, 126, '2015-01-15 00:51:44.000000', 'consum', 0.0225, 'lps'),
	(374141, 126, '2015-01-15 00:51:45.000000', 'consum', 0.0228, 'lps'),
	(374142, 126, '2015-01-15 00:51:46.000000', 'consum', 0.0215, 'lps'),
	(374143, 126, '2015-01-15 00:51:47.000000', 'consum', 0.0219, 'lps'),
	(374144, 126, '2015-01-15 00:51:48.000000', 'consum', 0.0220, 'lps'),
	(374145, 126, '2015-01-15 00:51:49.000000', 'consum', 0.0218, 'lps'),
	(374146, 126, '2015-01-15 00:51:50.000000', 'consum', 0.0219, 'lps'),
	(374147, 126, '2015-01-15 00:51:51.000000', 'consum', 0.0214, 'lps'),
	(374148, 126, '2015-01-15 00:51:52.000000', 'consum', 0.0222, 'lps'),
	(374149, 126, '2015-01-15 00:51:53.000000', 'consum', 0.0222, 'lps'),
	(374150, 126, '2015-01-15 00:51:54.000000', 'consum', 0.0213, 'lps'),
	(374151, 126, '2015-01-15 00:51:55.000000', 'consum', 0.0227, 'lps'),
	(374152, 126, '2015-01-15 00:51:56.000000', 'consum', 0.0212, 'lps'),
	(374153, 126, '2015-01-15 00:51:57.000000', 'consum', 0.0227, 'lps'),
	(374154, 126, '2015-01-15 00:51:58.000000', 'consum', 0.0212, 'lps'),
	(374155, 126, '2015-01-15 00:51:59.000000', 'consum', 0.0226, 'lps'),
	(374156, 126, '2015-01-15 00:52:00.000000', 'consum', 0.0227, 'lps'),
	(374157, 126, '2015-01-15 00:52:01.000000', 'consum', 0.0211, 'lps'),
	(374158, 126, '2015-01-15 00:52:02.000000', 'consum', 0.0220, 'lps'),
	(374159, 126, '2015-01-15 00:52:03.000000', 'consum', 0.0219, 'lps'),
	(374160, 126, '2015-01-15 00:52:04.000000', 'consum', 0.0228, 'lps'),
	(374161, 126, '2015-01-15 00:52:05.000000', 'consum', 0.0217, 'lps'),
	(374162, 126, '2015-01-15 00:52:06.000000', 'consum', 0.0226, 'lps'),
	(374163, 126, '2015-01-15 00:52:07.000000', 'consum', 0.0215, 'lps'),
	(374164, 126, '2015-01-15 00:52:08.000000', 'consum', 0.0225, 'lps'),
	(374165, 126, '2015-01-15 00:52:09.000000', 'consum', 0.0215, 'lps'),
	(374166, 126, '2015-01-15 00:52:10.000000', 'consum', 0.0227, 'lps'),
	(374167, 126, '2015-01-15 00:52:11.000000', 'consum', 0.0222, 'lps'),
	(374168, 126, '2015-01-15 00:52:12.000000', 'consum', 0.0220, 'lps'),
	(374169, 126, '2015-01-15 00:52:13.000000', 'consum', 0.0223, 'lps'),
	(374170, 126, '2015-01-15 00:52:14.000000', 'consum', 0.0211, 'lps'),
	(374171, 126, '2015-01-15 00:52:15.000000', 'consum', 0.0211, 'lps'),
	(374172, 126, '2015-01-15 00:52:16.000000', 'consum', 0.0214, 'lps'),
	(374173, 126, '2015-01-15 00:52:17.000000', 'consum', 0.0226, 'lps'),
	(374174, 126, '2015-01-15 00:52:18.000000', 'consum', 0.0222, 'lps'),
	(374175, 126, '2015-01-15 00:52:19.000000', 'consum', 0.0225, 'lps'),
	(374176, 126, '2015-01-15 00:52:20.000000', 'consum', 0.0210, 'lps'),
	(374177, 126, '2015-01-15 00:52:21.000000', 'consum', 0.0221, 'lps'),
	(374178, 126, '2015-01-15 00:52:22.000000', 'consum', 0.0227, 'lps'),
	(374179, 126, '2015-01-15 00:52:23.000000', 'consum', 0.0226, 'lps'),
	(374180, 126, '2015-01-15 00:52:24.000000', 'consum', 0.0219, 'lps'),
	(374181, 126, '2015-01-15 00:52:25.000000', 'consum', 0.0227, 'lps'),
	(374182, 126, '2015-01-15 00:52:26.000000', 'consum', 0.0212, 'lps'),
	(374183, 126, '2015-01-15 00:52:27.000000', 'consum', 0.0228, 'lps'),
	(374184, 126, '2015-01-15 00:52:28.000000', 'consum', 0.0219, 'lps'),
	(374185, 126, '2015-01-15 00:52:29.000000', 'consum', 0.0220, 'lps'),
	(374186, 126, '2015-01-15 00:52:30.000000', 'consum', 0.0216, 'lps'),
	(374187, 126, '2015-01-15 00:52:31.000000', 'consum', 0.0227, 'lps'),
	(374188, 126, '2015-01-15 00:52:32.000000', 'consum', 0.0221, 'lps'),
	(374189, 126, '2015-01-15 00:52:33.000000', 'consum', 0.0214, 'lps'),
	(374190, 126, '2015-01-15 00:52:34.000000', 'consum', 0.0216, 'lps'),
	(374191, 126, '2015-01-15 00:52:35.000000', 'consum', 0.0212, 'lps'),
	(374192, 126, '2015-01-15 00:52:36.000000', 'consum', 0.0220, 'lps'),
	(374193, 126, '2015-01-15 00:52:37.000000', 'consum', 0.0215, 'lps'),
	(374194, 126, '2015-01-15 00:52:38.000000', 'consum', 0.0224, 'lps'),
	(374195, 126, '2015-01-15 00:52:39.000000', 'consum', 0.0227, 'lps'),
	(374196, 126, '2015-01-15 00:52:40.000000', 'consum', 0.0216, 'lps'),
	(374197, 126, '2015-01-15 00:52:41.000000', 'consum', 0.0228, 'lps'),
	(374198, 126, '2015-01-15 00:52:42.000000', 'consum', 0.0224, 'lps'),
	(374199, 126, '2015-01-15 00:52:43.000000', 'consum', 0.0227, 'lps'),
	(374200, 126, '2015-01-15 00:52:44.000000', 'consum', 0.0215, 'lps'),
	(374201, 126, '2015-01-15 00:52:45.000000', 'consum', 0.0221, 'lps'),
	(374202, 126, '2015-01-15 00:52:46.000000', 'consum', 0.0214, 'lps'),
	(374203, 126, '2015-01-15 00:52:47.000000', 'consum', 0.0218, 'lps'),
	(374204, 126, '2015-01-15 00:52:48.000000', 'consum', 0.0217, 'lps'),
	(374205, 126, '2015-01-15 00:52:49.000000', 'consum', 0.0221, 'lps'),
	(374206, 126, '2015-01-15 00:52:50.000000', 'consum', 0.0228, 'lps'),
	(374207, 126, '2015-01-15 00:52:51.000000', 'consum', 0.0227, 'lps'),
	(374208, 126, '2015-01-15 00:52:52.000000', 'consum', 0.0224, 'lps'),
	(374209, 126, '2015-01-15 00:52:53.000000', 'consum', 0.0227, 'lps'),
	(374210, 126, '2015-01-15 00:52:54.000000', 'consum', 0.0218, 'lps'),
	(374211, 126, '2015-01-15 00:52:55.000000', 'consum', 0.0217, 'lps'),
	(374212, 126, '2015-01-15 00:52:56.000000', 'consum', 0.0222, 'lps'),
	(374213, 126, '2015-01-15 00:52:57.000000', 'consum', 0.0213, 'lps'),
	(374214, 126, '2015-01-15 00:52:58.000000', 'consum', 0.0227, 'lps'),
	(374215, 126, '2015-01-15 00:52:59.000000', 'consum', 0.0211, 'lps'),
	(374216, 126, '2015-01-15 00:53:00.000000', 'consum', 0.0221, 'lps'),
	(374217, 126, '2015-01-15 00:53:01.000000', 'consum', 0.0226, 'lps'),
	(374218, 126, '2015-01-15 00:53:02.000000', 'consum', 0.0218, 'lps'),
	(374219, 126, '2015-01-15 00:53:03.000000', 'consum', 0.0223, 'lps'),
	(374220, 126, '2015-01-15 00:53:04.000000', 'consum', 0.0214, 'lps'),
	(374221, 126, '2015-01-15 00:53:05.000000', 'consum', 0.0228, 'lps'),
	(374222, 126, '2015-01-15 00:53:06.000000', 'consum', 0.0214, 'lps'),
	(374223, 126, '2015-01-15 00:53:07.000000', 'consum', 0.0213, 'lps'),
	(374224, 126, '2015-01-15 00:53:08.000000', 'consum', 0.0213, 'lps'),
	(374225, 126, '2015-01-15 00:53:09.000000', 'consum', 0.0219, 'lps'),
	(374226, 126, '2015-01-15 00:53:10.000000', 'consum', 0.0226, 'lps'),
	(374227, 126, '2015-01-15 00:53:11.000000', 'consum', 0.0226, 'lps'),
	(374228, 126, '2015-01-15 00:53:12.000000', 'consum', 0.0225, 'lps'),
	(374229, 126, '2015-01-15 00:53:13.000000', 'consum', 0.0216, 'lps'),
	(374230, 126, '2015-01-15 00:53:14.000000', 'consum', 0.0216, 'lps'),
	(374231, 126, '2015-01-15 00:53:15.000000', 'consum', 0.0221, 'lps'),
	(374232, 126, '2015-01-15 00:53:16.000000', 'consum', 0.0211, 'lps'),
	(374233, 126, '2015-01-15 00:53:17.000000', 'consum', 0.0221, 'lps'),
	(374234, 126, '2015-01-15 00:53:18.000000', 'consum', 0.0224, 'lps'),
	(374235, 126, '2015-01-15 00:53:19.000000', 'consum', 0.0211, 'lps'),
	(374236, 126, '2015-01-15 00:53:20.000000', 'consum', 0.0212, 'lps'),
	(374237, 126, '2015-01-15 00:53:21.000000', 'consum', 0.0216, 'lps'),
	(374238, 126, '2015-01-15 00:53:22.000000', 'consum', 0.0217, 'lps'),
	(374239, 126, '2015-01-15 00:53:23.000000', 'consum', 0.0210, 'lps'),
	(374240, 126, '2015-01-15 00:53:24.000000', 'consum', 0.0225, 'lps'),
	(374241, 126, '2015-01-15 00:53:25.000000', 'consum', 0.0227, 'lps'),
	(374242, 126, '2015-01-15 00:53:26.000000', 'consum', 0.0214, 'lps'),
	(374243, 126, '2015-01-15 00:53:27.000000', 'consum', 0.0217, 'lps'),
	(374244, 126, '2015-01-15 00:53:28.000000', 'consum', 0.0213, 'lps'),
	(374245, 126, '2015-01-15 00:53:29.000000', 'consum', 0.0226, 'lps'),
	(374246, 126, '2015-01-15 00:53:30.000000', 'consum', 0.0222, 'lps'),
	(374247, 126, '2015-01-15 00:53:31.000000', 'consum', 0.0223, 'lps'),
	(374248, 126, '2015-01-15 00:53:32.000000', 'consum', 0.0222, 'lps'),
	(374249, 126, '2015-01-15 00:53:33.000000', 'consum', 0.0210, 'lps'),
	(374250, 126, '2015-01-15 00:53:34.000000', 'consum', 0.0216, 'lps'),
	(374251, 126, '2015-01-15 00:53:35.000000', 'consum', 0.0218, 'lps'),
	(374252, 126, '2015-01-15 00:53:36.000000', 'consum', 0.0215, 'lps'),
	(374253, 126, '2015-01-15 00:53:37.000000', 'consum', 0.0211, 'lps'),
	(374254, 126, '2015-01-15 00:53:38.000000', 'consum', 0.0222, 'lps'),
	(374255, 126, '2015-01-15 00:53:39.000000', 'consum', 0.0226, 'lps'),
	(374256, 126, '2015-01-15 00:53:40.000000', 'consum', 0.0220, 'lps'),
	(374257, 126, '2015-01-15 00:53:41.000000', 'consum', 0.0211, 'lps'),
	(374258, 126, '2015-01-15 00:53:42.000000', 'consum', 0.0223, 'lps'),
	(374259, 126, '2015-01-15 00:53:43.000000', 'consum', 0.0216, 'lps'),
	(374260, 126, '2015-01-15 00:53:44.000000', 'consum', 0.0219, 'lps'),
	(374261, 126, '2015-01-15 00:53:45.000000', 'consum', 0.0218, 'lps'),
	(374262, 126, '2015-01-15 00:53:46.000000', 'consum', 0.0225, 'lps'),
	(374263, 126, '2015-01-15 00:53:47.000000', 'consum', 0.0224, 'lps'),
	(374264, 126, '2015-01-15 00:53:48.000000', 'consum', 0.0215, 'lps'),
	(374265, 126, '2015-01-15 00:53:49.000000', 'consum', 0.0214, 'lps'),
	(374266, 126, '2015-01-15 00:53:50.000000', 'consum', 0.0215, 'lps'),
	(374267, 126, '2015-01-15 00:53:51.000000', 'consum', 0.0224, 'lps'),
	(374268, 126, '2015-01-15 00:53:52.000000', 'consum', 0.0228, 'lps'),
	(374269, 126, '2015-01-15 00:53:53.000000', 'consum', 0.0220, 'lps'),
	(374270, 126, '2015-01-15 00:53:54.000000', 'consum', 0.0224, 'lps'),
	(374271, 126, '2015-01-15 00:53:55.000000', 'consum', 0.0212, 'lps'),
	(374272, 126, '2015-01-15 00:53:56.000000', 'consum', 0.0218, 'lps'),
	(374273, 126, '2015-01-15 00:53:57.000000', 'consum', 0.0225, 'lps'),
	(374274, 126, '2015-01-15 00:53:58.000000', 'consum', 0.0225, 'lps'),
	(374275, 126, '2015-01-15 00:53:59.000000', 'consum', 0.0219, 'lps'),
	(374276, 126, '2015-01-15 00:54:00.000000', 'consum', 0.0214, 'lps'),
	(374277, 126, '2015-01-15 00:54:01.000000', 'consum', 0.0219, 'lps'),
	(374278, 126, '2015-01-15 00:54:02.000000', 'consum', 0.0225, 'lps'),
	(374279, 126, '2015-01-15 00:54:03.000000', 'consum', 0.0220, 'lps'),
	(374280, 126, '2015-01-15 00:54:04.000000', 'consum', 0.0215, 'lps'),
	(374281, 126, '2015-01-15 00:54:05.000000', 'consum', 0.0227, 'lps'),
	(374282, 126, '2015-01-15 00:54:06.000000', 'consum', 0.0220, 'lps'),
	(374283, 126, '2015-01-15 00:54:07.000000', 'consum', 0.0213, 'lps'),
	(374284, 126, '2015-01-15 00:54:08.000000', 'consum', 0.0212, 'lps'),
	(374285, 126, '2015-01-15 00:54:09.000000', 'consum', 0.0212, 'lps'),
	(374286, 126, '2015-01-15 00:54:10.000000', 'consum', 0.0215, 'lps'),
	(374287, 126, '2015-01-15 00:54:11.000000', 'consum', 0.0211, 'lps'),
	(374288, 126, '2015-01-15 00:54:12.000000', 'consum', 0.0217, 'lps'),
	(374289, 126, '2015-01-15 00:54:13.000000', 'consum', 0.0227, 'lps'),
	(374290, 126, '2015-01-15 00:54:14.000000', 'consum', 0.0215, 'lps'),
	(374291, 126, '2015-01-15 00:54:15.000000', 'consum', 0.0224, 'lps'),
	(374292, 126, '2015-01-15 00:54:16.000000', 'consum', 0.0225, 'lps'),
	(374293, 126, '2015-01-15 00:54:17.000000', 'consum', 0.0226, 'lps'),
	(374294, 126, '2015-01-15 00:54:18.000000', 'consum', 0.0227, 'lps'),
	(374295, 126, '2015-01-15 00:54:19.000000', 'consum', 0.0210, 'lps'),
	(374296, 126, '2015-01-15 00:54:20.000000', 'consum', 0.0216, 'lps'),
	(374297, 126, '2015-01-15 00:54:21.000000', 'consum', 0.0221, 'lps'),
	(374298, 126, '2015-01-15 00:54:22.000000', 'consum', 0.0228, 'lps'),
	(374299, 126, '2015-01-15 00:54:23.000000', 'consum', 0.0212, 'lps'),
	(374300, 126, '2015-01-15 00:54:24.000000', 'consum', 0.0223, 'lps'),
	(374301, 126, '2015-01-15 00:54:25.000000', 'consum', 0.0211, 'lps'),
	(374302, 126, '2015-01-15 00:54:26.000000', 'consum', 0.0214, 'lps'),
	(374303, 126, '2015-01-15 00:54:27.000000', 'consum', 0.0227, 'lps'),
	(374304, 126, '2015-01-15 00:54:28.000000', 'consum', 0.0210, 'lps'),
	(374305, 126, '2015-01-15 00:54:29.000000', 'consum', 0.0217, 'lps'),
	(374306, 126, '2015-01-15 00:54:30.000000', 'consum', 0.0223, 'lps'),
	(374307, 126, '2015-01-15 00:54:31.000000', 'consum', 0.0220, 'lps'),
	(374308, 126, '2015-01-15 00:54:32.000000', 'consum', 0.0220, 'lps'),
	(374309, 126, '2015-01-15 00:54:33.000000', 'consum', 0.0212, 'lps'),
	(374310, 126, '2015-01-15 00:54:34.000000', 'consum', 0.0210, 'lps'),
	(374311, 126, '2015-01-15 00:54:35.000000', 'consum', 0.0222, 'lps'),
	(374312, 126, '2015-01-15 00:54:36.000000', 'consum', 0.0216, 'lps'),
	(374313, 126, '2015-01-15 00:54:37.000000', 'consum', 0.0223, 'lps'),
	(374314, 126, '2015-01-15 00:54:38.000000', 'consum', 0.0221, 'lps'),
	(374315, 126, '2015-01-15 00:54:39.000000', 'consum', 0.0225, 'lps'),
	(374316, 126, '2015-01-15 00:54:40.000000', 'consum', 0.0215, 'lps'),
	(374317, 126, '2015-01-15 00:54:41.000000', 'consum', 0.0210, 'lps'),
	(374318, 126, '2015-01-15 00:54:42.000000', 'consum', 0.0213, 'lps'),
	(374319, 126, '2015-01-15 00:54:43.000000', 'consum', 0.0225, 'lps'),
	(374320, 126, '2015-01-15 00:54:44.000000', 'consum', 0.0221, 'lps'),
	(374321, 126, '2015-01-15 00:54:45.000000', 'consum', 0.0220, 'lps'),
	(374322, 126, '2015-01-15 00:54:46.000000', 'consum', 0.0226, 'lps'),
	(374323, 126, '2015-01-15 00:54:47.000000', 'consum', 0.0223, 'lps'),
	(374324, 126, '2015-01-15 00:54:48.000000', 'consum', 0.0210, 'lps'),
	(374325, 126, '2015-01-15 00:54:49.000000', 'consum', 0.0226, 'lps'),
	(374326, 126, '2015-01-15 00:54:50.000000', 'consum', 0.0215, 'lps'),
	(374327, 126, '2015-01-15 00:54:51.000000', 'consum', 0.0225, 'lps'),
	(374328, 126, '2015-01-15 00:54:52.000000', 'consum', 0.0213, 'lps'),
	(374329, 126, '2015-01-15 00:54:53.000000', 'consum', 0.0221, 'lps'),
	(374330, 126, '2015-01-15 00:54:54.000000', 'consum', 0.0217, 'lps'),
	(374331, 126, '2015-01-15 00:54:55.000000', 'consum', 0.0214, 'lps'),
	(374332, 126, '2015-01-15 00:54:56.000000', 'consum', 0.0227, 'lps'),
	(374333, 126, '2015-01-15 00:54:57.000000', 'consum', 0.0210, 'lps'),
	(374334, 126, '2015-01-15 00:54:58.000000', 'consum', 0.0215, 'lps'),
	(374335, 126, '2015-01-15 00:54:59.000000', 'consum', 0.0218, 'lps'),
	(374336, 126, '2015-01-15 00:55:00.000000', 'consum', 0.0214, 'lps'),
	(374337, 126, '2015-01-15 00:55:01.000000', 'consum', 0.0227, 'lps'),
	(374338, 126, '2015-01-15 00:55:02.000000', 'consum', 0.0226, 'lps'),
	(374339, 126, '2015-01-15 00:55:03.000000', 'consum', 0.0220, 'lps'),
	(374340, 126, '2015-01-15 00:55:04.000000', 'consum', 0.0211, 'lps'),
	(374341, 126, '2015-01-15 00:55:05.000000', 'consum', 0.0226, 'lps'),
	(374342, 126, '2015-01-15 00:55:06.000000', 'consum', 0.0211, 'lps'),
	(374343, 126, '2015-01-15 00:55:07.000000', 'consum', 0.0226, 'lps'),
	(374344, 126, '2015-01-15 00:55:08.000000', 'consum', 0.0211, 'lps'),
	(374345, 126, '2015-01-15 00:55:09.000000', 'consum', 0.0224, 'lps'),
	(374346, 126, '2015-01-15 00:55:10.000000', 'consum', 0.0222, 'lps'),
	(374347, 126, '2015-01-15 00:55:11.000000', 'consum', 0.0226, 'lps'),
	(374348, 126, '2015-01-15 00:55:12.000000', 'consum', 0.0219, 'lps'),
	(374349, 126, '2015-01-15 00:55:13.000000', 'consum', 0.0225, 'lps'),
	(374350, 126, '2015-01-15 00:55:14.000000', 'consum', 0.0222, 'lps'),
	(374351, 126, '2015-01-15 00:55:15.000000', 'consum', 0.0227, 'lps'),
	(374352, 126, '2015-01-15 00:55:16.000000', 'consum', 0.0218, 'lps'),
	(374353, 126, '2015-01-15 00:55:17.000000', 'consum', 0.0221, 'lps'),
	(374354, 126, '2015-01-15 00:55:18.000000', 'consum', 0.0220, 'lps'),
	(374355, 126, '2015-01-15 00:55:19.000000', 'consum', 0.0227, 'lps'),
	(374356, 126, '2015-01-15 00:55:20.000000', 'consum', 0.0227, 'lps'),
	(374357, 126, '2015-01-15 00:55:21.000000', 'consum', 0.0228, 'lps'),
	(374358, 126, '2015-01-15 00:55:22.000000', 'consum', 0.0211, 'lps'),
	(374359, 126, '2015-01-15 00:55:23.000000', 'consum', 0.0219, 'lps'),
	(374360, 126, '2015-01-15 00:55:24.000000', 'consum', 0.0216, 'lps'),
	(374361, 126, '2015-01-15 00:55:25.000000', 'consum', 0.0211, 'lps'),
	(374362, 126, '2015-01-15 00:55:26.000000', 'consum', 0.0216, 'lps'),
	(374363, 126, '2015-01-15 00:55:27.000000', 'consum', 0.0220, 'lps'),
	(374364, 126, '2015-01-15 00:55:28.000000', 'consum', 0.0222, 'lps'),
	(374365, 126, '2015-01-15 00:55:29.000000', 'consum', 0.0221, 'lps'),
	(374366, 126, '2015-01-15 00:55:30.000000', 'consum', 0.0210, 'lps'),
	(374367, 126, '2015-01-15 00:55:31.000000', 'consum', 0.0217, 'lps'),
	(374368, 126, '2015-01-15 00:55:32.000000', 'consum', 0.0227, 'lps'),
	(374369, 126, '2015-01-15 00:55:33.000000', 'consum', 0.0218, 'lps'),
	(374370, 126, '2015-01-15 00:55:34.000000', 'consum', 0.0219, 'lps'),
	(374371, 126, '2015-01-15 00:55:35.000000', 'consum', 0.0212, 'lps'),
	(374372, 126, '2015-01-15 00:55:36.000000', 'consum', 0.0213, 'lps'),
	(374373, 126, '2015-01-15 00:55:37.000000', 'consum', 0.0218, 'lps'),
	(374374, 126, '2015-01-15 00:55:38.000000', 'consum', 0.0222, 'lps'),
	(374375, 126, '2015-01-15 00:55:39.000000', 'consum', 0.0228, 'lps'),
	(374376, 126, '2015-01-15 00:55:40.000000', 'consum', 0.0228, 'lps'),
	(374377, 126, '2015-01-15 00:55:41.000000', 'consum', 0.0228, 'lps'),
	(374378, 126, '2015-01-15 00:55:42.000000', 'consum', 0.0210, 'lps'),
	(374379, 126, '2015-01-15 00:55:43.000000', 'consum', 0.0210, 'lps'),
	(374380, 126, '2015-01-15 00:55:44.000000', 'consum', 0.0213, 'lps'),
	(374381, 126, '2015-01-15 00:55:45.000000', 'consum', 0.0225, 'lps'),
	(374382, 126, '2015-01-15 00:55:46.000000', 'consum', 0.0220, 'lps'),
	(374383, 126, '2015-01-15 00:55:47.000000', 'consum', 0.0213, 'lps'),
	(374384, 126, '2015-01-15 00:55:48.000000', 'consum', 0.0216, 'lps'),
	(374385, 126, '2015-01-15 00:55:49.000000', 'consum', 0.0213, 'lps'),
	(374386, 126, '2015-01-15 00:55:50.000000', 'consum', 0.0226, 'lps'),
	(374387, 126, '2015-01-15 00:55:51.000000', 'consum', 0.0224, 'lps'),
	(374388, 126, '2015-01-15 00:55:52.000000', 'consum', 0.0214, 'lps'),
	(374389, 126, '2015-01-15 00:55:53.000000', 'consum', 0.0226, 'lps'),
	(374390, 126, '2015-01-15 00:55:54.000000', 'consum', 0.0221, 'lps'),
	(374391, 126, '2015-01-15 00:55:55.000000', 'consum', 0.0219, 'lps'),
	(374392, 126, '2015-01-15 00:55:56.000000', 'consum', 0.0221, 'lps'),
	(374393, 126, '2015-01-15 00:55:57.000000', 'consum', 0.0221, 'lps'),
	(374394, 126, '2015-01-15 00:55:58.000000', 'consum', 0.0214, 'lps'),
	(374395, 126, '2015-01-15 00:55:59.000000', 'consum', 0.0214, 'lps'),
	(374396, 126, '2015-01-15 00:56:00.000000', 'consum', 0.0219, 'lps'),
	(374397, 126, '2015-01-15 00:56:01.000000', 'consum', 0.0223, 'lps'),
	(374398, 126, '2015-01-15 00:56:02.000000', 'consum', 0.0213, 'lps'),
	(374399, 126, '2015-01-15 00:56:03.000000', 'consum', 0.0225, 'lps'),
	(374400, 126, '2015-01-15 00:56:04.000000', 'consum', 0.0219, 'lps'),
	(374401, 126, '2015-01-15 00:56:05.000000', 'consum', 0.0212, 'lps'),
	(374402, 126, '2015-01-15 00:56:06.000000', 'consum', 0.0210, 'lps'),
	(374403, 126, '2015-01-15 00:56:07.000000', 'consum', 0.0226, 'lps'),
	(374404, 126, '2015-01-15 00:56:08.000000', 'consum', 0.0215, 'lps'),
	(374405, 126, '2015-01-15 00:56:09.000000', 'consum', 0.0224, 'lps'),
	(374406, 126, '2015-01-15 00:56:10.000000', 'consum', 0.0228, 'lps'),
	(374407, 126, '2015-01-15 00:56:11.000000', 'consum', 0.0219, 'lps'),
	(374408, 126, '2015-01-15 00:56:12.000000', 'consum', 0.0220, 'lps'),
	(374409, 126, '2015-01-15 00:56:13.000000', 'consum', 0.0215, 'lps'),
	(374410, 126, '2015-01-15 00:56:14.000000', 'consum', 0.0227, 'lps'),
	(374411, 126, '2015-01-15 00:56:15.000000', 'consum', 0.0222, 'lps'),
	(374412, 126, '2015-01-15 00:56:16.000000', 'consum', 0.0219, 'lps'),
	(374413, 126, '2015-01-15 00:56:17.000000', 'consum', 0.0219, 'lps'),
	(374414, 126, '2015-01-15 00:56:18.000000', 'consum', 0.0228, 'lps'),
	(374415, 126, '2015-01-15 00:56:19.000000', 'consum', 0.0219, 'lps'),
	(374416, 126, '2015-01-15 00:56:20.000000', 'consum', 0.0221, 'lps'),
	(374417, 126, '2015-01-15 00:56:21.000000', 'consum', 0.0217, 'lps'),
	(374418, 126, '2015-01-15 00:56:22.000000', 'consum', 0.0214, 'lps'),
	(374419, 126, '2015-01-15 00:56:23.000000', 'consum', 0.0211, 'lps'),
	(374420, 126, '2015-01-15 00:56:24.000000', 'consum', 0.0221, 'lps'),
	(374421, 126, '2015-01-15 00:56:25.000000', 'consum', 0.0225, 'lps'),
	(374422, 126, '2015-01-15 00:56:26.000000', 'consum', 0.0214, 'lps'),
	(374423, 126, '2015-01-15 00:56:27.000000', 'consum', 0.0224, 'lps'),
	(374424, 126, '2015-01-15 00:56:28.000000', 'consum', 0.0212, 'lps'),
	(374425, 126, '2015-01-15 00:56:29.000000', 'consum', 0.0217, 'lps'),
	(374426, 126, '2015-01-15 00:56:30.000000', 'consum', 0.0220, 'lps'),
	(374427, 126, '2015-01-15 00:56:31.000000', 'consum', 0.0222, 'lps'),
	(374428, 126, '2015-01-15 00:56:32.000000', 'consum', 0.0222, 'lps'),
	(374429, 126, '2015-01-15 00:56:33.000000', 'consum', 0.0213, 'lps'),
	(374430, 126, '2015-01-15 00:56:34.000000', 'consum', 0.0227, 'lps'),
	(374431, 126, '2015-01-15 00:56:35.000000', 'consum', 0.0213, 'lps'),
	(374432, 126, '2015-01-15 00:56:36.000000', 'consum', 0.0212, 'lps'),
	(374433, 126, '2015-01-15 00:56:37.000000', 'consum', 0.0212, 'lps'),
	(374434, 126, '2015-01-15 00:56:38.000000', 'consum', 0.0213, 'lps'),
	(374435, 126, '2015-01-15 00:56:39.000000', 'consum', 0.0222, 'lps'),
	(374436, 126, '2015-01-15 00:56:40.000000', 'consum', 0.0223, 'lps'),
	(374437, 126, '2015-01-15 00:56:41.000000', 'consum', 0.0220, 'lps'),
	(374438, 126, '2015-01-15 00:56:42.000000', 'consum', 0.0219, 'lps'),
	(374439, 126, '2015-01-15 00:56:43.000000', 'consum', 0.0210, 'lps'),
	(374440, 126, '2015-01-15 00:56:44.000000', 'consum', 0.0221, 'lps'),
	(374441, 126, '2015-01-15 00:56:45.000000', 'consum', 0.0228, 'lps'),
	(374442, 126, '2015-01-15 00:56:46.000000', 'consum', 0.0228, 'lps'),
	(374443, 126, '2015-01-15 00:56:47.000000', 'consum', 0.0227, 'lps'),
	(374444, 126, '2015-01-15 00:56:48.000000', 'consum', 0.0224, 'lps'),
	(374445, 126, '2015-01-15 00:56:49.000000', 'consum', 0.0228, 'lps'),
	(374446, 126, '2015-01-15 00:56:50.000000', 'consum', 0.0222, 'lps'),
	(374447, 126, '2015-01-15 00:56:51.000000', 'consum', 0.0216, 'lps'),
	(374448, 126, '2015-01-15 00:56:52.000000', 'consum', 0.0225, 'lps'),
	(374449, 126, '2015-01-15 00:56:53.000000', 'consum', 0.0210, 'lps'),
	(374450, 126, '2015-01-15 00:56:54.000000', 'consum', 0.0221, 'lps'),
	(374451, 126, '2015-01-15 00:56:55.000000', 'consum', 0.0211, 'lps'),
	(374452, 126, '2015-01-15 00:56:56.000000', 'consum', 0.0220, 'lps'),
	(374453, 126, '2015-01-15 00:56:57.000000', 'consum', 0.0217, 'lps'),
	(374454, 126, '2015-01-15 00:56:58.000000', 'consum', 0.0219, 'lps'),
	(374455, 126, '2015-01-15 00:56:59.000000', 'consum', 0.0213, 'lps'),
	(374456, 126, '2015-01-15 00:57:00.000000', 'consum', 0.0220, 'lps'),
	(374457, 126, '2015-01-15 00:57:01.000000', 'consum', 0.0212, 'lps'),
	(374458, 126, '2015-01-15 00:57:02.000000', 'consum', 0.0228, 'lps'),
	(374459, 126, '2015-01-15 00:57:03.000000', 'consum', 0.0221, 'lps'),
	(374460, 126, '2015-01-15 00:57:04.000000', 'consum', 0.0210, 'lps'),
	(374461, 126, '2015-01-15 00:57:05.000000', 'consum', 0.0217, 'lps'),
	(374462, 126, '2015-01-15 00:57:06.000000', 'consum', 0.0224, 'lps'),
	(374463, 126, '2015-01-15 00:57:07.000000', 'consum', 0.0223, 'lps'),
	(374464, 126, '2015-01-15 00:57:08.000000', 'consum', 0.0213, 'lps'),
	(374465, 126, '2015-01-15 00:57:09.000000', 'consum', 0.0224, 'lps'),
	(374466, 126, '2015-01-15 00:57:10.000000', 'consum', 0.0215, 'lps'),
	(374467, 126, '2015-01-15 00:57:11.000000', 'consum', 0.0213, 'lps'),
	(374468, 126, '2015-01-15 00:57:12.000000', 'consum', 0.0227, 'lps'),
	(374469, 126, '2015-01-15 00:57:13.000000', 'consum', 0.0213, 'lps'),
	(374470, 126, '2015-01-15 00:57:14.000000', 'consum', 0.0212, 'lps'),
	(374471, 126, '2015-01-15 00:57:15.000000', 'consum', 0.0213, 'lps'),
	(374472, 126, '2015-01-15 00:57:16.000000', 'consum', 0.0217, 'lps'),
	(374473, 126, '2015-01-15 00:57:17.000000', 'consum', 0.0217, 'lps'),
	(374474, 126, '2015-01-15 00:57:18.000000', 'consum', 0.0224, 'lps'),
	(374475, 126, '2015-01-15 00:57:19.000000', 'consum', 0.0222, 'lps'),
	(374476, 126, '2015-01-15 00:57:20.000000', 'consum', 0.0212, 'lps'),
	(374477, 126, '2015-01-15 00:57:21.000000', 'consum', 0.0220, 'lps'),
	(374478, 126, '2015-01-15 00:57:22.000000', 'consum', 0.0216, 'lps'),
	(374479, 126, '2015-01-15 00:57:23.000000', 'consum', 0.0213, 'lps'),
	(374480, 126, '2015-01-15 00:57:24.000000', 'consum', 0.0225, 'lps'),
	(374481, 126, '2015-01-15 00:57:25.000000', 'consum', 0.0218, 'lps'),
	(374482, 126, '2015-01-15 00:57:26.000000', 'consum', 0.0228, 'lps'),
	(374483, 126, '2015-01-15 00:57:27.000000', 'consum', 0.0216, 'lps'),
	(374484, 126, '2015-01-15 00:57:28.000000', 'consum', 0.0226, 'lps'),
	(374485, 126, '2015-01-15 00:57:29.000000', 'consum', 0.0215, 'lps'),
	(374486, 126, '2015-01-15 00:57:30.000000', 'consum', 0.0227, 'lps'),
	(374487, 126, '2015-01-15 00:57:31.000000', 'consum', 0.0225, 'lps'),
	(374488, 126, '2015-01-15 00:57:32.000000', 'consum', 0.0212, 'lps'),
	(374489, 126, '2015-01-15 00:57:33.000000', 'consum', 0.0215, 'lps'),
	(374490, 126, '2015-01-15 00:57:34.000000', 'consum', 0.0211, 'lps'),
	(374491, 126, '2015-01-15 00:57:35.000000', 'consum', 0.0219, 'lps'),
	(374492, 126, '2015-01-15 00:57:36.000000', 'consum', 0.0214, 'lps'),
	(374493, 126, '2015-01-15 00:57:37.000000', 'consum', 0.0221, 'lps'),
	(374494, 126, '2015-01-15 00:57:38.000000', 'consum', 0.0218, 'lps'),
	(374495, 126, '2015-01-15 00:57:39.000000', 'consum', 0.0215, 'lps'),
	(374496, 126, '2015-01-15 00:57:40.000000', 'consum', 0.0214, 'lps'),
	(374497, 126, '2015-01-15 00:57:41.000000', 'consum', 0.0214, 'lps'),
	(374498, 126, '2015-01-15 00:57:42.000000', 'consum', 0.0218, 'lps'),
	(374499, 126, '2015-01-15 00:57:43.000000', 'consum', 0.0222, 'lps'),
	(374500, 126, '2015-01-15 00:57:44.000000', 'consum', 0.0227, 'lps'),
	(374501, 126, '2015-01-15 00:57:45.000000', 'consum', 0.0220, 'lps'),
	(374502, 126, '2015-01-15 00:57:46.000000', 'consum', 0.0211, 'lps'),
	(374503, 126, '2015-01-15 00:57:47.000000', 'consum', 0.0224, 'lps'),
	(374504, 126, '2015-01-15 00:57:48.000000', 'consum', 0.0220, 'lps'),
	(374505, 126, '2015-01-15 00:57:49.000000', 'consum', 0.0216, 'lps'),
	(374506, 126, '2015-01-15 00:57:50.000000', 'consum', 0.0214, 'lps'),
	(374507, 126, '2015-01-15 00:57:51.000000', 'consum', 0.0212, 'lps'),
	(374508, 126, '2015-01-15 00:57:52.000000', 'consum', 0.0227, 'lps'),
	(374509, 126, '2015-01-15 00:57:53.000000', 'consum', 0.0213, 'lps'),
	(374510, 126, '2015-01-15 00:57:54.000000', 'consum', 0.0212, 'lps'),
	(374511, 126, '2015-01-15 00:57:55.000000', 'consum', 0.0214, 'lps'),
	(374512, 126, '2015-01-15 00:57:56.000000', 'consum', 0.0222, 'lps'),
	(374513, 126, '2015-01-15 00:57:57.000000', 'consum', 0.0222, 'lps'),
	(374514, 126, '2015-01-15 00:57:58.000000', 'consum', 0.0214, 'lps'),
	(374515, 126, '2015-01-15 00:57:59.000000', 'consum', 0.0212, 'lps'),
	(374516, 126, '2015-01-15 00:58:00.000000', 'consum', 0.0212, 'lps'),
	(374517, 126, '2015-01-15 00:58:01.000000', 'consum', 0.0214, 'lps'),
	(374518, 126, '2015-01-15 00:58:02.000000', 'consum', 0.0222, 'lps'),
	(374519, 126, '2015-01-15 00:58:03.000000', 'consum', 0.0223, 'lps'),
	(374520, 126, '2015-01-15 00:58:04.000000', 'consum', 0.0219, 'lps'),
	(374521, 126, '2015-01-15 00:58:05.000000', 'consum', 0.0217, 'lps'),
	(374522, 126, '2015-01-15 00:58:06.000000', 'consum', 0.0217, 'lps'),
	(374523, 126, '2015-01-15 00:58:07.000000', 'consum', 0.0226, 'lps'),
	(374524, 126, '2015-01-15 00:58:08.000000', 'consum', 0.0214, 'lps'),
	(374525, 126, '2015-01-15 00:58:09.000000', 'consum', 0.0219, 'lps'),
	(374526, 126, '2015-01-15 00:58:10.000000', 'consum', 0.0224, 'lps'),
	(374527, 126, '2015-01-15 00:58:11.000000', 'consum', 0.0214, 'lps'),
	(374528, 126, '2015-01-15 00:58:12.000000', 'consum', 0.0228, 'lps'),
	(374529, 126, '2015-01-15 00:58:13.000000', 'consum', 0.0210, 'lps'),
	(374530, 126, '2015-01-15 00:58:14.000000', 'consum', 0.0217, 'lps'),
	(374531, 126, '2015-01-15 00:58:15.000000', 'consum', 0.0226, 'lps'),
	(374532, 126, '2015-01-15 00:58:16.000000', 'consum', 0.0212, 'lps'),
	(374533, 126, '2015-01-15 00:58:17.000000', 'consum', 0.0211, 'lps'),
	(374534, 126, '2015-01-15 00:58:18.000000', 'consum', 0.0226, 'lps'),
	(374535, 126, '2015-01-15 00:58:19.000000', 'consum', 0.0213, 'lps'),
	(374536, 126, '2015-01-15 00:58:20.000000', 'consum', 0.0216, 'lps'),
	(374537, 126, '2015-01-15 00:58:21.000000', 'consum', 0.0213, 'lps'),
	(374538, 126, '2015-01-15 00:58:22.000000', 'consum', 0.0227, 'lps'),
	(374539, 126, '2015-01-15 00:58:23.000000', 'consum', 0.0211, 'lps'),
	(374540, 126, '2015-01-15 00:58:24.000000', 'consum', 0.0221, 'lps'),
	(374541, 126, '2015-01-15 00:58:25.000000', 'consum', 0.0224, 'lps'),
	(374542, 126, '2015-01-15 00:58:26.000000', 'consum', 0.0210, 'lps'),
	(374543, 126, '2015-01-15 00:58:27.000000', 'consum', 0.0223, 'lps'),
	(374544, 126, '2015-01-15 00:58:28.000000', 'consum', 0.0222, 'lps'),
	(374545, 126, '2015-01-15 00:58:29.000000', 'consum', 0.0212, 'lps'),
	(374546, 126, '2015-01-15 00:58:30.000000', 'consum', 0.0222, 'lps'),
	(374547, 126, '2015-01-15 00:58:31.000000', 'consum', 0.0226, 'lps'),
	(374548, 126, '2015-01-15 00:58:32.000000', 'consum', 0.0216, 'lps'),
	(374549, 126, '2015-01-15 00:58:33.000000', 'consum', 0.0213, 'lps'),
	(374550, 126, '2015-01-15 00:58:34.000000', 'consum', 0.0225, 'lps'),
	(374551, 126, '2015-01-15 00:58:35.000000', 'consum', 0.0220, 'lps'),
	(374552, 126, '2015-01-15 00:58:36.000000', 'consum', 0.0216, 'lps'),
	(374553, 126, '2015-01-15 00:58:37.000000', 'consum', 0.0210, 'lps'),
	(374554, 126, '2015-01-15 00:58:38.000000', 'consum', 0.0211, 'lps'),
	(374555, 126, '2015-01-15 00:58:39.000000', 'consum', 0.0215, 'lps'),
	(374556, 126, '2015-01-15 00:58:40.000000', 'consum', 0.0215, 'lps'),
	(374557, 126, '2015-01-15 00:58:41.000000', 'consum', 0.0218, 'lps'),
	(374558, 126, '2015-01-15 00:58:42.000000', 'consum', 0.0218, 'lps'),
	(374559, 126, '2015-01-15 00:58:43.000000', 'consum', 0.0228, 'lps'),
	(374560, 126, '2015-01-15 00:58:44.000000', 'consum', 0.0218, 'lps'),
	(374561, 126, '2015-01-15 00:58:45.000000', 'consum', 0.0217, 'lps'),
	(374562, 126, '2015-01-15 00:58:46.000000', 'consum', 0.0219, 'lps'),
	(374563, 126, '2015-01-15 00:58:47.000000', 'consum', 0.0215, 'lps'),
	(374564, 126, '2015-01-15 00:58:48.000000', 'consum', 0.0228, 'lps'),
	(374565, 126, '2015-01-15 00:58:49.000000', 'consum', 0.0228, 'lps'),
	(374566, 126, '2015-01-15 00:58:50.000000', 'consum', 0.0227, 'lps'),
	(374567, 126, '2015-01-15 00:58:51.000000', 'consum', 0.0224, 'lps'),
	(374568, 126, '2015-01-15 00:58:52.000000', 'consum', 0.0212, 'lps'),
	(374569, 126, '2015-01-15 00:58:53.000000', 'consum', 0.0214, 'lps'),
	(374570, 126, '2015-01-15 00:58:54.000000', 'consum', 0.0226, 'lps'),
	(374571, 126, '2015-01-15 00:58:55.000000', 'consum', 0.0222, 'lps'),
	(374572, 126, '2015-01-15 00:58:56.000000', 'consum', 0.0220, 'lps'),
	(374573, 126, '2015-01-15 00:58:57.000000', 'consum', 0.0225, 'lps'),
	(374574, 126, '2015-01-15 00:58:58.000000', 'consum', 0.0216, 'lps'),
	(374575, 126, '2015-01-15 00:58:59.000000', 'consum', 0.0218, 'lps'),
	(374576, 126, '2015-01-15 00:59:00.000000', 'consum', 0.0210, 'lps'),
	(374577, 126, '2015-01-15 00:59:01.000000', 'consum', 0.0227, 'lps'),
	(374578, 126, '2015-01-15 00:59:02.000000', 'consum', 0.0219, 'lps'),
	(374579, 126, '2015-01-15 00:59:03.000000', 'consum', 0.0222, 'lps'),
	(374580, 126, '2015-01-15 00:59:04.000000', 'consum', 0.0227, 'lps'),
	(374581, 126, '2015-01-15 00:59:05.000000', 'consum', 0.0219, 'lps'),
	(374582, 126, '2015-01-15 00:59:06.000000', 'consum', 0.0224, 'lps'),
	(374583, 126, '2015-01-15 00:59:07.000000', 'consum', 0.0215, 'lps'),
	(374584, 126, '2015-01-15 00:59:08.000000', 'consum', 0.0213, 'lps'),
	(374585, 126, '2015-01-15 00:59:09.000000', 'consum', 0.0228, 'lps'),
	(374586, 126, '2015-01-15 00:59:10.000000', 'consum', 0.0218, 'lps'),
	(374587, 126, '2015-01-15 00:59:11.000000', 'consum', 0.0214, 'lps'),
	(374588, 126, '2015-01-15 00:59:12.000000', 'consum', 0.0224, 'lps'),
	(374589, 126, '2015-01-15 00:59:13.000000', 'consum', 0.0213, 'lps'),
	(374590, 126, '2015-01-15 00:59:14.000000', 'consum', 0.0220, 'lps'),
	(374591, 126, '2015-01-15 00:59:15.000000', 'consum', 0.0214, 'lps'),
	(374592, 126, '2015-01-15 00:59:16.000000', 'consum', 0.0220, 'lps'),
	(374593, 126, '2015-01-15 00:59:17.000000', 'consum', 0.0212, 'lps'),
	(374594, 126, '2015-01-15 00:59:18.000000', 'consum', 0.0226, 'lps'),
	(374595, 126, '2015-01-15 00:59:19.000000', 'consum', 0.0227, 'lps'),
	(374596, 126, '2015-01-15 00:59:20.000000', 'consum', 0.0212, 'lps'),
	(374597, 126, '2015-01-15 00:59:21.000000', 'consum', 0.0227, 'lps'),
	(374598, 126, '2015-01-15 00:59:22.000000', 'consum', 0.0212, 'lps'),
	(374599, 126, '2015-01-15 00:59:23.000000', 'consum', 0.0226, 'lps'),
	(374600, 126, '2015-01-15 00:59:24.000000', 'consum', 0.0211, 'lps'),
	(374601, 126, '2015-01-15 00:59:25.000000', 'consum', 0.0222, 'lps'),
	(374602, 126, '2015-01-15 00:59:26.000000', 'consum', 0.0211, 'lps'),
	(374603, 126, '2015-01-15 00:59:27.000000', 'consum', 0.0218, 'lps'),
	(374604, 126, '2015-01-15 00:59:28.000000', 'consum', 0.0211, 'lps'),
	(374605, 126, '2015-01-15 00:59:29.000000', 'consum', 0.0211, 'lps'),
	(374606, 126, '2015-01-15 00:59:30.000000', 'consum', 0.0210, 'lps'),
	(374607, 126, '2015-01-15 00:59:31.000000', 'consum', 0.0226, 'lps'),
	(374608, 126, '2015-01-15 00:59:32.000000', 'consum', 0.0217, 'lps'),
	(374609, 126, '2015-01-15 00:59:33.000000', 'consum', 0.0216, 'lps'),
	(374610, 126, '2015-01-15 00:59:34.000000', 'consum', 0.0218, 'lps'),
	(374611, 126, '2015-01-15 00:59:35.000000', 'consum', 0.0214, 'lps'),
	(374612, 126, '2015-01-15 00:59:36.000000', 'consum', 0.0227, 'lps'),
	(374613, 126, '2015-01-15 00:59:37.000000', 'consum', 0.0226, 'lps'),
	(374614, 126, '2015-01-15 00:59:38.000000', 'consum', 0.0222, 'lps'),
	(374615, 126, '2015-01-15 00:59:39.000000', 'consum', 0.0222, 'lps'),
	(374616, 126, '2015-01-15 00:59:40.000000', 'consum', 0.0216, 'lps'),
	(374617, 126, '2015-01-15 00:59:41.000000', 'consum', 0.0221, 'lps'),
	(374618, 126, '2015-01-15 00:59:42.000000', 'consum', 0.0210, 'lps'),
	(374619, 126, '2015-01-15 00:59:43.000000', 'consum', 0.0215, 'lps'),
	(374620, 126, '2015-01-15 00:59:44.000000', 'consum', 0.0217, 'lps'),
	(374621, 126, '2015-01-15 00:59:45.000000', 'consum', 0.0213, 'lps'),
	(374622, 126, '2015-01-15 00:59:46.000000', 'consum', 0.0223, 'lps'),
	(374623, 126, '2015-01-15 00:59:47.000000', 'consum', 0.0228, 'lps'),
	(374624, 126, '2015-01-15 00:59:48.000000', 'consum', 0.0225, 'lps'),
	(374625, 126, '2015-01-15 00:59:49.000000', 'consum', 0.0212, 'lps'),
	(374626, 126, '2015-01-15 00:59:50.000000', 'consum', 0.0213, 'lps'),
	(374627, 126, '2015-01-15 00:59:51.000000', 'consum', 0.0221, 'lps'),
	(374628, 126, '2015-01-15 00:59:52.000000', 'consum', 0.0219, 'lps'),
	(374629, 126, '2015-01-15 00:59:53.000000', 'consum', 0.0221, 'lps'),
	(374630, 126, '2015-01-15 00:59:54.000000', 'consum', 0.0219, 'lps'),
	(374631, 126, '2015-01-15 00:59:55.000000', 'consum', 0.0223, 'lps'),
	(374632, 126, '2015-01-15 00:59:56.000000', 'consum', 0.0210, 'lps'),
	(374633, 126, '2015-01-15 00:59:57.000000', 'consum', 0.0211, 'lps'),
	(374634, 126, '2015-01-15 00:59:58.000000', 'consum', 0.0213, 'lps'),
	(374635, 126, '2015-01-15 00:59:59.000000', 'consum', 0.0223, 'lps'),
	(374636, 126, '2015-01-15 01:00:00.000000', 'consum', 0.0227, 'lps'),
	(374637, 126, '2015-01-15 01:00:01.000000', 'consum', 0.0220, 'lps'),
	(374638, 126, '2015-01-15 01:00:02.000000', 'consum', 0.0227, 'lps'),
	(374639, 126, '2015-01-15 01:00:03.000000', 'consum', 0.0210, 'lps'),
	(374640, 126, '2015-01-15 01:00:04.000000', 'consum', 0.0218, 'lps'),
	(374641, 126, '2015-01-15 01:00:05.000000', 'consum', 0.0210, 'lps'),
	(374642, 126, '2015-01-15 01:00:06.000000', 'consum', 0.0224, 'lps'),
	(374643, 126, '2015-01-15 01:00:07.000000', 'consum', 0.0224, 'lps'),
	(374644, 126, '2015-01-15 01:00:08.000000', 'consum', 0.0220, 'lps'),
	(374645, 126, '2015-01-15 01:00:09.000000', 'consum', 0.0220, 'lps'),
	(374646, 126, '2015-01-15 01:00:10.000000', 'consum', 0.0212, 'lps'),
	(374647, 126, '2015-01-15 01:00:11.000000', 'consum', 0.0226, 'lps'),
	(374648, 126, '2015-01-15 01:00:12.000000', 'consum', 0.0227, 'lps'),
	(374649, 126, '2015-01-15 01:00:13.000000', 'consum', 0.0210, 'lps'),
	(374650, 126, '2015-01-15 01:00:14.000000', 'consum', 0.0219, 'lps'),
	(374651, 126, '2015-01-15 01:00:15.000000', 'consum', 0.0214, 'lps'),
	(374652, 126, '2015-01-15 01:00:16.000000', 'consum', 0.0225, 'lps'),
	(374653, 126, '2015-01-15 01:00:17.000000', 'consum', 0.0217, 'lps'),
	(374654, 126, '2015-01-15 01:00:18.000000', 'consum', 0.0220, 'lps'),
	(374655, 126, '2015-01-15 01:00:19.000000', 'consum', 0.0218, 'lps'),
	(374656, 126, '2015-01-15 01:00:20.000000', 'consum', 0.0221, 'lps'),
	(374657, 126, '2015-01-15 01:00:21.000000', 'consum', 0.0223, 'lps'),
	(374658, 126, '2015-01-15 01:00:22.000000', 'consum', 0.0225, 'lps'),
	(374659, 126, '2015-01-15 01:00:23.000000', 'consum', 0.0226, 'lps'),
	(374660, 126, '2015-01-15 01:00:24.000000', 'consum', 0.0227, 'lps'),
	(374661, 126, '2015-01-15 01:00:25.000000', 'consum', 0.0228, 'lps'),
	(374662, 126, '2015-01-15 01:00:26.000000', 'consum', 0.0210, 'lps'),
	(374663, 126, '2015-01-15 01:00:27.000000', 'consum', 0.0215, 'lps'),
	(374664, 126, '2015-01-15 01:00:28.000000', 'consum', 0.0218, 'lps'),
	(374665, 126, '2015-01-15 01:00:29.000000', 'consum', 0.0216, 'lps'),
	(374666, 126, '2015-01-15 01:00:30.000000', 'consum', 0.0216, 'lps'),
	(374667, 126, '2015-01-15 01:00:31.000000', 'consum', 0.0224, 'lps'),
	(374668, 126, '2015-01-15 01:00:32.000000', 'consum', 0.0224, 'lps'),
	(374669, 126, '2015-01-15 01:00:33.000000', 'consum', 0.0217, 'lps'),
	(374670, 126, '2015-01-15 01:00:34.000000', 'consum', 0.0226, 'lps'),
	(374671, 126, '2015-01-15 01:00:35.000000', 'consum', 0.0210, 'lps'),
	(374672, 126, '2015-01-15 01:00:36.000000', 'consum', 0.0221, 'lps'),
	(374673, 126, '2015-01-15 01:00:37.000000', 'consum', 0.0225, 'lps'),
	(374674, 126, '2015-01-15 01:00:38.000000', 'consum', 0.0217, 'lps'),
	(374675, 126, '2015-01-15 01:00:39.000000', 'consum', 0.0219, 'lps'),
	(374676, 126, '2015-01-15 01:00:40.000000', 'consum', 0.0214, 'lps'),
	(374677, 126, '2015-01-15 01:00:41.000000', 'consum', 0.0222, 'lps'),
	(374678, 126, '2015-01-15 01:00:42.000000', 'consum', 0.0222, 'lps'),
	(374679, 126, '2015-01-15 01:00:43.000000', 'consum', 0.0216, 'lps'),
	(374680, 126, '2015-01-15 01:00:44.000000', 'consum', 0.0224, 'lps'),
	(374681, 126, '2015-01-15 01:00:45.000000', 'consum', 0.0226, 'lps'),
	(374682, 126, '2015-01-15 01:00:46.000000', 'consum', 0.0227, 'lps'),
	(374683, 126, '2015-01-15 01:00:47.000000', 'consum', 0.0210, 'lps'),
	(374684, 126, '2015-01-15 01:00:48.000000', 'consum', 0.0218, 'lps'),
	(374685, 126, '2015-01-15 01:00:49.000000', 'consum', 0.0210, 'lps'),
	(374686, 126, '2015-01-15 01:00:50.000000', 'consum', 0.0227, 'lps'),
	(374687, 126, '2015-01-15 01:00:51.000000', 'consum', 0.0216, 'lps'),
	(374688, 126, '2015-01-15 01:00:52.000000', 'consum', 0.0212, 'lps'),
	(374689, 126, '2015-01-15 01:00:53.000000', 'consum', 0.0220, 'lps'),
	(374690, 126, '2015-01-15 01:00:54.000000', 'consum', 0.0215, 'lps'),
	(374691, 126, '2015-01-15 01:00:55.000000', 'consum', 0.0225, 'lps'),
	(374692, 126, '2015-01-15 01:00:56.000000', 'consum', 0.0212, 'lps'),
	(374693, 126, '2015-01-15 01:00:57.000000', 'consum', 0.0216, 'lps'),
	(374694, 126, '2015-01-15 01:00:58.000000', 'consum', 0.0214, 'lps'),
	(374695, 126, '2015-01-15 01:00:59.000000', 'consum', 0.0211, 'lps'),
	(374696, 126, '2015-01-15 01:01:00.000000', 'consum', 0.0226, 'lps'),
	(374697, 126, '2015-01-15 01:01:01.000000', 'consum', 0.0228, 'lps'),
	(374698, 126, '2015-01-15 01:01:02.000000', 'consum', 0.0213, 'lps'),
	(374699, 126, '2015-01-15 01:01:03.000000', 'consum', 0.0213, 'lps'),
	(374700, 126, '2015-01-15 01:01:04.000000', 'consum', 0.0216, 'lps'),
	(374701, 126, '2015-01-15 01:01:05.000000', 'consum', 0.0212, 'lps'),
	(374702, 126, '2015-01-15 01:01:06.000000', 'consum', 0.0221, 'lps'),
	(374703, 126, '2015-01-15 01:01:07.000000', 'consum', 0.0220, 'lps'),
	(374704, 126, '2015-01-15 01:01:08.000000', 'consum', 0.0228, 'lps'),
	(374705, 126, '2015-01-15 01:01:09.000000', 'consum', 0.0214, 'lps'),
	(374706, 126, '2015-01-15 01:01:10.000000', 'consum', 0.0216, 'lps'),
	(374707, 126, '2015-01-15 01:01:11.000000', 'consum', 0.0226, 'lps'),
	(374708, 126, '2015-01-15 01:01:12.000000', 'consum', 0.0218, 'lps'),
	(374709, 126, '2015-01-15 01:01:13.000000', 'consum', 0.0218, 'lps'),
	(374710, 126, '2015-01-15 01:01:14.000000', 'consum', 0.0211, 'lps'),
	(374711, 126, '2015-01-15 01:01:15.000000', 'consum', 0.0210, 'lps'),
	(374712, 126, '2015-01-15 01:01:16.000000', 'consum', 0.0224, 'lps'),
	(374713, 126, '2015-01-15 01:01:17.000000', 'consum', 0.0227, 'lps'),
	(374714, 126, '2015-01-15 01:01:18.000000', 'consum', 0.0212, 'lps'),
	(374715, 126, '2015-01-15 01:01:19.000000', 'consum', 0.0210, 'lps'),
	(374716, 126, '2015-01-15 01:01:20.000000', 'consum', 0.0224, 'lps'),
	(374717, 126, '2015-01-15 01:01:21.000000', 'consum', 0.0221, 'lps'),
	(374718, 126, '2015-01-15 01:01:22.000000', 'consum', 0.0226, 'lps'),
	(374719, 126, '2015-01-15 01:01:23.000000', 'consum', 0.0217, 'lps'),
	(374720, 126, '2015-01-15 01:01:24.000000', 'consum', 0.0217, 'lps'),
	(374721, 126, '2015-01-15 01:01:25.000000', 'consum', 0.0227, 'lps'),
	(374722, 126, '2015-01-15 01:01:26.000000', 'consum', 0.0215, 'lps'),
	(374723, 126, '2015-01-15 01:01:27.000000', 'consum', 0.0222, 'lps'),
	(374724, 126, '2015-01-15 01:01:28.000000', 'consum', 0.0220, 'lps'),
	(374725, 126, '2015-01-15 01:01:29.000000', 'consum', 0.0222, 'lps'),
	(374726, 126, '2015-01-15 01:01:30.000000', 'consum', 0.0223, 'lps'),
	(374727, 126, '2015-01-15 01:01:31.000000', 'consum', 0.0221, 'lps'),
	(374728, 126, '2015-01-15 01:01:32.000000', 'consum', 0.0224, 'lps'),
	(374729, 126, '2015-01-15 01:01:33.000000', 'consum', 0.0212, 'lps'),
	(374730, 126, '2015-01-15 01:01:34.000000', 'consum', 0.0214, 'lps'),
	(374731, 126, '2015-01-15 01:01:35.000000', 'consum', 0.0227, 'lps'),
	(374732, 126, '2015-01-15 01:01:36.000000', 'consum', 0.0227, 'lps'),
	(374733, 126, '2015-01-15 01:01:37.000000', 'consum', 0.0224, 'lps'),
	(374734, 126, '2015-01-15 01:01:38.000000', 'consum', 0.0210, 'lps'),
	(374735, 126, '2015-01-15 01:01:39.000000', 'consum', 0.0226, 'lps'),
	(374736, 126, '2015-01-15 01:01:40.000000', 'consum', 0.0213, 'lps'),
	(374737, 126, '2015-01-15 01:01:41.000000', 'consum', 0.0217, 'lps'),
	(374738, 126, '2015-01-15 01:01:42.000000', 'consum', 0.0217, 'lps'),
	(374739, 126, '2015-01-15 01:01:43.000000', 'consum', 0.0223, 'lps'),
	(374740, 126, '2015-01-15 01:01:44.000000', 'consum', 0.0217, 'lps'),
	(374741, 126, '2015-01-15 01:01:45.000000', 'consum', 0.0227, 'lps'),
	(374742, 126, '2015-01-15 01:01:46.000000', 'consum', 0.0215, 'lps'),
	(374743, 126, '2015-01-15 01:01:47.000000', 'consum', 0.0223, 'lps'),
	(374744, 126, '2015-01-15 01:01:48.000000', 'consum', 0.0224, 'lps'),
	(374745, 126, '2015-01-15 01:01:49.000000', 'consum', 0.0222, 'lps'),
	(374746, 126, '2015-01-15 01:01:50.000000', 'consum', 0.0210, 'lps'),
	(374747, 126, '2015-01-15 01:01:51.000000', 'consum', 0.0210, 'lps'),
	(374748, 126, '2015-01-15 01:01:52.000000', 'consum', 0.0213, 'lps'),
	(374749, 126, '2015-01-15 01:01:53.000000', 'consum', 0.0226, 'lps'),
	(374750, 126, '2015-01-15 01:01:54.000000', 'consum', 0.0223, 'lps'),
	(374751, 126, '2015-01-15 01:01:55.000000', 'consum', 0.0211, 'lps'),
	(374752, 126, '2015-01-15 01:01:56.000000', 'consum', 0.0213, 'lps'),
	(374753, 126, '2015-01-15 01:01:57.000000', 'consum', 0.0224, 'lps'),
	(374754, 126, '2015-01-15 01:01:58.000000', 'consum', 0.0213, 'lps'),
	(374755, 126, '2015-01-15 01:01:59.000000', 'consum', 0.0223, 'lps'),
	(374756, 126, '2015-01-15 01:02:00.000000', 'consum', 0.0227, 'lps'),
	(374757, 126, '2015-01-15 01:02:01.000000', 'consum', 0.0218, 'lps'),
	(374758, 126, '2015-01-15 01:02:02.000000', 'consum', 0.0219, 'lps'),
	(374759, 126, '2015-01-15 01:02:03.000000', 'consum', 0.0213, 'lps'),
	(374760, 126, '2015-01-15 01:02:04.000000', 'consum', 0.0219, 'lps'),
	(374761, 126, '2015-01-15 01:02:05.000000', 'consum', 0.0228, 'lps'),
	(374762, 126, '2015-01-15 01:02:06.000000', 'consum', 0.0215, 'lps'),
	(374763, 126, '2015-01-15 01:02:07.000000', 'consum', 0.0220, 'lps'),
	(374764, 126, '2015-01-15 01:02:08.000000', 'consum', 0.0225, 'lps'),
	(374765, 126, '2015-01-15 01:02:09.000000', 'consum', 0.0218, 'lps'),
	(374766, 126, '2015-01-15 01:02:10.000000', 'consum', 0.0223, 'lps'),
	(374767, 126, '2015-01-15 01:02:11.000000', 'consum', 0.0217, 'lps'),
	(374768, 126, '2015-01-15 01:02:12.000000', 'consum', 0.0222, 'lps'),
	(374769, 126, '2015-01-15 01:02:13.000000', 'consum', 0.0213, 'lps'),
	(374770, 126, '2015-01-15 01:02:14.000000', 'consum', 0.0226, 'lps'),
	(374771, 126, '2015-01-15 01:02:15.000000', 'consum', 0.0224, 'lps'),
	(374772, 126, '2015-01-15 01:02:16.000000', 'consum', 0.0213, 'lps'),
	(374773, 126, '2015-01-15 01:02:17.000000', 'consum', 0.0223, 'lps'),
	(374774, 126, '2015-01-15 01:02:18.000000', 'consum', 0.0227, 'lps'),
	(374775, 126, '2015-01-15 01:02:19.000000', 'consum', 0.0219, 'lps'),
	(374776, 126, '2015-01-15 01:02:20.000000', 'consum', 0.0223, 'lps'),
	(374777, 126, '2015-01-15 01:02:21.000000', 'consum', 0.0212, 'lps'),
	(374778, 126, '2015-01-15 01:02:22.000000', 'consum', 0.0219, 'lps'),
	(374779, 126, '2015-01-15 01:02:23.000000', 'consum', 0.0210, 'lps'),
	(374780, 126, '2015-01-15 01:02:24.000000', 'consum', 0.0220, 'lps'),
	(374781, 126, '2015-01-15 01:02:25.000000', 'consum', 0.0226, 'lps'),
	(374782, 126, '2015-01-15 01:02:26.000000', 'consum', 0.0220, 'lps'),
	(374783, 126, '2015-01-15 01:02:27.000000', 'consum', 0.0214, 'lps'),
	(374784, 126, '2015-01-15 01:02:28.000000', 'consum', 0.0217, 'lps'),
	(374785, 126, '2015-01-15 01:02:29.000000', 'consum', 0.0216, 'lps'),
	(374786, 126, '2015-01-15 01:02:30.000000', 'consum', 0.0218, 'lps'),
	(374787, 126, '2015-01-15 01:02:31.000000', 'consum', 0.0213, 'lps'),
	(374788, 126, '2015-01-15 01:02:32.000000', 'consum', 0.0221, 'lps'),
	(374789, 126, '2015-01-15 01:02:33.000000', 'consum', 0.0218, 'lps'),
	(374790, 126, '2015-01-15 01:02:34.000000', 'consum', 0.0219, 'lps'),
	(374791, 126, '2015-01-15 01:02:35.000000', 'consum', 0.0213, 'lps'),
	(374792, 126, '2015-01-15 01:02:36.000000', 'consum', 0.0219, 'lps'),
	(374793, 126, '2015-01-15 01:02:37.000000', 'consum', 0.0224, 'lps'),
	(374794, 126, '2015-01-15 01:02:38.000000', 'consum', 0.0218, 'lps'),
	(374795, 126, '2015-01-15 01:02:39.000000', 'consum', 0.0225, 'lps'),
	(374796, 126, '2015-01-15 01:02:40.000000', 'consum', 0.0224, 'lps'),
	(374797, 126, '2015-01-15 01:02:41.000000', 'consum', 0.0218, 'lps'),
	(374798, 126, '2015-01-15 01:02:42.000000', 'consum', 0.0227, 'lps'),
	(374799, 126, '2015-01-15 01:02:43.000000', 'consum', 0.0212, 'lps'),
	(374800, 126, '2015-01-15 01:02:44.000000', 'consum', 0.0211, 'lps'),
	(374801, 126, '2015-01-15 01:02:45.000000', 'consum', 0.0228, 'lps'),
	(374802, 126, '2015-01-15 01:02:46.000000', 'consum', 0.0220, 'lps'),
	(374803, 126, '2015-01-15 01:02:47.000000', 'consum', 0.0226, 'lps'),
	(374804, 126, '2015-01-15 01:02:48.000000', 'consum', 0.0221, 'lps'),
	(374805, 126, '2015-01-15 01:02:49.000000', 'consum', 0.0217, 'lps'),
	(374806, 126, '2015-01-15 01:02:50.000000', 'consum', 0.0214, 'lps'),
	(374807, 126, '2015-01-15 01:02:51.000000', 'consum', 0.0227, 'lps'),
	(374808, 126, '2015-01-15 01:02:52.000000', 'consum', 0.0228, 'lps'),
	(374809, 126, '2015-01-15 01:02:53.000000', 'consum', 0.0211, 'lps'),
	(374810, 126, '2015-01-15 01:02:54.000000', 'consum', 0.0218, 'lps'),
	(374811, 126, '2015-01-15 01:02:55.000000', 'consum', 0.0228, 'lps'),
	(374812, 126, '2015-01-15 01:02:56.000000', 'consum', 0.0219, 'lps'),
	(374813, 126, '2015-01-15 01:02:57.000000', 'consum', 0.0221, 'lps'),
	(374814, 126, '2015-01-15 01:02:58.000000', 'consum', 0.0220, 'lps'),
	(374815, 126, '2015-01-15 01:02:59.000000', 'consum', 0.0226, 'lps'),
	(374816, 126, '2015-01-15 01:03:00.000000', 'consum', 0.0225, 'lps'),
	(374817, 126, '2015-01-15 01:03:01.000000', 'consum', 0.0216, 'lps'),
	(374818, 126, '2015-01-15 01:03:02.000000', 'consum', 0.0217, 'lps'),
	(374819, 126, '2015-01-15 01:03:03.000000', 'consum', 0.0228, 'lps'),
	(374820, 126, '2015-01-15 01:03:04.000000', 'consum', 0.0219, 'lps'),
	(374821, 126, '2015-01-15 01:03:05.000000', 'consum', 0.0224, 'lps'),
	(374822, 126, '2015-01-15 01:03:06.000000', 'consum', 0.0213, 'lps'),
	(374823, 126, '2015-01-15 01:03:07.000000', 'consum', 0.0223, 'lps'),
	(374824, 126, '2015-01-15 01:03:08.000000', 'consum', 0.0227, 'lps'),
	(374825, 126, '2015-01-15 01:03:09.000000', 'consum', 0.0218, 'lps'),
	(374826, 126, '2015-01-15 01:03:10.000000', 'consum', 0.0218, 'lps'),
	(374827, 126, '2015-01-15 01:03:11.000000', 'consum', 0.0227, 'lps'),
	(374828, 126, '2015-01-15 01:03:12.000000', 'consum', 0.0216, 'lps'),
	(374829, 126, '2015-01-15 01:03:13.000000', 'consum', 0.0225, 'lps'),
	(374830, 126, '2015-01-15 01:03:14.000000', 'consum', 0.0211, 'lps'),
	(374831, 126, '2015-01-15 01:03:15.000000', 'consum', 0.0210, 'lps'),
	(374832, 126, '2015-01-15 01:03:16.000000', 'consum', 0.0225, 'lps'),
	(374833, 126, '2015-01-15 01:03:17.000000', 'consum', 0.0228, 'lps'),
	(374834, 126, '2015-01-15 01:03:18.000000', 'consum', 0.0216, 'lps'),
	(374835, 126, '2015-01-15 01:03:19.000000', 'consum', 0.0226, 'lps'),
	(374836, 126, '2015-01-15 01:03:20.000000', 'consum', 0.0217, 'lps'),
	(374837, 126, '2015-01-15 01:03:21.000000', 'consum', 0.0217, 'lps'),
	(374838, 126, '2015-01-15 01:03:22.000000', 'consum', 0.0223, 'lps'),
	(374839, 126, '2015-01-15 01:03:23.000000', 'consum', 0.0216, 'lps'),
	(374840, 126, '2015-01-15 01:03:24.000000', 'consum', 0.0223, 'lps'),
	(374841, 126, '2015-01-15 01:03:25.000000', 'consum', 0.0217, 'lps'),
	(374842, 126, '2015-01-15 01:03:26.000000', 'consum', 0.0226, 'lps'),
	(374843, 126, '2015-01-15 01:03:27.000000', 'consum', 0.0213, 'lps'),
	(374844, 126, '2015-01-15 01:03:28.000000', 'consum', 0.0214, 'lps'),
	(374845, 126, '2015-01-15 01:03:29.000000', 'consum', 0.0222, 'lps'),
	(374846, 126, '2015-01-15 01:03:30.000000', 'consum', 0.0223, 'lps'),
	(374847, 126, '2015-01-15 01:03:31.000000', 'consum', 0.0218, 'lps'),
	(374848, 126, '2015-01-15 01:03:32.000000', 'consum', 0.0212, 'lps'),
	(374849, 126, '2015-01-15 01:03:33.000000', 'consum', 0.0216, 'lps'),
	(374850, 126, '2015-01-15 01:03:34.000000', 'consum', 0.0217, 'lps'),
	(374851, 126, '2015-01-15 01:03:35.000000', 'consum', 0.0227, 'lps'),
	(374852, 126, '2015-01-15 01:03:36.000000', 'consum', 0.0217, 'lps'),
	(374853, 126, '2015-01-15 01:03:37.000000', 'consum', 0.0213, 'lps'),
	(374854, 126, '2015-01-15 01:03:38.000000', 'consum', 0.0224, 'lps'),
	(374855, 126, '2015-01-15 01:03:39.000000', 'consum', 0.0214, 'lps'),
	(374856, 126, '2015-01-15 01:03:40.000000', 'consum', 0.0228, 'lps'),
	(374857, 126, '2015-01-15 01:03:41.000000', 'consum', 0.0210, 'lps'),
	(374858, 126, '2015-01-15 01:03:42.000000', 'consum', 0.0216, 'lps'),
	(374859, 126, '2015-01-15 01:03:43.000000', 'consum', 0.0222, 'lps'),
	(374860, 126, '2015-01-15 01:03:44.000000', 'consum', 0.0214, 'lps'),
	(374861, 126, '2015-01-15 01:03:45.000000', 'consum', 0.0214, 'lps'),
	(374862, 126, '2015-01-15 01:03:46.000000', 'consum', 0.0216, 'lps'),
	(374863, 126, '2015-01-15 01:03:47.000000', 'consum', 0.0211, 'lps'),
	(374864, 126, '2015-01-15 01:03:48.000000', 'consum', 0.0217, 'lps'),
	(374865, 126, '2015-01-15 01:03:49.000000', 'consum', 0.0222, 'lps'),
	(374866, 126, '2015-01-15 01:03:50.000000', 'consum', 0.0212, 'lps'),
	(374867, 126, '2015-01-15 01:03:51.000000', 'consum', 0.0221, 'lps'),
	(374868, 126, '2015-01-15 01:03:52.000000', 'consum', 0.0224, 'lps'),
	(374869, 126, '2015-01-15 01:03:53.000000', 'consum', 0.0227, 'lps'),
	(374870, 126, '2015-01-15 01:03:54.000000', 'consum', 0.0216, 'lps'),
	(374871, 126, '2015-01-15 01:03:55.000000', 'consum', 0.0226, 'lps'),
	(374872, 126, '2015-01-15 01:03:56.000000', 'consum', 0.0216, 'lps'),
	(374873, 126, '2015-01-15 01:03:57.000000', 'consum', 0.0213, 'lps'),
	(374874, 126, '2015-01-15 01:03:58.000000', 'consum', 0.0224, 'lps'),
	(374875, 126, '2015-01-15 01:03:59.000000', 'consum', 0.0214, 'lps'),
	(374876, 126, '2015-01-15 01:04:00.000000', 'consum', 0.0210, 'lps'),
	(374877, 126, '2015-01-15 01:04:01.000000', 'consum', 0.0216, 'lps'),
	(374878, 126, '2015-01-15 01:04:02.000000', 'consum', 0.0221, 'lps'),
	(374879, 126, '2015-01-15 01:04:03.000000', 'consum', 0.0210, 'lps'),
	(374880, 126, '2015-01-15 01:04:04.000000', 'consum', 0.0215, 'lps'),
	(374881, 126, '2015-01-15 01:04:05.000000', 'consum', 0.0216, 'lps'),
	(374882, 126, '2015-01-15 01:04:06.000000', 'consum', 0.0225, 'lps'),
	(374883, 126, '2015-01-15 01:04:07.000000', 'consum', 0.0212, 'lps'),
	(374884, 126, '2015-01-15 01:04:08.000000', 'consum', 0.0212, 'lps'),
	(374885, 126, '2015-01-15 01:04:09.000000', 'consum', 0.0213, 'lps'),
	(374886, 126, '2015-01-15 01:04:10.000000', 'consum', 0.0222, 'lps'),
	(374887, 126, '2015-01-15 01:04:11.000000', 'consum', 0.0224, 'lps'),
	(374888, 126, '2015-01-15 01:04:12.000000', 'consum', 0.0225, 'lps'),
	(374889, 126, '2015-01-15 01:04:13.000000', 'consum', 0.0223, 'lps'),
	(374890, 126, '2015-01-15 01:04:14.000000', 'consum', 0.0213, 'lps'),
	(374891, 126, '2015-01-15 01:04:15.000000', 'consum', 0.0225, 'lps'),
	(374892, 126, '2015-01-15 01:04:16.000000', 'consum', 0.0219, 'lps'),
	(374893, 126, '2015-01-15 01:04:17.000000', 'consum', 0.0210, 'lps'),
	(374894, 126, '2015-01-15 01:04:18.000000', 'consum', 0.0222, 'lps'),
	(374895, 126, '2015-01-15 01:04:19.000000', 'consum', 0.0215, 'lps'),
	(374896, 126, '2015-01-15 01:04:20.000000', 'consum', 0.0216, 'lps'),
	(374897, 126, '2015-01-15 01:04:21.000000', 'consum', 0.0225, 'lps'),
	(374898, 126, '2015-01-15 01:04:22.000000', 'consum', 0.0228, 'lps'),
	(374899, 126, '2015-01-15 01:04:23.000000', 'consum', 0.0221, 'lps'),
	(374900, 126, '2015-01-15 01:04:24.000000', 'consum', 0.0228, 'lps'),
	(374901, 126, '2015-01-15 01:04:25.000000', 'consum', 0.0213, 'lps'),
	(374902, 126, '2015-01-15 01:04:26.000000', 'consum', 0.0226, 'lps'),
	(374903, 126, '2015-01-15 01:04:27.000000', 'consum', 0.0227, 'lps'),
	(374904, 126, '2015-01-15 01:04:28.000000', 'consum', 0.0228, 'lps'),
	(374905, 126, '2015-01-15 01:04:29.000000', 'consum', 0.0211, 'lps'),
	(374906, 126, '2015-01-15 01:04:30.000000', 'consum', 0.0219, 'lps'),
	(374907, 126, '2015-01-15 01:04:31.000000', 'consum', 0.0212, 'lps'),
	(374908, 126, '2015-01-15 01:04:32.000000', 'consum', 0.0215, 'lps'),
	(374909, 126, '2015-01-15 01:04:33.000000', 'consum', 0.0211, 'lps'),
	(374910, 126, '2015-01-15 01:04:34.000000', 'consum', 0.0219, 'lps'),
	(374911, 126, '2015-01-15 01:04:35.000000', 'consum', 0.0212, 'lps'),
	(374912, 126, '2015-01-15 01:04:36.000000', 'consum', 0.0216, 'lps'),
	(374913, 126, '2015-01-15 01:04:37.000000', 'consum', 0.0213, 'lps'),
	(374914, 126, '2015-01-15 01:04:38.000000', 'consum', 0.0228, 'lps'),
	(374915, 126, '2015-01-15 01:04:39.000000', 'consum', 0.0215, 'lps'),
	(374916, 126, '2015-01-15 01:04:40.000000', 'consum', 0.0220, 'lps'),
	(374917, 126, '2015-01-15 01:04:41.000000', 'consum', 0.0226, 'lps'),
	(374918, 126, '2015-01-15 01:04:42.000000', 'consum', 0.0221, 'lps'),
	(374919, 126, '2015-01-15 01:04:43.000000', 'consum', 0.0220, 'lps'),
	(374920, 126, '2015-01-15 01:04:44.000000', 'consum', 0.0226, 'lps'),
	(374921, 126, '2015-01-15 01:04:45.000000', 'consum', 0.0223, 'lps'),
	(374922, 126, '2015-01-15 01:04:46.000000', 'consum', 0.0225, 'lps'),
	(374923, 126, '2015-01-15 01:04:47.000000', 'consum', 0.0212, 'lps'),
	(374924, 126, '2015-01-15 01:04:48.000000', 'consum', 0.0213, 'lps'),
	(374925, 126, '2015-01-15 01:04:49.000000', 'consum', 0.0220, 'lps'),
	(374926, 126, '2015-01-15 01:04:50.000000', 'consum', 0.0212, 'lps'),
	(374927, 126, '2015-01-15 01:04:51.000000', 'consum', 0.0212, 'lps'),
	(374928, 126, '2015-01-15 01:04:52.000000', 'consum', 0.0212, 'lps'),
	(374929, 126, '2015-01-15 01:04:53.000000', 'consum', 0.0214, 'lps'),
	(374930, 126, '2015-01-15 01:04:54.000000', 'consum', 0.0227, 'lps'),
	(374931, 126, '2015-01-15 01:04:55.000000', 'consum', 0.0227, 'lps'),
	(374932, 126, '2015-01-15 01:04:56.000000', 'consum', 0.0226, 'lps'),
	(374933, 126, '2015-01-15 01:04:57.000000', 'consum', 0.0218, 'lps'),
	(374934, 126, '2015-01-15 01:04:58.000000', 'consum', 0.0221, 'lps'),
	(374935, 126, '2015-01-15 01:04:59.000000', 'consum', 0.0224, 'lps'),
	(374936, 126, '2015-01-15 01:05:00.000000', 'consum', 0.0211, 'lps'),
	(374937, 126, '2015-01-15 01:05:01.000000', 'consum', 0.0228, 'lps'),
	(374938, 126, '2015-01-15 01:05:02.000000', 'consum', 0.0224, 'lps'),
	(374939, 126, '2015-01-15 01:05:03.000000', 'consum', 0.0225, 'lps'),
	(374940, 126, '2015-01-15 01:05:04.000000', 'consum', 0.0224, 'lps'),
	(374941, 126, '2015-01-15 01:05:05.000000', 'consum', 0.0219, 'lps'),
	(374942, 126, '2015-01-15 01:05:06.000000', 'consum', 0.0211, 'lps'),
	(374943, 126, '2015-01-15 01:05:07.000000', 'consum', 0.0227, 'lps'),
	(374944, 126, '2015-01-15 01:05:08.000000', 'consum', 0.0216, 'lps'),
	(374945, 126, '2015-01-15 01:05:09.000000', 'consum', 0.0210, 'lps'),
	(374946, 126, '2015-01-15 01:05:10.000000', 'consum', 0.0213, 'lps'),
	(374947, 126, '2015-01-15 01:05:11.000000', 'consum', 0.0222, 'lps'),
	(374948, 126, '2015-01-15 01:05:12.000000', 'consum', 0.0226, 'lps'),
	(374949, 126, '2015-01-15 01:05:13.000000', 'consum', 0.0216, 'lps'),
	(374950, 126, '2015-01-15 01:05:14.000000', 'consum', 0.0212, 'lps'),
	(374951, 126, '2015-01-15 01:05:15.000000', 'consum', 0.0221, 'lps'),
	(374952, 126, '2015-01-15 01:05:16.000000', 'consum', 0.0221, 'lps'),
	(374953, 126, '2015-01-15 01:05:17.000000', 'consum', 0.0214, 'lps'),
	(374954, 126, '2015-01-15 01:05:18.000000', 'consum', 0.0217, 'lps'),
	(374955, 126, '2015-01-15 01:05:19.000000', 'consum', 0.0213, 'lps'),
	(374956, 126, '2015-01-15 01:05:20.000000', 'consum', 0.0225, 'lps'),
	(374957, 126, '2015-01-15 01:05:21.000000', 'consum', 0.0217, 'lps'),
	(374958, 126, '2015-01-15 01:05:22.000000', 'consum', 0.0221, 'lps'),
	(374959, 126, '2015-01-15 01:05:23.000000', 'consum', 0.0227, 'lps'),
	(374960, 126, '2015-01-15 01:05:24.000000', 'consum', 0.0225, 'lps'),
	(374961, 126, '2015-01-15 01:05:25.000000', 'consum', 0.0216, 'lps'),
	(374962, 126, '2015-01-15 01:05:26.000000', 'consum', 0.0212, 'lps'),
	(374963, 126, '2015-01-15 01:05:27.000000', 'consum', 0.0220, 'lps'),
	(374964, 126, '2015-01-15 01:05:28.000000', 'consum', 0.0220, 'lps'),
	(374965, 126, '2015-01-15 01:05:29.000000', 'consum', 0.0228, 'lps'),
	(374966, 126, '2015-01-15 01:05:30.000000', 'consum', 0.0215, 'lps'),
	(374967, 126, '2015-01-15 01:05:31.000000', 'consum', 0.0218, 'lps'),
	(374968, 126, '2015-01-15 01:05:32.000000', 'consum', 0.0219, 'lps'),
	(374969, 126, '2015-01-15 01:05:33.000000', 'consum', 0.0228, 'lps'),
	(374970, 126, '2015-01-15 01:05:34.000000', 'consum', 0.0220, 'lps'),
	(374971, 126, '2015-01-15 01:05:35.000000', 'consum', 0.0223, 'lps'),
	(374972, 126, '2015-01-15 01:05:36.000000', 'consum', 0.0228, 'lps'),
	(374973, 126, '2015-01-15 01:05:37.000000', 'consum', 0.0223, 'lps'),
	(374974, 126, '2015-01-15 01:05:38.000000', 'consum', 0.0223, 'lps'),
	(374975, 126, '2015-01-15 01:05:39.000000', 'consum', 0.0217, 'lps'),
	(374976, 126, '2015-01-15 01:05:40.000000', 'consum', 0.0223, 'lps'),
	(374977, 126, '2015-01-15 01:05:41.000000', 'consum', 0.0220, 'lps'),
	(374978, 126, '2015-01-15 01:05:42.000000', 'consum', 0.0219, 'lps'),
	(374979, 126, '2015-01-15 01:05:43.000000', 'consum', 0.0226, 'lps'),
	(374980, 126, '2015-01-15 01:05:44.000000', 'consum', 0.0227, 'lps'),
	(374981, 126, '2015-01-15 01:05:45.000000', 'consum', 0.0227, 'lps'),
	(374982, 126, '2015-01-15 01:05:46.000000', 'consum', 0.0228, 'lps'),
	(374983, 126, '2015-01-15 01:05:47.000000', 'consum', 0.0228, 'lps'),
	(374984, 126, '2015-01-15 01:05:48.000000', 'consum', 0.0228, 'lps'),
	(374985, 126, '2015-01-15 01:05:49.000000', 'consum', 0.0210, 'lps'),
	(374986, 126, '2015-01-15 01:05:50.000000', 'consum', 0.0211, 'lps'),
	(374987, 126, '2015-01-15 01:05:51.000000', 'consum', 0.0217, 'lps'),
	(374988, 126, '2015-01-15 01:05:52.000000', 'consum', 0.0224, 'lps'),
	(374989, 126, '2015-01-15 01:05:53.000000', 'consum', 0.0220, 'lps'),
	(374990, 126, '2015-01-15 01:05:54.000000', 'consum', 0.0220, 'lps'),
	(374991, 126, '2015-01-15 01:05:55.000000', 'consum', 0.0228, 'lps'),
	(374992, 126, '2015-01-15 01:05:56.000000', 'consum', 0.0215, 'lps'),
	(374993, 126, '2015-01-15 01:05:57.000000', 'consum', 0.0221, 'lps'),
	(374994, 126, '2015-01-15 01:05:58.000000', 'consum', 0.0213, 'lps'),
	(374995, 126, '2015-01-15 01:05:59.000000', 'consum', 0.0227, 'lps'),
	(374996, 126, '2015-01-15 01:06:00.000000', 'consum', 0.0214, 'lps'),
	(374997, 126, '2015-01-15 01:06:01.000000', 'consum', 0.0217, 'lps'),
	(374998, 126, '2015-01-15 01:06:02.000000', 'consum', 0.0214, 'lps'),
	(374999, 126, '2015-01-15 01:06:03.000000', 'consum', 0.0228, 'lps'),
	(375000, 126, '2015-01-15 01:06:04.000000', 'consum', 0.0214, 'lps'),
	(375001, 126, '2015-01-15 01:06:05.000000', 'consum', 0.0212, 'lps'),
	(375002, 126, '2015-01-15 01:06:06.000000', 'consum', 0.0228, 'lps'),
	(375003, 126, '2015-01-15 01:06:07.000000', 'consum', 0.0219, 'lps'),
	(375004, 126, '2015-01-15 01:06:08.000000', 'consum', 0.0221, 'lps'),
	(375005, 126, '2015-01-15 01:06:09.000000', 'consum', 0.0217, 'lps'),
	(375006, 126, '2015-01-15 01:06:10.000000', 'consum', 0.0214, 'lps'),
	(375007, 126, '2015-01-15 01:06:11.000000', 'consum', 0.0211, 'lps'),
	(375008, 126, '2015-01-15 01:06:12.000000', 'consum', 0.0221, 'lps'),
	(375009, 126, '2015-01-15 01:06:13.000000', 'consum', 0.0226, 'lps'),
	(375010, 126, '2015-01-15 01:06:14.000000', 'consum', 0.0220, 'lps'),
	(375011, 126, '2015-01-15 01:06:15.000000', 'consum', 0.0212, 'lps'),
	(375012, 126, '2015-01-15 01:06:16.000000', 'consum', 0.0227, 'lps'),
	(375013, 126, '2015-01-15 01:06:17.000000', 'consum', 0.0214, 'lps'),
	(375014, 126, '2015-01-15 01:06:18.000000', 'consum', 0.0218, 'lps'),
	(375015, 126, '2015-01-15 01:06:19.000000', 'consum', 0.0221, 'lps'),
	(375016, 126, '2015-01-15 01:06:20.000000', 'consum', 0.0222, 'lps'),
	(375017, 126, '2015-01-15 01:06:21.000000', 'consum', 0.0220, 'lps'),
	(375018, 126, '2015-01-15 01:06:22.000000', 'consum', 0.0223, 'lps'),
	(375019, 126, '2015-01-15 01:06:23.000000', 'consum', 0.0227, 'lps'),
	(375020, 126, '2015-01-15 01:06:24.000000', 'consum', 0.0217, 'lps'),
	(375021, 126, '2015-01-15 01:06:25.000000', 'consum', 0.0215, 'lps'),
	(375022, 126, '2015-01-15 01:06:26.000000', 'consum', 0.0213, 'lps'),
	(375023, 126, '2015-01-15 01:06:27.000000', 'consum', 0.0213, 'lps'),
	(375024, 126, '2015-01-15 01:06:28.000000', 'consum', 0.0216, 'lps'),
	(375025, 126, '2015-01-15 01:06:29.000000', 'consum', 0.0214, 'lps'),
	(375026, 126, '2015-01-15 01:06:30.000000', 'consum', 0.0210, 'lps'),
	(375027, 126, '2015-01-15 01:06:31.000000', 'consum', 0.0217, 'lps'),
	(375028, 126, '2015-01-15 01:06:32.000000', 'consum', 0.0226, 'lps'),
	(375029, 126, '2015-01-15 01:06:33.000000', 'consum', 0.0211, 'lps'),
	(375030, 126, '2015-01-15 01:06:34.000000', 'consum', 0.0228, 'lps'),
	(375031, 126, '2015-01-15 01:06:35.000000', 'consum', 0.0222, 'lps'),
	(375032, 126, '2015-01-15 01:06:36.000000', 'consum', 0.0214, 'lps'),
	(375033, 126, '2015-01-15 01:06:37.000000', 'consum', 0.0215, 'lps'),
	(375034, 126, '2015-01-15 01:06:38.000000', 'consum', 0.0221, 'lps'),
	(375035, 126, '2015-01-15 01:06:39.000000', 'consum', 0.0214, 'lps'),
	(375036, 126, '2015-01-15 01:06:40.000000', 'consum', 0.0217, 'lps'),
	(375037, 126, '2015-01-15 01:06:41.000000', 'consum', 0.0215, 'lps'),
	(375038, 126, '2015-01-15 01:06:42.000000', 'consum', 0.0212, 'lps'),
	(375039, 126, '2015-01-15 01:06:43.000000', 'consum', 0.0225, 'lps'),
	(375040, 126, '2015-01-15 01:06:44.000000', 'consum', 0.0223, 'lps'),
	(375041, 126, '2015-01-15 01:06:45.000000', 'consum', 0.0212, 'lps'),
	(375042, 126, '2015-01-15 01:06:46.000000', 'consum', 0.0220, 'lps'),
	(375043, 126, '2015-01-15 01:06:47.000000', 'consum', 0.0214, 'lps'),
	(375044, 126, '2015-01-15 01:06:48.000000', 'consum', 0.0222, 'lps'),
	(375045, 126, '2015-01-15 01:06:49.000000', 'consum', 0.0219, 'lps'),
	(375046, 126, '2015-01-15 01:06:50.000000', 'consum', 0.0221, 'lps'),
	(375047, 126, '2015-01-15 01:06:51.000000', 'consum', 0.0218, 'lps'),
	(375048, 126, '2015-01-15 01:06:52.000000', 'consum', 0.0220, 'lps'),
	(375049, 126, '2015-01-15 01:06:53.000000', 'consum', 0.0217, 'lps'),
	(375050, 126, '2015-01-15 01:06:54.000000', 'consum', 0.0215, 'lps'),
	(375051, 126, '2015-01-15 01:06:55.000000', 'consum', 0.0214, 'lps'),
	(375052, 126, '2015-01-15 01:06:56.000000', 'consum', 0.0215, 'lps'),
	(375053, 126, '2015-01-15 01:06:57.000000', 'consum', 0.0226, 'lps'),
	(375054, 126, '2015-01-15 01:06:58.000000', 'consum', 0.0216, 'lps'),
	(375055, 126, '2015-01-15 01:06:59.000000', 'consum', 0.0210, 'lps'),
	(375056, 126, '2015-01-15 01:07:00.000000', 'consum', 0.0215, 'lps'),
	(375057, 126, '2015-01-15 01:07:01.000000', 'consum', 0.0215, 'lps'),
	(375058, 126, '2015-01-15 01:07:02.000000', 'consum', 0.0222, 'lps'),
	(375059, 126, '2015-01-15 01:07:03.000000', 'consum', 0.0217, 'lps'),
	(375060, 126, '2015-01-15 01:07:04.000000', 'consum', 0.0211, 'lps'),
	(375061, 126, '2015-01-15 01:07:05.000000', 'consum', 0.0211, 'lps'),
	(375062, 126, '2015-01-15 01:07:06.000000', 'consum', 0.0213, 'lps'),
	(375063, 126, '2015-01-15 01:07:07.000000', 'consum', 0.0224, 'lps'),
	(375064, 126, '2015-01-15 01:07:08.000000', 'consum', 0.0216, 'lps'),
	(375065, 126, '2015-01-15 01:07:09.000000', 'consum', 0.0214, 'lps'),
	(375066, 126, '2015-01-15 01:07:10.000000', 'consum', 0.0214, 'lps'),
	(375067, 126, '2015-01-15 01:07:11.000000', 'consum', 0.0219, 'lps'),
	(375068, 126, '2015-01-15 01:07:12.000000', 'consum', 0.0222, 'lps'),
	(375069, 126, '2015-01-15 01:07:13.000000', 'consum', 0.0225, 'lps'),
	(375070, 126, '2015-01-15 01:07:14.000000', 'consum', 0.0214, 'lps'),
	(375071, 126, '2015-01-15 01:07:15.000000', 'consum', 0.0223, 'lps'),
	(375072, 126, '2015-01-15 01:07:16.000000', 'consum', 0.0227, 'lps'),
	(375073, 126, '2015-01-15 01:07:17.000000', 'consum', 0.0216, 'lps'),
	(375074, 126, '2015-01-15 01:07:18.000000', 'consum', 0.0227, 'lps'),
	(375075, 126, '2015-01-15 01:07:19.000000', 'consum', 0.0220, 'lps'),
	(375076, 126, '2015-01-15 01:07:20.000000', 'consum', 0.0210, 'lps'),
	(375077, 126, '2015-01-15 01:07:21.000000', 'consum', 0.0221, 'lps'),
	(375078, 126, '2015-01-15 01:07:22.000000', 'consum', 0.0224, 'lps'),
	(375079, 126, '2015-01-15 01:07:23.000000', 'consum', 0.0212, 'lps'),
	(375080, 126, '2015-01-15 01:07:24.000000', 'consum', 0.0214, 'lps'),
	(375081, 126, '2015-01-15 01:07:25.000000', 'consum', 0.0226, 'lps'),
	(375082, 126, '2015-01-15 01:07:26.000000', 'consum', 0.0222, 'lps'),
	(375083, 126, '2015-01-15 01:07:27.000000', 'consum', 0.0222, 'lps'),
	(375084, 126, '2015-01-15 01:07:28.000000', 'consum', 0.0214, 'lps'),
	(375085, 126, '2015-01-15 01:07:29.000000', 'consum', 0.0214, 'lps'),
	(375086, 126, '2015-01-15 01:07:30.000000', 'consum', 0.0217, 'lps'),
	(375087, 126, '2015-01-15 01:07:31.000000', 'consum', 0.0217, 'lps'),
	(375088, 126, '2015-01-15 01:07:32.000000', 'consum', 0.0224, 'lps'),
	(375089, 126, '2015-01-15 01:07:33.000000', 'consum', 0.0223, 'lps'),
	(375090, 126, '2015-01-15 01:07:34.000000', 'consum', 0.0213, 'lps'),
	(375091, 126, '2015-01-15 01:07:35.000000', 'consum', 0.0223, 'lps'),
	(375092, 126, '2015-01-15 01:07:36.000000', 'consum', 0.0210, 'lps'),
	(375093, 126, '2015-01-15 01:07:37.000000', 'consum', 0.0211, 'lps'),
	(375094, 126, '2015-01-15 01:07:38.000000', 'consum', 0.0215, 'lps'),
	(375095, 126, '2015-01-15 01:07:39.000000', 'consum', 0.0213, 'lps'),
	(375096, 126, '2015-01-15 01:07:40.000000', 'consum', 0.0210, 'lps'),
	(375097, 126, '2015-01-15 01:07:41.000000', 'consum', 0.0222, 'lps'),
	(375098, 126, '2015-01-15 01:07:42.000000', 'consum', 0.0212, 'lps'),
	(375099, 126, '2015-01-15 01:07:43.000000', 'consum', 0.0225, 'lps'),
	(375100, 126, '2015-01-15 01:07:44.000000', 'consum', 0.0221, 'lps'),
	(375101, 126, '2015-01-15 01:07:45.000000', 'consum', 0.0220, 'lps'),
	(375102, 126, '2015-01-15 01:07:46.000000', 'consum', 0.0228, 'lps'),
	(375103, 126, '2015-01-15 01:07:47.000000', 'consum', 0.0214, 'lps'),
	(375104, 126, '2015-01-15 01:07:48.000000', 'consum', 0.0216, 'lps'),
	(375105, 126, '2015-01-15 01:07:49.000000', 'consum', 0.0226, 'lps'),
	(375106, 126, '2015-01-15 01:07:50.000000', 'consum', 0.0217, 'lps'),
	(375107, 126, '2015-01-15 01:07:51.000000', 'consum', 0.0217, 'lps'),
	(375108, 126, '2015-01-15 01:07:52.000000', 'consum', 0.0222, 'lps'),
	(375109, 126, '2015-01-15 01:07:53.000000', 'consum', 0.0214, 'lps'),
	(375110, 126, '2015-01-15 01:07:54.000000', 'consum', 0.0211, 'lps'),
	(375111, 126, '2015-01-15 01:07:55.000000', 'consum', 0.0225, 'lps'),
	(375112, 126, '2015-01-15 01:07:56.000000', 'consum', 0.0226, 'lps'),
	(375113, 126, '2015-01-15 01:07:57.000000', 'consum', 0.0227, 'lps'),
	(375114, 126, '2015-01-15 01:07:58.000000', 'consum', 0.0227, 'lps'),
	(375115, 126, '2015-01-15 01:07:59.000000', 'consum', 0.0224, 'lps'),
	(375116, 126, '2015-01-15 01:08:00.000000', 'consum', 0.0212, 'lps'),
	(375117, 126, '2015-01-15 01:08:01.000000', 'consum', 0.0218, 'lps'),
	(375118, 126, '2015-01-15 01:08:02.000000', 'consum', 0.0224, 'lps'),
	(375119, 126, '2015-01-15 01:08:03.000000', 'consum', 0.0220, 'lps'),
	(375120, 126, '2015-01-15 01:08:04.000000', 'consum', 0.0219, 'lps'),
	(375121, 126, '2015-01-15 01:08:05.000000', 'consum', 0.0224, 'lps'),
	(375122, 126, '2015-01-15 01:08:06.000000', 'consum', 0.0217, 'lps'),
	(375123, 126, '2015-01-15 01:08:07.000000', 'consum', 0.0220, 'lps'),
	(375124, 126, '2015-01-15 01:08:08.000000', 'consum', 0.0223, 'lps'),
	(375125, 126, '2015-01-15 01:08:09.000000', 'consum', 0.0225, 'lps'),
	(375126, 126, '2015-01-15 01:08:10.000000', 'consum', 0.0210, 'lps'),
	(375127, 126, '2015-01-15 01:08:11.000000', 'consum', 0.0223, 'lps'),
	(375128, 126, '2015-01-15 01:08:12.000000', 'consum', 0.0220, 'lps'),
	(375129, 126, '2015-01-15 01:08:13.000000', 'consum', 0.0218, 'lps'),
	(375130, 126, '2015-01-15 01:08:14.000000', 'consum', 0.0221, 'lps'),
	(375131, 126, '2015-01-15 01:08:15.000000', 'consum', 0.0224, 'lps'),
	(375132, 126, '2015-01-15 01:08:16.000000', 'consum', 0.0228, 'lps'),
	(375133, 126, '2015-01-15 01:08:17.000000', 'consum', 0.0219, 'lps'),
	(375134, 126, '2015-01-15 01:08:18.000000', 'consum', 0.0220, 'lps'),
	(375135, 126, '2015-01-15 01:08:19.000000', 'consum', 0.0215, 'lps'),
	(375136, 126, '2015-01-15 01:08:20.000000', 'consum', 0.0223, 'lps'),
	(375137, 126, '2015-01-15 01:08:21.000000', 'consum', 0.0224, 'lps'),
	(375138, 126, '2015-01-15 01:08:22.000000', 'consum', 0.0221, 'lps'),
	(375139, 126, '2015-01-15 01:08:23.000000', 'consum', 0.0223, 'lps'),
	(375140, 126, '2015-01-15 01:08:24.000000', 'consum', 0.0226, 'lps'),
	(375141, 126, '2015-01-15 01:08:25.000000', 'consum', 0.0210, 'lps'),
	(375142, 126, '2015-01-15 01:08:26.000000', 'consum', 0.0223, 'lps'),
	(375143, 126, '2015-01-15 01:08:27.000000', 'consum', 0.0216, 'lps'),
	(375144, 126, '2015-01-15 01:08:28.000000', 'consum', 0.0222, 'lps'),
	(375145, 126, '2015-01-15 01:08:29.000000', 'consum', 0.0216, 'lps'),
	(375146, 126, '2015-01-15 01:08:30.000000', 'consum', 0.0223, 'lps'),
	(375147, 126, '2015-01-15 01:08:31.000000', 'consum', 0.0217, 'lps'),
	(375148, 126, '2015-01-15 01:08:32.000000', 'consum', 0.0227, 'lps'),
	(375149, 126, '2015-01-15 01:08:33.000000', 'consum', 0.0219, 'lps'),
	(375150, 126, '2015-01-15 01:08:34.000000', 'consum', 0.0222, 'lps'),
	(375151, 126, '2015-01-15 01:08:35.000000', 'consum', 0.0226, 'lps'),
	(375152, 126, '2015-01-15 01:08:36.000000', 'consum', 0.0215, 'lps'),
	(375153, 126, '2015-01-15 01:08:37.000000', 'consum', 0.0227, 'lps'),
	(375154, 126, '2015-01-15 01:08:38.000000', 'consum', 0.0221, 'lps'),
	(375155, 126, '2015-01-15 01:08:39.000000', 'consum', 0.0215, 'lps'),
	(375156, 126, '2015-01-15 01:08:40.000000', 'consum', 0.0220, 'lps'),
	(375157, 126, '2015-01-15 01:08:41.000000', 'consum', 0.0210, 'lps'),
	(375158, 126, '2015-01-15 01:08:42.000000', 'consum', 0.0217, 'lps'),
	(375159, 126, '2015-01-15 01:08:43.000000', 'consum', 0.0227, 'lps'),
	(375160, 126, '2015-01-15 01:08:44.000000', 'consum', 0.0217, 'lps'),
	(375161, 126, '2015-01-15 01:08:45.000000', 'consum', 0.0213, 'lps'),
	(375162, 126, '2015-01-15 01:08:46.000000', 'consum', 0.0223, 'lps'),
	(375163, 126, '2015-01-15 01:08:47.000000', 'consum', 0.0212, 'lps'),
	(375164, 126, '2015-01-15 01:08:48.000000', 'consum', 0.0219, 'lps'),
	(375165, 126, '2015-01-15 01:08:49.000000', 'consum', 0.0210, 'lps'),
	(375166, 126, '2015-01-15 01:08:50.000000', 'consum', 0.0222, 'lps'),
	(375167, 126, '2015-01-15 01:08:51.000000', 'consum', 0.0216, 'lps'),
	(375168, 126, '2015-01-15 01:08:52.000000', 'consum', 0.0221, 'lps'),
	(375169, 126, '2015-01-15 01:08:53.000000', 'consum', 0.0228, 'lps'),
	(375170, 126, '2015-01-15 01:08:54.000000', 'consum', 0.0213, 'lps'),
	(375171, 126, '2015-01-15 01:08:55.000000', 'consum', 0.0226, 'lps'),
	(375172, 126, '2015-01-15 01:08:56.000000', 'consum', 0.0227, 'lps'),
	(375173, 126, '2015-01-15 01:08:57.000000', 'consum', 0.0210, 'lps'),
	(375174, 126, '2015-01-15 01:08:58.000000', 'consum', 0.0214, 'lps'),
	(375175, 126, '2015-01-15 01:08:59.000000', 'consum', 0.0210, 'lps'),
	(375176, 126, '2015-01-15 01:09:00.000000', 'consum', 0.0221, 'lps'),
	(375177, 126, '2015-01-15 01:09:01.000000', 'consum', 0.0227, 'lps'),
	(375178, 126, '2015-01-15 01:09:02.000000', 'consum', 0.0223, 'lps'),
	(375179, 126, '2015-01-15 01:09:03.000000', 'consum', 0.0227, 'lps'),
	(375180, 126, '2015-01-15 01:09:04.000000', 'consum', 0.0218, 'lps'),
	(375181, 126, '2015-01-15 01:09:05.000000', 'consum', 0.0216, 'lps'),
	(375182, 126, '2015-01-15 01:09:06.000000', 'consum', 0.0218, 'lps'),
	(375183, 126, '2015-01-15 01:09:07.000000', 'consum', 0.0211, 'lps'),
	(375184, 126, '2015-01-15 01:09:08.000000', 'consum', 0.0213, 'lps'),
	(375185, 126, '2015-01-15 01:09:09.000000', 'consum', 0.0224, 'lps'),
	(375186, 126, '2015-01-15 01:09:10.000000', 'consum', 0.0211, 'lps'),
	(375187, 126, '2015-01-15 01:09:11.000000', 'consum', 0.0214, 'lps'),
	(375188, 126, '2015-01-15 01:09:12.000000', 'consum', 0.0225, 'lps'),
	(375189, 126, '2015-01-15 01:09:13.000000', 'consum', 0.0219, 'lps'),
	(375190, 126, '2015-01-15 01:09:14.000000', 'consum', 0.0228, 'lps'),
	(375191, 126, '2015-01-15 01:09:15.000000', 'consum', 0.0218, 'lps'),
	(375192, 126, '2015-01-15 01:09:16.000000', 'consum', 0.0216, 'lps'),
	(375193, 126, '2015-01-15 01:09:17.000000', 'consum', 0.0214, 'lps'),
	(375194, 126, '2015-01-15 01:09:18.000000', 'consum', 0.0214, 'lps'),
	(375195, 126, '2015-01-15 01:09:19.000000', 'consum', 0.0219, 'lps'),
	(375196, 126, '2015-01-15 01:09:20.000000', 'consum', 0.0226, 'lps'),
	(375197, 126, '2015-01-15 01:09:21.000000', 'consum', 0.0224, 'lps'),
	(375198, 126, '2015-01-15 01:09:22.000000', 'consum', 0.0212, 'lps'),
	(375199, 126, '2015-01-15 01:09:23.000000', 'consum', 0.0216, 'lps'),
	(375200, 126, '2015-01-15 01:09:24.000000', 'consum', 0.0218, 'lps'),
	(375201, 126, '2015-01-15 01:09:25.000000', 'consum', 0.0212, 'lps'),
	(375202, 126, '2015-01-15 01:09:26.000000', 'consum', 0.0216, 'lps'),
	(375203, 126, '2015-01-15 01:09:27.000000', 'consum', 0.0216, 'lps'),
	(375204, 126, '2015-01-15 01:09:28.000000', 'consum', 0.0221, 'lps'),
	(375205, 126, '2015-01-15 01:09:29.000000', 'consum', 0.0212, 'lps'),
	(375206, 126, '2015-01-15 01:09:30.000000', 'consum', 0.0224, 'lps'),
	(375207, 126, '2015-01-15 01:09:31.000000', 'consum', 0.0219, 'lps'),
	(375208, 126, '2015-01-15 01:09:32.000000', 'consum', 0.0214, 'lps'),
	(375209, 126, '2015-01-15 01:09:33.000000', 'consum', 0.0222, 'lps'),
	(375210, 126, '2015-01-15 01:09:34.000000', 'consum', 0.0219, 'lps'),
	(375211, 126, '2015-01-15 01:09:35.000000', 'consum', 0.0221, 'lps'),
	(375212, 126, '2015-01-15 01:09:36.000000', 'consum', 0.0220, 'lps'),
	(375213, 126, '2015-01-15 01:09:37.000000', 'consum', 0.0228, 'lps'),
	(375214, 126, '2015-01-15 01:09:38.000000', 'consum', 0.0214, 'lps'),
	(375215, 126, '2015-01-15 01:09:39.000000', 'consum', 0.0212, 'lps'),
	(375216, 126, '2015-01-15 01:09:40.000000', 'consum', 0.0210, 'lps'),
	(375217, 126, '2015-01-15 01:09:41.000000', 'consum', 0.0224, 'lps'),
	(375218, 126, '2015-01-15 01:09:42.000000', 'consum', 0.0221, 'lps'),
	(375219, 126, '2015-01-15 01:09:43.000000', 'consum', 0.0225, 'lps'),
	(375220, 126, '2015-01-15 01:09:44.000000', 'consum', 0.0215, 'lps'),
	(375221, 126, '2015-01-15 01:09:45.000000', 'consum', 0.0228, 'lps'),
	(375222, 126, '2015-01-15 01:09:46.000000', 'consum', 0.0210, 'lps'),
	(375223, 126, '2015-01-15 01:09:47.000000', 'consum', 0.0214, 'lps'),
	(375224, 126, '2015-01-15 01:09:48.000000', 'consum', 0.0212, 'lps'),
	(375225, 126, '2015-01-15 01:09:49.000000', 'consum', 0.0225, 'lps'),
	(375226, 126, '2015-01-15 01:09:50.000000', 'consum', 0.0225, 'lps'),
	(375227, 126, '2015-01-15 01:09:51.000000', 'consum', 0.0220, 'lps'),
	(375228, 126, '2015-01-15 01:09:52.000000', 'consum', 0.0217, 'lps'),
	(375229, 126, '2015-01-15 01:09:53.000000', 'consum', 0.0213, 'lps'),
	(375230, 126, '2015-01-15 01:09:54.000000', 'consum', 0.0224, 'lps'),
	(375231, 126, '2015-01-15 01:09:55.000000', 'consum', 0.0213, 'lps'),
	(375232, 126, '2015-01-15 01:09:56.000000', 'consum', 0.0224, 'lps'),
	(375233, 126, '2015-01-15 01:09:57.000000', 'consum', 0.0213, 'lps'),
	(375234, 126, '2015-01-15 01:09:58.000000', 'consum', 0.0222, 'lps'),
	(375235, 126, '2015-01-15 01:09:59.000000', 'consum', 0.0223, 'lps'),
	(375236, 126, '2015-01-15 01:10:00.000000', 'consum', 0.0222, 'lps'),
	(375237, 126, '2015-01-15 01:10:01.000000', 'consum', 0.0214, 'lps'),
	(375238, 126, '2015-01-15 01:10:02.000000', 'consum', 0.0211, 'lps'),
	(375239, 126, '2015-01-15 01:10:03.000000', 'consum', 0.0221, 'lps'),
	(375240, 126, '2015-01-15 01:10:04.000000', 'consum', 0.0228, 'lps'),
	(375241, 126, '2015-01-15 01:10:05.000000', 'consum', 0.0228, 'lps'),
	(375242, 126, '2015-01-15 01:10:06.000000', 'consum', 0.0227, 'lps'),
	(375243, 126, '2015-01-15 01:10:07.000000', 'consum', 0.0224, 'lps'),
	(375244, 126, '2015-01-15 01:10:08.000000', 'consum', 0.0210, 'lps'),
	(375245, 126, '2015-01-15 01:10:09.000000', 'consum', 0.0226, 'lps'),
	(375246, 126, '2015-01-15 01:10:10.000000', 'consum', 0.0216, 'lps'),
	(375247, 126, '2015-01-15 01:10:11.000000', 'consum', 0.0228, 'lps'),
	(375248, 126, '2015-01-15 01:10:12.000000', 'consum', 0.0224, 'lps'),
	(375249, 126, '2015-01-15 01:10:13.000000', 'consum', 0.0210, 'lps'),
	(375250, 126, '2015-01-15 01:10:14.000000', 'consum', 0.0226, 'lps'),
	(375251, 126, '2015-01-15 01:10:15.000000', 'consum', 0.0216, 'lps'),
	(375252, 126, '2015-01-15 01:10:16.000000', 'consum', 0.0227, 'lps'),
	(375253, 126, '2015-01-15 01:10:17.000000', 'consum', 0.0223, 'lps'),
	(375254, 126, '2015-01-15 01:10:18.000000', 'consum', 0.0225, 'lps'),
	(375255, 126, '2015-01-15 01:10:19.000000', 'consum', 0.0226, 'lps'),
	(375256, 126, '2015-01-15 01:10:20.000000', 'consum', 0.0210, 'lps'),
	(375257, 126, '2015-01-15 01:10:21.000000', 'consum', 0.0217, 'lps'),
	(375258, 126, '2015-01-15 01:10:22.000000', 'consum', 0.0210, 'lps'),
	(375259, 126, '2015-01-15 01:10:23.000000', 'consum', 0.0225, 'lps'),
	(375260, 126, '2015-01-15 01:10:24.000000', 'consum', 0.0228, 'lps'),
	(375261, 126, '2015-01-15 01:10:25.000000', 'consum', 0.0219, 'lps'),
	(375262, 126, '2015-01-15 01:10:26.000000', 'consum', 0.0220, 'lps'),
	(375263, 126, '2015-01-15 01:10:27.000000', 'consum', 0.0215, 'lps'),
	(375264, 126, '2015-01-15 01:10:28.000000', 'consum', 0.0224, 'lps'),
	(375265, 126, '2015-01-15 01:10:29.000000', 'consum', 0.0227, 'lps'),
	(375266, 126, '2015-01-15 01:10:30.000000', 'consum', 0.0214, 'lps'),
	(375267, 126, '2015-01-15 01:10:31.000000', 'consum', 0.0219, 'lps'),
	(375268, 126, '2015-01-15 01:10:32.000000', 'consum', 0.0223, 'lps'),
	(375269, 126, '2015-01-15 01:10:33.000000', 'consum', 0.0213, 'lps'),
	(375270, 126, '2015-01-15 01:10:34.000000', 'consum', 0.0222, 'lps'),
	(375271, 126, '2015-01-15 01:10:35.000000', 'consum', 0.0226, 'lps'),
	(375272, 126, '2015-01-15 01:10:36.000000', 'consum', 0.0215, 'lps'),
	(375273, 126, '2015-01-15 01:10:37.000000', 'consum', 0.0227, 'lps'),
	(375274, 126, '2015-01-15 01:10:38.000000', 'consum', 0.0221, 'lps'),
	(375275, 126, '2015-01-15 01:10:39.000000', 'consum', 0.0214, 'lps'),
	(375276, 126, '2015-01-15 01:10:40.000000', 'consum', 0.0219, 'lps'),
	(375277, 126, '2015-01-15 01:10:41.000000', 'consum', 0.0226, 'lps'),
	(375278, 126, '2015-01-15 01:10:42.000000', 'consum', 0.0222, 'lps'),
	(375279, 126, '2015-01-15 01:10:43.000000', 'consum', 0.0225, 'lps'),
	(375280, 126, '2015-01-15 01:10:44.000000', 'consum', 0.0211, 'lps'),
	(375281, 126, '2015-01-15 01:10:45.000000', 'consum', 0.0226, 'lps'),
	(375282, 126, '2015-01-15 01:10:46.000000', 'consum', 0.0214, 'lps'),
	(375283, 126, '2015-01-15 01:10:47.000000', 'consum', 0.0220, 'lps'),
	(375284, 126, '2015-01-15 01:10:48.000000', 'consum', 0.0210, 'lps'),
	(375285, 126, '2015-01-15 01:10:49.000000', 'consum', 0.0218, 'lps'),
	(375286, 126, '2015-01-15 01:10:50.000000', 'consum', 0.0214, 'lps'),
	(375287, 126, '2015-01-15 01:10:51.000000', 'consum', 0.0225, 'lps'),
	(375288, 126, '2015-01-15 01:10:52.000000', 'consum', 0.0215, 'lps'),
	(375289, 126, '2015-01-15 01:10:53.000000', 'consum', 0.0228, 'lps'),
	(375290, 126, '2015-01-15 01:10:54.000000', 'consum', 0.0210, 'lps'),
	(375291, 126, '2015-01-15 01:10:55.000000', 'consum', 0.0213, 'lps'),
	(375292, 126, '2015-01-15 01:10:56.000000', 'consum', 0.0225, 'lps'),
	(375293, 126, '2015-01-15 01:10:57.000000', 'consum', 0.0222, 'lps'),
	(375294, 126, '2015-01-15 01:10:58.000000', 'consum', 0.0225, 'lps'),
	(375295, 126, '2015-01-15 01:10:59.000000', 'consum', 0.0211, 'lps'),
	(375296, 126, '2015-01-15 01:11:00.000000', 'consum', 0.0228, 'lps'),
	(375297, 126, '2015-01-15 01:11:01.000000', 'consum', 0.0220, 'lps'),
	(375298, 126, '2015-01-15 01:11:02.000000', 'consum', 0.0227, 'lps'),
	(375299, 126, '2015-01-15 01:11:03.000000', 'consum', 0.0228, 'lps'),
	(375300, 126, '2015-01-15 01:11:04.000000', 'consum', 0.0213, 'lps'),
	(375301, 126, '2015-01-15 01:11:05.000000', 'consum', 0.0226, 'lps'),
	(375302, 126, '2015-01-15 01:11:06.000000', 'consum', 0.0225, 'lps'),
	(375303, 126, '2015-01-15 01:11:07.000000', 'consum', 0.0218, 'lps'),
	(375304, 126, '2015-01-15 01:11:08.000000', 'consum', 0.0223, 'lps'),
	(375305, 126, '2015-01-15 01:11:09.000000', 'consum', 0.0217, 'lps'),
	(375306, 126, '2015-01-15 01:11:10.000000', 'consum', 0.0223, 'lps'),
	(375307, 126, '2015-01-15 01:11:11.000000', 'consum', 0.0218, 'lps'),
	(375308, 126, '2015-01-15 01:11:12.000000', 'consum', 0.0211, 'lps'),
	(375309, 126, '2015-01-15 01:11:13.000000', 'consum', 0.0212, 'lps'),
	(375310, 126, '2015-01-15 01:11:14.000000', 'consum', 0.0214, 'lps'),
	(375311, 126, '2015-01-15 01:11:15.000000', 'consum', 0.0228, 'lps'),
	(375312, 126, '2015-01-15 01:11:16.000000', 'consum', 0.0212, 'lps'),
	(375313, 126, '2015-01-15 01:11:17.000000', 'consum', 0.0224, 'lps'),
	(375314, 126, '2015-01-15 01:11:18.000000', 'consum', 0.0216, 'lps'),
	(375315, 126, '2015-01-15 01:11:19.000000', 'consum', 0.0218, 'lps'),
	(375316, 126, '2015-01-15 01:11:20.000000', 'consum', 0.0212, 'lps'),
	(375317, 126, '2015-01-15 01:11:21.000000', 'consum', 0.0215, 'lps'),
	(375318, 126, '2015-01-15 01:11:22.000000', 'consum', 0.0210, 'lps'),
	(375319, 126, '2015-01-15 01:11:23.000000', 'consum', 0.0214, 'lps'),
	(375320, 126, '2015-01-15 01:11:24.000000', 'consum', 0.0211, 'lps'),
	(375321, 126, '2015-01-15 01:11:25.000000', 'consum', 0.0222, 'lps'),
	(375322, 126, '2015-01-15 01:11:26.000000', 'consum', 0.0211, 'lps'),
	(375323, 126, '2015-01-15 01:11:27.000000', 'consum', 0.0219, 'lps'),
	(375324, 126, '2015-01-15 01:11:28.000000', 'consum', 0.0215, 'lps'),
	(375325, 126, '2015-01-15 01:11:29.000000', 'consum', 0.0228, 'lps'),
	(375326, 126, '2015-01-15 01:11:30.000000', 'consum', 0.0227, 'lps'),
	(375327, 126, '2015-01-15 01:11:31.000000', 'consum', 0.0222, 'lps'),
	(375328, 126, '2015-01-15 01:11:32.000000', 'consum', 0.0221, 'lps'),
	(375329, 126, '2015-01-15 01:11:33.000000', 'consum', 0.0212, 'lps'),
	(375330, 126, '2015-01-15 01:11:34.000000', 'consum', 0.0223, 'lps'),
	(375331, 126, '2015-01-15 01:11:35.000000', 'consum', 0.0215, 'lps'),
	(375332, 126, '2015-01-15 01:11:36.000000', 'consum', 0.0214, 'lps'),
	(375333, 126, '2015-01-15 01:11:37.000000', 'consum', 0.0217, 'lps'),
	(375334, 126, '2015-01-15 01:11:38.000000', 'consum', 0.0212, 'lps'),
	(375335, 126, '2015-01-15 01:11:39.000000', 'consum', 0.0220, 'lps'),
	(375336, 126, '2015-01-15 01:11:40.000000', 'consum', 0.0217, 'lps'),
	(375337, 126, '2015-01-15 01:11:41.000000', 'consum', 0.0214, 'lps'),
	(375338, 126, '2015-01-15 01:11:42.000000', 'consum', 0.0212, 'lps'),
	(375339, 126, '2015-01-15 01:11:43.000000', 'consum', 0.0225, 'lps'),
	(375340, 126, '2015-01-15 01:11:44.000000', 'consum', 0.0222, 'lps'),
	(375341, 126, '2015-01-15 01:11:45.000000', 'consum', 0.0227, 'lps'),
	(375342, 126, '2015-01-15 01:11:46.000000', 'consum', 0.0223, 'lps'),
	(375343, 126, '2015-01-15 01:11:47.000000', 'consum', 0.0224, 'lps'),
	(375344, 126, '2015-01-15 01:11:48.000000', 'consum', 0.0223, 'lps'),
	(375345, 126, '2015-01-15 01:11:49.000000', 'consum', 0.0213, 'lps'),
	(375346, 126, '2015-01-15 01:11:50.000000', 'consum', 0.0223, 'lps'),
	(375347, 126, '2015-01-15 01:11:51.000000', 'consum', 0.0212, 'lps'),
	(375348, 126, '2015-01-15 01:11:52.000000', 'consum', 0.0219, 'lps'),
	(375349, 126, '2015-01-15 01:11:53.000000', 'consum', 0.0228, 'lps'),
	(375350, 126, '2015-01-15 01:11:54.000000', 'consum', 0.0219, 'lps'),
	(375351, 126, '2015-01-15 01:11:55.000000', 'consum', 0.0219, 'lps'),
	(375352, 126, '2015-01-15 01:11:56.000000', 'consum', 0.0212, 'lps'),
	(375353, 126, '2015-01-15 01:11:57.000000', 'consum', 0.0211, 'lps'),
	(375354, 126, '2015-01-15 01:11:58.000000', 'consum', 0.0227, 'lps'),
	(375355, 126, '2015-01-15 01:11:59.000000', 'consum', 0.0216, 'lps'),
	(375356, 126, '2015-01-15 01:12:00.000000', 'consum', 0.0228, 'lps'),
	(375357, 126, '2015-01-15 01:12:01.000000', 'consum', 0.0226, 'lps'),
	(375358, 126, '2015-01-15 01:12:02.000000', 'consum', 0.0216, 'lps'),
	(375359, 126, '2015-01-15 01:12:03.000000', 'consum', 0.0214, 'lps'),
	(375360, 126, '2015-01-15 01:12:04.000000', 'consum', 0.0211, 'lps'),
	(375361, 126, '2015-01-15 01:12:05.000000', 'consum', 0.0224, 'lps'),
	(375362, 126, '2015-01-15 01:12:06.000000', 'consum', 0.0221, 'lps'),
	(375363, 126, '2015-01-15 01:12:07.000000', 'consum', 0.0224, 'lps'),
	(375364, 126, '2015-01-15 01:12:08.000000', 'consum', 0.0226, 'lps'),
	(375365, 126, '2015-01-15 01:12:09.000000', 'consum', 0.0210, 'lps'),
	(375366, 126, '2015-01-15 01:12:10.000000', 'consum', 0.0222, 'lps'),
	(375367, 126, '2015-01-15 01:12:11.000000', 'consum', 0.0210, 'lps'),
	(375368, 126, '2015-01-15 01:12:12.000000', 'consum', 0.0216, 'lps'),
	(375369, 126, '2015-01-15 01:12:13.000000', 'consum', 0.0221, 'lps'),
	(375370, 126, '2015-01-15 01:12:14.000000', 'consum', 0.0227, 'lps'),
	(375371, 126, '2015-01-15 01:12:15.000000', 'consum', 0.0224, 'lps'),
	(375372, 126, '2015-01-15 01:12:16.000000', 'consum', 0.0213, 'lps'),
	(375373, 126, '2015-01-15 01:12:17.000000', 'consum', 0.0222, 'lps'),
	(375374, 126, '2015-01-15 01:12:18.000000', 'consum', 0.0224, 'lps'),
	(375375, 126, '2015-01-15 01:12:19.000000', 'consum', 0.0225, 'lps'),
	(375376, 126, '2015-01-15 01:12:20.000000', 'consum', 0.0224, 'lps'),
	(375377, 126, '2015-01-15 01:12:21.000000', 'consum', 0.0218, 'lps'),
	(375378, 126, '2015-01-15 01:12:22.000000', 'consum', 0.0226, 'lps'),
	(375379, 126, '2015-01-15 01:12:23.000000', 'consum', 0.0228, 'lps'),
	(375380, 126, '2015-01-15 01:12:24.000000', 'consum', 0.0216, 'lps'),
	(375381, 126, '2015-01-15 01:12:25.000000', 'consum', 0.0223, 'lps'),
	(375382, 126, '2015-01-15 01:12:26.000000', 'consum', 0.0219, 'lps'),
	(375383, 126, '2015-01-15 01:12:27.000000', 'consum', 0.0218, 'lps'),
	(375384, 126, '2015-01-15 01:12:28.000000', 'consum', 0.0221, 'lps'),
	(375385, 126, '2015-01-15 01:12:29.000000', 'consum', 0.0224, 'lps'),
	(375386, 126, '2015-01-15 01:12:30.000000', 'consum', 0.0211, 'lps'),
	(375387, 126, '2015-01-15 01:12:31.000000', 'consum', 0.0227, 'lps'),
	(375388, 126, '2015-01-15 01:12:32.000000', 'consum', 0.0219, 'lps'),
	(375389, 126, '2015-01-15 01:12:33.000000', 'consum', 0.0225, 'lps'),
	(375390, 126, '2015-01-15 01:12:34.000000', 'consum', 0.0218, 'lps'),
	(375391, 126, '2015-01-15 01:12:35.000000', 'consum', 0.0224, 'lps'),
	(375392, 126, '2015-01-15 01:12:36.000000', 'consum', 0.0219, 'lps'),
	(375393, 126, '2015-01-15 01:12:37.000000', 'consum', 0.0214, 'lps'),
	(375394, 126, '2015-01-15 01:12:38.000000', 'consum', 0.0224, 'lps'),
	(375395, 126, '2015-01-15 01:12:39.000000', 'consum', 0.0228, 'lps'),
	(375396, 126, '2015-01-15 01:12:40.000000', 'consum', 0.0221, 'lps'),
	(375397, 126, '2015-01-15 01:12:41.000000', 'consum', 0.0212, 'lps'),
	(375398, 126, '2015-01-15 01:12:42.000000', 'consum', 0.0227, 'lps'),
	(375399, 126, '2015-01-15 01:12:43.000000', 'consum', 0.0214, 'lps'),
	(375400, 126, '2015-01-15 01:12:44.000000', 'consum', 0.0218, 'lps'),
	(375401, 126, '2015-01-15 01:12:45.000000', 'consum', 0.0217, 'lps'),
	(375402, 126, '2015-01-15 01:12:46.000000', 'consum', 0.0224, 'lps'),
	(375403, 126, '2015-01-15 01:12:47.000000', 'consum', 0.0221, 'lps'),
	(375404, 126, '2015-01-15 01:12:48.000000', 'consum', 0.0224, 'lps'),
	(375405, 126, '2015-01-15 01:12:49.000000', 'consum', 0.0228, 'lps'),
	(375406, 126, '2015-01-15 01:12:50.000000', 'consum', 0.0220, 'lps'),
	(375407, 126, '2015-01-15 01:12:51.000000', 'consum', 0.0227, 'lps'),
	(375408, 126, '2015-01-15 01:12:52.000000', 'consum', 0.0228, 'lps'),
	(375409, 126, '2015-01-15 01:12:53.000000', 'consum', 0.0212, 'lps'),
	(375410, 126, '2015-01-15 01:12:54.000000', 'consum', 0.0221, 'lps'),
	(375411, 126, '2015-01-15 01:12:55.000000', 'consum', 0.0224, 'lps'),
	(375412, 126, '2015-01-15 01:12:56.000000', 'consum', 0.0210, 'lps'),
	(375413, 126, '2015-01-15 01:12:57.000000', 'consum', 0.0222, 'lps'),
	(375414, 126, '2015-01-15 01:12:58.000000', 'consum', 0.0216, 'lps'),
	(375415, 126, '2015-01-15 01:12:59.000000', 'consum', 0.0225, 'lps'),
	(375416, 126, '2015-01-15 01:13:00.000000', 'consum', 0.0228, 'lps'),
	(375417, 126, '2015-01-15 01:13:01.000000', 'consum', 0.0220, 'lps'),
	(375418, 126, '2015-01-15 01:13:02.000000', 'consum', 0.0222, 'lps'),
	(375419, 126, '2015-01-15 01:13:03.000000', 'consum', 0.0222, 'lps'),
	(375420, 126, '2015-01-15 01:13:04.000000', 'consum', 0.0217, 'lps'),
	(375421, 126, '2015-01-15 01:13:05.000000', 'consum', 0.0227, 'lps'),
	(375422, 126, '2015-01-15 01:13:06.000000', 'consum', 0.0218, 'lps'),
	(375423, 126, '2015-01-15 01:13:07.000000', 'consum', 0.0220, 'lps'),
	(375424, 126, '2015-01-15 01:13:08.000000', 'consum', 0.0217, 'lps'),
	(375425, 126, '2015-01-15 01:13:09.000000', 'consum', 0.0216, 'lps'),
	(375426, 126, '2015-01-15 01:13:10.000000', 'consum', 0.0221, 'lps'),
	(375427, 126, '2015-01-15 01:13:11.000000', 'consum', 0.0225, 'lps'),
	(375428, 126, '2015-01-15 01:13:12.000000', 'consum', 0.0217, 'lps'),
	(375429, 126, '2015-01-15 01:13:13.000000', 'consum', 0.0218, 'lps'),
	(375430, 126, '2015-01-15 01:13:14.000000', 'consum', 0.0211, 'lps'),
	(375431, 126, '2015-01-15 01:13:15.000000', 'consum', 0.0210, 'lps'),
	(375432, 126, '2015-01-15 01:13:16.000000', 'consum', 0.0227, 'lps'),
	(375433, 126, '2015-01-15 01:13:17.000000', 'consum', 0.0220, 'lps'),
	(375434, 126, '2015-01-15 01:13:18.000000', 'consum', 0.0211, 'lps'),
	(375435, 126, '2015-01-15 01:13:19.000000', 'consum', 0.0222, 'lps'),
	(375436, 126, '2015-01-15 01:13:20.000000', 'consum', 0.0212, 'lps'),
	(375437, 126, '2015-01-15 01:13:21.000000', 'consum', 0.0223, 'lps'),
	(375438, 126, '2015-01-15 01:13:22.000000', 'consum', 0.0212, 'lps'),
	(375439, 126, '2015-01-15 01:13:23.000000', 'consum', 0.0218, 'lps'),
	(375440, 126, '2015-01-15 01:13:24.000000', 'consum', 0.0227, 'lps'),
	(375441, 126, '2015-01-15 01:13:25.000000', 'consum', 0.0216, 'lps'),
	(375442, 126, '2015-01-15 01:13:26.000000', 'consum', 0.0226, 'lps'),
	(375443, 126, '2015-01-15 01:13:27.000000', 'consum', 0.0216, 'lps'),
	(375444, 126, '2015-01-15 01:13:28.000000', 'consum', 0.0212, 'lps'),
	(375445, 126, '2015-01-15 01:13:29.000000', 'consum', 0.0221, 'lps'),
	(375446, 126, '2015-01-15 01:13:30.000000', 'consum', 0.0221, 'lps'),
	(375447, 126, '2015-01-15 01:13:31.000000', 'consum', 0.0215, 'lps'),
	(375448, 126, '2015-01-15 01:13:32.000000', 'consum', 0.0219, 'lps'),
	(375449, 126, '2015-01-15 01:13:33.000000', 'consum', 0.0222, 'lps'),
	(375450, 126, '2015-01-15 01:13:34.000000', 'consum', 0.0225, 'lps'),
	(375451, 126, '2015-01-15 01:13:35.000000', 'consum', 0.0212, 'lps'),
	(375452, 126, '2015-01-15 01:13:36.000000', 'consum', 0.0215, 'lps'),
	(375453, 126, '2015-01-15 01:13:37.000000', 'consum', 0.0228, 'lps'),
	(375454, 126, '2015-01-15 01:13:38.000000', 'consum', 0.0211, 'lps'),
	(375455, 126, '2015-01-15 01:13:39.000000', 'consum', 0.0217, 'lps'),
	(375456, 126, '2015-01-15 01:13:40.000000', 'consum', 0.0222, 'lps'),
	(375457, 126, '2015-01-15 01:13:41.000000', 'consum', 0.0214, 'lps'),
	(375458, 126, '2015-01-15 01:13:42.000000', 'consum', 0.0214, 'lps'),
	(375459, 126, '2015-01-15 01:13:43.000000', 'consum', 0.0216, 'lps'),
	(375460, 126, '2015-01-15 01:13:44.000000', 'consum', 0.0210, 'lps'),
	(375461, 126, '2015-01-15 01:13:45.000000', 'consum', 0.0214, 'lps'),
	(375462, 126, '2015-01-15 01:13:46.000000', 'consum', 0.0227, 'lps'),
	(375463, 126, '2015-01-15 01:13:47.000000', 'consum', 0.0228, 'lps'),
	(375464, 126, '2015-01-15 01:13:48.000000', 'consum', 0.0213, 'lps'),
	(375465, 126, '2015-01-15 01:13:49.000000', 'consum', 0.0228, 'lps'),
	(375466, 126, '2015-01-15 01:13:50.000000', 'consum', 0.0213, 'lps'),
	(375467, 126, '2015-01-15 01:13:51.000000', 'consum', 0.0212, 'lps'),
	(375468, 126, '2015-01-15 01:13:52.000000', 'consum', 0.0228, 'lps'),
	(375469, 126, '2015-01-15 01:13:53.000000', 'consum', 0.0219, 'lps'),
	(375470, 126, '2015-01-15 01:13:54.000000', 'consum', 0.0220, 'lps'),
	(375471, 126, '2015-01-15 01:13:55.000000', 'consum', 0.0216, 'lps'),
	(375472, 126, '2015-01-15 01:13:56.000000', 'consum', 0.0228, 'lps'),
	(375473, 126, '2015-01-15 01:13:57.000000', 'consum', 0.0226, 'lps'),
	(375474, 126, '2015-01-15 01:13:58.000000', 'consum', 0.0216, 'lps'),
	(375475, 126, '2015-01-15 01:13:59.000000', 'consum', 0.0214, 'lps'),
	(375476, 126, '2015-01-15 01:14:00.000000', 'consum', 0.0212, 'lps'),
	(375477, 126, '2015-01-15 01:14:01.000000', 'consum', 0.0228, 'lps'),
	(375478, 126, '2015-01-15 01:14:02.000000', 'consum', 0.0219, 'lps'),
	(375479, 126, '2015-01-15 01:14:03.000000', 'consum', 0.0218, 'lps'),
	(375480, 126, '2015-01-15 01:14:04.000000', 'consum', 0.0227, 'lps'),
	(375481, 126, '2015-01-15 01:14:05.000000', 'consum', 0.0212, 'lps'),
	(375482, 126, '2015-01-15 01:14:06.000000', 'consum', 0.0225, 'lps'),
	(375483, 126, '2015-01-15 01:14:07.000000', 'consum', 0.0225, 'lps'),
	(375484, 126, '2015-01-15 01:14:08.000000', 'consum', 0.0219, 'lps'),
	(375485, 126, '2015-01-15 01:14:09.000000', 'consum', 0.0213, 'lps'),
	(375486, 126, '2015-01-15 01:14:10.000000', 'consum', 0.0217, 'lps'),
	(375487, 126, '2015-01-15 01:14:11.000000', 'consum', 0.0216, 'lps'),
	(375488, 126, '2015-01-15 01:14:12.000000', 'consum', 0.0219, 'lps'),
	(375489, 126, '2015-01-15 01:14:13.000000', 'consum', 0.0220, 'lps'),
	(375490, 126, '2015-01-15 01:14:14.000000', 'consum', 0.0212, 'lps'),
	(375491, 126, '2015-01-15 01:14:15.000000', 'consum', 0.0213, 'lps'),
	(375492, 126, '2015-01-15 01:14:16.000000', 'consum', 0.0218, 'lps'),
	(375493, 126, '2015-01-15 01:14:17.000000', 'consum', 0.0225, 'lps'),
	(375494, 126, '2015-01-15 01:14:18.000000', 'consum', 0.0220, 'lps'),
	(375495, 126, '2015-01-15 01:14:19.000000', 'consum', 0.0217, 'lps'),
	(375496, 126, '2015-01-15 01:14:20.000000', 'consum', 0.0216, 'lps'),
	(375497, 126, '2015-01-15 01:14:21.000000', 'consum', 0.0218, 'lps'),
	(375498, 126, '2015-01-15 01:14:22.000000', 'consum', 0.0215, 'lps'),
	(375499, 126, '2015-01-15 01:14:23.000000', 'consum', 0.0212, 'lps'),
	(375500, 126, '2015-01-15 01:14:24.000000', 'consum', 0.0226, 'lps'),
	(375501, 126, '2015-01-15 01:14:25.000000', 'consum', 0.0225, 'lps'),
	(375502, 126, '2015-01-15 01:14:26.000000', 'consum', 0.0219, 'lps'),
	(375503, 126, '2015-01-15 01:14:27.000000', 'consum', 0.0211, 'lps'),
	(375504, 126, '2015-01-15 01:14:28.000000', 'consum', 0.0225, 'lps'),
	(375505, 126, '2015-01-15 01:14:29.000000', 'consum', 0.0228, 'lps'),
	(375506, 126, '2015-01-15 01:14:30.000000', 'consum', 0.0217, 'lps'),
	(375507, 126, '2015-01-15 01:14:31.000000', 'consum', 0.0212, 'lps'),
	(375508, 126, '2015-01-15 01:14:32.000000', 'consum', 0.0216, 'lps'),
	(375509, 126, '2015-01-15 01:14:33.000000', 'consum', 0.0217, 'lps'),
	(375510, 126, '2015-01-15 01:14:34.000000', 'consum', 0.0210, 'lps'),
	(375511, 126, '2015-01-15 01:14:35.000000', 'consum', 0.0226, 'lps'),
	(375512, 126, '2015-01-15 01:14:36.000000', 'consum', 0.0216, 'lps'),
	(375513, 126, '2015-01-15 01:14:37.000000', 'consum', 0.0211, 'lps'),
	(375514, 126, '2015-01-15 01:14:38.000000', 'consum', 0.0217, 'lps'),
	(375515, 126, '2015-01-15 01:14:39.000000', 'consum', 0.0222, 'lps'),
	(375516, 126, '2015-01-15 01:14:40.000000', 'consum', 0.0214, 'lps'),
	(375517, 126, '2015-01-15 01:14:41.000000', 'consum', 0.0212, 'lps'),
	(375518, 126, '2015-01-15 01:14:42.000000', 'consum', 0.0228, 'lps'),
	(375519, 126, '2015-01-15 01:14:43.000000', 'consum', 0.0219, 'lps'),
	(375520, 126, '2015-01-15 01:14:44.000000', 'consum', 0.0219, 'lps'),
	(375521, 126, '2015-01-15 01:14:45.000000', 'consum', 0.0212, 'lps'),
	(375522, 126, '2015-01-15 01:14:46.000000', 'consum', 0.0210, 'lps'),
	(375523, 126, '2015-01-15 01:14:47.000000', 'consum', 0.0224, 'lps'),
	(375524, 126, '2015-01-15 01:14:48.000000', 'consum', 0.0223, 'lps'),
	(375525, 126, '2015-01-15 01:14:49.000000', 'consum', 0.0215, 'lps'),
	(375526, 126, '2015-01-15 01:14:50.000000', 'consum', 0.0216, 'lps'),
	(375527, 126, '2015-01-15 01:14:51.000000', 'consum', 0.0224, 'lps'),
	(375528, 126, '2015-01-15 01:14:52.000000', 'consum', 0.0227, 'lps'),
	(375529, 126, '2015-01-15 01:14:53.000000', 'consum', 0.0213, 'lps'),
	(375530, 126, '2015-01-15 01:14:54.000000', 'consum', 0.0211, 'lps'),
	(375531, 126, '2015-01-15 01:14:55.000000', 'consum', 0.0210, 'lps'),
	(375532, 126, '2015-01-15 01:14:56.000000', 'consum', 0.0225, 'lps'),
	(375533, 126, '2015-01-15 01:14:57.000000', 'consum', 0.0211, 'lps'),
	(375534, 126, '2015-01-15 01:14:58.000000', 'consum', 0.0226, 'lps'),
	(375535, 126, '2015-01-15 01:14:59.000000', 'consum', 0.0214, 'lps'),
	(375536, 126, '2015-01-15 01:15:00.000000', 'consum', 0.0218, 'lps'),
	(375537, 126, '2015-01-15 01:15:01.000000', 'consum', 0.0220, 'lps'),
	(375538, 126, '2015-01-15 01:15:02.000000', 'consum', 0.0217, 'lps'),
	(375539, 126, '2015-01-15 01:15:03.000000', 'consum', 0.0217, 'lps'),
	(375540, 126, '2015-01-15 01:15:04.000000', 'consum', 0.0223, 'lps'),
	(375541, 126, '2015-01-15 01:15:05.000000', 'consum', 0.0215, 'lps'),
	(375542, 126, '2015-01-15 01:15:06.000000', 'consum', 0.0217, 'lps'),
	(375543, 126, '2015-01-15 01:15:07.000000', 'consum', 0.0228, 'lps'),
	(375544, 126, '2015-01-15 01:15:08.000000', 'consum', 0.0226, 'lps'),
	(375545, 126, '2015-01-15 01:15:09.000000', 'consum', 0.0217, 'lps'),
	(375546, 126, '2015-01-15 01:15:10.000000', 'consum', 0.0218, 'lps'),
	(375547, 126, '2015-01-15 01:15:11.000000', 'consum', 0.0226, 'lps'),
	(375548, 126, '2015-01-15 01:15:12.000000', 'consum', 0.0212, 'lps'),
	(375549, 126, '2015-01-15 01:15:13.000000', 'consum', 0.0227, 'lps'),
	(375550, 126, '2015-01-15 01:15:14.000000', 'consum', 0.0216, 'lps'),
	(375551, 126, '2015-01-15 01:15:15.000000', 'consum', 0.0227, 'lps'),
	(375552, 126, '2015-01-15 01:15:16.000000', 'consum', 0.0222, 'lps'),
	(375553, 126, '2015-01-15 01:15:17.000000', 'consum', 0.0218, 'lps'),
	(375554, 126, '2015-01-15 01:15:18.000000', 'consum', 0.0213, 'lps'),
	(375555, 126, '2015-01-15 01:15:19.000000', 'consum', 0.0222, 'lps'),
	(375556, 126, '2015-01-15 01:15:20.000000', 'consum', 0.0223, 'lps'),
	(375557, 126, '2015-01-15 01:15:21.000000', 'consum', 0.0221, 'lps'),
	(375558, 126, '2015-01-15 01:15:22.000000', 'consum', 0.0226, 'lps'),
	(375559, 126, '2015-01-15 01:15:23.000000', 'consum', 0.0218, 'lps'),
	(375560, 126, '2015-01-15 01:15:24.000000', 'consum', 0.0224, 'lps'),
	(375561, 126, '2015-01-15 01:15:25.000000', 'consum', 0.0219, 'lps'),
	(375562, 126, '2015-01-15 01:15:26.000000', 'consum', 0.0213, 'lps'),
	(375563, 126, '2015-01-15 01:15:27.000000', 'consum', 0.0215, 'lps'),
	(375564, 126, '2015-01-15 01:15:28.000000', 'consum', 0.0228, 'lps'),
	(375565, 126, '2015-01-15 01:15:29.000000', 'consum', 0.0212, 'lps'),
	(375566, 126, '2015-01-15 01:15:30.000000', 'consum', 0.0220, 'lps'),
	(375567, 126, '2015-01-15 01:15:31.000000', 'consum', 0.0217, 'lps'),
	(375568, 126, '2015-01-15 01:15:32.000000', 'consum', 0.0218, 'lps'),
	(375569, 126, '2015-01-15 01:15:33.000000', 'consum', 0.0226, 'lps'),
	(375570, 126, '2015-01-15 01:15:34.000000', 'consum', 0.0213, 'lps'),
	(375571, 126, '2015-01-15 01:15:35.000000', 'consum', 0.0212, 'lps'),
	(375572, 126, '2015-01-15 01:15:36.000000', 'consum', 0.0214, 'lps'),
	(375573, 126, '2015-01-15 01:15:37.000000', 'consum', 0.0226, 'lps'),
	(375574, 126, '2015-01-15 01:15:38.000000', 'consum', 0.0218, 'lps'),
	(375575, 126, '2015-01-15 01:15:39.000000', 'consum', 0.0224, 'lps'),
	(375576, 126, '2015-01-15 01:15:40.000000', 'consum', 0.0218, 'lps'),
	(375577, 126, '2015-01-15 01:15:41.000000', 'consum', 0.0210, 'lps'),
	(375578, 126, '2015-01-15 01:15:42.000000', 'consum', 0.0223, 'lps'),
	(375579, 126, '2015-01-15 01:15:43.000000', 'consum', 0.0219, 'lps'),
	(375580, 126, '2015-01-15 01:15:44.000000', 'consum', 0.0216, 'lps'),
	(375581, 126, '2015-01-15 01:15:45.000000', 'consum', 0.0212, 'lps'),
	(375582, 126, '2015-01-15 01:15:46.000000', 'consum', 0.0221, 'lps'),
	(375583, 126, '2015-01-15 01:15:47.000000', 'consum', 0.0224, 'lps'),
	(375584, 126, '2015-01-15 01:15:48.000000', 'consum', 0.0211, 'lps'),
	(375585, 126, '2015-01-15 01:15:49.000000', 'consum', 0.0227, 'lps'),
	(375586, 126, '2015-01-15 01:15:50.000000', 'consum', 0.0217, 'lps'),
	(375587, 126, '2015-01-15 01:15:51.000000', 'consum', 0.0213, 'lps'),
	(375588, 126, '2015-01-15 01:15:52.000000', 'consum', 0.0226, 'lps'),
	(375589, 126, '2015-01-15 01:15:53.000000', 'consum', 0.0223, 'lps'),
	(375590, 126, '2015-01-15 01:15:54.000000', 'consum', 0.0227, 'lps'),
	(375591, 126, '2015-01-15 01:15:55.000000', 'consum', 0.0218, 'lps'),
	(375592, 126, '2015-01-15 01:15:56.000000', 'consum', 0.0217, 'lps'),
	(375593, 126, '2015-01-15 01:15:57.000000', 'consum', 0.0224, 'lps'),
	(375594, 126, '2015-01-15 01:15:58.000000', 'consum', 0.0220, 'lps'),
	(375595, 126, '2015-01-15 01:15:59.000000', 'consum', 0.0220, 'lps'),
	(375596, 126, '2015-01-15 01:16:00.000000', 'consum', 0.0212, 'lps'),
	(375597, 126, '2015-01-15 01:16:01.000000', 'consum', 0.0228, 'lps'),
	(375598, 126, '2015-01-15 01:16:02.000000', 'consum', 0.0217, 'lps'),
	(375599, 126, '2015-01-15 01:16:03.000000', 'consum', 0.0210, 'lps'),
	(375600, 126, '2015-01-15 01:16:04.000000', 'consum', 0.0228, 'lps'),
	(375601, 126, '2015-01-15 01:16:05.000000', 'consum', 0.0224, 'lps'),
	(375602, 126, '2015-01-15 01:16:06.000000', 'consum', 0.0225, 'lps'),
	(375603, 126, '2015-01-15 01:16:07.000000', 'consum', 0.0227, 'lps'),
	(375604, 126, '2015-01-15 01:16:08.000000', 'consum', 0.0210, 'lps'),
	(375605, 126, '2015-01-15 01:16:09.000000', 'consum', 0.0220, 'lps'),
	(375606, 126, '2015-01-15 01:16:10.000000', 'consum', 0.0219, 'lps'),
	(375607, 126, '2015-01-15 01:16:11.000000', 'consum', 0.0227, 'lps'),
	(375608, 126, '2015-01-15 01:16:12.000000', 'consum', 0.0211, 'lps'),
	(375609, 126, '2015-01-15 01:16:13.000000', 'consum', 0.0221, 'lps'),
	(375610, 126, '2015-01-15 01:16:14.000000', 'consum', 0.0226, 'lps'),
	(375611, 126, '2015-01-15 01:16:15.000000', 'consum', 0.0218, 'lps'),
	(375612, 102, '2015-02-01 00:00:00.000000', 'consum', 0.0212, 'lps'),
	(375613, 102, '2015-02-01 00:00:01.000000', 'consum', 0.0220, 'lps'),
	(375614, 102, '2015-02-01 00:00:02.000000', 'consum', 0.0210, 'lps'),
	(375615, 102, '2015-02-01 00:00:03.000000', 'consum', 0.0228, 'lps'),
	(375616, 102, '2015-02-01 00:00:04.000000', 'consum', 0.0228, 'lps'),
	(375617, 102, '2015-02-01 00:00:05.000000', 'consum', 0.0225, 'lps'),
	(375618, 102, '2015-02-01 00:00:06.000000', 'consum', 0.0230, 'lps'),
	(375619, 102, '2015-02-01 00:00:07.000000', 'consum', 0.0222, 'lps'),
	(375620, 102, '2015-02-01 00:00:08.000000', 'consum', 0.0211, 'lps'),
	(375621, 102, '2015-02-01 00:00:09.000000', 'consum', 0.0224, 'lps'),
	(375622, 102, '2015-02-01 00:00:10.000000', 'consum', 0.0231, 'lps'),
	(375623, 102, '2015-02-01 00:00:11.000000', 'consum', 0.0229, 'lps'),
	(375624, 102, '2015-02-01 00:00:12.000000', 'consum', 0.0220, 'lps'),
	(375625, 102, '2015-02-01 00:00:13.000000', 'consum', 0.0227, 'lps'),
	(375626, 102, '2015-02-01 00:00:14.000000', 'consum', 0.0219, 'lps'),
	(375627, 102, '2015-02-01 00:00:15.000000', 'consum', 0.0225, 'lps'),
	(375628, 102, '2015-02-01 00:00:16.000000', 'consum', 0.0216, 'lps'),
	(375629, 102, '2015-02-01 00:00:17.000000', 'consum', 0.0218, 'lps'),
	(375630, 102, '2015-02-01 00:00:18.000000', 'consum', 0.0231, 'lps'),
	(375631, 102, '2015-02-01 00:00:19.000000', 'consum', 0.0222, 'lps'),
	(375632, 102, '2015-02-01 00:00:20.000000', 'consum', 0.0232, 'lps'),
	(375633, 102, '2015-02-01 00:00:21.000000', 'consum', 0.0214, 'lps'),
	(375634, 102, '2015-02-01 00:00:22.000000', 'consum', 0.0212, 'lps'),
	(375635, 102, '2015-02-01 00:00:23.000000', 'consum', 0.0230, 'lps'),
	(375636, 102, '2015-02-01 00:00:24.000000', 'consum', 0.0213, 'lps'),
	(375637, 102, '2015-02-01 00:00:25.000000', 'consum', 0.0213, 'lps'),
	(375638, 102, '2015-02-01 00:00:26.000000', 'consum', 0.0214, 'lps'),
	(375639, 102, '2015-02-01 00:00:27.000000', 'consum', 0.0222, 'lps'),
	(375640, 102, '2015-02-01 00:00:28.000000', 'consum', 0.0213, 'lps'),
	(375641, 102, '2015-02-01 00:00:29.000000', 'consum', 0.0214, 'lps'),
	(375642, 102, '2015-02-01 00:00:30.000000', 'consum', 0.0220, 'lps'),
	(375643, 102, '2015-02-01 00:00:31.000000', 'consum', 0.0225, 'lps'),
	(375644, 102, '2015-02-01 00:00:32.000000', 'consum', 0.0210, 'lps'),
	(375645, 102, '2015-02-01 00:00:33.000000', 'consum', 0.0213, 'lps'),
	(375646, 102, '2015-02-01 00:00:34.000000', 'consum', 0.0223, 'lps'),
	(375647, 102, '2015-02-01 00:00:35.000000', 'consum', 0.0220, 'lps'),
	(375648, 102, '2015-02-01 00:00:36.000000', 'consum', 0.0222, 'lps'),
	(375649, 102, '2015-02-01 00:00:37.000000', 'consum', 0.0219, 'lps'),
	(375650, 102, '2015-02-01 00:00:38.000000', 'consum', 0.0218, 'lps'),
	(375651, 102, '2015-02-01 00:00:39.000000', 'consum', 0.0226, 'lps'),
	(375652, 102, '2015-02-01 00:00:40.000000', 'consum', 0.0217, 'lps'),
	(375653, 102, '2015-02-01 00:00:41.000000', 'consum', 0.0224, 'lps'),
	(375654, 102, '2015-02-01 00:00:42.000000', 'consum', 0.0210, 'lps'),
	(375655, 102, '2015-02-01 00:00:43.000000', 'consum', 0.0217, 'lps'),
	(375656, 102, '2015-02-01 00:00:44.000000', 'consum', 0.0224, 'lps'),
	(375657, 102, '2015-02-01 00:00:45.000000', 'consum', 0.0211, 'lps'),
	(375658, 102, '2015-02-01 00:00:46.000000', 'consum', 0.0222, 'lps'),
	(375659, 102, '2015-02-01 00:00:47.000000', 'consum', 0.0219, 'lps'),
	(375660, 102, '2015-02-01 00:00:48.000000', 'consum', 0.0221, 'lps'),
	(375661, 102, '2015-02-01 00:00:49.000000', 'consum', 0.0214, 'lps'),
	(375662, 102, '2015-02-01 00:00:50.000000', 'consum', 0.0222, 'lps'),
	(375663, 102, '2015-02-01 00:00:51.000000', 'consum', 0.0212, 'lps'),
	(375664, 102, '2015-02-01 00:00:52.000000', 'consum', 0.0232, 'lps'),
	(375665, 102, '2015-02-01 00:00:53.000000', 'consum', 0.0221, 'lps'),
	(375666, 102, '2015-02-01 00:00:54.000000', 'consum', 0.0221, 'lps'),
	(375667, 102, '2015-02-01 00:00:55.000000', 'consum', 0.0212, 'lps'),
	(375668, 102, '2015-02-01 00:00:56.000000', 'consum', 0.0210, 'lps'),
	(375669, 102, '2015-02-01 00:00:57.000000', 'consum', 0.0229, 'lps'),
	(375670, 102, '2015-02-01 00:00:58.000000', 'consum', 0.0213, 'lps'),
	(375671, 102, '2015-02-01 00:00:59.000000', 'consum', 0.0214, 'lps'),
	(375672, 102, '2015-02-01 00:01:00.000000', 'consum', 0.0220, 'lps'),
	(375673, 102, '2015-02-01 00:01:01.000000', 'consum', 0.0225, 'lps'),
	(375674, 102, '2015-02-01 00:01:02.000000', 'consum', 0.0232, 'lps'),
	(375675, 102, '2015-02-01 00:01:03.000000', 'consum', 0.0230, 'lps'),
	(375676, 102, '2015-02-01 00:01:04.000000', 'consum', 0.0220, 'lps'),
	(375677, 102, '2015-02-01 00:01:05.000000', 'consum', 0.0225, 'lps'),
	(375678, 102, '2015-02-01 00:01:06.000000', 'consum', 0.0231, 'lps'),
	(375679, 102, '2015-02-01 00:01:07.000000', 'consum', 0.0224, 'lps'),
	(375680, 102, '2015-02-01 00:01:08.000000', 'consum', 0.0217, 'lps'),
	(375681, 102, '2015-02-01 00:01:09.000000', 'consum', 0.0228, 'lps'),
	(375682, 102, '2015-02-01 00:01:10.000000', 'consum', 0.0211, 'lps'),
	(375683, 102, '2015-02-01 00:01:11.000000', 'consum', 0.0230, 'lps'),
	(375684, 102, '2015-02-01 00:01:12.000000', 'consum', 0.0216, 'lps'),
	(375685, 102, '2015-02-01 00:01:13.000000', 'consum', 0.0225, 'lps'),
	(375686, 102, '2015-02-01 00:01:14.000000', 'consum', 0.0223, 'lps'),
	(375687, 102, '2015-02-01 00:01:15.000000', 'consum', 0.0228, 'lps'),
	(375688, 102, '2015-02-01 00:01:16.000000', 'consum', 0.0216, 'lps'),
	(375689, 102, '2015-02-01 00:01:17.000000', 'consum', 0.0212, 'lps'),
	(375690, 102, '2015-02-01 00:01:18.000000', 'consum', 0.0223, 'lps'),
	(375691, 102, '2015-02-01 00:01:19.000000', 'consum', 0.0226, 'lps'),
	(375692, 102, '2015-02-01 00:01:20.000000', 'consum', 0.0229, 'lps'),
	(375693, 102, '2015-02-01 00:01:21.000000', 'consum', 0.0210, 'lps'),
	(375694, 102, '2015-02-01 00:01:22.000000', 'consum', 0.0221, 'lps'),
	(375695, 102, '2015-02-01 00:01:23.000000', 'consum', 0.0222, 'lps'),
	(375696, 102, '2015-02-01 00:01:24.000000', 'consum', 0.0213, 'lps'),
	(375697, 102, '2015-02-01 00:01:25.000000', 'consum', 0.0214, 'lps'),
	(375698, 102, '2015-02-01 00:01:26.000000', 'consum', 0.0222, 'lps'),
	(375699, 102, '2015-02-01 00:01:27.000000', 'consum', 0.0210, 'lps'),
	(375700, 102, '2015-02-01 00:01:28.000000', 'consum', 0.0222, 'lps'),
	(375701, 102, '2015-02-01 00:01:29.000000', 'consum', 0.0226, 'lps'),
	(375702, 102, '2015-02-01 00:01:30.000000', 'consum', 0.0231, 'lps'),
	(375703, 102, '2015-02-01 00:01:31.000000', 'consum', 0.0219, 'lps'),
	(375704, 102, '2015-02-01 00:01:32.000000', 'consum', 0.0218, 'lps'),
	(375705, 102, '2015-02-01 00:01:33.000000', 'consum', 0.0225, 'lps'),
	(375706, 102, '2015-02-01 00:01:34.000000', 'consum', 0.0213, 'lps'),
	(375707, 102, '2015-02-01 00:01:35.000000', 'consum', 0.0226, 'lps'),
	(375708, 102, '2015-02-01 00:01:36.000000', 'consum', 0.0212, 'lps'),
	(375709, 102, '2015-02-01 00:01:37.000000', 'consum', 0.0220, 'lps'),
	(375710, 102, '2015-02-01 00:01:38.000000', 'consum', 0.0230, 'lps'),
	(375711, 102, '2015-02-01 00:01:39.000000', 'consum', 0.0214, 'lps'),
	(375712, 102, '2015-02-01 00:01:40.000000', 'consum', 0.0215, 'lps'),
	(375713, 102, '2015-02-01 00:01:41.000000', 'consum', 0.0223, 'lps'),
	(375714, 102, '2015-02-01 00:01:42.000000', 'consum', 0.0216, 'lps'),
	(375715, 102, '2015-02-01 00:01:43.000000', 'consum', 0.0222, 'lps'),
	(375716, 102, '2015-02-01 00:01:44.000000', 'consum', 0.0229, 'lps'),
	(375717, 102, '2015-02-01 00:01:45.000000', 'consum', 0.0226, 'lps'),
	(375718, 102, '2015-02-01 00:01:46.000000', 'consum', 0.0210, 'lps'),
	(375719, 102, '2015-02-01 00:01:47.000000', 'consum', 0.0231, 'lps'),
	(375720, 102, '2015-02-01 00:01:48.000000', 'consum', 0.0223, 'lps'),
	(375721, 102, '2015-02-01 00:01:49.000000', 'consum', 0.0212, 'lps'),
	(375722, 102, '2015-02-01 00:01:50.000000', 'consum', 0.0230, 'lps'),
	(375723, 102, '2015-02-01 00:01:51.000000', 'consum', 0.0210, 'lps'),
	(375724, 102, '2015-02-01 00:01:52.000000', 'consum', 0.0220, 'lps'),
	(375725, 102, '2015-02-01 00:01:53.000000', 'consum', 0.0214, 'lps'),
	(375726, 102, '2015-02-01 00:01:54.000000', 'consum', 0.0224, 'lps'),
	(375727, 102, '2015-02-01 00:01:55.000000', 'consum', 0.0223, 'lps'),
	(375728, 102, '2015-02-01 00:01:56.000000', 'consum', 0.0231, 'lps'),
	(375729, 102, '2015-02-01 00:01:57.000000', 'consum', 0.0232, 'lps'),
	(375730, 102, '2015-02-01 00:01:58.000000', 'consum', 0.0212, 'lps'),
	(375731, 102, '2015-02-01 00:01:59.000000', 'consum', 0.0223, 'lps'),
	(375732, 102, '2015-02-01 00:02:00.000000', 'consum', 0.0226, 'lps'),
	(375733, 102, '2015-02-01 00:02:01.000000', 'consum', 0.0226, 'lps'),
	(375734, 102, '2015-02-01 00:02:02.000000', 'consum', 0.0218, 'lps'),
	(375735, 102, '2015-02-01 00:02:03.000000', 'consum', 0.0228, 'lps'),
	(375736, 102, '2015-02-01 00:02:04.000000', 'consum', 0.0228, 'lps'),
	(375737, 102, '2015-02-01 00:02:05.000000', 'consum', 0.0226, 'lps'),
	(375738, 102, '2015-02-01 00:02:06.000000', 'consum', 0.0211, 'lps'),
	(375739, 102, '2015-02-01 00:02:07.000000', 'consum', 0.0213, 'lps'),
	(375740, 102, '2015-02-01 00:02:08.000000', 'consum', 0.0222, 'lps'),
	(375741, 102, '2015-02-01 00:02:09.000000', 'consum', 0.0219, 'lps'),
	(375742, 102, '2015-02-01 00:02:10.000000', 'consum', 0.0216, 'lps'),
	(375743, 102, '2015-02-01 00:02:11.000000', 'consum', 0.0214, 'lps'),
	(375744, 102, '2015-02-01 00:02:12.000000', 'consum', 0.0215, 'lps'),
	(375745, 102, '2015-02-01 00:02:13.000000', 'consum', 0.0223, 'lps'),
	(375746, 102, '2015-02-01 00:02:14.000000', 'consum', 0.0214, 'lps'),
	(375747, 102, '2015-02-01 00:02:15.000000', 'consum', 0.0213, 'lps'),
	(375748, 102, '2015-02-01 00:02:16.000000', 'consum', 0.0216, 'lps'),
	(375749, 102, '2015-02-01 00:02:17.000000', 'consum', 0.0230, 'lps'),
	(375750, 102, '2015-02-01 00:02:18.000000', 'consum', 0.0223, 'lps'),
	(375751, 102, '2015-02-01 00:02:19.000000', 'consum', 0.0217, 'lps'),
	(375752, 102, '2015-02-01 00:02:20.000000', 'consum', 0.0229, 'lps'),
	(375753, 102, '2015-02-01 00:02:21.000000', 'consum', 0.0214, 'lps'),
	(375754, 102, '2015-02-01 00:02:22.000000', 'consum', 0.0220, 'lps'),
	(375755, 102, '2015-02-01 00:02:23.000000', 'consum', 0.0225, 'lps'),
	(375756, 102, '2015-02-01 00:02:24.000000', 'consum', 0.0212, 'lps'),
	(375757, 102, '2015-02-01 00:02:25.000000', 'consum', 0.0219, 'lps'),
	(375758, 102, '2015-02-01 00:02:26.000000', 'consum', 0.0229, 'lps'),
	(375759, 102, '2015-02-01 00:02:27.000000', 'consum', 0.0230, 'lps'),
	(375760, 102, '2015-02-01 00:02:28.000000', 'consum', 0.0231, 'lps'),
	(375761, 102, '2015-02-01 00:02:29.000000', 'consum', 0.0212, 'lps'),
	(375762, 102, '2015-02-01 00:02:30.000000', 'consum', 0.0223, 'lps'),
	(375763, 102, '2015-02-01 00:02:31.000000', 'consum', 0.0224, 'lps'),
	(375764, 102, '2015-02-01 00:02:32.000000', 'consum', 0.0221, 'lps'),
	(375765, 102, '2015-02-01 00:02:33.000000', 'consum', 0.0222, 'lps'),
	(375766, 102, '2015-02-01 00:02:34.000000', 'consum', 0.0214, 'lps'),
	(375767, 102, '2015-02-01 00:02:35.000000', 'consum', 0.0217, 'lps'),
	(375768, 102, '2015-02-01 00:02:36.000000', 'consum', 0.0211, 'lps'),
	(375769, 102, '2015-02-01 00:02:37.000000', 'consum', 0.0216, 'lps'),
	(375770, 102, '2015-02-01 00:02:38.000000', 'consum', 0.0217, 'lps'),
	(375771, 102, '2015-02-01 00:02:39.000000', 'consum', 0.0228, 'lps'),
	(375772, 102, '2015-02-01 00:02:40.000000', 'consum', 0.0231, 'lps'),
	(375773, 102, '2015-02-01 00:02:41.000000', 'consum', 0.0218, 'lps'),
	(375774, 102, '2015-02-01 00:02:42.000000', 'consum', 0.0210, 'lps'),
	(375775, 102, '2015-02-01 00:02:43.000000', 'consum', 0.0211, 'lps'),
	(375776, 102, '2015-02-01 00:02:44.000000', 'consum', 0.0212, 'lps'),
	(375777, 102, '2015-02-01 00:02:45.000000', 'consum', 0.0221, 'lps'),
	(375778, 102, '2015-02-01 00:02:46.000000', 'consum', 0.0211, 'lps'),
	(375779, 102, '2015-02-01 00:02:47.000000', 'consum', 0.0229, 'lps'),
	(375780, 102, '2015-02-01 00:02:48.000000', 'consum', 0.0232, 'lps'),
	(375781, 102, '2015-02-01 00:02:49.000000', 'consum', 0.0221, 'lps'),
	(375782, 102, '2015-02-01 00:02:50.000000', 'consum', 0.0220, 'lps'),
	(375783, 102, '2015-02-01 00:02:51.000000', 'consum', 0.0229, 'lps'),
	(375784, 102, '2015-02-01 00:02:52.000000', 'consum', 0.0227, 'lps'),
	(375785, 102, '2015-02-01 00:02:53.000000', 'consum', 0.0217, 'lps'),
	(375786, 102, '2015-02-01 00:02:54.000000', 'consum', 0.0219, 'lps'),
	(375787, 102, '2015-02-01 00:02:55.000000', 'consum', 0.0211, 'lps'),
	(375788, 102, '2015-02-01 00:02:56.000000', 'consum', 0.0212, 'lps'),
	(375789, 102, '2015-02-01 00:02:57.000000', 'consum', 0.0216, 'lps'),
	(375790, 102, '2015-02-01 00:02:58.000000', 'consum', 0.0211, 'lps'),
	(375791, 102, '2015-02-01 00:02:59.000000', 'consum', 0.0221, 'lps'),
	(375792, 102, '2015-02-01 00:03:00.000000', 'consum', 0.0218, 'lps'),
	(375793, 102, '2015-02-01 00:03:01.000000', 'consum', 0.0216, 'lps'),
	(375794, 102, '2015-02-01 00:03:02.000000', 'consum', 0.0215, 'lps'),
	(375795, 102, '2015-02-01 00:03:03.000000', 'consum', 0.0221, 'lps'),
	(375796, 102, '2015-02-01 00:03:04.000000', 'consum', 0.0225, 'lps'),
	(375797, 102, '2015-02-01 00:03:05.000000', 'consum', 0.0231, 'lps'),
	(375798, 102, '2015-02-01 00:03:06.000000', 'consum', 0.0225, 'lps'),
	(375799, 102, '2015-02-01 00:03:07.000000', 'consum', 0.0222, 'lps'),
	(375800, 102, '2015-02-01 00:03:08.000000', 'consum', 0.0227, 'lps'),
	(375801, 102, '2015-02-01 00:03:09.000000', 'consum', 0.0212, 'lps'),
	(375802, 102, '2015-02-01 00:03:10.000000', 'consum', 0.0216, 'lps'),
	(375803, 102, '2015-02-01 00:03:11.000000', 'consum', 0.0212, 'lps'),
	(375804, 102, '2015-02-01 00:03:12.000000', 'consum', 0.0227, 'lps'),
	(375805, 102, '2015-02-01 00:03:13.000000', 'consum', 0.0219, 'lps'),
	(375806, 102, '2015-02-01 00:03:14.000000', 'consum', 0.0226, 'lps'),
	(375807, 102, '2015-02-01 00:03:15.000000', 'consum', 0.0221, 'lps'),
	(375808, 102, '2015-02-01 00:03:16.000000', 'consum', 0.0214, 'lps'),
	(375809, 102, '2015-02-01 00:03:17.000000', 'consum', 0.0221, 'lps'),
	(375810, 102, '2015-02-01 00:03:18.000000', 'consum', 0.0232, 'lps'),
	(375811, 102, '2015-02-01 00:03:19.000000', 'consum', 0.0217, 'lps'),
	(375812, 102, '2015-02-01 00:03:20.000000', 'consum', 0.0226, 'lps'),
	(375813, 102, '2015-02-01 00:03:21.000000', 'consum', 0.0223, 'lps'),
	(375814, 102, '2015-02-01 00:03:22.000000', 'consum', 0.0228, 'lps'),
	(375815, 102, '2015-02-01 00:03:23.000000', 'consum', 0.0216, 'lps'),
	(375816, 102, '2015-02-01 00:03:24.000000', 'consum', 0.0230, 'lps'),
	(375817, 102, '2015-02-01 00:03:25.000000', 'consum', 0.0225, 'lps'),
	(375818, 102, '2015-02-01 00:03:26.000000', 'consum', 0.0225, 'lps'),
	(375819, 102, '2015-02-01 00:03:27.000000', 'consum', 0.0216, 'lps'),
	(375820, 102, '2015-02-01 00:03:28.000000', 'consum', 0.0222, 'lps'),
	(375821, 102, '2015-02-01 00:03:29.000000', 'consum', 0.0227, 'lps'),
	(375822, 102, '2015-02-01 00:03:30.000000', 'consum', 0.0213, 'lps'),
	(375823, 102, '2015-02-01 00:03:31.000000', 'consum', 0.0222, 'lps'),
	(375824, 102, '2015-02-01 00:03:32.000000', 'consum', 0.0216, 'lps'),
	(375825, 102, '2015-02-01 00:03:33.000000', 'consum', 0.0228, 'lps'),
	(375826, 102, '2015-02-01 00:03:34.000000', 'consum', 0.0215, 'lps'),
	(375827, 102, '2015-02-01 00:03:35.000000', 'consum', 0.0224, 'lps'),
	(375828, 102, '2015-02-01 00:03:36.000000', 'consum', 0.0221, 'lps'),
	(375829, 102, '2015-02-01 00:03:37.000000', 'consum', 0.0223, 'lps'),
	(375830, 102, '2015-02-01 00:03:38.000000', 'consum', 0.0219, 'lps'),
	(375831, 102, '2015-02-01 00:03:39.000000', 'consum', 0.0218, 'lps'),
	(375832, 102, '2015-02-01 00:03:40.000000', 'consum', 0.0221, 'lps'),
	(375833, 102, '2015-02-01 00:03:41.000000', 'consum', 0.0219, 'lps'),
	(375834, 102, '2015-02-01 00:03:42.000000', 'consum', 0.0223, 'lps'),
	(375835, 102, '2015-02-01 00:03:43.000000', 'consum', 0.0224, 'lps'),
	(375836, 102, '2015-02-01 00:03:44.000000', 'consum', 0.0218, 'lps'),
	(375837, 102, '2015-02-01 00:03:45.000000', 'consum', 0.0211, 'lps'),
	(375838, 102, '2015-02-01 00:03:46.000000', 'consum', 0.0215, 'lps'),
	(375839, 102, '2015-02-01 00:03:47.000000', 'consum', 0.0232, 'lps'),
	(375840, 102, '2015-02-01 00:03:48.000000', 'consum', 0.0213, 'lps'),
	(375841, 102, '2015-02-01 00:03:49.000000', 'consum', 0.0230, 'lps'),
	(375842, 102, '2015-02-01 00:03:50.000000', 'consum', 0.0210, 'lps'),
	(375843, 102, '2015-02-01 00:03:51.000000', 'consum', 0.0219, 'lps'),
	(375844, 102, '2015-02-01 00:03:52.000000', 'consum', 0.0232, 'lps'),
	(375845, 102, '2015-02-01 00:03:53.000000', 'consum', 0.0226, 'lps'),
	(375846, 102, '2015-02-01 00:03:54.000000', 'consum', 0.0223, 'lps'),
	(375847, 102, '2015-02-01 00:03:55.000000', 'consum', 0.0227, 'lps'),
	(375848, 102, '2015-02-01 00:03:56.000000', 'consum', 0.0210, 'lps'),
	(375849, 102, '2015-02-01 00:03:57.000000', 'consum', 0.0228, 'lps'),
	(375850, 102, '2015-02-01 00:03:58.000000', 'consum', 0.0230, 'lps'),
	(375851, 102, '2015-02-01 00:03:59.000000', 'consum', 0.0214, 'lps'),
	(375852, 102, '2015-02-01 00:04:00.000000', 'consum', 0.0214, 'lps'),
	(375853, 102, '2015-02-01 00:04:01.000000', 'consum', 0.0219, 'lps'),
	(375854, 102, '2015-02-01 00:04:02.000000', 'consum', 0.0222, 'lps'),
	(375855, 102, '2015-02-01 00:04:03.000000', 'consum', 0.0219, 'lps'),
	(375856, 102, '2015-02-01 00:04:04.000000', 'consum', 0.0218, 'lps'),
	(375857, 102, '2015-02-01 00:04:05.000000', 'consum', 0.0226, 'lps'),
	(375858, 102, '2015-02-01 00:04:06.000000', 'consum', 0.0220, 'lps'),
	(375859, 102, '2015-02-01 00:04:07.000000', 'consum', 0.0213, 'lps'),
	(375860, 102, '2015-02-01 00:04:08.000000', 'consum', 0.0216, 'lps'),
	(375861, 102, '2015-02-01 00:04:09.000000', 'consum', 0.0211, 'lps'),
	(375862, 102, '2015-02-01 00:04:10.000000', 'consum', 0.0221, 'lps'),
	(375863, 102, '2015-02-01 00:04:11.000000', 'consum', 0.0216, 'lps'),
	(375864, 102, '2015-02-01 00:04:12.000000', 'consum', 0.0229, 'lps'),
	(375865, 102, '2015-02-01 00:04:13.000000', 'consum', 0.0218, 'lps'),
	(375866, 102, '2015-02-01 00:04:14.000000', 'consum', 0.0219, 'lps'),
	(375867, 102, '2015-02-01 00:04:15.000000', 'consum', 0.0229, 'lps'),
	(375868, 102, '2015-02-01 00:04:16.000000', 'consum', 0.0232, 'lps'),
	(375869, 102, '2015-02-01 00:04:17.000000', 'consum', 0.0220, 'lps'),
	(375870, 102, '2015-02-01 00:04:18.000000', 'consum', 0.0215, 'lps'),
	(375871, 102, '2015-02-01 00:04:19.000000', 'consum', 0.0228, 'lps'),
	(375872, 102, '2015-02-01 00:04:20.000000', 'consum', 0.0216, 'lps'),
	(375873, 102, '2015-02-01 00:04:21.000000', 'consum', 0.0212, 'lps'),
	(375874, 102, '2015-02-01 00:04:22.000000', 'consum', 0.0223, 'lps'),
	(375875, 102, '2015-02-01 00:04:23.000000', 'consum', 0.0227, 'lps'),
	(375876, 102, '2015-02-01 00:04:24.000000', 'consum', 0.0230, 'lps'),
	(375877, 102, '2015-02-01 00:04:25.000000', 'consum', 0.0216, 'lps'),
	(375878, 102, '2015-02-01 00:04:26.000000', 'consum', 0.0225, 'lps'),
	(375879, 102, '2015-02-01 00:04:27.000000', 'consum', 0.0222, 'lps'),
	(375880, 102, '2015-02-01 00:04:28.000000', 'consum', 0.0226, 'lps'),
	(375881, 102, '2015-02-01 00:04:29.000000', 'consum', 0.0210, 'lps'),
	(375882, 102, '2015-02-01 00:04:30.000000', 'consum', 0.0229, 'lps'),
	(375883, 102, '2015-02-01 00:04:31.000000', 'consum', 0.0213, 'lps'),
	(375884, 102, '2015-02-01 00:04:32.000000', 'consum', 0.0215, 'lps'),
	(375885, 102, '2015-02-01 00:04:33.000000', 'consum', 0.0225, 'lps'),
	(375886, 102, '2015-02-01 00:04:34.000000', 'consum', 0.0225, 'lps'),
	(375887, 102, '2015-02-01 00:04:35.000000', 'consum', 0.0219, 'lps'),
	(375888, 102, '2015-02-01 00:04:36.000000', 'consum', 0.0231, 'lps'),
	(375889, 102, '2015-02-01 00:04:37.000000', 'consum', 0.0222, 'lps'),
	(375890, 102, '2015-02-01 00:04:38.000000', 'consum', 0.0231, 'lps'),
	(375891, 102, '2015-02-01 00:04:39.000000', 'consum', 0.0231, 'lps'),
	(375892, 102, '2015-02-01 00:04:40.000000', 'consum', 0.0229, 'lps'),
	(375893, 102, '2015-02-01 00:04:41.000000', 'consum', 0.0223, 'lps'),
	(375894, 102, '2015-02-01 00:04:42.000000', 'consum', 0.0215, 'lps'),
	(375895, 102, '2015-02-01 00:04:43.000000', 'consum', 0.0222, 'lps'),
	(375896, 102, '2015-02-01 00:04:44.000000', 'consum', 0.0231, 'lps'),
	(375897, 102, '2015-02-01 00:04:45.000000', 'consum', 0.0211, 'lps'),
	(375898, 102, '2015-02-01 00:04:46.000000', 'consum', 0.0223, 'lps'),
	(375899, 102, '2015-02-01 00:04:47.000000', 'consum', 0.0225, 'lps'),
	(375900, 102, '2015-02-01 00:04:48.000000', 'consum', 0.0224, 'lps'),
	(375901, 102, '2015-02-01 00:04:49.000000', 'consum', 0.0212, 'lps'),
	(375902, 102, '2015-02-01 00:04:50.000000', 'consum', 0.0223, 'lps'),
	(375903, 102, '2015-02-01 00:04:51.000000', 'consum', 0.0224, 'lps'),
	(375904, 102, '2015-02-01 00:04:52.000000', 'consum', 0.0220, 'lps'),
	(375905, 102, '2015-02-01 00:04:53.000000', 'consum', 0.0216, 'lps'),
	(375906, 102, '2015-02-01 00:04:54.000000', 'consum', 0.0213, 'lps'),
	(375907, 102, '2015-02-01 00:04:55.000000', 'consum', 0.0231, 'lps'),
	(375908, 102, '2015-02-01 00:04:56.000000', 'consum', 0.0213, 'lps'),
	(375909, 102, '2015-02-01 00:04:57.000000', 'consum', 0.0232, 'lps'),
	(375910, 102, '2015-02-01 00:04:58.000000', 'consum', 0.0221, 'lps'),
	(375911, 102, '2015-02-01 00:04:59.000000', 'consum', 0.0221, 'lps'),
	(375912, 102, '2015-02-01 00:05:00.000000', 'consum', 0.0232, 'lps'),
	(375913, 102, '2015-02-01 00:05:01.000000', 'consum', 0.0221, 'lps'),
	(375914, 102, '2015-02-01 00:05:02.000000', 'consum', 0.0219, 'lps'),
	(375915, 102, '2015-02-01 00:05:03.000000', 'consum', 0.0225, 'lps'),
	(375916, 102, '2015-02-01 00:05:04.000000', 'consum', 0.0212, 'lps'),
	(375917, 102, '2015-02-01 00:05:05.000000', 'consum', 0.0222, 'lps'),
	(375918, 102, '2015-02-01 00:05:06.000000', 'consum', 0.0216, 'lps'),
	(375919, 102, '2015-02-01 00:05:07.000000', 'consum', 0.0229, 'lps'),
	(375920, 102, '2015-02-01 00:05:08.000000', 'consum', 0.0217, 'lps'),
	(375921, 102, '2015-02-01 00:05:09.000000', 'consum', 0.0214, 'lps'),
	(375922, 102, '2015-02-01 00:05:10.000000', 'consum', 0.0229, 'lps'),
	(375923, 102, '2015-02-01 00:05:11.000000', 'consum', 0.0228, 'lps'),
	(375924, 102, '2015-02-01 00:05:12.000000', 'consum', 0.0218, 'lps'),
	(375925, 102, '2015-02-01 00:05:13.000000', 'consum', 0.0221, 'lps'),
	(375926, 102, '2015-02-01 00:05:14.000000', 'consum', 0.0220, 'lps'),
	(375927, 102, '2015-02-01 00:05:15.000000', 'consum', 0.0225, 'lps'),
	(375928, 102, '2015-02-01 00:05:16.000000', 'consum', 0.0232, 'lps'),
	(375929, 102, '2015-02-01 00:05:17.000000', 'consum', 0.0232, 'lps'),
	(375930, 102, '2015-02-01 00:05:18.000000', 'consum', 0.0232, 'lps'),
	(375931, 102, '2015-02-01 00:05:19.000000', 'consum', 0.0230, 'lps'),
	(375932, 102, '2015-02-01 00:05:20.000000', 'consum', 0.0223, 'lps'),
	(375933, 102, '2015-02-01 00:05:21.000000', 'consum', 0.0214, 'lps'),
	(375934, 102, '2015-02-01 00:05:22.000000', 'consum', 0.0213, 'lps'),
	(375935, 102, '2015-02-01 00:05:23.000000', 'consum', 0.0216, 'lps'),
	(375936, 102, '2015-02-01 00:05:24.000000', 'consum', 0.0230, 'lps'),
	(375937, 102, '2015-02-01 00:05:25.000000', 'consum', 0.0225, 'lps'),
	(375938, 102, '2015-02-01 00:05:26.000000', 'consum', 0.0225, 'lps'),
	(375939, 102, '2015-02-01 00:05:27.000000', 'consum', 0.0216, 'lps'),
	(375940, 102, '2015-02-01 00:05:28.000000', 'consum', 0.0219, 'lps'),
	(375941, 102, '2015-02-01 00:05:29.000000', 'consum', 0.0216, 'lps'),
	(375942, 102, '2015-02-01 00:05:30.000000', 'consum', 0.0212, 'lps'),
	(375943, 102, '2015-02-01 00:05:31.000000', 'consum', 0.0227, 'lps'),
	(375944, 102, '2015-02-01 00:05:32.000000', 'consum', 0.0218, 'lps'),
	(375945, 102, '2015-02-01 00:05:33.000000', 'consum', 0.0222, 'lps'),
	(375946, 102, '2015-02-01 00:05:34.000000', 'consum', 0.0225, 'lps'),
	(375947, 102, '2015-02-01 00:05:35.000000', 'consum', 0.0228, 'lps'),
	(375948, 102, '2015-02-01 00:05:36.000000', 'consum', 0.0231, 'lps'),
	(375949, 102, '2015-02-01 00:05:37.000000', 'consum', 0.0217, 'lps'),
	(375950, 102, '2015-02-01 00:05:38.000000', 'consum', 0.0229, 'lps'),
	(375951, 102, '2015-02-01 00:05:39.000000', 'consum', 0.0213, 'lps'),
	(375952, 102, '2015-02-01 00:05:40.000000', 'consum', 0.0215, 'lps'),
	(375953, 102, '2015-02-01 00:05:41.000000', 'consum', 0.0227, 'lps'),
	(375954, 102, '2015-02-01 00:05:42.000000', 'consum', 0.0213, 'lps'),
	(375955, 102, '2015-02-01 00:05:43.000000', 'consum', 0.0218, 'lps'),
	(375956, 102, '2015-02-01 00:05:44.000000', 'consum', 0.0219, 'lps'),
	(375957, 102, '2015-02-01 00:05:45.000000', 'consum', 0.0210, 'lps'),
	(375958, 102, '2015-02-01 00:05:46.000000', 'consum', 0.0230, 'lps'),
	(375959, 102, '2015-02-01 00:05:47.000000', 'consum', 0.0219, 'lps'),
	(375960, 102, '2015-02-01 00:05:48.000000', 'consum', 0.0217, 'lps'),
	(375961, 102, '2015-02-01 00:05:49.000000', 'consum', 0.0217, 'lps'),
	(375962, 102, '2015-02-01 00:05:50.000000', 'consum', 0.0225, 'lps'),
	(375963, 102, '2015-02-01 00:05:51.000000', 'consum', 0.0219, 'lps'),
	(375964, 102, '2015-02-01 00:05:52.000000', 'consum', 0.0211, 'lps'),
	(375965, 102, '2015-02-01 00:05:53.000000', 'consum', 0.0212, 'lps'),
	(375966, 102, '2015-02-01 00:05:54.000000', 'consum', 0.0215, 'lps'),
	(375967, 102, '2015-02-01 00:05:55.000000', 'consum', 0.0231, 'lps'),
	(375968, 102, '2015-02-01 00:05:56.000000', 'consum', 0.0230, 'lps'),
	(375969, 102, '2015-02-01 00:05:57.000000', 'consum', 0.0223, 'lps'),
	(375970, 102, '2015-02-01 00:05:58.000000', 'consum', 0.0219, 'lps'),
	(375971, 102, '2015-02-01 00:05:59.000000', 'consum', 0.0215, 'lps'),
	(375972, 102, '2015-02-01 00:06:00.000000', 'consum', 0.0232, 'lps'),
	(375973, 102, '2015-02-01 00:06:01.000000', 'consum', 0.0214, 'lps'),
	(375974, 102, '2015-02-01 00:06:02.000000', 'consum', 0.0210, 'lps'),
	(375975, 102, '2015-02-01 00:06:03.000000', 'consum', 0.0221, 'lps'),
	(375976, 102, '2015-02-01 00:06:04.000000', 'consum', 0.0221, 'lps'),
	(375977, 102, '2015-02-01 00:06:05.000000', 'consum', 0.0232, 'lps'),
	(375978, 102, '2015-02-01 00:06:06.000000', 'consum', 0.0218, 'lps'),
	(375979, 102, '2015-02-01 00:06:07.000000', 'consum', 0.0229, 'lps'),
	(375980, 102, '2015-02-01 00:06:08.000000', 'consum', 0.0215, 'lps'),
	(375981, 102, '2015-02-01 00:06:09.000000', 'consum', 0.0222, 'lps'),
	(375982, 102, '2015-02-01 00:06:10.000000', 'consum', 0.0210, 'lps'),
	(375983, 102, '2015-02-01 00:06:11.000000', 'consum', 0.0219, 'lps'),
	(375984, 102, '2015-02-01 00:06:12.000000', 'consum', 0.0213, 'lps'),
	(375985, 102, '2015-02-01 00:06:13.000000', 'consum', 0.0218, 'lps'),
	(375986, 102, '2015-02-01 00:06:14.000000', 'consum', 0.0222, 'lps'),
	(375987, 102, '2015-02-01 00:06:15.000000', 'consum', 0.0220, 'lps'),
	(375988, 102, '2015-02-01 00:06:16.000000', 'consum', 0.0226, 'lps'),
	(375989, 102, '2015-02-01 00:06:17.000000', 'consum', 0.0213, 'lps'),
	(375990, 102, '2015-02-01 00:06:18.000000', 'consum', 0.0225, 'lps'),
	(375991, 102, '2015-02-01 00:06:19.000000', 'consum', 0.0230, 'lps'),
	(375992, 102, '2015-02-01 00:06:20.000000', 'consum', 0.0220, 'lps'),
	(375993, 102, '2015-02-01 00:06:21.000000', 'consum', 0.0224, 'lps'),
	(375994, 102, '2015-02-01 00:06:22.000000', 'consum', 0.0227, 'lps'),
	(375995, 102, '2015-02-01 00:06:23.000000', 'consum', 0.0230, 'lps'),
	(375996, 102, '2015-02-01 00:06:24.000000', 'consum', 0.0212, 'lps'),
	(375997, 102, '2015-02-01 00:06:25.000000', 'consum', 0.0232, 'lps'),
	(375998, 102, '2015-02-01 00:06:26.000000', 'consum', 0.0223, 'lps'),
	(375999, 102, '2015-02-01 00:06:27.000000', 'consum', 0.0232, 'lps'),
	(376000, 102, '2015-02-01 00:06:28.000000', 'consum', 0.0214, 'lps'),
	(376001, 102, '2015-02-01 00:06:29.000000', 'consum', 0.0210, 'lps'),
	(376002, 102, '2015-02-01 00:06:30.000000', 'consum', 0.0219, 'lps'),
	(376003, 102, '2015-02-01 00:06:31.000000', 'consum', 0.0211, 'lps'),
	(376004, 102, '2015-02-01 00:06:32.000000', 'consum', 0.0213, 'lps'),
	(376005, 102, '2015-02-01 00:06:33.000000', 'consum', 0.0221, 'lps'),
	(376006, 102, '2015-02-01 00:06:34.000000', 'consum', 0.0212, 'lps'),
	(376007, 102, '2015-02-01 00:06:35.000000', 'consum', 0.0210, 'lps'),
	(376008, 102, '2015-02-01 00:06:36.000000', 'consum', 0.0225, 'lps'),
	(376009, 102, '2015-02-01 00:06:37.000000', 'consum', 0.0220, 'lps'),
	(376010, 102, '2015-02-01 00:06:38.000000', 'consum', 0.0214, 'lps'),
	(376011, 102, '2015-02-01 00:06:39.000000', 'consum', 0.0225, 'lps'),
	(376012, 102, '2015-02-01 00:06:40.000000', 'consum', 0.0225, 'lps'),
	(376013, 102, '2015-02-01 00:06:41.000000', 'consum', 0.0218, 'lps'),
	(376014, 102, '2015-02-01 00:06:42.000000', 'consum', 0.0228, 'lps'),
	(376015, 102, '2015-02-01 00:06:43.000000', 'consum', 0.0210, 'lps'),
	(376016, 102, '2015-02-01 00:06:44.000000', 'consum', 0.0225, 'lps'),
	(376017, 102, '2015-02-01 00:06:45.000000', 'consum', 0.0214, 'lps'),
	(376018, 102, '2015-02-01 00:06:46.000000', 'consum', 0.0211, 'lps'),
	(376019, 102, '2015-02-01 00:06:47.000000', 'consum', 0.0227, 'lps'),
	(376020, 102, '2015-02-01 00:06:48.000000', 'consum', 0.0224, 'lps'),
	(376021, 102, '2015-02-01 00:06:49.000000', 'consum', 0.0227, 'lps'),
	(376022, 102, '2015-02-01 00:06:50.000000', 'consum', 0.0210, 'lps'),
	(376023, 102, '2015-02-01 00:06:51.000000', 'consum', 0.0229, 'lps'),
	(376024, 102, '2015-02-01 00:06:52.000000', 'consum', 0.0212, 'lps'),
	(376025, 102, '2015-02-01 00:06:53.000000', 'consum', 0.0231, 'lps'),
	(376026, 102, '2015-02-01 00:06:54.000000', 'consum', 0.0218, 'lps'),
	(376027, 102, '2015-02-01 00:06:55.000000', 'consum', 0.0213, 'lps'),
	(376028, 102, '2015-02-01 00:06:56.000000', 'consum', 0.0223, 'lps'),
	(376029, 102, '2015-02-01 00:06:57.000000', 'consum', 0.0220, 'lps'),
	(376030, 102, '2015-02-01 00:06:58.000000', 'consum', 0.0222, 'lps'),
	(376031, 102, '2015-02-01 00:06:59.000000', 'consum', 0.0218, 'lps'),
	(376032, 102, '2015-02-01 00:07:00.000000', 'consum', 0.0214, 'lps'),
	(376033, 102, '2015-02-01 00:07:01.000000', 'consum', 0.0229, 'lps'),
	(376034, 102, '2015-02-01 00:07:02.000000', 'consum', 0.0225, 'lps'),
	(376035, 102, '2015-02-01 00:07:03.000000', 'consum', 0.0229, 'lps'),
	(376036, 102, '2015-02-01 00:07:04.000000', 'consum', 0.0213, 'lps'),
	(376037, 102, '2015-02-01 00:07:05.000000', 'consum', 0.0215, 'lps'),
	(376038, 102, '2015-02-01 00:07:06.000000', 'consum', 0.0225, 'lps'),
	(376039, 102, '2015-02-01 00:07:07.000000', 'consum', 0.0224, 'lps'),
	(376040, 102, '2015-02-01 00:07:08.000000', 'consum', 0.0216, 'lps'),
	(376041, 102, '2015-02-01 00:07:09.000000', 'consum', 0.0218, 'lps'),
	(376042, 102, '2015-02-01 00:07:10.000000', 'consum', 0.0212, 'lps'),
	(376043, 102, '2015-02-01 00:07:11.000000', 'consum', 0.0219, 'lps'),
	(376044, 102, '2015-02-01 00:07:12.000000', 'consum', 0.0224, 'lps'),
	(376045, 102, '2015-02-01 00:07:13.000000', 'consum', 0.0210, 'lps'),
	(376046, 102, '2015-02-01 00:07:14.000000', 'consum', 0.0215, 'lps'),
	(376047, 102, '2015-02-01 00:07:15.000000', 'consum', 0.0213, 'lps'),
	(376048, 102, '2015-02-01 00:07:16.000000', 'consum', 0.0231, 'lps'),
	(376049, 102, '2015-02-01 00:07:17.000000', 'consum', 0.0216, 'lps'),
	(376050, 102, '2015-02-01 00:07:18.000000', 'consum', 0.0225, 'lps'),
	(376051, 102, '2015-02-01 00:07:19.000000', 'consum', 0.0221, 'lps'),
	(376052, 102, '2015-02-01 00:07:20.000000', 'consum', 0.0218, 'lps'),
	(376053, 102, '2015-02-01 00:07:21.000000', 'consum', 0.0219, 'lps'),
	(376054, 102, '2015-02-01 00:07:22.000000', 'consum', 0.0232, 'lps'),
	(376055, 102, '2015-02-01 00:07:23.000000', 'consum', 0.0223, 'lps'),
	(376056, 102, '2015-02-01 00:07:24.000000', 'consum', 0.0232, 'lps'),
	(376057, 102, '2015-02-01 00:07:25.000000', 'consum', 0.0214, 'lps'),
	(376058, 102, '2015-02-01 00:07:26.000000', 'consum', 0.0211, 'lps'),
	(376059, 102, '2015-02-01 00:07:27.000000', 'consum', 0.0224, 'lps'),
	(376060, 102, '2015-02-01 00:07:28.000000', 'consum', 0.0211, 'lps'),
	(376061, 102, '2015-02-01 00:07:29.000000', 'consum', 0.0218, 'lps'),
	(376062, 102, '2015-02-01 00:07:30.000000', 'consum', 0.0224, 'lps'),
	(376063, 102, '2015-02-01 00:07:31.000000', 'consum', 0.0211, 'lps'),
	(376064, 102, '2015-02-01 00:07:32.000000', 'consum', 0.0218, 'lps'),
	(376065, 102, '2015-02-01 00:07:33.000000', 'consum', 0.0226, 'lps'),
	(376066, 102, '2015-02-01 00:07:34.000000', 'consum', 0.0219, 'lps'),
	(376067, 102, '2015-02-01 00:07:35.000000', 'consum', 0.0210, 'lps'),
	(376068, 102, '2015-02-01 00:07:36.000000', 'consum', 0.0230, 'lps'),
	(376069, 102, '2015-02-01 00:07:37.000000', 'consum', 0.0219, 'lps'),
	(376070, 102, '2015-02-01 00:07:38.000000', 'consum', 0.0217, 'lps'),
	(376071, 102, '2015-02-01 00:07:39.000000', 'consum', 0.0218, 'lps'),
	(376072, 102, '2015-02-01 00:07:40.000000', 'consum', 0.0232, 'lps'),
	(376073, 102, '2015-02-01 00:07:41.000000', 'consum', 0.0225, 'lps'),
	(376074, 102, '2015-02-01 00:07:42.000000', 'consum', 0.0220, 'lps'),
	(376075, 102, '2015-02-01 00:07:43.000000', 'consum', 0.0216, 'lps'),
	(376076, 102, '2015-02-01 00:07:44.000000', 'consum', 0.0232, 'lps'),
	(376077, 102, '2015-02-01 00:07:45.000000', 'consum', 0.0210, 'lps'),
	(376078, 102, '2015-02-01 00:07:46.000000', 'consum', 0.0215, 'lps'),
	(376079, 102, '2015-02-01 00:07:47.000000', 'consum', 0.0213, 'lps'),
	(376080, 102, '2015-02-01 00:07:48.000000', 'consum', 0.0210, 'lps'),
	(376081, 102, '2015-02-01 00:07:49.000000', 'consum', 0.0225, 'lps'),
	(376082, 102, '2015-02-01 00:07:50.000000', 'consum', 0.0216, 'lps'),
	(376083, 102, '2015-02-01 00:07:51.000000', 'consum', 0.0219, 'lps'),
	(376084, 102, '2015-02-01 00:07:52.000000', 'consum', 0.0216, 'lps'),
	(376085, 102, '2015-02-01 00:07:53.000000', 'consum', 0.0211, 'lps'),
	(376086, 102, '2015-02-01 00:07:54.000000', 'consum', 0.0223, 'lps'),
	(376087, 102, '2015-02-01 00:07:55.000000', 'consum', 0.0227, 'lps'),
	(376088, 102, '2015-02-01 00:07:56.000000', 'consum', 0.0231, 'lps'),
	(376089, 102, '2015-02-01 00:07:57.000000', 'consum', 0.0218, 'lps'),
	(376090, 102, '2015-02-01 00:07:58.000000', 'consum', 0.0211, 'lps'),
	(376091, 102, '2015-02-01 00:07:59.000000', 'consum', 0.0214, 'lps'),
	(376092, 102, '2015-02-01 00:08:00.000000', 'consum', 0.0226, 'lps'),
	(376093, 102, '2015-02-01 00:08:01.000000', 'consum', 0.0213, 'lps'),
	(376094, 102, '2015-02-01 00:08:02.000000', 'consum', 0.0221, 'lps'),
	(376095, 102, '2015-02-01 00:08:03.000000', 'consum', 0.0212, 'lps'),
	(376096, 102, '2015-02-01 00:08:04.000000', 'consum', 0.0232, 'lps'),
	(376097, 102, '2015-02-01 00:08:05.000000', 'consum', 0.0225, 'lps'),
	(376098, 102, '2015-02-01 00:08:06.000000', 'consum', 0.0219, 'lps'),
	(376099, 102, '2015-02-01 00:08:07.000000', 'consum', 0.0210, 'lps'),
	(376100, 102, '2015-02-01 00:08:08.000000', 'consum', 0.0229, 'lps'),
	(376101, 102, '2015-02-01 00:08:09.000000', 'consum', 0.0216, 'lps'),
	(376102, 102, '2015-02-01 00:08:10.000000', 'consum', 0.0227, 'lps'),
	(376103, 102, '2015-02-01 00:08:11.000000', 'consum', 0.0211, 'lps'),
	(376104, 102, '2015-02-01 00:08:12.000000', 'consum', 0.0231, 'lps'),
	(376105, 102, '2015-02-01 00:08:13.000000', 'consum', 0.0222, 'lps'),
	(376106, 102, '2015-02-01 00:08:14.000000', 'consum', 0.0230, 'lps'),
	(376107, 102, '2015-02-01 00:08:15.000000', 'consum', 0.0228, 'lps'),
	(376108, 102, '2015-02-01 00:08:16.000000', 'consum', 0.0219, 'lps'),
	(376109, 102, '2015-02-01 00:08:17.000000', 'consum', 0.0225, 'lps'),
	(376110, 102, '2015-02-01 00:08:18.000000', 'consum', 0.0212, 'lps'),
	(376111, 102, '2015-02-01 00:08:19.000000', 'consum', 0.0221, 'lps'),
	(376112, 102, '2015-02-01 00:08:20.000000', 'consum', 0.0212, 'lps'),
	(376113, 102, '2015-02-01 00:08:21.000000', 'consum', 0.0213, 'lps'),
	(376114, 102, '2015-02-01 00:08:22.000000', 'consum', 0.0220, 'lps'),
	(376115, 102, '2015-02-01 00:08:23.000000', 'consum', 0.0228, 'lps'),
	(376116, 102, '2015-02-01 00:08:24.000000', 'consum', 0.0224, 'lps'),
	(376117, 102, '2015-02-01 00:08:25.000000', 'consum', 0.0226, 'lps'),
	(376118, 102, '2015-02-01 00:08:26.000000', 'consum', 0.0224, 'lps'),
	(376119, 102, '2015-02-01 00:08:27.000000', 'consum', 0.0210, 'lps'),
	(376120, 102, '2015-02-01 00:08:28.000000', 'consum', 0.0216, 'lps'),
	(376121, 102, '2015-02-01 00:08:29.000000', 'consum', 0.0219, 'lps'),
	(376122, 102, '2015-02-01 00:08:30.000000', 'consum', 0.0213, 'lps'),
	(376123, 102, '2015-02-01 00:08:31.000000', 'consum', 0.0221, 'lps'),
	(376124, 102, '2015-02-01 00:08:32.000000', 'consum', 0.0211, 'lps'),
	(376125, 102, '2015-02-01 00:08:33.000000', 'consum', 0.0229, 'lps'),
	(376126, 102, '2015-02-01 00:08:34.000000', 'consum', 0.0232, 'lps'),
	(376127, 102, '2015-02-01 00:08:35.000000', 'consum', 0.0220, 'lps'),
	(376128, 102, '2015-02-01 00:08:36.000000', 'consum', 0.0215, 'lps'),
	(376129, 102, '2015-02-01 00:08:37.000000', 'consum', 0.0230, 'lps'),
	(376130, 102, '2015-02-01 00:08:38.000000', 'consum', 0.0226, 'lps'),
	(376131, 102, '2015-02-01 00:08:39.000000', 'consum', 0.0231, 'lps'),
	(376132, 102, '2015-02-01 00:08:40.000000', 'consum', 0.0219, 'lps'),
	(376133, 102, '2015-02-01 00:08:41.000000', 'consum', 0.0218, 'lps'),
	(376134, 102, '2015-02-01 00:08:42.000000', 'consum', 0.0222, 'lps'),
	(376135, 102, '2015-02-01 00:08:43.000000', 'consum', 0.0222, 'lps'),
	(376136, 102, '2015-02-01 00:08:44.000000', 'consum', 0.0213, 'lps'),
	(376137, 102, '2015-02-01 00:08:45.000000', 'consum', 0.0214, 'lps'),
	(376138, 102, '2015-02-01 00:08:46.000000', 'consum', 0.0223, 'lps'),
	(376139, 102, '2015-02-01 00:08:47.000000', 'consum', 0.0214, 'lps'),
	(376140, 102, '2015-02-01 00:08:48.000000', 'consum', 0.0214, 'lps'),
	(376141, 102, '2015-02-01 00:08:49.000000', 'consum', 0.0219, 'lps'),
	(376142, 102, '2015-02-01 00:08:50.000000', 'consum', 0.0222, 'lps'),
	(376143, 102, '2015-02-01 00:08:51.000000', 'consum', 0.0218, 'lps'),
	(376144, 102, '2015-02-01 00:08:52.000000', 'consum', 0.0217, 'lps'),
	(376145, 102, '2015-02-01 00:08:53.000000', 'consum', 0.0220, 'lps'),
	(376146, 102, '2015-02-01 00:08:54.000000', 'consum', 0.0216, 'lps'),
	(376147, 102, '2015-02-01 00:08:55.000000', 'consum', 0.0213, 'lps'),
	(376148, 102, '2015-02-01 00:08:56.000000', 'consum', 0.0228, 'lps'),
	(376149, 102, '2015-02-01 00:08:57.000000', 'consum', 0.0222, 'lps'),
	(376150, 102, '2015-02-01 00:08:58.000000', 'consum', 0.0218, 'lps'),
	(376151, 102, '2015-02-01 00:08:59.000000', 'consum', 0.0216, 'lps'),
	(376152, 102, '2015-02-01 00:09:00.000000', 'consum', 0.0214, 'lps'),
	(376153, 102, '2015-02-01 00:09:01.000000', 'consum', 0.0213, 'lps'),
	(376154, 102, '2015-02-01 00:09:02.000000', 'consum', 0.0215, 'lps'),
	(376155, 102, '2015-02-01 00:09:03.000000', 'consum', 0.0225, 'lps'),
	(376156, 102, '2015-02-01 00:09:04.000000', 'consum', 0.0226, 'lps'),
	(376157, 102, '2015-02-01 00:09:05.000000', 'consum', 0.0222, 'lps'),
	(376158, 102, '2015-02-01 00:09:06.000000', 'consum', 0.0221, 'lps'),
	(376159, 102, '2015-02-01 00:09:07.000000', 'consum', 0.0228, 'lps'),
	(376160, 102, '2015-02-01 00:09:08.000000', 'consum', 0.0224, 'lps'),
	(376161, 102, '2015-02-01 00:09:09.000000', 'consum', 0.0228, 'lps'),
	(376162, 102, '2015-02-01 00:09:10.000000', 'consum', 0.0210, 'lps'),
	(376163, 102, '2015-02-01 00:09:11.000000', 'consum', 0.0226, 'lps'),
	(376164, 102, '2015-02-01 00:09:12.000000', 'consum', 0.0223, 'lps'),
	(376165, 102, '2015-02-01 00:09:13.000000', 'consum', 0.0225, 'lps'),
	(376166, 102, '2015-02-01 00:09:14.000000', 'consum', 0.0226, 'lps'),
	(376167, 102, '2015-02-01 00:09:15.000000', 'consum', 0.0224, 'lps'),
	(376168, 102, '2015-02-01 00:09:16.000000', 'consum', 0.0229, 'lps'),
	(376169, 102, '2015-02-01 00:09:17.000000', 'consum', 0.0218, 'lps'),
	(376170, 102, '2015-02-01 00:09:18.000000', 'consum', 0.0219, 'lps'),
	(376171, 102, '2015-02-01 00:09:19.000000', 'consum', 0.0229, 'lps'),
	(376172, 102, '2015-02-01 00:09:20.000000', 'consum', 0.0212, 'lps'),
	(376173, 102, '2015-02-01 00:09:21.000000', 'consum', 0.0210, 'lps'),
	(376174, 102, '2015-02-01 00:09:22.000000', 'consum', 0.0225, 'lps'),
	(376175, 102, '2015-02-01 00:09:23.000000', 'consum', 0.0218, 'lps'),
	(376176, 102, '2015-02-01 00:09:24.000000', 'consum', 0.0226, 'lps'),
	(376177, 102, '2015-02-01 00:09:25.000000', 'consum', 0.0224, 'lps'),
	(376178, 102, '2015-02-01 00:09:26.000000', 'consum', 0.0230, 'lps'),
	(376179, 102, '2015-02-01 00:09:27.000000', 'consum', 0.0223, 'lps'),
	(376180, 102, '2015-02-01 00:09:28.000000', 'consum', 0.0217, 'lps'),
	(376181, 102, '2015-02-01 00:09:29.000000', 'consum', 0.0228, 'lps'),
	(376182, 102, '2015-02-01 00:09:30.000000', 'consum', 0.0213, 'lps'),
	(376183, 102, '2015-02-01 00:09:31.000000', 'consum', 0.0215, 'lps'),
	(376184, 102, '2015-02-01 00:09:32.000000', 'consum', 0.0226, 'lps'),
	(376185, 102, '2015-02-01 00:09:33.000000', 'consum', 0.0231, 'lps'),
	(376186, 102, '2015-02-01 00:09:34.000000', 'consum', 0.0222, 'lps'),
	(376187, 102, '2015-02-01 00:09:35.000000', 'consum', 0.0229, 'lps'),
	(376188, 102, '2015-02-01 00:09:36.000000', 'consum', 0.0223, 'lps'),
	(376189, 102, '2015-02-01 00:09:37.000000', 'consum', 0.0217, 'lps'),
	(376190, 102, '2015-02-01 00:09:38.000000', 'consum', 0.0232, 'lps'),
	(376191, 102, '2015-02-01 00:09:39.000000', 'consum', 0.0229, 'lps'),
	(376192, 102, '2015-02-01 00:09:40.000000', 'consum', 0.0217, 'lps'),
	(376193, 102, '2015-02-01 00:09:41.000000', 'consum', 0.0212, 'lps'),
	(376194, 102, '2015-02-01 00:09:42.000000', 'consum', 0.0222, 'lps'),
	(376195, 102, '2015-02-01 00:09:43.000000', 'consum', 0.0219, 'lps'),
	(376196, 102, '2015-02-01 00:09:44.000000', 'consum', 0.0221, 'lps'),
	(376197, 102, '2015-02-01 00:09:45.000000', 'consum', 0.0214, 'lps'),
	(376198, 102, '2015-02-01 00:09:46.000000', 'consum', 0.0221, 'lps'),
	(376199, 102, '2015-02-01 00:09:47.000000', 'consum', 0.0228, 'lps'),
	(376200, 102, '2015-02-01 00:09:48.000000', 'consum', 0.0225, 'lps'),
	(376201, 102, '2015-02-01 00:09:49.000000', 'consum', 0.0228, 'lps'),
	(376202, 102, '2015-02-01 00:09:50.000000', 'consum', 0.0213, 'lps'),
	(376203, 102, '2015-02-01 00:09:51.000000', 'consum', 0.0216, 'lps'),
	(376204, 102, '2015-02-01 00:09:52.000000', 'consum', 0.0231, 'lps'),
	(376205, 102, '2015-02-01 00:09:53.000000', 'consum', 0.0227, 'lps'),
	(376206, 102, '2015-02-01 00:09:54.000000', 'consum', 0.0212, 'lps'),
	(376207, 102, '2015-02-01 00:09:55.000000', 'consum', 0.0215, 'lps'),
	(376208, 102, '2015-02-01 00:09:56.000000', 'consum', 0.0228, 'lps'),
	(376209, 102, '2015-02-01 00:09:57.000000', 'consum', 0.0215, 'lps'),
	(376210, 102, '2015-02-01 00:09:58.000000', 'consum', 0.0231, 'lps'),
	(376211, 102, '2015-02-01 00:09:59.000000', 'consum', 0.0231, 'lps'),
	(376212, 102, '2015-02-01 00:10:00.000000', 'consum', 0.0230, 'lps'),
	(376213, 102, '2015-02-01 00:10:01.000000', 'consum', 0.0224, 'lps'),
	(376214, 102, '2015-02-01 00:10:02.000000', 'consum', 0.0220, 'lps'),
	(376215, 102, '2015-02-01 00:10:03.000000', 'consum', 0.0221, 'lps'),
	(376216, 102, '2015-02-01 00:10:04.000000', 'consum', 0.0210, 'lps'),
	(376217, 102, '2015-02-01 00:10:05.000000', 'consum', 0.0224, 'lps'),
	(376218, 102, '2015-02-01 00:10:06.000000', 'consum', 0.0211, 'lps'),
	(376219, 102, '2015-02-01 00:10:07.000000', 'consum', 0.0219, 'lps'),
	(376220, 102, '2015-02-01 00:10:08.000000', 'consum', 0.0232, 'lps'),
	(376221, 102, '2015-02-01 00:10:09.000000', 'consum', 0.0223, 'lps'),
	(376222, 102, '2015-02-01 00:10:10.000000', 'consum', 0.0232, 'lps'),
	(376223, 102, '2015-02-01 00:10:11.000000', 'consum', 0.0215, 'lps'),
	(376224, 102, '2015-02-01 00:10:12.000000', 'consum', 0.0212, 'lps'),
	(376225, 102, '2015-02-01 00:10:13.000000', 'consum', 0.0230, 'lps'),
	(376226, 102, '2015-02-01 00:10:14.000000', 'consum', 0.0214, 'lps'),
	(376227, 102, '2015-02-01 00:10:15.000000', 'consum', 0.0214, 'lps'),
	(376228, 102, '2015-02-01 00:10:16.000000', 'consum', 0.0218, 'lps'),
	(376229, 102, '2015-02-01 00:10:17.000000', 'consum', 0.0218, 'lps'),
	(376230, 102, '2015-02-01 00:10:18.000000', 'consum', 0.0225, 'lps'),
	(376231, 102, '2015-02-01 00:10:19.000000', 'consum', 0.0216, 'lps'),
	(376232, 102, '2015-02-01 00:10:20.000000', 'consum', 0.0218, 'lps'),
	(376233, 102, '2015-02-01 00:10:21.000000', 'consum', 0.0232, 'lps'),
	(376234, 102, '2015-02-01 00:10:22.000000', 'consum', 0.0230, 'lps'),
	(376235, 102, '2015-02-01 00:10:23.000000', 'consum', 0.0220, 'lps'),
	(376236, 102, '2015-02-01 00:10:24.000000', 'consum', 0.0222, 'lps'),
	(376237, 102, '2015-02-01 00:10:25.000000', 'consum', 0.0217, 'lps'),
	(376238, 102, '2015-02-01 00:10:26.000000', 'consum', 0.0211, 'lps'),
	(376239, 102, '2015-02-01 00:10:27.000000', 'consum', 0.0217, 'lps'),
	(376240, 102, '2015-02-01 00:10:28.000000', 'consum', 0.0219, 'lps'),
	(376241, 102, '2015-02-01 00:10:29.000000', 'consum', 0.0212, 'lps'),
	(376242, 102, '2015-02-01 00:10:30.000000', 'consum', 0.0215, 'lps'),
	(376243, 102, '2015-02-01 00:10:31.000000', 'consum', 0.0231, 'lps'),
	(376244, 102, '2015-02-01 00:10:32.000000', 'consum', 0.0232, 'lps'),
	(376245, 102, '2015-02-01 00:10:33.000000', 'consum', 0.0212, 'lps'),
	(376246, 102, '2015-02-01 00:10:34.000000', 'consum', 0.0223, 'lps'),
	(376247, 102, '2015-02-01 00:10:35.000000', 'consum', 0.0223, 'lps'),
	(376248, 102, '2015-02-01 00:10:36.000000', 'consum', 0.0215, 'lps'),
	(376249, 102, '2015-02-01 00:10:37.000000', 'consum', 0.0217, 'lps'),
	(376250, 102, '2015-02-01 00:10:38.000000', 'consum', 0.0232, 'lps'),
	(376251, 102, '2015-02-01 00:10:39.000000', 'consum', 0.0230, 'lps'),
	(376252, 102, '2015-02-01 00:10:40.000000', 'consum', 0.0220, 'lps'),
	(376253, 102, '2015-02-01 00:10:41.000000', 'consum', 0.0223, 'lps'),
	(376254, 102, '2015-02-01 00:10:42.000000', 'consum', 0.0224, 'lps'),
	(376255, 102, '2015-02-01 00:10:43.000000', 'consum', 0.0220, 'lps'),
	(376256, 102, '2015-02-01 00:10:44.000000', 'consum', 0.0216, 'lps'),
	(376257, 102, '2015-02-01 00:10:45.000000', 'consum', 0.0213, 'lps'),
	(376258, 102, '2015-02-01 00:10:46.000000', 'consum', 0.0228, 'lps'),
	(376259, 102, '2015-02-01 00:10:47.000000', 'consum', 0.0225, 'lps'),
	(376260, 102, '2015-02-01 00:10:48.000000', 'consum', 0.0232, 'lps'),
	(376261, 102, '2015-02-01 00:10:49.000000', 'consum', 0.0229, 'lps'),
	(376262, 102, '2015-02-01 00:10:50.000000', 'consum', 0.0216, 'lps'),
	(376263, 102, '2015-02-01 00:10:51.000000', 'consum', 0.0230, 'lps'),
	(376264, 102, '2015-02-01 00:10:52.000000', 'consum', 0.0224, 'lps'),
	(376265, 102, '2015-02-01 00:10:53.000000', 'consum', 0.0218, 'lps'),
	(376266, 102, '2015-02-01 00:10:54.000000', 'consum', 0.0210, 'lps'),
	(376267, 102, '2015-02-01 00:10:55.000000', 'consum', 0.0211, 'lps'),
	(376268, 102, '2015-02-01 00:10:56.000000', 'consum', 0.0215, 'lps'),
	(376269, 102, '2015-02-01 00:10:57.000000', 'consum', 0.0232, 'lps'),
	(376270, 102, '2015-02-01 00:10:58.000000', 'consum', 0.0214, 'lps'),
	(376271, 102, '2015-02-01 00:10:59.000000', 'consum', 0.0232, 'lps'),
	(376272, 102, '2015-02-01 00:11:00.000000', 'consum', 0.0218, 'lps'),
	(376273, 102, '2015-02-01 00:11:01.000000', 'consum', 0.0228, 'lps'),
	(376274, 102, '2015-02-01 00:11:02.000000', 'consum', 0.0211, 'lps'),
	(376275, 102, '2015-02-01 00:11:03.000000', 'consum', 0.0228, 'lps'),
	(376276, 102, '2015-02-01 00:11:04.000000', 'consum', 0.0229, 'lps'),
	(376277, 102, '2015-02-01 00:11:05.000000', 'consum', 0.0228, 'lps'),
	(376278, 102, '2015-02-01 00:11:06.000000', 'consum', 0.0220, 'lps'),
	(376279, 102, '2015-02-01 00:11:07.000000', 'consum', 0.0228, 'lps'),
	(376280, 102, '2015-02-01 00:11:08.000000', 'consum', 0.0227, 'lps'),
	(376281, 102, '2015-02-01 00:11:09.000000', 'consum', 0.0217, 'lps'),
	(376282, 102, '2015-02-01 00:11:10.000000', 'consum', 0.0217, 'lps'),
	(376283, 102, '2015-02-01 00:11:11.000000', 'consum', 0.0227, 'lps'),
	(376284, 102, '2015-02-01 00:11:12.000000', 'consum', 0.0227, 'lps'),
	(376285, 102, '2015-02-01 00:11:13.000000', 'consum', 0.0223, 'lps'),
	(376286, 102, '2015-02-01 00:11:14.000000', 'consum', 0.0222, 'lps'),
	(376287, 102, '2015-02-01 00:11:15.000000', 'consum', 0.0231, 'lps'),
	(376288, 102, '2015-02-01 00:11:16.000000', 'consum', 0.0212, 'lps'),
	(376289, 102, '2015-02-01 00:11:17.000000', 'consum', 0.0227, 'lps'),
	(376290, 102, '2015-02-01 00:11:18.000000', 'consum', 0.0218, 'lps'),
	(376291, 102, '2015-02-01 00:11:19.000000', 'consum', 0.0226, 'lps'),
	(376292, 102, '2015-02-01 00:11:20.000000', 'consum', 0.0218, 'lps'),
	(376293, 102, '2015-02-01 00:11:21.000000', 'consum', 0.0226, 'lps'),
	(376294, 102, '2015-02-01 00:11:22.000000', 'consum', 0.0219, 'lps'),
	(376295, 102, '2015-02-01 00:11:23.000000', 'consum', 0.0232, 'lps'),
	(376296, 102, '2015-02-01 00:11:24.000000', 'consum', 0.0225, 'lps'),
	(376297, 102, '2015-02-01 00:11:25.000000', 'consum', 0.0220, 'lps'),
	(376298, 102, '2015-02-01 00:11:26.000000', 'consum', 0.0216, 'lps'),
	(376299, 102, '2015-02-01 00:11:27.000000', 'consum', 0.0210, 'lps'),
	(376300, 102, '2015-02-01 00:11:28.000000', 'consum', 0.0217, 'lps'),
	(376301, 102, '2015-02-01 00:11:29.000000', 'consum', 0.0221, 'lps'),
	(376302, 102, '2015-02-01 00:11:30.000000', 'consum', 0.0223, 'lps'),
	(376303, 102, '2015-02-01 00:11:31.000000', 'consum', 0.0220, 'lps'),
	(376304, 102, '2015-02-01 00:11:32.000000', 'consum', 0.0219, 'lps'),
	(376305, 102, '2015-02-01 00:11:33.000000', 'consum', 0.0227, 'lps'),
	(376306, 102, '2015-02-01 00:11:34.000000', 'consum', 0.0223, 'lps'),
	(376307, 102, '2015-02-01 00:11:35.000000', 'consum', 0.0222, 'lps'),
	(376308, 102, '2015-02-01 00:11:36.000000', 'consum', 0.0210, 'lps'),
	(376309, 102, '2015-02-01 00:11:37.000000', 'consum', 0.0218, 'lps'),
	(376310, 102, '2015-02-01 00:11:38.000000', 'consum', 0.0230, 'lps'),
	(376311, 102, '2015-02-01 00:11:39.000000', 'consum', 0.0219, 'lps'),
	(376312, 102, '2015-02-01 00:11:40.000000', 'consum', 0.0216, 'lps'),
	(376313, 102, '2015-02-01 00:11:41.000000', 'consum', 0.0216, 'lps'),
	(376314, 102, '2015-02-01 00:11:42.000000', 'consum', 0.0221, 'lps'),
	(376315, 102, '2015-02-01 00:11:43.000000', 'consum', 0.0223, 'lps'),
	(376316, 102, '2015-02-01 00:11:44.000000', 'consum', 0.0219, 'lps'),
	(376317, 102, '2015-02-01 00:11:45.000000', 'consum', 0.0218, 'lps'),
	(376318, 102, '2015-02-01 00:11:46.000000', 'consum', 0.0225, 'lps'),
	(376319, 102, '2015-02-01 00:11:47.000000', 'consum', 0.0212, 'lps'),
	(376320, 102, '2015-02-01 00:11:48.000000', 'consum', 0.0225, 'lps'),
	(376321, 102, '2015-02-01 00:11:49.000000', 'consum', 0.0232, 'lps'),
	(376322, 102, '2015-02-01 00:11:50.000000', 'consum', 0.0231, 'lps'),
	(376323, 102, '2015-02-01 00:11:51.000000', 'consum', 0.0226, 'lps'),
	(376324, 102, '2015-02-01 00:11:52.000000', 'consum', 0.0227, 'lps'),
	(376325, 102, '2015-02-01 00:11:53.000000', 'consum', 0.0225, 'lps'),
	(376326, 102, '2015-02-01 00:11:54.000000', 'consum', 0.0211, 'lps'),
	(376327, 102, '2015-02-01 00:11:55.000000', 'consum', 0.0217, 'lps'),
	(376328, 102, '2015-02-01 00:11:56.000000', 'consum', 0.0220, 'lps'),
	(376329, 102, '2015-02-01 00:11:57.000000', 'consum', 0.0214, 'lps'),
	(376330, 102, '2015-02-01 00:11:58.000000', 'consum', 0.0226, 'lps'),
	(376331, 102, '2015-02-01 00:11:59.000000', 'consum', 0.0230, 'lps'),
	(376332, 102, '2015-02-01 00:12:00.000000', 'consum', 0.0218, 'lps'),
	(376333, 102, '2015-02-01 00:12:01.000000', 'consum', 0.0212, 'lps'),
	(376334, 102, '2015-02-01 00:12:02.000000', 'consum', 0.0220, 'lps'),
	(376335, 102, '2015-02-01 00:12:03.000000', 'consum', 0.0232, 'lps'),
	(376336, 102, '2015-02-01 00:12:04.000000', 'consum', 0.0222, 'lps'),
	(376337, 102, '2015-02-01 00:12:05.000000', 'consum', 0.0229, 'lps'),
	(376338, 102, '2015-02-01 00:12:06.000000', 'consum', 0.0221, 'lps'),
	(376339, 102, '2015-02-01 00:12:07.000000', 'consum', 0.0211, 'lps'),
	(376340, 102, '2015-02-01 00:12:08.000000', 'consum', 0.0226, 'lps'),
	(376341, 102, '2015-02-01 00:12:09.000000', 'consum', 0.0218, 'lps'),
	(376342, 102, '2015-02-01 00:12:10.000000', 'consum', 0.0226, 'lps'),
	(376343, 102, '2015-02-01 00:12:11.000000', 'consum', 0.0222, 'lps'),
	(376344, 102, '2015-02-01 00:12:12.000000', 'consum', 0.0220, 'lps'),
	(376345, 102, '2015-02-01 00:12:13.000000', 'consum', 0.0225, 'lps'),
	(376346, 102, '2015-02-01 00:12:14.000000', 'consum', 0.0232, 'lps'),
	(376347, 102, '2015-02-01 00:12:15.000000', 'consum', 0.0230, 'lps'),
	(376348, 102, '2015-02-01 00:12:16.000000', 'consum', 0.0220, 'lps'),
	(376349, 102, '2015-02-01 00:12:17.000000', 'consum', 0.0226, 'lps'),
	(376350, 102, '2015-02-01 00:12:18.000000', 'consum', 0.0215, 'lps'),
	(376351, 102, '2015-02-01 00:12:19.000000', 'consum', 0.0211, 'lps'),
	(376352, 102, '2015-02-01 00:12:20.000000', 'consum', 0.0222, 'lps'),
	(376353, 102, '2015-02-01 00:12:21.000000', 'consum', 0.0222, 'lps'),
	(376354, 102, '2015-02-01 00:12:22.000000', 'consum', 0.0211, 'lps'),
	(376355, 102, '2015-02-01 00:12:23.000000', 'consum', 0.0226, 'lps'),
	(376356, 102, '2015-02-01 00:12:24.000000', 'consum', 0.0219, 'lps'),
	(376357, 102, '2015-02-01 00:12:25.000000', 'consum', 0.0229, 'lps'),
	(376358, 102, '2015-02-01 00:12:26.000000', 'consum', 0.0211, 'lps'),
	(376359, 102, '2015-02-01 00:12:27.000000', 'consum', 0.0229, 'lps'),
	(376360, 102, '2015-02-01 00:12:28.000000', 'consum', 0.0230, 'lps'),
	(376361, 102, '2015-02-01 00:12:29.000000', 'consum', 0.0210, 'lps'),
	(376362, 102, '2015-02-01 00:12:30.000000', 'consum', 0.0219, 'lps'),
	(376363, 102, '2015-02-01 00:12:31.000000', 'consum', 0.0232, 'lps'),
	(376364, 102, '2015-02-01 00:12:32.000000', 'consum', 0.0224, 'lps'),
	(376365, 102, '2015-02-01 00:12:33.000000', 'consum', 0.0216, 'lps'),
	(376366, 102, '2015-02-01 00:12:34.000000', 'consum', 0.0222, 'lps'),
	(376367, 102, '2015-02-01 00:12:35.000000', 'consum', 0.0227, 'lps'),
	(376368, 102, '2015-02-01 00:12:36.000000', 'consum', 0.0213, 'lps'),
	(376369, 102, '2015-02-01 00:12:37.000000', 'consum', 0.0223, 'lps'),
	(376370, 102, '2015-02-01 00:12:38.000000', 'consum', 0.0220, 'lps'),
	(376371, 102, '2015-02-01 00:12:39.000000', 'consum', 0.0223, 'lps'),
	(376372, 102, '2015-02-01 00:12:40.000000', 'consum', 0.0219, 'lps'),
	(376373, 102, '2015-02-01 00:12:41.000000', 'consum', 0.0219, 'lps'),
	(376374, 102, '2015-02-01 00:12:42.000000', 'consum', 0.0227, 'lps'),
	(376375, 102, '2015-02-01 00:12:43.000000', 'consum', 0.0223, 'lps'),
	(376376, 102, '2015-02-01 00:12:44.000000', 'consum', 0.0226, 'lps'),
	(376377, 102, '2015-02-01 00:12:45.000000', 'consum', 0.0226, 'lps'),
	(376378, 102, '2015-02-01 00:12:46.000000', 'consum', 0.0221, 'lps'),
	(376379, 102, '2015-02-01 00:12:47.000000', 'consum', 0.0218, 'lps'),
	(376380, 102, '2015-02-01 00:12:48.000000', 'consum', 0.0217, 'lps'),
	(376381, 102, '2015-02-01 00:12:49.000000', 'consum', 0.0220, 'lps'),
	(376382, 102, '2015-02-01 00:12:50.000000', 'consum', 0.0216, 'lps'),
	(376383, 102, '2015-02-01 00:12:51.000000', 'consum', 0.0210, 'lps'),
	(376384, 102, '2015-02-01 00:12:52.000000', 'consum', 0.0215, 'lps'),
	(376385, 102, '2015-02-01 00:12:53.000000', 'consum', 0.0214, 'lps'),
	(376386, 102, '2015-02-01 00:12:54.000000', 'consum', 0.0215, 'lps'),
	(376387, 102, '2015-02-01 00:12:55.000000', 'consum', 0.0225, 'lps'),
	(376388, 102, '2015-02-01 00:12:56.000000', 'consum', 0.0224, 'lps'),
	(376389, 102, '2015-02-01 00:12:57.000000', 'consum', 0.0212, 'lps'),
	(376390, 102, '2015-02-01 00:12:58.000000', 'consum', 0.0224, 'lps'),
	(376391, 102, '2015-02-01 00:12:59.000000', 'consum', 0.0230, 'lps'),
	(376392, 102, '2015-02-01 00:13:00.000000', 'consum', 0.0222, 'lps'),
	(376393, 102, '2015-02-01 00:13:01.000000', 'consum', 0.0211, 'lps'),
	(376394, 102, '2015-02-01 00:13:02.000000', 'consum', 0.0226, 'lps'),
	(376395, 102, '2015-02-01 00:13:03.000000', 'consum', 0.0219, 'lps'),
	(376396, 102, '2015-02-01 00:13:04.000000', 'consum', 0.0228, 'lps'),
	(376397, 102, '2015-02-01 00:13:05.000000', 'consum', 0.0227, 'lps'),
	(376398, 102, '2015-02-01 00:13:06.000000', 'consum', 0.0221, 'lps'),
	(376399, 102, '2015-02-01 00:13:07.000000', 'consum', 0.0215, 'lps'),
	(376400, 102, '2015-02-01 00:13:08.000000', 'consum', 0.0223, 'lps'),
	(376401, 102, '2015-02-01 00:13:09.000000', 'consum', 0.0217, 'lps'),
	(376402, 102, '2015-02-01 00:13:10.000000', 'consum', 0.0228, 'lps'),
	(376403, 102, '2015-02-01 00:13:11.000000', 'consum', 0.0232, 'lps'),
	(376404, 102, '2015-02-01 00:13:12.000000', 'consum', 0.0224, 'lps'),
	(376405, 102, '2015-02-01 00:13:13.000000', 'consum', 0.0211, 'lps'),
	(376406, 102, '2015-02-01 00:13:14.000000', 'consum', 0.0222, 'lps'),
	(376407, 102, '2015-02-01 00:13:15.000000', 'consum', 0.0219, 'lps'),
	(376408, 102, '2015-02-01 00:13:16.000000', 'consum', 0.0222, 'lps'),
	(376409, 102, '2015-02-01 00:13:17.000000', 'consum', 0.0221, 'lps'),
	(376410, 102, '2015-02-01 00:13:18.000000', 'consum', 0.0228, 'lps'),
	(376411, 102, '2015-02-01 00:13:19.000000', 'consum', 0.0223, 'lps'),
	(376412, 102, '2015-02-01 00:13:20.000000', 'consum', 0.0220, 'lps'),
	(376413, 102, '2015-02-01 00:13:21.000000', 'consum', 0.0221, 'lps'),
	(376414, 102, '2015-02-01 00:13:22.000000', 'consum', 0.0212, 'lps'),
	(376415, 102, '2015-02-01 00:13:23.000000', 'consum', 0.0210, 'lps'),
	(376416, 102, '2015-02-01 00:13:24.000000', 'consum', 0.0228, 'lps'),
	(376417, 102, '2015-02-01 00:13:25.000000', 'consum', 0.0231, 'lps'),
	(376418, 102, '2015-02-01 00:13:26.000000', 'consum', 0.0215, 'lps'),
	(376419, 102, '2015-02-01 00:13:27.000000', 'consum', 0.0218, 'lps'),
	(376420, 102, '2015-02-01 00:13:28.000000', 'consum', 0.0213, 'lps'),
	(376421, 102, '2015-02-01 00:13:29.000000', 'consum', 0.0225, 'lps'),
	(376422, 102, '2015-02-01 00:13:30.000000', 'consum', 0.0231, 'lps'),
	(376423, 102, '2015-02-01 00:13:31.000000', 'consum', 0.0226, 'lps'),
	(376424, 102, '2015-02-01 00:13:32.000000', 'consum', 0.0225, 'lps'),
	(376425, 102, '2015-02-01 00:13:33.000000', 'consum', 0.0214, 'lps'),
	(376426, 102, '2015-02-01 00:13:34.000000', 'consum', 0.0211, 'lps'),
	(376427, 102, '2015-02-01 00:13:35.000000', 'consum', 0.0223, 'lps'),
	(376428, 102, '2015-02-01 00:13:36.000000', 'consum', 0.0230, 'lps'),
	(376429, 102, '2015-02-01 00:13:37.000000', 'consum', 0.0223, 'lps'),
	(376430, 102, '2015-02-01 00:13:38.000000', 'consum', 0.0218, 'lps'),
	(376431, 102, '2015-02-01 00:13:39.000000', 'consum', 0.0210, 'lps'),
	(376432, 102, '2015-02-01 00:13:40.000000', 'consum', 0.0211, 'lps'),
	(376433, 102, '2015-02-01 00:13:41.000000', 'consum', 0.0214, 'lps'),
	(376434, 102, '2015-02-01 00:13:42.000000', 'consum', 0.0230, 'lps'),
	(376435, 102, '2015-02-01 00:13:43.000000', 'consum', 0.0226, 'lps'),
	(376436, 102, '2015-02-01 00:13:44.000000', 'consum', 0.0211, 'lps'),
	(376437, 102, '2015-02-01 00:13:45.000000', 'consum', 0.0212, 'lps'),
	(376438, 102, '2015-02-01 00:13:46.000000', 'consum', 0.0219, 'lps'),
	(376439, 102, '2015-02-01 00:13:47.000000', 'consum', 0.0227, 'lps'),
	(376440, 102, '2015-02-01 00:13:48.000000', 'consum', 0.0220, 'lps'),
	(376441, 102, '2015-02-01 00:13:49.000000', 'consum', 0.0212, 'lps'),
	(376442, 102, '2015-02-01 00:13:50.000000', 'consum', 0.0213, 'lps'),
	(376443, 102, '2015-02-01 00:13:51.000000', 'consum', 0.0219, 'lps'),
	(376444, 102, '2015-02-01 00:13:52.000000', 'consum', 0.0225, 'lps'),
	(376445, 102, '2015-02-01 00:13:53.000000', 'consum', 0.0212, 'lps'),
	(376446, 102, '2015-02-01 00:13:54.000000', 'consum', 0.0220, 'lps'),
	(376447, 102, '2015-02-01 00:13:55.000000', 'consum', 0.0230, 'lps'),
	(376448, 102, '2015-02-01 00:13:56.000000', 'consum', 0.0215, 'lps'),
	(376449, 102, '2015-02-01 00:13:57.000000', 'consum', 0.0220, 'lps'),
	(376450, 102, '2015-02-01 00:13:58.000000', 'consum', 0.0222, 'lps'),
	(376451, 102, '2015-02-01 00:13:59.000000', 'consum', 0.0218, 'lps'),
	(376452, 102, '2015-02-01 00:14:00.000000', 'consum', 0.0215, 'lps'),
	(376453, 102, '2015-02-01 00:14:01.000000', 'consum', 0.0211, 'lps'),
	(376454, 102, '2015-02-01 00:14:02.000000', 'consum', 0.0223, 'lps'),
	(376455, 102, '2015-02-01 00:14:03.000000', 'consum', 0.0226, 'lps'),
	(376456, 102, '2015-02-01 00:14:04.000000', 'consum', 0.0231, 'lps'),
	(376457, 102, '2015-02-01 00:14:05.000000', 'consum', 0.0219, 'lps'),
	(376458, 102, '2015-02-01 00:14:06.000000', 'consum', 0.0216, 'lps'),
	(376459, 102, '2015-02-01 00:14:07.000000', 'consum', 0.0214, 'lps'),
	(376460, 102, '2015-02-01 00:14:08.000000', 'consum', 0.0213, 'lps'),
	(376461, 102, '2015-02-01 00:14:09.000000', 'consum', 0.0211, 'lps'),
	(376462, 102, '2015-02-01 00:14:10.000000', 'consum', 0.0232, 'lps'),
	(376463, 102, '2015-02-01 00:14:11.000000', 'consum', 0.0223, 'lps'),
	(376464, 102, '2015-02-01 00:14:12.000000', 'consum', 0.0213, 'lps'),
	(376465, 102, '2015-02-01 00:14:13.000000', 'consum', 0.0229, 'lps'),
	(376466, 102, '2015-02-01 00:14:14.000000', 'consum', 0.0228, 'lps'),
	(376467, 102, '2015-02-01 00:14:15.000000', 'consum', 0.0222, 'lps'),
	(376468, 102, '2015-02-01 00:14:16.000000', 'consum', 0.0218, 'lps'),
	(376469, 102, '2015-02-01 00:14:17.000000', 'consum', 0.0211, 'lps'),
	(376470, 102, '2015-02-01 00:14:18.000000', 'consum', 0.0218, 'lps'),
	(376471, 102, '2015-02-01 00:14:19.000000', 'consum', 0.0221, 'lps'),
	(376472, 102, '2015-02-01 00:14:20.000000', 'consum', 0.0220, 'lps'),
	(376473, 102, '2015-02-01 00:14:21.000000', 'consum', 0.0228, 'lps'),
	(376474, 102, '2015-02-01 00:14:22.000000', 'consum', 0.0222, 'lps'),
	(376475, 102, '2015-02-01 00:14:23.000000', 'consum', 0.0219, 'lps'),
	(376476, 102, '2015-02-01 00:14:24.000000', 'consum', 0.0218, 'lps'),
	(376477, 102, '2015-02-01 00:14:25.000000', 'consum', 0.0223, 'lps'),
	(376478, 102, '2015-02-01 00:14:26.000000', 'consum', 0.0230, 'lps'),
	(376479, 102, '2015-02-01 00:14:27.000000', 'consum', 0.0227, 'lps'),
	(376480, 102, '2015-02-01 00:14:28.000000', 'consum', 0.0232, 'lps'),
	(376481, 102, '2015-02-01 00:14:29.000000', 'consum', 0.0225, 'lps'),
	(376482, 102, '2015-02-01 00:14:30.000000', 'consum', 0.0220, 'lps'),
	(376483, 102, '2015-02-01 00:14:31.000000', 'consum', 0.0215, 'lps'),
	(376484, 102, '2015-02-01 00:14:32.000000', 'consum', 0.0230, 'lps'),
	(376485, 102, '2015-02-01 00:14:33.000000', 'consum', 0.0227, 'lps'),
	(376486, 102, '2015-02-01 00:14:34.000000', 'consum', 0.0213, 'lps'),
	(376487, 102, '2015-02-01 00:14:35.000000', 'consum', 0.0221, 'lps'),
	(376488, 102, '2015-02-01 00:14:36.000000', 'consum', 0.0211, 'lps'),
	(376489, 102, '2015-02-01 00:14:37.000000', 'consum', 0.0227, 'lps'),
	(376490, 102, '2015-02-01 00:14:38.000000', 'consum', 0.0223, 'lps'),
	(376491, 102, '2015-02-01 00:14:39.000000', 'consum', 0.0225, 'lps'),
	(376492, 102, '2015-02-01 00:14:40.000000', 'consum', 0.0226, 'lps'),
	(376493, 102, '2015-02-01 00:14:41.000000', 'consum', 0.0219, 'lps'),
	(376494, 102, '2015-02-01 00:14:42.000000', 'consum', 0.0230, 'lps'),
	(376495, 102, '2015-02-01 00:14:43.000000', 'consum', 0.0217, 'lps'),
	(376496, 102, '2015-02-01 00:14:44.000000', 'consum', 0.0229, 'lps'),
	(376497, 102, '2015-02-01 00:14:45.000000', 'consum', 0.0215, 'lps'),
	(376498, 102, '2015-02-01 00:14:46.000000', 'consum', 0.0227, 'lps'),
	(376499, 102, '2015-02-01 00:14:47.000000', 'consum', 0.0232, 'lps'),
	(376500, 102, '2015-02-01 00:14:48.000000', 'consum', 0.0223, 'lps'),
	(376501, 102, '2015-02-01 00:14:49.000000', 'consum', 0.0211, 'lps'),
	(376502, 102, '2015-02-01 00:14:50.000000', 'consum', 0.0221, 'lps'),
	(376503, 102, '2015-02-01 00:14:51.000000', 'consum', 0.0215, 'lps'),
	(376504, 102, '2015-02-01 00:14:52.000000', 'consum', 0.0228, 'lps'),
	(376505, 102, '2015-02-01 00:14:53.000000', 'consum', 0.0216, 'lps'),
	(376506, 102, '2015-02-01 00:14:54.000000', 'consum', 0.0232, 'lps'),
	(376507, 102, '2015-02-01 00:14:55.000000', 'consum', 0.0211, 'lps'),
	(376508, 102, '2015-02-01 00:14:56.000000', 'consum', 0.0220, 'lps'),
	(376509, 102, '2015-02-01 00:14:57.000000', 'consum', 0.0210, 'lps'),
	(376510, 102, '2015-02-01 00:14:58.000000', 'consum', 0.0227, 'lps'),
	(376511, 102, '2015-02-01 00:14:59.000000', 'consum', 0.0227, 'lps'),
	(376512, 102, '2015-02-01 00:15:00.000000', 'consum', 0.0220, 'lps'),
	(376513, 102, '2015-02-01 00:15:01.000000', 'consum', 0.0211, 'lps'),
	(376514, 102, '2015-02-01 00:15:02.000000', 'consum', 0.0231, 'lps'),
	(376515, 102, '2015-02-01 00:15:03.000000', 'consum', 0.0219, 'lps'),
	(376516, 102, '2015-02-01 00:15:04.000000', 'consum', 0.0215, 'lps'),
	(376517, 102, '2015-02-01 00:15:05.000000', 'consum', 0.0232, 'lps'),
	(376518, 102, '2015-02-01 00:15:06.000000', 'consum', 0.0214, 'lps'),
	(376519, 102, '2015-02-01 00:15:07.000000', 'consum', 0.0212, 'lps'),
	(376520, 102, '2015-02-01 00:15:08.000000', 'consum', 0.0230, 'lps'),
	(376521, 102, '2015-02-01 00:15:09.000000', 'consum', 0.0214, 'lps'),
	(376522, 102, '2015-02-01 00:15:10.000000', 'consum', 0.0216, 'lps'),
	(376523, 102, '2015-02-01 00:15:11.000000', 'consum', 0.0228, 'lps'),
	(376524, 102, '2015-02-01 00:15:12.000000', 'consum', 0.0214, 'lps'),
	(376525, 102, '2015-02-01 00:15:13.000000', 'consum', 0.0223, 'lps'),
	(376526, 102, '2015-02-01 00:15:14.000000', 'consum', 0.0218, 'lps'),
	(376527, 102, '2015-02-01 00:15:15.000000', 'consum', 0.0213, 'lps'),
	(376528, 102, '2015-02-01 00:15:16.000000', 'consum', 0.0222, 'lps'),
	(376529, 102, '2015-02-01 00:15:17.000000', 'consum', 0.0217, 'lps'),
	(376530, 102, '2015-02-01 00:15:18.000000', 'consum', 0.0231, 'lps'),
	(376531, 102, '2015-02-01 00:15:19.000000', 'consum', 0.0228, 'lps'),
	(376532, 102, '2015-02-01 00:15:20.000000', 'consum', 0.0212, 'lps'),
	(376533, 102, '2015-02-01 00:15:21.000000', 'consum', 0.0214, 'lps'),
	(376534, 102, '2015-02-01 00:15:22.000000', 'consum', 0.0224, 'lps'),
	(376535, 102, '2015-02-01 00:15:23.000000', 'consum', 0.0221, 'lps'),
	(376536, 102, '2015-02-01 00:15:24.000000', 'consum', 0.0225, 'lps'),
	(376537, 102, '2015-02-01 00:15:25.000000', 'consum', 0.0231, 'lps'),
	(376538, 102, '2015-02-01 00:15:26.000000', 'consum', 0.0222, 'lps'),
	(376539, 102, '2015-02-01 00:15:27.000000', 'consum', 0.0210, 'lps'),
	(376540, 102, '2015-02-01 00:15:28.000000', 'consum', 0.0221, 'lps'),
	(376541, 102, '2015-02-01 00:15:29.000000', 'consum', 0.0217, 'lps'),
	(376542, 102, '2015-02-01 00:15:30.000000', 'consum', 0.0213, 'lps'),
	(376543, 102, '2015-02-01 00:15:31.000000', 'consum', 0.0227, 'lps'),
	(376544, 102, '2015-02-01 00:15:32.000000', 'consum', 0.0219, 'lps'),
	(376545, 102, '2015-02-01 00:15:33.000000', 'consum', 0.0226, 'lps'),
	(376546, 102, '2015-02-01 00:15:34.000000', 'consum', 0.0217, 'lps'),
	(376547, 102, '2015-02-01 00:15:35.000000', 'consum', 0.0219, 'lps'),
	(376548, 102, '2015-02-01 00:15:36.000000', 'consum', 0.0215, 'lps'),
	(376549, 102, '2015-02-01 00:15:37.000000', 'consum', 0.0228, 'lps'),
	(376550, 102, '2015-02-01 00:15:38.000000', 'consum', 0.0220, 'lps'),
	(376551, 102, '2015-02-01 00:15:39.000000', 'consum', 0.0228, 'lps'),
	(376552, 102, '2015-02-01 00:15:40.000000', 'consum', 0.0226, 'lps'),
	(376553, 102, '2015-02-01 00:15:41.000000', 'consum', 0.0215, 'lps'),
	(376554, 102, '2015-02-01 00:15:42.000000', 'consum', 0.0230, 'lps'),
	(376555, 102, '2015-02-01 00:15:43.000000', 'consum', 0.0228, 'lps'),
	(376556, 102, '2015-02-01 00:15:44.000000', 'consum', 0.0219, 'lps'),
	(376557, 102, '2015-02-01 00:15:45.000000', 'consum', 0.0223, 'lps'),
	(376558, 102, '2015-02-01 00:15:46.000000', 'consum', 0.0225, 'lps'),
	(376559, 102, '2015-02-01 00:15:47.000000', 'consum', 0.0226, 'lps'),
	(376560, 102, '2015-02-01 00:15:48.000000', 'consum', 0.0221, 'lps'),
	(376561, 102, '2015-02-01 00:15:49.000000', 'consum', 0.0216, 'lps'),
	(376562, 102, '2015-02-01 00:15:50.000000', 'consum', 0.0232, 'lps'),
	(376563, 102, '2015-02-01 00:15:51.000000', 'consum', 0.0210, 'lps'),
	(376564, 102, '2015-02-01 00:15:52.000000', 'consum', 0.0212, 'lps'),
	(376565, 102, '2015-02-01 00:15:53.000000', 'consum', 0.0221, 'lps'),
	(376566, 102, '2015-02-01 00:15:54.000000', 'consum', 0.0213, 'lps'),
	(376567, 102, '2015-02-01 00:15:55.000000', 'consum', 0.0217, 'lps'),
	(376568, 102, '2015-02-01 00:15:56.000000', 'consum', 0.0212, 'lps'),
	(376569, 102, '2015-02-01 00:15:57.000000', 'consum', 0.0223, 'lps'),
	(376570, 102, '2015-02-01 00:15:58.000000', 'consum', 0.0222, 'lps'),
	(376571, 102, '2015-02-01 00:15:59.000000', 'consum', 0.0211, 'lps'),
	(376572, 102, '2015-02-01 00:16:00.000000', 'consum', 0.0223, 'lps'),
	(376573, 102, '2015-02-01 00:16:01.000000', 'consum', 0.0227, 'lps'),
	(376574, 102, '2015-02-01 00:16:02.000000', 'consum', 0.0212, 'lps'),
	(376575, 102, '2015-02-01 00:16:03.000000', 'consum', 0.0214, 'lps'),
	(376576, 102, '2015-02-01 00:16:04.000000', 'consum', 0.0226, 'lps'),
	(376577, 102, '2015-02-01 00:16:05.000000', 'consum', 0.0210, 'lps'),
	(376578, 102, '2015-02-01 00:16:06.000000', 'consum', 0.0231, 'lps'),
	(376579, 102, '2015-02-01 00:16:07.000000', 'consum', 0.0222, 'lps'),
	(376580, 102, '2015-02-01 00:16:08.000000', 'consum', 0.0232, 'lps'),
	(376581, 102, '2015-02-01 00:16:09.000000', 'consum', 0.0216, 'lps'),
	(376582, 102, '2015-02-01 00:16:10.000000', 'consum', 0.0219, 'lps'),
	(376583, 102, '2015-02-01 00:16:11.000000', 'consum', 0.0215, 'lps'),
	(376584, 102, '2015-02-01 00:16:12.000000', 'consum', 0.0231, 'lps'),
	(376585, 102, '2015-02-01 00:16:13.000000', 'consum', 0.0230, 'lps'),
	(376586, 102, '2015-02-01 00:16:14.000000', 'consum', 0.0228, 'lps'),
	(376587, 102, '2015-02-01 00:16:15.000000', 'consum', 0.0215, 'lps'),
	(376588, 102, '2015-02-01 00:16:16.000000', 'consum', 0.0229, 'lps'),
	(376589, 102, '2015-02-01 00:16:17.000000', 'consum', 0.0221, 'lps'),
	(376590, 102, '2015-02-01 00:16:18.000000', 'consum', 0.0230, 'lps'),
	(376591, 102, '2015-02-01 00:16:19.000000', 'consum', 0.0211, 'lps'),
	(376592, 102, '2015-02-01 00:16:20.000000', 'consum', 0.0225, 'lps'),
	(376593, 102, '2015-02-01 00:16:21.000000', 'consum', 0.0211, 'lps'),
	(376594, 102, '2015-02-01 00:16:22.000000', 'consum', 0.0219, 'lps'),
	(376595, 102, '2015-02-01 00:16:23.000000', 'consum', 0.0229, 'lps'),
	(376596, 102, '2015-02-01 00:16:24.000000', 'consum', 0.0231, 'lps'),
	(376597, 102, '2015-02-01 00:16:25.000000', 'consum', 0.0212, 'lps'),
	(376598, 102, '2015-02-01 00:16:26.000000', 'consum', 0.0227, 'lps'),
	(376599, 102, '2015-02-01 00:16:27.000000', 'consum', 0.0221, 'lps'),
	(376600, 102, '2015-02-01 00:16:28.000000', 'consum', 0.0216, 'lps'),
	(376601, 102, '2015-02-01 00:16:29.000000', 'consum', 0.0230, 'lps'),
	(376602, 102, '2015-02-01 00:16:30.000000', 'consum', 0.0224, 'lps'),
	(376603, 102, '2015-02-01 00:16:31.000000', 'consum', 0.0218, 'lps'),
	(376604, 102, '2015-02-01 00:16:32.000000', 'consum', 0.0232, 'lps'),
	(376605, 102, '2015-02-01 00:16:33.000000', 'consum', 0.0229, 'lps'),
	(376606, 102, '2015-02-01 00:16:34.000000', 'consum', 0.0215, 'lps'),
	(376607, 102, '2015-02-01 00:16:35.000000', 'consum', 0.0224, 'lps'),
	(376608, 102, '2015-02-01 00:16:36.000000', 'consum', 0.0220, 'lps'),
	(376609, 102, '2015-02-01 00:16:37.000000', 'consum', 0.0217, 'lps'),
	(376610, 102, '2015-02-01 00:16:38.000000', 'consum', 0.0215, 'lps'),
	(376611, 102, '2015-02-01 00:16:39.000000', 'consum', 0.0215, 'lps'),
	(376612, 102, '2015-02-01 00:16:40.000000', 'consum', 0.0222, 'lps'),
	(376613, 102, '2015-02-01 00:16:41.000000', 'consum', 0.0210, 'lps'),
	(376614, 102, '2015-02-01 00:16:42.000000', 'consum', 0.0221, 'lps'),
	(376615, 102, '2015-02-01 00:16:43.000000', 'consum', 0.0219, 'lps'),
	(376616, 102, '2015-02-01 00:16:44.000000', 'consum', 0.0220, 'lps'),
	(376617, 102, '2015-02-01 00:16:45.000000', 'consum', 0.0213, 'lps'),
	(376618, 102, '2015-02-01 00:16:46.000000', 'consum', 0.0219, 'lps'),
	(376619, 102, '2015-02-01 00:16:47.000000', 'consum', 0.0223, 'lps'),
	(376620, 102, '2015-02-01 00:16:48.000000', 'consum', 0.0225, 'lps'),
	(376621, 102, '2015-02-01 00:16:49.000000', 'consum', 0.0222, 'lps'),
	(376622, 102, '2015-02-01 00:16:50.000000', 'consum', 0.0225, 'lps'),
	(376623, 102, '2015-02-01 00:16:51.000000', 'consum', 0.0228, 'lps'),
	(376624, 102, '2015-02-01 00:16:52.000000', 'consum', 0.0231, 'lps'),
	(376625, 102, '2015-02-01 00:16:53.000000', 'consum', 0.0216, 'lps'),
	(376626, 102, '2015-02-01 00:16:54.000000', 'consum', 0.0224, 'lps'),
	(376627, 102, '2015-02-01 00:16:55.000000', 'consum', 0.0218, 'lps'),
	(376628, 102, '2015-02-01 00:16:56.000000', 'consum', 0.0229, 'lps'),
	(376629, 102, '2015-02-01 00:16:57.000000', 'consum', 0.0212, 'lps'),
	(376630, 102, '2015-02-01 00:16:58.000000', 'consum', 0.0232, 'lps'),
	(376631, 102, '2015-02-01 00:16:59.000000', 'consum', 0.0222, 'lps'),
	(376632, 102, '2015-02-01 00:17:00.000000', 'consum', 0.0230, 'lps'),
	(376633, 102, '2015-02-01 00:17:01.000000', 'consum', 0.0228, 'lps'),
	(376634, 102, '2015-02-01 00:17:02.000000', 'consum', 0.0218, 'lps'),
	(376635, 102, '2015-02-01 00:17:03.000000', 'consum', 0.0218, 'lps'),
	(376636, 102, '2015-02-01 00:17:04.000000', 'consum', 0.0228, 'lps'),
	(376637, 102, '2015-02-01 00:17:05.000000', 'consum', 0.0228, 'lps'),
	(376638, 102, '2015-02-01 00:17:06.000000', 'consum', 0.0224, 'lps'),
	(376639, 102, '2015-02-01 00:17:07.000000', 'consum', 0.0229, 'lps'),
	(376640, 102, '2015-02-01 00:17:08.000000', 'consum', 0.0217, 'lps'),
	(376641, 102, '2015-02-01 00:17:09.000000', 'consum', 0.0211, 'lps'),
	(376642, 102, '2015-02-01 00:17:10.000000', 'consum', 0.0218, 'lps'),
	(376643, 102, '2015-02-01 00:17:11.000000', 'consum', 0.0225, 'lps'),
	(376644, 102, '2015-02-01 00:17:12.000000', 'consum', 0.0213, 'lps'),
	(376645, 102, '2015-02-01 00:17:13.000000', 'consum', 0.0230, 'lps'),
	(376646, 102, '2015-02-01 00:17:14.000000', 'consum', 0.0230, 'lps'),
	(376647, 102, '2015-02-01 00:17:15.000000', 'consum', 0.0230, 'lps'),
	(376648, 102, '2015-02-01 00:17:16.000000', 'consum', 0.0224, 'lps'),
	(376649, 102, '2015-02-01 00:17:17.000000', 'consum', 0.0223, 'lps'),
	(376650, 102, '2015-02-01 00:17:18.000000', 'consum', 0.0232, 'lps'),
	(376651, 102, '2015-02-01 00:17:19.000000', 'consum', 0.0212, 'lps'),
	(376652, 102, '2015-02-01 00:17:20.000000', 'consum', 0.0225, 'lps'),
	(376653, 102, '2015-02-01 00:17:21.000000', 'consum', 0.0210, 'lps'),
	(376654, 102, '2015-02-01 00:17:22.000000', 'consum', 0.0210, 'lps'),
	(376655, 102, '2015-02-01 00:17:23.000000', 'consum', 0.0213, 'lps'),
	(376656, 102, '2015-02-01 00:17:24.000000', 'consum', 0.0223, 'lps'),
	(376657, 102, '2015-02-01 00:17:25.000000', 'consum', 0.0220, 'lps'),
	(376658, 102, '2015-02-01 00:17:26.000000', 'consum', 0.0221, 'lps'),
	(376659, 102, '2015-02-01 00:17:27.000000', 'consum', 0.0213, 'lps'),
	(376660, 102, '2015-02-01 00:17:28.000000', 'consum', 0.0216, 'lps'),
	(376661, 102, '2015-02-01 00:17:29.000000', 'consum', 0.0211, 'lps'),
	(376662, 102, '2015-02-01 00:17:30.000000', 'consum', 0.0217, 'lps'),
	(376663, 102, '2015-02-01 00:17:31.000000', 'consum', 0.0220, 'lps'),
	(376664, 102, '2015-02-01 00:17:32.000000', 'consum', 0.0219, 'lps'),
	(376665, 102, '2015-02-01 00:17:33.000000', 'consum', 0.0222, 'lps'),
	(376666, 102, '2015-02-01 00:17:34.000000', 'consum', 0.0222, 'lps'),
	(376667, 102, '2015-02-01 00:17:35.000000', 'consum', 0.0213, 'lps'),
	(376668, 102, '2015-02-01 00:17:36.000000', 'consum', 0.0212, 'lps'),
	(376669, 102, '2015-02-01 00:17:37.000000', 'consum', 0.0213, 'lps'),
	(376670, 102, '2015-02-01 00:17:38.000000', 'consum', 0.0216, 'lps'),
	(376671, 102, '2015-02-01 00:17:39.000000', 'consum', 0.0212, 'lps'),
	(376672, 102, '2015-02-01 00:17:40.000000', 'consum', 0.0224, 'lps'),
	(376673, 102, '2015-02-01 00:17:41.000000', 'consum', 0.0230, 'lps'),
	(376674, 102, '2015-02-01 00:17:42.000000', 'consum', 0.0221, 'lps'),
	(376675, 102, '2015-02-01 00:17:43.000000', 'consum', 0.0230, 'lps'),
	(376676, 102, '2015-02-01 00:17:44.000000', 'consum', 0.0231, 'lps'),
	(376677, 102, '2015-02-01 00:17:45.000000', 'consum', 0.0211, 'lps'),
	(376678, 102, '2015-02-01 00:17:46.000000', 'consum', 0.0220, 'lps'),
	(376679, 102, '2015-02-01 00:17:47.000000', 'consum', 0.0211, 'lps'),
	(376680, 102, '2015-02-01 00:17:48.000000', 'consum', 0.0231, 'lps'),
	(376681, 102, '2015-02-01 00:17:49.000000', 'consum', 0.0221, 'lps'),
	(376682, 102, '2015-02-01 00:17:50.000000', 'consum', 0.0224, 'lps'),
	(376683, 102, '2015-02-01 00:17:51.000000', 'consum', 0.0224, 'lps'),
	(376684, 102, '2015-02-01 00:17:52.000000', 'consum', 0.0217, 'lps'),
	(376685, 102, '2015-02-01 00:17:53.000000', 'consum', 0.0225, 'lps'),
	(376686, 102, '2015-02-01 00:17:54.000000', 'consum', 0.0220, 'lps'),
	(376687, 102, '2015-02-01 00:17:55.000000', 'consum', 0.0215, 'lps'),
	(376688, 102, '2015-02-01 00:17:56.000000', 'consum', 0.0230, 'lps'),
	(376689, 102, '2015-02-01 00:17:57.000000', 'consum', 0.0226, 'lps'),
	(376690, 102, '2015-02-01 00:17:58.000000', 'consum', 0.0228, 'lps'),
	(376691, 102, '2015-02-01 00:17:59.000000', 'consum', 0.0210, 'lps'),
	(376692, 102, '2015-02-01 00:18:00.000000', 'consum', 0.0224, 'lps'),
	(376693, 102, '2015-02-01 00:18:01.000000', 'consum', 0.0211, 'lps'),
	(376694, 102, '2015-02-01 00:18:02.000000', 'consum', 0.0222, 'lps'),
	(376695, 102, '2015-02-01 00:18:03.000000', 'consum', 0.0218, 'lps'),
	(376696, 102, '2015-02-01 00:18:04.000000', 'consum', 0.0217, 'lps'),
	(376697, 102, '2015-02-01 00:18:05.000000', 'consum', 0.0223, 'lps'),
	(376698, 102, '2015-02-01 00:18:06.000000', 'consum', 0.0229, 'lps'),
	(376699, 102, '2015-02-01 00:18:07.000000', 'consum', 0.0221, 'lps'),
	(376700, 102, '2015-02-01 00:18:08.000000', 'consum', 0.0210, 'lps'),
	(376701, 102, '2015-02-01 00:18:09.000000', 'consum', 0.0224, 'lps'),
	(376702, 102, '2015-02-01 00:18:10.000000', 'consum', 0.0213, 'lps'),
	(376703, 102, '2015-02-01 00:18:11.000000', 'consum', 0.0226, 'lps'),
	(376704, 102, '2015-02-01 00:18:12.000000', 'consum', 0.0213, 'lps'),
	(376705, 102, '2015-02-01 00:18:13.000000', 'consum', 0.0223, 'lps'),
	(376706, 102, '2015-02-01 00:18:14.000000', 'consum', 0.0223, 'lps'),
	(376707, 102, '2015-02-01 00:18:15.000000', 'consum', 0.0211, 'lps'),
	(376708, 102, '2015-02-01 00:18:16.000000', 'consum', 0.0224, 'lps'),
	(376709, 102, '2015-02-01 00:18:17.000000', 'consum', 0.0210, 'lps'),
	(376710, 102, '2015-02-01 00:18:18.000000', 'consum', 0.0212, 'lps'),
	(376711, 102, '2015-02-01 00:18:19.000000', 'consum', 0.0220, 'lps'),
	(376712, 102, '2015-02-01 00:18:20.000000', 'consum', 0.0232, 'lps'),
	(376713, 102, '2015-02-01 00:18:21.000000', 'consum', 0.0220, 'lps'),
	(376714, 102, '2015-02-01 00:18:22.000000', 'consum', 0.0219, 'lps'),
	(376715, 102, '2015-02-01 00:18:23.000000', 'consum', 0.0224, 'lps'),
	(376716, 102, '2015-02-01 00:18:24.000000', 'consum', 0.0230, 'lps'),
	(376717, 102, '2015-02-01 00:18:25.000000', 'consum', 0.0224, 'lps'),
	(376718, 102, '2015-02-01 00:18:26.000000', 'consum', 0.0220, 'lps'),
	(376719, 102, '2015-02-01 00:18:27.000000', 'consum', 0.0219, 'lps'),
	(376720, 102, '2015-02-01 00:18:28.000000', 'consum', 0.0225, 'lps'),
	(376721, 102, '2015-02-01 00:18:29.000000', 'consum', 0.0211, 'lps'),
	(376722, 102, '2015-02-01 00:18:30.000000', 'consum', 0.0219, 'lps'),
	(376723, 102, '2015-02-01 00:18:31.000000', 'consum', 0.0228, 'lps'),
	(376724, 102, '2015-02-01 00:18:32.000000', 'consum', 0.0229, 'lps'),
	(376725, 102, '2015-02-01 00:18:33.000000', 'consum', 0.0226, 'lps'),
	(376726, 102, '2015-02-01 00:18:34.000000', 'consum', 0.0211, 'lps'),
	(376727, 102, '2015-02-01 00:18:35.000000', 'consum', 0.0215, 'lps'),
	(376728, 102, '2015-02-01 00:18:36.000000', 'consum', 0.0211, 'lps'),
	(376729, 102, '2015-02-01 00:18:37.000000', 'consum', 0.0220, 'lps'),
	(376730, 102, '2015-02-01 00:18:38.000000', 'consum', 0.0215, 'lps'),
	(376731, 102, '2015-02-01 00:18:39.000000', 'consum', 0.0227, 'lps'),
	(376732, 102, '2015-02-01 00:18:40.000000', 'consum', 0.0210, 'lps'),
	(376733, 102, '2015-02-01 00:18:41.000000', 'consum', 0.0229, 'lps'),
	(376734, 102, '2015-02-01 00:18:42.000000', 'consum', 0.0214, 'lps'),
	(376735, 102, '2015-02-01 00:18:43.000000', 'consum', 0.0221, 'lps'),
	(376736, 102, '2015-02-01 00:18:44.000000', 'consum', 0.0229, 'lps'),
	(376737, 102, '2015-02-01 00:18:45.000000', 'consum', 0.0227, 'lps'),
	(376738, 102, '2015-02-01 00:18:46.000000', 'consum', 0.0215, 'lps'),
	(376739, 102, '2015-02-01 00:18:47.000000', 'consum', 0.0229, 'lps'),
	(376740, 102, '2015-02-01 00:18:48.000000', 'consum', 0.0224, 'lps'),
	(376741, 102, '2015-02-01 00:18:49.000000', 'consum', 0.0223, 'lps'),
	(376742, 102, '2015-02-01 00:18:50.000000', 'consum', 0.0212, 'lps'),
	(376743, 102, '2015-02-01 00:18:51.000000', 'consum', 0.0226, 'lps'),
	(376744, 102, '2015-02-01 00:18:52.000000', 'consum', 0.0218, 'lps'),
	(376745, 102, '2015-02-01 00:18:53.000000', 'consum', 0.0222, 'lps'),
	(376746, 102, '2015-02-01 00:18:54.000000', 'consum', 0.0224, 'lps'),
	(376747, 102, '2015-02-01 00:18:55.000000', 'consum', 0.0223, 'lps'),
	(376748, 102, '2015-02-01 00:18:56.000000', 'consum', 0.0211, 'lps'),
	(376749, 102, '2015-02-01 00:18:57.000000', 'consum', 0.0224, 'lps'),
	(376750, 102, '2015-02-01 00:18:58.000000', 'consum', 0.0228, 'lps'),
	(376751, 102, '2015-02-01 00:18:59.000000', 'consum', 0.0214, 'lps'),
	(376752, 102, '2015-02-01 00:19:00.000000', 'consum', 0.0224, 'lps'),
	(376753, 102, '2015-02-01 00:19:01.000000', 'consum', 0.0221, 'lps'),
	(376754, 102, '2015-02-01 00:19:02.000000', 'consum', 0.0225, 'lps'),
	(376755, 102, '2015-02-01 00:19:03.000000', 'consum', 0.0227, 'lps'),
	(376756, 102, '2015-02-01 00:19:04.000000', 'consum', 0.0228, 'lps'),
	(376757, 102, '2015-02-01 00:19:05.000000', 'consum', 0.0227, 'lps'),
	(376758, 102, '2015-02-01 00:19:06.000000', 'consum', 0.0218, 'lps'),
	(376759, 102, '2015-02-01 00:19:07.000000', 'consum', 0.0223, 'lps'),
	(376760, 102, '2015-02-01 00:19:08.000000', 'consum', 0.0229, 'lps'),
	(376761, 102, '2015-02-01 00:19:09.000000', 'consum', 0.0219, 'lps'),
	(376762, 102, '2015-02-01 00:19:10.000000', 'consum', 0.0224, 'lps'),
	(376763, 102, '2015-02-01 00:19:11.000000', 'consum', 0.0230, 'lps'),
	(376764, 102, '2015-02-01 00:19:12.000000', 'consum', 0.0224, 'lps'),
	(376765, 102, '2015-02-01 00:19:13.000000', 'consum', 0.0218, 'lps'),
	(376766, 102, '2015-02-01 00:19:14.000000', 'consum', 0.0232, 'lps'),
	(376767, 102, '2015-02-01 00:19:15.000000', 'consum', 0.0226, 'lps'),
	(376768, 102, '2015-02-01 00:19:16.000000', 'consum', 0.0227, 'lps'),
	(376769, 102, '2015-02-01 00:19:17.000000', 'consum', 0.0225, 'lps'),
	(376770, 102, '2015-02-01 00:19:18.000000', 'consum', 0.0212, 'lps'),
	(376771, 102, '2015-02-01 00:19:19.000000', 'consum', 0.0219, 'lps'),
	(376772, 102, '2015-02-01 00:19:20.000000', 'consum', 0.0226, 'lps'),
	(376773, 102, '2015-02-01 00:19:21.000000', 'consum', 0.0219, 'lps'),
	(376774, 102, '2015-02-01 00:19:22.000000', 'consum', 0.0229, 'lps'),
	(376775, 102, '2015-02-01 00:19:23.000000', 'consum', 0.0210, 'lps'),
	(376776, 102, '2015-02-01 00:19:24.000000', 'consum', 0.0224, 'lps'),
	(376777, 102, '2015-02-01 00:19:25.000000', 'consum', 0.0212, 'lps'),
	(376778, 102, '2015-02-01 00:19:26.000000', 'consum', 0.0223, 'lps'),
	(376779, 102, '2015-02-01 00:19:27.000000', 'consum', 0.0222, 'lps'),
	(376780, 102, '2015-02-01 00:19:28.000000', 'consum', 0.0232, 'lps'),
	(376781, 102, '2015-02-01 00:19:29.000000', 'consum', 0.0215, 'lps'),
	(376782, 102, '2015-02-01 00:19:30.000000', 'consum', 0.0216, 'lps'),
	(376783, 102, '2015-02-01 00:19:31.000000', 'consum', 0.0224, 'lps'),
	(376784, 102, '2015-02-01 00:19:32.000000', 'consum', 0.0216, 'lps'),
	(376785, 102, '2015-02-01 00:19:33.000000', 'consum', 0.0223, 'lps'),
	(376786, 102, '2015-02-01 00:19:34.000000', 'consum', 0.0210, 'lps'),
	(376787, 102, '2015-02-01 00:19:35.000000', 'consum', 0.0219, 'lps'),
	(376788, 102, '2015-02-01 00:19:36.000000', 'consum', 0.0211, 'lps'),
	(376789, 102, '2015-02-01 00:19:37.000000', 'consum', 0.0211, 'lps'),
	(376790, 102, '2015-02-01 00:19:38.000000', 'consum', 0.0211, 'lps'),
	(376791, 102, '2015-02-01 00:19:39.000000', 'consum', 0.0214, 'lps'),
	(376792, 102, '2015-02-01 00:19:40.000000', 'consum', 0.0228, 'lps'),
	(376793, 102, '2015-02-01 00:19:41.000000', 'consum', 0.0220, 'lps'),
	(376794, 102, '2015-02-01 00:19:42.000000', 'consum', 0.0228, 'lps'),
	(376795, 102, '2015-02-01 00:19:43.000000', 'consum', 0.0223, 'lps'),
	(376796, 102, '2015-02-01 00:19:44.000000', 'consum', 0.0224, 'lps'),
	(376797, 102, '2015-02-01 00:19:45.000000', 'consum', 0.0219, 'lps'),
	(376798, 102, '2015-02-01 00:19:46.000000', 'consum', 0.0211, 'lps'),
	(376799, 102, '2015-02-01 00:19:47.000000', 'consum', 0.0213, 'lps'),
	(376800, 102, '2015-02-01 00:19:48.000000', 'consum', 0.0224, 'lps'),
	(376801, 102, '2015-02-01 00:19:49.000000', 'consum', 0.0223, 'lps'),
	(376802, 102, '2015-02-01 00:19:50.000000', 'consum', 0.0212, 'lps'),
	(376803, 102, '2015-02-01 00:19:51.000000', 'consum', 0.0225, 'lps'),
	(376804, 102, '2015-02-01 00:19:52.000000', 'consum', 0.0213, 'lps'),
	(376805, 102, '2015-02-01 00:19:53.000000', 'consum', 0.0227, 'lps'),
	(376806, 102, '2015-02-01 00:19:54.000000', 'consum', 0.0216, 'lps'),
	(376807, 102, '2015-02-01 00:19:55.000000', 'consum', 0.0214, 'lps'),
	(376808, 102, '2015-02-01 00:19:56.000000', 'consum', 0.0213, 'lps'),
	(376809, 102, '2015-02-01 00:19:57.000000', 'consum', 0.0214, 'lps'),
	(376810, 102, '2015-02-01 00:19:58.000000', 'consum', 0.0220, 'lps'),
	(376811, 102, '2015-02-01 00:19:59.000000', 'consum', 0.0228, 'lps'),
	(376812, 102, '2015-02-01 00:20:00.000000', 'consum', 0.0223, 'lps'),
	(376813, 102, '2015-02-01 00:20:01.000000', 'consum', 0.0220, 'lps'),
	(376814, 102, '2015-02-01 00:20:02.000000', 'consum', 0.0223, 'lps'),
	(376815, 102, '2015-02-01 00:20:03.000000', 'consum', 0.0222, 'lps'),
	(376816, 102, '2015-02-01 00:20:04.000000', 'consum', 0.0230, 'lps'),
	(376817, 102, '2015-02-01 00:20:05.000000', 'consum', 0.0228, 'lps'),
	(376818, 102, '2015-02-01 00:20:06.000000', 'consum', 0.0219, 'lps'),
	(376819, 102, '2015-02-01 00:20:07.000000', 'consum', 0.0224, 'lps'),
	(376820, 102, '2015-02-01 00:20:08.000000', 'consum', 0.0230, 'lps'),
	(376821, 102, '2015-02-01 00:20:09.000000', 'consum', 0.0223, 'lps'),
	(376822, 102, '2015-02-01 00:20:10.000000', 'consum', 0.0216, 'lps'),
	(376823, 102, '2015-02-01 00:20:11.000000', 'consum', 0.0226, 'lps'),
	(376824, 102, '2015-02-01 00:20:12.000000', 'consum', 0.0225, 'lps'),
	(376825, 102, '2015-02-01 00:20:13.000000', 'consum', 0.0217, 'lps'),
	(376826, 102, '2015-02-01 00:20:14.000000', 'consum', 0.0221, 'lps'),
	(376827, 102, '2015-02-01 00:20:15.000000', 'consum', 0.0221, 'lps'),
	(376828, 102, '2015-02-01 00:20:16.000000', 'consum', 0.0232, 'lps'),
	(376829, 102, '2015-02-01 00:20:17.000000', 'consum', 0.0222, 'lps'),
	(376830, 102, '2015-02-01 00:20:18.000000', 'consum', 0.0224, 'lps'),
	(376831, 102, '2015-02-01 00:20:19.000000', 'consum', 0.0221, 'lps'),
	(376832, 102, '2015-02-01 00:20:20.000000', 'consum', 0.0223, 'lps'),
	(376833, 102, '2015-02-01 00:20:21.000000', 'consum', 0.0222, 'lps'),
	(376834, 102, '2015-02-01 00:20:22.000000', 'consum', 0.0230, 'lps'),
	(376835, 102, '2015-02-01 00:20:23.000000', 'consum', 0.0228, 'lps'),
	(376836, 102, '2015-02-01 00:20:24.000000', 'consum', 0.0220, 'lps'),
	(376837, 102, '2015-02-01 00:20:25.000000', 'consum', 0.0228, 'lps'),
	(376838, 102, '2015-02-01 00:20:26.000000', 'consum', 0.0225, 'lps'),
	(376839, 102, '2015-02-01 00:20:27.000000', 'consum', 0.0232, 'lps'),
	(376840, 102, '2015-02-01 00:20:28.000000', 'consum', 0.0227, 'lps'),
	(376841, 102, '2015-02-01 00:20:29.000000', 'consum', 0.0232, 'lps'),
	(376842, 102, '2015-02-01 00:20:30.000000', 'consum', 0.0221, 'lps'),
	(376843, 102, '2015-02-01 00:20:31.000000', 'consum', 0.0224, 'lps'),
	(376844, 102, '2015-02-01 00:20:32.000000', 'consum', 0.0225, 'lps'),
	(376845, 102, '2015-02-01 00:20:33.000000', 'consum', 0.0218, 'lps'),
	(376846, 102, '2015-02-01 00:20:34.000000', 'consum', 0.0231, 'lps'),
	(376847, 102, '2015-02-01 00:20:35.000000', 'consum', 0.0223, 'lps'),
	(376848, 102, '2015-02-01 00:20:36.000000', 'consum', 0.0211, 'lps'),
	(376849, 102, '2015-02-01 00:20:37.000000', 'consum', 0.0223, 'lps'),
	(376850, 102, '2015-02-01 00:20:38.000000', 'consum', 0.0228, 'lps'),
	(376851, 102, '2015-02-01 00:20:39.000000', 'consum', 0.0214, 'lps'),
	(376852, 102, '2015-02-01 00:20:40.000000', 'consum', 0.0225, 'lps'),
	(376853, 102, '2015-02-01 00:20:41.000000', 'consum', 0.0225, 'lps'),
	(376854, 102, '2015-02-01 00:20:42.000000', 'consum', 0.0219, 'lps'),
	(376855, 102, '2015-02-01 00:20:43.000000', 'consum', 0.0211, 'lps'),
	(376856, 102, '2015-02-01 00:20:44.000000', 'consum', 0.0213, 'lps'),
	(376857, 102, '2015-02-01 00:20:45.000000', 'consum', 0.0220, 'lps'),
	(376858, 102, '2015-02-01 00:20:46.000000', 'consum', 0.0227, 'lps'),
	(376859, 102, '2015-02-01 00:20:47.000000', 'consum', 0.0222, 'lps'),
	(376860, 102, '2015-02-01 00:20:48.000000', 'consum', 0.0219, 'lps'),
	(376861, 102, '2015-02-01 00:20:49.000000', 'consum', 0.0220, 'lps'),
	(376862, 102, '2015-02-01 00:20:50.000000', 'consum', 0.0211, 'lps'),
	(376863, 102, '2015-02-01 00:20:51.000000', 'consum', 0.0230, 'lps'),
	(376864, 102, '2015-02-01 00:20:52.000000', 'consum', 0.0215, 'lps'),
	(376865, 102, '2015-02-01 00:20:53.000000', 'consum', 0.0221, 'lps'),
	(376866, 102, '2015-02-01 00:20:54.000000', 'consum', 0.0227, 'lps'),
	(376867, 102, '2015-02-01 00:20:55.000000', 'consum', 0.0218, 'lps'),
	(376868, 102, '2015-02-01 00:20:56.000000', 'consum', 0.0222, 'lps'),
	(376869, 102, '2015-02-01 00:20:57.000000', 'consum', 0.0223, 'lps'),
	(376870, 102, '2015-02-01 00:20:58.000000', 'consum', 0.0216, 'lps'),
	(376871, 102, '2015-02-01 00:20:59.000000', 'consum', 0.0226, 'lps'),
	(376872, 102, '2015-02-01 00:21:00.000000', 'consum', 0.0226, 'lps'),
	(376873, 102, '2015-02-01 00:21:01.000000', 'consum', 0.0218, 'lps'),
	(376874, 102, '2015-02-01 00:21:02.000000', 'consum', 0.0228, 'lps'),
	(376875, 102, '2015-02-01 00:21:03.000000', 'consum', 0.0229, 'lps'),
	(376876, 102, '2015-02-01 00:21:04.000000', 'consum', 0.0231, 'lps'),
	(376877, 102, '2015-02-01 00:21:05.000000', 'consum', 0.0232, 'lps'),
	(376878, 102, '2015-02-01 00:21:06.000000', 'consum', 0.0212, 'lps'),
	(376879, 102, '2015-02-01 00:21:07.000000', 'consum', 0.0226, 'lps'),
	(376880, 102, '2015-02-01 00:21:08.000000', 'consum', 0.0215, 'lps'),
	(376881, 102, '2015-02-01 00:21:09.000000', 'consum', 0.0211, 'lps'),
	(376882, 102, '2015-02-01 00:21:10.000000', 'consum', 0.0224, 'lps'),
	(376883, 102, '2015-02-01 00:21:11.000000', 'consum', 0.0230, 'lps'),
	(376884, 102, '2015-02-01 00:21:12.000000', 'consum', 0.0223, 'lps'),
	(376885, 102, '2015-02-01 00:21:13.000000', 'consum', 0.0214, 'lps'),
	(376886, 102, '2015-02-01 00:21:14.000000', 'consum', 0.0217, 'lps'),
	(376887, 102, '2015-02-01 00:21:15.000000', 'consum', 0.0211, 'lps'),
	(376888, 102, '2015-02-01 00:21:16.000000', 'consum', 0.0216, 'lps'),
	(376889, 102, '2015-02-01 00:21:17.000000', 'consum', 0.0215, 'lps'),
	(376890, 102, '2015-02-01 00:21:18.000000', 'consum', 0.0217, 'lps'),
	(376891, 102, '2015-02-01 00:21:19.000000', 'consum', 0.0232, 'lps'),
	(376892, 102, '2015-02-01 00:21:20.000000', 'consum', 0.0230, 'lps'),
	(376893, 102, '2015-02-01 00:21:21.000000', 'consum', 0.0223, 'lps'),
	(376894, 102, '2015-02-01 00:21:22.000000', 'consum', 0.0213, 'lps'),
	(376895, 102, '2015-02-01 00:21:23.000000', 'consum', 0.0212, 'lps'),
	(376896, 102, '2015-02-01 00:21:24.000000', 'consum', 0.0211, 'lps'),
	(376897, 102, '2015-02-01 00:21:25.000000', 'consum', 0.0210, 'lps'),
	(376898, 102, '2015-02-01 00:21:26.000000', 'consum', 0.0228, 'lps'),
	(376899, 102, '2015-02-01 00:21:27.000000', 'consum', 0.0211, 'lps'),
	(376900, 102, '2015-02-01 00:21:28.000000', 'consum', 0.0231, 'lps'),
	(376901, 102, '2015-02-01 00:21:29.000000', 'consum', 0.0219, 'lps'),
	(376902, 102, '2015-02-01 00:21:30.000000', 'consum', 0.0218, 'lps'),
	(376903, 102, '2015-02-01 00:21:31.000000', 'consum', 0.0221, 'lps'),
	(376904, 102, '2015-02-01 00:21:32.000000', 'consum', 0.0221, 'lps'),
	(376905, 102, '2015-02-01 00:21:33.000000', 'consum', 0.0231, 'lps'),
	(376906, 102, '2015-02-01 00:21:34.000000', 'consum', 0.0213, 'lps'),
	(376907, 102, '2015-02-01 00:21:35.000000', 'consum', 0.0211, 'lps'),
	(376908, 102, '2015-02-01 00:21:36.000000', 'consum', 0.0229, 'lps'),
	(376909, 102, '2015-02-01 00:21:37.000000', 'consum', 0.0231, 'lps'),
	(376910, 102, '2015-02-01 00:21:38.000000', 'consum', 0.0214, 'lps'),
	(376911, 102, '2015-02-01 00:21:39.000000', 'consum', 0.0214, 'lps'),
	(376912, 102, '2015-02-01 00:21:40.000000', 'consum', 0.0218, 'lps'),
	(376913, 102, '2015-02-01 00:21:41.000000', 'consum', 0.0214, 'lps'),
	(376914, 102, '2015-02-01 00:21:42.000000', 'consum', 0.0232, 'lps'),
	(376915, 102, '2015-02-01 00:21:43.000000', 'consum', 0.0214, 'lps'),
	(376916, 102, '2015-02-01 00:21:44.000000', 'consum', 0.0211, 'lps'),
	(376917, 102, '2015-02-01 00:21:45.000000', 'consum', 0.0225, 'lps'),
	(376918, 102, '2015-02-01 00:21:46.000000', 'consum', 0.0214, 'lps'),
	(376919, 102, '2015-02-01 00:21:47.000000', 'consum', 0.0210, 'lps'),
	(376920, 102, '2015-02-01 00:21:48.000000', 'consum', 0.0221, 'lps'),
	(376921, 102, '2015-02-01 00:21:49.000000', 'consum', 0.0218, 'lps'),
	(376922, 102, '2015-02-01 00:21:50.000000', 'consum', 0.0216, 'lps'),
	(376923, 102, '2015-02-01 00:21:51.000000', 'consum', 0.0220, 'lps'),
	(376924, 102, '2015-02-01 00:21:52.000000', 'consum', 0.0217, 'lps'),
	(376925, 102, '2015-02-01 00:21:53.000000', 'consum', 0.0217, 'lps'),
	(376926, 102, '2015-02-01 00:21:54.000000', 'consum', 0.0222, 'lps'),
	(376927, 102, '2015-02-01 00:21:55.000000', 'consum', 0.0230, 'lps'),
	(376928, 102, '2015-02-01 00:21:56.000000', 'consum', 0.0226, 'lps'),
	(376929, 102, '2015-02-01 00:21:57.000000', 'consum', 0.0231, 'lps'),
	(376930, 102, '2015-02-01 00:21:58.000000', 'consum', 0.0220, 'lps'),
	(376931, 102, '2015-02-01 00:21:59.000000', 'consum', 0.0220, 'lps'),
	(376932, 102, '2015-02-01 00:22:00.000000', 'consum', 0.0231, 'lps'),
	(376933, 102, '2015-02-01 00:22:01.000000', 'consum', 0.0219, 'lps'),
	(376934, 102, '2015-02-01 00:22:02.000000', 'consum', 0.0213, 'lps'),
	(376935, 102, '2015-02-01 00:22:03.000000', 'consum', 0.0222, 'lps'),
	(376936, 102, '2015-02-01 00:22:04.000000', 'consum', 0.0214, 'lps'),
	(376937, 102, '2015-02-01 00:22:05.000000', 'consum', 0.0219, 'lps'),
	(376938, 102, '2015-02-01 00:22:06.000000', 'consum', 0.0221, 'lps'),
	(376939, 102, '2015-02-01 00:22:07.000000', 'consum', 0.0217, 'lps'),
	(376940, 102, '2015-02-01 00:22:08.000000', 'consum', 0.0211, 'lps'),
	(376941, 102, '2015-02-01 00:22:09.000000', 'consum', 0.0218, 'lps'),
	(376942, 102, '2015-02-01 00:22:10.000000', 'consum', 0.0225, 'lps'),
	(376943, 102, '2015-02-01 00:22:11.000000', 'consum', 0.0214, 'lps'),
	(376944, 102, '2015-02-01 00:22:12.000000', 'consum', 0.0211, 'lps'),
	(376945, 102, '2015-02-01 00:22:13.000000', 'consum', 0.0226, 'lps'),
	(376946, 102, '2015-02-01 00:22:14.000000', 'consum', 0.0219, 'lps'),
	(376947, 102, '2015-02-01 00:22:15.000000', 'consum', 0.0232, 'lps'),
	(376948, 102, '2015-02-01 00:22:16.000000', 'consum', 0.0222, 'lps'),
	(376949, 102, '2015-02-01 00:22:17.000000', 'consum', 0.0229, 'lps'),
	(376950, 102, '2015-02-01 00:22:18.000000', 'consum', 0.0224, 'lps'),
	(376951, 102, '2015-02-01 00:22:19.000000', 'consum', 0.0225, 'lps'),
	(376952, 102, '2015-02-01 00:22:20.000000', 'consum', 0.0218, 'lps'),
	(376953, 102, '2015-02-01 00:22:21.000000', 'consum', 0.0230, 'lps'),
	(376954, 102, '2015-02-01 00:22:22.000000', 'consum', 0.0217, 'lps'),
	(376955, 102, '2015-02-01 00:22:23.000000', 'consum', 0.0232, 'lps'),
	(376956, 102, '2015-02-01 00:22:24.000000', 'consum', 0.0230, 'lps'),
	(376957, 102, '2015-02-01 00:22:25.000000', 'consum', 0.0223, 'lps'),
	(376958, 102, '2015-02-01 00:22:26.000000', 'consum', 0.0217, 'lps'),
	(376959, 102, '2015-02-01 00:22:27.000000', 'consum', 0.0226, 'lps'),
	(376960, 102, '2015-02-01 00:22:28.000000', 'consum', 0.0224, 'lps'),
	(376961, 102, '2015-02-01 00:22:29.000000', 'consum', 0.0232, 'lps'),
	(376962, 102, '2015-02-01 00:22:30.000000', 'consum', 0.0211, 'lps'),
	(376963, 102, '2015-02-01 00:22:31.000000', 'consum', 0.0220, 'lps'),
	(376964, 102, '2015-02-01 00:22:32.000000', 'consum', 0.0210, 'lps'),
	(376965, 102, '2015-02-01 00:22:33.000000', 'consum', 0.0227, 'lps'),
	(376966, 102, '2015-02-01 00:22:34.000000', 'consum', 0.0225, 'lps'),
	(376967, 102, '2015-02-01 00:22:35.000000', 'consum', 0.0214, 'lps'),
	(376968, 102, '2015-02-01 00:22:36.000000', 'consum', 0.0231, 'lps'),
	(376969, 102, '2015-02-01 00:22:37.000000', 'consum', 0.0213, 'lps'),
	(376970, 102, '2015-02-01 00:22:38.000000', 'consum', 0.0228, 'lps'),
	(376971, 102, '2015-02-01 00:22:39.000000', 'consum', 0.0224, 'lps'),
	(376972, 102, '2015-02-01 00:22:40.000000', 'consum', 0.0228, 'lps'),
	(376973, 102, '2015-02-01 00:22:41.000000', 'consum', 0.0213, 'lps'),
	(376974, 102, '2015-02-01 00:22:42.000000', 'consum', 0.0217, 'lps'),
	(376975, 102, '2015-02-01 00:22:43.000000', 'consum', 0.0212, 'lps'),
	(376976, 102, '2015-02-01 00:22:44.000000', 'consum', 0.0225, 'lps'),
	(376977, 102, '2015-02-01 00:22:45.000000', 'consum', 0.0211, 'lps'),
	(376978, 102, '2015-02-01 00:22:46.000000', 'consum', 0.0216, 'lps'),
	(376979, 102, '2015-02-01 00:22:47.000000', 'consum', 0.0212, 'lps'),
	(376980, 102, '2015-02-01 00:22:48.000000', 'consum', 0.0228, 'lps'),
	(376981, 102, '2015-02-01 00:22:49.000000', 'consum', 0.0224, 'lps'),
	(376982, 102, '2015-02-01 00:22:50.000000', 'consum', 0.0227, 'lps'),
	(376983, 102, '2015-02-01 00:22:51.000000', 'consum', 0.0232, 'lps'),
	(376984, 102, '2015-02-01 00:22:52.000000', 'consum', 0.0222, 'lps'),
	(376985, 102, '2015-02-01 00:22:53.000000', 'consum', 0.0228, 'lps'),
	(376986, 102, '2015-02-01 00:22:54.000000', 'consum', 0.0219, 'lps'),
	(376987, 102, '2015-02-01 00:22:55.000000', 'consum', 0.0225, 'lps'),
	(376988, 102, '2015-02-01 00:22:56.000000', 'consum', 0.0210, 'lps'),
	(376989, 102, '2015-02-01 00:22:57.000000', 'consum', 0.0213, 'lps'),
	(376990, 102, '2015-02-01 00:22:58.000000', 'consum', 0.0224, 'lps'),
	(376991, 102, '2015-02-01 00:22:59.000000', 'consum', 0.0225, 'lps'),
	(376992, 102, '2015-02-01 00:23:00.000000', 'consum', 0.0223, 'lps'),
	(376993, 102, '2015-02-01 00:23:01.000000', 'consum', 0.0231, 'lps'),
	(376994, 102, '2015-02-01 00:23:02.000000', 'consum', 0.0229, 'lps'),
	(376995, 102, '2015-02-01 00:23:03.000000', 'consum', 0.0221, 'lps'),
	(376996, 102, '2015-02-01 00:23:04.000000', 'consum', 0.0232, 'lps'),
	(376997, 102, '2015-02-01 00:23:05.000000', 'consum', 0.0218, 'lps'),
	(376998, 102, '2015-02-01 00:23:06.000000', 'consum', 0.0230, 'lps'),
	(376999, 102, '2015-02-01 00:23:07.000000', 'consum', 0.0218, 'lps'),
	(377000, 102, '2015-02-01 00:23:08.000000', 'consum', 0.0215, 'lps'),
	(377001, 102, '2015-02-01 00:23:09.000000', 'consum', 0.0231, 'lps'),
	(377002, 102, '2015-02-01 00:23:10.000000', 'consum', 0.0211, 'lps'),
	(377003, 102, '2015-02-01 00:23:11.000000', 'consum', 0.0222, 'lps'),
	(377004, 102, '2015-02-01 00:23:12.000000', 'consum', 0.0222, 'lps'),
	(377005, 102, '2015-02-01 00:23:13.000000', 'consum', 0.0213, 'lps'),
	(377006, 102, '2015-02-01 00:23:14.000000', 'consum', 0.0232, 'lps'),
	(377007, 102, '2015-02-01 00:23:15.000000', 'consum', 0.0223, 'lps'),
	(377008, 102, '2015-02-01 00:23:16.000000', 'consum', 0.0230, 'lps'),
	(377009, 102, '2015-02-01 00:23:17.000000', 'consum', 0.0226, 'lps'),
	(377010, 102, '2015-02-01 00:23:18.000000', 'consum', 0.0229, 'lps'),
	(377011, 102, '2015-02-01 00:23:19.000000', 'consum', 0.0214, 'lps'),
	(377012, 102, '2015-02-01 00:23:20.000000', 'consum', 0.0217, 'lps'),
	(377013, 102, '2015-02-01 00:23:21.000000', 'consum', 0.0211, 'lps'),
	(377014, 102, '2015-02-01 00:23:22.000000', 'consum', 0.0218, 'lps'),
	(377015, 102, '2015-02-01 00:23:23.000000', 'consum', 0.0224, 'lps'),
	(377016, 102, '2015-02-01 00:23:24.000000', 'consum', 0.0211, 'lps'),
	(377017, 102, '2015-02-01 00:23:25.000000', 'consum', 0.0220, 'lps'),
	(377018, 102, '2015-02-01 00:23:26.000000', 'consum', 0.0232, 'lps'),
	(377019, 102, '2015-02-01 00:23:27.000000', 'consum', 0.0224, 'lps'),
	(377020, 102, '2015-02-01 00:23:28.000000', 'consum', 0.0215, 'lps'),
	(377021, 102, '2015-02-01 00:23:29.000000', 'consum', 0.0217, 'lps'),
	(377022, 102, '2015-02-01 00:23:30.000000', 'consum', 0.0231, 'lps'),
	(377023, 102, '2015-02-01 00:23:31.000000', 'consum', 0.0225, 'lps'),
	(377024, 102, '2015-02-01 00:23:32.000000', 'consum', 0.0222, 'lps'),
	(377025, 102, '2015-02-01 00:23:33.000000', 'consum', 0.0227, 'lps'),
	(377026, 102, '2015-02-01 00:23:34.000000', 'consum', 0.0214, 'lps'),
	(377027, 102, '2015-02-01 00:23:35.000000', 'consum', 0.0225, 'lps'),
	(377028, 102, '2015-02-01 00:23:36.000000', 'consum', 0.0228, 'lps'),
	(377029, 102, '2015-02-01 00:23:37.000000', 'consum', 0.0231, 'lps'),
	(377030, 102, '2015-02-01 00:23:38.000000', 'consum', 0.0216, 'lps'),
	(377031, 102, '2015-02-01 00:23:39.000000', 'consum', 0.0224, 'lps'),
	(377032, 102, '2015-02-01 00:23:40.000000', 'consum', 0.0216, 'lps'),
	(377033, 102, '2015-02-01 00:23:41.000000', 'consum', 0.0222, 'lps'),
	(377034, 102, '2015-02-01 00:23:42.000000', 'consum', 0.0228, 'lps'),
	(377035, 102, '2015-02-01 00:23:43.000000', 'consum', 0.0219, 'lps'),
	(377036, 102, '2015-02-01 00:23:44.000000', 'consum', 0.0226, 'lps'),
	(377037, 102, '2015-02-01 00:23:45.000000', 'consum', 0.0216, 'lps'),
	(377038, 102, '2015-02-01 00:23:46.000000', 'consum', 0.0214, 'lps'),
	(377039, 102, '2015-02-01 00:23:47.000000', 'consum', 0.0216, 'lps'),
	(377040, 102, '2015-02-01 00:23:48.000000', 'consum', 0.0225, 'lps'),
	(377041, 102, '2015-02-01 00:23:49.000000', 'consum', 0.0225, 'lps'),
	(377042, 102, '2015-02-01 00:23:50.000000', 'consum', 0.0215, 'lps'),
	(377043, 102, '2015-02-01 00:23:51.000000', 'consum', 0.0216, 'lps'),
	(377044, 102, '2015-02-01 00:23:52.000000', 'consum', 0.0226, 'lps'),
	(377045, 102, '2015-02-01 00:23:53.000000', 'consum', 0.0225, 'lps'),
	(377046, 102, '2015-02-01 00:23:54.000000', 'consum', 0.0213, 'lps'),
	(377047, 102, '2015-02-01 00:23:55.000000', 'consum', 0.0227, 'lps'),
	(377048, 102, '2015-02-01 00:23:56.000000', 'consum', 0.0219, 'lps'),
	(377049, 102, '2015-02-01 00:23:57.000000', 'consum', 0.0227, 'lps'),
	(377050, 102, '2015-02-01 00:23:58.000000', 'consum', 0.0224, 'lps'),
	(377051, 102, '2015-02-01 00:23:59.000000', 'consum', 0.0228, 'lps'),
	(377052, 102, '2015-02-01 00:24:00.000000', 'consum', 0.0214, 'lps'),
	(377053, 102, '2015-02-01 00:24:01.000000', 'consum', 0.0220, 'lps'),
	(377054, 102, '2015-02-01 00:24:02.000000', 'consum', 0.0229, 'lps'),
	(377055, 102, '2015-02-01 00:24:03.000000', 'consum', 0.0226, 'lps'),
	(377056, 102, '2015-02-01 00:24:04.000000', 'consum', 0.0214, 'lps'),
	(377057, 102, '2015-02-01 00:24:05.000000', 'consum', 0.0226, 'lps'),
	(377058, 102, '2015-02-01 00:24:06.000000', 'consum', 0.0232, 'lps'),
	(377059, 102, '2015-02-01 00:24:07.000000', 'consum', 0.0229, 'lps'),
	(377060, 102, '2015-02-01 00:24:08.000000', 'consum', 0.0214, 'lps'),
	(377061, 102, '2015-02-01 00:24:09.000000', 'consum', 0.0219, 'lps'),
	(377062, 102, '2015-02-01 00:24:10.000000', 'consum', 0.0220, 'lps'),
	(377063, 102, '2015-02-01 00:24:11.000000', 'consum', 0.0212, 'lps'),
	(377064, 102, '2015-02-01 00:24:12.000000', 'consum', 0.0213, 'lps'),
	(377065, 102, '2015-02-01 00:24:13.000000', 'consum', 0.0220, 'lps'),
	(377066, 102, '2015-02-01 00:24:14.000000', 'consum', 0.0226, 'lps'),
	(377067, 102, '2015-02-01 00:24:15.000000', 'consum', 0.0217, 'lps'),
	(377068, 102, '2015-02-01 00:24:16.000000', 'consum', 0.0218, 'lps'),
	(377069, 102, '2015-02-01 00:24:17.000000', 'consum', 0.0210, 'lps'),
	(377070, 102, '2015-02-01 00:24:18.000000', 'consum', 0.0230, 'lps'),
	(377071, 102, '2015-02-01 00:24:19.000000', 'consum', 0.0220, 'lps'),
	(377072, 102, '2015-02-01 00:24:20.000000', 'consum', 0.0222, 'lps'),
	(377073, 102, '2015-02-01 00:24:21.000000', 'consum', 0.0219, 'lps'),
	(377074, 102, '2015-02-01 00:24:22.000000', 'consum', 0.0219, 'lps'),
	(377075, 102, '2015-02-01 00:24:23.000000', 'consum', 0.0229, 'lps'),
	(377076, 102, '2015-02-01 00:24:24.000000', 'consum', 0.0230, 'lps'),
	(377077, 102, '2015-02-01 00:24:25.000000', 'consum', 0.0210, 'lps'),
	(377078, 102, '2015-02-01 00:24:26.000000', 'consum', 0.0219, 'lps'),
	(377079, 102, '2015-02-01 00:24:27.000000', 'consum', 0.0211, 'lps'),
	(377080, 102, '2015-02-01 00:24:28.000000', 'consum', 0.0231, 'lps'),
	(377081, 102, '2015-02-01 00:24:29.000000', 'consum', 0.0224, 'lps'),
	(377082, 102, '2015-02-01 00:24:30.000000', 'consum', 0.0216, 'lps'),
	(377083, 102, '2015-02-01 00:24:31.000000', 'consum', 0.0221, 'lps'),
	(377084, 102, '2015-02-01 00:24:32.000000', 'consum', 0.0225, 'lps'),
	(377085, 102, '2015-02-01 00:24:33.000000', 'consum', 0.0228, 'lps'),
	(377086, 102, '2015-02-01 00:24:34.000000', 'consum', 0.0212, 'lps'),
	(377087, 102, '2015-02-01 00:24:35.000000', 'consum', 0.0212, 'lps'),
	(377088, 102, '2015-02-01 00:24:36.000000', 'consum', 0.0212, 'lps'),
	(377089, 102, '2015-02-01 00:24:37.000000', 'consum', 0.0218, 'lps'),
	(377090, 102, '2015-02-01 00:24:38.000000', 'consum', 0.0218, 'lps'),
	(377091, 102, '2015-02-01 00:24:39.000000', 'consum', 0.0230, 'lps'),
	(377092, 102, '2015-02-01 00:24:40.000000', 'consum', 0.0216, 'lps'),
	(377093, 102, '2015-02-01 00:24:41.000000', 'consum', 0.0227, 'lps'),
	(377094, 102, '2015-02-01 00:24:42.000000', 'consum', 0.0230, 'lps'),
	(377095, 102, '2015-02-01 00:24:43.000000', 'consum', 0.0216, 'lps'),
	(377096, 102, '2015-02-01 00:24:44.000000', 'consum', 0.0224, 'lps'),
	(377097, 102, '2015-02-01 00:24:45.000000', 'consum', 0.0217, 'lps'),
	(377098, 102, '2015-02-01 00:24:46.000000', 'consum', 0.0228, 'lps'),
	(377099, 102, '2015-02-01 00:24:47.000000', 'consum', 0.0211, 'lps'),
	(377100, 102, '2015-02-01 00:24:48.000000', 'consum', 0.0230, 'lps'),
	(377101, 102, '2015-02-01 00:24:49.000000', 'consum', 0.0217, 'lps'),
	(377102, 102, '2015-02-01 00:24:50.000000', 'consum', 0.0230, 'lps'),
	(377103, 102, '2015-02-01 00:24:51.000000', 'consum', 0.0220, 'lps'),
	(377104, 102, '2015-02-01 00:24:52.000000', 'consum', 0.0224, 'lps'),
	(377105, 102, '2015-02-01 00:24:53.000000', 'consum', 0.0228, 'lps'),
	(377106, 102, '2015-02-01 00:24:54.000000', 'consum', 0.0210, 'lps'),
	(377107, 102, '2015-02-01 00:24:55.000000', 'consum', 0.0227, 'lps'),
	(377108, 102, '2015-02-01 00:24:56.000000', 'consum', 0.0227, 'lps'),
	(377109, 102, '2015-02-01 00:24:57.000000', 'consum', 0.0220, 'lps'),
	(377110, 102, '2015-02-01 00:24:58.000000', 'consum', 0.0211, 'lps'),
	(377111, 102, '2015-02-01 00:24:59.000000', 'consum', 0.0232, 'lps'),
	(377112, 102, '2015-02-01 00:25:00.000000', 'consum', 0.0225, 'lps'),
	(377113, 102, '2015-02-01 00:25:01.000000', 'consum', 0.0220, 'lps'),
	(377114, 102, '2015-02-01 00:25:02.000000', 'consum', 0.0213, 'lps'),
	(377115, 102, '2015-02-01 00:25:03.000000', 'consum', 0.0222, 'lps'),
	(377116, 102, '2015-02-01 00:25:04.000000', 'consum', 0.0213, 'lps'),
	(377117, 102, '2015-02-01 00:25:05.000000', 'consum', 0.0212, 'lps'),
	(377118, 102, '2015-02-01 00:25:06.000000', 'consum', 0.0212, 'lps'),
	(377119, 102, '2015-02-01 00:25:07.000000', 'consum', 0.0217, 'lps'),
	(377120, 102, '2015-02-01 00:25:08.000000', 'consum', 0.0214, 'lps'),
	(377121, 102, '2015-02-01 00:25:09.000000', 'consum', 0.0231, 'lps'),
	(377122, 102, '2015-02-01 00:25:10.000000', 'consum', 0.0214, 'lps'),
	(377123, 102, '2015-02-01 00:25:11.000000', 'consum', 0.0212, 'lps'),
	(377124, 102, '2015-02-01 00:25:12.000000', 'consum', 0.0210, 'lps'),
	(377125, 102, '2015-02-01 00:25:13.000000', 'consum', 0.0229, 'lps'),
	(377126, 102, '2015-02-01 00:25:14.000000', 'consum', 0.0212, 'lps'),
	(377127, 102, '2015-02-01 00:25:15.000000', 'consum', 0.0232, 'lps'),
	(377128, 102, '2015-02-01 00:25:16.000000', 'consum', 0.0223, 'lps'),
	(377129, 102, '2015-02-01 00:25:17.000000', 'consum', 0.0210, 'lps'),
	(377130, 102, '2015-02-01 00:25:18.000000', 'consum', 0.0218, 'lps'),
	(377131, 102, '2015-02-01 00:25:19.000000', 'consum', 0.0228, 'lps'),
	(377132, 102, '2015-02-01 00:25:20.000000', 'consum', 0.0232, 'lps'),
	(377133, 102, '2015-02-01 00:25:21.000000', 'consum', 0.0217, 'lps'),
	(377134, 102, '2015-02-01 00:25:22.000000', 'consum', 0.0229, 'lps'),
	(377135, 102, '2015-02-01 00:25:23.000000', 'consum', 0.0213, 'lps'),
	(377136, 102, '2015-02-01 00:25:24.000000', 'consum', 0.0213, 'lps'),
	(377137, 102, '2015-02-01 00:25:25.000000', 'consum', 0.0218, 'lps'),
	(377138, 102, '2015-02-01 00:25:26.000000', 'consum', 0.0220, 'lps'),
	(377139, 102, '2015-02-01 00:25:27.000000', 'consum', 0.0214, 'lps'),
	(377140, 102, '2015-02-01 00:25:28.000000', 'consum', 0.0221, 'lps'),
	(377141, 102, '2015-02-01 00:25:29.000000', 'consum', 0.0232, 'lps'),
	(377142, 102, '2015-02-01 00:25:30.000000', 'consum', 0.0218, 'lps'),
	(377143, 102, '2015-02-01 00:25:31.000000', 'consum', 0.0230, 'lps'),
	(377144, 102, '2015-02-01 00:25:32.000000', 'consum', 0.0219, 'lps'),
	(377145, 102, '2015-02-01 00:25:33.000000', 'consum', 0.0218, 'lps'),
	(377146, 102, '2015-02-01 00:25:34.000000', 'consum', 0.0223, 'lps'),
	(377147, 102, '2015-02-01 00:25:35.000000', 'consum', 0.0229, 'lps'),
	(377148, 102, '2015-02-01 00:25:36.000000', 'consum', 0.0222, 'lps'),
	(377149, 102, '2015-02-01 00:25:37.000000', 'consum', 0.0211, 'lps'),
	(377150, 102, '2015-02-01 00:25:38.000000', 'consum', 0.0226, 'lps'),
	(377151, 102, '2015-02-01 00:25:39.000000', 'consum', 0.0219, 'lps'),
	(377152, 102, '2015-02-01 00:25:40.000000', 'consum', 0.0230, 'lps'),
	(377153, 102, '2015-02-01 00:25:41.000000', 'consum', 0.0214, 'lps'),
	(377154, 102, '2015-02-01 00:25:42.000000', 'consum', 0.0217, 'lps'),
	(377155, 102, '2015-02-01 00:25:43.000000', 'consum', 0.0210, 'lps'),
	(377156, 102, '2015-02-01 00:25:44.000000', 'consum', 0.0213, 'lps'),
	(377157, 102, '2015-02-01 00:25:45.000000', 'consum', 0.0224, 'lps'),
	(377158, 102, '2015-02-01 00:25:46.000000', 'consum', 0.0226, 'lps'),
	(377159, 102, '2015-02-01 00:25:47.000000', 'consum', 0.0228, 'lps'),
	(377160, 102, '2015-02-01 00:25:48.000000', 'consum', 0.0226, 'lps'),
	(377161, 102, '2015-02-01 00:25:49.000000', 'consum', 0.0215, 'lps'),
	(377162, 102, '2015-02-01 00:25:50.000000', 'consum', 0.0210, 'lps'),
	(377163, 102, '2015-02-01 00:25:51.000000', 'consum', 0.0217, 'lps'),
	(377164, 102, '2015-02-01 00:25:52.000000', 'consum', 0.0222, 'lps'),
	(377165, 102, '2015-02-01 00:25:53.000000', 'consum', 0.0229, 'lps'),
	(377166, 102, '2015-02-01 00:25:54.000000', 'consum', 0.0221, 'lps'),
	(377167, 102, '2015-02-01 00:25:55.000000', 'consum', 0.0212, 'lps'),
	(377168, 102, '2015-02-01 00:25:56.000000', 'consum', 0.0230, 'lps'),
	(377169, 102, '2015-02-01 00:25:57.000000', 'consum', 0.0214, 'lps'),
	(377170, 102, '2015-02-01 00:25:58.000000', 'consum', 0.0217, 'lps'),
	(377171, 102, '2015-02-01 00:25:59.000000', 'consum', 0.0232, 'lps'),
	(377172, 102, '2015-02-01 00:26:00.000000', 'consum', 0.0232, 'lps'),
	(377173, 102, '2015-02-01 00:26:01.000000', 'consum', 0.0210, 'lps'),
	(377174, 102, '2015-02-01 00:26:02.000000', 'consum', 0.0210, 'lps'),
	(377175, 102, '2015-02-01 00:26:03.000000', 'consum', 0.0213, 'lps'),
	(377176, 102, '2015-02-01 00:26:04.000000', 'consum', 0.0223, 'lps'),
	(377177, 102, '2015-02-01 00:26:05.000000', 'consum', 0.0221, 'lps'),
	(377178, 102, '2015-02-01 00:26:06.000000', 'consum', 0.0228, 'lps'),
	(377179, 102, '2015-02-01 00:26:07.000000', 'consum', 0.0222, 'lps'),
	(377180, 102, '2015-02-01 00:26:08.000000', 'consum', 0.0214, 'lps'),
	(377181, 102, '2015-02-01 00:26:09.000000', 'consum', 0.0218, 'lps'),
	(377182, 102, '2015-02-01 00:26:10.000000', 'consum', 0.0217, 'lps'),
	(377183, 102, '2015-02-01 00:26:11.000000', 'consum', 0.0219, 'lps'),
	(377184, 102, '2015-02-01 00:26:12.000000', 'consum', 0.0213, 'lps'),
	(377185, 102, '2015-02-01 00:26:13.000000', 'consum', 0.0221, 'lps'),
	(377186, 102, '2015-02-01 00:26:14.000000', 'consum', 0.0211, 'lps'),
	(377187, 102, '2015-02-01 00:26:15.000000', 'consum', 0.0230, 'lps'),
	(377188, 102, '2015-02-01 00:26:16.000000', 'consum', 0.0212, 'lps'),
	(377189, 102, '2015-02-01 00:26:17.000000', 'consum', 0.0232, 'lps'),
	(377190, 102, '2015-02-01 00:26:18.000000', 'consum', 0.0223, 'lps'),
	(377191, 102, '2015-02-01 00:26:19.000000', 'consum', 0.0211, 'lps'),
	(377192, 102, '2015-02-01 00:26:20.000000', 'consum', 0.0219, 'lps'),
	(377193, 102, '2015-02-01 00:26:21.000000', 'consum', 0.0210, 'lps'),
	(377194, 102, '2015-02-01 00:26:22.000000', 'consum', 0.0226, 'lps'),
	(377195, 102, '2015-02-01 00:26:23.000000', 'consum', 0.0224, 'lps'),
	(377196, 102, '2015-02-01 00:26:24.000000', 'consum', 0.0210, 'lps'),
	(377197, 102, '2015-02-01 00:26:25.000000', 'consum', 0.0215, 'lps'),
	(377198, 102, '2015-02-01 00:26:26.000000', 'consum', 0.0210, 'lps'),
	(377199, 102, '2015-02-01 00:26:27.000000', 'consum', 0.0218, 'lps'),
	(377200, 102, '2015-02-01 00:26:28.000000', 'consum', 0.0230, 'lps'),
	(377201, 102, '2015-02-01 00:26:29.000000', 'consum', 0.0216, 'lps'),
	(377202, 102, '2015-02-01 00:26:30.000000', 'consum', 0.0227, 'lps'),
	(377203, 102, '2015-02-01 00:26:31.000000', 'consum', 0.0229, 'lps'),
	(377204, 102, '2015-02-01 00:26:32.000000', 'consum', 0.0212, 'lps'),
	(377205, 102, '2015-02-01 00:26:33.000000', 'consum', 0.0231, 'lps'),
	(377206, 102, '2015-02-01 00:26:34.000000', 'consum', 0.0216, 'lps'),
	(377207, 102, '2015-02-01 00:26:35.000000', 'consum', 0.0223, 'lps'),
	(377208, 102, '2015-02-01 00:26:36.000000', 'consum', 0.0214, 'lps'),
	(377209, 102, '2015-02-01 00:26:37.000000', 'consum', 0.0213, 'lps'),
	(377210, 102, '2015-02-01 00:26:38.000000', 'consum', 0.0214, 'lps'),
	(377211, 102, '2015-02-01 00:26:39.000000', 'consum', 0.0222, 'lps'),
	(377212, 102, '2015-02-01 00:26:40.000000', 'consum', 0.0213, 'lps'),
	(377213, 102, '2015-02-01 00:26:41.000000', 'consum', 0.0211, 'lps'),
	(377214, 102, '2015-02-01 00:26:42.000000', 'consum', 0.0230, 'lps'),
	(377215, 102, '2015-02-01 00:26:43.000000', 'consum', 0.0217, 'lps'),
	(377216, 102, '2015-02-01 00:26:44.000000', 'consum', 0.0231, 'lps'),
	(377217, 102, '2015-02-01 00:26:45.000000', 'consum', 0.0224, 'lps'),
	(377218, 102, '2015-02-01 00:26:46.000000', 'consum', 0.0220, 'lps'),
	(377219, 102, '2015-02-01 00:26:47.000000', 'consum', 0.0217, 'lps'),
	(377220, 102, '2015-02-01 00:26:48.000000', 'consum', 0.0215, 'lps'),
	(377221, 102, '2015-02-01 00:26:49.000000', 'consum', 0.0214, 'lps'),
	(377222, 102, '2015-02-01 00:26:50.000000', 'consum', 0.0216, 'lps'),
	(377223, 102, '2015-02-01 00:26:51.000000', 'consum', 0.0228, 'lps'),
	(377224, 102, '2015-02-01 00:26:52.000000', 'consum', 0.0213, 'lps'),
	(377225, 102, '2015-02-01 00:26:53.000000', 'consum', 0.0216, 'lps'),
	(377226, 102, '2015-02-01 00:26:54.000000', 'consum', 0.0211, 'lps'),
	(377227, 102, '2015-02-01 00:26:55.000000', 'consum', 0.0221, 'lps'),
	(377228, 102, '2015-02-01 00:26:56.000000', 'consum', 0.0218, 'lps'),
	(377229, 102, '2015-02-01 00:26:57.000000', 'consum', 0.0215, 'lps'),
	(377230, 102, '2015-02-01 00:26:58.000000', 'consum', 0.0211, 'lps'),
	(377231, 102, '2015-02-01 00:26:59.000000', 'consum', 0.0224, 'lps'),
	(377232, 102, '2015-02-01 00:27:00.000000', 'consum', 0.0231, 'lps'),
	(377233, 102, '2015-02-01 00:27:01.000000', 'consum', 0.0229, 'lps'),
	(377234, 102, '2015-02-01 00:27:02.000000', 'consum', 0.0221, 'lps'),
	(377235, 102, '2015-02-01 00:27:03.000000', 'consum', 0.0228, 'lps'),
	(377236, 102, '2015-02-01 00:27:04.000000', 'consum', 0.0224, 'lps'),
	(377237, 102, '2015-02-01 00:27:05.000000', 'consum', 0.0226, 'lps'),
	(377238, 102, '2015-02-01 00:27:06.000000', 'consum', 0.0225, 'lps'),
	(377239, 102, '2015-02-01 00:27:07.000000', 'consum', 0.0214, 'lps'),
	(377240, 102, '2015-02-01 00:27:08.000000', 'consum', 0.0232, 'lps'),
	(377241, 102, '2015-02-01 00:27:09.000000', 'consum', 0.0215, 'lps'),
	(377242, 102, '2015-02-01 00:27:10.000000', 'consum', 0.0215, 'lps'),
	(377243, 102, '2015-02-01 00:27:11.000000', 'consum', 0.0222, 'lps'),
	(377244, 102, '2015-02-01 00:27:12.000000', 'consum', 0.0232, 'lps'),
	(377245, 102, '2015-02-01 00:27:13.000000', 'consum', 0.0214, 'lps'),
	(377246, 102, '2015-02-01 00:27:14.000000', 'consum', 0.0210, 'lps'),
	(377247, 102, '2015-02-01 00:27:15.000000', 'consum', 0.0222, 'lps'),
	(377248, 102, '2015-02-01 00:27:16.000000', 'consum', 0.0223, 'lps'),
	(377249, 102, '2015-02-01 00:27:17.000000', 'consum', 0.0218, 'lps'),
	(377250, 102, '2015-02-01 00:27:18.000000', 'consum', 0.0210, 'lps'),
	(377251, 102, '2015-02-01 00:27:19.000000', 'consum', 0.0231, 'lps'),
	(377252, 102, '2015-02-01 00:27:20.000000', 'consum', 0.0227, 'lps'),
	(377253, 102, '2015-02-01 00:27:21.000000', 'consum', 0.0230, 'lps'),
	(377254, 102, '2015-02-01 00:27:22.000000', 'consum', 0.0216, 'lps'),
	(377255, 102, '2015-02-01 00:27:23.000000', 'consum', 0.0224, 'lps'),
	(377256, 102, '2015-02-01 00:27:24.000000', 'consum', 0.0217, 'lps'),
	(377257, 102, '2015-02-01 00:27:25.000000', 'consum', 0.0228, 'lps'),
	(377258, 102, '2015-02-01 00:27:26.000000', 'consum', 0.0211, 'lps'),
	(377259, 102, '2015-02-01 00:27:27.000000', 'consum', 0.0228, 'lps'),
	(377260, 102, '2015-02-01 00:27:28.000000', 'consum', 0.0231, 'lps'),
	(377261, 102, '2015-02-01 00:27:29.000000', 'consum', 0.0216, 'lps'),
	(377262, 102, '2015-02-01 00:27:30.000000', 'consum', 0.0223, 'lps'),
	(377263, 102, '2015-02-01 00:27:31.000000', 'consum', 0.0213, 'lps'),
	(377264, 102, '2015-02-01 00:27:32.000000', 'consum', 0.0229, 'lps'),
	(377265, 102, '2015-02-01 00:27:33.000000', 'consum', 0.0230, 'lps'),
	(377266, 102, '2015-02-01 00:27:34.000000', 'consum', 0.0229, 'lps'),
	(377267, 102, '2015-02-01 00:27:35.000000', 'consum', 0.0224, 'lps'),
	(377268, 102, '2015-02-01 00:27:36.000000', 'consum', 0.0221, 'lps'),
	(377269, 102, '2015-02-01 00:27:37.000000', 'consum', 0.0226, 'lps'),
	(377270, 102, '2015-02-01 00:27:38.000000', 'consum', 0.0211, 'lps'),
	(377271, 102, '2015-02-01 00:27:39.000000', 'consum', 0.0211, 'lps'),
	(377272, 102, '2015-02-01 00:27:40.000000', 'consum', 0.0215, 'lps'),
	(377273, 102, '2015-02-01 00:27:41.000000', 'consum', 0.0231, 'lps'),
	(377274, 102, '2015-02-01 00:27:42.000000', 'consum', 0.0211, 'lps'),
	(377275, 102, '2015-02-01 00:27:43.000000', 'consum', 0.0218, 'lps'),
	(377276, 102, '2015-02-01 00:27:44.000000', 'consum', 0.0226, 'lps'),
	(377277, 102, '2015-02-01 00:27:45.000000', 'consum', 0.0222, 'lps'),
	(377278, 102, '2015-02-01 00:27:46.000000', 'consum', 0.0221, 'lps'),
	(377279, 102, '2015-02-01 00:27:47.000000', 'consum', 0.0231, 'lps'),
	(377280, 102, '2015-02-01 00:27:48.000000', 'consum', 0.0214, 'lps'),
	(377281, 102, '2015-02-01 00:27:49.000000', 'consum', 0.0214, 'lps'),
	(377282, 102, '2015-02-01 00:27:50.000000', 'consum', 0.0218, 'lps'),
	(377283, 102, '2015-02-01 00:27:51.000000', 'consum', 0.0215, 'lps'),
	(377284, 102, '2015-02-01 00:27:52.000000', 'consum', 0.0232, 'lps'),
	(377285, 102, '2015-02-01 00:27:53.000000', 'consum', 0.0217, 'lps'),
	(377286, 102, '2015-02-01 00:27:54.000000', 'consum', 0.0226, 'lps'),
	(377287, 102, '2015-02-01 00:27:55.000000', 'consum', 0.0222, 'lps'),
	(377288, 102, '2015-02-01 00:27:56.000000', 'consum', 0.0221, 'lps'),
	(377289, 102, '2015-02-01 00:27:57.000000', 'consum', 0.0230, 'lps'),
	(377290, 102, '2015-02-01 00:27:58.000000', 'consum', 0.0211, 'lps'),
	(377291, 102, '2015-02-01 00:27:59.000000', 'consum', 0.0223, 'lps'),
	(377292, 102, '2015-02-01 00:28:00.000000', 'consum', 0.0226, 'lps'),
	(377293, 102, '2015-02-01 00:28:01.000000', 'consum', 0.0229, 'lps'),
	(377294, 102, '2015-02-01 00:28:02.000000', 'consum', 0.0210, 'lps'),
	(377295, 102, '2015-02-01 00:28:03.000000', 'consum', 0.0223, 'lps'),
	(377296, 102, '2015-02-01 00:28:04.000000', 'consum', 0.0229, 'lps'),
	(377297, 102, '2015-02-01 00:28:05.000000', 'consum', 0.0221, 'lps'),
	(377298, 102, '2015-02-01 00:28:06.000000', 'consum', 0.0210, 'lps'),
	(377299, 102, '2015-02-01 00:28:07.000000', 'consum', 0.0223, 'lps'),
	(377300, 102, '2015-02-01 00:28:08.000000', 'consum', 0.0231, 'lps'),
	(377301, 102, '2015-02-01 00:28:09.000000', 'consum', 0.0228, 'lps'),
	(377302, 102, '2015-02-01 00:28:10.000000', 'consum', 0.0215, 'lps'),
	(377303, 102, '2015-02-01 00:28:11.000000', 'consum', 0.0227, 'lps'),
	(377304, 102, '2015-02-01 00:28:12.000000', 'consum', 0.0214, 'lps'),
	(377305, 102, '2015-02-01 00:28:13.000000', 'consum', 0.0224, 'lps'),
	(377306, 102, '2015-02-01 00:28:14.000000', 'consum', 0.0222, 'lps'),
	(377307, 102, '2015-02-01 00:28:15.000000', 'consum', 0.0230, 'lps'),
	(377308, 102, '2015-02-01 00:28:16.000000', 'consum', 0.0227, 'lps'),
	(377309, 102, '2015-02-01 00:28:17.000000', 'consum', 0.0214, 'lps'),
	(377310, 102, '2015-02-01 00:28:18.000000', 'consum', 0.0227, 'lps'),
	(377311, 102, '2015-02-01 00:28:19.000000', 'consum', 0.0211, 'lps'),
	(377312, 102, '2015-02-01 00:28:20.000000', 'consum', 0.0213, 'lps'),
	(377313, 102, '2015-02-01 00:28:21.000000', 'consum', 0.0222, 'lps'),
	(377314, 102, '2015-02-01 00:28:22.000000', 'consum', 0.0217, 'lps'),
	(377315, 102, '2015-02-01 00:28:23.000000', 'consum', 0.0232, 'lps'),
	(377316, 102, '2015-02-01 00:28:24.000000', 'consum', 0.0231, 'lps'),
	(377317, 102, '2015-02-01 00:28:25.000000', 'consum', 0.0227, 'lps'),
	(377318, 102, '2015-02-01 00:28:26.000000', 'consum', 0.0230, 'lps'),
	(377319, 102, '2015-02-01 00:28:27.000000', 'consum', 0.0215, 'lps'),
	(377320, 102, '2015-02-01 00:28:28.000000', 'consum', 0.0223, 'lps'),
	(377321, 102, '2015-02-01 00:28:29.000000', 'consum', 0.0212, 'lps'),
	(377322, 102, '2015-02-01 00:28:30.000000', 'consum', 0.0226, 'lps'),
	(377323, 102, '2015-02-01 00:28:31.000000', 'consum', 0.0219, 'lps'),
	(377324, 102, '2015-02-01 00:28:32.000000', 'consum', 0.0229, 'lps'),
	(377325, 102, '2015-02-01 00:28:33.000000', 'consum', 0.0211, 'lps'),
	(377326, 102, '2015-02-01 00:28:34.000000', 'consum', 0.0225, 'lps'),
	(377327, 102, '2015-02-01 00:28:35.000000', 'consum', 0.0216, 'lps'),
	(377328, 102, '2015-02-01 00:28:36.000000', 'consum', 0.0220, 'lps'),
	(377329, 102, '2015-02-01 00:28:37.000000', 'consum', 0.0216, 'lps'),
	(377330, 102, '2015-02-01 00:28:38.000000', 'consum', 0.0210, 'lps'),
	(377331, 102, '2015-02-01 00:28:39.000000', 'consum', 0.0219, 'lps'),
	(377332, 102, '2015-02-01 00:28:40.000000', 'consum', 0.0229, 'lps'),
	(377333, 102, '2015-02-01 00:28:41.000000', 'consum', 0.0210, 'lps'),
	(377334, 102, '2015-02-01 00:28:42.000000', 'consum', 0.0224, 'lps'),
	(377335, 102, '2015-02-01 00:28:43.000000', 'consum', 0.0211, 'lps'),
	(377336, 102, '2015-02-01 00:28:44.000000', 'consum', 0.0219, 'lps'),
	(377337, 102, '2015-02-01 00:28:45.000000', 'consum', 0.0228, 'lps'),
	(377338, 102, '2015-02-01 00:28:46.000000', 'consum', 0.0229, 'lps'),
	(377339, 102, '2015-02-01 00:28:47.000000', 'consum', 0.0228, 'lps'),
	(377340, 102, '2015-02-01 00:28:48.000000', 'consum', 0.0222, 'lps'),
	(377341, 102, '2015-02-01 00:28:49.000000', 'consum', 0.0217, 'lps'),
	(377342, 102, '2015-02-01 00:28:50.000000', 'consum', 0.0230, 'lps'),
	(377343, 102, '2015-02-01 00:28:51.000000', 'consum', 0.0222, 'lps'),
	(377344, 102, '2015-02-01 00:28:52.000000', 'consum', 0.0212, 'lps'),
	(377345, 102, '2015-02-01 00:28:53.000000', 'consum', 0.0228, 'lps'),
	(377346, 102, '2015-02-01 00:28:54.000000', 'consum', 0.0227, 'lps'),
	(377347, 102, '2015-02-01 00:28:55.000000', 'consum', 0.0217, 'lps'),
	(377348, 102, '2015-02-01 00:28:56.000000', 'consum', 0.0218, 'lps'),
	(377349, 102, '2015-02-01 00:28:57.000000', 'consum', 0.0228, 'lps'),
	(377350, 102, '2015-02-01 00:28:58.000000', 'consum', 0.0230, 'lps'),
	(377351, 102, '2015-02-01 00:28:59.000000', 'consum', 0.0214, 'lps'),
	(377352, 102, '2015-02-01 00:29:00.000000', 'consum', 0.0213, 'lps'),
	(377353, 102, '2015-02-01 00:29:01.000000', 'consum', 0.0216, 'lps'),
	(377354, 102, '2015-02-01 00:29:02.000000', 'consum', 0.0232, 'lps'),
	(377355, 102, '2015-02-01 00:29:03.000000', 'consum', 0.0211, 'lps'),
	(377356, 102, '2015-02-01 00:29:04.000000', 'consum', 0.0216, 'lps'),
	(377357, 102, '2015-02-01 00:29:05.000000', 'consum', 0.0215, 'lps'),
	(377358, 102, '2015-02-01 00:29:06.000000', 'consum', 0.0220, 'lps'),
	(377359, 102, '2015-02-01 00:29:07.000000', 'consum', 0.0220, 'lps'),
	(377360, 102, '2015-02-01 00:29:08.000000', 'consum', 0.0231, 'lps'),
	(377361, 102, '2015-02-01 00:29:09.000000', 'consum', 0.0217, 'lps'),
	(377362, 102, '2015-02-01 00:29:10.000000', 'consum', 0.0226, 'lps'),
	(377363, 102, '2015-02-01 00:29:11.000000', 'consum', 0.0226, 'lps'),
	(377364, 102, '2015-02-01 00:29:12.000000', 'consum', 0.0219, 'lps'),
	(377365, 102, '2015-02-01 00:29:13.000000', 'consum', 0.0232, 'lps'),
	(377366, 102, '2015-02-01 00:29:14.000000', 'consum', 0.0221, 'lps'),
	(377367, 102, '2015-02-01 00:29:15.000000', 'consum', 0.0225, 'lps'),
	(377368, 102, '2015-02-01 00:29:16.000000', 'consum', 0.0230, 'lps'),
	(377369, 102, '2015-02-01 00:29:17.000000', 'consum', 0.0220, 'lps'),
	(377370, 102, '2015-02-01 00:29:18.000000', 'consum', 0.0221, 'lps'),
	(377371, 102, '2015-02-01 00:29:19.000000', 'consum', 0.0215, 'lps'),
	(377372, 102, '2015-02-01 00:29:20.000000', 'consum', 0.0223, 'lps'),
	(377373, 102, '2015-02-01 00:29:21.000000', 'consum', 0.0216, 'lps'),
	(377374, 102, '2015-02-01 00:29:22.000000', 'consum', 0.0225, 'lps'),
	(377375, 102, '2015-02-01 00:29:23.000000', 'consum', 0.0222, 'lps'),
	(377376, 102, '2015-02-01 00:29:24.000000', 'consum', 0.0225, 'lps'),
	(377377, 102, '2015-02-01 00:29:25.000000', 'consum', 0.0228, 'lps'),
	(377378, 102, '2015-02-01 00:29:26.000000', 'consum', 0.0231, 'lps'),
	(377379, 102, '2015-02-01 00:29:27.000000', 'consum', 0.0215, 'lps'),
	(377380, 102, '2015-02-01 00:29:28.000000', 'consum', 0.0221, 'lps'),
	(377381, 102, '2015-02-01 00:29:29.000000', 'consum', 0.0225, 'lps'),
	(377382, 102, '2015-02-01 00:29:30.000000', 'consum', 0.0230, 'lps'),
	(377383, 102, '2015-02-01 00:29:31.000000', 'consum', 0.0218, 'lps'),
	(377384, 102, '2015-02-01 00:29:32.000000', 'consum', 0.0214, 'lps'),
	(377385, 102, '2015-02-01 00:29:33.000000', 'consum', 0.0231, 'lps'),
	(377386, 102, '2015-02-01 00:29:34.000000', 'consum', 0.0211, 'lps'),
	(377387, 102, '2015-02-01 00:29:35.000000', 'consum', 0.0222, 'lps'),
	(377388, 102, '2015-02-01 00:29:36.000000', 'consum', 0.0222, 'lps'),
	(377389, 102, '2015-02-01 00:29:37.000000', 'consum', 0.0210, 'lps'),
	(377390, 102, '2015-02-01 00:29:38.000000', 'consum', 0.0220, 'lps'),
	(377391, 102, '2015-02-01 00:29:39.000000', 'consum', 0.0214, 'lps'),
	(377392, 102, '2015-02-01 00:29:40.000000', 'consum', 0.0226, 'lps'),
	(377393, 102, '2015-02-01 00:29:41.000000', 'consum', 0.0230, 'lps'),
	(377394, 102, '2015-02-01 00:29:42.000000', 'consum', 0.0216, 'lps'),
	(377395, 102, '2015-02-01 00:29:43.000000', 'consum', 0.0228, 'lps'),
	(377396, 102, '2015-02-01 00:29:44.000000', 'consum', 0.0215, 'lps'),
	(377397, 102, '2015-02-01 00:29:45.000000', 'consum', 0.0226, 'lps'),
	(377398, 102, '2015-02-01 00:29:46.000000', 'consum', 0.0232, 'lps'),
	(377399, 102, '2015-02-01 00:29:47.000000', 'consum', 0.0224, 'lps'),
	(377400, 102, '2015-02-01 00:29:48.000000', 'consum', 0.0215, 'lps'),
	(377401, 102, '2015-02-01 00:29:49.000000', 'consum', 0.0216, 'lps'),
	(377402, 102, '2015-02-01 00:29:50.000000', 'consum', 0.0225, 'lps'),
	(377403, 102, '2015-02-01 00:29:51.000000', 'consum', 0.0221, 'lps'),
	(377404, 102, '2015-02-01 00:29:52.000000', 'consum', 0.0222, 'lps'),
	(377405, 102, '2015-02-01 00:29:53.000000', 'consum', 0.0213, 'lps'),
	(377406, 102, '2015-02-01 00:29:54.000000', 'consum', 0.0215, 'lps'),
	(377407, 102, '2015-02-01 00:29:55.000000', 'consum', 0.0225, 'lps'),
	(377408, 102, '2015-02-01 00:29:56.000000', 'consum', 0.0226, 'lps'),
	(377409, 102, '2015-02-01 00:29:57.000000', 'consum', 0.0221, 'lps'),
	(377410, 102, '2015-02-01 00:29:58.000000', 'consum', 0.0217, 'lps'),
	(377411, 102, '2015-02-01 00:29:59.000000', 'consum', 0.0211, 'lps'),
	(377412, 102, '2015-02-01 00:30:00.000000', 'consum', 0.0221, 'lps'),
	(377413, 102, '2015-02-01 00:30:01.000000', 'consum', 0.0215, 'lps'),
	(377414, 102, '2015-02-01 00:30:02.000000', 'consum', 0.0226, 'lps'),
	(377415, 102, '2015-02-01 00:30:03.000000', 'consum', 0.0230, 'lps'),
	(377416, 102, '2015-02-01 00:30:04.000000', 'consum', 0.0217, 'lps'),
	(377417, 102, '2015-02-01 00:30:05.000000', 'consum', 0.0229, 'lps'),
	(377418, 102, '2015-02-01 00:30:06.000000', 'consum', 0.0218, 'lps'),
	(377419, 102, '2015-02-01 00:30:07.000000', 'consum', 0.0214, 'lps'),
	(377420, 102, '2015-02-01 00:30:08.000000', 'consum', 0.0210, 'lps'),
	(377421, 102, '2015-02-01 00:30:09.000000', 'consum', 0.0218, 'lps'),
	(377422, 102, '2015-02-01 00:30:10.000000', 'consum', 0.0230, 'lps'),
	(377423, 102, '2015-02-01 00:30:11.000000', 'consum', 0.0217, 'lps'),
	(377424, 102, '2015-02-01 00:30:12.000000', 'consum', 0.0230, 'lps'),
	(377425, 102, '2015-02-01 00:30:13.000000', 'consum', 0.0220, 'lps'),
	(377426, 102, '2015-02-01 00:30:14.000000', 'consum', 0.0225, 'lps'),
	(377427, 102, '2015-02-01 00:30:15.000000', 'consum', 0.0211, 'lps'),
	(377428, 102, '2015-02-01 00:30:16.000000', 'consum', 0.0214, 'lps'),
	(377429, 102, '2015-02-01 00:30:17.000000', 'consum', 0.0228, 'lps'),
	(377430, 102, '2015-02-01 00:30:18.000000', 'consum', 0.0221, 'lps'),
	(377431, 102, '2015-02-01 00:30:19.000000', 'consum', 0.0210, 'lps'),
	(377432, 102, '2015-02-01 00:30:20.000000', 'consum', 0.0222, 'lps'),
	(377433, 102, '2015-02-01 00:30:21.000000', 'consum', 0.0227, 'lps'),
	(377434, 102, '2015-02-01 00:30:22.000000', 'consum', 0.0212, 'lps'),
	(377435, 102, '2015-02-01 00:30:23.000000', 'consum', 0.0214, 'lps'),
	(377436, 102, '2015-02-01 00:30:24.000000', 'consum', 0.0227, 'lps'),
	(377437, 102, '2015-02-01 00:30:25.000000', 'consum', 0.0215, 'lps'),
	(377438, 102, '2015-02-01 00:30:26.000000', 'consum', 0.0228, 'lps'),
	(377439, 102, '2015-02-01 00:30:27.000000', 'consum', 0.0216, 'lps'),
	(377440, 102, '2015-02-01 00:30:28.000000', 'consum', 0.0232, 'lps'),
	(377441, 102, '2015-02-01 00:30:29.000000', 'consum', 0.0210, 'lps'),
	(377442, 102, '2015-02-01 00:30:30.000000', 'consum', 0.0215, 'lps'),
	(377443, 102, '2015-02-01 00:30:31.000000', 'consum', 0.0211, 'lps'),
	(377444, 102, '2015-02-01 00:30:32.000000', 'consum', 0.0224, 'lps'),
	(377445, 102, '2015-02-01 00:30:33.000000', 'consum', 0.0230, 'lps'),
	(377446, 102, '2015-02-01 00:30:34.000000', 'consum', 0.0224, 'lps'),
	(377447, 102, '2015-02-01 00:30:35.000000', 'consum', 0.0220, 'lps'),
	(377448, 102, '2015-02-01 00:30:36.000000', 'consum', 0.0217, 'lps'),
	(377449, 102, '2015-02-01 00:30:37.000000', 'consum', 0.0218, 'lps'),
	(377450, 102, '2015-02-01 00:30:38.000000', 'consum', 0.0228, 'lps'),
	(377451, 102, '2015-02-01 00:30:39.000000', 'consum', 0.0210, 'lps'),
	(377452, 102, '2015-02-01 00:30:40.000000', 'consum', 0.0224, 'lps'),
	(377453, 102, '2015-02-01 00:30:41.000000', 'consum', 0.0211, 'lps'),
	(377454, 102, '2015-02-01 00:30:42.000000', 'consum', 0.0221, 'lps'),
	(377455, 102, '2015-02-01 00:30:43.000000', 'consum', 0.0217, 'lps'),
	(377456, 102, '2015-02-01 00:30:44.000000', 'consum', 0.0212, 'lps'),
	(377457, 102, '2015-02-01 00:30:45.000000', 'consum', 0.0221, 'lps'),
	(377458, 102, '2015-02-01 00:30:46.000000', 'consum', 0.0212, 'lps'),
	(377459, 102, '2015-02-01 00:30:47.000000', 'consum', 0.0213, 'lps'),
	(377460, 102, '2015-02-01 00:30:48.000000', 'consum', 0.0220, 'lps'),
	(377461, 102, '2015-02-01 00:30:49.000000', 'consum', 0.0226, 'lps'),
	(377462, 102, '2015-02-01 00:30:50.000000', 'consum', 0.0215, 'lps'),
	(377463, 102, '2015-02-01 00:30:51.000000', 'consum', 0.0211, 'lps'),
	(377464, 102, '2015-02-01 00:30:52.000000', 'consum', 0.0222, 'lps'),
	(377465, 102, '2015-02-01 00:30:53.000000', 'consum', 0.0225, 'lps'),
	(377466, 102, '2015-02-01 00:30:54.000000', 'consum', 0.0223, 'lps'),
	(377467, 102, '2015-02-01 00:30:55.000000', 'consum', 0.0232, 'lps'),
	(377468, 102, '2015-02-01 00:30:56.000000', 'consum', 0.0214, 'lps'),
	(377469, 102, '2015-02-01 00:30:57.000000', 'consum', 0.0211, 'lps'),
	(377470, 102, '2015-02-01 00:30:58.000000', 'consum', 0.0225, 'lps'),
	(377471, 102, '2015-02-01 00:30:59.000000', 'consum', 0.0215, 'lps'),
	(377472, 102, '2015-02-01 00:31:00.000000', 'consum', 0.0211, 'lps'),
	(377473, 102, '2015-02-01 00:31:01.000000', 'consum', 0.0224, 'lps'),
	(377474, 102, '2015-02-01 00:31:02.000000', 'consum', 0.0231, 'lps'),
	(377475, 102, '2015-02-01 00:31:03.000000', 'consum', 0.0228, 'lps'),
	(377476, 102, '2015-02-01 00:31:04.000000', 'consum', 0.0215, 'lps'),
	(377477, 102, '2015-02-01 00:31:05.000000', 'consum', 0.0228, 'lps'),
	(377478, 102, '2015-02-01 00:31:06.000000', 'consum', 0.0215, 'lps'),
	(377479, 102, '2015-02-01 00:31:07.000000', 'consum', 0.0227, 'lps'),
	(377480, 102, '2015-02-01 00:31:08.000000', 'consum', 0.0211, 'lps'),
	(377481, 102, '2015-02-01 00:31:09.000000', 'consum', 0.0211, 'lps'),
	(377482, 102, '2015-02-01 00:31:10.000000', 'consum', 0.0212, 'lps'),
	(377483, 102, '2015-02-01 00:31:11.000000', 'consum', 0.0218, 'lps'),
	(377484, 102, '2015-02-01 00:31:12.000000', 'consum', 0.0222, 'lps'),
	(377485, 102, '2015-02-01 00:31:13.000000', 'consum', 0.0224, 'lps'),
	(377486, 102, '2015-02-01 00:31:14.000000', 'consum', 0.0222, 'lps'),
	(377487, 102, '2015-02-01 00:31:15.000000', 'consum', 0.0227, 'lps'),
	(377488, 102, '2015-02-01 00:31:16.000000', 'consum', 0.0215, 'lps'),
	(377489, 102, '2015-02-01 00:31:17.000000', 'consum', 0.0231, 'lps'),
	(377490, 102, '2015-02-01 00:31:18.000000', 'consum', 0.0232, 'lps'),
	(377491, 102, '2015-02-01 00:31:19.000000', 'consum', 0.0212, 'lps'),
	(377492, 102, '2015-02-01 00:31:20.000000', 'consum', 0.0222, 'lps'),
	(377493, 102, '2015-02-01 00:31:21.000000', 'consum', 0.0219, 'lps'),
	(377494, 102, '2015-02-01 00:31:22.000000', 'consum', 0.0220, 'lps'),
	(377495, 102, '2015-02-01 00:31:23.000000', 'consum', 0.0232, 'lps'),
	(377496, 102, '2015-02-01 00:31:24.000000', 'consum', 0.0224, 'lps'),
	(377497, 102, '2015-02-01 00:31:25.000000', 'consum', 0.0212, 'lps'),
	(377498, 102, '2015-02-01 00:31:26.000000', 'consum', 0.0225, 'lps'),
	(377499, 102, '2015-02-01 00:31:27.000000', 'consum', 0.0211, 'lps'),
	(377500, 102, '2015-02-01 00:31:28.000000', 'consum', 0.0215, 'lps'),
	(377501, 102, '2015-02-01 00:31:29.000000', 'consum', 0.0211, 'lps'),
	(377502, 102, '2015-02-01 00:31:30.000000', 'consum', 0.0223, 'lps'),
	(377503, 102, '2015-02-01 00:31:31.000000', 'consum', 0.0225, 'lps'),
	(377504, 102, '2015-02-01 00:31:32.000000', 'consum', 0.0227, 'lps'),
	(377505, 102, '2015-02-01 00:31:33.000000', 'consum', 0.0224, 'lps'),
	(377506, 102, '2015-02-01 00:31:34.000000', 'consum', 0.0231, 'lps'),
	(377507, 102, '2015-02-01 00:31:35.000000', 'consum', 0.0225, 'lps'),
	(377508, 102, '2015-02-01 00:31:36.000000', 'consum', 0.0225, 'lps'),
	(377509, 102, '2015-02-01 00:31:37.000000', 'consum', 0.0217, 'lps'),
	(377510, 102, '2015-02-01 00:31:38.000000', 'consum', 0.0223, 'lps'),
	(377511, 102, '2015-02-01 00:31:39.000000', 'consum', 0.0210, 'lps'),
	(377512, 102, '2015-02-01 00:31:40.000000', 'consum', 0.0218, 'lps'),
	(377513, 102, '2015-02-01 00:31:41.000000', 'consum', 0.0229, 'lps'),
	(377514, 102, '2015-02-01 00:31:42.000000', 'consum', 0.0232, 'lps'),
	(377515, 102, '2015-02-01 00:31:43.000000', 'consum', 0.0219, 'lps'),
	(377516, 102, '2015-02-01 00:31:44.000000', 'consum', 0.0212, 'lps'),
	(377517, 102, '2015-02-01 00:31:45.000000', 'consum', 0.0217, 'lps'),
	(377518, 102, '2015-02-01 00:31:46.000000', 'consum', 0.0214, 'lps'),
	(377519, 102, '2015-02-01 00:31:47.000000', 'consum', 0.0213, 'lps'),
	(377520, 102, '2015-02-01 00:31:48.000000', 'consum', 0.0211, 'lps'),
	(377521, 102, '2015-02-01 00:31:49.000000', 'consum', 0.0229, 'lps'),
	(377522, 102, '2015-02-01 00:31:50.000000', 'consum', 0.0213, 'lps'),
	(377523, 102, '2015-02-01 00:31:51.000000', 'consum', 0.0215, 'lps'),
	(377524, 102, '2015-02-01 00:31:52.000000', 'consum', 0.0227, 'lps'),
	(377525, 102, '2015-02-01 00:31:53.000000', 'consum', 0.0210, 'lps'),
	(377526, 102, '2015-02-01 00:31:54.000000', 'consum', 0.0227, 'lps'),
	(377527, 102, '2015-02-01 00:31:55.000000', 'consum', 0.0226, 'lps'),
	(377528, 102, '2015-02-01 00:31:56.000000', 'consum', 0.0218, 'lps'),
	(377529, 102, '2015-02-01 00:31:57.000000', 'consum', 0.0227, 'lps'),
	(377530, 102, '2015-02-01 00:31:58.000000', 'consum', 0.0223, 'lps'),
	(377531, 102, '2015-02-01 00:31:59.000000', 'consum', 0.0224, 'lps'),
	(377532, 102, '2015-02-01 00:32:00.000000', 'consum', 0.0221, 'lps'),
	(377533, 102, '2015-02-01 00:32:01.000000', 'consum', 0.0222, 'lps'),
	(377534, 102, '2015-02-01 00:32:02.000000', 'consum', 0.0213, 'lps'),
	(377535, 102, '2015-02-01 00:32:03.000000', 'consum', 0.0215, 'lps'),
	(377536, 102, '2015-02-01 00:32:04.000000', 'consum', 0.0225, 'lps'),
	(377537, 102, '2015-02-01 00:32:05.000000', 'consum', 0.0224, 'lps'),
	(377538, 102, '2015-02-01 00:32:06.000000', 'consum', 0.0212, 'lps'),
	(377539, 102, '2015-02-01 00:32:07.000000', 'consum', 0.0226, 'lps'),
	(377540, 102, '2015-02-01 00:32:08.000000', 'consum', 0.0213, 'lps'),
	(377541, 102, '2015-02-01 00:32:09.000000', 'consum', 0.0226, 'lps'),
	(377542, 102, '2015-02-01 00:32:10.000000', 'consum', 0.0213, 'lps'),
	(377543, 102, '2015-02-01 00:32:11.000000', 'consum', 0.0221, 'lps'),
	(377544, 102, '2015-02-01 00:32:12.000000', 'consum', 0.0213, 'lps'),
	(377545, 102, '2015-02-01 00:32:13.000000', 'consum', 0.0215, 'lps'),
	(377546, 102, '2015-02-01 00:32:14.000000', 'consum', 0.0225, 'lps'),
	(377547, 102, '2015-02-01 00:32:15.000000', 'consum', 0.0225, 'lps'),
	(377548, 102, '2015-02-01 00:32:16.000000', 'consum', 0.0218, 'lps'),
	(377549, 102, '2015-02-01 00:32:17.000000', 'consum', 0.0228, 'lps'),
	(377550, 102, '2015-02-01 00:32:18.000000', 'consum', 0.0230, 'lps'),
	(377551, 102, '2015-02-01 00:32:19.000000', 'consum', 0.0213, 'lps'),
	(377552, 102, '2015-02-01 00:32:20.000000', 'consum', 0.0232, 'lps'),
	(377553, 102, '2015-02-01 00:32:21.000000', 'consum', 0.0222, 'lps'),
	(377554, 102, '2015-02-01 00:32:22.000000', 'consum', 0.0227, 'lps'),
	(377555, 102, '2015-02-01 00:32:23.000000', 'consum', 0.0212, 'lps'),
	(377556, 102, '2015-02-01 00:32:24.000000', 'consum', 0.0215, 'lps'),
	(377557, 102, '2015-02-01 00:32:25.000000', 'consum', 0.0230, 'lps'),
	(377558, 102, '2015-02-01 00:32:26.000000', 'consum', 0.0226, 'lps'),
	(377559, 102, '2015-02-01 00:32:27.000000', 'consum', 0.0231, 'lps'),
	(377560, 102, '2015-02-01 00:32:28.000000', 'consum', 0.0221, 'lps'),
	(377561, 102, '2015-02-01 00:32:29.000000', 'consum', 0.0227, 'lps'),
	(377562, 102, '2015-02-01 00:32:30.000000', 'consum', 0.0217, 'lps'),
	(377563, 102, '2015-02-01 00:32:31.000000', 'consum', 0.0217, 'lps'),
	(377564, 102, '2015-02-01 00:32:32.000000', 'consum', 0.0226, 'lps'),
	(377565, 102, '2015-02-01 00:32:33.000000', 'consum', 0.0223, 'lps'),
	(377566, 102, '2015-02-01 00:32:34.000000', 'consum', 0.0228, 'lps'),
	(377567, 102, '2015-02-01 00:32:35.000000', 'consum', 0.0214, 'lps'),
	(377568, 102, '2015-02-01 00:32:36.000000', 'consum', 0.0224, 'lps'),
	(377569, 102, '2015-02-01 00:32:37.000000', 'consum', 0.0223, 'lps'),
	(377570, 102, '2015-02-01 00:32:38.000000', 'consum', 0.0212, 'lps'),
	(377571, 102, '2015-02-01 00:32:39.000000', 'consum', 0.0224, 'lps'),
	(377572, 102, '2015-02-01 00:32:40.000000', 'consum', 0.0230, 'lps'),
	(377573, 102, '2015-02-01 00:32:41.000000', 'consum', 0.0221, 'lps'),
	(377574, 102, '2015-02-01 00:32:42.000000', 'consum', 0.0231, 'lps'),
	(377575, 102, '2015-02-01 00:32:43.000000', 'consum', 0.0211, 'lps'),
	(377576, 102, '2015-02-01 00:32:44.000000', 'consum', 0.0221, 'lps'),
	(377577, 102, '2015-02-01 00:32:45.000000', 'consum', 0.0216, 'lps'),
	(377578, 102, '2015-02-01 00:32:46.000000', 'consum', 0.0211, 'lps'),
	(377579, 102, '2015-02-01 00:32:47.000000', 'consum', 0.0217, 'lps'),
	(377580, 102, '2015-02-01 00:32:48.000000', 'consum', 0.0220, 'lps'),
	(377581, 102, '2015-02-01 00:32:49.000000', 'consum', 0.0219, 'lps'),
	(377582, 102, '2015-02-01 00:32:50.000000', 'consum', 0.0224, 'lps'),
	(377583, 102, '2015-02-01 00:32:51.000000', 'consum', 0.0232, 'lps'),
	(377584, 102, '2015-02-01 00:32:52.000000', 'consum', 0.0231, 'lps'),
	(377585, 102, '2015-02-01 00:32:53.000000', 'consum', 0.0225, 'lps'),
	(377586, 102, '2015-02-01 00:32:54.000000', 'consum', 0.0223, 'lps'),
	(377587, 102, '2015-02-01 00:32:55.000000', 'consum', 0.0210, 'lps'),
	(377588, 102, '2015-02-01 00:32:56.000000', 'consum', 0.0214, 'lps'),
	(377589, 102, '2015-02-01 00:32:57.000000', 'consum', 0.0232, 'lps'),
	(377590, 102, '2015-02-01 00:32:58.000000', 'consum', 0.0218, 'lps'),
	(377591, 102, '2015-02-01 00:32:59.000000', 'consum', 0.0229, 'lps'),
	(377592, 102, '2015-02-01 00:33:00.000000', 'consum', 0.0212, 'lps'),
	(377593, 102, '2015-02-01 00:33:01.000000', 'consum', 0.0231, 'lps'),
	(377594, 102, '2015-02-01 00:33:02.000000', 'consum', 0.0220, 'lps'),
	(377595, 102, '2015-02-01 00:33:03.000000', 'consum', 0.0220, 'lps'),
	(377596, 102, '2015-02-01 00:33:04.000000', 'consum', 0.0230, 'lps'),
	(377597, 102, '2015-02-01 00:33:05.000000', 'consum', 0.0210, 'lps'),
	(377598, 102, '2015-02-01 00:33:06.000000', 'consum', 0.0220, 'lps'),
	(377599, 102, '2015-02-01 00:33:07.000000', 'consum', 0.0215, 'lps'),
	(377600, 102, '2015-02-01 00:33:08.000000', 'consum', 0.0230, 'lps'),
	(377601, 102, '2015-02-01 00:33:09.000000', 'consum', 0.0225, 'lps'),
	(377602, 102, '2015-02-01 00:33:10.000000', 'consum', 0.0224, 'lps'),
	(377603, 102, '2015-02-01 00:33:11.000000', 'consum', 0.0214, 'lps'),
	(377604, 102, '2015-02-01 00:33:12.000000', 'consum', 0.0210, 'lps'),
	(377605, 102, '2015-02-01 00:33:13.000000', 'consum', 0.0223, 'lps'),
	(377606, 102, '2015-02-01 00:33:14.000000', 'consum', 0.0231, 'lps'),
	(377607, 102, '2015-02-01 00:33:15.000000', 'consum', 0.0227, 'lps'),
	(377608, 102, '2015-02-01 00:33:16.000000', 'consum', 0.0213, 'lps'),
	(377609, 102, '2015-02-01 00:33:17.000000', 'consum', 0.0218, 'lps'),
	(377610, 102, '2015-02-01 00:33:18.000000', 'consum', 0.0218, 'lps'),
	(377611, 102, '2015-02-01 00:33:19.000000', 'consum', 0.0229, 'lps'),
	(377612, 102, '2015-02-01 00:33:20.000000', 'consum', 0.0211, 'lps'),
	(377613, 102, '2015-02-01 00:33:21.000000', 'consum', 0.0228, 'lps'),
	(377614, 102, '2015-02-01 00:33:22.000000', 'consum', 0.0227, 'lps'),
	(377615, 102, '2015-02-01 00:33:23.000000', 'consum', 0.0220, 'lps'),
	(377616, 102, '2015-02-01 00:33:24.000000', 'consum', 0.0232, 'lps'),
	(377617, 102, '2015-02-01 00:33:25.000000', 'consum', 0.0222, 'lps'),
	(377618, 102, '2015-02-01 00:33:26.000000', 'consum', 0.0229, 'lps'),
	(377619, 102, '2015-02-01 00:33:27.000000', 'consum', 0.0221, 'lps'),
	(377620, 102, '2015-02-01 00:33:28.000000', 'consum', 0.0232, 'lps'),
	(377621, 102, '2015-02-01 00:33:29.000000', 'consum', 0.0218, 'lps'),
	(377622, 102, '2015-02-01 00:33:30.000000', 'consum', 0.0232, 'lps'),
	(377623, 102, '2015-02-01 00:33:31.000000', 'consum', 0.0226, 'lps'),
	(377624, 102, '2015-02-01 00:33:32.000000', 'consum', 0.0224, 'lps'),
	(377625, 102, '2015-02-01 00:33:33.000000', 'consum', 0.0210, 'lps'),
	(377626, 102, '2015-02-01 00:33:34.000000', 'consum', 0.0215, 'lps'),
	(377627, 102, '2015-02-01 00:33:35.000000', 'consum', 0.0212, 'lps'),
	(377628, 102, '2015-02-01 00:33:36.000000', 'consum', 0.0228, 'lps'),
	(377629, 102, '2015-02-01 00:33:37.000000', 'consum', 0.0227, 'lps'),
	(377630, 102, '2015-02-01 00:33:38.000000', 'consum', 0.0217, 'lps'),
	(377631, 102, '2015-02-01 00:33:39.000000', 'consum', 0.0219, 'lps'),
	(377632, 102, '2015-02-01 00:33:40.000000', 'consum', 0.0212, 'lps'),
	(377633, 102, '2015-02-01 00:33:41.000000', 'consum', 0.0214, 'lps'),
	(377634, 102, '2015-02-01 00:33:42.000000', 'consum', 0.0228, 'lps'),
	(377635, 102, '2015-02-01 00:33:43.000000', 'consum', 0.0217, 'lps'),
	(377636, 102, '2015-02-01 00:33:44.000000', 'consum', 0.0215, 'lps'),
	(377637, 102, '2015-02-01 00:33:45.000000', 'consum', 0.0216, 'lps'),
	(377638, 102, '2015-02-01 00:33:46.000000', 'consum', 0.0226, 'lps'),
	(377639, 102, '2015-02-01 00:33:47.000000', 'consum', 0.0225, 'lps'),
	(377640, 102, '2015-02-01 00:33:48.000000', 'consum', 0.0214, 'lps'),
	(377641, 102, '2015-02-01 00:33:49.000000', 'consum', 0.0230, 'lps'),
	(377642, 102, '2015-02-01 00:33:50.000000', 'consum', 0.0231, 'lps'),
	(377643, 102, '2015-02-01 00:33:51.000000', 'consum', 0.0231, 'lps'),
	(377644, 102, '2015-02-01 00:33:52.000000', 'consum', 0.0231, 'lps'),
	(377645, 102, '2015-02-01 00:33:53.000000', 'consum', 0.0227, 'lps'),
	(377646, 102, '2015-02-01 00:33:54.000000', 'consum', 0.0212, 'lps'),
	(377647, 102, '2015-02-01 00:33:55.000000', 'consum', 0.0213, 'lps'),
	(377648, 102, '2015-02-01 00:33:56.000000', 'consum', 0.0223, 'lps'),
	(377649, 102, '2015-02-01 00:33:57.000000', 'consum', 0.0217, 'lps'),
	(377650, 102, '2015-02-01 00:33:58.000000', 'consum', 0.0230, 'lps'),
	(377651, 102, '2015-02-01 00:33:59.000000', 'consum', 0.0221, 'lps'),
	(377652, 102, '2015-02-01 00:34:00.000000', 'consum', 0.0231, 'lps'),
	(377653, 102, '2015-02-01 00:34:01.000000', 'consum', 0.0210, 'lps'),
	(377654, 102, '2015-02-01 00:34:02.000000', 'consum', 0.0220, 'lps'),
	(377655, 102, '2015-02-01 00:34:03.000000', 'consum', 0.0212, 'lps'),
	(377656, 102, '2015-02-01 00:34:04.000000', 'consum', 0.0212, 'lps'),
	(377657, 102, '2015-02-01 00:34:05.000000', 'consum', 0.0217, 'lps'),
	(377658, 102, '2015-02-01 00:34:06.000000', 'consum', 0.0215, 'lps'),
	(377659, 102, '2015-02-01 00:34:07.000000', 'consum', 0.0213, 'lps'),
	(377660, 102, '2015-02-01 00:34:08.000000', 'consum', 0.0213, 'lps'),
	(377661, 102, '2015-02-01 00:34:09.000000', 'consum', 0.0214, 'lps'),
	(377662, 102, '2015-02-01 00:34:10.000000', 'consum', 0.0221, 'lps'),
	(377663, 102, '2015-02-01 00:34:11.000000', 'consum', 0.0232, 'lps'),
	(377664, 102, '2015-02-01 00:34:12.000000', 'consum', 0.0219, 'lps'),
	(377665, 102, '2015-02-01 00:34:13.000000', 'consum', 0.0214, 'lps'),
	(377666, 102, '2015-02-01 00:34:14.000000', 'consum', 0.0223, 'lps'),
	(377667, 102, '2015-02-01 00:34:15.000000', 'consum', 0.0220, 'lps'),
	(377668, 102, '2015-02-01 00:34:16.000000', 'consum', 0.0220, 'lps'),
	(377669, 102, '2015-02-01 00:34:17.000000', 'consum', 0.0232, 'lps'),
	(377670, 102, '2015-02-01 00:34:18.000000', 'consum', 0.0223, 'lps'),
	(377671, 102, '2015-02-01 00:34:19.000000', 'consum', 0.0230, 'lps'),
	(377672, 102, '2015-02-01 00:34:20.000000', 'consum', 0.0227, 'lps'),
	(377673, 102, '2015-02-01 00:34:21.000000', 'consum', 0.0213, 'lps'),
	(377674, 102, '2015-02-01 00:34:22.000000', 'consum', 0.0221, 'lps'),
	(377675, 102, '2015-02-01 00:34:23.000000', 'consum', 0.0211, 'lps'),
	(377676, 102, '2015-02-01 00:34:24.000000', 'consum', 0.0229, 'lps'),
	(377677, 102, '2015-02-01 00:34:25.000000', 'consum', 0.0231, 'lps'),
	(377678, 102, '2015-02-01 00:34:26.000000', 'consum', 0.0211, 'lps'),
	(377679, 102, '2015-02-01 00:34:27.000000', 'consum', 0.0225, 'lps'),
	(377680, 102, '2015-02-01 00:34:28.000000', 'consum', 0.0213, 'lps'),
	(377681, 102, '2015-02-01 00:34:29.000000', 'consum', 0.0224, 'lps'),
	(377682, 102, '2015-02-01 00:34:30.000000', 'consum', 0.0227, 'lps'),
	(377683, 102, '2015-02-01 00:34:31.000000', 'consum', 0.0230, 'lps'),
	(377684, 102, '2015-02-01 00:34:32.000000', 'consum', 0.0212, 'lps'),
	(377685, 102, '2015-02-01 00:34:33.000000', 'consum', 0.0232, 'lps'),
	(377686, 102, '2015-02-01 00:34:34.000000', 'consum', 0.0223, 'lps'),
	(377687, 102, '2015-02-01 00:34:35.000000', 'consum', 0.0210, 'lps'),
	(377688, 102, '2015-02-01 00:34:36.000000', 'consum', 0.0217, 'lps'),
	(377689, 102, '2015-02-01 00:34:37.000000', 'consum', 0.0220, 'lps'),
	(377690, 102, '2015-02-01 00:34:38.000000', 'consum', 0.0220, 'lps'),
	(377691, 102, '2015-02-01 00:34:39.000000', 'consum', 0.0229, 'lps'),
	(377692, 102, '2015-02-01 00:34:40.000000', 'consum', 0.0229, 'lps'),
	(377693, 102, '2015-02-01 00:34:41.000000', 'consum', 0.0226, 'lps'),
	(377694, 102, '2015-02-01 00:34:42.000000', 'consum', 0.0212, 'lps'),
	(377695, 102, '2015-02-01 00:34:43.000000', 'consum', 0.0219, 'lps'),
	(377696, 102, '2015-02-01 00:34:44.000000', 'consum', 0.0225, 'lps'),
	(377697, 102, '2015-02-01 00:34:45.000000', 'consum', 0.0211, 'lps'),
	(377698, 102, '2015-02-01 00:34:46.000000', 'consum', 0.0220, 'lps'),
	(377699, 102, '2015-02-01 00:34:47.000000', 'consum', 0.0232, 'lps'),
	(377700, 102, '2015-02-01 00:34:48.000000', 'consum', 0.0222, 'lps'),
	(377701, 102, '2015-02-01 00:34:49.000000', 'consum', 0.0229, 'lps'),
	(377702, 102, '2015-02-01 00:34:50.000000', 'consum', 0.0222, 'lps'),
	(377703, 102, '2015-02-01 00:34:51.000000', 'consum', 0.0215, 'lps'),
	(377704, 102, '2015-02-01 00:34:52.000000', 'consum', 0.0224, 'lps'),
	(377705, 102, '2015-02-01 00:34:53.000000', 'consum', 0.0216, 'lps'),
	(377706, 102, '2015-02-01 00:34:54.000000', 'consum', 0.0222, 'lps'),
	(377707, 102, '2015-02-01 00:34:55.000000', 'consum', 0.0231, 'lps'),
	(377708, 102, '2015-02-01 00:34:56.000000', 'consum', 0.0210, 'lps'),
	(377709, 102, '2015-02-01 00:34:57.000000', 'consum', 0.0216, 'lps'),
	(377710, 102, '2015-02-01 00:34:58.000000', 'consum', 0.0218, 'lps'),
	(377711, 102, '2015-02-01 00:34:59.000000', 'consum', 0.0211, 'lps'),
	(377712, 102, '2015-02-01 00:35:00.000000', 'consum', 0.0215, 'lps'),
	(377713, 102, '2015-02-01 00:35:01.000000', 'consum', 0.0230, 'lps'),
	(377714, 102, '2015-02-01 00:35:02.000000', 'consum', 0.0226, 'lps'),
	(377715, 102, '2015-02-01 00:35:03.000000', 'consum', 0.0230, 'lps'),
	(377716, 102, '2015-02-01 00:35:04.000000', 'consum', 0.0216, 'lps'),
	(377717, 102, '2015-02-01 00:35:05.000000', 'consum', 0.0229, 'lps'),
	(377718, 102, '2015-02-01 00:35:06.000000', 'consum', 0.0217, 'lps'),
	(377719, 102, '2015-02-01 00:35:07.000000', 'consum', 0.0210, 'lps'),
	(377720, 102, '2015-02-01 00:35:08.000000', 'consum', 0.0216, 'lps'),
	(377721, 102, '2015-02-01 00:35:09.000000', 'consum', 0.0215, 'lps'),
	(377722, 102, '2015-02-01 00:35:10.000000', 'consum', 0.0218, 'lps'),
	(377723, 102, '2015-02-01 00:35:11.000000', 'consum', 0.0213, 'lps'),
	(377724, 102, '2015-02-01 00:35:12.000000', 'consum', 0.0224, 'lps'),
	(377725, 102, '2015-02-01 00:35:13.000000', 'consum', 0.0224, 'lps'),
	(377726, 102, '2015-02-01 00:35:14.000000', 'consum', 0.0218, 'lps'),
	(377727, 102, '2015-02-01 00:35:15.000000', 'consum', 0.0232, 'lps'),
	(377728, 102, '2015-02-01 00:35:16.000000', 'consum', 0.0225, 'lps'),
	(377729, 102, '2015-02-01 00:35:17.000000', 'consum', 0.0220, 'lps'),
	(377730, 102, '2015-02-01 00:35:18.000000', 'consum', 0.0216, 'lps'),
	(377731, 102, '2015-02-01 00:35:19.000000', 'consum', 0.0210, 'lps'),
	(377732, 102, '2015-02-01 00:35:20.000000', 'consum', 0.0215, 'lps'),
	(377733, 102, '2015-02-01 00:35:21.000000', 'consum', 0.0212, 'lps'),
	(377734, 102, '2015-02-01 00:35:22.000000', 'consum', 0.0227, 'lps'),
	(377735, 102, '2015-02-01 00:35:23.000000', 'consum', 0.0223, 'lps'),
	(377736, 102, '2015-02-01 00:35:24.000000', 'consum', 0.0225, 'lps'),
	(377737, 102, '2015-02-01 00:35:25.000000', 'consum', 0.0225, 'lps'),
	(377738, 102, '2015-02-01 00:35:26.000000', 'consum', 0.0214, 'lps'),
	(377739, 102, '2015-02-01 00:35:27.000000', 'consum', 0.0211, 'lps'),
	(377740, 102, '2015-02-01 00:35:28.000000', 'consum', 0.0224, 'lps'),
	(377741, 102, '2015-02-01 00:35:29.000000', 'consum', 0.0231, 'lps'),
	(377742, 102, '2015-02-01 00:35:30.000000', 'consum', 0.0230, 'lps'),
	(377743, 102, '2015-02-01 00:35:31.000000', 'consum', 0.0222, 'lps'),
	(377744, 102, '2015-02-01 00:35:32.000000', 'consum', 0.0210, 'lps'),
	(377745, 102, '2015-02-01 00:35:33.000000', 'consum', 0.0222, 'lps'),
	(377746, 102, '2015-02-01 00:35:34.000000', 'consum', 0.0226, 'lps'),
	(377747, 102, '2015-02-01 00:35:35.000000', 'consum', 0.0231, 'lps'),
	(377748, 102, '2015-02-01 00:35:36.000000', 'consum', 0.0222, 'lps'),
	(377749, 102, '2015-02-01 00:35:37.000000', 'consum', 0.0232, 'lps'),
	(377750, 102, '2015-02-01 00:35:38.000000', 'consum', 0.0213, 'lps'),
	(377751, 102, '2015-02-01 00:35:39.000000', 'consum', 0.0227, 'lps'),
	(377752, 102, '2015-02-01 00:35:40.000000', 'consum', 0.0221, 'lps'),
	(377753, 102, '2015-02-01 00:35:41.000000', 'consum', 0.0212, 'lps'),
	(377754, 102, '2015-02-01 00:35:42.000000', 'consum', 0.0212, 'lps'),
	(377755, 102, '2015-02-01 00:35:43.000000', 'consum', 0.0216, 'lps'),
	(377756, 102, '2015-02-01 00:35:44.000000', 'consum', 0.0210, 'lps'),
	(377757, 102, '2015-02-01 00:35:45.000000', 'consum', 0.0218, 'lps'),
	(377758, 102, '2015-02-01 00:35:46.000000', 'consum', 0.0224, 'lps'),
	(377759, 102, '2015-02-01 00:35:47.000000', 'consum', 0.0213, 'lps'),
	(377760, 102, '2015-02-01 00:35:48.000000', 'consum', 0.0229, 'lps'),
	(377761, 102, '2015-02-01 00:35:49.000000', 'consum', 0.0226, 'lps'),
	(377762, 102, '2015-02-01 00:35:50.000000', 'consum', 0.0210, 'lps'),
	(377763, 102, '2015-02-01 00:35:51.000000', 'consum', 0.0232, 'lps'),
	(377764, 102, '2015-02-01 00:35:52.000000', 'consum', 0.0228, 'lps'),
	(377765, 102, '2015-02-01 00:35:53.000000', 'consum', 0.0213, 'lps'),
	(377766, 102, '2015-02-01 00:35:54.000000', 'consum', 0.0217, 'lps'),
	(377767, 102, '2015-02-01 00:35:55.000000', 'consum', 0.0212, 'lps'),
	(377768, 102, '2015-02-01 00:35:56.000000', 'consum', 0.0222, 'lps'),
	(377769, 102, '2015-02-01 00:35:57.000000', 'consum', 0.0218, 'lps'),
	(377770, 102, '2015-02-01 00:35:58.000000', 'consum', 0.0218, 'lps'),
	(377771, 102, '2015-02-01 00:35:59.000000', 'consum', 0.0224, 'lps'),
	(377772, 102, '2015-02-01 00:36:00.000000', 'consum', 0.0232, 'lps'),
	(377773, 102, '2015-02-01 00:36:01.000000', 'consum', 0.0212, 'lps'),
	(377774, 102, '2015-02-01 00:36:02.000000', 'consum', 0.0222, 'lps'),
	(377775, 102, '2015-02-01 00:36:03.000000', 'consum', 0.0219, 'lps'),
	(377776, 102, '2015-02-01 00:36:04.000000', 'consum', 0.0220, 'lps'),
	(377777, 102, '2015-02-01 00:36:05.000000', 'consum', 0.0210, 'lps'),
	(377778, 102, '2015-02-01 00:36:06.000000', 'consum', 0.0228, 'lps'),
	(377779, 102, '2015-02-01 00:36:07.000000', 'consum', 0.0231, 'lps'),
	(377780, 102, '2015-02-01 00:36:08.000000', 'consum', 0.0214, 'lps'),
	(377781, 102, '2015-02-01 00:36:09.000000', 'consum', 0.0214, 'lps'),
	(377782, 102, '2015-02-01 00:36:10.000000', 'consum', 0.0220, 'lps'),
	(377783, 102, '2015-02-01 00:36:11.000000', 'consum', 0.0224, 'lps'),
	(377784, 102, '2015-02-01 00:36:12.000000', 'consum', 0.0230, 'lps'),
	(377785, 102, '2015-02-01 00:36:13.000000', 'consum', 0.0220, 'lps'),
	(377786, 102, '2015-02-01 00:36:14.000000', 'consum', 0.0223, 'lps'),
	(377787, 102, '2015-02-01 00:36:15.000000', 'consum', 0.0222, 'lps'),
	(377788, 102, '2015-02-01 00:36:16.000000', 'consum', 0.0232, 'lps'),
	(377789, 102, '2015-02-01 00:36:17.000000', 'consum', 0.0215, 'lps'),
	(377790, 102, '2015-02-01 00:36:18.000000', 'consum', 0.0217, 'lps'),
	(377791, 102, '2015-02-01 00:36:19.000000', 'consum', 0.0228, 'lps'),
	(377792, 102, '2015-02-01 00:36:20.000000', 'consum', 0.0214, 'lps'),
	(377793, 102, '2015-02-01 00:36:21.000000', 'consum', 0.0220, 'lps'),
	(377794, 102, '2015-02-01 00:36:22.000000', 'consum', 0.0225, 'lps'),
	(377795, 102, '2015-02-01 00:36:23.000000', 'consum', 0.0232, 'lps'),
	(377796, 102, '2015-02-01 00:36:24.000000', 'consum', 0.0210, 'lps'),
	(377797, 102, '2015-02-01 00:36:25.000000', 'consum', 0.0210, 'lps'),
	(377798, 102, '2015-02-01 00:36:26.000000', 'consum', 0.0210, 'lps'),
	(377799, 102, '2015-02-01 00:36:27.000000', 'consum', 0.0211, 'lps'),
	(377800, 102, '2015-02-01 00:36:28.000000', 'consum', 0.0215, 'lps'),
	(377801, 102, '2015-02-01 00:36:29.000000', 'consum', 0.0232, 'lps'),
	(377802, 102, '2015-02-01 00:36:30.000000', 'consum', 0.0212, 'lps'),
	(377803, 102, '2015-02-01 00:36:31.000000', 'consum', 0.0226, 'lps'),
	(377804, 102, '2015-02-01 00:36:32.000000', 'consum', 0.0217, 'lps'),
	(377805, 102, '2015-02-01 00:36:33.000000', 'consum', 0.0217, 'lps'),
	(377806, 102, '2015-02-01 00:36:34.000000', 'consum', 0.0228, 'lps'),
	(377807, 102, '2015-02-01 00:36:35.000000', 'consum', 0.0232, 'lps'),
	(377808, 102, '2015-02-01 00:36:36.000000', 'consum', 0.0220, 'lps'),
	(377809, 102, '2015-02-01 00:36:37.000000', 'consum', 0.0218, 'lps'),
	(377810, 102, '2015-02-01 00:36:38.000000', 'consum', 0.0219, 'lps'),
	(377811, 102, '2015-02-01 00:36:39.000000', 'consum', 0.0211, 'lps'),
	(377812, 102, '2015-02-01 00:36:40.000000', 'consum', 0.0232, 'lps'),
	(377813, 102, '2015-02-01 00:36:41.000000', 'consum', 0.0227, 'lps'),
	(377814, 102, '2015-02-01 00:36:42.000000', 'consum', 0.0230, 'lps'),
	(377815, 102, '2015-02-01 00:36:43.000000', 'consum', 0.0214, 'lps'),
	(377816, 102, '2015-02-01 00:36:44.000000', 'consum', 0.0215, 'lps'),
	(377817, 102, '2015-02-01 00:36:45.000000', 'consum', 0.0224, 'lps'),
	(377818, 102, '2015-02-01 00:36:46.000000', 'consum', 0.0220, 'lps'),
	(377819, 102, '2015-02-01 00:36:47.000000', 'consum', 0.0220, 'lps'),
	(377820, 102, '2015-02-01 00:36:48.000000', 'consum', 0.0227, 'lps'),
	(377821, 102, '2015-02-01 00:36:49.000000', 'consum', 0.0223, 'lps'),
	(377822, 102, '2015-02-01 00:36:50.000000', 'consum', 0.0223, 'lps'),
	(377823, 102, '2015-02-01 00:36:51.000000', 'consum', 0.0211, 'lps'),
	(377824, 102, '2015-02-01 00:36:52.000000', 'consum', 0.0226, 'lps'),
	(377825, 102, '2015-02-01 00:36:53.000000', 'consum', 0.0219, 'lps'),
	(377826, 102, '2015-02-01 00:36:54.000000', 'consum', 0.0230, 'lps'),
	(377827, 102, '2015-02-01 00:36:55.000000', 'consum', 0.0215, 'lps'),
	(377828, 102, '2015-02-01 00:36:56.000000', 'consum', 0.0219, 'lps'),
	(377829, 102, '2015-02-01 00:36:57.000000', 'consum', 0.0220, 'lps'),
	(377830, 102, '2015-02-01 00:36:58.000000', 'consum', 0.0210, 'lps'),
	(377831, 102, '2015-02-01 00:36:59.000000', 'consum', 0.0228, 'lps'),
	(377832, 102, '2015-02-01 00:37:00.000000', 'consum', 0.0230, 'lps'),
	(377833, 102, '2015-02-01 00:37:01.000000', 'consum', 0.0211, 'lps'),
	(377834, 102, '2015-02-01 00:37:02.000000', 'consum', 0.0226, 'lps'),
	(377835, 102, '2015-02-01 00:37:03.000000', 'consum', 0.0216, 'lps'),
	(377836, 102, '2015-02-01 00:37:04.000000', 'consum', 0.0216, 'lps'),
	(377837, 102, '2015-02-01 00:37:05.000000', 'consum', 0.0223, 'lps'),
	(377838, 102, '2015-02-01 00:37:06.000000', 'consum', 0.0213, 'lps'),
	(377839, 102, '2015-02-01 00:37:07.000000', 'consum', 0.0230, 'lps'),
	(377840, 102, '2015-02-01 00:37:08.000000', 'consum', 0.0232, 'lps'),
	(377841, 102, '2015-02-01 00:37:09.000000', 'consum', 0.0215, 'lps'),
	(377842, 102, '2015-02-01 00:37:10.000000', 'consum', 0.0217, 'lps'),
	(377843, 102, '2015-02-01 00:37:11.000000', 'consum', 0.0228, 'lps'),
	(377844, 102, '2015-02-01 00:37:12.000000', 'consum', 0.0210, 'lps'),
	(377845, 102, '2015-02-01 00:37:13.000000', 'consum', 0.0228, 'lps'),
	(377846, 102, '2015-02-01 00:37:14.000000', 'consum', 0.0230, 'lps'),
	(377847, 102, '2015-02-01 00:37:15.000000', 'consum', 0.0210, 'lps'),
	(377848, 102, '2015-02-01 00:37:16.000000', 'consum', 0.0221, 'lps'),
	(377849, 102, '2015-02-01 00:37:17.000000', 'consum', 0.0220, 'lps'),
	(377850, 102, '2015-02-01 00:37:18.000000', 'consum', 0.0226, 'lps'),
	(377851, 102, '2015-02-01 00:37:19.000000', 'consum', 0.0216, 'lps'),
	(377852, 102, '2015-02-01 00:37:20.000000', 'consum', 0.0216, 'lps'),
	(377853, 102, '2015-02-01 00:37:21.000000', 'consum', 0.0222, 'lps'),
	(377854, 102, '2015-02-01 00:37:22.000000', 'consum', 0.0229, 'lps'),
	(377855, 102, '2015-02-01 00:37:23.000000', 'consum', 0.0223, 'lps'),
	(377856, 102, '2015-02-01 00:37:24.000000', 'consum', 0.0220, 'lps'),
	(377857, 102, '2015-02-01 00:37:25.000000', 'consum', 0.0220, 'lps'),
	(377858, 102, '2015-02-01 00:37:26.000000', 'consum', 0.0232, 'lps'),
	(377859, 102, '2015-02-01 00:37:27.000000', 'consum', 0.0221, 'lps'),
	(377860, 102, '2015-02-01 00:37:28.000000', 'consum', 0.0221, 'lps'),
	(377861, 102, '2015-02-01 00:37:29.000000', 'consum', 0.0211, 'lps'),
	(377862, 102, '2015-02-01 00:37:30.000000', 'consum', 0.0228, 'lps'),
	(377863, 102, '2015-02-01 00:37:31.000000', 'consum', 0.0230, 'lps'),
	(377864, 102, '2015-02-01 00:37:32.000000', 'consum', 0.0210, 'lps'),
	(377865, 102, '2015-02-01 00:37:33.000000', 'consum', 0.0220, 'lps'),
	(377866, 102, '2015-02-01 00:37:34.000000', 'consum', 0.0214, 'lps'),
	(377867, 102, '2015-02-01 00:37:35.000000', 'consum', 0.0222, 'lps'),
	(377868, 102, '2015-02-01 00:37:36.000000', 'consum', 0.0214, 'lps'),
	(377869, 102, '2015-02-01 00:37:37.000000', 'consum', 0.0218, 'lps'),
	(377870, 102, '2015-02-01 00:37:38.000000', 'consum', 0.0217, 'lps'),
	(377871, 102, '2015-02-01 00:37:39.000000', 'consum', 0.0220, 'lps'),
	(377872, 102, '2015-02-01 00:37:40.000000', 'consum', 0.0217, 'lps'),
	(377873, 102, '2015-02-01 00:37:41.000000', 'consum', 0.0217, 'lps'),
	(377874, 102, '2015-02-01 00:37:42.000000', 'consum', 0.0224, 'lps'),
	(377875, 102, '2015-02-01 00:37:43.000000', 'consum', 0.0214, 'lps'),
	(377876, 102, '2015-02-01 00:37:44.000000', 'consum', 0.0210, 'lps'),
	(377877, 102, '2015-02-01 00:37:45.000000', 'consum', 0.0220, 'lps'),
	(377878, 102, '2015-02-01 00:37:46.000000', 'consum', 0.0217, 'lps'),
	(377879, 102, '2015-02-01 00:37:47.000000', 'consum', 0.0215, 'lps'),
	(377880, 102, '2015-02-01 00:37:48.000000', 'consum', 0.0213, 'lps'),
	(377881, 102, '2015-02-01 00:37:49.000000', 'consum', 0.0211, 'lps'),
	(377882, 102, '2015-02-01 00:37:50.000000', 'consum', 0.0232, 'lps'),
	(377883, 102, '2015-02-01 00:37:51.000000', 'consum', 0.0223, 'lps'),
	(377884, 102, '2015-02-01 00:37:52.000000', 'consum', 0.0210, 'lps'),
	(377885, 102, '2015-02-01 00:37:53.000000', 'consum', 0.0218, 'lps'),
	(377886, 102, '2015-02-01 00:37:54.000000', 'consum', 0.0227, 'lps'),
	(377887, 102, '2015-02-01 00:37:55.000000', 'consum', 0.0225, 'lps'),
	(377888, 102, '2015-02-01 00:37:56.000000', 'consum', 0.0210, 'lps'),
	(377889, 102, '2015-02-01 00:37:57.000000', 'consum', 0.0215, 'lps'),
	(377890, 102, '2015-02-01 00:37:58.000000', 'consum', 0.0232, 'lps'),
	(377891, 102, '2015-02-01 00:37:59.000000', 'consum', 0.0215, 'lps'),
	(377892, 102, '2015-02-01 00:38:00.000000', 'consum', 0.0217, 'lps'),
	(377893, 102, '2015-02-01 00:38:01.000000', 'consum', 0.0229, 'lps'),
	(377894, 102, '2015-02-01 00:38:02.000000', 'consum', 0.0216, 'lps'),
	(377895, 102, '2015-02-01 00:38:03.000000', 'consum', 0.0228, 'lps'),
	(377896, 102, '2015-02-01 00:38:04.000000', 'consum', 0.0216, 'lps'),
	(377897, 102, '2015-02-01 00:38:05.000000', 'consum', 0.0232, 'lps'),
	(377898, 102, '2015-02-01 00:38:06.000000', 'consum', 0.0210, 'lps'),
	(377899, 102, '2015-02-01 00:38:07.000000', 'consum', 0.0213, 'lps'),
	(377900, 102, '2015-02-01 00:38:08.000000', 'consum', 0.0225, 'lps'),
	(377901, 102, '2015-02-01 00:38:09.000000', 'consum', 0.0232, 'lps'),
	(377902, 102, '2015-02-01 00:38:10.000000', 'consum', 0.0227, 'lps'),
	(377903, 102, '2015-02-01 00:38:11.000000', 'consum', 0.0230, 'lps'),
	(377904, 102, '2015-02-01 00:38:12.000000', 'consum', 0.0215, 'lps'),
	(377905, 102, '2015-02-01 00:38:13.000000', 'consum', 0.0219, 'lps'),
	(377906, 102, '2015-02-01 00:38:14.000000', 'consum', 0.0218, 'lps'),
	(377907, 102, '2015-02-01 00:38:15.000000', 'consum', 0.0224, 'lps'),
	(377908, 102, '2015-02-01 00:38:16.000000', 'consum', 0.0212, 'lps'),
	(377909, 102, '2015-02-01 00:38:17.000000', 'consum', 0.0222, 'lps'),
	(377910, 102, '2015-02-01 00:38:18.000000', 'consum', 0.0219, 'lps'),
	(377911, 102, '2015-02-01 00:38:19.000000', 'consum', 0.0219, 'lps'),
	(377912, 102, '2015-02-01 00:38:20.000000', 'consum', 0.0231, 'lps'),
	(377913, 102, '2015-02-01 00:38:21.000000', 'consum', 0.0216, 'lps'),
	(377914, 102, '2015-02-01 00:38:22.000000', 'consum', 0.0227, 'lps'),
	(377915, 102, '2015-02-01 00:38:23.000000', 'consum', 0.0229, 'lps'),
	(377916, 102, '2015-02-01 00:38:24.000000', 'consum', 0.0231, 'lps'),
	(377917, 102, '2015-02-01 00:38:25.000000', 'consum', 0.0215, 'lps'),
	(377918, 102, '2015-02-01 00:38:26.000000', 'consum', 0.0218, 'lps'),
	(377919, 102, '2015-02-01 00:38:27.000000', 'consum', 0.0211, 'lps'),
	(377920, 102, '2015-02-01 00:38:28.000000', 'consum', 0.0213, 'lps'),
	(377921, 102, '2015-02-01 00:38:29.000000', 'consum', 0.0226, 'lps'),
	(377922, 102, '2015-02-01 00:38:30.000000', 'consum', 0.0210, 'lps'),
	(377923, 102, '2015-02-01 00:38:31.000000', 'consum', 0.0210, 'lps'),
	(377924, 102, '2015-02-01 00:38:32.000000', 'consum', 0.0210, 'lps'),
	(377925, 102, '2015-02-01 00:38:33.000000', 'consum', 0.0210, 'lps'),
	(377926, 102, '2015-02-01 00:38:34.000000', 'consum', 0.0232, 'lps'),
	(377927, 102, '2015-02-01 00:38:35.000000', 'consum', 0.0231, 'lps'),
	(377928, 102, '2015-02-01 00:38:36.000000', 'consum', 0.0224, 'lps'),
	(377929, 102, '2015-02-01 00:38:37.000000', 'consum', 0.0220, 'lps'),
	(377930, 102, '2015-02-01 00:38:38.000000', 'consum', 0.0218, 'lps'),
	(377931, 102, '2015-02-01 00:38:39.000000', 'consum', 0.0218, 'lps'),
	(377932, 102, '2015-02-01 00:38:40.000000', 'consum', 0.0230, 'lps'),
	(377933, 102, '2015-02-01 00:38:41.000000', 'consum', 0.0214, 'lps'),
	(377934, 102, '2015-02-01 00:38:42.000000', 'consum', 0.0220, 'lps'),
	(377935, 102, '2015-02-01 00:38:43.000000', 'consum', 0.0222, 'lps'),
	(377936, 102, '2015-02-01 00:38:44.000000', 'consum', 0.0219, 'lps'),
	(377937, 102, '2015-02-01 00:38:45.000000', 'consum', 0.0220, 'lps'),
	(377938, 102, '2015-02-01 00:38:46.000000', 'consum', 0.0210, 'lps'),
	(377939, 102, '2015-02-01 00:38:47.000000', 'consum', 0.0228, 'lps'),
	(377940, 102, '2015-02-01 00:38:48.000000', 'consum', 0.0230, 'lps'),
	(377941, 102, '2015-02-01 00:38:49.000000', 'consum', 0.0211, 'lps'),
	(377942, 102, '2015-02-01 00:38:50.000000', 'consum', 0.0226, 'lps'),
	(377943, 102, '2015-02-01 00:38:51.000000', 'consum', 0.0219, 'lps'),
	(377944, 102, '2015-02-01 00:38:52.000000', 'consum', 0.0229, 'lps'),
	(377945, 102, '2015-02-01 00:38:53.000000', 'consum', 0.0231, 'lps'),
	(377946, 102, '2015-02-01 00:38:54.000000', 'consum', 0.0213, 'lps'),
	(377947, 102, '2015-02-01 00:38:55.000000', 'consum', 0.0230, 'lps'),
	(377948, 102, '2015-02-01 00:38:56.000000', 'consum', 0.0211, 'lps'),
	(377949, 102, '2015-02-01 00:38:57.000000', 'consum', 0.0225, 'lps'),
	(377950, 102, '2015-02-01 00:38:58.000000', 'consum', 0.0213, 'lps'),
	(377951, 102, '2015-02-01 00:38:59.000000', 'consum', 0.0226, 'lps'),
	(377952, 102, '2015-02-01 00:39:00.000000', 'consum', 0.0213, 'lps'),
	(377953, 102, '2015-02-01 00:39:01.000000', 'consum', 0.0223, 'lps'),
	(377954, 102, '2015-02-01 00:39:02.000000', 'consum', 0.0219, 'lps'),
	(377955, 102, '2015-02-01 00:39:03.000000', 'consum', 0.0216, 'lps'),
	(377956, 102, '2015-02-01 00:39:04.000000', 'consum', 0.0217, 'lps'),
	(377957, 102, '2015-02-01 00:39:05.000000', 'consum', 0.0224, 'lps'),
	(377958, 102, '2015-02-01 00:39:06.000000', 'consum', 0.0217, 'lps'),
	(377959, 102, '2015-02-01 00:39:07.000000', 'consum', 0.0225, 'lps'),
	(377960, 102, '2015-02-01 00:39:08.000000', 'consum', 0.0218, 'lps'),
	(377961, 102, '2015-02-01 00:39:09.000000', 'consum', 0.0228, 'lps'),
	(377962, 102, '2015-02-01 00:39:10.000000', 'consum', 0.0231, 'lps'),
	(377963, 102, '2015-02-01 00:39:11.000000', 'consum', 0.0215, 'lps'),
	(377964, 102, '2015-02-01 00:39:12.000000', 'consum', 0.0221, 'lps'),
	(377965, 102, '2015-02-01 00:39:13.000000', 'consum', 0.0225, 'lps'),
	(377966, 102, '2015-02-01 00:39:14.000000', 'consum', 0.0228, 'lps'),
	(377967, 102, '2015-02-01 00:39:15.000000', 'consum', 0.0211, 'lps'),
	(377968, 102, '2015-02-01 00:39:16.000000', 'consum', 0.0232, 'lps'),
	(377969, 102, '2015-02-01 00:39:17.000000', 'consum', 0.0225, 'lps'),
	(377970, 102, '2015-02-01 00:39:18.000000', 'consum', 0.0219, 'lps'),
	(377971, 102, '2015-02-01 00:39:19.000000', 'consum', 0.0232, 'lps'),
	(377972, 102, '2015-02-01 00:39:20.000000', 'consum', 0.0228, 'lps'),
	(377973, 102, '2015-02-01 00:39:21.000000', 'consum', 0.0232, 'lps'),
	(377974, 102, '2015-02-01 00:39:22.000000', 'consum', 0.0220, 'lps'),
	(377975, 102, '2015-02-01 00:39:23.000000', 'consum', 0.0218, 'lps'),
	(377976, 102, '2015-02-01 00:39:24.000000', 'consum', 0.0221, 'lps'),
	(377977, 102, '2015-02-01 00:39:25.000000', 'consum', 0.0220, 'lps'),
	(377978, 102, '2015-02-01 00:39:26.000000', 'consum', 0.0228, 'lps'),
	(377979, 102, '2015-02-01 00:39:27.000000', 'consum', 0.0223, 'lps'),
	(377980, 102, '2015-02-01 00:39:28.000000', 'consum', 0.0224, 'lps'),
	(377981, 102, '2015-02-01 00:39:29.000000', 'consum', 0.0215, 'lps'),
	(377982, 102, '2015-02-01 00:39:30.000000', 'consum', 0.0219, 'lps'),
	(377983, 102, '2015-02-01 00:39:31.000000', 'consum', 0.0216, 'lps'),
	(377984, 102, '2015-02-01 00:39:32.000000', 'consum', 0.0214, 'lps'),
	(377985, 102, '2015-02-01 00:39:33.000000', 'consum', 0.0211, 'lps'),
	(377986, 102, '2015-02-01 00:39:34.000000', 'consum', 0.0227, 'lps'),
	(377987, 102, '2015-02-01 00:39:35.000000', 'consum', 0.0226, 'lps'),
	(377988, 102, '2015-02-01 00:39:36.000000', 'consum', 0.0213, 'lps'),
	(377989, 102, '2015-02-01 00:39:37.000000', 'consum', 0.0225, 'lps'),
	(377990, 102, '2015-02-01 00:39:38.000000', 'consum', 0.0231, 'lps'),
	(377991, 102, '2015-02-01 00:39:39.000000', 'consum', 0.0226, 'lps'),
	(377992, 102, '2015-02-01 00:39:40.000000', 'consum', 0.0224, 'lps'),
	(377993, 102, '2015-02-01 00:39:41.000000', 'consum', 0.0212, 'lps'),
	(377994, 102, '2015-02-01 00:39:42.000000', 'consum', 0.0225, 'lps'),
	(377995, 102, '2015-02-01 00:39:43.000000', 'consum', 0.0210, 'lps'),
	(377996, 102, '2015-02-01 00:39:44.000000', 'consum', 0.0211, 'lps'),
	(377997, 102, '2015-02-01 00:39:45.000000', 'consum', 0.0216, 'lps'),
	(377998, 102, '2015-02-01 00:39:46.000000', 'consum', 0.0213, 'lps'),
	(377999, 102, '2015-02-01 00:39:47.000000', 'consum', 0.0210, 'lps'),
	(378000, 102, '2015-02-01 00:39:48.000000', 'consum', 0.0222, 'lps'),
	(378001, 102, '2015-02-01 00:39:49.000000', 'consum', 0.0228, 'lps'),
	(378002, 102, '2015-02-01 00:39:50.000000', 'consum', 0.0215, 'lps'),
	(378003, 102, '2015-02-01 00:39:51.000000', 'consum', 0.0227, 'lps'),
	(378004, 102, '2015-02-01 00:39:52.000000', 'consum', 0.0213, 'lps'),
	(378005, 102, '2015-02-01 00:39:53.000000', 'consum', 0.0219, 'lps'),
	(378006, 102, '2015-02-01 00:39:54.000000', 'consum', 0.0226, 'lps'),
	(378007, 102, '2015-02-01 00:39:55.000000', 'consum', 0.0217, 'lps'),
	(378008, 102, '2015-02-01 00:39:56.000000', 'consum', 0.0221, 'lps'),
	(378009, 102, '2015-02-01 00:39:57.000000', 'consum', 0.0219, 'lps'),
	(378010, 102, '2015-02-01 00:39:58.000000', 'consum', 0.0225, 'lps'),
	(378011, 102, '2015-02-01 00:39:59.000000', 'consum', 0.0214, 'lps'),
	(378012, 102, '2015-02-01 00:40:00.000000', 'consum', 0.0228, 'lps'),
	(378013, 102, '2015-02-01 00:40:01.000000', 'consum', 0.0221, 'lps'),
	(378014, 102, '2015-02-01 00:40:02.000000', 'consum', 0.0210, 'lps'),
	(378015, 102, '2015-02-01 00:40:03.000000', 'consum', 0.0226, 'lps'),
	(378016, 102, '2015-02-01 00:40:04.000000', 'consum', 0.0221, 'lps'),
	(378017, 102, '2015-02-01 00:40:05.000000', 'consum', 0.0217, 'lps'),
	(378018, 102, '2015-02-01 00:40:06.000000', 'consum', 0.0211, 'lps'),
	(378019, 102, '2015-02-01 00:40:07.000000', 'consum', 0.0218, 'lps'),
	(378020, 102, '2015-02-01 00:40:08.000000', 'consum', 0.0226, 'lps'),
	(378021, 102, '2015-02-01 00:40:09.000000', 'consum', 0.0218, 'lps'),
	(378022, 102, '2015-02-01 00:40:10.000000', 'consum', 0.0228, 'lps'),
	(378023, 102, '2015-02-01 00:40:11.000000', 'consum', 0.0230, 'lps'),
	(378024, 102, '2015-02-01 00:40:12.000000', 'consum', 0.0210, 'lps'),
	(378025, 102, '2015-02-01 00:40:13.000000', 'consum', 0.0219, 'lps'),
	(378026, 102, '2015-02-01 00:40:14.000000', 'consum', 0.0231, 'lps'),
	(378027, 102, '2015-02-01 00:40:15.000000', 'consum', 0.0221, 'lps'),
	(378028, 102, '2015-02-01 00:40:16.000000', 'consum', 0.0223, 'lps'),
	(378029, 102, '2015-02-01 00:40:17.000000', 'consum', 0.0223, 'lps'),
	(378030, 102, '2015-02-01 00:40:18.000000', 'consum', 0.0211, 'lps'),
	(378031, 102, '2015-02-01 00:40:19.000000', 'consum', 0.0222, 'lps'),
	(378032, 102, '2015-02-01 00:40:20.000000', 'consum', 0.0224, 'lps'),
	(378033, 102, '2015-02-01 00:40:21.000000', 'consum', 0.0222, 'lps'),
	(378034, 102, '2015-02-01 00:40:22.000000', 'consum', 0.0227, 'lps'),
	(378035, 102, '2015-02-01 00:40:23.000000', 'consum', 0.0214, 'lps'),
	(378036, 102, '2015-02-01 00:40:24.000000', 'consum', 0.0227, 'lps'),
	(378037, 102, '2015-02-01 00:40:25.000000', 'consum', 0.0214, 'lps'),
	(378038, 102, '2015-02-01 00:40:26.000000', 'consum', 0.0226, 'lps'),
	(378039, 102, '2015-02-01 00:40:27.000000', 'consum', 0.0210, 'lps'),
	(378040, 102, '2015-02-01 00:40:28.000000', 'consum', 0.0231, 'lps'),
	(378041, 102, '2015-02-01 00:40:29.000000', 'consum', 0.0223, 'lps'),
	(378042, 102, '2015-02-01 00:40:30.000000', 'consum', 0.0212, 'lps'),
	(378043, 102, '2015-02-01 00:40:31.000000', 'consum', 0.0227, 'lps'),
	(378044, 102, '2015-02-01 00:40:32.000000', 'consum', 0.0222, 'lps'),
	(378045, 102, '2015-02-01 00:40:33.000000', 'consum', 0.0217, 'lps'),
	(378046, 102, '2015-02-01 00:40:34.000000', 'consum', 0.0212, 'lps'),
	(378047, 102, '2015-02-01 00:40:35.000000', 'consum', 0.0221, 'lps'),
	(378048, 102, '2015-02-01 00:40:36.000000', 'consum', 0.0214, 'lps'),
	(378049, 102, '2015-02-01 00:40:37.000000', 'consum', 0.0219, 'lps'),
	(378050, 102, '2015-02-01 00:40:38.000000', 'consum', 0.0222, 'lps'),
	(378051, 102, '2015-02-01 00:40:39.000000', 'consum', 0.0219, 'lps'),
	(378052, 102, '2015-02-01 00:40:40.000000', 'consum', 0.0221, 'lps'),
	(378053, 102, '2015-02-01 00:40:41.000000', 'consum', 0.0215, 'lps'),
	(378054, 102, '2015-02-01 00:40:42.000000', 'consum', 0.0225, 'lps'),
	(378055, 102, '2015-02-01 00:40:43.000000', 'consum', 0.0224, 'lps'),
	(378056, 102, '2015-02-01 00:40:44.000000', 'consum', 0.0213, 'lps'),
	(378057, 102, '2015-02-01 00:40:45.000000', 'consum', 0.0231, 'lps'),
	(378058, 102, '2015-02-01 00:40:46.000000', 'consum', 0.0213, 'lps'),
	(378059, 102, '2015-02-01 00:40:47.000000', 'consum', 0.0230, 'lps'),
	(378060, 102, '2015-02-01 00:40:48.000000', 'consum', 0.0210, 'lps'),
	(378061, 102, '2015-02-01 00:40:49.000000', 'consum', 0.0219, 'lps'),
	(378062, 102, '2015-02-01 00:40:50.000000', 'consum', 0.0210, 'lps'),
	(378063, 102, '2015-02-01 00:40:51.000000', 'consum', 0.0230, 'lps'),
	(378064, 102, '2015-02-01 00:40:52.000000', 'consum', 0.0217, 'lps'),
	(378065, 102, '2015-02-01 00:40:53.000000', 'consum', 0.0211, 'lps'),
	(378066, 102, '2015-02-01 00:40:54.000000', 'consum', 0.0217, 'lps'),
	(378067, 102, '2015-02-01 00:40:55.000000', 'consum', 0.0220, 'lps'),
	(378068, 102, '2015-02-01 00:40:56.000000', 'consum', 0.0214, 'lps'),
	(378069, 102, '2015-02-01 00:40:57.000000', 'consum', 0.0224, 'lps'),
	(378070, 102, '2015-02-01 00:40:58.000000', 'consum', 0.0221, 'lps'),
	(378071, 102, '2015-02-01 00:40:59.000000', 'consum', 0.0225, 'lps'),
	(378072, 102, '2015-02-01 00:41:00.000000', 'consum', 0.0231, 'lps'),
	(378073, 102, '2015-02-01 00:41:01.000000', 'consum', 0.0224, 'lps'),
	(378074, 102, '2015-02-01 00:41:02.000000', 'consum', 0.0216, 'lps'),
	(378075, 102, '2015-02-01 00:41:03.000000', 'consum', 0.0221, 'lps'),
	(378076, 102, '2015-02-01 00:41:04.000000', 'consum', 0.0224, 'lps'),
	(378077, 102, '2015-02-01 00:41:05.000000', 'consum', 0.0224, 'lps'),
	(378078, 102, '2015-02-01 00:41:06.000000', 'consum', 0.0215, 'lps'),
	(378079, 102, '2015-02-01 00:41:07.000000', 'consum', 0.0217, 'lps'),
	(378080, 102, '2015-02-01 00:41:08.000000', 'consum', 0.0231, 'lps'),
	(378081, 102, '2015-02-01 00:41:09.000000', 'consum', 0.0226, 'lps'),
	(378082, 102, '2015-02-01 00:41:10.000000', 'consum', 0.0226, 'lps'),
	(378083, 102, '2015-02-01 00:41:11.000000', 'consum', 0.0221, 'lps'),
	(378084, 102, '2015-02-01 00:41:12.000000', 'consum', 0.0215, 'lps'),
	(378085, 102, '2015-02-01 00:41:13.000000', 'consum', 0.0228, 'lps'),
	(378086, 102, '2015-02-01 00:41:14.000000', 'consum', 0.0214, 'lps'),
	(378087, 102, '2015-02-01 00:41:15.000000', 'consum', 0.0222, 'lps'),
	(378088, 102, '2015-02-01 00:41:16.000000', 'consum', 0.0215, 'lps'),
	(378089, 102, '2015-02-01 00:41:17.000000', 'consum', 0.0224, 'lps'),
	(378090, 102, '2015-02-01 00:41:18.000000', 'consum', 0.0216, 'lps'),
	(378091, 102, '2015-02-01 00:41:19.000000', 'consum', 0.0225, 'lps'),
	(378092, 102, '2015-02-01 00:41:20.000000', 'consum', 0.0219, 'lps'),
	(378093, 102, '2015-02-01 00:41:21.000000', 'consum', 0.0232, 'lps'),
	(378094, 102, '2015-02-01 00:41:22.000000', 'consum', 0.0226, 'lps'),
	(378095, 102, '2015-02-01 00:41:23.000000', 'consum', 0.0226, 'lps'),
	(378096, 102, '2015-02-01 00:41:24.000000', 'consum', 0.0219, 'lps'),
	(378097, 102, '2015-02-01 00:41:25.000000', 'consum', 0.0229, 'lps'),
	(378098, 102, '2015-02-01 00:41:26.000000', 'consum', 0.0210, 'lps'),
	(378099, 102, '2015-02-01 00:41:27.000000', 'consum', 0.0224, 'lps'),
	(378100, 102, '2015-02-01 00:41:28.000000', 'consum', 0.0232, 'lps'),
	(378101, 102, '2015-02-01 00:41:29.000000', 'consum', 0.0212, 'lps'),
	(378102, 102, '2015-02-01 00:41:30.000000', 'consum', 0.0222, 'lps'),
	(378103, 102, '2015-02-01 00:41:31.000000', 'consum', 0.0218, 'lps'),
	(378104, 102, '2015-02-01 00:41:32.000000', 'consum', 0.0216, 'lps'),
	(378105, 102, '2015-02-01 00:41:33.000000', 'consum', 0.0215, 'lps'),
	(378106, 102, '2015-02-01 00:41:34.000000', 'consum', 0.0216, 'lps'),
	(378107, 102, '2015-02-01 00:41:35.000000', 'consum', 0.0228, 'lps'),
	(378108, 102, '2015-02-01 00:41:36.000000', 'consum', 0.0213, 'lps'),
	(378109, 102, '2015-02-01 00:41:37.000000', 'consum', 0.0217, 'lps'),
	(378110, 102, '2015-02-01 00:41:38.000000', 'consum', 0.0212, 'lps'),
	(378111, 102, '2015-02-01 00:41:39.000000', 'consum', 0.0225, 'lps'),
	(378112, 102, '2015-02-01 00:41:40.000000', 'consum', 0.0210, 'lps'),
	(378113, 102, '2015-02-01 00:41:41.000000', 'consum', 0.0210, 'lps'),
	(378114, 102, '2015-02-01 00:41:42.000000', 'consum', 0.0210, 'lps'),
	(378115, 102, '2015-02-01 00:41:43.000000', 'consum', 0.0212, 'lps'),
	(378116, 102, '2015-02-01 00:41:44.000000', 'consum', 0.0218, 'lps'),
	(378117, 102, '2015-02-01 00:41:45.000000', 'consum', 0.0223, 'lps'),
	(378118, 102, '2015-02-01 00:41:46.000000', 'consum', 0.0229, 'lps'),
	(378119, 102, '2015-02-01 00:41:47.000000', 'consum', 0.0222, 'lps'),
	(378120, 102, '2015-02-01 00:41:48.000000', 'consum', 0.0213, 'lps'),
	(378121, 102, '2015-02-01 00:41:49.000000', 'consum', 0.0214, 'lps'),
	(378122, 102, '2015-02-01 00:41:50.000000', 'consum', 0.0218, 'lps'),
	(378123, 102, '2015-02-01 00:41:51.000000', 'consum', 0.0217, 'lps'),
	(378124, 102, '2015-02-01 00:41:52.000000', 'consum', 0.0221, 'lps'),
	(378125, 102, '2015-02-01 00:41:53.000000', 'consum', 0.0223, 'lps'),
	(378126, 102, '2015-02-01 00:41:54.000000', 'consum', 0.0218, 'lps'),
	(378127, 102, '2015-02-01 00:41:55.000000', 'consum', 0.0212, 'lps'),
	(378128, 102, '2015-02-01 00:41:56.000000', 'consum', 0.0221, 'lps'),
	(378129, 102, '2015-02-01 00:41:57.000000', 'consum', 0.0212, 'lps'),
	(378130, 102, '2015-02-01 00:41:58.000000', 'consum', 0.0210, 'lps'),
	(378131, 102, '2015-02-01 00:41:59.000000', 'consum', 0.0230, 'lps'),
	(378132, 102, '2015-02-01 00:42:00.000000', 'consum', 0.0218, 'lps'),
	(378133, 102, '2015-02-01 00:42:01.000000', 'consum', 0.0213, 'lps'),
	(378134, 102, '2015-02-01 00:42:02.000000', 'consum', 0.0224, 'lps'),
	(378135, 102, '2015-02-01 00:42:03.000000', 'consum', 0.0226, 'lps'),
	(378136, 102, '2015-02-01 00:42:04.000000', 'consum', 0.0227, 'lps'),
	(378137, 102, '2015-02-01 00:42:05.000000', 'consum', 0.0224, 'lps'),
	(378138, 102, '2015-02-01 00:42:06.000000', 'consum', 0.0229, 'lps'),
	(378139, 102, '2015-02-01 00:42:07.000000', 'consum', 0.0219, 'lps'),
	(378140, 102, '2015-02-01 00:42:08.000000', 'consum', 0.0221, 'lps'),
	(378141, 102, '2015-02-01 00:42:09.000000', 'consum', 0.0216, 'lps'),
	(378142, 102, '2015-02-01 00:42:10.000000', 'consum', 0.0229, 'lps'),
	(378143, 102, '2015-02-01 00:42:11.000000', 'consum', 0.0218, 'lps'),
	(378144, 102, '2015-02-01 00:42:12.000000', 'consum', 0.0218, 'lps'),
	(378145, 102, '2015-02-01 00:42:13.000000', 'consum', 0.0228, 'lps'),
	(378146, 102, '2015-02-01 00:42:14.000000', 'consum', 0.0227, 'lps'),
	(378147, 102, '2015-02-01 00:42:15.000000', 'consum', 0.0220, 'lps'),
	(378148, 102, '2015-02-01 00:42:16.000000', 'consum', 0.0232, 'lps'),
	(378149, 102, '2015-02-01 00:42:17.000000', 'consum', 0.0220, 'lps'),
	(378150, 102, '2015-02-01 00:42:18.000000', 'consum', 0.0218, 'lps'),
	(378151, 102, '2015-02-01 00:42:19.000000', 'consum', 0.0223, 'lps'),
	(378152, 102, '2015-02-01 00:42:20.000000', 'consum', 0.0226, 'lps'),
	(378153, 102, '2015-02-01 00:42:21.000000', 'consum', 0.0227, 'lps'),
	(378154, 102, '2015-02-01 00:42:22.000000', 'consum', 0.0227, 'lps'),
	(378155, 102, '2015-02-01 00:42:23.000000', 'consum', 0.0223, 'lps'),
	(378156, 102, '2015-02-01 00:42:24.000000', 'consum', 0.0222, 'lps'),
	(378157, 102, '2015-02-01 00:42:25.000000', 'consum', 0.0231, 'lps'),
	(378158, 102, '2015-02-01 00:42:26.000000', 'consum', 0.0211, 'lps'),
	(378159, 102, '2015-02-01 00:42:27.000000', 'consum', 0.0221, 'lps'),
	(378160, 102, '2015-02-01 00:42:28.000000', 'consum', 0.0218, 'lps'),
	(378161, 102, '2015-02-01 00:42:29.000000', 'consum', 0.0217, 'lps'),
	(378162, 102, '2015-02-01 00:42:30.000000', 'consum', 0.0222, 'lps'),
	(378163, 102, '2015-02-01 00:42:31.000000', 'consum', 0.0228, 'lps'),
	(378164, 102, '2015-02-01 00:42:32.000000', 'consum', 0.0216, 'lps'),
	(378165, 102, '2015-02-01 00:42:33.000000', 'consum', 0.0211, 'lps'),
	(378166, 102, '2015-02-01 00:42:34.000000', 'consum', 0.0221, 'lps'),
	(378167, 102, '2015-02-01 00:42:35.000000', 'consum', 0.0214, 'lps'),
	(378168, 102, '2015-02-01 00:42:36.000000', 'consum', 0.0223, 'lps'),
	(378169, 102, '2015-02-01 00:42:37.000000', 'consum', 0.0216, 'lps'),
	(378170, 102, '2015-02-01 00:42:38.000000', 'consum', 0.0226, 'lps'),
	(378171, 102, '2015-02-01 00:42:39.000000', 'consum', 0.0227, 'lps'),
	(378172, 102, '2015-02-01 00:42:40.000000', 'consum', 0.0222, 'lps'),
	(378173, 102, '2015-02-01 00:42:41.000000', 'consum', 0.0222, 'lps'),
	(378174, 102, '2015-02-01 00:42:42.000000', 'consum', 0.0210, 'lps'),
	(378175, 102, '2015-02-01 00:42:43.000000', 'consum', 0.0221, 'lps'),
	(378176, 102, '2015-02-01 00:42:44.000000', 'consum', 0.0218, 'lps'),
	(378177, 102, '2015-02-01 00:42:45.000000', 'consum', 0.0217, 'lps'),
	(378178, 102, '2015-02-01 00:42:46.000000', 'consum', 0.0221, 'lps'),
	(378179, 102, '2015-02-01 00:42:47.000000', 'consum', 0.0222, 'lps'),
	(378180, 102, '2015-02-01 00:42:48.000000', 'consum', 0.0215, 'lps'),
	(378181, 102, '2015-02-01 00:42:49.000000', 'consum', 0.0221, 'lps'),
	(378182, 102, '2015-02-01 00:42:50.000000', 'consum', 0.0230, 'lps'),
	(378183, 102, '2015-02-01 00:42:51.000000', 'consum', 0.0210, 'lps'),
	(378184, 102, '2015-02-01 00:42:52.000000', 'consum', 0.0216, 'lps'),
	(378185, 102, '2015-02-01 00:42:53.000000', 'consum', 0.0219, 'lps'),
	(378186, 102, '2015-02-01 00:42:54.000000', 'consum', 0.0212, 'lps'),
	(378187, 102, '2015-02-01 00:42:55.000000', 'consum', 0.0219, 'lps'),
	(378188, 102, '2015-02-01 00:42:56.000000', 'consum', 0.0227, 'lps'),
	(378189, 102, '2015-02-01 00:42:57.000000', 'consum', 0.0221, 'lps'),
	(378190, 102, '2015-02-01 00:42:58.000000', 'consum', 0.0216, 'lps'),
	(378191, 102, '2015-02-01 00:42:59.000000', 'consum', 0.0228, 'lps'),
	(378192, 102, '2015-02-01 00:43:00.000000', 'consum', 0.0214, 'lps'),
	(378193, 102, '2015-02-01 00:43:01.000000', 'consum', 0.0222, 'lps'),
	(378194, 102, '2015-02-01 00:43:02.000000', 'consum', 0.0212, 'lps'),
	(378195, 102, '2015-02-01 00:43:03.000000', 'consum', 0.0232, 'lps'),
	(378196, 102, '2015-02-01 00:43:04.000000', 'consum', 0.0221, 'lps'),
	(378197, 102, '2015-02-01 00:43:05.000000', 'consum', 0.0222, 'lps'),
	(378198, 102, '2015-02-01 00:43:06.000000', 'consum', 0.0216, 'lps'),
	(378199, 102, '2015-02-01 00:43:07.000000', 'consum', 0.0226, 'lps'),
	(378200, 102, '2015-02-01 00:43:08.000000', 'consum', 0.0229, 'lps'),
	(378201, 102, '2015-02-01 00:43:09.000000', 'consum', 0.0210, 'lps'),
	(378202, 102, '2015-02-01 00:43:10.000000', 'consum', 0.0223, 'lps'),
	(378203, 102, '2015-02-01 00:43:11.000000', 'consum', 0.0230, 'lps'),
	(378204, 102, '2015-02-01 00:43:12.000000', 'consum', 0.0225, 'lps'),
	(378205, 102, '2015-02-01 00:43:13.000000', 'consum', 0.0227, 'lps'),
	(378206, 102, '2015-02-01 00:43:14.000000', 'consum', 0.0227, 'lps'),
	(378207, 102, '2015-02-01 00:43:15.000000', 'consum', 0.0220, 'lps'),
	(378208, 102, '2015-02-01 00:43:16.000000', 'consum', 0.0211, 'lps'),
	(378209, 102, '2015-02-01 00:43:17.000000', 'consum', 0.0231, 'lps'),
	(378210, 102, '2015-02-01 00:43:18.000000', 'consum', 0.0222, 'lps'),
	(378211, 102, '2015-02-01 00:43:19.000000', 'consum', 0.0231, 'lps'),
	(378212, 102, '2015-02-01 00:43:20.000000', 'consum', 0.0211, 'lps'),
	(378213, 102, '2015-02-01 00:43:21.000000', 'consum', 0.0220, 'lps'),
	(378214, 102, '2015-02-01 00:43:22.000000', 'consum', 0.0210, 'lps'),
	(378215, 102, '2015-02-01 00:43:23.000000', 'consum', 0.0228, 'lps'),
	(378216, 102, '2015-02-01 00:43:24.000000', 'consum', 0.0210, 'lps'),
	(378217, 102, '2015-02-01 00:43:25.000000', 'consum', 0.0225, 'lps'),
	(378218, 102, '2015-02-01 00:43:26.000000', 'consum', 0.0214, 'lps'),
	(378219, 102, '2015-02-01 00:43:27.000000', 'consum', 0.0211, 'lps'),
	(378220, 102, '2015-02-01 00:43:28.000000', 'consum', 0.0227, 'lps'),
	(378221, 102, '2015-02-01 00:43:29.000000', 'consum', 0.0224, 'lps'),
	(378222, 102, '2015-02-01 00:43:30.000000', 'consum', 0.0227, 'lps'),
	(378223, 102, '2015-02-01 00:43:31.000000', 'consum', 0.0211, 'lps'),
	(378224, 102, '2015-02-01 00:43:32.000000', 'consum', 0.0230, 'lps'),
	(378225, 102, '2015-02-01 00:43:33.000000', 'consum', 0.0217, 'lps'),
	(378226, 102, '2015-02-01 00:43:34.000000', 'consum', 0.0210, 'lps'),
	(378227, 102, '2015-02-01 00:43:35.000000', 'consum', 0.0212, 'lps'),
	(378228, 102, '2015-02-01 00:43:36.000000', 'consum', 0.0220, 'lps'),
	(378229, 102, '2015-02-01 00:43:37.000000', 'consum', 0.0232, 'lps'),
	(378230, 102, '2015-02-01 00:43:38.000000', 'consum', 0.0223, 'lps'),
	(378231, 102, '2015-02-01 00:43:39.000000', 'consum', 0.0231, 'lps'),
	(378232, 102, '2015-02-01 00:43:40.000000', 'consum', 0.0231, 'lps'),
	(378233, 102, '2015-02-01 00:43:41.000000', 'consum', 0.0229, 'lps'),
	(378234, 102, '2015-02-01 00:43:42.000000', 'consum', 0.0218, 'lps'),
	(378235, 102, '2015-02-01 00:43:43.000000', 'consum', 0.0218, 'lps'),
	(378236, 102, '2015-02-01 00:43:44.000000', 'consum', 0.0225, 'lps'),
	(378237, 102, '2015-02-01 00:43:45.000000', 'consum', 0.0216, 'lps'),
	(378238, 102, '2015-02-01 00:43:46.000000', 'consum', 0.0221, 'lps'),
	(378239, 102, '2015-02-01 00:43:47.000000', 'consum', 0.0222, 'lps'),
	(378240, 102, '2015-02-01 00:43:48.000000', 'consum', 0.0214, 'lps'),
	(378241, 102, '2015-02-01 00:43:49.000000', 'consum', 0.0218, 'lps'),
	(378242, 102, '2015-02-01 00:43:50.000000', 'consum', 0.0215, 'lps'),
	(378243, 102, '2015-02-01 00:43:51.000000', 'consum', 0.0213, 'lps'),
	(378244, 102, '2015-02-01 00:43:52.000000', 'consum', 0.0232, 'lps'),
	(378245, 102, '2015-02-01 00:43:53.000000', 'consum', 0.0220, 'lps'),
	(378246, 102, '2015-02-01 00:43:54.000000', 'consum', 0.0217, 'lps'),
	(378247, 102, '2015-02-01 00:43:55.000000', 'consum', 0.0216, 'lps'),
	(378248, 102, '2015-02-01 00:43:56.000000', 'consum', 0.0221, 'lps'),
	(378249, 102, '2015-02-01 00:43:57.000000', 'consum', 0.0225, 'lps'),
	(378250, 102, '2015-02-01 00:43:58.000000', 'consum', 0.0228, 'lps'),
	(378251, 102, '2015-02-01 00:43:59.000000', 'consum', 0.0232, 'lps'),
	(378252, 102, '2015-02-01 00:44:00.000000', 'consum', 0.0221, 'lps'),
	(378253, 102, '2015-02-01 00:44:01.000000', 'consum', 0.0223, 'lps'),
	(378254, 102, '2015-02-01 00:44:02.000000', 'consum', 0.0219, 'lps'),
	(378255, 102, '2015-02-01 00:44:03.000000', 'consum', 0.0218, 'lps'),
	(378256, 102, '2015-02-01 00:44:04.000000', 'consum', 0.0224, 'lps'),
	(378257, 102, '2015-02-01 00:44:05.000000', 'consum', 0.0211, 'lps'),
	(378258, 102, '2015-02-01 00:44:06.000000', 'consum', 0.0217, 'lps'),
	(378259, 102, '2015-02-01 00:44:07.000000', 'consum', 0.0222, 'lps'),
	(378260, 102, '2015-02-01 00:44:08.000000', 'consum', 0.0223, 'lps'),
	(378261, 102, '2015-02-01 00:44:09.000000', 'consum', 0.0220, 'lps'),
	(378262, 102, '2015-02-01 00:44:10.000000', 'consum', 0.0221, 'lps'),
	(378263, 102, '2015-02-01 00:44:11.000000', 'consum', 0.0212, 'lps'),
	(378264, 102, '2015-02-01 00:44:12.000000', 'consum', 0.0210, 'lps'),
	(378265, 102, '2015-02-01 00:44:13.000000', 'consum', 0.0226, 'lps'),
	(378266, 102, '2015-02-01 00:44:14.000000', 'consum', 0.0224, 'lps'),
	(378267, 102, '2015-02-01 00:44:15.000000', 'consum', 0.0232, 'lps'),
	(378268, 102, '2015-02-01 00:44:16.000000', 'consum', 0.0210, 'lps'),
	(378269, 102, '2015-02-01 00:44:17.000000', 'consum', 0.0213, 'lps'),
	(378270, 102, '2015-02-01 00:44:18.000000', 'consum', 0.0226, 'lps'),
	(378271, 102, '2015-02-01 00:44:19.000000', 'consum', 0.0210, 'lps'),
	(378272, 102, '2015-02-01 00:44:20.000000', 'consum', 0.0211, 'lps'),
	(378273, 102, '2015-02-01 00:44:21.000000', 'consum', 0.0215, 'lps'),
	(378274, 102, '2015-02-01 00:44:22.000000', 'consum', 0.0210, 'lps'),
	(378275, 102, '2015-02-01 00:44:23.000000', 'consum', 0.0216, 'lps'),
	(378276, 102, '2015-02-01 00:44:24.000000', 'consum', 0.0219, 'lps'),
	(378277, 102, '2015-02-01 00:44:25.000000', 'consum', 0.0213, 'lps'),
	(378278, 102, '2015-02-01 00:44:26.000000', 'consum', 0.0223, 'lps'),
	(378279, 102, '2015-02-01 00:44:27.000000', 'consum', 0.0221, 'lps'),
	(378280, 102, '2015-02-01 00:44:28.000000', 'consum', 0.0224, 'lps'),
	(378281, 102, '2015-02-01 00:44:29.000000', 'consum', 0.0225, 'lps'),
	(378282, 102, '2015-02-01 00:44:30.000000', 'consum', 0.0221, 'lps'),
	(378283, 102, '2015-02-01 00:44:31.000000', 'consum', 0.0219, 'lps'),
	(378284, 102, '2015-02-01 00:44:32.000000', 'consum', 0.0221, 'lps'),
	(378285, 102, '2015-02-01 00:44:33.000000', 'consum', 0.0219, 'lps'),
	(378286, 102, '2015-02-01 00:44:34.000000', 'consum', 0.0223, 'lps'),
	(378287, 102, '2015-02-01 00:44:35.000000', 'consum', 0.0222, 'lps'),
	(378288, 102, '2015-02-01 00:44:36.000000', 'consum', 0.0212, 'lps'),
	(378289, 102, '2015-02-01 00:44:37.000000', 'consum', 0.0228, 'lps'),
	(378290, 102, '2015-02-01 00:44:38.000000', 'consum', 0.0227, 'lps'),
	(378291, 102, '2015-02-01 00:44:39.000000', 'consum', 0.0219, 'lps'),
	(378292, 102, '2015-02-01 00:44:40.000000', 'consum', 0.0227, 'lps'),
	(378293, 102, '2015-02-01 00:44:41.000000', 'consum', 0.0221, 'lps'),
	(378294, 102, '2015-02-01 00:44:42.000000', 'consum', 0.0214, 'lps'),
	(378295, 102, '2015-02-01 00:44:43.000000', 'consum', 0.0221, 'lps'),
	(378296, 102, '2015-02-01 00:44:44.000000', 'consum', 0.0232, 'lps'),
	(378297, 102, '2015-02-01 00:44:45.000000', 'consum', 0.0219, 'lps'),
	(378298, 102, '2015-02-01 00:44:46.000000', 'consum', 0.0211, 'lps'),
	(378299, 102, '2015-02-01 00:44:47.000000', 'consum', 0.0212, 'lps'),
	(378300, 102, '2015-02-01 00:44:48.000000', 'consum', 0.0219, 'lps'),
	(378301, 102, '2015-02-01 00:44:49.000000', 'consum', 0.0227, 'lps'),
	(378302, 102, '2015-02-01 00:44:50.000000', 'consum', 0.0223, 'lps'),
	(378303, 102, '2015-02-01 00:44:51.000000', 'consum', 0.0223, 'lps'),
	(378304, 102, '2015-02-01 00:44:52.000000', 'consum', 0.0212, 'lps'),
	(378305, 102, '2015-02-01 00:44:53.000000', 'consum', 0.0227, 'lps'),
	(378306, 102, '2015-02-01 00:44:54.000000', 'consum', 0.0222, 'lps'),
	(378307, 102, '2015-02-01 00:44:55.000000', 'consum', 0.0220, 'lps'),
	(378308, 102, '2015-02-01 00:44:56.000000', 'consum', 0.0223, 'lps'),
	(378309, 102, '2015-02-01 00:44:57.000000', 'consum', 0.0224, 'lps'),
	(378310, 102, '2015-02-01 00:44:58.000000', 'consum', 0.0217, 'lps'),
	(378311, 102, '2015-02-01 00:44:59.000000', 'consum', 0.0226, 'lps'),
	(378312, 102, '2015-02-01 00:45:00.000000', 'consum', 0.0225, 'lps'),
	(378313, 102, '2015-02-01 00:45:01.000000', 'consum', 0.0215, 'lps'),
	(378314, 102, '2015-02-01 00:45:02.000000', 'consum', 0.0212, 'lps'),
	(378315, 102, '2015-02-01 00:45:03.000000', 'consum', 0.0229, 'lps'),
	(378316, 102, '2015-02-01 00:45:04.000000', 'consum', 0.0232, 'lps'),
	(378317, 102, '2015-02-01 00:45:05.000000', 'consum', 0.0217, 'lps'),
	(378318, 102, '2015-02-01 00:45:06.000000', 'consum', 0.0226, 'lps'),
	(378319, 102, '2015-02-01 00:45:07.000000', 'consum', 0.0223, 'lps'),
	(378320, 102, '2015-02-01 00:45:08.000000', 'consum', 0.0229, 'lps'),
	(378321, 102, '2015-02-01 00:45:09.000000', 'consum', 0.0217, 'lps'),
	(378322, 102, '2015-02-01 00:45:10.000000', 'consum', 0.0215, 'lps'),
	(378323, 102, '2015-02-01 00:45:11.000000', 'consum', 0.0214, 'lps'),
	(378324, 102, '2015-02-01 00:45:12.000000', 'consum', 0.0215, 'lps'),
	(378325, 102, '2015-02-01 00:45:13.000000', 'consum', 0.0224, 'lps'),
	(378326, 102, '2015-02-01 00:45:14.000000', 'consum', 0.0217, 'lps'),
	(378327, 102, '2015-02-01 00:45:15.000000', 'consum', 0.0228, 'lps'),
	(378328, 102, '2015-02-01 00:45:16.000000', 'consum', 0.0213, 'lps'),
	(378329, 102, '2015-02-01 00:45:17.000000', 'consum', 0.0214, 'lps'),
	(378330, 102, '2015-02-01 00:45:18.000000', 'consum', 0.0223, 'lps'),
	(378331, 102, '2015-02-01 00:45:19.000000', 'consum', 0.0219, 'lps'),
	(378332, 102, '2015-02-01 00:45:20.000000', 'consum', 0.0214, 'lps'),
	(378333, 102, '2015-02-01 00:45:21.000000', 'consum', 0.0226, 'lps'),
	(378334, 102, '2015-02-01 00:45:22.000000', 'consum', 0.0232, 'lps'),
	(378335, 102, '2015-02-01 00:45:23.000000', 'consum', 0.0228, 'lps'),
	(378336, 102, '2015-02-01 00:45:24.000000', 'consum', 0.0210, 'lps'),
	(378337, 102, '2015-02-01 00:45:25.000000', 'consum', 0.0227, 'lps'),
	(378338, 102, '2015-02-01 00:45:26.000000', 'consum', 0.0226, 'lps'),
	(378339, 102, '2015-02-01 00:45:27.000000', 'consum', 0.0217, 'lps'),
	(378340, 102, '2015-02-01 00:45:28.000000', 'consum', 0.0220, 'lps'),
	(378341, 102, '2015-02-01 00:45:29.000000', 'consum', 0.0217, 'lps'),
	(378342, 102, '2015-02-01 00:45:30.000000', 'consum', 0.0215, 'lps'),
	(378343, 102, '2015-02-01 00:45:31.000000', 'consum', 0.0216, 'lps'),
	(378344, 102, '2015-02-01 00:45:32.000000', 'consum', 0.0224, 'lps'),
	(378345, 102, '2015-02-01 00:45:33.000000', 'consum', 0.0216, 'lps'),
	(378346, 102, '2015-02-01 00:45:34.000000', 'consum', 0.0220, 'lps'),
	(378347, 102, '2015-02-01 00:45:35.000000', 'consum', 0.0222, 'lps'),
	(378348, 102, '2015-02-01 00:45:36.000000', 'consum', 0.0215, 'lps'),
	(378349, 102, '2015-02-01 00:45:37.000000', 'consum', 0.0224, 'lps'),
	(378350, 102, '2015-02-01 00:45:38.000000', 'consum', 0.0219, 'lps'),
	(378351, 102, '2015-02-01 00:45:39.000000', 'consum', 0.0213, 'lps'),
	(378352, 102, '2015-02-01 00:45:40.000000', 'consum', 0.0221, 'lps'),
	(378353, 102, '2015-02-01 00:45:41.000000', 'consum', 0.0213, 'lps'),
	(378354, 102, '2015-02-01 00:45:42.000000', 'consum', 0.0215, 'lps'),
	(378355, 102, '2015-02-01 00:45:43.000000', 'consum', 0.0227, 'lps'),
	(378356, 102, '2015-02-01 00:45:44.000000', 'consum', 0.0212, 'lps'),
	(378357, 102, '2015-02-01 00:45:45.000000', 'consum', 0.0214, 'lps'),
	(378358, 102, '2015-02-01 00:45:46.000000', 'consum', 0.0226, 'lps'),
	(378359, 102, '2015-02-01 00:45:47.000000', 'consum', 0.0232, 'lps'),
	(378360, 102, '2015-02-01 00:45:48.000000', 'consum', 0.0225, 'lps'),
	(378361, 102, '2015-02-01 00:45:49.000000', 'consum', 0.0222, 'lps'),
	(378362, 102, '2015-02-01 00:45:50.000000', 'consum', 0.0226, 'lps'),
	(378363, 102, '2015-02-01 00:45:51.000000', 'consum', 0.0232, 'lps'),
	(378364, 102, '2015-02-01 00:45:52.000000', 'consum', 0.0225, 'lps'),
	(378365, 102, '2015-02-01 00:45:53.000000', 'consum', 0.0222, 'lps'),
	(378366, 102, '2015-02-01 00:45:54.000000', 'consum', 0.0222, 'lps'),
	(378367, 102, '2015-02-01 00:45:55.000000', 'consum', 0.0213, 'lps'),
	(378368, 102, '2015-02-01 00:45:56.000000', 'consum', 0.0212, 'lps'),
	(378369, 102, '2015-02-01 00:45:57.000000', 'consum', 0.0211, 'lps'),
	(378370, 102, '2015-02-01 00:45:58.000000', 'consum', 0.0232, 'lps'),
	(378371, 102, '2015-02-01 00:45:59.000000', 'consum', 0.0227, 'lps'),
	(378372, 102, '2015-02-01 00:46:00.000000', 'consum', 0.0231, 'lps'),
	(378373, 102, '2015-02-01 00:46:01.000000', 'consum', 0.0217, 'lps'),
	(378374, 102, '2015-02-01 00:46:02.000000', 'consum', 0.0229, 'lps'),
	(378375, 102, '2015-02-01 00:46:03.000000', 'consum', 0.0215, 'lps'),
	(378376, 102, '2015-02-01 00:46:04.000000', 'consum', 0.0226, 'lps'),
	(378377, 102, '2015-02-01 00:46:05.000000', 'consum', 0.0227, 'lps'),
	(378378, 102, '2015-02-01 00:46:06.000000', 'consum', 0.0226, 'lps'),
	(378379, 102, '2015-02-01 00:46:07.000000', 'consum', 0.0216, 'lps'),
	(378380, 102, '2015-02-01 00:46:08.000000', 'consum', 0.0215, 'lps'),
	(378381, 102, '2015-02-01 00:46:09.000000', 'consum', 0.0220, 'lps'),
	(378382, 102, '2015-02-01 00:46:10.000000', 'consum', 0.0221, 'lps'),
	(378383, 102, '2015-02-01 00:46:11.000000', 'consum', 0.0212, 'lps'),
	(378384, 102, '2015-02-01 00:46:12.000000', 'consum', 0.0213, 'lps'),
	(378385, 102, '2015-02-01 00:46:13.000000', 'consum', 0.0217, 'lps'),
	(378386, 102, '2015-02-01 00:46:14.000000', 'consum', 0.0214, 'lps'),
	(378387, 102, '2015-02-01 00:46:15.000000', 'consum', 0.0232, 'lps'),
	(378388, 102, '2015-02-01 00:46:16.000000', 'consum', 0.0218, 'lps'),
	(378389, 102, '2015-02-01 00:46:17.000000', 'consum', 0.0228, 'lps'),
	(378390, 102, '2015-02-01 00:46:18.000000', 'consum', 0.0230, 'lps'),
	(378391, 102, '2015-02-01 00:46:19.000000', 'consum', 0.0213, 'lps'),
	(378392, 102, '2015-02-01 00:46:20.000000', 'consum', 0.0232, 'lps'),
	(378393, 102, '2015-02-01 00:46:21.000000', 'consum', 0.0220, 'lps'),
	(378394, 102, '2015-02-01 00:46:22.000000', 'consum', 0.0218, 'lps'),
	(378395, 102, '2015-02-01 00:46:23.000000', 'consum', 0.0219, 'lps'),
	(378396, 102, '2015-02-01 00:46:24.000000', 'consum', 0.0210, 'lps'),
	(378397, 102, '2015-02-01 00:46:25.000000', 'consum', 0.0227, 'lps'),
	(378398, 102, '2015-02-01 00:46:26.000000', 'consum', 0.0229, 'lps'),
	(378399, 102, '2015-02-01 00:46:27.000000', 'consum', 0.0230, 'lps'),
	(378400, 102, '2015-02-01 00:46:28.000000', 'consum', 0.0231, 'lps'),
	(378401, 102, '2015-02-01 00:46:29.000000', 'consum', 0.0210, 'lps'),
	(378402, 102, '2015-02-01 00:46:30.000000', 'consum', 0.0216, 'lps'),
	(378403, 102, '2015-02-01 00:46:31.000000', 'consum', 0.0217, 'lps'),
	(378404, 102, '2015-02-01 00:46:32.000000', 'consum', 0.0229, 'lps'),
	(378405, 102, '2015-02-01 00:46:33.000000', 'consum', 0.0215, 'lps'),
	(378406, 102, '2015-02-01 00:46:34.000000', 'consum', 0.0225, 'lps'),
	(378407, 102, '2015-02-01 00:46:35.000000', 'consum', 0.0225, 'lps'),
	(378408, 102, '2015-02-01 00:46:36.000000', 'consum', 0.0215, 'lps'),
	(378409, 102, '2015-02-01 00:46:37.000000', 'consum', 0.0215, 'lps'),
	(378410, 102, '2015-02-01 00:46:38.000000', 'consum', 0.0219, 'lps'),
	(378411, 102, '2015-02-01 00:46:39.000000', 'consum', 0.0219, 'lps'),
	(378412, 102, '2015-02-01 00:46:40.000000', 'consum', 0.0226, 'lps'),
	(378413, 102, '2015-02-01 00:46:41.000000', 'consum', 0.0220, 'lps'),
	(378414, 102, '2015-02-01 00:46:42.000000', 'consum', 0.0210, 'lps'),
	(378415, 102, '2015-02-01 00:46:43.000000', 'consum', 0.0226, 'lps'),
	(378416, 102, '2015-02-01 00:46:44.000000', 'consum', 0.0225, 'lps'),
	(378417, 102, '2015-02-01 00:46:45.000000', 'consum', 0.0212, 'lps'),
	(378418, 102, '2015-02-01 00:46:46.000000', 'consum', 0.0222, 'lps'),
	(378419, 102, '2015-02-01 00:46:47.000000', 'consum', 0.0220, 'lps'),
	(378420, 102, '2015-02-01 00:46:48.000000', 'consum', 0.0224, 'lps'),
	(378421, 102, '2015-02-01 00:46:49.000000', 'consum', 0.0227, 'lps'),
	(378422, 102, '2015-02-01 00:46:50.000000', 'consum', 0.0230, 'lps'),
	(378423, 102, '2015-02-01 00:46:51.000000', 'consum', 0.0216, 'lps'),
	(378424, 102, '2015-02-01 00:46:52.000000', 'consum', 0.0225, 'lps'),
	(378425, 102, '2015-02-01 00:46:53.000000', 'consum', 0.0222, 'lps'),
	(378426, 102, '2015-02-01 00:46:54.000000', 'consum', 0.0225, 'lps'),
	(378427, 102, '2015-02-01 00:46:55.000000', 'consum', 0.0227, 'lps'),
	(378428, 102, '2015-02-01 00:46:56.000000', 'consum', 0.0228, 'lps'),
	(378429, 102, '2015-02-01 00:46:57.000000', 'consum', 0.0225, 'lps'),
	(378430, 102, '2015-02-01 00:46:58.000000', 'consum', 0.0210, 'lps'),
	(378431, 102, '2015-02-01 00:46:59.000000', 'consum', 0.0211, 'lps'),
	(378432, 102, '2015-02-01 00:47:00.000000', 'consum', 0.0214, 'lps'),
	(378433, 102, '2015-02-01 00:47:01.000000', 'consum', 0.0231, 'lps'),
	(378434, 102, '2015-02-01 00:47:02.000000', 'consum', 0.0231, 'lps'),
	(378435, 102, '2015-02-01 00:47:03.000000', 'consum', 0.0231, 'lps'),
	(378436, 102, '2015-02-01 00:47:04.000000', 'consum', 0.0231, 'lps'),
	(378437, 102, '2015-02-01 00:47:05.000000', 'consum', 0.0227, 'lps'),
	(378438, 102, '2015-02-01 00:47:06.000000', 'consum', 0.0212, 'lps'),
	(378439, 102, '2015-02-01 00:47:07.000000', 'consum', 0.0215, 'lps'),
	(378440, 102, '2015-02-01 00:47:08.000000', 'consum', 0.0231, 'lps'),
	(378441, 102, '2015-02-01 00:47:09.000000', 'consum', 0.0230, 'lps'),
	(378442, 102, '2015-02-01 00:47:10.000000', 'consum', 0.0225, 'lps'),
	(378443, 102, '2015-02-01 00:47:11.000000', 'consum', 0.0225, 'lps'),
	(378444, 102, '2015-02-01 00:47:12.000000', 'consum', 0.0218, 'lps'),
	(378445, 102, '2015-02-01 00:47:13.000000', 'consum', 0.0227, 'lps'),
	(378446, 102, '2015-02-01 00:47:14.000000', 'consum', 0.0225, 'lps'),
	(378447, 102, '2015-02-01 00:47:15.000000', 'consum', 0.0212, 'lps'),
	(378448, 102, '2015-02-01 00:47:16.000000', 'consum', 0.0220, 'lps'),
	(378449, 102, '2015-02-01 00:47:17.000000', 'consum', 0.0210, 'lps'),
	(378450, 102, '2015-02-01 00:47:18.000000', 'consum', 0.0227, 'lps'),
	(378451, 102, '2015-02-01 00:47:19.000000', 'consum', 0.0228, 'lps'),
	(378452, 102, '2015-02-01 00:47:20.000000', 'consum', 0.0225, 'lps'),
	(378453, 102, '2015-02-01 00:47:21.000000', 'consum', 0.0231, 'lps'),
	(378454, 102, '2015-02-01 00:47:22.000000', 'consum', 0.0226, 'lps'),
	(378455, 102, '2015-02-01 00:47:23.000000', 'consum', 0.0225, 'lps'),
	(378456, 102, '2015-02-01 00:47:24.000000', 'consum', 0.0214, 'lps'),
	(378457, 102, '2015-02-01 00:47:25.000000', 'consum', 0.0212, 'lps'),
	(378458, 102, '2015-02-01 00:47:26.000000', 'consum', 0.0228, 'lps'),
	(378459, 102, '2015-02-01 00:47:27.000000', 'consum', 0.0229, 'lps'),
	(378460, 102, '2015-02-01 00:47:28.000000', 'consum', 0.0225, 'lps'),
	(378461, 102, '2015-02-01 00:47:29.000000', 'consum', 0.0231, 'lps'),
	(378462, 102, '2015-02-01 00:47:30.000000', 'consum', 0.0224, 'lps'),
	(378463, 102, '2015-02-01 00:47:31.000000', 'consum', 0.0219, 'lps'),
	(378464, 102, '2015-02-01 00:47:32.000000', 'consum', 0.0214, 'lps'),
	(378465, 102, '2015-02-01 00:47:33.000000', 'consum', 0.0226, 'lps'),
	(378466, 102, '2015-02-01 00:47:34.000000', 'consum', 0.0231, 'lps'),
	(378467, 102, '2015-02-01 00:47:35.000000', 'consum', 0.0221, 'lps'),
	(378468, 102, '2015-02-01 00:47:36.000000', 'consum', 0.0227, 'lps'),
	(378469, 102, '2015-02-01 00:47:37.000000', 'consum', 0.0217, 'lps'),
	(378470, 102, '2015-02-01 00:47:38.000000', 'consum', 0.0219, 'lps'),
	(378471, 102, '2015-02-01 00:47:39.000000', 'consum', 0.0210, 'lps'),
	(378472, 102, '2015-02-01 00:47:40.000000', 'consum', 0.0227, 'lps'),
	(378473, 102, '2015-02-01 00:47:41.000000', 'consum', 0.0230, 'lps'),
	(378474, 102, '2015-02-01 00:47:42.000000', 'consum', 0.0213, 'lps'),
	(378475, 102, '2015-02-01 00:47:43.000000', 'consum', 0.0212, 'lps'),
	(378476, 102, '2015-02-01 00:47:44.000000', 'consum', 0.0210, 'lps'),
	(378477, 102, '2015-02-01 00:47:45.000000', 'consum', 0.0227, 'lps'),
	(378478, 102, '2015-02-01 00:47:46.000000', 'consum', 0.0229, 'lps'),
	(378479, 102, '2015-02-01 00:47:47.000000', 'consum', 0.0231, 'lps'),
	(378480, 102, '2015-02-01 00:47:48.000000', 'consum', 0.0211, 'lps'),
	(378481, 102, '2015-02-01 00:47:49.000000', 'consum', 0.0220, 'lps'),
	(378482, 102, '2015-02-01 00:47:50.000000', 'consum', 0.0214, 'lps'),
	(378483, 102, '2015-02-01 00:47:51.000000', 'consum', 0.0224, 'lps'),
	(378484, 102, '2015-02-01 00:47:52.000000', 'consum', 0.0220, 'lps'),
	(378485, 102, '2015-02-01 00:47:53.000000', 'consum', 0.0221, 'lps'),
	(378486, 102, '2015-02-01 00:47:54.000000', 'consum', 0.0212, 'lps'),
	(378487, 102, '2015-02-01 00:47:55.000000', 'consum', 0.0211, 'lps'),
	(378488, 102, '2015-02-01 00:47:56.000000', 'consum', 0.0232, 'lps'),
	(378489, 102, '2015-02-01 00:47:57.000000', 'consum', 0.0227, 'lps'),
	(378490, 102, '2015-02-01 00:47:58.000000', 'consum', 0.0230, 'lps'),
	(378491, 102, '2015-02-01 00:47:59.000000', 'consum', 0.0214, 'lps'),
	(378492, 102, '2015-02-01 00:48:00.000000', 'consum', 0.0216, 'lps'),
	(378493, 102, '2015-02-01 00:48:01.000000', 'consum', 0.0228, 'lps'),
	(378494, 102, '2015-02-01 00:48:02.000000', 'consum', 0.0214, 'lps'),
	(378495, 102, '2015-02-01 00:48:03.000000', 'consum', 0.0221, 'lps'),
	(378496, 102, '2015-02-01 00:48:04.000000', 'consum', 0.0230, 'lps'),
	(378497, 102, '2015-02-01 00:48:05.000000', 'consum', 0.0231, 'lps'),
	(378498, 102, '2015-02-01 00:48:06.000000', 'consum', 0.0211, 'lps'),
	(378499, 102, '2015-02-01 00:48:07.000000', 'consum', 0.0223, 'lps'),
	(378500, 102, '2015-02-01 00:48:08.000000', 'consum', 0.0225, 'lps'),
	(378501, 102, '2015-02-01 00:48:09.000000', 'consum', 0.0223, 'lps'),
	(378502, 102, '2015-02-01 00:48:10.000000', 'consum', 0.0231, 'lps'),
	(378503, 102, '2015-02-01 00:48:11.000000', 'consum', 0.0232, 'lps'),
	(378504, 102, '2015-02-01 00:48:12.000000', 'consum', 0.0212, 'lps'),
	(378505, 102, '2015-02-01 00:48:13.000000', 'consum', 0.0224, 'lps'),
	(378506, 102, '2015-02-01 00:48:14.000000', 'consum', 0.0227, 'lps'),
	(378507, 102, '2015-02-01 00:48:15.000000', 'consum', 0.0232, 'lps'),
	(378508, 102, '2015-02-01 00:48:16.000000', 'consum', 0.0221, 'lps'),
	(378509, 102, '2015-02-01 00:48:17.000000', 'consum', 0.0223, 'lps'),
	(378510, 102, '2015-02-01 00:48:18.000000', 'consum', 0.0219, 'lps'),
	(378511, 102, '2015-02-01 00:48:19.000000', 'consum', 0.0217, 'lps'),
	(378512, 102, '2015-02-01 00:48:20.000000', 'consum', 0.0221, 'lps'),
	(378513, 102, '2015-02-01 00:48:21.000000', 'consum', 0.0218, 'lps'),
	(378514, 102, '2015-02-01 00:48:22.000000', 'consum', 0.0220, 'lps'),
	(378515, 102, '2015-02-01 00:48:23.000000', 'consum', 0.0213, 'lps'),
	(378516, 102, '2015-02-01 00:48:24.000000', 'consum', 0.0216, 'lps'),
	(378517, 102, '2015-02-01 00:48:25.000000', 'consum', 0.0212, 'lps'),
	(378518, 102, '2015-02-01 00:48:26.000000', 'consum', 0.0223, 'lps'),
	(378519, 102, '2015-02-01 00:48:27.000000', 'consum', 0.0222, 'lps'),
	(378520, 102, '2015-02-01 00:48:28.000000', 'consum', 0.0211, 'lps'),
	(378521, 102, '2015-02-01 00:48:29.000000', 'consum', 0.0225, 'lps'),
	(378522, 102, '2015-02-01 00:48:30.000000', 'consum', 0.0215, 'lps'),
	(378523, 102, '2015-02-01 00:48:31.000000', 'consum', 0.0213, 'lps'),
	(378524, 102, '2015-02-01 00:48:32.000000', 'consum', 0.0231, 'lps'),
	(378525, 102, '2015-02-01 00:48:33.000000', 'consum', 0.0216, 'lps'),
	(378526, 102, '2015-02-01 00:48:34.000000', 'consum', 0.0224, 'lps'),
	(378527, 102, '2015-02-01 00:48:35.000000', 'consum', 0.0217, 'lps'),
	(378528, 102, '2015-02-01 00:48:36.000000', 'consum', 0.0224, 'lps'),
	(378529, 102, '2015-02-01 00:48:37.000000', 'consum', 0.0214, 'lps'),
	(378530, 102, '2015-02-01 00:48:38.000000', 'consum', 0.0211, 'lps'),
	(378531, 102, '2015-02-01 00:48:39.000000', 'consum', 0.0228, 'lps'),
	(378532, 102, '2015-02-01 00:48:40.000000', 'consum', 0.0228, 'lps'),
	(378533, 102, '2015-02-01 00:48:41.000000', 'consum', 0.0223, 'lps'),
	(378534, 102, '2015-02-01 00:48:42.000000', 'consum', 0.0221, 'lps'),
	(378535, 102, '2015-02-01 00:48:43.000000', 'consum', 0.0228, 'lps'),
	(378536, 102, '2015-02-01 00:48:44.000000', 'consum', 0.0222, 'lps'),
	(378537, 102, '2015-02-01 00:48:45.000000', 'consum', 0.0217, 'lps'),
	(378538, 102, '2015-02-01 00:48:46.000000', 'consum', 0.0231, 'lps'),
	(378539, 102, '2015-02-01 00:48:47.000000', 'consum', 0.0225, 'lps'),
	(378540, 102, '2015-02-01 00:48:48.000000', 'consum', 0.0223, 'lps'),
	(378541, 102, '2015-02-01 00:48:49.000000', 'consum', 0.0230, 'lps'),
	(378542, 102, '2015-02-01 00:48:50.000000', 'consum', 0.0227, 'lps'),
	(378543, 102, '2015-02-01 00:48:51.000000', 'consum', 0.0212, 'lps'),
	(378544, 102, '2015-02-01 00:48:52.000000', 'consum', 0.0213, 'lps'),
	(378545, 102, '2015-02-01 00:48:53.000000', 'consum', 0.0223, 'lps'),
	(378546, 102, '2015-02-01 00:48:54.000000', 'consum', 0.0219, 'lps'),
	(378547, 102, '2015-02-01 00:48:55.000000', 'consum', 0.0218, 'lps'),
	(378548, 102, '2015-02-01 00:48:56.000000', 'consum', 0.0222, 'lps'),
	(378549, 102, '2015-02-01 00:48:57.000000', 'consum', 0.0222, 'lps'),
	(378550, 102, '2015-02-01 00:48:58.000000', 'consum', 0.0215, 'lps'),
	(378551, 102, '2015-02-01 00:48:59.000000', 'consum', 0.0220, 'lps'),
	(378552, 102, '2015-02-01 00:49:00.000000', 'consum', 0.0223, 'lps'),
	(378553, 102, '2015-02-01 00:49:01.000000', 'consum', 0.0224, 'lps'),
	(378554, 102, '2015-02-01 00:49:02.000000', 'consum', 0.0216, 'lps'),
	(378555, 102, '2015-02-01 00:49:03.000000', 'consum', 0.0225, 'lps'),
	(378556, 102, '2015-02-01 00:49:04.000000', 'consum', 0.0218, 'lps'),
	(378557, 102, '2015-02-01 00:49:05.000000', 'consum', 0.0230, 'lps'),
	(378558, 102, '2015-02-01 00:49:06.000000', 'consum', 0.0216, 'lps'),
	(378559, 102, '2015-02-01 00:49:07.000000', 'consum', 0.0228, 'lps'),
	(378560, 102, '2015-02-01 00:49:08.000000', 'consum', 0.0214, 'lps'),
	(378561, 102, '2015-02-01 00:49:09.000000', 'consum', 0.0222, 'lps'),
	(378562, 102, '2015-02-01 00:49:10.000000', 'consum', 0.0211, 'lps'),
	(378563, 102, '2015-02-01 00:49:11.000000', 'consum', 0.0227, 'lps'),
	(378564, 102, '2015-02-01 00:49:12.000000', 'consum', 0.0222, 'lps'),
	(378565, 102, '2015-02-01 00:49:13.000000', 'consum', 0.0220, 'lps'),
	(378566, 102, '2015-02-01 00:49:14.000000', 'consum', 0.0224, 'lps'),
	(378567, 102, '2015-02-01 00:49:15.000000', 'consum', 0.0227, 'lps'),
	(378568, 102, '2015-02-01 00:49:16.000000', 'consum', 0.0229, 'lps'),
	(378569, 102, '2015-02-01 00:49:17.000000', 'consum', 0.0212, 'lps'),
	(378570, 102, '2015-02-01 00:49:18.000000', 'consum', 0.0231, 'lps'),
	(378571, 102, '2015-02-01 00:49:19.000000', 'consum', 0.0216, 'lps'),
	(378572, 102, '2015-02-01 00:49:20.000000', 'consum', 0.0223, 'lps'),
	(378573, 102, '2015-02-01 00:49:21.000000', 'consum', 0.0214, 'lps'),
	(378574, 102, '2015-02-01 00:49:22.000000', 'consum', 0.0214, 'lps'),
	(378575, 102, '2015-02-01 00:49:23.000000', 'consum', 0.0219, 'lps'),
	(378576, 102, '2015-02-01 00:49:24.000000', 'consum', 0.0219, 'lps'),
	(378577, 102, '2015-02-01 00:49:25.000000', 'consum', 0.0228, 'lps'),
	(378578, 102, '2015-02-01 00:49:26.000000', 'consum', 0.0229, 'lps'),
	(378579, 102, '2015-02-01 00:49:27.000000', 'consum', 0.0228, 'lps'),
	(378580, 102, '2015-02-01 00:49:28.000000', 'consum', 0.0223, 'lps'),
	(378581, 102, '2015-02-01 00:49:29.000000', 'consum', 0.0218, 'lps'),
	(378582, 102, '2015-02-01 00:49:30.000000', 'consum', 0.0212, 'lps'),
	(378583, 102, '2015-02-01 00:49:31.000000', 'consum', 0.0221, 'lps'),
	(378584, 102, '2015-02-01 00:49:32.000000', 'consum', 0.0212, 'lps'),
	(378585, 102, '2015-02-01 00:49:33.000000', 'consum', 0.0211, 'lps'),
	(378586, 102, '2015-02-01 00:49:34.000000', 'consum', 0.0232, 'lps'),
	(378587, 102, '2015-02-01 00:49:35.000000', 'consum', 0.0225, 'lps'),
	(378588, 102, '2015-02-01 00:49:36.000000', 'consum', 0.0222, 'lps'),
	(378589, 102, '2015-02-01 00:49:37.000000', 'consum', 0.0225, 'lps'),
	(378590, 102, '2015-02-01 00:49:38.000000', 'consum', 0.0224, 'lps'),
	(378591, 102, '2015-02-01 00:49:39.000000', 'consum', 0.0215, 'lps'),
	(378592, 102, '2015-02-01 00:49:40.000000', 'consum', 0.0215, 'lps'),
	(378593, 102, '2015-02-01 00:49:41.000000', 'consum', 0.0220, 'lps'),
	(378594, 102, '2015-02-01 00:49:42.000000', 'consum', 0.0224, 'lps'),
	(378595, 102, '2015-02-01 00:49:43.000000', 'consum', 0.0227, 'lps'),
	(378596, 102, '2015-02-01 00:49:44.000000', 'consum', 0.0232, 'lps'),
	(378597, 102, '2015-02-01 00:49:45.000000', 'consum', 0.0223, 'lps'),
	(378598, 102, '2015-02-01 00:49:46.000000', 'consum', 0.0210, 'lps'),
	(378599, 102, '2015-02-01 00:49:47.000000', 'consum', 0.0216, 'lps'),
	(378600, 102, '2015-02-01 00:49:48.000000', 'consum', 0.0219, 'lps'),
	(378601, 102, '2015-02-01 00:49:49.000000', 'consum', 0.0215, 'lps'),
	(378602, 102, '2015-02-01 00:49:50.000000', 'consum', 0.0231, 'lps'),
	(378603, 102, '2015-02-01 00:49:51.000000', 'consum', 0.0231, 'lps'),
	(378604, 102, '2015-02-01 00:49:52.000000', 'consum', 0.0231, 'lps'),
	(378605, 102, '2015-02-01 00:49:53.000000', 'consum', 0.0229, 'lps'),
	(378606, 102, '2015-02-01 00:49:54.000000', 'consum', 0.0221, 'lps'),
	(378607, 102, '2015-02-01 00:49:55.000000', 'consum', 0.0231, 'lps'),
	(378608, 102, '2015-02-01 00:49:56.000000', 'consum', 0.0212, 'lps'),
	(378609, 102, '2015-02-01 00:49:57.000000', 'consum', 0.0228, 'lps'),
	(378610, 102, '2015-02-01 00:49:58.000000', 'consum', 0.0227, 'lps'),
	(378611, 102, '2015-02-01 00:49:59.000000', 'consum', 0.0215, 'lps'),
	(378612, 102, '2015-02-01 00:50:00.000000', 'consum', 0.0210, 'lps'),
	(378613, 102, '2015-02-01 00:50:01.000000', 'consum', 0.0216, 'lps'),
	(378614, 102, '2015-02-01 00:50:02.000000', 'consum', 0.0218, 'lps'),
	(378615, 102, '2015-02-01 00:50:03.000000', 'consum', 0.0210, 'lps'),
	(378616, 102, '2015-02-01 00:50:04.000000', 'consum', 0.0212, 'lps'),
	(378617, 102, '2015-02-01 00:50:05.000000', 'consum', 0.0217, 'lps'),
	(378618, 102, '2015-02-01 00:50:06.000000', 'consum', 0.0219, 'lps'),
	(378619, 102, '2015-02-01 00:50:07.000000', 'consum', 0.0232, 'lps'),
	(378620, 102, '2015-02-01 00:50:08.000000', 'consum', 0.0227, 'lps'),
	(378621, 102, '2015-02-01 00:50:09.000000', 'consum', 0.0227, 'lps'),
	(378622, 102, '2015-02-01 00:50:10.000000', 'consum', 0.0224, 'lps'),
	(378623, 102, '2015-02-01 00:50:11.000000', 'consum', 0.0230, 'lps'),
	(378624, 102, '2015-02-01 00:50:12.000000', 'consum', 0.0220, 'lps'),
	(378625, 102, '2015-02-01 00:50:13.000000', 'consum', 0.0225, 'lps'),
	(378626, 102, '2015-02-01 00:50:14.000000', 'consum', 0.0211, 'lps'),
	(378627, 102, '2015-02-01 00:50:15.000000', 'consum', 0.0214, 'lps'),
	(378628, 102, '2015-02-01 00:50:16.000000', 'consum', 0.0230, 'lps'),
	(378629, 102, '2015-02-01 00:50:17.000000', 'consum', 0.0226, 'lps'),
	(378630, 102, '2015-02-01 00:50:18.000000', 'consum', 0.0210, 'lps'),
	(378631, 102, '2015-02-01 00:50:19.000000', 'consum', 0.0232, 'lps'),
	(378632, 102, '2015-02-01 00:50:20.000000', 'consum', 0.0229, 'lps'),
	(378633, 102, '2015-02-01 00:50:21.000000', 'consum', 0.0215, 'lps'),
	(378634, 102, '2015-02-01 00:50:22.000000', 'consum', 0.0224, 'lps'),
	(378635, 102, '2015-02-01 00:50:23.000000', 'consum', 0.0221, 'lps'),
	(378636, 102, '2015-02-01 00:50:24.000000', 'consum', 0.0223, 'lps'),
	(378637, 102, '2015-02-01 00:50:25.000000', 'consum', 0.0218, 'lps'),
	(378638, 102, '2015-02-01 00:50:26.000000', 'consum', 0.0214, 'lps'),
	(378639, 102, '2015-02-01 00:50:27.000000', 'consum', 0.0227, 'lps'),
	(378640, 102, '2015-02-01 00:50:28.000000', 'consum', 0.0214, 'lps'),
	(378641, 102, '2015-02-01 00:50:29.000000', 'consum', 0.0229, 'lps'),
	(378642, 102, '2015-02-01 00:50:30.000000', 'consum', 0.0221, 'lps'),
	(378643, 102, '2015-02-01 00:50:31.000000', 'consum', 0.0210, 'lps'),
	(378644, 102, '2015-02-01 00:50:32.000000', 'consum', 0.0224, 'lps'),
	(378645, 102, '2015-02-01 00:50:33.000000', 'consum', 0.0212, 'lps'),
	(378646, 102, '2015-02-01 00:50:34.000000', 'consum', 0.0224, 'lps'),
	(378647, 102, '2015-02-01 00:50:35.000000', 'consum', 0.0229, 'lps'),
	(378648, 102, '2015-02-01 00:50:36.000000', 'consum', 0.0218, 'lps'),
	(378649, 102, '2015-02-01 00:50:37.000000', 'consum', 0.0216, 'lps'),
	(378650, 102, '2015-02-01 00:50:38.000000', 'consum', 0.0215, 'lps'),
	(378651, 102, '2015-02-01 00:50:39.000000', 'consum', 0.0220, 'lps'),
	(378652, 102, '2015-02-01 00:50:40.000000', 'consum', 0.0221, 'lps'),
	(378653, 102, '2015-02-01 00:50:41.000000', 'consum', 0.0214, 'lps'),
	(378654, 102, '2015-02-01 00:50:42.000000', 'consum', 0.0219, 'lps'),
	(378655, 102, '2015-02-01 00:50:43.000000', 'consum', 0.0221, 'lps'),
	(378656, 102, '2015-02-01 00:50:44.000000', 'consum', 0.0217, 'lps'),
	(378657, 102, '2015-02-01 00:50:45.000000', 'consum', 0.0210, 'lps'),
	(378658, 102, '2015-02-01 00:50:46.000000', 'consum', 0.0214, 'lps'),
	(378659, 102, '2015-02-01 00:50:47.000000', 'consum', 0.0230, 'lps'),
	(378660, 102, '2015-02-01 00:50:48.000000', 'consum', 0.0228, 'lps'),
	(378661, 102, '2015-02-01 00:50:49.000000', 'consum', 0.0221, 'lps'),
	(378662, 102, '2015-02-01 00:50:50.000000', 'consum', 0.0232, 'lps'),
	(378663, 102, '2015-02-01 00:50:51.000000', 'consum', 0.0217, 'lps'),
	(378664, 102, '2015-02-01 00:50:52.000000', 'consum', 0.0228, 'lps'),
	(378665, 102, '2015-02-01 00:50:53.000000', 'consum', 0.0211, 'lps'),
	(378666, 102, '2015-02-01 00:50:54.000000', 'consum', 0.0228, 'lps'),
	(378667, 102, '2015-02-01 00:50:55.000000', 'consum', 0.0229, 'lps'),
	(378668, 102, '2015-02-01 00:50:56.000000', 'consum', 0.0230, 'lps'),
	(378669, 102, '2015-02-01 00:50:57.000000', 'consum', 0.0231, 'lps'),
	(378670, 102, '2015-02-01 00:50:58.000000', 'consum', 0.0232, 'lps'),
	(378671, 102, '2015-02-01 00:50:59.000000', 'consum', 0.0210, 'lps'),
	(378672, 102, '2015-02-01 00:51:00.000000', 'consum', 0.0215, 'lps'),
	(378673, 102, '2015-02-01 00:51:01.000000', 'consum', 0.0212, 'lps'),
	(378674, 102, '2015-02-01 00:51:02.000000', 'consum', 0.0227, 'lps'),
	(378675, 102, '2015-02-01 00:51:03.000000', 'consum', 0.0220, 'lps'),
	(378676, 102, '2015-02-01 00:51:04.000000', 'consum', 0.0211, 'lps'),
	(378677, 102, '2015-02-01 00:51:05.000000', 'consum', 0.0230, 'lps'),
	(378678, 102, '2015-02-01 00:51:06.000000', 'consum', 0.0217, 'lps'),
	(378679, 102, '2015-02-01 00:51:07.000000', 'consum', 0.0231, 'lps'),
	(378680, 102, '2015-02-01 00:51:08.000000', 'consum', 0.0224, 'lps'),
	(378681, 102, '2015-02-01 00:51:09.000000', 'consum', 0.0217, 'lps'),
	(378682, 102, '2015-02-01 00:51:10.000000', 'consum', 0.0226, 'lps'),
	(378683, 102, '2015-02-01 00:51:11.000000', 'consum', 0.0223, 'lps'),
	(378684, 102, '2015-02-01 00:51:12.000000', 'consum', 0.0229, 'lps'),
	(378685, 102, '2015-02-01 00:51:13.000000', 'consum', 0.0221, 'lps'),
	(378686, 102, '2015-02-01 00:51:14.000000', 'consum', 0.0230, 'lps'),
	(378687, 102, '2015-02-01 00:51:15.000000', 'consum', 0.0230, 'lps'),
	(378688, 102, '2015-02-01 00:51:16.000000', 'consum', 0.0229, 'lps'),
	(378689, 102, '2015-02-01 00:51:17.000000', 'consum', 0.0224, 'lps'),
	(378690, 102, '2015-02-01 00:51:18.000000', 'consum', 0.0221, 'lps'),
	(378691, 102, '2015-02-01 00:51:19.000000', 'consum', 0.0223, 'lps'),
	(378692, 102, '2015-02-01 00:51:20.000000', 'consum', 0.0222, 'lps'),
	(378693, 102, '2015-02-01 00:51:21.000000', 'consum', 0.0232, 'lps'),
	(378694, 102, '2015-02-01 00:51:22.000000', 'consum', 0.0216, 'lps'),
	(378695, 123, '2015-02-01 00:00:00.000000', 'consum', 0.0221, 'lps'),
	(378696, 123, '2015-02-01 00:00:01.000000', 'consum', 0.0222, 'lps'),
	(378697, 123, '2015-02-01 00:00:02.000000', 'consum', 0.0223, 'lps'),
	(378698, 123, '2015-02-01 00:00:03.000000', 'consum', 0.0220, 'lps'),
	(378699, 123, '2015-02-01 00:00:04.000000', 'consum', 0.0223, 'lps'),
	(378700, 123, '2015-02-01 00:00:05.000000', 'consum', 0.0211, 'lps'),
	(378701, 123, '2015-02-01 00:00:06.000000', 'consum', 0.0212, 'lps'),
	(378702, 123, '2015-02-01 00:00:07.000000', 'consum', 0.0218, 'lps'),
	(378703, 123, '2015-02-01 00:00:08.000000', 'consum', 0.0225, 'lps'),
	(378704, 123, '2015-02-01 00:00:09.000000', 'consum', 0.0210, 'lps'),
	(378705, 123, '2015-02-01 00:00:10.000000', 'consum', 0.0216, 'lps'),
	(378706, 123, '2015-02-01 00:00:11.000000', 'consum', 0.0224, 'lps'),
	(378707, 123, '2015-02-01 00:00:12.000000', 'consum', 0.0212, 'lps'),
	(378708, 123, '2015-02-01 00:00:13.000000', 'consum', 0.0212, 'lps'),
	(378709, 123, '2015-02-01 00:00:14.000000', 'consum', 0.0213, 'lps'),
	(378710, 123, '2015-02-01 00:00:15.000000', 'consum', 0.0220, 'lps'),
	(378711, 123, '2015-02-01 00:00:16.000000', 'consum', 0.0217, 'lps'),
	(378712, 123, '2015-02-01 00:00:17.000000', 'consum', 0.0216, 'lps'),
	(378713, 123, '2015-02-01 00:00:18.000000', 'consum', 0.0221, 'lps'),
	(378714, 123, '2015-02-01 00:00:19.000000', 'consum', 0.0211, 'lps'),
	(378715, 123, '2015-02-01 00:00:20.000000', 'consum', 0.0218, 'lps'),
	(378716, 123, '2015-02-01 00:00:21.000000', 'consum', 0.0215, 'lps'),
	(378717, 123, '2015-02-01 00:00:22.000000', 'consum', 0.0226, 'lps'),
	(378718, 123, '2015-02-01 00:00:23.000000', 'consum', 0.0226, 'lps'),
	(378719, 123, '2015-02-01 00:00:24.000000', 'consum', 0.0210, 'lps'),
	(378720, 123, '2015-02-01 00:00:25.000000', 'consum', 0.0211, 'lps'),
	(378721, 123, '2015-02-01 00:00:26.000000', 'consum', 0.0217, 'lps'),
	(378722, 123, '2015-02-01 00:00:27.000000', 'consum', 0.0224, 'lps'),
	(378723, 123, '2015-02-01 00:00:28.000000', 'consum', 0.0210, 'lps'),
	(378724, 123, '2015-02-01 00:00:29.000000', 'consum', 0.0217, 'lps'),
	(378725, 123, '2015-02-01 00:00:30.000000', 'consum', 0.0213, 'lps'),
	(378726, 123, '2015-02-01 00:00:31.000000', 'consum', 0.0221, 'lps'),
	(378727, 123, '2015-02-01 00:00:32.000000', 'consum', 0.0223, 'lps'),
	(378728, 123, '2015-02-01 00:00:33.000000', 'consum', 0.0226, 'lps'),
	(378729, 123, '2015-02-01 00:00:34.000000', 'consum', 0.0218, 'lps'),
	(378730, 123, '2015-02-01 00:00:35.000000', 'consum', 0.0219, 'lps'),
	(378731, 123, '2015-02-01 00:00:36.000000', 'consum', 0.0214, 'lps'),
	(378732, 123, '2015-02-01 00:00:37.000000', 'consum', 0.0219, 'lps'),
	(378733, 123, '2015-02-01 00:00:38.000000', 'consum', 0.0210, 'lps'),
	(378734, 123, '2015-02-01 00:00:39.000000', 'consum', 0.0218, 'lps'),
	(378735, 123, '2015-02-01 00:00:40.000000', 'consum', 0.0216, 'lps'),
	(378736, 123, '2015-02-01 00:00:41.000000', 'consum', 0.0217, 'lps'),
	(378737, 123, '2015-02-01 00:00:42.000000', 'consum', 0.0210, 'lps'),
	(378738, 123, '2015-02-01 00:00:43.000000', 'consum', 0.0226, 'lps'),
	(378739, 123, '2015-02-01 00:00:44.000000', 'consum', 0.0221, 'lps'),
	(378740, 123, '2015-02-01 00:00:45.000000', 'consum', 0.0216, 'lps'),
	(378741, 123, '2015-02-01 00:00:46.000000', 'consum', 0.0225, 'lps'),
	(378742, 123, '2015-02-01 00:00:47.000000', 'consum', 0.0216, 'lps'),
	(378743, 123, '2015-02-01 00:00:48.000000', 'consum', 0.0214, 'lps'),
	(378744, 123, '2015-02-01 00:00:49.000000', 'consum', 0.0213, 'lps'),
	(378745, 123, '2015-02-01 00:00:50.000000', 'consum', 0.0214, 'lps'),
	(378746, 123, '2015-02-01 00:00:51.000000', 'consum', 0.0219, 'lps'),
	(378747, 123, '2015-02-01 00:00:52.000000', 'consum', 0.0211, 'lps'),
	(378748, 123, '2015-02-01 00:00:53.000000', 'consum', 0.0223, 'lps'),
	(378749, 123, '2015-02-01 00:00:54.000000', 'consum', 0.0222, 'lps'),
	(378750, 123, '2015-02-01 00:00:55.000000', 'consum', 0.0214, 'lps'),
	(378751, 123, '2015-02-01 00:00:56.000000', 'consum', 0.0213, 'lps'),
	(378752, 123, '2015-02-01 00:00:57.000000', 'consum', 0.0212, 'lps'),
	(378753, 123, '2015-02-01 00:00:58.000000', 'consum', 0.0212, 'lps'),
	(378754, 123, '2015-02-01 00:00:59.000000', 'consum', 0.0214, 'lps'),
	(378755, 123, '2015-02-01 00:01:00.000000', 'consum', 0.0224, 'lps'),
	(378756, 123, '2015-02-01 00:01:01.000000', 'consum', 0.0218, 'lps'),
	(378757, 123, '2015-02-01 00:01:02.000000', 'consum', 0.0210, 'lps'),
	(378758, 123, '2015-02-01 00:01:03.000000', 'consum', 0.0219, 'lps'),
	(378759, 123, '2015-02-01 00:01:04.000000', 'consum', 0.0220, 'lps'),
	(378760, 123, '2015-02-01 00:01:05.000000', 'consum', 0.0217, 'lps'),
	(378761, 123, '2015-02-01 00:01:06.000000', 'consum', 0.0216, 'lps'),
	(378762, 123, '2015-02-01 00:01:07.000000', 'consum', 0.0219, 'lps'),
	(378763, 123, '2015-02-01 00:01:08.000000', 'consum', 0.0222, 'lps'),
	(378764, 123, '2015-02-01 00:01:09.000000', 'consum', 0.0225, 'lps'),
	(378765, 123, '2015-02-01 00:01:10.000000', 'consum', 0.0217, 'lps'),
	(378766, 123, '2015-02-01 00:01:11.000000', 'consum', 0.0218, 'lps'),
	(378767, 123, '2015-02-01 00:01:12.000000', 'consum', 0.0210, 'lps'),
	(378768, 123, '2015-02-01 00:01:13.000000', 'consum', 0.0223, 'lps'),
	(378769, 123, '2015-02-01 00:01:14.000000', 'consum', 0.0223, 'lps'),
	(378770, 123, '2015-02-01 00:01:15.000000', 'consum', 0.0218, 'lps'),
	(378771, 123, '2015-02-01 00:01:16.000000', 'consum', 0.0213, 'lps'),
	(378772, 123, '2015-02-01 00:01:17.000000', 'consum', 0.0217, 'lps'),
	(378773, 123, '2015-02-01 00:01:18.000000', 'consum', 0.0219, 'lps'),
	(378774, 123, '2015-02-01 00:01:19.000000', 'consum', 0.0220, 'lps'),
	(378775, 123, '2015-02-01 00:01:20.000000', 'consum', 0.0216, 'lps'),
	(378776, 123, '2015-02-01 00:01:21.000000', 'consum', 0.0212, 'lps'),
	(378777, 123, '2015-02-01 00:01:22.000000', 'consum', 0.0219, 'lps'),
	(378778, 123, '2015-02-01 00:01:23.000000', 'consum', 0.0214, 'lps'),
	(378779, 123, '2015-02-01 00:01:24.000000', 'consum', 0.0220, 'lps'),
	(378780, 123, '2015-02-01 00:01:25.000000', 'consum', 0.0215, 'lps'),
	(378781, 123, '2015-02-01 00:01:26.000000', 'consum', 0.0221, 'lps'),
	(378782, 123, '2015-02-01 00:01:27.000000', 'consum', 0.0216, 'lps'),
	(378783, 123, '2015-02-01 00:01:28.000000', 'consum', 0.0210, 'lps'),
	(378784, 123, '2015-02-01 00:01:29.000000', 'consum', 0.0225, 'lps'),
	(378785, 123, '2015-02-01 00:01:30.000000', 'consum', 0.0217, 'lps'),
	(378786, 123, '2015-02-01 00:01:31.000000', 'consum', 0.0218, 'lps'),
	(378787, 123, '2015-02-01 00:01:32.000000', 'consum', 0.0213, 'lps'),
	(378788, 123, '2015-02-01 00:01:33.000000', 'consum', 0.0219, 'lps'),
	(378789, 123, '2015-02-01 00:01:34.000000', 'consum', 0.0213, 'lps'),
	(378790, 123, '2015-02-01 00:01:35.000000', 'consum', 0.0215, 'lps'),
	(378791, 123, '2015-02-01 00:01:36.000000', 'consum', 0.0225, 'lps'),
	(378792, 123, '2015-02-01 00:01:37.000000', 'consum', 0.0219, 'lps'),
	(378793, 123, '2015-02-01 00:01:38.000000', 'consum', 0.0210, 'lps'),
	(378794, 123, '2015-02-01 00:01:39.000000', 'consum', 0.0219, 'lps'),
	(378795, 123, '2015-02-01 00:01:40.000000', 'consum', 0.0223, 'lps'),
	(378796, 123, '2015-02-01 00:01:41.000000', 'consum', 0.0212, 'lps'),
	(378797, 123, '2015-02-01 00:01:42.000000', 'consum', 0.0218, 'lps'),
	(378798, 123, '2015-02-01 00:01:43.000000', 'consum', 0.0211, 'lps'),
	(378799, 123, '2015-02-01 00:01:44.000000', 'consum', 0.0226, 'lps'),
	(378800, 123, '2015-02-01 00:01:45.000000', 'consum', 0.0220, 'lps'),
	(378801, 123, '2015-02-01 00:01:46.000000', 'consum', 0.0213, 'lps'),
	(378802, 123, '2015-02-01 00:01:47.000000', 'consum', 0.0212, 'lps'),
	(378803, 123, '2015-02-01 00:01:48.000000', 'consum', 0.0210, 'lps'),
	(378804, 123, '2015-02-01 00:01:49.000000', 'consum', 0.0220, 'lps'),
	(378805, 123, '2015-02-01 00:01:50.000000', 'consum', 0.0212, 'lps'),
	(378806, 123, '2015-02-01 00:01:51.000000', 'consum', 0.0224, 'lps'),
	(378807, 123, '2015-02-01 00:01:52.000000', 'consum', 0.0223, 'lps'),
	(378808, 123, '2015-02-01 00:01:53.000000', 'consum', 0.0218, 'lps'),
	(378809, 123, '2015-02-01 00:01:54.000000', 'consum', 0.0211, 'lps'),
	(378810, 123, '2015-02-01 00:01:55.000000', 'consum', 0.0226, 'lps'),
	(378811, 123, '2015-02-01 00:01:56.000000', 'consum', 0.0217, 'lps'),
	(378812, 123, '2015-02-01 00:01:57.000000', 'consum', 0.0215, 'lps'),
	(378813, 123, '2015-02-01 00:01:58.000000', 'consum', 0.0216, 'lps'),
	(378814, 123, '2015-02-01 00:01:59.000000', 'consum', 0.0226, 'lps'),
	(378815, 123, '2015-02-01 00:02:00.000000', 'consum', 0.0220, 'lps'),
	(378816, 123, '2015-02-01 00:02:01.000000', 'consum', 0.0213, 'lps'),
	(378817, 123, '2015-02-01 00:02:02.000000', 'consum', 0.0211, 'lps'),
	(378818, 123, '2015-02-01 00:02:03.000000', 'consum', 0.0226, 'lps'),
	(378819, 123, '2015-02-01 00:02:04.000000', 'consum', 0.0217, 'lps'),
	(378820, 123, '2015-02-01 00:02:05.000000', 'consum', 0.0217, 'lps'),
	(378821, 123, '2015-02-01 00:02:06.000000', 'consum', 0.0223, 'lps'),
	(378822, 123, '2015-02-01 00:02:07.000000', 'consum', 0.0221, 'lps'),
	(378823, 123, '2015-02-01 00:02:08.000000', 'consum', 0.0210, 'lps'),
	(378824, 123, '2015-02-01 00:02:09.000000', 'consum', 0.0226, 'lps'),
	(378825, 123, '2015-02-01 00:02:10.000000', 'consum', 0.0224, 'lps'),
	(378826, 123, '2015-02-01 00:02:11.000000', 'consum', 0.0217, 'lps'),
	(378827, 123, '2015-02-01 00:02:12.000000', 'consum', 0.0220, 'lps'),
	(378828, 123, '2015-02-01 00:02:13.000000', 'consum', 0.0223, 'lps'),
	(378829, 123, '2015-02-01 00:02:14.000000', 'consum', 0.0226, 'lps'),
	(378830, 123, '2015-02-01 00:02:15.000000', 'consum', 0.0218, 'lps'),
	(378831, 123, '2015-02-01 00:02:16.000000', 'consum', 0.0219, 'lps'),
	(378832, 123, '2015-02-01 00:02:17.000000', 'consum', 0.0217, 'lps'),
	(378833, 123, '2015-02-01 00:02:18.000000', 'consum', 0.0218, 'lps'),
	(378834, 123, '2015-02-01 00:02:19.000000', 'consum', 0.0214, 'lps'),
	(378835, 123, '2015-02-01 00:02:20.000000', 'consum', 0.0220, 'lps'),
	(378836, 123, '2015-02-01 00:02:21.000000', 'consum', 0.0217, 'lps'),
	(378837, 123, '2015-02-01 00:02:22.000000', 'consum', 0.0215, 'lps'),
	(378838, 123, '2015-02-01 00:02:23.000000', 'consum', 0.0215, 'lps'),
	(378839, 123, '2015-02-01 00:02:24.000000', 'consum', 0.0221, 'lps'),
	(378840, 123, '2015-02-01 00:02:25.000000', 'consum', 0.0216, 'lps'),
	(378841, 123, '2015-02-01 00:02:26.000000', 'consum', 0.0225, 'lps'),
	(378842, 123, '2015-02-01 00:02:27.000000', 'consum', 0.0215, 'lps'),
	(378843, 123, '2015-02-01 00:02:28.000000', 'consum', 0.0226, 'lps'),
	(378844, 123, '2015-02-01 00:02:29.000000', 'consum', 0.0222, 'lps'),
	(378845, 123, '2015-02-01 00:02:30.000000', 'consum', 0.0225, 'lps'),
	(378846, 123, '2015-02-01 00:02:31.000000', 'consum', 0.0214, 'lps'),
	(378847, 123, '2015-02-01 00:02:32.000000', 'consum', 0.0220, 'lps'),
	(378848, 123, '2015-02-01 00:02:33.000000', 'consum', 0.0217, 'lps'),
	(378849, 123, '2015-02-01 00:02:34.000000', 'consum', 0.0212, 'lps'),
	(378850, 123, '2015-02-01 00:02:35.000000', 'consum', 0.0218, 'lps'),
	(378851, 123, '2015-02-01 00:02:36.000000', 'consum', 0.0210, 'lps'),
	(378852, 123, '2015-02-01 00:02:37.000000', 'consum', 0.0219, 'lps'),
	(378853, 123, '2015-02-01 00:02:38.000000', 'consum', 0.0223, 'lps'),
	(378854, 123, '2015-02-01 00:02:39.000000', 'consum', 0.0215, 'lps'),
	(378855, 123, '2015-02-01 00:02:40.000000', 'consum', 0.0214, 'lps'),
	(378856, 123, '2015-02-01 00:02:41.000000', 'consum', 0.0214, 'lps'),
	(378857, 123, '2015-02-01 00:02:42.000000', 'consum', 0.0219, 'lps'),
	(378858, 123, '2015-02-01 00:02:43.000000', 'consum', 0.0225, 'lps'),
	(378859, 123, '2015-02-01 00:02:44.000000', 'consum', 0.0210, 'lps'),
	(378860, 123, '2015-02-01 00:02:45.000000', 'consum', 0.0217, 'lps'),
	(378861, 123, '2015-02-01 00:02:46.000000', 'consum', 0.0211, 'lps'),
	(378862, 123, '2015-02-01 00:02:47.000000', 'consum', 0.0210, 'lps'),
	(378863, 123, '2015-02-01 00:02:48.000000', 'consum', 0.0225, 'lps'),
	(378864, 123, '2015-02-01 00:02:49.000000', 'consum', 0.0218, 'lps'),
	(378865, 123, '2015-02-01 00:02:50.000000', 'consum', 0.0222, 'lps'),
	(378866, 123, '2015-02-01 00:02:51.000000', 'consum', 0.0211, 'lps'),
	(378867, 123, '2015-02-01 00:02:52.000000', 'consum', 0.0216, 'lps'),
	(378868, 123, '2015-02-01 00:02:53.000000', 'consum', 0.0219, 'lps'),
	(378869, 123, '2015-02-01 00:02:54.000000', 'consum', 0.0220, 'lps'),
	(378870, 123, '2015-02-01 00:02:55.000000', 'consum', 0.0215, 'lps'),
	(378871, 123, '2015-02-01 00:02:56.000000', 'consum', 0.0225, 'lps'),
	(378872, 123, '2015-02-01 00:02:57.000000', 'consum', 0.0220, 'lps'),
	(378873, 123, '2015-02-01 00:02:58.000000', 'consum', 0.0216, 'lps'),
	(378874, 123, '2015-02-01 00:02:59.000000', 'consum', 0.0211, 'lps'),
	(378875, 123, '2015-02-01 00:03:00.000000', 'consum', 0.0213, 'lps'),
	(378876, 123, '2015-02-01 00:03:01.000000', 'consum', 0.0224, 'lps'),
	(378877, 123, '2015-02-01 00:03:02.000000', 'consum', 0.0220, 'lps'),
	(378878, 123, '2015-02-01 00:03:03.000000', 'consum', 0.0218, 'lps'),
	(378879, 123, '2015-02-01 00:03:04.000000', 'consum', 0.0222, 'lps'),
	(378880, 123, '2015-02-01 00:03:05.000000', 'consum', 0.0210, 'lps'),
	(378881, 123, '2015-02-01 00:03:06.000000', 'consum', 0.0225, 'lps'),
	(378882, 123, '2015-02-01 00:03:07.000000', 'consum', 0.0217, 'lps'),
	(378883, 123, '2015-02-01 00:03:08.000000', 'consum', 0.0217, 'lps'),
	(378884, 123, '2015-02-01 00:03:09.000000', 'consum', 0.0210, 'lps'),
	(378885, 123, '2015-02-01 00:03:10.000000', 'consum', 0.0224, 'lps'),
	(378886, 123, '2015-02-01 00:03:11.000000', 'consum', 0.0211, 'lps'),
	(378887, 123, '2015-02-01 00:03:12.000000', 'consum', 0.0225, 'lps'),
	(378888, 123, '2015-02-01 00:03:13.000000', 'consum', 0.0214, 'lps'),
	(378889, 123, '2015-02-01 00:03:14.000000', 'consum', 0.0219, 'lps'),
	(378890, 123, '2015-02-01 00:03:15.000000', 'consum', 0.0210, 'lps'),
	(378891, 123, '2015-02-01 00:03:16.000000', 'consum', 0.0217, 'lps'),
	(378892, 123, '2015-02-01 00:03:17.000000', 'consum', 0.0213, 'lps'),
	(378893, 123, '2015-02-01 00:03:18.000000', 'consum', 0.0221, 'lps'),
	(378894, 123, '2015-02-01 00:03:19.000000', 'consum', 0.0221, 'lps'),
	(378895, 123, '2015-02-01 00:03:20.000000', 'consum', 0.0215, 'lps'),
	(378896, 123, '2015-02-01 00:03:21.000000', 'consum', 0.0220, 'lps'),
	(378897, 123, '2015-02-01 00:03:22.000000', 'consum', 0.0211, 'lps'),
	(378898, 123, '2015-02-01 00:03:23.000000', 'consum', 0.0221, 'lps'),
	(378899, 123, '2015-02-01 00:03:24.000000', 'consum', 0.0213, 'lps'),
	(378900, 123, '2015-02-01 00:03:25.000000', 'consum', 0.0224, 'lps'),
	(378901, 123, '2015-02-01 00:03:26.000000', 'consum', 0.0222, 'lps'),
	(378902, 123, '2015-02-01 00:03:27.000000', 'consum', 0.0210, 'lps'),
	(378903, 123, '2015-02-01 00:03:28.000000', 'consum', 0.0226, 'lps'),
	(378904, 123, '2015-02-01 00:03:29.000000', 'consum', 0.0223, 'lps'),
	(378905, 123, '2015-02-01 00:03:30.000000', 'consum', 0.0211, 'lps'),
	(378906, 123, '2015-02-01 00:03:31.000000', 'consum', 0.0211, 'lps'),
	(378907, 123, '2015-02-01 00:03:32.000000', 'consum', 0.0210, 'lps'),
	(378908, 123, '2015-02-01 00:03:33.000000', 'consum', 0.0226, 'lps'),
	(378909, 123, '2015-02-01 00:03:34.000000', 'consum', 0.0221, 'lps'),
	(378910, 123, '2015-02-01 00:03:35.000000', 'consum', 0.0220, 'lps'),
	(378911, 123, '2015-02-01 00:03:36.000000', 'consum', 0.0225, 'lps'),
	(378912, 123, '2015-02-01 00:03:37.000000', 'consum', 0.0222, 'lps'),
	(378913, 123, '2015-02-01 00:03:38.000000', 'consum', 0.0211, 'lps'),
	(378914, 123, '2015-02-01 00:03:39.000000', 'consum', 0.0211, 'lps'),
	(378915, 123, '2015-02-01 00:03:40.000000', 'consum', 0.0213, 'lps'),
	(378916, 123, '2015-02-01 00:03:41.000000', 'consum', 0.0224, 'lps'),
	(378917, 123, '2015-02-01 00:03:42.000000', 'consum', 0.0220, 'lps'),
	(378918, 123, '2015-02-01 00:03:43.000000', 'consum', 0.0218, 'lps'),
	(378919, 123, '2015-02-01 00:03:44.000000', 'consum', 0.0221, 'lps'),
	(378920, 123, '2015-02-01 00:03:45.000000', 'consum', 0.0224, 'lps'),
	(378921, 123, '2015-02-01 00:03:46.000000', 'consum', 0.0213, 'lps'),
	(378922, 123, '2015-02-01 00:03:47.000000', 'consum', 0.0219, 'lps'),
	(378923, 123, '2015-02-01 00:03:48.000000', 'consum', 0.0211, 'lps'),
	(378924, 123, '2015-02-01 00:03:49.000000', 'consum', 0.0224, 'lps'),
	(378925, 123, '2015-02-01 00:03:50.000000', 'consum', 0.0225, 'lps'),
	(378926, 123, '2015-02-01 00:03:51.000000', 'consum', 0.0212, 'lps'),
	(378927, 123, '2015-02-01 00:03:52.000000', 'consum', 0.0225, 'lps'),
	(378928, 123, '2015-02-01 00:03:53.000000', 'consum', 0.0213, 'lps'),
	(378929, 123, '2015-02-01 00:03:54.000000', 'consum', 0.0216, 'lps'),
	(378930, 123, '2015-02-01 00:03:55.000000', 'consum', 0.0211, 'lps'),
	(378931, 123, '2015-02-01 00:03:56.000000', 'consum', 0.0216, 'lps'),
	(378932, 123, '2015-02-01 00:03:57.000000', 'consum', 0.0220, 'lps'),
	(378933, 123, '2015-02-01 00:03:58.000000', 'consum', 0.0224, 'lps'),
	(378934, 123, '2015-02-01 00:03:59.000000', 'consum', 0.0218, 'lps'),
	(378935, 123, '2015-02-01 00:04:00.000000', 'consum', 0.0224, 'lps'),
	(378936, 123, '2015-02-01 00:04:01.000000', 'consum', 0.0223, 'lps'),
	(378937, 123, '2015-02-01 00:04:02.000000', 'consum', 0.0218, 'lps'),
	(378938, 123, '2015-02-01 00:04:03.000000', 'consum', 0.0212, 'lps'),
	(378939, 123, '2015-02-01 00:04:04.000000', 'consum', 0.0212, 'lps'),
	(378940, 123, '2015-02-01 00:04:05.000000', 'consum', 0.0213, 'lps'),
	(378941, 123, '2015-02-01 00:04:06.000000', 'consum', 0.0221, 'lps'),
	(378942, 123, '2015-02-01 00:04:07.000000', 'consum', 0.0220, 'lps'),
	(378943, 123, '2015-02-01 00:04:08.000000', 'consum', 0.0214, 'lps'),
	(378944, 123, '2015-02-01 00:04:09.000000', 'consum', 0.0216, 'lps'),
	(378945, 123, '2015-02-01 00:04:10.000000', 'consum', 0.0213, 'lps'),
	(378946, 123, '2015-02-01 00:04:11.000000', 'consum', 0.0224, 'lps'),
	(378947, 123, '2015-02-01 00:04:12.000000', 'consum', 0.0220, 'lps'),
	(378948, 123, '2015-02-01 00:04:13.000000', 'consum', 0.0218, 'lps'),
	(378949, 123, '2015-02-01 00:04:14.000000', 'consum', 0.0222, 'lps'),
	(378950, 123, '2015-02-01 00:04:15.000000', 'consum', 0.0210, 'lps'),
	(378951, 123, '2015-02-01 00:04:16.000000', 'consum', 0.0226, 'lps'),
	(378952, 123, '2015-02-01 00:04:17.000000', 'consum', 0.0224, 'lps'),
	(378953, 123, '2015-02-01 00:04:18.000000', 'consum', 0.0215, 'lps'),
	(378954, 123, '2015-02-01 00:04:19.000000', 'consum', 0.0225, 'lps'),
	(378955, 123, '2015-02-01 00:04:20.000000', 'consum', 0.0223, 'lps'),
	(378956, 123, '2015-02-01 00:04:21.000000', 'consum', 0.0212, 'lps'),
	(378957, 123, '2015-02-01 00:04:22.000000', 'consum', 0.0217, 'lps'),
	(378958, 123, '2015-02-01 00:04:23.000000', 'consum', 0.0220, 'lps'),
	(378959, 123, '2015-02-01 00:04:24.000000', 'consum', 0.0223, 'lps'),
	(378960, 123, '2015-02-01 00:04:25.000000', 'consum', 0.0212, 'lps'),
	(378961, 123, '2015-02-01 00:04:26.000000', 'consum', 0.0216, 'lps'),
	(378962, 123, '2015-02-01 00:04:27.000000', 'consum', 0.0216, 'lps'),
	(378963, 123, '2015-02-01 00:04:28.000000', 'consum', 0.0225, 'lps'),
	(378964, 123, '2015-02-01 00:04:29.000000', 'consum', 0.0214, 'lps'),
	(378965, 123, '2015-02-01 00:04:30.000000', 'consum', 0.0222, 'lps'),
	(378966, 123, '2015-02-01 00:04:31.000000', 'consum', 0.0223, 'lps'),
	(378967, 123, '2015-02-01 00:04:32.000000', 'consum', 0.0222, 'lps'),
	(378968, 123, '2015-02-01 00:04:33.000000', 'consum', 0.0214, 'lps'),
	(378969, 123, '2015-02-01 00:04:34.000000', 'consum', 0.0212, 'lps'),
	(378970, 123, '2015-02-01 00:04:35.000000', 'consum', 0.0224, 'lps'),
	(378971, 123, '2015-02-01 00:04:36.000000', 'consum', 0.0226, 'lps'),
	(378972, 123, '2015-02-01 00:04:37.000000', 'consum', 0.0212, 'lps'),
	(378973, 123, '2015-02-01 00:04:38.000000', 'consum', 0.0224, 'lps'),
	(378974, 123, '2015-02-01 00:04:39.000000', 'consum', 0.0224, 'lps'),
	(378975, 123, '2015-02-01 00:04:40.000000', 'consum', 0.0223, 'lps'),
	(378976, 123, '2015-02-01 00:04:41.000000', 'consum', 0.0216, 'lps'),
	(378977, 123, '2015-02-01 00:04:42.000000', 'consum', 0.0219, 'lps'),
	(378978, 123, '2015-02-01 00:04:43.000000', 'consum', 0.0221, 'lps'),
	(378979, 123, '2015-02-01 00:04:44.000000', 'consum', 0.0219, 'lps'),
	(378980, 123, '2015-02-01 00:04:45.000000', 'consum', 0.0223, 'lps'),
	(378981, 123, '2015-02-01 00:04:46.000000', 'consum', 0.0214, 'lps'),
	(378982, 123, '2015-02-01 00:04:47.000000', 'consum', 0.0225, 'lps'),
	(378983, 123, '2015-02-01 00:04:48.000000', 'consum', 0.0222, 'lps'),
	(378984, 123, '2015-02-01 00:04:49.000000', 'consum', 0.0225, 'lps'),
	(378985, 123, '2015-02-01 00:04:50.000000', 'consum', 0.0217, 'lps'),
	(378986, 123, '2015-02-01 00:04:51.000000', 'consum', 0.0219, 'lps'),
	(378987, 123, '2015-02-01 00:04:52.000000', 'consum', 0.0214, 'lps'),
	(378988, 123, '2015-02-01 00:04:53.000000', 'consum', 0.0223, 'lps'),
	(378989, 123, '2015-02-01 00:04:54.000000', 'consum', 0.0210, 'lps'),
	(378990, 123, '2015-02-01 00:04:55.000000', 'consum', 0.0224, 'lps'),
	(378991, 123, '2015-02-01 00:04:56.000000', 'consum', 0.0214, 'lps'),
	(378992, 123, '2015-02-01 00:04:57.000000', 'consum', 0.0221, 'lps'),
	(378993, 123, '2015-02-01 00:04:58.000000', 'consum', 0.0219, 'lps'),
	(378994, 123, '2015-02-01 00:04:59.000000', 'consum', 0.0225, 'lps'),
	(378995, 123, '2015-02-01 00:05:00.000000', 'consum', 0.0222, 'lps'),
	(378996, 123, '2015-02-01 00:05:01.000000', 'consum', 0.0211, 'lps'),
	(378997, 123, '2015-02-01 00:05:02.000000', 'consum', 0.0213, 'lps'),
	(378998, 123, '2015-02-01 00:05:03.000000', 'consum', 0.0221, 'lps'),
	(378999, 123, '2015-02-01 00:05:04.000000', 'consum', 0.0225, 'lps'),
	(379000, 123, '2015-02-01 00:05:05.000000', 'consum', 0.0218, 'lps'),
	(379001, 123, '2015-02-01 00:05:06.000000', 'consum', 0.0222, 'lps'),
	(379002, 123, '2015-02-01 00:05:07.000000', 'consum', 0.0211, 'lps'),
	(379003, 123, '2015-02-01 00:05:08.000000', 'consum', 0.0214, 'lps'),
	(379004, 123, '2015-02-01 00:05:09.000000', 'consum', 0.0226, 'lps'),
	(379005, 123, '2015-02-01 00:05:10.000000', 'consum', 0.0212, 'lps'),
	(379006, 123, '2015-02-01 00:05:11.000000', 'consum', 0.0222, 'lps'),
	(379007, 123, '2015-02-01 00:05:12.000000', 'consum', 0.0213, 'lps'),
	(379008, 123, '2015-02-01 00:05:13.000000', 'consum', 0.0223, 'lps'),
	(379009, 123, '2015-02-01 00:05:14.000000', 'consum', 0.0216, 'lps'),
	(379010, 123, '2015-02-01 00:05:15.000000', 'consum', 0.0218, 'lps'),
	(379011, 123, '2015-02-01 00:05:16.000000', 'consum', 0.0218, 'lps'),
	(379012, 123, '2015-02-01 00:05:17.000000', 'consum', 0.0224, 'lps'),
	(379013, 123, '2015-02-01 00:05:18.000000', 'consum', 0.0225, 'lps'),
	(379014, 123, '2015-02-01 00:05:19.000000', 'consum', 0.0210, 'lps'),
	(379015, 123, '2015-02-01 00:05:20.000000', 'consum', 0.0215, 'lps'),
	(379016, 123, '2015-02-01 00:05:21.000000', 'consum', 0.0220, 'lps'),
	(379017, 123, '2015-02-01 00:05:22.000000', 'consum', 0.0226, 'lps'),
	(379018, 123, '2015-02-01 00:05:23.000000', 'consum', 0.0210, 'lps'),
	(379019, 123, '2015-02-01 00:05:24.000000', 'consum', 0.0214, 'lps'),
	(379020, 123, '2015-02-01 00:05:25.000000', 'consum', 0.0212, 'lps'),
	(379021, 123, '2015-02-01 00:05:26.000000', 'consum', 0.0210, 'lps'),
	(379022, 123, '2015-02-01 00:05:27.000000', 'consum', 0.0221, 'lps'),
	(379023, 123, '2015-02-01 00:05:28.000000', 'consum', 0.0215, 'lps'),
	(379024, 123, '2015-02-01 00:05:29.000000', 'consum', 0.0217, 'lps'),
	(379025, 123, '2015-02-01 00:05:30.000000', 'consum', 0.0217, 'lps'),
	(379026, 123, '2015-02-01 00:05:31.000000', 'consum', 0.0221, 'lps'),
	(379027, 123, '2015-02-01 00:05:32.000000', 'consum', 0.0214, 'lps'),
	(379028, 123, '2015-02-01 00:05:33.000000', 'consum', 0.0213, 'lps'),
	(379029, 123, '2015-02-01 00:05:34.000000', 'consum', 0.0215, 'lps'),
	(379030, 123, '2015-02-01 00:05:35.000000', 'consum', 0.0210, 'lps'),
	(379031, 123, '2015-02-01 00:05:36.000000', 'consum', 0.0210, 'lps'),
	(379032, 123, '2015-02-01 00:05:37.000000', 'consum', 0.0211, 'lps'),
	(379033, 123, '2015-02-01 00:05:38.000000', 'consum', 0.0216, 'lps'),
	(379034, 123, '2015-02-01 00:05:39.000000', 'consum', 0.0220, 'lps'),
	(379035, 123, '2015-02-01 00:05:40.000000', 'consum', 0.0225, 'lps'),
	(379036, 123, '2015-02-01 00:05:41.000000', 'consum', 0.0220, 'lps'),
	(379037, 123, '2015-02-01 00:05:42.000000', 'consum', 0.0218, 'lps'),
	(379038, 123, '2015-02-01 00:05:43.000000', 'consum', 0.0221, 'lps'),
	(379039, 123, '2015-02-01 00:05:44.000000', 'consum', 0.0223, 'lps'),
	(379040, 123, '2015-02-01 00:05:45.000000', 'consum', 0.0225, 'lps'),
	(379041, 123, '2015-02-01 00:05:46.000000', 'consum', 0.0213, 'lps'),
	(379042, 123, '2015-02-01 00:05:47.000000', 'consum', 0.0214, 'lps'),
	(379043, 123, '2015-02-01 00:05:48.000000', 'consum', 0.0220, 'lps'),
	(379044, 123, '2015-02-01 00:05:49.000000', 'consum', 0.0216, 'lps'),
	(379045, 123, '2015-02-01 00:05:50.000000', 'consum', 0.0225, 'lps'),
	(379046, 123, '2015-02-01 00:05:51.000000', 'consum', 0.0219, 'lps'),
	(379047, 123, '2015-02-01 00:05:52.000000', 'consum', 0.0211, 'lps'),
	(379048, 123, '2015-02-01 00:05:53.000000', 'consum', 0.0222, 'lps'),
	(379049, 123, '2015-02-01 00:05:54.000000', 'consum', 0.0216, 'lps'),
	(379050, 123, '2015-02-01 00:05:55.000000', 'consum', 0.0222, 'lps'),
	(379051, 123, '2015-02-01 00:05:56.000000', 'consum', 0.0219, 'lps'),
	(379052, 123, '2015-02-01 00:05:57.000000', 'consum', 0.0219, 'lps'),
	(379053, 123, '2015-02-01 00:05:58.000000', 'consum', 0.0213, 'lps'),
	(379054, 123, '2015-02-01 00:05:59.000000', 'consum', 0.0215, 'lps'),
	(379055, 123, '2015-02-01 00:06:00.000000', 'consum', 0.0225, 'lps'),
	(379056, 123, '2015-02-01 00:06:01.000000', 'consum', 0.0219, 'lps'),
	(379057, 123, '2015-02-01 00:06:02.000000', 'consum', 0.0211, 'lps'),
	(379058, 123, '2015-02-01 00:06:03.000000', 'consum', 0.0221, 'lps'),
	(379059, 123, '2015-02-01 00:06:04.000000', 'consum', 0.0212, 'lps'),
	(379060, 123, '2015-02-01 00:06:05.000000', 'consum', 0.0221, 'lps'),
	(379061, 123, '2015-02-01 00:06:06.000000', 'consum', 0.0226, 'lps'),
	(379062, 123, '2015-02-01 00:06:07.000000', 'consum', 0.0226, 'lps'),
	(379063, 123, '2015-02-01 00:06:08.000000', 'consum', 0.0223, 'lps'),
	(379064, 123, '2015-02-01 00:06:09.000000', 'consum', 0.0210, 'lps'),
	(379065, 123, '2015-02-01 00:06:10.000000', 'consum', 0.0225, 'lps'),
	(379066, 123, '2015-02-01 00:06:11.000000', 'consum', 0.0214, 'lps'),
	(379067, 123, '2015-02-01 00:06:12.000000', 'consum', 0.0223, 'lps'),
	(379068, 123, '2015-02-01 00:06:13.000000', 'consum', 0.0226, 'lps'),
	(379069, 123, '2015-02-01 00:06:14.000000', 'consum', 0.0220, 'lps'),
	(379070, 123, '2015-02-01 00:06:15.000000', 'consum', 0.0212, 'lps'),
	(379071, 123, '2015-02-01 00:06:16.000000', 'consum', 0.0224, 'lps'),
	(379072, 123, '2015-02-01 00:06:17.000000', 'consum', 0.0223, 'lps'),
	(379073, 123, '2015-02-01 00:06:18.000000', 'consum', 0.0217, 'lps'),
	(379074, 123, '2015-02-01 00:06:19.000000', 'consum', 0.0225, 'lps'),
	(379075, 123, '2015-02-01 00:06:20.000000', 'consum', 0.0213, 'lps'),
	(379076, 123, '2015-02-01 00:06:21.000000', 'consum', 0.0216, 'lps'),
	(379077, 123, '2015-02-01 00:06:22.000000', 'consum', 0.0213, 'lps'),
	(379078, 123, '2015-02-01 00:06:23.000000', 'consum', 0.0225, 'lps'),
	(379079, 123, '2015-02-01 00:06:24.000000', 'consum', 0.0224, 'lps'),
	(379080, 123, '2015-02-01 00:06:25.000000', 'consum', 0.0220, 'lps'),
	(379081, 123, '2015-02-01 00:06:26.000000', 'consum', 0.0217, 'lps'),
	(379082, 123, '2015-02-01 00:06:27.000000', 'consum', 0.0217, 'lps'),
	(379083, 123, '2015-02-01 00:06:28.000000', 'consum', 0.0225, 'lps'),
	(379084, 123, '2015-02-01 00:06:29.000000', 'consum', 0.0211, 'lps'),
	(379085, 123, '2015-02-01 00:06:30.000000', 'consum', 0.0224, 'lps'),
	(379086, 123, '2015-02-01 00:06:31.000000', 'consum', 0.0225, 'lps'),
	(379087, 123, '2015-02-01 00:06:32.000000', 'consum', 0.0225, 'lps'),
	(379088, 123, '2015-02-01 00:06:33.000000', 'consum', 0.0225, 'lps'),
	(379089, 123, '2015-02-01 00:06:34.000000', 'consum', 0.0221, 'lps'),
	(379090, 123, '2015-02-01 00:06:35.000000', 'consum', 0.0224, 'lps'),
	(379091, 123, '2015-02-01 00:06:36.000000', 'consum', 0.0213, 'lps'),
	(379092, 123, '2015-02-01 00:06:37.000000', 'consum', 0.0216, 'lps'),
	(379093, 123, '2015-02-01 00:06:38.000000', 'consum', 0.0214, 'lps'),
	(379094, 123, '2015-02-01 00:06:39.000000', 'consum', 0.0213, 'lps'),
	(379095, 123, '2015-02-01 00:06:40.000000', 'consum', 0.0214, 'lps'),
	(379096, 123, '2015-02-01 00:06:41.000000', 'consum', 0.0222, 'lps'),
	(379097, 123, '2015-02-01 00:06:42.000000', 'consum', 0.0223, 'lps'),
	(379098, 123, '2015-02-01 00:06:43.000000', 'consum', 0.0224, 'lps'),
	(379099, 123, '2015-02-01 00:06:44.000000', 'consum', 0.0225, 'lps'),
	(379100, 123, '2015-02-01 00:06:45.000000', 'consum', 0.0226, 'lps'),
	(379101, 123, '2015-02-01 00:06:46.000000', 'consum', 0.0211, 'lps'),
	(379102, 123, '2015-02-01 00:06:47.000000', 'consum', 0.0218, 'lps'),
	(379103, 123, '2015-02-01 00:06:48.000000', 'consum', 0.0213, 'lps'),
	(379104, 123, '2015-02-01 00:06:49.000000', 'consum', 0.0220, 'lps'),
	(379105, 123, '2015-02-01 00:06:50.000000', 'consum', 0.0217, 'lps'),
	(379106, 123, '2015-02-01 00:06:51.000000', 'consum', 0.0217, 'lps'),
	(379107, 123, '2015-02-01 00:06:52.000000', 'consum', 0.0221, 'lps'),
	(379108, 123, '2015-02-01 00:06:53.000000', 'consum', 0.0214, 'lps'),
	(379109, 123, '2015-02-01 00:06:54.000000', 'consum', 0.0215, 'lps'),
	(379110, 123, '2015-02-01 00:06:55.000000', 'consum', 0.0220, 'lps'),
	(379111, 123, '2015-02-01 00:06:56.000000', 'consum', 0.0215, 'lps'),
	(379112, 123, '2015-02-01 00:06:57.000000', 'consum', 0.0221, 'lps'),
	(379113, 123, '2015-02-01 00:06:58.000000', 'consum', 0.0215, 'lps'),
	(379114, 123, '2015-02-01 00:06:59.000000', 'consum', 0.0222, 'lps'),
	(379115, 123, '2015-02-01 00:07:00.000000', 'consum', 0.0219, 'lps'),
	(379116, 123, '2015-02-01 00:07:01.000000', 'consum', 0.0220, 'lps'),
	(379117, 123, '2015-02-01 00:07:02.000000', 'consum', 0.0219, 'lps'),
	(379118, 123, '2015-02-01 00:07:03.000000', 'consum', 0.0223, 'lps'),
	(379119, 123, '2015-02-01 00:07:04.000000', 'consum', 0.0214, 'lps'),
	(379120, 123, '2015-02-01 00:07:05.000000', 'consum', 0.0226, 'lps'),
	(379121, 123, '2015-02-01 00:07:06.000000', 'consum', 0.0213, 'lps'),
	(379122, 123, '2015-02-01 00:07:07.000000', 'consum', 0.0225, 'lps'),
	(379123, 123, '2015-02-01 00:07:08.000000', 'consum', 0.0211, 'lps'),
	(379124, 123, '2015-02-01 00:07:09.000000', 'consum', 0.0219, 'lps'),
	(379125, 123, '2015-02-01 00:07:10.000000', 'consum', 0.0218, 'lps'),
	(379126, 123, '2015-02-01 00:07:11.000000', 'consum', 0.0226, 'lps'),
	(379127, 123, '2015-02-01 00:07:12.000000', 'consum', 0.0214, 'lps'),
	(379128, 123, '2015-02-01 00:07:13.000000', 'consum', 0.0218, 'lps'),
	(379129, 123, '2015-02-01 00:07:14.000000', 'consum', 0.0223, 'lps'),
	(379130, 123, '2015-02-01 00:07:15.000000', 'consum', 0.0214, 'lps'),
	(379131, 123, '2015-02-01 00:07:16.000000', 'consum', 0.0212, 'lps'),
	(379132, 123, '2015-02-01 00:07:17.000000', 'consum', 0.0222, 'lps'),
	(379133, 123, '2015-02-01 00:07:18.000000', 'consum', 0.0215, 'lps'),
	(379134, 123, '2015-02-01 00:07:19.000000', 'consum', 0.0215, 'lps'),
	(379135, 123, '2015-02-01 00:07:20.000000', 'consum', 0.0224, 'lps'),
	(379136, 123, '2015-02-01 00:07:21.000000', 'consum', 0.0211, 'lps'),
	(379137, 123, '2015-02-01 00:07:22.000000', 'consum', 0.0224, 'lps'),
	(379138, 123, '2015-02-01 00:07:23.000000', 'consum', 0.0212, 'lps'),
	(379139, 123, '2015-02-01 00:07:24.000000', 'consum', 0.0214, 'lps'),
	(379140, 123, '2015-02-01 00:07:25.000000', 'consum', 0.0221, 'lps'),
	(379141, 123, '2015-02-01 00:07:26.000000', 'consum', 0.0222, 'lps'),
	(379142, 123, '2015-02-01 00:07:27.000000', 'consum', 0.0218, 'lps'),
	(379143, 123, '2015-02-01 00:07:28.000000', 'consum', 0.0217, 'lps'),
	(379144, 123, '2015-02-01 00:07:29.000000', 'consum', 0.0222, 'lps'),
	(379145, 123, '2015-02-01 00:07:30.000000', 'consum', 0.0213, 'lps'),
	(379146, 123, '2015-02-01 00:07:31.000000', 'consum', 0.0224, 'lps'),
	(379147, 123, '2015-02-01 00:07:32.000000', 'consum', 0.0221, 'lps'),
	(379148, 123, '2015-02-01 00:07:33.000000', 'consum', 0.0223, 'lps'),
	(379149, 123, '2015-02-01 00:07:34.000000', 'consum', 0.0224, 'lps'),
	(379150, 123, '2015-02-01 00:07:35.000000', 'consum', 0.0225, 'lps'),
	(379151, 123, '2015-02-01 00:07:36.000000', 'consum', 0.0225, 'lps'),
	(379152, 123, '2015-02-01 00:07:37.000000', 'consum', 0.0226, 'lps'),
	(379153, 123, '2015-02-01 00:07:38.000000', 'consum', 0.0226, 'lps'),
	(379154, 123, '2015-02-01 00:07:39.000000', 'consum', 0.0226, 'lps'),
	(379155, 123, '2015-02-01 00:07:40.000000', 'consum', 0.0226, 'lps'),
	(379156, 123, '2015-02-01 00:07:41.000000', 'consum', 0.0224, 'lps'),
	(379157, 123, '2015-02-01 00:07:42.000000', 'consum', 0.0216, 'lps'),
	(379158, 123, '2015-02-01 00:07:43.000000', 'consum', 0.0215, 'lps'),
	(379159, 123, '2015-02-01 00:07:44.000000', 'consum', 0.0218, 'lps'),
	(379160, 123, '2015-02-01 00:07:45.000000', 'consum', 0.0219, 'lps'),
	(379161, 123, '2015-02-01 00:07:46.000000', 'consum', 0.0216, 'lps'),
	(379162, 123, '2015-02-01 00:07:47.000000', 'consum', 0.0212, 'lps'),
	(379163, 123, '2015-02-01 00:07:48.000000', 'consum', 0.0221, 'lps'),
	(379164, 123, '2015-02-01 00:07:49.000000', 'consum', 0.0224, 'lps'),
	(379165, 123, '2015-02-01 00:07:50.000000', 'consum', 0.0216, 'lps'),
	(379166, 123, '2015-02-01 00:07:51.000000', 'consum', 0.0214, 'lps'),
	(379167, 123, '2015-02-01 00:07:52.000000', 'consum', 0.0212, 'lps'),
	(379168, 123, '2015-02-01 00:07:53.000000', 'consum', 0.0225, 'lps'),
	(379169, 123, '2015-02-01 00:07:54.000000', 'consum', 0.0212, 'lps'),
	(379170, 123, '2015-02-01 00:07:55.000000', 'consum', 0.0226, 'lps'),
	(379171, 123, '2015-02-01 00:07:56.000000', 'consum', 0.0215, 'lps'),
	(379172, 123, '2015-02-01 00:07:57.000000', 'consum', 0.0222, 'lps'),
	(379173, 123, '2015-02-01 00:07:58.000000', 'consum', 0.0224, 'lps'),
	(379174, 123, '2015-02-01 00:07:59.000000', 'consum', 0.0225, 'lps'),
	(379175, 123, '2015-02-01 00:08:00.000000', 'consum', 0.0226, 'lps'),
	(379176, 123, '2015-02-01 00:08:01.000000', 'consum', 0.0211, 'lps'),
	(379177, 123, '2015-02-01 00:08:02.000000', 'consum', 0.0220, 'lps'),
	(379178, 123, '2015-02-01 00:08:03.000000', 'consum', 0.0222, 'lps'),
	(379179, 123, '2015-02-01 00:08:04.000000', 'consum', 0.0225, 'lps'),
	(379180, 123, '2015-02-01 00:08:05.000000', 'consum', 0.0216, 'lps'),
	(379181, 123, '2015-02-01 00:08:06.000000', 'consum', 0.0212, 'lps'),
	(379182, 123, '2015-02-01 00:08:07.000000', 'consum', 0.0219, 'lps'),
	(379183, 123, '2015-02-01 00:08:08.000000', 'consum', 0.0216, 'lps'),
	(379184, 123, '2015-02-01 00:08:09.000000', 'consum', 0.0214, 'lps'),
	(379185, 123, '2015-02-01 00:08:10.000000', 'consum', 0.0211, 'lps'),
	(379186, 123, '2015-02-01 00:08:11.000000', 'consum', 0.0220, 'lps'),
	(379187, 123, '2015-02-01 00:08:12.000000', 'consum', 0.0222, 'lps'),
	(379188, 123, '2015-02-01 00:08:13.000000', 'consum', 0.0210, 'lps'),
	(379189, 123, '2015-02-01 00:08:14.000000', 'consum', 0.0224, 'lps'),
	(379190, 123, '2015-02-01 00:08:15.000000', 'consum', 0.0214, 'lps'),
	(379191, 123, '2015-02-01 00:08:16.000000', 'consum', 0.0223, 'lps'),
	(379192, 123, '2015-02-01 00:08:17.000000', 'consum', 0.0212, 'lps'),
	(379193, 123, '2015-02-01 00:08:18.000000', 'consum', 0.0215, 'lps'),
	(379194, 123, '2015-02-01 00:08:19.000000', 'consum', 0.0211, 'lps'),
	(379195, 123, '2015-02-01 00:08:20.000000', 'consum', 0.0217, 'lps'),
	(379196, 123, '2015-02-01 00:08:21.000000', 'consum', 0.0226, 'lps'),
	(379197, 123, '2015-02-01 00:08:22.000000', 'consum', 0.0218, 'lps'),
	(379198, 123, '2015-02-01 00:08:23.000000', 'consum', 0.0221, 'lps'),
	(379199, 123, '2015-02-01 00:08:24.000000', 'consum', 0.0223, 'lps'),
	(379200, 123, '2015-02-01 00:08:25.000000', 'consum', 0.0225, 'lps'),
	(379201, 123, '2015-02-01 00:08:26.000000', 'consum', 0.0215, 'lps'),
	(379202, 123, '2015-02-01 00:08:27.000000', 'consum', 0.0224, 'lps'),
	(379203, 123, '2015-02-01 00:08:28.000000', 'consum', 0.0214, 'lps'),
	(379204, 123, '2015-02-01 00:08:29.000000', 'consum', 0.0224, 'lps'),
	(379205, 123, '2015-02-01 00:08:30.000000', 'consum', 0.0215, 'lps'),
	(379206, 123, '2015-02-01 00:08:31.000000', 'consum', 0.0213, 'lps'),
	(379207, 123, '2015-02-01 00:08:32.000000', 'consum', 0.0211, 'lps'),
	(379208, 123, '2015-02-01 00:08:33.000000', 'consum', 0.0220, 'lps'),
	(379209, 123, '2015-02-01 00:08:34.000000', 'consum', 0.0210, 'lps'),
	(379210, 123, '2015-02-01 00:08:35.000000', 'consum', 0.0213, 'lps'),
	(379211, 123, '2015-02-01 00:08:36.000000', 'consum', 0.0226, 'lps'),
	(379212, 123, '2015-02-01 00:08:37.000000', 'consum', 0.0212, 'lps'),
	(379213, 123, '2015-02-01 00:08:38.000000', 'consum', 0.0224, 'lps'),
	(379214, 123, '2015-02-01 00:08:39.000000', 'consum', 0.0225, 'lps'),
	(379215, 123, '2015-02-01 00:08:40.000000', 'consum', 0.0225, 'lps'),
	(379216, 123, '2015-02-01 00:08:41.000000', 'consum', 0.0222, 'lps'),
	(379217, 123, '2015-02-01 00:08:42.000000', 'consum', 0.0210, 'lps'),
	(379218, 123, '2015-02-01 00:08:43.000000', 'consum', 0.0210, 'lps'),
	(379219, 123, '2015-02-01 00:08:44.000000', 'consum', 0.0210, 'lps'),
	(379220, 123, '2015-02-01 00:08:45.000000', 'consum', 0.0211, 'lps'),
	(379221, 123, '2015-02-01 00:08:46.000000', 'consum', 0.0213, 'lps'),
	(379222, 123, '2015-02-01 00:08:47.000000', 'consum', 0.0225, 'lps'),
	(379223, 123, '2015-02-01 00:08:48.000000', 'consum', 0.0226, 'lps'),
	(379224, 123, '2015-02-01 00:08:49.000000', 'consum', 0.0210, 'lps'),
	(379225, 123, '2015-02-01 00:08:50.000000', 'consum', 0.0212, 'lps'),
	(379226, 123, '2015-02-01 00:08:51.000000', 'consum', 0.0221, 'lps'),
	(379227, 123, '2015-02-01 00:08:52.000000', 'consum', 0.0210, 'lps'),
	(379228, 123, '2015-02-01 00:08:53.000000', 'consum', 0.0212, 'lps'),
	(379229, 123, '2015-02-01 00:08:54.000000', 'consum', 0.0219, 'lps'),
	(379230, 123, '2015-02-01 00:08:55.000000', 'consum', 0.0215, 'lps'),
	(379231, 123, '2015-02-01 00:08:56.000000', 'consum', 0.0225, 'lps'),
	(379232, 123, '2015-02-01 00:08:57.000000', 'consum', 0.0220, 'lps'),
	(379233, 123, '2015-02-01 00:08:58.000000', 'consum', 0.0215, 'lps'),
	(379234, 123, '2015-02-01 00:08:59.000000', 'consum', 0.0225, 'lps'),
	(379235, 123, '2015-02-01 00:09:00.000000', 'consum', 0.0217, 'lps'),
	(379236, 123, '2015-02-01 00:09:01.000000', 'consum', 0.0217, 'lps'),
	(379237, 123, '2015-02-01 00:09:02.000000', 'consum', 0.0226, 'lps'),
	(379238, 123, '2015-02-01 00:09:03.000000', 'consum', 0.0217, 'lps'),
	(379239, 123, '2015-02-01 00:09:04.000000', 'consum', 0.0217, 'lps'),
	(379240, 123, '2015-02-01 00:09:05.000000', 'consum', 0.0225, 'lps'),
	(379241, 123, '2015-02-01 00:09:06.000000', 'consum', 0.0210, 'lps'),
	(379242, 123, '2015-02-01 00:09:07.000000', 'consum', 0.0219, 'lps'),
	(379243, 123, '2015-02-01 00:09:08.000000', 'consum', 0.0222, 'lps'),
	(379244, 123, '2015-02-01 00:09:09.000000', 'consum', 0.0226, 'lps'),
	(379245, 123, '2015-02-01 00:09:10.000000', 'consum', 0.0221, 'lps'),
	(379246, 123, '2015-02-01 00:09:11.000000', 'consum', 0.0216, 'lps'),
	(379247, 123, '2015-02-01 00:09:12.000000', 'consum', 0.0210, 'lps'),
	(379248, 123, '2015-02-01 00:09:13.000000', 'consum', 0.0223, 'lps'),
	(379249, 123, '2015-02-01 00:09:14.000000', 'consum', 0.0211, 'lps'),
	(379250, 123, '2015-02-01 00:09:15.000000', 'consum', 0.0210, 'lps'),
	(379251, 123, '2015-02-01 00:09:16.000000', 'consum', 0.0224, 'lps'),
	(379252, 123, '2015-02-01 00:09:17.000000', 'consum', 0.0211, 'lps'),
	(379253, 123, '2015-02-01 00:09:18.000000', 'consum', 0.0210, 'lps'),
	(379254, 123, '2015-02-01 00:09:19.000000', 'consum', 0.0225, 'lps'),
	(379255, 123, '2015-02-01 00:09:20.000000', 'consum', 0.0215, 'lps'),
	(379256, 123, '2015-02-01 00:09:21.000000', 'consum', 0.0210, 'lps'),
	(379257, 123, '2015-02-01 00:09:22.000000', 'consum', 0.0213, 'lps'),
	(379258, 123, '2015-02-01 00:09:23.000000', 'consum', 0.0223, 'lps'),
	(379259, 123, '2015-02-01 00:09:24.000000', 'consum', 0.0216, 'lps'),
	(379260, 123, '2015-02-01 00:09:25.000000', 'consum', 0.0220, 'lps'),
	(379261, 123, '2015-02-01 00:09:26.000000', 'consum', 0.0225, 'lps'),
	(379262, 123, '2015-02-01 00:09:27.000000', 'consum', 0.0220, 'lps'),
	(379263, 123, '2015-02-01 00:09:28.000000', 'consum', 0.0216, 'lps'),
	(379264, 123, '2015-02-01 00:09:29.000000', 'consum', 0.0210, 'lps'),
	(379265, 123, '2015-02-01 00:09:30.000000', 'consum', 0.0210, 'lps'),
	(379266, 123, '2015-02-01 00:09:31.000000', 'consum', 0.0211, 'lps'),
	(379267, 123, '2015-02-01 00:09:32.000000', 'consum', 0.0214, 'lps'),
	(379268, 123, '2015-02-01 00:09:33.000000', 'consum', 0.0211, 'lps'),
	(379269, 123, '2015-02-01 00:09:34.000000', 'consum', 0.0219, 'lps'),
	(379270, 123, '2015-02-01 00:09:35.000000', 'consum', 0.0222, 'lps'),
	(379271, 123, '2015-02-01 00:09:36.000000', 'consum', 0.0224, 'lps'),
	(379272, 123, '2015-02-01 00:09:37.000000', 'consum', 0.0210, 'lps'),
	(379273, 123, '2015-02-01 00:09:38.000000', 'consum', 0.0219, 'lps'),
	(379274, 123, '2015-02-01 00:09:39.000000', 'consum', 0.0220, 'lps'),
	(379275, 123, '2015-02-01 00:09:40.000000', 'consum', 0.0220, 'lps'),
	(379276, 123, '2015-02-01 00:09:41.000000', 'consum', 0.0213, 'lps'),
	(379277, 123, '2015-02-01 00:09:42.000000', 'consum', 0.0213, 'lps'),
	(379278, 123, '2015-02-01 00:09:43.000000', 'consum', 0.0217, 'lps'),
	(379279, 123, '2015-02-01 00:09:44.000000', 'consum', 0.0217, 'lps'),
	(379280, 123, '2015-02-01 00:09:45.000000', 'consum', 0.0226, 'lps'),
	(379281, 123, '2015-02-01 00:09:46.000000', 'consum', 0.0217, 'lps'),
	(379282, 123, '2015-02-01 00:09:47.000000', 'consum', 0.0214, 'lps'),
	(379283, 123, '2015-02-01 00:09:48.000000', 'consum', 0.0212, 'lps'),
	(379284, 123, '2015-02-01 00:09:49.000000', 'consum', 0.0226, 'lps'),
	(379285, 123, '2015-02-01 00:09:50.000000', 'consum', 0.0216, 'lps'),
	(379286, 123, '2015-02-01 00:09:51.000000', 'consum', 0.0225, 'lps'),
	(379287, 123, '2015-02-01 00:09:52.000000', 'consum', 0.0217, 'lps'),
	(379288, 123, '2015-02-01 00:09:53.000000', 'consum', 0.0220, 'lps'),
	(379289, 123, '2015-02-01 00:09:54.000000', 'consum', 0.0219, 'lps'),
	(379290, 123, '2015-02-01 00:09:55.000000', 'consum', 0.0211, 'lps'),
	(379291, 123, '2015-02-01 00:09:56.000000', 'consum', 0.0221, 'lps'),
	(379292, 123, '2015-02-01 00:09:57.000000', 'consum', 0.0212, 'lps'),
	(379293, 123, '2015-02-01 00:09:58.000000', 'consum', 0.0220, 'lps'),
	(379294, 123, '2015-02-01 00:09:59.000000', 'consum', 0.0220, 'lps'),
	(379295, 123, '2015-02-01 00:10:00.000000', 'consum', 0.0215, 'lps'),
	(379296, 123, '2015-02-01 00:10:01.000000', 'consum', 0.0222, 'lps'),
	(379297, 123, '2015-02-01 00:10:02.000000', 'consum', 0.0220, 'lps'),
	(379298, 123, '2015-02-01 00:10:03.000000', 'consum', 0.0210, 'lps'),
	(379299, 123, '2015-02-01 00:10:04.000000', 'consum', 0.0215, 'lps'),
	(379300, 123, '2015-02-01 00:10:05.000000', 'consum', 0.0219, 'lps'),
	(379301, 123, '2015-02-01 00:10:06.000000', 'consum', 0.0221, 'lps'),
	(379302, 123, '2015-02-01 00:10:07.000000', 'consum', 0.0224, 'lps'),
	(379303, 123, '2015-02-01 00:10:08.000000', 'consum', 0.0214, 'lps'),
	(379304, 123, '2015-02-01 00:10:09.000000', 'consum', 0.0222, 'lps'),
	(379305, 123, '2015-02-01 00:10:10.000000', 'consum', 0.0224, 'lps'),
	(379306, 123, '2015-02-01 00:10:11.000000', 'consum', 0.0226, 'lps'),
	(379307, 123, '2015-02-01 00:10:12.000000', 'consum', 0.0216, 'lps'),
	(379308, 123, '2015-02-01 00:10:13.000000', 'consum', 0.0226, 'lps'),
	(379309, 123, '2015-02-01 00:10:14.000000', 'consum', 0.0222, 'lps'),
	(379310, 123, '2015-02-01 00:10:15.000000', 'consum', 0.0220, 'lps'),
	(379311, 123, '2015-02-01 00:10:16.000000', 'consum', 0.0210, 'lps'),
	(379312, 123, '2015-02-01 00:10:17.000000', 'consum', 0.0213, 'lps'),
	(379313, 123, '2015-02-01 00:10:18.000000', 'consum', 0.0225, 'lps'),
	(379314, 123, '2015-02-01 00:10:19.000000', 'consum', 0.0224, 'lps'),
	(379315, 123, '2015-02-01 00:10:20.000000', 'consum', 0.0221, 'lps'),
	(379316, 123, '2015-02-01 00:10:21.000000', 'consum', 0.0222, 'lps'),
	(379317, 123, '2015-02-01 00:10:22.000000', 'consum', 0.0220, 'lps'),
	(379318, 123, '2015-02-01 00:10:23.000000', 'consum', 0.0225, 'lps'),
	(379319, 123, '2015-02-01 00:10:24.000000', 'consum', 0.0222, 'lps'),
	(379320, 123, '2015-02-01 00:10:25.000000', 'consum', 0.0223, 'lps'),
	(379321, 123, '2015-02-01 00:10:26.000000', 'consum', 0.0226, 'lps'),
	(379322, 123, '2015-02-01 00:10:27.000000', 'consum', 0.0216, 'lps'),
	(379323, 123, '2015-02-01 00:10:28.000000', 'consum', 0.0226, 'lps'),
	(379324, 123, '2015-02-01 00:10:29.000000', 'consum', 0.0221, 'lps'),
	(379325, 123, '2015-02-01 00:10:30.000000', 'consum', 0.0218, 'lps'),
	(379326, 123, '2015-02-01 00:10:31.000000', 'consum', 0.0216, 'lps'),
	(379327, 123, '2015-02-01 00:10:32.000000', 'consum', 0.0216, 'lps'),
	(379328, 123, '2015-02-01 00:10:33.000000', 'consum', 0.0222, 'lps'),
	(379329, 123, '2015-02-01 00:10:34.000000', 'consum', 0.0221, 'lps'),
	(379330, 123, '2015-02-01 00:10:35.000000', 'consum', 0.0211, 'lps'),
	(379331, 123, '2015-02-01 00:10:36.000000', 'consum', 0.0217, 'lps'),
	(379332, 123, '2015-02-01 00:10:37.000000', 'consum', 0.0225, 'lps'),
	(379333, 123, '2015-02-01 00:10:38.000000', 'consum', 0.0215, 'lps'),
	(379334, 123, '2015-02-01 00:10:39.000000', 'consum', 0.0224, 'lps'),
	(379335, 123, '2015-02-01 00:10:40.000000', 'consum', 0.0212, 'lps'),
	(379336, 123, '2015-02-01 00:10:41.000000', 'consum', 0.0215, 'lps'),
	(379337, 123, '2015-02-01 00:10:42.000000', 'consum', 0.0212, 'lps'),
	(379338, 123, '2015-02-01 00:10:43.000000', 'consum', 0.0223, 'lps'),
	(379339, 123, '2015-02-01 00:10:44.000000', 'consum', 0.0219, 'lps'),
	(379340, 123, '2015-02-01 00:10:45.000000', 'consum', 0.0216, 'lps'),
	(379341, 123, '2015-02-01 00:10:46.000000', 'consum', 0.0213, 'lps'),
	(379342, 123, '2015-02-01 00:10:47.000000', 'consum', 0.0226, 'lps'),
	(379343, 123, '2015-02-01 00:10:48.000000', 'consum', 0.0212, 'lps'),
	(379344, 123, '2015-02-01 00:10:49.000000', 'consum', 0.0225, 'lps'),
	(379345, 123, '2015-02-01 00:10:50.000000', 'consum', 0.0212, 'lps'),
	(379346, 123, '2015-02-01 00:10:51.000000', 'consum', 0.0224, 'lps'),
	(379347, 123, '2015-02-01 00:10:52.000000', 'consum', 0.0224, 'lps'),
	(379348, 123, '2015-02-01 00:10:53.000000', 'consum', 0.0220, 'lps'),
	(379349, 123, '2015-02-01 00:10:54.000000', 'consum', 0.0220, 'lps'),
	(379350, 123, '2015-02-01 00:10:55.000000', 'consum', 0.0215, 'lps'),
	(379351, 123, '2015-02-01 00:10:56.000000', 'consum', 0.0222, 'lps'),
	(379352, 123, '2015-02-01 00:10:57.000000', 'consum', 0.0220, 'lps'),
	(379353, 123, '2015-02-01 00:10:58.000000', 'consum', 0.0225, 'lps'),
	(379354, 123, '2015-02-01 00:10:59.000000', 'consum', 0.0223, 'lps'),
	(379355, 123, '2015-02-01 00:11:00.000000', 'consum', 0.0213, 'lps'),
	(379356, 123, '2015-02-01 00:11:01.000000', 'consum', 0.0222, 'lps'),
	(379357, 123, '2015-02-01 00:11:02.000000', 'consum', 0.0225, 'lps'),
	(379358, 123, '2015-02-01 00:11:03.000000', 'consum', 0.0217, 'lps'),
	(379359, 123, '2015-02-01 00:11:04.000000', 'consum', 0.0215, 'lps'),
	(379360, 123, '2015-02-01 00:11:05.000000', 'consum', 0.0217, 'lps'),
	(379361, 123, '2015-02-01 00:11:06.000000', 'consum', 0.0215, 'lps'),
	(379362, 123, '2015-02-01 00:11:07.000000', 'consum', 0.0211, 'lps'),
	(379363, 123, '2015-02-01 00:11:08.000000', 'consum', 0.0219, 'lps'),
	(379364, 123, '2015-02-01 00:11:09.000000', 'consum', 0.0219, 'lps'),
	(379365, 123, '2015-02-01 00:11:10.000000', 'consum', 0.0226, 'lps'),
	(379366, 123, '2015-02-01 00:11:11.000000', 'consum', 0.0214, 'lps'),
	(379367, 123, '2015-02-01 00:11:12.000000', 'consum', 0.0217, 'lps'),
	(379368, 123, '2015-02-01 00:11:13.000000', 'consum', 0.0215, 'lps'),
	(379369, 123, '2015-02-01 00:11:14.000000', 'consum', 0.0213, 'lps'),
	(379370, 123, '2015-02-01 00:11:15.000000', 'consum', 0.0213, 'lps'),
	(379371, 123, '2015-02-01 00:11:16.000000', 'consum', 0.0215, 'lps'),
	(379372, 123, '2015-02-01 00:11:17.000000', 'consum', 0.0212, 'lps'),
	(379373, 123, '2015-02-01 00:11:18.000000', 'consum', 0.0221, 'lps'),
	(379374, 123, '2015-02-01 00:11:19.000000', 'consum', 0.0210, 'lps'),
	(379375, 123, '2015-02-01 00:11:20.000000', 'consum', 0.0211, 'lps'),
	(379376, 123, '2015-02-01 00:11:21.000000', 'consum', 0.0214, 'lps'),
	(379377, 123, '2015-02-01 00:11:22.000000', 'consum', 0.0210, 'lps'),
	(379378, 123, '2015-02-01 00:11:23.000000', 'consum', 0.0217, 'lps'),
	(379379, 123, '2015-02-01 00:11:24.000000', 'consum', 0.0212, 'lps'),
	(379380, 123, '2015-02-01 00:11:25.000000', 'consum', 0.0215, 'lps'),
	(379381, 123, '2015-02-01 00:11:26.000000', 'consum', 0.0214, 'lps'),
	(379382, 123, '2015-02-01 00:11:27.000000', 'consum', 0.0213, 'lps'),
	(379383, 123, '2015-02-01 00:11:28.000000', 'consum', 0.0215, 'lps'),
	(379384, 123, '2015-02-01 00:11:29.000000', 'consum', 0.0225, 'lps'),
	(379385, 123, '2015-02-01 00:11:30.000000', 'consum', 0.0219, 'lps'),
	(379386, 123, '2015-02-01 00:11:31.000000', 'consum', 0.0212, 'lps'),
	(379387, 123, '2015-02-01 00:11:32.000000', 'consum', 0.0211, 'lps'),
	(379388, 123, '2015-02-01 00:11:33.000000', 'consum', 0.0211, 'lps'),
	(379389, 123, '2015-02-01 00:11:34.000000', 'consum', 0.0210, 'lps'),
	(379390, 123, '2015-02-01 00:11:35.000000', 'consum', 0.0224, 'lps'),
	(379391, 123, '2015-02-01 00:11:36.000000', 'consum', 0.0212, 'lps'),
	(379392, 123, '2015-02-01 00:11:37.000000', 'consum', 0.0215, 'lps'),
	(379393, 123, '2015-02-01 00:11:38.000000', 'consum', 0.0226, 'lps'),
	(379394, 123, '2015-02-01 00:11:39.000000', 'consum', 0.0210, 'lps'),
	(379395, 123, '2015-02-01 00:11:40.000000', 'consum', 0.0215, 'lps'),
	(379396, 123, '2015-02-01 00:11:41.000000', 'consum', 0.0216, 'lps'),
	(379397, 123, '2015-02-01 00:11:42.000000', 'consum', 0.0224, 'lps'),
	(379398, 123, '2015-02-01 00:11:43.000000', 'consum', 0.0214, 'lps'),
	(379399, 123, '2015-02-01 00:11:44.000000', 'consum', 0.0221, 'lps'),
	(379400, 123, '2015-02-01 00:11:45.000000', 'consum', 0.0220, 'lps'),
	(379401, 123, '2015-02-01 00:11:46.000000', 'consum', 0.0210, 'lps'),
	(379402, 123, '2015-02-01 00:11:47.000000', 'consum', 0.0215, 'lps'),
	(379403, 123, '2015-02-01 00:11:48.000000', 'consum', 0.0218, 'lps'),
	(379404, 123, '2015-02-01 00:11:49.000000', 'consum', 0.0219, 'lps'),
	(379405, 123, '2015-02-01 00:11:50.000000', 'consum', 0.0212, 'lps'),
	(379406, 123, '2015-02-01 00:11:51.000000', 'consum', 0.0214, 'lps'),
	(379407, 123, '2015-02-01 00:11:52.000000', 'consum', 0.0222, 'lps'),
	(379408, 123, '2015-02-01 00:11:53.000000', 'consum', 0.0224, 'lps'),
	(379409, 123, '2015-02-01 00:11:54.000000', 'consum', 0.0213, 'lps'),
	(379410, 123, '2015-02-01 00:11:55.000000', 'consum', 0.0217, 'lps'),
	(379411, 123, '2015-02-01 00:11:56.000000', 'consum', 0.0217, 'lps'),
	(379412, 123, '2015-02-01 00:11:57.000000', 'consum', 0.0210, 'lps'),
	(379413, 123, '2015-02-01 00:11:58.000000', 'consum', 0.0223, 'lps'),
	(379414, 123, '2015-02-01 00:11:59.000000', 'consum', 0.0225, 'lps'),
	(379415, 123, '2015-02-01 00:12:00.000000', 'consum', 0.0213, 'lps'),
	(379416, 123, '2015-02-01 00:12:01.000000', 'consum', 0.0213, 'lps'),
	(379417, 123, '2015-02-01 00:12:02.000000', 'consum', 0.0217, 'lps'),
	(379418, 123, '2015-02-01 00:12:03.000000', 'consum', 0.0220, 'lps'),
	(379419, 123, '2015-02-01 00:12:04.000000', 'consum', 0.0224, 'lps'),
	(379420, 123, '2015-02-01 00:12:05.000000', 'consum', 0.0216, 'lps'),
	(379421, 123, '2015-02-01 00:12:06.000000', 'consum', 0.0214, 'lps'),
	(379422, 123, '2015-02-01 00:12:07.000000', 'consum', 0.0211, 'lps'),
	(379423, 123, '2015-02-01 00:12:08.000000', 'consum', 0.0223, 'lps'),
	(379424, 123, '2015-02-01 00:12:09.000000', 'consum', 0.0220, 'lps'),
	(379425, 123, '2015-02-01 00:12:10.000000', 'consum', 0.0222, 'lps'),
	(379426, 123, '2015-02-01 00:12:11.000000', 'consum', 0.0225, 'lps'),
	(379427, 123, '2015-02-01 00:12:12.000000', 'consum', 0.0215, 'lps'),
	(379428, 123, '2015-02-01 00:12:13.000000', 'consum', 0.0224, 'lps'),
	(379429, 123, '2015-02-01 00:12:14.000000', 'consum', 0.0216, 'lps'),
	(379430, 123, '2015-02-01 00:12:15.000000', 'consum', 0.0216, 'lps'),
	(379431, 123, '2015-02-01 00:12:16.000000', 'consum', 0.0222, 'lps'),
	(379432, 123, '2015-02-01 00:12:17.000000', 'consum', 0.0220, 'lps'),
	(379433, 123, '2015-02-01 00:12:18.000000', 'consum', 0.0223, 'lps'),
	(379434, 123, '2015-02-01 00:12:19.000000', 'consum', 0.0211, 'lps'),
	(379435, 123, '2015-02-01 00:12:20.000000', 'consum', 0.0210, 'lps'),
	(379436, 123, '2015-02-01 00:12:21.000000', 'consum', 0.0223, 'lps'),
	(379437, 123, '2015-02-01 00:12:22.000000', 'consum', 0.0211, 'lps'),
	(379438, 123, '2015-02-01 00:12:23.000000', 'consum', 0.0225, 'lps'),
	(379439, 123, '2015-02-01 00:12:24.000000', 'consum', 0.0215, 'lps'),
	(379440, 123, '2015-02-01 00:12:25.000000', 'consum', 0.0225, 'lps'),
	(379441, 123, '2015-02-01 00:12:26.000000', 'consum', 0.0221, 'lps'),
	(379442, 123, '2015-02-01 00:12:27.000000', 'consum', 0.0220, 'lps'),
	(379443, 123, '2015-02-01 00:12:28.000000', 'consum', 0.0225, 'lps'),
	(379444, 123, '2015-02-01 00:12:29.000000', 'consum', 0.0223, 'lps'),
	(379445, 123, '2015-02-01 00:12:30.000000', 'consum', 0.0214, 'lps'),
	(379446, 123, '2015-02-01 00:12:31.000000', 'consum', 0.0226, 'lps'),
	(379447, 123, '2015-02-01 00:12:32.000000', 'consum', 0.0211, 'lps'),
	(379448, 123, '2015-02-01 00:12:33.000000', 'consum', 0.0220, 'lps'),
	(379449, 123, '2015-02-01 00:12:34.000000', 'consum', 0.0221, 'lps'),
	(379450, 123, '2015-02-01 00:12:35.000000', 'consum', 0.0220, 'lps'),
	(379451, 123, '2015-02-01 00:12:36.000000', 'consum', 0.0210, 'lps'),
	(379452, 123, '2015-02-01 00:12:37.000000', 'consum', 0.0214, 'lps'),
	(379453, 123, '2015-02-01 00:12:38.000000', 'consum', 0.0216, 'lps'),
	(379454, 123, '2015-02-01 00:12:39.000000', 'consum', 0.0226, 'lps'),
	(379455, 123, '2015-02-01 00:12:40.000000', 'consum', 0.0223, 'lps'),
	(379456, 123, '2015-02-01 00:12:41.000000', 'consum', 0.0212, 'lps'),
	(379457, 123, '2015-02-01 00:12:42.000000', 'consum', 0.0213, 'lps'),
	(379458, 123, '2015-02-01 00:12:43.000000', 'consum', 0.0220, 'lps'),
	(379459, 123, '2015-02-01 00:12:44.000000', 'consum', 0.0216, 'lps'),
	(379460, 123, '2015-02-01 00:12:45.000000', 'consum', 0.0210, 'lps'),
	(379461, 123, '2015-02-01 00:12:46.000000', 'consum', 0.0210, 'lps'),
	(379462, 123, '2015-02-01 00:12:47.000000', 'consum', 0.0211, 'lps'),
	(379463, 123, '2015-02-01 00:12:48.000000', 'consum', 0.0217, 'lps'),
	(379464, 123, '2015-02-01 00:12:49.000000', 'consum', 0.0226, 'lps'),
	(379465, 123, '2015-02-01 00:12:50.000000', 'consum', 0.0219, 'lps'),
	(379466, 123, '2015-02-01 00:12:51.000000', 'consum', 0.0224, 'lps'),
	(379467, 123, '2015-02-01 00:12:52.000000', 'consum', 0.0219, 'lps'),
	(379468, 123, '2015-02-01 00:12:53.000000', 'consum', 0.0213, 'lps'),
	(379469, 123, '2015-02-01 00:12:54.000000', 'consum', 0.0217, 'lps'),
	(379470, 123, '2015-02-01 00:12:55.000000', 'consum', 0.0220, 'lps'),
	(379471, 123, '2015-02-01 00:12:56.000000', 'consum', 0.0221, 'lps'),
	(379472, 123, '2015-02-01 00:12:57.000000', 'consum', 0.0220, 'lps'),
	(379473, 123, '2015-02-01 00:12:58.000000', 'consum', 0.0226, 'lps'),
	(379474, 123, '2015-02-01 00:12:59.000000', 'consum', 0.0210, 'lps'),
	(379475, 123, '2015-02-01 00:13:00.000000', 'consum', 0.0211, 'lps'),
	(379476, 123, '2015-02-01 00:13:01.000000', 'consum', 0.0219, 'lps'),
	(379477, 123, '2015-02-01 00:13:02.000000', 'consum', 0.0219, 'lps'),
	(379478, 123, '2015-02-01 00:13:03.000000', 'consum', 0.0226, 'lps'),
	(379479, 123, '2015-02-01 00:13:04.000000', 'consum', 0.0211, 'lps'),
	(379480, 123, '2015-02-01 00:13:05.000000', 'consum', 0.0222, 'lps'),
	(379481, 123, '2015-02-01 00:13:06.000000', 'consum', 0.0216, 'lps'),
	(379482, 123, '2015-02-01 00:13:07.000000', 'consum', 0.0219, 'lps'),
	(379483, 123, '2015-02-01 00:13:08.000000', 'consum', 0.0221, 'lps'),
	(379484, 123, '2015-02-01 00:13:09.000000', 'consum', 0.0223, 'lps'),
	(379485, 123, '2015-02-01 00:13:10.000000', 'consum', 0.0226, 'lps'),
	(379486, 123, '2015-02-01 00:13:11.000000', 'consum', 0.0218, 'lps'),
	(379487, 123, '2015-02-01 00:13:12.000000', 'consum', 0.0217, 'lps'),
	(379488, 123, '2015-02-01 00:13:13.000000', 'consum', 0.0223, 'lps'),
	(379489, 123, '2015-02-01 00:13:14.000000', 'consum', 0.0222, 'lps'),
	(379490, 123, '2015-02-01 00:13:15.000000', 'consum', 0.0211, 'lps'),
	(379491, 123, '2015-02-01 00:13:16.000000', 'consum', 0.0217, 'lps'),
	(379492, 123, '2015-02-01 00:13:17.000000', 'consum', 0.0224, 'lps'),
	(379493, 123, '2015-02-01 00:13:18.000000', 'consum', 0.0226, 'lps'),
	(379494, 123, '2015-02-01 00:13:19.000000', 'consum', 0.0213, 'lps'),
	(379495, 123, '2015-02-01 00:13:20.000000', 'consum', 0.0214, 'lps'),
	(379496, 123, '2015-02-01 00:13:21.000000', 'consum', 0.0219, 'lps'),
	(379497, 123, '2015-02-01 00:13:22.000000', 'consum', 0.0211, 'lps'),
	(379498, 123, '2015-02-01 00:13:23.000000', 'consum', 0.0224, 'lps'),
	(379499, 123, '2015-02-01 00:13:24.000000', 'consum', 0.0224, 'lps'),
	(379500, 123, '2015-02-01 00:13:25.000000', 'consum', 0.0223, 'lps'),
	(379501, 123, '2015-02-01 00:13:26.000000', 'consum', 0.0217, 'lps'),
	(379502, 123, '2015-02-01 00:13:27.000000', 'consum', 0.0222, 'lps'),
	(379503, 123, '2015-02-01 00:13:28.000000', 'consum', 0.0218, 'lps'),
	(379504, 123, '2015-02-01 00:13:29.000000', 'consum', 0.0213, 'lps'),
	(379505, 123, '2015-02-01 00:13:30.000000', 'consum', 0.0221, 'lps'),
	(379506, 123, '2015-02-01 00:13:31.000000', 'consum', 0.0219, 'lps'),
	(379507, 123, '2015-02-01 00:13:32.000000', 'consum', 0.0223, 'lps'),
	(379508, 123, '2015-02-01 00:13:33.000000', 'consum', 0.0215, 'lps'),
	(379509, 123, '2015-02-01 00:13:34.000000', 'consum', 0.0214, 'lps'),
	(379510, 123, '2015-02-01 00:13:35.000000', 'consum', 0.0214, 'lps'),
	(379511, 123, '2015-02-01 00:13:36.000000', 'consum', 0.0220, 'lps'),
	(379512, 123, '2015-02-01 00:13:37.000000', 'consum', 0.0212, 'lps'),
	(379513, 123, '2015-02-01 00:13:38.000000', 'consum', 0.0226, 'lps'),
	(379514, 123, '2015-02-01 00:13:39.000000', 'consum', 0.0217, 'lps'),
	(379515, 123, '2015-02-01 00:13:40.000000', 'consum', 0.0214, 'lps'),
	(379516, 123, '2015-02-01 00:13:41.000000', 'consum', 0.0211, 'lps'),
	(379517, 123, '2015-02-01 00:13:42.000000', 'consum', 0.0220, 'lps'),
	(379518, 123, '2015-02-01 00:13:43.000000', 'consum', 0.0222, 'lps'),
	(379519, 123, '2015-02-01 00:13:44.000000', 'consum', 0.0225, 'lps'),
	(379520, 123, '2015-02-01 00:13:45.000000', 'consum', 0.0217, 'lps'),
	(379521, 123, '2015-02-01 00:13:46.000000', 'consum', 0.0216, 'lps'),
	(379522, 123, '2015-02-01 00:13:47.000000', 'consum', 0.0218, 'lps'),
	(379523, 123, '2015-02-01 00:13:48.000000', 'consum', 0.0217, 'lps'),
	(379524, 123, '2015-02-01 00:13:49.000000', 'consum', 0.0221, 'lps'),
	(379525, 123, '2015-02-01 00:13:50.000000', 'consum', 0.0210, 'lps'),
	(379526, 123, '2015-02-01 00:13:51.000000', 'consum', 0.0213, 'lps'),
	(379527, 123, '2015-02-01 00:13:52.000000', 'consum', 0.0225, 'lps'),
	(379528, 123, '2015-02-01 00:13:53.000000', 'consum', 0.0224, 'lps'),
	(379529, 123, '2015-02-01 00:13:54.000000', 'consum', 0.0221, 'lps'),
	(379530, 123, '2015-02-01 00:13:55.000000', 'consum', 0.0221, 'lps'),
	(379531, 123, '2015-02-01 00:13:56.000000', 'consum', 0.0215, 'lps'),
	(379532, 123, '2015-02-01 00:13:57.000000', 'consum', 0.0221, 'lps'),
	(379533, 123, '2015-02-01 00:13:58.000000', 'consum', 0.0214, 'lps'),
	(379534, 123, '2015-02-01 00:13:59.000000', 'consum', 0.0217, 'lps'),
	(379535, 123, '2015-02-01 00:14:00.000000', 'consum', 0.0215, 'lps'),
	(379536, 123, '2015-02-01 00:14:01.000000', 'consum', 0.0216, 'lps'),
	(379537, 123, '2015-02-01 00:14:02.000000', 'consum', 0.0226, 'lps'),
	(379538, 123, '2015-02-01 00:14:03.000000', 'consum', 0.0221, 'lps'),
	(379539, 123, '2015-02-01 00:14:04.000000', 'consum', 0.0217, 'lps'),
	(379540, 123, '2015-02-01 00:14:05.000000', 'consum', 0.0212, 'lps'),
	(379541, 123, '2015-02-01 00:14:06.000000', 'consum', 0.0218, 'lps'),
	(379542, 123, '2015-02-01 00:14:07.000000', 'consum', 0.0210, 'lps'),
	(379543, 123, '2015-02-01 00:14:08.000000', 'consum', 0.0219, 'lps'),
	(379544, 123, '2015-02-01 00:14:09.000000', 'consum', 0.0224, 'lps'),
	(379545, 123, '2015-02-01 00:14:10.000000', 'consum', 0.0220, 'lps'),
	(379546, 123, '2015-02-01 00:14:11.000000', 'consum', 0.0218, 'lps'),
	(379547, 123, '2015-02-01 00:14:12.000000', 'consum', 0.0221, 'lps'),
	(379548, 123, '2015-02-01 00:14:13.000000', 'consum', 0.0223, 'lps'),
	(379549, 123, '2015-02-01 00:14:14.000000', 'consum', 0.0225, 'lps'),
	(379550, 123, '2015-02-01 00:14:15.000000', 'consum', 0.0213, 'lps'),
	(379551, 123, '2015-02-01 00:14:16.000000', 'consum', 0.0217, 'lps'),
	(379552, 123, '2015-02-01 00:14:17.000000', 'consum', 0.0216, 'lps'),
	(379553, 123, '2015-02-01 00:14:18.000000', 'consum', 0.0222, 'lps'),
	(379554, 123, '2015-02-01 00:14:19.000000', 'consum', 0.0217, 'lps'),
	(379555, 123, '2015-02-01 00:14:20.000000', 'consum', 0.0210, 'lps'),
	(379556, 123, '2015-02-01 00:14:21.000000', 'consum', 0.0222, 'lps'),
	(379557, 123, '2015-02-01 00:14:22.000000', 'consum', 0.0220, 'lps'),
	(379558, 123, '2015-02-01 00:14:23.000000', 'consum', 0.0223, 'lps'),
	(379559, 123, '2015-02-01 00:14:24.000000', 'consum', 0.0214, 'lps'),
	(379560, 123, '2015-02-01 00:14:25.000000', 'consum', 0.0225, 'lps'),
	(379561, 123, '2015-02-01 00:14:26.000000', 'consum', 0.0224, 'lps'),
	(379562, 123, '2015-02-01 00:14:27.000000', 'consum', 0.0215, 'lps'),
	(379563, 123, '2015-02-01 00:14:28.000000', 'consum', 0.0214, 'lps'),
	(379564, 123, '2015-02-01 00:14:29.000000', 'consum', 0.0213, 'lps'),
	(379565, 123, '2015-02-01 00:14:30.000000', 'consum', 0.0216, 'lps'),
	(379566, 123, '2015-02-01 00:14:31.000000', 'consum', 0.0214, 'lps'),
	(379567, 123, '2015-02-01 00:14:32.000000', 'consum', 0.0212, 'lps'),
	(379568, 123, '2015-02-01 00:14:33.000000', 'consum', 0.0225, 'lps'),
	(379569, 123, '2015-02-01 00:14:34.000000', 'consum', 0.0212, 'lps'),
	(379570, 123, '2015-02-01 00:14:35.000000', 'consum', 0.0225, 'lps'),
	(379571, 123, '2015-02-01 00:14:36.000000', 'consum', 0.0212, 'lps'),
	(379572, 123, '2015-02-01 00:14:37.000000', 'consum', 0.0212, 'lps'),
	(379573, 123, '2015-02-01 00:14:38.000000', 'consum', 0.0213, 'lps'),
	(379574, 123, '2015-02-01 00:14:39.000000', 'consum', 0.0219, 'lps'),
	(379575, 123, '2015-02-01 00:14:40.000000', 'consum', 0.0212, 'lps'),
	(379576, 123, '2015-02-01 00:14:41.000000', 'consum', 0.0212, 'lps'),
	(379577, 123, '2015-02-01 00:14:42.000000', 'consum', 0.0215, 'lps'),
	(379578, 123, '2015-02-01 00:14:43.000000', 'consum', 0.0211, 'lps'),
	(379579, 123, '2015-02-01 00:14:44.000000', 'consum', 0.0219, 'lps'),
	(379580, 123, '2015-02-01 00:14:45.000000', 'consum', 0.0217, 'lps'),
	(379581, 123, '2015-02-01 00:14:46.000000', 'consum', 0.0221, 'lps'),
	(379582, 123, '2015-02-01 00:14:47.000000', 'consum', 0.0225, 'lps'),
	(379583, 123, '2015-02-01 00:14:48.000000', 'consum', 0.0219, 'lps'),
	(379584, 123, '2015-02-01 00:14:49.000000', 'consum', 0.0210, 'lps'),
	(379585, 123, '2015-02-01 00:14:50.000000', 'consum', 0.0220, 'lps'),
	(379586, 123, '2015-02-01 00:14:51.000000', 'consum', 0.0223, 'lps'),
	(379587, 123, '2015-02-01 00:14:52.000000', 'consum', 0.0215, 'lps'),
	(379588, 123, '2015-02-01 00:14:53.000000', 'consum', 0.0211, 'lps'),
	(379589, 123, '2015-02-01 00:14:54.000000', 'consum', 0.0219, 'lps'),
	(379590, 123, '2015-02-01 00:14:55.000000', 'consum', 0.0216, 'lps'),
	(379591, 123, '2015-02-01 00:14:56.000000', 'consum', 0.0217, 'lps'),
	(379592, 123, '2015-02-01 00:14:57.000000', 'consum', 0.0224, 'lps'),
	(379593, 123, '2015-02-01 00:14:58.000000', 'consum', 0.0212, 'lps'),
	(379594, 123, '2015-02-01 00:14:59.000000', 'consum', 0.0226, 'lps'),
	(379595, 123, '2015-02-01 00:15:00.000000', 'consum', 0.0219, 'lps'),
	(379596, 123, '2015-02-01 00:15:01.000000', 'consum', 0.0223, 'lps'),
	(379597, 123, '2015-02-01 00:15:02.000000', 'consum', 0.0214, 'lps'),
	(379598, 123, '2015-02-01 00:15:03.000000', 'consum', 0.0226, 'lps'),
	(379599, 123, '2015-02-01 00:15:04.000000', 'consum', 0.0211, 'lps'),
	(379600, 123, '2015-02-01 00:15:05.000000', 'consum', 0.0220, 'lps'),
	(379601, 123, '2015-02-01 00:15:06.000000', 'consum', 0.0223, 'lps'),
	(379602, 123, '2015-02-01 00:15:07.000000', 'consum', 0.0212, 'lps'),
	(379603, 123, '2015-02-01 00:15:08.000000', 'consum', 0.0213, 'lps'),
	(379604, 123, '2015-02-01 00:15:09.000000', 'consum', 0.0222, 'lps'),
	(379605, 123, '2015-02-01 00:15:10.000000', 'consum', 0.0210, 'lps'),
	(379606, 123, '2015-02-01 00:15:11.000000', 'consum', 0.0210, 'lps'),
	(379607, 123, '2015-02-01 00:15:12.000000', 'consum', 0.0225, 'lps'),
	(379608, 123, '2015-02-01 00:15:13.000000', 'consum', 0.0216, 'lps'),
	(379609, 123, '2015-02-01 00:15:14.000000', 'consum', 0.0216, 'lps'),
	(379610, 123, '2015-02-01 00:15:15.000000', 'consum', 0.0219, 'lps'),
	(379611, 123, '2015-02-01 00:15:16.000000', 'consum', 0.0224, 'lps'),
	(379612, 123, '2015-02-01 00:15:17.000000', 'consum', 0.0219, 'lps'),
	(379613, 123, '2015-02-01 00:15:18.000000', 'consum', 0.0211, 'lps'),
	(379614, 123, '2015-02-01 00:15:19.000000', 'consum', 0.0224, 'lps'),
	(379615, 123, '2015-02-01 00:15:20.000000', 'consum', 0.0226, 'lps'),
	(379616, 123, '2015-02-01 00:15:21.000000', 'consum', 0.0216, 'lps'),
	(379617, 123, '2015-02-01 00:15:22.000000', 'consum', 0.0224, 'lps'),
	(379618, 123, '2015-02-01 00:15:23.000000', 'consum', 0.0213, 'lps'),
	(379619, 123, '2015-02-01 00:15:24.000000', 'consum', 0.0219, 'lps'),
	(379620, 123, '2015-02-01 00:15:25.000000', 'consum', 0.0213, 'lps'),
	(379621, 123, '2015-02-01 00:15:26.000000', 'consum', 0.0213, 'lps'),
	(379622, 123, '2015-02-01 00:15:27.000000', 'consum', 0.0216, 'lps'),
	(379623, 123, '2015-02-01 00:15:28.000000', 'consum', 0.0216, 'lps'),
	(379624, 123, '2015-02-01 00:15:29.000000', 'consum', 0.0221, 'lps'),
	(379625, 123, '2015-02-01 00:15:30.000000', 'consum', 0.0215, 'lps'),
	(379626, 123, '2015-02-01 00:15:31.000000', 'consum', 0.0220, 'lps'),
	(379627, 123, '2015-02-01 00:15:32.000000', 'consum', 0.0211, 'lps'),
	(379628, 123, '2015-02-01 00:15:33.000000', 'consum', 0.0221, 'lps'),
	(379629, 123, '2015-02-01 00:15:34.000000', 'consum', 0.0226, 'lps'),
	(379630, 123, '2015-02-01 00:15:35.000000', 'consum', 0.0222, 'lps'),
	(379631, 123, '2015-02-01 00:15:36.000000', 'consum', 0.0226, 'lps'),
	(379632, 123, '2015-02-01 00:15:37.000000', 'consum', 0.0220, 'lps'),
	(379633, 123, '2015-02-01 00:15:38.000000', 'consum', 0.0210, 'lps'),
	(379634, 123, '2015-02-01 00:15:39.000000', 'consum', 0.0215, 'lps'),
	(379635, 123, '2015-02-01 00:15:40.000000', 'consum', 0.0220, 'lps'),
	(379636, 123, '2015-02-01 00:15:41.000000', 'consum', 0.0212, 'lps'),
	(379637, 123, '2015-02-01 00:15:42.000000', 'consum', 0.0225, 'lps'),
	(379638, 123, '2015-02-01 00:15:43.000000', 'consum', 0.0211, 'lps'),
	(379639, 123, '2015-02-01 00:15:44.000000', 'consum', 0.0223, 'lps'),
	(379640, 123, '2015-02-01 00:15:45.000000', 'consum', 0.0218, 'lps'),
	(379641, 123, '2015-02-01 00:15:46.000000', 'consum', 0.0214, 'lps'),
	(379642, 123, '2015-02-01 00:15:47.000000', 'consum', 0.0223, 'lps'),
	(379643, 123, '2015-02-01 00:15:48.000000', 'consum', 0.0214, 'lps'),
	(379644, 123, '2015-02-01 00:15:49.000000', 'consum', 0.0223, 'lps'),
	(379645, 123, '2015-02-01 00:15:50.000000', 'consum', 0.0214, 'lps'),
	(379646, 123, '2015-02-01 00:15:51.000000', 'consum', 0.0224, 'lps'),
	(379647, 123, '2015-02-01 00:15:52.000000', 'consum', 0.0219, 'lps'),
	(379648, 123, '2015-02-01 00:15:53.000000', 'consum', 0.0214, 'lps'),
	(379649, 123, '2015-02-01 00:15:54.000000', 'consum', 0.0220, 'lps'),
	(379650, 123, '2015-02-01 00:15:55.000000', 'consum', 0.0215, 'lps'),
	(379651, 123, '2015-02-01 00:15:56.000000', 'consum', 0.0221, 'lps'),
	(379652, 123, '2015-02-01 00:15:57.000000', 'consum', 0.0219, 'lps'),
	(379653, 123, '2015-02-01 00:15:58.000000', 'consum', 0.0222, 'lps'),
	(379654, 123, '2015-02-01 00:15:59.000000', 'consum', 0.0210, 'lps'),
	(379655, 123, '2015-02-01 00:16:00.000000', 'consum', 0.0223, 'lps'),
	(379656, 123, '2015-02-01 00:16:01.000000', 'consum', 0.0226, 'lps'),
	(379657, 123, '2015-02-01 00:16:02.000000', 'consum', 0.0218, 'lps'),
	(379658, 123, '2015-02-01 00:16:03.000000', 'consum', 0.0221, 'lps'),
	(379659, 123, '2015-02-01 00:16:04.000000', 'consum', 0.0222, 'lps'),
	(379660, 123, '2015-02-01 00:16:05.000000', 'consum', 0.0222, 'lps'),
	(379661, 123, '2015-02-01 00:16:06.000000', 'consum', 0.0218, 'lps'),
	(379662, 123, '2015-02-01 00:16:07.000000', 'consum', 0.0212, 'lps'),
	(379663, 123, '2015-02-01 00:16:08.000000', 'consum', 0.0216, 'lps'),
	(379664, 123, '2015-02-01 00:16:09.000000', 'consum', 0.0216, 'lps'),
	(379665, 123, '2015-02-01 00:16:10.000000', 'consum', 0.0222, 'lps'),
	(379666, 123, '2015-02-01 00:16:11.000000', 'consum', 0.0217, 'lps'),
	(379667, 123, '2015-02-01 00:16:12.000000', 'consum', 0.0212, 'lps'),
	(379668, 123, '2015-02-01 00:16:13.000000', 'consum', 0.0217, 'lps'),
	(379669, 123, '2015-02-01 00:16:14.000000', 'consum', 0.0220, 'lps'),
	(379670, 123, '2015-02-01 00:16:15.000000', 'consum', 0.0223, 'lps'),
	(379671, 123, '2015-02-01 00:16:16.000000', 'consum', 0.0211, 'lps'),
	(379672, 123, '2015-02-01 00:16:17.000000', 'consum', 0.0212, 'lps'),
	(379673, 123, '2015-02-01 00:16:18.000000', 'consum', 0.0215, 'lps'),
	(379674, 123, '2015-02-01 00:16:19.000000', 'consum', 0.0214, 'lps'),
	(379675, 123, '2015-02-01 00:16:20.000000', 'consum', 0.0215, 'lps'),
	(379676, 123, '2015-02-01 00:16:21.000000', 'consum', 0.0222, 'lps'),
	(379677, 123, '2015-02-01 00:16:22.000000', 'consum', 0.0224, 'lps'),
	(379678, 123, '2015-02-01 00:16:23.000000', 'consum', 0.0226, 'lps'),
	(379679, 123, '2015-02-01 00:16:24.000000', 'consum', 0.0216, 'lps'),
	(379680, 123, '2015-02-01 00:16:25.000000', 'consum', 0.0224, 'lps'),
	(379681, 123, '2015-02-01 00:16:26.000000', 'consum', 0.0215, 'lps'),
	(379682, 123, '2015-02-01 00:16:27.000000', 'consum', 0.0224, 'lps'),
	(379683, 123, '2015-02-01 00:16:28.000000', 'consum', 0.0216, 'lps'),
	(379684, 123, '2015-02-01 00:16:29.000000', 'consum', 0.0216, 'lps'),
	(379685, 123, '2015-02-01 00:16:30.000000', 'consum', 0.0221, 'lps'),
	(379686, 123, '2015-02-01 00:16:31.000000', 'consum', 0.0214, 'lps'),
	(379687, 123, '2015-02-01 00:16:32.000000', 'consum', 0.0215, 'lps'),
	(379688, 123, '2015-02-01 00:16:33.000000', 'consum', 0.0221, 'lps'),
	(379689, 123, '2015-02-01 00:16:34.000000', 'consum', 0.0220, 'lps'),
	(379690, 123, '2015-02-01 00:16:35.000000', 'consum', 0.0226, 'lps'),
	(379691, 123, '2015-02-01 00:16:36.000000', 'consum', 0.0225, 'lps'),
	(379692, 123, '2015-02-01 00:16:37.000000', 'consum', 0.0220, 'lps'),
	(379693, 123, '2015-02-01 00:16:38.000000', 'consum', 0.0218, 'lps'),
	(379694, 123, '2015-02-01 00:16:39.000000', 'consum', 0.0220, 'lps'),
	(379695, 123, '2015-02-01 00:16:40.000000', 'consum', 0.0220, 'lps'),
	(379696, 123, '2015-02-01 00:16:41.000000', 'consum', 0.0214, 'lps'),
	(379697, 123, '2015-02-01 00:16:42.000000', 'consum', 0.0218, 'lps'),
	(379698, 123, '2015-02-01 00:16:43.000000', 'consum', 0.0221, 'lps'),
	(379699, 123, '2015-02-01 00:16:44.000000', 'consum', 0.0222, 'lps'),
	(379700, 123, '2015-02-01 00:16:45.000000', 'consum', 0.0223, 'lps'),
	(379701, 123, '2015-02-01 00:16:46.000000', 'consum', 0.0221, 'lps'),
	(379702, 123, '2015-02-01 00:16:47.000000', 'consum', 0.0225, 'lps'),
	(379703, 123, '2015-02-01 00:16:48.000000', 'consum', 0.0222, 'lps'),
	(379704, 123, '2015-02-01 00:16:49.000000', 'consum', 0.0223, 'lps'),
	(379705, 123, '2015-02-01 00:16:50.000000', 'consum', 0.0224, 'lps'),
	(379706, 123, '2015-02-01 00:16:51.000000', 'consum', 0.0222, 'lps'),
	(379707, 123, '2015-02-01 00:16:52.000000', 'consum', 0.0213, 'lps'),
	(379708, 123, '2015-02-01 00:16:53.000000', 'consum', 0.0222, 'lps'),
	(379709, 123, '2015-02-01 00:16:54.000000', 'consum', 0.0210, 'lps'),
	(379710, 123, '2015-02-01 00:16:55.000000', 'consum', 0.0225, 'lps'),
	(379711, 123, '2015-02-01 00:16:56.000000', 'consum', 0.0217, 'lps'),
	(379712, 123, '2015-02-01 00:16:57.000000', 'consum', 0.0217, 'lps'),
	(379713, 123, '2015-02-01 00:16:58.000000', 'consum', 0.0211, 'lps'),
	(379714, 123, '2015-02-01 00:16:59.000000', 'consum', 0.0225, 'lps'),
	(379715, 123, '2015-02-01 00:17:00.000000', 'consum', 0.0215, 'lps'),
	(379716, 123, '2015-02-01 00:17:01.000000', 'consum', 0.0224, 'lps'),
	(379717, 123, '2015-02-01 00:17:02.000000', 'consum', 0.0213, 'lps'),
	(379718, 123, '2015-02-01 00:17:03.000000', 'consum', 0.0220, 'lps'),
	(379719, 123, '2015-02-01 00:17:04.000000', 'consum', 0.0217, 'lps'),
	(379720, 123, '2015-02-01 00:17:05.000000', 'consum', 0.0216, 'lps'),
	(379721, 123, '2015-02-01 00:17:06.000000', 'consum', 0.0219, 'lps'),
	(379722, 123, '2015-02-01 00:17:07.000000', 'consum', 0.0218, 'lps'),
	(379723, 123, '2015-02-01 00:17:08.000000', 'consum', 0.0210, 'lps'),
	(379724, 123, '2015-02-01 00:17:09.000000', 'consum', 0.0221, 'lps'),
	(379725, 123, '2015-02-01 00:17:10.000000', 'consum', 0.0212, 'lps'),
	(379726, 123, '2015-02-01 00:17:11.000000', 'consum', 0.0222, 'lps'),
	(379727, 123, '2015-02-01 00:17:12.000000', 'consum', 0.0214, 'lps'),
	(379728, 123, '2015-02-01 00:17:13.000000', 'consum', 0.0211, 'lps'),
	(379729, 123, '2015-02-01 00:17:14.000000', 'consum', 0.0220, 'lps'),
	(379730, 123, '2015-02-01 00:17:15.000000', 'consum', 0.0223, 'lps'),
	(379731, 123, '2015-02-01 00:17:16.000000', 'consum', 0.0211, 'lps'),
	(379732, 123, '2015-02-01 00:17:17.000000', 'consum', 0.0213, 'lps'),
	(379733, 123, '2015-02-01 00:17:18.000000', 'consum', 0.0223, 'lps'),
	(379734, 123, '2015-02-01 00:17:19.000000', 'consum', 0.0214, 'lps'),
	(379735, 123, '2015-02-01 00:17:20.000000', 'consum', 0.0211, 'lps'),
	(379736, 123, '2015-02-01 00:17:21.000000', 'consum', 0.0217, 'lps'),
	(379737, 123, '2015-02-01 00:17:22.000000', 'consum', 0.0212, 'lps'),
	(379738, 123, '2015-02-01 00:17:23.000000', 'consum', 0.0214, 'lps'),
	(379739, 123, '2015-02-01 00:17:24.000000', 'consum', 0.0226, 'lps'),
	(379740, 123, '2015-02-01 00:17:25.000000', 'consum', 0.0226, 'lps'),
	(379741, 123, '2015-02-01 00:17:26.000000', 'consum', 0.0210, 'lps'),
	(379742, 123, '2015-02-01 00:17:27.000000', 'consum', 0.0211, 'lps'),
	(379743, 123, '2015-02-01 00:17:28.000000', 'consum', 0.0218, 'lps'),
	(379744, 123, '2015-02-01 00:17:29.000000', 'consum', 0.0214, 'lps'),
	(379745, 123, '2015-02-01 00:17:30.000000', 'consum', 0.0223, 'lps'),
	(379746, 123, '2015-02-01 00:17:31.000000', 'consum', 0.0213, 'lps'),
	(379747, 123, '2015-02-01 00:17:32.000000', 'consum', 0.0219, 'lps'),
	(379748, 123, '2015-02-01 00:17:33.000000', 'consum', 0.0213, 'lps'),
	(379749, 123, '2015-02-01 00:17:34.000000', 'consum', 0.0216, 'lps'),
	(379750, 123, '2015-02-01 00:17:35.000000', 'consum', 0.0212, 'lps'),
	(379751, 123, '2015-02-01 00:17:36.000000', 'consum', 0.0222, 'lps'),
	(379752, 123, '2015-02-01 00:17:37.000000', 'consum', 0.0214, 'lps'),
	(379753, 123, '2015-02-01 00:17:38.000000', 'consum', 0.0210, 'lps'),
	(379754, 123, '2015-02-01 00:17:39.000000', 'consum', 0.0217, 'lps'),
	(379755, 123, '2015-02-01 00:17:40.000000', 'consum', 0.0226, 'lps'),
	(379756, 123, '2015-02-01 00:17:41.000000', 'consum', 0.0219, 'lps'),
	(379757, 123, '2015-02-01 00:17:42.000000', 'consum', 0.0224, 'lps'),
	(379758, 123, '2015-02-01 00:17:43.000000', 'consum', 0.0218, 'lps'),
	(379759, 123, '2015-02-01 00:17:44.000000', 'consum', 0.0211, 'lps'),
	(379760, 123, '2015-02-01 00:17:45.000000', 'consum', 0.0226, 'lps'),
	(379761, 123, '2015-02-01 00:17:46.000000', 'consum', 0.0219, 'lps'),
	(379762, 123, '2015-02-01 00:17:47.000000', 'consum', 0.0225, 'lps'),
	(379763, 123, '2015-02-01 00:17:48.000000', 'consum', 0.0222, 'lps'),
	(379764, 123, '2015-02-01 00:17:49.000000', 'consum', 0.0210, 'lps'),
	(379765, 123, '2015-02-01 00:17:50.000000', 'consum', 0.0224, 'lps'),
	(379766, 123, '2015-02-01 00:17:51.000000', 'consum', 0.0212, 'lps'),
	(379767, 123, '2015-02-01 00:17:52.000000', 'consum', 0.0215, 'lps'),
	(379768, 123, '2015-02-01 00:17:53.000000', 'consum', 0.0212, 'lps'),
	(379769, 123, '2015-02-01 00:17:54.000000', 'consum', 0.0220, 'lps'),
	(379770, 123, '2015-02-01 00:17:55.000000', 'consum', 0.0222, 'lps'),
	(379771, 123, '2015-02-01 00:17:56.000000', 'consum', 0.0225, 'lps'),
	(379772, 123, '2015-02-01 00:17:57.000000', 'consum', 0.0214, 'lps'),
	(379773, 123, '2015-02-01 00:17:58.000000', 'consum', 0.0219, 'lps'),
	(379774, 123, '2015-02-01 00:17:59.000000', 'consum', 0.0225, 'lps'),
	(379775, 123, '2015-02-01 00:18:00.000000', 'consum', 0.0211, 'lps'),
	(379776, 123, '2015-02-01 00:18:01.000000', 'consum', 0.0220, 'lps'),
	(379777, 123, '2015-02-01 00:18:02.000000', 'consum', 0.0225, 'lps'),
	(379778, 123, '2015-02-01 00:18:03.000000', 'consum', 0.0222, 'lps'),
	(379779, 123, '2015-02-01 00:18:04.000000', 'consum', 0.0226, 'lps'),
	(379780, 123, '2015-02-01 00:18:05.000000', 'consum', 0.0220, 'lps'),
	(379781, 123, '2015-02-01 00:18:06.000000', 'consum', 0.0212, 'lps'),
	(379782, 123, '2015-02-01 00:18:07.000000', 'consum', 0.0225, 'lps'),
	(379783, 123, '2015-02-01 00:18:08.000000', 'consum', 0.0213, 'lps'),
	(379784, 123, '2015-02-01 00:18:09.000000', 'consum', 0.0213, 'lps'),
	(379785, 123, '2015-02-01 00:18:10.000000', 'consum', 0.0216, 'lps'),
	(379786, 123, '2015-02-01 00:18:11.000000', 'consum', 0.0215, 'lps'),
	(379787, 123, '2015-02-01 00:18:12.000000', 'consum', 0.0216, 'lps'),
	(379788, 123, '2015-02-01 00:18:13.000000', 'consum', 0.0210, 'lps'),
	(379789, 123, '2015-02-01 00:18:14.000000', 'consum', 0.0210, 'lps'),
	(379790, 123, '2015-02-01 00:18:15.000000', 'consum', 0.0212, 'lps'),
	(379791, 123, '2015-02-01 00:18:16.000000', 'consum', 0.0218, 'lps'),
	(379792, 123, '2015-02-01 00:18:17.000000', 'consum', 0.0210, 'lps'),
	(379793, 123, '2015-02-01 00:18:18.000000', 'consum', 0.0220, 'lps'),
	(379794, 123, '2015-02-01 00:18:19.000000', 'consum', 0.0212, 'lps'),
	(379795, 123, '2015-02-01 00:18:20.000000', 'consum', 0.0223, 'lps'),
	(379796, 123, '2015-02-01 00:18:21.000000', 'consum', 0.0218, 'lps'),
	(379797, 123, '2015-02-01 00:18:22.000000', 'consum', 0.0214, 'lps'),
	(379798, 123, '2015-02-01 00:18:23.000000', 'consum', 0.0220, 'lps'),
	(379799, 123, '2015-02-01 00:18:24.000000', 'consum', 0.0216, 'lps'),
	(379800, 123, '2015-02-01 00:18:25.000000', 'consum', 0.0212, 'lps'),
	(379801, 123, '2015-02-01 00:18:26.000000', 'consum', 0.0218, 'lps'),
	(379802, 123, '2015-02-01 00:18:27.000000', 'consum', 0.0210, 'lps'),
	(379803, 123, '2015-02-01 00:18:28.000000', 'consum', 0.0221, 'lps'),
	(379804, 123, '2015-02-01 00:18:29.000000', 'consum', 0.0215, 'lps'),
	(379805, 123, '2015-02-01 00:18:30.000000', 'consum', 0.0219, 'lps'),
	(379806, 123, '2015-02-01 00:18:31.000000', 'consum', 0.0223, 'lps'),
	(379807, 123, '2015-02-01 00:18:32.000000', 'consum', 0.0214, 'lps'),
	(379808, 123, '2015-02-01 00:18:33.000000', 'consum', 0.0210, 'lps'),
	(379809, 123, '2015-02-01 00:18:34.000000', 'consum', 0.0217, 'lps'),
	(379810, 123, '2015-02-01 00:18:35.000000', 'consum', 0.0225, 'lps'),
	(379811, 123, '2015-02-01 00:18:36.000000', 'consum', 0.0216, 'lps'),
	(379812, 123, '2015-02-01 00:18:37.000000', 'consum', 0.0211, 'lps'),
	(379813, 123, '2015-02-01 00:18:38.000000', 'consum', 0.0217, 'lps'),
	(379814, 123, '2015-02-01 00:18:39.000000', 'consum', 0.0224, 'lps'),
	(379815, 123, '2015-02-01 00:18:40.000000', 'consum', 0.0226, 'lps'),
	(379816, 123, '2015-02-01 00:18:41.000000', 'consum', 0.0212, 'lps'),
	(379817, 123, '2015-02-01 00:18:42.000000', 'consum', 0.0225, 'lps'),
	(379818, 123, '2015-02-01 00:18:43.000000', 'consum', 0.0213, 'lps'),
	(379819, 123, '2015-02-01 00:18:44.000000', 'consum', 0.0215, 'lps'),
	(379820, 123, '2015-02-01 00:18:45.000000', 'consum', 0.0210, 'lps'),
	(379821, 123, '2015-02-01 00:18:46.000000', 'consum', 0.0212, 'lps'),
	(379822, 123, '2015-02-01 00:18:47.000000', 'consum', 0.0219, 'lps'),
	(379823, 123, '2015-02-01 00:18:48.000000', 'consum', 0.0218, 'lps'),
	(379824, 123, '2015-02-01 00:18:49.000000', 'consum', 0.0222, 'lps'),
	(379825, 123, '2015-02-01 00:18:50.000000', 'consum', 0.0214, 'lps'),
	(379826, 123, '2015-02-01 00:18:51.000000', 'consum', 0.0212, 'lps'),
	(379827, 123, '2015-02-01 00:18:52.000000', 'consum', 0.0225, 'lps'),
	(379828, 123, '2015-02-01 00:18:53.000000', 'consum', 0.0213, 'lps'),
	(379829, 123, '2015-02-01 00:18:54.000000', 'consum', 0.0214, 'lps'),
	(379830, 123, '2015-02-01 00:18:55.000000', 'consum', 0.0221, 'lps'),
	(379831, 123, '2015-02-01 00:18:56.000000', 'consum', 0.0218, 'lps'),
	(379832, 123, '2015-02-01 00:18:57.000000', 'consum', 0.0220, 'lps'),
	(379833, 123, '2015-02-01 00:18:58.000000', 'consum', 0.0218, 'lps'),
	(379834, 123, '2015-02-01 00:18:59.000000', 'consum', 0.0220, 'lps'),
	(379835, 123, '2015-02-01 00:19:00.000000', 'consum', 0.0222, 'lps'),
	(379836, 123, '2015-02-01 00:19:01.000000', 'consum', 0.0221, 'lps'),
	(379837, 123, '2015-02-01 00:19:02.000000', 'consum', 0.0213, 'lps'),
	(379838, 123, '2015-02-01 00:19:03.000000', 'consum', 0.0211, 'lps'),
	(379839, 123, '2015-02-01 00:19:04.000000', 'consum', 0.0222, 'lps'),
	(379840, 123, '2015-02-01 00:19:05.000000', 'consum', 0.0219, 'lps'),
	(379841, 123, '2015-02-01 00:19:06.000000', 'consum', 0.0216, 'lps'),
	(379842, 123, '2015-02-01 00:19:07.000000', 'consum', 0.0215, 'lps'),
	(379843, 123, '2015-02-01 00:19:08.000000', 'consum', 0.0217, 'lps'),
	(379844, 123, '2015-02-01 00:19:09.000000', 'consum', 0.0213, 'lps'),
	(379845, 123, '2015-02-01 00:19:10.000000', 'consum', 0.0220, 'lps'),
	(379846, 123, '2015-02-01 00:19:11.000000', 'consum', 0.0219, 'lps'),
	(379847, 123, '2015-02-01 00:19:12.000000', 'consum', 0.0210, 'lps'),
	(379848, 123, '2015-02-01 00:19:13.000000', 'consum', 0.0218, 'lps'),
	(379849, 123, '2015-02-01 00:19:14.000000', 'consum', 0.0216, 'lps'),
	(379850, 123, '2015-02-01 00:19:15.000000', 'consum', 0.0218, 'lps'),
	(379851, 123, '2015-02-01 00:19:16.000000', 'consum', 0.0213, 'lps'),
	(379852, 123, '2015-02-01 00:19:17.000000', 'consum', 0.0220, 'lps'),
	(379853, 123, '2015-02-01 00:19:18.000000', 'consum', 0.0215, 'lps'),
	(379854, 123, '2015-02-01 00:19:19.000000', 'consum', 0.0224, 'lps'),
	(379855, 123, '2015-02-01 00:19:20.000000', 'consum', 0.0216, 'lps'),
	(379856, 123, '2015-02-01 00:19:21.000000', 'consum', 0.0214, 'lps'),
	(379857, 123, '2015-02-01 00:19:22.000000', 'consum', 0.0212, 'lps'),
	(379858, 123, '2015-02-01 00:19:23.000000', 'consum', 0.0225, 'lps'),
	(379859, 123, '2015-02-01 00:19:24.000000', 'consum', 0.0213, 'lps'),
	(379860, 123, '2015-02-01 00:19:25.000000', 'consum', 0.0213, 'lps'),
	(379861, 123, '2015-02-01 00:19:26.000000', 'consum', 0.0217, 'lps'),
	(379862, 123, '2015-02-01 00:19:27.000000', 'consum', 0.0220, 'lps'),
	(379863, 123, '2015-02-01 00:19:28.000000', 'consum', 0.0220, 'lps'),
	(379864, 123, '2015-02-01 00:19:29.000000', 'consum', 0.0215, 'lps'),
	(379865, 123, '2015-02-01 00:19:30.000000', 'consum', 0.0224, 'lps'),
	(379866, 123, '2015-02-01 00:19:31.000000', 'consum', 0.0216, 'lps'),
	(379867, 123, '2015-02-01 00:19:32.000000', 'consum', 0.0212, 'lps'),
	(379868, 123, '2015-02-01 00:19:33.000000', 'consum', 0.0219, 'lps'),
	(379869, 123, '2015-02-01 00:19:34.000000', 'consum', 0.0218, 'lps'),
	(379870, 123, '2015-02-01 00:19:35.000000', 'consum', 0.0224, 'lps'),
	(379871, 123, '2015-02-01 00:19:36.000000', 'consum', 0.0223, 'lps'),
	(379872, 123, '2015-02-01 00:19:37.000000', 'consum', 0.0214, 'lps'),
	(379873, 123, '2015-02-01 00:19:38.000000', 'consum', 0.0226, 'lps'),
	(379874, 123, '2015-02-01 00:19:39.000000', 'consum', 0.0211, 'lps'),
	(379875, 123, '2015-02-01 00:19:40.000000', 'consum', 0.0219, 'lps'),
	(379876, 123, '2015-02-01 00:19:41.000000', 'consum', 0.0219, 'lps'),
	(379877, 123, '2015-02-01 00:19:42.000000', 'consum', 0.0212, 'lps'),
	(379878, 123, '2015-02-01 00:19:43.000000', 'consum', 0.0210, 'lps'),
	(379879, 123, '2015-02-01 00:19:44.000000', 'consum', 0.0220, 'lps'),
	(379880, 123, '2015-02-01 00:19:45.000000', 'consum', 0.0210, 'lps'),
	(379881, 123, '2015-02-01 00:19:46.000000', 'consum', 0.0215, 'lps'),
	(379882, 123, '2015-02-01 00:19:47.000000', 'consum', 0.0219, 'lps'),
	(379883, 123, '2015-02-01 00:19:48.000000', 'consum', 0.0222, 'lps'),
	(379884, 123, '2015-02-01 00:19:49.000000', 'consum', 0.0211, 'lps'),
	(379885, 123, '2015-02-01 00:19:50.000000', 'consum', 0.0213, 'lps'),
	(379886, 123, '2015-02-01 00:19:51.000000', 'consum', 0.0223, 'lps'),
	(379887, 123, '2015-02-01 00:19:52.000000', 'consum', 0.0216, 'lps'),
	(379888, 123, '2015-02-01 00:19:53.000000', 'consum', 0.0218, 'lps'),
	(379889, 123, '2015-02-01 00:19:54.000000', 'consum', 0.0216, 'lps'),
	(379890, 123, '2015-02-01 00:19:55.000000', 'consum', 0.0214, 'lps'),
	(379891, 123, '2015-02-01 00:19:56.000000', 'consum', 0.0215, 'lps'),
	(379892, 123, '2015-02-01 00:19:57.000000', 'consum', 0.0223, 'lps'),
	(379893, 123, '2015-02-01 00:19:58.000000', 'consum', 0.0224, 'lps'),
	(379894, 123, '2015-02-01 00:19:59.000000', 'consum', 0.0211, 'lps'),
	(379895, 123, '2015-02-01 00:20:00.000000', 'consum', 0.0224, 'lps'),
	(379896, 123, '2015-02-01 00:20:01.000000', 'consum', 0.0211, 'lps'),
	(379897, 123, '2015-02-01 00:20:02.000000', 'consum', 0.0221, 'lps'),
	(379898, 123, '2015-02-01 00:20:03.000000', 'consum', 0.0214, 'lps'),
	(379899, 123, '2015-02-01 00:20:04.000000', 'consum', 0.0212, 'lps'),
	(379900, 123, '2015-02-01 00:20:05.000000', 'consum', 0.0212, 'lps'),
	(379901, 123, '2015-02-01 00:20:06.000000', 'consum', 0.0212, 'lps'),
	(379902, 123, '2015-02-01 00:20:07.000000', 'consum', 0.0215, 'lps'),
	(379903, 123, '2015-02-01 00:20:08.000000', 'consum', 0.0215, 'lps'),
	(379904, 123, '2015-02-01 00:20:09.000000', 'consum', 0.0217, 'lps'),
	(379905, 123, '2015-02-01 00:20:10.000000', 'consum', 0.0216, 'lps'),
	(379906, 123, '2015-02-01 00:20:11.000000', 'consum', 0.0220, 'lps'),
	(379907, 123, '2015-02-01 00:20:12.000000', 'consum', 0.0225, 'lps'),
	(379908, 123, '2015-02-01 00:20:13.000000', 'consum', 0.0220, 'lps'),
	(379909, 123, '2015-02-01 00:20:14.000000', 'consum', 0.0216, 'lps'),
	(379910, 123, '2015-02-01 00:20:15.000000', 'consum', 0.0226, 'lps'),
	(379911, 123, '2015-02-01 00:20:16.000000', 'consum', 0.0223, 'lps'),
	(379912, 123, '2015-02-01 00:20:17.000000', 'consum', 0.0211, 'lps'),
	(379913, 123, '2015-02-01 00:20:18.000000', 'consum', 0.0210, 'lps'),
	(379914, 123, '2015-02-01 00:20:19.000000', 'consum', 0.0210, 'lps'),
	(379915, 123, '2015-02-01 00:20:20.000000', 'consum', 0.0224, 'lps'),
	(379916, 123, '2015-02-01 00:20:21.000000', 'consum', 0.0213, 'lps'),
	(379917, 123, '2015-02-01 00:20:22.000000', 'consum', 0.0218, 'lps'),
	(379918, 123, '2015-02-01 00:20:23.000000', 'consum', 0.0225, 'lps'),
	(379919, 123, '2015-02-01 00:20:24.000000', 'consum', 0.0210, 'lps'),
	(379920, 123, '2015-02-01 00:20:25.000000', 'consum', 0.0218, 'lps'),
	(379921, 123, '2015-02-01 00:20:26.000000', 'consum', 0.0213, 'lps'),
	(379922, 123, '2015-02-01 00:20:27.000000', 'consum', 0.0222, 'lps'),
	(379923, 123, '2015-02-01 00:20:28.000000', 'consum', 0.0211, 'lps'),
	(379924, 123, '2015-02-01 00:20:29.000000', 'consum', 0.0212, 'lps'),
	(379925, 123, '2015-02-01 00:20:30.000000', 'consum', 0.0217, 'lps'),
	(379926, 123, '2015-02-01 00:20:31.000000', 'consum', 0.0224, 'lps'),
	(379927, 123, '2015-02-01 00:20:32.000000', 'consum', 0.0226, 'lps'),
	(379928, 123, '2015-02-01 00:20:33.000000', 'consum', 0.0213, 'lps'),
	(379929, 123, '2015-02-01 00:20:34.000000', 'consum', 0.0214, 'lps'),
	(379930, 123, '2015-02-01 00:20:35.000000', 'consum', 0.0220, 'lps'),
	(379931, 123, '2015-02-01 00:20:36.000000', 'consum', 0.0215, 'lps'),
	(379932, 123, '2015-02-01 00:20:37.000000', 'consum', 0.0223, 'lps'),
	(379933, 123, '2015-02-01 00:20:38.000000', 'consum', 0.0224, 'lps'),
	(379934, 123, '2015-02-01 00:20:39.000000', 'consum', 0.0211, 'lps'),
	(379935, 123, '2015-02-01 00:20:40.000000', 'consum', 0.0222, 'lps'),
	(379936, 123, '2015-02-01 00:20:41.000000', 'consum', 0.0216, 'lps'),
	(379937, 123, '2015-02-01 00:20:42.000000', 'consum', 0.0220, 'lps'),
	(379938, 123, '2015-02-01 00:20:43.000000', 'consum', 0.0212, 'lps'),
	(379939, 123, '2015-02-01 00:20:44.000000', 'consum', 0.0223, 'lps'),
	(379940, 123, '2015-02-01 00:20:45.000000', 'consum', 0.0220, 'lps'),
	(379941, 123, '2015-02-01 00:20:46.000000', 'consum', 0.0222, 'lps'),
	(379942, 123, '2015-02-01 00:20:47.000000', 'consum', 0.0222, 'lps'),
	(379943, 123, '2015-02-01 00:20:48.000000', 'consum', 0.0218, 'lps'),
	(379944, 123, '2015-02-01 00:20:49.000000', 'consum', 0.0215, 'lps'),
	(379945, 123, '2015-02-01 00:20:50.000000', 'consum', 0.0213, 'lps'),
	(379946, 123, '2015-02-01 00:20:51.000000', 'consum', 0.0225, 'lps'),
	(379947, 123, '2015-02-01 00:20:52.000000', 'consum', 0.0210, 'lps'),
	(379948, 123, '2015-02-01 00:20:53.000000', 'consum', 0.0218, 'lps'),
	(379949, 123, '2015-02-01 00:20:54.000000', 'consum', 0.0213, 'lps'),
	(379950, 123, '2015-02-01 00:20:55.000000', 'consum', 0.0222, 'lps'),
	(379951, 123, '2015-02-01 00:20:56.000000', 'consum', 0.0225, 'lps'),
	(379952, 123, '2015-02-01 00:20:57.000000', 'consum', 0.0215, 'lps'),
	(379953, 123, '2015-02-01 00:20:58.000000', 'consum', 0.0225, 'lps'),
	(379954, 123, '2015-02-01 00:20:59.000000', 'consum', 0.0219, 'lps'),
	(379955, 123, '2015-02-01 00:21:00.000000', 'consum', 0.0212, 'lps'),
	(379956, 123, '2015-02-01 00:21:01.000000', 'consum', 0.0212, 'lps'),
	(379957, 123, '2015-02-01 00:21:02.000000', 'consum', 0.0211, 'lps'),
	(379958, 123, '2015-02-01 00:21:03.000000', 'consum', 0.0211, 'lps'),
	(379959, 123, '2015-02-01 00:21:04.000000', 'consum', 0.0211, 'lps'),
	(379960, 123, '2015-02-01 00:21:05.000000', 'consum', 0.0216, 'lps'),
	(379961, 123, '2015-02-01 00:21:06.000000', 'consum', 0.0217, 'lps'),
	(379962, 123, '2015-02-01 00:21:07.000000', 'consum', 0.0211, 'lps'),
	(379963, 123, '2015-02-01 00:21:08.000000', 'consum', 0.0213, 'lps'),
	(379964, 123, '2015-02-01 00:21:09.000000', 'consum', 0.0221, 'lps'),
	(379965, 123, '2015-02-01 00:21:10.000000', 'consum', 0.0222, 'lps'),
	(379966, 123, '2015-02-01 00:21:11.000000', 'consum', 0.0220, 'lps'),
	(379967, 123, '2015-02-01 00:21:12.000000', 'consum', 0.0224, 'lps'),
	(379968, 123, '2015-02-01 00:21:13.000000', 'consum', 0.0216, 'lps'),
	(379969, 123, '2015-02-01 00:21:14.000000', 'consum', 0.0217, 'lps'),
	(379970, 123, '2015-02-01 00:21:15.000000', 'consum', 0.0212, 'lps'),
	(379971, 123, '2015-02-01 00:21:16.000000', 'consum', 0.0216, 'lps'),
	(379972, 123, '2015-02-01 00:21:17.000000', 'consum', 0.0217, 'lps'),
	(379973, 123, '2015-02-01 00:21:18.000000', 'consum', 0.0210, 'lps'),
	(379974, 123, '2015-02-01 00:21:19.000000', 'consum', 0.0222, 'lps'),
	(379975, 123, '2015-02-01 00:21:20.000000', 'consum', 0.0221, 'lps'),
	(379976, 123, '2015-02-01 00:21:21.000000', 'consum', 0.0211, 'lps'),
	(379977, 123, '2015-02-01 00:21:22.000000', 'consum', 0.0218, 'lps'),
	(379978, 123, '2015-02-01 00:21:23.000000', 'consum', 0.0213, 'lps'),
	(379979, 123, '2015-02-01 00:21:24.000000', 'consum', 0.0217, 'lps'),
	(379980, 123, '2015-02-01 00:21:25.000000', 'consum', 0.0221, 'lps'),
	(379981, 123, '2015-02-01 00:21:26.000000', 'consum', 0.0212, 'lps'),
	(379982, 123, '2015-02-01 00:21:27.000000', 'consum', 0.0219, 'lps'),
	(379983, 123, '2015-02-01 00:21:28.000000', 'consum', 0.0218, 'lps'),
	(379984, 123, '2015-02-01 00:21:29.000000', 'consum', 0.0224, 'lps'),
	(379985, 123, '2015-02-01 00:21:30.000000', 'consum', 0.0220, 'lps'),
	(379986, 123, '2015-02-01 00:21:31.000000', 'consum', 0.0219, 'lps'),
	(379987, 123, '2015-02-01 00:21:32.000000', 'consum', 0.0226, 'lps'),
	(379988, 123, '2015-02-01 00:21:33.000000', 'consum', 0.0212, 'lps'),
	(379989, 123, '2015-02-01 00:21:34.000000', 'consum', 0.0223, 'lps'),
	(379990, 123, '2015-02-01 00:21:35.000000', 'consum', 0.0221, 'lps'),
	(379991, 123, '2015-02-01 00:21:36.000000', 'consum', 0.0226, 'lps'),
	(379992, 123, '2015-02-01 00:21:37.000000', 'consum', 0.0222, 'lps'),
	(379993, 123, '2015-02-01 00:21:38.000000', 'consum', 0.0221, 'lps'),
	(379994, 123, '2015-02-01 00:21:39.000000', 'consum', 0.0215, 'lps'),
	(379995, 123, '2015-02-01 00:21:40.000000', 'consum', 0.0218, 'lps'),
	(379996, 123, '2015-02-01 00:21:41.000000', 'consum', 0.0218, 'lps'),
	(379997, 123, '2015-02-01 00:21:42.000000', 'consum', 0.0226, 'lps'),
	(379998, 123, '2015-02-01 00:21:43.000000', 'consum', 0.0215, 'lps'),
	(379999, 123, '2015-02-01 00:21:44.000000', 'consum', 0.0221, 'lps'),
	(380000, 123, '2015-02-01 00:21:45.000000', 'consum', 0.0216, 'lps'),
	(380001, 123, '2015-02-01 00:21:46.000000', 'consum', 0.0224, 'lps'),
	(380002, 123, '2015-02-01 00:21:47.000000', 'consum', 0.0212, 'lps'),
	(380003, 123, '2015-02-01 00:21:48.000000', 'consum', 0.0212, 'lps'),
	(380004, 123, '2015-02-01 00:21:49.000000', 'consum', 0.0216, 'lps'),
	(380005, 123, '2015-02-01 00:21:50.000000', 'consum', 0.0217, 'lps'),
	(380006, 123, '2015-02-01 00:21:51.000000', 'consum', 0.0226, 'lps'),
	(380007, 123, '2015-02-01 00:21:52.000000', 'consum', 0.0221, 'lps'),
	(380008, 123, '2015-02-01 00:21:53.000000', 'consum', 0.0218, 'lps'),
	(380009, 123, '2015-02-01 00:21:54.000000', 'consum', 0.0216, 'lps'),
	(380010, 123, '2015-02-01 00:21:55.000000', 'consum', 0.0215, 'lps'),
	(380011, 123, '2015-02-01 00:21:56.000000', 'consum', 0.0217, 'lps'),
	(380012, 123, '2015-02-01 00:21:57.000000', 'consum', 0.0216, 'lps'),
	(380013, 123, '2015-02-01 00:21:58.000000', 'consum', 0.0218, 'lps'),
	(380014, 123, '2015-02-01 00:21:59.000000', 'consum', 0.0218, 'lps'),
	(380015, 123, '2015-02-01 00:22:00.000000', 'consum', 0.0224, 'lps'),
	(380016, 123, '2015-02-01 00:22:01.000000', 'consum', 0.0225, 'lps'),
	(380017, 123, '2015-02-01 00:22:02.000000', 'consum', 0.0226, 'lps'),
	(380018, 123, '2015-02-01 00:22:03.000000', 'consum', 0.0210, 'lps'),
	(380019, 123, '2015-02-01 00:22:04.000000', 'consum', 0.0212, 'lps'),
	(380020, 123, '2015-02-01 00:22:05.000000', 'consum', 0.0223, 'lps'),
	(380021, 123, '2015-02-01 00:22:06.000000', 'consum', 0.0218, 'lps'),
	(380022, 123, '2015-02-01 00:22:07.000000', 'consum', 0.0210, 'lps'),
	(380023, 123, '2015-02-01 00:22:08.000000', 'consum', 0.0221, 'lps'),
	(380024, 123, '2015-02-01 00:22:09.000000', 'consum', 0.0216, 'lps'),
	(380025, 123, '2015-02-01 00:22:10.000000', 'consum', 0.0226, 'lps'),
	(380026, 123, '2015-02-01 00:22:11.000000', 'consum', 0.0219, 'lps'),
	(380027, 123, '2015-02-01 00:22:12.000000', 'consum', 0.0224, 'lps'),
	(380028, 123, '2015-02-01 00:22:13.000000', 'consum', 0.0218, 'lps'),
	(380029, 123, '2015-02-01 00:22:14.000000', 'consum', 0.0212, 'lps'),
	(380030, 123, '2015-02-01 00:22:15.000000', 'consum', 0.0210, 'lps'),
	(380031, 123, '2015-02-01 00:22:16.000000', 'consum', 0.0225, 'lps'),
	(380032, 123, '2015-02-01 00:22:17.000000', 'consum', 0.0215, 'lps'),
	(380033, 123, '2015-02-01 00:22:18.000000', 'consum', 0.0225, 'lps'),
	(380034, 123, '2015-02-01 00:22:19.000000', 'consum', 0.0218, 'lps'),
	(380035, 123, '2015-02-01 00:22:20.000000', 'consum', 0.0225, 'lps'),
	(380036, 123, '2015-02-01 00:22:21.000000', 'consum', 0.0226, 'lps'),
	(380037, 123, '2015-02-01 00:22:22.000000', 'consum', 0.0214, 'lps'),
	(380038, 123, '2015-02-01 00:22:23.000000', 'consum', 0.0215, 'lps'),
	(380039, 123, '2015-02-01 00:22:24.000000', 'consum', 0.0222, 'lps'),
	(380040, 123, '2015-02-01 00:22:25.000000', 'consum', 0.0222, 'lps'),
	(380041, 123, '2015-02-01 00:22:26.000000', 'consum', 0.0218, 'lps'),
	(380042, 123, '2015-02-01 00:22:27.000000', 'consum', 0.0215, 'lps'),
	(380043, 123, '2015-02-01 00:22:28.000000', 'consum', 0.0212, 'lps'),
	(380044, 123, '2015-02-01 00:22:29.000000', 'consum', 0.0220, 'lps'),
	(380045, 123, '2015-02-01 00:22:30.000000', 'consum', 0.0223, 'lps'),
	(380046, 123, '2015-02-01 00:22:31.000000', 'consum', 0.0210, 'lps'),
	(380047, 123, '2015-02-01 00:22:32.000000', 'consum', 0.0224, 'lps'),
	(380048, 123, '2015-02-01 00:22:33.000000', 'consum', 0.0210, 'lps'),
	(380049, 123, '2015-02-01 00:22:34.000000', 'consum', 0.0221, 'lps'),
	(380050, 123, '2015-02-01 00:22:35.000000', 'consum', 0.0213, 'lps'),
	(380051, 123, '2015-02-01 00:22:36.000000', 'consum', 0.0210, 'lps'),
	(380052, 123, '2015-02-01 00:22:37.000000', 'consum', 0.0217, 'lps'),
	(380053, 123, '2015-02-01 00:22:38.000000', 'consum', 0.0214, 'lps'),
	(380054, 123, '2015-02-01 00:22:39.000000', 'consum', 0.0210, 'lps'),
	(380055, 123, '2015-02-01 00:22:40.000000', 'consum', 0.0214, 'lps'),
	(380056, 123, '2015-02-01 00:22:41.000000', 'consum', 0.0212, 'lps'),
	(380057, 123, '2015-02-01 00:22:42.000000', 'consum', 0.0211, 'lps'),
	(380058, 123, '2015-02-01 00:22:43.000000', 'consum', 0.0224, 'lps'),
	(380059, 123, '2015-02-01 00:22:44.000000', 'consum', 0.0226, 'lps'),
	(380060, 123, '2015-02-01 00:22:45.000000', 'consum', 0.0214, 'lps'),
	(380061, 123, '2015-02-01 00:22:46.000000', 'consum', 0.0219, 'lps'),
	(380062, 123, '2015-02-01 00:22:47.000000', 'consum', 0.0210, 'lps'),
	(380063, 123, '2015-02-01 00:22:48.000000', 'consum', 0.0218, 'lps'),
	(380064, 123, '2015-02-01 00:22:49.000000', 'consum', 0.0216, 'lps'),
	(380065, 123, '2015-02-01 00:22:50.000000', 'consum', 0.0215, 'lps'),
	(380066, 123, '2015-02-01 00:22:51.000000', 'consum', 0.0220, 'lps'),
	(380067, 123, '2015-02-01 00:22:52.000000', 'consum', 0.0210, 'lps'),
	(380068, 123, '2015-02-01 00:22:53.000000', 'consum', 0.0216, 'lps'),
	(380069, 123, '2015-02-01 00:22:54.000000', 'consum', 0.0224, 'lps'),
	(380070, 123, '2015-02-01 00:22:55.000000', 'consum', 0.0211, 'lps'),
	(380071, 123, '2015-02-01 00:22:56.000000', 'consum', 0.0225, 'lps'),
	(380072, 123, '2015-02-01 00:22:57.000000', 'consum', 0.0212, 'lps'),
	(380073, 123, '2015-02-01 00:22:58.000000', 'consum', 0.0210, 'lps'),
	(380074, 123, '2015-02-01 00:22:59.000000', 'consum', 0.0223, 'lps'),
	(380075, 123, '2015-02-01 00:23:00.000000', 'consum', 0.0225, 'lps'),
	(380076, 123, '2015-02-01 00:23:01.000000', 'consum', 0.0213, 'lps'),
	(380077, 123, '2015-02-01 00:23:02.000000', 'consum', 0.0213, 'lps'),
	(380078, 123, '2015-02-01 00:23:03.000000', 'consum', 0.0217, 'lps'),
	(380079, 123, '2015-02-01 00:23:04.000000', 'consum', 0.0219, 'lps'),
	(380080, 123, '2015-02-01 00:23:05.000000', 'consum', 0.0216, 'lps'),
	(380081, 123, '2015-02-01 00:23:06.000000', 'consum', 0.0217, 'lps'),
	(380082, 123, '2015-02-01 00:23:07.000000', 'consum', 0.0225, 'lps'),
	(380083, 123, '2015-02-01 00:23:08.000000', 'consum', 0.0213, 'lps'),
	(380084, 123, '2015-02-01 00:23:09.000000', 'consum', 0.0217, 'lps'),
	(380085, 123, '2015-02-01 00:23:10.000000', 'consum', 0.0220, 'lps'),
	(380086, 123, '2015-02-01 00:23:11.000000', 'consum', 0.0221, 'lps'),
	(380087, 123, '2015-02-01 00:23:12.000000', 'consum', 0.0218, 'lps'),
	(380088, 123, '2015-02-01 00:23:13.000000', 'consum', 0.0219, 'lps'),
	(380089, 123, '2015-02-01 00:23:14.000000', 'consum', 0.0212, 'lps'),
	(380090, 123, '2015-02-01 00:23:15.000000', 'consum', 0.0214, 'lps'),
	(380091, 123, '2015-02-01 00:23:16.000000', 'consum', 0.0222, 'lps'),
	(380092, 123, '2015-02-01 00:23:17.000000', 'consum', 0.0226, 'lps'),
	(380093, 123, '2015-02-01 00:23:18.000000', 'consum', 0.0221, 'lps'),
	(380094, 123, '2015-02-01 00:23:19.000000', 'consum', 0.0218, 'lps'),
	(380095, 123, '2015-02-01 00:23:20.000000', 'consum', 0.0216, 'lps'),
	(380096, 123, '2015-02-01 00:23:21.000000', 'consum', 0.0217, 'lps'),
	(380097, 123, '2015-02-01 00:23:22.000000', 'consum', 0.0226, 'lps'),
	(380098, 123, '2015-02-01 00:23:23.000000', 'consum', 0.0217, 'lps'),
	(380099, 123, '2015-02-01 00:23:24.000000', 'consum', 0.0218, 'lps'),
	(380100, 123, '2015-02-01 00:23:25.000000', 'consum', 0.0211, 'lps'),
	(380101, 123, '2015-02-01 00:23:26.000000', 'consum', 0.0210, 'lps'),
	(380102, 123, '2015-02-01 00:23:27.000000', 'consum', 0.0223, 'lps'),
	(380103, 123, '2015-02-01 00:23:28.000000', 'consum', 0.0226, 'lps'),
	(380104, 123, '2015-02-01 00:23:29.000000', 'consum', 0.0216, 'lps'),
	(380105, 123, '2015-02-01 00:23:30.000000', 'consum', 0.0226, 'lps'),
	(380106, 123, '2015-02-01 00:23:31.000000', 'consum', 0.0221, 'lps'),
	(380107, 123, '2015-02-01 00:23:32.000000', 'consum', 0.0217, 'lps'),
	(380108, 123, '2015-02-01 00:23:33.000000', 'consum', 0.0213, 'lps'),
	(380109, 123, '2015-02-01 00:23:34.000000', 'consum', 0.0222, 'lps'),
	(380110, 123, '2015-02-01 00:23:35.000000', 'consum', 0.0225, 'lps'),
	(380111, 123, '2015-02-01 00:23:36.000000', 'consum', 0.0219, 'lps'),
	(380112, 123, '2015-02-01 00:23:37.000000', 'consum', 0.0225, 'lps'),
	(380113, 123, '2015-02-01 00:23:38.000000', 'consum', 0.0226, 'lps'),
	(380114, 123, '2015-02-01 00:23:39.000000', 'consum', 0.0211, 'lps'),
	(380115, 123, '2015-02-01 00:23:40.000000', 'consum', 0.0217, 'lps'),
	(380116, 123, '2015-02-01 00:23:41.000000', 'consum', 0.0226, 'lps'),
	(380117, 123, '2015-02-01 00:23:42.000000', 'consum', 0.0219, 'lps'),
	(380118, 123, '2015-02-01 00:23:43.000000', 'consum', 0.0226, 'lps'),
	(380119, 123, '2015-02-01 00:23:44.000000', 'consum', 0.0211, 'lps'),
	(380120, 123, '2015-02-01 00:23:45.000000', 'consum', 0.0220, 'lps'),
	(380121, 123, '2015-02-01 00:23:46.000000', 'consum', 0.0225, 'lps'),
	(380122, 123, '2015-02-01 00:23:47.000000', 'consum', 0.0218, 'lps'),
	(380123, 123, '2015-02-01 00:23:48.000000', 'consum', 0.0225, 'lps'),
	(380124, 123, '2015-02-01 00:23:49.000000', 'consum', 0.0225, 'lps'),
	(380125, 123, '2015-02-01 00:23:50.000000', 'consum', 0.0224, 'lps'),
	(380126, 123, '2015-02-01 00:23:51.000000', 'consum', 0.0217, 'lps'),
	(380127, 123, '2015-02-01 00:23:52.000000', 'consum', 0.0222, 'lps'),
	(380128, 123, '2015-02-01 00:23:53.000000', 'consum', 0.0214, 'lps'),
	(380129, 123, '2015-02-01 00:23:54.000000', 'consum', 0.0213, 'lps'),
	(380130, 123, '2015-02-01 00:23:55.000000', 'consum', 0.0213, 'lps'),
	(380131, 123, '2015-02-01 00:23:56.000000', 'consum', 0.0217, 'lps'),
	(380132, 123, '2015-02-01 00:23:57.000000', 'consum', 0.0220, 'lps'),
	(380133, 123, '2015-02-01 00:23:58.000000', 'consum', 0.0222, 'lps'),
	(380134, 123, '2015-02-01 00:23:59.000000', 'consum', 0.0225, 'lps'),
	(380135, 123, '2015-02-01 00:24:00.000000', 'consum', 0.0217, 'lps'),
	(380136, 123, '2015-02-01 00:24:01.000000', 'consum', 0.0214, 'lps'),
	(380137, 123, '2015-02-01 00:24:02.000000', 'consum', 0.0210, 'lps'),
	(380138, 123, '2015-02-01 00:24:03.000000', 'consum', 0.0215, 'lps'),
	(380139, 123, '2015-02-01 00:24:04.000000', 'consum', 0.0219, 'lps'),
	(380140, 123, '2015-02-01 00:24:05.000000', 'consum', 0.0224, 'lps'),
	(380141, 123, '2015-02-01 00:24:06.000000', 'consum', 0.0220, 'lps'),
	(380142, 123, '2015-02-01 00:24:07.000000', 'consum', 0.0218, 'lps'),
	(380143, 123, '2015-02-01 00:24:08.000000', 'consum', 0.0222, 'lps'),
	(380144, 123, '2015-02-01 00:24:09.000000', 'consum', 0.0210, 'lps'),
	(380145, 123, '2015-02-01 00:24:10.000000', 'consum', 0.0210, 'lps'),
	(380146, 123, '2015-02-01 00:24:11.000000', 'consum', 0.0211, 'lps'),
	(380147, 123, '2015-02-01 00:24:12.000000', 'consum', 0.0214, 'lps'),
	(380148, 123, '2015-02-01 00:24:13.000000', 'consum', 0.0210, 'lps'),
	(380149, 123, '2015-02-01 00:24:14.000000', 'consum', 0.0215, 'lps'),
	(380150, 123, '2015-02-01 00:24:15.000000', 'consum', 0.0220, 'lps'),
	(380151, 123, '2015-02-01 00:24:16.000000', 'consum', 0.0211, 'lps'),
	(380152, 123, '2015-02-01 00:24:17.000000', 'consum', 0.0220, 'lps'),
	(380153, 123, '2015-02-01 00:24:18.000000', 'consum', 0.0222, 'lps'),
	(380154, 123, '2015-02-01 00:24:19.000000', 'consum', 0.0224, 'lps'),
	(380155, 123, '2015-02-01 00:24:20.000000', 'consum', 0.0226, 'lps'),
	(380156, 123, '2015-02-01 00:24:21.000000', 'consum', 0.0215, 'lps'),
	(380157, 123, '2015-02-01 00:24:22.000000', 'consum', 0.0222, 'lps'),
	(380158, 123, '2015-02-01 00:24:23.000000', 'consum', 0.0221, 'lps'),
	(380159, 123, '2015-02-01 00:24:24.000000', 'consum', 0.0214, 'lps'),
	(380160, 123, '2015-02-01 00:24:25.000000', 'consum', 0.0214, 'lps'),
	(380161, 123, '2015-02-01 00:24:26.000000', 'consum', 0.0218, 'lps'),
	(380162, 123, '2015-02-01 00:24:27.000000', 'consum', 0.0220, 'lps'),
	(380163, 123, '2015-02-01 00:24:28.000000', 'consum', 0.0219, 'lps'),
	(380164, 123, '2015-02-01 00:24:29.000000', 'consum', 0.0211, 'lps'),
	(380165, 123, '2015-02-01 00:24:30.000000', 'consum', 0.0222, 'lps'),
	(380166, 123, '2015-02-01 00:24:31.000000', 'consum', 0.0217, 'lps'),
	(380167, 123, '2015-02-01 00:24:32.000000', 'consum', 0.0210, 'lps'),
	(380168, 123, '2015-02-01 00:24:33.000000', 'consum', 0.0225, 'lps'),
	(380169, 123, '2015-02-01 00:24:34.000000', 'consum', 0.0214, 'lps'),
	(380170, 123, '2015-02-01 00:24:35.000000', 'consum', 0.0222, 'lps'),
	(380171, 123, '2015-02-01 00:24:36.000000', 'consum', 0.0222, 'lps'),
	(380172, 123, '2015-02-01 00:24:37.000000', 'consum', 0.0220, 'lps'),
	(380173, 123, '2015-02-01 00:24:38.000000', 'consum', 0.0223, 'lps'),
	(380174, 123, '2015-02-01 00:24:39.000000', 'consum', 0.0213, 'lps'),
	(380175, 123, '2015-02-01 00:24:40.000000', 'consum', 0.0220, 'lps'),
	(380176, 123, '2015-02-01 00:24:41.000000', 'consum', 0.0217, 'lps'),
	(380177, 123, '2015-02-01 00:24:42.000000', 'consum', 0.0214, 'lps'),
	(380178, 123, '2015-02-01 00:24:43.000000', 'consum', 0.0210, 'lps'),
	(380179, 123, '2015-02-01 00:24:44.000000', 'consum', 0.0216, 'lps'),
	(380180, 123, '2015-02-01 00:24:45.000000', 'consum', 0.0225, 'lps'),
	(380181, 123, '2015-02-01 00:24:46.000000', 'consum', 0.0215, 'lps'),
	(380182, 123, '2015-02-01 00:24:47.000000', 'consum', 0.0225, 'lps'),
	(380183, 123, '2015-02-01 00:24:48.000000', 'consum', 0.0219, 'lps'),
	(380184, 123, '2015-02-01 00:24:49.000000', 'consum', 0.0211, 'lps'),
	(380185, 123, '2015-02-01 00:24:50.000000', 'consum', 0.0221, 'lps'),
	(380186, 123, '2015-02-01 00:24:51.000000', 'consum', 0.0214, 'lps'),
	(380187, 123, '2015-02-01 00:24:52.000000', 'consum', 0.0215, 'lps'),
	(380188, 123, '2015-02-01 00:24:53.000000', 'consum', 0.0221, 'lps'),
	(380189, 123, '2015-02-01 00:24:54.000000', 'consum', 0.0219, 'lps'),
	(380190, 123, '2015-02-01 00:24:55.000000', 'consum', 0.0221, 'lps'),
	(380191, 123, '2015-02-01 00:24:56.000000', 'consum', 0.0223, 'lps'),
	(380192, 123, '2015-02-01 00:24:57.000000', 'consum', 0.0226, 'lps'),
	(380193, 123, '2015-02-01 00:24:58.000000', 'consum', 0.0215, 'lps'),
	(380194, 123, '2015-02-01 00:24:59.000000', 'consum', 0.0223, 'lps'),
	(380195, 123, '2015-02-01 00:25:00.000000', 'consum', 0.0210, 'lps'),
	(380196, 123, '2015-02-01 00:25:01.000000', 'consum', 0.0223, 'lps'),
	(380197, 123, '2015-02-01 00:25:02.000000', 'consum', 0.0225, 'lps'),
	(380198, 123, '2015-02-01 00:25:03.000000', 'consum', 0.0210, 'lps'),
	(380199, 123, '2015-02-01 00:25:04.000000', 'consum', 0.0218, 'lps'),
	(380200, 123, '2015-02-01 00:25:05.000000', 'consum', 0.0217, 'lps'),
	(380201, 123, '2015-02-01 00:25:06.000000', 'consum', 0.0219, 'lps'),
	(380202, 123, '2015-02-01 00:25:07.000000', 'consum', 0.0219, 'lps'),
	(380203, 123, '2015-02-01 00:25:08.000000', 'consum', 0.0213, 'lps'),
	(380204, 123, '2015-02-01 00:25:09.000000', 'consum', 0.0215, 'lps'),
	(380205, 123, '2015-02-01 00:25:10.000000', 'consum', 0.0210, 'lps'),
	(380206, 123, '2015-02-01 00:25:11.000000', 'consum', 0.0214, 'lps'),
	(380207, 123, '2015-02-01 00:25:12.000000', 'consum', 0.0211, 'lps'),
	(380208, 123, '2015-02-01 00:25:13.000000', 'consum', 0.0221, 'lps'),
	(380209, 123, '2015-02-01 00:25:14.000000', 'consum', 0.0214, 'lps'),
	(380210, 123, '2015-02-01 00:25:15.000000', 'consum', 0.0212, 'lps'),
	(380211, 123, '2015-02-01 00:25:16.000000', 'consum', 0.0224, 'lps'),
	(380212, 123, '2015-02-01 00:25:17.000000', 'consum', 0.0210, 'lps'),
	(380213, 123, '2015-02-01 00:25:18.000000', 'consum', 0.0216, 'lps'),
	(380214, 123, '2015-02-01 00:25:19.000000', 'consum', 0.0226, 'lps'),
	(380215, 123, '2015-02-01 00:25:20.000000', 'consum', 0.0222, 'lps'),
	(380216, 123, '2015-02-01 00:25:21.000000', 'consum', 0.0223, 'lps'),
	(380217, 123, '2015-02-01 00:25:22.000000', 'consum', 0.0223, 'lps'),
	(380218, 123, '2015-02-01 00:25:23.000000', 'consum', 0.0217, 'lps'),
	(380219, 123, '2015-02-01 00:25:24.000000', 'consum', 0.0224, 'lps'),
	(380220, 123, '2015-02-01 00:25:25.000000', 'consum', 0.0226, 'lps'),
	(380221, 123, '2015-02-01 00:25:26.000000', 'consum', 0.0213, 'lps'),
	(380222, 123, '2015-02-01 00:25:27.000000', 'consum', 0.0214, 'lps'),
	(380223, 123, '2015-02-01 00:25:28.000000', 'consum', 0.0222, 'lps'),
	(380224, 123, '2015-02-01 00:25:29.000000', 'consum', 0.0224, 'lps'),
	(380225, 123, '2015-02-01 00:25:30.000000', 'consum', 0.0211, 'lps'),
	(380226, 123, '2015-02-01 00:25:31.000000', 'consum', 0.0224, 'lps'),
	(380227, 123, '2015-02-01 00:25:32.000000', 'consum', 0.0225, 'lps'),
	(380228, 123, '2015-02-01 00:25:33.000000', 'consum', 0.0212, 'lps'),
	(380229, 123, '2015-02-01 00:25:34.000000', 'consum', 0.0224, 'lps'),
	(380230, 123, '2015-02-01 00:25:35.000000', 'consum', 0.0224, 'lps'),
	(380231, 123, '2015-02-01 00:25:36.000000', 'consum', 0.0223, 'lps'),
	(380232, 123, '2015-02-01 00:25:37.000000', 'consum', 0.0216, 'lps'),
	(380233, 123, '2015-02-01 00:25:38.000000', 'consum', 0.0216, 'lps'),
	(380234, 123, '2015-02-01 00:25:39.000000', 'consum', 0.0226, 'lps'),
	(380235, 123, '2015-02-01 00:25:40.000000', 'consum', 0.0218, 'lps'),
	(380236, 123, '2015-02-01 00:25:41.000000', 'consum', 0.0222, 'lps'),
	(380237, 123, '2015-02-01 00:25:42.000000', 'consum', 0.0211, 'lps'),
	(380238, 123, '2015-02-01 00:25:43.000000', 'consum', 0.0215, 'lps'),
	(380239, 123, '2015-02-01 00:25:44.000000', 'consum', 0.0217, 'lps'),
	(380240, 123, '2015-02-01 00:25:45.000000', 'consum', 0.0210, 'lps'),
	(380241, 123, '2015-02-01 00:25:46.000000', 'consum', 0.0225, 'lps'),
	(380242, 123, '2015-02-01 00:25:47.000000', 'consum', 0.0217, 'lps'),
	(380243, 123, '2015-02-01 00:25:48.000000', 'consum', 0.0219, 'lps'),
	(380244, 123, '2015-02-01 00:25:49.000000', 'consum', 0.0217, 'lps'),
	(380245, 123, '2015-02-01 00:25:50.000000', 'consum', 0.0220, 'lps'),
	(380246, 123, '2015-02-01 00:25:51.000000', 'consum', 0.0222, 'lps'),
	(380247, 123, '2015-02-01 00:25:52.000000', 'consum', 0.0222, 'lps'),
	(380248, 123, '2015-02-01 00:25:53.000000', 'consum', 0.0216, 'lps'),
	(380249, 123, '2015-02-01 00:25:54.000000', 'consum', 0.0224, 'lps'),
	(380250, 123, '2015-02-01 00:25:55.000000', 'consum', 0.0210, 'lps'),
	(380251, 123, '2015-02-01 00:25:56.000000', 'consum', 0.0219, 'lps'),
	(380252, 123, '2015-02-01 00:25:57.000000', 'consum', 0.0223, 'lps'),
	(380253, 123, '2015-02-01 00:25:58.000000', 'consum', 0.0215, 'lps'),
	(380254, 123, '2015-02-01 00:25:59.000000', 'consum', 0.0213, 'lps'),
	(380255, 123, '2015-02-01 00:26:00.000000', 'consum', 0.0212, 'lps'),
	(380256, 123, '2015-02-01 00:26:01.000000', 'consum', 0.0210, 'lps'),
	(380257, 123, '2015-02-01 00:26:02.000000', 'consum', 0.0223, 'lps'),
	(380258, 123, '2015-02-01 00:26:03.000000', 'consum', 0.0225, 'lps'),
	(380259, 123, '2015-02-01 00:26:04.000000', 'consum', 0.0211, 'lps'),
	(380260, 123, '2015-02-01 00:26:05.000000', 'consum', 0.0221, 'lps'),
	(380261, 123, '2015-02-01 00:26:06.000000', 'consum', 0.0213, 'lps'),
	(380262, 123, '2015-02-01 00:26:07.000000', 'consum', 0.0211, 'lps'),
	(380263, 123, '2015-02-01 00:26:08.000000', 'consum', 0.0220, 'lps'),
	(380264, 123, '2015-02-01 00:26:09.000000', 'consum', 0.0225, 'lps'),
	(380265, 123, '2015-02-01 00:26:10.000000', 'consum', 0.0221, 'lps'),
	(380266, 123, '2015-02-01 00:26:11.000000', 'consum', 0.0219, 'lps'),
	(380267, 123, '2015-02-01 00:26:12.000000', 'consum', 0.0223, 'lps'),
	(380268, 123, '2015-02-01 00:26:13.000000', 'consum', 0.0214, 'lps'),
	(380269, 123, '2015-02-01 00:26:14.000000', 'consum', 0.0210, 'lps'),
	(380270, 123, '2015-02-01 00:26:15.000000', 'consum', 0.0216, 'lps'),
	(380271, 123, '2015-02-01 00:26:16.000000', 'consum', 0.0221, 'lps'),
	(380272, 123, '2015-02-01 00:26:17.000000', 'consum', 0.0217, 'lps'),
	(380273, 123, '2015-02-01 00:26:18.000000', 'consum', 0.0226, 'lps'),
	(380274, 123, '2015-02-01 00:26:19.000000', 'consum', 0.0222, 'lps'),
	(380275, 123, '2015-02-01 00:26:20.000000', 'consum', 0.0220, 'lps'),
	(380276, 123, '2015-02-01 00:26:21.000000', 'consum', 0.0210, 'lps'),
	(380277, 123, '2015-02-01 00:26:22.000000', 'consum', 0.0211, 'lps'),
	(380278, 123, '2015-02-01 00:26:23.000000', 'consum', 0.0219, 'lps'),
	(380279, 123, '2015-02-01 00:26:24.000000', 'consum', 0.0216, 'lps'),
	(380280, 123, '2015-02-01 00:26:25.000000', 'consum', 0.0216, 'lps'),
	(380281, 123, '2015-02-01 00:26:26.000000', 'consum', 0.0221, 'lps'),
	(380282, 123, '2015-02-01 00:26:27.000000', 'consum', 0.0212, 'lps'),
	(380283, 123, '2015-02-01 00:26:28.000000', 'consum', 0.0223, 'lps'),
	(380284, 123, '2015-02-01 00:26:29.000000', 'consum', 0.0217, 'lps'),
	(380285, 123, '2015-02-01 00:26:30.000000', 'consum', 0.0225, 'lps'),
	(380286, 123, '2015-02-01 00:26:31.000000', 'consum', 0.0213, 'lps'),
	(380287, 123, '2015-02-01 00:26:32.000000', 'consum', 0.0216, 'lps'),
	(380288, 123, '2015-02-01 00:26:33.000000', 'consum', 0.0212, 'lps'),
	(380289, 123, '2015-02-01 00:26:34.000000', 'consum', 0.0223, 'lps'),
	(380290, 123, '2015-02-01 00:26:35.000000', 'consum', 0.0215, 'lps'),
	(380291, 123, '2015-02-01 00:26:36.000000', 'consum', 0.0213, 'lps'),
	(380292, 123, '2015-02-01 00:26:37.000000', 'consum', 0.0214, 'lps'),
	(380293, 123, '2015-02-01 00:26:38.000000', 'consum', 0.0218, 'lps'),
	(380294, 123, '2015-02-01 00:26:39.000000', 'consum', 0.0224, 'lps'),
	(380295, 123, '2015-02-01 00:26:40.000000', 'consum', 0.0221, 'lps'),
	(380296, 123, '2015-02-01 00:26:41.000000', 'consum', 0.0224, 'lps'),
	(380297, 123, '2015-02-01 00:26:42.000000', 'consum', 0.0212, 'lps'),
	(380298, 123, '2015-02-01 00:26:43.000000', 'consum', 0.0214, 'lps'),
	(380299, 123, '2015-02-01 00:26:44.000000', 'consum', 0.0223, 'lps'),
	(380300, 123, '2015-02-01 00:26:45.000000', 'consum', 0.0212, 'lps'),
	(380301, 123, '2015-02-01 00:26:46.000000', 'consum', 0.0215, 'lps'),
	(380302, 123, '2015-02-01 00:26:47.000000', 'consum', 0.0213, 'lps'),
	(380303, 123, '2015-02-01 00:26:48.000000', 'consum', 0.0210, 'lps'),
	(380304, 123, '2015-02-01 00:26:49.000000', 'consum', 0.0220, 'lps'),
	(380305, 123, '2015-02-01 00:26:50.000000', 'consum', 0.0210, 'lps'),
	(380306, 123, '2015-02-01 00:26:51.000000', 'consum', 0.0214, 'lps'),
	(380307, 123, '2015-02-01 00:26:52.000000', 'consum', 0.0211, 'lps'),
	(380308, 123, '2015-02-01 00:26:53.000000', 'consum', 0.0223, 'lps'),
	(380309, 123, '2015-02-01 00:26:54.000000', 'consum', 0.0223, 'lps'),
	(380310, 123, '2015-02-01 00:26:55.000000', 'consum', 0.0216, 'lps'),
	(380311, 123, '2015-02-01 00:26:56.000000', 'consum', 0.0221, 'lps'),
	(380312, 123, '2015-02-01 00:26:57.000000', 'consum', 0.0212, 'lps'),
	(380313, 123, '2015-02-01 00:26:58.000000', 'consum', 0.0221, 'lps'),
	(380314, 123, '2015-02-01 00:26:59.000000', 'consum', 0.0225, 'lps'),
	(380315, 123, '2015-02-01 00:27:00.000000', 'consum', 0.0218, 'lps'),
	(380316, 123, '2015-02-01 00:27:01.000000', 'consum', 0.0225, 'lps'),
	(380317, 123, '2015-02-01 00:27:02.000000', 'consum', 0.0224, 'lps'),
	(380318, 123, '2015-02-01 00:27:03.000000', 'consum', 0.0222, 'lps'),
	(380319, 123, '2015-02-01 00:27:04.000000', 'consum', 0.0226, 'lps'),
	(380320, 123, '2015-02-01 00:27:05.000000', 'consum', 0.0219, 'lps'),
	(380321, 123, '2015-02-01 00:27:06.000000', 'consum', 0.0210, 'lps'),
	(380322, 123, '2015-02-01 00:27:07.000000', 'consum', 0.0218, 'lps'),
	(380323, 123, '2015-02-01 00:27:08.000000', 'consum', 0.0215, 'lps'),
	(380324, 123, '2015-02-01 00:27:09.000000', 'consum', 0.0210, 'lps'),
	(380325, 123, '2015-02-01 00:27:10.000000', 'consum', 0.0214, 'lps'),
	(380326, 123, '2015-02-01 00:27:11.000000', 'consum', 0.0215, 'lps'),
	(380327, 123, '2015-02-01 00:27:12.000000', 'consum', 0.0222, 'lps'),
	(380328, 123, '2015-02-01 00:27:13.000000', 'consum', 0.0221, 'lps'),
	(380329, 123, '2015-02-01 00:27:14.000000', 'consum', 0.0211, 'lps'),
	(380330, 123, '2015-02-01 00:27:15.000000', 'consum', 0.0220, 'lps'),
	(380331, 123, '2015-02-01 00:27:16.000000', 'consum', 0.0221, 'lps'),
	(380332, 123, '2015-02-01 00:27:17.000000', 'consum', 0.0221, 'lps'),
	(380333, 123, '2015-02-01 00:27:18.000000', 'consum', 0.0215, 'lps'),
	(380334, 123, '2015-02-01 00:27:19.000000', 'consum', 0.0219, 'lps'),
	(380335, 123, '2015-02-01 00:27:20.000000', 'consum', 0.0222, 'lps'),
	(380336, 123, '2015-02-01 00:27:21.000000', 'consum', 0.0211, 'lps'),
	(380337, 123, '2015-02-01 00:27:22.000000', 'consum', 0.0212, 'lps'),
	(380338, 123, '2015-02-01 00:27:23.000000', 'consum', 0.0219, 'lps'),
	(380339, 123, '2015-02-01 00:27:24.000000', 'consum', 0.0213, 'lps'),
	(380340, 123, '2015-02-01 00:27:25.000000', 'consum', 0.0218, 'lps'),
	(380341, 123, '2015-02-01 00:27:26.000000', 'consum', 0.0225, 'lps'),
	(380342, 123, '2015-02-01 00:27:27.000000', 'consum', 0.0211, 'lps'),
	(380343, 123, '2015-02-01 00:27:28.000000', 'consum', 0.0222, 'lps'),
	(380344, 123, '2015-02-01 00:27:29.000000', 'consum', 0.0213, 'lps'),
	(380345, 123, '2015-02-01 00:27:30.000000', 'consum', 0.0210, 'lps'),
	(380346, 123, '2015-02-01 00:27:31.000000', 'consum', 0.0217, 'lps'),
	(380347, 123, '2015-02-01 00:27:32.000000', 'consum', 0.0212, 'lps'),
	(380348, 123, '2015-02-01 00:27:33.000000', 'consum', 0.0216, 'lps'),
	(380349, 123, '2015-02-01 00:27:34.000000', 'consum', 0.0216, 'lps'),
	(380350, 123, '2015-02-01 00:27:35.000000', 'consum', 0.0225, 'lps'),
	(380351, 123, '2015-02-01 00:27:36.000000', 'consum', 0.0218, 'lps'),
	(380352, 123, '2015-02-01 00:27:37.000000', 'consum', 0.0220, 'lps'),
	(380353, 123, '2015-02-01 00:27:38.000000', 'consum', 0.0219, 'lps'),
	(380354, 123, '2015-02-01 00:27:39.000000', 'consum', 0.0224, 'lps'),
	(380355, 123, '2015-02-01 00:27:40.000000', 'consum', 0.0222, 'lps'),
	(380356, 123, '2015-02-01 00:27:41.000000', 'consum', 0.0211, 'lps'),
	(380357, 123, '2015-02-01 00:27:42.000000', 'consum', 0.0212, 'lps'),
	(380358, 123, '2015-02-01 00:27:43.000000', 'consum', 0.0218, 'lps'),
	(380359, 123, '2015-02-01 00:27:44.000000', 'consum', 0.0226, 'lps'),
	(380360, 123, '2015-02-01 00:27:45.000000', 'consum', 0.0217, 'lps'),
	(380361, 123, '2015-02-01 00:27:46.000000', 'consum', 0.0213, 'lps'),
	(380362, 123, '2015-02-01 00:27:47.000000', 'consum', 0.0223, 'lps'),
	(380363, 123, '2015-02-01 00:27:48.000000', 'consum', 0.0214, 'lps'),
	(380364, 123, '2015-02-01 00:27:49.000000', 'consum', 0.0211, 'lps'),
	(380365, 123, '2015-02-01 00:27:50.000000', 'consum', 0.0218, 'lps'),
	(380366, 123, '2015-02-01 00:27:51.000000', 'consum', 0.0215, 'lps'),
	(380367, 123, '2015-02-01 00:27:52.000000', 'consum', 0.0212, 'lps'),
	(380368, 123, '2015-02-01 00:27:53.000000', 'consum', 0.0224, 'lps'),
	(380369, 123, '2015-02-01 00:27:54.000000', 'consum', 0.0220, 'lps'),
	(380370, 123, '2015-02-01 00:27:55.000000', 'consum', 0.0221, 'lps'),
	(380371, 123, '2015-02-01 00:27:56.000000', 'consum', 0.0216, 'lps'),
	(380372, 123, '2015-02-01 00:27:57.000000', 'consum', 0.0210, 'lps'),
	(380373, 123, '2015-02-01 00:27:58.000000', 'consum', 0.0210, 'lps'),
	(380374, 123, '2015-02-01 00:27:59.000000', 'consum', 0.0225, 'lps'),
	(380375, 123, '2015-02-01 00:28:00.000000', 'consum', 0.0218, 'lps'),
	(380376, 123, '2015-02-01 00:28:01.000000', 'consum', 0.0222, 'lps'),
	(380377, 123, '2015-02-01 00:28:02.000000', 'consum', 0.0213, 'lps'),
	(380378, 123, '2015-02-01 00:28:03.000000', 'consum', 0.0223, 'lps'),
	(380379, 123, '2015-02-01 00:28:04.000000', 'consum', 0.0217, 'lps'),
	(380380, 123, '2015-02-01 00:28:05.000000', 'consum', 0.0222, 'lps'),
	(380381, 123, '2015-02-01 00:28:06.000000', 'consum', 0.0215, 'lps'),
	(380382, 123, '2015-02-01 00:28:07.000000', 'consum', 0.0219, 'lps'),
	(380383, 123, '2015-02-01 00:28:08.000000', 'consum', 0.0220, 'lps'),
	(380384, 123, '2015-02-01 00:28:09.000000', 'consum', 0.0219, 'lps'),
	(380385, 123, '2015-02-01 00:28:10.000000', 'consum', 0.0225, 'lps'),
	(380386, 123, '2015-02-01 00:28:11.000000', 'consum', 0.0224, 'lps'),
	(380387, 123, '2015-02-01 00:28:12.000000', 'consum', 0.0219, 'lps'),
	(380388, 123, '2015-02-01 00:28:13.000000', 'consum', 0.0212, 'lps'),
	(380389, 123, '2015-02-01 00:28:14.000000', 'consum', 0.0211, 'lps'),
	(380390, 123, '2015-02-01 00:28:15.000000', 'consum', 0.0212, 'lps'),
	(380391, 123, '2015-02-01 00:28:16.000000', 'consum', 0.0214, 'lps'),
	(380392, 123, '2015-02-01 00:28:17.000000', 'consum', 0.0225, 'lps'),
	(380393, 123, '2015-02-01 00:28:18.000000', 'consum', 0.0225, 'lps'),
	(380394, 123, '2015-02-01 00:28:19.000000', 'consum', 0.0221, 'lps'),
	(380395, 123, '2015-02-01 00:28:20.000000', 'consum', 0.0221, 'lps'),
	(380396, 123, '2015-02-01 00:28:21.000000', 'consum', 0.0215, 'lps'),
	(380397, 123, '2015-02-01 00:28:22.000000', 'consum', 0.0221, 'lps'),
	(380398, 123, '2015-02-01 00:28:23.000000', 'consum', 0.0215, 'lps'),
	(380399, 123, '2015-02-01 00:28:24.000000', 'consum', 0.0221, 'lps'),
	(380400, 123, '2015-02-01 00:28:25.000000', 'consum', 0.0214, 'lps'),
	(380401, 123, '2015-02-01 00:28:26.000000', 'consum', 0.0216, 'lps'),
	(380402, 123, '2015-02-01 00:28:27.000000', 'consum', 0.0210, 'lps'),
	(380403, 123, '2015-02-01 00:28:28.000000', 'consum', 0.0211, 'lps'),
	(380404, 123, '2015-02-01 00:28:29.000000', 'consum', 0.0217, 'lps'),
	(380405, 123, '2015-02-01 00:28:30.000000', 'consum', 0.0224, 'lps'),
	(380406, 123, '2015-02-01 00:28:31.000000', 'consum', 0.0225, 'lps'),
	(380407, 123, '2015-02-01 00:28:32.000000', 'consum', 0.0211, 'lps'),
	(380408, 123, '2015-02-01 00:28:33.000000', 'consum', 0.0219, 'lps'),
	(380409, 123, '2015-02-01 00:28:34.000000', 'consum', 0.0220, 'lps'),
	(380410, 123, '2015-02-01 00:28:35.000000', 'consum', 0.0215, 'lps'),
	(380411, 123, '2015-02-01 00:28:36.000000', 'consum', 0.0224, 'lps'),
	(380412, 123, '2015-02-01 00:28:37.000000', 'consum', 0.0213, 'lps'),
	(380413, 123, '2015-02-01 00:28:38.000000', 'consum', 0.0217, 'lps'),
	(380414, 123, '2015-02-01 00:28:39.000000', 'consum', 0.0221, 'lps'),
	(380415, 123, '2015-02-01 00:28:40.000000', 'consum', 0.0225, 'lps'),
	(380416, 123, '2015-02-01 00:28:41.000000', 'consum', 0.0222, 'lps'),
	(380417, 123, '2015-02-01 00:28:42.000000', 'consum', 0.0222, 'lps'),
	(380418, 123, '2015-02-01 00:28:43.000000', 'consum', 0.0221, 'lps'),
	(380419, 123, '2015-02-01 00:28:44.000000', 'consum', 0.0211, 'lps'),
	(380420, 123, '2015-02-01 00:28:45.000000', 'consum', 0.0216, 'lps'),
	(380421, 123, '2015-02-01 00:28:46.000000', 'consum', 0.0219, 'lps'),
	(380422, 123, '2015-02-01 00:28:47.000000', 'consum', 0.0222, 'lps'),
	(380423, 123, '2015-02-01 00:28:48.000000', 'consum', 0.0226, 'lps'),
	(380424, 123, '2015-02-01 00:28:49.000000', 'consum', 0.0222, 'lps'),
	(380425, 123, '2015-02-01 00:28:50.000000', 'consum', 0.0221, 'lps'),
	(380426, 123, '2015-02-01 00:28:51.000000', 'consum', 0.0213, 'lps'),
	(380427, 123, '2015-02-01 00:28:52.000000', 'consum', 0.0226, 'lps'),
	(380428, 123, '2015-02-01 00:28:53.000000', 'consum', 0.0215, 'lps'),
	(380429, 123, '2015-02-01 00:28:54.000000', 'consum', 0.0219, 'lps'),
	(380430, 123, '2015-02-01 00:28:55.000000', 'consum', 0.0224, 'lps'),
	(380431, 123, '2015-02-01 00:28:56.000000', 'consum', 0.0219, 'lps'),
	(380432, 123, '2015-02-01 00:28:57.000000', 'consum', 0.0212, 'lps'),
	(380433, 123, '2015-02-01 00:28:58.000000', 'consum', 0.0213, 'lps'),
	(380434, 123, '2015-02-01 00:28:59.000000', 'consum', 0.0220, 'lps'),
	(380435, 123, '2015-02-01 00:29:00.000000', 'consum', 0.0216, 'lps'),
	(380436, 123, '2015-02-01 00:29:01.000000', 'consum', 0.0211, 'lps'),
	(380437, 123, '2015-02-01 00:29:02.000000', 'consum', 0.0213, 'lps'),
	(380438, 123, '2015-02-01 00:29:03.000000', 'consum', 0.0224, 'lps'),
	(380439, 123, '2015-02-01 00:29:04.000000', 'consum', 0.0222, 'lps'),
	(380440, 123, '2015-02-01 00:29:05.000000', 'consum', 0.0211, 'lps'),
	(380441, 123, '2015-02-01 00:29:06.000000', 'consum', 0.0214, 'lps'),
	(380442, 123, '2015-02-01 00:29:07.000000', 'consum', 0.0226, 'lps'),
	(380443, 123, '2015-02-01 00:29:08.000000', 'consum', 0.0213, 'lps'),
	(380444, 123, '2015-02-01 00:29:09.000000', 'consum', 0.0225, 'lps'),
	(380445, 123, '2015-02-01 00:29:10.000000', 'consum', 0.0211, 'lps'),
	(380446, 123, '2015-02-01 00:29:11.000000', 'consum', 0.0220, 'lps'),
	(380447, 123, '2015-02-01 00:29:12.000000', 'consum', 0.0224, 'lps'),
	(380448, 123, '2015-02-01 00:29:13.000000', 'consum', 0.0218, 'lps'),
	(380449, 123, '2015-02-01 00:29:14.000000', 'consum', 0.0226, 'lps'),
	(380450, 123, '2015-02-01 00:29:15.000000', 'consum', 0.0216, 'lps'),
	(380451, 123, '2015-02-01 00:29:16.000000', 'consum', 0.0226, 'lps'),
	(380452, 123, '2015-02-01 00:29:17.000000', 'consum', 0.0223, 'lps'),
	(380453, 123, '2015-02-01 00:29:18.000000', 'consum', 0.0225, 'lps'),
	(380454, 123, '2015-02-01 00:29:19.000000', 'consum', 0.0214, 'lps'),
	(380455, 123, '2015-02-01 00:29:20.000000', 'consum', 0.0218, 'lps'),
	(380456, 123, '2015-02-01 00:29:21.000000', 'consum', 0.0223, 'lps'),
	(380457, 123, '2015-02-01 00:29:22.000000', 'consum', 0.0219, 'lps'),
	(380458, 123, '2015-02-01 00:29:23.000000', 'consum', 0.0213, 'lps'),
	(380459, 123, '2015-02-01 00:29:24.000000', 'consum', 0.0219, 'lps'),
	(380460, 123, '2015-02-01 00:29:25.000000', 'consum', 0.0226, 'lps'),
	(380461, 123, '2015-02-01 00:29:26.000000', 'consum', 0.0214, 'lps'),
	(380462, 123, '2015-02-01 00:29:27.000000', 'consum', 0.0215, 'lps'),
	(380463, 123, '2015-02-01 00:29:28.000000', 'consum', 0.0225, 'lps'),
	(380464, 123, '2015-02-01 00:29:29.000000', 'consum', 0.0217, 'lps'),
	(380465, 123, '2015-02-01 00:29:30.000000', 'consum', 0.0220, 'lps'),
	(380466, 123, '2015-02-01 00:29:31.000000', 'consum', 0.0223, 'lps'),
	(380467, 123, '2015-02-01 00:29:32.000000', 'consum', 0.0211, 'lps'),
	(380468, 123, '2015-02-01 00:29:33.000000', 'consum', 0.0226, 'lps'),
	(380469, 123, '2015-02-01 00:29:34.000000', 'consum', 0.0220, 'lps'),
	(380470, 123, '2015-02-01 00:29:35.000000', 'consum', 0.0213, 'lps'),
	(380471, 123, '2015-02-01 00:29:36.000000', 'consum', 0.0210, 'lps'),
	(380472, 123, '2015-02-01 00:29:37.000000', 'consum', 0.0221, 'lps'),
	(380473, 123, '2015-02-01 00:29:38.000000', 'consum', 0.0214, 'lps'),
	(380474, 123, '2015-02-01 00:29:39.000000', 'consum', 0.0216, 'lps'),
	(380475, 123, '2015-02-01 00:29:40.000000', 'consum', 0.0212, 'lps'),
	(380476, 123, '2015-02-01 00:29:41.000000', 'consum', 0.0216, 'lps'),
	(380477, 123, '2015-02-01 00:29:42.000000', 'consum', 0.0220, 'lps'),
	(380478, 123, '2015-02-01 00:29:43.000000', 'consum', 0.0226, 'lps'),
	(380479, 123, '2015-02-01 00:29:44.000000', 'consum', 0.0226, 'lps'),
	(380480, 123, '2015-02-01 00:29:45.000000', 'consum', 0.0225, 'lps'),
	(380481, 123, '2015-02-01 00:29:46.000000', 'consum', 0.0219, 'lps'),
	(380482, 123, '2015-02-01 00:29:47.000000', 'consum', 0.0210, 'lps'),
	(380483, 123, '2015-02-01 00:29:48.000000', 'consum', 0.0219, 'lps'),
	(380484, 123, '2015-02-01 00:29:49.000000', 'consum', 0.0219, 'lps'),
	(380485, 123, '2015-02-01 00:29:50.000000', 'consum', 0.0215, 'lps'),
	(380486, 123, '2015-02-01 00:29:51.000000', 'consum', 0.0225, 'lps'),
	(380487, 123, '2015-02-01 00:29:52.000000', 'consum', 0.0220, 'lps'),
	(380488, 123, '2015-02-01 00:29:53.000000', 'consum', 0.0213, 'lps'),
	(380489, 123, '2015-02-01 00:29:54.000000', 'consum', 0.0212, 'lps'),
	(380490, 123, '2015-02-01 00:29:55.000000', 'consum', 0.0213, 'lps'),
	(380491, 123, '2015-02-01 00:29:56.000000', 'consum', 0.0220, 'lps'),
	(380492, 123, '2015-02-01 00:29:57.000000', 'consum', 0.0216, 'lps'),
	(380493, 123, '2015-02-01 00:29:58.000000', 'consum', 0.0211, 'lps'),
	(380494, 123, '2015-02-01 00:29:59.000000', 'consum', 0.0215, 'lps'),
	(380495, 123, '2015-02-01 00:30:00.000000', 'consum', 0.0216, 'lps'),
	(380496, 123, '2015-02-01 00:30:01.000000', 'consum', 0.0226, 'lps'),
	(380497, 123, '2015-02-01 00:30:02.000000', 'consum', 0.0221, 'lps'),
	(380498, 123, '2015-02-01 00:30:03.000000', 'consum', 0.0219, 'lps'),
	(380499, 123, '2015-02-01 00:30:04.000000', 'consum', 0.0220, 'lps'),
	(380500, 123, '2015-02-01 00:30:05.000000', 'consum', 0.0217, 'lps'),
	(380501, 123, '2015-02-01 00:30:06.000000', 'consum', 0.0217, 'lps'),
	(380502, 123, '2015-02-01 00:30:07.000000', 'consum', 0.0223, 'lps'),
	(380503, 123, '2015-02-01 00:30:08.000000', 'consum', 0.0222, 'lps'),
	(380504, 123, '2015-02-01 00:30:09.000000', 'consum', 0.0213, 'lps'),
	(380505, 123, '2015-02-01 00:30:10.000000', 'consum', 0.0222, 'lps'),
	(380506, 123, '2015-02-01 00:30:11.000000', 'consum', 0.0213, 'lps'),
	(380507, 123, '2015-02-01 00:30:12.000000', 'consum', 0.0224, 'lps'),
	(380508, 123, '2015-02-01 00:30:13.000000', 'consum', 0.0221, 'lps'),
	(380509, 123, '2015-02-01 00:30:14.000000', 'consum', 0.0222, 'lps'),
	(380510, 123, '2015-02-01 00:30:15.000000', 'consum', 0.0220, 'lps'),
	(380511, 123, '2015-02-01 00:30:16.000000', 'consum', 0.0224, 'lps'),
	(380512, 123, '2015-02-01 00:30:17.000000', 'consum', 0.0218, 'lps'),
	(380513, 123, '2015-02-01 00:30:18.000000', 'consum', 0.0210, 'lps'),
	(380514, 123, '2015-02-01 00:30:19.000000', 'consum', 0.0219, 'lps'),
	(380515, 123, '2015-02-01 00:30:20.000000', 'consum', 0.0222, 'lps'),
	(380516, 123, '2015-02-01 00:30:21.000000', 'consum', 0.0225, 'lps'),
	(380517, 123, '2015-02-01 00:30:22.000000', 'consum', 0.0217, 'lps'),
	(380518, 123, '2015-02-01 00:30:23.000000', 'consum', 0.0219, 'lps'),
	(380519, 123, '2015-02-01 00:30:24.000000', 'consum', 0.0215, 'lps'),
	(380520, 123, '2015-02-01 00:30:25.000000', 'consum', 0.0225, 'lps'),
	(380521, 123, '2015-02-01 00:30:26.000000', 'consum', 0.0221, 'lps'),
	(380522, 123, '2015-02-01 00:30:27.000000', 'consum', 0.0220, 'lps'),
	(380523, 123, '2015-02-01 00:30:28.000000', 'consum', 0.0226, 'lps'),
	(380524, 123, '2015-02-01 00:30:29.000000', 'consum', 0.0211, 'lps'),
	(380525, 123, '2015-02-01 00:30:30.000000', 'consum', 0.0217, 'lps'),
	(380526, 123, '2015-02-01 00:30:31.000000', 'consum', 0.0210, 'lps'),
	(380527, 123, '2015-02-01 00:30:32.000000', 'consum', 0.0223, 'lps'),
	(380528, 123, '2015-02-01 00:30:33.000000', 'consum', 0.0223, 'lps'),
	(380529, 123, '2015-02-01 00:30:34.000000', 'consum', 0.0220, 'lps'),
	(380530, 123, '2015-02-01 00:30:35.000000', 'consum', 0.0222, 'lps'),
	(380531, 123, '2015-02-01 00:30:36.000000', 'consum', 0.0222, 'lps'),
	(380532, 123, '2015-02-01 00:30:37.000000', 'consum', 0.0219, 'lps'),
	(380533, 123, '2015-02-01 00:30:38.000000', 'consum', 0.0218, 'lps'),
	(380534, 123, '2015-02-01 00:30:39.000000', 'consum', 0.0224, 'lps'),
	(380535, 123, '2015-02-01 00:30:40.000000', 'consum', 0.0222, 'lps'),
	(380536, 123, '2015-02-01 00:30:41.000000', 'consum', 0.0213, 'lps'),
	(380537, 123, '2015-02-01 00:30:42.000000', 'consum', 0.0222, 'lps'),
	(380538, 123, '2015-02-01 00:30:43.000000', 'consum', 0.0213, 'lps'),
	(380539, 123, '2015-02-01 00:30:44.000000', 'consum', 0.0222, 'lps'),
	(380540, 123, '2015-02-01 00:30:45.000000', 'consum', 0.0210, 'lps'),
	(380541, 123, '2015-02-01 00:30:46.000000', 'consum', 0.0226, 'lps'),
	(380542, 123, '2015-02-01 00:30:47.000000', 'consum', 0.0222, 'lps'),
	(380543, 123, '2015-02-01 00:30:48.000000', 'consum', 0.0223, 'lps'),
	(380544, 123, '2015-02-01 00:30:49.000000', 'consum', 0.0222, 'lps'),
	(380545, 123, '2015-02-01 00:30:50.000000', 'consum', 0.0217, 'lps'),
	(380546, 123, '2015-02-01 00:30:51.000000', 'consum', 0.0224, 'lps'),
	(380547, 123, '2015-02-01 00:30:52.000000', 'consum', 0.0226, 'lps'),
	(380548, 123, '2015-02-01 00:30:53.000000', 'consum', 0.0213, 'lps'),
	(380549, 123, '2015-02-01 00:30:54.000000', 'consum', 0.0210, 'lps'),
	(380550, 123, '2015-02-01 00:30:55.000000', 'consum', 0.0222, 'lps'),
	(380551, 123, '2015-02-01 00:30:56.000000', 'consum', 0.0220, 'lps'),
	(380552, 123, '2015-02-01 00:30:57.000000', 'consum', 0.0223, 'lps'),
	(380553, 123, '2015-02-01 00:30:58.000000', 'consum', 0.0212, 'lps'),
	(380554, 123, '2015-02-01 00:30:59.000000', 'consum', 0.0215, 'lps'),
	(380555, 123, '2015-02-01 00:31:00.000000', 'consum', 0.0212, 'lps'),
	(380556, 123, '2015-02-01 00:31:01.000000', 'consum', 0.0224, 'lps'),
	(380557, 123, '2015-02-01 00:31:02.000000', 'consum', 0.0222, 'lps'),
	(380558, 123, '2015-02-01 00:31:03.000000', 'consum', 0.0212, 'lps'),
	(380559, 123, '2015-02-01 00:31:04.000000', 'consum', 0.0220, 'lps'),
	(380560, 123, '2015-02-01 00:31:05.000000', 'consum', 0.0221, 'lps'),
	(380561, 123, '2015-02-01 00:31:06.000000', 'consum', 0.0216, 'lps'),
	(380562, 123, '2015-02-01 00:31:07.000000', 'consum', 0.0223, 'lps'),
	(380563, 123, '2015-02-01 00:31:08.000000', 'consum', 0.0210, 'lps'),
	(380564, 123, '2015-02-01 00:31:09.000000', 'consum', 0.0222, 'lps'),
	(380565, 123, '2015-02-01 00:31:10.000000', 'consum', 0.0221, 'lps'),
	(380566, 123, '2015-02-01 00:31:11.000000', 'consum', 0.0211, 'lps'),
	(380567, 123, '2015-02-01 00:31:12.000000', 'consum', 0.0215, 'lps'),
	(380568, 123, '2015-02-01 00:31:13.000000', 'consum', 0.0216, 'lps'),
	(380569, 123, '2015-02-01 00:31:14.000000', 'consum', 0.0224, 'lps'),
	(380570, 123, '2015-02-01 00:31:15.000000', 'consum', 0.0215, 'lps'),
	(380571, 123, '2015-02-01 00:31:16.000000', 'consum', 0.0225, 'lps'),
	(380572, 123, '2015-02-01 00:31:17.000000', 'consum', 0.0221, 'lps'),
	(380573, 123, '2015-02-01 00:31:18.000000', 'consum', 0.0218, 'lps'),
	(380574, 123, '2015-02-01 00:31:19.000000', 'consum', 0.0218, 'lps'),
	(380575, 123, '2015-02-01 00:31:20.000000', 'consum', 0.0210, 'lps'),
	(380576, 123, '2015-02-01 00:31:21.000000', 'consum', 0.0222, 'lps'),
	(380577, 123, '2015-02-01 00:31:22.000000', 'consum', 0.0218, 'lps'),
	(380578, 123, '2015-02-01 00:31:23.000000', 'consum', 0.0217, 'lps'),
	(380579, 123, '2015-02-01 00:31:24.000000', 'consum', 0.0220, 'lps'),
	(380580, 123, '2015-02-01 00:31:25.000000', 'consum', 0.0221, 'lps'),
	(380581, 123, '2015-02-01 00:31:26.000000', 'consum', 0.0221, 'lps'),
	(380582, 123, '2015-02-01 00:31:27.000000', 'consum', 0.0214, 'lps'),
	(380583, 123, '2015-02-01 00:31:28.000000', 'consum', 0.0214, 'lps'),
	(380584, 123, '2015-02-01 00:31:29.000000', 'consum', 0.0221, 'lps'),
	(380585, 123, '2015-02-01 00:31:30.000000', 'consum', 0.0219, 'lps'),
	(380586, 123, '2015-02-01 00:31:31.000000', 'consum', 0.0222, 'lps'),
	(380587, 123, '2015-02-01 00:31:32.000000', 'consum', 0.0224, 'lps'),
	(380588, 123, '2015-02-01 00:31:33.000000', 'consum', 0.0214, 'lps'),
	(380589, 123, '2015-02-01 00:31:34.000000', 'consum', 0.0222, 'lps'),
	(380590, 123, '2015-02-01 00:31:35.000000', 'consum', 0.0224, 'lps'),
	(380591, 123, '2015-02-01 00:31:36.000000', 'consum', 0.0212, 'lps'),
	(380592, 123, '2015-02-01 00:31:37.000000', 'consum', 0.0213, 'lps'),
	(380593, 123, '2015-02-01 00:31:38.000000', 'consum', 0.0218, 'lps'),
	(380594, 123, '2015-02-01 00:31:39.000000', 'consum', 0.0223, 'lps'),
	(380595, 123, '2015-02-01 00:31:40.000000', 'consum', 0.0218, 'lps'),
	(380596, 123, '2015-02-01 00:31:41.000000', 'consum', 0.0213, 'lps'),
	(380597, 123, '2015-02-01 00:31:42.000000', 'consum', 0.0220, 'lps'),
	(380598, 123, '2015-02-01 00:31:43.000000', 'consum', 0.0215, 'lps'),
	(380599, 123, '2015-02-01 00:31:44.000000', 'consum', 0.0224, 'lps'),
	(380600, 123, '2015-02-01 00:31:45.000000', 'consum', 0.0216, 'lps'),
	(380601, 123, '2015-02-01 00:31:46.000000', 'consum', 0.0214, 'lps'),
	(380602, 123, '2015-02-01 00:31:47.000000', 'consum', 0.0210, 'lps'),
	(380603, 123, '2015-02-01 00:31:48.000000', 'consum', 0.0219, 'lps'),
	(380604, 123, '2015-02-01 00:31:49.000000', 'consum', 0.0222, 'lps'),
	(380605, 123, '2015-02-01 00:31:50.000000', 'consum', 0.0225, 'lps'),
	(380606, 123, '2015-02-01 00:31:51.000000', 'consum', 0.0217, 'lps'),
	(380607, 123, '2015-02-01 00:31:52.000000', 'consum', 0.0216, 'lps'),
	(380608, 123, '2015-02-01 00:31:53.000000', 'consum', 0.0222, 'lps'),
	(380609, 123, '2015-02-01 00:31:54.000000', 'consum', 0.0216, 'lps'),
	(380610, 123, '2015-02-01 00:31:55.000000', 'consum', 0.0222, 'lps'),
	(380611, 123, '2015-02-01 00:31:56.000000', 'consum', 0.0218, 'lps'),
	(380612, 123, '2015-02-01 00:31:57.000000', 'consum', 0.0217, 'lps'),
	(380613, 123, '2015-02-01 00:31:58.000000', 'consum', 0.0219, 'lps'),
	(380614, 123, '2015-02-01 00:31:59.000000', 'consum', 0.0219, 'lps'),
	(380615, 123, '2015-02-01 00:32:00.000000', 'consum', 0.0213, 'lps'),
	(380616, 123, '2015-02-01 00:32:01.000000', 'consum', 0.0213, 'lps'),
	(380617, 123, '2015-02-01 00:32:02.000000', 'consum', 0.0217, 'lps'),
	(380618, 123, '2015-02-01 00:32:03.000000', 'consum', 0.0219, 'lps'),
	(380619, 123, '2015-02-01 00:32:04.000000', 'consum', 0.0217, 'lps'),
	(380620, 123, '2015-02-01 00:32:05.000000', 'consum', 0.0218, 'lps'),
	(380621, 123, '2015-02-01 00:32:06.000000', 'consum', 0.0212, 'lps'),
	(380622, 123, '2015-02-01 00:32:07.000000', 'consum', 0.0216, 'lps'),
	(380623, 123, '2015-02-01 00:32:08.000000', 'consum', 0.0215, 'lps'),
	(380624, 123, '2015-02-01 00:32:09.000000', 'consum', 0.0219, 'lps'),
	(380625, 123, '2015-02-01 00:32:10.000000', 'consum', 0.0225, 'lps'),
	(380626, 123, '2015-02-01 00:32:11.000000', 'consum', 0.0223, 'lps'),
	(380627, 123, '2015-02-01 00:32:12.000000', 'consum', 0.0213, 'lps'),
	(380628, 123, '2015-02-01 00:32:13.000000', 'consum', 0.0222, 'lps'),
	(380629, 123, '2015-02-01 00:32:14.000000', 'consum', 0.0225, 'lps'),
	(380630, 123, '2015-02-01 00:32:15.000000', 'consum', 0.0217, 'lps'),
	(380631, 123, '2015-02-01 00:32:16.000000', 'consum', 0.0217, 'lps'),
	(380632, 123, '2015-02-01 00:32:17.000000', 'consum', 0.0224, 'lps'),
	(380633, 123, '2015-02-01 00:32:18.000000', 'consum', 0.0210, 'lps'),
	(380634, 123, '2015-02-01 00:32:19.000000', 'consum', 0.0219, 'lps'),
	(380635, 123, '2015-02-01 00:32:20.000000', 'consum', 0.0220, 'lps'),
	(380636, 123, '2015-02-01 00:32:21.000000', 'consum', 0.0218, 'lps'),
	(380637, 123, '2015-02-01 00:32:22.000000', 'consum', 0.0219, 'lps'),
	(380638, 123, '2015-02-01 00:32:23.000000', 'consum', 0.0217, 'lps'),
	(380639, 123, '2015-02-01 00:32:24.000000', 'consum', 0.0218, 'lps'),
	(380640, 123, '2015-02-01 00:32:25.000000', 'consum', 0.0212, 'lps'),
	(380641, 123, '2015-02-01 00:32:26.000000', 'consum', 0.0212, 'lps'),
	(380642, 123, '2015-02-01 00:32:27.000000', 'consum', 0.0217, 'lps'),
	(380643, 123, '2015-02-01 00:32:28.000000', 'consum', 0.0222, 'lps'),
	(380644, 123, '2015-02-01 00:32:29.000000', 'consum', 0.0214, 'lps'),
	(380645, 123, '2015-02-01 00:32:30.000000', 'consum', 0.0210, 'lps'),
	(380646, 123, '2015-02-01 00:32:31.000000', 'consum', 0.0219, 'lps'),
	(380647, 123, '2015-02-01 00:32:32.000000', 'consum', 0.0221, 'lps'),
	(380648, 123, '2015-02-01 00:32:33.000000', 'consum', 0.0220, 'lps'),
	(380649, 123, '2015-02-01 00:32:34.000000', 'consum', 0.0210, 'lps'),
	(380650, 123, '2015-02-01 00:32:35.000000', 'consum', 0.0214, 'lps'),
	(380651, 123, '2015-02-01 00:32:36.000000', 'consum', 0.0214, 'lps'),
	(380652, 123, '2015-02-01 00:32:37.000000', 'consum', 0.0220, 'lps'),
	(380653, 123, '2015-02-01 00:32:38.000000', 'consum', 0.0215, 'lps'),
	(380654, 123, '2015-02-01 00:32:39.000000', 'consum', 0.0219, 'lps'),
	(380655, 123, '2015-02-01 00:32:40.000000', 'consum', 0.0210, 'lps'),
	(380656, 123, '2015-02-01 00:32:41.000000', 'consum', 0.0218, 'lps'),
	(380657, 123, '2015-02-01 00:32:42.000000', 'consum', 0.0215, 'lps'),
	(380658, 123, '2015-02-01 00:32:43.000000', 'consum', 0.0212, 'lps'),
	(380659, 123, '2015-02-01 00:32:44.000000', 'consum', 0.0223, 'lps'),
	(380660, 123, '2015-02-01 00:32:45.000000', 'consum', 0.0217, 'lps'),
	(380661, 123, '2015-02-01 00:32:46.000000', 'consum', 0.0226, 'lps'),
	(380662, 123, '2015-02-01 00:32:47.000000', 'consum', 0.0215, 'lps'),
	(380663, 123, '2015-02-01 00:32:48.000000', 'consum', 0.0224, 'lps'),
	(380664, 123, '2015-02-01 00:32:49.000000', 'consum', 0.0214, 'lps'),
	(380665, 123, '2015-02-01 00:32:50.000000', 'consum', 0.0222, 'lps'),
	(380666, 123, '2015-02-01 00:32:51.000000', 'consum', 0.0223, 'lps'),
	(380667, 123, '2015-02-01 00:32:52.000000', 'consum', 0.0225, 'lps'),
	(380668, 123, '2015-02-01 00:32:53.000000', 'consum', 0.0212, 'lps'),
	(380669, 123, '2015-02-01 00:32:54.000000', 'consum', 0.0224, 'lps'),
	(380670, 123, '2015-02-01 00:32:55.000000', 'consum', 0.0210, 'lps'),
	(380671, 123, '2015-02-01 00:32:56.000000', 'consum', 0.0216, 'lps'),
	(380672, 123, '2015-02-01 00:32:57.000000', 'consum', 0.0225, 'lps'),
	(380673, 123, '2015-02-01 00:32:58.000000', 'consum', 0.0219, 'lps'),
	(380674, 123, '2015-02-01 00:32:59.000000', 'consum', 0.0224, 'lps'),
	(380675, 123, '2015-02-01 00:33:00.000000', 'consum', 0.0219, 'lps'),
	(380676, 123, '2015-02-01 00:33:01.000000', 'consum', 0.0215, 'lps'),
	(380677, 123, '2015-02-01 00:33:02.000000', 'consum', 0.0225, 'lps'),
	(380678, 123, '2015-02-01 00:33:03.000000', 'consum', 0.0218, 'lps'),
	(380679, 123, '2015-02-01 00:33:04.000000', 'consum', 0.0224, 'lps'),
	(380680, 123, '2015-02-01 00:33:05.000000', 'consum', 0.0221, 'lps'),
	(380681, 123, '2015-02-01 00:33:06.000000', 'consum', 0.0224, 'lps'),
	(380682, 123, '2015-02-01 00:33:07.000000', 'consum', 0.0212, 'lps'),
	(380683, 123, '2015-02-01 00:33:08.000000', 'consum', 0.0214, 'lps'),
	(380684, 123, '2015-02-01 00:33:09.000000', 'consum', 0.0226, 'lps'),
	(380685, 123, '2015-02-01 00:33:10.000000', 'consum', 0.0226, 'lps'),
	(380686, 123, '2015-02-01 00:33:11.000000', 'consum', 0.0226, 'lps'),
	(380687, 123, '2015-02-01 00:33:12.000000', 'consum', 0.0210, 'lps'),
	(380688, 123, '2015-02-01 00:33:13.000000', 'consum', 0.0210, 'lps'),
	(380689, 123, '2015-02-01 00:33:14.000000', 'consum', 0.0214, 'lps'),
	(380690, 123, '2015-02-01 00:33:15.000000', 'consum', 0.0211, 'lps'),
	(380691, 123, '2015-02-01 00:33:16.000000', 'consum', 0.0222, 'lps'),
	(380692, 123, '2015-02-01 00:33:17.000000', 'consum', 0.0217, 'lps'),
	(380693, 123, '2015-02-01 00:33:18.000000', 'consum', 0.0225, 'lps'),
	(380694, 123, '2015-02-01 00:33:19.000000', 'consum', 0.0215, 'lps'),
	(380695, 123, '2015-02-01 00:33:20.000000', 'consum', 0.0224, 'lps'),
	(380696, 123, '2015-02-01 00:33:21.000000', 'consum', 0.0213, 'lps'),
	(380697, 123, '2015-02-01 00:33:22.000000', 'consum', 0.0218, 'lps'),
	(380698, 123, '2015-02-01 00:33:23.000000', 'consum', 0.0223, 'lps'),
	(380699, 123, '2015-02-01 00:33:24.000000', 'consum', 0.0218, 'lps'),
	(380700, 123, '2015-02-01 00:33:25.000000', 'consum', 0.0213, 'lps'),
	(380701, 123, '2015-02-01 00:33:26.000000', 'consum', 0.0219, 'lps'),
	(380702, 123, '2015-02-01 00:33:27.000000', 'consum', 0.0211, 'lps'),
	(380703, 123, '2015-02-01 00:33:28.000000', 'consum', 0.0224, 'lps'),
	(380704, 123, '2015-02-01 00:33:29.000000', 'consum', 0.0226, 'lps'),
	(380705, 123, '2015-02-01 00:33:30.000000', 'consum', 0.0216, 'lps'),
	(380706, 123, '2015-02-01 00:33:31.000000', 'consum', 0.0210, 'lps'),
	(380707, 123, '2015-02-01 00:33:32.000000', 'consum', 0.0225, 'lps'),
	(380708, 123, '2015-02-01 00:33:33.000000', 'consum', 0.0217, 'lps'),
	(380709, 123, '2015-02-01 00:33:34.000000', 'consum', 0.0219, 'lps'),
	(380710, 123, '2015-02-01 00:33:35.000000', 'consum', 0.0215, 'lps'),
	(380711, 123, '2015-02-01 00:33:36.000000', 'consum', 0.0226, 'lps'),
	(380712, 123, '2015-02-01 00:33:37.000000', 'consum', 0.0225, 'lps'),
	(380713, 123, '2015-02-01 00:33:38.000000', 'consum', 0.0220, 'lps'),
	(380714, 123, '2015-02-01 00:33:39.000000', 'consum', 0.0217, 'lps'),
	(380715, 123, '2015-02-01 00:33:40.000000', 'consum', 0.0215, 'lps'),
	(380716, 123, '2015-02-01 00:33:41.000000', 'consum', 0.0214, 'lps'),
	(380717, 123, '2015-02-01 00:33:42.000000', 'consum', 0.0215, 'lps'),
	(380718, 123, '2015-02-01 00:33:43.000000', 'consum', 0.0223, 'lps'),
	(380719, 123, '2015-02-01 00:33:44.000000', 'consum', 0.0211, 'lps'),
	(380720, 123, '2015-02-01 00:33:45.000000', 'consum', 0.0211, 'lps'),
	(380721, 123, '2015-02-01 00:33:46.000000', 'consum', 0.0214, 'lps'),
	(380722, 123, '2015-02-01 00:33:47.000000', 'consum', 0.0224, 'lps'),
	(380723, 123, '2015-02-01 00:33:48.000000', 'consum', 0.0220, 'lps'),
	(380724, 123, '2015-02-01 00:33:49.000000', 'consum', 0.0220, 'lps'),
	(380725, 123, '2015-02-01 00:33:50.000000', 'consum', 0.0210, 'lps'),
	(380726, 123, '2015-02-01 00:33:51.000000', 'consum', 0.0216, 'lps'),
	(380727, 123, '2015-02-01 00:33:52.000000', 'consum', 0.0225, 'lps'),
	(380728, 123, '2015-02-01 00:33:53.000000', 'consum', 0.0216, 'lps'),
	(380729, 123, '2015-02-01 00:33:54.000000', 'consum', 0.0211, 'lps'),
	(380730, 123, '2015-02-01 00:33:55.000000', 'consum', 0.0217, 'lps'),
	(380731, 123, '2015-02-01 00:33:56.000000', 'consum', 0.0223, 'lps'),
	(380732, 123, '2015-02-01 00:33:57.000000', 'consum', 0.0220, 'lps'),
	(380733, 123, '2015-02-01 00:33:58.000000', 'consum', 0.0220, 'lps'),
	(380734, 123, '2015-02-01 00:33:59.000000', 'consum', 0.0217, 'lps'),
	(380735, 123, '2015-02-01 00:34:00.000000', 'consum', 0.0215, 'lps'),
	(380736, 123, '2015-02-01 00:34:01.000000', 'consum', 0.0215, 'lps'),
	(380737, 123, '2015-02-01 00:34:02.000000', 'consum', 0.0221, 'lps'),
	(380738, 123, '2015-02-01 00:34:03.000000', 'consum', 0.0215, 'lps'),
	(380739, 123, '2015-02-01 00:34:04.000000', 'consum', 0.0221, 'lps'),
	(380740, 123, '2015-02-01 00:34:05.000000', 'consum', 0.0216, 'lps'),
	(380741, 123, '2015-02-01 00:34:06.000000', 'consum', 0.0223, 'lps'),
	(380742, 123, '2015-02-01 00:34:07.000000', 'consum', 0.0223, 'lps'),
	(380743, 123, '2015-02-01 00:34:08.000000', 'consum', 0.0219, 'lps'),
	(380744, 123, '2015-02-01 00:34:09.000000', 'consum', 0.0216, 'lps'),
	(380745, 123, '2015-02-01 00:34:10.000000', 'consum', 0.0213, 'lps'),
	(380746, 123, '2015-02-01 00:34:11.000000', 'consum', 0.0226, 'lps'),
	(380747, 123, '2015-02-01 00:34:12.000000', 'consum', 0.0214, 'lps'),
	(380748, 123, '2015-02-01 00:34:13.000000', 'consum', 0.0217, 'lps'),
	(380749, 123, '2015-02-01 00:34:14.000000', 'consum', 0.0217, 'lps'),
	(380750, 123, '2015-02-01 00:34:15.000000', 'consum', 0.0226, 'lps'),
	(380751, 123, '2015-02-01 00:34:16.000000', 'consum', 0.0215, 'lps'),
	(380752, 123, '2015-02-01 00:34:17.000000', 'consum', 0.0223, 'lps'),
	(380753, 123, '2015-02-01 00:34:18.000000', 'consum', 0.0211, 'lps'),
	(380754, 123, '2015-02-01 00:34:19.000000', 'consum', 0.0211, 'lps'),
	(380755, 123, '2015-02-01 00:34:20.000000', 'consum', 0.0212, 'lps'),
	(380756, 123, '2015-02-01 00:34:21.000000', 'consum', 0.0216, 'lps'),
	(380757, 123, '2015-02-01 00:34:22.000000', 'consum', 0.0219, 'lps'),
	(380758, 123, '2015-02-01 00:34:23.000000', 'consum', 0.0220, 'lps'),
	(380759, 123, '2015-02-01 00:34:24.000000', 'consum', 0.0216, 'lps'),
	(380760, 123, '2015-02-01 00:34:25.000000', 'consum', 0.0212, 'lps'),
	(380761, 123, '2015-02-01 00:34:26.000000', 'consum', 0.0218, 'lps'),
	(380762, 123, '2015-02-01 00:34:27.000000', 'consum', 0.0213, 'lps'),
	(380763, 123, '2015-02-01 00:34:28.000000', 'consum', 0.0217, 'lps'),
	(380764, 123, '2015-02-01 00:34:29.000000', 'consum', 0.0220, 'lps'),
	(380765, 123, '2015-02-01 00:34:30.000000', 'consum', 0.0220, 'lps'),
	(380766, 123, '2015-02-01 00:34:31.000000', 'consum', 0.0215, 'lps'),
	(380767, 123, '2015-02-01 00:34:32.000000', 'consum', 0.0224, 'lps'),
	(380768, 123, '2015-02-01 00:34:33.000000', 'consum', 0.0212, 'lps'),
	(380769, 123, '2015-02-01 00:34:34.000000', 'consum', 0.0213, 'lps'),
	(380770, 123, '2015-02-01 00:34:35.000000', 'consum', 0.0219, 'lps'),
	(380771, 123, '2015-02-01 00:34:36.000000', 'consum', 0.0214, 'lps'),
	(380772, 123, '2015-02-01 00:34:37.000000', 'consum', 0.0220, 'lps'),
	(380773, 123, '2015-02-01 00:34:38.000000', 'consum', 0.0215, 'lps'),
	(380774, 123, '2015-02-01 00:34:39.000000', 'consum', 0.0224, 'lps'),
	(380775, 123, '2015-02-01 00:34:40.000000', 'consum', 0.0212, 'lps'),
	(380776, 123, '2015-02-01 00:34:41.000000', 'consum', 0.0215, 'lps'),
	(380777, 123, '2015-02-01 00:34:42.000000', 'consum', 0.0211, 'lps'),
	(380778, 123, '2015-02-01 00:34:43.000000', 'consum', 0.0218, 'lps'),
	(380779, 123, '2015-02-01 00:34:44.000000', 'consum', 0.0213, 'lps'),
	(380780, 123, '2015-02-01 00:34:45.000000', 'consum', 0.0218, 'lps'),
	(380781, 123, '2015-02-01 00:34:46.000000', 'consum', 0.0210, 'lps'),
	(380782, 123, '2015-02-01 00:34:47.000000', 'consum', 0.0217, 'lps'),
	(380783, 123, '2015-02-01 00:34:48.000000', 'consum', 0.0214, 'lps'),
	(380784, 123, '2015-02-01 00:34:49.000000', 'consum', 0.0211, 'lps'),
	(380785, 123, '2015-02-01 00:34:50.000000', 'consum', 0.0217, 'lps'),
	(380786, 123, '2015-02-01 00:34:51.000000', 'consum', 0.0210, 'lps'),
	(380787, 123, '2015-02-01 00:34:52.000000', 'consum', 0.0223, 'lps'),
	(380788, 123, '2015-02-01 00:34:53.000000', 'consum', 0.0223, 'lps'),
	(380789, 123, '2015-02-01 00:34:54.000000', 'consum', 0.0220, 'lps'),
	(380790, 123, '2015-02-01 00:34:55.000000', 'consum', 0.0220, 'lps'),
	(380791, 123, '2015-02-01 00:34:56.000000', 'consum', 0.0216, 'lps'),
	(380792, 123, '2015-02-01 00:34:57.000000', 'consum', 0.0212, 'lps'),
	(380793, 123, '2015-02-01 00:34:58.000000', 'consum', 0.0216, 'lps'),
	(380794, 123, '2015-02-01 00:34:59.000000', 'consum', 0.0218, 'lps'),
	(380795, 123, '2015-02-01 00:35:00.000000', 'consum', 0.0216, 'lps'),
	(380796, 123, '2015-02-01 00:35:01.000000', 'consum', 0.0216, 'lps'),
	(380797, 123, '2015-02-01 00:35:02.000000', 'consum', 0.0223, 'lps'),
	(380798, 123, '2015-02-01 00:35:03.000000', 'consum', 0.0225, 'lps'),
	(380799, 123, '2015-02-01 00:35:04.000000', 'consum', 0.0211, 'lps'),
	(380800, 123, '2015-02-01 00:35:05.000000', 'consum', 0.0221, 'lps'),
	(380801, 123, '2015-02-01 00:35:06.000000', 'consum', 0.0211, 'lps'),
	(380802, 123, '2015-02-01 00:35:07.000000', 'consum', 0.0215, 'lps'),
	(380803, 123, '2015-02-01 00:35:08.000000', 'consum', 0.0219, 'lps'),
	(380804, 123, '2015-02-01 00:35:09.000000', 'consum', 0.0223, 'lps'),
	(380805, 123, '2015-02-01 00:35:10.000000', 'consum', 0.0213, 'lps'),
	(380806, 123, '2015-02-01 00:35:11.000000', 'consum', 0.0223, 'lps'),
	(380807, 123, '2015-02-01 00:35:12.000000', 'consum', 0.0212, 'lps'),
	(380808, 123, '2015-02-01 00:35:13.000000', 'consum', 0.0219, 'lps'),
	(380809, 123, '2015-02-01 00:35:14.000000', 'consum', 0.0212, 'lps'),
	(380810, 123, '2015-02-01 00:35:15.000000', 'consum', 0.0214, 'lps'),
	(380811, 123, '2015-02-01 00:35:16.000000', 'consum', 0.0221, 'lps'),
	(380812, 123, '2015-02-01 00:35:17.000000', 'consum', 0.0222, 'lps'),
	(380813, 123, '2015-02-01 00:35:18.000000', 'consum', 0.0220, 'lps'),
	(380814, 123, '2015-02-01 00:35:19.000000', 'consum', 0.0226, 'lps'),
	(380815, 123, '2015-02-01 00:35:20.000000', 'consum', 0.0225, 'lps'),
	(380816, 123, '2015-02-01 00:35:21.000000', 'consum', 0.0219, 'lps'),
	(380817, 123, '2015-02-01 00:35:22.000000', 'consum', 0.0211, 'lps'),
	(380818, 123, '2015-02-01 00:35:23.000000', 'consum', 0.0222, 'lps'),
	(380819, 123, '2015-02-01 00:35:24.000000', 'consum', 0.0217, 'lps'),
	(380820, 123, '2015-02-01 00:35:25.000000', 'consum', 0.0226, 'lps'),
	(380821, 123, '2015-02-01 00:35:26.000000', 'consum', 0.0219, 'lps'),
	(380822, 123, '2015-02-01 00:35:27.000000', 'consum', 0.0224, 'lps'),
	(380823, 123, '2015-02-01 00:35:28.000000', 'consum', 0.0219, 'lps'),
	(380824, 123, '2015-02-01 00:35:29.000000', 'consum', 0.0213, 'lps'),
	(380825, 123, '2015-02-01 00:35:30.000000', 'consum', 0.0218, 'lps'),
	(380826, 123, '2015-02-01 00:35:31.000000', 'consum', 0.0223, 'lps'),
	(380827, 123, '2015-02-01 00:35:32.000000', 'consum', 0.0217, 'lps'),
	(380828, 123, '2015-02-01 00:35:33.000000', 'consum', 0.0223, 'lps'),
	(380829, 123, '2015-02-01 00:35:34.000000', 'consum', 0.0219, 'lps'),
	(380830, 123, '2015-02-01 00:35:35.000000', 'consum', 0.0220, 'lps'),
	(380831, 123, '2015-02-01 00:35:36.000000', 'consum', 0.0213, 'lps'),
	(380832, 123, '2015-02-01 00:35:37.000000', 'consum', 0.0216, 'lps'),
	(380833, 123, '2015-02-01 00:35:38.000000', 'consum', 0.0211, 'lps'),
	(380834, 123, '2015-02-01 00:35:39.000000', 'consum', 0.0217, 'lps'),
	(380835, 123, '2015-02-01 00:35:40.000000', 'consum', 0.0223, 'lps'),
	(380836, 123, '2015-02-01 00:35:41.000000', 'consum', 0.0221, 'lps'),
	(380837, 123, '2015-02-01 00:35:42.000000', 'consum', 0.0212, 'lps'),
	(380838, 123, '2015-02-01 00:35:43.000000', 'consum', 0.0220, 'lps'),
	(380839, 123, '2015-02-01 00:35:44.000000', 'consum', 0.0220, 'lps'),
	(380840, 123, '2015-02-01 00:35:45.000000', 'consum', 0.0213, 'lps'),
	(380841, 123, '2015-02-01 00:35:46.000000', 'consum', 0.0214, 'lps'),
	(380842, 123, '2015-02-01 00:35:47.000000', 'consum', 0.0220, 'lps'),
	(380843, 123, '2015-02-01 00:35:48.000000', 'consum', 0.0215, 'lps'),
	(380844, 123, '2015-02-01 00:35:49.000000', 'consum', 0.0223, 'lps'),
	(380845, 123, '2015-02-01 00:35:50.000000', 'consum', 0.0224, 'lps'),
	(380846, 123, '2015-02-01 00:35:51.000000', 'consum', 0.0211, 'lps'),
	(380847, 123, '2015-02-01 00:35:52.000000', 'consum', 0.0222, 'lps'),
	(380848, 123, '2015-02-01 00:35:53.000000', 'consum', 0.0216, 'lps'),
	(380849, 123, '2015-02-01 00:35:54.000000', 'consum', 0.0224, 'lps'),
	(380850, 123, '2015-02-01 00:35:55.000000', 'consum', 0.0212, 'lps'),
	(380851, 123, '2015-02-01 00:35:56.000000', 'consum', 0.0210, 'lps'),
	(380852, 123, '2015-02-01 00:35:57.000000', 'consum', 0.0225, 'lps'),
	(380853, 123, '2015-02-01 00:35:58.000000', 'consum', 0.0214, 'lps'),
	(380854, 123, '2015-02-01 00:35:59.000000', 'consum', 0.0221, 'lps'),
	(380855, 123, '2015-02-01 00:36:00.000000', 'consum', 0.0219, 'lps'),
	(380856, 123, '2015-02-01 00:36:01.000000', 'consum', 0.0221, 'lps'),
	(380857, 123, '2015-02-01 00:36:02.000000', 'consum', 0.0224, 'lps'),
	(380858, 123, '2015-02-01 00:36:03.000000', 'consum', 0.0213, 'lps'),
	(380859, 123, '2015-02-01 00:36:04.000000', 'consum', 0.0218, 'lps'),
	(380860, 123, '2015-02-01 00:36:05.000000', 'consum', 0.0223, 'lps'),
	(380861, 123, '2015-02-01 00:36:06.000000', 'consum', 0.0217, 'lps'),
	(380862, 123, '2015-02-01 00:36:07.000000', 'consum', 0.0222, 'lps'),
	(380863, 123, '2015-02-01 00:36:08.000000', 'consum', 0.0218, 'lps'),
	(380864, 123, '2015-02-01 00:36:09.000000', 'consum', 0.0215, 'lps'),
	(380865, 123, '2015-02-01 00:36:10.000000', 'consum', 0.0212, 'lps'),
	(380866, 123, '2015-02-01 00:36:11.000000', 'consum', 0.0222, 'lps'),
	(380867, 123, '2015-02-01 00:36:12.000000', 'consum', 0.0211, 'lps'),
	(380868, 123, '2015-02-01 00:36:13.000000', 'consum', 0.0217, 'lps'),
	(380869, 123, '2015-02-01 00:36:14.000000', 'consum', 0.0223, 'lps'),
	(380870, 123, '2015-02-01 00:36:15.000000', 'consum', 0.0223, 'lps'),
	(380871, 123, '2015-02-01 00:36:16.000000', 'consum', 0.0217, 'lps'),
	(380872, 123, '2015-02-01 00:36:17.000000', 'consum', 0.0223, 'lps'),
	(380873, 123, '2015-02-01 00:36:18.000000', 'consum', 0.0221, 'lps'),
	(380874, 123, '2015-02-01 00:36:19.000000', 'consum', 0.0226, 'lps'),
	(380875, 123, '2015-02-01 00:36:20.000000', 'consum', 0.0223, 'lps'),
	(380876, 123, '2015-02-01 00:36:21.000000', 'consum', 0.0213, 'lps'),
	(380877, 123, '2015-02-01 00:36:22.000000', 'consum', 0.0219, 'lps'),
	(380878, 123, '2015-02-01 00:36:23.000000', 'consum', 0.0215, 'lps'),
	(380879, 123, '2015-02-01 00:36:24.000000', 'consum', 0.0222, 'lps'),
	(380880, 123, '2015-02-01 00:36:25.000000', 'consum', 0.0224, 'lps'),
	(380881, 123, '2015-02-01 00:36:26.000000', 'consum', 0.0225, 'lps'),
	(380882, 123, '2015-02-01 00:36:27.000000', 'consum', 0.0210, 'lps'),
	(380883, 123, '2015-02-01 00:36:28.000000', 'consum', 0.0216, 'lps'),
	(380884, 123, '2015-02-01 00:36:29.000000', 'consum', 0.0226, 'lps'),
	(380885, 123, '2015-02-01 00:36:30.000000', 'consum', 0.0221, 'lps'),
	(380886, 123, '2015-02-01 00:36:31.000000', 'consum', 0.0215, 'lps'),
	(380887, 123, '2015-02-01 00:36:32.000000', 'consum', 0.0223, 'lps'),
	(380888, 123, '2015-02-01 00:36:33.000000', 'consum', 0.0224, 'lps'),
	(380889, 123, '2015-02-01 00:36:34.000000', 'consum', 0.0223, 'lps'),
	(380890, 123, '2015-02-01 00:36:35.000000', 'consum', 0.0219, 'lps'),
	(380891, 123, '2015-02-01 00:36:36.000000', 'consum', 0.0217, 'lps'),
	(380892, 123, '2015-02-01 00:36:37.000000', 'consum', 0.0218, 'lps'),
	(380893, 123, '2015-02-01 00:36:38.000000', 'consum', 0.0212, 'lps'),
	(380894, 123, '2015-02-01 00:36:39.000000', 'consum', 0.0214, 'lps'),
	(380895, 123, '2015-02-01 00:36:40.000000', 'consum', 0.0225, 'lps'),
	(380896, 123, '2015-02-01 00:36:41.000000', 'consum', 0.0224, 'lps'),
	(380897, 123, '2015-02-01 00:36:42.000000', 'consum', 0.0216, 'lps'),
	(380898, 123, '2015-02-01 00:36:43.000000', 'consum', 0.0216, 'lps'),
	(380899, 123, '2015-02-01 00:36:44.000000', 'consum', 0.0222, 'lps'),
	(380900, 123, '2015-02-01 00:36:45.000000', 'consum', 0.0218, 'lps'),
	(380901, 123, '2015-02-01 00:36:46.000000', 'consum', 0.0217, 'lps'),
	(380902, 123, '2015-02-01 00:36:47.000000', 'consum', 0.0220, 'lps'),
	(380903, 123, '2015-02-01 00:36:48.000000', 'consum', 0.0223, 'lps'),
	(380904, 123, '2015-02-01 00:36:49.000000', 'consum', 0.0211, 'lps'),
	(380905, 123, '2015-02-01 00:36:50.000000', 'consum', 0.0211, 'lps'),
	(380906, 123, '2015-02-01 00:36:51.000000', 'consum', 0.0213, 'lps'),
	(380907, 123, '2015-02-01 00:36:52.000000', 'consum', 0.0220, 'lps'),
	(380908, 123, '2015-02-01 00:36:53.000000', 'consum', 0.0220, 'lps'),
	(380909, 123, '2015-02-01 00:36:54.000000', 'consum', 0.0213, 'lps'),
	(380910, 123, '2015-02-01 00:36:55.000000', 'consum', 0.0212, 'lps'),
	(380911, 123, '2015-02-01 00:36:56.000000', 'consum', 0.0212, 'lps'),
	(380912, 123, '2015-02-01 00:36:57.000000', 'consum', 0.0213, 'lps'),
	(380913, 123, '2015-02-01 00:36:58.000000', 'consum', 0.0221, 'lps'),
	(380914, 123, '2015-02-01 00:36:59.000000', 'consum', 0.0222, 'lps'),
	(380915, 123, '2015-02-01 00:37:00.000000', 'consum', 0.0220, 'lps'),
	(380916, 123, '2015-02-01 00:37:01.000000', 'consum', 0.0225, 'lps'),
	(380917, 123, '2015-02-01 00:37:02.000000', 'consum', 0.0220, 'lps'),
	(380918, 123, '2015-02-01 00:37:03.000000', 'consum', 0.0219, 'lps'),
	(380919, 123, '2015-02-01 00:37:04.000000', 'consum', 0.0222, 'lps'),
	(380920, 123, '2015-02-01 00:37:05.000000', 'consum', 0.0210, 'lps'),
	(380921, 123, '2015-02-01 00:37:06.000000', 'consum', 0.0210, 'lps'),
	(380922, 123, '2015-02-01 00:37:07.000000', 'consum', 0.0226, 'lps'),
	(380923, 123, '2015-02-01 00:37:08.000000', 'consum', 0.0222, 'lps'),
	(380924, 123, '2015-02-01 00:37:09.000000', 'consum', 0.0223, 'lps'),
	(380925, 123, '2015-02-01 00:37:10.000000', 'consum', 0.0221, 'lps'),
	(380926, 123, '2015-02-01 00:37:11.000000', 'consum', 0.0226, 'lps'),
	(380927, 123, '2015-02-01 00:37:12.000000', 'consum', 0.0223, 'lps'),
	(380928, 123, '2015-02-01 00:37:13.000000', 'consum', 0.0211, 'lps'),
	(380929, 123, '2015-02-01 00:37:14.000000', 'consum', 0.0212, 'lps'),
	(380930, 123, '2015-02-01 00:37:15.000000', 'consum', 0.0216, 'lps'),
	(380931, 123, '2015-02-01 00:37:16.000000', 'consum', 0.0217, 'lps'),
	(380932, 123, '2015-02-01 00:37:17.000000', 'consum', 0.0210, 'lps'),
	(380933, 123, '2015-02-01 00:37:18.000000', 'consum', 0.0226, 'lps'),
	(380934, 123, '2015-02-01 00:37:19.000000', 'consum', 0.0219, 'lps'),
	(380935, 123, '2015-02-01 00:37:20.000000', 'consum', 0.0210, 'lps'),
	(380936, 123, '2015-02-01 00:37:21.000000', 'consum', 0.0218, 'lps'),
	(380937, 123, '2015-02-01 00:37:22.000000', 'consum', 0.0215, 'lps'),
	(380938, 123, '2015-02-01 00:37:23.000000', 'consum', 0.0213, 'lps'),
	(380939, 123, '2015-02-01 00:37:24.000000', 'consum', 0.0210, 'lps'),
	(380940, 123, '2015-02-01 00:37:25.000000', 'consum', 0.0219, 'lps'),
	(380941, 123, '2015-02-01 00:37:26.000000', 'consum', 0.0219, 'lps'),
	(380942, 123, '2015-02-01 00:37:27.000000', 'consum', 0.0214, 'lps'),
	(380943, 123, '2015-02-01 00:37:28.000000', 'consum', 0.0221, 'lps'),
	(380944, 123, '2015-02-01 00:37:29.000000', 'consum', 0.0218, 'lps'),
	(380945, 123, '2015-02-01 00:37:30.000000', 'consum', 0.0217, 'lps'),
	(380946, 123, '2015-02-01 00:37:31.000000', 'consum', 0.0223, 'lps'),
	(380947, 123, '2015-02-01 00:37:32.000000', 'consum', 0.0221, 'lps'),
	(380948, 123, '2015-02-01 00:37:33.000000', 'consum', 0.0225, 'lps'),
	(380949, 123, '2015-02-01 00:37:34.000000', 'consum', 0.0217, 'lps'),
	(380950, 123, '2015-02-01 00:37:35.000000', 'consum', 0.0219, 'lps'),
	(380951, 123, '2015-02-01 00:37:36.000000', 'consum', 0.0217, 'lps'),
	(380952, 123, '2015-02-01 00:37:37.000000', 'consum', 0.0219, 'lps'),
	(380953, 123, '2015-02-01 00:37:38.000000', 'consum', 0.0218, 'lps'),
	(380954, 123, '2015-02-01 00:37:39.000000', 'consum', 0.0224, 'lps'),
	(380955, 123, '2015-02-01 00:37:40.000000', 'consum', 0.0222, 'lps'),
	(380956, 123, '2015-02-01 00:37:41.000000', 'consum', 0.0212, 'lps'),
	(380957, 123, '2015-02-01 00:37:42.000000', 'consum', 0.0219, 'lps'),
	(380958, 123, '2015-02-01 00:37:43.000000', 'consum', 0.0214, 'lps'),
	(380959, 123, '2015-02-01 00:37:44.000000', 'consum', 0.0221, 'lps'),
	(380960, 123, '2015-02-01 00:37:45.000000', 'consum', 0.0219, 'lps'),
	(380961, 123, '2015-02-01 00:37:46.000000', 'consum', 0.0223, 'lps'),
	(380962, 123, '2015-02-01 00:37:47.000000', 'consum', 0.0216, 'lps'),
	(380963, 123, '2015-02-01 00:37:48.000000', 'consum', 0.0217, 'lps'),
	(380964, 123, '2015-02-01 00:37:49.000000', 'consum', 0.0210, 'lps'),
	(380965, 123, '2015-02-01 00:37:50.000000', 'consum', 0.0225, 'lps'),
	(380966, 123, '2015-02-01 00:37:51.000000', 'consum', 0.0216, 'lps'),
	(380967, 123, '2015-02-01 00:37:52.000000', 'consum', 0.0215, 'lps'),
	(380968, 123, '2015-02-01 00:37:53.000000', 'consum', 0.0215, 'lps'),
	(380969, 123, '2015-02-01 00:37:54.000000', 'consum', 0.0222, 'lps'),
	(380970, 123, '2015-02-01 00:37:55.000000', 'consum', 0.0222, 'lps'),
	(380971, 123, '2015-02-01 00:37:56.000000', 'consum', 0.0215, 'lps'),
	(380972, 123, '2015-02-01 00:37:57.000000', 'consum', 0.0220, 'lps'),
	(380973, 123, '2015-02-01 00:37:58.000000', 'consum', 0.0226, 'lps'),
	(380974, 123, '2015-02-01 00:37:59.000000', 'consum', 0.0210, 'lps'),
	(380975, 123, '2015-02-01 00:38:00.000000', 'consum', 0.0211, 'lps'),
	(380976, 123, '2015-02-01 00:38:01.000000', 'consum', 0.0219, 'lps'),
	(380977, 123, '2015-02-01 00:38:02.000000', 'consum', 0.0219, 'lps'),
	(380978, 123, '2015-02-01 00:38:03.000000', 'consum', 0.0210, 'lps'),
	(380979, 123, '2015-02-01 00:38:04.000000', 'consum', 0.0220, 'lps'),
	(380980, 123, '2015-02-01 00:38:05.000000', 'consum', 0.0224, 'lps'),
	(380981, 123, '2015-02-01 00:38:06.000000', 'consum', 0.0216, 'lps'),
	(380982, 123, '2015-02-01 00:38:07.000000', 'consum', 0.0215, 'lps'),
	(380983, 123, '2015-02-01 00:38:08.000000', 'consum', 0.0220, 'lps'),
	(380984, 123, '2015-02-01 00:38:09.000000', 'consum', 0.0210, 'lps'),
	(380985, 123, '2015-02-01 00:38:10.000000', 'consum', 0.0214, 'lps'),
	(380986, 123, '2015-02-01 00:38:11.000000', 'consum', 0.0214, 'lps'),
	(380987, 123, '2015-02-01 00:38:12.000000', 'consum', 0.0218, 'lps'),
	(380988, 123, '2015-02-01 00:38:13.000000', 'consum', 0.0223, 'lps'),
	(380989, 123, '2015-02-01 00:38:14.000000', 'consum', 0.0217, 'lps'),
	(380990, 123, '2015-02-01 00:38:15.000000', 'consum', 0.0225, 'lps'),
	(380991, 123, '2015-02-01 00:38:16.000000', 'consum', 0.0212, 'lps'),
	(380992, 123, '2015-02-01 00:38:17.000000', 'consum', 0.0225, 'lps'),
	(380993, 123, '2015-02-01 00:38:18.000000', 'consum', 0.0214, 'lps'),
	(380994, 123, '2015-02-01 00:38:19.000000', 'consum', 0.0219, 'lps'),
	(380995, 123, '2015-02-01 00:38:20.000000', 'consum', 0.0226, 'lps'),
	(380996, 123, '2015-02-01 00:38:21.000000', 'consum', 0.0213, 'lps'),
	(380997, 123, '2015-02-01 00:38:22.000000', 'consum', 0.0212, 'lps'),
	(380998, 123, '2015-02-01 00:38:23.000000', 'consum', 0.0213, 'lps'),
	(380999, 123, '2015-02-01 00:38:24.000000', 'consum', 0.0218, 'lps'),
	(381000, 123, '2015-02-01 00:38:25.000000', 'consum', 0.0224, 'lps'),
	(381001, 123, '2015-02-01 00:38:26.000000', 'consum', 0.0224, 'lps'),
	(381002, 123, '2015-02-01 00:38:27.000000', 'consum', 0.0221, 'lps'),
	(381003, 123, '2015-02-01 00:38:28.000000', 'consum', 0.0225, 'lps'),
	(381004, 123, '2015-02-01 00:38:29.000000', 'consum', 0.0218, 'lps'),
	(381005, 123, '2015-02-01 00:38:30.000000', 'consum', 0.0222, 'lps'),
	(381006, 123, '2015-02-01 00:38:31.000000', 'consum', 0.0214, 'lps'),
	(381007, 123, '2015-02-01 00:38:32.000000', 'consum', 0.0212, 'lps'),
	(381008, 123, '2015-02-01 00:38:33.000000', 'consum', 0.0223, 'lps'),
	(381009, 123, '2015-02-01 00:38:34.000000', 'consum', 0.0221, 'lps'),
	(381010, 123, '2015-02-01 00:38:35.000000', 'consum', 0.0224, 'lps'),
	(381011, 123, '2015-02-01 00:38:36.000000', 'consum', 0.0216, 'lps'),
	(381012, 123, '2015-02-01 00:38:37.000000', 'consum', 0.0216, 'lps'),
	(381013, 123, '2015-02-01 00:38:38.000000', 'consum', 0.0219, 'lps'),
	(381014, 123, '2015-02-01 00:38:39.000000', 'consum', 0.0224, 'lps'),
	(381015, 123, '2015-02-01 00:38:40.000000', 'consum', 0.0219, 'lps'),
	(381016, 123, '2015-02-01 00:38:41.000000', 'consum', 0.0212, 'lps'),
	(381017, 123, '2015-02-01 00:38:42.000000', 'consum', 0.0212, 'lps'),
	(381018, 123, '2015-02-01 00:38:43.000000', 'consum', 0.0213, 'lps'),
	(381019, 123, '2015-02-01 00:38:44.000000', 'consum', 0.0219, 'lps'),
	(381020, 123, '2015-02-01 00:38:45.000000', 'consum', 0.0215, 'lps'),
	(381021, 123, '2015-02-01 00:38:46.000000', 'consum', 0.0225, 'lps'),
	(381022, 123, '2015-02-01 00:38:47.000000', 'consum', 0.0217, 'lps'),
	(381023, 123, '2015-02-01 00:38:48.000000', 'consum', 0.0221, 'lps'),
	(381024, 123, '2015-02-01 00:38:49.000000', 'consum', 0.0226, 'lps'),
	(381025, 123, '2015-02-01 00:38:50.000000', 'consum', 0.0223, 'lps'),
	(381026, 123, '2015-02-01 00:38:51.000000', 'consum', 0.0211, 'lps'),
	(381027, 123, '2015-02-01 00:38:52.000000', 'consum', 0.0211, 'lps'),
	(381028, 123, '2015-02-01 00:38:53.000000', 'consum', 0.0213, 'lps'),
	(381029, 123, '2015-02-01 00:38:54.000000', 'consum', 0.0220, 'lps'),
	(381030, 123, '2015-02-01 00:38:55.000000', 'consum', 0.0219, 'lps'),
	(381031, 123, '2015-02-01 00:38:56.000000', 'consum', 0.0226, 'lps'),
	(381032, 123, '2015-02-01 00:38:57.000000', 'consum', 0.0213, 'lps'),
	(381033, 123, '2015-02-01 00:38:58.000000', 'consum', 0.0226, 'lps'),
	(381034, 123, '2015-02-01 00:38:59.000000', 'consum', 0.0217, 'lps'),
	(381035, 123, '2015-02-01 00:39:00.000000', 'consum', 0.0213, 'lps'),
	(381036, 123, '2015-02-01 00:39:01.000000', 'consum', 0.0220, 'lps'),
	(381037, 123, '2015-02-01 00:39:02.000000', 'consum', 0.0217, 'lps'),
	(381038, 123, '2015-02-01 00:39:03.000000', 'consum', 0.0215, 'lps'),
	(381039, 123, '2015-02-01 00:39:04.000000', 'consum', 0.0218, 'lps'),
	(381040, 123, '2015-02-01 00:39:05.000000', 'consum', 0.0215, 'lps'),
	(381041, 123, '2015-02-01 00:39:06.000000', 'consum', 0.0215, 'lps'),
	(381042, 123, '2015-02-01 00:39:07.000000', 'consum', 0.0218, 'lps'),
	(381043, 123, '2015-02-01 00:39:08.000000', 'consum', 0.0219, 'lps'),
	(381044, 123, '2015-02-01 00:39:09.000000', 'consum', 0.0216, 'lps'),
	(381045, 123, '2015-02-01 00:39:10.000000', 'consum', 0.0214, 'lps'),
	(381046, 123, '2015-02-01 00:39:11.000000', 'consum', 0.0212, 'lps'),
	(381047, 123, '2015-02-01 00:39:12.000000', 'consum', 0.0224, 'lps'),
	(381048, 123, '2015-02-01 00:39:13.000000', 'consum', 0.0226, 'lps'),
	(381049, 123, '2015-02-01 00:39:14.000000', 'consum', 0.0214, 'lps'),
	(381050, 123, '2015-02-01 00:39:15.000000', 'consum', 0.0214, 'lps'),
	(381051, 123, '2015-02-01 00:39:16.000000', 'consum', 0.0221, 'lps'),
	(381052, 123, '2015-02-01 00:39:17.000000', 'consum', 0.0217, 'lps'),
	(381053, 123, '2015-02-01 00:39:18.000000', 'consum', 0.0212, 'lps'),
	(381054, 123, '2015-02-01 00:39:19.000000', 'consum', 0.0220, 'lps'),
	(381055, 123, '2015-02-01 00:39:20.000000', 'consum', 0.0217, 'lps'),
	(381056, 123, '2015-02-01 00:39:21.000000', 'consum', 0.0216, 'lps'),
	(381057, 123, '2015-02-01 00:39:22.000000', 'consum', 0.0221, 'lps'),
	(381058, 123, '2015-02-01 00:39:23.000000', 'consum', 0.0211, 'lps'),
	(381059, 123, '2015-02-01 00:39:24.000000', 'consum', 0.0217, 'lps'),
	(381060, 123, '2015-02-01 00:39:25.000000', 'consum', 0.0226, 'lps'),
	(381061, 123, '2015-02-01 00:39:26.000000', 'consum', 0.0217, 'lps'),
	(381062, 123, '2015-02-01 00:39:27.000000', 'consum', 0.0214, 'lps'),
	(381063, 123, '2015-02-01 00:39:28.000000', 'consum', 0.0210, 'lps'),
	(381064, 123, '2015-02-01 00:39:29.000000', 'consum', 0.0218, 'lps'),
	(381065, 123, '2015-02-01 00:39:30.000000', 'consum', 0.0214, 'lps'),
	(381066, 123, '2015-02-01 00:39:31.000000', 'consum', 0.0223, 'lps'),
	(381067, 123, '2015-02-01 00:39:32.000000', 'consum', 0.0213, 'lps'),
	(381068, 123, '2015-02-01 00:39:33.000000', 'consum', 0.0221, 'lps'),
	(381069, 123, '2015-02-01 00:39:34.000000', 'consum', 0.0221, 'lps'),
	(381070, 123, '2015-02-01 00:39:35.000000', 'consum', 0.0214, 'lps'),
	(381071, 123, '2015-02-01 00:39:36.000000', 'consum', 0.0218, 'lps'),
	(381072, 123, '2015-02-01 00:39:37.000000', 'consum', 0.0219, 'lps'),
	(381073, 123, '2015-02-01 00:39:38.000000', 'consum', 0.0215, 'lps'),
	(381074, 123, '2015-02-01 00:39:39.000000', 'consum', 0.0211, 'lps'),
	(381075, 123, '2015-02-01 00:39:40.000000', 'consum', 0.0215, 'lps'),
	(381076, 123, '2015-02-01 00:39:41.000000', 'consum', 0.0215, 'lps'),
	(381077, 123, '2015-02-01 00:39:42.000000', 'consum', 0.0223, 'lps'),
	(381078, 123, '2015-02-01 00:39:43.000000', 'consum', 0.0210, 'lps'),
	(381079, 123, '2015-02-01 00:39:44.000000', 'consum', 0.0221, 'lps'),
	(381080, 123, '2015-02-01 00:39:45.000000', 'consum', 0.0216, 'lps'),
	(381081, 123, '2015-02-01 00:39:46.000000', 'consum', 0.0225, 'lps'),
	(381082, 123, '2015-02-01 00:39:47.000000', 'consum', 0.0218, 'lps'),
	(381083, 123, '2015-02-01 00:39:48.000000', 'consum', 0.0219, 'lps'),
	(381084, 123, '2015-02-01 00:39:49.000000', 'consum', 0.0217, 'lps'),
	(381085, 123, '2015-02-01 00:39:50.000000', 'consum', 0.0216, 'lps'),
	(381086, 123, '2015-02-01 00:39:51.000000', 'consum', 0.0220, 'lps'),
	(381087, 123, '2015-02-01 00:39:52.000000', 'consum', 0.0225, 'lps'),
	(381088, 123, '2015-02-01 00:39:53.000000', 'consum', 0.0221, 'lps'),
	(381089, 123, '2015-02-01 00:39:54.000000', 'consum', 0.0220, 'lps'),
	(381090, 123, '2015-02-01 00:39:55.000000', 'consum', 0.0211, 'lps'),
	(381091, 123, '2015-02-01 00:39:56.000000', 'consum', 0.0221, 'lps'),
	(381092, 123, '2015-02-01 00:39:57.000000', 'consum', 0.0211, 'lps'),
	(381093, 123, '2015-02-01 00:39:58.000000', 'consum', 0.0217, 'lps'),
	(381094, 123, '2015-02-01 00:39:59.000000', 'consum', 0.0223, 'lps'),
	(381095, 123, '2015-02-01 00:40:00.000000', 'consum', 0.0222, 'lps'),
	(381096, 123, '2015-02-01 00:40:01.000000', 'consum', 0.0215, 'lps'),
	(381097, 123, '2015-02-01 00:40:02.000000', 'consum', 0.0214, 'lps'),
	(381098, 123, '2015-02-01 00:40:03.000000', 'consum', 0.0219, 'lps'),
	(381099, 123, '2015-02-01 00:40:04.000000', 'consum', 0.0223, 'lps'),
	(381100, 123, '2015-02-01 00:40:05.000000', 'consum', 0.0217, 'lps'),
	(381101, 123, '2015-02-01 00:40:06.000000', 'consum', 0.0221, 'lps'),
	(381102, 123, '2015-02-01 00:40:07.000000', 'consum', 0.0212, 'lps'),
	(381103, 123, '2015-02-01 00:40:08.000000', 'consum', 0.0223, 'lps'),
	(381104, 123, '2015-02-01 00:40:09.000000', 'consum', 0.0218, 'lps'),
	(381105, 123, '2015-02-01 00:40:10.000000', 'consum', 0.0211, 'lps'),
	(381106, 123, '2015-02-01 00:40:11.000000', 'consum', 0.0224, 'lps'),
	(381107, 123, '2015-02-01 00:40:12.000000', 'consum', 0.0210, 'lps'),
	(381108, 123, '2015-02-01 00:40:13.000000', 'consum', 0.0219, 'lps'),
	(381109, 123, '2015-02-01 00:40:14.000000', 'consum', 0.0223, 'lps'),
	(381110, 123, '2015-02-01 00:40:15.000000', 'consum', 0.0215, 'lps'),
	(381111, 123, '2015-02-01 00:40:16.000000', 'consum', 0.0213, 'lps'),
	(381112, 123, '2015-02-01 00:40:17.000000', 'consum', 0.0210, 'lps'),
	(381113, 123, '2015-02-01 00:40:18.000000', 'consum', 0.0217, 'lps'),
	(381114, 123, '2015-02-01 00:40:19.000000', 'consum', 0.0215, 'lps'),
	(381115, 123, '2015-02-01 00:40:20.000000', 'consum', 0.0211, 'lps'),
	(381116, 123, '2015-02-01 00:40:21.000000', 'consum', 0.0218, 'lps'),
	(381117, 123, '2015-02-01 00:40:22.000000', 'consum', 0.0214, 'lps'),
	(381118, 123, '2015-02-01 00:40:23.000000', 'consum', 0.0225, 'lps'),
	(381119, 123, '2015-02-01 00:40:24.000000', 'consum', 0.0222, 'lps'),
	(381120, 123, '2015-02-01 00:40:25.000000', 'consum', 0.0224, 'lps'),
	(381121, 123, '2015-02-01 00:40:26.000000', 'consum', 0.0210, 'lps'),
	(381122, 123, '2015-02-01 00:40:27.000000', 'consum', 0.0219, 'lps'),
	(381123, 123, '2015-02-01 00:40:28.000000', 'consum', 0.0222, 'lps'),
	(381124, 123, '2015-02-01 00:40:29.000000', 'consum', 0.0210, 'lps'),
	(381125, 123, '2015-02-01 00:40:30.000000', 'consum', 0.0224, 'lps'),
	(381126, 123, '2015-02-01 00:40:31.000000', 'consum', 0.0214, 'lps'),
	(381127, 123, '2015-02-01 00:40:32.000000', 'consum', 0.0223, 'lps'),
	(381128, 123, '2015-02-01 00:40:33.000000', 'consum', 0.0212, 'lps'),
	(381129, 123, '2015-02-01 00:40:34.000000', 'consum', 0.0217, 'lps'),
	(381130, 123, '2015-02-01 00:40:35.000000', 'consum', 0.0220, 'lps'),
	(381131, 123, '2015-02-01 00:40:36.000000', 'consum', 0.0223, 'lps'),
	(381132, 123, '2015-02-01 00:40:37.000000', 'consum', 0.0210, 'lps'),
	(381133, 123, '2015-02-01 00:40:38.000000', 'consum', 0.0225, 'lps'),
	(381134, 123, '2015-02-01 00:40:39.000000', 'consum', 0.0216, 'lps'),
	(381135, 123, '2015-02-01 00:40:40.000000', 'consum', 0.0214, 'lps'),
	(381136, 123, '2015-02-01 00:40:41.000000', 'consum', 0.0212, 'lps'),
	(381137, 123, '2015-02-01 00:40:42.000000', 'consum', 0.0225, 'lps'),
	(381138, 123, '2015-02-01 00:40:43.000000', 'consum', 0.0212, 'lps'),
	(381139, 123, '2015-02-01 00:40:44.000000', 'consum', 0.0211, 'lps'),
	(381140, 123, '2015-02-01 00:40:45.000000', 'consum', 0.0224, 'lps'),
	(381141, 123, '2015-02-01 00:40:46.000000', 'consum', 0.0212, 'lps'),
	(381142, 123, '2015-02-01 00:40:47.000000', 'consum', 0.0212, 'lps'),
	(381143, 123, '2015-02-01 00:40:48.000000', 'consum', 0.0215, 'lps'),
	(381144, 123, '2015-02-01 00:40:49.000000', 'consum', 0.0214, 'lps'),
	(381145, 123, '2015-02-01 00:40:50.000000', 'consum', 0.0212, 'lps'),
	(381146, 123, '2015-02-01 00:40:51.000000', 'consum', 0.0211, 'lps'),
	(381147, 123, '2015-02-01 00:40:52.000000', 'consum', 0.0224, 'lps'),
	(381148, 123, '2015-02-01 00:40:53.000000', 'consum', 0.0212, 'lps'),
	(381149, 123, '2015-02-01 00:40:54.000000', 'consum', 0.0211, 'lps'),
	(381150, 123, '2015-02-01 00:40:55.000000', 'consum', 0.0211, 'lps'),
	(381151, 123, '2015-02-01 00:40:56.000000', 'consum', 0.0214, 'lps'),
	(381152, 123, '2015-02-01 00:40:57.000000', 'consum', 0.0225, 'lps'),
	(381153, 123, '2015-02-01 00:40:58.000000', 'consum', 0.0225, 'lps'),
	(381154, 123, '2015-02-01 00:40:59.000000', 'consum', 0.0220, 'lps'),
	(381155, 123, '2015-02-01 00:41:00.000000', 'consum', 0.0219, 'lps'),
	(381156, 123, '2015-02-01 00:41:01.000000', 'consum', 0.0223, 'lps'),
	(381157, 123, '2015-02-01 00:41:02.000000', 'consum', 0.0217, 'lps'),
	(381158, 123, '2015-02-01 00:41:03.000000', 'consum', 0.0220, 'lps'),
	(381159, 123, '2015-02-01 00:41:04.000000', 'consum', 0.0226, 'lps'),
	(381160, 123, '2015-02-01 00:41:05.000000', 'consum', 0.0225, 'lps'),
	(381161, 123, '2015-02-01 00:41:06.000000', 'consum', 0.0222, 'lps'),
	(381162, 123, '2015-02-01 00:41:07.000000', 'consum', 0.0225, 'lps'),
	(381163, 123, '2015-02-01 00:41:08.000000', 'consum', 0.0214, 'lps'),
	(381164, 123, '2015-02-01 00:41:09.000000', 'consum', 0.0221, 'lps'),
	(381165, 123, '2015-02-01 00:41:10.000000', 'consum', 0.0220, 'lps'),
	(381166, 123, '2015-02-01 00:41:11.000000', 'consum', 0.0211, 'lps'),
	(381167, 123, '2015-02-01 00:41:12.000000', 'consum', 0.0218, 'lps'),
	(381168, 123, '2015-02-01 00:41:13.000000', 'consum', 0.0214, 'lps'),
	(381169, 123, '2015-02-01 00:41:14.000000', 'consum', 0.0225, 'lps'),
	(381170, 123, '2015-02-01 00:41:15.000000', 'consum', 0.0222, 'lps'),
	(381171, 123, '2015-02-01 00:41:16.000000', 'consum', 0.0210, 'lps'),
	(381172, 123, '2015-02-01 00:41:17.000000', 'consum', 0.0224, 'lps'),
	(381173, 123, '2015-02-01 00:41:18.000000', 'consum', 0.0214, 'lps'),
	(381174, 123, '2015-02-01 00:41:19.000000', 'consum', 0.0220, 'lps'),
	(381175, 123, '2015-02-01 00:41:20.000000', 'consum', 0.0215, 'lps'),
	(381176, 123, '2015-02-01 00:41:21.000000', 'consum', 0.0223, 'lps'),
	(381177, 123, '2015-02-01 00:41:22.000000', 'consum', 0.0226, 'lps'),
	(381178, 123, '2015-02-01 00:41:23.000000', 'consum', 0.0216, 'lps'),
	(381179, 123, '2015-02-01 00:41:24.000000', 'consum', 0.0212, 'lps'),
	(381180, 123, '2015-02-01 00:41:25.000000', 'consum', 0.0218, 'lps'),
	(381181, 123, '2015-02-01 00:41:26.000000', 'consum', 0.0210, 'lps'),
	(381182, 123, '2015-02-01 00:41:27.000000', 'consum', 0.0221, 'lps'),
	(381183, 123, '2015-02-01 00:41:28.000000', 'consum', 0.0213, 'lps'),
	(381184, 123, '2015-02-01 00:41:29.000000', 'consum', 0.0213, 'lps'),
	(381185, 123, '2015-02-01 00:41:30.000000', 'consum', 0.0213, 'lps'),
	(381186, 123, '2015-02-01 00:41:31.000000', 'consum', 0.0217, 'lps'),
	(381187, 123, '2015-02-01 00:41:32.000000', 'consum', 0.0220, 'lps'),
	(381188, 123, '2015-02-01 00:41:33.000000', 'consum', 0.0221, 'lps'),
	(381189, 123, '2015-02-01 00:41:34.000000', 'consum', 0.0220, 'lps'),
	(381190, 123, '2015-02-01 00:41:35.000000', 'consum', 0.0210, 'lps'),
	(381191, 123, '2015-02-01 00:41:36.000000', 'consum', 0.0217, 'lps'),
	(381192, 123, '2015-02-01 00:41:37.000000', 'consum', 0.0225, 'lps'),
	(381193, 123, '2015-02-01 00:41:38.000000', 'consum', 0.0214, 'lps'),
	(381194, 123, '2015-02-01 00:41:39.000000', 'consum', 0.0220, 'lps'),
	(381195, 123, '2015-02-01 00:41:40.000000', 'consum', 0.0213, 'lps'),
	(381196, 123, '2015-02-01 00:41:41.000000', 'consum', 0.0215, 'lps'),
	(381197, 123, '2015-02-01 00:41:42.000000', 'consum', 0.0226, 'lps'),
	(381198, 123, '2015-02-01 00:41:43.000000', 'consum', 0.0222, 'lps'),
	(381199, 123, '2015-02-01 00:41:44.000000', 'consum', 0.0225, 'lps'),
	(381200, 123, '2015-02-01 00:41:45.000000', 'consum', 0.0216, 'lps'),
	(381201, 123, '2015-02-01 00:41:46.000000', 'consum', 0.0211, 'lps'),
	(381202, 123, '2015-02-01 00:41:47.000000', 'consum', 0.0214, 'lps'),
	(381203, 123, '2015-02-01 00:41:48.000000', 'consum', 0.0211, 'lps'),
	(381204, 123, '2015-02-01 00:41:49.000000', 'consum', 0.0220, 'lps'),
	(381205, 123, '2015-02-01 00:41:50.000000', 'consum', 0.0222, 'lps'),
	(381206, 123, '2015-02-01 00:41:51.000000', 'consum', 0.0226, 'lps'),
	(381207, 123, '2015-02-01 00:41:52.000000', 'consum', 0.0219, 'lps'),
	(381208, 123, '2015-02-01 00:41:53.000000', 'consum', 0.0210, 'lps'),
	(381209, 123, '2015-02-01 00:41:54.000000', 'consum', 0.0216, 'lps'),
	(381210, 123, '2015-02-01 00:41:55.000000', 'consum', 0.0224, 'lps'),
	(381211, 123, '2015-02-01 00:41:56.000000', 'consum', 0.0212, 'lps'),
	(381212, 123, '2015-02-01 00:41:57.000000', 'consum', 0.0211, 'lps'),
	(381213, 123, '2015-02-01 00:41:58.000000', 'consum', 0.0212, 'lps'),
	(381214, 123, '2015-02-01 00:41:59.000000', 'consum', 0.0217, 'lps'),
	(381215, 123, '2015-02-01 00:42:00.000000', 'consum', 0.0220, 'lps'),
	(381216, 123, '2015-02-01 00:42:01.000000', 'consum', 0.0224, 'lps'),
	(381217, 123, '2015-02-01 00:42:02.000000', 'consum', 0.0215, 'lps'),
	(381218, 123, '2015-02-01 00:42:03.000000', 'consum', 0.0211, 'lps'),
	(381219, 123, '2015-02-01 00:42:04.000000', 'consum', 0.0219, 'lps'),
	(381220, 123, '2015-02-01 00:42:05.000000', 'consum', 0.0219, 'lps'),
	(381221, 123, '2015-02-01 00:42:06.000000', 'consum', 0.0211, 'lps'),
	(381222, 123, '2015-02-01 00:42:07.000000', 'consum', 0.0222, 'lps'),
	(381223, 123, '2015-02-01 00:42:08.000000', 'consum', 0.0218, 'lps'),
	(381224, 123, '2015-02-01 00:42:09.000000', 'consum', 0.0215, 'lps'),
	(381225, 123, '2015-02-01 00:42:10.000000', 'consum', 0.0212, 'lps'),
	(381226, 123, '2015-02-01 00:42:11.000000', 'consum', 0.0222, 'lps'),
	(381227, 123, '2015-02-01 00:42:12.000000', 'consum', 0.0211, 'lps'),
	(381228, 123, '2015-02-01 00:42:13.000000', 'consum', 0.0215, 'lps'),
	(381229, 123, '2015-02-01 00:42:14.000000', 'consum', 0.0217, 'lps'),
	(381230, 123, '2015-02-01 00:42:15.000000', 'consum', 0.0211, 'lps'),
	(381231, 123, '2015-02-01 00:42:16.000000', 'consum', 0.0212, 'lps'),
	(381232, 123, '2015-02-01 00:42:17.000000', 'consum', 0.0220, 'lps'),
	(381233, 123, '2015-02-01 00:42:18.000000', 'consum', 0.0219, 'lps'),
	(381234, 123, '2015-02-01 00:42:19.000000', 'consum', 0.0225, 'lps'),
	(381235, 123, '2015-02-01 00:42:20.000000', 'consum', 0.0224, 'lps'),
	(381236, 123, '2015-02-01 00:42:21.000000', 'consum', 0.0219, 'lps'),
	(381237, 123, '2015-02-01 00:42:22.000000', 'consum', 0.0212, 'lps'),
	(381238, 123, '2015-02-01 00:42:23.000000', 'consum', 0.0213, 'lps'),
	(381239, 123, '2015-02-01 00:42:24.000000', 'consum', 0.0219, 'lps'),
	(381240, 123, '2015-02-01 00:42:25.000000', 'consum', 0.0211, 'lps'),
	(381241, 123, '2015-02-01 00:42:26.000000', 'consum', 0.0225, 'lps'),
	(381242, 123, '2015-02-01 00:42:27.000000', 'consum', 0.0213, 'lps'),
	(381243, 123, '2015-02-01 00:42:28.000000', 'consum', 0.0213, 'lps'),
	(381244, 123, '2015-02-01 00:42:29.000000', 'consum', 0.0218, 'lps'),
	(381245, 123, '2015-02-01 00:42:30.000000', 'consum', 0.0224, 'lps'),
	(381246, 123, '2015-02-01 00:42:31.000000', 'consum', 0.0221, 'lps'),
	(381247, 123, '2015-02-01 00:42:32.000000', 'consum', 0.0224, 'lps'),
	(381248, 123, '2015-02-01 00:42:33.000000', 'consum', 0.0213, 'lps'),
	(381249, 123, '2015-02-01 00:42:34.000000', 'consum', 0.0220, 'lps'),
	(381250, 123, '2015-02-01 00:42:35.000000', 'consum', 0.0215, 'lps'),
	(381251, 123, '2015-02-01 00:42:36.000000', 'consum', 0.0224, 'lps'),
	(381252, 123, '2015-02-01 00:42:37.000000', 'consum', 0.0213, 'lps'),
	(381253, 123, '2015-02-01 00:42:38.000000', 'consum', 0.0217, 'lps'),
	(381254, 123, '2015-02-01 00:42:39.000000', 'consum', 0.0219, 'lps'),
	(381255, 123, '2015-02-01 00:42:40.000000', 'consum', 0.0218, 'lps'),
	(381256, 123, '2015-02-01 00:42:41.000000', 'consum', 0.0224, 'lps'),
	(381257, 123, '2015-02-01 00:42:42.000000', 'consum', 0.0224, 'lps'),
	(381258, 123, '2015-02-01 00:42:43.000000', 'consum', 0.0221, 'lps'),
	(381259, 123, '2015-02-01 00:42:44.000000', 'consum', 0.0225, 'lps'),
	(381260, 123, '2015-02-01 00:42:45.000000', 'consum', 0.0217, 'lps'),
	(381261, 123, '2015-02-01 00:42:46.000000', 'consum', 0.0216, 'lps'),
	(381262, 123, '2015-02-01 00:42:47.000000', 'consum', 0.0219, 'lps'),
	(381263, 123, '2015-02-01 00:42:48.000000', 'consum', 0.0223, 'lps'),
	(381264, 123, '2015-02-01 00:42:49.000000', 'consum', 0.0215, 'lps'),
	(381265, 123, '2015-02-01 00:42:50.000000', 'consum', 0.0214, 'lps'),
	(381266, 123, '2015-02-01 00:42:51.000000', 'consum', 0.0214, 'lps'),
	(381267, 123, '2015-02-01 00:42:52.000000', 'consum', 0.0218, 'lps'),
	(381268, 123, '2015-02-01 00:42:53.000000', 'consum', 0.0224, 'lps'),
	(381269, 123, '2015-02-01 00:42:54.000000', 'consum', 0.0219, 'lps'),
	(381270, 123, '2015-02-01 00:42:55.000000', 'consum', 0.0216, 'lps'),
	(381271, 123, '2015-02-01 00:42:56.000000', 'consum', 0.0215, 'lps'),
	(381272, 123, '2015-02-01 00:42:57.000000', 'consum', 0.0215, 'lps'),
	(381273, 123, '2015-02-01 00:42:58.000000', 'consum', 0.0219, 'lps'),
	(381274, 123, '2015-02-01 00:42:59.000000', 'consum', 0.0210, 'lps'),
	(381275, 123, '2015-02-01 00:43:00.000000', 'consum', 0.0217, 'lps'),
	(381276, 123, '2015-02-01 00:43:01.000000', 'consum', 0.0210, 'lps'),
	(381277, 123, '2015-02-01 00:43:02.000000', 'consum', 0.0224, 'lps'),
	(381278, 123, '2015-02-01 00:43:03.000000', 'consum', 0.0213, 'lps'),
	(381279, 123, '2015-02-01 00:43:04.000000', 'consum', 0.0215, 'lps'),
	(381280, 123, '2015-02-01 00:43:05.000000', 'consum', 0.0213, 'lps'),
	(381281, 123, '2015-02-01 00:43:06.000000', 'consum', 0.0210, 'lps'),
	(381282, 123, '2015-02-01 00:43:07.000000', 'consum', 0.0216, 'lps'),
	(381283, 123, '2015-02-01 00:43:08.000000', 'consum', 0.0226, 'lps'),
	(381284, 123, '2015-02-01 00:43:09.000000', 'consum', 0.0223, 'lps'),
	(381285, 123, '2015-02-01 00:43:10.000000', 'consum', 0.0225, 'lps'),
	(381286, 123, '2015-02-01 00:43:11.000000', 'consum', 0.0213, 'lps'),
	(381287, 123, '2015-02-01 00:43:12.000000', 'consum', 0.0213, 'lps'),
	(381288, 123, '2015-02-01 00:43:13.000000', 'consum', 0.0217, 'lps'),
	(381289, 123, '2015-02-01 00:43:14.000000', 'consum', 0.0218, 'lps'),
	(381290, 123, '2015-02-01 00:43:15.000000', 'consum', 0.0214, 'lps'),
	(381291, 123, '2015-02-01 00:43:16.000000', 'consum', 0.0222, 'lps'),
	(381292, 123, '2015-02-01 00:43:17.000000', 'consum', 0.0210, 'lps'),
	(381293, 123, '2015-02-01 00:43:18.000000', 'consum', 0.0224, 'lps'),
	(381294, 123, '2015-02-01 00:43:19.000000', 'consum', 0.0213, 'lps'),
	(381295, 123, '2015-02-01 00:43:20.000000', 'consum', 0.0219, 'lps'),
	(381296, 123, '2015-02-01 00:43:21.000000', 'consum', 0.0213, 'lps'),
	(381297, 123, '2015-02-01 00:43:22.000000', 'consum', 0.0212, 'lps'),
	(381298, 123, '2015-02-01 00:43:23.000000', 'consum', 0.0215, 'lps'),
	(381299, 123, '2015-02-01 00:43:24.000000', 'consum', 0.0212, 'lps'),
	(381300, 123, '2015-02-01 00:43:25.000000', 'consum', 0.0222, 'lps'),
	(381301, 123, '2015-02-01 00:43:26.000000', 'consum', 0.0215, 'lps'),
	(381302, 123, '2015-02-01 00:43:27.000000', 'consum', 0.0215, 'lps'),
	(381303, 123, '2015-02-01 00:43:28.000000', 'consum', 0.0219, 'lps'),
	(381304, 123, '2015-02-01 00:43:29.000000', 'consum', 0.0226, 'lps'),
	(381305, 123, '2015-02-01 00:43:30.000000', 'consum', 0.0210, 'lps'),
	(381306, 123, '2015-02-01 00:43:31.000000', 'consum', 0.0213, 'lps'),
	(381307, 123, '2015-02-01 00:43:32.000000', 'consum', 0.0210, 'lps'),
	(381308, 123, '2015-02-01 00:43:33.000000', 'consum', 0.0218, 'lps'),
	(381309, 123, '2015-02-01 00:43:34.000000', 'consum', 0.0215, 'lps'),
	(381310, 123, '2015-02-01 00:43:35.000000', 'consum', 0.0211, 'lps'),
	(381311, 123, '2015-02-01 00:43:36.000000', 'consum', 0.0219, 'lps'),
	(381312, 123, '2015-02-01 00:43:37.000000', 'consum', 0.0219, 'lps'),
	(381313, 123, '2015-02-01 00:43:38.000000', 'consum', 0.0213, 'lps'),
	(381314, 123, '2015-02-01 00:43:39.000000', 'consum', 0.0213, 'lps'),
	(381315, 123, '2015-02-01 00:43:40.000000', 'consum', 0.0219, 'lps'),
	(381316, 123, '2015-02-01 00:43:41.000000', 'consum', 0.0211, 'lps'),
	(381317, 123, '2015-02-01 00:43:42.000000', 'consum', 0.0221, 'lps'),
	(381318, 123, '2015-02-01 00:43:43.000000', 'consum', 0.0214, 'lps'),
	(381319, 123, '2015-02-01 00:43:44.000000', 'consum', 0.0215, 'lps'),
	(381320, 123, '2015-02-01 00:43:45.000000', 'consum', 0.0224, 'lps'),
	(381321, 123, '2015-02-01 00:43:46.000000', 'consum', 0.0215, 'lps'),
	(381322, 123, '2015-02-01 00:43:47.000000', 'consum', 0.0224, 'lps'),
	(381323, 123, '2015-02-01 00:43:48.000000', 'consum', 0.0218, 'lps'),
	(381324, 123, '2015-02-01 00:43:49.000000', 'consum', 0.0224, 'lps'),
	(381325, 123, '2015-02-01 00:43:50.000000', 'consum', 0.0224, 'lps'),
	(381326, 123, '2015-02-01 00:43:51.000000', 'consum', 0.0221, 'lps'),
	(381327, 123, '2015-02-01 00:43:52.000000', 'consum', 0.0224, 'lps'),
	(381328, 123, '2015-02-01 00:43:53.000000', 'consum', 0.0215, 'lps'),
	(381329, 123, '2015-02-01 00:43:54.000000', 'consum', 0.0226, 'lps'),
	(381330, 123, '2015-02-01 00:43:55.000000', 'consum', 0.0224, 'lps'),
	(381331, 123, '2015-02-01 00:43:56.000000', 'consum', 0.0218, 'lps'),
	(381332, 123, '2015-02-01 00:43:57.000000', 'consum', 0.0224, 'lps'),
	(381333, 123, '2015-02-01 00:43:58.000000', 'consum', 0.0223, 'lps'),
	(381334, 123, '2015-02-01 00:43:59.000000', 'consum', 0.0217, 'lps'),
	(381335, 123, '2015-02-01 00:44:00.000000', 'consum', 0.0221, 'lps'),
	(381336, 123, '2015-02-01 00:44:01.000000', 'consum', 0.0213, 'lps'),
	(381337, 123, '2015-02-01 00:44:02.000000', 'consum', 0.0226, 'lps'),
	(381338, 123, '2015-02-01 00:44:03.000000', 'consum', 0.0214, 'lps'),
	(381339, 123, '2015-02-01 00:44:04.000000', 'consum', 0.0216, 'lps'),
	(381340, 123, '2015-02-01 00:44:05.000000', 'consum', 0.0210, 'lps'),
	(381341, 123, '2015-02-01 00:44:06.000000', 'consum', 0.0211, 'lps'),
	(381342, 123, '2015-02-01 00:44:07.000000', 'consum', 0.0217, 'lps'),
	(381343, 123, '2015-02-01 00:44:08.000000', 'consum', 0.0225, 'lps'),
	(381344, 123, '2015-02-01 00:44:09.000000', 'consum', 0.0212, 'lps'),
	(381345, 123, '2015-02-01 00:44:10.000000', 'consum', 0.0210, 'lps'),
	(381346, 123, '2015-02-01 00:44:11.000000', 'consum', 0.0222, 'lps'),
	(381347, 123, '2015-02-01 00:44:12.000000', 'consum', 0.0221, 'lps'),
	(381348, 123, '2015-02-01 00:44:13.000000', 'consum', 0.0210, 'lps'),
	(381349, 123, '2015-02-01 00:44:14.000000', 'consum', 0.0212, 'lps'),
	(381350, 123, '2015-02-01 00:44:15.000000', 'consum', 0.0220, 'lps'),
	(381351, 123, '2015-02-01 00:44:16.000000', 'consum', 0.0222, 'lps'),
	(381352, 123, '2015-02-01 00:44:17.000000', 'consum', 0.0221, 'lps'),
	(381353, 123, '2015-02-01 00:44:18.000000', 'consum', 0.0214, 'lps'),
	(381354, 123, '2015-02-01 00:44:19.000000', 'consum', 0.0212, 'lps'),
	(381355, 123, '2015-02-01 00:44:20.000000', 'consum', 0.0212, 'lps'),
	(381356, 123, '2015-02-01 00:44:21.000000', 'consum', 0.0214, 'lps'),
	(381357, 123, '2015-02-01 00:44:22.000000', 'consum', 0.0226, 'lps'),
	(381358, 123, '2015-02-01 00:44:23.000000', 'consum', 0.0225, 'lps'),
	(381359, 123, '2015-02-01 00:44:24.000000', 'consum', 0.0220, 'lps'),
	(381360, 123, '2015-02-01 00:44:25.000000', 'consum', 0.0218, 'lps'),
	(381361, 123, '2015-02-01 00:44:26.000000', 'consum', 0.0220, 'lps'),
	(381362, 123, '2015-02-01 00:44:27.000000', 'consum', 0.0218, 'lps'),
	(381363, 123, '2015-02-01 00:44:28.000000', 'consum', 0.0223, 'lps'),
	(381364, 123, '2015-02-01 00:44:29.000000', 'consum', 0.0215, 'lps'),
	(381365, 123, '2015-02-01 00:44:30.000000', 'consum', 0.0212, 'lps'),
	(381366, 123, '2015-02-01 00:44:31.000000', 'consum', 0.0226, 'lps'),
	(381367, 123, '2015-02-01 00:44:32.000000', 'consum', 0.0214, 'lps'),
	(381368, 123, '2015-02-01 00:44:33.000000', 'consum', 0.0219, 'lps'),
	(381369, 123, '2015-02-01 00:44:34.000000', 'consum', 0.0210, 'lps'),
	(381370, 123, '2015-02-01 00:44:35.000000', 'consum', 0.0216, 'lps'),
	(381371, 123, '2015-02-01 00:44:36.000000', 'consum', 0.0225, 'lps'),
	(381372, 123, '2015-02-01 00:44:37.000000', 'consum', 0.0214, 'lps'),
	(381373, 123, '2015-02-01 00:44:38.000000', 'consum', 0.0223, 'lps'),
	(381374, 123, '2015-02-01 00:44:39.000000', 'consum', 0.0226, 'lps'),
	(381375, 123, '2015-02-01 00:44:40.000000', 'consum', 0.0221, 'lps'),
	(381376, 123, '2015-02-01 00:44:41.000000', 'consum', 0.0215, 'lps'),
	(381377, 123, '2015-02-01 00:44:42.000000', 'consum', 0.0222, 'lps'),
	(381378, 123, '2015-02-01 00:44:43.000000', 'consum', 0.0221, 'lps'),
	(381379, 123, '2015-02-01 00:44:44.000000', 'consum', 0.0211, 'lps'),
	(381380, 123, '2015-02-01 00:44:45.000000', 'consum', 0.0218, 'lps'),
	(381381, 123, '2015-02-01 00:44:46.000000', 'consum', 0.0215, 'lps'),
	(381382, 123, '2015-02-01 00:44:47.000000', 'consum', 0.0226, 'lps'),
	(381383, 123, '2015-02-01 00:44:48.000000', 'consum', 0.0225, 'lps'),
	(381384, 123, '2015-02-01 00:44:49.000000', 'consum', 0.0220, 'lps'),
	(381385, 123, '2015-02-01 00:44:50.000000', 'consum', 0.0216, 'lps'),
	(381386, 123, '2015-02-01 00:44:51.000000', 'consum', 0.0211, 'lps'),
	(381387, 123, '2015-02-01 00:44:52.000000', 'consum', 0.0214, 'lps'),
	(381388, 123, '2015-02-01 00:44:53.000000', 'consum', 0.0211, 'lps'),
	(381389, 123, '2015-02-01 00:44:54.000000', 'consum', 0.0222, 'lps'),
	(381390, 123, '2015-02-01 00:44:55.000000', 'consum', 0.0215, 'lps'),
	(381391, 123, '2015-02-01 00:44:56.000000', 'consum', 0.0218, 'lps'),
	(381392, 123, '2015-02-01 00:44:57.000000', 'consum', 0.0220, 'lps'),
	(381393, 123, '2015-02-01 00:44:58.000000', 'consum', 0.0216, 'lps'),
	(381394, 123, '2015-02-01 00:44:59.000000', 'consum', 0.0213, 'lps'),
	(381395, 123, '2015-02-01 00:45:00.000000', 'consum', 0.0223, 'lps'),
	(381396, 123, '2015-02-01 00:45:01.000000', 'consum', 0.0218, 'lps'),
	(381397, 123, '2015-02-01 00:45:02.000000', 'consum', 0.0225, 'lps'),
	(381398, 123, '2015-02-01 00:45:03.000000', 'consum', 0.0214, 'lps'),
	(381399, 123, '2015-02-01 00:45:04.000000', 'consum', 0.0218, 'lps'),
	(381400, 123, '2015-02-01 00:45:05.000000', 'consum', 0.0220, 'lps'),
	(381401, 123, '2015-02-01 00:45:06.000000', 'consum', 0.0219, 'lps'),
	(381402, 123, '2015-02-01 00:45:07.000000', 'consum', 0.0226, 'lps'),
	(381403, 123, '2015-02-01 00:45:08.000000', 'consum', 0.0215, 'lps'),
	(381404, 123, '2015-02-01 00:45:09.000000', 'consum', 0.0218, 'lps'),
	(381405, 123, '2015-02-01 00:45:10.000000', 'consum', 0.0222, 'lps'),
	(381406, 123, '2015-02-01 00:45:11.000000', 'consum', 0.0211, 'lps'),
	(381407, 123, '2015-02-01 00:45:12.000000', 'consum', 0.0213, 'lps'),
	(381408, 123, '2015-02-01 00:45:13.000000', 'consum', 0.0223, 'lps'),
	(381409, 123, '2015-02-01 00:45:14.000000', 'consum', 0.0217, 'lps'),
	(381410, 123, '2015-02-01 00:45:15.000000', 'consum', 0.0223, 'lps'),
	(381411, 123, '2015-02-01 00:45:16.000000', 'consum', 0.0220, 'lps'),
	(381412, 123, '2015-02-01 00:45:17.000000', 'consum', 0.0220, 'lps'),
	(381413, 123, '2015-02-01 00:45:18.000000', 'consum', 0.0214, 'lps'),
	(381414, 123, '2015-02-01 00:45:19.000000', 'consum', 0.0217, 'lps'),
	(381415, 123, '2015-02-01 00:45:20.000000', 'consum', 0.0217, 'lps'),
	(381416, 123, '2015-02-01 00:45:21.000000', 'consum', 0.0226, 'lps'),
	(381417, 123, '2015-02-01 00:45:22.000000', 'consum', 0.0217, 'lps'),
	(381418, 123, '2015-02-01 00:45:23.000000', 'consum', 0.0213, 'lps'),
	(381419, 123, '2015-02-01 00:45:24.000000', 'consum', 0.0224, 'lps'),
	(381420, 123, '2015-02-01 00:45:25.000000', 'consum', 0.0219, 'lps'),
	(381421, 123, '2015-02-01 00:45:26.000000', 'consum', 0.0215, 'lps'),
	(381422, 123, '2015-02-01 00:45:27.000000', 'consum', 0.0224, 'lps'),
	(381423, 123, '2015-02-01 00:45:28.000000', 'consum', 0.0214, 'lps'),
	(381424, 123, '2015-02-01 00:45:29.000000', 'consum', 0.0224, 'lps'),
	(381425, 123, '2015-02-01 00:45:30.000000', 'consum', 0.0217, 'lps'),
	(381426, 123, '2015-02-01 00:45:31.000000', 'consum', 0.0219, 'lps'),
	(381427, 123, '2015-02-01 00:45:32.000000', 'consum', 0.0217, 'lps'),
	(381428, 123, '2015-02-01 00:45:33.000000', 'consum', 0.0220, 'lps'),
	(381429, 123, '2015-02-01 00:45:34.000000', 'consum', 0.0223, 'lps'),
	(381430, 123, '2015-02-01 00:45:35.000000', 'consum', 0.0210, 'lps'),
	(381431, 123, '2015-02-01 00:45:36.000000', 'consum', 0.0222, 'lps'),
	(381432, 123, '2015-02-01 00:45:37.000000', 'consum', 0.0220, 'lps'),
	(381433, 123, '2015-02-01 00:45:38.000000', 'consum', 0.0223, 'lps'),
	(381434, 123, '2015-02-01 00:45:39.000000', 'consum', 0.0215, 'lps'),
	(381435, 123, '2015-02-01 00:45:40.000000', 'consum', 0.0210, 'lps'),
	(381436, 123, '2015-02-01 00:45:41.000000', 'consum', 0.0214, 'lps'),
	(381437, 123, '2015-02-01 00:45:42.000000', 'consum', 0.0212, 'lps'),
	(381438, 123, '2015-02-01 00:45:43.000000', 'consum', 0.0226, 'lps'),
	(381439, 123, '2015-02-01 00:45:44.000000', 'consum', 0.0215, 'lps'),
	(381440, 123, '2015-02-01 00:45:45.000000', 'consum', 0.0222, 'lps'),
	(381441, 123, '2015-02-01 00:45:46.000000', 'consum', 0.0222, 'lps'),
	(381442, 123, '2015-02-01 00:45:47.000000', 'consum', 0.0216, 'lps'),
	(381443, 123, '2015-02-01 00:45:48.000000', 'consum', 0.0224, 'lps'),
	(381444, 123, '2015-02-01 00:45:49.000000', 'consum', 0.0226, 'lps'),
	(381445, 123, '2015-02-01 00:45:50.000000', 'consum', 0.0217, 'lps'),
	(381446, 123, '2015-02-01 00:45:51.000000', 'consum', 0.0214, 'lps'),
	(381447, 123, '2015-02-01 00:45:52.000000', 'consum', 0.0226, 'lps'),
	(381448, 123, '2015-02-01 00:45:53.000000', 'consum', 0.0211, 'lps'),
	(381449, 123, '2015-02-01 00:45:54.000000', 'consum', 0.0219, 'lps'),
	(381450, 123, '2015-02-01 00:45:55.000000', 'consum', 0.0219, 'lps'),
	(381451, 123, '2015-02-01 00:45:56.000000', 'consum', 0.0213, 'lps'),
	(381452, 123, '2015-02-01 00:45:57.000000', 'consum', 0.0212, 'lps'),
	(381453, 123, '2015-02-01 00:45:58.000000', 'consum', 0.0215, 'lps'),
	(381454, 123, '2015-02-01 00:45:59.000000', 'consum', 0.0211, 'lps'),
	(381455, 123, '2015-02-01 00:46:00.000000', 'consum', 0.0217, 'lps'),
	(381456, 123, '2015-02-01 00:46:01.000000', 'consum', 0.0224, 'lps'),
	(381457, 123, '2015-02-01 00:46:02.000000', 'consum', 0.0210, 'lps'),
	(381458, 123, '2015-02-01 00:46:03.000000', 'consum', 0.0221, 'lps'),
	(381459, 123, '2015-02-01 00:46:04.000000', 'consum', 0.0215, 'lps'),
	(381460, 123, '2015-02-01 00:46:05.000000', 'consum', 0.0220, 'lps'),
	(381461, 123, '2015-02-01 00:46:06.000000', 'consum', 0.0211, 'lps'),
	(381462, 123, '2015-02-01 00:46:07.000000', 'consum', 0.0217, 'lps'),
	(381463, 123, '2015-02-01 00:46:08.000000', 'consum', 0.0211, 'lps'),
	(381464, 123, '2015-02-01 00:46:09.000000', 'consum', 0.0211, 'lps'),
	(381465, 123, '2015-02-01 00:46:10.000000', 'consum', 0.0210, 'lps'),
	(381466, 123, '2015-02-01 00:46:11.000000', 'consum', 0.0210, 'lps'),
	(381467, 123, '2015-02-01 00:46:12.000000', 'consum', 0.0211, 'lps'),
	(381468, 123, '2015-02-01 00:46:13.000000', 'consum', 0.0216, 'lps'),
	(381469, 123, '2015-02-01 00:46:14.000000', 'consum', 0.0220, 'lps'),
	(381470, 123, '2015-02-01 00:46:15.000000', 'consum', 0.0225, 'lps'),
	(381471, 123, '2015-02-01 00:46:16.000000', 'consum', 0.0223, 'lps'),
	(381472, 123, '2015-02-01 00:46:17.000000', 'consum', 0.0213, 'lps'),
	(381473, 123, '2015-02-01 00:46:18.000000', 'consum', 0.0222, 'lps'),
	(381474, 123, '2015-02-01 00:46:19.000000', 'consum', 0.0226, 'lps'),
	(381475, 123, '2015-02-01 00:46:20.000000', 'consum', 0.0220, 'lps'),
	(381476, 123, '2015-02-01 00:46:21.000000', 'consum', 0.0214, 'lps'),
	(381477, 123, '2015-02-01 00:46:22.000000', 'consum', 0.0218, 'lps'),
	(381478, 123, '2015-02-01 00:46:23.000000', 'consum', 0.0220, 'lps'),
	(381479, 123, '2015-02-01 00:46:24.000000', 'consum', 0.0218, 'lps'),
	(381480, 123, '2015-02-01 00:46:25.000000', 'consum', 0.0222, 'lps'),
	(381481, 123, '2015-02-01 00:46:26.000000', 'consum', 0.0211, 'lps'),
	(381482, 123, '2015-02-01 00:46:27.000000', 'consum', 0.0216, 'lps'),
	(381483, 123, '2015-02-01 00:46:28.000000', 'consum', 0.0221, 'lps'),
	(381484, 123, '2015-02-01 00:46:29.000000', 'consum', 0.0214, 'lps'),
	(381485, 123, '2015-02-01 00:46:30.000000', 'consum', 0.0215, 'lps'),
	(381486, 123, '2015-02-01 00:46:31.000000', 'consum', 0.0222, 'lps'),
	(381487, 123, '2015-02-01 00:46:32.000000', 'consum', 0.0222, 'lps'),
	(381488, 123, '2015-02-01 00:46:33.000000', 'consum', 0.0216, 'lps'),
	(381489, 123, '2015-02-01 00:46:34.000000', 'consum', 0.0223, 'lps'),
	(381490, 123, '2015-02-01 00:46:35.000000', 'consum', 0.0222, 'lps'),
	(381491, 123, '2015-02-01 00:46:36.000000', 'consum', 0.0213, 'lps'),
	(381492, 123, '2015-02-01 00:46:37.000000', 'consum', 0.0226, 'lps'),
	(381493, 123, '2015-02-01 00:46:38.000000', 'consum', 0.0214, 'lps'),
	(381494, 123, '2015-02-01 00:46:39.000000', 'consum', 0.0217, 'lps'),
	(381495, 123, '2015-02-01 00:46:40.000000', 'consum', 0.0214, 'lps'),
	(381496, 123, '2015-02-01 00:46:41.000000', 'consum', 0.0226, 'lps'),
	(381497, 123, '2015-02-01 00:46:42.000000', 'consum', 0.0212, 'lps'),
	(381498, 123, '2015-02-01 00:46:43.000000', 'consum', 0.0223, 'lps'),
	(381499, 123, '2015-02-01 00:46:44.000000', 'consum', 0.0219, 'lps'),
	(381500, 123, '2015-02-01 00:46:45.000000', 'consum', 0.0217, 'lps'),
	(381501, 123, '2015-02-01 00:46:46.000000', 'consum', 0.0217, 'lps'),
	(381502, 123, '2015-02-01 00:46:47.000000', 'consum', 0.0224, 'lps'),
	(381503, 123, '2015-02-01 00:46:48.000000', 'consum', 0.0226, 'lps'),
	(381504, 123, '2015-02-01 00:46:49.000000', 'consum', 0.0213, 'lps'),
	(381505, 123, '2015-02-01 00:46:50.000000', 'consum', 0.0213, 'lps'),
	(381506, 123, '2015-02-01 00:46:51.000000', 'consum', 0.0217, 'lps'),
	(381507, 123, '2015-02-01 00:46:52.000000', 'consum', 0.0220, 'lps'),
	(381508, 123, '2015-02-01 00:46:53.000000', 'consum', 0.0220, 'lps'),
	(381509, 123, '2015-02-01 00:46:54.000000', 'consum', 0.0216, 'lps'),
	(381510, 123, '2015-02-01 00:46:55.000000', 'consum', 0.0210, 'lps'),
	(381511, 123, '2015-02-01 00:46:56.000000', 'consum', 0.0210, 'lps'),
	(381512, 123, '2015-02-01 00:46:57.000000', 'consum', 0.0211, 'lps'),
	(381513, 123, '2015-02-01 00:46:58.000000', 'consum', 0.0216, 'lps'),
	(381514, 123, '2015-02-01 00:46:59.000000', 'consum', 0.0219, 'lps'),
	(381515, 123, '2015-02-01 00:47:00.000000', 'consum', 0.0222, 'lps'),
	(381516, 123, '2015-02-01 00:47:01.000000', 'consum', 0.0225, 'lps'),
	(381517, 123, '2015-02-01 00:47:02.000000', 'consum', 0.0217, 'lps'),
	(381518, 123, '2015-02-01 00:47:03.000000', 'consum', 0.0218, 'lps'),
	(381519, 123, '2015-02-01 00:47:04.000000', 'consum', 0.0210, 'lps'),
	(381520, 123, '2015-02-01 00:47:05.000000', 'consum', 0.0223, 'lps'),
	(381521, 123, '2015-02-01 00:47:06.000000', 'consum', 0.0226, 'lps'),
	(381522, 123, '2015-02-01 00:47:07.000000', 'consum', 0.0215, 'lps'),
	(381523, 123, '2015-02-01 00:47:08.000000', 'consum', 0.0220, 'lps'),
	(381524, 123, '2015-02-01 00:47:09.000000', 'consum', 0.0213, 'lps'),
	(381525, 123, '2015-02-01 00:47:10.000000', 'consum', 0.0214, 'lps'),
	(381526, 123, '2015-02-01 00:47:11.000000', 'consum', 0.0221, 'lps'),
	(381527, 123, '2015-02-01 00:47:12.000000', 'consum', 0.0218, 'lps'),
	(381528, 123, '2015-02-01 00:47:13.000000', 'consum', 0.0220, 'lps'),
	(381529, 123, '2015-02-01 00:47:14.000000', 'consum', 0.0217, 'lps'),
	(381530, 123, '2015-02-01 00:47:15.000000', 'consum', 0.0215, 'lps'),
	(381531, 123, '2015-02-01 00:47:16.000000', 'consum', 0.0213, 'lps'),
	(381532, 123, '2015-02-01 00:47:17.000000', 'consum', 0.0214, 'lps'),
	(381533, 123, '2015-02-01 00:47:18.000000', 'consum', 0.0221, 'lps'),
	(381534, 123, '2015-02-01 00:47:19.000000', 'consum', 0.0217, 'lps'),
	(381535, 123, '2015-02-01 00:47:20.000000', 'consum', 0.0214, 'lps'),
	(381536, 123, '2015-02-01 00:47:21.000000', 'consum', 0.0225, 'lps'),
	(381537, 123, '2015-02-01 00:47:22.000000', 'consum', 0.0222, 'lps'),
	(381538, 123, '2015-02-01 00:47:23.000000', 'consum', 0.0226, 'lps'),
	(381539, 123, '2015-02-01 00:47:24.000000', 'consum', 0.0220, 'lps'),
	(381540, 123, '2015-02-01 00:47:25.000000', 'consum', 0.0214, 'lps'),
	(381541, 123, '2015-02-01 00:47:26.000000', 'consum', 0.0219, 'lps'),
	(381542, 123, '2015-02-01 00:47:27.000000', 'consum', 0.0224, 'lps'),
	(381543, 123, '2015-02-01 00:47:28.000000', 'consum', 0.0219, 'lps'),
	(381544, 123, '2015-02-01 00:47:29.000000', 'consum', 0.0215, 'lps'),
	(381545, 123, '2015-02-01 00:47:30.000000', 'consum', 0.0226, 'lps'),
	(381546, 123, '2015-02-01 00:47:31.000000', 'consum', 0.0225, 'lps'),
	(381547, 123, '2015-02-01 00:47:32.000000', 'consum', 0.0222, 'lps'),
	(381548, 123, '2015-02-01 00:47:33.000000', 'consum', 0.0223, 'lps'),
	(381549, 123, '2015-02-01 00:47:34.000000', 'consum', 0.0222, 'lps'),
	(381550, 123, '2015-02-01 00:47:35.000000', 'consum', 0.0217, 'lps'),
	(381551, 123, '2015-02-01 00:47:36.000000', 'consum', 0.0225, 'lps'),
	(381552, 123, '2015-02-01 00:47:37.000000', 'consum', 0.0214, 'lps'),
	(381553, 123, '2015-02-01 00:47:38.000000', 'consum', 0.0218, 'lps'),
	(381554, 123, '2015-02-01 00:47:39.000000', 'consum', 0.0222, 'lps'),
	(381555, 123, '2015-02-01 00:47:40.000000', 'consum', 0.0212, 'lps'),
	(381556, 123, '2015-02-01 00:47:41.000000', 'consum', 0.0220, 'lps'),
	(381557, 123, '2015-02-01 00:47:42.000000', 'consum', 0.0220, 'lps'),
	(381558, 123, '2015-02-01 00:47:43.000000', 'consum', 0.0212, 'lps'),
	(381559, 123, '2015-02-01 00:47:44.000000', 'consum', 0.0225, 'lps'),
	(381560, 123, '2015-02-01 00:47:45.000000', 'consum', 0.0210, 'lps'),
	(381561, 123, '2015-02-01 00:47:46.000000', 'consum', 0.0220, 'lps'),
	(381562, 123, '2015-02-01 00:47:47.000000', 'consum', 0.0224, 'lps'),
	(381563, 123, '2015-02-01 00:47:48.000000', 'consum', 0.0218, 'lps'),
	(381564, 123, '2015-02-01 00:47:49.000000', 'consum', 0.0225, 'lps'),
	(381565, 123, '2015-02-01 00:47:50.000000', 'consum', 0.0212, 'lps'),
	(381566, 123, '2015-02-01 00:47:51.000000', 'consum', 0.0223, 'lps'),
	(381567, 123, '2015-02-01 00:47:52.000000', 'consum', 0.0221, 'lps'),
	(381568, 123, '2015-02-01 00:47:53.000000', 'consum', 0.0211, 'lps'),
	(381569, 123, '2015-02-01 00:47:54.000000', 'consum', 0.0215, 'lps'),
	(381570, 123, '2015-02-01 00:47:55.000000', 'consum', 0.0214, 'lps'),
	(381571, 123, '2015-02-01 00:47:56.000000', 'consum', 0.0215, 'lps'),
	(381572, 123, '2015-02-01 00:47:57.000000', 'consum', 0.0226, 'lps'),
	(381573, 123, '2015-02-01 00:47:58.000000', 'consum', 0.0224, 'lps'),
	(381574, 123, '2015-02-01 00:47:59.000000', 'consum', 0.0213, 'lps'),
	(381575, 123, '2015-02-01 00:48:00.000000', 'consum', 0.0219, 'lps'),
	(381576, 123, '2015-02-01 00:48:01.000000', 'consum', 0.0214, 'lps'),
	(381577, 123, '2015-02-01 00:48:02.000000', 'consum', 0.0221, 'lps'),
	(381578, 123, '2015-02-01 00:48:03.000000', 'consum', 0.0216, 'lps'),
	(381579, 123, '2015-02-01 00:48:04.000000', 'consum', 0.0211, 'lps'),
	(381580, 123, '2015-02-01 00:48:05.000000', 'consum', 0.0213, 'lps'),
	(381581, 123, '2015-02-01 00:48:06.000000', 'consum', 0.0222, 'lps'),
	(381582, 123, '2015-02-01 00:48:07.000000', 'consum', 0.0210, 'lps'),
	(381583, 123, '2015-02-01 00:48:08.000000', 'consum', 0.0211, 'lps'),
	(381584, 123, '2015-02-01 00:48:09.000000', 'consum', 0.0212, 'lps'),
	(381585, 123, '2015-02-01 00:48:10.000000', 'consum', 0.0220, 'lps'),
	(381586, 123, '2015-02-01 00:48:11.000000', 'consum', 0.0222, 'lps'),
	(381587, 123, '2015-02-01 00:48:12.000000', 'consum', 0.0221, 'lps'),
	(381588, 123, '2015-02-01 00:48:13.000000', 'consum', 0.0214, 'lps'),
	(381589, 123, '2015-02-01 00:48:14.000000', 'consum', 0.0215, 'lps'),
	(381590, 123, '2015-02-01 00:48:15.000000', 'consum', 0.0223, 'lps'),
	(381591, 123, '2015-02-01 00:48:16.000000', 'consum', 0.0225, 'lps'),
	(381592, 123, '2015-02-01 00:48:17.000000', 'consum', 0.0213, 'lps'),
	(381593, 123, '2015-02-01 00:48:18.000000', 'consum', 0.0217, 'lps'),
	(381594, 123, '2015-02-01 00:48:19.000000', 'consum', 0.0217, 'lps'),
	(381595, 123, '2015-02-01 00:48:20.000000', 'consum', 0.0225, 'lps'),
	(381596, 123, '2015-02-01 00:48:21.000000', 'consum', 0.0211, 'lps'),
	(381597, 123, '2015-02-01 00:48:22.000000', 'consum', 0.0225, 'lps'),
	(381598, 123, '2015-02-01 00:48:23.000000', 'consum', 0.0215, 'lps'),
	(381599, 123, '2015-02-01 00:48:24.000000', 'consum', 0.0224, 'lps'),
	(381600, 123, '2015-02-01 00:48:25.000000', 'consum', 0.0215, 'lps'),
	(381601, 123, '2015-02-01 00:48:26.000000', 'consum', 0.0225, 'lps'),
	(381602, 123, '2015-02-01 00:48:27.000000', 'consum', 0.0220, 'lps'),
	(381603, 123, '2015-02-01 00:48:28.000000', 'consum', 0.0216, 'lps'),
	(381604, 123, '2015-02-01 00:48:29.000000', 'consum', 0.0226, 'lps'),
	(381605, 123, '2015-02-01 00:48:30.000000', 'consum', 0.0221, 'lps'),
	(381606, 123, '2015-02-01 00:48:31.000000', 'consum', 0.0220, 'lps'),
	(381607, 123, '2015-02-01 00:48:32.000000', 'consum', 0.0211, 'lps'),
	(381608, 123, '2015-02-01 00:48:33.000000', 'consum', 0.0217, 'lps'),
	(381609, 123, '2015-02-01 00:48:34.000000', 'consum', 0.0210, 'lps'),
	(381610, 123, '2015-02-01 00:48:35.000000', 'consum', 0.0223, 'lps'),
	(381611, 123, '2015-02-01 00:48:36.000000', 'consum', 0.0210, 'lps'),
	(381612, 123, '2015-02-01 00:48:37.000000', 'consum', 0.0219, 'lps'),
	(381613, 123, '2015-02-01 00:48:38.000000', 'consum', 0.0223, 'lps'),
	(381614, 123, '2015-02-01 00:48:39.000000', 'consum', 0.0214, 'lps'),
	(381615, 123, '2015-02-01 00:48:40.000000', 'consum', 0.0211, 'lps'),
	(381616, 123, '2015-02-01 00:48:41.000000', 'consum', 0.0218, 'lps'),
	(381617, 123, '2015-02-01 00:48:42.000000', 'consum', 0.0213, 'lps'),
	(381618, 123, '2015-02-01 00:48:43.000000', 'consum', 0.0218, 'lps'),
	(381619, 123, '2015-02-01 00:48:44.000000', 'consum', 0.0226, 'lps'),
	(381620, 123, '2015-02-01 00:48:45.000000', 'consum', 0.0215, 'lps'),
	(381621, 123, '2015-02-01 00:48:46.000000', 'consum', 0.0223, 'lps'),
	(381622, 123, '2015-02-01 00:48:47.000000', 'consum', 0.0210, 'lps'),
	(381623, 123, '2015-02-01 00:48:48.000000', 'consum', 0.0222, 'lps'),
	(381624, 123, '2015-02-01 00:48:49.000000', 'consum', 0.0220, 'lps'),
	(381625, 123, '2015-02-01 00:48:50.000000', 'consum', 0.0225, 'lps'),
	(381626, 123, '2015-02-01 00:48:51.000000', 'consum', 0.0223, 'lps'),
	(381627, 123, '2015-02-01 00:48:52.000000', 'consum', 0.0211, 'lps'),
	(381628, 123, '2015-02-01 00:48:53.000000', 'consum', 0.0210, 'lps'),
	(381629, 123, '2015-02-01 00:48:54.000000', 'consum', 0.0225, 'lps'),
	(381630, 123, '2015-02-01 00:48:55.000000', 'consum', 0.0218, 'lps'),
	(381631, 123, '2015-02-01 00:48:56.000000', 'consum', 0.0221, 'lps'),
	(381632, 123, '2015-02-01 00:48:57.000000', 'consum', 0.0210, 'lps'),
	(381633, 123, '2015-02-01 00:48:58.000000', 'consum', 0.0210, 'lps'),
	(381634, 123, '2015-02-01 00:48:59.000000', 'consum', 0.0211, 'lps'),
	(381635, 123, '2015-02-01 00:49:00.000000', 'consum', 0.0215, 'lps'),
	(381636, 123, '2015-02-01 00:49:01.000000', 'consum', 0.0214, 'lps'),
	(381637, 123, '2015-02-01 00:49:02.000000', 'consum', 0.0217, 'lps'),
	(381638, 123, '2015-02-01 00:49:03.000000', 'consum', 0.0217, 'lps'),
	(381639, 123, '2015-02-01 00:49:04.000000', 'consum', 0.0223, 'lps'),
	(381640, 123, '2015-02-01 00:49:05.000000', 'consum', 0.0222, 'lps'),
	(381641, 123, '2015-02-01 00:49:06.000000', 'consum', 0.0214, 'lps'),
	(381642, 123, '2015-02-01 00:49:07.000000', 'consum', 0.0212, 'lps'),
	(381643, 123, '2015-02-01 00:49:08.000000', 'consum', 0.0223, 'lps'),
	(381644, 123, '2015-02-01 00:49:09.000000', 'consum', 0.0220, 'lps'),
	(381645, 123, '2015-02-01 00:49:10.000000', 'consum', 0.0223, 'lps'),
	(381646, 123, '2015-02-01 00:49:11.000000', 'consum', 0.0226, 'lps'),
	(381647, 123, '2015-02-01 00:49:12.000000', 'consum', 0.0217, 'lps'),
	(381648, 123, '2015-02-01 00:49:13.000000', 'consum', 0.0213, 'lps'),
	(381649, 123, '2015-02-01 00:49:14.000000', 'consum', 0.0225, 'lps'),
	(381650, 123, '2015-02-01 00:49:15.000000', 'consum', 0.0224, 'lps'),
	(381651, 123, '2015-02-01 00:49:16.000000', 'consum', 0.0221, 'lps'),
	(381652, 123, '2015-02-01 00:49:17.000000', 'consum', 0.0221, 'lps'),
	(381653, 123, '2015-02-01 00:49:18.000000', 'consum', 0.0217, 'lps'),
	(381654, 123, '2015-02-01 00:49:19.000000', 'consum', 0.0213, 'lps'),
	(381655, 123, '2015-02-01 00:49:20.000000', 'consum', 0.0219, 'lps'),
	(381656, 123, '2015-02-01 00:49:21.000000', 'consum', 0.0213, 'lps'),
	(381657, 123, '2015-02-01 00:49:22.000000', 'consum', 0.0215, 'lps'),
	(381658, 123, '2015-02-01 00:49:23.000000', 'consum', 0.0211, 'lps'),
	(381659, 123, '2015-02-01 00:49:24.000000', 'consum', 0.0218, 'lps'),
	(381660, 123, '2015-02-01 00:49:25.000000', 'consum', 0.0215, 'lps'),
	(381661, 123, '2015-02-01 00:49:26.000000', 'consum', 0.0226, 'lps'),
	(381662, 123, '2015-02-01 00:49:27.000000', 'consum', 0.0226, 'lps'),
	(381663, 123, '2015-02-01 00:49:28.000000', 'consum', 0.0225, 'lps'),
	(381664, 123, '2015-02-01 00:49:29.000000', 'consum', 0.0220, 'lps'),
	(381665, 123, '2015-02-01 00:49:30.000000', 'consum', 0.0216, 'lps'),
	(381666, 123, '2015-02-01 00:49:31.000000', 'consum', 0.0226, 'lps'),
	(381667, 123, '2015-02-01 00:49:32.000000', 'consum', 0.0224, 'lps'),
	(381668, 123, '2015-02-01 00:49:33.000000', 'consum', 0.0215, 'lps'),
	(381669, 123, '2015-02-01 00:49:34.000000', 'consum', 0.0210, 'lps'),
	(381670, 123, '2015-02-01 00:49:35.000000', 'consum', 0.0213, 'lps'),
	(381671, 123, '2015-02-01 00:49:36.000000', 'consum', 0.0210, 'lps'),
	(381672, 123, '2015-02-01 00:49:37.000000', 'consum', 0.0216, 'lps'),
	(381673, 123, '2015-02-01 00:49:38.000000', 'consum', 0.0223, 'lps'),
	(381674, 123, '2015-02-01 00:49:39.000000', 'consum', 0.0225, 'lps'),
	(381675, 123, '2015-02-01 00:49:40.000000', 'consum', 0.0214, 'lps'),
	(381676, 123, '2015-02-01 00:49:41.000000', 'consum', 0.0218, 'lps'),
	(381677, 123, '2015-02-01 00:49:42.000000', 'consum', 0.0223, 'lps'),
	(381678, 123, '2015-02-01 00:49:43.000000', 'consum', 0.0216, 'lps'),
	(381679, 123, '2015-02-01 00:49:44.000000', 'consum', 0.0221, 'lps'),
	(381680, 123, '2015-02-01 00:49:45.000000', 'consum', 0.0211, 'lps'),
	(381681, 123, '2015-02-01 00:49:46.000000', 'consum', 0.0216, 'lps'),
	(381682, 123, '2015-02-01 00:49:47.000000', 'consum', 0.0221, 'lps'),
	(381683, 123, '2015-02-01 00:49:48.000000', 'consum', 0.0215, 'lps'),
	(381684, 123, '2015-02-01 00:49:49.000000', 'consum', 0.0220, 'lps'),
	(381685, 123, '2015-02-01 00:49:50.000000', 'consum', 0.0211, 'lps'),
	(381686, 123, '2015-02-01 00:49:51.000000', 'consum', 0.0219, 'lps'),
	(381687, 123, '2015-02-01 00:49:52.000000', 'consum', 0.0217, 'lps'),
	(381688, 123, '2015-02-01 00:49:53.000000', 'consum', 0.0219, 'lps'),
	(381689, 123, '2015-02-01 00:49:54.000000', 'consum', 0.0216, 'lps'),
	(381690, 123, '2015-02-01 00:49:55.000000', 'consum', 0.0217, 'lps'),
	(381691, 123, '2015-02-01 00:49:56.000000', 'consum', 0.0225, 'lps'),
	(381692, 123, '2015-02-01 00:49:57.000000', 'consum', 0.0216, 'lps'),
	(381693, 123, '2015-02-01 00:49:58.000000', 'consum', 0.0210, 'lps'),
	(381694, 123, '2015-02-01 00:49:59.000000', 'consum', 0.0210, 'lps'),
	(381695, 123, '2015-02-01 00:50:00.000000', 'consum', 0.0210, 'lps'),
	(381696, 123, '2015-02-01 00:50:01.000000', 'consum', 0.0212, 'lps'),
	(381697, 123, '2015-02-01 00:50:02.000000', 'consum', 0.0219, 'lps'),
	(381698, 123, '2015-02-01 00:50:03.000000', 'consum', 0.0218, 'lps'),
	(381699, 123, '2015-02-01 00:50:04.000000', 'consum', 0.0221, 'lps'),
	(381700, 123, '2015-02-01 00:50:05.000000', 'consum', 0.0225, 'lps'),
	(381701, 123, '2015-02-01 00:50:06.000000', 'consum', 0.0218, 'lps'),
	(381702, 123, '2015-02-01 00:50:07.000000', 'consum', 0.0223, 'lps'),
	(381703, 123, '2015-02-01 00:50:08.000000', 'consum', 0.0218, 'lps'),
	(381704, 123, '2015-02-01 00:50:09.000000', 'consum', 0.0226, 'lps'),
	(381705, 123, '2015-02-01 00:50:10.000000', 'consum', 0.0218, 'lps'),
	(381706, 123, '2015-02-01 00:50:11.000000', 'consum', 0.0219, 'lps'),
	(381707, 123, '2015-02-01 00:50:12.000000', 'consum', 0.0213, 'lps'),
	(381708, 123, '2015-02-01 00:50:13.000000', 'consum', 0.0218, 'lps'),
	(381709, 123, '2015-02-01 00:50:14.000000', 'consum', 0.0224, 'lps'),
	(381710, 123, '2015-02-01 00:50:15.000000', 'consum', 0.0224, 'lps'),
	(381711, 123, '2015-02-01 00:50:16.000000', 'consum', 0.0221, 'lps'),
	(381712, 123, '2015-02-01 00:50:17.000000', 'consum', 0.0223, 'lps'),
	(381713, 123, '2015-02-01 00:50:18.000000', 'consum', 0.0210, 'lps'),
	(381714, 123, '2015-02-01 00:50:19.000000', 'consum', 0.0221, 'lps'),
	(381715, 123, '2015-02-01 00:50:20.000000', 'consum', 0.0216, 'lps'),
	(381716, 123, '2015-02-01 00:50:21.000000', 'consum', 0.0225, 'lps'),
	(381717, 123, '2015-02-01 00:50:22.000000', 'consum', 0.0215, 'lps'),
	(381718, 123, '2015-02-01 00:50:23.000000', 'consum', 0.0224, 'lps'),
	(381719, 123, '2015-02-01 00:50:24.000000', 'consum', 0.0214, 'lps'),
	(381720, 123, '2015-02-01 00:50:25.000000', 'consum', 0.0224, 'lps'),
	(381721, 123, '2015-02-01 00:50:26.000000', 'consum', 0.0216, 'lps'),
	(381722, 123, '2015-02-01 00:50:27.000000', 'consum', 0.0215, 'lps'),
	(381723, 123, '2015-02-01 00:50:28.000000', 'consum', 0.0219, 'lps'),
	(381724, 123, '2015-02-01 00:50:29.000000', 'consum', 0.0224, 'lps'),
	(381725, 123, '2015-02-01 00:50:30.000000', 'consum', 0.0221, 'lps'),
	(381726, 123, '2015-02-01 00:50:31.000000', 'consum', 0.0221, 'lps'),
	(381727, 123, '2015-02-01 00:50:32.000000', 'consum', 0.0217, 'lps'),
	(381728, 123, '2015-02-01 00:50:33.000000', 'consum', 0.0214, 'lps'),
	(381729, 123, '2015-02-01 00:50:34.000000', 'consum', 0.0223, 'lps'),
	(381730, 123, '2015-02-01 00:50:35.000000', 'consum', 0.0215, 'lps'),
	(381731, 123, '2015-02-01 00:50:36.000000', 'consum', 0.0212, 'lps'),
	(381732, 123, '2015-02-01 00:50:37.000000', 'consum', 0.0222, 'lps'),
	(381733, 123, '2015-02-01 00:50:38.000000', 'consum', 0.0216, 'lps'),
	(381734, 123, '2015-02-01 00:50:39.000000', 'consum', 0.0221, 'lps'),
	(381735, 123, '2015-02-01 00:50:40.000000', 'consum', 0.0215, 'lps'),
	(381736, 123, '2015-02-01 00:50:41.000000', 'consum', 0.0216, 'lps'),
	(381737, 123, '2015-02-01 00:50:42.000000', 'consum', 0.0211, 'lps'),
	(381738, 123, '2015-02-01 00:50:43.000000', 'consum', 0.0214, 'lps'),
	(381739, 123, '2015-02-01 00:50:44.000000', 'consum', 0.0211, 'lps'),
	(381740, 123, '2015-02-01 00:50:45.000000', 'consum', 0.0221, 'lps'),
	(381741, 123, '2015-02-01 00:50:46.000000', 'consum', 0.0212, 'lps'),
	(381742, 123, '2015-02-01 00:50:47.000000', 'consum', 0.0219, 'lps'),
	(381743, 123, '2015-02-01 00:50:48.000000', 'consum', 0.0215, 'lps'),
	(381744, 123, '2015-02-01 00:50:49.000000', 'consum', 0.0210, 'lps'),
	(381745, 123, '2015-02-01 00:50:50.000000', 'consum', 0.0213, 'lps'),
	(381746, 123, '2015-02-01 00:50:51.000000', 'consum', 0.0223, 'lps'),
	(381747, 123, '2015-02-01 00:50:52.000000', 'consum', 0.0217, 'lps'),
	(381748, 123, '2015-02-01 00:50:53.000000', 'consum', 0.0221, 'lps'),
	(381749, 123, '2015-02-01 00:50:54.000000', 'consum', 0.0213, 'lps'),
	(381750, 123, '2015-02-01 00:50:55.000000', 'consum', 0.0211, 'lps'),
	(381751, 123, '2015-02-01 00:50:56.000000', 'consum', 0.0222, 'lps'),
	(381752, 123, '2015-02-01 00:50:57.000000', 'consum', 0.0215, 'lps'),
	(381753, 123, '2015-02-01 00:50:58.000000', 'consum', 0.0218, 'lps'),
	(381754, 123, '2015-02-01 00:50:59.000000', 'consum', 0.0217, 'lps'),
	(381755, 123, '2015-02-01 00:51:00.000000', 'consum', 0.0221, 'lps'),
	(381756, 123, '2015-02-01 00:51:01.000000', 'consum', 0.0212, 'lps'),
	(381757, 123, '2015-02-01 00:51:02.000000', 'consum', 0.0221, 'lps'),
	(381758, 123, '2015-02-01 00:51:03.000000', 'consum', 0.0211, 'lps'),
	(381759, 123, '2015-02-01 00:51:04.000000', 'consum', 0.0213, 'lps'),
	(381760, 123, '2015-02-01 00:51:05.000000', 'consum', 0.0225, 'lps'),
	(381761, 123, '2015-02-01 00:51:06.000000', 'consum', 0.0223, 'lps'),
	(381762, 123, '2015-02-01 00:51:07.000000', 'consum', 0.0214, 'lps'),
	(381763, 123, '2015-02-01 00:51:08.000000', 'consum', 0.0211, 'lps'),
	(381764, 123, '2015-02-01 00:51:09.000000', 'consum', 0.0219, 'lps'),
	(381765, 123, '2015-02-01 00:51:10.000000', 'consum', 0.0220, 'lps'),
	(381766, 123, '2015-02-01 00:51:11.000000', 'consum', 0.0214, 'lps'),
	(381767, 123, '2015-02-01 00:51:12.000000', 'consum', 0.0220, 'lps'),
	(381768, 123, '2015-02-01 00:51:13.000000', 'consum', 0.0215, 'lps'),
	(381769, 123, '2015-02-01 00:51:14.000000', 'consum', 0.0221, 'lps'),
	(381770, 123, '2015-02-01 00:51:15.000000', 'consum', 0.0217, 'lps'),
	(381771, 123, '2015-02-01 00:51:16.000000', 'consum', 0.0211, 'lps'),
	(381772, 123, '2015-02-01 00:51:17.000000', 'consum', 0.0211, 'lps'),
	(381773, 123, '2015-02-01 00:51:18.000000', 'consum', 0.0215, 'lps'),
	(381774, 123, '2015-02-01 00:51:19.000000', 'consum', 0.0217, 'lps'),
	(381775, 123, '2015-02-01 00:51:20.000000', 'consum', 0.0210, 'lps'),
	(381776, 123, '2015-02-01 00:51:21.000000', 'consum', 0.0224, 'lps'),
	(381777, 123, '2015-02-01 00:51:22.000000', 'consum', 0.0213, 'lps'),
	(381778, 123, '2015-02-01 00:51:23.000000', 'consum', 0.0217, 'lps'),
	(381779, 123, '2015-02-01 00:51:24.000000', 'consum', 0.0219, 'lps'),
	(381780, 123, '2015-02-01 00:51:25.000000', 'consum', 0.0218, 'lps'),
	(381781, 123, '2015-02-01 00:51:26.000000', 'consum', 0.0222, 'lps'),
	(381782, 123, '2015-02-01 00:51:27.000000', 'consum', 0.0213, 'lps'),
	(381783, 123, '2015-02-01 00:51:28.000000', 'consum', 0.0225, 'lps'),
	(381784, 123, '2015-02-01 00:51:29.000000', 'consum', 0.0223, 'lps'),
	(381785, 123, '2015-02-01 00:51:30.000000', 'consum', 0.0214, 'lps'),
	(381786, 123, '2015-02-01 00:51:31.000000', 'consum', 0.0226, 'lps'),
	(381787, 123, '2015-02-01 00:51:32.000000', 'consum', 0.0225, 'lps'),
	(381788, 123, '2015-02-01 00:51:33.000000', 'consum', 0.0224, 'lps'),
	(381789, 123, '2015-02-01 00:51:34.000000', 'consum', 0.0218, 'lps'),
	(381790, 123, '2015-02-01 00:51:35.000000', 'consum', 0.0226, 'lps'),
	(381791, 123, '2015-02-01 00:51:36.000000', 'consum', 0.0217, 'lps'),
	(381792, 123, '2015-02-01 00:51:37.000000', 'consum', 0.0211, 'lps'),
	(381793, 123, '2015-02-01 00:51:38.000000', 'consum', 0.0213, 'lps'),
	(381794, 123, '2015-02-01 00:51:39.000000', 'consum', 0.0224, 'lps'),
	(381795, 123, '2015-02-01 00:51:40.000000', 'consum', 0.0220, 'lps'),
	(381796, 123, '2015-02-01 00:51:41.000000', 'consum', 0.0217, 'lps'),
	(381797, 123, '2015-02-01 00:51:42.000000', 'consum', 0.0216, 'lps'),
	(381798, 123, '2015-02-01 00:51:43.000000', 'consum', 0.0221, 'lps'),
	(381799, 123, '2015-02-01 00:51:44.000000', 'consum', 0.0213, 'lps'),
	(381800, 123, '2015-02-01 00:51:45.000000', 'consum', 0.0224, 'lps'),
	(381801, 123, '2015-02-01 00:51:46.000000', 'consum', 0.0224, 'lps'),
	(381802, 123, '2015-02-01 00:51:47.000000', 'consum', 0.0220, 'lps'),
	(381803, 123, '2015-02-01 00:51:48.000000', 'consum', 0.0218, 'lps'),
	(381804, 123, '2015-02-01 00:51:49.000000', 'consum', 0.0221, 'lps'),
	(381805, 123, '2015-02-01 00:51:50.000000', 'consum', 0.0223, 'lps'),
	(381806, 123, '2015-02-01 00:51:51.000000', 'consum', 0.0210, 'lps'),
	(381807, 123, '2015-02-01 00:51:52.000000', 'consum', 0.0221, 'lps'),
	(381808, 123, '2015-02-01 00:51:53.000000', 'consum', 0.0214, 'lps'),
	(381809, 123, '2015-02-01 00:51:54.000000', 'consum', 0.0216, 'lps'),
	(381810, 123, '2015-02-01 00:51:55.000000', 'consum', 0.0211, 'lps'),
	(381811, 123, '2015-02-01 00:51:56.000000', 'consum', 0.0214, 'lps'),
	(381812, 123, '2015-02-01 00:51:57.000000', 'consum', 0.0212, 'lps'),
	(381813, 123, '2015-02-01 00:51:58.000000', 'consum', 0.0223, 'lps'),
	(381814, 123, '2015-02-01 00:51:59.000000', 'consum', 0.0221, 'lps'),
	(381815, 123, '2015-02-01 00:52:00.000000', 'consum', 0.0226, 'lps'),
	(381816, 123, '2015-02-01 00:52:01.000000', 'consum', 0.0224, 'lps'),
	(381817, 123, '2015-02-01 00:52:02.000000', 'consum', 0.0213, 'lps'),
	(381818, 123, '2015-02-01 00:52:03.000000', 'consum', 0.0220, 'lps'),
	(381819, 123, '2015-02-01 00:52:04.000000', 'consum', 0.0215, 'lps'),
	(381820, 123, '2015-02-01 00:52:05.000000', 'consum', 0.0224, 'lps'),
	(381821, 123, '2015-02-01 00:52:06.000000', 'consum', 0.0216, 'lps'),
	(381822, 123, '2015-02-01 00:52:07.000000', 'consum', 0.0216, 'lps'),
	(381823, 123, '2015-02-01 00:52:08.000000', 'consum', 0.0221, 'lps'),
	(381824, 123, '2015-02-01 00:52:09.000000', 'consum', 0.0213, 'lps'),
	(381825, 123, '2015-02-01 00:52:10.000000', 'consum', 0.0210, 'lps'),
	(381826, 123, '2015-02-01 00:52:11.000000', 'consum', 0.0220, 'lps'),
	(381827, 123, '2015-02-01 00:52:12.000000', 'consum', 0.0210, 'lps'),
	(381828, 123, '2015-02-01 00:52:13.000000', 'consum', 0.0214, 'lps'),
	(381829, 123, '2015-02-01 00:52:14.000000', 'consum', 0.0213, 'lps'),
	(381830, 123, '2015-02-01 00:52:15.000000', 'consum', 0.0213, 'lps'),
	(381831, 123, '2015-02-01 00:52:16.000000', 'consum', 0.0218, 'lps'),
	(381832, 123, '2015-02-01 00:52:17.000000', 'consum', 0.0226, 'lps'),
	(381833, 123, '2015-02-01 00:52:18.000000', 'consum', 0.0213, 'lps'),
	(381834, 123, '2015-02-01 00:52:19.000000', 'consum', 0.0213, 'lps'),
	(381835, 123, '2015-02-01 00:52:20.000000', 'consum', 0.0215, 'lps'),
	(381836, 123, '2015-02-01 00:52:21.000000', 'consum', 0.0226, 'lps'),
	(381837, 123, '2015-02-01 00:52:22.000000', 'consum', 0.0226, 'lps'),
	(381838, 123, '2015-02-01 00:52:23.000000', 'consum', 0.0226, 'lps'),
	(381839, 123, '2015-02-01 00:52:24.000000', 'consum', 0.0223, 'lps'),
	(381840, 123, '2015-02-01 00:52:25.000000', 'consum', 0.0212, 'lps'),
	(381841, 123, '2015-02-01 00:52:26.000000', 'consum', 0.0213, 'lps'),
	(381842, 123, '2015-02-01 00:52:27.000000', 'consum', 0.0223, 'lps'),
	(381843, 123, '2015-02-01 00:52:28.000000', 'consum', 0.0214, 'lps'),
	(381844, 123, '2015-02-01 00:52:29.000000', 'consum', 0.0210, 'lps'),
	(381845, 123, '2015-02-01 00:52:30.000000', 'consum', 0.0215, 'lps'),
	(381846, 123, '2015-02-01 00:52:31.000000', 'consum', 0.0219, 'lps'),
	(381847, 123, '2015-02-01 00:52:32.000000', 'consum', 0.0221, 'lps'),
	(381848, 123, '2015-02-01 00:52:33.000000', 'consum', 0.0222, 'lps'),
	(381849, 123, '2015-02-01 00:52:34.000000', 'consum', 0.0223, 'lps'),
	(381850, 123, '2015-02-01 00:52:35.000000', 'consum', 0.0220, 'lps'),
	(381851, 123, '2015-02-01 00:52:36.000000', 'consum', 0.0220, 'lps'),
	(381852, 123, '2015-02-01 00:52:37.000000', 'consum', 0.0217, 'lps'),
	(381853, 123, '2015-02-01 00:52:38.000000', 'consum', 0.0215, 'lps'),
	(381854, 123, '2015-02-01 00:52:39.000000', 'consum', 0.0212, 'lps'),
	(381855, 123, '2015-02-01 00:52:40.000000', 'consum', 0.0225, 'lps'),
	(381856, 123, '2015-02-01 00:52:41.000000', 'consum', 0.0212, 'lps'),
	(381857, 123, '2015-02-01 00:52:42.000000', 'consum', 0.0210, 'lps'),
	(381858, 123, '2015-02-01 00:52:43.000000', 'consum', 0.0222, 'lps'),
	(381859, 123, '2015-02-01 00:52:44.000000', 'consum', 0.0219, 'lps'),
	(381860, 123, '2015-02-01 00:52:45.000000', 'consum', 0.0220, 'lps'),
	(381861, 123, '2015-02-01 00:52:46.000000', 'consum', 0.0217, 'lps'),
	(381862, 123, '2015-02-01 00:52:47.000000', 'consum', 0.0216, 'lps'),
	(381863, 123, '2015-02-01 00:52:48.000000', 'consum', 0.0218, 'lps'),
	(381864, 123, '2015-02-01 00:52:49.000000', 'consum', 0.0217, 'lps'),
	(381865, 123, '2015-02-01 00:52:50.000000', 'consum', 0.0220, 'lps'),
	(381866, 123, '2015-02-01 00:52:51.000000', 'consum', 0.0221, 'lps'),
	(381867, 123, '2015-02-01 00:52:52.000000', 'consum', 0.0222, 'lps'),
	(381868, 123, '2015-02-01 00:52:53.000000', 'consum', 0.0219, 'lps'),
	(381869, 123, '2015-02-01 00:52:54.000000', 'consum', 0.0220, 'lps'),
	(381870, 123, '2015-02-01 00:52:55.000000', 'consum', 0.0217, 'lps'),
	(381871, 123, '2015-02-01 00:52:56.000000', 'consum', 0.0213, 'lps'),
	(381872, 123, '2015-02-01 00:52:57.000000', 'consum', 0.0222, 'lps'),
	(381873, 123, '2015-02-01 00:52:58.000000', 'consum', 0.0211, 'lps'),
	(381874, 123, '2015-02-01 00:52:59.000000', 'consum', 0.0213, 'lps'),
	(381875, 123, '2015-02-01 00:53:00.000000', 'consum', 0.0225, 'lps'),
	(381876, 123, '2015-02-01 00:53:01.000000', 'consum', 0.0224, 'lps'),
	(381877, 123, '2015-02-01 00:53:02.000000', 'consum', 0.0218, 'lps'),
	(381878, 123, '2015-02-01 00:53:03.000000', 'consum', 0.0225, 'lps'),
	(381879, 123, '2015-02-01 00:53:04.000000', 'consum', 0.0213, 'lps'),
	(381880, 123, '2015-02-01 00:53:05.000000', 'consum', 0.0213, 'lps'),
	(381881, 123, '2015-02-01 00:53:06.000000', 'consum', 0.0217, 'lps'),
	(381882, 123, '2015-02-01 00:53:07.000000', 'consum', 0.0217, 'lps'),
	(381883, 123, '2015-02-01 00:53:08.000000', 'consum', 0.0210, 'lps'),
	(381884, 123, '2015-02-01 00:53:09.000000', 'consum', 0.0224, 'lps'),
	(381885, 123, '2015-02-01 00:53:10.000000', 'consum', 0.0213, 'lps'),
	(381886, 123, '2015-02-01 00:53:11.000000', 'consum', 0.0215, 'lps'),
	(381887, 123, '2015-02-01 00:53:12.000000', 'consum', 0.0226, 'lps'),
	(381888, 123, '2015-02-01 00:53:13.000000', 'consum', 0.0210, 'lps'),
	(381889, 123, '2015-02-01 00:53:14.000000', 'consum', 0.0213, 'lps'),
	(381890, 123, '2015-02-01 00:53:15.000000', 'consum', 0.0226, 'lps'),
	(381891, 123, '2015-02-01 00:53:16.000000', 'consum', 0.0212, 'lps'),
	(381892, 123, '2015-02-01 00:53:17.000000', 'consum', 0.0226, 'lps'),
	(381893, 123, '2015-02-01 00:53:18.000000', 'consum', 0.0215, 'lps'),
	(381894, 123, '2015-02-01 00:53:19.000000', 'consum', 0.0221, 'lps'),
	(381895, 123, '2015-02-01 00:53:20.000000', 'consum', 0.0218, 'lps'),
	(381896, 123, '2015-02-01 00:53:21.000000', 'consum', 0.0219, 'lps'),
	(381897, 123, '2015-02-01 00:53:22.000000', 'consum', 0.0211, 'lps'),
	(381898, 123, '2015-02-01 00:53:23.000000', 'consum', 0.0226, 'lps'),
	(381899, 123, '2015-02-01 00:53:24.000000', 'consum', 0.0216, 'lps'),
	(381900, 123, '2015-02-01 00:53:25.000000', 'consum', 0.0211, 'lps'),
	(381901, 123, '2015-02-01 00:53:26.000000', 'consum', 0.0215, 'lps'),
	(381902, 123, '2015-02-01 00:53:27.000000', 'consum', 0.0213, 'lps'),
	(381903, 123, '2015-02-01 00:53:28.000000', 'consum', 0.0213, 'lps'),
	(381904, 123, '2015-02-01 00:53:29.000000', 'consum', 0.0215, 'lps'),
	(381905, 123, '2015-02-01 00:53:30.000000', 'consum', 0.0226, 'lps'),
	(381906, 123, '2015-02-01 00:53:31.000000', 'consum', 0.0223, 'lps'),
	(381907, 123, '2015-02-01 00:53:32.000000', 'consum', 0.0214, 'lps'),
	(381908, 123, '2015-02-01 00:53:33.000000', 'consum', 0.0225, 'lps'),
	(381909, 123, '2015-02-01 00:53:34.000000', 'consum', 0.0222, 'lps'),
	(381910, 123, '2015-02-01 00:53:35.000000', 'consum', 0.0225, 'lps'),
	(381911, 123, '2015-02-01 00:53:36.000000', 'consum', 0.0217, 'lps'),
	(381912, 123, '2015-02-01 00:53:37.000000', 'consum', 0.0217, 'lps'),
	(381913, 123, '2015-02-01 00:53:38.000000', 'consum', 0.0225, 'lps'),
	(381914, 123, '2015-02-01 00:53:39.000000', 'consum', 0.0213, 'lps'),
	(381915, 123, '2015-02-01 00:53:40.000000', 'consum', 0.0215, 'lps'),
	(381916, 123, '2015-02-01 00:53:41.000000', 'consum', 0.0210, 'lps'),
	(381917, 123, '2015-02-01 00:53:42.000000', 'consum', 0.0212, 'lps'),
	(381918, 123, '2015-02-01 00:53:43.000000', 'consum', 0.0219, 'lps'),
	(381919, 123, '2015-02-01 00:53:44.000000', 'consum', 0.0215, 'lps'),
	(381920, 123, '2015-02-01 00:53:45.000000', 'consum', 0.0210, 'lps'),
	(381921, 123, '2015-02-01 00:53:46.000000', 'consum', 0.0210, 'lps'),
	(381922, 123, '2015-02-01 00:53:47.000000', 'consum', 0.0213, 'lps'),
	(381923, 123, '2015-02-01 00:53:48.000000', 'consum', 0.0224, 'lps'),
	(381924, 123, '2015-02-01 00:53:49.000000', 'consum', 0.0220, 'lps'),
	(381925, 123, '2015-02-01 00:53:50.000000', 'consum', 0.0220, 'lps'),
	(381926, 123, '2015-02-01 00:53:51.000000', 'consum', 0.0211, 'lps'),
	(381927, 123, '2015-02-01 00:53:52.000000', 'consum', 0.0222, 'lps'),
	(381928, 123, '2015-02-01 00:53:53.000000', 'consum', 0.0218, 'lps'),
	(381929, 123, '2015-02-01 00:53:54.000000', 'consum', 0.0212, 'lps'),
	(381930, 123, '2015-02-01 00:53:55.000000', 'consum', 0.0216, 'lps'),
	(381931, 123, '2015-02-01 00:53:56.000000', 'consum', 0.0214, 'lps'),
	(381932, 123, '2015-02-01 00:53:57.000000', 'consum', 0.0215, 'lps'),
	(381933, 123, '2015-02-01 00:53:58.000000', 'consum', 0.0224, 'lps'),
	(381934, 123, '2015-02-01 00:53:59.000000', 'consum', 0.0214, 'lps'),
	(381935, 123, '2015-02-01 00:54:00.000000', 'consum', 0.0223, 'lps'),
	(381936, 123, '2015-02-01 00:54:01.000000', 'consum', 0.0214, 'lps'),
	(381937, 123, '2015-02-01 00:54:02.000000', 'consum', 0.0223, 'lps'),
	(381938, 123, '2015-02-01 00:54:03.000000', 'consum', 0.0211, 'lps'),
	(381939, 123, '2015-02-01 00:54:04.000000', 'consum', 0.0213, 'lps'),
	(381940, 123, '2015-02-01 00:54:05.000000', 'consum', 0.0222, 'lps'),
	(381941, 123, '2015-02-01 00:54:06.000000', 'consum', 0.0226, 'lps'),
	(381942, 123, '2015-02-01 00:54:07.000000', 'consum', 0.0222, 'lps'),
	(381943, 123, '2015-02-01 00:54:08.000000', 'consum', 0.0222, 'lps'),
	(381944, 123, '2015-02-01 00:54:09.000000', 'consum', 0.0219, 'lps'),
	(381945, 123, '2015-02-01 00:54:10.000000', 'consum', 0.0218, 'lps'),
	(381946, 123, '2015-02-01 00:54:11.000000', 'consum', 0.0224, 'lps'),
	(381947, 123, '2015-02-01 00:54:12.000000', 'consum', 0.0222, 'lps'),
	(381948, 123, '2015-02-01 00:54:13.000000', 'consum', 0.0211, 'lps'),
	(381949, 123, '2015-02-01 00:54:14.000000', 'consum', 0.0213, 'lps'),
	(381950, 123, '2015-02-01 00:54:15.000000', 'consum', 0.0223, 'lps'),
	(381951, 123, '2015-02-01 00:54:16.000000', 'consum', 0.0214, 'lps'),
	(381952, 123, '2015-02-01 00:54:17.000000', 'consum', 0.0211, 'lps'),
	(381953, 123, '2015-02-01 00:54:18.000000', 'consum', 0.0220, 'lps'),
	(381954, 123, '2015-02-01 00:54:19.000000', 'consum', 0.0222, 'lps'),
	(381955, 123, '2015-02-01 00:54:20.000000', 'consum', 0.0223, 'lps'),
	(381956, 123, '2015-02-01 00:54:21.000000', 'consum', 0.0222, 'lps'),
	(381957, 123, '2015-02-01 00:54:22.000000', 'consum', 0.0214, 'lps'),
	(381958, 123, '2015-02-01 00:54:23.000000', 'consum', 0.0214, 'lps'),
	(381959, 123, '2015-02-01 00:54:24.000000', 'consum', 0.0219, 'lps'),
	(381960, 123, '2015-02-01 00:54:25.000000', 'consum', 0.0210, 'lps'),
	(381961, 123, '2015-02-01 00:54:26.000000', 'consum', 0.0215, 'lps'),
	(381962, 123, '2015-02-01 00:54:27.000000', 'consum', 0.0219, 'lps'),
	(381963, 123, '2015-02-01 00:54:28.000000', 'consum', 0.0223, 'lps'),
	(381964, 123, '2015-02-01 00:54:29.000000', 'consum', 0.0214, 'lps'),
	(381965, 123, '2015-02-01 00:54:30.000000', 'consum', 0.0225, 'lps'),
	(381966, 123, '2015-02-01 00:54:31.000000', 'consum', 0.0222, 'lps'),
	(381967, 123, '2015-02-01 00:54:32.000000', 'consum', 0.0211, 'lps'),
	(381968, 123, '2015-02-01 00:54:33.000000', 'consum', 0.0212, 'lps'),
	(381969, 123, '2015-02-01 00:54:34.000000', 'consum', 0.0219, 'lps'),
	(381970, 123, '2015-02-01 00:54:35.000000', 'consum', 0.0217, 'lps'),
	(381971, 123, '2015-02-01 00:54:36.000000', 'consum', 0.0216, 'lps'),
	(381972, 123, '2015-02-01 00:54:37.000000', 'consum', 0.0218, 'lps'),
	(381973, 123, '2015-02-01 00:54:38.000000', 'consum', 0.0217, 'lps'),
	(381974, 123, '2015-02-01 00:54:39.000000', 'consum', 0.0221, 'lps'),
	(381975, 123, '2015-02-01 00:54:40.000000', 'consum', 0.0212, 'lps'),
	(381976, 123, '2015-02-01 00:54:41.000000', 'consum', 0.0222, 'lps'),
	(381977, 123, '2015-02-01 00:54:42.000000', 'consum', 0.0213, 'lps'),
	(381978, 123, '2015-02-01 00:54:43.000000', 'consum', 0.0222, 'lps'),
	(381979, 123, '2015-02-01 00:54:44.000000', 'consum', 0.0212, 'lps'),
	(381980, 123, '2015-02-01 00:54:45.000000', 'consum', 0.0216, 'lps'),
	(381981, 123, '2015-02-01 00:54:46.000000', 'consum', 0.0220, 'lps'),
	(381982, 123, '2015-02-01 00:54:47.000000', 'consum', 0.0223, 'lps'),
	(381983, 123, '2015-02-01 00:54:48.000000', 'consum', 0.0213, 'lps'),
	(381984, 123, '2015-02-01 00:54:49.000000', 'consum', 0.0222, 'lps'),
	(381985, 123, '2015-02-01 00:54:50.000000', 'consum', 0.0225, 'lps'),
	(381986, 123, '2015-02-01 00:54:51.000000', 'consum', 0.0217, 'lps'),
	(381987, 123, '2015-02-01 00:54:52.000000', 'consum', 0.0215, 'lps'),
	(381988, 123, '2015-02-01 00:54:53.000000', 'consum', 0.0217, 'lps'),
	(381989, 123, '2015-02-01 00:54:54.000000', 'consum', 0.0214, 'lps'),
	(381990, 123, '2015-02-01 00:54:55.000000', 'consum', 0.0210, 'lps'),
	(381991, 123, '2015-02-01 00:54:56.000000', 'consum', 0.0214, 'lps'),
	(381992, 123, '2015-02-01 00:54:57.000000', 'consum', 0.0213, 'lps'),
	(381993, 123, '2015-02-01 00:54:58.000000', 'consum', 0.0214, 'lps'),
	(381994, 123, '2015-02-01 00:54:59.000000', 'consum', 0.0223, 'lps'),
	(381995, 123, '2015-02-01 00:55:00.000000', 'consum', 0.0210, 'lps'),
	(381996, 123, '2015-02-01 00:55:01.000000', 'consum', 0.0224, 'lps'),
	(381997, 123, '2015-02-01 00:55:02.000000', 'consum', 0.0213, 'lps'),
	(381998, 123, '2015-02-01 00:55:03.000000', 'consum', 0.0218, 'lps'),
	(381999, 123, '2015-02-01 00:55:04.000000', 'consum', 0.0225, 'lps'),
	(382000, 123, '2015-02-01 00:55:05.000000', 'consum', 0.0210, 'lps'),
	(382001, 123, '2015-02-01 00:55:06.000000', 'consum', 0.0215, 'lps'),
	(382002, 123, '2015-02-01 00:55:07.000000', 'consum', 0.0218, 'lps'),
	(382003, 123, '2015-02-01 00:55:08.000000', 'consum', 0.0218, 'lps'),
	(382004, 123, '2015-02-01 00:55:09.000000', 'consum', 0.0211, 'lps'),
	(382005, 123, '2015-02-01 00:55:10.000000', 'consum', 0.0224, 'lps'),
	(382006, 123, '2015-02-01 00:55:11.000000', 'consum', 0.0210, 'lps'),
	(382007, 123, '2015-02-01 00:55:12.000000', 'consum', 0.0218, 'lps'),
	(382008, 123, '2015-02-01 00:55:13.000000', 'consum', 0.0219, 'lps'),
	(382009, 123, '2015-02-01 00:55:14.000000', 'consum', 0.0215, 'lps'),
	(382010, 123, '2015-02-01 00:55:15.000000', 'consum', 0.0223, 'lps'),
	(382011, 123, '2015-02-01 00:55:16.000000', 'consum', 0.0226, 'lps'),
	(382012, 123, '2015-02-01 00:55:17.000000', 'consum', 0.0219, 'lps'),
	(382013, 123, '2015-02-01 00:55:18.000000', 'consum', 0.0223, 'lps'),
	(382014, 123, '2015-02-01 00:55:19.000000', 'consum', 0.0217, 'lps'),
	(382015, 123, '2015-02-01 00:55:20.000000', 'consum', 0.0224, 'lps'),
	(382016, 123, '2015-02-01 00:55:21.000000', 'consum', 0.0225, 'lps'),
	(382017, 123, '2015-02-01 00:55:22.000000', 'consum', 0.0224, 'lps'),
	(382018, 123, '2015-02-01 00:55:23.000000', 'consum', 0.0220, 'lps'),
	(382019, 123, '2015-02-01 00:55:24.000000', 'consum', 0.0219, 'lps'),
	(382020, 123, '2015-02-01 00:55:25.000000', 'consum', 0.0225, 'lps'),
	(382021, 123, '2015-02-01 00:55:26.000000', 'consum', 0.0223, 'lps'),
	(382022, 123, '2015-02-01 00:55:27.000000', 'consum', 0.0216, 'lps'),
	(382023, 123, '2015-02-01 00:55:28.000000', 'consum', 0.0217, 'lps'),
	(382024, 123, '2015-02-01 00:55:29.000000', 'consum', 0.0210, 'lps'),
	(382025, 123, '2015-02-01 00:55:30.000000', 'consum', 0.0222, 'lps'),
	(382026, 123, '2015-02-01 00:55:31.000000', 'consum', 0.0223, 'lps'),
	(382027, 123, '2015-02-01 00:55:32.000000', 'consum', 0.0221, 'lps'),
	(382028, 123, '2015-02-01 00:55:33.000000', 'consum', 0.0226, 'lps'),
	(382029, 123, '2015-02-01 00:55:34.000000', 'consum', 0.0226, 'lps'),
	(382030, 123, '2015-02-01 00:55:35.000000', 'consum', 0.0224, 'lps'),
	(382031, 123, '2015-02-01 00:55:36.000000', 'consum', 0.0215, 'lps'),
	(382032, 123, '2015-02-01 00:55:37.000000', 'consum', 0.0212, 'lps'),
	(382033, 123, '2015-02-01 00:55:38.000000', 'consum', 0.0220, 'lps'),
	(382034, 123, '2015-02-01 00:55:39.000000', 'consum', 0.0220, 'lps'),
	(382035, 123, '2015-02-01 00:55:40.000000', 'consum', 0.0216, 'lps'),
	(382036, 123, '2015-02-01 00:55:41.000000', 'consum', 0.0210, 'lps'),
	(382037, 123, '2015-02-01 00:55:42.000000', 'consum', 0.0211, 'lps'),
	(382038, 123, '2015-02-01 00:55:43.000000', 'consum', 0.0215, 'lps'),
	(382039, 123, '2015-02-01 00:55:44.000000', 'consum', 0.0216, 'lps'),
	(382040, 123, '2015-02-01 00:55:45.000000', 'consum', 0.0226, 'lps'),
	(382041, 123, '2015-02-01 00:55:46.000000', 'consum', 0.0219, 'lps'),
	(382042, 123, '2015-02-01 00:55:47.000000', 'consum', 0.0224, 'lps'),
	(382043, 123, '2015-02-01 00:55:48.000000', 'consum', 0.0222, 'lps'),
	(382044, 123, '2015-02-01 00:55:49.000000', 'consum', 0.0210, 'lps'),
	(382045, 123, '2015-02-01 00:55:50.000000', 'consum', 0.0225, 'lps'),
	(382046, 123, '2015-02-01 00:55:51.000000', 'consum', 0.0218, 'lps'),
	(382047, 123, '2015-02-01 00:55:52.000000', 'consum', 0.0224, 'lps'),
	(382048, 123, '2015-02-01 00:55:53.000000', 'consum', 0.0220, 'lps'),
	(382049, 123, '2015-02-01 00:55:54.000000', 'consum', 0.0218, 'lps'),
	(382050, 123, '2015-02-01 00:55:55.000000', 'consum', 0.0220, 'lps'),
	(382051, 123, '2015-02-01 00:55:56.000000', 'consum', 0.0221, 'lps'),
	(382052, 123, '2015-02-01 00:55:57.000000', 'consum', 0.0219, 'lps'),
	(382053, 123, '2015-02-01 00:55:58.000000', 'consum', 0.0223, 'lps'),
	(382054, 123, '2015-02-01 00:55:59.000000', 'consum', 0.0216, 'lps'),
	(382055, 123, '2015-02-01 00:56:00.000000', 'consum', 0.0216, 'lps'),
	(382056, 123, '2015-02-01 00:56:01.000000', 'consum', 0.0222, 'lps'),
	(382057, 123, '2015-02-01 00:56:02.000000', 'consum', 0.0221, 'lps'),
	(382058, 123, '2015-02-01 00:56:03.000000', 'consum', 0.0226, 'lps'),
	(382059, 123, '2015-02-01 00:56:04.000000', 'consum', 0.0210, 'lps'),
	(382060, 123, '2015-02-01 00:56:05.000000', 'consum', 0.0211, 'lps'),
	(382061, 123, '2015-02-01 00:56:06.000000', 'consum', 0.0216, 'lps'),
	(382062, 123, '2015-02-01 00:56:07.000000', 'consum', 0.0222, 'lps'),
	(382063, 123, '2015-02-01 00:56:08.000000', 'consum', 0.0218, 'lps'),
	(382064, 123, '2015-02-01 00:56:09.000000', 'consum', 0.0212, 'lps'),
	(382065, 123, '2015-02-01 00:56:10.000000', 'consum', 0.0216, 'lps'),
	(382066, 123, '2015-02-01 00:56:11.000000', 'consum', 0.0215, 'lps'),
	(382067, 123, '2015-02-01 00:56:12.000000', 'consum', 0.0220, 'lps'),
	(382068, 123, '2015-02-01 00:56:13.000000', 'consum', 0.0212, 'lps'),
	(382069, 123, '2015-02-01 00:56:14.000000', 'consum', 0.0225, 'lps'),
	(382070, 123, '2015-02-01 00:56:15.000000', 'consum', 0.0211, 'lps'),
	(382071, 123, '2015-02-01 00:56:16.000000', 'consum', 0.0219, 'lps'),
	(382072, 123, '2015-02-01 00:56:17.000000', 'consum', 0.0222, 'lps'),
	(382073, 123, '2015-02-01 00:56:18.000000', 'consum', 0.0223, 'lps'),
	(382074, 123, '2015-02-01 00:56:19.000000', 'consum', 0.0225, 'lps'),
	(382075, 123, '2015-02-01 00:56:20.000000', 'consum', 0.0212, 'lps'),
	(382076, 123, '2015-02-01 00:56:21.000000', 'consum', 0.0224, 'lps'),
	(382077, 123, '2015-02-01 00:56:22.000000', 'consum', 0.0226, 'lps'),
	(382078, 123, '2015-02-01 00:56:23.000000', 'consum', 0.0215, 'lps'),
	(382079, 123, '2015-02-01 00:56:24.000000', 'consum', 0.0221, 'lps'),
	(382080, 123, '2015-02-01 00:56:25.000000', 'consum', 0.0216, 'lps'),
	(382081, 123, '2015-02-01 00:56:26.000000', 'consum', 0.0210, 'lps'),
	(382082, 123, '2015-02-01 00:56:27.000000', 'consum', 0.0224, 'lps'),
	(382083, 123, '2015-02-01 00:56:28.000000', 'consum', 0.0213, 'lps'),
	(382084, 123, '2015-02-01 00:56:29.000000', 'consum', 0.0216, 'lps'),
	(382085, 123, '2015-02-01 00:56:30.000000', 'consum', 0.0215, 'lps'),
	(382086, 123, '2015-02-01 00:56:31.000000', 'consum', 0.0216, 'lps'),
	(382087, 123, '2015-02-01 00:56:32.000000', 'consum', 0.0210, 'lps'),
	(382088, 123, '2015-02-01 00:56:33.000000', 'consum', 0.0210, 'lps'),
	(382089, 123, '2015-02-01 00:56:34.000000', 'consum', 0.0225, 'lps'),
	(382090, 123, '2015-02-01 00:56:35.000000', 'consum', 0.0220, 'lps'),
	(382091, 123, '2015-02-01 00:56:36.000000', 'consum', 0.0215, 'lps'),
	(382092, 123, '2015-02-01 00:56:37.000000', 'consum', 0.0222, 'lps'),
	(382093, 123, '2015-02-01 00:56:38.000000', 'consum', 0.0222, 'lps'),
	(382094, 123, '2015-02-01 00:56:39.000000', 'consum', 0.0216, 'lps'),
	(382095, 123, '2015-02-01 00:56:40.000000', 'consum', 0.0223, 'lps'),
	(382096, 123, '2015-02-01 00:56:41.000000', 'consum', 0.0222, 'lps'),
	(382097, 123, '2015-02-01 00:56:42.000000', 'consum', 0.0214, 'lps'),
	(382098, 123, '2015-02-01 00:56:43.000000', 'consum', 0.0212, 'lps'),
	(382099, 123, '2015-02-01 00:56:44.000000', 'consum', 0.0225, 'lps'),
	(382100, 123, '2015-02-01 00:56:45.000000', 'consum', 0.0213, 'lps'),
	(382101, 123, '2015-02-01 00:56:46.000000', 'consum', 0.0212, 'lps'),
	(382102, 123, '2015-02-01 00:56:47.000000', 'consum', 0.0212, 'lps'),
	(382103, 123, '2015-02-01 00:56:48.000000', 'consum', 0.0214, 'lps'),
	(382104, 123, '2015-02-01 00:56:49.000000', 'consum', 0.0224, 'lps'),
	(382105, 123, '2015-02-01 00:56:50.000000', 'consum', 0.0216, 'lps'),
	(382106, 123, '2015-02-01 00:56:51.000000', 'consum', 0.0219, 'lps'),
	(382107, 123, '2015-02-01 00:56:52.000000', 'consum', 0.0219, 'lps'),
	(382108, 123, '2015-02-01 00:56:53.000000', 'consum', 0.0211, 'lps'),
	(382109, 123, '2015-02-01 00:56:54.000000', 'consum', 0.0223, 'lps'),
	(382110, 123, '2015-02-01 00:56:55.000000', 'consum', 0.0223, 'lps'),
	(382111, 123, '2015-02-01 00:56:56.000000', 'consum', 0.0216, 'lps'),
	(382112, 123, '2015-02-01 00:56:57.000000', 'consum', 0.0222, 'lps'),
	(382113, 123, '2015-02-01 00:56:58.000000', 'consum', 0.0217, 'lps'),
	(382114, 123, '2015-02-01 00:56:59.000000', 'consum', 0.0225, 'lps'),
	(382115, 123, '2015-02-01 00:57:00.000000', 'consum', 0.0215, 'lps'),
	(382116, 123, '2015-02-01 00:57:01.000000', 'consum', 0.0225, 'lps'),
	(382117, 123, '2015-02-01 00:57:02.000000', 'consum', 0.0220, 'lps'),
	(382118, 123, '2015-02-01 00:57:03.000000', 'consum', 0.0215, 'lps'),
	(382119, 123, '2015-02-01 00:57:04.000000', 'consum', 0.0222, 'lps'),
	(382120, 123, '2015-02-01 00:57:05.000000', 'consum', 0.0221, 'lps'),
	(382121, 123, '2015-02-01 00:57:06.000000', 'consum', 0.0214, 'lps'),
	(382122, 123, '2015-02-01 00:57:07.000000', 'consum', 0.0216, 'lps'),
	(382123, 123, '2015-02-01 00:57:08.000000', 'consum', 0.0226, 'lps'),
	(382124, 123, '2015-02-01 00:57:09.000000', 'consum', 0.0222, 'lps'),
	(382125, 123, '2015-02-01 00:57:10.000000', 'consum', 0.0221, 'lps'),
	(382126, 123, '2015-02-01 00:57:11.000000', 'consum', 0.0214, 'lps'),
	(382127, 123, '2015-02-01 00:57:12.000000', 'consum', 0.0213, 'lps'),
	(382128, 123, '2015-02-01 00:57:13.000000', 'consum', 0.0214, 'lps'),
	(382129, 123, '2015-02-01 00:57:14.000000', 'consum', 0.0222, 'lps'),
	(382130, 123, '2015-02-01 00:57:15.000000', 'consum', 0.0226, 'lps'),
	(382131, 123, '2015-02-01 00:57:16.000000', 'consum', 0.0221, 'lps'),
	(382132, 123, '2015-02-01 00:57:17.000000', 'consum', 0.0217, 'lps'),
	(382133, 123, '2015-02-01 00:57:18.000000', 'consum', 0.0213, 'lps'),
	(382134, 123, '2015-02-01 00:57:19.000000', 'consum', 0.0219, 'lps'),
	(382135, 123, '2015-02-01 00:57:20.000000', 'consum', 0.0213, 'lps'),
	(382136, 123, '2015-02-01 00:57:21.000000', 'consum', 0.0216, 'lps'),
	(382137, 123, '2015-02-01 00:57:22.000000', 'consum', 0.0215, 'lps'),
	(382138, 123, '2015-02-01 00:57:23.000000', 'consum', 0.0217, 'lps'),
	(382139, 123, '2015-02-01 00:57:24.000000', 'consum', 0.0214, 'lps'),
	(382140, 123, '2015-02-01 00:57:25.000000', 'consum', 0.0225, 'lps'),
	(382141, 123, '2015-02-01 00:57:26.000000', 'consum', 0.0222, 'lps'),
	(382142, 123, '2015-02-01 00:57:27.000000', 'consum', 0.0226, 'lps'),
	(382143, 123, '2015-02-01 00:57:28.000000', 'consum', 0.0220, 'lps'),
	(382144, 123, '2015-02-01 00:57:29.000000', 'consum', 0.0212, 'lps'),
	(382145, 123, '2015-02-01 00:57:30.000000', 'consum', 0.0223, 'lps'),
	(382146, 123, '2015-02-01 00:57:31.000000', 'consum', 0.0222, 'lps'),
	(382147, 123, '2015-02-01 00:57:32.000000', 'consum', 0.0211, 'lps'),
	(382148, 123, '2015-02-01 00:57:33.000000', 'consum', 0.0215, 'lps'),
	(382149, 123, '2015-02-01 00:57:34.000000', 'consum', 0.0216, 'lps'),
	(382150, 123, '2015-02-01 00:57:35.000000', 'consum', 0.0226, 'lps'),
	(382151, 123, '2015-02-01 00:57:36.000000', 'consum', 0.0220, 'lps'),
	(382152, 123, '2015-02-01 00:57:37.000000', 'consum', 0.0215, 'lps'),
	(382153, 123, '2015-02-01 00:57:38.000000', 'consum', 0.0220, 'lps'),
	(382154, 123, '2015-02-01 00:57:39.000000', 'consum', 0.0213, 'lps'),
	(382155, 123, '2015-02-01 00:57:40.000000', 'consum', 0.0211, 'lps'),
	(382156, 123, '2015-02-01 00:57:41.000000', 'consum', 0.0223, 'lps'),
	(382157, 123, '2015-02-01 00:57:42.000000', 'consum', 0.0224, 'lps'),
	(382158, 123, '2015-02-01 00:57:43.000000', 'consum', 0.0222, 'lps'),
	(382159, 123, '2015-02-01 00:57:44.000000', 'consum', 0.0211, 'lps'),
	(382160, 123, '2015-02-01 00:57:45.000000', 'consum', 0.0214, 'lps'),
	(382161, 123, '2015-02-01 00:57:46.000000', 'consum', 0.0211, 'lps'),
	(382162, 123, '2015-02-01 00:57:47.000000', 'consum', 0.0222, 'lps'),
	(382163, 123, '2015-02-01 00:57:48.000000', 'consum', 0.0217, 'lps'),
	(382164, 123, '2015-02-01 00:57:49.000000', 'consum', 0.0224, 'lps'),
	(382165, 123, '2015-02-01 00:57:50.000000', 'consum', 0.0211, 'lps'),
	(382166, 123, '2015-02-01 00:57:51.000000', 'consum', 0.0224, 'lps'),
	(382167, 123, '2015-02-01 00:57:52.000000', 'consum', 0.0210, 'lps'),
	(382168, 123, '2015-02-01 00:57:53.000000', 'consum', 0.0219, 'lps'),
	(382169, 123, '2015-02-01 00:57:54.000000', 'consum', 0.0223, 'lps'),
	(382170, 123, '2015-02-01 00:57:55.000000', 'consum', 0.0215, 'lps'),
	(382171, 123, '2015-02-01 00:57:56.000000', 'consum', 0.0210, 'lps'),
	(382172, 123, '2015-02-01 00:57:57.000000', 'consum', 0.0215, 'lps'),
	(382173, 123, '2015-02-01 00:57:58.000000', 'consum', 0.0220, 'lps'),
	(382174, 123, '2015-02-01 00:57:59.000000', 'consum', 0.0225, 'lps'),
	(382175, 123, '2015-02-01 00:58:00.000000', 'consum', 0.0225, 'lps'),
	(382176, 123, '2015-02-01 00:58:01.000000', 'consum', 0.0220, 'lps'),
	(382177, 123, '2015-02-01 00:58:02.000000', 'consum', 0.0218, 'lps'),
	(382178, 123, '2015-02-01 00:58:03.000000', 'consum', 0.0219, 'lps'),
	(382179, 123, '2015-02-01 00:58:04.000000', 'consum', 0.0216, 'lps'),
	(382180, 123, '2015-02-01 00:58:05.000000', 'consum', 0.0212, 'lps'),
	(382181, 123, '2015-02-01 00:58:06.000000', 'consum', 0.0222, 'lps'),
	(382182, 123, '2015-02-01 00:58:07.000000', 'consum', 0.0213, 'lps'),
	(382183, 123, '2015-02-01 00:58:08.000000', 'consum', 0.0222, 'lps'),
	(382184, 123, '2015-02-01 00:58:09.000000', 'consum', 0.0226, 'lps'),
	(382185, 123, '2015-02-01 00:58:10.000000', 'consum', 0.0222, 'lps'),
	(382186, 123, '2015-02-01 00:58:11.000000', 'consum', 0.0223, 'lps'),
	(382187, 123, '2015-02-01 00:58:12.000000', 'consum', 0.0224, 'lps'),
	(382188, 123, '2015-02-01 00:58:13.000000', 'consum', 0.0224, 'lps'),
	(382189, 123, '2015-02-01 00:58:14.000000', 'consum', 0.0222, 'lps'),
	(382190, 123, '2015-02-01 00:58:15.000000', 'consum', 0.0211, 'lps'),
	(382191, 123, '2015-02-01 00:58:16.000000', 'consum', 0.0214, 'lps'),
	(382192, 123, '2015-02-01 00:58:17.000000', 'consum', 0.0211, 'lps'),
	(382193, 123, '2015-02-01 00:58:18.000000', 'consum', 0.0221, 'lps'),
	(382194, 123, '2015-02-01 00:58:19.000000', 'consum', 0.0211, 'lps'),
	(382195, 123, '2015-02-01 00:58:20.000000', 'consum', 0.0215, 'lps'),
	(382196, 123, '2015-02-01 00:58:21.000000', 'consum', 0.0216, 'lps'),
	(382197, 123, '2015-02-01 00:58:22.000000', 'consum', 0.0211, 'lps'),
	(382198, 123, '2015-02-01 00:58:23.000000', 'consum', 0.0211, 'lps'),
	(382199, 123, '2015-02-01 00:58:24.000000', 'consum', 0.0214, 'lps'),
	(382200, 123, '2015-02-01 00:58:25.000000', 'consum', 0.0213, 'lps'),
	(382201, 123, '2015-02-01 00:58:26.000000', 'consum', 0.0210, 'lps'),
	(382202, 123, '2015-02-01 00:58:27.000000', 'consum', 0.0218, 'lps'),
	(382203, 124, '2015-02-01 00:00:00.000000', 'consum', 0.0224, 'lps'),
	(382204, 124, '2015-02-01 00:00:01.000000', 'consum', 0.0224, 'lps'),
	(382205, 124, '2015-02-01 00:00:02.000000', 'consum', 0.0217, 'lps'),
	(382206, 124, '2015-02-01 00:00:03.000000', 'consum', 0.0226, 'lps'),
	(382207, 124, '2015-02-01 00:00:04.000000', 'consum', 0.0227, 'lps'),
	(382208, 124, '2015-02-01 00:00:05.000000', 'consum', 0.0225, 'lps'),
	(382209, 124, '2015-02-01 00:00:06.000000', 'consum', 0.0214, 'lps'),
	(382210, 124, '2015-02-01 00:00:07.000000', 'consum', 0.0226, 'lps'),
	(382211, 124, '2015-02-01 00:00:08.000000', 'consum', 0.0215, 'lps'),
	(382212, 124, '2015-02-01 00:00:09.000000', 'consum', 0.0212, 'lps'),
	(382213, 124, '2015-02-01 00:00:10.000000', 'consum', 0.0223, 'lps'),
	(382214, 124, '2015-02-01 00:00:11.000000', 'consum', 0.0230, 'lps'),
	(382215, 124, '2015-02-01 00:00:12.000000', 'consum', 0.0228, 'lps'),
	(382216, 124, '2015-02-01 00:00:13.000000', 'consum', 0.0222, 'lps'),
	(382217, 124, '2015-02-01 00:00:14.000000', 'consum', 0.0214, 'lps'),
	(382218, 124, '2015-02-01 00:00:15.000000', 'consum', 0.0216, 'lps'),
	(382219, 124, '2015-02-01 00:00:16.000000', 'consum', 0.0228, 'lps'),
	(382220, 124, '2015-02-01 00:00:17.000000', 'consum', 0.0221, 'lps'),
	(382221, 124, '2015-02-01 00:00:18.000000', 'consum', 0.0211, 'lps'),
	(382222, 124, '2015-02-01 00:00:19.000000', 'consum', 0.0225, 'lps'),
	(382223, 124, '2015-02-01 00:00:20.000000', 'consum', 0.0218, 'lps'),
	(382224, 124, '2015-02-01 00:00:21.000000', 'consum', 0.0226, 'lps'),
	(382225, 124, '2015-02-01 00:00:22.000000', 'consum', 0.0225, 'lps'),
	(382226, 124, '2015-02-01 00:00:23.000000', 'consum', 0.0216, 'lps'),
	(382227, 124, '2015-02-01 00:00:24.000000', 'consum', 0.0217, 'lps'),
	(382228, 124, '2015-02-01 00:00:25.000000', 'consum', 0.0229, 'lps'),
	(382229, 124, '2015-02-01 00:00:26.000000', 'consum', 0.0219, 'lps'),
	(382230, 124, '2015-02-01 00:00:27.000000', 'consum', 0.0219, 'lps'),
	(382231, 124, '2015-02-01 00:00:28.000000', 'consum', 0.0210, 'lps'),
	(382232, 124, '2015-02-01 00:00:29.000000', 'consum', 0.0225, 'lps'),
	(382233, 124, '2015-02-01 00:00:30.000000', 'consum', 0.0222, 'lps'),
	(382234, 124, '2015-02-01 00:00:31.000000', 'consum', 0.0224, 'lps'),
	(382235, 124, '2015-02-01 00:00:32.000000', 'consum', 0.0223, 'lps'),
	(382236, 124, '2015-02-01 00:00:33.000000', 'consum', 0.0214, 'lps'),
	(382237, 124, '2015-02-01 00:00:34.000000', 'consum', 0.0212, 'lps'),
	(382238, 124, '2015-02-01 00:00:35.000000', 'consum', 0.0229, 'lps'),
	(382239, 124, '2015-02-01 00:00:36.000000', 'consum', 0.0218, 'lps'),
	(382240, 124, '2015-02-01 00:00:37.000000', 'consum', 0.0212, 'lps'),
	(382241, 124, '2015-02-01 00:00:38.000000', 'consum', 0.0217, 'lps'),
	(382242, 124, '2015-02-01 00:00:39.000000', 'consum', 0.0218, 'lps'),
	(382243, 124, '2015-02-01 00:00:40.000000', 'consum', 0.0230, 'lps'),
	(382244, 124, '2015-02-01 00:00:41.000000', 'consum', 0.0225, 'lps'),
	(382245, 124, '2015-02-01 00:00:42.000000', 'consum', 0.0226, 'lps'),
	(382246, 124, '2015-02-01 00:00:43.000000', 'consum', 0.0223, 'lps'),
	(382247, 124, '2015-02-01 00:00:44.000000', 'consum', 0.0227, 'lps'),
	(382248, 124, '2015-02-01 00:00:45.000000', 'consum', 0.0216, 'lps'),
	(382249, 124, '2015-02-01 00:00:46.000000', 'consum', 0.0210, 'lps'),
	(382250, 124, '2015-02-01 00:00:47.000000', 'consum', 0.0214, 'lps'),
	(382251, 124, '2015-02-01 00:00:48.000000', 'consum', 0.0229, 'lps'),
	(382252, 124, '2015-02-01 00:00:49.000000', 'consum', 0.0230, 'lps'),
	(382253, 124, '2015-02-01 00:00:50.000000', 'consum', 0.0210, 'lps'),
	(382254, 124, '2015-02-01 00:00:51.000000', 'consum', 0.0217, 'lps'),
	(382255, 124, '2015-02-01 00:00:52.000000', 'consum', 0.0221, 'lps'),
	(382256, 124, '2015-02-01 00:00:53.000000', 'consum', 0.0226, 'lps'),
	(382257, 124, '2015-02-01 00:00:54.000000', 'consum', 0.0217, 'lps'),
	(382258, 124, '2015-02-01 00:00:55.000000', 'consum', 0.0216, 'lps'),
	(382259, 124, '2015-02-01 00:00:56.000000', 'consum', 0.0222, 'lps'),
	(382260, 124, '2015-02-01 00:00:57.000000', 'consum', 0.0228, 'lps'),
	(382261, 124, '2015-02-01 00:00:58.000000', 'consum', 0.0225, 'lps'),
	(382262, 124, '2015-02-01 00:00:59.000000', 'consum', 0.0230, 'lps'),
	(382263, 124, '2015-02-01 00:01:00.000000', 'consum', 0.0224, 'lps'),
	(382264, 124, '2015-02-01 00:01:01.000000', 'consum', 0.0220, 'lps'),
	(382265, 124, '2015-02-01 00:01:02.000000', 'consum', 0.0219, 'lps'),
	(382266, 124, '2015-02-01 00:01:03.000000', 'consum', 0.0226, 'lps'),
	(382267, 124, '2015-02-01 00:01:04.000000', 'consum', 0.0223, 'lps'),
	(382268, 124, '2015-02-01 00:01:05.000000', 'consum', 0.0226, 'lps'),
	(382269, 124, '2015-02-01 00:01:06.000000', 'consum', 0.0230, 'lps'),
	(382270, 124, '2015-02-01 00:01:07.000000', 'consum', 0.0223, 'lps'),
	(382271, 124, '2015-02-01 00:01:08.000000', 'consum', 0.0214, 'lps'),
	(382272, 124, '2015-02-01 00:01:09.000000', 'consum', 0.0214, 'lps'),
	(382273, 124, '2015-02-01 00:01:10.000000', 'consum', 0.0217, 'lps'),
	(382274, 124, '2015-02-01 00:01:11.000000', 'consum', 0.0211, 'lps'),
	(382275, 124, '2015-02-01 00:01:12.000000', 'consum', 0.0217, 'lps'),
	(382276, 124, '2015-02-01 00:01:13.000000', 'consum', 0.0221, 'lps'),
	(382277, 124, '2015-02-01 00:01:14.000000', 'consum', 0.0225, 'lps'),
	(382278, 124, '2015-02-01 00:01:15.000000', 'consum', 0.0230, 'lps'),
	(382279, 124, '2015-02-01 00:01:16.000000', 'consum', 0.0224, 'lps'),
	(382280, 124, '2015-02-01 00:01:17.000000', 'consum', 0.0222, 'lps'),
	(382281, 124, '2015-02-01 00:01:18.000000', 'consum', 0.0226, 'lps'),
	(382282, 124, '2015-02-01 00:01:19.000000', 'consum', 0.0212, 'lps'),
	(382283, 124, '2015-02-01 00:01:20.000000', 'consum', 0.0215, 'lps'),
	(382284, 124, '2015-02-01 00:01:21.000000', 'consum', 0.0210, 'lps'),
	(382285, 124, '2015-02-01 00:01:22.000000', 'consum', 0.0217, 'lps'),
	(382286, 124, '2015-02-01 00:01:23.000000', 'consum', 0.0223, 'lps'),
	(382287, 124, '2015-02-01 00:01:24.000000', 'consum', 0.0213, 'lps'),
	(382288, 124, '2015-02-01 00:01:25.000000', 'consum', 0.0227, 'lps'),
	(382289, 124, '2015-02-01 00:01:26.000000', 'consum', 0.0223, 'lps'),
	(382290, 124, '2015-02-01 00:01:27.000000', 'consum', 0.0225, 'lps'),
	(382291, 124, '2015-02-01 00:01:28.000000', 'consum', 0.0224, 'lps'),
	(382292, 124, '2015-02-01 00:01:29.000000', 'consum', 0.0216, 'lps'),
	(382293, 124, '2015-02-01 00:01:30.000000', 'consum', 0.0218, 'lps'),
	(382294, 124, '2015-02-01 00:01:31.000000', 'consum', 0.0212, 'lps'),
	(382295, 124, '2015-02-01 00:01:32.000000', 'consum', 0.0217, 'lps'),
	(382296, 124, '2015-02-01 00:01:33.000000', 'consum', 0.0217, 'lps'),
	(382297, 124, '2015-02-01 00:01:34.000000', 'consum', 0.0226, 'lps'),
	(382298, 124, '2015-02-01 00:01:35.000000', 'consum', 0.0228, 'lps'),
	(382299, 124, '2015-02-01 00:01:36.000000', 'consum', 0.0230, 'lps'),
	(382300, 124, '2015-02-01 00:01:37.000000', 'consum', 0.0217, 'lps'),
	(382301, 124, '2015-02-01 00:01:38.000000', 'consum', 0.0226, 'lps'),
	(382302, 124, '2015-02-01 00:01:39.000000', 'consum', 0.0227, 'lps'),
	(382303, 124, '2015-02-01 00:01:40.000000', 'consum', 0.0226, 'lps'),
	(382304, 124, '2015-02-01 00:01:41.000000', 'consum', 0.0218, 'lps'),
	(382305, 124, '2015-02-01 00:01:42.000000', 'consum', 0.0225, 'lps'),
	(382306, 124, '2015-02-01 00:01:43.000000', 'consum', 0.0218, 'lps'),
	(382307, 124, '2015-02-01 00:01:44.000000', 'consum', 0.0226, 'lps'),
	(382308, 124, '2015-02-01 00:01:45.000000', 'consum', 0.0226, 'lps'),
	(382309, 124, '2015-02-01 00:01:46.000000', 'consum', 0.0220, 'lps'),
	(382310, 124, '2015-02-01 00:01:47.000000', 'consum', 0.0211, 'lps'),
	(382311, 124, '2015-02-01 00:01:48.000000', 'consum', 0.0230, 'lps'),
	(382312, 124, '2015-02-01 00:01:49.000000', 'consum', 0.0221, 'lps'),
	(382313, 124, '2015-02-01 00:01:50.000000', 'consum', 0.0228, 'lps'),
	(382314, 124, '2015-02-01 00:01:51.000000', 'consum', 0.0227, 'lps'),
	(382315, 124, '2015-02-01 00:01:52.000000', 'consum', 0.0218, 'lps'),
	(382316, 124, '2015-02-01 00:01:53.000000', 'consum', 0.0220, 'lps'),
	(382317, 124, '2015-02-01 00:01:54.000000', 'consum', 0.0216, 'lps'),
	(382318, 124, '2015-02-01 00:01:55.000000', 'consum', 0.0210, 'lps'),
	(382319, 124, '2015-02-01 00:01:56.000000', 'consum', 0.0216, 'lps'),
	(382320, 124, '2015-02-01 00:01:57.000000', 'consum', 0.0217, 'lps'),
	(382321, 124, '2015-02-01 00:01:58.000000', 'consum', 0.0228, 'lps'),
	(382322, 124, '2015-02-01 00:01:59.000000', 'consum', 0.0218, 'lps'),
	(382323, 124, '2015-02-01 00:02:00.000000', 'consum', 0.0217, 'lps'),
	(382324, 124, '2015-02-01 00:02:01.000000', 'consum', 0.0222, 'lps'),
	(382325, 124, '2015-02-01 00:02:02.000000', 'consum', 0.0226, 'lps'),
	(382326, 124, '2015-02-01 00:02:03.000000', 'consum', 0.0215, 'lps'),
	(382327, 124, '2015-02-01 00:02:04.000000', 'consum', 0.0228, 'lps'),
	(382328, 124, '2015-02-01 00:02:05.000000', 'consum', 0.0223, 'lps'),
	(382329, 124, '2015-02-01 00:02:06.000000', 'consum', 0.0221, 'lps'),
	(382330, 124, '2015-02-01 00:02:07.000000', 'consum', 0.0225, 'lps'),
	(382331, 124, '2015-02-01 00:02:08.000000', 'consum', 0.0210, 'lps'),
	(382332, 124, '2015-02-01 00:02:09.000000', 'consum', 0.0211, 'lps'),
	(382333, 124, '2015-02-01 00:02:10.000000', 'consum', 0.0213, 'lps'),
	(382334, 124, '2015-02-01 00:02:11.000000', 'consum', 0.0224, 'lps'),
	(382335, 124, '2015-02-01 00:02:12.000000', 'consum', 0.0229, 'lps'),
	(382336, 124, '2015-02-01 00:02:13.000000', 'consum', 0.0223, 'lps'),
	(382337, 124, '2015-02-01 00:02:14.000000', 'consum', 0.0217, 'lps'),
	(382338, 124, '2015-02-01 00:02:15.000000', 'consum', 0.0228, 'lps'),
	(382339, 124, '2015-02-01 00:02:16.000000', 'consum', 0.0217, 'lps'),
	(382340, 124, '2015-02-01 00:02:17.000000', 'consum', 0.0212, 'lps'),
	(382341, 124, '2015-02-01 00:02:18.000000', 'consum', 0.0221, 'lps'),
	(382342, 124, '2015-02-01 00:02:19.000000', 'consum', 0.0219, 'lps'),
	(382343, 124, '2015-02-01 00:02:20.000000', 'consum', 0.0221, 'lps'),
	(382344, 124, '2015-02-01 00:02:21.000000', 'consum', 0.0219, 'lps'),
	(382345, 124, '2015-02-01 00:02:22.000000', 'consum', 0.0220, 'lps'),
	(382346, 124, '2015-02-01 00:02:23.000000', 'consum', 0.0214, 'lps'),
	(382347, 124, '2015-02-01 00:02:24.000000', 'consum', 0.0220, 'lps'),
	(382348, 124, '2015-02-01 00:02:25.000000', 'consum', 0.0229, 'lps'),
	(382349, 124, '2015-02-01 00:02:26.000000', 'consum', 0.0214, 'lps'),
	(382350, 124, '2015-02-01 00:02:27.000000', 'consum', 0.0212, 'lps'),
	(382351, 124, '2015-02-01 00:02:28.000000', 'consum', 0.0212, 'lps'),
	(382352, 124, '2015-02-01 00:02:29.000000', 'consum', 0.0213, 'lps'),
	(382353, 124, '2015-02-01 00:02:30.000000', 'consum', 0.0219, 'lps'),
	(382354, 124, '2015-02-01 00:02:31.000000', 'consum', 0.0225, 'lps'),
	(382355, 124, '2015-02-01 00:02:32.000000', 'consum', 0.0218, 'lps'),
	(382356, 124, '2015-02-01 00:02:33.000000', 'consum', 0.0227, 'lps'),
	(382357, 124, '2015-02-01 00:02:34.000000', 'consum', 0.0227, 'lps'),
	(382358, 124, '2015-02-01 00:02:35.000000', 'consum', 0.0227, 'lps'),
	(382359, 124, '2015-02-01 00:02:36.000000', 'consum', 0.0221, 'lps'),
	(382360, 124, '2015-02-01 00:02:37.000000', 'consum', 0.0215, 'lps'),
	(382361, 124, '2015-02-01 00:02:38.000000', 'consum', 0.0223, 'lps'),
	(382362, 124, '2015-02-01 00:02:39.000000', 'consum', 0.0220, 'lps'),
	(382363, 124, '2015-02-01 00:02:40.000000', 'consum', 0.0219, 'lps'),
	(382364, 124, '2015-02-01 00:02:41.000000', 'consum', 0.0228, 'lps'),
	(382365, 124, '2015-02-01 00:02:42.000000', 'consum', 0.0230, 'lps'),
	(382366, 124, '2015-02-01 00:02:43.000000', 'consum', 0.0216, 'lps'),
	(382367, 124, '2015-02-01 00:02:44.000000', 'consum', 0.0222, 'lps'),
	(382368, 124, '2015-02-01 00:02:45.000000', 'consum', 0.0212, 'lps'),
	(382369, 124, '2015-02-01 00:02:46.000000', 'consum', 0.0225, 'lps'),
	(382370, 124, '2015-02-01 00:02:47.000000', 'consum', 0.0219, 'lps'),
	(382371, 124, '2015-02-01 00:02:48.000000', 'consum', 0.0228, 'lps'),
	(382372, 124, '2015-02-01 00:02:49.000000', 'consum', 0.0212, 'lps'),
	(382373, 124, '2015-02-01 00:02:50.000000', 'consum', 0.0210, 'lps'),
	(382374, 124, '2015-02-01 00:02:51.000000', 'consum', 0.0222, 'lps'),
	(382375, 124, '2015-02-01 00:02:52.000000', 'consum', 0.0211, 'lps'),
	(382376, 124, '2015-02-01 00:02:53.000000', 'consum', 0.0218, 'lps'),
	(382377, 124, '2015-02-01 00:02:54.000000', 'consum', 0.0229, 'lps'),
	(382378, 124, '2015-02-01 00:02:55.000000', 'consum', 0.0218, 'lps'),
	(382379, 124, '2015-02-01 00:02:56.000000', 'consum', 0.0216, 'lps'),
	(382380, 124, '2015-02-01 00:02:57.000000', 'consum', 0.0216, 'lps'),
	(382381, 124, '2015-02-01 00:02:58.000000', 'consum', 0.0221, 'lps'),
	(382382, 124, '2015-02-01 00:02:59.000000', 'consum', 0.0227, 'lps'),
	(382383, 124, '2015-02-01 00:03:00.000000', 'consum', 0.0219, 'lps'),
	(382384, 124, '2015-02-01 00:03:01.000000', 'consum', 0.0228, 'lps'),
	(382385, 124, '2015-02-01 00:03:02.000000', 'consum', 0.0211, 'lps'),
	(382386, 124, '2015-02-01 00:03:03.000000', 'consum', 0.0222, 'lps'),
	(382387, 124, '2015-02-01 00:03:04.000000', 'consum', 0.0227, 'lps'),
	(382388, 124, '2015-02-01 00:03:05.000000', 'consum', 0.0216, 'lps'),
	(382389, 124, '2015-02-01 00:03:06.000000', 'consum', 0.0212, 'lps'),
	(382390, 124, '2015-02-01 00:03:07.000000', 'consum', 0.0221, 'lps'),
	(382391, 124, '2015-02-01 00:03:08.000000', 'consum', 0.0219, 'lps'),
	(382392, 124, '2015-02-01 00:03:09.000000', 'consum', 0.0224, 'lps'),
	(382393, 124, '2015-02-01 00:03:10.000000', 'consum', 0.0211, 'lps'),
	(382394, 124, '2015-02-01 00:03:11.000000', 'consum', 0.0213, 'lps'),
	(382395, 124, '2015-02-01 00:03:12.000000', 'consum', 0.0224, 'lps'),
	(382396, 124, '2015-02-01 00:03:13.000000', 'consum', 0.0229, 'lps'),
	(382397, 124, '2015-02-01 00:03:14.000000', 'consum', 0.0223, 'lps'),
	(382398, 124, '2015-02-01 00:03:15.000000', 'consum', 0.0217, 'lps'),
	(382399, 124, '2015-02-01 00:03:16.000000', 'consum', 0.0228, 'lps'),
	(382400, 124, '2015-02-01 00:03:17.000000', 'consum', 0.0216, 'lps'),
	(382401, 124, '2015-02-01 00:03:18.000000', 'consum', 0.0229, 'lps'),
	(382402, 124, '2015-02-01 00:03:19.000000', 'consum', 0.0224, 'lps'),
	(382403, 124, '2015-02-01 00:03:20.000000', 'consum', 0.0222, 'lps'),
	(382404, 124, '2015-02-01 00:03:21.000000', 'consum', 0.0229, 'lps'),
	(382405, 124, '2015-02-01 00:03:22.000000', 'consum', 0.0227, 'lps'),
	(382406, 124, '2015-02-01 00:03:23.000000', 'consum', 0.0219, 'lps'),
	(382407, 124, '2015-02-01 00:03:24.000000', 'consum', 0.0223, 'lps'),
	(382408, 124, '2015-02-01 00:03:25.000000', 'consum', 0.0228, 'lps'),
	(382409, 124, '2015-02-01 00:03:26.000000', 'consum', 0.0222, 'lps'),
	(382410, 124, '2015-02-01 00:03:27.000000', 'consum', 0.0214, 'lps'),
	(382411, 124, '2015-02-01 00:03:28.000000', 'consum', 0.0216, 'lps'),
	(382412, 124, '2015-02-01 00:03:29.000000', 'consum', 0.0230, 'lps'),
	(382413, 124, '2015-02-01 00:03:30.000000', 'consum', 0.0227, 'lps'),
	(382414, 124, '2015-02-01 00:03:31.000000', 'consum', 0.0217, 'lps'),
	(382415, 124, '2015-02-01 00:03:32.000000', 'consum', 0.0216, 'lps'),
	(382416, 124, '2015-02-01 00:03:33.000000', 'consum', 0.0218, 'lps'),
	(382417, 124, '2015-02-01 00:03:34.000000', 'consum', 0.0211, 'lps'),
	(382418, 124, '2015-02-01 00:03:35.000000', 'consum', 0.0214, 'lps'),
	(382419, 124, '2015-02-01 00:03:36.000000', 'consum', 0.0225, 'lps'),
	(382420, 124, '2015-02-01 00:03:37.000000', 'consum', 0.0213, 'lps'),
	(382421, 124, '2015-02-01 00:03:38.000000', 'consum', 0.0221, 'lps'),
	(382422, 124, '2015-02-01 00:03:39.000000', 'consum', 0.0217, 'lps'),
	(382423, 124, '2015-02-01 00:03:40.000000', 'consum', 0.0212, 'lps'),
	(382424, 124, '2015-02-01 00:03:41.000000', 'consum', 0.0218, 'lps'),
	(382425, 124, '2015-02-01 00:03:42.000000', 'consum', 0.0224, 'lps'),
	(382426, 124, '2015-02-01 00:03:43.000000', 'consum', 0.0216, 'lps'),
	(382427, 124, '2015-02-01 00:03:44.000000', 'consum', 0.0219, 'lps'),
	(382428, 124, '2015-02-01 00:03:45.000000', 'consum', 0.0218, 'lps'),
	(382429, 124, '2015-02-01 00:03:46.000000', 'consum', 0.0223, 'lps'),
	(382430, 124, '2015-02-01 00:03:47.000000', 'consum', 0.0210, 'lps'),
	(382431, 124, '2015-02-01 00:03:48.000000', 'consum', 0.0215, 'lps'),
	(382432, 124, '2015-02-01 00:03:49.000000', 'consum', 0.0211, 'lps'),
	(382433, 124, '2015-02-01 00:03:50.000000', 'consum', 0.0225, 'lps'),
	(382434, 124, '2015-02-01 00:03:51.000000', 'consum', 0.0217, 'lps'),
	(382435, 124, '2015-02-01 00:03:52.000000', 'consum', 0.0221, 'lps'),
	(382436, 124, '2015-02-01 00:03:53.000000', 'consum', 0.0224, 'lps'),
	(382437, 124, '2015-02-01 00:03:54.000000', 'consum', 0.0227, 'lps'),
	(382438, 124, '2015-02-01 00:03:55.000000', 'consum', 0.0210, 'lps'),
	(382439, 124, '2015-02-01 00:03:56.000000', 'consum', 0.0224, 'lps'),
	(382440, 124, '2015-02-01 00:03:57.000000', 'consum', 0.0218, 'lps'),
	(382441, 124, '2015-02-01 00:03:58.000000', 'consum', 0.0227, 'lps'),
	(382442, 124, '2015-02-01 00:03:59.000000', 'consum', 0.0210, 'lps'),
	(382443, 124, '2015-02-01 00:04:00.000000', 'consum', 0.0221, 'lps'),
	(382444, 124, '2015-02-01 00:04:01.000000', 'consum', 0.0223, 'lps'),
	(382445, 124, '2015-02-01 00:04:02.000000', 'consum', 0.0220, 'lps'),
	(382446, 124, '2015-02-01 00:04:03.000000', 'consum', 0.0225, 'lps'),
	(382447, 124, '2015-02-01 00:04:04.000000', 'consum', 0.0214, 'lps'),
	(382448, 124, '2015-02-01 00:04:05.000000', 'consum', 0.0225, 'lps'),
	(382449, 124, '2015-02-01 00:04:06.000000', 'consum', 0.0213, 'lps'),
	(382450, 124, '2015-02-01 00:04:07.000000', 'consum', 0.0221, 'lps'),
	(382451, 124, '2015-02-01 00:04:08.000000', 'consum', 0.0215, 'lps'),
	(382452, 124, '2015-02-01 00:04:09.000000', 'consum', 0.0222, 'lps'),
	(382453, 124, '2015-02-01 00:04:10.000000', 'consum', 0.0216, 'lps'),
	(382454, 124, '2015-02-01 00:04:11.000000', 'consum', 0.0225, 'lps'),
	(382455, 124, '2015-02-01 00:04:12.000000', 'consum', 0.0226, 'lps'),
	(382456, 124, '2015-02-01 00:04:13.000000', 'consum', 0.0225, 'lps'),
	(382457, 124, '2015-02-01 00:04:14.000000', 'consum', 0.0216, 'lps'),
	(382458, 124, '2015-02-01 00:04:15.000000', 'consum', 0.0215, 'lps'),
	(382459, 124, '2015-02-01 00:04:16.000000', 'consum', 0.0217, 'lps'),
	(382460, 124, '2015-02-01 00:04:17.000000', 'consum', 0.0212, 'lps'),
	(382461, 124, '2015-02-01 00:04:18.000000', 'consum', 0.0217, 'lps'),
	(382462, 124, '2015-02-01 00:04:19.000000', 'consum', 0.0222, 'lps'),
	(382463, 124, '2015-02-01 00:04:20.000000', 'consum', 0.0227, 'lps'),
	(382464, 124, '2015-02-01 00:04:21.000000', 'consum', 0.0218, 'lps'),
	(382465, 124, '2015-02-01 00:04:22.000000', 'consum', 0.0220, 'lps'),
	(382466, 124, '2015-02-01 00:04:23.000000', 'consum', 0.0215, 'lps'),
	(382467, 124, '2015-02-01 00:04:24.000000', 'consum', 0.0226, 'lps'),
	(382468, 124, '2015-02-01 00:04:25.000000', 'consum', 0.0211, 'lps'),
	(382469, 124, '2015-02-01 00:04:26.000000', 'consum', 0.0212, 'lps'),
	(382470, 124, '2015-02-01 00:04:27.000000', 'consum', 0.0218, 'lps'),
	(382471, 124, '2015-02-01 00:04:28.000000', 'consum', 0.0223, 'lps'),
	(382472, 124, '2015-02-01 00:04:29.000000', 'consum', 0.0229, 'lps'),
	(382473, 124, '2015-02-01 00:04:30.000000', 'consum', 0.0225, 'lps'),
	(382474, 124, '2015-02-01 00:04:31.000000', 'consum', 0.0229, 'lps'),
	(382475, 124, '2015-02-01 00:04:32.000000', 'consum', 0.0217, 'lps'),
	(382476, 124, '2015-02-01 00:04:33.000000', 'consum', 0.0211, 'lps'),
	(382477, 124, '2015-02-01 00:04:34.000000', 'consum', 0.0216, 'lps'),
	(382478, 124, '2015-02-01 00:04:35.000000', 'consum', 0.0216, 'lps'),
	(382479, 124, '2015-02-01 00:04:36.000000', 'consum', 0.0223, 'lps'),
	(382480, 124, '2015-02-01 00:04:37.000000', 'consum', 0.0215, 'lps'),
	(382481, 124, '2015-02-01 00:04:38.000000', 'consum', 0.0216, 'lps'),
	(382482, 124, '2015-02-01 00:04:39.000000', 'consum', 0.0227, 'lps'),
	(382483, 124, '2015-02-01 00:04:40.000000', 'consum', 0.0215, 'lps'),
	(382484, 124, '2015-02-01 00:04:41.000000', 'consum', 0.0227, 'lps'),
	(382485, 124, '2015-02-01 00:04:42.000000', 'consum', 0.0216, 'lps'),
	(382486, 124, '2015-02-01 00:04:43.000000', 'consum', 0.0211, 'lps'),
	(382487, 124, '2015-02-01 00:04:44.000000', 'consum', 0.0220, 'lps'),
	(382488, 124, '2015-02-01 00:04:45.000000', 'consum', 0.0214, 'lps'),
	(382489, 124, '2015-02-01 00:04:46.000000', 'consum', 0.0224, 'lps'),
	(382490, 124, '2015-02-01 00:04:47.000000', 'consum', 0.0224, 'lps'),
	(382491, 124, '2015-02-01 00:04:48.000000', 'consum', 0.0218, 'lps'),
	(382492, 124, '2015-02-01 00:04:49.000000', 'consum', 0.0229, 'lps'),
	(382493, 124, '2015-02-01 00:04:50.000000', 'consum', 0.0217, 'lps'),
	(382494, 124, '2015-02-01 00:04:51.000000', 'consum', 0.0212, 'lps'),
	(382495, 124, '2015-02-01 00:04:52.000000', 'consum', 0.0219, 'lps'),
	(382496, 124, '2015-02-01 00:04:53.000000', 'consum', 0.0227, 'lps'),
	(382497, 124, '2015-02-01 00:04:54.000000', 'consum', 0.0227, 'lps'),
	(382498, 124, '2015-02-01 00:04:55.000000', 'consum', 0.0225, 'lps'),
	(382499, 124, '2015-02-01 00:04:56.000000', 'consum', 0.0215, 'lps'),
	(382500, 124, '2015-02-01 00:04:57.000000', 'consum', 0.0230, 'lps'),
	(382501, 124, '2015-02-01 00:04:58.000000', 'consum', 0.0214, 'lps'),
	(382502, 124, '2015-02-01 00:04:59.000000', 'consum', 0.0212, 'lps'),
	(382503, 124, '2015-02-01 00:05:00.000000', 'consum', 0.0230, 'lps'),
	(382504, 124, '2015-02-01 00:05:01.000000', 'consum', 0.0218, 'lps'),
	(382505, 124, '2015-02-01 00:05:02.000000', 'consum', 0.0211, 'lps'),
	(382506, 124, '2015-02-01 00:05:03.000000', 'consum', 0.0215, 'lps'),
	(382507, 124, '2015-02-01 00:05:04.000000', 'consum', 0.0211, 'lps'),
	(382508, 124, '2015-02-01 00:05:05.000000', 'consum', 0.0219, 'lps'),
	(382509, 124, '2015-02-01 00:05:06.000000', 'consum', 0.0214, 'lps'),
	(382510, 124, '2015-02-01 00:05:07.000000', 'consum', 0.0223, 'lps'),
	(382511, 124, '2015-02-01 00:05:08.000000', 'consum', 0.0221, 'lps'),
	(382512, 124, '2015-02-01 00:05:09.000000', 'consum', 0.0225, 'lps'),
	(382513, 124, '2015-02-01 00:05:10.000000', 'consum', 0.0212, 'lps'),
	(382514, 124, '2015-02-01 00:05:11.000000', 'consum', 0.0217, 'lps'),
	(382515, 124, '2015-02-01 00:05:12.000000', 'consum', 0.0217, 'lps'),
	(382516, 124, '2015-02-01 00:05:13.000000', 'consum', 0.0226, 'lps'),
	(382517, 124, '2015-02-01 00:05:14.000000', 'consum', 0.0227, 'lps'),
	(382518, 124, '2015-02-01 00:05:15.000000', 'consum', 0.0226, 'lps'),
	(382519, 124, '2015-02-01 00:05:16.000000', 'consum', 0.0220, 'lps'),
	(382520, 124, '2015-02-01 00:05:17.000000', 'consum', 0.0212, 'lps'),
	(382521, 124, '2015-02-01 00:05:18.000000', 'consum', 0.0211, 'lps'),
	(382522, 124, '2015-02-01 00:05:19.000000', 'consum', 0.0211, 'lps'),
	(382523, 124, '2015-02-01 00:05:20.000000', 'consum', 0.0210, 'lps'),
	(382524, 124, '2015-02-01 00:05:21.000000', 'consum', 0.0228, 'lps'),
	(382525, 124, '2015-02-01 00:05:22.000000', 'consum', 0.0217, 'lps'),
	(382526, 124, '2015-02-01 00:05:23.000000', 'consum', 0.0214, 'lps'),
	(382527, 124, '2015-02-01 00:05:24.000000', 'consum', 0.0230, 'lps'),
	(382528, 124, '2015-02-01 00:05:25.000000', 'consum', 0.0215, 'lps'),
	(382529, 124, '2015-02-01 00:05:26.000000', 'consum', 0.0219, 'lps'),
	(382530, 124, '2015-02-01 00:05:27.000000', 'consum', 0.0217, 'lps'),
	(382531, 124, '2015-02-01 00:05:28.000000', 'consum', 0.0218, 'lps'),
	(382532, 124, '2015-02-01 00:05:29.000000', 'consum', 0.0229, 'lps'),
	(382533, 124, '2015-02-01 00:05:30.000000', 'consum', 0.0218, 'lps'),
	(382534, 124, '2015-02-01 00:05:31.000000', 'consum', 0.0213, 'lps'),
	(382535, 124, '2015-02-01 00:05:32.000000', 'consum', 0.0226, 'lps'),
	(382536, 124, '2015-02-01 00:05:33.000000', 'consum', 0.0219, 'lps'),
	(382537, 124, '2015-02-01 00:05:34.000000', 'consum', 0.0227, 'lps'),
	(382538, 124, '2015-02-01 00:05:35.000000', 'consum', 0.0225, 'lps'),
	(382539, 124, '2015-02-01 00:05:36.000000', 'consum', 0.0215, 'lps'),
	(382540, 124, '2015-02-01 00:05:37.000000', 'consum', 0.0210, 'lps'),
	(382541, 124, '2015-02-01 00:05:38.000000', 'consum', 0.0217, 'lps'),
	(382542, 124, '2015-02-01 00:05:39.000000', 'consum', 0.0226, 'lps'),
	(382543, 124, '2015-02-01 00:05:40.000000', 'consum', 0.0226, 'lps'),
	(382544, 124, '2015-02-01 00:05:41.000000', 'consum', 0.0220, 'lps'),
	(382545, 124, '2015-02-01 00:05:42.000000', 'consum', 0.0213, 'lps'),
	(382546, 124, '2015-02-01 00:05:43.000000', 'consum', 0.0218, 'lps'),
	(382547, 124, '2015-02-01 00:05:44.000000', 'consum', 0.0218, 'lps'),
	(382548, 124, '2015-02-01 00:05:45.000000', 'consum', 0.0228, 'lps'),
	(382549, 124, '2015-02-01 00:05:46.000000', 'consum', 0.0214, 'lps'),
	(382550, 124, '2015-02-01 00:05:47.000000', 'consum', 0.0219, 'lps'),
	(382551, 124, '2015-02-01 00:05:48.000000', 'consum', 0.0221, 'lps'),
	(382552, 124, '2015-02-01 00:05:49.000000', 'consum', 0.0218, 'lps'),
	(382553, 124, '2015-02-01 00:05:50.000000', 'consum', 0.0219, 'lps'),
	(382554, 124, '2015-02-01 00:05:51.000000', 'consum', 0.0210, 'lps'),
	(382555, 124, '2015-02-01 00:05:52.000000', 'consum', 0.0224, 'lps'),
	(382556, 124, '2015-02-01 00:05:53.000000', 'consum', 0.0217, 'lps'),
	(382557, 124, '2015-02-01 00:05:54.000000', 'consum', 0.0224, 'lps'),
	(382558, 124, '2015-02-01 00:05:55.000000', 'consum', 0.0219, 'lps'),
	(382559, 124, '2015-02-01 00:05:56.000000', 'consum', 0.0212, 'lps'),
	(382560, 124, '2015-02-01 00:05:57.000000', 'consum', 0.0217, 'lps'),
	(382561, 124, '2015-02-01 00:05:58.000000', 'consum', 0.0215, 'lps'),
	(382562, 124, '2015-02-01 00:05:59.000000', 'consum', 0.0217, 'lps'),
	(382563, 124, '2015-02-01 00:06:00.000000', 'consum', 0.0230, 'lps'),
	(382564, 124, '2015-02-01 00:06:01.000000', 'consum', 0.0225, 'lps'),
	(382565, 124, '2015-02-01 00:06:02.000000', 'consum', 0.0226, 'lps'),
	(382566, 124, '2015-02-01 00:06:03.000000', 'consum', 0.0225, 'lps'),
	(382567, 124, '2015-02-01 00:06:04.000000', 'consum', 0.0214, 'lps'),
	(382568, 124, '2015-02-01 00:06:05.000000', 'consum', 0.0210, 'lps'),
	(382569, 124, '2015-02-01 00:06:06.000000', 'consum', 0.0218, 'lps'),
	(382570, 124, '2015-02-01 00:06:07.000000', 'consum', 0.0229, 'lps'),
	(382571, 124, '2015-02-01 00:06:08.000000', 'consum', 0.0219, 'lps'),
	(382572, 124, '2015-02-01 00:06:09.000000', 'consum', 0.0218, 'lps'),
	(382573, 124, '2015-02-01 00:06:10.000000', 'consum', 0.0223, 'lps'),
	(382574, 124, '2015-02-01 00:06:11.000000', 'consum', 0.0210, 'lps'),
	(382575, 124, '2015-02-01 00:06:12.000000', 'consum', 0.0216, 'lps'),
	(382576, 124, '2015-02-01 00:06:13.000000', 'consum', 0.0217, 'lps'),
	(382577, 124, '2015-02-01 00:06:14.000000', 'consum', 0.0229, 'lps'),
	(382578, 124, '2015-02-01 00:06:15.000000', 'consum', 0.0223, 'lps'),
	(382579, 124, '2015-02-01 00:06:16.000000', 'consum', 0.0217, 'lps'),
	(382580, 124, '2015-02-01 00:06:17.000000', 'consum', 0.0229, 'lps'),
	(382581, 124, '2015-02-01 00:06:18.000000', 'consum', 0.0221, 'lps'),
	(382582, 124, '2015-02-01 00:06:19.000000', 'consum', 0.0228, 'lps'),
	(382583, 124, '2015-02-01 00:06:20.000000', 'consum', 0.0228, 'lps'),
	(382584, 124, '2015-02-01 00:06:21.000000', 'consum', 0.0223, 'lps'),
	(382585, 124, '2015-02-01 00:06:22.000000', 'consum', 0.0224, 'lps'),
	(382586, 124, '2015-02-01 00:06:23.000000', 'consum', 0.0218, 'lps'),
	(382587, 124, '2015-02-01 00:06:24.000000', 'consum', 0.0210, 'lps'),
	(382588, 124, '2015-02-01 00:06:25.000000', 'consum', 0.0227, 'lps'),
	(382589, 124, '2015-02-01 00:06:26.000000', 'consum', 0.0212, 'lps'),
	(382590, 124, '2015-02-01 00:06:27.000000', 'consum', 0.0212, 'lps'),
	(382591, 124, '2015-02-01 00:06:28.000000', 'consum', 0.0215, 'lps'),
	(382592, 124, '2015-02-01 00:06:29.000000', 'consum', 0.0229, 'lps'),
	(382593, 124, '2015-02-01 00:06:30.000000', 'consum', 0.0227, 'lps'),
	(382594, 124, '2015-02-01 00:06:31.000000', 'consum', 0.0217, 'lps'),
	(382595, 124, '2015-02-01 00:06:32.000000', 'consum', 0.0216, 'lps'),
	(382596, 124, '2015-02-01 00:06:33.000000', 'consum', 0.0219, 'lps'),
	(382597, 124, '2015-02-01 00:06:34.000000', 'consum', 0.0219, 'lps'),
	(382598, 124, '2015-02-01 00:06:35.000000', 'consum', 0.0227, 'lps'),
	(382599, 124, '2015-02-01 00:06:36.000000', 'consum', 0.0225, 'lps'),
	(382600, 124, '2015-02-01 00:06:37.000000', 'consum', 0.0215, 'lps'),
	(382601, 124, '2015-02-01 00:06:38.000000', 'consum', 0.0211, 'lps'),
	(382602, 124, '2015-02-01 00:06:39.000000', 'consum', 0.0222, 'lps'),
	(382603, 124, '2015-02-01 00:06:40.000000', 'consum', 0.0227, 'lps'),
	(382604, 124, '2015-02-01 00:06:41.000000', 'consum', 0.0215, 'lps'),
	(382605, 124, '2015-02-01 00:06:42.000000', 'consum', 0.0227, 'lps'),
	(382606, 124, '2015-02-01 00:06:43.000000', 'consum', 0.0218, 'lps'),
	(382607, 124, '2015-02-01 00:06:44.000000', 'consum', 0.0219, 'lps'),
	(382608, 124, '2015-02-01 00:06:45.000000', 'consum', 0.0210, 'lps'),
	(382609, 124, '2015-02-01 00:06:46.000000', 'consum', 0.0225, 'lps'),
	(382610, 124, '2015-02-01 00:06:47.000000', 'consum', 0.0223, 'lps'),
	(382611, 124, '2015-02-01 00:06:48.000000', 'consum', 0.0230, 'lps'),
	(382612, 124, '2015-02-01 00:06:49.000000', 'consum', 0.0229, 'lps'),
	(382613, 124, '2015-02-01 00:06:50.000000', 'consum', 0.0225, 'lps'),
	(382614, 124, '2015-02-01 00:06:51.000000', 'consum', 0.0227, 'lps'),
	(382615, 124, '2015-02-01 00:06:52.000000', 'consum', 0.0210, 'lps'),
	(382616, 124, '2015-02-01 00:06:53.000000', 'consum', 0.0221, 'lps'),
	(382617, 124, '2015-02-01 00:06:54.000000', 'consum', 0.0223, 'lps'),
	(382618, 124, '2015-02-01 00:06:55.000000', 'consum', 0.0223, 'lps'),
	(382619, 124, '2015-02-01 00:06:56.000000', 'consum', 0.0215, 'lps'),
	(382620, 124, '2015-02-01 00:06:57.000000', 'consum', 0.0220, 'lps'),
	(382621, 124, '2015-02-01 00:06:58.000000', 'consum', 0.0222, 'lps'),
	(382622, 124, '2015-02-01 00:06:59.000000', 'consum', 0.0219, 'lps'),
	(382623, 124, '2015-02-01 00:07:00.000000', 'consum', 0.0219, 'lps'),
	(382624, 124, '2015-02-01 00:07:01.000000', 'consum', 0.0210, 'lps'),
	(382625, 124, '2015-02-01 00:07:02.000000', 'consum', 0.0224, 'lps'),
	(382626, 124, '2015-02-01 00:07:03.000000', 'consum', 0.0220, 'lps'),
	(382627, 124, '2015-02-01 00:07:04.000000', 'consum', 0.0215, 'lps'),
	(382628, 124, '2015-02-01 00:07:05.000000', 'consum', 0.0228, 'lps'),
	(382629, 124, '2015-02-01 00:07:06.000000', 'consum', 0.0223, 'lps'),
	(382630, 124, '2015-02-01 00:07:07.000000', 'consum', 0.0220, 'lps'),
	(382631, 124, '2015-02-01 00:07:08.000000', 'consum', 0.0221, 'lps'),
	(382632, 124, '2015-02-01 00:07:09.000000', 'consum', 0.0216, 'lps'),
	(382633, 124, '2015-02-01 00:07:10.000000', 'consum', 0.0229, 'lps'),
	(382634, 124, '2015-02-01 00:07:11.000000', 'consum', 0.0224, 'lps'),
	(382635, 124, '2015-02-01 00:07:12.000000', 'consum', 0.0225, 'lps'),
	(382636, 124, '2015-02-01 00:07:13.000000', 'consum', 0.0221, 'lps'),
	(382637, 124, '2015-02-01 00:07:14.000000', 'consum', 0.0222, 'lps'),
	(382638, 124, '2015-02-01 00:07:15.000000', 'consum', 0.0215, 'lps'),
	(382639, 124, '2015-02-01 00:07:16.000000', 'consum', 0.0223, 'lps'),
	(382640, 124, '2015-02-01 00:07:17.000000', 'consum', 0.0216, 'lps'),
	(382641, 124, '2015-02-01 00:07:18.000000', 'consum', 0.0221, 'lps'),
	(382642, 124, '2015-02-01 00:07:19.000000', 'consum', 0.0230, 'lps'),
	(382643, 124, '2015-02-01 00:07:20.000000', 'consum', 0.0212, 'lps'),
	(382644, 124, '2015-02-01 00:07:21.000000', 'consum', 0.0223, 'lps'),
	(382645, 124, '2015-02-01 00:07:22.000000', 'consum', 0.0227, 'lps'),
	(382646, 124, '2015-02-01 00:07:23.000000', 'consum', 0.0214, 'lps'),
	(382647, 124, '2015-02-01 00:07:24.000000', 'consum', 0.0224, 'lps'),
	(382648, 124, '2015-02-01 00:07:25.000000', 'consum', 0.0224, 'lps'),
	(382649, 124, '2015-02-01 00:07:26.000000', 'consum', 0.0220, 'lps'),
	(382650, 124, '2015-02-01 00:07:27.000000', 'consum', 0.0218, 'lps'),
	(382651, 124, '2015-02-01 00:07:28.000000', 'consum', 0.0219, 'lps'),
	(382652, 124, '2015-02-01 00:07:29.000000', 'consum', 0.0212, 'lps'),
	(382653, 124, '2015-02-01 00:07:30.000000', 'consum', 0.0214, 'lps'),
	(382654, 124, '2015-02-01 00:07:31.000000', 'consum', 0.0225, 'lps'),
	(382655, 124, '2015-02-01 00:07:32.000000', 'consum', 0.0210, 'lps'),
	(382656, 124, '2015-02-01 00:07:33.000000', 'consum', 0.0230, 'lps'),
	(382657, 124, '2015-02-01 00:07:34.000000', 'consum', 0.0227, 'lps'),
	(382658, 124, '2015-02-01 00:07:35.000000', 'consum', 0.0213, 'lps'),
	(382659, 124, '2015-02-01 00:07:36.000000', 'consum', 0.0218, 'lps'),
	(382660, 124, '2015-02-01 00:07:37.000000', 'consum', 0.0219, 'lps'),
	(382661, 124, '2015-02-01 00:07:38.000000', 'consum', 0.0211, 'lps'),
	(382662, 124, '2015-02-01 00:07:39.000000', 'consum', 0.0229, 'lps'),
	(382663, 124, '2015-02-01 00:07:40.000000', 'consum', 0.0221, 'lps'),
	(382664, 124, '2015-02-01 00:07:41.000000', 'consum', 0.0229, 'lps'),
	(382665, 124, '2015-02-01 00:07:42.000000', 'consum', 0.0230, 'lps'),
	(382666, 124, '2015-02-01 00:07:43.000000', 'consum', 0.0211, 'lps'),
	(382667, 124, '2015-02-01 00:07:44.000000', 'consum', 0.0217, 'lps'),
	(382668, 124, '2015-02-01 00:07:45.000000', 'consum', 0.0224, 'lps'),
	(382669, 124, '2015-02-01 00:07:46.000000', 'consum', 0.0215, 'lps'),
	(382670, 124, '2015-02-01 00:07:47.000000', 'consum', 0.0217, 'lps'),
	(382671, 124, '2015-02-01 00:07:48.000000', 'consum', 0.0230, 'lps'),
	(382672, 124, '2015-02-01 00:07:49.000000', 'consum', 0.0227, 'lps'),
	(382673, 124, '2015-02-01 00:07:50.000000', 'consum', 0.0213, 'lps'),
	(382674, 124, '2015-02-01 00:07:51.000000', 'consum', 0.0217, 'lps'),
	(382675, 124, '2015-02-01 00:07:52.000000', 'consum', 0.0216, 'lps'),
	(382676, 124, '2015-02-01 00:07:53.000000', 'consum', 0.0221, 'lps'),
	(382677, 124, '2015-02-01 00:07:54.000000', 'consum', 0.0223, 'lps'),
	(382678, 124, '2015-02-01 00:07:55.000000', 'consum', 0.0225, 'lps'),
	(382679, 124, '2015-02-01 00:07:56.000000', 'consum', 0.0224, 'lps'),
	(382680, 124, '2015-02-01 00:07:57.000000', 'consum', 0.0215, 'lps'),
	(382681, 124, '2015-02-01 00:07:58.000000', 'consum', 0.0213, 'lps'),
	(382682, 124, '2015-02-01 00:07:59.000000', 'consum', 0.0230, 'lps'),
	(382683, 124, '2015-02-01 00:08:00.000000', 'consum', 0.0220, 'lps'),
	(382684, 124, '2015-02-01 00:08:01.000000', 'consum', 0.0222, 'lps'),
	(382685, 124, '2015-02-01 00:08:02.000000', 'consum', 0.0220, 'lps'),
	(382686, 124, '2015-02-01 00:08:03.000000', 'consum', 0.0223, 'lps'),
	(382687, 124, '2015-02-01 00:08:04.000000', 'consum', 0.0225, 'lps'),
	(382688, 124, '2015-02-01 00:08:05.000000', 'consum', 0.0226, 'lps'),
	(382689, 124, '2015-02-01 00:08:06.000000', 'consum', 0.0223, 'lps'),
	(382690, 124, '2015-02-01 00:08:07.000000', 'consum', 0.0230, 'lps'),
	(382691, 124, '2015-02-01 00:08:08.000000', 'consum', 0.0229, 'lps'),
	(382692, 124, '2015-02-01 00:08:09.000000', 'consum', 0.0226, 'lps'),
	(382693, 124, '2015-02-01 00:08:10.000000', 'consum', 0.0210, 'lps'),
	(382694, 124, '2015-02-01 00:08:11.000000', 'consum', 0.0226, 'lps'),
	(382695, 124, '2015-02-01 00:08:12.000000', 'consum', 0.0228, 'lps'),
	(382696, 124, '2015-02-01 00:08:13.000000', 'consum', 0.0210, 'lps'),
	(382697, 124, '2015-02-01 00:08:14.000000', 'consum', 0.0221, 'lps'),
	(382698, 124, '2015-02-01 00:08:15.000000', 'consum', 0.0223, 'lps'),
	(382699, 124, '2015-02-01 00:08:16.000000', 'consum', 0.0222, 'lps'),
	(382700, 124, '2015-02-01 00:08:17.000000', 'consum', 0.0229, 'lps'),
	(382701, 124, '2015-02-01 00:08:18.000000', 'consum', 0.0230, 'lps'),
	(382702, 124, '2015-02-01 00:08:19.000000', 'consum', 0.0212, 'lps'),
	(382703, 124, '2015-02-01 00:08:20.000000', 'consum', 0.0224, 'lps'),
	(382704, 124, '2015-02-01 00:08:21.000000', 'consum', 0.0212, 'lps'),
	(382705, 124, '2015-02-01 00:08:22.000000', 'consum', 0.0219, 'lps'),
	(382706, 124, '2015-02-01 00:08:23.000000', 'consum', 0.0228, 'lps'),
	(382707, 124, '2015-02-01 00:08:24.000000', 'consum', 0.0212, 'lps'),
	(382708, 124, '2015-02-01 00:08:25.000000', 'consum', 0.0210, 'lps'),
	(382709, 124, '2015-02-01 00:08:26.000000', 'consum', 0.0222, 'lps'),
	(382710, 124, '2015-02-01 00:08:27.000000', 'consum', 0.0230, 'lps'),
	(382711, 124, '2015-02-01 00:08:28.000000', 'consum', 0.0211, 'lps'),
	(382712, 124, '2015-02-01 00:08:29.000000', 'consum', 0.0219, 'lps'),
	(382713, 124, '2015-02-01 00:08:30.000000', 'consum', 0.0210, 'lps'),
	(382714, 124, '2015-02-01 00:08:31.000000', 'consum', 0.0225, 'lps'),
	(382715, 124, '2015-02-01 00:08:32.000000', 'consum', 0.0224, 'lps'),
	(382716, 124, '2015-02-01 00:08:33.000000', 'consum', 0.0213, 'lps'),
	(382717, 124, '2015-02-01 00:08:34.000000', 'consum', 0.0228, 'lps'),
	(382718, 124, '2015-02-01 00:08:35.000000', 'consum', 0.0226, 'lps'),
	(382719, 124, '2015-02-01 00:08:36.000000', 'consum', 0.0218, 'lps'),
	(382720, 124, '2015-02-01 00:08:37.000000', 'consum', 0.0221, 'lps'),
	(382721, 124, '2015-02-01 00:08:38.000000', 'consum', 0.0220, 'lps'),
	(382722, 124, '2015-02-01 00:08:39.000000', 'consum', 0.0229, 'lps'),
	(382723, 124, '2015-02-01 00:08:40.000000', 'consum', 0.0210, 'lps'),
	(382724, 124, '2015-02-01 00:08:41.000000', 'consum', 0.0220, 'lps'),
	(382725, 124, '2015-02-01 00:08:42.000000', 'consum', 0.0216, 'lps'),
	(382726, 124, '2015-02-01 00:08:43.000000', 'consum', 0.0213, 'lps'),
	(382727, 124, '2015-02-01 00:08:44.000000', 'consum', 0.0228, 'lps'),
	(382728, 124, '2015-02-01 00:08:45.000000', 'consum', 0.0228, 'lps'),
	(382729, 124, '2015-02-01 00:08:46.000000', 'consum', 0.0224, 'lps'),
	(382730, 124, '2015-02-01 00:08:47.000000', 'consum', 0.0228, 'lps'),
	(382731, 124, '2015-02-01 00:08:48.000000', 'consum', 0.0218, 'lps'),
	(382732, 124, '2015-02-01 00:08:49.000000', 'consum', 0.0215, 'lps'),
	(382733, 124, '2015-02-01 00:08:50.000000', 'consum', 0.0213, 'lps'),
	(382734, 124, '2015-02-01 00:08:51.000000', 'consum', 0.0212, 'lps'),
	(382735, 124, '2015-02-01 00:08:52.000000', 'consum', 0.0230, 'lps'),
	(382736, 124, '2015-02-01 00:08:53.000000', 'consum', 0.0221, 'lps'),
	(382737, 124, '2015-02-01 00:08:54.000000', 'consum', 0.0225, 'lps'),
	(382738, 124, '2015-02-01 00:08:55.000000', 'consum', 0.0214, 'lps'),
	(382739, 124, '2015-02-01 00:08:56.000000', 'consum', 0.0224, 'lps'),
	(382740, 124, '2015-02-01 00:08:57.000000', 'consum', 0.0229, 'lps'),
	(382741, 124, '2015-02-01 00:08:58.000000', 'consum', 0.0222, 'lps'),
	(382742, 124, '2015-02-01 00:08:59.000000', 'consum', 0.0211, 'lps'),
	(382743, 124, '2015-02-01 00:09:00.000000', 'consum', 0.0222, 'lps'),
	(382744, 124, '2015-02-01 00:09:01.000000', 'consum', 0.0227, 'lps'),
	(382745, 124, '2015-02-01 00:09:02.000000', 'consum', 0.0217, 'lps'),
	(382746, 124, '2015-02-01 00:09:03.000000', 'consum', 0.0217, 'lps'),
	(382747, 124, '2015-02-01 00:09:04.000000', 'consum', 0.0225, 'lps'),
	(382748, 124, '2015-02-01 00:09:05.000000', 'consum', 0.0221, 'lps'),
	(382749, 124, '2015-02-01 00:09:06.000000', 'consum', 0.0221, 'lps'),
	(382750, 124, '2015-02-01 00:09:07.000000', 'consum', 0.0211, 'lps'),
	(382751, 124, '2015-02-01 00:09:08.000000', 'consum', 0.0224, 'lps'),
	(382752, 124, '2015-02-01 00:09:09.000000', 'consum', 0.0214, 'lps'),
	(382753, 124, '2015-02-01 00:09:10.000000', 'consum', 0.0211, 'lps'),
	(382754, 124, '2015-02-01 00:09:11.000000', 'consum', 0.0225, 'lps'),
	(382755, 124, '2015-02-01 00:09:12.000000', 'consum', 0.0218, 'lps'),
	(382756, 124, '2015-02-01 00:09:13.000000', 'consum', 0.0228, 'lps'),
	(382757, 124, '2015-02-01 00:09:14.000000', 'consum', 0.0213, 'lps'),
	(382758, 124, '2015-02-01 00:09:15.000000', 'consum', 0.0212, 'lps'),
	(382759, 124, '2015-02-01 00:09:16.000000', 'consum', 0.0211, 'lps'),
	(382760, 124, '2015-02-01 00:09:17.000000', 'consum', 0.0230, 'lps'),
	(382761, 124, '2015-02-01 00:09:18.000000', 'consum', 0.0226, 'lps'),
	(382762, 124, '2015-02-01 00:09:19.000000', 'consum', 0.0229, 'lps'),
	(382763, 124, '2015-02-01 00:09:20.000000', 'consum', 0.0214, 'lps'),
	(382764, 124, '2015-02-01 00:09:21.000000', 'consum', 0.0217, 'lps'),
	(382765, 124, '2015-02-01 00:09:22.000000', 'consum', 0.0210, 'lps'),
	(382766, 124, '2015-02-01 00:09:23.000000', 'consum', 0.0213, 'lps'),
	(382767, 124, '2015-02-01 00:09:24.000000', 'consum', 0.0227, 'lps'),
	(382768, 124, '2015-02-01 00:09:25.000000', 'consum', 0.0222, 'lps'),
	(382769, 124, '2015-02-01 00:09:26.000000', 'consum', 0.0218, 'lps'),
	(382770, 124, '2015-02-01 00:09:27.000000', 'consum', 0.0214, 'lps'),
	(382771, 124, '2015-02-01 00:09:28.000000', 'consum', 0.0228, 'lps'),
	(382772, 124, '2015-02-01 00:09:29.000000', 'consum', 0.0226, 'lps'),
	(382773, 124, '2015-02-01 00:09:30.000000', 'consum', 0.0214, 'lps'),
	(382774, 124, '2015-02-01 00:09:31.000000', 'consum', 0.0225, 'lps'),
	(382775, 124, '2015-02-01 00:09:32.000000', 'consum', 0.0213, 'lps'),
	(382776, 124, '2015-02-01 00:09:33.000000', 'consum', 0.0220, 'lps'),
	(382777, 124, '2015-02-01 00:09:34.000000', 'consum', 0.0230, 'lps'),
	(382778, 124, '2015-02-01 00:09:35.000000', 'consum', 0.0218, 'lps'),
	(382779, 124, '2015-02-01 00:09:36.000000', 'consum', 0.0213, 'lps'),
	(382780, 124, '2015-02-01 00:09:37.000000', 'consum', 0.0222, 'lps'),
	(382781, 124, '2015-02-01 00:09:38.000000', 'consum', 0.0220, 'lps'),
	(382782, 124, '2015-02-01 00:09:39.000000', 'consum', 0.0226, 'lps'),
	(382783, 124, '2015-02-01 00:09:40.000000', 'consum', 0.0216, 'lps'),
	(382784, 124, '2015-02-01 00:09:41.000000', 'consum', 0.0215, 'lps'),
	(382785, 124, '2015-02-01 00:09:42.000000', 'consum', 0.0218, 'lps'),
	(382786, 124, '2015-02-01 00:09:43.000000', 'consum', 0.0212, 'lps'),
	(382787, 124, '2015-02-01 00:09:44.000000', 'consum', 0.0218, 'lps'),
	(382788, 124, '2015-02-01 00:09:45.000000', 'consum', 0.0222, 'lps'),
	(382789, 124, '2015-02-01 00:09:46.000000', 'consum', 0.0229, 'lps'),
	(382790, 124, '2015-02-01 00:09:47.000000', 'consum', 0.0225, 'lps'),
	(382791, 124, '2015-02-01 00:09:48.000000', 'consum', 0.0229, 'lps'),
	(382792, 124, '2015-02-01 00:09:49.000000', 'consum', 0.0218, 'lps'),
	(382793, 124, '2015-02-01 00:09:50.000000', 'consum', 0.0217, 'lps'),
	(382794, 124, '2015-02-01 00:09:51.000000', 'consum', 0.0220, 'lps'),
	(382795, 124, '2015-02-01 00:09:52.000000', 'consum', 0.0219, 'lps'),
	(382796, 124, '2015-02-01 00:09:53.000000', 'consum', 0.0224, 'lps'),
	(382797, 124, '2015-02-01 00:09:54.000000', 'consum', 0.0211, 'lps'),
	(382798, 124, '2015-02-01 00:09:55.000000', 'consum', 0.0216, 'lps'),
	(382799, 124, '2015-02-01 00:09:56.000000', 'consum', 0.0215, 'lps'),
	(382800, 124, '2015-02-01 00:09:57.000000', 'consum', 0.0218, 'lps'),
	(382801, 124, '2015-02-01 00:09:58.000000', 'consum', 0.0216, 'lps'),
	(382802, 124, '2015-02-01 00:09:59.000000', 'consum', 0.0214, 'lps'),
	(382803, 124, '2015-02-01 00:10:00.000000', 'consum', 0.0214, 'lps'),
	(382804, 124, '2015-02-01 00:10:01.000000', 'consum', 0.0217, 'lps'),
	(382805, 124, '2015-02-01 00:10:02.000000', 'consum', 0.0212, 'lps'),
	(382806, 124, '2015-02-01 00:10:03.000000', 'consum', 0.0220, 'lps'),
	(382807, 124, '2015-02-01 00:10:04.000000', 'consum', 0.0213, 'lps'),
	(382808, 124, '2015-02-01 00:10:05.000000', 'consum', 0.0217, 'lps'),
	(382809, 124, '2015-02-01 00:10:06.000000', 'consum', 0.0217, 'lps'),
	(382810, 124, '2015-02-01 00:10:07.000000', 'consum', 0.0224, 'lps'),
	(382811, 124, '2015-02-01 00:10:08.000000', 'consum', 0.0218, 'lps'),
	(382812, 124, '2015-02-01 00:10:09.000000', 'consum', 0.0228, 'lps'),
	(382813, 124, '2015-02-01 00:10:10.000000', 'consum', 0.0212, 'lps'),
	(382814, 124, '2015-02-01 00:10:11.000000', 'consum', 0.0210, 'lps'),
	(382815, 124, '2015-02-01 00:10:12.000000', 'consum', 0.0226, 'lps'),
	(382816, 124, '2015-02-01 00:10:13.000000', 'consum', 0.0226, 'lps'),
	(382817, 124, '2015-02-01 00:10:14.000000', 'consum', 0.0222, 'lps'),
	(382818, 124, '2015-02-01 00:10:15.000000', 'consum', 0.0223, 'lps'),
	(382819, 124, '2015-02-01 00:10:16.000000', 'consum', 0.0217, 'lps'),
	(382820, 124, '2015-02-01 00:10:17.000000', 'consum', 0.0228, 'lps'),
	(382821, 124, '2015-02-01 00:10:18.000000', 'consum', 0.0217, 'lps'),
	(382822, 124, '2015-02-01 00:10:19.000000', 'consum', 0.0211, 'lps'),
	(382823, 124, '2015-02-01 00:10:20.000000', 'consum', 0.0214, 'lps'),
	(382824, 124, '2015-02-01 00:10:21.000000', 'consum', 0.0210, 'lps'),
	(382825, 124, '2015-02-01 00:10:22.000000', 'consum', 0.0219, 'lps'),
	(382826, 124, '2015-02-01 00:10:23.000000', 'consum', 0.0212, 'lps'),
	(382827, 124, '2015-02-01 00:10:24.000000', 'consum', 0.0215, 'lps'),
	(382828, 124, '2015-02-01 00:10:25.000000', 'consum', 0.0229, 'lps'),
	(382829, 124, '2015-02-01 00:10:26.000000', 'consum', 0.0230, 'lps'),
	(382830, 124, '2015-02-01 00:10:27.000000', 'consum', 0.0210, 'lps'),
	(382831, 124, '2015-02-01 00:10:28.000000', 'consum', 0.0214, 'lps'),
	(382832, 124, '2015-02-01 00:10:29.000000', 'consum', 0.0211, 'lps'),
	(382833, 124, '2015-02-01 00:10:30.000000', 'consum', 0.0221, 'lps'),
	(382834, 124, '2015-02-01 00:10:31.000000', 'consum', 0.0223, 'lps'),
	(382835, 124, '2015-02-01 00:10:32.000000', 'consum', 0.0219, 'lps'),
	(382836, 124, '2015-02-01 00:10:33.000000', 'consum', 0.0218, 'lps'),
	(382837, 124, '2015-02-01 00:10:34.000000', 'consum', 0.0225, 'lps'),
	(382838, 124, '2015-02-01 00:10:35.000000', 'consum', 0.0218, 'lps'),
	(382839, 124, '2015-02-01 00:10:36.000000', 'consum', 0.0227, 'lps'),
	(382840, 124, '2015-02-01 00:10:37.000000', 'consum', 0.0229, 'lps'),
	(382841, 124, '2015-02-01 00:10:38.000000', 'consum', 0.0211, 'lps'),
	(382842, 124, '2015-02-01 00:10:39.000000', 'consum', 0.0223, 'lps'),
	(382843, 124, '2015-02-01 00:10:40.000000', 'consum', 0.0210, 'lps'),
	(382844, 124, '2015-02-01 00:10:41.000000', 'consum', 0.0214, 'lps'),
	(382845, 124, '2015-02-01 00:10:42.000000', 'consum', 0.0228, 'lps'),
	(382846, 124, '2015-02-01 00:10:43.000000', 'consum', 0.0226, 'lps'),
	(382847, 124, '2015-02-01 00:10:44.000000', 'consum', 0.0215, 'lps'),
	(382848, 124, '2015-02-01 00:10:45.000000', 'consum', 0.0210, 'lps'),
	(382849, 124, '2015-02-01 00:10:46.000000', 'consum', 0.0216, 'lps'),
	(382850, 124, '2015-02-01 00:10:47.000000', 'consum', 0.0222, 'lps'),
	(382851, 124, '2015-02-01 00:10:48.000000', 'consum', 0.0228, 'lps'),
	(382852, 124, '2015-02-01 00:10:49.000000', 'consum', 0.0224, 'lps'),
	(382853, 124, '2015-02-01 00:10:50.000000', 'consum', 0.0226, 'lps'),
	(382854, 124, '2015-02-01 00:10:51.000000', 'consum', 0.0226, 'lps'),
	(382855, 124, '2015-02-01 00:10:52.000000', 'consum', 0.0223, 'lps'),
	(382856, 124, '2015-02-01 00:10:53.000000', 'consum', 0.0229, 'lps'),
	(382857, 124, '2015-02-01 00:10:54.000000', 'consum', 0.0222, 'lps'),
	(382858, 124, '2015-02-01 00:10:55.000000', 'consum', 0.0215, 'lps'),
	(382859, 124, '2015-02-01 00:10:56.000000', 'consum', 0.0218, 'lps'),
	(382860, 124, '2015-02-01 00:10:57.000000', 'consum', 0.0216, 'lps'),
	(382861, 124, '2015-02-01 00:10:58.000000', 'consum', 0.0216, 'lps'),
	(382862, 124, '2015-02-01 00:10:59.000000', 'consum', 0.0223, 'lps'),
	(382863, 124, '2015-02-01 00:11:00.000000', 'consum', 0.0217, 'lps'),
	(382864, 124, '2015-02-01 00:11:01.000000', 'consum', 0.0228, 'lps'),
	(382865, 124, '2015-02-01 00:11:02.000000', 'consum', 0.0215, 'lps'),
	(382866, 124, '2015-02-01 00:11:03.000000', 'consum', 0.0224, 'lps'),
	(382867, 124, '2015-02-01 00:11:04.000000', 'consum', 0.0223, 'lps'),
	(382868, 124, '2015-02-01 00:11:05.000000', 'consum', 0.0214, 'lps'),
	(382869, 124, '2015-02-01 00:11:06.000000', 'consum', 0.0213, 'lps'),
	(382870, 124, '2015-02-01 00:11:07.000000', 'consum', 0.0211, 'lps'),
	(382871, 124, '2015-02-01 00:11:08.000000', 'consum', 0.0228, 'lps'),
	(382872, 124, '2015-02-01 00:11:09.000000', 'consum', 0.0213, 'lps'),
	(382873, 124, '2015-02-01 00:11:10.000000', 'consum', 0.0213, 'lps'),
	(382874, 124, '2015-02-01 00:11:11.000000', 'consum', 0.0215, 'lps'),
	(382875, 124, '2015-02-01 00:11:12.000000', 'consum', 0.0229, 'lps'),
	(382876, 124, '2015-02-01 00:11:13.000000', 'consum', 0.0228, 'lps'),
	(382877, 124, '2015-02-01 00:11:14.000000', 'consum', 0.0223, 'lps'),
	(382878, 124, '2015-02-01 00:11:15.000000', 'consum', 0.0222, 'lps'),
	(382879, 124, '2015-02-01 00:11:16.000000', 'consum', 0.0229, 'lps'),
	(382880, 124, '2015-02-01 00:11:17.000000', 'consum', 0.0228, 'lps'),
	(382881, 124, '2015-02-01 00:11:18.000000', 'consum', 0.0225, 'lps'),
	(382882, 124, '2015-02-01 00:11:19.000000', 'consum', 0.0230, 'lps'),
	(382883, 124, '2015-02-01 00:11:20.000000', 'consum', 0.0224, 'lps'),
	(382884, 124, '2015-02-01 00:11:21.000000', 'consum', 0.0219, 'lps'),
	(382885, 124, '2015-02-01 00:11:22.000000', 'consum', 0.0215, 'lps'),
	(382886, 124, '2015-02-01 00:11:23.000000', 'consum', 0.0227, 'lps'),
	(382887, 124, '2015-02-01 00:11:24.000000', 'consum', 0.0219, 'lps'),
	(382888, 124, '2015-02-01 00:11:25.000000', 'consum', 0.0227, 'lps'),
	(382889, 124, '2015-02-01 00:11:26.000000', 'consum', 0.0224, 'lps'),
	(382890, 124, '2015-02-01 00:11:27.000000', 'consum', 0.0210, 'lps'),
	(382891, 124, '2015-02-01 00:11:28.000000', 'consum', 0.0230, 'lps'),
	(382892, 124, '2015-02-01 00:11:29.000000', 'consum', 0.0226, 'lps'),
	(382893, 124, '2015-02-01 00:11:30.000000', 'consum', 0.0211, 'lps'),
	(382894, 124, '2015-02-01 00:11:31.000000', 'consum', 0.0230, 'lps'),
	(382895, 124, '2015-02-01 00:11:32.000000', 'consum', 0.0222, 'lps'),
	(382896, 124, '2015-02-01 00:11:33.000000', 'consum', 0.0212, 'lps'),
	(382897, 124, '2015-02-01 00:11:34.000000', 'consum', 0.0225, 'lps'),
	(382898, 124, '2015-02-01 00:11:35.000000', 'consum', 0.0219, 'lps'),
	(382899, 124, '2015-02-01 00:11:36.000000', 'consum', 0.0210, 'lps'),
	(382900, 124, '2015-02-01 00:11:37.000000', 'consum', 0.0226, 'lps'),
	(382901, 124, '2015-02-01 00:11:38.000000', 'consum', 0.0225, 'lps'),
	(382902, 124, '2015-02-01 00:11:39.000000', 'consum', 0.0217, 'lps'),
	(382903, 124, '2015-02-01 00:11:40.000000', 'consum', 0.0222, 'lps'),
	(382904, 124, '2015-02-01 00:11:41.000000', 'consum', 0.0227, 'lps'),
	(382905, 124, '2015-02-01 00:11:42.000000', 'consum', 0.0220, 'lps'),
	(382906, 124, '2015-02-01 00:11:43.000000', 'consum', 0.0229, 'lps'),
	(382907, 124, '2015-02-01 00:11:44.000000', 'consum', 0.0212, 'lps'),
	(382908, 124, '2015-02-01 00:11:45.000000', 'consum', 0.0227, 'lps'),
	(382909, 124, '2015-02-01 00:11:46.000000', 'consum', 0.0225, 'lps'),
	(382910, 124, '2015-02-01 00:11:47.000000', 'consum', 0.0216, 'lps'),
	(382911, 124, '2015-02-01 00:11:48.000000', 'consum', 0.0214, 'lps'),
	(382912, 124, '2015-02-01 00:11:49.000000', 'consum', 0.0213, 'lps'),
	(382913, 124, '2015-02-01 00:11:50.000000', 'consum', 0.0216, 'lps'),
	(382914, 124, '2015-02-01 00:11:51.000000', 'consum', 0.0229, 'lps'),
	(382915, 124, '2015-02-01 00:11:52.000000', 'consum', 0.0224, 'lps'),
	(382916, 124, '2015-02-01 00:11:53.000000', 'consum', 0.0226, 'lps'),
	(382917, 124, '2015-02-01 00:11:54.000000', 'consum', 0.0225, 'lps'),
	(382918, 124, '2015-02-01 00:11:55.000000', 'consum', 0.0216, 'lps'),
	(382919, 124, '2015-02-01 00:11:56.000000', 'consum', 0.0218, 'lps'),
	(382920, 124, '2015-02-01 00:11:57.000000', 'consum', 0.0213, 'lps'),
	(382921, 124, '2015-02-01 00:11:58.000000', 'consum', 0.0220, 'lps'),
	(382922, 124, '2015-02-01 00:11:59.000000', 'consum', 0.0210, 'lps'),
	(382923, 124, '2015-02-01 00:12:00.000000', 'consum', 0.0221, 'lps'),
	(382924, 124, '2015-02-01 00:12:01.000000', 'consum', 0.0226, 'lps'),
	(382925, 124, '2015-02-01 00:12:02.000000', 'consum', 0.0214, 'lps'),
	(382926, 124, '2015-02-01 00:12:03.000000', 'consum', 0.0225, 'lps'),
	(382927, 124, '2015-02-01 00:12:04.000000', 'consum', 0.0212, 'lps'),
	(382928, 124, '2015-02-01 00:12:05.000000', 'consum', 0.0215, 'lps'),
	(382929, 124, '2015-02-01 00:12:06.000000', 'consum', 0.0230, 'lps'),
	(382930, 124, '2015-02-01 00:12:07.000000', 'consum', 0.0210, 'lps'),
	(382931, 124, '2015-02-01 00:12:08.000000', 'consum', 0.0216, 'lps'),
	(382932, 124, '2015-02-01 00:12:09.000000', 'consum', 0.0218, 'lps'),
	(382933, 124, '2015-02-01 00:12:10.000000', 'consum', 0.0212, 'lps'),
	(382934, 124, '2015-02-01 00:12:11.000000', 'consum', 0.0217, 'lps'),
	(382935, 124, '2015-02-01 00:12:12.000000', 'consum', 0.0217, 'lps'),
	(382936, 124, '2015-02-01 00:12:13.000000', 'consum', 0.0225, 'lps'),
	(382937, 124, '2015-02-01 00:12:14.000000', 'consum', 0.0225, 'lps'),
	(382938, 124, '2015-02-01 00:12:15.000000', 'consum', 0.0218, 'lps'),
	(382939, 124, '2015-02-01 00:12:16.000000', 'consum', 0.0227, 'lps'),
	(382940, 124, '2015-02-01 00:12:17.000000', 'consum', 0.0228, 'lps'),
	(382941, 124, '2015-02-01 00:12:18.000000', 'consum', 0.0210, 'lps'),
	(382942, 124, '2015-02-01 00:12:19.000000', 'consum', 0.0219, 'lps'),
	(382943, 124, '2015-02-01 00:12:20.000000', 'consum', 0.0211, 'lps'),
	(382944, 124, '2015-02-01 00:12:21.000000', 'consum', 0.0211, 'lps'),
	(382945, 124, '2015-02-01 00:12:22.000000', 'consum', 0.0213, 'lps'),
	(382946, 124, '2015-02-01 00:12:23.000000', 'consum', 0.0220, 'lps'),
	(382947, 124, '2015-02-01 00:12:24.000000', 'consum', 0.0211, 'lps'),
	(382948, 124, '2015-02-01 00:12:25.000000', 'consum', 0.0229, 'lps'),
	(382949, 124, '2015-02-01 00:12:26.000000', 'consum', 0.0218, 'lps'),
	(382950, 124, '2015-02-01 00:12:27.000000', 'consum', 0.0214, 'lps'),
	(382951, 124, '2015-02-01 00:12:28.000000', 'consum', 0.0228, 'lps'),
	(382952, 124, '2015-02-01 00:12:29.000000', 'consum', 0.0226, 'lps'),
	(382953, 124, '2015-02-01 00:12:30.000000', 'consum', 0.0216, 'lps'),
	(382954, 124, '2015-02-01 00:12:31.000000', 'consum', 0.0213, 'lps'),
	(382955, 124, '2015-02-01 00:12:32.000000', 'consum', 0.0228, 'lps'),
	(382956, 124, '2015-02-01 00:12:33.000000', 'consum', 0.0227, 'lps'),
	(382957, 124, '2015-02-01 00:12:34.000000', 'consum', 0.0224, 'lps'),
	(382958, 124, '2015-02-01 00:12:35.000000', 'consum', 0.0226, 'lps'),
	(382959, 124, '2015-02-01 00:12:36.000000', 'consum', 0.0230, 'lps'),
	(382960, 124, '2015-02-01 00:12:37.000000', 'consum', 0.0218, 'lps'),
	(382961, 124, '2015-02-01 00:12:38.000000', 'consum', 0.0214, 'lps'),
	(382962, 124, '2015-02-01 00:12:39.000000', 'consum', 0.0225, 'lps'),
	(382963, 124, '2015-02-01 00:12:40.000000', 'consum', 0.0214, 'lps'),
	(382964, 124, '2015-02-01 00:12:41.000000', 'consum', 0.0224, 'lps'),
	(382965, 124, '2015-02-01 00:12:42.000000', 'consum', 0.0227, 'lps'),
	(382966, 124, '2015-02-01 00:12:43.000000', 'consum', 0.0213, 'lps'),
	(382967, 124, '2015-02-01 00:12:44.000000', 'consum', 0.0215, 'lps'),
	(382968, 124, '2015-02-01 00:12:45.000000', 'consum', 0.0228, 'lps'),
	(382969, 124, '2015-02-01 00:12:46.000000', 'consum', 0.0224, 'lps'),
	(382970, 124, '2015-02-01 00:12:47.000000', 'consum', 0.0224, 'lps'),
	(382971, 124, '2015-02-01 00:12:48.000000', 'consum', 0.0220, 'lps'),
	(382972, 124, '2015-02-01 00:12:49.000000', 'consum', 0.0215, 'lps'),
	(382973, 124, '2015-02-01 00:12:50.000000', 'consum', 0.0230, 'lps'),
	(382974, 124, '2015-02-01 00:12:51.000000', 'consum', 0.0210, 'lps'),
	(382975, 124, '2015-02-01 00:12:52.000000', 'consum', 0.0212, 'lps'),
	(382976, 124, '2015-02-01 00:12:53.000000', 'consum', 0.0222, 'lps'),
	(382977, 124, '2015-02-01 00:12:54.000000', 'consum', 0.0224, 'lps'),
	(382978, 124, '2015-02-01 00:12:55.000000', 'consum', 0.0223, 'lps'),
	(382979, 124, '2015-02-01 00:12:56.000000', 'consum', 0.0214, 'lps'),
	(382980, 124, '2015-02-01 00:12:57.000000', 'consum', 0.0210, 'lps'),
	(382981, 124, '2015-02-01 00:12:58.000000', 'consum', 0.0222, 'lps'),
	(382982, 124, '2015-02-01 00:12:59.000000', 'consum', 0.0225, 'lps'),
	(382983, 124, '2015-02-01 00:13:00.000000', 'consum', 0.0211, 'lps'),
	(382984, 124, '2015-02-01 00:13:01.000000', 'consum', 0.0212, 'lps'),
	(382985, 124, '2015-02-01 00:13:02.000000', 'consum', 0.0215, 'lps'),
	(382986, 124, '2015-02-01 00:13:03.000000', 'consum', 0.0211, 'lps'),
	(382987, 124, '2015-02-01 00:13:04.000000', 'consum', 0.0222, 'lps'),
	(382988, 124, '2015-02-01 00:13:05.000000', 'consum', 0.0226, 'lps'),
	(382989, 124, '2015-02-01 00:13:06.000000', 'consum', 0.0212, 'lps'),
	(382990, 124, '2015-02-01 00:13:07.000000', 'consum', 0.0215, 'lps'),
	(382991, 124, '2015-02-01 00:13:08.000000', 'consum', 0.0228, 'lps'),
	(382992, 124, '2015-02-01 00:13:09.000000', 'consum', 0.0223, 'lps'),
	(382993, 124, '2015-02-01 00:13:10.000000', 'consum', 0.0221, 'lps'),
	(382994, 124, '2015-02-01 00:13:11.000000', 'consum', 0.0227, 'lps'),
	(382995, 124, '2015-02-01 00:13:12.000000', 'consum', 0.0220, 'lps'),
	(382996, 124, '2015-02-01 00:13:13.000000', 'consum', 0.0210, 'lps'),
	(382997, 124, '2015-02-01 00:13:14.000000', 'consum', 0.0224, 'lps'),
	(382998, 124, '2015-02-01 00:13:15.000000', 'consum', 0.0215, 'lps'),
	(382999, 124, '2015-02-01 00:13:16.000000', 'consum', 0.0216, 'lps'),
	(383000, 124, '2015-02-01 00:13:17.000000', 'consum', 0.0224, 'lps'),
	(383001, 124, '2015-02-01 00:13:18.000000', 'consum', 0.0222, 'lps'),
	(383002, 124, '2015-02-01 00:13:19.000000', 'consum', 0.0227, 'lps'),
	(383003, 124, '2015-02-01 00:13:20.000000', 'consum', 0.0218, 'lps'),
	(383004, 124, '2015-02-01 00:13:21.000000', 'consum', 0.0222, 'lps'),
	(383005, 124, '2015-02-01 00:13:22.000000', 'consum', 0.0224, 'lps'),
	(383006, 124, '2015-02-01 00:13:23.000000', 'consum', 0.0223, 'lps'),
	(383007, 124, '2015-02-01 00:13:24.000000', 'consum', 0.0214, 'lps'),
	(383008, 124, '2015-02-01 00:13:25.000000', 'consum', 0.0210, 'lps'),
	(383009, 124, '2015-02-01 00:13:26.000000', 'consum', 0.0220, 'lps'),
	(383010, 124, '2015-02-01 00:13:27.000000', 'consum', 0.0220, 'lps'),
	(383011, 124, '2015-02-01 00:13:28.000000', 'consum', 0.0228, 'lps'),
	(383012, 124, '2015-02-01 00:13:29.000000', 'consum', 0.0211, 'lps'),
	(383013, 124, '2015-02-01 00:13:30.000000', 'consum', 0.0222, 'lps'),
	(383014, 124, '2015-02-01 00:13:31.000000', 'consum', 0.0227, 'lps'),
	(383015, 124, '2015-02-01 00:13:32.000000', 'consum', 0.0219, 'lps'),
	(383016, 124, '2015-02-01 00:13:33.000000', 'consum', 0.0223, 'lps'),
	(383017, 124, '2015-02-01 00:13:34.000000', 'consum', 0.0228, 'lps'),
	(383018, 124, '2015-02-01 00:13:35.000000', 'consum', 0.0219, 'lps'),
	(383019, 124, '2015-02-01 00:13:36.000000', 'consum', 0.0222, 'lps'),
	(383020, 124, '2015-02-01 00:13:37.000000', 'consum', 0.0224, 'lps'),
	(383021, 124, '2015-02-01 00:13:38.000000', 'consum', 0.0221, 'lps'),
	(383022, 124, '2015-02-01 00:13:39.000000', 'consum', 0.0226, 'lps'),
	(383023, 124, '2015-02-01 00:13:40.000000', 'consum', 0.0213, 'lps'),
	(383024, 124, '2015-02-01 00:13:41.000000', 'consum', 0.0222, 'lps'),
	(383025, 124, '2015-02-01 00:13:42.000000', 'consum', 0.0220, 'lps'),
	(383026, 124, '2015-02-01 00:13:43.000000', 'consum', 0.0223, 'lps'),
	(383027, 124, '2015-02-01 00:13:44.000000', 'consum', 0.0224, 'lps'),
	(383028, 124, '2015-02-01 00:13:45.000000', 'consum', 0.0221, 'lps'),
	(383029, 124, '2015-02-01 00:13:46.000000', 'consum', 0.0222, 'lps'),
	(383030, 124, '2015-02-01 00:13:47.000000', 'consum', 0.0217, 'lps'),
	(383031, 124, '2015-02-01 00:13:48.000000', 'consum', 0.0211, 'lps'),
	(383032, 124, '2015-02-01 00:13:49.000000', 'consum', 0.0215, 'lps'),
	(383033, 124, '2015-02-01 00:13:50.000000', 'consum', 0.0210, 'lps'),
	(383034, 124, '2015-02-01 00:13:51.000000', 'consum', 0.0217, 'lps'),
	(383035, 124, '2015-02-01 00:13:52.000000', 'consum', 0.0224, 'lps'),
	(383036, 124, '2015-02-01 00:13:53.000000', 'consum', 0.0219, 'lps'),
	(383037, 124, '2015-02-01 00:13:54.000000', 'consum', 0.0211, 'lps'),
	(383038, 124, '2015-02-01 00:13:55.000000', 'consum', 0.0210, 'lps'),
	(383039, 124, '2015-02-01 00:13:56.000000', 'consum', 0.0210, 'lps'),
	(383040, 124, '2015-02-01 00:13:57.000000', 'consum', 0.0229, 'lps'),
	(383041, 124, '2015-02-01 00:13:58.000000', 'consum', 0.0221, 'lps'),
	(383042, 124, '2015-02-01 00:13:59.000000', 'consum', 0.0230, 'lps'),
	(383043, 124, '2015-02-01 00:14:00.000000', 'consum', 0.0216, 'lps'),
	(383044, 124, '2015-02-01 00:14:01.000000', 'consum', 0.0220, 'lps'),
	(383045, 124, '2015-02-01 00:14:02.000000', 'consum', 0.0221, 'lps'),
	(383046, 124, '2015-02-01 00:14:03.000000', 'consum', 0.0217, 'lps'),
	(383047, 124, '2015-02-01 00:14:04.000000', 'consum', 0.0210, 'lps'),
	(383048, 124, '2015-02-01 00:14:05.000000', 'consum', 0.0212, 'lps'),
	(383049, 124, '2015-02-01 00:14:06.000000', 'consum', 0.0221, 'lps'),
	(383050, 124, '2015-02-01 00:14:07.000000', 'consum', 0.0216, 'lps'),
	(383051, 124, '2015-02-01 00:14:08.000000', 'consum', 0.0227, 'lps'),
	(383052, 124, '2015-02-01 00:14:09.000000', 'consum', 0.0218, 'lps'),
	(383053, 124, '2015-02-01 00:14:10.000000', 'consum', 0.0218, 'lps'),
	(383054, 124, '2015-02-01 00:14:11.000000', 'consum', 0.0228, 'lps'),
	(383055, 124, '2015-02-01 00:14:12.000000', 'consum', 0.0212, 'lps'),
	(383056, 124, '2015-02-01 00:14:13.000000', 'consum', 0.0228, 'lps'),
	(383057, 124, '2015-02-01 00:14:14.000000', 'consum', 0.0213, 'lps'),
	(383058, 124, '2015-02-01 00:14:15.000000', 'consum', 0.0214, 'lps'),
	(383059, 124, '2015-02-01 00:14:16.000000', 'consum', 0.0220, 'lps'),
	(383060, 124, '2015-02-01 00:14:17.000000', 'consum', 0.0227, 'lps'),
	(383061, 124, '2015-02-01 00:14:18.000000', 'consum', 0.0225, 'lps'),
	(383062, 124, '2015-02-01 00:14:19.000000', 'consum', 0.0212, 'lps'),
	(383063, 124, '2015-02-01 00:14:20.000000', 'consum', 0.0217, 'lps'),
	(383064, 124, '2015-02-01 00:14:21.000000', 'consum', 0.0221, 'lps'),
	(383065, 124, '2015-02-01 00:14:22.000000', 'consum', 0.0221, 'lps'),
	(383066, 124, '2015-02-01 00:14:23.000000', 'consum', 0.0212, 'lps'),
	(383067, 124, '2015-02-01 00:14:24.000000', 'consum', 0.0230, 'lps'),
	(383068, 124, '2015-02-01 00:14:25.000000', 'consum', 0.0222, 'lps'),
	(383069, 124, '2015-02-01 00:14:26.000000', 'consum', 0.0210, 'lps'),
	(383070, 124, '2015-02-01 00:14:27.000000', 'consum', 0.0218, 'lps'),
	(383071, 124, '2015-02-01 00:14:28.000000', 'consum', 0.0226, 'lps'),
	(383072, 124, '2015-02-01 00:14:29.000000', 'consum', 0.0227, 'lps'),
	(383073, 124, '2015-02-01 00:14:30.000000', 'consum', 0.0225, 'lps'),
	(383074, 124, '2015-02-01 00:14:31.000000', 'consum', 0.0213, 'lps'),
	(383075, 124, '2015-02-01 00:14:32.000000', 'consum', 0.0222, 'lps'),
	(383076, 124, '2015-02-01 00:14:33.000000', 'consum', 0.0220, 'lps'),
	(383077, 124, '2015-02-01 00:14:34.000000', 'consum', 0.0225, 'lps'),
	(383078, 124, '2015-02-01 00:14:35.000000', 'consum', 0.0214, 'lps'),
	(383079, 124, '2015-02-01 00:14:36.000000', 'consum', 0.0225, 'lps'),
	(383080, 124, '2015-02-01 00:14:37.000000', 'consum', 0.0212, 'lps'),
	(383081, 124, '2015-02-01 00:14:38.000000', 'consum', 0.0217, 'lps'),
	(383082, 124, '2015-02-01 00:14:39.000000', 'consum', 0.0220, 'lps'),
	(383083, 124, '2015-02-01 00:14:40.000000', 'consum', 0.0216, 'lps'),
	(383084, 124, '2015-02-01 00:14:41.000000', 'consum', 0.0213, 'lps'),
	(383085, 124, '2015-02-01 00:14:42.000000', 'consum', 0.0229, 'lps'),
	(383086, 124, '2015-02-01 00:14:43.000000', 'consum', 0.0212, 'lps'),
	(383087, 124, '2015-02-01 00:14:44.000000', 'consum', 0.0227, 'lps'),
	(383088, 124, '2015-02-01 00:14:45.000000', 'consum', 0.0227, 'lps'),
	(383089, 124, '2015-02-01 00:14:46.000000', 'consum', 0.0223, 'lps'),
	(383090, 124, '2015-02-01 00:14:47.000000', 'consum', 0.0225, 'lps'),
	(383091, 124, '2015-02-01 00:14:48.000000', 'consum', 0.0227, 'lps'),
	(383092, 124, '2015-02-01 00:14:49.000000', 'consum', 0.0228, 'lps'),
	(383093, 124, '2015-02-01 00:14:50.000000', 'consum', 0.0228, 'lps'),
	(383094, 124, '2015-02-01 00:14:51.000000', 'consum', 0.0227, 'lps'),
	(383095, 124, '2015-02-01 00:14:52.000000', 'consum', 0.0219, 'lps'),
	(383096, 124, '2015-02-01 00:14:53.000000', 'consum', 0.0224, 'lps'),
	(383097, 124, '2015-02-01 00:14:54.000000', 'consum', 0.0214, 'lps'),
	(383098, 124, '2015-02-01 00:14:55.000000', 'consum', 0.0210, 'lps'),
	(383099, 124, '2015-02-01 00:14:56.000000', 'consum', 0.0220, 'lps'),
	(383100, 124, '2015-02-01 00:14:57.000000', 'consum', 0.0217, 'lps'),
	(383101, 124, '2015-02-01 00:14:58.000000', 'consum', 0.0216, 'lps'),
	(383102, 124, '2015-02-01 00:14:59.000000', 'consum', 0.0218, 'lps'),
	(383103, 124, '2015-02-01 00:15:00.000000', 'consum', 0.0212, 'lps'),
	(383104, 124, '2015-02-01 00:15:01.000000', 'consum', 0.0217, 'lps'),
	(383105, 124, '2015-02-01 00:15:02.000000', 'consum', 0.0221, 'lps'),
	(383106, 124, '2015-02-01 00:15:03.000000', 'consum', 0.0221, 'lps'),
	(383107, 124, '2015-02-01 00:15:04.000000', 'consum', 0.0214, 'lps'),
	(383108, 124, '2015-02-01 00:15:05.000000', 'consum', 0.0217, 'lps'),
	(383109, 124, '2015-02-01 00:15:06.000000', 'consum', 0.0214, 'lps'),
	(383110, 124, '2015-02-01 00:15:07.000000', 'consum', 0.0228, 'lps'),
	(383111, 124, '2015-02-01 00:15:08.000000', 'consum', 0.0228, 'lps'),
	(383112, 124, '2015-02-01 00:15:09.000000', 'consum', 0.0226, 'lps'),
	(383113, 124, '2015-02-01 00:15:10.000000', 'consum', 0.0213, 'lps'),
	(383114, 124, '2015-02-01 00:15:11.000000', 'consum', 0.0220, 'lps'),
	(383115, 124, '2015-02-01 00:15:12.000000', 'consum', 0.0229, 'lps'),
	(383116, 124, '2015-02-01 00:15:13.000000', 'consum', 0.0213, 'lps'),
	(383117, 124, '2015-02-01 00:15:14.000000', 'consum', 0.0211, 'lps'),
	(383118, 124, '2015-02-01 00:15:15.000000', 'consum', 0.0228, 'lps'),
	(383119, 124, '2015-02-01 00:15:16.000000', 'consum', 0.0212, 'lps'),
	(383120, 124, '2015-02-01 00:15:17.000000', 'consum', 0.0229, 'lps'),
	(383121, 124, '2015-02-01 00:15:18.000000', 'consum', 0.0216, 'lps'),
	(383122, 124, '2015-02-01 00:15:19.000000', 'consum', 0.0226, 'lps'),
	(383123, 124, '2015-02-01 00:15:20.000000', 'consum', 0.0210, 'lps'),
	(383124, 124, '2015-02-01 00:15:21.000000', 'consum', 0.0225, 'lps'),
	(383125, 124, '2015-02-01 00:15:22.000000', 'consum', 0.0221, 'lps'),
	(383126, 124, '2015-02-01 00:15:23.000000', 'consum', 0.0220, 'lps'),
	(383127, 124, '2015-02-01 00:15:24.000000', 'consum', 0.0227, 'lps'),
	(383128, 124, '2015-02-01 00:15:25.000000', 'consum', 0.0223, 'lps'),
	(383129, 124, '2015-02-01 00:15:26.000000', 'consum', 0.0226, 'lps'),
	(383130, 124, '2015-02-01 00:15:27.000000', 'consum', 0.0230, 'lps'),
	(383131, 124, '2015-02-01 00:15:28.000000', 'consum', 0.0219, 'lps'),
	(383132, 124, '2015-02-01 00:15:29.000000', 'consum', 0.0216, 'lps'),
	(383133, 124, '2015-02-01 00:15:30.000000', 'consum', 0.0214, 'lps'),
	(383134, 124, '2015-02-01 00:15:31.000000', 'consum', 0.0213, 'lps'),
	(383135, 124, '2015-02-01 00:15:32.000000', 'consum', 0.0211, 'lps'),
	(383136, 124, '2015-02-01 00:15:33.000000', 'consum', 0.0210, 'lps'),
	(383137, 124, '2015-02-01 00:15:34.000000', 'consum', 0.0228, 'lps'),
	(383138, 124, '2015-02-01 00:15:35.000000', 'consum', 0.0215, 'lps'),
	(383139, 124, '2015-02-01 00:15:36.000000', 'consum', 0.0225, 'lps'),
	(383140, 124, '2015-02-01 00:15:37.000000', 'consum', 0.0226, 'lps'),
	(383141, 124, '2015-02-01 00:15:38.000000', 'consum', 0.0226, 'lps'),
	(383142, 124, '2015-02-01 00:15:39.000000', 'consum', 0.0223, 'lps'),
	(383143, 124, '2015-02-01 00:15:40.000000', 'consum', 0.0226, 'lps'),
	(383144, 124, '2015-02-01 00:15:41.000000', 'consum', 0.0230, 'lps'),
	(383145, 124, '2015-02-01 00:15:42.000000', 'consum', 0.0222, 'lps'),
	(383146, 124, '2015-02-01 00:15:43.000000', 'consum', 0.0212, 'lps'),
	(383147, 124, '2015-02-01 00:15:44.000000', 'consum', 0.0223, 'lps'),
	(383148, 124, '2015-02-01 00:15:45.000000', 'consum', 0.0228, 'lps'),
	(383149, 124, '2015-02-01 00:15:46.000000', 'consum', 0.0222, 'lps'),
	(383150, 124, '2015-02-01 00:15:47.000000', 'consum', 0.0214, 'lps'),
	(383151, 124, '2015-02-01 00:15:48.000000', 'consum', 0.0215, 'lps'),
	(383152, 124, '2015-02-01 00:15:49.000000', 'consum', 0.0226, 'lps'),
	(383153, 124, '2015-02-01 00:15:50.000000', 'consum', 0.0210, 'lps'),
	(383154, 124, '2015-02-01 00:15:51.000000', 'consum', 0.0226, 'lps'),
	(383155, 124, '2015-02-01 00:15:52.000000', 'consum', 0.0229, 'lps'),
	(383156, 124, '2015-02-01 00:15:53.000000', 'consum', 0.0213, 'lps'),
	(383157, 124, '2015-02-01 00:15:54.000000', 'consum', 0.0211, 'lps'),
	(383158, 124, '2015-02-01 00:15:55.000000', 'consum', 0.0227, 'lps'),
	(383159, 124, '2015-02-01 00:15:56.000000', 'consum', 0.0229, 'lps'),
	(383160, 124, '2015-02-01 00:15:57.000000', 'consum', 0.0212, 'lps'),
	(383161, 124, '2015-02-01 00:15:58.000000', 'consum', 0.0227, 'lps'),
	(383162, 124, '2015-02-01 00:15:59.000000', 'consum', 0.0226, 'lps'),
	(383163, 124, '2015-02-01 00:16:00.000000', 'consum', 0.0220, 'lps'),
	(383164, 124, '2015-02-01 00:16:01.000000', 'consum', 0.0211, 'lps'),
	(383165, 124, '2015-02-01 00:16:02.000000', 'consum', 0.0229, 'lps'),
	(383166, 124, '2015-02-01 00:16:03.000000', 'consum', 0.0219, 'lps'),
	(383167, 124, '2015-02-01 00:16:04.000000', 'consum', 0.0219, 'lps'),
	(383168, 124, '2015-02-01 00:16:05.000000', 'consum', 0.0228, 'lps'),
	(383169, 124, '2015-02-01 00:16:06.000000', 'consum', 0.0211, 'lps'),
	(383170, 124, '2015-02-01 00:16:07.000000', 'consum', 0.0226, 'lps'),
	(383171, 124, '2015-02-01 00:16:08.000000', 'consum', 0.0224, 'lps'),
	(383172, 124, '2015-02-01 00:16:09.000000', 'consum', 0.0211, 'lps'),
	(383173, 124, '2015-02-01 00:16:10.000000', 'consum', 0.0215, 'lps'),
	(383174, 124, '2015-02-01 00:16:11.000000', 'consum', 0.0213, 'lps'),
	(383175, 124, '2015-02-01 00:16:12.000000', 'consum', 0.0230, 'lps'),
	(383176, 124, '2015-02-01 00:16:13.000000', 'consum', 0.0217, 'lps'),
	(383177, 124, '2015-02-01 00:16:14.000000', 'consum', 0.0228, 'lps'),
	(383178, 124, '2015-02-01 00:16:15.000000', 'consum', 0.0218, 'lps'),
	(383179, 124, '2015-02-01 00:16:16.000000', 'consum', 0.0216, 'lps'),
	(383180, 124, '2015-02-01 00:16:17.000000', 'consum', 0.0216, 'lps'),
	(383181, 124, '2015-02-01 00:16:18.000000', 'consum', 0.0221, 'lps'),
	(383182, 124, '2015-02-01 00:16:19.000000', 'consum', 0.0228, 'lps'),
	(383183, 124, '2015-02-01 00:16:20.000000', 'consum', 0.0225, 'lps'),
	(383184, 124, '2015-02-01 00:16:21.000000', 'consum', 0.0211, 'lps'),
	(383185, 124, '2015-02-01 00:16:22.000000', 'consum', 0.0213, 'lps'),
	(383186, 124, '2015-02-01 00:16:23.000000', 'consum', 0.0222, 'lps'),
	(383187, 124, '2015-02-01 00:16:24.000000', 'consum', 0.0218, 'lps'),
	(383188, 124, '2015-02-01 00:16:25.000000', 'consum', 0.0214, 'lps'),
	(383189, 124, '2015-02-01 00:16:26.000000', 'consum', 0.0229, 'lps'),
	(383190, 124, '2015-02-01 00:16:27.000000', 'consum', 0.0230, 'lps'),
	(383191, 124, '2015-02-01 00:16:28.000000', 'consum', 0.0213, 'lps'),
	(383192, 124, '2015-02-01 00:16:29.000000', 'consum', 0.0229, 'lps'),
	(383193, 124, '2015-02-01 00:16:30.000000', 'consum', 0.0212, 'lps'),
	(383194, 124, '2015-02-01 00:16:31.000000', 'consum', 0.0226, 'lps'),
	(383195, 124, '2015-02-01 00:16:32.000000', 'consum', 0.0221, 'lps'),
	(383196, 124, '2015-02-01 00:16:33.000000', 'consum', 0.0219, 'lps'),
	(383197, 124, '2015-02-01 00:16:34.000000', 'consum', 0.0224, 'lps'),
	(383198, 124, '2015-02-01 00:16:35.000000', 'consum', 0.0229, 'lps'),
	(383199, 124, '2015-02-01 00:16:36.000000', 'consum', 0.0223, 'lps'),
	(383200, 124, '2015-02-01 00:16:37.000000', 'consum', 0.0218, 'lps'),
	(383201, 124, '2015-02-01 00:16:38.000000', 'consum', 0.0214, 'lps'),
	(383202, 124, '2015-02-01 00:16:39.000000', 'consum', 0.0224, 'lps'),
	(383203, 124, '2015-02-01 00:16:40.000000', 'consum', 0.0228, 'lps'),
	(383204, 124, '2015-02-01 00:16:41.000000', 'consum', 0.0218, 'lps'),
	(383205, 124, '2015-02-01 00:16:42.000000', 'consum', 0.0218, 'lps'),
	(383206, 124, '2015-02-01 00:16:43.000000', 'consum', 0.0227, 'lps'),
	(383207, 124, '2015-02-01 00:16:44.000000', 'consum', 0.0228, 'lps'),
	(383208, 124, '2015-02-01 00:16:45.000000', 'consum', 0.0227, 'lps'),
	(383209, 124, '2015-02-01 00:16:46.000000', 'consum', 0.0221, 'lps'),
	(383210, 124, '2015-02-01 00:16:47.000000', 'consum', 0.0216, 'lps'),
	(383211, 124, '2015-02-01 00:16:48.000000', 'consum', 0.0227, 'lps'),
	(383212, 124, '2015-02-01 00:16:49.000000', 'consum', 0.0214, 'lps'),
	(383213, 124, '2015-02-01 00:16:50.000000', 'consum', 0.0221, 'lps'),
	(383214, 124, '2015-02-01 00:16:51.000000', 'consum', 0.0214, 'lps'),
	(383215, 124, '2015-02-01 00:16:52.000000', 'consum', 0.0217, 'lps'),
	(383216, 124, '2015-02-01 00:16:53.000000', 'consum', 0.0211, 'lps'),
	(383217, 124, '2015-02-01 00:16:54.000000', 'consum', 0.0215, 'lps'),
	(383218, 124, '2015-02-01 00:16:55.000000', 'consum', 0.0213, 'lps'),
	(383219, 124, '2015-02-01 00:16:56.000000', 'consum', 0.0211, 'lps'),
	(383220, 124, '2015-02-01 00:16:57.000000', 'consum', 0.0227, 'lps'),
	(383221, 124, '2015-02-01 00:16:58.000000', 'consum', 0.0230, 'lps'),
	(383222, 124, '2015-02-01 00:16:59.000000', 'consum', 0.0219, 'lps'),
	(383223, 124, '2015-02-01 00:17:00.000000', 'consum', 0.0216, 'lps'),
	(383224, 124, '2015-02-01 00:17:01.000000', 'consum', 0.0214, 'lps'),
	(383225, 124, '2015-02-01 00:17:02.000000', 'consum', 0.0213, 'lps'),
	(383226, 124, '2015-02-01 00:17:03.000000', 'consum', 0.0211, 'lps'),
	(383227, 124, '2015-02-01 00:17:04.000000', 'consum', 0.0228, 'lps'),
	(383228, 124, '2015-02-01 00:17:05.000000', 'consum', 0.0215, 'lps'),
	(383229, 124, '2015-02-01 00:17:06.000000', 'consum', 0.0225, 'lps'),
	(383230, 124, '2015-02-01 00:17:07.000000', 'consum', 0.0226, 'lps'),
	(383231, 124, '2015-02-01 00:17:08.000000', 'consum', 0.0226, 'lps'),
	(383232, 124, '2015-02-01 00:17:09.000000', 'consum', 0.0221, 'lps'),
	(383233, 124, '2015-02-01 00:17:10.000000', 'consum', 0.0217, 'lps'),
	(383234, 124, '2015-02-01 00:17:11.000000', 'consum', 0.0212, 'lps'),
	(383235, 124, '2015-02-01 00:17:12.000000', 'consum', 0.0219, 'lps'),
	(383236, 124, '2015-02-01 00:17:13.000000', 'consum', 0.0211, 'lps'),
	(383237, 124, '2015-02-01 00:17:14.000000', 'consum', 0.0229, 'lps'),
	(383238, 124, '2015-02-01 00:17:15.000000', 'consum', 0.0220, 'lps'),
	(383239, 124, '2015-02-01 00:17:16.000000', 'consum', 0.0221, 'lps'),
	(383240, 124, '2015-02-01 00:17:17.000000', 'consum', 0.0218, 'lps'),
	(383241, 124, '2015-02-01 00:17:18.000000', 'consum', 0.0218, 'lps'),
	(383242, 124, '2015-02-01 00:17:19.000000', 'consum', 0.0224, 'lps'),
	(383243, 124, '2015-02-01 00:17:20.000000', 'consum', 0.0214, 'lps'),
	(383244, 124, '2015-02-01 00:17:21.000000', 'consum', 0.0210, 'lps'),
	(383245, 124, '2015-02-01 00:17:22.000000', 'consum', 0.0219, 'lps'),
	(383246, 124, '2015-02-01 00:17:23.000000', 'consum', 0.0215, 'lps'),
	(383247, 124, '2015-02-01 00:17:24.000000', 'consum', 0.0230, 'lps'),
	(383248, 124, '2015-02-01 00:17:25.000000', 'consum', 0.0212, 'lps'),
	(383249, 124, '2015-02-01 00:17:26.000000', 'consum', 0.0223, 'lps'),
	(383250, 124, '2015-02-01 00:17:27.000000', 'consum', 0.0227, 'lps'),
	(383251, 124, '2015-02-01 00:17:28.000000', 'consum', 0.0215, 'lps'),
	(383252, 124, '2015-02-01 00:17:29.000000', 'consum', 0.0228, 'lps'),
	(383253, 124, '2015-02-01 00:17:30.000000', 'consum', 0.0223, 'lps'),
	(383254, 124, '2015-02-01 00:17:31.000000', 'consum', 0.0220, 'lps'),
	(383255, 124, '2015-02-01 00:17:32.000000', 'consum', 0.0223, 'lps'),
	(383256, 124, '2015-02-01 00:17:33.000000', 'consum', 0.0223, 'lps'),
	(383257, 124, '2015-02-01 00:17:34.000000', 'consum', 0.0218, 'lps'),
	(383258, 124, '2015-02-01 00:17:35.000000', 'consum', 0.0229, 'lps'),
	(383259, 124, '2015-02-01 00:17:36.000000', 'consum', 0.0222, 'lps'),
	(383260, 124, '2015-02-01 00:17:37.000000', 'consum', 0.0210, 'lps'),
	(383261, 124, '2015-02-01 00:17:38.000000', 'consum', 0.0220, 'lps'),
	(383262, 124, '2015-02-01 00:17:39.000000', 'consum', 0.0217, 'lps'),
	(383263, 124, '2015-02-01 00:17:40.000000', 'consum', 0.0215, 'lps'),
	(383264, 124, '2015-02-01 00:17:41.000000', 'consum', 0.0213, 'lps'),
	(383265, 124, '2015-02-01 00:17:42.000000', 'consum', 0.0212, 'lps'),
	(383266, 124, '2015-02-01 00:17:43.000000', 'consum', 0.0212, 'lps'),
	(383267, 124, '2015-02-01 00:17:44.000000', 'consum', 0.0213, 'lps'),
	(383268, 124, '2015-02-01 00:17:45.000000', 'consum', 0.0221, 'lps'),
	(383269, 124, '2015-02-01 00:17:46.000000', 'consum', 0.0213, 'lps'),
	(383270, 124, '2015-02-01 00:17:47.000000', 'consum', 0.0216, 'lps'),
	(383271, 124, '2015-02-01 00:17:48.000000', 'consum', 0.0230, 'lps'),
	(383272, 124, '2015-02-01 00:17:49.000000', 'consum', 0.0228, 'lps'),
	(383273, 124, '2015-02-01 00:17:50.000000', 'consum', 0.0219, 'lps'),
	(383274, 124, '2015-02-01 00:17:51.000000', 'consum', 0.0225, 'lps'),
	(383275, 124, '2015-02-01 00:17:52.000000', 'consum', 0.0214, 'lps'),
	(383276, 124, '2015-02-01 00:17:53.000000', 'consum', 0.0228, 'lps'),
	(383277, 124, '2015-02-01 00:17:54.000000', 'consum', 0.0226, 'lps'),
	(383278, 124, '2015-02-01 00:17:55.000000', 'consum', 0.0213, 'lps'),
	(383279, 124, '2015-02-01 00:17:56.000000', 'consum', 0.0223, 'lps'),
	(383280, 124, '2015-02-01 00:17:57.000000', 'consum', 0.0222, 'lps'),
	(383281, 124, '2015-02-01 00:17:58.000000', 'consum', 0.0212, 'lps'),
	(383282, 124, '2015-02-01 00:17:59.000000', 'consum', 0.0226, 'lps'),
	(383283, 124, '2015-02-01 00:18:00.000000', 'consum', 0.0220, 'lps'),
	(383284, 124, '2015-02-01 00:18:01.000000', 'consum', 0.0214, 'lps'),
	(383285, 124, '2015-02-01 00:18:02.000000', 'consum', 0.0221, 'lps'),
	(383286, 124, '2015-02-01 00:18:03.000000', 'consum', 0.0211, 'lps'),
	(383287, 124, '2015-02-01 00:18:04.000000', 'consum', 0.0226, 'lps'),
	(383288, 124, '2015-02-01 00:18:05.000000', 'consum', 0.0226, 'lps'),
	(383289, 124, '2015-02-01 00:18:06.000000', 'consum', 0.0218, 'lps'),
	(383290, 124, '2015-02-01 00:18:07.000000', 'consum', 0.0224, 'lps'),
	(383291, 124, '2015-02-01 00:18:08.000000', 'consum', 0.0217, 'lps'),
	(383292, 124, '2015-02-01 00:18:09.000000', 'consum', 0.0223, 'lps'),
	(383293, 124, '2015-02-01 00:18:10.000000', 'consum', 0.0211, 'lps'),
	(383294, 124, '2015-02-01 00:18:11.000000', 'consum', 0.0220, 'lps'),
	(383295, 124, '2015-02-01 00:18:12.000000', 'consum', 0.0216, 'lps'),
	(383296, 124, '2015-02-01 00:18:13.000000', 'consum', 0.0230, 'lps'),
	(383297, 124, '2015-02-01 00:18:14.000000', 'consum', 0.0228, 'lps'),
	(383298, 124, '2015-02-01 00:18:15.000000', 'consum', 0.0223, 'lps'),
	(383299, 124, '2015-02-01 00:18:16.000000', 'consum', 0.0220, 'lps'),
	(383300, 124, '2015-02-01 00:18:17.000000', 'consum', 0.0222, 'lps'),
	(383301, 124, '2015-02-01 00:18:18.000000', 'consum', 0.0218, 'lps'),
	(383302, 124, '2015-02-01 00:18:19.000000', 'consum', 0.0216, 'lps'),
	(383303, 124, '2015-02-01 00:18:20.000000', 'consum', 0.0215, 'lps'),
	(383304, 124, '2015-02-01 00:18:21.000000', 'consum', 0.0219, 'lps'),
	(383305, 124, '2015-02-01 00:18:22.000000', 'consum', 0.0220, 'lps'),
	(383306, 124, '2015-02-01 00:18:23.000000', 'consum', 0.0212, 'lps'),
	(383307, 124, '2015-02-01 00:18:24.000000', 'consum', 0.0212, 'lps'),
	(383308, 124, '2015-02-01 00:18:25.000000', 'consum', 0.0213, 'lps'),
	(383309, 124, '2015-02-01 00:18:26.000000', 'consum', 0.0222, 'lps'),
	(383310, 124, '2015-02-01 00:18:27.000000', 'consum', 0.0218, 'lps'),
	(383311, 124, '2015-02-01 00:18:28.000000', 'consum', 0.0215, 'lps'),
	(383312, 124, '2015-02-01 00:18:29.000000', 'consum', 0.0211, 'lps'),
	(383313, 124, '2015-02-01 00:18:30.000000', 'consum', 0.0223, 'lps'),
	(383314, 124, '2015-02-01 00:18:31.000000', 'consum', 0.0228, 'lps'),
	(383315, 124, '2015-02-01 00:18:32.000000', 'consum', 0.0218, 'lps'),
	(383316, 124, '2015-02-01 00:18:33.000000', 'consum', 0.0221, 'lps'),
	(383317, 124, '2015-02-01 00:18:34.000000', 'consum', 0.0221, 'lps'),
	(383318, 124, '2015-02-01 00:18:35.000000', 'consum', 0.0211, 'lps'),
	(383319, 124, '2015-02-01 00:18:36.000000', 'consum', 0.0224, 'lps'),
	(383320, 124, '2015-02-01 00:18:37.000000', 'consum', 0.0214, 'lps'),
	(383321, 124, '2015-02-01 00:18:38.000000', 'consum', 0.0229, 'lps'),
	(383322, 124, '2015-02-01 00:18:39.000000', 'consum', 0.0212, 'lps'),
	(383323, 124, '2015-02-01 00:18:40.000000', 'consum', 0.0227, 'lps'),
	(383324, 124, '2015-02-01 00:18:41.000000', 'consum', 0.0224, 'lps'),
	(383325, 124, '2015-02-01 00:18:42.000000', 'consum', 0.0210, 'lps'),
	(383326, 124, '2015-02-01 00:18:43.000000', 'consum', 0.0212, 'lps'),
	(383327, 124, '2015-02-01 00:18:44.000000', 'consum', 0.0217, 'lps'),
	(383328, 124, '2015-02-01 00:18:45.000000', 'consum', 0.0222, 'lps'),
	(383329, 124, '2015-02-01 00:18:46.000000', 'consum', 0.0225, 'lps'),
	(383330, 124, '2015-02-01 00:18:47.000000', 'consum', 0.0210, 'lps'),
	(383331, 124, '2015-02-01 00:18:48.000000', 'consum', 0.0227, 'lps'),
	(383332, 124, '2015-02-01 00:18:49.000000', 'consum', 0.0214, 'lps'),
	(383333, 124, '2015-02-01 00:18:50.000000', 'consum', 0.0221, 'lps'),
	(383334, 124, '2015-02-01 00:18:51.000000', 'consum', 0.0210, 'lps'),
	(383335, 124, '2015-02-01 00:18:52.000000', 'consum', 0.0221, 'lps'),
	(383336, 124, '2015-02-01 00:18:53.000000', 'consum', 0.0223, 'lps'),
	(383337, 124, '2015-02-01 00:18:54.000000', 'consum', 0.0222, 'lps'),
	(383338, 124, '2015-02-01 00:18:55.000000', 'consum', 0.0211, 'lps'),
	(383339, 124, '2015-02-01 00:18:56.000000', 'consum', 0.0222, 'lps'),
	(383340, 124, '2015-02-01 00:18:57.000000', 'consum', 0.0223, 'lps'),
	(383341, 124, '2015-02-01 00:18:58.000000', 'consum', 0.0221, 'lps'),
	(383342, 124, '2015-02-01 00:18:59.000000', 'consum', 0.0226, 'lps'),
	(383343, 124, '2015-02-01 00:19:00.000000', 'consum', 0.0214, 'lps'),
	(383344, 124, '2015-02-01 00:19:01.000000', 'consum', 0.0226, 'lps'),
	(383345, 124, '2015-02-01 00:19:02.000000', 'consum', 0.0215, 'lps'),
	(383346, 124, '2015-02-01 00:19:03.000000', 'consum', 0.0230, 'lps'),
	(383347, 124, '2015-02-01 00:19:04.000000', 'consum', 0.0212, 'lps'),
	(383348, 124, '2015-02-01 00:19:05.000000', 'consum', 0.0221, 'lps'),
	(383349, 124, '2015-02-01 00:19:06.000000', 'consum', 0.0219, 'lps'),
	(383350, 124, '2015-02-01 00:19:07.000000', 'consum', 0.0221, 'lps'),
	(383351, 124, '2015-02-01 00:19:08.000000', 'consum', 0.0220, 'lps'),
	(383352, 124, '2015-02-01 00:19:09.000000', 'consum', 0.0227, 'lps'),
	(383353, 124, '2015-02-01 00:19:10.000000', 'consum', 0.0221, 'lps'),
	(383354, 124, '2015-02-01 00:19:11.000000', 'consum', 0.0218, 'lps'),
	(383355, 124, '2015-02-01 00:19:12.000000', 'consum', 0.0216, 'lps'),
	(383356, 124, '2015-02-01 00:19:13.000000', 'consum', 0.0217, 'lps'),
	(383357, 124, '2015-02-01 00:19:14.000000', 'consum', 0.0227, 'lps'),
	(383358, 124, '2015-02-01 00:19:15.000000', 'consum', 0.0211, 'lps'),
	(383359, 124, '2015-02-01 00:19:16.000000', 'consum', 0.0227, 'lps'),
	(383360, 124, '2015-02-01 00:19:17.000000', 'consum', 0.0210, 'lps'),
	(383361, 124, '2015-02-01 00:19:18.000000', 'consum', 0.0221, 'lps'),
	(383362, 124, '2015-02-01 00:19:19.000000', 'consum', 0.0225, 'lps'),
	(383363, 124, '2015-02-01 00:19:20.000000', 'consum', 0.0212, 'lps'),
	(383364, 124, '2015-02-01 00:19:21.000000', 'consum', 0.0215, 'lps'),
	(383365, 124, '2015-02-01 00:19:22.000000', 'consum', 0.0210, 'lps'),
	(383366, 124, '2015-02-01 00:19:23.000000', 'consum', 0.0215, 'lps'),
	(383367, 124, '2015-02-01 00:19:24.000000', 'consum', 0.0217, 'lps'),
	(383368, 124, '2015-02-01 00:19:25.000000', 'consum', 0.0227, 'lps'),
	(383369, 124, '2015-02-01 00:19:26.000000', 'consum', 0.0214, 'lps'),
	(383370, 124, '2015-02-01 00:19:27.000000', 'consum', 0.0221, 'lps'),
	(383371, 124, '2015-02-01 00:19:28.000000', 'consum', 0.0212, 'lps'),
	(383372, 124, '2015-02-01 00:19:29.000000', 'consum', 0.0228, 'lps'),
	(383373, 124, '2015-02-01 00:19:30.000000', 'consum', 0.0211, 'lps'),
	(383374, 124, '2015-02-01 00:19:31.000000', 'consum', 0.0224, 'lps'),
	(383375, 124, '2015-02-01 00:19:32.000000', 'consum', 0.0215, 'lps'),
	(383376, 124, '2015-02-01 00:19:33.000000', 'consum', 0.0215, 'lps'),
	(383377, 124, '2015-02-01 00:19:34.000000', 'consum', 0.0219, 'lps'),
	(383378, 124, '2015-02-01 00:19:35.000000', 'consum', 0.0221, 'lps'),
	(383379, 124, '2015-02-01 00:19:36.000000', 'consum', 0.0217, 'lps'),
	(383380, 124, '2015-02-01 00:19:37.000000', 'consum', 0.0211, 'lps'),
	(383381, 124, '2015-02-01 00:19:38.000000', 'consum', 0.0218, 'lps'),
	(383382, 124, '2015-02-01 00:19:39.000000', 'consum', 0.0226, 'lps'),
	(383383, 124, '2015-02-01 00:19:40.000000', 'consum', 0.0224, 'lps'),
	(383384, 124, '2015-02-01 00:19:41.000000', 'consum', 0.0214, 'lps'),
	(383385, 124, '2015-02-01 00:19:42.000000', 'consum', 0.0227, 'lps'),
	(383386, 124, '2015-02-01 00:19:43.000000', 'consum', 0.0223, 'lps'),
	(383387, 124, '2015-02-01 00:19:44.000000', 'consum', 0.0222, 'lps'),
	(383388, 124, '2015-02-01 00:19:45.000000', 'consum', 0.0214, 'lps'),
	(383389, 124, '2015-02-01 00:19:46.000000', 'consum', 0.0212, 'lps'),
	(383390, 124, '2015-02-01 00:19:47.000000', 'consum', 0.0210, 'lps'),
	(383391, 124, '2015-02-01 00:19:48.000000', 'consum', 0.0224, 'lps'),
	(383392, 124, '2015-02-01 00:19:49.000000', 'consum', 0.0217, 'lps'),
	(383393, 124, '2015-02-01 00:19:50.000000', 'consum', 0.0227, 'lps'),
	(383394, 124, '2015-02-01 00:19:51.000000', 'consum', 0.0210, 'lps'),
	(383395, 124, '2015-02-01 00:19:52.000000', 'consum', 0.0224, 'lps'),
	(383396, 124, '2015-02-01 00:19:53.000000', 'consum', 0.0216, 'lps'),
	(383397, 124, '2015-02-01 00:19:54.000000', 'consum', 0.0219, 'lps'),
	(383398, 124, '2015-02-01 00:19:55.000000', 'consum', 0.0215, 'lps'),
	(383399, 124, '2015-02-01 00:19:56.000000', 'consum', 0.0211, 'lps'),
	(383400, 124, '2015-02-01 00:19:57.000000', 'consum', 0.0221, 'lps'),
	(383401, 124, '2015-02-01 00:19:58.000000', 'consum', 0.0218, 'lps'),
	(383402, 124, '2015-02-01 00:19:59.000000', 'consum', 0.0221, 'lps'),
	(383403, 124, '2015-02-01 00:20:00.000000', 'consum', 0.0219, 'lps'),
	(383404, 124, '2015-02-01 00:20:01.000000', 'consum', 0.0224, 'lps'),
	(383405, 124, '2015-02-01 00:20:02.000000', 'consum', 0.0230, 'lps'),
	(383406, 124, '2015-02-01 00:20:03.000000', 'consum', 0.0226, 'lps'),
	(383407, 124, '2015-02-01 00:20:04.000000', 'consum', 0.0211, 'lps'),
	(383408, 124, '2015-02-01 00:20:05.000000', 'consum', 0.0210, 'lps'),
	(383409, 124, '2015-02-01 00:20:06.000000', 'consum', 0.0227, 'lps'),
	(383410, 124, '2015-02-01 00:20:07.000000', 'consum', 0.0210, 'lps'),
	(383411, 124, '2015-02-01 00:20:08.000000', 'consum', 0.0224, 'lps'),
	(383412, 124, '2015-02-01 00:20:09.000000', 'consum', 0.0220, 'lps'),
	(383413, 124, '2015-02-01 00:20:10.000000', 'consum', 0.0215, 'lps'),
	(383414, 124, '2015-02-01 00:20:11.000000', 'consum', 0.0227, 'lps'),
	(383415, 124, '2015-02-01 00:20:12.000000', 'consum', 0.0218, 'lps'),
	(383416, 124, '2015-02-01 00:20:13.000000', 'consum', 0.0220, 'lps'),
	(383417, 124, '2015-02-01 00:20:14.000000', 'consum', 0.0214, 'lps'),
	(383418, 124, '2015-02-01 00:20:15.000000', 'consum', 0.0222, 'lps'),
	(383419, 124, '2015-02-01 00:20:16.000000', 'consum', 0.0216, 'lps'),
	(383420, 124, '2015-02-01 00:20:17.000000', 'consum', 0.0225, 'lps'),
	(383421, 124, '2015-02-01 00:20:18.000000', 'consum', 0.0228, 'lps'),
	(383422, 124, '2015-02-01 00:20:19.000000', 'consum', 0.0211, 'lps'),
	(383423, 124, '2015-02-01 00:20:20.000000', 'consum', 0.0225, 'lps'),
	(383424, 124, '2015-02-01 00:20:21.000000', 'consum', 0.0219, 'lps'),
	(383425, 124, '2015-02-01 00:20:22.000000', 'consum', 0.0210, 'lps'),
	(383426, 124, '2015-02-01 00:20:23.000000', 'consum', 0.0227, 'lps'),
	(383427, 124, '2015-02-01 00:20:24.000000', 'consum', 0.0212, 'lps'),
	(383428, 124, '2015-02-01 00:20:25.000000', 'consum', 0.0212, 'lps'),
	(383429, 124, '2015-02-01 00:20:26.000000', 'consum', 0.0215, 'lps'),
	(383430, 124, '2015-02-01 00:20:27.000000', 'consum', 0.0228, 'lps'),
	(383431, 124, '2015-02-01 00:20:28.000000', 'consum', 0.0223, 'lps'),
	(383432, 124, '2015-02-01 00:20:29.000000', 'consum', 0.0222, 'lps'),
	(383433, 124, '2015-02-01 00:20:30.000000', 'consum', 0.0212, 'lps'),
	(383434, 124, '2015-02-01 00:20:31.000000', 'consum', 0.0224, 'lps'),
	(383435, 124, '2015-02-01 00:20:32.000000', 'consum', 0.0213, 'lps'),
	(383436, 124, '2015-02-01 00:20:33.000000', 'consum', 0.0226, 'lps'),
	(383437, 124, '2015-02-01 00:20:34.000000', 'consum', 0.0219, 'lps'),
	(383438, 124, '2015-02-01 00:20:35.000000', 'consum', 0.0228, 'lps'),
	(383439, 124, '2015-02-01 00:20:36.000000', 'consum', 0.0212, 'lps'),
	(383440, 124, '2015-02-01 00:20:37.000000', 'consum', 0.0227, 'lps'),
	(383441, 124, '2015-02-01 00:20:38.000000', 'consum', 0.0226, 'lps'),
	(383442, 124, '2015-02-01 00:20:39.000000', 'consum', 0.0220, 'lps'),
	(383443, 124, '2015-02-01 00:20:40.000000', 'consum', 0.0211, 'lps'),
	(383444, 124, '2015-02-01 00:20:41.000000', 'consum', 0.0227, 'lps'),
	(383445, 124, '2015-02-01 00:20:42.000000', 'consum', 0.0230, 'lps'),
	(383446, 124, '2015-02-01 00:20:43.000000', 'consum', 0.0216, 'lps'),
	(383447, 124, '2015-02-01 00:20:44.000000', 'consum', 0.0224, 'lps'),
	(383448, 124, '2015-02-01 00:20:45.000000', 'consum', 0.0220, 'lps'),
	(383449, 124, '2015-02-01 00:20:46.000000', 'consum', 0.0217, 'lps'),
	(383450, 124, '2015-02-01 00:20:47.000000', 'consum', 0.0218, 'lps'),
	(383451, 124, '2015-02-01 00:20:48.000000', 'consum', 0.0230, 'lps'),
	(383452, 124, '2015-02-01 00:20:49.000000', 'consum', 0.0223, 'lps'),
	(383453, 124, '2015-02-01 00:20:50.000000', 'consum', 0.0213, 'lps'),
	(383454, 124, '2015-02-01 00:20:51.000000', 'consum', 0.0230, 'lps'),
	(383455, 124, '2015-02-01 00:20:52.000000', 'consum', 0.0218, 'lps'),
	(383456, 124, '2015-02-01 00:20:53.000000', 'consum', 0.0212, 'lps'),
	(383457, 124, '2015-02-01 00:20:54.000000', 'consum', 0.0215, 'lps'),
	(383458, 124, '2015-02-01 00:20:55.000000', 'consum', 0.0211, 'lps'),
	(383459, 124, '2015-02-01 00:20:56.000000', 'consum', 0.0223, 'lps'),
	(383460, 124, '2015-02-01 00:20:57.000000', 'consum', 0.0227, 'lps'),
	(383461, 124, '2015-02-01 00:20:58.000000', 'consum', 0.0215, 'lps'),
	(383462, 124, '2015-02-01 00:20:59.000000', 'consum', 0.0227, 'lps'),
	(383463, 124, '2015-02-01 00:21:00.000000', 'consum', 0.0217, 'lps'),
	(383464, 124, '2015-02-01 00:21:01.000000', 'consum', 0.0215, 'lps'),
	(383465, 124, '2015-02-01 00:21:02.000000', 'consum', 0.0214, 'lps'),
	(383466, 124, '2015-02-01 00:21:03.000000', 'consum', 0.0217, 'lps'),
	(383467, 124, '2015-02-01 00:21:04.000000', 'consum', 0.0211, 'lps'),
	(383468, 124, '2015-02-01 00:21:05.000000', 'consum', 0.0216, 'lps'),
	(383469, 124, '2015-02-01 00:21:06.000000', 'consum', 0.0217, 'lps'),
	(383470, 124, '2015-02-01 00:21:07.000000', 'consum', 0.0227, 'lps'),
	(383471, 124, '2015-02-01 00:21:08.000000', 'consum', 0.0211, 'lps'),
	(383472, 124, '2015-02-01 00:21:09.000000', 'consum', 0.0228, 'lps'),
	(383473, 124, '2015-02-01 00:21:10.000000', 'consum', 0.0212, 'lps'),
	(383474, 124, '2015-02-01 00:21:11.000000', 'consum', 0.0211, 'lps'),
	(383475, 124, '2015-02-01 00:21:12.000000', 'consum', 0.0210, 'lps'),
	(383476, 124, '2015-02-01 00:21:13.000000', 'consum', 0.0226, 'lps'),
	(383477, 124, '2015-02-01 00:21:14.000000', 'consum', 0.0227, 'lps'),
	(383478, 124, '2015-02-01 00:21:15.000000', 'consum', 0.0228, 'lps'),
	(383479, 124, '2015-02-01 00:21:16.000000', 'consum', 0.0227, 'lps'),
	(383480, 124, '2015-02-01 00:21:17.000000', 'consum', 0.0222, 'lps'),
	(383481, 124, '2015-02-01 00:21:18.000000', 'consum', 0.0218, 'lps'),
	(383482, 124, '2015-02-01 00:21:19.000000', 'consum', 0.0214, 'lps'),
	(383483, 124, '2015-02-01 00:21:20.000000', 'consum', 0.0228, 'lps'),
	(383484, 124, '2015-02-01 00:21:21.000000', 'consum', 0.0226, 'lps'),
	(383485, 124, '2015-02-01 00:21:22.000000', 'consum', 0.0217, 'lps'),
	(383486, 124, '2015-02-01 00:21:23.000000', 'consum', 0.0216, 'lps'),
	(383487, 124, '2015-02-01 00:21:24.000000', 'consum', 0.0220, 'lps'),
	(383488, 124, '2015-02-01 00:21:25.000000', 'consum', 0.0220, 'lps'),
	(383489, 124, '2015-02-01 00:21:26.000000', 'consum', 0.0210, 'lps'),
	(383490, 124, '2015-02-01 00:21:27.000000', 'consum', 0.0225, 'lps'),
	(383491, 124, '2015-02-01 00:21:28.000000', 'consum', 0.0220, 'lps'),
	(383492, 124, '2015-02-01 00:21:29.000000', 'consum', 0.0215, 'lps'),
	(383493, 124, '2015-02-01 00:21:30.000000', 'consum', 0.0227, 'lps'),
	(383494, 124, '2015-02-01 00:21:31.000000', 'consum', 0.0219, 'lps'),
	(383495, 124, '2015-02-01 00:21:32.000000', 'consum', 0.0223, 'lps'),
	(383496, 124, '2015-02-01 00:21:33.000000', 'consum', 0.0230, 'lps'),
	(383497, 124, '2015-02-01 00:21:34.000000', 'consum', 0.0230, 'lps'),
	(383498, 124, '2015-02-01 00:21:35.000000', 'consum', 0.0230, 'lps'),
	(383499, 124, '2015-02-01 00:21:36.000000', 'consum', 0.0227, 'lps'),
	(383500, 124, '2015-02-01 00:21:37.000000', 'consum', 0.0218, 'lps'),
	(383501, 124, '2015-02-01 00:21:38.000000', 'consum', 0.0217, 'lps'),
	(383502, 124, '2015-02-01 00:21:39.000000', 'consum', 0.0224, 'lps'),
	(383503, 124, '2015-02-01 00:21:40.000000', 'consum', 0.0215, 'lps'),
	(383504, 124, '2015-02-01 00:21:41.000000', 'consum', 0.0216, 'lps'),
	(383505, 124, '2015-02-01 00:21:42.000000', 'consum', 0.0227, 'lps'),
	(383506, 124, '2015-02-01 00:21:43.000000', 'consum', 0.0212, 'lps'),
	(383507, 124, '2015-02-01 00:21:44.000000', 'consum', 0.0211, 'lps'),
	(383508, 124, '2015-02-01 00:21:45.000000', 'consum', 0.0211, 'lps'),
	(383509, 124, '2015-02-01 00:21:46.000000', 'consum', 0.0213, 'lps'),
	(383510, 124, '2015-02-01 00:21:47.000000', 'consum', 0.0223, 'lps'),
	(383511, 124, '2015-02-01 00:21:48.000000', 'consum', 0.0224, 'lps'),
	(383512, 124, '2015-02-01 00:21:49.000000', 'consum', 0.0221, 'lps'),
	(383513, 124, '2015-02-01 00:21:50.000000', 'consum', 0.0224, 'lps'),
	(383514, 124, '2015-02-01 00:21:51.000000', 'consum', 0.0226, 'lps'),
	(383515, 124, '2015-02-01 00:21:52.000000', 'consum', 0.0229, 'lps'),
	(383516, 124, '2015-02-01 00:21:53.000000', 'consum', 0.0215, 'lps'),
	(383517, 124, '2015-02-01 00:21:54.000000', 'consum', 0.0219, 'lps'),
	(383518, 124, '2015-02-01 00:21:55.000000', 'consum', 0.0219, 'lps'),
	(383519, 124, '2015-02-01 00:21:56.000000', 'consum', 0.0228, 'lps'),
	(383520, 124, '2015-02-01 00:21:57.000000', 'consum', 0.0213, 'lps'),
	(383521, 124, '2015-02-01 00:21:58.000000', 'consum', 0.0213, 'lps'),
	(383522, 124, '2015-02-01 00:21:59.000000', 'consum', 0.0215, 'lps'),
	(383523, 124, '2015-02-01 00:22:00.000000', 'consum', 0.0227, 'lps'),
	(383524, 124, '2015-02-01 00:22:01.000000', 'consum', 0.0219, 'lps'),
	(383525, 124, '2015-02-01 00:22:02.000000', 'consum', 0.0226, 'lps'),
	(383526, 124, '2015-02-01 00:22:03.000000', 'consum', 0.0219, 'lps'),
	(383527, 124, '2015-02-01 00:22:04.000000', 'consum', 0.0230, 'lps'),
	(383528, 124, '2015-02-01 00:22:05.000000', 'consum', 0.0219, 'lps'),
	(383529, 124, '2015-02-01 00:22:06.000000', 'consum', 0.0219, 'lps'),
	(383530, 124, '2015-02-01 00:22:07.000000', 'consum', 0.0228, 'lps'),
	(383531, 124, '2015-02-01 00:22:08.000000', 'consum', 0.0211, 'lps'),
	(383532, 124, '2015-02-01 00:22:09.000000', 'consum', 0.0222, 'lps'),
	(383533, 124, '2015-02-01 00:22:10.000000', 'consum', 0.0226, 'lps'),
	(383534, 124, '2015-02-01 00:22:11.000000', 'consum', 0.0214, 'lps'),
	(383535, 124, '2015-02-01 00:22:12.000000', 'consum', 0.0224, 'lps'),
	(383536, 124, '2015-02-01 00:22:13.000000', 'consum', 0.0225, 'lps'),
	(383537, 124, '2015-02-01 00:22:14.000000', 'consum', 0.0222, 'lps'),
	(383538, 124, '2015-02-01 00:22:15.000000', 'consum', 0.0227, 'lps'),
	(383539, 124, '2015-02-01 00:22:16.000000', 'consum', 0.0216, 'lps'),
	(383540, 124, '2015-02-01 00:22:17.000000', 'consum', 0.0210, 'lps'),
	(383541, 124, '2015-02-01 00:22:18.000000', 'consum', 0.0213, 'lps'),
	(383542, 124, '2015-02-01 00:22:19.000000', 'consum', 0.0227, 'lps'),
	(383543, 124, '2015-02-01 00:22:20.000000', 'consum', 0.0224, 'lps'),
	(383544, 124, '2015-02-01 00:22:21.000000', 'consum', 0.0227, 'lps'),
	(383545, 124, '2015-02-01 00:22:22.000000', 'consum', 0.0214, 'lps'),
	(383546, 124, '2015-02-01 00:22:23.000000', 'consum', 0.0221, 'lps'),
	(383547, 124, '2015-02-01 00:22:24.000000', 'consum', 0.0210, 'lps'),
	(383548, 124, '2015-02-01 00:22:25.000000', 'consum', 0.0222, 'lps'),
	(383549, 124, '2015-02-01 00:22:26.000000', 'consum', 0.0226, 'lps'),
	(383550, 124, '2015-02-01 00:22:27.000000', 'consum', 0.0212, 'lps'),
	(383551, 124, '2015-02-01 00:22:28.000000', 'consum', 0.0213, 'lps'),
	(383552, 124, '2015-02-01 00:22:29.000000', 'consum', 0.0223, 'lps'),
	(383553, 124, '2015-02-01 00:22:30.000000', 'consum', 0.0224, 'lps'),
	(383554, 124, '2015-02-01 00:22:31.000000', 'consum', 0.0221, 'lps'),
	(383555, 124, '2015-02-01 00:22:32.000000', 'consum', 0.0223, 'lps'),
	(383556, 124, '2015-02-01 00:22:33.000000', 'consum', 0.0224, 'lps'),
	(383557, 124, '2015-02-01 00:22:34.000000', 'consum', 0.0217, 'lps'),
	(383558, 124, '2015-02-01 00:22:35.000000', 'consum', 0.0224, 'lps'),
	(383559, 124, '2015-02-01 00:22:36.000000', 'consum', 0.0217, 'lps'),
	(383560, 124, '2015-02-01 00:22:37.000000', 'consum', 0.0227, 'lps'),
	(383561, 124, '2015-02-01 00:22:38.000000', 'consum', 0.0212, 'lps'),
	(383562, 124, '2015-02-01 00:22:39.000000', 'consum', 0.0210, 'lps'),
	(383563, 124, '2015-02-01 00:22:40.000000', 'consum', 0.0227, 'lps'),
	(383564, 124, '2015-02-01 00:22:41.000000', 'consum', 0.0212, 'lps'),
	(383565, 124, '2015-02-01 00:22:42.000000', 'consum', 0.0210, 'lps'),
	(383566, 124, '2015-02-01 00:22:43.000000', 'consum', 0.0225, 'lps'),
	(383567, 124, '2015-02-01 00:22:44.000000', 'consum', 0.0225, 'lps'),
	(383568, 124, '2015-02-01 00:22:45.000000', 'consum', 0.0216, 'lps'),
	(383569, 124, '2015-02-01 00:22:46.000000', 'consum', 0.0220, 'lps'),
	(383570, 124, '2015-02-01 00:22:47.000000', 'consum', 0.0218, 'lps'),
	(383571, 124, '2015-02-01 00:22:48.000000', 'consum', 0.0222, 'lps'),
	(383572, 124, '2015-02-01 00:22:49.000000', 'consum', 0.0227, 'lps'),
	(383573, 124, '2015-02-01 00:22:50.000000', 'consum', 0.0216, 'lps'),
	(383574, 124, '2015-02-01 00:22:51.000000', 'consum', 0.0212, 'lps'),
	(383575, 124, '2015-02-01 00:22:52.000000', 'consum', 0.0222, 'lps'),
	(383576, 124, '2015-02-01 00:22:53.000000', 'consum', 0.0223, 'lps'),
	(383577, 124, '2015-02-01 00:22:54.000000', 'consum', 0.0220, 'lps'),
	(383578, 124, '2015-02-01 00:22:55.000000', 'consum', 0.0220, 'lps'),
	(383579, 124, '2015-02-01 00:22:56.000000', 'consum', 0.0229, 'lps'),
	(383580, 124, '2015-02-01 00:22:57.000000', 'consum', 0.0213, 'lps'),
	(383581, 124, '2015-02-01 00:22:58.000000', 'consum', 0.0211, 'lps'),
	(383582, 124, '2015-02-01 00:22:59.000000', 'consum', 0.0229, 'lps'),
	(383583, 124, '2015-02-01 00:23:00.000000', 'consum', 0.0218, 'lps'),
	(383584, 124, '2015-02-01 00:23:01.000000', 'consum', 0.0216, 'lps'),
	(383585, 124, '2015-02-01 00:23:02.000000', 'consum', 0.0216, 'lps'),
	(383586, 124, '2015-02-01 00:23:03.000000', 'consum', 0.0221, 'lps'),
	(383587, 124, '2015-02-01 00:23:04.000000', 'consum', 0.0229, 'lps'),
	(383588, 124, '2015-02-01 00:23:05.000000', 'consum', 0.0229, 'lps'),
	(383589, 124, '2015-02-01 00:23:06.000000', 'consum', 0.0227, 'lps'),
	(383590, 124, '2015-02-01 00:23:07.000000', 'consum', 0.0217, 'lps'),
	(383591, 124, '2015-02-01 00:23:08.000000', 'consum', 0.0216, 'lps'),
	(383592, 124, '2015-02-01 00:23:09.000000', 'consum', 0.0220, 'lps'),
	(383593, 124, '2015-02-01 00:23:10.000000', 'consum', 0.0219, 'lps'),
	(383594, 124, '2015-02-01 00:23:11.000000', 'consum', 0.0228, 'lps'),
	(383595, 124, '2015-02-01 00:23:12.000000', 'consum', 0.0211, 'lps'),
	(383596, 124, '2015-02-01 00:23:13.000000', 'consum', 0.0223, 'lps'),
	(383597, 124, '2015-02-01 00:23:14.000000', 'consum', 0.0210, 'lps'),
	(383598, 124, '2015-02-01 00:23:15.000000', 'consum', 0.0212, 'lps'),
	(383599, 124, '2015-02-01 00:23:16.000000', 'consum', 0.0220, 'lps'),
	(383600, 124, '2015-02-01 00:23:17.000000', 'consum', 0.0216, 'lps'),
	(383601, 124, '2015-02-01 00:23:18.000000', 'consum', 0.0228, 'lps'),
	(383602, 124, '2015-02-01 00:23:19.000000', 'consum', 0.0220, 'lps'),
	(383603, 124, '2015-02-01 00:23:20.000000', 'consum', 0.0229, 'lps'),
	(383604, 124, '2015-02-01 00:23:21.000000', 'consum', 0.0213, 'lps'),
	(383605, 124, '2015-02-01 00:23:22.000000', 'consum', 0.0230, 'lps'),
	(383606, 124, '2015-02-01 00:23:23.000000', 'consum', 0.0217, 'lps'),
	(383607, 124, '2015-02-01 00:23:24.000000', 'consum', 0.0227, 'lps'),
	(383608, 124, '2015-02-01 00:23:25.000000', 'consum', 0.0210, 'lps'),
	(383609, 124, '2015-02-01 00:23:26.000000', 'consum', 0.0226, 'lps'),
	(383610, 124, '2015-02-01 00:23:27.000000', 'consum', 0.0226, 'lps'),
	(383611, 124, '2015-02-01 00:23:28.000000', 'consum', 0.0220, 'lps'),
	(383612, 124, '2015-02-01 00:23:29.000000', 'consum', 0.0213, 'lps'),
	(383613, 124, '2015-02-01 00:23:30.000000', 'consum', 0.0218, 'lps'),
	(383614, 124, '2015-02-01 00:23:31.000000', 'consum', 0.0219, 'lps'),
	(383615, 124, '2015-02-01 00:23:32.000000', 'consum', 0.0212, 'lps'),
	(383616, 124, '2015-02-01 00:23:33.000000', 'consum', 0.0213, 'lps'),
	(383617, 124, '2015-02-01 00:23:34.000000', 'consum', 0.0221, 'lps'),
	(383618, 124, '2015-02-01 00:23:35.000000', 'consum', 0.0216, 'lps'),
	(383619, 124, '2015-02-01 00:23:36.000000', 'consum', 0.0227, 'lps'),
	(383620, 124, '2015-02-01 00:23:37.000000', 'consum', 0.0214, 'lps'),
	(383621, 124, '2015-02-01 00:23:38.000000', 'consum', 0.0224, 'lps'),
	(383622, 124, '2015-02-01 00:23:39.000000', 'consum', 0.0224, 'lps'),
	(383623, 124, '2015-02-01 00:23:40.000000', 'consum', 0.0216, 'lps'),
	(383624, 124, '2015-02-01 00:23:41.000000', 'consum', 0.0221, 'lps'),
	(383625, 124, '2015-02-01 00:23:42.000000', 'consum', 0.0228, 'lps'),
	(383626, 124, '2015-02-01 00:23:43.000000', 'consum', 0.0225, 'lps'),
	(383627, 124, '2015-02-01 00:23:44.000000', 'consum', 0.0211, 'lps'),
	(383628, 124, '2015-02-01 00:23:45.000000', 'consum', 0.0211, 'lps'),
	(383629, 124, '2015-02-01 00:23:46.000000', 'consum', 0.0214, 'lps'),
	(383630, 124, '2015-02-01 00:23:47.000000', 'consum', 0.0226, 'lps'),
	(383631, 124, '2015-02-01 00:23:48.000000', 'consum', 0.0217, 'lps'),
	(383632, 124, '2015-02-01 00:23:49.000000', 'consum', 0.0218, 'lps'),
	(383633, 124, '2015-02-01 00:23:50.000000', 'consum', 0.0229, 'lps'),
	(383634, 124, '2015-02-01 00:23:51.000000', 'consum', 0.0220, 'lps'),
	(383635, 124, '2015-02-01 00:23:52.000000', 'consum', 0.0225, 'lps'),
	(383636, 124, '2015-02-01 00:23:53.000000', 'consum', 0.0212, 'lps'),
	(383637, 124, '2015-02-01 00:23:54.000000', 'consum', 0.0216, 'lps'),
	(383638, 124, '2015-02-01 00:23:55.000000', 'consum', 0.0215, 'lps'),
	(383639, 124, '2015-02-01 00:23:56.000000', 'consum', 0.0217, 'lps'),
	(383640, 124, '2015-02-01 00:23:57.000000', 'consum', 0.0211, 'lps'),
	(383641, 124, '2015-02-01 00:23:58.000000', 'consum', 0.0216, 'lps'),
	(383642, 124, '2015-02-01 00:23:59.000000', 'consum', 0.0214, 'lps'),
	(383643, 124, '2015-02-01 00:24:00.000000', 'consum', 0.0212, 'lps'),
	(383644, 124, '2015-02-01 00:24:01.000000', 'consum', 0.0212, 'lps'),
	(383645, 124, '2015-02-01 00:24:02.000000', 'consum', 0.0211, 'lps'),
	(383646, 124, '2015-02-01 00:24:03.000000', 'consum', 0.0212, 'lps'),
	(383647, 124, '2015-02-01 00:24:04.000000', 'consum', 0.0216, 'lps'),
	(383648, 124, '2015-02-01 00:24:05.000000', 'consum', 0.0214, 'lps'),
	(383649, 124, '2015-02-01 00:24:06.000000', 'consum', 0.0214, 'lps'),
	(383650, 124, '2015-02-01 00:24:07.000000', 'consum', 0.0219, 'lps'),
	(383651, 124, '2015-02-01 00:24:08.000000', 'consum', 0.0220, 'lps'),
	(383652, 124, '2015-02-01 00:24:09.000000', 'consum', 0.0215, 'lps'),
	(383653, 124, '2015-02-01 00:24:10.000000', 'consum', 0.0227, 'lps'),
	(383654, 124, '2015-02-01 00:24:11.000000', 'consum', 0.0215, 'lps'),
	(383655, 124, '2015-02-01 00:24:12.000000', 'consum', 0.0227, 'lps'),
	(383656, 124, '2015-02-01 00:24:13.000000', 'consum', 0.0216, 'lps'),
	(383657, 124, '2015-02-01 00:24:14.000000', 'consum', 0.0211, 'lps'),
	(383658, 124, '2015-02-01 00:24:15.000000', 'consum', 0.0220, 'lps'),
	(383659, 124, '2015-02-01 00:24:16.000000', 'consum', 0.0216, 'lps'),
	(383660, 124, '2015-02-01 00:24:17.000000', 'consum', 0.0229, 'lps'),
	(383661, 124, '2015-02-01 00:24:18.000000', 'consum', 0.0224, 'lps'),
	(383662, 124, '2015-02-01 00:24:19.000000', 'consum', 0.0224, 'lps'),
	(383663, 124, '2015-02-01 00:24:20.000000', 'consum', 0.0219, 'lps'),
	(383664, 124, '2015-02-01 00:24:21.000000', 'consum', 0.0213, 'lps'),
	(383665, 124, '2015-02-01 00:24:22.000000', 'consum', 0.0221, 'lps'),
	(383666, 124, '2015-02-01 00:24:23.000000', 'consum', 0.0213, 'lps'),
	(383667, 124, '2015-02-01 00:24:24.000000', 'consum', 0.0215, 'lps'),
	(383668, 124, '2015-02-01 00:24:25.000000', 'consum', 0.0225, 'lps'),
	(383669, 124, '2015-02-01 00:24:26.000000', 'consum', 0.0230, 'lps'),
	(383670, 124, '2015-02-01 00:24:27.000000', 'consum', 0.0222, 'lps'),
	(383671, 124, '2015-02-01 00:24:28.000000', 'consum', 0.0230, 'lps'),
	(383672, 124, '2015-02-01 00:24:29.000000', 'consum', 0.0215, 'lps'),
	(383673, 124, '2015-02-01 00:24:30.000000', 'consum', 0.0215, 'lps'),
	(383674, 124, '2015-02-01 00:24:31.000000', 'consum', 0.0222, 'lps'),
	(383675, 124, '2015-02-01 00:24:32.000000', 'consum', 0.0214, 'lps'),
	(383676, 124, '2015-02-01 00:24:33.000000', 'consum', 0.0215, 'lps'),
	(383677, 124, '2015-02-01 00:24:34.000000', 'consum', 0.0222, 'lps'),
	(383678, 124, '2015-02-01 00:24:35.000000', 'consum', 0.0213, 'lps'),
	(383679, 124, '2015-02-01 00:24:36.000000', 'consum', 0.0213, 'lps'),
	(383680, 124, '2015-02-01 00:24:37.000000', 'consum', 0.0215, 'lps'),
	(383681, 124, '2015-02-01 00:24:38.000000', 'consum', 0.0225, 'lps'),
	(383682, 124, '2015-02-01 00:24:39.000000', 'consum', 0.0230, 'lps'),
	(383683, 124, '2015-02-01 00:24:40.000000', 'consum', 0.0224, 'lps'),
	(383684, 124, '2015-02-01 00:24:41.000000', 'consum', 0.0221, 'lps'),
	(383685, 124, '2015-02-01 00:24:42.000000', 'consum', 0.0224, 'lps'),
	(383686, 124, '2015-02-01 00:24:43.000000', 'consum', 0.0225, 'lps'),
	(383687, 124, '2015-02-01 00:24:44.000000', 'consum', 0.0223, 'lps'),
	(383688, 124, '2015-02-01 00:24:45.000000', 'consum', 0.0211, 'lps'),
	(383689, 124, '2015-02-01 00:24:46.000000', 'consum', 0.0218, 'lps'),
	(383690, 124, '2015-02-01 00:24:47.000000', 'consum', 0.0227, 'lps'),
	(383691, 124, '2015-02-01 00:24:48.000000', 'consum', 0.0228, 'lps'),
	(383692, 124, '2015-02-01 00:24:49.000000', 'consum', 0.0230, 'lps'),
	(383693, 124, '2015-02-01 00:24:50.000000', 'consum', 0.0215, 'lps'),
	(383694, 124, '2015-02-01 00:24:51.000000', 'consum', 0.0216, 'lps'),
	(383695, 124, '2015-02-01 00:24:52.000000', 'consum', 0.0225, 'lps'),
	(383696, 124, '2015-02-01 00:24:53.000000', 'consum', 0.0228, 'lps'),
	(383697, 124, '2015-02-01 00:24:54.000000', 'consum', 0.0214, 'lps'),
	(383698, 124, '2015-02-01 00:24:55.000000', 'consum', 0.0216, 'lps'),
	(383699, 124, '2015-02-01 00:24:56.000000', 'consum', 0.0229, 'lps'),
	(383700, 124, '2015-02-01 00:24:57.000000', 'consum', 0.0226, 'lps'),
	(383701, 124, '2015-02-01 00:24:58.000000', 'consum', 0.0213, 'lps'),
	(383702, 124, '2015-02-01 00:24:59.000000', 'consum', 0.0217, 'lps'),
	(383703, 124, '2015-02-01 00:25:00.000000', 'consum', 0.0214, 'lps'),
	(383704, 124, '2015-02-01 00:25:01.000000', 'consum', 0.0213, 'lps'),
	(383705, 124, '2015-02-01 00:25:02.000000', 'consum', 0.0214, 'lps'),
	(383706, 124, '2015-02-01 00:25:03.000000', 'consum', 0.0220, 'lps'),
	(383707, 124, '2015-02-01 00:25:04.000000', 'consum', 0.0230, 'lps'),
	(383708, 124, '2015-02-01 00:25:05.000000', 'consum', 0.0214, 'lps'),
	(383709, 124, '2015-02-01 00:25:06.000000', 'consum', 0.0214, 'lps'),
	(383710, 124, '2015-02-01 00:25:07.000000', 'consum', 0.0216, 'lps'),
	(383711, 124, '2015-02-01 00:25:08.000000', 'consum', 0.0210, 'lps'),
	(383712, 124, '2015-02-01 00:25:09.000000', 'consum', 0.0215, 'lps'),
	(383713, 124, '2015-02-01 00:25:10.000000', 'consum', 0.0213, 'lps'),
	(383714, 124, '2015-02-01 00:25:11.000000', 'consum', 0.0230, 'lps'),
	(383715, 124, '2015-02-01 00:25:12.000000', 'consum', 0.0217, 'lps'),
	(383716, 124, '2015-02-01 00:25:13.000000', 'consum', 0.0227, 'lps'),
	(383717, 124, '2015-02-01 00:25:14.000000', 'consum', 0.0211, 'lps'),
	(383718, 124, '2015-02-01 00:25:15.000000', 'consum', 0.0228, 'lps'),
	(383719, 124, '2015-02-01 00:25:16.000000', 'consum', 0.0215, 'lps'),
	(383720, 124, '2015-02-01 00:25:17.000000', 'consum', 0.0224, 'lps'),
	(383721, 124, '2015-02-01 00:25:18.000000', 'consum', 0.0221, 'lps'),
	(383722, 124, '2015-02-01 00:25:19.000000', 'consum', 0.0223, 'lps'),
	(383723, 124, '2015-02-01 00:25:20.000000', 'consum', 0.0223, 'lps'),
	(383724, 124, '2015-02-01 00:25:21.000000', 'consum', 0.0216, 'lps'),
	(383725, 124, '2015-02-01 00:25:22.000000', 'consum', 0.0222, 'lps'),
	(383726, 124, '2015-02-01 00:25:23.000000', 'consum', 0.0211, 'lps'),
	(383727, 124, '2015-02-01 00:25:24.000000', 'consum', 0.0223, 'lps'),
	(383728, 124, '2015-02-01 00:25:25.000000', 'consum', 0.0229, 'lps'),
	(383729, 124, '2015-02-01 00:25:26.000000', 'consum', 0.0224, 'lps'),
	(383730, 124, '2015-02-01 00:25:27.000000', 'consum', 0.0224, 'lps'),
	(383731, 124, '2015-02-01 00:25:28.000000', 'consum', 0.0216, 'lps'),
	(383732, 124, '2015-02-01 00:25:29.000000', 'consum', 0.0219, 'lps'),
	(383733, 124, '2015-02-01 00:25:30.000000', 'consum', 0.0218, 'lps'),
	(383734, 124, '2015-02-01 00:25:31.000000', 'consum', 0.0225, 'lps'),
	(383735, 124, '2015-02-01 00:25:32.000000', 'consum', 0.0219, 'lps'),
	(383736, 124, '2015-02-01 00:25:33.000000', 'consum', 0.0210, 'lps'),
	(383737, 124, '2015-02-01 00:25:34.000000', 'consum', 0.0227, 'lps'),
	(383738, 124, '2015-02-01 00:25:35.000000', 'consum', 0.0212, 'lps'),
	(383739, 124, '2015-02-01 00:25:36.000000', 'consum', 0.0210, 'lps'),
	(383740, 124, '2015-02-01 00:25:37.000000', 'consum', 0.0225, 'lps'),
	(383741, 124, '2015-02-01 00:25:38.000000', 'consum', 0.0224, 'lps'),
	(383742, 124, '2015-02-01 00:25:39.000000', 'consum', 0.0213, 'lps'),
	(383743, 124, '2015-02-01 00:25:40.000000', 'consum', 0.0224, 'lps'),
	(383744, 124, '2015-02-01 00:25:41.000000', 'consum', 0.0211, 'lps'),
	(383745, 124, '2015-02-01 00:25:42.000000', 'consum', 0.0215, 'lps'),
	(383746, 124, '2015-02-01 00:25:43.000000', 'consum', 0.0213, 'lps'),
	(383747, 124, '2015-02-01 00:25:44.000000', 'consum', 0.0229, 'lps'),
	(383748, 124, '2015-02-01 00:25:45.000000', 'consum', 0.0214, 'lps'),
	(383749, 124, '2015-02-01 00:25:46.000000', 'consum', 0.0215, 'lps'),
	(383750, 124, '2015-02-01 00:25:47.000000', 'consum', 0.0225, 'lps'),
	(383751, 124, '2015-02-01 00:25:48.000000', 'consum', 0.0229, 'lps'),
	(383752, 124, '2015-02-01 00:25:49.000000', 'consum', 0.0219, 'lps'),
	(383753, 124, '2015-02-01 00:25:50.000000', 'consum', 0.0217, 'lps'),
	(383754, 124, '2015-02-01 00:25:51.000000', 'consum', 0.0221, 'lps'),
	(383755, 124, '2015-02-01 00:25:52.000000', 'consum', 0.0223, 'lps'),
	(383756, 124, '2015-02-01 00:25:53.000000', 'consum', 0.0222, 'lps'),
	(383757, 124, '2015-02-01 00:25:54.000000', 'consum', 0.0210, 'lps'),
	(383758, 124, '2015-02-01 00:25:55.000000', 'consum', 0.0216, 'lps'),
	(383759, 124, '2015-02-01 00:25:56.000000', 'consum', 0.0218, 'lps'),
	(383760, 124, '2015-02-01 00:25:57.000000', 'consum', 0.0212, 'lps'),
	(383761, 124, '2015-02-01 00:25:58.000000', 'consum', 0.0217, 'lps'),
	(383762, 124, '2015-02-01 00:25:59.000000', 'consum', 0.0220, 'lps'),
	(383763, 124, '2015-02-01 00:26:00.000000', 'consum', 0.0217, 'lps'),
	(383764, 124, '2015-02-01 00:26:01.000000', 'consum', 0.0217, 'lps'),
	(383765, 124, '2015-02-01 00:26:02.000000', 'consum', 0.0226, 'lps'),
	(383766, 124, '2015-02-01 00:26:03.000000', 'consum', 0.0226, 'lps'),
	(383767, 124, '2015-02-01 00:26:04.000000', 'consum', 0.0221, 'lps'),
	(383768, 124, '2015-02-01 00:26:05.000000', 'consum', 0.0218, 'lps'),
	(383769, 124, '2015-02-01 00:26:06.000000', 'consum', 0.0216, 'lps'),
	(383770, 124, '2015-02-01 00:26:07.000000', 'consum', 0.0216, 'lps'),
	(383771, 124, '2015-02-01 00:26:08.000000', 'consum', 0.0225, 'lps'),
	(383772, 124, '2015-02-01 00:26:09.000000', 'consum', 0.0225, 'lps'),
	(383773, 124, '2015-02-01 00:26:10.000000', 'consum', 0.0220, 'lps'),
	(383774, 124, '2015-02-01 00:26:11.000000', 'consum', 0.0214, 'lps'),
	(383775, 124, '2015-02-01 00:26:12.000000', 'consum', 0.0223, 'lps'),
	(383776, 124, '2015-02-01 00:26:13.000000', 'consum', 0.0223, 'lps'),
	(383777, 124, '2015-02-01 00:26:14.000000', 'consum', 0.0214, 'lps'),
	(383778, 124, '2015-02-01 00:26:15.000000', 'consum', 0.0211, 'lps'),
	(383779, 124, '2015-02-01 00:26:16.000000', 'consum', 0.0227, 'lps'),
	(383780, 124, '2015-02-01 00:26:17.000000', 'consum', 0.0230, 'lps'),
	(383781, 124, '2015-02-01 00:26:18.000000', 'consum', 0.0217, 'lps'),
	(383782, 124, '2015-02-01 00:26:19.000000', 'consum', 0.0226, 'lps'),
	(383783, 124, '2015-02-01 00:26:20.000000', 'consum', 0.0227, 'lps'),
	(383784, 124, '2015-02-01 00:26:21.000000', 'consum', 0.0227, 'lps'),
	(383785, 124, '2015-02-01 00:26:22.000000', 'consum', 0.0222, 'lps'),
	(383786, 124, '2015-02-01 00:26:23.000000', 'consum', 0.0221, 'lps'),
	(383787, 124, '2015-02-01 00:26:24.000000', 'consum', 0.0230, 'lps'),
	(383788, 124, '2015-02-01 00:26:25.000000', 'consum', 0.0214, 'lps'),
	(383789, 124, '2015-02-01 00:26:26.000000', 'consum', 0.0214, 'lps'),
	(383790, 124, '2015-02-01 00:26:27.000000', 'consum', 0.0216, 'lps'),
	(383791, 124, '2015-02-01 00:26:28.000000', 'consum', 0.0230, 'lps'),
	(383792, 124, '2015-02-01 00:26:29.000000', 'consum', 0.0228, 'lps'),
	(383793, 124, '2015-02-01 00:26:30.000000', 'consum', 0.0220, 'lps'),
	(383794, 124, '2015-02-01 00:26:31.000000', 'consum', 0.0230, 'lps'),
	(383795, 124, '2015-02-01 00:26:32.000000', 'consum', 0.0214, 'lps'),
	(383796, 124, '2015-02-01 00:26:33.000000', 'consum', 0.0214, 'lps'),
	(383797, 124, '2015-02-01 00:26:34.000000', 'consum', 0.0217, 'lps'),
	(383798, 124, '2015-02-01 00:26:35.000000', 'consum', 0.0212, 'lps'),
	(383799, 124, '2015-02-01 00:26:36.000000', 'consum', 0.0219, 'lps'),
	(383800, 124, '2015-02-01 00:26:37.000000', 'consum', 0.0211, 'lps'),
	(383801, 124, '2015-02-01 00:26:38.000000', 'consum', 0.0229, 'lps'),
	(383802, 124, '2015-02-01 00:26:39.000000', 'consum', 0.0217, 'lps'),
	(383803, 124, '2015-02-01 00:26:40.000000', 'consum', 0.0213, 'lps'),
	(383804, 124, '2015-02-01 00:26:41.000000', 'consum', 0.0223, 'lps'),
	(383805, 124, '2015-02-01 00:26:42.000000', 'consum', 0.0224, 'lps'),
	(383806, 124, '2015-02-01 00:26:43.000000', 'consum', 0.0222, 'lps'),
	(383807, 124, '2015-02-01 00:26:44.000000', 'consum', 0.0227, 'lps'),
	(383808, 124, '2015-02-01 00:26:45.000000', 'consum', 0.0218, 'lps'),
	(383809, 124, '2015-02-01 00:26:46.000000', 'consum', 0.0220, 'lps'),
	(383810, 124, '2015-02-01 00:26:47.000000', 'consum', 0.0217, 'lps'),
	(383811, 124, '2015-02-01 00:26:48.000000', 'consum', 0.0213, 'lps'),
	(383812, 124, '2015-02-01 00:26:49.000000', 'consum', 0.0228, 'lps'),
	(383813, 124, '2015-02-01 00:26:50.000000', 'consum', 0.0228, 'lps'),
	(383814, 124, '2015-02-01 00:26:51.000000', 'consum', 0.0224, 'lps'),
	(383815, 124, '2015-02-01 00:26:52.000000', 'consum', 0.0227, 'lps'),
	(383816, 124, '2015-02-01 00:26:53.000000', 'consum', 0.0211, 'lps'),
	(383817, 124, '2015-02-01 00:26:54.000000', 'consum', 0.0230, 'lps'),
	(383818, 124, '2015-02-01 00:26:55.000000', 'consum', 0.0220, 'lps'),
	(383819, 124, '2015-02-01 00:26:56.000000', 'consum', 0.0225, 'lps'),
	(383820, 124, '2015-02-01 00:26:57.000000', 'consum', 0.0211, 'lps'),
	(383821, 124, '2015-02-01 00:26:58.000000', 'consum', 0.0213, 'lps'),
	(383822, 124, '2015-02-01 00:26:59.000000', 'consum', 0.0225, 'lps'),
	(383823, 124, '2015-02-01 00:27:00.000000', 'consum', 0.0211, 'lps'),
	(383824, 124, '2015-02-01 00:27:01.000000', 'consum', 0.0212, 'lps'),
	(383825, 124, '2015-02-01 00:27:02.000000', 'consum', 0.0217, 'lps'),
	(383826, 124, '2015-02-01 00:27:03.000000', 'consum', 0.0218, 'lps'),
	(383827, 124, '2015-02-01 00:27:04.000000', 'consum', 0.0211, 'lps'),
	(383828, 124, '2015-02-01 00:27:05.000000', 'consum', 0.0210, 'lps'),
	(383829, 124, '2015-02-01 00:27:06.000000', 'consum', 0.0228, 'lps'),
	(383830, 124, '2015-02-01 00:27:07.000000', 'consum', 0.0219, 'lps'),
	(383831, 124, '2015-02-01 00:27:08.000000', 'consum', 0.0220, 'lps'),
	(383832, 124, '2015-02-01 00:27:09.000000', 'consum', 0.0215, 'lps'),
	(383833, 124, '2015-02-01 00:27:10.000000', 'consum', 0.0226, 'lps'),
	(383834, 124, '2015-02-01 00:27:11.000000', 'consum', 0.0212, 'lps'),
	(383835, 124, '2015-02-01 00:27:12.000000', 'consum', 0.0213, 'lps'),
	(383836, 124, '2015-02-01 00:27:13.000000', 'consum', 0.0220, 'lps'),
	(383837, 124, '2015-02-01 00:27:14.000000', 'consum', 0.0229, 'lps'),
	(383838, 124, '2015-02-01 00:27:15.000000', 'consum', 0.0216, 'lps'),
	(383839, 124, '2015-02-01 00:27:16.000000', 'consum', 0.0223, 'lps'),
	(383840, 124, '2015-02-01 00:27:17.000000', 'consum', 0.0218, 'lps'),
	(383841, 124, '2015-02-01 00:27:18.000000', 'consum', 0.0211, 'lps'),
	(383842, 124, '2015-02-01 00:27:19.000000', 'consum', 0.0210, 'lps'),
	(383843, 124, '2015-02-01 00:27:20.000000', 'consum', 0.0229, 'lps'),
	(383844, 124, '2015-02-01 00:27:21.000000', 'consum', 0.0223, 'lps'),
	(383845, 124, '2015-02-01 00:27:22.000000', 'consum', 0.0218, 'lps'),
	(383846, 124, '2015-02-01 00:27:23.000000', 'consum', 0.0210, 'lps'),
	(383847, 124, '2015-02-01 00:27:24.000000', 'consum', 0.0228, 'lps'),
	(383848, 124, '2015-02-01 00:27:25.000000', 'consum', 0.0219, 'lps'),
	(383849, 124, '2015-02-01 00:27:26.000000', 'consum', 0.0223, 'lps'),
	(383850, 124, '2015-02-01 00:27:27.000000', 'consum', 0.0224, 'lps'),
	(383851, 124, '2015-02-01 00:27:28.000000', 'consum', 0.0224, 'lps'),
	(383852, 124, '2015-02-01 00:27:29.000000', 'consum', 0.0217, 'lps'),
	(383853, 124, '2015-02-01 00:27:30.000000', 'consum', 0.0224, 'lps'),
	(383854, 124, '2015-02-01 00:27:31.000000', 'consum', 0.0219, 'lps'),
	(383855, 124, '2015-02-01 00:27:32.000000', 'consum', 0.0211, 'lps'),
	(383856, 124, '2015-02-01 00:27:33.000000', 'consum', 0.0212, 'lps'),
	(383857, 124, '2015-02-01 00:27:34.000000', 'consum', 0.0216, 'lps'),
	(383858, 124, '2015-02-01 00:27:35.000000', 'consum', 0.0214, 'lps'),
	(383859, 124, '2015-02-01 00:27:36.000000', 'consum', 0.0214, 'lps'),
	(383860, 124, '2015-02-01 00:27:37.000000', 'consum', 0.0218, 'lps'),
	(383861, 124, '2015-02-01 00:27:38.000000', 'consum', 0.0219, 'lps'),
	(383862, 124, '2015-02-01 00:27:39.000000', 'consum', 0.0228, 'lps'),
	(383863, 124, '2015-02-01 00:27:40.000000', 'consum', 0.0213, 'lps'),
	(383864, 124, '2015-02-01 00:27:41.000000', 'consum', 0.0214, 'lps'),
	(383865, 124, '2015-02-01 00:27:42.000000', 'consum', 0.0222, 'lps'),
	(383866, 124, '2015-02-01 00:27:43.000000', 'consum', 0.0215, 'lps'),
	(383867, 124, '2015-02-01 00:27:44.000000', 'consum', 0.0219, 'lps'),
	(383868, 124, '2015-02-01 00:27:45.000000', 'consum', 0.0220, 'lps'),
	(383869, 124, '2015-02-01 00:27:46.000000', 'consum', 0.0213, 'lps'),
	(383870, 124, '2015-02-01 00:27:47.000000', 'consum', 0.0217, 'lps'),
	(383871, 124, '2015-02-01 00:27:48.000000', 'consum', 0.0216, 'lps'),
	(383872, 124, '2015-02-01 00:27:49.000000', 'consum', 0.0219, 'lps'),
	(383873, 124, '2015-02-01 00:27:50.000000', 'consum', 0.0216, 'lps'),
	(383874, 124, '2015-02-01 00:27:51.000000', 'consum', 0.0216, 'lps'),
	(383875, 124, '2015-02-01 00:27:52.000000', 'consum', 0.0221, 'lps'),
	(383876, 124, '2015-02-01 00:27:53.000000', 'consum', 0.0225, 'lps'),
	(383877, 124, '2015-02-01 00:27:54.000000', 'consum', 0.0211, 'lps'),
	(383878, 124, '2015-02-01 00:27:55.000000', 'consum', 0.0213, 'lps'),
	(383879, 124, '2015-02-01 00:27:56.000000', 'consum', 0.0224, 'lps'),
	(383880, 124, '2015-02-01 00:27:57.000000', 'consum', 0.0230, 'lps'),
	(383881, 124, '2015-02-01 00:27:58.000000', 'consum', 0.0227, 'lps'),
	(383882, 124, '2015-02-01 00:27:59.000000', 'consum', 0.0212, 'lps'),
	(383883, 124, '2015-02-01 00:28:00.000000', 'consum', 0.0215, 'lps'),
	(383884, 124, '2015-02-01 00:28:01.000000', 'consum', 0.0226, 'lps'),
	(383885, 124, '2015-02-01 00:28:02.000000', 'consum', 0.0213, 'lps'),
	(383886, 124, '2015-02-01 00:28:03.000000', 'consum', 0.0218, 'lps'),
	(383887, 124, '2015-02-01 00:28:04.000000', 'consum', 0.0223, 'lps'),
	(383888, 124, '2015-02-01 00:28:05.000000', 'consum', 0.0211, 'lps'),
	(383889, 124, '2015-02-01 00:28:06.000000', 'consum', 0.0216, 'lps'),
	(383890, 124, '2015-02-01 00:28:07.000000', 'consum', 0.0217, 'lps'),
	(383891, 124, '2015-02-01 00:28:08.000000', 'consum', 0.0228, 'lps'),
	(383892, 124, '2015-02-01 00:28:09.000000', 'consum', 0.0216, 'lps'),
	(383893, 124, '2015-02-01 00:28:10.000000', 'consum', 0.0228, 'lps'),
	(383894, 124, '2015-02-01 00:28:11.000000', 'consum', 0.0218, 'lps'),
	(383895, 124, '2015-02-01 00:28:12.000000', 'consum', 0.0219, 'lps'),
	(383896, 124, '2015-02-01 00:28:13.000000', 'consum', 0.0230, 'lps'),
	(383897, 124, '2015-02-01 00:28:14.000000', 'consum', 0.0222, 'lps'),
	(383898, 124, '2015-02-01 00:28:15.000000', 'consum', 0.0229, 'lps'),
	(383899, 124, '2015-02-01 00:28:16.000000', 'consum', 0.0230, 'lps'),
	(383900, 124, '2015-02-01 00:28:17.000000', 'consum', 0.0210, 'lps'),
	(383901, 124, '2015-02-01 00:28:18.000000', 'consum', 0.0213, 'lps'),
	(383902, 124, '2015-02-01 00:28:19.000000', 'consum', 0.0227, 'lps'),
	(383903, 124, '2015-02-01 00:28:20.000000', 'consum', 0.0224, 'lps'),
	(383904, 124, '2015-02-01 00:28:21.000000', 'consum', 0.0229, 'lps'),
	(383905, 124, '2015-02-01 00:28:22.000000', 'consum', 0.0222, 'lps'),
	(383906, 124, '2015-02-01 00:28:23.000000', 'consum', 0.0215, 'lps'),
	(383907, 124, '2015-02-01 00:28:24.000000', 'consum', 0.0220, 'lps'),
	(383908, 124, '2015-02-01 00:28:25.000000', 'consum', 0.0224, 'lps'),
	(383909, 124, '2015-02-01 00:28:26.000000', 'consum', 0.0228, 'lps'),
	(383910, 124, '2015-02-01 00:28:27.000000', 'consum', 0.0216, 'lps'),
	(383911, 124, '2015-02-01 00:28:28.000000', 'consum', 0.0228, 'lps'),
	(383912, 124, '2015-02-01 00:28:29.000000', 'consum', 0.0220, 'lps'),
	(383913, 124, '2015-02-01 00:28:30.000000', 'consum', 0.0229, 'lps'),
	(383914, 124, '2015-02-01 00:28:31.000000', 'consum', 0.0213, 'lps'),
	(383915, 124, '2015-02-01 00:28:32.000000', 'consum', 0.0210, 'lps'),
	(383916, 124, '2015-02-01 00:28:33.000000', 'consum', 0.0223, 'lps'),
	(383917, 124, '2015-02-01 00:28:34.000000', 'consum', 0.0213, 'lps'),
	(383918, 124, '2015-02-01 00:28:35.000000', 'consum', 0.0227, 'lps'),
	(383919, 124, '2015-02-01 00:28:36.000000', 'consum', 0.0225, 'lps'),
	(383920, 124, '2015-02-01 00:28:37.000000', 'consum', 0.0211, 'lps'),
	(383921, 124, '2015-02-01 00:28:38.000000', 'consum', 0.0215, 'lps'),
	(383922, 124, '2015-02-01 00:28:39.000000', 'consum', 0.0210, 'lps'),
	(383923, 124, '2015-02-01 00:28:40.000000', 'consum', 0.0217, 'lps'),
	(383924, 124, '2015-02-01 00:28:41.000000', 'consum', 0.0224, 'lps'),
	(383925, 124, '2015-02-01 00:28:42.000000', 'consum', 0.0216, 'lps'),
	(383926, 124, '2015-02-01 00:28:43.000000', 'consum', 0.0221, 'lps'),
	(383927, 124, '2015-02-01 00:28:44.000000', 'consum', 0.0228, 'lps'),
	(383928, 124, '2015-02-01 00:28:45.000000', 'consum', 0.0225, 'lps'),
	(383929, 124, '2015-02-01 00:28:46.000000', 'consum', 0.0229, 'lps'),
	(383930, 124, '2015-02-01 00:28:47.000000', 'consum', 0.0221, 'lps'),
	(383931, 124, '2015-02-01 00:28:48.000000', 'consum', 0.0210, 'lps'),
	(383932, 124, '2015-02-01 00:28:49.000000', 'consum', 0.0217, 'lps'),
	(383933, 124, '2015-02-01 00:28:50.000000', 'consum', 0.0223, 'lps'),
	(383934, 124, '2015-02-01 00:28:51.000000', 'consum', 0.0214, 'lps'),
	(383935, 124, '2015-02-01 00:28:52.000000', 'consum', 0.0213, 'lps'),
	(383936, 124, '2015-02-01 00:28:53.000000', 'consum', 0.0213, 'lps'),
	(383937, 124, '2015-02-01 00:28:54.000000', 'consum', 0.0218, 'lps'),
	(383938, 124, '2015-02-01 00:28:55.000000', 'consum', 0.0218, 'lps'),
	(383939, 124, '2015-02-01 00:28:56.000000', 'consum', 0.0229, 'lps'),
	(383940, 124, '2015-02-01 00:28:57.000000', 'consum', 0.0218, 'lps'),
	(383941, 124, '2015-02-01 00:28:58.000000', 'consum', 0.0213, 'lps'),
	(383942, 124, '2015-02-01 00:28:59.000000', 'consum', 0.0225, 'lps'),
	(383943, 124, '2015-02-01 00:29:00.000000', 'consum', 0.0212, 'lps'),
	(383944, 124, '2015-02-01 00:29:01.000000', 'consum', 0.0217, 'lps'),
	(383945, 124, '2015-02-01 00:29:02.000000', 'consum', 0.0218, 'lps'),
	(383946, 124, '2015-02-01 00:29:03.000000', 'consum', 0.0229, 'lps'),
	(383947, 124, '2015-02-01 00:29:04.000000', 'consum', 0.0221, 'lps'),
	(383948, 124, '2015-02-01 00:29:05.000000', 'consum', 0.0229, 'lps'),
	(383949, 124, '2015-02-01 00:29:06.000000', 'consum', 0.0229, 'lps'),
	(383950, 124, '2015-02-01 00:29:07.000000', 'consum', 0.0230, 'lps'),
	(383951, 124, '2015-02-01 00:29:08.000000', 'consum', 0.0230, 'lps'),
	(383952, 124, '2015-02-01 00:29:09.000000', 'consum', 0.0228, 'lps'),
	(383953, 124, '2015-02-01 00:29:10.000000', 'consum', 0.0223, 'lps'),
	(383954, 124, '2015-02-01 00:29:11.000000', 'consum', 0.0219, 'lps'),
	(383955, 124, '2015-02-01 00:29:12.000000', 'consum', 0.0215, 'lps'),
	(383956, 124, '2015-02-01 00:29:13.000000', 'consum', 0.0212, 'lps'),
	(383957, 124, '2015-02-01 00:29:14.000000', 'consum', 0.0224, 'lps'),
	(383958, 124, '2015-02-01 00:29:15.000000', 'consum', 0.0211, 'lps'),
	(383959, 124, '2015-02-01 00:29:16.000000', 'consum', 0.0215, 'lps'),
	(383960, 124, '2015-02-01 00:29:17.000000', 'consum', 0.0212, 'lps'),
	(383961, 124, '2015-02-01 00:29:18.000000', 'consum', 0.0227, 'lps'),
	(383962, 124, '2015-02-01 00:29:19.000000', 'consum', 0.0226, 'lps'),
	(383963, 124, '2015-02-01 00:29:20.000000', 'consum', 0.0218, 'lps'),
	(383964, 124, '2015-02-01 00:29:21.000000', 'consum', 0.0225, 'lps'),
	(383965, 124, '2015-02-01 00:29:22.000000', 'consum', 0.0220, 'lps'),
	(383966, 124, '2015-02-01 00:29:23.000000', 'consum', 0.0216, 'lps'),
	(383967, 124, '2015-02-01 00:29:24.000000', 'consum', 0.0230, 'lps'),
	(383968, 124, '2015-02-01 00:29:25.000000', 'consum', 0.0229, 'lps'),
	(383969, 124, '2015-02-01 00:29:26.000000', 'consum', 0.0226, 'lps'),
	(383970, 124, '2015-02-01 00:29:27.000000', 'consum', 0.0213, 'lps'),
	(383971, 124, '2015-02-01 00:29:28.000000', 'consum', 0.0220, 'lps'),
	(383972, 124, '2015-02-01 00:29:29.000000', 'consum', 0.0229, 'lps'),
	(383973, 124, '2015-02-01 00:29:30.000000', 'consum', 0.0214, 'lps'),
	(383974, 124, '2015-02-01 00:29:31.000000', 'consum', 0.0214, 'lps'),
	(383975, 124, '2015-02-01 00:29:32.000000', 'consum', 0.0219, 'lps'),
	(383976, 124, '2015-02-01 00:29:33.000000', 'consum', 0.0222, 'lps'),
	(383977, 124, '2015-02-01 00:29:34.000000', 'consum', 0.0225, 'lps'),
	(383978, 124, '2015-02-01 00:29:35.000000', 'consum', 0.0226, 'lps'),
	(383979, 124, '2015-02-01 00:29:36.000000', 'consum', 0.0225, 'lps'),
	(383980, 124, '2015-02-01 00:29:37.000000', 'consum', 0.0219, 'lps'),
	(383981, 124, '2015-02-01 00:29:38.000000', 'consum', 0.0229, 'lps'),
	(383982, 124, '2015-02-01 00:29:39.000000', 'consum', 0.0214, 'lps'),
	(383983, 124, '2015-02-01 00:29:40.000000', 'consum', 0.0217, 'lps'),
	(383984, 124, '2015-02-01 00:29:41.000000', 'consum', 0.0213, 'lps'),
	(383985, 124, '2015-02-01 00:29:42.000000', 'consum', 0.0226, 'lps'),
	(383986, 124, '2015-02-01 00:29:43.000000', 'consum', 0.0217, 'lps'),
	(383987, 124, '2015-02-01 00:29:44.000000', 'consum', 0.0221, 'lps'),
	(383988, 124, '2015-02-01 00:29:45.000000', 'consum', 0.0222, 'lps'),
	(383989, 124, '2015-02-01 00:29:46.000000', 'consum', 0.0215, 'lps'),
	(383990, 124, '2015-02-01 00:29:47.000000', 'consum', 0.0223, 'lps'),
	(383991, 124, '2015-02-01 00:29:48.000000', 'consum', 0.0217, 'lps'),
	(383992, 124, '2015-02-01 00:29:49.000000', 'consum', 0.0228, 'lps'),
	(383993, 124, '2015-02-01 00:29:50.000000', 'consum', 0.0218, 'lps'),
	(383994, 124, '2015-02-01 00:29:51.000000', 'consum', 0.0216, 'lps'),
	(383995, 124, '2015-02-01 00:29:52.000000', 'consum', 0.0218, 'lps'),
	(383996, 124, '2015-02-01 00:29:53.000000', 'consum', 0.0230, 'lps'),
	(383997, 124, '2015-02-01 00:29:54.000000', 'consum', 0.0223, 'lps'),
	(383998, 124, '2015-02-01 00:29:55.000000', 'consum', 0.0214, 'lps'),
	(383999, 124, '2015-02-01 00:29:56.000000', 'consum', 0.0216, 'lps'),
	(384000, 124, '2015-02-01 00:29:57.000000', 'consum', 0.0229, 'lps'),
	(384001, 124, '2015-02-01 00:29:58.000000', 'consum', 0.0225, 'lps'),
	(384002, 124, '2015-02-01 00:29:59.000000', 'consum', 0.0229, 'lps'),
	(384003, 124, '2015-02-01 00:30:00.000000', 'consum', 0.0217, 'lps'),
	(384004, 124, '2015-02-01 00:30:01.000000', 'consum', 0.0211, 'lps'),
	(384005, 124, '2015-02-01 00:30:02.000000', 'consum', 0.0215, 'lps'),
	(384006, 124, '2015-02-01 00:30:03.000000', 'consum', 0.0213, 'lps'),
	(384007, 124, '2015-02-01 00:30:04.000000', 'consum', 0.0211, 'lps'),
	(384008, 124, '2015-02-01 00:30:05.000000', 'consum', 0.0225, 'lps'),
	(384009, 124, '2015-02-01 00:30:06.000000', 'consum', 0.0219, 'lps'),
	(384010, 124, '2015-02-01 00:30:07.000000', 'consum', 0.0212, 'lps'),
	(384011, 124, '2015-02-01 00:30:08.000000', 'consum', 0.0213, 'lps'),
	(384012, 124, '2015-02-01 00:30:09.000000', 'consum', 0.0218, 'lps'),
	(384013, 124, '2015-02-01 00:30:10.000000', 'consum', 0.0223, 'lps'),
	(384014, 124, '2015-02-01 00:30:11.000000', 'consum', 0.0211, 'lps'),
	(384015, 124, '2015-02-01 00:30:12.000000', 'consum', 0.0216, 'lps'),
	(384016, 124, '2015-02-01 00:30:13.000000', 'consum', 0.0218, 'lps'),
	(384017, 124, '2015-02-01 00:30:14.000000', 'consum', 0.0212, 'lps'),
	(384018, 124, '2015-02-01 00:30:15.000000', 'consum', 0.0217, 'lps'),
	(384019, 124, '2015-02-01 00:30:16.000000', 'consum', 0.0220, 'lps'),
	(384020, 124, '2015-02-01 00:30:17.000000', 'consum', 0.0217, 'lps'),
	(384021, 124, '2015-02-01 00:30:18.000000', 'consum', 0.0217, 'lps'),
	(384022, 124, '2015-02-01 00:30:19.000000', 'consum', 0.0222, 'lps'),
	(384023, 124, '2015-02-01 00:30:20.000000', 'consum', 0.0228, 'lps'),
	(384024, 124, '2015-02-01 00:30:21.000000', 'consum', 0.0226, 'lps'),
	(384025, 124, '2015-02-01 00:30:22.000000', 'consum', 0.0213, 'lps'),
	(384026, 124, '2015-02-01 00:30:23.000000', 'consum', 0.0218, 'lps'),
	(384027, 124, '2015-02-01 00:30:24.000000', 'consum', 0.0223, 'lps'),
	(384028, 124, '2015-02-01 00:30:25.000000', 'consum', 0.0228, 'lps'),
	(384029, 124, '2015-02-01 00:30:26.000000', 'consum', 0.0221, 'lps'),
	(384030, 124, '2015-02-01 00:30:27.000000', 'consum', 0.0213, 'lps'),
	(384031, 124, '2015-02-01 00:30:28.000000', 'consum', 0.0213, 'lps'),
	(384032, 124, '2015-02-01 00:30:29.000000', 'consum', 0.0214, 'lps'),
	(384033, 124, '2015-02-01 00:30:30.000000', 'consum', 0.0223, 'lps'),
	(384034, 124, '2015-02-01 00:30:31.000000', 'consum', 0.0223, 'lps'),
	(384035, 124, '2015-02-01 00:30:32.000000', 'consum', 0.0213, 'lps'),
	(384036, 124, '2015-02-01 00:30:33.000000', 'consum', 0.0229, 'lps'),
	(384037, 124, '2015-02-01 00:30:34.000000', 'consum', 0.0212, 'lps'),
	(384038, 124, '2015-02-01 00:30:35.000000', 'consum', 0.0227, 'lps'),
	(384039, 124, '2015-02-01 00:30:36.000000', 'consum', 0.0228, 'lps'),
	(384040, 124, '2015-02-01 00:30:37.000000', 'consum', 0.0226, 'lps'),
	(384041, 124, '2015-02-01 00:30:38.000000', 'consum', 0.0218, 'lps'),
	(384042, 124, '2015-02-01 00:30:39.000000', 'consum', 0.0220, 'lps'),
	(384043, 124, '2015-02-01 00:30:40.000000', 'consum', 0.0219, 'lps'),
	(384044, 124, '2015-02-01 00:30:41.000000', 'consum', 0.0224, 'lps'),
	(384045, 124, '2015-02-01 00:30:42.000000', 'consum', 0.0210, 'lps'),
	(384046, 124, '2015-02-01 00:30:43.000000', 'consum', 0.0212, 'lps'),
	(384047, 124, '2015-02-01 00:30:44.000000', 'consum', 0.0222, 'lps'),
	(384048, 124, '2015-02-01 00:30:45.000000', 'consum', 0.0222, 'lps'),
	(384049, 124, '2015-02-01 00:30:46.000000', 'consum', 0.0215, 'lps'),
	(384050, 124, '2015-02-01 00:30:47.000000', 'consum', 0.0218, 'lps'),
	(384051, 124, '2015-02-01 00:30:48.000000', 'consum', 0.0216, 'lps'),
	(384052, 124, '2015-02-01 00:30:49.000000', 'consum', 0.0217, 'lps'),
	(384053, 124, '2015-02-01 00:30:50.000000', 'consum', 0.0228, 'lps'),
	(384054, 124, '2015-02-01 00:30:51.000000', 'consum', 0.0215, 'lps'),
	(384055, 124, '2015-02-01 00:30:52.000000', 'consum', 0.0226, 'lps'),
	(384056, 124, '2015-02-01 00:30:53.000000', 'consum', 0.0211, 'lps'),
	(384057, 124, '2015-02-01 00:30:54.000000', 'consum', 0.0229, 'lps'),
	(384058, 124, '2015-02-01 00:30:55.000000', 'consum', 0.0221, 'lps'),
	(384059, 124, '2015-02-01 00:30:56.000000', 'consum', 0.0227, 'lps'),
	(384060, 124, '2015-02-01 00:30:57.000000', 'consum', 0.0220, 'lps'),
	(384061, 124, '2015-02-01 00:30:58.000000', 'consum', 0.0230, 'lps'),
	(384062, 124, '2015-02-01 00:30:59.000000', 'consum', 0.0220, 'lps'),
	(384063, 124, '2015-02-01 00:31:00.000000', 'consum', 0.0222, 'lps'),
	(384064, 124, '2015-02-01 00:31:01.000000', 'consum', 0.0219, 'lps'),
	(384065, 124, '2015-02-01 00:31:02.000000', 'consum', 0.0220, 'lps'),
	(384066, 124, '2015-02-01 00:31:03.000000', 'consum', 0.0212, 'lps'),
	(384067, 124, '2015-02-01 00:31:04.000000', 'consum', 0.0210, 'lps'),
	(384068, 124, '2015-02-01 00:31:05.000000', 'consum', 0.0226, 'lps'),
	(384069, 124, '2015-02-01 00:31:06.000000', 'consum', 0.0229, 'lps'),
	(384070, 124, '2015-02-01 00:31:07.000000', 'consum', 0.0216, 'lps'),
	(384071, 124, '2015-02-01 00:31:08.000000', 'consum', 0.0226, 'lps'),
	(384072, 124, '2015-02-01 00:31:09.000000', 'consum', 0.0228, 'lps'),
	(384073, 124, '2015-02-01 00:31:10.000000', 'consum', 0.0210, 'lps'),
	(384074, 124, '2015-02-01 00:31:11.000000', 'consum', 0.0222, 'lps'),
	(384075, 124, '2015-02-01 00:31:12.000000', 'consum', 0.0226, 'lps'),
	(384076, 124, '2015-02-01 00:31:13.000000', 'consum', 0.0213, 'lps'),
	(384077, 124, '2015-02-01 00:31:14.000000', 'consum', 0.0218, 'lps'),
	(384078, 124, '2015-02-01 00:31:15.000000', 'consum', 0.0221, 'lps'),
	(384079, 124, '2015-02-01 00:31:16.000000', 'consum', 0.0223, 'lps'),
	(384080, 124, '2015-02-01 00:31:17.000000', 'consum', 0.0220, 'lps'),
	(384081, 124, '2015-02-01 00:31:18.000000', 'consum', 0.0220, 'lps'),
	(384082, 124, '2015-02-01 00:31:19.000000', 'consum', 0.0210, 'lps'),
	(384083, 124, '2015-02-01 00:31:20.000000', 'consum', 0.0222, 'lps'),
	(384084, 124, '2015-02-01 00:31:21.000000', 'consum', 0.0229, 'lps'),
	(384085, 124, '2015-02-01 00:31:22.000000', 'consum', 0.0226, 'lps'),
	(384086, 124, '2015-02-01 00:31:23.000000', 'consum', 0.0216, 'lps'),
	(384087, 124, '2015-02-01 00:31:24.000000', 'consum', 0.0210, 'lps'),
	(384088, 124, '2015-02-01 00:31:25.000000', 'consum', 0.0216, 'lps'),
	(384089, 124, '2015-02-01 00:31:26.000000', 'consum', 0.0219, 'lps'),
	(384090, 124, '2015-02-01 00:31:27.000000', 'consum', 0.0214, 'lps'),
	(384091, 124, '2015-02-01 00:31:28.000000', 'consum', 0.0227, 'lps'),
	(384092, 124, '2015-02-01 00:31:29.000000', 'consum', 0.0219, 'lps'),
	(384093, 124, '2015-02-01 00:31:30.000000', 'consum', 0.0226, 'lps'),
	(384094, 124, '2015-02-01 00:31:31.000000', 'consum', 0.0221, 'lps'),
	(384095, 124, '2015-02-01 00:31:32.000000', 'consum', 0.0218, 'lps'),
	(384096, 124, '2015-02-01 00:31:33.000000', 'consum', 0.0217, 'lps'),
	(384097, 124, '2015-02-01 00:31:34.000000', 'consum', 0.0223, 'lps'),
	(384098, 124, '2015-02-01 00:31:35.000000', 'consum', 0.0214, 'lps'),
	(384099, 124, '2015-02-01 00:31:36.000000', 'consum', 0.0210, 'lps'),
	(384100, 124, '2015-02-01 00:31:37.000000', 'consum', 0.0220, 'lps'),
	(384101, 124, '2015-02-01 00:31:38.000000', 'consum', 0.0218, 'lps'),
	(384102, 124, '2015-02-01 00:31:39.000000', 'consum', 0.0219, 'lps'),
	(384103, 124, '2015-02-01 00:31:40.000000', 'consum', 0.0213, 'lps'),
	(384104, 124, '2015-02-01 00:31:41.000000', 'consum', 0.0217, 'lps'),
	(384105, 124, '2015-02-01 00:31:42.000000', 'consum', 0.0219, 'lps'),
	(384106, 124, '2015-02-01 00:31:43.000000', 'consum', 0.0210, 'lps'),
	(384107, 124, '2015-02-01 00:31:44.000000', 'consum', 0.0226, 'lps'),
	(384108, 124, '2015-02-01 00:31:45.000000', 'consum', 0.0228, 'lps'),
	(384109, 124, '2015-02-01 00:31:46.000000', 'consum', 0.0211, 'lps'),
	(384110, 124, '2015-02-01 00:31:47.000000', 'consum', 0.0225, 'lps'),
	(384111, 124, '2015-02-01 00:31:48.000000', 'consum', 0.0217, 'lps'),
	(384112, 124, '2015-02-01 00:31:49.000000', 'consum', 0.0224, 'lps'),
	(384113, 124, '2015-02-01 00:31:50.000000', 'consum', 0.0218, 'lps'),
	(384114, 124, '2015-02-01 00:31:51.000000', 'consum', 0.0228, 'lps'),
	(384115, 124, '2015-02-01 00:31:52.000000', 'consum', 0.0216, 'lps'),
	(384116, 124, '2015-02-01 00:31:53.000000', 'consum', 0.0226, 'lps'),
	(384117, 124, '2015-02-01 00:31:54.000000', 'consum', 0.0210, 'lps'),
	(384118, 124, '2015-02-01 00:31:55.000000', 'consum', 0.0226, 'lps'),
	(384119, 124, '2015-02-01 00:31:56.000000', 'consum', 0.0226, 'lps'),
	(384120, 124, '2015-02-01 00:31:57.000000', 'consum', 0.0222, 'lps'),
	(384121, 124, '2015-02-01 00:31:58.000000', 'consum', 0.0221, 'lps'),
	(384122, 124, '2015-02-01 00:31:59.000000', 'consum', 0.0230, 'lps'),
	(384123, 124, '2015-02-01 00:32:00.000000', 'consum', 0.0216, 'lps'),
	(384124, 124, '2015-02-01 00:32:01.000000', 'consum', 0.0223, 'lps'),
	(384125, 124, '2015-02-01 00:32:02.000000', 'consum', 0.0216, 'lps'),
	(384126, 124, '2015-02-01 00:32:03.000000', 'consum', 0.0222, 'lps'),
	(384127, 124, '2015-02-01 00:32:04.000000', 'consum', 0.0212, 'lps'),
	(384128, 124, '2015-02-01 00:32:05.000000', 'consum', 0.0224, 'lps'),
	(384129, 124, '2015-02-01 00:32:06.000000', 'consum', 0.0213, 'lps'),
	(384130, 124, '2015-02-01 00:32:07.000000', 'consum', 0.0224, 'lps'),
	(384131, 124, '2015-02-01 00:32:08.000000', 'consum', 0.0230, 'lps'),
	(384132, 124, '2015-02-01 00:32:09.000000', 'consum', 0.0225, 'lps'),
	(384133, 124, '2015-02-01 00:32:10.000000', 'consum', 0.0225, 'lps'),
	(384134, 124, '2015-02-01 00:32:11.000000', 'consum', 0.0222, 'lps'),
	(384135, 124, '2015-02-01 00:32:12.000000', 'consum', 0.0225, 'lps'),
	(384136, 124, '2015-02-01 00:32:13.000000', 'consum', 0.0227, 'lps'),
	(384137, 124, '2015-02-01 00:32:14.000000', 'consum', 0.0211, 'lps'),
	(384138, 124, '2015-02-01 00:32:15.000000', 'consum', 0.0228, 'lps'),
	(384139, 124, '2015-02-01 00:32:16.000000', 'consum', 0.0213, 'lps'),
	(384140, 124, '2015-02-01 00:32:17.000000', 'consum', 0.0213, 'lps'),
	(384141, 124, '2015-02-01 00:32:18.000000', 'consum', 0.0217, 'lps'),
	(384142, 124, '2015-02-01 00:32:19.000000', 'consum', 0.0214, 'lps'),
	(384143, 124, '2015-02-01 00:32:20.000000', 'consum', 0.0212, 'lps'),
	(384144, 124, '2015-02-01 00:32:21.000000', 'consum', 0.0230, 'lps'),
	(384145, 124, '2015-02-01 00:32:22.000000', 'consum', 0.0218, 'lps'),
	(384146, 124, '2015-02-01 00:32:23.000000', 'consum', 0.0211, 'lps'),
	(384147, 124, '2015-02-01 00:32:24.000000', 'consum', 0.0213, 'lps'),
	(384148, 124, '2015-02-01 00:32:25.000000', 'consum', 0.0223, 'lps'),
	(384149, 124, '2015-02-01 00:32:26.000000', 'consum', 0.0226, 'lps'),
	(384150, 124, '2015-02-01 00:32:27.000000', 'consum', 0.0228, 'lps'),
	(384151, 124, '2015-02-01 00:32:28.000000', 'consum', 0.0211, 'lps'),
	(384152, 124, '2015-02-01 00:32:29.000000', 'consum', 0.0223, 'lps'),
	(384153, 124, '2015-02-01 00:32:30.000000', 'consum', 0.0211, 'lps'),
	(384154, 124, '2015-02-01 00:32:31.000000', 'consum', 0.0217, 'lps'),
	(384155, 124, '2015-02-01 00:32:32.000000', 'consum', 0.0221, 'lps'),
	(384156, 124, '2015-02-01 00:32:33.000000', 'consum', 0.0224, 'lps'),
	(384157, 124, '2015-02-01 00:32:34.000000', 'consum', 0.0226, 'lps'),
	(384158, 124, '2015-02-01 00:32:35.000000', 'consum', 0.0229, 'lps'),
	(384159, 124, '2015-02-01 00:32:36.000000', 'consum', 0.0213, 'lps'),
	(384160, 124, '2015-02-01 00:32:37.000000', 'consum', 0.0211, 'lps'),
	(384161, 124, '2015-02-01 00:32:38.000000', 'consum', 0.0226, 'lps'),
	(384162, 124, '2015-02-01 00:32:39.000000', 'consum', 0.0227, 'lps'),
	(384163, 124, '2015-02-01 00:32:40.000000', 'consum', 0.0226, 'lps'),
	(384164, 124, '2015-02-01 00:32:41.000000', 'consum', 0.0219, 'lps'),
	(384165, 124, '2015-02-01 00:32:42.000000', 'consum', 0.0229, 'lps'),
	(384166, 124, '2015-02-01 00:32:43.000000', 'consum', 0.0214, 'lps'),
	(384167, 124, '2015-02-01 00:32:44.000000', 'consum', 0.0214, 'lps'),
	(384168, 124, '2015-02-01 00:32:45.000000', 'consum', 0.0221, 'lps'),
	(384169, 124, '2015-02-01 00:32:46.000000', 'consum', 0.0212, 'lps'),
	(384170, 124, '2015-02-01 00:32:47.000000', 'consum', 0.0228, 'lps'),
	(384171, 124, '2015-02-01 00:32:48.000000', 'consum', 0.0230, 'lps'),
	(384172, 124, '2015-02-01 00:32:49.000000', 'consum', 0.0217, 'lps'),
	(384173, 124, '2015-02-01 00:32:50.000000', 'consum', 0.0228, 'lps'),
	(384174, 124, '2015-02-01 00:32:51.000000', 'consum', 0.0218, 'lps'),
	(384175, 124, '2015-02-01 00:32:52.000000', 'consum', 0.0214, 'lps'),
	(384176, 124, '2015-02-01 00:32:53.000000', 'consum', 0.0229, 'lps'),
	(384177, 124, '2015-02-01 00:32:54.000000', 'consum', 0.0228, 'lps'),
	(384178, 124, '2015-02-01 00:32:55.000000', 'consum', 0.0226, 'lps'),
	(384179, 124, '2015-02-01 00:32:56.000000', 'consum', 0.0212, 'lps'),
	(384180, 124, '2015-02-01 00:32:57.000000', 'consum', 0.0217, 'lps'),
	(384181, 124, '2015-02-01 00:32:58.000000', 'consum', 0.0218, 'lps'),
	(384182, 124, '2015-02-01 00:32:59.000000', 'consum', 0.0229, 'lps'),
	(384183, 124, '2015-02-01 00:33:00.000000', 'consum', 0.0219, 'lps'),
	(384184, 124, '2015-02-01 00:33:01.000000', 'consum', 0.0218, 'lps'),
	(384185, 124, '2015-02-01 00:33:02.000000', 'consum', 0.0225, 'lps'),
	(384186, 124, '2015-02-01 00:33:03.000000', 'consum', 0.0221, 'lps'),
	(384187, 124, '2015-02-01 00:33:04.000000', 'consum', 0.0218, 'lps'),
	(384188, 124, '2015-02-01 00:33:05.000000', 'consum', 0.0219, 'lps'),
	(384189, 124, '2015-02-01 00:33:06.000000', 'consum', 0.0210, 'lps'),
	(384190, 124, '2015-02-01 00:33:07.000000', 'consum', 0.0226, 'lps'),
	(384191, 124, '2015-02-01 00:33:08.000000', 'consum', 0.0226, 'lps'),
	(384192, 124, '2015-02-01 00:33:09.000000', 'consum', 0.0222, 'lps'),
	(384193, 124, '2015-02-01 00:33:10.000000', 'consum', 0.0223, 'lps'),
	(384194, 124, '2015-02-01 00:33:11.000000', 'consum', 0.0219, 'lps'),
	(384195, 124, '2015-02-01 00:33:12.000000', 'consum', 0.0217, 'lps'),
	(384196, 124, '2015-02-01 00:33:13.000000', 'consum', 0.0218, 'lps'),
	(384197, 124, '2015-02-01 00:33:14.000000', 'consum', 0.0229, 'lps'),
	(384198, 124, '2015-02-01 00:33:15.000000', 'consum', 0.0219, 'lps'),
	(384199, 124, '2015-02-01 00:33:16.000000', 'consum', 0.0221, 'lps'),
	(384200, 124, '2015-02-01 00:33:17.000000', 'consum', 0.0217, 'lps'),
	(384201, 124, '2015-02-01 00:33:18.000000', 'consum', 0.0213, 'lps'),
	(384202, 124, '2015-02-01 00:33:19.000000', 'consum', 0.0224, 'lps'),
	(384203, 124, '2015-02-01 00:33:20.000000', 'consum', 0.0211, 'lps'),
	(384204, 124, '2015-02-01 00:33:21.000000', 'consum', 0.0213, 'lps'),
	(384205, 124, '2015-02-01 00:33:22.000000', 'consum', 0.0225, 'lps'),
	(384206, 124, '2015-02-01 00:33:23.000000', 'consum', 0.0213, 'lps'),
	(384207, 124, '2015-02-01 00:33:24.000000', 'consum', 0.0221, 'lps'),
	(384208, 124, '2015-02-01 00:33:25.000000', 'consum', 0.0215, 'lps'),
	(384209, 124, '2015-02-01 00:33:26.000000', 'consum', 0.0225, 'lps'),
	(384210, 124, '2015-02-01 00:33:27.000000', 'consum', 0.0226, 'lps'),
	(384211, 124, '2015-02-01 00:33:28.000000', 'consum', 0.0227, 'lps'),
	(384212, 124, '2015-02-01 00:33:29.000000', 'consum', 0.0224, 'lps'),
	(384213, 124, '2015-02-01 00:33:30.000000', 'consum', 0.0210, 'lps'),
	(384214, 124, '2015-02-01 00:33:31.000000', 'consum', 0.0212, 'lps'),
	(384215, 124, '2015-02-01 00:33:32.000000', 'consum', 0.0218, 'lps'),
	(384216, 124, '2015-02-01 00:33:33.000000', 'consum', 0.0223, 'lps'),
	(384217, 124, '2015-02-01 00:33:34.000000', 'consum', 0.0212, 'lps'),
	(384218, 124, '2015-02-01 00:33:35.000000', 'consum', 0.0224, 'lps'),
	(384219, 124, '2015-02-01 00:33:36.000000', 'consum', 0.0230, 'lps'),
	(384220, 124, '2015-02-01 00:33:37.000000', 'consum', 0.0225, 'lps'),
	(384221, 124, '2015-02-01 00:33:38.000000', 'consum', 0.0229, 'lps'),
	(384222, 124, '2015-02-01 00:33:39.000000', 'consum', 0.0217, 'lps'),
	(384223, 124, '2015-02-01 00:33:40.000000', 'consum', 0.0230, 'lps'),
	(384224, 124, '2015-02-01 00:33:41.000000', 'consum', 0.0229, 'lps'),
	(384225, 124, '2015-02-01 00:33:42.000000', 'consum', 0.0222, 'lps'),
	(384226, 124, '2015-02-01 00:33:43.000000', 'consum', 0.0215, 'lps'),
	(384227, 124, '2015-02-01 00:33:44.000000', 'consum', 0.0221, 'lps'),
	(384228, 124, '2015-02-01 00:33:45.000000', 'consum', 0.0227, 'lps'),
	(384229, 124, '2015-02-01 00:33:46.000000', 'consum', 0.0223, 'lps'),
	(384230, 124, '2015-02-01 00:33:47.000000', 'consum', 0.0222, 'lps'),
	(384231, 124, '2015-02-01 00:33:48.000000', 'consum', 0.0210, 'lps'),
	(384232, 124, '2015-02-01 00:33:49.000000', 'consum', 0.0219, 'lps'),
	(384233, 124, '2015-02-01 00:33:50.000000', 'consum', 0.0213, 'lps'),
	(384234, 124, '2015-02-01 00:33:51.000000', 'consum', 0.0218, 'lps'),
	(384235, 124, '2015-02-01 00:33:52.000000', 'consum', 0.0223, 'lps'),
	(384236, 124, '2015-02-01 00:33:53.000000', 'consum', 0.0230, 'lps'),
	(384237, 124, '2015-02-01 00:33:54.000000', 'consum', 0.0228, 'lps'),
	(384238, 124, '2015-02-01 00:33:55.000000', 'consum', 0.0219, 'lps'),
	(384239, 124, '2015-02-01 00:33:56.000000', 'consum', 0.0221, 'lps'),
	(384240, 124, '2015-02-01 00:33:57.000000', 'consum', 0.0220, 'lps'),
	(384241, 124, '2015-02-01 00:33:58.000000', 'consum', 0.0228, 'lps'),
	(384242, 124, '2015-02-01 00:33:59.000000', 'consum', 0.0226, 'lps'),
	(384243, 124, '2015-02-01 00:34:00.000000', 'consum', 0.0218, 'lps'),
	(384244, 124, '2015-02-01 00:34:01.000000', 'consum', 0.0221, 'lps'),
	(384245, 124, '2015-02-01 00:34:02.000000', 'consum', 0.0220, 'lps'),
	(384246, 124, '2015-02-01 00:34:03.000000', 'consum', 0.0227, 'lps'),
	(384247, 124, '2015-02-01 00:34:04.000000', 'consum', 0.0223, 'lps'),
	(384248, 124, '2015-02-01 00:34:05.000000', 'consum', 0.0227, 'lps'),
	(384249, 124, '2015-02-01 00:34:06.000000', 'consum', 0.0212, 'lps'),
	(384250, 124, '2015-02-01 00:34:07.000000', 'consum', 0.0212, 'lps'),
	(384251, 124, '2015-02-01 00:34:08.000000', 'consum', 0.0213, 'lps'),
	(384252, 124, '2015-02-01 00:34:09.000000', 'consum', 0.0223, 'lps'),
	(384253, 124, '2015-02-01 00:34:10.000000', 'consum', 0.0222, 'lps'),
	(384254, 124, '2015-02-01 00:34:11.000000', 'consum', 0.0211, 'lps'),
	(384255, 124, '2015-02-01 00:34:12.000000', 'consum', 0.0224, 'lps'),
	(384256, 124, '2015-02-01 00:34:13.000000', 'consum', 0.0211, 'lps'),
	(384257, 124, '2015-02-01 00:34:14.000000', 'consum', 0.0218, 'lps'),
	(384258, 124, '2015-02-01 00:34:15.000000', 'consum', 0.0226, 'lps'),
	(384259, 124, '2015-02-01 00:34:16.000000', 'consum', 0.0225, 'lps'),
	(384260, 124, '2015-02-01 00:34:17.000000', 'consum', 0.0215, 'lps'),
	(384261, 124, '2015-02-01 00:34:18.000000', 'consum', 0.0214, 'lps'),
	(384262, 124, '2015-02-01 00:34:19.000000', 'consum', 0.0215, 'lps'),
	(384263, 124, '2015-02-01 00:34:20.000000', 'consum', 0.0223, 'lps'),
	(384264, 124, '2015-02-01 00:34:21.000000', 'consum', 0.0221, 'lps'),
	(384265, 124, '2015-02-01 00:34:22.000000', 'consum', 0.0223, 'lps'),
	(384266, 124, '2015-02-01 00:34:23.000000', 'consum', 0.0222, 'lps'),
	(384267, 124, '2015-02-01 00:34:24.000000', 'consum', 0.0212, 'lps'),
	(384268, 124, '2015-02-01 00:34:25.000000', 'consum', 0.0224, 'lps'),
	(384269, 124, '2015-02-01 00:34:26.000000', 'consum', 0.0212, 'lps'),
	(384270, 124, '2015-02-01 00:34:27.000000', 'consum', 0.0222, 'lps'),
	(384271, 124, '2015-02-01 00:34:28.000000', 'consum', 0.0221, 'lps'),
	(384272, 124, '2015-02-01 00:34:29.000000', 'consum', 0.0211, 'lps'),
	(384273, 124, '2015-02-01 00:34:30.000000', 'consum', 0.0222, 'lps'),
	(384274, 124, '2015-02-01 00:34:31.000000', 'consum', 0.0227, 'lps'),
	(384275, 124, '2015-02-01 00:34:32.000000', 'consum', 0.0218, 'lps'),
	(384276, 124, '2015-02-01 00:34:33.000000', 'consum', 0.0220, 'lps'),
	(384277, 124, '2015-02-01 00:34:34.000000', 'consum', 0.0217, 'lps'),
	(384278, 124, '2015-02-01 00:34:35.000000', 'consum', 0.0212, 'lps'),
	(384279, 124, '2015-02-01 00:34:36.000000', 'consum', 0.0224, 'lps'),
	(384280, 124, '2015-02-01 00:34:37.000000', 'consum', 0.0211, 'lps'),
	(384281, 124, '2015-02-01 00:34:38.000000', 'consum', 0.0213, 'lps'),
	(384282, 124, '2015-02-01 00:34:39.000000', 'consum', 0.0224, 'lps'),
	(384283, 124, '2015-02-01 00:34:40.000000', 'consum', 0.0210, 'lps'),
	(384284, 124, '2015-02-01 00:34:41.000000', 'consum', 0.0211, 'lps'),
	(384285, 124, '2015-02-01 00:34:42.000000', 'consum', 0.0213, 'lps'),
	(384286, 124, '2015-02-01 00:34:43.000000', 'consum', 0.0224, 'lps'),
	(384287, 124, '2015-02-01 00:34:44.000000', 'consum', 0.0228, 'lps'),
	(384288, 124, '2015-02-01 00:34:45.000000', 'consum', 0.0216, 'lps'),
	(384289, 124, '2015-02-01 00:34:46.000000', 'consum', 0.0228, 'lps'),
	(384290, 124, '2015-02-01 00:34:47.000000', 'consum', 0.0222, 'lps'),
	(384291, 124, '2015-02-01 00:34:48.000000', 'consum', 0.0216, 'lps'),
	(384292, 124, '2015-02-01 00:34:49.000000', 'consum', 0.0227, 'lps'),
	(384293, 124, '2015-02-01 00:34:50.000000', 'consum', 0.0212, 'lps'),
	(384294, 124, '2015-02-01 00:34:51.000000', 'consum', 0.0211, 'lps'),
	(384295, 124, '2015-02-01 00:34:52.000000', 'consum', 0.0210, 'lps'),
	(384296, 124, '2015-02-01 00:34:53.000000', 'consum', 0.0210, 'lps'),
	(384297, 124, '2015-02-01 00:34:54.000000', 'consum', 0.0228, 'lps'),
	(384298, 124, '2015-02-01 00:34:55.000000', 'consum', 0.0220, 'lps'),
	(384299, 124, '2015-02-01 00:34:56.000000', 'consum', 0.0225, 'lps'),
	(384300, 124, '2015-02-01 00:34:57.000000', 'consum', 0.0213, 'lps'),
	(384301, 124, '2015-02-01 00:34:58.000000', 'consum', 0.0224, 'lps'),
	(384302, 124, '2015-02-01 00:34:59.000000', 'consum', 0.0230, 'lps'),
	(384303, 124, '2015-02-01 00:35:00.000000', 'consum', 0.0224, 'lps'),
	(384304, 124, '2015-02-01 00:35:01.000000', 'consum', 0.0223, 'lps'),
	(384305, 124, '2015-02-01 00:35:02.000000', 'consum', 0.0210, 'lps'),
	(384306, 124, '2015-02-01 00:35:03.000000', 'consum', 0.0214, 'lps'),
	(384307, 124, '2015-02-01 00:35:04.000000', 'consum', 0.0229, 'lps'),
	(384308, 124, '2015-02-01 00:35:05.000000', 'consum', 0.0211, 'lps'),
	(384309, 124, '2015-02-01 00:35:06.000000', 'consum', 0.0223, 'lps'),
	(384310, 124, '2015-02-01 00:35:07.000000', 'consum', 0.0230, 'lps'),
	(384311, 124, '2015-02-01 00:35:08.000000', 'consum', 0.0230, 'lps'),
	(384312, 124, '2015-02-01 00:35:09.000000', 'consum', 0.0229, 'lps'),
	(384313, 124, '2015-02-01 00:35:10.000000', 'consum', 0.0224, 'lps'),
	(384314, 124, '2015-02-01 00:35:11.000000', 'consum', 0.0225, 'lps'),
	(384315, 124, '2015-02-01 00:35:12.000000', 'consum', 0.0224, 'lps'),
	(384316, 124, '2015-02-01 00:35:13.000000', 'consum', 0.0212, 'lps'),
	(384317, 124, '2015-02-01 00:35:14.000000', 'consum', 0.0219, 'lps'),
	(384318, 124, '2015-02-01 00:35:15.000000', 'consum', 0.0230, 'lps'),
	(384319, 124, '2015-02-01 00:35:16.000000', 'consum', 0.0222, 'lps'),
	(384320, 124, '2015-02-01 00:35:17.000000', 'consum', 0.0211, 'lps'),
	(384321, 124, '2015-02-01 00:35:18.000000', 'consum', 0.0222, 'lps'),
	(384322, 124, '2015-02-01 00:35:19.000000', 'consum', 0.0225, 'lps'),
	(384323, 124, '2015-02-01 00:35:20.000000', 'consum', 0.0228, 'lps'),
	(384324, 124, '2015-02-01 00:35:21.000000', 'consum', 0.0214, 'lps'),
	(384325, 124, '2015-02-01 00:35:22.000000', 'consum', 0.0218, 'lps'),
	(384326, 124, '2015-02-01 00:35:23.000000', 'consum', 0.0217, 'lps'),
	(384327, 124, '2015-02-01 00:35:24.000000', 'consum', 0.0224, 'lps'),
	(384328, 124, '2015-02-01 00:35:25.000000', 'consum', 0.0216, 'lps'),
	(384329, 124, '2015-02-01 00:35:26.000000', 'consum', 0.0219, 'lps'),
	(384330, 124, '2015-02-01 00:35:27.000000', 'consum', 0.0217, 'lps'),
	(384331, 124, '2015-02-01 00:35:28.000000', 'consum', 0.0217, 'lps'),
	(384332, 124, '2015-02-01 00:35:29.000000', 'consum', 0.0225, 'lps'),
	(384333, 124, '2015-02-01 00:35:30.000000', 'consum', 0.0221, 'lps'),
	(384334, 124, '2015-02-01 00:35:31.000000', 'consum', 0.0222, 'lps'),
	(384335, 124, '2015-02-01 00:35:32.000000', 'consum', 0.0215, 'lps'),
	(384336, 124, '2015-02-01 00:35:33.000000', 'consum', 0.0220, 'lps'),
	(384337, 124, '2015-02-01 00:35:34.000000', 'consum', 0.0225, 'lps'),
	(384338, 124, '2015-02-01 00:35:35.000000', 'consum', 0.0213, 'lps'),
	(384339, 124, '2015-02-01 00:35:36.000000', 'consum', 0.0221, 'lps'),
	(384340, 124, '2015-02-01 00:35:37.000000', 'consum', 0.0217, 'lps'),
	(384341, 124, '2015-02-01 00:35:38.000000', 'consum', 0.0210, 'lps'),
	(384342, 124, '2015-02-01 00:35:39.000000', 'consum', 0.0213, 'lps'),
	(384343, 124, '2015-02-01 00:35:40.000000', 'consum', 0.0227, 'lps'),
	(384344, 124, '2015-02-01 00:35:41.000000', 'consum', 0.0221, 'lps'),
	(384345, 124, '2015-02-01 00:35:42.000000', 'consum', 0.0214, 'lps'),
	(384346, 124, '2015-02-01 00:35:43.000000', 'consum', 0.0219, 'lps'),
	(384347, 124, '2015-02-01 00:35:44.000000', 'consum', 0.0221, 'lps'),
	(384348, 124, '2015-02-01 00:35:45.000000', 'consum', 0.0217, 'lps'),
	(384349, 124, '2015-02-01 00:35:46.000000', 'consum', 0.0212, 'lps'),
	(384350, 124, '2015-02-01 00:35:47.000000', 'consum', 0.0222, 'lps'),
	(384351, 124, '2015-02-01 00:35:48.000000', 'consum', 0.0224, 'lps'),
	(384352, 124, '2015-02-01 00:35:49.000000', 'consum', 0.0223, 'lps'),
	(384353, 124, '2015-02-01 00:35:50.000000', 'consum', 0.0213, 'lps'),
	(384354, 124, '2015-02-01 00:35:51.000000', 'consum', 0.0228, 'lps'),
	(384355, 124, '2015-02-01 00:35:52.000000', 'consum', 0.0230, 'lps'),
	(384356, 124, '2015-02-01 00:35:53.000000', 'consum', 0.0212, 'lps'),
	(384357, 124, '2015-02-01 00:35:54.000000', 'consum', 0.0225, 'lps'),
	(384358, 124, '2015-02-01 00:35:55.000000', 'consum', 0.0215, 'lps'),
	(384359, 124, '2015-02-01 00:35:56.000000', 'consum', 0.0214, 'lps'),
	(384360, 124, '2015-02-01 00:35:57.000000', 'consum', 0.0212, 'lps'),
	(384361, 124, '2015-02-01 00:35:58.000000', 'consum', 0.0211, 'lps'),
	(384362, 124, '2015-02-01 00:35:59.000000', 'consum', 0.0229, 'lps'),
	(384363, 124, '2015-02-01 00:36:00.000000', 'consum', 0.0220, 'lps'),
	(384364, 124, '2015-02-01 00:36:01.000000', 'consum', 0.0224, 'lps'),
	(384365, 124, '2015-02-01 00:36:02.000000', 'consum', 0.0230, 'lps'),
	(384366, 124, '2015-02-01 00:36:03.000000', 'consum', 0.0226, 'lps'),
	(384367, 124, '2015-02-01 00:36:04.000000', 'consum', 0.0229, 'lps'),
	(384368, 124, '2015-02-01 00:36:05.000000', 'consum', 0.0216, 'lps'),
	(384369, 124, '2015-02-01 00:36:06.000000', 'consum', 0.0227, 'lps'),
	(384370, 124, '2015-02-01 00:36:07.000000', 'consum', 0.0212, 'lps'),
	(384371, 124, '2015-02-01 00:36:08.000000', 'consum', 0.0213, 'lps'),
	(384372, 124, '2015-02-01 00:36:09.000000', 'consum', 0.0217, 'lps'),
	(384373, 124, '2015-02-01 00:36:10.000000', 'consum', 0.0219, 'lps'),
	(384374, 124, '2015-02-01 00:36:11.000000', 'consum', 0.0210, 'lps'),
	(384375, 124, '2015-02-01 00:36:12.000000', 'consum', 0.0227, 'lps'),
	(384376, 124, '2015-02-01 00:36:13.000000', 'consum', 0.0213, 'lps'),
	(384377, 124, '2015-02-01 00:36:14.000000', 'consum', 0.0213, 'lps'),
	(384378, 124, '2015-02-01 00:36:15.000000', 'consum', 0.0220, 'lps'),
	(384379, 124, '2015-02-01 00:36:16.000000', 'consum', 0.0228, 'lps'),
	(384380, 124, '2015-02-01 00:36:17.000000', 'consum', 0.0210, 'lps'),
	(384381, 124, '2015-02-01 00:36:18.000000', 'consum', 0.0219, 'lps'),
	(384382, 124, '2015-02-01 00:36:19.000000', 'consum', 0.0212, 'lps'),
	(384383, 124, '2015-02-01 00:36:20.000000', 'consum', 0.0214, 'lps'),
	(384384, 124, '2015-02-01 00:36:21.000000', 'consum', 0.0223, 'lps'),
	(384385, 124, '2015-02-01 00:36:22.000000', 'consum', 0.0225, 'lps'),
	(384386, 124, '2015-02-01 00:36:23.000000', 'consum', 0.0222, 'lps'),
	(384387, 124, '2015-02-01 00:36:24.000000', 'consum', 0.0228, 'lps'),
	(384388, 124, '2015-02-01 00:36:25.000000', 'consum', 0.0222, 'lps'),
	(384389, 124, '2015-02-01 00:36:26.000000', 'consum', 0.0218, 'lps'),
	(384390, 124, '2015-02-01 00:36:27.000000', 'consum', 0.0214, 'lps'),
	(384391, 124, '2015-02-01 00:36:28.000000', 'consum', 0.0225, 'lps'),
	(384392, 124, '2015-02-01 00:36:29.000000', 'consum', 0.0212, 'lps'),
	(384393, 124, '2015-02-01 00:36:30.000000', 'consum', 0.0217, 'lps'),
	(384394, 124, '2015-02-01 00:36:31.000000', 'consum', 0.0220, 'lps'),
	(384395, 124, '2015-02-01 00:36:32.000000', 'consum', 0.0218, 'lps'),
	(384396, 124, '2015-02-01 00:36:33.000000', 'consum', 0.0221, 'lps'),
	(384397, 124, '2015-02-01 00:36:34.000000', 'consum', 0.0219, 'lps'),
	(384398, 124, '2015-02-01 00:36:35.000000', 'consum', 0.0222, 'lps'),
	(384399, 124, '2015-02-01 00:36:36.000000', 'consum', 0.0221, 'lps'),
	(384400, 124, '2015-02-01 00:36:37.000000', 'consum', 0.0211, 'lps'),
	(384401, 124, '2015-02-01 00:36:38.000000', 'consum', 0.0225, 'lps'),
	(384402, 124, '2015-02-01 00:36:39.000000', 'consum', 0.0220, 'lps'),
	(384403, 124, '2015-02-01 00:36:40.000000', 'consum', 0.0217, 'lps'),
	(384404, 124, '2015-02-01 00:36:41.000000', 'consum', 0.0213, 'lps'),
	(384405, 124, '2015-02-01 00:36:42.000000', 'consum', 0.0224, 'lps'),
	(384406, 124, '2015-02-01 00:36:43.000000', 'consum', 0.0210, 'lps'),
	(384407, 124, '2015-02-01 00:36:44.000000', 'consum', 0.0230, 'lps'),
	(384408, 124, '2015-02-01 00:36:45.000000', 'consum', 0.0229, 'lps'),
	(384409, 124, '2015-02-01 00:36:46.000000', 'consum', 0.0222, 'lps'),
	(384410, 124, '2015-02-01 00:36:47.000000', 'consum', 0.0216, 'lps'),
	(384411, 124, '2015-02-01 00:36:48.000000', 'consum', 0.0226, 'lps'),
	(384412, 124, '2015-02-01 00:36:49.000000', 'consum', 0.0210, 'lps'),
	(384413, 124, '2015-02-01 00:36:50.000000', 'consum', 0.0226, 'lps'),
	(384414, 124, '2015-02-01 00:36:51.000000', 'consum', 0.0226, 'lps'),
	(384415, 124, '2015-02-01 00:36:52.000000', 'consum', 0.0221, 'lps'),
	(384416, 124, '2015-02-01 00:36:53.000000', 'consum', 0.0218, 'lps'),
	(384417, 124, '2015-02-01 00:36:54.000000', 'consum', 0.0219, 'lps'),
	(384418, 124, '2015-02-01 00:36:55.000000', 'consum', 0.0211, 'lps'),
	(384419, 124, '2015-02-01 00:36:56.000000', 'consum', 0.0228, 'lps'),
	(384420, 124, '2015-02-01 00:36:57.000000', 'consum', 0.0215, 'lps'),
	(384421, 124, '2015-02-01 00:36:58.000000', 'consum', 0.0223, 'lps'),
	(384422, 124, '2015-02-01 00:36:59.000000', 'consum', 0.0217, 'lps'),
	(384423, 124, '2015-02-01 00:37:00.000000', 'consum', 0.0228, 'lps'),
	(384424, 124, '2015-02-01 00:37:01.000000', 'consum', 0.0218, 'lps'),
	(384425, 124, '2015-02-01 00:37:02.000000', 'consum', 0.0218, 'lps'),
	(384426, 124, '2015-02-01 00:37:03.000000', 'consum', 0.0226, 'lps'),
	(384427, 124, '2015-02-01 00:37:04.000000', 'consum', 0.0224, 'lps'),
	(384428, 124, '2015-02-01 00:37:05.000000', 'consum', 0.0210, 'lps'),
	(384429, 124, '2015-02-01 00:37:06.000000', 'consum', 0.0210, 'lps'),
	(384430, 124, '2015-02-01 00:37:07.000000', 'consum', 0.0212, 'lps'),
	(384431, 124, '2015-02-01 00:37:08.000000', 'consum', 0.0221, 'lps'),
	(384432, 124, '2015-02-01 00:37:09.000000', 'consum', 0.0217, 'lps'),
	(384433, 124, '2015-02-01 00:37:10.000000', 'consum', 0.0214, 'lps'),
	(384434, 124, '2015-02-01 00:37:11.000000', 'consum', 0.0229, 'lps'),
	(384435, 124, '2015-02-01 00:37:12.000000', 'consum', 0.0212, 'lps'),
	(384436, 124, '2015-02-01 00:37:13.000000', 'consum', 0.0223, 'lps'),
	(384437, 124, '2015-02-01 00:37:14.000000', 'consum', 0.0230, 'lps'),
	(384438, 124, '2015-02-01 00:37:15.000000', 'consum', 0.0229, 'lps'),
	(384439, 124, '2015-02-01 00:37:16.000000', 'consum', 0.0226, 'lps'),
	(384440, 124, '2015-02-01 00:37:17.000000', 'consum', 0.0213, 'lps'),
	(384441, 124, '2015-02-01 00:37:18.000000', 'consum', 0.0217, 'lps'),
	(384442, 124, '2015-02-01 00:37:19.000000', 'consum', 0.0218, 'lps'),
	(384443, 124, '2015-02-01 00:37:20.000000', 'consum', 0.0230, 'lps'),
	(384444, 124, '2015-02-01 00:37:21.000000', 'consum', 0.0222, 'lps'),
	(384445, 124, '2015-02-01 00:37:22.000000', 'consum', 0.0230, 'lps'),
	(384446, 124, '2015-02-01 00:37:23.000000', 'consum', 0.0214, 'lps'),
	(384447, 124, '2015-02-01 00:37:24.000000', 'consum', 0.0212, 'lps'),
	(384448, 124, '2015-02-01 00:37:25.000000', 'consum', 0.0229, 'lps'),
	(384449, 124, '2015-02-01 00:37:26.000000', 'consum', 0.0217, 'lps'),
	(384450, 124, '2015-02-01 00:37:27.000000', 'consum', 0.0229, 'lps'),
	(384451, 124, '2015-02-01 00:37:28.000000', 'consum', 0.0220, 'lps'),
	(384452, 124, '2015-02-01 00:37:29.000000', 'consum', 0.0228, 'lps'),
	(384453, 124, '2015-02-01 00:37:30.000000', 'consum', 0.0226, 'lps'),
	(384454, 124, '2015-02-01 00:37:31.000000', 'consum', 0.0216, 'lps'),
	(384455, 124, '2015-02-01 00:37:32.000000', 'consum', 0.0215, 'lps'),
	(384456, 124, '2015-02-01 00:37:33.000000', 'consum', 0.0217, 'lps'),
	(384457, 124, '2015-02-01 00:37:34.000000', 'consum', 0.0230, 'lps'),
	(384458, 124, '2015-02-01 00:37:35.000000', 'consum', 0.0227, 'lps'),
	(384459, 124, '2015-02-01 00:37:36.000000', 'consum', 0.0214, 'lps'),
	(384460, 124, '2015-02-01 00:37:37.000000', 'consum', 0.0223, 'lps'),
	(384461, 124, '2015-02-01 00:37:38.000000', 'consum', 0.0220, 'lps'),
	(384462, 124, '2015-02-01 00:37:39.000000', 'consum', 0.0220, 'lps'),
	(384463, 124, '2015-02-01 00:37:40.000000', 'consum', 0.0210, 'lps'),
	(384464, 124, '2015-02-01 00:37:41.000000', 'consum', 0.0225, 'lps'),
	(384465, 124, '2015-02-01 00:37:42.000000', 'consum', 0.0221, 'lps'),
	(384466, 124, '2015-02-01 00:37:43.000000', 'consum', 0.0220, 'lps'),
	(384467, 124, '2015-02-01 00:37:44.000000', 'consum', 0.0227, 'lps'),
	(384468, 124, '2015-02-01 00:37:45.000000', 'consum', 0.0225, 'lps'),
	(384469, 124, '2015-02-01 00:37:46.000000', 'consum', 0.0211, 'lps'),
	(384470, 124, '2015-02-01 00:37:47.000000', 'consum', 0.0214, 'lps'),
	(384471, 124, '2015-02-01 00:37:48.000000', 'consum', 0.0229, 'lps'),
	(384472, 124, '2015-02-01 00:37:49.000000', 'consum', 0.0230, 'lps'),
	(384473, 124, '2015-02-01 00:37:50.000000', 'consum', 0.0211, 'lps'),
	(384474, 124, '2015-02-01 00:37:51.000000', 'consum', 0.0218, 'lps'),
	(384475, 124, '2015-02-01 00:37:52.000000', 'consum', 0.0227, 'lps'),
	(384476, 124, '2015-02-01 00:37:53.000000', 'consum', 0.0227, 'lps'),
	(384477, 124, '2015-02-01 00:37:54.000000', 'consum', 0.0227, 'lps'),
	(384478, 124, '2015-02-01 00:37:55.000000', 'consum', 0.0220, 'lps'),
	(384479, 124, '2015-02-01 00:37:56.000000', 'consum', 0.0212, 'lps'),
	(384480, 124, '2015-02-01 00:37:57.000000', 'consum', 0.0213, 'lps'),
	(384481, 124, '2015-02-01 00:37:58.000000', 'consum', 0.0218, 'lps'),
	(384482, 124, '2015-02-01 00:37:59.000000', 'consum', 0.0220, 'lps'),
	(384483, 124, '2015-02-01 00:38:00.000000', 'consum', 0.0215, 'lps'),
	(384484, 124, '2015-02-01 00:38:01.000000', 'consum', 0.0226, 'lps'),
	(384485, 124, '2015-02-01 00:38:02.000000', 'consum', 0.0212, 'lps'),
	(384486, 124, '2015-02-01 00:38:03.000000', 'consum', 0.0215, 'lps'),
	(384487, 124, '2015-02-01 00:38:04.000000', 'consum', 0.0211, 'lps'),
	(384488, 124, '2015-02-01 00:38:05.000000', 'consum', 0.0219, 'lps'),
	(384489, 124, '2015-02-01 00:38:06.000000', 'consum', 0.0211, 'lps'),
	(384490, 124, '2015-02-01 00:38:07.000000', 'consum', 0.0211, 'lps'),
	(384491, 124, '2015-02-01 00:38:08.000000', 'consum', 0.0230, 'lps'),
	(384492, 124, '2015-02-01 00:38:09.000000', 'consum', 0.0227, 'lps'),
	(384493, 124, '2015-02-01 00:38:10.000000', 'consum', 0.0214, 'lps'),
	(384494, 124, '2015-02-01 00:38:11.000000', 'consum', 0.0221, 'lps'),
	(384495, 124, '2015-02-01 00:38:12.000000', 'consum', 0.0210, 'lps'),
	(384496, 124, '2015-02-01 00:38:13.000000', 'consum', 0.0222, 'lps'),
	(384497, 124, '2015-02-01 00:38:14.000000', 'consum', 0.0228, 'lps'),
	(384498, 124, '2015-02-01 00:38:15.000000', 'consum', 0.0221, 'lps'),
	(384499, 124, '2015-02-01 00:38:16.000000', 'consum', 0.0212, 'lps'),
	(384500, 124, '2015-02-01 00:38:17.000000', 'consum', 0.0229, 'lps'),
	(384501, 124, '2015-02-01 00:38:18.000000', 'consum', 0.0216, 'lps'),
	(384502, 124, '2015-02-01 00:38:19.000000', 'consum', 0.0227, 'lps'),
	(384503, 124, '2015-02-01 00:38:20.000000', 'consum', 0.0214, 'lps'),
	(384504, 124, '2015-02-01 00:38:21.000000', 'consum', 0.0219, 'lps'),
	(384505, 124, '2015-02-01 00:38:22.000000', 'consum', 0.0226, 'lps'),
	(384506, 124, '2015-02-01 00:38:23.000000', 'consum', 0.0218, 'lps'),
	(384507, 124, '2015-02-01 00:38:24.000000', 'consum', 0.0225, 'lps'),
	(384508, 124, '2015-02-01 00:38:25.000000', 'consum', 0.0219, 'lps'),
	(384509, 124, '2015-02-01 00:38:26.000000', 'consum', 0.0212, 'lps'),
	(384510, 124, '2015-02-01 00:38:27.000000', 'consum', 0.0216, 'lps'),
	(384511, 124, '2015-02-01 00:38:28.000000', 'consum', 0.0211, 'lps'),
	(384512, 124, '2015-02-01 00:38:29.000000', 'consum', 0.0219, 'lps'),
	(384513, 124, '2015-02-01 00:38:30.000000', 'consum', 0.0211, 'lps'),
	(384514, 124, '2015-02-01 00:38:31.000000', 'consum', 0.0210, 'lps'),
	(384515, 124, '2015-02-01 00:38:32.000000', 'consum', 0.0230, 'lps'),
	(384516, 124, '2015-02-01 00:38:33.000000', 'consum', 0.0225, 'lps'),
	(384517, 124, '2015-02-01 00:38:34.000000', 'consum', 0.0226, 'lps'),
	(384518, 124, '2015-02-01 00:38:35.000000', 'consum', 0.0225, 'lps'),
	(384519, 124, '2015-02-01 00:38:36.000000', 'consum', 0.0217, 'lps'),
	(384520, 124, '2015-02-01 00:38:37.000000', 'consum', 0.0221, 'lps'),
	(384521, 124, '2015-02-01 00:38:38.000000', 'consum', 0.0222, 'lps'),
	(384522, 124, '2015-02-01 00:38:39.000000', 'consum', 0.0217, 'lps'),
	(384523, 124, '2015-02-01 00:38:40.000000', 'consum', 0.0230, 'lps'),
	(384524, 124, '2015-02-01 00:38:41.000000', 'consum', 0.0227, 'lps'),
	(384525, 124, '2015-02-01 00:38:42.000000', 'consum', 0.0217, 'lps'),
	(384526, 124, '2015-02-01 00:38:43.000000', 'consum', 0.0212, 'lps'),
	(384527, 124, '2015-02-01 00:38:44.000000', 'consum', 0.0223, 'lps'),
	(384528, 124, '2015-02-01 00:38:45.000000', 'consum', 0.0229, 'lps'),
	(384529, 124, '2015-02-01 00:38:46.000000', 'consum', 0.0221, 'lps'),
	(384530, 124, '2015-02-01 00:38:47.000000', 'consum', 0.0210, 'lps'),
	(384531, 124, '2015-02-01 00:38:48.000000', 'consum', 0.0221, 'lps'),
	(384532, 124, '2015-02-01 00:38:49.000000', 'consum', 0.0220, 'lps'),
	(384533, 124, '2015-02-01 00:38:50.000000', 'consum', 0.0230, 'lps'),
	(384534, 124, '2015-02-01 00:38:51.000000', 'consum', 0.0218, 'lps'),
	(384535, 124, '2015-02-01 00:38:52.000000', 'consum', 0.0212, 'lps'),
	(384536, 124, '2015-02-01 00:38:53.000000', 'consum', 0.0217, 'lps'),
	(384537, 124, '2015-02-01 00:38:54.000000', 'consum', 0.0219, 'lps'),
	(384538, 124, '2015-02-01 00:38:55.000000', 'consum', 0.0214, 'lps'),
	(384539, 124, '2015-02-01 00:38:56.000000', 'consum', 0.0225, 'lps'),
	(384540, 124, '2015-02-01 00:38:57.000000', 'consum', 0.0229, 'lps'),
	(384541, 124, '2015-02-01 00:38:58.000000', 'consum', 0.0218, 'lps'),
	(384542, 124, '2015-02-01 00:38:59.000000', 'consum', 0.0216, 'lps'),
	(384543, 124, '2015-02-01 00:39:00.000000', 'consum', 0.0218, 'lps'),
	(384544, 124, '2015-02-01 00:39:01.000000', 'consum', 0.0210, 'lps'),
	(384545, 124, '2015-02-01 00:39:02.000000', 'consum', 0.0230, 'lps'),
	(384546, 124, '2015-02-01 00:39:03.000000', 'consum', 0.0223, 'lps'),
	(384547, 124, '2015-02-01 00:39:04.000000', 'consum', 0.0219, 'lps'),
	(384548, 124, '2015-02-01 00:39:05.000000', 'consum', 0.0217, 'lps'),
	(384549, 124, '2015-02-01 00:39:06.000000', 'consum', 0.0217, 'lps'),
	(384550, 124, '2015-02-01 00:39:07.000000', 'consum', 0.0225, 'lps'),
	(384551, 124, '2015-02-01 00:39:08.000000', 'consum', 0.0221, 'lps'),
	(384552, 124, '2015-02-01 00:39:09.000000', 'consum', 0.0220, 'lps'),
	(384553, 124, '2015-02-01 00:39:10.000000', 'consum', 0.0230, 'lps'),
	(384554, 124, '2015-02-01 00:39:11.000000', 'consum', 0.0215, 'lps'),
	(384555, 124, '2015-02-01 00:39:12.000000', 'consum', 0.0216, 'lps'),
	(384556, 124, '2015-02-01 00:39:13.000000', 'consum', 0.0229, 'lps'),
	(384557, 124, '2015-02-01 00:39:14.000000', 'consum', 0.0225, 'lps'),
	(384558, 124, '2015-02-01 00:39:15.000000', 'consum', 0.0226, 'lps'),
	(384559, 124, '2015-02-01 00:39:16.000000', 'consum', 0.0227, 'lps'),
	(384560, 124, '2015-02-01 00:39:17.000000', 'consum', 0.0224, 'lps'),
	(384561, 124, '2015-02-01 00:39:18.000000', 'consum', 0.0230, 'lps'),
	(384562, 124, '2015-02-01 00:39:19.000000', 'consum', 0.0225, 'lps'),
	(384563, 124, '2015-02-01 00:39:20.000000', 'consum', 0.0228, 'lps'),
	(384564, 124, '2015-02-01 00:39:21.000000', 'consum', 0.0214, 'lps'),
	(384565, 124, '2015-02-01 00:39:22.000000', 'consum', 0.0215, 'lps'),
	(384566, 124, '2015-02-01 00:39:23.000000', 'consum', 0.0227, 'lps'),
	(384567, 124, '2015-02-01 00:39:24.000000', 'consum', 0.0218, 'lps'),
	(384568, 124, '2015-02-01 00:39:25.000000', 'consum', 0.0219, 'lps'),
	(384569, 124, '2015-02-01 00:39:26.000000', 'consum', 0.0211, 'lps'),
	(384570, 124, '2015-02-01 00:39:27.000000', 'consum', 0.0211, 'lps'),
	(384571, 124, '2015-02-01 00:39:28.000000', 'consum', 0.0211, 'lps'),
	(384572, 124, '2015-02-01 00:39:29.000000', 'consum', 0.0214, 'lps'),
	(384573, 124, '2015-02-01 00:39:30.000000', 'consum', 0.0228, 'lps'),
	(384574, 124, '2015-02-01 00:39:31.000000', 'consum', 0.0224, 'lps'),
	(384575, 124, '2015-02-01 00:39:32.000000', 'consum', 0.0228, 'lps'),
	(384576, 124, '2015-02-01 00:39:33.000000', 'consum', 0.0216, 'lps'),
	(384577, 124, '2015-02-01 00:39:34.000000', 'consum', 0.0226, 'lps'),
	(384578, 124, '2015-02-01 00:39:35.000000', 'consum', 0.0213, 'lps'),
	(384579, 124, '2015-02-01 00:39:36.000000', 'consum', 0.0217, 'lps'),
	(384580, 124, '2015-02-01 00:39:37.000000', 'consum', 0.0217, 'lps'),
	(384581, 124, '2015-02-01 00:39:38.000000', 'consum', 0.0224, 'lps'),
	(384582, 124, '2015-02-01 00:39:39.000000', 'consum', 0.0216, 'lps'),
	(384583, 124, '2015-02-01 00:39:40.000000', 'consum', 0.0221, 'lps'),
	(384584, 124, '2015-02-01 00:39:41.000000', 'consum', 0.0227, 'lps'),
	(384585, 124, '2015-02-01 00:39:42.000000', 'consum', 0.0218, 'lps'),
	(384586, 124, '2015-02-01 00:39:43.000000', 'consum', 0.0224, 'lps'),
	(384587, 124, '2015-02-01 00:39:44.000000', 'consum', 0.0212, 'lps'),
	(384588, 124, '2015-02-01 00:39:45.000000', 'consum', 0.0223, 'lps'),
	(384589, 124, '2015-02-01 00:39:46.000000', 'consum', 0.0227, 'lps'),
	(384590, 124, '2015-02-01 00:39:47.000000', 'consum', 0.0214, 'lps'),
	(384591, 124, '2015-02-01 00:39:48.000000', 'consum', 0.0222, 'lps'),
	(384592, 124, '2015-02-01 00:39:49.000000', 'consum', 0.0217, 'lps'),
	(384593, 124, '2015-02-01 00:39:50.000000', 'consum', 0.0228, 'lps'),
	(384594, 124, '2015-02-01 00:39:51.000000', 'consum', 0.0217, 'lps'),
	(384595, 124, '2015-02-01 00:39:52.000000', 'consum', 0.0215, 'lps'),
	(384596, 124, '2015-02-01 00:39:53.000000', 'consum', 0.0214, 'lps'),
	(384597, 124, '2015-02-01 00:39:54.000000', 'consum', 0.0214, 'lps'),
	(384598, 124, '2015-02-01 00:39:55.000000', 'consum', 0.0220, 'lps'),
	(384599, 124, '2015-02-01 00:39:56.000000', 'consum', 0.0225, 'lps'),
	(384600, 124, '2015-02-01 00:39:57.000000', 'consum', 0.0215, 'lps'),
	(384601, 124, '2015-02-01 00:39:58.000000', 'consum', 0.0212, 'lps'),
	(384602, 124, '2015-02-01 00:39:59.000000', 'consum', 0.0225, 'lps'),
	(384603, 124, '2015-02-01 00:40:00.000000', 'consum', 0.0218, 'lps'),
	(384604, 124, '2015-02-01 00:40:01.000000', 'consum', 0.0225, 'lps'),
	(384605, 124, '2015-02-01 00:40:02.000000', 'consum', 0.0218, 'lps'),
	(384606, 124, '2015-02-01 00:40:03.000000', 'consum', 0.0230, 'lps'),
	(384607, 124, '2015-02-01 00:40:04.000000', 'consum', 0.0222, 'lps'),
	(384608, 124, '2015-02-01 00:40:05.000000', 'consum', 0.0230, 'lps'),
	(384609, 124, '2015-02-01 00:40:06.000000', 'consum', 0.0213, 'lps'),
	(384610, 124, '2015-02-01 00:40:07.000000', 'consum', 0.0227, 'lps'),
	(384611, 124, '2015-02-01 00:40:08.000000', 'consum', 0.0226, 'lps'),
	(384612, 124, '2015-02-01 00:40:09.000000', 'consum', 0.0216, 'lps'),
	(384613, 124, '2015-02-01 00:40:10.000000', 'consum', 0.0215, 'lps'),
	(384614, 124, '2015-02-01 00:40:11.000000', 'consum', 0.0219, 'lps'),
	(384615, 124, '2015-02-01 00:40:12.000000', 'consum', 0.0218, 'lps'),
	(384616, 124, '2015-02-01 00:40:13.000000', 'consum', 0.0224, 'lps'),
	(384617, 124, '2015-02-01 00:40:14.000000', 'consum', 0.0216, 'lps'),
	(384618, 124, '2015-02-01 00:40:15.000000', 'consum', 0.0218, 'lps'),
	(384619, 124, '2015-02-01 00:40:16.000000', 'consum', 0.0213, 'lps'),
	(384620, 124, '2015-02-01 00:40:17.000000', 'consum', 0.0220, 'lps'),
	(384621, 124, '2015-02-01 00:40:18.000000', 'consum', 0.0211, 'lps'),
	(384622, 124, '2015-02-01 00:40:19.000000', 'consum', 0.0226, 'lps'),
	(384623, 124, '2015-02-01 00:40:20.000000', 'consum', 0.0225, 'lps'),
	(384624, 124, '2015-02-01 00:40:21.000000', 'consum', 0.0215, 'lps'),
	(384625, 124, '2015-02-01 00:40:22.000000', 'consum', 0.0212, 'lps'),
	(384626, 124, '2015-02-01 00:40:23.000000', 'consum', 0.0227, 'lps'),
	(384627, 124, '2015-02-01 00:40:24.000000', 'consum', 0.0227, 'lps'),
	(384628, 124, '2015-02-01 00:40:25.000000', 'consum', 0.0224, 'lps'),
	(384629, 124, '2015-02-01 00:40:26.000000', 'consum', 0.0229, 'lps'),
	(384630, 124, '2015-02-01 00:40:27.000000', 'consum', 0.0222, 'lps'),
	(384631, 124, '2015-02-01 00:40:28.000000', 'consum', 0.0212, 'lps'),
	(384632, 124, '2015-02-01 00:40:29.000000', 'consum', 0.0227, 'lps'),
	(384633, 124, '2015-02-01 00:40:30.000000', 'consum', 0.0228, 'lps'),
	(384634, 124, '2015-02-01 00:40:31.000000', 'consum', 0.0229, 'lps'),
	(384635, 124, '2015-02-01 00:40:32.000000', 'consum', 0.0210, 'lps'),
	(384636, 124, '2015-02-01 00:40:33.000000', 'consum', 0.0216, 'lps'),
	(384637, 124, '2015-02-01 00:40:34.000000', 'consum', 0.0219, 'lps'),
	(384638, 124, '2015-02-01 00:40:35.000000', 'consum', 0.0216, 'lps'),
	(384639, 124, '2015-02-01 00:40:36.000000', 'consum', 0.0213, 'lps'),
	(384640, 124, '2015-02-01 00:40:37.000000', 'consum', 0.0229, 'lps'),
	(384641, 124, '2015-02-01 00:40:38.000000', 'consum', 0.0213, 'lps'),
	(384642, 124, '2015-02-01 00:40:39.000000', 'consum', 0.0230, 'lps'),
	(384643, 124, '2015-02-01 00:40:40.000000', 'consum', 0.0218, 'lps'),
	(384644, 124, '2015-02-01 00:40:41.000000', 'consum', 0.0210, 'lps'),
	(384645, 124, '2015-02-01 00:40:42.000000', 'consum', 0.0229, 'lps'),
	(384646, 124, '2015-02-01 00:40:43.000000', 'consum', 0.0220, 'lps'),
	(384647, 124, '2015-02-01 00:40:44.000000', 'consum', 0.0227, 'lps'),
	(384648, 124, '2015-02-01 00:40:45.000000', 'consum', 0.0223, 'lps'),
	(384649, 124, '2015-02-01 00:40:46.000000', 'consum', 0.0224, 'lps'),
	(384650, 124, '2015-02-01 00:40:47.000000', 'consum', 0.0220, 'lps'),
	(384651, 124, '2015-02-01 00:40:48.000000', 'consum', 0.0217, 'lps'),
	(384652, 124, '2015-02-01 00:40:49.000000', 'consum', 0.0218, 'lps'),
	(384653, 124, '2015-02-01 00:40:50.000000', 'consum', 0.0228, 'lps'),
	(384654, 124, '2015-02-01 00:40:51.000000', 'consum', 0.0212, 'lps'),
	(384655, 124, '2015-02-01 00:40:52.000000', 'consum', 0.0211, 'lps'),
	(384656, 124, '2015-02-01 00:40:53.000000', 'consum', 0.0210, 'lps'),
	(384657, 124, '2015-02-01 00:40:54.000000', 'consum', 0.0229, 'lps'),
	(384658, 124, '2015-02-01 00:40:55.000000', 'consum', 0.0222, 'lps'),
	(384659, 124, '2015-02-01 00:40:56.000000', 'consum', 0.0214, 'lps'),
	(384660, 124, '2015-02-01 00:40:57.000000', 'consum', 0.0213, 'lps'),
	(384661, 124, '2015-02-01 00:40:58.000000', 'consum', 0.0216, 'lps'),
	(384662, 124, '2015-02-01 00:40:59.000000', 'consum', 0.0210, 'lps'),
	(384663, 124, '2015-02-01 00:41:00.000000', 'consum', 0.0212, 'lps'),
	(384664, 124, '2015-02-01 00:41:01.000000', 'consum', 0.0220, 'lps'),
	(384665, 124, '2015-02-01 00:41:02.000000', 'consum', 0.0214, 'lps'),
	(384666, 124, '2015-02-01 00:41:03.000000', 'consum', 0.0219, 'lps'),
	(384667, 124, '2015-02-01 00:41:04.000000', 'consum', 0.0226, 'lps'),
	(384668, 124, '2015-02-01 00:41:05.000000', 'consum', 0.0219, 'lps'),
	(384669, 124, '2015-02-01 00:41:06.000000', 'consum', 0.0228, 'lps'),
	(384670, 124, '2015-02-01 00:41:07.000000', 'consum', 0.0212, 'lps'),
	(384671, 124, '2015-02-01 00:41:08.000000', 'consum', 0.0230, 'lps'),
	(384672, 124, '2015-02-01 00:41:09.000000', 'consum', 0.0221, 'lps'),
	(384673, 124, '2015-02-01 00:41:10.000000', 'consum', 0.0226, 'lps'),
	(384674, 124, '2015-02-01 00:41:11.000000', 'consum', 0.0216, 'lps'),
	(384675, 124, '2015-02-01 00:41:12.000000', 'consum', 0.0211, 'lps'),
	(384676, 124, '2015-02-01 00:41:13.000000', 'consum', 0.0220, 'lps'),
	(384677, 124, '2015-02-01 00:41:14.000000', 'consum', 0.0217, 'lps'),
	(384678, 124, '2015-02-01 00:41:15.000000', 'consum', 0.0213, 'lps'),
	(384679, 124, '2015-02-01 00:41:16.000000', 'consum', 0.0228, 'lps'),
	(384680, 124, '2015-02-01 00:41:17.000000', 'consum', 0.0228, 'lps'),
	(384681, 124, '2015-02-01 00:41:18.000000', 'consum', 0.0227, 'lps'),
	(384682, 124, '2015-02-01 00:41:19.000000', 'consum', 0.0218, 'lps'),
	(384683, 124, '2015-02-01 00:41:20.000000', 'consum', 0.0222, 'lps'),
	(384684, 124, '2015-02-01 00:41:21.000000', 'consum', 0.0224, 'lps'),
	(384685, 124, '2015-02-01 00:41:22.000000', 'consum', 0.0223, 'lps'),
	(384686, 124, '2015-02-01 00:41:23.000000', 'consum', 0.0215, 'lps'),
	(384687, 124, '2015-02-01 00:41:24.000000', 'consum', 0.0217, 'lps'),
	(384688, 124, '2015-02-01 00:41:25.000000', 'consum', 0.0210, 'lps'),
	(384689, 124, '2015-02-01 00:41:26.000000', 'consum', 0.0210, 'lps'),
	(384690, 124, '2015-02-01 00:41:27.000000', 'consum', 0.0210, 'lps'),
	(384691, 124, '2015-02-01 00:41:28.000000', 'consum', 0.0210, 'lps'),
	(384692, 124, '2015-02-01 00:41:29.000000', 'consum', 0.0212, 'lps'),
	(384693, 124, '2015-02-01 00:41:30.000000', 'consum', 0.0222, 'lps'),
	(384694, 124, '2015-02-01 00:41:31.000000', 'consum', 0.0220, 'lps'),
	(384695, 124, '2015-02-01 00:41:32.000000', 'consum', 0.0224, 'lps'),
	(384696, 124, '2015-02-01 00:41:33.000000', 'consum', 0.0211, 'lps'),
	(384697, 124, '2015-02-01 00:41:34.000000', 'consum', 0.0215, 'lps'),
	(384698, 124, '2015-02-01 00:41:35.000000', 'consum', 0.0210, 'lps'),
	(384699, 124, '2015-02-01 00:41:36.000000', 'consum', 0.0218, 'lps'),
	(384700, 124, '2015-02-01 00:41:37.000000', 'consum', 0.0230, 'lps'),
	(384701, 124, '2015-02-01 00:41:38.000000', 'consum', 0.0222, 'lps'),
	(384702, 124, '2015-02-01 00:41:39.000000', 'consum', 0.0210, 'lps'),
	(384703, 124, '2015-02-01 00:41:40.000000', 'consum', 0.0216, 'lps'),
	(384704, 124, '2015-02-01 00:41:41.000000', 'consum', 0.0219, 'lps'),
	(384705, 124, '2015-02-01 00:41:42.000000', 'consum', 0.0218, 'lps'),
	(384706, 124, '2015-02-01 00:41:43.000000', 'consum', 0.0224, 'lps'),
	(384707, 124, '2015-02-01 00:41:44.000000', 'consum', 0.0216, 'lps'),
	(384708, 124, '2015-02-01 00:41:45.000000', 'consum', 0.0218, 'lps'),
	(384709, 124, '2015-02-01 00:41:46.000000', 'consum', 0.0211, 'lps'),
	(384710, 124, '2015-02-01 00:41:47.000000', 'consum', 0.0212, 'lps'),
	(384711, 124, '2015-02-01 00:41:48.000000', 'consum', 0.0218, 'lps'),
	(384712, 124, '2015-02-01 00:41:49.000000', 'consum', 0.0225, 'lps'),
	(384713, 124, '2015-02-01 00:41:50.000000', 'consum', 0.0218, 'lps'),
	(384714, 124, '2015-02-01 00:41:51.000000', 'consum', 0.0228, 'lps'),
	(384715, 124, '2015-02-01 00:41:52.000000', 'consum', 0.0212, 'lps'),
	(384716, 124, '2015-02-01 00:41:53.000000', 'consum', 0.0210, 'lps'),
	(384717, 124, '2015-02-01 00:41:54.000000', 'consum', 0.0226, 'lps'),
	(384718, 124, '2015-02-01 00:41:55.000000', 'consum', 0.0225, 'lps'),
	(384719, 124, '2015-02-01 00:41:56.000000', 'consum', 0.0219, 'lps'),
	(384720, 124, '2015-02-01 00:41:57.000000', 'consum', 0.0211, 'lps'),
	(384721, 124, '2015-02-01 00:41:58.000000', 'consum', 0.0227, 'lps'),
	(384722, 124, '2015-02-01 00:41:59.000000', 'consum', 0.0212, 'lps'),
	(384723, 124, '2015-02-01 00:42:00.000000', 'consum', 0.0211, 'lps'),
	(384724, 124, '2015-02-01 00:42:01.000000', 'consum', 0.0228, 'lps'),
	(384725, 124, '2015-02-01 00:42:02.000000', 'consum', 0.0215, 'lps'),
	(384726, 124, '2015-02-01 00:42:03.000000', 'consum', 0.0224, 'lps'),
	(384727, 124, '2015-02-01 00:42:04.000000', 'consum', 0.0223, 'lps'),
	(384728, 124, '2015-02-01 00:42:05.000000', 'consum', 0.0211, 'lps'),
	(384729, 124, '2015-02-01 00:42:06.000000', 'consum', 0.0220, 'lps'),
	(384730, 124, '2015-02-01 00:42:07.000000', 'consum', 0.0216, 'lps'),
	(384731, 124, '2015-02-01 00:42:08.000000', 'consum', 0.0211, 'lps'),
	(384732, 124, '2015-02-01 00:42:09.000000', 'consum', 0.0219, 'lps'),
	(384733, 124, '2015-02-01 00:42:10.000000', 'consum', 0.0210, 'lps'),
	(384734, 124, '2015-02-01 00:42:11.000000', 'consum', 0.0225, 'lps'),
	(384735, 124, '2015-02-01 00:42:12.000000', 'consum', 0.0224, 'lps'),
	(384736, 124, '2015-02-01 00:42:13.000000', 'consum', 0.0216, 'lps'),
	(384737, 124, '2015-02-01 00:42:14.000000', 'consum', 0.0216, 'lps'),
	(384738, 124, '2015-02-01 00:42:15.000000', 'consum', 0.0224, 'lps'),
	(384739, 124, '2015-02-01 00:42:16.000000', 'consum', 0.0222, 'lps'),
	(384740, 124, '2015-02-01 00:42:17.000000', 'consum', 0.0227, 'lps'),
	(384741, 124, '2015-02-01 00:42:18.000000', 'consum', 0.0218, 'lps'),
	(384742, 124, '2015-02-01 00:42:19.000000', 'consum', 0.0218, 'lps'),
	(384743, 124, '2015-02-01 00:42:20.000000', 'consum', 0.0230, 'lps'),
	(384744, 124, '2015-02-01 00:42:21.000000', 'consum', 0.0221, 'lps'),
	(384745, 124, '2015-02-01 00:42:22.000000', 'consum', 0.0229, 'lps'),
	(384746, 124, '2015-02-01 00:42:23.000000', 'consum', 0.0227, 'lps'),
	(384747, 124, '2015-02-01 00:42:24.000000', 'consum', 0.0220, 'lps'),
	(384748, 124, '2015-02-01 00:42:25.000000', 'consum', 0.0230, 'lps'),
	(384749, 124, '2015-02-01 00:42:26.000000', 'consum', 0.0216, 'lps'),
	(384750, 124, '2015-02-01 00:42:27.000000', 'consum', 0.0221, 'lps'),
	(384751, 124, '2015-02-01 00:42:28.000000', 'consum', 0.0230, 'lps'),
	(384752, 124, '2015-02-01 00:42:29.000000', 'consum', 0.0215, 'lps'),
	(384753, 124, '2015-02-01 00:42:30.000000', 'consum', 0.0215, 'lps'),
	(384754, 124, '2015-02-01 00:42:31.000000', 'consum', 0.0220, 'lps'),
	(384755, 124, '2015-02-01 00:42:32.000000', 'consum', 0.0228, 'lps'),
	(384756, 124, '2015-02-01 00:42:33.000000', 'consum', 0.0225, 'lps'),
	(384757, 124, '2015-02-01 00:42:34.000000', 'consum', 0.0211, 'lps'),
	(384758, 124, '2015-02-01 00:42:35.000000', 'consum', 0.0211, 'lps'),
	(384759, 124, '2015-02-01 00:42:36.000000', 'consum', 0.0214, 'lps'),
	(384760, 124, '2015-02-01 00:42:37.000000', 'consum', 0.0228, 'lps'),
	(384761, 124, '2015-02-01 00:42:38.000000', 'consum', 0.0224, 'lps'),
	(384762, 124, '2015-02-01 00:42:39.000000', 'consum', 0.0228, 'lps'),
	(384763, 124, '2015-02-01 00:42:40.000000', 'consum', 0.0214, 'lps'),
	(384764, 124, '2015-02-01 00:42:41.000000', 'consum', 0.0222, 'lps'),
	(384765, 124, '2015-02-01 00:42:42.000000', 'consum', 0.0215, 'lps'),
	(384766, 124, '2015-02-01 00:42:43.000000', 'consum', 0.0221, 'lps'),
	(384767, 124, '2015-02-01 00:42:44.000000', 'consum', 0.0229, 'lps'),
	(384768, 124, '2015-02-01 00:42:45.000000', 'consum', 0.0211, 'lps'),
	(384769, 124, '2015-02-01 00:42:46.000000', 'consum', 0.0219, 'lps'),
	(384770, 124, '2015-02-01 00:42:47.000000', 'consum', 0.0212, 'lps'),
	(384771, 124, '2015-02-01 00:42:48.000000', 'consum', 0.0215, 'lps'),
	(384772, 124, '2015-02-01 00:42:49.000000', 'consum', 0.0228, 'lps'),
	(384773, 124, '2015-02-01 00:42:50.000000', 'consum', 0.0221, 'lps'),
	(384774, 124, '2015-02-01 00:42:51.000000', 'consum', 0.0215, 'lps'),
	(384775, 124, '2015-02-01 00:42:52.000000', 'consum', 0.0222, 'lps'),
	(384776, 124, '2015-02-01 00:42:53.000000', 'consum', 0.0215, 'lps'),
	(384777, 124, '2015-02-01 00:42:54.000000', 'consum', 0.0221, 'lps'),
	(384778, 124, '2015-02-01 00:42:55.000000', 'consum', 0.0229, 'lps'),
	(384779, 124, '2015-02-01 00:42:56.000000', 'consum', 0.0230, 'lps'),
	(384780, 124, '2015-02-01 00:42:57.000000', 'consum', 0.0211, 'lps'),
	(384781, 124, '2015-02-01 00:42:58.000000', 'consum', 0.0217, 'lps'),
	(384782, 124, '2015-02-01 00:42:59.000000', 'consum', 0.0223, 'lps'),
	(384783, 124, '2015-02-01 00:43:00.000000', 'consum', 0.0214, 'lps'),
	(384784, 124, '2015-02-01 00:43:01.000000', 'consum', 0.0211, 'lps'),
	(384785, 124, '2015-02-01 00:43:02.000000', 'consum', 0.0225, 'lps'),
	(384786, 124, '2015-02-01 00:43:03.000000', 'consum', 0.0219, 'lps'),
	(384787, 124, '2015-02-01 00:43:04.000000', 'consum', 0.0210, 'lps'),
	(384788, 124, '2015-02-01 00:43:05.000000', 'consum', 0.0225, 'lps'),
	(384789, 124, '2015-02-01 00:43:06.000000', 'consum', 0.0225, 'lps'),
	(384790, 124, '2015-02-01 00:43:07.000000', 'consum', 0.0219, 'lps'),
	(384791, 124, '2015-02-01 00:43:08.000000', 'consum', 0.0212, 'lps'),
	(384792, 124, '2015-02-01 00:43:09.000000', 'consum', 0.0213, 'lps'),
	(384793, 124, '2015-02-01 00:43:10.000000', 'consum', 0.0219, 'lps'),
	(384794, 124, '2015-02-01 00:43:11.000000', 'consum', 0.0224, 'lps'),
	(384795, 124, '2015-02-01 00:43:12.000000', 'consum', 0.0214, 'lps'),
	(384796, 124, '2015-02-01 00:43:13.000000', 'consum', 0.0211, 'lps'),
	(384797, 124, '2015-02-01 00:43:14.000000', 'consum', 0.0221, 'lps'),
	(384798, 124, '2015-02-01 00:43:15.000000', 'consum', 0.0221, 'lps'),
	(384799, 124, '2015-02-01 00:43:16.000000', 'consum', 0.0214, 'lps'),
	(384800, 124, '2015-02-01 00:43:17.000000', 'consum', 0.0215, 'lps'),
	(384801, 124, '2015-02-01 00:43:18.000000', 'consum', 0.0227, 'lps'),
	(384802, 124, '2015-02-01 00:43:19.000000', 'consum', 0.0216, 'lps'),
	(384803, 124, '2015-02-01 00:43:20.000000', 'consum', 0.0211, 'lps'),
	(384804, 124, '2015-02-01 00:43:21.000000', 'consum', 0.0219, 'lps'),
	(384805, 124, '2015-02-01 00:43:22.000000', 'consum', 0.0230, 'lps'),
	(384806, 124, '2015-02-01 00:43:23.000000', 'consum', 0.0220, 'lps'),
	(384807, 124, '2015-02-01 00:43:24.000000', 'consum', 0.0221, 'lps'),
	(384808, 124, '2015-02-01 00:43:25.000000', 'consum', 0.0214, 'lps'),
	(384809, 124, '2015-02-01 00:43:26.000000', 'consum', 0.0220, 'lps'),
	(384810, 124, '2015-02-01 00:43:27.000000', 'consum', 0.0229, 'lps'),
	(384811, 124, '2015-02-01 00:43:28.000000', 'consum', 0.0210, 'lps'),
	(384812, 124, '2015-02-01 00:43:29.000000', 'consum', 0.0218, 'lps'),
	(384813, 124, '2015-02-01 00:43:30.000000', 'consum', 0.0227, 'lps'),
	(384814, 124, '2015-02-01 00:43:31.000000', 'consum', 0.0210, 'lps'),
	(384815, 124, '2015-02-01 00:43:32.000000', 'consum', 0.0224, 'lps'),
	(384816, 124, '2015-02-01 00:43:33.000000', 'consum', 0.0218, 'lps'),
	(384817, 124, '2015-02-01 00:43:34.000000', 'consum', 0.0230, 'lps'),
	(384818, 124, '2015-02-01 00:43:35.000000', 'consum', 0.0222, 'lps'),
	(384819, 124, '2015-02-01 00:43:36.000000', 'consum', 0.0213, 'lps'),
	(384820, 124, '2015-02-01 00:43:37.000000', 'consum', 0.0228, 'lps'),
	(384821, 124, '2015-02-01 00:43:38.000000', 'consum', 0.0210, 'lps'),
	(384822, 124, '2015-02-01 00:43:39.000000', 'consum', 0.0218, 'lps'),
	(384823, 124, '2015-02-01 00:43:40.000000', 'consum', 0.0230, 'lps'),
	(384824, 124, '2015-02-01 00:43:41.000000', 'consum', 0.0222, 'lps'),
	(384825, 124, '2015-02-01 00:43:42.000000', 'consum', 0.0211, 'lps'),
	(384826, 124, '2015-02-01 00:43:43.000000', 'consum', 0.0222, 'lps'),
	(384827, 124, '2015-02-01 00:43:44.000000', 'consum', 0.0226, 'lps'),
	(384828, 124, '2015-02-01 00:43:45.000000', 'consum', 0.0214, 'lps'),
	(384829, 124, '2015-02-01 00:43:46.000000', 'consum', 0.0221, 'lps'),
	(384830, 124, '2015-02-01 00:43:47.000000', 'consum', 0.0214, 'lps'),
	(384831, 124, '2015-02-01 00:43:48.000000', 'consum', 0.0219, 'lps'),
	(384832, 124, '2015-02-01 00:43:49.000000', 'consum', 0.0222, 'lps'),
	(384833, 124, '2015-02-01 00:43:50.000000', 'consum', 0.0221, 'lps'),
	(384834, 124, '2015-02-01 00:43:51.000000', 'consum', 0.0211, 'lps'),
	(384835, 124, '2015-02-01 00:43:52.000000', 'consum', 0.0224, 'lps'),
	(384836, 124, '2015-02-01 00:43:53.000000', 'consum', 0.0213, 'lps'),
	(384837, 124, '2015-02-01 00:43:54.000000', 'consum', 0.0227, 'lps'),
	(384838, 124, '2015-02-01 00:43:55.000000', 'consum', 0.0222, 'lps'),
	(384839, 124, '2015-02-01 00:43:56.000000', 'consum', 0.0219, 'lps'),
	(384840, 124, '2015-02-01 00:43:57.000000', 'consum', 0.0221, 'lps'),
	(384841, 124, '2015-02-01 00:43:58.000000', 'consum', 0.0215, 'lps'),
	(384842, 124, '2015-02-01 00:43:59.000000', 'consum', 0.0226, 'lps'),
	(384843, 124, '2015-02-01 00:44:00.000000', 'consum', 0.0210, 'lps'),
	(384844, 124, '2015-02-01 00:44:01.000000', 'consum', 0.0227, 'lps'),
	(384845, 124, '2015-02-01 00:44:02.000000', 'consum', 0.0210, 'lps'),
	(384846, 124, '2015-02-01 00:44:03.000000', 'consum', 0.0222, 'lps'),
	(384847, 124, '2015-02-01 00:44:04.000000', 'consum', 0.0230, 'lps'),
	(384848, 124, '2015-02-01 00:44:05.000000', 'consum', 0.0213, 'lps'),
	(384849, 124, '2015-02-01 00:44:06.000000', 'consum', 0.0226, 'lps'),
	(384850, 124, '2015-02-01 00:44:07.000000', 'consum', 0.0221, 'lps'),
	(384851, 124, '2015-02-01 00:44:08.000000', 'consum', 0.0217, 'lps'),
	(384852, 124, '2015-02-01 00:44:09.000000', 'consum', 0.0214, 'lps'),
	(384853, 124, '2015-02-01 00:44:10.000000', 'consum', 0.0230, 'lps'),
	(384854, 124, '2015-02-01 00:44:11.000000', 'consum', 0.0212, 'lps'),
	(384855, 124, '2015-02-01 00:44:12.000000', 'consum', 0.0225, 'lps'),
	(384856, 124, '2015-02-01 00:44:13.000000', 'consum', 0.0216, 'lps'),
	(384857, 124, '2015-02-01 00:44:14.000000', 'consum', 0.0218, 'lps'),
	(384858, 124, '2015-02-01 00:44:15.000000', 'consum', 0.0210, 'lps'),
	(384859, 124, '2015-02-01 00:44:16.000000', 'consum', 0.0228, 'lps'),
	(384860, 124, '2015-02-01 00:44:17.000000', 'consum', 0.0216, 'lps'),
	(384861, 124, '2015-02-01 00:44:18.000000', 'consum', 0.0229, 'lps'),
	(384862, 124, '2015-02-01 00:44:19.000000', 'consum', 0.0223, 'lps'),
	(384863, 124, '2015-02-01 00:44:20.000000', 'consum', 0.0219, 'lps'),
	(384864, 124, '2015-02-01 00:44:21.000000', 'consum', 0.0218, 'lps'),
	(384865, 124, '2015-02-01 00:44:22.000000', 'consum', 0.0222, 'lps'),
	(384866, 124, '2015-02-01 00:44:23.000000', 'consum', 0.0227, 'lps'),
	(384867, 124, '2015-02-01 00:44:24.000000', 'consum', 0.0217, 'lps'),
	(384868, 124, '2015-02-01 00:44:25.000000', 'consum', 0.0213, 'lps'),
	(384869, 124, '2015-02-01 00:44:26.000000', 'consum', 0.0229, 'lps'),
	(384870, 124, '2015-02-01 00:44:27.000000', 'consum', 0.0212, 'lps'),
	(384871, 124, '2015-02-01 00:44:28.000000', 'consum', 0.0224, 'lps'),
	(384872, 124, '2015-02-01 00:44:29.000000', 'consum', 0.0214, 'lps'),
	(384873, 124, '2015-02-01 00:44:30.000000', 'consum', 0.0210, 'lps'),
	(384874, 124, '2015-02-01 00:44:31.000000', 'consum', 0.0219, 'lps'),
	(384875, 124, '2015-02-01 00:44:32.000000', 'consum', 0.0214, 'lps'),
	(384876, 124, '2015-02-01 00:44:33.000000', 'consum', 0.0226, 'lps'),
	(384877, 124, '2015-02-01 00:44:34.000000', 'consum', 0.0214, 'lps'),
	(384878, 124, '2015-02-01 00:44:35.000000', 'consum', 0.0223, 'lps'),
	(384879, 124, '2015-02-01 00:44:36.000000', 'consum', 0.0221, 'lps'),
	(384880, 124, '2015-02-01 00:44:37.000000', 'consum', 0.0228, 'lps'),
	(384881, 124, '2015-02-01 00:44:38.000000', 'consum', 0.0225, 'lps'),
	(384882, 124, '2015-02-01 00:44:39.000000', 'consum', 0.0210, 'lps'),
	(384883, 124, '2015-02-01 00:44:40.000000', 'consum', 0.0229, 'lps'),
	(384884, 124, '2015-02-01 00:44:41.000000', 'consum', 0.0219, 'lps'),
	(384885, 124, '2015-02-01 00:44:42.000000', 'consum', 0.0223, 'lps'),
	(384886, 124, '2015-02-01 00:44:43.000000', 'consum', 0.0227, 'lps'),
	(384887, 124, '2015-02-01 00:44:44.000000', 'consum', 0.0215, 'lps'),
	(384888, 124, '2015-02-01 00:44:45.000000', 'consum', 0.0225, 'lps'),
	(384889, 124, '2015-02-01 00:44:46.000000', 'consum', 0.0228, 'lps'),
	(384890, 124, '2015-02-01 00:44:47.000000', 'consum', 0.0214, 'lps'),
	(384891, 124, '2015-02-01 00:44:48.000000', 'consum', 0.0217, 'lps'),
	(384892, 124, '2015-02-01 00:44:49.000000', 'consum', 0.0213, 'lps'),
	(384893, 124, '2015-02-01 00:44:50.000000', 'consum', 0.0227, 'lps'),
	(384894, 124, '2015-02-01 00:44:51.000000', 'consum', 0.0224, 'lps'),
	(384895, 124, '2015-02-01 00:44:52.000000', 'consum', 0.0230, 'lps'),
	(384896, 124, '2015-02-01 00:44:53.000000', 'consum', 0.0225, 'lps'),
	(384897, 124, '2015-02-01 00:44:54.000000', 'consum', 0.0226, 'lps'),
	(384898, 124, '2015-02-01 00:44:55.000000', 'consum', 0.0223, 'lps'),
	(384899, 124, '2015-02-01 00:44:56.000000', 'consum', 0.0230, 'lps'),
	(384900, 124, '2015-02-01 00:44:57.000000', 'consum', 0.0229, 'lps'),
	(384901, 124, '2015-02-01 00:44:58.000000', 'consum', 0.0224, 'lps'),
	(384902, 124, '2015-02-01 00:44:59.000000', 'consum', 0.0225, 'lps'),
	(384903, 124, '2015-02-01 00:45:00.000000', 'consum', 0.0222, 'lps'),
	(384904, 124, '2015-02-01 00:45:01.000000', 'consum', 0.0224, 'lps'),
	(384905, 124, '2015-02-01 00:45:02.000000', 'consum', 0.0225, 'lps'),
	(384906, 124, '2015-02-01 00:45:03.000000', 'consum', 0.0222, 'lps'),
	(384907, 124, '2015-02-01 00:45:04.000000', 'consum', 0.0227, 'lps'),
	(384908, 124, '2015-02-01 00:45:05.000000', 'consum', 0.0216, 'lps'),
	(384909, 124, '2015-02-01 00:45:06.000000', 'consum', 0.0212, 'lps'),
	(384910, 124, '2015-02-01 00:45:07.000000', 'consum', 0.0221, 'lps'),
	(384911, 124, '2015-02-01 00:45:08.000000', 'consum', 0.0218, 'lps'),
	(384912, 124, '2015-02-01 00:45:09.000000', 'consum', 0.0218, 'lps'),
	(384913, 124, '2015-02-01 00:45:10.000000', 'consum', 0.0228, 'lps'),
	(384914, 124, '2015-02-01 00:45:11.000000', 'consum', 0.0212, 'lps'),
	(384915, 124, '2015-02-01 00:45:12.000000', 'consum', 0.0228, 'lps'),
	(384916, 124, '2015-02-01 00:45:13.000000', 'consum', 0.0214, 'lps'),
	(384917, 124, '2015-02-01 00:45:14.000000', 'consum', 0.0216, 'lps'),
	(384918, 124, '2015-02-01 00:45:15.000000', 'consum', 0.0230, 'lps'),
	(384919, 124, '2015-02-01 00:45:16.000000', 'consum', 0.0230, 'lps'),
	(384920, 124, '2015-02-01 00:45:17.000000', 'consum', 0.0227, 'lps'),
	(384921, 124, '2015-02-01 00:45:18.000000', 'consum', 0.0214, 'lps'),
	(384922, 124, '2015-02-01 00:45:19.000000', 'consum', 0.0223, 'lps'),
	(384923, 124, '2015-02-01 00:45:20.000000', 'consum', 0.0223, 'lps'),
	(384924, 124, '2015-02-01 00:45:21.000000', 'consum', 0.0216, 'lps'),
	(384925, 124, '2015-02-01 00:45:22.000000', 'consum', 0.0221, 'lps'),
	(384926, 124, '2015-02-01 00:45:23.000000', 'consum', 0.0226, 'lps'),
	(384927, 124, '2015-02-01 00:45:24.000000', 'consum', 0.0214, 'lps'),
	(384928, 124, '2015-02-01 00:45:25.000000', 'consum', 0.0227, 'lps'),
	(384929, 124, '2015-02-01 00:45:26.000000', 'consum', 0.0219, 'lps'),
	(384930, 124, '2015-02-01 00:45:27.000000', 'consum', 0.0226, 'lps'),
	(384931, 124, '2015-02-01 00:45:28.000000', 'consum', 0.0221, 'lps'),
	(384932, 124, '2015-02-01 00:45:29.000000', 'consum', 0.0218, 'lps'),
	(384933, 124, '2015-02-01 00:45:30.000000', 'consum', 0.0219, 'lps'),
	(384934, 124, '2015-02-01 00:45:31.000000', 'consum', 0.0229, 'lps'),
	(384935, 124, '2015-02-01 00:45:32.000000', 'consum', 0.0217, 'lps'),
	(384936, 124, '2015-02-01 00:45:33.000000', 'consum', 0.0228, 'lps'),
	(384937, 124, '2015-02-01 00:45:34.000000', 'consum', 0.0218, 'lps'),
	(384938, 124, '2015-02-01 00:45:35.000000', 'consum', 0.0219, 'lps'),
	(384939, 124, '2015-02-01 00:45:36.000000', 'consum', 0.0210, 'lps'),
	(384940, 124, '2015-02-01 00:45:37.000000', 'consum', 0.0224, 'lps'),
	(384941, 124, '2015-02-01 00:45:38.000000', 'consum', 0.0217, 'lps'),
	(384942, 124, '2015-02-01 00:45:39.000000', 'consum', 0.0225, 'lps'),
	(384943, 124, '2015-02-01 00:45:40.000000', 'consum', 0.0222, 'lps'),
	(384944, 124, '2015-02-01 00:45:41.000000', 'consum', 0.0226, 'lps'),
	(384945, 124, '2015-02-01 00:45:42.000000', 'consum', 0.0213, 'lps'),
	(384946, 124, '2015-02-01 00:45:43.000000', 'consum', 0.0218, 'lps'),
	(384947, 124, '2015-02-01 00:45:44.000000', 'consum', 0.0222, 'lps'),
	(384948, 124, '2015-02-01 00:45:45.000000', 'consum', 0.0227, 'lps'),
	(384949, 124, '2015-02-01 00:45:46.000000', 'consum', 0.0214, 'lps'),
	(384950, 124, '2015-02-01 00:45:47.000000', 'consum', 0.0224, 'lps'),
	(384951, 124, '2015-02-01 00:45:48.000000', 'consum', 0.0225, 'lps'),
	(384952, 124, '2015-02-01 00:45:49.000000', 'consum', 0.0222, 'lps'),
	(384953, 124, '2015-02-01 00:45:50.000000', 'consum', 0.0226, 'lps'),
	(384954, 124, '2015-02-01 00:45:51.000000', 'consum', 0.0213, 'lps'),
	(384955, 124, '2015-02-01 00:45:52.000000', 'consum', 0.0219, 'lps'),
	(384956, 124, '2015-02-01 00:45:53.000000', 'consum', 0.0227, 'lps'),
	(384957, 124, '2015-02-01 00:45:54.000000', 'consum', 0.0225, 'lps'),
	(384958, 124, '2015-02-01 00:45:55.000000', 'consum', 0.0215, 'lps'),
	(384959, 124, '2015-02-01 00:45:56.000000', 'consum', 0.0211, 'lps'),
	(384960, 124, '2015-02-01 00:45:57.000000', 'consum', 0.0223, 'lps'),
	(384961, 124, '2015-02-01 00:45:58.000000', 'consum', 0.0230, 'lps'),
	(384962, 124, '2015-02-01 00:45:59.000000', 'consum', 0.0228, 'lps'),
	(384963, 124, '2015-02-01 00:46:00.000000', 'consum', 0.0221, 'lps'),
	(384964, 124, '2015-02-01 00:46:01.000000', 'consum', 0.0230, 'lps'),
	(384965, 124, '2015-02-01 00:46:02.000000', 'consum', 0.0218, 'lps'),
	(384966, 124, '2015-02-01 00:46:03.000000', 'consum', 0.0210, 'lps'),
	(384967, 124, '2015-02-01 00:46:04.000000', 'consum', 0.0227, 'lps'),
	(384968, 124, '2015-02-01 00:46:05.000000', 'consum', 0.0211, 'lps'),
	(384969, 124, '2015-02-01 00:46:06.000000', 'consum', 0.0228, 'lps'),
	(384970, 124, '2015-02-01 00:46:07.000000', 'consum', 0.0212, 'lps'),
	(384971, 124, '2015-02-01 00:46:08.000000', 'consum', 0.0212, 'lps'),
	(384972, 124, '2015-02-01 00:46:09.000000', 'consum', 0.0211, 'lps'),
	(384973, 124, '2015-02-01 00:46:10.000000', 'consum', 0.0211, 'lps'),
	(384974, 124, '2015-02-01 00:46:11.000000', 'consum', 0.0211, 'lps'),
	(384975, 124, '2015-02-01 00:46:12.000000', 'consum', 0.0213, 'lps'),
	(384976, 124, '2015-02-01 00:46:13.000000', 'consum', 0.0222, 'lps'),
	(384977, 124, '2015-02-01 00:46:14.000000', 'consum', 0.0221, 'lps'),
	(384978, 124, '2015-02-01 00:46:15.000000', 'consum', 0.0228, 'lps'),
	(384979, 124, '2015-02-01 00:46:16.000000', 'consum', 0.0226, 'lps'),
	(384980, 124, '2015-02-01 00:46:17.000000', 'consum', 0.0214, 'lps'),
	(384981, 124, '2015-02-01 00:46:18.000000', 'consum', 0.0228, 'lps'),
	(384982, 124, '2015-02-01 00:46:19.000000', 'consum', 0.0222, 'lps'),
	(384983, 124, '2015-02-01 00:46:20.000000', 'consum', 0.0217, 'lps'),
	(384984, 124, '2015-02-01 00:46:21.000000', 'consum', 0.0211, 'lps'),
	(384985, 124, '2015-02-01 00:46:22.000000', 'consum', 0.0216, 'lps'),
	(384986, 124, '2015-02-01 00:46:23.000000', 'consum', 0.0215, 'lps'),
	(384987, 124, '2015-02-01 00:46:24.000000', 'consum', 0.0217, 'lps'),
	(384988, 124, '2015-02-01 00:46:25.000000', 'consum', 0.0210, 'lps'),
	(384989, 124, '2015-02-01 00:46:26.000000', 'consum', 0.0212, 'lps'),
	(384990, 124, '2015-02-01 00:46:27.000000', 'consum', 0.0219, 'lps'),
	(384991, 124, '2015-02-01 00:46:28.000000', 'consum', 0.0227, 'lps'),
	(384992, 124, '2015-02-01 00:46:29.000000', 'consum', 0.0229, 'lps'),
	(384993, 124, '2015-02-01 00:46:30.000000', 'consum', 0.0211, 'lps'),
	(384994, 124, '2015-02-01 00:46:31.000000', 'consum', 0.0224, 'lps'),
	(384995, 124, '2015-02-01 00:46:32.000000', 'consum', 0.0213, 'lps'),
	(384996, 124, '2015-02-01 00:46:33.000000', 'consum', 0.0225, 'lps'),
	(384997, 124, '2015-02-01 00:46:34.000000', 'consum', 0.0214, 'lps'),
	(384998, 124, '2015-02-01 00:46:35.000000', 'consum', 0.0227, 'lps'),
	(384999, 124, '2015-02-01 00:46:36.000000', 'consum', 0.0220, 'lps'),
	(385000, 124, '2015-02-01 00:46:37.000000', 'consum', 0.0211, 'lps'),
	(385001, 124, '2015-02-01 00:46:38.000000', 'consum', 0.0227, 'lps'),
	(385002, 124, '2015-02-01 00:46:39.000000', 'consum', 0.0228, 'lps'),
	(385003, 124, '2015-02-01 00:46:40.000000', 'consum', 0.0230, 'lps'),
	(385004, 124, '2015-02-01 00:46:41.000000', 'consum', 0.0213, 'lps'),
	(385005, 124, '2015-02-01 00:46:42.000000', 'consum', 0.0210, 'lps'),
	(385006, 124, '2015-02-01 00:46:43.000000', 'consum', 0.0220, 'lps'),
	(385007, 124, '2015-02-01 00:46:44.000000', 'consum', 0.0220, 'lps'),
	(385008, 124, '2015-02-01 00:46:45.000000', 'consum', 0.0210, 'lps'),
	(385009, 124, '2015-02-01 00:46:46.000000', 'consum', 0.0223, 'lps'),
	(385010, 124, '2015-02-01 00:46:47.000000', 'consum', 0.0211, 'lps'),
	(385011, 124, '2015-02-01 00:46:48.000000', 'consum', 0.0217, 'lps'),
	(385012, 124, '2015-02-01 00:46:49.000000', 'consum', 0.0224, 'lps'),
	(385013, 124, '2015-02-01 00:46:50.000000', 'consum', 0.0215, 'lps'),
	(385014, 124, '2015-02-01 00:46:51.000000', 'consum', 0.0216, 'lps'),
	(385015, 124, '2015-02-01 00:46:52.000000', 'consum', 0.0223, 'lps'),
	(385016, 124, '2015-02-01 00:46:53.000000', 'consum', 0.0218, 'lps'),
	(385017, 124, '2015-02-01 00:46:54.000000', 'consum', 0.0210, 'lps'),
	(385018, 124, '2015-02-01 00:46:55.000000', 'consum', 0.0230, 'lps'),
	(385019, 124, '2015-02-01 00:46:56.000000', 'consum', 0.0226, 'lps'),
	(385020, 124, '2015-02-01 00:46:57.000000', 'consum', 0.0229, 'lps'),
	(385021, 124, '2015-02-01 00:46:58.000000', 'consum', 0.0219, 'lps'),
	(385022, 124, '2015-02-01 00:46:59.000000', 'consum', 0.0216, 'lps'),
	(385023, 124, '2015-02-01 00:47:00.000000', 'consum', 0.0213, 'lps'),
	(385024, 124, '2015-02-01 00:47:01.000000', 'consum', 0.0230, 'lps'),
	(385025, 124, '2015-02-01 00:47:02.000000', 'consum', 0.0216, 'lps'),
	(385026, 124, '2015-02-01 00:47:03.000000', 'consum', 0.0224, 'lps'),
	(385027, 124, '2015-02-01 00:47:04.000000', 'consum', 0.0222, 'lps'),
	(385028, 124, '2015-02-01 00:47:05.000000', 'consum', 0.0227, 'lps'),
	(385029, 124, '2015-02-01 00:47:06.000000', 'consum', 0.0218, 'lps'),
	(385030, 124, '2015-02-01 00:47:07.000000', 'consum', 0.0221, 'lps'),
	(385031, 124, '2015-02-01 00:47:08.000000', 'consum', 0.0221, 'lps'),
	(385032, 124, '2015-02-01 00:47:09.000000', 'consum', 0.0230, 'lps'),
	(385033, 124, '2015-02-01 00:47:10.000000', 'consum', 0.0217, 'lps'),
	(385034, 124, '2015-02-01 00:47:11.000000', 'consum', 0.0228, 'lps'),
	(385035, 124, '2015-02-01 00:47:12.000000', 'consum', 0.0214, 'lps'),
	(385036, 124, '2015-02-01 00:47:13.000000', 'consum', 0.0218, 'lps'),
	(385037, 124, '2015-02-01 00:47:14.000000', 'consum', 0.0219, 'lps'),
	(385038, 124, '2015-02-01 00:47:15.000000', 'consum', 0.0229, 'lps'),
	(385039, 124, '2015-02-01 00:47:16.000000', 'consum', 0.0218, 'lps'),
	(385040, 124, '2015-02-01 00:47:17.000000', 'consum', 0.0215, 'lps'),
	(385041, 124, '2015-02-01 00:47:18.000000', 'consum', 0.0212, 'lps'),
	(385042, 124, '2015-02-01 00:47:19.000000', 'consum', 0.0225, 'lps'),
	(385043, 124, '2015-02-01 00:47:20.000000', 'consum', 0.0218, 'lps'),
	(385044, 124, '2015-02-01 00:47:21.000000', 'consum', 0.0226, 'lps'),
	(385045, 124, '2015-02-01 00:47:22.000000', 'consum', 0.0226, 'lps'),
	(385046, 124, '2015-02-01 00:47:23.000000', 'consum', 0.0221, 'lps'),
	(385047, 124, '2015-02-01 00:47:24.000000', 'consum', 0.0216, 'lps'),
	(385048, 124, '2015-02-01 00:47:25.000000', 'consum', 0.0230, 'lps'),
	(385049, 124, '2015-02-01 00:47:26.000000', 'consum', 0.0229, 'lps'),
	(385050, 124, '2015-02-01 00:47:27.000000', 'consum', 0.0225, 'lps'),
	(385051, 124, '2015-02-01 00:47:28.000000', 'consum', 0.0228, 'lps'),
	(385052, 124, '2015-02-01 00:47:29.000000', 'consum', 0.0212, 'lps'),
	(385053, 124, '2015-02-01 00:47:30.000000', 'consum', 0.0210, 'lps'),
	(385054, 124, '2015-02-01 00:47:31.000000', 'consum', 0.0225, 'lps'),
	(385055, 124, '2015-02-01 00:47:32.000000', 'consum', 0.0221, 'lps'),
	(385056, 124, '2015-02-01 00:47:33.000000', 'consum', 0.0220, 'lps'),
	(385057, 124, '2015-02-01 00:47:34.000000', 'consum', 0.0227, 'lps'),
	(385058, 124, '2015-02-01 00:47:35.000000', 'consum', 0.0225, 'lps'),
	(385059, 124, '2015-02-01 00:47:36.000000', 'consum', 0.0214, 'lps'),
	(385060, 124, '2015-02-01 00:47:37.000000', 'consum', 0.0226, 'lps'),
	(385061, 124, '2015-02-01 00:47:38.000000', 'consum', 0.0218, 'lps'),
	(385062, 124, '2015-02-01 00:47:39.000000', 'consum', 0.0222, 'lps'),
	(385063, 124, '2015-02-01 00:47:40.000000', 'consum', 0.0225, 'lps'),
	(385064, 124, '2015-02-01 00:47:41.000000', 'consum', 0.0210, 'lps'),
	(385065, 124, '2015-02-01 00:47:42.000000', 'consum', 0.0225, 'lps'),
	(385066, 124, '2015-02-01 00:47:43.000000', 'consum', 0.0226, 'lps'),
	(385067, 124, '2015-02-01 00:47:44.000000', 'consum', 0.0223, 'lps'),
	(385068, 124, '2015-02-01 00:47:45.000000', 'consum', 0.0228, 'lps'),
	(385069, 124, '2015-02-01 00:47:46.000000', 'consum', 0.0220, 'lps'),
	(385070, 124, '2015-02-01 00:47:47.000000', 'consum', 0.0229, 'lps'),
	(385071, 124, '2015-02-01 00:47:48.000000', 'consum', 0.0230, 'lps'),
	(385072, 124, '2015-02-01 00:47:49.000000', 'consum', 0.0214, 'lps'),
	(385073, 124, '2015-02-01 00:47:50.000000', 'consum', 0.0211, 'lps'),
	(385074, 124, '2015-02-01 00:47:51.000000', 'consum', 0.0224, 'lps'),
	(385075, 124, '2015-02-01 00:47:52.000000', 'consum', 0.0215, 'lps'),
	(385076, 124, '2015-02-01 00:47:53.000000', 'consum', 0.0215, 'lps'),
	(385077, 124, '2015-02-01 00:47:54.000000', 'consum', 0.0222, 'lps'),
	(385078, 124, '2015-02-01 00:47:55.000000', 'consum', 0.0214, 'lps'),
	(385079, 124, '2015-02-01 00:47:56.000000', 'consum', 0.0214, 'lps'),
	(385080, 124, '2015-02-01 00:47:57.000000', 'consum', 0.0219, 'lps'),
	(385081, 124, '2015-02-01 00:47:58.000000', 'consum', 0.0222, 'lps'),
	(385082, 124, '2015-02-01 00:47:59.000000', 'consum', 0.0222, 'lps'),
	(385083, 124, '2015-02-01 00:48:00.000000', 'consum', 0.0215, 'lps'),
	(385084, 124, '2015-02-01 00:48:01.000000', 'consum', 0.0221, 'lps'),
	(385085, 124, '2015-02-01 00:48:02.000000', 'consum', 0.0227, 'lps'),
	(385086, 124, '2015-02-01 00:48:03.000000', 'consum', 0.0222, 'lps'),
	(385087, 124, '2015-02-01 00:48:04.000000', 'consum', 0.0219, 'lps'),
	(385088, 124, '2015-02-01 00:48:05.000000', 'consum', 0.0221, 'lps'),
	(385089, 124, '2015-02-01 00:48:06.000000', 'consum', 0.0216, 'lps'),
	(385090, 124, '2015-02-01 00:48:07.000000', 'consum', 0.0228, 'lps'),
	(385091, 124, '2015-02-01 00:48:08.000000', 'consum', 0.0221, 'lps'),
	(385092, 124, '2015-02-01 00:48:09.000000', 'consum', 0.0213, 'lps'),
	(385093, 124, '2015-02-01 00:48:10.000000', 'consum', 0.0211, 'lps'),
	(385094, 124, '2015-02-01 00:48:11.000000', 'consum', 0.0229, 'lps'),
	(385095, 124, '2015-02-01 00:48:12.000000', 'consum', 0.0218, 'lps'),
	(385096, 124, '2015-02-01 00:48:13.000000', 'consum', 0.0213, 'lps'),
	(385097, 124, '2015-02-01 00:48:14.000000', 'consum', 0.0225, 'lps'),
	(385098, 124, '2015-02-01 00:48:15.000000', 'consum', 0.0211, 'lps'),
	(385099, 124, '2015-02-01 00:48:16.000000', 'consum', 0.0216, 'lps'),
	(385100, 124, '2015-02-01 00:48:17.000000', 'consum', 0.0213, 'lps'),
	(385101, 124, '2015-02-01 00:48:18.000000', 'consum', 0.0210, 'lps'),
	(385102, 124, '2015-02-01 00:48:19.000000', 'consum', 0.0221, 'lps'),
	(385103, 124, '2015-02-01 00:48:20.000000', 'consum', 0.0223, 'lps'),
	(385104, 124, '2015-02-01 00:48:21.000000', 'consum', 0.0223, 'lps'),
	(385105, 124, '2015-02-01 00:48:22.000000', 'consum', 0.0217, 'lps'),
	(385106, 124, '2015-02-01 00:48:23.000000', 'consum', 0.0224, 'lps'),
	(385107, 124, '2015-02-01 00:48:24.000000', 'consum', 0.0219, 'lps'),
	(385108, 124, '2015-02-01 00:48:25.000000', 'consum', 0.0214, 'lps'),
	(385109, 124, '2015-02-01 00:48:26.000000', 'consum', 0.0226, 'lps'),
	(385110, 124, '2015-02-01 00:48:27.000000', 'consum', 0.0214, 'lps'),
	(385111, 124, '2015-02-01 00:48:28.000000', 'consum', 0.0226, 'lps'),
	(385112, 124, '2015-02-01 00:48:29.000000', 'consum', 0.0213, 'lps'),
	(385113, 124, '2015-02-01 00:48:30.000000', 'consum', 0.0220, 'lps'),
	(385114, 124, '2015-02-01 00:48:31.000000', 'consum', 0.0230, 'lps'),
	(385115, 124, '2015-02-01 00:48:32.000000', 'consum', 0.0217, 'lps'),
	(385116, 124, '2015-02-01 00:48:33.000000', 'consum', 0.0229, 'lps'),
	(385117, 124, '2015-02-01 00:48:34.000000', 'consum', 0.0223, 'lps'),
	(385118, 124, '2015-02-01 00:48:35.000000', 'consum', 0.0218, 'lps'),
	(385119, 124, '2015-02-01 00:48:36.000000', 'consum', 0.0230, 'lps'),
	(385120, 124, '2015-02-01 00:48:37.000000', 'consum', 0.0225, 'lps'),
	(385121, 124, '2015-02-01 00:48:38.000000', 'consum', 0.0227, 'lps'),
	(385122, 124, '2015-02-01 00:48:39.000000', 'consum', 0.0230, 'lps'),
	(385123, 124, '2015-02-01 00:48:40.000000', 'consum', 0.0217, 'lps'),
	(385124, 124, '2015-02-01 00:48:41.000000', 'consum', 0.0228, 'lps'),
	(385125, 124, '2015-02-01 00:48:42.000000', 'consum', 0.0217, 'lps'),
	(385126, 124, '2015-02-01 00:48:43.000000', 'consum', 0.0214, 'lps'),
	(385127, 124, '2015-02-01 00:48:44.000000', 'consum', 0.0228, 'lps'),
	(385128, 124, '2015-02-01 00:48:45.000000', 'consum', 0.0225, 'lps'),
	(385129, 124, '2015-02-01 00:48:46.000000', 'consum', 0.0211, 'lps'),
	(385130, 124, '2015-02-01 00:48:47.000000', 'consum', 0.0214, 'lps'),
	(385131, 124, '2015-02-01 00:48:48.000000', 'consum', 0.0227, 'lps'),
	(385132, 124, '2015-02-01 00:48:49.000000', 'consum', 0.0222, 'lps'),
	(385133, 124, '2015-02-01 00:48:50.000000', 'consum', 0.0219, 'lps'),
	(385134, 124, '2015-02-01 00:48:51.000000', 'consum', 0.0218, 'lps'),
	(385135, 124, '2015-02-01 00:48:52.000000', 'consum', 0.0226, 'lps'),
	(385136, 124, '2015-02-01 00:48:53.000000', 'consum', 0.0222, 'lps'),
	(385137, 124, '2015-02-01 00:48:54.000000', 'consum', 0.0222, 'lps'),
	(385138, 124, '2015-02-01 00:48:55.000000', 'consum', 0.0214, 'lps'),
	(385139, 124, '2015-02-01 00:48:56.000000', 'consum', 0.0215, 'lps'),
	(385140, 124, '2015-02-01 00:48:57.000000', 'consum', 0.0226, 'lps'),
	(385141, 124, '2015-02-01 00:48:58.000000', 'consum', 0.0230, 'lps'),
	(385142, 124, '2015-02-01 00:48:59.000000', 'consum', 0.0223, 'lps'),
	(385143, 124, '2015-02-01 00:49:00.000000', 'consum', 0.0214, 'lps'),
	(385144, 124, '2015-02-01 00:49:01.000000', 'consum', 0.0212, 'lps'),
	(385145, 124, '2015-02-01 00:49:02.000000', 'consum', 0.0230, 'lps'),
	(385146, 124, '2015-02-01 00:49:03.000000', 'consum', 0.0219, 'lps'),
	(385147, 124, '2015-02-01 00:49:04.000000', 'consum', 0.0220, 'lps'),
	(385148, 124, '2015-02-01 00:49:05.000000', 'consum', 0.0230, 'lps'),
	(385149, 124, '2015-02-01 00:49:06.000000', 'consum', 0.0219, 'lps'),
	(385150, 124, '2015-02-01 00:49:07.000000', 'consum', 0.0216, 'lps'),
	(385151, 124, '2015-02-01 00:49:08.000000', 'consum', 0.0212, 'lps'),
	(385152, 124, '2015-02-01 00:49:09.000000', 'consum', 0.0225, 'lps'),
	(385153, 124, '2015-02-01 00:49:10.000000', 'consum', 0.0218, 'lps'),
	(385154, 124, '2015-02-01 00:49:11.000000', 'consum', 0.0226, 'lps'),
	(385155, 124, '2015-02-01 00:49:12.000000', 'consum', 0.0225, 'lps'),
	(385156, 124, '2015-02-01 00:49:13.000000', 'consum', 0.0217, 'lps'),
	(385157, 124, '2015-02-01 00:49:14.000000', 'consum', 0.0221, 'lps'),
	(385158, 124, '2015-02-01 00:49:15.000000', 'consum', 0.0223, 'lps'),
	(385159, 124, '2015-02-01 00:49:16.000000', 'consum', 0.0224, 'lps'),
	(385160, 124, '2015-02-01 00:49:17.000000', 'consum', 0.0218, 'lps'),
	(385161, 124, '2015-02-01 00:49:18.000000', 'consum', 0.0230, 'lps'),
	(385162, 124, '2015-02-01 00:49:19.000000', 'consum', 0.0222, 'lps'),
	(385163, 124, '2015-02-01 00:49:20.000000', 'consum', 0.0210, 'lps'),
	(385164, 124, '2015-02-01 00:49:21.000000', 'consum', 0.0218, 'lps'),
	(385165, 124, '2015-02-01 00:49:22.000000', 'consum', 0.0230, 'lps'),
	(385166, 124, '2015-02-01 00:49:23.000000', 'consum', 0.0223, 'lps'),
	(385167, 124, '2015-02-01 00:49:24.000000', 'consum', 0.0214, 'lps'),
	(385168, 124, '2015-02-01 00:49:25.000000', 'consum', 0.0215, 'lps'),
	(385169, 124, '2015-02-01 00:49:26.000000', 'consum', 0.0224, 'lps'),
	(385170, 124, '2015-02-01 00:49:27.000000', 'consum', 0.0224, 'lps'),
	(385171, 124, '2015-02-01 00:49:28.000000', 'consum', 0.0217, 'lps'),
	(385172, 124, '2015-02-01 00:49:29.000000', 'consum', 0.0225, 'lps'),
	(385173, 124, '2015-02-01 00:49:30.000000', 'consum', 0.0224, 'lps'),
	(385174, 124, '2015-02-01 00:49:31.000000', 'consum', 0.0213, 'lps'),
	(385175, 124, '2015-02-01 00:49:32.000000', 'consum', 0.0225, 'lps'),
	(385176, 124, '2015-02-01 00:49:33.000000', 'consum', 0.0214, 'lps'),
	(385177, 124, '2015-02-01 00:49:34.000000', 'consum', 0.0226, 'lps'),
	(385178, 124, '2015-02-01 00:49:35.000000', 'consum', 0.0217, 'lps'),
	(385179, 124, '2015-02-01 00:49:36.000000', 'consum', 0.0218, 'lps'),
	(385180, 124, '2015-02-01 00:49:37.000000', 'consum', 0.0228, 'lps'),
	(385181, 124, '2015-02-01 00:49:38.000000', 'consum', 0.0214, 'lps'),
	(385182, 124, '2015-02-01 00:49:39.000000', 'consum', 0.0217, 'lps'),
	(385183, 124, '2015-02-01 00:49:40.000000', 'consum', 0.0214, 'lps'),
	(385184, 124, '2015-02-01 00:49:41.000000', 'consum', 0.0211, 'lps'),
	(385185, 124, '2015-02-01 00:49:42.000000', 'consum', 0.0226, 'lps'),
	(385186, 124, '2015-02-01 00:49:43.000000', 'consum', 0.0221, 'lps'),
	(385187, 124, '2015-02-01 00:49:44.000000', 'consum', 0.0217, 'lps'),
	(385188, 124, '2015-02-01 00:49:45.000000', 'consum', 0.0214, 'lps'),
	(385189, 124, '2015-02-01 00:49:46.000000', 'consum', 0.0228, 'lps'),
	(385190, 124, '2015-02-01 00:49:47.000000', 'consum', 0.0228, 'lps'),
	(385191, 124, '2015-02-01 00:49:48.000000', 'consum', 0.0225, 'lps'),
	(385192, 124, '2015-02-01 00:49:49.000000', 'consum', 0.0211, 'lps'),
	(385193, 124, '2015-02-01 00:49:50.000000', 'consum', 0.0214, 'lps'),
	(385194, 124, '2015-02-01 00:49:51.000000', 'consum', 0.0225, 'lps'),
	(385195, 124, '2015-02-01 00:49:52.000000', 'consum', 0.0212, 'lps'),
	(385196, 124, '2015-02-01 00:49:53.000000', 'consum', 0.0217, 'lps'),
	(385197, 124, '2015-02-01 00:49:54.000000', 'consum', 0.0218, 'lps'),
	(385198, 124, '2015-02-01 00:49:55.000000', 'consum', 0.0230, 'lps'),
	(385199, 124, '2015-02-01 00:49:56.000000', 'consum', 0.0222, 'lps'),
	(385200, 124, '2015-02-01 00:49:57.000000', 'consum', 0.0212, 'lps'),
	(385201, 124, '2015-02-01 00:49:58.000000', 'consum', 0.0226, 'lps'),
	(385202, 124, '2015-02-01 00:49:59.000000', 'consum', 0.0221, 'lps'),
	(385203, 124, '2015-02-01 00:50:00.000000', 'consum', 0.0217, 'lps'),
	(385204, 124, '2015-02-01 00:50:01.000000', 'consum', 0.0214, 'lps'),
	(385205, 124, '2015-02-01 00:50:02.000000', 'consum', 0.0210, 'lps'),
	(385206, 124, '2015-02-01 00:50:03.000000', 'consum', 0.0221, 'lps'),
	(385207, 124, '2015-02-01 00:50:04.000000', 'consum', 0.0220, 'lps'),
	(385208, 124, '2015-02-01 00:50:05.000000', 'consum', 0.0230, 'lps'),
	(385209, 124, '2015-02-01 00:50:06.000000', 'consum', 0.0217, 'lps'),
	(385210, 124, '2015-02-01 00:50:07.000000', 'consum', 0.0229, 'lps'),
	(385211, 124, '2015-02-01 00:50:08.000000', 'consum', 0.0220, 'lps'),
	(385212, 124, '2015-02-01 00:50:09.000000', 'consum', 0.0225, 'lps'),
	(385213, 124, '2015-02-01 00:50:10.000000', 'consum', 0.0212, 'lps'),
	(385214, 124, '2015-02-01 00:50:11.000000', 'consum', 0.0220, 'lps'),
	(385215, 124, '2015-02-01 00:50:12.000000', 'consum', 0.0212, 'lps'),
	(385216, 124, '2015-02-01 00:50:13.000000', 'consum', 0.0230, 'lps'),
	(385217, 124, '2015-02-01 00:50:14.000000', 'consum', 0.0223, 'lps'),
	(385218, 124, '2015-02-01 00:50:15.000000', 'consum', 0.0213, 'lps'),
	(385219, 124, '2015-02-01 00:50:16.000000', 'consum', 0.0230, 'lps'),
	(385220, 124, '2015-02-01 00:50:17.000000', 'consum', 0.0219, 'lps'),
	(385221, 124, '2015-02-01 00:50:18.000000', 'consum', 0.0216, 'lps'),
	(385222, 124, '2015-02-01 00:50:19.000000', 'consum', 0.0213, 'lps'),
	(385223, 124, '2015-02-01 00:50:20.000000', 'consum', 0.0228, 'lps'),
	(385224, 124, '2015-02-01 00:50:21.000000', 'consum', 0.0228, 'lps'),
	(385225, 124, '2015-02-01 00:50:22.000000', 'consum', 0.0227, 'lps'),
	(385226, 124, '2015-02-01 00:50:23.000000', 'consum', 0.0221, 'lps'),
	(385227, 124, '2015-02-01 00:50:24.000000', 'consum', 0.0213, 'lps'),
	(385228, 124, '2015-02-01 00:50:25.000000', 'consum', 0.0213, 'lps'),
	(385229, 124, '2015-02-01 00:50:26.000000', 'consum', 0.0216, 'lps'),
	(385230, 124, '2015-02-01 00:50:27.000000', 'consum', 0.0211, 'lps'),
	(385231, 124, '2015-02-01 00:50:28.000000', 'consum', 0.0218, 'lps'),
	(385232, 124, '2015-02-01 00:50:29.000000', 'consum', 0.0225, 'lps'),
	(385233, 124, '2015-02-01 00:50:30.000000', 'consum', 0.0220, 'lps'),
	(385234, 124, '2015-02-01 00:50:31.000000', 'consum', 0.0218, 'lps'),
	(385235, 124, '2015-02-01 00:50:32.000000', 'consum', 0.0218, 'lps'),
	(385236, 124, '2015-02-01 00:50:33.000000', 'consum', 0.0229, 'lps'),
	(385237, 124, '2015-02-01 00:50:34.000000', 'consum', 0.0217, 'lps'),
	(385238, 124, '2015-02-01 00:50:35.000000', 'consum', 0.0230, 'lps'),
	(385239, 124, '2015-02-01 00:50:36.000000', 'consum', 0.0226, 'lps'),
	(385240, 124, '2015-02-01 00:50:37.000000', 'consum', 0.0230, 'lps'),
	(385241, 124, '2015-02-01 00:50:38.000000', 'consum', 0.0223, 'lps'),
	(385242, 124, '2015-02-01 00:50:39.000000', 'consum', 0.0216, 'lps'),
	(385243, 124, '2015-02-01 00:50:40.000000', 'consum', 0.0220, 'lps'),
	(385244, 124, '2015-02-01 00:50:41.000000', 'consum', 0.0224, 'lps'),
	(385245, 124, '2015-02-01 00:50:42.000000', 'consum', 0.0228, 'lps'),
	(385246, 124, '2015-02-01 00:50:43.000000', 'consum', 0.0216, 'lps'),
	(385247, 124, '2015-02-01 00:50:44.000000', 'consum', 0.0230, 'lps'),
	(385248, 124, '2015-02-01 00:50:45.000000', 'consum', 0.0229, 'lps'),
	(385249, 124, '2015-02-01 00:50:46.000000', 'consum', 0.0222, 'lps'),
	(385250, 124, '2015-02-01 00:50:47.000000', 'consum', 0.0216, 'lps'),
	(385251, 124, '2015-02-01 00:50:48.000000', 'consum', 0.0226, 'lps'),
	(385252, 124, '2015-02-01 00:50:49.000000', 'consum', 0.0210, 'lps'),
	(385253, 124, '2015-02-01 00:50:50.000000', 'consum', 0.0225, 'lps'),
	(385254, 124, '2015-02-01 00:50:51.000000', 'consum', 0.0222, 'lps'),
	(385255, 124, '2015-02-01 00:50:52.000000', 'consum', 0.0225, 'lps'),
	(385256, 124, '2015-02-01 00:50:53.000000', 'consum', 0.0229, 'lps'),
	(385257, 124, '2015-02-01 00:50:54.000000', 'consum', 0.0219, 'lps'),
	(385258, 124, '2015-02-01 00:50:55.000000', 'consum', 0.0221, 'lps'),
	(385259, 124, '2015-02-01 00:50:56.000000', 'consum', 0.0216, 'lps'),
	(385260, 124, '2015-02-01 00:50:57.000000', 'consum', 0.0227, 'lps'),
	(385261, 124, '2015-02-01 00:50:58.000000', 'consum', 0.0217, 'lps'),
	(385262, 124, '2015-02-01 00:50:59.000000', 'consum', 0.0213, 'lps'),
	(385263, 124, '2015-02-01 00:51:00.000000', 'consum', 0.0228, 'lps'),
	(385264, 124, '2015-02-01 00:51:01.000000', 'consum', 0.0227, 'lps'),
	(385265, 124, '2015-02-01 00:51:02.000000', 'consum', 0.0219, 'lps'),
	(385266, 124, '2015-02-01 00:51:03.000000', 'consum', 0.0226, 'lps'),
	(385267, 124, '2015-02-01 00:51:04.000000', 'consum', 0.0224, 'lps'),
	(385268, 124, '2015-02-01 00:51:05.000000', 'consum', 0.0230, 'lps'),
	(385269, 124, '2015-02-01 00:51:06.000000', 'consum', 0.0227, 'lps'),
	(385270, 124, '2015-02-01 00:51:07.000000', 'consum', 0.0214, 'lps'),
	(385271, 124, '2015-02-01 00:51:08.000000', 'consum', 0.0220, 'lps'),
	(385272, 124, '2015-02-01 00:51:09.000000', 'consum', 0.0210, 'lps'),
	(385273, 124, '2015-02-01 00:51:10.000000', 'consum', 0.0220, 'lps'),
	(385274, 124, '2015-02-01 00:51:11.000000', 'consum', 0.0219, 'lps'),
	(385275, 124, '2015-02-01 00:51:12.000000', 'consum', 0.0224, 'lps'),
	(385276, 124, '2015-02-01 00:51:13.000000', 'consum', 0.0215, 'lps'),
	(385277, 124, '2015-02-01 00:51:14.000000', 'consum', 0.0211, 'lps'),
	(385278, 124, '2015-02-01 00:51:15.000000', 'consum', 0.0223, 'lps'),
	(385279, 124, '2015-02-01 00:51:16.000000', 'consum', 0.0210, 'lps'),
	(385280, 124, '2015-02-01 00:51:17.000000', 'consum', 0.0214, 'lps'),
	(385281, 124, '2015-02-01 00:51:18.000000', 'consum', 0.0211, 'lps'),
	(385282, 124, '2015-02-01 00:51:19.000000', 'consum', 0.0222, 'lps'),
	(385283, 124, '2015-02-01 00:51:20.000000', 'consum', 0.0226, 'lps'),
	(385284, 124, '2015-02-01 00:51:21.000000', 'consum', 0.0211, 'lps'),
	(385285, 124, '2015-02-01 00:51:22.000000', 'consum', 0.0212, 'lps'),
	(385286, 124, '2015-02-01 00:51:23.000000', 'consum', 0.0217, 'lps'),
	(385287, 124, '2015-02-01 00:51:24.000000', 'consum', 0.0217, 'lps'),
	(385288, 124, '2015-02-01 00:51:25.000000', 'consum', 0.0226, 'lps'),
	(385289, 124, '2015-02-01 00:51:26.000000', 'consum', 0.0226, 'lps'),
	(385290, 124, '2015-02-01 00:51:27.000000', 'consum', 0.0221, 'lps'),
	(385291, 124, '2015-02-01 00:51:28.000000', 'consum', 0.0217, 'lps'),
	(385292, 124, '2015-02-01 00:51:29.000000', 'consum', 0.0213, 'lps'),
	(385293, 124, '2015-02-01 00:51:30.000000', 'consum', 0.0227, 'lps'),
	(385294, 124, '2015-02-01 00:51:31.000000', 'consum', 0.0225, 'lps'),
	(385295, 124, '2015-02-01 00:51:32.000000', 'consum', 0.0211, 'lps'),
	(385296, 124, '2015-02-01 00:51:33.000000', 'consum', 0.0212, 'lps'),
	(385297, 124, '2015-02-01 00:51:34.000000', 'consum', 0.0219, 'lps'),
	(385298, 124, '2015-02-01 00:51:35.000000', 'consum', 0.0230, 'lps'),
	(385299, 124, '2015-02-01 00:51:36.000000', 'consum', 0.0218, 'lps'),
	(385300, 124, '2015-02-01 00:51:37.000000', 'consum', 0.0213, 'lps'),
	(385301, 124, '2015-02-01 00:51:38.000000', 'consum', 0.0222, 'lps'),
	(385302, 124, '2015-02-01 00:51:39.000000', 'consum', 0.0219, 'lps'),
	(385303, 124, '2015-02-01 00:51:40.000000', 'consum', 0.0218, 'lps'),
	(385304, 124, '2015-02-01 00:51:41.000000', 'consum', 0.0225, 'lps'),
	(385305, 124, '2015-02-01 00:51:42.000000', 'consum', 0.0218, 'lps'),
	(385306, 124, '2015-02-01 00:51:43.000000', 'consum', 0.0228, 'lps'),
	(385307, 124, '2015-02-01 00:51:44.000000', 'consum', 0.0214, 'lps'),
	(385308, 124, '2015-02-01 00:51:45.000000', 'consum', 0.0220, 'lps'),
	(385309, 124, '2015-02-01 00:51:46.000000', 'consum', 0.0226, 'lps'),
	(385310, 124, '2015-02-01 00:51:47.000000', 'consum', 0.0218, 'lps'),
	(385311, 124, '2015-02-01 00:51:48.000000', 'consum', 0.0223, 'lps'),
	(385312, 124, '2015-02-01 00:51:49.000000', 'consum', 0.0212, 'lps'),
	(385313, 124, '2015-02-01 00:51:50.000000', 'consum', 0.0223, 'lps'),
	(385314, 124, '2015-02-01 00:51:51.000000', 'consum', 0.0226, 'lps'),
	(385315, 124, '2015-02-01 00:51:52.000000', 'consum', 0.0230, 'lps'),
	(385316, 124, '2015-02-01 00:51:53.000000', 'consum', 0.0221, 'lps'),
	(385317, 124, '2015-02-01 00:51:54.000000', 'consum', 0.0226, 'lps'),
	(385318, 124, '2015-02-01 00:51:55.000000', 'consum', 0.0216, 'lps'),
	(385319, 124, '2015-02-01 00:51:56.000000', 'consum', 0.0212, 'lps'),
	(385320, 124, '2015-02-01 00:51:57.000000', 'consum', 0.0223, 'lps'),
	(385321, 124, '2015-02-01 00:51:58.000000', 'consum', 0.0230, 'lps'),
	(385322, 124, '2015-02-01 00:51:59.000000', 'consum', 0.0228, 'lps'),
	(385323, 124, '2015-02-01 00:52:00.000000', 'consum', 0.0222, 'lps'),
	(385324, 124, '2015-02-01 00:52:01.000000', 'consum', 0.0213, 'lps'),
	(385325, 124, '2015-02-01 00:52:02.000000', 'consum', 0.0214, 'lps'),
	(385326, 124, '2015-02-01 00:52:03.000000', 'consum', 0.0220, 'lps'),
	(385327, 124, '2015-02-01 00:52:04.000000', 'consum', 0.0229, 'lps'),
	(385328, 124, '2015-02-01 00:52:05.000000', 'consum', 0.0210, 'lps'),
	(385329, 124, '2015-02-01 00:52:06.000000', 'consum', 0.0216, 'lps'),
	(385330, 124, '2015-02-01 00:52:07.000000', 'consum', 0.0219, 'lps'),
	(385331, 124, '2015-02-01 00:52:08.000000', 'consum', 0.0218, 'lps'),
	(385332, 124, '2015-02-01 00:52:09.000000', 'consum', 0.0223, 'lps'),
	(385333, 124, '2015-02-01 00:52:10.000000', 'consum', 0.0211, 'lps'),
	(385334, 124, '2015-02-01 00:52:11.000000', 'consum', 0.0217, 'lps'),
	(385335, 124, '2015-02-01 00:52:12.000000', 'consum', 0.0222, 'lps'),
	(385336, 124, '2015-02-01 00:52:13.000000', 'consum', 0.0228, 'lps'),
	(385337, 124, '2015-02-01 00:52:14.000000', 'consum', 0.0225, 'lps'),
	(385338, 124, '2015-02-01 00:52:15.000000', 'consum', 0.0229, 'lps'),
	(385339, 124, '2015-02-01 00:52:16.000000', 'consum', 0.0218, 'lps'),
	(385340, 124, '2015-02-01 00:52:17.000000', 'consum', 0.0214, 'lps'),
	(385341, 124, '2015-02-01 00:52:18.000000', 'consum', 0.0230, 'lps'),
	(385342, 124, '2015-02-01 00:52:19.000000', 'consum', 0.0215, 'lps'),
	(385343, 124, '2015-02-01 00:52:20.000000', 'consum', 0.0217, 'lps'),
	(385344, 124, '2015-02-01 00:52:21.000000', 'consum', 0.0228, 'lps'),
	(385345, 124, '2015-02-01 00:52:22.000000', 'consum', 0.0218, 'lps'),
	(385346, 124, '2015-02-01 00:52:23.000000', 'consum', 0.0219, 'lps'),
	(385347, 124, '2015-02-01 00:52:24.000000', 'consum', 0.0210, 'lps'),
	(385348, 124, '2015-02-01 00:52:25.000000', 'consum', 0.0224, 'lps'),
	(385349, 124, '2015-02-01 00:52:26.000000', 'consum', 0.0219, 'lps'),
	(385350, 124, '2015-02-01 00:52:27.000000', 'consum', 0.0212, 'lps'),
	(385351, 124, '2015-02-01 00:52:28.000000', 'consum', 0.0214, 'lps'),
	(385352, 124, '2015-02-01 00:52:29.000000', 'consum', 0.0224, 'lps'),
	(385353, 124, '2015-02-01 00:52:30.000000', 'consum', 0.0225, 'lps'),
	(385354, 124, '2015-02-01 00:52:31.000000', 'consum', 0.0226, 'lps'),
	(385355, 124, '2015-02-01 00:52:32.000000', 'consum', 0.0222, 'lps'),
	(385356, 124, '2015-02-01 00:52:33.000000', 'consum', 0.0225, 'lps'),
	(385357, 124, '2015-02-01 00:52:34.000000', 'consum', 0.0227, 'lps'),
	(385358, 124, '2015-02-01 00:52:35.000000', 'consum', 0.0228, 'lps'),
	(385359, 124, '2015-02-01 00:52:36.000000', 'consum', 0.0211, 'lps'),
	(385360, 124, '2015-02-01 00:52:37.000000', 'consum', 0.0221, 'lps'),
	(385361, 124, '2015-02-01 00:52:38.000000', 'consum', 0.0223, 'lps'),
	(385362, 124, '2015-02-01 00:52:39.000000', 'consum', 0.0222, 'lps'),
	(385363, 124, '2015-02-01 00:52:40.000000', 'consum', 0.0212, 'lps'),
	(385364, 124, '2015-02-01 00:52:41.000000', 'consum', 0.0224, 'lps'),
	(385365, 124, '2015-02-01 00:52:42.000000', 'consum', 0.0210, 'lps'),
	(385366, 124, '2015-02-01 00:52:43.000000', 'consum', 0.0212, 'lps'),
	(385367, 124, '2015-02-01 00:52:44.000000', 'consum', 0.0220, 'lps'),
	(385368, 124, '2015-02-01 00:52:45.000000', 'consum', 0.0213, 'lps'),
	(385369, 124, '2015-02-01 00:52:46.000000', 'consum', 0.0216, 'lps'),
	(385370, 124, '2015-02-01 00:52:47.000000', 'consum', 0.0212, 'lps'),
	(385371, 124, '2015-02-01 00:52:48.000000', 'consum', 0.0223, 'lps'),
	(385372, 124, '2015-02-01 00:52:49.000000', 'consum', 0.0228, 'lps'),
	(385373, 124, '2015-02-01 00:52:50.000000', 'consum', 0.0221, 'lps'),
	(385374, 124, '2015-02-01 00:52:51.000000', 'consum', 0.0210, 'lps'),
	(385375, 124, '2015-02-01 00:52:52.000000', 'consum', 0.0221, 'lps'),
	(385376, 124, '2015-02-01 00:52:53.000000', 'consum', 0.0221, 'lps'),
	(385377, 124, '2015-02-01 00:52:54.000000', 'consum', 0.0213, 'lps'),
	(385378, 124, '2015-02-01 00:52:55.000000', 'consum', 0.0215, 'lps'),
	(385379, 124, '2015-02-01 00:52:56.000000', 'consum', 0.0224, 'lps'),
	(385380, 124, '2015-02-01 00:52:57.000000', 'consum', 0.0223, 'lps'),
	(385381, 124, '2015-02-01 00:52:58.000000', 'consum', 0.0214, 'lps'),
	(385382, 124, '2015-02-01 00:52:59.000000', 'consum', 0.0212, 'lps'),
	(385383, 124, '2015-02-01 00:53:00.000000', 'consum', 0.0210, 'lps'),
	(385384, 124, '2015-02-01 00:53:01.000000', 'consum', 0.0223, 'lps'),
	(385385, 124, '2015-02-01 00:53:02.000000', 'consum', 0.0213, 'lps'),
	(385386, 124, '2015-02-01 00:53:03.000000', 'consum', 0.0227, 'lps'),
	(385387, 124, '2015-02-01 00:53:04.000000', 'consum', 0.0226, 'lps'),
	(385388, 124, '2015-02-01 00:53:05.000000', 'consum', 0.0217, 'lps'),
	(385389, 124, '2015-02-01 00:53:06.000000', 'consum', 0.0219, 'lps'),
	(385390, 124, '2015-02-01 00:53:07.000000', 'consum', 0.0215, 'lps'),
	(385391, 124, '2015-02-01 00:53:08.000000', 'consum', 0.0228, 'lps'),
	(385392, 124, '2015-02-01 00:53:09.000000', 'consum', 0.0222, 'lps'),
	(385393, 124, '2015-02-01 00:53:10.000000', 'consum', 0.0216, 'lps'),
	(385394, 124, '2015-02-01 00:53:11.000000', 'consum', 0.0227, 'lps'),
	(385395, 124, '2015-02-01 00:53:12.000000', 'consum', 0.0215, 'lps'),
	(385396, 124, '2015-02-01 00:53:13.000000', 'consum', 0.0225, 'lps'),
	(385397, 124, '2015-02-01 00:53:14.000000', 'consum', 0.0228, 'lps'),
	(385398, 124, '2015-02-01 00:53:15.000000', 'consum', 0.0212, 'lps'),
	(385399, 124, '2015-02-01 00:53:16.000000', 'consum', 0.0211, 'lps'),
	(385400, 124, '2015-02-01 00:53:17.000000', 'consum', 0.0211, 'lps'),
	(385401, 124, '2015-02-01 00:53:18.000000', 'consum', 0.0230, 'lps'),
	(385402, 124, '2015-02-01 00:53:19.000000', 'consum', 0.0226, 'lps'),
	(385403, 124, '2015-02-01 00:53:20.000000', 'consum', 0.0230, 'lps'),
	(385404, 124, '2015-02-01 00:53:21.000000', 'consum', 0.0219, 'lps'),
	(385405, 124, '2015-02-01 00:53:22.000000', 'consum', 0.0216, 'lps'),
	(385406, 124, '2015-02-01 00:53:23.000000', 'consum', 0.0213, 'lps'),
	(385407, 124, '2015-02-01 00:53:24.000000', 'consum', 0.0230, 'lps'),
	(385408, 124, '2015-02-01 00:53:25.000000', 'consum', 0.0216, 'lps'),
	(385409, 124, '2015-02-01 00:53:26.000000', 'consum', 0.0223, 'lps'),
	(385410, 124, '2015-02-01 00:53:27.000000', 'consum', 0.0214, 'lps'),
	(385411, 124, '2015-02-01 00:53:28.000000', 'consum', 0.0215, 'lps'),
	(385412, 124, '2015-02-01 00:53:29.000000', 'consum', 0.0221, 'lps'),
	(385413, 124, '2015-02-01 00:53:30.000000', 'consum', 0.0210, 'lps'),
	(385414, 124, '2015-02-01 00:53:31.000000', 'consum', 0.0219, 'lps'),
	(385415, 124, '2015-02-01 00:53:32.000000', 'consum', 0.0212, 'lps'),
	(385416, 124, '2015-02-01 00:53:33.000000', 'consum', 0.0214, 'lps'),
	(385417, 124, '2015-02-01 00:53:34.000000', 'consum', 0.0226, 'lps'),
	(385418, 124, '2015-02-01 00:53:35.000000', 'consum', 0.0213, 'lps'),
	(385419, 124, '2015-02-01 00:53:36.000000', 'consum', 0.0222, 'lps'),
	(385420, 124, '2015-02-01 00:53:37.000000', 'consum', 0.0218, 'lps'),
	(385421, 124, '2015-02-01 00:53:38.000000', 'consum', 0.0213, 'lps'),
	(385422, 124, '2015-02-01 00:53:39.000000', 'consum', 0.0226, 'lps'),
	(385423, 124, '2015-02-01 00:53:40.000000', 'consum', 0.0216, 'lps'),
	(385424, 124, '2015-02-01 00:53:41.000000', 'consum', 0.0213, 'lps'),
	(385425, 124, '2015-02-01 00:53:42.000000', 'consum', 0.0228, 'lps'),
	(385426, 124, '2015-02-01 00:53:43.000000', 'consum', 0.0228, 'lps'),
	(385427, 124, '2015-02-01 00:53:44.000000', 'consum', 0.0227, 'lps'),
	(385428, 124, '2015-02-01 00:53:45.000000', 'consum', 0.0222, 'lps'),
	(385429, 124, '2015-02-01 00:53:46.000000', 'consum', 0.0219, 'lps'),
	(385430, 124, '2015-02-01 00:53:47.000000', 'consum', 0.0219, 'lps'),
	(385431, 124, '2015-02-01 00:53:48.000000', 'consum', 0.0229, 'lps'),
	(385432, 124, '2015-02-01 00:53:49.000000', 'consum', 0.0217, 'lps'),
	(385433, 124, '2015-02-01 00:53:50.000000', 'consum', 0.0229, 'lps'),
	(385434, 124, '2015-02-01 00:53:51.000000', 'consum', 0.0220, 'lps'),
	(385435, 124, '2015-02-01 00:53:52.000000', 'consum', 0.0226, 'lps'),
	(385436, 124, '2015-02-01 00:53:53.000000', 'consum', 0.0216, 'lps'),
	(385437, 124, '2015-02-01 00:53:54.000000', 'consum', 0.0216, 'lps'),
	(385438, 124, '2015-02-01 00:53:55.000000', 'consum', 0.0223, 'lps'),
	(385439, 124, '2015-02-01 00:53:56.000000', 'consum', 0.0215, 'lps'),
	(385440, 124, '2015-02-01 00:53:57.000000', 'consum', 0.0218, 'lps'),
	(385441, 124, '2015-02-01 00:53:58.000000', 'consum', 0.0214, 'lps'),
	(385442, 124, '2015-02-01 00:53:59.000000', 'consum', 0.0227, 'lps'),
	(385443, 124, '2015-02-01 00:54:00.000000', 'consum', 0.0222, 'lps'),
	(385444, 124, '2015-02-01 00:54:01.000000', 'consum', 0.0219, 'lps'),
	(385445, 124, '2015-02-01 00:54:02.000000', 'consum', 0.0219, 'lps'),
	(385446, 124, '2015-02-01 00:54:03.000000', 'consum', 0.0210, 'lps'),
	(385447, 124, '2015-02-01 00:54:04.000000', 'consum', 0.0222, 'lps'),
	(385448, 124, '2015-02-01 00:54:05.000000', 'consum', 0.0229, 'lps'),
	(385449, 124, '2015-02-01 00:54:06.000000', 'consum', 0.0228, 'lps'),
	(385450, 124, '2015-02-01 00:54:07.000000', 'consum', 0.0221, 'lps'),
	(385451, 124, '2015-02-01 00:54:08.000000', 'consum', 0.0214, 'lps'),
	(385452, 124, '2015-02-01 00:54:09.000000', 'consum', 0.0218, 'lps'),
	(385453, 124, '2015-02-01 00:54:10.000000', 'consum', 0.0216, 'lps'),
	(385454, 124, '2015-02-01 00:54:11.000000', 'consum', 0.0217, 'lps'),
	(385455, 124, '2015-02-01 00:54:12.000000', 'consum', 0.0230, 'lps'),
	(385456, 124, '2015-02-01 00:54:13.000000', 'consum', 0.0223, 'lps'),
	(385457, 124, '2015-02-01 00:54:14.000000', 'consum', 0.0218, 'lps'),
	(385458, 124, '2015-02-01 00:54:15.000000', 'consum', 0.0230, 'lps'),
	(385459, 124, '2015-02-01 00:54:16.000000', 'consum', 0.0223, 'lps'),
	(385460, 124, '2015-02-01 00:54:17.000000', 'consum', 0.0215, 'lps'),
	(385461, 124, '2015-02-01 00:54:18.000000', 'consum', 0.0220, 'lps'),
	(385462, 124, '2015-02-01 00:54:19.000000', 'consum', 0.0225, 'lps'),
	(385463, 124, '2015-02-01 00:54:20.000000', 'consum', 0.0214, 'lps'),
	(385464, 124, '2015-02-01 00:54:21.000000', 'consum', 0.0225, 'lps'),
	(385465, 124, '2015-02-01 00:54:22.000000', 'consum', 0.0211, 'lps'),
	(385466, 124, '2015-02-01 00:54:23.000000', 'consum', 0.0211, 'lps'),
	(385467, 124, '2015-02-01 00:54:24.000000', 'consum', 0.0214, 'lps'),
	(385468, 124, '2015-02-01 00:54:25.000000', 'consum', 0.0229, 'lps'),
	(385469, 124, '2015-02-01 00:54:26.000000', 'consum', 0.0230, 'lps'),
	(385470, 124, '2015-02-01 00:54:27.000000', 'consum', 0.0212, 'lps'),
	(385471, 124, '2015-02-01 00:54:28.000000', 'consum', 0.0223, 'lps'),
	(385472, 124, '2015-02-01 00:54:29.000000', 'consum', 0.0229, 'lps'),
	(385473, 124, '2015-02-01 00:54:30.000000', 'consum', 0.0224, 'lps'),
	(385474, 124, '2015-02-01 00:54:31.000000', 'consum', 0.0223, 'lps'),
	(385475, 124, '2015-02-01 00:54:32.000000', 'consum', 0.0213, 'lps'),
	(385476, 124, '2015-02-01 00:54:33.000000', 'consum', 0.0229, 'lps'),
	(385477, 124, '2015-02-01 00:54:34.000000', 'consum', 0.0214, 'lps'),
	(385478, 124, '2015-02-01 00:54:35.000000', 'consum', 0.0214, 'lps'),
	(385479, 124, '2015-02-01 00:54:36.000000', 'consum', 0.0220, 'lps'),
	(385480, 124, '2015-02-01 00:54:37.000000', 'consum', 0.0226, 'lps'),
	(385481, 124, '2015-02-01 00:54:38.000000', 'consum', 0.0220, 'lps'),
	(385482, 124, '2015-02-01 00:54:39.000000', 'consum', 0.0212, 'lps'),
	(385483, 124, '2015-02-01 00:54:40.000000', 'consum', 0.0210, 'lps'),
	(385484, 124, '2015-02-01 00:54:41.000000', 'consum', 0.0225, 'lps'),
	(385485, 124, '2015-02-01 00:54:42.000000', 'consum', 0.0222, 'lps'),
	(385486, 124, '2015-02-01 00:54:43.000000', 'consum', 0.0227, 'lps'),
	(385487, 124, '2015-02-01 00:54:44.000000', 'consum', 0.0218, 'lps'),
	(385488, 124, '2015-02-01 00:54:45.000000', 'consum', 0.0220, 'lps'),
	(385489, 124, '2015-02-01 00:54:46.000000', 'consum', 0.0214, 'lps'),
	(385490, 124, '2015-02-01 00:54:47.000000', 'consum', 0.0221, 'lps'),
	(385491, 124, '2015-02-01 00:54:48.000000', 'consum', 0.0214, 'lps'),
	(385492, 124, '2015-02-01 00:54:49.000000', 'consum', 0.0219, 'lps'),
	(385493, 124, '2015-02-01 00:54:50.000000', 'consum', 0.0223, 'lps'),
	(385494, 124, '2015-02-01 00:54:51.000000', 'consum', 0.0226, 'lps'),
	(385495, 124, '2015-02-01 00:54:52.000000', 'consum', 0.0211, 'lps'),
	(385496, 124, '2015-02-01 00:54:53.000000', 'consum', 0.0210, 'lps'),
	(385497, 124, '2015-02-01 00:54:54.000000', 'consum', 0.0227, 'lps'),
	(385498, 124, '2015-02-01 00:54:55.000000', 'consum', 0.0213, 'lps'),
	(385499, 124, '2015-02-01 00:54:56.000000', 'consum', 0.0216, 'lps'),
	(385500, 124, '2015-02-01 00:54:57.000000', 'consum', 0.0212, 'lps'),
	(385501, 124, '2015-02-01 00:54:58.000000', 'consum', 0.0222, 'lps'),
	(385502, 124, '2015-02-01 00:54:59.000000', 'consum', 0.0225, 'lps'),
	(385503, 124, '2015-02-01 00:55:00.000000', 'consum', 0.0226, 'lps'),
	(385504, 124, '2015-02-01 00:55:01.000000', 'consum', 0.0224, 'lps'),
	(385505, 124, '2015-02-01 00:55:02.000000', 'consum', 0.0213, 'lps'),
	(385506, 124, '2015-02-01 00:55:03.000000', 'consum', 0.0224, 'lps'),
	(385507, 124, '2015-02-01 00:55:04.000000', 'consum', 0.0210, 'lps'),
	(385508, 124, '2015-02-01 00:55:05.000000', 'consum', 0.0210, 'lps'),
	(385509, 124, '2015-02-01 00:55:06.000000', 'consum', 0.0211, 'lps'),
	(385510, 124, '2015-02-01 00:55:07.000000', 'consum', 0.0215, 'lps'),
	(385511, 124, '2015-02-01 00:55:08.000000', 'consum', 0.0213, 'lps'),
	(385512, 124, '2015-02-01 00:55:09.000000', 'consum', 0.0229, 'lps'),
	(385513, 124, '2015-02-01 00:55:10.000000', 'consum', 0.0215, 'lps'),
	(385514, 124, '2015-02-01 00:55:11.000000', 'consum', 0.0219, 'lps'),
	(385515, 124, '2015-02-01 00:55:12.000000', 'consum', 0.0219, 'lps'),
	(385516, 124, '2015-02-01 00:55:13.000000', 'consum', 0.0229, 'lps'),
	(385517, 124, '2015-02-01 00:55:14.000000', 'consum', 0.0214, 'lps'),
	(385518, 124, '2015-02-01 00:55:15.000000', 'consum', 0.0217, 'lps'),
	(385519, 124, '2015-02-01 00:55:16.000000', 'consum', 0.0210, 'lps'),
	(385520, 124, '2015-02-01 00:55:17.000000', 'consum', 0.0212, 'lps'),
	(385521, 124, '2015-02-01 00:55:18.000000', 'consum', 0.0223, 'lps'),
	(385522, 124, '2015-02-01 00:55:19.000000', 'consum', 0.0224, 'lps'),
	(385523, 124, '2015-02-01 00:55:20.000000', 'consum', 0.0220, 'lps'),
	(385524, 124, '2015-02-01 00:55:21.000000', 'consum', 0.0221, 'lps'),
	(385525, 124, '2015-02-01 00:55:22.000000', 'consum', 0.0212, 'lps'),
	(385526, 124, '2015-02-01 00:55:23.000000', 'consum', 0.0229, 'lps'),
	(385527, 124, '2015-02-01 00:55:24.000000', 'consum', 0.0217, 'lps'),
	(385528, 124, '2015-02-01 00:55:25.000000', 'consum', 0.0210, 'lps'),
	(385529, 124, '2015-02-01 00:55:26.000000', 'consum', 0.0210, 'lps'),
	(385530, 124, '2015-02-01 00:55:27.000000', 'consum', 0.0210, 'lps'),
	(385531, 124, '2015-02-01 00:55:28.000000', 'consum', 0.0211, 'lps'),
	(385532, 124, '2015-02-01 00:55:29.000000', 'consum', 0.0214, 'lps'),
	(385533, 124, '2015-02-01 00:55:30.000000', 'consum', 0.0228, 'lps'),
	(385534, 124, '2015-02-01 00:55:31.000000', 'consum', 0.0224, 'lps'),
	(385535, 124, '2015-02-01 00:55:32.000000', 'consum', 0.0226, 'lps'),
	(385536, 124, '2015-02-01 00:55:33.000000', 'consum', 0.0210, 'lps'),
	(385537, 124, '2015-02-01 00:55:34.000000', 'consum', 0.0222, 'lps'),
	(385538, 124, '2015-02-01 00:55:35.000000', 'consum', 0.0210, 'lps'),
	(385539, 124, '2015-02-01 00:55:36.000000', 'consum', 0.0214, 'lps'),
	(385540, 124, '2015-02-01 00:55:37.000000', 'consum', 0.0230, 'lps'),
	(385541, 124, '2015-02-01 00:55:38.000000', 'consum', 0.0214, 'lps'),
	(385542, 124, '2015-02-01 00:55:39.000000', 'consum', 0.0216, 'lps'),
	(385543, 124, '2015-02-01 00:55:40.000000', 'consum', 0.0225, 'lps'),
	(385544, 124, '2015-02-01 00:55:41.000000', 'consum', 0.0228, 'lps'),
	(385545, 124, '2015-02-01 00:55:42.000000', 'consum', 0.0214, 'lps'),
	(385546, 124, '2015-02-01 00:55:43.000000', 'consum', 0.0218, 'lps'),
	(385547, 124, '2015-02-01 00:55:44.000000', 'consum', 0.0218, 'lps'),
	(385548, 124, '2015-02-01 00:55:45.000000', 'consum', 0.0228, 'lps'),
	(385549, 124, '2015-02-01 00:55:46.000000', 'consum', 0.0212, 'lps'),
	(385550, 124, '2015-02-01 00:55:47.000000', 'consum', 0.0230, 'lps'),
	(385551, 124, '2015-02-01 00:55:48.000000', 'consum', 0.0220, 'lps'),
	(385552, 124, '2015-02-01 00:55:49.000000', 'consum', 0.0220, 'lps'),
	(385553, 124, '2015-02-01 00:55:50.000000', 'consum', 0.0230, 'lps'),
	(385554, 124, '2015-02-01 00:55:51.000000', 'consum', 0.0219, 'lps'),
	(385555, 124, '2015-02-01 00:55:52.000000', 'consum', 0.0217, 'lps'),
	(385556, 124, '2015-02-01 00:55:53.000000', 'consum', 0.0217, 'lps'),
	(385557, 124, '2015-02-01 00:55:54.000000', 'consum', 0.0227, 'lps'),
	(385558, 124, '2015-02-01 00:55:55.000000', 'consum', 0.0210, 'lps'),
	(385559, 124, '2015-02-01 00:55:56.000000', 'consum', 0.0223, 'lps'),
	(385560, 124, '2015-02-01 00:55:57.000000', 'consum', 0.0214, 'lps'),
	(385561, 124, '2015-02-01 00:55:58.000000', 'consum', 0.0213, 'lps'),
	(385562, 124, '2015-02-01 00:55:59.000000', 'consum', 0.0212, 'lps'),
	(385563, 124, '2015-02-01 00:56:00.000000', 'consum', 0.0210, 'lps'),
	(385564, 124, '2015-02-01 00:56:01.000000', 'consum', 0.0229, 'lps'),
	(385565, 124, '2015-02-01 00:56:02.000000', 'consum', 0.0218, 'lps'),
	(385566, 124, '2015-02-01 00:56:03.000000', 'consum', 0.0217, 'lps'),
	(385567, 124, '2015-02-01 00:56:04.000000', 'consum', 0.0222, 'lps'),
	(385568, 124, '2015-02-01 00:56:05.000000', 'consum', 0.0229, 'lps'),
	(385569, 124, '2015-02-01 00:56:06.000000', 'consum', 0.0228, 'lps'),
	(385570, 124, '2015-02-01 00:56:07.000000', 'consum', 0.0220, 'lps'),
	(385571, 124, '2015-02-01 00:56:08.000000', 'consum', 0.0227, 'lps'),
	(385572, 124, '2015-02-01 00:56:09.000000', 'consum', 0.0227, 'lps'),
	(385573, 124, '2015-02-01 00:56:10.000000', 'consum', 0.0220, 'lps'),
	(385574, 124, '2015-02-01 00:56:11.000000', 'consum', 0.0212, 'lps'),
	(385575, 124, '2015-02-01 00:56:12.000000', 'consum', 0.0211, 'lps'),
	(385576, 124, '2015-02-01 00:56:13.000000', 'consum', 0.0229, 'lps'),
	(385577, 124, '2015-02-01 00:56:14.000000', 'consum', 0.0220, 'lps'),
	(385578, 124, '2015-02-01 00:56:15.000000', 'consum', 0.0222, 'lps'),
	(385579, 124, '2015-02-01 00:56:16.000000', 'consum', 0.0222, 'lps'),
	(385580, 124, '2015-02-01 00:56:17.000000', 'consum', 0.0211, 'lps'),
	(385581, 124, '2015-02-01 00:56:18.000000', 'consum', 0.0222, 'lps'),
	(385582, 124, '2015-02-01 00:56:19.000000', 'consum', 0.0226, 'lps'),
	(385583, 124, '2015-02-01 00:56:20.000000', 'consum', 0.0210, 'lps'),
	(385584, 124, '2015-02-01 00:56:21.000000', 'consum', 0.0229, 'lps'),
	(385585, 124, '2015-02-01 00:56:22.000000', 'consum', 0.0221, 'lps'),
	(385586, 124, '2015-02-01 00:56:23.000000', 'consum', 0.0229, 'lps'),
	(385587, 124, '2015-02-01 00:56:24.000000', 'consum', 0.0211, 'lps'),
	(385588, 124, '2015-02-01 00:56:25.000000', 'consum', 0.0222, 'lps'),
	(385589, 124, '2015-02-01 00:56:26.000000', 'consum', 0.0223, 'lps'),
	(385590, 124, '2015-02-01 00:56:27.000000', 'consum', 0.0220, 'lps'),
	(385591, 124, '2015-02-01 00:56:28.000000', 'consum', 0.0222, 'lps'),
	(385592, 124, '2015-02-01 00:56:29.000000', 'consum', 0.0217, 'lps'),
	(385593, 124, '2015-02-01 00:56:30.000000', 'consum', 0.0212, 'lps'),
	(385594, 124, '2015-02-01 00:56:31.000000', 'consum', 0.0220, 'lps'),
	(385595, 124, '2015-02-01 00:56:32.000000', 'consum', 0.0213, 'lps'),
	(385596, 124, '2015-02-01 00:56:33.000000', 'consum', 0.0215, 'lps'),
	(385597, 124, '2015-02-01 00:56:34.000000', 'consum', 0.0228, 'lps'),
	(385598, 124, '2015-02-01 00:56:35.000000', 'consum', 0.0223, 'lps'),
	(385599, 124, '2015-02-01 00:56:36.000000', 'consum', 0.0220, 'lps'),
	(385600, 124, '2015-02-01 00:56:37.000000', 'consum', 0.0221, 'lps'),
	(385601, 124, '2015-02-01 00:56:38.000000', 'consum', 0.0216, 'lps'),
	(385602, 124, '2015-02-01 00:56:39.000000', 'consum', 0.0227, 'lps'),
	(385603, 124, '2015-02-01 00:56:40.000000', 'consum', 0.0214, 'lps'),
	(385604, 124, '2015-02-01 00:56:41.000000', 'consum', 0.0221, 'lps'),
	(385605, 124, '2015-02-01 00:56:42.000000', 'consum', 0.0211, 'lps'),
	(385606, 124, '2015-02-01 00:56:43.000000', 'consum', 0.0225, 'lps'),
	(385607, 124, '2015-02-01 00:56:44.000000', 'consum', 0.0220, 'lps'),
	(385608, 124, '2015-02-01 00:56:45.000000', 'consum', 0.0215, 'lps'),
	(385609, 124, '2015-02-01 00:56:46.000000', 'consum', 0.0228, 'lps'),
	(385610, 124, '2015-02-01 00:56:47.000000', 'consum', 0.0222, 'lps'),
	(385611, 124, '2015-02-01 00:56:48.000000', 'consum', 0.0218, 'lps'),
	(385612, 124, '2015-02-01 00:56:49.000000', 'consum', 0.0215, 'lps'),
	(385613, 124, '2015-02-01 00:56:50.000000', 'consum', 0.0230, 'lps'),
	(385614, 124, '2015-02-01 00:56:51.000000', 'consum', 0.0214, 'lps'),
	(385615, 124, '2015-02-01 00:56:52.000000', 'consum', 0.0230, 'lps'),
	(385616, 124, '2015-02-01 00:56:53.000000', 'consum', 0.0218, 'lps'),
	(385617, 124, '2015-02-01 00:56:54.000000', 'consum', 0.0211, 'lps'),
	(385618, 124, '2015-02-01 00:56:55.000000', 'consum', 0.0214, 'lps'),
	(385619, 124, '2015-02-01 00:56:56.000000', 'consum', 0.0224, 'lps'),
	(385620, 124, '2015-02-01 00:56:57.000000', 'consum', 0.0229, 'lps'),
	(385621, 124, '2015-02-01 00:56:58.000000', 'consum', 0.0222, 'lps'),
	(385622, 124, '2015-02-01 00:56:59.000000', 'consum', 0.0211, 'lps'),
	(385623, 124, '2015-02-01 00:57:00.000000', 'consum', 0.0222, 'lps'),
	(385624, 124, '2015-02-01 00:57:01.000000', 'consum', 0.0224, 'lps'),
	(385625, 124, '2015-02-01 00:57:02.000000', 'consum', 0.0224, 'lps'),
	(385626, 124, '2015-02-01 00:57:03.000000', 'consum', 0.0218, 'lps'),
	(385627, 124, '2015-02-01 00:57:04.000000', 'consum', 0.0230, 'lps'),
	(385628, 124, '2015-02-01 00:57:05.000000', 'consum', 0.0224, 'lps'),
	(385629, 124, '2015-02-01 00:57:06.000000', 'consum', 0.0221, 'lps'),
	(385630, 124, '2015-02-01 00:57:07.000000', 'consum', 0.0222, 'lps'),
	(385631, 124, '2015-02-01 00:57:08.000000', 'consum', 0.0218, 'lps'),
	(385632, 124, '2015-02-01 00:57:09.000000', 'consum', 0.0212, 'lps'),
	(385633, 124, '2015-02-01 00:57:10.000000', 'consum', 0.0217, 'lps'),
	(385634, 124, '2015-02-01 00:57:11.000000', 'consum', 0.0222, 'lps'),
	(385635, 124, '2015-02-01 00:57:12.000000', 'consum', 0.0226, 'lps'),
	(385636, 124, '2015-02-01 00:57:13.000000', 'consum', 0.0215, 'lps'),
	(385637, 124, '2015-02-01 00:57:14.000000', 'consum', 0.0228, 'lps'),
	(385638, 124, '2015-02-01 00:57:15.000000', 'consum', 0.0224, 'lps'),
	(385639, 124, '2015-02-01 00:57:16.000000', 'consum', 0.0224, 'lps'),
	(385640, 124, '2015-02-01 00:57:17.000000', 'consum', 0.0219, 'lps'),
	(385641, 124, '2015-02-01 00:57:18.000000', 'consum', 0.0214, 'lps'),
	(385642, 124, '2015-02-01 00:57:19.000000', 'consum', 0.0223, 'lps'),
	(385643, 124, '2015-02-01 00:57:20.000000', 'consum', 0.0220, 'lps'),
	(385644, 124, '2015-02-01 00:57:21.000000', 'consum', 0.0224, 'lps'),
	(385645, 124, '2015-02-01 00:57:22.000000', 'consum', 0.0227, 'lps'),
	(385646, 124, '2015-02-01 00:57:23.000000', 'consum', 0.0214, 'lps'),
	(385647, 124, '2015-02-01 00:57:24.000000', 'consum', 0.0222, 'lps'),
	(385648, 124, '2015-02-01 00:57:25.000000', 'consum', 0.0214, 'lps'),
	(385649, 124, '2015-02-01 00:57:26.000000', 'consum', 0.0215, 'lps'),
	(385650, 124, '2015-02-01 00:57:27.000000', 'consum', 0.0223, 'lps'),
	(385651, 124, '2015-02-01 00:57:28.000000', 'consum', 0.0219, 'lps'),
	(385652, 124, '2015-02-01 00:57:29.000000', 'consum', 0.0215, 'lps'),
	(385653, 124, '2015-02-01 00:57:30.000000', 'consum', 0.0211, 'lps'),
	(385654, 124, '2015-02-01 00:57:31.000000', 'consum', 0.0219, 'lps'),
	(385655, 124, '2015-02-01 00:57:32.000000', 'consum', 0.0211, 'lps'),
	(385656, 124, '2015-02-01 00:57:33.000000', 'consum', 0.0230, 'lps'),
	(385657, 124, '2015-02-01 00:57:34.000000', 'consum', 0.0226, 'lps'),
	(385658, 124, '2015-02-01 00:57:35.000000', 'consum', 0.0227, 'lps'),
	(385659, 124, '2015-02-01 00:57:36.000000', 'consum', 0.0230, 'lps'),
	(385660, 124, '2015-02-01 00:57:37.000000', 'consum', 0.0214, 'lps'),
	(385661, 124, '2015-02-01 00:57:38.000000', 'consum', 0.0215, 'lps'),
	(385662, 124, '2015-02-01 00:57:39.000000', 'consum', 0.0221, 'lps'),
	(385663, 124, '2015-02-01 00:57:40.000000', 'consum', 0.0211, 'lps'),
	(385664, 124, '2015-02-01 00:57:41.000000', 'consum', 0.0222, 'lps'),
	(385665, 124, '2015-02-01 00:57:42.000000', 'consum', 0.0226, 'lps'),
	(385666, 124, '2015-02-01 00:57:43.000000', 'consum', 0.0214, 'lps'),
	(385667, 124, '2015-02-01 00:57:44.000000', 'consum', 0.0225, 'lps'),
	(385668, 124, '2015-02-01 00:57:45.000000', 'consum', 0.0230, 'lps'),
	(385669, 124, '2015-02-01 00:57:46.000000', 'consum', 0.0225, 'lps'),
	(385670, 124, '2015-02-01 00:57:47.000000', 'consum', 0.0223, 'lps'),
	(385671, 124, '2015-02-01 00:57:48.000000', 'consum', 0.0212, 'lps'),
	(385672, 124, '2015-02-01 00:57:49.000000', 'consum', 0.0222, 'lps'),
	(385673, 124, '2015-02-01 00:57:50.000000', 'consum', 0.0223, 'lps'),
	(385674, 124, '2015-02-01 00:57:51.000000', 'consum', 0.0218, 'lps'),
	(385675, 124, '2015-02-01 00:57:52.000000', 'consum', 0.0210, 'lps'),
	(385676, 124, '2015-02-01 00:57:53.000000', 'consum', 0.0210, 'lps'),
	(385677, 124, '2015-02-01 00:57:54.000000', 'consum', 0.0229, 'lps'),
	(385678, 124, '2015-02-01 00:57:55.000000', 'consum', 0.0223, 'lps'),
	(385679, 124, '2015-02-01 00:57:56.000000', 'consum', 0.0220, 'lps'),
	(385680, 124, '2015-02-01 00:57:57.000000', 'consum', 0.0219, 'lps'),
	(385681, 124, '2015-02-01 00:57:58.000000', 'consum', 0.0228, 'lps'),
	(385682, 124, '2015-02-01 00:57:59.000000', 'consum', 0.0228, 'lps'),
	(385683, 124, '2015-02-01 00:58:00.000000', 'consum', 0.0229, 'lps'),
	(385684, 124, '2015-02-01 00:58:01.000000', 'consum', 0.0230, 'lps'),
	(385685, 124, '2015-02-01 00:58:02.000000', 'consum', 0.0212, 'lps'),
	(385686, 124, '2015-02-01 00:58:03.000000', 'consum', 0.0224, 'lps'),
	(385687, 124, '2015-02-01 00:58:04.000000', 'consum', 0.0212, 'lps'),
	(385688, 124, '2015-02-01 00:58:05.000000', 'consum', 0.0219, 'lps'),
	(385689, 124, '2015-02-01 00:58:06.000000', 'consum', 0.0230, 'lps'),
	(385690, 124, '2015-02-01 00:58:07.000000', 'consum', 0.0219, 'lps'),
	(385691, 124, '2015-02-01 00:58:08.000000', 'consum', 0.0216, 'lps'),
	(385692, 124, '2015-02-01 00:58:09.000000', 'consum', 0.0213, 'lps'),
	(385693, 124, '2015-02-01 00:58:10.000000', 'consum', 0.0210, 'lps'),
	(385694, 124, '2015-02-01 00:58:11.000000', 'consum', 0.0222, 'lps'),
	(385695, 124, '2015-02-01 00:58:12.000000', 'consum', 0.0226, 'lps'),
	(385696, 124, '2015-02-01 00:58:13.000000', 'consum', 0.0215, 'lps'),
	(385697, 124, '2015-02-01 00:58:14.000000', 'consum', 0.0228, 'lps'),
	(385698, 124, '2015-02-01 00:58:15.000000', 'consum', 0.0221, 'lps'),
	(385699, 124, '2015-02-01 00:58:16.000000', 'consum', 0.0213, 'lps'),
	(385700, 124, '2015-02-01 00:58:17.000000', 'consum', 0.0213, 'lps'),
	(385701, 124, '2015-02-01 00:58:18.000000', 'consum', 0.0219, 'lps'),
	(385702, 124, '2015-02-01 00:58:19.000000', 'consum', 0.0222, 'lps'),
	(385703, 124, '2015-02-01 00:58:20.000000', 'consum', 0.0226, 'lps'),
	(385704, 124, '2015-02-01 00:58:21.000000', 'consum', 0.0210, 'lps'),
	(385705, 124, '2015-02-01 00:58:22.000000', 'consum', 0.0226, 'lps'),
	(385706, 124, '2015-02-01 00:58:23.000000', 'consum', 0.0227, 'lps'),
	(385707, 124, '2015-02-01 00:58:24.000000', 'consum', 0.0227, 'lps'),
	(385708, 124, '2015-02-01 00:58:25.000000', 'consum', 0.0221, 'lps'),
	(385709, 124, '2015-02-01 00:58:26.000000', 'consum', 0.0218, 'lps'),
	(385710, 124, '2015-02-01 00:58:27.000000', 'consum', 0.0218, 'lps'),
	(385711, 124, '2015-02-01 00:58:28.000000', 'consum', 0.0223, 'lps'),
	(385712, 124, '2015-02-01 00:58:29.000000', 'consum', 0.0212, 'lps'),
	(385713, 124, '2015-02-01 00:58:30.000000', 'consum', 0.0222, 'lps'),
	(385714, 124, '2015-02-01 00:58:31.000000', 'consum', 0.0225, 'lps'),
	(385715, 124, '2015-02-01 00:58:32.000000', 'consum', 0.0227, 'lps'),
	(385716, 124, '2015-02-01 00:58:33.000000', 'consum', 0.0228, 'lps'),
	(385717, 124, '2015-02-01 00:58:34.000000', 'consum', 0.0211, 'lps'),
	(385718, 124, '2015-02-01 00:58:35.000000', 'consum', 0.0221, 'lps'),
	(385719, 124, '2015-02-01 00:58:36.000000', 'consum', 0.0221, 'lps'),
	(385720, 124, '2015-02-01 00:58:37.000000', 'consum', 0.0212, 'lps'),
	(385721, 124, '2015-02-01 00:58:38.000000', 'consum', 0.0210, 'lps'),
	(385722, 124, '2015-02-01 00:58:39.000000', 'consum', 0.0225, 'lps'),
	(385723, 124, '2015-02-01 00:58:40.000000', 'consum', 0.0224, 'lps'),
	(385724, 124, '2015-02-01 00:58:41.000000', 'consum', 0.0214, 'lps'),
	(385725, 124, '2015-02-01 00:58:42.000000', 'consum', 0.0229, 'lps'),
	(385726, 124, '2015-02-01 00:58:43.000000', 'consum', 0.0229, 'lps'),
	(385727, 124, '2015-02-01 00:58:44.000000', 'consum', 0.0210, 'lps'),
	(385728, 124, '2015-02-01 00:58:45.000000', 'consum', 0.0215, 'lps'),
	(385729, 124, '2015-02-01 00:58:46.000000', 'consum', 0.0215, 'lps'),
	(385730, 124, '2015-02-01 00:58:47.000000', 'consum', 0.0218, 'lps'),
	(385731, 124, '2015-02-01 00:58:48.000000', 'consum', 0.0218, 'lps'),
	(385732, 124, '2015-02-01 00:58:49.000000', 'consum', 0.0226, 'lps'),
	(385733, 124, '2015-02-01 00:58:50.000000', 'consum', 0.0223, 'lps'),
	(385734, 124, '2015-02-01 00:58:51.000000', 'consum', 0.0227, 'lps'),
	(385735, 124, '2015-02-01 00:58:52.000000', 'consum', 0.0216, 'lps'),
	(385736, 124, '2015-02-01 00:58:53.000000', 'consum', 0.0210, 'lps'),
	(385737, 124, '2015-02-01 00:58:54.000000', 'consum', 0.0211, 'lps'),
	(385738, 124, '2015-02-01 00:58:55.000000', 'consum', 0.0219, 'lps'),
	(385739, 124, '2015-02-01 00:58:56.000000', 'consum', 0.0229, 'lps'),
	(385740, 124, '2015-02-01 00:58:57.000000', 'consum', 0.0218, 'lps'),
	(385741, 124, '2015-02-01 00:58:58.000000', 'consum', 0.0214, 'lps'),
	(385742, 124, '2015-02-01 00:58:59.000000', 'consum', 0.0228, 'lps'),
	(385743, 124, '2015-02-01 00:59:00.000000', 'consum', 0.0223, 'lps'),
	(385744, 124, '2015-02-01 00:59:01.000000', 'consum', 0.0223, 'lps'),
	(385745, 124, '2015-02-01 00:59:02.000000', 'consum', 0.0215, 'lps'),
	(385746, 124, '2015-02-01 00:59:03.000000', 'consum', 0.0219, 'lps'),
	(385747, 124, '2015-02-01 00:59:04.000000', 'consum', 0.0217, 'lps'),
	(385748, 124, '2015-02-01 00:59:05.000000', 'consum', 0.0220, 'lps'),
	(385749, 124, '2015-02-01 00:59:06.000000', 'consum', 0.0220, 'lps'),
	(385750, 124, '2015-02-01 00:59:07.000000', 'consum', 0.0210, 'lps'),
	(385751, 124, '2015-02-01 00:59:08.000000', 'consum', 0.0220, 'lps'),
	(385752, 124, '2015-02-01 00:59:09.000000', 'consum', 0.0217, 'lps'),
	(385753, 124, '2015-02-01 00:59:10.000000', 'consum', 0.0219, 'lps'),
	(385754, 124, '2015-02-01 00:59:11.000000', 'consum', 0.0213, 'lps'),
	(385755, 124, '2015-02-01 00:59:12.000000', 'consum', 0.0221, 'lps'),
	(385756, 124, '2015-02-01 00:59:13.000000', 'consum', 0.0212, 'lps'),
	(385757, 124, '2015-02-01 00:59:14.000000', 'consum', 0.0229, 'lps'),
	(385758, 124, '2015-02-01 00:59:15.000000', 'consum', 0.0217, 'lps'),
	(385759, 124, '2015-02-01 00:59:16.000000', 'consum', 0.0229, 'lps'),
	(385760, 124, '2015-02-01 00:59:17.000000', 'consum', 0.0221, 'lps'),
	(385761, 124, '2015-02-01 00:59:18.000000', 'consum', 0.0210, 'lps'),
	(385762, 124, '2015-02-01 00:59:19.000000', 'consum', 0.0220, 'lps'),
	(385763, 124, '2015-02-01 00:59:20.000000', 'consum', 0.0220, 'lps'),
	(385764, 124, '2015-02-01 00:59:21.000000', 'consum', 0.0227, 'lps'),
	(385765, 124, '2015-02-01 00:59:22.000000', 'consum', 0.0225, 'lps'),
	(385766, 124, '2015-02-01 00:59:23.000000', 'consum', 0.0216, 'lps'),
	(385767, 124, '2015-02-01 00:59:24.000000', 'consum', 0.0213, 'lps'),
	(385768, 124, '2015-02-01 00:59:25.000000', 'consum', 0.0228, 'lps'),
	(385769, 124, '2015-02-01 00:59:26.000000', 'consum', 0.0210, 'lps'),
	(385770, 124, '2015-02-01 00:59:27.000000', 'consum', 0.0217, 'lps'),
	(385771, 124, '2015-02-01 00:59:28.000000', 'consum', 0.0228, 'lps'),
	(385772, 124, '2015-02-01 00:59:29.000000', 'consum', 0.0213, 'lps'),
	(385773, 124, '2015-02-01 00:59:30.000000', 'consum', 0.0214, 'lps'),
	(385774, 124, '2015-02-01 00:59:31.000000', 'consum', 0.0221, 'lps'),
	(385775, 124, '2015-02-01 00:59:32.000000', 'consum', 0.0211, 'lps'),
	(385776, 124, '2015-02-01 00:59:33.000000', 'consum', 0.0226, 'lps'),
	(385777, 124, '2015-02-01 00:59:34.000000', 'consum', 0.0225, 'lps'),
	(385778, 124, '2015-02-01 00:59:35.000000', 'consum', 0.0214, 'lps'),
	(385779, 124, '2015-02-01 00:59:36.000000', 'consum', 0.0210, 'lps'),
	(385780, 124, '2015-02-01 00:59:37.000000', 'consum', 0.0216, 'lps'),
	(385781, 124, '2015-02-01 00:59:38.000000', 'consum', 0.0222, 'lps'),
	(385782, 124, '2015-02-01 00:59:39.000000', 'consum', 0.0230, 'lps'),
	(385783, 124, '2015-02-01 00:59:40.000000', 'consum', 0.0211, 'lps'),
	(385784, 124, '2015-02-01 00:59:41.000000', 'consum', 0.0220, 'lps'),
	(385785, 124, '2015-02-01 00:59:42.000000', 'consum', 0.0215, 'lps'),
	(385786, 124, '2015-02-01 00:59:43.000000', 'consum', 0.0228, 'lps'),
	(385787, 124, '2015-02-01 00:59:44.000000', 'consum', 0.0220, 'lps'),
	(385788, 124, '2015-02-01 00:59:45.000000', 'consum', 0.0228, 'lps'),
	(385789, 124, '2015-02-01 00:59:46.000000', 'consum', 0.0228, 'lps'),
	(385790, 124, '2015-02-01 00:59:47.000000', 'consum', 0.0225, 'lps'),
	(385791, 124, '2015-02-01 00:59:48.000000', 'consum', 0.0210, 'lps'),
	(385792, 124, '2015-02-01 00:59:49.000000', 'consum', 0.0228, 'lps'),
	(385793, 124, '2015-02-01 00:59:50.000000', 'consum', 0.0218, 'lps'),
	(385794, 124, '2015-02-01 00:59:51.000000', 'consum', 0.0218, 'lps'),
	(385795, 124, '2015-02-01 00:59:52.000000', 'consum', 0.0226, 'lps'),
	(385796, 124, '2015-02-01 00:59:53.000000', 'consum', 0.0224, 'lps'),
	(385797, 124, '2015-02-01 00:59:54.000000', 'consum', 0.0212, 'lps'),
	(385798, 124, '2015-02-01 00:59:55.000000', 'consum', 0.0222, 'lps'),
	(385799, 124, '2015-02-01 00:59:56.000000', 'consum', 0.0220, 'lps'),
	(385800, 124, '2015-02-01 00:59:57.000000', 'consum', 0.0224, 'lps'),
	(385801, 124, '2015-02-01 00:59:58.000000', 'consum', 0.0210, 'lps'),
	(385802, 124, '2015-02-01 00:59:59.000000', 'consum', 0.0229, 'lps'),
	(385803, 124, '2015-02-01 01:00:00.000000', 'consum', 0.0225, 'lps'),
	(385804, 124, '2015-02-01 01:00:01.000000', 'consum', 0.0227, 'lps'),
	(385805, 124, '2015-02-01 01:00:02.000000', 'consum', 0.0210, 'lps'),
	(385806, 124, '2015-02-01 01:00:03.000000', 'consum', 0.0222, 'lps'),
	(385807, 124, '2015-02-01 01:00:04.000000', 'consum', 0.0230, 'lps'),
	(385808, 124, '2015-02-01 01:00:05.000000', 'consum', 0.0211, 'lps'),
	(385809, 124, '2015-02-01 01:00:06.000000', 'consum', 0.0218, 'lps'),
	(385810, 124, '2015-02-01 01:00:07.000000', 'consum', 0.0225, 'lps'),
	(385811, 124, '2015-02-01 01:00:08.000000', 'consum', 0.0222, 'lps'),
	(385812, 124, '2015-02-01 01:00:09.000000', 'consum', 0.0222, 'lps'),
	(385813, 124, '2015-02-01 01:00:10.000000', 'consum', 0.0217, 'lps'),
	(385814, 124, '2015-02-01 01:00:11.000000', 'consum', 0.0230, 'lps'),
	(385815, 124, '2015-02-01 01:00:12.000000', 'consum', 0.0225, 'lps'),
	(385816, 124, '2015-02-01 01:00:13.000000', 'consum', 0.0225, 'lps'),
	(385817, 124, '2015-02-01 01:00:14.000000', 'consum', 0.0222, 'lps'),
	(385818, 124, '2015-02-01 01:00:15.000000', 'consum', 0.0224, 'lps'),
	(385819, 124, '2015-02-01 01:00:16.000000', 'consum', 0.0222, 'lps'),
	(385820, 124, '2015-02-01 01:00:17.000000', 'consum', 0.0229, 'lps'),
	(385821, 124, '2015-02-01 01:00:18.000000', 'consum', 0.0230, 'lps'),
	(385822, 124, '2015-02-01 01:00:19.000000', 'consum', 0.0210, 'lps'),
	(385823, 124, '2015-02-01 01:00:20.000000', 'consum', 0.0214, 'lps'),
	(385824, 124, '2015-02-01 01:00:21.000000', 'consum', 0.0230, 'lps'),
	(385825, 124, '2015-02-01 01:00:22.000000', 'consum', 0.0213, 'lps'),
	(385826, 124, '2015-02-01 01:00:23.000000', 'consum', 0.0210, 'lps'),
	(385827, 124, '2015-02-01 01:00:24.000000', 'consum', 0.0223, 'lps'),
	(385828, 124, '2015-02-01 01:00:25.000000', 'consum', 0.0210, 'lps'),
	(385829, 124, '2015-02-01 01:00:26.000000', 'consum', 0.0214, 'lps'),
	(385830, 124, '2015-02-01 01:00:27.000000', 'consum', 0.0210, 'lps'),
	(385831, 124, '2015-02-01 01:00:28.000000', 'consum', 0.0220, 'lps'),
	(385832, 124, '2015-02-01 01:00:29.000000', 'consum', 0.0217, 'lps'),
	(385833, 124, '2015-02-01 01:00:30.000000', 'consum', 0.0218, 'lps'),
	(385834, 124, '2015-02-01 01:00:31.000000', 'consum', 0.0227, 'lps'),
	(385835, 124, '2015-02-01 01:00:32.000000', 'consum', 0.0229, 'lps'),
	(385836, 124, '2015-02-01 01:00:33.000000', 'consum', 0.0212, 'lps'),
	(385837, 124, '2015-02-01 01:00:34.000000', 'consum', 0.0230, 'lps'),
	(385838, 124, '2015-02-01 01:00:35.000000', 'consum', 0.0217, 'lps'),
	(385839, 124, '2015-02-01 01:00:36.000000', 'consum', 0.0228, 'lps'),
	(385840, 124, '2015-02-01 01:00:37.000000', 'consum', 0.0215, 'lps'),
	(385841, 124, '2015-02-01 01:00:38.000000', 'consum', 0.0226, 'lps'),
	(385842, 124, '2015-02-01 01:00:39.000000', 'consum', 0.0211, 'lps'),
	(385843, 124, '2015-02-01 01:00:40.000000', 'consum', 0.0230, 'lps'),
	(385844, 124, '2015-02-01 01:00:41.000000', 'consum', 0.0223, 'lps'),
	(385845, 124, '2015-02-01 01:00:42.000000', 'consum', 0.0218, 'lps'),
	(385846, 124, '2015-02-01 01:00:43.000000', 'consum', 0.0210, 'lps'),
	(385847, 124, '2015-02-01 01:00:44.000000', 'consum', 0.0230, 'lps'),
	(385848, 124, '2015-02-01 01:00:45.000000', 'consum', 0.0226, 'lps'),
	(385849, 124, '2015-02-01 01:00:46.000000', 'consum', 0.0229, 'lps'),
	(385850, 124, '2015-02-01 01:00:47.000000', 'consum', 0.0218, 'lps'),
	(385851, 124, '2015-02-01 01:00:48.000000', 'consum', 0.0212, 'lps'),
	(385852, 124, '2015-02-01 01:00:49.000000', 'consum', 0.0218, 'lps'),
	(385853, 124, '2015-02-01 01:00:50.000000', 'consum', 0.0222, 'lps'),
	(385854, 124, '2015-02-01 01:00:51.000000', 'consum', 0.0228, 'lps'),
	(385855, 124, '2015-02-01 01:00:52.000000', 'consum', 0.0222, 'lps'),
	(385856, 124, '2015-02-01 01:00:53.000000', 'consum', 0.0217, 'lps'),
	(385857, 124, '2015-02-01 01:00:54.000000', 'consum', 0.0229, 'lps'),
	(385858, 124, '2015-02-01 01:00:55.000000', 'consum', 0.0221, 'lps'),
	(385859, 124, '2015-02-01 01:00:56.000000', 'consum', 0.0230, 'lps'),
	(385860, 124, '2015-02-01 01:00:57.000000', 'consum', 0.0215, 'lps'),
	(385861, 124, '2015-02-01 01:00:58.000000', 'consum', 0.0219, 'lps'),
	(385862, 124, '2015-02-01 01:00:59.000000', 'consum', 0.0216, 'lps'),
	(385863, 124, '2015-02-01 01:01:00.000000', 'consum', 0.0216, 'lps'),
	(385864, 124, '2015-02-01 01:01:01.000000', 'consum', 0.0224, 'lps'),
	(385865, 124, '2015-02-01 01:01:02.000000', 'consum', 0.0219, 'lps'),
	(385866, 124, '2015-02-01 01:01:03.000000', 'consum', 0.0213, 'lps'),
	(385867, 124, '2015-02-01 01:01:04.000000', 'consum', 0.0220, 'lps'),
	(385868, 124, '2015-02-01 01:01:05.000000', 'consum', 0.0211, 'lps'),
	(385869, 124, '2015-02-01 01:01:06.000000', 'consum', 0.0227, 'lps'),
	(385870, 124, '2015-02-01 01:01:07.000000', 'consum', 0.0228, 'lps'),
	(385871, 124, '2015-02-01 01:01:08.000000', 'consum', 0.0228, 'lps'),
	(385872, 124, '2015-02-01 01:01:09.000000', 'consum', 0.0228, 'lps'),
	(385873, 124, '2015-02-01 01:01:10.000000', 'consum', 0.0223, 'lps'),
	(385874, 124, '2015-02-01 01:01:11.000000', 'consum', 0.0222, 'lps'),
	(385875, 124, '2015-02-01 01:01:12.000000', 'consum', 0.0210, 'lps'),
	(385876, 124, '2015-02-01 01:01:13.000000', 'consum', 0.0217, 'lps'),
	(385877, 124, '2015-02-01 01:01:14.000000', 'consum', 0.0224, 'lps'),
	(385878, 124, '2015-02-01 01:01:15.000000', 'consum', 0.0217, 'lps'),
	(385879, 124, '2015-02-01 01:01:16.000000', 'consum', 0.0225, 'lps'),
	(385880, 124, '2015-02-01 01:01:17.000000', 'consum', 0.0221, 'lps'),
	(385881, 124, '2015-02-01 01:01:18.000000', 'consum', 0.0221, 'lps'),
	(385882, 124, '2015-02-01 01:01:19.000000', 'consum', 0.0213, 'lps'),
	(385883, 124, '2015-02-01 01:01:20.000000', 'consum', 0.0213, 'lps'),
	(385884, 124, '2015-02-01 01:01:21.000000', 'consum', 0.0218, 'lps'),
	(385885, 124, '2015-02-01 01:01:22.000000', 'consum', 0.0221, 'lps'),
	(385886, 124, '2015-02-01 01:01:23.000000', 'consum', 0.0219, 'lps'),
	(385887, 124, '2015-02-01 01:01:24.000000', 'consum', 0.0223, 'lps'),
	(385888, 124, '2015-02-01 01:01:25.000000', 'consum', 0.0227, 'lps'),
	(385889, 124, '2015-02-01 01:01:26.000000', 'consum', 0.0213, 'lps'),
	(385890, 124, '2015-02-01 01:01:27.000000', 'consum', 0.0219, 'lps'),
	(385891, 124, '2015-02-01 01:01:28.000000', 'consum', 0.0224, 'lps'),
	(385892, 124, '2015-02-01 01:01:29.000000', 'consum', 0.0213, 'lps'),
	(385893, 124, '2015-02-01 01:01:30.000000', 'consum', 0.0223, 'lps'),
	(385894, 124, '2015-02-01 01:01:31.000000', 'consum', 0.0227, 'lps'),
	(385895, 124, '2015-02-01 01:01:32.000000', 'consum', 0.0212, 'lps'),
	(385896, 124, '2015-02-01 01:01:33.000000', 'consum', 0.0211, 'lps'),
	(385897, 124, '2015-02-01 01:01:34.000000', 'consum', 0.0230, 'lps'),
	(385898, 124, '2015-02-01 01:01:35.000000', 'consum', 0.0225, 'lps'),
	(385899, 124, '2015-02-01 01:01:36.000000', 'consum', 0.0223, 'lps'),
	(385900, 124, '2015-02-01 01:01:37.000000', 'consum', 0.0212, 'lps'),
	(385901, 124, '2015-02-01 01:01:38.000000', 'consum', 0.0225, 'lps'),
	(385902, 124, '2015-02-01 01:01:39.000000', 'consum', 0.0213, 'lps'),
	(385903, 124, '2015-02-01 01:01:40.000000', 'consum', 0.0225, 'lps'),
	(385904, 124, '2015-02-01 01:01:41.000000', 'consum', 0.0213, 'lps'),
	(385905, 124, '2015-02-01 01:01:42.000000', 'consum', 0.0222, 'lps'),
	(385906, 124, '2015-02-01 01:01:43.000000', 'consum', 0.0218, 'lps'),
	(385907, 124, '2015-02-01 01:01:44.000000', 'consum', 0.0214, 'lps'),
	(385908, 124, '2015-02-01 01:01:45.000000', 'consum', 0.0229, 'lps'),
	(385909, 124, '2015-02-01 01:01:46.000000', 'consum', 0.0229, 'lps'),
	(385910, 124, '2015-02-01 01:01:47.000000', 'consum', 0.0230, 'lps'),
	(385911, 124, '2015-02-01 01:01:48.000000', 'consum', 0.0210, 'lps'),
	(385912, 124, '2015-02-01 01:01:49.000000', 'consum', 0.0212, 'lps'),
	(385913, 124, '2015-02-01 01:01:50.000000', 'consum', 0.0222, 'lps'),
	(385914, 124, '2015-02-01 01:01:51.000000', 'consum', 0.0224, 'lps'),
	(385915, 124, '2015-02-01 01:01:52.000000', 'consum', 0.0221, 'lps'),
	(385916, 124, '2015-02-01 01:01:53.000000', 'consum', 0.0224, 'lps'),
	(385917, 124, '2015-02-01 01:01:54.000000', 'consum', 0.0227, 'lps'),
	(385918, 124, '2015-02-01 01:01:55.000000', 'consum', 0.0212, 'lps'),
	(385919, 124, '2015-02-01 01:01:56.000000', 'consum', 0.0211, 'lps'),
	(385920, 124, '2015-02-01 01:01:57.000000', 'consum', 0.0211, 'lps'),
	(385921, 124, '2015-02-01 01:01:58.000000', 'consum', 0.0230, 'lps'),
	(385922, 124, '2015-02-01 01:01:59.000000', 'consum', 0.0227, 'lps'),
	(385923, 124, '2015-02-01 01:02:00.000000', 'consum', 0.0215, 'lps'),
	(385924, 124, '2015-02-01 01:02:01.000000', 'consum', 0.0224, 'lps'),
	(385925, 124, '2015-02-01 01:02:02.000000', 'consum', 0.0227, 'lps'),
	(385926, 124, '2015-02-01 01:02:03.000000', 'consum', 0.0229, 'lps'),
	(385927, 124, '2015-02-01 01:02:04.000000', 'consum', 0.0212, 'lps'),
	(385928, 124, '2015-02-01 01:02:05.000000', 'consum', 0.0229, 'lps'),
	(385929, 124, '2015-02-01 01:02:06.000000', 'consum', 0.0215, 'lps'),
	(385930, 124, '2015-02-01 01:02:07.000000', 'consum', 0.0221, 'lps'),
	(385931, 124, '2015-02-01 01:02:08.000000', 'consum', 0.0229, 'lps'),
	(385932, 124, '2015-02-01 01:02:09.000000', 'consum', 0.0230, 'lps'),
	(385933, 124, '2015-02-01 01:02:10.000000', 'consum', 0.0212, 'lps'),
	(385934, 124, '2015-02-01 01:02:11.000000', 'consum', 0.0224, 'lps'),
	(385935, 124, '2015-02-01 01:02:12.000000', 'consum', 0.0230, 'lps'),
	(385936, 124, '2015-02-01 01:02:13.000000', 'consum', 0.0229, 'lps'),
	(385937, 124, '2015-02-01 01:02:14.000000', 'consum', 0.0224, 'lps'),
	(385938, 124, '2015-02-01 01:02:15.000000', 'consum', 0.0225, 'lps'),
	(385939, 124, '2015-02-01 01:02:16.000000', 'consum', 0.0222, 'lps'),
	(385940, 124, '2015-02-01 01:02:17.000000', 'consum', 0.0224, 'lps'),
	(385941, 124, '2015-02-01 01:02:18.000000', 'consum', 0.0226, 'lps'),
	(385942, 124, '2015-02-01 01:02:19.000000', 'consum', 0.0226, 'lps'),
	(385943, 124, '2015-02-01 01:02:20.000000', 'consum', 0.0221, 'lps'),
	(385944, 124, '2015-02-01 01:02:21.000000', 'consum', 0.0219, 'lps'),
	(385945, 124, '2015-02-01 01:02:22.000000', 'consum', 0.0220, 'lps'),
	(385946, 124, '2015-02-01 01:02:23.000000', 'consum', 0.0213, 'lps'),
	(385947, 124, '2015-02-01 01:02:24.000000', 'consum', 0.0218, 'lps'),
	(385948, 124, '2015-02-01 01:02:25.000000', 'consum', 0.0218, 'lps'),
	(385949, 124, '2015-02-01 01:02:26.000000', 'consum', 0.0228, 'lps'),
	(385950, 124, '2015-02-01 01:02:27.000000', 'consum', 0.0212, 'lps'),
	(385951, 124, '2015-02-01 01:02:28.000000', 'consum', 0.0230, 'lps'),
	(385952, 124, '2015-02-01 01:02:29.000000', 'consum', 0.0219, 'lps'),
	(385953, 124, '2015-02-01 01:02:30.000000', 'consum', 0.0219, 'lps'),
	(385954, 124, '2015-02-01 01:02:31.000000', 'consum', 0.0230, 'lps'),
	(385955, 124, '2015-02-01 01:02:32.000000', 'consum', 0.0218, 'lps'),
	(385956, 124, '2015-02-01 01:02:33.000000', 'consum', 0.0212, 'lps'),
	(385957, 124, '2015-02-01 01:02:34.000000', 'consum', 0.0216, 'lps'),
	(385958, 124, '2015-02-01 01:02:35.000000', 'consum', 0.0215, 'lps'),
	(385959, 124, '2015-02-01 01:02:36.000000', 'consum', 0.0216, 'lps'),
	(385960, 124, '2015-02-01 01:02:37.000000', 'consum', 0.0225, 'lps'),
	(385961, 124, '2015-02-01 01:02:38.000000', 'consum', 0.0225, 'lps'),
	(385962, 124, '2015-02-01 01:02:39.000000', 'consum', 0.0221, 'lps'),
	(385963, 124, '2015-02-01 01:02:40.000000', 'consum', 0.0219, 'lps'),
	(385964, 124, '2015-02-01 01:02:41.000000', 'consum', 0.0223, 'lps'),
	(385965, 124, '2015-02-01 01:02:42.000000', 'consum', 0.0227, 'lps'),
	(385966, 124, '2015-02-01 01:02:43.000000', 'consum', 0.0213, 'lps'),
	(385967, 124, '2015-02-01 01:02:44.000000', 'consum', 0.0219, 'lps'),
	(385968, 124, '2015-02-01 01:02:45.000000', 'consum', 0.0226, 'lps'),
	(385969, 124, '2015-02-01 01:02:46.000000', 'consum', 0.0220, 'lps'),
	(385970, 124, '2015-02-01 01:02:47.000000', 'consum', 0.0213, 'lps'),
	(385971, 124, '2015-02-01 01:02:48.000000', 'consum', 0.0216, 'lps'),
	(385972, 124, '2015-02-01 01:02:49.000000', 'consum', 0.0213, 'lps'),
	(385973, 124, '2015-02-01 01:02:50.000000', 'consum', 0.0225, 'lps'),
	(385974, 124, '2015-02-01 01:02:51.000000', 'consum', 0.0216, 'lps'),
	(385975, 124, '2015-02-01 01:02:52.000000', 'consum', 0.0215, 'lps'),
	(385976, 124, '2015-02-01 01:02:53.000000', 'consum', 0.0219, 'lps'),
	(385977, 124, '2015-02-01 01:02:54.000000', 'consum', 0.0220, 'lps'),
	(385978, 124, '2015-02-01 01:02:55.000000', 'consum', 0.0210, 'lps'),
	(385979, 124, '2015-02-01 01:02:56.000000', 'consum', 0.0223, 'lps'),
	(385980, 124, '2015-02-01 01:02:57.000000', 'consum', 0.0211, 'lps'),
	(385981, 124, '2015-02-01 01:02:58.000000', 'consum', 0.0220, 'lps'),
	(385982, 124, '2015-02-01 01:02:59.000000', 'consum', 0.0217, 'lps'),
	(385983, 124, '2015-02-01 01:03:00.000000', 'consum', 0.0213, 'lps'),
	(385984, 124, '2015-02-01 01:03:01.000000', 'consum', 0.0228, 'lps'),
	(385985, 124, '2015-02-01 01:03:02.000000', 'consum', 0.0229, 'lps'),
	(385986, 124, '2015-02-01 01:03:03.000000', 'consum', 0.0210, 'lps'),
	(385987, 124, '2015-02-01 01:03:04.000000', 'consum', 0.0217, 'lps'),
	(385988, 124, '2015-02-01 01:03:05.000000', 'consum', 0.0224, 'lps'),
	(385989, 124, '2015-02-01 01:03:06.000000', 'consum', 0.0218, 'lps'),
	(385990, 124, '2015-02-01 01:03:07.000000', 'consum', 0.0227, 'lps'),
	(385991, 124, '2015-02-01 01:03:08.000000', 'consum', 0.0211, 'lps'),
	(385992, 124, '2015-02-01 01:03:09.000000', 'consum', 0.0227, 'lps'),
	(385993, 124, '2015-02-01 01:03:10.000000', 'consum', 0.0210, 'lps'),
	(385994, 124, '2015-02-01 01:03:11.000000', 'consum', 0.0223, 'lps'),
	(385995, 124, '2015-02-01 01:03:12.000000', 'consum', 0.0211, 'lps'),
	(385996, 124, '2015-02-01 01:03:13.000000', 'consum', 0.0219, 'lps'),
	(385997, 124, '2015-02-01 01:03:14.000000', 'consum', 0.0212, 'lps'),
	(385998, 124, '2015-02-01 01:03:15.000000', 'consum', 0.0215, 'lps'),
	(385999, 124, '2015-02-01 01:03:16.000000', 'consum', 0.0227, 'lps'),
	(386000, 124, '2015-02-01 01:03:17.000000', 'consum', 0.0220, 'lps'),
	(386001, 124, '2015-02-01 01:03:18.000000', 'consum', 0.0229, 'lps'),
	(386002, 124, '2015-02-01 01:03:19.000000', 'consum', 0.0212, 'lps'),
	(386003, 124, '2015-02-01 01:03:20.000000', 'consum', 0.0227, 'lps'),
	(386004, 124, '2015-02-01 01:03:21.000000', 'consum', 0.0228, 'lps'),
	(386005, 124, '2015-02-01 01:03:22.000000', 'consum', 0.0226, 'lps'),
	(386006, 124, '2015-02-01 01:03:23.000000', 'consum', 0.0217, 'lps'),
	(386007, 124, '2015-02-01 01:03:24.000000', 'consum', 0.0217, 'lps'),
	(386008, 124, '2015-02-01 01:03:25.000000', 'consum', 0.0224, 'lps'),
	(386009, 124, '2015-02-01 01:03:26.000000', 'consum', 0.0220, 'lps'),
	(386010, 124, '2015-02-01 01:03:27.000000', 'consum', 0.0217, 'lps'),
	(386011, 124, '2015-02-01 01:03:28.000000', 'consum', 0.0215, 'lps'),
	(386012, 124, '2015-02-01 01:03:29.000000', 'consum', 0.0217, 'lps'),
	(386013, 124, '2015-02-01 01:03:30.000000', 'consum', 0.0227, 'lps'),
	(386014, 124, '2015-02-01 01:03:31.000000', 'consum', 0.0215, 'lps'),
	(386015, 124, '2015-02-01 01:03:32.000000', 'consum', 0.0225, 'lps'),
	(386016, 124, '2015-02-01 01:03:33.000000', 'consum', 0.0210, 'lps'),
	(386017, 124, '2015-02-01 01:03:34.000000', 'consum', 0.0225, 'lps'),
	(386018, 124, '2015-02-01 01:03:35.000000', 'consum', 0.0225, 'lps'),
	(386019, 124, '2015-02-01 01:03:36.000000', 'consum', 0.0218, 'lps'),
	(386020, 124, '2015-02-01 01:03:37.000000', 'consum', 0.0226, 'lps'),
	(386021, 124, '2015-02-01 01:03:38.000000', 'consum', 0.0225, 'lps'),
	(386022, 124, '2015-02-01 01:03:39.000000', 'consum', 0.0216, 'lps'),
	(386023, 124, '2015-02-01 01:03:40.000000', 'consum', 0.0218, 'lps'),
	(386024, 124, '2015-02-01 01:03:41.000000', 'consum', 0.0210, 'lps'),
	(386025, 124, '2015-02-01 01:03:42.000000', 'consum', 0.0210, 'lps'),
	(386026, 124, '2015-02-01 01:03:43.000000', 'consum', 0.0228, 'lps'),
	(386027, 124, '2015-02-01 01:03:44.000000', 'consum', 0.0218, 'lps'),
	(386028, 124, '2015-02-01 01:03:45.000000', 'consum', 0.0219, 'lps'),
	(386029, 124, '2015-02-01 01:03:46.000000', 'consum', 0.0211, 'lps'),
	(386030, 124, '2015-02-01 01:03:47.000000', 'consum', 0.0229, 'lps'),
	(386031, 124, '2015-02-01 01:03:48.000000', 'consum', 0.0219, 'lps'),
	(386032, 124, '2015-02-01 01:03:49.000000', 'consum', 0.0218, 'lps'),
	(386033, 124, '2015-02-01 01:03:50.000000', 'consum', 0.0223, 'lps'),
	(386034, 124, '2015-02-01 01:03:51.000000', 'consum', 0.0211, 'lps'),
	(386035, 124, '2015-02-01 01:03:52.000000', 'consum', 0.0217, 'lps'),
	(386036, 124, '2015-02-01 01:03:53.000000', 'consum', 0.0224, 'lps'),
	(386037, 124, '2015-02-01 01:03:54.000000', 'consum', 0.0216, 'lps'),
	(386038, 124, '2015-02-01 01:03:55.000000', 'consum', 0.0220, 'lps'),
	(386039, 124, '2015-02-01 01:03:56.000000', 'consum', 0.0223, 'lps'),
	(386040, 124, '2015-02-01 01:03:57.000000', 'consum', 0.0225, 'lps'),
	(386041, 124, '2015-02-01 01:03:58.000000', 'consum', 0.0223, 'lps'),
	(386042, 124, '2015-02-01 01:03:59.000000', 'consum', 0.0211, 'lps'),
	(386043, 124, '2015-02-01 01:04:00.000000', 'consum', 0.0217, 'lps'),
	(386044, 124, '2015-02-01 01:04:01.000000', 'consum', 0.0223, 'lps'),
	(386045, 124, '2015-02-01 01:04:02.000000', 'consum', 0.0212, 'lps'),
	(386046, 124, '2015-02-01 01:04:03.000000', 'consum', 0.0222, 'lps'),
	(386047, 124, '2015-02-01 01:04:04.000000', 'consum', 0.0225, 'lps'),
	(386048, 124, '2015-02-01 01:04:05.000000', 'consum', 0.0227, 'lps'),
	(386049, 124, '2015-02-01 01:04:06.000000', 'consum', 0.0230, 'lps'),
	(386050, 124, '2015-02-01 01:04:07.000000', 'consum', 0.0219, 'lps'),
	(386051, 124, '2015-02-01 01:04:08.000000', 'consum', 0.0214, 'lps'),
	(386052, 124, '2015-02-01 01:04:09.000000', 'consum', 0.0224, 'lps'),
	(386053, 125, '2015-02-01 00:00:00.000000', 'consum', 0.0222, 'lps'),
	(386054, 125, '2015-02-01 00:00:01.000000', 'consum', 0.0227, 'lps'),
	(386055, 125, '2015-02-01 00:00:02.000000', 'consum', 0.0232, 'lps'),
	(386056, 125, '2015-02-01 00:00:03.000000', 'consum', 0.0215, 'lps'),
	(386057, 125, '2015-02-01 00:00:04.000000', 'consum', 0.0224, 'lps'),
	(386058, 125, '2015-02-01 00:00:05.000000', 'consum', 0.0213, 'lps'),
	(386059, 125, '2015-02-01 00:00:06.000000', 'consum', 0.0210, 'lps'),
	(386060, 125, '2015-02-01 00:00:07.000000', 'consum', 0.0227, 'lps'),
	(386061, 125, '2015-02-01 00:00:08.000000', 'consum', 0.0214, 'lps'),
	(386062, 125, '2015-02-01 00:00:09.000000', 'consum', 0.0235, 'lps'),
	(386063, 125, '2015-02-01 00:00:10.000000', 'consum', 0.0214, 'lps'),
	(386064, 125, '2015-02-01 00:00:11.000000', 'consum', 0.0211, 'lps'),
	(386065, 125, '2015-02-01 00:00:12.000000', 'consum', 0.0231, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(386066, 125, '2015-02-01 00:00:13.000000', 'consum', 0.0232, 'lps'),
	(386067, 125, '2015-02-01 00:00:14.000000', 'consum', 0.0231, 'lps'),
	(386068, 125, '2015-02-01 00:00:15.000000', 'consum', 0.0219, 'lps'),
	(386069, 125, '2015-02-01 00:00:16.000000', 'consum', 0.0223, 'lps'),
	(386070, 125, '2015-02-01 00:00:17.000000', 'consum', 0.0222, 'lps'),
	(386071, 125, '2015-02-01 00:00:18.000000', 'consum', 0.0228, 'lps'),
	(386072, 125, '2015-02-01 00:00:19.000000', 'consum', 0.0214, 'lps'),
	(386073, 125, '2015-02-01 00:00:20.000000', 'consum', 0.0229, 'lps'),
	(386074, 125, '2015-02-01 00:00:21.000000', 'consum', 0.0213, 'lps'),
	(386075, 125, '2015-02-01 00:00:22.000000', 'consum', 0.0223, 'lps'),
	(386076, 125, '2015-02-01 00:00:23.000000', 'consum', 0.0211, 'lps'),
	(386077, 125, '2015-02-01 00:00:24.000000', 'consum', 0.0232, 'lps'),
	(386078, 125, '2015-02-01 00:00:25.000000', 'consum', 0.0236, 'lps'),
	(386079, 125, '2015-02-01 00:00:26.000000', 'consum', 0.0219, 'lps'),
	(386080, 125, '2015-02-01 00:00:27.000000', 'consum', 0.0231, 'lps'),
	(386081, 125, '2015-02-01 00:00:28.000000', 'consum', 0.0210, 'lps'),
	(386082, 125, '2015-02-01 00:00:29.000000', 'consum', 0.0228, 'lps'),
	(386083, 125, '2015-02-01 00:00:30.000000', 'consum', 0.0220, 'lps'),
	(386084, 125, '2015-02-01 00:00:31.000000', 'consum', 0.0231, 'lps'),
	(386085, 125, '2015-02-01 00:00:32.000000', 'consum', 0.0235, 'lps'),
	(386086, 125, '2015-02-01 00:00:33.000000', 'consum', 0.0216, 'lps'),
	(386087, 125, '2015-02-01 00:00:34.000000', 'consum', 0.0219, 'lps'),
	(386088, 125, '2015-02-01 00:00:35.000000', 'consum', 0.0213, 'lps'),
	(386089, 125, '2015-02-01 00:00:36.000000', 'consum', 0.0223, 'lps'),
	(386090, 125, '2015-02-01 00:00:37.000000', 'consum', 0.0211, 'lps'),
	(386091, 125, '2015-02-01 00:00:38.000000', 'consum', 0.0234, 'lps'),
	(386092, 125, '2015-02-01 00:00:39.000000', 'consum', 0.0219, 'lps'),
	(386093, 125, '2015-02-01 00:00:40.000000', 'consum', 0.0210, 'lps'),
	(386094, 125, '2015-02-01 00:00:41.000000', 'consum', 0.0212, 'lps'),
	(386095, 125, '2015-02-01 00:00:42.000000', 'consum', 0.0221, 'lps'),
	(386096, 125, '2015-02-01 00:00:43.000000', 'consum', 0.0233, 'lps'),
	(386097, 125, '2015-02-01 00:00:44.000000', 'consum', 0.0210, 'lps'),
	(386098, 125, '2015-02-01 00:00:45.000000', 'consum', 0.0223, 'lps'),
	(386099, 125, '2015-02-01 00:00:46.000000', 'consum', 0.0222, 'lps'),
	(386100, 125, '2015-02-01 00:00:47.000000', 'consum', 0.0231, 'lps'),
	(386101, 125, '2015-02-01 00:00:48.000000', 'consum', 0.0224, 'lps'),
	(386102, 125, '2015-02-01 00:00:49.000000', 'consum', 0.0217, 'lps'),
	(386103, 125, '2015-02-01 00:00:50.000000', 'consum', 0.0232, 'lps'),
	(386104, 125, '2015-02-01 00:00:51.000000', 'consum', 0.0218, 'lps'),
	(386105, 125, '2015-02-01 00:00:52.000000', 'consum', 0.0212, 'lps'),
	(386106, 125, '2015-02-01 00:00:53.000000', 'consum', 0.0225, 'lps'),
	(386107, 125, '2015-02-01 00:00:54.000000', 'consum', 0.0224, 'lps'),
	(386108, 125, '2015-02-01 00:00:55.000000', 'consum', 0.0235, 'lps'),
	(386109, 125, '2015-02-01 00:00:56.000000', 'consum', 0.0212, 'lps'),
	(386110, 125, '2015-02-01 00:00:57.000000', 'consum', 0.0227, 'lps'),
	(386111, 125, '2015-02-01 00:00:58.000000', 'consum', 0.0211, 'lps'),
	(386112, 125, '2015-02-01 00:00:59.000000', 'consum', 0.0216, 'lps'),
	(386113, 125, '2015-02-01 00:01:00.000000', 'consum', 0.0210, 'lps'),
	(386114, 125, '2015-02-01 00:01:01.000000', 'consum', 0.0222, 'lps'),
	(386115, 125, '2015-02-01 00:01:02.000000', 'consum', 0.0216, 'lps'),
	(386116, 125, '2015-02-01 00:01:03.000000', 'consum', 0.0230, 'lps'),
	(386117, 125, '2015-02-01 00:01:04.000000', 'consum', 0.0210, 'lps'),
	(386118, 125, '2015-02-01 00:01:05.000000', 'consum', 0.0235, 'lps'),
	(386119, 125, '2015-02-01 00:01:06.000000', 'consum', 0.0225, 'lps'),
	(386120, 125, '2015-02-01 00:01:07.000000', 'consum', 0.0210, 'lps'),
	(386121, 125, '2015-02-01 00:01:08.000000', 'consum', 0.0219, 'lps'),
	(386122, 125, '2015-02-01 00:01:09.000000', 'consum', 0.0229, 'lps'),
	(386123, 125, '2015-02-01 00:01:10.000000', 'consum', 0.0225, 'lps'),
	(386124, 125, '2015-02-01 00:01:11.000000', 'consum', 0.0230, 'lps'),
	(386125, 125, '2015-02-01 00:01:12.000000', 'consum', 0.0212, 'lps'),
	(386126, 125, '2015-02-01 00:01:13.000000', 'consum', 0.0213, 'lps'),
	(386127, 125, '2015-02-01 00:01:14.000000', 'consum', 0.0218, 'lps'),
	(386128, 125, '2015-02-01 00:01:15.000000', 'consum', 0.0215, 'lps'),
	(386129, 125, '2015-02-01 00:01:16.000000', 'consum', 0.0214, 'lps'),
	(386130, 125, '2015-02-01 00:01:17.000000', 'consum', 0.0213, 'lps'),
	(386131, 125, '2015-02-01 00:01:18.000000', 'consum', 0.0213, 'lps'),
	(386132, 125, '2015-02-01 00:01:19.000000', 'consum', 0.0220, 'lps'),
	(386133, 125, '2015-02-01 00:01:20.000000', 'consum', 0.0221, 'lps'),
	(386134, 125, '2015-02-01 00:01:21.000000', 'consum', 0.0235, 'lps'),
	(386135, 125, '2015-02-01 00:01:22.000000', 'consum', 0.0224, 'lps'),
	(386136, 125, '2015-02-01 00:01:23.000000', 'consum', 0.0232, 'lps'),
	(386137, 125, '2015-02-01 00:01:24.000000', 'consum', 0.0222, 'lps'),
	(386138, 125, '2015-02-01 00:01:25.000000', 'consum', 0.0235, 'lps'),
	(386139, 125, '2015-02-01 00:01:26.000000', 'consum', 0.0216, 'lps'),
	(386140, 125, '2015-02-01 00:01:27.000000', 'consum', 0.0222, 'lps'),
	(386141, 125, '2015-02-01 00:01:28.000000', 'consum', 0.0226, 'lps'),
	(386142, 125, '2015-02-01 00:01:29.000000', 'consum', 0.0225, 'lps'),
	(386143, 125, '2015-02-01 00:01:30.000000', 'consum', 0.0210, 'lps'),
	(386144, 125, '2015-02-01 00:01:31.000000', 'consum', 0.0222, 'lps'),
	(386145, 125, '2015-02-01 00:01:32.000000', 'consum', 0.0214, 'lps'),
	(386146, 125, '2015-02-01 00:01:33.000000', 'consum', 0.0224, 'lps'),
	(386147, 125, '2015-02-01 00:01:34.000000', 'consum', 0.0214, 'lps'),
	(386148, 125, '2015-02-01 00:01:35.000000', 'consum', 0.0214, 'lps'),
	(386149, 125, '2015-02-01 00:01:36.000000', 'consum', 0.0220, 'lps'),
	(386150, 125, '2015-02-01 00:01:37.000000', 'consum', 0.0221, 'lps'),
	(386151, 125, '2015-02-01 00:01:38.000000', 'consum', 0.0234, 'lps'),
	(386152, 125, '2015-02-01 00:01:39.000000', 'consum', 0.0215, 'lps'),
	(386153, 125, '2015-02-01 00:01:40.000000', 'consum', 0.0221, 'lps'),
	(386154, 125, '2015-02-01 00:01:41.000000', 'consum', 0.0223, 'lps'),
	(386155, 125, '2015-02-01 00:01:42.000000', 'consum', 0.0214, 'lps'),
	(386156, 125, '2015-02-01 00:01:43.000000', 'consum', 0.0220, 'lps'),
	(386157, 125, '2015-02-01 00:01:44.000000', 'consum', 0.0221, 'lps'),
	(386158, 125, '2015-02-01 00:01:45.000000', 'consum', 0.0210, 'lps'),
	(386159, 125, '2015-02-01 00:01:46.000000', 'consum', 0.0232, 'lps'),
	(386160, 125, '2015-02-01 00:01:47.000000', 'consum', 0.0211, 'lps'),
	(386161, 125, '2015-02-01 00:01:48.000000', 'consum', 0.0229, 'lps'),
	(386162, 125, '2015-02-01 00:01:49.000000', 'consum', 0.0225, 'lps'),
	(386163, 125, '2015-02-01 00:01:50.000000', 'consum', 0.0225, 'lps'),
	(386164, 125, '2015-02-01 00:01:51.000000', 'consum', 0.0215, 'lps'),
	(386165, 125, '2015-02-01 00:01:52.000000', 'consum', 0.0216, 'lps'),
	(386166, 125, '2015-02-01 00:01:53.000000', 'consum', 0.0227, 'lps'),
	(386167, 125, '2015-02-01 00:01:54.000000', 'consum', 0.0225, 'lps'),
	(386168, 125, '2015-02-01 00:01:55.000000', 'consum', 0.0233, 'lps'),
	(386169, 125, '2015-02-01 00:01:56.000000', 'consum', 0.0226, 'lps'),
	(386170, 125, '2015-02-01 00:01:57.000000', 'consum', 0.0220, 'lps'),
	(386171, 125, '2015-02-01 00:01:58.000000', 'consum', 0.0215, 'lps'),
	(386172, 125, '2015-02-01 00:01:59.000000', 'consum', 0.0230, 'lps'),
	(386173, 125, '2015-02-01 00:02:00.000000', 'consum', 0.0217, 'lps'),
	(386174, 125, '2015-02-01 00:02:01.000000', 'consum', 0.0212, 'lps'),
	(386175, 125, '2015-02-01 00:02:02.000000', 'consum', 0.0226, 'lps'),
	(386176, 125, '2015-02-01 00:02:03.000000', 'consum', 0.0229, 'lps'),
	(386177, 125, '2015-02-01 00:02:04.000000', 'consum', 0.0230, 'lps'),
	(386178, 125, '2015-02-01 00:02:05.000000', 'consum', 0.0229, 'lps'),
	(386179, 125, '2015-02-01 00:02:06.000000', 'consum', 0.0217, 'lps'),
	(386180, 125, '2015-02-01 00:02:07.000000', 'consum', 0.0216, 'lps'),
	(386181, 125, '2015-02-01 00:02:08.000000', 'consum', 0.0218, 'lps'),
	(386182, 125, '2015-02-01 00:02:09.000000', 'consum', 0.0233, 'lps'),
	(386183, 125, '2015-02-01 00:02:10.000000', 'consum', 0.0221, 'lps'),
	(386184, 125, '2015-02-01 00:02:11.000000', 'consum', 0.0222, 'lps'),
	(386185, 125, '2015-02-01 00:02:12.000000', 'consum', 0.0212, 'lps'),
	(386186, 125, '2015-02-01 00:02:13.000000', 'consum', 0.0211, 'lps'),
	(386187, 125, '2015-02-01 00:02:14.000000', 'consum', 0.0236, 'lps'),
	(386188, 125, '2015-02-01 00:02:15.000000', 'consum', 0.0230, 'lps'),
	(386189, 125, '2015-02-01 00:02:16.000000', 'consum', 0.0233, 'lps'),
	(386190, 125, '2015-02-01 00:02:17.000000', 'consum', 0.0211, 'lps'),
	(386191, 125, '2015-02-01 00:02:18.000000', 'consum', 0.0228, 'lps'),
	(386192, 125, '2015-02-01 00:02:19.000000', 'consum', 0.0215, 'lps'),
	(386193, 125, '2015-02-01 00:02:20.000000', 'consum', 0.0210, 'lps'),
	(386194, 125, '2015-02-01 00:02:21.000000', 'consum', 0.0220, 'lps'),
	(386195, 125, '2015-02-01 00:02:22.000000', 'consum', 0.0210, 'lps'),
	(386196, 125, '2015-02-01 00:02:23.000000', 'consum', 0.0231, 'lps'),
	(386197, 125, '2015-02-01 00:02:24.000000', 'consum', 0.0236, 'lps'),
	(386198, 125, '2015-02-01 00:02:25.000000', 'consum', 0.0225, 'lps'),
	(386199, 125, '2015-02-01 00:02:26.000000', 'consum', 0.0233, 'lps'),
	(386200, 125, '2015-02-01 00:02:27.000000', 'consum', 0.0228, 'lps'),
	(386201, 125, '2015-02-01 00:02:28.000000', 'consum', 0.0233, 'lps'),
	(386202, 125, '2015-02-01 00:02:29.000000', 'consum', 0.0215, 'lps'),
	(386203, 125, '2015-02-01 00:02:30.000000', 'consum', 0.0221, 'lps'),
	(386204, 125, '2015-02-01 00:02:31.000000', 'consum', 0.0224, 'lps'),
	(386205, 125, '2015-02-01 00:02:32.000000', 'consum', 0.0219, 'lps'),
	(386206, 125, '2015-02-01 00:02:33.000000', 'consum', 0.0216, 'lps'),
	(386207, 125, '2015-02-01 00:02:34.000000', 'consum', 0.0214, 'lps'),
	(386208, 125, '2015-02-01 00:02:35.000000', 'consum', 0.0213, 'lps'),
	(386209, 125, '2015-02-01 00:02:36.000000', 'consum', 0.0213, 'lps'),
	(386210, 125, '2015-02-01 00:02:37.000000', 'consum', 0.0215, 'lps'),
	(386211, 125, '2015-02-01 00:02:38.000000', 'consum', 0.0227, 'lps'),
	(386212, 125, '2015-02-01 00:02:39.000000', 'consum', 0.0228, 'lps'),
	(386213, 125, '2015-02-01 00:02:40.000000', 'consum', 0.0220, 'lps'),
	(386214, 125, '2015-02-01 00:02:41.000000', 'consum', 0.0235, 'lps'),
	(386215, 125, '2015-02-01 00:02:42.000000', 'consum', 0.0222, 'lps'),
	(386216, 125, '2015-02-01 00:02:43.000000', 'consum', 0.0224, 'lps'),
	(386217, 125, '2015-02-01 00:02:44.000000', 'consum', 0.0219, 'lps'),
	(386218, 125, '2015-02-01 00:02:45.000000', 'consum', 0.0214, 'lps'),
	(386219, 125, '2015-02-01 00:02:46.000000', 'consum', 0.0228, 'lps'),
	(386220, 125, '2015-02-01 00:02:47.000000', 'consum', 0.0235, 'lps'),
	(386221, 125, '2015-02-01 00:02:48.000000', 'consum', 0.0228, 'lps'),
	(386222, 125, '2015-02-01 00:02:49.000000', 'consum', 0.0226, 'lps'),
	(386223, 125, '2015-02-01 00:02:50.000000', 'consum', 0.0210, 'lps'),
	(386224, 125, '2015-02-01 00:02:51.000000', 'consum', 0.0216, 'lps'),
	(386225, 125, '2015-02-01 00:02:52.000000', 'consum', 0.0213, 'lps'),
	(386226, 125, '2015-02-01 00:02:53.000000', 'consum', 0.0234, 'lps'),
	(386227, 125, '2015-02-01 00:02:54.000000', 'consum', 0.0214, 'lps'),
	(386228, 125, '2015-02-01 00:02:55.000000', 'consum', 0.0211, 'lps'),
	(386229, 125, '2015-02-01 00:02:56.000000', 'consum', 0.0233, 'lps'),
	(386230, 125, '2015-02-01 00:02:57.000000', 'consum', 0.0214, 'lps'),
	(386231, 125, '2015-02-01 00:02:58.000000', 'consum', 0.0215, 'lps'),
	(386232, 125, '2015-02-01 00:02:59.000000', 'consum', 0.0223, 'lps'),
	(386233, 125, '2015-02-01 00:03:00.000000', 'consum', 0.0232, 'lps'),
	(386234, 125, '2015-02-01 00:03:01.000000', 'consum', 0.0229, 'lps'),
	(386235, 125, '2015-02-01 00:03:02.000000', 'consum', 0.0211, 'lps'),
	(386236, 125, '2015-02-01 00:03:03.000000', 'consum', 0.0212, 'lps'),
	(386237, 125, '2015-02-01 00:03:04.000000', 'consum', 0.0219, 'lps'),
	(386238, 125, '2015-02-01 00:03:05.000000', 'consum', 0.0224, 'lps'),
	(386239, 125, '2015-02-01 00:03:06.000000', 'consum', 0.0224, 'lps'),
	(386240, 125, '2015-02-01 00:03:07.000000', 'consum', 0.0213, 'lps'),
	(386241, 125, '2015-02-01 00:03:08.000000', 'consum', 0.0210, 'lps'),
	(386242, 125, '2015-02-01 00:03:09.000000', 'consum', 0.0227, 'lps'),
	(386243, 125, '2015-02-01 00:03:10.000000', 'consum', 0.0213, 'lps'),
	(386244, 125, '2015-02-01 00:03:11.000000', 'consum', 0.0232, 'lps'),
	(386245, 125, '2015-02-01 00:03:12.000000', 'consum', 0.0230, 'lps'),
	(386246, 125, '2015-02-01 00:03:13.000000', 'consum', 0.0219, 'lps'),
	(386247, 125, '2015-02-01 00:03:14.000000', 'consum', 0.0219, 'lps'),
	(386248, 125, '2015-02-01 00:03:15.000000', 'consum', 0.0232, 'lps'),
	(386249, 125, '2015-02-01 00:03:16.000000', 'consum', 0.0210, 'lps'),
	(386250, 125, '2015-02-01 00:03:17.000000', 'consum', 0.0226, 'lps'),
	(386251, 125, '2015-02-01 00:03:18.000000', 'consum', 0.0235, 'lps'),
	(386252, 125, '2015-02-01 00:03:19.000000', 'consum', 0.0234, 'lps'),
	(386253, 125, '2015-02-01 00:03:20.000000', 'consum', 0.0229, 'lps'),
	(386254, 125, '2015-02-01 00:03:21.000000', 'consum', 0.0232, 'lps'),
	(386255, 125, '2015-02-01 00:03:22.000000', 'consum', 0.0211, 'lps'),
	(386256, 125, '2015-02-01 00:03:23.000000', 'consum', 0.0232, 'lps'),
	(386257, 125, '2015-02-01 00:03:24.000000', 'consum', 0.0235, 'lps'),
	(386258, 125, '2015-02-01 00:03:25.000000', 'consum', 0.0216, 'lps'),
	(386259, 125, '2015-02-01 00:03:26.000000', 'consum', 0.0219, 'lps'),
	(386260, 125, '2015-02-01 00:03:27.000000', 'consum', 0.0210, 'lps'),
	(386261, 125, '2015-02-01 00:03:28.000000', 'consum', 0.0212, 'lps'),
	(386262, 125, '2015-02-01 00:03:29.000000', 'consum', 0.0218, 'lps'),
	(386263, 125, '2015-02-01 00:03:30.000000', 'consum', 0.0220, 'lps'),
	(386264, 125, '2015-02-01 00:03:31.000000', 'consum', 0.0234, 'lps'),
	(386265, 125, '2015-02-01 00:03:32.000000', 'consum', 0.0222, 'lps'),
	(386266, 125, '2015-02-01 00:03:33.000000', 'consum', 0.0225, 'lps'),
	(386267, 125, '2015-02-01 00:03:34.000000', 'consum', 0.0224, 'lps'),
	(386268, 125, '2015-02-01 00:03:35.000000', 'consum', 0.0234, 'lps'),
	(386269, 125, '2015-02-01 00:03:36.000000', 'consum', 0.0236, 'lps'),
	(386270, 125, '2015-02-01 00:03:37.000000', 'consum', 0.0212, 'lps'),
	(386271, 125, '2015-02-01 00:03:38.000000', 'consum', 0.0222, 'lps'),
	(386272, 125, '2015-02-01 00:03:39.000000', 'consum', 0.0214, 'lps'),
	(386273, 125, '2015-02-01 00:03:40.000000', 'consum', 0.0222, 'lps'),
	(386274, 125, '2015-02-01 00:03:41.000000', 'consum', 0.0231, 'lps'),
	(386275, 125, '2015-02-01 00:03:42.000000', 'consum', 0.0225, 'lps'),
	(386276, 125, '2015-02-01 00:03:43.000000', 'consum', 0.0223, 'lps'),
	(386277, 125, '2015-02-01 00:03:44.000000', 'consum', 0.0231, 'lps'),
	(386278, 125, '2015-02-01 00:03:45.000000', 'consum', 0.0224, 'lps'),
	(386279, 125, '2015-02-01 00:03:46.000000', 'consum', 0.0216, 'lps'),
	(386280, 125, '2015-02-01 00:03:47.000000', 'consum', 0.0224, 'lps'),
	(386281, 125, '2015-02-01 00:03:48.000000', 'consum', 0.0210, 'lps'),
	(386282, 125, '2015-02-01 00:03:49.000000', 'consum', 0.0221, 'lps'),
	(386283, 125, '2015-02-01 00:03:50.000000', 'consum', 0.0213, 'lps'),
	(386284, 125, '2015-02-01 00:03:51.000000', 'consum', 0.0218, 'lps'),
	(386285, 125, '2015-02-01 00:03:52.000000', 'consum', 0.0215, 'lps'),
	(386286, 125, '2015-02-01 00:03:53.000000', 'consum', 0.0211, 'lps'),
	(386287, 125, '2015-02-01 00:03:54.000000', 'consum', 0.0226, 'lps'),
	(386288, 125, '2015-02-01 00:03:55.000000', 'consum', 0.0210, 'lps'),
	(386289, 125, '2015-02-01 00:03:56.000000', 'consum', 0.0213, 'lps'),
	(386290, 125, '2015-02-01 00:03:57.000000', 'consum', 0.0226, 'lps'),
	(386291, 125, '2015-02-01 00:03:58.000000', 'consum', 0.0230, 'lps'),
	(386292, 125, '2015-02-01 00:03:59.000000', 'consum', 0.0235, 'lps'),
	(386293, 125, '2015-02-01 00:04:00.000000', 'consum', 0.0220, 'lps'),
	(386294, 125, '2015-02-01 00:04:01.000000', 'consum', 0.0212, 'lps'),
	(386295, 125, '2015-02-01 00:04:02.000000', 'consum', 0.0217, 'lps'),
	(386296, 125, '2015-02-01 00:04:03.000000', 'consum', 0.0213, 'lps'),
	(386297, 125, '2015-02-01 00:04:04.000000', 'consum', 0.0231, 'lps'),
	(386298, 125, '2015-02-01 00:04:05.000000', 'consum', 0.0226, 'lps'),
	(386299, 125, '2015-02-01 00:04:06.000000', 'consum', 0.0228, 'lps'),
	(386300, 125, '2015-02-01 00:04:07.000000', 'consum', 0.0224, 'lps'),
	(386301, 125, '2015-02-01 00:04:08.000000', 'consum', 0.0226, 'lps'),
	(386302, 125, '2015-02-01 00:04:09.000000', 'consum', 0.0221, 'lps'),
	(386303, 125, '2015-02-01 00:04:10.000000', 'consum', 0.0219, 'lps'),
	(386304, 125, '2015-02-01 00:04:11.000000', 'consum', 0.0221, 'lps'),
	(386305, 125, '2015-02-01 00:04:12.000000', 'consum', 0.0212, 'lps'),
	(386306, 125, '2015-02-01 00:04:13.000000', 'consum', 0.0216, 'lps'),
	(386307, 125, '2015-02-01 00:04:14.000000', 'consum', 0.0233, 'lps'),
	(386308, 125, '2015-02-01 00:04:15.000000', 'consum', 0.0227, 'lps'),
	(386309, 125, '2015-02-01 00:04:16.000000', 'consum', 0.0227, 'lps'),
	(386310, 125, '2015-02-01 00:04:17.000000', 'consum', 0.0218, 'lps'),
	(386311, 125, '2015-02-01 00:04:18.000000', 'consum', 0.0226, 'lps'),
	(386312, 125, '2015-02-01 00:04:19.000000', 'consum', 0.0212, 'lps'),
	(386313, 125, '2015-02-01 00:04:20.000000', 'consum', 0.0229, 'lps'),
	(386314, 125, '2015-02-01 00:04:21.000000', 'consum', 0.0216, 'lps'),
	(386315, 125, '2015-02-01 00:04:22.000000', 'consum', 0.0212, 'lps'),
	(386316, 125, '2015-02-01 00:04:23.000000', 'consum', 0.0230, 'lps'),
	(386317, 125, '2015-02-01 00:04:24.000000', 'consum', 0.0221, 'lps'),
	(386318, 125, '2015-02-01 00:04:25.000000', 'consum', 0.0234, 'lps'),
	(386319, 125, '2015-02-01 00:04:26.000000', 'consum', 0.0218, 'lps'),
	(386320, 125, '2015-02-01 00:04:27.000000', 'consum', 0.0232, 'lps'),
	(386321, 125, '2015-02-01 00:04:28.000000', 'consum', 0.0216, 'lps'),
	(386322, 125, '2015-02-01 00:04:29.000000', 'consum', 0.0229, 'lps'),
	(386323, 125, '2015-02-01 00:04:30.000000', 'consum', 0.0231, 'lps'),
	(386324, 125, '2015-02-01 00:04:31.000000', 'consum', 0.0234, 'lps'),
	(386325, 125, '2015-02-01 00:04:32.000000', 'consum', 0.0214, 'lps'),
	(386326, 125, '2015-02-01 00:04:33.000000', 'consum', 0.0210, 'lps'),
	(386327, 125, '2015-02-01 00:04:34.000000', 'consum', 0.0225, 'lps'),
	(386328, 125, '2015-02-01 00:04:35.000000', 'consum', 0.0234, 'lps'),
	(386329, 125, '2015-02-01 00:04:36.000000', 'consum', 0.0229, 'lps'),
	(386330, 125, '2015-02-01 00:04:37.000000', 'consum', 0.0233, 'lps'),
	(386331, 125, '2015-02-01 00:04:38.000000', 'consum', 0.0216, 'lps'),
	(386332, 125, '2015-02-01 00:04:39.000000', 'consum', 0.0226, 'lps'),
	(386333, 125, '2015-02-01 00:04:40.000000', 'consum', 0.0218, 'lps'),
	(386334, 125, '2015-02-01 00:04:41.000000', 'consum', 0.0231, 'lps'),
	(386335, 125, '2015-02-01 00:04:42.000000', 'consum', 0.0211, 'lps'),
	(386336, 125, '2015-02-01 00:04:43.000000', 'consum', 0.0231, 'lps'),
	(386337, 125, '2015-02-01 00:04:44.000000', 'consum', 0.0234, 'lps'),
	(386338, 125, '2015-02-01 00:04:45.000000', 'consum', 0.0212, 'lps'),
	(386339, 125, '2015-02-01 00:04:46.000000', 'consum', 0.0228, 'lps'),
	(386340, 125, '2015-02-01 00:04:47.000000', 'consum', 0.0214, 'lps'),
	(386341, 125, '2015-02-01 00:04:48.000000', 'consum', 0.0229, 'lps'),
	(386342, 125, '2015-02-01 00:04:49.000000', 'consum', 0.0214, 'lps'),
	(386343, 125, '2015-02-01 00:04:50.000000', 'consum', 0.0227, 'lps'),
	(386344, 125, '2015-02-01 00:04:51.000000', 'consum', 0.0228, 'lps'),
	(386345, 125, '2015-02-01 00:04:52.000000', 'consum', 0.0223, 'lps'),
	(386346, 125, '2015-02-01 00:04:53.000000', 'consum', 0.0222, 'lps'),
	(386347, 125, '2015-02-01 00:04:54.000000', 'consum', 0.0231, 'lps'),
	(386348, 125, '2015-02-01 00:04:55.000000', 'consum', 0.0227, 'lps'),
	(386349, 125, '2015-02-01 00:04:56.000000', 'consum', 0.0233, 'lps'),
	(386350, 125, '2015-02-01 00:04:57.000000', 'consum', 0.0221, 'lps'),
	(386351, 125, '2015-02-01 00:04:58.000000', 'consum', 0.0223, 'lps'),
	(386352, 125, '2015-02-01 00:04:59.000000', 'consum', 0.0217, 'lps'),
	(386353, 125, '2015-02-01 00:05:00.000000', 'consum', 0.0232, 'lps'),
	(386354, 125, '2015-02-01 00:05:01.000000', 'consum', 0.0220, 'lps'),
	(386355, 125, '2015-02-01 00:05:02.000000', 'consum', 0.0220, 'lps'),
	(386356, 125, '2015-02-01 00:05:03.000000', 'consum', 0.0229, 'lps'),
	(386357, 125, '2015-02-01 00:05:04.000000', 'consum', 0.0224, 'lps'),
	(386358, 125, '2015-02-01 00:05:05.000000', 'consum', 0.0225, 'lps'),
	(386359, 125, '2015-02-01 00:05:06.000000', 'consum', 0.0213, 'lps'),
	(386360, 125, '2015-02-01 00:05:07.000000', 'consum', 0.0235, 'lps'),
	(386361, 125, '2015-02-01 00:05:08.000000', 'consum', 0.0219, 'lps'),
	(386362, 125, '2015-02-01 00:05:09.000000', 'consum', 0.0236, 'lps'),
	(386363, 125, '2015-02-01 00:05:10.000000', 'consum', 0.0230, 'lps'),
	(386364, 125, '2015-02-01 00:05:11.000000', 'consum', 0.0235, 'lps'),
	(386365, 125, '2015-02-01 00:05:12.000000', 'consum', 0.0222, 'lps'),
	(386366, 125, '2015-02-01 00:05:13.000000', 'consum', 0.0220, 'lps'),
	(386367, 125, '2015-02-01 00:05:14.000000', 'consum', 0.0227, 'lps'),
	(386368, 125, '2015-02-01 00:05:15.000000', 'consum', 0.0236, 'lps'),
	(386369, 125, '2015-02-01 00:05:16.000000', 'consum', 0.0211, 'lps'),
	(386370, 125, '2015-02-01 00:05:17.000000', 'consum', 0.0220, 'lps'),
	(386371, 125, '2015-02-01 00:05:18.000000', 'consum', 0.0227, 'lps'),
	(386372, 125, '2015-02-01 00:05:19.000000', 'consum', 0.0212, 'lps'),
	(386373, 125, '2015-02-01 00:05:20.000000', 'consum', 0.0224, 'lps'),
	(386374, 125, '2015-02-01 00:05:21.000000', 'consum', 0.0220, 'lps'),
	(386375, 125, '2015-02-01 00:05:22.000000', 'consum', 0.0219, 'lps'),
	(386376, 125, '2015-02-01 00:05:23.000000', 'consum', 0.0225, 'lps'),
	(386377, 125, '2015-02-01 00:05:24.000000', 'consum', 0.0233, 'lps'),
	(386378, 125, '2015-02-01 00:05:25.000000', 'consum', 0.0225, 'lps'),
	(386379, 125, '2015-02-01 00:05:26.000000', 'consum', 0.0217, 'lps'),
	(386380, 125, '2015-02-01 00:05:27.000000', 'consum', 0.0227, 'lps'),
	(386381, 125, '2015-02-01 00:05:28.000000', 'consum', 0.0220, 'lps'),
	(386382, 125, '2015-02-01 00:05:29.000000', 'consum', 0.0210, 'lps'),
	(386383, 125, '2015-02-01 00:05:30.000000', 'consum', 0.0236, 'lps'),
	(386384, 125, '2015-02-01 00:05:31.000000', 'consum', 0.0231, 'lps'),
	(386385, 125, '2015-02-01 00:05:32.000000', 'consum', 0.0212, 'lps'),
	(386386, 125, '2015-02-01 00:05:33.000000', 'consum', 0.0210, 'lps'),
	(386387, 125, '2015-02-01 00:05:34.000000', 'consum', 0.0234, 'lps'),
	(386388, 125, '2015-02-01 00:05:35.000000', 'consum', 0.0220, 'lps'),
	(386389, 125, '2015-02-01 00:05:36.000000', 'consum', 0.0216, 'lps'),
	(386390, 125, '2015-02-01 00:05:37.000000', 'consum', 0.0213, 'lps'),
	(386391, 125, '2015-02-01 00:05:38.000000', 'consum', 0.0232, 'lps'),
	(386392, 125, '2015-02-01 00:05:39.000000', 'consum', 0.0231, 'lps'),
	(386393, 125, '2015-02-01 00:05:40.000000', 'consum', 0.0222, 'lps'),
	(386394, 125, '2015-02-01 00:05:41.000000', 'consum', 0.0236, 'lps'),
	(386395, 125, '2015-02-01 00:05:42.000000', 'consum', 0.0224, 'lps'),
	(386396, 125, '2015-02-01 00:05:43.000000', 'consum', 0.0228, 'lps'),
	(386397, 125, '2015-02-01 00:05:44.000000', 'consum', 0.0232, 'lps'),
	(386398, 125, '2015-02-01 00:05:45.000000', 'consum', 0.0213, 'lps'),
	(386399, 125, '2015-02-01 00:05:46.000000', 'consum', 0.0214, 'lps'),
	(386400, 125, '2015-02-01 00:05:47.000000', 'consum', 0.0223, 'lps'),
	(386401, 125, '2015-02-01 00:05:48.000000', 'consum', 0.0233, 'lps'),
	(386402, 125, '2015-02-01 00:05:49.000000', 'consum', 0.0235, 'lps'),
	(386403, 125, '2015-02-01 00:05:50.000000', 'consum', 0.0211, 'lps'),
	(386404, 125, '2015-02-01 00:05:51.000000', 'consum', 0.0222, 'lps'),
	(386405, 125, '2015-02-01 00:05:52.000000', 'consum', 0.0212, 'lps'),
	(386406, 125, '2015-02-01 00:05:53.000000', 'consum', 0.0214, 'lps'),
	(386407, 125, '2015-02-01 00:05:54.000000', 'consum', 0.0223, 'lps'),
	(386408, 125, '2015-02-01 00:05:55.000000', 'consum', 0.0236, 'lps'),
	(386409, 125, '2015-02-01 00:05:56.000000', 'consum', 0.0222, 'lps'),
	(386410, 125, '2015-02-01 00:05:57.000000', 'consum', 0.0219, 'lps'),
	(386411, 125, '2015-02-01 00:05:58.000000', 'consum', 0.0220, 'lps'),
	(386412, 125, '2015-02-01 00:05:59.000000', 'consum', 0.0235, 'lps'),
	(386413, 125, '2015-02-01 00:06:00.000000', 'consum', 0.0223, 'lps'),
	(386414, 125, '2015-02-01 00:06:01.000000', 'consum', 0.0226, 'lps'),
	(386415, 125, '2015-02-01 00:06:02.000000', 'consum', 0.0227, 'lps'),
	(386416, 125, '2015-02-01 00:06:03.000000', 'consum', 0.0220, 'lps'),
	(386417, 125, '2015-02-01 00:06:04.000000', 'consum', 0.0211, 'lps'),
	(386418, 125, '2015-02-01 00:06:05.000000', 'consum', 0.0211, 'lps'),
	(386419, 125, '2015-02-01 00:06:06.000000', 'consum', 0.0211, 'lps'),
	(386420, 125, '2015-02-01 00:06:07.000000', 'consum', 0.0214, 'lps'),
	(386421, 125, '2015-02-01 00:06:08.000000', 'consum', 0.0227, 'lps'),
	(386422, 125, '2015-02-01 00:06:09.000000', 'consum', 0.0229, 'lps'),
	(386423, 125, '2015-02-01 00:06:10.000000', 'consum', 0.0229, 'lps'),
	(386424, 125, '2015-02-01 00:06:11.000000', 'consum', 0.0220, 'lps'),
	(386425, 125, '2015-02-01 00:06:12.000000', 'consum', 0.0233, 'lps'),
	(386426, 125, '2015-02-01 00:06:13.000000', 'consum', 0.0214, 'lps'),
	(386427, 125, '2015-02-01 00:06:14.000000', 'consum', 0.0215, 'lps'),
	(386428, 125, '2015-02-01 00:06:15.000000', 'consum', 0.0222, 'lps'),
	(386429, 125, '2015-02-01 00:06:16.000000', 'consum', 0.0231, 'lps'),
	(386430, 125, '2015-02-01 00:06:17.000000', 'consum', 0.0223, 'lps'),
	(386431, 125, '2015-02-01 00:06:18.000000', 'consum', 0.0212, 'lps'),
	(386432, 125, '2015-02-01 00:06:19.000000', 'consum', 0.0235, 'lps'),
	(386433, 125, '2015-02-01 00:06:20.000000', 'consum', 0.0221, 'lps'),
	(386434, 125, '2015-02-01 00:06:21.000000', 'consum', 0.0217, 'lps'),
	(386435, 125, '2015-02-01 00:06:22.000000', 'consum', 0.0212, 'lps'),
	(386436, 125, '2015-02-01 00:06:23.000000', 'consum', 0.0228, 'lps'),
	(386437, 125, '2015-02-01 00:06:24.000000', 'consum', 0.0212, 'lps'),
	(386438, 125, '2015-02-01 00:06:25.000000', 'consum', 0.0221, 'lps'),
	(386439, 125, '2015-02-01 00:06:26.000000', 'consum', 0.0232, 'lps'),
	(386440, 125, '2015-02-01 00:06:27.000000', 'consum', 0.0234, 'lps'),
	(386441, 125, '2015-02-01 00:06:28.000000', 'consum', 0.0211, 'lps'),
	(386442, 125, '2015-02-01 00:06:29.000000', 'consum', 0.0223, 'lps'),
	(386443, 125, '2015-02-01 00:06:30.000000', 'consum', 0.0218, 'lps'),
	(386444, 125, '2015-02-01 00:06:31.000000', 'consum', 0.0210, 'lps'),
	(386445, 125, '2015-02-01 00:06:32.000000', 'consum', 0.0217, 'lps'),
	(386446, 125, '2015-02-01 00:06:33.000000', 'consum', 0.0218, 'lps'),
	(386447, 125, '2015-02-01 00:06:34.000000', 'consum', 0.0227, 'lps'),
	(386448, 125, '2015-02-01 00:06:35.000000', 'consum', 0.0220, 'lps'),
	(386449, 125, '2015-02-01 00:06:36.000000', 'consum', 0.0234, 'lps'),
	(386450, 125, '2015-02-01 00:06:37.000000', 'consum', 0.0223, 'lps'),
	(386451, 125, '2015-02-01 00:06:38.000000', 'consum', 0.0227, 'lps'),
	(386452, 125, '2015-02-01 00:06:39.000000', 'consum', 0.0232, 'lps'),
	(386453, 125, '2015-02-01 00:06:40.000000', 'consum', 0.0214, 'lps'),
	(386454, 125, '2015-02-01 00:06:41.000000', 'consum', 0.0218, 'lps'),
	(386455, 125, '2015-02-01 00:06:42.000000', 'consum', 0.0211, 'lps'),
	(386456, 125, '2015-02-01 00:06:43.000000', 'consum', 0.0219, 'lps'),
	(386457, 125, '2015-02-01 00:06:44.000000', 'consum', 0.0224, 'lps'),
	(386458, 125, '2015-02-01 00:06:45.000000', 'consum', 0.0227, 'lps'),
	(386459, 125, '2015-02-01 00:06:46.000000', 'consum', 0.0229, 'lps'),
	(386460, 125, '2015-02-01 00:06:47.000000', 'consum', 0.0226, 'lps'),
	(386461, 125, '2015-02-01 00:06:48.000000', 'consum', 0.0233, 'lps'),
	(386462, 125, '2015-02-01 00:06:49.000000', 'consum', 0.0226, 'lps'),
	(386463, 125, '2015-02-01 00:06:50.000000', 'consum', 0.0218, 'lps'),
	(386464, 125, '2015-02-01 00:06:51.000000', 'consum', 0.0232, 'lps'),
	(386465, 125, '2015-02-01 00:06:52.000000', 'consum', 0.0214, 'lps'),
	(386466, 125, '2015-02-01 00:06:53.000000', 'consum', 0.0220, 'lps'),
	(386467, 125, '2015-02-01 00:06:54.000000', 'consum', 0.0223, 'lps'),
	(386468, 125, '2015-02-01 00:06:55.000000', 'consum', 0.0215, 'lps'),
	(386469, 125, '2015-02-01 00:06:56.000000', 'consum', 0.0227, 'lps'),
	(386470, 125, '2015-02-01 00:06:57.000000', 'consum', 0.0223, 'lps'),
	(386471, 125, '2015-02-01 00:06:58.000000', 'consum', 0.0228, 'lps'),
	(386472, 125, '2015-02-01 00:06:59.000000', 'consum', 0.0231, 'lps'),
	(386473, 125, '2015-02-01 00:07:00.000000', 'consum', 0.0210, 'lps'),
	(386474, 125, '2015-02-01 00:07:01.000000', 'consum', 0.0228, 'lps'),
	(386475, 125, '2015-02-01 00:07:02.000000', 'consum', 0.0218, 'lps'),
	(386476, 125, '2015-02-01 00:07:03.000000', 'consum', 0.0222, 'lps'),
	(386477, 125, '2015-02-01 00:07:04.000000', 'consum', 0.0223, 'lps'),
	(386478, 125, '2015-02-01 00:07:05.000000', 'consum', 0.0211, 'lps'),
	(386479, 125, '2015-02-01 00:07:06.000000', 'consum', 0.0233, 'lps'),
	(386480, 125, '2015-02-01 00:07:07.000000', 'consum', 0.0211, 'lps'),
	(386481, 125, '2015-02-01 00:07:08.000000', 'consum', 0.0229, 'lps'),
	(386482, 125, '2015-02-01 00:07:09.000000', 'consum', 0.0221, 'lps'),
	(386483, 125, '2015-02-01 00:07:10.000000', 'consum', 0.0210, 'lps'),
	(386484, 125, '2015-02-01 00:07:11.000000', 'consum', 0.0230, 'lps'),
	(386485, 125, '2015-02-01 00:07:12.000000', 'consum', 0.0231, 'lps'),
	(386486, 125, '2015-02-01 00:07:13.000000', 'consum', 0.0228, 'lps'),
	(386487, 125, '2015-02-01 00:07:14.000000', 'consum', 0.0235, 'lps'),
	(386488, 125, '2015-02-01 00:07:15.000000', 'consum', 0.0230, 'lps'),
	(386489, 125, '2015-02-01 00:07:16.000000', 'consum', 0.0236, 'lps'),
	(386490, 125, '2015-02-01 00:07:17.000000', 'consum', 0.0227, 'lps'),
	(386491, 125, '2015-02-01 00:07:18.000000', 'consum', 0.0218, 'lps'),
	(386492, 125, '2015-02-01 00:07:19.000000', 'consum', 0.0227, 'lps'),
	(386493, 125, '2015-02-01 00:07:20.000000', 'consum', 0.0218, 'lps'),
	(386494, 125, '2015-02-01 00:07:21.000000', 'consum', 0.0226, 'lps'),
	(386495, 125, '2015-02-01 00:07:22.000000', 'consum', 0.0211, 'lps'),
	(386496, 125, '2015-02-01 00:07:23.000000', 'consum', 0.0224, 'lps'),
	(386497, 125, '2015-02-01 00:07:24.000000', 'consum', 0.0221, 'lps'),
	(386498, 125, '2015-02-01 00:07:25.000000', 'consum', 0.0225, 'lps'),
	(386499, 125, '2015-02-01 00:07:26.000000', 'consum', 0.0227, 'lps'),
	(386500, 125, '2015-02-01 00:07:27.000000', 'consum', 0.0222, 'lps'),
	(386501, 125, '2015-02-01 00:07:28.000000', 'consum', 0.0221, 'lps'),
	(386502, 125, '2015-02-01 00:07:29.000000', 'consum', 0.0227, 'lps'),
	(386503, 125, '2015-02-01 00:07:30.000000', 'consum', 0.0236, 'lps'),
	(386504, 125, '2015-02-01 00:07:31.000000', 'consum', 0.0236, 'lps'),
	(386505, 125, '2015-02-01 00:07:32.000000', 'consum', 0.0235, 'lps'),
	(386506, 125, '2015-02-01 00:07:33.000000', 'consum', 0.0233, 'lps'),
	(386507, 125, '2015-02-01 00:07:34.000000', 'consum', 0.0221, 'lps'),
	(386508, 125, '2015-02-01 00:07:35.000000', 'consum', 0.0223, 'lps'),
	(386509, 125, '2015-02-01 00:07:36.000000', 'consum', 0.0215, 'lps'),
	(386510, 125, '2015-02-01 00:07:37.000000', 'consum', 0.0226, 'lps'),
	(386511, 125, '2015-02-01 00:07:38.000000', 'consum', 0.0219, 'lps'),
	(386512, 125, '2015-02-01 00:07:39.000000', 'consum', 0.0236, 'lps'),
	(386513, 125, '2015-02-01 00:07:40.000000', 'consum', 0.0232, 'lps'),
	(386514, 125, '2015-02-01 00:07:41.000000', 'consum', 0.0216, 'lps'),
	(386515, 125, '2015-02-01 00:07:42.000000', 'consum', 0.0229, 'lps'),
	(386516, 125, '2015-02-01 00:07:43.000000', 'consum', 0.0232, 'lps'),
	(386517, 125, '2015-02-01 00:07:44.000000', 'consum', 0.0210, 'lps'),
	(386518, 125, '2015-02-01 00:07:45.000000', 'consum', 0.0225, 'lps'),
	(386519, 125, '2015-02-01 00:07:46.000000', 'consum', 0.0234, 'lps'),
	(386520, 125, '2015-02-01 00:07:47.000000', 'consum', 0.0230, 'lps'),
	(386521, 125, '2015-02-01 00:07:48.000000', 'consum', 0.0210, 'lps'),
	(386522, 125, '2015-02-01 00:07:49.000000', 'consum', 0.0233, 'lps'),
	(386523, 125, '2015-02-01 00:07:50.000000', 'consum', 0.0217, 'lps'),
	(386524, 125, '2015-02-01 00:07:51.000000', 'consum', 0.0229, 'lps'),
	(386525, 125, '2015-02-01 00:07:52.000000', 'consum', 0.0232, 'lps'),
	(386526, 125, '2015-02-01 00:07:53.000000', 'consum', 0.0234, 'lps'),
	(386527, 125, '2015-02-01 00:07:54.000000', 'consum', 0.0214, 'lps'),
	(386528, 125, '2015-02-01 00:07:55.000000', 'consum', 0.0212, 'lps'),
	(386529, 125, '2015-02-01 00:07:56.000000', 'consum', 0.0235, 'lps'),
	(386530, 125, '2015-02-01 00:07:57.000000', 'consum', 0.0221, 'lps'),
	(386531, 125, '2015-02-01 00:07:58.000000', 'consum', 0.0217, 'lps'),
	(386532, 125, '2015-02-01 00:07:59.000000', 'consum', 0.0212, 'lps'),
	(386533, 125, '2015-02-01 00:08:00.000000', 'consum', 0.0229, 'lps'),
	(386534, 125, '2015-02-01 00:08:01.000000', 'consum', 0.0219, 'lps'),
	(386535, 125, '2015-02-01 00:08:02.000000', 'consum', 0.0223, 'lps'),
	(386536, 125, '2015-02-01 00:08:03.000000', 'consum', 0.0223, 'lps'),
	(386537, 125, '2015-02-01 00:08:04.000000', 'consum', 0.0236, 'lps'),
	(386538, 125, '2015-02-01 00:08:05.000000', 'consum', 0.0219, 'lps'),
	(386539, 125, '2015-02-01 00:08:06.000000', 'consum', 0.0231, 'lps'),
	(386540, 125, '2015-02-01 00:08:07.000000', 'consum', 0.0210, 'lps'),
	(386541, 125, '2015-02-01 00:08:08.000000', 'consum', 0.0227, 'lps'),
	(386542, 125, '2015-02-01 00:08:09.000000', 'consum', 0.0216, 'lps'),
	(386543, 125, '2015-02-01 00:08:10.000000', 'consum', 0.0214, 'lps'),
	(386544, 125, '2015-02-01 00:08:11.000000', 'consum', 0.0215, 'lps'),
	(386545, 125, '2015-02-01 00:08:12.000000', 'consum', 0.0224, 'lps'),
	(386546, 125, '2015-02-01 00:08:13.000000', 'consum', 0.0211, 'lps'),
	(386547, 125, '2015-02-01 00:08:14.000000', 'consum', 0.0228, 'lps'),
	(386548, 125, '2015-02-01 00:08:15.000000', 'consum', 0.0218, 'lps'),
	(386549, 125, '2015-02-01 00:08:16.000000', 'consum', 0.0220, 'lps'),
	(386550, 125, '2015-02-01 00:08:17.000000', 'consum', 0.0211, 'lps'),
	(386551, 125, '2015-02-01 00:08:18.000000', 'consum', 0.0213, 'lps'),
	(386552, 125, '2015-02-01 00:08:19.000000', 'consum', 0.0221, 'lps'),
	(386553, 125, '2015-02-01 00:08:20.000000', 'consum', 0.0230, 'lps'),
	(386554, 125, '2015-02-01 00:08:21.000000', 'consum', 0.0224, 'lps'),
	(386555, 125, '2015-02-01 00:08:22.000000', 'consum', 0.0221, 'lps'),
	(386556, 125, '2015-02-01 00:08:23.000000', 'consum', 0.0223, 'lps'),
	(386557, 125, '2015-02-01 00:08:24.000000', 'consum', 0.0214, 'lps'),
	(386558, 125, '2015-02-01 00:08:25.000000', 'consum', 0.0221, 'lps'),
	(386559, 125, '2015-02-01 00:08:26.000000', 'consum', 0.0225, 'lps'),
	(386560, 125, '2015-02-01 00:08:27.000000', 'consum', 0.0226, 'lps'),
	(386561, 125, '2015-02-01 00:08:28.000000', 'consum', 0.0220, 'lps'),
	(386562, 125, '2015-02-01 00:08:29.000000', 'consum', 0.0211, 'lps'),
	(386563, 125, '2015-02-01 00:08:30.000000', 'consum', 0.0211, 'lps'),
	(386564, 125, '2015-02-01 00:08:31.000000', 'consum', 0.0214, 'lps'),
	(386565, 125, '2015-02-01 00:08:32.000000', 'consum', 0.0225, 'lps'),
	(386566, 125, '2015-02-01 00:08:33.000000', 'consum', 0.0223, 'lps'),
	(386567, 125, '2015-02-01 00:08:34.000000', 'consum', 0.0227, 'lps'),
	(386568, 125, '2015-02-01 00:08:35.000000', 'consum', 0.0231, 'lps'),
	(386569, 125, '2015-02-01 00:08:36.000000', 'consum', 0.0212, 'lps'),
	(386570, 125, '2015-02-01 00:08:37.000000', 'consum', 0.0235, 'lps'),
	(386571, 125, '2015-02-01 00:08:38.000000', 'consum', 0.0225, 'lps'),
	(386572, 125, '2015-02-01 00:08:39.000000', 'consum', 0.0210, 'lps'),
	(386573, 125, '2015-02-01 00:08:40.000000', 'consum', 0.0220, 'lps'),
	(386574, 125, '2015-02-01 00:08:41.000000', 'consum', 0.0231, 'lps'),
	(386575, 125, '2015-02-01 00:08:42.000000', 'consum', 0.0235, 'lps'),
	(386576, 125, '2015-02-01 00:08:43.000000', 'consum', 0.0216, 'lps'),
	(386577, 125, '2015-02-01 00:08:44.000000', 'consum', 0.0222, 'lps'),
	(386578, 125, '2015-02-01 00:08:45.000000', 'consum', 0.0224, 'lps'),
	(386579, 125, '2015-02-01 00:08:46.000000', 'consum', 0.0219, 'lps'),
	(386580, 125, '2015-02-01 00:08:47.000000', 'consum', 0.0211, 'lps'),
	(386581, 125, '2015-02-01 00:08:48.000000', 'consum', 0.0215, 'lps'),
	(386582, 125, '2015-02-01 00:08:49.000000', 'consum', 0.0233, 'lps'),
	(386583, 125, '2015-02-01 00:08:50.000000', 'consum', 0.0232, 'lps'),
	(386584, 125, '2015-02-01 00:08:51.000000', 'consum', 0.0221, 'lps'),
	(386585, 125, '2015-02-01 00:08:52.000000', 'consum', 0.0229, 'lps'),
	(386586, 125, '2015-02-01 00:08:53.000000', 'consum', 0.0216, 'lps'),
	(386587, 125, '2015-02-01 00:08:54.000000', 'consum', 0.0213, 'lps'),
	(386588, 125, '2015-02-01 00:08:55.000000', 'consum', 0.0234, 'lps'),
	(386589, 125, '2015-02-01 00:08:56.000000', 'consum', 0.0212, 'lps'),
	(386590, 125, '2015-02-01 00:08:57.000000', 'consum', 0.0232, 'lps'),
	(386591, 125, '2015-02-01 00:08:58.000000', 'consum', 0.0234, 'lps'),
	(386592, 125, '2015-02-01 00:08:59.000000', 'consum', 0.0236, 'lps'),
	(386593, 125, '2015-02-01 00:09:00.000000', 'consum', 0.0216, 'lps'),
	(386594, 125, '2015-02-01 00:09:01.000000', 'consum', 0.0214, 'lps'),
	(386595, 125, '2015-02-01 00:09:02.000000', 'consum', 0.0215, 'lps'),
	(386596, 125, '2015-02-01 00:09:03.000000', 'consum', 0.0221, 'lps'),
	(386597, 125, '2015-02-01 00:09:04.000000', 'consum', 0.0223, 'lps'),
	(386598, 125, '2015-02-01 00:09:05.000000', 'consum', 0.0216, 'lps'),
	(386599, 125, '2015-02-01 00:09:06.000000', 'consum', 0.0229, 'lps'),
	(386600, 125, '2015-02-01 00:09:07.000000', 'consum', 0.0234, 'lps'),
	(386601, 125, '2015-02-01 00:09:08.000000', 'consum', 0.0217, 'lps'),
	(386602, 125, '2015-02-01 00:09:09.000000', 'consum', 0.0230, 'lps'),
	(386603, 125, '2015-02-01 00:09:10.000000', 'consum', 0.0210, 'lps'),
	(386604, 125, '2015-02-01 00:09:11.000000', 'consum', 0.0228, 'lps'),
	(386605, 125, '2015-02-01 00:09:12.000000', 'consum', 0.0220, 'lps'),
	(386606, 125, '2015-02-01 00:09:13.000000', 'consum', 0.0236, 'lps'),
	(386607, 125, '2015-02-01 00:09:14.000000', 'consum', 0.0228, 'lps'),
	(386608, 125, '2015-02-01 00:09:15.000000', 'consum', 0.0224, 'lps'),
	(386609, 125, '2015-02-01 00:09:16.000000', 'consum', 0.0224, 'lps'),
	(386610, 125, '2015-02-01 00:09:17.000000', 'consum', 0.0211, 'lps'),
	(386611, 125, '2015-02-01 00:09:18.000000', 'consum', 0.0228, 'lps'),
	(386612, 125, '2015-02-01 00:09:19.000000', 'consum', 0.0219, 'lps'),
	(386613, 125, '2015-02-01 00:09:20.000000', 'consum', 0.0227, 'lps'),
	(386614, 125, '2015-02-01 00:09:21.000000', 'consum', 0.0214, 'lps'),
	(386615, 125, '2015-02-01 00:09:22.000000', 'consum', 0.0232, 'lps'),
	(386616, 125, '2015-02-01 00:09:23.000000', 'consum', 0.0229, 'lps'),
	(386617, 125, '2015-02-01 00:09:24.000000', 'consum', 0.0214, 'lps'),
	(386618, 125, '2015-02-01 00:09:25.000000', 'consum', 0.0227, 'lps'),
	(386619, 125, '2015-02-01 00:09:26.000000', 'consum', 0.0230, 'lps'),
	(386620, 125, '2015-02-01 00:09:27.000000', 'consum', 0.0232, 'lps'),
	(386621, 125, '2015-02-01 00:09:28.000000', 'consum', 0.0231, 'lps'),
	(386622, 125, '2015-02-01 00:09:29.000000', 'consum', 0.0226, 'lps'),
	(386623, 125, '2015-02-01 00:09:30.000000', 'consum', 0.0225, 'lps'),
	(386624, 125, '2015-02-01 00:09:31.000000', 'consum', 0.0211, 'lps'),
	(386625, 125, '2015-02-01 00:09:32.000000', 'consum', 0.0224, 'lps'),
	(386626, 125, '2015-02-01 00:09:33.000000', 'consum', 0.0225, 'lps'),
	(386627, 125, '2015-02-01 00:09:34.000000', 'consum', 0.0215, 'lps'),
	(386628, 125, '2015-02-01 00:09:35.000000', 'consum', 0.0220, 'lps'),
	(386629, 125, '2015-02-01 00:09:36.000000', 'consum', 0.0218, 'lps'),
	(386630, 125, '2015-02-01 00:09:37.000000', 'consum', 0.0220, 'lps'),
	(386631, 125, '2015-02-01 00:09:38.000000', 'consum', 0.0236, 'lps'),
	(386632, 125, '2015-02-01 00:09:39.000000', 'consum', 0.0229, 'lps'),
	(386633, 125, '2015-02-01 00:09:40.000000', 'consum', 0.0229, 'lps'),
	(386634, 125, '2015-02-01 00:09:41.000000', 'consum', 0.0223, 'lps'),
	(386635, 125, '2015-02-01 00:09:42.000000', 'consum', 0.0216, 'lps'),
	(386636, 125, '2015-02-01 00:09:43.000000', 'consum', 0.0231, 'lps'),
	(386637, 125, '2015-02-01 00:09:44.000000', 'consum', 0.0216, 'lps'),
	(386638, 125, '2015-02-01 00:09:45.000000', 'consum', 0.0230, 'lps'),
	(386639, 125, '2015-02-01 00:09:46.000000', 'consum', 0.0210, 'lps'),
	(386640, 125, '2015-02-01 00:09:47.000000', 'consum', 0.0235, 'lps'),
	(386641, 125, '2015-02-01 00:09:48.000000', 'consum', 0.0225, 'lps'),
	(386642, 125, '2015-02-01 00:09:49.000000', 'consum', 0.0212, 'lps'),
	(386643, 125, '2015-02-01 00:09:50.000000', 'consum', 0.0228, 'lps'),
	(386644, 125, '2015-02-01 00:09:51.000000', 'consum', 0.0213, 'lps'),
	(386645, 125, '2015-02-01 00:09:52.000000', 'consum', 0.0227, 'lps'),
	(386646, 125, '2015-02-01 00:09:53.000000', 'consum', 0.0233, 'lps'),
	(386647, 125, '2015-02-01 00:09:54.000000', 'consum', 0.0222, 'lps'),
	(386648, 125, '2015-02-01 00:09:55.000000', 'consum', 0.0225, 'lps'),
	(386649, 125, '2015-02-01 00:09:56.000000', 'consum', 0.0224, 'lps'),
	(386650, 125, '2015-02-01 00:09:57.000000', 'consum', 0.0210, 'lps'),
	(386651, 125, '2015-02-01 00:09:58.000000', 'consum', 0.0223, 'lps'),
	(386652, 125, '2015-02-01 00:09:59.000000', 'consum', 0.0219, 'lps'),
	(386653, 125, '2015-02-01 00:10:00.000000', 'consum', 0.0219, 'lps'),
	(386654, 125, '2015-02-01 00:10:01.000000', 'consum', 0.0226, 'lps'),
	(386655, 125, '2015-02-01 00:10:02.000000', 'consum', 0.0210, 'lps'),
	(386656, 125, '2015-02-01 00:10:03.000000', 'consum', 0.0215, 'lps'),
	(386657, 125, '2015-02-01 00:10:04.000000', 'consum', 0.0212, 'lps'),
	(386658, 125, '2015-02-01 00:10:05.000000', 'consum', 0.0229, 'lps'),
	(386659, 125, '2015-02-01 00:10:06.000000', 'consum', 0.0219, 'lps'),
	(386660, 125, '2015-02-01 00:10:07.000000', 'consum', 0.0227, 'lps'),
	(386661, 125, '2015-02-01 00:10:08.000000', 'consum', 0.0215, 'lps'),
	(386662, 125, '2015-02-01 00:10:09.000000', 'consum', 0.0236, 'lps'),
	(386663, 125, '2015-02-01 00:10:10.000000', 'consum', 0.0217, 'lps'),
	(386664, 125, '2015-02-01 00:10:11.000000', 'consum', 0.0224, 'lps'),
	(386665, 125, '2015-02-01 00:10:12.000000', 'consum', 0.0229, 'lps'),
	(386666, 125, '2015-02-01 00:10:13.000000', 'consum', 0.0213, 'lps'),
	(386667, 125, '2015-02-01 00:10:14.000000', 'consum', 0.0223, 'lps'),
	(386668, 125, '2015-02-01 00:10:15.000000', 'consum', 0.0212, 'lps'),
	(386669, 125, '2015-02-01 00:10:16.000000', 'consum', 0.0235, 'lps'),
	(386670, 125, '2015-02-01 00:10:17.000000', 'consum', 0.0220, 'lps'),
	(386671, 125, '2015-02-01 00:10:18.000000', 'consum', 0.0212, 'lps'),
	(386672, 125, '2015-02-01 00:10:19.000000', 'consum', 0.0219, 'lps'),
	(386673, 125, '2015-02-01 00:10:20.000000', 'consum', 0.0223, 'lps'),
	(386674, 125, '2015-02-01 00:10:21.000000', 'consum', 0.0221, 'lps'),
	(386675, 125, '2015-02-01 00:10:22.000000', 'consum', 0.0226, 'lps'),
	(386676, 125, '2015-02-01 00:10:23.000000', 'consum', 0.0231, 'lps'),
	(386677, 125, '2015-02-01 00:10:24.000000', 'consum', 0.0212, 'lps'),
	(386678, 125, '2015-02-01 00:10:25.000000', 'consum', 0.0211, 'lps'),
	(386679, 125, '2015-02-01 00:10:26.000000', 'consum', 0.0212, 'lps'),
	(386680, 125, '2015-02-01 00:10:27.000000', 'consum', 0.0217, 'lps'),
	(386681, 125, '2015-02-01 00:10:28.000000', 'consum', 0.0210, 'lps'),
	(386682, 125, '2015-02-01 00:10:29.000000', 'consum', 0.0219, 'lps'),
	(386683, 125, '2015-02-01 00:10:30.000000', 'consum', 0.0229, 'lps'),
	(386684, 125, '2015-02-01 00:10:31.000000', 'consum', 0.0225, 'lps'),
	(386685, 125, '2015-02-01 00:10:32.000000', 'consum', 0.0229, 'lps'),
	(386686, 125, '2015-02-01 00:10:33.000000', 'consum', 0.0231, 'lps'),
	(386687, 125, '2015-02-01 00:10:34.000000', 'consum', 0.0233, 'lps'),
	(386688, 125, '2015-02-01 00:10:35.000000', 'consum', 0.0210, 'lps'),
	(386689, 125, '2015-02-01 00:10:36.000000', 'consum', 0.0220, 'lps'),
	(386690, 125, '2015-02-01 00:10:37.000000', 'consum', 0.0235, 'lps'),
	(386691, 125, '2015-02-01 00:10:38.000000', 'consum', 0.0224, 'lps'),
	(386692, 125, '2015-02-01 00:10:39.000000', 'consum', 0.0231, 'lps'),
	(386693, 125, '2015-02-01 00:10:40.000000', 'consum', 0.0222, 'lps'),
	(386694, 125, '2015-02-01 00:10:41.000000', 'consum', 0.0234, 'lps'),
	(386695, 125, '2015-02-01 00:10:42.000000', 'consum', 0.0213, 'lps'),
	(386696, 125, '2015-02-01 00:10:43.000000', 'consum', 0.0233, 'lps'),
	(386697, 125, '2015-02-01 00:10:44.000000', 'consum', 0.0236, 'lps'),
	(386698, 125, '2015-02-01 00:10:45.000000', 'consum', 0.0217, 'lps'),
	(386699, 125, '2015-02-01 00:10:46.000000', 'consum', 0.0222, 'lps'),
	(386700, 125, '2015-02-01 00:10:47.000000', 'consum', 0.0222, 'lps'),
	(386701, 125, '2015-02-01 00:10:48.000000', 'consum', 0.0235, 'lps'),
	(386702, 125, '2015-02-01 00:10:49.000000', 'consum', 0.0220, 'lps'),
	(386703, 125, '2015-02-01 00:10:50.000000', 'consum', 0.0212, 'lps'),
	(386704, 125, '2015-02-01 00:10:51.000000', 'consum', 0.0217, 'lps'),
	(386705, 125, '2015-02-01 00:10:52.000000', 'consum', 0.0212, 'lps'),
	(386706, 125, '2015-02-01 00:10:53.000000', 'consum', 0.0226, 'lps'),
	(386707, 125, '2015-02-01 00:10:54.000000', 'consum', 0.0230, 'lps'),
	(386708, 125, '2015-02-01 00:10:55.000000', 'consum', 0.0234, 'lps'),
	(386709, 125, '2015-02-01 00:10:56.000000', 'consum', 0.0220, 'lps'),
	(386710, 125, '2015-02-01 00:10:57.000000', 'consum', 0.0213, 'lps'),
	(386711, 125, '2015-02-01 00:10:58.000000', 'consum', 0.0225, 'lps'),
	(386712, 125, '2015-02-01 00:10:59.000000', 'consum', 0.0220, 'lps'),
	(386713, 125, '2015-02-01 00:11:00.000000', 'consum', 0.0215, 'lps'),
	(386714, 125, '2015-02-01 00:11:01.000000', 'consum', 0.0234, 'lps'),
	(386715, 125, '2015-02-01 00:11:02.000000', 'consum', 0.0235, 'lps'),
	(386716, 125, '2015-02-01 00:11:03.000000', 'consum', 0.0234, 'lps'),
	(386717, 125, '2015-02-01 00:11:04.000000', 'consum', 0.0231, 'lps'),
	(386718, 125, '2015-02-01 00:11:05.000000', 'consum', 0.0217, 'lps'),
	(386719, 125, '2015-02-01 00:11:06.000000', 'consum', 0.0235, 'lps'),
	(386720, 125, '2015-02-01 00:11:07.000000', 'consum', 0.0232, 'lps'),
	(386721, 125, '2015-02-01 00:11:08.000000', 'consum', 0.0221, 'lps'),
	(386722, 125, '2015-02-01 00:11:09.000000', 'consum', 0.0227, 'lps'),
	(386723, 125, '2015-02-01 00:11:10.000000', 'consum', 0.0236, 'lps'),
	(386724, 125, '2015-02-01 00:11:11.000000', 'consum', 0.0232, 'lps'),
	(386725, 125, '2015-02-01 00:11:12.000000', 'consum', 0.0219, 'lps'),
	(386726, 125, '2015-02-01 00:11:13.000000', 'consum', 0.0215, 'lps'),
	(386727, 125, '2015-02-01 00:11:14.000000', 'consum', 0.0235, 'lps'),
	(386728, 125, '2015-02-01 00:11:15.000000', 'consum', 0.0215, 'lps'),
	(386729, 125, '2015-02-01 00:11:16.000000', 'consum', 0.0213, 'lps'),
	(386730, 125, '2015-02-01 00:11:17.000000', 'consum', 0.0212, 'lps'),
	(386731, 125, '2015-02-01 00:11:18.000000', 'consum', 0.0210, 'lps'),
	(386732, 125, '2015-02-01 00:11:19.000000', 'consum', 0.0231, 'lps'),
	(386733, 125, '2015-02-01 00:11:20.000000', 'consum', 0.0234, 'lps'),
	(386734, 125, '2015-02-01 00:11:21.000000', 'consum', 0.0214, 'lps'),
	(386735, 125, '2015-02-01 00:11:22.000000', 'consum', 0.0212, 'lps'),
	(386736, 125, '2015-02-01 00:11:23.000000', 'consum', 0.0211, 'lps'),
	(386737, 125, '2015-02-01 00:11:24.000000', 'consum', 0.0233, 'lps'),
	(386738, 125, '2015-02-01 00:11:25.000000', 'consum', 0.0218, 'lps'),
	(386739, 125, '2015-02-01 00:11:26.000000', 'consum', 0.0232, 'lps'),
	(386740, 125, '2015-02-01 00:11:27.000000', 'consum', 0.0219, 'lps'),
	(386741, 125, '2015-02-01 00:11:28.000000', 'consum', 0.0215, 'lps'),
	(386742, 125, '2015-02-01 00:11:29.000000', 'consum', 0.0236, 'lps'),
	(386743, 125, '2015-02-01 00:11:30.000000', 'consum', 0.0217, 'lps'),
	(386744, 125, '2015-02-01 00:11:31.000000', 'consum', 0.0221, 'lps'),
	(386745, 125, '2015-02-01 00:11:32.000000', 'consum', 0.0217, 'lps'),
	(386746, 125, '2015-02-01 00:11:33.000000', 'consum', 0.0214, 'lps'),
	(386747, 125, '2015-02-01 00:11:34.000000', 'consum', 0.0234, 'lps'),
	(386748, 125, '2015-02-01 00:11:35.000000', 'consum', 0.0211, 'lps'),
	(386749, 125, '2015-02-01 00:11:36.000000', 'consum', 0.0225, 'lps'),
	(386750, 125, '2015-02-01 00:11:37.000000', 'consum', 0.0228, 'lps'),
	(386751, 125, '2015-02-01 00:11:38.000000', 'consum', 0.0231, 'lps'),
	(386752, 125, '2015-02-01 00:11:39.000000', 'consum', 0.0232, 'lps'),
	(386753, 125, '2015-02-01 00:11:40.000000', 'consum', 0.0231, 'lps'),
	(386754, 125, '2015-02-01 00:11:41.000000', 'consum', 0.0222, 'lps'),
	(386755, 125, '2015-02-01 00:11:42.000000', 'consum', 0.0234, 'lps'),
	(386756, 125, '2015-02-01 00:11:43.000000', 'consum', 0.0216, 'lps'),
	(386757, 125, '2015-02-01 00:11:44.000000', 'consum', 0.0221, 'lps'),
	(386758, 125, '2015-02-01 00:11:45.000000', 'consum', 0.0221, 'lps'),
	(386759, 125, '2015-02-01 00:11:46.000000', 'consum', 0.0231, 'lps'),
	(386760, 125, '2015-02-01 00:11:47.000000', 'consum', 0.0228, 'lps'),
	(386761, 125, '2015-02-01 00:11:48.000000', 'consum', 0.0236, 'lps'),
	(386762, 125, '2015-02-01 00:11:49.000000', 'consum', 0.0236, 'lps'),
	(386763, 125, '2015-02-01 00:11:50.000000', 'consum', 0.0233, 'lps'),
	(386764, 125, '2015-02-01 00:11:51.000000', 'consum', 0.0221, 'lps'),
	(386765, 125, '2015-02-01 00:11:52.000000', 'consum', 0.0224, 'lps'),
	(386766, 125, '2015-02-01 00:11:53.000000', 'consum', 0.0219, 'lps'),
	(386767, 125, '2015-02-01 00:11:54.000000', 'consum', 0.0213, 'lps'),
	(386768, 125, '2015-02-01 00:11:55.000000', 'consum', 0.0224, 'lps'),
	(386769, 125, '2015-02-01 00:11:56.000000', 'consum', 0.0221, 'lps'),
	(386770, 125, '2015-02-01 00:11:57.000000', 'consum', 0.0221, 'lps'),
	(386771, 125, '2015-02-01 00:11:58.000000', 'consum', 0.0234, 'lps'),
	(386772, 125, '2015-02-01 00:11:59.000000', 'consum', 0.0217, 'lps'),
	(386773, 125, '2015-02-01 00:12:00.000000', 'consum', 0.0226, 'lps'),
	(386774, 125, '2015-02-01 00:12:01.000000', 'consum', 0.0218, 'lps'),
	(386775, 125, '2015-02-01 00:12:02.000000', 'consum', 0.0228, 'lps'),
	(386776, 125, '2015-02-01 00:12:03.000000', 'consum', 0.0224, 'lps'),
	(386777, 125, '2015-02-01 00:12:04.000000', 'consum', 0.0227, 'lps'),
	(386778, 125, '2015-02-01 00:12:05.000000', 'consum', 0.0225, 'lps'),
	(386779, 125, '2015-02-01 00:12:06.000000', 'consum', 0.0234, 'lps'),
	(386780, 125, '2015-02-01 00:12:07.000000', 'consum', 0.0231, 'lps'),
	(386781, 125, '2015-02-01 00:12:08.000000', 'consum', 0.0217, 'lps'),
	(386782, 125, '2015-02-01 00:12:09.000000', 'consum', 0.0236, 'lps'),
	(386783, 125, '2015-02-01 00:12:10.000000', 'consum', 0.0214, 'lps'),
	(386784, 125, '2015-02-01 00:12:11.000000', 'consum', 0.0231, 'lps'),
	(386785, 125, '2015-02-01 00:12:12.000000', 'consum', 0.0225, 'lps'),
	(386786, 125, '2015-02-01 00:12:13.000000', 'consum', 0.0222, 'lps'),
	(386787, 125, '2015-02-01 00:12:14.000000', 'consum', 0.0223, 'lps'),
	(386788, 125, '2015-02-01 00:12:15.000000', 'consum', 0.0215, 'lps'),
	(386789, 125, '2015-02-01 00:12:16.000000', 'consum', 0.0224, 'lps'),
	(386790, 125, '2015-02-01 00:12:17.000000', 'consum', 0.0236, 'lps'),
	(386791, 125, '2015-02-01 00:12:18.000000', 'consum', 0.0218, 'lps'),
	(386792, 125, '2015-02-01 00:12:19.000000', 'consum', 0.0225, 'lps'),
	(386793, 125, '2015-02-01 00:12:20.000000', 'consum', 0.0210, 'lps'),
	(386794, 125, '2015-02-01 00:12:21.000000', 'consum', 0.0217, 'lps'),
	(386795, 125, '2015-02-01 00:12:22.000000', 'consum', 0.0220, 'lps'),
	(386796, 125, '2015-02-01 00:12:23.000000', 'consum', 0.0210, 'lps'),
	(386797, 125, '2015-02-01 00:12:24.000000', 'consum', 0.0210, 'lps'),
	(386798, 125, '2015-02-01 00:12:25.000000', 'consum', 0.0236, 'lps'),
	(386799, 125, '2015-02-01 00:12:26.000000', 'consum', 0.0235, 'lps'),
	(386800, 125, '2015-02-01 00:12:27.000000', 'consum', 0.0229, 'lps'),
	(386801, 125, '2015-02-01 00:12:28.000000', 'consum', 0.0230, 'lps'),
	(386802, 125, '2015-02-01 00:12:29.000000', 'consum', 0.0228, 'lps'),
	(386803, 125, '2015-02-01 00:12:30.000000', 'consum', 0.0212, 'lps'),
	(386804, 125, '2015-02-01 00:12:31.000000', 'consum', 0.0222, 'lps'),
	(386805, 125, '2015-02-01 00:12:32.000000', 'consum', 0.0210, 'lps'),
	(386806, 125, '2015-02-01 00:12:33.000000', 'consum', 0.0229, 'lps'),
	(386807, 125, '2015-02-01 00:12:34.000000', 'consum', 0.0225, 'lps'),
	(386808, 125, '2015-02-01 00:12:35.000000', 'consum', 0.0226, 'lps'),
	(386809, 125, '2015-02-01 00:12:36.000000', 'consum', 0.0221, 'lps'),
	(386810, 125, '2015-02-01 00:12:37.000000', 'consum', 0.0215, 'lps'),
	(386811, 125, '2015-02-01 00:12:38.000000', 'consum', 0.0230, 'lps'),
	(386812, 125, '2015-02-01 00:12:39.000000', 'consum', 0.0217, 'lps'),
	(386813, 125, '2015-02-01 00:12:40.000000', 'consum', 0.0236, 'lps'),
	(386814, 125, '2015-02-01 00:12:41.000000', 'consum', 0.0214, 'lps'),
	(386815, 125, '2015-02-01 00:12:42.000000', 'consum', 0.0233, 'lps'),
	(386816, 125, '2015-02-01 00:12:43.000000', 'consum', 0.0234, 'lps'),
	(386817, 125, '2015-02-01 00:12:44.000000', 'consum', 0.0233, 'lps'),
	(386818, 125, '2015-02-01 00:12:45.000000', 'consum', 0.0228, 'lps'),
	(386819, 125, '2015-02-01 00:12:46.000000', 'consum', 0.0229, 'lps'),
	(386820, 125, '2015-02-01 00:12:47.000000', 'consum', 0.0227, 'lps'),
	(386821, 125, '2015-02-01 00:12:48.000000', 'consum', 0.0236, 'lps'),
	(386822, 125, '2015-02-01 00:12:49.000000', 'consum', 0.0210, 'lps'),
	(386823, 125, '2015-02-01 00:12:50.000000', 'consum', 0.0215, 'lps'),
	(386824, 125, '2015-02-01 00:12:51.000000', 'consum', 0.0232, 'lps'),
	(386825, 125, '2015-02-01 00:12:52.000000', 'consum', 0.0227, 'lps'),
	(386826, 125, '2015-02-01 00:12:53.000000', 'consum', 0.0228, 'lps'),
	(386827, 125, '2015-02-01 00:12:54.000000', 'consum', 0.0224, 'lps'),
	(386828, 125, '2015-02-01 00:12:55.000000', 'consum', 0.0228, 'lps'),
	(386829, 125, '2015-02-01 00:12:56.000000', 'consum', 0.0229, 'lps'),
	(386830, 125, '2015-02-01 00:12:57.000000', 'consum', 0.0227, 'lps'),
	(386831, 125, '2015-02-01 00:12:58.000000', 'consum', 0.0236, 'lps'),
	(386832, 125, '2015-02-01 00:12:59.000000', 'consum', 0.0235, 'lps'),
	(386833, 125, '2015-02-01 00:13:00.000000', 'consum', 0.0233, 'lps'),
	(386834, 125, '2015-02-01 00:13:01.000000', 'consum', 0.0222, 'lps'),
	(386835, 125, '2015-02-01 00:13:02.000000', 'consum', 0.0228, 'lps'),
	(386836, 125, '2015-02-01 00:13:03.000000', 'consum', 0.0210, 'lps'),
	(386837, 125, '2015-02-01 00:13:04.000000', 'consum', 0.0211, 'lps'),
	(386838, 125, '2015-02-01 00:13:05.000000', 'consum', 0.0214, 'lps'),
	(386839, 125, '2015-02-01 00:13:06.000000', 'consum', 0.0229, 'lps'),
	(386840, 125, '2015-02-01 00:13:07.000000', 'consum', 0.0211, 'lps'),
	(386841, 125, '2015-02-01 00:13:08.000000', 'consum', 0.0215, 'lps'),
	(386842, 125, '2015-02-01 00:13:09.000000', 'consum', 0.0229, 'lps'),
	(386843, 125, '2015-02-01 00:13:10.000000', 'consum', 0.0213, 'lps'),
	(386844, 125, '2015-02-01 00:13:11.000000', 'consum', 0.0222, 'lps'),
	(386845, 125, '2015-02-01 00:13:12.000000', 'consum', 0.0235, 'lps'),
	(386846, 125, '2015-02-01 00:13:13.000000', 'consum', 0.0217, 'lps'),
	(386847, 125, '2015-02-01 00:13:14.000000', 'consum', 0.0225, 'lps'),
	(386848, 125, '2015-02-01 00:13:15.000000', 'consum', 0.0210, 'lps'),
	(386849, 125, '2015-02-01 00:13:16.000000', 'consum', 0.0220, 'lps'),
	(386850, 125, '2015-02-01 00:13:17.000000', 'consum', 0.0235, 'lps'),
	(386851, 125, '2015-02-01 00:13:18.000000', 'consum', 0.0222, 'lps'),
	(386852, 125, '2015-02-01 00:13:19.000000', 'consum', 0.0225, 'lps'),
	(386853, 125, '2015-02-01 00:13:20.000000', 'consum', 0.0223, 'lps'),
	(386854, 125, '2015-02-01 00:13:21.000000', 'consum', 0.0230, 'lps'),
	(386855, 125, '2015-02-01 00:13:22.000000', 'consum', 0.0218, 'lps'),
	(386856, 125, '2015-02-01 00:13:23.000000', 'consum', 0.0218, 'lps'),
	(386857, 125, '2015-02-01 00:13:24.000000', 'consum', 0.0224, 'lps'),
	(386858, 125, '2015-02-01 00:13:25.000000', 'consum', 0.0229, 'lps'),
	(386859, 125, '2015-02-01 00:13:26.000000', 'consum', 0.0211, 'lps'),
	(386860, 125, '2015-02-01 00:13:27.000000', 'consum', 0.0211, 'lps'),
	(386861, 125, '2015-02-01 00:13:28.000000', 'consum', 0.0213, 'lps'),
	(386862, 125, '2015-02-01 00:13:29.000000', 'consum', 0.0225, 'lps'),
	(386863, 125, '2015-02-01 00:13:30.000000', 'consum', 0.0219, 'lps'),
	(386864, 125, '2015-02-01 00:13:31.000000', 'consum', 0.0212, 'lps'),
	(386865, 125, '2015-02-01 00:13:32.000000', 'consum', 0.0220, 'lps'),
	(386866, 125, '2015-02-01 00:13:33.000000', 'consum', 0.0226, 'lps'),
	(386867, 125, '2015-02-01 00:13:34.000000', 'consum', 0.0210, 'lps'),
	(386868, 125, '2015-02-01 00:13:35.000000', 'consum', 0.0214, 'lps'),
	(386869, 125, '2015-02-01 00:13:36.000000', 'consum', 0.0229, 'lps'),
	(386870, 125, '2015-02-01 00:13:37.000000', 'consum', 0.0216, 'lps'),
	(386871, 125, '2015-02-01 00:13:38.000000', 'consum', 0.0235, 'lps'),
	(386872, 125, '2015-02-01 00:13:39.000000', 'consum', 0.0211, 'lps'),
	(386873, 125, '2015-02-01 00:13:40.000000', 'consum', 0.0222, 'lps'),
	(386874, 125, '2015-02-01 00:13:41.000000', 'consum', 0.0212, 'lps'),
	(386875, 125, '2015-02-01 00:13:42.000000', 'consum', 0.0211, 'lps'),
	(386876, 125, '2015-02-01 00:13:43.000000', 'consum', 0.0235, 'lps'),
	(386877, 125, '2015-02-01 00:13:44.000000', 'consum', 0.0227, 'lps'),
	(386878, 125, '2015-02-01 00:13:45.000000', 'consum', 0.0221, 'lps'),
	(386879, 125, '2015-02-01 00:13:46.000000', 'consum', 0.0213, 'lps'),
	(386880, 125, '2015-02-01 00:13:47.000000', 'consum', 0.0219, 'lps'),
	(386881, 125, '2015-02-01 00:13:48.000000', 'consum', 0.0220, 'lps'),
	(386882, 125, '2015-02-01 00:13:49.000000', 'consum', 0.0235, 'lps'),
	(386883, 125, '2015-02-01 00:13:50.000000', 'consum', 0.0223, 'lps'),
	(386884, 125, '2015-02-01 00:13:51.000000', 'consum', 0.0228, 'lps'),
	(386885, 125, '2015-02-01 00:13:52.000000', 'consum', 0.0234, 'lps'),
	(386886, 125, '2015-02-01 00:13:53.000000', 'consum', 0.0223, 'lps'),
	(386887, 125, '2015-02-01 00:13:54.000000', 'consum', 0.0231, 'lps'),
	(386888, 125, '2015-02-01 00:13:55.000000', 'consum', 0.0222, 'lps'),
	(386889, 125, '2015-02-01 00:13:56.000000', 'consum', 0.0236, 'lps'),
	(386890, 125, '2015-02-01 00:13:57.000000', 'consum', 0.0220, 'lps'),
	(386891, 125, '2015-02-01 00:13:58.000000', 'consum', 0.0213, 'lps'),
	(386892, 125, '2015-02-01 00:13:59.000000', 'consum', 0.0221, 'lps'),
	(386893, 125, '2015-02-01 00:14:00.000000', 'consum', 0.0228, 'lps'),
	(386894, 125, '2015-02-01 00:14:01.000000', 'consum', 0.0214, 'lps'),
	(386895, 125, '2015-02-01 00:14:02.000000', 'consum', 0.0232, 'lps'),
	(386896, 125, '2015-02-01 00:14:03.000000', 'consum', 0.0225, 'lps'),
	(386897, 125, '2015-02-01 00:14:04.000000', 'consum', 0.0221, 'lps'),
	(386898, 125, '2015-02-01 00:14:05.000000', 'consum', 0.0220, 'lps'),
	(386899, 125, '2015-02-01 00:14:06.000000', 'consum', 0.0228, 'lps'),
	(386900, 125, '2015-02-01 00:14:07.000000', 'consum', 0.0218, 'lps'),
	(386901, 125, '2015-02-01 00:14:08.000000', 'consum', 0.0221, 'lps'),
	(386902, 125, '2015-02-01 00:14:09.000000', 'consum', 0.0214, 'lps'),
	(386903, 125, '2015-02-01 00:14:10.000000', 'consum', 0.0224, 'lps'),
	(386904, 125, '2015-02-01 00:14:11.000000', 'consum', 0.0216, 'lps'),
	(386905, 125, '2015-02-01 00:14:12.000000', 'consum', 0.0223, 'lps'),
	(386906, 125, '2015-02-01 00:14:13.000000', 'consum', 0.0233, 'lps'),
	(386907, 125, '2015-02-01 00:14:14.000000', 'consum', 0.0231, 'lps'),
	(386908, 125, '2015-02-01 00:14:15.000000', 'consum', 0.0218, 'lps'),
	(386909, 125, '2015-02-01 00:14:16.000000', 'consum', 0.0217, 'lps'),
	(386910, 125, '2015-02-01 00:14:17.000000', 'consum', 0.0221, 'lps'),
	(386911, 125, '2015-02-01 00:14:18.000000', 'consum', 0.0216, 'lps'),
	(386912, 125, '2015-02-01 00:14:19.000000', 'consum', 0.0235, 'lps'),
	(386913, 125, '2015-02-01 00:14:20.000000', 'consum', 0.0236, 'lps'),
	(386914, 125, '2015-02-01 00:14:21.000000', 'consum', 0.0213, 'lps'),
	(386915, 125, '2015-02-01 00:14:22.000000', 'consum', 0.0229, 'lps'),
	(386916, 125, '2015-02-01 00:14:23.000000', 'consum', 0.0216, 'lps'),
	(386917, 125, '2015-02-01 00:14:24.000000', 'consum', 0.0210, 'lps'),
	(386918, 125, '2015-02-01 00:14:25.000000', 'consum', 0.0220, 'lps'),
	(386919, 125, '2015-02-01 00:14:26.000000', 'consum', 0.0231, 'lps'),
	(386920, 125, '2015-02-01 00:14:27.000000', 'consum', 0.0232, 'lps'),
	(386921, 125, '2015-02-01 00:14:28.000000', 'consum', 0.0232, 'lps'),
	(386922, 125, '2015-02-01 00:14:29.000000', 'consum', 0.0229, 'lps'),
	(386923, 125, '2015-02-01 00:14:30.000000', 'consum', 0.0211, 'lps'),
	(386924, 125, '2015-02-01 00:14:31.000000', 'consum', 0.0211, 'lps'),
	(386925, 125, '2015-02-01 00:14:32.000000', 'consum', 0.0212, 'lps'),
	(386926, 125, '2015-02-01 00:14:33.000000', 'consum', 0.0219, 'lps'),
	(386927, 125, '2015-02-01 00:14:34.000000', 'consum', 0.0222, 'lps'),
	(386928, 125, '2015-02-01 00:14:35.000000', 'consum', 0.0217, 'lps'),
	(386929, 125, '2015-02-01 00:14:36.000000', 'consum', 0.0235, 'lps'),
	(386930, 125, '2015-02-01 00:14:37.000000', 'consum', 0.0236, 'lps'),
	(386931, 125, '2015-02-01 00:14:38.000000', 'consum', 0.0210, 'lps'),
	(386932, 125, '2015-02-01 00:14:39.000000', 'consum', 0.0213, 'lps'),
	(386933, 125, '2015-02-01 00:14:40.000000', 'consum', 0.0226, 'lps'),
	(386934, 125, '2015-02-01 00:14:41.000000', 'consum', 0.0229, 'lps'),
	(386935, 125, '2015-02-01 00:14:42.000000', 'consum', 0.0229, 'lps'),
	(386936, 125, '2015-02-01 00:14:43.000000', 'consum', 0.0223, 'lps'),
	(386937, 125, '2015-02-01 00:14:44.000000', 'consum', 0.0219, 'lps'),
	(386938, 125, '2015-02-01 00:14:45.000000', 'consum', 0.0215, 'lps'),
	(386939, 125, '2015-02-01 00:14:46.000000', 'consum', 0.0235, 'lps'),
	(386940, 125, '2015-02-01 00:14:47.000000', 'consum', 0.0212, 'lps'),
	(386941, 125, '2015-02-01 00:14:48.000000', 'consum', 0.0228, 'lps'),
	(386942, 125, '2015-02-01 00:14:49.000000', 'consum', 0.0214, 'lps'),
	(386943, 125, '2015-02-01 00:14:50.000000', 'consum', 0.0229, 'lps'),
	(386944, 125, '2015-02-01 00:14:51.000000', 'consum', 0.0212, 'lps'),
	(386945, 125, '2015-02-01 00:14:52.000000', 'consum', 0.0219, 'lps'),
	(386946, 125, '2015-02-01 00:14:53.000000', 'consum', 0.0223, 'lps'),
	(386947, 125, '2015-02-01 00:14:54.000000', 'consum', 0.0220, 'lps'),
	(386948, 125, '2015-02-01 00:14:55.000000', 'consum', 0.0220, 'lps'),
	(386949, 125, '2015-02-01 00:14:56.000000', 'consum', 0.0232, 'lps'),
	(386950, 125, '2015-02-01 00:14:57.000000', 'consum', 0.0236, 'lps'),
	(386951, 125, '2015-02-01 00:14:58.000000', 'consum', 0.0219, 'lps'),
	(386952, 125, '2015-02-01 00:14:59.000000', 'consum', 0.0234, 'lps'),
	(386953, 125, '2015-02-01 00:15:00.000000', 'consum', 0.0221, 'lps'),
	(386954, 125, '2015-02-01 00:15:01.000000', 'consum', 0.0221, 'lps'),
	(386955, 125, '2015-02-01 00:15:02.000000', 'consum', 0.0231, 'lps'),
	(386956, 125, '2015-02-01 00:15:03.000000', 'consum', 0.0229, 'lps'),
	(386957, 125, '2015-02-01 00:15:04.000000', 'consum', 0.0218, 'lps'),
	(386958, 125, '2015-02-01 00:15:05.000000', 'consum', 0.0217, 'lps'),
	(386959, 125, '2015-02-01 00:15:06.000000', 'consum', 0.0223, 'lps'),
	(386960, 125, '2015-02-01 00:15:07.000000', 'consum', 0.0229, 'lps'),
	(386961, 125, '2015-02-01 00:15:08.000000', 'consum', 0.0212, 'lps'),
	(386962, 125, '2015-02-01 00:15:09.000000', 'consum', 0.0217, 'lps'),
	(386963, 125, '2015-02-01 00:15:10.000000', 'consum', 0.0215, 'lps'),
	(386964, 125, '2015-02-01 00:15:11.000000', 'consum', 0.0211, 'lps'),
	(386965, 125, '2015-02-01 00:15:12.000000', 'consum', 0.0229, 'lps'),
	(386966, 125, '2015-02-01 00:15:13.000000', 'consum', 0.0222, 'lps'),
	(386967, 125, '2015-02-01 00:15:14.000000', 'consum', 0.0214, 'lps'),
	(386968, 125, '2015-02-01 00:15:15.000000', 'consum', 0.0219, 'lps'),
	(386969, 125, '2015-02-01 00:15:16.000000', 'consum', 0.0218, 'lps'),
	(386970, 125, '2015-02-01 00:15:17.000000', 'consum', 0.0225, 'lps'),
	(386971, 125, '2015-02-01 00:15:18.000000', 'consum', 0.0232, 'lps'),
	(386972, 125, '2015-02-01 00:15:19.000000', 'consum', 0.0224, 'lps'),
	(386973, 125, '2015-02-01 00:15:20.000000', 'consum', 0.0214, 'lps'),
	(386974, 125, '2015-02-01 00:15:21.000000', 'consum', 0.0214, 'lps'),
	(386975, 125, '2015-02-01 00:15:22.000000', 'consum', 0.0218, 'lps'),
	(386976, 125, '2015-02-01 00:15:23.000000', 'consum', 0.0214, 'lps'),
	(386977, 125, '2015-02-01 00:15:24.000000', 'consum', 0.0231, 'lps'),
	(386978, 125, '2015-02-01 00:15:25.000000', 'consum', 0.0223, 'lps'),
	(386979, 125, '2015-02-01 00:15:26.000000', 'consum', 0.0215, 'lps'),
	(386980, 125, '2015-02-01 00:15:27.000000', 'consum', 0.0221, 'lps'),
	(386981, 125, '2015-02-01 00:15:28.000000', 'consum', 0.0223, 'lps'),
	(386982, 125, '2015-02-01 00:15:29.000000', 'consum', 0.0216, 'lps'),
	(386983, 125, '2015-02-01 00:15:30.000000', 'consum', 0.0228, 'lps'),
	(386984, 125, '2015-02-01 00:15:31.000000', 'consum', 0.0230, 'lps'),
	(386985, 125, '2015-02-01 00:15:32.000000', 'consum', 0.0228, 'lps'),
	(386986, 125, '2015-02-01 00:15:33.000000', 'consum', 0.0213, 'lps'),
	(386987, 125, '2015-02-01 00:15:34.000000', 'consum', 0.0227, 'lps'),
	(386988, 125, '2015-02-01 00:15:35.000000', 'consum', 0.0233, 'lps'),
	(386989, 125, '2015-02-01 00:15:36.000000', 'consum', 0.0218, 'lps'),
	(386990, 125, '2015-02-01 00:15:37.000000', 'consum', 0.0211, 'lps'),
	(386991, 125, '2015-02-01 00:15:38.000000', 'consum', 0.0216, 'lps'),
	(386992, 125, '2015-02-01 00:15:39.000000', 'consum', 0.0214, 'lps'),
	(386993, 125, '2015-02-01 00:15:40.000000', 'consum', 0.0236, 'lps'),
	(386994, 125, '2015-02-01 00:15:41.000000', 'consum', 0.0221, 'lps'),
	(386995, 125, '2015-02-01 00:15:42.000000', 'consum', 0.0216, 'lps'),
	(386996, 125, '2015-02-01 00:15:43.000000', 'consum', 0.0235, 'lps'),
	(386997, 125, '2015-02-01 00:15:44.000000', 'consum', 0.0236, 'lps'),
	(386998, 125, '2015-02-01 00:15:45.000000', 'consum', 0.0210, 'lps'),
	(386999, 125, '2015-02-01 00:15:46.000000', 'consum', 0.0214, 'lps'),
	(387000, 125, '2015-02-01 00:15:47.000000', 'consum', 0.0229, 'lps'),
	(387001, 125, '2015-02-01 00:15:48.000000', 'consum', 0.0213, 'lps'),
	(387002, 125, '2015-02-01 00:15:49.000000', 'consum', 0.0224, 'lps'),
	(387003, 125, '2015-02-01 00:15:50.000000', 'consum', 0.0219, 'lps'),
	(387004, 125, '2015-02-01 00:15:51.000000', 'consum', 0.0211, 'lps'),
	(387005, 125, '2015-02-01 00:15:52.000000', 'consum', 0.0215, 'lps'),
	(387006, 125, '2015-02-01 00:15:53.000000', 'consum', 0.0235, 'lps'),
	(387007, 125, '2015-02-01 00:15:54.000000', 'consum', 0.0213, 'lps'),
	(387008, 125, '2015-02-01 00:15:55.000000', 'consum', 0.0231, 'lps'),
	(387009, 125, '2015-02-01 00:15:56.000000', 'consum', 0.0224, 'lps'),
	(387010, 125, '2015-02-01 00:15:57.000000', 'consum', 0.0219, 'lps'),
	(387011, 125, '2015-02-01 00:15:58.000000', 'consum', 0.0215, 'lps'),
	(387012, 125, '2015-02-01 00:15:59.000000', 'consum', 0.0234, 'lps'),
	(387013, 125, '2015-02-01 00:16:00.000000', 'consum', 0.0235, 'lps'),
	(387014, 125, '2015-02-01 00:16:01.000000', 'consum', 0.0234, 'lps'),
	(387015, 125, '2015-02-01 00:16:02.000000', 'consum', 0.0231, 'lps'),
	(387016, 125, '2015-02-01 00:16:03.000000', 'consum', 0.0217, 'lps'),
	(387017, 125, '2015-02-01 00:16:04.000000', 'consum', 0.0210, 'lps'),
	(387018, 125, '2015-02-01 00:16:05.000000', 'consum', 0.0214, 'lps'),
	(387019, 125, '2015-02-01 00:16:06.000000', 'consum', 0.0233, 'lps'),
	(387020, 125, '2015-02-01 00:16:07.000000', 'consum', 0.0234, 'lps'),
	(387021, 125, '2015-02-01 00:16:08.000000', 'consum', 0.0231, 'lps'),
	(387022, 125, '2015-02-01 00:16:09.000000', 'consum', 0.0216, 'lps'),
	(387023, 125, '2015-02-01 00:16:10.000000', 'consum', 0.0235, 'lps'),
	(387024, 125, '2015-02-01 00:16:11.000000', 'consum', 0.0233, 'lps'),
	(387025, 125, '2015-02-01 00:16:12.000000', 'consum', 0.0224, 'lps'),
	(387026, 125, '2015-02-01 00:16:13.000000', 'consum', 0.0212, 'lps'),
	(387027, 125, '2015-02-01 00:16:14.000000', 'consum', 0.0231, 'lps'),
	(387028, 125, '2015-02-01 00:16:15.000000', 'consum', 0.0229, 'lps'),
	(387029, 125, '2015-02-01 00:16:16.000000', 'consum', 0.0214, 'lps'),
	(387030, 125, '2015-02-01 00:16:17.000000', 'consum', 0.0230, 'lps'),
	(387031, 125, '2015-02-01 00:16:18.000000', 'consum', 0.0219, 'lps'),
	(387032, 125, '2015-02-01 00:16:19.000000', 'consum', 0.0219, 'lps'),
	(387033, 125, '2015-02-01 00:16:20.000000', 'consum', 0.0231, 'lps'),
	(387034, 125, '2015-02-01 00:16:21.000000', 'consum', 0.0233, 'lps'),
	(387035, 125, '2015-02-01 00:16:22.000000', 'consum', 0.0211, 'lps'),
	(387036, 125, '2015-02-01 00:16:23.000000', 'consum', 0.0226, 'lps'),
	(387037, 125, '2015-02-01 00:16:24.000000', 'consum', 0.0233, 'lps'),
	(387038, 125, '2015-02-01 00:16:25.000000', 'consum', 0.0222, 'lps'),
	(387039, 125, '2015-02-01 00:16:26.000000', 'consum', 0.0231, 'lps'),
	(387040, 125, '2015-02-01 00:16:27.000000', 'consum', 0.0226, 'lps'),
	(387041, 125, '2015-02-01 00:16:28.000000', 'consum', 0.0227, 'lps'),
	(387042, 125, '2015-02-01 00:16:29.000000', 'consum', 0.0221, 'lps'),
	(387043, 125, '2015-02-01 00:16:30.000000', 'consum', 0.0213, 'lps'),
	(387044, 125, '2015-02-01 00:16:31.000000', 'consum', 0.0219, 'lps'),
	(387045, 125, '2015-02-01 00:16:32.000000', 'consum', 0.0219, 'lps'),
	(387046, 125, '2015-02-01 00:16:33.000000', 'consum', 0.0230, 'lps'),
	(387047, 125, '2015-02-01 00:16:34.000000', 'consum', 0.0231, 'lps'),
	(387048, 125, '2015-02-01 00:16:35.000000', 'consum', 0.0227, 'lps'),
	(387049, 125, '2015-02-01 00:16:36.000000', 'consum', 0.0233, 'lps'),
	(387050, 125, '2015-02-01 00:16:37.000000', 'consum', 0.0221, 'lps'),
	(387051, 125, '2015-02-01 00:16:38.000000', 'consum', 0.0223, 'lps'),
	(387052, 125, '2015-02-01 00:16:39.000000', 'consum', 0.0215, 'lps'),
	(387053, 125, '2015-02-01 00:16:40.000000', 'consum', 0.0226, 'lps'),
	(387054, 125, '2015-02-01 00:16:41.000000', 'consum', 0.0218, 'lps'),
	(387055, 125, '2015-02-01 00:16:42.000000', 'consum', 0.0232, 'lps'),
	(387056, 125, '2015-02-01 00:16:43.000000', 'consum', 0.0215, 'lps'),
	(387057, 125, '2015-02-01 00:16:44.000000', 'consum', 0.0225, 'lps'),
	(387058, 125, '2015-02-01 00:16:45.000000', 'consum', 0.0216, 'lps'),
	(387059, 125, '2015-02-01 00:16:46.000000', 'consum', 0.0220, 'lps'),
	(387060, 125, '2015-02-01 00:16:47.000000', 'consum', 0.0219, 'lps'),
	(387061, 125, '2015-02-01 00:16:48.000000', 'consum', 0.0223, 'lps'),
	(387062, 125, '2015-02-01 00:16:49.000000', 'consum', 0.0221, 'lps'),
	(387063, 125, '2015-02-01 00:16:50.000000', 'consum', 0.0228, 'lps'),
	(387064, 125, '2015-02-01 00:16:51.000000', 'consum', 0.0214, 'lps'),
	(387065, 125, '2015-02-01 00:16:52.000000', 'consum', 0.0228, 'lps'),
	(387066, 125, '2015-02-01 00:16:53.000000', 'consum', 0.0236, 'lps'),
	(387067, 125, '2015-02-01 00:16:54.000000', 'consum', 0.0232, 'lps'),
	(387068, 125, '2015-02-01 00:16:55.000000', 'consum', 0.0214, 'lps'),
	(387069, 125, '2015-02-01 00:16:56.000000', 'consum', 0.0221, 'lps'),
	(387070, 125, '2015-02-01 00:16:57.000000', 'consum', 0.0225, 'lps'),
	(387071, 125, '2015-02-01 00:16:58.000000', 'consum', 0.0228, 'lps'),
	(387072, 125, '2015-02-01 00:16:59.000000', 'consum', 0.0226, 'lps'),
	(387073, 125, '2015-02-01 00:17:00.000000', 'consum', 0.0211, 'lps'),
	(387074, 125, '2015-02-01 00:17:01.000000', 'consum', 0.0222, 'lps'),
	(387075, 125, '2015-02-01 00:17:02.000000', 'consum', 0.0214, 'lps'),
	(387076, 125, '2015-02-01 00:17:03.000000', 'consum', 0.0220, 'lps'),
	(387077, 125, '2015-02-01 00:17:04.000000', 'consum', 0.0223, 'lps'),
	(387078, 125, '2015-02-01 00:17:05.000000', 'consum', 0.0217, 'lps'),
	(387079, 125, '2015-02-01 00:17:06.000000', 'consum', 0.0234, 'lps'),
	(387080, 125, '2015-02-01 00:17:07.000000', 'consum', 0.0228, 'lps'),
	(387081, 125, '2015-02-01 00:17:08.000000', 'consum', 0.0229, 'lps'),
	(387082, 125, '2015-02-01 00:17:09.000000', 'consum', 0.0226, 'lps'),
	(387083, 125, '2015-02-01 00:17:10.000000', 'consum', 0.0230, 'lps'),
	(387084, 125, '2015-02-01 00:17:11.000000', 'consum', 0.0212, 'lps'),
	(387085, 125, '2015-02-01 00:17:12.000000', 'consum', 0.0212, 'lps'),
	(387086, 125, '2015-02-01 00:17:13.000000', 'consum', 0.0217, 'lps'),
	(387087, 125, '2015-02-01 00:17:14.000000', 'consum', 0.0212, 'lps'),
	(387088, 125, '2015-02-01 00:17:15.000000', 'consum', 0.0225, 'lps'),
	(387089, 125, '2015-02-01 00:17:16.000000', 'consum', 0.0227, 'lps'),
	(387090, 125, '2015-02-01 00:17:17.000000', 'consum', 0.0224, 'lps'),
	(387091, 125, '2015-02-01 00:17:18.000000', 'consum', 0.0228, 'lps'),
	(387092, 125, '2015-02-01 00:17:19.000000', 'consum', 0.0230, 'lps'),
	(387093, 125, '2015-02-01 00:17:20.000000', 'consum', 0.0233, 'lps'),
	(387094, 125, '2015-02-01 00:17:21.000000', 'consum', 0.0210, 'lps'),
	(387095, 125, '2015-02-01 00:17:22.000000', 'consum', 0.0222, 'lps'),
	(387096, 125, '2015-02-01 00:17:23.000000', 'consum', 0.0216, 'lps'),
	(387097, 125, '2015-02-01 00:17:24.000000', 'consum', 0.0233, 'lps'),
	(387098, 125, '2015-02-01 00:17:25.000000', 'consum', 0.0228, 'lps'),
	(387099, 125, '2015-02-01 00:17:26.000000', 'consum', 0.0228, 'lps'),
	(387100, 125, '2015-02-01 00:17:27.000000', 'consum', 0.0223, 'lps'),
	(387101, 125, '2015-02-01 00:17:28.000000', 'consum', 0.0220, 'lps'),
	(387102, 125, '2015-02-01 00:17:29.000000', 'consum', 0.0221, 'lps'),
	(387103, 125, '2015-02-01 00:17:30.000000', 'consum', 0.0210, 'lps'),
	(387104, 125, '2015-02-01 00:17:31.000000', 'consum', 0.0232, 'lps'),
	(387105, 125, '2015-02-01 00:17:32.000000', 'consum', 0.0212, 'lps'),
	(387106, 125, '2015-02-01 00:17:33.000000', 'consum', 0.0236, 'lps'),
	(387107, 125, '2015-02-01 00:17:34.000000', 'consum', 0.0224, 'lps'),
	(387108, 125, '2015-02-01 00:17:35.000000', 'consum', 0.0232, 'lps'),
	(387109, 125, '2015-02-01 00:17:36.000000', 'consum', 0.0225, 'lps'),
	(387110, 125, '2015-02-01 00:17:37.000000', 'consum', 0.0218, 'lps'),
	(387111, 125, '2015-02-01 00:17:38.000000', 'consum', 0.0235, 'lps'),
	(387112, 125, '2015-02-01 00:17:39.000000', 'consum', 0.0228, 'lps'),
	(387113, 125, '2015-02-01 00:17:40.000000', 'consum', 0.0225, 'lps'),
	(387114, 125, '2015-02-01 00:17:41.000000', 'consum', 0.0231, 'lps'),
	(387115, 125, '2015-02-01 00:17:42.000000', 'consum', 0.0215, 'lps'),
	(387116, 125, '2015-02-01 00:17:43.000000', 'consum', 0.0230, 'lps'),
	(387117, 125, '2015-02-01 00:17:44.000000', 'consum', 0.0212, 'lps'),
	(387118, 125, '2015-02-01 00:17:45.000000', 'consum', 0.0215, 'lps'),
	(387119, 125, '2015-02-01 00:17:46.000000', 'consum', 0.0231, 'lps'),
	(387120, 125, '2015-02-01 00:17:47.000000', 'consum', 0.0219, 'lps'),
	(387121, 125, '2015-02-01 00:17:48.000000', 'consum', 0.0218, 'lps'),
	(387122, 125, '2015-02-01 00:17:49.000000', 'consum', 0.0224, 'lps'),
	(387123, 125, '2015-02-01 00:17:50.000000', 'consum', 0.0229, 'lps'),
	(387124, 125, '2015-02-01 00:17:51.000000', 'consum', 0.0210, 'lps'),
	(387125, 125, '2015-02-01 00:17:52.000000', 'consum', 0.0235, 'lps'),
	(387126, 125, '2015-02-01 00:17:53.000000', 'consum', 0.0229, 'lps'),
	(387127, 125, '2015-02-01 00:17:54.000000', 'consum', 0.0228, 'lps'),
	(387128, 125, '2015-02-01 00:17:55.000000', 'consum', 0.0217, 'lps'),
	(387129, 125, '2015-02-01 00:17:56.000000', 'consum', 0.0219, 'lps'),
	(387130, 125, '2015-02-01 00:17:57.000000', 'consum', 0.0236, 'lps'),
	(387131, 125, '2015-02-01 00:17:58.000000', 'consum', 0.0229, 'lps'),
	(387132, 125, '2015-02-01 00:17:59.000000', 'consum', 0.0231, 'lps'),
	(387133, 125, '2015-02-01 00:18:00.000000', 'consum', 0.0228, 'lps'),
	(387134, 125, '2015-02-01 00:18:01.000000', 'consum', 0.0213, 'lps'),
	(387135, 125, '2015-02-01 00:18:02.000000', 'consum', 0.0225, 'lps'),
	(387136, 125, '2015-02-01 00:18:03.000000', 'consum', 0.0223, 'lps'),
	(387137, 125, '2015-02-01 00:18:04.000000', 'consum', 0.0231, 'lps'),
	(387138, 125, '2015-02-01 00:18:05.000000', 'consum', 0.0220, 'lps'),
	(387139, 125, '2015-02-01 00:18:06.000000', 'consum', 0.0225, 'lps'),
	(387140, 125, '2015-02-01 00:18:07.000000', 'consum', 0.0228, 'lps'),
	(387141, 125, '2015-02-01 00:18:08.000000', 'consum', 0.0229, 'lps'),
	(387142, 125, '2015-02-01 00:18:09.000000', 'consum', 0.0223, 'lps'),
	(387143, 125, '2015-02-01 00:18:10.000000', 'consum', 0.0221, 'lps'),
	(387144, 125, '2015-02-01 00:18:11.000000', 'consum', 0.0223, 'lps'),
	(387145, 125, '2015-02-01 00:18:12.000000', 'consum', 0.0219, 'lps'),
	(387146, 125, '2015-02-01 00:18:13.000000', 'consum', 0.0216, 'lps'),
	(387147, 125, '2015-02-01 00:18:14.000000', 'consum', 0.0213, 'lps'),
	(387148, 125, '2015-02-01 00:18:15.000000', 'consum', 0.0234, 'lps'),
	(387149, 125, '2015-02-01 00:18:16.000000', 'consum', 0.0213, 'lps'),
	(387150, 125, '2015-02-01 00:18:17.000000', 'consum', 0.0235, 'lps'),
	(387151, 125, '2015-02-01 00:18:18.000000', 'consum', 0.0218, 'lps'),
	(387152, 125, '2015-02-01 00:18:19.000000', 'consum', 0.0230, 'lps'),
	(387153, 125, '2015-02-01 00:18:20.000000', 'consum', 0.0231, 'lps'),
	(387154, 125, '2015-02-01 00:18:21.000000', 'consum', 0.0231, 'lps'),
	(387155, 125, '2015-02-01 00:18:22.000000', 'consum', 0.0225, 'lps'),
	(387156, 125, '2015-02-01 00:18:23.000000', 'consum', 0.0223, 'lps'),
	(387157, 125, '2015-02-01 00:18:24.000000', 'consum', 0.0229, 'lps'),
	(387158, 125, '2015-02-01 00:18:25.000000', 'consum', 0.0213, 'lps'),
	(387159, 125, '2015-02-01 00:18:26.000000', 'consum', 0.0222, 'lps'),
	(387160, 125, '2015-02-01 00:18:27.000000', 'consum', 0.0210, 'lps'),
	(387161, 125, '2015-02-01 00:18:28.000000', 'consum', 0.0227, 'lps'),
	(387162, 125, '2015-02-01 00:18:29.000000', 'consum', 0.0214, 'lps'),
	(387163, 125, '2015-02-01 00:18:30.000000', 'consum', 0.0235, 'lps'),
	(387164, 125, '2015-02-01 00:18:31.000000', 'consum', 0.0216, 'lps'),
	(387165, 125, '2015-02-01 00:18:32.000000', 'consum', 0.0218, 'lps'),
	(387166, 125, '2015-02-01 00:18:33.000000', 'consum', 0.0235, 'lps'),
	(387167, 125, '2015-02-01 00:18:34.000000', 'consum', 0.0228, 'lps'),
	(387168, 125, '2015-02-01 00:18:35.000000', 'consum', 0.0228, 'lps'),
	(387169, 125, '2015-02-01 00:18:36.000000', 'consum', 0.0217, 'lps'),
	(387170, 125, '2015-02-01 00:18:37.000000', 'consum', 0.0219, 'lps'),
	(387171, 125, '2015-02-01 00:18:38.000000', 'consum', 0.0236, 'lps'),
	(387172, 125, '2015-02-01 00:18:39.000000', 'consum', 0.0233, 'lps'),
	(387173, 125, '2015-02-01 00:18:40.000000', 'consum', 0.0220, 'lps'),
	(387174, 125, '2015-02-01 00:18:41.000000', 'consum', 0.0218, 'lps'),
	(387175, 125, '2015-02-01 00:18:42.000000', 'consum', 0.0222, 'lps'),
	(387176, 125, '2015-02-01 00:18:43.000000', 'consum', 0.0217, 'lps'),
	(387177, 125, '2015-02-01 00:18:44.000000', 'consum', 0.0236, 'lps'),
	(387178, 125, '2015-02-01 00:18:45.000000', 'consum', 0.0213, 'lps'),
	(387179, 125, '2015-02-01 00:18:46.000000', 'consum', 0.0227, 'lps'),
	(387180, 125, '2015-02-01 00:18:47.000000', 'consum', 0.0234, 'lps'),
	(387181, 125, '2015-02-01 00:18:48.000000', 'consum', 0.0225, 'lps'),
	(387182, 125, '2015-02-01 00:18:49.000000', 'consum', 0.0215, 'lps'),
	(387183, 125, '2015-02-01 00:18:50.000000', 'consum', 0.0217, 'lps'),
	(387184, 125, '2015-02-01 00:18:51.000000', 'consum', 0.0229, 'lps'),
	(387185, 125, '2015-02-01 00:18:52.000000', 'consum', 0.0229, 'lps'),
	(387186, 125, '2015-02-01 00:18:53.000000', 'consum', 0.0224, 'lps'),
	(387187, 125, '2015-02-01 00:18:54.000000', 'consum', 0.0223, 'lps'),
	(387188, 125, '2015-02-01 00:18:55.000000', 'consum', 0.0235, 'lps'),
	(387189, 125, '2015-02-01 00:18:56.000000', 'consum', 0.0212, 'lps'),
	(387190, 125, '2015-02-01 00:18:57.000000', 'consum', 0.0230, 'lps'),
	(387191, 125, '2015-02-01 00:18:58.000000', 'consum', 0.0223, 'lps'),
	(387192, 125, '2015-02-01 00:18:59.000000', 'consum', 0.0217, 'lps'),
	(387193, 125, '2015-02-01 00:19:00.000000', 'consum', 0.0231, 'lps'),
	(387194, 125, '2015-02-01 00:19:01.000000', 'consum', 0.0216, 'lps'),
	(387195, 125, '2015-02-01 00:19:02.000000', 'consum', 0.0230, 'lps'),
	(387196, 125, '2015-02-01 00:19:03.000000', 'consum', 0.0211, 'lps'),
	(387197, 125, '2015-02-01 00:19:04.000000', 'consum', 0.0211, 'lps'),
	(387198, 125, '2015-02-01 00:19:05.000000', 'consum', 0.0210, 'lps'),
	(387199, 125, '2015-02-01 00:19:06.000000', 'consum', 0.0211, 'lps'),
	(387200, 125, '2015-02-01 00:19:07.000000', 'consum', 0.0212, 'lps'),
	(387201, 125, '2015-02-01 00:19:08.000000', 'consum', 0.0220, 'lps'),
	(387202, 125, '2015-02-01 00:19:09.000000', 'consum', 0.0226, 'lps'),
	(387203, 125, '2015-02-01 00:19:10.000000', 'consum', 0.0234, 'lps'),
	(387204, 125, '2015-02-01 00:19:11.000000', 'consum', 0.0227, 'lps'),
	(387205, 125, '2015-02-01 00:19:12.000000', 'consum', 0.0224, 'lps'),
	(387206, 125, '2015-02-01 00:19:13.000000', 'consum', 0.0231, 'lps'),
	(387207, 125, '2015-02-01 00:19:14.000000', 'consum', 0.0219, 'lps'),
	(387208, 125, '2015-02-01 00:19:15.000000', 'consum', 0.0218, 'lps'),
	(387209, 125, '2015-02-01 00:19:16.000000', 'consum', 0.0226, 'lps'),
	(387210, 125, '2015-02-01 00:19:17.000000', 'consum', 0.0212, 'lps'),
	(387211, 125, '2015-02-01 00:19:18.000000', 'consum', 0.0225, 'lps'),
	(387212, 125, '2015-02-01 00:19:19.000000', 'consum', 0.0227, 'lps'),
	(387213, 125, '2015-02-01 00:19:20.000000', 'consum', 0.0223, 'lps'),
	(387214, 125, '2015-02-01 00:19:21.000000', 'consum', 0.0225, 'lps'),
	(387215, 125, '2015-02-01 00:19:22.000000', 'consum', 0.0221, 'lps'),
	(387216, 125, '2015-02-01 00:19:23.000000', 'consum', 0.0220, 'lps'),
	(387217, 125, '2015-02-01 00:19:24.000000', 'consum', 0.0225, 'lps'),
	(387218, 125, '2015-02-01 00:19:25.000000', 'consum', 0.0232, 'lps'),
	(387219, 125, '2015-02-01 00:19:26.000000', 'consum', 0.0219, 'lps'),
	(387220, 125, '2015-02-01 00:19:27.000000', 'consum', 0.0217, 'lps'),
	(387221, 125, '2015-02-01 00:19:28.000000', 'consum', 0.0217, 'lps'),
	(387222, 125, '2015-02-01 00:19:29.000000', 'consum', 0.0224, 'lps'),
	(387223, 125, '2015-02-01 00:19:30.000000', 'consum', 0.0233, 'lps'),
	(387224, 125, '2015-02-01 00:19:31.000000', 'consum', 0.0232, 'lps'),
	(387225, 125, '2015-02-01 00:19:32.000000', 'consum', 0.0223, 'lps'),
	(387226, 125, '2015-02-01 00:19:33.000000', 'consum', 0.0211, 'lps'),
	(387227, 125, '2015-02-01 00:19:34.000000', 'consum', 0.0228, 'lps'),
	(387228, 125, '2015-02-01 00:19:35.000000', 'consum', 0.0220, 'lps'),
	(387229, 125, '2015-02-01 00:19:36.000000', 'consum', 0.0230, 'lps'),
	(387230, 125, '2015-02-01 00:19:37.000000', 'consum', 0.0227, 'lps'),
	(387231, 125, '2015-02-01 00:19:38.000000', 'consum', 0.0235, 'lps'),
	(387232, 125, '2015-02-01 00:19:39.000000', 'consum', 0.0231, 'lps'),
	(387233, 125, '2015-02-01 00:19:40.000000', 'consum', 0.0213, 'lps'),
	(387234, 125, '2015-02-01 00:19:41.000000', 'consum', 0.0216, 'lps'),
	(387235, 125, '2015-02-01 00:19:42.000000', 'consum', 0.0234, 'lps'),
	(387236, 125, '2015-02-01 00:19:43.000000', 'consum', 0.0231, 'lps'),
	(387237, 125, '2015-02-01 00:19:44.000000', 'consum', 0.0214, 'lps'),
	(387238, 125, '2015-02-01 00:19:45.000000', 'consum', 0.0224, 'lps'),
	(387239, 125, '2015-02-01 00:19:46.000000', 'consum', 0.0215, 'lps'),
	(387240, 125, '2015-02-01 00:19:47.000000', 'consum', 0.0218, 'lps'),
	(387241, 125, '2015-02-01 00:19:48.000000', 'consum', 0.0236, 'lps'),
	(387242, 125, '2015-02-01 00:19:49.000000', 'consum', 0.0236, 'lps'),
	(387243, 125, '2015-02-01 00:19:50.000000', 'consum', 0.0236, 'lps'),
	(387244, 125, '2015-02-01 00:19:51.000000', 'consum', 0.0210, 'lps'),
	(387245, 125, '2015-02-01 00:19:52.000000', 'consum', 0.0211, 'lps'),
	(387246, 125, '2015-02-01 00:19:53.000000', 'consum', 0.0217, 'lps'),
	(387247, 125, '2015-02-01 00:19:54.000000', 'consum', 0.0214, 'lps'),
	(387248, 125, '2015-02-01 00:19:55.000000', 'consum', 0.0211, 'lps'),
	(387249, 125, '2015-02-01 00:19:56.000000', 'consum', 0.0228, 'lps'),
	(387250, 125, '2015-02-01 00:19:57.000000', 'consum', 0.0220, 'lps'),
	(387251, 125, '2015-02-01 00:19:58.000000', 'consum', 0.0230, 'lps'),
	(387252, 125, '2015-02-01 00:19:59.000000', 'consum', 0.0229, 'lps'),
	(387253, 125, '2015-02-01 00:20:00.000000', 'consum', 0.0219, 'lps'),
	(387254, 125, '2015-02-01 00:20:01.000000', 'consum', 0.0226, 'lps'),
	(387255, 125, '2015-02-01 00:20:02.000000', 'consum', 0.0236, 'lps'),
	(387256, 125, '2015-02-01 00:20:03.000000', 'consum', 0.0211, 'lps'),
	(387257, 125, '2015-02-01 00:20:04.000000', 'consum', 0.0219, 'lps'),
	(387258, 125, '2015-02-01 00:20:05.000000', 'consum', 0.0224, 'lps'),
	(387259, 125, '2015-02-01 00:20:06.000000', 'consum', 0.0229, 'lps'),
	(387260, 125, '2015-02-01 00:20:07.000000', 'consum', 0.0235, 'lps'),
	(387261, 125, '2015-02-01 00:20:08.000000', 'consum', 0.0226, 'lps'),
	(387262, 125, '2015-02-01 00:20:09.000000', 'consum', 0.0214, 'lps'),
	(387263, 125, '2015-02-01 00:20:10.000000', 'consum', 0.0236, 'lps'),
	(387264, 125, '2015-02-01 00:20:11.000000', 'consum', 0.0219, 'lps'),
	(387265, 125, '2015-02-01 00:20:12.000000', 'consum', 0.0235, 'lps'),
	(387266, 125, '2015-02-01 00:20:13.000000', 'consum', 0.0224, 'lps'),
	(387267, 125, '2015-02-01 00:20:14.000000', 'consum', 0.0236, 'lps'),
	(387268, 125, '2015-02-01 00:20:15.000000', 'consum', 0.0216, 'lps'),
	(387269, 125, '2015-02-01 00:20:16.000000', 'consum', 0.0215, 'lps'),
	(387270, 125, '2015-02-01 00:20:17.000000', 'consum', 0.0219, 'lps'),
	(387271, 125, '2015-02-01 00:20:18.000000', 'consum', 0.0213, 'lps'),
	(387272, 125, '2015-02-01 00:20:19.000000', 'consum', 0.0226, 'lps'),
	(387273, 125, '2015-02-01 00:20:20.000000', 'consum', 0.0228, 'lps'),
	(387274, 125, '2015-02-01 00:20:21.000000', 'consum', 0.0224, 'lps'),
	(387275, 125, '2015-02-01 00:20:22.000000', 'consum', 0.0226, 'lps'),
	(387276, 125, '2015-02-01 00:20:23.000000', 'consum', 0.0224, 'lps'),
	(387277, 125, '2015-02-01 00:20:24.000000', 'consum', 0.0230, 'lps'),
	(387278, 125, '2015-02-01 00:20:25.000000', 'consum', 0.0216, 'lps'),
	(387279, 125, '2015-02-01 00:20:26.000000', 'consum', 0.0233, 'lps'),
	(387280, 125, '2015-02-01 00:20:27.000000', 'consum', 0.0226, 'lps'),
	(387281, 125, '2015-02-01 00:20:28.000000', 'consum', 0.0220, 'lps'),
	(387282, 125, '2015-02-01 00:20:29.000000', 'consum', 0.0215, 'lps'),
	(387283, 125, '2015-02-01 00:20:30.000000', 'consum', 0.0233, 'lps'),
	(387284, 125, '2015-02-01 00:20:31.000000', 'consum', 0.0230, 'lps'),
	(387285, 125, '2015-02-01 00:20:32.000000', 'consum', 0.0215, 'lps'),
	(387286, 125, '2015-02-01 00:20:33.000000', 'consum', 0.0231, 'lps'),
	(387287, 125, '2015-02-01 00:20:34.000000', 'consum', 0.0216, 'lps'),
	(387288, 125, '2015-02-01 00:20:35.000000', 'consum', 0.0233, 'lps'),
	(387289, 125, '2015-02-01 00:20:36.000000', 'consum', 0.0227, 'lps'),
	(387290, 125, '2015-02-01 00:20:37.000000', 'consum', 0.0227, 'lps'),
	(387291, 125, '2015-02-01 00:20:38.000000', 'consum', 0.0219, 'lps'),
	(387292, 125, '2015-02-01 00:20:39.000000', 'consum', 0.0229, 'lps'),
	(387293, 125, '2015-02-01 00:20:40.000000', 'consum', 0.0225, 'lps'),
	(387294, 125, '2015-02-01 00:20:41.000000', 'consum', 0.0228, 'lps'),
	(387295, 125, '2015-02-01 00:20:42.000000', 'consum', 0.0230, 'lps'),
	(387296, 125, '2015-02-01 00:20:43.000000', 'consum', 0.0229, 'lps'),
	(387297, 125, '2015-02-01 00:20:44.000000', 'consum', 0.0218, 'lps'),
	(387298, 125, '2015-02-01 00:20:45.000000', 'consum', 0.0222, 'lps'),
	(387299, 125, '2015-02-01 00:20:46.000000', 'consum', 0.0219, 'lps'),
	(387300, 125, '2015-02-01 00:20:47.000000', 'consum', 0.0218, 'lps'),
	(387301, 125, '2015-02-01 00:20:48.000000', 'consum', 0.0225, 'lps'),
	(387302, 125, '2015-02-01 00:20:49.000000', 'consum', 0.0234, 'lps'),
	(387303, 125, '2015-02-01 00:20:50.000000', 'consum', 0.0231, 'lps'),
	(387304, 125, '2015-02-01 00:20:51.000000', 'consum', 0.0218, 'lps'),
	(387305, 125, '2015-02-01 00:20:52.000000', 'consum', 0.0215, 'lps'),
	(387306, 125, '2015-02-01 00:20:53.000000', 'consum', 0.0211, 'lps'),
	(387307, 125, '2015-02-01 00:20:54.000000', 'consum', 0.0227, 'lps'),
	(387308, 125, '2015-02-01 00:20:55.000000', 'consum', 0.0210, 'lps'),
	(387309, 125, '2015-02-01 00:20:56.000000', 'consum', 0.0213, 'lps'),
	(387310, 125, '2015-02-01 00:20:57.000000', 'consum', 0.0228, 'lps'),
	(387311, 125, '2015-02-01 00:20:58.000000', 'consum', 0.0211, 'lps'),
	(387312, 125, '2015-02-01 00:20:59.000000', 'consum', 0.0216, 'lps'),
	(387313, 125, '2015-02-01 00:21:00.000000', 'consum', 0.0234, 'lps'),
	(387314, 125, '2015-02-01 00:21:01.000000', 'consum', 0.0235, 'lps'),
	(387315, 125, '2015-02-01 00:21:02.000000', 'consum', 0.0236, 'lps'),
	(387316, 125, '2015-02-01 00:21:03.000000', 'consum', 0.0213, 'lps'),
	(387317, 125, '2015-02-01 00:21:04.000000', 'consum', 0.0226, 'lps'),
	(387318, 125, '2015-02-01 00:21:05.000000', 'consum', 0.0227, 'lps'),
	(387319, 125, '2015-02-01 00:21:06.000000', 'consum', 0.0222, 'lps'),
	(387320, 125, '2015-02-01 00:21:07.000000', 'consum', 0.0220, 'lps'),
	(387321, 125, '2015-02-01 00:21:08.000000', 'consum', 0.0226, 'lps'),
	(387322, 125, '2015-02-01 00:21:09.000000', 'consum', 0.0231, 'lps'),
	(387323, 125, '2015-02-01 00:21:10.000000', 'consum', 0.0216, 'lps'),
	(387324, 125, '2015-02-01 00:21:11.000000', 'consum', 0.0231, 'lps'),
	(387325, 125, '2015-02-01 00:21:12.000000', 'consum', 0.0217, 'lps'),
	(387326, 125, '2015-02-01 00:21:13.000000', 'consum', 0.0236, 'lps'),
	(387327, 125, '2015-02-01 00:21:14.000000', 'consum', 0.0210, 'lps'),
	(387328, 125, '2015-02-01 00:21:15.000000', 'consum', 0.0216, 'lps'),
	(387329, 125, '2015-02-01 00:21:16.000000', 'consum', 0.0214, 'lps'),
	(387330, 125, '2015-02-01 00:21:17.000000', 'consum', 0.0210, 'lps'),
	(387331, 125, '2015-02-01 00:21:18.000000', 'consum', 0.0225, 'lps'),
	(387332, 125, '2015-02-01 00:21:19.000000', 'consum', 0.0231, 'lps'),
	(387333, 125, '2015-02-01 00:21:20.000000', 'consum', 0.0216, 'lps'),
	(387334, 125, '2015-02-01 00:21:21.000000', 'consum', 0.0231, 'lps'),
	(387335, 125, '2015-02-01 00:21:22.000000', 'consum', 0.0219, 'lps'),
	(387336, 125, '2015-02-01 00:21:23.000000', 'consum', 0.0218, 'lps'),
	(387337, 125, '2015-02-01 00:21:24.000000', 'consum', 0.0222, 'lps'),
	(387338, 125, '2015-02-01 00:21:25.000000', 'consum', 0.0221, 'lps'),
	(387339, 125, '2015-02-01 00:21:26.000000', 'consum', 0.0227, 'lps'),
	(387340, 125, '2015-02-01 00:21:27.000000', 'consum', 0.0211, 'lps'),
	(387341, 125, '2015-02-01 00:21:28.000000', 'consum', 0.0219, 'lps'),
	(387342, 125, '2015-02-01 00:21:29.000000', 'consum', 0.0227, 'lps'),
	(387343, 125, '2015-02-01 00:21:30.000000', 'consum', 0.0211, 'lps'),
	(387344, 125, '2015-02-01 00:21:31.000000', 'consum', 0.0220, 'lps'),
	(387345, 125, '2015-02-01 00:21:32.000000', 'consum', 0.0232, 'lps'),
	(387346, 125, '2015-02-01 00:21:33.000000', 'consum', 0.0233, 'lps'),
	(387347, 125, '2015-02-01 00:21:34.000000', 'consum', 0.0236, 'lps'),
	(387348, 125, '2015-02-01 00:21:35.000000', 'consum', 0.0216, 'lps'),
	(387349, 125, '2015-02-01 00:21:36.000000', 'consum', 0.0215, 'lps'),
	(387350, 125, '2015-02-01 00:21:37.000000', 'consum', 0.0221, 'lps'),
	(387351, 125, '2015-02-01 00:21:38.000000', 'consum', 0.0221, 'lps'),
	(387352, 125, '2015-02-01 00:21:39.000000', 'consum', 0.0232, 'lps'),
	(387353, 125, '2015-02-01 00:21:40.000000', 'consum', 0.0233, 'lps'),
	(387354, 125, '2015-02-01 00:21:41.000000', 'consum', 0.0234, 'lps'),
	(387355, 125, '2015-02-01 00:21:42.000000', 'consum', 0.0235, 'lps'),
	(387356, 125, '2015-02-01 00:21:43.000000', 'consum', 0.0210, 'lps'),
	(387357, 125, '2015-02-01 00:21:44.000000', 'consum', 0.0214, 'lps'),
	(387358, 125, '2015-02-01 00:21:45.000000', 'consum', 0.0230, 'lps'),
	(387359, 125, '2015-02-01 00:21:46.000000', 'consum', 0.0219, 'lps'),
	(387360, 125, '2015-02-01 00:21:47.000000', 'consum', 0.0224, 'lps'),
	(387361, 125, '2015-02-01 00:21:48.000000', 'consum', 0.0224, 'lps'),
	(387362, 125, '2015-02-01 00:21:49.000000', 'consum', 0.0212, 'lps'),
	(387363, 125, '2015-02-01 00:21:50.000000', 'consum', 0.0231, 'lps'),
	(387364, 125, '2015-02-01 00:21:51.000000', 'consum', 0.0230, 'lps'),
	(387365, 125, '2015-02-01 00:21:52.000000', 'consum', 0.0220, 'lps'),
	(387366, 125, '2015-02-01 00:21:53.000000', 'consum', 0.0227, 'lps'),
	(387367, 125, '2015-02-01 00:21:54.000000', 'consum', 0.0211, 'lps'),
	(387368, 125, '2015-02-01 00:21:55.000000', 'consum', 0.0218, 'lps'),
	(387369, 125, '2015-02-01 00:21:56.000000', 'consum', 0.0223, 'lps'),
	(387370, 125, '2015-02-01 00:21:57.000000', 'consum', 0.0223, 'lps'),
	(387371, 125, '2015-02-01 00:21:58.000000', 'consum', 0.0211, 'lps'),
	(387372, 125, '2015-02-01 00:21:59.000000', 'consum', 0.0230, 'lps'),
	(387373, 125, '2015-02-01 00:22:00.000000', 'consum', 0.0225, 'lps'),
	(387374, 125, '2015-02-01 00:22:01.000000', 'consum', 0.0226, 'lps'),
	(387375, 125, '2015-02-01 00:22:02.000000', 'consum', 0.0220, 'lps'),
	(387376, 125, '2015-02-01 00:22:03.000000', 'consum', 0.0212, 'lps'),
	(387377, 125, '2015-02-01 00:22:04.000000', 'consum', 0.0216, 'lps'),
	(387378, 125, '2015-02-01 00:22:05.000000', 'consum', 0.0234, 'lps'),
	(387379, 125, '2015-02-01 00:22:06.000000', 'consum', 0.0233, 'lps'),
	(387380, 125, '2015-02-01 00:22:07.000000', 'consum', 0.0227, 'lps'),
	(387381, 125, '2015-02-01 00:22:08.000000', 'consum', 0.0227, 'lps'),
	(387382, 125, '2015-02-01 00:22:09.000000', 'consum', 0.0218, 'lps'),
	(387383, 125, '2015-02-01 00:22:10.000000', 'consum', 0.0226, 'lps'),
	(387384, 125, '2015-02-01 00:22:11.000000', 'consum', 0.0213, 'lps'),
	(387385, 125, '2015-02-01 00:22:12.000000', 'consum', 0.0232, 'lps'),
	(387386, 125, '2015-02-01 00:22:13.000000', 'consum', 0.0228, 'lps'),
	(387387, 125, '2015-02-01 00:22:14.000000', 'consum', 0.0236, 'lps'),
	(387388, 125, '2015-02-01 00:22:15.000000', 'consum', 0.0233, 'lps'),
	(387389, 125, '2015-02-01 00:22:16.000000', 'consum', 0.0222, 'lps'),
	(387390, 125, '2015-02-01 00:22:17.000000', 'consum', 0.0225, 'lps'),
	(387391, 125, '2015-02-01 00:22:18.000000', 'consum', 0.0224, 'lps'),
	(387392, 125, '2015-02-01 00:22:19.000000', 'consum', 0.0210, 'lps'),
	(387393, 125, '2015-02-01 00:22:20.000000', 'consum', 0.0220, 'lps'),
	(387394, 125, '2015-02-01 00:22:21.000000', 'consum', 0.0234, 'lps'),
	(387395, 125, '2015-02-01 00:22:22.000000', 'consum', 0.0222, 'lps'),
	(387396, 125, '2015-02-01 00:22:23.000000', 'consum', 0.0223, 'lps'),
	(387397, 125, '2015-02-01 00:22:24.000000', 'consum', 0.0212, 'lps'),
	(387398, 125, '2015-02-01 00:22:25.000000', 'consum', 0.0235, 'lps'),
	(387399, 125, '2015-02-01 00:22:26.000000', 'consum', 0.0224, 'lps'),
	(387400, 125, '2015-02-01 00:22:27.000000', 'consum', 0.0230, 'lps'),
	(387401, 125, '2015-02-01 00:22:28.000000', 'consum', 0.0214, 'lps'),
	(387402, 125, '2015-02-01 00:22:29.000000', 'consum', 0.0227, 'lps'),
	(387403, 125, '2015-02-01 00:22:30.000000', 'consum', 0.0230, 'lps'),
	(387404, 125, '2015-02-01 00:22:31.000000', 'consum', 0.0231, 'lps'),
	(387405, 125, '2015-02-01 00:22:32.000000', 'consum', 0.0228, 'lps'),
	(387406, 125, '2015-02-01 00:22:33.000000', 'consum', 0.0213, 'lps'),
	(387407, 125, '2015-02-01 00:22:34.000000', 'consum', 0.0225, 'lps'),
	(387408, 125, '2015-02-01 00:22:35.000000', 'consum', 0.0220, 'lps'),
	(387409, 125, '2015-02-01 00:22:36.000000', 'consum', 0.0217, 'lps'),
	(387410, 125, '2015-02-01 00:22:37.000000', 'consum', 0.0215, 'lps'),
	(387411, 125, '2015-02-01 00:22:38.000000', 'consum', 0.0214, 'lps'),
	(387412, 125, '2015-02-01 00:22:39.000000', 'consum', 0.0216, 'lps'),
	(387413, 125, '2015-02-01 00:22:40.000000', 'consum', 0.0227, 'lps'),
	(387414, 125, '2015-02-01 00:22:41.000000', 'consum', 0.0226, 'lps'),
	(387415, 125, '2015-02-01 00:22:42.000000', 'consum', 0.0212, 'lps'),
	(387416, 125, '2015-02-01 00:22:43.000000', 'consum', 0.0227, 'lps'),
	(387417, 125, '2015-02-01 00:22:44.000000', 'consum', 0.0235, 'lps'),
	(387418, 125, '2015-02-01 00:22:45.000000', 'consum', 0.0231, 'lps'),
	(387419, 125, '2015-02-01 00:22:46.000000', 'consum', 0.0211, 'lps'),
	(387420, 125, '2015-02-01 00:22:47.000000', 'consum', 0.0235, 'lps'),
	(387421, 125, '2015-02-01 00:22:48.000000', 'consum', 0.0224, 'lps'),
	(387422, 125, '2015-02-01 00:22:49.000000', 'consum', 0.0233, 'lps'),
	(387423, 125, '2015-02-01 00:22:50.000000', 'consum', 0.0228, 'lps'),
	(387424, 125, '2015-02-01 00:22:51.000000', 'consum', 0.0231, 'lps'),
	(387425, 125, '2015-02-01 00:22:52.000000', 'consum', 0.0234, 'lps'),
	(387426, 125, '2015-02-01 00:22:53.000000', 'consum', 0.0213, 'lps'),
	(387427, 125, '2015-02-01 00:22:54.000000', 'consum', 0.0235, 'lps'),
	(387428, 125, '2015-02-01 00:22:55.000000', 'consum', 0.0219, 'lps'),
	(387429, 125, '2015-02-01 00:22:56.000000', 'consum', 0.0234, 'lps'),
	(387430, 125, '2015-02-01 00:22:57.000000', 'consum', 0.0223, 'lps'),
	(387431, 125, '2015-02-01 00:22:58.000000', 'consum', 0.0230, 'lps'),
	(387432, 125, '2015-02-01 00:22:59.000000', 'consum', 0.0217, 'lps'),
	(387433, 125, '2015-02-01 00:23:00.000000', 'consum', 0.0213, 'lps'),
	(387434, 125, '2015-02-01 00:23:01.000000', 'consum', 0.0231, 'lps'),
	(387435, 125, '2015-02-01 00:23:02.000000', 'consum', 0.0227, 'lps'),
	(387436, 125, '2015-02-01 00:23:03.000000', 'consum', 0.0233, 'lps'),
	(387437, 125, '2015-02-01 00:23:04.000000', 'consum', 0.0219, 'lps'),
	(387438, 125, '2015-02-01 00:23:05.000000', 'consum', 0.0216, 'lps'),
	(387439, 125, '2015-02-01 00:23:06.000000', 'consum', 0.0212, 'lps'),
	(387440, 125, '2015-02-01 00:23:07.000000', 'consum', 0.0227, 'lps'),
	(387441, 125, '2015-02-01 00:23:08.000000', 'consum', 0.0212, 'lps'),
	(387442, 125, '2015-02-01 00:23:09.000000', 'consum', 0.0222, 'lps'),
	(387443, 125, '2015-02-01 00:23:10.000000', 'consum', 0.0212, 'lps'),
	(387444, 125, '2015-02-01 00:23:11.000000', 'consum', 0.0236, 'lps'),
	(387445, 125, '2015-02-01 00:23:12.000000', 'consum', 0.0227, 'lps'),
	(387446, 125, '2015-02-01 00:23:13.000000', 'consum', 0.0218, 'lps'),
	(387447, 125, '2015-02-01 00:23:14.000000', 'consum', 0.0226, 'lps'),
	(387448, 125, '2015-02-01 00:23:15.000000', 'consum', 0.0213, 'lps'),
	(387449, 125, '2015-02-01 00:23:16.000000', 'consum', 0.0231, 'lps'),
	(387450, 125, '2015-02-01 00:23:17.000000', 'consum', 0.0224, 'lps'),
	(387451, 125, '2015-02-01 00:23:18.000000', 'consum', 0.0218, 'lps'),
	(387452, 125, '2015-02-01 00:23:19.000000', 'consum', 0.0210, 'lps'),
	(387453, 125, '2015-02-01 00:23:20.000000', 'consum', 0.0214, 'lps'),
	(387454, 125, '2015-02-01 00:23:21.000000', 'consum', 0.0229, 'lps'),
	(387455, 125, '2015-02-01 00:23:22.000000', 'consum', 0.0213, 'lps'),
	(387456, 125, '2015-02-01 00:23:23.000000', 'consum', 0.0223, 'lps'),
	(387457, 125, '2015-02-01 00:23:24.000000', 'consum', 0.0213, 'lps'),
	(387458, 125, '2015-02-01 00:23:25.000000', 'consum', 0.0213, 'lps'),
	(387459, 125, '2015-02-01 00:23:26.000000', 'consum', 0.0217, 'lps'),
	(387460, 125, '2015-02-01 00:23:27.000000', 'consum', 0.0235, 'lps'),
	(387461, 125, '2015-02-01 00:23:28.000000', 'consum', 0.0233, 'lps'),
	(387462, 125, '2015-02-01 00:23:29.000000', 'consum', 0.0224, 'lps'),
	(387463, 125, '2015-02-01 00:23:30.000000', 'consum', 0.0213, 'lps'),
	(387464, 125, '2015-02-01 00:23:31.000000', 'consum', 0.0236, 'lps'),
	(387465, 125, '2015-02-01 00:23:32.000000', 'consum', 0.0225, 'lps'),
	(387466, 125, '2015-02-01 00:23:33.000000', 'consum', 0.0235, 'lps'),
	(387467, 125, '2015-02-01 00:23:34.000000', 'consum', 0.0210, 'lps'),
	(387468, 125, '2015-02-01 00:23:35.000000', 'consum', 0.0216, 'lps'),
	(387469, 125, '2015-02-01 00:23:36.000000', 'consum', 0.0213, 'lps'),
	(387470, 125, '2015-02-01 00:23:37.000000', 'consum', 0.0233, 'lps'),
	(387471, 125, '2015-02-01 00:23:38.000000', 'consum', 0.0236, 'lps'),
	(387472, 125, '2015-02-01 00:23:39.000000', 'consum', 0.0219, 'lps'),
	(387473, 125, '2015-02-01 00:23:40.000000', 'consum', 0.0230, 'lps'),
	(387474, 125, '2015-02-01 00:23:41.000000', 'consum', 0.0231, 'lps'),
	(387475, 125, '2015-02-01 00:23:42.000000', 'consum', 0.0226, 'lps'),
	(387476, 125, '2015-02-01 00:23:43.000000', 'consum', 0.0230, 'lps'),
	(387477, 125, '2015-02-01 00:23:44.000000', 'consum', 0.0233, 'lps'),
	(387478, 125, '2015-02-01 00:23:45.000000', 'consum', 0.0214, 'lps'),
	(387479, 125, '2015-02-01 00:23:46.000000', 'consum', 0.0213, 'lps'),
	(387480, 125, '2015-02-01 00:23:47.000000', 'consum', 0.0213, 'lps'),
	(387481, 125, '2015-02-01 00:23:48.000000', 'consum', 0.0216, 'lps'),
	(387482, 125, '2015-02-01 00:23:49.000000', 'consum', 0.0232, 'lps'),
	(387483, 125, '2015-02-01 00:23:50.000000', 'consum', 0.0220, 'lps'),
	(387484, 125, '2015-02-01 00:23:51.000000', 'consum', 0.0223, 'lps'),
	(387485, 125, '2015-02-01 00:23:52.000000', 'consum', 0.0218, 'lps'),
	(387486, 125, '2015-02-01 00:23:53.000000', 'consum', 0.0214, 'lps'),
	(387487, 125, '2015-02-01 00:23:54.000000', 'consum', 0.0230, 'lps'),
	(387488, 125, '2015-02-01 00:23:55.000000', 'consum', 0.0219, 'lps'),
	(387489, 125, '2015-02-01 00:23:56.000000', 'consum', 0.0223, 'lps'),
	(387490, 125, '2015-02-01 00:23:57.000000', 'consum', 0.0223, 'lps'),
	(387491, 125, '2015-02-01 00:23:58.000000', 'consum', 0.0234, 'lps'),
	(387492, 125, '2015-02-01 00:23:59.000000', 'consum', 0.0213, 'lps'),
	(387493, 125, '2015-02-01 00:24:00.000000', 'consum', 0.0233, 'lps'),
	(387494, 125, '2015-02-01 00:24:01.000000', 'consum', 0.0235, 'lps'),
	(387495, 125, '2015-02-01 00:24:02.000000', 'consum', 0.0214, 'lps'),
	(387496, 125, '2015-02-01 00:24:03.000000', 'consum', 0.0211, 'lps'),
	(387497, 125, '2015-02-01 00:24:04.000000', 'consum', 0.0228, 'lps'),
	(387498, 125, '2015-02-01 00:24:05.000000', 'consum', 0.0219, 'lps'),
	(387499, 125, '2015-02-01 00:24:06.000000', 'consum', 0.0228, 'lps'),
	(387500, 125, '2015-02-01 00:24:07.000000', 'consum', 0.0220, 'lps'),
	(387501, 125, '2015-02-01 00:24:08.000000', 'consum', 0.0233, 'lps'),
	(387502, 125, '2015-02-01 00:24:09.000000', 'consum', 0.0213, 'lps'),
	(387503, 125, '2015-02-01 00:24:10.000000', 'consum', 0.0236, 'lps'),
	(387504, 125, '2015-02-01 00:24:11.000000', 'consum', 0.0227, 'lps'),
	(387505, 125, '2015-02-01 00:24:12.000000', 'consum', 0.0215, 'lps'),
	(387506, 125, '2015-02-01 00:24:13.000000', 'consum', 0.0214, 'lps'),
	(387507, 125, '2015-02-01 00:24:14.000000', 'consum', 0.0213, 'lps'),
	(387508, 125, '2015-02-01 00:24:15.000000', 'consum', 0.0215, 'lps'),
	(387509, 125, '2015-02-01 00:24:16.000000', 'consum', 0.0228, 'lps'),
	(387510, 125, '2015-02-01 00:24:17.000000', 'consum', 0.0228, 'lps'),
	(387511, 125, '2015-02-01 00:24:18.000000', 'consum', 0.0223, 'lps'),
	(387512, 125, '2015-02-01 00:24:19.000000', 'consum', 0.0220, 'lps'),
	(387513, 125, '2015-02-01 00:24:20.000000', 'consum', 0.0220, 'lps'),
	(387514, 125, '2015-02-01 00:24:21.000000', 'consum', 0.0230, 'lps'),
	(387515, 125, '2015-02-01 00:24:22.000000', 'consum', 0.0227, 'lps'),
	(387516, 125, '2015-02-01 00:24:23.000000', 'consum', 0.0211, 'lps'),
	(387517, 125, '2015-02-01 00:24:24.000000', 'consum', 0.0216, 'lps'),
	(387518, 125, '2015-02-01 00:24:25.000000', 'consum', 0.0236, 'lps'),
	(387519, 125, '2015-02-01 00:24:26.000000', 'consum', 0.0217, 'lps'),
	(387520, 125, '2015-02-01 00:24:27.000000', 'consum', 0.0219, 'lps'),
	(387521, 125, '2015-02-01 00:24:28.000000', 'consum', 0.0235, 'lps'),
	(387522, 125, '2015-02-01 00:24:29.000000', 'consum', 0.0229, 'lps'),
	(387523, 125, '2015-02-01 00:24:30.000000', 'consum', 0.0230, 'lps'),
	(387524, 125, '2015-02-01 00:24:31.000000', 'consum', 0.0228, 'lps'),
	(387525, 125, '2015-02-01 00:24:32.000000', 'consum', 0.0213, 'lps'),
	(387526, 125, '2015-02-01 00:24:33.000000', 'consum', 0.0224, 'lps'),
	(387527, 125, '2015-02-01 00:24:34.000000', 'consum', 0.0218, 'lps'),
	(387528, 125, '2015-02-01 00:24:35.000000', 'consum', 0.0235, 'lps'),
	(387529, 125, '2015-02-01 00:24:36.000000', 'consum', 0.0231, 'lps'),
	(387530, 125, '2015-02-01 00:24:37.000000', 'consum', 0.0215, 'lps'),
	(387531, 125, '2015-02-01 00:24:38.000000', 'consum', 0.0227, 'lps'),
	(387532, 125, '2015-02-01 00:24:39.000000', 'consum', 0.0226, 'lps'),
	(387533, 125, '2015-02-01 00:24:40.000000', 'consum', 0.0210, 'lps'),
	(387534, 125, '2015-02-01 00:24:41.000000', 'consum', 0.0219, 'lps'),
	(387535, 125, '2015-02-01 00:24:42.000000', 'consum', 0.0226, 'lps'),
	(387536, 125, '2015-02-01 00:24:43.000000', 'consum', 0.0212, 'lps'),
	(387537, 125, '2015-02-01 00:24:44.000000', 'consum', 0.0225, 'lps'),
	(387538, 125, '2015-02-01 00:24:45.000000', 'consum', 0.0224, 'lps'),
	(387539, 125, '2015-02-01 00:24:46.000000', 'consum', 0.0211, 'lps'),
	(387540, 125, '2015-02-01 00:24:47.000000', 'consum', 0.0227, 'lps'),
	(387541, 125, '2015-02-01 00:24:48.000000', 'consum', 0.0210, 'lps'),
	(387542, 125, '2015-02-01 00:24:49.000000', 'consum', 0.0213, 'lps'),
	(387543, 125, '2015-02-01 00:24:50.000000', 'consum', 0.0227, 'lps'),
	(387544, 125, '2015-02-01 00:24:51.000000', 'consum', 0.0233, 'lps'),
	(387545, 125, '2015-02-01 00:24:52.000000', 'consum', 0.0219, 'lps'),
	(387546, 125, '2015-02-01 00:24:53.000000', 'consum', 0.0213, 'lps'),
	(387547, 125, '2015-02-01 00:24:54.000000', 'consum', 0.0225, 'lps'),
	(387548, 125, '2015-02-01 00:24:55.000000', 'consum', 0.0223, 'lps'),
	(387549, 125, '2015-02-01 00:24:56.000000', 'consum', 0.0232, 'lps'),
	(387550, 125, '2015-02-01 00:24:57.000000', 'consum', 0.0225, 'lps'),
	(387551, 125, '2015-02-01 00:24:58.000000', 'consum', 0.0219, 'lps'),
	(387552, 125, '2015-02-01 00:24:59.000000', 'consum', 0.0211, 'lps'),
	(387553, 125, '2015-02-01 00:25:00.000000', 'consum', 0.0216, 'lps'),
	(387554, 125, '2015-02-01 00:25:01.000000', 'consum', 0.0210, 'lps'),
	(387555, 125, '2015-02-01 00:25:02.000000', 'consum', 0.0220, 'lps'),
	(387556, 125, '2015-02-01 00:25:03.000000', 'consum', 0.0235, 'lps'),
	(387557, 125, '2015-02-01 00:25:04.000000', 'consum', 0.0225, 'lps'),
	(387558, 125, '2015-02-01 00:25:05.000000', 'consum', 0.0211, 'lps'),
	(387559, 125, '2015-02-01 00:25:06.000000', 'consum', 0.0223, 'lps'),
	(387560, 125, '2015-02-01 00:25:07.000000', 'consum', 0.0221, 'lps'),
	(387561, 125, '2015-02-01 00:25:08.000000', 'consum', 0.0224, 'lps'),
	(387562, 125, '2015-02-01 00:25:09.000000', 'consum', 0.0223, 'lps'),
	(387563, 125, '2015-02-01 00:25:10.000000', 'consum', 0.0231, 'lps'),
	(387564, 125, '2015-02-01 00:25:11.000000', 'consum', 0.0225, 'lps'),
	(387565, 125, '2015-02-01 00:25:12.000000', 'consum', 0.0222, 'lps'),
	(387566, 125, '2015-02-01 00:25:13.000000', 'consum', 0.0223, 'lps'),
	(387567, 125, '2015-02-01 00:25:14.000000', 'consum', 0.0215, 'lps'),
	(387568, 125, '2015-02-01 00:25:15.000000', 'consum', 0.0222, 'lps'),
	(387569, 125, '2015-02-01 00:25:16.000000', 'consum', 0.0227, 'lps'),
	(387570, 125, '2015-02-01 00:25:17.000000', 'consum', 0.0234, 'lps'),
	(387571, 125, '2015-02-01 00:25:18.000000', 'consum', 0.0226, 'lps'),
	(387572, 125, '2015-02-01 00:25:19.000000', 'consum', 0.0220, 'lps'),
	(387573, 125, '2015-02-01 00:25:20.000000', 'consum', 0.0210, 'lps'),
	(387574, 125, '2015-02-01 00:25:21.000000', 'consum', 0.0236, 'lps'),
	(387575, 125, '2015-02-01 00:25:22.000000', 'consum', 0.0231, 'lps'),
	(387576, 125, '2015-02-01 00:25:23.000000', 'consum', 0.0211, 'lps'),
	(387577, 125, '2015-02-01 00:25:24.000000', 'consum', 0.0232, 'lps'),
	(387578, 125, '2015-02-01 00:25:25.000000', 'consum', 0.0236, 'lps'),
	(387579, 125, '2015-02-01 00:25:26.000000', 'consum', 0.0222, 'lps'),
	(387580, 125, '2015-02-01 00:25:27.000000', 'consum', 0.0221, 'lps'),
	(387581, 125, '2015-02-01 00:25:28.000000', 'consum', 0.0228, 'lps'),
	(387582, 125, '2015-02-01 00:25:29.000000', 'consum', 0.0214, 'lps'),
	(387583, 125, '2015-02-01 00:25:30.000000', 'consum', 0.0232, 'lps'),
	(387584, 125, '2015-02-01 00:25:31.000000', 'consum', 0.0227, 'lps'),
	(387585, 125, '2015-02-01 00:25:32.000000', 'consum', 0.0229, 'lps'),
	(387586, 125, '2015-02-01 00:25:33.000000', 'consum', 0.0229, 'lps'),
	(387587, 125, '2015-02-01 00:25:34.000000', 'consum', 0.0221, 'lps'),
	(387588, 125, '2015-02-01 00:25:35.000000', 'consum', 0.0234, 'lps'),
	(387589, 125, '2015-02-01 00:25:36.000000', 'consum', 0.0218, 'lps'),
	(387590, 125, '2015-02-01 00:25:37.000000', 'consum', 0.0232, 'lps'),
	(387591, 125, '2015-02-01 00:25:38.000000', 'consum', 0.0217, 'lps'),
	(387592, 125, '2015-02-01 00:25:39.000000', 'consum', 0.0231, 'lps'),
	(387593, 125, '2015-02-01 00:25:40.000000', 'consum', 0.0214, 'lps'),
	(387594, 125, '2015-02-01 00:25:41.000000', 'consum', 0.0223, 'lps'),
	(387595, 125, '2015-02-01 00:25:42.000000', 'consum', 0.0235, 'lps'),
	(387596, 125, '2015-02-01 00:25:43.000000', 'consum', 0.0214, 'lps'),
	(387597, 125, '2015-02-01 00:25:44.000000', 'consum', 0.0213, 'lps'),
	(387598, 125, '2015-02-01 00:25:45.000000', 'consum', 0.0211, 'lps'),
	(387599, 125, '2015-02-01 00:25:46.000000', 'consum', 0.0235, 'lps'),
	(387600, 125, '2015-02-01 00:25:47.000000', 'consum', 0.0223, 'lps'),
	(387601, 125, '2015-02-01 00:25:48.000000', 'consum', 0.0229, 'lps'),
	(387602, 125, '2015-02-01 00:25:49.000000', 'consum', 0.0213, 'lps'),
	(387603, 125, '2015-02-01 00:25:50.000000', 'consum', 0.0223, 'lps'),
	(387604, 125, '2015-02-01 00:25:51.000000', 'consum', 0.0212, 'lps'),
	(387605, 125, '2015-02-01 00:25:52.000000', 'consum', 0.0234, 'lps'),
	(387606, 125, '2015-02-01 00:25:53.000000', 'consum', 0.0218, 'lps'),
	(387607, 125, '2015-02-01 00:25:54.000000', 'consum', 0.0233, 'lps'),
	(387608, 125, '2015-02-01 00:25:55.000000', 'consum', 0.0219, 'lps'),
	(387609, 125, '2015-02-01 00:25:56.000000', 'consum', 0.0216, 'lps'),
	(387610, 125, '2015-02-01 00:25:57.000000', 'consum', 0.0213, 'lps'),
	(387611, 125, '2015-02-01 00:25:58.000000', 'consum', 0.0234, 'lps'),
	(387612, 125, '2015-02-01 00:25:59.000000', 'consum', 0.0215, 'lps'),
	(387613, 125, '2015-02-01 00:26:00.000000', 'consum', 0.0217, 'lps'),
	(387614, 125, '2015-02-01 00:26:01.000000', 'consum', 0.0229, 'lps'),
	(387615, 125, '2015-02-01 00:26:02.000000', 'consum', 0.0231, 'lps'),
	(387616, 125, '2015-02-01 00:26:03.000000', 'consum', 0.0230, 'lps'),
	(387617, 125, '2015-02-01 00:26:04.000000', 'consum', 0.0221, 'lps'),
	(387618, 125, '2015-02-01 00:26:05.000000', 'consum', 0.0234, 'lps'),
	(387619, 125, '2015-02-01 00:26:06.000000', 'consum', 0.0217, 'lps'),
	(387620, 125, '2015-02-01 00:26:07.000000', 'consum', 0.0229, 'lps'),
	(387621, 125, '2015-02-01 00:26:08.000000', 'consum', 0.0227, 'lps'),
	(387622, 125, '2015-02-01 00:26:09.000000', 'consum', 0.0214, 'lps'),
	(387623, 125, '2015-02-01 00:26:10.000000', 'consum', 0.0233, 'lps'),
	(387624, 125, '2015-02-01 00:26:11.000000', 'consum', 0.0233, 'lps'),
	(387625, 125, '2015-02-01 00:26:12.000000', 'consum', 0.0227, 'lps'),
	(387626, 125, '2015-02-01 00:26:13.000000', 'consum', 0.0228, 'lps'),
	(387627, 125, '2015-02-01 00:26:14.000000', 'consum', 0.0221, 'lps'),
	(387628, 125, '2015-02-01 00:26:15.000000', 'consum', 0.0213, 'lps'),
	(387629, 125, '2015-02-01 00:26:16.000000', 'consum', 0.0220, 'lps'),
	(387630, 125, '2015-02-01 00:26:17.000000', 'consum', 0.0224, 'lps'),
	(387631, 125, '2015-02-01 00:26:18.000000', 'consum', 0.0222, 'lps'),
	(387632, 125, '2015-02-01 00:26:19.000000', 'consum', 0.0230, 'lps'),
	(387633, 125, '2015-02-01 00:26:20.000000', 'consum', 0.0219, 'lps'),
	(387634, 125, '2015-02-01 00:26:21.000000', 'consum', 0.0225, 'lps'),
	(387635, 125, '2015-02-01 00:26:22.000000', 'consum', 0.0231, 'lps'),
	(387636, 125, '2015-02-01 00:26:23.000000', 'consum', 0.0214, 'lps'),
	(387637, 125, '2015-02-01 00:26:24.000000', 'consum', 0.0222, 'lps'),
	(387638, 125, '2015-02-01 00:26:25.000000', 'consum', 0.0234, 'lps'),
	(387639, 125, '2015-02-01 00:26:26.000000', 'consum', 0.0213, 'lps'),
	(387640, 125, '2015-02-01 00:26:27.000000', 'consum', 0.0233, 'lps'),
	(387641, 125, '2015-02-01 00:26:28.000000', 'consum', 0.0210, 'lps'),
	(387642, 125, '2015-02-01 00:26:29.000000', 'consum', 0.0220, 'lps'),
	(387643, 125, '2015-02-01 00:26:30.000000', 'consum', 0.0236, 'lps'),
	(387644, 125, '2015-02-01 00:26:31.000000', 'consum', 0.0227, 'lps'),
	(387645, 125, '2015-02-01 00:26:32.000000', 'consum', 0.0218, 'lps'),
	(387646, 125, '2015-02-01 00:26:33.000000', 'consum', 0.0225, 'lps'),
	(387647, 125, '2015-02-01 00:26:34.000000', 'consum', 0.0211, 'lps'),
	(387648, 125, '2015-02-01 00:26:35.000000', 'consum', 0.0222, 'lps'),
	(387649, 125, '2015-02-01 00:26:36.000000', 'consum', 0.0212, 'lps'),
	(387650, 125, '2015-02-01 00:26:37.000000', 'consum', 0.0214, 'lps'),
	(387651, 125, '2015-02-01 00:26:38.000000', 'consum', 0.0226, 'lps'),
	(387652, 125, '2015-02-01 00:26:39.000000', 'consum', 0.0221, 'lps'),
	(387653, 125, '2015-02-01 00:26:40.000000', 'consum', 0.0220, 'lps'),
	(387654, 125, '2015-02-01 00:26:41.000000', 'consum', 0.0226, 'lps'),
	(387655, 125, '2015-02-01 00:26:42.000000', 'consum', 0.0235, 'lps'),
	(387656, 125, '2015-02-01 00:26:43.000000', 'consum', 0.0233, 'lps'),
	(387657, 125, '2015-02-01 00:26:44.000000', 'consum', 0.0222, 'lps'),
	(387658, 125, '2015-02-01 00:26:45.000000', 'consum', 0.0228, 'lps'),
	(387659, 125, '2015-02-01 00:26:46.000000', 'consum', 0.0213, 'lps'),
	(387660, 125, '2015-02-01 00:26:47.000000', 'consum', 0.0225, 'lps'),
	(387661, 125, '2015-02-01 00:26:48.000000', 'consum', 0.0221, 'lps'),
	(387662, 125, '2015-02-01 00:26:49.000000', 'consum', 0.0223, 'lps'),
	(387663, 125, '2015-02-01 00:26:50.000000', 'consum', 0.0215, 'lps'),
	(387664, 125, '2015-02-01 00:26:51.000000', 'consum', 0.0223, 'lps'),
	(387665, 125, '2015-02-01 00:26:52.000000', 'consum', 0.0235, 'lps'),
	(387666, 125, '2015-02-01 00:26:53.000000', 'consum', 0.0215, 'lps'),
	(387667, 125, '2015-02-01 00:26:54.000000', 'consum', 0.0216, 'lps'),
	(387668, 125, '2015-02-01 00:26:55.000000', 'consum', 0.0223, 'lps'),
	(387669, 125, '2015-02-01 00:26:56.000000', 'consum', 0.0232, 'lps'),
	(387670, 125, '2015-02-01 00:26:57.000000', 'consum', 0.0226, 'lps'),
	(387671, 125, '2015-02-01 00:26:58.000000', 'consum', 0.0225, 'lps'),
	(387672, 125, '2015-02-01 00:26:59.000000', 'consum', 0.0212, 'lps'),
	(387673, 125, '2015-02-01 00:27:00.000000', 'consum', 0.0229, 'lps'),
	(387674, 125, '2015-02-01 00:27:01.000000', 'consum', 0.0218, 'lps'),
	(387675, 125, '2015-02-01 00:27:02.000000', 'consum', 0.0221, 'lps'),
	(387676, 125, '2015-02-01 00:27:03.000000', 'consum', 0.0215, 'lps'),
	(387677, 125, '2015-02-01 00:27:04.000000', 'consum', 0.0230, 'lps'),
	(387678, 125, '2015-02-01 00:27:05.000000', 'consum', 0.0215, 'lps'),
	(387679, 125, '2015-02-01 00:27:06.000000', 'consum', 0.0230, 'lps'),
	(387680, 125, '2015-02-01 00:27:07.000000', 'consum', 0.0213, 'lps'),
	(387681, 125, '2015-02-01 00:27:08.000000', 'consum', 0.0221, 'lps'),
	(387682, 125, '2015-02-01 00:27:09.000000', 'consum', 0.0230, 'lps'),
	(387683, 125, '2015-02-01 00:27:10.000000', 'consum', 0.0221, 'lps'),
	(387684, 125, '2015-02-01 00:27:11.000000', 'consum', 0.0233, 'lps'),
	(387685, 125, '2015-02-01 00:27:12.000000', 'consum', 0.0211, 'lps'),
	(387686, 125, '2015-02-01 00:27:13.000000', 'consum', 0.0230, 'lps'),
	(387687, 125, '2015-02-01 00:27:14.000000', 'consum', 0.0224, 'lps'),
	(387688, 125, '2015-02-01 00:27:15.000000', 'consum', 0.0220, 'lps'),
	(387689, 125, '2015-02-01 00:27:16.000000', 'consum', 0.0220, 'lps'),
	(387690, 125, '2015-02-01 00:27:17.000000', 'consum', 0.0232, 'lps'),
	(387691, 125, '2015-02-01 00:27:18.000000', 'consum', 0.0234, 'lps'),
	(387692, 125, '2015-02-01 00:27:19.000000', 'consum', 0.0213, 'lps'),
	(387693, 125, '2015-02-01 00:27:20.000000', 'consum', 0.0233, 'lps'),
	(387694, 125, '2015-02-01 00:27:21.000000', 'consum', 0.0235, 'lps'),
	(387695, 125, '2015-02-01 00:27:22.000000', 'consum', 0.0211, 'lps'),
	(387696, 125, '2015-02-01 00:27:23.000000', 'consum', 0.0224, 'lps'),
	(387697, 125, '2015-02-01 00:27:24.000000', 'consum', 0.0221, 'lps'),
	(387698, 125, '2015-02-01 00:27:25.000000', 'consum', 0.0225, 'lps'),
	(387699, 125, '2015-02-01 00:27:26.000000', 'consum', 0.0226, 'lps'),
	(387700, 125, '2015-02-01 00:27:27.000000', 'consum', 0.0217, 'lps'),
	(387701, 125, '2015-02-01 00:27:28.000000', 'consum', 0.0227, 'lps'),
	(387702, 125, '2015-02-01 00:27:29.000000', 'consum', 0.0217, 'lps'),
	(387703, 125, '2015-02-01 00:27:30.000000', 'consum', 0.0225, 'lps'),
	(387704, 125, '2015-02-01 00:27:31.000000', 'consum', 0.0234, 'lps'),
	(387705, 125, '2015-02-01 00:27:32.000000', 'consum', 0.0234, 'lps'),
	(387706, 125, '2015-02-01 00:27:33.000000', 'consum', 0.0230, 'lps'),
	(387707, 125, '2015-02-01 00:27:34.000000', 'consum', 0.0214, 'lps'),
	(387708, 125, '2015-02-01 00:27:35.000000', 'consum', 0.0223, 'lps'),
	(387709, 125, '2015-02-01 00:27:36.000000', 'consum', 0.0210, 'lps'),
	(387710, 125, '2015-02-01 00:27:37.000000', 'consum', 0.0227, 'lps'),
	(387711, 125, '2015-02-01 00:27:38.000000', 'consum', 0.0214, 'lps'),
	(387712, 125, '2015-02-01 00:27:39.000000', 'consum', 0.0231, 'lps'),
	(387713, 125, '2015-02-01 00:27:40.000000', 'consum', 0.0224, 'lps'),
	(387714, 125, '2015-02-01 00:27:41.000000', 'consum', 0.0218, 'lps'),
	(387715, 125, '2015-02-01 00:27:42.000000', 'consum', 0.0234, 'lps'),
	(387716, 125, '2015-02-01 00:27:43.000000', 'consum', 0.0227, 'lps'),
	(387717, 125, '2015-02-01 00:27:44.000000', 'consum', 0.0222, 'lps'),
	(387718, 125, '2015-02-01 00:27:45.000000', 'consum', 0.0221, 'lps'),
	(387719, 125, '2015-02-01 00:27:46.000000', 'consum', 0.0228, 'lps'),
	(387720, 125, '2015-02-01 00:27:47.000000', 'consum', 0.0216, 'lps'),
	(387721, 125, '2015-02-01 00:27:48.000000', 'consum', 0.0212, 'lps'),
	(387722, 125, '2015-02-01 00:27:49.000000', 'consum', 0.0229, 'lps'),
	(387723, 125, '2015-02-01 00:27:50.000000', 'consum', 0.0220, 'lps'),
	(387724, 125, '2015-02-01 00:27:51.000000', 'consum', 0.0231, 'lps'),
	(387725, 125, '2015-02-01 00:27:52.000000', 'consum', 0.0232, 'lps'),
	(387726, 125, '2015-02-01 00:27:53.000000', 'consum', 0.0229, 'lps'),
	(387727, 125, '2015-02-01 00:27:54.000000', 'consum', 0.0214, 'lps'),
	(387728, 125, '2015-02-01 00:27:55.000000', 'consum', 0.0226, 'lps'),
	(387729, 125, '2015-02-01 00:27:56.000000', 'consum', 0.0225, 'lps'),
	(387730, 125, '2015-02-01 00:27:57.000000', 'consum', 0.0236, 'lps'),
	(387731, 125, '2015-02-01 00:27:58.000000', 'consum', 0.0216, 'lps'),
	(387732, 125, '2015-02-01 00:27:59.000000', 'consum', 0.0216, 'lps'),
	(387733, 125, '2015-02-01 00:28:00.000000', 'consum', 0.0224, 'lps'),
	(387734, 125, '2015-02-01 00:28:01.000000', 'consum', 0.0233, 'lps'),
	(387735, 125, '2015-02-01 00:28:02.000000', 'consum', 0.0231, 'lps'),
	(387736, 125, '2015-02-01 00:28:03.000000', 'consum', 0.0220, 'lps'),
	(387737, 125, '2015-02-01 00:28:04.000000', 'consum', 0.0225, 'lps'),
	(387738, 125, '2015-02-01 00:28:05.000000', 'consum', 0.0229, 'lps'),
	(387739, 125, '2015-02-01 00:28:06.000000', 'consum', 0.0232, 'lps'),
	(387740, 125, '2015-02-01 00:28:07.000000', 'consum', 0.0236, 'lps'),
	(387741, 125, '2015-02-01 00:28:08.000000', 'consum', 0.0220, 'lps'),
	(387742, 125, '2015-02-01 00:28:09.000000', 'consum', 0.0211, 'lps'),
	(387743, 125, '2015-02-01 00:28:10.000000', 'consum', 0.0212, 'lps'),
	(387744, 125, '2015-02-01 00:28:11.000000', 'consum', 0.0219, 'lps'),
	(387745, 125, '2015-02-01 00:28:12.000000', 'consum', 0.0219, 'lps'),
	(387746, 125, '2015-02-01 00:28:13.000000', 'consum', 0.0232, 'lps'),
	(387747, 125, '2015-02-01 00:28:14.000000', 'consum', 0.0211, 'lps'),
	(387748, 125, '2015-02-01 00:28:15.000000', 'consum', 0.0232, 'lps'),
	(387749, 125, '2015-02-01 00:28:16.000000', 'consum', 0.0236, 'lps'),
	(387750, 125, '2015-02-01 00:28:17.000000', 'consum', 0.0220, 'lps'),
	(387751, 125, '2015-02-01 00:28:18.000000', 'consum', 0.0211, 'lps'),
	(387752, 125, '2015-02-01 00:28:19.000000', 'consum', 0.0213, 'lps'),
	(387753, 125, '2015-02-01 00:28:20.000000', 'consum', 0.0222, 'lps'),
	(387754, 125, '2015-02-01 00:28:21.000000', 'consum', 0.0234, 'lps'),
	(387755, 125, '2015-02-01 00:28:22.000000', 'consum', 0.0214, 'lps'),
	(387756, 125, '2015-02-01 00:28:23.000000', 'consum', 0.0214, 'lps'),
	(387757, 125, '2015-02-01 00:28:24.000000', 'consum', 0.0217, 'lps'),
	(387758, 125, '2015-02-01 00:28:25.000000', 'consum', 0.0235, 'lps'),
	(387759, 125, '2015-02-01 00:28:26.000000', 'consum', 0.0233, 'lps'),
	(387760, 125, '2015-02-01 00:28:27.000000', 'consum', 0.0222, 'lps'),
	(387761, 125, '2015-02-01 00:28:28.000000', 'consum', 0.0229, 'lps'),
	(387762, 125, '2015-02-01 00:28:29.000000', 'consum', 0.0215, 'lps'),
	(387763, 125, '2015-02-01 00:28:30.000000', 'consum', 0.0233, 'lps'),
	(387764, 125, '2015-02-01 00:28:31.000000', 'consum', 0.0228, 'lps'),
	(387765, 125, '2015-02-01 00:28:32.000000', 'consum', 0.0231, 'lps'),
	(387766, 125, '2015-02-01 00:28:33.000000', 'consum', 0.0235, 'lps'),
	(387767, 125, '2015-02-01 00:28:34.000000', 'consum', 0.0217, 'lps'),
	(387768, 125, '2015-02-01 00:28:35.000000', 'consum', 0.0228, 'lps'),
	(387769, 125, '2015-02-01 00:28:36.000000', 'consum', 0.0222, 'lps'),
	(387770, 125, '2015-02-01 00:28:37.000000', 'consum', 0.0219, 'lps'),
	(387771, 125, '2015-02-01 00:28:38.000000', 'consum', 0.0217, 'lps'),
	(387772, 125, '2015-02-01 00:28:39.000000', 'consum', 0.0219, 'lps'),
	(387773, 125, '2015-02-01 00:28:40.000000', 'consum', 0.0236, 'lps'),
	(387774, 125, '2015-02-01 00:28:41.000000', 'consum', 0.0231, 'lps'),
	(387775, 125, '2015-02-01 00:28:42.000000', 'consum', 0.0236, 'lps'),
	(387776, 125, '2015-02-01 00:28:43.000000', 'consum', 0.0225, 'lps'),
	(387777, 125, '2015-02-01 00:28:44.000000', 'consum', 0.0236, 'lps'),
	(387778, 125, '2015-02-01 00:28:45.000000', 'consum', 0.0215, 'lps'),
	(387779, 125, '2015-02-01 00:28:46.000000', 'consum', 0.0211, 'lps'),
	(387780, 125, '2015-02-01 00:28:47.000000', 'consum', 0.0226, 'lps'),
	(387781, 125, '2015-02-01 00:28:48.000000', 'consum', 0.0233, 'lps'),
	(387782, 125, '2015-02-01 00:28:49.000000', 'consum', 0.0225, 'lps'),
	(387783, 125, '2015-02-01 00:28:50.000000', 'consum', 0.0217, 'lps'),
	(387784, 125, '2015-02-01 00:28:51.000000', 'consum', 0.0225, 'lps'),
	(387785, 125, '2015-02-01 00:28:52.000000', 'consum', 0.0212, 'lps'),
	(387786, 125, '2015-02-01 00:28:53.000000', 'consum', 0.0231, 'lps'),
	(387787, 125, '2015-02-01 00:28:54.000000', 'consum', 0.0227, 'lps'),
	(387788, 125, '2015-02-01 00:28:55.000000', 'consum', 0.0235, 'lps'),
	(387789, 125, '2015-02-01 00:28:56.000000', 'consum', 0.0227, 'lps'),
	(387790, 125, '2015-02-01 00:28:57.000000', 'consum', 0.0223, 'lps'),
	(387791, 125, '2015-02-01 00:28:58.000000', 'consum', 0.0223, 'lps'),
	(387792, 125, '2015-02-01 00:28:59.000000', 'consum', 0.0211, 'lps'),
	(387793, 125, '2015-02-01 00:29:00.000000', 'consum', 0.0231, 'lps'),
	(387794, 125, '2015-02-01 00:29:01.000000', 'consum', 0.0233, 'lps'),
	(387795, 125, '2015-02-01 00:29:02.000000', 'consum', 0.0233, 'lps'),
	(387796, 125, '2015-02-01 00:29:03.000000', 'consum', 0.0229, 'lps'),
	(387797, 125, '2015-02-01 00:29:04.000000', 'consum', 0.0235, 'lps'),
	(387798, 125, '2015-02-01 00:29:05.000000', 'consum', 0.0227, 'lps'),
	(387799, 125, '2015-02-01 00:29:06.000000', 'consum', 0.0221, 'lps'),
	(387800, 125, '2015-02-01 00:29:07.000000', 'consum', 0.0214, 'lps'),
	(387801, 125, '2015-02-01 00:29:08.000000', 'consum', 0.0225, 'lps'),
	(387802, 125, '2015-02-01 00:29:09.000000', 'consum', 0.0219, 'lps'),
	(387803, 125, '2015-02-01 00:29:10.000000', 'consum', 0.0212, 'lps'),
	(387804, 125, '2015-02-01 00:29:11.000000', 'consum', 0.0218, 'lps'),
	(387805, 125, '2015-02-01 00:29:12.000000', 'consum', 0.0217, 'lps'),
	(387806, 125, '2015-02-01 00:29:13.000000', 'consum', 0.0222, 'lps'),
	(387807, 125, '2015-02-01 00:29:14.000000', 'consum', 0.0223, 'lps'),
	(387808, 125, '2015-02-01 00:29:15.000000', 'consum', 0.0212, 'lps'),
	(387809, 125, '2015-02-01 00:29:16.000000', 'consum', 0.0210, 'lps'),
	(387810, 125, '2015-02-01 00:29:17.000000', 'consum', 0.0229, 'lps'),
	(387811, 125, '2015-02-01 00:29:18.000000', 'consum', 0.0225, 'lps'),
	(387812, 125, '2015-02-01 00:29:19.000000', 'consum', 0.0229, 'lps'),
	(387813, 125, '2015-02-01 00:29:20.000000', 'consum', 0.0234, 'lps'),
	(387814, 125, '2015-02-01 00:29:21.000000', 'consum', 0.0218, 'lps'),
	(387815, 125, '2015-02-01 00:29:22.000000', 'consum', 0.0231, 'lps'),
	(387816, 125, '2015-02-01 00:29:23.000000', 'consum', 0.0214, 'lps'),
	(387817, 125, '2015-02-01 00:29:24.000000', 'consum', 0.0220, 'lps'),
	(387818, 125, '2015-02-01 00:29:25.000000', 'consum', 0.0223, 'lps'),
	(387819, 125, '2015-02-01 00:29:26.000000', 'consum', 0.0219, 'lps'),
	(387820, 125, '2015-02-01 00:29:27.000000', 'consum', 0.0214, 'lps'),
	(387821, 125, '2015-02-01 00:29:28.000000', 'consum', 0.0232, 'lps'),
	(387822, 125, '2015-02-01 00:29:29.000000', 'consum', 0.0228, 'lps'),
	(387823, 125, '2015-02-01 00:29:30.000000', 'consum', 0.0234, 'lps'),
	(387824, 125, '2015-02-01 00:29:31.000000', 'consum', 0.0221, 'lps'),
	(387825, 125, '2015-02-01 00:29:32.000000', 'consum', 0.0224, 'lps'),
	(387826, 125, '2015-02-01 00:29:33.000000', 'consum', 0.0217, 'lps'),
	(387827, 125, '2015-02-01 00:29:34.000000', 'consum', 0.0232, 'lps'),
	(387828, 125, '2015-02-01 00:29:35.000000', 'consum', 0.0219, 'lps'),
	(387829, 125, '2015-02-01 00:29:36.000000', 'consum', 0.0218, 'lps'),
	(387830, 125, '2015-02-01 00:29:37.000000', 'consum', 0.0222, 'lps'),
	(387831, 125, '2015-02-01 00:29:38.000000', 'consum', 0.0220, 'lps'),
	(387832, 125, '2015-02-01 00:29:39.000000', 'consum', 0.0223, 'lps'),
	(387833, 125, '2015-02-01 00:29:40.000000', 'consum', 0.0219, 'lps'),
	(387834, 125, '2015-02-01 00:29:41.000000', 'consum', 0.0219, 'lps'),
	(387835, 125, '2015-02-01 00:29:42.000000', 'consum', 0.0226, 'lps'),
	(387836, 125, '2015-02-01 00:29:43.000000', 'consum', 0.0210, 'lps'),
	(387837, 125, '2015-02-01 00:29:44.000000', 'consum', 0.0215, 'lps'),
	(387838, 125, '2015-02-01 00:29:45.000000', 'consum', 0.0236, 'lps'),
	(387839, 125, '2015-02-01 00:29:46.000000', 'consum', 0.0219, 'lps'),
	(387840, 125, '2015-02-01 00:29:47.000000', 'consum', 0.0233, 'lps'),
	(387841, 125, '2015-02-01 00:29:48.000000', 'consum', 0.0215, 'lps'),
	(387842, 125, '2015-02-01 00:29:49.000000', 'consum', 0.0222, 'lps'),
	(387843, 125, '2015-02-01 00:29:50.000000', 'consum', 0.0229, 'lps'),
	(387844, 125, '2015-02-01 00:29:51.000000', 'consum', 0.0214, 'lps'),
	(387845, 125, '2015-02-01 00:29:52.000000', 'consum', 0.0230, 'lps'),
	(387846, 125, '2015-02-01 00:29:53.000000', 'consum', 0.0214, 'lps'),
	(387847, 125, '2015-02-01 00:29:54.000000', 'consum', 0.0228, 'lps'),
	(387848, 125, '2015-02-01 00:29:55.000000', 'consum', 0.0233, 'lps'),
	(387849, 125, '2015-02-01 00:29:56.000000', 'consum', 0.0216, 'lps'),
	(387850, 125, '2015-02-01 00:29:57.000000', 'consum', 0.0227, 'lps'),
	(387851, 125, '2015-02-01 00:29:58.000000', 'consum', 0.0222, 'lps'),
	(387852, 125, '2015-02-01 00:29:59.000000', 'consum', 0.0219, 'lps'),
	(387853, 125, '2015-02-01 00:30:00.000000', 'consum', 0.0219, 'lps'),
	(387854, 125, '2015-02-01 00:30:01.000000', 'consum', 0.0232, 'lps'),
	(387855, 125, '2015-02-01 00:30:02.000000', 'consum', 0.0236, 'lps'),
	(387856, 125, '2015-02-01 00:30:03.000000', 'consum', 0.0221, 'lps'),
	(387857, 125, '2015-02-01 00:30:04.000000', 'consum', 0.0213, 'lps'),
	(387858, 125, '2015-02-01 00:30:05.000000', 'consum', 0.0222, 'lps'),
	(387859, 125, '2015-02-01 00:30:06.000000', 'consum', 0.0233, 'lps'),
	(387860, 125, '2015-02-01 00:30:07.000000', 'consum', 0.0210, 'lps'),
	(387861, 125, '2015-02-01 00:30:08.000000', 'consum', 0.0220, 'lps'),
	(387862, 125, '2015-02-01 00:30:09.000000', 'consum', 0.0234, 'lps'),
	(387863, 125, '2015-02-01 00:30:10.000000', 'consum', 0.0221, 'lps'),
	(387864, 125, '2015-02-01 00:30:11.000000', 'consum', 0.0219, 'lps'),
	(387865, 125, '2015-02-01 00:30:12.000000', 'consum', 0.0224, 'lps'),
	(387866, 125, '2015-02-01 00:30:13.000000', 'consum', 0.0228, 'lps'),
	(387867, 125, '2015-02-01 00:30:14.000000', 'consum', 0.0228, 'lps'),
	(387868, 125, '2015-02-01 00:30:15.000000', 'consum', 0.0222, 'lps'),
	(387869, 125, '2015-02-01 00:30:16.000000', 'consum', 0.0216, 'lps'),
	(387870, 125, '2015-02-01 00:30:17.000000', 'consum', 0.0229, 'lps'),
	(387871, 125, '2015-02-01 00:30:18.000000', 'consum', 0.0236, 'lps'),
	(387872, 125, '2015-02-01 00:30:19.000000', 'consum', 0.0229, 'lps'),
	(387873, 125, '2015-02-01 00:30:20.000000', 'consum', 0.0229, 'lps'),
	(387874, 125, '2015-02-01 00:30:21.000000', 'consum', 0.0219, 'lps'),
	(387875, 125, '2015-02-01 00:30:22.000000', 'consum', 0.0226, 'lps'),
	(387876, 125, '2015-02-01 00:30:23.000000', 'consum', 0.0236, 'lps'),
	(387877, 125, '2015-02-01 00:30:24.000000', 'consum', 0.0210, 'lps'),
	(387878, 125, '2015-02-01 00:30:25.000000', 'consum', 0.0215, 'lps'),
	(387879, 125, '2015-02-01 00:30:26.000000', 'consum', 0.0210, 'lps'),
	(387880, 125, '2015-02-01 00:30:27.000000', 'consum', 0.0223, 'lps'),
	(387881, 125, '2015-02-01 00:30:28.000000', 'consum', 0.0221, 'lps'),
	(387882, 125, '2015-02-01 00:30:29.000000', 'consum', 0.0228, 'lps'),
	(387883, 125, '2015-02-01 00:30:30.000000', 'consum', 0.0213, 'lps'),
	(387884, 125, '2015-02-01 00:30:31.000000', 'consum', 0.0225, 'lps'),
	(387885, 125, '2015-02-01 00:30:32.000000', 'consum', 0.0224, 'lps'),
	(387886, 125, '2015-02-01 00:30:33.000000', 'consum', 0.0236, 'lps'),
	(387887, 125, '2015-02-01 00:30:34.000000', 'consum', 0.0218, 'lps'),
	(387888, 125, '2015-02-01 00:30:35.000000', 'consum', 0.0227, 'lps'),
	(387889, 125, '2015-02-01 00:30:36.000000', 'consum', 0.0217, 'lps'),
	(387890, 125, '2015-02-01 00:30:37.000000', 'consum', 0.0219, 'lps'),
	(387891, 125, '2015-02-01 00:30:38.000000', 'consum', 0.0211, 'lps'),
	(387892, 125, '2015-02-01 00:30:39.000000', 'consum', 0.0214, 'lps'),
	(387893, 125, '2015-02-01 00:30:40.000000', 'consum', 0.0226, 'lps'),
	(387894, 125, '2015-02-01 00:30:41.000000', 'consum', 0.0227, 'lps'),
	(387895, 125, '2015-02-01 00:30:42.000000', 'consum', 0.0221, 'lps'),
	(387896, 125, '2015-02-01 00:30:43.000000', 'consum', 0.0212, 'lps'),
	(387897, 125, '2015-02-01 00:30:44.000000', 'consum', 0.0217, 'lps'),
	(387898, 125, '2015-02-01 00:30:45.000000', 'consum', 0.0212, 'lps'),
	(387899, 125, '2015-02-01 00:30:46.000000', 'consum', 0.0227, 'lps'),
	(387900, 125, '2015-02-01 00:30:47.000000', 'consum', 0.0235, 'lps'),
	(387901, 125, '2015-02-01 00:30:48.000000', 'consum', 0.0230, 'lps'),
	(387902, 125, '2015-02-01 00:30:49.000000', 'consum', 0.0210, 'lps'),
	(387903, 125, '2015-02-01 00:30:50.000000', 'consum', 0.0231, 'lps'),
	(387904, 125, '2015-02-01 00:30:51.000000', 'consum', 0.0233, 'lps'),
	(387905, 125, '2015-02-01 00:30:52.000000', 'consum', 0.0210, 'lps'),
	(387906, 125, '2015-02-01 00:30:53.000000', 'consum', 0.0224, 'lps'),
	(387907, 125, '2015-02-01 00:30:54.000000', 'consum', 0.0224, 'lps'),
	(387908, 125, '2015-02-01 00:30:55.000000', 'consum', 0.0214, 'lps'),
	(387909, 125, '2015-02-01 00:30:56.000000', 'consum', 0.0214, 'lps'),
	(387910, 125, '2015-02-01 00:30:57.000000', 'consum', 0.0218, 'lps'),
	(387911, 125, '2015-02-01 00:30:58.000000', 'consum', 0.0214, 'lps'),
	(387912, 125, '2015-02-01 00:30:59.000000', 'consum', 0.0231, 'lps'),
	(387913, 125, '2015-02-01 00:31:00.000000', 'consum', 0.0222, 'lps'),
	(387914, 125, '2015-02-01 00:31:01.000000', 'consum', 0.0234, 'lps'),
	(387915, 125, '2015-02-01 00:31:02.000000', 'consum', 0.0213, 'lps'),
	(387916, 125, '2015-02-01 00:31:03.000000', 'consum', 0.0234, 'lps'),
	(387917, 125, '2015-02-01 00:31:04.000000', 'consum', 0.0214, 'lps'),
	(387918, 125, '2015-02-01 00:31:05.000000', 'consum', 0.0212, 'lps'),
	(387919, 125, '2015-02-01 00:31:06.000000', 'consum', 0.0211, 'lps'),
	(387920, 125, '2015-02-01 00:31:07.000000', 'consum', 0.0234, 'lps'),
	(387921, 125, '2015-02-01 00:31:08.000000', 'consum', 0.0222, 'lps'),
	(387922, 125, '2015-02-01 00:31:09.000000', 'consum', 0.0226, 'lps'),
	(387923, 125, '2015-02-01 00:31:10.000000', 'consum', 0.0225, 'lps'),
	(387924, 125, '2015-02-01 00:31:11.000000', 'consum', 0.0211, 'lps'),
	(387925, 125, '2015-02-01 00:31:12.000000', 'consum', 0.0227, 'lps'),
	(387926, 125, '2015-02-01 00:31:13.000000', 'consum', 0.0236, 'lps'),
	(387927, 125, '2015-02-01 00:31:14.000000', 'consum', 0.0234, 'lps'),
	(387928, 125, '2015-02-01 00:31:15.000000', 'consum', 0.0228, 'lps'),
	(387929, 125, '2015-02-01 00:31:16.000000', 'consum', 0.0228, 'lps'),
	(387930, 125, '2015-02-01 00:31:17.000000', 'consum', 0.0218, 'lps'),
	(387931, 125, '2015-02-01 00:31:18.000000', 'consum', 0.0226, 'lps'),
	(387932, 125, '2015-02-01 00:31:19.000000', 'consum', 0.0210, 'lps'),
	(387933, 125, '2015-02-01 00:31:20.000000', 'consum', 0.0216, 'lps'),
	(387934, 125, '2015-02-01 00:31:21.000000', 'consum', 0.0214, 'lps'),
	(387935, 125, '2015-02-01 00:31:22.000000', 'consum', 0.0212, 'lps'),
	(387936, 125, '2015-02-01 00:31:23.000000', 'consum', 0.0234, 'lps'),
	(387937, 125, '2015-02-01 00:31:24.000000', 'consum', 0.0219, 'lps'),
	(387938, 125, '2015-02-01 00:31:25.000000', 'consum', 0.0211, 'lps'),
	(387939, 125, '2015-02-01 00:31:26.000000', 'consum', 0.0214, 'lps'),
	(387940, 125, '2015-02-01 00:31:27.000000', 'consum', 0.0229, 'lps'),
	(387941, 125, '2015-02-01 00:31:28.000000', 'consum', 0.0212, 'lps'),
	(387942, 125, '2015-02-01 00:31:29.000000', 'consum', 0.0217, 'lps'),
	(387943, 125, '2015-02-01 00:31:30.000000', 'consum', 0.0211, 'lps'),
	(387944, 125, '2015-02-01 00:31:31.000000', 'consum', 0.0222, 'lps'),
	(387945, 125, '2015-02-01 00:31:32.000000', 'consum', 0.0215, 'lps'),
	(387946, 125, '2015-02-01 00:31:33.000000', 'consum', 0.0225, 'lps'),
	(387947, 125, '2015-02-01 00:31:34.000000', 'consum', 0.0216, 'lps'),
	(387948, 125, '2015-02-01 00:31:35.000000', 'consum', 0.0221, 'lps'),
	(387949, 125, '2015-02-01 00:31:36.000000', 'consum', 0.0223, 'lps'),
	(387950, 125, '2015-02-01 00:31:37.000000', 'consum', 0.0216, 'lps'),
	(387951, 125, '2015-02-01 00:31:38.000000', 'consum', 0.0230, 'lps'),
	(387952, 125, '2015-02-01 00:31:39.000000', 'consum', 0.0235, 'lps'),
	(387953, 125, '2015-02-01 00:31:40.000000', 'consum', 0.0222, 'lps'),
	(387954, 125, '2015-02-01 00:31:41.000000', 'consum', 0.0223, 'lps'),
	(387955, 125, '2015-02-01 00:31:42.000000', 'consum', 0.0213, 'lps'),
	(387956, 125, '2015-02-01 00:31:43.000000', 'consum', 0.0214, 'lps'),
	(387957, 125, '2015-02-01 00:31:44.000000', 'consum', 0.0219, 'lps'),
	(387958, 125, '2015-02-01 00:31:45.000000', 'consum', 0.0218, 'lps'),
	(387959, 125, '2015-02-01 00:31:46.000000', 'consum', 0.0225, 'lps'),
	(387960, 125, '2015-02-01 00:31:47.000000', 'consum', 0.0233, 'lps'),
	(387961, 125, '2015-02-01 00:31:48.000000', 'consum', 0.0225, 'lps'),
	(387962, 125, '2015-02-01 00:31:49.000000', 'consum', 0.0218, 'lps'),
	(387963, 125, '2015-02-01 00:31:50.000000', 'consum', 0.0233, 'lps'),
	(387964, 125, '2015-02-01 00:31:51.000000', 'consum', 0.0218, 'lps'),
	(387965, 125, '2015-02-01 00:31:52.000000', 'consum', 0.0212, 'lps'),
	(387966, 125, '2015-02-01 00:31:53.000000', 'consum', 0.0222, 'lps'),
	(387967, 125, '2015-02-01 00:31:54.000000', 'consum', 0.0236, 'lps'),
	(387968, 125, '2015-02-01 00:31:55.000000', 'consum', 0.0224, 'lps'),
	(387969, 125, '2015-02-01 00:31:56.000000', 'consum', 0.0230, 'lps'),
	(387970, 125, '2015-02-01 00:31:57.000000', 'consum', 0.0216, 'lps'),
	(387971, 125, '2015-02-01 00:31:58.000000', 'consum', 0.0233, 'lps'),
	(387972, 125, '2015-02-01 00:31:59.000000', 'consum', 0.0228, 'lps'),
	(387973, 125, '2015-02-01 00:32:00.000000', 'consum', 0.0230, 'lps'),
	(387974, 125, '2015-02-01 00:32:01.000000', 'consum', 0.0229, 'lps'),
	(387975, 125, '2015-02-01 00:32:02.000000', 'consum', 0.0218, 'lps'),
	(387976, 125, '2015-02-01 00:32:03.000000', 'consum', 0.0220, 'lps'),
	(387977, 125, '2015-02-01 00:32:04.000000', 'consum', 0.0210, 'lps'),
	(387978, 125, '2015-02-01 00:32:05.000000', 'consum', 0.0236, 'lps'),
	(387979, 125, '2015-02-01 00:32:06.000000', 'consum', 0.0230, 'lps'),
	(387980, 125, '2015-02-01 00:32:07.000000', 'consum', 0.0232, 'lps'),
	(387981, 125, '2015-02-01 00:32:08.000000', 'consum', 0.0210, 'lps'),
	(387982, 125, '2015-02-01 00:32:09.000000', 'consum', 0.0223, 'lps'),
	(387983, 125, '2015-02-01 00:32:10.000000', 'consum', 0.0221, 'lps'),
	(387984, 125, '2015-02-01 00:32:11.000000', 'consum', 0.0229, 'lps'),
	(387985, 125, '2015-02-01 00:32:12.000000', 'consum', 0.0216, 'lps'),
	(387986, 125, '2015-02-01 00:32:13.000000', 'consum', 0.0212, 'lps'),
	(387987, 125, '2015-02-01 00:32:14.000000', 'consum', 0.0227, 'lps'),
	(387988, 125, '2015-02-01 00:32:15.000000', 'consum', 0.0210, 'lps'),
	(387989, 125, '2015-02-01 00:32:16.000000', 'consum', 0.0215, 'lps'),
	(387990, 125, '2015-02-01 00:32:17.000000', 'consum', 0.0235, 'lps'),
	(387991, 125, '2015-02-01 00:32:18.000000', 'consum', 0.0214, 'lps'),
	(387992, 125, '2015-02-01 00:32:19.000000', 'consum', 0.0235, 'lps'),
	(387993, 125, '2015-02-01 00:32:20.000000', 'consum', 0.0214, 'lps'),
	(387994, 125, '2015-02-01 00:32:21.000000', 'consum', 0.0210, 'lps'),
	(387995, 125, '2015-02-01 00:32:22.000000', 'consum', 0.0228, 'lps'),
	(387996, 125, '2015-02-01 00:32:23.000000', 'consum', 0.0218, 'lps'),
	(387997, 125, '2015-02-01 00:32:24.000000', 'consum', 0.0222, 'lps'),
	(387998, 125, '2015-02-01 00:32:25.000000', 'consum', 0.0221, 'lps'),
	(387999, 125, '2015-02-01 00:32:26.000000', 'consum', 0.0230, 'lps'),
	(388000, 125, '2015-02-01 00:32:27.000000', 'consum', 0.0224, 'lps'),
	(388001, 125, '2015-02-01 00:32:28.000000', 'consum', 0.0221, 'lps'),
	(388002, 125, '2015-02-01 00:32:29.000000', 'consum', 0.0222, 'lps'),
	(388003, 125, '2015-02-01 00:32:30.000000', 'consum', 0.0210, 'lps'),
	(388004, 125, '2015-02-01 00:32:31.000000', 'consum', 0.0231, 'lps'),
	(388005, 125, '2015-02-01 00:32:32.000000', 'consum', 0.0232, 'lps'),
	(388006, 125, '2015-02-01 00:32:33.000000', 'consum', 0.0230, 'lps'),
	(388007, 125, '2015-02-01 00:32:34.000000', 'consum', 0.0217, 'lps'),
	(388008, 125, '2015-02-01 00:32:35.000000', 'consum', 0.0215, 'lps'),
	(388009, 125, '2015-02-01 00:32:36.000000', 'consum', 0.0213, 'lps'),
	(388010, 125, '2015-02-01 00:32:37.000000', 'consum', 0.0236, 'lps'),
	(388011, 125, '2015-02-01 00:32:38.000000', 'consum', 0.0225, 'lps'),
	(388012, 125, '2015-02-01 00:32:39.000000', 'consum', 0.0234, 'lps'),
	(388013, 125, '2015-02-01 00:32:40.000000', 'consum', 0.0233, 'lps'),
	(388014, 125, '2015-02-01 00:32:41.000000', 'consum', 0.0225, 'lps'),
	(388015, 125, '2015-02-01 00:32:42.000000', 'consum', 0.0216, 'lps'),
	(388016, 125, '2015-02-01 00:32:43.000000', 'consum', 0.0225, 'lps'),
	(388017, 125, '2015-02-01 00:32:44.000000', 'consum', 0.0211, 'lps'),
	(388018, 125, '2015-02-01 00:32:45.000000', 'consum', 0.0225, 'lps'),
	(388019, 125, '2015-02-01 00:32:46.000000', 'consum', 0.0229, 'lps'),
	(388020, 125, '2015-02-01 00:32:47.000000', 'consum', 0.0233, 'lps'),
	(388021, 125, '2015-02-01 00:32:48.000000', 'consum', 0.0216, 'lps'),
	(388022, 125, '2015-02-01 00:32:49.000000', 'consum', 0.0225, 'lps'),
	(388023, 125, '2015-02-01 00:32:50.000000', 'consum', 0.0215, 'lps'),
	(388024, 125, '2015-02-01 00:32:51.000000', 'consum', 0.0215, 'lps'),
	(388025, 125, '2015-02-01 00:32:52.000000', 'consum', 0.0222, 'lps'),
	(388026, 125, '2015-02-01 00:32:53.000000', 'consum', 0.0226, 'lps'),
	(388027, 125, '2015-02-01 00:32:54.000000', 'consum', 0.0230, 'lps'),
	(388028, 125, '2015-02-01 00:32:55.000000', 'consum', 0.0235, 'lps'),
	(388029, 125, '2015-02-01 00:32:56.000000', 'consum', 0.0220, 'lps'),
	(388030, 125, '2015-02-01 00:32:57.000000', 'consum', 0.0214, 'lps'),
	(388031, 125, '2015-02-01 00:32:58.000000', 'consum', 0.0228, 'lps'),
	(388032, 125, '2015-02-01 00:32:59.000000', 'consum', 0.0236, 'lps'),
	(388033, 125, '2015-02-01 00:33:00.000000', 'consum', 0.0230, 'lps'),
	(388034, 125, '2015-02-01 00:33:01.000000', 'consum', 0.0235, 'lps'),
	(388035, 125, '2015-02-01 00:33:02.000000', 'consum', 0.0219, 'lps'),
	(388036, 125, '2015-02-01 00:33:03.000000', 'consum', 0.0235, 'lps'),
	(388037, 125, '2015-02-01 00:33:04.000000', 'consum', 0.0227, 'lps'),
	(388038, 125, '2015-02-01 00:33:05.000000', 'consum', 0.0222, 'lps'),
	(388039, 125, '2015-02-01 00:33:06.000000', 'consum', 0.0218, 'lps'),
	(388040, 125, '2015-02-01 00:33:07.000000', 'consum', 0.0216, 'lps'),
	(388041, 125, '2015-02-01 00:33:08.000000', 'consum', 0.0215, 'lps'),
	(388042, 125, '2015-02-01 00:33:09.000000', 'consum', 0.0217, 'lps'),
	(388043, 125, '2015-02-01 00:33:10.000000', 'consum', 0.0232, 'lps'),
	(388044, 125, '2015-02-01 00:33:11.000000', 'consum', 0.0218, 'lps'),
	(388045, 125, '2015-02-01 00:33:12.000000', 'consum', 0.0210, 'lps'),
	(388046, 125, '2015-02-01 00:33:13.000000', 'consum', 0.0214, 'lps'),
	(388047, 125, '2015-02-01 00:33:14.000000', 'consum', 0.0231, 'lps'),
	(388048, 125, '2015-02-01 00:33:15.000000', 'consum', 0.0224, 'lps'),
	(388049, 125, '2015-02-01 00:33:16.000000', 'consum', 0.0216, 'lps'),
	(388050, 125, '2015-02-01 00:33:17.000000', 'consum', 0.0224, 'lps'),
	(388051, 125, '2015-02-01 00:33:18.000000', 'consum', 0.0211, 'lps'),
	(388052, 125, '2015-02-01 00:33:19.000000', 'consum', 0.0228, 'lps'),
	(388053, 125, '2015-02-01 00:33:20.000000', 'consum', 0.0216, 'lps'),
	(388054, 125, '2015-02-01 00:33:21.000000', 'consum', 0.0213, 'lps'),
	(388055, 125, '2015-02-01 00:33:22.000000', 'consum', 0.0236, 'lps'),
	(388056, 125, '2015-02-01 00:33:23.000000', 'consum', 0.0222, 'lps'),
	(388057, 125, '2015-02-01 00:33:24.000000', 'consum', 0.0220, 'lps'),
	(388058, 125, '2015-02-01 00:33:25.000000', 'consum', 0.0226, 'lps'),
	(388059, 125, '2015-02-01 00:33:26.000000', 'consum', 0.0232, 'lps'),
	(388060, 125, '2015-02-01 00:33:27.000000', 'consum', 0.0218, 'lps'),
	(388061, 125, '2015-02-01 00:33:28.000000', 'consum', 0.0210, 'lps'),
	(388062, 125, '2015-02-01 00:33:29.000000', 'consum', 0.0215, 'lps'),
	(388063, 125, '2015-02-01 00:33:30.000000', 'consum', 0.0234, 'lps'),
	(388064, 125, '2015-02-01 00:33:31.000000', 'consum', 0.0234, 'lps'),
	(388065, 125, '2015-02-01 00:33:32.000000', 'consum', 0.0234, 'lps'),
	(388066, 125, '2015-02-01 00:33:33.000000', 'consum', 0.0232, 'lps'),
	(388067, 125, '2015-02-01 00:33:34.000000', 'consum', 0.0220, 'lps'),
	(388068, 125, '2015-02-01 00:33:35.000000', 'consum', 0.0223, 'lps'),
	(388069, 125, '2015-02-01 00:33:36.000000', 'consum', 0.0217, 'lps'),
	(388070, 125, '2015-02-01 00:33:37.000000', 'consum', 0.0233, 'lps'),
	(388071, 125, '2015-02-01 00:33:38.000000', 'consum', 0.0224, 'lps'),
	(388072, 125, '2015-02-01 00:33:39.000000', 'consum', 0.0213, 'lps'),
	(388073, 125, '2015-02-01 00:33:40.000000', 'consum', 0.0210, 'lps'),
	(388074, 125, '2015-02-01 00:33:41.000000', 'consum', 0.0229, 'lps'),
	(388075, 125, '2015-02-01 00:33:42.000000', 'consum', 0.0226, 'lps'),
	(388076, 125, '2015-02-01 00:33:43.000000', 'consum', 0.0232, 'lps'),
	(388077, 125, '2015-02-01 00:33:44.000000', 'consum', 0.0217, 'lps'),
	(388078, 125, '2015-02-01 00:33:45.000000', 'consum', 0.0234, 'lps'),
	(388079, 125, '2015-02-01 00:33:46.000000', 'consum', 0.0228, 'lps'),
	(388080, 125, '2015-02-01 00:33:47.000000', 'consum', 0.0230, 'lps'),
	(388081, 125, '2015-02-01 00:33:48.000000', 'consum', 0.0228, 'lps'),
	(388082, 125, '2015-02-01 00:33:49.000000', 'consum', 0.0216, 'lps'),
	(388083, 125, '2015-02-01 00:33:50.000000', 'consum', 0.0213, 'lps'),
	(388084, 125, '2015-02-01 00:33:51.000000', 'consum', 0.0234, 'lps'),
	(388085, 125, '2015-02-01 00:33:52.000000', 'consum', 0.0214, 'lps'),
	(388086, 125, '2015-02-01 00:33:53.000000', 'consum', 0.0212, 'lps'),
	(388087, 125, '2015-02-01 00:33:54.000000', 'consum', 0.0235, 'lps'),
	(388088, 125, '2015-02-01 00:33:55.000000', 'consum', 0.0223, 'lps'),
	(388089, 125, '2015-02-01 00:33:56.000000', 'consum', 0.0225, 'lps'),
	(388090, 125, '2015-02-01 00:33:57.000000', 'consum', 0.0223, 'lps'),
	(388091, 125, '2015-02-01 00:33:58.000000', 'consum', 0.0227, 'lps'),
	(388092, 125, '2015-02-01 00:33:59.000000', 'consum', 0.0231, 'lps'),
	(388093, 125, '2015-02-01 00:34:00.000000', 'consum', 0.0211, 'lps'),
	(388094, 125, '2015-02-01 00:34:01.000000', 'consum', 0.0232, 'lps'),
	(388095, 125, '2015-02-01 00:34:02.000000', 'consum', 0.0210, 'lps'),
	(388096, 125, '2015-02-01 00:34:03.000000', 'consum', 0.0228, 'lps'),
	(388097, 125, '2015-02-01 00:34:04.000000', 'consum', 0.0216, 'lps'),
	(388098, 125, '2015-02-01 00:34:05.000000', 'consum', 0.0216, 'lps'),
	(388099, 125, '2015-02-01 00:34:06.000000', 'consum', 0.0223, 'lps'),
	(388100, 125, '2015-02-01 00:34:07.000000', 'consum', 0.0229, 'lps'),
	(388101, 125, '2015-02-01 00:34:08.000000', 'consum', 0.0214, 'lps'),
	(388102, 125, '2015-02-01 00:34:09.000000', 'consum', 0.0228, 'lps'),
	(388103, 125, '2015-02-01 00:34:10.000000', 'consum', 0.0235, 'lps'),
	(388104, 125, '2015-02-01 00:34:11.000000', 'consum', 0.0228, 'lps'),
	(388105, 125, '2015-02-01 00:34:12.000000', 'consum', 0.0223, 'lps'),
	(388106, 125, '2015-02-01 00:34:13.000000', 'consum', 0.0222, 'lps'),
	(388107, 125, '2015-02-01 00:34:14.000000', 'consum', 0.0231, 'lps'),
	(388108, 125, '2015-02-01 00:34:15.000000', 'consum', 0.0225, 'lps'),
	(388109, 125, '2015-02-01 00:34:16.000000', 'consum', 0.0223, 'lps'),
	(388110, 125, '2015-02-01 00:34:17.000000', 'consum', 0.0229, 'lps'),
	(388111, 125, '2015-02-01 00:34:18.000000', 'consum', 0.0214, 'lps'),
	(388112, 125, '2015-02-01 00:34:19.000000', 'consum', 0.0226, 'lps'),
	(388113, 125, '2015-02-01 00:34:20.000000', 'consum', 0.0227, 'lps'),
	(388114, 125, '2015-02-01 00:34:21.000000', 'consum', 0.0220, 'lps'),
	(388115, 125, '2015-02-01 00:34:22.000000', 'consum', 0.0211, 'lps'),
	(388116, 125, '2015-02-01 00:34:23.000000', 'consum', 0.0210, 'lps'),
	(388117, 125, '2015-02-01 00:34:24.000000', 'consum', 0.0234, 'lps'),
	(388118, 125, '2015-02-01 00:34:25.000000', 'consum', 0.0223, 'lps'),
	(388119, 125, '2015-02-01 00:34:26.000000', 'consum', 0.0232, 'lps'),
	(388120, 125, '2015-02-01 00:34:27.000000', 'consum', 0.0226, 'lps'),
	(388121, 125, '2015-02-01 00:34:28.000000', 'consum', 0.0223, 'lps'),
	(388122, 125, '2015-02-01 00:34:29.000000', 'consum', 0.0230, 'lps'),
	(388123, 125, '2015-02-01 00:34:30.000000', 'consum', 0.0219, 'lps'),
	(388124, 125, '2015-02-01 00:34:31.000000', 'consum', 0.0220, 'lps'),
	(388125, 125, '2015-02-01 00:34:32.000000', 'consum', 0.0233, 'lps'),
	(388126, 125, '2015-02-01 00:34:33.000000', 'consum', 0.0217, 'lps'),
	(388127, 125, '2015-02-01 00:34:34.000000', 'consum', 0.0228, 'lps'),
	(388128, 125, '2015-02-01 00:34:35.000000', 'consum', 0.0224, 'lps'),
	(388129, 125, '2015-02-01 00:34:36.000000', 'consum', 0.0230, 'lps'),
	(388130, 125, '2015-02-01 00:34:37.000000', 'consum', 0.0212, 'lps'),
	(388131, 125, '2015-02-01 00:34:38.000000', 'consum', 0.0217, 'lps'),
	(388132, 125, '2015-02-01 00:34:39.000000', 'consum', 0.0213, 'lps'),
	(388133, 125, '2015-02-01 00:34:40.000000', 'consum', 0.0232, 'lps'),
	(388134, 125, '2015-02-01 00:34:41.000000', 'consum', 0.0229, 'lps'),
	(388135, 125, '2015-02-01 00:34:42.000000', 'consum', 0.0214, 'lps'),
	(388136, 125, '2015-02-01 00:34:43.000000', 'consum', 0.0228, 'lps'),
	(388137, 125, '2015-02-01 00:34:44.000000', 'consum', 0.0232, 'lps'),
	(388138, 125, '2015-02-01 00:34:45.000000', 'consum', 0.0216, 'lps'),
	(388139, 125, '2015-02-01 00:34:46.000000', 'consum', 0.0225, 'lps'),
	(388140, 125, '2015-02-01 00:34:47.000000', 'consum', 0.0214, 'lps'),
	(388141, 125, '2015-02-01 00:34:48.000000', 'consum', 0.0214, 'lps'),
	(388142, 125, '2015-02-01 00:34:49.000000', 'consum', 0.0217, 'lps'),
	(388143, 125, '2015-02-01 00:34:50.000000', 'consum', 0.0235, 'lps'),
	(388144, 125, '2015-02-01 00:34:51.000000', 'consum', 0.0234, 'lps'),
	(388145, 125, '2015-02-01 00:34:52.000000', 'consum', 0.0227, 'lps'),
	(388146, 125, '2015-02-01 00:34:53.000000', 'consum', 0.0225, 'lps'),
	(388147, 125, '2015-02-01 00:34:54.000000', 'consum', 0.0232, 'lps'),
	(388148, 125, '2015-02-01 00:34:55.000000', 'consum', 0.0221, 'lps'),
	(388149, 125, '2015-02-01 00:34:56.000000', 'consum', 0.0230, 'lps'),
	(388150, 125, '2015-02-01 00:34:57.000000', 'consum', 0.0221, 'lps'),
	(388151, 125, '2015-02-01 00:34:58.000000', 'consum', 0.0234, 'lps'),
	(388152, 125, '2015-02-01 00:34:59.000000', 'consum', 0.0214, 'lps'),
	(388153, 125, '2015-02-01 00:35:00.000000', 'consum', 0.0215, 'lps'),
	(388154, 125, '2015-02-01 00:35:01.000000', 'consum', 0.0223, 'lps'),
	(388155, 125, '2015-02-01 00:35:02.000000', 'consum', 0.0234, 'lps'),
	(388156, 125, '2015-02-01 00:35:03.000000', 'consum', 0.0236, 'lps'),
	(388157, 125, '2015-02-01 00:35:04.000000', 'consum', 0.0216, 'lps'),
	(388158, 125, '2015-02-01 00:35:05.000000', 'consum', 0.0216, 'lps'),
	(388159, 125, '2015-02-01 00:35:06.000000', 'consum', 0.0223, 'lps'),
	(388160, 125, '2015-02-01 00:35:07.000000', 'consum', 0.0229, 'lps'),
	(388161, 125, '2015-02-01 00:35:08.000000', 'consum', 0.0213, 'lps'),
	(388162, 125, '2015-02-01 00:35:09.000000', 'consum', 0.0222, 'lps'),
	(388163, 125, '2015-02-01 00:35:10.000000', 'consum', 0.0235, 'lps'),
	(388164, 125, '2015-02-01 00:35:11.000000', 'consum', 0.0220, 'lps'),
	(388165, 125, '2015-02-01 00:35:12.000000', 'consum', 0.0214, 'lps'),
	(388166, 125, '2015-02-01 00:35:13.000000', 'consum', 0.0224, 'lps'),
	(388167, 125, '2015-02-01 00:35:14.000000', 'consum', 0.0215, 'lps'),
	(388168, 125, '2015-02-01 00:35:15.000000', 'consum', 0.0219, 'lps'),
	(388169, 125, '2015-02-01 00:35:16.000000', 'consum', 0.0215, 'lps'),
	(388170, 125, '2015-02-01 00:35:17.000000', 'consum', 0.0235, 'lps'),
	(388171, 125, '2015-02-01 00:35:18.000000', 'consum', 0.0215, 'lps'),
	(388172, 125, '2015-02-01 00:35:19.000000', 'consum', 0.0212, 'lps'),
	(388173, 125, '2015-02-01 00:35:20.000000', 'consum', 0.0232, 'lps'),
	(388174, 125, '2015-02-01 00:35:21.000000', 'consum', 0.0236, 'lps'),
	(388175, 125, '2015-02-01 00:35:22.000000', 'consum', 0.0220, 'lps'),
	(388176, 125, '2015-02-01 00:35:23.000000', 'consum', 0.0236, 'lps'),
	(388177, 125, '2015-02-01 00:35:24.000000', 'consum', 0.0230, 'lps'),
	(388178, 125, '2015-02-01 00:35:25.000000', 'consum', 0.0234, 'lps'),
	(388179, 125, '2015-02-01 00:35:26.000000', 'consum', 0.0215, 'lps'),
	(388180, 125, '2015-02-01 00:35:27.000000', 'consum', 0.0219, 'lps'),
	(388181, 125, '2015-02-01 00:35:28.000000', 'consum', 0.0212, 'lps'),
	(388182, 125, '2015-02-01 00:35:29.000000', 'consum', 0.0223, 'lps'),
	(388183, 125, '2015-02-01 00:35:30.000000', 'consum', 0.0214, 'lps'),
	(388184, 125, '2015-02-01 00:35:31.000000', 'consum', 0.0217, 'lps'),
	(388185, 125, '2015-02-01 00:35:32.000000', 'consum', 0.0233, 'lps'),
	(388186, 125, '2015-02-01 00:35:33.000000', 'consum', 0.0224, 'lps'),
	(388187, 125, '2015-02-01 00:35:34.000000', 'consum', 0.0213, 'lps'),
	(388188, 125, '2015-02-01 00:35:35.000000', 'consum', 0.0210, 'lps'),
	(388189, 125, '2015-02-01 00:35:36.000000', 'consum', 0.0230, 'lps'),
	(388190, 125, '2015-02-01 00:35:37.000000', 'consum', 0.0229, 'lps'),
	(388191, 125, '2015-02-01 00:35:38.000000', 'consum', 0.0218, 'lps'),
	(388192, 125, '2015-02-01 00:35:39.000000', 'consum', 0.0222, 'lps'),
	(388193, 125, '2015-02-01 00:35:40.000000', 'consum', 0.0217, 'lps'),
	(388194, 125, '2015-02-01 00:35:41.000000', 'consum', 0.0211, 'lps'),
	(388195, 125, '2015-02-01 00:35:42.000000', 'consum', 0.0222, 'lps'),
	(388196, 125, '2015-02-01 00:35:43.000000', 'consum', 0.0213, 'lps'),
	(388197, 125, '2015-02-01 00:35:44.000000', 'consum', 0.0217, 'lps'),
	(388198, 125, '2015-02-01 00:35:45.000000', 'consum', 0.0210, 'lps'),
	(388199, 125, '2015-02-01 00:35:46.000000', 'consum', 0.0215, 'lps'),
	(388200, 125, '2015-02-01 00:35:47.000000', 'consum', 0.0235, 'lps'),
	(388201, 125, '2015-02-01 00:35:48.000000', 'consum', 0.0214, 'lps'),
	(388202, 125, '2015-02-01 00:35:49.000000', 'consum', 0.0234, 'lps'),
	(388203, 125, '2015-02-01 00:35:50.000000', 'consum', 0.0214, 'lps'),
	(388204, 125, '2015-02-01 00:35:51.000000', 'consum', 0.0236, 'lps'),
	(388205, 125, '2015-02-01 00:35:52.000000', 'consum', 0.0222, 'lps'),
	(388206, 125, '2015-02-01 00:35:53.000000', 'consum', 0.0220, 'lps'),
	(388207, 125, '2015-02-01 00:35:54.000000', 'consum', 0.0223, 'lps'),
	(388208, 125, '2015-02-01 00:35:55.000000', 'consum', 0.0220, 'lps'),
	(388209, 125, '2015-02-01 00:35:56.000000', 'consum', 0.0222, 'lps'),
	(388210, 125, '2015-02-01 00:35:57.000000', 'consum', 0.0214, 'lps'),
	(388211, 125, '2015-02-01 00:35:58.000000', 'consum', 0.0221, 'lps'),
	(388212, 125, '2015-02-01 00:35:59.000000', 'consum', 0.0226, 'lps'),
	(388213, 125, '2015-02-01 00:36:00.000000', 'consum', 0.0229, 'lps'),
	(388214, 125, '2015-02-01 00:36:01.000000', 'consum', 0.0232, 'lps'),
	(388215, 125, '2015-02-01 00:36:02.000000', 'consum', 0.0235, 'lps'),
	(388216, 125, '2015-02-01 00:36:03.000000', 'consum', 0.0214, 'lps'),
	(388217, 125, '2015-02-01 00:36:04.000000', 'consum', 0.0213, 'lps'),
	(388218, 125, '2015-02-01 00:36:05.000000', 'consum', 0.0211, 'lps'),
	(388219, 125, '2015-02-01 00:36:06.000000', 'consum', 0.0234, 'lps'),
	(388220, 125, '2015-02-01 00:36:07.000000', 'consum', 0.0220, 'lps'),
	(388221, 125, '2015-02-01 00:36:08.000000', 'consum', 0.0213, 'lps'),
	(388222, 125, '2015-02-01 00:36:09.000000', 'consum', 0.0226, 'lps'),
	(388223, 125, '2015-02-01 00:36:10.000000', 'consum', 0.0226, 'lps'),
	(388224, 125, '2015-02-01 00:36:11.000000', 'consum', 0.0215, 'lps'),
	(388225, 125, '2015-02-01 00:36:12.000000', 'consum', 0.0217, 'lps'),
	(388226, 125, '2015-02-01 00:36:13.000000', 'consum', 0.0229, 'lps'),
	(388227, 125, '2015-02-01 00:36:14.000000', 'consum', 0.0229, 'lps'),
	(388228, 125, '2015-02-01 00:36:15.000000', 'consum', 0.0224, 'lps'),
	(388229, 125, '2015-02-01 00:36:16.000000', 'consum', 0.0222, 'lps'),
	(388230, 125, '2015-02-01 00:36:17.000000', 'consum', 0.0227, 'lps'),
	(388231, 125, '2015-02-01 00:36:18.000000', 'consum', 0.0235, 'lps'),
	(388232, 125, '2015-02-01 00:36:19.000000', 'consum', 0.0230, 'lps'),
	(388233, 125, '2015-02-01 00:36:20.000000', 'consum', 0.0235, 'lps'),
	(388234, 125, '2015-02-01 00:36:21.000000', 'consum', 0.0220, 'lps'),
	(388235, 125, '2015-02-01 00:36:22.000000', 'consum', 0.0213, 'lps'),
	(388236, 125, '2015-02-01 00:36:23.000000', 'consum', 0.0224, 'lps'),
	(388237, 125, '2015-02-01 00:36:24.000000', 'consum', 0.0217, 'lps'),
	(388238, 125, '2015-02-01 00:36:25.000000', 'consum', 0.0230, 'lps'),
	(388239, 125, '2015-02-01 00:36:26.000000', 'consum', 0.0234, 'lps'),
	(388240, 125, '2015-02-01 00:36:27.000000', 'consum', 0.0217, 'lps'),
	(388241, 125, '2015-02-01 00:36:28.000000', 'consum', 0.0226, 'lps'),
	(388242, 125, '2015-02-01 00:36:29.000000', 'consum', 0.0218, 'lps'),
	(388243, 125, '2015-02-01 00:36:30.000000', 'consum', 0.0230, 'lps'),
	(388244, 125, '2015-02-01 00:36:31.000000', 'consum', 0.0232, 'lps'),
	(388245, 125, '2015-02-01 00:36:32.000000', 'consum', 0.0232, 'lps'),
	(388246, 125, '2015-02-01 00:36:33.000000', 'consum', 0.0227, 'lps'),
	(388247, 125, '2015-02-01 00:36:34.000000', 'consum', 0.0231, 'lps'),
	(388248, 125, '2015-02-01 00:36:35.000000', 'consum', 0.0211, 'lps'),
	(388249, 125, '2015-02-01 00:36:36.000000', 'consum', 0.0231, 'lps'),
	(388250, 125, '2015-02-01 00:36:37.000000', 'consum', 0.0234, 'lps'),
	(388251, 125, '2015-02-01 00:36:38.000000', 'consum', 0.0214, 'lps'),
	(388252, 125, '2015-02-01 00:36:39.000000', 'consum', 0.0210, 'lps'),
	(388253, 125, '2015-02-01 00:36:40.000000', 'consum', 0.0226, 'lps'),
	(388254, 125, '2015-02-01 00:36:41.000000', 'consum', 0.0236, 'lps'),
	(388255, 125, '2015-02-01 00:36:42.000000', 'consum', 0.0211, 'lps'),
	(388256, 125, '2015-02-01 00:36:43.000000', 'consum', 0.0219, 'lps'),
	(388257, 125, '2015-02-01 00:36:44.000000', 'consum', 0.0227, 'lps'),
	(388258, 125, '2015-02-01 00:36:45.000000', 'consum', 0.0213, 'lps'),
	(388259, 125, '2015-02-01 00:36:46.000000', 'consum', 0.0229, 'lps'),
	(388260, 125, '2015-02-01 00:36:47.000000', 'consum', 0.0214, 'lps'),
	(388261, 125, '2015-02-01 00:36:48.000000', 'consum', 0.0227, 'lps'),
	(388262, 125, '2015-02-01 00:36:49.000000', 'consum', 0.0229, 'lps'),
	(388263, 125, '2015-02-01 00:36:50.000000', 'consum', 0.0230, 'lps'),
	(388264, 125, '2015-02-01 00:36:51.000000', 'consum', 0.0227, 'lps'),
	(388265, 125, '2015-02-01 00:36:52.000000', 'consum', 0.0236, 'lps'),
	(388266, 125, '2015-02-01 00:36:53.000000', 'consum', 0.0234, 'lps'),
	(388267, 125, '2015-02-01 00:36:54.000000', 'consum', 0.0225, 'lps'),
	(388268, 125, '2015-02-01 00:36:55.000000', 'consum', 0.0215, 'lps'),
	(388269, 125, '2015-02-01 00:36:56.000000', 'consum', 0.0216, 'lps'),
	(388270, 125, '2015-02-01 00:36:57.000000', 'consum', 0.0224, 'lps'),
	(388271, 125, '2015-02-01 00:36:58.000000', 'consum', 0.0211, 'lps'),
	(388272, 125, '2015-02-01 00:36:59.000000', 'consum', 0.0227, 'lps'),
	(388273, 125, '2015-02-01 00:37:00.000000', 'consum', 0.0236, 'lps'),
	(388274, 125, '2015-02-01 00:37:01.000000', 'consum', 0.0211, 'lps'),
	(388275, 125, '2015-02-01 00:37:02.000000', 'consum', 0.0220, 'lps'),
	(388276, 125, '2015-02-01 00:37:03.000000', 'consum', 0.0228, 'lps'),
	(388277, 125, '2015-02-01 00:37:04.000000', 'consum', 0.0216, 'lps'),
	(388278, 125, '2015-02-01 00:37:05.000000', 'consum', 0.0216, 'lps'),
	(388279, 125, '2015-02-01 00:37:06.000000', 'consum', 0.0222, 'lps'),
	(388280, 125, '2015-02-01 00:37:07.000000', 'consum', 0.0224, 'lps'),
	(388281, 125, '2015-02-01 00:37:08.000000', 'consum', 0.0220, 'lps'),
	(388282, 125, '2015-02-01 00:37:09.000000', 'consum', 0.0217, 'lps'),
	(388283, 125, '2015-02-01 00:37:10.000000', 'consum', 0.0214, 'lps'),
	(388284, 125, '2015-02-01 00:37:11.000000', 'consum', 0.0210, 'lps'),
	(388285, 125, '2015-02-01 00:37:12.000000', 'consum', 0.0225, 'lps'),
	(388286, 125, '2015-02-01 00:37:13.000000', 'consum', 0.0232, 'lps'),
	(388287, 125, '2015-02-01 00:37:14.000000', 'consum', 0.0221, 'lps'),
	(388288, 125, '2015-02-01 00:37:15.000000', 'consum', 0.0227, 'lps'),
	(388289, 125, '2015-02-01 00:37:16.000000', 'consum', 0.0234, 'lps'),
	(388290, 125, '2015-02-01 00:37:17.000000', 'consum', 0.0225, 'lps'),
	(388291, 125, '2015-02-01 00:37:18.000000', 'consum', 0.0215, 'lps'),
	(388292, 125, '2015-02-01 00:37:19.000000', 'consum', 0.0217, 'lps'),
	(388293, 125, '2015-02-01 00:37:20.000000', 'consum', 0.0232, 'lps'),
	(388294, 125, '2015-02-01 00:37:21.000000', 'consum', 0.0218, 'lps'),
	(388295, 125, '2015-02-01 00:37:22.000000', 'consum', 0.0212, 'lps'),
	(388296, 125, '2015-02-01 00:37:23.000000', 'consum', 0.0224, 'lps'),
	(388297, 125, '2015-02-01 00:37:24.000000', 'consum', 0.0219, 'lps'),
	(388298, 125, '2015-02-01 00:37:25.000000', 'consum', 0.0213, 'lps'),
	(388299, 125, '2015-02-01 00:37:26.000000', 'consum', 0.0228, 'lps'),
	(388300, 125, '2015-02-01 00:37:27.000000', 'consum', 0.0210, 'lps'),
	(388301, 125, '2015-02-01 00:37:28.000000', 'consum', 0.0211, 'lps'),
	(388302, 125, '2015-02-01 00:37:29.000000', 'consum', 0.0213, 'lps'),
	(388303, 125, '2015-02-01 00:37:30.000000', 'consum', 0.0225, 'lps'),
	(388304, 125, '2015-02-01 00:37:31.000000', 'consum', 0.0220, 'lps'),
	(388305, 125, '2015-02-01 00:37:32.000000', 'consum', 0.0215, 'lps'),
	(388306, 125, '2015-02-01 00:37:33.000000', 'consum', 0.0234, 'lps'),
	(388307, 125, '2015-02-01 00:37:34.000000', 'consum', 0.0236, 'lps'),
	(388308, 125, '2015-02-01 00:37:35.000000', 'consum', 0.0212, 'lps'),
	(388309, 125, '2015-02-01 00:37:36.000000', 'consum', 0.0225, 'lps'),
	(388310, 125, '2015-02-01 00:37:37.000000', 'consum', 0.0223, 'lps'),
	(388311, 125, '2015-02-01 00:37:38.000000', 'consum', 0.0232, 'lps'),
	(388312, 125, '2015-02-01 00:37:39.000000', 'consum', 0.0226, 'lps'),
	(388313, 125, '2015-02-01 00:37:40.000000', 'consum', 0.0225, 'lps'),
	(388314, 125, '2015-02-01 00:37:41.000000', 'consum', 0.0213, 'lps'),
	(388315, 125, '2015-02-01 00:37:42.000000', 'consum', 0.0232, 'lps'),
	(388316, 125, '2015-02-01 00:37:43.000000', 'consum', 0.0233, 'lps'),
	(388317, 125, '2015-02-01 00:37:44.000000', 'consum', 0.0232, 'lps'),
	(388318, 125, '2015-02-01 00:37:45.000000', 'consum', 0.0225, 'lps'),
	(388319, 125, '2015-02-01 00:37:46.000000', 'consum', 0.0220, 'lps'),
	(388320, 125, '2015-02-01 00:37:47.000000', 'consum', 0.0213, 'lps'),
	(388321, 125, '2015-02-01 00:37:48.000000', 'consum', 0.0223, 'lps'),
	(388322, 125, '2015-02-01 00:37:49.000000', 'consum', 0.0211, 'lps'),
	(388323, 125, '2015-02-01 00:37:50.000000', 'consum', 0.0233, 'lps'),
	(388324, 125, '2015-02-01 00:37:51.000000', 'consum', 0.0214, 'lps'),
	(388325, 125, '2015-02-01 00:37:52.000000', 'consum', 0.0215, 'lps'),
	(388326, 125, '2015-02-01 00:37:53.000000', 'consum', 0.0223, 'lps'),
	(388327, 125, '2015-02-01 00:37:54.000000', 'consum', 0.0232, 'lps'),
	(388328, 125, '2015-02-01 00:37:55.000000', 'consum', 0.0231, 'lps'),
	(388329, 125, '2015-02-01 00:37:56.000000', 'consum', 0.0220, 'lps'),
	(388330, 125, '2015-02-01 00:37:57.000000', 'consum', 0.0224, 'lps'),
	(388331, 125, '2015-02-01 00:37:58.000000', 'consum', 0.0226, 'lps'),
	(388332, 125, '2015-02-01 00:37:59.000000', 'consum', 0.0219, 'lps'),
	(388333, 125, '2015-02-01 00:38:00.000000', 'consum', 0.0234, 'lps'),
	(388334, 125, '2015-02-01 00:38:01.000000', 'consum', 0.0224, 'lps'),
	(388335, 125, '2015-02-01 00:38:02.000000', 'consum', 0.0236, 'lps'),
	(388336, 125, '2015-02-01 00:38:03.000000', 'consum', 0.0217, 'lps'),
	(388337, 125, '2015-02-01 00:38:04.000000', 'consum', 0.0222, 'lps'),
	(388338, 125, '2015-02-01 00:38:05.000000', 'consum', 0.0224, 'lps'),
	(388339, 125, '2015-02-01 00:38:06.000000', 'consum', 0.0217, 'lps'),
	(388340, 125, '2015-02-01 00:38:07.000000', 'consum', 0.0230, 'lps'),
	(388341, 125, '2015-02-01 00:38:08.000000', 'consum', 0.0236, 'lps'),
	(388342, 125, '2015-02-01 00:38:09.000000', 'consum', 0.0228, 'lps'),
	(388343, 125, '2015-02-01 00:38:10.000000', 'consum', 0.0220, 'lps'),
	(388344, 125, '2015-02-01 00:38:11.000000', 'consum', 0.0234, 'lps'),
	(388345, 125, '2015-02-01 00:38:12.000000', 'consum', 0.0219, 'lps'),
	(388346, 125, '2015-02-01 00:38:13.000000', 'consum', 0.0236, 'lps'),
	(388347, 125, '2015-02-01 00:38:14.000000', 'consum', 0.0235, 'lps'),
	(388348, 125, '2015-02-01 00:38:15.000000', 'consum', 0.0229, 'lps'),
	(388349, 125, '2015-02-01 00:38:16.000000', 'consum', 0.0230, 'lps'),
	(388350, 125, '2015-02-01 00:38:17.000000', 'consum', 0.0229, 'lps'),
	(388351, 125, '2015-02-01 00:38:18.000000', 'consum', 0.0217, 'lps'),
	(388352, 125, '2015-02-01 00:38:19.000000', 'consum', 0.0218, 'lps'),
	(388353, 125, '2015-02-01 00:38:20.000000', 'consum', 0.0227, 'lps'),
	(388354, 125, '2015-02-01 00:38:21.000000', 'consum', 0.0218, 'lps'),
	(388355, 125, '2015-02-01 00:38:22.000000', 'consum', 0.0228, 'lps'),
	(388356, 125, '2015-02-01 00:38:23.000000', 'consum', 0.0221, 'lps'),
	(388357, 125, '2015-02-01 00:38:24.000000', 'consum', 0.0213, 'lps'),
	(388358, 125, '2015-02-01 00:38:25.000000', 'consum', 0.0220, 'lps'),
	(388359, 125, '2015-02-01 00:38:26.000000', 'consum', 0.0225, 'lps'),
	(388360, 125, '2015-02-01 00:38:27.000000', 'consum', 0.0226, 'lps'),
	(388361, 125, '2015-02-01 00:38:28.000000', 'consum', 0.0220, 'lps'),
	(388362, 125, '2015-02-01 00:38:29.000000', 'consum', 0.0214, 'lps'),
	(388363, 125, '2015-02-01 00:38:30.000000', 'consum', 0.0225, 'lps'),
	(388364, 125, '2015-02-01 00:38:31.000000', 'consum', 0.0222, 'lps'),
	(388365, 125, '2015-02-01 00:38:32.000000', 'consum', 0.0224, 'lps'),
	(388366, 125, '2015-02-01 00:38:33.000000', 'consum', 0.0219, 'lps'),
	(388367, 125, '2015-02-01 00:38:34.000000', 'consum', 0.0212, 'lps'),
	(388368, 125, '2015-02-01 00:38:35.000000', 'consum', 0.0222, 'lps'),
	(388369, 125, '2015-02-01 00:38:36.000000', 'consum', 0.0235, 'lps'),
	(388370, 125, '2015-02-01 00:38:37.000000', 'consum', 0.0220, 'lps'),
	(388371, 125, '2015-02-01 00:38:38.000000', 'consum', 0.0214, 'lps'),
	(388372, 125, '2015-02-01 00:38:39.000000', 'consum', 0.0228, 'lps'),
	(388373, 125, '2015-02-01 00:38:40.000000', 'consum', 0.0234, 'lps'),
	(388374, 125, '2015-02-01 00:38:41.000000', 'consum', 0.0224, 'lps'),
	(388375, 125, '2015-02-01 00:38:42.000000', 'consum', 0.0232, 'lps'),
	(388376, 125, '2015-02-01 00:38:43.000000', 'consum', 0.0227, 'lps'),
	(388377, 125, '2015-02-01 00:38:44.000000', 'consum', 0.0228, 'lps'),
	(388378, 125, '2015-02-01 00:38:45.000000', 'consum', 0.0222, 'lps'),
	(388379, 125, '2015-02-01 00:38:46.000000', 'consum', 0.0219, 'lps'),
	(388380, 125, '2015-02-01 00:38:47.000000', 'consum', 0.0218, 'lps'),
	(388381, 125, '2015-02-01 00:38:48.000000', 'consum', 0.0224, 'lps'),
	(388382, 125, '2015-02-01 00:38:49.000000', 'consum', 0.0228, 'lps'),
	(388383, 125, '2015-02-01 00:38:50.000000', 'consum', 0.0233, 'lps'),
	(388384, 125, '2015-02-01 00:38:51.000000', 'consum', 0.0219, 'lps'),
	(388385, 125, '2015-02-01 00:38:52.000000', 'consum', 0.0211, 'lps'),
	(388386, 125, '2015-02-01 00:38:53.000000', 'consum', 0.0218, 'lps'),
	(388387, 125, '2015-02-01 00:38:54.000000', 'consum', 0.0220, 'lps'),
	(388388, 125, '2015-02-01 00:38:55.000000', 'consum', 0.0210, 'lps'),
	(388389, 125, '2015-02-01 00:38:56.000000', 'consum', 0.0234, 'lps'),
	(388390, 125, '2015-02-01 00:38:57.000000', 'consum', 0.0222, 'lps'),
	(388391, 125, '2015-02-01 00:38:58.000000', 'consum', 0.0226, 'lps'),
	(388392, 125, '2015-02-01 00:38:59.000000', 'consum', 0.0228, 'lps'),
	(388393, 125, '2015-02-01 00:39:00.000000', 'consum', 0.0227, 'lps'),
	(388394, 125, '2015-02-01 00:39:01.000000', 'consum', 0.0213, 'lps'),
	(388395, 125, '2015-02-01 00:39:02.000000', 'consum', 0.0230, 'lps'),
	(388396, 125, '2015-02-01 00:39:03.000000', 'consum', 0.0219, 'lps'),
	(388397, 125, '2015-02-01 00:39:04.000000', 'consum', 0.0221, 'lps'),
	(388398, 125, '2015-02-01 00:39:05.000000', 'consum', 0.0213, 'lps'),
	(388399, 125, '2015-02-01 00:39:06.000000', 'consum', 0.0220, 'lps'),
	(388400, 125, '2015-02-01 00:39:07.000000', 'consum', 0.0226, 'lps'),
	(388401, 125, '2015-02-01 00:39:08.000000', 'consum', 0.0233, 'lps'),
	(388402, 125, '2015-02-01 00:39:09.000000', 'consum', 0.0221, 'lps'),
	(388403, 125, '2015-02-01 00:39:10.000000', 'consum', 0.0224, 'lps'),
	(388404, 125, '2015-02-01 00:39:11.000000', 'consum', 0.0222, 'lps'),
	(388405, 125, '2015-02-01 00:39:12.000000', 'consum', 0.0230, 'lps'),
	(388406, 125, '2015-02-01 00:39:13.000000', 'consum', 0.0217, 'lps'),
	(388407, 125, '2015-02-01 00:39:14.000000', 'consum', 0.0215, 'lps'),
	(388408, 125, '2015-02-01 00:39:15.000000', 'consum', 0.0213, 'lps'),
	(388409, 125, '2015-02-01 00:39:16.000000', 'consum', 0.0212, 'lps'),
	(388410, 125, '2015-02-01 00:39:17.000000', 'consum', 0.0212, 'lps'),
	(388411, 125, '2015-02-01 00:39:18.000000', 'consum', 0.0216, 'lps'),
	(388412, 125, '2015-02-01 00:39:19.000000', 'consum', 0.0232, 'lps'),
	(388413, 125, '2015-02-01 00:39:20.000000', 'consum', 0.0220, 'lps'),
	(388414, 125, '2015-02-01 00:39:21.000000', 'consum', 0.0224, 'lps'),
	(388415, 125, '2015-02-01 00:39:22.000000', 'consum', 0.0224, 'lps'),
	(388416, 125, '2015-02-01 00:39:23.000000', 'consum', 0.0236, 'lps'),
	(388417, 125, '2015-02-01 00:39:24.000000', 'consum', 0.0219, 'lps'),
	(388418, 125, '2015-02-01 00:39:25.000000', 'consum', 0.0232, 'lps'),
	(388419, 125, '2015-02-01 00:39:26.000000', 'consum', 0.0214, 'lps'),
	(388420, 125, '2015-02-01 00:39:27.000000', 'consum', 0.0216, 'lps'),
	(388421, 125, '2015-02-01 00:39:28.000000', 'consum', 0.0229, 'lps'),
	(388422, 125, '2015-02-01 00:39:29.000000', 'consum', 0.0232, 'lps'),
	(388423, 125, '2015-02-01 00:39:30.000000', 'consum', 0.0236, 'lps'),
	(388424, 125, '2015-02-01 00:39:31.000000', 'consum', 0.0223, 'lps'),
	(388425, 125, '2015-02-01 00:39:32.000000', 'consum', 0.0224, 'lps'),
	(388426, 125, '2015-02-01 00:39:33.000000', 'consum', 0.0214, 'lps'),
	(388427, 125, '2015-02-01 00:39:34.000000', 'consum', 0.0218, 'lps'),
	(388428, 125, '2015-02-01 00:39:35.000000', 'consum', 0.0235, 'lps'),
	(388429, 125, '2015-02-01 00:39:36.000000', 'consum', 0.0233, 'lps'),
	(388430, 125, '2015-02-01 00:39:37.000000', 'consum', 0.0221, 'lps'),
	(388431, 125, '2015-02-01 00:39:38.000000', 'consum', 0.0226, 'lps'),
	(388432, 125, '2015-02-01 00:39:39.000000', 'consum', 0.0229, 'lps'),
	(388433, 125, '2015-02-01 00:39:40.000000', 'consum', 0.0231, 'lps'),
	(388434, 125, '2015-02-01 00:39:41.000000', 'consum', 0.0231, 'lps'),
	(388435, 125, '2015-02-01 00:39:42.000000', 'consum', 0.0226, 'lps'),
	(388436, 125, '2015-02-01 00:39:43.000000', 'consum', 0.0229, 'lps'),
	(388437, 125, '2015-02-01 00:39:44.000000', 'consum', 0.0231, 'lps'),
	(388438, 125, '2015-02-01 00:39:45.000000', 'consum', 0.0229, 'lps'),
	(388439, 125, '2015-02-01 00:39:46.000000', 'consum', 0.0218, 'lps'),
	(388440, 125, '2015-02-01 00:39:47.000000', 'consum', 0.0220, 'lps'),
	(388441, 125, '2015-02-01 00:39:48.000000', 'consum', 0.0211, 'lps'),
	(388442, 125, '2015-02-01 00:39:49.000000', 'consum', 0.0211, 'lps'),
	(388443, 125, '2015-02-01 00:39:50.000000', 'consum', 0.0213, 'lps'),
	(388444, 125, '2015-02-01 00:39:51.000000', 'consum', 0.0221, 'lps'),
	(388445, 125, '2015-02-01 00:39:52.000000', 'consum', 0.0231, 'lps'),
	(388446, 125, '2015-02-01 00:39:53.000000', 'consum', 0.0226, 'lps'),
	(388447, 125, '2015-02-01 00:39:54.000000', 'consum', 0.0231, 'lps'),
	(388448, 125, '2015-02-01 00:39:55.000000', 'consum', 0.0211, 'lps'),
	(388449, 125, '2015-02-01 00:39:56.000000', 'consum', 0.0234, 'lps'),
	(388450, 125, '2015-02-01 00:39:57.000000', 'consum', 0.0222, 'lps'),
	(388451, 125, '2015-02-01 00:39:58.000000', 'consum', 0.0222, 'lps'),
	(388452, 125, '2015-02-01 00:39:59.000000', 'consum', 0.0236, 'lps'),
	(388453, 125, '2015-02-01 00:40:00.000000', 'consum', 0.0222, 'lps'),
	(388454, 125, '2015-02-01 00:40:01.000000', 'consum', 0.0221, 'lps'),
	(388455, 125, '2015-02-01 00:40:02.000000', 'consum', 0.0230, 'lps'),
	(388456, 125, '2015-02-01 00:40:03.000000', 'consum', 0.0223, 'lps'),
	(388457, 125, '2015-02-01 00:40:04.000000', 'consum', 0.0214, 'lps'),
	(388458, 125, '2015-02-01 00:40:05.000000', 'consum', 0.0218, 'lps'),
	(388459, 125, '2015-02-01 00:40:06.000000', 'consum', 0.0213, 'lps'),
	(388460, 125, '2015-02-01 00:40:07.000000', 'consum', 0.0229, 'lps'),
	(388461, 125, '2015-02-01 00:40:08.000000', 'consum', 0.0213, 'lps'),
	(388462, 125, '2015-02-01 00:40:09.000000', 'consum', 0.0224, 'lps'),
	(388463, 125, '2015-02-01 00:40:10.000000', 'consum', 0.0219, 'lps'),
	(388464, 125, '2015-02-01 00:40:11.000000', 'consum', 0.0214, 'lps'),
	(388465, 125, '2015-02-01 00:40:12.000000', 'consum', 0.0228, 'lps'),
	(388466, 125, '2015-02-01 00:40:13.000000', 'consum', 0.0233, 'lps'),
	(388467, 125, '2015-02-01 00:40:14.000000', 'consum', 0.0221, 'lps'),
	(388468, 125, '2015-02-01 00:40:15.000000', 'consum', 0.0221, 'lps'),
	(388469, 125, '2015-02-01 00:40:16.000000', 'consum', 0.0235, 'lps'),
	(388470, 125, '2015-02-01 00:40:17.000000', 'consum', 0.0222, 'lps'),
	(388471, 125, '2015-02-01 00:40:18.000000', 'consum', 0.0223, 'lps'),
	(388472, 125, '2015-02-01 00:40:19.000000', 'consum', 0.0210, 'lps'),
	(388473, 125, '2015-02-01 00:40:20.000000', 'consum', 0.0228, 'lps'),
	(388474, 125, '2015-02-01 00:40:21.000000', 'consum', 0.0218, 'lps'),
	(388475, 125, '2015-02-01 00:40:22.000000', 'consum', 0.0224, 'lps'),
	(388476, 125, '2015-02-01 00:40:23.000000', 'consum', 0.0230, 'lps'),
	(388477, 125, '2015-02-01 00:40:24.000000', 'consum', 0.0212, 'lps'),
	(388478, 125, '2015-02-01 00:40:25.000000', 'consum', 0.0216, 'lps'),
	(388479, 125, '2015-02-01 00:40:26.000000', 'consum', 0.0235, 'lps'),
	(388480, 125, '2015-02-01 00:40:27.000000', 'consum', 0.0236, 'lps'),
	(388481, 125, '2015-02-01 00:40:28.000000', 'consum', 0.0210, 'lps'),
	(388482, 125, '2015-02-01 00:40:29.000000', 'consum', 0.0215, 'lps'),
	(388483, 125, '2015-02-01 00:40:30.000000', 'consum', 0.0233, 'lps'),
	(388484, 125, '2015-02-01 00:40:31.000000', 'consum', 0.0231, 'lps'),
	(388485, 125, '2015-02-01 00:40:32.000000', 'consum', 0.0221, 'lps'),
	(388486, 125, '2015-02-01 00:40:33.000000', 'consum', 0.0229, 'lps'),
	(388487, 125, '2015-02-01 00:40:34.000000', 'consum', 0.0218, 'lps'),
	(388488, 125, '2015-02-01 00:40:35.000000', 'consum', 0.0220, 'lps'),
	(388489, 125, '2015-02-01 00:40:36.000000', 'consum', 0.0210, 'lps'),
	(388490, 125, '2015-02-01 00:40:37.000000', 'consum', 0.0236, 'lps'),
	(388491, 125, '2015-02-01 00:40:38.000000', 'consum', 0.0230, 'lps'),
	(388492, 125, '2015-02-01 00:40:39.000000', 'consum', 0.0233, 'lps'),
	(388493, 125, '2015-02-01 00:40:40.000000', 'consum', 0.0213, 'lps'),
	(388494, 125, '2015-02-01 00:40:41.000000', 'consum', 0.0235, 'lps'),
	(388495, 125, '2015-02-01 00:40:42.000000', 'consum', 0.0222, 'lps'),
	(388496, 125, '2015-02-01 00:40:43.000000', 'consum', 0.0220, 'lps'),
	(388497, 125, '2015-02-01 00:40:44.000000', 'consum', 0.0223, 'lps'),
	(388498, 125, '2015-02-01 00:40:45.000000', 'consum', 0.0222, 'lps'),
	(388499, 125, '2015-02-01 00:40:46.000000', 'consum', 0.0228, 'lps'),
	(388500, 125, '2015-02-01 00:40:47.000000', 'consum', 0.0212, 'lps'),
	(388501, 125, '2015-02-01 00:40:48.000000', 'consum', 0.0222, 'lps'),
	(388502, 125, '2015-02-01 00:40:49.000000', 'consum', 0.0211, 'lps'),
	(388503, 125, '2015-02-01 00:40:50.000000', 'consum', 0.0233, 'lps'),
	(388504, 125, '2015-02-01 00:40:51.000000', 'consum', 0.0215, 'lps'),
	(388505, 125, '2015-02-01 00:40:52.000000', 'consum', 0.0219, 'lps'),
	(388506, 125, '2015-02-01 00:40:53.000000', 'consum', 0.0213, 'lps'),
	(388507, 125, '2015-02-01 00:40:54.000000', 'consum', 0.0226, 'lps'),
	(388508, 125, '2015-02-01 00:40:55.000000', 'consum', 0.0229, 'lps'),
	(388509, 125, '2015-02-01 00:40:56.000000', 'consum', 0.0228, 'lps'),
	(388510, 125, '2015-02-01 00:40:57.000000', 'consum', 0.0219, 'lps'),
	(388511, 125, '2015-02-01 00:40:58.000000', 'consum', 0.0226, 'lps'),
	(388512, 125, '2015-02-01 00:40:59.000000', 'consum', 0.0213, 'lps'),
	(388513, 125, '2015-02-01 00:41:00.000000', 'consum', 0.0228, 'lps'),
	(388514, 125, '2015-02-01 00:41:01.000000', 'consum', 0.0212, 'lps'),
	(388515, 125, '2015-02-01 00:41:02.000000', 'consum', 0.0222, 'lps'),
	(388516, 125, '2015-02-01 00:41:03.000000', 'consum', 0.0211, 'lps'),
	(388517, 125, '2015-02-01 00:41:04.000000', 'consum', 0.0232, 'lps'),
	(388518, 125, '2015-02-01 00:41:05.000000', 'consum', 0.0211, 'lps'),
	(388519, 125, '2015-02-01 00:41:06.000000', 'consum', 0.0231, 'lps'),
	(388520, 125, '2015-02-01 00:41:07.000000', 'consum', 0.0228, 'lps'),
	(388521, 125, '2015-02-01 00:41:08.000000', 'consum', 0.0214, 'lps'),
	(388522, 125, '2015-02-01 00:41:09.000000', 'consum', 0.0230, 'lps'),
	(388523, 125, '2015-02-01 00:41:10.000000', 'consum', 0.0217, 'lps'),
	(388524, 125, '2015-02-01 00:41:11.000000', 'consum', 0.0211, 'lps'),
	(388525, 125, '2015-02-01 00:41:12.000000', 'consum', 0.0224, 'lps'),
	(388526, 125, '2015-02-01 00:41:13.000000', 'consum', 0.0221, 'lps'),
	(388527, 125, '2015-02-01 00:41:14.000000', 'consum', 0.0225, 'lps'),
	(388528, 125, '2015-02-01 00:41:15.000000', 'consum', 0.0224, 'lps'),
	(388529, 125, '2015-02-01 00:41:16.000000', 'consum', 0.0210, 'lps'),
	(388530, 125, '2015-02-01 00:41:17.000000', 'consum', 0.0220, 'lps'),
	(388531, 125, '2015-02-01 00:41:18.000000', 'consum', 0.0210, 'lps'),
	(388532, 125, '2015-02-01 00:41:19.000000', 'consum', 0.0233, 'lps'),
	(388533, 125, '2015-02-01 00:41:20.000000', 'consum', 0.0219, 'lps'),
	(388534, 125, '2015-02-01 00:41:21.000000', 'consum', 0.0211, 'lps'),
	(388535, 125, '2015-02-01 00:41:22.000000', 'consum', 0.0218, 'lps'),
	(388536, 125, '2015-02-01 00:41:23.000000', 'consum', 0.0221, 'lps'),
	(388537, 125, '2015-02-01 00:41:24.000000', 'consum', 0.0215, 'lps'),
	(388538, 125, '2015-02-01 00:41:25.000000', 'consum', 0.0230, 'lps'),
	(388539, 125, '2015-02-01 00:41:26.000000', 'consum', 0.0214, 'lps'),
	(388540, 125, '2015-02-01 00:41:27.000000', 'consum', 0.0225, 'lps'),
	(388541, 125, '2015-02-01 00:41:28.000000', 'consum', 0.0219, 'lps'),
	(388542, 125, '2015-02-01 00:41:29.000000', 'consum', 0.0212, 'lps'),
	(388543, 125, '2015-02-01 00:41:30.000000', 'consum', 0.0218, 'lps'),
	(388544, 125, '2015-02-01 00:41:31.000000', 'consum', 0.0218, 'lps'),
	(388545, 125, '2015-02-01 00:41:32.000000', 'consum', 0.0229, 'lps'),
	(388546, 125, '2015-02-01 00:41:33.000000', 'consum', 0.0225, 'lps'),
	(388547, 125, '2015-02-01 00:41:34.000000', 'consum', 0.0229, 'lps'),
	(388548, 125, '2015-02-01 00:41:35.000000', 'consum', 0.0234, 'lps'),
	(388549, 125, '2015-02-01 00:41:36.000000', 'consum', 0.0220, 'lps'),
	(388550, 125, '2015-02-01 00:41:37.000000', 'consum', 0.0217, 'lps'),
	(388551, 125, '2015-02-01 00:41:38.000000', 'consum', 0.0214, 'lps'),
	(388552, 125, '2015-02-01 00:41:39.000000', 'consum', 0.0211, 'lps'),
	(388553, 125, '2015-02-01 00:41:40.000000', 'consum', 0.0231, 'lps'),
	(388554, 125, '2015-02-01 00:41:41.000000', 'consum', 0.0232, 'lps'),
	(388555, 125, '2015-02-01 00:41:42.000000', 'consum', 0.0229, 'lps'),
	(388556, 125, '2015-02-01 00:41:43.000000', 'consum', 0.0211, 'lps'),
	(388557, 125, '2015-02-01 00:41:44.000000', 'consum', 0.0215, 'lps'),
	(388558, 125, '2015-02-01 00:41:45.000000', 'consum', 0.0231, 'lps'),
	(388559, 125, '2015-02-01 00:41:46.000000', 'consum', 0.0222, 'lps'),
	(388560, 125, '2015-02-01 00:41:47.000000', 'consum', 0.0232, 'lps'),
	(388561, 125, '2015-02-01 00:41:48.000000', 'consum', 0.0232, 'lps'),
	(388562, 125, '2015-02-01 00:41:49.000000', 'consum', 0.0226, 'lps'),
	(388563, 125, '2015-02-01 00:41:50.000000', 'consum', 0.0226, 'lps'),
	(388564, 125, '2015-02-01 00:41:51.000000', 'consum', 0.0213, 'lps'),
	(388565, 125, '2015-02-01 00:41:52.000000', 'consum', 0.0233, 'lps'),
	(388566, 125, '2015-02-01 00:41:53.000000', 'consum', 0.0234, 'lps'),
	(388567, 125, '2015-02-01 00:41:54.000000', 'consum', 0.0234, 'lps'),
	(388568, 125, '2015-02-01 00:41:55.000000', 'consum', 0.0233, 'lps'),
	(388569, 125, '2015-02-01 00:41:56.000000', 'consum', 0.0226, 'lps'),
	(388570, 125, '2015-02-01 00:41:57.000000', 'consum', 0.0221, 'lps'),
	(388571, 125, '2015-02-01 00:41:58.000000', 'consum', 0.0218, 'lps'),
	(388572, 125, '2015-02-01 00:41:59.000000', 'consum', 0.0217, 'lps'),
	(388573, 125, '2015-02-01 00:42:00.000000', 'consum', 0.0220, 'lps'),
	(388574, 125, '2015-02-01 00:42:01.000000', 'consum', 0.0215, 'lps'),
	(388575, 125, '2015-02-01 00:42:02.000000', 'consum', 0.0230, 'lps'),
	(388576, 125, '2015-02-01 00:42:03.000000', 'consum', 0.0216, 'lps'),
	(388577, 125, '2015-02-01 00:42:04.000000', 'consum', 0.0234, 'lps'),
	(388578, 125, '2015-02-01 00:42:05.000000', 'consum', 0.0234, 'lps'),
	(388579, 125, '2015-02-01 00:42:06.000000', 'consum', 0.0229, 'lps'),
	(388580, 125, '2015-02-01 00:42:07.000000', 'consum', 0.0232, 'lps'),
	(388581, 125, '2015-02-01 00:42:08.000000', 'consum', 0.0211, 'lps'),
	(388582, 125, '2015-02-01 00:42:09.000000', 'consum', 0.0231, 'lps'),
	(388583, 125, '2015-02-01 00:42:10.000000', 'consum', 0.0230, 'lps'),
	(388584, 125, '2015-02-01 00:42:11.000000', 'consum', 0.0219, 'lps'),
	(388585, 125, '2015-02-01 00:42:12.000000', 'consum', 0.0225, 'lps'),
	(388586, 125, '2015-02-01 00:42:13.000000', 'consum', 0.0232, 'lps'),
	(388587, 125, '2015-02-01 00:42:14.000000', 'consum', 0.0221, 'lps'),
	(388588, 125, '2015-02-01 00:42:15.000000', 'consum', 0.0226, 'lps'),
	(388589, 125, '2015-02-01 00:42:16.000000', 'consum', 0.0232, 'lps'),
	(388590, 125, '2015-02-01 00:42:17.000000', 'consum', 0.0219, 'lps'),
	(388591, 125, '2015-02-01 00:42:18.000000', 'consum', 0.0216, 'lps'),
	(388592, 125, '2015-02-01 00:42:19.000000', 'consum', 0.0212, 'lps'),
	(388593, 125, '2015-02-01 00:42:20.000000', 'consum', 0.0231, 'lps'),
	(388594, 125, '2015-02-01 00:42:21.000000', 'consum', 0.0229, 'lps'),
	(388595, 125, '2015-02-01 00:42:22.000000', 'consum', 0.0216, 'lps'),
	(388596, 125, '2015-02-01 00:42:23.000000', 'consum', 0.0211, 'lps'),
	(388597, 125, '2015-02-01 00:42:24.000000', 'consum', 0.0224, 'lps'),
	(388598, 125, '2015-02-01 00:42:25.000000', 'consum', 0.0223, 'lps'),
	(388599, 125, '2015-02-01 00:42:26.000000', 'consum', 0.0233, 'lps'),
	(388600, 125, '2015-02-01 00:42:27.000000', 'consum', 0.0233, 'lps'),
	(388601, 125, '2015-02-01 00:42:28.000000', 'consum', 0.0231, 'lps'),
	(388602, 125, '2015-02-01 00:42:29.000000', 'consum', 0.0220, 'lps'),
	(388603, 125, '2015-02-01 00:42:30.000000', 'consum', 0.0222, 'lps'),
	(388604, 125, '2015-02-01 00:42:31.000000', 'consum', 0.0214, 'lps'),
	(388605, 125, '2015-02-01 00:42:32.000000', 'consum', 0.0223, 'lps'),
	(388606, 125, '2015-02-01 00:42:33.000000', 'consum', 0.0236, 'lps'),
	(388607, 125, '2015-02-01 00:42:34.000000', 'consum', 0.0221, 'lps'),
	(388608, 125, '2015-02-01 00:42:35.000000', 'consum', 0.0213, 'lps'),
	(388609, 125, '2015-02-01 00:42:36.000000', 'consum', 0.0222, 'lps'),
	(388610, 125, '2015-02-01 00:42:37.000000', 'consum', 0.0234, 'lps'),
	(388611, 125, '2015-02-01 00:42:38.000000', 'consum', 0.0213, 'lps'),
	(388612, 125, '2015-02-01 00:42:39.000000', 'consum', 0.0235, 'lps'),
	(388613, 125, '2015-02-01 00:42:40.000000', 'consum', 0.0217, 'lps'),
	(388614, 125, '2015-02-01 00:42:41.000000', 'consum', 0.0225, 'lps'),
	(388615, 125, '2015-02-01 00:42:42.000000', 'consum', 0.0211, 'lps'),
	(388616, 125, '2015-02-01 00:42:43.000000', 'consum', 0.0225, 'lps'),
	(388617, 125, '2015-02-01 00:42:44.000000', 'consum', 0.0228, 'lps'),
	(388618, 125, '2015-02-01 00:42:45.000000', 'consum', 0.0229, 'lps'),
	(388619, 125, '2015-02-01 00:42:46.000000', 'consum', 0.0225, 'lps'),
	(388620, 125, '2015-02-01 00:42:47.000000', 'consum', 0.0228, 'lps'),
	(388621, 125, '2015-02-01 00:42:48.000000', 'consum', 0.0230, 'lps'),
	(388622, 125, '2015-02-01 00:42:49.000000', 'consum', 0.0226, 'lps'),
	(388623, 125, '2015-02-01 00:42:50.000000', 'consum', 0.0234, 'lps'),
	(388624, 125, '2015-02-01 00:42:51.000000', 'consum', 0.0227, 'lps'),
	(388625, 125, '2015-02-01 00:42:52.000000', 'consum', 0.0224, 'lps'),
	(388626, 125, '2015-02-01 00:42:53.000000', 'consum', 0.0228, 'lps'),
	(388627, 125, '2015-02-01 00:42:54.000000', 'consum', 0.0234, 'lps'),
	(388628, 125, '2015-02-01 00:42:55.000000', 'consum', 0.0223, 'lps'),
	(388629, 125, '2015-02-01 00:42:56.000000', 'consum', 0.0231, 'lps'),
	(388630, 125, '2015-02-01 00:42:57.000000', 'consum', 0.0222, 'lps'),
	(388631, 125, '2015-02-01 00:42:58.000000', 'consum', 0.0234, 'lps'),
	(388632, 125, '2015-02-01 00:42:59.000000', 'consum', 0.0214, 'lps'),
	(388633, 125, '2015-02-01 00:43:00.000000', 'consum', 0.0214, 'lps'),
	(388634, 125, '2015-02-01 00:43:01.000000', 'consum', 0.0217, 'lps'),
	(388635, 125, '2015-02-01 00:43:02.000000', 'consum', 0.0232, 'lps'),
	(388636, 125, '2015-02-01 00:43:03.000000', 'consum', 0.0219, 'lps'),
	(388637, 125, '2015-02-01 00:43:04.000000', 'consum', 0.0218, 'lps'),
	(388638, 125, '2015-02-01 00:43:05.000000', 'consum', 0.0222, 'lps'),
	(388639, 125, '2015-02-01 00:43:06.000000', 'consum', 0.0221, 'lps'),
	(388640, 125, '2015-02-01 00:43:07.000000', 'consum', 0.0229, 'lps'),
	(388641, 125, '2015-02-01 00:43:08.000000', 'consum', 0.0218, 'lps'),
	(388642, 125, '2015-02-01 00:43:09.000000', 'consum', 0.0219, 'lps'),
	(388643, 125, '2015-02-01 00:43:10.000000', 'consum', 0.0234, 'lps'),
	(388644, 125, '2015-02-01 00:43:11.000000', 'consum', 0.0223, 'lps'),
	(388645, 125, '2015-02-01 00:43:12.000000', 'consum', 0.0231, 'lps'),
	(388646, 125, '2015-02-01 00:43:13.000000', 'consum', 0.0223, 'lps'),
	(388647, 125, '2015-02-01 00:43:14.000000', 'consum', 0.0213, 'lps'),
	(388648, 125, '2015-02-01 00:43:15.000000', 'consum', 0.0211, 'lps'),
	(388649, 125, '2015-02-01 00:43:16.000000', 'consum', 0.0234, 'lps'),
	(388650, 125, '2015-02-01 00:43:17.000000', 'consum', 0.0220, 'lps'),
	(388651, 125, '2015-02-01 00:43:18.000000', 'consum', 0.0217, 'lps'),
	(388652, 125, '2015-02-01 00:43:19.000000', 'consum', 0.0213, 'lps'),
	(388653, 125, '2015-02-01 00:43:20.000000', 'consum', 0.0232, 'lps'),
	(388654, 125, '2015-02-01 00:43:21.000000', 'consum', 0.0231, 'lps'),
	(388655, 125, '2015-02-01 00:43:22.000000', 'consum', 0.0221, 'lps'),
	(388656, 125, '2015-02-01 00:43:23.000000', 'consum', 0.0232, 'lps'),
	(388657, 125, '2015-02-01 00:43:24.000000', 'consum', 0.0231, 'lps'),
	(388658, 125, '2015-02-01 00:43:25.000000', 'consum', 0.0225, 'lps'),
	(388659, 125, '2015-02-01 00:43:26.000000', 'consum', 0.0223, 'lps'),
	(388660, 125, '2015-02-01 00:43:27.000000', 'consum', 0.0230, 'lps'),
	(388661, 125, '2015-02-01 00:43:28.000000', 'consum', 0.0216, 'lps'),
	(388662, 125, '2015-02-01 00:43:29.000000', 'consum', 0.0236, 'lps'),
	(388663, 125, '2015-02-01 00:43:30.000000', 'consum', 0.0215, 'lps'),
	(388664, 125, '2015-02-01 00:43:31.000000', 'consum', 0.0211, 'lps'),
	(388665, 125, '2015-02-01 00:43:32.000000', 'consum', 0.0227, 'lps'),
	(388666, 125, '2015-02-01 00:43:33.000000', 'consum', 0.0214, 'lps'),
	(388667, 125, '2015-02-01 00:43:34.000000', 'consum', 0.0231, 'lps'),
	(388668, 125, '2015-02-01 00:43:35.000000', 'consum', 0.0224, 'lps'),
	(388669, 125, '2015-02-01 00:43:36.000000', 'consum', 0.0219, 'lps'),
	(388670, 125, '2015-02-01 00:43:37.000000', 'consum', 0.0211, 'lps'),
	(388671, 125, '2015-02-01 00:43:38.000000', 'consum', 0.0216, 'lps'),
	(388672, 125, '2015-02-01 00:43:39.000000', 'consum', 0.0236, 'lps'),
	(388673, 125, '2015-02-01 00:43:40.000000', 'consum', 0.0217, 'lps'),
	(388674, 125, '2015-02-01 00:43:41.000000', 'consum', 0.0220, 'lps'),
	(388675, 125, '2015-02-01 00:43:42.000000', 'consum', 0.0213, 'lps'),
	(388676, 125, '2015-02-01 00:43:43.000000', 'consum', 0.0221, 'lps'),
	(388677, 125, '2015-02-01 00:43:44.000000', 'consum', 0.0232, 'lps'),
	(388678, 125, '2015-02-01 00:43:45.000000', 'consum', 0.0232, 'lps'),
	(388679, 125, '2015-02-01 00:43:46.000000', 'consum', 0.0227, 'lps'),
	(388680, 125, '2015-02-01 00:43:47.000000', 'consum', 0.0232, 'lps'),
	(388681, 125, '2015-02-01 00:43:48.000000', 'consum', 0.0215, 'lps'),
	(388682, 125, '2015-02-01 00:43:49.000000', 'consum', 0.0222, 'lps'),
	(388683, 125, '2015-02-01 00:43:50.000000', 'consum', 0.0231, 'lps'),
	(388684, 125, '2015-02-01 00:43:51.000000', 'consum', 0.0222, 'lps'),
	(388685, 125, '2015-02-01 00:43:52.000000', 'consum', 0.0211, 'lps'),
	(388686, 125, '2015-02-01 00:43:53.000000', 'consum', 0.0233, 'lps'),
	(388687, 125, '2015-02-01 00:43:54.000000', 'consum', 0.0212, 'lps'),
	(388688, 125, '2015-02-01 00:43:55.000000', 'consum', 0.0234, 'lps'),
	(388689, 125, '2015-02-01 00:43:56.000000', 'consum', 0.0217, 'lps'),
	(388690, 125, '2015-02-01 00:43:57.000000', 'consum', 0.0227, 'lps'),
	(388691, 125, '2015-02-01 00:43:58.000000', 'consum', 0.0220, 'lps'),
	(388692, 125, '2015-02-01 00:43:59.000000', 'consum', 0.0212, 'lps'),
	(388693, 125, '2015-02-01 00:44:00.000000', 'consum', 0.0216, 'lps'),
	(388694, 125, '2015-02-01 00:44:01.000000', 'consum', 0.0234, 'lps'),
	(388695, 125, '2015-02-01 00:44:02.000000', 'consum', 0.0234, 'lps'),
	(388696, 125, '2015-02-01 00:44:03.000000', 'consum', 0.0229, 'lps'),
	(388697, 125, '2015-02-01 00:44:04.000000', 'consum', 0.0232, 'lps'),
	(388698, 125, '2015-02-01 00:44:05.000000', 'consum', 0.0211, 'lps'),
	(388699, 125, '2015-02-01 00:44:06.000000', 'consum', 0.0233, 'lps'),
	(388700, 125, '2015-02-01 00:44:07.000000', 'consum', 0.0211, 'lps'),
	(388701, 125, '2015-02-01 00:44:08.000000', 'consum', 0.0229, 'lps'),
	(388702, 125, '2015-02-01 00:44:09.000000', 'consum', 0.0223, 'lps'),
	(388703, 125, '2015-02-01 00:44:10.000000', 'consum', 0.0216, 'lps'),
	(388704, 125, '2015-02-01 00:44:11.000000', 'consum', 0.0231, 'lps'),
	(388705, 125, '2015-02-01 00:44:12.000000', 'consum', 0.0214, 'lps'),
	(388706, 125, '2015-02-01 00:44:13.000000', 'consum', 0.0222, 'lps'),
	(388707, 125, '2015-02-01 00:44:14.000000', 'consum', 0.0232, 'lps'),
	(388708, 125, '2015-02-01 00:44:15.000000', 'consum', 0.0230, 'lps'),
	(388709, 125, '2015-02-01 00:44:16.000000', 'consum', 0.0218, 'lps'),
	(388710, 125, '2015-02-01 00:44:17.000000', 'consum', 0.0219, 'lps'),
	(388711, 125, '2015-02-01 00:44:18.000000', 'consum', 0.0229, 'lps'),
	(388712, 125, '2015-02-01 00:44:19.000000', 'consum', 0.0224, 'lps'),
	(388713, 125, '2015-02-01 00:44:20.000000', 'consum', 0.0224, 'lps'),
	(388714, 125, '2015-02-01 00:44:21.000000', 'consum', 0.0212, 'lps'),
	(388715, 125, '2015-02-01 00:44:22.000000', 'consum', 0.0231, 'lps'),
	(388716, 125, '2015-02-01 00:44:23.000000', 'consum', 0.0230, 'lps'),
	(388717, 125, '2015-02-01 00:44:24.000000', 'consum', 0.0219, 'lps'),
	(388718, 125, '2015-02-01 00:44:25.000000', 'consum', 0.0225, 'lps'),
	(388719, 125, '2015-02-01 00:44:26.000000', 'consum', 0.0229, 'lps'),
	(388720, 125, '2015-02-01 00:44:27.000000', 'consum', 0.0233, 'lps'),
	(388721, 125, '2015-02-01 00:44:28.000000', 'consum', 0.0215, 'lps'),
	(388722, 125, '2015-02-01 00:44:29.000000', 'consum', 0.0219, 'lps'),
	(388723, 125, '2015-02-01 00:44:30.000000', 'consum', 0.0216, 'lps'),
	(388724, 125, '2015-02-01 00:44:31.000000', 'consum', 0.0212, 'lps'),
	(388725, 125, '2015-02-01 00:44:32.000000', 'consum', 0.0229, 'lps'),
	(388726, 125, '2015-02-01 00:44:33.000000', 'consum', 0.0219, 'lps'),
	(388727, 125, '2015-02-01 00:44:34.000000', 'consum', 0.0227, 'lps'),
	(388728, 125, '2015-02-01 00:44:35.000000', 'consum', 0.0213, 'lps'),
	(388729, 125, '2015-02-01 00:44:36.000000', 'consum', 0.0228, 'lps'),
	(388730, 125, '2015-02-01 00:44:37.000000', 'consum', 0.0213, 'lps'),
	(388731, 125, '2015-02-01 00:44:38.000000', 'consum', 0.0223, 'lps'),
	(388732, 125, '2015-02-01 00:44:39.000000', 'consum', 0.0213, 'lps'),
	(388733, 125, '2015-02-01 00:44:40.000000', 'consum', 0.0213, 'lps'),
	(388734, 125, '2015-02-01 00:44:41.000000', 'consum', 0.0215, 'lps'),
	(388735, 125, '2015-02-01 00:44:42.000000', 'consum', 0.0229, 'lps'),
	(388736, 125, '2015-02-01 00:44:43.000000', 'consum', 0.0210, 'lps'),
	(388737, 125, '2015-02-01 00:44:44.000000', 'consum', 0.0232, 'lps'),
	(388738, 125, '2015-02-01 00:44:45.000000', 'consum', 0.0213, 'lps'),
	(388739, 125, '2015-02-01 00:44:46.000000', 'consum', 0.0214, 'lps'),
	(388740, 125, '2015-02-01 00:44:47.000000', 'consum', 0.0219, 'lps'),
	(388741, 125, '2015-02-01 00:44:48.000000', 'consum', 0.0220, 'lps'),
	(388742, 125, '2015-02-01 00:44:49.000000', 'consum', 0.0232, 'lps'),
	(388743, 125, '2015-02-01 00:44:50.000000', 'consum', 0.0210, 'lps'),
	(388744, 125, '2015-02-01 00:44:51.000000', 'consum', 0.0223, 'lps'),
	(388745, 125, '2015-02-01 00:44:52.000000', 'consum', 0.0225, 'lps'),
	(388746, 125, '2015-02-01 00:44:53.000000', 'consum', 0.0216, 'lps'),
	(388747, 125, '2015-02-01 00:44:54.000000', 'consum', 0.0225, 'lps'),
	(388748, 125, '2015-02-01 00:44:55.000000', 'consum', 0.0211, 'lps'),
	(388749, 125, '2015-02-01 00:44:56.000000', 'consum', 0.0225, 'lps'),
	(388750, 125, '2015-02-01 00:44:57.000000', 'consum', 0.0229, 'lps'),
	(388751, 125, '2015-02-01 00:44:58.000000', 'consum', 0.0234, 'lps'),
	(388752, 125, '2015-02-01 00:44:59.000000', 'consum', 0.0219, 'lps'),
	(388753, 125, '2015-02-01 00:45:00.000000', 'consum', 0.0210, 'lps'),
	(388754, 125, '2015-02-01 00:45:01.000000', 'consum', 0.0210, 'lps'),
	(388755, 125, '2015-02-01 00:45:02.000000', 'consum', 0.0211, 'lps'),
	(388756, 125, '2015-02-01 00:45:03.000000', 'consum', 0.0215, 'lps'),
	(388757, 125, '2015-02-01 00:45:04.000000', 'consum', 0.0231, 'lps'),
	(388758, 125, '2015-02-01 00:45:05.000000', 'consum', 0.0222, 'lps'),
	(388759, 125, '2015-02-01 00:45:06.000000', 'consum', 0.0236, 'lps'),
	(388760, 125, '2015-02-01 00:45:07.000000', 'consum', 0.0220, 'lps'),
	(388761, 125, '2015-02-01 00:45:08.000000', 'consum', 0.0210, 'lps'),
	(388762, 125, '2015-02-01 00:45:09.000000', 'consum', 0.0235, 'lps'),
	(388763, 125, '2015-02-01 00:45:10.000000', 'consum', 0.0228, 'lps'),
	(388764, 125, '2015-02-01 00:45:11.000000', 'consum', 0.0226, 'lps'),
	(388765, 125, '2015-02-01 00:45:12.000000', 'consum', 0.0211, 'lps'),
	(388766, 125, '2015-02-01 00:45:13.000000', 'consum', 0.0219, 'lps'),
	(388767, 125, '2015-02-01 00:45:14.000000', 'consum', 0.0228, 'lps'),
	(388768, 125, '2015-02-01 00:45:15.000000', 'consum', 0.0220, 'lps'),
	(388769, 125, '2015-02-01 00:45:16.000000', 'consum', 0.0231, 'lps'),
	(388770, 125, '2015-02-01 00:45:17.000000', 'consum', 0.0234, 'lps'),
	(388771, 125, '2015-02-01 00:45:18.000000', 'consum', 0.0211, 'lps'),
	(388772, 125, '2015-02-01 00:45:19.000000', 'consum', 0.0224, 'lps'),
	(388773, 125, '2015-02-01 00:45:20.000000', 'consum', 0.0225, 'lps'),
	(388774, 125, '2015-02-01 00:45:21.000000', 'consum', 0.0215, 'lps'),
	(388775, 125, '2015-02-01 00:45:22.000000', 'consum', 0.0217, 'lps'),
	(388776, 125, '2015-02-01 00:45:23.000000', 'consum', 0.0230, 'lps'),
	(388777, 125, '2015-02-01 00:45:24.000000', 'consum', 0.0210, 'lps'),
	(388778, 125, '2015-02-01 00:45:25.000000', 'consum', 0.0229, 'lps'),
	(388779, 125, '2015-02-01 00:45:26.000000', 'consum', 0.0228, 'lps'),
	(388780, 125, '2015-02-01 00:45:27.000000', 'consum', 0.0215, 'lps'),
	(388781, 125, '2015-02-01 00:45:28.000000', 'consum', 0.0210, 'lps'),
	(388782, 125, '2015-02-01 00:45:29.000000', 'consum', 0.0222, 'lps'),
	(388783, 125, '2015-02-01 00:45:30.000000', 'consum', 0.0215, 'lps'),
	(388784, 125, '2015-02-01 00:45:31.000000', 'consum', 0.0227, 'lps'),
	(388785, 125, '2015-02-01 00:45:32.000000', 'consum', 0.0225, 'lps'),
	(388786, 125, '2015-02-01 00:45:33.000000', 'consum', 0.0210, 'lps'),
	(388787, 125, '2015-02-01 00:45:34.000000', 'consum', 0.0217, 'lps'),
	(388788, 125, '2015-02-01 00:45:35.000000', 'consum', 0.0218, 'lps'),
	(388789, 125, '2015-02-01 00:45:36.000000', 'consum', 0.0230, 'lps'),
	(388790, 125, '2015-02-01 00:45:37.000000', 'consum', 0.0231, 'lps'),
	(388791, 125, '2015-02-01 00:45:38.000000', 'consum', 0.0230, 'lps'),
	(388792, 125, '2015-02-01 00:45:39.000000', 'consum', 0.0221, 'lps'),
	(388793, 125, '2015-02-01 00:45:40.000000', 'consum', 0.0231, 'lps'),
	(388794, 125, '2015-02-01 00:45:41.000000', 'consum', 0.0231, 'lps'),
	(388795, 125, '2015-02-01 00:45:42.000000', 'consum', 0.0225, 'lps'),
	(388796, 125, '2015-02-01 00:45:43.000000', 'consum', 0.0221, 'lps'),
	(388797, 125, '2015-02-01 00:45:44.000000', 'consum', 0.0219, 'lps'),
	(388798, 125, '2015-02-01 00:45:45.000000', 'consum', 0.0226, 'lps'),
	(388799, 125, '2015-02-01 00:45:46.000000', 'consum', 0.0233, 'lps'),
	(388800, 125, '2015-02-01 00:45:47.000000', 'consum', 0.0226, 'lps'),
	(388801, 125, '2015-02-01 00:45:48.000000', 'consum', 0.0220, 'lps'),
	(388802, 125, '2015-02-01 00:45:49.000000', 'consum', 0.0214, 'lps'),
	(388803, 125, '2015-02-01 00:45:50.000000', 'consum', 0.0227, 'lps'),
	(388804, 125, '2015-02-01 00:45:51.000000', 'consum', 0.0231, 'lps'),
	(388805, 125, '2015-02-01 00:45:52.000000', 'consum', 0.0236, 'lps'),
	(388806, 125, '2015-02-01 00:45:53.000000', 'consum', 0.0224, 'lps'),
	(388807, 125, '2015-02-01 00:45:54.000000', 'consum', 0.0230, 'lps'),
	(388808, 125, '2015-02-01 00:45:55.000000', 'consum', 0.0215, 'lps'),
	(388809, 125, '2015-02-01 00:45:56.000000', 'consum', 0.0228, 'lps'),
	(388810, 125, '2015-02-01 00:45:57.000000', 'consum', 0.0231, 'lps'),
	(388811, 125, '2015-02-01 00:45:58.000000', 'consum', 0.0236, 'lps'),
	(388812, 125, '2015-02-01 00:45:59.000000', 'consum', 0.0223, 'lps'),
	(388813, 125, '2015-02-01 00:46:00.000000', 'consum', 0.0222, 'lps'),
	(388814, 125, '2015-02-01 00:46:01.000000', 'consum', 0.0235, 'lps'),
	(388815, 125, '2015-02-01 00:46:02.000000', 'consum', 0.0219, 'lps'),
	(388816, 125, '2015-02-01 00:46:03.000000', 'consum', 0.0233, 'lps'),
	(388817, 125, '2015-02-01 00:46:04.000000', 'consum', 0.0217, 'lps'),
	(388818, 125, '2015-02-01 00:46:05.000000', 'consum', 0.0233, 'lps'),
	(388819, 125, '2015-02-01 00:46:06.000000', 'consum', 0.0221, 'lps'),
	(388820, 125, '2015-02-01 00:46:07.000000', 'consum', 0.0226, 'lps'),
	(388821, 125, '2015-02-01 00:46:08.000000', 'consum', 0.0228, 'lps'),
	(388822, 125, '2015-02-01 00:46:09.000000', 'consum', 0.0228, 'lps'),
	(388823, 125, '2015-02-01 00:46:10.000000', 'consum', 0.0220, 'lps'),
	(388824, 125, '2015-02-01 00:46:11.000000', 'consum', 0.0232, 'lps'),
	(388825, 125, '2015-02-01 00:46:12.000000', 'consum', 0.0210, 'lps'),
	(388826, 125, '2015-02-01 00:46:13.000000', 'consum', 0.0226, 'lps'),
	(388827, 125, '2015-02-01 00:46:14.000000', 'consum', 0.0235, 'lps'),
	(388828, 125, '2015-02-01 00:46:15.000000', 'consum', 0.0233, 'lps'),
	(388829, 125, '2015-02-01 00:46:16.000000', 'consum', 0.0223, 'lps'),
	(388830, 125, '2015-02-01 00:46:17.000000', 'consum', 0.0235, 'lps'),
	(388831, 125, '2015-02-01 00:46:18.000000', 'consum', 0.0217, 'lps'),
	(388832, 125, '2015-02-01 00:46:19.000000', 'consum', 0.0222, 'lps'),
	(388833, 125, '2015-02-01 00:46:20.000000', 'consum', 0.0222, 'lps'),
	(388834, 125, '2015-02-01 00:46:21.000000', 'consum', 0.0210, 'lps'),
	(388835, 125, '2015-02-01 00:46:22.000000', 'consum', 0.0227, 'lps'),
	(388836, 125, '2015-02-01 00:46:23.000000', 'consum', 0.0217, 'lps'),
	(388837, 125, '2015-02-01 00:46:24.000000', 'consum', 0.0219, 'lps'),
	(388838, 125, '2015-02-01 00:46:25.000000', 'consum', 0.0236, 'lps'),
	(388839, 125, '2015-02-01 00:46:26.000000', 'consum', 0.0234, 'lps'),
	(388840, 125, '2015-02-01 00:46:27.000000', 'consum', 0.0222, 'lps'),
	(388841, 125, '2015-02-01 00:46:28.000000', 'consum', 0.0228, 'lps'),
	(388842, 125, '2015-02-01 00:46:29.000000', 'consum', 0.0211, 'lps'),
	(388843, 125, '2015-02-01 00:46:30.000000', 'consum', 0.0213, 'lps'),
	(388844, 125, '2015-02-01 00:46:31.000000', 'consum', 0.0223, 'lps'),
	(388845, 125, '2015-02-01 00:46:32.000000', 'consum', 0.0211, 'lps'),
	(388846, 125, '2015-02-01 00:46:33.000000', 'consum', 0.0234, 'lps'),
	(388847, 125, '2015-02-01 00:46:34.000000', 'consum', 0.0218, 'lps'),
	(388848, 125, '2015-02-01 00:46:35.000000', 'consum', 0.0232, 'lps'),
	(388849, 125, '2015-02-01 00:46:36.000000', 'consum', 0.0215, 'lps'),
	(388850, 125, '2015-02-01 00:46:37.000000', 'consum', 0.0224, 'lps'),
	(388851, 125, '2015-02-01 00:46:38.000000', 'consum', 0.0211, 'lps'),
	(388852, 125, '2015-02-01 00:46:39.000000', 'consum', 0.0229, 'lps'),
	(388853, 125, '2015-02-01 00:46:40.000000', 'consum', 0.0220, 'lps'),
	(388854, 125, '2015-02-01 00:46:41.000000', 'consum', 0.0233, 'lps'),
	(388855, 125, '2015-02-01 00:46:42.000000', 'consum', 0.0211, 'lps'),
	(388856, 125, '2015-02-01 00:46:43.000000', 'consum', 0.0230, 'lps'),
	(388857, 125, '2015-02-01 00:46:44.000000', 'consum', 0.0225, 'lps'),
	(388858, 125, '2015-02-01 00:46:45.000000', 'consum', 0.0226, 'lps'),
	(388859, 125, '2015-02-01 00:46:46.000000', 'consum', 0.0220, 'lps'),
	(388860, 125, '2015-02-01 00:46:47.000000', 'consum', 0.0212, 'lps'),
	(388861, 125, '2015-02-01 00:46:48.000000', 'consum', 0.0216, 'lps'),
	(388862, 125, '2015-02-01 00:46:49.000000', 'consum', 0.0236, 'lps'),
	(388863, 125, '2015-02-01 00:46:50.000000', 'consum', 0.0216, 'lps'),
	(388864, 125, '2015-02-01 00:46:51.000000', 'consum', 0.0215, 'lps'),
	(388865, 125, '2015-02-01 00:46:52.000000', 'consum', 0.0217, 'lps'),
	(388866, 125, '2015-02-01 00:46:53.000000', 'consum', 0.0231, 'lps'),
	(388867, 125, '2015-02-01 00:46:54.000000', 'consum', 0.0212, 'lps'),
	(388868, 125, '2015-02-01 00:46:55.000000', 'consum', 0.0211, 'lps'),
	(388869, 125, '2015-02-01 00:46:56.000000', 'consum', 0.0236, 'lps'),
	(388870, 125, '2015-02-01 00:46:57.000000', 'consum', 0.0229, 'lps'),
	(388871, 125, '2015-02-01 00:46:58.000000', 'consum', 0.0229, 'lps'),
	(388872, 125, '2015-02-01 00:46:59.000000', 'consum', 0.0221, 'lps'),
	(388873, 125, '2015-02-01 00:47:00.000000', 'consum', 0.0234, 'lps'),
	(388874, 125, '2015-02-01 00:47:01.000000', 'consum', 0.0218, 'lps'),
	(388875, 125, '2015-02-01 00:47:02.000000', 'consum', 0.0233, 'lps'),
	(388876, 125, '2015-02-01 00:47:03.000000', 'consum', 0.0219, 'lps'),
	(388877, 125, '2015-02-01 00:47:04.000000', 'consum', 0.0215, 'lps'),
	(388878, 125, '2015-02-01 00:47:05.000000', 'consum', 0.0236, 'lps'),
	(388879, 125, '2015-02-01 00:47:06.000000', 'consum', 0.0215, 'lps'),
	(388880, 125, '2015-02-01 00:47:07.000000', 'consum', 0.0212, 'lps'),
	(388881, 125, '2015-02-01 00:47:08.000000', 'consum', 0.0233, 'lps'),
	(388882, 125, '2015-02-01 00:47:09.000000', 'consum', 0.0213, 'lps'),
	(388883, 125, '2015-02-01 00:47:10.000000', 'consum', 0.0210, 'lps'),
	(388884, 125, '2015-02-01 00:47:11.000000', 'consum', 0.0226, 'lps'),
	(388885, 125, '2015-02-01 00:47:12.000000', 'consum', 0.0213, 'lps'),
	(388886, 125, '2015-02-01 00:47:13.000000', 'consum', 0.0229, 'lps'),
	(388887, 125, '2015-02-01 00:47:14.000000', 'consum', 0.0216, 'lps'),
	(388888, 125, '2015-02-01 00:47:15.000000', 'consum', 0.0211, 'lps'),
	(388889, 125, '2015-02-01 00:47:16.000000', 'consum', 0.0224, 'lps'),
	(388890, 125, '2015-02-01 00:47:17.000000', 'consum', 0.0225, 'lps'),
	(388891, 125, '2015-02-01 00:47:18.000000', 'consum', 0.0214, 'lps'),
	(388892, 125, '2015-02-01 00:47:19.000000', 'consum', 0.0213, 'lps'),
	(388893, 125, '2015-02-01 00:47:20.000000', 'consum', 0.0212, 'lps'),
	(388894, 125, '2015-02-01 00:47:21.000000', 'consum', 0.0213, 'lps'),
	(388895, 125, '2015-02-01 00:47:22.000000', 'consum', 0.0221, 'lps'),
	(388896, 125, '2015-02-01 00:47:23.000000', 'consum', 0.0229, 'lps'),
	(388897, 125, '2015-02-01 00:47:24.000000', 'consum', 0.0220, 'lps'),
	(388898, 125, '2015-02-01 00:47:25.000000', 'consum', 0.0229, 'lps'),
	(388899, 125, '2015-02-01 00:47:26.000000', 'consum', 0.0223, 'lps'),
	(388900, 125, '2015-02-01 00:47:27.000000', 'consum', 0.0217, 'lps'),
	(388901, 125, '2015-02-01 00:47:28.000000', 'consum', 0.0232, 'lps'),
	(388902, 125, '2015-02-01 00:47:29.000000', 'consum', 0.0220, 'lps'),
	(388903, 125, '2015-02-01 00:47:30.000000', 'consum', 0.0220, 'lps'),
	(388904, 125, '2015-02-01 00:47:31.000000', 'consum', 0.0230, 'lps'),
	(388905, 125, '2015-02-01 00:47:32.000000', 'consum', 0.0227, 'lps'),
	(388906, 125, '2015-02-01 00:47:33.000000', 'consum', 0.0236, 'lps'),
	(388907, 125, '2015-02-01 00:47:34.000000', 'consum', 0.0235, 'lps'),
	(388908, 125, '2015-02-01 00:47:35.000000', 'consum', 0.0230, 'lps'),
	(388909, 125, '2015-02-01 00:47:36.000000', 'consum', 0.0236, 'lps'),
	(388910, 125, '2015-02-01 00:47:37.000000', 'consum', 0.0226, 'lps'),
	(388911, 125, '2015-02-01 00:47:38.000000', 'consum', 0.0211, 'lps'),
	(388912, 125, '2015-02-01 00:47:39.000000', 'consum', 0.0223, 'lps'),
	(388913, 125, '2015-02-01 00:47:40.000000', 'consum', 0.0217, 'lps'),
	(388914, 125, '2015-02-01 00:47:41.000000', 'consum', 0.0236, 'lps'),
	(388915, 125, '2015-02-01 00:47:42.000000', 'consum', 0.0211, 'lps'),
	(388916, 125, '2015-02-01 00:47:43.000000', 'consum', 0.0217, 'lps'),
	(388917, 125, '2015-02-01 00:47:44.000000', 'consum', 0.0216, 'lps'),
	(388918, 125, '2015-02-01 00:47:45.000000', 'consum', 0.0219, 'lps'),
	(388919, 125, '2015-02-01 00:47:46.000000', 'consum', 0.0211, 'lps'),
	(388920, 125, '2015-02-01 00:47:47.000000', 'consum', 0.0217, 'lps'),
	(388921, 125, '2015-02-01 00:47:48.000000', 'consum', 0.0214, 'lps'),
	(388922, 125, '2015-02-01 00:47:49.000000', 'consum', 0.0210, 'lps'),
	(388923, 125, '2015-02-01 00:47:50.000000', 'consum', 0.0227, 'lps'),
	(388924, 125, '2015-02-01 00:47:51.000000', 'consum', 0.0215, 'lps'),
	(388925, 125, '2015-02-01 00:47:52.000000', 'consum', 0.0210, 'lps'),
	(388926, 125, '2015-02-01 00:47:53.000000', 'consum', 0.0221, 'lps'),
	(388927, 125, '2015-02-01 00:47:54.000000', 'consum', 0.0215, 'lps'),
	(388928, 125, '2015-02-01 00:47:55.000000', 'consum', 0.0227, 'lps'),
	(388929, 125, '2015-02-01 00:47:56.000000', 'consum', 0.0228, 'lps'),
	(388930, 125, '2015-02-01 00:47:57.000000', 'consum', 0.0220, 'lps'),
	(388931, 125, '2015-02-01 00:47:58.000000', 'consum', 0.0235, 'lps'),
	(388932, 125, '2015-02-01 00:47:59.000000', 'consum', 0.0225, 'lps'),
	(388933, 125, '2015-02-01 00:48:00.000000', 'consum', 0.0210, 'lps'),
	(388934, 125, '2015-02-01 00:48:01.000000', 'consum', 0.0220, 'lps'),
	(388935, 125, '2015-02-01 00:48:02.000000', 'consum', 0.0232, 'lps'),
	(388936, 125, '2015-02-01 00:48:03.000000', 'consum', 0.0236, 'lps'),
	(388937, 125, '2015-02-01 00:48:04.000000', 'consum', 0.0220, 'lps'),
	(388938, 125, '2015-02-01 00:48:05.000000', 'consum', 0.0210, 'lps'),
	(388939, 125, '2015-02-01 00:48:06.000000', 'consum', 0.0236, 'lps'),
	(388940, 125, '2015-02-01 00:48:07.000000', 'consum', 0.0233, 'lps'),
	(388941, 125, '2015-02-01 00:48:08.000000', 'consum', 0.0218, 'lps'),
	(388942, 125, '2015-02-01 00:48:09.000000', 'consum', 0.0211, 'lps'),
	(388943, 125, '2015-02-01 00:48:10.000000', 'consum', 0.0216, 'lps'),
	(388944, 125, '2015-02-01 00:48:11.000000', 'consum', 0.0212, 'lps'),
	(388945, 125, '2015-02-01 00:48:12.000000', 'consum', 0.0229, 'lps'),
	(388946, 125, '2015-02-01 00:48:13.000000', 'consum', 0.0219, 'lps'),
	(388947, 125, '2015-02-01 00:48:14.000000', 'consum', 0.0225, 'lps'),
	(388948, 125, '2015-02-01 00:48:15.000000', 'consum', 0.0231, 'lps'),
	(388949, 125, '2015-02-01 00:48:16.000000', 'consum', 0.0219, 'lps'),
	(388950, 125, '2015-02-01 00:48:17.000000', 'consum', 0.0218, 'lps'),
	(388951, 125, '2015-02-01 00:48:18.000000', 'consum', 0.0222, 'lps'),
	(388952, 125, '2015-02-01 00:48:19.000000', 'consum', 0.0223, 'lps'),
	(388953, 125, '2015-02-01 00:48:20.000000', 'consum', 0.0236, 'lps'),
	(388954, 125, '2015-02-01 00:48:21.000000', 'consum', 0.0224, 'lps'),
	(388955, 125, '2015-02-01 00:48:22.000000', 'consum', 0.0227, 'lps'),
	(388956, 125, '2015-02-01 00:48:23.000000', 'consum', 0.0226, 'lps'),
	(388957, 125, '2015-02-01 00:48:24.000000', 'consum', 0.0214, 'lps'),
	(388958, 125, '2015-02-01 00:48:25.000000', 'consum', 0.0235, 'lps'),
	(388959, 125, '2015-02-01 00:48:26.000000', 'consum', 0.0216, 'lps'),
	(388960, 125, '2015-02-01 00:48:27.000000', 'consum', 0.0218, 'lps'),
	(388961, 125, '2015-02-01 00:48:28.000000', 'consum', 0.0232, 'lps'),
	(388962, 125, '2015-02-01 00:48:29.000000', 'consum', 0.0215, 'lps'),
	(388963, 125, '2015-02-01 00:48:30.000000', 'consum', 0.0223, 'lps'),
	(388964, 125, '2015-02-01 00:48:31.000000', 'consum', 0.0233, 'lps'),
	(388965, 125, '2015-02-01 00:48:32.000000', 'consum', 0.0234, 'lps'),
	(388966, 125, '2015-02-01 00:48:33.000000', 'consum', 0.0233, 'lps'),
	(388967, 125, '2015-02-01 00:48:34.000000', 'consum', 0.0229, 'lps'),
	(388968, 125, '2015-02-01 00:48:35.000000', 'consum', 0.0234, 'lps'),
	(388969, 125, '2015-02-01 00:48:36.000000', 'consum', 0.0220, 'lps'),
	(388970, 125, '2015-02-01 00:48:37.000000', 'consum', 0.0217, 'lps'),
	(388971, 125, '2015-02-01 00:48:38.000000', 'consum', 0.0217, 'lps'),
	(388972, 125, '2015-02-01 00:48:39.000000', 'consum', 0.0222, 'lps'),
	(388973, 125, '2015-02-01 00:48:40.000000', 'consum', 0.0222, 'lps'),
	(388974, 125, '2015-02-01 00:48:41.000000', 'consum', 0.0210, 'lps'),
	(388975, 125, '2015-02-01 00:48:42.000000', 'consum', 0.0228, 'lps'),
	(388976, 125, '2015-02-01 00:48:43.000000', 'consum', 0.0220, 'lps'),
	(388977, 125, '2015-02-01 00:48:44.000000', 'consum', 0.0232, 'lps'),
	(388978, 125, '2015-02-01 00:48:45.000000', 'consum', 0.0211, 'lps'),
	(388979, 125, '2015-02-01 00:48:46.000000', 'consum', 0.0229, 'lps'),
	(388980, 125, '2015-02-01 00:48:47.000000', 'consum', 0.0221, 'lps'),
	(388981, 125, '2015-02-01 00:48:48.000000', 'consum', 0.0211, 'lps'),
	(388982, 125, '2015-02-01 00:48:49.000000', 'consum', 0.0234, 'lps'),
	(388983, 125, '2015-02-01 00:48:50.000000', 'consum', 0.0219, 'lps'),
	(388984, 125, '2015-02-01 00:48:51.000000', 'consum', 0.0212, 'lps'),
	(388985, 125, '2015-02-01 00:48:52.000000', 'consum', 0.0221, 'lps'),
	(388986, 125, '2015-02-01 00:48:53.000000', 'consum', 0.0233, 'lps'),
	(388987, 125, '2015-02-01 00:48:54.000000', 'consum', 0.0212, 'lps'),
	(388988, 125, '2015-02-01 00:48:55.000000', 'consum', 0.0230, 'lps'),
	(388989, 125, '2015-02-01 00:48:56.000000', 'consum', 0.0224, 'lps'),
	(388990, 125, '2015-02-01 00:48:57.000000', 'consum', 0.0221, 'lps'),
	(388991, 125, '2015-02-01 00:48:58.000000', 'consum', 0.0224, 'lps'),
	(388992, 125, '2015-02-01 00:48:59.000000', 'consum', 0.0221, 'lps'),
	(388993, 125, '2015-02-01 00:49:00.000000', 'consum', 0.0222, 'lps'),
	(388994, 125, '2015-02-01 00:49:01.000000', 'consum', 0.0210, 'lps'),
	(388995, 125, '2015-02-01 00:49:02.000000', 'consum', 0.0229, 'lps'),
	(388996, 125, '2015-02-01 00:49:03.000000', 'consum', 0.0223, 'lps'),
	(388997, 125, '2015-02-01 00:49:04.000000', 'consum', 0.0221, 'lps'),
	(388998, 125, '2015-02-01 00:49:05.000000', 'consum', 0.0225, 'lps'),
	(388999, 125, '2015-02-01 00:49:06.000000', 'consum', 0.0224, 'lps'),
	(389000, 125, '2015-02-01 00:49:07.000000', 'consum', 0.0211, 'lps'),
	(389001, 125, '2015-02-01 00:49:08.000000', 'consum', 0.0226, 'lps'),
	(389002, 125, '2015-02-01 00:49:09.000000', 'consum', 0.0234, 'lps'),
	(389003, 125, '2015-02-01 00:49:10.000000', 'consum', 0.0230, 'lps'),
	(389004, 125, '2015-02-01 00:49:11.000000', 'consum', 0.0211, 'lps'),
	(389005, 125, '2015-02-01 00:49:12.000000', 'consum', 0.0235, 'lps'),
	(389006, 125, '2015-02-01 00:49:13.000000', 'consum', 0.0226, 'lps'),
	(389007, 125, '2015-02-01 00:49:14.000000', 'consum', 0.0217, 'lps'),
	(389008, 125, '2015-02-01 00:49:15.000000', 'consum', 0.0222, 'lps'),
	(389009, 125, '2015-02-01 00:49:16.000000', 'consum', 0.0223, 'lps'),
	(389010, 125, '2015-02-01 00:49:17.000000', 'consum', 0.0211, 'lps'),
	(389011, 125, '2015-02-01 00:49:18.000000', 'consum', 0.0233, 'lps'),
	(389012, 125, '2015-02-01 00:49:19.000000', 'consum', 0.0212, 'lps'),
	(389013, 125, '2015-02-01 00:49:20.000000', 'consum', 0.0232, 'lps'),
	(389014, 125, '2015-02-01 00:49:21.000000', 'consum', 0.0233, 'lps'),
	(389015, 125, '2015-02-01 00:49:22.000000', 'consum', 0.0234, 'lps'),
	(389016, 125, '2015-02-01 00:49:23.000000', 'consum', 0.0235, 'lps'),
	(389017, 125, '2015-02-01 00:49:24.000000', 'consum', 0.0234, 'lps'),
	(389018, 125, '2015-02-01 00:49:25.000000', 'consum', 0.0232, 'lps'),
	(389019, 125, '2015-02-01 00:49:26.000000', 'consum', 0.0218, 'lps'),
	(389020, 125, '2015-02-01 00:49:27.000000', 'consum', 0.0215, 'lps'),
	(389021, 125, '2015-02-01 00:49:28.000000', 'consum', 0.0236, 'lps'),
	(389022, 125, '2015-02-01 00:49:29.000000', 'consum', 0.0219, 'lps'),
	(389023, 125, '2015-02-01 00:49:30.000000', 'consum', 0.0231, 'lps'),
	(389024, 125, '2015-02-01 00:49:31.000000', 'consum', 0.0236, 'lps'),
	(389025, 125, '2015-02-01 00:49:32.000000', 'consum', 0.0221, 'lps'),
	(389026, 125, '2015-02-01 00:49:33.000000', 'consum', 0.0214, 'lps'),
	(389027, 125, '2015-02-01 00:49:34.000000', 'consum', 0.0227, 'lps'),
	(389028, 125, '2015-02-01 00:49:35.000000', 'consum', 0.0227, 'lps'),
	(389029, 125, '2015-02-01 00:49:36.000000', 'consum', 0.0220, 'lps'),
	(389030, 125, '2015-02-01 00:49:37.000000', 'consum', 0.0233, 'lps'),
	(389031, 125, '2015-02-01 00:49:38.000000', 'consum', 0.0218, 'lps'),
	(389032, 125, '2015-02-01 00:49:39.000000', 'consum', 0.0233, 'lps'),
	(389033, 125, '2015-02-01 00:49:40.000000', 'consum', 0.0222, 'lps'),
	(389034, 125, '2015-02-01 00:49:41.000000', 'consum', 0.0228, 'lps'),
	(389035, 125, '2015-02-01 00:49:42.000000', 'consum', 0.0212, 'lps'),
	(389036, 125, '2015-02-01 00:49:43.000000', 'consum', 0.0218, 'lps'),
	(389037, 125, '2015-02-01 00:49:44.000000', 'consum', 0.0220, 'lps'),
	(389038, 125, '2015-02-01 00:49:45.000000', 'consum', 0.0210, 'lps'),
	(389039, 125, '2015-02-01 00:49:46.000000', 'consum', 0.0235, 'lps'),
	(389040, 125, '2015-02-01 00:49:47.000000', 'consum', 0.0228, 'lps'),
	(389041, 125, '2015-02-01 00:49:48.000000', 'consum', 0.0226, 'lps'),
	(389042, 125, '2015-02-01 00:49:49.000000', 'consum', 0.0236, 'lps'),
	(389043, 125, '2015-02-01 00:49:50.000000', 'consum', 0.0212, 'lps'),
	(389044, 125, '2015-02-01 00:49:51.000000', 'consum', 0.0223, 'lps'),
	(389045, 125, '2015-02-01 00:49:52.000000', 'consum', 0.0214, 'lps'),
	(389046, 125, '2015-02-01 00:49:53.000000', 'consum', 0.0218, 'lps'),
	(389047, 125, '2015-02-01 00:49:54.000000', 'consum', 0.0211, 'lps'),
	(389048, 125, '2015-02-01 00:49:55.000000', 'consum', 0.0218, 'lps'),
	(389049, 125, '2015-02-01 00:49:56.000000', 'consum', 0.0221, 'lps'),
	(389050, 125, '2015-02-01 00:49:57.000000', 'consum', 0.0215, 'lps'),
	(389051, 125, '2015-02-01 00:49:58.000000', 'consum', 0.0230, 'lps'),
	(389052, 125, '2015-02-01 00:49:59.000000', 'consum', 0.0214, 'lps'),
	(389053, 125, '2015-02-01 00:50:00.000000', 'consum', 0.0223, 'lps'),
	(389054, 125, '2015-02-01 00:50:01.000000', 'consum', 0.0210, 'lps'),
	(389055, 125, '2015-02-01 00:50:02.000000', 'consum', 0.0228, 'lps'),
	(389056, 125, '2015-02-01 00:50:03.000000', 'consum', 0.0216, 'lps'),
	(389057, 125, '2015-02-01 00:50:04.000000', 'consum', 0.0216, 'lps'),
	(389058, 125, '2015-02-01 00:50:05.000000', 'consum', 0.0224, 'lps'),
	(389059, 125, '2015-02-01 00:50:06.000000', 'consum', 0.0233, 'lps'),
	(389060, 125, '2015-02-01 00:50:07.000000', 'consum', 0.0228, 'lps'),
	(389061, 125, '2015-02-01 00:50:08.000000', 'consum', 0.0233, 'lps'),
	(389062, 125, '2015-02-01 00:50:09.000000', 'consum', 0.0218, 'lps'),
	(389063, 125, '2015-02-01 00:50:10.000000', 'consum', 0.0233, 'lps'),
	(389064, 125, '2015-02-01 00:50:11.000000', 'consum', 0.0223, 'lps'),
	(389065, 125, '2015-02-01 00:50:12.000000', 'consum', 0.0232, 'lps'),
	(389066, 125, '2015-02-01 00:50:13.000000', 'consum', 0.0228, 'lps'),
	(389067, 125, '2015-02-01 00:50:14.000000', 'consum', 0.0235, 'lps'),
	(389068, 125, '2015-02-01 00:50:15.000000', 'consum', 0.0226, 'lps'),
	(389069, 125, '2015-02-01 00:50:16.000000', 'consum', 0.0214, 'lps'),
	(389070, 125, '2015-02-01 00:50:17.000000', 'consum', 0.0213, 'lps'),
	(389071, 125, '2015-02-01 00:50:18.000000', 'consum', 0.0210, 'lps'),
	(389072, 125, '2015-02-01 00:50:19.000000', 'consum', 0.0231, 'lps'),
	(389073, 125, '2015-02-01 00:50:20.000000', 'consum', 0.0232, 'lps'),
	(389074, 125, '2015-02-01 00:50:21.000000', 'consum', 0.0233, 'lps'),
	(389075, 125, '2015-02-01 00:50:22.000000', 'consum', 0.0230, 'lps'),
	(389076, 125, '2015-02-01 00:50:23.000000', 'consum', 0.0217, 'lps'),
	(389077, 125, '2015-02-01 00:50:24.000000', 'consum', 0.0211, 'lps'),
	(389078, 125, '2015-02-01 00:50:25.000000', 'consum', 0.0220, 'lps'),
	(389079, 125, '2015-02-01 00:50:26.000000', 'consum', 0.0233, 'lps'),
	(389080, 125, '2015-02-01 00:50:27.000000', 'consum', 0.0216, 'lps'),
	(389081, 125, '2015-02-01 00:50:28.000000', 'consum', 0.0222, 'lps'),
	(389082, 125, '2015-02-01 00:50:29.000000', 'consum', 0.0228, 'lps'),
	(389083, 125, '2015-02-01 00:50:30.000000', 'consum', 0.0235, 'lps'),
	(389084, 125, '2015-02-01 00:50:31.000000', 'consum', 0.0231, 'lps'),
	(389085, 125, '2015-02-01 00:50:32.000000', 'consum', 0.0211, 'lps'),
	(389086, 125, '2015-02-01 00:50:33.000000', 'consum', 0.0234, 'lps'),
	(389087, 125, '2015-02-01 00:50:34.000000', 'consum', 0.0218, 'lps'),
	(389088, 125, '2015-02-01 00:50:35.000000', 'consum', 0.0234, 'lps'),
	(389089, 125, '2015-02-01 00:50:36.000000', 'consum', 0.0225, 'lps'),
	(389090, 125, '2015-02-01 00:50:37.000000', 'consum', 0.0215, 'lps'),
	(389091, 125, '2015-02-01 00:50:38.000000', 'consum', 0.0215, 'lps'),
	(389092, 125, '2015-02-01 00:50:39.000000', 'consum', 0.0223, 'lps'),
	(389093, 125, '2015-02-01 00:50:40.000000', 'consum', 0.0232, 'lps'),
	(389094, 125, '2015-02-01 00:50:41.000000', 'consum', 0.0226, 'lps'),
	(389095, 125, '2015-02-01 00:50:42.000000', 'consum', 0.0227, 'lps'),
	(389096, 125, '2015-02-01 00:50:43.000000', 'consum', 0.0218, 'lps'),
	(389097, 125, '2015-02-01 00:50:44.000000', 'consum', 0.0226, 'lps'),
	(389098, 125, '2015-02-01 00:50:45.000000', 'consum', 0.0213, 'lps'),
	(389099, 125, '2015-02-01 00:50:46.000000', 'consum', 0.0233, 'lps'),
	(389100, 125, '2015-02-01 00:50:47.000000', 'consum', 0.0233, 'lps'),
	(389101, 125, '2015-02-01 00:50:48.000000', 'consum', 0.0232, 'lps'),
	(389102, 125, '2015-02-01 00:50:49.000000', 'consum', 0.0225, 'lps'),
	(389103, 125, '2015-02-01 00:50:50.000000', 'consum', 0.0218, 'lps'),
	(389104, 125, '2015-02-01 00:50:51.000000', 'consum', 0.0233, 'lps'),
	(389105, 125, '2015-02-01 00:50:52.000000', 'consum', 0.0222, 'lps'),
	(389106, 125, '2015-02-01 00:50:53.000000', 'consum', 0.0226, 'lps'),
	(389107, 125, '2015-02-01 00:50:54.000000', 'consum', 0.0230, 'lps'),
	(389108, 125, '2015-02-01 00:50:55.000000', 'consum', 0.0235, 'lps'),
	(389109, 125, '2015-02-01 00:50:56.000000', 'consum', 0.0221, 'lps'),
	(389110, 125, '2015-02-01 00:50:57.000000', 'consum', 0.0217, 'lps'),
	(389111, 125, '2015-02-01 00:50:58.000000', 'consum', 0.0211, 'lps'),
	(389112, 125, '2015-02-01 00:50:59.000000', 'consum', 0.0222, 'lps'),
	(389113, 125, '2015-02-01 00:51:00.000000', 'consum', 0.0213, 'lps'),
	(389114, 125, '2015-02-01 00:51:01.000000', 'consum', 0.0218, 'lps'),
	(389115, 125, '2015-02-01 00:51:02.000000', 'consum', 0.0215, 'lps'),
	(389116, 125, '2015-02-01 00:51:03.000000', 'consum', 0.0211, 'lps'),
	(389117, 125, '2015-02-01 00:51:04.000000', 'consum', 0.0228, 'lps'),
	(389118, 125, '2015-02-01 00:51:05.000000', 'consum', 0.0218, 'lps'),
	(389119, 125, '2015-02-01 00:51:06.000000', 'consum', 0.0222, 'lps'),
	(389120, 125, '2015-02-01 00:51:07.000000', 'consum', 0.0219, 'lps'),
	(389121, 125, '2015-02-01 00:51:08.000000', 'consum', 0.0221, 'lps'),
	(389122, 125, '2015-02-01 00:51:09.000000', 'consum', 0.0212, 'lps'),
	(389123, 125, '2015-02-01 00:51:10.000000', 'consum', 0.0214, 'lps'),
	(389124, 125, '2015-02-01 00:51:11.000000', 'consum', 0.0226, 'lps'),
	(389125, 125, '2015-02-01 00:51:12.000000', 'consum', 0.0223, 'lps'),
	(389126, 125, '2015-02-01 00:51:13.000000', 'consum', 0.0227, 'lps'),
	(389127, 125, '2015-02-01 00:51:14.000000', 'consum', 0.0232, 'lps'),
	(389128, 125, '2015-02-01 00:51:15.000000', 'consum', 0.0214, 'lps'),
	(389129, 125, '2015-02-01 00:51:16.000000', 'consum', 0.0219, 'lps'),
	(389130, 125, '2015-02-01 00:51:17.000000', 'consum', 0.0218, 'lps'),
	(389131, 125, '2015-02-01 00:51:18.000000', 'consum', 0.0220, 'lps'),
	(389132, 125, '2015-02-01 00:51:19.000000', 'consum', 0.0212, 'lps'),
	(389133, 125, '2015-02-01 00:51:20.000000', 'consum', 0.0215, 'lps'),
	(389134, 125, '2015-02-01 00:51:21.000000', 'consum', 0.0233, 'lps'),
	(389135, 125, '2015-02-01 00:51:22.000000', 'consum', 0.0226, 'lps'),
	(389136, 125, '2015-02-01 00:51:23.000000', 'consum', 0.0223, 'lps'),
	(389137, 125, '2015-02-01 00:51:24.000000', 'consum', 0.0229, 'lps'),
	(389138, 125, '2015-02-01 00:51:25.000000', 'consum', 0.0211, 'lps'),
	(389139, 125, '2015-02-01 00:51:26.000000', 'consum', 0.0211, 'lps'),
	(389140, 125, '2015-02-01 00:51:27.000000', 'consum', 0.0212, 'lps'),
	(389141, 125, '2015-02-01 00:51:28.000000', 'consum', 0.0220, 'lps'),
	(389142, 125, '2015-02-01 00:51:29.000000', 'consum', 0.0228, 'lps'),
	(389143, 125, '2015-02-01 00:51:30.000000', 'consum', 0.0214, 'lps'),
	(389144, 125, '2015-02-01 00:51:31.000000', 'consum', 0.0232, 'lps'),
	(389145, 125, '2015-02-01 00:51:32.000000', 'consum', 0.0228, 'lps'),
	(389146, 125, '2015-02-01 00:51:33.000000', 'consum', 0.0234, 'lps'),
	(389147, 125, '2015-02-01 00:51:34.000000', 'consum', 0.0224, 'lps'),
	(389148, 125, '2015-02-01 00:51:35.000000', 'consum', 0.0232, 'lps'),
	(389149, 125, '2015-02-01 00:51:36.000000', 'consum', 0.0227, 'lps'),
	(389150, 125, '2015-02-01 00:51:37.000000', 'consum', 0.0231, 'lps'),
	(389151, 125, '2015-02-01 00:51:38.000000', 'consum', 0.0235, 'lps'),
	(389152, 125, '2015-02-01 00:51:39.000000', 'consum', 0.0218, 'lps'),
	(389153, 125, '2015-02-01 00:51:40.000000', 'consum', 0.0229, 'lps'),
	(389154, 125, '2015-02-01 00:51:41.000000', 'consum', 0.0229, 'lps'),
	(389155, 125, '2015-02-01 00:51:42.000000', 'consum', 0.0222, 'lps'),
	(389156, 125, '2015-02-01 00:51:43.000000', 'consum', 0.0211, 'lps'),
	(389157, 125, '2015-02-01 00:51:44.000000', 'consum', 0.0234, 'lps'),
	(389158, 125, '2015-02-01 00:51:45.000000', 'consum', 0.0221, 'lps'),
	(389159, 125, '2015-02-01 00:51:46.000000', 'consum', 0.0221, 'lps'),
	(389160, 125, '2015-02-01 00:51:47.000000', 'consum', 0.0230, 'lps'),
	(389161, 125, '2015-02-01 00:51:48.000000', 'consum', 0.0224, 'lps'),
	(389162, 125, '2015-02-01 00:51:49.000000', 'consum', 0.0222, 'lps'),
	(389163, 125, '2015-02-01 00:51:50.000000', 'consum', 0.0227, 'lps'),
	(389164, 125, '2015-02-01 00:51:51.000000', 'consum', 0.0234, 'lps'),
	(389165, 125, '2015-02-01 00:51:52.000000', 'consum', 0.0224, 'lps'),
	(389166, 125, '2015-02-01 00:51:53.000000', 'consum', 0.0235, 'lps'),
	(389167, 125, '2015-02-01 00:51:54.000000', 'consum', 0.0212, 'lps'),
	(389168, 125, '2015-02-01 00:51:55.000000', 'consum', 0.0227, 'lps'),
	(389169, 125, '2015-02-01 00:51:56.000000', 'consum', 0.0236, 'lps'),
	(389170, 125, '2015-02-01 00:51:57.000000', 'consum', 0.0210, 'lps'),
	(389171, 125, '2015-02-01 00:51:58.000000', 'consum', 0.0212, 'lps'),
	(389172, 125, '2015-02-01 00:51:59.000000', 'consum', 0.0222, 'lps'),
	(389173, 125, '2015-02-01 00:52:00.000000', 'consum', 0.0235, 'lps'),
	(389174, 125, '2015-02-01 00:52:01.000000', 'consum', 0.0220, 'lps'),
	(389175, 125, '2015-02-01 00:52:02.000000', 'consum', 0.0213, 'lps'),
	(389176, 125, '2015-02-01 00:52:03.000000', 'consum', 0.0221, 'lps'),
	(389177, 125, '2015-02-01 00:52:04.000000', 'consum', 0.0229, 'lps'),
	(389178, 125, '2015-02-01 00:52:05.000000', 'consum', 0.0220, 'lps'),
	(389179, 125, '2015-02-01 00:52:06.000000', 'consum', 0.0230, 'lps'),
	(389180, 125, '2015-02-01 00:52:07.000000', 'consum', 0.0227, 'lps'),
	(389181, 125, '2015-02-01 00:52:08.000000', 'consum', 0.0236, 'lps'),
	(389182, 125, '2015-02-01 00:52:09.000000', 'consum', 0.0234, 'lps'),
	(389183, 125, '2015-02-01 00:52:10.000000', 'consum', 0.0226, 'lps'),
	(389184, 125, '2015-02-01 00:52:11.000000', 'consum', 0.0219, 'lps'),
	(389185, 125, '2015-02-01 00:52:12.000000', 'consum', 0.0233, 'lps'),
	(389186, 125, '2015-02-01 00:52:13.000000', 'consum', 0.0217, 'lps'),
	(389187, 125, '2015-02-01 00:52:14.000000', 'consum', 0.0230, 'lps'),
	(389188, 125, '2015-02-01 00:52:15.000000', 'consum', 0.0236, 'lps'),
	(389189, 125, '2015-02-01 00:52:16.000000', 'consum', 0.0225, 'lps'),
	(389190, 125, '2015-02-01 00:52:17.000000', 'consum', 0.0236, 'lps'),
	(389191, 125, '2015-02-01 00:52:18.000000', 'consum', 0.0213, 'lps'),
	(389192, 125, '2015-02-01 00:52:19.000000', 'consum', 0.0228, 'lps'),
	(389193, 125, '2015-02-01 00:52:20.000000', 'consum', 0.0210, 'lps'),
	(389194, 125, '2015-02-01 00:52:21.000000', 'consum', 0.0213, 'lps'),
	(389195, 125, '2015-02-01 00:52:22.000000', 'consum', 0.0226, 'lps'),
	(389196, 125, '2015-02-01 00:52:23.000000', 'consum', 0.0226, 'lps'),
	(389197, 125, '2015-02-01 00:52:24.000000', 'consum', 0.0218, 'lps'),
	(389198, 125, '2015-02-01 00:52:25.000000', 'consum', 0.0226, 'lps'),
	(389199, 125, '2015-02-01 00:52:26.000000', 'consum', 0.0215, 'lps'),
	(389200, 125, '2015-02-01 00:52:27.000000', 'consum', 0.0212, 'lps'),
	(389201, 125, '2015-02-01 00:52:28.000000', 'consum', 0.0233, 'lps'),
	(389202, 125, '2015-02-01 00:52:29.000000', 'consum', 0.0214, 'lps'),
	(389203, 125, '2015-02-01 00:52:30.000000', 'consum', 0.0213, 'lps'),
	(389204, 125, '2015-02-01 00:52:31.000000', 'consum', 0.0213, 'lps'),
	(389205, 125, '2015-02-01 00:52:32.000000', 'consum', 0.0217, 'lps'),
	(389206, 125, '2015-02-01 00:52:33.000000', 'consum', 0.0212, 'lps'),
	(389207, 125, '2015-02-01 00:52:34.000000', 'consum', 0.0224, 'lps'),
	(389208, 125, '2015-02-01 00:52:35.000000', 'consum', 0.0221, 'lps'),
	(389209, 125, '2015-02-01 00:52:36.000000', 'consum', 0.0224, 'lps'),
	(389210, 125, '2015-02-01 00:52:37.000000', 'consum', 0.0221, 'lps'),
	(389211, 125, '2015-02-01 00:52:38.000000', 'consum', 0.0223, 'lps'),
	(389212, 125, '2015-02-01 00:52:39.000000', 'consum', 0.0217, 'lps'),
	(389213, 125, '2015-02-01 00:52:40.000000', 'consum', 0.0232, 'lps'),
	(389214, 125, '2015-02-01 00:52:41.000000', 'consum', 0.0218, 'lps'),
	(389215, 125, '2015-02-01 00:52:42.000000', 'consum', 0.0213, 'lps'),
	(389216, 125, '2015-02-01 00:52:43.000000', 'consum', 0.0227, 'lps'),
	(389217, 125, '2015-02-01 00:52:44.000000', 'consum', 0.0232, 'lps'),
	(389218, 125, '2015-02-01 00:52:45.000000', 'consum', 0.0214, 'lps'),
	(389219, 125, '2015-02-01 00:52:46.000000', 'consum', 0.0221, 'lps'),
	(389220, 125, '2015-02-01 00:52:47.000000', 'consum', 0.0226, 'lps'),
	(389221, 125, '2015-02-01 00:52:48.000000', 'consum', 0.0232, 'lps'),
	(389222, 125, '2015-02-01 00:52:49.000000', 'consum', 0.0218, 'lps'),
	(389223, 125, '2015-02-01 00:52:50.000000', 'consum', 0.0212, 'lps'),
	(389224, 125, '2015-02-01 00:52:51.000000', 'consum', 0.0225, 'lps'),
	(389225, 125, '2015-02-01 00:52:52.000000', 'consum', 0.0224, 'lps'),
	(389226, 125, '2015-02-01 00:52:53.000000', 'consum', 0.0235, 'lps'),
	(389227, 125, '2015-02-01 00:52:54.000000', 'consum', 0.0214, 'lps'),
	(389228, 125, '2015-02-01 00:52:55.000000', 'consum', 0.0211, 'lps'),
	(389229, 125, '2015-02-01 00:52:56.000000', 'consum', 0.0228, 'lps'),
	(389230, 125, '2015-02-01 00:52:57.000000', 'consum', 0.0216, 'lps'),
	(389231, 125, '2015-02-01 00:52:58.000000', 'consum', 0.0214, 'lps'),
	(389232, 125, '2015-02-01 00:52:59.000000', 'consum', 0.0211, 'lps'),
	(389233, 125, '2015-02-01 00:53:00.000000', 'consum', 0.0232, 'lps'),
	(389234, 125, '2015-02-01 00:53:01.000000', 'consum', 0.0211, 'lps'),
	(389235, 125, '2015-02-01 00:53:02.000000', 'consum', 0.0228, 'lps'),
	(389236, 125, '2015-02-01 00:53:03.000000', 'consum', 0.0217, 'lps'),
	(389237, 125, '2015-02-01 00:53:04.000000', 'consum', 0.0219, 'lps'),
	(389238, 125, '2015-02-01 00:53:05.000000', 'consum', 0.0236, 'lps'),
	(389239, 125, '2015-02-01 00:53:06.000000', 'consum', 0.0232, 'lps'),
	(389240, 125, '2015-02-01 00:53:07.000000', 'consum', 0.0215, 'lps'),
	(389241, 125, '2015-02-01 00:53:08.000000', 'consum', 0.0225, 'lps'),
	(389242, 125, '2015-02-01 00:53:09.000000', 'consum', 0.0213, 'lps'),
	(389243, 125, '2015-02-01 00:53:10.000000', 'consum', 0.0211, 'lps'),
	(389244, 125, '2015-02-01 00:53:11.000000', 'consum', 0.0232, 'lps'),
	(389245, 125, '2015-02-01 00:53:12.000000', 'consum', 0.0210, 'lps'),
	(389246, 125, '2015-02-01 00:53:13.000000', 'consum', 0.0226, 'lps'),
	(389247, 125, '2015-02-01 00:53:14.000000', 'consum', 0.0235, 'lps'),
	(389248, 125, '2015-02-01 00:53:15.000000', 'consum', 0.0235, 'lps'),
	(389249, 125, '2015-02-01 00:53:16.000000', 'consum', 0.0231, 'lps'),
	(389250, 125, '2015-02-01 00:53:17.000000', 'consum', 0.0216, 'lps'),
	(389251, 125, '2015-02-01 00:53:18.000000', 'consum', 0.0230, 'lps'),
	(389252, 125, '2015-02-01 00:53:19.000000', 'consum', 0.0214, 'lps'),
	(389253, 125, '2015-02-01 00:53:20.000000', 'consum', 0.0221, 'lps'),
	(389254, 125, '2015-02-01 00:53:21.000000', 'consum', 0.0230, 'lps'),
	(389255, 125, '2015-02-01 00:53:22.000000', 'consum', 0.0220, 'lps'),
	(389256, 125, '2015-02-01 00:53:23.000000', 'consum', 0.0229, 'lps'),
	(389257, 125, '2015-02-01 00:53:24.000000', 'consum', 0.0223, 'lps'),
	(389258, 125, '2015-02-01 00:53:25.000000', 'consum', 0.0218, 'lps'),
	(389259, 125, '2015-02-01 00:53:26.000000', 'consum', 0.0212, 'lps'),
	(389260, 125, '2015-02-01 00:53:27.000000', 'consum', 0.0224, 'lps'),
	(389261, 125, '2015-02-01 00:53:28.000000', 'consum', 0.0218, 'lps'),
	(389262, 125, '2015-02-01 00:53:29.000000', 'consum', 0.0210, 'lps'),
	(389263, 125, '2015-02-01 00:53:30.000000', 'consum', 0.0212, 'lps'),
	(389264, 125, '2015-02-01 00:53:31.000000', 'consum', 0.0223, 'lps'),
	(389265, 125, '2015-02-01 00:53:32.000000', 'consum', 0.0215, 'lps'),
	(389266, 125, '2015-02-01 00:53:33.000000', 'consum', 0.0222, 'lps'),
	(389267, 125, '2015-02-01 00:53:34.000000', 'consum', 0.0230, 'lps'),
	(389268, 125, '2015-02-01 00:53:35.000000', 'consum', 0.0219, 'lps'),
	(389269, 125, '2015-02-01 00:53:36.000000', 'consum', 0.0223, 'lps'),
	(389270, 125, '2015-02-01 00:53:37.000000', 'consum', 0.0221, 'lps'),
	(389271, 125, '2015-02-01 00:53:38.000000', 'consum', 0.0228, 'lps'),
	(389272, 125, '2015-02-01 00:53:39.000000', 'consum', 0.0213, 'lps'),
	(389273, 125, '2015-02-01 00:53:40.000000', 'consum', 0.0226, 'lps'),
	(389274, 125, '2015-02-01 00:53:41.000000', 'consum', 0.0227, 'lps'),
	(389275, 125, '2015-02-01 00:53:42.000000', 'consum', 0.0222, 'lps'),
	(389276, 125, '2015-02-01 00:53:43.000000', 'consum', 0.0219, 'lps'),
	(389277, 125, '2015-02-01 00:53:44.000000', 'consum', 0.0219, 'lps'),
	(389278, 125, '2015-02-01 00:53:45.000000', 'consum', 0.0229, 'lps'),
	(389279, 125, '2015-02-01 00:53:46.000000', 'consum', 0.0222, 'lps'),
	(389280, 125, '2015-02-01 00:53:47.000000', 'consum', 0.0217, 'lps'),
	(389281, 125, '2015-02-01 00:53:48.000000', 'consum', 0.0234, 'lps'),
	(389282, 125, '2015-02-01 00:53:49.000000', 'consum', 0.0229, 'lps'),
	(389283, 125, '2015-02-01 00:53:50.000000', 'consum', 0.0233, 'lps'),
	(389284, 125, '2015-02-01 00:53:51.000000', 'consum', 0.0213, 'lps'),
	(389285, 125, '2015-02-01 00:53:52.000000', 'consum', 0.0213, 'lps'),
	(389286, 125, '2015-02-01 00:53:53.000000', 'consum', 0.0217, 'lps'),
	(389287, 125, '2015-02-01 00:53:54.000000', 'consum', 0.0234, 'lps'),
	(389288, 125, '2015-02-01 00:53:55.000000', 'consum', 0.0230, 'lps'),
	(389289, 125, '2015-02-01 00:53:56.000000', 'consum', 0.0212, 'lps'),
	(389290, 125, '2015-02-01 00:53:57.000000', 'consum', 0.0215, 'lps'),
	(389291, 125, '2015-02-01 00:53:58.000000', 'consum', 0.0228, 'lps'),
	(389292, 125, '2015-02-01 00:53:59.000000', 'consum', 0.0232, 'lps'),
	(389293, 125, '2015-02-01 00:54:00.000000', 'consum', 0.0211, 'lps'),
	(389294, 125, '2015-02-01 00:54:01.000000', 'consum', 0.0230, 'lps'),
	(389295, 125, '2015-02-01 00:54:02.000000', 'consum', 0.0227, 'lps'),
	(389296, 125, '2015-02-01 00:54:03.000000', 'consum', 0.0210, 'lps'),
	(389297, 125, '2015-02-01 00:54:04.000000', 'consum', 0.0214, 'lps'),
	(389298, 125, '2015-02-01 00:54:05.000000', 'consum', 0.0230, 'lps'),
	(389299, 125, '2015-02-01 00:54:06.000000', 'consum', 0.0218, 'lps'),
	(389300, 125, '2015-02-01 00:54:07.000000', 'consum', 0.0215, 'lps'),
	(389301, 125, '2015-02-01 00:54:08.000000', 'consum', 0.0214, 'lps'),
	(389302, 125, '2015-02-01 00:54:09.000000', 'consum', 0.0213, 'lps'),
	(389303, 125, '2015-02-01 00:54:10.000000', 'consum', 0.0215, 'lps'),
	(389304, 125, '2015-02-01 00:54:11.000000', 'consum', 0.0227, 'lps'),
	(389305, 125, '2015-02-01 00:54:12.000000', 'consum', 0.0227, 'lps'),
	(389306, 125, '2015-02-01 00:54:13.000000', 'consum', 0.0217, 'lps'),
	(389307, 125, '2015-02-01 00:54:14.000000', 'consum', 0.0223, 'lps'),
	(389308, 125, '2015-02-01 00:54:15.000000', 'consum', 0.0228, 'lps'),
	(389309, 125, '2015-02-01 00:54:16.000000', 'consum', 0.0231, 'lps'),
	(389310, 125, '2015-02-01 00:54:17.000000', 'consum', 0.0211, 'lps'),
	(389311, 125, '2015-02-01 00:54:18.000000', 'consum', 0.0231, 'lps'),
	(389312, 125, '2015-02-01 00:54:19.000000', 'consum', 0.0231, 'lps'),
	(389313, 125, '2015-02-01 00:54:20.000000', 'consum', 0.0227, 'lps'),
	(389314, 125, '2015-02-01 00:54:21.000000', 'consum', 0.0232, 'lps'),
	(389315, 125, '2015-02-01 00:54:22.000000', 'consum', 0.0214, 'lps'),
	(389316, 125, '2015-02-01 00:54:23.000000', 'consum', 0.0220, 'lps'),
	(389317, 125, '2015-02-01 00:54:24.000000', 'consum', 0.0220, 'lps'),
	(389318, 125, '2015-02-01 00:54:25.000000', 'consum', 0.0230, 'lps'),
	(389319, 125, '2015-02-01 00:54:26.000000', 'consum', 0.0228, 'lps'),
	(389320, 125, '2015-02-01 00:54:27.000000', 'consum', 0.0211, 'lps'),
	(389321, 125, '2015-02-01 00:54:28.000000', 'consum', 0.0219, 'lps'),
	(389322, 125, '2015-02-01 00:54:29.000000', 'consum', 0.0223, 'lps'),
	(389323, 125, '2015-02-01 00:54:30.000000', 'consum', 0.0221, 'lps'),
	(389324, 125, '2015-02-01 00:54:31.000000', 'consum', 0.0227, 'lps'),
	(389325, 125, '2015-02-01 00:54:32.000000', 'consum', 0.0211, 'lps'),
	(389326, 125, '2015-02-01 00:54:33.000000', 'consum', 0.0215, 'lps'),
	(389327, 125, '2015-02-01 00:54:34.000000', 'consum', 0.0233, 'lps'),
	(389328, 125, '2015-02-01 00:54:35.000000', 'consum', 0.0231, 'lps'),
	(389329, 125, '2015-02-01 00:54:36.000000', 'consum', 0.0220, 'lps'),
	(389330, 125, '2015-02-01 00:54:37.000000', 'consum', 0.0225, 'lps'),
	(389331, 125, '2015-02-01 00:54:38.000000', 'consum', 0.0226, 'lps'),
	(389332, 125, '2015-02-01 00:54:39.000000', 'consum', 0.0221, 'lps'),
	(389333, 125, '2015-02-01 00:54:40.000000', 'consum', 0.0215, 'lps'),
	(389334, 125, '2015-02-01 00:54:41.000000', 'consum', 0.0232, 'lps'),
	(389335, 125, '2015-02-01 00:54:42.000000', 'consum', 0.0224, 'lps'),
	(389336, 125, '2015-02-01 00:54:43.000000', 'consum', 0.0214, 'lps'),
	(389337, 125, '2015-02-01 00:54:44.000000', 'consum', 0.0216, 'lps'),
	(389338, 125, '2015-02-01 00:54:45.000000', 'consum', 0.0230, 'lps'),
	(389339, 125, '2015-02-01 00:54:46.000000', 'consum', 0.0236, 'lps'),
	(389340, 125, '2015-02-01 00:54:47.000000', 'consum', 0.0225, 'lps'),
	(389341, 125, '2015-02-01 00:54:48.000000', 'consum', 0.0211, 'lps'),
	(389342, 125, '2015-02-01 00:54:49.000000', 'consum', 0.0221, 'lps'),
	(389343, 125, '2015-02-01 00:54:50.000000', 'consum', 0.0211, 'lps'),
	(389344, 125, '2015-02-01 00:54:51.000000', 'consum', 0.0236, 'lps'),
	(389345, 125, '2015-02-01 00:54:52.000000', 'consum', 0.0231, 'lps'),
	(389346, 125, '2015-02-01 00:54:53.000000', 'consum', 0.0236, 'lps'),
	(389347, 125, '2015-02-01 00:54:54.000000', 'consum', 0.0224, 'lps'),
	(389348, 125, '2015-02-01 00:54:55.000000', 'consum', 0.0231, 'lps'),
	(389349, 125, '2015-02-01 00:54:56.000000', 'consum', 0.0220, 'lps'),
	(389350, 125, '2015-02-01 00:54:57.000000', 'consum', 0.0223, 'lps'),
	(389351, 125, '2015-02-01 00:54:58.000000', 'consum', 0.0217, 'lps'),
	(389352, 125, '2015-02-01 00:54:59.000000', 'consum', 0.0236, 'lps'),
	(389353, 125, '2015-02-01 00:55:00.000000', 'consum', 0.0213, 'lps'),
	(389354, 125, '2015-02-01 00:55:01.000000', 'consum', 0.0225, 'lps'),
	(389355, 125, '2015-02-01 00:55:02.000000', 'consum', 0.0223, 'lps'),
	(389356, 125, '2015-02-01 00:55:03.000000', 'consum', 0.0229, 'lps'),
	(389357, 125, '2015-02-01 00:55:04.000000', 'consum', 0.0214, 'lps'),
	(389358, 125, '2015-02-01 00:55:05.000000', 'consum', 0.0226, 'lps'),
	(389359, 125, '2015-02-01 00:55:06.000000', 'consum', 0.0226, 'lps'),
	(389360, 125, '2015-02-01 00:55:07.000000', 'consum', 0.0213, 'lps'),
	(389361, 125, '2015-02-01 00:55:08.000000', 'consum', 0.0235, 'lps'),
	(389362, 125, '2015-02-01 00:55:09.000000', 'consum', 0.0217, 'lps'),
	(389363, 125, '2015-02-01 00:55:10.000000', 'consum', 0.0224, 'lps'),
	(389364, 125, '2015-02-01 00:55:11.000000', 'consum', 0.0235, 'lps'),
	(389365, 125, '2015-02-01 00:55:12.000000', 'consum', 0.0211, 'lps'),
	(389366, 125, '2015-02-01 00:55:13.000000', 'consum', 0.0221, 'lps'),
	(389367, 125, '2015-02-01 00:55:14.000000', 'consum', 0.0235, 'lps'),
	(389368, 125, '2015-02-01 00:55:15.000000', 'consum', 0.0223, 'lps'),
	(389369, 125, '2015-02-01 00:55:16.000000', 'consum', 0.0228, 'lps'),
	(389370, 125, '2015-02-01 00:55:17.000000', 'consum', 0.0233, 'lps'),
	(389371, 125, '2015-02-01 00:55:18.000000', 'consum', 0.0217, 'lps'),
	(389372, 125, '2015-02-01 00:55:19.000000', 'consum', 0.0230, 'lps'),
	(389373, 125, '2015-02-01 00:55:20.000000', 'consum', 0.0235, 'lps'),
	(389374, 125, '2015-02-01 00:55:21.000000', 'consum', 0.0221, 'lps'),
	(389375, 125, '2015-02-01 00:55:22.000000', 'consum', 0.0219, 'lps'),
	(389376, 125, '2015-02-01 00:55:23.000000', 'consum', 0.0222, 'lps'),
	(389377, 125, '2015-02-01 00:55:24.000000', 'consum', 0.0215, 'lps'),
	(389378, 125, '2015-02-01 00:55:25.000000', 'consum', 0.0229, 'lps'),
	(389379, 125, '2015-02-01 00:55:26.000000', 'consum', 0.0210, 'lps'),
	(389380, 125, '2015-02-01 00:55:27.000000', 'consum', 0.0233, 'lps'),
	(389381, 125, '2015-02-01 00:55:28.000000', 'consum', 0.0218, 'lps'),
	(389382, 125, '2015-02-01 00:55:29.000000', 'consum', 0.0235, 'lps'),
	(389383, 125, '2015-02-01 00:55:30.000000', 'consum', 0.0230, 'lps'),
	(389384, 125, '2015-02-01 00:55:31.000000', 'consum', 0.0210, 'lps'),
	(389385, 125, '2015-02-01 00:55:32.000000', 'consum', 0.0230, 'lps'),
	(389386, 125, '2015-02-01 00:55:33.000000', 'consum', 0.0228, 'lps'),
	(389387, 125, '2015-02-01 00:55:34.000000', 'consum', 0.0215, 'lps'),
	(389388, 125, '2015-02-01 00:55:35.000000', 'consum', 0.0235, 'lps'),
	(389389, 125, '2015-02-01 00:55:36.000000', 'consum', 0.0213, 'lps'),
	(389390, 125, '2015-02-01 00:55:37.000000', 'consum', 0.0230, 'lps'),
	(389391, 125, '2015-02-01 00:55:38.000000', 'consum', 0.0220, 'lps'),
	(389392, 125, '2015-02-01 00:55:39.000000', 'consum', 0.0228, 'lps'),
	(389393, 125, '2015-02-01 00:55:40.000000', 'consum', 0.0216, 'lps'),
	(389394, 125, '2015-02-01 00:55:41.000000', 'consum', 0.0215, 'lps'),
	(389395, 125, '2015-02-01 00:55:42.000000', 'consum', 0.0217, 'lps'),
	(389396, 125, '2015-02-01 00:55:43.000000', 'consum', 0.0228, 'lps'),
	(389397, 125, '2015-02-01 00:55:44.000000', 'consum', 0.0229, 'lps'),
	(389398, 125, '2015-02-01 00:55:45.000000', 'consum', 0.0222, 'lps'),
	(389399, 125, '2015-02-01 00:55:46.000000', 'consum', 0.0213, 'lps'),
	(389400, 125, '2015-02-01 00:55:47.000000', 'consum', 0.0217, 'lps'),
	(389401, 125, '2015-02-01 00:55:48.000000', 'consum', 0.0235, 'lps'),
	(389402, 125, '2015-02-01 00:55:49.000000', 'consum', 0.0235, 'lps'),
	(389403, 125, '2015-02-01 00:55:50.000000', 'consum', 0.0234, 'lps'),
	(389404, 125, '2015-02-01 00:55:51.000000', 'consum', 0.0228, 'lps'),
	(389405, 125, '2015-02-01 00:55:52.000000', 'consum', 0.0231, 'lps'),
	(389406, 125, '2015-02-01 00:55:53.000000', 'consum', 0.0231, 'lps'),
	(389407, 125, '2015-02-01 00:55:54.000000', 'consum', 0.0226, 'lps'),
	(389408, 125, '2015-02-01 00:55:55.000000', 'consum', 0.0228, 'lps'),
	(389409, 125, '2015-02-01 00:55:56.000000', 'consum', 0.0224, 'lps'),
	(389410, 125, '2015-02-01 00:55:57.000000', 'consum', 0.0229, 'lps'),
	(389411, 125, '2015-02-01 00:55:58.000000', 'consum', 0.0234, 'lps'),
	(389412, 125, '2015-02-01 00:55:59.000000', 'consum', 0.0219, 'lps'),
	(389413, 125, '2015-02-01 00:56:00.000000', 'consum', 0.0212, 'lps'),
	(389414, 125, '2015-02-01 00:56:01.000000', 'consum', 0.0220, 'lps'),
	(389415, 125, '2015-02-01 00:56:02.000000', 'consum', 0.0227, 'lps'),
	(389416, 125, '2015-02-01 00:56:03.000000', 'consum', 0.0210, 'lps'),
	(389417, 125, '2015-02-01 00:56:04.000000', 'consum', 0.0214, 'lps'),
	(389418, 125, '2015-02-01 00:56:05.000000', 'consum', 0.0233, 'lps'),
	(389419, 125, '2015-02-01 00:56:06.000000', 'consum', 0.0231, 'lps'),
	(389420, 125, '2015-02-01 00:56:07.000000', 'consum', 0.0218, 'lps'),
	(389421, 125, '2015-02-01 00:56:08.000000', 'consum', 0.0215, 'lps'),
	(389422, 125, '2015-02-01 00:56:09.000000', 'consum', 0.0210, 'lps'),
	(389423, 125, '2015-02-01 00:56:10.000000', 'consum', 0.0225, 'lps'),
	(389424, 125, '2015-02-01 00:56:11.000000', 'consum', 0.0229, 'lps'),
	(389425, 125, '2015-02-01 00:56:12.000000', 'consum', 0.0233, 'lps'),
	(389426, 125, '2015-02-01 00:56:13.000000', 'consum', 0.0215, 'lps'),
	(389427, 125, '2015-02-01 00:56:14.000000', 'consum', 0.0220, 'lps'),
	(389428, 125, '2015-02-01 00:56:15.000000', 'consum', 0.0218, 'lps'),
	(389429, 125, '2015-02-01 00:56:16.000000', 'consum', 0.0221, 'lps'),
	(389430, 125, '2015-02-01 00:56:17.000000', 'consum', 0.0213, 'lps'),
	(389431, 125, '2015-02-01 00:56:18.000000', 'consum', 0.0220, 'lps'),
	(389432, 125, '2015-02-01 00:56:19.000000', 'consum', 0.0225, 'lps'),
	(389433, 125, '2015-02-01 00:56:20.000000', 'consum', 0.0230, 'lps'),
	(389434, 125, '2015-02-01 00:56:21.000000', 'consum', 0.0236, 'lps'),
	(389435, 125, '2015-02-01 00:56:22.000000', 'consum', 0.0229, 'lps'),
	(389436, 125, '2015-02-01 00:56:23.000000', 'consum', 0.0226, 'lps'),
	(389437, 125, '2015-02-01 00:56:24.000000', 'consum', 0.0232, 'lps'),
	(389438, 125, '2015-02-01 00:56:25.000000', 'consum', 0.0219, 'lps'),
	(389439, 125, '2015-02-01 00:56:26.000000', 'consum', 0.0219, 'lps'),
	(389440, 125, '2015-02-01 00:56:27.000000', 'consum', 0.0226, 'lps'),
	(389441, 125, '2015-02-01 00:56:28.000000', 'consum', 0.0236, 'lps'),
	(389442, 125, '2015-02-01 00:56:29.000000', 'consum', 0.0212, 'lps'),
	(389443, 125, '2015-02-01 00:56:30.000000', 'consum', 0.0223, 'lps'),
	(389444, 125, '2015-02-01 00:56:31.000000', 'consum', 0.0218, 'lps'),
	(389445, 125, '2015-02-01 00:56:32.000000', 'consum', 0.0211, 'lps'),
	(389446, 125, '2015-02-01 00:56:33.000000', 'consum', 0.0217, 'lps'),
	(389447, 125, '2015-02-01 00:56:34.000000', 'consum', 0.0214, 'lps'),
	(389448, 125, '2015-02-01 00:56:35.000000', 'consum', 0.0211, 'lps'),
	(389449, 125, '2015-02-01 00:56:36.000000', 'consum', 0.0230, 'lps'),
	(389450, 125, '2015-02-01 00:56:37.000000', 'consum', 0.0227, 'lps'),
	(389451, 125, '2015-02-01 00:56:38.000000', 'consum', 0.0235, 'lps'),
	(389452, 125, '2015-02-01 00:56:39.000000', 'consum', 0.0230, 'lps'),
	(389453, 125, '2015-02-01 00:56:40.000000', 'consum', 0.0235, 'lps'),
	(389454, 125, '2015-02-01 00:56:41.000000', 'consum', 0.0221, 'lps'),
	(389455, 125, '2015-02-01 00:56:42.000000', 'consum', 0.0219, 'lps'),
	(389456, 125, '2015-02-01 00:56:43.000000', 'consum', 0.0220, 'lps'),
	(389457, 125, '2015-02-01 00:56:44.000000', 'consum', 0.0236, 'lps'),
	(389458, 125, '2015-02-01 00:56:45.000000', 'consum', 0.0227, 'lps'),
	(389459, 125, '2015-02-01 00:56:46.000000', 'consum', 0.0220, 'lps'),
	(389460, 125, '2015-02-01 00:56:47.000000', 'consum', 0.0211, 'lps'),
	(389461, 125, '2015-02-01 00:56:48.000000', 'consum', 0.0236, 'lps'),
	(389462, 125, '2015-02-01 00:56:49.000000', 'consum', 0.0231, 'lps'),
	(389463, 125, '2015-02-01 00:56:50.000000', 'consum', 0.0210, 'lps'),
	(389464, 125, '2015-02-01 00:56:51.000000', 'consum', 0.0227, 'lps'),
	(389465, 125, '2015-02-01 00:56:52.000000', 'consum', 0.0217, 'lps'),
	(389466, 125, '2015-02-01 00:56:53.000000', 'consum', 0.0221, 'lps'),
	(389467, 125, '2015-02-01 00:56:54.000000', 'consum', 0.0216, 'lps'),
	(389468, 125, '2015-02-01 00:56:55.000000', 'consum', 0.0210, 'lps'),
	(389469, 125, '2015-02-01 00:56:56.000000', 'consum', 0.0218, 'lps'),
	(389470, 125, '2015-02-01 00:56:57.000000', 'consum', 0.0223, 'lps'),
	(389471, 125, '2015-02-01 00:56:58.000000', 'consum', 0.0225, 'lps'),
	(389472, 125, '2015-02-01 00:56:59.000000', 'consum', 0.0219, 'lps'),
	(389473, 125, '2015-02-01 00:57:00.000000', 'consum', 0.0212, 'lps'),
	(389474, 125, '2015-02-01 00:57:01.000000', 'consum', 0.0219, 'lps'),
	(389475, 125, '2015-02-01 00:57:02.000000', 'consum', 0.0223, 'lps'),
	(389476, 125, '2015-02-01 00:57:03.000000', 'consum', 0.0221, 'lps'),
	(389477, 125, '2015-02-01 00:57:04.000000', 'consum', 0.0227, 'lps'),
	(389478, 125, '2015-02-01 00:57:05.000000', 'consum', 0.0236, 'lps'),
	(389479, 125, '2015-02-01 00:57:06.000000', 'consum', 0.0210, 'lps'),
	(389480, 125, '2015-02-01 00:57:07.000000', 'consum', 0.0212, 'lps'),
	(389481, 125, '2015-02-01 00:57:08.000000', 'consum', 0.0219, 'lps'),
	(389482, 125, '2015-02-01 00:57:09.000000', 'consum', 0.0222, 'lps'),
	(389483, 125, '2015-02-01 00:57:10.000000', 'consum', 0.0220, 'lps'),
	(389484, 125, '2015-02-01 00:57:11.000000', 'consum', 0.0221, 'lps'),
	(389485, 125, '2015-02-01 00:57:12.000000', 'consum', 0.0236, 'lps'),
	(389486, 125, '2015-02-01 00:57:13.000000', 'consum', 0.0226, 'lps'),
	(389487, 125, '2015-02-01 00:57:14.000000', 'consum', 0.0215, 'lps'),
	(389488, 125, '2015-02-01 00:57:15.000000', 'consum', 0.0214, 'lps'),
	(389489, 125, '2015-02-01 00:57:16.000000', 'consum', 0.0214, 'lps'),
	(389490, 125, '2015-02-01 00:57:17.000000', 'consum', 0.0220, 'lps'),
	(389491, 125, '2015-02-01 00:57:18.000000', 'consum', 0.0220, 'lps'),
	(389492, 125, '2015-02-01 00:57:19.000000', 'consum', 0.0230, 'lps'),
	(389493, 125, '2015-02-01 00:57:20.000000', 'consum', 0.0229, 'lps'),
	(389494, 125, '2015-02-01 00:57:21.000000', 'consum', 0.0217, 'lps'),
	(389495, 125, '2015-02-01 00:57:22.000000', 'consum', 0.0218, 'lps'),
	(389496, 125, '2015-02-01 00:57:23.000000', 'consum', 0.0227, 'lps'),
	(389497, 125, '2015-02-01 00:57:24.000000', 'consum', 0.0219, 'lps'),
	(389498, 125, '2015-02-01 00:57:25.000000', 'consum', 0.0231, 'lps'),
	(389499, 125, '2015-02-01 00:57:26.000000', 'consum', 0.0236, 'lps'),
	(389500, 125, '2015-02-01 00:57:27.000000', 'consum', 0.0224, 'lps'),
	(389501, 125, '2015-02-01 00:57:28.000000', 'consum', 0.0228, 'lps'),
	(389502, 125, '2015-02-01 00:57:29.000000', 'consum', 0.0230, 'lps'),
	(389503, 125, '2015-02-01 00:57:30.000000', 'consum', 0.0231, 'lps'),
	(389504, 125, '2015-02-01 00:57:31.000000', 'consum', 0.0228, 'lps'),
	(389505, 125, '2015-02-01 00:57:32.000000', 'consum', 0.0210, 'lps'),
	(389506, 125, '2015-02-01 00:57:33.000000', 'consum', 0.0212, 'lps'),
	(389507, 125, '2015-02-01 00:57:34.000000', 'consum', 0.0218, 'lps'),
	(389508, 125, '2015-02-01 00:57:35.000000', 'consum', 0.0220, 'lps'),
	(389509, 125, '2015-02-01 00:57:36.000000', 'consum', 0.0235, 'lps'),
	(389510, 125, '2015-02-01 00:57:37.000000', 'consum', 0.0226, 'lps'),
	(389511, 125, '2015-02-01 00:57:38.000000', 'consum', 0.0214, 'lps'),
	(389512, 125, '2015-02-01 00:57:39.000000', 'consum', 0.0210, 'lps'),
	(389513, 125, '2015-02-01 00:57:40.000000', 'consum', 0.0227, 'lps'),
	(389514, 125, '2015-02-01 00:57:41.000000', 'consum', 0.0214, 'lps'),
	(389515, 125, '2015-02-01 00:57:42.000000', 'consum', 0.0235, 'lps'),
	(389516, 125, '2015-02-01 00:57:43.000000', 'consum', 0.0214, 'lps'),
	(389517, 125, '2015-02-01 00:57:44.000000', 'consum', 0.0235, 'lps'),
	(389518, 125, '2015-02-01 00:57:45.000000', 'consum', 0.0217, 'lps'),
	(389519, 125, '2015-02-01 00:57:46.000000', 'consum', 0.0223, 'lps'),
	(389520, 125, '2015-02-01 00:57:47.000000', 'consum', 0.0226, 'lps'),
	(389521, 125, '2015-02-01 00:57:48.000000', 'consum', 0.0228, 'lps'),
	(389522, 125, '2015-02-01 00:57:49.000000', 'consum', 0.0225, 'lps'),
	(389523, 125, '2015-02-01 00:57:50.000000', 'consum', 0.0230, 'lps'),
	(389524, 125, '2015-02-01 00:57:51.000000', 'consum', 0.0214, 'lps'),
	(389525, 125, '2015-02-01 00:57:52.000000', 'consum', 0.0224, 'lps'),
	(389526, 125, '2015-02-01 00:57:53.000000', 'consum', 0.0214, 'lps'),
	(389527, 125, '2015-02-01 00:57:54.000000', 'consum', 0.0214, 'lps'),
	(389528, 125, '2015-02-01 00:57:55.000000', 'consum', 0.0220, 'lps'),
	(389529, 125, '2015-02-01 00:57:56.000000', 'consum', 0.0220, 'lps'),
	(389530, 125, '2015-02-01 00:57:57.000000', 'consum', 0.0232, 'lps'),
	(389531, 125, '2015-02-01 00:57:58.000000', 'consum', 0.0235, 'lps'),
	(389532, 125, '2015-02-01 00:57:59.000000', 'consum', 0.0217, 'lps'),
	(389533, 125, '2015-02-01 00:58:00.000000', 'consum', 0.0222, 'lps'),
	(389534, 125, '2015-02-01 00:58:01.000000', 'consum', 0.0223, 'lps'),
	(389535, 125, '2015-02-01 00:58:02.000000', 'consum', 0.0215, 'lps'),
	(389536, 125, '2015-02-01 00:58:03.000000', 'consum', 0.0223, 'lps'),
	(389537, 125, '2015-02-01 00:58:04.000000', 'consum', 0.0233, 'lps'),
	(389538, 125, '2015-02-01 00:58:05.000000', 'consum', 0.0234, 'lps'),
	(389539, 125, '2015-02-01 00:58:06.000000', 'consum', 0.0234, 'lps'),
	(389540, 125, '2015-02-01 00:58:07.000000', 'consum', 0.0229, 'lps'),
	(389541, 125, '2015-02-01 00:58:08.000000', 'consum', 0.0210, 'lps'),
	(389542, 125, '2015-02-01 00:58:09.000000', 'consum', 0.0231, 'lps'),
	(389543, 125, '2015-02-01 00:58:10.000000', 'consum', 0.0236, 'lps'),
	(389544, 125, '2015-02-01 00:58:11.000000', 'consum', 0.0222, 'lps'),
	(389545, 125, '2015-02-01 00:58:12.000000', 'consum', 0.0221, 'lps'),
	(389546, 125, '2015-02-01 00:58:13.000000', 'consum', 0.0228, 'lps'),
	(389547, 125, '2015-02-01 00:58:14.000000', 'consum', 0.0215, 'lps'),
	(389548, 125, '2015-02-01 00:58:15.000000', 'consum', 0.0235, 'lps'),
	(389549, 125, '2015-02-01 00:58:16.000000', 'consum', 0.0211, 'lps'),
	(389550, 125, '2015-02-01 00:58:17.000000', 'consum', 0.0224, 'lps'),
	(389551, 125, '2015-02-01 00:58:18.000000', 'consum', 0.0223, 'lps'),
	(389552, 125, '2015-02-01 00:58:19.000000', 'consum', 0.0233, 'lps'),
	(389553, 125, '2015-02-01 00:58:20.000000', 'consum', 0.0233, 'lps'),
	(389554, 125, '2015-02-01 00:58:21.000000', 'consum', 0.0228, 'lps'),
	(389555, 125, '2015-02-01 00:58:22.000000', 'consum', 0.0233, 'lps'),
	(389556, 125, '2015-02-01 00:58:23.000000', 'consum', 0.0216, 'lps'),
	(389557, 125, '2015-02-01 00:58:24.000000', 'consum', 0.0224, 'lps'),
	(389558, 125, '2015-02-01 00:58:25.000000', 'consum', 0.0211, 'lps'),
	(389559, 125, '2015-02-01 00:58:26.000000', 'consum', 0.0226, 'lps'),
	(389560, 125, '2015-02-01 00:58:27.000000', 'consum', 0.0235, 'lps'),
	(389561, 125, '2015-02-01 00:58:28.000000', 'consum', 0.0231, 'lps'),
	(389562, 125, '2015-02-01 00:58:29.000000', 'consum', 0.0214, 'lps'),
	(389563, 125, '2015-02-01 00:58:30.000000', 'consum', 0.0223, 'lps'),
	(389564, 125, '2015-02-01 00:58:31.000000', 'consum', 0.0235, 'lps'),
	(389565, 125, '2015-02-01 00:58:32.000000', 'consum', 0.0218, 'lps'),
	(389566, 125, '2015-02-01 00:58:33.000000', 'consum', 0.0227, 'lps'),
	(389567, 125, '2015-02-01 00:58:34.000000', 'consum', 0.0220, 'lps'),
	(389568, 125, '2015-02-01 00:58:35.000000', 'consum', 0.0234, 'lps'),
	(389569, 125, '2015-02-01 00:58:36.000000', 'consum', 0.0219, 'lps'),
	(389570, 125, '2015-02-01 00:58:37.000000', 'consum', 0.0212, 'lps'),
	(389571, 125, '2015-02-01 00:58:38.000000', 'consum', 0.0219, 'lps'),
	(389572, 125, '2015-02-01 00:58:39.000000', 'consum', 0.0223, 'lps'),
	(389573, 125, '2015-02-01 00:58:40.000000', 'consum', 0.0223, 'lps'),
	(389574, 125, '2015-02-01 00:58:41.000000', 'consum', 0.0234, 'lps'),
	(389575, 125, '2015-02-01 00:58:42.000000', 'consum', 0.0211, 'lps'),
	(389576, 125, '2015-02-01 00:58:43.000000', 'consum', 0.0225, 'lps'),
	(389577, 125, '2015-02-01 00:58:44.000000', 'consum', 0.0230, 'lps'),
	(389578, 125, '2015-02-01 00:58:45.000000', 'consum', 0.0211, 'lps'),
	(389579, 125, '2015-02-01 00:58:46.000000', 'consum', 0.0235, 'lps'),
	(389580, 125, '2015-02-01 00:58:47.000000', 'consum', 0.0225, 'lps'),
	(389581, 125, '2015-02-01 00:58:48.000000', 'consum', 0.0210, 'lps'),
	(389582, 125, '2015-02-01 00:58:49.000000', 'consum', 0.0219, 'lps'),
	(389583, 125, '2015-02-01 00:58:50.000000', 'consum', 0.0229, 'lps'),
	(389584, 125, '2015-02-01 00:58:51.000000', 'consum', 0.0223, 'lps'),
	(389585, 125, '2015-02-01 00:58:52.000000', 'consum', 0.0220, 'lps'),
	(389586, 125, '2015-02-01 00:58:53.000000', 'consum', 0.0221, 'lps'),
	(389587, 125, '2015-02-01 00:58:54.000000', 'consum', 0.0211, 'lps'),
	(389588, 125, '2015-02-01 00:58:55.000000', 'consum', 0.0233, 'lps'),
	(389589, 125, '2015-02-01 00:58:56.000000', 'consum', 0.0217, 'lps'),
	(389590, 125, '2015-02-01 00:58:57.000000', 'consum', 0.0229, 'lps'),
	(389591, 125, '2015-02-01 00:58:58.000000', 'consum', 0.0233, 'lps'),
	(389592, 125, '2015-02-01 00:58:59.000000', 'consum', 0.0212, 'lps'),
	(389593, 125, '2015-02-01 00:59:00.000000', 'consum', 0.0233, 'lps'),
	(389594, 125, '2015-02-01 00:59:01.000000', 'consum', 0.0213, 'lps'),
	(389595, 125, '2015-02-01 00:59:02.000000', 'consum', 0.0210, 'lps'),
	(389596, 125, '2015-02-01 00:59:03.000000', 'consum', 0.0230, 'lps'),
	(389597, 125, '2015-02-01 00:59:04.000000', 'consum', 0.0229, 'lps'),
	(389598, 125, '2015-02-01 00:59:05.000000', 'consum', 0.0219, 'lps'),
	(389599, 125, '2015-02-01 00:59:06.000000', 'consum', 0.0225, 'lps'),
	(389600, 125, '2015-02-01 00:59:07.000000', 'consum', 0.0230, 'lps'),
	(389601, 125, '2015-02-01 00:59:08.000000', 'consum', 0.0214, 'lps'),
	(389602, 125, '2015-02-01 00:59:09.000000', 'consum', 0.0225, 'lps'),
	(389603, 125, '2015-02-01 00:59:10.000000', 'consum', 0.0218, 'lps'),
	(389604, 125, '2015-02-01 00:59:11.000000', 'consum', 0.0234, 'lps'),
	(389605, 125, '2015-02-01 00:59:12.000000', 'consum', 0.0223, 'lps'),
	(389606, 125, '2015-02-01 00:59:13.000000', 'consum', 0.0232, 'lps'),
	(389607, 125, '2015-02-01 00:59:14.000000', 'consum', 0.0227, 'lps'),
	(389608, 125, '2015-02-01 00:59:15.000000', 'consum', 0.0229, 'lps'),
	(389609, 125, '2015-02-01 00:59:16.000000', 'consum', 0.0228, 'lps'),
	(389610, 125, '2015-02-01 00:59:17.000000', 'consum', 0.0214, 'lps'),
	(389611, 125, '2015-02-01 00:59:18.000000', 'consum', 0.0234, 'lps'),
	(389612, 125, '2015-02-01 00:59:19.000000', 'consum', 0.0236, 'lps'),
	(389613, 125, '2015-02-01 00:59:20.000000', 'consum', 0.0214, 'lps'),
	(389614, 125, '2015-02-01 00:59:21.000000', 'consum', 0.0234, 'lps'),
	(389615, 125, '2015-02-01 00:59:22.000000', 'consum', 0.0236, 'lps'),
	(389616, 125, '2015-02-01 00:59:23.000000', 'consum', 0.0215, 'lps'),
	(389617, 125, '2015-02-01 00:59:24.000000', 'consum', 0.0213, 'lps'),
	(389618, 125, '2015-02-01 00:59:25.000000', 'consum', 0.0236, 'lps'),
	(389619, 125, '2015-02-01 00:59:26.000000', 'consum', 0.0225, 'lps'),
	(389620, 125, '2015-02-01 00:59:27.000000', 'consum', 0.0234, 'lps'),
	(389621, 125, '2015-02-01 00:59:28.000000', 'consum', 0.0231, 'lps'),
	(389622, 125, '2015-02-01 00:59:29.000000', 'consum', 0.0216, 'lps'),
	(389623, 125, '2015-02-01 00:59:30.000000', 'consum', 0.0232, 'lps'),
	(389624, 125, '2015-02-01 00:59:31.000000', 'consum', 0.0221, 'lps'),
	(389625, 125, '2015-02-01 00:59:32.000000', 'consum', 0.0227, 'lps'),
	(389626, 125, '2015-02-01 00:59:33.000000', 'consum', 0.0234, 'lps'),
	(389627, 125, '2015-02-01 00:59:34.000000', 'consum', 0.0228, 'lps'),
	(389628, 125, '2015-02-01 00:59:35.000000', 'consum', 0.0229, 'lps'),
	(389629, 125, '2015-02-01 00:59:36.000000', 'consum', 0.0222, 'lps'),
	(389630, 125, '2015-02-01 00:59:37.000000', 'consum', 0.0215, 'lps'),
	(389631, 125, '2015-02-01 00:59:38.000000', 'consum', 0.0224, 'lps'),
	(389632, 125, '2015-02-01 00:59:39.000000', 'consum', 0.0214, 'lps'),
	(389633, 125, '2015-02-01 00:59:40.000000', 'consum', 0.0214, 'lps'),
	(389634, 125, '2015-02-01 00:59:41.000000', 'consum', 0.0220, 'lps'),
	(389635, 125, '2015-02-01 00:59:42.000000', 'consum', 0.0222, 'lps'),
	(389636, 125, '2015-02-01 00:59:43.000000', 'consum', 0.0212, 'lps'),
	(389637, 125, '2015-02-01 00:59:44.000000', 'consum', 0.0213, 'lps'),
	(389638, 125, '2015-02-01 00:59:45.000000', 'consum', 0.0220, 'lps'),
	(389639, 125, '2015-02-01 00:59:46.000000', 'consum', 0.0223, 'lps'),
	(389640, 125, '2015-02-01 00:59:47.000000', 'consum', 0.0218, 'lps'),
	(389641, 125, '2015-02-01 00:59:48.000000', 'consum', 0.0212, 'lps'),
	(389642, 125, '2015-02-01 00:59:49.000000', 'consum', 0.0224, 'lps'),
	(389643, 125, '2015-02-01 00:59:50.000000', 'consum', 0.0220, 'lps'),
	(389644, 125, '2015-02-01 00:59:51.000000', 'consum', 0.0219, 'lps'),
	(389645, 125, '2015-02-01 00:59:52.000000', 'consum', 0.0227, 'lps'),
	(389646, 125, '2015-02-01 00:59:53.000000', 'consum', 0.0214, 'lps'),
	(389647, 125, '2015-02-01 00:59:54.000000', 'consum', 0.0235, 'lps'),
	(389648, 125, '2015-02-01 00:59:55.000000', 'consum', 0.0213, 'lps'),
	(389649, 125, '2015-02-01 00:59:56.000000', 'consum', 0.0233, 'lps'),
	(389650, 125, '2015-02-01 00:59:57.000000', 'consum', 0.0234, 'lps'),
	(389651, 125, '2015-02-01 00:59:58.000000', 'consum', 0.0235, 'lps'),
	(389652, 125, '2015-02-01 00:59:59.000000', 'consum', 0.0210, 'lps'),
	(389653, 125, '2015-02-01 01:00:00.000000', 'consum', 0.0217, 'lps'),
	(389654, 125, '2015-02-01 01:00:01.000000', 'consum', 0.0218, 'lps'),
	(389655, 125, '2015-02-01 01:00:02.000000', 'consum', 0.0229, 'lps'),
	(389656, 125, '2015-02-01 01:00:03.000000', 'consum', 0.0228, 'lps'),
	(389657, 125, '2015-02-01 01:00:04.000000', 'consum', 0.0215, 'lps'),
	(389658, 125, '2015-02-01 01:00:05.000000', 'consum', 0.0236, 'lps'),
	(389659, 126, '2015-02-01 00:00:00.000000', 'consum', 0.0213, 'lps'),
	(389660, 126, '2015-02-01 00:00:01.000000', 'consum', 0.0223, 'lps'),
	(389661, 126, '2015-02-01 00:00:02.000000', 'consum', 0.0221, 'lps'),
	(389662, 126, '2015-02-01 00:00:03.000000', 'consum', 0.0214, 'lps'),
	(389663, 126, '2015-02-01 00:00:04.000000', 'consum', 0.0212, 'lps'),
	(389664, 126, '2015-02-01 00:00:05.000000', 'consum', 0.0222, 'lps'),
	(389665, 126, '2015-02-01 00:00:06.000000', 'consum', 0.0218, 'lps'),
	(389666, 126, '2015-02-01 00:00:07.000000', 'consum', 0.0218, 'lps'),
	(389667, 126, '2015-02-01 00:00:08.000000', 'consum', 0.0210, 'lps'),
	(389668, 126, '2015-02-01 00:00:09.000000', 'consum', 0.0217, 'lps'),
	(389669, 126, '2015-02-01 00:00:10.000000', 'consum', 0.0217, 'lps'),
	(389670, 126, '2015-02-01 00:00:11.000000', 'consum', 0.0221, 'lps'),
	(389671, 126, '2015-02-01 00:00:12.000000', 'consum', 0.0218, 'lps'),
	(389672, 126, '2015-02-01 00:00:13.000000', 'consum', 0.0216, 'lps'),
	(389673, 126, '2015-02-01 00:00:14.000000', 'consum', 0.0215, 'lps'),
	(389674, 126, '2015-02-01 00:00:15.000000', 'consum', 0.0218, 'lps'),
	(389675, 126, '2015-02-01 00:00:16.000000', 'consum', 0.0219, 'lps'),
	(389676, 126, '2015-02-01 00:00:17.000000', 'consum', 0.0217, 'lps'),
	(389677, 126, '2015-02-01 00:00:18.000000', 'consum', 0.0220, 'lps'),
	(389678, 126, '2015-02-01 00:00:19.000000', 'consum', 0.0224, 'lps'),
	(389679, 126, '2015-02-01 00:00:20.000000', 'consum', 0.0220, 'lps'),
	(389680, 126, '2015-02-01 00:00:21.000000', 'consum', 0.0221, 'lps'),
	(389681, 126, '2015-02-01 00:00:22.000000', 'consum', 0.0218, 'lps'),
	(389682, 126, '2015-02-01 00:00:23.000000', 'consum', 0.0217, 'lps'),
	(389683, 126, '2015-02-01 00:00:24.000000', 'consum', 0.0224, 'lps'),
	(389684, 126, '2015-02-01 00:00:25.000000', 'consum', 0.0212, 'lps'),
	(389685, 126, '2015-02-01 00:00:26.000000', 'consum', 0.0224, 'lps'),
	(389686, 126, '2015-02-01 00:00:27.000000', 'consum', 0.0214, 'lps'),
	(389687, 126, '2015-02-01 00:00:28.000000', 'consum', 0.0217, 'lps'),
	(389688, 126, '2015-02-01 00:00:29.000000', 'consum', 0.0220, 'lps'),
	(389689, 126, '2015-02-01 00:00:30.000000', 'consum', 0.0210, 'lps'),
	(389690, 126, '2015-02-01 00:00:31.000000', 'consum', 0.0223, 'lps'),
	(389691, 126, '2015-02-01 00:00:32.000000', 'consum', 0.0218, 'lps'),
	(389692, 126, '2015-02-01 00:00:33.000000', 'consum', 0.0212, 'lps'),
	(389693, 126, '2015-02-01 00:00:34.000000', 'consum', 0.0212, 'lps'),
	(389694, 126, '2015-02-01 00:00:35.000000', 'consum', 0.0215, 'lps'),
	(389695, 126, '2015-02-01 00:00:36.000000', 'consum', 0.0213, 'lps'),
	(389696, 126, '2015-02-01 00:00:37.000000', 'consum', 0.0224, 'lps'),
	(389697, 126, '2015-02-01 00:00:38.000000', 'consum', 0.0212, 'lps'),
	(389698, 126, '2015-02-01 00:00:39.000000', 'consum', 0.0224, 'lps'),
	(389699, 126, '2015-02-01 00:00:40.000000', 'consum', 0.0213, 'lps'),
	(389700, 126, '2015-02-01 00:00:41.000000', 'consum', 0.0212, 'lps'),
	(389701, 126, '2015-02-01 00:00:42.000000', 'consum', 0.0215, 'lps'),
	(389702, 126, '2015-02-01 00:00:43.000000', 'consum', 0.0214, 'lps'),
	(389703, 126, '2015-02-01 00:00:44.000000', 'consum', 0.0217, 'lps'),
	(389704, 126, '2015-02-01 00:00:45.000000', 'consum', 0.0216, 'lps'),
	(389705, 126, '2015-02-01 00:00:46.000000', 'consum', 0.0222, 'lps'),
	(389706, 126, '2015-02-01 00:00:47.000000', 'consum', 0.0220, 'lps'),
	(389707, 126, '2015-02-01 00:00:48.000000', 'consum', 0.0212, 'lps'),
	(389708, 126, '2015-02-01 00:00:49.000000', 'consum', 0.0218, 'lps'),
	(389709, 126, '2015-02-01 00:00:50.000000', 'consum', 0.0213, 'lps'),
	(389710, 126, '2015-02-01 00:00:51.000000', 'consum', 0.0220, 'lps'),
	(389711, 126, '2015-02-01 00:00:52.000000', 'consum', 0.0220, 'lps'),
	(389712, 126, '2015-02-01 00:00:53.000000', 'consum', 0.0218, 'lps'),
	(389713, 126, '2015-02-01 00:00:54.000000', 'consum', 0.0218, 'lps'),
	(389714, 126, '2015-02-01 00:00:55.000000', 'consum', 0.0212, 'lps'),
	(389715, 126, '2015-02-01 00:00:56.000000', 'consum', 0.0212, 'lps'),
	(389716, 126, '2015-02-01 00:00:57.000000', 'consum', 0.0213, 'lps'),
	(389717, 126, '2015-02-01 00:00:58.000000', 'consum', 0.0221, 'lps'),
	(389718, 126, '2015-02-01 00:00:59.000000', 'consum', 0.0212, 'lps'),
	(389719, 126, '2015-02-01 00:01:00.000000', 'consum', 0.0216, 'lps'),
	(389720, 126, '2015-02-01 00:01:01.000000', 'consum', 0.0220, 'lps'),
	(389721, 126, '2015-02-01 00:01:02.000000', 'consum', 0.0214, 'lps'),
	(389722, 126, '2015-02-01 00:01:03.000000', 'consum', 0.0213, 'lps'),
	(389723, 126, '2015-02-01 00:01:04.000000', 'consum', 0.0217, 'lps'),
	(389724, 126, '2015-02-01 00:01:05.000000', 'consum', 0.0218, 'lps'),
	(389725, 126, '2015-02-01 00:01:06.000000', 'consum', 0.0217, 'lps'),
	(389726, 126, '2015-02-01 00:01:07.000000', 'consum', 0.0222, 'lps'),
	(389727, 126, '2015-02-01 00:01:08.000000', 'consum', 0.0220, 'lps'),
	(389728, 126, '2015-02-01 00:01:09.000000', 'consum', 0.0224, 'lps'),
	(389729, 126, '2015-02-01 00:01:10.000000', 'consum', 0.0222, 'lps'),
	(389730, 126, '2015-02-01 00:01:11.000000', 'consum', 0.0210, 'lps'),
	(389731, 126, '2015-02-01 00:01:12.000000', 'consum', 0.0222, 'lps'),
	(389732, 126, '2015-02-01 00:01:13.000000', 'consum', 0.0211, 'lps'),
	(389733, 126, '2015-02-01 00:01:14.000000', 'consum', 0.0224, 'lps'),
	(389734, 126, '2015-02-01 00:01:15.000000', 'consum', 0.0215, 'lps'),
	(389735, 126, '2015-02-01 00:01:16.000000', 'consum', 0.0212, 'lps'),
	(389736, 126, '2015-02-01 00:01:17.000000', 'consum', 0.0220, 'lps'),
	(389737, 126, '2015-02-01 00:01:18.000000', 'consum', 0.0222, 'lps'),
	(389738, 126, '2015-02-01 00:01:19.000000', 'consum', 0.0214, 'lps'),
	(389739, 126, '2015-02-01 00:01:20.000000', 'consum', 0.0222, 'lps'),
	(389740, 126, '2015-02-01 00:01:21.000000', 'consum', 0.0216, 'lps'),
	(389741, 126, '2015-02-01 00:01:22.000000', 'consum', 0.0220, 'lps'),
	(389742, 126, '2015-02-01 00:01:23.000000', 'consum', 0.0210, 'lps'),
	(389743, 126, '2015-02-01 00:01:24.000000', 'consum', 0.0212, 'lps'),
	(389744, 126, '2015-02-01 00:01:25.000000', 'consum', 0.0218, 'lps'),
	(389745, 126, '2015-02-01 00:01:26.000000', 'consum', 0.0218, 'lps'),
	(389746, 126, '2015-02-01 00:01:27.000000', 'consum', 0.0224, 'lps'),
	(389747, 126, '2015-02-01 00:01:28.000000', 'consum', 0.0213, 'lps'),
	(389748, 126, '2015-02-01 00:01:29.000000', 'consum', 0.0212, 'lps'),
	(389749, 126, '2015-02-01 00:01:30.000000', 'consum', 0.0211, 'lps'),
	(389750, 126, '2015-02-01 00:01:31.000000', 'consum', 0.0211, 'lps'),
	(389751, 126, '2015-02-01 00:01:32.000000', 'consum', 0.0211, 'lps'),
	(389752, 126, '2015-02-01 00:01:33.000000', 'consum', 0.0215, 'lps'),
	(389753, 126, '2015-02-01 00:01:34.000000', 'consum', 0.0217, 'lps'),
	(389754, 126, '2015-02-01 00:01:35.000000', 'consum', 0.0217, 'lps'),
	(389755, 126, '2015-02-01 00:01:36.000000', 'consum', 0.0222, 'lps'),
	(389756, 126, '2015-02-01 00:01:37.000000', 'consum', 0.0219, 'lps'),
	(389757, 126, '2015-02-01 00:01:38.000000', 'consum', 0.0221, 'lps'),
	(389758, 126, '2015-02-01 00:01:39.000000', 'consum', 0.0224, 'lps'),
	(389759, 126, '2015-02-01 00:01:40.000000', 'consum', 0.0216, 'lps'),
	(389760, 126, '2015-02-01 00:01:41.000000', 'consum', 0.0214, 'lps'),
	(389761, 126, '2015-02-01 00:01:42.000000', 'consum', 0.0215, 'lps'),
	(389762, 126, '2015-02-01 00:01:43.000000', 'consum', 0.0220, 'lps'),
	(389763, 126, '2015-02-01 00:01:44.000000', 'consum', 0.0216, 'lps'),
	(389764, 126, '2015-02-01 00:01:45.000000', 'consum', 0.0211, 'lps'),
	(389765, 126, '2015-02-01 00:01:46.000000', 'consum', 0.0210, 'lps'),
	(389766, 126, '2015-02-01 00:01:47.000000', 'consum', 0.0211, 'lps'),
	(389767, 126, '2015-02-01 00:01:48.000000', 'consum', 0.0215, 'lps'),
	(389768, 126, '2015-02-01 00:01:49.000000', 'consum', 0.0215, 'lps'),
	(389769, 126, '2015-02-01 00:01:50.000000', 'consum', 0.0222, 'lps'),
	(389770, 126, '2015-02-01 00:01:51.000000', 'consum', 0.0224, 'lps'),
	(389771, 126, '2015-02-01 00:01:52.000000', 'consum', 0.0217, 'lps'),
	(389772, 126, '2015-02-01 00:01:53.000000', 'consum', 0.0218, 'lps'),
	(389773, 126, '2015-02-01 00:01:54.000000', 'consum', 0.0215, 'lps'),
	(389774, 126, '2015-02-01 00:01:55.000000', 'consum', 0.0213, 'lps'),
	(389775, 126, '2015-02-01 00:01:56.000000', 'consum', 0.0223, 'lps'),
	(389776, 126, '2015-02-01 00:01:57.000000', 'consum', 0.0222, 'lps'),
	(389777, 126, '2015-02-01 00:01:58.000000', 'consum', 0.0218, 'lps'),
	(389778, 126, '2015-02-01 00:01:59.000000', 'consum', 0.0215, 'lps'),
	(389779, 126, '2015-02-01 00:02:00.000000', 'consum', 0.0210, 'lps'),
	(389780, 126, '2015-02-01 00:02:01.000000', 'consum', 0.0212, 'lps'),
	(389781, 126, '2015-02-01 00:02:02.000000', 'consum', 0.0220, 'lps'),
	(389782, 126, '2015-02-01 00:02:03.000000', 'consum', 0.0224, 'lps'),
	(389783, 126, '2015-02-01 00:02:04.000000', 'consum', 0.0221, 'lps'),
	(389784, 126, '2015-02-01 00:02:05.000000', 'consum', 0.0223, 'lps'),
	(389785, 126, '2015-02-01 00:02:06.000000', 'consum', 0.0212, 'lps'),
	(389786, 126, '2015-02-01 00:02:07.000000', 'consum', 0.0211, 'lps'),
	(389787, 126, '2015-02-01 00:02:08.000000', 'consum', 0.0224, 'lps'),
	(389788, 126, '2015-02-01 00:02:09.000000', 'consum', 0.0217, 'lps'),
	(389789, 126, '2015-02-01 00:02:10.000000', 'consum', 0.0220, 'lps'),
	(389790, 126, '2015-02-01 00:02:11.000000', 'consum', 0.0211, 'lps'),
	(389791, 126, '2015-02-01 00:02:12.000000', 'consum', 0.0215, 'lps'),
	(389792, 126, '2015-02-01 00:02:13.000000', 'consum', 0.0217, 'lps'),
	(389793, 126, '2015-02-01 00:02:14.000000', 'consum', 0.0217, 'lps'),
	(389794, 126, '2015-02-01 00:02:15.000000', 'consum', 0.0223, 'lps'),
	(389795, 126, '2015-02-01 00:02:16.000000', 'consum', 0.0210, 'lps'),
	(389796, 126, '2015-02-01 00:02:17.000000', 'consum', 0.0216, 'lps'),
	(389797, 126, '2015-02-01 00:02:18.000000', 'consum', 0.0224, 'lps'),
	(389798, 126, '2015-02-01 00:02:19.000000', 'consum', 0.0219, 'lps'),
	(389799, 126, '2015-02-01 00:02:20.000000', 'consum', 0.0212, 'lps'),
	(389800, 126, '2015-02-01 00:02:21.000000', 'consum', 0.0210, 'lps'),
	(389801, 126, '2015-02-01 00:02:22.000000', 'consum', 0.0219, 'lps'),
	(389802, 126, '2015-02-01 00:02:23.000000', 'consum', 0.0224, 'lps'),
	(389803, 126, '2015-02-01 00:02:24.000000', 'consum', 0.0224, 'lps'),
	(389804, 126, '2015-02-01 00:02:25.000000', 'consum', 0.0222, 'lps'),
	(389805, 126, '2015-02-01 00:02:26.000000', 'consum', 0.0214, 'lps'),
	(389806, 126, '2015-02-01 00:02:27.000000', 'consum', 0.0210, 'lps'),
	(389807, 126, '2015-02-01 00:02:28.000000', 'consum', 0.0214, 'lps'),
	(389808, 126, '2015-02-01 00:02:29.000000', 'consum', 0.0215, 'lps'),
	(389809, 126, '2015-02-01 00:02:30.000000', 'consum', 0.0224, 'lps'),
	(389810, 126, '2015-02-01 00:02:31.000000', 'consum', 0.0219, 'lps'),
	(389811, 126, '2015-02-01 00:02:32.000000', 'consum', 0.0215, 'lps'),
	(389812, 126, '2015-02-01 00:02:33.000000', 'consum', 0.0222, 'lps'),
	(389813, 126, '2015-02-01 00:02:34.000000', 'consum', 0.0211, 'lps'),
	(389814, 126, '2015-02-01 00:02:35.000000', 'consum', 0.0223, 'lps'),
	(389815, 126, '2015-02-01 00:02:36.000000', 'consum', 0.0213, 'lps'),
	(389816, 126, '2015-02-01 00:02:37.000000', 'consum', 0.0215, 'lps'),
	(389817, 126, '2015-02-01 00:02:38.000000', 'consum', 0.0215, 'lps'),
	(389818, 126, '2015-02-01 00:02:39.000000', 'consum', 0.0218, 'lps'),
	(389819, 126, '2015-02-01 00:02:40.000000', 'consum', 0.0221, 'lps'),
	(389820, 126, '2015-02-01 00:02:41.000000', 'consum', 0.0210, 'lps'),
	(389821, 126, '2015-02-01 00:02:42.000000', 'consum', 0.0211, 'lps'),
	(389822, 126, '2015-02-01 00:02:43.000000', 'consum', 0.0213, 'lps'),
	(389823, 126, '2015-02-01 00:02:44.000000', 'consum', 0.0223, 'lps'),
	(389824, 126, '2015-02-01 00:02:45.000000', 'consum', 0.0221, 'lps'),
	(389825, 126, '2015-02-01 00:02:46.000000', 'consum', 0.0211, 'lps'),
	(389826, 126, '2015-02-01 00:02:47.000000', 'consum', 0.0212, 'lps'),
	(389827, 126, '2015-02-01 00:02:48.000000', 'consum', 0.0219, 'lps'),
	(389828, 126, '2015-02-01 00:02:49.000000', 'consum', 0.0221, 'lps'),
	(389829, 126, '2015-02-01 00:02:50.000000', 'consum', 0.0221, 'lps'),
	(389830, 126, '2015-02-01 00:02:51.000000', 'consum', 0.0217, 'lps'),
	(389831, 126, '2015-02-01 00:02:52.000000', 'consum', 0.0212, 'lps'),
	(389832, 126, '2015-02-01 00:02:53.000000', 'consum', 0.0214, 'lps'),
	(389833, 126, '2015-02-01 00:02:54.000000', 'consum', 0.0213, 'lps'),
	(389834, 126, '2015-02-01 00:02:55.000000', 'consum', 0.0210, 'lps'),
	(389835, 126, '2015-02-01 00:02:56.000000', 'consum', 0.0219, 'lps'),
	(389836, 126, '2015-02-01 00:02:57.000000', 'consum', 0.0210, 'lps'),
	(389837, 126, '2015-02-01 00:02:58.000000', 'consum', 0.0214, 'lps'),
	(389838, 126, '2015-02-01 00:02:59.000000', 'consum', 0.0217, 'lps'),
	(389839, 126, '2015-02-01 00:03:00.000000', 'consum', 0.0216, 'lps'),
	(389840, 126, '2015-02-01 00:03:01.000000', 'consum', 0.0219, 'lps'),
	(389841, 126, '2015-02-01 00:03:02.000000', 'consum', 0.0221, 'lps'),
	(389842, 126, '2015-02-01 00:03:03.000000', 'consum', 0.0211, 'lps'),
	(389843, 126, '2015-02-01 00:03:04.000000', 'consum', 0.0214, 'lps'),
	(389844, 126, '2015-02-01 00:03:05.000000', 'consum', 0.0210, 'lps'),
	(389845, 126, '2015-02-01 00:03:06.000000', 'consum', 0.0213, 'lps'),
	(389846, 126, '2015-02-01 00:03:07.000000', 'consum', 0.0212, 'lps'),
	(389847, 126, '2015-02-01 00:03:08.000000', 'consum', 0.0212, 'lps'),
	(389848, 126, '2015-02-01 00:03:09.000000', 'consum', 0.0212, 'lps'),
	(389849, 126, '2015-02-01 00:03:10.000000', 'consum', 0.0217, 'lps'),
	(389850, 126, '2015-02-01 00:03:11.000000', 'consum', 0.0223, 'lps'),
	(389851, 126, '2015-02-01 00:03:12.000000', 'consum', 0.0210, 'lps'),
	(389852, 126, '2015-02-01 00:03:13.000000', 'consum', 0.0215, 'lps'),
	(389853, 126, '2015-02-01 00:03:14.000000', 'consum', 0.0222, 'lps'),
	(389854, 126, '2015-02-01 00:03:15.000000', 'consum', 0.0224, 'lps'),
	(389855, 126, '2015-02-01 00:03:16.000000', 'consum', 0.0216, 'lps'),
	(389856, 126, '2015-02-01 00:03:17.000000', 'consum', 0.0212, 'lps'),
	(389857, 126, '2015-02-01 00:03:18.000000', 'consum', 0.0219, 'lps'),
	(389858, 126, '2015-02-01 00:03:19.000000', 'consum', 0.0219, 'lps'),
	(389859, 126, '2015-02-01 00:03:20.000000', 'consum', 0.0212, 'lps'),
	(389860, 126, '2015-02-01 00:03:21.000000', 'consum', 0.0210, 'lps'),
	(389861, 126, '2015-02-01 00:03:22.000000', 'consum', 0.0219, 'lps'),
	(389862, 126, '2015-02-01 00:03:23.000000', 'consum', 0.0211, 'lps'),
	(389863, 126, '2015-02-01 00:03:24.000000', 'consum', 0.0218, 'lps'),
	(389864, 126, '2015-02-01 00:03:25.000000', 'consum', 0.0217, 'lps'),
	(389865, 126, '2015-02-01 00:03:26.000000', 'consum', 0.0223, 'lps'),
	(389866, 126, '2015-02-01 00:03:27.000000', 'consum', 0.0224, 'lps'),
	(389867, 126, '2015-02-01 00:03:28.000000', 'consum', 0.0210, 'lps'),
	(389868, 126, '2015-02-01 00:03:29.000000', 'consum', 0.0216, 'lps'),
	(389869, 126, '2015-02-01 00:03:30.000000', 'consum', 0.0224, 'lps'),
	(389870, 126, '2015-02-01 00:03:31.000000', 'consum', 0.0219, 'lps'),
	(389871, 126, '2015-02-01 00:03:32.000000', 'consum', 0.0211, 'lps'),
	(389872, 126, '2015-02-01 00:03:33.000000', 'consum', 0.0218, 'lps'),
	(389873, 126, '2015-02-01 00:03:34.000000', 'consum', 0.0217, 'lps'),
	(389874, 126, '2015-02-01 00:03:35.000000', 'consum', 0.0223, 'lps'),
	(389875, 126, '2015-02-01 00:03:36.000000', 'consum', 0.0223, 'lps'),
	(389876, 126, '2015-02-01 00:03:37.000000', 'consum', 0.0224, 'lps'),
	(389877, 126, '2015-02-01 00:03:38.000000', 'consum', 0.0212, 'lps'),
	(389878, 126, '2015-02-01 00:03:39.000000', 'consum', 0.0224, 'lps'),
	(389879, 126, '2015-02-01 00:03:40.000000', 'consum', 0.0214, 'lps'),
	(389880, 126, '2015-02-01 00:03:41.000000', 'consum', 0.0217, 'lps'),
	(389881, 126, '2015-02-01 00:03:42.000000', 'consum', 0.0218, 'lps'),
	(389882, 126, '2015-02-01 00:03:43.000000', 'consum', 0.0214, 'lps'),
	(389883, 126, '2015-02-01 00:03:44.000000', 'consum', 0.0224, 'lps'),
	(389884, 126, '2015-02-01 00:03:45.000000', 'consum', 0.0224, 'lps'),
	(389885, 126, '2015-02-01 00:03:46.000000', 'consum', 0.0223, 'lps'),
	(389886, 126, '2015-02-01 00:03:47.000000', 'consum', 0.0218, 'lps'),
	(389887, 126, '2015-02-01 00:03:48.000000', 'consum', 0.0213, 'lps'),
	(389888, 126, '2015-02-01 00:03:49.000000', 'consum', 0.0216, 'lps'),
	(389889, 126, '2015-02-01 00:03:50.000000', 'consum', 0.0214, 'lps'),
	(389890, 126, '2015-02-01 00:03:51.000000', 'consum', 0.0215, 'lps'),
	(389891, 126, '2015-02-01 00:03:52.000000', 'consum', 0.0223, 'lps'),
	(389892, 126, '2015-02-01 00:03:53.000000', 'consum', 0.0216, 'lps'),
	(389893, 126, '2015-02-01 00:03:54.000000', 'consum', 0.0217, 'lps'),
	(389894, 126, '2015-02-01 00:03:55.000000', 'consum', 0.0211, 'lps'),
	(389895, 126, '2015-02-01 00:03:56.000000', 'consum', 0.0223, 'lps'),
	(389896, 126, '2015-02-01 00:03:57.000000', 'consum', 0.0214, 'lps'),
	(389897, 126, '2015-02-01 00:03:58.000000', 'consum', 0.0222, 'lps'),
	(389898, 126, '2015-02-01 00:03:59.000000', 'consum', 0.0215, 'lps'),
	(389899, 126, '2015-02-01 00:04:00.000000', 'consum', 0.0212, 'lps'),
	(389900, 126, '2015-02-01 00:04:01.000000', 'consum', 0.0220, 'lps'),
	(389901, 126, '2015-02-01 00:04:02.000000', 'consum', 0.0211, 'lps'),
	(389902, 126, '2015-02-01 00:04:03.000000', 'consum', 0.0216, 'lps'),
	(389903, 126, '2015-02-01 00:04:04.000000', 'consum', 0.0222, 'lps'),
	(389904, 126, '2015-02-01 00:04:05.000000', 'consum', 0.0222, 'lps'),
	(389905, 126, '2015-02-01 00:04:06.000000', 'consum', 0.0220, 'lps'),
	(389906, 126, '2015-02-01 00:04:07.000000', 'consum', 0.0210, 'lps'),
	(389907, 126, '2015-02-01 00:04:08.000000', 'consum', 0.0212, 'lps'),
	(389908, 126, '2015-02-01 00:04:09.000000', 'consum', 0.0219, 'lps'),
	(389909, 126, '2015-02-01 00:04:10.000000', 'consum', 0.0219, 'lps'),
	(389910, 126, '2015-02-01 00:04:11.000000', 'consum', 0.0215, 'lps'),
	(389911, 126, '2015-02-01 00:04:12.000000', 'consum', 0.0223, 'lps'),
	(389912, 126, '2015-02-01 00:04:13.000000', 'consum', 0.0214, 'lps'),
	(389913, 126, '2015-02-01 00:04:14.000000', 'consum', 0.0224, 'lps'),
	(389914, 126, '2015-02-01 00:04:15.000000', 'consum', 0.0223, 'lps'),
	(389915, 126, '2015-02-01 00:04:16.000000', 'consum', 0.0216, 'lps'),
	(389916, 126, '2015-02-01 00:04:17.000000', 'consum', 0.0219, 'lps'),
	(389917, 126, '2015-02-01 00:04:18.000000', 'consum', 0.0223, 'lps'),
	(389918, 126, '2015-02-01 00:04:19.000000', 'consum', 0.0216, 'lps'),
	(389919, 126, '2015-02-01 00:04:20.000000', 'consum', 0.0218, 'lps'),
	(389920, 126, '2015-02-01 00:04:21.000000', 'consum', 0.0219, 'lps'),
	(389921, 126, '2015-02-01 00:04:22.000000', 'consum', 0.0213, 'lps'),
	(389922, 126, '2015-02-01 00:04:23.000000', 'consum', 0.0216, 'lps'),
	(389923, 126, '2015-02-01 00:04:24.000000', 'consum', 0.0217, 'lps'),
	(389924, 126, '2015-02-01 00:04:25.000000', 'consum', 0.0213, 'lps'),
	(389925, 126, '2015-02-01 00:04:26.000000', 'consum', 0.0220, 'lps'),
	(389926, 126, '2015-02-01 00:04:27.000000', 'consum', 0.0218, 'lps'),
	(389927, 126, '2015-02-01 00:04:28.000000', 'consum', 0.0224, 'lps'),
	(389928, 126, '2015-02-01 00:04:29.000000', 'consum', 0.0211, 'lps'),
	(389929, 126, '2015-02-01 00:04:30.000000', 'consum', 0.0216, 'lps'),
	(389930, 126, '2015-02-01 00:04:31.000000', 'consum', 0.0224, 'lps'),
	(389931, 126, '2015-02-01 00:04:32.000000', 'consum', 0.0218, 'lps'),
	(389932, 126, '2015-02-01 00:04:33.000000', 'consum', 0.0224, 'lps'),
	(389933, 126, '2015-02-01 00:04:34.000000', 'consum', 0.0213, 'lps'),
	(389934, 126, '2015-02-01 00:04:35.000000', 'consum', 0.0211, 'lps'),
	(389935, 126, '2015-02-01 00:04:36.000000', 'consum', 0.0221, 'lps'),
	(389936, 126, '2015-02-01 00:04:37.000000', 'consum', 0.0219, 'lps'),
	(389937, 126, '2015-02-01 00:04:38.000000', 'consum', 0.0224, 'lps'),
	(389938, 126, '2015-02-01 00:04:39.000000', 'consum', 0.0223, 'lps'),
	(389939, 126, '2015-02-01 00:04:40.000000', 'consum', 0.0217, 'lps'),
	(389940, 126, '2015-02-01 00:04:41.000000', 'consum', 0.0224, 'lps'),
	(389941, 126, '2015-02-01 00:04:42.000000', 'consum', 0.0213, 'lps'),
	(389942, 126, '2015-02-01 00:04:43.000000', 'consum', 0.0213, 'lps'),
	(389943, 126, '2015-02-01 00:04:44.000000', 'consum', 0.0218, 'lps'),
	(389944, 126, '2015-02-01 00:04:45.000000', 'consum', 0.0212, 'lps'),
	(389945, 126, '2015-02-01 00:04:46.000000', 'consum', 0.0210, 'lps'),
	(389946, 126, '2015-02-01 00:04:47.000000', 'consum', 0.0219, 'lps'),
	(389947, 126, '2015-02-01 00:04:48.000000', 'consum', 0.0210, 'lps'),
	(389948, 126, '2015-02-01 00:04:49.000000', 'consum', 0.0214, 'lps'),
	(389949, 126, '2015-02-01 00:04:50.000000', 'consum', 0.0214, 'lps'),
	(389950, 126, '2015-02-01 00:04:51.000000', 'consum', 0.0218, 'lps'),
	(389951, 126, '2015-02-01 00:04:52.000000', 'consum', 0.0210, 'lps'),
	(389952, 126, '2015-02-01 00:04:53.000000', 'consum', 0.0214, 'lps'),
	(389953, 126, '2015-02-01 00:04:54.000000', 'consum', 0.0218, 'lps'),
	(389954, 126, '2015-02-01 00:04:55.000000', 'consum', 0.0222, 'lps'),
	(389955, 126, '2015-02-01 00:04:56.000000', 'consum', 0.0215, 'lps'),
	(389956, 126, '2015-02-01 00:04:57.000000', 'consum', 0.0216, 'lps'),
	(389957, 126, '2015-02-01 00:04:58.000000', 'consum', 0.0210, 'lps'),
	(389958, 126, '2015-02-01 00:04:59.000000', 'consum', 0.0222, 'lps'),
	(389959, 126, '2015-02-01 00:05:00.000000', 'consum', 0.0224, 'lps'),
	(389960, 126, '2015-02-01 00:05:01.000000', 'consum', 0.0216, 'lps'),
	(389961, 126, '2015-02-01 00:05:02.000000', 'consum', 0.0213, 'lps'),
	(389962, 126, '2015-02-01 00:05:03.000000', 'consum', 0.0224, 'lps'),
	(389963, 126, '2015-02-01 00:05:04.000000', 'consum', 0.0224, 'lps'),
	(389964, 126, '2015-02-01 00:05:05.000000', 'consum', 0.0210, 'lps'),
	(389965, 126, '2015-02-01 00:05:06.000000', 'consum', 0.0215, 'lps'),
	(389966, 126, '2015-02-01 00:05:07.000000', 'consum', 0.0220, 'lps'),
	(389967, 126, '2015-02-01 00:05:08.000000', 'consum', 0.0213, 'lps'),
	(389968, 126, '2015-02-01 00:05:09.000000', 'consum', 0.0213, 'lps'),
	(389969, 126, '2015-02-01 00:05:10.000000', 'consum', 0.0216, 'lps'),
	(389970, 126, '2015-02-01 00:05:11.000000', 'consum', 0.0215, 'lps'),
	(389971, 126, '2015-02-01 00:05:12.000000', 'consum', 0.0217, 'lps'),
	(389972, 126, '2015-02-01 00:05:13.000000', 'consum', 0.0217, 'lps'),
	(389973, 126, '2015-02-01 00:05:14.000000', 'consum', 0.0210, 'lps'),
	(389974, 126, '2015-02-01 00:05:15.000000', 'consum', 0.0219, 'lps'),
	(389975, 126, '2015-02-01 00:05:16.000000', 'consum', 0.0211, 'lps'),
	(389976, 126, '2015-02-01 00:05:17.000000', 'consum', 0.0220, 'lps'),
	(389977, 126, '2015-02-01 00:05:18.000000', 'consum', 0.0211, 'lps'),
	(389978, 126, '2015-02-01 00:05:19.000000', 'consum', 0.0215, 'lps'),
	(389979, 126, '2015-02-01 00:05:20.000000', 'consum', 0.0218, 'lps'),
	(389980, 126, '2015-02-01 00:05:21.000000', 'consum', 0.0221, 'lps'),
	(389981, 126, '2015-02-01 00:05:22.000000', 'consum', 0.0212, 'lps'),
	(389982, 126, '2015-02-01 00:05:23.000000', 'consum', 0.0215, 'lps'),
	(389983, 126, '2015-02-01 00:05:24.000000', 'consum', 0.0217, 'lps'),
	(389984, 126, '2015-02-01 00:05:25.000000', 'consum', 0.0213, 'lps'),
	(389985, 126, '2015-02-01 00:05:26.000000', 'consum', 0.0222, 'lps'),
	(389986, 126, '2015-02-01 00:05:27.000000', 'consum', 0.0217, 'lps'),
	(389987, 126, '2015-02-01 00:05:28.000000', 'consum', 0.0224, 'lps'),
	(389988, 126, '2015-02-01 00:05:29.000000', 'consum', 0.0214, 'lps'),
	(389989, 126, '2015-02-01 00:05:30.000000', 'consum', 0.0218, 'lps'),
	(389990, 126, '2015-02-01 00:05:31.000000', 'consum', 0.0222, 'lps'),
	(389991, 126, '2015-02-01 00:05:32.000000', 'consum', 0.0218, 'lps'),
	(389992, 126, '2015-02-01 00:05:33.000000', 'consum', 0.0215, 'lps'),
	(389993, 126, '2015-02-01 00:05:34.000000', 'consum', 0.0212, 'lps'),
	(389994, 126, '2015-02-01 00:05:35.000000', 'consum', 0.0221, 'lps'),
	(389995, 126, '2015-02-01 00:05:36.000000', 'consum', 0.0213, 'lps'),
	(389996, 126, '2015-02-01 00:05:37.000000', 'consum', 0.0221, 'lps'),
	(389997, 126, '2015-02-01 00:05:38.000000', 'consum', 0.0212, 'lps'),
	(389998, 126, '2015-02-01 00:05:39.000000', 'consum', 0.0220, 'lps'),
	(389999, 126, '2015-02-01 00:05:40.000000', 'consum', 0.0223, 'lps'),
	(390000, 126, '2015-02-01 00:05:41.000000', 'consum', 0.0215, 'lps'),
	(390001, 126, '2015-02-01 00:05:42.000000', 'consum', 0.0211, 'lps'),
	(390002, 126, '2015-02-01 00:05:43.000000', 'consum', 0.0217, 'lps'),
	(390003, 126, '2015-02-01 00:05:44.000000', 'consum', 0.0212, 'lps'),
	(390004, 126, '2015-02-01 00:05:45.000000', 'consum', 0.0215, 'lps'),
	(390005, 126, '2015-02-01 00:05:46.000000', 'consum', 0.0212, 'lps'),
	(390006, 126, '2015-02-01 00:05:47.000000', 'consum', 0.0224, 'lps'),
	(390007, 126, '2015-02-01 00:05:48.000000', 'consum', 0.0212, 'lps'),
	(390008, 126, '2015-02-01 00:05:49.000000', 'consum', 0.0211, 'lps'),
	(390009, 126, '2015-02-01 00:05:50.000000', 'consum', 0.0222, 'lps'),
	(390010, 126, '2015-02-01 00:05:51.000000', 'consum', 0.0223, 'lps'),
	(390011, 126, '2015-02-01 00:05:52.000000', 'consum', 0.0210, 'lps'),
	(390012, 126, '2015-02-01 00:05:53.000000', 'consum', 0.0218, 'lps'),
	(390013, 126, '2015-02-01 00:05:54.000000', 'consum', 0.0219, 'lps'),
	(390014, 126, '2015-02-01 00:05:55.000000', 'consum', 0.0219, 'lps'),
	(390015, 126, '2015-02-01 00:05:56.000000', 'consum', 0.0211, 'lps'),
	(390016, 126, '2015-02-01 00:05:57.000000', 'consum', 0.0218, 'lps'),
	(390017, 126, '2015-02-01 00:05:58.000000', 'consum', 0.0219, 'lps'),
	(390018, 126, '2015-02-01 00:05:59.000000', 'consum', 0.0215, 'lps'),
	(390019, 126, '2015-02-01 00:06:00.000000', 'consum', 0.0223, 'lps'),
	(390020, 126, '2015-02-01 00:06:01.000000', 'consum', 0.0216, 'lps'),
	(390021, 126, '2015-02-01 00:06:02.000000', 'consum', 0.0217, 'lps'),
	(390022, 126, '2015-02-01 00:06:03.000000', 'consum', 0.0211, 'lps'),
	(390023, 126, '2015-02-01 00:06:04.000000', 'consum', 0.0211, 'lps'),
	(390024, 126, '2015-02-01 00:06:05.000000', 'consum', 0.0212, 'lps'),
	(390025, 126, '2015-02-01 00:06:06.000000', 'consum', 0.0219, 'lps'),
	(390026, 126, '2015-02-01 00:06:07.000000', 'consum', 0.0218, 'lps'),
	(390027, 126, '2015-02-01 00:06:08.000000', 'consum', 0.0223, 'lps'),
	(390028, 126, '2015-02-01 00:06:09.000000', 'consum', 0.0222, 'lps'),
	(390029, 126, '2015-02-01 00:06:10.000000', 'consum', 0.0216, 'lps'),
	(390030, 126, '2015-02-01 00:06:11.000000', 'consum', 0.0221, 'lps'),
	(390031, 126, '2015-02-01 00:06:12.000000', 'consum', 0.0218, 'lps'),
	(390032, 126, '2015-02-01 00:06:13.000000', 'consum', 0.0218, 'lps'),
	(390033, 126, '2015-02-01 00:06:14.000000', 'consum', 0.0212, 'lps'),
	(390034, 126, '2015-02-01 00:06:15.000000', 'consum', 0.0212, 'lps'),
	(390035, 126, '2015-02-01 00:06:16.000000', 'consum', 0.0214, 'lps'),
	(390036, 126, '2015-02-01 00:06:17.000000', 'consum', 0.0210, 'lps'),
	(390037, 126, '2015-02-01 00:06:18.000000', 'consum', 0.0215, 'lps'),
	(390038, 126, '2015-02-01 00:06:19.000000', 'consum', 0.0218, 'lps'),
	(390039, 126, '2015-02-01 00:06:20.000000', 'consum', 0.0221, 'lps'),
	(390040, 126, '2015-02-01 00:06:21.000000', 'consum', 0.0212, 'lps'),
	(390041, 126, '2015-02-01 00:06:22.000000', 'consum', 0.0217, 'lps'),
	(390042, 126, '2015-02-01 00:06:23.000000', 'consum', 0.0223, 'lps'),
	(390043, 126, '2015-02-01 00:06:24.000000', 'consum', 0.0210, 'lps'),
	(390044, 126, '2015-02-01 00:06:25.000000', 'consum', 0.0218, 'lps'),
	(390045, 126, '2015-02-01 00:06:26.000000', 'consum', 0.0218, 'lps'),
	(390046, 126, '2015-02-01 00:06:27.000000', 'consum', 0.0211, 'lps'),
	(390047, 126, '2015-02-01 00:06:28.000000', 'consum', 0.0223, 'lps'),
	(390048, 126, '2015-02-01 00:06:29.000000', 'consum', 0.0214, 'lps'),
	(390049, 126, '2015-02-01 00:06:30.000000', 'consum', 0.0220, 'lps'),
	(390050, 126, '2015-02-01 00:06:31.000000', 'consum', 0.0217, 'lps'),
	(390051, 126, '2015-02-01 00:06:32.000000', 'consum', 0.0218, 'lps'),
	(390052, 126, '2015-02-01 00:06:33.000000', 'consum', 0.0215, 'lps'),
	(390053, 126, '2015-02-01 00:06:34.000000', 'consum', 0.0210, 'lps'),
	(390054, 126, '2015-02-01 00:06:35.000000', 'consum', 0.0211, 'lps'),
	(390055, 126, '2015-02-01 00:06:36.000000', 'consum', 0.0214, 'lps'),
	(390056, 126, '2015-02-01 00:06:37.000000', 'consum', 0.0215, 'lps'),
	(390057, 126, '2015-02-01 00:06:38.000000', 'consum', 0.0222, 'lps'),
	(390058, 126, '2015-02-01 00:06:39.000000', 'consum', 0.0224, 'lps'),
	(390059, 126, '2015-02-01 00:06:40.000000', 'consum', 0.0215, 'lps'),
	(390060, 126, '2015-02-01 00:06:41.000000', 'consum', 0.0224, 'lps'),
	(390061, 126, '2015-02-01 00:06:42.000000', 'consum', 0.0222, 'lps'),
	(390062, 126, '2015-02-01 00:06:43.000000', 'consum', 0.0213, 'lps'),
	(390063, 126, '2015-02-01 00:06:44.000000', 'consum', 0.0218, 'lps'),
	(390064, 126, '2015-02-01 00:06:45.000000', 'consum', 0.0213, 'lps'),
	(390065, 126, '2015-02-01 00:06:46.000000', 'consum', 0.0218, 'lps'),
	(390066, 126, '2015-02-01 00:06:47.000000', 'consum', 0.0224, 'lps'),
	(390067, 126, '2015-02-01 00:06:48.000000', 'consum', 0.0211, 'lps'),
	(390068, 126, '2015-02-01 00:06:49.000000', 'consum', 0.0218, 'lps'),
	(390069, 126, '2015-02-01 00:06:50.000000', 'consum', 0.0217, 'lps'),
	(390070, 126, '2015-02-01 00:06:51.000000', 'consum', 0.0222, 'lps'),
	(390071, 126, '2015-02-01 00:06:52.000000', 'consum', 0.0220, 'lps'),
	(390072, 126, '2015-02-01 00:06:53.000000', 'consum', 0.0211, 'lps'),
	(390073, 126, '2015-02-01 00:06:54.000000', 'consum', 0.0216, 'lps'),
	(390074, 126, '2015-02-01 00:06:55.000000', 'consum', 0.0222, 'lps'),
	(390075, 126, '2015-02-01 00:06:56.000000', 'consum', 0.0221, 'lps'),
	(390076, 126, '2015-02-01 00:06:57.000000', 'consum', 0.0214, 'lps'),
	(390077, 126, '2015-02-01 00:06:58.000000', 'consum', 0.0215, 'lps'),
	(390078, 126, '2015-02-01 00:06:59.000000', 'consum', 0.0221, 'lps'),
	(390079, 126, '2015-02-01 00:07:00.000000', 'consum', 0.0221, 'lps'),
	(390080, 126, '2015-02-01 00:07:01.000000', 'consum', 0.0218, 'lps'),
	(390081, 126, '2015-02-01 00:07:02.000000', 'consum', 0.0216, 'lps'),
	(390082, 126, '2015-02-01 00:07:03.000000', 'consum', 0.0219, 'lps'),
	(390083, 126, '2015-02-01 00:07:04.000000', 'consum', 0.0223, 'lps'),
	(390084, 126, '2015-02-01 00:07:05.000000', 'consum', 0.0217, 'lps'),
	(390085, 126, '2015-02-01 00:07:06.000000', 'consum', 0.0220, 'lps'),
	(390086, 126, '2015-02-01 00:07:07.000000', 'consum', 0.0211, 'lps'),
	(390087, 126, '2015-02-01 00:07:08.000000', 'consum', 0.0215, 'lps'),
	(390088, 126, '2015-02-01 00:07:09.000000', 'consum', 0.0216, 'lps'),
	(390089, 126, '2015-02-01 00:07:10.000000', 'consum', 0.0212, 'lps'),
	(390090, 126, '2015-02-01 00:07:11.000000', 'consum', 0.0217, 'lps'),
	(390091, 126, '2015-02-01 00:07:12.000000', 'consum', 0.0224, 'lps'),
	(390092, 126, '2015-02-01 00:07:13.000000', 'consum', 0.0217, 'lps'),
	(390093, 126, '2015-02-01 00:07:14.000000', 'consum', 0.0217, 'lps'),
	(390094, 126, '2015-02-01 00:07:15.000000', 'consum', 0.0224, 'lps'),
	(390095, 126, '2015-02-01 00:07:16.000000', 'consum', 0.0217, 'lps'),
	(390096, 126, '2015-02-01 00:07:17.000000', 'consum', 0.0217, 'lps'),
	(390097, 126, '2015-02-01 00:07:18.000000', 'consum', 0.0222, 'lps'),
	(390098, 126, '2015-02-01 00:07:19.000000', 'consum', 0.0223, 'lps'),
	(390099, 126, '2015-02-01 00:07:20.000000', 'consum', 0.0210, 'lps'),
	(390100, 126, '2015-02-01 00:07:21.000000', 'consum', 0.0213, 'lps'),
	(390101, 126, '2015-02-01 00:07:22.000000', 'consum', 0.0213, 'lps'),
	(390102, 126, '2015-02-01 00:07:23.000000', 'consum', 0.0216, 'lps'),
	(390103, 126, '2015-02-01 00:07:24.000000', 'consum', 0.0218, 'lps'),
	(390104, 126, '2015-02-01 00:07:25.000000', 'consum', 0.0216, 'lps'),
	(390105, 126, '2015-02-01 00:07:26.000000', 'consum', 0.0218, 'lps'),
	(390106, 126, '2015-02-01 00:07:27.000000', 'consum', 0.0216, 'lps'),
	(390107, 126, '2015-02-01 00:07:28.000000', 'consum', 0.0218, 'lps'),
	(390108, 126, '2015-02-01 00:07:29.000000', 'consum', 0.0217, 'lps'),
	(390109, 126, '2015-02-01 00:07:30.000000', 'consum', 0.0221, 'lps'),
	(390110, 126, '2015-02-01 00:07:31.000000', 'consum', 0.0216, 'lps'),
	(390111, 126, '2015-02-01 00:07:32.000000', 'consum', 0.0221, 'lps'),
	(390112, 126, '2015-02-01 00:07:33.000000', 'consum', 0.0216, 'lps'),
	(390113, 126, '2015-02-01 00:07:34.000000', 'consum', 0.0224, 'lps'),
	(390114, 126, '2015-02-01 00:07:35.000000', 'consum', 0.0219, 'lps'),
	(390115, 126, '2015-02-01 00:07:36.000000', 'consum', 0.0210, 'lps'),
	(390116, 126, '2015-02-01 00:07:37.000000', 'consum', 0.0217, 'lps'),
	(390117, 126, '2015-02-01 00:07:38.000000', 'consum', 0.0214, 'lps'),
	(390118, 126, '2015-02-01 00:07:39.000000', 'consum', 0.0210, 'lps'),
	(390119, 126, '2015-02-01 00:07:40.000000', 'consum', 0.0215, 'lps'),
	(390120, 126, '2015-02-01 00:07:41.000000', 'consum', 0.0220, 'lps'),
	(390121, 126, '2015-02-01 00:07:42.000000', 'consum', 0.0214, 'lps'),
	(390122, 126, '2015-02-01 00:07:43.000000', 'consum', 0.0216, 'lps'),
	(390123, 126, '2015-02-01 00:07:44.000000', 'consum', 0.0213, 'lps'),
	(390124, 126, '2015-02-01 00:07:45.000000', 'consum', 0.0222, 'lps'),
	(390125, 126, '2015-02-01 00:07:46.000000', 'consum', 0.0216, 'lps'),
	(390126, 126, '2015-02-01 00:07:47.000000', 'consum', 0.0220, 'lps'),
	(390127, 126, '2015-02-01 00:07:48.000000', 'consum', 0.0213, 'lps'),
	(390128, 126, '2015-02-01 00:07:49.000000', 'consum', 0.0223, 'lps'),
	(390129, 126, '2015-02-01 00:07:50.000000', 'consum', 0.0210, 'lps'),
	(390130, 126, '2015-02-01 00:07:51.000000', 'consum', 0.0216, 'lps'),
	(390131, 126, '2015-02-01 00:07:52.000000', 'consum', 0.0223, 'lps'),
	(390132, 126, '2015-02-01 00:07:53.000000', 'consum', 0.0214, 'lps'),
	(390133, 126, '2015-02-01 00:07:54.000000', 'consum', 0.0220, 'lps'),
	(390134, 126, '2015-02-01 00:07:55.000000', 'consum', 0.0219, 'lps'),
	(390135, 126, '2015-02-01 00:07:56.000000', 'consum', 0.0212, 'lps'),
	(390136, 126, '2015-02-01 00:07:57.000000', 'consum', 0.0223, 'lps'),
	(390137, 126, '2015-02-01 00:07:58.000000', 'consum', 0.0224, 'lps'),
	(390138, 126, '2015-02-01 00:07:59.000000', 'consum', 0.0212, 'lps'),
	(390139, 126, '2015-02-01 00:08:00.000000', 'consum', 0.0221, 'lps'),
	(390140, 126, '2015-02-01 00:08:01.000000', 'consum', 0.0218, 'lps'),
	(390141, 126, '2015-02-01 00:08:02.000000', 'consum', 0.0214, 'lps'),
	(390142, 126, '2015-02-01 00:08:03.000000', 'consum', 0.0223, 'lps'),
	(390143, 126, '2015-02-01 00:08:04.000000', 'consum', 0.0220, 'lps'),
	(390144, 126, '2015-02-01 00:08:05.000000', 'consum', 0.0219, 'lps'),
	(390145, 126, '2015-02-01 00:08:06.000000', 'consum', 0.0212, 'lps'),
	(390146, 126, '2015-02-01 00:08:07.000000', 'consum', 0.0223, 'lps'),
	(390147, 126, '2015-02-01 00:08:08.000000', 'consum', 0.0210, 'lps'),
	(390148, 126, '2015-02-01 00:08:09.000000', 'consum', 0.0215, 'lps'),
	(390149, 126, '2015-02-01 00:08:10.000000', 'consum', 0.0221, 'lps'),
	(390150, 126, '2015-02-01 00:08:11.000000', 'consum', 0.0222, 'lps'),
	(390151, 126, '2015-02-01 00:08:12.000000', 'consum', 0.0222, 'lps'),
	(390152, 126, '2015-02-01 00:08:13.000000', 'consum', 0.0221, 'lps'),
	(390153, 126, '2015-02-01 00:08:14.000000', 'consum', 0.0215, 'lps'),
	(390154, 126, '2015-02-01 00:08:15.000000', 'consum', 0.0216, 'lps'),
	(390155, 126, '2015-02-01 00:08:16.000000', 'consum', 0.0224, 'lps'),
	(390156, 126, '2015-02-01 00:08:17.000000', 'consum', 0.0221, 'lps'),
	(390157, 126, '2015-02-01 00:08:18.000000', 'consum', 0.0220, 'lps'),
	(390158, 126, '2015-02-01 00:08:19.000000', 'consum', 0.0216, 'lps'),
	(390159, 126, '2015-02-01 00:08:20.000000', 'consum', 0.0223, 'lps'),
	(390160, 126, '2015-02-01 00:08:21.000000', 'consum', 0.0213, 'lps'),
	(390161, 126, '2015-02-01 00:08:22.000000', 'consum', 0.0217, 'lps'),
	(390162, 126, '2015-02-01 00:08:23.000000', 'consum', 0.0219, 'lps'),
	(390163, 126, '2015-02-01 00:08:24.000000', 'consum', 0.0222, 'lps'),
	(390164, 126, '2015-02-01 00:08:25.000000', 'consum', 0.0213, 'lps'),
	(390165, 126, '2015-02-01 00:08:26.000000', 'consum', 0.0220, 'lps'),
	(390166, 126, '2015-02-01 00:08:27.000000', 'consum', 0.0220, 'lps'),
	(390167, 126, '2015-02-01 00:08:28.000000', 'consum', 0.0215, 'lps'),
	(390168, 126, '2015-02-01 00:08:29.000000', 'consum', 0.0220, 'lps'),
	(390169, 126, '2015-02-01 00:08:30.000000', 'consum', 0.0216, 'lps'),
	(390170, 126, '2015-02-01 00:08:31.000000', 'consum', 0.0211, 'lps'),
	(390171, 126, '2015-02-01 00:08:32.000000', 'consum', 0.0213, 'lps'),
	(390172, 126, '2015-02-01 00:08:33.000000', 'consum', 0.0223, 'lps'),
	(390173, 126, '2015-02-01 00:08:34.000000', 'consum', 0.0220, 'lps'),
	(390174, 126, '2015-02-01 00:08:35.000000', 'consum', 0.0221, 'lps'),
	(390175, 126, '2015-02-01 00:08:36.000000', 'consum', 0.0222, 'lps'),
	(390176, 126, '2015-02-01 00:08:37.000000', 'consum', 0.0221, 'lps'),
	(390177, 126, '2015-02-01 00:08:38.000000', 'consum', 0.0216, 'lps'),
	(390178, 126, '2015-02-01 00:08:39.000000', 'consum', 0.0220, 'lps'),
	(390179, 126, '2015-02-01 00:08:40.000000', 'consum', 0.0216, 'lps'),
	(390180, 126, '2015-02-01 00:08:41.000000', 'consum', 0.0223, 'lps'),
	(390181, 126, '2015-02-01 00:08:42.000000', 'consum', 0.0214, 'lps'),
	(390182, 126, '2015-02-01 00:08:43.000000', 'consum', 0.0222, 'lps'),
	(390183, 126, '2015-02-01 00:08:44.000000', 'consum', 0.0213, 'lps'),
	(390184, 126, '2015-02-01 00:08:45.000000', 'consum', 0.0218, 'lps'),
	(390185, 126, '2015-02-01 00:08:46.000000', 'consum', 0.0212, 'lps'),
	(390186, 126, '2015-02-01 00:08:47.000000', 'consum', 0.0212, 'lps'),
	(390187, 126, '2015-02-01 00:08:48.000000', 'consum', 0.0213, 'lps'),
	(390188, 126, '2015-02-01 00:08:49.000000', 'consum', 0.0219, 'lps'),
	(390189, 126, '2015-02-01 00:08:50.000000', 'consum', 0.0219, 'lps'),
	(390190, 126, '2015-02-01 00:08:51.000000', 'consum', 0.0211, 'lps'),
	(390191, 126, '2015-02-01 00:08:52.000000', 'consum', 0.0220, 'lps'),
	(390192, 126, '2015-02-01 00:08:53.000000', 'consum', 0.0212, 'lps'),
	(390193, 126, '2015-02-01 00:08:54.000000', 'consum', 0.0221, 'lps'),
	(390194, 126, '2015-02-01 00:08:55.000000', 'consum', 0.0215, 'lps'),
	(390195, 126, '2015-02-01 00:08:56.000000', 'consum', 0.0218, 'lps'),
	(390196, 126, '2015-02-01 00:08:57.000000', 'consum', 0.0220, 'lps'),
	(390197, 126, '2015-02-01 00:08:58.000000', 'consum', 0.0220, 'lps'),
	(390198, 126, '2015-02-01 00:08:59.000000', 'consum', 0.0218, 'lps'),
	(390199, 126, '2015-02-01 00:09:00.000000', 'consum', 0.0221, 'lps'),
	(390200, 126, '2015-02-01 00:09:01.000000', 'consum', 0.0210, 'lps'),
	(390201, 126, '2015-02-01 00:09:02.000000', 'consum', 0.0223, 'lps'),
	(390202, 126, '2015-02-01 00:09:03.000000', 'consum', 0.0214, 'lps'),
	(390203, 126, '2015-02-01 00:09:04.000000', 'consum', 0.0223, 'lps'),
	(390204, 126, '2015-02-01 00:09:05.000000', 'consum', 0.0218, 'lps'),
	(390205, 126, '2015-02-01 00:09:06.000000', 'consum', 0.0213, 'lps'),
	(390206, 126, '2015-02-01 00:09:07.000000', 'consum', 0.0215, 'lps'),
	(390207, 126, '2015-02-01 00:09:08.000000', 'consum', 0.0212, 'lps'),
	(390208, 126, '2015-02-01 00:09:09.000000', 'consum', 0.0222, 'lps'),
	(390209, 126, '2015-02-01 00:09:10.000000', 'consum', 0.0217, 'lps'),
	(390210, 126, '2015-02-01 00:09:11.000000', 'consum', 0.0212, 'lps'),
	(390211, 126, '2015-02-01 00:09:12.000000', 'consum', 0.0212, 'lps'),
	(390212, 126, '2015-02-01 00:09:13.000000', 'consum', 0.0216, 'lps'),
	(390213, 126, '2015-02-01 00:09:14.000000', 'consum', 0.0221, 'lps'),
	(390214, 126, '2015-02-01 00:09:15.000000', 'consum', 0.0217, 'lps'),
	(390215, 126, '2015-02-01 00:09:16.000000', 'consum', 0.0213, 'lps'),
	(390216, 126, '2015-02-01 00:09:17.000000', 'consum', 0.0219, 'lps'),
	(390217, 126, '2015-02-01 00:09:18.000000', 'consum', 0.0217, 'lps'),
	(390218, 126, '2015-02-01 00:09:19.000000', 'consum', 0.0218, 'lps'),
	(390219, 126, '2015-02-01 00:09:20.000000', 'consum', 0.0216, 'lps'),
	(390220, 126, '2015-02-01 00:09:21.000000', 'consum', 0.0216, 'lps'),
	(390221, 126, '2015-02-01 00:09:22.000000', 'consum', 0.0224, 'lps'),
	(390222, 126, '2015-02-01 00:09:23.000000', 'consum', 0.0215, 'lps'),
	(390223, 126, '2015-02-01 00:09:24.000000', 'consum', 0.0210, 'lps'),
	(390224, 126, '2015-02-01 00:09:25.000000', 'consum', 0.0210, 'lps'),
	(390225, 126, '2015-02-01 00:09:26.000000', 'consum', 0.0211, 'lps'),
	(390226, 126, '2015-02-01 00:09:27.000000', 'consum', 0.0214, 'lps'),
	(390227, 126, '2015-02-01 00:09:28.000000', 'consum', 0.0212, 'lps'),
	(390228, 126, '2015-02-01 00:09:29.000000', 'consum', 0.0224, 'lps'),
	(390229, 126, '2015-02-01 00:09:30.000000', 'consum', 0.0214, 'lps'),
	(390230, 126, '2015-02-01 00:09:31.000000', 'consum', 0.0221, 'lps'),
	(390231, 126, '2015-02-01 00:09:32.000000', 'consum', 0.0222, 'lps'),
	(390232, 126, '2015-02-01 00:09:33.000000', 'consum', 0.0222, 'lps'),
	(390233, 126, '2015-02-01 00:09:34.000000', 'consum', 0.0222, 'lps'),
	(390234, 126, '2015-02-01 00:09:35.000000', 'consum', 0.0217, 'lps'),
	(390235, 126, '2015-02-01 00:09:36.000000', 'consum', 0.0224, 'lps'),
	(390236, 126, '2015-02-01 00:09:37.000000', 'consum', 0.0215, 'lps'),
	(390237, 126, '2015-02-01 00:09:38.000000', 'consum', 0.0222, 'lps'),
	(390238, 126, '2015-02-01 00:09:39.000000', 'consum', 0.0212, 'lps'),
	(390239, 126, '2015-02-01 00:09:40.000000', 'consum', 0.0213, 'lps'),
	(390240, 126, '2015-02-01 00:09:41.000000', 'consum', 0.0219, 'lps'),
	(390241, 126, '2015-02-01 00:09:42.000000', 'consum', 0.0218, 'lps'),
	(390242, 126, '2015-02-01 00:09:43.000000', 'consum', 0.0223, 'lps'),
	(390243, 126, '2015-02-01 00:09:44.000000', 'consum', 0.0221, 'lps'),
	(390244, 126, '2015-02-01 00:09:45.000000', 'consum', 0.0212, 'lps'),
	(390245, 126, '2015-02-01 00:09:46.000000', 'consum', 0.0217, 'lps'),
	(390246, 126, '2015-02-01 00:09:47.000000', 'consum', 0.0224, 'lps'),
	(390247, 126, '2015-02-01 00:09:48.000000', 'consum', 0.0215, 'lps'),
	(390248, 126, '2015-02-01 00:09:49.000000', 'consum', 0.0223, 'lps'),
	(390249, 126, '2015-02-01 00:09:50.000000', 'consum', 0.0216, 'lps'),
	(390250, 126, '2015-02-01 00:09:51.000000', 'consum', 0.0217, 'lps'),
	(390251, 126, '2015-02-01 00:09:52.000000', 'consum', 0.0213, 'lps'),
	(390252, 126, '2015-02-01 00:09:53.000000', 'consum', 0.0220, 'lps'),
	(390253, 126, '2015-02-01 00:09:54.000000', 'consum', 0.0219, 'lps'),
	(390254, 126, '2015-02-01 00:09:55.000000', 'consum', 0.0210, 'lps'),
	(390255, 126, '2015-02-01 00:09:56.000000', 'consum', 0.0215, 'lps'),
	(390256, 126, '2015-02-01 00:09:57.000000', 'consum', 0.0222, 'lps'),
	(390257, 126, '2015-02-01 00:09:58.000000', 'consum', 0.0223, 'lps'),
	(390258, 126, '2015-02-01 00:09:59.000000', 'consum', 0.0224, 'lps'),
	(390259, 126, '2015-02-01 00:10:00.000000', 'consum', 0.0211, 'lps'),
	(390260, 126, '2015-02-01 00:10:01.000000', 'consum', 0.0219, 'lps'),
	(390261, 126, '2015-02-01 00:10:02.000000', 'consum', 0.0223, 'lps'),
	(390262, 126, '2015-02-01 00:10:03.000000', 'consum', 0.0220, 'lps'),
	(390263, 126, '2015-02-01 00:10:04.000000', 'consum', 0.0222, 'lps'),
	(390264, 126, '2015-02-01 00:10:05.000000', 'consum', 0.0211, 'lps'),
	(390265, 126, '2015-02-01 00:10:06.000000', 'consum', 0.0223, 'lps'),
	(390266, 126, '2015-02-01 00:10:07.000000', 'consum', 0.0213, 'lps'),
	(390267, 126, '2015-02-01 00:10:08.000000', 'consum', 0.0216, 'lps'),
	(390268, 126, '2015-02-01 00:10:09.000000', 'consum', 0.0218, 'lps'),
	(390269, 126, '2015-02-01 00:10:10.000000', 'consum', 0.0215, 'lps'),
	(390270, 126, '2015-02-01 00:10:11.000000', 'consum', 0.0211, 'lps'),
	(390271, 126, '2015-02-01 00:10:12.000000', 'consum', 0.0219, 'lps'),
	(390272, 126, '2015-02-01 00:10:13.000000', 'consum', 0.0219, 'lps'),
	(390273, 126, '2015-02-01 00:10:14.000000', 'consum', 0.0217, 'lps'),
	(390274, 126, '2015-02-01 00:10:15.000000', 'consum', 0.0216, 'lps'),
	(390275, 126, '2015-02-01 00:10:16.000000', 'consum', 0.0222, 'lps'),
	(390276, 126, '2015-02-01 00:10:17.000000', 'consum', 0.0220, 'lps'),
	(390277, 126, '2015-02-01 00:10:18.000000', 'consum', 0.0210, 'lps'),
	(390278, 126, '2015-02-01 00:10:19.000000', 'consum', 0.0211, 'lps'),
	(390279, 126, '2015-02-01 00:10:20.000000', 'consum', 0.0217, 'lps'),
	(390280, 126, '2015-02-01 00:10:21.000000', 'consum', 0.0210, 'lps'),
	(390281, 126, '2015-02-01 00:10:22.000000', 'consum', 0.0221, 'lps'),
	(390282, 126, '2015-02-01 00:10:23.000000', 'consum', 0.0220, 'lps'),
	(390283, 126, '2015-02-01 00:10:24.000000', 'consum', 0.0212, 'lps'),
	(390284, 126, '2015-02-01 00:10:25.000000', 'consum', 0.0223, 'lps'),
	(390285, 126, '2015-02-01 00:10:26.000000', 'consum', 0.0221, 'lps'),
	(390286, 126, '2015-02-01 00:10:27.000000', 'consum', 0.0213, 'lps'),
	(390287, 126, '2015-02-01 00:10:28.000000', 'consum', 0.0222, 'lps'),
	(390288, 126, '2015-02-01 00:10:29.000000', 'consum', 0.0216, 'lps'),
	(390289, 126, '2015-02-01 00:10:30.000000', 'consum', 0.0220, 'lps'),
	(390290, 126, '2015-02-01 00:10:31.000000', 'consum', 0.0212, 'lps'),
	(390291, 126, '2015-02-01 00:10:32.000000', 'consum', 0.0222, 'lps'),
	(390292, 126, '2015-02-01 00:10:33.000000', 'consum', 0.0221, 'lps'),
	(390293, 126, '2015-02-01 00:10:34.000000', 'consum', 0.0211, 'lps'),
	(390294, 126, '2015-02-01 00:10:35.000000', 'consum', 0.0214, 'lps'),
	(390295, 126, '2015-02-01 00:10:36.000000', 'consum', 0.0214, 'lps'),
	(390296, 126, '2015-02-01 00:10:37.000000', 'consum', 0.0216, 'lps'),
	(390297, 126, '2015-02-01 00:10:38.000000', 'consum', 0.0216, 'lps'),
	(390298, 126, '2015-02-01 00:10:39.000000', 'consum', 0.0222, 'lps'),
	(390299, 126, '2015-02-01 00:10:40.000000', 'consum', 0.0224, 'lps'),
	(390300, 126, '2015-02-01 00:10:41.000000', 'consum', 0.0212, 'lps'),
	(390301, 126, '2015-02-01 00:10:42.000000', 'consum', 0.0211, 'lps'),
	(390302, 126, '2015-02-01 00:10:43.000000', 'consum', 0.0210, 'lps'),
	(390303, 126, '2015-02-01 00:10:44.000000', 'consum', 0.0223, 'lps'),
	(390304, 126, '2015-02-01 00:10:45.000000', 'consum', 0.0213, 'lps'),
	(390305, 126, '2015-02-01 00:10:46.000000', 'consum', 0.0218, 'lps'),
	(390306, 126, '2015-02-01 00:10:47.000000', 'consum', 0.0210, 'lps'),
	(390307, 126, '2015-02-01 00:10:48.000000', 'consum', 0.0218, 'lps'),
	(390308, 126, '2015-02-01 00:10:49.000000', 'consum', 0.0221, 'lps'),
	(390309, 126, '2015-02-01 00:10:50.000000', 'consum', 0.0211, 'lps'),
	(390310, 126, '2015-02-01 00:10:51.000000', 'consum', 0.0213, 'lps'),
	(390311, 126, '2015-02-01 00:10:52.000000', 'consum', 0.0220, 'lps'),
	(390312, 126, '2015-02-01 00:10:53.000000', 'consum', 0.0223, 'lps'),
	(390313, 126, '2015-02-01 00:10:54.000000', 'consum', 0.0214, 'lps'),
	(390314, 126, '2015-02-01 00:10:55.000000', 'consum', 0.0224, 'lps'),
	(390315, 126, '2015-02-01 00:10:56.000000', 'consum', 0.0222, 'lps'),
	(390316, 126, '2015-02-01 00:10:57.000000', 'consum', 0.0212, 'lps'),
	(390317, 126, '2015-02-01 00:10:58.000000', 'consum', 0.0218, 'lps'),
	(390318, 126, '2015-02-01 00:10:59.000000', 'consum', 0.0212, 'lps'),
	(390319, 126, '2015-02-01 00:11:00.000000', 'consum', 0.0213, 'lps'),
	(390320, 126, '2015-02-01 00:11:01.000000', 'consum', 0.0217, 'lps'),
	(390321, 126, '2015-02-01 00:11:02.000000', 'consum', 0.0223, 'lps'),
	(390322, 126, '2015-02-01 00:11:03.000000', 'consum', 0.0223, 'lps'),
	(390323, 126, '2015-02-01 00:11:04.000000', 'consum', 0.0224, 'lps'),
	(390324, 126, '2015-02-01 00:11:05.000000', 'consum', 0.0224, 'lps'),
	(390325, 126, '2015-02-01 00:11:06.000000', 'consum', 0.0223, 'lps'),
	(390326, 126, '2015-02-01 00:11:07.000000', 'consum', 0.0219, 'lps'),
	(390327, 126, '2015-02-01 00:11:08.000000', 'consum', 0.0219, 'lps'),
	(390328, 126, '2015-02-01 00:11:09.000000', 'consum', 0.0212, 'lps'),
	(390329, 126, '2015-02-01 00:11:10.000000', 'consum', 0.0223, 'lps'),
	(390330, 126, '2015-02-01 00:11:11.000000', 'consum', 0.0224, 'lps'),
	(390331, 126, '2015-02-01 00:11:12.000000', 'consum', 0.0211, 'lps'),
	(390332, 126, '2015-02-01 00:11:13.000000', 'consum', 0.0220, 'lps'),
	(390333, 126, '2015-02-01 00:11:14.000000', 'consum', 0.0210, 'lps'),
	(390334, 126, '2015-02-01 00:11:15.000000', 'consum', 0.0213, 'lps'),
	(390335, 126, '2015-02-01 00:11:16.000000', 'consum', 0.0211, 'lps'),
	(390336, 126, '2015-02-01 00:11:17.000000', 'consum', 0.0219, 'lps'),
	(390337, 126, '2015-02-01 00:11:18.000000', 'consum', 0.0224, 'lps'),
	(390338, 126, '2015-02-01 00:11:19.000000', 'consum', 0.0224, 'lps'),
	(390339, 126, '2015-02-01 00:11:20.000000', 'consum', 0.0224, 'lps'),
	(390340, 126, '2015-02-01 00:11:21.000000', 'consum', 0.0221, 'lps'),
	(390341, 126, '2015-02-01 00:11:22.000000', 'consum', 0.0211, 'lps'),
	(390342, 126, '2015-02-01 00:11:23.000000', 'consum', 0.0213, 'lps'),
	(390343, 126, '2015-02-01 00:11:24.000000', 'consum', 0.0223, 'lps'),
	(390344, 126, '2015-02-01 00:11:25.000000', 'consum', 0.0221, 'lps'),
	(390345, 126, '2015-02-01 00:11:26.000000', 'consum', 0.0211, 'lps'),
	(390346, 126, '2015-02-01 00:11:27.000000', 'consum', 0.0213, 'lps'),
	(390347, 126, '2015-02-01 00:11:28.000000', 'consum', 0.0224, 'lps'),
	(390348, 126, '2015-02-01 00:11:29.000000', 'consum', 0.0211, 'lps'),
	(390349, 126, '2015-02-01 00:11:30.000000', 'consum', 0.0220, 'lps'),
	(390350, 126, '2015-02-01 00:11:31.000000', 'consum', 0.0210, 'lps'),
	(390351, 126, '2015-02-01 00:11:32.000000', 'consum', 0.0212, 'lps'),
	(390352, 126, '2015-02-01 00:11:33.000000', 'consum', 0.0221, 'lps'),
	(390353, 126, '2015-02-01 00:11:34.000000', 'consum', 0.0213, 'lps'),
	(390354, 126, '2015-02-01 00:11:35.000000', 'consum', 0.0224, 'lps'),
	(390355, 126, '2015-02-01 00:11:36.000000', 'consum', 0.0212, 'lps'),
	(390356, 126, '2015-02-01 00:11:37.000000', 'consum', 0.0223, 'lps'),
	(390357, 126, '2015-02-01 00:11:38.000000', 'consum', 0.0223, 'lps'),
	(390358, 126, '2015-02-01 00:11:39.000000', 'consum', 0.0224, 'lps'),
	(390359, 126, '2015-02-01 00:11:40.000000', 'consum', 0.0224, 'lps'),
	(390360, 126, '2015-02-01 00:11:41.000000', 'consum', 0.0210, 'lps'),
	(390361, 126, '2015-02-01 00:11:42.000000', 'consum', 0.0214, 'lps'),
	(390362, 126, '2015-02-01 00:11:43.000000', 'consum', 0.0216, 'lps'),
	(390363, 126, '2015-02-01 00:11:44.000000', 'consum', 0.0214, 'lps'),
	(390364, 126, '2015-02-01 00:11:45.000000', 'consum', 0.0212, 'lps'),
	(390365, 126, '2015-02-01 00:11:46.000000', 'consum', 0.0210, 'lps'),
	(390366, 126, '2015-02-01 00:11:47.000000', 'consum', 0.0218, 'lps'),
	(390367, 126, '2015-02-01 00:11:48.000000', 'consum', 0.0220, 'lps'),
	(390368, 126, '2015-02-01 00:11:49.000000', 'consum', 0.0222, 'lps'),
	(390369, 126, '2015-02-01 00:11:50.000000', 'consum', 0.0212, 'lps'),
	(390370, 126, '2015-02-01 00:11:51.000000', 'consum', 0.0212, 'lps'),
	(390371, 126, '2015-02-01 00:11:52.000000', 'consum', 0.0214, 'lps'),
	(390372, 126, '2015-02-01 00:11:53.000000', 'consum', 0.0210, 'lps'),
	(390373, 126, '2015-02-01 00:11:54.000000', 'consum', 0.0215, 'lps'),
	(390374, 126, '2015-02-01 00:11:55.000000', 'consum', 0.0221, 'lps'),
	(390375, 126, '2015-02-01 00:11:56.000000', 'consum', 0.0219, 'lps'),
	(390376, 126, '2015-02-01 00:11:57.000000', 'consum', 0.0223, 'lps'),
	(390377, 126, '2015-02-01 00:11:58.000000', 'consum', 0.0217, 'lps'),
	(390378, 126, '2015-02-01 00:11:59.000000', 'consum', 0.0222, 'lps'),
	(390379, 126, '2015-02-01 00:12:00.000000', 'consum', 0.0218, 'lps'),
	(390380, 126, '2015-02-01 00:12:01.000000', 'consum', 0.0215, 'lps'),
	(390381, 126, '2015-02-01 00:12:02.000000', 'consum', 0.0211, 'lps'),
	(390382, 126, '2015-02-01 00:12:03.000000', 'consum', 0.0214, 'lps'),
	(390383, 126, '2015-02-01 00:12:04.000000', 'consum', 0.0215, 'lps'),
	(390384, 126, '2015-02-01 00:12:05.000000', 'consum', 0.0224, 'lps'),
	(390385, 126, '2015-02-01 00:12:06.000000', 'consum', 0.0221, 'lps'),
	(390386, 126, '2015-02-01 00:12:07.000000', 'consum', 0.0224, 'lps'),
	(390387, 126, '2015-02-01 00:12:08.000000', 'consum', 0.0216, 'lps'),
	(390388, 126, '2015-02-01 00:12:09.000000', 'consum', 0.0213, 'lps'),
	(390389, 126, '2015-02-01 00:12:10.000000', 'consum', 0.0224, 'lps'),
	(390390, 126, '2015-02-01 00:12:11.000000', 'consum', 0.0212, 'lps'),
	(390391, 126, '2015-02-01 00:12:12.000000', 'consum', 0.0224, 'lps'),
	(390392, 126, '2015-02-01 00:12:13.000000', 'consum', 0.0212, 'lps'),
	(390393, 126, '2015-02-01 00:12:14.000000', 'consum', 0.0223, 'lps'),
	(390394, 126, '2015-02-01 00:12:15.000000', 'consum', 0.0224, 'lps'),
	(390395, 126, '2015-02-01 00:12:16.000000', 'consum', 0.0211, 'lps'),
	(390396, 126, '2015-02-01 00:12:17.000000', 'consum', 0.0221, 'lps'),
	(390397, 126, '2015-02-01 00:12:18.000000', 'consum', 0.0216, 'lps'),
	(390398, 126, '2015-02-01 00:12:19.000000', 'consum', 0.0223, 'lps'),
	(390399, 126, '2015-02-01 00:12:20.000000', 'consum', 0.0210, 'lps'),
	(390400, 126, '2015-02-01 00:12:21.000000', 'consum', 0.0220, 'lps'),
	(390401, 126, '2015-02-01 00:12:22.000000', 'consum', 0.0213, 'lps'),
	(390402, 126, '2015-02-01 00:12:23.000000', 'consum', 0.0213, 'lps'),
	(390403, 126, '2015-02-01 00:12:24.000000', 'consum', 0.0217, 'lps'),
	(390404, 126, '2015-02-01 00:12:25.000000', 'consum', 0.0219, 'lps'),
	(390405, 126, '2015-02-01 00:12:26.000000', 'consum', 0.0222, 'lps'),
	(390406, 126, '2015-02-01 00:12:27.000000', 'consum', 0.0211, 'lps'),
	(390407, 126, '2015-02-01 00:12:28.000000', 'consum', 0.0224, 'lps'),
	(390408, 126, '2015-02-01 00:12:29.000000', 'consum', 0.0217, 'lps'),
	(390409, 126, '2015-02-01 00:12:30.000000', 'consum', 0.0220, 'lps'),
	(390410, 126, '2015-02-01 00:12:31.000000', 'consum', 0.0224, 'lps'),
	(390411, 126, '2015-02-01 00:12:32.000000', 'consum', 0.0219, 'lps'),
	(390412, 126, '2015-02-01 00:12:33.000000', 'consum', 0.0215, 'lps'),
	(390413, 126, '2015-02-01 00:12:34.000000', 'consum', 0.0222, 'lps'),
	(390414, 126, '2015-02-01 00:12:35.000000', 'consum', 0.0210, 'lps'),
	(390415, 126, '2015-02-01 00:12:36.000000', 'consum', 0.0221, 'lps'),
	(390416, 126, '2015-02-01 00:12:37.000000', 'consum', 0.0221, 'lps'),
	(390417, 126, '2015-02-01 00:12:38.000000', 'consum', 0.0217, 'lps'),
	(390418, 126, '2015-02-01 00:12:39.000000', 'consum', 0.0212, 'lps'),
	(390419, 126, '2015-02-01 00:12:40.000000', 'consum', 0.0214, 'lps'),
	(390420, 126, '2015-02-01 00:12:41.000000', 'consum', 0.0211, 'lps'),
	(390421, 126, '2015-02-01 00:12:42.000000', 'consum', 0.0219, 'lps'),
	(390422, 126, '2015-02-01 00:12:43.000000', 'consum', 0.0222, 'lps'),
	(390423, 126, '2015-02-01 00:12:44.000000', 'consum', 0.0212, 'lps'),
	(390424, 126, '2015-02-01 00:12:45.000000', 'consum', 0.0214, 'lps'),
	(390425, 126, '2015-02-01 00:12:46.000000', 'consum', 0.0210, 'lps'),
	(390426, 126, '2015-02-01 00:12:47.000000', 'consum', 0.0215, 'lps'),
	(390427, 126, '2015-02-01 00:12:48.000000', 'consum', 0.0219, 'lps'),
	(390428, 126, '2015-02-01 00:12:49.000000', 'consum', 0.0211, 'lps'),
	(390429, 126, '2015-02-01 00:12:50.000000', 'consum', 0.0220, 'lps'),
	(390430, 126, '2015-02-01 00:12:51.000000', 'consum', 0.0213, 'lps'),
	(390431, 126, '2015-02-01 00:12:52.000000', 'consum', 0.0224, 'lps'),
	(390432, 126, '2015-02-01 00:12:53.000000', 'consum', 0.0213, 'lps'),
	(390433, 126, '2015-02-01 00:12:54.000000', 'consum', 0.0212, 'lps'),
	(390434, 126, '2015-02-01 00:12:55.000000', 'consum', 0.0210, 'lps'),
	(390435, 126, '2015-02-01 00:12:56.000000', 'consum', 0.0222, 'lps'),
	(390436, 126, '2015-02-01 00:12:57.000000', 'consum', 0.0224, 'lps'),
	(390437, 126, '2015-02-01 00:12:58.000000', 'consum', 0.0214, 'lps'),
	(390438, 126, '2015-02-01 00:12:59.000000', 'consum', 0.0217, 'lps'),
	(390439, 126, '2015-02-01 00:13:00.000000', 'consum', 0.0222, 'lps'),
	(390440, 126, '2015-02-01 00:13:01.000000', 'consum', 0.0217, 'lps'),
	(390441, 126, '2015-02-01 00:13:02.000000', 'consum', 0.0224, 'lps'),
	(390442, 126, '2015-02-01 00:13:03.000000', 'consum', 0.0214, 'lps'),
	(390443, 126, '2015-02-01 00:13:04.000000', 'consum', 0.0221, 'lps'),
	(390444, 126, '2015-02-01 00:13:05.000000', 'consum', 0.0223, 'lps'),
	(390445, 126, '2015-02-01 00:13:06.000000', 'consum', 0.0212, 'lps'),
	(390446, 126, '2015-02-01 00:13:07.000000', 'consum', 0.0213, 'lps'),
	(390447, 126, '2015-02-01 00:13:08.000000', 'consum', 0.0217, 'lps'),
	(390448, 126, '2015-02-01 00:13:09.000000', 'consum', 0.0222, 'lps'),
	(390449, 126, '2015-02-01 00:13:10.000000', 'consum', 0.0219, 'lps'),
	(390450, 126, '2015-02-01 00:13:11.000000', 'consum', 0.0218, 'lps'),
	(390451, 126, '2015-02-01 00:13:12.000000', 'consum', 0.0211, 'lps'),
	(390452, 126, '2015-02-01 00:13:13.000000', 'consum', 0.0221, 'lps'),
	(390453, 126, '2015-02-01 00:13:14.000000', 'consum', 0.0216, 'lps'),
	(390454, 126, '2015-02-01 00:13:15.000000', 'consum', 0.0224, 'lps'),
	(390455, 126, '2015-02-01 00:13:16.000000', 'consum', 0.0216, 'lps'),
	(390456, 126, '2015-02-01 00:13:17.000000', 'consum', 0.0216, 'lps'),
	(390457, 126, '2015-02-01 00:13:18.000000', 'consum', 0.0222, 'lps'),
	(390458, 126, '2015-02-01 00:13:19.000000', 'consum', 0.0223, 'lps'),
	(390459, 126, '2015-02-01 00:13:20.000000', 'consum', 0.0210, 'lps'),
	(390460, 126, '2015-02-01 00:13:21.000000', 'consum', 0.0217, 'lps'),
	(390461, 126, '2015-02-01 00:13:22.000000', 'consum', 0.0212, 'lps'),
	(390462, 126, '2015-02-01 00:13:23.000000', 'consum', 0.0218, 'lps'),
	(390463, 126, '2015-02-01 00:13:24.000000', 'consum', 0.0215, 'lps'),
	(390464, 126, '2015-02-01 00:13:25.000000', 'consum', 0.0223, 'lps'),
	(390465, 126, '2015-02-01 00:13:26.000000', 'consum', 0.0218, 'lps'),
	(390466, 126, '2015-02-01 00:13:27.000000', 'consum', 0.0211, 'lps'),
	(390467, 126, '2015-02-01 00:13:28.000000', 'consum', 0.0220, 'lps'),
	(390468, 126, '2015-02-01 00:13:29.000000', 'consum', 0.0212, 'lps'),
	(390469, 126, '2015-02-01 00:13:30.000000', 'consum', 0.0219, 'lps'),
	(390470, 126, '2015-02-01 00:13:31.000000', 'consum', 0.0223, 'lps'),
	(390471, 126, '2015-02-01 00:13:32.000000', 'consum', 0.0218, 'lps'),
	(390472, 126, '2015-02-01 00:13:33.000000', 'consum', 0.0211, 'lps'),
	(390473, 126, '2015-02-01 00:13:34.000000', 'consum', 0.0223, 'lps'),
	(390474, 126, '2015-02-01 00:13:35.000000', 'consum', 0.0212, 'lps'),
	(390475, 126, '2015-02-01 00:13:36.000000', 'consum', 0.0210, 'lps'),
	(390476, 126, '2015-02-01 00:13:37.000000', 'consum', 0.0221, 'lps'),
	(390477, 126, '2015-02-01 00:13:38.000000', 'consum', 0.0220, 'lps'),
	(390478, 126, '2015-02-01 00:13:39.000000', 'consum', 0.0212, 'lps'),
	(390479, 126, '2015-02-01 00:13:40.000000', 'consum', 0.0220, 'lps'),
	(390480, 126, '2015-02-01 00:13:41.000000', 'consum', 0.0212, 'lps'),
	(390481, 126, '2015-02-01 00:13:42.000000', 'consum', 0.0218, 'lps'),
	(390482, 126, '2015-02-01 00:13:43.000000', 'consum', 0.0215, 'lps'),
	(390483, 126, '2015-02-01 00:13:44.000000', 'consum', 0.0211, 'lps'),
	(390484, 126, '2015-02-01 00:13:45.000000', 'consum', 0.0218, 'lps'),
	(390485, 126, '2015-02-01 00:13:46.000000', 'consum', 0.0214, 'lps'),
	(390486, 126, '2015-02-01 00:13:47.000000', 'consum', 0.0224, 'lps'),
	(390487, 126, '2015-02-01 00:13:48.000000', 'consum', 0.0223, 'lps'),
	(390488, 126, '2015-02-01 00:13:49.000000', 'consum', 0.0218, 'lps'),
	(390489, 126, '2015-02-01 00:13:50.000000', 'consum', 0.0211, 'lps'),
	(390490, 126, '2015-02-01 00:13:51.000000', 'consum', 0.0221, 'lps'),
	(390491, 126, '2015-02-01 00:13:52.000000', 'consum', 0.0218, 'lps'),
	(390492, 126, '2015-02-01 00:13:53.000000', 'consum', 0.0216, 'lps'),
	(390493, 126, '2015-02-01 00:13:54.000000', 'consum', 0.0220, 'lps'),
	(390494, 126, '2015-02-01 00:13:55.000000', 'consum', 0.0224, 'lps'),
	(390495, 126, '2015-02-01 00:13:56.000000', 'consum', 0.0224, 'lps'),
	(390496, 126, '2015-02-01 00:13:57.000000', 'consum', 0.0221, 'lps'),
	(390497, 126, '2015-02-01 00:13:58.000000', 'consum', 0.0211, 'lps'),
	(390498, 126, '2015-02-01 00:13:59.000000', 'consum', 0.0212, 'lps'),
	(390499, 126, '2015-02-01 00:14:00.000000', 'consum', 0.0218, 'lps'),
	(390500, 126, '2015-02-01 00:14:01.000000', 'consum', 0.0214, 'lps'),
	(390501, 126, '2015-02-01 00:14:02.000000', 'consum', 0.0222, 'lps'),
	(390502, 126, '2015-02-01 00:14:03.000000', 'consum', 0.0212, 'lps'),
	(390503, 126, '2015-02-01 00:14:04.000000', 'consum', 0.0213, 'lps'),
	(390504, 126, '2015-02-01 00:14:05.000000', 'consum', 0.0222, 'lps'),
	(390505, 126, '2015-02-01 00:14:06.000000', 'consum', 0.0216, 'lps'),
	(390506, 126, '2015-02-01 00:14:07.000000', 'consum', 0.0219, 'lps'),
	(390507, 126, '2015-02-01 00:14:08.000000', 'consum', 0.0210, 'lps'),
	(390508, 126, '2015-02-01 00:14:09.000000', 'consum', 0.0212, 'lps'),
	(390509, 126, '2015-02-01 00:14:10.000000', 'consum', 0.0219, 'lps'),
	(390510, 126, '2015-02-01 00:14:11.000000', 'consum', 0.0219, 'lps'),
	(390511, 126, '2015-02-01 00:14:12.000000', 'consum', 0.0213, 'lps'),
	(390512, 126, '2015-02-01 00:14:13.000000', 'consum', 0.0214, 'lps'),
	(390513, 126, '2015-02-01 00:14:14.000000', 'consum', 0.0222, 'lps'),
	(390514, 126, '2015-02-01 00:14:15.000000', 'consum', 0.0212, 'lps'),
	(390515, 126, '2015-02-01 00:14:16.000000', 'consum', 0.0215, 'lps'),
	(390516, 126, '2015-02-01 00:14:17.000000', 'consum', 0.0216, 'lps'),
	(390517, 126, '2015-02-01 00:14:18.000000', 'consum', 0.0224, 'lps'),
	(390518, 126, '2015-02-01 00:14:19.000000', 'consum', 0.0220, 'lps'),
	(390519, 126, '2015-02-01 00:14:20.000000', 'consum', 0.0215, 'lps'),
	(390520, 126, '2015-02-01 00:14:21.000000', 'consum', 0.0223, 'lps'),
	(390521, 126, '2015-02-01 00:14:22.000000', 'consum', 0.0216, 'lps'),
	(390522, 126, '2015-02-01 00:14:23.000000', 'consum', 0.0216, 'lps'),
	(390523, 126, '2015-02-01 00:14:24.000000', 'consum', 0.0222, 'lps'),
	(390524, 126, '2015-02-01 00:14:25.000000', 'consum', 0.0221, 'lps'),
	(390525, 126, '2015-02-01 00:14:26.000000', 'consum', 0.0215, 'lps'),
	(390526, 126, '2015-02-01 00:14:27.000000', 'consum', 0.0217, 'lps'),
	(390527, 126, '2015-02-01 00:14:28.000000', 'consum', 0.0215, 'lps'),
	(390528, 126, '2015-02-01 00:14:29.000000', 'consum', 0.0216, 'lps'),
	(390529, 126, '2015-02-01 00:14:30.000000', 'consum', 0.0212, 'lps'),
	(390530, 126, '2015-02-01 00:14:31.000000', 'consum', 0.0214, 'lps'),
	(390531, 126, '2015-02-01 00:14:32.000000', 'consum', 0.0211, 'lps'),
	(390532, 126, '2015-02-01 00:14:33.000000', 'consum', 0.0219, 'lps'),
	(390533, 126, '2015-02-01 00:14:34.000000', 'consum', 0.0223, 'lps'),
	(390534, 126, '2015-02-01 00:14:35.000000', 'consum', 0.0218, 'lps'),
	(390535, 126, '2015-02-01 00:14:36.000000', 'consum', 0.0211, 'lps'),
	(390536, 126, '2015-02-01 00:14:37.000000', 'consum', 0.0220, 'lps'),
	(390537, 126, '2015-02-01 00:14:38.000000', 'consum', 0.0215, 'lps'),
	(390538, 126, '2015-02-01 00:14:39.000000', 'consum', 0.0221, 'lps'),
	(390539, 126, '2015-02-01 00:14:40.000000', 'consum', 0.0221, 'lps'),
	(390540, 126, '2015-02-01 00:14:41.000000', 'consum', 0.0217, 'lps'),
	(390541, 126, '2015-02-01 00:14:42.000000', 'consum', 0.0213, 'lps'),
	(390542, 126, '2015-02-01 00:14:43.000000', 'consum', 0.0219, 'lps'),
	(390543, 126, '2015-02-01 00:14:44.000000', 'consum', 0.0216, 'lps'),
	(390544, 126, '2015-02-01 00:14:45.000000', 'consum', 0.0213, 'lps'),
	(390545, 126, '2015-02-01 00:14:46.000000', 'consum', 0.0210, 'lps'),
	(390546, 126, '2015-02-01 00:14:47.000000', 'consum', 0.0213, 'lps'),
	(390547, 126, '2015-02-01 00:14:48.000000', 'consum', 0.0212, 'lps'),
	(390548, 126, '2015-02-01 00:14:49.000000', 'consum', 0.0212, 'lps'),
	(390549, 126, '2015-02-01 00:14:50.000000', 'consum', 0.0214, 'lps'),
	(390550, 126, '2015-02-01 00:14:51.000000', 'consum', 0.0211, 'lps'),
	(390551, 126, '2015-02-01 00:14:52.000000', 'consum', 0.0219, 'lps'),
	(390552, 126, '2015-02-01 00:14:53.000000', 'consum', 0.0220, 'lps'),
	(390553, 126, '2015-02-01 00:14:54.000000', 'consum', 0.0221, 'lps'),
	(390554, 126, '2015-02-01 00:14:55.000000', 'consum', 0.0220, 'lps'),
	(390555, 126, '2015-02-01 00:14:56.000000', 'consum', 0.0213, 'lps'),
	(390556, 126, '2015-02-01 00:14:57.000000', 'consum', 0.0210, 'lps'),
	(390557, 126, '2015-02-01 00:14:58.000000', 'consum', 0.0215, 'lps'),
	(390558, 126, '2015-02-01 00:14:59.000000', 'consum', 0.0223, 'lps'),
	(390559, 126, '2015-02-01 00:15:00.000000', 'consum', 0.0213, 'lps'),
	(390560, 126, '2015-02-01 00:15:01.000000', 'consum', 0.0220, 'lps'),
	(390561, 126, '2015-02-01 00:15:02.000000', 'consum', 0.0218, 'lps'),
	(390562, 126, '2015-02-01 00:15:03.000000', 'consum', 0.0221, 'lps'),
	(390563, 126, '2015-02-01 00:15:04.000000', 'consum', 0.0214, 'lps'),
	(390564, 126, '2015-02-01 00:15:05.000000', 'consum', 0.0211, 'lps'),
	(390565, 126, '2015-02-01 00:15:06.000000', 'consum', 0.0218, 'lps'),
	(390566, 126, '2015-02-01 00:15:07.000000', 'consum', 0.0219, 'lps'),
	(390567, 126, '2015-02-01 00:15:08.000000', 'consum', 0.0216, 'lps'),
	(390568, 126, '2015-02-01 00:15:09.000000', 'consum', 0.0211, 'lps'),
	(390569, 126, '2015-02-01 00:15:10.000000', 'consum', 0.0216, 'lps'),
	(390570, 126, '2015-02-01 00:15:11.000000', 'consum', 0.0220, 'lps'),
	(390571, 126, '2015-02-01 00:15:12.000000', 'consum', 0.0214, 'lps'),
	(390572, 126, '2015-02-01 00:15:13.000000', 'consum', 0.0215, 'lps'),
	(390573, 126, '2015-02-01 00:15:14.000000', 'consum', 0.0211, 'lps'),
	(390574, 126, '2015-02-01 00:15:15.000000', 'consum', 0.0212, 'lps'),
	(390575, 126, '2015-02-01 00:15:16.000000', 'consum', 0.0218, 'lps'),
	(390576, 126, '2015-02-01 00:15:17.000000', 'consum', 0.0217, 'lps'),
	(390577, 126, '2015-02-01 00:15:18.000000', 'consum', 0.0221, 'lps'),
	(390578, 126, '2015-02-01 00:15:19.000000', 'consum', 0.0212, 'lps'),
	(390579, 126, '2015-02-01 00:15:20.000000', 'consum', 0.0218, 'lps'),
	(390580, 126, '2015-02-01 00:15:21.000000', 'consum', 0.0215, 'lps'),
	(390581, 126, '2015-02-01 00:15:22.000000', 'consum', 0.0212, 'lps'),
	(390582, 126, '2015-02-01 00:15:23.000000', 'consum', 0.0222, 'lps'),
	(390583, 126, '2015-02-01 00:15:24.000000', 'consum', 0.0217, 'lps'),
	(390584, 126, '2015-02-01 00:15:25.000000', 'consum', 0.0211, 'lps'),
	(390585, 126, '2015-02-01 00:15:26.000000', 'consum', 0.0222, 'lps'),
	(390586, 126, '2015-02-01 00:15:27.000000', 'consum', 0.0210, 'lps'),
	(390587, 126, '2015-02-01 00:15:28.000000', 'consum', 0.0220, 'lps'),
	(390588, 126, '2015-02-01 00:15:29.000000', 'consum', 0.0215, 'lps'),
	(390589, 126, '2015-02-01 00:15:30.000000', 'consum', 0.0219, 'lps'),
	(390590, 126, '2015-02-01 00:15:31.000000', 'consum', 0.0213, 'lps'),
	(390591, 126, '2015-02-01 00:15:32.000000', 'consum', 0.0213, 'lps'),
	(390592, 126, '2015-02-01 00:15:33.000000', 'consum', 0.0217, 'lps'),
	(390593, 126, '2015-02-01 00:15:34.000000', 'consum', 0.0220, 'lps'),
	(390594, 126, '2015-02-01 00:15:35.000000', 'consum', 0.0210, 'lps'),
	(390595, 126, '2015-02-01 00:15:36.000000', 'consum', 0.0210, 'lps'),
	(390596, 126, '2015-02-01 00:15:37.000000', 'consum', 0.0212, 'lps'),
	(390597, 126, '2015-02-01 00:15:38.000000', 'consum', 0.0221, 'lps'),
	(390598, 126, '2015-02-01 00:15:39.000000', 'consum', 0.0212, 'lps'),
	(390599, 126, '2015-02-01 00:15:40.000000', 'consum', 0.0219, 'lps'),
	(390600, 126, '2015-02-01 00:15:41.000000', 'consum', 0.0220, 'lps'),
	(390601, 126, '2015-02-01 00:15:42.000000', 'consum', 0.0219, 'lps'),
	(390602, 126, '2015-02-01 00:15:43.000000', 'consum', 0.0210, 'lps'),
	(390603, 126, '2015-02-01 00:15:44.000000', 'consum', 0.0213, 'lps'),
	(390604, 126, '2015-02-01 00:15:45.000000', 'consum', 0.0210, 'lps'),
	(390605, 126, '2015-02-01 00:15:46.000000', 'consum', 0.0218, 'lps'),
	(390606, 126, '2015-02-01 00:15:47.000000', 'consum', 0.0218, 'lps'),
	(390607, 126, '2015-02-01 00:15:48.000000', 'consum', 0.0214, 'lps'),
	(390608, 126, '2015-02-01 00:15:49.000000', 'consum', 0.0220, 'lps'),
	(390609, 126, '2015-02-01 00:15:50.000000', 'consum', 0.0219, 'lps'),
	(390610, 126, '2015-02-01 00:15:51.000000', 'consum', 0.0224, 'lps'),
	(390611, 126, '2015-02-01 00:15:52.000000', 'consum', 0.0224, 'lps'),
	(390612, 126, '2015-02-01 00:15:53.000000', 'consum', 0.0223, 'lps'),
	(390613, 126, '2015-02-01 00:15:54.000000', 'consum', 0.0217, 'lps'),
	(390614, 126, '2015-02-01 00:15:55.000000', 'consum', 0.0223, 'lps'),
	(390615, 126, '2015-02-01 00:15:56.000000', 'consum', 0.0210, 'lps'),
	(390616, 126, '2015-02-01 00:15:57.000000', 'consum', 0.0217, 'lps'),
	(390617, 126, '2015-02-01 00:15:58.000000', 'consum', 0.0216, 'lps'),
	(390618, 126, '2015-02-01 00:15:59.000000', 'consum', 0.0218, 'lps'),
	(390619, 126, '2015-02-01 00:16:00.000000', 'consum', 0.0219, 'lps'),
	(390620, 126, '2015-02-01 00:16:01.000000', 'consum', 0.0218, 'lps'),
	(390621, 126, '2015-02-01 00:16:02.000000', 'consum', 0.0220, 'lps'),
	(390622, 126, '2015-02-01 00:16:03.000000', 'consum', 0.0223, 'lps'),
	(390623, 126, '2015-02-01 00:16:04.000000', 'consum', 0.0217, 'lps'),
	(390624, 126, '2015-02-01 00:16:05.000000', 'consum', 0.0220, 'lps'),
	(390625, 126, '2015-02-01 00:16:06.000000', 'consum', 0.0224, 'lps'),
	(390626, 126, '2015-02-01 00:16:07.000000', 'consum', 0.0221, 'lps'),
	(390627, 126, '2015-02-01 00:16:08.000000', 'consum', 0.0210, 'lps'),
	(390628, 126, '2015-02-01 00:16:09.000000', 'consum', 0.0221, 'lps'),
	(390629, 126, '2015-02-01 00:16:10.000000', 'consum', 0.0222, 'lps'),
	(390630, 126, '2015-02-01 00:16:11.000000', 'consum', 0.0221, 'lps'),
	(390631, 126, '2015-02-01 00:16:12.000000', 'consum', 0.0216, 'lps'),
	(390632, 126, '2015-02-01 00:16:13.000000', 'consum', 0.0222, 'lps'),
	(390633, 126, '2015-02-01 00:16:14.000000', 'consum', 0.0222, 'lps'),
	(390634, 126, '2015-02-01 00:16:15.000000', 'consum', 0.0221, 'lps'),
	(390635, 126, '2015-02-01 00:16:16.000000', 'consum', 0.0212, 'lps'),
	(390636, 126, '2015-02-01 00:16:17.000000', 'consum', 0.0218, 'lps'),
	(390637, 126, '2015-02-01 00:16:18.000000', 'consum', 0.0216, 'lps'),
	(390638, 126, '2015-02-01 00:16:19.000000', 'consum', 0.0215, 'lps'),
	(390639, 126, '2015-02-01 00:16:20.000000', 'consum', 0.0218, 'lps'),
	(390640, 126, '2015-02-01 00:16:21.000000', 'consum', 0.0219, 'lps'),
	(390641, 126, '2015-02-01 00:16:22.000000', 'consum', 0.0217, 'lps'),
	(390642, 126, '2015-02-01 00:16:23.000000', 'consum', 0.0220, 'lps'),
	(390643, 126, '2015-02-01 00:16:24.000000', 'consum', 0.0222, 'lps'),
	(390644, 126, '2015-02-01 00:16:25.000000', 'consum', 0.0213, 'lps'),
	(390645, 126, '2015-02-01 00:16:26.000000', 'consum', 0.0220, 'lps'),
	(390646, 126, '2015-02-01 00:16:27.000000', 'consum', 0.0221, 'lps'),
	(390647, 126, '2015-02-01 00:16:28.000000', 'consum', 0.0222, 'lps'),
	(390648, 126, '2015-02-01 00:16:29.000000', 'consum', 0.0221, 'lps'),
	(390649, 126, '2015-02-01 00:16:30.000000', 'consum', 0.0214, 'lps'),
	(390650, 126, '2015-02-01 00:16:31.000000', 'consum', 0.0212, 'lps'),
	(390651, 126, '2015-02-01 00:16:32.000000', 'consum', 0.0223, 'lps'),
	(390652, 126, '2015-02-01 00:16:33.000000', 'consum', 0.0210, 'lps'),
	(390653, 126, '2015-02-01 00:16:34.000000', 'consum', 0.0215, 'lps'),
	(390654, 126, '2015-02-01 00:16:35.000000', 'consum', 0.0220, 'lps'),
	(390655, 126, '2015-02-01 00:16:36.000000', 'consum', 0.0219, 'lps'),
	(390656, 126, '2015-02-01 00:16:37.000000', 'consum', 0.0223, 'lps'),
	(390657, 126, '2015-02-01 00:16:38.000000', 'consum', 0.0219, 'lps'),
	(390658, 126, '2015-02-01 00:16:39.000000', 'consum', 0.0215, 'lps'),
	(390659, 126, '2015-02-01 00:16:40.000000', 'consum', 0.0223, 'lps'),
	(390660, 126, '2015-02-01 00:16:41.000000', 'consum', 0.0217, 'lps'),
	(390661, 126, '2015-02-01 00:16:42.000000', 'consum', 0.0221, 'lps'),
	(390662, 126, '2015-02-01 00:16:43.000000', 'consum', 0.0213, 'lps'),
	(390663, 126, '2015-02-01 00:16:44.000000', 'consum', 0.0223, 'lps'),
	(390664, 126, '2015-02-01 00:16:45.000000', 'consum', 0.0220, 'lps'),
	(390665, 126, '2015-02-01 00:16:46.000000', 'consum', 0.0224, 'lps'),
	(390666, 126, '2015-02-01 00:16:47.000000', 'consum', 0.0219, 'lps'),
	(390667, 126, '2015-02-01 00:16:48.000000', 'consum', 0.0212, 'lps'),
	(390668, 126, '2015-02-01 00:16:49.000000', 'consum', 0.0224, 'lps'),
	(390669, 126, '2015-02-01 00:16:50.000000', 'consum', 0.0217, 'lps'),
	(390670, 126, '2015-02-01 00:16:51.000000', 'consum', 0.0215, 'lps'),
	(390671, 126, '2015-02-01 00:16:52.000000', 'consum', 0.0218, 'lps'),
	(390672, 126, '2015-02-01 00:16:53.000000', 'consum', 0.0219, 'lps'),
	(390673, 126, '2015-02-01 00:16:54.000000', 'consum', 0.0215, 'lps'),
	(390674, 126, '2015-02-01 00:16:55.000000', 'consum', 0.0223, 'lps'),
	(390675, 126, '2015-02-01 00:16:56.000000', 'consum', 0.0216, 'lps'),
	(390676, 126, '2015-02-01 00:16:57.000000', 'consum', 0.0218, 'lps'),
	(390677, 126, '2015-02-01 00:16:58.000000', 'consum', 0.0218, 'lps'),
	(390678, 126, '2015-02-01 00:16:59.000000', 'consum', 0.0224, 'lps'),
	(390679, 126, '2015-02-01 00:17:00.000000', 'consum', 0.0215, 'lps'),
	(390680, 126, '2015-02-01 00:17:01.000000', 'consum', 0.0220, 'lps'),
	(390681, 126, '2015-02-01 00:17:02.000000', 'consum', 0.0217, 'lps'),
	(390682, 126, '2015-02-01 00:17:03.000000', 'consum', 0.0215, 'lps'),
	(390683, 126, '2015-02-01 00:17:04.000000', 'consum', 0.0214, 'lps'),
	(390684, 126, '2015-02-01 00:17:05.000000', 'consum', 0.0217, 'lps'),
	(390685, 126, '2015-02-01 00:17:06.000000', 'consum', 0.0218, 'lps'),
	(390686, 126, '2015-02-01 00:17:07.000000', 'consum', 0.0215, 'lps'),
	(390687, 126, '2015-02-01 00:17:08.000000', 'consum', 0.0211, 'lps'),
	(390688, 126, '2015-02-01 00:17:09.000000', 'consum', 0.0217, 'lps'),
	(390689, 126, '2015-02-01 00:17:10.000000', 'consum', 0.0210, 'lps'),
	(390690, 126, '2015-02-01 00:17:11.000000', 'consum', 0.0221, 'lps'),
	(390691, 126, '2015-02-01 00:17:12.000000', 'consum', 0.0222, 'lps'),
	(390692, 126, '2015-02-01 00:17:13.000000', 'consum', 0.0220, 'lps'),
	(390693, 126, '2015-02-01 00:17:14.000000', 'consum', 0.0210, 'lps'),
	(390694, 126, '2015-02-01 00:17:15.000000', 'consum', 0.0210, 'lps'),
	(390695, 126, '2015-02-01 00:17:16.000000', 'consum', 0.0212, 'lps'),
	(390696, 126, '2015-02-01 00:17:17.000000', 'consum', 0.0222, 'lps'),
	(390697, 126, '2015-02-01 00:17:18.000000', 'consum', 0.0217, 'lps'),
	(390698, 126, '2015-02-01 00:17:19.000000', 'consum', 0.0224, 'lps'),
	(390699, 126, '2015-02-01 00:17:20.000000', 'consum', 0.0216, 'lps'),
	(390700, 126, '2015-02-01 00:17:21.000000', 'consum', 0.0214, 'lps'),
	(390701, 126, '2015-02-01 00:17:22.000000', 'consum', 0.0212, 'lps'),
	(390702, 126, '2015-02-01 00:17:23.000000', 'consum', 0.0222, 'lps'),
	(390703, 126, '2015-02-01 00:17:24.000000', 'consum', 0.0221, 'lps'),
	(390704, 126, '2015-02-01 00:17:25.000000', 'consum', 0.0215, 'lps'),
	(390705, 126, '2015-02-01 00:17:26.000000', 'consum', 0.0216, 'lps'),
	(390706, 126, '2015-02-01 00:17:27.000000', 'consum', 0.0212, 'lps'),
	(390707, 126, '2015-02-01 00:17:28.000000', 'consum', 0.0217, 'lps'),
	(390708, 126, '2015-02-01 00:17:29.000000', 'consum', 0.0210, 'lps'),
	(390709, 126, '2015-02-01 00:17:30.000000', 'consum', 0.0221, 'lps'),
	(390710, 126, '2015-02-01 00:17:31.000000', 'consum', 0.0218, 'lps'),
	(390711, 126, '2015-02-01 00:17:32.000000', 'consum', 0.0217, 'lps'),
	(390712, 126, '2015-02-01 00:17:33.000000', 'consum', 0.0223, 'lps'),
	(390713, 126, '2015-02-01 00:17:34.000000', 'consum', 0.0210, 'lps'),
	(390714, 126, '2015-02-01 00:17:35.000000', 'consum', 0.0215, 'lps'),
	(390715, 126, '2015-02-01 00:17:36.000000', 'consum', 0.0222, 'lps'),
	(390716, 126, '2015-02-01 00:17:37.000000', 'consum', 0.0210, 'lps'),
	(390717, 126, '2015-02-01 00:17:38.000000', 'consum', 0.0220, 'lps'),
	(390718, 126, '2015-02-01 00:17:39.000000', 'consum', 0.0217, 'lps'),
	(390719, 126, '2015-02-01 00:17:40.000000', 'consum', 0.0213, 'lps'),
	(390720, 126, '2015-02-01 00:17:41.000000', 'consum', 0.0222, 'lps'),
	(390721, 126, '2015-02-01 00:17:42.000000', 'consum', 0.0217, 'lps'),
	(390722, 126, '2015-02-01 00:17:43.000000', 'consum', 0.0222, 'lps'),
	(390723, 126, '2015-02-01 00:17:44.000000', 'consum', 0.0219, 'lps'),
	(390724, 126, '2015-02-01 00:17:45.000000', 'consum', 0.0219, 'lps'),
	(390725, 126, '2015-02-01 00:17:46.000000', 'consum', 0.0216, 'lps'),
	(390726, 126, '2015-02-01 00:17:47.000000', 'consum', 0.0213, 'lps'),
	(390727, 126, '2015-02-01 00:17:48.000000', 'consum', 0.0224, 'lps'),
	(390728, 126, '2015-02-01 00:17:49.000000', 'consum', 0.0210, 'lps'),
	(390729, 126, '2015-02-01 00:17:50.000000', 'consum', 0.0215, 'lps'),
	(390730, 126, '2015-02-01 00:17:51.000000', 'consum', 0.0221, 'lps'),
	(390731, 126, '2015-02-01 00:17:52.000000', 'consum', 0.0221, 'lps'),
	(390732, 126, '2015-02-01 00:17:53.000000', 'consum', 0.0216, 'lps'),
	(390733, 126, '2015-02-01 00:17:54.000000', 'consum', 0.0222, 'lps'),
	(390734, 126, '2015-02-01 00:17:55.000000', 'consum', 0.0223, 'lps'),
	(390735, 126, '2015-02-01 00:17:56.000000', 'consum', 0.0224, 'lps'),
	(390736, 126, '2015-02-01 00:17:57.000000', 'consum', 0.0214, 'lps'),
	(390737, 126, '2015-02-01 00:17:58.000000', 'consum', 0.0216, 'lps'),
	(390738, 126, '2015-02-01 00:17:59.000000', 'consum', 0.0215, 'lps'),
	(390739, 126, '2015-02-01 00:18:00.000000', 'consum', 0.0215, 'lps'),
	(390740, 126, '2015-02-01 00:18:01.000000', 'consum', 0.0222, 'lps'),
	(390741, 126, '2015-02-01 00:18:02.000000', 'consum', 0.0212, 'lps'),
	(390742, 126, '2015-02-01 00:18:03.000000', 'consum', 0.0213, 'lps'),
	(390743, 126, '2015-02-01 00:18:04.000000', 'consum', 0.0218, 'lps'),
	(390744, 126, '2015-02-01 00:18:05.000000', 'consum', 0.0214, 'lps'),
	(390745, 126, '2015-02-01 00:18:06.000000', 'consum', 0.0222, 'lps'),
	(390746, 126, '2015-02-01 00:18:07.000000', 'consum', 0.0212, 'lps'),
	(390747, 126, '2015-02-01 00:18:08.000000', 'consum', 0.0214, 'lps'),
	(390748, 126, '2015-02-01 00:18:09.000000', 'consum', 0.0210, 'lps'),
	(390749, 126, '2015-02-01 00:18:10.000000', 'consum', 0.0213, 'lps'),
	(390750, 126, '2015-02-01 00:18:11.000000', 'consum', 0.0224, 'lps'),
	(390751, 126, '2015-02-01 00:18:12.000000', 'consum', 0.0214, 'lps'),
	(390752, 126, '2015-02-01 00:18:13.000000', 'consum', 0.0218, 'lps'),
	(390753, 126, '2015-02-01 00:18:14.000000', 'consum', 0.0210, 'lps'),
	(390754, 126, '2015-02-01 00:18:15.000000', 'consum', 0.0214, 'lps'),
	(390755, 126, '2015-02-01 00:18:16.000000', 'consum', 0.0219, 'lps'),
	(390756, 126, '2015-02-01 00:18:17.000000', 'consum', 0.0210, 'lps'),
	(390757, 126, '2015-02-01 00:18:18.000000', 'consum', 0.0213, 'lps'),
	(390758, 126, '2015-02-01 00:18:19.000000', 'consum', 0.0213, 'lps'),
	(390759, 126, '2015-02-01 00:18:20.000000', 'consum', 0.0217, 'lps'),
	(390760, 126, '2015-02-01 00:18:21.000000', 'consum', 0.0222, 'lps'),
	(390761, 126, '2015-02-01 00:18:22.000000', 'consum', 0.0220, 'lps'),
	(390762, 126, '2015-02-01 00:18:23.000000', 'consum', 0.0223, 'lps'),
	(390763, 126, '2015-02-01 00:18:24.000000', 'consum', 0.0215, 'lps'),
	(390764, 126, '2015-02-01 00:18:25.000000', 'consum', 0.0211, 'lps'),
	(390765, 126, '2015-02-01 00:18:26.000000', 'consum', 0.0218, 'lps'),
	(390766, 126, '2015-02-01 00:18:27.000000', 'consum', 0.0214, 'lps'),
	(390767, 126, '2015-02-01 00:18:28.000000', 'consum', 0.0224, 'lps'),
	(390768, 126, '2015-02-01 00:18:29.000000', 'consum', 0.0222, 'lps'),
	(390769, 126, '2015-02-01 00:18:30.000000', 'consum', 0.0213, 'lps'),
	(390770, 126, '2015-02-01 00:18:31.000000', 'consum', 0.0222, 'lps'),
	(390771, 126, '2015-02-01 00:18:32.000000', 'consum', 0.0214, 'lps'),
	(390772, 126, '2015-02-01 00:18:33.000000', 'consum', 0.0224, 'lps'),
	(390773, 126, '2015-02-01 00:18:34.000000', 'consum', 0.0222, 'lps'),
	(390774, 126, '2015-02-01 00:18:35.000000', 'consum', 0.0217, 'lps'),
	(390775, 126, '2015-02-01 00:18:36.000000', 'consum', 0.0222, 'lps'),
	(390776, 126, '2015-02-01 00:18:37.000000', 'consum', 0.0221, 'lps'),
	(390777, 126, '2015-02-01 00:18:38.000000', 'consum', 0.0213, 'lps'),
	(390778, 126, '2015-02-01 00:18:39.000000', 'consum', 0.0210, 'lps'),
	(390779, 126, '2015-02-01 00:18:40.000000', 'consum', 0.0215, 'lps'),
	(390780, 126, '2015-02-01 00:18:41.000000', 'consum', 0.0220, 'lps'),
	(390781, 126, '2015-02-01 00:18:42.000000', 'consum', 0.0216, 'lps'),
	(390782, 126, '2015-02-01 00:18:43.000000', 'consum', 0.0212, 'lps'),
	(390783, 126, '2015-02-01 00:18:44.000000', 'consum', 0.0215, 'lps'),
	(390784, 126, '2015-02-01 00:18:45.000000', 'consum', 0.0217, 'lps'),
	(390785, 126, '2015-02-01 00:18:46.000000', 'consum', 0.0214, 'lps'),
	(390786, 126, '2015-02-01 00:18:47.000000', 'consum', 0.0212, 'lps'),
	(390787, 126, '2015-02-01 00:18:48.000000', 'consum', 0.0222, 'lps'),
	(390788, 126, '2015-02-01 00:18:49.000000', 'consum', 0.0218, 'lps'),
	(390789, 126, '2015-02-01 00:18:50.000000', 'consum', 0.0217, 'lps'),
	(390790, 126, '2015-02-01 00:18:51.000000', 'consum', 0.0220, 'lps'),
	(390791, 126, '2015-02-01 00:18:52.000000', 'consum', 0.0223, 'lps'),
	(390792, 126, '2015-02-01 00:18:53.000000', 'consum', 0.0218, 'lps'),
	(390793, 126, '2015-02-01 00:18:54.000000', 'consum', 0.0210, 'lps'),
	(390794, 126, '2015-02-01 00:18:55.000000', 'consum', 0.0216, 'lps'),
	(390795, 126, '2015-02-01 00:18:56.000000', 'consum', 0.0210, 'lps'),
	(390796, 126, '2015-02-01 00:18:57.000000', 'consum', 0.0224, 'lps'),
	(390797, 126, '2015-02-01 00:18:58.000000', 'consum', 0.0221, 'lps'),
	(390798, 126, '2015-02-01 00:18:59.000000', 'consum', 0.0224, 'lps'),
	(390799, 126, '2015-02-01 00:19:00.000000', 'consum', 0.0219, 'lps'),
	(390800, 126, '2015-02-01 00:19:01.000000', 'consum', 0.0210, 'lps'),
	(390801, 126, '2015-02-01 00:19:02.000000', 'consum', 0.0217, 'lps'),
	(390802, 126, '2015-02-01 00:19:03.000000', 'consum', 0.0213, 'lps'),
	(390803, 126, '2015-02-01 00:19:04.000000', 'consum', 0.0218, 'lps'),
	(390804, 126, '2015-02-01 00:19:05.000000', 'consum', 0.0214, 'lps'),
	(390805, 126, '2015-02-01 00:19:06.000000', 'consum', 0.0220, 'lps'),
	(390806, 126, '2015-02-01 00:19:07.000000', 'consum', 0.0218, 'lps'),
	(390807, 126, '2015-02-01 00:19:08.000000', 'consum', 0.0220, 'lps'),
	(390808, 126, '2015-02-01 00:19:09.000000', 'consum', 0.0221, 'lps'),
	(390809, 126, '2015-02-01 00:19:10.000000', 'consum', 0.0224, 'lps'),
	(390810, 126, '2015-02-01 00:19:11.000000', 'consum', 0.0214, 'lps'),
	(390811, 126, '2015-02-01 00:19:12.000000', 'consum', 0.0219, 'lps'),
	(390812, 126, '2015-02-01 00:19:13.000000', 'consum', 0.0214, 'lps'),
	(390813, 126, '2015-02-01 00:19:14.000000', 'consum', 0.0219, 'lps'),
	(390814, 126, '2015-02-01 00:19:15.000000', 'consum', 0.0215, 'lps'),
	(390815, 126, '2015-02-01 00:19:16.000000', 'consum', 0.0221, 'lps'),
	(390816, 126, '2015-02-01 00:19:17.000000', 'consum', 0.0223, 'lps'),
	(390817, 126, '2015-02-01 00:19:18.000000', 'consum', 0.0211, 'lps'),
	(390818, 126, '2015-02-01 00:19:19.000000', 'consum', 0.0223, 'lps'),
	(390819, 126, '2015-02-01 00:19:20.000000', 'consum', 0.0224, 'lps'),
	(390820, 126, '2015-02-01 00:19:21.000000', 'consum', 0.0215, 'lps'),
	(390821, 126, '2015-02-01 00:19:22.000000', 'consum', 0.0224, 'lps'),
	(390822, 126, '2015-02-01 00:19:23.000000', 'consum', 0.0220, 'lps'),
	(390823, 126, '2015-02-01 00:19:24.000000', 'consum', 0.0218, 'lps'),
	(390824, 126, '2015-02-01 00:19:25.000000', 'consum', 0.0222, 'lps'),
	(390825, 126, '2015-02-01 00:19:26.000000', 'consum', 0.0215, 'lps'),
	(390826, 126, '2015-02-01 00:19:27.000000', 'consum', 0.0215, 'lps'),
	(390827, 126, '2015-02-01 00:19:28.000000', 'consum', 0.0220, 'lps'),
	(390828, 126, '2015-02-01 00:19:29.000000', 'consum', 0.0215, 'lps'),
	(390829, 126, '2015-02-01 00:19:30.000000', 'consum', 0.0220, 'lps'),
	(390830, 126, '2015-02-01 00:19:31.000000', 'consum', 0.0218, 'lps'),
	(390831, 126, '2015-02-01 00:19:32.000000', 'consum', 0.0219, 'lps'),
	(390832, 126, '2015-02-01 00:19:33.000000', 'consum', 0.0218, 'lps'),
	(390833, 126, '2015-02-01 00:19:34.000000', 'consum', 0.0223, 'lps'),
	(390834, 126, '2015-02-01 00:19:35.000000', 'consum', 0.0222, 'lps'),
	(390835, 126, '2015-02-01 00:19:36.000000', 'consum', 0.0218, 'lps'),
	(390836, 126, '2015-02-01 00:19:37.000000', 'consum', 0.0212, 'lps'),
	(390837, 126, '2015-02-01 00:19:38.000000', 'consum', 0.0211, 'lps'),
	(390838, 126, '2015-02-01 00:19:39.000000', 'consum', 0.0211, 'lps'),
	(390839, 126, '2015-02-01 00:19:40.000000', 'consum', 0.0213, 'lps'),
	(390840, 126, '2015-02-01 00:19:41.000000', 'consum', 0.0222, 'lps'),
	(390841, 126, '2015-02-01 00:19:42.000000', 'consum', 0.0216, 'lps'),
	(390842, 126, '2015-02-01 00:19:43.000000', 'consum', 0.0218, 'lps'),
	(390843, 126, '2015-02-01 00:19:44.000000', 'consum', 0.0220, 'lps'),
	(390844, 126, '2015-02-01 00:19:45.000000', 'consum', 0.0220, 'lps'),
	(390845, 126, '2015-02-01 00:19:46.000000', 'consum', 0.0214, 'lps'),
	(390846, 126, '2015-02-01 00:19:47.000000', 'consum', 0.0219, 'lps'),
	(390847, 126, '2015-02-01 00:19:48.000000', 'consum', 0.0210, 'lps'),
	(390848, 126, '2015-02-01 00:19:49.000000', 'consum', 0.0214, 'lps'),
	(390849, 126, '2015-02-01 00:19:50.000000', 'consum', 0.0218, 'lps'),
	(390850, 126, '2015-02-01 00:19:51.000000', 'consum', 0.0220, 'lps'),
	(390851, 126, '2015-02-01 00:19:52.000000', 'consum', 0.0210, 'lps'),
	(390852, 126, '2015-02-01 00:19:53.000000', 'consum', 0.0223, 'lps'),
	(390853, 126, '2015-02-01 00:19:54.000000', 'consum', 0.0217, 'lps'),
	(390854, 126, '2015-02-01 00:19:55.000000', 'consum', 0.0221, 'lps'),
	(390855, 126, '2015-02-01 00:19:56.000000', 'consum', 0.0216, 'lps'),
	(390856, 126, '2015-02-01 00:19:57.000000', 'consum', 0.0221, 'lps'),
	(390857, 126, '2015-02-01 00:19:58.000000', 'consum', 0.0220, 'lps'),
	(390858, 126, '2015-02-01 00:19:59.000000', 'consum', 0.0210, 'lps'),
	(390859, 126, '2015-02-01 00:20:00.000000', 'consum', 0.0211, 'lps'),
	(390860, 126, '2015-02-01 00:20:01.000000', 'consum', 0.0217, 'lps'),
	(390861, 126, '2015-02-01 00:20:02.000000', 'consum', 0.0210, 'lps'),
	(390862, 126, '2015-02-01 00:20:03.000000', 'consum', 0.0221, 'lps'),
	(390863, 126, '2015-02-01 00:20:04.000000', 'consum', 0.0218, 'lps'),
	(390864, 126, '2015-02-01 00:20:05.000000', 'consum', 0.0221, 'lps'),
	(390865, 126, '2015-02-01 00:20:06.000000', 'consum', 0.0211, 'lps'),
	(390866, 126, '2015-02-01 00:20:07.000000', 'consum', 0.0212, 'lps'),
	(390867, 126, '2015-02-01 00:20:08.000000', 'consum', 0.0216, 'lps'),
	(390868, 126, '2015-02-01 00:20:09.000000', 'consum', 0.0220, 'lps'),
	(390869, 126, '2015-02-01 00:20:10.000000', 'consum', 0.0212, 'lps'),
	(390870, 126, '2015-02-01 00:20:11.000000', 'consum', 0.0222, 'lps'),
	(390871, 126, '2015-02-01 00:20:12.000000', 'consum', 0.0218, 'lps'),
	(390872, 126, '2015-02-01 00:20:13.000000', 'consum', 0.0213, 'lps'),
	(390873, 126, '2015-02-01 00:20:14.000000', 'consum', 0.0218, 'lps'),
	(390874, 126, '2015-02-01 00:20:15.000000', 'consum', 0.0213, 'lps'),
	(390875, 126, '2015-02-01 00:20:16.000000', 'consum', 0.0216, 'lps'),
	(390876, 126, '2015-02-01 00:20:17.000000', 'consum', 0.0218, 'lps'),
	(390877, 126, '2015-02-01 00:20:18.000000', 'consum', 0.0217, 'lps'),
	(390878, 126, '2015-02-01 00:20:19.000000', 'consum', 0.0222, 'lps'),
	(390879, 126, '2015-02-01 00:20:20.000000', 'consum', 0.0218, 'lps'),
	(390880, 126, '2015-02-01 00:20:21.000000', 'consum', 0.0217, 'lps'),
	(390881, 126, '2015-02-01 00:20:22.000000', 'consum', 0.0218, 'lps'),
	(390882, 126, '2015-02-01 00:20:23.000000', 'consum', 0.0217, 'lps'),
	(390883, 126, '2015-02-01 00:20:24.000000', 'consum', 0.0220, 'lps'),
	(390884, 126, '2015-02-01 00:20:25.000000', 'consum', 0.0211, 'lps'),
	(390885, 126, '2015-02-01 00:20:26.000000', 'consum', 0.0217, 'lps'),
	(390886, 126, '2015-02-01 00:20:27.000000', 'consum', 0.0210, 'lps'),
	(390887, 126, '2015-02-01 00:20:28.000000', 'consum', 0.0221, 'lps'),
	(390888, 126, '2015-02-01 00:20:29.000000', 'consum', 0.0222, 'lps'),
	(390889, 126, '2015-02-01 00:20:30.000000', 'consum', 0.0220, 'lps'),
	(390890, 126, '2015-02-01 00:20:31.000000', 'consum', 0.0210, 'lps'),
	(390891, 126, '2015-02-01 00:20:32.000000', 'consum', 0.0212, 'lps'),
	(390892, 126, '2015-02-01 00:20:33.000000', 'consum', 0.0218, 'lps'),
	(390893, 126, '2015-02-01 00:20:34.000000', 'consum', 0.0217, 'lps'),
	(390894, 126, '2015-02-01 00:20:35.000000', 'consum', 0.0221, 'lps'),
	(390895, 126, '2015-02-01 00:20:36.000000', 'consum', 0.0215, 'lps'),
	(390896, 126, '2015-02-01 00:20:37.000000', 'consum', 0.0217, 'lps'),
	(390897, 126, '2015-02-01 00:20:38.000000', 'consum', 0.0217, 'lps'),
	(390898, 126, '2015-02-01 00:20:39.000000', 'consum', 0.0210, 'lps'),
	(390899, 126, '2015-02-01 00:20:40.000000', 'consum', 0.0217, 'lps'),
	(390900, 126, '2015-02-01 00:20:41.000000', 'consum', 0.0215, 'lps'),
	(390901, 126, '2015-02-01 00:20:42.000000', 'consum', 0.0216, 'lps'),
	(390902, 126, '2015-02-01 00:20:43.000000', 'consum', 0.0210, 'lps'),
	(390903, 126, '2015-02-01 00:20:44.000000', 'consum', 0.0221, 'lps'),
	(390904, 126, '2015-02-01 00:20:45.000000', 'consum', 0.0223, 'lps'),
	(390905, 126, '2015-02-01 00:20:46.000000', 'consum', 0.0213, 'lps'),
	(390906, 126, '2015-02-01 00:20:47.000000', 'consum', 0.0216, 'lps'),
	(390907, 126, '2015-02-01 00:20:48.000000', 'consum', 0.0216, 'lps'),
	(390908, 126, '2015-02-01 00:20:49.000000', 'consum', 0.0221, 'lps'),
	(390909, 126, '2015-02-01 00:20:50.000000', 'consum', 0.0217, 'lps'),
	(390910, 126, '2015-02-01 00:20:51.000000', 'consum', 0.0212, 'lps'),
	(390911, 126, '2015-02-01 00:20:52.000000', 'consum', 0.0216, 'lps'),
	(390912, 126, '2015-02-01 00:20:53.000000', 'consum', 0.0218, 'lps'),
	(390913, 126, '2015-02-01 00:20:54.000000', 'consum', 0.0217, 'lps'),
	(390914, 126, '2015-02-01 00:20:55.000000', 'consum', 0.0224, 'lps'),
	(390915, 126, '2015-02-01 00:20:56.000000', 'consum', 0.0212, 'lps'),
	(390916, 126, '2015-02-01 00:20:57.000000', 'consum', 0.0224, 'lps'),
	(390917, 126, '2015-02-01 00:20:58.000000', 'consum', 0.0216, 'lps'),
	(390918, 126, '2015-02-01 00:20:59.000000', 'consum', 0.0211, 'lps'),
	(390919, 126, '2015-02-01 00:21:00.000000', 'consum', 0.0213, 'lps'),
	(390920, 126, '2015-02-01 00:21:01.000000', 'consum', 0.0221, 'lps'),
	(390921, 126, '2015-02-01 00:21:02.000000', 'consum', 0.0212, 'lps'),
	(390922, 126, '2015-02-01 00:21:03.000000', 'consum', 0.0219, 'lps'),
	(390923, 126, '2015-02-01 00:21:04.000000', 'consum', 0.0220, 'lps'),
	(390924, 126, '2015-02-01 00:21:05.000000', 'consum', 0.0220, 'lps'),
	(390925, 126, '2015-02-01 00:21:06.000000', 'consum', 0.0213, 'lps'),
	(390926, 126, '2015-02-01 00:21:07.000000', 'consum', 0.0211, 'lps'),
	(390927, 126, '2015-02-01 00:21:08.000000', 'consum', 0.0220, 'lps'),
	(390928, 126, '2015-02-01 00:21:09.000000', 'consum', 0.0213, 'lps'),
	(390929, 126, '2015-02-01 00:21:10.000000', 'consum', 0.0211, 'lps'),
	(390930, 126, '2015-02-01 00:21:11.000000', 'consum', 0.0223, 'lps'),
	(390931, 126, '2015-02-01 00:21:12.000000', 'consum', 0.0212, 'lps'),
	(390932, 126, '2015-02-01 00:21:13.000000', 'consum', 0.0211, 'lps'),
	(390933, 126, '2015-02-01 00:21:14.000000', 'consum', 0.0222, 'lps'),
	(390934, 126, '2015-02-01 00:21:15.000000', 'consum', 0.0211, 'lps'),
	(390935, 126, '2015-02-01 00:21:16.000000', 'consum', 0.0224, 'lps'),
	(390936, 126, '2015-02-01 00:21:17.000000', 'consum', 0.0217, 'lps'),
	(390937, 126, '2015-02-01 00:21:18.000000', 'consum', 0.0217, 'lps'),
	(390938, 126, '2015-02-01 00:21:19.000000', 'consum', 0.0224, 'lps'),
	(390939, 126, '2015-02-01 00:21:20.000000', 'consum', 0.0215, 'lps'),
	(390940, 126, '2015-02-01 00:21:21.000000', 'consum', 0.0224, 'lps'),
	(390941, 126, '2015-02-01 00:21:22.000000', 'consum', 0.0219, 'lps'),
	(390942, 126, '2015-02-01 00:21:23.000000', 'consum', 0.0213, 'lps'),
	(390943, 126, '2015-02-01 00:21:24.000000', 'consum', 0.0215, 'lps'),
	(390944, 126, '2015-02-01 00:21:25.000000', 'consum', 0.0213, 'lps'),
	(390945, 126, '2015-02-01 00:21:26.000000', 'consum', 0.0224, 'lps'),
	(390946, 126, '2015-02-01 00:21:27.000000', 'consum', 0.0212, 'lps'),
	(390947, 126, '2015-02-01 00:21:28.000000', 'consum', 0.0224, 'lps'),
	(390948, 126, '2015-02-01 00:21:29.000000', 'consum', 0.0213, 'lps'),
	(390949, 126, '2015-02-01 00:21:30.000000', 'consum', 0.0214, 'lps'),
	(390950, 126, '2015-02-01 00:21:31.000000', 'consum', 0.0221, 'lps'),
	(390951, 126, '2015-02-01 00:21:32.000000', 'consum', 0.0210, 'lps'),
	(390952, 126, '2015-02-01 00:21:33.000000', 'consum', 0.0224, 'lps'),
	(390953, 126, '2015-02-01 00:21:34.000000', 'consum', 0.0218, 'lps'),
	(390954, 126, '2015-02-01 00:21:35.000000', 'consum', 0.0223, 'lps'),
	(390955, 126, '2015-02-01 00:21:36.000000', 'consum', 0.0223, 'lps'),
	(390956, 126, '2015-02-01 00:21:37.000000', 'consum', 0.0220, 'lps'),
	(390957, 126, '2015-02-01 00:21:38.000000', 'consum', 0.0223, 'lps'),
	(390958, 126, '2015-02-01 00:21:39.000000', 'consum', 0.0217, 'lps'),
	(390959, 126, '2015-02-01 00:21:40.000000', 'consum', 0.0218, 'lps'),
	(390960, 126, '2015-02-01 00:21:41.000000', 'consum', 0.0217, 'lps'),
	(390961, 126, '2015-02-01 00:21:42.000000', 'consum', 0.0219, 'lps'),
	(390962, 126, '2015-02-01 00:21:43.000000', 'consum', 0.0223, 'lps'),
	(390963, 126, '2015-02-01 00:21:44.000000', 'consum', 0.0215, 'lps'),
	(390964, 126, '2015-02-01 00:21:45.000000', 'consum', 0.0213, 'lps'),
	(390965, 126, '2015-02-01 00:21:46.000000', 'consum', 0.0212, 'lps'),
	(390966, 126, '2015-02-01 00:21:47.000000', 'consum', 0.0210, 'lps'),
	(390967, 126, '2015-02-01 00:21:48.000000', 'consum', 0.0219, 'lps'),
	(390968, 126, '2015-02-01 00:21:49.000000', 'consum', 0.0224, 'lps'),
	(390969, 126, '2015-02-01 00:21:50.000000', 'consum', 0.0211, 'lps'),
	(390970, 126, '2015-02-01 00:21:51.000000', 'consum', 0.0218, 'lps'),
	(390971, 126, '2015-02-01 00:21:52.000000', 'consum', 0.0217, 'lps'),
	(390972, 126, '2015-02-01 00:21:53.000000', 'consum', 0.0221, 'lps'),
	(390973, 126, '2015-02-01 00:21:54.000000', 'consum', 0.0215, 'lps'),
	(390974, 126, '2015-02-01 00:21:55.000000', 'consum', 0.0216, 'lps'),
	(390975, 126, '2015-02-01 00:21:56.000000', 'consum', 0.0211, 'lps'),
	(390976, 126, '2015-02-01 00:21:57.000000', 'consum', 0.0214, 'lps'),
	(390977, 126, '2015-02-01 00:21:58.000000', 'consum', 0.0211, 'lps'),
	(390978, 126, '2015-02-01 00:21:59.000000', 'consum', 0.0220, 'lps'),
	(390979, 126, '2015-02-01 00:22:00.000000', 'consum', 0.0211, 'lps'),
	(390980, 126, '2015-02-01 00:22:01.000000', 'consum', 0.0215, 'lps'),
	(390981, 126, '2015-02-01 00:22:02.000000', 'consum', 0.0218, 'lps'),
	(390982, 126, '2015-02-01 00:22:03.000000', 'consum', 0.0219, 'lps'),
	(390983, 126, '2015-02-01 00:22:04.000000', 'consum', 0.0219, 'lps'),
	(390984, 126, '2015-02-01 00:22:05.000000', 'consum', 0.0211, 'lps'),
	(390985, 126, '2015-02-01 00:22:06.000000', 'consum', 0.0221, 'lps'),
	(390986, 126, '2015-02-01 00:22:07.000000', 'consum', 0.0218, 'lps'),
	(390987, 126, '2015-02-01 00:22:08.000000', 'consum', 0.0217, 'lps'),
	(390988, 126, '2015-02-01 00:22:09.000000', 'consum', 0.0221, 'lps'),
	(390989, 126, '2015-02-01 00:22:10.000000', 'consum', 0.0216, 'lps'),
	(390990, 126, '2015-02-01 00:22:11.000000', 'consum', 0.0222, 'lps'),
	(390991, 126, '2015-02-01 00:22:12.000000', 'consum', 0.0224, 'lps'),
	(390992, 126, '2015-02-01 00:22:13.000000', 'consum', 0.0212, 'lps'),
	(390993, 126, '2015-02-01 00:22:14.000000', 'consum', 0.0223, 'lps'),
	(390994, 126, '2015-02-01 00:22:15.000000', 'consum', 0.0224, 'lps'),
	(390995, 126, '2015-02-01 00:22:16.000000', 'consum', 0.0214, 'lps'),
	(390996, 126, '2015-02-01 00:22:17.000000', 'consum', 0.0216, 'lps'),
	(390997, 126, '2015-02-01 00:22:18.000000', 'consum', 0.0216, 'lps'),
	(390998, 126, '2015-02-01 00:22:19.000000', 'consum', 0.0221, 'lps'),
	(390999, 126, '2015-02-01 00:22:20.000000', 'consum', 0.0219, 'lps'),
	(391000, 126, '2015-02-01 00:22:21.000000', 'consum', 0.0222, 'lps'),
	(391001, 126, '2015-02-01 00:22:22.000000', 'consum', 0.0215, 'lps'),
	(391002, 126, '2015-02-01 00:22:23.000000', 'consum', 0.0214, 'lps'),
	(391003, 126, '2015-02-01 00:22:24.000000', 'consum', 0.0217, 'lps'),
	(391004, 126, '2015-02-01 00:22:25.000000', 'consum', 0.0215, 'lps'),
	(391005, 126, '2015-02-01 00:22:26.000000', 'consum', 0.0217, 'lps'),
	(391006, 126, '2015-02-01 00:22:27.000000', 'consum', 0.0214, 'lps'),
	(391007, 126, '2015-02-01 00:22:28.000000', 'consum', 0.0224, 'lps'),
	(391008, 126, '2015-02-01 00:22:29.000000', 'consum', 0.0223, 'lps'),
	(391009, 126, '2015-02-01 00:22:30.000000', 'consum', 0.0220, 'lps'),
	(391010, 126, '2015-02-01 00:22:31.000000', 'consum', 0.0222, 'lps'),
	(391011, 126, '2015-02-01 00:22:32.000000', 'consum', 0.0224, 'lps'),
	(391012, 126, '2015-02-01 00:22:33.000000', 'consum', 0.0213, 'lps'),
	(391013, 126, '2015-02-01 00:22:34.000000', 'consum', 0.0215, 'lps'),
	(391014, 126, '2015-02-01 00:22:35.000000', 'consum', 0.0211, 'lps'),
	(391015, 126, '2015-02-01 00:22:36.000000', 'consum', 0.0217, 'lps'),
	(391016, 126, '2015-02-01 00:22:37.000000', 'consum', 0.0213, 'lps'),
	(391017, 126, '2015-02-01 00:22:38.000000', 'consum', 0.0218, 'lps'),
	(391018, 126, '2015-02-01 00:22:39.000000', 'consum', 0.0210, 'lps'),
	(391019, 126, '2015-02-01 00:22:40.000000', 'consum', 0.0217, 'lps'),
	(391020, 126, '2015-02-01 00:22:41.000000', 'consum', 0.0217, 'lps'),
	(391021, 126, '2015-02-01 00:22:42.000000', 'consum', 0.0210, 'lps'),
	(391022, 126, '2015-02-01 00:22:43.000000', 'consum', 0.0221, 'lps'),
	(391023, 126, '2015-02-01 00:22:44.000000', 'consum', 0.0217, 'lps'),
	(391024, 126, '2015-02-01 00:22:45.000000', 'consum', 0.0214, 'lps'),
	(391025, 126, '2015-02-01 00:22:46.000000', 'consum', 0.0224, 'lps'),
	(391026, 126, '2015-02-01 00:22:47.000000', 'consum', 0.0224, 'lps'),
	(391027, 126, '2015-02-01 00:22:48.000000', 'consum', 0.0222, 'lps'),
	(391028, 126, '2015-02-01 00:22:49.000000', 'consum', 0.0216, 'lps'),
	(391029, 126, '2015-02-01 00:22:50.000000', 'consum', 0.0219, 'lps'),
	(391030, 126, '2015-02-01 00:22:51.000000', 'consum', 0.0222, 'lps'),
	(391031, 126, '2015-02-01 00:22:52.000000', 'consum', 0.0215, 'lps'),
	(391032, 126, '2015-02-01 00:22:53.000000', 'consum', 0.0215, 'lps'),
	(391033, 126, '2015-02-01 00:22:54.000000', 'consum', 0.0219, 'lps'),
	(391034, 126, '2015-02-01 00:22:55.000000', 'consum', 0.0211, 'lps'),
	(391035, 126, '2015-02-01 00:22:56.000000', 'consum', 0.0219, 'lps'),
	(391036, 126, '2015-02-01 00:22:57.000000', 'consum', 0.0224, 'lps'),
	(391037, 126, '2015-02-01 00:22:58.000000', 'consum', 0.0222, 'lps'),
	(391038, 126, '2015-02-01 00:22:59.000000', 'consum', 0.0213, 'lps'),
	(391039, 126, '2015-02-01 00:23:00.000000', 'consum', 0.0219, 'lps'),
	(391040, 126, '2015-02-01 00:23:01.000000', 'consum', 0.0218, 'lps'),
	(391041, 126, '2015-02-01 00:23:02.000000', 'consum', 0.0221, 'lps'),
	(391042, 126, '2015-02-01 00:23:03.000000', 'consum', 0.0213, 'lps'),
	(391043, 126, '2015-02-01 00:23:04.000000', 'consum', 0.0224, 'lps'),
	(391044, 126, '2015-02-01 00:23:05.000000', 'consum', 0.0224, 'lps'),
	(391045, 126, '2015-02-01 00:23:06.000000', 'consum', 0.0223, 'lps'),
	(391046, 126, '2015-02-01 00:23:07.000000', 'consum', 0.0221, 'lps'),
	(391047, 126, '2015-02-01 00:23:08.000000', 'consum', 0.0210, 'lps'),
	(391048, 126, '2015-02-01 00:23:09.000000', 'consum', 0.0222, 'lps'),
	(391049, 126, '2015-02-01 00:23:10.000000', 'consum', 0.0212, 'lps'),
	(391050, 126, '2015-02-01 00:23:11.000000', 'consum', 0.0213, 'lps'),
	(391051, 126, '2015-02-01 00:23:12.000000', 'consum', 0.0220, 'lps'),
	(391052, 126, '2015-02-01 00:23:13.000000', 'consum', 0.0221, 'lps'),
	(391053, 126, '2015-02-01 00:23:14.000000', 'consum', 0.0223, 'lps'),
	(391054, 126, '2015-02-01 00:23:15.000000', 'consum', 0.0210, 'lps'),
	(391055, 126, '2015-02-01 00:23:16.000000', 'consum', 0.0216, 'lps'),
	(391056, 126, '2015-02-01 00:23:17.000000', 'consum', 0.0210, 'lps'),
	(391057, 126, '2015-02-01 00:23:18.000000', 'consum', 0.0223, 'lps'),
	(391058, 126, '2015-02-01 00:23:19.000000', 'consum', 0.0214, 'lps'),
	(391059, 126, '2015-02-01 00:23:20.000000', 'consum', 0.0221, 'lps'),
	(391060, 126, '2015-02-01 00:23:21.000000', 'consum', 0.0211, 'lps'),
	(391061, 126, '2015-02-01 00:23:22.000000', 'consum', 0.0212, 'lps'),
	(391062, 126, '2015-02-01 00:23:23.000000', 'consum', 0.0215, 'lps'),
	(391063, 126, '2015-02-01 00:23:24.000000', 'consum', 0.0217, 'lps'),
	(391064, 126, '2015-02-01 00:23:25.000000', 'consum', 0.0216, 'lps'),
	(391065, 126, '2015-02-01 00:23:26.000000', 'consum', 0.0217, 'lps'),
	(391066, 126, '2015-02-01 00:23:27.000000', 'consum', 0.0216, 'lps'),
	(391067, 126, '2015-02-01 00:23:28.000000', 'consum', 0.0216, 'lps'),
	(391068, 126, '2015-02-01 00:23:29.000000', 'consum', 0.0211, 'lps'),
	(391069, 126, '2015-02-01 00:23:30.000000', 'consum', 0.0211, 'lps'),
	(391070, 126, '2015-02-01 00:23:31.000000', 'consum', 0.0211, 'lps'),
	(391071, 126, '2015-02-01 00:23:32.000000', 'consum', 0.0213, 'lps'),
	(391072, 126, '2015-02-01 00:23:33.000000', 'consum', 0.0224, 'lps'),
	(391073, 126, '2015-02-01 00:23:34.000000', 'consum', 0.0211, 'lps'),
	(391074, 126, '2015-02-01 00:23:35.000000', 'consum', 0.0220, 'lps'),
	(391075, 126, '2015-02-01 00:23:36.000000', 'consum', 0.0213, 'lps'),
	(391076, 126, '2015-02-01 00:23:37.000000', 'consum', 0.0223, 'lps'),
	(391077, 126, '2015-02-01 00:23:38.000000', 'consum', 0.0221, 'lps'),
	(391078, 126, '2015-02-01 00:23:39.000000', 'consum', 0.0212, 'lps'),
	(391079, 126, '2015-02-01 00:23:40.000000', 'consum', 0.0217, 'lps'),
	(391080, 126, '2015-02-01 00:23:41.000000', 'consum', 0.0210, 'lps'),
	(391081, 126, '2015-02-01 00:23:42.000000', 'consum', 0.0219, 'lps'),
	(391082, 126, '2015-02-01 00:23:43.000000', 'consum', 0.0224, 'lps'),
	(391083, 126, '2015-02-01 00:23:44.000000', 'consum', 0.0224, 'lps'),
	(391084, 126, '2015-02-01 00:23:45.000000', 'consum', 0.0210, 'lps'),
	(391085, 126, '2015-02-01 00:23:46.000000', 'consum', 0.0214, 'lps'),
	(391086, 126, '2015-02-01 00:23:47.000000', 'consum', 0.0216, 'lps'),
	(391087, 126, '2015-02-01 00:23:48.000000', 'consum', 0.0215, 'lps'),
	(391088, 126, '2015-02-01 00:23:49.000000', 'consum', 0.0214, 'lps'),
	(391089, 126, '2015-02-01 00:23:50.000000', 'consum', 0.0219, 'lps'),
	(391090, 126, '2015-02-01 00:23:51.000000', 'consum', 0.0210, 'lps'),
	(391091, 126, '2015-02-01 00:23:52.000000', 'consum', 0.0217, 'lps'),
	(391092, 126, '2015-02-01 00:23:53.000000', 'consum', 0.0212, 'lps'),
	(391093, 126, '2015-02-01 00:23:54.000000', 'consum', 0.0216, 'lps'),
	(391094, 126, '2015-02-01 00:23:55.000000', 'consum', 0.0220, 'lps'),
	(391095, 126, '2015-02-01 00:23:56.000000', 'consum', 0.0212, 'lps'),
	(391096, 126, '2015-02-01 00:23:57.000000', 'consum', 0.0220, 'lps'),
	(391097, 126, '2015-02-01 00:23:58.000000', 'consum', 0.0224, 'lps'),
	(391098, 126, '2015-02-01 00:23:59.000000', 'consum', 0.0221, 'lps'),
	(391099, 126, '2015-02-01 00:24:00.000000', 'consum', 0.0210, 'lps'),
	(391100, 126, '2015-02-01 00:24:01.000000', 'consum', 0.0222, 'lps'),
	(391101, 126, '2015-02-01 00:24:02.000000', 'consum', 0.0210, 'lps'),
	(391102, 126, '2015-02-01 00:24:03.000000', 'consum', 0.0218, 'lps'),
	(391103, 126, '2015-02-01 00:24:04.000000', 'consum', 0.0223, 'lps'),
	(391104, 126, '2015-02-01 00:24:05.000000', 'consum', 0.0222, 'lps'),
	(391105, 126, '2015-02-01 00:24:06.000000', 'consum', 0.0216, 'lps'),
	(391106, 126, '2015-02-01 00:24:07.000000', 'consum', 0.0219, 'lps'),
	(391107, 126, '2015-02-01 00:24:08.000000', 'consum', 0.0222, 'lps'),
	(391108, 126, '2015-02-01 00:24:09.000000', 'consum', 0.0215, 'lps'),
	(391109, 126, '2015-02-01 00:24:10.000000', 'consum', 0.0215, 'lps'),
	(391110, 126, '2015-02-01 00:24:11.000000', 'consum', 0.0218, 'lps'),
	(391111, 126, '2015-02-01 00:24:12.000000', 'consum', 0.0223, 'lps'),
	(391112, 126, '2015-02-01 00:24:13.000000', 'consum', 0.0220, 'lps'),
	(391113, 126, '2015-02-01 00:24:14.000000', 'consum', 0.0223, 'lps'),
	(391114, 126, '2015-02-01 00:24:15.000000', 'consum', 0.0215, 'lps'),
	(391115, 126, '2015-02-01 00:24:16.000000', 'consum', 0.0213, 'lps'),
	(391116, 126, '2015-02-01 00:24:17.000000', 'consum', 0.0223, 'lps'),
	(391117, 126, '2015-02-01 00:24:18.000000', 'consum', 0.0223, 'lps'),
	(391118, 126, '2015-02-01 00:24:19.000000', 'consum', 0.0220, 'lps'),
	(391119, 126, '2015-02-01 00:24:20.000000', 'consum', 0.0221, 'lps'),
	(391120, 126, '2015-02-01 00:24:21.000000', 'consum', 0.0223, 'lps'),
	(391121, 126, '2015-02-01 00:24:22.000000', 'consum', 0.0210, 'lps'),
	(391122, 126, '2015-02-01 00:24:23.000000', 'consum', 0.0219, 'lps'),
	(391123, 126, '2015-02-01 00:24:24.000000', 'consum', 0.0211, 'lps'),
	(391124, 126, '2015-02-01 00:24:25.000000', 'consum', 0.0218, 'lps'),
	(391125, 126, '2015-02-01 00:24:26.000000', 'consum', 0.0217, 'lps'),
	(391126, 126, '2015-02-01 00:24:27.000000', 'consum', 0.0221, 'lps'),
	(391127, 126, '2015-02-01 00:24:28.000000', 'consum', 0.0216, 'lps'),
	(391128, 126, '2015-02-01 00:24:29.000000', 'consum', 0.0221, 'lps'),
	(391129, 126, '2015-02-01 00:24:30.000000', 'consum', 0.0216, 'lps'),
	(391130, 126, '2015-02-01 00:24:31.000000', 'consum', 0.0224, 'lps'),
	(391131, 126, '2015-02-01 00:24:32.000000', 'consum', 0.0217, 'lps'),
	(391132, 126, '2015-02-01 00:24:33.000000', 'consum', 0.0218, 'lps'),
	(391133, 126, '2015-02-01 00:24:34.000000', 'consum', 0.0217, 'lps'),
	(391134, 126, '2015-02-01 00:24:35.000000', 'consum', 0.0219, 'lps'),
	(391135, 126, '2015-02-01 00:24:36.000000', 'consum', 0.0218, 'lps'),
	(391136, 126, '2015-02-01 00:24:37.000000', 'consum', 0.0211, 'lps'),
	(391137, 126, '2015-02-01 00:24:38.000000', 'consum', 0.0221, 'lps'),
	(391138, 126, '2015-02-01 00:24:39.000000', 'consum', 0.0217, 'lps'),
	(391139, 126, '2015-02-01 00:24:40.000000', 'consum', 0.0211, 'lps'),
	(391140, 126, '2015-02-01 00:24:41.000000', 'consum', 0.0213, 'lps'),
	(391141, 126, '2015-02-01 00:24:42.000000', 'consum', 0.0219, 'lps'),
	(391142, 126, '2015-02-01 00:24:43.000000', 'consum', 0.0218, 'lps'),
	(391143, 126, '2015-02-01 00:24:44.000000', 'consum', 0.0222, 'lps'),
	(391144, 126, '2015-02-01 00:24:45.000000', 'consum', 0.0215, 'lps'),
	(391145, 126, '2015-02-01 00:24:46.000000', 'consum', 0.0218, 'lps'),
	(391146, 126, '2015-02-01 00:24:47.000000', 'consum', 0.0220, 'lps'),
	(391147, 126, '2015-02-01 00:24:48.000000', 'consum', 0.0221, 'lps'),
	(391148, 126, '2015-02-01 00:24:49.000000', 'consum', 0.0220, 'lps'),
	(391149, 126, '2015-02-01 00:24:50.000000', 'consum', 0.0211, 'lps'),
	(391150, 126, '2015-02-01 00:24:51.000000', 'consum', 0.0218, 'lps'),
	(391151, 126, '2015-02-01 00:24:52.000000', 'consum', 0.0219, 'lps'),
	(391152, 126, '2015-02-01 00:24:53.000000', 'consum', 0.0214, 'lps'),
	(391153, 126, '2015-02-01 00:24:54.000000', 'consum', 0.0219, 'lps'),
	(391154, 126, '2015-02-01 00:24:55.000000', 'consum', 0.0214, 'lps'),
	(391155, 126, '2015-02-01 00:24:56.000000', 'consum', 0.0217, 'lps'),
	(391156, 126, '2015-02-01 00:24:57.000000', 'consum', 0.0220, 'lps'),
	(391157, 126, '2015-02-01 00:24:58.000000', 'consum', 0.0224, 'lps'),
	(391158, 126, '2015-02-01 00:24:59.000000', 'consum', 0.0221, 'lps'),
	(391159, 126, '2015-02-01 00:25:00.000000', 'consum', 0.0210, 'lps'),
	(391160, 126, '2015-02-01 00:25:01.000000', 'consum', 0.0219, 'lps'),
	(391161, 126, '2015-02-01 00:25:02.000000', 'consum', 0.0214, 'lps'),
	(391162, 126, '2015-02-01 00:25:03.000000', 'consum', 0.0217, 'lps'),
	(391163, 126, '2015-02-01 00:25:04.000000', 'consum', 0.0218, 'lps'),
	(391164, 126, '2015-02-01 00:25:05.000000', 'consum', 0.0217, 'lps'),
	(391165, 126, '2015-02-01 00:25:06.000000', 'consum', 0.0219, 'lps'),
	(391166, 126, '2015-02-01 00:25:07.000000', 'consum', 0.0218, 'lps'),
	(391167, 126, '2015-02-01 00:25:08.000000', 'consum', 0.0211, 'lps'),
	(391168, 126, '2015-02-01 00:25:09.000000', 'consum', 0.0219, 'lps'),
	(391169, 126, '2015-02-01 00:25:10.000000', 'consum', 0.0210, 'lps'),
	(391170, 126, '2015-02-01 00:25:11.000000', 'consum', 0.0212, 'lps'),
	(391171, 126, '2015-02-01 00:25:12.000000', 'consum', 0.0222, 'lps'),
	(391172, 126, '2015-02-01 00:25:13.000000', 'consum', 0.0220, 'lps'),
	(391173, 126, '2015-02-01 00:25:14.000000', 'consum', 0.0222, 'lps'),
	(391174, 126, '2015-02-01 00:25:15.000000', 'consum', 0.0212, 'lps'),
	(391175, 126, '2015-02-01 00:25:16.000000', 'consum', 0.0216, 'lps'),
	(391176, 126, '2015-02-01 00:25:17.000000', 'consum', 0.0217, 'lps'),
	(391177, 126, '2015-02-01 00:25:18.000000', 'consum', 0.0213, 'lps'),
	(391178, 126, '2015-02-01 00:25:19.000000', 'consum', 0.0221, 'lps'),
	(391179, 126, '2015-02-01 00:25:20.000000', 'consum', 0.0224, 'lps'),
	(391180, 126, '2015-02-01 00:25:21.000000', 'consum', 0.0220, 'lps'),
	(391181, 126, '2015-02-01 00:25:22.000000', 'consum', 0.0217, 'lps'),
	(391182, 126, '2015-02-01 00:25:23.000000', 'consum', 0.0214, 'lps'),
	(391183, 126, '2015-02-01 00:25:24.000000', 'consum', 0.0211, 'lps'),
	(391184, 126, '2015-02-01 00:25:25.000000', 'consum', 0.0218, 'lps'),
	(391185, 126, '2015-02-01 00:25:26.000000', 'consum', 0.0218, 'lps'),
	(391186, 126, '2015-02-01 00:25:27.000000', 'consum', 0.0211, 'lps'),
	(391187, 126, '2015-02-01 00:25:28.000000', 'consum', 0.0221, 'lps'),
	(391188, 126, '2015-02-01 00:25:29.000000', 'consum', 0.0217, 'lps'),
	(391189, 126, '2015-02-01 00:25:30.000000', 'consum', 0.0212, 'lps'),
	(391190, 126, '2015-02-01 00:25:31.000000', 'consum', 0.0216, 'lps'),
	(391191, 126, '2015-02-01 00:25:32.000000', 'consum', 0.0219, 'lps'),
	(391192, 126, '2015-02-01 00:25:33.000000', 'consum', 0.0224, 'lps'),
	(391193, 126, '2015-02-01 00:25:34.000000', 'consum', 0.0221, 'lps'),
	(391194, 126, '2015-02-01 00:25:35.000000', 'consum', 0.0211, 'lps'),
	(391195, 126, '2015-02-01 00:25:36.000000', 'consum', 0.0210, 'lps'),
	(391196, 126, '2015-02-01 00:25:37.000000', 'consum', 0.0222, 'lps'),
	(391197, 126, '2015-02-01 00:25:38.000000', 'consum', 0.0212, 'lps'),
	(391198, 126, '2015-02-01 00:25:39.000000', 'consum', 0.0213, 'lps'),
	(391199, 126, '2015-02-01 00:25:40.000000', 'consum', 0.0222, 'lps'),
	(391200, 126, '2015-02-01 00:25:41.000000', 'consum', 0.0216, 'lps'),
	(391201, 126, '2015-02-01 00:25:42.000000', 'consum', 0.0218, 'lps'),
	(391202, 126, '2015-02-01 00:25:43.000000', 'consum', 0.0219, 'lps'),
	(391203, 126, '2015-02-01 00:25:44.000000', 'consum', 0.0215, 'lps'),
	(391204, 126, '2015-02-01 00:25:45.000000', 'consum', 0.0211, 'lps'),
	(391205, 126, '2015-02-01 00:25:46.000000', 'consum', 0.0213, 'lps'),
	(391206, 126, '2015-02-01 00:25:47.000000', 'consum', 0.0210, 'lps'),
	(391207, 126, '2015-02-01 00:25:48.000000', 'consum', 0.0216, 'lps'),
	(391208, 126, '2015-02-01 00:25:49.000000', 'consum', 0.0210, 'lps'),
	(391209, 126, '2015-02-01 00:25:50.000000', 'consum', 0.0223, 'lps'),
	(391210, 126, '2015-02-01 00:25:51.000000', 'consum', 0.0214, 'lps'),
	(391211, 126, '2015-02-01 00:25:52.000000', 'consum', 0.0223, 'lps'),
	(391212, 126, '2015-02-01 00:25:53.000000', 'consum', 0.0218, 'lps'),
	(391213, 126, '2015-02-01 00:25:54.000000', 'consum', 0.0211, 'lps'),
	(391214, 126, '2015-02-01 00:25:55.000000', 'consum', 0.0221, 'lps'),
	(391215, 126, '2015-02-01 00:25:56.000000', 'consum', 0.0219, 'lps'),
	(391216, 126, '2015-02-01 00:25:57.000000', 'consum', 0.0222, 'lps'),
	(391217, 126, '2015-02-01 00:25:58.000000', 'consum', 0.0214, 'lps'),
	(391218, 126, '2015-02-01 00:25:59.000000', 'consum', 0.0211, 'lps'),
	(391219, 126, '2015-02-01 00:26:00.000000', 'consum', 0.0216, 'lps'),
	(391220, 126, '2015-02-01 00:26:01.000000', 'consum', 0.0222, 'lps'),
	(391221, 126, '2015-02-01 00:26:02.000000', 'consum', 0.0224, 'lps'),
	(391222, 126, '2015-02-01 00:26:03.000000', 'consum', 0.0213, 'lps'),
	(391223, 126, '2015-02-01 00:26:04.000000', 'consum', 0.0212, 'lps'),
	(391224, 126, '2015-02-01 00:26:05.000000', 'consum', 0.0214, 'lps'),
	(391225, 126, '2015-02-01 00:26:06.000000', 'consum', 0.0211, 'lps'),
	(391226, 126, '2015-02-01 00:26:07.000000', 'consum', 0.0217, 'lps'),
	(391227, 126, '2015-02-01 00:26:08.000000', 'consum', 0.0212, 'lps'),
	(391228, 126, '2015-02-01 00:26:09.000000', 'consum', 0.0215, 'lps'),
	(391229, 126, '2015-02-01 00:26:10.000000', 'consum', 0.0213, 'lps'),
	(391230, 126, '2015-02-01 00:26:11.000000', 'consum', 0.0211, 'lps'),
	(391231, 126, '2015-02-01 00:26:12.000000', 'consum', 0.0220, 'lps'),
	(391232, 126, '2015-02-01 00:26:13.000000', 'consum', 0.0215, 'lps'),
	(391233, 126, '2015-02-01 00:26:14.000000', 'consum', 0.0220, 'lps'),
	(391234, 126, '2015-02-01 00:26:15.000000', 'consum', 0.0217, 'lps'),
	(391235, 126, '2015-02-01 00:26:16.000000', 'consum', 0.0214, 'lps'),
	(391236, 126, '2015-02-01 00:26:17.000000', 'consum', 0.0211, 'lps'),
	(391237, 126, '2015-02-01 00:26:18.000000', 'consum', 0.0220, 'lps'),
	(391238, 126, '2015-02-01 00:26:19.000000', 'consum', 0.0224, 'lps'),
	(391239, 126, '2015-02-01 00:26:20.000000', 'consum', 0.0222, 'lps'),
	(391240, 126, '2015-02-01 00:26:21.000000', 'consum', 0.0212, 'lps'),
	(391241, 126, '2015-02-01 00:26:22.000000', 'consum', 0.0216, 'lps'),
	(391242, 126, '2015-02-01 00:26:23.000000', 'consum', 0.0219, 'lps'),
	(391243, 126, '2015-02-01 00:26:24.000000', 'consum', 0.0224, 'lps'),
	(391244, 126, '2015-02-01 00:26:25.000000', 'consum', 0.0222, 'lps'),
	(391245, 126, '2015-02-01 00:26:26.000000', 'consum', 0.0212, 'lps'),
	(391246, 126, '2015-02-01 00:26:27.000000', 'consum', 0.0215, 'lps'),
	(391247, 126, '2015-02-01 00:26:28.000000', 'consum', 0.0215, 'lps'),
	(391248, 126, '2015-02-01 00:26:29.000000', 'consum', 0.0221, 'lps'),
	(391249, 126, '2015-02-01 00:26:30.000000', 'consum', 0.0221, 'lps'),
	(391250, 126, '2015-02-01 00:26:31.000000', 'consum', 0.0218, 'lps'),
	(391251, 126, '2015-02-01 00:26:32.000000', 'consum', 0.0216, 'lps'),
	(391252, 126, '2015-02-01 00:26:33.000000', 'consum', 0.0217, 'lps'),
	(391253, 126, '2015-02-01 00:26:34.000000', 'consum', 0.0214, 'lps'),
	(391254, 126, '2015-02-01 00:26:35.000000', 'consum', 0.0224, 'lps'),
	(391255, 126, '2015-02-01 00:26:36.000000', 'consum', 0.0224, 'lps'),
	(391256, 126, '2015-02-01 00:26:37.000000', 'consum', 0.0223, 'lps'),
	(391257, 126, '2015-02-01 00:26:38.000000', 'consum', 0.0220, 'lps'),
	(391258, 126, '2015-02-01 00:26:39.000000', 'consum', 0.0222, 'lps'),
	(391259, 126, '2015-02-01 00:26:40.000000', 'consum', 0.0211, 'lps'),
	(391260, 126, '2015-02-01 00:26:41.000000', 'consum', 0.0210, 'lps'),
	(391261, 126, '2015-02-01 00:26:42.000000', 'consum', 0.0221, 'lps'),
	(391262, 126, '2015-02-01 00:26:43.000000', 'consum', 0.0221, 'lps'),
	(391263, 126, '2015-02-01 00:26:44.000000', 'consum', 0.0216, 'lps'),
	(391264, 126, '2015-02-01 00:26:45.000000', 'consum', 0.0224, 'lps'),
	(391265, 126, '2015-02-01 00:26:46.000000', 'consum', 0.0215, 'lps'),
	(391266, 126, '2015-02-01 00:26:47.000000', 'consum', 0.0210, 'lps'),
	(391267, 126, '2015-02-01 00:26:48.000000', 'consum', 0.0213, 'lps'),
	(391268, 126, '2015-02-01 00:26:49.000000', 'consum', 0.0222, 'lps'),
	(391269, 126, '2015-02-01 00:26:50.000000', 'consum', 0.0217, 'lps'),
	(391270, 126, '2015-02-01 00:26:51.000000', 'consum', 0.0224, 'lps'),
	(391271, 126, '2015-02-01 00:26:52.000000', 'consum', 0.0214, 'lps'),
	(391272, 126, '2015-02-01 00:26:53.000000', 'consum', 0.0221, 'lps'),
	(391273, 126, '2015-02-01 00:26:54.000000', 'consum', 0.0222, 'lps'),
	(391274, 126, '2015-02-01 00:26:55.000000', 'consum', 0.0221, 'lps'),
	(391275, 126, '2015-02-01 00:26:56.000000', 'consum', 0.0217, 'lps'),
	(391276, 126, '2015-02-01 00:26:57.000000', 'consum', 0.0211, 'lps'),
	(391277, 126, '2015-02-01 00:26:58.000000', 'consum', 0.0211, 'lps'),
	(391278, 126, '2015-02-01 00:26:59.000000', 'consum', 0.0213, 'lps'),
	(391279, 126, '2015-02-01 00:27:00.000000', 'consum', 0.0221, 'lps'),
	(391280, 126, '2015-02-01 00:27:01.000000', 'consum', 0.0210, 'lps'),
	(391281, 126, '2015-02-01 00:27:02.000000', 'consum', 0.0224, 'lps'),
	(391282, 126, '2015-02-01 00:27:03.000000', 'consum', 0.0219, 'lps'),
	(391283, 126, '2015-02-01 00:27:04.000000', 'consum', 0.0214, 'lps'),
	(391284, 126, '2015-02-01 00:27:05.000000', 'consum', 0.0219, 'lps'),
	(391285, 126, '2015-02-01 00:27:06.000000', 'consum', 0.0212, 'lps'),
	(391286, 126, '2015-02-01 00:27:07.000000', 'consum', 0.0224, 'lps'),
	(391287, 126, '2015-02-01 00:27:08.000000', 'consum', 0.0214, 'lps'),
	(391288, 126, '2015-02-01 00:27:09.000000', 'consum', 0.0219, 'lps'),
	(391289, 126, '2015-02-01 00:27:10.000000', 'consum', 0.0213, 'lps'),
	(391290, 126, '2015-02-01 00:27:11.000000', 'consum', 0.0213, 'lps'),
	(391291, 126, '2015-02-01 00:27:12.000000', 'consum', 0.0215, 'lps'),
	(391292, 126, '2015-02-01 00:27:13.000000', 'consum', 0.0215, 'lps'),
	(391293, 126, '2015-02-01 00:27:14.000000', 'consum', 0.0219, 'lps'),
	(391294, 126, '2015-02-01 00:27:15.000000', 'consum', 0.0223, 'lps'),
	(391295, 126, '2015-02-01 00:27:16.000000', 'consum', 0.0222, 'lps'),
	(391296, 126, '2015-02-01 00:27:17.000000', 'consum', 0.0216, 'lps'),
	(391297, 126, '2015-02-01 00:27:18.000000', 'consum', 0.0217, 'lps'),
	(391298, 126, '2015-02-01 00:27:19.000000', 'consum', 0.0216, 'lps'),
	(391299, 126, '2015-02-01 00:27:20.000000', 'consum', 0.0217, 'lps'),
	(391300, 126, '2015-02-01 00:27:21.000000', 'consum', 0.0211, 'lps'),
	(391301, 126, '2015-02-01 00:27:22.000000', 'consum', 0.0212, 'lps'),
	(391302, 126, '2015-02-01 00:27:23.000000', 'consum', 0.0215, 'lps'),
	(391303, 126, '2015-02-01 00:27:24.000000', 'consum', 0.0217, 'lps'),
	(391304, 126, '2015-02-01 00:27:25.000000', 'consum', 0.0216, 'lps'),
	(391305, 126, '2015-02-01 00:27:26.000000', 'consum', 0.0219, 'lps'),
	(391306, 126, '2015-02-01 00:27:27.000000', 'consum', 0.0223, 'lps'),
	(391307, 126, '2015-02-01 00:27:28.000000', 'consum', 0.0219, 'lps'),
	(391308, 126, '2015-02-01 00:27:29.000000', 'consum', 0.0218, 'lps'),
	(391309, 126, '2015-02-01 00:27:30.000000', 'consum', 0.0220, 'lps'),
	(391310, 126, '2015-02-01 00:27:31.000000', 'consum', 0.0224, 'lps'),
	(391311, 126, '2015-02-01 00:27:32.000000', 'consum', 0.0222, 'lps'),
	(391312, 126, '2015-02-01 00:27:33.000000', 'consum', 0.0211, 'lps'),
	(391313, 126, '2015-02-01 00:27:34.000000', 'consum', 0.0224, 'lps'),
	(391314, 126, '2015-02-01 00:27:35.000000', 'consum', 0.0216, 'lps'),
	(391315, 126, '2015-02-01 00:27:36.000000', 'consum', 0.0217, 'lps'),
	(391316, 126, '2015-02-01 00:27:37.000000', 'consum', 0.0210, 'lps'),
	(391317, 126, '2015-02-01 00:27:38.000000', 'consum', 0.0222, 'lps'),
	(391318, 126, '2015-02-01 00:27:39.000000', 'consum', 0.0223, 'lps'),
	(391319, 126, '2015-02-01 00:27:40.000000', 'consum', 0.0224, 'lps'),
	(391320, 126, '2015-02-01 00:27:41.000000', 'consum', 0.0211, 'lps'),
	(391321, 126, '2015-02-01 00:27:42.000000', 'consum', 0.0218, 'lps'),
	(391322, 126, '2015-02-01 00:27:43.000000', 'consum', 0.0217, 'lps'),
	(391323, 126, '2015-02-01 00:27:44.000000', 'consum', 0.0221, 'lps'),
	(391324, 126, '2015-02-01 00:27:45.000000', 'consum', 0.0215, 'lps'),
	(391325, 126, '2015-02-01 00:27:46.000000', 'consum', 0.0218, 'lps'),
	(391326, 126, '2015-02-01 00:27:47.000000', 'consum', 0.0220, 'lps'),
	(391327, 126, '2015-02-01 00:27:48.000000', 'consum', 0.0223, 'lps'),
	(391328, 126, '2015-02-01 00:27:49.000000', 'consum', 0.0214, 'lps'),
	(391329, 126, '2015-02-01 00:27:50.000000', 'consum', 0.0222, 'lps'),
	(391330, 126, '2015-02-01 00:27:51.000000', 'consum', 0.0212, 'lps'),
	(391331, 126, '2015-02-01 00:27:52.000000', 'consum', 0.0216, 'lps'),
	(391332, 126, '2015-02-01 00:27:53.000000', 'consum', 0.0218, 'lps'),
	(391333, 126, '2015-02-01 00:27:54.000000', 'consum', 0.0220, 'lps'),
	(391334, 126, '2015-02-01 00:27:55.000000', 'consum', 0.0219, 'lps'),
	(391335, 126, '2015-02-01 00:27:56.000000', 'consum', 0.0212, 'lps'),
	(391336, 126, '2015-02-01 00:27:57.000000', 'consum', 0.0221, 'lps'),
	(391337, 126, '2015-02-01 00:27:58.000000', 'consum', 0.0217, 'lps'),
	(391338, 126, '2015-02-01 00:27:59.000000', 'consum', 0.0213, 'lps'),
	(391339, 126, '2015-02-01 00:28:00.000000', 'consum', 0.0219, 'lps'),
	(391340, 126, '2015-02-01 00:28:01.000000', 'consum', 0.0216, 'lps'),
	(391341, 126, '2015-02-01 00:28:02.000000', 'consum', 0.0213, 'lps'),
	(391342, 126, '2015-02-01 00:28:03.000000', 'consum', 0.0224, 'lps'),
	(391343, 126, '2015-02-01 00:28:04.000000', 'consum', 0.0212, 'lps'),
	(391344, 126, '2015-02-01 00:28:05.000000', 'consum', 0.0210, 'lps'),
	(391345, 126, '2015-02-01 00:28:06.000000', 'consum', 0.0216, 'lps'),
	(391346, 126, '2015-02-01 00:28:07.000000', 'consum', 0.0211, 'lps'),
	(391347, 126, '2015-02-01 00:28:08.000000', 'consum', 0.0213, 'lps'),
	(391348, 126, '2015-02-01 00:28:09.000000', 'consum', 0.0223, 'lps'),
	(391349, 126, '2015-02-01 00:28:10.000000', 'consum', 0.0221, 'lps'),
	(391350, 126, '2015-02-01 00:28:11.000000', 'consum', 0.0210, 'lps'),
	(391351, 126, '2015-02-01 00:28:12.000000', 'consum', 0.0223, 'lps'),
	(391352, 126, '2015-02-01 00:28:13.000000', 'consum', 0.0217, 'lps'),
	(391353, 126, '2015-02-01 00:28:14.000000', 'consum', 0.0222, 'lps'),
	(391354, 126, '2015-02-01 00:28:15.000000', 'consum', 0.0220, 'lps'),
	(391355, 126, '2015-02-01 00:28:16.000000', 'consum', 0.0223, 'lps'),
	(391356, 126, '2015-02-01 00:28:17.000000', 'consum', 0.0216, 'lps'),
	(391357, 126, '2015-02-01 00:28:18.000000', 'consum', 0.0216, 'lps'),
	(391358, 126, '2015-02-01 00:28:19.000000', 'consum', 0.0221, 'lps'),
	(391359, 126, '2015-02-01 00:28:20.000000', 'consum', 0.0217, 'lps'),
	(391360, 126, '2015-02-01 00:28:21.000000', 'consum', 0.0215, 'lps'),
	(391361, 126, '2015-02-01 00:28:22.000000', 'consum', 0.0213, 'lps'),
	(391362, 126, '2015-02-01 00:28:23.000000', 'consum', 0.0213, 'lps'),
	(391363, 126, '2015-02-01 00:28:24.000000', 'consum', 0.0215, 'lps'),
	(391364, 126, '2015-02-01 00:28:25.000000', 'consum', 0.0213, 'lps'),
	(391365, 126, '2015-02-01 00:28:26.000000', 'consum', 0.0223, 'lps'),
	(391366, 126, '2015-02-01 00:28:27.000000', 'consum', 0.0223, 'lps'),
	(391367, 126, '2015-02-01 00:28:28.000000', 'consum', 0.0219, 'lps'),
	(391368, 126, '2015-02-01 00:28:29.000000', 'consum', 0.0219, 'lps'),
	(391369, 126, '2015-02-01 00:28:30.000000', 'consum', 0.0211, 'lps'),
	(391370, 126, '2015-02-01 00:28:31.000000', 'consum', 0.0219, 'lps'),
	(391371, 126, '2015-02-01 00:28:32.000000', 'consum', 0.0221, 'lps'),
	(391372, 126, '2015-02-01 00:28:33.000000', 'consum', 0.0212, 'lps'),
	(391373, 126, '2015-02-01 00:28:34.000000', 'consum', 0.0216, 'lps'),
	(391374, 126, '2015-02-01 00:28:35.000000', 'consum', 0.0219, 'lps'),
	(391375, 126, '2015-02-01 00:28:36.000000', 'consum', 0.0223, 'lps'),
	(391376, 126, '2015-02-01 00:28:37.000000', 'consum', 0.0218, 'lps'),
	(391377, 126, '2015-02-01 00:28:38.000000', 'consum', 0.0210, 'lps'),
	(391378, 126, '2015-02-01 00:28:39.000000', 'consum', 0.0220, 'lps'),
	(391379, 126, '2015-02-01 00:28:40.000000', 'consum', 0.0213, 'lps'),
	(391380, 126, '2015-02-01 00:28:41.000000', 'consum', 0.0224, 'lps'),
	(391381, 126, '2015-02-01 00:28:42.000000', 'consum', 0.0215, 'lps'),
	(391382, 126, '2015-02-01 00:28:43.000000', 'consum', 0.0222, 'lps'),
	(391383, 126, '2015-02-01 00:28:44.000000', 'consum', 0.0210, 'lps'),
	(391384, 126, '2015-02-01 00:28:45.000000', 'consum', 0.0219, 'lps'),
	(391385, 126, '2015-02-01 00:28:46.000000', 'consum', 0.0211, 'lps'),
	(391386, 126, '2015-02-01 00:28:47.000000', 'consum', 0.0220, 'lps'),
	(391387, 126, '2015-02-01 00:28:48.000000', 'consum', 0.0210, 'lps'),
	(391388, 126, '2015-02-01 00:28:49.000000', 'consum', 0.0212, 'lps'),
	(391389, 126, '2015-02-01 00:28:50.000000', 'consum', 0.0218, 'lps'),
	(391390, 126, '2015-02-01 00:28:51.000000', 'consum', 0.0218, 'lps'),
	(391391, 126, '2015-02-01 00:28:52.000000', 'consum', 0.0223, 'lps'),
	(391392, 126, '2015-02-01 00:28:53.000000', 'consum', 0.0224, 'lps'),
	(391393, 126, '2015-02-01 00:28:54.000000', 'consum', 0.0210, 'lps'),
	(391394, 126, '2015-02-01 00:28:55.000000', 'consum', 0.0213, 'lps'),
	(391395, 126, '2015-02-01 00:28:56.000000', 'consum', 0.0213, 'lps'),
	(391396, 126, '2015-02-01 00:28:57.000000', 'consum', 0.0217, 'lps'),
	(391397, 126, '2015-02-01 00:28:58.000000', 'consum', 0.0218, 'lps'),
	(391398, 126, '2015-02-01 00:28:59.000000', 'consum', 0.0218, 'lps'),
	(391399, 126, '2015-02-01 00:29:00.000000', 'consum', 0.0224, 'lps'),
	(391400, 126, '2015-02-01 00:29:01.000000', 'consum', 0.0214, 'lps'),
	(391401, 126, '2015-02-01 00:29:02.000000', 'consum', 0.0218, 'lps'),
	(391402, 126, '2015-02-01 00:29:03.000000', 'consum', 0.0223, 'lps'),
	(391403, 126, '2015-02-01 00:29:04.000000', 'consum', 0.0224, 'lps'),
	(391404, 126, '2015-02-01 00:29:05.000000', 'consum', 0.0223, 'lps'),
	(391405, 126, '2015-02-01 00:29:06.000000', 'consum', 0.0221, 'lps'),
	(391406, 126, '2015-02-01 00:29:07.000000', 'consum', 0.0211, 'lps'),
	(391407, 126, '2015-02-01 00:29:08.000000', 'consum', 0.0213, 'lps'),
	(391408, 126, '2015-02-01 00:29:09.000000', 'consum', 0.0221, 'lps'),
	(391409, 126, '2015-02-01 00:29:10.000000', 'consum', 0.0211, 'lps'),
	(391410, 126, '2015-02-01 00:29:11.000000', 'consum', 0.0213, 'lps'),
	(391411, 126, '2015-02-01 00:29:12.000000', 'consum', 0.0224, 'lps'),
	(391412, 126, '2015-02-01 00:29:13.000000', 'consum', 0.0212, 'lps'),
	(391413, 126, '2015-02-01 00:29:14.000000', 'consum', 0.0222, 'lps'),
	(391414, 126, '2015-02-01 00:29:15.000000', 'consum', 0.0219, 'lps'),
	(391415, 126, '2015-02-01 00:29:16.000000', 'consum', 0.0219, 'lps'),
	(391416, 126, '2015-02-01 00:29:17.000000', 'consum', 0.0214, 'lps'),
	(391417, 126, '2015-02-01 00:29:18.000000', 'consum', 0.0219, 'lps'),
	(391418, 126, '2015-02-01 00:29:19.000000', 'consum', 0.0211, 'lps'),
	(391419, 126, '2015-02-01 00:29:20.000000', 'consum', 0.0222, 'lps'),
	(391420, 126, '2015-02-01 00:29:21.000000', 'consum', 0.0222, 'lps'),
	(391421, 126, '2015-02-01 00:29:22.000000', 'consum', 0.0219, 'lps'),
	(391422, 126, '2015-02-01 00:29:23.000000', 'consum', 0.0218, 'lps'),
	(391423, 126, '2015-02-01 00:29:24.000000', 'consum', 0.0222, 'lps'),
	(391424, 126, '2015-02-01 00:29:25.000000', 'consum', 0.0220, 'lps'),
	(391425, 126, '2015-02-01 00:29:26.000000', 'consum', 0.0210, 'lps'),
	(391426, 126, '2015-02-01 00:29:27.000000', 'consum', 0.0223, 'lps'),
	(391427, 126, '2015-02-01 00:29:28.000000', 'consum', 0.0216, 'lps'),
	(391428, 126, '2015-02-01 00:29:29.000000', 'consum', 0.0217, 'lps'),
	(391429, 126, '2015-02-01 00:29:30.000000', 'consum', 0.0214, 'lps'),
	(391430, 126, '2015-02-01 00:29:31.000000', 'consum', 0.0224, 'lps'),
	(391431, 126, '2015-02-01 00:29:32.000000', 'consum', 0.0210, 'lps'),
	(391432, 126, '2015-02-01 00:29:33.000000', 'consum', 0.0211, 'lps'),
	(391433, 126, '2015-02-01 00:29:34.000000', 'consum', 0.0216, 'lps'),
	(391434, 126, '2015-02-01 00:29:35.000000', 'consum', 0.0221, 'lps'),
	(391435, 126, '2015-02-01 00:29:36.000000', 'consum', 0.0217, 'lps'),
	(391436, 126, '2015-02-01 00:29:37.000000', 'consum', 0.0214, 'lps'),
	(391437, 126, '2015-02-01 00:29:38.000000', 'consum', 0.0223, 'lps'),
	(391438, 126, '2015-02-01 00:29:39.000000', 'consum', 0.0221, 'lps'),
	(391439, 126, '2015-02-01 00:29:40.000000', 'consum', 0.0210, 'lps'),
	(391440, 126, '2015-02-01 00:29:41.000000', 'consum', 0.0224, 'lps'),
	(391441, 126, '2015-02-01 00:29:42.000000', 'consum', 0.0219, 'lps'),
	(391442, 126, '2015-02-01 00:29:43.000000', 'consum', 0.0215, 'lps'),
	(391443, 126, '2015-02-01 00:29:44.000000', 'consum', 0.0223, 'lps'),
	(391444, 126, '2015-02-01 00:29:45.000000', 'consum', 0.0213, 'lps'),
	(391445, 126, '2015-02-01 00:29:46.000000', 'consum', 0.0220, 'lps'),
	(391446, 126, '2015-02-01 00:29:47.000000', 'consum', 0.0218, 'lps'),
	(391447, 126, '2015-02-01 00:29:48.000000', 'consum', 0.0224, 'lps'),
	(391448, 126, '2015-02-01 00:29:49.000000', 'consum', 0.0211, 'lps'),
	(391449, 126, '2015-02-01 00:29:50.000000', 'consum', 0.0217, 'lps'),
	(391450, 126, '2015-02-01 00:29:51.000000', 'consum', 0.0214, 'lps'),
	(391451, 126, '2015-02-01 00:29:52.000000', 'consum', 0.0210, 'lps'),
	(391452, 126, '2015-02-01 00:29:53.000000', 'consum', 0.0213, 'lps'),
	(391453, 126, '2015-02-01 00:29:54.000000', 'consum', 0.0210, 'lps'),
	(391454, 126, '2015-02-01 00:29:55.000000', 'consum', 0.0218, 'lps'),
	(391455, 126, '2015-02-01 00:29:56.000000', 'consum', 0.0221, 'lps'),
	(391456, 126, '2015-02-01 00:29:57.000000', 'consum', 0.0211, 'lps'),
	(391457, 126, '2015-02-01 00:29:58.000000', 'consum', 0.0211, 'lps'),
	(391458, 126, '2015-02-01 00:29:59.000000', 'consum', 0.0212, 'lps'),
	(391459, 126, '2015-02-01 00:30:00.000000', 'consum', 0.0217, 'lps'),
	(391460, 126, '2015-02-01 00:30:01.000000', 'consum', 0.0213, 'lps'),
	(391461, 126, '2015-02-01 00:30:02.000000', 'consum', 0.0216, 'lps'),
	(391462, 126, '2015-02-01 00:30:03.000000', 'consum', 0.0217, 'lps'),
	(391463, 126, '2015-02-01 00:30:04.000000', 'consum', 0.0213, 'lps'),
	(391464, 126, '2015-02-01 00:30:05.000000', 'consum', 0.0218, 'lps'),
	(391465, 126, '2015-02-01 00:30:06.000000', 'consum', 0.0214, 'lps'),
	(391466, 126, '2015-02-01 00:30:07.000000', 'consum', 0.0220, 'lps'),
	(391467, 126, '2015-02-01 00:30:08.000000', 'consum', 0.0219, 'lps'),
	(391468, 126, '2015-02-01 00:30:09.000000', 'consum', 0.0212, 'lps'),
	(391469, 126, '2015-02-01 00:30:10.000000', 'consum', 0.0221, 'lps'),
	(391470, 126, '2015-02-01 00:30:11.000000', 'consum', 0.0216, 'lps'),
	(391471, 126, '2015-02-01 00:30:12.000000', 'consum', 0.0221, 'lps'),
	(391472, 126, '2015-02-01 00:30:13.000000', 'consum', 0.0218, 'lps'),
	(391473, 126, '2015-02-01 00:30:14.000000', 'consum', 0.0217, 'lps'),
	(391474, 126, '2015-02-01 00:30:15.000000', 'consum', 0.0221, 'lps'),
	(391475, 126, '2015-02-01 00:30:16.000000', 'consum', 0.0215, 'lps'),
	(391476, 126, '2015-02-01 00:30:17.000000', 'consum', 0.0218, 'lps'),
	(391477, 126, '2015-02-01 00:30:18.000000', 'consum', 0.0219, 'lps'),
	(391478, 126, '2015-02-01 00:30:19.000000', 'consum', 0.0218, 'lps'),
	(391479, 126, '2015-02-01 00:30:20.000000', 'consum', 0.0223, 'lps'),
	(391480, 126, '2015-02-01 00:30:21.000000', 'consum', 0.0221, 'lps'),
	(391481, 126, '2015-02-01 00:30:22.000000', 'consum', 0.0214, 'lps'),
	(391482, 126, '2015-02-01 00:30:23.000000', 'consum', 0.0224, 'lps'),
	(391483, 126, '2015-02-01 00:30:24.000000', 'consum', 0.0210, 'lps'),
	(391484, 126, '2015-02-01 00:30:25.000000', 'consum', 0.0215, 'lps'),
	(391485, 126, '2015-02-01 00:30:26.000000', 'consum', 0.0218, 'lps'),
	(391486, 126, '2015-02-01 00:30:27.000000', 'consum', 0.0224, 'lps'),
	(391487, 126, '2015-02-01 00:30:28.000000', 'consum', 0.0223, 'lps'),
	(391488, 126, '2015-02-01 00:30:29.000000', 'consum', 0.0219, 'lps'),
	(391489, 126, '2015-02-01 00:30:30.000000', 'consum', 0.0217, 'lps'),
	(391490, 126, '2015-02-01 00:30:31.000000', 'consum', 0.0220, 'lps'),
	(391491, 126, '2015-02-01 00:30:32.000000', 'consum', 0.0222, 'lps'),
	(391492, 126, '2015-02-01 00:30:33.000000', 'consum', 0.0212, 'lps'),
	(391493, 126, '2015-02-01 00:30:34.000000', 'consum', 0.0216, 'lps'),
	(391494, 126, '2015-02-01 00:30:35.000000', 'consum', 0.0218, 'lps'),
	(391495, 126, '2015-02-01 00:30:36.000000', 'consum', 0.0216, 'lps'),
	(391496, 126, '2015-02-01 00:30:37.000000', 'consum', 0.0218, 'lps'),
	(391497, 126, '2015-02-01 00:30:38.000000', 'consum', 0.0216, 'lps'),
	(391498, 126, '2015-02-01 00:30:39.000000', 'consum', 0.0217, 'lps'),
	(391499, 126, '2015-02-01 00:30:40.000000', 'consum', 0.0211, 'lps'),
	(391500, 126, '2015-02-01 00:30:41.000000', 'consum', 0.0212, 'lps'),
	(391501, 126, '2015-02-01 00:30:42.000000', 'consum', 0.0216, 'lps'),
	(391502, 126, '2015-02-01 00:30:43.000000', 'consum', 0.0219, 'lps'),
	(391503, 126, '2015-02-01 00:30:44.000000', 'consum', 0.0210, 'lps'),
	(391504, 126, '2015-02-01 00:30:45.000000', 'consum', 0.0213, 'lps'),
	(391505, 126, '2015-02-01 00:30:46.000000', 'consum', 0.0211, 'lps'),
	(391506, 126, '2015-02-01 00:30:47.000000', 'consum', 0.0222, 'lps'),
	(391507, 126, '2015-02-01 00:30:48.000000', 'consum', 0.0221, 'lps'),
	(391508, 126, '2015-02-01 00:30:49.000000', 'consum', 0.0215, 'lps'),
	(391509, 126, '2015-02-01 00:30:50.000000', 'consum', 0.0219, 'lps'),
	(391510, 126, '2015-02-01 00:30:51.000000', 'consum', 0.0211, 'lps'),
	(391511, 126, '2015-02-01 00:30:52.000000', 'consum', 0.0217, 'lps'),
	(391512, 126, '2015-02-01 00:30:53.000000', 'consum', 0.0214, 'lps'),
	(391513, 126, '2015-02-01 00:30:54.000000', 'consum', 0.0210, 'lps'),
	(391514, 126, '2015-02-01 00:30:55.000000', 'consum', 0.0214, 'lps'),
	(391515, 126, '2015-02-01 00:30:56.000000', 'consum', 0.0212, 'lps'),
	(391516, 126, '2015-02-01 00:30:57.000000', 'consum', 0.0212, 'lps'),
	(391517, 126, '2015-02-01 00:30:58.000000', 'consum', 0.0214, 'lps'),
	(391518, 126, '2015-02-01 00:30:59.000000', 'consum', 0.0224, 'lps'),
	(391519, 126, '2015-02-01 00:31:00.000000', 'consum', 0.0223, 'lps'),
	(391520, 126, '2015-02-01 00:31:01.000000', 'consum', 0.0221, 'lps'),
	(391521, 126, '2015-02-01 00:31:02.000000', 'consum', 0.0224, 'lps'),
	(391522, 126, '2015-02-01 00:31:03.000000', 'consum', 0.0220, 'lps'),
	(391523, 126, '2015-02-01 00:31:04.000000', 'consum', 0.0215, 'lps'),
	(391524, 126, '2015-02-01 00:31:05.000000', 'consum', 0.0224, 'lps'),
	(391525, 126, '2015-02-01 00:31:06.000000', 'consum', 0.0217, 'lps'),
	(391526, 126, '2015-02-01 00:31:07.000000', 'consum', 0.0221, 'lps'),
	(391527, 126, '2015-02-01 00:31:08.000000', 'consum', 0.0216, 'lps'),
	(391528, 126, '2015-02-01 00:31:09.000000', 'consum', 0.0220, 'lps'),
	(391529, 126, '2015-02-01 00:31:10.000000', 'consum', 0.0211, 'lps'),
	(391530, 126, '2015-02-01 00:31:11.000000', 'consum', 0.0219, 'lps'),
	(391531, 126, '2015-02-01 00:31:12.000000', 'consum', 0.0220, 'lps'),
	(391532, 126, '2015-02-01 00:31:13.000000', 'consum', 0.0220, 'lps'),
	(391533, 126, '2015-02-01 00:31:14.000000', 'consum', 0.0215, 'lps'),
	(391534, 126, '2015-02-01 00:31:15.000000', 'consum', 0.0221, 'lps'),
	(391535, 126, '2015-02-01 00:31:16.000000', 'consum', 0.0222, 'lps'),
	(391536, 126, '2015-02-01 00:31:17.000000', 'consum', 0.0219, 'lps'),
	(391537, 126, '2015-02-01 00:31:18.000000', 'consum', 0.0222, 'lps'),
	(391538, 126, '2015-02-01 00:31:19.000000', 'consum', 0.0213, 'lps'),
	(391539, 126, '2015-02-01 00:31:20.000000', 'consum', 0.0220, 'lps'),
	(391540, 126, '2015-02-01 00:31:21.000000', 'consum', 0.0222, 'lps'),
	(391541, 126, '2015-02-01 00:31:22.000000', 'consum', 0.0211, 'lps'),
	(391542, 126, '2015-02-01 00:31:23.000000', 'consum', 0.0223, 'lps'),
	(391543, 126, '2015-02-01 00:31:24.000000', 'consum', 0.0212, 'lps'),
	(391544, 126, '2015-02-01 00:31:25.000000', 'consum', 0.0214, 'lps'),
	(391545, 126, '2015-02-01 00:31:26.000000', 'consum', 0.0223, 'lps'),
	(391546, 126, '2015-02-01 00:31:27.000000', 'consum', 0.0218, 'lps'),
	(391547, 126, '2015-02-01 00:31:28.000000', 'consum', 0.0213, 'lps'),
	(391548, 126, '2015-02-01 00:31:29.000000', 'consum', 0.0215, 'lps'),
	(391549, 126, '2015-02-01 00:31:30.000000', 'consum', 0.0213, 'lps'),
	(391550, 126, '2015-02-01 00:31:31.000000', 'consum', 0.0211, 'lps'),
	(391551, 126, '2015-02-01 00:31:32.000000', 'consum', 0.0220, 'lps'),
	(391552, 126, '2015-02-01 00:31:33.000000', 'consum', 0.0213, 'lps'),
	(391553, 126, '2015-02-01 00:31:34.000000', 'consum', 0.0224, 'lps'),
	(391554, 126, '2015-02-01 00:31:35.000000', 'consum', 0.0212, 'lps'),
	(391555, 126, '2015-02-01 00:31:36.000000', 'consum', 0.0223, 'lps'),
	(391556, 126, '2015-02-01 00:31:37.000000', 'consum', 0.0211, 'lps'),
	(391557, 126, '2015-02-01 00:31:38.000000', 'consum', 0.0221, 'lps'),
	(391558, 126, '2015-02-01 00:31:39.000000', 'consum', 0.0219, 'lps'),
	(391559, 126, '2015-02-01 00:31:40.000000', 'consum', 0.0220, 'lps'),
	(391560, 126, '2015-02-01 00:31:41.000000', 'consum', 0.0218, 'lps'),
	(391561, 126, '2015-02-01 00:31:42.000000', 'consum', 0.0221, 'lps'),
	(391562, 126, '2015-02-01 00:31:43.000000', 'consum', 0.0211, 'lps'),
	(391563, 126, '2015-02-01 00:31:44.000000', 'consum', 0.0211, 'lps'),
	(391564, 126, '2015-02-01 00:31:45.000000', 'consum', 0.0215, 'lps'),
	(391565, 126, '2015-02-01 00:31:46.000000', 'consum', 0.0219, 'lps'),
	(391566, 126, '2015-02-01 00:31:47.000000', 'consum', 0.0222, 'lps'),
	(391567, 126, '2015-02-01 00:31:48.000000', 'consum', 0.0215, 'lps'),
	(391568, 126, '2015-02-01 00:31:49.000000', 'consum', 0.0215, 'lps'),
	(391569, 126, '2015-02-01 00:31:50.000000', 'consum', 0.0219, 'lps'),
	(391570, 126, '2015-02-01 00:31:51.000000', 'consum', 0.0213, 'lps'),
	(391571, 126, '2015-02-01 00:31:52.000000', 'consum', 0.0211, 'lps'),
	(391572, 126, '2015-02-01 00:31:53.000000', 'consum', 0.0221, 'lps'),
	(391573, 126, '2015-02-01 00:31:54.000000', 'consum', 0.0219, 'lps'),
	(391574, 126, '2015-02-01 00:31:55.000000', 'consum', 0.0220, 'lps'),
	(391575, 126, '2015-02-01 00:31:56.000000', 'consum', 0.0221, 'lps'),
	(391576, 126, '2015-02-01 00:31:57.000000', 'consum', 0.0220, 'lps'),
	(391577, 126, '2015-02-01 00:31:58.000000', 'consum', 0.0213, 'lps'),
	(391578, 126, '2015-02-01 00:31:59.000000', 'consum', 0.0211, 'lps'),
	(391579, 126, '2015-02-01 00:32:00.000000', 'consum', 0.0221, 'lps'),
	(391580, 126, '2015-02-01 00:32:01.000000', 'consum', 0.0219, 'lps'),
	(391581, 126, '2015-02-01 00:32:02.000000', 'consum', 0.0222, 'lps'),
	(391582, 126, '2015-02-01 00:32:03.000000', 'consum', 0.0215, 'lps'),
	(391583, 126, '2015-02-01 00:32:04.000000', 'consum', 0.0214, 'lps'),
	(391584, 126, '2015-02-01 00:32:05.000000', 'consum', 0.0214, 'lps'),
	(391585, 126, '2015-02-01 00:32:06.000000', 'consum', 0.0220, 'lps'),
	(391586, 126, '2015-02-01 00:32:07.000000', 'consum', 0.0216, 'lps'),
	(391587, 126, '2015-02-01 00:32:08.000000', 'consum', 0.0214, 'lps'),
	(391588, 126, '2015-02-01 00:32:09.000000', 'consum', 0.0224, 'lps'),
	(391589, 126, '2015-02-01 00:32:10.000000', 'consum', 0.0224, 'lps'),
	(391590, 126, '2015-02-01 00:32:11.000000', 'consum', 0.0210, 'lps'),
	(391591, 126, '2015-02-01 00:32:12.000000', 'consum', 0.0215, 'lps'),
	(391592, 126, '2015-02-01 00:32:13.000000', 'consum', 0.0219, 'lps'),
	(391593, 126, '2015-02-01 00:32:14.000000', 'consum', 0.0210, 'lps'),
	(391594, 126, '2015-02-01 00:32:15.000000', 'consum', 0.0212, 'lps'),
	(391595, 126, '2015-02-01 00:32:16.000000', 'consum', 0.0221, 'lps'),
	(391596, 126, '2015-02-01 00:32:17.000000', 'consum', 0.0217, 'lps'),
	(391597, 126, '2015-02-01 00:32:18.000000', 'consum', 0.0224, 'lps'),
	(391598, 126, '2015-02-01 00:32:19.000000', 'consum', 0.0218, 'lps'),
	(391599, 126, '2015-02-01 00:32:20.000000', 'consum', 0.0220, 'lps'),
	(391600, 126, '2015-02-01 00:32:21.000000', 'consum', 0.0224, 'lps'),
	(391601, 126, '2015-02-01 00:32:22.000000', 'consum', 0.0219, 'lps'),
	(391602, 126, '2015-02-01 00:32:23.000000', 'consum', 0.0213, 'lps'),
	(391603, 126, '2015-02-01 00:32:24.000000', 'consum', 0.0212, 'lps'),
	(391604, 126, '2015-02-01 00:32:25.000000', 'consum', 0.0214, 'lps'),
	(391605, 126, '2015-02-01 00:32:26.000000', 'consum', 0.0224, 'lps'),
	(391606, 126, '2015-02-01 00:32:27.000000', 'consum', 0.0224, 'lps'),
	(391607, 126, '2015-02-01 00:32:28.000000', 'consum', 0.0222, 'lps'),
	(391608, 126, '2015-02-01 00:32:29.000000', 'consum', 0.0216, 'lps'),
	(391609, 126, '2015-02-01 00:32:30.000000', 'consum', 0.0217, 'lps'),
	(391610, 126, '2015-02-01 00:32:31.000000', 'consum', 0.0213, 'lps'),
	(391611, 126, '2015-02-01 00:32:32.000000', 'consum', 0.0220, 'lps'),
	(391612, 126, '2015-02-01 00:32:33.000000', 'consum', 0.0223, 'lps'),
	(391613, 126, '2015-02-01 00:32:34.000000', 'consum', 0.0216, 'lps'),
	(391614, 126, '2015-02-01 00:32:35.000000', 'consum', 0.0214, 'lps'),
	(391615, 126, '2015-02-01 00:32:36.000000', 'consum', 0.0215, 'lps'),
	(391616, 126, '2015-02-01 00:32:37.000000', 'consum', 0.0221, 'lps'),
	(391617, 126, '2015-02-01 00:32:38.000000', 'consum', 0.0222, 'lps'),
	(391618, 126, '2015-02-01 00:32:39.000000', 'consum', 0.0223, 'lps'),
	(391619, 126, '2015-02-01 00:32:40.000000', 'consum', 0.0223, 'lps'),
	(391620, 126, '2015-02-01 00:32:41.000000', 'consum', 0.0224, 'lps'),
	(391621, 126, '2015-02-01 00:32:42.000000', 'consum', 0.0211, 'lps'),
	(391622, 126, '2015-02-01 00:32:43.000000', 'consum', 0.0220, 'lps'),
	(391623, 126, '2015-02-01 00:32:44.000000', 'consum', 0.0224, 'lps'),
	(391624, 126, '2015-02-01 00:32:45.000000', 'consum', 0.0224, 'lps'),
	(391625, 126, '2015-02-01 00:32:46.000000', 'consum', 0.0221, 'lps'),
	(391626, 126, '2015-02-01 00:32:47.000000', 'consum', 0.0211, 'lps'),
	(391627, 126, '2015-02-01 00:32:48.000000', 'consum', 0.0211, 'lps'),
	(391628, 126, '2015-02-01 00:32:49.000000', 'consum', 0.0211, 'lps'),
	(391629, 126, '2015-02-01 00:32:50.000000', 'consum', 0.0215, 'lps'),
	(391630, 126, '2015-02-01 00:32:51.000000', 'consum', 0.0215, 'lps'),
	(391631, 126, '2015-02-01 00:32:52.000000', 'consum', 0.0222, 'lps'),
	(391632, 126, '2015-02-01 00:32:53.000000', 'consum', 0.0224, 'lps'),
	(391633, 126, '2015-02-01 00:32:54.000000', 'consum', 0.0213, 'lps'),
	(391634, 126, '2015-02-01 00:32:55.000000', 'consum', 0.0217, 'lps'),
	(391635, 126, '2015-02-01 00:32:56.000000', 'consum', 0.0221, 'lps'),
	(391636, 126, '2015-02-01 00:32:57.000000', 'consum', 0.0214, 'lps'),
	(391637, 126, '2015-02-01 00:32:58.000000', 'consum', 0.0213, 'lps'),
	(391638, 126, '2015-02-01 00:32:59.000000', 'consum', 0.0213, 'lps'),
	(391639, 126, '2015-02-01 00:33:00.000000', 'consum', 0.0215, 'lps'),
	(391640, 126, '2015-02-01 00:33:01.000000', 'consum', 0.0215, 'lps'),
	(391641, 126, '2015-02-01 00:33:02.000000', 'consum', 0.0217, 'lps'),
	(391642, 126, '2015-02-01 00:33:03.000000', 'consum', 0.0218, 'lps'),
	(391643, 126, '2015-02-01 00:33:04.000000', 'consum', 0.0213, 'lps'),
	(391644, 126, '2015-02-01 00:33:05.000000', 'consum', 0.0216, 'lps'),
	(391645, 126, '2015-02-01 00:33:06.000000', 'consum', 0.0217, 'lps'),
	(391646, 126, '2015-02-01 00:33:07.000000', 'consum', 0.0210, 'lps'),
	(391647, 126, '2015-02-01 00:33:08.000000', 'consum', 0.0223, 'lps'),
	(391648, 126, '2015-02-01 00:33:09.000000', 'consum', 0.0216, 'lps'),
	(391649, 126, '2015-02-01 00:33:10.000000', 'consum', 0.0216, 'lps'),
	(391650, 126, '2015-02-01 00:33:11.000000', 'consum', 0.0221, 'lps'),
	(391651, 126, '2015-02-01 00:33:12.000000', 'consum', 0.0220, 'lps'),
	(391652, 126, '2015-02-01 00:33:13.000000', 'consum', 0.0212, 'lps'),
	(391653, 126, '2015-02-01 00:33:14.000000', 'consum', 0.0220, 'lps'),
	(391654, 126, '2015-02-01 00:33:15.000000', 'consum', 0.0223, 'lps'),
	(391655, 126, '2015-02-01 00:33:16.000000', 'consum', 0.0216, 'lps'),
	(391656, 126, '2015-02-01 00:33:17.000000', 'consum', 0.0216, 'lps'),
	(391657, 126, '2015-02-01 00:33:18.000000', 'consum', 0.0223, 'lps'),
	(391658, 126, '2015-02-01 00:33:19.000000', 'consum', 0.0212, 'lps'),
	(391659, 126, '2015-02-01 00:33:20.000000', 'consum', 0.0213, 'lps'),
	(391660, 126, '2015-02-01 00:33:21.000000', 'consum', 0.0219, 'lps'),
	(391661, 126, '2015-02-01 00:33:22.000000', 'consum', 0.0217, 'lps'),
	(391662, 126, '2015-02-01 00:33:23.000000', 'consum', 0.0217, 'lps'),
	(391663, 126, '2015-02-01 00:33:24.000000', 'consum', 0.0210, 'lps'),
	(391664, 126, '2015-02-01 00:33:25.000000', 'consum', 0.0220, 'lps'),
	(391665, 126, '2015-02-01 00:33:26.000000', 'consum', 0.0216, 'lps'),
	(391666, 126, '2015-02-01 00:33:27.000000', 'consum', 0.0212, 'lps'),
	(391667, 126, '2015-02-01 00:33:28.000000', 'consum', 0.0215, 'lps'),
	(391668, 126, '2015-02-01 00:33:29.000000', 'consum', 0.0217, 'lps'),
	(391669, 126, '2015-02-01 00:33:30.000000', 'consum', 0.0213, 'lps'),
	(391670, 126, '2015-02-01 00:33:31.000000', 'consum', 0.0222, 'lps'),
	(391671, 126, '2015-02-01 00:33:32.000000', 'consum', 0.0216, 'lps'),
	(391672, 126, '2015-02-01 00:33:33.000000', 'consum', 0.0220, 'lps'),
	(391673, 126, '2015-02-01 00:33:34.000000', 'consum', 0.0213, 'lps'),
	(391674, 126, '2015-02-01 00:33:35.000000', 'consum', 0.0224, 'lps'),
	(391675, 126, '2015-02-01 00:33:36.000000', 'consum', 0.0212, 'lps'),
	(391676, 126, '2015-02-01 00:33:37.000000', 'consum', 0.0222, 'lps'),
	(391677, 126, '2015-02-01 00:33:38.000000', 'consum', 0.0220, 'lps'),
	(391678, 126, '2015-02-01 00:33:39.000000', 'consum', 0.0211, 'lps'),
	(391679, 126, '2015-02-01 00:33:40.000000', 'consum', 0.0213, 'lps'),
	(391680, 126, '2015-02-01 00:33:41.000000', 'consum', 0.0223, 'lps'),
	(391681, 126, '2015-02-01 00:33:42.000000', 'consum', 0.0224, 'lps'),
	(391682, 126, '2015-02-01 00:33:43.000000', 'consum', 0.0210, 'lps'),
	(391683, 126, '2015-02-01 00:33:44.000000', 'consum', 0.0212, 'lps'),
	(391684, 126, '2015-02-01 00:33:45.000000', 'consum', 0.0220, 'lps'),
	(391685, 126, '2015-02-01 00:33:46.000000', 'consum', 0.0212, 'lps'),
	(391686, 126, '2015-02-01 00:33:47.000000', 'consum', 0.0221, 'lps'),
	(391687, 126, '2015-02-01 00:33:48.000000', 'consum', 0.0214, 'lps'),
	(391688, 126, '2015-02-01 00:33:49.000000', 'consum', 0.0211, 'lps'),
	(391689, 126, '2015-02-01 00:33:50.000000', 'consum', 0.0219, 'lps'),
	(391690, 126, '2015-02-01 00:33:51.000000', 'consum', 0.0224, 'lps'),
	(391691, 126, '2015-02-01 00:33:52.000000', 'consum', 0.0223, 'lps'),
	(391692, 126, '2015-02-01 00:33:53.000000', 'consum', 0.0220, 'lps'),
	(391693, 126, '2015-02-01 00:33:54.000000', 'consum', 0.0218, 'lps'),
	(391694, 126, '2015-02-01 00:33:55.000000', 'consum', 0.0223, 'lps'),
	(391695, 126, '2015-02-01 00:33:56.000000', 'consum', 0.0223, 'lps'),
	(391696, 126, '2015-02-01 00:33:57.000000', 'consum', 0.0219, 'lps'),
	(391697, 126, '2015-02-01 00:33:58.000000', 'consum', 0.0217, 'lps'),
	(391698, 126, '2015-02-01 00:33:59.000000', 'consum', 0.0219, 'lps'),
	(391699, 126, '2015-02-01 00:34:00.000000', 'consum', 0.0221, 'lps'),
	(391700, 126, '2015-02-01 00:34:01.000000', 'consum', 0.0223, 'lps'),
	(391701, 126, '2015-02-01 00:34:02.000000', 'consum', 0.0210, 'lps'),
	(391702, 126, '2015-02-01 00:34:03.000000', 'consum', 0.0217, 'lps'),
	(391703, 126, '2015-02-01 00:34:04.000000', 'consum', 0.0218, 'lps'),
	(391704, 126, '2015-02-01 00:34:05.000000', 'consum', 0.0212, 'lps'),
	(391705, 126, '2015-02-01 00:34:06.000000', 'consum', 0.0214, 'lps'),
	(391706, 126, '2015-02-01 00:34:07.000000', 'consum', 0.0210, 'lps'),
	(391707, 126, '2015-02-01 00:34:08.000000', 'consum', 0.0213, 'lps'),
	(391708, 126, '2015-02-01 00:34:09.000000', 'consum', 0.0224, 'lps'),
	(391709, 126, '2015-02-01 00:34:10.000000', 'consum', 0.0214, 'lps'),
	(391710, 126, '2015-02-01 00:34:11.000000', 'consum', 0.0217, 'lps'),
	(391711, 126, '2015-02-01 00:34:12.000000', 'consum', 0.0218, 'lps'),
	(391712, 126, '2015-02-01 00:34:13.000000', 'consum', 0.0217, 'lps'),
	(391713, 126, '2015-02-01 00:34:14.000000', 'consum', 0.0220, 'lps'),
	(391714, 126, '2015-02-01 00:34:15.000000', 'consum', 0.0210, 'lps'),
	(391715, 126, '2015-02-01 00:34:16.000000', 'consum', 0.0224, 'lps'),
	(391716, 126, '2015-02-01 00:34:17.000000', 'consum', 0.0219, 'lps'),
	(391717, 126, '2015-02-01 00:34:18.000000', 'consum', 0.0217, 'lps'),
	(391718, 126, '2015-02-01 00:34:19.000000', 'consum', 0.0218, 'lps'),
	(391719, 126, '2015-02-01 00:34:20.000000', 'consum', 0.0215, 'lps'),
	(391720, 126, '2015-02-01 00:34:21.000000', 'consum', 0.0224, 'lps'),
	(391721, 126, '2015-02-01 00:34:22.000000', 'consum', 0.0221, 'lps'),
	(391722, 126, '2015-02-01 00:34:23.000000', 'consum', 0.0224, 'lps'),
	(391723, 126, '2015-02-01 00:34:24.000000', 'consum', 0.0218, 'lps'),
	(391724, 126, '2015-02-01 00:34:25.000000', 'consum', 0.0222, 'lps'),
	(391725, 126, '2015-02-01 00:34:26.000000', 'consum', 0.0216, 'lps'),
	(391726, 126, '2015-02-01 00:34:27.000000', 'consum', 0.0221, 'lps'),
	(391727, 126, '2015-02-01 00:34:28.000000', 'consum', 0.0218, 'lps'),
	(391728, 126, '2015-02-01 00:34:29.000000', 'consum', 0.0218, 'lps'),
	(391729, 126, '2015-02-01 00:34:30.000000', 'consum', 0.0212, 'lps'),
	(391730, 126, '2015-02-01 00:34:31.000000', 'consum', 0.0212, 'lps'),
	(391731, 126, '2015-02-01 00:34:32.000000', 'consum', 0.0213, 'lps'),
	(391732, 126, '2015-02-01 00:34:33.000000', 'consum', 0.0219, 'lps'),
	(391733, 126, '2015-02-01 00:34:34.000000', 'consum', 0.0216, 'lps'),
	(391734, 126, '2015-02-01 00:34:35.000000', 'consum', 0.0215, 'lps'),
	(391735, 126, '2015-02-01 00:34:36.000000', 'consum', 0.0218, 'lps'),
	(391736, 126, '2015-02-01 00:34:37.000000', 'consum', 0.0218, 'lps'),
	(391737, 126, '2015-02-01 00:34:38.000000', 'consum', 0.0214, 'lps'),
	(391738, 126, '2015-02-01 00:34:39.000000', 'consum', 0.0221, 'lps'),
	(391739, 126, '2015-02-01 00:34:40.000000', 'consum', 0.0210, 'lps'),
	(391740, 126, '2015-02-01 00:34:41.000000', 'consum', 0.0221, 'lps'),
	(391741, 126, '2015-02-01 00:34:42.000000', 'consum', 0.0223, 'lps'),
	(391742, 126, '2015-02-01 00:34:43.000000', 'consum', 0.0224, 'lps'),
	(391743, 126, '2015-02-01 00:34:44.000000', 'consum', 0.0214, 'lps'),
	(391744, 126, '2015-02-01 00:34:45.000000', 'consum', 0.0219, 'lps'),
	(391745, 126, '2015-02-01 00:34:46.000000', 'consum', 0.0213, 'lps'),
	(391746, 126, '2015-02-01 00:34:47.000000', 'consum', 0.0212, 'lps'),
	(391747, 126, '2015-02-01 00:34:48.000000', 'consum', 0.0213, 'lps'),
	(391748, 126, '2015-02-01 00:34:49.000000', 'consum', 0.0218, 'lps'),
	(391749, 126, '2015-02-01 00:34:50.000000', 'consum', 0.0210, 'lps'),
	(391750, 126, '2015-02-01 00:34:51.000000', 'consum', 0.0220, 'lps'),
	(391751, 126, '2015-02-01 00:34:52.000000', 'consum', 0.0213, 'lps'),
	(391752, 126, '2015-02-01 00:34:53.000000', 'consum', 0.0212, 'lps'),
	(391753, 126, '2015-02-01 00:34:54.000000', 'consum', 0.0211, 'lps'),
	(391754, 126, '2015-02-01 00:34:55.000000', 'consum', 0.0210, 'lps'),
	(391755, 126, '2015-02-01 00:34:56.000000', 'consum', 0.0224, 'lps'),
	(391756, 126, '2015-02-01 00:34:57.000000', 'consum', 0.0220, 'lps'),
	(391757, 126, '2015-02-01 00:34:58.000000', 'consum', 0.0217, 'lps'),
	(391758, 126, '2015-02-01 00:34:59.000000', 'consum', 0.0217, 'lps'),
	(391759, 126, '2015-02-01 00:35:00.000000', 'consum', 0.0223, 'lps'),
	(391760, 126, '2015-02-01 00:35:01.000000', 'consum', 0.0223, 'lps'),
	(391761, 126, '2015-02-01 00:35:02.000000', 'consum', 0.0210, 'lps'),
	(391762, 126, '2015-02-01 00:35:03.000000', 'consum', 0.0215, 'lps'),
	(391763, 126, '2015-02-01 00:35:04.000000', 'consum', 0.0219, 'lps'),
	(391764, 126, '2015-02-01 00:35:05.000000', 'consum', 0.0212, 'lps'),
	(391765, 126, '2015-02-01 00:35:06.000000', 'consum', 0.0222, 'lps'),
	(391766, 126, '2015-02-01 00:35:07.000000', 'consum', 0.0220, 'lps'),
	(391767, 126, '2015-02-01 00:35:08.000000', 'consum', 0.0210, 'lps'),
	(391768, 126, '2015-02-01 00:35:09.000000', 'consum', 0.0210, 'lps'),
	(391769, 126, '2015-02-01 00:35:10.000000', 'consum', 0.0210, 'lps'),
	(391770, 126, '2015-02-01 00:35:11.000000', 'consum', 0.0212, 'lps'),
	(391771, 126, '2015-02-01 00:35:12.000000', 'consum', 0.0220, 'lps'),
	(391772, 126, '2015-02-01 00:35:13.000000', 'consum', 0.0210, 'lps'),
	(391773, 126, '2015-02-01 00:35:14.000000', 'consum', 0.0211, 'lps'),
	(391774, 126, '2015-02-01 00:35:15.000000', 'consum', 0.0216, 'lps'),
	(391775, 126, '2015-02-01 00:35:16.000000', 'consum', 0.0221, 'lps'),
	(391776, 126, '2015-02-01 00:35:17.000000', 'consum', 0.0219, 'lps'),
	(391777, 126, '2015-02-01 00:35:18.000000', 'consum', 0.0221, 'lps'),
	(391778, 126, '2015-02-01 00:35:19.000000', 'consum', 0.0211, 'lps'),
	(391779, 126, '2015-02-01 00:35:20.000000', 'consum', 0.0212, 'lps'),
	(391780, 126, '2015-02-01 00:35:21.000000', 'consum', 0.0217, 'lps'),
	(391781, 126, '2015-02-01 00:35:22.000000', 'consum', 0.0224, 'lps'),
	(391782, 126, '2015-02-01 00:35:23.000000', 'consum', 0.0216, 'lps'),
	(391783, 126, '2015-02-01 00:35:24.000000', 'consum', 0.0211, 'lps'),
	(391784, 126, '2015-02-01 00:35:25.000000', 'consum', 0.0214, 'lps'),
	(391785, 126, '2015-02-01 00:35:26.000000', 'consum', 0.0211, 'lps'),
	(391786, 126, '2015-02-01 00:35:27.000000', 'consum', 0.0221, 'lps'),
	(391787, 126, '2015-02-01 00:35:28.000000', 'consum', 0.0217, 'lps'),
	(391788, 126, '2015-02-01 00:35:29.000000', 'consum', 0.0214, 'lps'),
	(391789, 126, '2015-02-01 00:35:30.000000', 'consum', 0.0222, 'lps'),
	(391790, 126, '2015-02-01 00:35:31.000000', 'consum', 0.0213, 'lps'),
	(391791, 126, '2015-02-01 00:35:32.000000', 'consum', 0.0219, 'lps'),
	(391792, 126, '2015-02-01 00:35:33.000000', 'consum', 0.0216, 'lps'),
	(391793, 126, '2015-02-01 00:35:34.000000', 'consum', 0.0217, 'lps'),
	(391794, 126, '2015-02-01 00:35:35.000000', 'consum', 0.0224, 'lps'),
	(391795, 126, '2015-02-01 00:35:36.000000', 'consum', 0.0216, 'lps'),
	(391796, 126, '2015-02-01 00:35:37.000000', 'consum', 0.0214, 'lps'),
	(391797, 126, '2015-02-01 00:35:38.000000', 'consum', 0.0212, 'lps'),
	(391798, 126, '2015-02-01 00:35:39.000000', 'consum', 0.0210, 'lps'),
	(391799, 126, '2015-02-01 00:35:40.000000', 'consum', 0.0220, 'lps'),
	(391800, 126, '2015-02-01 00:35:41.000000', 'consum', 0.0213, 'lps'),
	(391801, 126, '2015-02-01 00:35:42.000000', 'consum', 0.0211, 'lps'),
	(391802, 126, '2015-02-01 00:35:43.000000', 'consum', 0.0220, 'lps'),
	(391803, 126, '2015-02-01 00:35:44.000000', 'consum', 0.0215, 'lps'),
	(391804, 126, '2015-02-01 00:35:45.000000', 'consum', 0.0220, 'lps'),
	(391805, 126, '2015-02-01 00:35:46.000000', 'consum', 0.0215, 'lps'),
	(391806, 126, '2015-02-01 00:35:47.000000', 'consum', 0.0221, 'lps'),
	(391807, 126, '2015-02-01 00:35:48.000000', 'consum', 0.0219, 'lps'),
	(391808, 126, '2015-02-01 00:35:49.000000', 'consum', 0.0224, 'lps'),
	(391809, 126, '2015-02-01 00:35:50.000000', 'consum', 0.0223, 'lps'),
	(391810, 126, '2015-02-01 00:35:51.000000', 'consum', 0.0218, 'lps'),
	(391811, 126, '2015-02-01 00:35:52.000000', 'consum', 0.0213, 'lps'),
	(391812, 126, '2015-02-01 00:35:53.000000', 'consum', 0.0218, 'lps'),
	(391813, 126, '2015-02-01 00:35:54.000000', 'consum', 0.0224, 'lps'),
	(391814, 126, '2015-02-01 00:35:55.000000', 'consum', 0.0212, 'lps'),
	(391815, 126, '2015-02-01 00:35:56.000000', 'consum', 0.0222, 'lps'),
	(391816, 126, '2015-02-01 00:35:57.000000', 'consum', 0.0223, 'lps'),
	(391817, 126, '2015-02-01 00:35:58.000000', 'consum', 0.0222, 'lps'),
	(391818, 126, '2015-02-01 00:35:59.000000', 'consum', 0.0216, 'lps'),
	(391819, 126, '2015-02-01 00:36:00.000000', 'consum', 0.0220, 'lps'),
	(391820, 126, '2015-02-01 00:36:01.000000', 'consum', 0.0211, 'lps'),
	(391821, 126, '2015-02-01 00:36:02.000000', 'consum', 0.0216, 'lps'),
	(391822, 126, '2015-02-01 00:36:03.000000', 'consum', 0.0222, 'lps'),
	(391823, 126, '2015-02-01 00:36:04.000000', 'consum', 0.0223, 'lps'),
	(391824, 126, '2015-02-01 00:36:05.000000', 'consum', 0.0211, 'lps'),
	(391825, 126, '2015-02-01 00:36:06.000000', 'consum', 0.0218, 'lps'),
	(391826, 126, '2015-02-01 00:36:07.000000', 'consum', 0.0221, 'lps'),
	(391827, 126, '2015-02-01 00:36:08.000000', 'consum', 0.0212, 'lps'),
	(391828, 126, '2015-02-01 00:36:09.000000', 'consum', 0.0215, 'lps'),
	(391829, 126, '2015-02-01 00:36:10.000000', 'consum', 0.0217, 'lps'),
	(391830, 126, '2015-02-01 00:36:11.000000', 'consum', 0.0214, 'lps'),
	(391831, 126, '2015-02-01 00:36:12.000000', 'consum', 0.0211, 'lps'),
	(391832, 126, '2015-02-01 00:36:13.000000', 'consum', 0.0219, 'lps'),
	(391833, 126, '2015-02-01 00:36:14.000000', 'consum', 0.0222, 'lps'),
	(391834, 126, '2015-02-01 00:36:15.000000', 'consum', 0.0214, 'lps'),
	(391835, 126, '2015-02-01 00:36:16.000000', 'consum', 0.0210, 'lps'),
	(391836, 126, '2015-02-01 00:36:17.000000', 'consum', 0.0214, 'lps'),
	(391837, 126, '2015-02-01 00:36:18.000000', 'consum', 0.0213, 'lps'),
	(391838, 126, '2015-02-01 00:36:19.000000', 'consum', 0.0216, 'lps'),
	(391839, 126, '2015-02-01 00:36:20.000000', 'consum', 0.0214, 'lps'),
	(391840, 126, '2015-02-01 00:36:21.000000', 'consum', 0.0214, 'lps'),
	(391841, 126, '2015-02-01 00:36:22.000000', 'consum', 0.0219, 'lps'),
	(391842, 126, '2015-02-01 00:36:23.000000', 'consum', 0.0211, 'lps'),
	(391843, 126, '2015-02-01 00:36:24.000000', 'consum', 0.0221, 'lps'),
	(391844, 126, '2015-02-01 00:36:25.000000', 'consum', 0.0218, 'lps'),
	(391845, 126, '2015-02-01 00:36:26.000000', 'consum', 0.0218, 'lps'),
	(391846, 126, '2015-02-01 00:36:27.000000', 'consum', 0.0224, 'lps'),
	(391847, 126, '2015-02-01 00:36:28.000000', 'consum', 0.0213, 'lps'),
	(391848, 126, '2015-02-01 00:36:29.000000', 'consum', 0.0214, 'lps'),
	(391849, 126, '2015-02-01 00:36:30.000000', 'consum', 0.0222, 'lps'),
	(391850, 126, '2015-02-01 00:36:31.000000', 'consum', 0.0211, 'lps'),
	(391851, 126, '2015-02-01 00:36:32.000000', 'consum', 0.0210, 'lps'),
	(391852, 126, '2015-02-01 00:36:33.000000', 'consum', 0.0210, 'lps'),
	(391853, 126, '2015-02-01 00:36:34.000000', 'consum', 0.0223, 'lps'),
	(391854, 126, '2015-02-01 00:36:35.000000', 'consum', 0.0215, 'lps'),
	(391855, 126, '2015-02-01 00:36:36.000000', 'consum', 0.0210, 'lps'),
	(391856, 126, '2015-02-01 00:36:37.000000', 'consum', 0.0214, 'lps'),
	(391857, 126, '2015-02-01 00:36:38.000000', 'consum', 0.0215, 'lps'),
	(391858, 126, '2015-02-01 00:36:39.000000', 'consum', 0.0223, 'lps'),
	(391859, 126, '2015-02-01 00:36:40.000000', 'consum', 0.0214, 'lps'),
	(391860, 126, '2015-02-01 00:36:41.000000', 'consum', 0.0223, 'lps'),
	(391861, 126, '2015-02-01 00:36:42.000000', 'consum', 0.0220, 'lps'),
	(391862, 126, '2015-02-01 00:36:43.000000', 'consum', 0.0218, 'lps'),
	(391863, 126, '2015-02-01 00:36:44.000000', 'consum', 0.0223, 'lps'),
	(391864, 126, '2015-02-01 00:36:45.000000', 'consum', 0.0219, 'lps'),
	(391865, 126, '2015-02-01 00:36:46.000000', 'consum', 0.0219, 'lps'),
	(391866, 126, '2015-02-01 00:36:47.000000', 'consum', 0.0213, 'lps'),
	(391867, 126, '2015-02-01 00:36:48.000000', 'consum', 0.0212, 'lps'),
	(391868, 126, '2015-02-01 00:36:49.000000', 'consum', 0.0211, 'lps'),
	(391869, 126, '2015-02-01 00:36:50.000000', 'consum', 0.0224, 'lps'),
	(391870, 126, '2015-02-01 00:36:51.000000', 'consum', 0.0217, 'lps'),
	(391871, 126, '2015-02-01 00:36:52.000000', 'consum', 0.0221, 'lps'),
	(391872, 126, '2015-02-01 00:36:53.000000', 'consum', 0.0212, 'lps'),
	(391873, 126, '2015-02-01 00:36:54.000000', 'consum', 0.0219, 'lps'),
	(391874, 126, '2015-02-01 00:36:55.000000', 'consum', 0.0220, 'lps'),
	(391875, 126, '2015-02-01 00:36:56.000000', 'consum', 0.0216, 'lps'),
	(391876, 126, '2015-02-01 00:36:57.000000', 'consum', 0.0211, 'lps'),
	(391877, 126, '2015-02-01 00:36:58.000000', 'consum', 0.0214, 'lps'),
	(391878, 126, '2015-02-01 00:36:59.000000', 'consum', 0.0211, 'lps'),
	(391879, 126, '2015-02-01 00:37:00.000000', 'consum', 0.0221, 'lps'),
	(391880, 126, '2015-02-01 00:37:01.000000', 'consum', 0.0216, 'lps'),
	(391881, 126, '2015-02-01 00:37:02.000000', 'consum', 0.0222, 'lps'),
	(391882, 126, '2015-02-01 00:37:03.000000', 'consum', 0.0224, 'lps'),
	(391883, 126, '2015-02-01 00:37:04.000000', 'consum', 0.0213, 'lps'),
	(391884, 126, '2015-02-01 00:37:05.000000', 'consum', 0.0215, 'lps'),
	(391885, 126, '2015-02-01 00:37:06.000000', 'consum', 0.0212, 'lps'),
	(391886, 126, '2015-02-01 00:37:07.000000', 'consum', 0.0220, 'lps'),
	(391887, 126, '2015-02-01 00:37:08.000000', 'consum', 0.0223, 'lps'),
	(391888, 126, '2015-02-01 00:37:09.000000', 'consum', 0.0215, 'lps'),
	(391889, 126, '2015-02-01 00:37:10.000000', 'consum', 0.0211, 'lps'),
	(391890, 126, '2015-02-01 00:37:11.000000', 'consum', 0.0215, 'lps'),
	(391891, 126, '2015-02-01 00:37:12.000000', 'consum', 0.0220, 'lps'),
	(391892, 126, '2015-02-01 00:37:13.000000', 'consum', 0.0216, 'lps'),
	(391893, 126, '2015-02-01 00:37:14.000000', 'consum', 0.0224, 'lps'),
	(391894, 126, '2015-02-01 00:37:15.000000', 'consum', 0.0220, 'lps'),
	(391895, 126, '2015-02-01 00:37:16.000000', 'consum', 0.0217, 'lps'),
	(391896, 126, '2015-02-01 00:37:17.000000', 'consum', 0.0213, 'lps'),
	(391897, 126, '2015-02-01 00:37:18.000000', 'consum', 0.0223, 'lps'),
	(391898, 126, '2015-02-01 00:37:19.000000', 'consum', 0.0222, 'lps'),
	(391899, 126, '2015-02-01 00:37:20.000000', 'consum', 0.0214, 'lps'),
	(391900, 126, '2015-02-01 00:37:21.000000', 'consum', 0.0211, 'lps'),
	(391901, 126, '2015-02-01 00:37:22.000000', 'consum', 0.0220, 'lps'),
	(391902, 126, '2015-02-01 00:37:23.000000', 'consum', 0.0212, 'lps'),
	(391903, 126, '2015-02-01 00:37:24.000000', 'consum', 0.0218, 'lps'),
	(391904, 126, '2015-02-01 00:37:25.000000', 'consum', 0.0218, 'lps'),
	(391905, 126, '2015-02-01 00:37:26.000000', 'consum', 0.0223, 'lps'),
	(391906, 126, '2015-02-01 00:37:27.000000', 'consum', 0.0224, 'lps'),
	(391907, 126, '2015-02-01 00:37:28.000000', 'consum', 0.0211, 'lps'),
	(391908, 126, '2015-02-01 00:37:29.000000', 'consum', 0.0219, 'lps'),
	(391909, 126, '2015-02-01 00:37:30.000000', 'consum', 0.0222, 'lps'),
	(391910, 126, '2015-02-01 00:37:31.000000', 'consum', 0.0215, 'lps'),
	(391911, 126, '2015-02-01 00:37:32.000000', 'consum', 0.0214, 'lps'),
	(391912, 126, '2015-02-01 00:37:33.000000', 'consum', 0.0214, 'lps'),
	(391913, 126, '2015-02-01 00:37:34.000000', 'consum', 0.0221, 'lps'),
	(391914, 126, '2015-02-01 00:37:35.000000', 'consum', 0.0224, 'lps'),
	(391915, 126, '2015-02-01 00:37:36.000000', 'consum', 0.0217, 'lps'),
	(391916, 126, '2015-02-01 00:37:37.000000', 'consum', 0.0217, 'lps'),
	(391917, 126, '2015-02-01 00:37:38.000000', 'consum', 0.0210, 'lps'),
	(391918, 126, '2015-02-01 00:37:39.000000', 'consum', 0.0219, 'lps'),
	(391919, 126, '2015-02-01 00:37:40.000000', 'consum', 0.0212, 'lps'),
	(391920, 126, '2015-02-01 00:37:41.000000', 'consum', 0.0224, 'lps'),
	(391921, 126, '2015-02-01 00:37:42.000000', 'consum', 0.0215, 'lps'),
	(391922, 126, '2015-02-01 00:37:43.000000', 'consum', 0.0223, 'lps'),
	(391923, 126, '2015-02-01 00:37:44.000000', 'consum', 0.0216, 'lps'),
	(391924, 126, '2015-02-01 00:37:45.000000', 'consum', 0.0217, 'lps'),
	(391925, 126, '2015-02-01 00:37:46.000000', 'consum', 0.0213, 'lps'),
	(391926, 126, '2015-02-01 00:37:47.000000', 'consum', 0.0217, 'lps'),
	(391927, 126, '2015-02-01 00:37:48.000000', 'consum', 0.0221, 'lps'),
	(391928, 126, '2015-02-01 00:37:49.000000', 'consum', 0.0215, 'lps'),
	(391929, 126, '2015-02-01 00:37:50.000000', 'consum', 0.0219, 'lps'),
	(391930, 126, '2015-02-01 00:37:51.000000', 'consum', 0.0212, 'lps'),
	(391931, 126, '2015-02-01 00:37:52.000000', 'consum', 0.0220, 'lps'),
	(391932, 126, '2015-02-01 00:37:53.000000', 'consum', 0.0212, 'lps'),
	(391933, 126, '2015-02-01 00:37:54.000000', 'consum', 0.0220, 'lps'),
	(391934, 126, '2015-02-01 00:37:55.000000', 'consum', 0.0211, 'lps'),
	(391935, 126, '2015-02-01 00:37:56.000000', 'consum', 0.0213, 'lps'),
	(391936, 126, '2015-02-01 00:37:57.000000', 'consum', 0.0223, 'lps'),
	(391937, 126, '2015-02-01 00:37:58.000000', 'consum', 0.0221, 'lps'),
	(391938, 126, '2015-02-01 00:37:59.000000', 'consum', 0.0212, 'lps'),
	(391939, 126, '2015-02-01 00:38:00.000000', 'consum', 0.0216, 'lps'),
	(391940, 126, '2015-02-01 00:38:01.000000', 'consum', 0.0218, 'lps'),
	(391941, 126, '2015-02-01 00:38:02.000000', 'consum', 0.0221, 'lps'),
	(391942, 126, '2015-02-01 00:38:03.000000', 'consum', 0.0212, 'lps'),
	(391943, 126, '2015-02-01 00:38:04.000000', 'consum', 0.0215, 'lps'),
	(391944, 126, '2015-02-01 00:38:05.000000', 'consum', 0.0216, 'lps'),
	(391945, 126, '2015-02-01 00:38:06.000000', 'consum', 0.0212, 'lps'),
	(391946, 126, '2015-02-01 00:38:07.000000', 'consum', 0.0216, 'lps'),
	(391947, 126, '2015-02-01 00:38:08.000000', 'consum', 0.0220, 'lps'),
	(391948, 126, '2015-02-01 00:38:09.000000', 'consum', 0.0212, 'lps'),
	(391949, 126, '2015-02-01 00:38:10.000000', 'consum', 0.0220, 'lps'),
	(391950, 126, '2015-02-01 00:38:11.000000', 'consum', 0.0224, 'lps'),
	(391951, 126, '2015-02-01 00:38:12.000000', 'consum', 0.0220, 'lps'),
	(391952, 126, '2015-02-01 00:38:13.000000', 'consum', 0.0221, 'lps'),
	(391953, 126, '2015-02-01 00:38:14.000000', 'consum', 0.0218, 'lps'),
	(391954, 126, '2015-02-01 00:38:15.000000', 'consum', 0.0217, 'lps'),
	(391955, 126, '2015-02-01 00:38:16.000000', 'consum', 0.0223, 'lps'),
	(391956, 126, '2015-02-01 00:38:17.000000', 'consum', 0.0224, 'lps'),
	(391957, 126, '2015-02-01 00:38:18.000000', 'consum', 0.0210, 'lps'),
	(391958, 126, '2015-02-01 00:38:19.000000', 'consum', 0.0214, 'lps'),
	(391959, 126, '2015-02-01 00:38:20.000000', 'consum', 0.0215, 'lps'),
	(391960, 126, '2015-02-01 00:38:21.000000', 'consum', 0.0211, 'lps'),
	(391961, 126, '2015-02-01 00:38:22.000000', 'consum', 0.0213, 'lps'),
	(391962, 126, '2015-02-01 00:38:23.000000', 'consum', 0.0221, 'lps'),
	(391963, 126, '2015-02-01 00:38:24.000000', 'consum', 0.0215, 'lps'),
	(391964, 126, '2015-02-01 00:38:25.000000', 'consum', 0.0216, 'lps'),
	(391965, 126, '2015-02-01 00:38:26.000000', 'consum', 0.0211, 'lps'),
	(391966, 126, '2015-02-01 00:38:27.000000', 'consum', 0.0213, 'lps'),
	(391967, 126, '2015-02-01 00:38:28.000000', 'consum', 0.0224, 'lps'),
	(391968, 126, '2015-02-01 00:38:29.000000', 'consum', 0.0224, 'lps'),
	(391969, 126, '2015-02-01 00:38:30.000000', 'consum', 0.0223, 'lps'),
	(391970, 126, '2015-02-01 00:38:31.000000', 'consum', 0.0218, 'lps'),
	(391971, 126, '2015-02-01 00:38:32.000000', 'consum', 0.0213, 'lps'),
	(391972, 126, '2015-02-01 00:38:33.000000', 'consum', 0.0215, 'lps'),
	(391973, 126, '2015-02-01 00:38:34.000000', 'consum', 0.0211, 'lps'),
	(391974, 126, '2015-02-01 00:38:35.000000', 'consum', 0.0218, 'lps'),
	(391975, 126, '2015-02-01 00:38:36.000000', 'consum', 0.0218, 'lps'),
	(391976, 126, '2015-02-01 00:38:37.000000', 'consum', 0.0223, 'lps'),
	(391977, 126, '2015-02-01 00:38:38.000000', 'consum', 0.0224, 'lps'),
	(391978, 126, '2015-02-01 00:38:39.000000', 'consum', 0.0212, 'lps'),
	(391979, 126, '2015-02-01 00:38:40.000000', 'consum', 0.0224, 'lps'),
	(391980, 126, '2015-02-01 00:38:41.000000', 'consum', 0.0212, 'lps'),
	(391981, 126, '2015-02-01 00:38:42.000000', 'consum', 0.0223, 'lps'),
	(391982, 126, '2015-02-01 00:38:43.000000', 'consum', 0.0211, 'lps'),
	(391983, 126, '2015-02-01 00:38:44.000000', 'consum', 0.0223, 'lps'),
	(391984, 126, '2015-02-01 00:38:45.000000', 'consum', 0.0211, 'lps'),
	(391985, 126, '2015-02-01 00:38:46.000000', 'consum', 0.0224, 'lps'),
	(391986, 126, '2015-02-01 00:38:47.000000', 'consum', 0.0214, 'lps'),
	(391987, 126, '2015-02-01 00:38:48.000000', 'consum', 0.0219, 'lps'),
	(391988, 126, '2015-02-01 00:38:49.000000', 'consum', 0.0215, 'lps'),
	(391989, 126, '2015-02-01 00:38:50.000000', 'consum', 0.0210, 'lps'),
	(391990, 126, '2015-02-01 00:38:51.000000', 'consum', 0.0223, 'lps'),
	(391991, 126, '2015-02-01 00:38:52.000000', 'consum', 0.0217, 'lps'),
	(391992, 126, '2015-02-01 00:38:53.000000', 'consum', 0.0222, 'lps'),
	(391993, 126, '2015-02-01 00:38:54.000000', 'consum', 0.0221, 'lps'),
	(391994, 126, '2015-02-01 00:38:55.000000', 'consum', 0.0212, 'lps'),
	(391995, 126, '2015-02-01 00:38:56.000000', 'consum', 0.0217, 'lps'),
	(391996, 126, '2015-02-01 00:38:57.000000', 'consum', 0.0210, 'lps'),
	(391997, 126, '2015-02-01 00:38:58.000000', 'consum', 0.0218, 'lps'),
	(391998, 126, '2015-02-01 00:38:59.000000', 'consum', 0.0224, 'lps'),
	(391999, 126, '2015-02-01 00:39:00.000000', 'consum', 0.0224, 'lps'),
	(392000, 126, '2015-02-01 00:39:01.000000', 'consum', 0.0222, 'lps'),
	(392001, 126, '2015-02-01 00:39:02.000000', 'consum', 0.0216, 'lps'),
	(392002, 126, '2015-02-01 00:39:03.000000', 'consum', 0.0218, 'lps'),
	(392003, 126, '2015-02-01 00:39:04.000000', 'consum', 0.0217, 'lps'),
	(392004, 126, '2015-02-01 00:39:05.000000', 'consum', 0.0222, 'lps'),
	(392005, 126, '2015-02-01 00:39:06.000000', 'consum', 0.0221, 'lps'),
	(392006, 126, '2015-02-01 00:39:07.000000', 'consum', 0.0214, 'lps'),
	(392007, 126, '2015-02-01 00:39:08.000000', 'consum', 0.0212, 'lps'),
	(392008, 126, '2015-02-01 00:39:09.000000', 'consum', 0.0224, 'lps'),
	(392009, 126, '2015-02-01 00:39:10.000000', 'consum', 0.0212, 'lps'),
	(392010, 126, '2015-02-01 00:39:11.000000', 'consum', 0.0211, 'lps'),
	(392011, 126, '2015-02-01 00:39:12.000000', 'consum', 0.0210, 'lps'),
	(392012, 126, '2015-02-01 00:39:13.000000', 'consum', 0.0221, 'lps'),
	(392013, 126, '2015-02-01 00:39:14.000000', 'consum', 0.0220, 'lps'),
	(392014, 126, '2015-02-01 00:39:15.000000', 'consum', 0.0211, 'lps'),
	(392015, 126, '2015-02-01 00:39:16.000000', 'consum', 0.0219, 'lps'),
	(392016, 126, '2015-02-01 00:39:17.000000', 'consum', 0.0219, 'lps'),
	(392017, 126, '2015-02-01 00:39:18.000000', 'consum', 0.0217, 'lps'),
	(392018, 126, '2015-02-01 00:39:19.000000', 'consum', 0.0217, 'lps'),
	(392019, 126, '2015-02-01 00:39:20.000000', 'consum', 0.0211, 'lps'),
	(392020, 126, '2015-02-01 00:39:21.000000', 'consum', 0.0224, 'lps'),
	(392021, 126, '2015-02-01 00:39:22.000000', 'consum', 0.0215, 'lps'),
	(392022, 126, '2015-02-01 00:39:23.000000', 'consum', 0.0212, 'lps'),
	(392023, 126, '2015-02-01 00:39:24.000000', 'consum', 0.0220, 'lps'),
	(392024, 126, '2015-02-01 00:39:25.000000', 'consum', 0.0222, 'lps'),
	(392025, 126, '2015-02-01 00:39:26.000000', 'consum', 0.0211, 'lps'),
	(392026, 126, '2015-02-01 00:39:27.000000', 'consum', 0.0224, 'lps'),
	(392027, 126, '2015-02-01 00:39:28.000000', 'consum', 0.0220, 'lps'),
	(392028, 126, '2015-02-01 00:39:29.000000', 'consum', 0.0218, 'lps'),
	(392029, 126, '2015-02-01 00:39:30.000000', 'consum', 0.0219, 'lps'),
	(392030, 126, '2015-02-01 00:39:31.000000', 'consum', 0.0216, 'lps'),
	(392031, 126, '2015-02-01 00:39:32.000000', 'consum', 0.0216, 'lps'),
	(392032, 126, '2015-02-01 00:39:33.000000', 'consum', 0.0221, 'lps'),
	(392033, 126, '2015-02-01 00:39:34.000000', 'consum', 0.0216, 'lps'),
	(392034, 126, '2015-02-01 00:39:35.000000', 'consum', 0.0224, 'lps'),
	(392035, 126, '2015-02-01 00:39:36.000000', 'consum', 0.0219, 'lps'),
	(392036, 126, '2015-02-01 00:39:37.000000', 'consum', 0.0211, 'lps'),
	(392037, 126, '2015-02-01 00:39:38.000000', 'consum', 0.0221, 'lps'),
	(392038, 126, '2015-02-01 00:39:39.000000', 'consum', 0.0217, 'lps'),
	(392039, 126, '2015-02-01 00:39:40.000000', 'consum', 0.0211, 'lps'),
	(392040, 126, '2015-02-01 00:39:41.000000', 'consum', 0.0223, 'lps'),
	(392041, 126, '2015-02-01 00:39:42.000000', 'consum', 0.0215, 'lps'),
	(392042, 126, '2015-02-01 00:39:43.000000', 'consum', 0.0211, 'lps'),
	(392043, 126, '2015-02-01 00:39:44.000000', 'consum', 0.0214, 'lps'),
	(392044, 126, '2015-02-01 00:39:45.000000', 'consum', 0.0215, 'lps'),
	(392045, 126, '2015-02-01 00:39:46.000000', 'consum', 0.0221, 'lps'),
	(392046, 126, '2015-02-01 00:39:47.000000', 'consum', 0.0222, 'lps'),
	(392047, 126, '2015-02-01 00:39:48.000000', 'consum', 0.0221, 'lps'),
	(392048, 126, '2015-02-01 00:39:49.000000', 'consum', 0.0217, 'lps'),
	(392049, 126, '2015-02-01 00:39:50.000000', 'consum', 0.0212, 'lps'),
	(392050, 126, '2015-02-01 00:39:51.000000', 'consum', 0.0214, 'lps'),
	(392051, 126, '2015-02-01 00:39:52.000000', 'consum', 0.0210, 'lps'),
	(392052, 126, '2015-02-01 00:39:53.000000', 'consum', 0.0211, 'lps'),
	(392053, 126, '2015-02-01 00:39:54.000000', 'consum', 0.0218, 'lps'),
	(392054, 126, '2015-02-01 00:39:55.000000', 'consum', 0.0215, 'lps'),
	(392055, 126, '2015-02-01 00:39:56.000000', 'consum', 0.0211, 'lps'),
	(392056, 126, '2015-02-01 00:39:57.000000', 'consum', 0.0219, 'lps'),
	(392057, 126, '2015-02-01 00:39:58.000000', 'consum', 0.0219, 'lps'),
	(392058, 126, '2015-02-01 00:39:59.000000', 'consum', 0.0215, 'lps'),
	(392059, 126, '2015-02-01 00:40:00.000000', 'consum', 0.0224, 'lps'),
	(392060, 126, '2015-02-01 00:40:01.000000', 'consum', 0.0218, 'lps'),
	(392061, 126, '2015-02-01 00:40:02.000000', 'consum', 0.0211, 'lps'),
	(392062, 126, '2015-02-01 00:40:03.000000', 'consum', 0.0220, 'lps'),
	(392063, 126, '2015-02-01 00:40:04.000000', 'consum', 0.0213, 'lps'),
	(392064, 126, '2015-02-01 00:40:05.000000', 'consum', 0.0210, 'lps'),
	(392065, 126, '2015-02-01 00:40:06.000000', 'consum', 0.0217, 'lps'),
	(392066, 126, '2015-02-01 00:40:07.000000', 'consum', 0.0216, 'lps'),
	(392067, 126, '2015-02-01 00:40:08.000000', 'consum', 0.0218, 'lps'),
	(392068, 126, '2015-02-01 00:40:09.000000', 'consum', 0.0219, 'lps'),
	(392069, 126, '2015-02-01 00:40:10.000000', 'consum', 0.0216, 'lps'),
	(392070, 126, '2015-02-01 00:40:11.000000', 'consum', 0.0216, 'lps'),
	(392071, 126, '2015-02-01 00:40:12.000000', 'consum', 0.0219, 'lps'),
	(392072, 126, '2015-02-01 00:40:13.000000', 'consum', 0.0224, 'lps'),
	(392073, 126, '2015-02-01 00:40:14.000000', 'consum', 0.0223, 'lps'),
	(392074, 126, '2015-02-01 00:40:15.000000', 'consum', 0.0217, 'lps'),
	(392075, 126, '2015-02-01 00:40:16.000000', 'consum', 0.0223, 'lps'),
	(392076, 126, '2015-02-01 00:40:17.000000', 'consum', 0.0224, 'lps'),
	(392077, 126, '2015-02-01 00:40:18.000000', 'consum', 0.0213, 'lps'),
	(392078, 126, '2015-02-01 00:40:19.000000', 'consum', 0.0214, 'lps'),
	(392079, 126, '2015-02-01 00:40:20.000000', 'consum', 0.0221, 'lps'),
	(392080, 126, '2015-02-01 00:40:21.000000', 'consum', 0.0223, 'lps'),
	(392081, 126, '2015-02-01 00:40:22.000000', 'consum', 0.0214, 'lps'),
	(392082, 126, '2015-02-01 00:40:23.000000', 'consum', 0.0222, 'lps'),
	(392083, 126, '2015-02-01 00:40:24.000000', 'consum', 0.0213, 'lps'),
	(392084, 126, '2015-02-01 00:40:25.000000', 'consum', 0.0221, 'lps'),
	(392085, 126, '2015-02-01 00:40:26.000000', 'consum', 0.0210, 'lps'),
	(392086, 126, '2015-02-01 00:40:27.000000', 'consum', 0.0224, 'lps'),
	(392087, 126, '2015-02-01 00:40:28.000000', 'consum', 0.0219, 'lps'),
	(392088, 126, '2015-02-01 00:40:29.000000', 'consum', 0.0213, 'lps'),
	(392089, 126, '2015-02-01 00:40:30.000000', 'consum', 0.0212, 'lps'),
	(392090, 126, '2015-02-01 00:40:31.000000', 'consum', 0.0214, 'lps'),
	(392091, 126, '2015-02-01 00:40:32.000000', 'consum', 0.0224, 'lps'),
	(392092, 126, '2015-02-01 00:40:33.000000', 'consum', 0.0224, 'lps'),
	(392093, 126, '2015-02-01 00:40:34.000000', 'consum', 0.0223, 'lps'),
	(392094, 126, '2015-02-01 00:40:35.000000', 'consum', 0.0219, 'lps'),
	(392095, 126, '2015-02-01 00:40:36.000000', 'consum', 0.0217, 'lps'),
	(392096, 126, '2015-02-01 00:40:37.000000', 'consum', 0.0216, 'lps'),
	(392097, 126, '2015-02-01 00:40:38.000000', 'consum', 0.0220, 'lps'),
	(392098, 126, '2015-02-01 00:40:39.000000', 'consum', 0.0213, 'lps'),
	(392099, 126, '2015-02-01 00:40:40.000000', 'consum', 0.0212, 'lps'),
	(392100, 126, '2015-02-01 00:40:41.000000', 'consum', 0.0224, 'lps'),
	(392101, 126, '2015-02-01 00:40:42.000000', 'consum', 0.0217, 'lps'),
	(392102, 126, '2015-02-01 00:40:43.000000', 'consum', 0.0217, 'lps'),
	(392103, 126, '2015-02-01 00:40:44.000000', 'consum', 0.0211, 'lps'),
	(392104, 126, '2015-02-01 00:40:45.000000', 'consum', 0.0224, 'lps'),
	(392105, 126, '2015-02-01 00:40:46.000000', 'consum', 0.0216, 'lps'),
	(392106, 126, '2015-02-01 00:40:47.000000', 'consum', 0.0215, 'lps'),
	(392107, 126, '2015-02-01 00:40:48.000000', 'consum', 0.0216, 'lps'),
	(392108, 126, '2015-02-01 00:40:49.000000', 'consum', 0.0212, 'lps'),
	(392109, 126, '2015-02-01 00:40:50.000000', 'consum', 0.0215, 'lps'),
	(392110, 126, '2015-02-01 00:40:51.000000', 'consum', 0.0216, 'lps'),
	(392111, 126, '2015-02-01 00:40:52.000000', 'consum', 0.0211, 'lps'),
	(392112, 126, '2015-02-01 00:40:53.000000', 'consum', 0.0211, 'lps'),
	(392113, 126, '2015-02-01 00:40:54.000000', 'consum', 0.0214, 'lps'),
	(392114, 126, '2015-02-01 00:40:55.000000', 'consum', 0.0210, 'lps'),
	(392115, 126, '2015-02-01 00:40:56.000000', 'consum', 0.0217, 'lps'),
	(392116, 126, '2015-02-01 00:40:57.000000', 'consum', 0.0213, 'lps'),
	(392117, 126, '2015-02-01 00:40:58.000000', 'consum', 0.0222, 'lps'),
	(392118, 126, '2015-02-01 00:40:59.000000', 'consum', 0.0216, 'lps'),
	(392119, 126, '2015-02-01 00:41:00.000000', 'consum', 0.0219, 'lps'),
	(392120, 126, '2015-02-01 00:41:01.000000', 'consum', 0.0224, 'lps'),
	(392121, 126, '2015-02-01 00:41:02.000000', 'consum', 0.0223, 'lps'),
	(392122, 126, '2015-02-01 00:41:03.000000', 'consum', 0.0220, 'lps'),
	(392123, 126, '2015-02-01 00:41:04.000000', 'consum', 0.0221, 'lps'),
	(392124, 126, '2015-02-01 00:41:05.000000', 'consum', 0.0221, 'lps'),
	(392125, 126, '2015-02-01 00:41:06.000000', 'consum', 0.0215, 'lps'),
	(392126, 126, '2015-02-01 00:41:07.000000', 'consum', 0.0218, 'lps'),
	(392127, 126, '2015-02-01 00:41:08.000000', 'consum', 0.0220, 'lps'),
	(392128, 126, '2015-02-01 00:41:09.000000', 'consum', 0.0224, 'lps'),
	(392129, 126, '2015-02-01 00:41:10.000000', 'consum', 0.0219, 'lps'),
	(392130, 126, '2015-02-01 00:41:11.000000', 'consum', 0.0212, 'lps'),
	(392131, 126, '2015-02-01 00:41:12.000000', 'consum', 0.0211, 'lps'),
	(392132, 126, '2015-02-01 00:41:13.000000', 'consum', 0.0211, 'lps'),
	(392133, 126, '2015-02-01 00:41:14.000000', 'consum', 0.0224, 'lps'),
	(392134, 126, '2015-02-01 00:41:15.000000', 'consum', 0.0220, 'lps'),
	(392135, 126, '2015-02-01 00:41:16.000000', 'consum', 0.0218, 'lps'),
	(392136, 126, '2015-02-01 00:41:17.000000', 'consum', 0.0222, 'lps'),
	(392137, 126, '2015-02-01 00:41:18.000000', 'consum', 0.0216, 'lps'),
	(392138, 126, '2015-02-01 00:41:19.000000', 'consum', 0.0220, 'lps'),
	(392139, 126, '2015-02-01 00:41:20.000000', 'consum', 0.0213, 'lps'),
	(392140, 126, '2015-02-01 00:41:21.000000', 'consum', 0.0223, 'lps'),
	(392141, 126, '2015-02-01 00:41:22.000000', 'consum', 0.0210, 'lps'),
	(392142, 126, '2015-02-01 00:41:23.000000', 'consum', 0.0213, 'lps'),
	(392143, 126, '2015-02-01 00:41:24.000000', 'consum', 0.0211, 'lps'),
	(392144, 126, '2015-02-01 00:41:25.000000', 'consum', 0.0223, 'lps'),
	(392145, 126, '2015-02-01 00:41:26.000000', 'consum', 0.0213, 'lps'),
	(392146, 126, '2015-02-01 00:41:27.000000', 'consum', 0.0215, 'lps'),
	(392147, 126, '2015-02-01 00:41:28.000000', 'consum', 0.0212, 'lps'),
	(392148, 126, '2015-02-01 00:41:29.000000', 'consum', 0.0219, 'lps'),
	(392149, 126, '2015-02-01 00:41:30.000000', 'consum', 0.0221, 'lps'),
	(392150, 126, '2015-02-01 00:41:31.000000', 'consum', 0.0223, 'lps'),
	(392151, 126, '2015-02-01 00:41:32.000000', 'consum', 0.0214, 'lps'),
	(392152, 126, '2015-02-01 00:41:33.000000', 'consum', 0.0222, 'lps'),
	(392153, 126, '2015-02-01 00:41:34.000000', 'consum', 0.0213, 'lps'),
	(392154, 126, '2015-02-01 00:41:35.000000', 'consum', 0.0218, 'lps'),
	(392155, 126, '2015-02-01 00:41:36.000000', 'consum', 0.0212, 'lps'),
	(392156, 126, '2015-02-01 00:41:37.000000', 'consum', 0.0212, 'lps'),
	(392157, 126, '2015-02-01 00:41:38.000000', 'consum', 0.0216, 'lps'),
	(392158, 126, '2015-02-01 00:41:39.000000', 'consum', 0.0219, 'lps'),
	(392159, 126, '2015-02-01 00:41:40.000000', 'consum', 0.0220, 'lps'),
	(392160, 126, '2015-02-01 00:41:41.000000', 'consum', 0.0221, 'lps'),
	(392161, 126, '2015-02-01 00:41:42.000000', 'consum', 0.0221, 'lps'),
	(392162, 126, '2015-02-01 00:41:43.000000', 'consum', 0.0218, 'lps'),
	(392163, 126, '2015-02-01 00:41:44.000000', 'consum', 0.0216, 'lps'),
	(392164, 126, '2015-02-01 00:41:45.000000', 'consum', 0.0216, 'lps'),
	(392165, 126, '2015-02-01 00:41:46.000000', 'consum', 0.0210, 'lps'),
	(392166, 126, '2015-02-01 00:41:47.000000', 'consum', 0.0222, 'lps'),
	(392167, 126, '2015-02-01 00:41:48.000000', 'consum', 0.0224, 'lps'),
	(392168, 126, '2015-02-01 00:41:49.000000', 'consum', 0.0216, 'lps'),
	(392169, 126, '2015-02-01 00:41:50.000000', 'consum', 0.0214, 'lps'),
	(392170, 126, '2015-02-01 00:41:51.000000', 'consum', 0.0213, 'lps'),
	(392171, 126, '2015-02-01 00:41:52.000000', 'consum', 0.0212, 'lps'),
	(392172, 126, '2015-02-01 00:41:53.000000', 'consum', 0.0213, 'lps'),
	(392173, 126, '2015-02-01 00:41:54.000000', 'consum', 0.0219, 'lps'),
	(392174, 126, '2015-02-01 00:41:55.000000', 'consum', 0.0214, 'lps'),
	(392175, 126, '2015-02-01 00:41:56.000000', 'consum', 0.0222, 'lps'),
	(392176, 126, '2015-02-01 00:41:57.000000', 'consum', 0.0212, 'lps'),
	(392177, 126, '2015-02-01 00:41:58.000000', 'consum', 0.0215, 'lps'),
	(392178, 126, '2015-02-01 00:41:59.000000', 'consum', 0.0214, 'lps'),
	(392179, 126, '2015-02-01 00:42:00.000000', 'consum', 0.0217, 'lps'),
	(392180, 126, '2015-02-01 00:42:01.000000', 'consum', 0.0218, 'lps'),
	(392181, 126, '2015-02-01 00:42:02.000000', 'consum', 0.0213, 'lps'),
	(392182, 126, '2015-02-01 00:42:03.000000', 'consum', 0.0217, 'lps'),
	(392183, 126, '2015-02-01 00:42:04.000000', 'consum', 0.0222, 'lps'),
	(392184, 126, '2015-02-01 00:42:05.000000', 'consum', 0.0221, 'lps'),
	(392185, 126, '2015-02-01 00:42:06.000000', 'consum', 0.0214, 'lps'),
	(392186, 126, '2015-02-01 00:42:07.000000', 'consum', 0.0211, 'lps'),
	(392187, 126, '2015-02-01 00:42:08.000000', 'consum', 0.0221, 'lps'),
	(392188, 126, '2015-02-01 00:42:09.000000', 'consum', 0.0217, 'lps'),
	(392189, 126, '2015-02-01 00:42:10.000000', 'consum', 0.0213, 'lps'),
	(392190, 126, '2015-02-01 00:42:11.000000', 'consum', 0.0219, 'lps'),
	(392191, 126, '2015-02-01 00:42:12.000000', 'consum', 0.0218, 'lps'),
	(392192, 126, '2015-02-01 00:42:13.000000', 'consum', 0.0224, 'lps'),
	(392193, 126, '2015-02-01 00:42:14.000000', 'consum', 0.0224, 'lps'),
	(392194, 126, '2015-02-01 00:42:15.000000', 'consum', 0.0224, 'lps'),
	(392195, 126, '2015-02-01 00:42:16.000000', 'consum', 0.0224, 'lps'),
	(392196, 126, '2015-02-01 00:42:17.000000', 'consum', 0.0210, 'lps'),
	(392197, 126, '2015-02-01 00:42:18.000000', 'consum', 0.0210, 'lps'),
	(392198, 126, '2015-02-01 00:42:19.000000', 'consum', 0.0214, 'lps'),
	(392199, 126, '2015-02-01 00:42:20.000000', 'consum', 0.0215, 'lps'),
	(392200, 126, '2015-02-01 00:42:21.000000', 'consum', 0.0222, 'lps'),
	(392201, 126, '2015-02-01 00:42:22.000000', 'consum', 0.0213, 'lps'),
	(392202, 126, '2015-02-01 00:42:23.000000', 'consum', 0.0218, 'lps'),
	(392203, 126, '2015-02-01 00:42:24.000000', 'consum', 0.0214, 'lps'),
	(392204, 126, '2015-02-01 00:42:25.000000', 'consum', 0.0218, 'lps'),
	(392205, 126, '2015-02-01 00:42:26.000000', 'consum', 0.0211, 'lps'),
	(392206, 126, '2015-02-01 00:42:27.000000', 'consum', 0.0221, 'lps'),
	(392207, 126, '2015-02-01 00:42:28.000000', 'consum', 0.0215, 'lps'),
	(392208, 126, '2015-02-01 00:42:29.000000', 'consum', 0.0220, 'lps'),
	(392209, 126, '2015-02-01 00:42:30.000000', 'consum', 0.0213, 'lps'),
	(392210, 126, '2015-02-01 00:42:31.000000', 'consum', 0.0212, 'lps'),
	(392211, 126, '2015-02-01 00:42:32.000000', 'consum', 0.0210, 'lps'),
	(392212, 126, '2015-02-01 00:42:33.000000', 'consum', 0.0222, 'lps'),
	(392213, 126, '2015-02-01 00:42:34.000000', 'consum', 0.0211, 'lps'),
	(392214, 126, '2015-02-01 00:42:35.000000', 'consum', 0.0210, 'lps'),
	(392215, 126, '2015-02-01 00:42:36.000000', 'consum', 0.0223, 'lps'),
	(392216, 126, '2015-02-01 00:42:37.000000', 'consum', 0.0216, 'lps'),
	(392217, 126, '2015-02-01 00:42:38.000000', 'consum', 0.0217, 'lps'),
	(392218, 126, '2015-02-01 00:42:39.000000', 'consum', 0.0224, 'lps'),
	(392219, 126, '2015-02-01 00:42:40.000000', 'consum', 0.0217, 'lps'),
	(392220, 126, '2015-02-01 00:42:41.000000', 'consum', 0.0219, 'lps'),
	(392221, 126, '2015-02-01 00:42:42.000000', 'consum', 0.0217, 'lps'),
	(392222, 126, '2015-02-01 00:42:43.000000', 'consum', 0.0221, 'lps'),
	(392223, 126, '2015-02-01 00:42:44.000000', 'consum', 0.0213, 'lps'),
	(392224, 126, '2015-02-01 00:42:45.000000', 'consum', 0.0223, 'lps'),
	(392225, 126, '2015-02-01 00:42:46.000000', 'consum', 0.0223, 'lps'),
	(392226, 126, '2015-02-01 00:42:47.000000', 'consum', 0.0219, 'lps'),
	(392227, 126, '2015-02-01 00:42:48.000000', 'consum', 0.0216, 'lps'),
	(392228, 126, '2015-02-01 00:42:49.000000', 'consum', 0.0213, 'lps'),
	(392229, 126, '2015-02-01 00:42:50.000000', 'consum', 0.0210, 'lps'),
	(392230, 126, '2015-02-01 00:42:51.000000', 'consum', 0.0214, 'lps'),
	(392231, 126, '2015-02-01 00:42:52.000000', 'consum', 0.0218, 'lps'),
	(392232, 126, '2015-02-01 00:42:53.000000', 'consum', 0.0223, 'lps'),
	(392233, 126, '2015-02-01 00:42:54.000000', 'consum', 0.0220, 'lps'),
	(392234, 126, '2015-02-01 00:42:55.000000', 'consum', 0.0224, 'lps'),
	(392235, 126, '2015-02-01 00:42:56.000000', 'consum', 0.0218, 'lps'),
	(392236, 126, '2015-02-01 00:42:57.000000', 'consum', 0.0211, 'lps'),
	(392237, 126, '2015-02-01 00:42:58.000000', 'consum', 0.0220, 'lps'),
	(392238, 126, '2015-02-01 00:42:59.000000', 'consum', 0.0214, 'lps'),
	(392239, 126, '2015-02-01 00:43:00.000000', 'consum', 0.0217, 'lps'),
	(392240, 126, '2015-02-01 00:43:01.000000', 'consum', 0.0215, 'lps'),
	(392241, 126, '2015-02-01 00:43:02.000000', 'consum', 0.0216, 'lps'),
	(392242, 126, '2015-02-01 00:43:03.000000', 'consum', 0.0211, 'lps'),
	(392243, 126, '2015-02-01 00:43:04.000000', 'consum', 0.0210, 'lps'),
	(392244, 126, '2015-02-01 00:43:05.000000', 'consum', 0.0211, 'lps'),
	(392245, 126, '2015-02-01 00:43:06.000000', 'consum', 0.0213, 'lps'),
	(392246, 126, '2015-02-01 00:43:07.000000', 'consum', 0.0224, 'lps'),
	(392247, 126, '2015-02-01 00:43:08.000000', 'consum', 0.0213, 'lps'),
	(392248, 126, '2015-02-01 00:43:09.000000', 'consum', 0.0212, 'lps'),
	(392249, 126, '2015-02-01 00:43:10.000000', 'consum', 0.0210, 'lps'),
	(392250, 126, '2015-02-01 00:43:11.000000', 'consum', 0.0219, 'lps'),
	(392251, 126, '2015-02-01 00:43:12.000000', 'consum', 0.0213, 'lps'),
	(392252, 126, '2015-02-01 00:43:13.000000', 'consum', 0.0213, 'lps'),
	(392253, 126, '2015-02-01 00:43:14.000000', 'consum', 0.0215, 'lps'),
	(392254, 126, '2015-02-01 00:43:15.000000', 'consum', 0.0210, 'lps'),
	(392255, 126, '2015-02-01 00:43:16.000000', 'consum', 0.0214, 'lps'),
	(392256, 126, '2015-02-01 00:43:17.000000', 'consum', 0.0212, 'lps'),
	(392257, 126, '2015-02-01 00:43:18.000000', 'consum', 0.0211, 'lps'),
	(392258, 126, '2015-02-01 00:43:19.000000', 'consum', 0.0211, 'lps'),
	(392259, 126, '2015-02-01 00:43:20.000000', 'consum', 0.0211, 'lps'),
	(392260, 126, '2015-02-01 00:43:21.000000', 'consum', 0.0211, 'lps'),
	(392261, 126, '2015-02-01 00:43:22.000000', 'consum', 0.0215, 'lps'),
	(392262, 126, '2015-02-01 00:43:23.000000', 'consum', 0.0216, 'lps'),
	(392263, 126, '2015-02-01 00:43:24.000000', 'consum', 0.0211, 'lps'),
	(392264, 126, '2015-02-01 00:43:25.000000', 'consum', 0.0213, 'lps'),
	(392265, 126, '2015-02-01 00:43:26.000000', 'consum', 0.0220, 'lps'),
	(392266, 126, '2015-02-01 00:43:27.000000', 'consum', 0.0223, 'lps'),
	(392267, 126, '2015-02-01 00:43:28.000000', 'consum', 0.0214, 'lps'),
	(392268, 126, '2015-02-01 00:43:29.000000', 'consum', 0.0222, 'lps'),
	(392269, 126, '2015-02-01 00:43:30.000000', 'consum', 0.0216, 'lps'),
	(392270, 126, '2015-02-01 00:43:31.000000', 'consum', 0.0217, 'lps'),
	(392271, 126, '2015-02-01 00:43:32.000000', 'consum', 0.0212, 'lps'),
	(392272, 126, '2015-02-01 00:43:33.000000', 'consum', 0.0217, 'lps'),
	(392273, 126, '2015-02-01 00:43:34.000000', 'consum', 0.0222, 'lps'),
	(392274, 126, '2015-02-01 00:43:35.000000', 'consum', 0.0222, 'lps'),
	(392275, 126, '2015-02-01 00:43:36.000000', 'consum', 0.0220, 'lps'),
	(392276, 126, '2015-02-01 00:43:37.000000', 'consum', 0.0222, 'lps'),
	(392277, 126, '2015-02-01 00:43:38.000000', 'consum', 0.0212, 'lps'),
	(392278, 126, '2015-02-01 00:43:39.000000', 'consum', 0.0215, 'lps'),
	(392279, 126, '2015-02-01 00:43:40.000000', 'consum', 0.0215, 'lps'),
	(392280, 126, '2015-02-01 00:43:41.000000', 'consum', 0.0220, 'lps'),
	(392281, 126, '2015-02-01 00:43:42.000000', 'consum', 0.0214, 'lps'),
	(392282, 126, '2015-02-01 00:43:43.000000', 'consum', 0.0215, 'lps'),
	(392283, 126, '2015-02-01 00:43:44.000000', 'consum', 0.0224, 'lps'),
	(392284, 126, '2015-02-01 00:43:45.000000', 'consum', 0.0221, 'lps'),
	(392285, 126, '2015-02-01 00:43:46.000000', 'consum', 0.0224, 'lps'),
	(392286, 126, '2015-02-01 00:43:47.000000', 'consum', 0.0219, 'lps'),
	(392287, 126, '2015-02-01 00:43:48.000000', 'consum', 0.0211, 'lps'),
	(392288, 126, '2015-02-01 00:43:49.000000', 'consum', 0.0219, 'lps'),
	(392289, 126, '2015-02-01 00:43:50.000000', 'consum', 0.0222, 'lps'),
	(392290, 126, '2015-02-01 00:43:51.000000', 'consum', 0.0213, 'lps'),
	(392291, 126, '2015-02-01 00:43:52.000000', 'consum', 0.0221, 'lps'),
	(392292, 126, '2015-02-01 00:43:53.000000', 'consum', 0.0212, 'lps'),
	(392293, 126, '2015-02-01 00:43:54.000000', 'consum', 0.0217, 'lps'),
	(392294, 126, '2015-02-01 00:43:55.000000', 'consum', 0.0210, 'lps'),
	(392295, 126, '2015-02-01 00:43:56.000000', 'consum', 0.0220, 'lps'),
	(392296, 126, '2015-02-01 00:43:57.000000', 'consum', 0.0214, 'lps'),
	(392297, 126, '2015-02-01 00:43:58.000000', 'consum', 0.0214, 'lps'),
	(392298, 126, '2015-02-01 00:43:59.000000', 'consum', 0.0221, 'lps'),
	(392299, 126, '2015-02-01 00:44:00.000000', 'consum', 0.0223, 'lps'),
	(392300, 126, '2015-02-01 00:44:01.000000', 'consum', 0.0213, 'lps'),
	(392301, 126, '2015-02-01 00:44:02.000000', 'consum', 0.0215, 'lps'),
	(392302, 126, '2015-02-01 00:44:03.000000', 'consum', 0.0213, 'lps'),
	(392303, 126, '2015-02-01 00:44:04.000000', 'consum', 0.0210, 'lps'),
	(392304, 126, '2015-02-01 00:44:05.000000', 'consum', 0.0218, 'lps'),
	(392305, 126, '2015-02-01 00:44:06.000000', 'consum', 0.0218, 'lps'),
	(392306, 126, '2015-02-01 00:44:07.000000', 'consum', 0.0211, 'lps'),
	(392307, 126, '2015-02-01 00:44:08.000000', 'consum', 0.0224, 'lps'),
	(392308, 126, '2015-02-01 00:44:09.000000', 'consum', 0.0216, 'lps'),
	(392309, 126, '2015-02-01 00:44:10.000000', 'consum', 0.0216, 'lps'),
	(392310, 126, '2015-02-01 00:44:11.000000', 'consum', 0.0220, 'lps'),
	(392311, 126, '2015-02-01 00:44:12.000000', 'consum', 0.0213, 'lps'),
	(392312, 126, '2015-02-01 00:44:13.000000', 'consum', 0.0212, 'lps'),
	(392313, 126, '2015-02-01 00:44:14.000000', 'consum', 0.0211, 'lps'),
	(392314, 126, '2015-02-01 00:44:15.000000', 'consum', 0.0210, 'lps'),
	(392315, 126, '2015-02-01 00:44:16.000000', 'consum', 0.0223, 'lps'),
	(392316, 126, '2015-02-01 00:44:17.000000', 'consum', 0.0216, 'lps'),
	(392317, 126, '2015-02-01 00:44:18.000000', 'consum', 0.0215, 'lps'),
	(392318, 126, '2015-02-01 00:44:19.000000', 'consum', 0.0217, 'lps'),
	(392319, 126, '2015-02-01 00:44:20.000000', 'consum', 0.0214, 'lps'),
	(392320, 126, '2015-02-01 00:44:21.000000', 'consum', 0.0213, 'lps'),
	(392321, 126, '2015-02-01 00:44:22.000000', 'consum', 0.0211, 'lps'),
	(392322, 126, '2015-02-01 00:44:23.000000', 'consum', 0.0223, 'lps'),
	(392323, 126, '2015-02-01 00:44:24.000000', 'consum', 0.0212, 'lps'),
	(392324, 126, '2015-02-01 00:44:25.000000', 'consum', 0.0213, 'lps'),
	(392325, 126, '2015-02-01 00:44:26.000000', 'consum', 0.0217, 'lps'),
	(392326, 126, '2015-02-01 00:44:27.000000', 'consum', 0.0223, 'lps'),
	(392327, 126, '2015-02-01 00:44:28.000000', 'consum', 0.0211, 'lps'),
	(392328, 126, '2015-02-01 00:44:29.000000', 'consum', 0.0219, 'lps'),
	(392329, 126, '2015-02-01 00:44:30.000000', 'consum', 0.0210, 'lps'),
	(392330, 126, '2015-02-01 00:44:31.000000', 'consum', 0.0212, 'lps'),
	(392331, 126, '2015-02-01 00:44:32.000000', 'consum', 0.0223, 'lps'),
	(392332, 126, '2015-02-01 00:44:33.000000', 'consum', 0.0221, 'lps'),
	(392333, 126, '2015-02-01 00:44:34.000000', 'consum', 0.0214, 'lps'),
	(392334, 126, '2015-02-01 00:44:35.000000', 'consum', 0.0210, 'lps'),
	(392335, 126, '2015-02-01 00:44:36.000000', 'consum', 0.0215, 'lps'),
	(392336, 126, '2015-02-01 00:44:37.000000', 'consum', 0.0222, 'lps'),
	(392337, 126, '2015-02-01 00:44:38.000000', 'consum', 0.0224, 'lps'),
	(392338, 126, '2015-02-01 00:44:39.000000', 'consum', 0.0213, 'lps'),
	(392339, 126, '2015-02-01 00:44:40.000000', 'consum', 0.0214, 'lps'),
	(392340, 126, '2015-02-01 00:44:41.000000', 'consum', 0.0221, 'lps'),
	(392341, 126, '2015-02-01 00:44:42.000000', 'consum', 0.0223, 'lps'),
	(392342, 126, '2015-02-01 00:44:43.000000', 'consum', 0.0215, 'lps'),
	(392343, 126, '2015-02-01 00:44:44.000000', 'consum', 0.0211, 'lps'),
	(392344, 126, '2015-02-01 00:44:45.000000', 'consum', 0.0213, 'lps'),
	(392345, 126, '2015-02-01 00:44:46.000000', 'consum', 0.0210, 'lps'),
	(392346, 126, '2015-02-01 00:44:47.000000', 'consum', 0.0215, 'lps'),
	(392347, 126, '2015-02-01 00:44:48.000000', 'consum', 0.0222, 'lps'),
	(392348, 126, '2015-02-01 00:44:49.000000', 'consum', 0.0212, 'lps'),
	(392349, 126, '2015-02-01 00:44:50.000000', 'consum', 0.0212, 'lps'),
	(392350, 126, '2015-02-01 00:44:51.000000', 'consum', 0.0213, 'lps'),
	(392351, 126, '2015-02-01 00:44:52.000000', 'consum', 0.0222, 'lps'),
	(392352, 126, '2015-02-01 00:44:53.000000', 'consum', 0.0217, 'lps'),
	(392353, 126, '2015-02-01 00:44:54.000000', 'consum', 0.0224, 'lps'),
	(392354, 126, '2015-02-01 00:44:55.000000', 'consum', 0.0214, 'lps'),
	(392355, 126, '2015-02-01 00:44:56.000000', 'consum', 0.0220, 'lps'),
	(392356, 126, '2015-02-01 00:44:57.000000', 'consum', 0.0216, 'lps'),
	(392357, 126, '2015-02-01 00:44:58.000000', 'consum', 0.0210, 'lps'),
	(392358, 126, '2015-02-01 00:44:59.000000', 'consum', 0.0223, 'lps'),
	(392359, 126, '2015-02-01 00:45:00.000000', 'consum', 0.0215, 'lps'),
	(392360, 126, '2015-02-01 00:45:01.000000', 'consum', 0.0211, 'lps'),
	(392361, 126, '2015-02-01 00:45:02.000000', 'consum', 0.0218, 'lps'),
	(392362, 126, '2015-02-01 00:45:03.000000', 'consum', 0.0215, 'lps'),
	(392363, 126, '2015-02-01 00:45:04.000000', 'consum', 0.0214, 'lps'),
	(392364, 126, '2015-02-01 00:45:05.000000', 'consum', 0.0213, 'lps'),
	(392365, 126, '2015-02-01 00:45:06.000000', 'consum', 0.0213, 'lps'),
	(392366, 126, '2015-02-01 00:45:07.000000', 'consum', 0.0216, 'lps'),
	(392367, 126, '2015-02-01 00:45:08.000000', 'consum', 0.0219, 'lps'),
	(392368, 126, '2015-02-01 00:45:09.000000', 'consum', 0.0221, 'lps'),
	(392369, 126, '2015-02-01 00:45:10.000000', 'consum', 0.0223, 'lps'),
	(392370, 126, '2015-02-01 00:45:11.000000', 'consum', 0.0212, 'lps'),
	(392371, 126, '2015-02-01 00:45:12.000000', 'consum', 0.0213, 'lps'),
	(392372, 126, '2015-02-01 00:45:13.000000', 'consum', 0.0220, 'lps'),
	(392373, 126, '2015-02-01 00:45:14.000000', 'consum', 0.0221, 'lps'),
	(392374, 126, '2015-02-01 00:45:15.000000', 'consum', 0.0219, 'lps'),
	(392375, 126, '2015-02-01 00:45:16.000000', 'consum', 0.0224, 'lps'),
	(392376, 126, '2015-02-01 00:45:17.000000', 'consum', 0.0222, 'lps'),
	(392377, 126, '2015-02-01 00:45:18.000000', 'consum', 0.0212, 'lps'),
	(392378, 126, '2015-02-01 00:45:19.000000', 'consum', 0.0218, 'lps'),
	(392379, 126, '2015-02-01 00:45:20.000000', 'consum', 0.0213, 'lps'),
	(392380, 126, '2015-02-01 00:45:21.000000', 'consum', 0.0217, 'lps'),
	(392381, 126, '2015-02-01 00:45:22.000000', 'consum', 0.0222, 'lps'),
	(392382, 126, '2015-02-01 00:45:23.000000', 'consum', 0.0219, 'lps'),
	(392383, 126, '2015-02-01 00:45:24.000000', 'consum', 0.0219, 'lps'),
	(392384, 126, '2015-02-01 00:45:25.000000', 'consum', 0.0213, 'lps'),
	(392385, 126, '2015-02-01 00:45:26.000000', 'consum', 0.0212, 'lps'),
	(392386, 126, '2015-02-01 00:45:27.000000', 'consum', 0.0214, 'lps'),
	(392387, 126, '2015-02-01 00:45:28.000000', 'consum', 0.0222, 'lps'),
	(392388, 126, '2015-02-01 00:45:29.000000', 'consum', 0.0216, 'lps'),
	(392389, 126, '2015-02-01 00:45:30.000000', 'consum', 0.0219, 'lps'),
	(392390, 126, '2015-02-01 00:45:31.000000', 'consum', 0.0223, 'lps'),
	(392391, 126, '2015-02-01 00:45:32.000000', 'consum', 0.0216, 'lps'),
	(392392, 126, '2015-02-01 00:45:33.000000', 'consum', 0.0220, 'lps'),
	(392393, 126, '2015-02-01 00:45:34.000000', 'consum', 0.0210, 'lps'),
	(392394, 126, '2015-02-01 00:45:35.000000', 'consum', 0.0212, 'lps'),
	(392395, 126, '2015-02-01 00:45:36.000000', 'consum', 0.0219, 'lps'),
	(392396, 126, '2015-02-01 00:45:37.000000', 'consum', 0.0222, 'lps'),
	(392397, 126, '2015-02-01 00:45:38.000000', 'consum', 0.0213, 'lps'),
	(392398, 126, '2015-02-01 00:45:39.000000', 'consum', 0.0220, 'lps'),
	(392399, 126, '2015-02-01 00:45:40.000000', 'consum', 0.0220, 'lps'),
	(392400, 126, '2015-02-01 00:45:41.000000', 'consum', 0.0214, 'lps'),
	(392401, 126, '2015-02-01 00:45:42.000000', 'consum', 0.0217, 'lps'),
	(392402, 126, '2015-02-01 00:45:43.000000', 'consum', 0.0217, 'lps'),
	(392403, 126, '2015-02-01 00:45:44.000000', 'consum', 0.0211, 'lps'),
	(392404, 126, '2015-02-01 00:45:45.000000', 'consum', 0.0223, 'lps'),
	(392405, 126, '2015-02-01 00:45:46.000000', 'consum', 0.0215, 'lps'),
	(392406, 126, '2015-02-01 00:45:47.000000', 'consum', 0.0223, 'lps'),
	(392407, 126, '2015-02-01 00:45:48.000000', 'consum', 0.0219, 'lps'),
	(392408, 126, '2015-02-01 00:45:49.000000', 'consum', 0.0215, 'lps'),
	(392409, 126, '2015-02-01 00:45:50.000000', 'consum', 0.0210, 'lps'),
	(392410, 126, '2015-02-01 00:45:51.000000', 'consum', 0.0211, 'lps'),
	(392411, 126, '2015-02-01 00:45:52.000000', 'consum', 0.0216, 'lps'),
	(392412, 126, '2015-02-01 00:45:53.000000', 'consum', 0.0221, 'lps'),
	(392413, 126, '2015-02-01 00:45:54.000000', 'consum', 0.0216, 'lps'),
	(392414, 126, '2015-02-01 00:45:55.000000', 'consum', 0.0210, 'lps'),
	(392415, 126, '2015-02-01 00:45:56.000000', 'consum', 0.0223, 'lps'),
	(392416, 126, '2015-02-01 00:45:57.000000', 'consum', 0.0213, 'lps'),
	(392417, 126, '2015-02-01 00:45:58.000000', 'consum', 0.0217, 'lps'),
	(392418, 126, '2015-02-01 00:45:59.000000', 'consum', 0.0220, 'lps'),
	(392419, 126, '2015-02-01 00:46:00.000000', 'consum', 0.0210, 'lps'),
	(392420, 126, '2015-02-01 00:46:01.000000', 'consum', 0.0213, 'lps'),
	(392421, 126, '2015-02-01 00:46:02.000000', 'consum', 0.0223, 'lps'),
	(392422, 126, '2015-02-01 00:46:03.000000', 'consum', 0.0224, 'lps'),
	(392423, 126, '2015-02-01 00:46:04.000000', 'consum', 0.0223, 'lps'),
	(392424, 126, '2015-02-01 00:46:05.000000', 'consum', 0.0221, 'lps'),
	(392425, 126, '2015-02-01 00:46:06.000000', 'consum', 0.0212, 'lps'),
	(392426, 126, '2015-02-01 00:46:07.000000', 'consum', 0.0217, 'lps'),
	(392427, 126, '2015-02-01 00:46:08.000000', 'consum', 0.0224, 'lps'),
	(392428, 126, '2015-02-01 00:46:09.000000', 'consum', 0.0217, 'lps'),
	(392429, 126, '2015-02-01 00:46:10.000000', 'consum', 0.0215, 'lps'),
	(392430, 126, '2015-02-01 00:46:11.000000', 'consum', 0.0217, 'lps'),
	(392431, 126, '2015-02-01 00:46:12.000000', 'consum', 0.0216, 'lps'),
	(392432, 126, '2015-02-01 00:46:13.000000', 'consum', 0.0217, 'lps'),
	(392433, 126, '2015-02-01 00:46:14.000000', 'consum', 0.0212, 'lps'),
	(392434, 126, '2015-02-01 00:46:15.000000', 'consum', 0.0217, 'lps'),
	(392435, 126, '2015-02-01 00:46:16.000000', 'consum', 0.0223, 'lps'),
	(392436, 126, '2015-02-01 00:46:17.000000', 'consum', 0.0210, 'lps'),
	(392437, 126, '2015-02-01 00:46:18.000000', 'consum', 0.0218, 'lps'),
	(392438, 126, '2015-02-01 00:46:19.000000', 'consum', 0.0218, 'lps'),
	(392439, 126, '2015-02-01 00:46:20.000000', 'consum', 0.0211, 'lps'),
	(392440, 126, '2015-02-01 00:46:21.000000', 'consum', 0.0221, 'lps'),
	(392441, 126, '2015-02-01 00:46:22.000000', 'consum', 0.0220, 'lps'),
	(392442, 126, '2015-02-01 00:46:23.000000', 'consum', 0.0212, 'lps'),
	(392443, 126, '2015-02-01 00:46:24.000000', 'consum', 0.0222, 'lps'),
	(392444, 126, '2015-02-01 00:46:25.000000', 'consum', 0.0219, 'lps'),
	(392445, 126, '2015-02-01 00:46:26.000000', 'consum', 0.0219, 'lps'),
	(392446, 126, '2015-02-01 00:46:27.000000', 'consum', 0.0213, 'lps'),
	(392447, 126, '2015-02-01 00:46:28.000000', 'consum', 0.0215, 'lps'),
	(392448, 126, '2015-02-01 00:46:29.000000', 'consum', 0.0212, 'lps'),
	(392449, 126, '2015-02-01 00:46:30.000000', 'consum', 0.0222, 'lps'),
	(392450, 126, '2015-02-01 00:46:31.000000', 'consum', 0.0216, 'lps'),
	(392451, 126, '2015-02-01 00:46:32.000000', 'consum', 0.0220, 'lps'),
	(392452, 126, '2015-02-01 00:46:33.000000', 'consum', 0.0213, 'lps'),
	(392453, 126, '2015-02-01 00:46:34.000000', 'consum', 0.0212, 'lps'),
	(392454, 126, '2015-02-01 00:46:35.000000', 'consum', 0.0211, 'lps'),
	(392455, 126, '2015-02-01 00:46:36.000000', 'consum', 0.0210, 'lps'),
	(392456, 126, '2015-02-01 00:46:37.000000', 'consum', 0.0222, 'lps'),
	(392457, 126, '2015-02-01 00:46:38.000000', 'consum', 0.0212, 'lps'),
	(392458, 126, '2015-02-01 00:46:39.000000', 'consum', 0.0214, 'lps'),
	(392459, 126, '2015-02-01 00:46:40.000000', 'consum', 0.0211, 'lps'),
	(392460, 126, '2015-02-01 00:46:41.000000', 'consum', 0.0217, 'lps'),
	(392461, 126, '2015-02-01 00:46:42.000000', 'consum', 0.0212, 'lps'),
	(392462, 126, '2015-02-01 00:46:43.000000', 'consum', 0.0214, 'lps'),
	(392463, 126, '2015-02-01 00:46:44.000000', 'consum', 0.0212, 'lps'),
	(392464, 126, '2015-02-01 00:46:45.000000', 'consum', 0.0222, 'lps'),
	(392465, 126, '2015-02-01 00:46:46.000000', 'consum', 0.0220, 'lps'),
	(392466, 126, '2015-02-01 00:46:47.000000', 'consum', 0.0224, 'lps'),
	(392467, 126, '2015-02-01 00:46:48.000000', 'consum', 0.0221, 'lps'),
	(392468, 126, '2015-02-01 00:46:49.000000', 'consum', 0.0224, 'lps'),
	(392469, 126, '2015-02-01 00:46:50.000000', 'consum', 0.0215, 'lps'),
	(392470, 126, '2015-02-01 00:46:51.000000', 'consum', 0.0211, 'lps'),
	(392471, 126, '2015-02-01 00:46:52.000000', 'consum', 0.0217, 'lps'),
	(392472, 126, '2015-02-01 00:46:53.000000', 'consum', 0.0210, 'lps'),
	(392473, 126, '2015-02-01 00:46:54.000000', 'consum', 0.0220, 'lps'),
	(392474, 126, '2015-02-01 00:46:55.000000', 'consum', 0.0217, 'lps'),
	(392475, 126, '2015-02-01 00:46:56.000000', 'consum', 0.0216, 'lps'),
	(392476, 126, '2015-02-01 00:46:57.000000', 'consum', 0.0220, 'lps'),
	(392477, 126, '2015-02-01 00:46:58.000000', 'consum', 0.0212, 'lps'),
	(392478, 126, '2015-02-01 00:46:59.000000', 'consum', 0.0220, 'lps'),
	(392479, 126, '2015-02-01 00:47:00.000000', 'consum', 0.0210, 'lps'),
	(392480, 126, '2015-02-01 00:47:01.000000', 'consum', 0.0223, 'lps'),
	(392481, 126, '2015-02-01 00:47:02.000000', 'consum', 0.0219, 'lps'),
	(392482, 126, '2015-02-01 00:47:03.000000', 'consum', 0.0215, 'lps'),
	(392483, 126, '2015-02-01 00:47:04.000000', 'consum', 0.0224, 'lps'),
	(392484, 126, '2015-02-01 00:47:05.000000', 'consum', 0.0220, 'lps'),
	(392485, 126, '2015-02-01 00:47:06.000000', 'consum', 0.0218, 'lps'),
	(392486, 126, '2015-02-01 00:47:07.000000', 'consum', 0.0222, 'lps'),
	(392487, 126, '2015-02-01 00:47:08.000000', 'consum', 0.0215, 'lps'),
	(392488, 126, '2015-02-01 00:47:09.000000', 'consum', 0.0216, 'lps'),
	(392489, 126, '2015-02-01 00:47:10.000000', 'consum', 0.0223, 'lps'),
	(392490, 126, '2015-02-01 00:47:11.000000', 'consum', 0.0216, 'lps'),
	(392491, 126, '2015-02-01 00:47:12.000000', 'consum', 0.0214, 'lps'),
	(392492, 126, '2015-02-01 00:47:13.000000', 'consum', 0.0213, 'lps'),
	(392493, 126, '2015-02-01 00:47:14.000000', 'consum', 0.0216, 'lps'),
	(392494, 126, '2015-02-01 00:47:15.000000', 'consum', 0.0214, 'lps'),
	(392495, 126, '2015-02-01 00:47:16.000000', 'consum', 0.0212, 'lps'),
	(392496, 126, '2015-02-01 00:47:17.000000', 'consum', 0.0211, 'lps'),
	(392497, 126, '2015-02-01 00:47:18.000000', 'consum', 0.0221, 'lps'),
	(392498, 126, '2015-02-01 00:47:19.000000', 'consum', 0.0220, 'lps'),
	(392499, 126, '2015-02-01 00:47:20.000000', 'consum', 0.0211, 'lps'),
	(392500, 126, '2015-02-01 00:47:21.000000', 'consum', 0.0214, 'lps'),
	(392501, 126, '2015-02-01 00:47:22.000000', 'consum', 0.0214, 'lps'),
	(392502, 126, '2015-02-01 00:47:23.000000', 'consum', 0.0218, 'lps'),
	(392503, 126, '2015-02-01 00:47:24.000000', 'consum', 0.0210, 'lps'),
	(392504, 126, '2015-02-01 00:47:25.000000', 'consum', 0.0215, 'lps'),
	(392505, 126, '2015-02-01 00:47:26.000000', 'consum', 0.0223, 'lps'),
	(392506, 126, '2015-02-01 00:47:27.000000', 'consum', 0.0214, 'lps'),
	(392507, 126, '2015-02-01 00:47:28.000000', 'consum', 0.0219, 'lps'),
	(392508, 126, '2015-02-01 00:47:29.000000', 'consum', 0.0217, 'lps'),
	(392509, 126, '2015-02-01 00:47:30.000000', 'consum', 0.0219, 'lps'),
	(392510, 126, '2015-02-01 00:47:31.000000', 'consum', 0.0218, 'lps'),
	(392511, 126, '2015-02-01 00:47:32.000000', 'consum', 0.0223, 'lps'),
	(392512, 126, '2015-02-01 00:47:33.000000', 'consum', 0.0220, 'lps'),
	(392513, 126, '2015-02-01 00:47:34.000000', 'consum', 0.0222, 'lps'),
	(392514, 126, '2015-02-01 00:47:35.000000', 'consum', 0.0212, 'lps'),
	(392515, 126, '2015-02-01 00:47:36.000000', 'consum', 0.0215, 'lps'),
	(392516, 126, '2015-02-01 00:47:37.000000', 'consum', 0.0216, 'lps'),
	(392517, 126, '2015-02-01 00:47:38.000000', 'consum', 0.0223, 'lps'),
	(392518, 126, '2015-02-01 00:47:39.000000', 'consum', 0.0212, 'lps'),
	(392519, 126, '2015-02-01 00:47:40.000000', 'consum', 0.0210, 'lps'),
	(392520, 126, '2015-02-01 00:47:41.000000', 'consum', 0.0222, 'lps'),
	(392521, 126, '2015-02-01 00:47:42.000000', 'consum', 0.0210, 'lps'),
	(392522, 126, '2015-02-01 00:47:43.000000', 'consum', 0.0220, 'lps'),
	(392523, 126, '2015-02-01 00:47:44.000000', 'consum', 0.0215, 'lps'),
	(392524, 126, '2015-02-01 00:47:45.000000', 'consum', 0.0219, 'lps'),
	(392525, 126, '2015-02-01 00:47:46.000000', 'consum', 0.0213, 'lps'),
	(392526, 126, '2015-02-01 00:47:47.000000', 'consum', 0.0212, 'lps'),
	(392527, 126, '2015-02-01 00:47:48.000000', 'consum', 0.0214, 'lps'),
	(392528, 126, '2015-02-01 00:47:49.000000', 'consum', 0.0223, 'lps'),
	(392529, 126, '2015-02-01 00:47:50.000000', 'consum', 0.0219, 'lps'),
	(392530, 126, '2015-02-01 00:47:51.000000', 'consum', 0.0215, 'lps'),
	(392531, 126, '2015-02-01 00:47:52.000000', 'consum', 0.0222, 'lps'),
	(392532, 126, '2015-02-01 00:47:53.000000', 'consum', 0.0213, 'lps'),
	(392533, 126, '2015-02-01 00:47:54.000000', 'consum', 0.0220, 'lps'),
	(392534, 126, '2015-02-01 00:47:55.000000', 'consum', 0.0219, 'lps'),
	(392535, 126, '2015-02-01 00:47:56.000000', 'consum', 0.0213, 'lps'),
	(392536, 126, '2015-02-01 00:47:57.000000', 'consum', 0.0211, 'lps'),
	(392537, 126, '2015-02-01 00:47:58.000000', 'consum', 0.0221, 'lps'),
	(392538, 126, '2015-02-01 00:47:59.000000', 'consum', 0.0217, 'lps'),
	(392539, 126, '2015-02-01 00:48:00.000000', 'consum', 0.0213, 'lps'),
	(392540, 126, '2015-02-01 00:48:01.000000', 'consum', 0.0221, 'lps'),
	(392541, 126, '2015-02-01 00:48:02.000000', 'consum', 0.0212, 'lps'),
	(392542, 126, '2015-02-01 00:48:03.000000', 'consum', 0.0219, 'lps'),
	(392543, 126, '2015-02-01 00:48:04.000000', 'consum', 0.0216, 'lps'),
	(392544, 126, '2015-02-01 00:48:05.000000', 'consum', 0.0215, 'lps'),
	(392545, 126, '2015-02-01 00:48:06.000000', 'consum', 0.0216, 'lps'),
	(392546, 126, '2015-02-01 00:48:07.000000', 'consum', 0.0210, 'lps'),
	(392547, 126, '2015-02-01 00:48:08.000000', 'consum', 0.0223, 'lps'),
	(392548, 126, '2015-02-01 00:48:09.000000', 'consum', 0.0216, 'lps'),
	(392549, 126, '2015-02-01 00:48:10.000000', 'consum', 0.0217, 'lps'),
	(392550, 126, '2015-02-01 00:48:11.000000', 'consum', 0.0210, 'lps'),
	(392551, 126, '2015-02-01 00:48:12.000000', 'consum', 0.0222, 'lps'),
	(392552, 126, '2015-02-01 00:48:13.000000', 'consum', 0.0210, 'lps'),
	(392553, 126, '2015-02-01 00:48:14.000000', 'consum', 0.0220, 'lps'),
	(392554, 126, '2015-02-01 00:48:15.000000', 'consum', 0.0213, 'lps'),
	(392555, 126, '2015-02-01 00:48:16.000000', 'consum', 0.0213, 'lps'),
	(392556, 126, '2015-02-01 00:48:17.000000', 'consum', 0.0214, 'lps'),
	(392557, 126, '2015-02-01 00:48:18.000000', 'consum', 0.0221, 'lps'),
	(392558, 126, '2015-02-01 00:48:19.000000', 'consum', 0.0211, 'lps'),
	(392559, 126, '2015-02-01 00:48:20.000000', 'consum', 0.0211, 'lps'),
	(392560, 126, '2015-02-01 00:48:21.000000', 'consum', 0.0215, 'lps'),
	(392561, 126, '2015-02-01 00:48:22.000000', 'consum', 0.0216, 'lps'),
	(392562, 126, '2015-02-01 00:48:23.000000', 'consum', 0.0211, 'lps'),
	(392563, 126, '2015-02-01 00:48:24.000000', 'consum', 0.0213, 'lps'),
	(392564, 126, '2015-02-01 00:48:25.000000', 'consum', 0.0222, 'lps'),
	(392565, 126, '2015-02-01 00:48:26.000000', 'consum', 0.0218, 'lps'),
	(392566, 126, '2015-02-01 00:48:27.000000', 'consum', 0.0212, 'lps'),
	(392567, 126, '2015-02-01 00:48:28.000000', 'consum', 0.0211, 'lps'),
	(392568, 126, '2015-02-01 00:48:29.000000', 'consum', 0.0224, 'lps'),
	(392569, 126, '2015-02-01 00:48:30.000000', 'consum', 0.0217, 'lps'),
	(392570, 126, '2015-02-01 00:48:31.000000', 'consum', 0.0219, 'lps'),
	(392571, 126, '2015-02-01 00:48:32.000000', 'consum', 0.0221, 'lps'),
	(392572, 126, '2015-02-01 00:48:33.000000', 'consum', 0.0221, 'lps'),
	(392573, 126, '2015-02-01 00:48:34.000000', 'consum', 0.0219, 'lps'),
	(392574, 126, '2015-02-01 00:48:35.000000', 'consum', 0.0222, 'lps'),
	(392575, 126, '2015-02-01 00:48:36.000000', 'consum', 0.0215, 'lps'),
	(392576, 126, '2015-02-01 00:48:37.000000', 'consum', 0.0216, 'lps'),
	(392577, 126, '2015-02-01 00:48:38.000000', 'consum', 0.0222, 'lps'),
	(392578, 126, '2015-02-01 00:48:39.000000', 'consum', 0.0211, 'lps'),
	(392579, 126, '2015-02-01 00:48:40.000000', 'consum', 0.0221, 'lps'),
	(392580, 126, '2015-02-01 00:48:41.000000', 'consum', 0.0219, 'lps'),
	(392581, 126, '2015-02-01 00:48:42.000000', 'consum', 0.0222, 'lps'),
	(392582, 126, '2015-02-01 00:48:43.000000', 'consum', 0.0215, 'lps'),
	(392583, 126, '2015-02-01 00:48:44.000000', 'consum', 0.0213, 'lps'),
	(392584, 126, '2015-02-01 00:48:45.000000', 'consum', 0.0213, 'lps'),
	(392585, 126, '2015-02-01 00:48:46.000000', 'consum', 0.0214, 'lps'),
	(392586, 126, '2015-02-01 00:48:47.000000', 'consum', 0.0222, 'lps'),
	(392587, 126, '2015-02-01 00:48:48.000000', 'consum', 0.0214, 'lps'),
	(392588, 126, '2015-02-01 00:48:49.000000', 'consum', 0.0210, 'lps'),
	(392589, 126, '2015-02-01 00:48:50.000000', 'consum', 0.0211, 'lps'),
	(392590, 126, '2015-02-01 00:48:51.000000', 'consum', 0.0216, 'lps'),
	(392591, 126, '2015-02-01 00:48:52.000000', 'consum', 0.0210, 'lps'),
	(392592, 126, '2015-02-01 00:48:53.000000', 'consum', 0.0222, 'lps'),
	(392593, 126, '2015-02-01 00:48:54.000000', 'consum', 0.0210, 'lps'),
	(392594, 126, '2015-02-01 00:48:55.000000', 'consum', 0.0221, 'lps'),
	(392595, 126, '2015-02-01 00:48:56.000000', 'consum', 0.0220, 'lps'),
	(392596, 126, '2015-02-01 00:48:57.000000', 'consum', 0.0212, 'lps'),
	(392597, 126, '2015-02-01 00:48:58.000000', 'consum', 0.0220, 'lps'),
	(392598, 126, '2015-02-01 00:48:59.000000', 'consum', 0.0210, 'lps'),
	(392599, 126, '2015-02-01 00:49:00.000000', 'consum', 0.0224, 'lps'),
	(392600, 126, '2015-02-01 00:49:01.000000', 'consum', 0.0223, 'lps'),
	(392601, 126, '2015-02-01 00:49:02.000000', 'consum', 0.0219, 'lps'),
	(392602, 126, '2015-02-01 00:49:03.000000', 'consum', 0.0215, 'lps'),
	(392603, 126, '2015-02-01 00:49:04.000000', 'consum', 0.0210, 'lps'),
	(392604, 126, '2015-02-01 00:49:05.000000', 'consum', 0.0224, 'lps'),
	(392605, 126, '2015-02-01 00:49:06.000000', 'consum', 0.0221, 'lps'),
	(392606, 126, '2015-02-01 00:49:07.000000', 'consum', 0.0210, 'lps'),
	(392607, 126, '2015-02-01 00:49:08.000000', 'consum', 0.0220, 'lps'),
	(392608, 126, '2015-02-01 00:49:09.000000', 'consum', 0.0216, 'lps'),
	(392609, 126, '2015-02-01 00:49:10.000000', 'consum', 0.0211, 'lps'),
	(392610, 126, '2015-02-01 00:49:11.000000', 'consum', 0.0210, 'lps'),
	(392611, 126, '2015-02-01 00:49:12.000000', 'consum', 0.0211, 'lps'),
	(392612, 126, '2015-02-01 00:49:13.000000', 'consum', 0.0213, 'lps'),
	(392613, 126, '2015-02-01 00:49:14.000000', 'consum', 0.0222, 'lps'),
	(392614, 126, '2015-02-01 00:49:15.000000', 'consum', 0.0216, 'lps'),
	(392615, 126, '2015-02-01 00:49:16.000000', 'consum', 0.0222, 'lps'),
	(392616, 126, '2015-02-01 00:49:17.000000', 'consum', 0.0222, 'lps'),
	(392617, 126, '2015-02-01 00:49:18.000000', 'consum', 0.0219, 'lps'),
	(392618, 126, '2015-02-01 00:49:19.000000', 'consum', 0.0219, 'lps'),
	(392619, 126, '2015-02-01 00:49:20.000000', 'consum', 0.0212, 'lps'),
	(392620, 126, '2015-02-01 00:49:21.000000', 'consum', 0.0211, 'lps'),
	(392621, 126, '2015-02-01 00:49:22.000000', 'consum', 0.0223, 'lps'),
	(392622, 126, '2015-02-01 00:49:23.000000', 'consum', 0.0211, 'lps'),
	(392623, 126, '2015-02-01 00:49:24.000000', 'consum', 0.0224, 'lps'),
	(392624, 126, '2015-02-01 00:49:25.000000', 'consum', 0.0216, 'lps'),
	(392625, 126, '2015-02-01 00:49:26.000000', 'consum', 0.0213, 'lps'),
	(392626, 126, '2015-02-01 00:49:27.000000', 'consum', 0.0222, 'lps'),
	(392627, 126, '2015-02-01 00:49:28.000000', 'consum', 0.0218, 'lps'),
	(392628, 126, '2015-02-01 00:49:29.000000', 'consum', 0.0216, 'lps'),
	(392629, 126, '2015-02-01 00:49:30.000000', 'consum', 0.0214, 'lps'),
	(392630, 126, '2015-02-01 00:49:31.000000', 'consum', 0.0212, 'lps'),
	(392631, 126, '2015-02-01 00:49:32.000000', 'consum', 0.0223, 'lps'),
	(392632, 126, '2015-02-01 00:49:33.000000', 'consum', 0.0212, 'lps'),
	(392633, 126, '2015-02-01 00:49:34.000000', 'consum', 0.0212, 'lps'),
	(392634, 126, '2015-02-01 00:49:35.000000', 'consum', 0.0215, 'lps'),
	(392635, 126, '2015-02-01 00:49:36.000000', 'consum', 0.0215, 'lps'),
	(392636, 126, '2015-02-01 00:49:37.000000', 'consum', 0.0220, 'lps'),
	(392637, 126, '2015-02-01 00:49:38.000000', 'consum', 0.0215, 'lps'),
	(392638, 126, '2015-02-01 00:49:39.000000', 'consum', 0.0221, 'lps'),
	(392639, 126, '2015-02-01 00:49:40.000000', 'consum', 0.0222, 'lps'),
	(392640, 126, '2015-02-01 00:49:41.000000', 'consum', 0.0219, 'lps'),
	(392641, 126, '2015-02-01 00:49:42.000000', 'consum', 0.0222, 'lps'),
	(392642, 126, '2015-02-01 00:49:43.000000', 'consum', 0.0214, 'lps'),
	(392643, 126, '2015-02-01 00:49:44.000000', 'consum', 0.0224, 'lps'),
	(392644, 126, '2015-02-01 00:49:45.000000', 'consum', 0.0210, 'lps'),
	(392645, 126, '2015-02-01 00:49:46.000000', 'consum', 0.0213, 'lps'),
	(392646, 126, '2015-02-01 00:49:47.000000', 'consum', 0.0224, 'lps'),
	(392647, 126, '2015-02-01 00:49:48.000000', 'consum', 0.0212, 'lps'),
	(392648, 126, '2015-02-01 00:49:49.000000', 'consum', 0.0224, 'lps'),
	(392649, 126, '2015-02-01 00:49:50.000000', 'consum', 0.0213, 'lps'),
	(392650, 126, '2015-02-01 00:49:51.000000', 'consum', 0.0216, 'lps'),
	(392651, 126, '2015-02-01 00:49:52.000000', 'consum', 0.0216, 'lps'),
	(392652, 126, '2015-02-01 00:49:53.000000', 'consum', 0.0222, 'lps'),
	(392653, 126, '2015-02-01 00:49:54.000000', 'consum', 0.0222, 'lps'),
	(392654, 126, '2015-02-01 00:49:55.000000', 'consum', 0.0221, 'lps'),
	(392655, 126, '2015-02-01 00:49:56.000000', 'consum', 0.0213, 'lps'),
	(392656, 126, '2015-02-01 00:49:57.000000', 'consum', 0.0223, 'lps'),
	(392657, 126, '2015-02-01 00:49:58.000000', 'consum', 0.0220, 'lps'),
	(392658, 126, '2015-02-01 00:49:59.000000', 'consum', 0.0224, 'lps'),
	(392659, 126, '2015-02-01 00:50:00.000000', 'consum', 0.0220, 'lps'),
	(392660, 126, '2015-02-01 00:50:01.000000', 'consum', 0.0218, 'lps'),
	(392661, 126, '2015-02-01 00:50:02.000000', 'consum', 0.0219, 'lps'),
	(392662, 126, '2015-02-01 00:50:03.000000', 'consum', 0.0217, 'lps'),
	(392663, 126, '2015-02-01 00:50:04.000000', 'consum', 0.0217, 'lps'),
	(392664, 126, '2015-02-01 00:50:05.000000', 'consum', 0.0211, 'lps'),
	(392665, 126, '2015-02-01 00:50:06.000000', 'consum', 0.0224, 'lps'),
	(392666, 126, '2015-02-01 00:50:07.000000', 'consum', 0.0219, 'lps'),
	(392667, 126, '2015-02-01 00:50:08.000000', 'consum', 0.0211, 'lps'),
	(392668, 126, '2015-02-01 00:50:09.000000', 'consum', 0.0221, 'lps'),
	(392669, 126, '2015-02-01 00:50:10.000000', 'consum', 0.0216, 'lps'),
	(392670, 126, '2015-02-01 00:50:11.000000', 'consum', 0.0224, 'lps'),
	(392671, 126, '2015-02-01 00:50:12.000000', 'consum', 0.0215, 'lps'),
	(392672, 126, '2015-02-01 00:50:13.000000', 'consum', 0.0210, 'lps'),
	(392673, 126, '2015-02-01 00:50:14.000000', 'consum', 0.0211, 'lps'),
	(392674, 126, '2015-02-01 00:50:15.000000', 'consum', 0.0213, 'lps'),
	(392675, 126, '2015-02-01 00:50:16.000000', 'consum', 0.0224, 'lps'),
	(392676, 126, '2015-02-01 00:50:17.000000', 'consum', 0.0212, 'lps'),
	(392677, 126, '2015-02-01 00:50:18.000000', 'consum', 0.0210, 'lps'),
	(392678, 126, '2015-02-01 00:50:19.000000', 'consum', 0.0218, 'lps'),
	(392679, 126, '2015-02-01 00:50:20.000000', 'consum', 0.0220, 'lps'),
	(392680, 126, '2015-02-01 00:50:21.000000', 'consum', 0.0221, 'lps'),
	(392681, 126, '2015-02-01 00:50:22.000000', 'consum', 0.0220, 'lps'),
	(392682, 126, '2015-02-01 00:50:23.000000', 'consum', 0.0215, 'lps'),
	(392683, 126, '2015-02-01 00:50:24.000000', 'consum', 0.0221, 'lps'),
	(392684, 126, '2015-02-01 00:50:25.000000', 'consum', 0.0220, 'lps'),
	(392685, 126, '2015-02-01 00:50:26.000000', 'consum', 0.0214, 'lps'),
	(392686, 126, '2015-02-01 00:50:27.000000', 'consum', 0.0213, 'lps'),
	(392687, 126, '2015-02-01 00:50:28.000000', 'consum', 0.0213, 'lps'),
	(392688, 126, '2015-02-01 00:50:29.000000', 'consum', 0.0216, 'lps'),
	(392689, 126, '2015-02-01 00:50:30.000000', 'consum', 0.0216, 'lps'),
	(392690, 126, '2015-02-01 00:50:31.000000', 'consum', 0.0210, 'lps'),
	(392691, 126, '2015-02-01 00:50:32.000000', 'consum', 0.0220, 'lps'),
	(392692, 126, '2015-02-01 00:50:33.000000', 'consum', 0.0217, 'lps'),
	(392693, 126, '2015-02-01 00:50:34.000000', 'consum', 0.0214, 'lps'),
	(392694, 126, '2015-02-01 00:50:35.000000', 'consum', 0.0210, 'lps'),
	(392695, 126, '2015-02-01 00:50:36.000000', 'consum', 0.0214, 'lps'),
	(392696, 126, '2015-02-01 00:50:37.000000', 'consum', 0.0217, 'lps'),
	(392697, 126, '2015-02-01 00:50:38.000000', 'consum', 0.0216, 'lps'),
	(392698, 126, '2015-02-01 00:50:39.000000', 'consum', 0.0221, 'lps'),
	(392699, 126, '2015-02-01 00:50:40.000000', 'consum', 0.0218, 'lps'),
	(392700, 126, '2015-02-01 00:50:41.000000', 'consum', 0.0218, 'lps'),
	(392701, 126, '2015-02-01 00:50:42.000000', 'consum', 0.0211, 'lps'),
	(392702, 126, '2015-02-01 00:50:43.000000', 'consum', 0.0219, 'lps'),
	(392703, 126, '2015-02-01 00:50:44.000000', 'consum', 0.0210, 'lps'),
	(392704, 126, '2015-02-01 00:50:45.000000', 'consum', 0.0214, 'lps'),
	(392705, 126, '2015-02-01 00:50:46.000000', 'consum', 0.0213, 'lps'),
	(392706, 126, '2015-02-01 00:50:47.000000', 'consum', 0.0215, 'lps'),
	(392707, 126, '2015-02-01 00:50:48.000000', 'consum', 0.0212, 'lps'),
	(392708, 126, '2015-02-01 00:50:49.000000', 'consum', 0.0219, 'lps'),
	(392709, 126, '2015-02-01 00:50:50.000000', 'consum', 0.0221, 'lps'),
	(392710, 126, '2015-02-01 00:50:51.000000', 'consum', 0.0222, 'lps'),
	(392711, 126, '2015-02-01 00:50:52.000000', 'consum', 0.0222, 'lps'),
	(392712, 126, '2015-02-01 00:50:53.000000', 'consum', 0.0218, 'lps'),
	(392713, 126, '2015-02-01 00:50:54.000000', 'consum', 0.0217, 'lps'),
	(392714, 126, '2015-02-01 00:50:55.000000', 'consum', 0.0220, 'lps'),
	(392715, 126, '2015-02-01 00:50:56.000000', 'consum', 0.0212, 'lps'),
	(392716, 126, '2015-02-01 00:50:57.000000', 'consum', 0.0218, 'lps'),
	(392717, 126, '2015-02-01 00:50:58.000000', 'consum', 0.0217, 'lps'),
	(392718, 126, '2015-02-01 00:50:59.000000', 'consum', 0.0220, 'lps'),
	(392719, 126, '2015-02-01 00:51:00.000000', 'consum', 0.0223, 'lps'),
	(392720, 126, '2015-02-01 00:51:01.000000', 'consum', 0.0216, 'lps'),
	(392721, 126, '2015-02-01 00:51:02.000000', 'consum', 0.0217, 'lps'),
	(392722, 126, '2015-02-01 00:51:03.000000', 'consum', 0.0212, 'lps'),
	(392723, 126, '2015-02-01 00:51:04.000000', 'consum', 0.0215, 'lps'),
	(392724, 126, '2015-02-01 00:51:05.000000', 'consum', 0.0216, 'lps'),
	(392725, 126, '2015-02-01 00:51:06.000000', 'consum', 0.0224, 'lps'),
	(392726, 126, '2015-02-01 00:51:07.000000', 'consum', 0.0218, 'lps'),
	(392727, 126, '2015-02-01 00:51:08.000000', 'consum', 0.0221, 'lps'),
	(392728, 126, '2015-02-01 00:51:09.000000', 'consum', 0.0214, 'lps'),
	(392729, 126, '2015-02-01 00:51:10.000000', 'consum', 0.0212, 'lps'),
	(392730, 126, '2015-02-01 00:51:11.000000', 'consum', 0.0210, 'lps'),
	(392731, 126, '2015-02-01 00:51:12.000000', 'consum', 0.0220, 'lps'),
	(392732, 126, '2015-02-01 00:51:13.000000', 'consum', 0.0215, 'lps'),
	(392733, 126, '2015-02-01 00:51:14.000000', 'consum', 0.0218, 'lps'),
	(392734, 126, '2015-02-01 00:51:15.000000', 'consum', 0.0223, 'lps'),
	(392735, 126, '2015-02-01 00:51:16.000000', 'consum', 0.0220, 'lps'),
	(392736, 126, '2015-02-01 00:51:17.000000', 'consum', 0.0221, 'lps'),
	(392737, 126, '2015-02-01 00:51:18.000000', 'consum', 0.0220, 'lps'),
	(392738, 126, '2015-02-01 00:51:19.000000', 'consum', 0.0212, 'lps'),
	(392739, 126, '2015-02-01 00:51:20.000000', 'consum', 0.0223, 'lps'),
	(392740, 126, '2015-02-01 00:51:21.000000', 'consum', 0.0210, 'lps'),
	(392741, 126, '2015-02-01 00:51:22.000000', 'consum', 0.0216, 'lps'),
	(392742, 126, '2015-02-01 00:51:23.000000', 'consum', 0.0224, 'lps'),
	(392743, 126, '2015-02-01 00:51:24.000000', 'consum', 0.0216, 'lps'),
	(392744, 126, '2015-02-01 00:51:25.000000', 'consum', 0.0216, 'lps'),
	(392745, 126, '2015-02-01 00:51:26.000000', 'consum', 0.0221, 'lps'),
	(392746, 126, '2015-02-01 00:51:27.000000', 'consum', 0.0218, 'lps'),
	(392747, 126, '2015-02-01 00:51:28.000000', 'consum', 0.0216, 'lps'),
	(392748, 126, '2015-02-01 00:51:29.000000', 'consum', 0.0216, 'lps'),
	(392749, 126, '2015-02-01 00:51:30.000000', 'consum', 0.0224, 'lps'),
	(392750, 126, '2015-02-01 00:51:31.000000', 'consum', 0.0219, 'lps'),
	(392751, 126, '2015-02-01 00:51:32.000000', 'consum', 0.0214, 'lps'),
	(392752, 126, '2015-02-01 00:51:33.000000', 'consum', 0.0215, 'lps'),
	(392753, 126, '2015-02-01 00:51:34.000000', 'consum', 0.0211, 'lps'),
	(392754, 126, '2015-02-01 00:51:35.000000', 'consum', 0.0215, 'lps'),
	(392755, 126, '2015-02-01 00:51:36.000000', 'consum', 0.0219, 'lps'),
	(392756, 126, '2015-02-01 00:51:37.000000', 'consum', 0.0222, 'lps'),
	(392757, 126, '2015-02-01 00:51:38.000000', 'consum', 0.0216, 'lps'),
	(392758, 126, '2015-02-01 00:51:39.000000', 'consum', 0.0220, 'lps'),
	(392759, 126, '2015-02-01 00:51:40.000000', 'consum', 0.0213, 'lps'),
	(392760, 126, '2015-02-01 00:51:41.000000', 'consum', 0.0210, 'lps'),
	(392761, 126, '2015-02-01 00:51:42.000000', 'consum', 0.0216, 'lps'),
	(392762, 126, '2015-02-01 00:51:43.000000', 'consum', 0.0212, 'lps'),
	(392763, 126, '2015-02-01 00:51:44.000000', 'consum', 0.0218, 'lps'),
	(392764, 126, '2015-02-01 00:51:45.000000', 'consum', 0.0212, 'lps'),
	(392765, 126, '2015-02-01 00:51:46.000000', 'consum', 0.0213, 'lps'),
	(392766, 126, '2015-02-01 00:51:47.000000', 'consum', 0.0219, 'lps'),
	(392767, 126, '2015-02-01 00:51:48.000000', 'consum', 0.0218, 'lps'),
	(392768, 126, '2015-02-01 00:51:49.000000', 'consum', 0.0223, 'lps'),
	(392769, 126, '2015-02-01 00:51:50.000000', 'consum', 0.0223, 'lps'),
	(392770, 126, '2015-02-01 00:51:51.000000', 'consum', 0.0220, 'lps'),
	(392771, 126, '2015-02-01 00:51:52.000000', 'consum', 0.0222, 'lps'),
	(392772, 126, '2015-02-01 00:51:53.000000', 'consum', 0.0224, 'lps'),
	(392773, 126, '2015-02-01 00:51:54.000000', 'consum', 0.0215, 'lps'),
	(392774, 126, '2015-02-01 00:51:55.000000', 'consum', 0.0224, 'lps'),
	(392775, 126, '2015-02-01 00:51:56.000000', 'consum', 0.0220, 'lps'),
	(392776, 126, '2015-02-01 00:51:57.000000', 'consum', 0.0218, 'lps'),
	(392777, 126, '2015-02-01 00:51:58.000000', 'consum', 0.0220, 'lps'),
	(392778, 126, '2015-02-01 00:51:59.000000', 'consum', 0.0221, 'lps'),
	(392779, 126, '2015-02-01 00:52:00.000000', 'consum', 0.0223, 'lps'),
	(392780, 126, '2015-02-01 00:52:01.000000', 'consum', 0.0212, 'lps'),
	(392781, 126, '2015-02-01 00:52:02.000000', 'consum', 0.0212, 'lps'),
	(392782, 126, '2015-02-01 00:52:03.000000', 'consum', 0.0212, 'lps'),
	(392783, 126, '2015-02-01 00:52:04.000000', 'consum', 0.0216, 'lps'),
	(392784, 126, '2015-02-01 00:52:05.000000', 'consum', 0.0218, 'lps'),
	(392785, 126, '2015-02-01 00:52:06.000000', 'consum', 0.0220, 'lps'),
	(392786, 126, '2015-02-01 00:52:07.000000', 'consum', 0.0218, 'lps'),
	(392787, 126, '2015-02-01 00:52:08.000000', 'consum', 0.0224, 'lps'),
	(392788, 126, '2015-02-01 00:52:09.000000', 'consum', 0.0211, 'lps'),
	(392789, 126, '2015-02-01 00:52:10.000000', 'consum', 0.0219, 'lps'),
	(392790, 126, '2015-02-01 00:52:11.000000', 'consum', 0.0222, 'lps'),
	(392791, 126, '2015-02-01 00:52:12.000000', 'consum', 0.0213, 'lps'),
	(392792, 126, '2015-02-01 00:52:13.000000', 'consum', 0.0219, 'lps'),
	(392793, 126, '2015-02-01 00:52:14.000000', 'consum', 0.0219, 'lps'),
	(392794, 126, '2015-02-01 00:52:15.000000', 'consum', 0.0212, 'lps'),
	(392795, 126, '2015-02-01 00:52:16.000000', 'consum', 0.0223, 'lps'),
	(392796, 126, '2015-02-01 00:52:17.000000', 'consum', 0.0211, 'lps'),
	(392797, 126, '2015-02-01 00:52:18.000000', 'consum', 0.0220, 'lps'),
	(392798, 126, '2015-02-01 00:52:19.000000', 'consum', 0.0212, 'lps'),
	(392799, 126, '2015-02-01 00:52:20.000000', 'consum', 0.0222, 'lps'),
	(392800, 126, '2015-02-01 00:52:21.000000', 'consum', 0.0217, 'lps'),
	(392801, 126, '2015-02-01 00:52:22.000000', 'consum', 0.0211, 'lps'),
	(392802, 126, '2015-02-01 00:52:23.000000', 'consum', 0.0210, 'lps'),
	(392803, 126, '2015-02-01 00:52:24.000000', 'consum', 0.0224, 'lps'),
	(392804, 126, '2015-02-01 00:52:25.000000', 'consum', 0.0217, 'lps'),
	(392805, 126, '2015-02-01 00:52:26.000000', 'consum', 0.0221, 'lps'),
	(392806, 126, '2015-02-01 00:52:27.000000', 'consum', 0.0213, 'lps'),
	(392807, 126, '2015-02-01 00:52:28.000000', 'consum', 0.0222, 'lps'),
	(392808, 126, '2015-02-01 00:52:29.000000', 'consum', 0.0219, 'lps'),
	(392809, 126, '2015-02-01 00:52:30.000000', 'consum', 0.0217, 'lps'),
	(392810, 126, '2015-02-01 00:52:31.000000', 'consum', 0.0220, 'lps'),
	(392811, 126, '2015-02-01 00:52:32.000000', 'consum', 0.0210, 'lps'),
	(392812, 126, '2015-02-01 00:52:33.000000', 'consum', 0.0210, 'lps'),
	(392813, 126, '2015-02-01 00:52:34.000000', 'consum', 0.0210, 'lps'),
	(392814, 126, '2015-02-01 00:52:35.000000', 'consum', 0.0224, 'lps'),
	(392815, 126, '2015-02-01 00:52:36.000000', 'consum', 0.0224, 'lps'),
	(392816, 126, '2015-02-01 00:52:37.000000', 'consum', 0.0221, 'lps'),
	(392817, 126, '2015-02-01 00:52:38.000000', 'consum', 0.0222, 'lps'),
	(392818, 126, '2015-02-01 00:52:39.000000', 'consum', 0.0224, 'lps'),
	(392819, 126, '2015-02-01 00:52:40.000000', 'consum', 0.0215, 'lps'),
	(392820, 126, '2015-02-01 00:52:41.000000', 'consum', 0.0224, 'lps'),
	(392821, 126, '2015-02-01 00:52:42.000000', 'consum', 0.0220, 'lps'),
	(392822, 126, '2015-02-01 00:52:43.000000', 'consum', 0.0216, 'lps'),
	(392823, 126, '2015-02-01 00:52:44.000000', 'consum', 0.0214, 'lps'),
	(392824, 126, '2015-02-01 00:52:45.000000', 'consum', 0.0212, 'lps'),
	(392825, 126, '2015-02-01 00:52:46.000000', 'consum', 0.0221, 'lps'),
	(392826, 126, '2015-02-01 00:52:47.000000', 'consum', 0.0216, 'lps'),
	(392827, 126, '2015-02-01 00:52:48.000000', 'consum', 0.0224, 'lps'),
	(392828, 126, '2015-02-01 00:52:49.000000', 'consum', 0.0215, 'lps'),
	(392829, 126, '2015-02-01 00:52:50.000000', 'consum', 0.0211, 'lps'),
	(392830, 126, '2015-02-01 00:52:51.000000', 'consum', 0.0215, 'lps'),
	(392831, 126, '2015-02-01 00:52:52.000000', 'consum', 0.0215, 'lps'),
	(392832, 126, '2015-02-01 00:52:53.000000', 'consum', 0.0223, 'lps'),
	(392833, 126, '2015-02-01 00:52:54.000000', 'consum', 0.0213, 'lps'),
	(392834, 126, '2015-02-01 00:52:55.000000', 'consum', 0.0218, 'lps'),
	(392835, 126, '2015-02-01 00:52:56.000000', 'consum', 0.0212, 'lps'),
	(392836, 126, '2015-02-01 00:52:57.000000', 'consum', 0.0212, 'lps'),
	(392837, 126, '2015-02-01 00:52:58.000000', 'consum', 0.0214, 'lps'),
	(392838, 126, '2015-02-01 00:52:59.000000', 'consum', 0.0210, 'lps'),
	(392839, 126, '2015-02-01 00:53:00.000000', 'consum', 0.0212, 'lps'),
	(392840, 126, '2015-02-01 00:53:01.000000', 'consum', 0.0223, 'lps'),
	(392841, 126, '2015-02-01 00:53:02.000000', 'consum', 0.0224, 'lps'),
	(392842, 126, '2015-02-01 00:53:03.000000', 'consum', 0.0224, 'lps'),
	(392843, 126, '2015-02-01 00:53:04.000000', 'consum', 0.0210, 'lps'),
	(392844, 126, '2015-02-01 00:53:05.000000', 'consum', 0.0211, 'lps'),
	(392845, 126, '2015-02-01 00:53:06.000000', 'consum', 0.0219, 'lps'),
	(392846, 126, '2015-02-01 00:53:07.000000', 'consum', 0.0220, 'lps'),
	(392847, 126, '2015-02-01 00:53:08.000000', 'consum', 0.0220, 'lps'),
	(392848, 126, '2015-02-01 00:53:09.000000', 'consum', 0.0215, 'lps'),
	(392849, 126, '2015-02-01 00:53:10.000000', 'consum', 0.0221, 'lps'),
	(392850, 126, '2015-02-01 00:53:11.000000', 'consum', 0.0222, 'lps'),
	(392851, 126, '2015-02-01 00:53:12.000000', 'consum', 0.0222, 'lps'),
	(392852, 126, '2015-02-01 00:53:13.000000', 'consum', 0.0218, 'lps'),
	(392853, 126, '2015-02-01 00:53:14.000000', 'consum', 0.0215, 'lps'),
	(392854, 126, '2015-02-01 00:53:15.000000', 'consum', 0.0213, 'lps'),
	(392855, 126, '2015-02-01 00:53:16.000000', 'consum', 0.0224, 'lps'),
	(392856, 126, '2015-02-01 00:53:17.000000', 'consum', 0.0211, 'lps'),
	(392857, 126, '2015-02-01 00:53:18.000000', 'consum', 0.0217, 'lps'),
	(392858, 126, '2015-02-01 00:53:19.000000', 'consum', 0.0214, 'lps'),
	(392859, 126, '2015-02-01 00:53:20.000000', 'consum', 0.0211, 'lps'),
	(392860, 126, '2015-02-01 00:53:21.000000', 'consum', 0.0217, 'lps'),
	(392861, 126, '2015-02-01 00:53:22.000000', 'consum', 0.0214, 'lps'),
	(392862, 126, '2015-02-01 00:53:23.000000', 'consum', 0.0224, 'lps'),
	(392863, 126, '2015-02-01 00:53:24.000000', 'consum', 0.0210, 'lps'),
	(392864, 126, '2015-02-01 00:53:25.000000', 'consum', 0.0210, 'lps'),
	(392865, 126, '2015-02-01 00:53:26.000000', 'consum', 0.0213, 'lps'),
	(392866, 126, '2015-02-01 00:53:27.000000', 'consum', 0.0224, 'lps'),
	(392867, 126, '2015-02-01 00:53:28.000000', 'consum', 0.0212, 'lps'),
	(392868, 126, '2015-02-01 00:53:29.000000', 'consum', 0.0211, 'lps'),
	(392869, 126, '2015-02-01 00:53:30.000000', 'consum', 0.0221, 'lps'),
	(392870, 126, '2015-02-01 00:53:31.000000', 'consum', 0.0220, 'lps'),
	(392871, 126, '2015-02-01 00:53:32.000000', 'consum', 0.0210, 'lps'),
	(392872, 126, '2015-02-01 00:53:33.000000', 'consum', 0.0210, 'lps'),
	(392873, 126, '2015-02-01 00:53:34.000000', 'consum', 0.0214, 'lps'),
	(392874, 126, '2015-02-01 00:53:35.000000', 'consum', 0.0212, 'lps'),
	(392875, 126, '2015-02-01 00:53:36.000000', 'consum', 0.0211, 'lps'),
	(392876, 126, '2015-02-01 00:53:37.000000', 'consum', 0.0210, 'lps'),
	(392877, 126, '2015-02-01 00:53:38.000000', 'consum', 0.0222, 'lps'),
	(392878, 126, '2015-02-01 00:53:39.000000', 'consum', 0.0211, 'lps'),
	(392879, 126, '2015-02-01 00:53:40.000000', 'consum', 0.0223, 'lps'),
	(392880, 126, '2015-02-01 00:53:41.000000', 'consum', 0.0213, 'lps'),
	(392881, 126, '2015-02-01 00:53:42.000000', 'consum', 0.0215, 'lps'),
	(392882, 126, '2015-02-01 00:53:43.000000', 'consum', 0.0214, 'lps'),
	(392883, 126, '2015-02-01 00:53:44.000000', 'consum', 0.0214, 'lps'),
	(392884, 126, '2015-02-01 00:53:45.000000', 'consum', 0.0219, 'lps'),
	(392885, 126, '2015-02-01 00:53:46.000000', 'consum', 0.0211, 'lps'),
	(392886, 126, '2015-02-01 00:53:47.000000', 'consum', 0.0222, 'lps'),
	(392887, 126, '2015-02-01 00:53:48.000000', 'consum', 0.0220, 'lps'),
	(392888, 126, '2015-02-01 00:53:49.000000', 'consum', 0.0212, 'lps'),
	(392889, 126, '2015-02-01 00:53:50.000000', 'consum', 0.0220, 'lps'),
	(392890, 126, '2015-02-01 00:53:51.000000', 'consum', 0.0211, 'lps'),
	(392891, 126, '2015-02-01 00:53:52.000000', 'consum', 0.0214, 'lps'),
	(392892, 126, '2015-02-01 00:53:53.000000', 'consum', 0.0214, 'lps'),
	(392893, 126, '2015-02-01 00:53:54.000000', 'consum', 0.0219, 'lps'),
	(392894, 126, '2015-02-01 00:53:55.000000', 'consum', 0.0212, 'lps'),
	(392895, 126, '2015-02-01 00:53:56.000000', 'consum', 0.0224, 'lps'),
	(392896, 126, '2015-02-01 00:53:57.000000', 'consum', 0.0215, 'lps'),
	(392897, 126, '2015-02-01 00:53:58.000000', 'consum', 0.0221, 'lps'),
	(392898, 126, '2015-02-01 00:53:59.000000', 'consum', 0.0222, 'lps'),
	(392899, 126, '2015-02-01 00:54:00.000000', 'consum', 0.0221, 'lps'),
	(392900, 126, '2015-02-01 00:54:01.000000', 'consum', 0.0216, 'lps'),
	(392901, 126, '2015-02-01 00:54:02.000000', 'consum', 0.0222, 'lps'),
	(392902, 126, '2015-02-01 00:54:03.000000', 'consum', 0.0222, 'lps'),
	(392903, 126, '2015-02-01 00:54:04.000000', 'consum', 0.0219, 'lps'),
	(392904, 126, '2015-02-01 00:54:05.000000', 'consum', 0.0219, 'lps'),
	(392905, 126, '2015-02-01 00:54:06.000000', 'consum', 0.0213, 'lps'),
	(392906, 126, '2015-02-01 00:54:07.000000', 'consum', 0.0215, 'lps'),
	(392907, 126, '2015-02-01 00:54:08.000000', 'consum', 0.0224, 'lps'),
	(392908, 126, '2015-02-01 00:54:09.000000', 'consum', 0.0223, 'lps'),
	(392909, 126, '2015-02-01 00:54:10.000000', 'consum', 0.0219, 'lps'),
	(392910, 126, '2015-02-01 00:54:11.000000', 'consum', 0.0215, 'lps'),
	(392911, 126, '2015-02-01 00:54:12.000000', 'consum', 0.0222, 'lps'),
	(392912, 126, '2015-02-01 00:54:13.000000', 'consum', 0.0212, 'lps'),
	(392913, 126, '2015-02-01 00:54:14.000000', 'consum', 0.0214, 'lps'),
	(392914, 126, '2015-02-01 00:54:15.000000', 'consum', 0.0211, 'lps'),
	(392915, 126, '2015-02-01 00:54:16.000000', 'consum', 0.0216, 'lps'),
	(392916, 126, '2015-02-01 00:54:17.000000', 'consum', 0.0222, 'lps'),
	(392917, 126, '2015-02-01 00:54:18.000000', 'consum', 0.0222, 'lps'),
	(392918, 126, '2015-02-01 00:54:19.000000', 'consum', 0.0220, 'lps'),
	(392919, 126, '2015-02-01 00:54:20.000000', 'consum', 0.0210, 'lps'),
	(392920, 126, '2015-02-01 00:54:21.000000', 'consum', 0.0211, 'lps'),
	(392921, 126, '2015-02-01 00:54:22.000000', 'consum', 0.0215, 'lps'),
	(392922, 126, '2015-02-01 00:54:23.000000', 'consum', 0.0219, 'lps'),
	(392923, 126, '2015-02-01 00:54:24.000000', 'consum', 0.0210, 'lps'),
	(392924, 126, '2015-02-01 00:54:25.000000', 'consum', 0.0215, 'lps'),
	(392925, 126, '2015-02-01 00:54:26.000000', 'consum', 0.0220, 'lps'),
	(392926, 126, '2015-02-01 00:54:27.000000', 'consum', 0.0216, 'lps'),
	(392927, 126, '2015-02-01 00:54:28.000000', 'consum', 0.0210, 'lps'),
	(392928, 126, '2015-02-01 00:54:29.000000', 'consum', 0.0224, 'lps'),
	(392929, 126, '2015-02-01 00:54:30.000000', 'consum', 0.0219, 'lps'),
	(392930, 126, '2015-02-01 00:54:31.000000', 'consum', 0.0213, 'lps'),
	(392931, 126, '2015-02-01 00:54:32.000000', 'consum', 0.0212, 'lps'),
	(392932, 126, '2015-02-01 00:54:33.000000', 'consum', 0.0214, 'lps'),
	(392933, 126, '2015-02-01 00:54:34.000000', 'consum', 0.0211, 'lps'),
	(392934, 126, '2015-02-01 00:54:35.000000', 'consum', 0.0215, 'lps'),
	(392935, 126, '2015-02-01 00:54:36.000000', 'consum', 0.0221, 'lps'),
	(392936, 126, '2015-02-01 00:54:37.000000', 'consum', 0.0217, 'lps'),
	(392937, 126, '2015-02-01 00:54:38.000000', 'consum', 0.0215, 'lps'),
	(392938, 126, '2015-02-01 00:54:39.000000', 'consum', 0.0214, 'lps'),
	(392939, 126, '2015-02-01 00:54:40.000000', 'consum', 0.0213, 'lps'),
	(392940, 126, '2015-02-01 00:54:41.000000', 'consum', 0.0216, 'lps'),
	(392941, 126, '2015-02-01 00:54:42.000000', 'consum', 0.0216, 'lps'),
	(392942, 126, '2015-02-01 00:54:43.000000', 'consum', 0.0221, 'lps'),
	(392943, 126, '2015-02-01 00:54:44.000000', 'consum', 0.0217, 'lps'),
	(392944, 126, '2015-02-01 00:54:45.000000', 'consum', 0.0214, 'lps'),
	(392945, 126, '2015-02-01 00:54:46.000000', 'consum', 0.0211, 'lps'),
	(392946, 126, '2015-02-01 00:54:47.000000', 'consum', 0.0218, 'lps'),
	(392947, 126, '2015-02-01 00:54:48.000000', 'consum', 0.0217, 'lps'),
	(392948, 126, '2015-02-01 00:54:49.000000', 'consum', 0.0221, 'lps'),
	(392949, 126, '2015-02-01 00:54:50.000000', 'consum', 0.0214, 'lps'),
	(392950, 126, '2015-02-01 00:54:51.000000', 'consum', 0.0212, 'lps'),
	(392951, 126, '2015-02-01 00:54:52.000000', 'consum', 0.0222, 'lps'),
	(392952, 126, '2015-02-01 00:54:53.000000', 'consum', 0.0223, 'lps'),
	(392953, 126, '2015-02-01 00:54:54.000000', 'consum', 0.0222, 'lps'),
	(392954, 126, '2015-02-01 00:54:55.000000', 'consum', 0.0217, 'lps'),
	(392955, 126, '2015-02-01 00:54:56.000000', 'consum', 0.0224, 'lps'),
	(392956, 126, '2015-02-01 00:54:57.000000', 'consum', 0.0217, 'lps'),
	(392957, 126, '2015-02-01 00:54:58.000000', 'consum', 0.0215, 'lps'),
	(392958, 126, '2015-02-01 00:54:59.000000', 'consum', 0.0216, 'lps'),
	(392959, 126, '2015-02-01 00:55:00.000000', 'consum', 0.0210, 'lps'),
	(392960, 126, '2015-02-01 00:55:01.000000', 'consum', 0.0221, 'lps'),
	(392961, 126, '2015-02-01 00:55:02.000000', 'consum', 0.0222, 'lps'),
	(392962, 126, '2015-02-01 00:55:03.000000', 'consum', 0.0220, 'lps'),
	(392963, 126, '2015-02-01 00:55:04.000000', 'consum', 0.0212, 'lps'),
	(392964, 126, '2015-02-01 00:55:05.000000', 'consum', 0.0221, 'lps'),
	(392965, 126, '2015-02-01 00:55:06.000000', 'consum', 0.0214, 'lps'),
	(392966, 126, '2015-02-01 00:55:07.000000', 'consum', 0.0213, 'lps'),
	(392967, 126, '2015-02-01 00:55:08.000000', 'consum', 0.0215, 'lps'),
	(392968, 126, '2015-02-01 00:55:09.000000', 'consum', 0.0210, 'lps'),
	(392969, 126, '2015-02-01 00:55:10.000000', 'consum', 0.0211, 'lps'),
	(392970, 126, '2015-02-01 00:55:11.000000', 'consum', 0.0214, 'lps'),
	(392971, 126, '2015-02-01 00:55:12.000000', 'consum', 0.0213, 'lps'),
	(392972, 126, '2015-02-01 00:55:13.000000', 'consum', 0.0215, 'lps'),
	(392973, 126, '2015-02-01 00:55:14.000000', 'consum', 0.0211, 'lps'),
	(392974, 126, '2015-02-01 00:55:15.000000', 'consum', 0.0217, 'lps'),
	(392975, 126, '2015-02-01 00:55:16.000000', 'consum', 0.0211, 'lps'),
	(392976, 126, '2015-02-01 00:55:17.000000', 'consum', 0.0224, 'lps'),
	(392977, 126, '2015-02-01 00:55:18.000000', 'consum', 0.0219, 'lps'),
	(392978, 126, '2015-02-01 00:55:19.000000', 'consum', 0.0215, 'lps'),
	(392979, 126, '2015-02-01 00:55:20.000000', 'consum', 0.0221, 'lps'),
	(392980, 126, '2015-02-01 00:55:21.000000', 'consum', 0.0220, 'lps'),
	(392981, 126, '2015-02-01 00:55:22.000000', 'consum', 0.0213, 'lps'),
	(392982, 126, '2015-02-01 00:55:23.000000', 'consum', 0.0212, 'lps'),
	(392983, 126, '2015-02-01 00:55:24.000000', 'consum', 0.0224, 'lps'),
	(392984, 126, '2015-02-01 00:55:25.000000', 'consum', 0.0214, 'lps'),
	(392985, 126, '2015-02-01 00:55:26.000000', 'consum', 0.0221, 'lps'),
	(392986, 126, '2015-02-01 00:55:27.000000', 'consum', 0.0224, 'lps'),
	(392987, 126, '2015-02-01 00:55:28.000000', 'consum', 0.0217, 'lps'),
	(392988, 126, '2015-02-01 00:55:29.000000', 'consum', 0.0218, 'lps'),
	(392989, 126, '2015-02-01 00:55:30.000000', 'consum', 0.0214, 'lps'),
	(392990, 126, '2015-02-01 00:55:31.000000', 'consum', 0.0223, 'lps'),
	(392991, 126, '2015-02-01 00:55:32.000000', 'consum', 0.0217, 'lps'),
	(392992, 126, '2015-02-01 00:55:33.000000', 'consum', 0.0223, 'lps'),
	(392993, 126, '2015-02-01 00:55:34.000000', 'consum', 0.0211, 'lps'),
	(392994, 126, '2015-02-01 00:55:35.000000', 'consum', 0.0220, 'lps'),
	(392995, 126, '2015-02-01 00:55:36.000000', 'consum', 0.0212, 'lps'),
	(392996, 126, '2015-02-01 00:55:37.000000', 'consum', 0.0220, 'lps'),
	(392997, 126, '2015-02-01 00:55:38.000000', 'consum', 0.0210, 'lps'),
	(392998, 126, '2015-02-01 00:55:39.000000', 'consum', 0.0224, 'lps'),
	(392999, 126, '2015-02-01 00:55:40.000000', 'consum', 0.0223, 'lps'),
	(393000, 126, '2015-02-01 00:55:41.000000', 'consum', 0.0218, 'lps'),
	(393001, 126, '2015-02-01 00:55:42.000000', 'consum', 0.0212, 'lps'),
	(393002, 126, '2015-02-01 00:55:43.000000', 'consum', 0.0224, 'lps'),
	(393003, 126, '2015-02-01 00:55:44.000000', 'consum', 0.0218, 'lps'),
	(393004, 126, '2015-02-01 00:55:45.000000', 'consum', 0.0222, 'lps'),
	(393005, 126, '2015-02-01 00:55:46.000000', 'consum', 0.0215, 'lps'),
	(393006, 126, '2015-02-01 00:55:47.000000', 'consum', 0.0217, 'lps'),
	(393007, 126, '2015-02-01 00:55:48.000000', 'consum', 0.0214, 'lps'),
	(393008, 126, '2015-02-01 00:55:49.000000', 'consum', 0.0212, 'lps'),
	(393009, 126, '2015-02-01 00:55:50.000000', 'consum', 0.0221, 'lps'),
	(393010, 126, '2015-02-01 00:55:51.000000', 'consum', 0.0217, 'lps'),
	(393011, 126, '2015-02-01 00:55:52.000000', 'consum', 0.0210, 'lps'),
	(393012, 126, '2015-02-01 00:55:53.000000', 'consum', 0.0221, 'lps'),
	(393013, 126, '2015-02-01 00:55:54.000000', 'consum', 0.0219, 'lps'),
	(393014, 126, '2015-02-01 00:55:55.000000', 'consum', 0.0210, 'lps'),
	(393015, 126, '2015-02-01 00:55:56.000000', 'consum', 0.0211, 'lps'),
	(393016, 126, '2015-02-01 00:55:57.000000', 'consum', 0.0218, 'lps'),
	(393017, 126, '2015-02-01 00:55:58.000000', 'consum', 0.0215, 'lps'),
	(393018, 126, '2015-02-01 00:55:59.000000', 'consum', 0.0214, 'lps'),
	(393019, 126, '2015-02-01 00:56:00.000000', 'consum', 0.0212, 'lps'),
	(393020, 126, '2015-02-01 00:56:01.000000', 'consum', 0.0212, 'lps'),
	(393021, 126, '2015-02-01 00:56:02.000000', 'consum', 0.0213, 'lps'),
	(393022, 126, '2015-02-01 00:56:03.000000', 'consum', 0.0220, 'lps'),
	(393023, 126, '2015-02-01 00:56:04.000000', 'consum', 0.0220, 'lps'),
	(393024, 126, '2015-02-01 00:56:05.000000', 'consum', 0.0218, 'lps'),
	(393025, 126, '2015-02-01 00:56:06.000000', 'consum', 0.0217, 'lps'),
	(393026, 126, '2015-02-01 00:56:07.000000', 'consum', 0.0210, 'lps'),
	(393027, 126, '2015-02-01 00:56:08.000000', 'consum', 0.0218, 'lps'),
	(393028, 126, '2015-02-01 00:56:09.000000', 'consum', 0.0220, 'lps'),
	(393029, 126, '2015-02-01 00:56:10.000000', 'consum', 0.0220, 'lps'),
	(393030, 126, '2015-02-01 00:56:11.000000', 'consum', 0.0218, 'lps'),
	(393031, 126, '2015-02-01 00:56:12.000000', 'consum', 0.0219, 'lps'),
	(393032, 126, '2015-02-01 00:56:13.000000', 'consum', 0.0219, 'lps'),
	(393033, 126, '2015-02-01 00:56:14.000000', 'consum', 0.0211, 'lps'),
	(393034, 126, '2015-02-01 00:56:15.000000', 'consum', 0.0221, 'lps'),
	(393035, 126, '2015-02-01 00:56:16.000000', 'consum', 0.0214, 'lps'),
	(393036, 126, '2015-02-01 00:56:17.000000', 'consum', 0.0216, 'lps'),
	(393037, 126, '2015-02-01 00:56:18.000000', 'consum', 0.0211, 'lps'),
	(393038, 126, '2015-02-01 00:56:19.000000', 'consum', 0.0213, 'lps'),
	(393039, 126, '2015-02-01 00:56:20.000000', 'consum', 0.0222, 'lps'),
	(393040, 126, '2015-02-01 00:56:21.000000', 'consum', 0.0215, 'lps'),
	(393041, 126, '2015-02-01 00:56:22.000000', 'consum', 0.0216, 'lps'),
	(393042, 126, '2015-02-01 00:56:23.000000', 'consum', 0.0210, 'lps'),
	(393043, 126, '2015-02-01 00:56:24.000000', 'consum', 0.0224, 'lps'),
	(393044, 126, '2015-02-01 00:56:25.000000', 'consum', 0.0219, 'lps'),
	(393045, 126, '2015-02-01 00:56:26.000000', 'consum', 0.0215, 'lps'),
	(393046, 126, '2015-02-01 00:56:27.000000', 'consum', 0.0210, 'lps'),
	(393047, 126, '2015-02-01 00:56:28.000000', 'consum', 0.0223, 'lps'),
	(393048, 126, '2015-02-01 00:56:29.000000', 'consum', 0.0215, 'lps'),
	(393049, 126, '2015-02-01 00:56:30.000000', 'consum', 0.0210, 'lps'),
	(393050, 126, '2015-02-01 00:56:31.000000', 'consum', 0.0214, 'lps'),
	(393051, 126, '2015-02-01 00:56:32.000000', 'consum', 0.0213, 'lps'),
	(393052, 126, '2015-02-01 00:56:33.000000', 'consum', 0.0213, 'lps'),
	(393053, 126, '2015-02-01 00:56:34.000000', 'consum', 0.0216, 'lps'),
	(393054, 126, '2015-02-01 00:56:35.000000', 'consum', 0.0217, 'lps'),
	(393055, 126, '2015-02-01 00:56:36.000000', 'consum', 0.0214, 'lps'),
	(393056, 126, '2015-02-01 00:56:37.000000', 'consum', 0.0211, 'lps'),
	(393057, 126, '2015-02-01 00:56:38.000000', 'consum', 0.0215, 'lps'),
	(393058, 126, '2015-02-01 00:56:39.000000', 'consum', 0.0218, 'lps'),
	(393059, 126, '2015-02-01 00:56:40.000000', 'consum', 0.0222, 'lps'),
	(393060, 126, '2015-02-01 00:56:41.000000', 'consum', 0.0216, 'lps'),
	(393061, 126, '2015-02-01 00:56:42.000000', 'consum', 0.0218, 'lps'),
	(393062, 126, '2015-02-01 00:56:43.000000', 'consum', 0.0221, 'lps'),
	(393063, 126, '2015-02-01 00:56:44.000000', 'consum', 0.0223, 'lps'),
	(393064, 126, '2015-02-01 00:56:45.000000', 'consum', 0.0213, 'lps'),
	(393065, 126, '2015-02-01 00:56:46.000000', 'consum', 0.0218, 'lps'),
	(393066, 126, '2015-02-01 00:56:47.000000', 'consum', 0.0213, 'lps'),
	(393067, 126, '2015-02-01 00:56:48.000000', 'consum', 0.0214, 'lps'),
	(393068, 126, '2015-02-01 00:56:49.000000', 'consum', 0.0221, 'lps'),
	(393069, 126, '2015-02-01 00:56:50.000000', 'consum', 0.0223, 'lps'),
	(393070, 126, '2015-02-01 00:56:51.000000', 'consum', 0.0212, 'lps'),
	(393071, 126, '2015-02-01 00:56:52.000000', 'consum', 0.0214, 'lps'),
	(393072, 126, '2015-02-01 00:56:53.000000', 'consum', 0.0222, 'lps'),
	(393073, 126, '2015-02-01 00:56:54.000000', 'consum', 0.0215, 'lps'),
	(393074, 126, '2015-02-01 00:56:55.000000', 'consum', 0.0214, 'lps'),
	(393075, 126, '2015-02-01 00:56:56.000000', 'consum', 0.0216, 'lps'),
	(393076, 126, '2015-02-01 00:56:57.000000', 'consum', 0.0215, 'lps'),
	(393077, 126, '2015-02-01 00:56:58.000000', 'consum', 0.0215, 'lps'),
	(393078, 126, '2015-02-01 00:56:59.000000', 'consum', 0.0223, 'lps'),
	(393079, 126, '2015-02-01 00:57:00.000000', 'consum', 0.0214, 'lps'),
	(393080, 126, '2015-02-01 00:57:01.000000', 'consum', 0.0223, 'lps'),
	(393081, 126, '2015-02-01 00:57:02.000000', 'consum', 0.0217, 'lps'),
	(393082, 126, '2015-02-01 00:57:03.000000', 'consum', 0.0221, 'lps'),
	(393083, 126, '2015-02-01 00:57:04.000000', 'consum', 0.0214, 'lps'),
	(393084, 126, '2015-02-01 00:57:05.000000', 'consum', 0.0212, 'lps'),
	(393085, 126, '2015-02-01 00:57:06.000000', 'consum', 0.0210, 'lps'),
	(393086, 126, '2015-02-01 00:57:07.000000', 'consum', 0.0221, 'lps'),
	(393087, 126, '2015-02-01 00:57:08.000000', 'consum', 0.0218, 'lps'),
	(393088, 126, '2015-02-01 00:57:09.000000', 'consum', 0.0216, 'lps'),
	(393089, 126, '2015-02-01 00:57:10.000000', 'consum', 0.0220, 'lps'),
	(393090, 126, '2015-02-01 00:57:11.000000', 'consum', 0.0224, 'lps'),
	(393091, 126, '2015-02-01 00:57:12.000000', 'consum', 0.0223, 'lps'),
	(393092, 126, '2015-02-01 00:57:13.000000', 'consum', 0.0217, 'lps'),
	(393093, 126, '2015-02-01 00:57:14.000000', 'consum', 0.0222, 'lps'),
	(393094, 126, '2015-02-01 00:57:15.000000', 'consum', 0.0219, 'lps'),
	(393095, 126, '2015-02-01 00:57:16.000000', 'consum', 0.0220, 'lps'),
	(393096, 126, '2015-02-01 00:57:17.000000', 'consum', 0.0216, 'lps'),
	(393097, 126, '2015-02-01 00:57:18.000000', 'consum', 0.0214, 'lps'),
	(393098, 126, '2015-02-01 00:57:19.000000', 'consum', 0.0211, 'lps'),
	(393099, 126, '2015-02-01 00:57:20.000000', 'consum', 0.0221, 'lps'),
	(393100, 126, '2015-02-01 00:57:21.000000', 'consum', 0.0214, 'lps'),
	(393101, 126, '2015-02-01 00:57:22.000000', 'consum', 0.0213, 'lps'),
	(393102, 126, '2015-02-01 00:57:23.000000', 'consum', 0.0216, 'lps'),
	(393103, 126, '2015-02-01 00:57:24.000000', 'consum', 0.0214, 'lps'),
	(393104, 126, '2015-02-01 00:57:25.000000', 'consum', 0.0213, 'lps'),
	(393105, 126, '2015-02-01 00:57:26.000000', 'consum', 0.0212, 'lps'),
	(393106, 126, '2015-02-01 00:57:27.000000', 'consum', 0.0214, 'lps'),
	(393107, 126, '2015-02-01 00:57:28.000000', 'consum', 0.0223, 'lps'),
	(393108, 126, '2015-02-01 00:57:29.000000', 'consum', 0.0220, 'lps'),
	(393109, 126, '2015-02-01 00:57:30.000000', 'consum', 0.0223, 'lps'),
	(393110, 126, '2015-02-01 00:57:31.000000', 'consum', 0.0213, 'lps'),
	(393111, 126, '2015-02-01 00:57:32.000000', 'consum', 0.0216, 'lps'),
	(393112, 126, '2015-02-01 00:57:33.000000', 'consum', 0.0218, 'lps'),
	(393113, 126, '2015-02-01 00:57:34.000000', 'consum', 0.0215, 'lps'),
	(393114, 126, '2015-02-01 00:57:35.000000', 'consum', 0.0214, 'lps'),
	(393115, 126, '2015-02-01 00:57:36.000000', 'consum', 0.0216, 'lps'),
	(393116, 126, '2015-02-01 00:57:37.000000', 'consum', 0.0212, 'lps'),
	(393117, 126, '2015-02-01 00:57:38.000000', 'consum', 0.0217, 'lps'),
	(393118, 126, '2015-02-01 00:57:39.000000', 'consum', 0.0210, 'lps'),
	(393119, 126, '2015-02-01 00:57:40.000000', 'consum', 0.0220, 'lps'),
	(393120, 126, '2015-02-01 00:57:41.000000', 'consum', 0.0215, 'lps'),
	(393121, 126, '2015-02-01 00:57:42.000000', 'consum', 0.0223, 'lps'),
	(393122, 126, '2015-02-01 00:57:43.000000', 'consum', 0.0212, 'lps'),
	(393123, 126, '2015-02-01 00:57:44.000000', 'consum', 0.0214, 'lps'),
	(393124, 126, '2015-02-01 00:57:45.000000', 'consum', 0.0223, 'lps'),
	(393125, 126, '2015-02-01 00:57:46.000000', 'consum', 0.0220, 'lps'),
	(393126, 126, '2015-02-01 00:57:47.000000', 'consum', 0.0220, 'lps'),
	(393127, 126, '2015-02-01 00:57:48.000000', 'consum', 0.0216, 'lps'),
	(393128, 126, '2015-02-01 00:57:49.000000', 'consum', 0.0210, 'lps'),
	(393129, 126, '2015-02-01 00:57:50.000000', 'consum', 0.0222, 'lps'),
	(393130, 126, '2015-02-01 00:57:51.000000', 'consum', 0.0213, 'lps'),
	(393131, 126, '2015-02-01 00:57:52.000000', 'consum', 0.0219, 'lps'),
	(393132, 126, '2015-02-01 00:57:53.000000', 'consum', 0.0216, 'lps'),
	(393133, 126, '2015-02-01 00:57:54.000000', 'consum', 0.0213, 'lps'),
	(393134, 126, '2015-02-01 00:57:55.000000', 'consum', 0.0222, 'lps'),
	(393135, 126, '2015-02-01 00:57:56.000000', 'consum', 0.0217, 'lps'),
	(393136, 126, '2015-02-01 00:57:57.000000', 'consum', 0.0210, 'lps'),
	(393137, 126, '2015-02-01 00:57:58.000000', 'consum', 0.0221, 'lps'),
	(393138, 126, '2015-02-01 00:57:59.000000', 'consum', 0.0218, 'lps'),
	(393139, 126, '2015-02-01 00:58:00.000000', 'consum', 0.0218, 'lps'),
	(393140, 126, '2015-02-01 00:58:01.000000', 'consum', 0.0213, 'lps'),
	(393141, 126, '2015-02-01 00:58:02.000000', 'consum', 0.0217, 'lps'),
	(393142, 126, '2015-02-01 00:58:03.000000', 'consum', 0.0223, 'lps'),
	(393143, 126, '2015-02-01 00:58:04.000000', 'consum', 0.0221, 'lps'),
	(393144, 126, '2015-02-01 00:58:05.000000', 'consum', 0.0215, 'lps'),
	(393145, 126, '2015-02-01 00:58:06.000000', 'consum', 0.0215, 'lps'),
	(393146, 126, '2015-02-01 00:58:07.000000', 'consum', 0.0220, 'lps'),
	(393147, 126, '2015-02-01 00:58:08.000000', 'consum', 0.0217, 'lps'),
	(393148, 126, '2015-02-01 00:58:09.000000', 'consum', 0.0216, 'lps'),
	(393149, 126, '2015-02-01 00:58:10.000000', 'consum', 0.0217, 'lps'),
	(393150, 126, '2015-02-01 00:58:11.000000', 'consum', 0.0215, 'lps'),
	(393151, 126, '2015-02-01 00:58:12.000000', 'consum', 0.0213, 'lps'),
	(393152, 126, '2015-02-01 00:58:13.000000', 'consum', 0.0212, 'lps'),
	(393153, 126, '2015-02-01 00:58:14.000000', 'consum', 0.0224, 'lps'),
	(393154, 126, '2015-02-01 00:58:15.000000', 'consum', 0.0215, 'lps'),
	(393155, 126, '2015-02-01 00:58:16.000000', 'consum', 0.0210, 'lps'),
	(393156, 126, '2015-02-01 00:58:17.000000', 'consum', 0.0210, 'lps'),
	(393157, 126, '2015-02-01 00:58:18.000000', 'consum', 0.0210, 'lps'),
	(393158, 126, '2015-02-01 00:58:19.000000', 'consum', 0.0210, 'lps'),
	(393159, 126, '2015-02-01 00:58:20.000000', 'consum', 0.0210, 'lps'),
	(393160, 126, '2015-02-01 00:58:21.000000', 'consum', 0.0224, 'lps'),
	(393161, 126, '2015-02-01 00:58:22.000000', 'consum', 0.0224, 'lps'),
	(393162, 126, '2015-02-01 00:58:23.000000', 'consum', 0.0222, 'lps'),
	(393163, 126, '2015-02-01 00:58:24.000000', 'consum', 0.0212, 'lps'),
	(393164, 126, '2015-02-01 00:58:25.000000', 'consum', 0.0216, 'lps'),
	(393165, 126, '2015-02-01 00:58:26.000000', 'consum', 0.0218, 'lps'),
	(393166, 126, '2015-02-01 00:58:27.000000', 'consum', 0.0219, 'lps'),
	(393167, 126, '2015-02-01 00:58:28.000000', 'consum', 0.0217, 'lps'),
	(393168, 126, '2015-02-01 00:58:29.000000', 'consum', 0.0217, 'lps'),
	(393169, 126, '2015-02-01 00:58:30.000000', 'consum', 0.0210, 'lps'),
	(393170, 126, '2015-02-01 00:58:31.000000', 'consum', 0.0221, 'lps'),
	(393171, 126, '2015-02-01 00:58:32.000000', 'consum', 0.0218, 'lps'),
	(393172, 126, '2015-02-01 00:58:33.000000', 'consum', 0.0219, 'lps'),
	(393173, 126, '2015-02-01 00:58:34.000000', 'consum', 0.0216, 'lps'),
	(393174, 126, '2015-02-01 00:58:35.000000', 'consum', 0.0214, 'lps'),
	(393175, 126, '2015-02-01 00:58:36.000000', 'consum', 0.0214, 'lps'),
	(393176, 126, '2015-02-01 00:58:37.000000', 'consum', 0.0216, 'lps'),
	(393177, 126, '2015-02-01 00:58:38.000000', 'consum', 0.0213, 'lps'),
	(393178, 126, '2015-02-01 00:58:39.000000', 'consum', 0.0223, 'lps'),
	(393179, 126, '2015-02-01 00:58:40.000000', 'consum', 0.0223, 'lps'),
	(393180, 126, '2015-02-01 00:58:41.000000', 'consum', 0.0221, 'lps'),
	(393181, 126, '2015-02-01 00:58:42.000000', 'consum', 0.0213, 'lps'),
	(393182, 126, '2015-02-01 00:58:43.000000', 'consum', 0.0219, 'lps'),
	(393183, 126, '2015-02-01 00:58:44.000000', 'consum', 0.0220, 'lps'),
	(393184, 126, '2015-02-01 00:58:45.000000', 'consum', 0.0216, 'lps'),
	(393185, 126, '2015-02-01 00:58:46.000000', 'consum', 0.0210, 'lps'),
	(393186, 126, '2015-02-01 00:58:47.000000', 'consum', 0.0224, 'lps'),
	(393187, 126, '2015-02-01 00:58:48.000000', 'consum', 0.0218, 'lps'),
	(393188, 126, '2015-02-01 00:58:49.000000', 'consum', 0.0212, 'lps'),
	(393189, 126, '2015-02-01 00:58:50.000000', 'consum', 0.0210, 'lps'),
	(393190, 126, '2015-02-01 00:58:51.000000', 'consum', 0.0221, 'lps'),
	(393191, 126, '2015-02-01 00:58:52.000000', 'consum', 0.0217, 'lps'),
	(393192, 126, '2015-02-01 00:58:53.000000', 'consum', 0.0216, 'lps'),
	(393193, 126, '2015-02-01 00:58:54.000000', 'consum', 0.0220, 'lps'),
	(393194, 126, '2015-02-01 00:58:55.000000', 'consum', 0.0224, 'lps'),
	(393195, 126, '2015-02-01 00:58:56.000000', 'consum', 0.0223, 'lps'),
	(393196, 126, '2015-02-01 00:58:57.000000', 'consum', 0.0218, 'lps'),
	(393197, 126, '2015-02-01 00:58:58.000000', 'consum', 0.0214, 'lps'),
	(393198, 126, '2015-02-01 00:58:59.000000', 'consum', 0.0218, 'lps'),
	(393199, 126, '2015-02-01 00:59:00.000000', 'consum', 0.0223, 'lps'),
	(393200, 126, '2015-02-01 00:59:01.000000', 'consum', 0.0224, 'lps'),
	(393201, 126, '2015-02-01 00:59:02.000000', 'consum', 0.0210, 'lps'),
	(393202, 126, '2015-02-01 00:59:03.000000', 'consum', 0.0212, 'lps'),
	(393203, 126, '2015-02-01 00:59:04.000000', 'consum', 0.0221, 'lps'),
	(393204, 126, '2015-02-01 00:59:05.000000', 'consum', 0.0217, 'lps'),
	(393205, 126, '2015-02-01 00:59:06.000000', 'consum', 0.0210, 'lps'),
	(393206, 126, '2015-02-01 00:59:07.000000', 'consum', 0.0222, 'lps'),
	(393207, 126, '2015-02-01 00:59:08.000000', 'consum', 0.0223, 'lps'),
	(393208, 126, '2015-02-01 00:59:09.000000', 'consum', 0.0213, 'lps'),
	(393209, 126, '2015-02-01 00:59:10.000000', 'consum', 0.0213, 'lps'),
	(393210, 126, '2015-02-01 00:59:11.000000', 'consum', 0.0216, 'lps'),
	(393211, 126, '2015-02-01 00:59:12.000000', 'consum', 0.0218, 'lps'),
	(393212, 126, '2015-02-01 00:59:13.000000', 'consum', 0.0219, 'lps'),
	(393213, 126, '2015-02-01 00:59:14.000000', 'consum', 0.0215, 'lps'),
	(393214, 126, '2015-02-01 00:59:15.000000', 'consum', 0.0222, 'lps'),
	(393215, 126, '2015-02-01 00:59:16.000000', 'consum', 0.0214, 'lps'),
	(393216, 126, '2015-02-01 00:59:17.000000', 'consum', 0.0222, 'lps'),
	(393217, 126, '2015-02-01 00:59:18.000000', 'consum', 0.0213, 'lps'),
	(393218, 126, '2015-02-01 00:59:19.000000', 'consum', 0.0219, 'lps'),
	(393219, 126, '2015-02-01 00:59:20.000000', 'consum', 0.0216, 'lps'),
	(393220, 126, '2015-02-01 00:59:21.000000', 'consum', 0.0214, 'lps'),
	(393221, 126, '2015-02-01 00:59:22.000000', 'consum', 0.0211, 'lps'),
	(393222, 126, '2015-02-01 00:59:23.000000', 'consum', 0.0222, 'lps'),
	(393223, 126, '2015-02-01 00:59:24.000000', 'consum', 0.0220, 'lps'),
	(393224, 126, '2015-02-01 00:59:25.000000', 'consum', 0.0224, 'lps'),
	(393225, 126, '2015-02-01 00:59:26.000000', 'consum', 0.0222, 'lps'),
	(393226, 126, '2015-02-01 00:59:27.000000', 'consum', 0.0212, 'lps'),
	(393227, 126, '2015-02-01 00:59:28.000000', 'consum', 0.0215, 'lps'),
	(393228, 126, '2015-02-01 00:59:29.000000', 'consum', 0.0214, 'lps'),
	(393229, 126, '2015-02-01 00:59:30.000000', 'consum', 0.0215, 'lps'),
	(393230, 126, '2015-02-01 00:59:31.000000', 'consum', 0.0211, 'lps'),
	(393231, 126, '2015-02-01 00:59:32.000000', 'consum', 0.0214, 'lps'),
	(393232, 126, '2015-02-01 00:59:33.000000', 'consum', 0.0212, 'lps'),
	(393233, 126, '2015-02-01 00:59:34.000000', 'consum', 0.0223, 'lps'),
	(393234, 126, '2015-02-01 00:59:35.000000', 'consum', 0.0223, 'lps'),
	(393235, 126, '2015-02-01 00:59:36.000000', 'consum', 0.0210, 'lps'),
	(393236, 126, '2015-02-01 00:59:37.000000', 'consum', 0.0215, 'lps'),
	(393237, 126, '2015-02-01 00:59:38.000000', 'consum', 0.0222, 'lps'),
	(393238, 126, '2015-02-01 00:59:39.000000', 'consum', 0.0224, 'lps'),
	(393239, 126, '2015-02-01 00:59:40.000000', 'consum', 0.0214, 'lps'),
	(393240, 126, '2015-02-01 00:59:41.000000', 'consum', 0.0218, 'lps'),
	(393241, 126, '2015-02-01 00:59:42.000000', 'consum', 0.0223, 'lps'),
	(393242, 126, '2015-02-01 00:59:43.000000', 'consum', 0.0222, 'lps'),
	(393243, 126, '2015-02-01 00:59:44.000000', 'consum', 0.0217, 'lps'),
	(393244, 126, '2015-02-01 00:59:45.000000', 'consum', 0.0224, 'lps'),
	(393245, 126, '2015-02-01 00:59:46.000000', 'consum', 0.0215, 'lps'),
	(393246, 126, '2015-02-01 00:59:47.000000', 'consum', 0.0222, 'lps'),
	(393247, 126, '2015-02-01 00:59:48.000000', 'consum', 0.0214, 'lps'),
	(393248, 126, '2015-02-01 00:59:49.000000', 'consum', 0.0221, 'lps'),
	(393249, 126, '2015-02-01 00:59:50.000000', 'consum', 0.0224, 'lps'),
	(393250, 126, '2015-02-01 00:59:51.000000', 'consum', 0.0218, 'lps'),
	(393251, 126, '2015-02-01 00:59:52.000000', 'consum', 0.0223, 'lps'),
	(393252, 126, '2015-02-01 00:59:53.000000', 'consum', 0.0220, 'lps'),
	(393253, 126, '2015-02-01 00:59:54.000000', 'consum', 0.0222, 'lps'),
	(393254, 126, '2015-02-01 00:59:55.000000', 'consum', 0.0212, 'lps'),
	(393255, 126, '2015-02-01 00:59:56.000000', 'consum', 0.0215, 'lps'),
	(393256, 126, '2015-02-01 00:59:57.000000', 'consum', 0.0214, 'lps'),
	(393257, 126, '2015-02-01 00:59:58.000000', 'consum', 0.0215, 'lps'),
	(393258, 126, '2015-02-01 00:59:59.000000', 'consum', 0.0222, 'lps'),
	(393259, 126, '2015-02-01 01:00:00.000000', 'consum', 0.0213, 'lps'),
	(393260, 126, '2015-02-01 01:00:01.000000', 'consum', 0.0218, 'lps'),
	(393261, 126, '2015-02-01 01:00:02.000000', 'consum', 0.0210, 'lps'),
	(393262, 126, '2015-02-01 01:00:03.000000', 'consum', 0.0220, 'lps'),
	(393263, 126, '2015-02-01 01:00:04.000000', 'consum', 0.0212, 'lps'),
	(393264, 126, '2015-02-01 01:00:05.000000', 'consum', 0.0221, 'lps'),
	(393265, 126, '2015-02-01 01:00:06.000000', 'consum', 0.0216, 'lps'),
	(393266, 126, '2015-02-01 01:00:07.000000', 'consum', 0.0222, 'lps'),
	(393267, 126, '2015-02-01 01:00:08.000000', 'consum', 0.0221, 'lps'),
	(393268, 126, '2015-02-01 01:00:09.000000', 'consum', 0.0217, 'lps'),
	(393269, 126, '2015-02-01 01:00:10.000000', 'consum', 0.0211, 'lps'),
	(393270, 126, '2015-02-01 01:00:11.000000', 'consum', 0.0224, 'lps'),
	(393271, 126, '2015-02-01 01:00:12.000000', 'consum', 0.0219, 'lps'),
	(393272, 126, '2015-02-01 01:00:13.000000', 'consum', 0.0214, 'lps'),
	(393273, 126, '2015-02-01 01:00:14.000000', 'consum', 0.0219, 'lps'),
	(393274, 126, '2015-02-01 01:00:15.000000', 'consum', 0.0214, 'lps'),
	(393275, 126, '2015-02-01 01:00:16.000000', 'consum', 0.0216, 'lps'),
	(393276, 126, '2015-02-01 01:00:17.000000', 'consum', 0.0212, 'lps'),
	(393277, 126, '2015-02-01 01:00:18.000000', 'consum', 0.0221, 'lps'),
	(393278, 126, '2015-02-01 01:00:19.000000', 'consum', 0.0215, 'lps'),
	(393279, 126, '2015-02-01 01:00:20.000000', 'consum', 0.0215, 'lps'),
	(393280, 126, '2015-02-01 01:00:21.000000', 'consum', 0.0220, 'lps'),
	(393281, 126, '2015-02-01 01:00:22.000000', 'consum', 0.0218, 'lps'),
	(393282, 126, '2015-02-01 01:00:23.000000', 'consum', 0.0221, 'lps'),
	(393283, 126, '2015-02-01 01:00:24.000000', 'consum', 0.0211, 'lps'),
	(393284, 126, '2015-02-01 01:00:25.000000', 'consum', 0.0210, 'lps'),
	(393285, 126, '2015-02-01 01:00:26.000000', 'consum', 0.0210, 'lps'),
	(393286, 126, '2015-02-01 01:00:27.000000', 'consum', 0.0211, 'lps'),
	(393287, 126, '2015-02-01 01:00:28.000000', 'consum', 0.0214, 'lps'),
	(393288, 126, '2015-02-01 01:00:29.000000', 'consum', 0.0214, 'lps'),
	(393289, 126, '2015-02-01 01:00:30.000000', 'consum', 0.0219, 'lps'),
	(393290, 126, '2015-02-01 01:00:31.000000', 'consum', 0.0212, 'lps'),
	(393291, 126, '2015-02-01 01:00:32.000000', 'consum', 0.0223, 'lps'),
	(393292, 126, '2015-02-01 01:00:33.000000', 'consum', 0.0223, 'lps'),
	(393293, 126, '2015-02-01 01:00:34.000000', 'consum', 0.0224, 'lps'),
	(393294, 126, '2015-02-01 01:00:35.000000', 'consum', 0.0211, 'lps'),
	(393295, 126, '2015-02-01 01:00:36.000000', 'consum', 0.0217, 'lps'),
	(393296, 126, '2015-02-01 01:00:37.000000', 'consum', 0.0212, 'lps'),
	(393297, 126, '2015-02-01 01:00:38.000000', 'consum', 0.0217, 'lps'),
	(393298, 126, '2015-02-01 01:00:39.000000', 'consum', 0.0223, 'lps'),
	(393299, 126, '2015-02-01 01:00:40.000000', 'consum', 0.0212, 'lps'),
	(393300, 126, '2015-02-01 01:00:41.000000', 'consum', 0.0223, 'lps'),
	(393301, 126, '2015-02-01 01:00:42.000000', 'consum', 0.0212, 'lps'),
	(393302, 126, '2015-02-01 01:00:43.000000', 'consum', 0.0212, 'lps'),
	(393303, 126, '2015-02-01 01:00:44.000000', 'consum', 0.0212, 'lps'),
	(393304, 126, '2015-02-01 01:00:45.000000', 'consum', 0.0215, 'lps'),
	(393305, 126, '2015-02-01 01:00:46.000000', 'consum', 0.0215, 'lps'),
	(393306, 126, '2015-02-01 01:00:47.000000', 'consum', 0.0221, 'lps'),
	(393307, 126, '2015-02-01 01:00:48.000000', 'consum', 0.0219, 'lps'),
	(393308, 126, '2015-02-01 01:00:49.000000', 'consum', 0.0222, 'lps'),
	(393309, 126, '2015-02-01 01:00:50.000000', 'consum', 0.0213, 'lps'),
	(393310, 126, '2015-02-01 01:00:51.000000', 'consum', 0.0219, 'lps'),
	(393311, 126, '2015-02-01 01:00:52.000000', 'consum', 0.0216, 'lps'),
	(393312, 126, '2015-02-01 01:00:53.000000', 'consum', 0.0214, 'lps'),
	(393313, 126, '2015-02-01 01:00:54.000000', 'consum', 0.0214, 'lps'),
	(393314, 126, '2015-02-01 01:00:55.000000', 'consum', 0.0217, 'lps'),
	(393315, 126, '2015-02-01 01:00:56.000000', 'consum', 0.0217, 'lps'),
	(393316, 126, '2015-02-01 01:00:57.000000', 'consum', 0.0212, 'lps'),
	(393317, 126, '2015-02-01 01:00:58.000000', 'consum', 0.0212, 'lps'),
	(393318, 126, '2015-02-01 01:00:59.000000', 'consum', 0.0215, 'lps'),
	(393319, 126, '2015-02-01 01:01:00.000000', 'consum', 0.0213, 'lps'),
	(393320, 126, '2015-02-01 01:01:01.000000', 'consum', 0.0211, 'lps'),
	(393321, 126, '2015-02-01 01:01:02.000000', 'consum', 0.0224, 'lps'),
	(393322, 126, '2015-02-01 01:01:03.000000', 'consum', 0.0216, 'lps'),
	(393323, 126, '2015-02-01 01:01:04.000000', 'consum', 0.0213, 'lps'),
	(393324, 126, '2015-02-01 01:01:05.000000', 'consum', 0.0221, 'lps'),
	(393325, 126, '2015-02-01 01:01:06.000000', 'consum', 0.0215, 'lps'),
	(393326, 126, '2015-02-01 01:01:07.000000', 'consum', 0.0214, 'lps'),
	(393327, 126, '2015-02-01 01:01:08.000000', 'consum', 0.0217, 'lps'),
	(393328, 126, '2015-02-01 01:01:09.000000', 'consum', 0.0220, 'lps'),
	(393329, 126, '2015-02-01 01:01:10.000000', 'consum', 0.0222, 'lps'),
	(393330, 126, '2015-02-01 01:01:11.000000', 'consum', 0.0213, 'lps'),
	(393331, 126, '2015-02-01 01:01:12.000000', 'consum', 0.0217, 'lps'),
	(393332, 126, '2015-02-01 01:01:13.000000', 'consum', 0.0222, 'lps'),
	(393333, 126, '2015-02-01 01:01:14.000000', 'consum', 0.0220, 'lps'),
	(393334, 126, '2015-02-01 01:01:15.000000', 'consum', 0.0210, 'lps'),
	(393335, 126, '2015-02-01 01:01:16.000000', 'consum', 0.0211, 'lps'),
	(393336, 126, '2015-02-01 01:01:17.000000', 'consum', 0.0217, 'lps'),
	(393337, 126, '2015-02-01 01:01:18.000000', 'consum', 0.0211, 'lps'),
	(393338, 126, '2015-02-01 01:01:19.000000', 'consum', 0.0222, 'lps'),
	(393339, 126, '2015-02-01 01:01:20.000000', 'consum', 0.0211, 'lps'),
	(393340, 126, '2015-02-01 01:01:21.000000', 'consum', 0.0224, 'lps'),
	(393341, 126, '2015-02-01 01:01:22.000000', 'consum', 0.0218, 'lps'),
	(393342, 126, '2015-02-01 01:01:23.000000', 'consum', 0.0222, 'lps'),
	(393343, 126, '2015-02-01 01:01:24.000000', 'consum', 0.0218, 'lps'),
	(393344, 126, '2015-02-01 01:01:25.000000', 'consum', 0.0215, 'lps'),
	(393345, 126, '2015-02-01 01:01:26.000000', 'consum', 0.0224, 'lps'),
	(393346, 126, '2015-02-01 01:01:27.000000', 'consum', 0.0222, 'lps'),
	(393347, 126, '2015-02-01 01:01:28.000000', 'consum', 0.0211, 'lps'),
	(393348, 126, '2015-02-01 01:01:29.000000', 'consum', 0.0213, 'lps'),
	(393349, 126, '2015-02-01 01:01:30.000000', 'consum', 0.0221, 'lps'),
	(393350, 126, '2015-02-01 01:01:31.000000', 'consum', 0.0213, 'lps'),
	(393351, 126, '2015-02-01 01:01:32.000000', 'consum', 0.0221, 'lps'),
	(393352, 126, '2015-02-01 01:01:33.000000', 'consum', 0.0213, 'lps'),
	(393353, 126, '2015-02-01 01:01:34.000000', 'consum', 0.0223, 'lps'),
	(393354, 126, '2015-02-01 01:01:35.000000', 'consum', 0.0220, 'lps'),
	(393355, 126, '2015-02-01 01:01:36.000000', 'consum', 0.0222, 'lps'),
	(393356, 126, '2015-02-01 01:01:37.000000', 'consum', 0.0224, 'lps'),
	(393357, 126, '2015-02-01 01:01:38.000000', 'consum', 0.0215, 'lps'),
	(393358, 126, '2015-02-01 01:01:39.000000', 'consum', 0.0210, 'lps'),
	(393359, 126, '2015-02-01 01:01:40.000000', 'consum', 0.0224, 'lps'),
	(393360, 126, '2015-02-01 01:01:41.000000', 'consum', 0.0219, 'lps'),
	(393361, 126, '2015-02-01 01:01:42.000000', 'consum', 0.0217, 'lps'),
	(393362, 126, '2015-02-01 01:01:43.000000', 'consum', 0.0217, 'lps'),
	(393363, 126, '2015-02-01 01:01:44.000000', 'consum', 0.0223, 'lps'),
	(393364, 126, '2015-02-01 01:01:45.000000', 'consum', 0.0212, 'lps'),
	(393365, 126, '2015-02-01 01:01:46.000000', 'consum', 0.0210, 'lps'),
	(393366, 126, '2015-02-01 01:01:47.000000', 'consum', 0.0220, 'lps'),
	(393367, 126, '2015-02-01 01:01:48.000000', 'consum', 0.0215, 'lps'),
	(393368, 126, '2015-02-01 01:01:49.000000', 'consum', 0.0220, 'lps'),
	(393369, 126, '2015-02-01 01:01:50.000000', 'consum', 0.0217, 'lps'),
	(393370, 126, '2015-02-01 01:01:51.000000', 'consum', 0.0213, 'lps'),
	(393371, 126, '2015-02-01 01:01:52.000000', 'consum', 0.0222, 'lps'),
	(393372, 126, '2015-02-01 01:01:53.000000', 'consum', 0.0215, 'lps'),
	(393373, 126, '2015-02-01 01:01:54.000000', 'consum', 0.0216, 'lps'),
	(393374, 126, '2015-02-01 01:01:55.000000', 'consum', 0.0211, 'lps'),
	(393375, 126, '2015-02-01 01:01:56.000000', 'consum', 0.0213, 'lps'),
	(393376, 126, '2015-02-01 01:01:57.000000', 'consum', 0.0223, 'lps'),
	(393377, 126, '2015-02-01 01:01:58.000000', 'consum', 0.0220, 'lps'),
	(393378, 126, '2015-02-01 01:01:59.000000', 'consum', 0.0223, 'lps'),
	(393379, 126, '2015-02-01 01:02:00.000000', 'consum', 0.0214, 'lps'),
	(393380, 126, '2015-02-01 01:02:01.000000', 'consum', 0.0223, 'lps'),
	(393381, 126, '2015-02-01 01:02:02.000000', 'consum', 0.0216, 'lps'),
	(393382, 126, '2015-02-01 01:02:03.000000', 'consum', 0.0218, 'lps'),
	(393383, 126, '2015-02-01 01:02:04.000000', 'consum', 0.0218, 'lps'),
	(393384, 126, '2015-02-01 01:02:05.000000', 'consum', 0.0210, 'lps'),
	(393385, 126, '2015-02-01 01:02:06.000000', 'consum', 0.0217, 'lps'),
	(393386, 126, '2015-02-01 01:02:07.000000', 'consum', 0.0216, 'lps'),
	(393387, 126, '2015-02-01 01:02:08.000000', 'consum', 0.0218, 'lps'),
	(393388, 126, '2015-02-01 01:02:09.000000', 'consum', 0.0220, 'lps'),
	(393389, 126, '2015-02-01 01:02:10.000000', 'consum', 0.0219, 'lps'),
	(393390, 126, '2015-02-01 01:02:11.000000', 'consum', 0.0211, 'lps'),
	(393391, 126, '2015-02-01 01:02:12.000000', 'consum', 0.0218, 'lps'),
	(393392, 126, '2015-02-01 01:02:13.000000', 'consum', 0.0217, 'lps'),
	(393393, 126, '2015-02-01 01:02:14.000000', 'consum', 0.0224, 'lps'),
	(393394, 126, '2015-02-01 01:02:15.000000', 'consum', 0.0211, 'lps'),
	(393395, 126, '2015-02-01 01:02:16.000000', 'consum', 0.0222, 'lps'),
	(393396, 126, '2015-02-01 01:02:17.000000', 'consum', 0.0221, 'lps'),
	(393397, 126, '2015-02-01 01:02:18.000000', 'consum', 0.0213, 'lps'),
	(393398, 126, '2015-02-01 01:02:19.000000', 'consum', 0.0222, 'lps'),
	(393399, 126, '2015-02-01 01:02:20.000000', 'consum', 0.0218, 'lps'),
	(393400, 126, '2015-02-01 01:02:21.000000', 'consum', 0.0213, 'lps'),
	(393401, 126, '2015-02-01 01:02:22.000000', 'consum', 0.0216, 'lps'),
	(393402, 126, '2015-02-01 01:02:23.000000', 'consum', 0.0219, 'lps'),
	(393403, 126, '2015-02-01 01:02:24.000000', 'consum', 0.0222, 'lps'),
	(393404, 126, '2015-02-01 01:02:25.000000', 'consum', 0.0211, 'lps'),
	(393405, 126, '2015-02-01 01:02:26.000000', 'consum', 0.0213, 'lps'),
	(393406, 126, '2015-02-01 01:02:27.000000', 'consum', 0.0221, 'lps'),
	(393407, 126, '2015-02-01 01:02:28.000000', 'consum', 0.0210, 'lps'),
	(393408, 126, '2015-02-01 01:02:29.000000', 'consum', 0.0210, 'lps'),
	(393409, 126, '2015-02-01 01:02:30.000000', 'consum', 0.0211, 'lps'),
	(393410, 126, '2015-02-01 01:02:31.000000', 'consum', 0.0215, 'lps'),
	(393411, 126, '2015-02-01 01:02:32.000000', 'consum', 0.0218, 'lps'),
	(393412, 126, '2015-02-01 01:02:33.000000', 'consum', 0.0222, 'lps'),
	(393413, 126, '2015-02-01 01:02:34.000000', 'consum', 0.0213, 'lps'),
	(393414, 126, '2015-02-01 01:02:35.000000', 'consum', 0.0221, 'lps'),
	(393415, 126, '2015-02-01 01:02:36.000000', 'consum', 0.0211, 'lps'),
	(393416, 126, '2015-02-01 01:02:37.000000', 'consum', 0.0211, 'lps'),
	(393417, 126, '2015-02-01 01:02:38.000000', 'consum', 0.0216, 'lps'),
	(393418, 126, '2015-02-01 01:02:39.000000', 'consum', 0.0220, 'lps'),
	(393419, 126, '2015-02-01 01:02:40.000000', 'consum', 0.0212, 'lps'),
	(393420, 126, '2015-02-01 01:02:41.000000', 'consum', 0.0220, 'lps'),
	(393421, 126, '2015-02-01 01:02:42.000000', 'consum', 0.0224, 'lps'),
	(393422, 126, '2015-02-01 01:02:43.000000', 'consum', 0.0221, 'lps'),
	(393423, 126, '2015-02-01 01:02:44.000000', 'consum', 0.0222, 'lps'),
	(393424, 126, '2015-02-01 01:02:45.000000', 'consum', 0.0224, 'lps'),
	(393425, 126, '2015-02-01 01:02:46.000000', 'consum', 0.0215, 'lps'),
	(393426, 126, '2015-02-01 01:02:47.000000', 'consum', 0.0221, 'lps'),
	(393427, 126, '2015-02-01 01:02:48.000000', 'consum', 0.0224, 'lps'),
	(393428, 126, '2015-02-01 01:02:49.000000', 'consum', 0.0214, 'lps'),
	(393429, 126, '2015-02-01 01:02:50.000000', 'consum', 0.0220, 'lps'),
	(393430, 126, '2015-02-01 01:02:51.000000', 'consum', 0.0218, 'lps'),
	(393431, 126, '2015-02-01 01:02:52.000000', 'consum', 0.0219, 'lps'),
	(393432, 126, '2015-02-01 01:02:53.000000', 'consum', 0.0217, 'lps'),
	(393433, 126, '2015-02-01 01:02:54.000000', 'consum', 0.0219, 'lps'),
	(393434, 126, '2015-02-01 01:02:55.000000', 'consum', 0.0220, 'lps'),
	(393435, 126, '2015-02-01 01:02:56.000000', 'consum', 0.0219, 'lps'),
	(393436, 126, '2015-02-01 01:02:57.000000', 'consum', 0.0224, 'lps'),
	(393437, 126, '2015-02-01 01:02:58.000000', 'consum', 0.0224, 'lps'),
	(393438, 126, '2015-02-01 01:02:59.000000', 'consum', 0.0223, 'lps'),
	(393439, 126, '2015-02-01 01:03:00.000000', 'consum', 0.0218, 'lps'),
	(393440, 126, '2015-02-01 01:03:01.000000', 'consum', 0.0211, 'lps'),
	(393441, 126, '2015-02-01 01:03:02.000000', 'consum', 0.0222, 'lps'),
	(393442, 126, '2015-02-01 01:03:03.000000', 'consum', 0.0222, 'lps'),
	(393443, 126, '2015-02-01 01:03:04.000000', 'consum', 0.0220, 'lps'),
	(393444, 126, '2015-02-01 01:03:05.000000', 'consum', 0.0224, 'lps'),
	(393445, 126, '2015-02-01 01:03:06.000000', 'consum', 0.0220, 'lps'),
	(393446, 126, '2015-02-01 01:03:07.000000', 'consum', 0.0220, 'lps'),
	(393447, 126, '2015-02-01 01:03:08.000000', 'consum', 0.0213, 'lps'),
	(393448, 126, '2015-02-01 01:03:09.000000', 'consum', 0.0211, 'lps'),
	(393449, 126, '2015-02-01 01:03:10.000000', 'consum', 0.0223, 'lps'),
	(393450, 126, '2015-02-01 01:03:11.000000', 'consum', 0.0212, 'lps'),
	(393451, 126, '2015-02-01 01:03:12.000000', 'consum', 0.0210, 'lps'),
	(393452, 126, '2015-02-01 01:03:13.000000', 'consum', 0.0220, 'lps'),
	(393453, 126, '2015-02-01 01:03:14.000000', 'consum', 0.0215, 'lps'),
	(393454, 126, '2015-02-01 01:03:15.000000', 'consum', 0.0222, 'lps'),
	(393455, 126, '2015-02-01 01:03:16.000000', 'consum', 0.0223, 'lps'),
	(393456, 126, '2015-02-01 01:03:17.000000', 'consum', 0.0211, 'lps'),
	(393457, 126, '2015-02-01 01:03:18.000000', 'consum', 0.0219, 'lps'),
	(393458, 126, '2015-02-01 01:03:19.000000', 'consum', 0.0210, 'lps'),
	(393459, 126, '2015-02-01 01:03:20.000000', 'consum', 0.0213, 'lps'),
	(393460, 126, '2015-02-01 01:03:21.000000', 'consum', 0.0211, 'lps'),
	(393461, 126, '2015-02-01 01:03:22.000000', 'consum', 0.0220, 'lps'),
	(393462, 126, '2015-02-01 01:03:23.000000', 'consum', 0.0214, 'lps'),
	(393463, 126, '2015-02-01 01:03:24.000000', 'consum', 0.0214, 'lps'),
	(393464, 126, '2015-02-01 01:03:25.000000', 'consum', 0.0218, 'lps'),
	(393465, 126, '2015-02-01 01:03:26.000000', 'consum', 0.0211, 'lps'),
	(393466, 126, '2015-02-01 01:03:27.000000', 'consum', 0.0218, 'lps'),
	(393467, 126, '2015-02-01 01:03:28.000000', 'consum', 0.0220, 'lps'),
	(393468, 126, '2015-02-01 01:03:29.000000', 'consum', 0.0221, 'lps'),
	(393469, 126, '2015-02-01 01:03:30.000000', 'consum', 0.0222, 'lps'),
	(393470, 126, '2015-02-01 01:03:31.000000', 'consum', 0.0222, 'lps'),
	(393471, 126, '2015-02-01 01:03:32.000000', 'consum', 0.0219, 'lps'),
	(393472, 126, '2015-02-01 01:03:33.000000', 'consum', 0.0221, 'lps'),
	(393473, 126, '2015-02-01 01:03:34.000000', 'consum', 0.0221, 'lps'),
	(393474, 126, '2015-02-01 01:03:35.000000', 'consum', 0.0216, 'lps'),
	(393475, 126, '2015-02-01 01:03:36.000000', 'consum', 0.0211, 'lps'),
	(393476, 126, '2015-02-01 01:03:37.000000', 'consum', 0.0212, 'lps'),
	(393477, 126, '2015-02-01 01:03:38.000000', 'consum', 0.0218, 'lps'),
	(393478, 126, '2015-02-01 01:03:39.000000', 'consum', 0.0212, 'lps'),
	(393479, 126, '2015-02-01 01:03:40.000000', 'consum', 0.0211, 'lps'),
	(393480, 126, '2015-02-01 01:03:41.000000', 'consum', 0.0212, 'lps'),
	(393481, 126, '2015-02-01 01:03:42.000000', 'consum', 0.0218, 'lps'),
	(393482, 126, '2015-02-01 01:03:43.000000', 'consum', 0.0213, 'lps'),
	(393483, 126, '2015-02-01 01:03:44.000000', 'consum', 0.0217, 'lps'),
	(393484, 126, '2015-02-01 01:03:45.000000', 'consum', 0.0220, 'lps'),
	(393485, 126, '2015-02-01 01:03:46.000000', 'consum', 0.0211, 'lps'),
	(393486, 126, '2015-02-01 01:03:47.000000', 'consum', 0.0216, 'lps'),
	(393487, 126, '2015-02-01 01:03:48.000000', 'consum', 0.0222, 'lps'),
	(393488, 126, '2015-02-01 01:03:49.000000', 'consum', 0.0221, 'lps'),
	(393489, 126, '2015-02-01 01:03:50.000000', 'consum', 0.0217, 'lps'),
	(393490, 126, '2015-02-01 01:03:51.000000', 'consum', 0.0213, 'lps'),
	(393491, 126, '2015-02-01 01:03:52.000000', 'consum', 0.0218, 'lps'),
	(393492, 126, '2015-02-01 01:03:53.000000', 'consum', 0.0213, 'lps'),
	(393493, 126, '2015-02-01 01:03:54.000000', 'consum', 0.0216, 'lps'),
	(393494, 126, '2015-02-01 01:03:55.000000', 'consum', 0.0214, 'lps'),
	(393495, 126, '2015-02-01 01:03:56.000000', 'consum', 0.0216, 'lps'),
	(393496, 126, '2015-02-01 01:03:57.000000', 'consum', 0.0212, 'lps'),
	(393497, 126, '2015-02-01 01:03:58.000000', 'consum', 0.0216, 'lps'),
	(393498, 126, '2015-02-01 01:03:59.000000', 'consum', 0.0221, 'lps'),
	(393499, 126, '2015-02-01 01:04:00.000000', 'consum', 0.0217, 'lps'),
	(393500, 126, '2015-02-01 01:04:01.000000', 'consum', 0.0212, 'lps'),
	(393501, 126, '2015-02-01 01:04:02.000000', 'consum', 0.0215, 'lps'),
	(393502, 126, '2015-02-01 01:04:03.000000', 'consum', 0.0215, 'lps'),
	(393503, 126, '2015-02-01 01:04:04.000000', 'consum', 0.0219, 'lps'),
	(393504, 126, '2015-02-01 01:04:05.000000', 'consum', 0.0211, 'lps'),
	(393505, 126, '2015-02-01 01:04:06.000000', 'consum', 0.0218, 'lps'),
	(393506, 126, '2015-02-01 01:04:07.000000', 'consum', 0.0217, 'lps'),
	(393507, 126, '2015-02-01 01:04:08.000000', 'consum', 0.0224, 'lps'),
	(393508, 126, '2015-02-01 01:04:09.000000', 'consum', 0.0212, 'lps'),
	(393509, 126, '2015-02-01 01:04:10.000000', 'consum', 0.0224, 'lps'),
	(393510, 126, '2015-02-01 01:04:11.000000', 'consum', 0.0216, 'lps'),
	(393511, 126, '2015-02-01 01:04:12.000000', 'consum', 0.0211, 'lps'),
	(393512, 126, '2015-02-01 01:04:13.000000', 'consum', 0.0215, 'lps'),
	(393513, 126, '2015-02-01 01:04:14.000000', 'consum', 0.0217, 'lps'),
	(393514, 126, '2015-02-01 01:04:15.000000', 'consum', 0.0217, 'lps'),
	(393515, 126, '2015-02-01 01:04:16.000000', 'consum', 0.0221, 'lps'),
	(393516, 126, '2015-02-01 01:04:17.000000', 'consum', 0.0217, 'lps'),
	(393517, 126, '2015-02-01 01:04:18.000000', 'consum', 0.0212, 'lps'),
	(393518, 126, '2015-02-01 01:04:19.000000', 'consum', 0.0214, 'lps'),
	(393519, 126, '2015-02-01 01:04:20.000000', 'consum', 0.0210, 'lps'),
	(393520, 126, '2015-02-01 01:04:21.000000', 'consum', 0.0214, 'lps'),
	(393521, 126, '2015-02-01 01:04:22.000000', 'consum', 0.0214, 'lps'),
	(393522, 126, '2015-02-01 01:04:23.000000', 'consum', 0.0218, 'lps'),
	(393523, 126, '2015-02-01 01:04:24.000000', 'consum', 0.0210, 'lps'),
	(393524, 126, '2015-02-01 01:04:25.000000', 'consum', 0.0217, 'lps'),
	(393525, 126, '2015-02-01 01:04:26.000000', 'consum', 0.0216, 'lps'),
	(393526, 126, '2015-02-01 01:04:27.000000', 'consum', 0.0219, 'lps'),
	(393527, 126, '2015-02-01 01:04:28.000000', 'consum', 0.0223, 'lps'),
	(393528, 126, '2015-02-01 01:04:29.000000', 'consum', 0.0217, 'lps'),
	(393529, 126, '2015-02-01 01:04:30.000000', 'consum', 0.0221, 'lps'),
	(393530, 126, '2015-02-01 01:04:31.000000', 'consum', 0.0215, 'lps'),
	(393531, 126, '2015-02-01 01:04:32.000000', 'consum', 0.0216, 'lps'),
	(393532, 126, '2015-02-01 01:04:33.000000', 'consum', 0.0214, 'lps'),
	(393533, 126, '2015-02-01 01:04:34.000000', 'consum', 0.0210, 'lps'),
	(393534, 126, '2015-02-01 01:04:35.000000', 'consum', 0.0214, 'lps'),
	(393535, 126, '2015-02-01 01:04:36.000000', 'consum', 0.0216, 'lps'),
	(393536, 126, '2015-02-01 01:04:37.000000', 'consum', 0.0212, 'lps'),
	(393537, 126, '2015-02-01 01:04:38.000000', 'consum', 0.0218, 'lps'),
	(393538, 126, '2015-02-01 01:04:39.000000', 'consum', 0.0214, 'lps'),
	(393539, 126, '2015-02-01 01:04:40.000000', 'consum', 0.0223, 'lps'),
	(393540, 126, '2015-02-01 01:04:41.000000', 'consum', 0.0218, 'lps'),
	(393541, 126, '2015-02-01 01:04:42.000000', 'consum', 0.0213, 'lps'),
	(393542, 126, '2015-02-01 01:04:43.000000', 'consum', 0.0217, 'lps'),
	(393543, 126, '2015-02-01 01:04:44.000000', 'consum', 0.0219, 'lps'),
	(393544, 126, '2015-02-01 01:04:45.000000', 'consum', 0.0220, 'lps'),
	(393545, 126, '2015-02-01 01:04:46.000000', 'consum', 0.0219, 'lps'),
	(393546, 126, '2015-02-01 01:04:47.000000', 'consum', 0.0212, 'lps'),
	(393547, 126, '2015-02-01 01:04:48.000000', 'consum', 0.0224, 'lps'),
	(393548, 126, '2015-02-01 01:04:49.000000', 'consum', 0.0212, 'lps'),
	(393549, 126, '2015-02-01 01:04:50.000000', 'consum', 0.0223, 'lps'),
	(393550, 126, '2015-02-01 01:04:51.000000', 'consum', 0.0211, 'lps'),
	(393551, 126, '2015-02-01 01:04:52.000000', 'consum', 0.0223, 'lps'),
	(393552, 126, '2015-02-01 01:04:53.000000', 'consum', 0.0212, 'lps'),
	(393553, 126, '2015-02-01 01:04:54.000000', 'consum', 0.0224, 'lps'),
	(393554, 126, '2015-02-01 01:04:55.000000', 'consum', 0.0217, 'lps'),
	(393555, 126, '2015-02-01 01:04:56.000000', 'consum', 0.0218, 'lps'),
	(393556, 126, '2015-02-01 01:04:57.000000', 'consum', 0.0215, 'lps'),
	(393557, 126, '2015-02-01 01:04:58.000000', 'consum', 0.0210, 'lps'),
	(393558, 126, '2015-02-01 01:04:59.000000', 'consum', 0.0211, 'lps'),
	(393559, 126, '2015-02-01 01:05:00.000000', 'consum', 0.0217, 'lps'),
	(393560, 126, '2015-02-01 01:05:01.000000', 'consum', 0.0224, 'lps'),
	(393561, 126, '2015-02-01 01:05:02.000000', 'consum', 0.0218, 'lps'),
	(393562, 126, '2015-02-01 01:05:03.000000', 'consum', 0.0224, 'lps'),
	(393563, 126, '2015-02-01 01:05:04.000000', 'consum', 0.0211, 'lps'),
	(393564, 126, '2015-02-01 01:05:05.000000', 'consum', 0.0216, 'lps'),
	(393565, 126, '2015-02-01 01:05:06.000000', 'consum', 0.0210, 'lps'),
	(393566, 126, '2015-02-01 01:05:07.000000', 'consum', 0.0223, 'lps'),
	(393567, 126, '2015-02-01 01:05:08.000000', 'consum', 0.0214, 'lps'),
	(393568, 126, '2015-02-01 01:05:09.000000', 'consum', 0.0222, 'lps'),
	(393569, 126, '2015-02-01 01:05:10.000000', 'consum', 0.0215, 'lps'),
	(393570, 126, '2015-02-01 01:05:11.000000', 'consum', 0.0212, 'lps'),
	(393571, 126, '2015-02-01 01:05:12.000000', 'consum', 0.0219, 'lps'),
	(393572, 126, '2015-02-01 01:05:13.000000', 'consum', 0.0223, 'lps'),
	(393573, 126, '2015-02-01 01:05:14.000000', 'consum', 0.0218, 'lps'),
	(393574, 126, '2015-02-01 01:05:15.000000', 'consum', 0.0210, 'lps'),
	(393575, 126, '2015-02-01 01:05:16.000000', 'consum', 0.0219, 'lps'),
	(393576, 126, '2015-02-01 01:05:17.000000', 'consum', 0.0210, 'lps'),
	(393577, 126, '2015-02-01 01:05:18.000000', 'consum', 0.0211, 'lps'),
	(393578, 126, '2015-02-01 01:05:19.000000', 'consum', 0.0218, 'lps'),
	(393579, 126, '2015-02-01 01:05:20.000000', 'consum', 0.0218, 'lps'),
	(393580, 126, '2015-02-01 01:05:21.000000', 'consum', 0.0210, 'lps'),
	(393581, 126, '2015-02-01 01:05:22.000000', 'consum', 0.0217, 'lps'),
	(393582, 126, '2015-02-01 01:05:23.000000', 'consum', 0.0217, 'lps'),
	(393583, 126, '2015-02-01 01:05:24.000000', 'consum', 0.0223, 'lps'),
	(393584, 126, '2015-02-01 01:05:25.000000', 'consum', 0.0211, 'lps'),
	(393585, 126, '2015-02-01 01:05:26.000000', 'consum', 0.0220, 'lps'),
	(393586, 126, '2015-02-01 01:05:27.000000', 'consum', 0.0211, 'lps'),
	(393587, 126, '2015-02-01 01:05:28.000000', 'consum', 0.0218, 'lps'),
	(393588, 126, '2015-02-01 01:05:29.000000', 'consum', 0.0218, 'lps'),
	(393589, 126, '2015-02-01 01:05:30.000000', 'consum', 0.0210, 'lps'),
	(393590, 126, '2015-02-01 01:05:31.000000', 'consum', 0.0217, 'lps'),
	(393591, 126, '2015-02-01 01:05:32.000000', 'consum', 0.0217, 'lps'),
	(393592, 126, '2015-02-01 01:05:33.000000', 'consum', 0.0222, 'lps'),
	(393593, 126, '2015-02-01 01:05:34.000000', 'consum', 0.0221, 'lps'),
	(393594, 126, '2015-02-01 01:05:35.000000', 'consum', 0.0216, 'lps'),
	(393595, 126, '2015-02-01 01:05:36.000000', 'consum', 0.0222, 'lps'),
	(393596, 126, '2015-02-01 01:05:37.000000', 'consum', 0.0223, 'lps'),
	(393597, 126, '2015-02-01 01:05:38.000000', 'consum', 0.0222, 'lps'),
	(393598, 126, '2015-02-01 01:05:39.000000', 'consum', 0.0219, 'lps'),
	(393599, 126, '2015-02-01 01:05:40.000000', 'consum', 0.0219, 'lps'),
	(393600, 126, '2015-02-01 01:05:41.000000', 'consum', 0.0213, 'lps'),
	(393601, 126, '2015-02-01 01:05:42.000000', 'consum', 0.0213, 'lps'),
	(393602, 126, '2015-02-01 01:05:43.000000', 'consum', 0.0216, 'lps'),
	(393603, 126, '2015-02-01 01:05:44.000000', 'consum', 0.0217, 'lps'),
	(393604, 126, '2015-02-01 01:05:45.000000', 'consum', 0.0214, 'lps'),
	(393605, 126, '2015-02-01 01:05:46.000000', 'consum', 0.0223, 'lps'),
	(393606, 126, '2015-02-01 01:05:47.000000', 'consum', 0.0217, 'lps'),
	(393607, 126, '2015-02-01 01:05:48.000000', 'consum', 0.0224, 'lps'),
	(393608, 126, '2015-02-01 01:05:49.000000', 'consum', 0.0213, 'lps'),
	(393609, 126, '2015-02-01 01:05:50.000000', 'consum', 0.0216, 'lps'),
	(393610, 126, '2015-02-01 01:05:51.000000', 'consum', 0.0213, 'lps'),
	(393611, 126, '2015-02-01 01:05:52.000000', 'consum', 0.0210, 'lps'),
	(393612, 126, '2015-02-01 01:05:53.000000', 'consum', 0.0218, 'lps'),
	(393613, 126, '2015-02-01 01:05:54.000000', 'consum', 0.0218, 'lps'),
	(393614, 126, '2015-02-01 01:05:55.000000', 'consum', 0.0214, 'lps'),
	(393615, 126, '2015-02-01 01:05:56.000000', 'consum', 0.0219, 'lps'),
	(393616, 126, '2015-02-01 01:05:57.000000', 'consum', 0.0213, 'lps'),
	(393617, 126, '2015-02-01 01:05:58.000000', 'consum', 0.0214, 'lps'),
	(393618, 126, '2015-02-01 01:05:59.000000', 'consum', 0.0222, 'lps'),
	(393619, 126, '2015-02-01 01:06:00.000000', 'consum', 0.0215, 'lps'),
	(393620, 126, '2015-02-01 01:06:01.000000', 'consum', 0.0215, 'lps'),
	(393621, 126, '2015-02-01 01:06:02.000000', 'consum', 0.0219, 'lps'),
	(393622, 126, '2015-02-01 01:06:03.000000', 'consum', 0.0224, 'lps'),
	(393623, 126, '2015-02-01 01:06:04.000000', 'consum', 0.0210, 'lps'),
	(393624, 126, '2015-02-01 01:06:05.000000', 'consum', 0.0213, 'lps'),
	(393625, 126, '2015-02-01 01:06:06.000000', 'consum', 0.0224, 'lps'),
	(393626, 126, '2015-02-01 01:06:07.000000', 'consum', 0.0213, 'lps'),
	(393627, 126, '2015-02-01 01:06:08.000000', 'consum', 0.0211, 'lps'),
	(393628, 126, '2015-02-01 01:06:09.000000', 'consum', 0.0224, 'lps'),
	(393629, 126, '2015-02-01 01:06:10.000000', 'consum', 0.0218, 'lps'),
	(393630, 126, '2015-02-01 01:06:11.000000', 'consum', 0.0222, 'lps'),
	(393631, 126, '2015-02-01 01:06:12.000000', 'consum', 0.0219, 'lps'),
	(393632, 126, '2015-02-01 01:06:13.000000', 'consum', 0.0218, 'lps'),
	(393633, 126, '2015-02-01 01:06:14.000000', 'consum', 0.0223, 'lps'),
	(393634, 126, '2015-02-01 01:06:15.000000', 'consum', 0.0223, 'lps'),
	(393635, 126, '2015-02-01 01:06:16.000000', 'consum', 0.0221, 'lps'),
	(393636, 126, '2015-02-01 01:06:17.000000', 'consum', 0.0224, 'lps'),
	(393637, 126, '2015-02-01 01:06:18.000000', 'consum', 0.0220, 'lps'),
	(393638, 126, '2015-02-01 01:06:19.000000', 'consum', 0.0219, 'lps'),
	(393639, 126, '2015-02-01 01:06:20.000000', 'consum', 0.0210, 'lps'),
	(393640, 126, '2015-02-01 01:06:21.000000', 'consum', 0.0213, 'lps'),
	(393641, 126, '2015-02-01 01:06:22.000000', 'consum', 0.0211, 'lps'),
	(393642, 126, '2015-02-01 01:06:23.000000', 'consum', 0.0222, 'lps'),
	(393643, 126, '2015-02-01 01:06:24.000000', 'consum', 0.0223, 'lps'),
	(393644, 126, '2015-02-01 01:06:25.000000', 'consum', 0.0223, 'lps'),
	(393645, 126, '2015-02-01 01:06:26.000000', 'consum', 0.0223, 'lps'),
	(393646, 126, '2015-02-01 01:06:27.000000', 'consum', 0.0222, 'lps'),
	(393647, 126, '2015-02-01 01:06:28.000000', 'consum', 0.0215, 'lps'),
	(393648, 126, '2015-02-01 01:06:29.000000', 'consum', 0.0215, 'lps'),
	(393649, 126, '2015-02-01 01:06:30.000000', 'consum', 0.0218, 'lps'),
	(393650, 126, '2015-02-01 01:06:31.000000', 'consum', 0.0224, 'lps'),
	(393651, 126, '2015-02-01 01:06:32.000000', 'consum', 0.0210, 'lps'),
	(393652, 126, '2015-02-01 01:06:33.000000', 'consum', 0.0212, 'lps'),
	(393653, 126, '2015-02-01 01:06:34.000000', 'consum', 0.0220, 'lps'),
	(393654, 126, '2015-02-01 01:06:35.000000', 'consum', 0.0210, 'lps'),
	(393655, 126, '2015-02-01 01:06:36.000000', 'consum', 0.0212, 'lps'),
	(393656, 126, '2015-02-01 01:06:37.000000', 'consum', 0.0218, 'lps'),
	(393657, 126, '2015-02-01 01:06:38.000000', 'consum', 0.0216, 'lps'),
	(393658, 126, '2015-02-01 01:06:39.000000', 'consum', 0.0217, 'lps'),
	(393659, 126, '2015-02-01 01:06:40.000000', 'consum', 0.0214, 'lps'),
	(393660, 126, '2015-02-01 01:06:41.000000', 'consum', 0.0223, 'lps'),
	(393661, 126, '2015-02-01 01:06:42.000000', 'consum', 0.0219, 'lps'),
	(393662, 126, '2015-02-01 01:06:43.000000', 'consum', 0.0215, 'lps'),
	(393663, 126, '2015-02-01 01:06:44.000000', 'consum', 0.0210, 'lps'),
	(393664, 126, '2015-02-01 01:06:45.000000', 'consum', 0.0212, 'lps'),
	(393665, 126, '2015-02-01 01:06:46.000000', 'consum', 0.0217, 'lps'),
	(393666, 126, '2015-02-01 01:06:47.000000', 'consum', 0.0213, 'lps'),
	(393667, 126, '2015-02-01 01:06:48.000000', 'consum', 0.0217, 'lps'),
	(393668, 126, '2015-02-01 01:06:49.000000', 'consum', 0.0223, 'lps'),
	(393669, 126, '2015-02-01 01:06:50.000000', 'consum', 0.0210, 'lps'),
	(393670, 126, '2015-02-01 01:06:51.000000', 'consum', 0.0214, 'lps'),
	(393671, 126, '2015-02-01 01:06:52.000000', 'consum', 0.0217, 'lps'),
	(393672, 126, '2015-02-01 01:06:53.000000', 'consum', 0.0216, 'lps'),
	(393673, 126, '2015-02-01 01:06:54.000000', 'consum', 0.0223, 'lps'),
	(393674, 126, '2015-02-01 01:06:55.000000', 'consum', 0.0211, 'lps'),
	(393675, 126, '2015-02-01 01:06:56.000000', 'consum', 0.0222, 'lps'),
	(393676, 126, '2015-02-01 01:06:57.000000', 'consum', 0.0223, 'lps'),
	(393677, 126, '2015-02-01 01:06:58.000000', 'consum', 0.0210, 'lps'),
	(393678, 126, '2015-02-01 01:06:59.000000', 'consum', 0.0217, 'lps'),
	(393679, 126, '2015-02-01 01:07:00.000000', 'consum', 0.0214, 'lps'),
	(393680, 126, '2015-02-01 01:07:01.000000', 'consum', 0.0224, 'lps'),
	(393681, 126, '2015-02-01 01:07:02.000000', 'consum', 0.0222, 'lps'),
	(393682, 126, '2015-02-01 01:07:03.000000', 'consum', 0.0216, 'lps'),
	(393683, 126, '2015-02-01 01:07:04.000000', 'consum', 0.0218, 'lps'),
	(393684, 126, '2015-02-01 01:07:05.000000', 'consum', 0.0216, 'lps'),
	(393685, 126, '2015-02-01 01:07:06.000000', 'consum', 0.0219, 'lps'),
	(393686, 126, '2015-02-01 01:07:07.000000', 'consum', 0.0220, 'lps'),
	(393687, 126, '2015-02-01 01:07:08.000000', 'consum', 0.0220, 'lps'),
	(393688, 126, '2015-02-01 01:07:09.000000', 'consum', 0.0214, 'lps'),
	(393689, 126, '2015-02-01 01:07:10.000000', 'consum', 0.0216, 'lps'),
	(393690, 126, '2015-02-01 01:07:11.000000', 'consum', 0.0215, 'lps'),
	(393691, 126, '2015-02-01 01:07:12.000000', 'consum', 0.0218, 'lps'),
	(393692, 126, '2015-02-01 01:07:13.000000', 'consum', 0.0221, 'lps'),
	(393693, 126, '2015-02-01 01:07:14.000000', 'consum', 0.0211, 'lps'),
	(393694, 126, '2015-02-01 01:07:15.000000', 'consum', 0.0210, 'lps'),
	(393695, 126, '2015-02-01 01:07:16.000000', 'consum', 0.0211, 'lps'),
	(393696, 126, '2015-02-01 01:07:17.000000', 'consum', 0.0212, 'lps'),
	(393697, 126, '2015-02-01 01:07:18.000000', 'consum', 0.0221, 'lps'),
	(393698, 126, '2015-02-01 01:07:19.000000', 'consum', 0.0213, 'lps'),
	(393699, 126, '2015-02-01 01:07:20.000000', 'consum', 0.0223, 'lps'),
	(393700, 126, '2015-02-01 01:07:21.000000', 'consum', 0.0222, 'lps'),
	(393701, 126, '2015-02-01 01:07:22.000000', 'consum', 0.0216, 'lps'),
	(393702, 126, '2015-02-01 01:07:23.000000', 'consum', 0.0220, 'lps'),
	(393703, 126, '2015-02-01 01:07:24.000000', 'consum', 0.0212, 'lps'),
	(393704, 126, '2015-02-01 01:07:25.000000', 'consum', 0.0222, 'lps'),
	(393705, 126, '2015-02-01 01:07:26.000000', 'consum', 0.0219, 'lps'),
	(393706, 126, '2015-02-01 01:07:27.000000', 'consum', 0.0218, 'lps'),
	(393707, 126, '2015-02-01 01:07:28.000000', 'consum', 0.0224, 'lps'),
	(393708, 126, '2015-02-01 01:07:29.000000', 'consum', 0.0211, 'lps'),
	(393709, 126, '2015-02-01 01:07:30.000000', 'consum', 0.0219, 'lps'),
	(393710, 126, '2015-02-01 01:07:31.000000', 'consum', 0.0224, 'lps'),
	(393711, 126, '2015-02-01 01:07:32.000000', 'consum', 0.0223, 'lps'),
	(393712, 126, '2015-02-01 01:07:33.000000', 'consum', 0.0220, 'lps'),
	(393713, 126, '2015-02-01 01:07:34.000000', 'consum', 0.0221, 'lps'),
	(393714, 126, '2015-02-01 01:07:35.000000', 'consum', 0.0219, 'lps'),
	(393715, 126, '2015-02-01 01:07:36.000000', 'consum', 0.0221, 'lps'),
	(393716, 126, '2015-02-01 01:07:37.000000', 'consum', 0.0211, 'lps'),
	(393717, 126, '2015-02-01 01:07:38.000000', 'consum', 0.0212, 'lps'),
	(393718, 126, '2015-02-01 01:07:39.000000', 'consum', 0.0216, 'lps'),
	(393719, 126, '2015-02-01 01:07:40.000000', 'consum', 0.0219, 'lps'),
	(393720, 126, '2015-02-01 01:07:41.000000', 'consum', 0.0210, 'lps'),
	(393721, 126, '2015-02-01 01:07:42.000000', 'consum', 0.0213, 'lps'),
	(393722, 126, '2015-02-01 01:07:43.000000', 'consum', 0.0210, 'lps'),
	(393723, 126, '2015-02-01 01:07:44.000000', 'consum', 0.0218, 'lps'),
	(393724, 126, '2015-02-01 01:07:45.000000', 'consum', 0.0218, 'lps'),
	(393725, 126, '2015-02-01 01:07:46.000000', 'consum', 0.0212, 'lps'),
	(393726, 126, '2015-02-01 01:07:47.000000', 'consum', 0.0211, 'lps'),
	(393727, 126, '2015-02-01 01:07:48.000000', 'consum', 0.0210, 'lps'),
	(393728, 126, '2015-02-01 01:07:49.000000', 'consum', 0.0222, 'lps'),
	(393729, 126, '2015-02-01 01:07:50.000000', 'consum', 0.0212, 'lps'),
	(393730, 126, '2015-02-01 01:07:51.000000', 'consum', 0.0213, 'lps'),
	(393731, 126, '2015-02-01 01:07:52.000000', 'consum', 0.0220, 'lps'),
	(393732, 126, '2015-02-01 01:07:53.000000', 'consum', 0.0223, 'lps'),
	(393733, 126, '2015-02-01 01:07:54.000000', 'consum', 0.0214, 'lps'),
	(393734, 126, '2015-02-01 01:07:55.000000', 'consum', 0.0220, 'lps'),
	(393735, 126, '2015-02-01 01:07:56.000000', 'consum', 0.0220, 'lps'),
	(393736, 126, '2015-02-01 01:07:57.000000', 'consum', 0.0215, 'lps'),
	(393737, 126, '2015-02-01 01:07:58.000000', 'consum', 0.0221, 'lps'),
	(393738, 126, '2015-02-01 01:07:59.000000', 'consum', 0.0222, 'lps'),
	(393739, 126, '2015-02-01 01:08:00.000000', 'consum', 0.0220, 'lps'),
	(393740, 126, '2015-02-01 01:08:01.000000', 'consum', 0.0210, 'lps'),
	(393741, 126, '2015-02-01 01:08:02.000000', 'consum', 0.0211, 'lps'),
	(393742, 126, '2015-02-01 01:08:03.000000', 'consum', 0.0216, 'lps'),
	(393743, 126, '2015-02-01 01:08:04.000000', 'consum', 0.0223, 'lps'),
	(393744, 126, '2015-02-01 01:08:05.000000', 'consum', 0.0213, 'lps'),
	(393745, 126, '2015-02-01 01:08:06.000000', 'consum', 0.0217, 'lps'),
	(393746, 126, '2015-02-01 01:08:07.000000', 'consum', 0.0222, 'lps'),
	(393747, 126, '2015-02-01 01:08:08.000000', 'consum', 0.0218, 'lps'),
	(393748, 126, '2015-02-01 01:08:09.000000', 'consum', 0.0214, 'lps'),
	(393749, 126, '2015-02-01 01:08:10.000000', 'consum', 0.0222, 'lps'),
	(393750, 126, '2015-02-01 01:08:11.000000', 'consum', 0.0212, 'lps'),
	(393751, 126, '2015-02-01 01:08:12.000000', 'consum', 0.0216, 'lps'),
	(393752, 126, '2015-02-01 01:08:13.000000', 'consum', 0.0220, 'lps'),
	(393753, 126, '2015-02-01 01:08:14.000000', 'consum', 0.0210, 'lps'),
	(393754, 126, '2015-02-01 01:08:15.000000', 'consum', 0.0213, 'lps'),
	(393755, 126, '2015-02-01 01:08:16.000000', 'consum', 0.0223, 'lps'),
	(393756, 126, '2015-02-01 01:08:17.000000', 'consum', 0.0223, 'lps'),
	(393757, 126, '2015-02-01 01:08:18.000000', 'consum', 0.0222, 'lps'),
	(393758, 126, '2015-02-01 01:08:19.000000', 'consum', 0.0215, 'lps'),
	(393759, 126, '2015-02-01 01:08:20.000000', 'consum', 0.0214, 'lps'),
	(393760, 126, '2015-02-01 01:08:21.000000', 'consum', 0.0217, 'lps'),
	(393761, 126, '2015-02-01 01:08:22.000000', 'consum', 0.0216, 'lps'),
	(393762, 126, '2015-02-01 01:08:23.000000', 'consum', 0.0223, 'lps'),
	(393763, 126, '2015-02-01 01:08:24.000000', 'consum', 0.0210, 'lps'),
	(393764, 126, '2015-02-01 01:08:25.000000', 'consum', 0.0217, 'lps'),
	(393765, 126, '2015-02-01 01:08:26.000000', 'consum', 0.0216, 'lps'),
	(393766, 126, '2015-02-01 01:08:27.000000', 'consum', 0.0218, 'lps'),
	(393767, 126, '2015-02-01 01:08:28.000000', 'consum', 0.0217, 'lps'),
	(393768, 126, '2015-02-01 01:08:29.000000', 'consum', 0.0222, 'lps'),
	(393769, 126, '2015-02-01 01:08:30.000000', 'consum', 0.0221, 'lps'),
	(393770, 126, '2015-02-01 01:08:31.000000', 'consum', 0.0216, 'lps'),
	(393771, 126, '2015-02-01 01:08:32.000000', 'consum', 0.0219, 'lps'),
	(393772, 126, '2015-02-01 01:08:33.000000', 'consum', 0.0210, 'lps'),
	(393773, 126, '2015-02-01 01:08:34.000000', 'consum', 0.0214, 'lps'),
	(393774, 126, '2015-02-01 01:08:35.000000', 'consum', 0.0214, 'lps'),
	(393775, 126, '2015-02-01 01:08:36.000000', 'consum', 0.0220, 'lps'),
	(393776, 126, '2015-02-01 01:08:37.000000', 'consum', 0.0219, 'lps'),
	(393777, 126, '2015-02-01 01:08:38.000000', 'consum', 0.0224, 'lps'),
	(393778, 126, '2015-02-01 01:08:39.000000', 'consum', 0.0210, 'lps'),
	(393779, 126, '2015-02-01 01:08:40.000000', 'consum', 0.0211, 'lps'),
	(393780, 126, '2015-02-01 01:08:41.000000', 'consum', 0.0216, 'lps'),
	(393781, 126, '2015-02-01 01:08:42.000000', 'consum', 0.0222, 'lps'),
	(393782, 126, '2015-02-01 01:08:43.000000', 'consum', 0.0210, 'lps'),
	(393783, 126, '2015-02-01 01:08:44.000000', 'consum', 0.0217, 'lps'),
	(393784, 126, '2015-02-01 01:08:45.000000', 'consum', 0.0217, 'lps'),
	(393785, 126, '2015-02-01 01:08:46.000000', 'consum', 0.0223, 'lps'),
	(393786, 126, '2015-02-01 01:08:47.000000', 'consum', 0.0210, 'lps'),
	(393787, 126, '2015-02-01 01:08:48.000000', 'consum', 0.0218, 'lps'),
	(393788, 126, '2015-02-01 01:08:49.000000', 'consum', 0.0220, 'lps'),
	(393789, 126, '2015-02-01 01:08:50.000000', 'consum', 0.0220, 'lps'),
	(393790, 126, '2015-02-01 01:08:51.000000', 'consum', 0.0217, 'lps'),
	(393791, 126, '2015-02-01 01:08:52.000000', 'consum', 0.0213, 'lps'),
	(393792, 126, '2015-02-01 01:08:53.000000', 'consum', 0.0221, 'lps'),
	(393793, 126, '2015-02-01 01:08:54.000000', 'consum', 0.0210, 'lps'),
	(393794, 126, '2015-02-01 01:08:55.000000', 'consum', 0.0222, 'lps'),
	(393795, 126, '2015-02-01 01:08:56.000000', 'consum', 0.0211, 'lps'),
	(393796, 126, '2015-02-01 01:08:57.000000', 'consum', 0.0210, 'lps'),
	(393797, 126, '2015-02-01 01:08:58.000000', 'consum', 0.0223, 'lps'),
	(393798, 126, '2015-02-01 01:08:59.000000', 'consum', 0.0215, 'lps'),
	(393799, 126, '2015-02-01 01:09:00.000000', 'consum', 0.0213, 'lps'),
	(393800, 126, '2015-02-01 01:09:01.000000', 'consum', 0.0223, 'lps'),
	(393801, 126, '2015-02-01 01:09:02.000000', 'consum', 0.0222, 'lps'),
	(393802, 126, '2015-02-01 01:09:03.000000', 'consum', 0.0218, 'lps'),
	(393803, 126, '2015-02-01 01:09:04.000000', 'consum', 0.0215, 'lps'),
	(393804, 126, '2015-02-01 01:09:05.000000', 'consum', 0.0212, 'lps'),
	(393805, 126, '2015-02-01 01:09:06.000000', 'consum', 0.0221, 'lps'),
	(393806, 126, '2015-02-01 01:09:07.000000', 'consum', 0.0213, 'lps'),
	(393807, 126, '2015-02-01 01:09:08.000000', 'consum', 0.0223, 'lps'),
	(393808, 126, '2015-02-01 01:09:09.000000', 'consum', 0.0219, 'lps'),
	(393809, 126, '2015-02-01 01:09:10.000000', 'consum', 0.0220, 'lps'),
	(393810, 126, '2015-02-01 01:09:11.000000', 'consum', 0.0216, 'lps'),
	(393811, 126, '2015-02-01 01:09:12.000000', 'consum', 0.0211, 'lps'),
	(393812, 126, '2015-02-01 01:09:13.000000', 'consum', 0.0213, 'lps'),
	(393813, 126, '2015-02-01 01:09:14.000000', 'consum', 0.0223, 'lps'),
	(393814, 126, '2015-02-01 01:09:15.000000', 'consum', 0.0221, 'lps'),
	(393815, 126, '2015-02-01 01:09:16.000000', 'consum', 0.0212, 'lps'),
	(393816, 126, '2015-02-01 01:09:17.000000', 'consum', 0.0218, 'lps'),
	(393817, 126, '2015-02-01 01:09:18.000000', 'consum', 0.0214, 'lps'),
	(393818, 126, '2015-02-01 01:09:19.000000', 'consum', 0.0221, 'lps'),
	(393819, 126, '2015-02-01 01:09:20.000000', 'consum', 0.0210, 'lps'),
	(393820, 126, '2015-02-01 01:09:21.000000', 'consum', 0.0222, 'lps'),
	(393821, 126, '2015-02-01 01:09:22.000000', 'consum', 0.0224, 'lps'),
	(393822, 126, '2015-02-01 01:09:23.000000', 'consum', 0.0216, 'lps'),
	(393823, 126, '2015-02-01 01:09:24.000000', 'consum', 0.0215, 'lps'),
	(393824, 126, '2015-02-01 01:09:25.000000', 'consum', 0.0216, 'lps'),
	(393825, 126, '2015-02-01 01:09:26.000000', 'consum', 0.0211, 'lps'),
	(393826, 126, '2015-02-01 01:09:27.000000', 'consum', 0.0211, 'lps'),
	(393827, 126, '2015-02-01 01:09:28.000000', 'consum', 0.0214, 'lps'),
	(393828, 126, '2015-02-01 01:09:29.000000', 'consum', 0.0210, 'lps'),
	(393829, 126, '2015-02-01 01:09:30.000000', 'consum', 0.0217, 'lps'),
	(393830, 126, '2015-02-01 01:09:31.000000', 'consum', 0.0212, 'lps'),
	(393831, 126, '2015-02-01 01:09:32.000000', 'consum', 0.0216, 'lps'),
	(393832, 126, '2015-02-01 01:09:33.000000', 'consum', 0.0218, 'lps'),
	(393833, 126, '2015-02-01 01:09:34.000000', 'consum', 0.0217, 'lps'),
	(393834, 126, '2015-02-01 01:09:35.000000', 'consum', 0.0224, 'lps'),
	(393835, 126, '2015-02-01 01:09:36.000000', 'consum', 0.0213, 'lps'),
	(393836, 126, '2015-02-01 01:09:37.000000', 'consum', 0.0213, 'lps'),
	(393837, 126, '2015-02-01 01:09:38.000000', 'consum', 0.0219, 'lps'),
	(393838, 126, '2015-02-01 01:09:39.000000', 'consum', 0.0213, 'lps'),
	(393839, 126, '2015-02-01 01:09:40.000000', 'consum', 0.0216, 'lps'),
	(393840, 126, '2015-02-01 01:09:41.000000', 'consum', 0.0215, 'lps'),
	(393841, 126, '2015-02-01 01:09:42.000000', 'consum', 0.0217, 'lps'),
	(393842, 126, '2015-02-01 01:09:43.000000', 'consum', 0.0215, 'lps'),
	(393843, 126, '2015-02-01 01:09:44.000000', 'consum', 0.0214, 'lps'),
	(393844, 126, '2015-02-01 01:09:45.000000', 'consum', 0.0219, 'lps'),
	(393845, 126, '2015-02-01 01:09:46.000000', 'consum', 0.0210, 'lps'),
	(393846, 126, '2015-02-01 01:09:47.000000', 'consum', 0.0213, 'lps'),
	(393847, 126, '2015-02-01 01:09:48.000000', 'consum', 0.0212, 'lps'),
	(393848, 126, '2015-02-01 01:09:49.000000', 'consum', 0.0210, 'lps'),
	(393849, 126, '2015-02-01 01:09:50.000000', 'consum', 0.0222, 'lps'),
	(393850, 126, '2015-02-01 01:09:51.000000', 'consum', 0.0210, 'lps'),
	(393851, 126, '2015-02-01 01:09:52.000000', 'consum', 0.0217, 'lps'),
	(393852, 126, '2015-02-01 01:09:53.000000', 'consum', 0.0219, 'lps'),
	(393853, 126, '2015-02-01 01:09:54.000000', 'consum', 0.0217, 'lps'),
	(393854, 126, '2015-02-01 01:09:55.000000', 'consum', 0.0220, 'lps'),
	(393855, 126, '2015-02-01 01:09:56.000000', 'consum', 0.0224, 'lps'),
	(393856, 126, '2015-02-01 01:09:57.000000', 'consum', 0.0221, 'lps'),
	(393857, 126, '2015-02-01 01:09:58.000000', 'consum', 0.0210, 'lps'),
	(393858, 126, '2015-02-01 01:09:59.000000', 'consum', 0.0220, 'lps'),
	(393859, 126, '2015-02-01 01:10:00.000000', 'consum', 0.0215, 'lps'),
	(393860, 126, '2015-02-01 01:10:01.000000', 'consum', 0.0223, 'lps'),
	(393861, 126, '2015-02-01 01:10:02.000000', 'consum', 0.0215, 'lps'),
	(393862, 126, '2015-02-01 01:10:03.000000', 'consum', 0.0211, 'lps'),
	(393863, 102, '2015-02-15 00:00:00.000000', 'consum', 0.0223, 'lps'),
	(393864, 102, '2015-02-15 00:00:01.000000', 'consum', 0.0221, 'lps'),
	(393865, 102, '2015-02-15 00:00:02.000000', 'consum', 0.0227, 'lps'),
	(393866, 102, '2015-02-15 00:00:03.000000', 'consum', 0.0223, 'lps'),
	(393867, 102, '2015-02-15 00:00:04.000000', 'consum', 0.0225, 'lps'),
	(393868, 102, '2015-02-15 00:00:05.000000', 'consum', 0.0228, 'lps'),
	(393869, 102, '2015-02-15 00:00:06.000000', 'consum', 0.0214, 'lps'),
	(393870, 102, '2015-02-15 00:00:07.000000', 'consum', 0.0215, 'lps'),
	(393871, 102, '2015-02-15 00:00:08.000000', 'consum', 0.0224, 'lps'),
	(393872, 102, '2015-02-15 00:00:09.000000', 'consum', 0.0227, 'lps'),
	(393873, 102, '2015-02-15 00:00:10.000000', 'consum', 0.0212, 'lps'),
	(393874, 102, '2015-02-15 00:00:11.000000', 'consum', 0.0211, 'lps'),
	(393875, 102, '2015-02-15 00:00:12.000000', 'consum', 0.0228, 'lps'),
	(393876, 102, '2015-02-15 00:00:13.000000', 'consum', 0.0217, 'lps'),
	(393877, 102, '2015-02-15 00:00:14.000000', 'consum', 0.0210, 'lps'),
	(393878, 102, '2015-02-15 00:00:15.000000', 'consum', 0.0212, 'lps'),
	(393879, 102, '2015-02-15 00:00:16.000000', 'consum', 0.0222, 'lps'),
	(393880, 102, '2015-02-15 00:00:17.000000', 'consum', 0.0222, 'lps'),
	(393881, 102, '2015-02-15 00:00:18.000000', 'consum', 0.0214, 'lps'),
	(393882, 102, '2015-02-15 00:00:19.000000', 'consum', 0.0214, 'lps'),
	(393883, 102, '2015-02-15 00:00:20.000000', 'consum', 0.0220, 'lps'),
	(393884, 102, '2015-02-15 00:00:21.000000', 'consum', 0.0228, 'lps'),
	(393885, 102, '2015-02-15 00:00:22.000000', 'consum', 0.0211, 'lps'),
	(393886, 102, '2015-02-15 00:00:23.000000', 'consum', 0.0221, 'lps'),
	(393887, 102, '2015-02-15 00:00:24.000000', 'consum', 0.0221, 'lps'),
	(393888, 102, '2015-02-15 00:00:25.000000', 'consum', 0.0212, 'lps'),
	(393889, 102, '2015-02-15 00:00:26.000000', 'consum', 0.0229, 'lps'),
	(393890, 102, '2015-02-15 00:00:27.000000', 'consum', 0.0217, 'lps'),
	(393891, 102, '2015-02-15 00:00:28.000000', 'consum', 0.0212, 'lps'),
	(393892, 102, '2015-02-15 00:00:29.000000', 'consum', 0.0216, 'lps'),
	(393893, 102, '2015-02-15 00:00:30.000000', 'consum', 0.0218, 'lps'),
	(393894, 102, '2015-02-15 00:00:31.000000', 'consum', 0.0212, 'lps'),
	(393895, 102, '2015-02-15 00:00:32.000000', 'consum', 0.0214, 'lps'),
	(393896, 102, '2015-02-15 00:00:33.000000', 'consum', 0.0226, 'lps'),
	(393897, 102, '2015-02-15 00:00:34.000000', 'consum', 0.0219, 'lps'),
	(393898, 102, '2015-02-15 00:00:35.000000', 'consum', 0.0226, 'lps'),
	(393899, 102, '2015-02-15 00:00:36.000000', 'consum', 0.0223, 'lps'),
	(393900, 102, '2015-02-15 00:00:37.000000', 'consum', 0.0227, 'lps'),
	(393901, 102, '2015-02-15 00:00:38.000000', 'consum', 0.0219, 'lps'),
	(393902, 102, '2015-02-15 00:00:39.000000', 'consum', 0.0225, 'lps'),
	(393903, 102, '2015-02-15 00:00:40.000000', 'consum', 0.0218, 'lps'),
	(393904, 102, '2015-02-15 00:00:41.000000', 'consum', 0.0226, 'lps'),
	(393905, 102, '2015-02-15 00:00:42.000000', 'consum', 0.0226, 'lps'),
	(393906, 102, '2015-02-15 00:00:43.000000', 'consum', 0.0221, 'lps'),
	(393907, 102, '2015-02-15 00:00:44.000000', 'consum', 0.0217, 'lps'),
	(393908, 102, '2015-02-15 00:00:45.000000', 'consum', 0.0214, 'lps'),
	(393909, 102, '2015-02-15 00:00:46.000000', 'consum', 0.0210, 'lps'),
	(393910, 102, '2015-02-15 00:00:47.000000', 'consum', 0.0219, 'lps'),
	(393911, 102, '2015-02-15 00:00:48.000000', 'consum', 0.0213, 'lps'),
	(393912, 102, '2015-02-15 00:00:49.000000', 'consum', 0.0219, 'lps'),
	(393913, 102, '2015-02-15 00:00:50.000000', 'consum', 0.0228, 'lps'),
	(393914, 102, '2015-02-15 00:00:51.000000', 'consum', 0.0215, 'lps'),
	(393915, 102, '2015-02-15 00:00:52.000000', 'consum', 0.0219, 'lps'),
	(393916, 102, '2015-02-15 00:00:53.000000', 'consum', 0.0221, 'lps'),
	(393917, 102, '2015-02-15 00:00:54.000000', 'consum', 0.0219, 'lps'),
	(393918, 102, '2015-02-15 00:00:55.000000', 'consum', 0.0223, 'lps'),
	(393919, 102, '2015-02-15 00:00:56.000000', 'consum', 0.0227, 'lps'),
	(393920, 102, '2015-02-15 00:00:57.000000', 'consum', 0.0215, 'lps'),
	(393921, 102, '2015-02-15 00:00:58.000000', 'consum', 0.0226, 'lps'),
	(393922, 102, '2015-02-15 00:00:59.000000', 'consum', 0.0217, 'lps'),
	(393923, 102, '2015-02-15 00:01:00.000000', 'consum', 0.0215, 'lps'),
	(393924, 102, '2015-02-15 00:01:01.000000', 'consum', 0.0215, 'lps'),
	(393925, 102, '2015-02-15 00:01:02.000000', 'consum', 0.0220, 'lps'),
	(393926, 102, '2015-02-15 00:01:03.000000', 'consum', 0.0227, 'lps'),
	(393927, 102, '2015-02-15 00:01:04.000000', 'consum', 0.0225, 'lps'),
	(393928, 102, '2015-02-15 00:01:05.000000', 'consum', 0.0216, 'lps'),
	(393929, 102, '2015-02-15 00:01:06.000000', 'consum', 0.0214, 'lps'),
	(393930, 102, '2015-02-15 00:01:07.000000', 'consum', 0.0213, 'lps'),
	(393931, 102, '2015-02-15 00:01:08.000000', 'consum', 0.0211, 'lps'),
	(393932, 102, '2015-02-15 00:01:09.000000', 'consum', 0.0210, 'lps'),
	(393933, 102, '2015-02-15 00:01:10.000000', 'consum', 0.0226, 'lps'),
	(393934, 102, '2015-02-15 00:01:11.000000', 'consum', 0.0229, 'lps'),
	(393935, 102, '2015-02-15 00:01:12.000000', 'consum', 0.0218, 'lps'),
	(393936, 102, '2015-02-15 00:01:13.000000', 'consum', 0.0213, 'lps'),
	(393937, 102, '2015-02-15 00:01:14.000000', 'consum', 0.0221, 'lps'),
	(393938, 102, '2015-02-15 00:01:15.000000', 'consum', 0.0219, 'lps'),
	(393939, 102, '2015-02-15 00:01:16.000000', 'consum', 0.0222, 'lps'),
	(393940, 102, '2015-02-15 00:01:17.000000', 'consum', 0.0225, 'lps'),
	(393941, 102, '2015-02-15 00:01:18.000000', 'consum', 0.0227, 'lps'),
	(393942, 102, '2015-02-15 00:01:19.000000', 'consum', 0.0210, 'lps'),
	(393943, 102, '2015-02-15 00:01:20.000000', 'consum', 0.0222, 'lps'),
	(393944, 102, '2015-02-15 00:01:21.000000', 'consum', 0.0229, 'lps'),
	(393945, 102, '2015-02-15 00:01:22.000000', 'consum', 0.0211, 'lps'),
	(393946, 102, '2015-02-15 00:01:23.000000', 'consum', 0.0220, 'lps'),
	(393947, 102, '2015-02-15 00:01:24.000000', 'consum', 0.0215, 'lps'),
	(393948, 102, '2015-02-15 00:01:25.000000', 'consum', 0.0226, 'lps'),
	(393949, 102, '2015-02-15 00:01:26.000000', 'consum', 0.0215, 'lps'),
	(393950, 102, '2015-02-15 00:01:27.000000', 'consum', 0.0228, 'lps'),
	(393951, 102, '2015-02-15 00:01:28.000000', 'consum', 0.0227, 'lps'),
	(393952, 102, '2015-02-15 00:01:29.000000', 'consum', 0.0219, 'lps'),
	(393953, 102, '2015-02-15 00:01:30.000000', 'consum', 0.0227, 'lps'),
	(393954, 102, '2015-02-15 00:01:31.000000', 'consum', 0.0226, 'lps'),
	(393955, 102, '2015-02-15 00:01:32.000000', 'consum', 0.0219, 'lps'),
	(393956, 102, '2015-02-15 00:01:33.000000', 'consum', 0.0227, 'lps'),
	(393957, 102, '2015-02-15 00:01:34.000000', 'consum', 0.0229, 'lps'),
	(393958, 102, '2015-02-15 00:01:35.000000', 'consum', 0.0214, 'lps'),
	(393959, 102, '2015-02-15 00:01:36.000000', 'consum', 0.0214, 'lps'),
	(393960, 102, '2015-02-15 00:01:37.000000', 'consum', 0.0218, 'lps'),
	(393961, 102, '2015-02-15 00:01:38.000000', 'consum', 0.0220, 'lps'),
	(393962, 102, '2015-02-15 00:01:39.000000', 'consum', 0.0215, 'lps'),
	(393963, 102, '2015-02-15 00:01:40.000000', 'consum', 0.0226, 'lps'),
	(393964, 102, '2015-02-15 00:01:41.000000', 'consum', 0.0216, 'lps'),
	(393965, 102, '2015-02-15 00:01:42.000000', 'consum', 0.0211, 'lps'),
	(393966, 102, '2015-02-15 00:01:43.000000', 'consum', 0.0220, 'lps'),
	(393967, 102, '2015-02-15 00:01:44.000000', 'consum', 0.0216, 'lps'),
	(393968, 102, '2015-02-15 00:01:45.000000', 'consum', 0.0210, 'lps'),
	(393969, 102, '2015-02-15 00:01:46.000000', 'consum', 0.0214, 'lps'),
	(393970, 102, '2015-02-15 00:01:47.000000', 'consum', 0.0211, 'lps'),
	(393971, 102, '2015-02-15 00:01:48.000000', 'consum', 0.0221, 'lps'),
	(393972, 102, '2015-02-15 00:01:49.000000', 'consum', 0.0224, 'lps'),
	(393973, 102, '2015-02-15 00:01:50.000000', 'consum', 0.0228, 'lps'),
	(393974, 102, '2015-02-15 00:01:51.000000', 'consum', 0.0218, 'lps'),
	(393975, 102, '2015-02-15 00:01:52.000000', 'consum', 0.0216, 'lps'),
	(393976, 102, '2015-02-15 00:01:53.000000', 'consum', 0.0217, 'lps'),
	(393977, 102, '2015-02-15 00:01:54.000000', 'consum', 0.0227, 'lps'),
	(393978, 102, '2015-02-15 00:01:55.000000', 'consum', 0.0214, 'lps'),
	(393979, 102, '2015-02-15 00:01:56.000000', 'consum', 0.0218, 'lps'),
	(393980, 102, '2015-02-15 00:01:57.000000', 'consum', 0.0222, 'lps'),
	(393981, 102, '2015-02-15 00:01:58.000000', 'consum', 0.0223, 'lps'),
	(393982, 102, '2015-02-15 00:01:59.000000', 'consum', 0.0221, 'lps'),
	(393983, 102, '2015-02-15 00:02:00.000000', 'consum', 0.0227, 'lps'),
	(393984, 102, '2015-02-15 00:02:01.000000', 'consum', 0.0222, 'lps'),
	(393985, 102, '2015-02-15 00:02:02.000000', 'consum', 0.0221, 'lps'),
	(393986, 102, '2015-02-15 00:02:03.000000', 'consum', 0.0227, 'lps'),
	(393987, 102, '2015-02-15 00:02:04.000000', 'consum', 0.0223, 'lps'),
	(393988, 102, '2015-02-15 00:02:05.000000', 'consum', 0.0226, 'lps'),
	(393989, 102, '2015-02-15 00:02:06.000000', 'consum', 0.0229, 'lps'),
	(393990, 102, '2015-02-15 00:02:07.000000', 'consum', 0.0219, 'lps'),
	(393991, 102, '2015-02-15 00:02:08.000000', 'consum', 0.0219, 'lps'),
	(393992, 102, '2015-02-15 00:02:09.000000', 'consum', 0.0227, 'lps'),
	(393993, 102, '2015-02-15 00:02:10.000000', 'consum', 0.0227, 'lps'),
	(393994, 102, '2015-02-15 00:02:11.000000', 'consum', 0.0228, 'lps'),
	(393995, 102, '2015-02-15 00:02:12.000000', 'consum', 0.0228, 'lps'),
	(393996, 102, '2015-02-15 00:02:13.000000', 'consum', 0.0229, 'lps'),
	(393997, 102, '2015-02-15 00:02:14.000000', 'consum', 0.0228, 'lps'),
	(393998, 102, '2015-02-15 00:02:15.000000', 'consum', 0.0225, 'lps'),
	(393999, 102, '2015-02-15 00:02:16.000000', 'consum', 0.0212, 'lps'),
	(394000, 102, '2015-02-15 00:02:17.000000', 'consum', 0.0217, 'lps'),
	(394001, 102, '2015-02-15 00:02:18.000000', 'consum', 0.0218, 'lps'),
	(394002, 102, '2015-02-15 00:02:19.000000', 'consum', 0.0229, 'lps'),
	(394003, 102, '2015-02-15 00:02:20.000000', 'consum', 0.0224, 'lps'),
	(394004, 102, '2015-02-15 00:02:21.000000', 'consum', 0.0221, 'lps'),
	(394005, 102, '2015-02-15 00:02:22.000000', 'consum', 0.0223, 'lps'),
	(394006, 102, '2015-02-15 00:02:23.000000', 'consum', 0.0223, 'lps'),
	(394007, 102, '2015-02-15 00:02:24.000000', 'consum', 0.0217, 'lps'),
	(394008, 102, '2015-02-15 00:02:25.000000', 'consum', 0.0226, 'lps'),
	(394009, 102, '2015-02-15 00:02:26.000000', 'consum', 0.0229, 'lps'),
	(394010, 102, '2015-02-15 00:02:27.000000', 'consum', 0.0216, 'lps'),
	(394011, 102, '2015-02-15 00:02:28.000000', 'consum', 0.0225, 'lps'),
	(394012, 102, '2015-02-15 00:02:29.000000', 'consum', 0.0227, 'lps'),
	(394013, 102, '2015-02-15 00:02:30.000000', 'consum', 0.0229, 'lps'),
	(394014, 102, '2015-02-15 00:02:31.000000', 'consum', 0.0217, 'lps'),
	(394015, 102, '2015-02-15 00:02:32.000000', 'consum', 0.0210, 'lps'),
	(394016, 102, '2015-02-15 00:02:33.000000', 'consum', 0.0226, 'lps'),
	(394017, 102, '2015-02-15 00:02:34.000000', 'consum', 0.0211, 'lps'),
	(394018, 102, '2015-02-15 00:02:35.000000', 'consum', 0.0229, 'lps'),
	(394019, 102, '2015-02-15 00:02:36.000000', 'consum', 0.0222, 'lps'),
	(394020, 102, '2015-02-15 00:02:37.000000', 'consum', 0.0215, 'lps'),
	(394021, 102, '2015-02-15 00:02:38.000000', 'consum', 0.0217, 'lps'),
	(394022, 102, '2015-02-15 00:02:39.000000', 'consum', 0.0213, 'lps'),
	(394023, 102, '2015-02-15 00:02:40.000000', 'consum', 0.0224, 'lps'),
	(394024, 102, '2015-02-15 00:02:41.000000', 'consum', 0.0212, 'lps'),
	(394025, 102, '2015-02-15 00:02:42.000000', 'consum', 0.0217, 'lps'),
	(394026, 102, '2015-02-15 00:02:43.000000', 'consum', 0.0218, 'lps'),
	(394027, 102, '2015-02-15 00:02:44.000000', 'consum', 0.0211, 'lps'),
	(394028, 102, '2015-02-15 00:02:45.000000', 'consum', 0.0213, 'lps'),
	(394029, 102, '2015-02-15 00:02:46.000000', 'consum', 0.0220, 'lps'),
	(394030, 102, '2015-02-15 00:02:47.000000', 'consum', 0.0210, 'lps'),
	(394031, 102, '2015-02-15 00:02:48.000000', 'consum', 0.0224, 'lps'),
	(394032, 102, '2015-02-15 00:02:49.000000', 'consum', 0.0220, 'lps'),
	(394033, 102, '2015-02-15 00:02:50.000000', 'consum', 0.0218, 'lps'),
	(394034, 102, '2015-02-15 00:02:51.000000', 'consum', 0.0218, 'lps'),
	(394035, 102, '2015-02-15 00:02:52.000000', 'consum', 0.0210, 'lps'),
	(394036, 102, '2015-02-15 00:02:53.000000', 'consum', 0.0226, 'lps'),
	(394037, 102, '2015-02-15 00:02:54.000000', 'consum', 0.0211, 'lps'),
	(394038, 102, '2015-02-15 00:02:55.000000', 'consum', 0.0228, 'lps'),
	(394039, 102, '2015-02-15 00:02:56.000000', 'consum', 0.0215, 'lps'),
	(394040, 102, '2015-02-15 00:02:57.000000', 'consum', 0.0222, 'lps'),
	(394041, 102, '2015-02-15 00:02:58.000000', 'consum', 0.0216, 'lps'),
	(394042, 102, '2015-02-15 00:02:59.000000', 'consum', 0.0223, 'lps'),
	(394043, 102, '2015-02-15 00:03:00.000000', 'consum', 0.0217, 'lps'),
	(394044, 102, '2015-02-15 00:03:01.000000', 'consum', 0.0229, 'lps'),
	(394045, 102, '2015-02-15 00:03:02.000000', 'consum', 0.0224, 'lps'),
	(394046, 102, '2015-02-15 00:03:03.000000', 'consum', 0.0222, 'lps'),
	(394047, 102, '2015-02-15 00:03:04.000000', 'consum', 0.0228, 'lps'),
	(394048, 102, '2015-02-15 00:03:05.000000', 'consum', 0.0226, 'lps'),
	(394049, 102, '2015-02-15 00:03:06.000000', 'consum', 0.0215, 'lps'),
	(394050, 102, '2015-02-15 00:03:07.000000', 'consum', 0.0227, 'lps'),
	(394051, 102, '2015-02-15 00:03:08.000000', 'consum', 0.0220, 'lps'),
	(394052, 102, '2015-02-15 00:03:09.000000', 'consum', 0.0229, 'lps'),
	(394053, 102, '2015-02-15 00:03:10.000000', 'consum', 0.0216, 'lps'),
	(394054, 102, '2015-02-15 00:03:11.000000', 'consum', 0.0223, 'lps'),
	(394055, 102, '2015-02-15 00:03:12.000000', 'consum', 0.0216, 'lps'),
	(394056, 102, '2015-02-15 00:03:13.000000', 'consum', 0.0225, 'lps'),
	(394057, 102, '2015-02-15 00:03:14.000000', 'consum', 0.0226, 'lps'),
	(394058, 102, '2015-02-15 00:03:15.000000', 'consum', 0.0227, 'lps'),
	(394059, 102, '2015-02-15 00:03:16.000000', 'consum', 0.0226, 'lps'),
	(394060, 102, '2015-02-15 00:03:17.000000', 'consum', 0.0220, 'lps'),
	(394061, 102, '2015-02-15 00:03:18.000000', 'consum', 0.0212, 'lps'),
	(394062, 102, '2015-02-15 00:03:19.000000', 'consum', 0.0211, 'lps'),
	(394063, 102, '2015-02-15 00:03:20.000000', 'consum', 0.0211, 'lps'),
	(394064, 102, '2015-02-15 00:03:21.000000', 'consum', 0.0211, 'lps'),
	(394065, 102, '2015-02-15 00:03:22.000000', 'consum', 0.0213, 'lps'),
	(394066, 102, '2015-02-15 00:03:23.000000', 'consum', 0.0221, 'lps'),
	(394067, 102, '2015-02-15 00:03:24.000000', 'consum', 0.0218, 'lps'),
	(394068, 102, '2015-02-15 00:03:25.000000', 'consum', 0.0215, 'lps'),
	(394069, 102, '2015-02-15 00:03:26.000000', 'consum', 0.0215, 'lps'),
	(394070, 102, '2015-02-15 00:03:27.000000', 'consum', 0.0219, 'lps'),
	(394071, 102, '2015-02-15 00:03:28.000000', 'consum', 0.0222, 'lps'),
	(394072, 102, '2015-02-15 00:03:29.000000', 'consum', 0.0220, 'lps'),
	(394073, 102, '2015-02-15 00:03:30.000000', 'consum', 0.0228, 'lps'),
	(394074, 102, '2015-02-15 00:03:31.000000', 'consum', 0.0211, 'lps'),
	(394075, 102, '2015-02-15 00:03:32.000000', 'consum', 0.0219, 'lps'),
	(394076, 102, '2015-02-15 00:03:33.000000', 'consum', 0.0214, 'lps'),
	(394077, 102, '2015-02-15 00:03:34.000000', 'consum', 0.0224, 'lps'),
	(394078, 102, '2015-02-15 00:03:35.000000', 'consum', 0.0227, 'lps'),
	(394079, 102, '2015-02-15 00:03:36.000000', 'consum', 0.0215, 'lps'),
	(394080, 102, '2015-02-15 00:03:37.000000', 'consum', 0.0222, 'lps'),
	(394081, 102, '2015-02-15 00:03:38.000000', 'consum', 0.0218, 'lps'),
	(394082, 102, '2015-02-15 00:03:39.000000', 'consum', 0.0213, 'lps'),
	(394083, 102, '2015-02-15 00:03:40.000000', 'consum', 0.0221, 'lps'),
	(394084, 102, '2015-02-15 00:03:41.000000', 'consum', 0.0215, 'lps'),
	(394085, 102, '2015-02-15 00:03:42.000000', 'consum', 0.0226, 'lps'),
	(394086, 102, '2015-02-15 00:03:43.000000', 'consum', 0.0214, 'lps'),
	(394087, 102, '2015-02-15 00:03:44.000000', 'consum', 0.0221, 'lps'),
	(394088, 102, '2015-02-15 00:03:45.000000', 'consum', 0.0215, 'lps'),
	(394089, 102, '2015-02-15 00:03:46.000000', 'consum', 0.0220, 'lps'),
	(394090, 102, '2015-02-15 00:03:47.000000', 'consum', 0.0229, 'lps'),
	(394091, 102, '2015-02-15 00:03:48.000000', 'consum', 0.0212, 'lps'),
	(394092, 102, '2015-02-15 00:03:49.000000', 'consum', 0.0227, 'lps'),
	(394093, 102, '2015-02-15 00:03:50.000000', 'consum', 0.0226, 'lps'),
	(394094, 102, '2015-02-15 00:03:51.000000', 'consum', 0.0222, 'lps'),
	(394095, 102, '2015-02-15 00:03:52.000000', 'consum', 0.0220, 'lps'),
	(394096, 102, '2015-02-15 00:03:53.000000', 'consum', 0.0228, 'lps'),
	(394097, 102, '2015-02-15 00:03:54.000000', 'consum', 0.0227, 'lps'),
	(394098, 102, '2015-02-15 00:03:55.000000', 'consum', 0.0224, 'lps'),
	(394099, 102, '2015-02-15 00:03:56.000000', 'consum', 0.0229, 'lps'),
	(394100, 102, '2015-02-15 00:03:57.000000', 'consum', 0.0224, 'lps'),
	(394101, 102, '2015-02-15 00:03:58.000000', 'consum', 0.0223, 'lps'),
	(394102, 102, '2015-02-15 00:03:59.000000', 'consum', 0.0212, 'lps'),
	(394103, 102, '2015-02-15 00:04:00.000000', 'consum', 0.0221, 'lps'),
	(394104, 102, '2015-02-15 00:04:01.000000', 'consum', 0.0222, 'lps'),
	(394105, 102, '2015-02-15 00:04:02.000000', 'consum', 0.0214, 'lps'),
	(394106, 102, '2015-02-15 00:04:03.000000', 'consum', 0.0218, 'lps'),
	(394107, 102, '2015-02-15 00:04:04.000000', 'consum', 0.0218, 'lps'),
	(394108, 102, '2015-02-15 00:04:05.000000', 'consum', 0.0225, 'lps'),
	(394109, 102, '2015-02-15 00:04:06.000000', 'consum', 0.0220, 'lps'),
	(394110, 102, '2015-02-15 00:04:07.000000', 'consum', 0.0219, 'lps'),
	(394111, 102, '2015-02-15 00:04:08.000000', 'consum', 0.0223, 'lps'),
	(394112, 102, '2015-02-15 00:04:09.000000', 'consum', 0.0210, 'lps'),
	(394113, 102, '2015-02-15 00:04:10.000000', 'consum', 0.0213, 'lps'),
	(394114, 102, '2015-02-15 00:04:11.000000', 'consum', 0.0224, 'lps'),
	(394115, 102, '2015-02-15 00:04:12.000000', 'consum', 0.0212, 'lps'),
	(394116, 102, '2015-02-15 00:04:13.000000', 'consum', 0.0216, 'lps'),
	(394117, 102, '2015-02-15 00:04:14.000000', 'consum', 0.0217, 'lps'),
	(394118, 102, '2015-02-15 00:04:15.000000', 'consum', 0.0226, 'lps'),
	(394119, 102, '2015-02-15 00:04:16.000000', 'consum', 0.0212, 'lps'),
	(394120, 102, '2015-02-15 00:04:17.000000', 'consum', 0.0212, 'lps'),
	(394121, 102, '2015-02-15 00:04:18.000000', 'consum', 0.0213, 'lps'),
	(394122, 102, '2015-02-15 00:04:19.000000', 'consum', 0.0221, 'lps'),
	(394123, 102, '2015-02-15 00:04:20.000000', 'consum', 0.0214, 'lps'),
	(394124, 102, '2015-02-15 00:04:21.000000', 'consum', 0.0219, 'lps'),
	(394125, 102, '2015-02-15 00:04:22.000000', 'consum', 0.0223, 'lps'),
	(394126, 102, '2015-02-15 00:04:23.000000', 'consum', 0.0229, 'lps'),
	(394127, 102, '2015-02-15 00:04:24.000000', 'consum', 0.0228, 'lps'),
	(394128, 102, '2015-02-15 00:04:25.000000', 'consum', 0.0221, 'lps'),
	(394129, 102, '2015-02-15 00:04:26.000000', 'consum', 0.0215, 'lps'),
	(394130, 102, '2015-02-15 00:04:27.000000', 'consum', 0.0219, 'lps'),
	(394131, 102, '2015-02-15 00:04:28.000000', 'consum', 0.0221, 'lps'),
	(394132, 102, '2015-02-15 00:04:29.000000', 'consum', 0.0219, 'lps'),
	(394133, 102, '2015-02-15 00:04:30.000000', 'consum', 0.0222, 'lps'),
	(394134, 102, '2015-02-15 00:04:31.000000', 'consum', 0.0226, 'lps'),
	(394135, 102, '2015-02-15 00:04:32.000000', 'consum', 0.0213, 'lps'),
	(394136, 102, '2015-02-15 00:04:33.000000', 'consum', 0.0216, 'lps'),
	(394137, 102, '2015-02-15 00:04:34.000000', 'consum', 0.0211, 'lps'),
	(394138, 102, '2015-02-15 00:04:35.000000', 'consum', 0.0217, 'lps'),
	(394139, 102, '2015-02-15 00:04:36.000000', 'consum', 0.0224, 'lps'),
	(394140, 102, '2015-02-15 00:04:37.000000', 'consum', 0.0218, 'lps'),
	(394141, 102, '2015-02-15 00:04:38.000000', 'consum', 0.0211, 'lps'),
	(394142, 102, '2015-02-15 00:04:39.000000', 'consum', 0.0229, 'lps'),
	(394143, 102, '2015-02-15 00:04:40.000000', 'consum', 0.0223, 'lps'),
	(394144, 102, '2015-02-15 00:04:41.000000', 'consum', 0.0217, 'lps'),
	(394145, 102, '2015-02-15 00:04:42.000000', 'consum', 0.0228, 'lps'),
	(394146, 102, '2015-02-15 00:04:43.000000', 'consum', 0.0218, 'lps'),
	(394147, 102, '2015-02-15 00:04:44.000000', 'consum', 0.0218, 'lps'),
	(394148, 102, '2015-02-15 00:04:45.000000', 'consum', 0.0224, 'lps'),
	(394149, 102, '2015-02-15 00:04:46.000000', 'consum', 0.0219, 'lps'),
	(394150, 102, '2015-02-15 00:04:47.000000', 'consum', 0.0213, 'lps'),
	(394151, 102, '2015-02-15 00:04:48.000000', 'consum', 0.0220, 'lps'),
	(394152, 102, '2015-02-15 00:04:49.000000', 'consum', 0.0229, 'lps'),
	(394153, 102, '2015-02-15 00:04:50.000000', 'consum', 0.0217, 'lps'),
	(394154, 102, '2015-02-15 00:04:51.000000', 'consum', 0.0226, 'lps'),
	(394155, 102, '2015-02-15 00:04:52.000000', 'consum', 0.0212, 'lps'),
	(394156, 102, '2015-02-15 00:04:53.000000', 'consum', 0.0212, 'lps'),
	(394157, 102, '2015-02-15 00:04:54.000000', 'consum', 0.0215, 'lps'),
	(394158, 102, '2015-02-15 00:04:55.000000', 'consum', 0.0229, 'lps'),
	(394159, 102, '2015-02-15 00:04:56.000000', 'consum', 0.0229, 'lps'),
	(394160, 102, '2015-02-15 00:04:57.000000', 'consum', 0.0228, 'lps'),
	(394161, 102, '2015-02-15 00:04:58.000000', 'consum', 0.0223, 'lps'),
	(394162, 102, '2015-02-15 00:04:59.000000', 'consum', 0.0224, 'lps'),
	(394163, 102, '2015-02-15 00:05:00.000000', 'consum', 0.0222, 'lps'),
	(394164, 102, '2015-02-15 00:05:01.000000', 'consum', 0.0229, 'lps'),
	(394165, 102, '2015-02-15 00:05:02.000000', 'consum', 0.0228, 'lps'),
	(394166, 102, '2015-02-15 00:05:03.000000', 'consum', 0.0223, 'lps'),
	(394167, 102, '2015-02-15 00:05:04.000000', 'consum', 0.0222, 'lps'),
	(394168, 102, '2015-02-15 00:05:05.000000', 'consum', 0.0213, 'lps'),
	(394169, 102, '2015-02-15 00:05:06.000000', 'consum', 0.0226, 'lps'),
	(394170, 102, '2015-02-15 00:05:07.000000', 'consum', 0.0225, 'lps'),
	(394171, 102, '2015-02-15 00:05:08.000000', 'consum', 0.0217, 'lps'),
	(394172, 102, '2015-02-15 00:05:09.000000', 'consum', 0.0222, 'lps'),
	(394173, 102, '2015-02-15 00:05:10.000000', 'consum', 0.0228, 'lps'),
	(394174, 102, '2015-02-15 00:05:11.000000', 'consum', 0.0224, 'lps'),
	(394175, 102, '2015-02-15 00:05:12.000000', 'consum', 0.0226, 'lps'),
	(394176, 102, '2015-02-15 00:05:13.000000', 'consum', 0.0229, 'lps'),
	(394177, 102, '2015-02-15 00:05:14.000000', 'consum', 0.0217, 'lps'),
	(394178, 102, '2015-02-15 00:05:15.000000', 'consum', 0.0227, 'lps'),
	(394179, 102, '2015-02-15 00:05:16.000000', 'consum', 0.0216, 'lps'),
	(394180, 102, '2015-02-15 00:05:17.000000', 'consum', 0.0210, 'lps'),
	(394181, 102, '2015-02-15 00:05:18.000000', 'consum', 0.0211, 'lps'),
	(394182, 102, '2015-02-15 00:05:19.000000', 'consum', 0.0215, 'lps'),
	(394183, 102, '2015-02-15 00:05:20.000000', 'consum', 0.0215, 'lps'),
	(394184, 102, '2015-02-15 00:05:21.000000', 'consum', 0.0219, 'lps'),
	(394185, 102, '2015-02-15 00:05:22.000000', 'consum', 0.0220, 'lps'),
	(394186, 102, '2015-02-15 00:05:23.000000', 'consum', 0.0213, 'lps'),
	(394187, 102, '2015-02-15 00:05:24.000000', 'consum', 0.0217, 'lps'),
	(394188, 102, '2015-02-15 00:05:25.000000', 'consum', 0.0216, 'lps'),
	(394189, 102, '2015-02-15 00:05:26.000000', 'consum', 0.0220, 'lps'),
	(394190, 102, '2015-02-15 00:05:27.000000', 'consum', 0.0224, 'lps'),
	(394191, 102, '2015-02-15 00:05:28.000000', 'consum', 0.0228, 'lps'),
	(394192, 102, '2015-02-15 00:05:29.000000', 'consum', 0.0220, 'lps'),
	(394193, 102, '2015-02-15 00:05:30.000000', 'consum', 0.0227, 'lps'),
	(394194, 102, '2015-02-15 00:05:31.000000', 'consum', 0.0226, 'lps'),
	(394195, 102, '2015-02-15 00:05:32.000000', 'consum', 0.0217, 'lps'),
	(394196, 102, '2015-02-15 00:05:33.000000', 'consum', 0.0217, 'lps'),
	(394197, 102, '2015-02-15 00:05:34.000000', 'consum', 0.0227, 'lps'),
	(394198, 102, '2015-02-15 00:05:35.000000', 'consum', 0.0212, 'lps'),
	(394199, 102, '2015-02-15 00:05:36.000000', 'consum', 0.0210, 'lps'),
	(394200, 102, '2015-02-15 00:05:37.000000', 'consum', 0.0226, 'lps'),
	(394201, 102, '2015-02-15 00:05:38.000000', 'consum', 0.0228, 'lps'),
	(394202, 102, '2015-02-15 00:05:39.000000', 'consum', 0.0216, 'lps'),
	(394203, 102, '2015-02-15 00:05:40.000000', 'consum', 0.0223, 'lps'),
	(394204, 102, '2015-02-15 00:05:41.000000', 'consum', 0.0219, 'lps'),
	(394205, 102, '2015-02-15 00:05:42.000000', 'consum', 0.0218, 'lps'),
	(394206, 102, '2015-02-15 00:05:43.000000', 'consum', 0.0223, 'lps'),
	(394207, 102, '2015-02-15 00:05:44.000000', 'consum', 0.0212, 'lps'),
	(394208, 102, '2015-02-15 00:05:45.000000', 'consum', 0.0219, 'lps'),
	(394209, 102, '2015-02-15 00:05:46.000000', 'consum', 0.0212, 'lps'),
	(394210, 102, '2015-02-15 00:05:47.000000', 'consum', 0.0215, 'lps'),
	(394211, 102, '2015-02-15 00:05:48.000000', 'consum', 0.0227, 'lps'),
	(394212, 102, '2015-02-15 00:05:49.000000', 'consum', 0.0221, 'lps'),
	(394213, 102, '2015-02-15 00:05:50.000000', 'consum', 0.0213, 'lps'),
	(394214, 102, '2015-02-15 00:05:51.000000', 'consum', 0.0213, 'lps'),
	(394215, 102, '2015-02-15 00:05:52.000000', 'consum', 0.0215, 'lps'),
	(394216, 102, '2015-02-15 00:05:53.000000', 'consum', 0.0228, 'lps'),
	(394217, 102, '2015-02-15 00:05:54.000000', 'consum', 0.0226, 'lps'),
	(394218, 102, '2015-02-15 00:05:55.000000', 'consum', 0.0218, 'lps'),
	(394219, 102, '2015-02-15 00:05:56.000000', 'consum', 0.0221, 'lps'),
	(394220, 102, '2015-02-15 00:05:57.000000', 'consum', 0.0220, 'lps'),
	(394221, 102, '2015-02-15 00:05:58.000000', 'consum', 0.0228, 'lps'),
	(394222, 102, '2015-02-15 00:05:59.000000', 'consum', 0.0210, 'lps'),
	(394223, 102, '2015-02-15 00:06:00.000000', 'consum', 0.0217, 'lps'),
	(394224, 102, '2015-02-15 00:06:01.000000', 'consum', 0.0225, 'lps'),
	(394225, 102, '2015-02-15 00:06:02.000000', 'consum', 0.0227, 'lps'),
	(394226, 102, '2015-02-15 00:06:03.000000', 'consum', 0.0228, 'lps'),
	(394227, 102, '2015-02-15 00:06:04.000000', 'consum', 0.0229, 'lps'),
	(394228, 102, '2015-02-15 00:06:05.000000', 'consum', 0.0214, 'lps'),
	(394229, 102, '2015-02-15 00:06:06.000000', 'consum', 0.0214, 'lps'),
	(394230, 102, '2015-02-15 00:06:07.000000', 'consum', 0.0216, 'lps'),
	(394231, 102, '2015-02-15 00:06:08.000000', 'consum', 0.0229, 'lps'),
	(394232, 102, '2015-02-15 00:06:09.000000', 'consum', 0.0229, 'lps'),
	(394233, 102, '2015-02-15 00:06:10.000000', 'consum', 0.0226, 'lps'),
	(394234, 102, '2015-02-15 00:06:11.000000', 'consum', 0.0214, 'lps'),
	(394235, 102, '2015-02-15 00:06:12.000000', 'consum', 0.0222, 'lps'),
	(394236, 102, '2015-02-15 00:06:13.000000', 'consum', 0.0219, 'lps'),
	(394237, 102, '2015-02-15 00:06:14.000000', 'consum', 0.0221, 'lps'),
	(394238, 102, '2015-02-15 00:06:15.000000', 'consum', 0.0216, 'lps'),
	(394239, 102, '2015-02-15 00:06:16.000000', 'consum', 0.0227, 'lps'),
	(394240, 102, '2015-02-15 00:06:17.000000', 'consum', 0.0219, 'lps'),
	(394241, 102, '2015-02-15 00:06:18.000000', 'consum', 0.0226, 'lps'),
	(394242, 102, '2015-02-15 00:06:19.000000', 'consum', 0.0222, 'lps'),
	(394243, 102, '2015-02-15 00:06:20.000000', 'consum', 0.0224, 'lps'),
	(394244, 102, '2015-02-15 00:06:21.000000', 'consum', 0.0223, 'lps'),
	(394245, 102, '2015-02-15 00:06:22.000000', 'consum', 0.0216, 'lps'),
	(394246, 102, '2015-02-15 00:06:23.000000', 'consum', 0.0219, 'lps'),
	(394247, 102, '2015-02-15 00:06:24.000000', 'consum', 0.0218, 'lps'),
	(394248, 102, '2015-02-15 00:06:25.000000', 'consum', 0.0224, 'lps'),
	(394249, 102, '2015-02-15 00:06:26.000000', 'consum', 0.0218, 'lps'),
	(394250, 102, '2015-02-15 00:06:27.000000', 'consum', 0.0226, 'lps'),
	(394251, 102, '2015-02-15 00:06:28.000000', 'consum', 0.0227, 'lps'),
	(394252, 102, '2015-02-15 00:06:29.000000', 'consum', 0.0210, 'lps'),
	(394253, 102, '2015-02-15 00:06:30.000000', 'consum', 0.0217, 'lps'),
	(394254, 102, '2015-02-15 00:06:31.000000', 'consum', 0.0228, 'lps'),
	(394255, 102, '2015-02-15 00:06:32.000000', 'consum', 0.0220, 'lps'),
	(394256, 102, '2015-02-15 00:06:33.000000', 'consum', 0.0223, 'lps'),
	(394257, 102, '2015-02-15 00:06:34.000000', 'consum', 0.0228, 'lps'),
	(394258, 102, '2015-02-15 00:06:35.000000', 'consum', 0.0219, 'lps'),
	(394259, 102, '2015-02-15 00:06:36.000000', 'consum', 0.0224, 'lps'),
	(394260, 102, '2015-02-15 00:06:37.000000', 'consum', 0.0213, 'lps'),
	(394261, 102, '2015-02-15 00:06:38.000000', 'consum', 0.0221, 'lps'),
	(394262, 102, '2015-02-15 00:06:39.000000', 'consum', 0.0220, 'lps'),
	(394263, 102, '2015-02-15 00:06:40.000000', 'consum', 0.0225, 'lps'),
	(394264, 102, '2015-02-15 00:06:41.000000', 'consum', 0.0216, 'lps'),
	(394265, 102, '2015-02-15 00:06:42.000000', 'consum', 0.0216, 'lps'),
	(394266, 102, '2015-02-15 00:06:43.000000', 'consum', 0.0224, 'lps'),
	(394267, 102, '2015-02-15 00:06:44.000000', 'consum', 0.0221, 'lps'),
	(394268, 102, '2015-02-15 00:06:45.000000', 'consum', 0.0222, 'lps'),
	(394269, 102, '2015-02-15 00:06:46.000000', 'consum', 0.0220, 'lps'),
	(394270, 102, '2015-02-15 00:06:47.000000', 'consum', 0.0222, 'lps'),
	(394271, 102, '2015-02-15 00:06:48.000000', 'consum', 0.0221, 'lps'),
	(394272, 102, '2015-02-15 00:06:49.000000', 'consum', 0.0211, 'lps'),
	(394273, 102, '2015-02-15 00:06:50.000000', 'consum', 0.0222, 'lps'),
	(394274, 102, '2015-02-15 00:06:51.000000', 'consum', 0.0228, 'lps'),
	(394275, 102, '2015-02-15 00:06:52.000000', 'consum', 0.0223, 'lps'),
	(394276, 102, '2015-02-15 00:06:53.000000', 'consum', 0.0223, 'lps'),
	(394277, 102, '2015-02-15 00:06:54.000000', 'consum', 0.0216, 'lps'),
	(394278, 102, '2015-02-15 00:06:55.000000', 'consum', 0.0222, 'lps'),
	(394279, 102, '2015-02-15 00:06:56.000000', 'consum', 0.0211, 'lps'),
	(394280, 102, '2015-02-15 00:06:57.000000', 'consum', 0.0220, 'lps'),
	(394281, 102, '2015-02-15 00:06:58.000000', 'consum', 0.0217, 'lps'),
	(394282, 102, '2015-02-15 00:06:59.000000', 'consum', 0.0217, 'lps'),
	(394283, 102, '2015-02-15 00:07:00.000000', 'consum', 0.0224, 'lps'),
	(394284, 102, '2015-02-15 00:07:01.000000', 'consum', 0.0219, 'lps'),
	(394285, 102, '2015-02-15 00:07:02.000000', 'consum', 0.0214, 'lps'),
	(394286, 102, '2015-02-15 00:07:03.000000', 'consum', 0.0223, 'lps'),
	(394287, 102, '2015-02-15 00:07:04.000000', 'consum', 0.0223, 'lps'),
	(394288, 102, '2015-02-15 00:07:05.000000', 'consum', 0.0216, 'lps'),
	(394289, 102, '2015-02-15 00:07:06.000000', 'consum', 0.0222, 'lps'),
	(394290, 102, '2015-02-15 00:07:07.000000', 'consum', 0.0211, 'lps'),
	(394291, 102, '2015-02-15 00:07:08.000000', 'consum', 0.0220, 'lps'),
	(394292, 102, '2015-02-15 00:07:09.000000', 'consum', 0.0218, 'lps'),
	(394293, 102, '2015-02-15 00:07:10.000000', 'consum', 0.0220, 'lps'),
	(394294, 102, '2015-02-15 00:07:11.000000', 'consum', 0.0218, 'lps'),
	(394295, 102, '2015-02-15 00:07:12.000000', 'consum', 0.0221, 'lps'),
	(394296, 102, '2015-02-15 00:07:13.000000', 'consum', 0.0221, 'lps'),
	(394297, 102, '2015-02-15 00:07:14.000000', 'consum', 0.0214, 'lps'),
	(394298, 102, '2015-02-15 00:07:15.000000', 'consum', 0.0217, 'lps'),
	(394299, 102, '2015-02-15 00:07:16.000000', 'consum', 0.0211, 'lps'),
	(394300, 102, '2015-02-15 00:07:17.000000', 'consum', 0.0217, 'lps'),
	(394301, 102, '2015-02-15 00:07:18.000000', 'consum', 0.0221, 'lps'),
	(394302, 102, '2015-02-15 00:07:19.000000', 'consum', 0.0225, 'lps'),
	(394303, 102, '2015-02-15 00:07:20.000000', 'consum', 0.0213, 'lps'),
	(394304, 102, '2015-02-15 00:07:21.000000', 'consum', 0.0222, 'lps'),
	(394305, 102, '2015-02-15 00:07:22.000000', 'consum', 0.0221, 'lps'),
	(394306, 102, '2015-02-15 00:07:23.000000', 'consum', 0.0210, 'lps'),
	(394307, 102, '2015-02-15 00:07:24.000000', 'consum', 0.0218, 'lps'),
	(394308, 102, '2015-02-15 00:07:25.000000', 'consum', 0.0212, 'lps'),
	(394309, 102, '2015-02-15 00:07:26.000000', 'consum', 0.0213, 'lps'),
	(394310, 102, '2015-02-15 00:07:27.000000', 'consum', 0.0220, 'lps'),
	(394311, 102, '2015-02-15 00:07:28.000000', 'consum', 0.0213, 'lps'),
	(394312, 102, '2015-02-15 00:07:29.000000', 'consum', 0.0215, 'lps'),
	(394313, 102, '2015-02-15 00:07:30.000000', 'consum', 0.0227, 'lps'),
	(394314, 102, '2015-02-15 00:07:31.000000', 'consum', 0.0220, 'lps'),
	(394315, 102, '2015-02-15 00:07:32.000000', 'consum', 0.0229, 'lps'),
	(394316, 102, '2015-02-15 00:07:33.000000', 'consum', 0.0217, 'lps'),
	(394317, 102, '2015-02-15 00:07:34.000000', 'consum', 0.0229, 'lps'),
	(394318, 102, '2015-02-15 00:07:35.000000', 'consum', 0.0225, 'lps'),
	(394319, 102, '2015-02-15 00:07:36.000000', 'consum', 0.0226, 'lps'),
	(394320, 102, '2015-02-15 00:07:37.000000', 'consum', 0.0227, 'lps'),
	(394321, 102, '2015-02-15 00:07:38.000000', 'consum', 0.0228, 'lps'),
	(394322, 102, '2015-02-15 00:07:39.000000', 'consum', 0.0210, 'lps'),
	(394323, 102, '2015-02-15 00:07:40.000000', 'consum', 0.0217, 'lps'),
	(394324, 102, '2015-02-15 00:07:41.000000', 'consum', 0.0225, 'lps'),
	(394325, 102, '2015-02-15 00:07:42.000000', 'consum', 0.0222, 'lps'),
	(394326, 102, '2015-02-15 00:07:43.000000', 'consum', 0.0229, 'lps'),
	(394327, 102, '2015-02-15 00:07:44.000000', 'consum', 0.0228, 'lps'),
	(394328, 102, '2015-02-15 00:07:45.000000', 'consum', 0.0226, 'lps'),
	(394329, 102, '2015-02-15 00:07:46.000000', 'consum', 0.0213, 'lps'),
	(394330, 102, '2015-02-15 00:07:47.000000', 'consum', 0.0221, 'lps'),
	(394331, 102, '2015-02-15 00:07:48.000000', 'consum', 0.0215, 'lps'),
	(394332, 102, '2015-02-15 00:07:49.000000', 'consum', 0.0220, 'lps'),
	(394333, 102, '2015-02-15 00:07:50.000000', 'consum', 0.0229, 'lps'),
	(394334, 102, '2015-02-15 00:07:51.000000', 'consum', 0.0213, 'lps'),
	(394335, 102, '2015-02-15 00:07:52.000000', 'consum', 0.0210, 'lps'),
	(394336, 102, '2015-02-15 00:07:53.000000', 'consum', 0.0222, 'lps'),
	(394337, 102, '2015-02-15 00:07:54.000000', 'consum', 0.0211, 'lps'),
	(394338, 102, '2015-02-15 00:07:55.000000', 'consum', 0.0219, 'lps'),
	(394339, 102, '2015-02-15 00:07:56.000000', 'consum', 0.0211, 'lps'),
	(394340, 102, '2015-02-15 00:07:57.000000', 'consum', 0.0210, 'lps'),
	(394341, 102, '2015-02-15 00:07:58.000000', 'consum', 0.0229, 'lps'),
	(394342, 102, '2015-02-15 00:07:59.000000', 'consum', 0.0224, 'lps'),
	(394343, 102, '2015-02-15 00:08:00.000000', 'consum', 0.0224, 'lps'),
	(394344, 102, '2015-02-15 00:08:01.000000', 'consum', 0.0218, 'lps'),
	(394345, 102, '2015-02-15 00:08:02.000000', 'consum', 0.0227, 'lps'),
	(394346, 102, '2015-02-15 00:08:03.000000', 'consum', 0.0213, 'lps'),
	(394347, 102, '2015-02-15 00:08:04.000000', 'consum', 0.0216, 'lps'),
	(394348, 102, '2015-02-15 00:08:05.000000', 'consum', 0.0229, 'lps'),
	(394349, 102, '2015-02-15 00:08:06.000000', 'consum', 0.0229, 'lps'),
	(394350, 102, '2015-02-15 00:08:07.000000', 'consum', 0.0229, 'lps'),
	(394351, 102, '2015-02-15 00:08:08.000000', 'consum', 0.0227, 'lps'),
	(394352, 102, '2015-02-15 00:08:09.000000', 'consum', 0.0217, 'lps'),
	(394353, 102, '2015-02-15 00:08:10.000000', 'consum', 0.0216, 'lps'),
	(394354, 102, '2015-02-15 00:08:11.000000', 'consum', 0.0221, 'lps'),
	(394355, 102, '2015-02-15 00:08:12.000000', 'consum', 0.0225, 'lps'),
	(394356, 102, '2015-02-15 00:08:13.000000', 'consum', 0.0213, 'lps'),
	(394357, 102, '2015-02-15 00:08:14.000000', 'consum', 0.0223, 'lps'),
	(394358, 102, '2015-02-15 00:08:15.000000', 'consum', 0.0225, 'lps'),
	(394359, 102, '2015-02-15 00:08:16.000000', 'consum', 0.0225, 'lps'),
	(394360, 102, '2015-02-15 00:08:17.000000', 'consum', 0.0220, 'lps'),
	(394361, 102, '2015-02-15 00:08:18.000000', 'consum', 0.0216, 'lps'),
	(394362, 102, '2015-02-15 00:08:19.000000', 'consum', 0.0211, 'lps'),
	(394363, 102, '2015-02-15 00:08:20.000000', 'consum', 0.0218, 'lps'),
	(394364, 102, '2015-02-15 00:08:21.000000', 'consum', 0.0226, 'lps'),
	(394365, 102, '2015-02-15 00:08:22.000000', 'consum', 0.0229, 'lps'),
	(394366, 102, '2015-02-15 00:08:23.000000', 'consum', 0.0215, 'lps'),
	(394367, 102, '2015-02-15 00:08:24.000000', 'consum', 0.0221, 'lps'),
	(394368, 102, '2015-02-15 00:08:25.000000', 'consum', 0.0211, 'lps'),
	(394369, 102, '2015-02-15 00:08:26.000000', 'consum', 0.0223, 'lps'),
	(394370, 102, '2015-02-15 00:08:27.000000', 'consum', 0.0212, 'lps'),
	(394371, 102, '2015-02-15 00:08:28.000000', 'consum', 0.0222, 'lps'),
	(394372, 102, '2015-02-15 00:08:29.000000', 'consum', 0.0223, 'lps'),
	(394373, 102, '2015-02-15 00:08:30.000000', 'consum', 0.0221, 'lps'),
	(394374, 102, '2015-02-15 00:08:31.000000', 'consum', 0.0224, 'lps'),
	(394375, 102, '2015-02-15 00:08:32.000000', 'consum', 0.0229, 'lps'),
	(394376, 102, '2015-02-15 00:08:33.000000', 'consum', 0.0224, 'lps'),
	(394377, 102, '2015-02-15 00:08:34.000000', 'consum', 0.0223, 'lps'),
	(394378, 102, '2015-02-15 00:08:35.000000', 'consum', 0.0212, 'lps'),
	(394379, 102, '2015-02-15 00:08:36.000000', 'consum', 0.0223, 'lps'),
	(394380, 102, '2015-02-15 00:08:37.000000', 'consum', 0.0228, 'lps'),
	(394381, 102, '2015-02-15 00:08:38.000000', 'consum', 0.0223, 'lps'),
	(394382, 102, '2015-02-15 00:08:39.000000', 'consum', 0.0222, 'lps'),
	(394383, 102, '2015-02-15 00:08:40.000000', 'consum', 0.0211, 'lps'),
	(394384, 102, '2015-02-15 00:08:41.000000', 'consum', 0.0219, 'lps'),
	(394385, 102, '2015-02-15 00:08:42.000000', 'consum', 0.0215, 'lps'),
	(394386, 102, '2015-02-15 00:08:43.000000', 'consum', 0.0226, 'lps'),
	(394387, 102, '2015-02-15 00:08:44.000000', 'consum', 0.0218, 'lps'),
	(394388, 102, '2015-02-15 00:08:45.000000', 'consum', 0.0221, 'lps'),
	(394389, 102, '2015-02-15 00:08:46.000000', 'consum', 0.0223, 'lps'),
	(394390, 102, '2015-02-15 00:08:47.000000', 'consum', 0.0223, 'lps'),
	(394391, 102, '2015-02-15 00:08:48.000000', 'consum', 0.0215, 'lps'),
	(394392, 102, '2015-02-15 00:08:49.000000', 'consum', 0.0216, 'lps'),
	(394393, 102, '2015-02-15 00:08:50.000000', 'consum', 0.0226, 'lps'),
	(394394, 102, '2015-02-15 00:08:51.000000', 'consum', 0.0214, 'lps'),
	(394395, 102, '2015-02-15 00:08:52.000000', 'consum', 0.0220, 'lps'),
	(394396, 102, '2015-02-15 00:08:53.000000', 'consum', 0.0210, 'lps'),
	(394397, 102, '2015-02-15 00:08:54.000000', 'consum', 0.0222, 'lps'),
	(394398, 102, '2015-02-15 00:08:55.000000', 'consum', 0.0228, 'lps'),
	(394399, 102, '2015-02-15 00:08:56.000000', 'consum', 0.0226, 'lps'),
	(394400, 102, '2015-02-15 00:08:57.000000', 'consum', 0.0218, 'lps'),
	(394401, 102, '2015-02-15 00:08:58.000000', 'consum', 0.0220, 'lps'),
	(394402, 102, '2015-02-15 00:08:59.000000', 'consum', 0.0219, 'lps'),
	(394403, 102, '2015-02-15 00:09:00.000000', 'consum', 0.0224, 'lps'),
	(394404, 102, '2015-02-15 00:09:01.000000', 'consum', 0.0213, 'lps'),
	(394405, 102, '2015-02-15 00:09:02.000000', 'consum', 0.0223, 'lps'),
	(394406, 102, '2015-02-15 00:09:03.000000', 'consum', 0.0227, 'lps'),
	(394407, 102, '2015-02-15 00:09:04.000000', 'consum', 0.0216, 'lps'),
	(394408, 102, '2015-02-15 00:09:05.000000', 'consum', 0.0228, 'lps'),
	(394409, 102, '2015-02-15 00:09:06.000000', 'consum', 0.0226, 'lps'),
	(394410, 102, '2015-02-15 00:09:07.000000', 'consum', 0.0214, 'lps'),
	(394411, 102, '2015-02-15 00:09:08.000000', 'consum', 0.0224, 'lps'),
	(394412, 102, '2015-02-15 00:09:09.000000', 'consum', 0.0210, 'lps'),
	(394413, 102, '2015-02-15 00:09:10.000000', 'consum', 0.0227, 'lps'),
	(394414, 102, '2015-02-15 00:09:11.000000', 'consum', 0.0215, 'lps'),
	(394415, 102, '2015-02-15 00:09:12.000000', 'consum', 0.0224, 'lps'),
	(394416, 102, '2015-02-15 00:09:13.000000', 'consum', 0.0227, 'lps'),
	(394417, 102, '2015-02-15 00:09:14.000000', 'consum', 0.0215, 'lps'),
	(394418, 102, '2015-02-15 00:09:15.000000', 'consum', 0.0221, 'lps'),
	(394419, 102, '2015-02-15 00:09:16.000000', 'consum', 0.0213, 'lps'),
	(394420, 102, '2015-02-15 00:09:17.000000', 'consum', 0.0210, 'lps'),
	(394421, 102, '2015-02-15 00:09:18.000000', 'consum', 0.0222, 'lps'),
	(394422, 102, '2015-02-15 00:09:19.000000', 'consum', 0.0229, 'lps'),
	(394423, 102, '2015-02-15 00:09:20.000000', 'consum', 0.0213, 'lps'),
	(394424, 102, '2015-02-15 00:09:21.000000', 'consum', 0.0227, 'lps'),
	(394425, 102, '2015-02-15 00:09:22.000000', 'consum', 0.0225, 'lps'),
	(394426, 102, '2015-02-15 00:09:23.000000', 'consum', 0.0216, 'lps'),
	(394427, 102, '2015-02-15 00:09:24.000000', 'consum', 0.0216, 'lps'),
	(394428, 102, '2015-02-15 00:09:25.000000', 'consum', 0.0223, 'lps'),
	(394429, 102, '2015-02-15 00:09:26.000000', 'consum', 0.0218, 'lps'),
	(394430, 102, '2015-02-15 00:09:27.000000', 'consum', 0.0210, 'lps'),
	(394431, 102, '2015-02-15 00:09:28.000000', 'consum', 0.0225, 'lps'),
	(394432, 102, '2015-02-15 00:09:29.000000', 'consum', 0.0229, 'lps'),
	(394433, 102, '2015-02-15 00:09:30.000000', 'consum', 0.0218, 'lps'),
	(394434, 102, '2015-02-15 00:09:31.000000', 'consum', 0.0212, 'lps'),
	(394435, 102, '2015-02-15 00:09:32.000000', 'consum', 0.0220, 'lps'),
	(394436, 102, '2015-02-15 00:09:33.000000', 'consum', 0.0212, 'lps'),
	(394437, 102, '2015-02-15 00:09:34.000000', 'consum', 0.0212, 'lps'),
	(394438, 102, '2015-02-15 00:09:35.000000', 'consum', 0.0214, 'lps'),
	(394439, 102, '2015-02-15 00:09:36.000000', 'consum', 0.0224, 'lps'),
	(394440, 102, '2015-02-15 00:09:37.000000', 'consum', 0.0227, 'lps'),
	(394441, 102, '2015-02-15 00:09:38.000000', 'consum', 0.0214, 'lps'),
	(394442, 102, '2015-02-15 00:09:39.000000', 'consum', 0.0220, 'lps'),
	(394443, 102, '2015-02-15 00:09:40.000000', 'consum', 0.0211, 'lps'),
	(394444, 102, '2015-02-15 00:09:41.000000', 'consum', 0.0222, 'lps'),
	(394445, 102, '2015-02-15 00:09:42.000000', 'consum', 0.0227, 'lps'),
	(394446, 102, '2015-02-15 00:09:43.000000', 'consum', 0.0222, 'lps'),
	(394447, 102, '2015-02-15 00:09:44.000000', 'consum', 0.0217, 'lps'),
	(394448, 102, '2015-02-15 00:09:45.000000', 'consum', 0.0211, 'lps'),
	(394449, 102, '2015-02-15 00:09:46.000000', 'consum', 0.0213, 'lps'),
	(394450, 102, '2015-02-15 00:09:47.000000', 'consum', 0.0222, 'lps'),
	(394451, 102, '2015-02-15 00:09:48.000000', 'consum', 0.0224, 'lps'),
	(394452, 102, '2015-02-15 00:09:49.000000', 'consum', 0.0225, 'lps'),
	(394453, 102, '2015-02-15 00:09:50.000000', 'consum', 0.0224, 'lps'),
	(394454, 102, '2015-02-15 00:09:51.000000', 'consum', 0.0213, 'lps'),
	(394455, 102, '2015-02-15 00:09:52.000000', 'consum', 0.0225, 'lps'),
	(394456, 102, '2015-02-15 00:09:53.000000', 'consum', 0.0216, 'lps'),
	(394457, 102, '2015-02-15 00:09:54.000000', 'consum', 0.0214, 'lps'),
	(394458, 102, '2015-02-15 00:09:55.000000', 'consum', 0.0214, 'lps'),
	(394459, 102, '2015-02-15 00:09:56.000000', 'consum', 0.0219, 'lps'),
	(394460, 102, '2015-02-15 00:09:57.000000', 'consum', 0.0222, 'lps'),
	(394461, 102, '2015-02-15 00:09:58.000000', 'consum', 0.0225, 'lps'),
	(394462, 102, '2015-02-15 00:09:59.000000', 'consum', 0.0211, 'lps'),
	(394463, 102, '2015-02-15 00:10:00.000000', 'consum', 0.0228, 'lps'),
	(394464, 102, '2015-02-15 00:10:01.000000', 'consum', 0.0219, 'lps'),
	(394465, 102, '2015-02-15 00:10:02.000000', 'consum', 0.0222, 'lps'),
	(394466, 102, '2015-02-15 00:10:03.000000', 'consum', 0.0223, 'lps'),
	(394467, 102, '2015-02-15 00:10:04.000000', 'consum', 0.0218, 'lps'),
	(394468, 102, '2015-02-15 00:10:05.000000', 'consum', 0.0213, 'lps'),
	(394469, 102, '2015-02-15 00:10:06.000000', 'consum', 0.0222, 'lps'),
	(394470, 102, '2015-02-15 00:10:07.000000', 'consum', 0.0223, 'lps'),
	(394471, 102, '2015-02-15 00:10:08.000000', 'consum', 0.0217, 'lps'),
	(394472, 102, '2015-02-15 00:10:09.000000', 'consum', 0.0226, 'lps'),
	(394473, 102, '2015-02-15 00:10:10.000000', 'consum', 0.0212, 'lps'),
	(394474, 102, '2015-02-15 00:10:11.000000', 'consum', 0.0211, 'lps'),
	(394475, 102, '2015-02-15 00:10:12.000000', 'consum', 0.0229, 'lps'),
	(394476, 102, '2015-02-15 00:10:13.000000', 'consum', 0.0224, 'lps'),
	(394477, 102, '2015-02-15 00:10:14.000000', 'consum', 0.0223, 'lps'),
	(394478, 102, '2015-02-15 00:10:15.000000', 'consum', 0.0214, 'lps'),
	(394479, 102, '2015-02-15 00:10:16.000000', 'consum', 0.0211, 'lps'),
	(394480, 102, '2015-02-15 00:10:17.000000', 'consum', 0.0222, 'lps'),
	(394481, 102, '2015-02-15 00:10:18.000000', 'consum', 0.0227, 'lps'),
	(394482, 102, '2015-02-15 00:10:19.000000', 'consum', 0.0219, 'lps'),
	(394483, 102, '2015-02-15 00:10:20.000000', 'consum', 0.0227, 'lps'),
	(394484, 102, '2015-02-15 00:10:21.000000', 'consum', 0.0229, 'lps'),
	(394485, 102, '2015-02-15 00:10:22.000000', 'consum', 0.0213, 'lps'),
	(394486, 102, '2015-02-15 00:10:23.000000', 'consum', 0.0210, 'lps'),
	(394487, 102, '2015-02-15 00:10:24.000000', 'consum', 0.0219, 'lps'),
	(394488, 102, '2015-02-15 00:10:25.000000', 'consum', 0.0218, 'lps'),
	(394489, 102, '2015-02-15 00:10:26.000000', 'consum', 0.0223, 'lps'),
	(394490, 102, '2015-02-15 00:10:27.000000', 'consum', 0.0229, 'lps'),
	(394491, 102, '2015-02-15 00:10:28.000000', 'consum', 0.0210, 'lps'),
	(394492, 102, '2015-02-15 00:10:29.000000', 'consum', 0.0213, 'lps'),
	(394493, 102, '2015-02-15 00:10:30.000000', 'consum', 0.0223, 'lps'),
	(394494, 102, '2015-02-15 00:10:31.000000', 'consum', 0.0210, 'lps'),
	(394495, 102, '2015-02-15 00:10:32.000000', 'consum', 0.0228, 'lps'),
	(394496, 102, '2015-02-15 00:10:33.000000', 'consum', 0.0224, 'lps'),
	(394497, 102, '2015-02-15 00:10:34.000000', 'consum', 0.0225, 'lps'),
	(394498, 102, '2015-02-15 00:10:35.000000', 'consum', 0.0222, 'lps'),
	(394499, 102, '2015-02-15 00:10:36.000000', 'consum', 0.0225, 'lps'),
	(394500, 102, '2015-02-15 00:10:37.000000', 'consum', 0.0213, 'lps'),
	(394501, 102, '2015-02-15 00:10:38.000000', 'consum', 0.0217, 'lps'),
	(394502, 102, '2015-02-15 00:10:39.000000', 'consum', 0.0219, 'lps'),
	(394503, 102, '2015-02-15 00:10:40.000000', 'consum', 0.0213, 'lps'),
	(394504, 102, '2015-02-15 00:10:41.000000', 'consum', 0.0219, 'lps'),
	(394505, 102, '2015-02-15 00:10:42.000000', 'consum', 0.0227, 'lps'),
	(394506, 102, '2015-02-15 00:10:43.000000', 'consum', 0.0229, 'lps'),
	(394507, 102, '2015-02-15 00:10:44.000000', 'consum', 0.0214, 'lps'),
	(394508, 102, '2015-02-15 00:10:45.000000', 'consum', 0.0214, 'lps'),
	(394509, 102, '2015-02-15 00:10:46.000000', 'consum', 0.0218, 'lps'),
	(394510, 102, '2015-02-15 00:10:47.000000', 'consum', 0.0217, 'lps'),
	(394511, 102, '2015-02-15 00:10:48.000000', 'consum', 0.0222, 'lps'),
	(394512, 102, '2015-02-15 00:10:49.000000', 'consum', 0.0210, 'lps'),
	(394513, 102, '2015-02-15 00:10:50.000000', 'consum', 0.0215, 'lps'),
	(394514, 102, '2015-02-15 00:10:51.000000', 'consum', 0.0216, 'lps'),
	(394515, 102, '2015-02-15 00:10:52.000000', 'consum', 0.0223, 'lps'),
	(394516, 102, '2015-02-15 00:10:53.000000', 'consum', 0.0218, 'lps'),
	(394517, 102, '2015-02-15 00:10:54.000000', 'consum', 0.0213, 'lps'),
	(394518, 102, '2015-02-15 00:10:55.000000', 'consum', 0.0220, 'lps'),
	(394519, 102, '2015-02-15 00:10:56.000000', 'consum', 0.0213, 'lps'),
	(394520, 102, '2015-02-15 00:10:57.000000', 'consum', 0.0217, 'lps'),
	(394521, 102, '2015-02-15 00:10:58.000000', 'consum', 0.0214, 'lps'),
	(394522, 102, '2015-02-15 00:10:59.000000', 'consum', 0.0229, 'lps'),
	(394523, 102, '2015-02-15 00:11:00.000000', 'consum', 0.0216, 'lps'),
	(394524, 102, '2015-02-15 00:11:01.000000', 'consum', 0.0222, 'lps'),
	(394525, 102, '2015-02-15 00:11:02.000000', 'consum', 0.0211, 'lps'),
	(394526, 102, '2015-02-15 00:11:03.000000', 'consum', 0.0221, 'lps'),
	(394527, 102, '2015-02-15 00:11:04.000000', 'consum', 0.0222, 'lps'),
	(394528, 102, '2015-02-15 00:11:05.000000', 'consum', 0.0219, 'lps'),
	(394529, 102, '2015-02-15 00:11:06.000000', 'consum', 0.0217, 'lps'),
	(394530, 102, '2015-02-15 00:11:07.000000', 'consum', 0.0221, 'lps'),
	(394531, 102, '2015-02-15 00:11:08.000000', 'consum', 0.0225, 'lps'),
	(394532, 102, '2015-02-15 00:11:09.000000', 'consum', 0.0212, 'lps'),
	(394533, 102, '2015-02-15 00:11:10.000000', 'consum', 0.0214, 'lps'),
	(394534, 102, '2015-02-15 00:11:11.000000', 'consum', 0.0225, 'lps'),
	(394535, 102, '2015-02-15 00:11:12.000000', 'consum', 0.0213, 'lps'),
	(394536, 102, '2015-02-15 00:11:13.000000', 'consum', 0.0221, 'lps'),
	(394537, 102, '2015-02-15 00:11:14.000000', 'consum', 0.0215, 'lps'),
	(394538, 102, '2015-02-15 00:11:15.000000', 'consum', 0.0224, 'lps'),
	(394539, 102, '2015-02-15 00:11:16.000000', 'consum', 0.0225, 'lps'),
	(394540, 102, '2015-02-15 00:11:17.000000', 'consum', 0.0223, 'lps'),
	(394541, 102, '2015-02-15 00:11:18.000000', 'consum', 0.0210, 'lps'),
	(394542, 102, '2015-02-15 00:11:19.000000', 'consum', 0.0212, 'lps'),
	(394543, 102, '2015-02-15 00:11:20.000000', 'consum', 0.0219, 'lps'),
	(394544, 102, '2015-02-15 00:11:21.000000', 'consum', 0.0212, 'lps'),
	(394545, 102, '2015-02-15 00:11:22.000000', 'consum', 0.0211, 'lps'),
	(394546, 102, '2015-02-15 00:11:23.000000', 'consum', 0.0229, 'lps'),
	(394547, 102, '2015-02-15 00:11:24.000000', 'consum', 0.0222, 'lps'),
	(394548, 102, '2015-02-15 00:11:25.000000', 'consum', 0.0215, 'lps'),
	(394549, 102, '2015-02-15 00:11:26.000000', 'consum', 0.0218, 'lps'),
	(394550, 102, '2015-02-15 00:11:27.000000', 'consum', 0.0217, 'lps'),
	(394551, 102, '2015-02-15 00:11:28.000000', 'consum', 0.0222, 'lps'),
	(394552, 102, '2015-02-15 00:11:29.000000', 'consum', 0.0210, 'lps'),
	(394553, 102, '2015-02-15 00:11:30.000000', 'consum', 0.0212, 'lps'),
	(394554, 102, '2015-02-15 00:11:31.000000', 'consum', 0.0222, 'lps'),
	(394555, 102, '2015-02-15 00:11:32.000000', 'consum', 0.0225, 'lps'),
	(394556, 102, '2015-02-15 00:11:33.000000', 'consum', 0.0229, 'lps'),
	(394557, 102, '2015-02-15 00:11:34.000000', 'consum', 0.0219, 'lps'),
	(394558, 102, '2015-02-15 00:11:35.000000', 'consum', 0.0221, 'lps'),
	(394559, 102, '2015-02-15 00:11:36.000000', 'consum', 0.0216, 'lps'),
	(394560, 102, '2015-02-15 00:11:37.000000', 'consum', 0.0227, 'lps'),
	(394561, 102, '2015-02-15 00:11:38.000000', 'consum', 0.0218, 'lps'),
	(394562, 102, '2015-02-15 00:11:39.000000', 'consum', 0.0221, 'lps'),
	(394563, 102, '2015-02-15 00:11:40.000000', 'consum', 0.0221, 'lps'),
	(394564, 102, '2015-02-15 00:11:41.000000', 'consum', 0.0213, 'lps'),
	(394565, 102, '2015-02-15 00:11:42.000000', 'consum', 0.0210, 'lps'),
	(394566, 102, '2015-02-15 00:11:43.000000', 'consum', 0.0223, 'lps'),
	(394567, 102, '2015-02-15 00:11:44.000000', 'consum', 0.0217, 'lps'),
	(394568, 102, '2015-02-15 00:11:45.000000', 'consum', 0.0227, 'lps'),
	(394569, 102, '2015-02-15 00:11:46.000000', 'consum', 0.0213, 'lps'),
	(394570, 102, '2015-02-15 00:11:47.000000', 'consum', 0.0213, 'lps'),
	(394571, 102, '2015-02-15 00:11:48.000000', 'consum', 0.0218, 'lps'),
	(394572, 102, '2015-02-15 00:11:49.000000', 'consum', 0.0221, 'lps'),
	(394573, 102, '2015-02-15 00:11:50.000000', 'consum', 0.0222, 'lps'),
	(394574, 102, '2015-02-15 00:11:51.000000', 'consum', 0.0219, 'lps'),
	(394575, 102, '2015-02-15 00:11:52.000000', 'consum', 0.0216, 'lps'),
	(394576, 102, '2015-02-15 00:11:53.000000', 'consum', 0.0216, 'lps'),
	(394577, 102, '2015-02-15 00:11:54.000000', 'consum', 0.0224, 'lps'),
	(394578, 102, '2015-02-15 00:11:55.000000', 'consum', 0.0219, 'lps'),
	(394579, 102, '2015-02-15 00:11:56.000000', 'consum', 0.0216, 'lps'),
	(394580, 102, '2015-02-15 00:11:57.000000', 'consum', 0.0215, 'lps'),
	(394581, 102, '2015-02-15 00:11:58.000000', 'consum', 0.0215, 'lps'),
	(394582, 102, '2015-02-15 00:11:59.000000', 'consum', 0.0220, 'lps'),
	(394583, 102, '2015-02-15 00:12:00.000000', 'consum', 0.0228, 'lps'),
	(394584, 102, '2015-02-15 00:12:01.000000', 'consum', 0.0229, 'lps'),
	(394585, 102, '2015-02-15 00:12:02.000000', 'consum', 0.0210, 'lps'),
	(394586, 102, '2015-02-15 00:12:03.000000', 'consum', 0.0216, 'lps'),
	(394587, 102, '2015-02-15 00:12:04.000000', 'consum', 0.0218, 'lps'),
	(394588, 102, '2015-02-15 00:12:05.000000', 'consum', 0.0211, 'lps'),
	(394589, 102, '2015-02-15 00:12:06.000000', 'consum', 0.0215, 'lps'),
	(394590, 102, '2015-02-15 00:12:07.000000', 'consum', 0.0213, 'lps'),
	(394591, 102, '2015-02-15 00:12:08.000000', 'consum', 0.0229, 'lps'),
	(394592, 102, '2015-02-15 00:12:09.000000', 'consum', 0.0215, 'lps'),
	(394593, 102, '2015-02-15 00:12:10.000000', 'consum', 0.0221, 'lps'),
	(394594, 102, '2015-02-15 00:12:11.000000', 'consum', 0.0229, 'lps'),
	(394595, 102, '2015-02-15 00:12:12.000000', 'consum', 0.0213, 'lps'),
	(394596, 102, '2015-02-15 00:12:13.000000', 'consum', 0.0228, 'lps'),
	(394597, 102, '2015-02-15 00:12:14.000000', 'consum', 0.0213, 'lps'),
	(394598, 102, '2015-02-15 00:12:15.000000', 'consum', 0.0212, 'lps'),
	(394599, 102, '2015-02-15 00:12:16.000000', 'consum', 0.0229, 'lps'),
	(394600, 102, '2015-02-15 00:12:17.000000', 'consum', 0.0219, 'lps'),
	(394601, 102, '2015-02-15 00:12:18.000000', 'consum', 0.0221, 'lps'),
	(394602, 102, '2015-02-15 00:12:19.000000', 'consum', 0.0218, 'lps'),
	(394603, 102, '2015-02-15 00:12:20.000000', 'consum', 0.0215, 'lps'),
	(394604, 102, '2015-02-15 00:12:21.000000', 'consum', 0.0215, 'lps'),
	(394605, 102, '2015-02-15 00:12:22.000000', 'consum', 0.0219, 'lps'),
	(394606, 102, '2015-02-15 00:12:23.000000', 'consum', 0.0221, 'lps'),
	(394607, 102, '2015-02-15 00:12:24.000000', 'consum', 0.0217, 'lps'),
	(394608, 102, '2015-02-15 00:12:25.000000', 'consum', 0.0213, 'lps'),
	(394609, 102, '2015-02-15 00:12:26.000000', 'consum', 0.0225, 'lps'),
	(394610, 102, '2015-02-15 00:12:27.000000', 'consum', 0.0217, 'lps'),
	(394611, 102, '2015-02-15 00:12:28.000000', 'consum', 0.0220, 'lps'),
	(394612, 102, '2015-02-15 00:12:29.000000', 'consum', 0.0220, 'lps'),
	(394613, 102, '2015-02-15 00:12:30.000000', 'consum', 0.0211, 'lps'),
	(394614, 102, '2015-02-15 00:12:31.000000', 'consum', 0.0225, 'lps'),
	(394615, 102, '2015-02-15 00:12:32.000000', 'consum', 0.0221, 'lps'),
	(394616, 102, '2015-02-15 00:12:33.000000', 'consum', 0.0221, 'lps'),
	(394617, 102, '2015-02-15 00:12:34.000000', 'consum', 0.0211, 'lps'),
	(394618, 102, '2015-02-15 00:12:35.000000', 'consum', 0.0223, 'lps'),
	(394619, 102, '2015-02-15 00:12:36.000000', 'consum', 0.0212, 'lps'),
	(394620, 102, '2015-02-15 00:12:37.000000', 'consum', 0.0221, 'lps'),
	(394621, 102, '2015-02-15 00:12:38.000000', 'consum', 0.0222, 'lps'),
	(394622, 102, '2015-02-15 00:12:39.000000', 'consum', 0.0217, 'lps'),
	(394623, 102, '2015-02-15 00:12:40.000000', 'consum', 0.0227, 'lps'),
	(394624, 102, '2015-02-15 00:12:41.000000', 'consum', 0.0218, 'lps'),
	(394625, 102, '2015-02-15 00:12:42.000000', 'consum', 0.0216, 'lps'),
	(394626, 102, '2015-02-15 00:12:43.000000', 'consum', 0.0220, 'lps'),
	(394627, 102, '2015-02-15 00:12:44.000000', 'consum', 0.0219, 'lps'),
	(394628, 102, '2015-02-15 00:12:45.000000', 'consum', 0.0227, 'lps'),
	(394629, 102, '2015-02-15 00:12:46.000000', 'consum', 0.0228, 'lps'),
	(394630, 102, '2015-02-15 00:12:47.000000', 'consum', 0.0211, 'lps'),
	(394631, 102, '2015-02-15 00:12:48.000000', 'consum', 0.0221, 'lps'),
	(394632, 102, '2015-02-15 00:12:49.000000', 'consum', 0.0223, 'lps'),
	(394633, 102, '2015-02-15 00:12:50.000000', 'consum', 0.0224, 'lps'),
	(394634, 102, '2015-02-15 00:12:51.000000', 'consum', 0.0220, 'lps'),
	(394635, 102, '2015-02-15 00:12:52.000000', 'consum', 0.0220, 'lps'),
	(394636, 102, '2015-02-15 00:12:53.000000', 'consum', 0.0210, 'lps'),
	(394637, 102, '2015-02-15 00:12:54.000000', 'consum', 0.0221, 'lps'),
	(394638, 102, '2015-02-15 00:12:55.000000', 'consum', 0.0226, 'lps'),
	(394639, 102, '2015-02-15 00:12:56.000000', 'consum', 0.0215, 'lps'),
	(394640, 102, '2015-02-15 00:12:57.000000', 'consum', 0.0229, 'lps'),
	(394641, 102, '2015-02-15 00:12:58.000000', 'consum', 0.0211, 'lps'),
	(394642, 102, '2015-02-15 00:12:59.000000', 'consum', 0.0218, 'lps'),
	(394643, 102, '2015-02-15 00:13:00.000000', 'consum', 0.0228, 'lps'),
	(394644, 102, '2015-02-15 00:13:01.000000', 'consum', 0.0215, 'lps'),
	(394645, 102, '2015-02-15 00:13:02.000000', 'consum', 0.0221, 'lps'),
	(394646, 102, '2015-02-15 00:13:03.000000', 'consum', 0.0213, 'lps'),
	(394647, 102, '2015-02-15 00:13:04.000000', 'consum', 0.0213, 'lps'),
	(394648, 102, '2015-02-15 00:13:05.000000', 'consum', 0.0218, 'lps'),
	(394649, 102, '2015-02-15 00:13:06.000000', 'consum', 0.0218, 'lps'),
	(394650, 102, '2015-02-15 00:13:07.000000', 'consum', 0.0226, 'lps'),
	(394651, 102, '2015-02-15 00:13:08.000000', 'consum', 0.0227, 'lps'),
	(394652, 102, '2015-02-15 00:13:09.000000', 'consum', 0.0228, 'lps'),
	(394653, 102, '2015-02-15 00:13:10.000000', 'consum', 0.0211, 'lps'),
	(394654, 102, '2015-02-15 00:13:11.000000', 'consum', 0.0222, 'lps'),
	(394655, 102, '2015-02-15 00:13:12.000000', 'consum', 0.0227, 'lps'),
	(394656, 102, '2015-02-15 00:13:13.000000', 'consum', 0.0220, 'lps'),
	(394657, 102, '2015-02-15 00:13:14.000000', 'consum', 0.0228, 'lps'),
	(394658, 102, '2015-02-15 00:13:15.000000', 'consum', 0.0210, 'lps'),
	(394659, 102, '2015-02-15 00:13:16.000000', 'consum', 0.0215, 'lps'),
	(394660, 102, '2015-02-15 00:13:17.000000', 'consum', 0.0219, 'lps'),
	(394661, 102, '2015-02-15 00:13:18.000000', 'consum', 0.0218, 'lps'),
	(394662, 102, '2015-02-15 00:13:19.000000', 'consum', 0.0223, 'lps'),
	(394663, 102, '2015-02-15 00:13:20.000000', 'consum', 0.0212, 'lps'),
	(394664, 102, '2015-02-15 00:13:21.000000', 'consum', 0.0222, 'lps'),
	(394665, 102, '2015-02-15 00:13:22.000000', 'consum', 0.0225, 'lps'),
	(394666, 102, '2015-02-15 00:13:23.000000', 'consum', 0.0229, 'lps'),
	(394667, 102, '2015-02-15 00:13:24.000000', 'consum', 0.0219, 'lps'),
	(394668, 102, '2015-02-15 00:13:25.000000', 'consum', 0.0219, 'lps'),
	(394669, 102, '2015-02-15 00:13:26.000000', 'consum', 0.0227, 'lps'),
	(394670, 102, '2015-02-15 00:13:27.000000', 'consum', 0.0211, 'lps'),
	(394671, 102, '2015-02-15 00:13:28.000000', 'consum', 0.0222, 'lps'),
	(394672, 102, '2015-02-15 00:13:29.000000', 'consum', 0.0210, 'lps'),
	(394673, 102, '2015-02-15 00:13:30.000000', 'consum', 0.0212, 'lps'),
	(394674, 102, '2015-02-15 00:13:31.000000', 'consum', 0.0223, 'lps'),
	(394675, 102, '2015-02-15 00:13:32.000000', 'consum', 0.0210, 'lps'),
	(394676, 102, '2015-02-15 00:13:33.000000', 'consum', 0.0211, 'lps'),
	(394677, 102, '2015-02-15 00:13:34.000000', 'consum', 0.0214, 'lps'),
	(394678, 102, '2015-02-15 00:13:35.000000', 'consum', 0.0210, 'lps'),
	(394679, 102, '2015-02-15 00:13:36.000000', 'consum', 0.0217, 'lps'),
	(394680, 102, '2015-02-15 00:13:37.000000', 'consum', 0.0225, 'lps'),
	(394681, 102, '2015-02-15 00:13:38.000000', 'consum', 0.0226, 'lps'),
	(394682, 102, '2015-02-15 00:13:39.000000', 'consum', 0.0225, 'lps'),
	(394683, 102, '2015-02-15 00:13:40.000000', 'consum', 0.0215, 'lps'),
	(394684, 102, '2015-02-15 00:13:41.000000', 'consum', 0.0214, 'lps'),
	(394685, 102, '2015-02-15 00:13:42.000000', 'consum', 0.0214, 'lps'),
	(394686, 102, '2015-02-15 00:13:43.000000', 'consum', 0.0221, 'lps'),
	(394687, 102, '2015-02-15 00:13:44.000000', 'consum', 0.0211, 'lps'),
	(394688, 102, '2015-02-15 00:13:45.000000', 'consum', 0.0221, 'lps'),
	(394689, 102, '2015-02-15 00:13:46.000000', 'consum', 0.0225, 'lps'),
	(394690, 102, '2015-02-15 00:13:47.000000', 'consum', 0.0213, 'lps'),
	(394691, 102, '2015-02-15 00:13:48.000000', 'consum', 0.0221, 'lps'),
	(394692, 102, '2015-02-15 00:13:49.000000', 'consum', 0.0217, 'lps'),
	(394693, 102, '2015-02-15 00:13:50.000000', 'consum', 0.0210, 'lps'),
	(394694, 102, '2015-02-15 00:13:51.000000', 'consum', 0.0213, 'lps'),
	(394695, 102, '2015-02-15 00:13:52.000000', 'consum', 0.0222, 'lps'),
	(394696, 102, '2015-02-15 00:13:53.000000', 'consum', 0.0224, 'lps'),
	(394697, 102, '2015-02-15 00:13:54.000000', 'consum', 0.0223, 'lps'),
	(394698, 102, '2015-02-15 00:13:55.000000', 'consum', 0.0213, 'lps'),
	(394699, 102, '2015-02-15 00:13:56.000000', 'consum', 0.0228, 'lps'),
	(394700, 102, '2015-02-15 00:13:57.000000', 'consum', 0.0210, 'lps'),
	(394701, 102, '2015-02-15 00:13:58.000000', 'consum', 0.0218, 'lps'),
	(394702, 102, '2015-02-15 00:13:59.000000', 'consum', 0.0229, 'lps'),
	(394703, 102, '2015-02-15 00:14:00.000000', 'consum', 0.0224, 'lps'),
	(394704, 102, '2015-02-15 00:14:01.000000', 'consum', 0.0222, 'lps'),
	(394705, 102, '2015-02-15 00:14:02.000000', 'consum', 0.0210, 'lps'),
	(394706, 102, '2015-02-15 00:14:03.000000', 'consum', 0.0213, 'lps'),
	(394707, 102, '2015-02-15 00:14:04.000000', 'consum', 0.0225, 'lps'),
	(394708, 102, '2015-02-15 00:14:05.000000', 'consum', 0.0219, 'lps'),
	(394709, 102, '2015-02-15 00:14:06.000000', 'consum', 0.0228, 'lps'),
	(394710, 102, '2015-02-15 00:14:07.000000', 'consum', 0.0214, 'lps'),
	(394711, 102, '2015-02-15 00:14:08.000000', 'consum', 0.0215, 'lps'),
	(394712, 102, '2015-02-15 00:14:09.000000', 'consum', 0.0226, 'lps'),
	(394713, 102, '2015-02-15 00:14:10.000000', 'consum', 0.0214, 'lps'),
	(394714, 102, '2015-02-15 00:14:11.000000', 'consum', 0.0225, 'lps'),
	(394715, 102, '2015-02-15 00:14:12.000000', 'consum', 0.0212, 'lps'),
	(394716, 102, '2015-02-15 00:14:13.000000', 'consum', 0.0214, 'lps'),
	(394717, 102, '2015-02-15 00:14:14.000000', 'consum', 0.0225, 'lps'),
	(394718, 102, '2015-02-15 00:14:15.000000', 'consum', 0.0215, 'lps'),
	(394719, 102, '2015-02-15 00:14:16.000000', 'consum', 0.0211, 'lps'),
	(394720, 102, '2015-02-15 00:14:17.000000', 'consum', 0.0221, 'lps'),
	(394721, 102, '2015-02-15 00:14:18.000000', 'consum', 0.0223, 'lps'),
	(394722, 102, '2015-02-15 00:14:19.000000', 'consum', 0.0222, 'lps'),
	(394723, 102, '2015-02-15 00:14:20.000000', 'consum', 0.0212, 'lps'),
	(394724, 102, '2015-02-15 00:14:21.000000', 'consum', 0.0225, 'lps'),
	(394725, 102, '2015-02-15 00:14:22.000000', 'consum', 0.0219, 'lps'),
	(394726, 102, '2015-02-15 00:14:23.000000', 'consum', 0.0229, 'lps'),
	(394727, 102, '2015-02-15 00:14:24.000000', 'consum', 0.0221, 'lps'),
	(394728, 102, '2015-02-15 00:14:25.000000', 'consum', 0.0228, 'lps'),
	(394729, 102, '2015-02-15 00:14:26.000000', 'consum', 0.0227, 'lps'),
	(394730, 102, '2015-02-15 00:14:27.000000', 'consum', 0.0221, 'lps'),
	(394731, 102, '2015-02-15 00:14:28.000000', 'consum', 0.0215, 'lps'),
	(394732, 102, '2015-02-15 00:14:29.000000', 'consum', 0.0221, 'lps'),
	(394733, 102, '2015-02-15 00:14:30.000000', 'consum', 0.0212, 'lps'),
	(394734, 102, '2015-02-15 00:14:31.000000', 'consum', 0.0229, 'lps'),
	(394735, 102, '2015-02-15 00:14:32.000000', 'consum', 0.0218, 'lps'),
	(394736, 102, '2015-02-15 00:14:33.000000', 'consum', 0.0214, 'lps'),
	(394737, 102, '2015-02-15 00:14:34.000000', 'consum', 0.0228, 'lps'),
	(394738, 102, '2015-02-15 00:14:35.000000', 'consum', 0.0227, 'lps'),
	(394739, 102, '2015-02-15 00:14:36.000000', 'consum', 0.0221, 'lps'),
	(394740, 102, '2015-02-15 00:14:37.000000', 'consum', 0.0217, 'lps'),
	(394741, 102, '2015-02-15 00:14:38.000000', 'consum', 0.0229, 'lps'),
	(394742, 102, '2015-02-15 00:14:39.000000', 'consum', 0.0226, 'lps'),
	(394743, 102, '2015-02-15 00:14:40.000000', 'consum', 0.0215, 'lps'),
	(394744, 102, '2015-02-15 00:14:41.000000', 'consum', 0.0225, 'lps'),
	(394745, 102, '2015-02-15 00:14:42.000000', 'consum', 0.0211, 'lps'),
	(394746, 102, '2015-02-15 00:14:43.000000', 'consum', 0.0229, 'lps'),
	(394747, 102, '2015-02-15 00:14:44.000000', 'consum', 0.0224, 'lps'),
	(394748, 102, '2015-02-15 00:14:45.000000', 'consum', 0.0223, 'lps'),
	(394749, 102, '2015-02-15 00:14:46.000000', 'consum', 0.0212, 'lps'),
	(394750, 102, '2015-02-15 00:14:47.000000', 'consum', 0.0222, 'lps'),
	(394751, 102, '2015-02-15 00:14:48.000000', 'consum', 0.0224, 'lps'),
	(394752, 102, '2015-02-15 00:14:49.000000', 'consum', 0.0224, 'lps'),
	(394753, 102, '2015-02-15 00:14:50.000000', 'consum', 0.0218, 'lps'),
	(394754, 102, '2015-02-15 00:14:51.000000', 'consum', 0.0229, 'lps'),
	(394755, 102, '2015-02-15 00:14:52.000000', 'consum', 0.0222, 'lps'),
	(394756, 102, '2015-02-15 00:14:53.000000', 'consum', 0.0212, 'lps'),
	(394757, 102, '2015-02-15 00:14:54.000000', 'consum', 0.0223, 'lps'),
	(394758, 102, '2015-02-15 00:14:55.000000', 'consum', 0.0213, 'lps'),
	(394759, 102, '2015-02-15 00:14:56.000000', 'consum', 0.0227, 'lps'),
	(394760, 102, '2015-02-15 00:14:57.000000', 'consum', 0.0224, 'lps'),
	(394761, 102, '2015-02-15 00:14:58.000000', 'consum', 0.0212, 'lps'),
	(394762, 102, '2015-02-15 00:14:59.000000', 'consum', 0.0217, 'lps'),
	(394763, 102, '2015-02-15 00:15:00.000000', 'consum', 0.0219, 'lps'),
	(394764, 102, '2015-02-15 00:15:01.000000', 'consum', 0.0215, 'lps'),
	(394765, 102, '2015-02-15 00:15:02.000000', 'consum', 0.0228, 'lps'),
	(394766, 102, '2015-02-15 00:15:03.000000', 'consum', 0.0227, 'lps'),
	(394767, 102, '2015-02-15 00:15:04.000000', 'consum', 0.0220, 'lps'),
	(394768, 102, '2015-02-15 00:15:05.000000', 'consum', 0.0228, 'lps'),
	(394769, 102, '2015-02-15 00:15:06.000000', 'consum', 0.0212, 'lps'),
	(394770, 102, '2015-02-15 00:15:07.000000', 'consum', 0.0225, 'lps'),
	(394771, 102, '2015-02-15 00:15:08.000000', 'consum', 0.0220, 'lps'),
	(394772, 102, '2015-02-15 00:15:09.000000', 'consum', 0.0216, 'lps'),
	(394773, 102, '2015-02-15 00:15:10.000000', 'consum', 0.0212, 'lps'),
	(394774, 102, '2015-02-15 00:15:11.000000', 'consum', 0.0223, 'lps'),
	(394775, 102, '2015-02-15 00:15:12.000000', 'consum', 0.0228, 'lps'),
	(394776, 102, '2015-02-15 00:15:13.000000', 'consum', 0.0221, 'lps'),
	(394777, 102, '2015-02-15 00:15:14.000000', 'consum', 0.0210, 'lps'),
	(394778, 102, '2015-02-15 00:15:15.000000', 'consum', 0.0219, 'lps'),
	(394779, 102, '2015-02-15 00:15:16.000000', 'consum', 0.0216, 'lps'),
	(394780, 102, '2015-02-15 00:15:17.000000', 'consum', 0.0211, 'lps'),
	(394781, 102, '2015-02-15 00:15:18.000000', 'consum', 0.0219, 'lps'),
	(394782, 102, '2015-02-15 00:15:19.000000', 'consum', 0.0213, 'lps'),
	(394783, 102, '2015-02-15 00:15:20.000000', 'consum', 0.0218, 'lps'),
	(394784, 102, '2015-02-15 00:15:21.000000', 'consum', 0.0222, 'lps'),
	(394785, 102, '2015-02-15 00:15:22.000000', 'consum', 0.0225, 'lps'),
	(394786, 102, '2015-02-15 00:15:23.000000', 'consum', 0.0210, 'lps'),
	(394787, 102, '2015-02-15 00:15:24.000000', 'consum', 0.0226, 'lps'),
	(394788, 102, '2015-02-15 00:15:25.000000', 'consum', 0.0229, 'lps'),
	(394789, 102, '2015-02-15 00:15:26.000000', 'consum', 0.0217, 'lps'),
	(394790, 102, '2015-02-15 00:15:27.000000', 'consum', 0.0211, 'lps'),
	(394791, 102, '2015-02-15 00:15:28.000000', 'consum', 0.0213, 'lps'),
	(394792, 102, '2015-02-15 00:15:29.000000', 'consum', 0.0223, 'lps'),
	(394793, 102, '2015-02-15 00:15:30.000000', 'consum', 0.0228, 'lps'),
	(394794, 102, '2015-02-15 00:15:31.000000', 'consum', 0.0221, 'lps'),
	(394795, 102, '2015-02-15 00:15:32.000000', 'consum', 0.0211, 'lps'),
	(394796, 102, '2015-02-15 00:15:33.000000', 'consum', 0.0221, 'lps'),
	(394797, 102, '2015-02-15 00:15:34.000000', 'consum', 0.0222, 'lps'),
	(394798, 102, '2015-02-15 00:15:35.000000', 'consum', 0.0219, 'lps'),
	(394799, 102, '2015-02-15 00:15:36.000000', 'consum', 0.0221, 'lps'),
	(394800, 102, '2015-02-15 00:15:37.000000', 'consum', 0.0216, 'lps'),
	(394801, 102, '2015-02-15 00:15:38.000000', 'consum', 0.0228, 'lps'),
	(394802, 102, '2015-02-15 00:15:39.000000', 'consum', 0.0225, 'lps'),
	(394803, 102, '2015-02-15 00:15:40.000000', 'consum', 0.0228, 'lps'),
	(394804, 102, '2015-02-15 00:15:41.000000', 'consum', 0.0217, 'lps'),
	(394805, 102, '2015-02-15 00:15:42.000000', 'consum', 0.0210, 'lps'),
	(394806, 102, '2015-02-15 00:15:43.000000', 'consum', 0.0212, 'lps'),
	(394807, 102, '2015-02-15 00:15:44.000000', 'consum', 0.0221, 'lps'),
	(394808, 102, '2015-02-15 00:15:45.000000', 'consum', 0.0220, 'lps'),
	(394809, 102, '2015-02-15 00:15:46.000000', 'consum', 0.0226, 'lps'),
	(394810, 102, '2015-02-15 00:15:47.000000', 'consum', 0.0220, 'lps'),
	(394811, 102, '2015-02-15 00:15:48.000000', 'consum', 0.0212, 'lps'),
	(394812, 102, '2015-02-15 00:15:49.000000', 'consum', 0.0210, 'lps'),
	(394813, 102, '2015-02-15 00:15:50.000000', 'consum', 0.0224, 'lps'),
	(394814, 102, '2015-02-15 00:15:51.000000', 'consum', 0.0221, 'lps'),
	(394815, 102, '2015-02-15 00:15:52.000000', 'consum', 0.0225, 'lps'),
	(394816, 102, '2015-02-15 00:15:53.000000', 'consum', 0.0212, 'lps'),
	(394817, 102, '2015-02-15 00:15:54.000000', 'consum', 0.0217, 'lps'),
	(394818, 102, '2015-02-15 00:15:55.000000', 'consum', 0.0218, 'lps'),
	(394819, 102, '2015-02-15 00:15:56.000000', 'consum', 0.0211, 'lps'),
	(394820, 102, '2015-02-15 00:15:57.000000', 'consum', 0.0211, 'lps'),
	(394821, 102, '2015-02-15 00:15:58.000000', 'consum', 0.0211, 'lps'),
	(394822, 102, '2015-02-15 00:15:59.000000', 'consum', 0.0212, 'lps'),
	(394823, 102, '2015-02-15 00:16:00.000000', 'consum', 0.0220, 'lps'),
	(394824, 102, '2015-02-15 00:16:01.000000', 'consum', 0.0212, 'lps'),
	(394825, 102, '2015-02-15 00:16:02.000000', 'consum', 0.0210, 'lps'),
	(394826, 102, '2015-02-15 00:16:03.000000', 'consum', 0.0224, 'lps'),
	(394827, 102, '2015-02-15 00:16:04.000000', 'consum', 0.0223, 'lps'),
	(394828, 102, '2015-02-15 00:16:05.000000', 'consum', 0.0213, 'lps'),
	(394829, 102, '2015-02-15 00:16:06.000000', 'consum', 0.0226, 'lps'),
	(394830, 102, '2015-02-15 00:16:07.000000', 'consum', 0.0222, 'lps'),
	(394831, 102, '2015-02-15 00:16:08.000000', 'consum', 0.0221, 'lps'),
	(394832, 102, '2015-02-15 00:16:09.000000', 'consum', 0.0210, 'lps'),
	(394833, 102, '2015-02-15 00:16:10.000000', 'consum', 0.0218, 'lps'),
	(394834, 102, '2015-02-15 00:16:11.000000', 'consum', 0.0229, 'lps'),
	(394835, 102, '2015-02-15 00:16:12.000000', 'consum', 0.0223, 'lps'),
	(394836, 102, '2015-02-15 00:16:13.000000', 'consum', 0.0217, 'lps'),
	(394837, 102, '2015-02-15 00:16:14.000000', 'consum', 0.0228, 'lps'),
	(394838, 102, '2015-02-15 00:16:15.000000', 'consum', 0.0217, 'lps'),
	(394839, 102, '2015-02-15 00:16:16.000000', 'consum', 0.0213, 'lps'),
	(394840, 102, '2015-02-15 00:16:17.000000', 'consum', 0.0223, 'lps'),
	(394841, 102, '2015-02-15 00:16:18.000000', 'consum', 0.0225, 'lps'),
	(394842, 102, '2015-02-15 00:16:19.000000', 'consum', 0.0210, 'lps'),
	(394843, 102, '2015-02-15 00:16:20.000000', 'consum', 0.0224, 'lps'),
	(394844, 102, '2015-02-15 00:16:21.000000', 'consum', 0.0220, 'lps'),
	(394845, 102, '2015-02-15 00:16:22.000000', 'consum', 0.0221, 'lps'),
	(394846, 102, '2015-02-15 00:16:23.000000', 'consum', 0.0214, 'lps'),
	(394847, 102, '2015-02-15 00:16:24.000000', 'consum', 0.0216, 'lps'),
	(394848, 102, '2015-02-15 00:16:25.000000', 'consum', 0.0229, 'lps'),
	(394849, 102, '2015-02-15 00:16:26.000000', 'consum', 0.0226, 'lps'),
	(394850, 102, '2015-02-15 00:16:27.000000', 'consum', 0.0215, 'lps'),
	(394851, 102, '2015-02-15 00:16:28.000000', 'consum', 0.0228, 'lps'),
	(394852, 102, '2015-02-15 00:16:29.000000', 'consum', 0.0227, 'lps'),
	(394853, 102, '2015-02-15 00:16:30.000000', 'consum', 0.0220, 'lps'),
	(394854, 102, '2015-02-15 00:16:31.000000', 'consum', 0.0228, 'lps'),
	(394855, 102, '2015-02-15 00:16:32.000000', 'consum', 0.0213, 'lps'),
	(394856, 102, '2015-02-15 00:16:33.000000', 'consum', 0.0211, 'lps'),
	(394857, 102, '2015-02-15 00:16:34.000000', 'consum', 0.0227, 'lps'),
	(394858, 102, '2015-02-15 00:16:35.000000', 'consum', 0.0214, 'lps'),
	(394859, 102, '2015-02-15 00:16:36.000000', 'consum', 0.0217, 'lps'),
	(394860, 102, '2015-02-15 00:16:37.000000', 'consum', 0.0216, 'lps'),
	(394861, 102, '2015-02-15 00:16:38.000000', 'consum', 0.0219, 'lps'),
	(394862, 102, '2015-02-15 00:16:39.000000', 'consum', 0.0217, 'lps'),
	(394863, 102, '2015-02-15 00:16:40.000000', 'consum', 0.0218, 'lps'),
	(394864, 102, '2015-02-15 00:16:41.000000', 'consum', 0.0210, 'lps'),
	(394865, 102, '2015-02-15 00:16:42.000000', 'consum', 0.0228, 'lps'),
	(394866, 102, '2015-02-15 00:16:43.000000', 'consum', 0.0220, 'lps'),
	(394867, 102, '2015-02-15 00:16:44.000000', 'consum', 0.0225, 'lps'),
	(394868, 102, '2015-02-15 00:16:45.000000', 'consum', 0.0218, 'lps'),
	(394869, 102, '2015-02-15 00:16:46.000000', 'consum', 0.0222, 'lps'),
	(394870, 102, '2015-02-15 00:16:47.000000', 'consum', 0.0210, 'lps'),
	(394871, 102, '2015-02-15 00:16:48.000000', 'consum', 0.0212, 'lps'),
	(394872, 102, '2015-02-15 00:16:49.000000', 'consum', 0.0221, 'lps'),
	(394873, 102, '2015-02-15 00:16:50.000000', 'consum', 0.0222, 'lps'),
	(394874, 102, '2015-02-15 00:16:51.000000', 'consum', 0.0215, 'lps'),
	(394875, 102, '2015-02-15 00:16:52.000000', 'consum', 0.0219, 'lps'),
	(394876, 102, '2015-02-15 00:16:53.000000', 'consum', 0.0223, 'lps'),
	(394877, 102, '2015-02-15 00:16:54.000000', 'consum', 0.0225, 'lps'),
	(394878, 102, '2015-02-15 00:16:55.000000', 'consum', 0.0210, 'lps'),
	(394879, 102, '2015-02-15 00:16:56.000000', 'consum', 0.0224, 'lps'),
	(394880, 102, '2015-02-15 00:16:57.000000', 'consum', 0.0221, 'lps'),
	(394881, 102, '2015-02-15 00:16:58.000000', 'consum', 0.0224, 'lps'),
	(394882, 102, '2015-02-15 00:16:59.000000', 'consum', 0.0228, 'lps'),
	(394883, 102, '2015-02-15 00:17:00.000000', 'consum', 0.0219, 'lps'),
	(394884, 102, '2015-02-15 00:17:01.000000', 'consum', 0.0219, 'lps'),
	(394885, 102, '2015-02-15 00:17:02.000000', 'consum', 0.0229, 'lps'),
	(394886, 102, '2015-02-15 00:17:03.000000', 'consum', 0.0221, 'lps'),
	(394887, 102, '2015-02-15 00:17:04.000000', 'consum', 0.0227, 'lps'),
	(394888, 102, '2015-02-15 00:17:05.000000', 'consum', 0.0221, 'lps'),
	(394889, 102, '2015-02-15 00:17:06.000000', 'consum', 0.0215, 'lps'),
	(394890, 102, '2015-02-15 00:17:07.000000', 'consum', 0.0224, 'lps'),
	(394891, 102, '2015-02-15 00:17:08.000000', 'consum', 0.0227, 'lps'),
	(394892, 102, '2015-02-15 00:17:09.000000', 'consum', 0.0211, 'lps'),
	(394893, 102, '2015-02-15 00:17:10.000000', 'consum', 0.0226, 'lps'),
	(394894, 102, '2015-02-15 00:17:11.000000', 'consum', 0.0228, 'lps'),
	(394895, 102, '2015-02-15 00:17:12.000000', 'consum', 0.0214, 'lps'),
	(394896, 102, '2015-02-15 00:17:13.000000', 'consum', 0.0214, 'lps'),
	(394897, 102, '2015-02-15 00:17:14.000000', 'consum', 0.0220, 'lps'),
	(394898, 102, '2015-02-15 00:17:15.000000', 'consum', 0.0227, 'lps'),
	(394899, 102, '2015-02-15 00:17:16.000000', 'consum', 0.0226, 'lps'),
	(394900, 102, '2015-02-15 00:17:17.000000', 'consum', 0.0218, 'lps'),
	(394901, 102, '2015-02-15 00:17:18.000000', 'consum', 0.0223, 'lps'),
	(394902, 102, '2015-02-15 00:17:19.000000', 'consum', 0.0210, 'lps'),
	(394903, 102, '2015-02-15 00:17:20.000000', 'consum', 0.0214, 'lps'),
	(394904, 102, '2015-02-15 00:17:21.000000', 'consum', 0.0229, 'lps'),
	(394905, 102, '2015-02-15 00:17:22.000000', 'consum', 0.0214, 'lps'),
	(394906, 102, '2015-02-15 00:17:23.000000', 'consum', 0.0214, 'lps'),
	(394907, 102, '2015-02-15 00:17:24.000000', 'consum', 0.0220, 'lps'),
	(394908, 102, '2015-02-15 00:17:25.000000', 'consum', 0.0228, 'lps'),
	(394909, 102, '2015-02-15 00:17:26.000000', 'consum', 0.0210, 'lps'),
	(394910, 102, '2015-02-15 00:17:27.000000', 'consum', 0.0216, 'lps'),
	(394911, 102, '2015-02-15 00:17:28.000000', 'consum', 0.0222, 'lps'),
	(394912, 102, '2015-02-15 00:17:29.000000', 'consum', 0.0213, 'lps'),
	(394913, 102, '2015-02-15 00:17:30.000000', 'consum', 0.0227, 'lps'),
	(394914, 102, '2015-02-15 00:17:31.000000', 'consum', 0.0228, 'lps'),
	(394915, 102, '2015-02-15 00:17:32.000000', 'consum', 0.0228, 'lps'),
	(394916, 102, '2015-02-15 00:17:33.000000', 'consum', 0.0226, 'lps'),
	(394917, 102, '2015-02-15 00:17:34.000000', 'consum', 0.0215, 'lps'),
	(394918, 102, '2015-02-15 00:17:35.000000', 'consum', 0.0210, 'lps'),
	(394919, 102, '2015-02-15 00:17:36.000000', 'consum', 0.0217, 'lps'),
	(394920, 102, '2015-02-15 00:17:37.000000', 'consum', 0.0224, 'lps'),
	(394921, 102, '2015-02-15 00:17:38.000000', 'consum', 0.0220, 'lps'),
	(394922, 102, '2015-02-15 00:17:39.000000', 'consum', 0.0218, 'lps'),
	(394923, 102, '2015-02-15 00:17:40.000000', 'consum', 0.0220, 'lps'),
	(394924, 102, '2015-02-15 00:17:41.000000', 'consum', 0.0219, 'lps'),
	(394925, 102, '2015-02-15 00:17:42.000000', 'consum', 0.0224, 'lps'),
	(394926, 102, '2015-02-15 00:17:43.000000', 'consum', 0.0215, 'lps'),
	(394927, 102, '2015-02-15 00:17:44.000000', 'consum', 0.0211, 'lps'),
	(394928, 102, '2015-02-15 00:17:45.000000', 'consum', 0.0223, 'lps'),
	(394929, 102, '2015-02-15 00:17:46.000000', 'consum', 0.0211, 'lps'),
	(394930, 102, '2015-02-15 00:17:47.000000', 'consum', 0.0216, 'lps'),
	(394931, 102, '2015-02-15 00:17:48.000000', 'consum', 0.0218, 'lps'),
	(394932, 102, '2015-02-15 00:17:49.000000', 'consum', 0.0211, 'lps'),
	(394933, 102, '2015-02-15 00:17:50.000000', 'consum', 0.0212, 'lps'),
	(394934, 102, '2015-02-15 00:17:51.000000', 'consum', 0.0217, 'lps'),
	(394935, 102, '2015-02-15 00:17:52.000000', 'consum', 0.0218, 'lps'),
	(394936, 102, '2015-02-15 00:17:53.000000', 'consum', 0.0211, 'lps'),
	(394937, 102, '2015-02-15 00:17:54.000000', 'consum', 0.0212, 'lps'),
	(394938, 102, '2015-02-15 00:17:55.000000', 'consum', 0.0218, 'lps'),
	(394939, 102, '2015-02-15 00:17:56.000000', 'consum', 0.0226, 'lps'),
	(394940, 102, '2015-02-15 00:17:57.000000', 'consum', 0.0225, 'lps'),
	(394941, 102, '2015-02-15 00:17:58.000000', 'consum', 0.0216, 'lps'),
	(394942, 102, '2015-02-15 00:17:59.000000', 'consum', 0.0215, 'lps'),
	(394943, 102, '2015-02-15 00:18:00.000000', 'consum', 0.0220, 'lps'),
	(394944, 102, '2015-02-15 00:18:01.000000', 'consum', 0.0223, 'lps'),
	(394945, 102, '2015-02-15 00:18:02.000000', 'consum', 0.0228, 'lps'),
	(394946, 102, '2015-02-15 00:18:03.000000', 'consum', 0.0220, 'lps'),
	(394947, 102, '2015-02-15 00:18:04.000000', 'consum', 0.0229, 'lps'),
	(394948, 102, '2015-02-15 00:18:05.000000', 'consum', 0.0212, 'lps'),
	(394949, 102, '2015-02-15 00:18:06.000000', 'consum', 0.0226, 'lps'),
	(394950, 102, '2015-02-15 00:18:07.000000', 'consum', 0.0224, 'lps'),
	(394951, 102, '2015-02-15 00:18:08.000000', 'consum', 0.0212, 'lps'),
	(394952, 102, '2015-02-15 00:18:09.000000', 'consum', 0.0218, 'lps'),
	(394953, 102, '2015-02-15 00:18:10.000000', 'consum', 0.0224, 'lps'),
	(394954, 102, '2015-02-15 00:18:11.000000', 'consum', 0.0219, 'lps'),
	(394955, 102, '2015-02-15 00:18:12.000000', 'consum', 0.0214, 'lps'),
	(394956, 102, '2015-02-15 00:18:13.000000', 'consum', 0.0220, 'lps'),
	(394957, 102, '2015-02-15 00:18:14.000000', 'consum', 0.0211, 'lps'),
	(394958, 102, '2015-02-15 00:18:15.000000', 'consum', 0.0224, 'lps'),
	(394959, 102, '2015-02-15 00:18:16.000000', 'consum', 0.0217, 'lps'),
	(394960, 102, '2015-02-15 00:18:17.000000', 'consum', 0.0226, 'lps'),
	(394961, 102, '2015-02-15 00:18:18.000000', 'consum', 0.0228, 'lps'),
	(394962, 102, '2015-02-15 00:18:19.000000', 'consum', 0.0211, 'lps'),
	(394963, 102, '2015-02-15 00:18:20.000000', 'consum', 0.0223, 'lps'),
	(394964, 102, '2015-02-15 00:18:21.000000', 'consum', 0.0210, 'lps'),
	(394965, 102, '2015-02-15 00:18:22.000000', 'consum', 0.0215, 'lps'),
	(394966, 102, '2015-02-15 00:18:23.000000', 'consum', 0.0213, 'lps'),
	(394967, 102, '2015-02-15 00:18:24.000000', 'consum', 0.0211, 'lps'),
	(394968, 102, '2015-02-15 00:18:25.000000', 'consum', 0.0227, 'lps'),
	(394969, 102, '2015-02-15 00:18:26.000000', 'consum', 0.0211, 'lps'),
	(394970, 102, '2015-02-15 00:18:27.000000', 'consum', 0.0225, 'lps'),
	(394971, 102, '2015-02-15 00:18:28.000000', 'consum', 0.0221, 'lps'),
	(394972, 102, '2015-02-15 00:18:29.000000', 'consum', 0.0223, 'lps'),
	(394973, 102, '2015-02-15 00:18:30.000000', 'consum', 0.0220, 'lps'),
	(394974, 102, '2015-02-15 00:18:31.000000', 'consum', 0.0221, 'lps'),
	(394975, 102, '2015-02-15 00:18:32.000000', 'consum', 0.0218, 'lps'),
	(394976, 102, '2015-02-15 00:18:33.000000', 'consum', 0.0217, 'lps'),
	(394977, 102, '2015-02-15 00:18:34.000000', 'consum', 0.0223, 'lps'),
	(394978, 102, '2015-02-15 00:18:35.000000', 'consum', 0.0214, 'lps'),
	(394979, 102, '2015-02-15 00:18:36.000000', 'consum', 0.0210, 'lps'),
	(394980, 102, '2015-02-15 00:18:37.000000', 'consum', 0.0218, 'lps'),
	(394981, 102, '2015-02-15 00:18:38.000000', 'consum', 0.0211, 'lps'),
	(394982, 102, '2015-02-15 00:18:39.000000', 'consum', 0.0214, 'lps'),
	(394983, 102, '2015-02-15 00:18:40.000000', 'consum', 0.0225, 'lps'),
	(394984, 102, '2015-02-15 00:18:41.000000', 'consum', 0.0212, 'lps'),
	(394985, 102, '2015-02-15 00:18:42.000000', 'consum', 0.0218, 'lps'),
	(394986, 102, '2015-02-15 00:18:43.000000', 'consum', 0.0223, 'lps'),
	(394987, 102, '2015-02-15 00:18:44.000000', 'consum', 0.0211, 'lps'),
	(394988, 102, '2015-02-15 00:18:45.000000', 'consum', 0.0217, 'lps'),
	(394989, 102, '2015-02-15 00:18:46.000000', 'consum', 0.0221, 'lps'),
	(394990, 102, '2015-02-15 00:18:47.000000', 'consum', 0.0225, 'lps'),
	(394991, 102, '2015-02-15 00:18:48.000000', 'consum', 0.0211, 'lps'),
	(394992, 102, '2015-02-15 00:18:49.000000', 'consum', 0.0212, 'lps'),
	(394993, 102, '2015-02-15 00:18:50.000000', 'consum', 0.0216, 'lps'),
	(394994, 102, '2015-02-15 00:18:51.000000', 'consum', 0.0215, 'lps'),
	(394995, 102, '2015-02-15 00:18:52.000000', 'consum', 0.0217, 'lps'),
	(394996, 102, '2015-02-15 00:18:53.000000', 'consum', 0.0213, 'lps'),
	(394997, 102, '2015-02-15 00:18:54.000000', 'consum', 0.0223, 'lps'),
	(394998, 102, '2015-02-15 00:18:55.000000', 'consum', 0.0227, 'lps'),
	(394999, 102, '2015-02-15 00:18:56.000000', 'consum', 0.0214, 'lps'),
	(395000, 102, '2015-02-15 00:18:57.000000', 'consum', 0.0222, 'lps'),
	(395001, 102, '2015-02-15 00:18:58.000000', 'consum', 0.0219, 'lps'),
	(395002, 102, '2015-02-15 00:18:59.000000', 'consum', 0.0220, 'lps'),
	(395003, 102, '2015-02-15 00:19:00.000000', 'consum', 0.0213, 'lps'),
	(395004, 102, '2015-02-15 00:19:01.000000', 'consum', 0.0215, 'lps'),
	(395005, 102, '2015-02-15 00:19:02.000000', 'consum', 0.0225, 'lps'),
	(395006, 102, '2015-02-15 00:19:03.000000', 'consum', 0.0211, 'lps'),
	(395007, 102, '2015-02-15 00:19:04.000000', 'consum', 0.0211, 'lps'),
	(395008, 102, '2015-02-15 00:19:05.000000', 'consum', 0.0212, 'lps'),
	(395009, 102, '2015-02-15 00:19:06.000000', 'consum', 0.0217, 'lps'),
	(395010, 102, '2015-02-15 00:19:07.000000', 'consum', 0.0220, 'lps'),
	(395011, 102, '2015-02-15 00:19:08.000000', 'consum', 0.0218, 'lps'),
	(395012, 102, '2015-02-15 00:19:09.000000', 'consum', 0.0220, 'lps'),
	(395013, 102, '2015-02-15 00:19:10.000000', 'consum', 0.0220, 'lps'),
	(395014, 102, '2015-02-15 00:19:11.000000', 'consum', 0.0227, 'lps'),
	(395015, 102, '2015-02-15 00:19:12.000000', 'consum', 0.0225, 'lps'),
	(395016, 102, '2015-02-15 00:19:13.000000', 'consum', 0.0218, 'lps'),
	(395017, 102, '2015-02-15 00:19:14.000000', 'consum', 0.0223, 'lps'),
	(395018, 102, '2015-02-15 00:19:15.000000', 'consum', 0.0211, 'lps'),
	(395019, 102, '2015-02-15 00:19:16.000000', 'consum', 0.0215, 'lps'),
	(395020, 102, '2015-02-15 00:19:17.000000', 'consum', 0.0216, 'lps'),
	(395021, 102, '2015-02-15 00:19:18.000000', 'consum', 0.0224, 'lps'),
	(395022, 102, '2015-02-15 00:19:19.000000', 'consum', 0.0221, 'lps'),
	(395023, 102, '2015-02-15 00:19:20.000000', 'consum', 0.0224, 'lps'),
	(395024, 102, '2015-02-15 00:19:21.000000', 'consum', 0.0227, 'lps'),
	(395025, 102, '2015-02-15 00:19:22.000000', 'consum', 0.0215, 'lps'),
	(395026, 102, '2015-02-15 00:19:23.000000', 'consum', 0.0224, 'lps'),
	(395027, 102, '2015-02-15 00:19:24.000000', 'consum', 0.0224, 'lps'),
	(395028, 102, '2015-02-15 00:19:25.000000', 'consum', 0.0218, 'lps'),
	(395029, 102, '2015-02-15 00:19:26.000000', 'consum', 0.0228, 'lps'),
	(395030, 102, '2015-02-15 00:19:27.000000', 'consum', 0.0218, 'lps'),
	(395031, 102, '2015-02-15 00:19:28.000000', 'consum', 0.0217, 'lps'),
	(395032, 102, '2015-02-15 00:19:29.000000', 'consum', 0.0220, 'lps'),
	(395033, 102, '2015-02-15 00:19:30.000000', 'consum', 0.0220, 'lps'),
	(395034, 102, '2015-02-15 00:19:31.000000', 'consum', 0.0213, 'lps'),
	(395035, 102, '2015-02-15 00:19:32.000000', 'consum', 0.0213, 'lps'),
	(395036, 102, '2015-02-15 00:19:33.000000', 'consum', 0.0215, 'lps'),
	(395037, 102, '2015-02-15 00:19:34.000000', 'consum', 0.0228, 'lps'),
	(395038, 102, '2015-02-15 00:19:35.000000', 'consum', 0.0225, 'lps'),
	(395039, 102, '2015-02-15 00:19:36.000000', 'consum', 0.0212, 'lps'),
	(395040, 102, '2015-02-15 00:19:37.000000', 'consum', 0.0216, 'lps'),
	(395041, 102, '2015-02-15 00:19:38.000000', 'consum', 0.0216, 'lps'),
	(395042, 102, '2015-02-15 00:19:39.000000', 'consum', 0.0221, 'lps'),
	(395043, 102, '2015-02-15 00:19:40.000000', 'consum', 0.0226, 'lps'),
	(395044, 102, '2015-02-15 00:19:41.000000', 'consum', 0.0218, 'lps'),
	(395045, 102, '2015-02-15 00:19:42.000000', 'consum', 0.0223, 'lps'),
	(395046, 102, '2015-02-15 00:19:43.000000', 'consum', 0.0212, 'lps'),
	(395047, 102, '2015-02-15 00:19:44.000000', 'consum', 0.0220, 'lps'),
	(395048, 102, '2015-02-15 00:19:45.000000', 'consum', 0.0216, 'lps'),
	(395049, 102, '2015-02-15 00:19:46.000000', 'consum', 0.0212, 'lps'),
	(395050, 102, '2015-02-15 00:19:47.000000', 'consum', 0.0222, 'lps'),
	(395051, 102, '2015-02-15 00:19:48.000000', 'consum', 0.0223, 'lps'),
	(395052, 102, '2015-02-15 00:19:49.000000', 'consum', 0.0219, 'lps'),
	(395053, 102, '2015-02-15 00:19:50.000000', 'consum', 0.0217, 'lps'),
	(395054, 102, '2015-02-15 00:19:51.000000', 'consum', 0.0218, 'lps'),
	(395055, 102, '2015-02-15 00:19:52.000000', 'consum', 0.0210, 'lps'),
	(395056, 102, '2015-02-15 00:19:53.000000', 'consum', 0.0225, 'lps'),
	(395057, 102, '2015-02-15 00:19:54.000000', 'consum', 0.0228, 'lps'),
	(395058, 102, '2015-02-15 00:19:55.000000', 'consum', 0.0216, 'lps'),
	(395059, 102, '2015-02-15 00:19:56.000000', 'consum', 0.0227, 'lps'),
	(395060, 102, '2015-02-15 00:19:57.000000', 'consum', 0.0214, 'lps'),
	(395061, 102, '2015-02-15 00:19:58.000000', 'consum', 0.0223, 'lps'),
	(395062, 102, '2015-02-15 00:19:59.000000', 'consum', 0.0222, 'lps'),
	(395063, 102, '2015-02-15 00:20:00.000000', 'consum', 0.0212, 'lps'),
	(395064, 102, '2015-02-15 00:20:01.000000', 'consum', 0.0225, 'lps'),
	(395065, 102, '2015-02-15 00:20:02.000000', 'consum', 0.0218, 'lps'),
	(395066, 102, '2015-02-15 00:20:03.000000', 'consum', 0.0225, 'lps'),
	(395067, 102, '2015-02-15 00:20:04.000000', 'consum', 0.0220, 'lps'),
	(395068, 102, '2015-02-15 00:20:05.000000', 'consum', 0.0219, 'lps'),
	(395069, 102, '2015-02-15 00:20:06.000000', 'consum', 0.0225, 'lps'),
	(395070, 102, '2015-02-15 00:20:07.000000', 'consum', 0.0218, 'lps'),
	(395071, 102, '2015-02-15 00:20:08.000000', 'consum', 0.0226, 'lps'),
	(395072, 102, '2015-02-15 00:20:09.000000', 'consum', 0.0226, 'lps'),
	(395073, 102, '2015-02-15 00:20:10.000000', 'consum', 0.0223, 'lps'),
	(395074, 102, '2015-02-15 00:20:11.000000', 'consum', 0.0225, 'lps'),
	(395075, 102, '2015-02-15 00:20:12.000000', 'consum', 0.0229, 'lps'),
	(395076, 102, '2015-02-15 00:20:13.000000', 'consum', 0.0218, 'lps'),
	(395077, 102, '2015-02-15 00:20:14.000000', 'consum', 0.0215, 'lps'),
	(395078, 102, '2015-02-15 00:20:15.000000', 'consum', 0.0210, 'lps'),
	(395079, 102, '2015-02-15 00:20:16.000000', 'consum', 0.0217, 'lps'),
	(395080, 102, '2015-02-15 00:20:17.000000', 'consum', 0.0226, 'lps'),
	(395081, 102, '2015-02-15 00:20:18.000000', 'consum', 0.0228, 'lps'),
	(395082, 102, '2015-02-15 00:20:19.000000', 'consum', 0.0213, 'lps'),
	(395083, 102, '2015-02-15 00:20:20.000000', 'consum', 0.0213, 'lps'),
	(395084, 102, '2015-02-15 00:20:21.000000', 'consum', 0.0216, 'lps'),
	(395085, 102, '2015-02-15 00:20:22.000000', 'consum', 0.0210, 'lps'),
	(395086, 102, '2015-02-15 00:20:23.000000', 'consum', 0.0213, 'lps'),
	(395087, 102, '2015-02-15 00:20:24.000000', 'consum', 0.0227, 'lps'),
	(395088, 102, '2015-02-15 00:20:25.000000', 'consum', 0.0226, 'lps'),
	(395089, 102, '2015-02-15 00:20:26.000000', 'consum', 0.0220, 'lps'),
	(395090, 102, '2015-02-15 00:20:27.000000', 'consum', 0.0210, 'lps'),
	(395091, 102, '2015-02-15 00:20:28.000000', 'consum', 0.0223, 'lps'),
	(395092, 102, '2015-02-15 00:20:29.000000', 'consum', 0.0217, 'lps'),
	(395093, 102, '2015-02-15 00:20:30.000000', 'consum', 0.0223, 'lps'),
	(395094, 102, '2015-02-15 00:20:31.000000', 'consum', 0.0216, 'lps'),
	(395095, 102, '2015-02-15 00:20:32.000000', 'consum', 0.0222, 'lps'),
	(395096, 102, '2015-02-15 00:20:33.000000', 'consum', 0.0213, 'lps'),
	(395097, 102, '2015-02-15 00:20:34.000000', 'consum', 0.0229, 'lps'),
	(395098, 102, '2015-02-15 00:20:35.000000', 'consum', 0.0217, 'lps'),
	(395099, 102, '2015-02-15 00:20:36.000000', 'consum', 0.0229, 'lps'),
	(395100, 102, '2015-02-15 00:20:37.000000', 'consum', 0.0224, 'lps'),
	(395101, 102, '2015-02-15 00:20:38.000000', 'consum', 0.0224, 'lps'),
	(395102, 102, '2015-02-15 00:20:39.000000', 'consum', 0.0218, 'lps'),
	(395103, 102, '2015-02-15 00:20:40.000000', 'consum', 0.0210, 'lps'),
	(395104, 102, '2015-02-15 00:20:41.000000', 'consum', 0.0227, 'lps'),
	(395105, 102, '2015-02-15 00:20:42.000000', 'consum', 0.0214, 'lps'),
	(395106, 102, '2015-02-15 00:20:43.000000', 'consum', 0.0219, 'lps'),
	(395107, 102, '2015-02-15 00:20:44.000000', 'consum', 0.0224, 'lps'),
	(395108, 102, '2015-02-15 00:20:45.000000', 'consum', 0.0211, 'lps'),
	(395109, 102, '2015-02-15 00:20:46.000000', 'consum', 0.0217, 'lps'),
	(395110, 102, '2015-02-15 00:20:47.000000', 'consum', 0.0222, 'lps'),
	(395111, 102, '2015-02-15 00:20:48.000000', 'consum', 0.0229, 'lps'),
	(395112, 102, '2015-02-15 00:20:49.000000', 'consum', 0.0229, 'lps'),
	(395113, 102, '2015-02-15 00:20:50.000000', 'consum', 0.0228, 'lps'),
	(395114, 102, '2015-02-15 00:20:51.000000', 'consum', 0.0224, 'lps'),
	(395115, 102, '2015-02-15 00:20:52.000000', 'consum', 0.0225, 'lps'),
	(395116, 102, '2015-02-15 00:20:53.000000', 'consum', 0.0225, 'lps'),
	(395117, 102, '2015-02-15 00:20:54.000000', 'consum', 0.0222, 'lps'),
	(395118, 102, '2015-02-15 00:20:55.000000', 'consum', 0.0224, 'lps'),
	(395119, 102, '2015-02-15 00:20:56.000000', 'consum', 0.0224, 'lps'),
	(395120, 102, '2015-02-15 00:20:57.000000', 'consum', 0.0219, 'lps'),
	(395121, 102, '2015-02-15 00:20:58.000000', 'consum', 0.0214, 'lps'),
	(395122, 102, '2015-02-15 00:20:59.000000', 'consum', 0.0225, 'lps'),
	(395123, 102, '2015-02-15 00:21:00.000000', 'consum', 0.0213, 'lps'),
	(395124, 102, '2015-02-15 00:21:01.000000', 'consum', 0.0218, 'lps'),
	(395125, 102, '2015-02-15 00:21:02.000000', 'consum', 0.0224, 'lps'),
	(395126, 102, '2015-02-15 00:21:03.000000', 'consum', 0.0217, 'lps'),
	(395127, 102, '2015-02-15 00:21:04.000000', 'consum', 0.0221, 'lps'),
	(395128, 102, '2015-02-15 00:21:05.000000', 'consum', 0.0224, 'lps'),
	(395129, 102, '2015-02-15 00:21:06.000000', 'consum', 0.0210, 'lps'),
	(395130, 102, '2015-02-15 00:21:07.000000', 'consum', 0.0226, 'lps'),
	(395131, 102, '2015-02-15 00:21:08.000000', 'consum', 0.0211, 'lps'),
	(395132, 102, '2015-02-15 00:21:09.000000', 'consum', 0.0229, 'lps'),
	(395133, 102, '2015-02-15 00:21:10.000000', 'consum', 0.0220, 'lps'),
	(395134, 102, '2015-02-15 00:21:11.000000', 'consum', 0.0225, 'lps'),
	(395135, 102, '2015-02-15 00:21:12.000000', 'consum', 0.0217, 'lps'),
	(395136, 102, '2015-02-15 00:21:13.000000', 'consum', 0.0218, 'lps'),
	(395137, 102, '2015-02-15 00:21:14.000000', 'consum', 0.0210, 'lps'),
	(395138, 102, '2015-02-15 00:21:15.000000', 'consum', 0.0228, 'lps'),
	(395139, 102, '2015-02-15 00:21:16.000000', 'consum', 0.0220, 'lps'),
	(395140, 102, '2015-02-15 00:21:17.000000', 'consum', 0.0224, 'lps'),
	(395141, 102, '2015-02-15 00:21:18.000000', 'consum', 0.0213, 'lps'),
	(395142, 102, '2015-02-15 00:21:19.000000', 'consum', 0.0221, 'lps'),
	(395143, 102, '2015-02-15 00:21:20.000000', 'consum', 0.0218, 'lps'),
	(395144, 102, '2015-02-15 00:21:21.000000', 'consum', 0.0217, 'lps'),
	(395145, 102, '2015-02-15 00:21:22.000000', 'consum', 0.0220, 'lps'),
	(395146, 102, '2015-02-15 00:21:23.000000', 'consum', 0.0220, 'lps'),
	(395147, 102, '2015-02-15 00:21:24.000000', 'consum', 0.0212, 'lps'),
	(395148, 102, '2015-02-15 00:21:25.000000', 'consum', 0.0211, 'lps'),
	(395149, 102, '2015-02-15 00:21:26.000000', 'consum', 0.0228, 'lps'),
	(395150, 102, '2015-02-15 00:21:27.000000', 'consum', 0.0220, 'lps'),
	(395151, 102, '2015-02-15 00:21:28.000000', 'consum', 0.0224, 'lps'),
	(395152, 102, '2015-02-15 00:21:29.000000', 'consum', 0.0212, 'lps'),
	(395153, 102, '2015-02-15 00:21:30.000000', 'consum', 0.0219, 'lps'),
	(395154, 102, '2015-02-15 00:21:31.000000', 'consum', 0.0228, 'lps'),
	(395155, 102, '2015-02-15 00:21:32.000000', 'consum', 0.0213, 'lps'),
	(395156, 102, '2015-02-15 00:21:33.000000', 'consum', 0.0212, 'lps'),
	(395157, 102, '2015-02-15 00:21:34.000000', 'consum', 0.0212, 'lps'),
	(395158, 102, '2015-02-15 00:21:35.000000', 'consum', 0.0216, 'lps'),
	(395159, 102, '2015-02-15 00:21:36.000000', 'consum', 0.0212, 'lps'),
	(395160, 102, '2015-02-15 00:21:37.000000', 'consum', 0.0222, 'lps'),
	(395161, 102, '2015-02-15 00:21:38.000000', 'consum', 0.0227, 'lps'),
	(395162, 102, '2015-02-15 00:21:39.000000', 'consum', 0.0219, 'lps'),
	(395163, 102, '2015-02-15 00:21:40.000000', 'consum', 0.0223, 'lps'),
	(395164, 102, '2015-02-15 00:21:41.000000', 'consum', 0.0211, 'lps'),
	(395165, 102, '2015-02-15 00:21:42.000000', 'consum', 0.0215, 'lps'),
	(395166, 102, '2015-02-15 00:21:43.000000', 'consum', 0.0215, 'lps'),
	(395167, 102, '2015-02-15 00:21:44.000000', 'consum', 0.0218, 'lps'),
	(395168, 102, '2015-02-15 00:21:45.000000', 'consum', 0.0215, 'lps'),
	(395169, 102, '2015-02-15 00:21:46.000000', 'consum', 0.0213, 'lps'),
	(395170, 102, '2015-02-15 00:21:47.000000', 'consum', 0.0211, 'lps'),
	(395171, 102, '2015-02-15 00:21:48.000000', 'consum', 0.0226, 'lps'),
	(395172, 102, '2015-02-15 00:21:49.000000', 'consum', 0.0227, 'lps'),
	(395173, 102, '2015-02-15 00:21:50.000000', 'consum', 0.0229, 'lps'),
	(395174, 102, '2015-02-15 00:21:51.000000', 'consum', 0.0213, 'lps'),
	(395175, 102, '2015-02-15 00:21:52.000000', 'consum', 0.0229, 'lps'),
	(395176, 102, '2015-02-15 00:21:53.000000', 'consum', 0.0215, 'lps'),
	(395177, 102, '2015-02-15 00:21:54.000000', 'consum', 0.0220, 'lps'),
	(395178, 102, '2015-02-15 00:21:55.000000', 'consum', 0.0224, 'lps'),
	(395179, 102, '2015-02-15 00:21:56.000000', 'consum', 0.0211, 'lps'),
	(395180, 102, '2015-02-15 00:21:57.000000', 'consum', 0.0213, 'lps'),
	(395181, 102, '2015-02-15 00:21:58.000000', 'consum', 0.0225, 'lps'),
	(395182, 102, '2015-02-15 00:21:59.000000', 'consum', 0.0215, 'lps'),
	(395183, 102, '2015-02-15 00:22:00.000000', 'consum', 0.0229, 'lps'),
	(395184, 102, '2015-02-15 00:22:01.000000', 'consum', 0.0211, 'lps'),
	(395185, 102, '2015-02-15 00:22:02.000000', 'consum', 0.0219, 'lps'),
	(395186, 102, '2015-02-15 00:22:03.000000', 'consum', 0.0211, 'lps'),
	(395187, 102, '2015-02-15 00:22:04.000000', 'consum', 0.0210, 'lps'),
	(395188, 102, '2015-02-15 00:22:05.000000', 'consum', 0.0225, 'lps'),
	(395189, 102, '2015-02-15 00:22:06.000000', 'consum', 0.0228, 'lps'),
	(395190, 102, '2015-02-15 00:22:07.000000', 'consum', 0.0217, 'lps'),
	(395191, 102, '2015-02-15 00:22:08.000000', 'consum', 0.0229, 'lps'),
	(395192, 102, '2015-02-15 00:22:09.000000', 'consum', 0.0226, 'lps'),
	(395193, 102, '2015-02-15 00:22:10.000000', 'consum', 0.0213, 'lps'),
	(395194, 102, '2015-02-15 00:22:11.000000', 'consum', 0.0216, 'lps'),
	(395195, 102, '2015-02-15 00:22:12.000000', 'consum', 0.0214, 'lps'),
	(395196, 102, '2015-02-15 00:22:13.000000', 'consum', 0.0210, 'lps'),
	(395197, 102, '2015-02-15 00:22:14.000000', 'consum', 0.0218, 'lps'),
	(395198, 102, '2015-02-15 00:22:15.000000', 'consum', 0.0212, 'lps'),
	(395199, 102, '2015-02-15 00:22:16.000000', 'consum', 0.0217, 'lps'),
	(395200, 102, '2015-02-15 00:22:17.000000', 'consum', 0.0218, 'lps'),
	(395201, 102, '2015-02-15 00:22:18.000000', 'consum', 0.0210, 'lps'),
	(395202, 102, '2015-02-15 00:22:19.000000', 'consum', 0.0228, 'lps'),
	(395203, 102, '2015-02-15 00:22:20.000000', 'consum', 0.0218, 'lps'),
	(395204, 102, '2015-02-15 00:22:21.000000', 'consum', 0.0219, 'lps'),
	(395205, 102, '2015-02-15 00:22:22.000000', 'consum', 0.0210, 'lps'),
	(395206, 102, '2015-02-15 00:22:23.000000', 'consum', 0.0223, 'lps'),
	(395207, 102, '2015-02-15 00:22:24.000000', 'consum', 0.0216, 'lps'),
	(395208, 102, '2015-02-15 00:22:25.000000', 'consum', 0.0221, 'lps'),
	(395209, 102, '2015-02-15 00:22:26.000000', 'consum', 0.0226, 'lps'),
	(395210, 102, '2015-02-15 00:22:27.000000', 'consum', 0.0220, 'lps'),
	(395211, 102, '2015-02-15 00:22:28.000000', 'consum', 0.0211, 'lps'),
	(395212, 102, '2015-02-15 00:22:29.000000', 'consum', 0.0228, 'lps'),
	(395213, 102, '2015-02-15 00:22:30.000000', 'consum', 0.0215, 'lps'),
	(395214, 102, '2015-02-15 00:22:31.000000', 'consum', 0.0221, 'lps'),
	(395215, 102, '2015-02-15 00:22:32.000000', 'consum', 0.0210, 'lps'),
	(395216, 102, '2015-02-15 00:22:33.000000', 'consum', 0.0217, 'lps'),
	(395217, 102, '2015-02-15 00:22:34.000000', 'consum', 0.0228, 'lps'),
	(395218, 102, '2015-02-15 00:22:35.000000', 'consum', 0.0217, 'lps'),
	(395219, 102, '2015-02-15 00:22:36.000000', 'consum', 0.0214, 'lps'),
	(395220, 102, '2015-02-15 00:22:37.000000', 'consum', 0.0228, 'lps'),
	(395221, 102, '2015-02-15 00:22:38.000000', 'consum', 0.0229, 'lps'),
	(395222, 102, '2015-02-15 00:22:39.000000', 'consum', 0.0213, 'lps'),
	(395223, 102, '2015-02-15 00:22:40.000000', 'consum', 0.0227, 'lps'),
	(395224, 102, '2015-02-15 00:22:41.000000', 'consum', 0.0227, 'lps'),
	(395225, 102, '2015-02-15 00:22:42.000000', 'consum', 0.0222, 'lps'),
	(395226, 102, '2015-02-15 00:22:43.000000', 'consum', 0.0223, 'lps'),
	(395227, 102, '2015-02-15 00:22:44.000000', 'consum', 0.0216, 'lps'),
	(395228, 102, '2015-02-15 00:22:45.000000', 'consum', 0.0224, 'lps'),
	(395229, 102, '2015-02-15 00:22:46.000000', 'consum', 0.0221, 'lps'),
	(395230, 102, '2015-02-15 00:22:47.000000', 'consum', 0.0223, 'lps'),
	(395231, 102, '2015-02-15 00:22:48.000000', 'consum', 0.0224, 'lps'),
	(395232, 102, '2015-02-15 00:22:49.000000', 'consum', 0.0219, 'lps'),
	(395233, 102, '2015-02-15 00:22:50.000000', 'consum', 0.0215, 'lps'),
	(395234, 102, '2015-02-15 00:22:51.000000', 'consum', 0.0229, 'lps'),
	(395235, 102, '2015-02-15 00:22:52.000000', 'consum', 0.0210, 'lps'),
	(395236, 102, '2015-02-15 00:22:53.000000', 'consum', 0.0214, 'lps'),
	(395237, 102, '2015-02-15 00:22:54.000000', 'consum', 0.0228, 'lps'),
	(395238, 102, '2015-02-15 00:22:55.000000', 'consum', 0.0210, 'lps'),
	(395239, 102, '2015-02-15 00:22:56.000000', 'consum', 0.0218, 'lps'),
	(395240, 102, '2015-02-15 00:22:57.000000', 'consum', 0.0211, 'lps'),
	(395241, 102, '2015-02-15 00:22:58.000000', 'consum', 0.0229, 'lps'),
	(395242, 102, '2015-02-15 00:22:59.000000', 'consum', 0.0222, 'lps'),
	(395243, 102, '2015-02-15 00:23:00.000000', 'consum', 0.0216, 'lps'),
	(395244, 102, '2015-02-15 00:23:01.000000', 'consum', 0.0225, 'lps'),
	(395245, 102, '2015-02-15 00:23:02.000000', 'consum', 0.0226, 'lps'),
	(395246, 102, '2015-02-15 00:23:03.000000', 'consum', 0.0228, 'lps'),
	(395247, 102, '2015-02-15 00:23:04.000000', 'consum', 0.0210, 'lps'),
	(395248, 102, '2015-02-15 00:23:05.000000', 'consum', 0.0217, 'lps'),
	(395249, 102, '2015-02-15 00:23:06.000000', 'consum', 0.0225, 'lps'),
	(395250, 102, '2015-02-15 00:23:07.000000', 'consum', 0.0224, 'lps'),
	(395251, 102, '2015-02-15 00:23:08.000000', 'consum', 0.0217, 'lps'),
	(395252, 102, '2015-02-15 00:23:09.000000', 'consum', 0.0224, 'lps'),
	(395253, 102, '2015-02-15 00:23:10.000000', 'consum', 0.0221, 'lps'),
	(395254, 102, '2015-02-15 00:23:11.000000', 'consum', 0.0221, 'lps'),
	(395255, 102, '2015-02-15 00:23:12.000000', 'consum', 0.0214, 'lps'),
	(395256, 102, '2015-02-15 00:23:13.000000', 'consum', 0.0218, 'lps'),
	(395257, 102, '2015-02-15 00:23:14.000000', 'consum', 0.0218, 'lps'),
	(395258, 102, '2015-02-15 00:23:15.000000', 'consum', 0.0226, 'lps'),
	(395259, 102, '2015-02-15 00:23:16.000000', 'consum', 0.0225, 'lps'),
	(395260, 102, '2015-02-15 00:23:17.000000', 'consum', 0.0218, 'lps'),
	(395261, 102, '2015-02-15 00:23:18.000000', 'consum', 0.0226, 'lps'),
	(395262, 102, '2015-02-15 00:23:19.000000', 'consum', 0.0228, 'lps'),
	(395263, 102, '2015-02-15 00:23:20.000000', 'consum', 0.0213, 'lps'),
	(395264, 102, '2015-02-15 00:23:21.000000', 'consum', 0.0211, 'lps'),
	(395265, 102, '2015-02-15 00:23:22.000000', 'consum', 0.0226, 'lps'),
	(395266, 102, '2015-02-15 00:23:23.000000', 'consum', 0.0226, 'lps'),
	(395267, 102, '2015-02-15 00:23:24.000000', 'consum', 0.0222, 'lps'),
	(395268, 102, '2015-02-15 00:23:25.000000', 'consum', 0.0223, 'lps'),
	(395269, 102, '2015-02-15 00:23:26.000000', 'consum', 0.0221, 'lps'),
	(395270, 102, '2015-02-15 00:23:27.000000', 'consum', 0.0227, 'lps'),
	(395271, 102, '2015-02-15 00:23:28.000000', 'consum', 0.0221, 'lps'),
	(395272, 102, '2015-02-15 00:23:29.000000', 'consum', 0.0215, 'lps'),
	(395273, 102, '2015-02-15 00:23:30.000000', 'consum', 0.0221, 'lps'),
	(395274, 102, '2015-02-15 00:23:31.000000', 'consum', 0.0210, 'lps'),
	(395275, 102, '2015-02-15 00:23:32.000000', 'consum', 0.0219, 'lps'),
	(395276, 102, '2015-02-15 00:23:33.000000', 'consum', 0.0216, 'lps'),
	(395277, 102, '2015-02-15 00:23:34.000000', 'consum', 0.0213, 'lps'),
	(395278, 102, '2015-02-15 00:23:35.000000', 'consum', 0.0229, 'lps'),
	(395279, 102, '2015-02-15 00:23:36.000000', 'consum', 0.0217, 'lps'),
	(395280, 102, '2015-02-15 00:23:37.000000', 'consum', 0.0226, 'lps'),
	(395281, 102, '2015-02-15 00:23:38.000000', 'consum', 0.0229, 'lps'),
	(395282, 102, '2015-02-15 00:23:39.000000', 'consum', 0.0220, 'lps'),
	(395283, 102, '2015-02-15 00:23:40.000000', 'consum', 0.0223, 'lps'),
	(395284, 102, '2015-02-15 00:23:41.000000', 'consum', 0.0223, 'lps'),
	(395285, 102, '2015-02-15 00:23:42.000000', 'consum', 0.0220, 'lps'),
	(395286, 102, '2015-02-15 00:23:43.000000', 'consum', 0.0220, 'lps'),
	(395287, 102, '2015-02-15 00:23:44.000000', 'consum', 0.0211, 'lps'),
	(395288, 102, '2015-02-15 00:23:45.000000', 'consum', 0.0225, 'lps'),
	(395289, 102, '2015-02-15 00:23:46.000000', 'consum', 0.0221, 'lps'),
	(395290, 102, '2015-02-15 00:23:47.000000', 'consum', 0.0223, 'lps'),
	(395291, 102, '2015-02-15 00:23:48.000000', 'consum', 0.0224, 'lps'),
	(395292, 102, '2015-02-15 00:23:49.000000', 'consum', 0.0219, 'lps'),
	(395293, 102, '2015-02-15 00:23:50.000000', 'consum', 0.0212, 'lps'),
	(395294, 102, '2015-02-15 00:23:51.000000', 'consum', 0.0215, 'lps'),
	(395295, 102, '2015-02-15 00:23:52.000000', 'consum', 0.0229, 'lps'),
	(395296, 102, '2015-02-15 00:23:53.000000', 'consum', 0.0210, 'lps'),
	(395297, 102, '2015-02-15 00:23:54.000000', 'consum', 0.0213, 'lps'),
	(395298, 102, '2015-02-15 00:23:55.000000', 'consum', 0.0226, 'lps'),
	(395299, 102, '2015-02-15 00:23:56.000000', 'consum', 0.0220, 'lps'),
	(395300, 102, '2015-02-15 00:23:57.000000', 'consum', 0.0215, 'lps'),
	(395301, 102, '2015-02-15 00:23:58.000000', 'consum', 0.0223, 'lps'),
	(395302, 102, '2015-02-15 00:23:59.000000', 'consum', 0.0223, 'lps'),
	(395303, 102, '2015-02-15 00:24:00.000000', 'consum', 0.0214, 'lps'),
	(395304, 102, '2015-02-15 00:24:01.000000', 'consum', 0.0214, 'lps'),
	(395305, 102, '2015-02-15 00:24:02.000000', 'consum', 0.0217, 'lps'),
	(395306, 102, '2015-02-15 00:24:03.000000', 'consum', 0.0212, 'lps'),
	(395307, 102, '2015-02-15 00:24:04.000000', 'consum', 0.0220, 'lps'),
	(395308, 102, '2015-02-15 00:24:05.000000', 'consum', 0.0213, 'lps'),
	(395309, 102, '2015-02-15 00:24:06.000000', 'consum', 0.0219, 'lps'),
	(395310, 102, '2015-02-15 00:24:07.000000', 'consum', 0.0224, 'lps'),
	(395311, 102, '2015-02-15 00:24:08.000000', 'consum', 0.0215, 'lps'),
	(395312, 102, '2015-02-15 00:24:09.000000', 'consum', 0.0211, 'lps'),
	(395313, 102, '2015-02-15 00:24:10.000000', 'consum', 0.0223, 'lps'),
	(395314, 102, '2015-02-15 00:24:11.000000', 'consum', 0.0211, 'lps'),
	(395315, 102, '2015-02-15 00:24:12.000000', 'consum', 0.0217, 'lps'),
	(395316, 102, '2015-02-15 00:24:13.000000', 'consum', 0.0222, 'lps'),
	(395317, 102, '2015-02-15 00:24:14.000000', 'consum', 0.0229, 'lps'),
	(395318, 102, '2015-02-15 00:24:15.000000', 'consum', 0.0228, 'lps'),
	(395319, 102, '2015-02-15 00:24:16.000000', 'consum', 0.0226, 'lps'),
	(395320, 102, '2015-02-15 00:24:17.000000', 'consum', 0.0215, 'lps'),
	(395321, 102, '2015-02-15 00:24:18.000000', 'consum', 0.0227, 'lps'),
	(395322, 102, '2015-02-15 00:24:19.000000', 'consum', 0.0222, 'lps'),
	(395323, 102, '2015-02-15 00:24:20.000000', 'consum', 0.0218, 'lps'),
	(395324, 102, '2015-02-15 00:24:21.000000', 'consum', 0.0214, 'lps'),
	(395325, 102, '2015-02-15 00:24:22.000000', 'consum', 0.0227, 'lps'),
	(395326, 102, '2015-02-15 00:24:23.000000', 'consum', 0.0224, 'lps'),
	(395327, 102, '2015-02-15 00:24:24.000000', 'consum', 0.0228, 'lps'),
	(395328, 102, '2015-02-15 00:24:25.000000', 'consum', 0.0220, 'lps'),
	(395329, 102, '2015-02-15 00:24:26.000000', 'consum', 0.0228, 'lps'),
	(395330, 102, '2015-02-15 00:24:27.000000', 'consum', 0.0210, 'lps'),
	(395331, 102, '2015-02-15 00:24:28.000000', 'consum', 0.0215, 'lps'),
	(395332, 102, '2015-02-15 00:24:29.000000', 'consum', 0.0216, 'lps'),
	(395333, 102, '2015-02-15 00:24:30.000000', 'consum', 0.0225, 'lps'),
	(395334, 102, '2015-02-15 00:24:31.000000', 'consum', 0.0229, 'lps'),
	(395335, 102, '2015-02-15 00:24:32.000000', 'consum', 0.0220, 'lps'),
	(395336, 102, '2015-02-15 00:24:33.000000', 'consum', 0.0223, 'lps'),
	(395337, 102, '2015-02-15 00:24:34.000000', 'consum', 0.0228, 'lps'),
	(395338, 102, '2015-02-15 00:24:35.000000', 'consum', 0.0218, 'lps'),
	(395339, 102, '2015-02-15 00:24:36.000000', 'consum', 0.0219, 'lps'),
	(395340, 102, '2015-02-15 00:24:37.000000', 'consum', 0.0213, 'lps'),
	(395341, 102, '2015-02-15 00:24:38.000000', 'consum', 0.0215, 'lps'),
	(395342, 102, '2015-02-15 00:24:39.000000', 'consum', 0.0210, 'lps'),
	(395343, 102, '2015-02-15 00:24:40.000000', 'consum', 0.0213, 'lps'),
	(395344, 102, '2015-02-15 00:24:41.000000', 'consum', 0.0228, 'lps'),
	(395345, 102, '2015-02-15 00:24:42.000000', 'consum', 0.0211, 'lps'),
	(395346, 102, '2015-02-15 00:24:43.000000', 'consum', 0.0220, 'lps'),
	(395347, 102, '2015-02-15 00:24:44.000000', 'consum', 0.0220, 'lps'),
	(395348, 102, '2015-02-15 00:24:45.000000', 'consum', 0.0211, 'lps'),
	(395349, 102, '2015-02-15 00:24:46.000000', 'consum', 0.0222, 'lps'),
	(395350, 102, '2015-02-15 00:24:47.000000', 'consum', 0.0211, 'lps'),
	(395351, 102, '2015-02-15 00:24:48.000000', 'consum', 0.0218, 'lps'),
	(395352, 102, '2015-02-15 00:24:49.000000', 'consum', 0.0210, 'lps'),
	(395353, 102, '2015-02-15 00:24:50.000000', 'consum', 0.0223, 'lps'),
	(395354, 102, '2015-02-15 00:24:51.000000', 'consum', 0.0218, 'lps'),
	(395355, 102, '2015-02-15 00:24:52.000000', 'consum', 0.0210, 'lps'),
	(395356, 102, '2015-02-15 00:24:53.000000', 'consum', 0.0226, 'lps'),
	(395357, 102, '2015-02-15 00:24:54.000000', 'consum', 0.0211, 'lps'),
	(395358, 102, '2015-02-15 00:24:55.000000', 'consum', 0.0227, 'lps'),
	(395359, 102, '2015-02-15 00:24:56.000000', 'consum', 0.0214, 'lps'),
	(395360, 102, '2015-02-15 00:24:57.000000', 'consum', 0.0220, 'lps'),
	(395361, 102, '2015-02-15 00:24:58.000000', 'consum', 0.0228, 'lps'),
	(395362, 102, '2015-02-15 00:24:59.000000', 'consum', 0.0211, 'lps'),
	(395363, 102, '2015-02-15 00:25:00.000000', 'consum', 0.0223, 'lps'),
	(395364, 102, '2015-02-15 00:25:01.000000', 'consum', 0.0229, 'lps'),
	(395365, 102, '2015-02-15 00:25:02.000000', 'consum', 0.0228, 'lps'),
	(395366, 102, '2015-02-15 00:25:03.000000', 'consum', 0.0225, 'lps'),
	(395367, 102, '2015-02-15 00:25:04.000000', 'consum', 0.0212, 'lps'),
	(395368, 102, '2015-02-15 00:25:05.000000', 'consum', 0.0216, 'lps'),
	(395369, 102, '2015-02-15 00:25:06.000000', 'consum', 0.0215, 'lps'),
	(395370, 102, '2015-02-15 00:25:07.000000', 'consum', 0.0218, 'lps'),
	(395371, 102, '2015-02-15 00:25:08.000000', 'consum', 0.0216, 'lps'),
	(395372, 102, '2015-02-15 00:25:09.000000', 'consum', 0.0214, 'lps'),
	(395373, 102, '2015-02-15 00:25:10.000000', 'consum', 0.0212, 'lps'),
	(395374, 102, '2015-02-15 00:25:11.000000', 'consum', 0.0211, 'lps'),
	(395375, 102, '2015-02-15 00:25:12.000000', 'consum', 0.0227, 'lps'),
	(395376, 102, '2015-02-15 00:25:13.000000', 'consum', 0.0213, 'lps'),
	(395377, 102, '2015-02-15 00:25:14.000000', 'consum', 0.0217, 'lps'),
	(395378, 102, '2015-02-15 00:25:15.000000', 'consum', 0.0214, 'lps'),
	(395379, 102, '2015-02-15 00:25:16.000000', 'consum', 0.0212, 'lps'),
	(395380, 102, '2015-02-15 00:25:17.000000', 'consum', 0.0228, 'lps'),
	(395381, 102, '2015-02-15 00:25:18.000000', 'consum', 0.0216, 'lps'),
	(395382, 102, '2015-02-15 00:25:19.000000', 'consum', 0.0224, 'lps'),
	(395383, 102, '2015-02-15 00:25:20.000000', 'consum', 0.0222, 'lps'),
	(395384, 102, '2015-02-15 00:25:21.000000', 'consum', 0.0210, 'lps'),
	(395385, 102, '2015-02-15 00:25:22.000000', 'consum', 0.0214, 'lps'),
	(395386, 102, '2015-02-15 00:25:23.000000', 'consum', 0.0210, 'lps'),
	(395387, 102, '2015-02-15 00:25:24.000000', 'consum', 0.0218, 'lps'),
	(395388, 102, '2015-02-15 00:25:25.000000', 'consum', 0.0211, 'lps'),
	(395389, 102, '2015-02-15 00:25:26.000000', 'consum', 0.0213, 'lps'),
	(395390, 102, '2015-02-15 00:25:27.000000', 'consum', 0.0220, 'lps'),
	(395391, 102, '2015-02-15 00:25:28.000000', 'consum', 0.0213, 'lps'),
	(395392, 102, '2015-02-15 00:25:29.000000', 'consum', 0.0213, 'lps'),
	(395393, 102, '2015-02-15 00:25:30.000000', 'consum', 0.0219, 'lps'),
	(395394, 102, '2015-02-15 00:25:31.000000', 'consum', 0.0228, 'lps'),
	(395395, 102, '2015-02-15 00:25:32.000000', 'consum', 0.0210, 'lps'),
	(395396, 102, '2015-02-15 00:25:33.000000', 'consum', 0.0219, 'lps'),
	(395397, 102, '2015-02-15 00:25:34.000000', 'consum', 0.0215, 'lps'),
	(395398, 102, '2015-02-15 00:25:35.000000', 'consum', 0.0210, 'lps'),
	(395399, 102, '2015-02-15 00:25:36.000000', 'consum', 0.0213, 'lps'),
	(395400, 102, '2015-02-15 00:25:37.000000', 'consum', 0.0225, 'lps'),
	(395401, 102, '2015-02-15 00:25:38.000000', 'consum', 0.0219, 'lps'),
	(395402, 102, '2015-02-15 00:25:39.000000', 'consum', 0.0210, 'lps'),
	(395403, 102, '2015-02-15 00:25:40.000000', 'consum', 0.0223, 'lps'),
	(395404, 102, '2015-02-15 00:25:41.000000', 'consum', 0.0215, 'lps'),
	(395405, 102, '2015-02-15 00:25:42.000000', 'consum', 0.0216, 'lps'),
	(395406, 102, '2015-02-15 00:25:43.000000', 'consum', 0.0227, 'lps'),
	(395407, 102, '2015-02-15 00:25:44.000000', 'consum', 0.0218, 'lps'),
	(395408, 102, '2015-02-15 00:25:45.000000', 'consum', 0.0217, 'lps'),
	(395409, 102, '2015-02-15 00:25:46.000000', 'consum', 0.0221, 'lps'),
	(395410, 102, '2015-02-15 00:25:47.000000', 'consum', 0.0227, 'lps'),
	(395411, 102, '2015-02-15 00:25:48.000000', 'consum', 0.0222, 'lps'),
	(395412, 102, '2015-02-15 00:25:49.000000', 'consum', 0.0218, 'lps'),
	(395413, 102, '2015-02-15 00:25:50.000000', 'consum', 0.0215, 'lps'),
	(395414, 102, '2015-02-15 00:25:51.000000', 'consum', 0.0214, 'lps'),
	(395415, 102, '2015-02-15 00:25:52.000000', 'consum', 0.0213, 'lps'),
	(395416, 102, '2015-02-15 00:25:53.000000', 'consum', 0.0212, 'lps'),
	(395417, 102, '2015-02-15 00:25:54.000000', 'consum', 0.0214, 'lps'),
	(395418, 102, '2015-02-15 00:25:55.000000', 'consum', 0.0224, 'lps'),
	(395419, 102, '2015-02-15 00:25:56.000000', 'consum', 0.0229, 'lps'),
	(395420, 102, '2015-02-15 00:25:57.000000', 'consum', 0.0222, 'lps'),
	(395421, 102, '2015-02-15 00:25:58.000000', 'consum', 0.0216, 'lps'),
	(395422, 102, '2015-02-15 00:25:59.000000', 'consum', 0.0222, 'lps'),
	(395423, 102, '2015-02-15 00:26:00.000000', 'consum', 0.0211, 'lps'),
	(395424, 102, '2015-02-15 00:26:01.000000', 'consum', 0.0223, 'lps'),
	(395425, 102, '2015-02-15 00:26:02.000000', 'consum', 0.0211, 'lps'),
	(395426, 102, '2015-02-15 00:26:03.000000', 'consum', 0.0217, 'lps'),
	(395427, 102, '2015-02-15 00:26:04.000000', 'consum', 0.0223, 'lps'),
	(395428, 102, '2015-02-15 00:26:05.000000', 'consum', 0.0212, 'lps'),
	(395429, 102, '2015-02-15 00:26:06.000000', 'consum', 0.0224, 'lps'),
	(395430, 102, '2015-02-15 00:26:07.000000', 'consum', 0.0216, 'lps'),
	(395431, 102, '2015-02-15 00:26:08.000000', 'consum', 0.0215, 'lps'),
	(395432, 102, '2015-02-15 00:26:09.000000', 'consum', 0.0220, 'lps'),
	(395433, 102, '2015-02-15 00:26:10.000000', 'consum', 0.0223, 'lps'),
	(395434, 102, '2015-02-15 00:26:11.000000', 'consum', 0.0226, 'lps'),
	(395435, 102, '2015-02-15 00:26:12.000000', 'consum', 0.0211, 'lps'),
	(395436, 102, '2015-02-15 00:26:13.000000', 'consum', 0.0229, 'lps'),
	(395437, 102, '2015-02-15 00:26:14.000000', 'consum', 0.0221, 'lps'),
	(395438, 102, '2015-02-15 00:26:15.000000', 'consum', 0.0228, 'lps'),
	(395439, 102, '2015-02-15 00:26:16.000000', 'consum', 0.0210, 'lps'),
	(395440, 102, '2015-02-15 00:26:17.000000', 'consum', 0.0216, 'lps'),
	(395441, 102, '2015-02-15 00:26:18.000000', 'consum', 0.0221, 'lps'),
	(395442, 102, '2015-02-15 00:26:19.000000', 'consum', 0.0226, 'lps'),
	(395443, 102, '2015-02-15 00:26:20.000000', 'consum', 0.0218, 'lps'),
	(395444, 102, '2015-02-15 00:26:21.000000', 'consum', 0.0223, 'lps'),
	(395445, 102, '2015-02-15 00:26:22.000000', 'consum', 0.0210, 'lps'),
	(395446, 102, '2015-02-15 00:26:23.000000', 'consum', 0.0213, 'lps'),
	(395447, 102, '2015-02-15 00:26:24.000000', 'consum', 0.0224, 'lps'),
	(395448, 102, '2015-02-15 00:26:25.000000', 'consum', 0.0213, 'lps'),
	(395449, 102, '2015-02-15 00:26:26.000000', 'consum', 0.0223, 'lps'),
	(395450, 102, '2015-02-15 00:26:27.000000', 'consum', 0.0227, 'lps'),
	(395451, 102, '2015-02-15 00:26:28.000000', 'consum', 0.0216, 'lps'),
	(395452, 102, '2015-02-15 00:26:29.000000', 'consum', 0.0212, 'lps'),
	(395453, 102, '2015-02-15 00:26:30.000000', 'consum', 0.0219, 'lps'),
	(395454, 102, '2015-02-15 00:26:31.000000', 'consum', 0.0210, 'lps'),
	(395455, 102, '2015-02-15 00:26:32.000000', 'consum', 0.0223, 'lps'),
	(395456, 102, '2015-02-15 00:26:33.000000', 'consum', 0.0218, 'lps'),
	(395457, 102, '2015-02-15 00:26:34.000000', 'consum', 0.0229, 'lps'),
	(395458, 102, '2015-02-15 00:26:35.000000', 'consum', 0.0222, 'lps'),
	(395459, 102, '2015-02-15 00:26:36.000000', 'consum', 0.0214, 'lps'),
	(395460, 102, '2015-02-15 00:26:37.000000', 'consum', 0.0216, 'lps'),
	(395461, 102, '2015-02-15 00:26:38.000000', 'consum', 0.0229, 'lps'),
	(395462, 102, '2015-02-15 00:26:39.000000', 'consum', 0.0226, 'lps'),
	(395463, 102, '2015-02-15 00:26:40.000000', 'consum', 0.0212, 'lps'),
	(395464, 102, '2015-02-15 00:26:41.000000', 'consum', 0.0212, 'lps'),
	(395465, 102, '2015-02-15 00:26:42.000000', 'consum', 0.0217, 'lps'),
	(395466, 102, '2015-02-15 00:26:43.000000', 'consum', 0.0220, 'lps'),
	(395467, 102, '2015-02-15 00:26:44.000000', 'consum', 0.0218, 'lps'),
	(395468, 102, '2015-02-15 00:26:45.000000', 'consum', 0.0222, 'lps'),
	(395469, 102, '2015-02-15 00:26:46.000000', 'consum', 0.0225, 'lps'),
	(395470, 102, '2015-02-15 00:26:47.000000', 'consum', 0.0229, 'lps'),
	(395471, 102, '2015-02-15 00:26:48.000000', 'consum', 0.0219, 'lps'),
	(395472, 102, '2015-02-15 00:26:49.000000', 'consum', 0.0222, 'lps'),
	(395473, 102, '2015-02-15 00:26:50.000000', 'consum', 0.0223, 'lps'),
	(395474, 102, '2015-02-15 00:26:51.000000', 'consum', 0.0218, 'lps'),
	(395475, 102, '2015-02-15 00:26:52.000000', 'consum', 0.0210, 'lps'),
	(395476, 102, '2015-02-15 00:26:53.000000', 'consum', 0.0229, 'lps'),
	(395477, 102, '2015-02-15 00:26:54.000000', 'consum', 0.0223, 'lps'),
	(395478, 102, '2015-02-15 00:26:55.000000', 'consum', 0.0218, 'lps'),
	(395479, 102, '2015-02-15 00:26:56.000000', 'consum', 0.0215, 'lps'),
	(395480, 102, '2015-02-15 00:26:57.000000', 'consum', 0.0228, 'lps'),
	(395481, 102, '2015-02-15 00:26:58.000000', 'consum', 0.0227, 'lps'),
	(395482, 102, '2015-02-15 00:26:59.000000', 'consum', 0.0219, 'lps'),
	(395483, 102, '2015-02-15 00:27:00.000000', 'consum', 0.0228, 'lps'),
	(395484, 102, '2015-02-15 00:27:01.000000', 'consum', 0.0212, 'lps'),
	(395485, 102, '2015-02-15 00:27:02.000000', 'consum', 0.0226, 'lps'),
	(395486, 102, '2015-02-15 00:27:03.000000', 'consum', 0.0227, 'lps'),
	(395487, 102, '2015-02-15 00:27:04.000000', 'consum', 0.0224, 'lps'),
	(395488, 102, '2015-02-15 00:27:05.000000', 'consum', 0.0212, 'lps'),
	(395489, 102, '2015-02-15 00:27:06.000000', 'consum', 0.0219, 'lps'),
	(395490, 102, '2015-02-15 00:27:07.000000', 'consum', 0.0228, 'lps'),
	(395491, 102, '2015-02-15 00:27:08.000000', 'consum', 0.0215, 'lps'),
	(395492, 102, '2015-02-15 00:27:09.000000', 'consum', 0.0220, 'lps'),
	(395493, 102, '2015-02-15 00:27:10.000000', 'consum', 0.0226, 'lps'),
	(395494, 102, '2015-02-15 00:27:11.000000', 'consum', 0.0221, 'lps'),
	(395495, 102, '2015-02-15 00:27:12.000000', 'consum', 0.0218, 'lps'),
	(395496, 102, '2015-02-15 00:27:13.000000', 'consum', 0.0217, 'lps'),
	(395497, 102, '2015-02-15 00:27:14.000000', 'consum', 0.0221, 'lps'),
	(395498, 102, '2015-02-15 00:27:15.000000', 'consum', 0.0224, 'lps'),
	(395499, 102, '2015-02-15 00:27:16.000000', 'consum', 0.0229, 'lps'),
	(395500, 102, '2015-02-15 00:27:17.000000', 'consum', 0.0224, 'lps'),
	(395501, 102, '2015-02-15 00:27:18.000000', 'consum', 0.0223, 'lps'),
	(395502, 102, '2015-02-15 00:27:19.000000', 'consum', 0.0212, 'lps'),
	(395503, 102, '2015-02-15 00:27:20.000000', 'consum', 0.0223, 'lps'),
	(395504, 102, '2015-02-15 00:27:21.000000', 'consum', 0.0229, 'lps'),
	(395505, 102, '2015-02-15 00:27:22.000000', 'consum', 0.0227, 'lps'),
	(395506, 102, '2015-02-15 00:27:23.000000', 'consum', 0.0217, 'lps'),
	(395507, 102, '2015-02-15 00:27:24.000000', 'consum', 0.0215, 'lps'),
	(395508, 102, '2015-02-15 00:27:25.000000', 'consum', 0.0216, 'lps'),
	(395509, 102, '2015-02-15 00:27:26.000000', 'consum', 0.0226, 'lps'),
	(395510, 102, '2015-02-15 00:27:27.000000', 'consum', 0.0210, 'lps'),
	(395511, 102, '2015-02-15 00:27:28.000000', 'consum', 0.0223, 'lps'),
	(395512, 102, '2015-02-15 00:27:29.000000', 'consum', 0.0218, 'lps'),
	(395513, 102, '2015-02-15 00:27:30.000000', 'consum', 0.0229, 'lps'),
	(395514, 102, '2015-02-15 00:27:31.000000', 'consum', 0.0223, 'lps'),
	(395515, 102, '2015-02-15 00:27:32.000000', 'consum', 0.0220, 'lps'),
	(395516, 102, '2015-02-15 00:27:33.000000', 'consum', 0.0218, 'lps'),
	(395517, 102, '2015-02-15 00:27:34.000000', 'consum', 0.0223, 'lps'),
	(395518, 102, '2015-02-15 00:27:35.000000', 'consum', 0.0229, 'lps'),
	(395519, 102, '2015-02-15 00:27:36.000000', 'consum', 0.0226, 'lps'),
	(395520, 102, '2015-02-15 00:27:37.000000', 'consum', 0.0217, 'lps'),
	(395521, 102, '2015-02-15 00:27:38.000000', 'consum', 0.0215, 'lps'),
	(395522, 102, '2015-02-15 00:27:39.000000', 'consum', 0.0214, 'lps'),
	(395523, 102, '2015-02-15 00:27:40.000000', 'consum', 0.0216, 'lps'),
	(395524, 102, '2015-02-15 00:27:41.000000', 'consum', 0.0228, 'lps'),
	(395525, 102, '2015-02-15 00:27:42.000000', 'consum', 0.0224, 'lps'),
	(395526, 102, '2015-02-15 00:27:43.000000', 'consum', 0.0227, 'lps'),
	(395527, 102, '2015-02-15 00:27:44.000000', 'consum', 0.0213, 'lps'),
	(395528, 102, '2015-02-15 00:27:45.000000', 'consum', 0.0213, 'lps'),
	(395529, 102, '2015-02-15 00:27:46.000000', 'consum', 0.0217, 'lps'),
	(395530, 102, '2015-02-15 00:27:47.000000', 'consum', 0.0219, 'lps'),
	(395531, 102, '2015-02-15 00:27:48.000000', 'consum', 0.0212, 'lps'),
	(395532, 102, '2015-02-15 00:27:49.000000', 'consum', 0.0215, 'lps'),
	(395533, 102, '2015-02-15 00:27:50.000000', 'consum', 0.0211, 'lps'),
	(395534, 102, '2015-02-15 00:27:51.000000', 'consum', 0.0219, 'lps'),
	(395535, 102, '2015-02-15 00:27:52.000000', 'consum', 0.0214, 'lps'),
	(395536, 102, '2015-02-15 00:27:53.000000', 'consum', 0.0221, 'lps'),
	(395537, 102, '2015-02-15 00:27:54.000000', 'consum', 0.0216, 'lps'),
	(395538, 102, '2015-02-15 00:27:55.000000', 'consum', 0.0225, 'lps'),
	(395539, 102, '2015-02-15 00:27:56.000000', 'consum', 0.0211, 'lps'),
	(395540, 102, '2015-02-15 00:27:57.000000', 'consum', 0.0227, 'lps'),
	(395541, 102, '2015-02-15 00:27:58.000000', 'consum', 0.0215, 'lps'),
	(395542, 102, '2015-02-15 00:27:59.000000', 'consum', 0.0224, 'lps'),
	(395543, 102, '2015-02-15 00:28:00.000000', 'consum', 0.0224, 'lps'),
	(395544, 102, '2015-02-15 00:28:01.000000', 'consum', 0.0221, 'lps'),
	(395545, 102, '2015-02-15 00:28:02.000000', 'consum', 0.0224, 'lps'),
	(395546, 102, '2015-02-15 00:28:03.000000', 'consum', 0.0224, 'lps'),
	(395547, 102, '2015-02-15 00:28:04.000000', 'consum', 0.0222, 'lps'),
	(395548, 102, '2015-02-15 00:28:05.000000', 'consum', 0.0226, 'lps'),
	(395549, 102, '2015-02-15 00:28:06.000000', 'consum', 0.0217, 'lps'),
	(395550, 102, '2015-02-15 00:28:07.000000', 'consum', 0.0216, 'lps'),
	(395551, 102, '2015-02-15 00:28:08.000000', 'consum', 0.0221, 'lps'),
	(395552, 102, '2015-02-15 00:28:09.000000', 'consum', 0.0226, 'lps'),
	(395553, 102, '2015-02-15 00:28:10.000000', 'consum', 0.0218, 'lps'),
	(395554, 102, '2015-02-15 00:28:11.000000', 'consum', 0.0223, 'lps'),
	(395555, 102, '2015-02-15 00:28:12.000000', 'consum', 0.0212, 'lps'),
	(395556, 102, '2015-02-15 00:28:13.000000', 'consum', 0.0219, 'lps'),
	(395557, 102, '2015-02-15 00:28:14.000000', 'consum', 0.0212, 'lps'),
	(395558, 102, '2015-02-15 00:28:15.000000', 'consum', 0.0214, 'lps'),
	(395559, 102, '2015-02-15 00:28:16.000000', 'consum', 0.0223, 'lps'),
	(395560, 102, '2015-02-15 00:28:17.000000', 'consum', 0.0226, 'lps'),
	(395561, 102, '2015-02-15 00:28:18.000000', 'consum', 0.0210, 'lps'),
	(395562, 102, '2015-02-15 00:28:19.000000', 'consum', 0.0222, 'lps'),
	(395563, 102, '2015-02-15 00:28:20.000000', 'consum', 0.0229, 'lps'),
	(395564, 102, '2015-02-15 00:28:21.000000', 'consum', 0.0211, 'lps'),
	(395565, 102, '2015-02-15 00:28:22.000000', 'consum', 0.0219, 'lps'),
	(395566, 102, '2015-02-15 00:28:23.000000', 'consum', 0.0211, 'lps'),
	(395567, 102, '2015-02-15 00:28:24.000000', 'consum', 0.0229, 'lps'),
	(395568, 102, '2015-02-15 00:28:25.000000', 'consum', 0.0223, 'lps'),
	(395569, 102, '2015-02-15 00:28:26.000000', 'consum', 0.0219, 'lps'),
	(395570, 102, '2015-02-15 00:28:27.000000', 'consum', 0.0217, 'lps'),
	(395571, 102, '2015-02-15 00:28:28.000000', 'consum', 0.0218, 'lps'),
	(395572, 102, '2015-02-15 00:28:29.000000', 'consum', 0.0211, 'lps'),
	(395573, 102, '2015-02-15 00:28:30.000000', 'consum', 0.0210, 'lps'),
	(395574, 102, '2015-02-15 00:28:31.000000', 'consum', 0.0229, 'lps'),
	(395575, 102, '2015-02-15 00:28:32.000000', 'consum', 0.0226, 'lps'),
	(395576, 102, '2015-02-15 00:28:33.000000', 'consum', 0.0211, 'lps'),
	(395577, 102, '2015-02-15 00:28:34.000000', 'consum', 0.0210, 'lps'),
	(395578, 102, '2015-02-15 00:28:35.000000', 'consum', 0.0228, 'lps'),
	(395579, 102, '2015-02-15 00:28:36.000000', 'consum', 0.0219, 'lps'),
	(395580, 102, '2015-02-15 00:28:37.000000', 'consum', 0.0224, 'lps'),
	(395581, 102, '2015-02-15 00:28:38.000000', 'consum', 0.0211, 'lps'),
	(395582, 102, '2015-02-15 00:28:39.000000', 'consum', 0.0214, 'lps'),
	(395583, 102, '2015-02-15 00:28:40.000000', 'consum', 0.0227, 'lps'),
	(395584, 102, '2015-02-15 00:28:41.000000', 'consum', 0.0224, 'lps'),
	(395585, 102, '2015-02-15 00:28:42.000000', 'consum', 0.0210, 'lps'),
	(395586, 102, '2015-02-15 00:28:43.000000', 'consum', 0.0227, 'lps'),
	(395587, 102, '2015-02-15 00:28:44.000000', 'consum', 0.0214, 'lps'),
	(395588, 102, '2015-02-15 00:28:45.000000', 'consum', 0.0222, 'lps'),
	(395589, 102, '2015-02-15 00:28:46.000000', 'consum', 0.0218, 'lps'),
	(395590, 102, '2015-02-15 00:28:47.000000', 'consum', 0.0214, 'lps'),
	(395591, 102, '2015-02-15 00:28:48.000000', 'consum', 0.0228, 'lps'),
	(395592, 102, '2015-02-15 00:28:49.000000', 'consum', 0.0227, 'lps'),
	(395593, 102, '2015-02-15 00:28:50.000000', 'consum', 0.0220, 'lps'),
	(395594, 102, '2015-02-15 00:28:51.000000', 'consum', 0.0212, 'lps'),
	(395595, 102, '2015-02-15 00:28:52.000000', 'consum', 0.0229, 'lps'),
	(395596, 102, '2015-02-15 00:28:53.000000', 'consum', 0.0220, 'lps'),
	(395597, 102, '2015-02-15 00:28:54.000000', 'consum', 0.0223, 'lps'),
	(395598, 102, '2015-02-15 00:28:55.000000', 'consum', 0.0224, 'lps'),
	(395599, 102, '2015-02-15 00:28:56.000000', 'consum', 0.0222, 'lps'),
	(395600, 102, '2015-02-15 00:28:57.000000', 'consum', 0.0210, 'lps'),
	(395601, 102, '2015-02-15 00:28:58.000000', 'consum', 0.0215, 'lps'),
	(395602, 102, '2015-02-15 00:28:59.000000', 'consum', 0.0213, 'lps'),
	(395603, 102, '2015-02-15 00:29:00.000000', 'consum', 0.0211, 'lps'),
	(395604, 102, '2015-02-15 00:29:01.000000', 'consum', 0.0226, 'lps'),
	(395605, 102, '2015-02-15 00:29:02.000000', 'consum', 0.0229, 'lps'),
	(395606, 102, '2015-02-15 00:29:03.000000', 'consum', 0.0219, 'lps'),
	(395607, 102, '2015-02-15 00:29:04.000000', 'consum', 0.0215, 'lps'),
	(395608, 102, '2015-02-15 00:29:05.000000', 'consum', 0.0210, 'lps'),
	(395609, 102, '2015-02-15 00:29:06.000000', 'consum', 0.0216, 'lps'),
	(395610, 102, '2015-02-15 00:29:07.000000', 'consum', 0.0219, 'lps'),
	(395611, 102, '2015-02-15 00:29:08.000000', 'consum', 0.0219, 'lps'),
	(395612, 102, '2015-02-15 00:29:09.000000', 'consum', 0.0210, 'lps'),
	(395613, 102, '2015-02-15 00:29:10.000000', 'consum', 0.0221, 'lps'),
	(395614, 102, '2015-02-15 00:29:11.000000', 'consum', 0.0226, 'lps'),
	(395615, 102, '2015-02-15 00:29:12.000000', 'consum', 0.0216, 'lps'),
	(395616, 102, '2015-02-15 00:29:13.000000', 'consum', 0.0216, 'lps'),
	(395617, 102, '2015-02-15 00:29:14.000000', 'consum', 0.0220, 'lps'),
	(395618, 102, '2015-02-15 00:29:15.000000', 'consum', 0.0221, 'lps'),
	(395619, 102, '2015-02-15 00:29:16.000000', 'consum', 0.0218, 'lps'),
	(395620, 102, '2015-02-15 00:29:17.000000', 'consum', 0.0217, 'lps'),
	(395621, 102, '2015-02-15 00:29:18.000000', 'consum', 0.0219, 'lps'),
	(395622, 102, '2015-02-15 00:29:19.000000', 'consum', 0.0218, 'lps'),
	(395623, 102, '2015-02-15 00:29:20.000000', 'consum', 0.0221, 'lps'),
	(395624, 102, '2015-02-15 00:29:21.000000', 'consum', 0.0223, 'lps'),
	(395625, 102, '2015-02-15 00:29:22.000000', 'consum', 0.0221, 'lps'),
	(395626, 102, '2015-02-15 00:29:23.000000', 'consum', 0.0229, 'lps'),
	(395627, 102, '2015-02-15 00:29:24.000000', 'consum', 0.0229, 'lps'),
	(395628, 102, '2015-02-15 00:29:25.000000', 'consum', 0.0212, 'lps'),
	(395629, 102, '2015-02-15 00:29:26.000000', 'consum', 0.0221, 'lps'),
	(395630, 102, '2015-02-15 00:29:27.000000', 'consum', 0.0222, 'lps'),
	(395631, 102, '2015-02-15 00:29:28.000000', 'consum', 0.0216, 'lps'),
	(395632, 102, '2015-02-15 00:29:29.000000', 'consum', 0.0224, 'lps'),
	(395633, 102, '2015-02-15 00:29:30.000000', 'consum', 0.0221, 'lps'),
	(395634, 102, '2015-02-15 00:29:31.000000', 'consum', 0.0225, 'lps'),
	(395635, 102, '2015-02-15 00:29:32.000000', 'consum', 0.0214, 'lps'),
	(395636, 102, '2015-02-15 00:29:33.000000', 'consum', 0.0223, 'lps'),
	(395637, 102, '2015-02-15 00:29:34.000000', 'consum', 0.0224, 'lps'),
	(395638, 102, '2015-02-15 00:29:35.000000', 'consum', 0.0222, 'lps'),
	(395639, 102, '2015-02-15 00:29:36.000000', 'consum', 0.0228, 'lps'),
	(395640, 102, '2015-02-15 00:29:37.000000', 'consum', 0.0224, 'lps'),
	(395641, 102, '2015-02-15 00:29:38.000000', 'consum', 0.0228, 'lps'),
	(395642, 102, '2015-02-15 00:29:39.000000', 'consum', 0.0218, 'lps'),
	(395643, 102, '2015-02-15 00:29:40.000000', 'consum', 0.0215, 'lps'),
	(395644, 102, '2015-02-15 00:29:41.000000', 'consum', 0.0211, 'lps'),
	(395645, 102, '2015-02-15 00:29:42.000000', 'consum', 0.0223, 'lps'),
	(395646, 102, '2015-02-15 00:29:43.000000', 'consum', 0.0211, 'lps'),
	(395647, 102, '2015-02-15 00:29:44.000000', 'consum', 0.0219, 'lps'),
	(395648, 102, '2015-02-15 00:29:45.000000', 'consum', 0.0210, 'lps'),
	(395649, 102, '2015-02-15 00:29:46.000000', 'consum', 0.0224, 'lps'),
	(395650, 102, '2015-02-15 00:29:47.000000', 'consum', 0.0221, 'lps'),
	(395651, 102, '2015-02-15 00:29:48.000000', 'consum', 0.0223, 'lps'),
	(395652, 102, '2015-02-15 00:29:49.000000', 'consum', 0.0223, 'lps'),
	(395653, 102, '2015-02-15 00:29:50.000000', 'consum', 0.0215, 'lps'),
	(395654, 102, '2015-02-15 00:29:51.000000', 'consum', 0.0219, 'lps'),
	(395655, 102, '2015-02-15 00:29:52.000000', 'consum', 0.0221, 'lps'),
	(395656, 102, '2015-02-15 00:29:53.000000', 'consum', 0.0219, 'lps'),
	(395657, 102, '2015-02-15 00:29:54.000000', 'consum', 0.0221, 'lps'),
	(395658, 102, '2015-02-15 00:29:55.000000', 'consum', 0.0220, 'lps'),
	(395659, 102, '2015-02-15 00:29:56.000000', 'consum', 0.0226, 'lps'),
	(395660, 102, '2015-02-15 00:29:57.000000', 'consum', 0.0221, 'lps'),
	(395661, 102, '2015-02-15 00:29:58.000000', 'consum', 0.0215, 'lps'),
	(395662, 102, '2015-02-15 00:29:59.000000', 'consum', 0.0226, 'lps'),
	(395663, 102, '2015-02-15 00:30:00.000000', 'consum', 0.0214, 'lps'),
	(395664, 102, '2015-02-15 00:30:01.000000', 'consum', 0.0223, 'lps'),
	(395665, 102, '2015-02-15 00:30:02.000000', 'consum', 0.0221, 'lps'),
	(395666, 102, '2015-02-15 00:30:03.000000', 'consum', 0.0210, 'lps'),
	(395667, 102, '2015-02-15 00:30:04.000000', 'consum', 0.0215, 'lps'),
	(395668, 102, '2015-02-15 00:30:05.000000', 'consum', 0.0216, 'lps'),
	(395669, 102, '2015-02-15 00:30:06.000000', 'consum', 0.0225, 'lps'),
	(395670, 102, '2015-02-15 00:30:07.000000', 'consum', 0.0228, 'lps'),
	(395671, 102, '2015-02-15 00:30:08.000000', 'consum', 0.0217, 'lps'),
	(395672, 102, '2015-02-15 00:30:09.000000', 'consum', 0.0229, 'lps'),
	(395673, 102, '2015-02-15 00:30:10.000000', 'consum', 0.0227, 'lps'),
	(395674, 102, '2015-02-15 00:30:11.000000', 'consum', 0.0219, 'lps'),
	(395675, 102, '2015-02-15 00:30:12.000000', 'consum', 0.0223, 'lps'),
	(395676, 102, '2015-02-15 00:30:13.000000', 'consum', 0.0211, 'lps'),
	(395677, 102, '2015-02-15 00:30:14.000000', 'consum', 0.0214, 'lps'),
	(395678, 102, '2015-02-15 00:30:15.000000', 'consum', 0.0226, 'lps'),
	(395679, 102, '2015-02-15 00:30:16.000000', 'consum', 0.0220, 'lps'),
	(395680, 102, '2015-02-15 00:30:17.000000', 'consum', 0.0213, 'lps'),
	(395681, 102, '2015-02-15 00:30:18.000000', 'consum', 0.0217, 'lps'),
	(395682, 102, '2015-02-15 00:30:19.000000', 'consum', 0.0216, 'lps'),
	(395683, 102, '2015-02-15 00:30:20.000000', 'consum', 0.0220, 'lps'),
	(395684, 102, '2015-02-15 00:30:21.000000', 'consum', 0.0221, 'lps'),
	(395685, 102, '2015-02-15 00:30:22.000000', 'consum', 0.0218, 'lps'),
	(395686, 102, '2015-02-15 00:30:23.000000', 'consum', 0.0215, 'lps'),
	(395687, 102, '2015-02-15 00:30:24.000000', 'consum', 0.0213, 'lps'),
	(395688, 102, '2015-02-15 00:30:25.000000', 'consum', 0.0211, 'lps'),
	(395689, 102, '2015-02-15 00:30:26.000000', 'consum', 0.0225, 'lps'),
	(395690, 102, '2015-02-15 00:30:27.000000', 'consum', 0.0221, 'lps'),
	(395691, 102, '2015-02-15 00:30:28.000000', 'consum', 0.0222, 'lps'),
	(395692, 102, '2015-02-15 00:30:29.000000', 'consum', 0.0219, 'lps'),
	(395693, 102, '2015-02-15 00:30:30.000000', 'consum', 0.0220, 'lps'),
	(395694, 102, '2015-02-15 00:30:31.000000', 'consum', 0.0212, 'lps'),
	(395695, 102, '2015-02-15 00:30:32.000000', 'consum', 0.0229, 'lps'),
	(395696, 102, '2015-02-15 00:30:33.000000', 'consum', 0.0222, 'lps'),
	(395697, 102, '2015-02-15 00:30:34.000000', 'consum', 0.0211, 'lps'),
	(395698, 102, '2015-02-15 00:30:35.000000', 'consum', 0.0219, 'lps'),
	(395699, 102, '2015-02-15 00:30:36.000000', 'consum', 0.0213, 'lps'),
	(395700, 102, '2015-02-15 00:30:37.000000', 'consum', 0.0218, 'lps'),
	(395701, 102, '2015-02-15 00:30:38.000000', 'consum', 0.0222, 'lps'),
	(395702, 102, '2015-02-15 00:30:39.000000', 'consum', 0.0226, 'lps'),
	(395703, 102, '2015-02-15 00:30:40.000000', 'consum', 0.0215, 'lps'),
	(395704, 102, '2015-02-15 00:30:41.000000', 'consum', 0.0228, 'lps'),
	(395705, 102, '2015-02-15 00:30:42.000000', 'consum', 0.0227, 'lps'),
	(395706, 102, '2015-02-15 00:30:43.000000', 'consum', 0.0220, 'lps'),
	(395707, 102, '2015-02-15 00:30:44.000000', 'consum', 0.0210, 'lps'),
	(395708, 102, '2015-02-15 00:30:45.000000', 'consum', 0.0220, 'lps'),
	(395709, 102, '2015-02-15 00:30:46.000000', 'consum', 0.0222, 'lps'),
	(395710, 102, '2015-02-15 00:30:47.000000', 'consum', 0.0221, 'lps'),
	(395711, 102, '2015-02-15 00:30:48.000000', 'consum', 0.0227, 'lps'),
	(395712, 102, '2015-02-15 00:30:49.000000', 'consum', 0.0226, 'lps'),
	(395713, 102, '2015-02-15 00:30:50.000000', 'consum', 0.0216, 'lps'),
	(395714, 102, '2015-02-15 00:30:51.000000', 'consum', 0.0213, 'lps'),
	(395715, 102, '2015-02-15 00:30:52.000000', 'consum', 0.0229, 'lps'),
	(395716, 102, '2015-02-15 00:30:53.000000', 'consum', 0.0218, 'lps'),
	(395717, 102, '2015-02-15 00:30:54.000000', 'consum', 0.0211, 'lps'),
	(395718, 102, '2015-02-15 00:30:55.000000', 'consum', 0.0214, 'lps'),
	(395719, 102, '2015-02-15 00:30:56.000000', 'consum', 0.0227, 'lps'),
	(395720, 102, '2015-02-15 00:30:57.000000', 'consum', 0.0224, 'lps'),
	(395721, 102, '2015-02-15 00:30:58.000000', 'consum', 0.0211, 'lps'),
	(395722, 102, '2015-02-15 00:30:59.000000', 'consum', 0.0210, 'lps'),
	(395723, 102, '2015-02-15 00:31:00.000000', 'consum', 0.0229, 'lps'),
	(395724, 102, '2015-02-15 00:31:01.000000', 'consum', 0.0225, 'lps'),
	(395725, 102, '2015-02-15 00:31:02.000000', 'consum', 0.0228, 'lps'),
	(395726, 102, '2015-02-15 00:31:03.000000', 'consum', 0.0218, 'lps'),
	(395727, 102, '2015-02-15 00:31:04.000000', 'consum', 0.0214, 'lps'),
	(395728, 102, '2015-02-15 00:31:05.000000', 'consum', 0.0228, 'lps'),
	(395729, 102, '2015-02-15 00:31:06.000000', 'consum', 0.0227, 'lps'),
	(395730, 102, '2015-02-15 00:31:07.000000', 'consum', 0.0224, 'lps'),
	(395731, 102, '2015-02-15 00:31:08.000000', 'consum', 0.0226, 'lps'),
	(395732, 102, '2015-02-15 00:31:09.000000', 'consum', 0.0210, 'lps'),
	(395733, 102, '2015-02-15 00:31:10.000000', 'consum', 0.0225, 'lps'),
	(395734, 102, '2015-02-15 00:31:11.000000', 'consum', 0.0222, 'lps'),
	(395735, 102, '2015-02-15 00:31:12.000000', 'consum', 0.0227, 'lps'),
	(395736, 102, '2015-02-15 00:31:13.000000', 'consum', 0.0221, 'lps'),
	(395737, 102, '2015-02-15 00:31:14.000000', 'consum', 0.0212, 'lps'),
	(395738, 102, '2015-02-15 00:31:15.000000', 'consum', 0.0210, 'lps'),
	(395739, 102, '2015-02-15 00:31:16.000000', 'consum', 0.0225, 'lps'),
	(395740, 102, '2015-02-15 00:31:17.000000', 'consum', 0.0225, 'lps'),
	(395741, 102, '2015-02-15 00:31:18.000000', 'consum', 0.0220, 'lps'),
	(395742, 102, '2015-02-15 00:31:19.000000', 'consum', 0.0215, 'lps'),
	(395743, 102, '2015-02-15 00:31:20.000000', 'consum', 0.0227, 'lps'),
	(395744, 102, '2015-02-15 00:31:21.000000', 'consum', 0.0218, 'lps'),
	(395745, 102, '2015-02-15 00:31:22.000000', 'consum', 0.0220, 'lps'),
	(395746, 102, '2015-02-15 00:31:23.000000', 'consum', 0.0218, 'lps'),
	(395747, 102, '2015-02-15 00:31:24.000000', 'consum', 0.0218, 'lps'),
	(395748, 102, '2015-02-15 00:31:25.000000', 'consum', 0.0210, 'lps'),
	(395749, 102, '2015-02-15 00:31:26.000000', 'consum', 0.0223, 'lps'),
	(395750, 102, '2015-02-15 00:31:27.000000', 'consum', 0.0219, 'lps'),
	(395751, 102, '2015-02-15 00:31:28.000000', 'consum', 0.0213, 'lps'),
	(395752, 102, '2015-02-15 00:31:29.000000', 'consum', 0.0221, 'lps'),
	(395753, 102, '2015-02-15 00:31:30.000000', 'consum', 0.0214, 'lps'),
	(395754, 102, '2015-02-15 00:31:31.000000', 'consum', 0.0218, 'lps'),
	(395755, 102, '2015-02-15 00:31:32.000000', 'consum', 0.0219, 'lps'),
	(395756, 102, '2015-02-15 00:31:33.000000', 'consum', 0.0211, 'lps'),
	(395757, 102, '2015-02-15 00:31:34.000000', 'consum', 0.0210, 'lps'),
	(395758, 102, '2015-02-15 00:31:35.000000', 'consum', 0.0226, 'lps'),
	(395759, 102, '2015-02-15 00:31:36.000000', 'consum', 0.0210, 'lps'),
	(395760, 102, '2015-02-15 00:31:37.000000', 'consum', 0.0222, 'lps'),
	(395761, 102, '2015-02-15 00:31:38.000000', 'consum', 0.0212, 'lps'),
	(395762, 102, '2015-02-15 00:31:39.000000', 'consum', 0.0222, 'lps'),
	(395763, 102, '2015-02-15 00:31:40.000000', 'consum', 0.0226, 'lps'),
	(395764, 102, '2015-02-15 00:31:41.000000', 'consum', 0.0214, 'lps'),
	(395765, 102, '2015-02-15 00:31:42.000000', 'consum', 0.0222, 'lps'),
	(395766, 102, '2015-02-15 00:31:43.000000', 'consum', 0.0220, 'lps'),
	(395767, 102, '2015-02-15 00:31:44.000000', 'consum', 0.0224, 'lps'),
	(395768, 102, '2015-02-15 00:31:45.000000', 'consum', 0.0212, 'lps'),
	(395769, 102, '2015-02-15 00:31:46.000000', 'consum', 0.0217, 'lps'),
	(395770, 102, '2015-02-15 00:31:47.000000', 'consum', 0.0219, 'lps'),
	(395771, 102, '2015-02-15 00:31:48.000000', 'consum', 0.0217, 'lps'),
	(395772, 102, '2015-02-15 00:31:49.000000', 'consum', 0.0216, 'lps'),
	(395773, 102, '2015-02-15 00:31:50.000000', 'consum', 0.0220, 'lps'),
	(395774, 102, '2015-02-15 00:31:51.000000', 'consum', 0.0222, 'lps'),
	(395775, 102, '2015-02-15 00:31:52.000000', 'consum', 0.0222, 'lps'),
	(395776, 102, '2015-02-15 00:31:53.000000', 'consum', 0.0213, 'lps'),
	(395777, 102, '2015-02-15 00:31:54.000000', 'consum', 0.0228, 'lps'),
	(395778, 102, '2015-02-15 00:31:55.000000', 'consum', 0.0213, 'lps'),
	(395779, 102, '2015-02-15 00:31:56.000000', 'consum', 0.0211, 'lps'),
	(395780, 102, '2015-02-15 00:31:57.000000', 'consum', 0.0228, 'lps'),
	(395781, 102, '2015-02-15 00:31:58.000000', 'consum', 0.0218, 'lps'),
	(395782, 102, '2015-02-15 00:31:59.000000', 'consum', 0.0216, 'lps'),
	(395783, 102, '2015-02-15 00:32:00.000000', 'consum', 0.0218, 'lps'),
	(395784, 102, '2015-02-15 00:32:01.000000', 'consum', 0.0211, 'lps'),
	(395785, 102, '2015-02-15 00:32:02.000000', 'consum', 0.0213, 'lps'),
	(395786, 102, '2015-02-15 00:32:03.000000', 'consum', 0.0223, 'lps'),
	(395787, 102, '2015-02-15 00:32:04.000000', 'consum', 0.0225, 'lps'),
	(395788, 102, '2015-02-15 00:32:05.000000', 'consum', 0.0225, 'lps'),
	(395789, 102, '2015-02-15 00:32:06.000000', 'consum', 0.0224, 'lps'),
	(395790, 102, '2015-02-15 00:32:07.000000', 'consum', 0.0213, 'lps'),
	(395791, 102, '2015-02-15 00:32:08.000000', 'consum', 0.0226, 'lps'),
	(395792, 102, '2015-02-15 00:32:09.000000', 'consum', 0.0220, 'lps'),
	(395793, 102, '2015-02-15 00:32:10.000000', 'consum', 0.0212, 'lps'),
	(395794, 102, '2015-02-15 00:32:11.000000', 'consum', 0.0210, 'lps'),
	(395795, 102, '2015-02-15 00:32:12.000000', 'consum', 0.0224, 'lps'),
	(395796, 102, '2015-02-15 00:32:13.000000', 'consum', 0.0221, 'lps'),
	(395797, 102, '2015-02-15 00:32:14.000000', 'consum', 0.0224, 'lps'),
	(395798, 102, '2015-02-15 00:32:15.000000', 'consum', 0.0229, 'lps'),
	(395799, 102, '2015-02-15 00:32:16.000000', 'consum', 0.0223, 'lps'),
	(395800, 102, '2015-02-15 00:32:17.000000', 'consum', 0.0218, 'lps'),
	(395801, 102, '2015-02-15 00:32:18.000000', 'consum', 0.0212, 'lps'),
	(395802, 102, '2015-02-15 00:32:19.000000', 'consum', 0.0215, 'lps'),
	(395803, 102, '2015-02-15 00:32:20.000000', 'consum', 0.0211, 'lps'),
	(395804, 102, '2015-02-15 00:32:21.000000', 'consum', 0.0220, 'lps'),
	(395805, 102, '2015-02-15 00:32:22.000000', 'consum', 0.0219, 'lps'),
	(395806, 102, '2015-02-15 00:32:23.000000', 'consum', 0.0225, 'lps'),
	(395807, 102, '2015-02-15 00:32:24.000000', 'consum', 0.0216, 'lps'),
	(395808, 102, '2015-02-15 00:32:25.000000', 'consum', 0.0217, 'lps'),
	(395809, 102, '2015-02-15 00:32:26.000000', 'consum', 0.0227, 'lps'),
	(395810, 102, '2015-02-15 00:32:27.000000', 'consum', 0.0215, 'lps'),
	(395811, 102, '2015-02-15 00:32:28.000000', 'consum', 0.0225, 'lps'),
	(395812, 102, '2015-02-15 00:32:29.000000', 'consum', 0.0210, 'lps'),
	(395813, 102, '2015-02-15 00:32:30.000000', 'consum', 0.0226, 'lps'),
	(395814, 102, '2015-02-15 00:32:31.000000', 'consum', 0.0210, 'lps'),
	(395815, 102, '2015-02-15 00:32:32.000000', 'consum', 0.0221, 'lps'),
	(395816, 102, '2015-02-15 00:32:33.000000', 'consum', 0.0228, 'lps'),
	(395817, 102, '2015-02-15 00:32:34.000000', 'consum', 0.0226, 'lps'),
	(395818, 102, '2015-02-15 00:32:35.000000', 'consum', 0.0216, 'lps'),
	(395819, 102, '2015-02-15 00:32:36.000000', 'consum', 0.0214, 'lps'),
	(395820, 102, '2015-02-15 00:32:37.000000', 'consum', 0.0212, 'lps'),
	(395821, 102, '2015-02-15 00:32:38.000000', 'consum', 0.0210, 'lps'),
	(395822, 102, '2015-02-15 00:32:39.000000', 'consum', 0.0224, 'lps'),
	(395823, 102, '2015-02-15 00:32:40.000000', 'consum', 0.0222, 'lps'),
	(395824, 102, '2015-02-15 00:32:41.000000', 'consum', 0.0226, 'lps'),
	(395825, 102, '2015-02-15 00:32:42.000000', 'consum', 0.0213, 'lps'),
	(395826, 102, '2015-02-15 00:32:43.000000', 'consum', 0.0221, 'lps'),
	(395827, 102, '2015-02-15 00:32:44.000000', 'consum', 0.0214, 'lps'),
	(395828, 102, '2015-02-15 00:32:45.000000', 'consum', 0.0218, 'lps'),
	(395829, 102, '2015-02-15 00:32:46.000000', 'consum', 0.0220, 'lps'),
	(395830, 102, '2015-02-15 00:32:47.000000', 'consum', 0.0216, 'lps'),
	(395831, 102, '2015-02-15 00:32:48.000000', 'consum', 0.0211, 'lps'),
	(395832, 102, '2015-02-15 00:32:49.000000', 'consum', 0.0219, 'lps'),
	(395833, 102, '2015-02-15 00:32:50.000000', 'consum', 0.0210, 'lps'),
	(395834, 102, '2015-02-15 00:32:51.000000', 'consum', 0.0224, 'lps'),
	(395835, 102, '2015-02-15 00:32:52.000000', 'consum', 0.0221, 'lps'),
	(395836, 102, '2015-02-15 00:32:53.000000', 'consum', 0.0222, 'lps'),
	(395837, 102, '2015-02-15 00:32:54.000000', 'consum', 0.0218, 'lps'),
	(395838, 102, '2015-02-15 00:32:55.000000', 'consum', 0.0216, 'lps'),
	(395839, 102, '2015-02-15 00:32:56.000000', 'consum', 0.0214, 'lps'),
	(395840, 102, '2015-02-15 00:32:57.000000', 'consum', 0.0214, 'lps'),
	(395841, 102, '2015-02-15 00:32:58.000000', 'consum', 0.0217, 'lps'),
	(395842, 102, '2015-02-15 00:32:59.000000', 'consum', 0.0215, 'lps'),
	(395843, 102, '2015-02-15 00:33:00.000000', 'consum', 0.0214, 'lps'),
	(395844, 102, '2015-02-15 00:33:01.000000', 'consum', 0.0217, 'lps'),
	(395845, 102, '2015-02-15 00:33:02.000000', 'consum', 0.0212, 'lps'),
	(395846, 102, '2015-02-15 00:33:03.000000', 'consum', 0.0220, 'lps'),
	(395847, 102, '2015-02-15 00:33:04.000000', 'consum', 0.0215, 'lps'),
	(395848, 102, '2015-02-15 00:33:05.000000', 'consum', 0.0223, 'lps'),
	(395849, 102, '2015-02-15 00:33:06.000000', 'consum', 0.0223, 'lps'),
	(395850, 102, '2015-02-15 00:33:07.000000', 'consum', 0.0216, 'lps'),
	(395851, 102, '2015-02-15 00:33:08.000000', 'consum', 0.0222, 'lps'),
	(395852, 102, '2015-02-15 00:33:09.000000', 'consum', 0.0213, 'lps'),
	(395853, 102, '2015-02-15 00:33:10.000000', 'consum', 0.0228, 'lps'),
	(395854, 102, '2015-02-15 00:33:11.000000', 'consum', 0.0210, 'lps'),
	(395855, 102, '2015-02-15 00:33:12.000000', 'consum', 0.0220, 'lps'),
	(395856, 102, '2015-02-15 00:33:13.000000', 'consum', 0.0218, 'lps'),
	(395857, 102, '2015-02-15 00:33:14.000000', 'consum', 0.0223, 'lps'),
	(395858, 102, '2015-02-15 00:33:15.000000', 'consum', 0.0229, 'lps'),
	(395859, 102, '2015-02-15 00:33:16.000000', 'consum', 0.0226, 'lps'),
	(395860, 102, '2015-02-15 00:33:17.000000', 'consum', 0.0215, 'lps'),
	(395861, 102, '2015-02-15 00:33:18.000000', 'consum', 0.0228, 'lps'),
	(395862, 102, '2015-02-15 00:33:19.000000', 'consum', 0.0225, 'lps'),
	(395863, 102, '2015-02-15 00:33:20.000000', 'consum', 0.0211, 'lps'),
	(395864, 102, '2015-02-15 00:33:21.000000', 'consum', 0.0210, 'lps'),
	(395865, 102, '2015-02-15 00:33:22.000000', 'consum', 0.0228, 'lps'),
	(395866, 102, '2015-02-15 00:33:23.000000', 'consum', 0.0221, 'lps'),
	(395867, 102, '2015-02-15 00:33:24.000000', 'consum', 0.0213, 'lps'),
	(395868, 102, '2015-02-15 00:33:25.000000', 'consum', 0.0212, 'lps'),
	(395869, 102, '2015-02-15 00:33:26.000000', 'consum', 0.0212, 'lps'),
	(395870, 102, '2015-02-15 00:33:27.000000', 'consum', 0.0216, 'lps'),
	(395871, 102, '2015-02-15 00:33:28.000000', 'consum', 0.0211, 'lps'),
	(395872, 102, '2015-02-15 00:33:29.000000', 'consum', 0.0218, 'lps'),
	(395873, 102, '2015-02-15 00:33:30.000000', 'consum', 0.0210, 'lps'),
	(395874, 102, '2015-02-15 00:33:31.000000', 'consum', 0.0224, 'lps'),
	(395875, 102, '2015-02-15 00:33:32.000000', 'consum', 0.0223, 'lps'),
	(395876, 102, '2015-02-15 00:33:33.000000', 'consum', 0.0211, 'lps'),
	(395877, 102, '2015-02-15 00:33:34.000000', 'consum', 0.0219, 'lps'),
	(395878, 102, '2015-02-15 00:33:35.000000', 'consum', 0.0213, 'lps'),
	(395879, 102, '2015-02-15 00:33:36.000000', 'consum', 0.0219, 'lps'),
	(395880, 102, '2015-02-15 00:33:37.000000', 'consum', 0.0226, 'lps'),
	(395881, 102, '2015-02-15 00:33:38.000000', 'consum', 0.0222, 'lps'),
	(395882, 102, '2015-02-15 00:33:39.000000', 'consum', 0.0221, 'lps'),
	(395883, 102, '2015-02-15 00:33:40.000000', 'consum', 0.0212, 'lps'),
	(395884, 102, '2015-02-15 00:33:41.000000', 'consum', 0.0227, 'lps'),
	(395885, 102, '2015-02-15 00:33:42.000000', 'consum', 0.0228, 'lps'),
	(395886, 102, '2015-02-15 00:33:43.000000', 'consum', 0.0210, 'lps'),
	(395887, 102, '2015-02-15 00:33:44.000000', 'consum', 0.0215, 'lps'),
	(395888, 102, '2015-02-15 00:33:45.000000', 'consum', 0.0218, 'lps'),
	(395889, 102, '2015-02-15 00:33:46.000000', 'consum', 0.0214, 'lps'),
	(395890, 102, '2015-02-15 00:33:47.000000', 'consum', 0.0228, 'lps'),
	(395891, 102, '2015-02-15 00:33:48.000000', 'consum', 0.0226, 'lps'),
	(395892, 102, '2015-02-15 00:33:49.000000', 'consum', 0.0218, 'lps'),
	(395893, 102, '2015-02-15 00:33:50.000000', 'consum', 0.0224, 'lps'),
	(395894, 102, '2015-02-15 00:33:51.000000', 'consum', 0.0214, 'lps'),
	(395895, 102, '2015-02-15 00:33:52.000000', 'consum', 0.0229, 'lps'),
	(395896, 102, '2015-02-15 00:33:53.000000', 'consum', 0.0214, 'lps'),
	(395897, 102, '2015-02-15 00:33:54.000000', 'consum', 0.0211, 'lps'),
	(395898, 102, '2015-02-15 00:33:55.000000', 'consum', 0.0227, 'lps'),
	(395899, 102, '2015-02-15 00:33:56.000000', 'consum', 0.0212, 'lps'),
	(395900, 102, '2015-02-15 00:33:57.000000', 'consum', 0.0228, 'lps'),
	(395901, 102, '2015-02-15 00:33:58.000000', 'consum', 0.0217, 'lps'),
	(395902, 102, '2015-02-15 00:33:59.000000', 'consum', 0.0229, 'lps'),
	(395903, 102, '2015-02-15 00:34:00.000000', 'consum', 0.0225, 'lps'),
	(395904, 102, '2015-02-15 00:34:01.000000', 'consum', 0.0227, 'lps'),
	(395905, 102, '2015-02-15 00:34:02.000000', 'consum', 0.0212, 'lps'),
	(395906, 102, '2015-02-15 00:34:03.000000', 'consum', 0.0229, 'lps'),
	(395907, 102, '2015-02-15 00:34:04.000000', 'consum', 0.0220, 'lps'),
	(395908, 102, '2015-02-15 00:34:05.000000', 'consum', 0.0223, 'lps'),
	(395909, 102, '2015-02-15 00:34:06.000000', 'consum', 0.0226, 'lps'),
	(395910, 102, '2015-02-15 00:34:07.000000', 'consum', 0.0210, 'lps'),
	(395911, 102, '2015-02-15 00:34:08.000000', 'consum', 0.0222, 'lps'),
	(395912, 102, '2015-02-15 00:34:09.000000', 'consum', 0.0212, 'lps'),
	(395913, 102, '2015-02-15 00:34:10.000000', 'consum', 0.0222, 'lps'),
	(395914, 102, '2015-02-15 00:34:11.000000', 'consum', 0.0227, 'lps'),
	(395915, 102, '2015-02-15 00:34:12.000000', 'consum', 0.0221, 'lps'),
	(395916, 102, '2015-02-15 00:34:13.000000', 'consum', 0.0212, 'lps'),
	(395917, 102, '2015-02-15 00:34:14.000000', 'consum', 0.0228, 'lps'),
	(395918, 102, '2015-02-15 00:34:15.000000', 'consum', 0.0214, 'lps'),
	(395919, 102, '2015-02-15 00:34:16.000000', 'consum', 0.0215, 'lps'),
	(395920, 102, '2015-02-15 00:34:17.000000', 'consum', 0.0225, 'lps'),
	(395921, 102, '2015-02-15 00:34:18.000000', 'consum', 0.0211, 'lps'),
	(395922, 102, '2015-02-15 00:34:19.000000', 'consum', 0.0228, 'lps'),
	(395923, 102, '2015-02-15 00:34:20.000000', 'consum', 0.0220, 'lps'),
	(395924, 102, '2015-02-15 00:34:21.000000', 'consum', 0.0227, 'lps'),
	(395925, 102, '2015-02-15 00:34:22.000000', 'consum', 0.0224, 'lps'),
	(395926, 102, '2015-02-15 00:34:23.000000', 'consum', 0.0210, 'lps'),
	(395927, 102, '2015-02-15 00:34:24.000000', 'consum', 0.0210, 'lps'),
	(395928, 102, '2015-02-15 00:34:25.000000', 'consum', 0.0211, 'lps'),
	(395929, 102, '2015-02-15 00:34:26.000000', 'consum', 0.0216, 'lps'),
	(395930, 102, '2015-02-15 00:34:27.000000', 'consum', 0.0215, 'lps'),
	(395931, 102, '2015-02-15 00:34:28.000000', 'consum', 0.0220, 'lps'),
	(395932, 102, '2015-02-15 00:34:29.000000', 'consum', 0.0223, 'lps'),
	(395933, 102, '2015-02-15 00:34:30.000000', 'consum', 0.0228, 'lps'),
	(395934, 102, '2015-02-15 00:34:31.000000', 'consum', 0.0220, 'lps'),
	(395935, 102, '2015-02-15 00:34:32.000000', 'consum', 0.0226, 'lps'),
	(395936, 102, '2015-02-15 00:34:33.000000', 'consum', 0.0221, 'lps'),
	(395937, 102, '2015-02-15 00:34:34.000000', 'consum', 0.0219, 'lps'),
	(395938, 102, '2015-02-15 00:34:35.000000', 'consum', 0.0222, 'lps'),
	(395939, 102, '2015-02-15 00:34:36.000000', 'consum', 0.0225, 'lps'),
	(395940, 102, '2015-02-15 00:34:37.000000', 'consum', 0.0229, 'lps'),
	(395941, 102, '2015-02-15 00:34:38.000000', 'consum', 0.0220, 'lps'),
	(395942, 102, '2015-02-15 00:34:39.000000', 'consum', 0.0225, 'lps'),
	(395943, 102, '2015-02-15 00:34:40.000000', 'consum', 0.0215, 'lps'),
	(395944, 102, '2015-02-15 00:34:41.000000', 'consum', 0.0212, 'lps'),
	(395945, 102, '2015-02-15 00:34:42.000000', 'consum', 0.0224, 'lps'),
	(395946, 102, '2015-02-15 00:34:43.000000', 'consum', 0.0215, 'lps'),
	(395947, 102, '2015-02-15 00:34:44.000000', 'consum', 0.0215, 'lps'),
	(395948, 102, '2015-02-15 00:34:45.000000', 'consum', 0.0218, 'lps'),
	(395949, 102, '2015-02-15 00:34:46.000000', 'consum', 0.0216, 'lps'),
	(395950, 102, '2015-02-15 00:34:47.000000', 'consum', 0.0218, 'lps'),
	(395951, 102, '2015-02-15 00:34:48.000000', 'consum', 0.0213, 'lps'),
	(395952, 102, '2015-02-15 00:34:49.000000', 'consum', 0.0221, 'lps'),
	(395953, 102, '2015-02-15 00:34:50.000000', 'consum', 0.0216, 'lps'),
	(395954, 102, '2015-02-15 00:34:51.000000', 'consum', 0.0210, 'lps'),
	(395955, 102, '2015-02-15 00:34:52.000000', 'consum', 0.0229, 'lps'),
	(395956, 102, '2015-02-15 00:34:53.000000', 'consum', 0.0227, 'lps'),
	(395957, 102, '2015-02-15 00:34:54.000000', 'consum', 0.0218, 'lps'),
	(395958, 102, '2015-02-15 00:34:55.000000', 'consum', 0.0221, 'lps'),
	(395959, 102, '2015-02-15 00:34:56.000000', 'consum', 0.0221, 'lps'),
	(395960, 102, '2015-02-15 00:34:57.000000', 'consum', 0.0214, 'lps'),
	(395961, 102, '2015-02-15 00:34:58.000000', 'consum', 0.0216, 'lps'),
	(395962, 102, '2015-02-15 00:34:59.000000', 'consum', 0.0210, 'lps'),
	(395963, 102, '2015-02-15 00:35:00.000000', 'consum', 0.0213, 'lps'),
	(395964, 102, '2015-02-15 00:35:01.000000', 'consum', 0.0225, 'lps'),
	(395965, 102, '2015-02-15 00:35:02.000000', 'consum', 0.0215, 'lps'),
	(395966, 102, '2015-02-15 00:35:03.000000', 'consum', 0.0210, 'lps'),
	(395967, 102, '2015-02-15 00:35:04.000000', 'consum', 0.0217, 'lps'),
	(395968, 102, '2015-02-15 00:35:05.000000', 'consum', 0.0225, 'lps'),
	(395969, 102, '2015-02-15 00:35:06.000000', 'consum', 0.0223, 'lps'),
	(395970, 102, '2015-02-15 00:35:07.000000', 'consum', 0.0212, 'lps'),
	(395971, 102, '2015-02-15 00:35:08.000000', 'consum', 0.0222, 'lps'),
	(395972, 102, '2015-02-15 00:35:09.000000', 'consum', 0.0224, 'lps'),
	(395973, 102, '2015-02-15 00:35:10.000000', 'consum', 0.0226, 'lps'),
	(395974, 102, '2015-02-15 00:35:11.000000', 'consum', 0.0227, 'lps'),
	(395975, 102, '2015-02-15 00:35:12.000000', 'consum', 0.0226, 'lps'),
	(395976, 102, '2015-02-15 00:35:13.000000', 'consum', 0.0220, 'lps'),
	(395977, 102, '2015-02-15 00:35:14.000000', 'consum', 0.0214, 'lps'),
	(395978, 102, '2015-02-15 00:35:15.000000', 'consum', 0.0218, 'lps'),
	(395979, 102, '2015-02-15 00:35:16.000000', 'consum', 0.0220, 'lps'),
	(395980, 102, '2015-02-15 00:35:17.000000', 'consum', 0.0218, 'lps'),
	(395981, 102, '2015-02-15 00:35:18.000000', 'consum', 0.0221, 'lps'),
	(395982, 102, '2015-02-15 00:35:19.000000', 'consum', 0.0220, 'lps'),
	(395983, 102, '2015-02-15 00:35:20.000000', 'consum', 0.0227, 'lps'),
	(395984, 102, '2015-02-15 00:35:21.000000', 'consum', 0.0226, 'lps'),
	(395985, 102, '2015-02-15 00:35:22.000000', 'consum', 0.0219, 'lps'),
	(395986, 102, '2015-02-15 00:35:23.000000', 'consum', 0.0227, 'lps'),
	(395987, 102, '2015-02-15 00:35:24.000000', 'consum', 0.0211, 'lps'),
	(395988, 102, '2015-02-15 00:35:25.000000', 'consum', 0.0224, 'lps'),
	(395989, 102, '2015-02-15 00:35:26.000000', 'consum', 0.0216, 'lps'),
	(395990, 102, '2015-02-15 00:35:27.000000', 'consum', 0.0220, 'lps'),
	(395991, 102, '2015-02-15 00:35:28.000000', 'consum', 0.0221, 'lps'),
	(395992, 102, '2015-02-15 00:35:29.000000', 'consum', 0.0215, 'lps'),
	(395993, 102, '2015-02-15 00:35:30.000000', 'consum', 0.0225, 'lps'),
	(395994, 102, '2015-02-15 00:35:31.000000', 'consum', 0.0228, 'lps'),
	(395995, 102, '2015-02-15 00:35:32.000000', 'consum', 0.0218, 'lps'),
	(395996, 102, '2015-02-15 00:35:33.000000', 'consum', 0.0216, 'lps'),
	(395997, 102, '2015-02-15 00:35:34.000000', 'consum', 0.0216, 'lps'),
	(395998, 102, '2015-02-15 00:35:35.000000', 'consum', 0.0222, 'lps'),
	(395999, 102, '2015-02-15 00:35:36.000000', 'consum', 0.0213, 'lps'),
	(396000, 102, '2015-02-15 00:35:37.000000', 'consum', 0.0210, 'lps'),
	(396001, 102, '2015-02-15 00:35:38.000000', 'consum', 0.0221, 'lps'),
	(396002, 102, '2015-02-15 00:35:39.000000', 'consum', 0.0226, 'lps'),
	(396003, 102, '2015-02-15 00:35:40.000000', 'consum', 0.0219, 'lps'),
	(396004, 102, '2015-02-15 00:35:41.000000', 'consum', 0.0225, 'lps'),
	(396005, 102, '2015-02-15 00:35:42.000000', 'consum', 0.0218, 'lps'),
	(396006, 102, '2015-02-15 00:35:43.000000', 'consum', 0.0224, 'lps'),
	(396007, 102, '2015-02-15 00:35:44.000000', 'consum', 0.0220, 'lps'),
	(396008, 102, '2015-02-15 00:35:45.000000', 'consum', 0.0217, 'lps'),
	(396009, 102, '2015-02-15 00:35:46.000000', 'consum', 0.0218, 'lps'),
	(396010, 102, '2015-02-15 00:35:47.000000', 'consum', 0.0227, 'lps'),
	(396011, 102, '2015-02-15 00:35:48.000000', 'consum', 0.0212, 'lps'),
	(396012, 102, '2015-02-15 00:35:49.000000', 'consum', 0.0212, 'lps'),
	(396013, 102, '2015-02-15 00:35:50.000000', 'consum', 0.0211, 'lps'),
	(396014, 102, '2015-02-15 00:35:51.000000', 'consum', 0.0211, 'lps'),
	(396015, 102, '2015-02-15 00:35:52.000000', 'consum', 0.0214, 'lps'),
	(396016, 102, '2015-02-15 00:35:53.000000', 'consum', 0.0228, 'lps'),
	(396017, 102, '2015-02-15 00:35:54.000000', 'consum', 0.0228, 'lps'),
	(396018, 102, '2015-02-15 00:35:55.000000', 'consum', 0.0228, 'lps'),
	(396019, 102, '2015-02-15 00:35:56.000000', 'consum', 0.0225, 'lps'),
	(396020, 102, '2015-02-15 00:35:57.000000', 'consum', 0.0212, 'lps'),
	(396021, 102, '2015-02-15 00:35:58.000000', 'consum', 0.0214, 'lps'),
	(396022, 102, '2015-02-15 00:35:59.000000', 'consum', 0.0225, 'lps'),
	(396023, 102, '2015-02-15 00:36:00.000000', 'consum', 0.0214, 'lps'),
	(396024, 102, '2015-02-15 00:36:01.000000', 'consum', 0.0223, 'lps'),
	(396025, 102, '2015-02-15 00:36:02.000000', 'consum', 0.0226, 'lps'),
	(396026, 102, '2015-02-15 00:36:03.000000', 'consum', 0.0212, 'lps'),
	(396027, 102, '2015-02-15 00:36:04.000000', 'consum', 0.0210, 'lps'),
	(396028, 102, '2015-02-15 00:36:05.000000', 'consum', 0.0225, 'lps'),
	(396029, 102, '2015-02-15 00:36:06.000000', 'consum', 0.0225, 'lps'),
	(396030, 102, '2015-02-15 00:36:07.000000', 'consum', 0.0223, 'lps'),
	(396031, 102, '2015-02-15 00:36:08.000000', 'consum', 0.0228, 'lps'),
	(396032, 102, '2015-02-15 00:36:09.000000', 'consum', 0.0221, 'lps'),
	(396033, 102, '2015-02-15 00:36:10.000000', 'consum', 0.0211, 'lps'),
	(396034, 102, '2015-02-15 00:36:11.000000', 'consum', 0.0223, 'lps'),
	(396035, 102, '2015-02-15 00:36:12.000000', 'consum', 0.0215, 'lps'),
	(396036, 102, '2015-02-15 00:36:13.000000', 'consum', 0.0215, 'lps'),
	(396037, 102, '2015-02-15 00:36:14.000000', 'consum', 0.0219, 'lps'),
	(396038, 102, '2015-02-15 00:36:15.000000', 'consum', 0.0221, 'lps'),
	(396039, 102, '2015-02-15 00:36:16.000000', 'consum', 0.0220, 'lps'),
	(396040, 102, '2015-02-15 00:36:17.000000', 'consum', 0.0225, 'lps'),
	(396041, 102, '2015-02-15 00:36:18.000000', 'consum', 0.0218, 'lps'),
	(396042, 102, '2015-02-15 00:36:19.000000', 'consum', 0.0224, 'lps'),
	(396043, 102, '2015-02-15 00:36:20.000000', 'consum', 0.0217, 'lps'),
	(396044, 102, '2015-02-15 00:36:21.000000', 'consum', 0.0224, 'lps'),
	(396045, 102, '2015-02-15 00:36:22.000000', 'consum', 0.0221, 'lps'),
	(396046, 102, '2015-02-15 00:36:23.000000', 'consum', 0.0223, 'lps'),
	(396047, 102, '2015-02-15 00:36:24.000000', 'consum', 0.0221, 'lps'),
	(396048, 102, '2015-02-15 00:36:25.000000', 'consum', 0.0227, 'lps'),
	(396049, 102, '2015-02-15 00:36:26.000000', 'consum', 0.0224, 'lps'),
	(396050, 102, '2015-02-15 00:36:27.000000', 'consum', 0.0227, 'lps'),
	(396051, 102, '2015-02-15 00:36:28.000000', 'consum', 0.0213, 'lps'),
	(396052, 102, '2015-02-15 00:36:29.000000', 'consum', 0.0217, 'lps'),
	(396053, 102, '2015-02-15 00:36:30.000000', 'consum', 0.0215, 'lps'),
	(396054, 102, '2015-02-15 00:36:31.000000', 'consum', 0.0216, 'lps'),
	(396055, 102, '2015-02-15 00:36:32.000000', 'consum', 0.0223, 'lps'),
	(396056, 102, '2015-02-15 00:36:33.000000', 'consum', 0.0217, 'lps'),
	(396057, 102, '2015-02-15 00:36:34.000000', 'consum', 0.0227, 'lps'),
	(396058, 102, '2015-02-15 00:36:35.000000', 'consum', 0.0214, 'lps'),
	(396059, 102, '2015-02-15 00:36:36.000000', 'consum', 0.0222, 'lps'),
	(396060, 102, '2015-02-15 00:36:37.000000', 'consum', 0.0218, 'lps'),
	(396061, 102, '2015-02-15 00:36:38.000000', 'consum', 0.0213, 'lps'),
	(396062, 102, '2015-02-15 00:36:39.000000', 'consum', 0.0224, 'lps'),
	(396063, 102, '2015-02-15 00:36:40.000000', 'consum', 0.0210, 'lps'),
	(396064, 102, '2015-02-15 00:36:41.000000', 'consum', 0.0229, 'lps'),
	(396065, 102, '2015-02-15 00:36:42.000000', 'consum', 0.0224, 'lps'),
	(396066, 102, '2015-02-15 00:36:43.000000', 'consum', 0.0226, 'lps'),
	(396067, 102, '2015-02-15 00:36:44.000000', 'consum', 0.0227, 'lps'),
	(396068, 102, '2015-02-15 00:36:45.000000', 'consum', 0.0210, 'lps'),
	(396069, 102, '2015-02-15 00:36:46.000000', 'consum', 0.0216, 'lps'),
	(396070, 102, '2015-02-15 00:36:47.000000', 'consum', 0.0222, 'lps'),
	(396071, 102, '2015-02-15 00:36:48.000000', 'consum', 0.0214, 'lps'),
	(396072, 102, '2015-02-15 00:36:49.000000', 'consum', 0.0213, 'lps'),
	(396073, 102, '2015-02-15 00:36:50.000000', 'consum', 0.0212, 'lps'),
	(396074, 102, '2015-02-15 00:36:51.000000', 'consum', 0.0214, 'lps'),
	(396075, 102, '2015-02-15 00:36:52.000000', 'consum', 0.0226, 'lps'),
	(396076, 102, '2015-02-15 00:36:53.000000', 'consum', 0.0215, 'lps'),
	(396077, 102, '2015-02-15 00:36:54.000000', 'consum', 0.0210, 'lps'),
	(396078, 102, '2015-02-15 00:36:55.000000', 'consum', 0.0217, 'lps'),
	(396079, 102, '2015-02-15 00:36:56.000000', 'consum', 0.0222, 'lps'),
	(396080, 102, '2015-02-15 00:36:57.000000', 'consum', 0.0210, 'lps'),
	(396081, 102, '2015-02-15 00:36:58.000000', 'consum', 0.0215, 'lps'),
	(396082, 102, '2015-02-15 00:36:59.000000', 'consum', 0.0216, 'lps'),
	(396083, 102, '2015-02-15 00:37:00.000000', 'consum', 0.0224, 'lps'),
	(396084, 102, '2015-02-15 00:37:01.000000', 'consum', 0.0223, 'lps'),
	(396085, 102, '2015-02-15 00:37:02.000000', 'consum', 0.0214, 'lps'),
	(396086, 102, '2015-02-15 00:37:03.000000', 'consum', 0.0210, 'lps'),
	(396087, 102, '2015-02-15 00:37:04.000000', 'consum', 0.0221, 'lps'),
	(396088, 102, '2015-02-15 00:37:05.000000', 'consum', 0.0224, 'lps'),
	(396089, 102, '2015-02-15 00:37:06.000000', 'consum', 0.0210, 'lps'),
	(396090, 102, '2015-02-15 00:37:07.000000', 'consum', 0.0226, 'lps'),
	(396091, 102, '2015-02-15 00:37:08.000000', 'consum', 0.0211, 'lps'),
	(396092, 102, '2015-02-15 00:37:09.000000', 'consum', 0.0227, 'lps'),
	(396093, 102, '2015-02-15 00:37:10.000000', 'consum', 0.0212, 'lps'),
	(396094, 102, '2015-02-15 00:37:11.000000', 'consum', 0.0212, 'lps'),
	(396095, 102, '2015-02-15 00:37:12.000000', 'consum', 0.0212, 'lps'),
	(396096, 102, '2015-02-15 00:37:13.000000', 'consum', 0.0217, 'lps'),
	(396097, 102, '2015-02-15 00:37:14.000000', 'consum', 0.0220, 'lps'),
	(396098, 102, '2015-02-15 00:37:15.000000', 'consum', 0.0217, 'lps'),
	(396099, 102, '2015-02-15 00:37:16.000000', 'consum', 0.0216, 'lps'),
	(396100, 102, '2015-02-15 00:37:17.000000', 'consum', 0.0221, 'lps'),
	(396101, 102, '2015-02-15 00:37:18.000000', 'consum', 0.0226, 'lps'),
	(396102, 102, '2015-02-15 00:37:19.000000', 'consum', 0.0217, 'lps'),
	(396103, 102, '2015-02-15 00:37:20.000000', 'consum', 0.0216, 'lps'),
	(396104, 102, '2015-02-15 00:37:21.000000', 'consum', 0.0223, 'lps'),
	(396105, 102, '2015-02-15 00:37:22.000000', 'consum', 0.0214, 'lps'),
	(396106, 102, '2015-02-15 00:37:23.000000', 'consum', 0.0213, 'lps'),
	(396107, 102, '2015-02-15 00:37:24.000000', 'consum', 0.0215, 'lps'),
	(396108, 102, '2015-02-15 00:37:25.000000', 'consum', 0.0227, 'lps'),
	(396109, 102, '2015-02-15 00:37:26.000000', 'consum', 0.0220, 'lps'),
	(396110, 102, '2015-02-15 00:37:27.000000', 'consum', 0.0228, 'lps'),
	(396111, 102, '2015-02-15 00:37:28.000000', 'consum', 0.0211, 'lps'),
	(396112, 102, '2015-02-15 00:37:29.000000', 'consum', 0.0221, 'lps'),
	(396113, 102, '2015-02-15 00:37:30.000000', 'consum', 0.0225, 'lps'),
	(396114, 102, '2015-02-15 00:37:31.000000', 'consum', 0.0210, 'lps'),
	(396115, 102, '2015-02-15 00:37:32.000000', 'consum', 0.0228, 'lps'),
	(396116, 102, '2015-02-15 00:37:33.000000', 'consum', 0.0217, 'lps'),
	(396117, 102, '2015-02-15 00:37:34.000000', 'consum', 0.0215, 'lps'),
	(396118, 102, '2015-02-15 00:37:35.000000', 'consum', 0.0211, 'lps'),
	(396119, 102, '2015-02-15 00:37:36.000000', 'consum', 0.0223, 'lps'),
	(396120, 102, '2015-02-15 00:37:37.000000', 'consum', 0.0210, 'lps'),
	(396121, 102, '2015-02-15 00:37:38.000000', 'consum', 0.0213, 'lps'),
	(396122, 102, '2015-02-15 00:37:39.000000', 'consum', 0.0224, 'lps'),
	(396123, 102, '2015-02-15 00:37:40.000000', 'consum', 0.0213, 'lps'),
	(396124, 102, '2015-02-15 00:37:41.000000', 'consum', 0.0221, 'lps'),
	(396125, 102, '2015-02-15 00:37:42.000000', 'consum', 0.0218, 'lps'),
	(396126, 102, '2015-02-15 00:37:43.000000', 'consum', 0.0219, 'lps'),
	(396127, 102, '2015-02-15 00:37:44.000000', 'consum', 0.0229, 'lps'),
	(396128, 102, '2015-02-15 00:37:45.000000', 'consum', 0.0219, 'lps'),
	(396129, 102, '2015-02-15 00:37:46.000000', 'consum', 0.0220, 'lps'),
	(396130, 102, '2015-02-15 00:37:47.000000', 'consum', 0.0214, 'lps'),
	(396131, 102, '2015-02-15 00:37:48.000000', 'consum', 0.0219, 'lps'),
	(396132, 102, '2015-02-15 00:37:49.000000', 'consum', 0.0224, 'lps'),
	(396133, 102, '2015-02-15 00:37:50.000000', 'consum', 0.0212, 'lps'),
	(396134, 102, '2015-02-15 00:37:51.000000', 'consum', 0.0218, 'lps'),
	(396135, 102, '2015-02-15 00:37:52.000000', 'consum', 0.0224, 'lps'),
	(396136, 102, '2015-02-15 00:37:53.000000', 'consum', 0.0216, 'lps'),
	(396137, 102, '2015-02-15 00:37:54.000000', 'consum', 0.0221, 'lps'),
	(396138, 102, '2015-02-15 00:37:55.000000', 'consum', 0.0227, 'lps'),
	(396139, 102, '2015-02-15 00:37:56.000000', 'consum', 0.0222, 'lps'),
	(396140, 102, '2015-02-15 00:37:57.000000', 'consum', 0.0220, 'lps'),
	(396141, 102, '2015-02-15 00:37:58.000000', 'consum', 0.0226, 'lps'),
	(396142, 102, '2015-02-15 00:37:59.000000', 'consum', 0.0219, 'lps'),
	(396143, 102, '2015-02-15 00:38:00.000000', 'consum', 0.0228, 'lps'),
	(396144, 102, '2015-02-15 00:38:01.000000', 'consum', 0.0213, 'lps'),
	(396145, 102, '2015-02-15 00:38:02.000000', 'consum', 0.0213, 'lps'),
	(396146, 102, '2015-02-15 00:38:03.000000', 'consum', 0.0214, 'lps'),
	(396147, 102, '2015-02-15 00:38:04.000000', 'consum', 0.0221, 'lps'),
	(396148, 102, '2015-02-15 00:38:05.000000', 'consum', 0.0215, 'lps'),
	(396149, 102, '2015-02-15 00:38:06.000000', 'consum', 0.0224, 'lps'),
	(396150, 102, '2015-02-15 00:38:07.000000', 'consum', 0.0223, 'lps'),
	(396151, 102, '2015-02-15 00:38:08.000000', 'consum', 0.0216, 'lps'),
	(396152, 102, '2015-02-15 00:38:09.000000', 'consum', 0.0221, 'lps'),
	(396153, 102, '2015-02-15 00:38:10.000000', 'consum', 0.0227, 'lps'),
	(396154, 102, '2015-02-15 00:38:11.000000', 'consum', 0.0224, 'lps'),
	(396155, 102, '2015-02-15 00:38:12.000000', 'consum', 0.0229, 'lps'),
	(396156, 102, '2015-02-15 00:38:13.000000', 'consum', 0.0224, 'lps'),
	(396157, 102, '2015-02-15 00:38:14.000000', 'consum', 0.0221, 'lps'),
	(396158, 102, '2015-02-15 00:38:15.000000', 'consum', 0.0226, 'lps'),
	(396159, 102, '2015-02-15 00:38:16.000000', 'consum', 0.0216, 'lps'),
	(396160, 102, '2015-02-15 00:38:17.000000', 'consum', 0.0213, 'lps'),
	(396161, 102, '2015-02-15 00:38:18.000000', 'consum', 0.0227, 'lps'),
	(396162, 102, '2015-02-15 00:38:19.000000', 'consum', 0.0227, 'lps'),
	(396163, 102, '2015-02-15 00:38:20.000000', 'consum', 0.0226, 'lps'),
	(396164, 102, '2015-02-15 00:38:21.000000', 'consum', 0.0220, 'lps'),
	(396165, 102, '2015-02-15 00:38:22.000000', 'consum', 0.0211, 'lps'),
	(396166, 102, '2015-02-15 00:38:23.000000', 'consum', 0.0225, 'lps'),
	(396167, 102, '2015-02-15 00:38:24.000000', 'consum', 0.0225, 'lps'),
	(396168, 102, '2015-02-15 00:38:25.000000', 'consum', 0.0220, 'lps'),
	(396169, 102, '2015-02-15 00:38:26.000000', 'consum', 0.0214, 'lps'),
	(396170, 102, '2015-02-15 00:38:27.000000', 'consum', 0.0220, 'lps'),
	(396171, 102, '2015-02-15 00:38:28.000000', 'consum', 0.0228, 'lps'),
	(396172, 102, '2015-02-15 00:38:29.000000', 'consum', 0.0212, 'lps'),
	(396173, 102, '2015-02-15 00:38:30.000000', 'consum', 0.0227, 'lps'),
	(396174, 102, '2015-02-15 00:38:31.000000', 'consum', 0.0228, 'lps'),
	(396175, 102, '2015-02-15 00:38:32.000000', 'consum', 0.0212, 'lps'),
	(396176, 102, '2015-02-15 00:38:33.000000', 'consum', 0.0224, 'lps'),
	(396177, 102, '2015-02-15 00:38:34.000000', 'consum', 0.0215, 'lps'),
	(396178, 102, '2015-02-15 00:38:35.000000', 'consum', 0.0212, 'lps'),
	(396179, 102, '2015-02-15 00:38:36.000000', 'consum', 0.0227, 'lps'),
	(396180, 102, '2015-02-15 00:38:37.000000', 'consum', 0.0228, 'lps'),
	(396181, 102, '2015-02-15 00:38:38.000000', 'consum', 0.0229, 'lps'),
	(396182, 102, '2015-02-15 00:38:39.000000', 'consum', 0.0215, 'lps'),
	(396183, 102, '2015-02-15 00:38:40.000000', 'consum', 0.0215, 'lps'),
	(396184, 102, '2015-02-15 00:38:41.000000', 'consum', 0.0222, 'lps'),
	(396185, 102, '2015-02-15 00:38:42.000000', 'consum', 0.0216, 'lps'),
	(396186, 102, '2015-02-15 00:38:43.000000', 'consum', 0.0225, 'lps'),
	(396187, 102, '2015-02-15 00:38:44.000000', 'consum', 0.0228, 'lps'),
	(396188, 102, '2015-02-15 00:38:45.000000', 'consum', 0.0213, 'lps'),
	(396189, 102, '2015-02-15 00:38:46.000000', 'consum', 0.0214, 'lps'),
	(396190, 102, '2015-02-15 00:38:47.000000', 'consum', 0.0222, 'lps'),
	(396191, 102, '2015-02-15 00:38:48.000000', 'consum', 0.0217, 'lps'),
	(396192, 102, '2015-02-15 00:38:49.000000', 'consum', 0.0229, 'lps'),
	(396193, 102, '2015-02-15 00:38:50.000000', 'consum', 0.0226, 'lps'),
	(396194, 102, '2015-02-15 00:38:51.000000', 'consum', 0.0213, 'lps'),
	(396195, 102, '2015-02-15 00:38:52.000000', 'consum', 0.0219, 'lps'),
	(396196, 102, '2015-02-15 00:38:53.000000', 'consum', 0.0226, 'lps'),
	(396197, 102, '2015-02-15 00:38:54.000000', 'consum', 0.0221, 'lps'),
	(396198, 102, '2015-02-15 00:38:55.000000', 'consum', 0.0220, 'lps'),
	(396199, 102, '2015-02-15 00:38:56.000000', 'consum', 0.0228, 'lps'),
	(396200, 102, '2015-02-15 00:38:57.000000', 'consum', 0.0210, 'lps'),
	(396201, 102, '2015-02-15 00:38:58.000000', 'consum', 0.0216, 'lps'),
	(396202, 102, '2015-02-15 00:38:59.000000', 'consum', 0.0221, 'lps'),
	(396203, 102, '2015-02-15 00:39:00.000000', 'consum', 0.0227, 'lps'),
	(396204, 102, '2015-02-15 00:39:01.000000', 'consum', 0.0223, 'lps'),
	(396205, 102, '2015-02-15 00:39:02.000000', 'consum', 0.0223, 'lps'),
	(396206, 102, '2015-02-15 00:39:03.000000', 'consum', 0.0217, 'lps'),
	(396207, 102, '2015-02-15 00:39:04.000000', 'consum', 0.0227, 'lps'),
	(396208, 102, '2015-02-15 00:39:05.000000', 'consum', 0.0216, 'lps'),
	(396209, 102, '2015-02-15 00:39:06.000000', 'consum', 0.0229, 'lps'),
	(396210, 102, '2015-02-15 00:39:07.000000', 'consum', 0.0225, 'lps'),
	(396211, 102, '2015-02-15 00:39:08.000000', 'consum', 0.0211, 'lps'),
	(396212, 102, '2015-02-15 00:39:09.000000', 'consum', 0.0211, 'lps'),
	(396213, 102, '2015-02-15 00:39:10.000000', 'consum', 0.0213, 'lps'),
	(396214, 102, '2015-02-15 00:39:11.000000', 'consum', 0.0220, 'lps'),
	(396215, 102, '2015-02-15 00:39:12.000000', 'consum', 0.0214, 'lps'),
	(396216, 102, '2015-02-15 00:39:13.000000', 'consum', 0.0220, 'lps'),
	(396217, 102, '2015-02-15 00:39:14.000000', 'consum', 0.0210, 'lps'),
	(396218, 102, '2015-02-15 00:39:15.000000', 'consum', 0.0218, 'lps'),
	(396219, 102, '2015-02-15 00:39:16.000000', 'consum', 0.0212, 'lps'),
	(396220, 102, '2015-02-15 00:39:17.000000', 'consum', 0.0215, 'lps'),
	(396221, 102, '2015-02-15 00:39:18.000000', 'consum', 0.0212, 'lps'),
	(396222, 102, '2015-02-15 00:39:19.000000', 'consum', 0.0222, 'lps'),
	(396223, 102, '2015-02-15 00:39:20.000000', 'consum', 0.0227, 'lps'),
	(396224, 102, '2015-02-15 00:39:21.000000', 'consum', 0.0220, 'lps'),
	(396225, 102, '2015-02-15 00:39:22.000000', 'consum', 0.0228, 'lps'),
	(396226, 102, '2015-02-15 00:39:23.000000', 'consum', 0.0210, 'lps'),
	(396227, 102, '2015-02-15 00:39:24.000000', 'consum', 0.0219, 'lps'),
	(396228, 102, '2015-02-15 00:39:25.000000', 'consum', 0.0215, 'lps'),
	(396229, 102, '2015-02-15 00:39:26.000000', 'consum', 0.0227, 'lps'),
	(396230, 102, '2015-02-15 00:39:27.000000', 'consum', 0.0222, 'lps'),
	(396231, 102, '2015-02-15 00:39:28.000000', 'consum', 0.0217, 'lps'),
	(396232, 102, '2015-02-15 00:39:29.000000', 'consum', 0.0210, 'lps'),
	(396233, 102, '2015-02-15 00:39:30.000000', 'consum', 0.0211, 'lps'),
	(396234, 102, '2015-02-15 00:39:31.000000', 'consum', 0.0214, 'lps'),
	(396235, 102, '2015-02-15 00:39:32.000000', 'consum', 0.0228, 'lps'),
	(396236, 102, '2015-02-15 00:39:33.000000', 'consum', 0.0227, 'lps'),
	(396237, 102, '2015-02-15 00:39:34.000000', 'consum', 0.0223, 'lps'),
	(396238, 102, '2015-02-15 00:39:35.000000', 'consum', 0.0223, 'lps'),
	(396239, 102, '2015-02-15 00:39:36.000000', 'consum', 0.0216, 'lps'),
	(396240, 102, '2015-02-15 00:39:37.000000', 'consum', 0.0224, 'lps'),
	(396241, 102, '2015-02-15 00:39:38.000000', 'consum', 0.0220, 'lps'),
	(396242, 102, '2015-02-15 00:39:39.000000', 'consum', 0.0220, 'lps'),
	(396243, 102, '2015-02-15 00:39:40.000000', 'consum', 0.0211, 'lps'),
	(396244, 102, '2015-02-15 00:39:41.000000', 'consum', 0.0225, 'lps'),
	(396245, 102, '2015-02-15 00:39:42.000000', 'consum', 0.0222, 'lps'),
	(396246, 102, '2015-02-15 00:39:43.000000', 'consum', 0.0227, 'lps'),
	(396247, 102, '2015-02-15 00:39:44.000000', 'consum', 0.0219, 'lps'),
	(396248, 102, '2015-02-15 00:39:45.000000', 'consum', 0.0224, 'lps'),
	(396249, 102, '2015-02-15 00:39:46.000000', 'consum', 0.0215, 'lps'),
	(396250, 102, '2015-02-15 00:39:47.000000', 'consum', 0.0211, 'lps'),
	(396251, 102, '2015-02-15 00:39:48.000000', 'consum', 0.0220, 'lps'),
	(396252, 102, '2015-02-15 00:39:49.000000', 'consum', 0.0218, 'lps'),
	(396253, 102, '2015-02-15 00:39:50.000000', 'consum', 0.0220, 'lps'),
	(396254, 102, '2015-02-15 00:39:51.000000', 'consum', 0.0216, 'lps'),
	(396255, 102, '2015-02-15 00:39:52.000000', 'consum', 0.0212, 'lps'),
	(396256, 102, '2015-02-15 00:39:53.000000', 'consum', 0.0221, 'lps'),
	(396257, 102, '2015-02-15 00:39:54.000000', 'consum', 0.0221, 'lps'),
	(396258, 102, '2015-02-15 00:39:55.000000', 'consum', 0.0210, 'lps'),
	(396259, 102, '2015-02-15 00:39:56.000000', 'consum', 0.0219, 'lps'),
	(396260, 102, '2015-02-15 00:39:57.000000', 'consum', 0.0216, 'lps'),
	(396261, 102, '2015-02-15 00:39:58.000000', 'consum', 0.0213, 'lps'),
	(396262, 102, '2015-02-15 00:39:59.000000', 'consum', 0.0227, 'lps'),
	(396263, 102, '2015-02-15 00:40:00.000000', 'consum', 0.0227, 'lps'),
	(396264, 102, '2015-02-15 00:40:01.000000', 'consum', 0.0225, 'lps'),
	(396265, 102, '2015-02-15 00:40:02.000000', 'consum', 0.0212, 'lps'),
	(396266, 102, '2015-02-15 00:40:03.000000', 'consum', 0.0217, 'lps'),
	(396267, 102, '2015-02-15 00:40:04.000000', 'consum', 0.0221, 'lps'),
	(396268, 102, '2015-02-15 00:40:05.000000', 'consum', 0.0223, 'lps'),
	(396269, 102, '2015-02-15 00:40:06.000000', 'consum', 0.0222, 'lps'),
	(396270, 102, '2015-02-15 00:40:07.000000', 'consum', 0.0211, 'lps'),
	(396271, 102, '2015-02-15 00:40:08.000000', 'consum', 0.0219, 'lps'),
	(396272, 102, '2015-02-15 00:40:09.000000', 'consum', 0.0215, 'lps'),
	(396273, 102, '2015-02-15 00:40:10.000000', 'consum', 0.0226, 'lps'),
	(396274, 102, '2015-02-15 00:40:11.000000', 'consum', 0.0216, 'lps'),
	(396275, 102, '2015-02-15 00:40:12.000000', 'consum', 0.0212, 'lps'),
	(396276, 102, '2015-02-15 00:40:13.000000', 'consum', 0.0223, 'lps'),
	(396277, 102, '2015-02-15 00:40:14.000000', 'consum', 0.0210, 'lps'),
	(396278, 102, '2015-02-15 00:40:15.000000', 'consum', 0.0212, 'lps'),
	(396279, 102, '2015-02-15 00:40:16.000000', 'consum', 0.0220, 'lps'),
	(396280, 102, '2015-02-15 00:40:17.000000', 'consum', 0.0214, 'lps'),
	(396281, 102, '2015-02-15 00:40:18.000000', 'consum', 0.0223, 'lps'),
	(396282, 102, '2015-02-15 00:40:19.000000', 'consum', 0.0221, 'lps'),
	(396283, 102, '2015-02-15 00:40:20.000000', 'consum', 0.0229, 'lps'),
	(396284, 102, '2015-02-15 00:40:21.000000', 'consum', 0.0211, 'lps'),
	(396285, 102, '2015-02-15 00:40:22.000000', 'consum', 0.0219, 'lps'),
	(396286, 102, '2015-02-15 00:40:23.000000', 'consum', 0.0214, 'lps'),
	(396287, 102, '2015-02-15 00:40:24.000000', 'consum', 0.0224, 'lps'),
	(396288, 102, '2015-02-15 00:40:25.000000', 'consum', 0.0227, 'lps'),
	(396289, 102, '2015-02-15 00:40:26.000000', 'consum', 0.0215, 'lps'),
	(396290, 102, '2015-02-15 00:40:27.000000', 'consum', 0.0225, 'lps'),
	(396291, 102, '2015-02-15 00:40:28.000000', 'consum', 0.0228, 'lps'),
	(396292, 102, '2015-02-15 00:40:29.000000', 'consum', 0.0217, 'lps'),
	(396293, 102, '2015-02-15 00:40:30.000000', 'consum', 0.0211, 'lps'),
	(396294, 102, '2015-02-15 00:40:31.000000', 'consum', 0.0214, 'lps'),
	(396295, 102, '2015-02-15 00:40:32.000000', 'consum', 0.0229, 'lps'),
	(396296, 102, '2015-02-15 00:40:33.000000', 'consum', 0.0212, 'lps'),
	(396297, 102, '2015-02-15 00:40:34.000000', 'consum', 0.0223, 'lps'),
	(396298, 102, '2015-02-15 00:40:35.000000', 'consum', 0.0212, 'lps'),
	(396299, 102, '2015-02-15 00:40:36.000000', 'consum', 0.0220, 'lps'),
	(396300, 102, '2015-02-15 00:40:37.000000', 'consum', 0.0213, 'lps'),
	(396301, 102, '2015-02-15 00:40:38.000000', 'consum', 0.0215, 'lps'),
	(396302, 102, '2015-02-15 00:40:39.000000', 'consum', 0.0226, 'lps'),
	(396303, 102, '2015-02-15 00:40:40.000000', 'consum', 0.0217, 'lps'),
	(396304, 102, '2015-02-15 00:40:41.000000', 'consum', 0.0219, 'lps'),
	(396305, 102, '2015-02-15 00:40:42.000000', 'consum', 0.0213, 'lps'),
	(396306, 102, '2015-02-15 00:40:43.000000', 'consum', 0.0217, 'lps'),
	(396307, 102, '2015-02-15 00:40:44.000000', 'consum', 0.0217, 'lps'),
	(396308, 102, '2015-02-15 00:40:45.000000', 'consum', 0.0223, 'lps'),
	(396309, 102, '2015-02-15 00:40:46.000000', 'consum', 0.0217, 'lps'),
	(396310, 102, '2015-02-15 00:40:47.000000', 'consum', 0.0227, 'lps'),
	(396311, 102, '2015-02-15 00:40:48.000000', 'consum', 0.0213, 'lps'),
	(396312, 102, '2015-02-15 00:40:49.000000', 'consum', 0.0215, 'lps'),
	(396313, 102, '2015-02-15 00:40:50.000000', 'consum', 0.0226, 'lps'),
	(396314, 102, '2015-02-15 00:40:51.000000', 'consum', 0.0215, 'lps'),
	(396315, 102, '2015-02-15 00:40:52.000000', 'consum', 0.0229, 'lps'),
	(396316, 102, '2015-02-15 00:40:53.000000', 'consum', 0.0210, 'lps'),
	(396317, 102, '2015-02-15 00:40:54.000000', 'consum', 0.0213, 'lps'),
	(396318, 102, '2015-02-15 00:40:55.000000', 'consum', 0.0224, 'lps'),
	(396319, 102, '2015-02-15 00:40:56.000000', 'consum', 0.0213, 'lps'),
	(396320, 102, '2015-02-15 00:40:57.000000', 'consum', 0.0221, 'lps'),
	(396321, 102, '2015-02-15 00:40:58.000000', 'consum', 0.0220, 'lps'),
	(396322, 102, '2015-02-15 00:40:59.000000', 'consum', 0.0225, 'lps'),
	(396323, 102, '2015-02-15 00:41:00.000000', 'consum', 0.0216, 'lps'),
	(396324, 102, '2015-02-15 00:41:01.000000', 'consum', 0.0216, 'lps'),
	(396325, 102, '2015-02-15 00:41:02.000000', 'consum', 0.0222, 'lps'),
	(396326, 102, '2015-02-15 00:41:03.000000', 'consum', 0.0214, 'lps'),
	(396327, 102, '2015-02-15 00:41:04.000000', 'consum', 0.0214, 'lps'),
	(396328, 102, '2015-02-15 00:41:05.000000', 'consum', 0.0218, 'lps'),
	(396329, 102, '2015-02-15 00:41:06.000000', 'consum', 0.0217, 'lps'),
	(396330, 102, '2015-02-15 00:41:07.000000', 'consum', 0.0221, 'lps'),
	(396331, 102, '2015-02-15 00:41:08.000000', 'consum', 0.0225, 'lps'),
	(396332, 102, '2015-02-15 00:41:09.000000', 'consum', 0.0213, 'lps'),
	(396333, 102, '2015-02-15 00:41:10.000000', 'consum', 0.0219, 'lps'),
	(396334, 102, '2015-02-15 00:41:11.000000', 'consum', 0.0228, 'lps'),
	(396335, 102, '2015-02-15 00:41:12.000000', 'consum', 0.0212, 'lps'),
	(396336, 102, '2015-02-15 00:41:13.000000', 'consum', 0.0227, 'lps'),
	(396337, 102, '2015-02-15 00:41:14.000000', 'consum', 0.0211, 'lps'),
	(396338, 102, '2015-02-15 00:41:15.000000', 'consum', 0.0223, 'lps'),
	(396339, 102, '2015-02-15 00:41:16.000000', 'consum', 0.0212, 'lps'),
	(396340, 102, '2015-02-15 00:41:17.000000', 'consum', 0.0223, 'lps'),
	(396341, 102, '2015-02-15 00:41:18.000000', 'consum', 0.0227, 'lps'),
	(396342, 102, '2015-02-15 00:41:19.000000', 'consum', 0.0220, 'lps'),
	(396343, 102, '2015-02-15 00:41:20.000000', 'consum', 0.0226, 'lps'),
	(396344, 102, '2015-02-15 00:41:21.000000', 'consum', 0.0222, 'lps'),
	(396345, 102, '2015-02-15 00:41:22.000000', 'consum', 0.0221, 'lps'),
	(396346, 102, '2015-02-15 00:41:23.000000', 'consum', 0.0212, 'lps'),
	(396347, 102, '2015-02-15 00:41:24.000000', 'consum', 0.0227, 'lps'),
	(396348, 102, '2015-02-15 00:41:25.000000', 'consum', 0.0227, 'lps'),
	(396349, 102, '2015-02-15 00:41:26.000000', 'consum', 0.0227, 'lps'),
	(396350, 102, '2015-02-15 00:41:27.000000', 'consum', 0.0222, 'lps'),
	(396351, 102, '2015-02-15 00:41:28.000000', 'consum', 0.0220, 'lps'),
	(396352, 102, '2015-02-15 00:41:29.000000', 'consum', 0.0224, 'lps'),
	(396353, 102, '2015-02-15 00:41:30.000000', 'consum', 0.0212, 'lps'),
	(396354, 102, '2015-02-15 00:41:31.000000', 'consum', 0.0219, 'lps'),
	(396355, 102, '2015-02-15 00:41:32.000000', 'consum', 0.0228, 'lps'),
	(396356, 102, '2015-02-15 00:41:33.000000', 'consum', 0.0216, 'lps'),
	(396357, 102, '2015-02-15 00:41:34.000000', 'consum', 0.0225, 'lps'),
	(396358, 102, '2015-02-15 00:41:35.000000', 'consum', 0.0228, 'lps'),
	(396359, 102, '2015-02-15 00:41:36.000000', 'consum', 0.0216, 'lps'),
	(396360, 102, '2015-02-15 00:41:37.000000', 'consum', 0.0226, 'lps'),
	(396361, 102, '2015-02-15 00:41:38.000000', 'consum', 0.0214, 'lps'),
	(396362, 102, '2015-02-15 00:41:39.000000', 'consum', 0.0220, 'lps'),
	(396363, 102, '2015-02-15 00:41:40.000000', 'consum', 0.0211, 'lps'),
	(396364, 102, '2015-02-15 00:41:41.000000', 'consum', 0.0225, 'lps'),
	(396365, 102, '2015-02-15 00:41:42.000000', 'consum', 0.0223, 'lps'),
	(396366, 102, '2015-02-15 00:41:43.000000', 'consum', 0.0210, 'lps'),
	(396367, 102, '2015-02-15 00:41:44.000000', 'consum', 0.0213, 'lps'),
	(396368, 102, '2015-02-15 00:41:45.000000', 'consum', 0.0225, 'lps'),
	(396369, 102, '2015-02-15 00:41:46.000000', 'consum', 0.0218, 'lps'),
	(396370, 102, '2015-02-15 00:41:47.000000', 'consum', 0.0224, 'lps'),
	(396371, 102, '2015-02-15 00:41:48.000000', 'consum', 0.0215, 'lps'),
	(396372, 102, '2015-02-15 00:41:49.000000', 'consum', 0.0213, 'lps'),
	(396373, 102, '2015-02-15 00:41:50.000000', 'consum', 0.0210, 'lps'),
	(396374, 102, '2015-02-15 00:41:51.000000', 'consum', 0.0222, 'lps'),
	(396375, 102, '2015-02-15 00:41:52.000000', 'consum', 0.0211, 'lps'),
	(396376, 102, '2015-02-15 00:41:53.000000', 'consum', 0.0218, 'lps'),
	(396377, 102, '2015-02-15 00:41:54.000000', 'consum', 0.0227, 'lps'),
	(396378, 102, '2015-02-15 00:41:55.000000', 'consum', 0.0211, 'lps'),
	(396379, 102, '2015-02-15 00:41:56.000000', 'consum', 0.0224, 'lps'),
	(396380, 102, '2015-02-15 00:41:57.000000', 'consum', 0.0219, 'lps'),
	(396381, 102, '2015-02-15 00:41:58.000000', 'consum', 0.0212, 'lps'),
	(396382, 102, '2015-02-15 00:41:59.000000', 'consum', 0.0216, 'lps'),
	(396383, 102, '2015-02-15 00:42:00.000000', 'consum', 0.0215, 'lps'),
	(396384, 102, '2015-02-15 00:42:01.000000', 'consum', 0.0217, 'lps'),
	(396385, 102, '2015-02-15 00:42:02.000000', 'consum', 0.0229, 'lps'),
	(396386, 102, '2015-02-15 00:42:03.000000', 'consum', 0.0224, 'lps'),
	(396387, 102, '2015-02-15 00:42:04.000000', 'consum', 0.0225, 'lps'),
	(396388, 102, '2015-02-15 00:42:05.000000', 'consum', 0.0223, 'lps'),
	(396389, 102, '2015-02-15 00:42:06.000000', 'consum', 0.0210, 'lps'),
	(396390, 102, '2015-02-15 00:42:07.000000', 'consum', 0.0210, 'lps'),
	(396391, 102, '2015-02-15 00:42:08.000000', 'consum', 0.0211, 'lps'),
	(396392, 102, '2015-02-15 00:42:09.000000', 'consum', 0.0218, 'lps'),
	(396393, 102, '2015-02-15 00:42:10.000000', 'consum', 0.0227, 'lps'),
	(396394, 102, '2015-02-15 00:42:11.000000', 'consum', 0.0211, 'lps'),
	(396395, 102, '2015-02-15 00:42:12.000000', 'consum', 0.0224, 'lps'),
	(396396, 102, '2015-02-15 00:42:13.000000', 'consum', 0.0216, 'lps'),
	(396397, 102, '2015-02-15 00:42:14.000000', 'consum', 0.0219, 'lps'),
	(396398, 102, '2015-02-15 00:42:15.000000', 'consum', 0.0217, 'lps'),
	(396399, 102, '2015-02-15 00:42:16.000000', 'consum', 0.0221, 'lps'),
	(396400, 102, '2015-02-15 00:42:17.000000', 'consum', 0.0223, 'lps'),
	(396401, 102, '2015-02-15 00:42:18.000000', 'consum', 0.0224, 'lps'),
	(396402, 102, '2015-02-15 00:42:19.000000', 'consum', 0.0221, 'lps'),
	(396403, 102, '2015-02-15 00:42:20.000000', 'consum', 0.0222, 'lps'),
	(396404, 102, '2015-02-15 00:42:21.000000', 'consum', 0.0219, 'lps'),
	(396405, 102, '2015-02-15 00:42:22.000000', 'consum', 0.0220, 'lps'),
	(396406, 102, '2015-02-15 00:42:23.000000', 'consum', 0.0213, 'lps'),
	(396407, 102, '2015-02-15 00:42:24.000000', 'consum', 0.0215, 'lps'),
	(396408, 102, '2015-02-15 00:42:25.000000', 'consum', 0.0229, 'lps'),
	(396409, 102, '2015-02-15 00:42:26.000000', 'consum', 0.0227, 'lps'),
	(396410, 102, '2015-02-15 00:42:27.000000', 'consum', 0.0220, 'lps'),
	(396411, 102, '2015-02-15 00:42:28.000000', 'consum', 0.0211, 'lps'),
	(396412, 102, '2015-02-15 00:42:29.000000', 'consum', 0.0226, 'lps'),
	(396413, 102, '2015-02-15 00:42:30.000000', 'consum', 0.0225, 'lps'),
	(396414, 102, '2015-02-15 00:42:31.000000', 'consum', 0.0219, 'lps'),
	(396415, 102, '2015-02-15 00:42:32.000000', 'consum', 0.0229, 'lps'),
	(396416, 102, '2015-02-15 00:42:33.000000', 'consum', 0.0217, 'lps'),
	(396417, 102, '2015-02-15 00:42:34.000000', 'consum', 0.0211, 'lps'),
	(396418, 102, '2015-02-15 00:42:35.000000', 'consum', 0.0214, 'lps'),
	(396419, 102, '2015-02-15 00:42:36.000000', 'consum', 0.0228, 'lps'),
	(396420, 102, '2015-02-15 00:42:37.000000', 'consum', 0.0229, 'lps'),
	(396421, 102, '2015-02-15 00:42:38.000000', 'consum', 0.0213, 'lps'),
	(396422, 102, '2015-02-15 00:42:39.000000', 'consum', 0.0227, 'lps'),
	(396423, 102, '2015-02-15 00:42:40.000000', 'consum', 0.0226, 'lps'),
	(396424, 102, '2015-02-15 00:42:41.000000', 'consum', 0.0218, 'lps'),
	(396425, 102, '2015-02-15 00:42:42.000000', 'consum', 0.0223, 'lps'),
	(396426, 102, '2015-02-15 00:42:43.000000', 'consum', 0.0210, 'lps'),
	(396427, 102, '2015-02-15 00:42:44.000000', 'consum', 0.0213, 'lps'),
	(396428, 102, '2015-02-15 00:42:45.000000', 'consum', 0.0226, 'lps'),
	(396429, 102, '2015-02-15 00:42:46.000000', 'consum', 0.0220, 'lps'),
	(396430, 102, '2015-02-15 00:42:47.000000', 'consum', 0.0213, 'lps'),
	(396431, 102, '2015-02-15 00:42:48.000000', 'consum', 0.0218, 'lps'),
	(396432, 102, '2015-02-15 00:42:49.000000', 'consum', 0.0218, 'lps'),
	(396433, 102, '2015-02-15 00:42:50.000000', 'consum', 0.0229, 'lps'),
	(396434, 102, '2015-02-15 00:42:51.000000', 'consum', 0.0219, 'lps'),
	(396435, 102, '2015-02-15 00:42:52.000000', 'consum', 0.0220, 'lps'),
	(396436, 102, '2015-02-15 00:42:53.000000', 'consum', 0.0213, 'lps'),
	(396437, 102, '2015-02-15 00:42:54.000000', 'consum', 0.0217, 'lps'),
	(396438, 102, '2015-02-15 00:42:55.000000', 'consum', 0.0218, 'lps'),
	(396439, 102, '2015-02-15 00:42:56.000000', 'consum', 0.0227, 'lps'),
	(396440, 102, '2015-02-15 00:42:57.000000', 'consum', 0.0211, 'lps'),
	(396441, 102, '2015-02-15 00:42:58.000000', 'consum', 0.0224, 'lps'),
	(396442, 102, '2015-02-15 00:42:59.000000', 'consum', 0.0217, 'lps'),
	(396443, 102, '2015-02-15 00:43:00.000000', 'consum', 0.0223, 'lps'),
	(396444, 102, '2015-02-15 00:43:01.000000', 'consum', 0.0218, 'lps'),
	(396445, 102, '2015-02-15 00:43:02.000000', 'consum', 0.0228, 'lps'),
	(396446, 102, '2015-02-15 00:43:03.000000', 'consum', 0.0217, 'lps'),
	(396447, 102, '2015-02-15 00:43:04.000000', 'consum', 0.0213, 'lps'),
	(396448, 102, '2015-02-15 00:43:05.000000', 'consum', 0.0222, 'lps'),
	(396449, 102, '2015-02-15 00:43:06.000000', 'consum', 0.0224, 'lps'),
	(396450, 102, '2015-02-15 00:43:07.000000', 'consum', 0.0223, 'lps'),
	(396451, 102, '2015-02-15 00:43:08.000000', 'consum', 0.0213, 'lps'),
	(396452, 102, '2015-02-15 00:43:09.000000', 'consum', 0.0226, 'lps'),
	(396453, 102, '2015-02-15 00:43:10.000000', 'consum', 0.0224, 'lps'),
	(396454, 102, '2015-02-15 00:43:11.000000', 'consum', 0.0212, 'lps'),
	(396455, 102, '2015-02-15 00:43:12.000000', 'consum', 0.0218, 'lps'),
	(396456, 102, '2015-02-15 00:43:13.000000', 'consum', 0.0224, 'lps'),
	(396457, 102, '2015-02-15 00:43:14.000000', 'consum', 0.0218, 'lps'),
	(396458, 102, '2015-02-15 00:43:15.000000', 'consum', 0.0226, 'lps'),
	(396459, 102, '2015-02-15 00:43:16.000000', 'consum', 0.0228, 'lps'),
	(396460, 102, '2015-02-15 00:43:17.000000', 'consum', 0.0213, 'lps'),
	(396461, 102, '2015-02-15 00:43:18.000000', 'consum', 0.0229, 'lps'),
	(396462, 102, '2015-02-15 00:43:19.000000', 'consum', 0.0219, 'lps'),
	(396463, 102, '2015-02-15 00:43:20.000000', 'consum', 0.0220, 'lps'),
	(396464, 102, '2015-02-15 00:43:21.000000', 'consum', 0.0211, 'lps'),
	(396465, 102, '2015-02-15 00:43:22.000000', 'consum', 0.0227, 'lps'),
	(396466, 102, '2015-02-15 00:43:23.000000', 'consum', 0.0212, 'lps'),
	(396467, 102, '2015-02-15 00:43:24.000000', 'consum', 0.0210, 'lps'),
	(396468, 102, '2015-02-15 00:43:25.000000', 'consum', 0.0224, 'lps'),
	(396469, 102, '2015-02-15 00:43:26.000000', 'consum', 0.0219, 'lps'),
	(396470, 102, '2015-02-15 00:43:27.000000', 'consum', 0.0214, 'lps'),
	(396471, 102, '2015-02-15 00:43:28.000000', 'consum', 0.0224, 'lps'),
	(396472, 102, '2015-02-15 00:43:29.000000', 'consum', 0.0227, 'lps'),
	(396473, 102, '2015-02-15 00:43:30.000000', 'consum', 0.0215, 'lps'),
	(396474, 102, '2015-02-15 00:43:31.000000', 'consum', 0.0223, 'lps'),
	(396475, 102, '2015-02-15 00:43:32.000000', 'consum', 0.0221, 'lps'),
	(396476, 102, '2015-02-15 00:43:33.000000', 'consum', 0.0228, 'lps'),
	(396477, 102, '2015-02-15 00:43:34.000000', 'consum', 0.0227, 'lps'),
	(396478, 102, '2015-02-15 00:43:35.000000', 'consum', 0.0221, 'lps'),
	(396479, 102, '2015-02-15 00:43:36.000000', 'consum', 0.0215, 'lps'),
	(396480, 102, '2015-02-15 00:43:37.000000', 'consum', 0.0221, 'lps'),
	(396481, 102, '2015-02-15 00:43:38.000000', 'consum', 0.0212, 'lps'),
	(396482, 102, '2015-02-15 00:43:39.000000', 'consum', 0.0229, 'lps'),
	(396483, 102, '2015-02-15 00:43:40.000000', 'consum', 0.0217, 'lps'),
	(396484, 102, '2015-02-15 00:43:41.000000', 'consum', 0.0228, 'lps'),
	(396485, 102, '2015-02-15 00:43:42.000000', 'consum', 0.0221, 'lps'),
	(396486, 102, '2015-02-15 00:43:43.000000', 'consum', 0.0210, 'lps'),
	(396487, 102, '2015-02-15 00:43:44.000000', 'consum', 0.0220, 'lps'),
	(396488, 102, '2015-02-15 00:43:45.000000', 'consum', 0.0217, 'lps'),
	(396489, 102, '2015-02-15 00:43:46.000000', 'consum', 0.0219, 'lps'),
	(396490, 102, '2015-02-15 00:43:47.000000', 'consum', 0.0211, 'lps'),
	(396491, 102, '2015-02-15 00:43:48.000000', 'consum', 0.0212, 'lps'),
	(396492, 102, '2015-02-15 00:43:49.000000', 'consum', 0.0214, 'lps'),
	(396493, 102, '2015-02-15 00:43:50.000000', 'consum', 0.0226, 'lps'),
	(396494, 102, '2015-02-15 00:43:51.000000', 'consum', 0.0218, 'lps'),
	(396495, 102, '2015-02-15 00:43:52.000000', 'consum', 0.0222, 'lps'),
	(396496, 102, '2015-02-15 00:43:53.000000', 'consum', 0.0225, 'lps'),
	(396497, 102, '2015-02-15 00:43:54.000000', 'consum', 0.0213, 'lps'),
	(396498, 102, '2015-02-15 00:43:55.000000', 'consum', 0.0218, 'lps'),
	(396499, 102, '2015-02-15 00:43:56.000000', 'consum', 0.0222, 'lps'),
	(396500, 102, '2015-02-15 00:43:57.000000', 'consum', 0.0227, 'lps'),
	(396501, 102, '2015-02-15 00:43:58.000000', 'consum', 0.0219, 'lps'),
	(396502, 102, '2015-02-15 00:43:59.000000', 'consum', 0.0223, 'lps'),
	(396503, 102, '2015-02-15 00:44:00.000000', 'consum', 0.0210, 'lps'),
	(396504, 102, '2015-02-15 00:44:01.000000', 'consum', 0.0212, 'lps'),
	(396505, 102, '2015-02-15 00:44:02.000000', 'consum', 0.0220, 'lps'),
	(396506, 102, '2015-02-15 00:44:03.000000', 'consum', 0.0216, 'lps'),
	(396507, 102, '2015-02-15 00:44:04.000000', 'consum', 0.0229, 'lps'),
	(396508, 102, '2015-02-15 00:44:05.000000', 'consum', 0.0210, 'lps'),
	(396509, 102, '2015-02-15 00:44:06.000000', 'consum', 0.0210, 'lps'),
	(396510, 102, '2015-02-15 00:44:07.000000', 'consum', 0.0213, 'lps'),
	(396511, 102, '2015-02-15 00:44:08.000000', 'consum', 0.0225, 'lps'),
	(396512, 102, '2015-02-15 00:44:09.000000', 'consum', 0.0217, 'lps'),
	(396513, 102, '2015-02-15 00:44:10.000000', 'consum', 0.0220, 'lps'),
	(396514, 102, '2015-02-15 00:44:11.000000', 'consum', 0.0219, 'lps'),
	(396515, 102, '2015-02-15 00:44:12.000000', 'consum', 0.0226, 'lps'),
	(396516, 102, '2015-02-15 00:44:13.000000', 'consum', 0.0225, 'lps'),
	(396517, 102, '2015-02-15 00:44:14.000000', 'consum', 0.0219, 'lps'),
	(396518, 102, '2015-02-15 00:44:15.000000', 'consum', 0.0227, 'lps'),
	(396519, 102, '2015-02-15 00:44:16.000000', 'consum', 0.0228, 'lps'),
	(396520, 102, '2015-02-15 00:44:17.000000', 'consum', 0.0211, 'lps'),
	(396521, 102, '2015-02-15 00:44:18.000000', 'consum', 0.0222, 'lps'),
	(396522, 102, '2015-02-15 00:44:19.000000', 'consum', 0.0228, 'lps'),
	(396523, 102, '2015-02-15 00:44:20.000000', 'consum', 0.0225, 'lps'),
	(396524, 102, '2015-02-15 00:44:21.000000', 'consum', 0.0210, 'lps'),
	(396525, 102, '2015-02-15 00:44:22.000000', 'consum', 0.0226, 'lps'),
	(396526, 102, '2015-02-15 00:44:23.000000', 'consum', 0.0212, 'lps'),
	(396527, 102, '2015-02-15 00:44:24.000000', 'consum', 0.0213, 'lps'),
	(396528, 102, '2015-02-15 00:44:25.000000', 'consum', 0.0217, 'lps'),
	(396529, 102, '2015-02-15 00:44:26.000000', 'consum', 0.0216, 'lps'),
	(396530, 102, '2015-02-15 00:44:27.000000', 'consum', 0.0221, 'lps'),
	(396531, 102, '2015-02-15 00:44:28.000000', 'consum', 0.0228, 'lps'),
	(396532, 102, '2015-02-15 00:44:29.000000', 'consum', 0.0228, 'lps'),
	(396533, 102, '2015-02-15 00:44:30.000000', 'consum', 0.0227, 'lps'),
	(396534, 102, '2015-02-15 00:44:31.000000', 'consum', 0.0222, 'lps'),
	(396535, 102, '2015-02-15 00:44:32.000000', 'consum', 0.0220, 'lps'),
	(396536, 102, '2015-02-15 00:44:33.000000', 'consum', 0.0223, 'lps'),
	(396537, 102, '2015-02-15 00:44:34.000000', 'consum', 0.0224, 'lps'),
	(396538, 102, '2015-02-15 00:44:35.000000', 'consum', 0.0224, 'lps'),
	(396539, 102, '2015-02-15 00:44:36.000000', 'consum', 0.0216, 'lps'),
	(396540, 102, '2015-02-15 00:44:37.000000', 'consum', 0.0219, 'lps'),
	(396541, 102, '2015-02-15 00:44:38.000000', 'consum', 0.0218, 'lps'),
	(396542, 102, '2015-02-15 00:44:39.000000', 'consum', 0.0225, 'lps'),
	(396543, 102, '2015-02-15 00:44:40.000000', 'consum', 0.0220, 'lps'),
	(396544, 102, '2015-02-15 00:44:41.000000', 'consum', 0.0217, 'lps'),
	(396545, 102, '2015-02-15 00:44:42.000000', 'consum', 0.0214, 'lps'),
	(396546, 102, '2015-02-15 00:44:43.000000', 'consum', 0.0229, 'lps'),
	(396547, 102, '2015-02-15 00:44:44.000000', 'consum', 0.0214, 'lps'),
	(396548, 102, '2015-02-15 00:44:45.000000', 'consum', 0.0213, 'lps'),
	(396549, 102, '2015-02-15 00:44:46.000000', 'consum', 0.0212, 'lps'),
	(396550, 102, '2015-02-15 00:44:47.000000', 'consum', 0.0215, 'lps'),
	(396551, 102, '2015-02-15 00:44:48.000000', 'consum', 0.0226, 'lps'),
	(396552, 102, '2015-02-15 00:44:49.000000', 'consum', 0.0216, 'lps'),
	(396553, 102, '2015-02-15 00:44:50.000000', 'consum', 0.0215, 'lps'),
	(396554, 102, '2015-02-15 00:44:51.000000', 'consum', 0.0214, 'lps'),
	(396555, 102, '2015-02-15 00:44:52.000000', 'consum', 0.0219, 'lps'),
	(396556, 102, '2015-02-15 00:44:53.000000', 'consum', 0.0221, 'lps'),
	(396557, 102, '2015-02-15 00:44:54.000000', 'consum', 0.0219, 'lps'),
	(396558, 102, '2015-02-15 00:44:55.000000', 'consum', 0.0222, 'lps'),
	(396559, 102, '2015-02-15 00:44:56.000000', 'consum', 0.0223, 'lps'),
	(396560, 102, '2015-02-15 00:44:57.000000', 'consum', 0.0221, 'lps'),
	(396561, 102, '2015-02-15 00:44:58.000000', 'consum', 0.0227, 'lps'),
	(396562, 102, '2015-02-15 00:44:59.000000', 'consum', 0.0223, 'lps'),
	(396563, 102, '2015-02-15 00:45:00.000000', 'consum', 0.0223, 'lps'),
	(396564, 102, '2015-02-15 00:45:01.000000', 'consum', 0.0219, 'lps'),
	(396565, 102, '2015-02-15 00:45:02.000000', 'consum', 0.0213, 'lps'),
	(396566, 102, '2015-02-15 00:45:03.000000', 'consum', 0.0221, 'lps'),
	(396567, 102, '2015-02-15 00:45:04.000000', 'consum', 0.0214, 'lps'),
	(396568, 102, '2015-02-15 00:45:05.000000', 'consum', 0.0219, 'lps'),
	(396569, 102, '2015-02-15 00:45:06.000000', 'consum', 0.0224, 'lps'),
	(396570, 102, '2015-02-15 00:45:07.000000', 'consum', 0.0211, 'lps'),
	(396571, 102, '2015-02-15 00:45:08.000000', 'consum', 0.0217, 'lps'),
	(396572, 102, '2015-02-15 00:45:09.000000', 'consum', 0.0221, 'lps'),
	(396573, 102, '2015-02-15 00:45:10.000000', 'consum', 0.0224, 'lps'),
	(396574, 102, '2015-02-15 00:45:11.000000', 'consum', 0.0210, 'lps'),
	(396575, 102, '2015-02-15 00:45:12.000000', 'consum', 0.0226, 'lps'),
	(396576, 102, '2015-02-15 00:45:13.000000', 'consum', 0.0212, 'lps'),
	(396577, 102, '2015-02-15 00:45:14.000000', 'consum', 0.0212, 'lps'),
	(396578, 102, '2015-02-15 00:45:15.000000', 'consum', 0.0214, 'lps'),
	(396579, 102, '2015-02-15 00:45:16.000000', 'consum', 0.0225, 'lps'),
	(396580, 102, '2015-02-15 00:45:17.000000', 'consum', 0.0213, 'lps'),
	(396581, 102, '2015-02-15 00:45:18.000000', 'consum', 0.0220, 'lps'),
	(396582, 102, '2015-02-15 00:45:19.000000', 'consum', 0.0213, 'lps'),
	(396583, 102, '2015-02-15 00:45:20.000000', 'consum', 0.0213, 'lps'),
	(396584, 102, '2015-02-15 00:45:21.000000', 'consum', 0.0219, 'lps'),
	(396585, 102, '2015-02-15 00:45:22.000000', 'consum', 0.0225, 'lps'),
	(396586, 102, '2015-02-15 00:45:23.000000', 'consum', 0.0217, 'lps'),
	(396587, 102, '2015-02-15 00:45:24.000000', 'consum', 0.0221, 'lps'),
	(396588, 102, '2015-02-15 00:45:25.000000', 'consum', 0.0227, 'lps'),
	(396589, 102, '2015-02-15 00:45:26.000000', 'consum', 0.0221, 'lps'),
	(396590, 102, '2015-02-15 00:45:27.000000', 'consum', 0.0215, 'lps'),
	(396591, 102, '2015-02-15 00:45:28.000000', 'consum', 0.0221, 'lps'),
	(396592, 102, '2015-02-15 00:45:29.000000', 'consum', 0.0210, 'lps'),
	(396593, 102, '2015-02-15 00:45:30.000000', 'consum', 0.0219, 'lps'),
	(396594, 102, '2015-02-15 00:45:31.000000', 'consum', 0.0217, 'lps'),
	(396595, 102, '2015-02-15 00:45:32.000000', 'consum', 0.0218, 'lps'),
	(396596, 102, '2015-02-15 00:45:33.000000', 'consum', 0.0229, 'lps'),
	(396597, 102, '2015-02-15 00:45:34.000000', 'consum', 0.0221, 'lps'),
	(396598, 102, '2015-02-15 00:45:35.000000', 'consum', 0.0227, 'lps'),
	(396599, 102, '2015-02-15 00:45:36.000000', 'consum', 0.0225, 'lps'),
	(396600, 102, '2015-02-15 00:45:37.000000', 'consum', 0.0215, 'lps'),
	(396601, 102, '2015-02-15 00:45:38.000000', 'consum', 0.0212, 'lps'),
	(396602, 102, '2015-02-15 00:45:39.000000', 'consum', 0.0222, 'lps'),
	(396603, 102, '2015-02-15 00:45:40.000000', 'consum', 0.0226, 'lps'),
	(396604, 102, '2015-02-15 00:45:41.000000', 'consum', 0.0212, 'lps'),
	(396605, 102, '2015-02-15 00:45:42.000000', 'consum', 0.0216, 'lps'),
	(396606, 102, '2015-02-15 00:45:43.000000', 'consum', 0.0212, 'lps'),
	(396607, 102, '2015-02-15 00:45:44.000000', 'consum', 0.0222, 'lps'),
	(396608, 102, '2015-02-15 00:45:45.000000', 'consum', 0.0226, 'lps'),
	(396609, 102, '2015-02-15 00:45:46.000000', 'consum', 0.0214, 'lps'),
	(396610, 102, '2015-02-15 00:45:47.000000', 'consum', 0.0223, 'lps'),
	(396611, 102, '2015-02-15 00:45:48.000000', 'consum', 0.0222, 'lps'),
	(396612, 102, '2015-02-15 00:45:49.000000', 'consum', 0.0211, 'lps'),
	(396613, 102, '2015-02-15 00:45:50.000000', 'consum', 0.0219, 'lps'),
	(396614, 102, '2015-02-15 00:45:51.000000', 'consum', 0.0215, 'lps'),
	(396615, 102, '2015-02-15 00:45:52.000000', 'consum', 0.0229, 'lps'),
	(396616, 102, '2015-02-15 00:45:53.000000', 'consum', 0.0211, 'lps'),
	(396617, 102, '2015-02-15 00:45:54.000000', 'consum', 0.0215, 'lps'),
	(396618, 102, '2015-02-15 00:45:55.000000', 'consum', 0.0215, 'lps'),
	(396619, 102, '2015-02-15 00:45:56.000000', 'consum', 0.0221, 'lps'),
	(396620, 102, '2015-02-15 00:45:57.000000', 'consum', 0.0211, 'lps'),
	(396621, 102, '2015-02-15 00:45:58.000000', 'consum', 0.0224, 'lps'),
	(396622, 102, '2015-02-15 00:45:59.000000', 'consum', 0.0215, 'lps'),
	(396623, 102, '2015-02-15 00:46:00.000000', 'consum', 0.0213, 'lps'),
	(396624, 102, '2015-02-15 00:46:01.000000', 'consum', 0.0211, 'lps'),
	(396625, 102, '2015-02-15 00:46:02.000000', 'consum', 0.0225, 'lps'),
	(396626, 102, '2015-02-15 00:46:03.000000', 'consum', 0.0224, 'lps'),
	(396627, 102, '2015-02-15 00:46:04.000000', 'consum', 0.0214, 'lps'),
	(396628, 102, '2015-02-15 00:46:05.000000', 'consum', 0.0211, 'lps'),
	(396629, 102, '2015-02-15 00:46:06.000000', 'consum', 0.0221, 'lps'),
	(396630, 102, '2015-02-15 00:46:07.000000', 'consum', 0.0222, 'lps'),
	(396631, 102, '2015-02-15 00:46:08.000000', 'consum', 0.0217, 'lps'),
	(396632, 102, '2015-02-15 00:46:09.000000', 'consum', 0.0212, 'lps'),
	(396633, 102, '2015-02-15 00:46:10.000000', 'consum', 0.0220, 'lps'),
	(396634, 102, '2015-02-15 00:46:11.000000', 'consum', 0.0213, 'lps'),
	(396635, 102, '2015-02-15 00:46:12.000000', 'consum', 0.0215, 'lps'),
	(396636, 102, '2015-02-15 00:46:13.000000', 'consum', 0.0226, 'lps'),
	(396637, 102, '2015-02-15 00:46:14.000000', 'consum', 0.0216, 'lps'),
	(396638, 102, '2015-02-15 00:46:15.000000', 'consum', 0.0214, 'lps'),
	(396639, 102, '2015-02-15 00:46:16.000000', 'consum', 0.0210, 'lps'),
	(396640, 102, '2015-02-15 00:46:17.000000', 'consum', 0.0219, 'lps'),
	(396641, 102, '2015-02-15 00:46:18.000000', 'consum', 0.0217, 'lps'),
	(396642, 102, '2015-02-15 00:46:19.000000', 'consum', 0.0218, 'lps'),
	(396643, 102, '2015-02-15 00:46:20.000000', 'consum', 0.0228, 'lps'),
	(396644, 102, '2015-02-15 00:46:21.000000', 'consum', 0.0218, 'lps'),
	(396645, 102, '2015-02-15 00:46:22.000000', 'consum', 0.0218, 'lps'),
	(396646, 102, '2015-02-15 00:46:23.000000', 'consum', 0.0225, 'lps'),
	(396647, 102, '2015-02-15 00:46:24.000000', 'consum', 0.0222, 'lps'),
	(396648, 102, '2015-02-15 00:46:25.000000', 'consum', 0.0225, 'lps'),
	(396649, 102, '2015-02-15 00:46:26.000000', 'consum', 0.0210, 'lps'),
	(396650, 102, '2015-02-15 00:46:27.000000', 'consum', 0.0225, 'lps'),
	(396651, 102, '2015-02-15 00:46:28.000000', 'consum', 0.0227, 'lps'),
	(396652, 102, '2015-02-15 00:46:29.000000', 'consum', 0.0210, 'lps'),
	(396653, 102, '2015-02-15 00:46:30.000000', 'consum', 0.0218, 'lps'),
	(396654, 102, '2015-02-15 00:46:31.000000', 'consum', 0.0212, 'lps'),
	(396655, 102, '2015-02-15 00:46:32.000000', 'consum', 0.0216, 'lps'),
	(396656, 102, '2015-02-15 00:46:33.000000', 'consum', 0.0214, 'lps'),
	(396657, 102, '2015-02-15 00:46:34.000000', 'consum', 0.0212, 'lps'),
	(396658, 102, '2015-02-15 00:46:35.000000', 'consum', 0.0210, 'lps'),
	(396659, 102, '2015-02-15 00:46:36.000000', 'consum', 0.0222, 'lps'),
	(396660, 102, '2015-02-15 00:46:37.000000', 'consum', 0.0212, 'lps'),
	(396661, 102, '2015-02-15 00:46:38.000000', 'consum', 0.0223, 'lps'),
	(396662, 102, '2015-02-15 00:46:39.000000', 'consum', 0.0212, 'lps'),
	(396663, 102, '2015-02-15 00:46:40.000000', 'consum', 0.0221, 'lps'),
	(396664, 102, '2015-02-15 00:46:41.000000', 'consum', 0.0221, 'lps'),
	(396665, 102, '2015-02-15 00:46:42.000000', 'consum', 0.0211, 'lps'),
	(396666, 102, '2015-02-15 00:46:43.000000', 'consum', 0.0224, 'lps'),
	(396667, 102, '2015-02-15 00:46:44.000000', 'consum', 0.0216, 'lps'),
	(396668, 102, '2015-02-15 00:46:45.000000', 'consum', 0.0219, 'lps'),
	(396669, 102, '2015-02-15 00:46:46.000000', 'consum', 0.0217, 'lps'),
	(396670, 102, '2015-02-15 00:46:47.000000', 'consum', 0.0220, 'lps'),
	(396671, 102, '2015-02-15 00:46:48.000000', 'consum', 0.0217, 'lps'),
	(396672, 102, '2015-02-15 00:46:49.000000', 'consum', 0.0218, 'lps'),
	(396673, 102, '2015-02-15 00:46:50.000000', 'consum', 0.0227, 'lps'),
	(396674, 102, '2015-02-15 00:46:51.000000', 'consum', 0.0212, 'lps'),
	(396675, 102, '2015-02-15 00:46:52.000000', 'consum', 0.0229, 'lps'),
	(396676, 102, '2015-02-15 00:46:53.000000', 'consum', 0.0219, 'lps'),
	(396677, 102, '2015-02-15 00:46:54.000000', 'consum', 0.0218, 'lps'),
	(396678, 102, '2015-02-15 00:46:55.000000', 'consum', 0.0225, 'lps'),
	(396679, 102, '2015-02-15 00:46:56.000000', 'consum', 0.0222, 'lps'),
	(396680, 102, '2015-02-15 00:46:57.000000', 'consum', 0.0224, 'lps'),
	(396681, 102, '2015-02-15 00:46:58.000000', 'consum', 0.0224, 'lps'),
	(396682, 102, '2015-02-15 00:46:59.000000', 'consum', 0.0219, 'lps'),
	(396683, 102, '2015-02-15 00:47:00.000000', 'consum', 0.0212, 'lps'),
	(396684, 102, '2015-02-15 00:47:01.000000', 'consum', 0.0216, 'lps'),
	(396685, 102, '2015-02-15 00:47:02.000000', 'consum', 0.0212, 'lps'),
	(396686, 102, '2015-02-15 00:47:03.000000', 'consum', 0.0224, 'lps'),
	(396687, 102, '2015-02-15 00:47:04.000000', 'consum', 0.0215, 'lps'),
	(396688, 102, '2015-02-15 00:47:05.000000', 'consum', 0.0213, 'lps'),
	(396689, 102, '2015-02-15 00:47:06.000000', 'consum', 0.0210, 'lps'),
	(396690, 102, '2015-02-15 00:47:07.000000', 'consum', 0.0221, 'lps'),
	(396691, 102, '2015-02-15 00:47:08.000000', 'consum', 0.0228, 'lps'),
	(396692, 102, '2015-02-15 00:47:09.000000', 'consum', 0.0226, 'lps'),
	(396693, 102, '2015-02-15 00:47:10.000000', 'consum', 0.0217, 'lps'),
	(396694, 102, '2015-02-15 00:47:11.000000', 'consum', 0.0217, 'lps'),
	(396695, 102, '2015-02-15 00:47:12.000000', 'consum', 0.0226, 'lps'),
	(396696, 102, '2015-02-15 00:47:13.000000', 'consum', 0.0229, 'lps'),
	(396697, 102, '2015-02-15 00:47:14.000000', 'consum', 0.0219, 'lps'),
	(396698, 102, '2015-02-15 00:47:15.000000', 'consum', 0.0215, 'lps'),
	(396699, 102, '2015-02-15 00:47:16.000000', 'consum', 0.0211, 'lps'),
	(396700, 102, '2015-02-15 00:47:17.000000', 'consum', 0.0222, 'lps'),
	(396701, 102, '2015-02-15 00:47:18.000000', 'consum', 0.0226, 'lps'),
	(396702, 102, '2015-02-15 00:47:19.000000', 'consum', 0.0213, 'lps'),
	(396703, 102, '2015-02-15 00:47:20.000000', 'consum', 0.0217, 'lps'),
	(396704, 102, '2015-02-15 00:47:21.000000', 'consum', 0.0216, 'lps'),
	(396705, 102, '2015-02-15 00:47:22.000000', 'consum', 0.0221, 'lps'),
	(396706, 102, '2015-02-15 00:47:23.000000', 'consum', 0.0225, 'lps'),
	(396707, 102, '2015-02-15 00:47:24.000000', 'consum', 0.0215, 'lps'),
	(396708, 102, '2015-02-15 00:47:25.000000', 'consum', 0.0228, 'lps'),
	(396709, 102, '2015-02-15 00:47:26.000000', 'consum', 0.0229, 'lps'),
	(396710, 102, '2015-02-15 00:47:27.000000', 'consum', 0.0229, 'lps'),
	(396711, 102, '2015-02-15 00:47:28.000000', 'consum', 0.0227, 'lps'),
	(396712, 102, '2015-02-15 00:47:29.000000', 'consum', 0.0220, 'lps'),
	(396713, 102, '2015-02-15 00:47:30.000000', 'consum', 0.0210, 'lps'),
	(396714, 102, '2015-02-15 00:47:31.000000', 'consum', 0.0221, 'lps'),
	(396715, 102, '2015-02-15 00:47:32.000000', 'consum', 0.0224, 'lps'),
	(396716, 102, '2015-02-15 00:47:33.000000', 'consum', 0.0229, 'lps'),
	(396717, 102, '2015-02-15 00:47:34.000000', 'consum', 0.0223, 'lps'),
	(396718, 102, '2015-02-15 00:47:35.000000', 'consum', 0.0219, 'lps'),
	(396719, 102, '2015-02-15 00:47:36.000000', 'consum', 0.0218, 'lps'),
	(396720, 102, '2015-02-15 00:47:37.000000', 'consum', 0.0222, 'lps'),
	(396721, 102, '2015-02-15 00:47:38.000000', 'consum', 0.0227, 'lps'),
	(396722, 102, '2015-02-15 00:47:39.000000', 'consum', 0.0220, 'lps'),
	(396723, 102, '2015-02-15 00:47:40.000000', 'consum', 0.0210, 'lps'),
	(396724, 102, '2015-02-15 00:47:41.000000', 'consum', 0.0222, 'lps'),
	(396725, 102, '2015-02-15 00:47:42.000000', 'consum', 0.0228, 'lps'),
	(396726, 102, '2015-02-15 00:47:43.000000', 'consum', 0.0226, 'lps'),
	(396727, 102, '2015-02-15 00:47:44.000000', 'consum', 0.0215, 'lps'),
	(396728, 102, '2015-02-15 00:47:45.000000', 'consum', 0.0228, 'lps'),
	(396729, 102, '2015-02-15 00:47:46.000000', 'consum', 0.0227, 'lps'),
	(396730, 102, '2015-02-15 00:47:47.000000', 'consum', 0.0222, 'lps'),
	(396731, 102, '2015-02-15 00:47:48.000000', 'consum', 0.0217, 'lps'),
	(396732, 102, '2015-02-15 00:47:49.000000', 'consum', 0.0211, 'lps'),
	(396733, 102, '2015-02-15 00:47:50.000000', 'consum', 0.0214, 'lps'),
	(396734, 102, '2015-02-15 00:47:51.000000', 'consum', 0.0227, 'lps'),
	(396735, 102, '2015-02-15 00:47:52.000000', 'consum', 0.0226, 'lps'),
	(396736, 102, '2015-02-15 00:47:53.000000', 'consum', 0.0217, 'lps'),
	(396737, 102, '2015-02-15 00:47:54.000000', 'consum', 0.0217, 'lps'),
	(396738, 102, '2015-02-15 00:47:55.000000', 'consum', 0.0227, 'lps'),
	(396739, 102, '2015-02-15 00:47:56.000000', 'consum', 0.0214, 'lps'),
	(396740, 102, '2015-02-15 00:47:57.000000', 'consum', 0.0218, 'lps'),
	(396741, 102, '2015-02-15 00:47:58.000000', 'consum', 0.0220, 'lps'),
	(396742, 102, '2015-02-15 00:47:59.000000', 'consum', 0.0215, 'lps'),
	(396743, 102, '2015-02-15 00:48:00.000000', 'consum', 0.0228, 'lps'),
	(396744, 102, '2015-02-15 00:48:01.000000', 'consum', 0.0223, 'lps'),
	(396745, 102, '2015-02-15 00:48:02.000000', 'consum', 0.0221, 'lps'),
	(396746, 102, '2015-02-15 00:48:03.000000', 'consum', 0.0226, 'lps'),
	(396747, 102, '2015-02-15 00:48:04.000000', 'consum', 0.0219, 'lps'),
	(396748, 102, '2015-02-15 00:48:05.000000', 'consum', 0.0225, 'lps'),
	(396749, 102, '2015-02-15 00:48:06.000000', 'consum', 0.0220, 'lps'),
	(396750, 102, '2015-02-15 00:48:07.000000', 'consum', 0.0216, 'lps'),
	(396751, 102, '2015-02-15 00:48:08.000000', 'consum', 0.0229, 'lps'),
	(396752, 102, '2015-02-15 00:48:09.000000', 'consum', 0.0229, 'lps'),
	(396753, 102, '2015-02-15 00:48:10.000000', 'consum', 0.0229, 'lps'),
	(396754, 102, '2015-02-15 00:48:11.000000', 'consum', 0.0226, 'lps'),
	(396755, 102, '2015-02-15 00:48:12.000000', 'consum', 0.0215, 'lps'),
	(396756, 102, '2015-02-15 00:48:13.000000', 'consum', 0.0229, 'lps'),
	(396757, 102, '2015-02-15 00:48:14.000000', 'consum', 0.0211, 'lps'),
	(396758, 102, '2015-02-15 00:48:15.000000', 'consum', 0.0217, 'lps'),
	(396759, 102, '2015-02-15 00:48:16.000000', 'consum', 0.0221, 'lps'),
	(396760, 102, '2015-02-15 00:48:17.000000', 'consum', 0.0225, 'lps'),
	(396761, 102, '2015-02-15 00:48:18.000000', 'consum', 0.0213, 'lps'),
	(396762, 102, '2015-02-15 00:48:19.000000', 'consum', 0.0220, 'lps'),
	(396763, 102, '2015-02-15 00:48:20.000000', 'consum', 0.0213, 'lps'),
	(396764, 102, '2015-02-15 00:48:21.000000', 'consum', 0.0215, 'lps'),
	(396765, 102, '2015-02-15 00:48:22.000000', 'consum', 0.0227, 'lps'),
	(396766, 102, '2015-02-15 00:48:23.000000', 'consum', 0.0220, 'lps'),
	(396767, 102, '2015-02-15 00:48:24.000000', 'consum', 0.0228, 'lps'),
	(396768, 102, '2015-02-15 00:48:25.000000', 'consum', 0.0211, 'lps'),
	(396769, 102, '2015-02-15 00:48:26.000000', 'consum', 0.0221, 'lps'),
	(396770, 102, '2015-02-15 00:48:27.000000', 'consum', 0.0224, 'lps'),
	(396771, 102, '2015-02-15 00:48:28.000000', 'consum', 0.0226, 'lps'),
	(396772, 102, '2015-02-15 00:48:29.000000', 'consum', 0.0229, 'lps'),
	(396773, 102, '2015-02-15 00:48:30.000000', 'consum', 0.0218, 'lps'),
	(396774, 102, '2015-02-15 00:48:31.000000', 'consum', 0.0214, 'lps'),
	(396775, 102, '2015-02-15 00:48:32.000000', 'consum', 0.0226, 'lps'),
	(396776, 102, '2015-02-15 00:48:33.000000', 'consum', 0.0220, 'lps'),
	(396777, 102, '2015-02-15 00:48:34.000000', 'consum', 0.0211, 'lps'),
	(396778, 102, '2015-02-15 00:48:35.000000', 'consum', 0.0224, 'lps'),
	(396779, 102, '2015-02-15 00:48:36.000000', 'consum', 0.0218, 'lps'),
	(396780, 102, '2015-02-15 00:48:37.000000', 'consum', 0.0211, 'lps'),
	(396781, 102, '2015-02-15 00:48:38.000000', 'consum', 0.0210, 'lps'),
	(396782, 102, '2015-02-15 00:48:39.000000', 'consum', 0.0227, 'lps'),
	(396783, 102, '2015-02-15 00:48:40.000000', 'consum', 0.0217, 'lps'),
	(396784, 102, '2015-02-15 00:48:41.000000', 'consum', 0.0215, 'lps'),
	(396785, 102, '2015-02-15 00:48:42.000000', 'consum', 0.0212, 'lps'),
	(396786, 102, '2015-02-15 00:48:43.000000', 'consum', 0.0228, 'lps'),
	(396787, 102, '2015-02-15 00:48:44.000000', 'consum', 0.0213, 'lps'),
	(396788, 102, '2015-02-15 00:48:45.000000', 'consum', 0.0210, 'lps'),
	(396789, 102, '2015-02-15 00:48:46.000000', 'consum', 0.0224, 'lps'),
	(396790, 102, '2015-02-15 00:48:47.000000', 'consum', 0.0218, 'lps'),
	(396791, 102, '2015-02-15 00:48:48.000000', 'consum', 0.0210, 'lps'),
	(396792, 102, '2015-02-15 00:48:49.000000', 'consum', 0.0227, 'lps'),
	(396793, 102, '2015-02-15 00:48:50.000000', 'consum', 0.0216, 'lps'),
	(396794, 102, '2015-02-15 00:48:51.000000', 'consum', 0.0229, 'lps'),
	(396795, 102, '2015-02-15 00:48:52.000000', 'consum', 0.0226, 'lps'),
	(396796, 102, '2015-02-15 00:48:53.000000', 'consum', 0.0212, 'lps'),
	(396797, 102, '2015-02-15 00:48:54.000000', 'consum', 0.0216, 'lps'),
	(396798, 102, '2015-02-15 00:48:55.000000', 'consum', 0.0214, 'lps'),
	(396799, 102, '2015-02-15 00:48:56.000000', 'consum', 0.0211, 'lps'),
	(396800, 102, '2015-02-15 00:48:57.000000', 'consum', 0.0224, 'lps'),
	(396801, 102, '2015-02-15 00:48:58.000000', 'consum', 0.0218, 'lps'),
	(396802, 102, '2015-02-15 00:48:59.000000', 'consum', 0.0210, 'lps'),
	(396803, 102, '2015-02-15 00:49:00.000000', 'consum', 0.0225, 'lps'),
	(396804, 102, '2015-02-15 00:49:01.000000', 'consum', 0.0225, 'lps'),
	(396805, 102, '2015-02-15 00:49:02.000000', 'consum', 0.0220, 'lps'),
	(396806, 102, '2015-02-15 00:49:03.000000', 'consum', 0.0218, 'lps'),
	(396807, 102, '2015-02-15 00:49:04.000000', 'consum', 0.0218, 'lps'),
	(396808, 102, '2015-02-15 00:49:05.000000', 'consum', 0.0228, 'lps'),
	(396809, 102, '2015-02-15 00:49:06.000000', 'consum', 0.0216, 'lps'),
	(396810, 102, '2015-02-15 00:49:07.000000', 'consum', 0.0228, 'lps'),
	(396811, 102, '2015-02-15 00:49:08.000000', 'consum', 0.0223, 'lps'),
	(396812, 102, '2015-02-15 00:49:09.000000', 'consum', 0.0218, 'lps'),
	(396813, 102, '2015-02-15 00:49:10.000000', 'consum', 0.0215, 'lps'),
	(396814, 102, '2015-02-15 00:49:11.000000', 'consum', 0.0210, 'lps'),
	(396815, 102, '2015-02-15 00:49:12.000000', 'consum', 0.0217, 'lps'),
	(396816, 102, '2015-02-15 00:49:13.000000', 'consum', 0.0225, 'lps'),
	(396817, 102, '2015-02-15 00:49:14.000000', 'consum', 0.0224, 'lps'),
	(396818, 102, '2015-02-15 00:49:15.000000', 'consum', 0.0216, 'lps'),
	(396819, 102, '2015-02-15 00:49:16.000000', 'consum', 0.0220, 'lps'),
	(396820, 102, '2015-02-15 00:49:17.000000', 'consum', 0.0220, 'lps'),
	(396821, 102, '2015-02-15 00:49:18.000000', 'consum', 0.0211, 'lps'),
	(396822, 102, '2015-02-15 00:49:19.000000', 'consum', 0.0224, 'lps'),
	(396823, 102, '2015-02-15 00:49:20.000000', 'consum', 0.0219, 'lps'),
	(396824, 102, '2015-02-15 00:49:21.000000', 'consum', 0.0213, 'lps'),
	(396825, 102, '2015-02-15 00:49:22.000000', 'consum', 0.0220, 'lps'),
	(396826, 102, '2015-02-15 00:49:23.000000', 'consum', 0.0210, 'lps'),
	(396827, 102, '2015-02-15 00:49:24.000000', 'consum', 0.0220, 'lps'),
	(396828, 102, '2015-02-15 00:49:25.000000', 'consum', 0.0221, 'lps'),
	(396829, 102, '2015-02-15 00:49:26.000000', 'consum', 0.0216, 'lps'),
	(396830, 102, '2015-02-15 00:49:27.000000', 'consum', 0.0226, 'lps'),
	(396831, 102, '2015-02-15 00:49:28.000000', 'consum', 0.0212, 'lps'),
	(396832, 102, '2015-02-15 00:49:29.000000', 'consum', 0.0212, 'lps'),
	(396833, 102, '2015-02-15 00:49:30.000000', 'consum', 0.0216, 'lps'),
	(396834, 102, '2015-02-15 00:49:31.000000', 'consum', 0.0212, 'lps'),
	(396835, 102, '2015-02-15 00:49:32.000000', 'consum', 0.0225, 'lps'),
	(396836, 102, '2015-02-15 00:49:33.000000', 'consum', 0.0218, 'lps'),
	(396837, 102, '2015-02-15 00:49:34.000000', 'consum', 0.0226, 'lps'),
	(396838, 102, '2015-02-15 00:49:35.000000', 'consum', 0.0226, 'lps'),
	(396839, 102, '2015-02-15 00:49:36.000000', 'consum', 0.0221, 'lps'),
	(396840, 102, '2015-02-15 00:49:37.000000', 'consum', 0.0219, 'lps'),
	(396841, 102, '2015-02-15 00:49:38.000000', 'consum', 0.0221, 'lps'),
	(396842, 102, '2015-02-15 00:49:39.000000', 'consum', 0.0218, 'lps'),
	(396843, 102, '2015-02-15 00:49:40.000000', 'consum', 0.0221, 'lps'),
	(396844, 102, '2015-02-15 00:49:41.000000', 'consum', 0.0218, 'lps'),
	(396845, 102, '2015-02-15 00:49:42.000000', 'consum', 0.0219, 'lps'),
	(396846, 102, '2015-02-15 00:49:43.000000', 'consum', 0.0229, 'lps'),
	(396847, 102, '2015-02-15 00:49:44.000000', 'consum', 0.0221, 'lps'),
	(396848, 102, '2015-02-15 00:49:45.000000', 'consum', 0.0228, 'lps'),
	(396849, 102, '2015-02-15 00:49:46.000000', 'consum', 0.0229, 'lps'),
	(396850, 102, '2015-02-15 00:49:47.000000', 'consum', 0.0211, 'lps'),
	(396851, 102, '2015-02-15 00:49:48.000000', 'consum', 0.0218, 'lps'),
	(396852, 102, '2015-02-15 00:49:49.000000', 'consum', 0.0226, 'lps'),
	(396853, 102, '2015-02-15 00:49:50.000000', 'consum', 0.0229, 'lps'),
	(396854, 102, '2015-02-15 00:49:51.000000', 'consum', 0.0218, 'lps'),
	(396855, 102, '2015-02-15 00:49:52.000000', 'consum', 0.0211, 'lps'),
	(396856, 102, '2015-02-15 00:49:53.000000', 'consum', 0.0214, 'lps'),
	(396857, 102, '2015-02-15 00:49:54.000000', 'consum', 0.0226, 'lps'),
	(396858, 102, '2015-02-15 00:49:55.000000', 'consum', 0.0219, 'lps'),
	(396859, 102, '2015-02-15 00:49:56.000000', 'consum', 0.0229, 'lps'),
	(396860, 102, '2015-02-15 00:49:57.000000', 'consum', 0.0217, 'lps'),
	(396861, 102, '2015-02-15 00:49:58.000000', 'consum', 0.0211, 'lps'),
	(396862, 102, '2015-02-15 00:49:59.000000', 'consum', 0.0212, 'lps'),
	(396863, 102, '2015-02-15 00:50:00.000000', 'consum', 0.0219, 'lps'),
	(396864, 102, '2015-02-15 00:50:01.000000', 'consum', 0.0229, 'lps'),
	(396865, 102, '2015-02-15 00:50:02.000000', 'consum', 0.0220, 'lps'),
	(396866, 102, '2015-02-15 00:50:03.000000', 'consum', 0.0223, 'lps'),
	(396867, 102, '2015-02-15 00:50:04.000000', 'consum', 0.0225, 'lps'),
	(396868, 102, '2015-02-15 00:50:05.000000', 'consum', 0.0227, 'lps'),
	(396869, 102, '2015-02-15 00:50:06.000000', 'consum', 0.0229, 'lps'),
	(396870, 102, '2015-02-15 00:50:07.000000', 'consum', 0.0214, 'lps'),
	(396871, 102, '2015-02-15 00:50:08.000000', 'consum', 0.0215, 'lps'),
	(396872, 102, '2015-02-15 00:50:09.000000', 'consum', 0.0224, 'lps'),
	(396873, 102, '2015-02-15 00:50:10.000000', 'consum', 0.0226, 'lps'),
	(396874, 102, '2015-02-15 00:50:11.000000', 'consum', 0.0227, 'lps'),
	(396875, 102, '2015-02-15 00:50:12.000000', 'consum', 0.0227, 'lps'),
	(396876, 102, '2015-02-15 00:50:13.000000', 'consum', 0.0226, 'lps'),
	(396877, 102, '2015-02-15 00:50:14.000000', 'consum', 0.0220, 'lps'),
	(396878, 102, '2015-02-15 00:50:15.000000', 'consum', 0.0213, 'lps'),
	(396879, 102, '2015-02-15 00:50:16.000000', 'consum', 0.0214, 'lps'),
	(396880, 102, '2015-02-15 00:50:17.000000', 'consum', 0.0223, 'lps'),
	(396881, 102, '2015-02-15 00:50:18.000000', 'consum', 0.0223, 'lps'),
	(396882, 102, '2015-02-15 00:50:19.000000', 'consum', 0.0215, 'lps'),
	(396883, 102, '2015-02-15 00:50:20.000000', 'consum', 0.0218, 'lps'),
	(396884, 102, '2015-02-15 00:50:21.000000', 'consum', 0.0217, 'lps'),
	(396885, 102, '2015-02-15 00:50:22.000000', 'consum', 0.0220, 'lps'),
	(396886, 102, '2015-02-15 00:50:23.000000', 'consum', 0.0221, 'lps'),
	(396887, 102, '2015-02-15 00:50:24.000000', 'consum', 0.0214, 'lps'),
	(396888, 102, '2015-02-15 00:50:25.000000', 'consum', 0.0219, 'lps'),
	(396889, 102, '2015-02-15 00:50:26.000000', 'consum', 0.0223, 'lps'),
	(396890, 102, '2015-02-15 00:50:27.000000', 'consum', 0.0210, 'lps'),
	(396891, 102, '2015-02-15 00:50:28.000000', 'consum', 0.0229, 'lps'),
	(396892, 102, '2015-02-15 00:50:29.000000', 'consum', 0.0226, 'lps'),
	(396893, 102, '2015-02-15 00:50:30.000000', 'consum', 0.0215, 'lps'),
	(396894, 102, '2015-02-15 00:50:31.000000', 'consum', 0.0227, 'lps'),
	(396895, 102, '2015-02-15 00:50:32.000000', 'consum', 0.0219, 'lps'),
	(396896, 102, '2015-02-15 00:50:33.000000', 'consum', 0.0224, 'lps'),
	(396897, 102, '2015-02-15 00:50:34.000000', 'consum', 0.0216, 'lps'),
	(396898, 102, '2015-02-15 00:50:35.000000', 'consum', 0.0219, 'lps'),
	(396899, 102, '2015-02-15 00:50:36.000000', 'consum', 0.0217, 'lps'),
	(396900, 102, '2015-02-15 00:50:37.000000', 'consum', 0.0219, 'lps'),
	(396901, 102, '2015-02-15 00:50:38.000000', 'consum', 0.0213, 'lps'),
	(396902, 102, '2015-02-15 00:50:39.000000', 'consum', 0.0221, 'lps'),
	(396903, 102, '2015-02-15 00:50:40.000000', 'consum', 0.0213, 'lps'),
	(396904, 102, '2015-02-15 00:50:41.000000', 'consum', 0.0216, 'lps'),
	(396905, 102, '2015-02-15 00:50:42.000000', 'consum', 0.0228, 'lps'),
	(396906, 102, '2015-02-15 00:50:43.000000', 'consum', 0.0226, 'lps'),
	(396907, 102, '2015-02-15 00:50:44.000000', 'consum', 0.0214, 'lps'),
	(396908, 102, '2015-02-15 00:50:45.000000', 'consum', 0.0223, 'lps'),
	(396909, 102, '2015-02-15 00:50:46.000000', 'consum', 0.0226, 'lps'),
	(396910, 102, '2015-02-15 00:50:47.000000', 'consum', 0.0228, 'lps'),
	(396911, 102, '2015-02-15 00:50:48.000000', 'consum', 0.0214, 'lps'),
	(396912, 102, '2015-02-15 00:50:49.000000', 'consum', 0.0215, 'lps'),
	(396913, 102, '2015-02-15 00:50:50.000000', 'consum', 0.0224, 'lps'),
	(396914, 102, '2015-02-15 00:50:51.000000', 'consum', 0.0226, 'lps'),
	(396915, 102, '2015-02-15 00:50:52.000000', 'consum', 0.0228, 'lps'),
	(396916, 102, '2015-02-15 00:50:53.000000', 'consum', 0.0215, 'lps'),
	(396917, 102, '2015-02-15 00:50:54.000000', 'consum', 0.0218, 'lps'),
	(396918, 102, '2015-02-15 00:50:55.000000', 'consum', 0.0218, 'lps'),
	(396919, 102, '2015-02-15 00:50:56.000000', 'consum', 0.0224, 'lps'),
	(396920, 102, '2015-02-15 00:50:57.000000', 'consum', 0.0217, 'lps'),
	(396921, 102, '2015-02-15 00:50:58.000000', 'consum', 0.0224, 'lps'),
	(396922, 102, '2015-02-15 00:50:59.000000', 'consum', 0.0221, 'lps'),
	(396923, 102, '2015-02-15 00:51:00.000000', 'consum', 0.0222, 'lps'),
	(396924, 102, '2015-02-15 00:51:01.000000', 'consum', 0.0218, 'lps'),
	(396925, 102, '2015-02-15 00:51:02.000000', 'consum', 0.0213, 'lps'),
	(396926, 102, '2015-02-15 00:51:03.000000', 'consum', 0.0223, 'lps'),
	(396927, 102, '2015-02-15 00:51:04.000000', 'consum', 0.0225, 'lps'),
	(396928, 102, '2015-02-15 00:51:05.000000', 'consum', 0.0228, 'lps'),
	(396929, 102, '2015-02-15 00:51:06.000000', 'consum', 0.0214, 'lps'),
	(396930, 102, '2015-02-15 00:51:07.000000', 'consum', 0.0217, 'lps'),
	(396931, 102, '2015-02-15 00:51:08.000000', 'consum', 0.0213, 'lps'),
	(396932, 102, '2015-02-15 00:51:09.000000', 'consum', 0.0224, 'lps'),
	(396933, 102, '2015-02-15 00:51:10.000000', 'consum', 0.0212, 'lps'),
	(396934, 102, '2015-02-15 00:51:11.000000', 'consum', 0.0218, 'lps'),
	(396935, 102, '2015-02-15 00:51:12.000000', 'consum', 0.0223, 'lps'),
	(396936, 102, '2015-02-15 00:51:13.000000', 'consum', 0.0213, 'lps'),
	(396937, 102, '2015-02-15 00:51:14.000000', 'consum', 0.0226, 'lps'),
	(396938, 102, '2015-02-15 00:51:15.000000', 'consum', 0.0223, 'lps'),
	(396939, 102, '2015-02-15 00:51:16.000000', 'consum', 0.0227, 'lps'),
	(396940, 102, '2015-02-15 00:51:17.000000', 'consum', 0.0216, 'lps'),
	(396941, 102, '2015-02-15 00:51:18.000000', 'consum', 0.0210, 'lps'),
	(396942, 102, '2015-02-15 00:51:19.000000', 'consum', 0.0214, 'lps'),
	(396943, 102, '2015-02-15 00:51:20.000000', 'consum', 0.0210, 'lps'),
	(396944, 102, '2015-02-15 00:51:21.000000', 'consum', 0.0218, 'lps'),
	(396945, 102, '2015-02-15 00:51:22.000000', 'consum', 0.0229, 'lps'),
	(396946, 102, '2015-02-15 00:51:23.000000', 'consum', 0.0223, 'lps'),
	(396947, 102, '2015-02-15 00:51:24.000000', 'consum', 0.0218, 'lps'),
	(396948, 102, '2015-02-15 00:51:25.000000', 'consum', 0.0210, 'lps'),
	(396949, 102, '2015-02-15 00:51:26.000000', 'consum', 0.0229, 'lps'),
	(396950, 102, '2015-02-15 00:51:27.000000', 'consum', 0.0225, 'lps'),
	(396951, 102, '2015-02-15 00:51:28.000000', 'consum', 0.0227, 'lps'),
	(396952, 102, '2015-02-15 00:51:29.000000', 'consum', 0.0213, 'lps'),
	(396953, 102, '2015-02-15 00:51:30.000000', 'consum', 0.0215, 'lps'),
	(396954, 102, '2015-02-15 00:51:31.000000', 'consum', 0.0223, 'lps'),
	(396955, 102, '2015-02-15 00:51:32.000000', 'consum', 0.0224, 'lps'),
	(396956, 102, '2015-02-15 00:51:33.000000', 'consum', 0.0221, 'lps'),
	(396957, 102, '2015-02-15 00:51:34.000000', 'consum', 0.0223, 'lps'),
	(396958, 102, '2015-02-15 00:51:35.000000', 'consum', 0.0221, 'lps'),
	(396959, 102, '2015-02-15 00:51:36.000000', 'consum', 0.0226, 'lps'),
	(396960, 102, '2015-02-15 00:51:37.000000', 'consum', 0.0219, 'lps'),
	(396961, 102, '2015-02-15 00:51:38.000000', 'consum', 0.0228, 'lps'),
	(396962, 102, '2015-02-15 00:51:39.000000', 'consum', 0.0212, 'lps'),
	(396963, 102, '2015-02-15 00:51:40.000000', 'consum', 0.0227, 'lps'),
	(396964, 102, '2015-02-15 00:51:41.000000', 'consum', 0.0210, 'lps'),
	(396965, 102, '2015-02-15 00:51:42.000000', 'consum', 0.0218, 'lps'),
	(396966, 102, '2015-02-15 00:51:43.000000', 'consum', 0.0213, 'lps'),
	(396967, 102, '2015-02-15 00:51:44.000000', 'consum', 0.0219, 'lps'),
	(396968, 102, '2015-02-15 00:51:45.000000', 'consum', 0.0225, 'lps'),
	(396969, 102, '2015-02-15 00:51:46.000000', 'consum', 0.0222, 'lps'),
	(396970, 102, '2015-02-15 00:51:47.000000', 'consum', 0.0223, 'lps'),
	(396971, 102, '2015-02-15 00:51:48.000000', 'consum', 0.0220, 'lps'),
	(396972, 102, '2015-02-15 00:51:49.000000', 'consum', 0.0224, 'lps'),
	(396973, 102, '2015-02-15 00:51:50.000000', 'consum', 0.0228, 'lps'),
	(396974, 102, '2015-02-15 00:51:51.000000', 'consum', 0.0221, 'lps'),
	(396975, 102, '2015-02-15 00:51:52.000000', 'consum', 0.0211, 'lps'),
	(396976, 102, '2015-02-15 00:51:53.000000', 'consum', 0.0223, 'lps'),
	(396977, 102, '2015-02-15 00:51:54.000000', 'consum', 0.0211, 'lps'),
	(396978, 102, '2015-02-15 00:51:55.000000', 'consum', 0.0217, 'lps'),
	(396979, 102, '2015-02-15 00:51:56.000000', 'consum', 0.0221, 'lps'),
	(396980, 102, '2015-02-15 00:51:57.000000', 'consum', 0.0224, 'lps'),
	(396981, 102, '2015-02-15 00:51:58.000000', 'consum', 0.0227, 'lps'),
	(396982, 102, '2015-02-15 00:51:59.000000', 'consum', 0.0216, 'lps'),
	(396983, 102, '2015-02-15 00:52:00.000000', 'consum', 0.0227, 'lps'),
	(396984, 102, '2015-02-15 00:52:01.000000', 'consum', 0.0219, 'lps'),
	(396985, 102, '2015-02-15 00:52:02.000000', 'consum', 0.0226, 'lps'),
	(396986, 102, '2015-02-15 00:52:03.000000', 'consum', 0.0222, 'lps'),
	(396987, 102, '2015-02-15 00:52:04.000000', 'consum', 0.0224, 'lps'),
	(396988, 102, '2015-02-15 00:52:05.000000', 'consum', 0.0224, 'lps'),
	(396989, 102, '2015-02-15 00:52:06.000000', 'consum', 0.0218, 'lps'),
	(396990, 102, '2015-02-15 00:52:07.000000', 'consum', 0.0227, 'lps'),
	(396991, 102, '2015-02-15 00:52:08.000000', 'consum', 0.0213, 'lps'),
	(396992, 102, '2015-02-15 00:52:09.000000', 'consum', 0.0212, 'lps'),
	(396993, 102, '2015-02-15 00:52:10.000000', 'consum', 0.0214, 'lps'),
	(396994, 102, '2015-02-15 00:52:11.000000', 'consum', 0.0222, 'lps'),
	(396995, 102, '2015-02-15 00:52:12.000000', 'consum', 0.0221, 'lps'),
	(396996, 102, '2015-02-15 00:52:13.000000', 'consum', 0.0228, 'lps'),
	(396997, 102, '2015-02-15 00:52:14.000000', 'consum', 0.0228, 'lps'),
	(396998, 102, '2015-02-15 00:52:15.000000', 'consum', 0.0227, 'lps'),
	(396999, 102, '2015-02-15 00:52:16.000000', 'consum', 0.0222, 'lps'),
	(397000, 102, '2015-02-15 00:52:17.000000', 'consum', 0.0217, 'lps'),
	(397001, 102, '2015-02-15 00:52:18.000000', 'consum', 0.0212, 'lps'),
	(397002, 102, '2015-02-15 00:52:19.000000', 'consum', 0.0217, 'lps'),
	(397003, 102, '2015-02-15 00:52:20.000000', 'consum', 0.0219, 'lps'),
	(397004, 102, '2015-02-15 00:52:21.000000', 'consum', 0.0217, 'lps'),
	(397005, 102, '2015-02-15 00:52:22.000000', 'consum', 0.0218, 'lps'),
	(397006, 102, '2015-02-15 00:52:23.000000', 'consum', 0.0229, 'lps'),
	(397007, 102, '2015-02-15 00:52:24.000000', 'consum', 0.0224, 'lps'),
	(397008, 102, '2015-02-15 00:52:25.000000', 'consum', 0.0220, 'lps'),
	(397009, 102, '2015-02-15 00:52:26.000000', 'consum', 0.0219, 'lps'),
	(397010, 102, '2015-02-15 00:52:27.000000', 'consum', 0.0224, 'lps'),
	(397011, 102, '2015-02-15 00:52:28.000000', 'consum', 0.0217, 'lps'),
	(397012, 102, '2015-02-15 00:52:29.000000', 'consum', 0.0221, 'lps'),
	(397013, 102, '2015-02-15 00:52:30.000000', 'consum', 0.0225, 'lps'),
	(397014, 102, '2015-02-15 00:52:31.000000', 'consum', 0.0214, 'lps'),
	(397015, 102, '2015-02-15 00:52:32.000000', 'consum', 0.0227, 'lps'),
	(397016, 102, '2015-02-15 00:52:33.000000', 'consum', 0.0220, 'lps'),
	(397017, 102, '2015-02-15 00:52:34.000000', 'consum', 0.0229, 'lps'),
	(397018, 102, '2015-02-15 00:52:35.000000', 'consum', 0.0218, 'lps'),
	(397019, 102, '2015-02-15 00:52:36.000000', 'consum', 0.0213, 'lps'),
	(397020, 102, '2015-02-15 00:52:37.000000', 'consum', 0.0223, 'lps'),
	(397021, 102, '2015-02-15 00:52:38.000000', 'consum', 0.0226, 'lps'),
	(397022, 102, '2015-02-15 00:52:39.000000', 'consum', 0.0211, 'lps'),
	(397023, 102, '2015-02-15 00:52:40.000000', 'consum', 0.0228, 'lps'),
	(397024, 102, '2015-02-15 00:52:41.000000', 'consum', 0.0216, 'lps'),
	(397025, 102, '2015-02-15 00:52:42.000000', 'consum', 0.0225, 'lps'),
	(397026, 102, '2015-02-15 00:52:43.000000', 'consum', 0.0210, 'lps'),
	(397027, 102, '2015-02-15 00:52:44.000000', 'consum', 0.0225, 'lps'),
	(397028, 102, '2015-02-15 00:52:45.000000', 'consum', 0.0224, 'lps'),
	(397029, 102, '2015-02-15 00:52:46.000000', 'consum', 0.0215, 'lps'),
	(397030, 102, '2015-02-15 00:52:47.000000', 'consum', 0.0214, 'lps'),
	(397031, 102, '2015-02-15 00:52:48.000000', 'consum', 0.0214, 'lps'),
	(397032, 102, '2015-02-15 00:52:49.000000', 'consum', 0.0222, 'lps'),
	(397033, 102, '2015-02-15 00:52:50.000000', 'consum', 0.0216, 'lps'),
	(397034, 102, '2015-02-15 00:52:51.000000', 'consum', 0.0225, 'lps'),
	(397035, 102, '2015-02-15 00:52:52.000000', 'consum', 0.0227, 'lps'),
	(397036, 102, '2015-02-15 00:52:53.000000', 'consum', 0.0212, 'lps'),
	(397037, 102, '2015-02-15 00:52:54.000000', 'consum', 0.0211, 'lps'),
	(397038, 102, '2015-02-15 00:52:55.000000', 'consum', 0.0227, 'lps'),
	(397039, 102, '2015-02-15 00:52:56.000000', 'consum', 0.0214, 'lps'),
	(397040, 102, '2015-02-15 00:52:57.000000', 'consum', 0.0220, 'lps'),
	(397041, 102, '2015-02-15 00:52:58.000000', 'consum', 0.0227, 'lps'),
	(397042, 102, '2015-02-15 00:52:59.000000', 'consum', 0.0227, 'lps'),
	(397043, 102, '2015-02-15 00:53:00.000000', 'consum', 0.0224, 'lps'),
	(397044, 102, '2015-02-15 00:53:01.000000', 'consum', 0.0210, 'lps'),
	(397045, 102, '2015-02-15 00:53:02.000000', 'consum', 0.0210, 'lps'),
	(397046, 102, '2015-02-15 00:53:03.000000', 'consum', 0.0228, 'lps'),
	(397047, 102, '2015-02-15 00:53:04.000000', 'consum', 0.0222, 'lps'),
	(397048, 102, '2015-02-15 00:53:05.000000', 'consum', 0.0217, 'lps'),
	(397049, 102, '2015-02-15 00:53:06.000000', 'consum', 0.0228, 'lps'),
	(397050, 102, '2015-02-15 00:53:07.000000', 'consum', 0.0219, 'lps'),
	(397051, 102, '2015-02-15 00:53:08.000000', 'consum', 0.0220, 'lps'),
	(397052, 102, '2015-02-15 00:53:09.000000', 'consum', 0.0216, 'lps'),
	(397053, 102, '2015-02-15 00:53:10.000000', 'consum', 0.0228, 'lps'),
	(397054, 102, '2015-02-15 00:53:11.000000', 'consum', 0.0223, 'lps'),
	(397055, 102, '2015-02-15 00:53:12.000000', 'consum', 0.0222, 'lps'),
	(397056, 102, '2015-02-15 00:53:13.000000', 'consum', 0.0211, 'lps'),
	(397057, 102, '2015-02-15 00:53:14.000000', 'consum', 0.0218, 'lps'),
	(397058, 102, '2015-02-15 00:53:15.000000', 'consum', 0.0228, 'lps'),
	(397059, 102, '2015-02-15 00:53:16.000000', 'consum', 0.0219, 'lps'),
	(397060, 102, '2015-02-15 00:53:17.000000', 'consum', 0.0220, 'lps'),
	(397061, 102, '2015-02-15 00:53:18.000000', 'consum', 0.0213, 'lps'),
	(397062, 102, '2015-02-15 00:53:19.000000', 'consum', 0.0217, 'lps'),
	(397063, 102, '2015-02-15 00:53:20.000000', 'consum', 0.0217, 'lps'),
	(397064, 102, '2015-02-15 00:53:21.000000', 'consum', 0.0222, 'lps'),
	(397065, 102, '2015-02-15 00:53:22.000000', 'consum', 0.0212, 'lps'),
	(397066, 102, '2015-02-15 00:53:23.000000', 'consum', 0.0225, 'lps'),
	(397067, 102, '2015-02-15 00:53:24.000000', 'consum', 0.0217, 'lps'),
	(397068, 102, '2015-02-15 00:53:25.000000', 'consum', 0.0220, 'lps'),
	(397069, 102, '2015-02-15 00:53:26.000000', 'consum', 0.0219, 'lps'),
	(397070, 102, '2015-02-15 00:53:27.000000', 'consum', 0.0224, 'lps'),
	(397071, 102, '2015-02-15 00:53:28.000000', 'consum', 0.0217, 'lps'),
	(397072, 102, '2015-02-15 00:53:29.000000', 'consum', 0.0224, 'lps'),
	(397073, 102, '2015-02-15 00:53:30.000000', 'consum', 0.0217, 'lps'),
	(397074, 102, '2015-02-15 00:53:31.000000', 'consum', 0.0224, 'lps'),
	(397075, 102, '2015-02-15 00:53:32.000000', 'consum', 0.0218, 'lps'),
	(397076, 102, '2015-02-15 00:53:33.000000', 'consum', 0.0210, 'lps'),
	(397077, 102, '2015-02-15 00:53:34.000000', 'consum', 0.0226, 'lps'),
	(397078, 102, '2015-02-15 00:53:35.000000', 'consum', 0.0212, 'lps'),
	(397079, 102, '2015-02-15 00:53:36.000000', 'consum', 0.0210, 'lps'),
	(397080, 102, '2015-02-15 00:53:37.000000', 'consum', 0.0224, 'lps'),
	(397081, 102, '2015-02-15 00:53:38.000000', 'consum', 0.0224, 'lps'),
	(397082, 102, '2015-02-15 00:53:39.000000', 'consum', 0.0215, 'lps'),
	(397083, 102, '2015-02-15 00:53:40.000000', 'consum', 0.0216, 'lps'),
	(397084, 102, '2015-02-15 00:53:41.000000', 'consum', 0.0227, 'lps'),
	(397085, 102, '2015-02-15 00:53:42.000000', 'consum', 0.0214, 'lps'),
	(397086, 102, '2015-02-15 00:53:43.000000', 'consum', 0.0222, 'lps'),
	(397087, 102, '2015-02-15 00:53:44.000000', 'consum', 0.0218, 'lps'),
	(397088, 102, '2015-02-15 00:53:45.000000', 'consum', 0.0213, 'lps'),
	(397089, 102, '2015-02-15 00:53:46.000000', 'consum', 0.0224, 'lps'),
	(397090, 102, '2015-02-15 00:53:47.000000', 'consum', 0.0228, 'lps'),
	(397091, 102, '2015-02-15 00:53:48.000000', 'consum', 0.0222, 'lps'),
	(397092, 102, '2015-02-15 00:53:49.000000', 'consum', 0.0214, 'lps'),
	(397093, 102, '2015-02-15 00:53:50.000000', 'consum', 0.0214, 'lps'),
	(397094, 102, '2015-02-15 00:53:51.000000', 'consum', 0.0221, 'lps'),
	(397095, 102, '2015-02-15 00:53:52.000000', 'consum', 0.0211, 'lps'),
	(397096, 102, '2015-02-15 00:53:53.000000', 'consum', 0.0225, 'lps'),
	(397097, 102, '2015-02-15 00:53:54.000000', 'consum', 0.0220, 'lps'),
	(397098, 102, '2015-02-15 00:53:55.000000', 'consum', 0.0215, 'lps'),
	(397099, 102, '2015-02-15 00:53:56.000000', 'consum', 0.0226, 'lps'),
	(397100, 102, '2015-02-15 00:53:57.000000', 'consum', 0.0218, 'lps'),
	(397101, 102, '2015-02-15 00:53:58.000000', 'consum', 0.0221, 'lps'),
	(397102, 102, '2015-02-15 00:53:59.000000', 'consum', 0.0221, 'lps'),
	(397103, 102, '2015-02-15 00:54:00.000000', 'consum', 0.0211, 'lps'),
	(397104, 102, '2015-02-15 00:54:01.000000', 'consum', 0.0226, 'lps'),
	(397105, 102, '2015-02-15 00:54:02.000000', 'consum', 0.0224, 'lps'),
	(397106, 102, '2015-02-15 00:54:03.000000', 'consum', 0.0213, 'lps'),
	(397107, 102, '2015-02-15 00:54:04.000000', 'consum', 0.0224, 'lps'),
	(397108, 102, '2015-02-15 00:54:05.000000', 'consum', 0.0214, 'lps'),
	(397109, 102, '2015-02-15 00:54:06.000000', 'consum', 0.0225, 'lps'),
	(397110, 102, '2015-02-15 00:54:07.000000', 'consum', 0.0216, 'lps'),
	(397111, 102, '2015-02-15 00:54:08.000000', 'consum', 0.0214, 'lps'),
	(397112, 102, '2015-02-15 00:54:09.000000', 'consum', 0.0211, 'lps'),
	(397113, 102, '2015-02-15 00:54:10.000000', 'consum', 0.0227, 'lps'),
	(397114, 102, '2015-02-15 00:54:11.000000', 'consum', 0.0229, 'lps'),
	(397115, 102, '2015-02-15 00:54:12.000000', 'consum', 0.0215, 'lps'),
	(397116, 102, '2015-02-15 00:54:13.000000', 'consum', 0.0221, 'lps'),
	(397117, 102, '2015-02-15 00:54:14.000000', 'consum', 0.0228, 'lps'),
	(397118, 102, '2015-02-15 00:54:15.000000', 'consum', 0.0228, 'lps'),
	(397119, 102, '2015-02-15 00:54:16.000000', 'consum', 0.0225, 'lps'),
	(397120, 102, '2015-02-15 00:54:17.000000', 'consum', 0.0214, 'lps'),
	(397121, 102, '2015-02-15 00:54:18.000000', 'consum', 0.0225, 'lps'),
	(397122, 102, '2015-02-15 00:54:19.000000', 'consum', 0.0213, 'lps'),
	(397123, 102, '2015-02-15 00:54:20.000000', 'consum', 0.0220, 'lps'),
	(397124, 102, '2015-02-15 00:54:21.000000', 'consum', 0.0210, 'lps'),
	(397125, 102, '2015-02-15 00:54:22.000000', 'consum', 0.0223, 'lps'),
	(397126, 102, '2015-02-15 00:54:23.000000', 'consum', 0.0215, 'lps'),
	(397127, 102, '2015-02-15 00:54:24.000000', 'consum', 0.0215, 'lps'),
	(397128, 102, '2015-02-15 00:54:25.000000', 'consum', 0.0222, 'lps'),
	(397129, 102, '2015-02-15 00:54:26.000000', 'consum', 0.0213, 'lps'),
	(397130, 102, '2015-02-15 00:54:27.000000', 'consum', 0.0211, 'lps'),
	(397131, 102, '2015-02-15 00:54:28.000000', 'consum', 0.0227, 'lps'),
	(397132, 102, '2015-02-15 00:54:29.000000', 'consum', 0.0210, 'lps'),
	(397133, 102, '2015-02-15 00:54:30.000000', 'consum', 0.0221, 'lps'),
	(397134, 102, '2015-02-15 00:54:31.000000', 'consum', 0.0227, 'lps'),
	(397135, 102, '2015-02-15 00:54:32.000000', 'consum', 0.0223, 'lps'),
	(397136, 102, '2015-02-15 00:54:33.000000', 'consum', 0.0222, 'lps'),
	(397137, 102, '2015-02-15 00:54:34.000000', 'consum', 0.0214, 'lps'),
	(397138, 102, '2015-02-15 00:54:35.000000', 'consum', 0.0215, 'lps'),
	(397139, 102, '2015-02-15 00:54:36.000000', 'consum', 0.0220, 'lps'),
	(397140, 102, '2015-02-15 00:54:37.000000', 'consum', 0.0229, 'lps'),
	(397141, 102, '2015-02-15 00:54:38.000000', 'consum', 0.0212, 'lps'),
	(397142, 102, '2015-02-15 00:54:39.000000', 'consum', 0.0227, 'lps'),
	(397143, 102, '2015-02-15 00:54:40.000000', 'consum', 0.0228, 'lps'),
	(397144, 102, '2015-02-15 00:54:41.000000', 'consum', 0.0229, 'lps'),
	(397145, 102, '2015-02-15 00:54:42.000000', 'consum', 0.0213, 'lps'),
	(397146, 102, '2015-02-15 00:54:43.000000', 'consum', 0.0226, 'lps'),
	(397147, 102, '2015-02-15 00:54:44.000000', 'consum', 0.0221, 'lps'),
	(397148, 102, '2015-02-15 00:54:45.000000', 'consum', 0.0220, 'lps'),
	(397149, 102, '2015-02-15 00:54:46.000000', 'consum', 0.0228, 'lps'),
	(397150, 102, '2015-02-15 00:54:47.000000', 'consum', 0.0228, 'lps'),
	(397151, 102, '2015-02-15 00:54:48.000000', 'consum', 0.0229, 'lps'),
	(397152, 102, '2015-02-15 00:54:49.000000', 'consum', 0.0212, 'lps'),
	(397153, 102, '2015-02-15 00:54:50.000000', 'consum', 0.0221, 'lps'),
	(397154, 102, '2015-02-15 00:54:51.000000', 'consum', 0.0219, 'lps'),
	(397155, 102, '2015-02-15 00:54:52.000000', 'consum', 0.0222, 'lps'),
	(397156, 102, '2015-02-15 00:54:53.000000', 'consum', 0.0225, 'lps'),
	(397157, 102, '2015-02-15 00:54:54.000000', 'consum', 0.0229, 'lps'),
	(397158, 102, '2015-02-15 00:54:55.000000', 'consum', 0.0220, 'lps'),
	(397159, 102, '2015-02-15 00:54:56.000000', 'consum', 0.0223, 'lps'),
	(397160, 102, '2015-02-15 00:54:57.000000', 'consum', 0.0226, 'lps'),
	(397161, 102, '2015-02-15 00:54:58.000000', 'consum', 0.0211, 'lps'),
	(397162, 102, '2015-02-15 00:54:59.000000', 'consum', 0.0226, 'lps'),
	(397163, 102, '2015-02-15 00:55:00.000000', 'consum', 0.0210, 'lps'),
	(397164, 102, '2015-02-15 00:55:01.000000', 'consum', 0.0222, 'lps'),
	(397165, 102, '2015-02-15 00:55:02.000000', 'consum', 0.0211, 'lps'),
	(397166, 102, '2015-02-15 00:55:03.000000', 'consum', 0.0220, 'lps'),
	(397167, 102, '2015-02-15 00:55:04.000000', 'consum', 0.0215, 'lps'),
	(397168, 102, '2015-02-15 00:55:05.000000', 'consum', 0.0227, 'lps'),
	(397169, 102, '2015-02-15 00:55:06.000000', 'consum', 0.0221, 'lps'),
	(397170, 102, '2015-02-15 00:55:07.000000', 'consum', 0.0215, 'lps'),
	(397171, 102, '2015-02-15 00:55:08.000000', 'consum', 0.0223, 'lps'),
	(397172, 102, '2015-02-15 00:55:09.000000', 'consum', 0.0221, 'lps'),
	(397173, 102, '2015-02-15 00:55:10.000000', 'consum', 0.0225, 'lps'),
	(397174, 102, '2015-02-15 00:55:11.000000', 'consum', 0.0212, 'lps'),
	(397175, 102, '2015-02-15 00:55:12.000000', 'consum', 0.0216, 'lps'),
	(397176, 102, '2015-02-15 00:55:13.000000', 'consum', 0.0214, 'lps'),
	(397177, 102, '2015-02-15 00:55:14.000000', 'consum', 0.0213, 'lps'),
	(397178, 102, '2015-02-15 00:55:15.000000', 'consum', 0.0212, 'lps'),
	(397179, 102, '2015-02-15 00:55:16.000000', 'consum', 0.0211, 'lps'),
	(397180, 102, '2015-02-15 00:55:17.000000', 'consum', 0.0212, 'lps'),
	(397181, 102, '2015-02-15 00:55:18.000000', 'consum', 0.0218, 'lps'),
	(397182, 102, '2015-02-15 00:55:19.000000', 'consum', 0.0222, 'lps'),
	(397183, 102, '2015-02-15 00:55:20.000000', 'consum', 0.0227, 'lps'),
	(397184, 102, '2015-02-15 00:55:21.000000', 'consum', 0.0219, 'lps'),
	(397185, 102, '2015-02-15 00:55:22.000000', 'consum', 0.0225, 'lps'),
	(397186, 102, '2015-02-15 00:55:23.000000', 'consum', 0.0217, 'lps'),
	(397187, 102, '2015-02-15 00:55:24.000000', 'consum', 0.0221, 'lps'),
	(397188, 102, '2015-02-15 00:55:25.000000', 'consum', 0.0224, 'lps'),
	(397189, 102, '2015-02-15 00:55:26.000000', 'consum', 0.0229, 'lps'),
	(397190, 102, '2015-02-15 00:55:27.000000', 'consum', 0.0223, 'lps'),
	(397191, 102, '2015-02-15 00:55:28.000000', 'consum', 0.0219, 'lps'),
	(397192, 102, '2015-02-15 00:55:29.000000', 'consum', 0.0218, 'lps'),
	(397193, 102, '2015-02-15 00:55:30.000000', 'consum', 0.0223, 'lps'),
	(397194, 102, '2015-02-15 00:55:31.000000', 'consum', 0.0229, 'lps'),
	(397195, 102, '2015-02-15 00:55:32.000000', 'consum', 0.0227, 'lps'),
	(397196, 102, '2015-02-15 00:55:33.000000', 'consum', 0.0220, 'lps'),
	(397197, 102, '2015-02-15 00:55:34.000000', 'consum', 0.0228, 'lps'),
	(397198, 102, '2015-02-15 00:55:35.000000', 'consum', 0.0212, 'lps'),
	(397199, 102, '2015-02-15 00:55:36.000000', 'consum', 0.0227, 'lps'),
	(397200, 102, '2015-02-15 00:55:37.000000', 'consum', 0.0211, 'lps'),
	(397201, 102, '2015-02-15 00:55:38.000000', 'consum', 0.0222, 'lps'),
	(397202, 102, '2015-02-15 00:55:39.000000', 'consum', 0.0228, 'lps'),
	(397203, 102, '2015-02-15 00:55:40.000000', 'consum', 0.0224, 'lps'),
	(397204, 102, '2015-02-15 00:55:41.000000', 'consum', 0.0228, 'lps'),
	(397205, 102, '2015-02-15 00:55:42.000000', 'consum', 0.0217, 'lps'),
	(397206, 102, '2015-02-15 00:55:43.000000', 'consum', 0.0213, 'lps'),
	(397207, 102, '2015-02-15 00:55:44.000000', 'consum', 0.0225, 'lps'),
	(397208, 102, '2015-02-15 00:55:45.000000', 'consum', 0.0216, 'lps'),
	(397209, 102, '2015-02-15 00:55:46.000000', 'consum', 0.0214, 'lps'),
	(397210, 102, '2015-02-15 00:55:47.000000', 'consum', 0.0212, 'lps'),
	(397211, 102, '2015-02-15 00:55:48.000000', 'consum', 0.0229, 'lps'),
	(397212, 102, '2015-02-15 00:55:49.000000', 'consum', 0.0221, 'lps'),
	(397213, 102, '2015-02-15 00:55:50.000000', 'consum', 0.0226, 'lps'),
	(397214, 102, '2015-02-15 00:55:51.000000', 'consum', 0.0218, 'lps'),
	(397215, 102, '2015-02-15 00:55:52.000000', 'consum', 0.0224, 'lps'),
	(397216, 102, '2015-02-15 00:55:53.000000', 'consum', 0.0216, 'lps'),
	(397217, 102, '2015-02-15 00:55:54.000000', 'consum', 0.0217, 'lps'),
	(397218, 102, '2015-02-15 00:55:55.000000', 'consum', 0.0228, 'lps'),
	(397219, 102, '2015-02-15 00:55:56.000000', 'consum', 0.0218, 'lps'),
	(397220, 102, '2015-02-15 00:55:57.000000', 'consum', 0.0218, 'lps'),
	(397221, 102, '2015-02-15 00:55:58.000000', 'consum', 0.0227, 'lps'),
	(397222, 102, '2015-02-15 00:55:59.000000', 'consum', 0.0213, 'lps'),
	(397223, 102, '2015-02-15 00:56:00.000000', 'consum', 0.0212, 'lps'),
	(397224, 102, '2015-02-15 00:56:01.000000', 'consum', 0.0212, 'lps'),
	(397225, 102, '2015-02-15 00:56:02.000000', 'consum', 0.0215, 'lps'),
	(397226, 102, '2015-02-15 00:56:03.000000', 'consum', 0.0227, 'lps'),
	(397227, 102, '2015-02-15 00:56:04.000000', 'consum', 0.0224, 'lps'),
	(397228, 102, '2015-02-15 00:56:05.000000', 'consum', 0.0229, 'lps'),
	(397229, 102, '2015-02-15 00:56:06.000000', 'consum', 0.0222, 'lps'),
	(397230, 102, '2015-02-15 00:56:07.000000', 'consum', 0.0213, 'lps'),
	(397231, 102, '2015-02-15 00:56:08.000000', 'consum', 0.0212, 'lps'),
	(397232, 102, '2015-02-15 00:56:09.000000', 'consum', 0.0212, 'lps'),
	(397233, 102, '2015-02-15 00:56:10.000000', 'consum', 0.0212, 'lps'),
	(397234, 102, '2015-02-15 00:56:11.000000', 'consum', 0.0215, 'lps'),
	(397235, 102, '2015-02-15 00:56:12.000000', 'consum', 0.0228, 'lps'),
	(397236, 102, '2015-02-15 00:56:13.000000', 'consum', 0.0226, 'lps'),
	(397237, 102, '2015-02-15 00:56:14.000000', 'consum', 0.0219, 'lps'),
	(397238, 102, '2015-02-15 00:56:15.000000', 'consum', 0.0225, 'lps'),
	(397239, 102, '2015-02-15 00:56:16.000000', 'consum', 0.0221, 'lps'),
	(397240, 102, '2015-02-15 00:56:17.000000', 'consum', 0.0219, 'lps'),
	(397241, 102, '2015-02-15 00:56:18.000000', 'consum', 0.0223, 'lps'),
	(397242, 102, '2015-02-15 00:56:19.000000', 'consum', 0.0227, 'lps'),
	(397243, 102, '2015-02-15 00:56:20.000000', 'consum', 0.0218, 'lps'),
	(397244, 102, '2015-02-15 00:56:21.000000', 'consum', 0.0221, 'lps'),
	(397245, 102, '2015-02-15 00:56:22.000000', 'consum', 0.0220, 'lps'),
	(397246, 102, '2015-02-15 00:56:23.000000', 'consum', 0.0227, 'lps'),
	(397247, 102, '2015-02-15 00:56:24.000000', 'consum', 0.0227, 'lps'),
	(397248, 102, '2015-02-15 00:56:25.000000', 'consum', 0.0222, 'lps'),
	(397249, 102, '2015-02-15 00:56:26.000000', 'consum', 0.0219, 'lps'),
	(397250, 102, '2015-02-15 00:56:27.000000', 'consum', 0.0222, 'lps'),
	(397251, 102, '2015-02-15 00:56:28.000000', 'consum', 0.0222, 'lps'),
	(397252, 102, '2015-02-15 00:56:29.000000', 'consum', 0.0213, 'lps'),
	(397253, 102, '2015-02-15 00:56:30.000000', 'consum', 0.0212, 'lps'),
	(397254, 102, '2015-02-15 00:56:31.000000', 'consum', 0.0213, 'lps'),
	(397255, 102, '2015-02-15 00:56:32.000000', 'consum', 0.0217, 'lps'),
	(397256, 102, '2015-02-15 00:56:33.000000', 'consum', 0.0216, 'lps'),
	(397257, 102, '2015-02-15 00:56:34.000000', 'consum', 0.0221, 'lps'),
	(397258, 102, '2015-02-15 00:56:35.000000', 'consum', 0.0228, 'lps'),
	(397259, 102, '2015-02-15 00:56:36.000000', 'consum', 0.0229, 'lps'),
	(397260, 102, '2015-02-15 00:56:37.000000', 'consum', 0.0229, 'lps'),
	(397261, 102, '2015-02-15 00:56:38.000000', 'consum', 0.0229, 'lps'),
	(397262, 102, '2015-02-15 00:56:39.000000', 'consum', 0.0228, 'lps'),
	(397263, 102, '2015-02-15 00:56:40.000000', 'consum', 0.0223, 'lps'),
	(397264, 102, '2015-02-15 00:56:41.000000', 'consum', 0.0222, 'lps'),
	(397265, 102, '2015-02-15 00:56:42.000000', 'consum', 0.0210, 'lps'),
	(397266, 102, '2015-02-15 00:56:43.000000', 'consum', 0.0217, 'lps'),
	(397267, 102, '2015-02-15 00:56:44.000000', 'consum', 0.0227, 'lps'),
	(397268, 102, '2015-02-15 00:56:45.000000', 'consum', 0.0211, 'lps'),
	(397269, 102, '2015-02-15 00:56:46.000000', 'consum', 0.0225, 'lps'),
	(397270, 102, '2015-02-15 00:56:47.000000', 'consum', 0.0224, 'lps'),
	(397271, 102, '2015-02-15 00:56:48.000000', 'consum', 0.0213, 'lps'),
	(397272, 102, '2015-02-15 00:56:49.000000', 'consum', 0.0225, 'lps'),
	(397273, 102, '2015-02-15 00:56:50.000000', 'consum', 0.0216, 'lps'),
	(397274, 102, '2015-02-15 00:56:51.000000', 'consum', 0.0217, 'lps'),
	(397275, 102, '2015-02-15 00:56:52.000000', 'consum', 0.0228, 'lps'),
	(397276, 102, '2015-02-15 00:56:53.000000', 'consum', 0.0220, 'lps'),
	(397277, 102, '2015-02-15 00:56:54.000000', 'consum', 0.0225, 'lps'),
	(397278, 102, '2015-02-15 00:56:55.000000', 'consum', 0.0217, 'lps'),
	(397279, 102, '2015-02-15 00:56:56.000000', 'consum', 0.0218, 'lps'),
	(397280, 102, '2015-02-15 00:56:57.000000', 'consum', 0.0212, 'lps'),
	(397281, 102, '2015-02-15 00:56:58.000000', 'consum', 0.0215, 'lps'),
	(397282, 102, '2015-02-15 00:56:59.000000', 'consum', 0.0211, 'lps'),
	(397283, 102, '2015-02-15 00:57:00.000000', 'consum', 0.0218, 'lps'),
	(397284, 102, '2015-02-15 00:57:01.000000', 'consum', 0.0210, 'lps'),
	(397285, 102, '2015-02-15 00:57:02.000000', 'consum', 0.0224, 'lps'),
	(397286, 102, '2015-02-15 00:57:03.000000', 'consum', 0.0223, 'lps'),
	(397287, 102, '2015-02-15 00:57:04.000000', 'consum', 0.0211, 'lps'),
	(397288, 102, '2015-02-15 00:57:05.000000', 'consum', 0.0217, 'lps'),
	(397289, 102, '2015-02-15 00:57:06.000000', 'consum', 0.0221, 'lps'),
	(397290, 102, '2015-02-15 00:57:07.000000', 'consum', 0.0225, 'lps'),
	(397291, 102, '2015-02-15 00:57:08.000000', 'consum', 0.0213, 'lps'),
	(397292, 102, '2015-02-15 00:57:09.000000', 'consum', 0.0219, 'lps'),
	(397293, 102, '2015-02-15 00:57:10.000000', 'consum', 0.0228, 'lps'),
	(397294, 102, '2015-02-15 00:57:11.000000', 'consum', 0.0213, 'lps'),
	(397295, 102, '2015-02-15 00:57:12.000000', 'consum', 0.0212, 'lps'),
	(397296, 102, '2015-02-15 00:57:13.000000', 'consum', 0.0212, 'lps'),
	(397297, 102, '2015-02-15 00:57:14.000000', 'consum', 0.0215, 'lps'),
	(397298, 102, '2015-02-15 00:57:15.000000', 'consum', 0.0210, 'lps'),
	(397299, 102, '2015-02-15 00:57:16.000000', 'consum', 0.0213, 'lps'),
	(397300, 102, '2015-02-15 00:57:17.000000', 'consum', 0.0227, 'lps'),
	(397301, 102, '2015-02-15 00:57:18.000000', 'consum', 0.0226, 'lps'),
	(397302, 102, '2015-02-15 00:57:19.000000', 'consum', 0.0218, 'lps'),
	(397303, 102, '2015-02-15 00:57:20.000000', 'consum', 0.0226, 'lps'),
	(397304, 102, '2015-02-15 00:57:21.000000', 'consum', 0.0224, 'lps'),
	(397305, 102, '2015-02-15 00:57:22.000000', 'consum', 0.0213, 'lps'),
	(397306, 102, '2015-02-15 00:57:23.000000', 'consum', 0.0224, 'lps'),
	(397307, 102, '2015-02-15 00:57:24.000000', 'consum', 0.0212, 'lps'),
	(397308, 102, '2015-02-15 00:57:25.000000', 'consum', 0.0220, 'lps'),
	(397309, 102, '2015-02-15 00:57:26.000000', 'consum', 0.0212, 'lps'),
	(397310, 102, '2015-02-15 00:57:27.000000', 'consum', 0.0211, 'lps'),
	(397311, 102, '2015-02-15 00:57:28.000000', 'consum', 0.0211, 'lps'),
	(397312, 102, '2015-02-15 00:57:29.000000', 'consum', 0.0210, 'lps'),
	(397313, 102, '2015-02-15 00:57:30.000000', 'consum', 0.0227, 'lps'),
	(397314, 102, '2015-02-15 00:57:31.000000', 'consum', 0.0216, 'lps'),
	(397315, 102, '2015-02-15 00:57:32.000000', 'consum', 0.0212, 'lps'),
	(397316, 102, '2015-02-15 00:57:33.000000', 'consum', 0.0221, 'lps'),
	(397317, 102, '2015-02-15 00:57:34.000000', 'consum', 0.0218, 'lps'),
	(397318, 102, '2015-02-15 00:57:35.000000', 'consum', 0.0217, 'lps'),
	(397319, 102, '2015-02-15 00:57:36.000000', 'consum', 0.0224, 'lps'),
	(397320, 102, '2015-02-15 00:57:37.000000', 'consum', 0.0219, 'lps'),
	(397321, 102, '2015-02-15 00:57:38.000000', 'consum', 0.0212, 'lps'),
	(397322, 102, '2015-02-15 00:57:39.000000', 'consum', 0.0214, 'lps'),
	(397323, 102, '2015-02-15 00:57:40.000000', 'consum', 0.0225, 'lps'),
	(397324, 102, '2015-02-15 00:57:41.000000', 'consum', 0.0211, 'lps'),
	(397325, 102, '2015-02-15 00:57:42.000000', 'consum', 0.0214, 'lps'),
	(397326, 102, '2015-02-15 00:57:43.000000', 'consum', 0.0226, 'lps'),
	(397327, 102, '2015-02-15 00:57:44.000000', 'consum', 0.0218, 'lps'),
	(397328, 102, '2015-02-15 00:57:45.000000', 'consum', 0.0224, 'lps'),
	(397329, 102, '2015-02-15 00:57:46.000000', 'consum', 0.0218, 'lps'),
	(397330, 102, '2015-02-15 00:57:47.000000', 'consum', 0.0226, 'lps'),
	(397331, 102, '2015-02-15 00:57:48.000000', 'consum', 0.0226, 'lps'),
	(397332, 102, '2015-02-15 00:57:49.000000', 'consum', 0.0225, 'lps'),
	(397333, 102, '2015-02-15 00:57:50.000000', 'consum', 0.0214, 'lps'),
	(397334, 102, '2015-02-15 00:57:51.000000', 'consum', 0.0229, 'lps'),
	(397335, 102, '2015-02-15 00:57:52.000000', 'consum', 0.0211, 'lps'),
	(397336, 102, '2015-02-15 00:57:53.000000', 'consum', 0.0220, 'lps'),
	(397337, 102, '2015-02-15 00:57:54.000000', 'consum', 0.0217, 'lps'),
	(397338, 102, '2015-02-15 00:57:55.000000', 'consum', 0.0215, 'lps'),
	(397339, 102, '2015-02-15 00:57:56.000000', 'consum', 0.0215, 'lps'),
	(397340, 102, '2015-02-15 00:57:57.000000', 'consum', 0.0221, 'lps'),
	(397341, 102, '2015-02-15 00:57:58.000000', 'consum', 0.0212, 'lps'),
	(397342, 102, '2015-02-15 00:57:59.000000', 'consum', 0.0225, 'lps'),
	(397343, 102, '2015-02-15 00:58:00.000000', 'consum', 0.0219, 'lps'),
	(397344, 102, '2015-02-15 00:58:01.000000', 'consum', 0.0211, 'lps'),
	(397345, 102, '2015-02-15 00:58:02.000000', 'consum', 0.0227, 'lps'),
	(397346, 102, '2015-02-15 00:58:03.000000', 'consum', 0.0215, 'lps'),
	(397347, 102, '2015-02-15 00:58:04.000000', 'consum', 0.0225, 'lps'),
	(397348, 102, '2015-02-15 00:58:05.000000', 'consum', 0.0229, 'lps'),
	(397349, 102, '2015-02-15 00:58:06.000000', 'consum', 0.0220, 'lps'),
	(397350, 102, '2015-02-15 00:58:07.000000', 'consum', 0.0225, 'lps'),
	(397351, 102, '2015-02-15 00:58:08.000000', 'consum', 0.0213, 'lps'),
	(397352, 102, '2015-02-15 00:58:09.000000', 'consum', 0.0222, 'lps'),
	(397353, 102, '2015-02-15 00:58:10.000000', 'consum', 0.0222, 'lps'),
	(397354, 102, '2015-02-15 00:58:11.000000', 'consum', 0.0215, 'lps'),
	(397355, 102, '2015-02-15 00:58:12.000000', 'consum', 0.0217, 'lps'),
	(397356, 102, '2015-02-15 00:58:13.000000', 'consum', 0.0211, 'lps'),
	(397357, 102, '2015-02-15 00:58:14.000000', 'consum', 0.0215, 'lps'),
	(397358, 102, '2015-02-15 00:58:15.000000', 'consum', 0.0213, 'lps'),
	(397359, 102, '2015-02-15 00:58:16.000000', 'consum', 0.0212, 'lps'),
	(397360, 102, '2015-02-15 00:58:17.000000', 'consum', 0.0210, 'lps'),
	(397361, 102, '2015-02-15 00:58:18.000000', 'consum', 0.0225, 'lps'),
	(397362, 102, '2015-02-15 00:58:19.000000', 'consum', 0.0225, 'lps'),
	(397363, 102, '2015-02-15 00:58:20.000000', 'consum', 0.0219, 'lps'),
	(397364, 102, '2015-02-15 00:58:21.000000', 'consum', 0.0213, 'lps'),
	(397365, 102, '2015-02-15 00:58:22.000000', 'consum', 0.0220, 'lps'),
	(397366, 102, '2015-02-15 00:58:23.000000', 'consum', 0.0228, 'lps'),
	(397367, 102, '2015-02-15 00:58:24.000000', 'consum', 0.0213, 'lps'),
	(397368, 102, '2015-02-15 00:58:25.000000', 'consum', 0.0212, 'lps'),
	(397369, 102, '2015-02-15 00:58:26.000000', 'consum', 0.0211, 'lps'),
	(397370, 102, '2015-02-15 00:58:27.000000', 'consum', 0.0211, 'lps'),
	(397371, 102, '2015-02-15 00:58:28.000000', 'consum', 0.0211, 'lps'),
	(397372, 102, '2015-02-15 00:58:29.000000', 'consum', 0.0212, 'lps'),
	(397373, 102, '2015-02-15 00:58:30.000000', 'consum', 0.0217, 'lps'),
	(397374, 102, '2015-02-15 00:58:31.000000', 'consum', 0.0220, 'lps'),
	(397375, 102, '2015-02-15 00:58:32.000000', 'consum', 0.0221, 'lps'),
	(397376, 102, '2015-02-15 00:58:33.000000', 'consum', 0.0215, 'lps'),
	(397377, 102, '2015-02-15 00:58:34.000000', 'consum', 0.0222, 'lps'),
	(397378, 102, '2015-02-15 00:58:35.000000', 'consum', 0.0217, 'lps'),
	(397379, 102, '2015-02-15 00:58:36.000000', 'consum', 0.0227, 'lps'),
	(397380, 102, '2015-02-15 00:58:37.000000', 'consum', 0.0217, 'lps'),
	(397381, 102, '2015-02-15 00:58:38.000000', 'consum', 0.0212, 'lps'),
	(397382, 102, '2015-02-15 00:58:39.000000', 'consum', 0.0222, 'lps'),
	(397383, 102, '2015-02-15 00:58:40.000000', 'consum', 0.0225, 'lps'),
	(397384, 102, '2015-02-15 00:58:41.000000', 'consum', 0.0227, 'lps'),
	(397385, 102, '2015-02-15 00:58:42.000000', 'consum', 0.0210, 'lps'),
	(397386, 102, '2015-02-15 00:58:43.000000', 'consum', 0.0222, 'lps'),
	(397387, 102, '2015-02-15 00:58:44.000000', 'consum', 0.0227, 'lps'),
	(397388, 102, '2015-02-15 00:58:45.000000', 'consum', 0.0223, 'lps'),
	(397389, 102, '2015-02-15 00:58:46.000000', 'consum', 0.0222, 'lps'),
	(397390, 102, '2015-02-15 00:58:47.000000', 'consum', 0.0214, 'lps'),
	(397391, 102, '2015-02-15 00:58:48.000000', 'consum', 0.0215, 'lps'),
	(397392, 102, '2015-02-15 00:58:49.000000', 'consum', 0.0220, 'lps'),
	(397393, 102, '2015-02-15 00:58:50.000000', 'consum', 0.0228, 'lps'),
	(397394, 102, '2015-02-15 00:58:51.000000', 'consum', 0.0212, 'lps'),
	(397395, 102, '2015-02-15 00:58:52.000000', 'consum', 0.0225, 'lps'),
	(397396, 102, '2015-02-15 00:58:53.000000', 'consum', 0.0218, 'lps'),
	(397397, 102, '2015-02-15 00:58:54.000000', 'consum', 0.0225, 'lps'),
	(397398, 102, '2015-02-15 00:58:55.000000', 'consum', 0.0221, 'lps'),
	(397399, 102, '2015-02-15 00:58:56.000000', 'consum', 0.0223, 'lps'),
	(397400, 102, '2015-02-15 00:58:57.000000', 'consum', 0.0223, 'lps'),
	(397401, 102, '2015-02-15 00:58:58.000000', 'consum', 0.0213, 'lps'),
	(397402, 102, '2015-02-15 00:58:59.000000', 'consum', 0.0210, 'lps'),
	(397403, 102, '2015-02-15 00:59:00.000000', 'consum', 0.0221, 'lps'),
	(397404, 102, '2015-02-15 00:59:01.000000', 'consum', 0.0226, 'lps'),
	(397405, 102, '2015-02-15 00:59:02.000000', 'consum', 0.0217, 'lps'),
	(397406, 102, '2015-02-15 00:59:03.000000', 'consum', 0.0218, 'lps'),
	(397407, 102, '2015-02-15 00:59:04.000000', 'consum', 0.0228, 'lps'),
	(397408, 102, '2015-02-15 00:59:05.000000', 'consum', 0.0216, 'lps'),
	(397409, 102, '2015-02-15 00:59:06.000000', 'consum', 0.0228, 'lps'),
	(397410, 102, '2015-02-15 00:59:07.000000', 'consum', 0.0220, 'lps'),
	(397411, 102, '2015-02-15 00:59:08.000000', 'consum', 0.0228, 'lps'),
	(397412, 102, '2015-02-15 00:59:09.000000', 'consum', 0.0211, 'lps'),
	(397413, 102, '2015-02-15 00:59:10.000000', 'consum', 0.0223, 'lps'),
	(397414, 102, '2015-02-15 00:59:11.000000', 'consum', 0.0210, 'lps'),
	(397415, 102, '2015-02-15 00:59:12.000000', 'consum', 0.0210, 'lps'),
	(397416, 102, '2015-02-15 00:59:13.000000', 'consum', 0.0213, 'lps'),
	(397417, 102, '2015-02-15 00:59:14.000000', 'consum', 0.0226, 'lps'),
	(397418, 102, '2015-02-15 00:59:15.000000', 'consum', 0.0219, 'lps'),
	(397419, 102, '2015-02-15 00:59:16.000000', 'consum', 0.0210, 'lps'),
	(397420, 102, '2015-02-15 00:59:17.000000', 'consum', 0.0221, 'lps'),
	(397421, 102, '2015-02-15 00:59:18.000000', 'consum', 0.0229, 'lps'),
	(397422, 102, '2015-02-15 00:59:19.000000', 'consum', 0.0229, 'lps'),
	(397423, 102, '2015-02-15 00:59:20.000000', 'consum', 0.0210, 'lps'),
	(397424, 102, '2015-02-15 00:59:21.000000', 'consum', 0.0212, 'lps'),
	(397425, 102, '2015-02-15 00:59:22.000000', 'consum', 0.0221, 'lps'),
	(397426, 102, '2015-02-15 00:59:23.000000', 'consum', 0.0219, 'lps'),
	(397427, 102, '2015-02-15 00:59:24.000000', 'consum', 0.0224, 'lps'),
	(397428, 102, '2015-02-15 00:59:25.000000', 'consum', 0.0212, 'lps'),
	(397429, 102, '2015-02-15 00:59:26.000000', 'consum', 0.0221, 'lps'),
	(397430, 102, '2015-02-15 00:59:27.000000', 'consum', 0.0217, 'lps'),
	(397431, 102, '2015-02-15 00:59:28.000000', 'consum', 0.0215, 'lps'),
	(397432, 102, '2015-02-15 00:59:29.000000', 'consum', 0.0213, 'lps'),
	(397433, 102, '2015-02-15 00:59:30.000000', 'consum', 0.0229, 'lps'),
	(397434, 102, '2015-02-15 00:59:31.000000', 'consum', 0.0219, 'lps'),
	(397435, 102, '2015-02-15 00:59:32.000000', 'consum', 0.0218, 'lps'),
	(397436, 102, '2015-02-15 00:59:33.000000', 'consum', 0.0225, 'lps'),
	(397437, 102, '2015-02-15 00:59:34.000000', 'consum', 0.0218, 'lps'),
	(397438, 102, '2015-02-15 00:59:35.000000', 'consum', 0.0229, 'lps'),
	(397439, 102, '2015-02-15 00:59:36.000000', 'consum', 0.0221, 'lps'),
	(397440, 102, '2015-02-15 00:59:37.000000', 'consum', 0.0228, 'lps'),
	(397441, 102, '2015-02-15 00:59:38.000000', 'consum', 0.0229, 'lps'),
	(397442, 102, '2015-02-15 00:59:39.000000', 'consum', 0.0210, 'lps'),
	(397443, 102, '2015-02-15 00:59:40.000000', 'consum', 0.0215, 'lps'),
	(397444, 102, '2015-02-15 00:59:41.000000', 'consum', 0.0216, 'lps'),
	(397445, 102, '2015-02-15 00:59:42.000000', 'consum', 0.0226, 'lps'),
	(397446, 102, '2015-02-15 00:59:43.000000', 'consum', 0.0210, 'lps'),
	(397447, 102, '2015-02-15 00:59:44.000000', 'consum', 0.0223, 'lps'),
	(397448, 102, '2015-02-15 00:59:45.000000', 'consum', 0.0217, 'lps'),
	(397449, 102, '2015-02-15 00:59:46.000000', 'consum', 0.0225, 'lps'),
	(397450, 102, '2015-02-15 00:59:47.000000', 'consum', 0.0224, 'lps'),
	(397451, 102, '2015-02-15 00:59:48.000000', 'consum', 0.0216, 'lps'),
	(397452, 102, '2015-02-15 00:59:49.000000', 'consum', 0.0219, 'lps'),
	(397453, 102, '2015-02-15 00:59:50.000000', 'consum', 0.0219, 'lps'),
	(397454, 102, '2015-02-15 00:59:51.000000', 'consum', 0.0227, 'lps'),
	(397455, 102, '2015-02-15 00:59:52.000000', 'consum', 0.0229, 'lps'),
	(397456, 102, '2015-02-15 00:59:53.000000', 'consum', 0.0213, 'lps'),
	(397457, 102, '2015-02-15 00:59:54.000000', 'consum', 0.0229, 'lps'),
	(397458, 102, '2015-02-15 00:59:55.000000', 'consum', 0.0215, 'lps'),
	(397459, 102, '2015-02-15 00:59:56.000000', 'consum', 0.0219, 'lps'),
	(397460, 102, '2015-02-15 00:59:57.000000', 'consum', 0.0219, 'lps'),
	(397461, 102, '2015-02-15 00:59:58.000000', 'consum', 0.0211, 'lps'),
	(397462, 102, '2015-02-15 00:59:59.000000', 'consum', 0.0228, 'lps'),
	(397463, 102, '2015-02-15 01:00:00.000000', 'consum', 0.0218, 'lps'),
	(397464, 102, '2015-02-15 01:00:01.000000', 'consum', 0.0214, 'lps'),
	(397465, 102, '2015-02-15 01:00:02.000000', 'consum', 0.0228, 'lps'),
	(397466, 102, '2015-02-15 01:00:03.000000', 'consum', 0.0229, 'lps'),
	(397467, 102, '2015-02-15 01:00:04.000000', 'consum', 0.0210, 'lps'),
	(397468, 102, '2015-02-15 01:00:05.000000', 'consum', 0.0213, 'lps'),
	(397469, 102, '2015-02-15 01:00:06.000000', 'consum', 0.0228, 'lps'),
	(397470, 102, '2015-02-15 01:00:07.000000', 'consum', 0.0211, 'lps'),
	(397471, 102, '2015-02-15 01:00:08.000000', 'consum', 0.0222, 'lps'),
	(397472, 102, '2015-02-15 01:00:09.000000', 'consum', 0.0225, 'lps'),
	(397473, 102, '2015-02-15 01:00:10.000000', 'consum', 0.0213, 'lps'),
	(397474, 102, '2015-02-15 01:00:11.000000', 'consum', 0.0218, 'lps'),
	(397475, 102, '2015-02-15 01:00:12.000000', 'consum', 0.0221, 'lps'),
	(397476, 102, '2015-02-15 01:00:13.000000', 'consum', 0.0222, 'lps'),
	(397477, 102, '2015-02-15 01:00:14.000000', 'consum', 0.0216, 'lps'),
	(397478, 102, '2015-02-15 01:00:15.000000', 'consum', 0.0226, 'lps'),
	(397479, 102, '2015-02-15 01:00:16.000000', 'consum', 0.0211, 'lps'),
	(397480, 102, '2015-02-15 01:00:17.000000', 'consum', 0.0228, 'lps'),
	(397481, 102, '2015-02-15 01:00:18.000000', 'consum', 0.0219, 'lps'),
	(397482, 102, '2015-02-15 01:00:19.000000', 'consum', 0.0221, 'lps'),
	(397483, 102, '2015-02-15 01:00:20.000000', 'consum', 0.0220, 'lps'),
	(397484, 102, '2015-02-15 01:00:21.000000', 'consum', 0.0226, 'lps'),
	(397485, 102, '2015-02-15 01:00:22.000000', 'consum', 0.0220, 'lps'),
	(397486, 102, '2015-02-15 01:00:23.000000', 'consum', 0.0215, 'lps'),
	(397487, 102, '2015-02-15 01:00:24.000000', 'consum', 0.0225, 'lps'),
	(397488, 102, '2015-02-15 01:00:25.000000', 'consum', 0.0228, 'lps'),
	(397489, 102, '2015-02-15 01:00:26.000000', 'consum', 0.0217, 'lps'),
	(397490, 102, '2015-02-15 01:00:27.000000', 'consum', 0.0213, 'lps'),
	(397491, 102, '2015-02-15 01:00:28.000000', 'consum', 0.0224, 'lps'),
	(397492, 102, '2015-02-15 01:00:29.000000', 'consum', 0.0211, 'lps'),
	(397493, 102, '2015-02-15 01:00:30.000000', 'consum', 0.0213, 'lps'),
	(397494, 102, '2015-02-15 01:00:31.000000', 'consum', 0.0224, 'lps'),
	(397495, 102, '2015-02-15 01:00:32.000000', 'consum', 0.0229, 'lps'),
	(397496, 102, '2015-02-15 01:00:33.000000', 'consum', 0.0226, 'lps'),
	(397497, 102, '2015-02-15 01:00:34.000000', 'consum', 0.0212, 'lps'),
	(397498, 102, '2015-02-15 01:00:35.000000', 'consum', 0.0214, 'lps'),
	(397499, 102, '2015-02-15 01:00:36.000000', 'consum', 0.0223, 'lps'),
	(397500, 102, '2015-02-15 01:00:37.000000', 'consum', 0.0225, 'lps'),
	(397501, 102, '2015-02-15 01:00:38.000000', 'consum', 0.0226, 'lps'),
	(397502, 102, '2015-02-15 01:00:39.000000', 'consum', 0.0225, 'lps'),
	(397503, 102, '2015-02-15 01:00:40.000000', 'consum', 0.0219, 'lps'),
	(397504, 102, '2015-02-15 01:00:41.000000', 'consum', 0.0210, 'lps'),
	(397505, 102, '2015-02-15 01:00:42.000000', 'consum', 0.0222, 'lps'),
	(397506, 102, '2015-02-15 01:00:43.000000', 'consum', 0.0211, 'lps'),
	(397507, 102, '2015-02-15 01:00:44.000000', 'consum', 0.0220, 'lps'),
	(397508, 102, '2015-02-15 01:00:45.000000', 'consum', 0.0219, 'lps'),
	(397509, 102, '2015-02-15 01:00:46.000000', 'consum', 0.0223, 'lps'),
	(397510, 102, '2015-02-15 01:00:47.000000', 'consum', 0.0228, 'lps'),
	(397511, 102, '2015-02-15 01:00:48.000000', 'consum', 0.0223, 'lps'),
	(397512, 102, '2015-02-15 01:00:49.000000', 'consum', 0.0221, 'lps'),
	(397513, 102, '2015-02-15 01:00:50.000000', 'consum', 0.0227, 'lps'),
	(397514, 102, '2015-02-15 01:00:51.000000', 'consum', 0.0223, 'lps'),
	(397515, 102, '2015-02-15 01:00:52.000000', 'consum', 0.0223, 'lps'),
	(397516, 102, '2015-02-15 01:00:53.000000', 'consum', 0.0219, 'lps'),
	(397517, 102, '2015-02-15 01:00:54.000000', 'consum', 0.0216, 'lps'),
	(397518, 102, '2015-02-15 01:00:55.000000', 'consum', 0.0213, 'lps'),
	(397519, 102, '2015-02-15 01:00:56.000000', 'consum', 0.0227, 'lps'),
	(397520, 102, '2015-02-15 01:00:57.000000', 'consum', 0.0227, 'lps'),
	(397521, 102, '2015-02-15 01:00:58.000000', 'consum', 0.0222, 'lps'),
	(397522, 102, '2015-02-15 01:00:59.000000', 'consum', 0.0223, 'lps'),
	(397523, 102, '2015-02-15 01:01:00.000000', 'consum', 0.0218, 'lps'),
	(397524, 102, '2015-02-15 01:01:01.000000', 'consum', 0.0212, 'lps'),
	(397525, 102, '2015-02-15 01:01:02.000000', 'consum', 0.0214, 'lps'),
	(397526, 102, '2015-02-15 01:01:03.000000', 'consum', 0.0228, 'lps'),
	(397527, 102, '2015-02-15 01:01:04.000000', 'consum', 0.0228, 'lps'),
	(397528, 102, '2015-02-15 01:01:05.000000', 'consum', 0.0225, 'lps'),
	(397529, 102, '2015-02-15 01:01:06.000000', 'consum', 0.0210, 'lps'),
	(397530, 102, '2015-02-15 01:01:07.000000', 'consum', 0.0227, 'lps'),
	(397531, 102, '2015-02-15 01:01:08.000000', 'consum', 0.0217, 'lps'),
	(397532, 102, '2015-02-15 01:01:09.000000', 'consum', 0.0214, 'lps'),
	(397533, 102, '2015-02-15 01:01:10.000000', 'consum', 0.0227, 'lps'),
	(397534, 102, '2015-02-15 01:01:11.000000', 'consum', 0.0226, 'lps'),
	(397535, 102, '2015-02-15 01:01:12.000000', 'consum', 0.0220, 'lps'),
	(397536, 102, '2015-02-15 01:01:13.000000', 'consum', 0.0210, 'lps'),
	(397537, 102, '2015-02-15 01:01:14.000000', 'consum', 0.0221, 'lps'),
	(397538, 102, '2015-02-15 01:01:15.000000', 'consum', 0.0227, 'lps'),
	(397539, 102, '2015-02-15 01:01:16.000000', 'consum', 0.0222, 'lps'),
	(397540, 102, '2015-02-15 01:01:17.000000', 'consum', 0.0219, 'lps'),
	(397541, 102, '2015-02-15 01:01:18.000000', 'consum', 0.0221, 'lps'),
	(397542, 102, '2015-02-15 01:01:19.000000', 'consum', 0.0216, 'lps'),
	(397543, 102, '2015-02-15 01:01:20.000000', 'consum', 0.0228, 'lps'),
	(397544, 102, '2015-02-15 01:01:21.000000', 'consum', 0.0221, 'lps'),
	(397545, 102, '2015-02-15 01:01:22.000000', 'consum', 0.0214, 'lps'),
	(397546, 102, '2015-02-15 01:01:23.000000', 'consum', 0.0216, 'lps'),
	(397547, 102, '2015-02-15 01:01:24.000000', 'consum', 0.0228, 'lps'),
	(397548, 102, '2015-02-15 01:01:25.000000', 'consum', 0.0225, 'lps'),
	(397549, 102, '2015-02-15 01:01:26.000000', 'consum', 0.0228, 'lps'),
	(397550, 102, '2015-02-15 01:01:27.000000', 'consum', 0.0218, 'lps'),
	(397551, 102, '2015-02-15 01:01:28.000000', 'consum', 0.0217, 'lps'),
	(397552, 102, '2015-02-15 01:01:29.000000', 'consum', 0.0221, 'lps'),
	(397553, 102, '2015-02-15 01:01:30.000000', 'consum', 0.0224, 'lps'),
	(397554, 102, '2015-02-15 01:01:31.000000', 'consum', 0.0226, 'lps'),
	(397555, 102, '2015-02-15 01:01:32.000000', 'consum', 0.0229, 'lps'),
	(397556, 102, '2015-02-15 01:01:33.000000', 'consum', 0.0217, 'lps'),
	(397557, 102, '2015-02-15 01:01:34.000000', 'consum', 0.0228, 'lps'),
	(397558, 102, '2015-02-15 01:01:35.000000', 'consum', 0.0220, 'lps'),
	(397559, 102, '2015-02-15 01:01:36.000000', 'consum', 0.0226, 'lps'),
	(397560, 102, '2015-02-15 01:01:37.000000', 'consum', 0.0221, 'lps'),
	(397561, 102, '2015-02-15 01:01:38.000000', 'consum', 0.0218, 'lps'),
	(397562, 102, '2015-02-15 01:01:39.000000', 'consum', 0.0218, 'lps'),
	(397563, 102, '2015-02-15 01:01:40.000000', 'consum', 0.0226, 'lps'),
	(397564, 102, '2015-02-15 01:01:41.000000', 'consum', 0.0228, 'lps'),
	(397565, 102, '2015-02-15 01:01:42.000000', 'consum', 0.0210, 'lps'),
	(397566, 102, '2015-02-15 01:01:43.000000', 'consum', 0.0218, 'lps'),
	(397567, 102, '2015-02-15 01:01:44.000000', 'consum', 0.0211, 'lps'),
	(397568, 102, '2015-02-15 01:01:45.000000', 'consum', 0.0213, 'lps'),
	(397569, 102, '2015-02-15 01:01:46.000000', 'consum', 0.0220, 'lps'),
	(397570, 102, '2015-02-15 01:01:47.000000', 'consum', 0.0212, 'lps'),
	(397571, 102, '2015-02-15 01:01:48.000000', 'consum', 0.0210, 'lps'),
	(397572, 102, '2015-02-15 01:01:49.000000', 'consum', 0.0225, 'lps'),
	(397573, 102, '2015-02-15 01:01:50.000000', 'consum', 0.0227, 'lps'),
	(397574, 102, '2015-02-15 01:01:51.000000', 'consum', 0.0211, 'lps'),
	(397575, 102, '2015-02-15 01:01:52.000000', 'consum', 0.0222, 'lps'),
	(397576, 102, '2015-02-15 01:01:53.000000', 'consum', 0.0210, 'lps'),
	(397577, 102, '2015-02-15 01:01:54.000000', 'consum', 0.0213, 'lps'),
	(397578, 102, '2015-02-15 01:01:55.000000', 'consum', 0.0226, 'lps'),
	(397579, 102, '2015-02-15 01:01:56.000000', 'consum', 0.0223, 'lps'),
	(397580, 102, '2015-02-15 01:01:57.000000', 'consum', 0.0227, 'lps'),
	(397581, 102, '2015-02-15 01:01:58.000000', 'consum', 0.0215, 'lps'),
	(397582, 102, '2015-02-15 01:01:59.000000', 'consum', 0.0224, 'lps'),
	(397583, 102, '2015-02-15 01:02:00.000000', 'consum', 0.0228, 'lps'),
	(397584, 102, '2015-02-15 01:02:01.000000', 'consum', 0.0219, 'lps'),
	(397585, 102, '2015-02-15 01:02:02.000000', 'consum', 0.0220, 'lps'),
	(397586, 102, '2015-02-15 01:02:03.000000', 'consum', 0.0214, 'lps'),
	(397587, 102, '2015-02-15 01:02:04.000000', 'consum', 0.0219, 'lps'),
	(397588, 102, '2015-02-15 01:02:05.000000', 'consum', 0.0223, 'lps'),
	(397589, 102, '2015-02-15 01:02:06.000000', 'consum', 0.0228, 'lps'),
	(397590, 102, '2015-02-15 01:02:07.000000', 'consum', 0.0221, 'lps'),
	(397591, 102, '2015-02-15 01:02:08.000000', 'consum', 0.0214, 'lps'),
	(397592, 102, '2015-02-15 01:02:09.000000', 'consum', 0.0218, 'lps'),
	(397593, 102, '2015-02-15 01:02:10.000000', 'consum', 0.0219, 'lps'),
	(397594, 102, '2015-02-15 01:02:11.000000', 'consum', 0.0211, 'lps'),
	(397595, 102, '2015-02-15 01:02:12.000000', 'consum', 0.0210, 'lps'),
	(397596, 102, '2015-02-15 01:02:13.000000', 'consum', 0.0226, 'lps'),
	(397597, 102, '2015-02-15 01:02:14.000000', 'consum', 0.0212, 'lps'),
	(397598, 102, '2015-02-15 01:02:15.000000', 'consum', 0.0212, 'lps'),
	(397599, 102, '2015-02-15 01:02:16.000000', 'consum', 0.0214, 'lps'),
	(397600, 102, '2015-02-15 01:02:17.000000', 'consum', 0.0226, 'lps'),
	(397601, 102, '2015-02-15 01:02:18.000000', 'consum', 0.0220, 'lps'),
	(397602, 102, '2015-02-15 01:02:19.000000', 'consum', 0.0229, 'lps'),
	(397603, 102, '2015-02-15 01:02:20.000000', 'consum', 0.0219, 'lps'),
	(397604, 102, '2015-02-15 01:02:21.000000', 'consum', 0.0215, 'lps'),
	(397605, 102, '2015-02-15 01:02:22.000000', 'consum', 0.0229, 'lps'),
	(397606, 102, '2015-02-15 01:02:23.000000', 'consum', 0.0212, 'lps'),
	(397607, 102, '2015-02-15 01:02:24.000000', 'consum', 0.0222, 'lps'),
	(397608, 102, '2015-02-15 01:02:25.000000', 'consum', 0.0224, 'lps'),
	(397609, 102, '2015-02-15 01:02:26.000000', 'consum', 0.0227, 'lps'),
	(397610, 123, '2015-02-15 00:00:00.000000', 'consum', 0.0217, 'lps'),
	(397611, 123, '2015-02-15 00:00:01.000000', 'consum', 0.0220, 'lps'),
	(397612, 123, '2015-02-15 00:00:02.000000', 'consum', 0.0217, 'lps'),
	(397613, 123, '2015-02-15 00:00:03.000000', 'consum', 0.0215, 'lps'),
	(397614, 123, '2015-02-15 00:00:04.000000', 'consum', 0.0215, 'lps'),
	(397615, 123, '2015-02-15 00:00:05.000000', 'consum', 0.0210, 'lps'),
	(397616, 123, '2015-02-15 00:00:06.000000', 'consum', 0.0217, 'lps'),
	(397617, 123, '2015-02-15 00:00:07.000000', 'consum', 0.0212, 'lps'),
	(397618, 123, '2015-02-15 00:00:08.000000', 'consum', 0.0211, 'lps'),
	(397619, 123, '2015-02-15 00:00:09.000000', 'consum', 0.0211, 'lps'),
	(397620, 123, '2015-02-15 00:00:10.000000', 'consum', 0.0213, 'lps'),
	(397621, 123, '2015-02-15 00:00:11.000000', 'consum', 0.0210, 'lps'),
	(397622, 123, '2015-02-15 00:00:12.000000', 'consum', 0.0214, 'lps'),
	(397623, 123, '2015-02-15 00:00:13.000000', 'consum', 0.0210, 'lps'),
	(397624, 123, '2015-02-15 00:00:14.000000', 'consum', 0.0218, 'lps'),
	(397625, 123, '2015-02-15 00:00:15.000000', 'consum', 0.0218, 'lps'),
	(397626, 123, '2015-02-15 00:00:16.000000', 'consum', 0.0215, 'lps'),
	(397627, 123, '2015-02-15 00:00:17.000000', 'consum', 0.0213, 'lps'),
	(397628, 123, '2015-02-15 00:00:18.000000', 'consum', 0.0211, 'lps'),
	(397629, 123, '2015-02-15 00:00:19.000000', 'consum', 0.0218, 'lps'),
	(397630, 123, '2015-02-15 00:00:20.000000', 'consum', 0.0215, 'lps'),
	(397631, 123, '2015-02-15 00:00:21.000000', 'consum', 0.0211, 'lps'),
	(397632, 123, '2015-02-15 00:00:22.000000', 'consum', 0.0220, 'lps'),
	(397633, 123, '2015-02-15 00:00:23.000000', 'consum', 0.0216, 'lps'),
	(397634, 123, '2015-02-15 00:00:24.000000', 'consum', 0.0211, 'lps'),
	(397635, 123, '2015-02-15 00:00:25.000000', 'consum', 0.0218, 'lps'),
	(397636, 123, '2015-02-15 00:00:26.000000', 'consum', 0.0217, 'lps'),
	(397637, 123, '2015-02-15 00:00:27.000000', 'consum', 0.0220, 'lps'),
	(397638, 123, '2015-02-15 00:00:28.000000', 'consum', 0.0216, 'lps'),
	(397639, 123, '2015-02-15 00:00:29.000000', 'consum', 0.0213, 'lps'),
	(397640, 123, '2015-02-15 00:00:30.000000', 'consum', 0.0219, 'lps'),
	(397641, 123, '2015-02-15 00:00:31.000000', 'consum', 0.0214, 'lps'),
	(397642, 123, '2015-02-15 00:00:32.000000', 'consum', 0.0214, 'lps'),
	(397643, 123, '2015-02-15 00:00:33.000000', 'consum', 0.0217, 'lps'),
	(397644, 123, '2015-02-15 00:00:34.000000', 'consum', 0.0211, 'lps'),
	(397645, 123, '2015-02-15 00:00:35.000000', 'consum', 0.0218, 'lps'),
	(397646, 123, '2015-02-15 00:00:36.000000', 'consum', 0.0216, 'lps'),
	(397647, 123, '2015-02-15 00:00:37.000000', 'consum', 0.0214, 'lps'),
	(397648, 123, '2015-02-15 00:00:38.000000', 'consum', 0.0214, 'lps'),
	(397649, 123, '2015-02-15 00:00:39.000000', 'consum', 0.0218, 'lps'),
	(397650, 123, '2015-02-15 00:00:40.000000', 'consum', 0.0216, 'lps'),
	(397651, 123, '2015-02-15 00:00:41.000000', 'consum', 0.0215, 'lps'),
	(397652, 123, '2015-02-15 00:00:42.000000', 'consum', 0.0220, 'lps'),
	(397653, 123, '2015-02-15 00:00:43.000000', 'consum', 0.0213, 'lps'),
	(397654, 123, '2015-02-15 00:00:44.000000', 'consum', 0.0216, 'lps'),
	(397655, 123, '2015-02-15 00:00:45.000000', 'consum', 0.0219, 'lps'),
	(397656, 123, '2015-02-15 00:00:46.000000', 'consum', 0.0218, 'lps'),
	(397657, 123, '2015-02-15 00:00:47.000000', 'consum', 0.0211, 'lps'),
	(397658, 123, '2015-02-15 00:00:48.000000', 'consum', 0.0212, 'lps'),
	(397659, 123, '2015-02-15 00:00:49.000000', 'consum', 0.0210, 'lps'),
	(397660, 123, '2015-02-15 00:00:50.000000', 'consum', 0.0214, 'lps'),
	(397661, 123, '2015-02-15 00:00:51.000000', 'consum', 0.0219, 'lps'),
	(397662, 123, '2015-02-15 00:00:52.000000', 'consum', 0.0212, 'lps'),
	(397663, 123, '2015-02-15 00:00:53.000000', 'consum', 0.0214, 'lps'),
	(397664, 123, '2015-02-15 00:00:54.000000', 'consum', 0.0213, 'lps'),
	(397665, 123, '2015-02-15 00:00:55.000000', 'consum', 0.0212, 'lps'),
	(397666, 123, '2015-02-15 00:00:56.000000', 'consum', 0.0215, 'lps'),
	(397667, 123, '2015-02-15 00:00:57.000000', 'consum', 0.0216, 'lps'),
	(397668, 123, '2015-02-15 00:00:58.000000', 'consum', 0.0214, 'lps'),
	(397669, 123, '2015-02-15 00:00:59.000000', 'consum', 0.0213, 'lps'),
	(397670, 123, '2015-02-15 00:01:00.000000', 'consum', 0.0215, 'lps'),
	(397671, 123, '2015-02-15 00:01:01.000000', 'consum', 0.0213, 'lps'),
	(397672, 123, '2015-02-15 00:01:02.000000', 'consum', 0.0210, 'lps'),
	(397673, 123, '2015-02-15 00:01:03.000000', 'consum', 0.0213, 'lps'),
	(397674, 123, '2015-02-15 00:01:04.000000', 'consum', 0.0215, 'lps'),
	(397675, 123, '2015-02-15 00:01:05.000000', 'consum', 0.0214, 'lps'),
	(397676, 123, '2015-02-15 00:01:06.000000', 'consum', 0.0216, 'lps'),
	(397677, 123, '2015-02-15 00:01:07.000000', 'consum', 0.0217, 'lps'),
	(397678, 123, '2015-02-15 00:01:08.000000', 'consum', 0.0216, 'lps'),
	(397679, 123, '2015-02-15 00:01:09.000000', 'consum', 0.0219, 'lps'),
	(397680, 123, '2015-02-15 00:01:10.000000', 'consum', 0.0218, 'lps'),
	(397681, 123, '2015-02-15 00:01:11.000000', 'consum', 0.0212, 'lps'),
	(397682, 123, '2015-02-15 00:01:12.000000', 'consum', 0.0220, 'lps'),
	(397683, 123, '2015-02-15 00:01:13.000000', 'consum', 0.0219, 'lps'),
	(397684, 123, '2015-02-15 00:01:14.000000', 'consum', 0.0213, 'lps'),
	(397685, 123, '2015-02-15 00:01:15.000000', 'consum', 0.0213, 'lps'),
	(397686, 123, '2015-02-15 00:01:16.000000', 'consum', 0.0216, 'lps'),
	(397687, 123, '2015-02-15 00:01:17.000000', 'consum', 0.0220, 'lps'),
	(397688, 123, '2015-02-15 00:01:18.000000', 'consum', 0.0211, 'lps'),
	(397689, 123, '2015-02-15 00:01:19.000000', 'consum', 0.0219, 'lps'),
	(397690, 123, '2015-02-15 00:01:20.000000', 'consum', 0.0219, 'lps'),
	(397691, 123, '2015-02-15 00:01:21.000000', 'consum', 0.0218, 'lps'),
	(397692, 123, '2015-02-15 00:01:22.000000', 'consum', 0.0213, 'lps'),
	(397693, 123, '2015-02-15 00:01:23.000000', 'consum', 0.0213, 'lps'),
	(397694, 123, '2015-02-15 00:01:24.000000', 'consum', 0.0216, 'lps'),
	(397695, 123, '2015-02-15 00:01:25.000000', 'consum', 0.0220, 'lps'),
	(397696, 123, '2015-02-15 00:01:26.000000', 'consum', 0.0210, 'lps'),
	(397697, 123, '2015-02-15 00:01:27.000000', 'consum', 0.0215, 'lps'),
	(397698, 123, '2015-02-15 00:01:28.000000', 'consum', 0.0210, 'lps'),
	(397699, 123, '2015-02-15 00:01:29.000000', 'consum', 0.0220, 'lps'),
	(397700, 123, '2015-02-15 00:01:30.000000', 'consum', 0.0215, 'lps'),
	(397701, 123, '2015-02-15 00:01:31.000000', 'consum', 0.0218, 'lps'),
	(397702, 123, '2015-02-15 00:01:32.000000', 'consum', 0.0211, 'lps'),
	(397703, 123, '2015-02-15 00:01:33.000000', 'consum', 0.0214, 'lps'),
	(397704, 123, '2015-02-15 00:01:34.000000', 'consum', 0.0218, 'lps'),
	(397705, 123, '2015-02-15 00:01:35.000000', 'consum', 0.0218, 'lps'),
	(397706, 123, '2015-02-15 00:01:36.000000', 'consum', 0.0213, 'lps'),
	(397707, 123, '2015-02-15 00:01:37.000000', 'consum', 0.0211, 'lps'),
	(397708, 123, '2015-02-15 00:01:38.000000', 'consum', 0.0220, 'lps'),
	(397709, 123, '2015-02-15 00:01:39.000000', 'consum', 0.0214, 'lps'),
	(397710, 123, '2015-02-15 00:01:40.000000', 'consum', 0.0212, 'lps'),
	(397711, 123, '2015-02-15 00:01:41.000000', 'consum', 0.0218, 'lps'),
	(397712, 123, '2015-02-15 00:01:42.000000', 'consum', 0.0214, 'lps'),
	(397713, 123, '2015-02-15 00:01:43.000000', 'consum', 0.0214, 'lps'),
	(397714, 123, '2015-02-15 00:01:44.000000', 'consum', 0.0220, 'lps'),
	(397715, 123, '2015-02-15 00:01:45.000000', 'consum', 0.0217, 'lps'),
	(397716, 123, '2015-02-15 00:01:46.000000', 'consum', 0.0216, 'lps'),
	(397717, 123, '2015-02-15 00:01:47.000000', 'consum', 0.0220, 'lps'),
	(397718, 123, '2015-02-15 00:01:48.000000', 'consum', 0.0219, 'lps'),
	(397719, 123, '2015-02-15 00:01:49.000000', 'consum', 0.0215, 'lps'),
	(397720, 123, '2015-02-15 00:01:50.000000', 'consum', 0.0210, 'lps'),
	(397721, 123, '2015-02-15 00:01:51.000000', 'consum', 0.0216, 'lps'),
	(397722, 123, '2015-02-15 00:01:52.000000', 'consum', 0.0218, 'lps'),
	(397723, 123, '2015-02-15 00:01:53.000000', 'consum', 0.0210, 'lps'),
	(397724, 123, '2015-02-15 00:01:54.000000', 'consum', 0.0211, 'lps'),
	(397725, 123, '2015-02-15 00:01:55.000000', 'consum', 0.0213, 'lps'),
	(397726, 123, '2015-02-15 00:01:56.000000', 'consum', 0.0212, 'lps'),
	(397727, 123, '2015-02-15 00:01:57.000000', 'consum', 0.0211, 'lps'),
	(397728, 123, '2015-02-15 00:01:58.000000', 'consum', 0.0212, 'lps'),
	(397729, 123, '2015-02-15 00:01:59.000000', 'consum', 0.0214, 'lps'),
	(397730, 123, '2015-02-15 00:02:00.000000', 'consum', 0.0216, 'lps'),
	(397731, 123, '2015-02-15 00:02:01.000000', 'consum', 0.0218, 'lps'),
	(397732, 123, '2015-02-15 00:02:02.000000', 'consum', 0.0210, 'lps'),
	(397733, 123, '2015-02-15 00:02:03.000000', 'consum', 0.0218, 'lps'),
	(397734, 123, '2015-02-15 00:02:04.000000', 'consum', 0.0216, 'lps'),
	(397735, 123, '2015-02-15 00:02:05.000000', 'consum', 0.0220, 'lps'),
	(397736, 123, '2015-02-15 00:02:06.000000', 'consum', 0.0220, 'lps'),
	(397737, 123, '2015-02-15 00:02:07.000000', 'consum', 0.0218, 'lps'),
	(397738, 123, '2015-02-15 00:02:08.000000', 'consum', 0.0220, 'lps'),
	(397739, 123, '2015-02-15 00:02:09.000000', 'consum', 0.0216, 'lps'),
	(397740, 123, '2015-02-15 00:02:10.000000', 'consum', 0.0220, 'lps'),
	(397741, 123, '2015-02-15 00:02:11.000000', 'consum', 0.0210, 'lps'),
	(397742, 123, '2015-02-15 00:02:12.000000', 'consum', 0.0215, 'lps'),
	(397743, 123, '2015-02-15 00:02:13.000000', 'consum', 0.0214, 'lps'),
	(397744, 123, '2015-02-15 00:02:14.000000', 'consum', 0.0216, 'lps'),
	(397745, 123, '2015-02-15 00:02:15.000000', 'consum', 0.0218, 'lps'),
	(397746, 123, '2015-02-15 00:02:16.000000', 'consum', 0.0211, 'lps'),
	(397747, 123, '2015-02-15 00:02:17.000000', 'consum', 0.0212, 'lps'),
	(397748, 123, '2015-02-15 00:02:18.000000', 'consum', 0.0219, 'lps'),
	(397749, 123, '2015-02-15 00:02:19.000000', 'consum', 0.0215, 'lps'),
	(397750, 123, '2015-02-15 00:02:20.000000', 'consum', 0.0219, 'lps'),
	(397751, 123, '2015-02-15 00:02:21.000000', 'consum', 0.0210, 'lps'),
	(397752, 123, '2015-02-15 00:02:22.000000', 'consum', 0.0216, 'lps'),
	(397753, 123, '2015-02-15 00:02:23.000000', 'consum', 0.0218, 'lps'),
	(397754, 123, '2015-02-15 00:02:24.000000', 'consum', 0.0211, 'lps'),
	(397755, 123, '2015-02-15 00:02:25.000000', 'consum', 0.0213, 'lps'),
	(397756, 123, '2015-02-15 00:02:26.000000', 'consum', 0.0213, 'lps'),
	(397757, 123, '2015-02-15 00:02:27.000000', 'consum', 0.0215, 'lps'),
	(397758, 123, '2015-02-15 00:02:28.000000', 'consum', 0.0214, 'lps'),
	(397759, 123, '2015-02-15 00:02:29.000000', 'consum', 0.0216, 'lps'),
	(397760, 123, '2015-02-15 00:02:30.000000', 'consum', 0.0217, 'lps'),
	(397761, 123, '2015-02-15 00:02:31.000000', 'consum', 0.0215, 'lps'),
	(397762, 123, '2015-02-15 00:02:32.000000', 'consum', 0.0218, 'lps'),
	(397763, 123, '2015-02-15 00:02:33.000000', 'consum', 0.0212, 'lps'),
	(397764, 123, '2015-02-15 00:02:34.000000', 'consum', 0.0219, 'lps'),
	(397765, 123, '2015-02-15 00:02:35.000000', 'consum', 0.0215, 'lps'),
	(397766, 123, '2015-02-15 00:02:36.000000', 'consum', 0.0211, 'lps'),
	(397767, 123, '2015-02-15 00:02:37.000000', 'consum', 0.0220, 'lps'),
	(397768, 123, '2015-02-15 00:02:38.000000', 'consum', 0.0213, 'lps'),
	(397769, 123, '2015-02-15 00:02:39.000000', 'consum', 0.0219, 'lps'),
	(397770, 123, '2015-02-15 00:02:40.000000', 'consum', 0.0211, 'lps'),
	(397771, 123, '2015-02-15 00:02:41.000000', 'consum', 0.0213, 'lps'),
	(397772, 123, '2015-02-15 00:02:42.000000', 'consum', 0.0210, 'lps'),
	(397773, 123, '2015-02-15 00:02:43.000000', 'consum', 0.0211, 'lps'),
	(397774, 123, '2015-02-15 00:02:44.000000', 'consum', 0.0218, 'lps'),
	(397775, 123, '2015-02-15 00:02:45.000000', 'consum', 0.0212, 'lps'),
	(397776, 123, '2015-02-15 00:02:46.000000', 'consum', 0.0220, 'lps'),
	(397777, 123, '2015-02-15 00:02:47.000000', 'consum', 0.0212, 'lps'),
	(397778, 123, '2015-02-15 00:02:48.000000', 'consum', 0.0213, 'lps'),
	(397779, 123, '2015-02-15 00:02:49.000000', 'consum', 0.0220, 'lps'),
	(397780, 123, '2015-02-15 00:02:50.000000', 'consum', 0.0216, 'lps'),
	(397781, 123, '2015-02-15 00:02:51.000000', 'consum', 0.0210, 'lps'),
	(397782, 123, '2015-02-15 00:02:52.000000', 'consum', 0.0214, 'lps'),
	(397783, 123, '2015-02-15 00:02:53.000000', 'consum', 0.0220, 'lps'),
	(397784, 123, '2015-02-15 00:02:54.000000', 'consum', 0.0215, 'lps'),
	(397785, 123, '2015-02-15 00:02:55.000000', 'consum', 0.0216, 'lps'),
	(397786, 123, '2015-02-15 00:02:56.000000', 'consum', 0.0217, 'lps'),
	(397787, 123, '2015-02-15 00:02:57.000000', 'consum', 0.0215, 'lps'),
	(397788, 123, '2015-02-15 00:02:58.000000', 'consum', 0.0215, 'lps'),
	(397789, 123, '2015-02-15 00:02:59.000000', 'consum', 0.0219, 'lps'),
	(397790, 123, '2015-02-15 00:03:00.000000', 'consum', 0.0210, 'lps'),
	(397791, 123, '2015-02-15 00:03:01.000000', 'consum', 0.0216, 'lps'),
	(397792, 123, '2015-02-15 00:03:02.000000', 'consum', 0.0220, 'lps'),
	(397793, 123, '2015-02-15 00:03:03.000000', 'consum', 0.0219, 'lps'),
	(397794, 123, '2015-02-15 00:03:04.000000', 'consum', 0.0215, 'lps'),
	(397795, 123, '2015-02-15 00:03:05.000000', 'consum', 0.0220, 'lps'),
	(397796, 123, '2015-02-15 00:03:06.000000', 'consum', 0.0211, 'lps'),
	(397797, 123, '2015-02-15 00:03:07.000000', 'consum', 0.0217, 'lps'),
	(397798, 123, '2015-02-15 00:03:08.000000', 'consum', 0.0211, 'lps'),
	(397799, 123, '2015-02-15 00:03:09.000000', 'consum', 0.0218, 'lps'),
	(397800, 123, '2015-02-15 00:03:10.000000', 'consum', 0.0215, 'lps'),
	(397801, 123, '2015-02-15 00:03:11.000000', 'consum', 0.0220, 'lps'),
	(397802, 123, '2015-02-15 00:03:12.000000', 'consum', 0.0213, 'lps'),
	(397803, 123, '2015-02-15 00:03:13.000000', 'consum', 0.0217, 'lps'),
	(397804, 123, '2015-02-15 00:03:14.000000', 'consum', 0.0214, 'lps'),
	(397805, 123, '2015-02-15 00:03:15.000000', 'consum', 0.0211, 'lps'),
	(397806, 123, '2015-02-15 00:03:16.000000', 'consum', 0.0212, 'lps'),
	(397807, 123, '2015-02-15 00:03:17.000000', 'consum', 0.0210, 'lps'),
	(397808, 123, '2015-02-15 00:03:18.000000', 'consum', 0.0213, 'lps'),
	(397809, 123, '2015-02-15 00:03:19.000000', 'consum', 0.0216, 'lps'),
	(397810, 123, '2015-02-15 00:03:20.000000', 'consum', 0.0218, 'lps'),
	(397811, 123, '2015-02-15 00:03:21.000000', 'consum', 0.0213, 'lps'),
	(397812, 123, '2015-02-15 00:03:22.000000', 'consum', 0.0211, 'lps'),
	(397813, 123, '2015-02-15 00:03:23.000000', 'consum', 0.0216, 'lps'),
	(397814, 123, '2015-02-15 00:03:24.000000', 'consum', 0.0219, 'lps'),
	(397815, 123, '2015-02-15 00:03:25.000000', 'consum', 0.0214, 'lps'),
	(397816, 123, '2015-02-15 00:03:26.000000', 'consum', 0.0213, 'lps'),
	(397817, 123, '2015-02-15 00:03:27.000000', 'consum', 0.0215, 'lps'),
	(397818, 123, '2015-02-15 00:03:28.000000', 'consum', 0.0216, 'lps'),
	(397819, 123, '2015-02-15 00:03:29.000000', 'consum', 0.0214, 'lps'),
	(397820, 123, '2015-02-15 00:03:30.000000', 'consum', 0.0213, 'lps'),
	(397821, 123, '2015-02-15 00:03:31.000000', 'consum', 0.0211, 'lps'),
	(397822, 123, '2015-02-15 00:03:32.000000', 'consum', 0.0210, 'lps'),
	(397823, 123, '2015-02-15 00:03:33.000000', 'consum', 0.0215, 'lps'),
	(397824, 123, '2015-02-15 00:03:34.000000', 'consum', 0.0216, 'lps'),
	(397825, 123, '2015-02-15 00:03:35.000000', 'consum', 0.0212, 'lps'),
	(397826, 123, '2015-02-15 00:03:36.000000', 'consum', 0.0215, 'lps'),
	(397827, 123, '2015-02-15 00:03:37.000000', 'consum', 0.0220, 'lps'),
	(397828, 123, '2015-02-15 00:03:38.000000', 'consum', 0.0220, 'lps'),
	(397829, 123, '2015-02-15 00:03:39.000000', 'consum', 0.0211, 'lps'),
	(397830, 123, '2015-02-15 00:03:40.000000', 'consum', 0.0217, 'lps'),
	(397831, 123, '2015-02-15 00:03:41.000000', 'consum', 0.0212, 'lps'),
	(397832, 123, '2015-02-15 00:03:42.000000', 'consum', 0.0210, 'lps'),
	(397833, 123, '2015-02-15 00:03:43.000000', 'consum', 0.0216, 'lps'),
	(397834, 123, '2015-02-15 00:03:44.000000', 'consum', 0.0219, 'lps'),
	(397835, 123, '2015-02-15 00:03:45.000000', 'consum', 0.0216, 'lps'),
	(397836, 123, '2015-02-15 00:03:46.000000', 'consum', 0.0215, 'lps'),
	(397837, 123, '2015-02-15 00:03:47.000000', 'consum', 0.0214, 'lps'),
	(397838, 123, '2015-02-15 00:03:48.000000', 'consum', 0.0217, 'lps'),
	(397839, 123, '2015-02-15 00:03:49.000000', 'consum', 0.0211, 'lps'),
	(397840, 123, '2015-02-15 00:03:50.000000', 'consum', 0.0219, 'lps'),
	(397841, 123, '2015-02-15 00:03:51.000000', 'consum', 0.0216, 'lps'),
	(397842, 123, '2015-02-15 00:03:52.000000', 'consum', 0.0215, 'lps'),
	(397843, 123, '2015-02-15 00:03:53.000000', 'consum', 0.0218, 'lps'),
	(397844, 123, '2015-02-15 00:03:54.000000', 'consum', 0.0214, 'lps'),
	(397845, 123, '2015-02-15 00:03:55.000000', 'consum', 0.0218, 'lps'),
	(397846, 123, '2015-02-15 00:03:56.000000', 'consum', 0.0215, 'lps'),
	(397847, 123, '2015-02-15 00:03:57.000000', 'consum', 0.0211, 'lps'),
	(397848, 123, '2015-02-15 00:03:58.000000', 'consum', 0.0213, 'lps'),
	(397849, 123, '2015-02-15 00:03:59.000000', 'consum', 0.0211, 'lps'),
	(397850, 123, '2015-02-15 00:04:00.000000', 'consum', 0.0219, 'lps'),
	(397851, 123, '2015-02-15 00:04:01.000000', 'consum', 0.0219, 'lps'),
	(397852, 123, '2015-02-15 00:04:02.000000', 'consum', 0.0218, 'lps'),
	(397853, 123, '2015-02-15 00:04:03.000000', 'consum', 0.0213, 'lps'),
	(397854, 123, '2015-02-15 00:04:04.000000', 'consum', 0.0214, 'lps'),
	(397855, 123, '2015-02-15 00:04:05.000000', 'consum', 0.0218, 'lps'),
	(397856, 123, '2015-02-15 00:04:06.000000', 'consum', 0.0218, 'lps'),
	(397857, 123, '2015-02-15 00:04:07.000000', 'consum', 0.0216, 'lps'),
	(397858, 123, '2015-02-15 00:04:08.000000', 'consum', 0.0218, 'lps'),
	(397859, 123, '2015-02-15 00:04:09.000000', 'consum', 0.0210, 'lps'),
	(397860, 123, '2015-02-15 00:04:10.000000', 'consum', 0.0219, 'lps'),
	(397861, 123, '2015-02-15 00:04:11.000000', 'consum', 0.0210, 'lps'),
	(397862, 123, '2015-02-15 00:04:12.000000', 'consum', 0.0217, 'lps'),
	(397863, 123, '2015-02-15 00:04:13.000000', 'consum', 0.0211, 'lps'),
	(397864, 123, '2015-02-15 00:04:14.000000', 'consum', 0.0219, 'lps'),
	(397865, 123, '2015-02-15 00:04:15.000000', 'consum', 0.0210, 'lps'),
	(397866, 123, '2015-02-15 00:04:16.000000', 'consum', 0.0213, 'lps'),
	(397867, 123, '2015-02-15 00:04:17.000000', 'consum', 0.0217, 'lps'),
	(397868, 123, '2015-02-15 00:04:18.000000', 'consum', 0.0215, 'lps'),
	(397869, 123, '2015-02-15 00:04:19.000000', 'consum', 0.0215, 'lps'),
	(397870, 123, '2015-02-15 00:04:20.000000', 'consum', 0.0219, 'lps'),
	(397871, 123, '2015-02-15 00:04:21.000000', 'consum', 0.0218, 'lps'),
	(397872, 123, '2015-02-15 00:04:22.000000', 'consum', 0.0214, 'lps'),
	(397873, 123, '2015-02-15 00:04:23.000000', 'consum', 0.0217, 'lps'),
	(397874, 123, '2015-02-15 00:04:24.000000', 'consum', 0.0211, 'lps'),
	(397875, 123, '2015-02-15 00:04:25.000000', 'consum', 0.0215, 'lps'),
	(397876, 123, '2015-02-15 00:04:26.000000', 'consum', 0.0213, 'lps'),
	(397877, 123, '2015-02-15 00:04:27.000000', 'consum', 0.0219, 'lps'),
	(397878, 123, '2015-02-15 00:04:28.000000', 'consum', 0.0216, 'lps'),
	(397879, 123, '2015-02-15 00:04:29.000000', 'consum', 0.0213, 'lps'),
	(397880, 123, '2015-02-15 00:04:30.000000', 'consum', 0.0219, 'lps'),
	(397881, 123, '2015-02-15 00:04:31.000000', 'consum', 0.0214, 'lps'),
	(397882, 123, '2015-02-15 00:04:32.000000', 'consum', 0.0215, 'lps'),
	(397883, 123, '2015-02-15 00:04:33.000000', 'consum', 0.0214, 'lps'),
	(397884, 123, '2015-02-15 00:04:34.000000', 'consum', 0.0212, 'lps'),
	(397885, 123, '2015-02-15 00:04:35.000000', 'consum', 0.0210, 'lps'),
	(397886, 123, '2015-02-15 00:04:36.000000', 'consum', 0.0216, 'lps'),
	(397887, 123, '2015-02-15 00:04:37.000000', 'consum', 0.0219, 'lps'),
	(397888, 123, '2015-02-15 00:04:38.000000', 'consum', 0.0216, 'lps'),
	(397889, 123, '2015-02-15 00:04:39.000000', 'consum', 0.0214, 'lps'),
	(397890, 123, '2015-02-15 00:04:40.000000', 'consum', 0.0210, 'lps'),
	(397891, 123, '2015-02-15 00:04:41.000000', 'consum', 0.0210, 'lps'),
	(397892, 123, '2015-02-15 00:04:42.000000', 'consum', 0.0212, 'lps'),
	(397893, 123, '2015-02-15 00:04:43.000000', 'consum', 0.0220, 'lps'),
	(397894, 123, '2015-02-15 00:04:44.000000', 'consum', 0.0211, 'lps'),
	(397895, 123, '2015-02-15 00:04:45.000000', 'consum', 0.0217, 'lps'),
	(397896, 123, '2015-02-15 00:04:46.000000', 'consum', 0.0220, 'lps'),
	(397897, 123, '2015-02-15 00:04:47.000000', 'consum', 0.0217, 'lps'),
	(397898, 123, '2015-02-15 00:04:48.000000', 'consum', 0.0216, 'lps'),
	(397899, 123, '2015-02-15 00:04:49.000000', 'consum', 0.0220, 'lps'),
	(397900, 123, '2015-02-15 00:04:50.000000', 'consum', 0.0220, 'lps'),
	(397901, 123, '2015-02-15 00:04:51.000000', 'consum', 0.0219, 'lps'),
	(397902, 123, '2015-02-15 00:04:52.000000', 'consum', 0.0217, 'lps'),
	(397903, 123, '2015-02-15 00:04:53.000000', 'consum', 0.0218, 'lps'),
	(397904, 123, '2015-02-15 00:04:54.000000', 'consum', 0.0216, 'lps'),
	(397905, 123, '2015-02-15 00:04:55.000000', 'consum', 0.0219, 'lps'),
	(397906, 123, '2015-02-15 00:04:56.000000', 'consum', 0.0217, 'lps'),
	(397907, 123, '2015-02-15 00:04:57.000000', 'consum', 0.0215, 'lps'),
	(397908, 123, '2015-02-15 00:04:58.000000', 'consum', 0.0215, 'lps'),
	(397909, 123, '2015-02-15 00:04:59.000000', 'consum', 0.0220, 'lps'),
	(397910, 123, '2015-02-15 00:05:00.000000', 'consum', 0.0215, 'lps'),
	(397911, 123, '2015-02-15 00:05:01.000000', 'consum', 0.0214, 'lps'),
	(397912, 123, '2015-02-15 00:05:02.000000', 'consum', 0.0215, 'lps'),
	(397913, 123, '2015-02-15 00:05:03.000000', 'consum', 0.0213, 'lps'),
	(397914, 123, '2015-02-15 00:05:04.000000', 'consum', 0.0213, 'lps'),
	(397915, 123, '2015-02-15 00:05:05.000000', 'consum', 0.0214, 'lps'),
	(397916, 123, '2015-02-15 00:05:06.000000', 'consum', 0.0210, 'lps'),
	(397917, 123, '2015-02-15 00:05:07.000000', 'consum', 0.0211, 'lps'),
	(397918, 123, '2015-02-15 00:05:08.000000', 'consum', 0.0214, 'lps'),
	(397919, 123, '2015-02-15 00:05:09.000000', 'consum', 0.0215, 'lps'),
	(397920, 123, '2015-02-15 00:05:10.000000', 'consum', 0.0215, 'lps'),
	(397921, 123, '2015-02-15 00:05:11.000000', 'consum', 0.0210, 'lps'),
	(397922, 123, '2015-02-15 00:05:12.000000', 'consum', 0.0219, 'lps'),
	(397923, 123, '2015-02-15 00:05:13.000000', 'consum', 0.0220, 'lps'),
	(397924, 123, '2015-02-15 00:05:14.000000', 'consum', 0.0210, 'lps'),
	(397925, 123, '2015-02-15 00:05:15.000000', 'consum', 0.0217, 'lps'),
	(397926, 123, '2015-02-15 00:05:16.000000', 'consum', 0.0210, 'lps'),
	(397927, 123, '2015-02-15 00:05:17.000000', 'consum', 0.0213, 'lps'),
	(397928, 123, '2015-02-15 00:05:18.000000', 'consum', 0.0216, 'lps'),
	(397929, 123, '2015-02-15 00:05:19.000000', 'consum', 0.0219, 'lps'),
	(397930, 123, '2015-02-15 00:05:20.000000', 'consum', 0.0216, 'lps'),
	(397931, 123, '2015-02-15 00:05:21.000000', 'consum', 0.0211, 'lps'),
	(397932, 123, '2015-02-15 00:05:22.000000', 'consum', 0.0211, 'lps'),
	(397933, 123, '2015-02-15 00:05:23.000000', 'consum', 0.0211, 'lps'),
	(397934, 123, '2015-02-15 00:05:24.000000', 'consum', 0.0213, 'lps'),
	(397935, 123, '2015-02-15 00:05:25.000000', 'consum', 0.0211, 'lps'),
	(397936, 123, '2015-02-15 00:05:26.000000', 'consum', 0.0216, 'lps'),
	(397937, 123, '2015-02-15 00:05:27.000000', 'consum', 0.0217, 'lps'),
	(397938, 123, '2015-02-15 00:05:28.000000', 'consum', 0.0216, 'lps'),
	(397939, 123, '2015-02-15 00:05:29.000000', 'consum', 0.0219, 'lps'),
	(397940, 123, '2015-02-15 00:05:30.000000', 'consum', 0.0216, 'lps'),
	(397941, 123, '2015-02-15 00:05:31.000000', 'consum', 0.0215, 'lps'),
	(397942, 123, '2015-02-15 00:05:32.000000', 'consum', 0.0216, 'lps'),
	(397943, 123, '2015-02-15 00:05:33.000000', 'consum', 0.0217, 'lps'),
	(397944, 123, '2015-02-15 00:05:34.000000', 'consum', 0.0215, 'lps'),
	(397945, 123, '2015-02-15 00:05:35.000000', 'consum', 0.0212, 'lps'),
	(397946, 123, '2015-02-15 00:05:36.000000', 'consum', 0.0220, 'lps'),
	(397947, 123, '2015-02-15 00:05:37.000000', 'consum', 0.0220, 'lps'),
	(397948, 123, '2015-02-15 00:05:38.000000', 'consum', 0.0210, 'lps'),
	(397949, 123, '2015-02-15 00:05:39.000000', 'consum', 0.0211, 'lps'),
	(397950, 123, '2015-02-15 00:05:40.000000', 'consum', 0.0218, 'lps'),
	(397951, 123, '2015-02-15 00:05:41.000000', 'consum', 0.0213, 'lps'),
	(397952, 123, '2015-02-15 00:05:42.000000', 'consum', 0.0211, 'lps'),
	(397953, 123, '2015-02-15 00:05:43.000000', 'consum', 0.0218, 'lps'),
	(397954, 123, '2015-02-15 00:05:44.000000', 'consum', 0.0214, 'lps'),
	(397955, 123, '2015-02-15 00:05:45.000000', 'consum', 0.0216, 'lps'),
	(397956, 123, '2015-02-15 00:05:46.000000', 'consum', 0.0220, 'lps'),
	(397957, 123, '2015-02-15 00:05:47.000000', 'consum', 0.0210, 'lps'),
	(397958, 123, '2015-02-15 00:05:48.000000', 'consum', 0.0213, 'lps'),
	(397959, 123, '2015-02-15 00:05:49.000000', 'consum', 0.0213, 'lps'),
	(397960, 123, '2015-02-15 00:05:50.000000', 'consum', 0.0215, 'lps'),
	(397961, 123, '2015-02-15 00:05:51.000000', 'consum', 0.0219, 'lps'),
	(397962, 123, '2015-02-15 00:05:52.000000', 'consum', 0.0219, 'lps'),
	(397963, 123, '2015-02-15 00:05:53.000000', 'consum', 0.0214, 'lps'),
	(397964, 123, '2015-02-15 00:05:54.000000', 'consum', 0.0218, 'lps'),
	(397965, 123, '2015-02-15 00:05:55.000000', 'consum', 0.0215, 'lps'),
	(397966, 123, '2015-02-15 00:05:56.000000', 'consum', 0.0213, 'lps'),
	(397967, 123, '2015-02-15 00:05:57.000000', 'consum', 0.0219, 'lps'),
	(397968, 123, '2015-02-15 00:05:58.000000', 'consum', 0.0217, 'lps'),
	(397969, 123, '2015-02-15 00:05:59.000000', 'consum', 0.0216, 'lps'),
	(397970, 123, '2015-02-15 00:06:00.000000', 'consum', 0.0218, 'lps'),
	(397971, 123, '2015-02-15 00:06:01.000000', 'consum', 0.0212, 'lps'),
	(397972, 123, '2015-02-15 00:06:02.000000', 'consum', 0.0217, 'lps'),
	(397973, 123, '2015-02-15 00:06:03.000000', 'consum', 0.0217, 'lps'),
	(397974, 123, '2015-02-15 00:06:04.000000', 'consum', 0.0216, 'lps'),
	(397975, 123, '2015-02-15 00:06:05.000000', 'consum', 0.0220, 'lps'),
	(397976, 123, '2015-02-15 00:06:06.000000', 'consum', 0.0218, 'lps'),
	(397977, 123, '2015-02-15 00:06:07.000000', 'consum', 0.0220, 'lps'),
	(397978, 123, '2015-02-15 00:06:08.000000', 'consum', 0.0214, 'lps'),
	(397979, 123, '2015-02-15 00:06:09.000000', 'consum', 0.0212, 'lps'),
	(397980, 123, '2015-02-15 00:06:10.000000', 'consum', 0.0210, 'lps'),
	(397981, 123, '2015-02-15 00:06:11.000000', 'consum', 0.0216, 'lps'),
	(397982, 123, '2015-02-15 00:06:12.000000', 'consum', 0.0218, 'lps'),
	(397983, 123, '2015-02-15 00:06:13.000000', 'consum', 0.0211, 'lps'),
	(397984, 123, '2015-02-15 00:06:14.000000', 'consum', 0.0212, 'lps'),
	(397985, 123, '2015-02-15 00:06:15.000000', 'consum', 0.0219, 'lps'),
	(397986, 123, '2015-02-15 00:06:16.000000', 'consum', 0.0218, 'lps'),
	(397987, 123, '2015-02-15 00:06:17.000000', 'consum', 0.0211, 'lps'),
	(397988, 123, '2015-02-15 00:06:18.000000', 'consum', 0.0215, 'lps'),
	(397989, 123, '2015-02-15 00:06:19.000000', 'consum', 0.0219, 'lps'),
	(397990, 123, '2015-02-15 00:06:20.000000', 'consum', 0.0219, 'lps'),
	(397991, 123, '2015-02-15 00:06:21.000000', 'consum', 0.0220, 'lps'),
	(397992, 123, '2015-02-15 00:06:22.000000', 'consum', 0.0210, 'lps'),
	(397993, 123, '2015-02-15 00:06:23.000000', 'consum', 0.0212, 'lps'),
	(397994, 123, '2015-02-15 00:06:24.000000', 'consum', 0.0210, 'lps'),
	(397995, 123, '2015-02-15 00:06:25.000000', 'consum', 0.0217, 'lps'),
	(397996, 123, '2015-02-15 00:06:26.000000', 'consum', 0.0211, 'lps'),
	(397997, 123, '2015-02-15 00:06:27.000000', 'consum', 0.0217, 'lps'),
	(397998, 123, '2015-02-15 00:06:28.000000', 'consum', 0.0219, 'lps'),
	(397999, 123, '2015-02-15 00:06:29.000000', 'consum', 0.0213, 'lps'),
	(398000, 123, '2015-02-15 00:06:30.000000', 'consum', 0.0212, 'lps'),
	(398001, 123, '2015-02-15 00:06:31.000000', 'consum', 0.0210, 'lps'),
	(398002, 123, '2015-02-15 00:06:32.000000', 'consum', 0.0216, 'lps'),
	(398003, 123, '2015-02-15 00:06:33.000000', 'consum', 0.0218, 'lps'),
	(398004, 123, '2015-02-15 00:06:34.000000', 'consum', 0.0211, 'lps'),
	(398005, 123, '2015-02-15 00:06:35.000000', 'consum', 0.0215, 'lps'),
	(398006, 123, '2015-02-15 00:06:36.000000', 'consum', 0.0219, 'lps'),
	(398007, 123, '2015-02-15 00:06:37.000000', 'consum', 0.0218, 'lps'),
	(398008, 123, '2015-02-15 00:06:38.000000', 'consum', 0.0212, 'lps'),
	(398009, 123, '2015-02-15 00:06:39.000000', 'consum', 0.0219, 'lps'),
	(398010, 123, '2015-02-15 00:06:40.000000', 'consum', 0.0216, 'lps'),
	(398011, 123, '2015-02-15 00:06:41.000000', 'consum', 0.0216, 'lps'),
	(398012, 123, '2015-02-15 00:06:42.000000', 'consum', 0.0211, 'lps'),
	(398013, 123, '2015-02-15 00:06:43.000000', 'consum', 0.0218, 'lps'),
	(398014, 123, '2015-02-15 00:06:44.000000', 'consum', 0.0213, 'lps'),
	(398015, 123, '2015-02-15 00:06:45.000000', 'consum', 0.0215, 'lps'),
	(398016, 123, '2015-02-15 00:06:46.000000', 'consum', 0.0215, 'lps'),
	(398017, 123, '2015-02-15 00:06:47.000000', 'consum', 0.0220, 'lps'),
	(398018, 123, '2015-02-15 00:06:48.000000', 'consum', 0.0214, 'lps'),
	(398019, 123, '2015-02-15 00:06:49.000000', 'consum', 0.0210, 'lps'),
	(398020, 123, '2015-02-15 00:06:50.000000', 'consum', 0.0210, 'lps'),
	(398021, 123, '2015-02-15 00:06:51.000000', 'consum', 0.0210, 'lps'),
	(398022, 123, '2015-02-15 00:06:52.000000', 'consum', 0.0220, 'lps'),
	(398023, 123, '2015-02-15 00:06:53.000000', 'consum', 0.0219, 'lps'),
	(398024, 123, '2015-02-15 00:06:54.000000', 'consum', 0.0214, 'lps'),
	(398025, 123, '2015-02-15 00:06:55.000000', 'consum', 0.0216, 'lps'),
	(398026, 123, '2015-02-15 00:06:56.000000', 'consum', 0.0216, 'lps'),
	(398027, 123, '2015-02-15 00:06:57.000000', 'consum', 0.0212, 'lps'),
	(398028, 123, '2015-02-15 00:06:58.000000', 'consum', 0.0215, 'lps'),
	(398029, 123, '2015-02-15 00:06:59.000000', 'consum', 0.0216, 'lps'),
	(398030, 123, '2015-02-15 00:07:00.000000', 'consum', 0.0213, 'lps'),
	(398031, 123, '2015-02-15 00:07:01.000000', 'consum', 0.0211, 'lps'),
	(398032, 123, '2015-02-15 00:07:02.000000', 'consum', 0.0217, 'lps'),
	(398033, 123, '2015-02-15 00:07:03.000000', 'consum', 0.0210, 'lps'),
	(398034, 123, '2015-02-15 00:07:04.000000', 'consum', 0.0210, 'lps'),
	(398035, 123, '2015-02-15 00:07:05.000000', 'consum', 0.0212, 'lps'),
	(398036, 123, '2015-02-15 00:07:06.000000', 'consum', 0.0220, 'lps'),
	(398037, 123, '2015-02-15 00:07:07.000000', 'consum', 0.0220, 'lps'),
	(398038, 123, '2015-02-15 00:07:08.000000', 'consum', 0.0219, 'lps'),
	(398039, 123, '2015-02-15 00:07:09.000000', 'consum', 0.0214, 'lps'),
	(398040, 123, '2015-02-15 00:07:10.000000', 'consum', 0.0214, 'lps'),
	(398041, 123, '2015-02-15 00:07:11.000000', 'consum', 0.0210, 'lps'),
	(398042, 123, '2015-02-15 00:07:12.000000', 'consum', 0.0220, 'lps'),
	(398043, 123, '2015-02-15 00:07:13.000000', 'consum', 0.0217, 'lps'),
	(398044, 123, '2015-02-15 00:07:14.000000', 'consum', 0.0215, 'lps'),
	(398045, 123, '2015-02-15 00:07:15.000000', 'consum', 0.0213, 'lps'),
	(398046, 123, '2015-02-15 00:07:16.000000', 'consum', 0.0210, 'lps'),
	(398047, 123, '2015-02-15 00:07:17.000000', 'consum', 0.0216, 'lps'),
	(398048, 123, '2015-02-15 00:07:18.000000', 'consum', 0.0215, 'lps'),
	(398049, 123, '2015-02-15 00:07:19.000000', 'consum', 0.0220, 'lps'),
	(398050, 123, '2015-02-15 00:07:20.000000', 'consum', 0.0212, 'lps'),
	(398051, 123, '2015-02-15 00:07:21.000000', 'consum', 0.0213, 'lps'),
	(398052, 123, '2015-02-15 00:07:22.000000', 'consum', 0.0210, 'lps'),
	(398053, 123, '2015-02-15 00:07:23.000000', 'consum', 0.0211, 'lps'),
	(398054, 123, '2015-02-15 00:07:24.000000', 'consum', 0.0214, 'lps'),
	(398055, 123, '2015-02-15 00:07:25.000000', 'consum', 0.0219, 'lps'),
	(398056, 123, '2015-02-15 00:07:26.000000', 'consum', 0.0210, 'lps'),
	(398057, 123, '2015-02-15 00:07:27.000000', 'consum', 0.0216, 'lps'),
	(398058, 123, '2015-02-15 00:07:28.000000', 'consum', 0.0220, 'lps'),
	(398059, 123, '2015-02-15 00:07:29.000000', 'consum', 0.0218, 'lps'),
	(398060, 123, '2015-02-15 00:07:30.000000', 'consum', 0.0211, 'lps'),
	(398061, 123, '2015-02-15 00:07:31.000000', 'consum', 0.0214, 'lps'),
	(398062, 123, '2015-02-15 00:07:32.000000', 'consum', 0.0217, 'lps'),
	(398063, 123, '2015-02-15 00:07:33.000000', 'consum', 0.0211, 'lps'),
	(398064, 123, '2015-02-15 00:07:34.000000', 'consum', 0.0215, 'lps'),
	(398065, 123, '2015-02-15 00:07:35.000000', 'consum', 0.0213, 'lps'),
	(398066, 123, '2015-02-15 00:07:36.000000', 'consum', 0.0220, 'lps'),
	(398067, 123, '2015-02-15 00:07:37.000000', 'consum', 0.0220, 'lps'),
	(398068, 123, '2015-02-15 00:07:38.000000', 'consum', 0.0220, 'lps'),
	(398069, 123, '2015-02-15 00:07:39.000000', 'consum', 0.0210, 'lps'),
	(398070, 123, '2015-02-15 00:07:40.000000', 'consum', 0.0210, 'lps'),
	(398071, 123, '2015-02-15 00:07:41.000000', 'consum', 0.0211, 'lps'),
	(398072, 123, '2015-02-15 00:07:42.000000', 'consum', 0.0216, 'lps'),
	(398073, 123, '2015-02-15 00:07:43.000000', 'consum', 0.0213, 'lps'),
	(398074, 123, '2015-02-15 00:07:44.000000', 'consum', 0.0211, 'lps'),
	(398075, 123, '2015-02-15 00:07:45.000000', 'consum', 0.0216, 'lps'),
	(398076, 123, '2015-02-15 00:07:46.000000', 'consum', 0.0214, 'lps'),
	(398077, 123, '2015-02-15 00:07:47.000000', 'consum', 0.0215, 'lps'),
	(398078, 123, '2015-02-15 00:07:48.000000', 'consum', 0.0212, 'lps'),
	(398079, 123, '2015-02-15 00:07:49.000000', 'consum', 0.0215, 'lps'),
	(398080, 123, '2015-02-15 00:07:50.000000', 'consum', 0.0219, 'lps'),
	(398081, 123, '2015-02-15 00:07:51.000000', 'consum', 0.0218, 'lps'),
	(398082, 123, '2015-02-15 00:07:52.000000', 'consum', 0.0213, 'lps'),
	(398083, 123, '2015-02-15 00:07:53.000000', 'consum', 0.0213, 'lps'),
	(398084, 123, '2015-02-15 00:07:54.000000', 'consum', 0.0215, 'lps'),
	(398085, 123, '2015-02-15 00:07:55.000000', 'consum', 0.0218, 'lps'),
	(398086, 123, '2015-02-15 00:07:56.000000', 'consum', 0.0211, 'lps'),
	(398087, 123, '2015-02-15 00:07:57.000000', 'consum', 0.0212, 'lps'),
	(398088, 123, '2015-02-15 00:07:58.000000', 'consum', 0.0210, 'lps'),
	(398089, 123, '2015-02-15 00:07:59.000000', 'consum', 0.0214, 'lps'),
	(398090, 123, '2015-02-15 00:08:00.000000', 'consum', 0.0220, 'lps'),
	(398091, 123, '2015-02-15 00:08:01.000000', 'consum', 0.0214, 'lps'),
	(398092, 123, '2015-02-15 00:08:02.000000', 'consum', 0.0212, 'lps'),
	(398093, 123, '2015-02-15 00:08:03.000000', 'consum', 0.0218, 'lps'),
	(398094, 123, '2015-02-15 00:08:04.000000', 'consum', 0.0214, 'lps'),
	(398095, 123, '2015-02-15 00:08:05.000000', 'consum', 0.0215, 'lps'),
	(398096, 123, '2015-02-15 00:08:06.000000', 'consum', 0.0212, 'lps'),
	(398097, 123, '2015-02-15 00:08:07.000000', 'consum', 0.0219, 'lps'),
	(398098, 123, '2015-02-15 00:08:08.000000', 'consum', 0.0216, 'lps'),
	(398099, 123, '2015-02-15 00:08:09.000000', 'consum', 0.0215, 'lps'),
	(398100, 123, '2015-02-15 00:08:10.000000', 'consum', 0.0215, 'lps'),
	(398101, 123, '2015-02-15 00:08:11.000000', 'consum', 0.0220, 'lps'),
	(398102, 123, '2015-02-15 00:08:12.000000', 'consum', 0.0214, 'lps'),
	(398103, 123, '2015-02-15 00:08:13.000000', 'consum', 0.0211, 'lps'),
	(398104, 123, '2015-02-15 00:08:14.000000', 'consum', 0.0215, 'lps'),
	(398105, 123, '2015-02-15 00:08:15.000000', 'consum', 0.0210, 'lps'),
	(398106, 123, '2015-02-15 00:08:16.000000', 'consum', 0.0219, 'lps'),
	(398107, 123, '2015-02-15 00:08:17.000000', 'consum', 0.0210, 'lps'),
	(398108, 123, '2015-02-15 00:08:18.000000', 'consum', 0.0218, 'lps'),
	(398109, 123, '2015-02-15 00:08:19.000000', 'consum', 0.0216, 'lps'),
	(398110, 123, '2015-02-15 00:08:20.000000', 'consum', 0.0218, 'lps'),
	(398111, 123, '2015-02-15 00:08:21.000000', 'consum', 0.0220, 'lps'),
	(398112, 123, '2015-02-15 00:08:22.000000', 'consum', 0.0215, 'lps'),
	(398113, 123, '2015-02-15 00:08:23.000000', 'consum', 0.0217, 'lps'),
	(398114, 123, '2015-02-15 00:08:24.000000', 'consum', 0.0219, 'lps'),
	(398115, 123, '2015-02-15 00:08:25.000000', 'consum', 0.0212, 'lps'),
	(398116, 123, '2015-02-15 00:08:26.000000', 'consum', 0.0214, 'lps'),
	(398117, 123, '2015-02-15 00:08:27.000000', 'consum', 0.0215, 'lps'),
	(398118, 123, '2015-02-15 00:08:28.000000', 'consum', 0.0214, 'lps'),
	(398119, 123, '2015-02-15 00:08:29.000000', 'consum', 0.0216, 'lps'),
	(398120, 123, '2015-02-15 00:08:30.000000', 'consum', 0.0216, 'lps'),
	(398121, 123, '2015-02-15 00:08:31.000000', 'consum', 0.0210, 'lps'),
	(398122, 123, '2015-02-15 00:08:32.000000', 'consum', 0.0218, 'lps'),
	(398123, 123, '2015-02-15 00:08:33.000000', 'consum', 0.0215, 'lps'),
	(398124, 123, '2015-02-15 00:08:34.000000', 'consum', 0.0212, 'lps'),
	(398125, 123, '2015-02-15 00:08:35.000000', 'consum', 0.0217, 'lps'),
	(398126, 123, '2015-02-15 00:08:36.000000', 'consum', 0.0218, 'lps'),
	(398127, 123, '2015-02-15 00:08:37.000000', 'consum', 0.0220, 'lps'),
	(398128, 123, '2015-02-15 00:08:38.000000', 'consum', 0.0212, 'lps'),
	(398129, 123, '2015-02-15 00:08:39.000000', 'consum', 0.0214, 'lps'),
	(398130, 123, '2015-02-15 00:08:40.000000', 'consum', 0.0212, 'lps'),
	(398131, 123, '2015-02-15 00:08:41.000000', 'consum', 0.0211, 'lps'),
	(398132, 123, '2015-02-15 00:08:42.000000', 'consum', 0.0219, 'lps'),
	(398133, 123, '2015-02-15 00:08:43.000000', 'consum', 0.0210, 'lps'),
	(398134, 123, '2015-02-15 00:08:44.000000', 'consum', 0.0218, 'lps'),
	(398135, 123, '2015-02-15 00:08:45.000000', 'consum', 0.0214, 'lps'),
	(398136, 123, '2015-02-15 00:08:46.000000', 'consum', 0.0219, 'lps'),
	(398137, 123, '2015-02-15 00:08:47.000000', 'consum', 0.0220, 'lps'),
	(398138, 123, '2015-02-15 00:08:48.000000', 'consum', 0.0212, 'lps'),
	(398139, 123, '2015-02-15 00:08:49.000000', 'consum', 0.0213, 'lps'),
	(398140, 123, '2015-02-15 00:08:50.000000', 'consum', 0.0210, 'lps'),
	(398141, 123, '2015-02-15 00:08:51.000000', 'consum', 0.0210, 'lps'),
	(398142, 123, '2015-02-15 00:08:52.000000', 'consum', 0.0213, 'lps'),
	(398143, 123, '2015-02-15 00:08:53.000000', 'consum', 0.0214, 'lps'),
	(398144, 123, '2015-02-15 00:08:54.000000', 'consum', 0.0220, 'lps'),
	(398145, 123, '2015-02-15 00:08:55.000000', 'consum', 0.0214, 'lps'),
	(398146, 123, '2015-02-15 00:08:56.000000', 'consum', 0.0215, 'lps'),
	(398147, 123, '2015-02-15 00:08:57.000000', 'consum', 0.0220, 'lps'),
	(398148, 123, '2015-02-15 00:08:58.000000', 'consum', 0.0214, 'lps'),
	(398149, 123, '2015-02-15 00:08:59.000000', 'consum', 0.0213, 'lps'),
	(398150, 123, '2015-02-15 00:09:00.000000', 'consum', 0.0213, 'lps'),
	(398151, 123, '2015-02-15 00:09:01.000000', 'consum', 0.0217, 'lps'),
	(398152, 123, '2015-02-15 00:09:02.000000', 'consum', 0.0213, 'lps'),
	(398153, 123, '2015-02-15 00:09:03.000000', 'consum', 0.0218, 'lps'),
	(398154, 123, '2015-02-15 00:09:04.000000', 'consum', 0.0219, 'lps'),
	(398155, 123, '2015-02-15 00:09:05.000000', 'consum', 0.0220, 'lps'),
	(398156, 123, '2015-02-15 00:09:06.000000', 'consum', 0.0213, 'lps'),
	(398157, 123, '2015-02-15 00:09:07.000000', 'consum', 0.0216, 'lps'),
	(398158, 123, '2015-02-15 00:09:08.000000', 'consum', 0.0210, 'lps'),
	(398159, 123, '2015-02-15 00:09:09.000000', 'consum', 0.0216, 'lps'),
	(398160, 123, '2015-02-15 00:09:10.000000', 'consum', 0.0218, 'lps'),
	(398161, 123, '2015-02-15 00:09:11.000000', 'consum', 0.0211, 'lps'),
	(398162, 123, '2015-02-15 00:09:12.000000', 'consum', 0.0214, 'lps'),
	(398163, 123, '2015-02-15 00:09:13.000000', 'consum', 0.0216, 'lps'),
	(398164, 123, '2015-02-15 00:09:14.000000', 'consum', 0.0219, 'lps'),
	(398165, 123, '2015-02-15 00:09:15.000000', 'consum', 0.0214, 'lps'),
	(398166, 123, '2015-02-15 00:09:16.000000', 'consum', 0.0216, 'lps'),
	(398167, 123, '2015-02-15 00:09:17.000000', 'consum', 0.0217, 'lps'),
	(398168, 123, '2015-02-15 00:09:18.000000', 'consum', 0.0217, 'lps'),
	(398169, 123, '2015-02-15 00:09:19.000000', 'consum', 0.0215, 'lps'),
	(398170, 123, '2015-02-15 00:09:20.000000', 'consum', 0.0213, 'lps'),
	(398171, 123, '2015-02-15 00:09:21.000000', 'consum', 0.0220, 'lps'),
	(398172, 123, '2015-02-15 00:09:22.000000', 'consum', 0.0219, 'lps'),
	(398173, 123, '2015-02-15 00:09:23.000000', 'consum', 0.0216, 'lps'),
	(398174, 123, '2015-02-15 00:09:24.000000', 'consum', 0.0214, 'lps'),
	(398175, 123, '2015-02-15 00:09:25.000000', 'consum', 0.0211, 'lps'),
	(398176, 123, '2015-02-15 00:09:26.000000', 'consum', 0.0215, 'lps'),
	(398177, 123, '2015-02-15 00:09:27.000000', 'consum', 0.0210, 'lps'),
	(398178, 123, '2015-02-15 00:09:28.000000', 'consum', 0.0218, 'lps'),
	(398179, 123, '2015-02-15 00:09:29.000000', 'consum', 0.0216, 'lps'),
	(398180, 123, '2015-02-15 00:09:30.000000', 'consum', 0.0215, 'lps'),
	(398181, 123, '2015-02-15 00:09:31.000000', 'consum', 0.0210, 'lps'),
	(398182, 123, '2015-02-15 00:09:32.000000', 'consum', 0.0216, 'lps'),
	(398183, 123, '2015-02-15 00:09:33.000000', 'consum', 0.0217, 'lps'),
	(398184, 123, '2015-02-15 00:09:34.000000', 'consum', 0.0218, 'lps'),
	(398185, 123, '2015-02-15 00:09:35.000000', 'consum', 0.0218, 'lps'),
	(398186, 123, '2015-02-15 00:09:36.000000', 'consum', 0.0217, 'lps'),
	(398187, 123, '2015-02-15 00:09:37.000000', 'consum', 0.0211, 'lps'),
	(398188, 123, '2015-02-15 00:09:38.000000', 'consum', 0.0217, 'lps'),
	(398189, 123, '2015-02-15 00:09:39.000000', 'consum', 0.0220, 'lps'),
	(398190, 123, '2015-02-15 00:09:40.000000', 'consum', 0.0218, 'lps'),
	(398191, 123, '2015-02-15 00:09:41.000000', 'consum', 0.0220, 'lps'),
	(398192, 123, '2015-02-15 00:09:42.000000', 'consum', 0.0215, 'lps'),
	(398193, 123, '2015-02-15 00:09:43.000000', 'consum', 0.0215, 'lps'),
	(398194, 123, '2015-02-15 00:09:44.000000', 'consum', 0.0210, 'lps'),
	(398195, 123, '2015-02-15 00:09:45.000000', 'consum', 0.0218, 'lps'),
	(398196, 123, '2015-02-15 00:09:46.000000', 'consum', 0.0218, 'lps'),
	(398197, 123, '2015-02-15 00:09:47.000000', 'consum', 0.0215, 'lps'),
	(398198, 123, '2015-02-15 00:09:48.000000', 'consum', 0.0211, 'lps'),
	(398199, 123, '2015-02-15 00:09:49.000000', 'consum', 0.0210, 'lps'),
	(398200, 123, '2015-02-15 00:09:50.000000', 'consum', 0.0210, 'lps'),
	(398201, 123, '2015-02-15 00:09:51.000000', 'consum', 0.0220, 'lps'),
	(398202, 123, '2015-02-15 00:09:52.000000', 'consum', 0.0215, 'lps'),
	(398203, 123, '2015-02-15 00:09:53.000000', 'consum', 0.0219, 'lps'),
	(398204, 123, '2015-02-15 00:09:54.000000', 'consum', 0.0216, 'lps'),
	(398205, 123, '2015-02-15 00:09:55.000000', 'consum', 0.0216, 'lps'),
	(398206, 123, '2015-02-15 00:09:56.000000', 'consum', 0.0220, 'lps'),
	(398207, 123, '2015-02-15 00:09:57.000000', 'consum', 0.0220, 'lps'),
	(398208, 123, '2015-02-15 00:09:58.000000', 'consum', 0.0211, 'lps'),
	(398209, 123, '2015-02-15 00:09:59.000000', 'consum', 0.0220, 'lps'),
	(398210, 123, '2015-02-15 00:10:00.000000', 'consum', 0.0210, 'lps'),
	(398211, 123, '2015-02-15 00:10:01.000000', 'consum', 0.0213, 'lps'),
	(398212, 123, '2015-02-15 00:10:02.000000', 'consum', 0.0217, 'lps'),
	(398213, 123, '2015-02-15 00:10:03.000000', 'consum', 0.0213, 'lps'),
	(398214, 123, '2015-02-15 00:10:04.000000', 'consum', 0.0217, 'lps'),
	(398215, 123, '2015-02-15 00:10:05.000000', 'consum', 0.0213, 'lps'),
	(398216, 123, '2015-02-15 00:10:06.000000', 'consum', 0.0217, 'lps'),
	(398217, 123, '2015-02-15 00:10:07.000000', 'consum', 0.0215, 'lps'),
	(398218, 123, '2015-02-15 00:10:08.000000', 'consum', 0.0214, 'lps'),
	(398219, 123, '2015-02-15 00:10:09.000000', 'consum', 0.0214, 'lps'),
	(398220, 123, '2015-02-15 00:10:10.000000', 'consum', 0.0219, 'lps'),
	(398221, 123, '2015-02-15 00:10:11.000000', 'consum', 0.0220, 'lps'),
	(398222, 123, '2015-02-15 00:10:12.000000', 'consum', 0.0213, 'lps'),
	(398223, 123, '2015-02-15 00:10:13.000000', 'consum', 0.0218, 'lps'),
	(398224, 123, '2015-02-15 00:10:14.000000', 'consum', 0.0210, 'lps'),
	(398225, 123, '2015-02-15 00:10:15.000000', 'consum', 0.0216, 'lps'),
	(398226, 123, '2015-02-15 00:10:16.000000', 'consum', 0.0210, 'lps'),
	(398227, 123, '2015-02-15 00:10:17.000000', 'consum', 0.0213, 'lps'),
	(398228, 123, '2015-02-15 00:10:18.000000', 'consum', 0.0216, 'lps'),
	(398229, 123, '2015-02-15 00:10:19.000000', 'consum', 0.0219, 'lps'),
	(398230, 123, '2015-02-15 00:10:20.000000', 'consum', 0.0216, 'lps'),
	(398231, 123, '2015-02-15 00:10:21.000000', 'consum', 0.0213, 'lps'),
	(398232, 123, '2015-02-15 00:10:22.000000', 'consum', 0.0219, 'lps'),
	(398233, 123, '2015-02-15 00:10:23.000000', 'consum', 0.0213, 'lps'),
	(398234, 123, '2015-02-15 00:10:24.000000', 'consum', 0.0210, 'lps'),
	(398235, 123, '2015-02-15 00:10:25.000000', 'consum', 0.0213, 'lps'),
	(398236, 123, '2015-02-15 00:10:26.000000', 'consum', 0.0212, 'lps'),
	(398237, 123, '2015-02-15 00:10:27.000000', 'consum', 0.0214, 'lps'),
	(398238, 123, '2015-02-15 00:10:28.000000', 'consum', 0.0215, 'lps'),
	(398239, 123, '2015-02-15 00:10:29.000000', 'consum', 0.0220, 'lps'),
	(398240, 123, '2015-02-15 00:10:30.000000', 'consum', 0.0213, 'lps'),
	(398241, 123, '2015-02-15 00:10:31.000000', 'consum', 0.0220, 'lps'),
	(398242, 123, '2015-02-15 00:10:32.000000', 'consum', 0.0217, 'lps'),
	(398243, 123, '2015-02-15 00:10:33.000000', 'consum', 0.0215, 'lps'),
	(398244, 123, '2015-02-15 00:10:34.000000', 'consum', 0.0213, 'lps'),
	(398245, 123, '2015-02-15 00:10:35.000000', 'consum', 0.0213, 'lps'),
	(398246, 123, '2015-02-15 00:10:36.000000', 'consum', 0.0217, 'lps'),
	(398247, 123, '2015-02-15 00:10:37.000000', 'consum', 0.0213, 'lps'),
	(398248, 123, '2015-02-15 00:10:38.000000', 'consum', 0.0214, 'lps'),
	(398249, 123, '2015-02-15 00:10:39.000000', 'consum', 0.0211, 'lps'),
	(398250, 123, '2015-02-15 00:10:40.000000', 'consum', 0.0216, 'lps'),
	(398251, 123, '2015-02-15 00:10:41.000000', 'consum', 0.0215, 'lps'),
	(398252, 123, '2015-02-15 00:10:42.000000', 'consum', 0.0218, 'lps'),
	(398253, 123, '2015-02-15 00:10:43.000000', 'consum', 0.0214, 'lps'),
	(398254, 123, '2015-02-15 00:10:44.000000', 'consum', 0.0215, 'lps'),
	(398255, 123, '2015-02-15 00:10:45.000000', 'consum', 0.0216, 'lps'),
	(398256, 123, '2015-02-15 00:10:46.000000', 'consum', 0.0212, 'lps'),
	(398257, 123, '2015-02-15 00:10:47.000000', 'consum', 0.0213, 'lps'),
	(398258, 123, '2015-02-15 00:10:48.000000', 'consum', 0.0220, 'lps'),
	(398259, 123, '2015-02-15 00:10:49.000000', 'consum', 0.0220, 'lps'),
	(398260, 123, '2015-02-15 00:10:50.000000', 'consum', 0.0217, 'lps'),
	(398261, 123, '2015-02-15 00:10:51.000000', 'consum', 0.0218, 'lps'),
	(398262, 123, '2015-02-15 00:10:52.000000', 'consum', 0.0217, 'lps'),
	(398263, 123, '2015-02-15 00:10:53.000000', 'consum', 0.0212, 'lps'),
	(398264, 123, '2015-02-15 00:10:54.000000', 'consum', 0.0210, 'lps'),
	(398265, 123, '2015-02-15 00:10:55.000000', 'consum', 0.0216, 'lps'),
	(398266, 123, '2015-02-15 00:10:56.000000', 'consum', 0.0218, 'lps'),
	(398267, 123, '2015-02-15 00:10:57.000000', 'consum', 0.0211, 'lps'),
	(398268, 123, '2015-02-15 00:10:58.000000', 'consum', 0.0213, 'lps'),
	(398269, 123, '2015-02-15 00:10:59.000000', 'consum', 0.0211, 'lps'),
	(398270, 123, '2015-02-15 00:11:00.000000', 'consum', 0.0216, 'lps'),
	(398271, 123, '2015-02-15 00:11:01.000000', 'consum', 0.0216, 'lps'),
	(398272, 123, '2015-02-15 00:11:02.000000', 'consum', 0.0214, 'lps'),
	(398273, 123, '2015-02-15 00:11:03.000000', 'consum', 0.0220, 'lps'),
	(398274, 123, '2015-02-15 00:11:04.000000', 'consum', 0.0219, 'lps'),
	(398275, 123, '2015-02-15 00:11:05.000000', 'consum', 0.0212, 'lps'),
	(398276, 123, '2015-02-15 00:11:06.000000', 'consum', 0.0217, 'lps'),
	(398277, 123, '2015-02-15 00:11:07.000000', 'consum', 0.0216, 'lps'),
	(398278, 123, '2015-02-15 00:11:08.000000', 'consum', 0.0211, 'lps'),
	(398279, 123, '2015-02-15 00:11:09.000000', 'consum', 0.0219, 'lps'),
	(398280, 123, '2015-02-15 00:11:10.000000', 'consum', 0.0219, 'lps'),
	(398281, 123, '2015-02-15 00:11:11.000000', 'consum', 0.0219, 'lps'),
	(398282, 123, '2015-02-15 00:11:12.000000', 'consum', 0.0216, 'lps'),
	(398283, 123, '2015-02-15 00:11:13.000000', 'consum', 0.0214, 'lps'),
	(398284, 123, '2015-02-15 00:11:14.000000', 'consum', 0.0214, 'lps'),
	(398285, 123, '2015-02-15 00:11:15.000000', 'consum', 0.0218, 'lps'),
	(398286, 123, '2015-02-15 00:11:16.000000', 'consum', 0.0218, 'lps'),
	(398287, 123, '2015-02-15 00:11:17.000000', 'consum', 0.0213, 'lps'),
	(398288, 123, '2015-02-15 00:11:18.000000', 'consum', 0.0214, 'lps'),
	(398289, 123, '2015-02-15 00:11:19.000000', 'consum', 0.0210, 'lps'),
	(398290, 123, '2015-02-15 00:11:20.000000', 'consum', 0.0219, 'lps'),
	(398291, 123, '2015-02-15 00:11:21.000000', 'consum', 0.0212, 'lps'),
	(398292, 123, '2015-02-15 00:11:22.000000', 'consum', 0.0214, 'lps'),
	(398293, 123, '2015-02-15 00:11:23.000000', 'consum', 0.0217, 'lps'),
	(398294, 123, '2015-02-15 00:11:24.000000', 'consum', 0.0219, 'lps'),
	(398295, 123, '2015-02-15 00:11:25.000000', 'consum', 0.0215, 'lps'),
	(398296, 123, '2015-02-15 00:11:26.000000', 'consum', 0.0210, 'lps'),
	(398297, 123, '2015-02-15 00:11:27.000000', 'consum', 0.0215, 'lps'),
	(398298, 123, '2015-02-15 00:11:28.000000', 'consum', 0.0214, 'lps'),
	(398299, 123, '2015-02-15 00:11:29.000000', 'consum', 0.0215, 'lps'),
	(398300, 123, '2015-02-15 00:11:30.000000', 'consum', 0.0212, 'lps'),
	(398301, 123, '2015-02-15 00:11:31.000000', 'consum', 0.0217, 'lps'),
	(398302, 123, '2015-02-15 00:11:32.000000', 'consum', 0.0216, 'lps'),
	(398303, 123, '2015-02-15 00:11:33.000000', 'consum', 0.0210, 'lps'),
	(398304, 123, '2015-02-15 00:11:34.000000', 'consum', 0.0214, 'lps'),
	(398305, 123, '2015-02-15 00:11:35.000000', 'consum', 0.0219, 'lps'),
	(398306, 123, '2015-02-15 00:11:36.000000', 'consum', 0.0212, 'lps'),
	(398307, 123, '2015-02-15 00:11:37.000000', 'consum', 0.0216, 'lps'),
	(398308, 123, '2015-02-15 00:11:38.000000', 'consum', 0.0212, 'lps'),
	(398309, 123, '2015-02-15 00:11:39.000000', 'consum', 0.0213, 'lps'),
	(398310, 123, '2015-02-15 00:11:40.000000', 'consum', 0.0219, 'lps'),
	(398311, 123, '2015-02-15 00:11:41.000000', 'consum', 0.0213, 'lps'),
	(398312, 123, '2015-02-15 00:11:42.000000', 'consum', 0.0212, 'lps'),
	(398313, 123, '2015-02-15 00:11:43.000000', 'consum', 0.0211, 'lps'),
	(398314, 123, '2015-02-15 00:11:44.000000', 'consum', 0.0211, 'lps'),
	(398315, 123, '2015-02-15 00:11:45.000000', 'consum', 0.0210, 'lps'),
	(398316, 123, '2015-02-15 00:11:46.000000', 'consum', 0.0210, 'lps'),
	(398317, 123, '2015-02-15 00:11:47.000000', 'consum', 0.0220, 'lps'),
	(398318, 123, '2015-02-15 00:11:48.000000', 'consum', 0.0216, 'lps'),
	(398319, 123, '2015-02-15 00:11:49.000000', 'consum', 0.0210, 'lps'),
	(398320, 123, '2015-02-15 00:11:50.000000', 'consum', 0.0217, 'lps'),
	(398321, 123, '2015-02-15 00:11:51.000000', 'consum', 0.0212, 'lps'),
	(398322, 123, '2015-02-15 00:11:52.000000', 'consum', 0.0212, 'lps'),
	(398323, 123, '2015-02-15 00:11:53.000000', 'consum', 0.0211, 'lps'),
	(398324, 123, '2015-02-15 00:11:54.000000', 'consum', 0.0212, 'lps'),
	(398325, 123, '2015-02-15 00:11:55.000000', 'consum', 0.0215, 'lps'),
	(398326, 123, '2015-02-15 00:11:56.000000', 'consum', 0.0219, 'lps'),
	(398327, 123, '2015-02-15 00:11:57.000000', 'consum', 0.0219, 'lps'),
	(398328, 123, '2015-02-15 00:11:58.000000', 'consum', 0.0219, 'lps'),
	(398329, 123, '2015-02-15 00:11:59.000000', 'consum', 0.0215, 'lps'),
	(398330, 123, '2015-02-15 00:12:00.000000', 'consum', 0.0210, 'lps'),
	(398331, 123, '2015-02-15 00:12:01.000000', 'consum', 0.0216, 'lps'),
	(398332, 123, '2015-02-15 00:12:02.000000', 'consum', 0.0219, 'lps'),
	(398333, 123, '2015-02-15 00:12:03.000000', 'consum', 0.0215, 'lps'),
	(398334, 123, '2015-02-15 00:12:04.000000', 'consum', 0.0219, 'lps'),
	(398335, 123, '2015-02-15 00:12:05.000000', 'consum', 0.0217, 'lps'),
	(398336, 123, '2015-02-15 00:12:06.000000', 'consum', 0.0211, 'lps'),
	(398337, 123, '2015-02-15 00:12:07.000000', 'consum', 0.0216, 'lps'),
	(398338, 123, '2015-02-15 00:12:08.000000', 'consum', 0.0214, 'lps'),
	(398339, 123, '2015-02-15 00:12:09.000000', 'consum', 0.0214, 'lps'),
	(398340, 123, '2015-02-15 00:12:10.000000', 'consum', 0.0216, 'lps'),
	(398341, 123, '2015-02-15 00:12:11.000000', 'consum', 0.0220, 'lps'),
	(398342, 123, '2015-02-15 00:12:12.000000', 'consum', 0.0220, 'lps'),
	(398343, 123, '2015-02-15 00:12:13.000000', 'consum', 0.0210, 'lps'),
	(398344, 123, '2015-02-15 00:12:14.000000', 'consum', 0.0211, 'lps'),
	(398345, 123, '2015-02-15 00:12:15.000000', 'consum', 0.0215, 'lps'),
	(398346, 123, '2015-02-15 00:12:16.000000', 'consum', 0.0210, 'lps'),
	(398347, 123, '2015-02-15 00:12:17.000000', 'consum', 0.0219, 'lps'),
	(398348, 123, '2015-02-15 00:12:18.000000', 'consum', 0.0220, 'lps'),
	(398349, 123, '2015-02-15 00:12:19.000000', 'consum', 0.0214, 'lps'),
	(398350, 123, '2015-02-15 00:12:20.000000', 'consum', 0.0211, 'lps'),
	(398351, 123, '2015-02-15 00:12:21.000000', 'consum', 0.0215, 'lps'),
	(398352, 123, '2015-02-15 00:12:22.000000', 'consum', 0.0210, 'lps'),
	(398353, 123, '2015-02-15 00:12:23.000000', 'consum', 0.0216, 'lps'),
	(398354, 123, '2015-02-15 00:12:24.000000', 'consum', 0.0210, 'lps'),
	(398355, 123, '2015-02-15 00:12:25.000000', 'consum', 0.0213, 'lps'),
	(398356, 123, '2015-02-15 00:12:26.000000', 'consum', 0.0216, 'lps'),
	(398357, 123, '2015-02-15 00:12:27.000000', 'consum', 0.0210, 'lps'),
	(398358, 123, '2015-02-15 00:12:28.000000', 'consum', 0.0213, 'lps'),
	(398359, 123, '2015-02-15 00:12:29.000000', 'consum', 0.0213, 'lps'),
	(398360, 123, '2015-02-15 00:12:30.000000', 'consum', 0.0219, 'lps'),
	(398361, 123, '2015-02-15 00:12:31.000000', 'consum', 0.0214, 'lps'),
	(398362, 123, '2015-02-15 00:12:32.000000', 'consum', 0.0212, 'lps'),
	(398363, 123, '2015-02-15 00:12:33.000000', 'consum', 0.0220, 'lps'),
	(398364, 123, '2015-02-15 00:12:34.000000', 'consum', 0.0210, 'lps'),
	(398365, 123, '2015-02-15 00:12:35.000000', 'consum', 0.0212, 'lps'),
	(398366, 123, '2015-02-15 00:12:36.000000', 'consum', 0.0212, 'lps'),
	(398367, 123, '2015-02-15 00:12:37.000000', 'consum', 0.0216, 'lps'),
	(398368, 123, '2015-02-15 00:12:38.000000', 'consum', 0.0210, 'lps'),
	(398369, 123, '2015-02-15 00:12:39.000000', 'consum', 0.0217, 'lps'),
	(398370, 123, '2015-02-15 00:12:40.000000', 'consum', 0.0212, 'lps'),
	(398371, 123, '2015-02-15 00:12:41.000000', 'consum', 0.0220, 'lps'),
	(398372, 123, '2015-02-15 00:12:42.000000', 'consum', 0.0220, 'lps'),
	(398373, 123, '2015-02-15 00:12:43.000000', 'consum', 0.0211, 'lps'),
	(398374, 123, '2015-02-15 00:12:44.000000', 'consum', 0.0219, 'lps'),
	(398375, 123, '2015-02-15 00:12:45.000000', 'consum', 0.0218, 'lps'),
	(398376, 123, '2015-02-15 00:12:46.000000', 'consum', 0.0213, 'lps'),
	(398377, 123, '2015-02-15 00:12:47.000000', 'consum', 0.0214, 'lps'),
	(398378, 123, '2015-02-15 00:12:48.000000', 'consum', 0.0218, 'lps'),
	(398379, 123, '2015-02-15 00:12:49.000000', 'consum', 0.0219, 'lps'),
	(398380, 123, '2015-02-15 00:12:50.000000', 'consum', 0.0211, 'lps'),
	(398381, 123, '2015-02-15 00:12:51.000000', 'consum', 0.0220, 'lps'),
	(398382, 123, '2015-02-15 00:12:52.000000', 'consum', 0.0213, 'lps'),
	(398383, 123, '2015-02-15 00:12:53.000000', 'consum', 0.0218, 'lps'),
	(398384, 123, '2015-02-15 00:12:54.000000', 'consum', 0.0219, 'lps'),
	(398385, 123, '2015-02-15 00:12:55.000000', 'consum', 0.0220, 'lps'),
	(398386, 123, '2015-02-15 00:12:56.000000', 'consum', 0.0212, 'lps'),
	(398387, 123, '2015-02-15 00:12:57.000000', 'consum', 0.0213, 'lps'),
	(398388, 123, '2015-02-15 00:12:58.000000', 'consum', 0.0218, 'lps'),
	(398389, 123, '2015-02-15 00:12:59.000000', 'consum', 0.0211, 'lps'),
	(398390, 123, '2015-02-15 00:13:00.000000', 'consum', 0.0213, 'lps'),
	(398391, 123, '2015-02-15 00:13:01.000000', 'consum', 0.0211, 'lps'),
	(398392, 123, '2015-02-15 00:13:02.000000', 'consum', 0.0217, 'lps'),
	(398393, 123, '2015-02-15 00:13:03.000000', 'consum', 0.0212, 'lps'),
	(398394, 123, '2015-02-15 00:13:04.000000', 'consum', 0.0219, 'lps'),
	(398395, 123, '2015-02-15 00:13:05.000000', 'consum', 0.0217, 'lps'),
	(398396, 123, '2015-02-15 00:13:06.000000', 'consum', 0.0220, 'lps'),
	(398397, 123, '2015-02-15 00:13:07.000000', 'consum', 0.0215, 'lps'),
	(398398, 123, '2015-02-15 00:13:08.000000', 'consum', 0.0218, 'lps'),
	(398399, 123, '2015-02-15 00:13:09.000000', 'consum', 0.0211, 'lps'),
	(398400, 123, '2015-02-15 00:13:10.000000', 'consum', 0.0215, 'lps'),
	(398401, 123, '2015-02-15 00:13:11.000000', 'consum', 0.0212, 'lps'),
	(398402, 123, '2015-02-15 00:13:12.000000', 'consum', 0.0215, 'lps'),
	(398403, 123, '2015-02-15 00:13:13.000000', 'consum', 0.0219, 'lps'),
	(398404, 123, '2015-02-15 00:13:14.000000', 'consum', 0.0219, 'lps'),
	(398405, 123, '2015-02-15 00:13:15.000000', 'consum', 0.0217, 'lps'),
	(398406, 123, '2015-02-15 00:13:16.000000', 'consum', 0.0219, 'lps'),
	(398407, 123, '2015-02-15 00:13:17.000000', 'consum', 0.0212, 'lps'),
	(398408, 123, '2015-02-15 00:13:18.000000', 'consum', 0.0215, 'lps'),
	(398409, 123, '2015-02-15 00:13:19.000000', 'consum', 0.0220, 'lps'),
	(398410, 123, '2015-02-15 00:13:20.000000', 'consum', 0.0212, 'lps'),
	(398411, 123, '2015-02-15 00:13:21.000000', 'consum', 0.0212, 'lps'),
	(398412, 123, '2015-02-15 00:13:22.000000', 'consum', 0.0215, 'lps'),
	(398413, 123, '2015-02-15 00:13:23.000000', 'consum', 0.0218, 'lps'),
	(398414, 123, '2015-02-15 00:13:24.000000', 'consum', 0.0215, 'lps'),
	(398415, 123, '2015-02-15 00:13:25.000000', 'consum', 0.0211, 'lps'),
	(398416, 123, '2015-02-15 00:13:26.000000', 'consum', 0.0212, 'lps'),
	(398417, 123, '2015-02-15 00:13:27.000000', 'consum', 0.0218, 'lps'),
	(398418, 123, '2015-02-15 00:13:28.000000', 'consum', 0.0210, 'lps'),
	(398419, 123, '2015-02-15 00:13:29.000000', 'consum', 0.0211, 'lps'),
	(398420, 123, '2015-02-15 00:13:30.000000', 'consum', 0.0213, 'lps'),
	(398421, 123, '2015-02-15 00:13:31.000000', 'consum', 0.0211, 'lps'),
	(398422, 123, '2015-02-15 00:13:32.000000', 'consum', 0.0219, 'lps'),
	(398423, 123, '2015-02-15 00:13:33.000000', 'consum', 0.0217, 'lps'),
	(398424, 123, '2015-02-15 00:13:34.000000', 'consum', 0.0211, 'lps'),
	(398425, 123, '2015-02-15 00:13:35.000000', 'consum', 0.0215, 'lps'),
	(398426, 123, '2015-02-15 00:13:36.000000', 'consum', 0.0220, 'lps'),
	(398427, 123, '2015-02-15 00:13:37.000000', 'consum', 0.0215, 'lps'),
	(398428, 123, '2015-02-15 00:13:38.000000', 'consum', 0.0216, 'lps'),
	(398429, 123, '2015-02-15 00:13:39.000000', 'consum', 0.0215, 'lps'),
	(398430, 123, '2015-02-15 00:13:40.000000', 'consum', 0.0218, 'lps'),
	(398431, 123, '2015-02-15 00:13:41.000000', 'consum', 0.0212, 'lps'),
	(398432, 123, '2015-02-15 00:13:42.000000', 'consum', 0.0220, 'lps'),
	(398433, 123, '2015-02-15 00:13:43.000000', 'consum', 0.0220, 'lps'),
	(398434, 123, '2015-02-15 00:13:44.000000', 'consum', 0.0219, 'lps'),
	(398435, 123, '2015-02-15 00:13:45.000000', 'consum', 0.0214, 'lps'),
	(398436, 123, '2015-02-15 00:13:46.000000', 'consum', 0.0214, 'lps'),
	(398437, 123, '2015-02-15 00:13:47.000000', 'consum', 0.0210, 'lps'),
	(398438, 123, '2015-02-15 00:13:48.000000', 'consum', 0.0220, 'lps'),
	(398439, 123, '2015-02-15 00:13:49.000000', 'consum', 0.0216, 'lps'),
	(398440, 123, '2015-02-15 00:13:50.000000', 'consum', 0.0220, 'lps'),
	(398441, 123, '2015-02-15 00:13:51.000000', 'consum', 0.0220, 'lps'),
	(398442, 123, '2015-02-15 00:13:52.000000', 'consum', 0.0220, 'lps'),
	(398443, 123, '2015-02-15 00:13:53.000000', 'consum', 0.0210, 'lps'),
	(398444, 123, '2015-02-15 00:13:54.000000', 'consum', 0.0212, 'lps'),
	(398445, 123, '2015-02-15 00:13:55.000000', 'consum', 0.0220, 'lps'),
	(398446, 123, '2015-02-15 00:13:56.000000', 'consum', 0.0212, 'lps'),
	(398447, 123, '2015-02-15 00:13:57.000000', 'consum', 0.0214, 'lps'),
	(398448, 123, '2015-02-15 00:13:58.000000', 'consum', 0.0211, 'lps'),
	(398449, 123, '2015-02-15 00:13:59.000000', 'consum', 0.0215, 'lps'),
	(398450, 123, '2015-02-15 00:14:00.000000', 'consum', 0.0213, 'lps'),
	(398451, 123, '2015-02-15 00:14:01.000000', 'consum', 0.0218, 'lps'),
	(398452, 123, '2015-02-15 00:14:02.000000', 'consum', 0.0210, 'lps'),
	(398453, 123, '2015-02-15 00:14:03.000000', 'consum', 0.0210, 'lps'),
	(398454, 123, '2015-02-15 00:14:04.000000', 'consum', 0.0211, 'lps'),
	(398455, 123, '2015-02-15 00:14:05.000000', 'consum', 0.0212, 'lps'),
	(398456, 123, '2015-02-15 00:14:06.000000', 'consum', 0.0210, 'lps'),
	(398457, 123, '2015-02-15 00:14:07.000000', 'consum', 0.0215, 'lps'),
	(398458, 123, '2015-02-15 00:14:08.000000', 'consum', 0.0215, 'lps'),
	(398459, 123, '2015-02-15 00:14:09.000000', 'consum', 0.0218, 'lps'),
	(398460, 123, '2015-02-15 00:14:10.000000', 'consum', 0.0213, 'lps'),
	(398461, 123, '2015-02-15 00:14:11.000000', 'consum', 0.0215, 'lps'),
	(398462, 123, '2015-02-15 00:14:12.000000', 'consum', 0.0213, 'lps'),
	(398463, 123, '2015-02-15 00:14:13.000000', 'consum', 0.0210, 'lps'),
	(398464, 123, '2015-02-15 00:14:14.000000', 'consum', 0.0214, 'lps'),
	(398465, 123, '2015-02-15 00:14:15.000000', 'consum', 0.0210, 'lps'),
	(398466, 123, '2015-02-15 00:14:16.000000', 'consum', 0.0218, 'lps'),
	(398467, 123, '2015-02-15 00:14:17.000000', 'consum', 0.0218, 'lps'),
	(398468, 123, '2015-02-15 00:14:18.000000', 'consum', 0.0215, 'lps'),
	(398469, 123, '2015-02-15 00:14:19.000000', 'consum', 0.0213, 'lps'),
	(398470, 123, '2015-02-15 00:14:20.000000', 'consum', 0.0219, 'lps'),
	(398471, 123, '2015-02-15 00:14:21.000000', 'consum', 0.0216, 'lps'),
	(398472, 123, '2015-02-15 00:14:22.000000', 'consum', 0.0214, 'lps'),
	(398473, 123, '2015-02-15 00:14:23.000000', 'consum', 0.0211, 'lps'),
	(398474, 123, '2015-02-15 00:14:24.000000', 'consum', 0.0213, 'lps'),
	(398475, 123, '2015-02-15 00:14:25.000000', 'consum', 0.0215, 'lps'),
	(398476, 123, '2015-02-15 00:14:26.000000', 'consum', 0.0214, 'lps'),
	(398477, 123, '2015-02-15 00:14:27.000000', 'consum', 0.0214, 'lps'),
	(398478, 123, '2015-02-15 00:14:28.000000', 'consum', 0.0220, 'lps'),
	(398479, 123, '2015-02-15 00:14:29.000000', 'consum', 0.0216, 'lps'),
	(398480, 123, '2015-02-15 00:14:30.000000', 'consum', 0.0210, 'lps'),
	(398481, 123, '2015-02-15 00:14:31.000000', 'consum', 0.0215, 'lps'),
	(398482, 123, '2015-02-15 00:14:32.000000', 'consum', 0.0214, 'lps'),
	(398483, 123, '2015-02-15 00:14:33.000000', 'consum', 0.0217, 'lps'),
	(398484, 123, '2015-02-15 00:14:34.000000', 'consum', 0.0219, 'lps'),
	(398485, 123, '2015-02-15 00:14:35.000000', 'consum', 0.0214, 'lps'),
	(398486, 123, '2015-02-15 00:14:36.000000', 'consum', 0.0216, 'lps'),
	(398487, 123, '2015-02-15 00:14:37.000000', 'consum', 0.0215, 'lps'),
	(398488, 123, '2015-02-15 00:14:38.000000', 'consum', 0.0217, 'lps'),
	(398489, 123, '2015-02-15 00:14:39.000000', 'consum', 0.0210, 'lps'),
	(398490, 123, '2015-02-15 00:14:40.000000', 'consum', 0.0212, 'lps'),
	(398491, 123, '2015-02-15 00:14:41.000000', 'consum', 0.0210, 'lps'),
	(398492, 123, '2015-02-15 00:14:42.000000', 'consum', 0.0215, 'lps'),
	(398493, 123, '2015-02-15 00:14:43.000000', 'consum', 0.0215, 'lps'),
	(398494, 123, '2015-02-15 00:14:44.000000', 'consum', 0.0220, 'lps'),
	(398495, 123, '2015-02-15 00:14:45.000000', 'consum', 0.0210, 'lps'),
	(398496, 123, '2015-02-15 00:14:46.000000', 'consum', 0.0215, 'lps'),
	(398497, 123, '2015-02-15 00:14:47.000000', 'consum', 0.0213, 'lps'),
	(398498, 123, '2015-02-15 00:14:48.000000', 'consum', 0.0220, 'lps'),
	(398499, 123, '2015-02-15 00:14:49.000000', 'consum', 0.0219, 'lps'),
	(398500, 123, '2015-02-15 00:14:50.000000', 'consum', 0.0214, 'lps'),
	(398501, 123, '2015-02-15 00:14:51.000000', 'consum', 0.0214, 'lps'),
	(398502, 123, '2015-02-15 00:14:52.000000', 'consum', 0.0218, 'lps'),
	(398503, 123, '2015-02-15 00:14:53.000000', 'consum', 0.0216, 'lps'),
	(398504, 123, '2015-02-15 00:14:54.000000', 'consum', 0.0216, 'lps'),
	(398505, 123, '2015-02-15 00:14:55.000000', 'consum', 0.0213, 'lps'),
	(398506, 123, '2015-02-15 00:14:56.000000', 'consum', 0.0219, 'lps'),
	(398507, 123, '2015-02-15 00:14:57.000000', 'consum', 0.0213, 'lps'),
	(398508, 123, '2015-02-15 00:14:58.000000', 'consum', 0.0210, 'lps'),
	(398509, 123, '2015-02-15 00:14:59.000000', 'consum', 0.0211, 'lps'),
	(398510, 123, '2015-02-15 00:15:00.000000', 'consum', 0.0214, 'lps'),
	(398511, 123, '2015-02-15 00:15:01.000000', 'consum', 0.0219, 'lps'),
	(398512, 123, '2015-02-15 00:15:02.000000', 'consum', 0.0210, 'lps'),
	(398513, 123, '2015-02-15 00:15:03.000000', 'consum', 0.0216, 'lps'),
	(398514, 123, '2015-02-15 00:15:04.000000', 'consum', 0.0220, 'lps'),
	(398515, 123, '2015-02-15 00:15:05.000000', 'consum', 0.0218, 'lps'),
	(398516, 123, '2015-02-15 00:15:06.000000', 'consum', 0.0220, 'lps'),
	(398517, 123, '2015-02-15 00:15:07.000000', 'consum', 0.0217, 'lps'),
	(398518, 123, '2015-02-15 00:15:08.000000', 'consum', 0.0213, 'lps'),
	(398519, 123, '2015-02-15 00:15:09.000000', 'consum', 0.0217, 'lps'),
	(398520, 123, '2015-02-15 00:15:10.000000', 'consum', 0.0213, 'lps'),
	(398521, 123, '2015-02-15 00:15:11.000000', 'consum', 0.0215, 'lps'),
	(398522, 123, '2015-02-15 00:15:12.000000', 'consum', 0.0215, 'lps'),
	(398523, 123, '2015-02-15 00:15:13.000000', 'consum', 0.0212, 'lps'),
	(398524, 123, '2015-02-15 00:15:14.000000', 'consum', 0.0217, 'lps'),
	(398525, 123, '2015-02-15 00:15:15.000000', 'consum', 0.0218, 'lps'),
	(398526, 123, '2015-02-15 00:15:16.000000', 'consum', 0.0218, 'lps'),
	(398527, 123, '2015-02-15 00:15:17.000000', 'consum', 0.0215, 'lps'),
	(398528, 123, '2015-02-15 00:15:18.000000', 'consum', 0.0210, 'lps'),
	(398529, 123, '2015-02-15 00:15:19.000000', 'consum', 0.0219, 'lps'),
	(398530, 123, '2015-02-15 00:15:20.000000', 'consum', 0.0211, 'lps'),
	(398531, 123, '2015-02-15 00:15:21.000000', 'consum', 0.0212, 'lps'),
	(398532, 123, '2015-02-15 00:15:22.000000', 'consum', 0.0217, 'lps'),
	(398533, 123, '2015-02-15 00:15:23.000000', 'consum', 0.0216, 'lps'),
	(398534, 123, '2015-02-15 00:15:24.000000', 'consum', 0.0211, 'lps'),
	(398535, 123, '2015-02-15 00:15:25.000000', 'consum', 0.0216, 'lps'),
	(398536, 123, '2015-02-15 00:15:26.000000', 'consum', 0.0219, 'lps'),
	(398537, 123, '2015-02-15 00:15:27.000000', 'consum', 0.0213, 'lps'),
	(398538, 123, '2015-02-15 00:15:28.000000', 'consum', 0.0219, 'lps'),
	(398539, 123, '2015-02-15 00:15:29.000000', 'consum', 0.0217, 'lps'),
	(398540, 123, '2015-02-15 00:15:30.000000', 'consum', 0.0218, 'lps'),
	(398541, 123, '2015-02-15 00:15:31.000000', 'consum', 0.0216, 'lps'),
	(398542, 123, '2015-02-15 00:15:32.000000', 'consum', 0.0219, 'lps'),
	(398543, 123, '2015-02-15 00:15:33.000000', 'consum', 0.0215, 'lps'),
	(398544, 123, '2015-02-15 00:15:34.000000', 'consum', 0.0210, 'lps'),
	(398545, 123, '2015-02-15 00:15:35.000000', 'consum', 0.0217, 'lps'),
	(398546, 123, '2015-02-15 00:15:36.000000', 'consum', 0.0210, 'lps'),
	(398547, 123, '2015-02-15 00:15:37.000000', 'consum', 0.0213, 'lps'),
	(398548, 123, '2015-02-15 00:15:38.000000', 'consum', 0.0215, 'lps'),
	(398549, 123, '2015-02-15 00:15:39.000000', 'consum', 0.0215, 'lps'),
	(398550, 123, '2015-02-15 00:15:40.000000', 'consum', 0.0220, 'lps'),
	(398551, 123, '2015-02-15 00:15:41.000000', 'consum', 0.0214, 'lps'),
	(398552, 123, '2015-02-15 00:15:42.000000', 'consum', 0.0211, 'lps'),
	(398553, 123, '2015-02-15 00:15:43.000000', 'consum', 0.0215, 'lps'),
	(398554, 123, '2015-02-15 00:15:44.000000', 'consum', 0.0211, 'lps'),
	(398555, 123, '2015-02-15 00:15:45.000000', 'consum', 0.0211, 'lps'),
	(398556, 123, '2015-02-15 00:15:46.000000', 'consum', 0.0213, 'lps'),
	(398557, 123, '2015-02-15 00:15:47.000000', 'consum', 0.0210, 'lps'),
	(398558, 123, '2015-02-15 00:15:48.000000', 'consum', 0.0211, 'lps'),
	(398559, 123, '2015-02-15 00:15:49.000000', 'consum', 0.0218, 'lps'),
	(398560, 123, '2015-02-15 00:15:50.000000', 'consum', 0.0212, 'lps'),
	(398561, 123, '2015-02-15 00:15:51.000000', 'consum', 0.0220, 'lps'),
	(398562, 123, '2015-02-15 00:15:52.000000', 'consum', 0.0211, 'lps'),
	(398563, 123, '2015-02-15 00:15:53.000000', 'consum', 0.0217, 'lps'),
	(398564, 123, '2015-02-15 00:15:54.000000', 'consum', 0.0212, 'lps'),
	(398565, 123, '2015-02-15 00:15:55.000000', 'consum', 0.0219, 'lps'),
	(398566, 123, '2015-02-15 00:15:56.000000', 'consum', 0.0218, 'lps'),
	(398567, 123, '2015-02-15 00:15:57.000000', 'consum', 0.0213, 'lps'),
	(398568, 123, '2015-02-15 00:15:58.000000', 'consum', 0.0213, 'lps'),
	(398569, 123, '2015-02-15 00:15:59.000000', 'consum', 0.0216, 'lps'),
	(398570, 123, '2015-02-15 00:16:00.000000', 'consum', 0.0220, 'lps'),
	(398571, 123, '2015-02-15 00:16:01.000000', 'consum', 0.0212, 'lps'),
	(398572, 123, '2015-02-15 00:16:02.000000', 'consum', 0.0220, 'lps'),
	(398573, 123, '2015-02-15 00:16:03.000000', 'consum', 0.0212, 'lps'),
	(398574, 123, '2015-02-15 00:16:04.000000', 'consum', 0.0212, 'lps'),
	(398575, 123, '2015-02-15 00:16:05.000000', 'consum', 0.0214, 'lps'),
	(398576, 123, '2015-02-15 00:16:06.000000', 'consum', 0.0215, 'lps'),
	(398577, 123, '2015-02-15 00:16:07.000000', 'consum', 0.0213, 'lps'),
	(398578, 123, '2015-02-15 00:16:08.000000', 'consum', 0.0220, 'lps'),
	(398579, 123, '2015-02-15 00:16:09.000000', 'consum', 0.0220, 'lps'),
	(398580, 123, '2015-02-15 00:16:10.000000', 'consum', 0.0217, 'lps'),
	(398581, 123, '2015-02-15 00:16:11.000000', 'consum', 0.0218, 'lps'),
	(398582, 123, '2015-02-15 00:16:12.000000', 'consum', 0.0217, 'lps'),
	(398583, 123, '2015-02-15 00:16:13.000000', 'consum', 0.0211, 'lps'),
	(398584, 123, '2015-02-15 00:16:14.000000', 'consum', 0.0217, 'lps'),
	(398585, 123, '2015-02-15 00:16:15.000000', 'consum', 0.0211, 'lps'),
	(398586, 123, '2015-02-15 00:16:16.000000', 'consum', 0.0216, 'lps'),
	(398587, 123, '2015-02-15 00:16:17.000000', 'consum', 0.0214, 'lps'),
	(398588, 123, '2015-02-15 00:16:18.000000', 'consum', 0.0214, 'lps'),
	(398589, 123, '2015-02-15 00:16:19.000000', 'consum', 0.0219, 'lps'),
	(398590, 123, '2015-02-15 00:16:20.000000', 'consum', 0.0220, 'lps'),
	(398591, 123, '2015-02-15 00:16:21.000000', 'consum', 0.0212, 'lps'),
	(398592, 123, '2015-02-15 00:16:22.000000', 'consum', 0.0214, 'lps'),
	(398593, 123, '2015-02-15 00:16:23.000000', 'consum', 0.0211, 'lps'),
	(398594, 123, '2015-02-15 00:16:24.000000', 'consum', 0.0217, 'lps'),
	(398595, 123, '2015-02-15 00:16:25.000000', 'consum', 0.0218, 'lps'),
	(398596, 123, '2015-02-15 00:16:26.000000', 'consum', 0.0220, 'lps'),
	(398597, 123, '2015-02-15 00:16:27.000000', 'consum', 0.0216, 'lps'),
	(398598, 123, '2015-02-15 00:16:28.000000', 'consum', 0.0218, 'lps'),
	(398599, 123, '2015-02-15 00:16:29.000000', 'consum', 0.0213, 'lps'),
	(398600, 123, '2015-02-15 00:16:30.000000', 'consum', 0.0212, 'lps'),
	(398601, 123, '2015-02-15 00:16:31.000000', 'consum', 0.0211, 'lps'),
	(398602, 123, '2015-02-15 00:16:32.000000', 'consum', 0.0211, 'lps'),
	(398603, 123, '2015-02-15 00:16:33.000000', 'consum', 0.0210, 'lps'),
	(398604, 123, '2015-02-15 00:16:34.000000', 'consum', 0.0219, 'lps'),
	(398605, 123, '2015-02-15 00:16:35.000000', 'consum', 0.0211, 'lps'),
	(398606, 123, '2015-02-15 00:16:36.000000', 'consum', 0.0212, 'lps'),
	(398607, 123, '2015-02-15 00:16:37.000000', 'consum', 0.0216, 'lps'),
	(398608, 123, '2015-02-15 00:16:38.000000', 'consum', 0.0211, 'lps'),
	(398609, 123, '2015-02-15 00:16:39.000000', 'consum', 0.0211, 'lps'),
	(398610, 123, '2015-02-15 00:16:40.000000', 'consum', 0.0214, 'lps'),
	(398611, 123, '2015-02-15 00:16:41.000000', 'consum', 0.0215, 'lps'),
	(398612, 123, '2015-02-15 00:16:42.000000', 'consum', 0.0211, 'lps'),
	(398613, 123, '2015-02-15 00:16:43.000000', 'consum', 0.0212, 'lps'),
	(398614, 123, '2015-02-15 00:16:44.000000', 'consum', 0.0216, 'lps'),
	(398615, 123, '2015-02-15 00:16:45.000000', 'consum', 0.0215, 'lps'),
	(398616, 123, '2015-02-15 00:16:46.000000', 'consum', 0.0217, 'lps'),
	(398617, 123, '2015-02-15 00:16:47.000000', 'consum', 0.0217, 'lps'),
	(398618, 123, '2015-02-15 00:16:48.000000', 'consum', 0.0216, 'lps'),
	(398619, 123, '2015-02-15 00:16:49.000000', 'consum', 0.0219, 'lps'),
	(398620, 123, '2015-02-15 00:16:50.000000', 'consum', 0.0214, 'lps'),
	(398621, 123, '2015-02-15 00:16:51.000000', 'consum', 0.0216, 'lps'),
	(398622, 123, '2015-02-15 00:16:52.000000', 'consum', 0.0215, 'lps'),
	(398623, 123, '2015-02-15 00:16:53.000000', 'consum', 0.0220, 'lps'),
	(398624, 123, '2015-02-15 00:16:54.000000', 'consum', 0.0212, 'lps'),
	(398625, 123, '2015-02-15 00:16:55.000000', 'consum', 0.0212, 'lps'),
	(398626, 123, '2015-02-15 00:16:56.000000', 'consum', 0.0215, 'lps'),
	(398627, 123, '2015-02-15 00:16:57.000000', 'consum', 0.0220, 'lps'),
	(398628, 123, '2015-02-15 00:16:58.000000', 'consum', 0.0213, 'lps'),
	(398629, 123, '2015-02-15 00:16:59.000000', 'consum', 0.0218, 'lps'),
	(398630, 123, '2015-02-15 00:17:00.000000', 'consum', 0.0218, 'lps'),
	(398631, 123, '2015-02-15 00:17:01.000000', 'consum', 0.0214, 'lps'),
	(398632, 123, '2015-02-15 00:17:02.000000', 'consum', 0.0218, 'lps'),
	(398633, 123, '2015-02-15 00:17:03.000000', 'consum', 0.0217, 'lps'),
	(398634, 123, '2015-02-15 00:17:04.000000', 'consum', 0.0220, 'lps'),
	(398635, 123, '2015-02-15 00:17:05.000000', 'consum', 0.0218, 'lps'),
	(398636, 123, '2015-02-15 00:17:06.000000', 'consum', 0.0211, 'lps'),
	(398637, 123, '2015-02-15 00:17:07.000000', 'consum', 0.0214, 'lps'),
	(398638, 123, '2015-02-15 00:17:08.000000', 'consum', 0.0217, 'lps'),
	(398639, 123, '2015-02-15 00:17:09.000000', 'consum', 0.0210, 'lps'),
	(398640, 123, '2015-02-15 00:17:10.000000', 'consum', 0.0210, 'lps'),
	(398641, 123, '2015-02-15 00:17:11.000000', 'consum', 0.0213, 'lps'),
	(398642, 123, '2015-02-15 00:17:12.000000', 'consum', 0.0215, 'lps'),
	(398643, 123, '2015-02-15 00:17:13.000000', 'consum', 0.0217, 'lps'),
	(398644, 123, '2015-02-15 00:17:14.000000', 'consum', 0.0216, 'lps'),
	(398645, 123, '2015-02-15 00:17:15.000000', 'consum', 0.0220, 'lps'),
	(398646, 123, '2015-02-15 00:17:16.000000', 'consum', 0.0219, 'lps'),
	(398647, 123, '2015-02-15 00:17:17.000000', 'consum', 0.0216, 'lps'),
	(398648, 123, '2015-02-15 00:17:18.000000', 'consum', 0.0214, 'lps'),
	(398649, 123, '2015-02-15 00:17:19.000000', 'consum', 0.0213, 'lps'),
	(398650, 123, '2015-02-15 00:17:20.000000', 'consum', 0.0212, 'lps'),
	(398651, 123, '2015-02-15 00:17:21.000000', 'consum', 0.0211, 'lps'),
	(398652, 123, '2015-02-15 00:17:22.000000', 'consum', 0.0220, 'lps'),
	(398653, 123, '2015-02-15 00:17:23.000000', 'consum', 0.0215, 'lps'),
	(398654, 123, '2015-02-15 00:17:24.000000', 'consum', 0.0214, 'lps'),
	(398655, 123, '2015-02-15 00:17:25.000000', 'consum', 0.0218, 'lps'),
	(398656, 123, '2015-02-15 00:17:26.000000', 'consum', 0.0216, 'lps'),
	(398657, 123, '2015-02-15 00:17:27.000000', 'consum', 0.0215, 'lps'),
	(398658, 123, '2015-02-15 00:17:28.000000', 'consum', 0.0218, 'lps'),
	(398659, 123, '2015-02-15 00:17:29.000000', 'consum', 0.0215, 'lps'),
	(398660, 123, '2015-02-15 00:17:30.000000', 'consum', 0.0212, 'lps'),
	(398661, 123, '2015-02-15 00:17:31.000000', 'consum', 0.0217, 'lps'),
	(398662, 123, '2015-02-15 00:17:32.000000', 'consum', 0.0218, 'lps'),
	(398663, 123, '2015-02-15 00:17:33.000000', 'consum', 0.0217, 'lps'),
	(398664, 123, '2015-02-15 00:17:34.000000', 'consum', 0.0210, 'lps'),
	(398665, 123, '2015-02-15 00:17:35.000000', 'consum', 0.0211, 'lps'),
	(398666, 123, '2015-02-15 00:17:36.000000', 'consum', 0.0217, 'lps'),
	(398667, 123, '2015-02-15 00:17:37.000000', 'consum', 0.0220, 'lps'),
	(398668, 123, '2015-02-15 00:17:38.000000', 'consum', 0.0219, 'lps'),
	(398669, 123, '2015-02-15 00:17:39.000000', 'consum', 0.0212, 'lps'),
	(398670, 123, '2015-02-15 00:17:40.000000', 'consum', 0.0218, 'lps'),
	(398671, 123, '2015-02-15 00:17:41.000000', 'consum', 0.0211, 'lps'),
	(398672, 123, '2015-02-15 00:17:42.000000', 'consum', 0.0214, 'lps'),
	(398673, 123, '2015-02-15 00:17:43.000000', 'consum', 0.0215, 'lps'),
	(398674, 123, '2015-02-15 00:17:44.000000', 'consum', 0.0212, 'lps'),
	(398675, 123, '2015-02-15 00:17:45.000000', 'consum', 0.0218, 'lps'),
	(398676, 123, '2015-02-15 00:17:46.000000', 'consum', 0.0220, 'lps'),
	(398677, 123, '2015-02-15 00:17:47.000000', 'consum', 0.0216, 'lps'),
	(398678, 123, '2015-02-15 00:17:48.000000', 'consum', 0.0220, 'lps'),
	(398679, 123, '2015-02-15 00:17:49.000000', 'consum', 0.0210, 'lps'),
	(398680, 123, '2015-02-15 00:17:50.000000', 'consum', 0.0213, 'lps'),
	(398681, 123, '2015-02-15 00:17:51.000000', 'consum', 0.0214, 'lps'),
	(398682, 123, '2015-02-15 00:17:52.000000', 'consum', 0.0210, 'lps'),
	(398683, 123, '2015-02-15 00:17:53.000000', 'consum', 0.0211, 'lps'),
	(398684, 123, '2015-02-15 00:17:54.000000', 'consum', 0.0214, 'lps'),
	(398685, 123, '2015-02-15 00:17:55.000000', 'consum', 0.0216, 'lps'),
	(398686, 123, '2015-02-15 00:17:56.000000', 'consum', 0.0219, 'lps'),
	(398687, 123, '2015-02-15 00:17:57.000000', 'consum', 0.0214, 'lps'),
	(398688, 123, '2015-02-15 00:17:58.000000', 'consum', 0.0217, 'lps'),
	(398689, 123, '2015-02-15 00:17:59.000000', 'consum', 0.0220, 'lps'),
	(398690, 123, '2015-02-15 00:18:00.000000', 'consum', 0.0218, 'lps'),
	(398691, 123, '2015-02-15 00:18:01.000000', 'consum', 0.0220, 'lps'),
	(398692, 123, '2015-02-15 00:18:02.000000', 'consum', 0.0214, 'lps'),
	(398693, 123, '2015-02-15 00:18:03.000000', 'consum', 0.0214, 'lps'),
	(398694, 123, '2015-02-15 00:18:04.000000', 'consum', 0.0216, 'lps'),
	(398695, 123, '2015-02-15 00:18:05.000000', 'consum', 0.0219, 'lps'),
	(398696, 123, '2015-02-15 00:18:06.000000', 'consum', 0.0217, 'lps'),
	(398697, 123, '2015-02-15 00:18:07.000000', 'consum', 0.0216, 'lps'),
	(398698, 123, '2015-02-15 00:18:08.000000', 'consum', 0.0220, 'lps'),
	(398699, 123, '2015-02-15 00:18:09.000000', 'consum', 0.0210, 'lps'),
	(398700, 123, '2015-02-15 00:18:10.000000', 'consum', 0.0215, 'lps'),
	(398701, 123, '2015-02-15 00:18:11.000000', 'consum', 0.0212, 'lps'),
	(398702, 123, '2015-02-15 00:18:12.000000', 'consum', 0.0218, 'lps'),
	(398703, 123, '2015-02-15 00:18:13.000000', 'consum', 0.0211, 'lps'),
	(398704, 123, '2015-02-15 00:18:14.000000', 'consum', 0.0215, 'lps'),
	(398705, 123, '2015-02-15 00:18:15.000000', 'consum', 0.0220, 'lps'),
	(398706, 123, '2015-02-15 00:18:16.000000', 'consum', 0.0215, 'lps'),
	(398707, 123, '2015-02-15 00:18:17.000000', 'consum', 0.0214, 'lps'),
	(398708, 123, '2015-02-15 00:18:18.000000', 'consum', 0.0214, 'lps'),
	(398709, 123, '2015-02-15 00:18:19.000000', 'consum', 0.0220, 'lps'),
	(398710, 123, '2015-02-15 00:18:20.000000', 'consum', 0.0217, 'lps'),
	(398711, 123, '2015-02-15 00:18:21.000000', 'consum', 0.0216, 'lps'),
	(398712, 123, '2015-02-15 00:18:22.000000', 'consum', 0.0220, 'lps'),
	(398713, 123, '2015-02-15 00:18:23.000000', 'consum', 0.0210, 'lps'),
	(398714, 123, '2015-02-15 00:18:24.000000', 'consum', 0.0210, 'lps'),
	(398715, 123, '2015-02-15 00:18:25.000000', 'consum', 0.0213, 'lps'),
	(398716, 123, '2015-02-15 00:18:26.000000', 'consum', 0.0215, 'lps'),
	(398717, 123, '2015-02-15 00:18:27.000000', 'consum', 0.0215, 'lps'),
	(398718, 123, '2015-02-15 00:18:28.000000', 'consum', 0.0210, 'lps'),
	(398719, 123, '2015-02-15 00:18:29.000000', 'consum', 0.0218, 'lps'),
	(398720, 123, '2015-02-15 00:18:30.000000', 'consum', 0.0216, 'lps'),
	(398721, 123, '2015-02-15 00:18:31.000000', 'consum', 0.0216, 'lps'),
	(398722, 123, '2015-02-15 00:18:32.000000', 'consum', 0.0212, 'lps'),
	(398723, 123, '2015-02-15 00:18:33.000000', 'consum', 0.0215, 'lps'),
	(398724, 123, '2015-02-15 00:18:34.000000', 'consum', 0.0218, 'lps'),
	(398725, 123, '2015-02-15 00:18:35.000000', 'consum', 0.0214, 'lps'),
	(398726, 123, '2015-02-15 00:18:36.000000', 'consum', 0.0217, 'lps'),
	(398727, 123, '2015-02-15 00:18:37.000000', 'consum', 0.0213, 'lps'),
	(398728, 123, '2015-02-15 00:18:38.000000', 'consum', 0.0214, 'lps'),
	(398729, 123, '2015-02-15 00:18:39.000000', 'consum', 0.0213, 'lps'),
	(398730, 123, '2015-02-15 00:18:40.000000', 'consum', 0.0211, 'lps'),
	(398731, 123, '2015-02-15 00:18:41.000000', 'consum', 0.0217, 'lps'),
	(398732, 123, '2015-02-15 00:18:42.000000', 'consum', 0.0220, 'lps'),
	(398733, 123, '2015-02-15 00:18:43.000000', 'consum', 0.0220, 'lps'),
	(398734, 123, '2015-02-15 00:18:44.000000', 'consum', 0.0219, 'lps'),
	(398735, 123, '2015-02-15 00:18:45.000000', 'consum', 0.0215, 'lps'),
	(398736, 123, '2015-02-15 00:18:46.000000', 'consum', 0.0220, 'lps'),
	(398737, 123, '2015-02-15 00:18:47.000000', 'consum', 0.0212, 'lps'),
	(398738, 123, '2015-02-15 00:18:48.000000', 'consum', 0.0213, 'lps'),
	(398739, 123, '2015-02-15 00:18:49.000000', 'consum', 0.0210, 'lps'),
	(398740, 123, '2015-02-15 00:18:50.000000', 'consum', 0.0220, 'lps'),
	(398741, 123, '2015-02-15 00:18:51.000000', 'consum', 0.0218, 'lps'),
	(398742, 123, '2015-02-15 00:18:52.000000', 'consum', 0.0220, 'lps'),
	(398743, 123, '2015-02-15 00:18:53.000000', 'consum', 0.0217, 'lps'),
	(398744, 123, '2015-02-15 00:18:54.000000', 'consum', 0.0212, 'lps'),
	(398745, 123, '2015-02-15 00:18:55.000000', 'consum', 0.0212, 'lps'),
	(398746, 123, '2015-02-15 00:18:56.000000', 'consum', 0.0214, 'lps'),
	(398747, 123, '2015-02-15 00:18:57.000000', 'consum', 0.0216, 'lps'),
	(398748, 123, '2015-02-15 00:18:58.000000', 'consum', 0.0215, 'lps'),
	(398749, 123, '2015-02-15 00:18:59.000000', 'consum', 0.0217, 'lps'),
	(398750, 123, '2015-02-15 00:19:00.000000', 'consum', 0.0220, 'lps'),
	(398751, 123, '2015-02-15 00:19:01.000000', 'consum', 0.0216, 'lps'),
	(398752, 123, '2015-02-15 00:19:02.000000', 'consum', 0.0211, 'lps'),
	(398753, 123, '2015-02-15 00:19:03.000000', 'consum', 0.0220, 'lps'),
	(398754, 123, '2015-02-15 00:19:04.000000', 'consum', 0.0213, 'lps'),
	(398755, 123, '2015-02-15 00:19:05.000000', 'consum', 0.0217, 'lps'),
	(398756, 123, '2015-02-15 00:19:06.000000', 'consum', 0.0214, 'lps'),
	(398757, 123, '2015-02-15 00:19:07.000000', 'consum', 0.0212, 'lps'),
	(398758, 123, '2015-02-15 00:19:08.000000', 'consum', 0.0219, 'lps'),
	(398759, 123, '2015-02-15 00:19:09.000000', 'consum', 0.0215, 'lps'),
	(398760, 123, '2015-02-15 00:19:10.000000', 'consum', 0.0219, 'lps'),
	(398761, 123, '2015-02-15 00:19:11.000000', 'consum', 0.0218, 'lps'),
	(398762, 123, '2015-02-15 00:19:12.000000', 'consum', 0.0215, 'lps'),
	(398763, 123, '2015-02-15 00:19:13.000000', 'consum', 0.0220, 'lps'),
	(398764, 123, '2015-02-15 00:19:14.000000', 'consum', 0.0213, 'lps'),
	(398765, 123, '2015-02-15 00:19:15.000000', 'consum', 0.0220, 'lps'),
	(398766, 123, '2015-02-15 00:19:16.000000', 'consum', 0.0216, 'lps'),
	(398767, 123, '2015-02-15 00:19:17.000000', 'consum', 0.0210, 'lps'),
	(398768, 123, '2015-02-15 00:19:18.000000', 'consum', 0.0214, 'lps'),
	(398769, 123, '2015-02-15 00:19:19.000000', 'consum', 0.0220, 'lps'),
	(398770, 123, '2015-02-15 00:19:20.000000', 'consum', 0.0217, 'lps'),
	(398771, 123, '2015-02-15 00:19:21.000000', 'consum', 0.0216, 'lps'),
	(398772, 123, '2015-02-15 00:19:22.000000', 'consum', 0.0219, 'lps'),
	(398773, 123, '2015-02-15 00:19:23.000000', 'consum', 0.0214, 'lps'),
	(398774, 123, '2015-02-15 00:19:24.000000', 'consum', 0.0214, 'lps'),
	(398775, 123, '2015-02-15 00:19:25.000000', 'consum', 0.0220, 'lps'),
	(398776, 123, '2015-02-15 00:19:26.000000', 'consum', 0.0216, 'lps'),
	(398777, 123, '2015-02-15 00:19:27.000000', 'consum', 0.0210, 'lps'),
	(398778, 123, '2015-02-15 00:19:28.000000', 'consum', 0.0214, 'lps'),
	(398779, 123, '2015-02-15 00:19:29.000000', 'consum', 0.0211, 'lps'),
	(398780, 123, '2015-02-15 00:19:30.000000', 'consum', 0.0213, 'lps'),
	(398781, 123, '2015-02-15 00:19:31.000000', 'consum', 0.0210, 'lps'),
	(398782, 123, '2015-02-15 00:19:32.000000', 'consum', 0.0213, 'lps'),
	(398783, 123, '2015-02-15 00:19:33.000000', 'consum', 0.0213, 'lps'),
	(398784, 123, '2015-02-15 00:19:34.000000', 'consum', 0.0218, 'lps'),
	(398785, 123, '2015-02-15 00:19:35.000000', 'consum', 0.0219, 'lps'),
	(398786, 123, '2015-02-15 00:19:36.000000', 'consum', 0.0220, 'lps'),
	(398787, 123, '2015-02-15 00:19:37.000000', 'consum', 0.0212, 'lps'),
	(398788, 123, '2015-02-15 00:19:38.000000', 'consum', 0.0213, 'lps'),
	(398789, 123, '2015-02-15 00:19:39.000000', 'consum', 0.0219, 'lps'),
	(398790, 123, '2015-02-15 00:19:40.000000', 'consum', 0.0215, 'lps'),
	(398791, 123, '2015-02-15 00:19:41.000000', 'consum', 0.0218, 'lps'),
	(398792, 123, '2015-02-15 00:19:42.000000', 'consum', 0.0214, 'lps'),
	(398793, 123, '2015-02-15 00:19:43.000000', 'consum', 0.0218, 'lps'),
	(398794, 123, '2015-02-15 00:19:44.000000', 'consum', 0.0216, 'lps'),
	(398795, 123, '2015-02-15 00:19:45.000000', 'consum', 0.0218, 'lps'),
	(398796, 123, '2015-02-15 00:19:46.000000', 'consum', 0.0211, 'lps'),
	(398797, 123, '2015-02-15 00:19:47.000000', 'consum', 0.0213, 'lps'),
	(398798, 123, '2015-02-15 00:19:48.000000', 'consum', 0.0210, 'lps'),
	(398799, 123, '2015-02-15 00:19:49.000000', 'consum', 0.0211, 'lps'),
	(398800, 123, '2015-02-15 00:19:50.000000', 'consum', 0.0218, 'lps'),
	(398801, 123, '2015-02-15 00:19:51.000000', 'consum', 0.0213, 'lps'),
	(398802, 123, '2015-02-15 00:19:52.000000', 'consum', 0.0214, 'lps'),
	(398803, 123, '2015-02-15 00:19:53.000000', 'consum', 0.0210, 'lps'),
	(398804, 123, '2015-02-15 00:19:54.000000', 'consum', 0.0220, 'lps'),
	(398805, 123, '2015-02-15 00:19:55.000000', 'consum', 0.0215, 'lps'),
	(398806, 123, '2015-02-15 00:19:56.000000', 'consum', 0.0218, 'lps'),
	(398807, 123, '2015-02-15 00:19:57.000000', 'consum', 0.0213, 'lps'),
	(398808, 123, '2015-02-15 00:19:58.000000', 'consum', 0.0212, 'lps'),
	(398809, 123, '2015-02-15 00:19:59.000000', 'consum', 0.0213, 'lps'),
	(398810, 123, '2015-02-15 00:20:00.000000', 'consum', 0.0219, 'lps'),
	(398811, 123, '2015-02-15 00:20:01.000000', 'consum', 0.0214, 'lps'),
	(398812, 123, '2015-02-15 00:20:02.000000', 'consum', 0.0214, 'lps'),
	(398813, 123, '2015-02-15 00:20:03.000000', 'consum', 0.0217, 'lps'),
	(398814, 123, '2015-02-15 00:20:04.000000', 'consum', 0.0211, 'lps'),
	(398815, 123, '2015-02-15 00:20:05.000000', 'consum', 0.0218, 'lps'),
	(398816, 123, '2015-02-15 00:20:06.000000', 'consum', 0.0216, 'lps'),
	(398817, 123, '2015-02-15 00:20:07.000000', 'consum', 0.0214, 'lps'),
	(398818, 123, '2015-02-15 00:20:08.000000', 'consum', 0.0215, 'lps'),
	(398819, 123, '2015-02-15 00:20:09.000000', 'consum', 0.0210, 'lps'),
	(398820, 123, '2015-02-15 00:20:10.000000', 'consum', 0.0217, 'lps'),
	(398821, 123, '2015-02-15 00:20:11.000000', 'consum', 0.0214, 'lps'),
	(398822, 123, '2015-02-15 00:20:12.000000', 'consum', 0.0220, 'lps'),
	(398823, 123, '2015-02-15 00:20:13.000000', 'consum', 0.0216, 'lps'),
	(398824, 123, '2015-02-15 00:20:14.000000', 'consum', 0.0212, 'lps'),
	(398825, 123, '2015-02-15 00:20:15.000000', 'consum', 0.0212, 'lps'),
	(398826, 123, '2015-02-15 00:20:16.000000', 'consum', 0.0216, 'lps'),
	(398827, 123, '2015-02-15 00:20:17.000000', 'consum', 0.0213, 'lps'),
	(398828, 123, '2015-02-15 00:20:18.000000', 'consum', 0.0219, 'lps'),
	(398829, 123, '2015-02-15 00:20:19.000000', 'consum', 0.0210, 'lps'),
	(398830, 123, '2015-02-15 00:20:20.000000', 'consum', 0.0220, 'lps'),
	(398831, 123, '2015-02-15 00:20:21.000000', 'consum', 0.0215, 'lps'),
	(398832, 123, '2015-02-15 00:20:22.000000', 'consum', 0.0217, 'lps'),
	(398833, 123, '2015-02-15 00:20:23.000000', 'consum', 0.0210, 'lps'),
	(398834, 123, '2015-02-15 00:20:24.000000', 'consum', 0.0220, 'lps'),
	(398835, 123, '2015-02-15 00:20:25.000000', 'consum', 0.0218, 'lps'),
	(398836, 123, '2015-02-15 00:20:26.000000', 'consum', 0.0219, 'lps'),
	(398837, 123, '2015-02-15 00:20:27.000000', 'consum', 0.0211, 'lps'),
	(398838, 123, '2015-02-15 00:20:28.000000', 'consum', 0.0211, 'lps'),
	(398839, 123, '2015-02-15 00:20:29.000000', 'consum', 0.0210, 'lps'),
	(398840, 123, '2015-02-15 00:20:30.000000', 'consum', 0.0219, 'lps'),
	(398841, 123, '2015-02-15 00:20:31.000000', 'consum', 0.0210, 'lps'),
	(398842, 123, '2015-02-15 00:20:32.000000', 'consum', 0.0219, 'lps'),
	(398843, 123, '2015-02-15 00:20:33.000000', 'consum', 0.0210, 'lps'),
	(398844, 123, '2015-02-15 00:20:34.000000', 'consum', 0.0216, 'lps'),
	(398845, 123, '2015-02-15 00:20:35.000000', 'consum', 0.0220, 'lps'),
	(398846, 123, '2015-02-15 00:20:36.000000', 'consum', 0.0218, 'lps'),
	(398847, 123, '2015-02-15 00:20:37.000000', 'consum', 0.0212, 'lps'),
	(398848, 123, '2015-02-15 00:20:38.000000', 'consum', 0.0218, 'lps'),
	(398849, 123, '2015-02-15 00:20:39.000000', 'consum', 0.0212, 'lps'),
	(398850, 123, '2015-02-15 00:20:40.000000', 'consum', 0.0218, 'lps'),
	(398851, 123, '2015-02-15 00:20:41.000000', 'consum', 0.0211, 'lps'),
	(398852, 123, '2015-02-15 00:20:42.000000', 'consum', 0.0214, 'lps'),
	(398853, 123, '2015-02-15 00:20:43.000000', 'consum', 0.0216, 'lps'),
	(398854, 123, '2015-02-15 00:20:44.000000', 'consum', 0.0218, 'lps'),
	(398855, 123, '2015-02-15 00:20:45.000000', 'consum', 0.0212, 'lps'),
	(398856, 123, '2015-02-15 00:20:46.000000', 'consum', 0.0216, 'lps'),
	(398857, 123, '2015-02-15 00:20:47.000000', 'consum', 0.0212, 'lps'),
	(398858, 123, '2015-02-15 00:20:48.000000', 'consum', 0.0214, 'lps'),
	(398859, 123, '2015-02-15 00:20:49.000000', 'consum', 0.0214, 'lps'),
	(398860, 123, '2015-02-15 00:20:50.000000', 'consum', 0.0218, 'lps'),
	(398861, 123, '2015-02-15 00:20:51.000000', 'consum', 0.0218, 'lps'),
	(398862, 123, '2015-02-15 00:20:52.000000', 'consum', 0.0214, 'lps'),
	(398863, 123, '2015-02-15 00:20:53.000000', 'consum', 0.0219, 'lps'),
	(398864, 123, '2015-02-15 00:20:54.000000', 'consum', 0.0211, 'lps'),
	(398865, 123, '2015-02-15 00:20:55.000000', 'consum', 0.0210, 'lps'),
	(398866, 123, '2015-02-15 00:20:56.000000', 'consum', 0.0219, 'lps'),
	(398867, 123, '2015-02-15 00:20:57.000000', 'consum', 0.0210, 'lps'),
	(398868, 123, '2015-02-15 00:20:58.000000', 'consum', 0.0218, 'lps'),
	(398869, 123, '2015-02-15 00:20:59.000000', 'consum', 0.0219, 'lps'),
	(398870, 123, '2015-02-15 00:21:00.000000', 'consum', 0.0219, 'lps'),
	(398871, 123, '2015-02-15 00:21:01.000000', 'consum', 0.0216, 'lps'),
	(398872, 123, '2015-02-15 00:21:02.000000', 'consum', 0.0215, 'lps'),
	(398873, 123, '2015-02-15 00:21:03.000000', 'consum', 0.0216, 'lps'),
	(398874, 123, '2015-02-15 00:21:04.000000', 'consum', 0.0216, 'lps'),
	(398875, 123, '2015-02-15 00:21:05.000000', 'consum', 0.0220, 'lps'),
	(398876, 123, '2015-02-15 00:21:06.000000', 'consum', 0.0213, 'lps'),
	(398877, 123, '2015-02-15 00:21:07.000000', 'consum', 0.0214, 'lps'),
	(398878, 123, '2015-02-15 00:21:08.000000', 'consum', 0.0214, 'lps'),
	(398879, 123, '2015-02-15 00:21:09.000000', 'consum', 0.0217, 'lps'),
	(398880, 123, '2015-02-15 00:21:10.000000', 'consum', 0.0212, 'lps'),
	(398881, 123, '2015-02-15 00:21:11.000000', 'consum', 0.0220, 'lps'),
	(398882, 123, '2015-02-15 00:21:12.000000', 'consum', 0.0212, 'lps'),
	(398883, 123, '2015-02-15 00:21:13.000000', 'consum', 0.0213, 'lps'),
	(398884, 123, '2015-02-15 00:21:14.000000', 'consum', 0.0219, 'lps'),
	(398885, 123, '2015-02-15 00:21:15.000000', 'consum', 0.0213, 'lps'),
	(398886, 123, '2015-02-15 00:21:16.000000', 'consum', 0.0219, 'lps'),
	(398887, 123, '2015-02-15 00:21:17.000000', 'consum', 0.0216, 'lps'),
	(398888, 123, '2015-02-15 00:21:18.000000', 'consum', 0.0214, 'lps'),
	(398889, 123, '2015-02-15 00:21:19.000000', 'consum', 0.0210, 'lps'),
	(398890, 123, '2015-02-15 00:21:20.000000', 'consum', 0.0210, 'lps'),
	(398891, 123, '2015-02-15 00:21:21.000000', 'consum', 0.0220, 'lps'),
	(398892, 123, '2015-02-15 00:21:22.000000', 'consum', 0.0219, 'lps'),
	(398893, 123, '2015-02-15 00:21:23.000000', 'consum', 0.0213, 'lps'),
	(398894, 123, '2015-02-15 00:21:24.000000', 'consum', 0.0211, 'lps'),
	(398895, 123, '2015-02-15 00:21:25.000000', 'consum', 0.0216, 'lps'),
	(398896, 123, '2015-02-15 00:21:26.000000', 'consum', 0.0215, 'lps'),
	(398897, 123, '2015-02-15 00:21:27.000000', 'consum', 0.0217, 'lps'),
	(398898, 123, '2015-02-15 00:21:28.000000', 'consum', 0.0220, 'lps'),
	(398899, 123, '2015-02-15 00:21:29.000000', 'consum', 0.0217, 'lps'),
	(398900, 123, '2015-02-15 00:21:30.000000', 'consum', 0.0215, 'lps'),
	(398901, 123, '2015-02-15 00:21:31.000000', 'consum', 0.0215, 'lps'),
	(398902, 123, '2015-02-15 00:21:32.000000', 'consum', 0.0219, 'lps'),
	(398903, 123, '2015-02-15 00:21:33.000000', 'consum', 0.0210, 'lps'),
	(398904, 123, '2015-02-15 00:21:34.000000', 'consum', 0.0217, 'lps'),
	(398905, 123, '2015-02-15 00:21:35.000000', 'consum', 0.0220, 'lps'),
	(398906, 123, '2015-02-15 00:21:36.000000', 'consum', 0.0210, 'lps'),
	(398907, 123, '2015-02-15 00:21:37.000000', 'consum', 0.0212, 'lps'),
	(398908, 123, '2015-02-15 00:21:38.000000', 'consum', 0.0211, 'lps'),
	(398909, 123, '2015-02-15 00:21:39.000000', 'consum', 0.0219, 'lps'),
	(398910, 123, '2015-02-15 00:21:40.000000', 'consum', 0.0220, 'lps'),
	(398911, 123, '2015-02-15 00:21:41.000000', 'consum', 0.0213, 'lps'),
	(398912, 123, '2015-02-15 00:21:42.000000', 'consum', 0.0216, 'lps'),
	(398913, 123, '2015-02-15 00:21:43.000000', 'consum', 0.0211, 'lps'),
	(398914, 123, '2015-02-15 00:21:44.000000', 'consum', 0.0220, 'lps'),
	(398915, 123, '2015-02-15 00:21:45.000000', 'consum', 0.0211, 'lps'),
	(398916, 123, '2015-02-15 00:21:46.000000', 'consum', 0.0220, 'lps'),
	(398917, 123, '2015-02-15 00:21:47.000000', 'consum', 0.0214, 'lps'),
	(398918, 123, '2015-02-15 00:21:48.000000', 'consum', 0.0212, 'lps'),
	(398919, 123, '2015-02-15 00:21:49.000000', 'consum', 0.0220, 'lps'),
	(398920, 123, '2015-02-15 00:21:50.000000', 'consum', 0.0219, 'lps'),
	(398921, 123, '2015-02-15 00:21:51.000000', 'consum', 0.0215, 'lps'),
	(398922, 123, '2015-02-15 00:21:52.000000', 'consum', 0.0220, 'lps'),
	(398923, 123, '2015-02-15 00:21:53.000000', 'consum', 0.0212, 'lps'),
	(398924, 123, '2015-02-15 00:21:54.000000', 'consum', 0.0212, 'lps'),
	(398925, 123, '2015-02-15 00:21:55.000000', 'consum', 0.0216, 'lps'),
	(398926, 123, '2015-02-15 00:21:56.000000', 'consum', 0.0212, 'lps'),
	(398927, 123, '2015-02-15 00:21:57.000000', 'consum', 0.0213, 'lps'),
	(398928, 123, '2015-02-15 00:21:58.000000', 'consum', 0.0220, 'lps'),
	(398929, 123, '2015-02-15 00:21:59.000000', 'consum', 0.0220, 'lps'),
	(398930, 123, '2015-02-15 00:22:00.000000', 'consum', 0.0219, 'lps'),
	(398931, 123, '2015-02-15 00:22:01.000000', 'consum', 0.0213, 'lps'),
	(398932, 123, '2015-02-15 00:22:02.000000', 'consum', 0.0210, 'lps'),
	(398933, 123, '2015-02-15 00:22:03.000000', 'consum', 0.0211, 'lps'),
	(398934, 123, '2015-02-15 00:22:04.000000', 'consum', 0.0217, 'lps'),
	(398935, 123, '2015-02-15 00:22:05.000000', 'consum', 0.0210, 'lps'),
	(398936, 123, '2015-02-15 00:22:06.000000', 'consum', 0.0210, 'lps'),
	(398937, 123, '2015-02-15 00:22:07.000000', 'consum', 0.0210, 'lps'),
	(398938, 123, '2015-02-15 00:22:08.000000', 'consum', 0.0211, 'lps'),
	(398939, 123, '2015-02-15 00:22:09.000000', 'consum', 0.0214, 'lps'),
	(398940, 123, '2015-02-15 00:22:10.000000', 'consum', 0.0218, 'lps'),
	(398941, 123, '2015-02-15 00:22:11.000000', 'consum', 0.0215, 'lps'),
	(398942, 123, '2015-02-15 00:22:12.000000', 'consum', 0.0213, 'lps'),
	(398943, 123, '2015-02-15 00:22:13.000000', 'consum', 0.0211, 'lps'),
	(398944, 123, '2015-02-15 00:22:14.000000', 'consum', 0.0217, 'lps'),
	(398945, 123, '2015-02-15 00:22:15.000000', 'consum', 0.0211, 'lps'),
	(398946, 123, '2015-02-15 00:22:16.000000', 'consum', 0.0216, 'lps'),
	(398947, 123, '2015-02-15 00:22:17.000000', 'consum', 0.0215, 'lps'),
	(398948, 123, '2015-02-15 00:22:18.000000', 'consum', 0.0220, 'lps'),
	(398949, 123, '2015-02-15 00:22:19.000000', 'consum', 0.0220, 'lps'),
	(398950, 123, '2015-02-15 00:22:20.000000', 'consum', 0.0210, 'lps'),
	(398951, 123, '2015-02-15 00:22:21.000000', 'consum', 0.0213, 'lps'),
	(398952, 123, '2015-02-15 00:22:22.000000', 'consum', 0.0216, 'lps'),
	(398953, 123, '2015-02-15 00:22:23.000000', 'consum', 0.0220, 'lps'),
	(398954, 123, '2015-02-15 00:22:24.000000', 'consum', 0.0219, 'lps'),
	(398955, 123, '2015-02-15 00:22:25.000000', 'consum', 0.0215, 'lps'),
	(398956, 123, '2015-02-15 00:22:26.000000', 'consum', 0.0220, 'lps'),
	(398957, 123, '2015-02-15 00:22:27.000000', 'consum', 0.0211, 'lps'),
	(398958, 123, '2015-02-15 00:22:28.000000', 'consum', 0.0210, 'lps'),
	(398959, 123, '2015-02-15 00:22:29.000000', 'consum', 0.0216, 'lps'),
	(398960, 123, '2015-02-15 00:22:30.000000', 'consum', 0.0220, 'lps'),
	(398961, 123, '2015-02-15 00:22:31.000000', 'consum', 0.0218, 'lps'),
	(398962, 123, '2015-02-15 00:22:32.000000', 'consum', 0.0213, 'lps'),
	(398963, 123, '2015-02-15 00:22:33.000000', 'consum', 0.0211, 'lps'),
	(398964, 123, '2015-02-15 00:22:34.000000', 'consum', 0.0215, 'lps'),
	(398965, 123, '2015-02-15 00:22:35.000000', 'consum', 0.0214, 'lps'),
	(398966, 123, '2015-02-15 00:22:36.000000', 'consum', 0.0216, 'lps'),
	(398967, 123, '2015-02-15 00:22:37.000000', 'consum', 0.0215, 'lps'),
	(398968, 123, '2015-02-15 00:22:38.000000', 'consum', 0.0219, 'lps'),
	(398969, 123, '2015-02-15 00:22:39.000000', 'consum', 0.0219, 'lps'),
	(398970, 123, '2015-02-15 00:22:40.000000', 'consum', 0.0217, 'lps'),
	(398971, 123, '2015-02-15 00:22:41.000000', 'consum', 0.0219, 'lps'),
	(398972, 123, '2015-02-15 00:22:42.000000', 'consum', 0.0213, 'lps'),
	(398973, 123, '2015-02-15 00:22:43.000000', 'consum', 0.0220, 'lps'),
	(398974, 123, '2015-02-15 00:22:44.000000', 'consum', 0.0217, 'lps'),
	(398975, 123, '2015-02-15 00:22:45.000000', 'consum', 0.0218, 'lps'),
	(398976, 123, '2015-02-15 00:22:46.000000', 'consum', 0.0218, 'lps'),
	(398977, 123, '2015-02-15 00:22:47.000000', 'consum', 0.0215, 'lps'),
	(398978, 123, '2015-02-15 00:22:48.000000', 'consum', 0.0210, 'lps'),
	(398979, 123, '2015-02-15 00:22:49.000000', 'consum', 0.0217, 'lps'),
	(398980, 123, '2015-02-15 00:22:50.000000', 'consum', 0.0212, 'lps'),
	(398981, 123, '2015-02-15 00:22:51.000000', 'consum', 0.0211, 'lps'),
	(398982, 123, '2015-02-15 00:22:52.000000', 'consum', 0.0212, 'lps'),
	(398983, 123, '2015-02-15 00:22:53.000000', 'consum', 0.0214, 'lps'),
	(398984, 123, '2015-02-15 00:22:54.000000', 'consum', 0.0216, 'lps'),
	(398985, 123, '2015-02-15 00:22:55.000000', 'consum', 0.0219, 'lps'),
	(398986, 123, '2015-02-15 00:22:56.000000', 'consum', 0.0213, 'lps'),
	(398987, 123, '2015-02-15 00:22:57.000000', 'consum', 0.0212, 'lps'),
	(398988, 123, '2015-02-15 00:22:58.000000', 'consum', 0.0211, 'lps'),
	(398989, 123, '2015-02-15 00:22:59.000000', 'consum', 0.0219, 'lps'),
	(398990, 123, '2015-02-15 00:23:00.000000', 'consum', 0.0210, 'lps'),
	(398991, 123, '2015-02-15 00:23:01.000000', 'consum', 0.0215, 'lps'),
	(398992, 123, '2015-02-15 00:23:02.000000', 'consum', 0.0216, 'lps'),
	(398993, 123, '2015-02-15 00:23:03.000000', 'consum', 0.0214, 'lps'),
	(398994, 123, '2015-02-15 00:23:04.000000', 'consum', 0.0211, 'lps'),
	(398995, 123, '2015-02-15 00:23:05.000000', 'consum', 0.0214, 'lps'),
	(398996, 123, '2015-02-15 00:23:06.000000', 'consum', 0.0216, 'lps'),
	(398997, 123, '2015-02-15 00:23:07.000000', 'consum', 0.0219, 'lps'),
	(398998, 123, '2015-02-15 00:23:08.000000', 'consum', 0.0216, 'lps'),
	(398999, 123, '2015-02-15 00:23:09.000000', 'consum', 0.0215, 'lps'),
	(399000, 123, '2015-02-15 00:23:10.000000', 'consum', 0.0214, 'lps'),
	(399001, 123, '2015-02-15 00:23:11.000000', 'consum', 0.0217, 'lps'),
	(399002, 123, '2015-02-15 00:23:12.000000', 'consum', 0.0212, 'lps'),
	(399003, 123, '2015-02-15 00:23:13.000000', 'consum', 0.0220, 'lps'),
	(399004, 123, '2015-02-15 00:23:14.000000', 'consum', 0.0213, 'lps'),
	(399005, 123, '2015-02-15 00:23:15.000000', 'consum', 0.0216, 'lps'),
	(399006, 123, '2015-02-15 00:23:16.000000', 'consum', 0.0212, 'lps'),
	(399007, 123, '2015-02-15 00:23:17.000000', 'consum', 0.0211, 'lps'),
	(399008, 123, '2015-02-15 00:23:18.000000', 'consum', 0.0220, 'lps'),
	(399009, 123, '2015-02-15 00:23:19.000000', 'consum', 0.0212, 'lps'),
	(399010, 123, '2015-02-15 00:23:20.000000', 'consum', 0.0215, 'lps'),
	(399011, 123, '2015-02-15 00:23:21.000000', 'consum', 0.0217, 'lps'),
	(399012, 123, '2015-02-15 00:23:22.000000', 'consum', 0.0220, 'lps'),
	(399013, 123, '2015-02-15 00:23:23.000000', 'consum', 0.0216, 'lps'),
	(399014, 123, '2015-02-15 00:23:24.000000', 'consum', 0.0212, 'lps'),
	(399015, 123, '2015-02-15 00:23:25.000000', 'consum', 0.0213, 'lps'),
	(399016, 123, '2015-02-15 00:23:26.000000', 'consum', 0.0210, 'lps'),
	(399017, 123, '2015-02-15 00:23:27.000000', 'consum', 0.0212, 'lps'),
	(399018, 123, '2015-02-15 00:23:28.000000', 'consum', 0.0218, 'lps'),
	(399019, 123, '2015-02-15 00:23:29.000000', 'consum', 0.0214, 'lps'),
	(399020, 123, '2015-02-15 00:23:30.000000', 'consum', 0.0217, 'lps'),
	(399021, 123, '2015-02-15 00:23:31.000000', 'consum', 0.0211, 'lps'),
	(399022, 123, '2015-02-15 00:23:32.000000', 'consum', 0.0218, 'lps'),
	(399023, 123, '2015-02-15 00:23:33.000000', 'consum', 0.0214, 'lps'),
	(399024, 123, '2015-02-15 00:23:34.000000', 'consum', 0.0219, 'lps'),
	(399025, 123, '2015-02-15 00:23:35.000000', 'consum', 0.0220, 'lps'),
	(399026, 123, '2015-02-15 00:23:36.000000', 'consum', 0.0210, 'lps'),
	(399027, 123, '2015-02-15 00:23:37.000000', 'consum', 0.0215, 'lps'),
	(399028, 123, '2015-02-15 00:23:38.000000', 'consum', 0.0212, 'lps'),
	(399029, 123, '2015-02-15 00:23:39.000000', 'consum', 0.0219, 'lps'),
	(399030, 123, '2015-02-15 00:23:40.000000', 'consum', 0.0216, 'lps'),
	(399031, 123, '2015-02-15 00:23:41.000000', 'consum', 0.0214, 'lps'),
	(399032, 123, '2015-02-15 00:23:42.000000', 'consum', 0.0211, 'lps'),
	(399033, 123, '2015-02-15 00:23:43.000000', 'consum', 0.0213, 'lps'),
	(399034, 123, '2015-02-15 00:23:44.000000', 'consum', 0.0213, 'lps'),
	(399035, 123, '2015-02-15 00:23:45.000000', 'consum', 0.0215, 'lps'),
	(399036, 123, '2015-02-15 00:23:46.000000', 'consum', 0.0219, 'lps'),
	(399037, 123, '2015-02-15 00:23:47.000000', 'consum', 0.0215, 'lps'),
	(399038, 123, '2015-02-15 00:23:48.000000', 'consum', 0.0220, 'lps'),
	(399039, 123, '2015-02-15 00:23:49.000000', 'consum', 0.0215, 'lps'),
	(399040, 123, '2015-02-15 00:23:50.000000', 'consum', 0.0215, 'lps'),
	(399041, 123, '2015-02-15 00:23:51.000000', 'consum', 0.0220, 'lps'),
	(399042, 123, '2015-02-15 00:23:52.000000', 'consum', 0.0215, 'lps'),
	(399043, 123, '2015-02-15 00:23:53.000000', 'consum', 0.0214, 'lps'),
	(399044, 123, '2015-02-15 00:23:54.000000', 'consum', 0.0218, 'lps'),
	(399045, 123, '2015-02-15 00:23:55.000000', 'consum', 0.0214, 'lps'),
	(399046, 123, '2015-02-15 00:23:56.000000', 'consum', 0.0217, 'lps'),
	(399047, 123, '2015-02-15 00:23:57.000000', 'consum', 0.0210, 'lps'),
	(399048, 123, '2015-02-15 00:23:58.000000', 'consum', 0.0215, 'lps'),
	(399049, 123, '2015-02-15 00:23:59.000000', 'consum', 0.0212, 'lps'),
	(399050, 123, '2015-02-15 00:24:00.000000', 'consum', 0.0215, 'lps'),
	(399051, 123, '2015-02-15 00:24:01.000000', 'consum', 0.0220, 'lps'),
	(399052, 123, '2015-02-15 00:24:02.000000', 'consum', 0.0212, 'lps'),
	(399053, 123, '2015-02-15 00:24:03.000000', 'consum', 0.0215, 'lps'),
	(399054, 123, '2015-02-15 00:24:04.000000', 'consum', 0.0215, 'lps'),
	(399055, 123, '2015-02-15 00:24:05.000000', 'consum', 0.0210, 'lps'),
	(399056, 123, '2015-02-15 00:24:06.000000', 'consum', 0.0219, 'lps'),
	(399057, 123, '2015-02-15 00:24:07.000000', 'consum', 0.0212, 'lps'),
	(399058, 123, '2015-02-15 00:24:08.000000', 'consum', 0.0213, 'lps'),
	(399059, 123, '2015-02-15 00:24:09.000000', 'consum', 0.0219, 'lps'),
	(399060, 123, '2015-02-15 00:24:10.000000', 'consum', 0.0215, 'lps'),
	(399061, 123, '2015-02-15 00:24:11.000000', 'consum', 0.0219, 'lps'),
	(399062, 123, '2015-02-15 00:24:12.000000', 'consum', 0.0219, 'lps'),
	(399063, 123, '2015-02-15 00:24:13.000000', 'consum', 0.0216, 'lps'),
	(399064, 123, '2015-02-15 00:24:14.000000', 'consum', 0.0215, 'lps'),
	(399065, 123, '2015-02-15 00:24:15.000000', 'consum', 0.0217, 'lps'),
	(399066, 123, '2015-02-15 00:24:16.000000', 'consum', 0.0219, 'lps'),
	(399067, 123, '2015-02-15 00:24:17.000000', 'consum', 0.0213, 'lps'),
	(399068, 123, '2015-02-15 00:24:18.000000', 'consum', 0.0210, 'lps'),
	(399069, 123, '2015-02-15 00:24:19.000000', 'consum', 0.0213, 'lps'),
	(399070, 123, '2015-02-15 00:24:20.000000', 'consum', 0.0212, 'lps'),
	(399071, 123, '2015-02-15 00:24:21.000000', 'consum', 0.0214, 'lps'),
	(399072, 123, '2015-02-15 00:24:22.000000', 'consum', 0.0213, 'lps'),
	(399073, 123, '2015-02-15 00:24:23.000000', 'consum', 0.0214, 'lps'),
	(399074, 123, '2015-02-15 00:24:24.000000', 'consum', 0.0219, 'lps'),
	(399075, 123, '2015-02-15 00:24:25.000000', 'consum', 0.0212, 'lps'),
	(399076, 123, '2015-02-15 00:24:26.000000', 'consum', 0.0214, 'lps'),
	(399077, 123, '2015-02-15 00:24:27.000000', 'consum', 0.0217, 'lps'),
	(399078, 123, '2015-02-15 00:24:28.000000', 'consum', 0.0219, 'lps'),
	(399079, 123, '2015-02-15 00:24:29.000000', 'consum', 0.0212, 'lps'),
	(399080, 123, '2015-02-15 00:24:30.000000', 'consum', 0.0218, 'lps'),
	(399081, 123, '2015-02-15 00:24:31.000000', 'consum', 0.0210, 'lps'),
	(399082, 123, '2015-02-15 00:24:32.000000', 'consum', 0.0210, 'lps'),
	(399083, 123, '2015-02-15 00:24:33.000000', 'consum', 0.0210, 'lps'),
	(399084, 123, '2015-02-15 00:24:34.000000', 'consum', 0.0220, 'lps'),
	(399085, 123, '2015-02-15 00:24:35.000000', 'consum', 0.0215, 'lps'),
	(399086, 123, '2015-02-15 00:24:36.000000', 'consum', 0.0220, 'lps'),
	(399087, 123, '2015-02-15 00:24:37.000000', 'consum', 0.0211, 'lps'),
	(399088, 123, '2015-02-15 00:24:38.000000', 'consum', 0.0220, 'lps'),
	(399089, 123, '2015-02-15 00:24:39.000000', 'consum', 0.0213, 'lps'),
	(399090, 123, '2015-02-15 00:24:40.000000', 'consum', 0.0217, 'lps'),
	(399091, 123, '2015-02-15 00:24:41.000000', 'consum', 0.0214, 'lps'),
	(399092, 123, '2015-02-15 00:24:42.000000', 'consum', 0.0211, 'lps'),
	(399093, 123, '2015-02-15 00:24:43.000000', 'consum', 0.0216, 'lps'),
	(399094, 123, '2015-02-15 00:24:44.000000', 'consum', 0.0213, 'lps'),
	(399095, 123, '2015-02-15 00:24:45.000000', 'consum', 0.0220, 'lps'),
	(399096, 123, '2015-02-15 00:24:46.000000', 'consum', 0.0218, 'lps'),
	(399097, 123, '2015-02-15 00:24:47.000000', 'consum', 0.0210, 'lps'),
	(399098, 123, '2015-02-15 00:24:48.000000', 'consum', 0.0210, 'lps'),
	(399099, 123, '2015-02-15 00:24:49.000000', 'consum', 0.0220, 'lps'),
	(399100, 123, '2015-02-15 00:24:50.000000', 'consum', 0.0216, 'lps'),
	(399101, 123, '2015-02-15 00:24:51.000000', 'consum', 0.0213, 'lps'),
	(399102, 123, '2015-02-15 00:24:52.000000', 'consum', 0.0217, 'lps'),
	(399103, 123, '2015-02-15 00:24:53.000000', 'consum', 0.0213, 'lps'),
	(399104, 123, '2015-02-15 00:24:54.000000', 'consum', 0.0218, 'lps'),
	(399105, 123, '2015-02-15 00:24:55.000000', 'consum', 0.0218, 'lps'),
	(399106, 123, '2015-02-15 00:24:56.000000', 'consum', 0.0217, 'lps'),
	(399107, 123, '2015-02-15 00:24:57.000000', 'consum', 0.0210, 'lps'),
	(399108, 123, '2015-02-15 00:24:58.000000', 'consum', 0.0211, 'lps'),
	(399109, 123, '2015-02-15 00:24:59.000000', 'consum', 0.0216, 'lps'),
	(399110, 123, '2015-02-15 00:25:00.000000', 'consum', 0.0217, 'lps'),
	(399111, 123, '2015-02-15 00:25:01.000000', 'consum', 0.0216, 'lps'),
	(399112, 123, '2015-02-15 00:25:02.000000', 'consum', 0.0220, 'lps'),
	(399113, 123, '2015-02-15 00:25:03.000000', 'consum', 0.0219, 'lps'),
	(399114, 123, '2015-02-15 00:25:04.000000', 'consum', 0.0213, 'lps'),
	(399115, 123, '2015-02-15 00:25:05.000000', 'consum', 0.0213, 'lps'),
	(399116, 123, '2015-02-15 00:25:06.000000', 'consum', 0.0214, 'lps'),
	(399117, 123, '2015-02-15 00:25:07.000000', 'consum', 0.0213, 'lps'),
	(399118, 123, '2015-02-15 00:25:08.000000', 'consum', 0.0212, 'lps'),
	(399119, 123, '2015-02-15 00:25:09.000000', 'consum', 0.0212, 'lps'),
	(399120, 123, '2015-02-15 00:25:10.000000', 'consum', 0.0214, 'lps'),
	(399121, 123, '2015-02-15 00:25:11.000000', 'consum', 0.0215, 'lps'),
	(399122, 123, '2015-02-15 00:25:12.000000', 'consum', 0.0211, 'lps'),
	(399123, 123, '2015-02-15 00:25:13.000000', 'consum', 0.0210, 'lps'),
	(399124, 123, '2015-02-15 00:25:14.000000', 'consum', 0.0220, 'lps'),
	(399125, 123, '2015-02-15 00:25:15.000000', 'consum', 0.0217, 'lps'),
	(399126, 123, '2015-02-15 00:25:16.000000', 'consum', 0.0213, 'lps'),
	(399127, 123, '2015-02-15 00:25:17.000000', 'consum', 0.0218, 'lps'),
	(399128, 123, '2015-02-15 00:25:18.000000', 'consum', 0.0217, 'lps'),
	(399129, 123, '2015-02-15 00:25:19.000000', 'consum', 0.0213, 'lps'),
	(399130, 123, '2015-02-15 00:25:20.000000', 'consum', 0.0217, 'lps'),
	(399131, 123, '2015-02-15 00:25:21.000000', 'consum', 0.0212, 'lps'),
	(399132, 123, '2015-02-15 00:25:22.000000', 'consum', 0.0210, 'lps'),
	(399133, 123, '2015-02-15 00:25:23.000000', 'consum', 0.0216, 'lps'),
	(399134, 123, '2015-02-15 00:25:24.000000', 'consum', 0.0220, 'lps'),
	(399135, 123, '2015-02-15 00:25:25.000000', 'consum', 0.0218, 'lps'),
	(399136, 123, '2015-02-15 00:25:26.000000', 'consum', 0.0210, 'lps'),
	(399137, 123, '2015-02-15 00:25:27.000000', 'consum', 0.0219, 'lps'),
	(399138, 123, '2015-02-15 00:25:28.000000', 'consum', 0.0212, 'lps'),
	(399139, 123, '2015-02-15 00:25:29.000000', 'consum', 0.0218, 'lps'),
	(399140, 123, '2015-02-15 00:25:30.000000', 'consum', 0.0219, 'lps'),
	(399141, 123, '2015-02-15 00:25:31.000000', 'consum', 0.0210, 'lps'),
	(399142, 123, '2015-02-15 00:25:32.000000', 'consum', 0.0219, 'lps'),
	(399143, 123, '2015-02-15 00:25:33.000000', 'consum', 0.0220, 'lps'),
	(399144, 123, '2015-02-15 00:25:34.000000', 'consum', 0.0214, 'lps'),
	(399145, 123, '2015-02-15 00:25:35.000000', 'consum', 0.0220, 'lps'),
	(399146, 123, '2015-02-15 00:25:36.000000', 'consum', 0.0215, 'lps'),
	(399147, 123, '2015-02-15 00:25:37.000000', 'consum', 0.0218, 'lps'),
	(399148, 123, '2015-02-15 00:25:38.000000', 'consum', 0.0211, 'lps'),
	(399149, 123, '2015-02-15 00:25:39.000000', 'consum', 0.0216, 'lps'),
	(399150, 123, '2015-02-15 00:25:40.000000', 'consum', 0.0215, 'lps'),
	(399151, 123, '2015-02-15 00:25:41.000000', 'consum', 0.0218, 'lps'),
	(399152, 123, '2015-02-15 00:25:42.000000', 'consum', 0.0213, 'lps'),
	(399153, 123, '2015-02-15 00:25:43.000000', 'consum', 0.0211, 'lps'),
	(399154, 123, '2015-02-15 00:25:44.000000', 'consum', 0.0217, 'lps'),
	(399155, 123, '2015-02-15 00:25:45.000000', 'consum', 0.0210, 'lps'),
	(399156, 123, '2015-02-15 00:25:46.000000', 'consum', 0.0211, 'lps'),
	(399157, 123, '2015-02-15 00:25:47.000000', 'consum', 0.0217, 'lps'),
	(399158, 123, '2015-02-15 00:25:48.000000', 'consum', 0.0211, 'lps'),
	(399159, 123, '2015-02-15 00:25:49.000000', 'consum', 0.0215, 'lps'),
	(399160, 123, '2015-02-15 00:25:50.000000', 'consum', 0.0211, 'lps'),
	(399161, 123, '2015-02-15 00:25:51.000000', 'consum', 0.0210, 'lps'),
	(399162, 123, '2015-02-15 00:25:52.000000', 'consum', 0.0220, 'lps'),
	(399163, 123, '2015-02-15 00:25:53.000000', 'consum', 0.0215, 'lps'),
	(399164, 123, '2015-02-15 00:25:54.000000', 'consum', 0.0219, 'lps'),
	(399165, 123, '2015-02-15 00:25:55.000000', 'consum', 0.0218, 'lps'),
	(399166, 123, '2015-02-15 00:25:56.000000', 'consum', 0.0212, 'lps'),
	(399167, 123, '2015-02-15 00:25:57.000000', 'consum', 0.0219, 'lps'),
	(399168, 123, '2015-02-15 00:25:58.000000', 'consum', 0.0214, 'lps'),
	(399169, 123, '2015-02-15 00:25:59.000000', 'consum', 0.0218, 'lps'),
	(399170, 123, '2015-02-15 00:26:00.000000', 'consum', 0.0214, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(399171, 123, '2015-02-15 00:26:01.000000', 'consum', 0.0219, 'lps'),
	(399172, 123, '2015-02-15 00:26:02.000000', 'consum', 0.0219, 'lps'),
	(399173, 123, '2015-02-15 00:26:03.000000', 'consum', 0.0219, 'lps'),
	(399174, 123, '2015-02-15 00:26:04.000000', 'consum', 0.0217, 'lps'),
	(399175, 123, '2015-02-15 00:26:05.000000', 'consum', 0.0218, 'lps'),
	(399176, 123, '2015-02-15 00:26:06.000000', 'consum', 0.0219, 'lps'),
	(399177, 123, '2015-02-15 00:26:07.000000', 'consum', 0.0220, 'lps'),
	(399178, 123, '2015-02-15 00:26:08.000000', 'consum', 0.0213, 'lps'),
	(399179, 123, '2015-02-15 00:26:09.000000', 'consum', 0.0215, 'lps'),
	(399180, 123, '2015-02-15 00:26:10.000000', 'consum', 0.0216, 'lps'),
	(399181, 123, '2015-02-15 00:26:11.000000', 'consum', 0.0216, 'lps'),
	(399182, 123, '2015-02-15 00:26:12.000000', 'consum', 0.0212, 'lps'),
	(399183, 123, '2015-02-15 00:26:13.000000', 'consum', 0.0211, 'lps'),
	(399184, 123, '2015-02-15 00:26:14.000000', 'consum', 0.0213, 'lps'),
	(399185, 123, '2015-02-15 00:26:15.000000', 'consum', 0.0219, 'lps'),
	(399186, 123, '2015-02-15 00:26:16.000000', 'consum', 0.0214, 'lps'),
	(399187, 123, '2015-02-15 00:26:17.000000', 'consum', 0.0214, 'lps'),
	(399188, 123, '2015-02-15 00:26:18.000000', 'consum', 0.0218, 'lps'),
	(399189, 123, '2015-02-15 00:26:19.000000', 'consum', 0.0218, 'lps'),
	(399190, 123, '2015-02-15 00:26:20.000000', 'consum', 0.0214, 'lps'),
	(399191, 123, '2015-02-15 00:26:21.000000', 'consum', 0.0217, 'lps'),
	(399192, 123, '2015-02-15 00:26:22.000000', 'consum', 0.0212, 'lps'),
	(399193, 123, '2015-02-15 00:26:23.000000', 'consum', 0.0210, 'lps'),
	(399194, 123, '2015-02-15 00:26:24.000000', 'consum', 0.0214, 'lps'),
	(399195, 123, '2015-02-15 00:26:25.000000', 'consum', 0.0210, 'lps'),
	(399196, 123, '2015-02-15 00:26:26.000000', 'consum', 0.0210, 'lps'),
	(399197, 123, '2015-02-15 00:26:27.000000', 'consum', 0.0219, 'lps'),
	(399198, 123, '2015-02-15 00:26:28.000000', 'consum', 0.0213, 'lps'),
	(399199, 123, '2015-02-15 00:26:29.000000', 'consum', 0.0211, 'lps'),
	(399200, 123, '2015-02-15 00:26:30.000000', 'consum', 0.0218, 'lps'),
	(399201, 123, '2015-02-15 00:26:31.000000', 'consum', 0.0213, 'lps'),
	(399202, 123, '2015-02-15 00:26:32.000000', 'consum', 0.0214, 'lps'),
	(399203, 123, '2015-02-15 00:26:33.000000', 'consum', 0.0210, 'lps'),
	(399204, 123, '2015-02-15 00:26:34.000000', 'consum', 0.0211, 'lps'),
	(399205, 123, '2015-02-15 00:26:35.000000', 'consum', 0.0216, 'lps'),
	(399206, 123, '2015-02-15 00:26:36.000000', 'consum', 0.0214, 'lps'),
	(399207, 123, '2015-02-15 00:26:37.000000', 'consum', 0.0213, 'lps'),
	(399208, 123, '2015-02-15 00:26:38.000000', 'consum', 0.0214, 'lps'),
	(399209, 123, '2015-02-15 00:26:39.000000', 'consum', 0.0210, 'lps'),
	(399210, 123, '2015-02-15 00:26:40.000000', 'consum', 0.0212, 'lps'),
	(399211, 123, '2015-02-15 00:26:41.000000', 'consum', 0.0217, 'lps'),
	(399212, 123, '2015-02-15 00:26:42.000000', 'consum', 0.0217, 'lps'),
	(399213, 123, '2015-02-15 00:26:43.000000', 'consum', 0.0215, 'lps'),
	(399214, 123, '2015-02-15 00:26:44.000000', 'consum', 0.0215, 'lps'),
	(399215, 123, '2015-02-15 00:26:45.000000', 'consum', 0.0218, 'lps'),
	(399216, 123, '2015-02-15 00:26:46.000000', 'consum', 0.0216, 'lps'),
	(399217, 123, '2015-02-15 00:26:47.000000', 'consum', 0.0216, 'lps'),
	(399218, 123, '2015-02-15 00:26:48.000000', 'consum', 0.0211, 'lps'),
	(399219, 123, '2015-02-15 00:26:49.000000', 'consum', 0.0220, 'lps'),
	(399220, 123, '2015-02-15 00:26:50.000000', 'consum', 0.0212, 'lps'),
	(399221, 123, '2015-02-15 00:26:51.000000', 'consum', 0.0215, 'lps'),
	(399222, 123, '2015-02-15 00:26:52.000000', 'consum', 0.0215, 'lps'),
	(399223, 123, '2015-02-15 00:26:53.000000', 'consum', 0.0213, 'lps'),
	(399224, 123, '2015-02-15 00:26:54.000000', 'consum', 0.0211, 'lps'),
	(399225, 123, '2015-02-15 00:26:55.000000', 'consum', 0.0214, 'lps'),
	(399226, 123, '2015-02-15 00:26:56.000000', 'consum', 0.0219, 'lps'),
	(399227, 123, '2015-02-15 00:26:57.000000', 'consum', 0.0212, 'lps'),
	(399228, 123, '2015-02-15 00:26:58.000000', 'consum', 0.0213, 'lps'),
	(399229, 123, '2015-02-15 00:26:59.000000', 'consum', 0.0220, 'lps'),
	(399230, 123, '2015-02-15 00:27:00.000000', 'consum', 0.0219, 'lps'),
	(399231, 123, '2015-02-15 00:27:01.000000', 'consum', 0.0215, 'lps'),
	(399232, 123, '2015-02-15 00:27:02.000000', 'consum', 0.0217, 'lps'),
	(399233, 123, '2015-02-15 00:27:03.000000', 'consum', 0.0220, 'lps'),
	(399234, 123, '2015-02-15 00:27:04.000000', 'consum', 0.0219, 'lps'),
	(399235, 123, '2015-02-15 00:27:05.000000', 'consum', 0.0214, 'lps'),
	(399236, 123, '2015-02-15 00:27:06.000000', 'consum', 0.0216, 'lps'),
	(399237, 123, '2015-02-15 00:27:07.000000', 'consum', 0.0217, 'lps'),
	(399238, 123, '2015-02-15 00:27:08.000000', 'consum', 0.0218, 'lps'),
	(399239, 123, '2015-02-15 00:27:09.000000', 'consum', 0.0217, 'lps'),
	(399240, 123, '2015-02-15 00:27:10.000000', 'consum', 0.0212, 'lps'),
	(399241, 123, '2015-02-15 00:27:11.000000', 'consum', 0.0219, 'lps'),
	(399242, 123, '2015-02-15 00:27:12.000000', 'consum', 0.0216, 'lps'),
	(399243, 123, '2015-02-15 00:27:13.000000', 'consum', 0.0214, 'lps'),
	(399244, 123, '2015-02-15 00:27:14.000000', 'consum', 0.0214, 'lps'),
	(399245, 123, '2015-02-15 00:27:15.000000', 'consum', 0.0218, 'lps'),
	(399246, 123, '2015-02-15 00:27:16.000000', 'consum', 0.0217, 'lps'),
	(399247, 123, '2015-02-15 00:27:17.000000', 'consum', 0.0220, 'lps'),
	(399248, 123, '2015-02-15 00:27:18.000000', 'consum', 0.0218, 'lps'),
	(399249, 123, '2015-02-15 00:27:19.000000', 'consum', 0.0212, 'lps'),
	(399250, 123, '2015-02-15 00:27:20.000000', 'consum', 0.0215, 'lps'),
	(399251, 123, '2015-02-15 00:27:21.000000', 'consum', 0.0220, 'lps'),
	(399252, 123, '2015-02-15 00:27:22.000000', 'consum', 0.0214, 'lps'),
	(399253, 123, '2015-02-15 00:27:23.000000', 'consum', 0.0212, 'lps'),
	(399254, 123, '2015-02-15 00:27:24.000000', 'consum', 0.0220, 'lps'),
	(399255, 123, '2015-02-15 00:27:25.000000', 'consum', 0.0210, 'lps'),
	(399256, 123, '2015-02-15 00:27:26.000000', 'consum', 0.0214, 'lps'),
	(399257, 123, '2015-02-15 00:27:27.000000', 'consum', 0.0210, 'lps'),
	(399258, 123, '2015-02-15 00:27:28.000000', 'consum', 0.0218, 'lps'),
	(399259, 123, '2015-02-15 00:27:29.000000', 'consum', 0.0217, 'lps'),
	(399260, 123, '2015-02-15 00:27:30.000000', 'consum', 0.0220, 'lps'),
	(399261, 123, '2015-02-15 00:27:31.000000', 'consum', 0.0210, 'lps'),
	(399262, 123, '2015-02-15 00:27:32.000000', 'consum', 0.0211, 'lps'),
	(399263, 123, '2015-02-15 00:27:33.000000', 'consum', 0.0218, 'lps'),
	(399264, 123, '2015-02-15 00:27:34.000000', 'consum', 0.0211, 'lps'),
	(399265, 123, '2015-02-15 00:27:35.000000', 'consum', 0.0216, 'lps'),
	(399266, 123, '2015-02-15 00:27:36.000000', 'consum', 0.0215, 'lps'),
	(399267, 123, '2015-02-15 00:27:37.000000', 'consum', 0.0216, 'lps'),
	(399268, 123, '2015-02-15 00:27:38.000000', 'consum', 0.0216, 'lps'),
	(399269, 123, '2015-02-15 00:27:39.000000', 'consum', 0.0213, 'lps'),
	(399270, 123, '2015-02-15 00:27:40.000000', 'consum', 0.0215, 'lps'),
	(399271, 123, '2015-02-15 00:27:41.000000', 'consum', 0.0217, 'lps'),
	(399272, 123, '2015-02-15 00:27:42.000000', 'consum', 0.0210, 'lps'),
	(399273, 123, '2015-02-15 00:27:43.000000', 'consum', 0.0210, 'lps'),
	(399274, 123, '2015-02-15 00:27:44.000000', 'consum', 0.0220, 'lps'),
	(399275, 123, '2015-02-15 00:27:45.000000', 'consum', 0.0217, 'lps'),
	(399276, 123, '2015-02-15 00:27:46.000000', 'consum', 0.0216, 'lps'),
	(399277, 123, '2015-02-15 00:27:47.000000', 'consum', 0.0219, 'lps'),
	(399278, 123, '2015-02-15 00:27:48.000000', 'consum', 0.0217, 'lps'),
	(399279, 123, '2015-02-15 00:27:49.000000', 'consum', 0.0218, 'lps'),
	(399280, 123, '2015-02-15 00:27:50.000000', 'consum', 0.0220, 'lps'),
	(399281, 123, '2015-02-15 00:27:51.000000', 'consum', 0.0213, 'lps'),
	(399282, 123, '2015-02-15 00:27:52.000000', 'consum', 0.0219, 'lps'),
	(399283, 123, '2015-02-15 00:27:53.000000', 'consum', 0.0213, 'lps'),
	(399284, 123, '2015-02-15 00:27:54.000000', 'consum', 0.0220, 'lps'),
	(399285, 123, '2015-02-15 00:27:55.000000', 'consum', 0.0220, 'lps'),
	(399286, 123, '2015-02-15 00:27:56.000000', 'consum', 0.0218, 'lps'),
	(399287, 123, '2015-02-15 00:27:57.000000', 'consum', 0.0211, 'lps'),
	(399288, 123, '2015-02-15 00:27:58.000000', 'consum', 0.0215, 'lps'),
	(399289, 123, '2015-02-15 00:27:59.000000', 'consum', 0.0218, 'lps'),
	(399290, 123, '2015-02-15 00:28:00.000000', 'consum', 0.0216, 'lps'),
	(399291, 123, '2015-02-15 00:28:01.000000', 'consum', 0.0215, 'lps'),
	(399292, 123, '2015-02-15 00:28:02.000000', 'consum', 0.0216, 'lps'),
	(399293, 123, '2015-02-15 00:28:03.000000', 'consum', 0.0215, 'lps'),
	(399294, 123, '2015-02-15 00:28:04.000000', 'consum', 0.0219, 'lps'),
	(399295, 123, '2015-02-15 00:28:05.000000', 'consum', 0.0220, 'lps'),
	(399296, 123, '2015-02-15 00:28:06.000000', 'consum', 0.0210, 'lps'),
	(399297, 123, '2015-02-15 00:28:07.000000', 'consum', 0.0212, 'lps'),
	(399298, 123, '2015-02-15 00:28:08.000000', 'consum', 0.0220, 'lps'),
	(399299, 123, '2015-02-15 00:28:09.000000', 'consum', 0.0211, 'lps'),
	(399300, 123, '2015-02-15 00:28:10.000000', 'consum', 0.0210, 'lps'),
	(399301, 123, '2015-02-15 00:28:11.000000', 'consum', 0.0217, 'lps'),
	(399302, 123, '2015-02-15 00:28:12.000000', 'consum', 0.0213, 'lps'),
	(399303, 123, '2015-02-15 00:28:13.000000', 'consum', 0.0215, 'lps'),
	(399304, 123, '2015-02-15 00:28:14.000000', 'consum', 0.0213, 'lps'),
	(399305, 123, '2015-02-15 00:28:15.000000', 'consum', 0.0214, 'lps'),
	(399306, 123, '2015-02-15 00:28:16.000000', 'consum', 0.0211, 'lps'),
	(399307, 123, '2015-02-15 00:28:17.000000', 'consum', 0.0213, 'lps'),
	(399308, 123, '2015-02-15 00:28:18.000000', 'consum', 0.0210, 'lps'),
	(399309, 123, '2015-02-15 00:28:19.000000', 'consum', 0.0213, 'lps'),
	(399310, 123, '2015-02-15 00:28:20.000000', 'consum', 0.0216, 'lps'),
	(399311, 123, '2015-02-15 00:28:21.000000', 'consum', 0.0210, 'lps'),
	(399312, 123, '2015-02-15 00:28:22.000000', 'consum', 0.0212, 'lps'),
	(399313, 123, '2015-02-15 00:28:23.000000', 'consum', 0.0211, 'lps'),
	(399314, 123, '2015-02-15 00:28:24.000000', 'consum', 0.0210, 'lps'),
	(399315, 123, '2015-02-15 00:28:25.000000', 'consum', 0.0217, 'lps'),
	(399316, 123, '2015-02-15 00:28:26.000000', 'consum', 0.0212, 'lps'),
	(399317, 123, '2015-02-15 00:28:27.000000', 'consum', 0.0213, 'lps'),
	(399318, 123, '2015-02-15 00:28:28.000000', 'consum', 0.0217, 'lps'),
	(399319, 123, '2015-02-15 00:28:29.000000', 'consum', 0.0217, 'lps'),
	(399320, 123, '2015-02-15 00:28:30.000000', 'consum', 0.0213, 'lps'),
	(399321, 123, '2015-02-15 00:28:31.000000', 'consum', 0.0216, 'lps'),
	(399322, 123, '2015-02-15 00:28:32.000000', 'consum', 0.0210, 'lps'),
	(399323, 123, '2015-02-15 00:28:33.000000', 'consum', 0.0214, 'lps'),
	(399324, 123, '2015-02-15 00:28:34.000000', 'consum', 0.0219, 'lps'),
	(399325, 123, '2015-02-15 00:28:35.000000', 'consum', 0.0212, 'lps'),
	(399326, 123, '2015-02-15 00:28:36.000000', 'consum', 0.0217, 'lps'),
	(399327, 123, '2015-02-15 00:28:37.000000', 'consum', 0.0215, 'lps'),
	(399328, 123, '2015-02-15 00:28:38.000000', 'consum', 0.0213, 'lps'),
	(399329, 123, '2015-02-15 00:28:39.000000', 'consum', 0.0213, 'lps'),
	(399330, 123, '2015-02-15 00:28:40.000000', 'consum', 0.0217, 'lps'),
	(399331, 123, '2015-02-15 00:28:41.000000', 'consum', 0.0213, 'lps'),
	(399332, 123, '2015-02-15 00:28:42.000000', 'consum', 0.0217, 'lps'),
	(399333, 123, '2015-02-15 00:28:43.000000', 'consum', 0.0213, 'lps'),
	(399334, 123, '2015-02-15 00:28:44.000000', 'consum', 0.0217, 'lps'),
	(399335, 123, '2015-02-15 00:28:45.000000', 'consum', 0.0212, 'lps'),
	(399336, 123, '2015-02-15 00:28:46.000000', 'consum', 0.0212, 'lps'),
	(399337, 123, '2015-02-15 00:28:47.000000', 'consum', 0.0213, 'lps'),
	(399338, 123, '2015-02-15 00:28:48.000000', 'consum', 0.0220, 'lps'),
	(399339, 123, '2015-02-15 00:28:49.000000', 'consum', 0.0218, 'lps'),
	(399340, 123, '2015-02-15 00:28:50.000000', 'consum', 0.0212, 'lps'),
	(399341, 123, '2015-02-15 00:28:51.000000', 'consum', 0.0215, 'lps'),
	(399342, 123, '2015-02-15 00:28:52.000000', 'consum', 0.0210, 'lps'),
	(399343, 123, '2015-02-15 00:28:53.000000', 'consum', 0.0216, 'lps'),
	(399344, 123, '2015-02-15 00:28:54.000000', 'consum', 0.0219, 'lps'),
	(399345, 123, '2015-02-15 00:28:55.000000', 'consum', 0.0218, 'lps'),
	(399346, 123, '2015-02-15 00:28:56.000000', 'consum', 0.0220, 'lps'),
	(399347, 123, '2015-02-15 00:28:57.000000', 'consum', 0.0217, 'lps'),
	(399348, 123, '2015-02-15 00:28:58.000000', 'consum', 0.0213, 'lps'),
	(399349, 123, '2015-02-15 00:28:59.000000', 'consum', 0.0218, 'lps'),
	(399350, 123, '2015-02-15 00:29:00.000000', 'consum', 0.0217, 'lps'),
	(399351, 123, '2015-02-15 00:29:01.000000', 'consum', 0.0213, 'lps'),
	(399352, 123, '2015-02-15 00:29:02.000000', 'consum', 0.0216, 'lps'),
	(399353, 123, '2015-02-15 00:29:03.000000', 'consum', 0.0218, 'lps'),
	(399354, 123, '2015-02-15 00:29:04.000000', 'consum', 0.0212, 'lps'),
	(399355, 123, '2015-02-15 00:29:05.000000', 'consum', 0.0216, 'lps'),
	(399356, 123, '2015-02-15 00:29:06.000000', 'consum', 0.0216, 'lps'),
	(399357, 123, '2015-02-15 00:29:07.000000', 'consum', 0.0219, 'lps'),
	(399358, 123, '2015-02-15 00:29:08.000000', 'consum', 0.0218, 'lps'),
	(399359, 123, '2015-02-15 00:29:09.000000', 'consum', 0.0213, 'lps'),
	(399360, 123, '2015-02-15 00:29:10.000000', 'consum', 0.0213, 'lps'),
	(399361, 123, '2015-02-15 00:29:11.000000', 'consum', 0.0215, 'lps'),
	(399362, 123, '2015-02-15 00:29:12.000000', 'consum', 0.0216, 'lps'),
	(399363, 123, '2015-02-15 00:29:13.000000', 'consum', 0.0216, 'lps'),
	(399364, 123, '2015-02-15 00:29:14.000000', 'consum', 0.0211, 'lps'),
	(399365, 123, '2015-02-15 00:29:15.000000', 'consum', 0.0220, 'lps'),
	(399366, 123, '2015-02-15 00:29:16.000000', 'consum', 0.0214, 'lps'),
	(399367, 123, '2015-02-15 00:29:17.000000', 'consum', 0.0212, 'lps'),
	(399368, 123, '2015-02-15 00:29:18.000000', 'consum', 0.0220, 'lps'),
	(399369, 123, '2015-02-15 00:29:19.000000', 'consum', 0.0211, 'lps'),
	(399370, 123, '2015-02-15 00:29:20.000000', 'consum', 0.0217, 'lps'),
	(399371, 123, '2015-02-15 00:29:21.000000', 'consum', 0.0210, 'lps'),
	(399372, 123, '2015-02-15 00:29:22.000000', 'consum', 0.0210, 'lps'),
	(399373, 123, '2015-02-15 00:29:23.000000', 'consum', 0.0210, 'lps'),
	(399374, 123, '2015-02-15 00:29:24.000000', 'consum', 0.0213, 'lps'),
	(399375, 123, '2015-02-15 00:29:25.000000', 'consum', 0.0215, 'lps'),
	(399376, 123, '2015-02-15 00:29:26.000000', 'consum', 0.0213, 'lps'),
	(399377, 123, '2015-02-15 00:29:27.000000', 'consum', 0.0214, 'lps'),
	(399378, 123, '2015-02-15 00:29:28.000000', 'consum', 0.0218, 'lps'),
	(399379, 123, '2015-02-15 00:29:29.000000', 'consum', 0.0216, 'lps'),
	(399380, 123, '2015-02-15 00:29:30.000000', 'consum', 0.0218, 'lps'),
	(399381, 123, '2015-02-15 00:29:31.000000', 'consum', 0.0211, 'lps'),
	(399382, 123, '2015-02-15 00:29:32.000000', 'consum', 0.0212, 'lps'),
	(399383, 123, '2015-02-15 00:29:33.000000', 'consum', 0.0219, 'lps'),
	(399384, 123, '2015-02-15 00:29:34.000000', 'consum', 0.0214, 'lps'),
	(399385, 123, '2015-02-15 00:29:35.000000', 'consum', 0.0217, 'lps'),
	(399386, 123, '2015-02-15 00:29:36.000000', 'consum', 0.0210, 'lps'),
	(399387, 123, '2015-02-15 00:29:37.000000', 'consum', 0.0214, 'lps'),
	(399388, 123, '2015-02-15 00:29:38.000000', 'consum', 0.0217, 'lps'),
	(399389, 123, '2015-02-15 00:29:39.000000', 'consum', 0.0211, 'lps'),
	(399390, 123, '2015-02-15 00:29:40.000000', 'consum', 0.0218, 'lps'),
	(399391, 123, '2015-02-15 00:29:41.000000', 'consum', 0.0214, 'lps'),
	(399392, 123, '2015-02-15 00:29:42.000000', 'consum', 0.0219, 'lps'),
	(399393, 123, '2015-02-15 00:29:43.000000', 'consum', 0.0211, 'lps'),
	(399394, 123, '2015-02-15 00:29:44.000000', 'consum', 0.0220, 'lps'),
	(399395, 123, '2015-02-15 00:29:45.000000', 'consum', 0.0213, 'lps'),
	(399396, 123, '2015-02-15 00:29:46.000000', 'consum', 0.0218, 'lps'),
	(399397, 123, '2015-02-15 00:29:47.000000', 'consum', 0.0210, 'lps'),
	(399398, 123, '2015-02-15 00:29:48.000000', 'consum', 0.0217, 'lps'),
	(399399, 123, '2015-02-15 00:29:49.000000', 'consum', 0.0214, 'lps'),
	(399400, 123, '2015-02-15 00:29:50.000000', 'consum', 0.0210, 'lps'),
	(399401, 123, '2015-02-15 00:29:51.000000', 'consum', 0.0220, 'lps'),
	(399402, 123, '2015-02-15 00:29:52.000000', 'consum', 0.0218, 'lps'),
	(399403, 123, '2015-02-15 00:29:53.000000', 'consum', 0.0210, 'lps'),
	(399404, 123, '2015-02-15 00:29:54.000000', 'consum', 0.0220, 'lps'),
	(399405, 123, '2015-02-15 00:29:55.000000', 'consum', 0.0215, 'lps'),
	(399406, 123, '2015-02-15 00:29:56.000000', 'consum', 0.0215, 'lps'),
	(399407, 123, '2015-02-15 00:29:57.000000', 'consum', 0.0211, 'lps'),
	(399408, 123, '2015-02-15 00:29:58.000000', 'consum', 0.0212, 'lps'),
	(399409, 123, '2015-02-15 00:29:59.000000', 'consum', 0.0218, 'lps'),
	(399410, 123, '2015-02-15 00:30:00.000000', 'consum', 0.0211, 'lps'),
	(399411, 123, '2015-02-15 00:30:01.000000', 'consum', 0.0215, 'lps'),
	(399412, 123, '2015-02-15 00:30:02.000000', 'consum', 0.0220, 'lps'),
	(399413, 123, '2015-02-15 00:30:03.000000', 'consum', 0.0214, 'lps'),
	(399414, 123, '2015-02-15 00:30:04.000000', 'consum', 0.0220, 'lps'),
	(399415, 123, '2015-02-15 00:30:05.000000', 'consum', 0.0219, 'lps'),
	(399416, 123, '2015-02-15 00:30:06.000000', 'consum', 0.0211, 'lps'),
	(399417, 123, '2015-02-15 00:30:07.000000', 'consum', 0.0212, 'lps'),
	(399418, 123, '2015-02-15 00:30:08.000000', 'consum', 0.0219, 'lps'),
	(399419, 123, '2015-02-15 00:30:09.000000', 'consum', 0.0216, 'lps'),
	(399420, 123, '2015-02-15 00:30:10.000000', 'consum', 0.0211, 'lps'),
	(399421, 123, '2015-02-15 00:30:11.000000', 'consum', 0.0211, 'lps'),
	(399422, 123, '2015-02-15 00:30:12.000000', 'consum', 0.0212, 'lps'),
	(399423, 123, '2015-02-15 00:30:13.000000', 'consum', 0.0216, 'lps'),
	(399424, 123, '2015-02-15 00:30:14.000000', 'consum', 0.0215, 'lps'),
	(399425, 123, '2015-02-15 00:30:15.000000', 'consum', 0.0217, 'lps'),
	(399426, 123, '2015-02-15 00:30:16.000000', 'consum', 0.0210, 'lps'),
	(399427, 123, '2015-02-15 00:30:17.000000', 'consum', 0.0220, 'lps'),
	(399428, 123, '2015-02-15 00:30:18.000000', 'consum', 0.0219, 'lps'),
	(399429, 123, '2015-02-15 00:30:19.000000', 'consum', 0.0214, 'lps'),
	(399430, 123, '2015-02-15 00:30:20.000000', 'consum', 0.0212, 'lps'),
	(399431, 123, '2015-02-15 00:30:21.000000', 'consum', 0.0211, 'lps'),
	(399432, 123, '2015-02-15 00:30:22.000000', 'consum', 0.0220, 'lps'),
	(399433, 123, '2015-02-15 00:30:23.000000', 'consum', 0.0212, 'lps'),
	(399434, 123, '2015-02-15 00:30:24.000000', 'consum', 0.0211, 'lps'),
	(399435, 123, '2015-02-15 00:30:25.000000', 'consum', 0.0213, 'lps'),
	(399436, 123, '2015-02-15 00:30:26.000000', 'consum', 0.0211, 'lps'),
	(399437, 123, '2015-02-15 00:30:27.000000', 'consum', 0.0215, 'lps'),
	(399438, 123, '2015-02-15 00:30:28.000000', 'consum', 0.0213, 'lps'),
	(399439, 123, '2015-02-15 00:30:29.000000', 'consum', 0.0212, 'lps'),
	(399440, 123, '2015-02-15 00:30:30.000000', 'consum', 0.0219, 'lps'),
	(399441, 123, '2015-02-15 00:30:31.000000', 'consum', 0.0217, 'lps'),
	(399442, 123, '2015-02-15 00:30:32.000000', 'consum', 0.0218, 'lps'),
	(399443, 123, '2015-02-15 00:30:33.000000', 'consum', 0.0220, 'lps'),
	(399444, 123, '2015-02-15 00:30:34.000000', 'consum', 0.0216, 'lps'),
	(399445, 123, '2015-02-15 00:30:35.000000', 'consum', 0.0220, 'lps'),
	(399446, 123, '2015-02-15 00:30:36.000000', 'consum', 0.0218, 'lps'),
	(399447, 123, '2015-02-15 00:30:37.000000', 'consum', 0.0213, 'lps'),
	(399448, 123, '2015-02-15 00:30:38.000000', 'consum', 0.0212, 'lps'),
	(399449, 123, '2015-02-15 00:30:39.000000', 'consum', 0.0213, 'lps'),
	(399450, 123, '2015-02-15 00:30:40.000000', 'consum', 0.0216, 'lps'),
	(399451, 123, '2015-02-15 00:30:41.000000', 'consum', 0.0213, 'lps'),
	(399452, 123, '2015-02-15 00:30:42.000000', 'consum', 0.0217, 'lps'),
	(399453, 123, '2015-02-15 00:30:43.000000', 'consum', 0.0215, 'lps'),
	(399454, 123, '2015-02-15 00:30:44.000000', 'consum', 0.0213, 'lps'),
	(399455, 123, '2015-02-15 00:30:45.000000', 'consum', 0.0211, 'lps'),
	(399456, 123, '2015-02-15 00:30:46.000000', 'consum', 0.0217, 'lps'),
	(399457, 123, '2015-02-15 00:30:47.000000', 'consum', 0.0220, 'lps'),
	(399458, 123, '2015-02-15 00:30:48.000000', 'consum', 0.0220, 'lps'),
	(399459, 123, '2015-02-15 00:30:49.000000', 'consum', 0.0218, 'lps'),
	(399460, 123, '2015-02-15 00:30:50.000000', 'consum', 0.0211, 'lps'),
	(399461, 123, '2015-02-15 00:30:51.000000', 'consum', 0.0215, 'lps'),
	(399462, 123, '2015-02-15 00:30:52.000000', 'consum', 0.0218, 'lps'),
	(399463, 123, '2015-02-15 00:30:53.000000', 'consum', 0.0214, 'lps'),
	(399464, 123, '2015-02-15 00:30:54.000000', 'consum', 0.0220, 'lps'),
	(399465, 123, '2015-02-15 00:30:55.000000', 'consum', 0.0215, 'lps'),
	(399466, 123, '2015-02-15 00:30:56.000000', 'consum', 0.0215, 'lps'),
	(399467, 123, '2015-02-15 00:30:57.000000', 'consum', 0.0210, 'lps'),
	(399468, 123, '2015-02-15 00:30:58.000000', 'consum', 0.0219, 'lps'),
	(399469, 123, '2015-02-15 00:30:59.000000', 'consum', 0.0210, 'lps'),
	(399470, 123, '2015-02-15 00:31:00.000000', 'consum', 0.0215, 'lps'),
	(399471, 123, '2015-02-15 00:31:01.000000', 'consum', 0.0216, 'lps'),
	(399472, 123, '2015-02-15 00:31:02.000000', 'consum', 0.0215, 'lps'),
	(399473, 123, '2015-02-15 00:31:03.000000', 'consum', 0.0215, 'lps'),
	(399474, 123, '2015-02-15 00:31:04.000000', 'consum', 0.0212, 'lps'),
	(399475, 123, '2015-02-15 00:31:05.000000', 'consum', 0.0216, 'lps'),
	(399476, 123, '2015-02-15 00:31:06.000000', 'consum', 0.0213, 'lps'),
	(399477, 123, '2015-02-15 00:31:07.000000', 'consum', 0.0219, 'lps'),
	(399478, 123, '2015-02-15 00:31:08.000000', 'consum', 0.0214, 'lps'),
	(399479, 123, '2015-02-15 00:31:09.000000', 'consum', 0.0215, 'lps'),
	(399480, 123, '2015-02-15 00:31:10.000000', 'consum', 0.0212, 'lps'),
	(399481, 123, '2015-02-15 00:31:11.000000', 'consum', 0.0215, 'lps'),
	(399482, 123, '2015-02-15 00:31:12.000000', 'consum', 0.0220, 'lps'),
	(399483, 123, '2015-02-15 00:31:13.000000', 'consum', 0.0212, 'lps'),
	(399484, 123, '2015-02-15 00:31:14.000000', 'consum', 0.0214, 'lps'),
	(399485, 123, '2015-02-15 00:31:15.000000', 'consum', 0.0214, 'lps'),
	(399486, 123, '2015-02-15 00:31:16.000000', 'consum', 0.0218, 'lps'),
	(399487, 123, '2015-02-15 00:31:17.000000', 'consum', 0.0217, 'lps'),
	(399488, 123, '2015-02-15 00:31:18.000000', 'consum', 0.0211, 'lps'),
	(399489, 123, '2015-02-15 00:31:19.000000', 'consum', 0.0214, 'lps'),
	(399490, 123, '2015-02-15 00:31:20.000000', 'consum', 0.0217, 'lps'),
	(399491, 123, '2015-02-15 00:31:21.000000', 'consum', 0.0214, 'lps'),
	(399492, 123, '2015-02-15 00:31:22.000000', 'consum', 0.0217, 'lps'),
	(399493, 123, '2015-02-15 00:31:23.000000', 'consum', 0.0213, 'lps'),
	(399494, 123, '2015-02-15 00:31:24.000000', 'consum', 0.0215, 'lps'),
	(399495, 123, '2015-02-15 00:31:25.000000', 'consum', 0.0214, 'lps'),
	(399496, 123, '2015-02-15 00:31:26.000000', 'consum', 0.0219, 'lps'),
	(399497, 123, '2015-02-15 00:31:27.000000', 'consum', 0.0219, 'lps'),
	(399498, 123, '2015-02-15 00:31:28.000000', 'consum', 0.0220, 'lps'),
	(399499, 123, '2015-02-15 00:31:29.000000', 'consum', 0.0220, 'lps'),
	(399500, 123, '2015-02-15 00:31:30.000000', 'consum', 0.0211, 'lps'),
	(399501, 123, '2015-02-15 00:31:31.000000', 'consum', 0.0218, 'lps'),
	(399502, 123, '2015-02-15 00:31:32.000000', 'consum', 0.0215, 'lps'),
	(399503, 123, '2015-02-15 00:31:33.000000', 'consum', 0.0220, 'lps'),
	(399504, 123, '2015-02-15 00:31:34.000000', 'consum', 0.0214, 'lps'),
	(399505, 123, '2015-02-15 00:31:35.000000', 'consum', 0.0212, 'lps'),
	(399506, 123, '2015-02-15 00:31:36.000000', 'consum', 0.0210, 'lps'),
	(399507, 123, '2015-02-15 00:31:37.000000', 'consum', 0.0214, 'lps'),
	(399508, 123, '2015-02-15 00:31:38.000000', 'consum', 0.0220, 'lps'),
	(399509, 123, '2015-02-15 00:31:39.000000', 'consum', 0.0217, 'lps'),
	(399510, 123, '2015-02-15 00:31:40.000000', 'consum', 0.0214, 'lps'),
	(399511, 123, '2015-02-15 00:31:41.000000', 'consum', 0.0220, 'lps'),
	(399512, 123, '2015-02-15 00:31:42.000000', 'consum', 0.0214, 'lps'),
	(399513, 123, '2015-02-15 00:31:43.000000', 'consum', 0.0214, 'lps'),
	(399514, 123, '2015-02-15 00:31:44.000000', 'consum', 0.0219, 'lps'),
	(399515, 123, '2015-02-15 00:31:45.000000', 'consum', 0.0211, 'lps'),
	(399516, 123, '2015-02-15 00:31:46.000000', 'consum', 0.0210, 'lps'),
	(399517, 123, '2015-02-15 00:31:47.000000', 'consum', 0.0220, 'lps'),
	(399518, 123, '2015-02-15 00:31:48.000000', 'consum', 0.0214, 'lps'),
	(399519, 123, '2015-02-15 00:31:49.000000', 'consum', 0.0212, 'lps'),
	(399520, 123, '2015-02-15 00:31:50.000000', 'consum', 0.0218, 'lps'),
	(399521, 123, '2015-02-15 00:31:51.000000', 'consum', 0.0212, 'lps'),
	(399522, 123, '2015-02-15 00:31:52.000000', 'consum', 0.0217, 'lps'),
	(399523, 123, '2015-02-15 00:31:53.000000', 'consum', 0.0210, 'lps'),
	(399524, 123, '2015-02-15 00:31:54.000000', 'consum', 0.0220, 'lps'),
	(399525, 123, '2015-02-15 00:31:55.000000', 'consum', 0.0218, 'lps'),
	(399526, 123, '2015-02-15 00:31:56.000000', 'consum', 0.0220, 'lps'),
	(399527, 123, '2015-02-15 00:31:57.000000', 'consum', 0.0213, 'lps'),
	(399528, 123, '2015-02-15 00:31:58.000000', 'consum', 0.0210, 'lps'),
	(399529, 123, '2015-02-15 00:31:59.000000', 'consum', 0.0220, 'lps'),
	(399530, 123, '2015-02-15 00:32:00.000000', 'consum', 0.0218, 'lps'),
	(399531, 123, '2015-02-15 00:32:01.000000', 'consum', 0.0220, 'lps'),
	(399532, 123, '2015-02-15 00:32:02.000000', 'consum', 0.0217, 'lps'),
	(399533, 123, '2015-02-15 00:32:03.000000', 'consum', 0.0213, 'lps'),
	(399534, 123, '2015-02-15 00:32:04.000000', 'consum', 0.0215, 'lps'),
	(399535, 123, '2015-02-15 00:32:05.000000', 'consum', 0.0215, 'lps'),
	(399536, 123, '2015-02-15 00:32:06.000000', 'consum', 0.0212, 'lps'),
	(399537, 123, '2015-02-15 00:32:07.000000', 'consum', 0.0217, 'lps'),
	(399538, 123, '2015-02-15 00:32:08.000000', 'consum', 0.0214, 'lps'),
	(399539, 123, '2015-02-15 00:32:09.000000', 'consum', 0.0213, 'lps'),
	(399540, 123, '2015-02-15 00:32:10.000000', 'consum', 0.0213, 'lps'),
	(399541, 123, '2015-02-15 00:32:11.000000', 'consum', 0.0217, 'lps'),
	(399542, 123, '2015-02-15 00:32:12.000000', 'consum', 0.0215, 'lps'),
	(399543, 123, '2015-02-15 00:32:13.000000', 'consum', 0.0216, 'lps'),
	(399544, 123, '2015-02-15 00:32:14.000000', 'consum', 0.0211, 'lps'),
	(399545, 123, '2015-02-15 00:32:15.000000', 'consum', 0.0210, 'lps'),
	(399546, 123, '2015-02-15 00:32:16.000000', 'consum', 0.0218, 'lps'),
	(399547, 123, '2015-02-15 00:32:17.000000', 'consum', 0.0218, 'lps'),
	(399548, 123, '2015-02-15 00:32:18.000000', 'consum', 0.0217, 'lps'),
	(399549, 123, '2015-02-15 00:32:19.000000', 'consum', 0.0211, 'lps'),
	(399550, 123, '2015-02-15 00:32:20.000000', 'consum', 0.0216, 'lps'),
	(399551, 123, '2015-02-15 00:32:21.000000', 'consum', 0.0215, 'lps'),
	(399552, 123, '2015-02-15 00:32:22.000000', 'consum', 0.0218, 'lps'),
	(399553, 123, '2015-02-15 00:32:23.000000', 'consum', 0.0213, 'lps'),
	(399554, 123, '2015-02-15 00:32:24.000000', 'consum', 0.0212, 'lps'),
	(399555, 123, '2015-02-15 00:32:25.000000', 'consum', 0.0211, 'lps'),
	(399556, 123, '2015-02-15 00:32:26.000000', 'consum', 0.0220, 'lps'),
	(399557, 123, '2015-02-15 00:32:27.000000', 'consum', 0.0213, 'lps'),
	(399558, 123, '2015-02-15 00:32:28.000000', 'consum', 0.0217, 'lps'),
	(399559, 123, '2015-02-15 00:32:29.000000', 'consum', 0.0217, 'lps'),
	(399560, 123, '2015-02-15 00:32:30.000000', 'consum', 0.0213, 'lps'),
	(399561, 123, '2015-02-15 00:32:31.000000', 'consum', 0.0216, 'lps'),
	(399562, 123, '2015-02-15 00:32:32.000000', 'consum', 0.0210, 'lps'),
	(399563, 123, '2015-02-15 00:32:33.000000', 'consum', 0.0216, 'lps'),
	(399564, 123, '2015-02-15 00:32:34.000000', 'consum', 0.0216, 'lps'),
	(399565, 123, '2015-02-15 00:32:35.000000', 'consum', 0.0212, 'lps'),
	(399566, 123, '2015-02-15 00:32:36.000000', 'consum', 0.0214, 'lps'),
	(399567, 123, '2015-02-15 00:32:37.000000', 'consum', 0.0213, 'lps'),
	(399568, 123, '2015-02-15 00:32:38.000000', 'consum', 0.0212, 'lps'),
	(399569, 123, '2015-02-15 00:32:39.000000', 'consum', 0.0211, 'lps'),
	(399570, 123, '2015-02-15 00:32:40.000000', 'consum', 0.0211, 'lps'),
	(399571, 123, '2015-02-15 00:32:41.000000', 'consum', 0.0213, 'lps'),
	(399572, 123, '2015-02-15 00:32:42.000000', 'consum', 0.0220, 'lps'),
	(399573, 123, '2015-02-15 00:32:43.000000', 'consum', 0.0219, 'lps'),
	(399574, 123, '2015-02-15 00:32:44.000000', 'consum', 0.0216, 'lps'),
	(399575, 123, '2015-02-15 00:32:45.000000', 'consum', 0.0214, 'lps'),
	(399576, 123, '2015-02-15 00:32:46.000000', 'consum', 0.0213, 'lps'),
	(399577, 123, '2015-02-15 00:32:47.000000', 'consum', 0.0213, 'lps'),
	(399578, 123, '2015-02-15 00:32:48.000000', 'consum', 0.0217, 'lps'),
	(399579, 123, '2015-02-15 00:32:49.000000', 'consum', 0.0214, 'lps'),
	(399580, 123, '2015-02-15 00:32:50.000000', 'consum', 0.0210, 'lps'),
	(399581, 123, '2015-02-15 00:32:51.000000', 'consum', 0.0211, 'lps'),
	(399582, 123, '2015-02-15 00:32:52.000000', 'consum', 0.0214, 'lps'),
	(399583, 123, '2015-02-15 00:32:53.000000', 'consum', 0.0215, 'lps'),
	(399584, 123, '2015-02-15 00:32:54.000000', 'consum', 0.0213, 'lps'),
	(399585, 123, '2015-02-15 00:32:55.000000', 'consum', 0.0212, 'lps'),
	(399586, 123, '2015-02-15 00:32:56.000000', 'consum', 0.0212, 'lps'),
	(399587, 123, '2015-02-15 00:32:57.000000', 'consum', 0.0213, 'lps'),
	(399588, 123, '2015-02-15 00:32:58.000000', 'consum', 0.0211, 'lps'),
	(399589, 123, '2015-02-15 00:32:59.000000', 'consum', 0.0214, 'lps'),
	(399590, 123, '2015-02-15 00:33:00.000000', 'consum', 0.0219, 'lps'),
	(399591, 123, '2015-02-15 00:33:01.000000', 'consum', 0.0220, 'lps'),
	(399592, 123, '2015-02-15 00:33:02.000000', 'consum', 0.0210, 'lps'),
	(399593, 123, '2015-02-15 00:33:03.000000', 'consum', 0.0215, 'lps'),
	(399594, 123, '2015-02-15 00:33:04.000000', 'consum', 0.0214, 'lps'),
	(399595, 123, '2015-02-15 00:33:05.000000', 'consum', 0.0215, 'lps'),
	(399596, 123, '2015-02-15 00:33:06.000000', 'consum', 0.0214, 'lps'),
	(399597, 123, '2015-02-15 00:33:07.000000', 'consum', 0.0216, 'lps'),
	(399598, 123, '2015-02-15 00:33:08.000000', 'consum', 0.0217, 'lps'),
	(399599, 123, '2015-02-15 00:33:09.000000', 'consum', 0.0218, 'lps'),
	(399600, 123, '2015-02-15 00:33:10.000000', 'consum', 0.0218, 'lps'),
	(399601, 123, '2015-02-15 00:33:11.000000', 'consum', 0.0215, 'lps'),
	(399602, 123, '2015-02-15 00:33:12.000000', 'consum', 0.0213, 'lps'),
	(399603, 123, '2015-02-15 00:33:13.000000', 'consum', 0.0219, 'lps'),
	(399604, 123, '2015-02-15 00:33:14.000000', 'consum', 0.0217, 'lps'),
	(399605, 123, '2015-02-15 00:33:15.000000', 'consum', 0.0215, 'lps'),
	(399606, 123, '2015-02-15 00:33:16.000000', 'consum', 0.0214, 'lps'),
	(399607, 123, '2015-02-15 00:33:17.000000', 'consum', 0.0219, 'lps'),
	(399608, 123, '2015-02-15 00:33:18.000000', 'consum', 0.0218, 'lps'),
	(399609, 123, '2015-02-15 00:33:19.000000', 'consum', 0.0215, 'lps'),
	(399610, 123, '2015-02-15 00:33:20.000000', 'consum', 0.0210, 'lps'),
	(399611, 123, '2015-02-15 00:33:21.000000', 'consum', 0.0219, 'lps'),
	(399612, 123, '2015-02-15 00:33:22.000000', 'consum', 0.0211, 'lps'),
	(399613, 123, '2015-02-15 00:33:23.000000', 'consum', 0.0211, 'lps'),
	(399614, 123, '2015-02-15 00:33:24.000000', 'consum', 0.0212, 'lps'),
	(399615, 123, '2015-02-15 00:33:25.000000', 'consum', 0.0217, 'lps'),
	(399616, 123, '2015-02-15 00:33:26.000000', 'consum', 0.0217, 'lps'),
	(399617, 123, '2015-02-15 00:33:27.000000', 'consum', 0.0214, 'lps'),
	(399618, 123, '2015-02-15 00:33:28.000000', 'consum', 0.0219, 'lps'),
	(399619, 123, '2015-02-15 00:33:29.000000', 'consum', 0.0210, 'lps'),
	(399620, 123, '2015-02-15 00:33:30.000000', 'consum', 0.0218, 'lps'),
	(399621, 123, '2015-02-15 00:33:31.000000', 'consum', 0.0219, 'lps'),
	(399622, 123, '2015-02-15 00:33:32.000000', 'consum', 0.0219, 'lps'),
	(399623, 123, '2015-02-15 00:33:33.000000', 'consum', 0.0219, 'lps'),
	(399624, 123, '2015-02-15 00:33:34.000000', 'consum', 0.0217, 'lps'),
	(399625, 123, '2015-02-15 00:33:35.000000', 'consum', 0.0217, 'lps'),
	(399626, 123, '2015-02-15 00:33:36.000000', 'consum', 0.0213, 'lps'),
	(399627, 123, '2015-02-15 00:33:37.000000', 'consum', 0.0216, 'lps'),
	(399628, 123, '2015-02-15 00:33:38.000000', 'consum', 0.0211, 'lps'),
	(399629, 123, '2015-02-15 00:33:39.000000', 'consum', 0.0219, 'lps'),
	(399630, 123, '2015-02-15 00:33:40.000000', 'consum', 0.0217, 'lps'),
	(399631, 123, '2015-02-15 00:33:41.000000', 'consum', 0.0210, 'lps'),
	(399632, 123, '2015-02-15 00:33:42.000000', 'consum', 0.0213, 'lps'),
	(399633, 123, '2015-02-15 00:33:43.000000', 'consum', 0.0211, 'lps'),
	(399634, 123, '2015-02-15 00:33:44.000000', 'consum', 0.0219, 'lps'),
	(399635, 123, '2015-02-15 00:33:45.000000', 'consum', 0.0219, 'lps'),
	(399636, 123, '2015-02-15 00:33:46.000000', 'consum', 0.0217, 'lps'),
	(399637, 123, '2015-02-15 00:33:47.000000', 'consum', 0.0220, 'lps'),
	(399638, 123, '2015-02-15 00:33:48.000000', 'consum', 0.0218, 'lps'),
	(399639, 123, '2015-02-15 00:33:49.000000', 'consum', 0.0219, 'lps'),
	(399640, 123, '2015-02-15 00:33:50.000000', 'consum', 0.0210, 'lps'),
	(399641, 123, '2015-02-15 00:33:51.000000', 'consum', 0.0216, 'lps'),
	(399642, 123, '2015-02-15 00:33:52.000000', 'consum', 0.0218, 'lps'),
	(399643, 123, '2015-02-15 00:33:53.000000', 'consum', 0.0211, 'lps'),
	(399644, 123, '2015-02-15 00:33:54.000000', 'consum', 0.0212, 'lps'),
	(399645, 123, '2015-02-15 00:33:55.000000', 'consum', 0.0220, 'lps'),
	(399646, 123, '2015-02-15 00:33:56.000000', 'consum', 0.0210, 'lps'),
	(399647, 123, '2015-02-15 00:33:57.000000', 'consum', 0.0215, 'lps'),
	(399648, 123, '2015-02-15 00:33:58.000000', 'consum', 0.0212, 'lps'),
	(399649, 123, '2015-02-15 00:33:59.000000', 'consum', 0.0216, 'lps'),
	(399650, 123, '2015-02-15 00:34:00.000000', 'consum', 0.0215, 'lps'),
	(399651, 123, '2015-02-15 00:34:01.000000', 'consum', 0.0214, 'lps'),
	(399652, 123, '2015-02-15 00:34:02.000000', 'consum', 0.0217, 'lps'),
	(399653, 123, '2015-02-15 00:34:03.000000', 'consum', 0.0210, 'lps'),
	(399654, 123, '2015-02-15 00:34:04.000000', 'consum', 0.0213, 'lps'),
	(399655, 123, '2015-02-15 00:34:05.000000', 'consum', 0.0213, 'lps'),
	(399656, 123, '2015-02-15 00:34:06.000000', 'consum', 0.0218, 'lps'),
	(399657, 123, '2015-02-15 00:34:07.000000', 'consum', 0.0219, 'lps'),
	(399658, 123, '2015-02-15 00:34:08.000000', 'consum', 0.0212, 'lps'),
	(399659, 123, '2015-02-15 00:34:09.000000', 'consum', 0.0212, 'lps'),
	(399660, 123, '2015-02-15 00:34:10.000000', 'consum', 0.0214, 'lps'),
	(399661, 123, '2015-02-15 00:34:11.000000', 'consum', 0.0215, 'lps'),
	(399662, 123, '2015-02-15 00:34:12.000000', 'consum', 0.0213, 'lps'),
	(399663, 123, '2015-02-15 00:34:13.000000', 'consum', 0.0210, 'lps'),
	(399664, 123, '2015-02-15 00:34:14.000000', 'consum', 0.0213, 'lps'),
	(399665, 123, '2015-02-15 00:34:15.000000', 'consum', 0.0215, 'lps'),
	(399666, 123, '2015-02-15 00:34:16.000000', 'consum', 0.0214, 'lps'),
	(399667, 123, '2015-02-15 00:34:17.000000', 'consum', 0.0214, 'lps'),
	(399668, 123, '2015-02-15 00:34:18.000000', 'consum', 0.0220, 'lps'),
	(399669, 123, '2015-02-15 00:34:19.000000', 'consum', 0.0215, 'lps'),
	(399670, 123, '2015-02-15 00:34:20.000000', 'consum', 0.0218, 'lps'),
	(399671, 123, '2015-02-15 00:34:21.000000', 'consum', 0.0212, 'lps'),
	(399672, 123, '2015-02-15 00:34:22.000000', 'consum', 0.0219, 'lps'),
	(399673, 123, '2015-02-15 00:34:23.000000', 'consum', 0.0214, 'lps'),
	(399674, 123, '2015-02-15 00:34:24.000000', 'consum', 0.0218, 'lps'),
	(399675, 123, '2015-02-15 00:34:25.000000', 'consum', 0.0217, 'lps'),
	(399676, 123, '2015-02-15 00:34:26.000000', 'consum', 0.0219, 'lps'),
	(399677, 123, '2015-02-15 00:34:27.000000', 'consum', 0.0214, 'lps'),
	(399678, 123, '2015-02-15 00:34:28.000000', 'consum', 0.0214, 'lps'),
	(399679, 123, '2015-02-15 00:34:29.000000', 'consum', 0.0220, 'lps'),
	(399680, 123, '2015-02-15 00:34:30.000000', 'consum', 0.0215, 'lps'),
	(399681, 123, '2015-02-15 00:34:31.000000', 'consum', 0.0217, 'lps'),
	(399682, 123, '2015-02-15 00:34:32.000000', 'consum', 0.0217, 'lps'),
	(399683, 123, '2015-02-15 00:34:33.000000', 'consum', 0.0216, 'lps'),
	(399684, 123, '2015-02-15 00:34:34.000000', 'consum', 0.0217, 'lps'),
	(399685, 123, '2015-02-15 00:34:35.000000', 'consum', 0.0217, 'lps'),
	(399686, 123, '2015-02-15 00:34:36.000000', 'consum', 0.0216, 'lps'),
	(399687, 123, '2015-02-15 00:34:37.000000', 'consum', 0.0218, 'lps'),
	(399688, 123, '2015-02-15 00:34:38.000000', 'consum', 0.0211, 'lps'),
	(399689, 123, '2015-02-15 00:34:39.000000', 'consum', 0.0212, 'lps'),
	(399690, 123, '2015-02-15 00:34:40.000000', 'consum', 0.0220, 'lps'),
	(399691, 123, '2015-02-15 00:34:41.000000', 'consum', 0.0220, 'lps'),
	(399692, 123, '2015-02-15 00:34:42.000000', 'consum', 0.0210, 'lps'),
	(399693, 123, '2015-02-15 00:34:43.000000', 'consum', 0.0213, 'lps'),
	(399694, 123, '2015-02-15 00:34:44.000000', 'consum', 0.0216, 'lps'),
	(399695, 123, '2015-02-15 00:34:45.000000', 'consum', 0.0217, 'lps'),
	(399696, 123, '2015-02-15 00:34:46.000000', 'consum', 0.0220, 'lps'),
	(399697, 123, '2015-02-15 00:34:47.000000', 'consum', 0.0217, 'lps'),
	(399698, 123, '2015-02-15 00:34:48.000000', 'consum', 0.0214, 'lps'),
	(399699, 123, '2015-02-15 00:34:49.000000', 'consum', 0.0212, 'lps'),
	(399700, 123, '2015-02-15 00:34:50.000000', 'consum', 0.0217, 'lps'),
	(399701, 123, '2015-02-15 00:34:51.000000', 'consum', 0.0218, 'lps'),
	(399702, 123, '2015-02-15 00:34:52.000000', 'consum', 0.0218, 'lps'),
	(399703, 123, '2015-02-15 00:34:53.000000', 'consum', 0.0217, 'lps'),
	(399704, 123, '2015-02-15 00:34:54.000000', 'consum', 0.0210, 'lps'),
	(399705, 123, '2015-02-15 00:34:55.000000', 'consum', 0.0212, 'lps'),
	(399706, 123, '2015-02-15 00:34:56.000000', 'consum', 0.0210, 'lps'),
	(399707, 123, '2015-02-15 00:34:57.000000', 'consum', 0.0215, 'lps'),
	(399708, 123, '2015-02-15 00:34:58.000000', 'consum', 0.0213, 'lps'),
	(399709, 123, '2015-02-15 00:34:59.000000', 'consum', 0.0211, 'lps'),
	(399710, 123, '2015-02-15 00:35:00.000000', 'consum', 0.0216, 'lps'),
	(399711, 123, '2015-02-15 00:35:01.000000', 'consum', 0.0215, 'lps'),
	(399712, 123, '2015-02-15 00:35:02.000000', 'consum', 0.0218, 'lps'),
	(399713, 123, '2015-02-15 00:35:03.000000', 'consum', 0.0214, 'lps'),
	(399714, 123, '2015-02-15 00:35:04.000000', 'consum', 0.0219, 'lps'),
	(399715, 123, '2015-02-15 00:35:05.000000', 'consum', 0.0211, 'lps'),
	(399716, 123, '2015-02-15 00:35:06.000000', 'consum', 0.0220, 'lps'),
	(399717, 123, '2015-02-15 00:35:07.000000', 'consum', 0.0212, 'lps'),
	(399718, 123, '2015-02-15 00:35:08.000000', 'consum', 0.0214, 'lps'),
	(399719, 123, '2015-02-15 00:35:09.000000', 'consum', 0.0213, 'lps'),
	(399720, 123, '2015-02-15 00:35:10.000000', 'consum', 0.0216, 'lps'),
	(399721, 123, '2015-02-15 00:35:11.000000', 'consum', 0.0218, 'lps'),
	(399722, 123, '2015-02-15 00:35:12.000000', 'consum', 0.0211, 'lps'),
	(399723, 123, '2015-02-15 00:35:13.000000', 'consum', 0.0215, 'lps'),
	(399724, 123, '2015-02-15 00:35:14.000000', 'consum', 0.0210, 'lps'),
	(399725, 123, '2015-02-15 00:35:15.000000', 'consum', 0.0219, 'lps'),
	(399726, 123, '2015-02-15 00:35:16.000000', 'consum', 0.0210, 'lps'),
	(399727, 123, '2015-02-15 00:35:17.000000', 'consum', 0.0218, 'lps'),
	(399728, 123, '2015-02-15 00:35:18.000000', 'consum', 0.0217, 'lps'),
	(399729, 123, '2015-02-15 00:35:19.000000', 'consum', 0.0210, 'lps'),
	(399730, 123, '2015-02-15 00:35:20.000000', 'consum', 0.0210, 'lps'),
	(399731, 123, '2015-02-15 00:35:21.000000', 'consum', 0.0213, 'lps'),
	(399732, 123, '2015-02-15 00:35:22.000000', 'consum', 0.0215, 'lps'),
	(399733, 123, '2015-02-15 00:35:23.000000', 'consum', 0.0216, 'lps'),
	(399734, 123, '2015-02-15 00:35:24.000000', 'consum', 0.0215, 'lps'),
	(399735, 123, '2015-02-15 00:35:25.000000', 'consum', 0.0215, 'lps'),
	(399736, 123, '2015-02-15 00:35:26.000000', 'consum', 0.0211, 'lps'),
	(399737, 123, '2015-02-15 00:35:27.000000', 'consum', 0.0220, 'lps'),
	(399738, 123, '2015-02-15 00:35:28.000000', 'consum', 0.0215, 'lps'),
	(399739, 123, '2015-02-15 00:35:29.000000', 'consum', 0.0217, 'lps'),
	(399740, 123, '2015-02-15 00:35:30.000000', 'consum', 0.0210, 'lps'),
	(399741, 123, '2015-02-15 00:35:31.000000', 'consum', 0.0210, 'lps'),
	(399742, 123, '2015-02-15 00:35:32.000000', 'consum', 0.0211, 'lps'),
	(399743, 123, '2015-02-15 00:35:33.000000', 'consum', 0.0216, 'lps'),
	(399744, 123, '2015-02-15 00:35:34.000000', 'consum', 0.0213, 'lps'),
	(399745, 123, '2015-02-15 00:35:35.000000', 'consum', 0.0220, 'lps'),
	(399746, 123, '2015-02-15 00:35:36.000000', 'consum', 0.0220, 'lps'),
	(399747, 123, '2015-02-15 00:35:37.000000', 'consum', 0.0220, 'lps'),
	(399748, 123, '2015-02-15 00:35:38.000000', 'consum', 0.0216, 'lps'),
	(399749, 123, '2015-02-15 00:35:39.000000', 'consum', 0.0213, 'lps'),
	(399750, 123, '2015-02-15 00:35:40.000000', 'consum', 0.0219, 'lps'),
	(399751, 123, '2015-02-15 00:35:41.000000', 'consum', 0.0214, 'lps'),
	(399752, 123, '2015-02-15 00:35:42.000000', 'consum', 0.0213, 'lps'),
	(399753, 123, '2015-02-15 00:35:43.000000', 'consum', 0.0216, 'lps'),
	(399754, 123, '2015-02-15 00:35:44.000000', 'consum', 0.0218, 'lps'),
	(399755, 123, '2015-02-15 00:35:45.000000', 'consum', 0.0212, 'lps'),
	(399756, 123, '2015-02-15 00:35:46.000000', 'consum', 0.0217, 'lps'),
	(399757, 123, '2015-02-15 00:35:47.000000', 'consum', 0.0216, 'lps'),
	(399758, 123, '2015-02-15 00:35:48.000000', 'consum', 0.0212, 'lps'),
	(399759, 123, '2015-02-15 00:35:49.000000', 'consum', 0.0211, 'lps'),
	(399760, 123, '2015-02-15 00:35:50.000000', 'consum', 0.0220, 'lps'),
	(399761, 123, '2015-02-15 00:35:51.000000', 'consum', 0.0216, 'lps'),
	(399762, 123, '2015-02-15 00:35:52.000000', 'consum', 0.0210, 'lps'),
	(399763, 123, '2015-02-15 00:35:53.000000', 'consum', 0.0214, 'lps'),
	(399764, 123, '2015-02-15 00:35:54.000000', 'consum', 0.0219, 'lps'),
	(399765, 123, '2015-02-15 00:35:55.000000', 'consum', 0.0220, 'lps'),
	(399766, 123, '2015-02-15 00:35:56.000000', 'consum', 0.0214, 'lps'),
	(399767, 123, '2015-02-15 00:35:57.000000', 'consum', 0.0220, 'lps'),
	(399768, 123, '2015-02-15 00:35:58.000000', 'consum', 0.0216, 'lps'),
	(399769, 123, '2015-02-15 00:35:59.000000', 'consum', 0.0210, 'lps'),
	(399770, 123, '2015-02-15 00:36:00.000000', 'consum', 0.0217, 'lps'),
	(399771, 123, '2015-02-15 00:36:01.000000', 'consum', 0.0211, 'lps'),
	(399772, 123, '2015-02-15 00:36:02.000000', 'consum', 0.0217, 'lps'),
	(399773, 123, '2015-02-15 00:36:03.000000', 'consum', 0.0220, 'lps'),
	(399774, 123, '2015-02-15 00:36:04.000000', 'consum', 0.0217, 'lps'),
	(399775, 123, '2015-02-15 00:36:05.000000', 'consum', 0.0216, 'lps'),
	(399776, 123, '2015-02-15 00:36:06.000000', 'consum', 0.0220, 'lps'),
	(399777, 123, '2015-02-15 00:36:07.000000', 'consum', 0.0219, 'lps'),
	(399778, 123, '2015-02-15 00:36:08.000000', 'consum', 0.0214, 'lps'),
	(399779, 123, '2015-02-15 00:36:09.000000', 'consum', 0.0216, 'lps'),
	(399780, 123, '2015-02-15 00:36:10.000000', 'consum', 0.0216, 'lps'),
	(399781, 123, '2015-02-15 00:36:11.000000', 'consum', 0.0211, 'lps'),
	(399782, 123, '2015-02-15 00:36:12.000000', 'consum', 0.0210, 'lps'),
	(399783, 123, '2015-02-15 00:36:13.000000', 'consum', 0.0220, 'lps'),
	(399784, 123, '2015-02-15 00:36:14.000000', 'consum', 0.0215, 'lps'),
	(399785, 123, '2015-02-15 00:36:15.000000', 'consum', 0.0217, 'lps'),
	(399786, 123, '2015-02-15 00:36:16.000000', 'consum', 0.0218, 'lps'),
	(399787, 123, '2015-02-15 00:36:17.000000', 'consum', 0.0220, 'lps'),
	(399788, 123, '2015-02-15 00:36:18.000000', 'consum', 0.0213, 'lps'),
	(399789, 123, '2015-02-15 00:36:19.000000', 'consum', 0.0218, 'lps'),
	(399790, 123, '2015-02-15 00:36:20.000000', 'consum', 0.0219, 'lps'),
	(399791, 123, '2015-02-15 00:36:21.000000', 'consum', 0.0219, 'lps'),
	(399792, 123, '2015-02-15 00:36:22.000000', 'consum', 0.0218, 'lps'),
	(399793, 123, '2015-02-15 00:36:23.000000', 'consum', 0.0215, 'lps'),
	(399794, 123, '2015-02-15 00:36:24.000000', 'consum', 0.0210, 'lps'),
	(399795, 123, '2015-02-15 00:36:25.000000', 'consum', 0.0218, 'lps'),
	(399796, 123, '2015-02-15 00:36:26.000000', 'consum', 0.0217, 'lps'),
	(399797, 123, '2015-02-15 00:36:27.000000', 'consum', 0.0220, 'lps'),
	(399798, 123, '2015-02-15 00:36:28.000000', 'consum', 0.0219, 'lps'),
	(399799, 123, '2015-02-15 00:36:29.000000', 'consum', 0.0216, 'lps'),
	(399800, 123, '2015-02-15 00:36:30.000000', 'consum', 0.0212, 'lps'),
	(399801, 123, '2015-02-15 00:36:31.000000', 'consum', 0.0214, 'lps'),
	(399802, 123, '2015-02-15 00:36:32.000000', 'consum', 0.0213, 'lps'),
	(399803, 123, '2015-02-15 00:36:33.000000', 'consum', 0.0215, 'lps'),
	(399804, 123, '2015-02-15 00:36:34.000000', 'consum', 0.0214, 'lps'),
	(399805, 123, '2015-02-15 00:36:35.000000', 'consum', 0.0215, 'lps'),
	(399806, 123, '2015-02-15 00:36:36.000000', 'consum', 0.0212, 'lps'),
	(399807, 123, '2015-02-15 00:36:37.000000', 'consum', 0.0218, 'lps'),
	(399808, 123, '2015-02-15 00:36:38.000000', 'consum', 0.0212, 'lps'),
	(399809, 123, '2015-02-15 00:36:39.000000', 'consum', 0.0218, 'lps'),
	(399810, 123, '2015-02-15 00:36:40.000000', 'consum', 0.0213, 'lps'),
	(399811, 123, '2015-02-15 00:36:41.000000', 'consum', 0.0211, 'lps'),
	(399812, 123, '2015-02-15 00:36:42.000000', 'consum', 0.0216, 'lps'),
	(399813, 123, '2015-02-15 00:36:43.000000', 'consum', 0.0216, 'lps'),
	(399814, 123, '2015-02-15 00:36:44.000000', 'consum', 0.0214, 'lps'),
	(399815, 123, '2015-02-15 00:36:45.000000', 'consum', 0.0210, 'lps'),
	(399816, 123, '2015-02-15 00:36:46.000000', 'consum', 0.0210, 'lps'),
	(399817, 123, '2015-02-15 00:36:47.000000', 'consum', 0.0210, 'lps'),
	(399818, 123, '2015-02-15 00:36:48.000000', 'consum', 0.0210, 'lps'),
	(399819, 123, '2015-02-15 00:36:49.000000', 'consum', 0.0212, 'lps'),
	(399820, 123, '2015-02-15 00:36:50.000000', 'consum', 0.0218, 'lps'),
	(399821, 123, '2015-02-15 00:36:51.000000', 'consum', 0.0215, 'lps'),
	(399822, 123, '2015-02-15 00:36:52.000000', 'consum', 0.0219, 'lps'),
	(399823, 123, '2015-02-15 00:36:53.000000', 'consum', 0.0220, 'lps'),
	(399824, 123, '2015-02-15 00:36:54.000000', 'consum', 0.0212, 'lps'),
	(399825, 123, '2015-02-15 00:36:55.000000', 'consum', 0.0213, 'lps'),
	(399826, 123, '2015-02-15 00:36:56.000000', 'consum', 0.0218, 'lps'),
	(399827, 123, '2015-02-15 00:36:57.000000', 'consum', 0.0220, 'lps'),
	(399828, 123, '2015-02-15 00:36:58.000000', 'consum', 0.0214, 'lps'),
	(399829, 123, '2015-02-15 00:36:59.000000', 'consum', 0.0213, 'lps'),
	(399830, 123, '2015-02-15 00:37:00.000000', 'consum', 0.0214, 'lps'),
	(399831, 123, '2015-02-15 00:37:01.000000', 'consum', 0.0220, 'lps'),
	(399832, 123, '2015-02-15 00:37:02.000000', 'consum', 0.0218, 'lps'),
	(399833, 123, '2015-02-15 00:37:03.000000', 'consum', 0.0219, 'lps'),
	(399834, 123, '2015-02-15 00:37:04.000000', 'consum', 0.0210, 'lps'),
	(399835, 123, '2015-02-15 00:37:05.000000', 'consum', 0.0215, 'lps'),
	(399836, 123, '2015-02-15 00:37:06.000000', 'consum', 0.0215, 'lps'),
	(399837, 123, '2015-02-15 00:37:07.000000', 'consum', 0.0211, 'lps'),
	(399838, 123, '2015-02-15 00:37:08.000000', 'consum', 0.0211, 'lps'),
	(399839, 123, '2015-02-15 00:37:09.000000', 'consum', 0.0210, 'lps'),
	(399840, 123, '2015-02-15 00:37:10.000000', 'consum', 0.0210, 'lps'),
	(399841, 123, '2015-02-15 00:37:11.000000', 'consum', 0.0219, 'lps'),
	(399842, 123, '2015-02-15 00:37:12.000000', 'consum', 0.0213, 'lps'),
	(399843, 123, '2015-02-15 00:37:13.000000', 'consum', 0.0220, 'lps'),
	(399844, 123, '2015-02-15 00:37:14.000000', 'consum', 0.0219, 'lps'),
	(399845, 123, '2015-02-15 00:37:15.000000', 'consum', 0.0215, 'lps'),
	(399846, 123, '2015-02-15 00:37:16.000000', 'consum', 0.0210, 'lps'),
	(399847, 123, '2015-02-15 00:37:17.000000', 'consum', 0.0217, 'lps'),
	(399848, 123, '2015-02-15 00:37:18.000000', 'consum', 0.0210, 'lps'),
	(399849, 123, '2015-02-15 00:37:19.000000', 'consum', 0.0214, 'lps'),
	(399850, 123, '2015-02-15 00:37:20.000000', 'consum', 0.0218, 'lps'),
	(399851, 123, '2015-02-15 00:37:21.000000', 'consum', 0.0215, 'lps'),
	(399852, 123, '2015-02-15 00:37:22.000000', 'consum', 0.0214, 'lps'),
	(399853, 123, '2015-02-15 00:37:23.000000', 'consum', 0.0215, 'lps'),
	(399854, 123, '2015-02-15 00:37:24.000000', 'consum', 0.0212, 'lps'),
	(399855, 123, '2015-02-15 00:37:25.000000', 'consum', 0.0217, 'lps'),
	(399856, 123, '2015-02-15 00:37:26.000000', 'consum', 0.0216, 'lps'),
	(399857, 123, '2015-02-15 00:37:27.000000', 'consum', 0.0219, 'lps'),
	(399858, 123, '2015-02-15 00:37:28.000000', 'consum', 0.0217, 'lps'),
	(399859, 123, '2015-02-15 00:37:29.000000', 'consum', 0.0216, 'lps'),
	(399860, 123, '2015-02-15 00:37:30.000000', 'consum', 0.0210, 'lps'),
	(399861, 123, '2015-02-15 00:37:31.000000', 'consum', 0.0215, 'lps'),
	(399862, 123, '2015-02-15 00:37:32.000000', 'consum', 0.0212, 'lps'),
	(399863, 123, '2015-02-15 00:37:33.000000', 'consum', 0.0218, 'lps'),
	(399864, 123, '2015-02-15 00:37:34.000000', 'consum', 0.0213, 'lps'),
	(399865, 123, '2015-02-15 00:37:35.000000', 'consum', 0.0220, 'lps'),
	(399866, 123, '2015-02-15 00:37:36.000000', 'consum', 0.0220, 'lps'),
	(399867, 123, '2015-02-15 00:37:37.000000', 'consum', 0.0220, 'lps'),
	(399868, 123, '2015-02-15 00:37:38.000000', 'consum', 0.0210, 'lps'),
	(399869, 123, '2015-02-15 00:37:39.000000', 'consum', 0.0210, 'lps'),
	(399870, 123, '2015-02-15 00:37:40.000000', 'consum', 0.0213, 'lps'),
	(399871, 123, '2015-02-15 00:37:41.000000', 'consum', 0.0215, 'lps'),
	(399872, 123, '2015-02-15 00:37:42.000000', 'consum', 0.0213, 'lps'),
	(399873, 123, '2015-02-15 00:37:43.000000', 'consum', 0.0213, 'lps'),
	(399874, 123, '2015-02-15 00:37:44.000000', 'consum', 0.0214, 'lps'),
	(399875, 123, '2015-02-15 00:37:45.000000', 'consum', 0.0212, 'lps'),
	(399876, 123, '2015-02-15 00:37:46.000000', 'consum', 0.0218, 'lps'),
	(399877, 123, '2015-02-15 00:37:47.000000', 'consum', 0.0211, 'lps'),
	(399878, 123, '2015-02-15 00:37:48.000000', 'consum', 0.0215, 'lps'),
	(399879, 123, '2015-02-15 00:37:49.000000', 'consum', 0.0220, 'lps'),
	(399880, 123, '2015-02-15 00:37:50.000000', 'consum', 0.0213, 'lps'),
	(399881, 123, '2015-02-15 00:37:51.000000', 'consum', 0.0219, 'lps'),
	(399882, 123, '2015-02-15 00:37:52.000000', 'consum', 0.0211, 'lps'),
	(399883, 123, '2015-02-15 00:37:53.000000', 'consum', 0.0213, 'lps'),
	(399884, 123, '2015-02-15 00:37:54.000000', 'consum', 0.0212, 'lps'),
	(399885, 123, '2015-02-15 00:37:55.000000', 'consum', 0.0212, 'lps'),
	(399886, 123, '2015-02-15 00:37:56.000000', 'consum', 0.0214, 'lps'),
	(399887, 123, '2015-02-15 00:37:57.000000', 'consum', 0.0214, 'lps'),
	(399888, 123, '2015-02-15 00:37:58.000000', 'consum', 0.0218, 'lps'),
	(399889, 123, '2015-02-15 00:37:59.000000', 'consum', 0.0216, 'lps'),
	(399890, 123, '2015-02-15 00:38:00.000000', 'consum', 0.0216, 'lps'),
	(399891, 123, '2015-02-15 00:38:01.000000', 'consum', 0.0213, 'lps'),
	(399892, 123, '2015-02-15 00:38:02.000000', 'consum', 0.0217, 'lps'),
	(399893, 123, '2015-02-15 00:38:03.000000', 'consum', 0.0214, 'lps'),
	(399894, 123, '2015-02-15 00:38:04.000000', 'consum', 0.0212, 'lps'),
	(399895, 123, '2015-02-15 00:38:05.000000', 'consum', 0.0220, 'lps'),
	(399896, 123, '2015-02-15 00:38:06.000000', 'consum', 0.0220, 'lps'),
	(399897, 123, '2015-02-15 00:38:07.000000', 'consum', 0.0219, 'lps'),
	(399898, 123, '2015-02-15 00:38:08.000000', 'consum', 0.0217, 'lps'),
	(399899, 123, '2015-02-15 00:38:09.000000', 'consum', 0.0216, 'lps'),
	(399900, 123, '2015-02-15 00:38:10.000000', 'consum', 0.0210, 'lps'),
	(399901, 123, '2015-02-15 00:38:11.000000', 'consum', 0.0212, 'lps'),
	(399902, 123, '2015-02-15 00:38:12.000000', 'consum', 0.0212, 'lps'),
	(399903, 123, '2015-02-15 00:38:13.000000', 'consum', 0.0212, 'lps'),
	(399904, 123, '2015-02-15 00:38:14.000000', 'consum', 0.0217, 'lps'),
	(399905, 123, '2015-02-15 00:38:15.000000', 'consum', 0.0216, 'lps'),
	(399906, 123, '2015-02-15 00:38:16.000000', 'consum', 0.0219, 'lps'),
	(399907, 123, '2015-02-15 00:38:17.000000', 'consum', 0.0215, 'lps'),
	(399908, 123, '2015-02-15 00:38:18.000000', 'consum', 0.0218, 'lps'),
	(399909, 123, '2015-02-15 00:38:19.000000', 'consum', 0.0216, 'lps'),
	(399910, 123, '2015-02-15 00:38:20.000000', 'consum', 0.0215, 'lps'),
	(399911, 123, '2015-02-15 00:38:21.000000', 'consum', 0.0220, 'lps'),
	(399912, 123, '2015-02-15 00:38:22.000000', 'consum', 0.0211, 'lps'),
	(399913, 123, '2015-02-15 00:38:23.000000', 'consum', 0.0217, 'lps'),
	(399914, 123, '2015-02-15 00:38:24.000000', 'consum', 0.0211, 'lps'),
	(399915, 123, '2015-02-15 00:38:25.000000', 'consum', 0.0215, 'lps'),
	(399916, 123, '2015-02-15 00:38:26.000000', 'consum', 0.0213, 'lps'),
	(399917, 123, '2015-02-15 00:38:27.000000', 'consum', 0.0219, 'lps'),
	(399918, 123, '2015-02-15 00:38:28.000000', 'consum', 0.0215, 'lps'),
	(399919, 123, '2015-02-15 00:38:29.000000', 'consum', 0.0210, 'lps'),
	(399920, 123, '2015-02-15 00:38:30.000000', 'consum', 0.0217, 'lps'),
	(399921, 123, '2015-02-15 00:38:31.000000', 'consum', 0.0211, 'lps'),
	(399922, 123, '2015-02-15 00:38:32.000000', 'consum', 0.0216, 'lps'),
	(399923, 123, '2015-02-15 00:38:33.000000', 'consum', 0.0216, 'lps'),
	(399924, 123, '2015-02-15 00:38:34.000000', 'consum', 0.0213, 'lps'),
	(399925, 123, '2015-02-15 00:38:35.000000', 'consum', 0.0217, 'lps'),
	(399926, 123, '2015-02-15 00:38:36.000000', 'consum', 0.0214, 'lps'),
	(399927, 123, '2015-02-15 00:38:37.000000', 'consum', 0.0219, 'lps'),
	(399928, 123, '2015-02-15 00:38:38.000000', 'consum', 0.0214, 'lps'),
	(399929, 123, '2015-02-15 00:38:39.000000', 'consum', 0.0213, 'lps'),
	(399930, 123, '2015-02-15 00:38:40.000000', 'consum', 0.0214, 'lps'),
	(399931, 123, '2015-02-15 00:38:41.000000', 'consum', 0.0210, 'lps'),
	(399932, 123, '2015-02-15 00:38:42.000000', 'consum', 0.0220, 'lps'),
	(399933, 123, '2015-02-15 00:38:43.000000', 'consum', 0.0218, 'lps'),
	(399934, 123, '2015-02-15 00:38:44.000000', 'consum', 0.0219, 'lps'),
	(399935, 123, '2015-02-15 00:38:45.000000', 'consum', 0.0212, 'lps'),
	(399936, 123, '2015-02-15 00:38:46.000000', 'consum', 0.0215, 'lps'),
	(399937, 123, '2015-02-15 00:38:47.000000', 'consum', 0.0216, 'lps'),
	(399938, 123, '2015-02-15 00:38:48.000000', 'consum', 0.0217, 'lps'),
	(399939, 123, '2015-02-15 00:38:49.000000', 'consum', 0.0214, 'lps'),
	(399940, 123, '2015-02-15 00:38:50.000000', 'consum', 0.0211, 'lps'),
	(399941, 123, '2015-02-15 00:38:51.000000', 'consum', 0.0213, 'lps'),
	(399942, 123, '2015-02-15 00:38:52.000000', 'consum', 0.0211, 'lps'),
	(399943, 123, '2015-02-15 00:38:53.000000', 'consum', 0.0220, 'lps'),
	(399944, 123, '2015-02-15 00:38:54.000000', 'consum', 0.0213, 'lps'),
	(399945, 123, '2015-02-15 00:38:55.000000', 'consum', 0.0215, 'lps'),
	(399946, 123, '2015-02-15 00:38:56.000000', 'consum', 0.0217, 'lps'),
	(399947, 123, '2015-02-15 00:38:57.000000', 'consum', 0.0219, 'lps'),
	(399948, 123, '2015-02-15 00:38:58.000000', 'consum', 0.0215, 'lps'),
	(399949, 123, '2015-02-15 00:38:59.000000', 'consum', 0.0217, 'lps'),
	(399950, 123, '2015-02-15 00:39:00.000000', 'consum', 0.0218, 'lps'),
	(399951, 123, '2015-02-15 00:39:01.000000', 'consum', 0.0210, 'lps'),
	(399952, 123, '2015-02-15 00:39:02.000000', 'consum', 0.0220, 'lps'),
	(399953, 123, '2015-02-15 00:39:03.000000', 'consum', 0.0216, 'lps'),
	(399954, 123, '2015-02-15 00:39:04.000000', 'consum', 0.0210, 'lps'),
	(399955, 123, '2015-02-15 00:39:05.000000', 'consum', 0.0216, 'lps'),
	(399956, 123, '2015-02-15 00:39:06.000000', 'consum', 0.0220, 'lps'),
	(399957, 123, '2015-02-15 00:39:07.000000', 'consum', 0.0218, 'lps'),
	(399958, 123, '2015-02-15 00:39:08.000000', 'consum', 0.0219, 'lps'),
	(399959, 123, '2015-02-15 00:39:09.000000', 'consum', 0.0212, 'lps'),
	(399960, 123, '2015-02-15 00:39:10.000000', 'consum', 0.0213, 'lps'),
	(399961, 123, '2015-02-15 00:39:11.000000', 'consum', 0.0219, 'lps'),
	(399962, 123, '2015-02-15 00:39:12.000000', 'consum', 0.0215, 'lps'),
	(399963, 123, '2015-02-15 00:39:13.000000', 'consum', 0.0220, 'lps'),
	(399964, 123, '2015-02-15 00:39:14.000000', 'consum', 0.0212, 'lps'),
	(399965, 123, '2015-02-15 00:39:15.000000', 'consum', 0.0213, 'lps'),
	(399966, 123, '2015-02-15 00:39:16.000000', 'consum', 0.0210, 'lps'),
	(399967, 123, '2015-02-15 00:39:17.000000', 'consum', 0.0210, 'lps'),
	(399968, 123, '2015-02-15 00:39:18.000000', 'consum', 0.0210, 'lps'),
	(399969, 123, '2015-02-15 00:39:19.000000', 'consum', 0.0211, 'lps'),
	(399970, 123, '2015-02-15 00:39:20.000000', 'consum', 0.0216, 'lps'),
	(399971, 123, '2015-02-15 00:39:21.000000', 'consum', 0.0215, 'lps'),
	(399972, 123, '2015-02-15 00:39:22.000000', 'consum', 0.0218, 'lps'),
	(399973, 123, '2015-02-15 00:39:23.000000', 'consum', 0.0214, 'lps'),
	(399974, 123, '2015-02-15 00:39:24.000000', 'consum', 0.0218, 'lps'),
	(399975, 123, '2015-02-15 00:39:25.000000', 'consum', 0.0214, 'lps'),
	(399976, 123, '2015-02-15 00:39:26.000000', 'consum', 0.0218, 'lps'),
	(399977, 123, '2015-02-15 00:39:27.000000', 'consum', 0.0219, 'lps'),
	(399978, 123, '2015-02-15 00:39:28.000000', 'consum', 0.0219, 'lps'),
	(399979, 123, '2015-02-15 00:39:29.000000', 'consum', 0.0218, 'lps'),
	(399980, 123, '2015-02-15 00:39:30.000000', 'consum', 0.0210, 'lps'),
	(399981, 123, '2015-02-15 00:39:31.000000', 'consum', 0.0211, 'lps'),
	(399982, 123, '2015-02-15 00:39:32.000000', 'consum', 0.0213, 'lps'),
	(399983, 123, '2015-02-15 00:39:33.000000', 'consum', 0.0213, 'lps'),
	(399984, 123, '2015-02-15 00:39:34.000000', 'consum', 0.0217, 'lps'),
	(399985, 123, '2015-02-15 00:39:35.000000', 'consum', 0.0212, 'lps'),
	(399986, 123, '2015-02-15 00:39:36.000000', 'consum', 0.0212, 'lps'),
	(399987, 123, '2015-02-15 00:39:37.000000', 'consum', 0.0215, 'lps'),
	(399988, 123, '2015-02-15 00:39:38.000000', 'consum', 0.0220, 'lps'),
	(399989, 123, '2015-02-15 00:39:39.000000', 'consum', 0.0212, 'lps'),
	(399990, 123, '2015-02-15 00:39:40.000000', 'consum', 0.0213, 'lps'),
	(399991, 123, '2015-02-15 00:39:41.000000', 'consum', 0.0220, 'lps'),
	(399992, 123, '2015-02-15 00:39:42.000000', 'consum', 0.0219, 'lps'),
	(399993, 123, '2015-02-15 00:39:43.000000', 'consum', 0.0211, 'lps'),
	(399994, 123, '2015-02-15 00:39:44.000000', 'consum', 0.0214, 'lps'),
	(399995, 123, '2015-02-15 00:39:45.000000', 'consum', 0.0216, 'lps'),
	(399996, 123, '2015-02-15 00:39:46.000000', 'consum', 0.0219, 'lps'),
	(399997, 123, '2015-02-15 00:39:47.000000', 'consum', 0.0214, 'lps'),
	(399998, 123, '2015-02-15 00:39:48.000000', 'consum', 0.0213, 'lps'),
	(399999, 123, '2015-02-15 00:39:49.000000', 'consum', 0.0216, 'lps'),
	(400000, 123, '2015-02-15 00:39:50.000000', 'consum', 0.0210, 'lps'),
	(400001, 123, '2015-02-15 00:39:51.000000', 'consum', 0.0213, 'lps'),
	(400002, 123, '2015-02-15 00:39:52.000000', 'consum', 0.0216, 'lps'),
	(400003, 123, '2015-02-15 00:39:53.000000', 'consum', 0.0218, 'lps'),
	(400004, 123, '2015-02-15 00:39:54.000000', 'consum', 0.0213, 'lps'),
	(400005, 123, '2015-02-15 00:39:55.000000', 'consum', 0.0211, 'lps'),
	(400006, 123, '2015-02-15 00:39:56.000000', 'consum', 0.0218, 'lps'),
	(400007, 123, '2015-02-15 00:39:57.000000', 'consum', 0.0215, 'lps'),
	(400008, 123, '2015-02-15 00:39:58.000000', 'consum', 0.0220, 'lps'),
	(400009, 123, '2015-02-15 00:39:59.000000', 'consum', 0.0215, 'lps'),
	(400010, 123, '2015-02-15 00:40:00.000000', 'consum', 0.0216, 'lps'),
	(400011, 123, '2015-02-15 00:40:01.000000', 'consum', 0.0212, 'lps'),
	(400012, 123, '2015-02-15 00:40:02.000000', 'consum', 0.0216, 'lps'),
	(400013, 123, '2015-02-15 00:40:03.000000', 'consum', 0.0213, 'lps'),
	(400014, 123, '2015-02-15 00:40:04.000000', 'consum', 0.0219, 'lps'),
	(400015, 123, '2015-02-15 00:40:05.000000', 'consum', 0.0211, 'lps'),
	(400016, 123, '2015-02-15 00:40:06.000000', 'consum', 0.0211, 'lps'),
	(400017, 123, '2015-02-15 00:40:07.000000', 'consum', 0.0213, 'lps'),
	(400018, 123, '2015-02-15 00:40:08.000000', 'consum', 0.0213, 'lps'),
	(400019, 123, '2015-02-15 00:40:09.000000', 'consum', 0.0215, 'lps'),
	(400020, 123, '2015-02-15 00:40:10.000000', 'consum', 0.0216, 'lps'),
	(400021, 123, '2015-02-15 00:40:11.000000', 'consum', 0.0213, 'lps'),
	(400022, 123, '2015-02-15 00:40:12.000000', 'consum', 0.0210, 'lps'),
	(400023, 123, '2015-02-15 00:40:13.000000', 'consum', 0.0212, 'lps'),
	(400024, 123, '2015-02-15 00:40:14.000000', 'consum', 0.0210, 'lps'),
	(400025, 123, '2015-02-15 00:40:15.000000', 'consum', 0.0216, 'lps'),
	(400026, 123, '2015-02-15 00:40:16.000000', 'consum', 0.0217, 'lps'),
	(400027, 123, '2015-02-15 00:40:17.000000', 'consum', 0.0215, 'lps'),
	(400028, 123, '2015-02-15 00:40:18.000000', 'consum', 0.0217, 'lps'),
	(400029, 123, '2015-02-15 00:40:19.000000', 'consum', 0.0217, 'lps'),
	(400030, 123, '2015-02-15 00:40:20.000000', 'consum', 0.0213, 'lps'),
	(400031, 123, '2015-02-15 00:40:21.000000', 'consum', 0.0217, 'lps'),
	(400032, 123, '2015-02-15 00:40:22.000000', 'consum', 0.0213, 'lps'),
	(400033, 123, '2015-02-15 00:40:23.000000', 'consum', 0.0217, 'lps'),
	(400034, 123, '2015-02-15 00:40:24.000000', 'consum', 0.0213, 'lps'),
	(400035, 123, '2015-02-15 00:40:25.000000', 'consum', 0.0215, 'lps'),
	(400036, 123, '2015-02-15 00:40:26.000000', 'consum', 0.0216, 'lps'),
	(400037, 123, '2015-02-15 00:40:27.000000', 'consum', 0.0214, 'lps'),
	(400038, 123, '2015-02-15 00:40:28.000000', 'consum', 0.0213, 'lps'),
	(400039, 123, '2015-02-15 00:40:29.000000', 'consum', 0.0214, 'lps'),
	(400040, 123, '2015-02-15 00:40:30.000000', 'consum', 0.0211, 'lps'),
	(400041, 123, '2015-02-15 00:40:31.000000', 'consum', 0.0215, 'lps'),
	(400042, 123, '2015-02-15 00:40:32.000000', 'consum', 0.0220, 'lps'),
	(400043, 123, '2015-02-15 00:40:33.000000', 'consum', 0.0213, 'lps'),
	(400044, 123, '2015-02-15 00:40:34.000000', 'consum', 0.0218, 'lps'),
	(400045, 123, '2015-02-15 00:40:35.000000', 'consum', 0.0218, 'lps'),
	(400046, 123, '2015-02-15 00:40:36.000000', 'consum', 0.0215, 'lps'),
	(400047, 123, '2015-02-15 00:40:37.000000', 'consum', 0.0214, 'lps'),
	(400048, 123, '2015-02-15 00:40:38.000000', 'consum', 0.0215, 'lps'),
	(400049, 123, '2015-02-15 00:40:39.000000', 'consum', 0.0211, 'lps'),
	(400050, 123, '2015-02-15 00:40:40.000000', 'consum', 0.0213, 'lps'),
	(400051, 123, '2015-02-15 00:40:41.000000', 'consum', 0.0211, 'lps'),
	(400052, 123, '2015-02-15 00:40:42.000000', 'consum', 0.0220, 'lps'),
	(400053, 123, '2015-02-15 00:40:43.000000', 'consum', 0.0210, 'lps'),
	(400054, 123, '2015-02-15 00:40:44.000000', 'consum', 0.0213, 'lps'),
	(400055, 123, '2015-02-15 00:40:45.000000', 'consum', 0.0217, 'lps'),
	(400056, 123, '2015-02-15 00:40:46.000000', 'consum', 0.0214, 'lps'),
	(400057, 123, '2015-02-15 00:40:47.000000', 'consum', 0.0219, 'lps'),
	(400058, 123, '2015-02-15 00:40:48.000000', 'consum', 0.0212, 'lps'),
	(400059, 123, '2015-02-15 00:40:49.000000', 'consum', 0.0215, 'lps'),
	(400060, 123, '2015-02-15 00:40:50.000000', 'consum', 0.0218, 'lps'),
	(400061, 123, '2015-02-15 00:40:51.000000', 'consum', 0.0216, 'lps'),
	(400062, 123, '2015-02-15 00:40:52.000000', 'consum', 0.0213, 'lps'),
	(400063, 123, '2015-02-15 00:40:53.000000', 'consum', 0.0210, 'lps'),
	(400064, 123, '2015-02-15 00:40:54.000000', 'consum', 0.0214, 'lps'),
	(400065, 123, '2015-02-15 00:40:55.000000', 'consum', 0.0216, 'lps'),
	(400066, 123, '2015-02-15 00:40:56.000000', 'consum', 0.0220, 'lps'),
	(400067, 123, '2015-02-15 00:40:57.000000', 'consum', 0.0219, 'lps'),
	(400068, 123, '2015-02-15 00:40:58.000000', 'consum', 0.0216, 'lps'),
	(400069, 123, '2015-02-15 00:40:59.000000', 'consum', 0.0214, 'lps'),
	(400070, 123, '2015-02-15 00:41:00.000000', 'consum', 0.0214, 'lps'),
	(400071, 123, '2015-02-15 00:41:01.000000', 'consum', 0.0216, 'lps'),
	(400072, 123, '2015-02-15 00:41:02.000000', 'consum', 0.0217, 'lps'),
	(400073, 123, '2015-02-15 00:41:03.000000', 'consum', 0.0218, 'lps'),
	(400074, 123, '2015-02-15 00:41:04.000000', 'consum', 0.0219, 'lps'),
	(400075, 123, '2015-02-15 00:41:05.000000', 'consum', 0.0219, 'lps'),
	(400076, 123, '2015-02-15 00:41:06.000000', 'consum', 0.0219, 'lps'),
	(400077, 123, '2015-02-15 00:41:07.000000', 'consum', 0.0216, 'lps'),
	(400078, 123, '2015-02-15 00:41:08.000000', 'consum', 0.0215, 'lps'),
	(400079, 123, '2015-02-15 00:41:09.000000', 'consum', 0.0218, 'lps'),
	(400080, 123, '2015-02-15 00:41:10.000000', 'consum', 0.0214, 'lps'),
	(400081, 123, '2015-02-15 00:41:11.000000', 'consum', 0.0216, 'lps'),
	(400082, 123, '2015-02-15 00:41:12.000000', 'consum', 0.0219, 'lps'),
	(400083, 123, '2015-02-15 00:41:13.000000', 'consum', 0.0214, 'lps'),
	(400084, 123, '2015-02-15 00:41:14.000000', 'consum', 0.0214, 'lps'),
	(400085, 123, '2015-02-15 00:41:15.000000', 'consum', 0.0220, 'lps'),
	(400086, 123, '2015-02-15 00:41:16.000000', 'consum', 0.0216, 'lps'),
	(400087, 123, '2015-02-15 00:41:17.000000', 'consum', 0.0219, 'lps'),
	(400088, 123, '2015-02-15 00:41:18.000000', 'consum', 0.0217, 'lps'),
	(400089, 123, '2015-02-15 00:41:19.000000', 'consum', 0.0218, 'lps'),
	(400090, 123, '2015-02-15 00:41:20.000000', 'consum', 0.0220, 'lps'),
	(400091, 123, '2015-02-15 00:41:21.000000', 'consum', 0.0214, 'lps'),
	(400092, 123, '2015-02-15 00:41:22.000000', 'consum', 0.0210, 'lps'),
	(400093, 123, '2015-02-15 00:41:23.000000', 'consum', 0.0220, 'lps'),
	(400094, 123, '2015-02-15 00:41:24.000000', 'consum', 0.0219, 'lps'),
	(400095, 123, '2015-02-15 00:41:25.000000', 'consum', 0.0215, 'lps'),
	(400096, 123, '2015-02-15 00:41:26.000000', 'consum', 0.0220, 'lps'),
	(400097, 123, '2015-02-15 00:41:27.000000', 'consum', 0.0211, 'lps'),
	(400098, 123, '2015-02-15 00:41:28.000000', 'consum', 0.0210, 'lps'),
	(400099, 123, '2015-02-15 00:41:29.000000', 'consum', 0.0216, 'lps'),
	(400100, 123, '2015-02-15 00:41:30.000000', 'consum', 0.0220, 'lps'),
	(400101, 123, '2015-02-15 00:41:31.000000', 'consum', 0.0218, 'lps'),
	(400102, 123, '2015-02-15 00:41:32.000000', 'consum', 0.0213, 'lps'),
	(400103, 123, '2015-02-15 00:41:33.000000', 'consum', 0.0210, 'lps'),
	(400104, 123, '2015-02-15 00:41:34.000000', 'consum', 0.0214, 'lps'),
	(400105, 123, '2015-02-15 00:41:35.000000', 'consum', 0.0210, 'lps'),
	(400106, 123, '2015-02-15 00:41:36.000000', 'consum', 0.0219, 'lps'),
	(400107, 123, '2015-02-15 00:41:37.000000', 'consum', 0.0210, 'lps'),
	(400108, 123, '2015-02-15 00:41:38.000000', 'consum', 0.0216, 'lps'),
	(400109, 123, '2015-02-15 00:41:39.000000', 'consum', 0.0219, 'lps'),
	(400110, 123, '2015-02-15 00:41:40.000000', 'consum', 0.0215, 'lps'),
	(400111, 123, '2015-02-15 00:41:41.000000', 'consum', 0.0219, 'lps'),
	(400112, 123, '2015-02-15 00:41:42.000000', 'consum', 0.0219, 'lps'),
	(400113, 123, '2015-02-15 00:41:43.000000', 'consum', 0.0219, 'lps'),
	(400114, 123, '2015-02-15 00:41:44.000000', 'consum', 0.0216, 'lps'),
	(400115, 123, '2015-02-15 00:41:45.000000', 'consum', 0.0215, 'lps'),
	(400116, 123, '2015-02-15 00:41:46.000000', 'consum', 0.0218, 'lps'),
	(400117, 123, '2015-02-15 00:41:47.000000', 'consum', 0.0211, 'lps'),
	(400118, 123, '2015-02-15 00:41:48.000000', 'consum', 0.0215, 'lps'),
	(400119, 123, '2015-02-15 00:41:49.000000', 'consum', 0.0219, 'lps'),
	(400120, 123, '2015-02-15 00:41:50.000000', 'consum', 0.0211, 'lps'),
	(400121, 123, '2015-02-15 00:41:51.000000', 'consum', 0.0220, 'lps'),
	(400122, 123, '2015-02-15 00:41:52.000000', 'consum', 0.0215, 'lps'),
	(400123, 123, '2015-02-15 00:41:53.000000', 'consum', 0.0215, 'lps'),
	(400124, 123, '2015-02-15 00:41:54.000000', 'consum', 0.0211, 'lps'),
	(400125, 123, '2015-02-15 00:41:55.000000', 'consum', 0.0220, 'lps'),
	(400126, 123, '2015-02-15 00:41:56.000000', 'consum', 0.0216, 'lps'),
	(400127, 123, '2015-02-15 00:41:57.000000', 'consum', 0.0220, 'lps'),
	(400128, 123, '2015-02-15 00:41:58.000000', 'consum', 0.0211, 'lps'),
	(400129, 123, '2015-02-15 00:41:59.000000', 'consum', 0.0219, 'lps'),
	(400130, 123, '2015-02-15 00:42:00.000000', 'consum', 0.0220, 'lps'),
	(400131, 123, '2015-02-15 00:42:01.000000', 'consum', 0.0220, 'lps'),
	(400132, 123, '2015-02-15 00:42:02.000000', 'consum', 0.0211, 'lps'),
	(400133, 123, '2015-02-15 00:42:03.000000', 'consum', 0.0216, 'lps'),
	(400134, 123, '2015-02-15 00:42:04.000000', 'consum', 0.0214, 'lps'),
	(400135, 123, '2015-02-15 00:42:05.000000', 'consum', 0.0216, 'lps'),
	(400136, 123, '2015-02-15 00:42:06.000000', 'consum', 0.0217, 'lps'),
	(400137, 123, '2015-02-15 00:42:07.000000', 'consum', 0.0216, 'lps'),
	(400138, 123, '2015-02-15 00:42:08.000000', 'consum', 0.0210, 'lps'),
	(400139, 123, '2015-02-15 00:42:09.000000', 'consum', 0.0214, 'lps'),
	(400140, 123, '2015-02-15 00:42:10.000000', 'consum', 0.0220, 'lps'),
	(400141, 123, '2015-02-15 00:42:11.000000', 'consum', 0.0216, 'lps'),
	(400142, 123, '2015-02-15 00:42:12.000000', 'consum', 0.0211, 'lps'),
	(400143, 123, '2015-02-15 00:42:13.000000', 'consum', 0.0219, 'lps'),
	(400144, 123, '2015-02-15 00:42:14.000000', 'consum', 0.0218, 'lps'),
	(400145, 123, '2015-02-15 00:42:15.000000', 'consum', 0.0212, 'lps'),
	(400146, 123, '2015-02-15 00:42:16.000000', 'consum', 0.0218, 'lps'),
	(400147, 123, '2015-02-15 00:42:17.000000', 'consum', 0.0212, 'lps'),
	(400148, 123, '2015-02-15 00:42:18.000000', 'consum', 0.0219, 'lps'),
	(400149, 123, '2015-02-15 00:42:19.000000', 'consum', 0.0216, 'lps'),
	(400150, 123, '2015-02-15 00:42:20.000000', 'consum', 0.0213, 'lps'),
	(400151, 123, '2015-02-15 00:42:21.000000', 'consum', 0.0210, 'lps'),
	(400152, 123, '2015-02-15 00:42:22.000000', 'consum', 0.0211, 'lps'),
	(400153, 123, '2015-02-15 00:42:23.000000', 'consum', 0.0214, 'lps'),
	(400154, 123, '2015-02-15 00:42:24.000000', 'consum', 0.0217, 'lps'),
	(400155, 123, '2015-02-15 00:42:25.000000', 'consum', 0.0210, 'lps'),
	(400156, 123, '2015-02-15 00:42:26.000000', 'consum', 0.0214, 'lps'),
	(400157, 123, '2015-02-15 00:42:27.000000', 'consum', 0.0219, 'lps'),
	(400158, 123, '2015-02-15 00:42:28.000000', 'consum', 0.0220, 'lps'),
	(400159, 123, '2015-02-15 00:42:29.000000', 'consum', 0.0211, 'lps'),
	(400160, 123, '2015-02-15 00:42:30.000000', 'consum', 0.0218, 'lps'),
	(400161, 123, '2015-02-15 00:42:31.000000', 'consum', 0.0217, 'lps'),
	(400162, 123, '2015-02-15 00:42:32.000000', 'consum', 0.0219, 'lps'),
	(400163, 123, '2015-02-15 00:42:33.000000', 'consum', 0.0212, 'lps'),
	(400164, 123, '2015-02-15 00:42:34.000000', 'consum', 0.0217, 'lps'),
	(400165, 123, '2015-02-15 00:42:35.000000', 'consum', 0.0216, 'lps'),
	(400166, 123, '2015-02-15 00:42:36.000000', 'consum', 0.0219, 'lps'),
	(400167, 123, '2015-02-15 00:42:37.000000', 'consum', 0.0218, 'lps'),
	(400168, 123, '2015-02-15 00:42:38.000000', 'consum', 0.0210, 'lps'),
	(400169, 123, '2015-02-15 00:42:39.000000', 'consum', 0.0219, 'lps'),
	(400170, 123, '2015-02-15 00:42:40.000000', 'consum', 0.0214, 'lps'),
	(400171, 123, '2015-02-15 00:42:41.000000', 'consum', 0.0215, 'lps'),
	(400172, 123, '2015-02-15 00:42:42.000000', 'consum', 0.0213, 'lps'),
	(400173, 123, '2015-02-15 00:42:43.000000', 'consum', 0.0220, 'lps'),
	(400174, 123, '2015-02-15 00:42:44.000000', 'consum', 0.0217, 'lps'),
	(400175, 123, '2015-02-15 00:42:45.000000', 'consum', 0.0218, 'lps'),
	(400176, 123, '2015-02-15 00:42:46.000000', 'consum', 0.0218, 'lps'),
	(400177, 123, '2015-02-15 00:42:47.000000', 'consum', 0.0217, 'lps'),
	(400178, 123, '2015-02-15 00:42:48.000000', 'consum', 0.0220, 'lps'),
	(400179, 123, '2015-02-15 00:42:49.000000', 'consum', 0.0218, 'lps'),
	(400180, 123, '2015-02-15 00:42:50.000000', 'consum', 0.0210, 'lps'),
	(400181, 123, '2015-02-15 00:42:51.000000', 'consum', 0.0219, 'lps'),
	(400182, 123, '2015-02-15 00:42:52.000000', 'consum', 0.0210, 'lps'),
	(400183, 123, '2015-02-15 00:42:53.000000', 'consum', 0.0220, 'lps'),
	(400184, 123, '2015-02-15 00:42:54.000000', 'consum', 0.0213, 'lps'),
	(400185, 123, '2015-02-15 00:42:55.000000', 'consum', 0.0219, 'lps'),
	(400186, 123, '2015-02-15 00:42:56.000000', 'consum', 0.0213, 'lps'),
	(400187, 123, '2015-02-15 00:42:57.000000', 'consum', 0.0219, 'lps'),
	(400188, 123, '2015-02-15 00:42:58.000000', 'consum', 0.0214, 'lps'),
	(400189, 123, '2015-02-15 00:42:59.000000', 'consum', 0.0217, 'lps'),
	(400190, 123, '2015-02-15 00:43:00.000000', 'consum', 0.0211, 'lps'),
	(400191, 123, '2015-02-15 00:43:01.000000', 'consum', 0.0214, 'lps'),
	(400192, 123, '2015-02-15 00:43:02.000000', 'consum', 0.0220, 'lps'),
	(400193, 123, '2015-02-15 00:43:03.000000', 'consum', 0.0213, 'lps'),
	(400194, 123, '2015-02-15 00:43:04.000000', 'consum', 0.0219, 'lps'),
	(400195, 123, '2015-02-15 00:43:05.000000', 'consum', 0.0213, 'lps'),
	(400196, 123, '2015-02-15 00:43:06.000000', 'consum', 0.0211, 'lps'),
	(400197, 123, '2015-02-15 00:43:07.000000', 'consum', 0.0217, 'lps'),
	(400198, 123, '2015-02-15 00:43:08.000000', 'consum', 0.0220, 'lps'),
	(400199, 123, '2015-02-15 00:43:09.000000', 'consum', 0.0216, 'lps'),
	(400200, 123, '2015-02-15 00:43:10.000000', 'consum', 0.0211, 'lps'),
	(400201, 123, '2015-02-15 00:43:11.000000', 'consum', 0.0220, 'lps'),
	(400202, 123, '2015-02-15 00:43:12.000000', 'consum', 0.0214, 'lps'),
	(400203, 123, '2015-02-15 00:43:13.000000', 'consum', 0.0210, 'lps'),
	(400204, 123, '2015-02-15 00:43:14.000000', 'consum', 0.0211, 'lps'),
	(400205, 123, '2015-02-15 00:43:15.000000', 'consum', 0.0217, 'lps'),
	(400206, 123, '2015-02-15 00:43:16.000000', 'consum', 0.0219, 'lps'),
	(400207, 123, '2015-02-15 00:43:17.000000', 'consum', 0.0211, 'lps'),
	(400208, 123, '2015-02-15 00:43:18.000000', 'consum', 0.0213, 'lps'),
	(400209, 123, '2015-02-15 00:43:19.000000', 'consum', 0.0212, 'lps'),
	(400210, 123, '2015-02-15 00:43:20.000000', 'consum', 0.0211, 'lps'),
	(400211, 123, '2015-02-15 00:43:21.000000', 'consum', 0.0219, 'lps'),
	(400212, 123, '2015-02-15 00:43:22.000000', 'consum', 0.0210, 'lps'),
	(400213, 123, '2015-02-15 00:43:23.000000', 'consum', 0.0217, 'lps'),
	(400214, 123, '2015-02-15 00:43:24.000000', 'consum', 0.0214, 'lps'),
	(400215, 123, '2015-02-15 00:43:25.000000', 'consum', 0.0219, 'lps'),
	(400216, 123, '2015-02-15 00:43:26.000000', 'consum', 0.0220, 'lps'),
	(400217, 123, '2015-02-15 00:43:27.000000', 'consum', 0.0213, 'lps'),
	(400218, 123, '2015-02-15 00:43:28.000000', 'consum', 0.0218, 'lps'),
	(400219, 123, '2015-02-15 00:43:29.000000', 'consum', 0.0217, 'lps'),
	(400220, 123, '2015-02-15 00:43:30.000000', 'consum', 0.0212, 'lps'),
	(400221, 123, '2015-02-15 00:43:31.000000', 'consum', 0.0211, 'lps'),
	(400222, 123, '2015-02-15 00:43:32.000000', 'consum', 0.0220, 'lps'),
	(400223, 123, '2015-02-15 00:43:33.000000', 'consum', 0.0213, 'lps'),
	(400224, 123, '2015-02-15 00:43:34.000000', 'consum', 0.0216, 'lps'),
	(400225, 123, '2015-02-15 00:43:35.000000', 'consum', 0.0211, 'lps'),
	(400226, 123, '2015-02-15 00:43:36.000000', 'consum', 0.0219, 'lps'),
	(400227, 123, '2015-02-15 00:43:37.000000', 'consum', 0.0210, 'lps'),
	(400228, 123, '2015-02-15 00:43:38.000000', 'consum', 0.0215, 'lps'),
	(400229, 123, '2015-02-15 00:43:39.000000', 'consum', 0.0215, 'lps'),
	(400230, 123, '2015-02-15 00:43:40.000000', 'consum', 0.0219, 'lps'),
	(400231, 123, '2015-02-15 00:43:41.000000', 'consum', 0.0220, 'lps'),
	(400232, 123, '2015-02-15 00:43:42.000000', 'consum', 0.0210, 'lps'),
	(400233, 123, '2015-02-15 00:43:43.000000', 'consum', 0.0215, 'lps'),
	(400234, 123, '2015-02-15 00:43:44.000000', 'consum', 0.0211, 'lps'),
	(400235, 123, '2015-02-15 00:43:45.000000', 'consum', 0.0214, 'lps'),
	(400236, 123, '2015-02-15 00:43:46.000000', 'consum', 0.0214, 'lps'),
	(400237, 123, '2015-02-15 00:43:47.000000', 'consum', 0.0220, 'lps'),
	(400238, 123, '2015-02-15 00:43:48.000000', 'consum', 0.0217, 'lps'),
	(400239, 123, '2015-02-15 00:43:49.000000', 'consum', 0.0214, 'lps'),
	(400240, 123, '2015-02-15 00:43:50.000000', 'consum', 0.0220, 'lps'),
	(400241, 123, '2015-02-15 00:43:51.000000', 'consum', 0.0214, 'lps'),
	(400242, 123, '2015-02-15 00:43:52.000000', 'consum', 0.0215, 'lps'),
	(400243, 123, '2015-02-15 00:43:53.000000', 'consum', 0.0220, 'lps'),
	(400244, 123, '2015-02-15 00:43:54.000000', 'consum', 0.0214, 'lps'),
	(400245, 123, '2015-02-15 00:43:55.000000', 'consum', 0.0220, 'lps'),
	(400246, 123, '2015-02-15 00:43:56.000000', 'consum', 0.0219, 'lps'),
	(400247, 123, '2015-02-15 00:43:57.000000', 'consum', 0.0213, 'lps'),
	(400248, 123, '2015-02-15 00:43:58.000000', 'consum', 0.0211, 'lps'),
	(400249, 123, '2015-02-15 00:43:59.000000', 'consum', 0.0217, 'lps'),
	(400250, 123, '2015-02-15 00:44:00.000000', 'consum', 0.0220, 'lps'),
	(400251, 123, '2015-02-15 00:44:01.000000', 'consum', 0.0218, 'lps'),
	(400252, 123, '2015-02-15 00:44:02.000000', 'consum', 0.0210, 'lps'),
	(400253, 123, '2015-02-15 00:44:03.000000', 'consum', 0.0218, 'lps'),
	(400254, 123, '2015-02-15 00:44:04.000000', 'consum', 0.0219, 'lps'),
	(400255, 123, '2015-02-15 00:44:05.000000', 'consum', 0.0211, 'lps'),
	(400256, 123, '2015-02-15 00:44:06.000000', 'consum', 0.0218, 'lps'),
	(400257, 123, '2015-02-15 00:44:07.000000', 'consum', 0.0216, 'lps'),
	(400258, 123, '2015-02-15 00:44:08.000000', 'consum', 0.0216, 'lps'),
	(400259, 123, '2015-02-15 00:44:09.000000', 'consum', 0.0210, 'lps'),
	(400260, 123, '2015-02-15 00:44:10.000000', 'consum', 0.0217, 'lps'),
	(400261, 123, '2015-02-15 00:44:11.000000', 'consum', 0.0211, 'lps'),
	(400262, 123, '2015-02-15 00:44:12.000000', 'consum', 0.0218, 'lps'),
	(400263, 123, '2015-02-15 00:44:13.000000', 'consum', 0.0213, 'lps'),
	(400264, 123, '2015-02-15 00:44:14.000000', 'consum', 0.0213, 'lps'),
	(400265, 123, '2015-02-15 00:44:15.000000', 'consum', 0.0215, 'lps'),
	(400266, 123, '2015-02-15 00:44:16.000000', 'consum', 0.0215, 'lps'),
	(400267, 123, '2015-02-15 00:44:17.000000', 'consum', 0.0212, 'lps'),
	(400268, 123, '2015-02-15 00:44:18.000000', 'consum', 0.0214, 'lps'),
	(400269, 123, '2015-02-15 00:44:19.000000', 'consum', 0.0215, 'lps'),
	(400270, 123, '2015-02-15 00:44:20.000000', 'consum', 0.0211, 'lps'),
	(400271, 123, '2015-02-15 00:44:21.000000', 'consum', 0.0212, 'lps'),
	(400272, 123, '2015-02-15 00:44:22.000000', 'consum', 0.0216, 'lps'),
	(400273, 123, '2015-02-15 00:44:23.000000', 'consum', 0.0213, 'lps'),
	(400274, 123, '2015-02-15 00:44:24.000000', 'consum', 0.0218, 'lps'),
	(400275, 123, '2015-02-15 00:44:25.000000', 'consum', 0.0210, 'lps'),
	(400276, 123, '2015-02-15 00:44:26.000000', 'consum', 0.0220, 'lps'),
	(400277, 123, '2015-02-15 00:44:27.000000', 'consum', 0.0216, 'lps'),
	(400278, 123, '2015-02-15 00:44:28.000000', 'consum', 0.0220, 'lps'),
	(400279, 123, '2015-02-15 00:44:29.000000', 'consum', 0.0211, 'lps'),
	(400280, 123, '2015-02-15 00:44:30.000000', 'consum', 0.0217, 'lps'),
	(400281, 123, '2015-02-15 00:44:31.000000', 'consum', 0.0220, 'lps'),
	(400282, 123, '2015-02-15 00:44:32.000000', 'consum', 0.0216, 'lps'),
	(400283, 123, '2015-02-15 00:44:33.000000', 'consum', 0.0214, 'lps'),
	(400284, 123, '2015-02-15 00:44:34.000000', 'consum', 0.0210, 'lps'),
	(400285, 123, '2015-02-15 00:44:35.000000', 'consum', 0.0219, 'lps'),
	(400286, 123, '2015-02-15 00:44:36.000000', 'consum', 0.0215, 'lps'),
	(400287, 123, '2015-02-15 00:44:37.000000', 'consum', 0.0216, 'lps'),
	(400288, 123, '2015-02-15 00:44:38.000000', 'consum', 0.0218, 'lps'),
	(400289, 123, '2015-02-15 00:44:39.000000', 'consum', 0.0218, 'lps'),
	(400290, 123, '2015-02-15 00:44:40.000000', 'consum', 0.0218, 'lps'),
	(400291, 123, '2015-02-15 00:44:41.000000', 'consum', 0.0213, 'lps'),
	(400292, 123, '2015-02-15 00:44:42.000000', 'consum', 0.0213, 'lps'),
	(400293, 123, '2015-02-15 00:44:43.000000', 'consum', 0.0217, 'lps'),
	(400294, 123, '2015-02-15 00:44:44.000000', 'consum', 0.0215, 'lps'),
	(400295, 123, '2015-02-15 00:44:45.000000', 'consum', 0.0214, 'lps'),
	(400296, 123, '2015-02-15 00:44:46.000000', 'consum', 0.0218, 'lps'),
	(400297, 123, '2015-02-15 00:44:47.000000', 'consum', 0.0213, 'lps'),
	(400298, 123, '2015-02-15 00:44:48.000000', 'consum', 0.0212, 'lps'),
	(400299, 123, '2015-02-15 00:44:49.000000', 'consum', 0.0215, 'lps'),
	(400300, 123, '2015-02-15 00:44:50.000000', 'consum', 0.0216, 'lps'),
	(400301, 123, '2015-02-15 00:44:51.000000', 'consum', 0.0214, 'lps'),
	(400302, 123, '2015-02-15 00:44:52.000000', 'consum', 0.0215, 'lps'),
	(400303, 123, '2015-02-15 00:44:53.000000', 'consum', 0.0211, 'lps'),
	(400304, 123, '2015-02-15 00:44:54.000000', 'consum', 0.0210, 'lps'),
	(400305, 123, '2015-02-15 00:44:55.000000', 'consum', 0.0211, 'lps'),
	(400306, 123, '2015-02-15 00:44:56.000000', 'consum', 0.0213, 'lps'),
	(400307, 123, '2015-02-15 00:44:57.000000', 'consum', 0.0212, 'lps'),
	(400308, 123, '2015-02-15 00:44:58.000000', 'consum', 0.0210, 'lps'),
	(400309, 123, '2015-02-15 00:44:59.000000', 'consum', 0.0215, 'lps'),
	(400310, 123, '2015-02-15 00:45:00.000000', 'consum', 0.0213, 'lps'),
	(400311, 123, '2015-02-15 00:45:01.000000', 'consum', 0.0212, 'lps'),
	(400312, 123, '2015-02-15 00:45:02.000000', 'consum', 0.0211, 'lps'),
	(400313, 123, '2015-02-15 00:45:03.000000', 'consum', 0.0210, 'lps'),
	(400314, 123, '2015-02-15 00:45:04.000000', 'consum', 0.0219, 'lps'),
	(400315, 123, '2015-02-15 00:45:05.000000', 'consum', 0.0210, 'lps'),
	(400316, 123, '2015-02-15 00:45:06.000000', 'consum', 0.0217, 'lps'),
	(400317, 123, '2015-02-15 00:45:07.000000', 'consum', 0.0213, 'lps'),
	(400318, 123, '2015-02-15 00:45:08.000000', 'consum', 0.0216, 'lps'),
	(400319, 123, '2015-02-15 00:45:09.000000', 'consum', 0.0220, 'lps'),
	(400320, 123, '2015-02-15 00:45:10.000000', 'consum', 0.0220, 'lps'),
	(400321, 123, '2015-02-15 00:45:11.000000', 'consum', 0.0219, 'lps'),
	(400322, 123, '2015-02-15 00:45:12.000000', 'consum', 0.0214, 'lps'),
	(400323, 123, '2015-02-15 00:45:13.000000', 'consum', 0.0217, 'lps'),
	(400324, 123, '2015-02-15 00:45:14.000000', 'consum', 0.0220, 'lps'),
	(400325, 123, '2015-02-15 00:45:15.000000', 'consum', 0.0218, 'lps'),
	(400326, 123, '2015-02-15 00:45:16.000000', 'consum', 0.0220, 'lps'),
	(400327, 123, '2015-02-15 00:45:17.000000', 'consum', 0.0217, 'lps'),
	(400328, 123, '2015-02-15 00:45:18.000000', 'consum', 0.0213, 'lps'),
	(400329, 123, '2015-02-15 00:45:19.000000', 'consum', 0.0218, 'lps'),
	(400330, 123, '2015-02-15 00:45:20.000000', 'consum', 0.0218, 'lps'),
	(400331, 123, '2015-02-15 00:45:21.000000', 'consum', 0.0216, 'lps'),
	(400332, 123, '2015-02-15 00:45:22.000000', 'consum', 0.0218, 'lps'),
	(400333, 123, '2015-02-15 00:45:23.000000', 'consum', 0.0220, 'lps'),
	(400334, 123, '2015-02-15 00:45:24.000000', 'consum', 0.0217, 'lps'),
	(400335, 123, '2015-02-15 00:45:25.000000', 'consum', 0.0213, 'lps'),
	(400336, 123, '2015-02-15 00:45:26.000000', 'consum', 0.0217, 'lps'),
	(400337, 123, '2015-02-15 00:45:27.000000', 'consum', 0.0215, 'lps'),
	(400338, 123, '2015-02-15 00:45:28.000000', 'consum', 0.0212, 'lps'),
	(400339, 123, '2015-02-15 00:45:29.000000', 'consum', 0.0220, 'lps'),
	(400340, 123, '2015-02-15 00:45:30.000000', 'consum', 0.0219, 'lps'),
	(400341, 123, '2015-02-15 00:45:31.000000', 'consum', 0.0215, 'lps'),
	(400342, 123, '2015-02-15 00:45:32.000000', 'consum', 0.0218, 'lps'),
	(400343, 123, '2015-02-15 00:45:33.000000', 'consum', 0.0213, 'lps'),
	(400344, 123, '2015-02-15 00:45:34.000000', 'consum', 0.0212, 'lps'),
	(400345, 123, '2015-02-15 00:45:35.000000', 'consum', 0.0213, 'lps'),
	(400346, 123, '2015-02-15 00:45:36.000000', 'consum', 0.0220, 'lps'),
	(400347, 123, '2015-02-15 00:45:37.000000', 'consum', 0.0216, 'lps'),
	(400348, 123, '2015-02-15 00:45:38.000000', 'consum', 0.0213, 'lps'),
	(400349, 123, '2015-02-15 00:45:39.000000', 'consum', 0.0218, 'lps'),
	(400350, 123, '2015-02-15 00:45:40.000000', 'consum', 0.0220, 'lps'),
	(400351, 123, '2015-02-15 00:45:41.000000', 'consum', 0.0214, 'lps'),
	(400352, 123, '2015-02-15 00:45:42.000000', 'consum', 0.0210, 'lps'),
	(400353, 123, '2015-02-15 00:45:43.000000', 'consum', 0.0212, 'lps'),
	(400354, 123, '2015-02-15 00:45:44.000000', 'consum', 0.0219, 'lps'),
	(400355, 123, '2015-02-15 00:45:45.000000', 'consum', 0.0218, 'lps'),
	(400356, 123, '2015-02-15 00:45:46.000000', 'consum', 0.0213, 'lps'),
	(400357, 123, '2015-02-15 00:45:47.000000', 'consum', 0.0212, 'lps'),
	(400358, 123, '2015-02-15 00:45:48.000000', 'consum', 0.0211, 'lps'),
	(400359, 123, '2015-02-15 00:45:49.000000', 'consum', 0.0212, 'lps'),
	(400360, 123, '2015-02-15 00:45:50.000000', 'consum', 0.0215, 'lps'),
	(400361, 123, '2015-02-15 00:45:51.000000', 'consum', 0.0219, 'lps'),
	(400362, 123, '2015-02-15 00:45:52.000000', 'consum', 0.0218, 'lps'),
	(400363, 123, '2015-02-15 00:45:53.000000', 'consum', 0.0211, 'lps'),
	(400364, 123, '2015-02-15 00:45:54.000000', 'consum', 0.0214, 'lps'),
	(400365, 123, '2015-02-15 00:45:55.000000', 'consum', 0.0216, 'lps'),
	(400366, 123, '2015-02-15 00:45:56.000000', 'consum', 0.0220, 'lps'),
	(400367, 123, '2015-02-15 00:45:57.000000', 'consum', 0.0220, 'lps'),
	(400368, 123, '2015-02-15 00:45:58.000000', 'consum', 0.0210, 'lps'),
	(400369, 123, '2015-02-15 00:45:59.000000', 'consum', 0.0211, 'lps'),
	(400370, 123, '2015-02-15 00:46:00.000000', 'consum', 0.0218, 'lps'),
	(400371, 123, '2015-02-15 00:46:01.000000', 'consum', 0.0215, 'lps'),
	(400372, 123, '2015-02-15 00:46:02.000000', 'consum', 0.0220, 'lps'),
	(400373, 123, '2015-02-15 00:46:03.000000', 'consum', 0.0214, 'lps'),
	(400374, 123, '2015-02-15 00:46:04.000000', 'consum', 0.0211, 'lps'),
	(400375, 123, '2015-02-15 00:46:05.000000', 'consum', 0.0215, 'lps'),
	(400376, 123, '2015-02-15 00:46:06.000000', 'consum', 0.0210, 'lps'),
	(400377, 123, '2015-02-15 00:46:07.000000', 'consum', 0.0218, 'lps'),
	(400378, 123, '2015-02-15 00:46:08.000000', 'consum', 0.0217, 'lps'),
	(400379, 123, '2015-02-15 00:46:09.000000', 'consum', 0.0212, 'lps'),
	(400380, 123, '2015-02-15 00:46:10.000000', 'consum', 0.0210, 'lps'),
	(400381, 123, '2015-02-15 00:46:11.000000', 'consum', 0.0215, 'lps'),
	(400382, 123, '2015-02-15 00:46:12.000000', 'consum', 0.0212, 'lps'),
	(400383, 123, '2015-02-15 00:46:13.000000', 'consum', 0.0219, 'lps'),
	(400384, 123, '2015-02-15 00:46:14.000000', 'consum', 0.0215, 'lps'),
	(400385, 123, '2015-02-15 00:46:15.000000', 'consum', 0.0219, 'lps'),
	(400386, 123, '2015-02-15 00:46:16.000000', 'consum', 0.0210, 'lps'),
	(400387, 123, '2015-02-15 00:46:17.000000', 'consum', 0.0213, 'lps'),
	(400388, 123, '2015-02-15 00:46:18.000000', 'consum', 0.0217, 'lps'),
	(400389, 123, '2015-02-15 00:46:19.000000', 'consum', 0.0213, 'lps'),
	(400390, 123, '2015-02-15 00:46:20.000000', 'consum', 0.0217, 'lps'),
	(400391, 123, '2015-02-15 00:46:21.000000', 'consum', 0.0213, 'lps'),
	(400392, 123, '2015-02-15 00:46:22.000000', 'consum', 0.0215, 'lps'),
	(400393, 123, '2015-02-15 00:46:23.000000', 'consum', 0.0216, 'lps'),
	(400394, 123, '2015-02-15 00:46:24.000000', 'consum', 0.0216, 'lps'),
	(400395, 123, '2015-02-15 00:46:25.000000', 'consum', 0.0210, 'lps'),
	(400396, 123, '2015-02-15 00:46:26.000000', 'consum', 0.0215, 'lps'),
	(400397, 123, '2015-02-15 00:46:27.000000', 'consum', 0.0213, 'lps'),
	(400398, 123, '2015-02-15 00:46:28.000000', 'consum', 0.0220, 'lps'),
	(400399, 123, '2015-02-15 00:46:29.000000', 'consum', 0.0220, 'lps'),
	(400400, 123, '2015-02-15 00:46:30.000000', 'consum', 0.0210, 'lps'),
	(400401, 123, '2015-02-15 00:46:31.000000', 'consum', 0.0213, 'lps'),
	(400402, 123, '2015-02-15 00:46:32.000000', 'consum', 0.0213, 'lps'),
	(400403, 123, '2015-02-15 00:46:33.000000', 'consum', 0.0217, 'lps'),
	(400404, 123, '2015-02-15 00:46:34.000000', 'consum', 0.0216, 'lps'),
	(400405, 123, '2015-02-15 00:46:35.000000', 'consum', 0.0219, 'lps'),
	(400406, 123, '2015-02-15 00:46:36.000000', 'consum', 0.0217, 'lps'),
	(400407, 123, '2015-02-15 00:46:37.000000', 'consum', 0.0219, 'lps'),
	(400408, 123, '2015-02-15 00:46:38.000000', 'consum', 0.0220, 'lps'),
	(400409, 123, '2015-02-15 00:46:39.000000', 'consum', 0.0214, 'lps'),
	(400410, 123, '2015-02-15 00:46:40.000000', 'consum', 0.0210, 'lps'),
	(400411, 123, '2015-02-15 00:46:41.000000', 'consum', 0.0212, 'lps'),
	(400412, 123, '2015-02-15 00:46:42.000000', 'consum', 0.0218, 'lps'),
	(400413, 123, '2015-02-15 00:46:43.000000', 'consum', 0.0211, 'lps'),
	(400414, 123, '2015-02-15 00:46:44.000000', 'consum', 0.0216, 'lps'),
	(400415, 123, '2015-02-15 00:46:45.000000', 'consum', 0.0213, 'lps'),
	(400416, 123, '2015-02-15 00:46:46.000000', 'consum', 0.0219, 'lps'),
	(400417, 123, '2015-02-15 00:46:47.000000', 'consum', 0.0216, 'lps'),
	(400418, 123, '2015-02-15 00:46:48.000000', 'consum', 0.0211, 'lps'),
	(400419, 123, '2015-02-15 00:46:49.000000', 'consum', 0.0219, 'lps'),
	(400420, 123, '2015-02-15 00:46:50.000000', 'consum', 0.0219, 'lps'),
	(400421, 123, '2015-02-15 00:46:51.000000', 'consum', 0.0218, 'lps'),
	(400422, 123, '2015-02-15 00:46:52.000000', 'consum', 0.0214, 'lps'),
	(400423, 123, '2015-02-15 00:46:53.000000', 'consum', 0.0217, 'lps'),
	(400424, 123, '2015-02-15 00:46:54.000000', 'consum', 0.0220, 'lps'),
	(400425, 123, '2015-02-15 00:46:55.000000', 'consum', 0.0220, 'lps'),
	(400426, 123, '2015-02-15 00:46:56.000000', 'consum', 0.0220, 'lps'),
	(400427, 123, '2015-02-15 00:46:57.000000', 'consum', 0.0220, 'lps'),
	(400428, 123, '2015-02-15 00:46:58.000000', 'consum', 0.0220, 'lps'),
	(400429, 123, '2015-02-15 00:46:59.000000', 'consum', 0.0220, 'lps'),
	(400430, 123, '2015-02-15 00:47:00.000000', 'consum', 0.0217, 'lps'),
	(400431, 123, '2015-02-15 00:47:01.000000', 'consum', 0.0215, 'lps'),
	(400432, 123, '2015-02-15 00:47:02.000000', 'consum', 0.0214, 'lps'),
	(400433, 123, '2015-02-15 00:47:03.000000', 'consum', 0.0218, 'lps'),
	(400434, 123, '2015-02-15 00:47:04.000000', 'consum', 0.0214, 'lps'),
	(400435, 123, '2015-02-15 00:47:05.000000', 'consum', 0.0220, 'lps'),
	(400436, 123, '2015-02-15 00:47:06.000000', 'consum', 0.0216, 'lps'),
	(400437, 123, '2015-02-15 00:47:07.000000', 'consum', 0.0212, 'lps'),
	(400438, 123, '2015-02-15 00:47:08.000000', 'consum', 0.0210, 'lps'),
	(400439, 123, '2015-02-15 00:47:09.000000', 'consum', 0.0216, 'lps'),
	(400440, 123, '2015-02-15 00:47:10.000000', 'consum', 0.0218, 'lps'),
	(400441, 123, '2015-02-15 00:47:11.000000', 'consum', 0.0210, 'lps'),
	(400442, 123, '2015-02-15 00:47:12.000000', 'consum', 0.0218, 'lps'),
	(400443, 123, '2015-02-15 00:47:13.000000', 'consum', 0.0220, 'lps'),
	(400444, 123, '2015-02-15 00:47:14.000000', 'consum', 0.0214, 'lps'),
	(400445, 123, '2015-02-15 00:47:15.000000', 'consum', 0.0211, 'lps'),
	(400446, 123, '2015-02-15 00:47:16.000000', 'consum', 0.0215, 'lps'),
	(400447, 123, '2015-02-15 00:47:17.000000', 'consum', 0.0211, 'lps'),
	(400448, 123, '2015-02-15 00:47:18.000000', 'consum', 0.0211, 'lps'),
	(400449, 123, '2015-02-15 00:47:19.000000', 'consum', 0.0211, 'lps'),
	(400450, 123, '2015-02-15 00:47:20.000000', 'consum', 0.0213, 'lps'),
	(400451, 123, '2015-02-15 00:47:21.000000', 'consum', 0.0214, 'lps'),
	(400452, 123, '2015-02-15 00:47:22.000000', 'consum', 0.0218, 'lps'),
	(400453, 123, '2015-02-15 00:47:23.000000', 'consum', 0.0218, 'lps'),
	(400454, 123, '2015-02-15 00:47:24.000000', 'consum', 0.0215, 'lps'),
	(400455, 123, '2015-02-15 00:47:25.000000', 'consum', 0.0214, 'lps'),
	(400456, 123, '2015-02-15 00:47:26.000000', 'consum', 0.0213, 'lps'),
	(400457, 123, '2015-02-15 00:47:27.000000', 'consum', 0.0212, 'lps'),
	(400458, 123, '2015-02-15 00:47:28.000000', 'consum', 0.0215, 'lps'),
	(400459, 123, '2015-02-15 00:47:29.000000', 'consum', 0.0216, 'lps'),
	(400460, 123, '2015-02-15 00:47:30.000000', 'consum', 0.0214, 'lps'),
	(400461, 123, '2015-02-15 00:47:31.000000', 'consum', 0.0213, 'lps'),
	(400462, 123, '2015-02-15 00:47:32.000000', 'consum', 0.0212, 'lps'),
	(400463, 123, '2015-02-15 00:47:33.000000', 'consum', 0.0212, 'lps'),
	(400464, 123, '2015-02-15 00:47:34.000000', 'consum', 0.0215, 'lps'),
	(400465, 123, '2015-02-15 00:47:35.000000', 'consum', 0.0218, 'lps'),
	(400466, 123, '2015-02-15 00:47:36.000000', 'consum', 0.0215, 'lps'),
	(400467, 123, '2015-02-15 00:47:37.000000', 'consum', 0.0213, 'lps'),
	(400468, 123, '2015-02-15 00:47:38.000000', 'consum', 0.0218, 'lps'),
	(400469, 123, '2015-02-15 00:47:39.000000', 'consum', 0.0211, 'lps'),
	(400470, 123, '2015-02-15 00:47:40.000000', 'consum', 0.0212, 'lps'),
	(400471, 123, '2015-02-15 00:47:41.000000', 'consum', 0.0220, 'lps'),
	(400472, 123, '2015-02-15 00:47:42.000000', 'consum', 0.0220, 'lps'),
	(400473, 123, '2015-02-15 00:47:43.000000', 'consum', 0.0210, 'lps'),
	(400474, 123, '2015-02-15 00:47:44.000000', 'consum', 0.0214, 'lps'),
	(400475, 123, '2015-02-15 00:47:45.000000', 'consum', 0.0220, 'lps'),
	(400476, 123, '2015-02-15 00:47:46.000000', 'consum', 0.0212, 'lps'),
	(400477, 123, '2015-02-15 00:47:47.000000', 'consum', 0.0215, 'lps'),
	(400478, 123, '2015-02-15 00:47:48.000000', 'consum', 0.0220, 'lps'),
	(400479, 123, '2015-02-15 00:47:49.000000', 'consum', 0.0211, 'lps'),
	(400480, 123, '2015-02-15 00:47:50.000000', 'consum', 0.0218, 'lps'),
	(400481, 123, '2015-02-15 00:47:51.000000', 'consum', 0.0216, 'lps'),
	(400482, 123, '2015-02-15 00:47:52.000000', 'consum', 0.0218, 'lps'),
	(400483, 123, '2015-02-15 00:47:53.000000', 'consum', 0.0219, 'lps'),
	(400484, 123, '2015-02-15 00:47:54.000000', 'consum', 0.0210, 'lps'),
	(400485, 123, '2015-02-15 00:47:55.000000', 'consum', 0.0216, 'lps'),
	(400486, 123, '2015-02-15 00:47:56.000000', 'consum', 0.0220, 'lps'),
	(400487, 123, '2015-02-15 00:47:57.000000', 'consum', 0.0218, 'lps'),
	(400488, 123, '2015-02-15 00:47:58.000000', 'consum', 0.0211, 'lps'),
	(400489, 123, '2015-02-15 00:47:59.000000', 'consum', 0.0212, 'lps'),
	(400490, 123, '2015-02-15 00:48:00.000000', 'consum', 0.0218, 'lps'),
	(400491, 123, '2015-02-15 00:48:01.000000', 'consum', 0.0214, 'lps'),
	(400492, 123, '2015-02-15 00:48:02.000000', 'consum', 0.0215, 'lps'),
	(400493, 123, '2015-02-15 00:48:03.000000', 'consum', 0.0215, 'lps'),
	(400494, 123, '2015-02-15 00:48:04.000000', 'consum', 0.0219, 'lps'),
	(400495, 123, '2015-02-15 00:48:05.000000', 'consum', 0.0217, 'lps'),
	(400496, 123, '2015-02-15 00:48:06.000000', 'consum', 0.0220, 'lps'),
	(400497, 123, '2015-02-15 00:48:07.000000', 'consum', 0.0216, 'lps'),
	(400498, 123, '2015-02-15 00:48:08.000000', 'consum', 0.0213, 'lps'),
	(400499, 123, '2015-02-15 00:48:09.000000', 'consum', 0.0218, 'lps'),
	(400500, 123, '2015-02-15 00:48:10.000000', 'consum', 0.0218, 'lps'),
	(400501, 123, '2015-02-15 00:48:11.000000', 'consum', 0.0216, 'lps'),
	(400502, 123, '2015-02-15 00:48:12.000000', 'consum', 0.0216, 'lps'),
	(400503, 123, '2015-02-15 00:48:13.000000', 'consum', 0.0213, 'lps'),
	(400504, 123, '2015-02-15 00:48:14.000000', 'consum', 0.0219, 'lps'),
	(400505, 123, '2015-02-15 00:48:15.000000', 'consum', 0.0211, 'lps'),
	(400506, 123, '2015-02-15 00:48:16.000000', 'consum', 0.0214, 'lps'),
	(400507, 123, '2015-02-15 00:48:17.000000', 'consum', 0.0214, 'lps'),
	(400508, 123, '2015-02-15 00:48:18.000000', 'consum', 0.0219, 'lps'),
	(400509, 123, '2015-02-15 00:48:19.000000', 'consum', 0.0210, 'lps'),
	(400510, 123, '2015-02-15 00:48:20.000000', 'consum', 0.0216, 'lps'),
	(400511, 123, '2015-02-15 00:48:21.000000', 'consum', 0.0218, 'lps'),
	(400512, 123, '2015-02-15 00:48:22.000000', 'consum', 0.0212, 'lps'),
	(400513, 123, '2015-02-15 00:48:23.000000', 'consum', 0.0218, 'lps'),
	(400514, 123, '2015-02-15 00:48:24.000000', 'consum', 0.0220, 'lps'),
	(400515, 123, '2015-02-15 00:48:25.000000', 'consum', 0.0218, 'lps'),
	(400516, 123, '2015-02-15 00:48:26.000000', 'consum', 0.0220, 'lps'),
	(400517, 123, '2015-02-15 00:48:27.000000', 'consum', 0.0215, 'lps'),
	(400518, 123, '2015-02-15 00:48:28.000000', 'consum', 0.0214, 'lps'),
	(400519, 123, '2015-02-15 00:48:29.000000', 'consum', 0.0217, 'lps'),
	(400520, 123, '2015-02-15 00:48:30.000000', 'consum', 0.0220, 'lps'),
	(400521, 123, '2015-02-15 00:48:31.000000', 'consum', 0.0210, 'lps'),
	(400522, 123, '2015-02-15 00:48:32.000000', 'consum', 0.0212, 'lps'),
	(400523, 123, '2015-02-15 00:48:33.000000', 'consum', 0.0219, 'lps'),
	(400524, 123, '2015-02-15 00:48:34.000000', 'consum', 0.0219, 'lps'),
	(400525, 123, '2015-02-15 00:48:35.000000', 'consum', 0.0217, 'lps'),
	(400526, 123, '2015-02-15 00:48:36.000000', 'consum', 0.0216, 'lps'),
	(400527, 123, '2015-02-15 00:48:37.000000', 'consum', 0.0211, 'lps'),
	(400528, 123, '2015-02-15 00:48:38.000000', 'consum', 0.0210, 'lps'),
	(400529, 123, '2015-02-15 00:48:39.000000', 'consum', 0.0216, 'lps'),
	(400530, 123, '2015-02-15 00:48:40.000000', 'consum', 0.0219, 'lps'),
	(400531, 123, '2015-02-15 00:48:41.000000', 'consum', 0.0217, 'lps'),
	(400532, 123, '2015-02-15 00:48:42.000000', 'consum', 0.0218, 'lps'),
	(400533, 123, '2015-02-15 00:48:43.000000', 'consum', 0.0217, 'lps'),
	(400534, 123, '2015-02-15 00:48:44.000000', 'consum', 0.0213, 'lps'),
	(400535, 123, '2015-02-15 00:48:45.000000', 'consum', 0.0214, 'lps'),
	(400536, 123, '2015-02-15 00:48:46.000000', 'consum', 0.0220, 'lps'),
	(400537, 123, '2015-02-15 00:48:47.000000', 'consum', 0.0216, 'lps'),
	(400538, 123, '2015-02-15 00:48:48.000000', 'consum', 0.0210, 'lps'),
	(400539, 123, '2015-02-15 00:48:49.000000', 'consum', 0.0216, 'lps'),
	(400540, 123, '2015-02-15 00:48:50.000000', 'consum', 0.0218, 'lps'),
	(400541, 123, '2015-02-15 00:48:51.000000', 'consum', 0.0210, 'lps'),
	(400542, 123, '2015-02-15 00:48:52.000000', 'consum', 0.0218, 'lps'),
	(400543, 123, '2015-02-15 00:48:53.000000', 'consum', 0.0217, 'lps'),
	(400544, 123, '2015-02-15 00:48:54.000000', 'consum', 0.0214, 'lps'),
	(400545, 123, '2015-02-15 00:48:55.000000', 'consum', 0.0217, 'lps'),
	(400546, 123, '2015-02-15 00:48:56.000000', 'consum', 0.0215, 'lps'),
	(400547, 123, '2015-02-15 00:48:57.000000', 'consum', 0.0211, 'lps'),
	(400548, 123, '2015-02-15 00:48:58.000000', 'consum', 0.0213, 'lps'),
	(400549, 123, '2015-02-15 00:48:59.000000', 'consum', 0.0212, 'lps'),
	(400550, 123, '2015-02-15 00:49:00.000000', 'consum', 0.0213, 'lps'),
	(400551, 123, '2015-02-15 00:49:01.000000', 'consum', 0.0219, 'lps'),
	(400552, 123, '2015-02-15 00:49:02.000000', 'consum', 0.0211, 'lps'),
	(400553, 123, '2015-02-15 00:49:03.000000', 'consum', 0.0213, 'lps'),
	(400554, 123, '2015-02-15 00:49:04.000000', 'consum', 0.0211, 'lps'),
	(400555, 123, '2015-02-15 00:49:05.000000', 'consum', 0.0217, 'lps'),
	(400556, 123, '2015-02-15 00:49:06.000000', 'consum', 0.0220, 'lps'),
	(400557, 123, '2015-02-15 00:49:07.000000', 'consum', 0.0216, 'lps'),
	(400558, 123, '2015-02-15 00:49:08.000000', 'consum', 0.0212, 'lps'),
	(400559, 123, '2015-02-15 00:49:09.000000', 'consum', 0.0213, 'lps'),
	(400560, 123, '2015-02-15 00:49:10.000000', 'consum', 0.0220, 'lps'),
	(400561, 123, '2015-02-15 00:49:11.000000', 'consum', 0.0218, 'lps'),
	(400562, 123, '2015-02-15 00:49:12.000000', 'consum', 0.0211, 'lps'),
	(400563, 123, '2015-02-15 00:49:13.000000', 'consum', 0.0211, 'lps'),
	(400564, 123, '2015-02-15 00:49:14.000000', 'consum', 0.0212, 'lps'),
	(400565, 123, '2015-02-15 00:49:15.000000', 'consum', 0.0218, 'lps'),
	(400566, 123, '2015-02-15 00:49:16.000000', 'consum', 0.0211, 'lps'),
	(400567, 123, '2015-02-15 00:49:17.000000', 'consum', 0.0214, 'lps'),
	(400568, 123, '2015-02-15 00:49:18.000000', 'consum', 0.0218, 'lps'),
	(400569, 123, '2015-02-15 00:49:19.000000', 'consum', 0.0216, 'lps'),
	(400570, 123, '2015-02-15 00:49:20.000000', 'consum', 0.0214, 'lps'),
	(400571, 123, '2015-02-15 00:49:21.000000', 'consum', 0.0216, 'lps'),
	(400572, 123, '2015-02-15 00:49:22.000000', 'consum', 0.0214, 'lps'),
	(400573, 123, '2015-02-15 00:49:23.000000', 'consum', 0.0215, 'lps'),
	(400574, 123, '2015-02-15 00:49:24.000000', 'consum', 0.0212, 'lps'),
	(400575, 123, '2015-02-15 00:49:25.000000', 'consum', 0.0215, 'lps'),
	(400576, 123, '2015-02-15 00:49:26.000000', 'consum', 0.0210, 'lps'),
	(400577, 123, '2015-02-15 00:49:27.000000', 'consum', 0.0215, 'lps'),
	(400578, 123, '2015-02-15 00:49:28.000000', 'consum', 0.0216, 'lps'),
	(400579, 123, '2015-02-15 00:49:29.000000', 'consum', 0.0213, 'lps'),
	(400580, 123, '2015-02-15 00:49:30.000000', 'consum', 0.0219, 'lps'),
	(400581, 123, '2015-02-15 00:49:31.000000', 'consum', 0.0214, 'lps'),
	(400582, 123, '2015-02-15 00:49:32.000000', 'consum', 0.0216, 'lps'),
	(400583, 123, '2015-02-15 00:49:33.000000', 'consum', 0.0216, 'lps'),
	(400584, 123, '2015-02-15 00:49:34.000000', 'consum', 0.0212, 'lps'),
	(400585, 123, '2015-02-15 00:49:35.000000', 'consum', 0.0215, 'lps'),
	(400586, 123, '2015-02-15 00:49:36.000000', 'consum', 0.0218, 'lps'),
	(400587, 123, '2015-02-15 00:49:37.000000', 'consum', 0.0214, 'lps'),
	(400588, 123, '2015-02-15 00:49:38.000000', 'consum', 0.0216, 'lps'),
	(400589, 123, '2015-02-15 00:49:39.000000', 'consum', 0.0219, 'lps'),
	(400590, 123, '2015-02-15 00:49:40.000000', 'consum', 0.0214, 'lps'),
	(400591, 123, '2015-02-15 00:49:41.000000', 'consum', 0.0214, 'lps'),
	(400592, 123, '2015-02-15 00:49:42.000000', 'consum', 0.0210, 'lps'),
	(400593, 123, '2015-02-15 00:49:43.000000', 'consum', 0.0218, 'lps'),
	(400594, 123, '2015-02-15 00:49:44.000000', 'consum', 0.0210, 'lps'),
	(400595, 123, '2015-02-15 00:49:45.000000', 'consum', 0.0216, 'lps'),
	(400596, 123, '2015-02-15 00:49:46.000000', 'consum', 0.0219, 'lps'),
	(400597, 123, '2015-02-15 00:49:47.000000', 'consum', 0.0214, 'lps'),
	(400598, 123, '2015-02-15 00:49:48.000000', 'consum', 0.0216, 'lps'),
	(400599, 123, '2015-02-15 00:49:49.000000', 'consum', 0.0215, 'lps'),
	(400600, 123, '2015-02-15 00:49:50.000000', 'consum', 0.0210, 'lps'),
	(400601, 123, '2015-02-15 00:49:51.000000', 'consum', 0.0215, 'lps'),
	(400602, 123, '2015-02-15 00:49:52.000000', 'consum', 0.0213, 'lps'),
	(400603, 123, '2015-02-15 00:49:53.000000', 'consum', 0.0210, 'lps'),
	(400604, 123, '2015-02-15 00:49:54.000000', 'consum', 0.0213, 'lps'),
	(400605, 123, '2015-02-15 00:49:55.000000', 'consum', 0.0215, 'lps'),
	(400606, 123, '2015-02-15 00:49:56.000000', 'consum', 0.0217, 'lps'),
	(400607, 123, '2015-02-15 00:49:57.000000', 'consum', 0.0217, 'lps'),
	(400608, 123, '2015-02-15 00:49:58.000000', 'consum', 0.0216, 'lps'),
	(400609, 123, '2015-02-15 00:49:59.000000', 'consum', 0.0217, 'lps'),
	(400610, 123, '2015-02-15 00:50:00.000000', 'consum', 0.0216, 'lps'),
	(400611, 123, '2015-02-15 00:50:01.000000', 'consum', 0.0219, 'lps'),
	(400612, 123, '2015-02-15 00:50:02.000000', 'consum', 0.0218, 'lps'),
	(400613, 123, '2015-02-15 00:50:03.000000', 'consum', 0.0212, 'lps'),
	(400614, 123, '2015-02-15 00:50:04.000000', 'consum', 0.0217, 'lps'),
	(400615, 123, '2015-02-15 00:50:05.000000', 'consum', 0.0216, 'lps'),
	(400616, 123, '2015-02-15 00:50:06.000000', 'consum', 0.0212, 'lps'),
	(400617, 123, '2015-02-15 00:50:07.000000', 'consum', 0.0211, 'lps'),
	(400618, 123, '2015-02-15 00:50:08.000000', 'consum', 0.0210, 'lps'),
	(400619, 123, '2015-02-15 00:50:09.000000', 'consum', 0.0217, 'lps'),
	(400620, 123, '2015-02-15 00:50:10.000000', 'consum', 0.0215, 'lps'),
	(400621, 123, '2015-02-15 00:50:11.000000', 'consum', 0.0213, 'lps'),
	(400622, 123, '2015-02-15 00:50:12.000000', 'consum', 0.0211, 'lps'),
	(400623, 123, '2015-02-15 00:50:13.000000', 'consum', 0.0216, 'lps'),
	(400624, 123, '2015-02-15 00:50:14.000000', 'consum', 0.0217, 'lps'),
	(400625, 123, '2015-02-15 00:50:15.000000', 'consum', 0.0214, 'lps'),
	(400626, 123, '2015-02-15 00:50:16.000000', 'consum', 0.0211, 'lps'),
	(400627, 123, '2015-02-15 00:50:17.000000', 'consum', 0.0215, 'lps'),
	(400628, 123, '2015-02-15 00:50:18.000000', 'consum', 0.0219, 'lps'),
	(400629, 123, '2015-02-15 00:50:19.000000', 'consum', 0.0211, 'lps'),
	(400630, 123, '2015-02-15 00:50:20.000000', 'consum', 0.0220, 'lps'),
	(400631, 123, '2015-02-15 00:50:21.000000', 'consum', 0.0215, 'lps'),
	(400632, 123, '2015-02-15 00:50:22.000000', 'consum', 0.0215, 'lps'),
	(400633, 123, '2015-02-15 00:50:23.000000', 'consum', 0.0220, 'lps'),
	(400634, 123, '2015-02-15 00:50:24.000000', 'consum', 0.0215, 'lps'),
	(400635, 123, '2015-02-15 00:50:25.000000', 'consum', 0.0214, 'lps'),
	(400636, 123, '2015-02-15 00:50:26.000000', 'consum', 0.0216, 'lps'),
	(400637, 123, '2015-02-15 00:50:27.000000', 'consum', 0.0216, 'lps'),
	(400638, 123, '2015-02-15 00:50:28.000000', 'consum', 0.0212, 'lps'),
	(400639, 123, '2015-02-15 00:50:29.000000', 'consum', 0.0216, 'lps'),
	(400640, 123, '2015-02-15 00:50:30.000000', 'consum', 0.0211, 'lps'),
	(400641, 123, '2015-02-15 00:50:31.000000', 'consum', 0.0210, 'lps'),
	(400642, 123, '2015-02-15 00:50:32.000000', 'consum', 0.0216, 'lps'),
	(400643, 123, '2015-02-15 00:50:33.000000', 'consum', 0.0220, 'lps'),
	(400644, 123, '2015-02-15 00:50:34.000000', 'consum', 0.0219, 'lps'),
	(400645, 123, '2015-02-15 00:50:35.000000', 'consum', 0.0215, 'lps'),
	(400646, 123, '2015-02-15 00:50:36.000000', 'consum', 0.0220, 'lps'),
	(400647, 123, '2015-02-15 00:50:37.000000', 'consum', 0.0212, 'lps'),
	(400648, 123, '2015-02-15 00:50:38.000000', 'consum', 0.0213, 'lps'),
	(400649, 123, '2015-02-15 00:50:39.000000', 'consum', 0.0217, 'lps'),
	(400650, 123, '2015-02-15 00:50:40.000000', 'consum', 0.0217, 'lps'),
	(400651, 123, '2015-02-15 00:50:41.000000', 'consum', 0.0214, 'lps'),
	(400652, 123, '2015-02-15 00:50:42.000000', 'consum', 0.0218, 'lps'),
	(400653, 123, '2015-02-15 00:50:43.000000', 'consum', 0.0216, 'lps'),
	(400654, 123, '2015-02-15 00:50:44.000000', 'consum', 0.0219, 'lps'),
	(400655, 123, '2015-02-15 00:50:45.000000', 'consum', 0.0212, 'lps'),
	(400656, 123, '2015-02-15 00:50:46.000000', 'consum', 0.0219, 'lps'),
	(400657, 123, '2015-02-15 00:50:47.000000', 'consum', 0.0217, 'lps'),
	(400658, 123, '2015-02-15 00:50:48.000000', 'consum', 0.0217, 'lps'),
	(400659, 123, '2015-02-15 00:50:49.000000', 'consum', 0.0212, 'lps'),
	(400660, 123, '2015-02-15 00:50:50.000000', 'consum', 0.0212, 'lps'),
	(400661, 123, '2015-02-15 00:50:51.000000', 'consum', 0.0215, 'lps'),
	(400662, 123, '2015-02-15 00:50:52.000000', 'consum', 0.0216, 'lps'),
	(400663, 123, '2015-02-15 00:50:53.000000', 'consum', 0.0217, 'lps'),
	(400664, 123, '2015-02-15 00:50:54.000000', 'consum', 0.0216, 'lps'),
	(400665, 123, '2015-02-15 00:50:55.000000', 'consum', 0.0219, 'lps'),
	(400666, 123, '2015-02-15 00:50:56.000000', 'consum', 0.0215, 'lps'),
	(400667, 123, '2015-02-15 00:50:57.000000', 'consum', 0.0220, 'lps'),
	(400668, 123, '2015-02-15 00:50:58.000000', 'consum', 0.0214, 'lps'),
	(400669, 123, '2015-02-15 00:50:59.000000', 'consum', 0.0212, 'lps'),
	(400670, 123, '2015-02-15 00:51:00.000000', 'consum', 0.0219, 'lps'),
	(400671, 123, '2015-02-15 00:51:01.000000', 'consum', 0.0214, 'lps'),
	(400672, 123, '2015-02-15 00:51:02.000000', 'consum', 0.0217, 'lps'),
	(400673, 123, '2015-02-15 00:51:03.000000', 'consum', 0.0211, 'lps'),
	(400674, 123, '2015-02-15 00:51:04.000000', 'consum', 0.0216, 'lps'),
	(400675, 123, '2015-02-15 00:51:05.000000', 'consum', 0.0215, 'lps'),
	(400676, 123, '2015-02-15 00:51:06.000000', 'consum', 0.0217, 'lps'),
	(400677, 123, '2015-02-15 00:51:07.000000', 'consum', 0.0211, 'lps'),
	(400678, 123, '2015-02-15 00:51:08.000000', 'consum', 0.0216, 'lps'),
	(400679, 123, '2015-02-15 00:51:09.000000', 'consum', 0.0216, 'lps'),
	(400680, 123, '2015-02-15 00:51:10.000000', 'consum', 0.0213, 'lps'),
	(400681, 123, '2015-02-15 00:51:11.000000', 'consum', 0.0215, 'lps'),
	(400682, 123, '2015-02-15 00:51:12.000000', 'consum', 0.0216, 'lps'),
	(400683, 123, '2015-02-15 00:51:13.000000', 'consum', 0.0217, 'lps'),
	(400684, 123, '2015-02-15 00:51:14.000000', 'consum', 0.0215, 'lps'),
	(400685, 123, '2015-02-15 00:51:15.000000', 'consum', 0.0214, 'lps'),
	(400686, 123, '2015-02-15 00:51:16.000000', 'consum', 0.0217, 'lps'),
	(400687, 123, '2015-02-15 00:51:17.000000', 'consum', 0.0213, 'lps'),
	(400688, 123, '2015-02-15 00:51:18.000000', 'consum', 0.0212, 'lps'),
	(400689, 123, '2015-02-15 00:51:19.000000', 'consum', 0.0213, 'lps'),
	(400690, 123, '2015-02-15 00:51:20.000000', 'consum', 0.0210, 'lps'),
	(400691, 123, '2015-02-15 00:51:21.000000', 'consum', 0.0212, 'lps'),
	(400692, 123, '2015-02-15 00:51:22.000000', 'consum', 0.0210, 'lps'),
	(400693, 123, '2015-02-15 00:51:23.000000', 'consum', 0.0214, 'lps'),
	(400694, 123, '2015-02-15 00:51:24.000000', 'consum', 0.0219, 'lps'),
	(400695, 123, '2015-02-15 00:51:25.000000', 'consum', 0.0213, 'lps'),
	(400696, 123, '2015-02-15 00:51:26.000000', 'consum', 0.0220, 'lps'),
	(400697, 123, '2015-02-15 00:51:27.000000', 'consum', 0.0217, 'lps'),
	(400698, 123, '2015-02-15 00:51:28.000000', 'consum', 0.0218, 'lps'),
	(400699, 123, '2015-02-15 00:51:29.000000', 'consum', 0.0218, 'lps'),
	(400700, 123, '2015-02-15 00:51:30.000000', 'consum', 0.0214, 'lps'),
	(400701, 123, '2015-02-15 00:51:31.000000', 'consum', 0.0220, 'lps'),
	(400702, 123, '2015-02-15 00:51:32.000000', 'consum', 0.0216, 'lps'),
	(400703, 123, '2015-02-15 00:51:33.000000', 'consum', 0.0218, 'lps'),
	(400704, 123, '2015-02-15 00:51:34.000000', 'consum', 0.0214, 'lps'),
	(400705, 123, '2015-02-15 00:51:35.000000', 'consum', 0.0216, 'lps'),
	(400706, 123, '2015-02-15 00:51:36.000000', 'consum', 0.0216, 'lps'),
	(400707, 123, '2015-02-15 00:51:37.000000', 'consum', 0.0213, 'lps'),
	(400708, 123, '2015-02-15 00:51:38.000000', 'consum', 0.0218, 'lps'),
	(400709, 123, '2015-02-15 00:51:39.000000', 'consum', 0.0219, 'lps'),
	(400710, 123, '2015-02-15 00:51:40.000000', 'consum', 0.0211, 'lps'),
	(400711, 123, '2015-02-15 00:51:41.000000', 'consum', 0.0212, 'lps'),
	(400712, 123, '2015-02-15 00:51:42.000000', 'consum', 0.0214, 'lps'),
	(400713, 123, '2015-02-15 00:51:43.000000', 'consum', 0.0214, 'lps'),
	(400714, 123, '2015-02-15 00:51:44.000000', 'consum', 0.0220, 'lps'),
	(400715, 123, '2015-02-15 00:51:45.000000', 'consum', 0.0213, 'lps'),
	(400716, 123, '2015-02-15 00:51:46.000000', 'consum', 0.0220, 'lps'),
	(400717, 123, '2015-02-15 00:51:47.000000', 'consum', 0.0219, 'lps'),
	(400718, 123, '2015-02-15 00:51:48.000000', 'consum', 0.0212, 'lps'),
	(400719, 123, '2015-02-15 00:51:49.000000', 'consum', 0.0217, 'lps'),
	(400720, 123, '2015-02-15 00:51:50.000000', 'consum', 0.0218, 'lps'),
	(400721, 123, '2015-02-15 00:51:51.000000', 'consum', 0.0218, 'lps'),
	(400722, 123, '2015-02-15 00:51:52.000000', 'consum', 0.0216, 'lps'),
	(400723, 123, '2015-02-15 00:51:53.000000', 'consum', 0.0217, 'lps'),
	(400724, 123, '2015-02-15 00:51:54.000000', 'consum', 0.0218, 'lps'),
	(400725, 123, '2015-02-15 00:51:55.000000', 'consum', 0.0215, 'lps'),
	(400726, 123, '2015-02-15 00:51:56.000000', 'consum', 0.0213, 'lps'),
	(400727, 123, '2015-02-15 00:51:57.000000', 'consum', 0.0210, 'lps'),
	(400728, 123, '2015-02-15 00:51:58.000000', 'consum', 0.0213, 'lps'),
	(400729, 123, '2015-02-15 00:51:59.000000', 'consum', 0.0214, 'lps'),
	(400730, 123, '2015-02-15 00:52:00.000000', 'consum', 0.0212, 'lps'),
	(400731, 123, '2015-02-15 00:52:01.000000', 'consum', 0.0218, 'lps'),
	(400732, 123, '2015-02-15 00:52:02.000000', 'consum', 0.0214, 'lps'),
	(400733, 123, '2015-02-15 00:52:03.000000', 'consum', 0.0216, 'lps'),
	(400734, 123, '2015-02-15 00:52:04.000000', 'consum', 0.0218, 'lps'),
	(400735, 123, '2015-02-15 00:52:05.000000', 'consum', 0.0210, 'lps'),
	(400736, 123, '2015-02-15 00:52:06.000000', 'consum', 0.0218, 'lps'),
	(400737, 123, '2015-02-15 00:52:07.000000', 'consum', 0.0210, 'lps'),
	(400738, 123, '2015-02-15 00:52:08.000000', 'consum', 0.0216, 'lps'),
	(400739, 123, '2015-02-15 00:52:09.000000', 'consum', 0.0210, 'lps'),
	(400740, 123, '2015-02-15 00:52:10.000000', 'consum', 0.0212, 'lps'),
	(400741, 123, '2015-02-15 00:52:11.000000', 'consum', 0.0211, 'lps'),
	(400742, 123, '2015-02-15 00:52:12.000000', 'consum', 0.0210, 'lps'),
	(400743, 123, '2015-02-15 00:52:13.000000', 'consum', 0.0217, 'lps'),
	(400744, 123, '2015-02-15 00:52:14.000000', 'consum', 0.0213, 'lps'),
	(400745, 123, '2015-02-15 00:52:15.000000', 'consum', 0.0216, 'lps'),
	(400746, 123, '2015-02-15 00:52:16.000000', 'consum', 0.0220, 'lps'),
	(400747, 123, '2015-02-15 00:52:17.000000', 'consum', 0.0220, 'lps'),
	(400748, 123, '2015-02-15 00:52:18.000000', 'consum', 0.0210, 'lps'),
	(400749, 123, '2015-02-15 00:52:19.000000', 'consum', 0.0214, 'lps'),
	(400750, 123, '2015-02-15 00:52:20.000000', 'consum', 0.0210, 'lps'),
	(400751, 123, '2015-02-15 00:52:21.000000', 'consum', 0.0217, 'lps'),
	(400752, 123, '2015-02-15 00:52:22.000000', 'consum', 0.0214, 'lps'),
	(400753, 123, '2015-02-15 00:52:23.000000', 'consum', 0.0210, 'lps'),
	(400754, 123, '2015-02-15 00:52:24.000000', 'consum', 0.0220, 'lps'),
	(400755, 123, '2015-02-15 00:52:25.000000', 'consum', 0.0215, 'lps'),
	(400756, 123, '2015-02-15 00:52:26.000000', 'consum', 0.0219, 'lps'),
	(400757, 123, '2015-02-15 00:52:27.000000', 'consum', 0.0218, 'lps'),
	(400758, 123, '2015-02-15 00:52:28.000000', 'consum', 0.0211, 'lps'),
	(400759, 123, '2015-02-15 00:52:29.000000', 'consum', 0.0213, 'lps'),
	(400760, 123, '2015-02-15 00:52:30.000000', 'consum', 0.0213, 'lps'),
	(400761, 123, '2015-02-15 00:52:31.000000', 'consum', 0.0218, 'lps'),
	(400762, 123, '2015-02-15 00:52:32.000000', 'consum', 0.0219, 'lps'),
	(400763, 123, '2015-02-15 00:52:33.000000', 'consum', 0.0219, 'lps'),
	(400764, 123, '2015-02-15 00:52:34.000000', 'consum', 0.0220, 'lps'),
	(400765, 123, '2015-02-15 00:52:35.000000', 'consum', 0.0219, 'lps'),
	(400766, 123, '2015-02-15 00:52:36.000000', 'consum', 0.0218, 'lps'),
	(400767, 123, '2015-02-15 00:52:37.000000', 'consum', 0.0211, 'lps'),
	(400768, 123, '2015-02-15 00:52:38.000000', 'consum', 0.0214, 'lps'),
	(400769, 123, '2015-02-15 00:52:39.000000', 'consum', 0.0217, 'lps'),
	(400770, 123, '2015-02-15 00:52:40.000000', 'consum', 0.0213, 'lps'),
	(400771, 123, '2015-02-15 00:52:41.000000', 'consum', 0.0214, 'lps'),
	(400772, 123, '2015-02-15 00:52:42.000000', 'consum', 0.0220, 'lps'),
	(400773, 123, '2015-02-15 00:52:43.000000', 'consum', 0.0215, 'lps'),
	(400774, 123, '2015-02-15 00:52:44.000000', 'consum', 0.0217, 'lps'),
	(400775, 123, '2015-02-15 00:52:45.000000', 'consum', 0.0210, 'lps'),
	(400776, 123, '2015-02-15 00:52:46.000000', 'consum', 0.0220, 'lps'),
	(400777, 123, '2015-02-15 00:52:47.000000', 'consum', 0.0217, 'lps'),
	(400778, 123, '2015-02-15 00:52:48.000000', 'consum', 0.0218, 'lps'),
	(400779, 123, '2015-02-15 00:52:49.000000', 'consum', 0.0217, 'lps'),
	(400780, 123, '2015-02-15 00:52:50.000000', 'consum', 0.0220, 'lps'),
	(400781, 123, '2015-02-15 00:52:51.000000', 'consum', 0.0217, 'lps'),
	(400782, 123, '2015-02-15 00:52:52.000000', 'consum', 0.0215, 'lps'),
	(400783, 123, '2015-02-15 00:52:53.000000', 'consum', 0.0218, 'lps'),
	(400784, 123, '2015-02-15 00:52:54.000000', 'consum', 0.0210, 'lps'),
	(400785, 123, '2015-02-15 00:52:55.000000', 'consum', 0.0220, 'lps'),
	(400786, 123, '2015-02-15 00:52:56.000000', 'consum', 0.0219, 'lps'),
	(400787, 123, '2015-02-15 00:52:57.000000', 'consum', 0.0213, 'lps'),
	(400788, 123, '2015-02-15 00:52:58.000000', 'consum', 0.0211, 'lps'),
	(400789, 123, '2015-02-15 00:52:59.000000', 'consum', 0.0216, 'lps'),
	(400790, 123, '2015-02-15 00:53:00.000000', 'consum', 0.0215, 'lps'),
	(400791, 123, '2015-02-15 00:53:01.000000', 'consum', 0.0218, 'lps'),
	(400792, 123, '2015-02-15 00:53:02.000000', 'consum', 0.0215, 'lps'),
	(400793, 123, '2015-02-15 00:53:03.000000', 'consum', 0.0220, 'lps'),
	(400794, 123, '2015-02-15 00:53:04.000000', 'consum', 0.0215, 'lps'),
	(400795, 123, '2015-02-15 00:53:05.000000', 'consum', 0.0215, 'lps'),
	(400796, 123, '2015-02-15 00:53:06.000000', 'consum', 0.0210, 'lps'),
	(400797, 123, '2015-02-15 00:53:07.000000', 'consum', 0.0216, 'lps'),
	(400798, 123, '2015-02-15 00:53:08.000000', 'consum', 0.0218, 'lps'),
	(400799, 123, '2015-02-15 00:53:09.000000', 'consum', 0.0212, 'lps'),
	(400800, 123, '2015-02-15 00:53:10.000000', 'consum', 0.0217, 'lps'),
	(400801, 123, '2015-02-15 00:53:11.000000', 'consum', 0.0216, 'lps'),
	(400802, 123, '2015-02-15 00:53:12.000000', 'consum', 0.0211, 'lps'),
	(400803, 123, '2015-02-15 00:53:13.000000', 'consum', 0.0219, 'lps'),
	(400804, 123, '2015-02-15 00:53:14.000000', 'consum', 0.0220, 'lps'),
	(400805, 123, '2015-02-15 00:53:15.000000', 'consum', 0.0212, 'lps'),
	(400806, 123, '2015-02-15 00:53:16.000000', 'consum', 0.0211, 'lps'),
	(400807, 123, '2015-02-15 00:53:17.000000', 'consum', 0.0211, 'lps'),
	(400808, 123, '2015-02-15 00:53:18.000000', 'consum', 0.0213, 'lps'),
	(400809, 123, '2015-02-15 00:53:19.000000', 'consum', 0.0212, 'lps'),
	(400810, 123, '2015-02-15 00:53:20.000000', 'consum', 0.0211, 'lps'),
	(400811, 123, '2015-02-15 00:53:21.000000', 'consum', 0.0219, 'lps'),
	(400812, 123, '2015-02-15 00:53:22.000000', 'consum', 0.0220, 'lps'),
	(400813, 123, '2015-02-15 00:53:23.000000', 'consum', 0.0211, 'lps'),
	(400814, 123, '2015-02-15 00:53:24.000000', 'consum', 0.0218, 'lps'),
	(400815, 123, '2015-02-15 00:53:25.000000', 'consum', 0.0216, 'lps'),
	(400816, 123, '2015-02-15 00:53:26.000000', 'consum', 0.0215, 'lps'),
	(400817, 123, '2015-02-15 00:53:27.000000', 'consum', 0.0220, 'lps'),
	(400818, 123, '2015-02-15 00:53:28.000000', 'consum', 0.0210, 'lps'),
	(400819, 123, '2015-02-15 00:53:29.000000', 'consum', 0.0216, 'lps'),
	(400820, 123, '2015-02-15 00:53:30.000000', 'consum', 0.0217, 'lps'),
	(400821, 123, '2015-02-15 00:53:31.000000', 'consum', 0.0217, 'lps'),
	(400822, 123, '2015-02-15 00:53:32.000000', 'consum', 0.0214, 'lps'),
	(400823, 123, '2015-02-15 00:53:33.000000', 'consum', 0.0219, 'lps'),
	(400824, 123, '2015-02-15 00:53:34.000000', 'consum', 0.0210, 'lps'),
	(400825, 123, '2015-02-15 00:53:35.000000', 'consum', 0.0215, 'lps'),
	(400826, 123, '2015-02-15 00:53:36.000000', 'consum', 0.0216, 'lps'),
	(400827, 123, '2015-02-15 00:53:37.000000', 'consum', 0.0214, 'lps'),
	(400828, 123, '2015-02-15 00:53:38.000000', 'consum', 0.0212, 'lps'),
	(400829, 123, '2015-02-15 00:53:39.000000', 'consum', 0.0220, 'lps'),
	(400830, 123, '2015-02-15 00:53:40.000000', 'consum', 0.0210, 'lps'),
	(400831, 123, '2015-02-15 00:53:41.000000', 'consum', 0.0213, 'lps'),
	(400832, 123, '2015-02-15 00:53:42.000000', 'consum', 0.0217, 'lps'),
	(400833, 123, '2015-02-15 00:53:43.000000', 'consum', 0.0213, 'lps'),
	(400834, 123, '2015-02-15 00:53:44.000000', 'consum', 0.0215, 'lps'),
	(400835, 123, '2015-02-15 00:53:45.000000', 'consum', 0.0216, 'lps'),
	(400836, 123, '2015-02-15 00:53:46.000000', 'consum', 0.0214, 'lps'),
	(400837, 123, '2015-02-15 00:53:47.000000', 'consum', 0.0214, 'lps'),
	(400838, 123, '2015-02-15 00:53:48.000000', 'consum', 0.0216, 'lps'),
	(400839, 123, '2015-02-15 00:53:49.000000', 'consum', 0.0219, 'lps'),
	(400840, 123, '2015-02-15 00:53:50.000000', 'consum', 0.0217, 'lps'),
	(400841, 123, '2015-02-15 00:53:51.000000', 'consum', 0.0215, 'lps'),
	(400842, 123, '2015-02-15 00:53:52.000000', 'consum', 0.0217, 'lps'),
	(400843, 123, '2015-02-15 00:53:53.000000', 'consum', 0.0219, 'lps'),
	(400844, 123, '2015-02-15 00:53:54.000000', 'consum', 0.0211, 'lps'),
	(400845, 123, '2015-02-15 00:53:55.000000', 'consum', 0.0212, 'lps'),
	(400846, 123, '2015-02-15 00:53:56.000000', 'consum', 0.0219, 'lps'),
	(400847, 123, '2015-02-15 00:53:57.000000', 'consum', 0.0216, 'lps'),
	(400848, 123, '2015-02-15 00:53:58.000000', 'consum', 0.0213, 'lps'),
	(400849, 123, '2015-02-15 00:53:59.000000', 'consum', 0.0219, 'lps'),
	(400850, 123, '2015-02-15 00:54:00.000000', 'consum', 0.0212, 'lps'),
	(400851, 123, '2015-02-15 00:54:01.000000', 'consum', 0.0217, 'lps'),
	(400852, 123, '2015-02-15 00:54:02.000000', 'consum', 0.0218, 'lps'),
	(400853, 123, '2015-02-15 00:54:03.000000', 'consum', 0.0220, 'lps'),
	(400854, 123, '2015-02-15 00:54:04.000000', 'consum', 0.0211, 'lps'),
	(400855, 123, '2015-02-15 00:54:05.000000', 'consum', 0.0219, 'lps'),
	(400856, 123, '2015-02-15 00:54:06.000000', 'consum', 0.0210, 'lps'),
	(400857, 123, '2015-02-15 00:54:07.000000', 'consum', 0.0216, 'lps'),
	(400858, 123, '2015-02-15 00:54:08.000000', 'consum', 0.0219, 'lps'),
	(400859, 123, '2015-02-15 00:54:09.000000', 'consum', 0.0215, 'lps'),
	(400860, 123, '2015-02-15 00:54:10.000000', 'consum', 0.0218, 'lps'),
	(400861, 123, '2015-02-15 00:54:11.000000', 'consum', 0.0216, 'lps'),
	(400862, 123, '2015-02-15 00:54:12.000000', 'consum', 0.0217, 'lps'),
	(400863, 123, '2015-02-15 00:54:13.000000', 'consum', 0.0217, 'lps'),
	(400864, 123, '2015-02-15 00:54:14.000000', 'consum', 0.0213, 'lps'),
	(400865, 123, '2015-02-15 00:54:15.000000', 'consum', 0.0216, 'lps'),
	(400866, 123, '2015-02-15 00:54:16.000000', 'consum', 0.0219, 'lps'),
	(400867, 123, '2015-02-15 00:54:17.000000', 'consum', 0.0217, 'lps'),
	(400868, 123, '2015-02-15 00:54:18.000000', 'consum', 0.0219, 'lps'),
	(400869, 123, '2015-02-15 00:54:19.000000', 'consum', 0.0213, 'lps'),
	(400870, 123, '2015-02-15 00:54:20.000000', 'consum', 0.0210, 'lps'),
	(400871, 123, '2015-02-15 00:54:21.000000', 'consum', 0.0210, 'lps'),
	(400872, 123, '2015-02-15 00:54:22.000000', 'consum', 0.0213, 'lps'),
	(400873, 123, '2015-02-15 00:54:23.000000', 'consum', 0.0212, 'lps'),
	(400874, 123, '2015-02-15 00:54:24.000000', 'consum', 0.0213, 'lps'),
	(400875, 123, '2015-02-15 00:54:25.000000', 'consum', 0.0218, 'lps'),
	(400876, 123, '2015-02-15 00:54:26.000000', 'consum', 0.0219, 'lps'),
	(400877, 123, '2015-02-15 00:54:27.000000', 'consum', 0.0220, 'lps'),
	(400878, 123, '2015-02-15 00:54:28.000000', 'consum', 0.0215, 'lps'),
	(400879, 123, '2015-02-15 00:54:29.000000', 'consum', 0.0213, 'lps'),
	(400880, 123, '2015-02-15 00:54:30.000000', 'consum', 0.0211, 'lps'),
	(400881, 123, '2015-02-15 00:54:31.000000', 'consum', 0.0220, 'lps'),
	(400882, 123, '2015-02-15 00:54:32.000000', 'consum', 0.0212, 'lps'),
	(400883, 123, '2015-02-15 00:54:33.000000', 'consum', 0.0211, 'lps'),
	(400884, 123, '2015-02-15 00:54:34.000000', 'consum', 0.0220, 'lps'),
	(400885, 123, '2015-02-15 00:54:35.000000', 'consum', 0.0214, 'lps'),
	(400886, 123, '2015-02-15 00:54:36.000000', 'consum', 0.0210, 'lps'),
	(400887, 123, '2015-02-15 00:54:37.000000', 'consum', 0.0210, 'lps'),
	(400888, 123, '2015-02-15 00:54:38.000000', 'consum', 0.0212, 'lps'),
	(400889, 123, '2015-02-15 00:54:39.000000', 'consum', 0.0218, 'lps'),
	(400890, 123, '2015-02-15 00:54:40.000000', 'consum', 0.0214, 'lps'),
	(400891, 123, '2015-02-15 00:54:41.000000', 'consum', 0.0217, 'lps'),
	(400892, 123, '2015-02-15 00:54:42.000000', 'consum', 0.0211, 'lps'),
	(400893, 123, '2015-02-15 00:54:43.000000', 'consum', 0.0215, 'lps'),
	(400894, 123, '2015-02-15 00:54:44.000000', 'consum', 0.0211, 'lps'),
	(400895, 123, '2015-02-15 00:54:45.000000', 'consum', 0.0210, 'lps'),
	(400896, 123, '2015-02-15 00:54:46.000000', 'consum', 0.0210, 'lps'),
	(400897, 123, '2015-02-15 00:54:47.000000', 'consum', 0.0210, 'lps'),
	(400898, 123, '2015-02-15 00:54:48.000000', 'consum', 0.0220, 'lps'),
	(400899, 123, '2015-02-15 00:54:49.000000', 'consum', 0.0216, 'lps'),
	(400900, 123, '2015-02-15 00:54:50.000000', 'consum', 0.0212, 'lps'),
	(400901, 123, '2015-02-15 00:54:51.000000', 'consum', 0.0215, 'lps'),
	(400902, 123, '2015-02-15 00:54:52.000000', 'consum', 0.0215, 'lps'),
	(400903, 123, '2015-02-15 00:54:53.000000', 'consum', 0.0213, 'lps'),
	(400904, 123, '2015-02-15 00:54:54.000000', 'consum', 0.0218, 'lps'),
	(400905, 123, '2015-02-15 00:54:55.000000', 'consum', 0.0212, 'lps'),
	(400906, 123, '2015-02-15 00:54:56.000000', 'consum', 0.0215, 'lps'),
	(400907, 123, '2015-02-15 00:54:57.000000', 'consum', 0.0211, 'lps'),
	(400908, 123, '2015-02-15 00:54:58.000000', 'consum', 0.0210, 'lps'),
	(400909, 123, '2015-02-15 00:54:59.000000', 'consum', 0.0219, 'lps'),
	(400910, 123, '2015-02-15 00:55:00.000000', 'consum', 0.0213, 'lps'),
	(400911, 123, '2015-02-15 00:55:01.000000', 'consum', 0.0219, 'lps'),
	(400912, 123, '2015-02-15 00:55:02.000000', 'consum', 0.0214, 'lps'),
	(400913, 123, '2015-02-15 00:55:03.000000', 'consum', 0.0214, 'lps'),
	(400914, 123, '2015-02-15 00:55:04.000000', 'consum', 0.0217, 'lps'),
	(400915, 123, '2015-02-15 00:55:05.000000', 'consum', 0.0214, 'lps'),
	(400916, 123, '2015-02-15 00:55:06.000000', 'consum', 0.0218, 'lps'),
	(400917, 123, '2015-02-15 00:55:07.000000', 'consum', 0.0217, 'lps'),
	(400918, 123, '2015-02-15 00:55:08.000000', 'consum', 0.0210, 'lps'),
	(400919, 123, '2015-02-15 00:55:09.000000', 'consum', 0.0211, 'lps'),
	(400920, 123, '2015-02-15 00:55:10.000000', 'consum', 0.0217, 'lps'),
	(400921, 123, '2015-02-15 00:55:11.000000', 'consum', 0.0211, 'lps'),
	(400922, 123, '2015-02-15 00:55:12.000000', 'consum', 0.0213, 'lps'),
	(400923, 123, '2015-02-15 00:55:13.000000', 'consum', 0.0213, 'lps'),
	(400924, 123, '2015-02-15 00:55:14.000000', 'consum', 0.0218, 'lps'),
	(400925, 123, '2015-02-15 00:55:15.000000', 'consum', 0.0216, 'lps'),
	(400926, 123, '2015-02-15 00:55:16.000000', 'consum', 0.0220, 'lps'),
	(400927, 123, '2015-02-15 00:55:17.000000', 'consum', 0.0219, 'lps'),
	(400928, 123, '2015-02-15 00:55:18.000000', 'consum', 0.0215, 'lps'),
	(400929, 123, '2015-02-15 00:55:19.000000', 'consum', 0.0210, 'lps'),
	(400930, 123, '2015-02-15 00:55:20.000000', 'consum', 0.0216, 'lps'),
	(400931, 123, '2015-02-15 00:55:21.000000', 'consum', 0.0220, 'lps'),
	(400932, 123, '2015-02-15 00:55:22.000000', 'consum', 0.0210, 'lps'),
	(400933, 123, '2015-02-15 00:55:23.000000', 'consum', 0.0211, 'lps'),
	(400934, 123, '2015-02-15 00:55:24.000000', 'consum', 0.0216, 'lps'),
	(400935, 123, '2015-02-15 00:55:25.000000', 'consum', 0.0214, 'lps'),
	(400936, 123, '2015-02-15 00:55:26.000000', 'consum', 0.0215, 'lps'),
	(400937, 123, '2015-02-15 00:55:27.000000', 'consum', 0.0214, 'lps'),
	(400938, 123, '2015-02-15 00:55:28.000000', 'consum', 0.0212, 'lps'),
	(400939, 123, '2015-02-15 00:55:29.000000', 'consum', 0.0212, 'lps'),
	(400940, 123, '2015-02-15 00:55:30.000000', 'consum', 0.0212, 'lps'),
	(400941, 123, '2015-02-15 00:55:31.000000', 'consum', 0.0216, 'lps'),
	(400942, 123, '2015-02-15 00:55:32.000000', 'consum', 0.0211, 'lps'),
	(400943, 123, '2015-02-15 00:55:33.000000', 'consum', 0.0211, 'lps'),
	(400944, 123, '2015-02-15 00:55:34.000000', 'consum', 0.0220, 'lps'),
	(400945, 123, '2015-02-15 00:55:35.000000', 'consum', 0.0216, 'lps'),
	(400946, 123, '2015-02-15 00:55:36.000000', 'consum', 0.0220, 'lps'),
	(400947, 123, '2015-02-15 00:55:37.000000', 'consum', 0.0220, 'lps'),
	(400948, 123, '2015-02-15 00:55:38.000000', 'consum', 0.0210, 'lps'),
	(400949, 123, '2015-02-15 00:55:39.000000', 'consum', 0.0213, 'lps'),
	(400950, 123, '2015-02-15 00:55:40.000000', 'consum', 0.0214, 'lps'),
	(400951, 123, '2015-02-15 00:55:41.000000', 'consum', 0.0211, 'lps'),
	(400952, 123, '2015-02-15 00:55:42.000000', 'consum', 0.0217, 'lps'),
	(400953, 123, '2015-02-15 00:55:43.000000', 'consum', 0.0217, 'lps'),
	(400954, 123, '2015-02-15 00:55:44.000000', 'consum', 0.0213, 'lps'),
	(400955, 123, '2015-02-15 00:55:45.000000', 'consum', 0.0216, 'lps'),
	(400956, 123, '2015-02-15 00:55:46.000000', 'consum', 0.0210, 'lps'),
	(400957, 123, '2015-02-15 00:55:47.000000', 'consum', 0.0215, 'lps'),
	(400958, 123, '2015-02-15 00:55:48.000000', 'consum', 0.0212, 'lps'),
	(400959, 123, '2015-02-15 00:55:49.000000', 'consum', 0.0215, 'lps'),
	(400960, 123, '2015-02-15 00:55:50.000000', 'consum', 0.0211, 'lps'),
	(400961, 123, '2015-02-15 00:55:51.000000', 'consum', 0.0211, 'lps'),
	(400962, 123, '2015-02-15 00:55:52.000000', 'consum', 0.0213, 'lps'),
	(400963, 123, '2015-02-15 00:55:53.000000', 'consum', 0.0210, 'lps'),
	(400964, 123, '2015-02-15 00:55:54.000000', 'consum', 0.0214, 'lps'),
	(400965, 123, '2015-02-15 00:55:55.000000', 'consum', 0.0217, 'lps'),
	(400966, 123, '2015-02-15 00:55:56.000000', 'consum', 0.0212, 'lps'),
	(400967, 123, '2015-02-15 00:55:57.000000', 'consum', 0.0220, 'lps'),
	(400968, 123, '2015-02-15 00:55:58.000000', 'consum', 0.0213, 'lps'),
	(400969, 123, '2015-02-15 00:55:59.000000', 'consum', 0.0217, 'lps'),
	(400970, 123, '2015-02-15 00:56:00.000000', 'consum', 0.0215, 'lps'),
	(400971, 123, '2015-02-15 00:56:01.000000', 'consum', 0.0214, 'lps'),
	(400972, 123, '2015-02-15 00:56:02.000000', 'consum', 0.0216, 'lps'),
	(400973, 123, '2015-02-15 00:56:03.000000', 'consum', 0.0217, 'lps'),
	(400974, 123, '2015-02-15 00:56:04.000000', 'consum', 0.0215, 'lps'),
	(400975, 123, '2015-02-15 00:56:05.000000', 'consum', 0.0217, 'lps'),
	(400976, 123, '2015-02-15 00:56:06.000000', 'consum', 0.0220, 'lps'),
	(400977, 123, '2015-02-15 00:56:07.000000', 'consum', 0.0216, 'lps'),
	(400978, 123, '2015-02-15 00:56:08.000000', 'consum', 0.0211, 'lps'),
	(400979, 123, '2015-02-15 00:56:09.000000', 'consum', 0.0218, 'lps'),
	(400980, 123, '2015-02-15 00:56:10.000000', 'consum', 0.0216, 'lps'),
	(400981, 123, '2015-02-15 00:56:11.000000', 'consum', 0.0214, 'lps'),
	(400982, 123, '2015-02-15 00:56:12.000000', 'consum', 0.0215, 'lps'),
	(400983, 123, '2015-02-15 00:56:13.000000', 'consum', 0.0214, 'lps'),
	(400984, 123, '2015-02-15 00:56:14.000000', 'consum', 0.0214, 'lps'),
	(400985, 123, '2015-02-15 00:56:15.000000', 'consum', 0.0216, 'lps'),
	(400986, 123, '2015-02-15 00:56:16.000000', 'consum', 0.0210, 'lps'),
	(400987, 123, '2015-02-15 00:56:17.000000', 'consum', 0.0212, 'lps'),
	(400988, 123, '2015-02-15 00:56:18.000000', 'consum', 0.0211, 'lps'),
	(400989, 123, '2015-02-15 00:56:19.000000', 'consum', 0.0210, 'lps'),
	(400990, 123, '2015-02-15 00:56:20.000000', 'consum', 0.0219, 'lps'),
	(400991, 123, '2015-02-15 00:56:21.000000', 'consum', 0.0213, 'lps'),
	(400992, 123, '2015-02-15 00:56:22.000000', 'consum', 0.0218, 'lps'),
	(400993, 123, '2015-02-15 00:56:23.000000', 'consum', 0.0220, 'lps'),
	(400994, 123, '2015-02-15 00:56:24.000000', 'consum', 0.0215, 'lps'),
	(400995, 123, '2015-02-15 00:56:25.000000', 'consum', 0.0214, 'lps'),
	(400996, 123, '2015-02-15 00:56:26.000000', 'consum', 0.0218, 'lps'),
	(400997, 123, '2015-02-15 00:56:27.000000', 'consum', 0.0214, 'lps'),
	(400998, 123, '2015-02-15 00:56:28.000000', 'consum', 0.0220, 'lps'),
	(400999, 123, '2015-02-15 00:56:29.000000', 'consum', 0.0213, 'lps'),
	(401000, 123, '2015-02-15 00:56:30.000000', 'consum', 0.0219, 'lps'),
	(401001, 123, '2015-02-15 00:56:31.000000', 'consum', 0.0212, 'lps'),
	(401002, 123, '2015-02-15 00:56:32.000000', 'consum', 0.0215, 'lps'),
	(401003, 123, '2015-02-15 00:56:33.000000', 'consum', 0.0219, 'lps'),
	(401004, 123, '2015-02-15 00:56:34.000000', 'consum', 0.0210, 'lps'),
	(401005, 123, '2015-02-15 00:56:35.000000', 'consum', 0.0214, 'lps'),
	(401006, 123, '2015-02-15 00:56:36.000000', 'consum', 0.0211, 'lps'),
	(401007, 123, '2015-02-15 00:56:37.000000', 'consum', 0.0214, 'lps'),
	(401008, 123, '2015-02-15 00:56:38.000000', 'consum', 0.0218, 'lps'),
	(401009, 123, '2015-02-15 00:56:39.000000', 'consum', 0.0213, 'lps'),
	(401010, 123, '2015-02-15 00:56:40.000000', 'consum', 0.0215, 'lps'),
	(401011, 123, '2015-02-15 00:56:41.000000', 'consum', 0.0215, 'lps'),
	(401012, 123, '2015-02-15 00:56:42.000000', 'consum', 0.0220, 'lps'),
	(401013, 123, '2015-02-15 00:56:43.000000', 'consum', 0.0213, 'lps'),
	(401014, 123, '2015-02-15 00:56:44.000000', 'consum', 0.0215, 'lps'),
	(401015, 123, '2015-02-15 00:56:45.000000', 'consum', 0.0218, 'lps'),
	(401016, 123, '2015-02-15 00:56:46.000000', 'consum', 0.0213, 'lps'),
	(401017, 123, '2015-02-15 00:56:47.000000', 'consum', 0.0212, 'lps'),
	(401018, 123, '2015-02-15 00:56:48.000000', 'consum', 0.0212, 'lps'),
	(401019, 123, '2015-02-15 00:56:49.000000', 'consum', 0.0214, 'lps'),
	(401020, 123, '2015-02-15 00:56:50.000000', 'consum', 0.0214, 'lps'),
	(401021, 123, '2015-02-15 00:56:51.000000', 'consum', 0.0217, 'lps'),
	(401022, 123, '2015-02-15 00:56:52.000000', 'consum', 0.0213, 'lps'),
	(401023, 123, '2015-02-15 00:56:53.000000', 'consum', 0.0217, 'lps'),
	(401024, 123, '2015-02-15 00:56:54.000000', 'consum', 0.0213, 'lps'),
	(401025, 123, '2015-02-15 00:56:55.000000', 'consum', 0.0217, 'lps'),
	(401026, 123, '2015-02-15 00:56:56.000000', 'consum', 0.0214, 'lps'),
	(401027, 123, '2015-02-15 00:56:57.000000', 'consum', 0.0220, 'lps'),
	(401028, 123, '2015-02-15 00:56:58.000000', 'consum', 0.0216, 'lps'),
	(401029, 123, '2015-02-15 00:56:59.000000', 'consum', 0.0219, 'lps'),
	(401030, 123, '2015-02-15 00:57:00.000000', 'consum', 0.0218, 'lps'),
	(401031, 123, '2015-02-15 00:57:01.000000', 'consum', 0.0213, 'lps'),
	(401032, 123, '2015-02-15 00:57:02.000000', 'consum', 0.0213, 'lps'),
	(401033, 123, '2015-02-15 00:57:03.000000', 'consum', 0.0215, 'lps'),
	(401034, 123, '2015-02-15 00:57:04.000000', 'consum', 0.0215, 'lps'),
	(401035, 123, '2015-02-15 00:57:05.000000', 'consum', 0.0219, 'lps'),
	(401036, 123, '2015-02-15 00:57:06.000000', 'consum', 0.0220, 'lps'),
	(401037, 123, '2015-02-15 00:57:07.000000', 'consum', 0.0211, 'lps'),
	(401038, 123, '2015-02-15 00:57:08.000000', 'consum', 0.0220, 'lps'),
	(401039, 123, '2015-02-15 00:57:09.000000', 'consum', 0.0214, 'lps'),
	(401040, 123, '2015-02-15 00:57:10.000000', 'consum', 0.0210, 'lps'),
	(401041, 123, '2015-02-15 00:57:11.000000', 'consum', 0.0219, 'lps'),
	(401042, 123, '2015-02-15 00:57:12.000000', 'consum', 0.0213, 'lps'),
	(401043, 123, '2015-02-15 00:57:13.000000', 'consum', 0.0219, 'lps'),
	(401044, 123, '2015-02-15 00:57:14.000000', 'consum', 0.0214, 'lps'),
	(401045, 123, '2015-02-15 00:57:15.000000', 'consum', 0.0213, 'lps'),
	(401046, 123, '2015-02-15 00:57:16.000000', 'consum', 0.0214, 'lps'),
	(401047, 123, '2015-02-15 00:57:17.000000', 'consum', 0.0211, 'lps'),
	(401048, 123, '2015-02-15 00:57:18.000000', 'consum', 0.0213, 'lps'),
	(401049, 123, '2015-02-15 00:57:19.000000', 'consum', 0.0211, 'lps'),
	(401050, 123, '2015-02-15 00:57:20.000000', 'consum', 0.0217, 'lps'),
	(401051, 123, '2015-02-15 00:57:21.000000', 'consum', 0.0212, 'lps'),
	(401052, 123, '2015-02-15 00:57:22.000000', 'consum', 0.0210, 'lps'),
	(401053, 123, '2015-02-15 00:57:23.000000', 'consum', 0.0215, 'lps'),
	(401054, 123, '2015-02-15 00:57:24.000000', 'consum', 0.0214, 'lps'),
	(401055, 123, '2015-02-15 00:57:25.000000', 'consum', 0.0214, 'lps'),
	(401056, 123, '2015-02-15 00:57:26.000000', 'consum', 0.0218, 'lps'),
	(401057, 123, '2015-02-15 00:57:27.000000', 'consum', 0.0215, 'lps'),
	(401058, 123, '2015-02-15 00:57:28.000000', 'consum', 0.0215, 'lps'),
	(401059, 123, '2015-02-15 00:57:29.000000', 'consum', 0.0219, 'lps'),
	(401060, 123, '2015-02-15 00:57:30.000000', 'consum', 0.0218, 'lps'),
	(401061, 123, '2015-02-15 00:57:31.000000', 'consum', 0.0212, 'lps'),
	(401062, 123, '2015-02-15 00:57:32.000000', 'consum', 0.0218, 'lps'),
	(401063, 123, '2015-02-15 00:57:33.000000', 'consum', 0.0211, 'lps'),
	(401064, 123, '2015-02-15 00:57:34.000000', 'consum', 0.0213, 'lps'),
	(401065, 123, '2015-02-15 00:57:35.000000', 'consum', 0.0210, 'lps'),
	(401066, 123, '2015-02-15 00:57:36.000000', 'consum', 0.0216, 'lps'),
	(401067, 123, '2015-02-15 00:57:37.000000', 'consum', 0.0218, 'lps'),
	(401068, 123, '2015-02-15 00:57:38.000000', 'consum', 0.0211, 'lps'),
	(401069, 123, '2015-02-15 00:57:39.000000', 'consum', 0.0213, 'lps'),
	(401070, 123, '2015-02-15 00:57:40.000000', 'consum', 0.0212, 'lps'),
	(401071, 123, '2015-02-15 00:57:41.000000', 'consum', 0.0211, 'lps'),
	(401072, 123, '2015-02-15 00:57:42.000000', 'consum', 0.0220, 'lps'),
	(401073, 123, '2015-02-15 00:57:43.000000', 'consum', 0.0213, 'lps'),
	(401074, 123, '2015-02-15 00:57:44.000000', 'consum', 0.0217, 'lps'),
	(401075, 123, '2015-02-15 00:57:45.000000', 'consum', 0.0216, 'lps'),
	(401076, 123, '2015-02-15 00:57:46.000000', 'consum', 0.0219, 'lps'),
	(401077, 123, '2015-02-15 00:57:47.000000', 'consum', 0.0216, 'lps'),
	(401078, 123, '2015-02-15 00:57:48.000000', 'consum', 0.0214, 'lps'),
	(401079, 123, '2015-02-15 00:57:49.000000', 'consum', 0.0212, 'lps'),
	(401080, 123, '2015-02-15 00:57:50.000000', 'consum', 0.0220, 'lps'),
	(401081, 123, '2015-02-15 00:57:51.000000', 'consum', 0.0220, 'lps'),
	(401082, 123, '2015-02-15 00:57:52.000000', 'consum', 0.0210, 'lps'),
	(401083, 123, '2015-02-15 00:57:53.000000', 'consum', 0.0214, 'lps'),
	(401084, 123, '2015-02-15 00:57:54.000000', 'consum', 0.0218, 'lps'),
	(401085, 123, '2015-02-15 00:57:55.000000', 'consum', 0.0217, 'lps'),
	(401086, 123, '2015-02-15 00:57:56.000000', 'consum', 0.0210, 'lps'),
	(401087, 123, '2015-02-15 00:57:57.000000', 'consum', 0.0211, 'lps'),
	(401088, 123, '2015-02-15 00:57:58.000000', 'consum', 0.0214, 'lps'),
	(401089, 123, '2015-02-15 00:57:59.000000', 'consum', 0.0218, 'lps'),
	(401090, 123, '2015-02-15 00:58:00.000000', 'consum', 0.0216, 'lps'),
	(401091, 123, '2015-02-15 00:58:01.000000', 'consum', 0.0218, 'lps'),
	(401092, 123, '2015-02-15 00:58:02.000000', 'consum', 0.0210, 'lps'),
	(401093, 123, '2015-02-15 00:58:03.000000', 'consum', 0.0220, 'lps'),
	(401094, 123, '2015-02-15 00:58:04.000000', 'consum', 0.0215, 'lps'),
	(401095, 123, '2015-02-15 00:58:05.000000', 'consum', 0.0218, 'lps'),
	(401096, 123, '2015-02-15 00:58:06.000000', 'consum', 0.0211, 'lps'),
	(401097, 123, '2015-02-15 00:58:07.000000', 'consum', 0.0216, 'lps'),
	(401098, 123, '2015-02-15 00:58:08.000000', 'consum', 0.0216, 'lps'),
	(401099, 123, '2015-02-15 00:58:09.000000', 'consum', 0.0211, 'lps'),
	(401100, 123, '2015-02-15 00:58:10.000000', 'consum', 0.0210, 'lps'),
	(401101, 123, '2015-02-15 00:58:11.000000', 'consum', 0.0216, 'lps'),
	(401102, 123, '2015-02-15 00:58:12.000000', 'consum', 0.0219, 'lps'),
	(401103, 123, '2015-02-15 00:58:13.000000', 'consum', 0.0217, 'lps'),
	(401104, 123, '2015-02-15 00:58:14.000000', 'consum', 0.0216, 'lps'),
	(401105, 123, '2015-02-15 00:58:15.000000', 'consum', 0.0210, 'lps'),
	(401106, 123, '2015-02-15 00:58:16.000000', 'consum', 0.0212, 'lps'),
	(401107, 123, '2015-02-15 00:58:17.000000', 'consum', 0.0212, 'lps'),
	(401108, 123, '2015-02-15 00:58:18.000000', 'consum', 0.0214, 'lps'),
	(401109, 123, '2015-02-15 00:58:19.000000', 'consum', 0.0215, 'lps'),
	(401110, 123, '2015-02-15 00:58:20.000000', 'consum', 0.0210, 'lps'),
	(401111, 123, '2015-02-15 00:58:21.000000', 'consum', 0.0216, 'lps'),
	(401112, 123, '2015-02-15 00:58:22.000000', 'consum', 0.0211, 'lps'),
	(401113, 123, '2015-02-15 00:58:23.000000', 'consum', 0.0219, 'lps'),
	(401114, 123, '2015-02-15 00:58:24.000000', 'consum', 0.0219, 'lps'),
	(401115, 123, '2015-02-15 00:58:25.000000', 'consum', 0.0217, 'lps'),
	(401116, 123, '2015-02-15 00:58:26.000000', 'consum', 0.0220, 'lps'),
	(401117, 123, '2015-02-15 00:58:27.000000', 'consum', 0.0217, 'lps'),
	(401118, 123, '2015-02-15 00:58:28.000000', 'consum', 0.0214, 'lps'),
	(401119, 123, '2015-02-15 00:58:29.000000', 'consum', 0.0212, 'lps'),
	(401120, 123, '2015-02-15 00:58:30.000000', 'consum', 0.0218, 'lps'),
	(401121, 123, '2015-02-15 00:58:31.000000', 'consum', 0.0214, 'lps'),
	(401122, 123, '2015-02-15 00:58:32.000000', 'consum', 0.0215, 'lps'),
	(401123, 123, '2015-02-15 00:58:33.000000', 'consum', 0.0215, 'lps'),
	(401124, 123, '2015-02-15 00:58:34.000000', 'consum', 0.0218, 'lps'),
	(401125, 123, '2015-02-15 00:58:35.000000', 'consum', 0.0215, 'lps'),
	(401126, 123, '2015-02-15 00:58:36.000000', 'consum', 0.0213, 'lps'),
	(401127, 123, '2015-02-15 00:58:37.000000', 'consum', 0.0210, 'lps'),
	(401128, 123, '2015-02-15 00:58:38.000000', 'consum', 0.0212, 'lps'),
	(401129, 123, '2015-02-15 00:58:39.000000', 'consum', 0.0219, 'lps'),
	(401130, 123, '2015-02-15 00:58:40.000000', 'consum', 0.0217, 'lps'),
	(401131, 123, '2015-02-15 00:58:41.000000', 'consum', 0.0218, 'lps'),
	(401132, 123, '2015-02-15 00:58:42.000000', 'consum', 0.0218, 'lps'),
	(401133, 123, '2015-02-15 00:58:43.000000', 'consum', 0.0214, 'lps'),
	(401134, 123, '2015-02-15 00:58:44.000000', 'consum', 0.0220, 'lps'),
	(401135, 123, '2015-02-15 00:58:45.000000', 'consum', 0.0216, 'lps'),
	(401136, 123, '2015-02-15 00:58:46.000000', 'consum', 0.0219, 'lps'),
	(401137, 123, '2015-02-15 00:58:47.000000', 'consum', 0.0215, 'lps'),
	(401138, 123, '2015-02-15 00:58:48.000000', 'consum', 0.0210, 'lps'),
	(401139, 123, '2015-02-15 00:58:49.000000', 'consum', 0.0217, 'lps'),
	(401140, 123, '2015-02-15 00:58:50.000000', 'consum', 0.0211, 'lps'),
	(401141, 123, '2015-02-15 00:58:51.000000', 'consum', 0.0217, 'lps'),
	(401142, 123, '2015-02-15 00:58:52.000000', 'consum', 0.0211, 'lps'),
	(401143, 123, '2015-02-15 00:58:53.000000', 'consum', 0.0215, 'lps'),
	(401144, 123, '2015-02-15 00:58:54.000000', 'consum', 0.0211, 'lps'),
	(401145, 123, '2015-02-15 00:58:55.000000', 'consum', 0.0213, 'lps'),
	(401146, 123, '2015-02-15 00:58:56.000000', 'consum', 0.0210, 'lps'),
	(401147, 123, '2015-02-15 00:58:57.000000', 'consum', 0.0215, 'lps'),
	(401148, 123, '2015-02-15 00:58:58.000000', 'consum', 0.0212, 'lps'),
	(401149, 123, '2015-02-15 00:58:59.000000', 'consum', 0.0215, 'lps'),
	(401150, 123, '2015-02-15 00:59:00.000000', 'consum', 0.0210, 'lps'),
	(401151, 123, '2015-02-15 00:59:01.000000', 'consum', 0.0216, 'lps'),
	(401152, 123, '2015-02-15 00:59:02.000000', 'consum', 0.0217, 'lps'),
	(401153, 123, '2015-02-15 00:59:03.000000', 'consum', 0.0220, 'lps'),
	(401154, 123, '2015-02-15 00:59:04.000000', 'consum', 0.0215, 'lps'),
	(401155, 123, '2015-02-15 00:59:05.000000', 'consum', 0.0217, 'lps'),
	(401156, 123, '2015-02-15 00:59:06.000000', 'consum', 0.0211, 'lps'),
	(401157, 123, '2015-02-15 00:59:07.000000', 'consum', 0.0214, 'lps'),
	(401158, 123, '2015-02-15 00:59:08.000000', 'consum', 0.0215, 'lps'),
	(401159, 123, '2015-02-15 00:59:09.000000', 'consum', 0.0216, 'lps'),
	(401160, 123, '2015-02-15 00:59:10.000000', 'consum', 0.0213, 'lps'),
	(401161, 123, '2015-02-15 00:59:11.000000', 'consum', 0.0219, 'lps'),
	(401162, 123, '2015-02-15 00:59:12.000000', 'consum', 0.0211, 'lps'),
	(401163, 123, '2015-02-15 00:59:13.000000', 'consum', 0.0213, 'lps'),
	(401164, 123, '2015-02-15 00:59:14.000000', 'consum', 0.0220, 'lps'),
	(401165, 123, '2015-02-15 00:59:15.000000', 'consum', 0.0211, 'lps'),
	(401166, 123, '2015-02-15 00:59:16.000000', 'consum', 0.0215, 'lps'),
	(401167, 123, '2015-02-15 00:59:17.000000', 'consum', 0.0212, 'lps'),
	(401168, 123, '2015-02-15 00:59:18.000000', 'consum', 0.0215, 'lps'),
	(401169, 123, '2015-02-15 00:59:19.000000', 'consum', 0.0219, 'lps'),
	(401170, 123, '2015-02-15 00:59:20.000000', 'consum', 0.0217, 'lps'),
	(401171, 123, '2015-02-15 00:59:21.000000', 'consum', 0.0220, 'lps'),
	(401172, 123, '2015-02-15 00:59:22.000000', 'consum', 0.0216, 'lps'),
	(401173, 123, '2015-02-15 00:59:23.000000', 'consum', 0.0212, 'lps'),
	(401174, 123, '2015-02-15 00:59:24.000000', 'consum', 0.0211, 'lps'),
	(401175, 123, '2015-02-15 00:59:25.000000', 'consum', 0.0211, 'lps'),
	(401176, 123, '2015-02-15 00:59:26.000000', 'consum', 0.0212, 'lps'),
	(401177, 123, '2015-02-15 00:59:27.000000', 'consum', 0.0216, 'lps'),
	(401178, 123, '2015-02-15 00:59:28.000000', 'consum', 0.0216, 'lps'),
	(401179, 123, '2015-02-15 00:59:29.000000', 'consum', 0.0220, 'lps'),
	(401180, 123, '2015-02-15 00:59:30.000000', 'consum', 0.0210, 'lps'),
	(401181, 123, '2015-02-15 00:59:31.000000', 'consum', 0.0214, 'lps'),
	(401182, 123, '2015-02-15 00:59:32.000000', 'consum', 0.0217, 'lps'),
	(401183, 123, '2015-02-15 00:59:33.000000', 'consum', 0.0214, 'lps'),
	(401184, 123, '2015-02-15 00:59:34.000000', 'consum', 0.0211, 'lps'),
	(401185, 123, '2015-02-15 00:59:35.000000', 'consum', 0.0212, 'lps'),
	(401186, 123, '2015-02-15 00:59:36.000000', 'consum', 0.0216, 'lps'),
	(401187, 123, '2015-02-15 00:59:37.000000', 'consum', 0.0215, 'lps'),
	(401188, 123, '2015-02-15 00:59:38.000000', 'consum', 0.0215, 'lps'),
	(401189, 123, '2015-02-15 00:59:39.000000', 'consum', 0.0211, 'lps'),
	(401190, 123, '2015-02-15 00:59:40.000000', 'consum', 0.0212, 'lps'),
	(401191, 123, '2015-02-15 00:59:41.000000', 'consum', 0.0218, 'lps'),
	(401192, 123, '2015-02-15 00:59:42.000000', 'consum', 0.0220, 'lps'),
	(401193, 123, '2015-02-15 00:59:43.000000', 'consum', 0.0214, 'lps'),
	(401194, 123, '2015-02-15 00:59:44.000000', 'consum', 0.0215, 'lps'),
	(401195, 123, '2015-02-15 00:59:45.000000', 'consum', 0.0210, 'lps'),
	(401196, 123, '2015-02-15 00:59:46.000000', 'consum', 0.0220, 'lps'),
	(401197, 123, '2015-02-15 00:59:47.000000', 'consum', 0.0214, 'lps'),
	(401198, 123, '2015-02-15 00:59:48.000000', 'consum', 0.0211, 'lps'),
	(401199, 123, '2015-02-15 00:59:49.000000', 'consum', 0.0215, 'lps'),
	(401200, 123, '2015-02-15 00:59:50.000000', 'consum', 0.0210, 'lps'),
	(401201, 123, '2015-02-15 00:59:51.000000', 'consum', 0.0218, 'lps'),
	(401202, 123, '2015-02-15 00:59:52.000000', 'consum', 0.0218, 'lps'),
	(401203, 123, '2015-02-15 00:59:53.000000', 'consum', 0.0217, 'lps'),
	(401204, 123, '2015-02-15 00:59:54.000000', 'consum', 0.0219, 'lps'),
	(401205, 123, '2015-02-15 00:59:55.000000', 'consum', 0.0214, 'lps'),
	(401206, 123, '2015-02-15 00:59:56.000000', 'consum', 0.0216, 'lps'),
	(401207, 123, '2015-02-15 00:59:57.000000', 'consum', 0.0215, 'lps'),
	(401208, 123, '2015-02-15 00:59:58.000000', 'consum', 0.0220, 'lps'),
	(401209, 123, '2015-02-15 00:59:59.000000', 'consum', 0.0213, 'lps'),
	(401210, 123, '2015-02-15 01:00:00.000000', 'consum', 0.0217, 'lps'),
	(401211, 123, '2015-02-15 01:00:01.000000', 'consum', 0.0213, 'lps'),
	(401212, 123, '2015-02-15 01:00:02.000000', 'consum', 0.0214, 'lps'),
	(401213, 123, '2015-02-15 01:00:03.000000', 'consum', 0.0212, 'lps'),
	(401214, 123, '2015-02-15 01:00:04.000000', 'consum', 0.0210, 'lps'),
	(401215, 123, '2015-02-15 01:00:05.000000', 'consum', 0.0215, 'lps'),
	(401216, 123, '2015-02-15 01:00:06.000000', 'consum', 0.0215, 'lps'),
	(401217, 123, '2015-02-15 01:00:07.000000', 'consum', 0.0220, 'lps'),
	(401218, 123, '2015-02-15 01:00:08.000000', 'consum', 0.0211, 'lps'),
	(401219, 123, '2015-02-15 01:00:09.000000', 'consum', 0.0210, 'lps'),
	(401220, 123, '2015-02-15 01:00:10.000000', 'consum', 0.0218, 'lps'),
	(401221, 123, '2015-02-15 01:00:11.000000', 'consum', 0.0215, 'lps'),
	(401222, 123, '2015-02-15 01:00:12.000000', 'consum', 0.0213, 'lps'),
	(401223, 123, '2015-02-15 01:00:13.000000', 'consum', 0.0220, 'lps'),
	(401224, 123, '2015-02-15 01:00:14.000000', 'consum', 0.0218, 'lps'),
	(401225, 123, '2015-02-15 01:00:15.000000', 'consum', 0.0210, 'lps'),
	(401226, 123, '2015-02-15 01:00:16.000000', 'consum', 0.0219, 'lps'),
	(401227, 123, '2015-02-15 01:00:17.000000', 'consum', 0.0214, 'lps'),
	(401228, 123, '2015-02-15 01:00:18.000000', 'consum', 0.0211, 'lps'),
	(401229, 123, '2015-02-15 01:00:19.000000', 'consum', 0.0218, 'lps'),
	(401230, 123, '2015-02-15 01:00:20.000000', 'consum', 0.0213, 'lps'),
	(401231, 123, '2015-02-15 01:00:21.000000', 'consum', 0.0213, 'lps'),
	(401232, 123, '2015-02-15 01:00:22.000000', 'consum', 0.0215, 'lps'),
	(401233, 123, '2015-02-15 01:00:23.000000', 'consum', 0.0215, 'lps'),
	(401234, 123, '2015-02-15 01:00:24.000000', 'consum', 0.0219, 'lps'),
	(401235, 123, '2015-02-15 01:00:25.000000', 'consum', 0.0211, 'lps'),
	(401236, 123, '2015-02-15 01:00:26.000000', 'consum', 0.0210, 'lps'),
	(401237, 123, '2015-02-15 01:00:27.000000', 'consum', 0.0219, 'lps'),
	(401238, 123, '2015-02-15 01:00:28.000000', 'consum', 0.0220, 'lps'),
	(401239, 123, '2015-02-15 01:00:29.000000', 'consum', 0.0212, 'lps'),
	(401240, 123, '2015-02-15 01:00:30.000000', 'consum', 0.0212, 'lps'),
	(401241, 123, '2015-02-15 01:00:31.000000', 'consum', 0.0214, 'lps'),
	(401242, 123, '2015-02-15 01:00:32.000000', 'consum', 0.0213, 'lps'),
	(401243, 123, '2015-02-15 01:00:33.000000', 'consum', 0.0214, 'lps'),
	(401244, 123, '2015-02-15 01:00:34.000000', 'consum', 0.0210, 'lps'),
	(401245, 123, '2015-02-15 01:00:35.000000', 'consum', 0.0210, 'lps'),
	(401246, 123, '2015-02-15 01:00:36.000000', 'consum', 0.0219, 'lps'),
	(401247, 123, '2015-02-15 01:00:37.000000', 'consum', 0.0215, 'lps'),
	(401248, 123, '2015-02-15 01:00:38.000000', 'consum', 0.0219, 'lps'),
	(401249, 123, '2015-02-15 01:00:39.000000', 'consum', 0.0218, 'lps'),
	(401250, 123, '2015-02-15 01:00:40.000000', 'consum', 0.0210, 'lps'),
	(401251, 123, '2015-02-15 01:00:41.000000', 'consum', 0.0212, 'lps'),
	(401252, 123, '2015-02-15 01:00:42.000000', 'consum', 0.0220, 'lps'),
	(401253, 123, '2015-02-15 01:00:43.000000', 'consum', 0.0220, 'lps'),
	(401254, 123, '2015-02-15 01:00:44.000000', 'consum', 0.0211, 'lps'),
	(401255, 123, '2015-02-15 01:00:45.000000', 'consum', 0.0216, 'lps'),
	(401256, 123, '2015-02-15 01:00:46.000000', 'consum', 0.0217, 'lps'),
	(401257, 123, '2015-02-15 01:00:47.000000', 'consum', 0.0218, 'lps'),
	(401258, 123, '2015-02-15 01:00:48.000000', 'consum', 0.0218, 'lps'),
	(401259, 123, '2015-02-15 01:00:49.000000', 'consum', 0.0213, 'lps'),
	(401260, 123, '2015-02-15 01:00:50.000000', 'consum', 0.0215, 'lps'),
	(401261, 123, '2015-02-15 01:00:51.000000', 'consum', 0.0216, 'lps'),
	(401262, 123, '2015-02-15 01:00:52.000000', 'consum', 0.0212, 'lps'),
	(401263, 123, '2015-02-15 01:00:53.000000', 'consum', 0.0213, 'lps'),
	(401264, 123, '2015-02-15 01:00:54.000000', 'consum', 0.0220, 'lps'),
	(401265, 123, '2015-02-15 01:00:55.000000', 'consum', 0.0219, 'lps'),
	(401266, 123, '2015-02-15 01:00:56.000000', 'consum', 0.0214, 'lps'),
	(401267, 123, '2015-02-15 01:00:57.000000', 'consum', 0.0213, 'lps'),
	(401268, 123, '2015-02-15 01:00:58.000000', 'consum', 0.0217, 'lps'),
	(401269, 123, '2015-02-15 01:00:59.000000', 'consum', 0.0212, 'lps'),
	(401270, 123, '2015-02-15 01:01:00.000000', 'consum', 0.0212, 'lps'),
	(401271, 123, '2015-02-15 01:01:01.000000', 'consum', 0.0215, 'lps'),
	(401272, 123, '2015-02-15 01:01:02.000000', 'consum', 0.0216, 'lps'),
	(401273, 123, '2015-02-15 01:01:03.000000', 'consum', 0.0217, 'lps'),
	(401274, 123, '2015-02-15 01:01:04.000000', 'consum', 0.0216, 'lps'),
	(401275, 123, '2015-02-15 01:01:05.000000', 'consum', 0.0220, 'lps'),
	(401276, 123, '2015-02-15 01:01:06.000000', 'consum', 0.0218, 'lps'),
	(401277, 123, '2015-02-15 01:01:07.000000', 'consum', 0.0212, 'lps'),
	(401278, 123, '2015-02-15 01:01:08.000000', 'consum', 0.0219, 'lps'),
	(401279, 123, '2015-02-15 01:01:09.000000', 'consum', 0.0214, 'lps'),
	(401280, 123, '2015-02-15 01:01:10.000000', 'consum', 0.0215, 'lps'),
	(401281, 123, '2015-02-15 01:01:11.000000', 'consum', 0.0211, 'lps'),
	(401282, 123, '2015-02-15 01:01:12.000000', 'consum', 0.0212, 'lps'),
	(401283, 123, '2015-02-15 01:01:13.000000', 'consum', 0.0218, 'lps'),
	(401284, 123, '2015-02-15 01:01:14.000000', 'consum', 0.0210, 'lps'),
	(401285, 123, '2015-02-15 01:01:15.000000', 'consum', 0.0210, 'lps'),
	(401286, 123, '2015-02-15 01:01:16.000000', 'consum', 0.0220, 'lps'),
	(401287, 123, '2015-02-15 01:01:17.000000', 'consum', 0.0216, 'lps'),
	(401288, 123, '2015-02-15 01:01:18.000000', 'consum', 0.0212, 'lps'),
	(401289, 123, '2015-02-15 01:01:19.000000', 'consum', 0.0215, 'lps'),
	(401290, 123, '2015-02-15 01:01:20.000000', 'consum', 0.0215, 'lps'),
	(401291, 123, '2015-02-15 01:01:21.000000', 'consum', 0.0213, 'lps'),
	(401292, 123, '2015-02-15 01:01:22.000000', 'consum', 0.0219, 'lps'),
	(401293, 123, '2015-02-15 01:01:23.000000', 'consum', 0.0214, 'lps'),
	(401294, 123, '2015-02-15 01:01:24.000000', 'consum', 0.0217, 'lps'),
	(401295, 123, '2015-02-15 01:01:25.000000', 'consum', 0.0220, 'lps'),
	(401296, 123, '2015-02-15 01:01:26.000000', 'consum', 0.0218, 'lps'),
	(401297, 123, '2015-02-15 01:01:27.000000', 'consum', 0.0218, 'lps'),
	(401298, 123, '2015-02-15 01:01:28.000000', 'consum', 0.0219, 'lps'),
	(401299, 123, '2015-02-15 01:01:29.000000', 'consum', 0.0210, 'lps'),
	(401300, 123, '2015-02-15 01:01:30.000000', 'consum', 0.0214, 'lps'),
	(401301, 123, '2015-02-15 01:01:31.000000', 'consum', 0.0220, 'lps'),
	(401302, 123, '2015-02-15 01:01:32.000000', 'consum', 0.0214, 'lps'),
	(401303, 123, '2015-02-15 01:01:33.000000', 'consum', 0.0211, 'lps'),
	(401304, 123, '2015-02-15 01:01:34.000000', 'consum', 0.0218, 'lps'),
	(401305, 123, '2015-02-15 01:01:35.000000', 'consum', 0.0212, 'lps'),
	(401306, 123, '2015-02-15 01:01:36.000000', 'consum', 0.0218, 'lps'),
	(401307, 123, '2015-02-15 01:01:37.000000', 'consum', 0.0213, 'lps'),
	(401308, 123, '2015-02-15 01:01:38.000000', 'consum', 0.0210, 'lps'),
	(401309, 123, '2015-02-15 01:01:39.000000', 'consum', 0.0216, 'lps'),
	(401310, 123, '2015-02-15 01:01:40.000000', 'consum', 0.0217, 'lps'),
	(401311, 123, '2015-02-15 01:01:41.000000', 'consum', 0.0215, 'lps'),
	(401312, 123, '2015-02-15 01:01:42.000000', 'consum', 0.0215, 'lps'),
	(401313, 123, '2015-02-15 01:01:43.000000', 'consum', 0.0211, 'lps'),
	(401314, 123, '2015-02-15 01:01:44.000000', 'consum', 0.0213, 'lps'),
	(401315, 123, '2015-02-15 01:01:45.000000', 'consum', 0.0219, 'lps'),
	(401316, 123, '2015-02-15 01:01:46.000000', 'consum', 0.0216, 'lps'),
	(401317, 123, '2015-02-15 01:01:47.000000', 'consum', 0.0215, 'lps'),
	(401318, 123, '2015-02-15 01:01:48.000000', 'consum', 0.0215, 'lps'),
	(401319, 123, '2015-02-15 01:01:49.000000', 'consum', 0.0220, 'lps'),
	(401320, 123, '2015-02-15 01:01:50.000000', 'consum', 0.0213, 'lps'),
	(401321, 123, '2015-02-15 01:01:51.000000', 'consum', 0.0218, 'lps'),
	(401322, 123, '2015-02-15 01:01:52.000000', 'consum', 0.0210, 'lps'),
	(401323, 123, '2015-02-15 01:01:53.000000', 'consum', 0.0218, 'lps'),
	(401324, 123, '2015-02-15 01:01:54.000000', 'consum', 0.0216, 'lps'),
	(401325, 123, '2015-02-15 01:01:55.000000', 'consum', 0.0218, 'lps'),
	(401326, 123, '2015-02-15 01:01:56.000000', 'consum', 0.0211, 'lps'),
	(401327, 123, '2015-02-15 01:01:57.000000', 'consum', 0.0213, 'lps'),
	(401328, 123, '2015-02-15 01:01:58.000000', 'consum', 0.0211, 'lps'),
	(401329, 123, '2015-02-15 01:01:59.000000', 'consum', 0.0219, 'lps'),
	(401330, 123, '2015-02-15 01:02:00.000000', 'consum', 0.0220, 'lps'),
	(401331, 123, '2015-02-15 01:02:01.000000', 'consum', 0.0212, 'lps'),
	(401332, 123, '2015-02-15 01:02:02.000000', 'consum', 0.0213, 'lps'),
	(401333, 123, '2015-02-15 01:02:03.000000', 'consum', 0.0219, 'lps'),
	(401334, 123, '2015-02-15 01:02:04.000000', 'consum', 0.0213, 'lps'),
	(401335, 123, '2015-02-15 01:02:05.000000', 'consum', 0.0210, 'lps'),
	(401336, 123, '2015-02-15 01:02:06.000000', 'consum', 0.0212, 'lps'),
	(401337, 123, '2015-02-15 01:02:07.000000', 'consum', 0.0220, 'lps'),
	(401338, 123, '2015-02-15 01:02:08.000000', 'consum', 0.0220, 'lps'),
	(401339, 123, '2015-02-15 01:02:09.000000', 'consum', 0.0211, 'lps'),
	(401340, 123, '2015-02-15 01:02:10.000000', 'consum', 0.0219, 'lps'),
	(401341, 123, '2015-02-15 01:02:11.000000', 'consum', 0.0217, 'lps'),
	(401342, 123, '2015-02-15 01:02:12.000000', 'consum', 0.0210, 'lps'),
	(401343, 123, '2015-02-15 01:02:13.000000', 'consum', 0.0212, 'lps'),
	(401344, 123, '2015-02-15 01:02:14.000000', 'consum', 0.0220, 'lps'),
	(401345, 123, '2015-02-15 01:02:15.000000', 'consum', 0.0211, 'lps'),
	(401346, 123, '2015-02-15 01:02:16.000000', 'consum', 0.0219, 'lps'),
	(401347, 123, '2015-02-15 01:02:17.000000', 'consum', 0.0217, 'lps'),
	(401348, 123, '2015-02-15 01:02:18.000000', 'consum', 0.0219, 'lps'),
	(401349, 123, '2015-02-15 01:02:19.000000', 'consum', 0.0214, 'lps'),
	(401350, 123, '2015-02-15 01:02:20.000000', 'consum', 0.0215, 'lps'),
	(401351, 123, '2015-02-15 01:02:21.000000', 'consum', 0.0210, 'lps'),
	(401352, 123, '2015-02-15 01:02:22.000000', 'consum', 0.0217, 'lps'),
	(401353, 123, '2015-02-15 01:02:23.000000', 'consum', 0.0212, 'lps'),
	(401354, 123, '2015-02-15 01:02:24.000000', 'consum', 0.0213, 'lps'),
	(401355, 123, '2015-02-15 01:02:25.000000', 'consum', 0.0219, 'lps'),
	(401356, 123, '2015-02-15 01:02:26.000000', 'consum', 0.0213, 'lps'),
	(401357, 123, '2015-02-15 01:02:27.000000', 'consum', 0.0220, 'lps'),
	(401358, 123, '2015-02-15 01:02:28.000000', 'consum', 0.0220, 'lps'),
	(401359, 123, '2015-02-15 01:02:29.000000', 'consum', 0.0219, 'lps'),
	(401360, 123, '2015-02-15 01:02:30.000000', 'consum', 0.0214, 'lps'),
	(401361, 123, '2015-02-15 01:02:31.000000', 'consum', 0.0215, 'lps'),
	(401362, 123, '2015-02-15 01:02:32.000000', 'consum', 0.0213, 'lps'),
	(401363, 123, '2015-02-15 01:02:33.000000', 'consum', 0.0212, 'lps'),
	(401364, 123, '2015-02-15 01:02:34.000000', 'consum', 0.0219, 'lps'),
	(401365, 123, '2015-02-15 01:02:35.000000', 'consum', 0.0219, 'lps'),
	(401366, 123, '2015-02-15 01:02:36.000000', 'consum', 0.0217, 'lps'),
	(401367, 123, '2015-02-15 01:02:37.000000', 'consum', 0.0218, 'lps'),
	(401368, 123, '2015-02-15 01:02:38.000000', 'consum', 0.0218, 'lps'),
	(401369, 123, '2015-02-15 01:02:39.000000', 'consum', 0.0218, 'lps'),
	(401370, 123, '2015-02-15 01:02:40.000000', 'consum', 0.0214, 'lps'),
	(401371, 123, '2015-02-15 01:02:41.000000', 'consum', 0.0216, 'lps'),
	(401372, 123, '2015-02-15 01:02:42.000000', 'consum', 0.0217, 'lps'),
	(401373, 123, '2015-02-15 01:02:43.000000', 'consum', 0.0217, 'lps'),
	(401374, 123, '2015-02-15 01:02:44.000000', 'consum', 0.0214, 'lps'),
	(401375, 123, '2015-02-15 01:02:45.000000', 'consum', 0.0219, 'lps'),
	(401376, 123, '2015-02-15 01:02:46.000000', 'consum', 0.0210, 'lps'),
	(401377, 123, '2015-02-15 01:02:47.000000', 'consum', 0.0219, 'lps'),
	(401378, 123, '2015-02-15 01:02:48.000000', 'consum', 0.0210, 'lps'),
	(401379, 123, '2015-02-15 01:02:49.000000', 'consum', 0.0216, 'lps'),
	(401380, 123, '2015-02-15 01:02:50.000000', 'consum', 0.0218, 'lps'),
	(401381, 123, '2015-02-15 01:02:51.000000', 'consum', 0.0220, 'lps'),
	(401382, 123, '2015-02-15 01:02:52.000000', 'consum', 0.0218, 'lps'),
	(401383, 123, '2015-02-15 01:02:53.000000', 'consum', 0.0217, 'lps'),
	(401384, 123, '2015-02-15 01:02:54.000000', 'consum', 0.0213, 'lps'),
	(401385, 123, '2015-02-15 01:02:55.000000', 'consum', 0.0215, 'lps'),
	(401386, 123, '2015-02-15 01:02:56.000000', 'consum', 0.0215, 'lps'),
	(401387, 123, '2015-02-15 01:02:57.000000', 'consum', 0.0219, 'lps'),
	(401388, 123, '2015-02-15 01:02:58.000000', 'consum', 0.0218, 'lps'),
	(401389, 123, '2015-02-15 01:02:59.000000', 'consum', 0.0215, 'lps'),
	(401390, 123, '2015-02-15 01:03:00.000000', 'consum', 0.0211, 'lps'),
	(401391, 123, '2015-02-15 01:03:01.000000', 'consum', 0.0213, 'lps'),
	(401392, 123, '2015-02-15 01:03:02.000000', 'consum', 0.0212, 'lps'),
	(401393, 123, '2015-02-15 01:03:03.000000', 'consum', 0.0220, 'lps'),
	(401394, 123, '2015-02-15 01:03:04.000000', 'consum', 0.0211, 'lps'),
	(401395, 123, '2015-02-15 01:03:05.000000', 'consum', 0.0220, 'lps'),
	(401396, 123, '2015-02-15 01:03:06.000000', 'consum', 0.0213, 'lps'),
	(401397, 123, '2015-02-15 01:03:07.000000', 'consum', 0.0216, 'lps'),
	(401398, 123, '2015-02-15 01:03:08.000000', 'consum', 0.0211, 'lps'),
	(401399, 123, '2015-02-15 01:03:09.000000', 'consum', 0.0220, 'lps'),
	(401400, 123, '2015-02-15 01:03:10.000000', 'consum', 0.0214, 'lps'),
	(401401, 123, '2015-02-15 01:03:11.000000', 'consum', 0.0220, 'lps'),
	(401402, 123, '2015-02-15 01:03:12.000000', 'consum', 0.0218, 'lps'),
	(401403, 123, '2015-02-15 01:03:13.000000', 'consum', 0.0218, 'lps'),
	(401404, 123, '2015-02-15 01:03:14.000000', 'consum', 0.0215, 'lps'),
	(401405, 123, '2015-02-15 01:03:15.000000', 'consum', 0.0214, 'lps'),
	(401406, 123, '2015-02-15 01:03:16.000000', 'consum', 0.0213, 'lps'),
	(401407, 123, '2015-02-15 01:03:17.000000', 'consum', 0.0214, 'lps'),
	(401408, 123, '2015-02-15 01:03:18.000000', 'consum', 0.0211, 'lps'),
	(401409, 123, '2015-02-15 01:03:19.000000', 'consum', 0.0215, 'lps'),
	(401410, 123, '2015-02-15 01:03:20.000000', 'consum', 0.0211, 'lps'),
	(401411, 123, '2015-02-15 01:03:21.000000', 'consum', 0.0212, 'lps'),
	(401412, 123, '2015-02-15 01:03:22.000000', 'consum', 0.0215, 'lps'),
	(401413, 123, '2015-02-15 01:03:23.000000', 'consum', 0.0219, 'lps'),
	(401414, 123, '2015-02-15 01:03:24.000000', 'consum', 0.0210, 'lps'),
	(401415, 123, '2015-02-15 01:03:25.000000', 'consum', 0.0214, 'lps'),
	(401416, 123, '2015-02-15 01:03:26.000000', 'consum', 0.0219, 'lps'),
	(401417, 123, '2015-02-15 01:03:27.000000', 'consum', 0.0212, 'lps'),
	(401418, 123, '2015-02-15 01:03:28.000000', 'consum', 0.0216, 'lps'),
	(401419, 123, '2015-02-15 01:03:29.000000', 'consum', 0.0210, 'lps'),
	(401420, 123, '2015-02-15 01:03:30.000000', 'consum', 0.0215, 'lps'),
	(401421, 123, '2015-02-15 01:03:31.000000', 'consum', 0.0216, 'lps'),
	(401422, 123, '2015-02-15 01:03:32.000000', 'consum', 0.0214, 'lps'),
	(401423, 123, '2015-02-15 01:03:33.000000', 'consum', 0.0210, 'lps'),
	(401424, 123, '2015-02-15 01:03:34.000000', 'consum', 0.0211, 'lps'),
	(401425, 123, '2015-02-15 01:03:35.000000', 'consum', 0.0216, 'lps'),
	(401426, 123, '2015-02-15 01:03:36.000000', 'consum', 0.0214, 'lps'),
	(401427, 123, '2015-02-15 01:03:37.000000', 'consum', 0.0214, 'lps'),
	(401428, 123, '2015-02-15 01:03:38.000000', 'consum', 0.0216, 'lps'),
	(401429, 123, '2015-02-15 01:03:39.000000', 'consum', 0.0219, 'lps'),
	(401430, 123, '2015-02-15 01:03:40.000000', 'consum', 0.0214, 'lps'),
	(401431, 123, '2015-02-15 01:03:41.000000', 'consum', 0.0217, 'lps'),
	(401432, 123, '2015-02-15 01:03:42.000000', 'consum', 0.0210, 'lps'),
	(401433, 123, '2015-02-15 01:03:43.000000', 'consum', 0.0213, 'lps'),
	(401434, 123, '2015-02-15 01:03:44.000000', 'consum', 0.0213, 'lps'),
	(401435, 123, '2015-02-15 01:03:45.000000', 'consum', 0.0218, 'lps'),
	(401436, 123, '2015-02-15 01:03:46.000000', 'consum', 0.0218, 'lps'),
	(401437, 123, '2015-02-15 01:03:47.000000', 'consum', 0.0215, 'lps'),
	(401438, 123, '2015-02-15 01:03:48.000000', 'consum', 0.0214, 'lps'),
	(401439, 123, '2015-02-15 01:03:49.000000', 'consum', 0.0213, 'lps'),
	(401440, 123, '2015-02-15 01:03:50.000000', 'consum', 0.0215, 'lps'),
	(401441, 123, '2015-02-15 01:03:51.000000', 'consum', 0.0216, 'lps'),
	(401442, 123, '2015-02-15 01:03:52.000000', 'consum', 0.0214, 'lps'),
	(401443, 123, '2015-02-15 01:03:53.000000', 'consum', 0.0213, 'lps'),
	(401444, 123, '2015-02-15 01:03:54.000000', 'consum', 0.0214, 'lps'),
	(401445, 123, '2015-02-15 01:03:55.000000', 'consum', 0.0210, 'lps'),
	(401446, 123, '2015-02-15 01:03:56.000000', 'consum', 0.0219, 'lps'),
	(401447, 123, '2015-02-15 01:03:57.000000', 'consum', 0.0211, 'lps'),
	(401448, 123, '2015-02-15 01:03:58.000000', 'consum', 0.0213, 'lps'),
	(401449, 123, '2015-02-15 01:03:59.000000', 'consum', 0.0211, 'lps'),
	(401450, 123, '2015-02-15 01:04:00.000000', 'consum', 0.0215, 'lps'),
	(401451, 123, '2015-02-15 01:04:01.000000', 'consum', 0.0213, 'lps'),
	(401452, 123, '2015-02-15 01:04:02.000000', 'consum', 0.0210, 'lps'),
	(401453, 123, '2015-02-15 01:04:03.000000', 'consum', 0.0213, 'lps'),
	(401454, 123, '2015-02-15 01:04:04.000000', 'consum', 0.0213, 'lps'),
	(401455, 123, '2015-02-15 01:04:05.000000', 'consum', 0.0216, 'lps'),
	(401456, 123, '2015-02-15 01:04:06.000000', 'consum', 0.0212, 'lps'),
	(401457, 123, '2015-02-15 01:04:07.000000', 'consum', 0.0213, 'lps'),
	(401458, 123, '2015-02-15 01:04:08.000000', 'consum', 0.0219, 'lps'),
	(401459, 123, '2015-02-15 01:04:09.000000', 'consum', 0.0214, 'lps'),
	(401460, 123, '2015-02-15 01:04:10.000000', 'consum', 0.0214, 'lps'),
	(401461, 123, '2015-02-15 01:04:11.000000', 'consum', 0.0217, 'lps'),
	(401462, 123, '2015-02-15 01:04:12.000000', 'consum', 0.0211, 'lps'),
	(401463, 123, '2015-02-15 01:04:13.000000', 'consum', 0.0219, 'lps'),
	(401464, 123, '2015-02-15 01:04:14.000000', 'consum', 0.0217, 'lps'),
	(401465, 123, '2015-02-15 01:04:15.000000', 'consum', 0.0218, 'lps'),
	(401466, 123, '2015-02-15 01:04:16.000000', 'consum', 0.0220, 'lps'),
	(401467, 123, '2015-02-15 01:04:17.000000', 'consum', 0.0216, 'lps'),
	(401468, 123, '2015-02-15 01:04:18.000000', 'consum', 0.0211, 'lps'),
	(401469, 123, '2015-02-15 01:04:19.000000', 'consum', 0.0217, 'lps'),
	(401470, 123, '2015-02-15 01:04:20.000000', 'consum', 0.0212, 'lps'),
	(401471, 123, '2015-02-15 01:04:21.000000', 'consum', 0.0220, 'lps'),
	(401472, 123, '2015-02-15 01:04:22.000000', 'consum', 0.0212, 'lps'),
	(401473, 123, '2015-02-15 01:04:23.000000', 'consum', 0.0213, 'lps'),
	(401474, 123, '2015-02-15 01:04:24.000000', 'consum', 0.0217, 'lps'),
	(401475, 123, '2015-02-15 01:04:25.000000', 'consum', 0.0217, 'lps'),
	(401476, 123, '2015-02-15 01:04:26.000000', 'consum', 0.0211, 'lps'),
	(401477, 123, '2015-02-15 01:04:27.000000', 'consum', 0.0216, 'lps'),
	(401478, 123, '2015-02-15 01:04:28.000000', 'consum', 0.0218, 'lps'),
	(401479, 123, '2015-02-15 01:04:29.000000', 'consum', 0.0211, 'lps'),
	(401480, 123, '2015-02-15 01:04:30.000000', 'consum', 0.0211, 'lps'),
	(401481, 123, '2015-02-15 01:04:31.000000', 'consum', 0.0216, 'lps'),
	(401482, 123, '2015-02-15 01:04:32.000000', 'consum', 0.0212, 'lps'),
	(401483, 123, '2015-02-15 01:04:33.000000', 'consum', 0.0216, 'lps'),
	(401484, 123, '2015-02-15 01:04:34.000000', 'consum', 0.0212, 'lps'),
	(401485, 123, '2015-02-15 01:04:35.000000', 'consum', 0.0214, 'lps'),
	(401486, 123, '2015-02-15 01:04:36.000000', 'consum', 0.0211, 'lps'),
	(401487, 123, '2015-02-15 01:04:37.000000', 'consum', 0.0217, 'lps'),
	(401488, 123, '2015-02-15 01:04:38.000000', 'consum', 0.0218, 'lps'),
	(401489, 123, '2015-02-15 01:04:39.000000', 'consum', 0.0219, 'lps'),
	(401490, 123, '2015-02-15 01:04:40.000000', 'consum', 0.0220, 'lps'),
	(401491, 123, '2015-02-15 01:04:41.000000', 'consum', 0.0212, 'lps'),
	(401492, 123, '2015-02-15 01:04:42.000000', 'consum', 0.0214, 'lps'),
	(401493, 123, '2015-02-15 01:04:43.000000', 'consum', 0.0213, 'lps'),
	(401494, 123, '2015-02-15 01:04:44.000000', 'consum', 0.0215, 'lps'),
	(401495, 123, '2015-02-15 01:04:45.000000', 'consum', 0.0214, 'lps'),
	(401496, 123, '2015-02-15 01:04:46.000000', 'consum', 0.0215, 'lps'),
	(401497, 123, '2015-02-15 01:04:47.000000', 'consum', 0.0213, 'lps'),
	(401498, 123, '2015-02-15 01:04:48.000000', 'consum', 0.0220, 'lps'),
	(401499, 123, '2015-02-15 01:04:49.000000', 'consum', 0.0219, 'lps'),
	(401500, 123, '2015-02-15 01:04:50.000000', 'consum', 0.0215, 'lps'),
	(401501, 123, '2015-02-15 01:04:51.000000', 'consum', 0.0219, 'lps'),
	(401502, 123, '2015-02-15 01:04:52.000000', 'consum', 0.0219, 'lps'),
	(401503, 123, '2015-02-15 01:04:53.000000', 'consum', 0.0218, 'lps'),
	(401504, 123, '2015-02-15 01:04:54.000000', 'consum', 0.0212, 'lps'),
	(401505, 123, '2015-02-15 01:04:55.000000', 'consum', 0.0217, 'lps'),
	(401506, 123, '2015-02-15 01:04:56.000000', 'consum', 0.0218, 'lps'),
	(401507, 123, '2015-02-15 01:04:57.000000', 'consum', 0.0210, 'lps'),
	(401508, 123, '2015-02-15 01:04:58.000000', 'consum', 0.0218, 'lps'),
	(401509, 123, '2015-02-15 01:04:59.000000', 'consum', 0.0216, 'lps'),
	(401510, 123, '2015-02-15 01:05:00.000000', 'consum', 0.0217, 'lps'),
	(401511, 123, '2015-02-15 01:05:01.000000', 'consum', 0.0217, 'lps'),
	(401512, 123, '2015-02-15 01:05:02.000000', 'consum', 0.0214, 'lps'),
	(401513, 123, '2015-02-15 01:05:03.000000', 'consum', 0.0218, 'lps'),
	(401514, 123, '2015-02-15 01:05:04.000000', 'consum', 0.0218, 'lps'),
	(401515, 123, '2015-02-15 01:05:05.000000', 'consum', 0.0217, 'lps'),
	(401516, 123, '2015-02-15 01:05:06.000000', 'consum', 0.0219, 'lps'),
	(401517, 123, '2015-02-15 01:05:07.000000', 'consum', 0.0215, 'lps'),
	(401518, 123, '2015-02-15 01:05:08.000000', 'consum', 0.0219, 'lps'),
	(401519, 123, '2015-02-15 01:05:09.000000', 'consum', 0.0216, 'lps'),
	(401520, 123, '2015-02-15 01:05:10.000000', 'consum', 0.0216, 'lps'),
	(401521, 123, '2015-02-15 01:05:11.000000', 'consum', 0.0220, 'lps'),
	(401522, 123, '2015-02-15 01:05:12.000000', 'consum', 0.0210, 'lps'),
	(401523, 123, '2015-02-15 01:05:13.000000', 'consum', 0.0212, 'lps'),
	(401524, 123, '2015-02-15 01:05:14.000000', 'consum', 0.0211, 'lps'),
	(401525, 123, '2015-02-15 01:05:15.000000', 'consum', 0.0210, 'lps'),
	(401526, 123, '2015-02-15 01:05:16.000000', 'consum', 0.0216, 'lps'),
	(401527, 123, '2015-02-15 01:05:17.000000', 'consum', 0.0210, 'lps'),
	(401528, 123, '2015-02-15 01:05:18.000000', 'consum', 0.0213, 'lps'),
	(401529, 123, '2015-02-15 01:05:19.000000', 'consum', 0.0216, 'lps'),
	(401530, 123, '2015-02-15 01:05:20.000000', 'consum', 0.0220, 'lps'),
	(401531, 123, '2015-02-15 01:05:21.000000', 'consum', 0.0220, 'lps'),
	(401532, 123, '2015-02-15 01:05:22.000000', 'consum', 0.0210, 'lps'),
	(401533, 123, '2015-02-15 01:05:23.000000', 'consum', 0.0213, 'lps'),
	(401534, 123, '2015-02-15 01:05:24.000000', 'consum', 0.0214, 'lps'),
	(401535, 123, '2015-02-15 01:05:25.000000', 'consum', 0.0211, 'lps'),
	(401536, 123, '2015-02-15 01:05:26.000000', 'consum', 0.0215, 'lps'),
	(401537, 123, '2015-02-15 01:05:27.000000', 'consum', 0.0219, 'lps'),
	(401538, 123, '2015-02-15 01:05:28.000000', 'consum', 0.0219, 'lps'),
	(401539, 123, '2015-02-15 01:05:29.000000', 'consum', 0.0220, 'lps'),
	(401540, 123, '2015-02-15 01:05:30.000000', 'consum', 0.0220, 'lps'),
	(401541, 123, '2015-02-15 01:05:31.000000', 'consum', 0.0220, 'lps'),
	(401542, 123, '2015-02-15 01:05:32.000000', 'consum', 0.0211, 'lps'),
	(401543, 123, '2015-02-15 01:05:33.000000', 'consum', 0.0215, 'lps'),
	(401544, 123, '2015-02-15 01:05:34.000000', 'consum', 0.0213, 'lps'),
	(401545, 123, '2015-02-15 01:05:35.000000', 'consum', 0.0211, 'lps'),
	(401546, 123, '2015-02-15 01:05:36.000000', 'consum', 0.0216, 'lps'),
	(401547, 123, '2015-02-15 01:05:37.000000', 'consum', 0.0214, 'lps'),
	(401548, 123, '2015-02-15 01:05:38.000000', 'consum', 0.0214, 'lps'),
	(401549, 123, '2015-02-15 01:05:39.000000', 'consum', 0.0218, 'lps'),
	(401550, 123, '2015-02-15 01:05:40.000000', 'consum', 0.0216, 'lps'),
	(401551, 123, '2015-02-15 01:05:41.000000', 'consum', 0.0215, 'lps'),
	(401552, 123, '2015-02-15 01:05:42.000000', 'consum', 0.0220, 'lps'),
	(401553, 123, '2015-02-15 01:05:43.000000', 'consum', 0.0213, 'lps'),
	(401554, 123, '2015-02-15 01:05:44.000000', 'consum', 0.0217, 'lps'),
	(401555, 123, '2015-02-15 01:05:45.000000', 'consum', 0.0215, 'lps'),
	(401556, 123, '2015-02-15 01:05:46.000000', 'consum', 0.0212, 'lps'),
	(401557, 123, '2015-02-15 01:05:47.000000', 'consum', 0.0218, 'lps'),
	(401558, 123, '2015-02-15 01:05:48.000000', 'consum', 0.0213, 'lps'),
	(401559, 123, '2015-02-15 01:05:49.000000', 'consum', 0.0212, 'lps'),
	(401560, 123, '2015-02-15 01:05:50.000000', 'consum', 0.0212, 'lps'),
	(401561, 123, '2015-02-15 01:05:51.000000', 'consum', 0.0212, 'lps'),
	(401562, 123, '2015-02-15 01:05:52.000000', 'consum', 0.0217, 'lps'),
	(401563, 123, '2015-02-15 01:05:53.000000', 'consum', 0.0219, 'lps'),
	(401564, 123, '2015-02-15 01:05:54.000000', 'consum', 0.0220, 'lps'),
	(401565, 123, '2015-02-15 01:05:55.000000', 'consum', 0.0214, 'lps'),
	(401566, 123, '2015-02-15 01:05:56.000000', 'consum', 0.0213, 'lps'),
	(401567, 123, '2015-02-15 01:05:57.000000', 'consum', 0.0211, 'lps'),
	(401568, 123, '2015-02-15 01:05:58.000000', 'consum', 0.0217, 'lps'),
	(401569, 123, '2015-02-15 01:05:59.000000', 'consum', 0.0212, 'lps'),
	(401570, 123, '2015-02-15 01:06:00.000000', 'consum', 0.0219, 'lps'),
	(401571, 123, '2015-02-15 01:06:01.000000', 'consum', 0.0217, 'lps'),
	(401572, 123, '2015-02-15 01:06:02.000000', 'consum', 0.0217, 'lps'),
	(401573, 123, '2015-02-15 01:06:03.000000', 'consum', 0.0216, 'lps'),
	(401574, 123, '2015-02-15 01:06:04.000000', 'consum', 0.0220, 'lps'),
	(401575, 123, '2015-02-15 01:06:05.000000', 'consum', 0.0219, 'lps'),
	(401576, 123, '2015-02-15 01:06:06.000000', 'consum', 0.0216, 'lps'),
	(401577, 123, '2015-02-15 01:06:07.000000', 'consum', 0.0212, 'lps'),
	(401578, 123, '2015-02-15 01:06:08.000000', 'consum', 0.0214, 'lps'),
	(401579, 123, '2015-02-15 01:06:09.000000', 'consum', 0.0214, 'lps'),
	(401580, 123, '2015-02-15 01:06:10.000000', 'consum', 0.0220, 'lps'),
	(401581, 123, '2015-02-15 01:06:11.000000', 'consum', 0.0213, 'lps'),
	(401582, 123, '2015-02-15 01:06:12.000000', 'consum', 0.0218, 'lps'),
	(401583, 123, '2015-02-15 01:06:13.000000', 'consum', 0.0220, 'lps'),
	(401584, 123, '2015-02-15 01:06:14.000000', 'consum', 0.0214, 'lps'),
	(401585, 123, '2015-02-15 01:06:15.000000', 'consum', 0.0212, 'lps'),
	(401586, 123, '2015-02-15 01:06:16.000000', 'consum', 0.0220, 'lps'),
	(401587, 123, '2015-02-15 01:06:17.000000', 'consum', 0.0211, 'lps'),
	(401588, 123, '2015-02-15 01:06:18.000000', 'consum', 0.0218, 'lps'),
	(401589, 123, '2015-02-15 01:06:19.000000', 'consum', 0.0213, 'lps'),
	(401590, 123, '2015-02-15 01:06:20.000000', 'consum', 0.0213, 'lps'),
	(401591, 123, '2015-02-15 01:06:21.000000', 'consum', 0.0216, 'lps'),
	(401592, 123, '2015-02-15 01:06:22.000000', 'consum', 0.0212, 'lps'),
	(401593, 123, '2015-02-15 01:06:23.000000', 'consum', 0.0213, 'lps'),
	(401594, 123, '2015-02-15 01:06:24.000000', 'consum', 0.0218, 'lps'),
	(401595, 123, '2015-02-15 01:06:25.000000', 'consum', 0.0210, 'lps'),
	(401596, 123, '2015-02-15 01:06:26.000000', 'consum', 0.0218, 'lps'),
	(401597, 123, '2015-02-15 01:06:27.000000', 'consum', 0.0217, 'lps'),
	(401598, 123, '2015-02-15 01:06:28.000000', 'consum', 0.0213, 'lps'),
	(401599, 123, '2015-02-15 01:06:29.000000', 'consum', 0.0216, 'lps'),
	(401600, 123, '2015-02-15 01:06:30.000000', 'consum', 0.0219, 'lps'),
	(401601, 123, '2015-02-15 01:06:31.000000', 'consum', 0.0214, 'lps'),
	(401602, 123, '2015-02-15 01:06:32.000000', 'consum', 0.0218, 'lps'),
	(401603, 123, '2015-02-15 01:06:33.000000', 'consum', 0.0214, 'lps'),
	(401604, 123, '2015-02-15 01:06:34.000000', 'consum', 0.0216, 'lps'),
	(401605, 123, '2015-02-15 01:06:35.000000', 'consum', 0.0210, 'lps'),
	(401606, 123, '2015-02-15 01:06:36.000000', 'consum', 0.0213, 'lps'),
	(401607, 123, '2015-02-15 01:06:37.000000', 'consum', 0.0214, 'lps'),
	(401608, 123, '2015-02-15 01:06:38.000000', 'consum', 0.0212, 'lps'),
	(401609, 123, '2015-02-15 01:06:39.000000', 'consum', 0.0217, 'lps'),
	(401610, 123, '2015-02-15 01:06:40.000000', 'consum', 0.0210, 'lps'),
	(401611, 123, '2015-02-15 01:06:41.000000', 'consum', 0.0220, 'lps'),
	(401612, 123, '2015-02-15 01:06:42.000000', 'consum', 0.0216, 'lps'),
	(401613, 123, '2015-02-15 01:06:43.000000', 'consum', 0.0211, 'lps'),
	(401614, 123, '2015-02-15 01:06:44.000000', 'consum', 0.0219, 'lps'),
	(401615, 123, '2015-02-15 01:06:45.000000', 'consum', 0.0211, 'lps'),
	(401616, 123, '2015-02-15 01:06:46.000000', 'consum', 0.0218, 'lps'),
	(401617, 123, '2015-02-15 01:06:47.000000', 'consum', 0.0217, 'lps'),
	(401618, 123, '2015-02-15 01:06:48.000000', 'consum', 0.0220, 'lps'),
	(401619, 123, '2015-02-15 01:06:49.000000', 'consum', 0.0219, 'lps'),
	(401620, 123, '2015-02-15 01:06:50.000000', 'consum', 0.0216, 'lps'),
	(401621, 123, '2015-02-15 01:06:51.000000', 'consum', 0.0212, 'lps'),
	(401622, 123, '2015-02-15 01:06:52.000000', 'consum', 0.0212, 'lps'),
	(401623, 123, '2015-02-15 01:06:53.000000', 'consum', 0.0216, 'lps'),
	(401624, 123, '2015-02-15 01:06:54.000000', 'consum', 0.0211, 'lps'),
	(401625, 123, '2015-02-15 01:06:55.000000', 'consum', 0.0211, 'lps'),
	(401626, 123, '2015-02-15 01:06:56.000000', 'consum', 0.0213, 'lps'),
	(401627, 123, '2015-02-15 01:06:57.000000', 'consum', 0.0210, 'lps'),
	(401628, 123, '2015-02-15 01:06:58.000000', 'consum', 0.0213, 'lps'),
	(401629, 123, '2015-02-15 01:06:59.000000', 'consum', 0.0215, 'lps'),
	(401630, 123, '2015-02-15 01:07:00.000000', 'consum', 0.0216, 'lps'),
	(401631, 123, '2015-02-15 01:07:01.000000', 'consum', 0.0214, 'lps'),
	(401632, 123, '2015-02-15 01:07:02.000000', 'consum', 0.0211, 'lps'),
	(401633, 123, '2015-02-15 01:07:03.000000', 'consum', 0.0216, 'lps'),
	(401634, 123, '2015-02-15 01:07:04.000000', 'consum', 0.0214, 'lps'),
	(401635, 123, '2015-02-15 01:07:05.000000', 'consum', 0.0213, 'lps'),
	(401636, 123, '2015-02-15 01:07:06.000000', 'consum', 0.0213, 'lps'),
	(401637, 123, '2015-02-15 01:07:07.000000', 'consum', 0.0216, 'lps'),
	(401638, 123, '2015-02-15 01:07:08.000000', 'consum', 0.0211, 'lps'),
	(401639, 123, '2015-02-15 01:07:09.000000', 'consum', 0.0217, 'lps'),
	(401640, 123, '2015-02-15 01:07:10.000000', 'consum', 0.0210, 'lps'),
	(401641, 123, '2015-02-15 01:07:11.000000', 'consum', 0.0213, 'lps'),
	(401642, 123, '2015-02-15 01:07:12.000000', 'consum', 0.0213, 'lps'),
	(401643, 123, '2015-02-15 01:07:13.000000', 'consum', 0.0217, 'lps'),
	(401644, 123, '2015-02-15 01:07:14.000000', 'consum', 0.0213, 'lps'),
	(401645, 123, '2015-02-15 01:07:15.000000', 'consum', 0.0215, 'lps'),
	(401646, 123, '2015-02-15 01:07:16.000000', 'consum', 0.0216, 'lps'),
	(401647, 123, '2015-02-15 01:07:17.000000', 'consum', 0.0217, 'lps'),
	(401648, 123, '2015-02-15 01:07:18.000000', 'consum', 0.0215, 'lps'),
	(401649, 123, '2015-02-15 01:07:19.000000', 'consum', 0.0214, 'lps'),
	(401650, 123, '2015-02-15 01:07:20.000000', 'consum', 0.0217, 'lps'),
	(401651, 123, '2015-02-15 01:07:21.000000', 'consum', 0.0211, 'lps'),
	(401652, 123, '2015-02-15 01:07:22.000000', 'consum', 0.0216, 'lps'),
	(401653, 123, '2015-02-15 01:07:23.000000', 'consum', 0.0216, 'lps'),
	(401654, 123, '2015-02-15 01:07:24.000000', 'consum', 0.0211, 'lps'),
	(401655, 123, '2015-02-15 01:07:25.000000', 'consum', 0.0220, 'lps'),
	(401656, 123, '2015-02-15 01:07:26.000000', 'consum', 0.0214, 'lps'),
	(401657, 123, '2015-02-15 01:07:27.000000', 'consum', 0.0220, 'lps'),
	(401658, 123, '2015-02-15 01:07:28.000000', 'consum', 0.0218, 'lps'),
	(401659, 123, '2015-02-15 01:07:29.000000', 'consum', 0.0219, 'lps'),
	(401660, 123, '2015-02-15 01:07:30.000000', 'consum', 0.0220, 'lps'),
	(401661, 123, '2015-02-15 01:07:31.000000', 'consum', 0.0213, 'lps'),
	(401662, 123, '2015-02-15 01:07:32.000000', 'consum', 0.0217, 'lps'),
	(401663, 123, '2015-02-15 01:07:33.000000', 'consum', 0.0214, 'lps'),
	(401664, 123, '2015-02-15 01:07:34.000000', 'consum', 0.0219, 'lps'),
	(401665, 123, '2015-02-15 01:07:35.000000', 'consum', 0.0211, 'lps'),
	(401666, 123, '2015-02-15 01:07:36.000000', 'consum', 0.0211, 'lps'),
	(401667, 123, '2015-02-15 01:07:37.000000', 'consum', 0.0214, 'lps'),
	(401668, 123, '2015-02-15 01:07:38.000000', 'consum', 0.0216, 'lps'),
	(401669, 123, '2015-02-15 01:07:39.000000', 'consum', 0.0216, 'lps'),
	(401670, 123, '2015-02-15 01:07:40.000000', 'consum', 0.0213, 'lps'),
	(401671, 123, '2015-02-15 01:07:41.000000', 'consum', 0.0220, 'lps'),
	(401672, 123, '2015-02-15 01:07:42.000000', 'consum', 0.0217, 'lps'),
	(401673, 123, '2015-02-15 01:07:43.000000', 'consum', 0.0216, 'lps'),
	(401674, 123, '2015-02-15 01:07:44.000000', 'consum', 0.0220, 'lps'),
	(401675, 123, '2015-02-15 01:07:45.000000', 'consum', 0.0219, 'lps'),
	(401676, 123, '2015-02-15 01:07:46.000000', 'consum', 0.0214, 'lps'),
	(401677, 123, '2015-02-15 01:07:47.000000', 'consum', 0.0215, 'lps'),
	(401678, 123, '2015-02-15 01:07:48.000000', 'consum', 0.0211, 'lps'),
	(401679, 123, '2015-02-15 01:07:49.000000', 'consum', 0.0212, 'lps'),
	(401680, 123, '2015-02-15 01:07:50.000000', 'consum', 0.0217, 'lps'),
	(401681, 123, '2015-02-15 01:07:51.000000', 'consum', 0.0217, 'lps'),
	(401682, 123, '2015-02-15 01:07:52.000000', 'consum', 0.0215, 'lps'),
	(401683, 123, '2015-02-15 01:07:53.000000', 'consum', 0.0212, 'lps'),
	(401684, 123, '2015-02-15 01:07:54.000000', 'consum', 0.0219, 'lps'),
	(401685, 123, '2015-02-15 01:07:55.000000', 'consum', 0.0218, 'lps'),
	(401686, 123, '2015-02-15 01:07:56.000000', 'consum', 0.0210, 'lps'),
	(401687, 123, '2015-02-15 01:07:57.000000', 'consum', 0.0219, 'lps'),
	(401688, 123, '2015-02-15 01:07:58.000000', 'consum', 0.0214, 'lps'),
	(401689, 123, '2015-02-15 01:07:59.000000', 'consum', 0.0214, 'lps'),
	(401690, 123, '2015-02-15 01:08:00.000000', 'consum', 0.0218, 'lps'),
	(401691, 123, '2015-02-15 01:08:01.000000', 'consum', 0.0215, 'lps'),
	(401692, 123, '2015-02-15 01:08:02.000000', 'consum', 0.0211, 'lps'),
	(401693, 123, '2015-02-15 01:08:03.000000', 'consum', 0.0211, 'lps'),
	(401694, 123, '2015-02-15 01:08:04.000000', 'consum', 0.0212, 'lps'),
	(401695, 123, '2015-02-15 01:08:05.000000', 'consum', 0.0218, 'lps'),
	(401696, 123, '2015-02-15 01:08:06.000000', 'consum', 0.0214, 'lps'),
	(401697, 123, '2015-02-15 01:08:07.000000', 'consum', 0.0215, 'lps'),
	(401698, 123, '2015-02-15 01:08:08.000000', 'consum', 0.0212, 'lps'),
	(401699, 123, '2015-02-15 01:08:09.000000', 'consum', 0.0219, 'lps'),
	(401700, 123, '2015-02-15 01:08:10.000000', 'consum', 0.0214, 'lps'),
	(401701, 123, '2015-02-15 01:08:11.000000', 'consum', 0.0216, 'lps'),
	(401702, 123, '2015-02-15 01:08:12.000000', 'consum', 0.0218, 'lps'),
	(401703, 123, '2015-02-15 01:08:13.000000', 'consum', 0.0211, 'lps'),
	(401704, 123, '2015-02-15 01:08:14.000000', 'consum', 0.0214, 'lps'),
	(401705, 123, '2015-02-15 01:08:15.000000', 'consum', 0.0216, 'lps'),
	(401706, 123, '2015-02-15 01:08:16.000000', 'consum', 0.0217, 'lps'),
	(401707, 123, '2015-02-15 01:08:17.000000', 'consum', 0.0217, 'lps'),
	(401708, 123, '2015-02-15 01:08:18.000000', 'consum', 0.0215, 'lps'),
	(401709, 123, '2015-02-15 01:08:19.000000', 'consum', 0.0215, 'lps'),
	(401710, 123, '2015-02-15 01:08:20.000000', 'consum', 0.0218, 'lps'),
	(401711, 123, '2015-02-15 01:08:21.000000', 'consum', 0.0214, 'lps'),
	(401712, 123, '2015-02-15 01:08:22.000000', 'consum', 0.0217, 'lps'),
	(401713, 123, '2015-02-15 01:08:23.000000', 'consum', 0.0213, 'lps'),
	(401714, 123, '2015-02-15 01:08:24.000000', 'consum', 0.0214, 'lps'),
	(401715, 123, '2015-02-15 01:08:25.000000', 'consum', 0.0212, 'lps'),
	(401716, 123, '2015-02-15 01:08:26.000000', 'consum', 0.0219, 'lps'),
	(401717, 123, '2015-02-15 01:08:27.000000', 'consum', 0.0216, 'lps'),
	(401718, 123, '2015-02-15 01:08:28.000000', 'consum', 0.0214, 'lps'),
	(401719, 123, '2015-02-15 01:08:29.000000', 'consum', 0.0213, 'lps'),
	(401720, 123, '2015-02-15 01:08:30.000000', 'consum', 0.0214, 'lps'),
	(401721, 123, '2015-02-15 01:08:31.000000', 'consum', 0.0220, 'lps'),
	(401722, 123, '2015-02-15 01:08:32.000000', 'consum', 0.0216, 'lps'),
	(401723, 123, '2015-02-15 01:08:33.000000', 'consum', 0.0220, 'lps'),
	(401724, 123, '2015-02-15 01:08:34.000000', 'consum', 0.0210, 'lps'),
	(401725, 123, '2015-02-15 01:08:35.000000', 'consum', 0.0216, 'lps'),
	(401726, 123, '2015-02-15 01:08:36.000000', 'consum', 0.0217, 'lps'),
	(401727, 123, '2015-02-15 01:08:37.000000', 'consum', 0.0217, 'lps'),
	(401728, 123, '2015-02-15 01:08:38.000000', 'consum', 0.0212, 'lps'),
	(401729, 123, '2015-02-15 01:08:39.000000', 'consum', 0.0213, 'lps'),
	(401730, 123, '2015-02-15 01:08:40.000000', 'consum', 0.0220, 'lps'),
	(401731, 123, '2015-02-15 01:08:41.000000', 'consum', 0.0218, 'lps'),
	(401732, 123, '2015-02-15 01:08:42.000000', 'consum', 0.0210, 'lps'),
	(401733, 123, '2015-02-15 01:08:43.000000', 'consum', 0.0219, 'lps'),
	(401734, 123, '2015-02-15 01:08:44.000000', 'consum', 0.0213, 'lps'),
	(401735, 123, '2015-02-15 01:08:45.000000', 'consum', 0.0210, 'lps'),
	(401736, 123, '2015-02-15 01:08:46.000000', 'consum', 0.0210, 'lps'),
	(401737, 123, '2015-02-15 01:08:47.000000', 'consum', 0.0213, 'lps'),
	(401738, 123, '2015-02-15 01:08:48.000000', 'consum', 0.0211, 'lps'),
	(401739, 123, '2015-02-15 01:08:49.000000', 'consum', 0.0210, 'lps'),
	(401740, 123, '2015-02-15 01:08:50.000000', 'consum', 0.0216, 'lps'),
	(401741, 123, '2015-02-15 01:08:51.000000', 'consum', 0.0219, 'lps'),
	(401742, 123, '2015-02-15 01:08:52.000000', 'consum', 0.0217, 'lps'),
	(401743, 123, '2015-02-15 01:08:53.000000', 'consum', 0.0218, 'lps'),
	(401744, 123, '2015-02-15 01:08:54.000000', 'consum', 0.0220, 'lps'),
	(401745, 123, '2015-02-15 01:08:55.000000', 'consum', 0.0213, 'lps'),
	(401746, 123, '2015-02-15 01:08:56.000000', 'consum', 0.0220, 'lps'),
	(401747, 123, '2015-02-15 01:08:57.000000', 'consum', 0.0215, 'lps'),
	(401748, 123, '2015-02-15 01:08:58.000000', 'consum', 0.0218, 'lps'),
	(401749, 123, '2015-02-15 01:08:59.000000', 'consum', 0.0213, 'lps'),
	(401750, 123, '2015-02-15 01:09:00.000000', 'consum', 0.0213, 'lps'),
	(401751, 123, '2015-02-15 01:09:01.000000', 'consum', 0.0216, 'lps'),
	(401752, 123, '2015-02-15 01:09:02.000000', 'consum', 0.0220, 'lps'),
	(401753, 123, '2015-02-15 01:09:03.000000', 'consum', 0.0212, 'lps'),
	(401754, 123, '2015-02-15 01:09:04.000000', 'consum', 0.0211, 'lps'),
	(401755, 123, '2015-02-15 01:09:05.000000', 'consum', 0.0211, 'lps'),
	(401756, 123, '2015-02-15 01:09:06.000000', 'consum', 0.0210, 'lps'),
	(401757, 123, '2015-02-15 01:09:07.000000', 'consum', 0.0218, 'lps'),
	(401758, 123, '2015-02-15 01:09:08.000000', 'consum', 0.0217, 'lps'),
	(401759, 123, '2015-02-15 01:09:09.000000', 'consum', 0.0211, 'lps'),
	(401760, 123, '2015-02-15 01:09:10.000000', 'consum', 0.0219, 'lps'),
	(401761, 123, '2015-02-15 01:09:11.000000', 'consum', 0.0216, 'lps'),
	(401762, 123, '2015-02-15 01:09:12.000000', 'consum', 0.0215, 'lps'),
	(401763, 123, '2015-02-15 01:09:13.000000', 'consum', 0.0217, 'lps'),
	(401764, 123, '2015-02-15 01:09:14.000000', 'consum', 0.0210, 'lps'),
	(401765, 123, '2015-02-15 01:09:15.000000', 'consum', 0.0210, 'lps'),
	(401766, 123, '2015-02-15 01:09:16.000000', 'consum', 0.0211, 'lps'),
	(401767, 123, '2015-02-15 01:09:17.000000', 'consum', 0.0214, 'lps'),
	(401768, 123, '2015-02-15 01:09:18.000000', 'consum', 0.0216, 'lps'),
	(401769, 123, '2015-02-15 01:09:19.000000', 'consum', 0.0220, 'lps'),
	(401770, 123, '2015-02-15 01:09:20.000000', 'consum', 0.0220, 'lps'),
	(401771, 123, '2015-02-15 01:09:21.000000', 'consum', 0.0220, 'lps'),
	(401772, 123, '2015-02-15 01:09:22.000000', 'consum', 0.0220, 'lps'),
	(401773, 123, '2015-02-15 01:09:23.000000', 'consum', 0.0220, 'lps'),
	(401774, 123, '2015-02-15 01:09:24.000000', 'consum', 0.0220, 'lps'),
	(401775, 123, '2015-02-15 01:09:25.000000', 'consum', 0.0217, 'lps'),
	(401776, 123, '2015-02-15 01:09:26.000000', 'consum', 0.0216, 'lps'),
	(401777, 123, '2015-02-15 01:09:27.000000', 'consum', 0.0210, 'lps'),
	(401778, 123, '2015-02-15 01:09:28.000000', 'consum', 0.0213, 'lps'),
	(401779, 123, '2015-02-15 01:09:29.000000', 'consum', 0.0216, 'lps'),
	(401780, 123, '2015-02-15 01:09:30.000000', 'consum', 0.0218, 'lps'),
	(401781, 123, '2015-02-15 01:09:31.000000', 'consum', 0.0210, 'lps'),
	(401782, 123, '2015-02-15 01:09:32.000000', 'consum', 0.0212, 'lps'),
	(401783, 123, '2015-02-15 01:09:33.000000', 'consum', 0.0218, 'lps'),
	(401784, 123, '2015-02-15 01:09:34.000000', 'consum', 0.0210, 'lps'),
	(401785, 123, '2015-02-15 01:09:35.000000', 'consum', 0.0211, 'lps'),
	(401786, 123, '2015-02-15 01:09:36.000000', 'consum', 0.0216, 'lps'),
	(401787, 123, '2015-02-15 01:09:37.000000', 'consum', 0.0216, 'lps'),
	(401788, 123, '2015-02-15 01:09:38.000000', 'consum', 0.0212, 'lps'),
	(401789, 123, '2015-02-15 01:09:39.000000', 'consum', 0.0214, 'lps'),
	(401790, 123, '2015-02-15 01:09:40.000000', 'consum', 0.0213, 'lps'),
	(401791, 123, '2015-02-15 01:09:41.000000', 'consum', 0.0214, 'lps'),
	(401792, 123, '2015-02-15 01:09:42.000000', 'consum', 0.0220, 'lps'),
	(401793, 123, '2015-02-15 01:09:43.000000', 'consum', 0.0218, 'lps'),
	(401794, 123, '2015-02-15 01:09:44.000000', 'consum', 0.0219, 'lps'),
	(401795, 123, '2015-02-15 01:09:45.000000', 'consum', 0.0220, 'lps'),
	(401796, 123, '2015-02-15 01:09:46.000000', 'consum', 0.0211, 'lps'),
	(401797, 123, '2015-02-15 01:09:47.000000', 'consum', 0.0218, 'lps'),
	(401798, 123, '2015-02-15 01:09:48.000000', 'consum', 0.0217, 'lps'),
	(401799, 123, '2015-02-15 01:09:49.000000', 'consum', 0.0219, 'lps'),
	(401800, 123, '2015-02-15 01:09:50.000000', 'consum', 0.0215, 'lps'),
	(401801, 123, '2015-02-15 01:09:51.000000', 'consum', 0.0217, 'lps'),
	(401802, 123, '2015-02-15 01:09:52.000000', 'consum', 0.0219, 'lps'),
	(401803, 123, '2015-02-15 01:09:53.000000', 'consum', 0.0214, 'lps'),
	(401804, 123, '2015-02-15 01:09:54.000000', 'consum', 0.0214, 'lps'),
	(401805, 123, '2015-02-15 01:09:55.000000', 'consum', 0.0219, 'lps'),
	(401806, 123, '2015-02-15 01:09:56.000000', 'consum', 0.0220, 'lps'),
	(401807, 123, '2015-02-15 01:09:57.000000', 'consum', 0.0214, 'lps'),
	(401808, 123, '2015-02-15 01:09:58.000000', 'consum', 0.0212, 'lps'),
	(401809, 123, '2015-02-15 01:09:59.000000', 'consum', 0.0217, 'lps'),
	(401810, 123, '2015-02-15 01:10:00.000000', 'consum', 0.0220, 'lps'),
	(401811, 123, '2015-02-15 01:10:01.000000', 'consum', 0.0215, 'lps'),
	(401812, 123, '2015-02-15 01:10:02.000000', 'consum', 0.0217, 'lps'),
	(401813, 123, '2015-02-15 01:10:03.000000', 'consum', 0.0210, 'lps'),
	(401814, 123, '2015-02-15 01:10:04.000000', 'consum', 0.0220, 'lps'),
	(401815, 123, '2015-02-15 01:10:05.000000', 'consum', 0.0216, 'lps'),
	(401816, 123, '2015-02-15 01:10:06.000000', 'consum', 0.0212, 'lps'),
	(401817, 123, '2015-02-15 01:10:07.000000', 'consum', 0.0215, 'lps'),
	(401818, 123, '2015-02-15 01:10:08.000000', 'consum', 0.0215, 'lps'),
	(401819, 123, '2015-02-15 01:10:09.000000', 'consum', 0.0213, 'lps'),
	(401820, 123, '2015-02-15 01:10:10.000000', 'consum', 0.0210, 'lps'),
	(401821, 123, '2015-02-15 01:10:11.000000', 'consum', 0.0212, 'lps'),
	(401822, 123, '2015-02-15 01:10:12.000000', 'consum', 0.0210, 'lps'),
	(401823, 123, '2015-02-15 01:10:13.000000', 'consum', 0.0214, 'lps'),
	(401824, 123, '2015-02-15 01:10:14.000000', 'consum', 0.0210, 'lps'),
	(401825, 123, '2015-02-15 01:10:15.000000', 'consum', 0.0218, 'lps'),
	(401826, 123, '2015-02-15 01:10:16.000000', 'consum', 0.0210, 'lps'),
	(401827, 123, '2015-02-15 01:10:17.000000', 'consum', 0.0217, 'lps'),
	(401828, 123, '2015-02-15 01:10:18.000000', 'consum', 0.0214, 'lps'),
	(401829, 123, '2015-02-15 01:10:19.000000', 'consum', 0.0210, 'lps'),
	(401830, 123, '2015-02-15 01:10:20.000000', 'consum', 0.0219, 'lps'),
	(401831, 123, '2015-02-15 01:10:21.000000', 'consum', 0.0214, 'lps'),
	(401832, 123, '2015-02-15 01:10:22.000000', 'consum', 0.0211, 'lps'),
	(401833, 123, '2015-02-15 01:10:23.000000', 'consum', 0.0217, 'lps'),
	(401834, 123, '2015-02-15 01:10:24.000000', 'consum', 0.0210, 'lps'),
	(401835, 123, '2015-02-15 01:10:25.000000', 'consum', 0.0211, 'lps'),
	(401836, 123, '2015-02-15 01:10:26.000000', 'consum', 0.0214, 'lps'),
	(401837, 123, '2015-02-15 01:10:27.000000', 'consum', 0.0219, 'lps'),
	(401838, 123, '2015-02-15 01:10:28.000000', 'consum', 0.0220, 'lps'),
	(401839, 123, '2015-02-15 01:10:29.000000', 'consum', 0.0212, 'lps'),
	(401840, 123, '2015-02-15 01:10:30.000000', 'consum', 0.0212, 'lps'),
	(401841, 123, '2015-02-15 01:10:31.000000', 'consum', 0.0215, 'lps'),
	(401842, 123, '2015-02-15 01:10:32.000000', 'consum', 0.0219, 'lps'),
	(401843, 123, '2015-02-15 01:10:33.000000', 'consum', 0.0218, 'lps'),
	(401844, 123, '2015-02-15 01:10:34.000000', 'consum', 0.0213, 'lps'),
	(401845, 123, '2015-02-15 01:10:35.000000', 'consum', 0.0212, 'lps'),
	(401846, 123, '2015-02-15 01:10:36.000000', 'consum', 0.0211, 'lps'),
	(401847, 123, '2015-02-15 01:10:37.000000', 'consum', 0.0211, 'lps'),
	(401848, 123, '2015-02-15 01:10:38.000000', 'consum', 0.0214, 'lps'),
	(401849, 123, '2015-02-15 01:10:39.000000', 'consum', 0.0213, 'lps'),
	(401850, 123, '2015-02-15 01:10:40.000000', 'consum', 0.0215, 'lps'),
	(401851, 123, '2015-02-15 01:10:41.000000', 'consum', 0.0215, 'lps'),
	(401852, 123, '2015-02-15 01:10:42.000000', 'consum', 0.0219, 'lps'),
	(401853, 123, '2015-02-15 01:10:43.000000', 'consum', 0.0210, 'lps'),
	(401854, 123, '2015-02-15 01:10:44.000000', 'consum', 0.0216, 'lps'),
	(401855, 123, '2015-02-15 01:10:45.000000', 'consum', 0.0217, 'lps'),
	(401856, 123, '2015-02-15 01:10:46.000000', 'consum', 0.0219, 'lps'),
	(401857, 123, '2015-02-15 01:10:47.000000', 'consum', 0.0211, 'lps'),
	(401858, 123, '2015-02-15 01:10:48.000000', 'consum', 0.0213, 'lps'),
	(401859, 123, '2015-02-15 01:10:49.000000', 'consum', 0.0220, 'lps'),
	(401860, 123, '2015-02-15 01:10:50.000000', 'consum', 0.0218, 'lps'),
	(401861, 123, '2015-02-15 01:10:51.000000', 'consum', 0.0210, 'lps'),
	(401862, 123, '2015-02-15 01:10:52.000000', 'consum', 0.0210, 'lps'),
	(401863, 123, '2015-02-15 01:10:53.000000', 'consum', 0.0212, 'lps'),
	(401864, 123, '2015-02-15 01:10:54.000000', 'consum', 0.0217, 'lps'),
	(401865, 123, '2015-02-15 01:10:55.000000', 'consum', 0.0218, 'lps'),
	(401866, 123, '2015-02-15 01:10:56.000000', 'consum', 0.0218, 'lps'),
	(401867, 123, '2015-02-15 01:10:57.000000', 'consum', 0.0215, 'lps'),
	(401868, 123, '2015-02-15 01:10:58.000000', 'consum', 0.0213, 'lps'),
	(401869, 123, '2015-02-15 01:10:59.000000', 'consum', 0.0220, 'lps'),
	(401870, 123, '2015-02-15 01:11:00.000000', 'consum', 0.0220, 'lps'),
	(401871, 123, '2015-02-15 01:11:01.000000', 'consum', 0.0210, 'lps'),
	(401872, 123, '2015-02-15 01:11:02.000000', 'consum', 0.0212, 'lps'),
	(401873, 123, '2015-02-15 01:11:03.000000', 'consum', 0.0210, 'lps'),
	(401874, 123, '2015-02-15 01:11:04.000000', 'consum', 0.0215, 'lps'),
	(401875, 123, '2015-02-15 01:11:05.000000', 'consum', 0.0214, 'lps'),
	(401876, 123, '2015-02-15 01:11:06.000000', 'consum', 0.0216, 'lps'),
	(401877, 123, '2015-02-15 01:11:07.000000', 'consum', 0.0217, 'lps'),
	(401878, 123, '2015-02-15 01:11:08.000000', 'consum', 0.0216, 'lps'),
	(401879, 123, '2015-02-15 01:11:09.000000', 'consum', 0.0211, 'lps'),
	(401880, 123, '2015-02-15 01:11:10.000000', 'consum', 0.0217, 'lps'),
	(401881, 123, '2015-02-15 01:11:11.000000', 'consum', 0.0219, 'lps'),
	(401882, 123, '2015-02-15 01:11:12.000000', 'consum', 0.0216, 'lps'),
	(401883, 123, '2015-02-15 01:11:13.000000', 'consum', 0.0212, 'lps'),
	(401884, 123, '2015-02-15 01:11:14.000000', 'consum', 0.0212, 'lps'),
	(401885, 123, '2015-02-15 01:11:15.000000', 'consum', 0.0217, 'lps'),
	(401886, 123, '2015-02-15 01:11:16.000000', 'consum', 0.0215, 'lps'),
	(401887, 123, '2015-02-15 01:11:17.000000', 'consum', 0.0215, 'lps'),
	(401888, 123, '2015-02-15 01:11:18.000000', 'consum', 0.0210, 'lps'),
	(401889, 123, '2015-02-15 01:11:19.000000', 'consum', 0.0219, 'lps'),
	(401890, 123, '2015-02-15 01:11:20.000000', 'consum', 0.0210, 'lps'),
	(401891, 123, '2015-02-15 01:11:21.000000', 'consum', 0.0217, 'lps'),
	(401892, 123, '2015-02-15 01:11:22.000000', 'consum', 0.0211, 'lps'),
	(401893, 123, '2015-02-15 01:11:23.000000', 'consum', 0.0217, 'lps'),
	(401894, 123, '2015-02-15 01:11:24.000000', 'consum', 0.0211, 'lps'),
	(401895, 123, '2015-02-15 01:11:25.000000', 'consum', 0.0217, 'lps'),
	(401896, 123, '2015-02-15 01:11:26.000000', 'consum', 0.0218, 'lps'),
	(401897, 123, '2015-02-15 01:11:27.000000', 'consum', 0.0211, 'lps'),
	(401898, 123, '2015-02-15 01:11:28.000000', 'consum', 0.0210, 'lps'),
	(401899, 123, '2015-02-15 01:11:29.000000', 'consum', 0.0219, 'lps'),
	(401900, 123, '2015-02-15 01:11:30.000000', 'consum', 0.0212, 'lps'),
	(401901, 123, '2015-02-15 01:11:31.000000', 'consum', 0.0217, 'lps'),
	(401902, 123, '2015-02-15 01:11:32.000000', 'consum', 0.0217, 'lps'),
	(401903, 123, '2015-02-15 01:11:33.000000', 'consum', 0.0214, 'lps'),
	(401904, 123, '2015-02-15 01:11:34.000000', 'consum', 0.0220, 'lps'),
	(401905, 123, '2015-02-15 01:11:35.000000', 'consum', 0.0217, 'lps'),
	(401906, 123, '2015-02-15 01:11:36.000000', 'consum', 0.0214, 'lps'),
	(401907, 123, '2015-02-15 01:11:37.000000', 'consum', 0.0211, 'lps'),
	(401908, 123, '2015-02-15 01:11:38.000000', 'consum', 0.0213, 'lps'),
	(401909, 123, '2015-02-15 01:11:39.000000', 'consum', 0.0213, 'lps'),
	(401910, 123, '2015-02-15 01:11:40.000000', 'consum', 0.0215, 'lps'),
	(401911, 123, '2015-02-15 01:11:41.000000', 'consum', 0.0216, 'lps'),
	(401912, 123, '2015-02-15 01:11:42.000000', 'consum', 0.0214, 'lps'),
	(401913, 123, '2015-02-15 01:11:43.000000', 'consum', 0.0212, 'lps'),
	(401914, 123, '2015-02-15 01:11:44.000000', 'consum', 0.0219, 'lps'),
	(401915, 123, '2015-02-15 01:11:45.000000', 'consum', 0.0217, 'lps'),
	(401916, 123, '2015-02-15 01:11:46.000000', 'consum', 0.0219, 'lps'),
	(401917, 123, '2015-02-15 01:11:47.000000', 'consum', 0.0214, 'lps'),
	(401918, 123, '2015-02-15 01:11:48.000000', 'consum', 0.0214, 'lps'),
	(401919, 123, '2015-02-15 01:11:49.000000', 'consum', 0.0216, 'lps'),
	(401920, 123, '2015-02-15 01:11:50.000000', 'consum', 0.0220, 'lps'),
	(401921, 123, '2015-02-15 01:11:51.000000', 'consum', 0.0220, 'lps'),
	(401922, 123, '2015-02-15 01:11:52.000000', 'consum', 0.0210, 'lps'),
	(401923, 123, '2015-02-15 01:11:53.000000', 'consum', 0.0210, 'lps'),
	(401924, 123, '2015-02-15 01:11:54.000000', 'consum', 0.0213, 'lps'),
	(401925, 123, '2015-02-15 01:11:55.000000', 'consum', 0.0215, 'lps'),
	(401926, 123, '2015-02-15 01:11:56.000000', 'consum', 0.0215, 'lps'),
	(401927, 123, '2015-02-15 01:11:57.000000', 'consum', 0.0219, 'lps'),
	(401928, 123, '2015-02-15 01:11:58.000000', 'consum', 0.0219, 'lps'),
	(401929, 123, '2015-02-15 01:11:59.000000', 'consum', 0.0218, 'lps'),
	(401930, 123, '2015-02-15 01:12:00.000000', 'consum', 0.0212, 'lps'),
	(401931, 123, '2015-02-15 01:12:01.000000', 'consum', 0.0217, 'lps'),
	(401932, 123, '2015-02-15 01:12:02.000000', 'consum', 0.0219, 'lps'),
	(401933, 123, '2015-02-15 01:12:03.000000', 'consum', 0.0213, 'lps'),
	(401934, 123, '2015-02-15 01:12:04.000000', 'consum', 0.0211, 'lps'),
	(401935, 123, '2015-02-15 01:12:05.000000', 'consum', 0.0214, 'lps'),
	(401936, 123, '2015-02-15 01:12:06.000000', 'consum', 0.0219, 'lps'),
	(401937, 123, '2015-02-15 01:12:07.000000', 'consum', 0.0220, 'lps'),
	(401938, 123, '2015-02-15 01:12:08.000000', 'consum', 0.0210, 'lps'),
	(401939, 123, '2015-02-15 01:12:09.000000', 'consum', 0.0216, 'lps'),
	(401940, 123, '2015-02-15 01:12:10.000000', 'consum', 0.0217, 'lps'),
	(401941, 123, '2015-02-15 01:12:11.000000', 'consum', 0.0217, 'lps'),
	(401942, 123, '2015-02-15 01:12:12.000000', 'consum', 0.0215, 'lps'),
	(401943, 123, '2015-02-15 01:12:13.000000', 'consum', 0.0214, 'lps'),
	(401944, 123, '2015-02-15 01:12:14.000000', 'consum', 0.0214, 'lps'),
	(401945, 123, '2015-02-15 01:12:15.000000', 'consum', 0.0220, 'lps'),
	(401946, 123, '2015-02-15 01:12:16.000000', 'consum', 0.0214, 'lps'),
	(401947, 123, '2015-02-15 01:12:17.000000', 'consum', 0.0214, 'lps'),
	(401948, 123, '2015-02-15 01:12:18.000000', 'consum', 0.0216, 'lps'),
	(401949, 123, '2015-02-15 01:12:19.000000', 'consum', 0.0219, 'lps'),
	(401950, 123, '2015-02-15 01:12:20.000000', 'consum', 0.0216, 'lps'),
	(401951, 123, '2015-02-15 01:12:21.000000', 'consum', 0.0213, 'lps'),
	(401952, 123, '2015-02-15 01:12:22.000000', 'consum', 0.0219, 'lps'),
	(401953, 123, '2015-02-15 01:12:23.000000', 'consum', 0.0213, 'lps'),
	(401954, 123, '2015-02-15 01:12:24.000000', 'consum', 0.0220, 'lps'),
	(401955, 123, '2015-02-15 01:12:25.000000', 'consum', 0.0220, 'lps'),
	(401956, 123, '2015-02-15 01:12:26.000000', 'consum', 0.0210, 'lps'),
	(401957, 123, '2015-02-15 01:12:27.000000', 'consum', 0.0210, 'lps'),
	(401958, 123, '2015-02-15 01:12:28.000000', 'consum', 0.0213, 'lps'),
	(401959, 123, '2015-02-15 01:12:29.000000', 'consum', 0.0213, 'lps'),
	(401960, 123, '2015-02-15 01:12:30.000000', 'consum', 0.0219, 'lps'),
	(401961, 123, '2015-02-15 01:12:31.000000', 'consum', 0.0211, 'lps'),
	(401962, 123, '2015-02-15 01:12:32.000000', 'consum', 0.0212, 'lps'),
	(401963, 123, '2015-02-15 01:12:33.000000', 'consum', 0.0219, 'lps'),
	(401964, 123, '2015-02-15 01:12:34.000000', 'consum', 0.0213, 'lps'),
	(401965, 123, '2015-02-15 01:12:35.000000', 'consum', 0.0213, 'lps'),
	(401966, 123, '2015-02-15 01:12:36.000000', 'consum', 0.0215, 'lps'),
	(401967, 123, '2015-02-15 01:12:37.000000', 'consum', 0.0217, 'lps'),
	(401968, 123, '2015-02-15 01:12:38.000000', 'consum', 0.0218, 'lps'),
	(401969, 123, '2015-02-15 01:12:39.000000', 'consum', 0.0217, 'lps'),
	(401970, 123, '2015-02-15 01:12:40.000000', 'consum', 0.0212, 'lps'),
	(401971, 123, '2015-02-15 01:12:41.000000', 'consum', 0.0210, 'lps'),
	(401972, 123, '2015-02-15 01:12:42.000000', 'consum', 0.0215, 'lps'),
	(401973, 123, '2015-02-15 01:12:43.000000', 'consum', 0.0212, 'lps'),
	(401974, 123, '2015-02-15 01:12:44.000000', 'consum', 0.0219, 'lps'),
	(401975, 123, '2015-02-15 01:12:45.000000', 'consum', 0.0217, 'lps'),
	(401976, 123, '2015-02-15 01:12:46.000000', 'consum', 0.0217, 'lps'),
	(401977, 123, '2015-02-15 01:12:47.000000', 'consum', 0.0213, 'lps'),
	(401978, 123, '2015-02-15 01:12:48.000000', 'consum', 0.0217, 'lps'),
	(401979, 123, '2015-02-15 01:12:49.000000', 'consum', 0.0213, 'lps'),
	(401980, 123, '2015-02-15 01:12:50.000000', 'consum', 0.0218, 'lps'),
	(401981, 123, '2015-02-15 01:12:51.000000', 'consum', 0.0216, 'lps'),
	(401982, 123, '2015-02-15 01:12:52.000000', 'consum', 0.0220, 'lps'),
	(401983, 123, '2015-02-15 01:12:53.000000', 'consum', 0.0218, 'lps'),
	(401984, 123, '2015-02-15 01:12:54.000000', 'consum', 0.0210, 'lps'),
	(401985, 123, '2015-02-15 01:12:55.000000', 'consum', 0.0219, 'lps'),
	(401986, 123, '2015-02-15 01:12:56.000000', 'consum', 0.0212, 'lps'),
	(401987, 123, '2015-02-15 01:12:57.000000', 'consum', 0.0216, 'lps'),
	(401988, 123, '2015-02-15 01:12:58.000000', 'consum', 0.0212, 'lps'),
	(401989, 123, '2015-02-15 01:12:59.000000', 'consum', 0.0216, 'lps'),
	(401990, 123, '2015-02-15 01:13:00.000000', 'consum', 0.0220, 'lps'),
	(401991, 123, '2015-02-15 01:13:01.000000', 'consum', 0.0213, 'lps'),
	(401992, 123, '2015-02-15 01:13:02.000000', 'consum', 0.0214, 'lps'),
	(401993, 123, '2015-02-15 01:13:03.000000', 'consum', 0.0214, 'lps'),
	(401994, 123, '2015-02-15 01:13:04.000000', 'consum', 0.0216, 'lps'),
	(401995, 123, '2015-02-15 01:13:05.000000', 'consum', 0.0219, 'lps'),
	(401996, 123, '2015-02-15 01:13:06.000000', 'consum', 0.0216, 'lps'),
	(401997, 123, '2015-02-15 01:13:07.000000', 'consum', 0.0214, 'lps'),
	(401998, 123, '2015-02-15 01:13:08.000000', 'consum', 0.0210, 'lps'),
	(401999, 123, '2015-02-15 01:13:09.000000', 'consum', 0.0210, 'lps'),
	(402000, 123, '2015-02-15 01:13:10.000000', 'consum', 0.0211, 'lps'),
	(402001, 123, '2015-02-15 01:13:11.000000', 'consum', 0.0214, 'lps'),
	(402002, 123, '2015-02-15 01:13:12.000000', 'consum', 0.0217, 'lps'),
	(402003, 123, '2015-02-15 01:13:13.000000', 'consum', 0.0210, 'lps'),
	(402004, 123, '2015-02-15 01:13:14.000000', 'consum', 0.0213, 'lps'),
	(402005, 123, '2015-02-15 01:13:15.000000', 'consum', 0.0213, 'lps'),
	(402006, 123, '2015-02-15 01:13:16.000000', 'consum', 0.0217, 'lps'),
	(402007, 123, '2015-02-15 01:13:17.000000', 'consum', 0.0213, 'lps'),
	(402008, 123, '2015-02-15 01:13:18.000000', 'consum', 0.0216, 'lps'),
	(402009, 123, '2015-02-15 01:13:19.000000', 'consum', 0.0212, 'lps'),
	(402010, 123, '2015-02-15 01:13:20.000000', 'consum', 0.0212, 'lps'),
	(402011, 123, '2015-02-15 01:13:21.000000', 'consum', 0.0213, 'lps'),
	(402012, 123, '2015-02-15 01:13:22.000000', 'consum', 0.0211, 'lps'),
	(402013, 123, '2015-02-15 01:13:23.000000', 'consum', 0.0217, 'lps'),
	(402014, 123, '2015-02-15 01:13:24.000000', 'consum', 0.0220, 'lps'),
	(402015, 123, '2015-02-15 01:13:25.000000', 'consum', 0.0219, 'lps'),
	(402016, 123, '2015-02-15 01:13:26.000000', 'consum', 0.0212, 'lps'),
	(402017, 123, '2015-02-15 01:13:27.000000', 'consum', 0.0216, 'lps'),
	(402018, 123, '2015-02-15 01:13:28.000000', 'consum', 0.0213, 'lps'),
	(402019, 123, '2015-02-15 01:13:29.000000', 'consum', 0.0220, 'lps'),
	(402020, 123, '2015-02-15 01:13:30.000000', 'consum', 0.0219, 'lps'),
	(402021, 123, '2015-02-15 01:13:31.000000', 'consum', 0.0214, 'lps'),
	(402022, 123, '2015-02-15 01:13:32.000000', 'consum', 0.0215, 'lps'),
	(402023, 123, '2015-02-15 01:13:33.000000', 'consum', 0.0211, 'lps'),
	(402024, 123, '2015-02-15 01:13:34.000000', 'consum', 0.0212, 'lps'),
	(402025, 123, '2015-02-15 01:13:35.000000', 'consum', 0.0217, 'lps'),
	(402026, 123, '2015-02-15 01:13:36.000000', 'consum', 0.0219, 'lps'),
	(402027, 123, '2015-02-15 01:13:37.000000', 'consum', 0.0210, 'lps'),
	(402028, 123, '2015-02-15 01:13:38.000000', 'consum', 0.0217, 'lps'),
	(402029, 123, '2015-02-15 01:13:39.000000', 'consum', 0.0215, 'lps'),
	(402030, 123, '2015-02-15 01:13:40.000000', 'consum', 0.0211, 'lps'),
	(402031, 123, '2015-02-15 01:13:41.000000', 'consum', 0.0213, 'lps'),
	(402032, 123, '2015-02-15 01:13:42.000000', 'consum', 0.0212, 'lps'),
	(402033, 123, '2015-02-15 01:13:43.000000', 'consum', 0.0220, 'lps'),
	(402034, 123, '2015-02-15 01:13:44.000000', 'consum', 0.0213, 'lps'),
	(402035, 123, '2015-02-15 01:13:45.000000', 'consum', 0.0219, 'lps'),
	(402036, 123, '2015-02-15 01:13:46.000000', 'consum', 0.0211, 'lps'),
	(402037, 123, '2015-02-15 01:13:47.000000', 'consum', 0.0211, 'lps'),
	(402038, 123, '2015-02-15 01:13:48.000000', 'consum', 0.0211, 'lps'),
	(402039, 123, '2015-02-15 01:13:49.000000', 'consum', 0.0213, 'lps'),
	(402040, 123, '2015-02-15 01:13:50.000000', 'consum', 0.0211, 'lps'),
	(402041, 123, '2015-02-15 01:13:51.000000', 'consum', 0.0218, 'lps'),
	(402042, 123, '2015-02-15 01:13:52.000000', 'consum', 0.0215, 'lps'),
	(402043, 123, '2015-02-15 01:13:53.000000', 'consum', 0.0211, 'lps'),
	(402044, 123, '2015-02-15 01:13:54.000000', 'consum', 0.0213, 'lps'),
	(402045, 123, '2015-02-15 01:13:55.000000', 'consum', 0.0210, 'lps'),
	(402046, 123, '2015-02-15 01:13:56.000000', 'consum', 0.0214, 'lps'),
	(402047, 123, '2015-02-15 01:13:57.000000', 'consum', 0.0217, 'lps'),
	(402048, 123, '2015-02-15 01:13:58.000000', 'consum', 0.0212, 'lps'),
	(402049, 123, '2015-02-15 01:13:59.000000', 'consum', 0.0211, 'lps'),
	(402050, 123, '2015-02-15 01:14:00.000000', 'consum', 0.0211, 'lps'),
	(402051, 123, '2015-02-15 01:14:01.000000', 'consum', 0.0210, 'lps'),
	(402052, 123, '2015-02-15 01:14:02.000000', 'consum', 0.0218, 'lps'),
	(402053, 123, '2015-02-15 01:14:03.000000', 'consum', 0.0218, 'lps'),
	(402054, 123, '2015-02-15 01:14:04.000000', 'consum', 0.0217, 'lps'),
	(402055, 123, '2015-02-15 01:14:05.000000', 'consum', 0.0210, 'lps'),
	(402056, 123, '2015-02-15 01:14:06.000000', 'consum', 0.0213, 'lps'),
	(402057, 123, '2015-02-15 01:14:07.000000', 'consum', 0.0212, 'lps'),
	(402058, 123, '2015-02-15 01:14:08.000000', 'consum', 0.0210, 'lps'),
	(402059, 123, '2015-02-15 01:14:09.000000', 'consum', 0.0219, 'lps'),
	(402060, 123, '2015-02-15 01:14:10.000000', 'consum', 0.0210, 'lps'),
	(402061, 123, '2015-02-15 01:14:11.000000', 'consum', 0.0215, 'lps'),
	(402062, 123, '2015-02-15 01:14:12.000000', 'consum', 0.0214, 'lps'),
	(402063, 123, '2015-02-15 01:14:13.000000', 'consum', 0.0215, 'lps'),
	(402064, 123, '2015-02-15 01:14:14.000000', 'consum', 0.0213, 'lps'),
	(402065, 123, '2015-02-15 01:14:15.000000', 'consum', 0.0220, 'lps'),
	(402066, 123, '2015-02-15 01:14:16.000000', 'consum', 0.0219, 'lps'),
	(402067, 123, '2015-02-15 01:14:17.000000', 'consum', 0.0213, 'lps'),
	(402068, 123, '2015-02-15 01:14:18.000000', 'consum', 0.0213, 'lps'),
	(402069, 123, '2015-02-15 01:14:19.000000', 'consum', 0.0214, 'lps'),
	(402070, 123, '2015-02-15 01:14:20.000000', 'consum', 0.0212, 'lps'),
	(402071, 123, '2015-02-15 01:14:21.000000', 'consum', 0.0220, 'lps'),
	(402072, 123, '2015-02-15 01:14:22.000000', 'consum', 0.0211, 'lps'),
	(402073, 123, '2015-02-15 01:14:23.000000', 'consum', 0.0216, 'lps'),
	(402074, 123, '2015-02-15 01:14:24.000000', 'consum', 0.0215, 'lps'),
	(402075, 123, '2015-02-15 01:14:25.000000', 'consum', 0.0217, 'lps'),
	(402076, 123, '2015-02-15 01:14:26.000000', 'consum', 0.0219, 'lps'),
	(402077, 123, '2015-02-15 01:14:27.000000', 'consum', 0.0214, 'lps'),
	(402078, 123, '2015-02-15 01:14:28.000000', 'consum', 0.0216, 'lps'),
	(402079, 123, '2015-02-15 01:14:29.000000', 'consum', 0.0217, 'lps'),
	(402080, 123, '2015-02-15 01:14:30.000000', 'consum', 0.0215, 'lps'),
	(402081, 123, '2015-02-15 01:14:31.000000', 'consum', 0.0216, 'lps'),
	(402082, 123, '2015-02-15 01:14:32.000000', 'consum', 0.0213, 'lps'),
	(402083, 123, '2015-02-15 01:14:33.000000', 'consum', 0.0219, 'lps'),
	(402084, 123, '2015-02-15 01:14:34.000000', 'consum', 0.0211, 'lps'),
	(402085, 123, '2015-02-15 01:14:35.000000', 'consum', 0.0214, 'lps'),
	(402086, 123, '2015-02-15 01:14:36.000000', 'consum', 0.0217, 'lps'),
	(402087, 123, '2015-02-15 01:14:37.000000', 'consum', 0.0220, 'lps'),
	(402088, 123, '2015-02-15 01:14:38.000000', 'consum', 0.0219, 'lps'),
	(402089, 123, '2015-02-15 01:14:39.000000', 'consum', 0.0215, 'lps'),
	(402090, 123, '2015-02-15 01:14:40.000000', 'consum', 0.0220, 'lps'),
	(402091, 123, '2015-02-15 01:14:41.000000', 'consum', 0.0212, 'lps'),
	(402092, 123, '2015-02-15 01:14:42.000000', 'consum', 0.0213, 'lps'),
	(402093, 123, '2015-02-15 01:14:43.000000', 'consum', 0.0210, 'lps'),
	(402094, 123, '2015-02-15 01:14:44.000000', 'consum', 0.0220, 'lps'),
	(402095, 123, '2015-02-15 01:14:45.000000', 'consum', 0.0220, 'lps'),
	(402096, 123, '2015-02-15 01:14:46.000000', 'consum', 0.0216, 'lps'),
	(402097, 123, '2015-02-15 01:14:47.000000', 'consum', 0.0212, 'lps'),
	(402098, 123, '2015-02-15 01:14:48.000000', 'consum', 0.0214, 'lps'),
	(402099, 123, '2015-02-15 01:14:49.000000', 'consum', 0.0213, 'lps'),
	(402100, 123, '2015-02-15 01:14:50.000000', 'consum', 0.0212, 'lps'),
	(402101, 123, '2015-02-15 01:14:51.000000', 'consum', 0.0213, 'lps'),
	(402102, 123, '2015-02-15 01:14:52.000000', 'consum', 0.0218, 'lps'),
	(402103, 123, '2015-02-15 01:14:53.000000', 'consum', 0.0220, 'lps'),
	(402104, 123, '2015-02-15 01:14:54.000000', 'consum', 0.0214, 'lps'),
	(402105, 123, '2015-02-15 01:14:55.000000', 'consum', 0.0214, 'lps'),
	(402106, 123, '2015-02-15 01:14:56.000000', 'consum', 0.0215, 'lps'),
	(402107, 123, '2015-02-15 01:14:57.000000', 'consum', 0.0215, 'lps'),
	(402108, 123, '2015-02-15 01:14:58.000000', 'consum', 0.0219, 'lps'),
	(402109, 123, '2015-02-15 01:14:59.000000', 'consum', 0.0219, 'lps'),
	(402110, 123, '2015-02-15 01:15:00.000000', 'consum', 0.0217, 'lps'),
	(402111, 123, '2015-02-15 01:15:01.000000', 'consum', 0.0210, 'lps'),
	(402112, 123, '2015-02-15 01:15:02.000000', 'consum', 0.0219, 'lps'),
	(402113, 123, '2015-02-15 01:15:03.000000', 'consum', 0.0214, 'lps'),
	(402114, 123, '2015-02-15 01:15:04.000000', 'consum', 0.0214, 'lps'),
	(402115, 123, '2015-02-15 01:15:05.000000', 'consum', 0.0217, 'lps'),
	(402116, 123, '2015-02-15 01:15:06.000000', 'consum', 0.0212, 'lps'),
	(402117, 123, '2015-02-15 01:15:07.000000', 'consum', 0.0220, 'lps'),
	(402118, 123, '2015-02-15 01:15:08.000000', 'consum', 0.0213, 'lps'),
	(402119, 123, '2015-02-15 01:15:09.000000', 'consum', 0.0217, 'lps'),
	(402120, 123, '2015-02-15 01:15:10.000000', 'consum', 0.0212, 'lps'),
	(402121, 123, '2015-02-15 01:15:11.000000', 'consum', 0.0213, 'lps'),
	(402122, 123, '2015-02-15 01:15:12.000000', 'consum', 0.0220, 'lps'),
	(402123, 123, '2015-02-15 01:15:13.000000', 'consum', 0.0217, 'lps'),
	(402124, 123, '2015-02-15 01:15:14.000000', 'consum', 0.0214, 'lps'),
	(402125, 123, '2015-02-15 01:15:15.000000', 'consum', 0.0211, 'lps'),
	(402126, 123, '2015-02-15 01:15:16.000000', 'consum', 0.0215, 'lps'),
	(402127, 123, '2015-02-15 01:15:17.000000', 'consum', 0.0212, 'lps'),
	(402128, 123, '2015-02-15 01:15:18.000000', 'consum', 0.0215, 'lps'),
	(402129, 123, '2015-02-15 01:15:19.000000', 'consum', 0.0219, 'lps'),
	(402130, 123, '2015-02-15 01:15:20.000000', 'consum', 0.0220, 'lps'),
	(402131, 123, '2015-02-15 01:15:21.000000', 'consum', 0.0211, 'lps'),
	(402132, 123, '2015-02-15 01:15:22.000000', 'consum', 0.0219, 'lps'),
	(402133, 123, '2015-02-15 01:15:23.000000', 'consum', 0.0217, 'lps'),
	(402134, 123, '2015-02-15 01:15:24.000000', 'consum', 0.0218, 'lps'),
	(402135, 123, '2015-02-15 01:15:25.000000', 'consum', 0.0210, 'lps'),
	(402136, 123, '2015-02-15 01:15:26.000000', 'consum', 0.0219, 'lps'),
	(402137, 123, '2015-02-15 01:15:27.000000', 'consum', 0.0211, 'lps'),
	(402138, 123, '2015-02-15 01:15:28.000000', 'consum', 0.0212, 'lps'),
	(402139, 123, '2015-02-15 01:15:29.000000', 'consum', 0.0218, 'lps'),
	(402140, 123, '2015-02-15 01:15:30.000000', 'consum', 0.0220, 'lps'),
	(402141, 123, '2015-02-15 01:15:31.000000', 'consum', 0.0217, 'lps'),
	(402142, 123, '2015-02-15 01:15:32.000000', 'consum', 0.0216, 'lps'),
	(402143, 123, '2015-02-15 01:15:33.000000', 'consum', 0.0219, 'lps'),
	(402144, 123, '2015-02-15 01:15:34.000000', 'consum', 0.0216, 'lps'),
	(402145, 123, '2015-02-15 01:15:35.000000', 'consum', 0.0212, 'lps'),
	(402146, 123, '2015-02-15 01:15:36.000000', 'consum', 0.0215, 'lps'),
	(402147, 123, '2015-02-15 01:15:37.000000', 'consum', 0.0217, 'lps'),
	(402148, 123, '2015-02-15 01:15:38.000000', 'consum', 0.0210, 'lps'),
	(402149, 123, '2015-02-15 01:15:39.000000', 'consum', 0.0210, 'lps'),
	(402150, 123, '2015-02-15 01:15:40.000000', 'consum', 0.0213, 'lps'),
	(402151, 123, '2015-02-15 01:15:41.000000', 'consum', 0.0213, 'lps'),
	(402152, 123, '2015-02-15 01:15:42.000000', 'consum', 0.0217, 'lps'),
	(402153, 123, '2015-02-15 01:15:43.000000', 'consum', 0.0213, 'lps'),
	(402154, 123, '2015-02-15 01:15:44.000000', 'consum', 0.0218, 'lps'),
	(402155, 123, '2015-02-15 01:15:45.000000', 'consum', 0.0219, 'lps'),
	(402156, 123, '2015-02-15 01:15:46.000000', 'consum', 0.0210, 'lps'),
	(402157, 123, '2015-02-15 01:15:47.000000', 'consum', 0.0214, 'lps'),
	(402158, 123, '2015-02-15 01:15:48.000000', 'consum', 0.0212, 'lps'),
	(402159, 123, '2015-02-15 01:15:49.000000', 'consum', 0.0217, 'lps'),
	(402160, 123, '2015-02-15 01:15:50.000000', 'consum', 0.0220, 'lps'),
	(402161, 123, '2015-02-15 01:15:51.000000', 'consum', 0.0216, 'lps'),
	(402162, 123, '2015-02-15 01:15:52.000000', 'consum', 0.0210, 'lps'),
	(402163, 123, '2015-02-15 01:15:53.000000', 'consum', 0.0214, 'lps'),
	(402164, 123, '2015-02-15 01:15:54.000000', 'consum', 0.0219, 'lps'),
	(402165, 123, '2015-02-15 01:15:55.000000', 'consum', 0.0213, 'lps'),
	(402166, 123, '2015-02-15 01:15:56.000000', 'consum', 0.0210, 'lps'),
	(402167, 123, '2015-02-15 01:15:57.000000', 'consum', 0.0211, 'lps'),
	(402168, 123, '2015-02-15 01:15:58.000000', 'consum', 0.0217, 'lps'),
	(402169, 123, '2015-02-15 01:15:59.000000', 'consum', 0.0219, 'lps'),
	(402170, 123, '2015-02-15 01:16:00.000000', 'consum', 0.0212, 'lps'),
	(402171, 123, '2015-02-15 01:16:01.000000', 'consum', 0.0218, 'lps'),
	(402172, 123, '2015-02-15 01:16:02.000000', 'consum', 0.0210, 'lps'),
	(402173, 123, '2015-02-15 01:16:03.000000', 'consum', 0.0220, 'lps'),
	(402174, 123, '2015-02-15 01:16:04.000000', 'consum', 0.0218, 'lps'),
	(402175, 123, '2015-02-15 01:16:05.000000', 'consum', 0.0220, 'lps'),
	(402176, 123, '2015-02-15 01:16:06.000000', 'consum', 0.0213, 'lps'),
	(402177, 123, '2015-02-15 01:16:07.000000', 'consum', 0.0218, 'lps'),
	(402178, 123, '2015-02-15 01:16:08.000000', 'consum', 0.0211, 'lps'),
	(402179, 123, '2015-02-15 01:16:09.000000', 'consum', 0.0210, 'lps'),
	(402180, 123, '2015-02-15 01:16:10.000000', 'consum', 0.0219, 'lps'),
	(402181, 123, '2015-02-15 01:16:11.000000', 'consum', 0.0212, 'lps'),
	(402182, 123, '2015-02-15 01:16:12.000000', 'consum', 0.0214, 'lps'),
	(402183, 123, '2015-02-15 01:16:13.000000', 'consum', 0.0215, 'lps'),
	(402184, 123, '2015-02-15 01:16:14.000000', 'consum', 0.0212, 'lps'),
	(402185, 123, '2015-02-15 01:16:15.000000', 'consum', 0.0216, 'lps'),
	(402186, 123, '2015-02-15 01:16:16.000000', 'consum', 0.0213, 'lps'),
	(402187, 123, '2015-02-15 01:16:17.000000', 'consum', 0.0217, 'lps'),
	(402188, 123, '2015-02-15 01:16:18.000000', 'consum', 0.0215, 'lps'),
	(402189, 123, '2015-02-15 01:16:19.000000', 'consum', 0.0217, 'lps'),
	(402190, 123, '2015-02-15 01:16:20.000000', 'consum', 0.0218, 'lps'),
	(402191, 123, '2015-02-15 01:16:21.000000', 'consum', 0.0218, 'lps'),
	(402192, 123, '2015-02-15 01:16:22.000000', 'consum', 0.0216, 'lps'),
	(402193, 123, '2015-02-15 01:16:23.000000', 'consum', 0.0216, 'lps'),
	(402194, 123, '2015-02-15 01:16:24.000000', 'consum', 0.0211, 'lps'),
	(402195, 123, '2015-02-15 01:16:25.000000', 'consum', 0.0218, 'lps'),
	(402196, 123, '2015-02-15 01:16:26.000000', 'consum', 0.0218, 'lps'),
	(402197, 123, '2015-02-15 01:16:27.000000', 'consum', 0.0212, 'lps'),
	(402198, 123, '2015-02-15 01:16:28.000000', 'consum', 0.0211, 'lps'),
	(402199, 123, '2015-02-15 01:16:29.000000', 'consum', 0.0218, 'lps'),
	(402200, 123, '2015-02-15 01:16:30.000000', 'consum', 0.0215, 'lps'),
	(402201, 123, '2015-02-15 01:16:31.000000', 'consum', 0.0210, 'lps'),
	(402202, 123, '2015-02-15 01:16:32.000000', 'consum', 0.0220, 'lps'),
	(402203, 123, '2015-02-15 01:16:33.000000', 'consum', 0.0217, 'lps'),
	(402204, 123, '2015-02-15 01:16:34.000000', 'consum', 0.0214, 'lps'),
	(402205, 123, '2015-02-15 01:16:35.000000', 'consum', 0.0211, 'lps'),
	(402206, 123, '2015-02-15 01:16:36.000000', 'consum', 0.0215, 'lps'),
	(402207, 123, '2015-02-15 01:16:37.000000', 'consum', 0.0211, 'lps'),
	(402208, 123, '2015-02-15 01:16:38.000000', 'consum', 0.0211, 'lps'),
	(402209, 123, '2015-02-15 01:16:39.000000', 'consum', 0.0213, 'lps'),
	(402210, 123, '2015-02-15 01:16:40.000000', 'consum', 0.0210, 'lps'),
	(402211, 123, '2015-02-15 01:16:41.000000', 'consum', 0.0215, 'lps'),
	(402212, 123, '2015-02-15 01:16:42.000000', 'consum', 0.0211, 'lps'),
	(402213, 123, '2015-02-15 01:16:43.000000', 'consum', 0.0214, 'lps'),
	(402214, 123, '2015-02-15 01:16:44.000000', 'consum', 0.0214, 'lps'),
	(402215, 123, '2015-02-15 01:16:45.000000', 'consum', 0.0219, 'lps'),
	(402216, 123, '2015-02-15 01:16:46.000000', 'consum', 0.0211, 'lps'),
	(402217, 123, '2015-02-15 01:16:47.000000', 'consum', 0.0219, 'lps'),
	(402218, 123, '2015-02-15 01:16:48.000000', 'consum', 0.0212, 'lps'),
	(402219, 123, '2015-02-15 01:16:49.000000', 'consum', 0.0215, 'lps'),
	(402220, 123, '2015-02-15 01:16:50.000000', 'consum', 0.0217, 'lps'),
	(402221, 123, '2015-02-15 01:16:51.000000', 'consum', 0.0219, 'lps'),
	(402222, 123, '2015-02-15 01:16:52.000000', 'consum', 0.0215, 'lps'),
	(402223, 123, '2015-02-15 01:16:53.000000', 'consum', 0.0220, 'lps'),
	(402224, 123, '2015-02-15 01:16:54.000000', 'consum', 0.0210, 'lps'),
	(402225, 123, '2015-02-15 01:16:55.000000', 'consum', 0.0216, 'lps'),
	(402226, 123, '2015-02-15 01:16:56.000000', 'consum', 0.0216, 'lps'),
	(402227, 123, '2015-02-15 01:16:57.000000', 'consum', 0.0211, 'lps'),
	(402228, 123, '2015-02-15 01:16:58.000000', 'consum', 0.0220, 'lps'),
	(402229, 123, '2015-02-15 01:16:59.000000', 'consum', 0.0215, 'lps'),
	(402230, 123, '2015-02-15 01:17:00.000000', 'consum', 0.0216, 'lps'),
	(402231, 123, '2015-02-15 01:17:01.000000', 'consum', 0.0213, 'lps'),
	(402232, 123, '2015-02-15 01:17:02.000000', 'consum', 0.0220, 'lps'),
	(402233, 123, '2015-02-15 01:17:03.000000', 'consum', 0.0219, 'lps'),
	(402234, 123, '2015-02-15 01:17:04.000000', 'consum', 0.0212, 'lps'),
	(402235, 123, '2015-02-15 01:17:05.000000', 'consum', 0.0218, 'lps'),
	(402236, 123, '2015-02-15 01:17:06.000000', 'consum', 0.0213, 'lps'),
	(402237, 123, '2015-02-15 01:17:07.000000', 'consum', 0.0210, 'lps'),
	(402238, 123, '2015-02-15 01:17:08.000000', 'consum', 0.0212, 'lps'),
	(402239, 123, '2015-02-15 01:17:09.000000', 'consum', 0.0212, 'lps'),
	(402240, 123, '2015-02-15 01:17:10.000000', 'consum', 0.0215, 'lps'),
	(402241, 123, '2015-02-15 01:17:11.000000', 'consum', 0.0215, 'lps'),
	(402242, 123, '2015-02-15 01:17:12.000000', 'consum', 0.0212, 'lps'),
	(402243, 123, '2015-02-15 01:17:13.000000', 'consum', 0.0217, 'lps'),
	(402244, 123, '2015-02-15 01:17:14.000000', 'consum', 0.0215, 'lps'),
	(402245, 123, '2015-02-15 01:17:15.000000', 'consum', 0.0216, 'lps'),
	(402246, 123, '2015-02-15 01:17:16.000000', 'consum', 0.0215, 'lps'),
	(402247, 123, '2015-02-15 01:17:17.000000', 'consum', 0.0216, 'lps'),
	(402248, 123, '2015-02-15 01:17:18.000000', 'consum', 0.0216, 'lps'),
	(402249, 123, '2015-02-15 01:17:19.000000', 'consum', 0.0211, 'lps'),
	(402250, 123, '2015-02-15 01:17:20.000000', 'consum', 0.0218, 'lps'),
	(402251, 123, '2015-02-15 01:17:21.000000', 'consum', 0.0215, 'lps'),
	(402252, 123, '2015-02-15 01:17:22.000000', 'consum', 0.0210, 'lps'),
	(402253, 123, '2015-02-15 01:17:23.000000', 'consum', 0.0210, 'lps'),
	(402254, 123, '2015-02-15 01:17:24.000000', 'consum', 0.0219, 'lps'),
	(402255, 123, '2015-02-15 01:17:25.000000', 'consum', 0.0211, 'lps'),
	(402256, 123, '2015-02-15 01:17:26.000000', 'consum', 0.0210, 'lps'),
	(402257, 123, '2015-02-15 01:17:27.000000', 'consum', 0.0218, 'lps'),
	(402258, 123, '2015-02-15 01:17:28.000000', 'consum', 0.0218, 'lps'),
	(402259, 123, '2015-02-15 01:17:29.000000', 'consum', 0.0218, 'lps'),
	(402260, 123, '2015-02-15 01:17:30.000000', 'consum', 0.0213, 'lps'),
	(402261, 123, '2015-02-15 01:17:31.000000', 'consum', 0.0212, 'lps'),
	(402262, 123, '2015-02-15 01:17:32.000000', 'consum', 0.0213, 'lps'),
	(402263, 123, '2015-02-15 01:17:33.000000', 'consum', 0.0217, 'lps'),
	(402264, 123, '2015-02-15 01:17:34.000000', 'consum', 0.0217, 'lps'),
	(402265, 123, '2015-02-15 01:17:35.000000', 'consum', 0.0211, 'lps'),
	(402266, 123, '2015-02-15 01:17:36.000000', 'consum', 0.0217, 'lps'),
	(402267, 123, '2015-02-15 01:17:37.000000', 'consum', 0.0210, 'lps'),
	(402268, 123, '2015-02-15 01:17:38.000000', 'consum', 0.0213, 'lps'),
	(402269, 123, '2015-02-15 01:17:39.000000', 'consum', 0.0215, 'lps'),
	(402270, 123, '2015-02-15 01:17:40.000000', 'consum', 0.0215, 'lps'),
	(402271, 123, '2015-02-15 01:17:41.000000', 'consum', 0.0220, 'lps'),
	(402272, 123, '2015-02-15 01:17:42.000000', 'consum', 0.0214, 'lps'),
	(402273, 123, '2015-02-15 01:17:43.000000', 'consum', 0.0212, 'lps'),
	(402274, 123, '2015-02-15 01:17:44.000000', 'consum', 0.0219, 'lps'),
	(402275, 123, '2015-02-15 01:17:45.000000', 'consum', 0.0216, 'lps'),
	(402276, 123, '2015-02-15 01:17:46.000000', 'consum', 0.0212, 'lps'),
	(402277, 123, '2015-02-15 01:17:47.000000', 'consum', 0.0215, 'lps'),
	(402278, 123, '2015-02-15 01:17:48.000000', 'consum', 0.0218, 'lps'),
	(402279, 123, '2015-02-15 01:17:49.000000', 'consum', 0.0214, 'lps'),
	(402280, 123, '2015-02-15 01:17:50.000000', 'consum', 0.0216, 'lps'),
	(402281, 123, '2015-02-15 01:17:51.000000', 'consum', 0.0216, 'lps'),
	(402282, 123, '2015-02-15 01:17:52.000000', 'consum', 0.0215, 'lps'),
	(402283, 123, '2015-02-15 01:17:53.000000', 'consum', 0.0215, 'lps'),
	(402284, 123, '2015-02-15 01:17:54.000000', 'consum', 0.0211, 'lps'),
	(402285, 123, '2015-02-15 01:17:55.000000', 'consum', 0.0210, 'lps'),
	(402286, 123, '2015-02-15 01:17:56.000000', 'consum', 0.0220, 'lps'),
	(402287, 123, '2015-02-15 01:17:57.000000', 'consum', 0.0218, 'lps'),
	(402288, 123, '2015-02-15 01:17:58.000000', 'consum', 0.0217, 'lps'),
	(402289, 123, '2015-02-15 01:17:59.000000', 'consum', 0.0212, 'lps'),
	(402290, 123, '2015-02-15 01:18:00.000000', 'consum', 0.0212, 'lps'),
	(402291, 123, '2015-02-15 01:18:01.000000', 'consum', 0.0211, 'lps'),
	(402292, 123, '2015-02-15 01:18:02.000000', 'consum', 0.0213, 'lps'),
	(402293, 123, '2015-02-15 01:18:03.000000', 'consum', 0.0210, 'lps'),
	(402294, 123, '2015-02-15 01:18:04.000000', 'consum', 0.0212, 'lps'),
	(402295, 123, '2015-02-15 01:18:05.000000', 'consum', 0.0210, 'lps'),
	(402296, 123, '2015-02-15 01:18:06.000000', 'consum', 0.0216, 'lps'),
	(402297, 123, '2015-02-15 01:18:07.000000', 'consum', 0.0219, 'lps'),
	(402298, 123, '2015-02-15 01:18:08.000000', 'consum', 0.0215, 'lps'),
	(402299, 123, '2015-02-15 01:18:09.000000', 'consum', 0.0210, 'lps'),
	(402300, 123, '2015-02-15 01:18:10.000000', 'consum', 0.0216, 'lps'),
	(402301, 123, '2015-02-15 01:18:11.000000', 'consum', 0.0218, 'lps'),
	(402302, 123, '2015-02-15 01:18:12.000000', 'consum', 0.0212, 'lps'),
	(402303, 123, '2015-02-15 01:18:13.000000', 'consum', 0.0219, 'lps'),
	(402304, 123, '2015-02-15 01:18:14.000000', 'consum', 0.0216, 'lps'),
	(402305, 123, '2015-02-15 01:18:15.000000', 'consum', 0.0214, 'lps'),
	(402306, 123, '2015-02-15 01:18:16.000000', 'consum', 0.0210, 'lps'),
	(402307, 123, '2015-02-15 01:18:17.000000', 'consum', 0.0213, 'lps'),
	(402308, 123, '2015-02-15 01:18:18.000000', 'consum', 0.0211, 'lps'),
	(402309, 123, '2015-02-15 01:18:19.000000', 'consum', 0.0219, 'lps'),
	(402310, 123, '2015-02-15 01:18:20.000000', 'consum', 0.0219, 'lps'),
	(402311, 123, '2015-02-15 01:18:21.000000', 'consum', 0.0216, 'lps'),
	(402312, 123, '2015-02-15 01:18:22.000000', 'consum', 0.0216, 'lps'),
	(402313, 123, '2015-02-15 01:18:23.000000', 'consum', 0.0211, 'lps'),
	(402314, 123, '2015-02-15 01:18:24.000000', 'consum', 0.0218, 'lps'),
	(402315, 123, '2015-02-15 01:18:25.000000', 'consum', 0.0216, 'lps'),
	(402316, 123, '2015-02-15 01:18:26.000000', 'consum', 0.0215, 'lps'),
	(402317, 123, '2015-02-15 01:18:27.000000', 'consum', 0.0220, 'lps'),
	(402318, 123, '2015-02-15 01:18:28.000000', 'consum', 0.0220, 'lps'),
	(402319, 123, '2015-02-15 01:18:29.000000', 'consum', 0.0212, 'lps'),
	(402320, 123, '2015-02-15 01:18:30.000000', 'consum', 0.0212, 'lps'),
	(402321, 123, '2015-02-15 01:18:31.000000', 'consum', 0.0214, 'lps'),
	(402322, 123, '2015-02-15 01:18:32.000000', 'consum', 0.0213, 'lps'),
	(402323, 123, '2015-02-15 01:18:33.000000', 'consum', 0.0213, 'lps'),
	(402324, 123, '2015-02-15 01:18:34.000000', 'consum', 0.0218, 'lps'),
	(402325, 123, '2015-02-15 01:18:35.000000', 'consum', 0.0217, 'lps'),
	(402326, 123, '2015-02-15 01:18:36.000000', 'consum', 0.0211, 'lps'),
	(402327, 123, '2015-02-15 01:18:37.000000', 'consum', 0.0219, 'lps'),
	(402328, 123, '2015-02-15 01:18:38.000000', 'consum', 0.0218, 'lps'),
	(402329, 123, '2015-02-15 01:18:39.000000', 'consum', 0.0212, 'lps'),
	(402330, 123, '2015-02-15 01:18:40.000000', 'consum', 0.0210, 'lps'),
	(402331, 123, '2015-02-15 01:18:41.000000', 'consum', 0.0214, 'lps'),
	(402332, 123, '2015-02-15 01:18:42.000000', 'consum', 0.0218, 'lps'),
	(402333, 123, '2015-02-15 01:18:43.000000', 'consum', 0.0217, 'lps'),
	(402334, 123, '2015-02-15 01:18:44.000000', 'consum', 0.0212, 'lps'),
	(402335, 123, '2015-02-15 01:18:45.000000', 'consum', 0.0220, 'lps'),
	(402336, 123, '2015-02-15 01:18:46.000000', 'consum', 0.0210, 'lps'),
	(402337, 123, '2015-02-15 01:18:47.000000', 'consum', 0.0213, 'lps'),
	(402338, 123, '2015-02-15 01:18:48.000000', 'consum', 0.0217, 'lps'),
	(402339, 123, '2015-02-15 01:18:49.000000', 'consum', 0.0213, 'lps'),
	(402340, 123, '2015-02-15 01:18:50.000000', 'consum', 0.0215, 'lps'),
	(402341, 123, '2015-02-15 01:18:51.000000', 'consum', 0.0215, 'lps'),
	(402342, 123, '2015-02-15 01:18:52.000000', 'consum', 0.0212, 'lps'),
	(402343, 123, '2015-02-15 01:18:53.000000', 'consum', 0.0216, 'lps'),
	(402344, 123, '2015-02-15 01:18:54.000000', 'consum', 0.0213, 'lps'),
	(402345, 123, '2015-02-15 01:18:55.000000', 'consum', 0.0218, 'lps'),
	(402346, 123, '2015-02-15 01:18:56.000000', 'consum', 0.0219, 'lps'),
	(402347, 123, '2015-02-15 01:18:57.000000', 'consum', 0.0210, 'lps'),
	(402348, 123, '2015-02-15 01:18:58.000000', 'consum', 0.0217, 'lps'),
	(402349, 123, '2015-02-15 01:18:59.000000', 'consum', 0.0210, 'lps'),
	(402350, 123, '2015-02-15 01:19:00.000000', 'consum', 0.0215, 'lps'),
	(402351, 123, '2015-02-15 01:19:01.000000', 'consum', 0.0211, 'lps'),
	(402352, 123, '2015-02-15 01:19:02.000000', 'consum', 0.0213, 'lps'),
	(402353, 123, '2015-02-15 01:19:03.000000', 'consum', 0.0210, 'lps'),
	(402354, 123, '2015-02-15 01:19:04.000000', 'consum', 0.0213, 'lps'),
	(402355, 123, '2015-02-15 01:19:05.000000', 'consum', 0.0213, 'lps'),
	(402356, 123, '2015-02-15 01:19:06.000000', 'consum', 0.0218, 'lps'),
	(402357, 123, '2015-02-15 01:19:07.000000', 'consum', 0.0220, 'lps'),
	(402358, 123, '2015-02-15 01:19:08.000000', 'consum', 0.0214, 'lps'),
	(402359, 123, '2015-02-15 01:19:09.000000', 'consum', 0.0211, 'lps'),
	(402360, 123, '2015-02-15 01:19:10.000000', 'consum', 0.0214, 'lps'),
	(402361, 123, '2015-02-15 01:19:11.000000', 'consum', 0.0219, 'lps'),
	(402362, 123, '2015-02-15 01:19:12.000000', 'consum', 0.0210, 'lps'),
	(402363, 123, '2015-02-15 01:19:13.000000', 'consum', 0.0215, 'lps'),
	(402364, 123, '2015-02-15 01:19:14.000000', 'consum', 0.0216, 'lps'),
	(402365, 123, '2015-02-15 01:19:15.000000', 'consum', 0.0213, 'lps'),
	(402366, 123, '2015-02-15 01:19:16.000000', 'consum', 0.0219, 'lps'),
	(402367, 123, '2015-02-15 01:19:17.000000', 'consum', 0.0211, 'lps'),
	(402368, 123, '2015-02-15 01:19:18.000000', 'consum', 0.0213, 'lps'),
	(402369, 123, '2015-02-15 01:19:19.000000', 'consum', 0.0212, 'lps'),
	(402370, 123, '2015-02-15 01:19:20.000000', 'consum', 0.0220, 'lps'),
	(402371, 123, '2015-02-15 01:19:21.000000', 'consum', 0.0211, 'lps'),
	(402372, 123, '2015-02-15 01:19:22.000000', 'consum', 0.0217, 'lps'),
	(402373, 123, '2015-02-15 01:19:23.000000', 'consum', 0.0211, 'lps'),
	(402374, 123, '2015-02-15 01:19:24.000000', 'consum', 0.0216, 'lps'),
	(402375, 123, '2015-02-15 01:19:25.000000', 'consum', 0.0215, 'lps'),
	(402376, 123, '2015-02-15 01:19:26.000000', 'consum', 0.0218, 'lps'),
	(402377, 123, '2015-02-15 01:19:27.000000', 'consum', 0.0212, 'lps'),
	(402378, 123, '2015-02-15 01:19:28.000000', 'consum', 0.0218, 'lps'),
	(402379, 123, '2015-02-15 01:19:29.000000', 'consum', 0.0211, 'lps'),
	(402380, 123, '2015-02-15 01:19:30.000000', 'consum', 0.0215, 'lps'),
	(402381, 123, '2015-02-15 01:19:31.000000', 'consum', 0.0210, 'lps'),
	(402382, 123, '2015-02-15 01:19:32.000000', 'consum', 0.0220, 'lps'),
	(402383, 123, '2015-02-15 01:19:33.000000', 'consum', 0.0214, 'lps'),
	(402384, 123, '2015-02-15 01:19:34.000000', 'consum', 0.0211, 'lps'),
	(402385, 123, '2015-02-15 01:19:35.000000', 'consum', 0.0215, 'lps'),
	(402386, 123, '2015-02-15 01:19:36.000000', 'consum', 0.0211, 'lps'),
	(402387, 123, '2015-02-15 01:19:37.000000', 'consum', 0.0211, 'lps'),
	(402388, 123, '2015-02-15 01:19:38.000000', 'consum', 0.0212, 'lps'),
	(402389, 123, '2015-02-15 01:19:39.000000', 'consum', 0.0219, 'lps'),
	(402390, 123, '2015-02-15 01:19:40.000000', 'consum', 0.0217, 'lps'),
	(402391, 123, '2015-02-15 01:19:41.000000', 'consum', 0.0220, 'lps'),
	(402392, 123, '2015-02-15 01:19:42.000000', 'consum', 0.0214, 'lps'),
	(402393, 123, '2015-02-15 01:19:43.000000', 'consum', 0.0213, 'lps'),
	(402394, 123, '2015-02-15 01:19:44.000000', 'consum', 0.0212, 'lps'),
	(402395, 123, '2015-02-15 01:19:45.000000', 'consum', 0.0215, 'lps'),
	(402396, 123, '2015-02-15 01:19:46.000000', 'consum', 0.0215, 'lps'),
	(402397, 123, '2015-02-15 01:19:47.000000', 'consum', 0.0210, 'lps'),
	(402398, 123, '2015-02-15 01:19:48.000000', 'consum', 0.0218, 'lps'),
	(402399, 123, '2015-02-15 01:19:49.000000', 'consum', 0.0218, 'lps'),
	(402400, 123, '2015-02-15 01:19:50.000000', 'consum', 0.0214, 'lps'),
	(402401, 123, '2015-02-15 01:19:51.000000', 'consum', 0.0219, 'lps'),
	(402402, 123, '2015-02-15 01:19:52.000000', 'consum', 0.0212, 'lps'),
	(402403, 123, '2015-02-15 01:19:53.000000', 'consum', 0.0212, 'lps'),
	(402404, 123, '2015-02-15 01:19:54.000000', 'consum', 0.0216, 'lps'),
	(402405, 123, '2015-02-15 01:19:55.000000', 'consum', 0.0213, 'lps'),
	(402406, 123, '2015-02-15 01:19:56.000000', 'consum', 0.0219, 'lps'),
	(402407, 123, '2015-02-15 01:19:57.000000', 'consum', 0.0213, 'lps'),
	(402408, 123, '2015-02-15 01:19:58.000000', 'consum', 0.0211, 'lps'),
	(402409, 123, '2015-02-15 01:19:59.000000', 'consum', 0.0218, 'lps'),
	(402410, 123, '2015-02-15 01:20:00.000000', 'consum', 0.0212, 'lps'),
	(402411, 123, '2015-02-15 01:20:01.000000', 'consum', 0.0220, 'lps'),
	(402412, 123, '2015-02-15 01:20:02.000000', 'consum', 0.0210, 'lps'),
	(402413, 123, '2015-02-15 01:20:03.000000', 'consum', 0.0212, 'lps'),
	(402414, 123, '2015-02-15 01:20:04.000000', 'consum', 0.0210, 'lps'),
	(402415, 123, '2015-02-15 01:20:05.000000', 'consum', 0.0217, 'lps'),
	(402416, 123, '2015-02-15 01:20:06.000000', 'consum', 0.0213, 'lps'),
	(402417, 123, '2015-02-15 01:20:07.000000', 'consum', 0.0215, 'lps'),
	(402418, 123, '2015-02-15 01:20:08.000000', 'consum', 0.0215, 'lps'),
	(402419, 123, '2015-02-15 01:20:09.000000', 'consum', 0.0211, 'lps'),
	(402420, 123, '2015-02-15 01:20:10.000000', 'consum', 0.0212, 'lps'),
	(402421, 123, '2015-02-15 01:20:11.000000', 'consum', 0.0215, 'lps'),
	(402422, 123, '2015-02-15 01:20:12.000000', 'consum', 0.0210, 'lps'),
	(402423, 123, '2015-02-15 01:20:13.000000', 'consum', 0.0216, 'lps'),
	(402424, 123, '2015-02-15 01:20:14.000000', 'consum', 0.0210, 'lps'),
	(402425, 123, '2015-02-15 01:20:15.000000', 'consum', 0.0212, 'lps'),
	(402426, 123, '2015-02-15 01:20:16.000000', 'consum', 0.0211, 'lps'),
	(402427, 123, '2015-02-15 01:20:17.000000', 'consum', 0.0218, 'lps'),
	(402428, 123, '2015-02-15 01:20:18.000000', 'consum', 0.0217, 'lps'),
	(402429, 123, '2015-02-15 01:20:19.000000', 'consum', 0.0211, 'lps'),
	(402430, 123, '2015-02-15 01:20:20.000000', 'consum', 0.0214, 'lps'),
	(402431, 123, '2015-02-15 01:20:21.000000', 'consum', 0.0220, 'lps'),
	(402432, 123, '2015-02-15 01:20:22.000000', 'consum', 0.0212, 'lps'),
	(402433, 123, '2015-02-15 01:20:23.000000', 'consum', 0.0212, 'lps'),
	(402434, 123, '2015-02-15 01:20:24.000000', 'consum', 0.0218, 'lps'),
	(402435, 123, '2015-02-15 01:20:25.000000', 'consum', 0.0220, 'lps'),
	(402436, 123, '2015-02-15 01:20:26.000000', 'consum', 0.0217, 'lps'),
	(402437, 123, '2015-02-15 01:20:27.000000', 'consum', 0.0214, 'lps'),
	(402438, 123, '2015-02-15 01:20:28.000000', 'consum', 0.0219, 'lps'),
	(402439, 123, '2015-02-15 01:20:29.000000', 'consum', 0.0211, 'lps'),
	(402440, 123, '2015-02-15 01:20:30.000000', 'consum', 0.0212, 'lps'),
	(402441, 123, '2015-02-15 01:20:31.000000', 'consum', 0.0219, 'lps'),
	(402442, 123, '2015-02-15 01:20:32.000000', 'consum', 0.0214, 'lps'),
	(402443, 123, '2015-02-15 01:20:33.000000', 'consum', 0.0213, 'lps'),
	(402444, 123, '2015-02-15 01:20:34.000000', 'consum', 0.0215, 'lps'),
	(402445, 123, '2015-02-15 01:20:35.000000', 'consum', 0.0217, 'lps'),
	(402446, 123, '2015-02-15 01:20:36.000000', 'consum', 0.0216, 'lps'),
	(402447, 123, '2015-02-15 01:20:37.000000', 'consum', 0.0212, 'lps'),
	(402448, 123, '2015-02-15 01:20:38.000000', 'consum', 0.0213, 'lps'),
	(402449, 123, '2015-02-15 01:20:39.000000', 'consum', 0.0217, 'lps'),
	(402450, 123, '2015-02-15 01:20:40.000000', 'consum', 0.0216, 'lps'),
	(402451, 123, '2015-02-15 01:20:41.000000', 'consum', 0.0210, 'lps'),
	(402452, 123, '2015-02-15 01:20:42.000000', 'consum', 0.0214, 'lps'),
	(402453, 123, '2015-02-15 01:20:43.000000', 'consum', 0.0210, 'lps'),
	(402454, 123, '2015-02-15 01:20:44.000000', 'consum', 0.0220, 'lps'),
	(402455, 123, '2015-02-15 01:20:45.000000', 'consum', 0.0216, 'lps'),
	(402456, 123, '2015-02-15 01:20:46.000000', 'consum', 0.0210, 'lps'),
	(402457, 123, '2015-02-15 01:20:47.000000', 'consum', 0.0213, 'lps'),
	(402458, 123, '2015-02-15 01:20:48.000000', 'consum', 0.0215, 'lps'),
	(402459, 123, '2015-02-15 01:20:49.000000', 'consum', 0.0218, 'lps'),
	(402460, 123, '2015-02-15 01:20:50.000000', 'consum', 0.0211, 'lps'),
	(402461, 123, '2015-02-15 01:20:51.000000', 'consum', 0.0214, 'lps'),
	(402462, 123, '2015-02-15 01:20:52.000000', 'consum', 0.0219, 'lps'),
	(402463, 123, '2015-02-15 01:20:53.000000', 'consum', 0.0218, 'lps'),
	(402464, 123, '2015-02-15 01:20:54.000000', 'consum', 0.0216, 'lps'),
	(402465, 123, '2015-02-15 01:20:55.000000', 'consum', 0.0213, 'lps'),
	(402466, 123, '2015-02-15 01:20:56.000000', 'consum', 0.0210, 'lps'),
	(402467, 123, '2015-02-15 01:20:57.000000', 'consum', 0.0213, 'lps'),
	(402468, 123, '2015-02-15 01:20:58.000000', 'consum', 0.0212, 'lps'),
	(402469, 123, '2015-02-15 01:20:59.000000', 'consum', 0.0214, 'lps'),
	(402470, 123, '2015-02-15 01:21:00.000000', 'consum', 0.0213, 'lps'),
	(402471, 123, '2015-02-15 01:21:01.000000', 'consum', 0.0214, 'lps'),
	(402472, 123, '2015-02-15 01:21:02.000000', 'consum', 0.0211, 'lps'),
	(402473, 123, '2015-02-15 01:21:03.000000', 'consum', 0.0214, 'lps'),
	(402474, 123, '2015-02-15 01:21:04.000000', 'consum', 0.0216, 'lps'),
	(402475, 123, '2015-02-15 01:21:05.000000', 'consum', 0.0219, 'lps'),
	(402476, 123, '2015-02-15 01:21:06.000000', 'consum', 0.0215, 'lps'),
	(402477, 123, '2015-02-15 01:21:07.000000', 'consum', 0.0218, 'lps'),
	(402478, 123, '2015-02-15 01:21:08.000000', 'consum', 0.0216, 'lps'),
	(402479, 123, '2015-02-15 01:21:09.000000', 'consum', 0.0213, 'lps'),
	(402480, 123, '2015-02-15 01:21:10.000000', 'consum', 0.0210, 'lps'),
	(402481, 123, '2015-02-15 01:21:11.000000', 'consum', 0.0214, 'lps'),
	(402482, 123, '2015-02-15 01:21:12.000000', 'consum', 0.0218, 'lps'),
	(402483, 123, '2015-02-15 01:21:13.000000', 'consum', 0.0216, 'lps'),
	(402484, 123, '2015-02-15 01:21:14.000000', 'consum', 0.0218, 'lps'),
	(402485, 123, '2015-02-15 01:21:15.000000', 'consum', 0.0210, 'lps'),
	(402486, 123, '2015-02-15 01:21:16.000000', 'consum', 0.0218, 'lps'),
	(402487, 123, '2015-02-15 01:21:17.000000', 'consum', 0.0220, 'lps'),
	(402488, 123, '2015-02-15 01:21:18.000000', 'consum', 0.0212, 'lps'),
	(402489, 123, '2015-02-15 01:21:19.000000', 'consum', 0.0213, 'lps'),
	(402490, 123, '2015-02-15 01:21:20.000000', 'consum', 0.0220, 'lps'),
	(402491, 123, '2015-02-15 01:21:21.000000', 'consum', 0.0220, 'lps'),
	(402492, 123, '2015-02-15 01:21:22.000000', 'consum', 0.0219, 'lps'),
	(402493, 123, '2015-02-15 01:21:23.000000', 'consum', 0.0213, 'lps'),
	(402494, 123, '2015-02-15 01:21:24.000000', 'consum', 0.0212, 'lps'),
	(402495, 123, '2015-02-15 01:21:25.000000', 'consum', 0.0210, 'lps'),
	(402496, 123, '2015-02-15 01:21:26.000000', 'consum', 0.0216, 'lps'),
	(402497, 123, '2015-02-15 01:21:27.000000', 'consum', 0.0218, 'lps'),
	(402498, 123, '2015-02-15 01:21:28.000000', 'consum', 0.0211, 'lps'),
	(402499, 123, '2015-02-15 01:21:29.000000', 'consum', 0.0213, 'lps'),
	(402500, 123, '2015-02-15 01:21:30.000000', 'consum', 0.0211, 'lps'),
	(402501, 123, '2015-02-15 01:21:31.000000', 'consum', 0.0217, 'lps'),
	(402502, 123, '2015-02-15 01:21:32.000000', 'consum', 0.0210, 'lps'),
	(402503, 123, '2015-02-15 01:21:33.000000', 'consum', 0.0210, 'lps'),
	(402504, 123, '2015-02-15 01:21:34.000000', 'consum', 0.0213, 'lps'),
	(402505, 123, '2015-02-15 01:21:35.000000', 'consum', 0.0215, 'lps'),
	(402506, 123, '2015-02-15 01:21:36.000000', 'consum', 0.0213, 'lps'),
	(402507, 123, '2015-02-15 01:21:37.000000', 'consum', 0.0214, 'lps'),
	(402508, 123, '2015-02-15 01:21:38.000000', 'consum', 0.0218, 'lps'),
	(402509, 123, '2015-02-15 01:21:39.000000', 'consum', 0.0219, 'lps'),
	(402510, 123, '2015-02-15 01:21:40.000000', 'consum', 0.0211, 'lps'),
	(402511, 123, '2015-02-15 01:21:41.000000', 'consum', 0.0218, 'lps'),
	(402512, 123, '2015-02-15 01:21:42.000000', 'consum', 0.0214, 'lps'),
	(402513, 123, '2015-02-15 01:21:43.000000', 'consum', 0.0210, 'lps'),
	(402514, 123, '2015-02-15 01:21:44.000000', 'consum', 0.0218, 'lps'),
	(402515, 123, '2015-02-15 01:21:45.000000', 'consum', 0.0218, 'lps'),
	(402516, 123, '2015-02-15 01:21:46.000000', 'consum', 0.0215, 'lps'),
	(402517, 123, '2015-02-15 01:21:47.000000', 'consum', 0.0211, 'lps'),
	(402518, 123, '2015-02-15 01:21:48.000000', 'consum', 0.0211, 'lps'),
	(402519, 123, '2015-02-15 01:21:49.000000', 'consum', 0.0212, 'lps'),
	(402520, 123, '2015-02-15 01:21:50.000000', 'consum', 0.0216, 'lps'),
	(402521, 123, '2015-02-15 01:21:51.000000', 'consum', 0.0216, 'lps'),
	(402522, 123, '2015-02-15 01:21:52.000000', 'consum', 0.0210, 'lps'),
	(402523, 123, '2015-02-15 01:21:53.000000', 'consum', 0.0214, 'lps'),
	(402524, 123, '2015-02-15 01:21:54.000000', 'consum', 0.0211, 'lps'),
	(402525, 123, '2015-02-15 01:21:55.000000', 'consum', 0.0211, 'lps'),
	(402526, 123, '2015-02-15 01:21:56.000000', 'consum', 0.0216, 'lps'),
	(402527, 123, '2015-02-15 01:21:57.000000', 'consum', 0.0214, 'lps'),
	(402528, 123, '2015-02-15 01:21:58.000000', 'consum', 0.0214, 'lps'),
	(402529, 123, '2015-02-15 01:21:59.000000', 'consum', 0.0218, 'lps'),
	(402530, 123, '2015-02-15 01:22:00.000000', 'consum', 0.0218, 'lps'),
	(402531, 123, '2015-02-15 01:22:01.000000', 'consum', 0.0215, 'lps'),
	(402532, 123, '2015-02-15 01:22:02.000000', 'consum', 0.0210, 'lps'),
	(402533, 123, '2015-02-15 01:22:03.000000', 'consum', 0.0217, 'lps'),
	(402534, 123, '2015-02-15 01:22:04.000000', 'consum', 0.0213, 'lps'),
	(402535, 123, '2015-02-15 01:22:05.000000', 'consum', 0.0217, 'lps'),
	(402536, 123, '2015-02-15 01:22:06.000000', 'consum', 0.0213, 'lps'),
	(402537, 123, '2015-02-15 01:22:07.000000', 'consum', 0.0218, 'lps'),
	(402538, 123, '2015-02-15 01:22:08.000000', 'consum', 0.0218, 'lps'),
	(402539, 123, '2015-02-15 01:22:09.000000', 'consum', 0.0217, 'lps'),
	(402540, 123, '2015-02-15 01:22:10.000000', 'consum', 0.0218, 'lps'),
	(402541, 123, '2015-02-15 01:22:11.000000', 'consum', 0.0211, 'lps'),
	(402542, 123, '2015-02-15 01:22:12.000000', 'consum', 0.0213, 'lps'),
	(402543, 123, '2015-02-15 01:22:13.000000', 'consum', 0.0212, 'lps'),
	(402544, 123, '2015-02-15 01:22:14.000000', 'consum', 0.0212, 'lps'),
	(402545, 123, '2015-02-15 01:22:15.000000', 'consum', 0.0213, 'lps'),
	(402546, 123, '2015-02-15 01:22:16.000000', 'consum', 0.0211, 'lps'),
	(402547, 123, '2015-02-15 01:22:17.000000', 'consum', 0.0214, 'lps'),
	(402548, 123, '2015-02-15 01:22:18.000000', 'consum', 0.0219, 'lps'),
	(402549, 123, '2015-02-15 01:22:19.000000', 'consum', 0.0219, 'lps'),
	(402550, 123, '2015-02-15 01:22:20.000000', 'consum', 0.0218, 'lps'),
	(402551, 123, '2015-02-15 01:22:21.000000', 'consum', 0.0211, 'lps'),
	(402552, 123, '2015-02-15 01:22:22.000000', 'consum', 0.0216, 'lps'),
	(402553, 123, '2015-02-15 01:22:23.000000', 'consum', 0.0215, 'lps'),
	(402554, 123, '2015-02-15 01:22:24.000000', 'consum', 0.0219, 'lps'),
	(402555, 123, '2015-02-15 01:22:25.000000', 'consum', 0.0216, 'lps'),
	(402556, 123, '2015-02-15 01:22:26.000000', 'consum', 0.0212, 'lps'),
	(402557, 123, '2015-02-15 01:22:27.000000', 'consum', 0.0217, 'lps'),
	(402558, 123, '2015-02-15 01:22:28.000000', 'consum', 0.0216, 'lps'),
	(402559, 123, '2015-02-15 01:22:29.000000', 'consum', 0.0220, 'lps'),
	(402560, 123, '2015-02-15 01:22:30.000000', 'consum', 0.0220, 'lps'),
	(402561, 123, '2015-02-15 01:22:31.000000', 'consum', 0.0210, 'lps'),
	(402562, 123, '2015-02-15 01:22:32.000000', 'consum', 0.0214, 'lps'),
	(402563, 123, '2015-02-15 01:22:33.000000', 'consum', 0.0220, 'lps'),
	(402564, 123, '2015-02-15 01:22:34.000000', 'consum', 0.0213, 'lps'),
	(402565, 123, '2015-02-15 01:22:35.000000', 'consum', 0.0217, 'lps'),
	(402566, 123, '2015-02-15 01:22:36.000000', 'consum', 0.0217, 'lps'),
	(402567, 123, '2015-02-15 01:22:37.000000', 'consum', 0.0213, 'lps'),
	(402568, 123, '2015-02-15 01:22:38.000000', 'consum', 0.0215, 'lps'),
	(402569, 123, '2015-02-15 01:22:39.000000', 'consum', 0.0216, 'lps'),
	(402570, 123, '2015-02-15 01:22:40.000000', 'consum', 0.0214, 'lps'),
	(402571, 123, '2015-02-15 01:22:41.000000', 'consum', 0.0214, 'lps'),
	(402572, 123, '2015-02-15 01:22:42.000000', 'consum', 0.0219, 'lps'),
	(402573, 123, '2015-02-15 01:22:43.000000', 'consum', 0.0219, 'lps'),
	(402574, 123, '2015-02-15 01:22:44.000000', 'consum', 0.0219, 'lps'),
	(402575, 123, '2015-02-15 01:22:45.000000', 'consum', 0.0217, 'lps'),
	(402576, 123, '2015-02-15 01:22:46.000000', 'consum', 0.0217, 'lps'),
	(402577, 123, '2015-02-15 01:22:47.000000', 'consum', 0.0216, 'lps'),
	(402578, 123, '2015-02-15 01:22:48.000000', 'consum', 0.0218, 'lps'),
	(402579, 123, '2015-02-15 01:22:49.000000', 'consum', 0.0211, 'lps'),
	(402580, 123, '2015-02-15 01:22:50.000000', 'consum', 0.0214, 'lps'),
	(402581, 123, '2015-02-15 01:22:51.000000', 'consum', 0.0217, 'lps'),
	(402582, 123, '2015-02-15 01:22:52.000000', 'consum', 0.0212, 'lps'),
	(402583, 123, '2015-02-15 01:22:53.000000', 'consum', 0.0211, 'lps'),
	(402584, 123, '2015-02-15 01:22:54.000000', 'consum', 0.0218, 'lps'),
	(402585, 123, '2015-02-15 01:22:55.000000', 'consum', 0.0215, 'lps'),
	(402586, 123, '2015-02-15 01:22:56.000000', 'consum', 0.0212, 'lps'),
	(402587, 123, '2015-02-15 01:22:57.000000', 'consum', 0.0216, 'lps'),
	(402588, 123, '2015-02-15 01:22:58.000000', 'consum', 0.0214, 'lps'),
	(402589, 123, '2015-02-15 01:22:59.000000', 'consum', 0.0211, 'lps'),
	(402590, 123, '2015-02-15 01:23:00.000000', 'consum', 0.0217, 'lps'),
	(402591, 123, '2015-02-15 01:23:01.000000', 'consum', 0.0219, 'lps'),
	(402592, 123, '2015-02-15 01:23:02.000000', 'consum', 0.0211, 'lps'),
	(402593, 123, '2015-02-15 01:23:03.000000', 'consum', 0.0213, 'lps'),
	(402594, 123, '2015-02-15 01:23:04.000000', 'consum', 0.0212, 'lps'),
	(402595, 123, '2015-02-15 01:23:05.000000', 'consum', 0.0210, 'lps'),
	(402596, 123, '2015-02-15 01:23:06.000000', 'consum', 0.0214, 'lps'),
	(402597, 123, '2015-02-15 01:23:07.000000', 'consum', 0.0220, 'lps'),
	(402598, 123, '2015-02-15 01:23:08.000000', 'consum', 0.0214, 'lps'),
	(402599, 123, '2015-02-15 01:23:09.000000', 'consum', 0.0214, 'lps'),
	(402600, 123, '2015-02-15 01:23:10.000000', 'consum', 0.0217, 'lps'),
	(402601, 123, '2015-02-15 01:23:11.000000', 'consum', 0.0212, 'lps'),
	(402602, 123, '2015-02-15 01:23:12.000000', 'consum', 0.0220, 'lps'),
	(402603, 123, '2015-02-15 01:23:13.000000', 'consum', 0.0211, 'lps'),
	(402604, 123, '2015-02-15 01:23:14.000000', 'consum', 0.0217, 'lps'),
	(402605, 123, '2015-02-15 01:23:15.000000', 'consum', 0.0211, 'lps'),
	(402606, 123, '2015-02-15 01:23:16.000000', 'consum', 0.0217, 'lps'),
	(402607, 123, '2015-02-15 01:23:17.000000', 'consum', 0.0210, 'lps'),
	(402608, 123, '2015-02-15 01:23:18.000000', 'consum', 0.0210, 'lps'),
	(402609, 123, '2015-02-15 01:23:19.000000', 'consum', 0.0220, 'lps'),
	(402610, 123, '2015-02-15 01:23:20.000000', 'consum', 0.0220, 'lps'),
	(402611, 123, '2015-02-15 01:23:21.000000', 'consum', 0.0218, 'lps'),
	(402612, 123, '2015-02-15 01:23:22.000000', 'consum', 0.0219, 'lps'),
	(402613, 123, '2015-02-15 01:23:23.000000', 'consum', 0.0210, 'lps'),
	(402614, 123, '2015-02-15 01:23:24.000000', 'consum', 0.0217, 'lps'),
	(402615, 123, '2015-02-15 01:23:25.000000', 'consum', 0.0214, 'lps'),
	(402616, 123, '2015-02-15 01:23:26.000000', 'consum', 0.0220, 'lps'),
	(402617, 123, '2015-02-15 01:23:27.000000', 'consum', 0.0216, 'lps'),
	(402618, 123, '2015-02-15 01:23:28.000000', 'consum', 0.0210, 'lps'),
	(402619, 123, '2015-02-15 01:23:29.000000', 'consum', 0.0214, 'lps'),
	(402620, 123, '2015-02-15 01:23:30.000000', 'consum', 0.0210, 'lps'),
	(402621, 123, '2015-02-15 01:23:31.000000', 'consum', 0.0210, 'lps'),
	(402622, 123, '2015-02-15 01:23:32.000000', 'consum', 0.0210, 'lps'),
	(402623, 123, '2015-02-15 01:23:33.000000', 'consum', 0.0211, 'lps'),
	(402624, 123, '2015-02-15 01:23:34.000000', 'consum', 0.0216, 'lps'),
	(402625, 123, '2015-02-15 01:23:35.000000', 'consum', 0.0214, 'lps'),
	(402626, 123, '2015-02-15 01:23:36.000000', 'consum', 0.0213, 'lps'),
	(402627, 123, '2015-02-15 01:23:37.000000', 'consum', 0.0212, 'lps'),
	(402628, 123, '2015-02-15 01:23:38.000000', 'consum', 0.0213, 'lps'),
	(402629, 123, '2015-02-15 01:23:39.000000', 'consum', 0.0219, 'lps'),
	(402630, 123, '2015-02-15 01:23:40.000000', 'consum', 0.0212, 'lps'),
	(402631, 123, '2015-02-15 01:23:41.000000', 'consum', 0.0217, 'lps'),
	(402632, 123, '2015-02-15 01:23:42.000000', 'consum', 0.0218, 'lps'),
	(402633, 123, '2015-02-15 01:23:43.000000', 'consum', 0.0219, 'lps'),
	(402634, 123, '2015-02-15 01:23:44.000000', 'consum', 0.0210, 'lps'),
	(402635, 123, '2015-02-15 01:23:45.000000', 'consum', 0.0215, 'lps'),
	(402636, 123, '2015-02-15 01:23:46.000000', 'consum', 0.0215, 'lps'),
	(402637, 123, '2015-02-15 01:23:47.000000', 'consum', 0.0210, 'lps'),
	(402638, 123, '2015-02-15 01:23:48.000000', 'consum', 0.0218, 'lps'),
	(402639, 123, '2015-02-15 01:23:49.000000', 'consum', 0.0215, 'lps'),
	(402640, 123, '2015-02-15 01:23:50.000000', 'consum', 0.0212, 'lps'),
	(402641, 123, '2015-02-15 01:23:51.000000', 'consum', 0.0215, 'lps'),
	(402642, 123, '2015-02-15 01:23:52.000000', 'consum', 0.0219, 'lps'),
	(402643, 123, '2015-02-15 01:23:53.000000', 'consum', 0.0220, 'lps'),
	(402644, 123, '2015-02-15 01:23:54.000000', 'consum', 0.0210, 'lps'),
	(402645, 123, '2015-02-15 01:23:55.000000', 'consum', 0.0214, 'lps'),
	(402646, 123, '2015-02-15 01:23:56.000000', 'consum', 0.0219, 'lps'),
	(402647, 123, '2015-02-15 01:23:57.000000', 'consum', 0.0211, 'lps'),
	(402648, 123, '2015-02-15 01:23:58.000000', 'consum', 0.0213, 'lps'),
	(402649, 123, '2015-02-15 01:23:59.000000', 'consum', 0.0219, 'lps'),
	(402650, 123, '2015-02-15 01:24:00.000000', 'consum', 0.0213, 'lps'),
	(402651, 123, '2015-02-15 01:24:01.000000', 'consum', 0.0212, 'lps'),
	(402652, 123, '2015-02-15 01:24:02.000000', 'consum', 0.0220, 'lps'),
	(402653, 123, '2015-02-15 01:24:03.000000', 'consum', 0.0210, 'lps'),
	(402654, 123, '2015-02-15 01:24:04.000000', 'consum', 0.0213, 'lps'),
	(402655, 123, '2015-02-15 01:24:05.000000', 'consum', 0.0214, 'lps'),
	(402656, 123, '2015-02-15 01:24:06.000000', 'consum', 0.0211, 'lps'),
	(402657, 123, '2015-02-15 01:24:07.000000', 'consum', 0.0214, 'lps'),
	(402658, 123, '2015-02-15 01:24:08.000000', 'consum', 0.0218, 'lps'),
	(402659, 123, '2015-02-15 01:24:09.000000', 'consum', 0.0215, 'lps'),
	(402660, 123, '2015-02-15 01:24:10.000000', 'consum', 0.0212, 'lps'),
	(402661, 123, '2015-02-15 01:24:11.000000', 'consum', 0.0218, 'lps'),
	(402662, 123, '2015-02-15 01:24:12.000000', 'consum', 0.0211, 'lps'),
	(402663, 123, '2015-02-15 01:24:13.000000', 'consum', 0.0215, 'lps'),
	(402664, 123, '2015-02-15 01:24:14.000000', 'consum', 0.0220, 'lps'),
	(402665, 123, '2015-02-15 01:24:15.000000', 'consum', 0.0214, 'lps'),
	(402666, 123, '2015-02-15 01:24:16.000000', 'consum', 0.0212, 'lps'),
	(402667, 123, '2015-02-15 01:24:17.000000', 'consum', 0.0217, 'lps'),
	(402668, 123, '2015-02-15 01:24:18.000000', 'consum', 0.0210, 'lps'),
	(402669, 123, '2015-02-15 01:24:19.000000', 'consum', 0.0219, 'lps'),
	(402670, 123, '2015-02-15 01:24:20.000000', 'consum', 0.0215, 'lps'),
	(402671, 123, '2015-02-15 01:24:21.000000', 'consum', 0.0217, 'lps'),
	(402672, 123, '2015-02-15 01:24:22.000000', 'consum', 0.0220, 'lps'),
	(402673, 123, '2015-02-15 01:24:23.000000', 'consum', 0.0218, 'lps'),
	(402674, 123, '2015-02-15 01:24:24.000000', 'consum', 0.0220, 'lps'),
	(402675, 123, '2015-02-15 01:24:25.000000', 'consum', 0.0214, 'lps'),
	(402676, 123, '2015-02-15 01:24:26.000000', 'consum', 0.0211, 'lps'),
	(402677, 123, '2015-02-15 01:24:27.000000', 'consum', 0.0217, 'lps'),
	(402678, 123, '2015-02-15 01:24:28.000000', 'consum', 0.0218, 'lps'),
	(402679, 123, '2015-02-15 01:24:29.000000', 'consum', 0.0210, 'lps'),
	(402680, 123, '2015-02-15 01:24:30.000000', 'consum', 0.0220, 'lps'),
	(402681, 123, '2015-02-15 01:24:31.000000', 'consum', 0.0215, 'lps'),
	(402682, 123, '2015-02-15 01:24:32.000000', 'consum', 0.0217, 'lps'),
	(402683, 123, '2015-02-15 01:24:33.000000', 'consum', 0.0218, 'lps'),
	(402684, 123, '2015-02-15 01:24:34.000000', 'consum', 0.0218, 'lps'),
	(402685, 123, '2015-02-15 01:24:35.000000', 'consum', 0.0217, 'lps'),
	(402686, 123, '2015-02-15 01:24:36.000000', 'consum', 0.0211, 'lps'),
	(402687, 123, '2015-02-15 01:24:37.000000', 'consum', 0.0216, 'lps'),
	(402688, 123, '2015-02-15 01:24:38.000000', 'consum', 0.0214, 'lps'),
	(402689, 123, '2015-02-15 01:24:39.000000', 'consum', 0.0215, 'lps'),
	(402690, 123, '2015-02-15 01:24:40.000000', 'consum', 0.0211, 'lps'),
	(402691, 123, '2015-02-15 01:24:41.000000', 'consum', 0.0211, 'lps'),
	(402692, 123, '2015-02-15 01:24:42.000000', 'consum', 0.0212, 'lps'),
	(402693, 123, '2015-02-15 01:24:43.000000', 'consum', 0.0220, 'lps'),
	(402694, 123, '2015-02-15 01:24:44.000000', 'consum', 0.0210, 'lps'),
	(402695, 123, '2015-02-15 01:24:45.000000', 'consum', 0.0211, 'lps'),
	(402696, 123, '2015-02-15 01:24:46.000000', 'consum', 0.0217, 'lps'),
	(402697, 123, '2015-02-15 01:24:47.000000', 'consum', 0.0219, 'lps'),
	(402698, 123, '2015-02-15 01:24:48.000000', 'consum', 0.0215, 'lps'),
	(402699, 123, '2015-02-15 01:24:49.000000', 'consum', 0.0220, 'lps'),
	(402700, 123, '2015-02-15 01:24:50.000000', 'consum', 0.0210, 'lps'),
	(402701, 123, '2015-02-15 01:24:51.000000', 'consum', 0.0214, 'lps'),
	(402702, 123, '2015-02-15 01:24:52.000000', 'consum', 0.0218, 'lps'),
	(402703, 123, '2015-02-15 01:24:53.000000', 'consum', 0.0220, 'lps'),
	(402704, 123, '2015-02-15 01:24:54.000000', 'consum', 0.0212, 'lps'),
	(402705, 123, '2015-02-15 01:24:55.000000', 'consum', 0.0215, 'lps'),
	(402706, 123, '2015-02-15 01:24:56.000000', 'consum', 0.0217, 'lps'),
	(402707, 123, '2015-02-15 01:24:57.000000', 'consum', 0.0218, 'lps'),
	(402708, 123, '2015-02-15 01:24:58.000000', 'consum', 0.0218, 'lps'),
	(402709, 123, '2015-02-15 01:24:59.000000', 'consum', 0.0217, 'lps'),
	(402710, 123, '2015-02-15 01:25:00.000000', 'consum', 0.0210, 'lps'),
	(402711, 123, '2015-02-15 01:25:01.000000', 'consum', 0.0211, 'lps'),
	(402712, 123, '2015-02-15 01:25:02.000000', 'consum', 0.0215, 'lps'),
	(402713, 123, '2015-02-15 01:25:03.000000', 'consum', 0.0213, 'lps'),
	(402714, 123, '2015-02-15 01:25:04.000000', 'consum', 0.0220, 'lps'),
	(402715, 123, '2015-02-15 01:25:05.000000', 'consum', 0.0220, 'lps'),
	(402716, 123, '2015-02-15 01:25:06.000000', 'consum', 0.0219, 'lps'),
	(402717, 123, '2015-02-15 01:25:07.000000', 'consum', 0.0213, 'lps'),
	(402718, 123, '2015-02-15 01:25:08.000000', 'consum', 0.0220, 'lps'),
	(402719, 123, '2015-02-15 01:25:09.000000', 'consum', 0.0210, 'lps'),
	(402720, 123, '2015-02-15 01:25:10.000000', 'consum', 0.0213, 'lps'),
	(402721, 123, '2015-02-15 01:25:11.000000', 'consum', 0.0213, 'lps'),
	(402722, 123, '2015-02-15 01:25:12.000000', 'consum', 0.0216, 'lps'),
	(402723, 123, '2015-02-15 01:25:13.000000', 'consum', 0.0211, 'lps'),
	(402724, 123, '2015-02-15 01:25:14.000000', 'consum', 0.0218, 'lps'),
	(402725, 123, '2015-02-15 01:25:15.000000', 'consum', 0.0216, 'lps'),
	(402726, 123, '2015-02-15 01:25:16.000000', 'consum', 0.0216, 'lps'),
	(402727, 123, '2015-02-15 01:25:17.000000', 'consum', 0.0210, 'lps'),
	(402728, 123, '2015-02-15 01:25:18.000000', 'consum', 0.0214, 'lps'),
	(402729, 123, '2015-02-15 01:25:19.000000', 'consum', 0.0220, 'lps'),
	(402730, 123, '2015-02-15 01:25:20.000000', 'consum', 0.0216, 'lps'),
	(402731, 123, '2015-02-15 01:25:21.000000', 'consum', 0.0210, 'lps'),
	(402732, 123, '2015-02-15 01:25:22.000000', 'consum', 0.0213, 'lps'),
	(402733, 123, '2015-02-15 01:25:23.000000', 'consum', 0.0217, 'lps'),
	(402734, 123, '2015-02-15 01:25:24.000000', 'consum', 0.0212, 'lps'),
	(402735, 123, '2015-02-15 01:25:25.000000', 'consum', 0.0213, 'lps'),
	(402736, 123, '2015-02-15 01:25:26.000000', 'consum', 0.0210, 'lps'),
	(402737, 123, '2015-02-15 01:25:27.000000', 'consum', 0.0220, 'lps'),
	(402738, 123, '2015-02-15 01:25:28.000000', 'consum', 0.0216, 'lps'),
	(402739, 123, '2015-02-15 01:25:29.000000', 'consum', 0.0213, 'lps'),
	(402740, 123, '2015-02-15 01:25:30.000000', 'consum', 0.0219, 'lps'),
	(402741, 123, '2015-02-15 01:25:31.000000', 'consum', 0.0214, 'lps'),
	(402742, 123, '2015-02-15 01:25:32.000000', 'consum', 0.0213, 'lps'),
	(402743, 123, '2015-02-15 01:25:33.000000', 'consum', 0.0214, 'lps'),
	(402744, 123, '2015-02-15 01:25:34.000000', 'consum', 0.0219, 'lps'),
	(402745, 123, '2015-02-15 01:25:35.000000', 'consum', 0.0214, 'lps'),
	(402746, 123, '2015-02-15 01:25:36.000000', 'consum', 0.0213, 'lps'),
	(402747, 123, '2015-02-15 01:25:37.000000', 'consum', 0.0213, 'lps'),
	(402748, 123, '2015-02-15 01:25:38.000000', 'consum', 0.0218, 'lps'),
	(402749, 123, '2015-02-15 01:25:39.000000', 'consum', 0.0217, 'lps'),
	(402750, 123, '2015-02-15 01:25:40.000000', 'consum', 0.0211, 'lps'),
	(402751, 123, '2015-02-15 01:25:41.000000', 'consum', 0.0217, 'lps'),
	(402752, 123, '2015-02-15 01:25:42.000000', 'consum', 0.0220, 'lps'),
	(402753, 123, '2015-02-15 01:25:43.000000', 'consum', 0.0217, 'lps'),
	(402754, 123, '2015-02-15 01:25:44.000000', 'consum', 0.0217, 'lps'),
	(402755, 123, '2015-02-15 01:25:45.000000', 'consum', 0.0212, 'lps'),
	(402756, 123, '2015-02-15 01:25:46.000000', 'consum', 0.0212, 'lps'),
	(402757, 123, '2015-02-15 01:25:47.000000', 'consum', 0.0216, 'lps'),
	(402758, 123, '2015-02-15 01:25:48.000000', 'consum', 0.0210, 'lps'),
	(402759, 123, '2015-02-15 01:25:49.000000', 'consum', 0.0215, 'lps'),
	(402760, 123, '2015-02-15 01:25:50.000000', 'consum', 0.0214, 'lps'),
	(402761, 123, '2015-02-15 01:25:51.000000', 'consum', 0.0213, 'lps'),
	(402762, 123, '2015-02-15 01:25:52.000000', 'consum', 0.0217, 'lps'),
	(402763, 123, '2015-02-15 01:25:53.000000', 'consum', 0.0212, 'lps'),
	(402764, 123, '2015-02-15 01:25:54.000000', 'consum', 0.0211, 'lps'),
	(402765, 123, '2015-02-15 01:25:55.000000', 'consum', 0.0219, 'lps'),
	(402766, 123, '2015-02-15 01:25:56.000000', 'consum', 0.0219, 'lps'),
	(402767, 123, '2015-02-15 01:25:57.000000', 'consum', 0.0220, 'lps'),
	(402768, 123, '2015-02-15 01:25:58.000000', 'consum', 0.0210, 'lps'),
	(402769, 123, '2015-02-15 01:25:59.000000', 'consum', 0.0212, 'lps'),
	(402770, 123, '2015-02-15 01:26:00.000000', 'consum', 0.0213, 'lps'),
	(402771, 123, '2015-02-15 01:26:01.000000', 'consum', 0.0217, 'lps'),
	(402772, 123, '2015-02-15 01:26:02.000000', 'consum', 0.0216, 'lps'),
	(402773, 123, '2015-02-15 01:26:03.000000', 'consum', 0.0219, 'lps'),
	(402774, 123, '2015-02-15 01:26:04.000000', 'consum', 0.0218, 'lps'),
	(402775, 123, '2015-02-15 01:26:05.000000', 'consum', 0.0220, 'lps'),
	(402776, 123, '2015-02-15 01:26:06.000000', 'consum', 0.0215, 'lps'),
	(402777, 123, '2015-02-15 01:26:07.000000', 'consum', 0.0215, 'lps'),
	(402778, 123, '2015-02-15 01:26:08.000000', 'consum', 0.0211, 'lps'),
	(402779, 123, '2015-02-15 01:26:09.000000', 'consum', 0.0213, 'lps'),
	(402780, 123, '2015-02-15 01:26:10.000000', 'consum', 0.0211, 'lps'),
	(402781, 123, '2015-02-15 01:26:11.000000', 'consum', 0.0219, 'lps'),
	(402782, 123, '2015-02-15 01:26:12.000000', 'consum', 0.0218, 'lps'),
	(402783, 123, '2015-02-15 01:26:13.000000', 'consum', 0.0212, 'lps'),
	(402784, 123, '2015-02-15 01:26:14.000000', 'consum', 0.0218, 'lps'),
	(402785, 123, '2015-02-15 01:26:15.000000', 'consum', 0.0210, 'lps'),
	(402786, 123, '2015-02-15 01:26:16.000000', 'consum', 0.0211, 'lps'),
	(402787, 123, '2015-02-15 01:26:17.000000', 'consum', 0.0217, 'lps'),
	(402788, 123, '2015-02-15 01:26:18.000000', 'consum', 0.0218, 'lps'),
	(402789, 123, '2015-02-15 01:26:19.000000', 'consum', 0.0220, 'lps'),
	(402790, 123, '2015-02-15 01:26:20.000000', 'consum', 0.0212, 'lps'),
	(402791, 123, '2015-02-15 01:26:21.000000', 'consum', 0.0214, 'lps'),
	(402792, 123, '2015-02-15 01:26:22.000000', 'consum', 0.0215, 'lps'),
	(402793, 123, '2015-02-15 01:26:23.000000', 'consum', 0.0210, 'lps'),
	(402794, 123, '2015-02-15 01:26:24.000000', 'consum', 0.0218, 'lps'),
	(402795, 123, '2015-02-15 01:26:25.000000', 'consum', 0.0218, 'lps'),
	(402796, 123, '2015-02-15 01:26:26.000000', 'consum', 0.0215, 'lps'),
	(402797, 123, '2015-02-15 01:26:27.000000', 'consum', 0.0211, 'lps'),
	(402798, 123, '2015-02-15 01:26:28.000000', 'consum', 0.0211, 'lps'),
	(402799, 123, '2015-02-15 01:26:29.000000', 'consum', 0.0214, 'lps'),
	(402800, 123, '2015-02-15 01:26:30.000000', 'consum', 0.0214, 'lps'),
	(402801, 123, '2015-02-15 01:26:31.000000', 'consum', 0.0219, 'lps'),
	(402802, 123, '2015-02-15 01:26:32.000000', 'consum', 0.0213, 'lps'),
	(402803, 123, '2015-02-15 01:26:33.000000', 'consum', 0.0218, 'lps'),
	(402804, 123, '2015-02-15 01:26:34.000000', 'consum', 0.0219, 'lps'),
	(402805, 123, '2015-02-15 01:26:35.000000', 'consum', 0.0220, 'lps'),
	(402806, 123, '2015-02-15 01:26:36.000000', 'consum', 0.0212, 'lps'),
	(402807, 123, '2015-02-15 01:26:37.000000', 'consum', 0.0213, 'lps'),
	(402808, 123, '2015-02-15 01:26:38.000000', 'consum', 0.0217, 'lps'),
	(402809, 123, '2015-02-15 01:26:39.000000', 'consum', 0.0218, 'lps'),
	(402810, 123, '2015-02-15 01:26:40.000000', 'consum', 0.0216, 'lps'),
	(402811, 123, '2015-02-15 01:26:41.000000', 'consum', 0.0219, 'lps'),
	(402812, 123, '2015-02-15 01:26:42.000000', 'consum', 0.0214, 'lps'),
	(402813, 123, '2015-02-15 01:26:43.000000', 'consum', 0.0214, 'lps'),
	(402814, 123, '2015-02-15 01:26:44.000000', 'consum', 0.0220, 'lps'),
	(402815, 123, '2015-02-15 01:26:45.000000', 'consum', 0.0215, 'lps'),
	(402816, 123, '2015-02-15 01:26:46.000000', 'consum', 0.0216, 'lps'),
	(402817, 123, '2015-02-15 01:26:47.000000', 'consum', 0.0215, 'lps'),
	(402818, 123, '2015-02-15 01:26:48.000000', 'consum', 0.0219, 'lps'),
	(402819, 123, '2015-02-15 01:26:49.000000', 'consum', 0.0218, 'lps'),
	(402820, 123, '2015-02-15 01:26:50.000000', 'consum', 0.0213, 'lps'),
	(402821, 123, '2015-02-15 01:26:51.000000', 'consum', 0.0210, 'lps'),
	(402822, 123, '2015-02-15 01:26:52.000000', 'consum', 0.0215, 'lps'),
	(402823, 123, '2015-02-15 01:26:53.000000', 'consum', 0.0213, 'lps'),
	(402824, 123, '2015-02-15 01:26:54.000000', 'consum', 0.0210, 'lps'),
	(402825, 123, '2015-02-15 01:26:55.000000', 'consum', 0.0212, 'lps'),
	(402826, 123, '2015-02-15 01:26:56.000000', 'consum', 0.0210, 'lps'),
	(402827, 123, '2015-02-15 01:26:57.000000', 'consum', 0.0216, 'lps'),
	(402828, 123, '2015-02-15 01:26:58.000000', 'consum', 0.0216, 'lps'),
	(402829, 123, '2015-02-15 01:26:59.000000', 'consum', 0.0214, 'lps'),
	(402830, 123, '2015-02-15 01:27:00.000000', 'consum', 0.0211, 'lps'),
	(402831, 123, '2015-02-15 01:27:01.000000', 'consum', 0.0214, 'lps'),
	(402832, 123, '2015-02-15 01:27:02.000000', 'consum', 0.0218, 'lps'),
	(402833, 123, '2015-02-15 01:27:03.000000', 'consum', 0.0217, 'lps'),
	(402834, 123, '2015-02-15 01:27:04.000000', 'consum', 0.0219, 'lps'),
	(402835, 123, '2015-02-15 01:27:05.000000', 'consum', 0.0212, 'lps'),
	(402836, 123, '2015-02-15 01:27:06.000000', 'consum', 0.0219, 'lps'),
	(402837, 123, '2015-02-15 01:27:07.000000', 'consum', 0.0213, 'lps'),
	(402838, 123, '2015-02-15 01:27:08.000000', 'consum', 0.0213, 'lps'),
	(402839, 123, '2015-02-15 01:27:09.000000', 'consum', 0.0213, 'lps'),
	(402840, 123, '2015-02-15 01:27:10.000000', 'consum', 0.0220, 'lps'),
	(402841, 123, '2015-02-15 01:27:11.000000', 'consum', 0.0217, 'lps'),
	(402842, 123, '2015-02-15 01:27:12.000000', 'consum', 0.0215, 'lps'),
	(402843, 123, '2015-02-15 01:27:13.000000', 'consum', 0.0214, 'lps'),
	(402844, 123, '2015-02-15 01:27:14.000000', 'consum', 0.0216, 'lps'),
	(402845, 123, '2015-02-15 01:27:15.000000', 'consum', 0.0218, 'lps'),
	(402846, 123, '2015-02-15 01:27:16.000000', 'consum', 0.0220, 'lps'),
	(402847, 123, '2015-02-15 01:27:17.000000', 'consum', 0.0216, 'lps'),
	(402848, 123, '2015-02-15 01:27:18.000000', 'consum', 0.0220, 'lps'),
	(402849, 123, '2015-02-15 01:27:19.000000', 'consum', 0.0211, 'lps'),
	(402850, 123, '2015-02-15 01:27:20.000000', 'consum', 0.0218, 'lps'),
	(402851, 123, '2015-02-15 01:27:21.000000', 'consum', 0.0215, 'lps'),
	(402852, 123, '2015-02-15 01:27:22.000000', 'consum', 0.0211, 'lps'),
	(402853, 123, '2015-02-15 01:27:23.000000', 'consum', 0.0211, 'lps'),
	(402854, 123, '2015-02-15 01:27:24.000000', 'consum', 0.0214, 'lps'),
	(402855, 123, '2015-02-15 01:27:25.000000', 'consum', 0.0218, 'lps'),
	(402856, 123, '2015-02-15 01:27:26.000000', 'consum', 0.0214, 'lps'),
	(402857, 123, '2015-02-15 01:27:27.000000', 'consum', 0.0217, 'lps'),
	(402858, 123, '2015-02-15 01:27:28.000000', 'consum', 0.0211, 'lps'),
	(402859, 123, '2015-02-15 01:27:29.000000', 'consum', 0.0216, 'lps'),
	(402860, 123, '2015-02-15 01:27:30.000000', 'consum', 0.0218, 'lps'),
	(402861, 123, '2015-02-15 01:27:31.000000', 'consum', 0.0210, 'lps'),
	(402862, 123, '2015-02-15 01:27:32.000000', 'consum', 0.0220, 'lps'),
	(402863, 123, '2015-02-15 01:27:33.000000', 'consum', 0.0215, 'lps'),
	(402864, 123, '2015-02-15 01:27:34.000000', 'consum', 0.0219, 'lps'),
	(402865, 123, '2015-02-15 01:27:35.000000', 'consum', 0.0218, 'lps'),
	(402866, 123, '2015-02-15 01:27:36.000000', 'consum', 0.0210, 'lps'),
	(402867, 123, '2015-02-15 01:27:37.000000', 'consum', 0.0211, 'lps'),
	(402868, 123, '2015-02-15 01:27:38.000000', 'consum', 0.0213, 'lps'),
	(402869, 123, '2015-02-15 01:27:39.000000', 'consum', 0.0212, 'lps'),
	(402870, 123, '2015-02-15 01:27:40.000000', 'consum', 0.0211, 'lps'),
	(402871, 123, '2015-02-15 01:27:41.000000', 'consum', 0.0220, 'lps'),
	(402872, 123, '2015-02-15 01:27:42.000000', 'consum', 0.0214, 'lps'),
	(402873, 123, '2015-02-15 01:27:43.000000', 'consum', 0.0213, 'lps'),
	(402874, 123, '2015-02-15 01:27:44.000000', 'consum', 0.0213, 'lps'),
	(402875, 123, '2015-02-15 01:27:45.000000', 'consum', 0.0217, 'lps'),
	(402876, 123, '2015-02-15 01:27:46.000000', 'consum', 0.0215, 'lps'),
	(402877, 123, '2015-02-15 01:27:47.000000', 'consum', 0.0214, 'lps'),
	(402878, 123, '2015-02-15 01:27:48.000000', 'consum', 0.0217, 'lps'),
	(402879, 123, '2015-02-15 01:27:49.000000', 'consum', 0.0220, 'lps'),
	(402880, 123, '2015-02-15 01:27:50.000000', 'consum', 0.0220, 'lps'),
	(402881, 123, '2015-02-15 01:27:51.000000', 'consum', 0.0219, 'lps'),
	(402882, 123, '2015-02-15 01:27:52.000000', 'consum', 0.0215, 'lps'),
	(402883, 123, '2015-02-15 01:27:53.000000', 'consum', 0.0220, 'lps'),
	(402884, 123, '2015-02-15 01:27:54.000000', 'consum', 0.0213, 'lps'),
	(402885, 123, '2015-02-15 01:27:55.000000', 'consum', 0.0215, 'lps'),
	(402886, 123, '2015-02-15 01:27:56.000000', 'consum', 0.0218, 'lps'),
	(402887, 123, '2015-02-15 01:27:57.000000', 'consum', 0.0214, 'lps'),
	(402888, 123, '2015-02-15 01:27:58.000000', 'consum', 0.0217, 'lps'),
	(402889, 123, '2015-02-15 01:27:59.000000', 'consum', 0.0213, 'lps'),
	(402890, 123, '2015-02-15 01:28:00.000000', 'consum', 0.0215, 'lps'),
	(402891, 123, '2015-02-15 01:28:01.000000', 'consum', 0.0216, 'lps'),
	(402892, 123, '2015-02-15 01:28:02.000000', 'consum', 0.0212, 'lps'),
	(402893, 123, '2015-02-15 01:28:03.000000', 'consum', 0.0213, 'lps'),
	(402894, 123, '2015-02-15 01:28:04.000000', 'consum', 0.0210, 'lps'),
	(402895, 123, '2015-02-15 01:28:05.000000', 'consum', 0.0214, 'lps'),
	(402896, 123, '2015-02-15 01:28:06.000000', 'consum', 0.0217, 'lps'),
	(402897, 123, '2015-02-15 01:28:07.000000', 'consum', 0.0212, 'lps'),
	(402898, 123, '2015-02-15 01:28:08.000000', 'consum', 0.0213, 'lps'),
	(402899, 123, '2015-02-15 01:28:09.000000', 'consum', 0.0216, 'lps'),
	(402900, 123, '2015-02-15 01:28:10.000000', 'consum', 0.0212, 'lps'),
	(402901, 123, '2015-02-15 01:28:11.000000', 'consum', 0.0214, 'lps'),
	(402902, 123, '2015-02-15 01:28:12.000000', 'consum', 0.0212, 'lps'),
	(402903, 123, '2015-02-15 01:28:13.000000', 'consum', 0.0219, 'lps'),
	(402904, 123, '2015-02-15 01:28:14.000000', 'consum', 0.0215, 'lps'),
	(402905, 123, '2015-02-15 01:28:15.000000', 'consum', 0.0210, 'lps'),
	(402906, 123, '2015-02-15 01:28:16.000000', 'consum', 0.0218, 'lps'),
	(402907, 123, '2015-02-15 01:28:17.000000', 'consum', 0.0218, 'lps'),
	(402908, 123, '2015-02-15 01:28:18.000000', 'consum', 0.0214, 'lps'),
	(402909, 123, '2015-02-15 01:28:19.000000', 'consum', 0.0219, 'lps'),
	(402910, 123, '2015-02-15 01:28:20.000000', 'consum', 0.0212, 'lps'),
	(402911, 123, '2015-02-15 01:28:21.000000', 'consum', 0.0213, 'lps'),
	(402912, 123, '2015-02-15 01:28:22.000000', 'consum', 0.0219, 'lps'),
	(402913, 123, '2015-02-15 01:28:23.000000', 'consum', 0.0214, 'lps'),
	(402914, 123, '2015-02-15 01:28:24.000000', 'consum', 0.0213, 'lps'),
	(402915, 123, '2015-02-15 01:28:25.000000', 'consum', 0.0217, 'lps'),
	(402916, 123, '2015-02-15 01:28:26.000000', 'consum', 0.0212, 'lps'),
	(402917, 123, '2015-02-15 01:28:27.000000', 'consum', 0.0211, 'lps'),
	(402918, 123, '2015-02-15 01:28:28.000000', 'consum', 0.0212, 'lps'),
	(402919, 123, '2015-02-15 01:28:29.000000', 'consum', 0.0214, 'lps'),
	(402920, 123, '2015-02-15 01:28:30.000000', 'consum', 0.0215, 'lps'),
	(402921, 123, '2015-02-15 01:28:31.000000', 'consum', 0.0211, 'lps'),
	(402922, 124, '2015-02-15 00:00:00.000000', 'consum', 0.0214, 'lps'),
	(402923, 124, '2015-02-15 00:00:01.000000', 'consum', 0.0221, 'lps'),
	(402924, 124, '2015-02-15 00:00:02.000000', 'consum', 0.0214, 'lps'),
	(402925, 124, '2015-02-15 00:00:03.000000', 'consum', 0.0212, 'lps'),
	(402926, 124, '2015-02-15 00:00:04.000000', 'consum', 0.0210, 'lps'),
	(402927, 124, '2015-02-15 00:00:05.000000', 'consum', 0.0214, 'lps'),
	(402928, 124, '2015-02-15 00:00:06.000000', 'consum', 0.0219, 'lps'),
	(402929, 124, '2015-02-15 00:00:07.000000', 'consum', 0.0220, 'lps'),
	(402930, 124, '2015-02-15 00:00:08.000000', 'consum', 0.0221, 'lps'),
	(402931, 124, '2015-02-15 00:00:09.000000', 'consum', 0.0211, 'lps'),
	(402932, 124, '2015-02-15 00:00:10.000000', 'consum', 0.0220, 'lps'),
	(402933, 124, '2015-02-15 00:00:11.000000', 'consum', 0.0211, 'lps'),
	(402934, 124, '2015-02-15 00:00:12.000000', 'consum', 0.0219, 'lps'),
	(402935, 124, '2015-02-15 00:00:13.000000', 'consum', 0.0218, 'lps'),
	(402936, 124, '2015-02-15 00:00:14.000000', 'consum', 0.0211, 'lps'),
	(402937, 124, '2015-02-15 00:00:15.000000', 'consum', 0.0217, 'lps'),
	(402938, 124, '2015-02-15 00:00:16.000000', 'consum', 0.0218, 'lps'),
	(402939, 124, '2015-02-15 00:00:17.000000', 'consum', 0.0218, 'lps'),
	(402940, 124, '2015-02-15 00:00:18.000000', 'consum', 0.0214, 'lps'),
	(402941, 124, '2015-02-15 00:00:19.000000', 'consum', 0.0219, 'lps'),
	(402942, 124, '2015-02-15 00:00:20.000000', 'consum', 0.0220, 'lps'),
	(402943, 124, '2015-02-15 00:00:21.000000', 'consum', 0.0210, 'lps'),
	(402944, 124, '2015-02-15 00:00:22.000000', 'consum', 0.0216, 'lps'),
	(402945, 124, '2015-02-15 00:00:23.000000', 'consum', 0.0216, 'lps'),
	(402946, 124, '2015-02-15 00:00:24.000000', 'consum', 0.0221, 'lps'),
	(402947, 124, '2015-02-15 00:00:25.000000', 'consum', 0.0212, 'lps'),
	(402948, 124, '2015-02-15 00:00:26.000000', 'consum', 0.0211, 'lps'),
	(402949, 124, '2015-02-15 00:00:27.000000', 'consum', 0.0212, 'lps'),
	(402950, 124, '2015-02-15 00:00:28.000000', 'consum', 0.0216, 'lps'),
	(402951, 124, '2015-02-15 00:00:29.000000', 'consum', 0.0212, 'lps'),
	(402952, 124, '2015-02-15 00:00:30.000000', 'consum', 0.0212, 'lps'),
	(402953, 124, '2015-02-15 00:00:31.000000', 'consum', 0.0214, 'lps'),
	(402954, 124, '2015-02-15 00:00:32.000000', 'consum', 0.0214, 'lps'),
	(402955, 124, '2015-02-15 00:00:33.000000', 'consum', 0.0217, 'lps'),
	(402956, 124, '2015-02-15 00:00:34.000000', 'consum', 0.0212, 'lps'),
	(402957, 124, '2015-02-15 00:00:35.000000', 'consum', 0.0221, 'lps'),
	(402958, 124, '2015-02-15 00:00:36.000000', 'consum', 0.0211, 'lps'),
	(402959, 124, '2015-02-15 00:00:37.000000', 'consum', 0.0218, 'lps'),
	(402960, 124, '2015-02-15 00:00:38.000000', 'consum', 0.0211, 'lps'),
	(402961, 124, '2015-02-15 00:00:39.000000', 'consum', 0.0218, 'lps'),
	(402962, 124, '2015-02-15 00:00:40.000000', 'consum', 0.0212, 'lps'),
	(402963, 124, '2015-02-15 00:00:41.000000', 'consum', 0.0221, 'lps'),
	(402964, 124, '2015-02-15 00:00:42.000000', 'consum', 0.0213, 'lps'),
	(402965, 124, '2015-02-15 00:00:43.000000', 'consum', 0.0213, 'lps'),
	(402966, 124, '2015-02-15 00:00:44.000000', 'consum', 0.0216, 'lps'),
	(402967, 124, '2015-02-15 00:00:45.000000', 'consum', 0.0221, 'lps'),
	(402968, 124, '2015-02-15 00:00:46.000000', 'consum', 0.0211, 'lps'),
	(402969, 124, '2015-02-15 00:00:47.000000', 'consum', 0.0218, 'lps'),
	(402970, 124, '2015-02-15 00:00:48.000000', 'consum', 0.0213, 'lps'),
	(402971, 124, '2015-02-15 00:00:49.000000', 'consum', 0.0215, 'lps'),
	(402972, 124, '2015-02-15 00:00:50.000000', 'consum', 0.0211, 'lps'),
	(402973, 124, '2015-02-15 00:00:51.000000', 'consum', 0.0214, 'lps'),
	(402974, 124, '2015-02-15 00:00:52.000000', 'consum', 0.0216, 'lps'),
	(402975, 124, '2015-02-15 00:00:53.000000', 'consum', 0.0217, 'lps'),
	(402976, 124, '2015-02-15 00:00:54.000000', 'consum', 0.0216, 'lps'),
	(402977, 124, '2015-02-15 00:00:55.000000', 'consum', 0.0219, 'lps'),
	(402978, 124, '2015-02-15 00:00:56.000000', 'consum', 0.0212, 'lps'),
	(402979, 124, '2015-02-15 00:00:57.000000', 'consum', 0.0217, 'lps'),
	(402980, 124, '2015-02-15 00:00:58.000000', 'consum', 0.0217, 'lps'),
	(402981, 124, '2015-02-15 00:00:59.000000', 'consum', 0.0211, 'lps'),
	(402982, 124, '2015-02-15 00:01:00.000000', 'consum', 0.0220, 'lps'),
	(402983, 124, '2015-02-15 00:01:01.000000', 'consum', 0.0211, 'lps'),
	(402984, 124, '2015-02-15 00:01:02.000000', 'consum', 0.0218, 'lps'),
	(402985, 124, '2015-02-15 00:01:03.000000', 'consum', 0.0214, 'lps'),
	(402986, 124, '2015-02-15 00:01:04.000000', 'consum', 0.0217, 'lps'),
	(402987, 124, '2015-02-15 00:01:05.000000', 'consum', 0.0210, 'lps'),
	(402988, 124, '2015-02-15 00:01:06.000000', 'consum', 0.0213, 'lps'),
	(402989, 124, '2015-02-15 00:01:07.000000', 'consum', 0.0214, 'lps'),
	(402990, 124, '2015-02-15 00:01:08.000000', 'consum', 0.0220, 'lps'),
	(402991, 124, '2015-02-15 00:01:09.000000', 'consum', 0.0214, 'lps'),
	(402992, 124, '2015-02-15 00:01:10.000000', 'consum', 0.0214, 'lps'),
	(402993, 124, '2015-02-15 00:01:11.000000', 'consum', 0.0216, 'lps'),
	(402994, 124, '2015-02-15 00:01:12.000000', 'consum', 0.0217, 'lps'),
	(402995, 124, '2015-02-15 00:01:13.000000', 'consum', 0.0218, 'lps'),
	(402996, 124, '2015-02-15 00:01:14.000000', 'consum', 0.0214, 'lps'),
	(402997, 124, '2015-02-15 00:01:15.000000', 'consum', 0.0220, 'lps'),
	(402998, 124, '2015-02-15 00:01:16.000000', 'consum', 0.0212, 'lps'),
	(402999, 124, '2015-02-15 00:01:17.000000', 'consum', 0.0213, 'lps'),
	(403000, 124, '2015-02-15 00:01:18.000000', 'consum', 0.0221, 'lps'),
	(403001, 124, '2015-02-15 00:01:19.000000', 'consum', 0.0210, 'lps'),
	(403002, 124, '2015-02-15 00:01:20.000000', 'consum', 0.0212, 'lps'),
	(403003, 124, '2015-02-15 00:01:21.000000', 'consum', 0.0220, 'lps'),
	(403004, 124, '2015-02-15 00:01:22.000000', 'consum', 0.0221, 'lps'),
	(403005, 124, '2015-02-15 00:01:23.000000', 'consum', 0.0221, 'lps'),
	(403006, 124, '2015-02-15 00:01:24.000000', 'consum', 0.0220, 'lps'),
	(403007, 124, '2015-02-15 00:01:25.000000', 'consum', 0.0215, 'lps'),
	(403008, 124, '2015-02-15 00:01:26.000000', 'consum', 0.0219, 'lps'),
	(403009, 124, '2015-02-15 00:01:27.000000', 'consum', 0.0217, 'lps'),
	(403010, 124, '2015-02-15 00:01:28.000000', 'consum', 0.0216, 'lps'),
	(403011, 124, '2015-02-15 00:01:29.000000', 'consum', 0.0221, 'lps'),
	(403012, 124, '2015-02-15 00:01:30.000000', 'consum', 0.0213, 'lps'),
	(403013, 124, '2015-02-15 00:01:31.000000', 'consum', 0.0215, 'lps'),
	(403014, 124, '2015-02-15 00:01:32.000000', 'consum', 0.0213, 'lps'),
	(403015, 124, '2015-02-15 00:01:33.000000', 'consum', 0.0211, 'lps'),
	(403016, 124, '2015-02-15 00:01:34.000000', 'consum', 0.0218, 'lps'),
	(403017, 124, '2015-02-15 00:01:35.000000', 'consum', 0.0213, 'lps'),
	(403018, 124, '2015-02-15 00:01:36.000000', 'consum', 0.0213, 'lps'),
	(403019, 124, '2015-02-15 00:01:37.000000', 'consum', 0.0217, 'lps'),
	(403020, 124, '2015-02-15 00:01:38.000000', 'consum', 0.0214, 'lps'),
	(403021, 124, '2015-02-15 00:01:39.000000', 'consum', 0.0219, 'lps'),
	(403022, 124, '2015-02-15 00:01:40.000000', 'consum', 0.0210, 'lps'),
	(403023, 124, '2015-02-15 00:01:41.000000', 'consum', 0.0220, 'lps'),
	(403024, 124, '2015-02-15 00:01:42.000000', 'consum', 0.0211, 'lps'),
	(403025, 124, '2015-02-15 00:01:43.000000', 'consum', 0.0210, 'lps'),
	(403026, 124, '2015-02-15 00:01:44.000000', 'consum', 0.0218, 'lps'),
	(403027, 124, '2015-02-15 00:01:45.000000', 'consum', 0.0215, 'lps'),
	(403028, 124, '2015-02-15 00:01:46.000000', 'consum', 0.0211, 'lps'),
	(403029, 124, '2015-02-15 00:01:47.000000', 'consum', 0.0212, 'lps'),
	(403030, 124, '2015-02-15 00:01:48.000000', 'consum', 0.0218, 'lps'),
	(403031, 124, '2015-02-15 00:01:49.000000', 'consum', 0.0221, 'lps'),
	(403032, 124, '2015-02-15 00:01:50.000000', 'consum', 0.0216, 'lps'),
	(403033, 124, '2015-02-15 00:01:51.000000', 'consum', 0.0210, 'lps'),
	(403034, 124, '2015-02-15 00:01:52.000000', 'consum', 0.0214, 'lps'),
	(403035, 124, '2015-02-15 00:01:53.000000', 'consum', 0.0221, 'lps'),
	(403036, 124, '2015-02-15 00:01:54.000000', 'consum', 0.0215, 'lps'),
	(403037, 124, '2015-02-15 00:01:55.000000', 'consum', 0.0214, 'lps'),
	(403038, 124, '2015-02-15 00:01:56.000000', 'consum', 0.0216, 'lps'),
	(403039, 124, '2015-02-15 00:01:57.000000', 'consum', 0.0219, 'lps'),
	(403040, 124, '2015-02-15 00:01:58.000000', 'consum', 0.0212, 'lps'),
	(403041, 124, '2015-02-15 00:01:59.000000', 'consum', 0.0216, 'lps'),
	(403042, 124, '2015-02-15 00:02:00.000000', 'consum', 0.0214, 'lps'),
	(403043, 124, '2015-02-15 00:02:01.000000', 'consum', 0.0221, 'lps'),
	(403044, 124, '2015-02-15 00:02:02.000000', 'consum', 0.0220, 'lps'),
	(403045, 124, '2015-02-15 00:02:03.000000', 'consum', 0.0216, 'lps'),
	(403046, 124, '2015-02-15 00:02:04.000000', 'consum', 0.0221, 'lps'),
	(403047, 124, '2015-02-15 00:02:05.000000', 'consum', 0.0212, 'lps'),
	(403048, 124, '2015-02-15 00:02:06.000000', 'consum', 0.0211, 'lps'),
	(403049, 124, '2015-02-15 00:02:07.000000', 'consum', 0.0210, 'lps'),
	(403050, 124, '2015-02-15 00:02:08.000000', 'consum', 0.0217, 'lps'),
	(403051, 124, '2015-02-15 00:02:09.000000', 'consum', 0.0213, 'lps'),
	(403052, 124, '2015-02-15 00:02:10.000000', 'consum', 0.0216, 'lps'),
	(403053, 124, '2015-02-15 00:02:11.000000', 'consum', 0.0220, 'lps'),
	(403054, 124, '2015-02-15 00:02:12.000000', 'consum', 0.0220, 'lps'),
	(403055, 124, '2015-02-15 00:02:13.000000', 'consum', 0.0216, 'lps'),
	(403056, 124, '2015-02-15 00:02:14.000000', 'consum', 0.0212, 'lps'),
	(403057, 124, '2015-02-15 00:02:15.000000', 'consum', 0.0213, 'lps'),
	(403058, 124, '2015-02-15 00:02:16.000000', 'consum', 0.0219, 'lps'),
	(403059, 124, '2015-02-15 00:02:17.000000', 'consum', 0.0211, 'lps'),
	(403060, 124, '2015-02-15 00:02:18.000000', 'consum', 0.0212, 'lps'),
	(403061, 124, '2015-02-15 00:02:19.000000', 'consum', 0.0218, 'lps'),
	(403062, 124, '2015-02-15 00:02:20.000000', 'consum', 0.0219, 'lps'),
	(403063, 124, '2015-02-15 00:02:21.000000', 'consum', 0.0221, 'lps'),
	(403064, 124, '2015-02-15 00:02:22.000000', 'consum', 0.0216, 'lps'),
	(403065, 124, '2015-02-15 00:02:23.000000', 'consum', 0.0220, 'lps'),
	(403066, 124, '2015-02-15 00:02:24.000000', 'consum', 0.0215, 'lps'),
	(403067, 124, '2015-02-15 00:02:25.000000', 'consum', 0.0220, 'lps'),
	(403068, 124, '2015-02-15 00:02:26.000000', 'consum', 0.0210, 'lps'),
	(403069, 124, '2015-02-15 00:02:27.000000', 'consum', 0.0216, 'lps'),
	(403070, 124, '2015-02-15 00:02:28.000000', 'consum', 0.0216, 'lps'),
	(403071, 124, '2015-02-15 00:02:29.000000', 'consum', 0.0213, 'lps'),
	(403072, 124, '2015-02-15 00:02:30.000000', 'consum', 0.0216, 'lps'),
	(403073, 124, '2015-02-15 00:02:31.000000', 'consum', 0.0210, 'lps'),
	(403074, 124, '2015-02-15 00:02:32.000000', 'consum', 0.0216, 'lps'),
	(403075, 124, '2015-02-15 00:02:33.000000', 'consum', 0.0215, 'lps'),
	(403076, 124, '2015-02-15 00:02:34.000000', 'consum', 0.0218, 'lps'),
	(403077, 124, '2015-02-15 00:02:35.000000', 'consum', 0.0212, 'lps'),
	(403078, 124, '2015-02-15 00:02:36.000000', 'consum', 0.0219, 'lps'),
	(403079, 124, '2015-02-15 00:02:37.000000', 'consum', 0.0213, 'lps'),
	(403080, 124, '2015-02-15 00:02:38.000000', 'consum', 0.0210, 'lps'),
	(403081, 124, '2015-02-15 00:02:39.000000', 'consum', 0.0215, 'lps'),
	(403082, 124, '2015-02-15 00:02:40.000000', 'consum', 0.0212, 'lps'),
	(403083, 124, '2015-02-15 00:02:41.000000', 'consum', 0.0217, 'lps'),
	(403084, 124, '2015-02-15 00:02:42.000000', 'consum', 0.0215, 'lps'),
	(403085, 124, '2015-02-15 00:02:43.000000', 'consum', 0.0215, 'lps'),
	(403086, 124, '2015-02-15 00:02:44.000000', 'consum', 0.0218, 'lps'),
	(403087, 124, '2015-02-15 00:02:45.000000', 'consum', 0.0215, 'lps'),
	(403088, 124, '2015-02-15 00:02:46.000000', 'consum', 0.0210, 'lps'),
	(403089, 124, '2015-02-15 00:02:47.000000', 'consum', 0.0219, 'lps'),
	(403090, 124, '2015-02-15 00:02:48.000000', 'consum', 0.0220, 'lps'),
	(403091, 124, '2015-02-15 00:02:49.000000', 'consum', 0.0221, 'lps'),
	(403092, 124, '2015-02-15 00:02:50.000000', 'consum', 0.0212, 'lps'),
	(403093, 124, '2015-02-15 00:02:51.000000', 'consum', 0.0211, 'lps'),
	(403094, 124, '2015-02-15 00:02:52.000000', 'consum', 0.0212, 'lps'),
	(403095, 124, '2015-02-15 00:02:53.000000', 'consum', 0.0215, 'lps'),
	(403096, 124, '2015-02-15 00:02:54.000000', 'consum', 0.0217, 'lps'),
	(403097, 124, '2015-02-15 00:02:55.000000', 'consum', 0.0219, 'lps'),
	(403098, 124, '2015-02-15 00:02:56.000000', 'consum', 0.0210, 'lps'),
	(403099, 124, '2015-02-15 00:02:57.000000', 'consum', 0.0218, 'lps'),
	(403100, 124, '2015-02-15 00:02:58.000000', 'consum', 0.0217, 'lps'),
	(403101, 124, '2015-02-15 00:02:59.000000', 'consum', 0.0220, 'lps'),
	(403102, 124, '2015-02-15 00:03:00.000000', 'consum', 0.0217, 'lps'),
	(403103, 124, '2015-02-15 00:03:01.000000', 'consum', 0.0217, 'lps'),
	(403104, 124, '2015-02-15 00:03:02.000000', 'consum', 0.0221, 'lps'),
	(403105, 124, '2015-02-15 00:03:03.000000', 'consum', 0.0210, 'lps'),
	(403106, 124, '2015-02-15 00:03:04.000000', 'consum', 0.0214, 'lps'),
	(403107, 124, '2015-02-15 00:03:05.000000', 'consum', 0.0218, 'lps'),
	(403108, 124, '2015-02-15 00:03:06.000000', 'consum', 0.0216, 'lps'),
	(403109, 124, '2015-02-15 00:03:07.000000', 'consum', 0.0217, 'lps'),
	(403110, 124, '2015-02-15 00:03:08.000000', 'consum', 0.0214, 'lps'),
	(403111, 124, '2015-02-15 00:03:09.000000', 'consum', 0.0212, 'lps'),
	(403112, 124, '2015-02-15 00:03:10.000000', 'consum', 0.0217, 'lps'),
	(403113, 124, '2015-02-15 00:03:11.000000', 'consum', 0.0217, 'lps'),
	(403114, 124, '2015-02-15 00:03:12.000000', 'consum', 0.0211, 'lps'),
	(403115, 124, '2015-02-15 00:03:13.000000', 'consum', 0.0219, 'lps'),
	(403116, 124, '2015-02-15 00:03:14.000000', 'consum', 0.0215, 'lps'),
	(403117, 124, '2015-02-15 00:03:15.000000', 'consum', 0.0212, 'lps'),
	(403118, 124, '2015-02-15 00:03:16.000000', 'consum', 0.0216, 'lps'),
	(403119, 124, '2015-02-15 00:03:17.000000', 'consum', 0.0221, 'lps'),
	(403120, 124, '2015-02-15 00:03:18.000000', 'consum', 0.0212, 'lps'),
	(403121, 124, '2015-02-15 00:03:19.000000', 'consum', 0.0213, 'lps'),
	(403122, 124, '2015-02-15 00:03:20.000000', 'consum', 0.0217, 'lps'),
	(403123, 124, '2015-02-15 00:03:21.000000', 'consum', 0.0214, 'lps'),
	(403124, 124, '2015-02-15 00:03:22.000000', 'consum', 0.0221, 'lps'),
	(403125, 124, '2015-02-15 00:03:23.000000', 'consum', 0.0218, 'lps'),
	(403126, 124, '2015-02-15 00:03:24.000000', 'consum', 0.0217, 'lps'),
	(403127, 124, '2015-02-15 00:03:25.000000', 'consum', 0.0220, 'lps'),
	(403128, 124, '2015-02-15 00:03:26.000000', 'consum', 0.0218, 'lps'),
	(403129, 124, '2015-02-15 00:03:27.000000', 'consum', 0.0210, 'lps'),
	(403130, 124, '2015-02-15 00:03:28.000000', 'consum', 0.0219, 'lps'),
	(403131, 124, '2015-02-15 00:03:29.000000', 'consum', 0.0220, 'lps'),
	(403132, 124, '2015-02-15 00:03:30.000000', 'consum', 0.0221, 'lps'),
	(403133, 124, '2015-02-15 00:03:31.000000', 'consum', 0.0213, 'lps'),
	(403134, 124, '2015-02-15 00:03:32.000000', 'consum', 0.0217, 'lps'),
	(403135, 124, '2015-02-15 00:03:33.000000', 'consum', 0.0210, 'lps'),
	(403136, 124, '2015-02-15 00:03:34.000000', 'consum', 0.0215, 'lps'),
	(403137, 124, '2015-02-15 00:03:35.000000', 'consum', 0.0210, 'lps'),
	(403138, 124, '2015-02-15 00:03:36.000000', 'consum', 0.0221, 'lps'),
	(403139, 124, '2015-02-15 00:03:37.000000', 'consum', 0.0219, 'lps'),
	(403140, 124, '2015-02-15 00:03:38.000000', 'consum', 0.0219, 'lps'),
	(403141, 124, '2015-02-15 00:03:39.000000', 'consum', 0.0218, 'lps'),
	(403142, 124, '2015-02-15 00:03:40.000000', 'consum', 0.0213, 'lps'),
	(403143, 124, '2015-02-15 00:03:41.000000', 'consum', 0.0214, 'lps'),
	(403144, 124, '2015-02-15 00:03:42.000000', 'consum', 0.0210, 'lps'),
	(403145, 124, '2015-02-15 00:03:43.000000', 'consum', 0.0210, 'lps'),
	(403146, 124, '2015-02-15 00:03:44.000000', 'consum', 0.0212, 'lps'),
	(403147, 124, '2015-02-15 00:03:45.000000', 'consum', 0.0220, 'lps'),
	(403148, 124, '2015-02-15 00:03:46.000000', 'consum', 0.0218, 'lps'),
	(403149, 124, '2015-02-15 00:03:47.000000', 'consum', 0.0210, 'lps'),
	(403150, 124, '2015-02-15 00:03:48.000000', 'consum', 0.0220, 'lps'),
	(403151, 124, '2015-02-15 00:03:49.000000', 'consum', 0.0212, 'lps'),
	(403152, 124, '2015-02-15 00:03:50.000000', 'consum', 0.0214, 'lps'),
	(403153, 124, '2015-02-15 00:03:51.000000', 'consum', 0.0212, 'lps'),
	(403154, 124, '2015-02-15 00:03:52.000000', 'consum', 0.0212, 'lps'),
	(403155, 124, '2015-02-15 00:03:53.000000', 'consum', 0.0211, 'lps'),
	(403156, 124, '2015-02-15 00:03:54.000000', 'consum', 0.0211, 'lps'),
	(403157, 124, '2015-02-15 00:03:55.000000', 'consum', 0.0211, 'lps'),
	(403158, 124, '2015-02-15 00:03:56.000000', 'consum', 0.0214, 'lps'),
	(403159, 124, '2015-02-15 00:03:57.000000', 'consum', 0.0217, 'lps'),
	(403160, 124, '2015-02-15 00:03:58.000000', 'consum', 0.0221, 'lps'),
	(403161, 124, '2015-02-15 00:03:59.000000', 'consum', 0.0220, 'lps'),
	(403162, 124, '2015-02-15 00:04:00.000000', 'consum', 0.0215, 'lps'),
	(403163, 124, '2015-02-15 00:04:01.000000', 'consum', 0.0216, 'lps'),
	(403164, 124, '2015-02-15 00:04:02.000000', 'consum', 0.0215, 'lps'),
	(403165, 124, '2015-02-15 00:04:03.000000', 'consum', 0.0216, 'lps'),
	(403166, 124, '2015-02-15 00:04:04.000000', 'consum', 0.0216, 'lps'),
	(403167, 124, '2015-02-15 00:04:05.000000', 'consum', 0.0211, 'lps'),
	(403168, 124, '2015-02-15 00:04:06.000000', 'consum', 0.0221, 'lps'),
	(403169, 124, '2015-02-15 00:04:07.000000', 'consum', 0.0215, 'lps'),
	(403170, 124, '2015-02-15 00:04:08.000000', 'consum', 0.0216, 'lps'),
	(403171, 124, '2015-02-15 00:04:09.000000', 'consum', 0.0210, 'lps'),
	(403172, 124, '2015-02-15 00:04:10.000000', 'consum', 0.0218, 'lps'),
	(403173, 124, '2015-02-15 00:04:11.000000', 'consum', 0.0216, 'lps'),
	(403174, 124, '2015-02-15 00:04:12.000000', 'consum', 0.0217, 'lps'),
	(403175, 124, '2015-02-15 00:04:13.000000', 'consum', 0.0216, 'lps'),
	(403176, 124, '2015-02-15 00:04:14.000000', 'consum', 0.0217, 'lps'),
	(403177, 124, '2015-02-15 00:04:15.000000', 'consum', 0.0217, 'lps'),
	(403178, 124, '2015-02-15 00:04:16.000000', 'consum', 0.0212, 'lps'),
	(403179, 124, '2015-02-15 00:04:17.000000', 'consum', 0.0211, 'lps'),
	(403180, 124, '2015-02-15 00:04:18.000000', 'consum', 0.0211, 'lps'),
	(403181, 124, '2015-02-15 00:04:19.000000', 'consum', 0.0210, 'lps'),
	(403182, 124, '2015-02-15 00:04:20.000000', 'consum', 0.0221, 'lps'),
	(403183, 124, '2015-02-15 00:04:21.000000', 'consum', 0.0218, 'lps'),
	(403184, 124, '2015-02-15 00:04:22.000000', 'consum', 0.0218, 'lps'),
	(403185, 124, '2015-02-15 00:04:23.000000', 'consum', 0.0213, 'lps'),
	(403186, 124, '2015-02-15 00:04:24.000000', 'consum', 0.0215, 'lps'),
	(403187, 124, '2015-02-15 00:04:25.000000', 'consum', 0.0215, 'lps'),
	(403188, 124, '2015-02-15 00:04:26.000000', 'consum', 0.0219, 'lps'),
	(403189, 124, '2015-02-15 00:04:27.000000', 'consum', 0.0217, 'lps'),
	(403190, 124, '2015-02-15 00:04:28.000000', 'consum', 0.0217, 'lps'),
	(403191, 124, '2015-02-15 00:04:29.000000', 'consum', 0.0215, 'lps'),
	(403192, 124, '2015-02-15 00:04:30.000000', 'consum', 0.0212, 'lps'),
	(403193, 124, '2015-02-15 00:04:31.000000', 'consum', 0.0217, 'lps'),
	(403194, 124, '2015-02-15 00:04:32.000000', 'consum', 0.0216, 'lps'),
	(403195, 124, '2015-02-15 00:04:33.000000', 'consum', 0.0210, 'lps'),
	(403196, 124, '2015-02-15 00:04:34.000000', 'consum', 0.0215, 'lps'),
	(403197, 124, '2015-02-15 00:04:35.000000', 'consum', 0.0210, 'lps'),
	(403198, 124, '2015-02-15 00:04:36.000000', 'consum', 0.0211, 'lps'),
	(403199, 124, '2015-02-15 00:04:37.000000', 'consum', 0.0212, 'lps'),
	(403200, 124, '2015-02-15 00:04:38.000000', 'consum', 0.0218, 'lps'),
	(403201, 124, '2015-02-15 00:04:39.000000', 'consum', 0.0211, 'lps'),
	(403202, 124, '2015-02-15 00:04:40.000000', 'consum', 0.0214, 'lps'),
	(403203, 124, '2015-02-15 00:04:41.000000', 'consum', 0.0216, 'lps'),
	(403204, 124, '2015-02-15 00:04:42.000000', 'consum', 0.0218, 'lps'),
	(403205, 124, '2015-02-15 00:04:43.000000', 'consum', 0.0221, 'lps'),
	(403206, 124, '2015-02-15 00:04:44.000000', 'consum', 0.0214, 'lps'),
	(403207, 124, '2015-02-15 00:04:45.000000', 'consum', 0.0212, 'lps'),
	(403208, 124, '2015-02-15 00:04:46.000000', 'consum', 0.0220, 'lps'),
	(403209, 124, '2015-02-15 00:04:47.000000', 'consum', 0.0220, 'lps'),
	(403210, 124, '2015-02-15 00:04:48.000000', 'consum', 0.0219, 'lps'),
	(403211, 124, '2015-02-15 00:04:49.000000', 'consum', 0.0214, 'lps'),
	(403212, 124, '2015-02-15 00:04:50.000000', 'consum', 0.0214, 'lps'),
	(403213, 124, '2015-02-15 00:04:51.000000', 'consum', 0.0219, 'lps'),
	(403214, 124, '2015-02-15 00:04:52.000000', 'consum', 0.0219, 'lps'),
	(403215, 124, '2015-02-15 00:04:53.000000', 'consum', 0.0217, 'lps'),
	(403216, 124, '2015-02-15 00:04:54.000000', 'consum', 0.0220, 'lps'),
	(403217, 124, '2015-02-15 00:04:55.000000', 'consum', 0.0214, 'lps'),
	(403218, 124, '2015-02-15 00:04:56.000000', 'consum', 0.0212, 'lps'),
	(403219, 124, '2015-02-15 00:04:57.000000', 'consum', 0.0210, 'lps'),
	(403220, 124, '2015-02-15 00:04:58.000000', 'consum', 0.0216, 'lps'),
	(403221, 124, '2015-02-15 00:04:59.000000', 'consum', 0.0217, 'lps'),
	(403222, 124, '2015-02-15 00:05:00.000000', 'consum', 0.0213, 'lps'),
	(403223, 124, '2015-02-15 00:05:01.000000', 'consum', 0.0219, 'lps'),
	(403224, 124, '2015-02-15 00:05:02.000000', 'consum', 0.0212, 'lps'),
	(403225, 124, '2015-02-15 00:05:03.000000', 'consum', 0.0214, 'lps'),
	(403226, 124, '2015-02-15 00:05:04.000000', 'consum', 0.0214, 'lps'),
	(403227, 124, '2015-02-15 00:05:05.000000', 'consum', 0.0220, 'lps'),
	(403228, 124, '2015-02-15 00:05:06.000000', 'consum', 0.0212, 'lps'),
	(403229, 124, '2015-02-15 00:05:07.000000', 'consum', 0.0214, 'lps'),
	(403230, 124, '2015-02-15 00:05:08.000000', 'consum', 0.0215, 'lps'),
	(403231, 124, '2015-02-15 00:05:09.000000', 'consum', 0.0220, 'lps'),
	(403232, 124, '2015-02-15 00:05:10.000000', 'consum', 0.0211, 'lps'),
	(403233, 124, '2015-02-15 00:05:11.000000', 'consum', 0.0221, 'lps'),
	(403234, 124, '2015-02-15 00:05:12.000000', 'consum', 0.0213, 'lps'),
	(403235, 124, '2015-02-15 00:05:13.000000', 'consum', 0.0219, 'lps'),
	(403236, 124, '2015-02-15 00:05:14.000000', 'consum', 0.0211, 'lps'),
	(403237, 124, '2015-02-15 00:05:15.000000', 'consum', 0.0211, 'lps'),
	(403238, 124, '2015-02-15 00:05:16.000000', 'consum', 0.0214, 'lps'),
	(403239, 124, '2015-02-15 00:05:17.000000', 'consum', 0.0215, 'lps'),
	(403240, 124, '2015-02-15 00:05:18.000000', 'consum', 0.0210, 'lps'),
	(403241, 124, '2015-02-15 00:05:19.000000', 'consum', 0.0219, 'lps'),
	(403242, 124, '2015-02-15 00:05:20.000000', 'consum', 0.0210, 'lps'),
	(403243, 124, '2015-02-15 00:05:21.000000', 'consum', 0.0220, 'lps'),
	(403244, 124, '2015-02-15 00:05:22.000000', 'consum', 0.0213, 'lps'),
	(403245, 124, '2015-02-15 00:05:23.000000', 'consum', 0.0219, 'lps'),
	(403246, 124, '2015-02-15 00:05:24.000000', 'consum', 0.0212, 'lps'),
	(403247, 124, '2015-02-15 00:05:25.000000', 'consum', 0.0215, 'lps'),
	(403248, 124, '2015-02-15 00:05:26.000000', 'consum', 0.0220, 'lps'),
	(403249, 124, '2015-02-15 00:05:27.000000', 'consum', 0.0220, 'lps'),
	(403250, 124, '2015-02-15 00:05:28.000000', 'consum', 0.0220, 'lps'),
	(403251, 124, '2015-02-15 00:05:29.000000', 'consum', 0.0220, 'lps'),
	(403252, 124, '2015-02-15 00:05:30.000000', 'consum', 0.0215, 'lps'),
	(403253, 124, '2015-02-15 00:05:31.000000', 'consum', 0.0220, 'lps'),
	(403254, 124, '2015-02-15 00:05:32.000000', 'consum', 0.0219, 'lps'),
	(403255, 124, '2015-02-15 00:05:33.000000', 'consum', 0.0216, 'lps'),
	(403256, 124, '2015-02-15 00:05:34.000000', 'consum', 0.0213, 'lps'),
	(403257, 124, '2015-02-15 00:05:35.000000', 'consum', 0.0220, 'lps'),
	(403258, 124, '2015-02-15 00:05:36.000000', 'consum', 0.0217, 'lps'),
	(403259, 124, '2015-02-15 00:05:37.000000', 'consum', 0.0214, 'lps'),
	(403260, 124, '2015-02-15 00:05:38.000000', 'consum', 0.0211, 'lps'),
	(403261, 124, '2015-02-15 00:05:39.000000', 'consum', 0.0213, 'lps'),
	(403262, 124, '2015-02-15 00:05:40.000000', 'consum', 0.0211, 'lps'),
	(403263, 124, '2015-02-15 00:05:41.000000', 'consum', 0.0220, 'lps'),
	(403264, 124, '2015-02-15 00:05:42.000000', 'consum', 0.0211, 'lps'),
	(403265, 124, '2015-02-15 00:05:43.000000', 'consum', 0.0218, 'lps'),
	(403266, 124, '2015-02-15 00:05:44.000000', 'consum', 0.0214, 'lps'),
	(403267, 124, '2015-02-15 00:05:45.000000', 'consum', 0.0216, 'lps'),
	(403268, 124, '2015-02-15 00:05:46.000000', 'consum', 0.0219, 'lps'),
	(403269, 124, '2015-02-15 00:05:47.000000', 'consum', 0.0213, 'lps'),
	(403270, 124, '2015-02-15 00:05:48.000000', 'consum', 0.0211, 'lps'),
	(403271, 124, '2015-02-15 00:05:49.000000', 'consum', 0.0217, 'lps'),
	(403272, 124, '2015-02-15 00:05:50.000000', 'consum', 0.0218, 'lps'),
	(403273, 124, '2015-02-15 00:05:51.000000', 'consum', 0.0218, 'lps'),
	(403274, 124, '2015-02-15 00:05:52.000000', 'consum', 0.0216, 'lps'),
	(403275, 124, '2015-02-15 00:05:53.000000', 'consum', 0.0216, 'lps'),
	(403276, 124, '2015-02-15 00:05:54.000000', 'consum', 0.0211, 'lps'),
	(403277, 124, '2015-02-15 00:05:55.000000', 'consum', 0.0219, 'lps'),
	(403278, 124, '2015-02-15 00:05:56.000000', 'consum', 0.0218, 'lps'),
	(403279, 124, '2015-02-15 00:05:57.000000', 'consum', 0.0211, 'lps'),
	(403280, 124, '2015-02-15 00:05:58.000000', 'consum', 0.0216, 'lps'),
	(403281, 124, '2015-02-15 00:05:59.000000', 'consum', 0.0215, 'lps'),
	(403282, 124, '2015-02-15 00:06:00.000000', 'consum', 0.0218, 'lps'),
	(403283, 124, '2015-02-15 00:06:01.000000', 'consum', 0.0212, 'lps'),
	(403284, 124, '2015-02-15 00:06:02.000000', 'consum', 0.0218, 'lps'),
	(403285, 124, '2015-02-15 00:06:03.000000', 'consum', 0.0220, 'lps'),
	(403286, 124, '2015-02-15 00:06:04.000000', 'consum', 0.0211, 'lps'),
	(403287, 124, '2015-02-15 00:06:05.000000', 'consum', 0.0213, 'lps'),
	(403288, 124, '2015-02-15 00:06:06.000000', 'consum', 0.0210, 'lps'),
	(403289, 124, '2015-02-15 00:06:07.000000', 'consum', 0.0212, 'lps'),
	(403290, 124, '2015-02-15 00:06:08.000000', 'consum', 0.0221, 'lps'),
	(403291, 124, '2015-02-15 00:06:09.000000', 'consum', 0.0213, 'lps'),
	(403292, 124, '2015-02-15 00:06:10.000000', 'consum', 0.0217, 'lps'),
	(403293, 124, '2015-02-15 00:06:11.000000', 'consum', 0.0214, 'lps'),
	(403294, 124, '2015-02-15 00:06:12.000000', 'consum', 0.0218, 'lps'),
	(403295, 124, '2015-02-15 00:06:13.000000', 'consum', 0.0215, 'lps'),
	(403296, 124, '2015-02-15 00:06:14.000000', 'consum', 0.0214, 'lps'),
	(403297, 124, '2015-02-15 00:06:15.000000', 'consum', 0.0214, 'lps'),
	(403298, 124, '2015-02-15 00:06:16.000000', 'consum', 0.0217, 'lps'),
	(403299, 124, '2015-02-15 00:06:17.000000', 'consum', 0.0211, 'lps'),
	(403300, 124, '2015-02-15 00:06:18.000000', 'consum', 0.0217, 'lps'),
	(403301, 124, '2015-02-15 00:06:19.000000', 'consum', 0.0219, 'lps'),
	(403302, 124, '2015-02-15 00:06:20.000000', 'consum', 0.0210, 'lps'),
	(403303, 124, '2015-02-15 00:06:21.000000', 'consum', 0.0220, 'lps'),
	(403304, 124, '2015-02-15 00:06:22.000000', 'consum', 0.0213, 'lps'),
	(403305, 124, '2015-02-15 00:06:23.000000', 'consum', 0.0221, 'lps'),
	(403306, 124, '2015-02-15 00:06:24.000000', 'consum', 0.0217, 'lps'),
	(403307, 124, '2015-02-15 00:06:25.000000', 'consum', 0.0215, 'lps'),
	(403308, 124, '2015-02-15 00:06:26.000000', 'consum', 0.0213, 'lps'),
	(403309, 124, '2015-02-15 00:06:27.000000', 'consum', 0.0212, 'lps'),
	(403310, 124, '2015-02-15 00:06:28.000000', 'consum', 0.0213, 'lps'),
	(403311, 124, '2015-02-15 00:06:29.000000', 'consum', 0.0218, 'lps'),
	(403312, 124, '2015-02-15 00:06:30.000000', 'consum', 0.0215, 'lps'),
	(403313, 124, '2015-02-15 00:06:31.000000', 'consum', 0.0215, 'lps'),
	(403314, 124, '2015-02-15 00:06:32.000000', 'consum', 0.0220, 'lps'),
	(403315, 124, '2015-02-15 00:06:33.000000', 'consum', 0.0220, 'lps'),
	(403316, 124, '2015-02-15 00:06:34.000000', 'consum', 0.0220, 'lps'),
	(403317, 124, '2015-02-15 00:06:35.000000', 'consum', 0.0219, 'lps'),
	(403318, 124, '2015-02-15 00:06:36.000000', 'consum', 0.0213, 'lps'),
	(403319, 124, '2015-02-15 00:06:37.000000', 'consum', 0.0210, 'lps'),
	(403320, 124, '2015-02-15 00:06:38.000000', 'consum', 0.0213, 'lps'),
	(403321, 124, '2015-02-15 00:06:39.000000', 'consum', 0.0214, 'lps'),
	(403322, 124, '2015-02-15 00:06:40.000000', 'consum', 0.0221, 'lps'),
	(403323, 124, '2015-02-15 00:06:41.000000', 'consum', 0.0218, 'lps'),
	(403324, 124, '2015-02-15 00:06:42.000000', 'consum', 0.0218, 'lps'),
	(403325, 124, '2015-02-15 00:06:43.000000', 'consum', 0.0216, 'lps'),
	(403326, 124, '2015-02-15 00:06:44.000000', 'consum', 0.0215, 'lps'),
	(403327, 124, '2015-02-15 00:06:45.000000', 'consum', 0.0219, 'lps'),
	(403328, 124, '2015-02-15 00:06:46.000000', 'consum', 0.0217, 'lps'),
	(403329, 124, '2015-02-15 00:06:47.000000', 'consum', 0.0217, 'lps'),
	(403330, 124, '2015-02-15 00:06:48.000000', 'consum', 0.0214, 'lps'),
	(403331, 124, '2015-02-15 00:06:49.000000', 'consum', 0.0219, 'lps'),
	(403332, 124, '2015-02-15 00:06:50.000000', 'consum', 0.0210, 'lps'),
	(403333, 124, '2015-02-15 00:06:51.000000', 'consum', 0.0220, 'lps'),
	(403334, 124, '2015-02-15 00:06:52.000000', 'consum', 0.0211, 'lps'),
	(403335, 124, '2015-02-15 00:06:53.000000', 'consum', 0.0211, 'lps'),
	(403336, 124, '2015-02-15 00:06:54.000000', 'consum', 0.0212, 'lps'),
	(403337, 124, '2015-02-15 00:06:55.000000', 'consum', 0.0218, 'lps'),
	(403338, 124, '2015-02-15 00:06:56.000000', 'consum', 0.0219, 'lps'),
	(403339, 124, '2015-02-15 00:06:57.000000', 'consum', 0.0220, 'lps'),
	(403340, 124, '2015-02-15 00:06:58.000000', 'consum', 0.0221, 'lps'),
	(403341, 124, '2015-02-15 00:06:59.000000', 'consum', 0.0211, 'lps'),
	(403342, 124, '2015-02-15 00:07:00.000000', 'consum', 0.0219, 'lps'),
	(403343, 124, '2015-02-15 00:07:01.000000', 'consum', 0.0216, 'lps'),
	(403344, 124, '2015-02-15 00:07:02.000000', 'consum', 0.0215, 'lps'),
	(403345, 124, '2015-02-15 00:07:03.000000', 'consum', 0.0215, 'lps'),
	(403346, 124, '2015-02-15 00:07:04.000000', 'consum', 0.0211, 'lps'),
	(403347, 124, '2015-02-15 00:07:05.000000', 'consum', 0.0212, 'lps'),
	(403348, 124, '2015-02-15 00:07:06.000000', 'consum', 0.0216, 'lps'),
	(403349, 124, '2015-02-15 00:07:07.000000', 'consum', 0.0210, 'lps'),
	(403350, 124, '2015-02-15 00:07:08.000000', 'consum', 0.0216, 'lps'),
	(403351, 124, '2015-02-15 00:07:09.000000', 'consum', 0.0219, 'lps'),
	(403352, 124, '2015-02-15 00:07:10.000000', 'consum', 0.0211, 'lps'),
	(403353, 124, '2015-02-15 00:07:11.000000', 'consum', 0.0216, 'lps'),
	(403354, 124, '2015-02-15 00:07:12.000000', 'consum', 0.0210, 'lps'),
	(403355, 124, '2015-02-15 00:07:13.000000', 'consum', 0.0217, 'lps'),
	(403356, 124, '2015-02-15 00:07:14.000000', 'consum', 0.0211, 'lps'),
	(403357, 124, '2015-02-15 00:07:15.000000', 'consum', 0.0216, 'lps'),
	(403358, 124, '2015-02-15 00:07:16.000000', 'consum', 0.0216, 'lps'),
	(403359, 124, '2015-02-15 00:07:17.000000', 'consum', 0.0210, 'lps'),
	(403360, 124, '2015-02-15 00:07:18.000000', 'consum', 0.0217, 'lps'),
	(403361, 124, '2015-02-15 00:07:19.000000', 'consum', 0.0220, 'lps'),
	(403362, 124, '2015-02-15 00:07:20.000000', 'consum', 0.0217, 'lps'),
	(403363, 124, '2015-02-15 00:07:21.000000', 'consum', 0.0214, 'lps'),
	(403364, 124, '2015-02-15 00:07:22.000000', 'consum', 0.0211, 'lps'),
	(403365, 124, '2015-02-15 00:07:23.000000', 'consum', 0.0214, 'lps'),
	(403366, 124, '2015-02-15 00:07:24.000000', 'consum', 0.0216, 'lps'),
	(403367, 124, '2015-02-15 00:07:25.000000', 'consum', 0.0215, 'lps'),
	(403368, 124, '2015-02-15 00:07:26.000000', 'consum', 0.0220, 'lps'),
	(403369, 124, '2015-02-15 00:07:27.000000', 'consum', 0.0219, 'lps'),
	(403370, 124, '2015-02-15 00:07:28.000000', 'consum', 0.0213, 'lps'),
	(403371, 124, '2015-02-15 00:07:29.000000', 'consum', 0.0211, 'lps'),
	(403372, 124, '2015-02-15 00:07:30.000000', 'consum', 0.0217, 'lps'),
	(403373, 124, '2015-02-15 00:07:31.000000', 'consum', 0.0210, 'lps'),
	(403374, 124, '2015-02-15 00:07:32.000000', 'consum', 0.0211, 'lps'),
	(403375, 124, '2015-02-15 00:07:33.000000', 'consum', 0.0215, 'lps'),
	(403376, 124, '2015-02-15 00:07:34.000000', 'consum', 0.0220, 'lps'),
	(403377, 124, '2015-02-15 00:07:35.000000', 'consum', 0.0211, 'lps'),
	(403378, 124, '2015-02-15 00:07:36.000000', 'consum', 0.0221, 'lps'),
	(403379, 124, '2015-02-15 00:07:37.000000', 'consum', 0.0216, 'lps'),
	(403380, 124, '2015-02-15 00:07:38.000000', 'consum', 0.0218, 'lps'),
	(403381, 124, '2015-02-15 00:07:39.000000', 'consum', 0.0219, 'lps'),
	(403382, 124, '2015-02-15 00:07:40.000000', 'consum', 0.0220, 'lps'),
	(403383, 124, '2015-02-15 00:07:41.000000', 'consum', 0.0210, 'lps'),
	(403384, 124, '2015-02-15 00:07:42.000000', 'consum', 0.0214, 'lps'),
	(403385, 124, '2015-02-15 00:07:43.000000', 'consum', 0.0210, 'lps'),
	(403386, 124, '2015-02-15 00:07:44.000000', 'consum', 0.0210, 'lps'),
	(403387, 124, '2015-02-15 00:07:45.000000', 'consum', 0.0221, 'lps'),
	(403388, 124, '2015-02-15 00:07:46.000000', 'consum', 0.0218, 'lps'),
	(403389, 124, '2015-02-15 00:07:47.000000', 'consum', 0.0219, 'lps'),
	(403390, 124, '2015-02-15 00:07:48.000000', 'consum', 0.0220, 'lps'),
	(403391, 124, '2015-02-15 00:07:49.000000', 'consum', 0.0221, 'lps'),
	(403392, 124, '2015-02-15 00:07:50.000000', 'consum', 0.0213, 'lps'),
	(403393, 124, '2015-02-15 00:07:51.000000', 'consum', 0.0216, 'lps'),
	(403394, 124, '2015-02-15 00:07:52.000000', 'consum', 0.0219, 'lps'),
	(403395, 124, '2015-02-15 00:07:53.000000', 'consum', 0.0212, 'lps'),
	(403396, 124, '2015-02-15 00:07:54.000000', 'consum', 0.0217, 'lps'),
	(403397, 124, '2015-02-15 00:07:55.000000', 'consum', 0.0215, 'lps'),
	(403398, 124, '2015-02-15 00:07:56.000000', 'consum', 0.0217, 'lps'),
	(403399, 124, '2015-02-15 00:07:57.000000', 'consum', 0.0218, 'lps'),
	(403400, 124, '2015-02-15 00:07:58.000000', 'consum', 0.0216, 'lps'),
	(403401, 124, '2015-02-15 00:07:59.000000', 'consum', 0.0218, 'lps'),
	(403402, 124, '2015-02-15 00:08:00.000000', 'consum', 0.0220, 'lps'),
	(403403, 124, '2015-02-15 00:08:01.000000', 'consum', 0.0211, 'lps'),
	(403404, 124, '2015-02-15 00:08:02.000000', 'consum', 0.0210, 'lps'),
	(403405, 124, '2015-02-15 00:08:03.000000', 'consum', 0.0221, 'lps'),
	(403406, 124, '2015-02-15 00:08:04.000000', 'consum', 0.0216, 'lps'),
	(403407, 124, '2015-02-15 00:08:05.000000', 'consum', 0.0219, 'lps'),
	(403408, 124, '2015-02-15 00:08:06.000000', 'consum', 0.0213, 'lps'),
	(403409, 124, '2015-02-15 00:08:07.000000', 'consum', 0.0210, 'lps'),
	(403410, 124, '2015-02-15 00:08:08.000000', 'consum', 0.0216, 'lps'),
	(403411, 124, '2015-02-15 00:08:09.000000', 'consum', 0.0215, 'lps'),
	(403412, 124, '2015-02-15 00:08:10.000000', 'consum', 0.0217, 'lps'),
	(403413, 124, '2015-02-15 00:08:11.000000', 'consum', 0.0218, 'lps'),
	(403414, 124, '2015-02-15 00:08:12.000000', 'consum', 0.0217, 'lps'),
	(403415, 124, '2015-02-15 00:08:13.000000', 'consum', 0.0212, 'lps'),
	(403416, 124, '2015-02-15 00:08:14.000000', 'consum', 0.0210, 'lps'),
	(403417, 124, '2015-02-15 00:08:15.000000', 'consum', 0.0217, 'lps'),
	(403418, 124, '2015-02-15 00:08:16.000000', 'consum', 0.0211, 'lps'),
	(403419, 124, '2015-02-15 00:08:17.000000', 'consum', 0.0219, 'lps'),
	(403420, 124, '2015-02-15 00:08:18.000000', 'consum', 0.0216, 'lps'),
	(403421, 124, '2015-02-15 00:08:19.000000', 'consum', 0.0211, 'lps'),
	(403422, 124, '2015-02-15 00:08:20.000000', 'consum', 0.0213, 'lps'),
	(403423, 124, '2015-02-15 00:08:21.000000', 'consum', 0.0221, 'lps'),
	(403424, 124, '2015-02-15 00:08:22.000000', 'consum', 0.0220, 'lps'),
	(403425, 124, '2015-02-15 00:08:23.000000', 'consum', 0.0217, 'lps'),
	(403426, 124, '2015-02-15 00:08:24.000000', 'consum', 0.0215, 'lps'),
	(403427, 124, '2015-02-15 00:08:25.000000', 'consum', 0.0216, 'lps'),
	(403428, 124, '2015-02-15 00:08:26.000000', 'consum', 0.0211, 'lps'),
	(403429, 124, '2015-02-15 00:08:27.000000', 'consum', 0.0221, 'lps'),
	(403430, 124, '2015-02-15 00:08:28.000000', 'consum', 0.0216, 'lps'),
	(403431, 124, '2015-02-15 00:08:29.000000', 'consum', 0.0221, 'lps'),
	(403432, 124, '2015-02-15 00:08:30.000000', 'consum', 0.0221, 'lps'),
	(403433, 124, '2015-02-15 00:08:31.000000', 'consum', 0.0211, 'lps'),
	(403434, 124, '2015-02-15 00:08:32.000000', 'consum', 0.0219, 'lps'),
	(403435, 124, '2015-02-15 00:08:33.000000', 'consum', 0.0213, 'lps'),
	(403436, 124, '2015-02-15 00:08:34.000000', 'consum', 0.0214, 'lps'),
	(403437, 124, '2015-02-15 00:08:35.000000', 'consum', 0.0221, 'lps'),
	(403438, 124, '2015-02-15 00:08:36.000000', 'consum', 0.0216, 'lps'),
	(403439, 124, '2015-02-15 00:08:37.000000', 'consum', 0.0221, 'lps'),
	(403440, 124, '2015-02-15 00:08:38.000000', 'consum', 0.0212, 'lps'),
	(403441, 124, '2015-02-15 00:08:39.000000', 'consum', 0.0210, 'lps'),
	(403442, 124, '2015-02-15 00:08:40.000000', 'consum', 0.0219, 'lps'),
	(403443, 124, '2015-02-15 00:08:41.000000', 'consum', 0.0217, 'lps'),
	(403444, 124, '2015-02-15 00:08:42.000000', 'consum', 0.0221, 'lps'),
	(403445, 124, '2015-02-15 00:08:43.000000', 'consum', 0.0221, 'lps'),
	(403446, 124, '2015-02-15 00:08:44.000000', 'consum', 0.0220, 'lps'),
	(403447, 124, '2015-02-15 00:08:45.000000', 'consum', 0.0214, 'lps'),
	(403448, 124, '2015-02-15 00:08:46.000000', 'consum', 0.0215, 'lps'),
	(403449, 124, '2015-02-15 00:08:47.000000', 'consum', 0.0210, 'lps'),
	(403450, 124, '2015-02-15 00:08:48.000000', 'consum', 0.0218, 'lps'),
	(403451, 124, '2015-02-15 00:08:49.000000', 'consum', 0.0216, 'lps'),
	(403452, 124, '2015-02-15 00:08:50.000000', 'consum', 0.0218, 'lps'),
	(403453, 124, '2015-02-15 00:08:51.000000', 'consum', 0.0217, 'lps'),
	(403454, 124, '2015-02-15 00:08:52.000000', 'consum', 0.0213, 'lps'),
	(403455, 124, '2015-02-15 00:08:53.000000', 'consum', 0.0216, 'lps'),
	(403456, 124, '2015-02-15 00:08:54.000000', 'consum', 0.0219, 'lps'),
	(403457, 124, '2015-02-15 00:08:55.000000', 'consum', 0.0215, 'lps'),
	(403458, 124, '2015-02-15 00:08:56.000000', 'consum', 0.0219, 'lps'),
	(403459, 124, '2015-02-15 00:08:57.000000', 'consum', 0.0216, 'lps'),
	(403460, 124, '2015-02-15 00:08:58.000000', 'consum', 0.0214, 'lps'),
	(403461, 124, '2015-02-15 00:08:59.000000', 'consum', 0.0211, 'lps'),
	(403462, 124, '2015-02-15 00:09:00.000000', 'consum', 0.0218, 'lps'),
	(403463, 124, '2015-02-15 00:09:01.000000', 'consum', 0.0211, 'lps'),
	(403464, 124, '2015-02-15 00:09:02.000000', 'consum', 0.0215, 'lps'),
	(403465, 124, '2015-02-15 00:09:03.000000', 'consum', 0.0219, 'lps'),
	(403466, 124, '2015-02-15 00:09:04.000000', 'consum', 0.0217, 'lps'),
	(403467, 124, '2015-02-15 00:09:05.000000', 'consum', 0.0220, 'lps'),
	(403468, 124, '2015-02-15 00:09:06.000000', 'consum', 0.0216, 'lps'),
	(403469, 124, '2015-02-15 00:09:07.000000', 'consum', 0.0221, 'lps'),
	(403470, 124, '2015-02-15 00:09:08.000000', 'consum', 0.0211, 'lps'),
	(403471, 124, '2015-02-15 00:09:09.000000', 'consum', 0.0221, 'lps'),
	(403472, 124, '2015-02-15 00:09:10.000000', 'consum', 0.0213, 'lps'),
	(403473, 124, '2015-02-15 00:09:11.000000', 'consum', 0.0218, 'lps'),
	(403474, 124, '2015-02-15 00:09:12.000000', 'consum', 0.0217, 'lps'),
	(403475, 124, '2015-02-15 00:09:13.000000', 'consum', 0.0210, 'lps'),
	(403476, 124, '2015-02-15 00:09:14.000000', 'consum', 0.0213, 'lps'),
	(403477, 124, '2015-02-15 00:09:15.000000', 'consum', 0.0212, 'lps'),
	(403478, 124, '2015-02-15 00:09:16.000000', 'consum', 0.0213, 'lps'),
	(403479, 124, '2015-02-15 00:09:17.000000', 'consum', 0.0221, 'lps'),
	(403480, 124, '2015-02-15 00:09:18.000000', 'consum', 0.0218, 'lps'),
	(403481, 124, '2015-02-15 00:09:19.000000', 'consum', 0.0218, 'lps'),
	(403482, 124, '2015-02-15 00:09:20.000000', 'consum', 0.0216, 'lps'),
	(403483, 124, '2015-02-15 00:09:21.000000', 'consum', 0.0214, 'lps'),
	(403484, 124, '2015-02-15 00:09:22.000000', 'consum', 0.0215, 'lps'),
	(403485, 124, '2015-02-15 00:09:23.000000', 'consum', 0.0210, 'lps'),
	(403486, 124, '2015-02-15 00:09:24.000000', 'consum', 0.0221, 'lps'),
	(403487, 124, '2015-02-15 00:09:25.000000', 'consum', 0.0217, 'lps'),
	(403488, 124, '2015-02-15 00:09:26.000000', 'consum', 0.0211, 'lps'),
	(403489, 124, '2015-02-15 00:09:27.000000', 'consum', 0.0220, 'lps'),
	(403490, 124, '2015-02-15 00:09:28.000000', 'consum', 0.0211, 'lps'),
	(403491, 124, '2015-02-15 00:09:29.000000', 'consum', 0.0220, 'lps'),
	(403492, 124, '2015-02-15 00:09:30.000000', 'consum', 0.0221, 'lps'),
	(403493, 124, '2015-02-15 00:09:31.000000', 'consum', 0.0212, 'lps'),
	(403494, 124, '2015-02-15 00:09:32.000000', 'consum', 0.0212, 'lps'),
	(403495, 124, '2015-02-15 00:09:33.000000', 'consum', 0.0214, 'lps'),
	(403496, 124, '2015-02-15 00:09:34.000000', 'consum', 0.0212, 'lps'),
	(403497, 124, '2015-02-15 00:09:35.000000', 'consum', 0.0220, 'lps'),
	(403498, 124, '2015-02-15 00:09:36.000000', 'consum', 0.0219, 'lps'),
	(403499, 124, '2015-02-15 00:09:37.000000', 'consum', 0.0212, 'lps'),
	(403500, 124, '2015-02-15 00:09:38.000000', 'consum', 0.0217, 'lps'),
	(403501, 124, '2015-02-15 00:09:39.000000', 'consum', 0.0216, 'lps'),
	(403502, 124, '2015-02-15 00:09:40.000000', 'consum', 0.0221, 'lps'),
	(403503, 124, '2015-02-15 00:09:41.000000', 'consum', 0.0212, 'lps'),
	(403504, 124, '2015-02-15 00:09:42.000000', 'consum', 0.0210, 'lps'),
	(403505, 124, '2015-02-15 00:09:43.000000', 'consum', 0.0217, 'lps'),
	(403506, 124, '2015-02-15 00:09:44.000000', 'consum', 0.0221, 'lps'),
	(403507, 124, '2015-02-15 00:09:45.000000', 'consum', 0.0210, 'lps'),
	(403508, 124, '2015-02-15 00:09:46.000000', 'consum', 0.0213, 'lps'),
	(403509, 124, '2015-02-15 00:09:47.000000', 'consum', 0.0211, 'lps'),
	(403510, 124, '2015-02-15 00:09:48.000000', 'consum', 0.0210, 'lps'),
	(403511, 124, '2015-02-15 00:09:49.000000', 'consum', 0.0217, 'lps'),
	(403512, 124, '2015-02-15 00:09:50.000000', 'consum', 0.0211, 'lps'),
	(403513, 124, '2015-02-15 00:09:51.000000', 'consum', 0.0219, 'lps'),
	(403514, 124, '2015-02-15 00:09:52.000000', 'consum', 0.0215, 'lps'),
	(403515, 124, '2015-02-15 00:09:53.000000', 'consum', 0.0219, 'lps'),
	(403516, 124, '2015-02-15 00:09:54.000000', 'consum', 0.0218, 'lps'),
	(403517, 124, '2015-02-15 00:09:55.000000', 'consum', 0.0212, 'lps'),
	(403518, 124, '2015-02-15 00:09:56.000000', 'consum', 0.0220, 'lps'),
	(403519, 124, '2015-02-15 00:09:57.000000', 'consum', 0.0219, 'lps'),
	(403520, 124, '2015-02-15 00:09:58.000000', 'consum', 0.0215, 'lps'),
	(403521, 124, '2015-02-15 00:09:59.000000', 'consum', 0.0219, 'lps'),
	(403522, 124, '2015-02-15 00:10:00.000000', 'consum', 0.0215, 'lps'),
	(403523, 124, '2015-02-15 00:10:01.000000', 'consum', 0.0211, 'lps'),
	(403524, 124, '2015-02-15 00:10:02.000000', 'consum', 0.0212, 'lps'),
	(403525, 124, '2015-02-15 00:10:03.000000', 'consum', 0.0219, 'lps'),
	(403526, 124, '2015-02-15 00:10:04.000000', 'consum', 0.0211, 'lps'),
	(403527, 124, '2015-02-15 00:10:05.000000', 'consum', 0.0215, 'lps'),
	(403528, 124, '2015-02-15 00:10:06.000000', 'consum', 0.0220, 'lps'),
	(403529, 124, '2015-02-15 00:10:07.000000', 'consum', 0.0219, 'lps'),
	(403530, 124, '2015-02-15 00:10:08.000000', 'consum', 0.0215, 'lps'),
	(403531, 124, '2015-02-15 00:10:09.000000', 'consum', 0.0219, 'lps'),
	(403532, 124, '2015-02-15 00:10:10.000000', 'consum', 0.0220, 'lps'),
	(403533, 124, '2015-02-15 00:10:11.000000', 'consum', 0.0218, 'lps'),
	(403534, 124, '2015-02-15 00:10:12.000000', 'consum', 0.0210, 'lps'),
	(403535, 124, '2015-02-15 00:10:13.000000', 'consum', 0.0210, 'lps'),
	(403536, 124, '2015-02-15 00:10:14.000000', 'consum', 0.0212, 'lps'),
	(403537, 124, '2015-02-15 00:10:15.000000', 'consum', 0.0219, 'lps'),
	(403538, 124, '2015-02-15 00:10:16.000000', 'consum', 0.0215, 'lps'),
	(403539, 124, '2015-02-15 00:10:17.000000', 'consum', 0.0219, 'lps'),
	(403540, 124, '2015-02-15 00:10:18.000000', 'consum', 0.0216, 'lps'),
	(403541, 124, '2015-02-15 00:10:19.000000', 'consum', 0.0213, 'lps'),
	(403542, 124, '2015-02-15 00:10:20.000000', 'consum', 0.0210, 'lps'),
	(403543, 124, '2015-02-15 00:10:21.000000', 'consum', 0.0214, 'lps'),
	(403544, 124, '2015-02-15 00:10:22.000000', 'consum', 0.0216, 'lps'),
	(403545, 124, '2015-02-15 00:10:23.000000', 'consum', 0.0218, 'lps'),
	(403546, 124, '2015-02-15 00:10:24.000000', 'consum', 0.0218, 'lps'),
	(403547, 124, '2015-02-15 00:10:25.000000', 'consum', 0.0216, 'lps'),
	(403548, 124, '2015-02-15 00:10:26.000000', 'consum', 0.0217, 'lps'),
	(403549, 124, '2015-02-15 00:10:27.000000', 'consum', 0.0215, 'lps'),
	(403550, 124, '2015-02-15 00:10:28.000000', 'consum', 0.0215, 'lps'),
	(403551, 124, '2015-02-15 00:10:29.000000', 'consum', 0.0210, 'lps'),
	(403552, 124, '2015-02-15 00:10:30.000000', 'consum', 0.0217, 'lps'),
	(403553, 124, '2015-02-15 00:10:31.000000', 'consum', 0.0221, 'lps'),
	(403554, 124, '2015-02-15 00:10:32.000000', 'consum', 0.0211, 'lps'),
	(403555, 124, '2015-02-15 00:10:33.000000', 'consum', 0.0219, 'lps'),
	(403556, 124, '2015-02-15 00:10:34.000000', 'consum', 0.0215, 'lps'),
	(403557, 124, '2015-02-15 00:10:35.000000', 'consum', 0.0210, 'lps'),
	(403558, 124, '2015-02-15 00:10:36.000000', 'consum', 0.0218, 'lps'),
	(403559, 124, '2015-02-15 00:10:37.000000', 'consum', 0.0213, 'lps'),
	(403560, 124, '2015-02-15 00:10:38.000000', 'consum', 0.0215, 'lps'),
	(403561, 124, '2015-02-15 00:10:39.000000', 'consum', 0.0216, 'lps'),
	(403562, 124, '2015-02-15 00:10:40.000000', 'consum', 0.0213, 'lps'),
	(403563, 124, '2015-02-15 00:10:41.000000', 'consum', 0.0220, 'lps'),
	(403564, 124, '2015-02-15 00:10:42.000000', 'consum', 0.0213, 'lps'),
	(403565, 124, '2015-02-15 00:10:43.000000', 'consum', 0.0210, 'lps'),
	(403566, 124, '2015-02-15 00:10:44.000000', 'consum', 0.0211, 'lps'),
	(403567, 124, '2015-02-15 00:10:45.000000', 'consum', 0.0216, 'lps'),
	(403568, 124, '2015-02-15 00:10:46.000000', 'consum', 0.0214, 'lps'),
	(403569, 124, '2015-02-15 00:10:47.000000', 'consum', 0.0210, 'lps'),
	(403570, 124, '2015-02-15 00:10:48.000000', 'consum', 0.0214, 'lps'),
	(403571, 124, '2015-02-15 00:10:49.000000', 'consum', 0.0217, 'lps'),
	(403572, 124, '2015-02-15 00:10:50.000000', 'consum', 0.0220, 'lps'),
	(403573, 124, '2015-02-15 00:10:51.000000', 'consum', 0.0217, 'lps'),
	(403574, 124, '2015-02-15 00:10:52.000000', 'consum', 0.0217, 'lps'),
	(403575, 124, '2015-02-15 00:10:53.000000', 'consum', 0.0211, 'lps'),
	(403576, 124, '2015-02-15 00:10:54.000000', 'consum', 0.0220, 'lps'),
	(403577, 124, '2015-02-15 00:10:55.000000', 'consum', 0.0219, 'lps'),
	(403578, 124, '2015-02-15 00:10:56.000000', 'consum', 0.0214, 'lps'),
	(403579, 124, '2015-02-15 00:10:57.000000', 'consum', 0.0218, 'lps'),
	(403580, 124, '2015-02-15 00:10:58.000000', 'consum', 0.0212, 'lps'),
	(403581, 124, '2015-02-15 00:10:59.000000', 'consum', 0.0219, 'lps'),
	(403582, 124, '2015-02-15 00:11:00.000000', 'consum', 0.0216, 'lps'),
	(403583, 124, '2015-02-15 00:11:01.000000', 'consum', 0.0214, 'lps'),
	(403584, 124, '2015-02-15 00:11:02.000000', 'consum', 0.0210, 'lps'),
	(403585, 124, '2015-02-15 00:11:03.000000', 'consum', 0.0212, 'lps'),
	(403586, 124, '2015-02-15 00:11:04.000000', 'consum', 0.0210, 'lps'),
	(403587, 124, '2015-02-15 00:11:05.000000', 'consum', 0.0214, 'lps'),
	(403588, 124, '2015-02-15 00:11:06.000000', 'consum', 0.0219, 'lps'),
	(403589, 124, '2015-02-15 00:11:07.000000', 'consum', 0.0221, 'lps'),
	(403590, 124, '2015-02-15 00:11:08.000000', 'consum', 0.0213, 'lps'),
	(403591, 124, '2015-02-15 00:11:09.000000', 'consum', 0.0215, 'lps'),
	(403592, 124, '2015-02-15 00:11:10.000000', 'consum', 0.0216, 'lps'),
	(403593, 124, '2015-02-15 00:11:11.000000', 'consum', 0.0215, 'lps'),
	(403594, 124, '2015-02-15 00:11:12.000000', 'consum', 0.0216, 'lps'),
	(403595, 124, '2015-02-15 00:11:13.000000', 'consum', 0.0213, 'lps'),
	(403596, 124, '2015-02-15 00:11:14.000000', 'consum', 0.0220, 'lps'),
	(403597, 124, '2015-02-15 00:11:15.000000', 'consum', 0.0216, 'lps'),
	(403598, 124, '2015-02-15 00:11:16.000000', 'consum', 0.0221, 'lps'),
	(403599, 124, '2015-02-15 00:11:17.000000', 'consum', 0.0210, 'lps'),
	(403600, 124, '2015-02-15 00:11:18.000000', 'consum', 0.0217, 'lps'),
	(403601, 124, '2015-02-15 00:11:19.000000', 'consum', 0.0219, 'lps'),
	(403602, 124, '2015-02-15 00:11:20.000000', 'consum', 0.0210, 'lps'),
	(403603, 124, '2015-02-15 00:11:21.000000', 'consum', 0.0211, 'lps'),
	(403604, 124, '2015-02-15 00:11:22.000000', 'consum', 0.0212, 'lps'),
	(403605, 124, '2015-02-15 00:11:23.000000', 'consum', 0.0218, 'lps'),
	(403606, 124, '2015-02-15 00:11:24.000000', 'consum', 0.0210, 'lps'),
	(403607, 124, '2015-02-15 00:11:25.000000', 'consum', 0.0220, 'lps'),
	(403608, 124, '2015-02-15 00:11:26.000000', 'consum', 0.0215, 'lps'),
	(403609, 124, '2015-02-15 00:11:27.000000', 'consum', 0.0215, 'lps'),
	(403610, 124, '2015-02-15 00:11:28.000000', 'consum', 0.0221, 'lps'),
	(403611, 124, '2015-02-15 00:11:29.000000', 'consum', 0.0213, 'lps'),
	(403612, 124, '2015-02-15 00:11:30.000000', 'consum', 0.0219, 'lps'),
	(403613, 124, '2015-02-15 00:11:31.000000', 'consum', 0.0210, 'lps'),
	(403614, 124, '2015-02-15 00:11:32.000000', 'consum', 0.0220, 'lps'),
	(403615, 124, '2015-02-15 00:11:33.000000', 'consum', 0.0210, 'lps'),
	(403616, 124, '2015-02-15 00:11:34.000000', 'consum', 0.0218, 'lps'),
	(403617, 124, '2015-02-15 00:11:35.000000', 'consum', 0.0213, 'lps'),
	(403618, 124, '2015-02-15 00:11:36.000000', 'consum', 0.0216, 'lps'),
	(403619, 124, '2015-02-15 00:11:37.000000', 'consum', 0.0219, 'lps'),
	(403620, 124, '2015-02-15 00:11:38.000000', 'consum', 0.0214, 'lps'),
	(403621, 124, '2015-02-15 00:11:39.000000', 'consum', 0.0214, 'lps'),
	(403622, 124, '2015-02-15 00:11:40.000000', 'consum', 0.0217, 'lps'),
	(403623, 124, '2015-02-15 00:11:41.000000', 'consum', 0.0211, 'lps'),
	(403624, 124, '2015-02-15 00:11:42.000000', 'consum', 0.0219, 'lps'),
	(403625, 124, '2015-02-15 00:11:43.000000', 'consum', 0.0216, 'lps'),
	(403626, 124, '2015-02-15 00:11:44.000000', 'consum', 0.0215, 'lps'),
	(403627, 124, '2015-02-15 00:11:45.000000', 'consum', 0.0218, 'lps'),
	(403628, 124, '2015-02-15 00:11:46.000000', 'consum', 0.0211, 'lps'),
	(403629, 124, '2015-02-15 00:11:47.000000', 'consum', 0.0213, 'lps'),
	(403630, 124, '2015-02-15 00:11:48.000000', 'consum', 0.0213, 'lps'),
	(403631, 124, '2015-02-15 00:11:49.000000', 'consum', 0.0217, 'lps'),
	(403632, 124, '2015-02-15 00:11:50.000000', 'consum', 0.0213, 'lps'),
	(403633, 124, '2015-02-15 00:11:51.000000', 'consum', 0.0217, 'lps'),
	(403634, 124, '2015-02-15 00:11:52.000000', 'consum', 0.0212, 'lps'),
	(403635, 124, '2015-02-15 00:11:53.000000', 'consum', 0.0212, 'lps'),
	(403636, 124, '2015-02-15 00:11:54.000000', 'consum', 0.0215, 'lps'),
	(403637, 124, '2015-02-15 00:11:55.000000', 'consum', 0.0217, 'lps'),
	(403638, 124, '2015-02-15 00:11:56.000000', 'consum', 0.0217, 'lps'),
	(403639, 124, '2015-02-15 00:11:57.000000', 'consum', 0.0212, 'lps'),
	(403640, 124, '2015-02-15 00:11:58.000000', 'consum', 0.0213, 'lps'),
	(403641, 124, '2015-02-15 00:11:59.000000', 'consum', 0.0220, 'lps'),
	(403642, 124, '2015-02-15 00:12:00.000000', 'consum', 0.0216, 'lps'),
	(403643, 124, '2015-02-15 00:12:01.000000', 'consum', 0.0211, 'lps'),
	(403644, 124, '2015-02-15 00:12:02.000000', 'consum', 0.0220, 'lps'),
	(403645, 124, '2015-02-15 00:12:03.000000', 'consum', 0.0221, 'lps'),
	(403646, 124, '2015-02-15 00:12:04.000000', 'consum', 0.0214, 'lps'),
	(403647, 124, '2015-02-15 00:12:05.000000', 'consum', 0.0218, 'lps'),
	(403648, 124, '2015-02-15 00:12:06.000000', 'consum', 0.0217, 'lps'),
	(403649, 124, '2015-02-15 00:12:07.000000', 'consum', 0.0221, 'lps'),
	(403650, 124, '2015-02-15 00:12:08.000000', 'consum', 0.0218, 'lps'),
	(403651, 124, '2015-02-15 00:12:09.000000', 'consum', 0.0221, 'lps'),
	(403652, 124, '2015-02-15 00:12:10.000000', 'consum', 0.0215, 'lps'),
	(403653, 124, '2015-02-15 00:12:11.000000', 'consum', 0.0215, 'lps'),
	(403654, 124, '2015-02-15 00:12:12.000000', 'consum', 0.0210, 'lps'),
	(403655, 124, '2015-02-15 00:12:13.000000', 'consum', 0.0217, 'lps'),
	(403656, 124, '2015-02-15 00:12:14.000000', 'consum', 0.0210, 'lps'),
	(403657, 124, '2015-02-15 00:12:15.000000', 'consum', 0.0212, 'lps'),
	(403658, 124, '2015-02-15 00:12:16.000000', 'consum', 0.0221, 'lps'),
	(403659, 124, '2015-02-15 00:12:17.000000', 'consum', 0.0214, 'lps'),
	(403660, 124, '2015-02-15 00:12:18.000000', 'consum', 0.0220, 'lps'),
	(403661, 124, '2015-02-15 00:12:19.000000', 'consum', 0.0213, 'lps'),
	(403662, 124, '2015-02-15 00:12:20.000000', 'consum', 0.0218, 'lps'),
	(403663, 124, '2015-02-15 00:12:21.000000', 'consum', 0.0220, 'lps'),
	(403664, 124, '2015-02-15 00:12:22.000000', 'consum', 0.0221, 'lps'),
	(403665, 124, '2015-02-15 00:12:23.000000', 'consum', 0.0215, 'lps'),
	(403666, 124, '2015-02-15 00:12:24.000000', 'consum', 0.0214, 'lps'),
	(403667, 124, '2015-02-15 00:12:25.000000', 'consum', 0.0213, 'lps'),
	(403668, 124, '2015-02-15 00:12:26.000000', 'consum', 0.0216, 'lps'),
	(403669, 124, '2015-02-15 00:12:27.000000', 'consum', 0.0220, 'lps'),
	(403670, 124, '2015-02-15 00:12:28.000000', 'consum', 0.0217, 'lps'),
	(403671, 124, '2015-02-15 00:12:29.000000', 'consum', 0.0214, 'lps'),
	(403672, 124, '2015-02-15 00:12:30.000000', 'consum', 0.0210, 'lps'),
	(403673, 124, '2015-02-15 00:12:31.000000', 'consum', 0.0213, 'lps'),
	(403674, 124, '2015-02-15 00:12:32.000000', 'consum', 0.0213, 'lps'),
	(403675, 124, '2015-02-15 00:12:33.000000', 'consum', 0.0215, 'lps'),
	(403676, 124, '2015-02-15 00:12:34.000000', 'consum', 0.0213, 'lps'),
	(403677, 124, '2015-02-15 00:12:35.000000', 'consum', 0.0212, 'lps'),
	(403678, 124, '2015-02-15 00:12:36.000000', 'consum', 0.0213, 'lps'),
	(403679, 124, '2015-02-15 00:12:37.000000', 'consum', 0.0218, 'lps'),
	(403680, 124, '2015-02-15 00:12:38.000000', 'consum', 0.0217, 'lps'),
	(403681, 124, '2015-02-15 00:12:39.000000', 'consum', 0.0210, 'lps'),
	(403682, 124, '2015-02-15 00:12:40.000000', 'consum', 0.0214, 'lps'),
	(403683, 124, '2015-02-15 00:12:41.000000', 'consum', 0.0219, 'lps'),
	(403684, 124, '2015-02-15 00:12:42.000000', 'consum', 0.0217, 'lps'),
	(403685, 124, '2015-02-15 00:12:43.000000', 'consum', 0.0210, 'lps'),
	(403686, 124, '2015-02-15 00:12:44.000000', 'consum', 0.0210, 'lps'),
	(403687, 124, '2015-02-15 00:12:45.000000', 'consum', 0.0214, 'lps'),
	(403688, 124, '2015-02-15 00:12:46.000000', 'consum', 0.0216, 'lps'),
	(403689, 124, '2015-02-15 00:12:47.000000', 'consum', 0.0217, 'lps'),
	(403690, 124, '2015-02-15 00:12:48.000000', 'consum', 0.0214, 'lps'),
	(403691, 124, '2015-02-15 00:12:49.000000', 'consum', 0.0212, 'lps'),
	(403692, 124, '2015-02-15 00:12:50.000000', 'consum', 0.0221, 'lps'),
	(403693, 124, '2015-02-15 00:12:51.000000', 'consum', 0.0210, 'lps'),
	(403694, 124, '2015-02-15 00:12:52.000000', 'consum', 0.0213, 'lps'),
	(403695, 124, '2015-02-15 00:12:53.000000', 'consum', 0.0215, 'lps'),
	(403696, 124, '2015-02-15 00:12:54.000000', 'consum', 0.0214, 'lps'),
	(403697, 124, '2015-02-15 00:12:55.000000', 'consum', 0.0214, 'lps'),
	(403698, 124, '2015-02-15 00:12:56.000000', 'consum', 0.0219, 'lps'),
	(403699, 124, '2015-02-15 00:12:57.000000', 'consum', 0.0219, 'lps'),
	(403700, 124, '2015-02-15 00:12:58.000000', 'consum', 0.0215, 'lps'),
	(403701, 124, '2015-02-15 00:12:59.000000', 'consum', 0.0211, 'lps'),
	(403702, 124, '2015-02-15 00:13:00.000000', 'consum', 0.0212, 'lps'),
	(403703, 124, '2015-02-15 00:13:01.000000', 'consum', 0.0218, 'lps'),
	(403704, 124, '2015-02-15 00:13:02.000000', 'consum', 0.0220, 'lps'),
	(403705, 124, '2015-02-15 00:13:03.000000', 'consum', 0.0211, 'lps'),
	(403706, 124, '2015-02-15 00:13:04.000000', 'consum', 0.0212, 'lps'),
	(403707, 124, '2015-02-15 00:13:05.000000', 'consum', 0.0218, 'lps'),
	(403708, 124, '2015-02-15 00:13:06.000000', 'consum', 0.0210, 'lps'),
	(403709, 124, '2015-02-15 00:13:07.000000', 'consum', 0.0219, 'lps'),
	(403710, 124, '2015-02-15 00:13:08.000000', 'consum', 0.0219, 'lps'),
	(403711, 124, '2015-02-15 00:13:09.000000', 'consum', 0.0217, 'lps'),
	(403712, 124, '2015-02-15 00:13:10.000000', 'consum', 0.0219, 'lps'),
	(403713, 124, '2015-02-15 00:13:11.000000', 'consum', 0.0213, 'lps'),
	(403714, 124, '2015-02-15 00:13:12.000000', 'consum', 0.0219, 'lps'),
	(403715, 124, '2015-02-15 00:13:13.000000', 'consum', 0.0211, 'lps'),
	(403716, 124, '2015-02-15 00:13:14.000000', 'consum', 0.0215, 'lps'),
	(403717, 124, '2015-02-15 00:13:15.000000', 'consum', 0.0220, 'lps'),
	(403718, 124, '2015-02-15 00:13:16.000000', 'consum', 0.0219, 'lps'),
	(403719, 124, '2015-02-15 00:13:17.000000', 'consum', 0.0217, 'lps'),
	(403720, 124, '2015-02-15 00:13:18.000000', 'consum', 0.0216, 'lps'),
	(403721, 124, '2015-02-15 00:13:19.000000', 'consum', 0.0221, 'lps'),
	(403722, 124, '2015-02-15 00:13:20.000000', 'consum', 0.0213, 'lps'),
	(403723, 124, '2015-02-15 00:13:21.000000', 'consum', 0.0214, 'lps'),
	(403724, 124, '2015-02-15 00:13:22.000000', 'consum', 0.0211, 'lps'),
	(403725, 124, '2015-02-15 00:13:23.000000', 'consum', 0.0214, 'lps'),
	(403726, 124, '2015-02-15 00:13:24.000000', 'consum', 0.0216, 'lps'),
	(403727, 124, '2015-02-15 00:13:25.000000', 'consum', 0.0219, 'lps'),
	(403728, 124, '2015-02-15 00:13:26.000000', 'consum', 0.0210, 'lps'),
	(403729, 124, '2015-02-15 00:13:27.000000', 'consum', 0.0220, 'lps'),
	(403730, 124, '2015-02-15 00:13:28.000000', 'consum', 0.0211, 'lps'),
	(403731, 124, '2015-02-15 00:13:29.000000', 'consum', 0.0211, 'lps'),
	(403732, 124, '2015-02-15 00:13:30.000000', 'consum', 0.0214, 'lps'),
	(403733, 124, '2015-02-15 00:13:31.000000', 'consum', 0.0214, 'lps'),
	(403734, 124, '2015-02-15 00:13:32.000000', 'consum', 0.0221, 'lps'),
	(403735, 124, '2015-02-15 00:13:33.000000', 'consum', 0.0215, 'lps'),
	(403736, 124, '2015-02-15 00:13:34.000000', 'consum', 0.0216, 'lps'),
	(403737, 124, '2015-02-15 00:13:35.000000', 'consum', 0.0214, 'lps'),
	(403738, 124, '2015-02-15 00:13:36.000000', 'consum', 0.0211, 'lps'),
	(403739, 124, '2015-02-15 00:13:37.000000', 'consum', 0.0216, 'lps'),
	(403740, 124, '2015-02-15 00:13:38.000000', 'consum', 0.0213, 'lps'),
	(403741, 124, '2015-02-15 00:13:39.000000', 'consum', 0.0221, 'lps'),
	(403742, 124, '2015-02-15 00:13:40.000000', 'consum', 0.0220, 'lps'),
	(403743, 124, '2015-02-15 00:13:41.000000', 'consum', 0.0216, 'lps'),
	(403744, 124, '2015-02-15 00:13:42.000000', 'consum', 0.0211, 'lps'),
	(403745, 124, '2015-02-15 00:13:43.000000', 'consum', 0.0210, 'lps'),
	(403746, 124, '2015-02-15 00:13:44.000000', 'consum', 0.0218, 'lps'),
	(403747, 124, '2015-02-15 00:13:45.000000', 'consum', 0.0215, 'lps'),
	(403748, 124, '2015-02-15 00:13:46.000000', 'consum', 0.0211, 'lps'),
	(403749, 124, '2015-02-15 00:13:47.000000', 'consum', 0.0212, 'lps'),
	(403750, 124, '2015-02-15 00:13:48.000000', 'consum', 0.0219, 'lps'),
	(403751, 124, '2015-02-15 00:13:49.000000', 'consum', 0.0213, 'lps'),
	(403752, 124, '2015-02-15 00:13:50.000000', 'consum', 0.0212, 'lps'),
	(403753, 124, '2015-02-15 00:13:51.000000', 'consum', 0.0212, 'lps'),
	(403754, 124, '2015-02-15 00:13:52.000000', 'consum', 0.0212, 'lps'),
	(403755, 124, '2015-02-15 00:13:53.000000', 'consum', 0.0217, 'lps'),
	(403756, 124, '2015-02-15 00:13:54.000000', 'consum', 0.0213, 'lps'),
	(403757, 124, '2015-02-15 00:13:55.000000', 'consum', 0.0216, 'lps'),
	(403758, 124, '2015-02-15 00:13:56.000000', 'consum', 0.0210, 'lps'),
	(403759, 124, '2015-02-15 00:13:57.000000', 'consum', 0.0217, 'lps'),
	(403760, 124, '2015-02-15 00:13:58.000000', 'consum', 0.0210, 'lps'),
	(403761, 124, '2015-02-15 00:13:59.000000', 'consum', 0.0212, 'lps'),
	(403762, 124, '2015-02-15 00:14:00.000000', 'consum', 0.0220, 'lps'),
	(403763, 124, '2015-02-15 00:14:01.000000', 'consum', 0.0219, 'lps'),
	(403764, 124, '2015-02-15 00:14:02.000000', 'consum', 0.0214, 'lps'),
	(403765, 124, '2015-02-15 00:14:03.000000', 'consum', 0.0216, 'lps'),
	(403766, 124, '2015-02-15 00:14:04.000000', 'consum', 0.0218, 'lps'),
	(403767, 124, '2015-02-15 00:14:05.000000', 'consum', 0.0218, 'lps'),
	(403768, 124, '2015-02-15 00:14:06.000000', 'consum', 0.0215, 'lps'),
	(403769, 124, '2015-02-15 00:14:07.000000', 'consum', 0.0213, 'lps'),
	(403770, 124, '2015-02-15 00:14:08.000000', 'consum', 0.0212, 'lps'),
	(403771, 124, '2015-02-15 00:14:09.000000', 'consum', 0.0220, 'lps'),
	(403772, 124, '2015-02-15 00:14:10.000000', 'consum', 0.0220, 'lps'),
	(403773, 124, '2015-02-15 00:14:11.000000', 'consum', 0.0220, 'lps'),
	(403774, 124, '2015-02-15 00:14:12.000000', 'consum', 0.0215, 'lps'),
	(403775, 124, '2015-02-15 00:14:13.000000', 'consum', 0.0220, 'lps'),
	(403776, 124, '2015-02-15 00:14:14.000000', 'consum', 0.0211, 'lps'),
	(403777, 124, '2015-02-15 00:14:15.000000', 'consum', 0.0219, 'lps'),
	(403778, 124, '2015-02-15 00:14:16.000000', 'consum', 0.0216, 'lps'),
	(403779, 124, '2015-02-15 00:14:17.000000', 'consum', 0.0214, 'lps'),
	(403780, 124, '2015-02-15 00:14:18.000000', 'consum', 0.0215, 'lps'),
	(403781, 124, '2015-02-15 00:14:19.000000', 'consum', 0.0221, 'lps'),
	(403782, 124, '2015-02-15 00:14:20.000000', 'consum', 0.0215, 'lps'),
	(403783, 124, '2015-02-15 00:14:21.000000', 'consum', 0.0216, 'lps'),
	(403784, 124, '2015-02-15 00:14:22.000000', 'consum', 0.0213, 'lps'),
	(403785, 124, '2015-02-15 00:14:23.000000', 'consum', 0.0217, 'lps'),
	(403786, 124, '2015-02-15 00:14:24.000000', 'consum', 0.0215, 'lps'),
	(403787, 124, '2015-02-15 00:14:25.000000', 'consum', 0.0213, 'lps'),
	(403788, 124, '2015-02-15 00:14:26.000000', 'consum', 0.0211, 'lps'),
	(403789, 124, '2015-02-15 00:14:27.000000', 'consum', 0.0217, 'lps'),
	(403790, 124, '2015-02-15 00:14:28.000000', 'consum', 0.0219, 'lps'),
	(403791, 124, '2015-02-15 00:14:29.000000', 'consum', 0.0211, 'lps'),
	(403792, 124, '2015-02-15 00:14:30.000000', 'consum', 0.0213, 'lps'),
	(403793, 124, '2015-02-15 00:14:31.000000', 'consum', 0.0210, 'lps'),
	(403794, 124, '2015-02-15 00:14:32.000000', 'consum', 0.0214, 'lps'),
	(403795, 124, '2015-02-15 00:14:33.000000', 'consum', 0.0219, 'lps'),
	(403796, 124, '2015-02-15 00:14:34.000000', 'consum', 0.0219, 'lps'),
	(403797, 124, '2015-02-15 00:14:35.000000', 'consum', 0.0216, 'lps'),
	(403798, 124, '2015-02-15 00:14:36.000000', 'consum', 0.0216, 'lps'),
	(403799, 124, '2015-02-15 00:14:37.000000', 'consum', 0.0220, 'lps'),
	(403800, 124, '2015-02-15 00:14:38.000000', 'consum', 0.0219, 'lps'),
	(403801, 124, '2015-02-15 00:14:39.000000', 'consum', 0.0215, 'lps'),
	(403802, 124, '2015-02-15 00:14:40.000000', 'consum', 0.0218, 'lps'),
	(403803, 124, '2015-02-15 00:14:41.000000', 'consum', 0.0211, 'lps'),
	(403804, 124, '2015-02-15 00:14:42.000000', 'consum', 0.0218, 'lps'),
	(403805, 124, '2015-02-15 00:14:43.000000', 'consum', 0.0210, 'lps'),
	(403806, 124, '2015-02-15 00:14:44.000000', 'consum', 0.0211, 'lps'),
	(403807, 124, '2015-02-15 00:14:45.000000', 'consum', 0.0213, 'lps'),
	(403808, 124, '2015-02-15 00:14:46.000000', 'consum', 0.0214, 'lps'),
	(403809, 124, '2015-02-15 00:14:47.000000', 'consum', 0.0221, 'lps'),
	(403810, 124, '2015-02-15 00:14:48.000000', 'consum', 0.0218, 'lps'),
	(403811, 124, '2015-02-15 00:14:49.000000', 'consum', 0.0215, 'lps'),
	(403812, 124, '2015-02-15 00:14:50.000000', 'consum', 0.0215, 'lps'),
	(403813, 124, '2015-02-15 00:14:51.000000', 'consum', 0.0217, 'lps'),
	(403814, 124, '2015-02-15 00:14:52.000000', 'consum', 0.0210, 'lps'),
	(403815, 124, '2015-02-15 00:14:53.000000', 'consum', 0.0210, 'lps'),
	(403816, 124, '2015-02-15 00:14:54.000000', 'consum', 0.0213, 'lps'),
	(403817, 124, '2015-02-15 00:14:55.000000', 'consum', 0.0212, 'lps'),
	(403818, 124, '2015-02-15 00:14:56.000000', 'consum', 0.0213, 'lps'),
	(403819, 124, '2015-02-15 00:14:57.000000', 'consum', 0.0220, 'lps'),
	(403820, 124, '2015-02-15 00:14:58.000000', 'consum', 0.0214, 'lps'),
	(403821, 124, '2015-02-15 00:14:59.000000', 'consum', 0.0212, 'lps'),
	(403822, 124, '2015-02-15 00:15:00.000000', 'consum', 0.0219, 'lps'),
	(403823, 124, '2015-02-15 00:15:01.000000', 'consum', 0.0216, 'lps'),
	(403824, 124, '2015-02-15 00:15:02.000000', 'consum', 0.0211, 'lps'),
	(403825, 124, '2015-02-15 00:15:03.000000', 'consum', 0.0211, 'lps'),
	(403826, 124, '2015-02-15 00:15:04.000000', 'consum', 0.0212, 'lps'),
	(403827, 124, '2015-02-15 00:15:05.000000', 'consum', 0.0220, 'lps'),
	(403828, 124, '2015-02-15 00:15:06.000000', 'consum', 0.0216, 'lps'),
	(403829, 124, '2015-02-15 00:15:07.000000', 'consum', 0.0221, 'lps'),
	(403830, 124, '2015-02-15 00:15:08.000000', 'consum', 0.0214, 'lps'),
	(403831, 124, '2015-02-15 00:15:09.000000', 'consum', 0.0210, 'lps'),
	(403832, 124, '2015-02-15 00:15:10.000000', 'consum', 0.0211, 'lps'),
	(403833, 124, '2015-02-15 00:15:11.000000', 'consum', 0.0216, 'lps'),
	(403834, 124, '2015-02-15 00:15:12.000000', 'consum', 0.0211, 'lps'),
	(403835, 124, '2015-02-15 00:15:13.000000', 'consum', 0.0213, 'lps'),
	(403836, 124, '2015-02-15 00:15:14.000000', 'consum', 0.0219, 'lps'),
	(403837, 124, '2015-02-15 00:15:15.000000', 'consum', 0.0212, 'lps'),
	(403838, 124, '2015-02-15 00:15:16.000000', 'consum', 0.0217, 'lps'),
	(403839, 124, '2015-02-15 00:15:17.000000', 'consum', 0.0214, 'lps'),
	(403840, 124, '2015-02-15 00:15:18.000000', 'consum', 0.0211, 'lps'),
	(403841, 124, '2015-02-15 00:15:19.000000', 'consum', 0.0214, 'lps'),
	(403842, 124, '2015-02-15 00:15:20.000000', 'consum', 0.0218, 'lps'),
	(403843, 124, '2015-02-15 00:15:21.000000', 'consum', 0.0212, 'lps'),
	(403844, 124, '2015-02-15 00:15:22.000000', 'consum', 0.0221, 'lps'),
	(403845, 124, '2015-02-15 00:15:23.000000', 'consum', 0.0212, 'lps'),
	(403846, 124, '2015-02-15 00:15:24.000000', 'consum', 0.0210, 'lps'),
	(403847, 124, '2015-02-15 00:15:25.000000', 'consum', 0.0220, 'lps'),
	(403848, 124, '2015-02-15 00:15:26.000000', 'consum', 0.0221, 'lps'),
	(403849, 124, '2015-02-15 00:15:27.000000', 'consum', 0.0212, 'lps'),
	(403850, 124, '2015-02-15 00:15:28.000000', 'consum', 0.0214, 'lps'),
	(403851, 124, '2015-02-15 00:15:29.000000', 'consum', 0.0210, 'lps'),
	(403852, 124, '2015-02-15 00:15:30.000000', 'consum', 0.0212, 'lps'),
	(403853, 124, '2015-02-15 00:15:31.000000', 'consum', 0.0220, 'lps'),
	(403854, 124, '2015-02-15 00:15:32.000000', 'consum', 0.0220, 'lps'),
	(403855, 124, '2015-02-15 00:15:33.000000', 'consum', 0.0216, 'lps'),
	(403856, 124, '2015-02-15 00:15:34.000000', 'consum', 0.0213, 'lps'),
	(403857, 124, '2015-02-15 00:15:35.000000', 'consum', 0.0218, 'lps'),
	(403858, 124, '2015-02-15 00:15:36.000000', 'consum', 0.0219, 'lps'),
	(403859, 124, '2015-02-15 00:15:37.000000', 'consum', 0.0220, 'lps'),
	(403860, 124, '2015-02-15 00:15:38.000000', 'consum', 0.0219, 'lps'),
	(403861, 124, '2015-02-15 00:15:39.000000', 'consum', 0.0215, 'lps'),
	(403862, 124, '2015-02-15 00:15:40.000000', 'consum', 0.0219, 'lps'),
	(403863, 124, '2015-02-15 00:15:41.000000', 'consum', 0.0219, 'lps'),
	(403864, 124, '2015-02-15 00:15:42.000000', 'consum', 0.0217, 'lps'),
	(403865, 124, '2015-02-15 00:15:43.000000', 'consum', 0.0218, 'lps'),
	(403866, 124, '2015-02-15 00:15:44.000000', 'consum', 0.0215, 'lps'),
	(403867, 124, '2015-02-15 00:15:45.000000', 'consum', 0.0213, 'lps'),
	(403868, 124, '2015-02-15 00:15:46.000000', 'consum', 0.0221, 'lps'),
	(403869, 124, '2015-02-15 00:15:47.000000', 'consum', 0.0210, 'lps'),
	(403870, 124, '2015-02-15 00:15:48.000000', 'consum', 0.0214, 'lps'),
	(403871, 124, '2015-02-15 00:15:49.000000', 'consum', 0.0218, 'lps'),
	(403872, 124, '2015-02-15 00:15:50.000000', 'consum', 0.0213, 'lps'),
	(403873, 124, '2015-02-15 00:15:51.000000', 'consum', 0.0215, 'lps'),
	(403874, 124, '2015-02-15 00:15:52.000000', 'consum', 0.0215, 'lps'),
	(403875, 124, '2015-02-15 00:15:53.000000', 'consum', 0.0220, 'lps'),
	(403876, 124, '2015-02-15 00:15:54.000000', 'consum', 0.0220, 'lps'),
	(403877, 124, '2015-02-15 00:15:55.000000', 'consum', 0.0210, 'lps'),
	(403878, 124, '2015-02-15 00:15:56.000000', 'consum', 0.0213, 'lps'),
	(403879, 124, '2015-02-15 00:15:57.000000', 'consum', 0.0215, 'lps'),
	(403880, 124, '2015-02-15 00:15:58.000000', 'consum', 0.0215, 'lps'),
	(403881, 124, '2015-02-15 00:15:59.000000', 'consum', 0.0219, 'lps'),
	(403882, 124, '2015-02-15 00:16:00.000000', 'consum', 0.0218, 'lps'),
	(403883, 124, '2015-02-15 00:16:01.000000', 'consum', 0.0221, 'lps'),
	(403884, 124, '2015-02-15 00:16:02.000000', 'consum', 0.0220, 'lps'),
	(403885, 124, '2015-02-15 00:16:03.000000', 'consum', 0.0213, 'lps'),
	(403886, 124, '2015-02-15 00:16:04.000000', 'consum', 0.0220, 'lps'),
	(403887, 124, '2015-02-15 00:16:05.000000', 'consum', 0.0216, 'lps'),
	(403888, 124, '2015-02-15 00:16:06.000000', 'consum', 0.0212, 'lps'),
	(403889, 124, '2015-02-15 00:16:07.000000', 'consum', 0.0215, 'lps'),
	(403890, 124, '2015-02-15 00:16:08.000000', 'consum', 0.0218, 'lps'),
	(403891, 124, '2015-02-15 00:16:09.000000', 'consum', 0.0220, 'lps'),
	(403892, 124, '2015-02-15 00:16:10.000000', 'consum', 0.0215, 'lps'),
	(403893, 124, '2015-02-15 00:16:11.000000', 'consum', 0.0219, 'lps'),
	(403894, 124, '2015-02-15 00:16:12.000000', 'consum', 0.0215, 'lps'),
	(403895, 124, '2015-02-15 00:16:13.000000', 'consum', 0.0220, 'lps'),
	(403896, 124, '2015-02-15 00:16:14.000000', 'consum', 0.0210, 'lps'),
	(403897, 124, '2015-02-15 00:16:15.000000', 'consum', 0.0217, 'lps'),
	(403898, 124, '2015-02-15 00:16:16.000000', 'consum', 0.0221, 'lps'),
	(403899, 124, '2015-02-15 00:16:17.000000', 'consum', 0.0220, 'lps'),
	(403900, 124, '2015-02-15 00:16:18.000000', 'consum', 0.0216, 'lps'),
	(403901, 124, '2015-02-15 00:16:19.000000', 'consum', 0.0221, 'lps'),
	(403902, 124, '2015-02-15 00:16:20.000000', 'consum', 0.0213, 'lps'),
	(403903, 124, '2015-02-15 00:16:21.000000', 'consum', 0.0215, 'lps'),
	(403904, 124, '2015-02-15 00:16:22.000000', 'consum', 0.0213, 'lps'),
	(403905, 124, '2015-02-15 00:16:23.000000', 'consum', 0.0213, 'lps'),
	(403906, 124, '2015-02-15 00:16:24.000000', 'consum', 0.0216, 'lps'),
	(403907, 124, '2015-02-15 00:16:25.000000', 'consum', 0.0219, 'lps'),
	(403908, 124, '2015-02-15 00:16:26.000000', 'consum', 0.0215, 'lps'),
	(403909, 124, '2015-02-15 00:16:27.000000', 'consum', 0.0219, 'lps'),
	(403910, 124, '2015-02-15 00:16:28.000000', 'consum', 0.0216, 'lps'),
	(403911, 124, '2015-02-15 00:16:29.000000', 'consum', 0.0216, 'lps'),
	(403912, 124, '2015-02-15 00:16:30.000000', 'consum', 0.0220, 'lps'),
	(403913, 124, '2015-02-15 00:16:31.000000', 'consum', 0.0220, 'lps'),
	(403914, 124, '2015-02-15 00:16:32.000000', 'consum', 0.0216, 'lps'),
	(403915, 124, '2015-02-15 00:16:33.000000', 'consum', 0.0213, 'lps'),
	(403916, 124, '2015-02-15 00:16:34.000000', 'consum', 0.0217, 'lps'),
	(403917, 124, '2015-02-15 00:16:35.000000', 'consum', 0.0213, 'lps'),
	(403918, 124, '2015-02-15 00:16:36.000000', 'consum', 0.0217, 'lps'),
	(403919, 124, '2015-02-15 00:16:37.000000', 'consum', 0.0214, 'lps'),
	(403920, 124, '2015-02-15 00:16:38.000000', 'consum', 0.0221, 'lps'),
	(403921, 124, '2015-02-15 00:16:39.000000', 'consum', 0.0215, 'lps'),
	(403922, 124, '2015-02-15 00:16:40.000000', 'consum', 0.0218, 'lps'),
	(403923, 124, '2015-02-15 00:16:41.000000', 'consum', 0.0221, 'lps'),
	(403924, 124, '2015-02-15 00:16:42.000000', 'consum', 0.0219, 'lps'),
	(403925, 124, '2015-02-15 00:16:43.000000', 'consum', 0.0220, 'lps'),
	(403926, 124, '2015-02-15 00:16:44.000000', 'consum', 0.0211, 'lps'),
	(403927, 124, '2015-02-15 00:16:45.000000', 'consum', 0.0221, 'lps'),
	(403928, 124, '2015-02-15 00:16:46.000000', 'consum', 0.0215, 'lps'),
	(403929, 124, '2015-02-15 00:16:47.000000', 'consum', 0.0214, 'lps'),
	(403930, 124, '2015-02-15 00:16:48.000000', 'consum', 0.0216, 'lps'),
	(403931, 124, '2015-02-15 00:16:49.000000', 'consum', 0.0216, 'lps'),
	(403932, 124, '2015-02-15 00:16:50.000000', 'consum', 0.0221, 'lps'),
	(403933, 124, '2015-02-15 00:16:51.000000', 'consum', 0.0215, 'lps'),
	(403934, 124, '2015-02-15 00:16:52.000000', 'consum', 0.0212, 'lps'),
	(403935, 124, '2015-02-15 00:16:53.000000', 'consum', 0.0218, 'lps'),
	(403936, 124, '2015-02-15 00:16:54.000000', 'consum', 0.0210, 'lps'),
	(403937, 124, '2015-02-15 00:16:55.000000', 'consum', 0.0211, 'lps'),
	(403938, 124, '2015-02-15 00:16:56.000000', 'consum', 0.0214, 'lps'),
	(403939, 124, '2015-02-15 00:16:57.000000', 'consum', 0.0216, 'lps'),
	(403940, 124, '2015-02-15 00:16:58.000000', 'consum', 0.0216, 'lps'),
	(403941, 124, '2015-02-15 00:16:59.000000', 'consum', 0.0211, 'lps'),
	(403942, 124, '2015-02-15 00:17:00.000000', 'consum', 0.0210, 'lps'),
	(403943, 124, '2015-02-15 00:17:01.000000', 'consum', 0.0218, 'lps'),
	(403944, 124, '2015-02-15 00:17:02.000000', 'consum', 0.0217, 'lps'),
	(403945, 124, '2015-02-15 00:17:03.000000', 'consum', 0.0210, 'lps'),
	(403946, 124, '2015-02-15 00:17:04.000000', 'consum', 0.0211, 'lps'),
	(403947, 124, '2015-02-15 00:17:05.000000', 'consum', 0.0215, 'lps'),
	(403948, 124, '2015-02-15 00:17:06.000000', 'consum', 0.0210, 'lps'),
	(403949, 124, '2015-02-15 00:17:07.000000', 'consum', 0.0219, 'lps'),
	(403950, 124, '2015-02-15 00:17:08.000000', 'consum', 0.0220, 'lps'),
	(403951, 124, '2015-02-15 00:17:09.000000', 'consum', 0.0211, 'lps'),
	(403952, 124, '2015-02-15 00:17:10.000000', 'consum', 0.0221, 'lps'),
	(403953, 124, '2015-02-15 00:17:11.000000', 'consum', 0.0212, 'lps'),
	(403954, 124, '2015-02-15 00:17:12.000000', 'consum', 0.0215, 'lps'),
	(403955, 124, '2015-02-15 00:17:13.000000', 'consum', 0.0216, 'lps'),
	(403956, 124, '2015-02-15 00:17:14.000000', 'consum', 0.0214, 'lps'),
	(403957, 124, '2015-02-15 00:17:15.000000', 'consum', 0.0211, 'lps'),
	(403958, 124, '2015-02-15 00:17:16.000000', 'consum', 0.0215, 'lps'),
	(403959, 124, '2015-02-15 00:17:17.000000', 'consum', 0.0220, 'lps'),
	(403960, 124, '2015-02-15 00:17:18.000000', 'consum', 0.0211, 'lps'),
	(403961, 124, '2015-02-15 00:17:19.000000', 'consum', 0.0210, 'lps'),
	(403962, 124, '2015-02-15 00:17:20.000000', 'consum', 0.0218, 'lps'),
	(403963, 124, '2015-02-15 00:17:21.000000', 'consum', 0.0215, 'lps'),
	(403964, 124, '2015-02-15 00:17:22.000000', 'consum', 0.0210, 'lps'),
	(403965, 124, '2015-02-15 00:17:23.000000', 'consum', 0.0220, 'lps'),
	(403966, 124, '2015-02-15 00:17:24.000000', 'consum', 0.0212, 'lps'),
	(403967, 124, '2015-02-15 00:17:25.000000', 'consum', 0.0215, 'lps'),
	(403968, 124, '2015-02-15 00:17:26.000000', 'consum', 0.0216, 'lps'),
	(403969, 124, '2015-02-15 00:17:27.000000', 'consum', 0.0214, 'lps'),
	(403970, 124, '2015-02-15 00:17:28.000000', 'consum', 0.0213, 'lps'),
	(403971, 124, '2015-02-15 00:17:29.000000', 'consum', 0.0215, 'lps'),
	(403972, 124, '2015-02-15 00:17:30.000000', 'consum', 0.0212, 'lps'),
	(403973, 124, '2015-02-15 00:17:31.000000', 'consum', 0.0220, 'lps'),
	(403974, 124, '2015-02-15 00:17:32.000000', 'consum', 0.0216, 'lps'),
	(403975, 124, '2015-02-15 00:17:33.000000', 'consum', 0.0210, 'lps'),
	(403976, 124, '2015-02-15 00:17:34.000000', 'consum', 0.0216, 'lps'),
	(403977, 124, '2015-02-15 00:17:35.000000', 'consum', 0.0219, 'lps'),
	(403978, 124, '2015-02-15 00:17:36.000000', 'consum', 0.0213, 'lps'),
	(403979, 124, '2015-02-15 00:17:37.000000', 'consum', 0.0210, 'lps'),
	(403980, 124, '2015-02-15 00:17:38.000000', 'consum', 0.0216, 'lps'),
	(403981, 124, '2015-02-15 00:17:39.000000', 'consum', 0.0213, 'lps'),
	(403982, 124, '2015-02-15 00:17:40.000000', 'consum', 0.0221, 'lps'),
	(403983, 124, '2015-02-15 00:17:41.000000', 'consum', 0.0220, 'lps'),
	(403984, 124, '2015-02-15 00:17:42.000000', 'consum', 0.0215, 'lps'),
	(403985, 124, '2015-02-15 00:17:43.000000', 'consum', 0.0217, 'lps'),
	(403986, 124, '2015-02-15 00:17:44.000000', 'consum', 0.0220, 'lps'),
	(403987, 124, '2015-02-15 00:17:45.000000', 'consum', 0.0214, 'lps'),
	(403988, 124, '2015-02-15 00:17:46.000000', 'consum', 0.0214, 'lps'),
	(403989, 124, '2015-02-15 00:17:47.000000', 'consum', 0.0220, 'lps'),
	(403990, 124, '2015-02-15 00:17:48.000000', 'consum', 0.0210, 'lps'),
	(403991, 124, '2015-02-15 00:17:49.000000', 'consum', 0.0216, 'lps'),
	(403992, 124, '2015-02-15 00:17:50.000000', 'consum', 0.0219, 'lps'),
	(403993, 124, '2015-02-15 00:17:51.000000', 'consum', 0.0213, 'lps'),
	(403994, 124, '2015-02-15 00:17:52.000000', 'consum', 0.0212, 'lps'),
	(403995, 124, '2015-02-15 00:17:53.000000', 'consum', 0.0221, 'lps'),
	(403996, 124, '2015-02-15 00:17:54.000000', 'consum', 0.0211, 'lps'),
	(403997, 124, '2015-02-15 00:17:55.000000', 'consum', 0.0220, 'lps'),
	(403998, 124, '2015-02-15 00:17:56.000000', 'consum', 0.0221, 'lps'),
	(403999, 124, '2015-02-15 00:17:57.000000', 'consum', 0.0212, 'lps'),
	(404000, 124, '2015-02-15 00:17:58.000000', 'consum', 0.0210, 'lps'),
	(404001, 124, '2015-02-15 00:17:59.000000', 'consum', 0.0217, 'lps'),
	(404002, 124, '2015-02-15 00:18:00.000000', 'consum', 0.0220, 'lps'),
	(404003, 124, '2015-02-15 00:18:01.000000', 'consum', 0.0217, 'lps'),
	(404004, 124, '2015-02-15 00:18:02.000000', 'consum', 0.0215, 'lps'),
	(404005, 124, '2015-02-15 00:18:03.000000', 'consum', 0.0215, 'lps'),
	(404006, 124, '2015-02-15 00:18:04.000000', 'consum', 0.0210, 'lps'),
	(404007, 124, '2015-02-15 00:18:05.000000', 'consum', 0.0217, 'lps'),
	(404008, 124, '2015-02-15 00:18:06.000000', 'consum', 0.0211, 'lps'),
	(404009, 124, '2015-02-15 00:18:07.000000', 'consum', 0.0219, 'lps'),
	(404010, 124, '2015-02-15 00:18:08.000000', 'consum', 0.0215, 'lps'),
	(404011, 124, '2015-02-15 00:18:09.000000', 'consum', 0.0210, 'lps'),
	(404012, 124, '2015-02-15 00:18:10.000000', 'consum', 0.0221, 'lps'),
	(404013, 124, '2015-02-15 00:18:11.000000', 'consum', 0.0214, 'lps'),
	(404014, 124, '2015-02-15 00:18:12.000000', 'consum', 0.0212, 'lps'),
	(404015, 124, '2015-02-15 00:18:13.000000', 'consum', 0.0218, 'lps'),
	(404016, 124, '2015-02-15 00:18:14.000000', 'consum', 0.0211, 'lps'),
	(404017, 124, '2015-02-15 00:18:15.000000', 'consum', 0.0215, 'lps'),
	(404018, 124, '2015-02-15 00:18:16.000000', 'consum', 0.0220, 'lps'),
	(404019, 124, '2015-02-15 00:18:17.000000', 'consum', 0.0210, 'lps'),
	(404020, 124, '2015-02-15 00:18:18.000000', 'consum', 0.0217, 'lps'),
	(404021, 124, '2015-02-15 00:18:19.000000', 'consum', 0.0220, 'lps'),
	(404022, 124, '2015-02-15 00:18:20.000000', 'consum', 0.0216, 'lps'),
	(404023, 124, '2015-02-15 00:18:21.000000', 'consum', 0.0211, 'lps'),
	(404024, 124, '2015-02-15 00:18:22.000000', 'consum', 0.0220, 'lps'),
	(404025, 124, '2015-02-15 00:18:23.000000', 'consum', 0.0212, 'lps'),
	(404026, 124, '2015-02-15 00:18:24.000000', 'consum', 0.0213, 'lps'),
	(404027, 124, '2015-02-15 00:18:25.000000', 'consum', 0.0220, 'lps'),
	(404028, 124, '2015-02-15 00:18:26.000000', 'consum', 0.0216, 'lps'),
	(404029, 124, '2015-02-15 00:18:27.000000', 'consum', 0.0220, 'lps'),
	(404030, 124, '2015-02-15 00:18:28.000000', 'consum', 0.0221, 'lps'),
	(404031, 124, '2015-02-15 00:18:29.000000', 'consum', 0.0210, 'lps'),
	(404032, 124, '2015-02-15 00:18:30.000000', 'consum', 0.0215, 'lps'),
	(404033, 124, '2015-02-15 00:18:31.000000', 'consum', 0.0221, 'lps'),
	(404034, 124, '2015-02-15 00:18:32.000000', 'consum', 0.0215, 'lps'),
	(404035, 124, '2015-02-15 00:18:33.000000', 'consum', 0.0215, 'lps'),
	(404036, 124, '2015-02-15 00:18:34.000000', 'consum', 0.0210, 'lps'),
	(404037, 124, '2015-02-15 00:18:35.000000', 'consum', 0.0219, 'lps'),
	(404038, 124, '2015-02-15 00:18:36.000000', 'consum', 0.0221, 'lps'),
	(404039, 124, '2015-02-15 00:18:37.000000', 'consum', 0.0213, 'lps'),
	(404040, 124, '2015-02-15 00:18:38.000000', 'consum', 0.0216, 'lps'),
	(404041, 124, '2015-02-15 00:18:39.000000', 'consum', 0.0220, 'lps'),
	(404042, 124, '2015-02-15 00:18:40.000000', 'consum', 0.0220, 'lps'),
	(404043, 124, '2015-02-15 00:18:41.000000', 'consum', 0.0217, 'lps'),
	(404044, 124, '2015-02-15 00:18:42.000000', 'consum', 0.0217, 'lps'),
	(404045, 124, '2015-02-15 00:18:43.000000', 'consum', 0.0214, 'lps'),
	(404046, 124, '2015-02-15 00:18:44.000000', 'consum', 0.0218, 'lps'),
	(404047, 124, '2015-02-15 00:18:45.000000', 'consum', 0.0216, 'lps'),
	(404048, 124, '2015-02-15 00:18:46.000000', 'consum', 0.0215, 'lps'),
	(404049, 124, '2015-02-15 00:18:47.000000', 'consum', 0.0220, 'lps'),
	(404050, 124, '2015-02-15 00:18:48.000000', 'consum', 0.0210, 'lps'),
	(404051, 124, '2015-02-15 00:18:49.000000', 'consum', 0.0214, 'lps'),
	(404052, 124, '2015-02-15 00:18:50.000000', 'consum', 0.0219, 'lps'),
	(404053, 124, '2015-02-15 00:18:51.000000', 'consum', 0.0221, 'lps'),
	(404054, 124, '2015-02-15 00:18:52.000000', 'consum', 0.0212, 'lps'),
	(404055, 124, '2015-02-15 00:18:53.000000', 'consum', 0.0214, 'lps'),
	(404056, 124, '2015-02-15 00:18:54.000000', 'consum', 0.0211, 'lps'),
	(404057, 124, '2015-02-15 00:18:55.000000', 'consum', 0.0214, 'lps'),
	(404058, 124, '2015-02-15 00:18:56.000000', 'consum', 0.0217, 'lps'),
	(404059, 124, '2015-02-15 00:18:57.000000', 'consum', 0.0210, 'lps'),
	(404060, 124, '2015-02-15 00:18:58.000000', 'consum', 0.0215, 'lps'),
	(404061, 124, '2015-02-15 00:18:59.000000', 'consum', 0.0221, 'lps'),
	(404062, 124, '2015-02-15 00:19:00.000000', 'consum', 0.0213, 'lps'),
	(404063, 124, '2015-02-15 00:19:01.000000', 'consum', 0.0219, 'lps'),
	(404064, 124, '2015-02-15 00:19:02.000000', 'consum', 0.0210, 'lps'),
	(404065, 124, '2015-02-15 00:19:03.000000', 'consum', 0.0221, 'lps'),
	(404066, 124, '2015-02-15 00:19:04.000000', 'consum', 0.0216, 'lps'),
	(404067, 124, '2015-02-15 00:19:05.000000', 'consum', 0.0221, 'lps'),
	(404068, 124, '2015-02-15 00:19:06.000000', 'consum', 0.0211, 'lps'),
	(404069, 124, '2015-02-15 00:19:07.000000', 'consum', 0.0219, 'lps'),
	(404070, 124, '2015-02-15 00:19:08.000000', 'consum', 0.0216, 'lps'),
	(404071, 124, '2015-02-15 00:19:09.000000', 'consum', 0.0215, 'lps'),
	(404072, 124, '2015-02-15 00:19:10.000000', 'consum', 0.0215, 'lps'),
	(404073, 124, '2015-02-15 00:19:11.000000', 'consum', 0.0210, 'lps'),
	(404074, 124, '2015-02-15 00:19:12.000000', 'consum', 0.0219, 'lps'),
	(404075, 124, '2015-02-15 00:19:13.000000', 'consum', 0.0220, 'lps'),
	(404076, 124, '2015-02-15 00:19:14.000000', 'consum', 0.0211, 'lps'),
	(404077, 124, '2015-02-15 00:19:15.000000', 'consum', 0.0220, 'lps'),
	(404078, 124, '2015-02-15 00:19:16.000000', 'consum', 0.0210, 'lps'),
	(404079, 124, '2015-02-15 00:19:17.000000', 'consum', 0.0216, 'lps'),
	(404080, 124, '2015-02-15 00:19:18.000000', 'consum', 0.0216, 'lps'),
	(404081, 124, '2015-02-15 00:19:19.000000', 'consum', 0.0213, 'lps'),
	(404082, 124, '2015-02-15 00:19:20.000000', 'consum', 0.0217, 'lps'),
	(404083, 124, '2015-02-15 00:19:21.000000', 'consum', 0.0213, 'lps'),
	(404084, 124, '2015-02-15 00:19:22.000000', 'consum', 0.0215, 'lps'),
	(404085, 124, '2015-02-15 00:19:23.000000', 'consum', 0.0216, 'lps'),
	(404086, 124, '2015-02-15 00:19:24.000000', 'consum', 0.0215, 'lps'),
	(404087, 124, '2015-02-15 00:19:25.000000', 'consum', 0.0215, 'lps'),
	(404088, 124, '2015-02-15 00:19:26.000000', 'consum', 0.0219, 'lps'),
	(404089, 124, '2015-02-15 00:19:27.000000', 'consum', 0.0220, 'lps'),
	(404090, 124, '2015-02-15 00:19:28.000000', 'consum', 0.0219, 'lps'),
	(404091, 124, '2015-02-15 00:19:29.000000', 'consum', 0.0213, 'lps'),
	(404092, 124, '2015-02-15 00:19:30.000000', 'consum', 0.0213, 'lps'),
	(404093, 124, '2015-02-15 00:19:31.000000', 'consum', 0.0214, 'lps'),
	(404094, 124, '2015-02-15 00:19:32.000000', 'consum', 0.0221, 'lps'),
	(404095, 124, '2015-02-15 00:19:33.000000', 'consum', 0.0219, 'lps'),
	(404096, 124, '2015-02-15 00:19:34.000000', 'consum', 0.0211, 'lps'),
	(404097, 124, '2015-02-15 00:19:35.000000', 'consum', 0.0210, 'lps'),
	(404098, 124, '2015-02-15 00:19:36.000000', 'consum', 0.0220, 'lps'),
	(404099, 124, '2015-02-15 00:19:37.000000', 'consum', 0.0214, 'lps'),
	(404100, 124, '2015-02-15 00:19:38.000000', 'consum', 0.0213, 'lps'),
	(404101, 124, '2015-02-15 00:19:39.000000', 'consum', 0.0212, 'lps'),
	(404102, 124, '2015-02-15 00:19:40.000000', 'consum', 0.0210, 'lps'),
	(404103, 124, '2015-02-15 00:19:41.000000', 'consum', 0.0220, 'lps'),
	(404104, 124, '2015-02-15 00:19:42.000000', 'consum', 0.0210, 'lps'),
	(404105, 124, '2015-02-15 00:19:43.000000', 'consum', 0.0218, 'lps'),
	(404106, 124, '2015-02-15 00:19:44.000000', 'consum', 0.0216, 'lps'),
	(404107, 124, '2015-02-15 00:19:45.000000', 'consum', 0.0213, 'lps'),
	(404108, 124, '2015-02-15 00:19:46.000000', 'consum', 0.0221, 'lps'),
	(404109, 124, '2015-02-15 00:19:47.000000', 'consum', 0.0210, 'lps'),
	(404110, 124, '2015-02-15 00:19:48.000000', 'consum', 0.0211, 'lps'),
	(404111, 124, '2015-02-15 00:19:49.000000', 'consum', 0.0218, 'lps'),
	(404112, 124, '2015-02-15 00:19:50.000000', 'consum', 0.0211, 'lps'),
	(404113, 124, '2015-02-15 00:19:51.000000', 'consum', 0.0215, 'lps'),
	(404114, 124, '2015-02-15 00:19:52.000000', 'consum', 0.0219, 'lps'),
	(404115, 124, '2015-02-15 00:19:53.000000', 'consum', 0.0216, 'lps'),
	(404116, 124, '2015-02-15 00:19:54.000000', 'consum', 0.0216, 'lps'),
	(404117, 124, '2015-02-15 00:19:55.000000', 'consum', 0.0210, 'lps'),
	(404118, 124, '2015-02-15 00:19:56.000000', 'consum', 0.0215, 'lps'),
	(404119, 124, '2015-02-15 00:19:57.000000', 'consum', 0.0211, 'lps'),
	(404120, 124, '2015-02-15 00:19:58.000000', 'consum', 0.0213, 'lps'),
	(404121, 124, '2015-02-15 00:19:59.000000', 'consum', 0.0211, 'lps'),
	(404122, 124, '2015-02-15 00:20:00.000000', 'consum', 0.0220, 'lps'),
	(404123, 124, '2015-02-15 00:20:01.000000', 'consum', 0.0220, 'lps'),
	(404124, 124, '2015-02-15 00:20:02.000000', 'consum', 0.0218, 'lps'),
	(404125, 124, '2015-02-15 00:20:03.000000', 'consum', 0.0219, 'lps'),
	(404126, 124, '2015-02-15 00:20:04.000000', 'consum', 0.0221, 'lps'),
	(404127, 124, '2015-02-15 00:20:05.000000', 'consum', 0.0215, 'lps'),
	(404128, 124, '2015-02-15 00:20:06.000000', 'consum', 0.0215, 'lps'),
	(404129, 124, '2015-02-15 00:20:07.000000', 'consum', 0.0220, 'lps'),
	(404130, 124, '2015-02-15 00:20:08.000000', 'consum', 0.0211, 'lps'),
	(404131, 124, '2015-02-15 00:20:09.000000', 'consum', 0.0219, 'lps'),
	(404132, 124, '2015-02-15 00:20:10.000000', 'consum', 0.0217, 'lps'),
	(404133, 124, '2015-02-15 00:20:11.000000', 'consum', 0.0220, 'lps'),
	(404134, 124, '2015-02-15 00:20:12.000000', 'consum', 0.0213, 'lps'),
	(404135, 124, '2015-02-15 00:20:13.000000', 'consum', 0.0220, 'lps'),
	(404136, 124, '2015-02-15 00:20:14.000000', 'consum', 0.0218, 'lps'),
	(404137, 124, '2015-02-15 00:20:15.000000', 'consum', 0.0219, 'lps'),
	(404138, 124, '2015-02-15 00:20:16.000000', 'consum', 0.0221, 'lps'),
	(404139, 124, '2015-02-15 00:20:17.000000', 'consum', 0.0213, 'lps'),
	(404140, 124, '2015-02-15 00:20:18.000000', 'consum', 0.0216, 'lps'),
	(404141, 124, '2015-02-15 00:20:19.000000', 'consum', 0.0220, 'lps'),
	(404142, 124, '2015-02-15 00:20:20.000000', 'consum', 0.0220, 'lps'),
	(404143, 124, '2015-02-15 00:20:21.000000', 'consum', 0.0218, 'lps'),
	(404144, 124, '2015-02-15 00:20:22.000000', 'consum', 0.0219, 'lps'),
	(404145, 124, '2015-02-15 00:20:23.000000', 'consum', 0.0221, 'lps'),
	(404146, 124, '2015-02-15 00:20:24.000000', 'consum', 0.0216, 'lps'),
	(404147, 124, '2015-02-15 00:20:25.000000', 'consum', 0.0216, 'lps'),
	(404148, 124, '2015-02-15 00:20:26.000000', 'consum', 0.0212, 'lps'),
	(404149, 124, '2015-02-15 00:20:27.000000', 'consum', 0.0214, 'lps'),
	(404150, 124, '2015-02-15 00:20:28.000000', 'consum', 0.0213, 'lps'),
	(404151, 124, '2015-02-15 00:20:29.000000', 'consum', 0.0212, 'lps'),
	(404152, 124, '2015-02-15 00:20:30.000000', 'consum', 0.0211, 'lps'),
	(404153, 124, '2015-02-15 00:20:31.000000', 'consum', 0.0221, 'lps'),
	(404154, 124, '2015-02-15 00:20:32.000000', 'consum', 0.0216, 'lps'),
	(404155, 124, '2015-02-15 00:20:33.000000', 'consum', 0.0219, 'lps'),
	(404156, 124, '2015-02-15 00:20:34.000000', 'consum', 0.0215, 'lps'),
	(404157, 124, '2015-02-15 00:20:35.000000', 'consum', 0.0221, 'lps'),
	(404158, 124, '2015-02-15 00:20:36.000000', 'consum', 0.0212, 'lps'),
	(404159, 124, '2015-02-15 00:20:37.000000', 'consum', 0.0214, 'lps'),
	(404160, 124, '2015-02-15 00:20:38.000000', 'consum', 0.0212, 'lps'),
	(404161, 124, '2015-02-15 00:20:39.000000', 'consum', 0.0220, 'lps'),
	(404162, 124, '2015-02-15 00:20:40.000000', 'consum', 0.0220, 'lps'),
	(404163, 124, '2015-02-15 00:20:41.000000', 'consum', 0.0215, 'lps'),
	(404164, 124, '2015-02-15 00:20:42.000000', 'consum', 0.0221, 'lps'),
	(404165, 124, '2015-02-15 00:20:43.000000', 'consum', 0.0214, 'lps'),
	(404166, 124, '2015-02-15 00:20:44.000000', 'consum', 0.0221, 'lps'),
	(404167, 124, '2015-02-15 00:20:45.000000', 'consum', 0.0217, 'lps'),
	(404168, 124, '2015-02-15 00:20:46.000000', 'consum', 0.0212, 'lps'),
	(404169, 124, '2015-02-15 00:20:47.000000', 'consum', 0.0210, 'lps'),
	(404170, 124, '2015-02-15 00:20:48.000000', 'consum', 0.0220, 'lps'),
	(404171, 124, '2015-02-15 00:20:49.000000', 'consum', 0.0210, 'lps'),
	(404172, 124, '2015-02-15 00:20:50.000000', 'consum', 0.0218, 'lps'),
	(404173, 124, '2015-02-15 00:20:51.000000', 'consum', 0.0213, 'lps'),
	(404174, 124, '2015-02-15 00:20:52.000000', 'consum', 0.0216, 'lps'),
	(404175, 124, '2015-02-15 00:20:53.000000', 'consum', 0.0219, 'lps'),
	(404176, 124, '2015-02-15 00:20:54.000000', 'consum', 0.0212, 'lps'),
	(404177, 124, '2015-02-15 00:20:55.000000', 'consum', 0.0218, 'lps'),
	(404178, 124, '2015-02-15 00:20:56.000000', 'consum', 0.0221, 'lps'),
	(404179, 124, '2015-02-15 00:20:57.000000', 'consum', 0.0218, 'lps'),
	(404180, 124, '2015-02-15 00:20:58.000000', 'consum', 0.0219, 'lps'),
	(404181, 124, '2015-02-15 00:20:59.000000', 'consum', 0.0218, 'lps'),
	(404182, 124, '2015-02-15 00:21:00.000000', 'consum', 0.0210, 'lps'),
	(404183, 124, '2015-02-15 00:21:01.000000', 'consum', 0.0211, 'lps'),
	(404184, 124, '2015-02-15 00:21:02.000000', 'consum', 0.0217, 'lps'),
	(404185, 124, '2015-02-15 00:21:03.000000', 'consum', 0.0219, 'lps'),
	(404186, 124, '2015-02-15 00:21:04.000000', 'consum', 0.0220, 'lps'),
	(404187, 124, '2015-02-15 00:21:05.000000', 'consum', 0.0212, 'lps'),
	(404188, 124, '2015-02-15 00:21:06.000000', 'consum', 0.0214, 'lps'),
	(404189, 124, '2015-02-15 00:21:07.000000', 'consum', 0.0212, 'lps'),
	(404190, 124, '2015-02-15 00:21:08.000000', 'consum', 0.0210, 'lps'),
	(404191, 124, '2015-02-15 00:21:09.000000', 'consum', 0.0216, 'lps'),
	(404192, 124, '2015-02-15 00:21:10.000000', 'consum', 0.0217, 'lps'),
	(404193, 124, '2015-02-15 00:21:11.000000', 'consum', 0.0213, 'lps'),
	(404194, 124, '2015-02-15 00:21:12.000000', 'consum', 0.0218, 'lps'),
	(404195, 124, '2015-02-15 00:21:13.000000', 'consum', 0.0219, 'lps'),
	(404196, 124, '2015-02-15 00:21:14.000000', 'consum', 0.0219, 'lps'),
	(404197, 124, '2015-02-15 00:21:15.000000', 'consum', 0.0217, 'lps'),
	(404198, 124, '2015-02-15 00:21:16.000000', 'consum', 0.0217, 'lps'),
	(404199, 124, '2015-02-15 00:21:17.000000', 'consum', 0.0214, 'lps'),
	(404200, 124, '2015-02-15 00:21:18.000000', 'consum', 0.0220, 'lps'),
	(404201, 124, '2015-02-15 00:21:19.000000', 'consum', 0.0213, 'lps'),
	(404202, 124, '2015-02-15 00:21:20.000000', 'consum', 0.0221, 'lps'),
	(404203, 124, '2015-02-15 00:21:21.000000', 'consum', 0.0218, 'lps'),
	(404204, 124, '2015-02-15 00:21:22.000000', 'consum', 0.0218, 'lps'),
	(404205, 124, '2015-02-15 00:21:23.000000', 'consum', 0.0216, 'lps'),
	(404206, 124, '2015-02-15 00:21:24.000000', 'consum', 0.0214, 'lps'),
	(404207, 124, '2015-02-15 00:21:25.000000', 'consum', 0.0213, 'lps'),
	(404208, 124, '2015-02-15 00:21:26.000000', 'consum', 0.0216, 'lps'),
	(404209, 124, '2015-02-15 00:21:27.000000', 'consum', 0.0216, 'lps'),
	(404210, 124, '2015-02-15 00:21:28.000000', 'consum', 0.0213, 'lps'),
	(404211, 124, '2015-02-15 00:21:29.000000', 'consum', 0.0217, 'lps'),
	(404212, 124, '2015-02-15 00:21:30.000000', 'consum', 0.0214, 'lps'),
	(404213, 124, '2015-02-15 00:21:31.000000', 'consum', 0.0221, 'lps'),
	(404214, 124, '2015-02-15 00:21:32.000000', 'consum', 0.0219, 'lps'),
	(404215, 124, '2015-02-15 00:21:33.000000', 'consum', 0.0211, 'lps'),
	(404216, 124, '2015-02-15 00:21:34.000000', 'consum', 0.0211, 'lps'),
	(404217, 124, '2015-02-15 00:21:35.000000', 'consum', 0.0214, 'lps'),
	(404218, 124, '2015-02-15 00:21:36.000000', 'consum', 0.0215, 'lps'),
	(404219, 124, '2015-02-15 00:21:37.000000', 'consum', 0.0221, 'lps'),
	(404220, 124, '2015-02-15 00:21:38.000000', 'consum', 0.0218, 'lps'),
	(404221, 124, '2015-02-15 00:21:39.000000', 'consum', 0.0215, 'lps'),
	(404222, 124, '2015-02-15 00:21:40.000000', 'consum', 0.0212, 'lps'),
	(404223, 124, '2015-02-15 00:21:41.000000', 'consum', 0.0219, 'lps'),
	(404224, 124, '2015-02-15 00:21:42.000000', 'consum', 0.0213, 'lps'),
	(404225, 124, '2015-02-15 00:21:43.000000', 'consum', 0.0212, 'lps'),
	(404226, 124, '2015-02-15 00:21:44.000000', 'consum', 0.0221, 'lps'),
	(404227, 124, '2015-02-15 00:21:45.000000', 'consum', 0.0210, 'lps'),
	(404228, 124, '2015-02-15 00:21:46.000000', 'consum', 0.0217, 'lps'),
	(404229, 124, '2015-02-15 00:21:47.000000', 'consum', 0.0221, 'lps'),
	(404230, 124, '2015-02-15 00:21:48.000000', 'consum', 0.0210, 'lps'),
	(404231, 124, '2015-02-15 00:21:49.000000', 'consum', 0.0210, 'lps'),
	(404232, 124, '2015-02-15 00:21:50.000000', 'consum', 0.0212, 'lps'),
	(404233, 124, '2015-02-15 00:21:51.000000', 'consum', 0.0210, 'lps'),
	(404234, 124, '2015-02-15 00:21:52.000000', 'consum', 0.0216, 'lps'),
	(404235, 124, '2015-02-15 00:21:53.000000', 'consum', 0.0218, 'lps'),
	(404236, 124, '2015-02-15 00:21:54.000000', 'consum', 0.0219, 'lps'),
	(404237, 124, '2015-02-15 00:21:55.000000', 'consum', 0.0221, 'lps'),
	(404238, 124, '2015-02-15 00:21:56.000000', 'consum', 0.0212, 'lps'),
	(404239, 124, '2015-02-15 00:21:57.000000', 'consum', 0.0212, 'lps'),
	(404240, 124, '2015-02-15 00:21:58.000000', 'consum', 0.0215, 'lps'),
	(404241, 124, '2015-02-15 00:21:59.000000', 'consum', 0.0219, 'lps'),
	(404242, 124, '2015-02-15 00:22:00.000000', 'consum', 0.0217, 'lps'),
	(404243, 124, '2015-02-15 00:22:01.000000', 'consum', 0.0219, 'lps'),
	(404244, 124, '2015-02-15 00:22:02.000000', 'consum', 0.0220, 'lps'),
	(404245, 124, '2015-02-15 00:22:03.000000', 'consum', 0.0212, 'lps'),
	(404246, 124, '2015-02-15 00:22:04.000000', 'consum', 0.0215, 'lps'),
	(404247, 124, '2015-02-15 00:22:05.000000', 'consum', 0.0217, 'lps'),
	(404248, 124, '2015-02-15 00:22:06.000000', 'consum', 0.0218, 'lps'),
	(404249, 124, '2015-02-15 00:22:07.000000', 'consum', 0.0216, 'lps'),
	(404250, 124, '2015-02-15 00:22:08.000000', 'consum', 0.0217, 'lps'),
	(404251, 124, '2015-02-15 00:22:09.000000', 'consum', 0.0218, 'lps'),
	(404252, 124, '2015-02-15 00:22:10.000000', 'consum', 0.0216, 'lps'),
	(404253, 124, '2015-02-15 00:22:11.000000', 'consum', 0.0216, 'lps'),
	(404254, 124, '2015-02-15 00:22:12.000000', 'consum', 0.0213, 'lps'),
	(404255, 124, '2015-02-15 00:22:13.000000', 'consum', 0.0217, 'lps'),
	(404256, 124, '2015-02-15 00:22:14.000000', 'consum', 0.0214, 'lps'),
	(404257, 124, '2015-02-15 00:22:15.000000', 'consum', 0.0211, 'lps'),
	(404258, 124, '2015-02-15 00:22:16.000000', 'consum', 0.0213, 'lps'),
	(404259, 124, '2015-02-15 00:22:17.000000', 'consum', 0.0210, 'lps'),
	(404260, 124, '2015-02-15 00:22:18.000000', 'consum', 0.0214, 'lps'),
	(404261, 124, '2015-02-15 00:22:19.000000', 'consum', 0.0220, 'lps'),
	(404262, 124, '2015-02-15 00:22:20.000000', 'consum', 0.0213, 'lps'),
	(404263, 124, '2015-02-15 00:22:21.000000', 'consum', 0.0218, 'lps'),
	(404264, 124, '2015-02-15 00:22:22.000000', 'consum', 0.0219, 'lps'),
	(404265, 124, '2015-02-15 00:22:23.000000', 'consum', 0.0218, 'lps'),
	(404266, 124, '2015-02-15 00:22:24.000000', 'consum', 0.0213, 'lps'),
	(404267, 124, '2015-02-15 00:22:25.000000', 'consum', 0.0212, 'lps'),
	(404268, 124, '2015-02-15 00:22:26.000000', 'consum', 0.0214, 'lps'),
	(404269, 124, '2015-02-15 00:22:27.000000', 'consum', 0.0211, 'lps'),
	(404270, 124, '2015-02-15 00:22:28.000000', 'consum', 0.0214, 'lps'),
	(404271, 124, '2015-02-15 00:22:29.000000', 'consum', 0.0219, 'lps'),
	(404272, 124, '2015-02-15 00:22:30.000000', 'consum', 0.0217, 'lps'),
	(404273, 124, '2015-02-15 00:22:31.000000', 'consum', 0.0217, 'lps'),
	(404274, 124, '2015-02-15 00:22:32.000000', 'consum', 0.0215, 'lps'),
	(404275, 124, '2015-02-15 00:22:33.000000', 'consum', 0.0213, 'lps'),
	(404276, 124, '2015-02-15 00:22:34.000000', 'consum', 0.0213, 'lps'),
	(404277, 124, '2015-02-15 00:22:35.000000', 'consum', 0.0213, 'lps'),
	(404278, 124, '2015-02-15 00:22:36.000000', 'consum', 0.0220, 'lps'),
	(404279, 124, '2015-02-15 00:22:37.000000', 'consum', 0.0215, 'lps'),
	(404280, 124, '2015-02-15 00:22:38.000000', 'consum', 0.0215, 'lps'),
	(404281, 124, '2015-02-15 00:22:39.000000', 'consum', 0.0210, 'lps'),
	(404282, 124, '2015-02-15 00:22:40.000000', 'consum', 0.0217, 'lps'),
	(404283, 124, '2015-02-15 00:22:41.000000', 'consum', 0.0212, 'lps'),
	(404284, 124, '2015-02-15 00:22:42.000000', 'consum', 0.0212, 'lps'),
	(404285, 124, '2015-02-15 00:22:43.000000', 'consum', 0.0213, 'lps'),
	(404286, 124, '2015-02-15 00:22:44.000000', 'consum', 0.0221, 'lps'),
	(404287, 124, '2015-02-15 00:22:45.000000', 'consum', 0.0210, 'lps'),
	(404288, 124, '2015-02-15 00:22:46.000000', 'consum', 0.0212, 'lps'),
	(404289, 124, '2015-02-15 00:22:47.000000', 'consum', 0.0219, 'lps'),
	(404290, 124, '2015-02-15 00:22:48.000000', 'consum', 0.0213, 'lps'),
	(404291, 124, '2015-02-15 00:22:49.000000', 'consum', 0.0213, 'lps'),
	(404292, 124, '2015-02-15 00:22:50.000000', 'consum', 0.0214, 'lps'),
	(404293, 124, '2015-02-15 00:22:51.000000', 'consum', 0.0211, 'lps'),
	(404294, 124, '2015-02-15 00:22:52.000000', 'consum', 0.0214, 'lps'),
	(404295, 124, '2015-02-15 00:22:53.000000', 'consum', 0.0217, 'lps'),
	(404296, 124, '2015-02-15 00:22:54.000000', 'consum', 0.0210, 'lps'),
	(404297, 124, '2015-02-15 00:22:55.000000', 'consum', 0.0213, 'lps'),
	(404298, 124, '2015-02-15 00:22:56.000000', 'consum', 0.0212, 'lps'),
	(404299, 124, '2015-02-15 00:22:57.000000', 'consum', 0.0213, 'lps'),
	(404300, 124, '2015-02-15 00:22:58.000000', 'consum', 0.0220, 'lps'),
	(404301, 124, '2015-02-15 00:22:59.000000', 'consum', 0.0214, 'lps'),
	(404302, 124, '2015-02-15 00:23:00.000000', 'consum', 0.0212, 'lps'),
	(404303, 124, '2015-02-15 00:23:01.000000', 'consum', 0.0210, 'lps'),
	(404304, 124, '2015-02-15 00:23:02.000000', 'consum', 0.0215, 'lps'),
	(404305, 124, '2015-02-15 00:23:03.000000', 'consum', 0.0211, 'lps'),
	(404306, 124, '2015-02-15 00:23:04.000000', 'consum', 0.0214, 'lps'),
	(404307, 124, '2015-02-15 00:23:05.000000', 'consum', 0.0213, 'lps'),
	(404308, 124, '2015-02-15 00:23:06.000000', 'consum', 0.0216, 'lps'),
	(404309, 124, '2015-02-15 00:23:07.000000', 'consum', 0.0219, 'lps'),
	(404310, 124, '2015-02-15 00:23:08.000000', 'consum', 0.0215, 'lps'),
	(404311, 124, '2015-02-15 00:23:09.000000', 'consum', 0.0219, 'lps'),
	(404312, 124, '2015-02-15 00:23:10.000000', 'consum', 0.0215, 'lps'),
	(404313, 124, '2015-02-15 00:23:11.000000', 'consum', 0.0221, 'lps'),
	(404314, 124, '2015-02-15 00:23:12.000000', 'consum', 0.0213, 'lps'),
	(404315, 124, '2015-02-15 00:23:13.000000', 'consum', 0.0218, 'lps'),
	(404316, 124, '2015-02-15 00:23:14.000000', 'consum', 0.0215, 'lps'),
	(404317, 124, '2015-02-15 00:23:15.000000', 'consum', 0.0215, 'lps'),
	(404318, 124, '2015-02-15 00:23:16.000000', 'consum', 0.0219, 'lps'),
	(404319, 124, '2015-02-15 00:23:17.000000', 'consum', 0.0218, 'lps'),
	(404320, 124, '2015-02-15 00:23:18.000000', 'consum', 0.0211, 'lps'),
	(404321, 124, '2015-02-15 00:23:19.000000', 'consum', 0.0215, 'lps'),
	(404322, 124, '2015-02-15 00:23:20.000000', 'consum', 0.0211, 'lps'),
	(404323, 124, '2015-02-15 00:23:21.000000', 'consum', 0.0221, 'lps'),
	(404324, 124, '2015-02-15 00:23:22.000000', 'consum', 0.0217, 'lps'),
	(404325, 124, '2015-02-15 00:23:23.000000', 'consum', 0.0211, 'lps'),
	(404326, 124, '2015-02-15 00:23:24.000000', 'consum', 0.0217, 'lps'),
	(404327, 124, '2015-02-15 00:23:25.000000', 'consum', 0.0220, 'lps'),
	(404328, 124, '2015-02-15 00:23:26.000000', 'consum', 0.0217, 'lps'),
	(404329, 124, '2015-02-15 00:23:27.000000', 'consum', 0.0215, 'lps'),
	(404330, 124, '2015-02-15 00:23:28.000000', 'consum', 0.0215, 'lps'),
	(404331, 124, '2015-02-15 00:23:29.000000', 'consum', 0.0220, 'lps'),
	(404332, 124, '2015-02-15 00:23:30.000000', 'consum', 0.0221, 'lps'),
	(404333, 124, '2015-02-15 00:23:31.000000', 'consum', 0.0210, 'lps'),
	(404334, 124, '2015-02-15 00:23:32.000000', 'consum', 0.0214, 'lps'),
	(404335, 124, '2015-02-15 00:23:33.000000', 'consum', 0.0219, 'lps'),
	(404336, 124, '2015-02-15 00:23:34.000000', 'consum', 0.0219, 'lps'),
	(404337, 124, '2015-02-15 00:23:35.000000', 'consum', 0.0215, 'lps'),
	(404338, 124, '2015-02-15 00:23:36.000000', 'consum', 0.0211, 'lps'),
	(404339, 124, '2015-02-15 00:23:37.000000', 'consum', 0.0211, 'lps'),
	(404340, 124, '2015-02-15 00:23:38.000000', 'consum', 0.0211, 'lps'),
	(404341, 124, '2015-02-15 00:23:39.000000', 'consum', 0.0216, 'lps'),
	(404342, 124, '2015-02-15 00:23:40.000000', 'consum', 0.0211, 'lps'),
	(404343, 124, '2015-02-15 00:23:41.000000', 'consum', 0.0212, 'lps'),
	(404344, 124, '2015-02-15 00:23:42.000000', 'consum', 0.0216, 'lps'),
	(404345, 124, '2015-02-15 00:23:43.000000', 'consum', 0.0221, 'lps'),
	(404346, 124, '2015-02-15 00:23:44.000000', 'consum', 0.0213, 'lps'),
	(404347, 124, '2015-02-15 00:23:45.000000', 'consum', 0.0217, 'lps'),
	(404348, 124, '2015-02-15 00:23:46.000000', 'consum', 0.0210, 'lps'),
	(404349, 124, '2015-02-15 00:23:47.000000', 'consum', 0.0217, 'lps'),
	(404350, 124, '2015-02-15 00:23:48.000000', 'consum', 0.0220, 'lps'),
	(404351, 124, '2015-02-15 00:23:49.000000', 'consum', 0.0213, 'lps'),
	(404352, 124, '2015-02-15 00:23:50.000000', 'consum', 0.0211, 'lps'),
	(404353, 124, '2015-02-15 00:23:51.000000', 'consum', 0.0217, 'lps'),
	(404354, 124, '2015-02-15 00:23:52.000000', 'consum', 0.0219, 'lps'),
	(404355, 124, '2015-02-15 00:23:53.000000', 'consum', 0.0211, 'lps'),
	(404356, 124, '2015-02-15 00:23:54.000000', 'consum', 0.0214, 'lps'),
	(404357, 124, '2015-02-15 00:23:55.000000', 'consum', 0.0214, 'lps'),
	(404358, 124, '2015-02-15 00:23:56.000000', 'consum', 0.0217, 'lps'),
	(404359, 124, '2015-02-15 00:23:57.000000', 'consum', 0.0210, 'lps'),
	(404360, 124, '2015-02-15 00:23:58.000000', 'consum', 0.0213, 'lps'),
	(404361, 124, '2015-02-15 00:23:59.000000', 'consum', 0.0212, 'lps'),
	(404362, 124, '2015-02-15 00:24:00.000000', 'consum', 0.0215, 'lps'),
	(404363, 124, '2015-02-15 00:24:01.000000', 'consum', 0.0217, 'lps'),
	(404364, 124, '2015-02-15 00:24:02.000000', 'consum', 0.0217, 'lps'),
	(404365, 124, '2015-02-15 00:24:03.000000', 'consum', 0.0211, 'lps'),
	(404366, 124, '2015-02-15 00:24:04.000000', 'consum', 0.0220, 'lps'),
	(404367, 124, '2015-02-15 00:24:05.000000', 'consum', 0.0211, 'lps'),
	(404368, 124, '2015-02-15 00:24:06.000000', 'consum', 0.0220, 'lps'),
	(404369, 124, '2015-02-15 00:24:07.000000', 'consum', 0.0210, 'lps'),
	(404370, 124, '2015-02-15 00:24:08.000000', 'consum', 0.0218, 'lps'),
	(404371, 124, '2015-02-15 00:24:09.000000', 'consum', 0.0214, 'lps'),
	(404372, 124, '2015-02-15 00:24:10.000000', 'consum', 0.0220, 'lps'),
	(404373, 124, '2015-02-15 00:24:11.000000', 'consum', 0.0221, 'lps'),
	(404374, 124, '2015-02-15 00:24:12.000000', 'consum', 0.0215, 'lps'),
	(404375, 124, '2015-02-15 00:24:13.000000', 'consum', 0.0213, 'lps'),
	(404376, 124, '2015-02-15 00:24:14.000000', 'consum', 0.0211, 'lps'),
	(404377, 124, '2015-02-15 00:24:15.000000', 'consum', 0.0218, 'lps'),
	(404378, 124, '2015-02-15 00:24:16.000000', 'consum', 0.0210, 'lps'),
	(404379, 124, '2015-02-15 00:24:17.000000', 'consum', 0.0211, 'lps'),
	(404380, 124, '2015-02-15 00:24:18.000000', 'consum', 0.0214, 'lps'),
	(404381, 124, '2015-02-15 00:24:19.000000', 'consum', 0.0218, 'lps'),
	(404382, 124, '2015-02-15 00:24:20.000000', 'consum', 0.0215, 'lps'),
	(404383, 124, '2015-02-15 00:24:21.000000', 'consum', 0.0211, 'lps'),
	(404384, 124, '2015-02-15 00:24:22.000000', 'consum', 0.0212, 'lps'),
	(404385, 124, '2015-02-15 00:24:23.000000', 'consum', 0.0217, 'lps'),
	(404386, 124, '2015-02-15 00:24:24.000000', 'consum', 0.0215, 'lps'),
	(404387, 124, '2015-02-15 00:24:25.000000', 'consum', 0.0214, 'lps'),
	(404388, 124, '2015-02-15 00:24:26.000000', 'consum', 0.0217, 'lps'),
	(404389, 124, '2015-02-15 00:24:27.000000', 'consum', 0.0211, 'lps'),
	(404390, 124, '2015-02-15 00:24:28.000000', 'consum', 0.0217, 'lps'),
	(404391, 124, '2015-02-15 00:24:29.000000', 'consum', 0.0218, 'lps'),
	(404392, 124, '2015-02-15 00:24:30.000000', 'consum', 0.0217, 'lps'),
	(404393, 124, '2015-02-15 00:24:31.000000', 'consum', 0.0210, 'lps'),
	(404394, 124, '2015-02-15 00:24:32.000000', 'consum', 0.0214, 'lps'),
	(404395, 124, '2015-02-15 00:24:33.000000', 'consum', 0.0217, 'lps'),
	(404396, 124, '2015-02-15 00:24:34.000000', 'consum', 0.0211, 'lps'),
	(404397, 124, '2015-02-15 00:24:35.000000', 'consum', 0.0218, 'lps'),
	(404398, 124, '2015-02-15 00:24:36.000000', 'consum', 0.0213, 'lps'),
	(404399, 124, '2015-02-15 00:24:37.000000', 'consum', 0.0211, 'lps'),
	(404400, 124, '2015-02-15 00:24:38.000000', 'consum', 0.0221, 'lps'),
	(404401, 124, '2015-02-15 00:24:39.000000', 'consum', 0.0212, 'lps'),
	(404402, 124, '2015-02-15 00:24:40.000000', 'consum', 0.0212, 'lps'),
	(404403, 124, '2015-02-15 00:24:41.000000', 'consum', 0.0214, 'lps'),
	(404404, 124, '2015-02-15 00:24:42.000000', 'consum', 0.0213, 'lps'),
	(404405, 124, '2015-02-15 00:24:43.000000', 'consum', 0.0213, 'lps'),
	(404406, 124, '2015-02-15 00:24:44.000000', 'consum', 0.0218, 'lps'),
	(404407, 124, '2015-02-15 00:24:45.000000', 'consum', 0.0217, 'lps'),
	(404408, 124, '2015-02-15 00:24:46.000000', 'consum', 0.0221, 'lps'),
	(404409, 124, '2015-02-15 00:24:47.000000', 'consum', 0.0219, 'lps'),
	(404410, 124, '2015-02-15 00:24:48.000000', 'consum', 0.0210, 'lps'),
	(404411, 124, '2015-02-15 00:24:49.000000', 'consum', 0.0210, 'lps'),
	(404412, 124, '2015-02-15 00:24:50.000000', 'consum', 0.0211, 'lps'),
	(404413, 124, '2015-02-15 00:24:51.000000', 'consum', 0.0213, 'lps'),
	(404414, 124, '2015-02-15 00:24:52.000000', 'consum', 0.0211, 'lps'),
	(404415, 124, '2015-02-15 00:24:53.000000', 'consum', 0.0220, 'lps'),
	(404416, 124, '2015-02-15 00:24:54.000000', 'consum', 0.0221, 'lps'),
	(404417, 124, '2015-02-15 00:24:55.000000', 'consum', 0.0210, 'lps'),
	(404418, 124, '2015-02-15 00:24:56.000000', 'consum', 0.0213, 'lps'),
	(404419, 124, '2015-02-15 00:24:57.000000', 'consum', 0.0217, 'lps'),
	(404420, 124, '2015-02-15 00:24:58.000000', 'consum', 0.0221, 'lps'),
	(404421, 124, '2015-02-15 00:24:59.000000', 'consum', 0.0210, 'lps'),
	(404422, 124, '2015-02-15 00:25:00.000000', 'consum', 0.0214, 'lps'),
	(404423, 124, '2015-02-15 00:25:01.000000', 'consum', 0.0217, 'lps'),
	(404424, 124, '2015-02-15 00:25:02.000000', 'consum', 0.0211, 'lps'),
	(404425, 124, '2015-02-15 00:25:03.000000', 'consum', 0.0216, 'lps'),
	(404426, 124, '2015-02-15 00:25:04.000000', 'consum', 0.0215, 'lps'),
	(404427, 124, '2015-02-15 00:25:05.000000', 'consum', 0.0215, 'lps'),
	(404428, 124, '2015-02-15 00:25:06.000000', 'consum', 0.0212, 'lps'),
	(404429, 124, '2015-02-15 00:25:07.000000', 'consum', 0.0217, 'lps'),
	(404430, 124, '2015-02-15 00:25:08.000000', 'consum', 0.0214, 'lps'),
	(404431, 124, '2015-02-15 00:25:09.000000', 'consum', 0.0211, 'lps'),
	(404432, 124, '2015-02-15 00:25:10.000000', 'consum', 0.0215, 'lps'),
	(404433, 124, '2015-02-15 00:25:11.000000', 'consum', 0.0219, 'lps'),
	(404434, 124, '2015-02-15 00:25:12.000000', 'consum', 0.0219, 'lps'),
	(404435, 124, '2015-02-15 00:25:13.000000', 'consum', 0.0214, 'lps'),
	(404436, 124, '2015-02-15 00:25:14.000000', 'consum', 0.0215, 'lps'),
	(404437, 124, '2015-02-15 00:25:15.000000', 'consum', 0.0211, 'lps'),
	(404438, 124, '2015-02-15 00:25:16.000000', 'consum', 0.0215, 'lps'),
	(404439, 124, '2015-02-15 00:25:17.000000', 'consum', 0.0221, 'lps'),
	(404440, 124, '2015-02-15 00:25:18.000000', 'consum', 0.0214, 'lps'),
	(404441, 124, '2015-02-15 00:25:19.000000', 'consum', 0.0210, 'lps'),
	(404442, 124, '2015-02-15 00:25:20.000000', 'consum', 0.0210, 'lps'),
	(404443, 124, '2015-02-15 00:25:21.000000', 'consum', 0.0211, 'lps'),
	(404444, 124, '2015-02-15 00:25:22.000000', 'consum', 0.0214, 'lps'),
	(404445, 124, '2015-02-15 00:25:23.000000', 'consum', 0.0214, 'lps'),
	(404446, 124, '2015-02-15 00:25:24.000000', 'consum', 0.0210, 'lps'),
	(404447, 124, '2015-02-15 00:25:25.000000', 'consum', 0.0219, 'lps'),
	(404448, 124, '2015-02-15 00:25:26.000000', 'consum', 0.0210, 'lps'),
	(404449, 124, '2015-02-15 00:25:27.000000', 'consum', 0.0220, 'lps'),
	(404450, 124, '2015-02-15 00:25:28.000000', 'consum', 0.0214, 'lps'),
	(404451, 124, '2015-02-15 00:25:29.000000', 'consum', 0.0210, 'lps'),
	(404452, 124, '2015-02-15 00:25:30.000000', 'consum', 0.0212, 'lps'),
	(404453, 124, '2015-02-15 00:25:31.000000', 'consum', 0.0218, 'lps'),
	(404454, 124, '2015-02-15 00:25:32.000000', 'consum', 0.0221, 'lps'),
	(404455, 124, '2015-02-15 00:25:33.000000', 'consum', 0.0217, 'lps'),
	(404456, 124, '2015-02-15 00:25:34.000000', 'consum', 0.0213, 'lps'),
	(404457, 124, '2015-02-15 00:25:35.000000', 'consum', 0.0218, 'lps'),
	(404458, 124, '2015-02-15 00:25:36.000000', 'consum', 0.0215, 'lps'),
	(404459, 124, '2015-02-15 00:25:37.000000', 'consum', 0.0214, 'lps'),
	(404460, 124, '2015-02-15 00:25:38.000000', 'consum', 0.0216, 'lps'),
	(404461, 124, '2015-02-15 00:25:39.000000', 'consum', 0.0217, 'lps'),
	(404462, 124, '2015-02-15 00:25:40.000000', 'consum', 0.0215, 'lps'),
	(404463, 124, '2015-02-15 00:25:41.000000', 'consum', 0.0216, 'lps'),
	(404464, 124, '2015-02-15 00:25:42.000000', 'consum', 0.0212, 'lps'),
	(404465, 124, '2015-02-15 00:25:43.000000', 'consum', 0.0215, 'lps'),
	(404466, 124, '2015-02-15 00:25:44.000000', 'consum', 0.0219, 'lps'),
	(404467, 124, '2015-02-15 00:25:45.000000', 'consum', 0.0215, 'lps'),
	(404468, 124, '2015-02-15 00:25:46.000000', 'consum', 0.0219, 'lps'),
	(404469, 124, '2015-02-15 00:25:47.000000', 'consum', 0.0219, 'lps'),
	(404470, 124, '2015-02-15 00:25:48.000000', 'consum', 0.0216, 'lps'),
	(404471, 124, '2015-02-15 00:25:49.000000', 'consum', 0.0214, 'lps'),
	(404472, 124, '2015-02-15 00:25:50.000000', 'consum', 0.0213, 'lps'),
	(404473, 124, '2015-02-15 00:25:51.000000', 'consum', 0.0213, 'lps'),
	(404474, 124, '2015-02-15 00:25:52.000000', 'consum', 0.0218, 'lps'),
	(404475, 124, '2015-02-15 00:25:53.000000', 'consum', 0.0218, 'lps'),
	(404476, 124, '2015-02-15 00:25:54.000000', 'consum', 0.0214, 'lps'),
	(404477, 124, '2015-02-15 00:25:55.000000', 'consum', 0.0218, 'lps'),
	(404478, 124, '2015-02-15 00:25:56.000000', 'consum', 0.0213, 'lps'),
	(404479, 124, '2015-02-15 00:25:57.000000', 'consum', 0.0213, 'lps'),
	(404480, 124, '2015-02-15 00:25:58.000000', 'consum', 0.0218, 'lps'),
	(404481, 124, '2015-02-15 00:25:59.000000', 'consum', 0.0218, 'lps'),
	(404482, 124, '2015-02-15 00:26:00.000000', 'consum', 0.0215, 'lps'),
	(404483, 124, '2015-02-15 00:26:01.000000', 'consum', 0.0211, 'lps'),
	(404484, 124, '2015-02-15 00:26:02.000000', 'consum', 0.0212, 'lps'),
	(404485, 124, '2015-02-15 00:26:03.000000', 'consum', 0.0218, 'lps'),
	(404486, 124, '2015-02-15 00:26:04.000000', 'consum', 0.0210, 'lps'),
	(404487, 124, '2015-02-15 00:26:05.000000', 'consum', 0.0211, 'lps'),
	(404488, 124, '2015-02-15 00:26:06.000000', 'consum', 0.0215, 'lps'),
	(404489, 124, '2015-02-15 00:26:07.000000', 'consum', 0.0219, 'lps'),
	(404490, 124, '2015-02-15 00:26:08.000000', 'consum', 0.0218, 'lps'),
	(404491, 124, '2015-02-15 00:26:09.000000', 'consum', 0.0211, 'lps'),
	(404492, 124, '2015-02-15 00:26:10.000000', 'consum', 0.0216, 'lps'),
	(404493, 124, '2015-02-15 00:26:11.000000', 'consum', 0.0213, 'lps'),
	(404494, 124, '2015-02-15 00:26:12.000000', 'consum', 0.0220, 'lps'),
	(404495, 124, '2015-02-15 00:26:13.000000', 'consum', 0.0216, 'lps'),
	(404496, 124, '2015-02-15 00:26:14.000000', 'consum', 0.0210, 'lps'),
	(404497, 124, '2015-02-15 00:26:15.000000', 'consum', 0.0217, 'lps'),
	(404498, 124, '2015-02-15 00:26:16.000000', 'consum', 0.0210, 'lps'),
	(404499, 124, '2015-02-15 00:26:17.000000', 'consum', 0.0212, 'lps'),
	(404500, 124, '2015-02-15 00:26:18.000000', 'consum', 0.0219, 'lps'),
	(404501, 124, '2015-02-15 00:26:19.000000', 'consum', 0.0215, 'lps'),
	(404502, 124, '2015-02-15 00:26:20.000000', 'consum', 0.0210, 'lps'),
	(404503, 124, '2015-02-15 00:26:21.000000', 'consum', 0.0220, 'lps'),
	(404504, 124, '2015-02-15 00:26:22.000000', 'consum', 0.0213, 'lps'),
	(404505, 124, '2015-02-15 00:26:23.000000', 'consum', 0.0220, 'lps'),
	(404506, 124, '2015-02-15 00:26:24.000000', 'consum', 0.0216, 'lps'),
	(404507, 124, '2015-02-15 00:26:25.000000', 'consum', 0.0220, 'lps'),
	(404508, 124, '2015-02-15 00:26:26.000000', 'consum', 0.0220, 'lps'),
	(404509, 124, '2015-02-15 00:26:27.000000', 'consum', 0.0219, 'lps'),
	(404510, 124, '2015-02-15 00:26:28.000000', 'consum', 0.0214, 'lps'),
	(404511, 124, '2015-02-15 00:26:29.000000', 'consum', 0.0213, 'lps'),
	(404512, 124, '2015-02-15 00:26:30.000000', 'consum', 0.0213, 'lps'),
	(404513, 124, '2015-02-15 00:26:31.000000', 'consum', 0.0219, 'lps'),
	(404514, 124, '2015-02-15 00:26:32.000000', 'consum', 0.0220, 'lps'),
	(404515, 124, '2015-02-15 00:26:33.000000', 'consum', 0.0210, 'lps'),
	(404516, 124, '2015-02-15 00:26:34.000000', 'consum', 0.0219, 'lps'),
	(404517, 124, '2015-02-15 00:26:35.000000', 'consum', 0.0217, 'lps'),
	(404518, 124, '2015-02-15 00:26:36.000000', 'consum', 0.0219, 'lps'),
	(404519, 124, '2015-02-15 00:26:37.000000', 'consum', 0.0221, 'lps'),
	(404520, 124, '2015-02-15 00:26:38.000000', 'consum', 0.0217, 'lps'),
	(404521, 124, '2015-02-15 00:26:39.000000', 'consum', 0.0212, 'lps'),
	(404522, 124, '2015-02-15 00:26:40.000000', 'consum', 0.0210, 'lps'),
	(404523, 124, '2015-02-15 00:26:41.000000', 'consum', 0.0217, 'lps'),
	(404524, 124, '2015-02-15 00:26:42.000000', 'consum', 0.0210, 'lps'),
	(404525, 124, '2015-02-15 00:26:43.000000', 'consum', 0.0211, 'lps'),
	(404526, 124, '2015-02-15 00:26:44.000000', 'consum', 0.0219, 'lps'),
	(404527, 124, '2015-02-15 00:26:45.000000', 'consum', 0.0214, 'lps'),
	(404528, 124, '2015-02-15 00:26:46.000000', 'consum', 0.0218, 'lps'),
	(404529, 124, '2015-02-15 00:26:47.000000', 'consum', 0.0212, 'lps'),
	(404530, 124, '2015-02-15 00:26:48.000000', 'consum', 0.0210, 'lps'),
	(404531, 124, '2015-02-15 00:26:49.000000', 'consum', 0.0217, 'lps'),
	(404532, 124, '2015-02-15 00:26:50.000000', 'consum', 0.0221, 'lps'),
	(404533, 124, '2015-02-15 00:26:51.000000', 'consum', 0.0220, 'lps'),
	(404534, 124, '2015-02-15 00:26:52.000000', 'consum', 0.0214, 'lps'),
	(404535, 124, '2015-02-15 00:26:53.000000', 'consum', 0.0214, 'lps'),
	(404536, 124, '2015-02-15 00:26:54.000000', 'consum', 0.0216, 'lps'),
	(404537, 124, '2015-02-15 00:26:55.000000', 'consum', 0.0219, 'lps'),
	(404538, 124, '2015-02-15 00:26:56.000000', 'consum', 0.0214, 'lps'),
	(404539, 124, '2015-02-15 00:26:57.000000', 'consum', 0.0216, 'lps'),
	(404540, 124, '2015-02-15 00:26:58.000000', 'consum', 0.0215, 'lps'),
	(404541, 124, '2015-02-15 00:26:59.000000', 'consum', 0.0217, 'lps'),
	(404542, 124, '2015-02-15 00:27:00.000000', 'consum', 0.0221, 'lps'),
	(404543, 124, '2015-02-15 00:27:01.000000', 'consum', 0.0220, 'lps'),
	(404544, 124, '2015-02-15 00:27:02.000000', 'consum', 0.0214, 'lps'),
	(404545, 124, '2015-02-15 00:27:03.000000', 'consum', 0.0212, 'lps'),
	(404546, 124, '2015-02-15 00:27:04.000000', 'consum', 0.0221, 'lps'),
	(404547, 124, '2015-02-15 00:27:05.000000', 'consum', 0.0210, 'lps'),
	(404548, 124, '2015-02-15 00:27:06.000000', 'consum', 0.0216, 'lps'),
	(404549, 124, '2015-02-15 00:27:07.000000', 'consum', 0.0216, 'lps'),
	(404550, 124, '2015-02-15 00:27:08.000000', 'consum', 0.0210, 'lps'),
	(404551, 124, '2015-02-15 00:27:09.000000', 'consum', 0.0218, 'lps'),
	(404552, 124, '2015-02-15 00:27:10.000000', 'consum', 0.0214, 'lps'),
	(404553, 124, '2015-02-15 00:27:11.000000', 'consum', 0.0218, 'lps'),
	(404554, 124, '2015-02-15 00:27:12.000000', 'consum', 0.0217, 'lps'),
	(404555, 124, '2015-02-15 00:27:13.000000', 'consum', 0.0218, 'lps'),
	(404556, 124, '2015-02-15 00:27:14.000000', 'consum', 0.0219, 'lps'),
	(404557, 124, '2015-02-15 00:27:15.000000', 'consum', 0.0220, 'lps'),
	(404558, 124, '2015-02-15 00:27:16.000000', 'consum', 0.0220, 'lps'),
	(404559, 124, '2015-02-15 00:27:17.000000', 'consum', 0.0221, 'lps'),
	(404560, 124, '2015-02-15 00:27:18.000000', 'consum', 0.0221, 'lps'),
	(404561, 124, '2015-02-15 00:27:19.000000', 'consum', 0.0210, 'lps'),
	(404562, 124, '2015-02-15 00:27:20.000000', 'consum', 0.0211, 'lps'),
	(404563, 124, '2015-02-15 00:27:21.000000', 'consum', 0.0217, 'lps'),
	(404564, 124, '2015-02-15 00:27:22.000000', 'consum', 0.0220, 'lps'),
	(404565, 124, '2015-02-15 00:27:23.000000', 'consum', 0.0215, 'lps'),
	(404566, 124, '2015-02-15 00:27:24.000000', 'consum', 0.0219, 'lps'),
	(404567, 124, '2015-02-15 00:27:25.000000', 'consum', 0.0213, 'lps'),
	(404568, 124, '2015-02-15 00:27:26.000000', 'consum', 0.0214, 'lps'),
	(404569, 124, '2015-02-15 00:27:27.000000', 'consum', 0.0218, 'lps'),
	(404570, 124, '2015-02-15 00:27:28.000000', 'consum', 0.0218, 'lps'),
	(404571, 124, '2015-02-15 00:27:29.000000', 'consum', 0.0211, 'lps'),
	(404572, 124, '2015-02-15 00:27:30.000000', 'consum', 0.0218, 'lps'),
	(404573, 124, '2015-02-15 00:27:31.000000', 'consum', 0.0211, 'lps'),
	(404574, 124, '2015-02-15 00:27:32.000000', 'consum', 0.0216, 'lps'),
	(404575, 124, '2015-02-15 00:27:33.000000', 'consum', 0.0213, 'lps'),
	(404576, 124, '2015-02-15 00:27:34.000000', 'consum', 0.0220, 'lps'),
	(404577, 124, '2015-02-15 00:27:35.000000', 'consum', 0.0214, 'lps'),
	(404578, 124, '2015-02-15 00:27:36.000000', 'consum', 0.0214, 'lps'),
	(404579, 124, '2015-02-15 00:27:37.000000', 'consum', 0.0218, 'lps'),
	(404580, 124, '2015-02-15 00:27:38.000000', 'consum', 0.0216, 'lps'),
	(404581, 124, '2015-02-15 00:27:39.000000', 'consum', 0.0216, 'lps'),
	(404582, 124, '2015-02-15 00:27:40.000000', 'consum', 0.0211, 'lps'),
	(404583, 124, '2015-02-15 00:27:41.000000', 'consum', 0.0221, 'lps'),
	(404584, 124, '2015-02-15 00:27:42.000000', 'consum', 0.0216, 'lps'),
	(404585, 124, '2015-02-15 00:27:43.000000', 'consum', 0.0218, 'lps'),
	(404586, 124, '2015-02-15 00:27:44.000000', 'consum', 0.0219, 'lps'),
	(404587, 124, '2015-02-15 00:27:45.000000', 'consum', 0.0210, 'lps'),
	(404588, 124, '2015-02-15 00:27:46.000000', 'consum', 0.0218, 'lps'),
	(404589, 124, '2015-02-15 00:27:47.000000', 'consum', 0.0215, 'lps'),
	(404590, 124, '2015-02-15 00:27:48.000000', 'consum', 0.0213, 'lps'),
	(404591, 124, '2015-02-15 00:27:49.000000', 'consum', 0.0220, 'lps'),
	(404592, 124, '2015-02-15 00:27:50.000000', 'consum', 0.0215, 'lps'),
	(404593, 124, '2015-02-15 00:27:51.000000', 'consum', 0.0219, 'lps'),
	(404594, 124, '2015-02-15 00:27:52.000000', 'consum', 0.0218, 'lps'),
	(404595, 124, '2015-02-15 00:27:53.000000', 'consum', 0.0221, 'lps'),
	(404596, 124, '2015-02-15 00:27:54.000000', 'consum', 0.0217, 'lps'),
	(404597, 124, '2015-02-15 00:27:55.000000', 'consum', 0.0215, 'lps'),
	(404598, 124, '2015-02-15 00:27:56.000000', 'consum', 0.0213, 'lps'),
	(404599, 124, '2015-02-15 00:27:57.000000', 'consum', 0.0213, 'lps'),
	(404600, 124, '2015-02-15 00:27:58.000000', 'consum', 0.0213, 'lps'),
	(404601, 124, '2015-02-15 00:27:59.000000', 'consum', 0.0218, 'lps'),
	(404602, 124, '2015-02-15 00:28:00.000000', 'consum', 0.0216, 'lps'),
	(404603, 124, '2015-02-15 00:28:01.000000', 'consum', 0.0217, 'lps'),
	(404604, 124, '2015-02-15 00:28:02.000000', 'consum', 0.0217, 'lps'),
	(404605, 124, '2015-02-15 00:28:03.000000', 'consum', 0.0213, 'lps'),
	(404606, 124, '2015-02-15 00:28:04.000000', 'consum', 0.0214, 'lps'),
	(404607, 124, '2015-02-15 00:28:05.000000', 'consum', 0.0210, 'lps'),
	(404608, 124, '2015-02-15 00:28:06.000000', 'consum', 0.0210, 'lps'),
	(404609, 124, '2015-02-15 00:28:07.000000', 'consum', 0.0210, 'lps'),
	(404610, 124, '2015-02-15 00:28:08.000000', 'consum', 0.0212, 'lps'),
	(404611, 124, '2015-02-15 00:28:09.000000', 'consum', 0.0219, 'lps'),
	(404612, 124, '2015-02-15 00:28:10.000000', 'consum', 0.0215, 'lps'),
	(404613, 124, '2015-02-15 00:28:11.000000', 'consum', 0.0221, 'lps'),
	(404614, 124, '2015-02-15 00:28:12.000000', 'consum', 0.0213, 'lps'),
	(404615, 124, '2015-02-15 00:28:13.000000', 'consum', 0.0216, 'lps'),
	(404616, 124, '2015-02-15 00:28:14.000000', 'consum', 0.0220, 'lps'),
	(404617, 124, '2015-02-15 00:28:15.000000', 'consum', 0.0219, 'lps'),
	(404618, 124, '2015-02-15 00:28:16.000000', 'consum', 0.0212, 'lps'),
	(404619, 124, '2015-02-15 00:28:17.000000', 'consum', 0.0217, 'lps'),
	(404620, 124, '2015-02-15 00:28:18.000000', 'consum', 0.0216, 'lps'),
	(404621, 124, '2015-02-15 00:28:19.000000', 'consum', 0.0219, 'lps'),
	(404622, 124, '2015-02-15 00:28:20.000000', 'consum', 0.0216, 'lps'),
	(404623, 124, '2015-02-15 00:28:21.000000', 'consum', 0.0212, 'lps'),
	(404624, 124, '2015-02-15 00:28:22.000000', 'consum', 0.0214, 'lps'),
	(404625, 124, '2015-02-15 00:28:23.000000', 'consum', 0.0212, 'lps'),
	(404626, 124, '2015-02-15 00:28:24.000000', 'consum', 0.0220, 'lps'),
	(404627, 124, '2015-02-15 00:28:25.000000', 'consum', 0.0221, 'lps'),
	(404628, 124, '2015-02-15 00:28:26.000000', 'consum', 0.0221, 'lps'),
	(404629, 124, '2015-02-15 00:28:27.000000', 'consum', 0.0221, 'lps'),
	(404630, 124, '2015-02-15 00:28:28.000000', 'consum', 0.0219, 'lps'),
	(404631, 124, '2015-02-15 00:28:29.000000', 'consum', 0.0213, 'lps'),
	(404632, 124, '2015-02-15 00:28:30.000000', 'consum', 0.0221, 'lps'),
	(404633, 124, '2015-02-15 00:28:31.000000', 'consum', 0.0221, 'lps'),
	(404634, 124, '2015-02-15 00:28:32.000000', 'consum', 0.0221, 'lps'),
	(404635, 124, '2015-02-15 00:28:33.000000', 'consum', 0.0221, 'lps'),
	(404636, 124, '2015-02-15 00:28:34.000000', 'consum', 0.0221, 'lps'),
	(404637, 124, '2015-02-15 00:28:35.000000', 'consum', 0.0221, 'lps'),
	(404638, 124, '2015-02-15 00:28:36.000000', 'consum', 0.0210, 'lps'),
	(404639, 124, '2015-02-15 00:28:37.000000', 'consum', 0.0210, 'lps'),
	(404640, 124, '2015-02-15 00:28:38.000000', 'consum', 0.0212, 'lps'),
	(404641, 124, '2015-02-15 00:28:39.000000', 'consum', 0.0219, 'lps'),
	(404642, 124, '2015-02-15 00:28:40.000000', 'consum', 0.0215, 'lps'),
	(404643, 124, '2015-02-15 00:28:41.000000', 'consum', 0.0221, 'lps'),
	(404644, 124, '2015-02-15 00:28:42.000000', 'consum', 0.0214, 'lps'),
	(404645, 124, '2015-02-15 00:28:43.000000', 'consum', 0.0211, 'lps'),
	(404646, 124, '2015-02-15 00:28:44.000000', 'consum', 0.0214, 'lps'),
	(404647, 124, '2015-02-15 00:28:45.000000', 'consum', 0.0218, 'lps'),
	(404648, 124, '2015-02-15 00:28:46.000000', 'consum', 0.0211, 'lps'),
	(404649, 124, '2015-02-15 00:28:47.000000', 'consum', 0.0218, 'lps'),
	(404650, 124, '2015-02-15 00:28:48.000000', 'consum', 0.0210, 'lps'),
	(404651, 124, '2015-02-15 00:28:49.000000', 'consum', 0.0210, 'lps'),
	(404652, 124, '2015-02-15 00:28:50.000000', 'consum', 0.0221, 'lps'),
	(404653, 124, '2015-02-15 00:28:51.000000', 'consum', 0.0220, 'lps'),
	(404654, 124, '2015-02-15 00:28:52.000000', 'consum', 0.0215, 'lps'),
	(404655, 124, '2015-02-15 00:28:53.000000', 'consum', 0.0219, 'lps'),
	(404656, 124, '2015-02-15 00:28:54.000000', 'consum', 0.0213, 'lps'),
	(404657, 124, '2015-02-15 00:28:55.000000', 'consum', 0.0214, 'lps'),
	(404658, 124, '2015-02-15 00:28:56.000000', 'consum', 0.0219, 'lps'),
	(404659, 124, '2015-02-15 00:28:57.000000', 'consum', 0.0210, 'lps'),
	(404660, 124, '2015-02-15 00:28:58.000000', 'consum', 0.0217, 'lps'),
	(404661, 124, '2015-02-15 00:28:59.000000', 'consum', 0.0211, 'lps'),
	(404662, 124, '2015-02-15 00:29:00.000000', 'consum', 0.0216, 'lps'),
	(404663, 124, '2015-02-15 00:29:01.000000', 'consum', 0.0215, 'lps'),
	(404664, 124, '2015-02-15 00:29:02.000000', 'consum', 0.0217, 'lps'),
	(404665, 124, '2015-02-15 00:29:03.000000', 'consum', 0.0218, 'lps'),
	(404666, 124, '2015-02-15 00:29:04.000000', 'consum', 0.0219, 'lps'),
	(404667, 124, '2015-02-15 00:29:05.000000', 'consum', 0.0218, 'lps'),
	(404668, 124, '2015-02-15 00:29:06.000000', 'consum', 0.0213, 'lps'),
	(404669, 124, '2015-02-15 00:29:07.000000', 'consum', 0.0211, 'lps'),
	(404670, 124, '2015-02-15 00:29:08.000000', 'consum', 0.0221, 'lps'),
	(404671, 124, '2015-02-15 00:29:09.000000', 'consum', 0.0215, 'lps'),
	(404672, 124, '2015-02-15 00:29:10.000000', 'consum', 0.0213, 'lps'),
	(404673, 124, '2015-02-15 00:29:11.000000', 'consum', 0.0210, 'lps'),
	(404674, 124, '2015-02-15 00:29:12.000000', 'consum', 0.0212, 'lps'),
	(404675, 124, '2015-02-15 00:29:13.000000', 'consum', 0.0210, 'lps'),
	(404676, 124, '2015-02-15 00:29:14.000000', 'consum', 0.0216, 'lps'),
	(404677, 124, '2015-02-15 00:29:15.000000', 'consum', 0.0218, 'lps'),
	(404678, 124, '2015-02-15 00:29:16.000000', 'consum', 0.0220, 'lps'),
	(404679, 124, '2015-02-15 00:29:17.000000', 'consum', 0.0212, 'lps'),
	(404680, 124, '2015-02-15 00:29:18.000000', 'consum', 0.0215, 'lps'),
	(404681, 124, '2015-02-15 00:29:19.000000', 'consum', 0.0217, 'lps'),
	(404682, 124, '2015-02-15 00:29:20.000000', 'consum', 0.0219, 'lps'),
	(404683, 124, '2015-02-15 00:29:21.000000', 'consum', 0.0210, 'lps'),
	(404684, 124, '2015-02-15 00:29:22.000000', 'consum', 0.0210, 'lps'),
	(404685, 124, '2015-02-15 00:29:23.000000', 'consum', 0.0220, 'lps'),
	(404686, 124, '2015-02-15 00:29:24.000000', 'consum', 0.0214, 'lps'),
	(404687, 124, '2015-02-15 00:29:25.000000', 'consum', 0.0212, 'lps'),
	(404688, 124, '2015-02-15 00:29:26.000000', 'consum', 0.0219, 'lps'),
	(404689, 124, '2015-02-15 00:29:27.000000', 'consum', 0.0214, 'lps'),
	(404690, 124, '2015-02-15 00:29:28.000000', 'consum', 0.0215, 'lps'),
	(404691, 124, '2015-02-15 00:29:29.000000', 'consum', 0.0212, 'lps'),
	(404692, 124, '2015-02-15 00:29:30.000000', 'consum', 0.0218, 'lps'),
	(404693, 124, '2015-02-15 00:29:31.000000', 'consum', 0.0219, 'lps'),
	(404694, 124, '2015-02-15 00:29:32.000000', 'consum', 0.0221, 'lps'),
	(404695, 124, '2015-02-15 00:29:33.000000', 'consum', 0.0214, 'lps'),
	(404696, 124, '2015-02-15 00:29:34.000000', 'consum', 0.0221, 'lps'),
	(404697, 124, '2015-02-15 00:29:35.000000', 'consum', 0.0216, 'lps'),
	(404698, 124, '2015-02-15 00:29:36.000000', 'consum', 0.0210, 'lps'),
	(404699, 124, '2015-02-15 00:29:37.000000', 'consum', 0.0217, 'lps'),
	(404700, 124, '2015-02-15 00:29:38.000000', 'consum', 0.0220, 'lps'),
	(404701, 124, '2015-02-15 00:29:39.000000', 'consum', 0.0218, 'lps'),
	(404702, 124, '2015-02-15 00:29:40.000000', 'consum', 0.0219, 'lps'),
	(404703, 124, '2015-02-15 00:29:41.000000', 'consum', 0.0220, 'lps'),
	(404704, 124, '2015-02-15 00:29:42.000000', 'consum', 0.0221, 'lps'),
	(404705, 124, '2015-02-15 00:29:43.000000', 'consum', 0.0213, 'lps'),
	(404706, 124, '2015-02-15 00:29:44.000000', 'consum', 0.0216, 'lps'),
	(404707, 124, '2015-02-15 00:29:45.000000', 'consum', 0.0221, 'lps'),
	(404708, 124, '2015-02-15 00:29:46.000000', 'consum', 0.0210, 'lps'),
	(404709, 124, '2015-02-15 00:29:47.000000', 'consum', 0.0212, 'lps'),
	(404710, 124, '2015-02-15 00:29:48.000000', 'consum', 0.0212, 'lps'),
	(404711, 124, '2015-02-15 00:29:49.000000', 'consum', 0.0212, 'lps'),
	(404712, 124, '2015-02-15 00:29:50.000000', 'consum', 0.0214, 'lps'),
	(404713, 124, '2015-02-15 00:29:51.000000', 'consum', 0.0214, 'lps'),
	(404714, 124, '2015-02-15 00:29:52.000000', 'consum', 0.0219, 'lps'),
	(404715, 124, '2015-02-15 00:29:53.000000', 'consum', 0.0219, 'lps'),
	(404716, 124, '2015-02-15 00:29:54.000000', 'consum', 0.0215, 'lps'),
	(404717, 124, '2015-02-15 00:29:55.000000', 'consum', 0.0220, 'lps'),
	(404718, 124, '2015-02-15 00:29:56.000000', 'consum', 0.0221, 'lps'),
	(404719, 124, '2015-02-15 00:29:57.000000', 'consum', 0.0211, 'lps'),
	(404720, 124, '2015-02-15 00:29:58.000000', 'consum', 0.0221, 'lps'),
	(404721, 124, '2015-02-15 00:29:59.000000', 'consum', 0.0213, 'lps'),
	(404722, 124, '2015-02-15 00:30:00.000000', 'consum', 0.0219, 'lps'),
	(404723, 124, '2015-02-15 00:30:01.000000', 'consum', 0.0219, 'lps'),
	(404724, 124, '2015-02-15 00:30:02.000000', 'consum', 0.0219, 'lps'),
	(404725, 124, '2015-02-15 00:30:03.000000', 'consum', 0.0216, 'lps'),
	(404726, 124, '2015-02-15 00:30:04.000000', 'consum', 0.0213, 'lps'),
	(404727, 124, '2015-02-15 00:30:05.000000', 'consum', 0.0210, 'lps'),
	(404728, 124, '2015-02-15 00:30:06.000000', 'consum', 0.0210, 'lps'),
	(404729, 124, '2015-02-15 00:30:07.000000', 'consum', 0.0212, 'lps'),
	(404730, 124, '2015-02-15 00:30:08.000000', 'consum', 0.0210, 'lps'),
	(404731, 124, '2015-02-15 00:30:09.000000', 'consum', 0.0214, 'lps'),
	(404732, 124, '2015-02-15 00:30:10.000000', 'consum', 0.0219, 'lps'),
	(404733, 124, '2015-02-15 00:30:11.000000', 'consum', 0.0221, 'lps'),
	(404734, 124, '2015-02-15 00:30:12.000000', 'consum', 0.0212, 'lps'),
	(404735, 124, '2015-02-15 00:30:13.000000', 'consum', 0.0212, 'lps'),
	(404736, 124, '2015-02-15 00:30:14.000000', 'consum', 0.0213, 'lps'),
	(404737, 124, '2015-02-15 00:30:15.000000', 'consum', 0.0221, 'lps'),
	(404738, 124, '2015-02-15 00:30:16.000000', 'consum', 0.0220, 'lps'),
	(404739, 124, '2015-02-15 00:30:17.000000', 'consum', 0.0217, 'lps'),
	(404740, 124, '2015-02-15 00:30:18.000000', 'consum', 0.0214, 'lps'),
	(404741, 124, '2015-02-15 00:30:19.000000', 'consum', 0.0221, 'lps'),
	(404742, 124, '2015-02-15 00:30:20.000000', 'consum', 0.0216, 'lps'),
	(404743, 124, '2015-02-15 00:30:21.000000', 'consum', 0.0211, 'lps'),
	(404744, 124, '2015-02-15 00:30:22.000000', 'consum', 0.0220, 'lps'),
	(404745, 124, '2015-02-15 00:30:23.000000', 'consum', 0.0221, 'lps'),
	(404746, 124, '2015-02-15 00:30:24.000000', 'consum', 0.0211, 'lps'),
	(404747, 124, '2015-02-15 00:30:25.000000', 'consum', 0.0220, 'lps'),
	(404748, 124, '2015-02-15 00:30:26.000000', 'consum', 0.0220, 'lps'),
	(404749, 124, '2015-02-15 00:30:27.000000', 'consum', 0.0218, 'lps'),
	(404750, 124, '2015-02-15 00:30:28.000000', 'consum', 0.0220, 'lps'),
	(404751, 124, '2015-02-15 00:30:29.000000', 'consum', 0.0212, 'lps'),
	(404752, 124, '2015-02-15 00:30:30.000000', 'consum', 0.0217, 'lps'),
	(404753, 124, '2015-02-15 00:30:31.000000', 'consum', 0.0214, 'lps'),
	(404754, 124, '2015-02-15 00:30:32.000000', 'consum', 0.0210, 'lps'),
	(404755, 124, '2015-02-15 00:30:33.000000', 'consum', 0.0210, 'lps'),
	(404756, 124, '2015-02-15 00:30:34.000000', 'consum', 0.0213, 'lps'),
	(404757, 124, '2015-02-15 00:30:35.000000', 'consum', 0.0210, 'lps'),
	(404758, 124, '2015-02-15 00:30:36.000000', 'consum', 0.0217, 'lps'),
	(404759, 124, '2015-02-15 00:30:37.000000', 'consum', 0.0218, 'lps'),
	(404760, 124, '2015-02-15 00:30:38.000000', 'consum', 0.0219, 'lps'),
	(404761, 124, '2015-02-15 00:30:39.000000', 'consum', 0.0221, 'lps'),
	(404762, 124, '2015-02-15 00:30:40.000000', 'consum', 0.0213, 'lps'),
	(404763, 124, '2015-02-15 00:30:41.000000', 'consum', 0.0218, 'lps'),
	(404764, 124, '2015-02-15 00:30:42.000000', 'consum', 0.0217, 'lps'),
	(404765, 124, '2015-02-15 00:30:43.000000', 'consum', 0.0221, 'lps'),
	(404766, 124, '2015-02-15 00:30:44.000000', 'consum', 0.0211, 'lps'),
	(404767, 124, '2015-02-15 00:30:45.000000', 'consum', 0.0216, 'lps'),
	(404768, 124, '2015-02-15 00:30:46.000000', 'consum', 0.0215, 'lps'),
	(404769, 124, '2015-02-15 00:30:47.000000', 'consum', 0.0215, 'lps'),
	(404770, 124, '2015-02-15 00:30:48.000000', 'consum', 0.0212, 'lps'),
	(404771, 124, '2015-02-15 00:30:49.000000', 'consum', 0.0214, 'lps'),
	(404772, 124, '2015-02-15 00:30:50.000000', 'consum', 0.0215, 'lps'),
	(404773, 124, '2015-02-15 00:30:51.000000', 'consum', 0.0211, 'lps'),
	(404774, 124, '2015-02-15 00:30:52.000000', 'consum', 0.0214, 'lps'),
	(404775, 124, '2015-02-15 00:30:53.000000', 'consum', 0.0212, 'lps'),
	(404776, 124, '2015-02-15 00:30:54.000000', 'consum', 0.0212, 'lps'),
	(404777, 124, '2015-02-15 00:30:55.000000', 'consum', 0.0213, 'lps'),
	(404778, 124, '2015-02-15 00:30:56.000000', 'consum', 0.0221, 'lps'),
	(404779, 124, '2015-02-15 00:30:57.000000', 'consum', 0.0218, 'lps'),
	(404780, 124, '2015-02-15 00:30:58.000000', 'consum', 0.0220, 'lps'),
	(404781, 124, '2015-02-15 00:30:59.000000', 'consum', 0.0212, 'lps'),
	(404782, 124, '2015-02-15 00:31:00.000000', 'consum', 0.0213, 'lps'),
	(404783, 124, '2015-02-15 00:31:01.000000', 'consum', 0.0219, 'lps'),
	(404784, 124, '2015-02-15 00:31:02.000000', 'consum', 0.0211, 'lps'),
	(404785, 124, '2015-02-15 00:31:03.000000', 'consum', 0.0215, 'lps'),
	(404786, 124, '2015-02-15 00:31:04.000000', 'consum', 0.0218, 'lps'),
	(404787, 124, '2015-02-15 00:31:05.000000', 'consum', 0.0212, 'lps'),
	(404788, 124, '2015-02-15 00:31:06.000000', 'consum', 0.0220, 'lps'),
	(404789, 124, '2015-02-15 00:31:07.000000', 'consum', 0.0220, 'lps'),
	(404790, 124, '2015-02-15 00:31:08.000000', 'consum', 0.0220, 'lps'),
	(404791, 124, '2015-02-15 00:31:09.000000', 'consum', 0.0216, 'lps'),
	(404792, 124, '2015-02-15 00:31:10.000000', 'consum', 0.0213, 'lps'),
	(404793, 124, '2015-02-15 00:31:11.000000', 'consum', 0.0219, 'lps'),
	(404794, 124, '2015-02-15 00:31:12.000000', 'consum', 0.0211, 'lps'),
	(404795, 124, '2015-02-15 00:31:13.000000', 'consum', 0.0211, 'lps'),
	(404796, 124, '2015-02-15 00:31:14.000000', 'consum', 0.0211, 'lps'),
	(404797, 124, '2015-02-15 00:31:15.000000', 'consum', 0.0215, 'lps'),
	(404798, 124, '2015-02-15 00:31:16.000000', 'consum', 0.0218, 'lps'),
	(404799, 124, '2015-02-15 00:31:17.000000', 'consum', 0.0212, 'lps'),
	(404800, 124, '2015-02-15 00:31:18.000000', 'consum', 0.0210, 'lps'),
	(404801, 124, '2015-02-15 00:31:19.000000', 'consum', 0.0216, 'lps'),
	(404802, 124, '2015-02-15 00:31:20.000000', 'consum', 0.0218, 'lps'),
	(404803, 124, '2015-02-15 00:31:21.000000', 'consum', 0.0219, 'lps'),
	(404804, 124, '2015-02-15 00:31:22.000000', 'consum', 0.0220, 'lps'),
	(404805, 124, '2015-02-15 00:31:23.000000', 'consum', 0.0221, 'lps'),
	(404806, 124, '2015-02-15 00:31:24.000000', 'consum', 0.0212, 'lps'),
	(404807, 124, '2015-02-15 00:31:25.000000', 'consum', 0.0212, 'lps'),
	(404808, 124, '2015-02-15 00:31:26.000000', 'consum', 0.0214, 'lps'),
	(404809, 124, '2015-02-15 00:31:27.000000', 'consum', 0.0211, 'lps'),
	(404810, 124, '2015-02-15 00:31:28.000000', 'consum', 0.0216, 'lps'),
	(404811, 124, '2015-02-15 00:31:29.000000', 'consum', 0.0214, 'lps'),
	(404812, 124, '2015-02-15 00:31:30.000000', 'consum', 0.0213, 'lps'),
	(404813, 124, '2015-02-15 00:31:31.000000', 'consum', 0.0212, 'lps'),
	(404814, 124, '2015-02-15 00:31:32.000000', 'consum', 0.0210, 'lps'),
	(404815, 124, '2015-02-15 00:31:33.000000', 'consum', 0.0220, 'lps'),
	(404816, 124, '2015-02-15 00:31:34.000000', 'consum', 0.0212, 'lps'),
	(404817, 124, '2015-02-15 00:31:35.000000', 'consum', 0.0212, 'lps'),
	(404818, 124, '2015-02-15 00:31:36.000000', 'consum', 0.0218, 'lps'),
	(404819, 124, '2015-02-15 00:31:37.000000', 'consum', 0.0218, 'lps'),
	(404820, 124, '2015-02-15 00:31:38.000000', 'consum', 0.0216, 'lps'),
	(404821, 124, '2015-02-15 00:31:39.000000', 'consum', 0.0216, 'lps'),
	(404822, 124, '2015-02-15 00:31:40.000000', 'consum', 0.0211, 'lps'),
	(404823, 124, '2015-02-15 00:31:41.000000', 'consum', 0.0221, 'lps'),
	(404824, 124, '2015-02-15 00:31:42.000000', 'consum', 0.0216, 'lps'),
	(404825, 124, '2015-02-15 00:31:43.000000', 'consum', 0.0220, 'lps'),
	(404826, 124, '2015-02-15 00:31:44.000000', 'consum', 0.0217, 'lps'),
	(404827, 124, '2015-02-15 00:31:45.000000', 'consum', 0.0216, 'lps'),
	(404828, 124, '2015-02-15 00:31:46.000000', 'consum', 0.0221, 'lps'),
	(404829, 124, '2015-02-15 00:31:47.000000', 'consum', 0.0220, 'lps'),
	(404830, 124, '2015-02-15 00:31:48.000000', 'consum', 0.0218, 'lps'),
	(404831, 124, '2015-02-15 00:31:49.000000', 'consum', 0.0221, 'lps'),
	(404832, 124, '2015-02-15 00:31:50.000000', 'consum', 0.0218, 'lps'),
	(404833, 124, '2015-02-15 00:31:51.000000', 'consum', 0.0219, 'lps'),
	(404834, 124, '2015-02-15 00:31:52.000000', 'consum', 0.0217, 'lps'),
	(404835, 124, '2015-02-15 00:31:53.000000', 'consum', 0.0218, 'lps'),
	(404836, 124, '2015-02-15 00:31:54.000000', 'consum', 0.0218, 'lps'),
	(404837, 124, '2015-02-15 00:31:55.000000', 'consum', 0.0213, 'lps'),
	(404838, 124, '2015-02-15 00:31:56.000000', 'consum', 0.0216, 'lps'),
	(404839, 124, '2015-02-15 00:31:57.000000', 'consum', 0.0220, 'lps'),
	(404840, 124, '2015-02-15 00:31:58.000000', 'consum', 0.0217, 'lps'),
	(404841, 124, '2015-02-15 00:31:59.000000', 'consum', 0.0218, 'lps'),
	(404842, 124, '2015-02-15 00:32:00.000000', 'consum', 0.0214, 'lps'),
	(404843, 124, '2015-02-15 00:32:01.000000', 'consum', 0.0221, 'lps'),
	(404844, 124, '2015-02-15 00:32:02.000000', 'consum', 0.0216, 'lps'),
	(404845, 124, '2015-02-15 00:32:03.000000', 'consum', 0.0219, 'lps'),
	(404846, 124, '2015-02-15 00:32:04.000000', 'consum', 0.0215, 'lps'),
	(404847, 124, '2015-02-15 00:32:05.000000', 'consum', 0.0219, 'lps'),
	(404848, 124, '2015-02-15 00:32:06.000000', 'consum', 0.0215, 'lps'),
	(404849, 124, '2015-02-15 00:32:07.000000', 'consum', 0.0211, 'lps'),
	(404850, 124, '2015-02-15 00:32:08.000000', 'consum', 0.0213, 'lps'),
	(404851, 124, '2015-02-15 00:32:09.000000', 'consum', 0.0210, 'lps'),
	(404852, 124, '2015-02-15 00:32:10.000000', 'consum', 0.0212, 'lps'),
	(404853, 124, '2015-02-15 00:32:11.000000', 'consum', 0.0219, 'lps'),
	(404854, 124, '2015-02-15 00:32:12.000000', 'consum', 0.0216, 'lps'),
	(404855, 124, '2015-02-15 00:32:13.000000', 'consum', 0.0215, 'lps'),
	(404856, 124, '2015-02-15 00:32:14.000000', 'consum', 0.0216, 'lps'),
	(404857, 124, '2015-02-15 00:32:15.000000', 'consum', 0.0212, 'lps'),
	(404858, 124, '2015-02-15 00:32:16.000000', 'consum', 0.0213, 'lps'),
	(404859, 124, '2015-02-15 00:32:17.000000', 'consum', 0.0211, 'lps'),
	(404860, 124, '2015-02-15 00:32:18.000000', 'consum', 0.0219, 'lps'),
	(404861, 124, '2015-02-15 00:32:19.000000', 'consum', 0.0214, 'lps'),
	(404862, 124, '2015-02-15 00:32:20.000000', 'consum', 0.0218, 'lps'),
	(404863, 124, '2015-02-15 00:32:21.000000', 'consum', 0.0215, 'lps'),
	(404864, 124, '2015-02-15 00:32:22.000000', 'consum', 0.0221, 'lps'),
	(404865, 124, '2015-02-15 00:32:23.000000', 'consum', 0.0213, 'lps'),
	(404866, 124, '2015-02-15 00:32:24.000000', 'consum', 0.0220, 'lps'),
	(404867, 124, '2015-02-15 00:32:25.000000', 'consum', 0.0214, 'lps'),
	(404868, 124, '2015-02-15 00:32:26.000000', 'consum', 0.0215, 'lps'),
	(404869, 124, '2015-02-15 00:32:27.000000', 'consum', 0.0221, 'lps'),
	(404870, 124, '2015-02-15 00:32:28.000000', 'consum', 0.0215, 'lps'),
	(404871, 124, '2015-02-15 00:32:29.000000', 'consum', 0.0217, 'lps'),
	(404872, 124, '2015-02-15 00:32:30.000000', 'consum', 0.0215, 'lps'),
	(404873, 124, '2015-02-15 00:32:31.000000', 'consum', 0.0215, 'lps'),
	(404874, 124, '2015-02-15 00:32:32.000000', 'consum', 0.0211, 'lps'),
	(404875, 124, '2015-02-15 00:32:33.000000', 'consum', 0.0210, 'lps'),
	(404876, 124, '2015-02-15 00:32:34.000000', 'consum', 0.0210, 'lps'),
	(404877, 124, '2015-02-15 00:32:35.000000', 'consum', 0.0210, 'lps'),
	(404878, 124, '2015-02-15 00:32:36.000000', 'consum', 0.0221, 'lps'),
	(404879, 124, '2015-02-15 00:32:37.000000', 'consum', 0.0216, 'lps'),
	(404880, 124, '2015-02-15 00:32:38.000000', 'consum', 0.0211, 'lps'),
	(404881, 124, '2015-02-15 00:32:39.000000', 'consum', 0.0221, 'lps'),
	(404882, 124, '2015-02-15 00:32:40.000000', 'consum', 0.0213, 'lps'),
	(404883, 124, '2015-02-15 00:32:41.000000', 'consum', 0.0217, 'lps'),
	(404884, 124, '2015-02-15 00:32:42.000000', 'consum', 0.0214, 'lps'),
	(404885, 124, '2015-02-15 00:32:43.000000', 'consum', 0.0221, 'lps'),
	(404886, 124, '2015-02-15 00:32:44.000000', 'consum', 0.0218, 'lps'),
	(404887, 124, '2015-02-15 00:32:45.000000', 'consum', 0.0218, 'lps'),
	(404888, 124, '2015-02-15 00:32:46.000000', 'consum', 0.0212, 'lps'),
	(404889, 124, '2015-02-15 00:32:47.000000', 'consum', 0.0220, 'lps'),
	(404890, 124, '2015-02-15 00:32:48.000000', 'consum', 0.0220, 'lps'),
	(404891, 124, '2015-02-15 00:32:49.000000', 'consum', 0.0220, 'lps'),
	(404892, 124, '2015-02-15 00:32:50.000000', 'consum', 0.0216, 'lps'),
	(404893, 124, '2015-02-15 00:32:51.000000', 'consum', 0.0212, 'lps'),
	(404894, 124, '2015-02-15 00:32:52.000000', 'consum', 0.0215, 'lps'),
	(404895, 124, '2015-02-15 00:32:53.000000', 'consum', 0.0218, 'lps'),
	(404896, 124, '2015-02-15 00:32:54.000000', 'consum', 0.0212, 'lps'),
	(404897, 124, '2015-02-15 00:32:55.000000', 'consum', 0.0218, 'lps'),
	(404898, 124, '2015-02-15 00:32:56.000000', 'consum', 0.0212, 'lps'),
	(404899, 124, '2015-02-15 00:32:57.000000', 'consum', 0.0217, 'lps'),
	(404900, 124, '2015-02-15 00:32:58.000000', 'consum', 0.0216, 'lps'),
	(404901, 124, '2015-02-15 00:32:59.000000', 'consum', 0.0210, 'lps'),
	(404902, 124, '2015-02-15 00:33:00.000000', 'consum', 0.0215, 'lps'),
	(404903, 124, '2015-02-15 00:33:01.000000', 'consum', 0.0210, 'lps'),
	(404904, 124, '2015-02-15 00:33:02.000000', 'consum', 0.0220, 'lps'),
	(404905, 124, '2015-02-15 00:33:03.000000', 'consum', 0.0212, 'lps'),
	(404906, 124, '2015-02-15 00:33:04.000000', 'consum', 0.0214, 'lps'),
	(404907, 124, '2015-02-15 00:33:05.000000', 'consum', 0.0215, 'lps'),
	(404908, 124, '2015-02-15 00:33:06.000000', 'consum', 0.0210, 'lps'),
	(404909, 124, '2015-02-15 00:33:07.000000', 'consum', 0.0218, 'lps'),
	(404910, 124, '2015-02-15 00:33:08.000000', 'consum', 0.0217, 'lps'),
	(404911, 124, '2015-02-15 00:33:09.000000', 'consum', 0.0210, 'lps'),
	(404912, 124, '2015-02-15 00:33:10.000000', 'consum', 0.0214, 'lps'),
	(404913, 124, '2015-02-15 00:33:11.000000', 'consum', 0.0216, 'lps'),
	(404914, 124, '2015-02-15 00:33:12.000000', 'consum', 0.0219, 'lps'),
	(404915, 124, '2015-02-15 00:33:13.000000', 'consum', 0.0214, 'lps'),
	(404916, 124, '2015-02-15 00:33:14.000000', 'consum', 0.0213, 'lps'),
	(404917, 124, '2015-02-15 00:33:15.000000', 'consum', 0.0215, 'lps'),
	(404918, 124, '2015-02-15 00:33:16.000000', 'consum', 0.0215, 'lps'),
	(404919, 124, '2015-02-15 00:33:17.000000', 'consum', 0.0219, 'lps'),
	(404920, 124, '2015-02-15 00:33:18.000000', 'consum', 0.0217, 'lps'),
	(404921, 124, '2015-02-15 00:33:19.000000', 'consum', 0.0217, 'lps'),
	(404922, 124, '2015-02-15 00:33:20.000000', 'consum', 0.0215, 'lps'),
	(404923, 124, '2015-02-15 00:33:21.000000', 'consum', 0.0214, 'lps'),
	(404924, 124, '2015-02-15 00:33:22.000000', 'consum', 0.0215, 'lps'),
	(404925, 124, '2015-02-15 00:33:23.000000', 'consum', 0.0210, 'lps'),
	(404926, 124, '2015-02-15 00:33:24.000000', 'consum', 0.0219, 'lps'),
	(404927, 124, '2015-02-15 00:33:25.000000', 'consum', 0.0220, 'lps'),
	(404928, 124, '2015-02-15 00:33:26.000000', 'consum', 0.0221, 'lps'),
	(404929, 124, '2015-02-15 00:33:27.000000', 'consum', 0.0211, 'lps'),
	(404930, 124, '2015-02-15 00:33:28.000000', 'consum', 0.0221, 'lps'),
	(404931, 124, '2015-02-15 00:33:29.000000', 'consum', 0.0212, 'lps'),
	(404932, 124, '2015-02-15 00:33:30.000000', 'consum', 0.0214, 'lps'),
	(404933, 124, '2015-02-15 00:33:31.000000', 'consum', 0.0211, 'lps'),
	(404934, 124, '2015-02-15 00:33:32.000000', 'consum', 0.0217, 'lps'),
	(404935, 124, '2015-02-15 00:33:33.000000', 'consum', 0.0219, 'lps'),
	(404936, 124, '2015-02-15 00:33:34.000000', 'consum', 0.0211, 'lps'),
	(404937, 124, '2015-02-15 00:33:35.000000', 'consum', 0.0213, 'lps'),
	(404938, 124, '2015-02-15 00:33:36.000000', 'consum', 0.0211, 'lps'),
	(404939, 124, '2015-02-15 00:33:37.000000', 'consum', 0.0217, 'lps'),
	(404940, 124, '2015-02-15 00:33:38.000000', 'consum', 0.0219, 'lps'),
	(404941, 124, '2015-02-15 00:33:39.000000', 'consum', 0.0210, 'lps'),
	(404942, 124, '2015-02-15 00:33:40.000000', 'consum', 0.0210, 'lps'),
	(404943, 124, '2015-02-15 00:33:41.000000', 'consum', 0.0220, 'lps'),
	(404944, 124, '2015-02-15 00:33:42.000000', 'consum', 0.0214, 'lps'),
	(404945, 124, '2015-02-15 00:33:43.000000', 'consum', 0.0212, 'lps'),
	(404946, 124, '2015-02-15 00:33:44.000000', 'consum', 0.0219, 'lps'),
	(404947, 124, '2015-02-15 00:33:45.000000', 'consum', 0.0217, 'lps'),
	(404948, 124, '2015-02-15 00:33:46.000000', 'consum', 0.0215, 'lps'),
	(404949, 124, '2015-02-15 00:33:47.000000', 'consum', 0.0214, 'lps'),
	(404950, 124, '2015-02-15 00:33:48.000000', 'consum', 0.0218, 'lps'),
	(404951, 124, '2015-02-15 00:33:49.000000', 'consum', 0.0213, 'lps'),
	(404952, 124, '2015-02-15 00:33:50.000000', 'consum', 0.0216, 'lps'),
	(404953, 124, '2015-02-15 00:33:51.000000', 'consum', 0.0218, 'lps'),
	(404954, 124, '2015-02-15 00:33:52.000000', 'consum', 0.0219, 'lps'),
	(404955, 124, '2015-02-15 00:33:53.000000', 'consum', 0.0221, 'lps'),
	(404956, 124, '2015-02-15 00:33:54.000000', 'consum', 0.0215, 'lps'),
	(404957, 124, '2015-02-15 00:33:55.000000', 'consum', 0.0213, 'lps'),
	(404958, 124, '2015-02-15 00:33:56.000000', 'consum', 0.0211, 'lps'),
	(404959, 124, '2015-02-15 00:33:57.000000', 'consum', 0.0219, 'lps'),
	(404960, 124, '2015-02-15 00:33:58.000000', 'consum', 0.0216, 'lps'),
	(404961, 124, '2015-02-15 00:33:59.000000', 'consum', 0.0213, 'lps'),
	(404962, 124, '2015-02-15 00:34:00.000000', 'consum', 0.0219, 'lps'),
	(404963, 124, '2015-02-15 00:34:01.000000', 'consum', 0.0210, 'lps'),
	(404964, 124, '2015-02-15 00:34:02.000000', 'consum', 0.0218, 'lps'),
	(404965, 124, '2015-02-15 00:34:03.000000', 'consum', 0.0217, 'lps'),
	(404966, 124, '2015-02-15 00:34:04.000000', 'consum', 0.0211, 'lps'),
	(404967, 124, '2015-02-15 00:34:05.000000', 'consum', 0.0215, 'lps'),
	(404968, 124, '2015-02-15 00:34:06.000000', 'consum', 0.0210, 'lps'),
	(404969, 124, '2015-02-15 00:34:07.000000', 'consum', 0.0220, 'lps'),
	(404970, 124, '2015-02-15 00:34:08.000000', 'consum', 0.0210, 'lps'),
	(404971, 124, '2015-02-15 00:34:09.000000', 'consum', 0.0218, 'lps'),
	(404972, 124, '2015-02-15 00:34:10.000000', 'consum', 0.0214, 'lps'),
	(404973, 124, '2015-02-15 00:34:11.000000', 'consum', 0.0219, 'lps'),
	(404974, 124, '2015-02-15 00:34:12.000000', 'consum', 0.0220, 'lps'),
	(404975, 124, '2015-02-15 00:34:13.000000', 'consum', 0.0211, 'lps'),
	(404976, 124, '2015-02-15 00:34:14.000000', 'consum', 0.0220, 'lps'),
	(404977, 124, '2015-02-15 00:34:15.000000', 'consum', 0.0211, 'lps'),
	(404978, 124, '2015-02-15 00:34:16.000000', 'consum', 0.0219, 'lps'),
	(404979, 124, '2015-02-15 00:34:17.000000', 'consum', 0.0216, 'lps'),
	(404980, 124, '2015-02-15 00:34:18.000000', 'consum', 0.0217, 'lps'),
	(404981, 124, '2015-02-15 00:34:19.000000', 'consum', 0.0212, 'lps'),
	(404982, 124, '2015-02-15 00:34:20.000000', 'consum', 0.0213, 'lps'),
	(404983, 124, '2015-02-15 00:34:21.000000', 'consum', 0.0218, 'lps'),
	(404984, 124, '2015-02-15 00:34:22.000000', 'consum', 0.0220, 'lps'),
	(404985, 124, '2015-02-15 00:34:23.000000', 'consum', 0.0211, 'lps'),
	(404986, 124, '2015-02-15 00:34:24.000000', 'consum', 0.0211, 'lps'),
	(404987, 124, '2015-02-15 00:34:25.000000', 'consum', 0.0212, 'lps'),
	(404988, 124, '2015-02-15 00:34:26.000000', 'consum', 0.0218, 'lps'),
	(404989, 124, '2015-02-15 00:34:27.000000', 'consum', 0.0218, 'lps'),
	(404990, 124, '2015-02-15 00:34:28.000000', 'consum', 0.0217, 'lps'),
	(404991, 124, '2015-02-15 00:34:29.000000', 'consum', 0.0210, 'lps'),
	(404992, 124, '2015-02-15 00:34:30.000000', 'consum', 0.0211, 'lps'),
	(404993, 124, '2015-02-15 00:34:31.000000', 'consum', 0.0215, 'lps'),
	(404994, 124, '2015-02-15 00:34:32.000000', 'consum', 0.0221, 'lps'),
	(404995, 124, '2015-02-15 00:34:33.000000', 'consum', 0.0214, 'lps'),
	(404996, 124, '2015-02-15 00:34:34.000000', 'consum', 0.0210, 'lps'),
	(404997, 124, '2015-02-15 00:34:35.000000', 'consum', 0.0212, 'lps'),
	(404998, 124, '2015-02-15 00:34:36.000000', 'consum', 0.0218, 'lps'),
	(404999, 124, '2015-02-15 00:34:37.000000', 'consum', 0.0211, 'lps'),
	(405000, 124, '2015-02-15 00:34:38.000000', 'consum', 0.0215, 'lps'),
	(405001, 124, '2015-02-15 00:34:39.000000', 'consum', 0.0219, 'lps'),
	(405002, 124, '2015-02-15 00:34:40.000000', 'consum', 0.0216, 'lps'),
	(405003, 124, '2015-02-15 00:34:41.000000', 'consum', 0.0213, 'lps'),
	(405004, 124, '2015-02-15 00:34:42.000000', 'consum', 0.0219, 'lps'),
	(405005, 124, '2015-02-15 00:34:43.000000', 'consum', 0.0210, 'lps'),
	(405006, 124, '2015-02-15 00:34:44.000000', 'consum', 0.0219, 'lps'),
	(405007, 124, '2015-02-15 00:34:45.000000', 'consum', 0.0219, 'lps'),
	(405008, 124, '2015-02-15 00:34:46.000000', 'consum', 0.0220, 'lps'),
	(405009, 124, '2015-02-15 00:34:47.000000', 'consum', 0.0219, 'lps'),
	(405010, 124, '2015-02-15 00:34:48.000000', 'consum', 0.0213, 'lps'),
	(405011, 124, '2015-02-15 00:34:49.000000', 'consum', 0.0212, 'lps'),
	(405012, 124, '2015-02-15 00:34:50.000000', 'consum', 0.0211, 'lps'),
	(405013, 124, '2015-02-15 00:34:51.000000', 'consum', 0.0220, 'lps'),
	(405014, 124, '2015-02-15 00:34:52.000000', 'consum', 0.0221, 'lps'),
	(405015, 124, '2015-02-15 00:34:53.000000', 'consum', 0.0212, 'lps'),
	(405016, 124, '2015-02-15 00:34:54.000000', 'consum', 0.0212, 'lps'),
	(405017, 124, '2015-02-15 00:34:55.000000', 'consum', 0.0214, 'lps'),
	(405018, 124, '2015-02-15 00:34:56.000000', 'consum', 0.0213, 'lps'),
	(405019, 124, '2015-02-15 00:34:57.000000', 'consum', 0.0215, 'lps'),
	(405020, 124, '2015-02-15 00:34:58.000000', 'consum', 0.0212, 'lps'),
	(405021, 124, '2015-02-15 00:34:59.000000', 'consum', 0.0219, 'lps'),
	(405022, 124, '2015-02-15 00:35:00.000000', 'consum', 0.0211, 'lps'),
	(405023, 124, '2015-02-15 00:35:01.000000', 'consum', 0.0216, 'lps'),
	(405024, 124, '2015-02-15 00:35:02.000000', 'consum', 0.0212, 'lps'),
	(405025, 124, '2015-02-15 00:35:03.000000', 'consum', 0.0215, 'lps'),
	(405026, 124, '2015-02-15 00:35:04.000000', 'consum', 0.0216, 'lps'),
	(405027, 124, '2015-02-15 00:35:05.000000', 'consum', 0.0216, 'lps'),
	(405028, 124, '2015-02-15 00:35:06.000000', 'consum', 0.0220, 'lps'),
	(405029, 124, '2015-02-15 00:35:07.000000', 'consum', 0.0221, 'lps'),
	(405030, 124, '2015-02-15 00:35:08.000000', 'consum', 0.0221, 'lps'),
	(405031, 124, '2015-02-15 00:35:09.000000', 'consum', 0.0210, 'lps'),
	(405032, 124, '2015-02-15 00:35:10.000000', 'consum', 0.0212, 'lps'),
	(405033, 124, '2015-02-15 00:35:11.000000', 'consum', 0.0211, 'lps'),
	(405034, 124, '2015-02-15 00:35:12.000000', 'consum', 0.0210, 'lps'),
	(405035, 124, '2015-02-15 00:35:13.000000', 'consum', 0.0218, 'lps'),
	(405036, 124, '2015-02-15 00:35:14.000000', 'consum', 0.0213, 'lps'),
	(405037, 124, '2015-02-15 00:35:15.000000', 'consum', 0.0214, 'lps'),
	(405038, 124, '2015-02-15 00:35:16.000000', 'consum', 0.0220, 'lps'),
	(405039, 124, '2015-02-15 00:35:17.000000', 'consum', 0.0214, 'lps'),
	(405040, 124, '2015-02-15 00:35:18.000000', 'consum', 0.0211, 'lps'),
	(405041, 124, '2015-02-15 00:35:19.000000', 'consum', 0.0218, 'lps'),
	(405042, 124, '2015-02-15 00:35:20.000000', 'consum', 0.0210, 'lps'),
	(405043, 124, '2015-02-15 00:35:21.000000', 'consum', 0.0211, 'lps'),
	(405044, 124, '2015-02-15 00:35:22.000000', 'consum', 0.0214, 'lps'),
	(405045, 124, '2015-02-15 00:35:23.000000', 'consum', 0.0216, 'lps'),
	(405046, 124, '2015-02-15 00:35:24.000000', 'consum', 0.0215, 'lps'),
	(405047, 124, '2015-02-15 00:35:25.000000', 'consum', 0.0218, 'lps'),
	(405048, 124, '2015-02-15 00:35:26.000000', 'consum', 0.0214, 'lps'),
	(405049, 124, '2015-02-15 00:35:27.000000', 'consum', 0.0217, 'lps'),
	(405050, 124, '2015-02-15 00:35:28.000000', 'consum', 0.0210, 'lps'),
	(405051, 124, '2015-02-15 00:35:29.000000', 'consum', 0.0212, 'lps'),
	(405052, 124, '2015-02-15 00:35:30.000000', 'consum', 0.0220, 'lps'),
	(405053, 124, '2015-02-15 00:35:31.000000', 'consum', 0.0218, 'lps'),
	(405054, 124, '2015-02-15 00:35:32.000000', 'consum', 0.0210, 'lps'),
	(405055, 124, '2015-02-15 00:35:33.000000', 'consum', 0.0212, 'lps'),
	(405056, 124, '2015-02-15 00:35:34.000000', 'consum', 0.0217, 'lps'),
	(405057, 124, '2015-02-15 00:35:35.000000', 'consum', 0.0217, 'lps'),
	(405058, 124, '2015-02-15 00:35:36.000000', 'consum', 0.0214, 'lps'),
	(405059, 124, '2015-02-15 00:35:37.000000', 'consum', 0.0220, 'lps'),
	(405060, 124, '2015-02-15 00:35:38.000000', 'consum', 0.0214, 'lps'),
	(405061, 124, '2015-02-15 00:35:39.000000', 'consum', 0.0211, 'lps'),
	(405062, 124, '2015-02-15 00:35:40.000000', 'consum', 0.0214, 'lps'),
	(405063, 124, '2015-02-15 00:35:41.000000', 'consum', 0.0218, 'lps'),
	(405064, 124, '2015-02-15 00:35:42.000000', 'consum', 0.0212, 'lps'),
	(405065, 124, '2015-02-15 00:35:43.000000', 'consum', 0.0221, 'lps'),
	(405066, 124, '2015-02-15 00:35:44.000000', 'consum', 0.0211, 'lps'),
	(405067, 124, '2015-02-15 00:35:45.000000', 'consum', 0.0220, 'lps'),
	(405068, 124, '2015-02-15 00:35:46.000000', 'consum', 0.0220, 'lps'),
	(405069, 124, '2015-02-15 00:35:47.000000', 'consum', 0.0219, 'lps'),
	(405070, 124, '2015-02-15 00:35:48.000000', 'consum', 0.0213, 'lps'),
	(405071, 124, '2015-02-15 00:35:49.000000', 'consum', 0.0211, 'lps'),
	(405072, 124, '2015-02-15 00:35:50.000000', 'consum', 0.0217, 'lps'),
	(405073, 124, '2015-02-15 00:35:51.000000', 'consum', 0.0218, 'lps'),
	(405074, 124, '2015-02-15 00:35:52.000000', 'consum', 0.0221, 'lps'),
	(405075, 124, '2015-02-15 00:35:53.000000', 'consum', 0.0214, 'lps'),
	(405076, 124, '2015-02-15 00:35:54.000000', 'consum', 0.0212, 'lps'),
	(405077, 124, '2015-02-15 00:35:55.000000', 'consum', 0.0219, 'lps'),
	(405078, 124, '2015-02-15 00:35:56.000000', 'consum', 0.0212, 'lps'),
	(405079, 124, '2015-02-15 00:35:57.000000', 'consum', 0.0218, 'lps'),
	(405080, 124, '2015-02-15 00:35:58.000000', 'consum', 0.0210, 'lps'),
	(405081, 124, '2015-02-15 00:35:59.000000', 'consum', 0.0220, 'lps'),
	(405082, 124, '2015-02-15 00:36:00.000000', 'consum', 0.0214, 'lps'),
	(405083, 124, '2015-02-15 00:36:01.000000', 'consum', 0.0213, 'lps'),
	(405084, 124, '2015-02-15 00:36:02.000000', 'consum', 0.0213, 'lps'),
	(405085, 124, '2015-02-15 00:36:03.000000', 'consum', 0.0218, 'lps'),
	(405086, 124, '2015-02-15 00:36:04.000000', 'consum', 0.0217, 'lps'),
	(405087, 124, '2015-02-15 00:36:05.000000', 'consum', 0.0220, 'lps'),
	(405088, 124, '2015-02-15 00:36:06.000000', 'consum', 0.0217, 'lps'),
	(405089, 124, '2015-02-15 00:36:07.000000', 'consum', 0.0215, 'lps'),
	(405090, 124, '2015-02-15 00:36:08.000000', 'consum', 0.0216, 'lps'),
	(405091, 124, '2015-02-15 00:36:09.000000', 'consum', 0.0213, 'lps'),
	(405092, 124, '2015-02-15 00:36:10.000000', 'consum', 0.0220, 'lps'),
	(405093, 124, '2015-02-15 00:36:11.000000', 'consum', 0.0217, 'lps'),
	(405094, 124, '2015-02-15 00:36:12.000000', 'consum', 0.0214, 'lps'),
	(405095, 124, '2015-02-15 00:36:13.000000', 'consum', 0.0219, 'lps'),
	(405096, 124, '2015-02-15 00:36:14.000000', 'consum', 0.0211, 'lps'),
	(405097, 124, '2015-02-15 00:36:15.000000', 'consum', 0.0212, 'lps'),
	(405098, 124, '2015-02-15 00:36:16.000000', 'consum', 0.0216, 'lps'),
	(405099, 124, '2015-02-15 00:36:17.000000', 'consum', 0.0211, 'lps'),
	(405100, 124, '2015-02-15 00:36:18.000000', 'consum', 0.0220, 'lps'),
	(405101, 124, '2015-02-15 00:36:19.000000', 'consum', 0.0210, 'lps'),
	(405102, 124, '2015-02-15 00:36:20.000000', 'consum', 0.0218, 'lps'),
	(405103, 124, '2015-02-15 00:36:21.000000', 'consum', 0.0215, 'lps'),
	(405104, 124, '2015-02-15 00:36:22.000000', 'consum', 0.0212, 'lps'),
	(405105, 124, '2015-02-15 00:36:23.000000', 'consum', 0.0216, 'lps'),
	(405106, 124, '2015-02-15 00:36:24.000000', 'consum', 0.0211, 'lps'),
	(405107, 124, '2015-02-15 00:36:25.000000', 'consum', 0.0210, 'lps'),
	(405108, 124, '2015-02-15 00:36:26.000000', 'consum', 0.0218, 'lps'),
	(405109, 124, '2015-02-15 00:36:27.000000', 'consum', 0.0213, 'lps'),
	(405110, 124, '2015-02-15 00:36:28.000000', 'consum', 0.0217, 'lps'),
	(405111, 124, '2015-02-15 00:36:29.000000', 'consum', 0.0211, 'lps'),
	(405112, 124, '2015-02-15 00:36:30.000000', 'consum', 0.0218, 'lps'),
	(405113, 124, '2015-02-15 00:36:31.000000', 'consum', 0.0214, 'lps'),
	(405114, 124, '2015-02-15 00:36:32.000000', 'consum', 0.0216, 'lps'),
	(405115, 124, '2015-02-15 00:36:33.000000', 'consum', 0.0217, 'lps'),
	(405116, 124, '2015-02-15 00:36:34.000000', 'consum', 0.0215, 'lps'),
	(405117, 124, '2015-02-15 00:36:35.000000', 'consum', 0.0213, 'lps'),
	(405118, 124, '2015-02-15 00:36:36.000000', 'consum', 0.0214, 'lps'),
	(405119, 124, '2015-02-15 00:36:37.000000', 'consum', 0.0219, 'lps'),
	(405120, 124, '2015-02-15 00:36:38.000000', 'consum', 0.0220, 'lps'),
	(405121, 124, '2015-02-15 00:36:39.000000', 'consum', 0.0221, 'lps'),
	(405122, 124, '2015-02-15 00:36:40.000000', 'consum', 0.0214, 'lps'),
	(405123, 124, '2015-02-15 00:36:41.000000', 'consum', 0.0219, 'lps'),
	(405124, 124, '2015-02-15 00:36:42.000000', 'consum', 0.0219, 'lps'),
	(405125, 124, '2015-02-15 00:36:43.000000', 'consum', 0.0218, 'lps'),
	(405126, 124, '2015-02-15 00:36:44.000000', 'consum', 0.0211, 'lps'),
	(405127, 124, '2015-02-15 00:36:45.000000', 'consum', 0.0215, 'lps'),
	(405128, 124, '2015-02-15 00:36:46.000000', 'consum', 0.0219, 'lps'),
	(405129, 124, '2015-02-15 00:36:47.000000', 'consum', 0.0217, 'lps'),
	(405130, 124, '2015-02-15 00:36:48.000000', 'consum', 0.0220, 'lps'),
	(405131, 124, '2015-02-15 00:36:49.000000', 'consum', 0.0213, 'lps'),
	(405132, 124, '2015-02-15 00:36:50.000000', 'consum', 0.0221, 'lps'),
	(405133, 124, '2015-02-15 00:36:51.000000', 'consum', 0.0210, 'lps'),
	(405134, 124, '2015-02-15 00:36:52.000000', 'consum', 0.0214, 'lps'),
	(405135, 124, '2015-02-15 00:36:53.000000', 'consum', 0.0216, 'lps'),
	(405136, 124, '2015-02-15 00:36:54.000000', 'consum', 0.0216, 'lps'),
	(405137, 124, '2015-02-15 00:36:55.000000', 'consum', 0.0212, 'lps'),
	(405138, 124, '2015-02-15 00:36:56.000000', 'consum', 0.0214, 'lps'),
	(405139, 124, '2015-02-15 00:36:57.000000', 'consum', 0.0211, 'lps'),
	(405140, 124, '2015-02-15 00:36:58.000000', 'consum', 0.0217, 'lps'),
	(405141, 124, '2015-02-15 00:36:59.000000', 'consum', 0.0220, 'lps'),
	(405142, 124, '2015-02-15 00:37:00.000000', 'consum', 0.0212, 'lps'),
	(405143, 124, '2015-02-15 00:37:01.000000', 'consum', 0.0217, 'lps'),
	(405144, 124, '2015-02-15 00:37:02.000000', 'consum', 0.0215, 'lps'),
	(405145, 124, '2015-02-15 00:37:03.000000', 'consum', 0.0216, 'lps'),
	(405146, 124, '2015-02-15 00:37:04.000000', 'consum', 0.0211, 'lps'),
	(405147, 124, '2015-02-15 00:37:05.000000', 'consum', 0.0211, 'lps'),
	(405148, 124, '2015-02-15 00:37:06.000000', 'consum', 0.0212, 'lps'),
	(405149, 124, '2015-02-15 00:37:07.000000', 'consum', 0.0219, 'lps'),
	(405150, 124, '2015-02-15 00:37:08.000000', 'consum', 0.0213, 'lps'),
	(405151, 124, '2015-02-15 00:37:09.000000', 'consum', 0.0221, 'lps'),
	(405152, 124, '2015-02-15 00:37:10.000000', 'consum', 0.0211, 'lps'),
	(405153, 124, '2015-02-15 00:37:11.000000', 'consum', 0.0217, 'lps'),
	(405154, 124, '2015-02-15 00:37:12.000000', 'consum', 0.0218, 'lps'),
	(405155, 124, '2015-02-15 00:37:13.000000', 'consum', 0.0220, 'lps'),
	(405156, 124, '2015-02-15 00:37:14.000000', 'consum', 0.0210, 'lps'),
	(405157, 124, '2015-02-15 00:37:15.000000', 'consum', 0.0216, 'lps'),
	(405158, 124, '2015-02-15 00:37:16.000000', 'consum', 0.0216, 'lps'),
	(405159, 124, '2015-02-15 00:37:17.000000', 'consum', 0.0214, 'lps'),
	(405160, 124, '2015-02-15 00:37:18.000000', 'consum', 0.0221, 'lps'),
	(405161, 124, '2015-02-15 00:37:19.000000', 'consum', 0.0218, 'lps'),
	(405162, 124, '2015-02-15 00:37:20.000000', 'consum', 0.0216, 'lps'),
	(405163, 124, '2015-02-15 00:37:21.000000', 'consum', 0.0218, 'lps'),
	(405164, 124, '2015-02-15 00:37:22.000000', 'consum', 0.0220, 'lps'),
	(405165, 124, '2015-02-15 00:37:23.000000', 'consum', 0.0214, 'lps'),
	(405166, 124, '2015-02-15 00:37:24.000000', 'consum', 0.0213, 'lps'),
	(405167, 124, '2015-02-15 00:37:25.000000', 'consum', 0.0211, 'lps'),
	(405168, 124, '2015-02-15 00:37:26.000000', 'consum', 0.0220, 'lps'),
	(405169, 124, '2015-02-15 00:37:27.000000', 'consum', 0.0220, 'lps'),
	(405170, 124, '2015-02-15 00:37:28.000000', 'consum', 0.0221, 'lps'),
	(405171, 124, '2015-02-15 00:37:29.000000', 'consum', 0.0211, 'lps'),
	(405172, 124, '2015-02-15 00:37:30.000000', 'consum', 0.0216, 'lps'),
	(405173, 124, '2015-02-15 00:37:31.000000', 'consum', 0.0215, 'lps'),
	(405174, 124, '2015-02-15 00:37:32.000000', 'consum', 0.0217, 'lps'),
	(405175, 124, '2015-02-15 00:37:33.000000', 'consum', 0.0218, 'lps'),
	(405176, 124, '2015-02-15 00:37:34.000000', 'consum', 0.0219, 'lps'),
	(405177, 124, '2015-02-15 00:37:35.000000', 'consum', 0.0220, 'lps'),
	(405178, 124, '2015-02-15 00:37:36.000000', 'consum', 0.0221, 'lps'),
	(405179, 124, '2015-02-15 00:37:37.000000', 'consum', 0.0213, 'lps'),
	(405180, 124, '2015-02-15 00:37:38.000000', 'consum', 0.0214, 'lps'),
	(405181, 124, '2015-02-15 00:37:39.000000', 'consum', 0.0221, 'lps'),
	(405182, 124, '2015-02-15 00:37:40.000000', 'consum', 0.0219, 'lps'),
	(405183, 124, '2015-02-15 00:37:41.000000', 'consum', 0.0211, 'lps'),
	(405184, 124, '2015-02-15 00:37:42.000000', 'consum', 0.0213, 'lps'),
	(405185, 124, '2015-02-15 00:37:43.000000', 'consum', 0.0221, 'lps'),
	(405186, 124, '2015-02-15 00:37:44.000000', 'consum', 0.0219, 'lps'),
	(405187, 124, '2015-02-15 00:37:45.000000', 'consum', 0.0213, 'lps'),
	(405188, 124, '2015-02-15 00:37:46.000000', 'consum', 0.0220, 'lps'),
	(405189, 124, '2015-02-15 00:37:47.000000', 'consum', 0.0215, 'lps'),
	(405190, 124, '2015-02-15 00:37:48.000000', 'consum', 0.0220, 'lps'),
	(405191, 124, '2015-02-15 00:37:49.000000', 'consum', 0.0219, 'lps'),
	(405192, 124, '2015-02-15 00:37:50.000000', 'consum', 0.0217, 'lps'),
	(405193, 124, '2015-02-15 00:37:51.000000', 'consum', 0.0216, 'lps'),
	(405194, 124, '2015-02-15 00:37:52.000000', 'consum', 0.0219, 'lps'),
	(405195, 124, '2015-02-15 00:37:53.000000', 'consum', 0.0215, 'lps'),
	(405196, 124, '2015-02-15 00:37:54.000000', 'consum', 0.0220, 'lps'),
	(405197, 124, '2015-02-15 00:37:55.000000', 'consum', 0.0221, 'lps'),
	(405198, 124, '2015-02-15 00:37:56.000000', 'consum', 0.0213, 'lps'),
	(405199, 124, '2015-02-15 00:37:57.000000', 'consum', 0.0216, 'lps'),
	(405200, 124, '2015-02-15 00:37:58.000000', 'consum', 0.0219, 'lps'),
	(405201, 124, '2015-02-15 00:37:59.000000', 'consum', 0.0214, 'lps'),
	(405202, 124, '2015-02-15 00:38:00.000000', 'consum', 0.0215, 'lps'),
	(405203, 124, '2015-02-15 00:38:01.000000', 'consum', 0.0210, 'lps'),
	(405204, 124, '2015-02-15 00:38:02.000000', 'consum', 0.0210, 'lps'),
	(405205, 124, '2015-02-15 00:38:03.000000', 'consum', 0.0211, 'lps'),
	(405206, 124, '2015-02-15 00:38:04.000000', 'consum', 0.0216, 'lps'),
	(405207, 124, '2015-02-15 00:38:05.000000', 'consum', 0.0211, 'lps'),
	(405208, 124, '2015-02-15 00:38:06.000000', 'consum', 0.0210, 'lps'),
	(405209, 124, '2015-02-15 00:38:07.000000', 'consum', 0.0220, 'lps'),
	(405210, 124, '2015-02-15 00:38:08.000000', 'consum', 0.0211, 'lps'),
	(405211, 124, '2015-02-15 00:38:09.000000', 'consum', 0.0212, 'lps'),
	(405212, 124, '2015-02-15 00:38:10.000000', 'consum', 0.0214, 'lps'),
	(405213, 124, '2015-02-15 00:38:11.000000', 'consum', 0.0216, 'lps'),
	(405214, 124, '2015-02-15 00:38:12.000000', 'consum', 0.0215, 'lps'),
	(405215, 124, '2015-02-15 00:38:13.000000', 'consum', 0.0219, 'lps'),
	(405216, 124, '2015-02-15 00:38:14.000000', 'consum', 0.0216, 'lps'),
	(405217, 124, '2015-02-15 00:38:15.000000', 'consum', 0.0212, 'lps'),
	(405218, 124, '2015-02-15 00:38:16.000000', 'consum', 0.0217, 'lps'),
	(405219, 124, '2015-02-15 00:38:17.000000', 'consum', 0.0215, 'lps'),
	(405220, 124, '2015-02-15 00:38:18.000000', 'consum', 0.0215, 'lps'),
	(405221, 124, '2015-02-15 00:38:19.000000', 'consum', 0.0210, 'lps'),
	(405222, 124, '2015-02-15 00:38:20.000000', 'consum', 0.0217, 'lps'),
	(405223, 124, '2015-02-15 00:38:21.000000', 'consum', 0.0211, 'lps'),
	(405224, 124, '2015-02-15 00:38:22.000000', 'consum', 0.0219, 'lps'),
	(405225, 124, '2015-02-15 00:38:23.000000', 'consum', 0.0214, 'lps'),
	(405226, 124, '2015-02-15 00:38:24.000000', 'consum', 0.0218, 'lps'),
	(405227, 124, '2015-02-15 00:38:25.000000', 'consum', 0.0215, 'lps'),
	(405228, 124, '2015-02-15 00:38:26.000000', 'consum', 0.0212, 'lps'),
	(405229, 124, '2015-02-15 00:38:27.000000', 'consum', 0.0215, 'lps'),
	(405230, 124, '2015-02-15 00:38:28.000000', 'consum', 0.0219, 'lps'),
	(405231, 124, '2015-02-15 00:38:29.000000', 'consum', 0.0218, 'lps'),
	(405232, 124, '2015-02-15 00:38:30.000000', 'consum', 0.0210, 'lps'),
	(405233, 124, '2015-02-15 00:38:31.000000', 'consum', 0.0221, 'lps'),
	(405234, 124, '2015-02-15 00:38:32.000000', 'consum', 0.0218, 'lps'),
	(405235, 124, '2015-02-15 00:38:33.000000', 'consum', 0.0217, 'lps'),
	(405236, 124, '2015-02-15 00:38:34.000000', 'consum', 0.0220, 'lps'),
	(405237, 124, '2015-02-15 00:38:35.000000', 'consum', 0.0218, 'lps'),
	(405238, 124, '2015-02-15 00:38:36.000000', 'consum', 0.0219, 'lps'),
	(405239, 124, '2015-02-15 00:38:37.000000', 'consum', 0.0210, 'lps'),
	(405240, 124, '2015-02-15 00:38:38.000000', 'consum', 0.0217, 'lps'),
	(405241, 124, '2015-02-15 00:38:39.000000', 'consum', 0.0211, 'lps'),
	(405242, 124, '2015-02-15 00:38:40.000000', 'consum', 0.0218, 'lps'),
	(405243, 124, '2015-02-15 00:38:41.000000', 'consum', 0.0210, 'lps'),
	(405244, 124, '2015-02-15 00:38:42.000000', 'consum', 0.0212, 'lps'),
	(405245, 124, '2015-02-15 00:38:43.000000', 'consum', 0.0219, 'lps'),
	(405246, 124, '2015-02-15 00:38:44.000000', 'consum', 0.0216, 'lps'),
	(405247, 124, '2015-02-15 00:38:45.000000', 'consum', 0.0211, 'lps'),
	(405248, 124, '2015-02-15 00:38:46.000000', 'consum', 0.0221, 'lps'),
	(405249, 124, '2015-02-15 00:38:47.000000', 'consum', 0.0213, 'lps'),
	(405250, 124, '2015-02-15 00:38:48.000000', 'consum', 0.0220, 'lps'),
	(405251, 124, '2015-02-15 00:38:49.000000', 'consum', 0.0214, 'lps'),
	(405252, 124, '2015-02-15 00:38:50.000000', 'consum', 0.0214, 'lps'),
	(405253, 124, '2015-02-15 00:38:51.000000', 'consum', 0.0219, 'lps'),
	(405254, 124, '2015-02-15 00:38:52.000000', 'consum', 0.0219, 'lps'),
	(405255, 124, '2015-02-15 00:38:53.000000', 'consum', 0.0218, 'lps'),
	(405256, 124, '2015-02-15 00:38:54.000000', 'consum', 0.0210, 'lps'),
	(405257, 124, '2015-02-15 00:38:55.000000', 'consum', 0.0221, 'lps'),
	(405258, 124, '2015-02-15 00:38:56.000000', 'consum', 0.0220, 'lps'),
	(405259, 124, '2015-02-15 00:38:57.000000', 'consum', 0.0214, 'lps'),
	(405260, 124, '2015-02-15 00:38:58.000000', 'consum', 0.0212, 'lps'),
	(405261, 124, '2015-02-15 00:38:59.000000', 'consum', 0.0219, 'lps'),
	(405262, 124, '2015-02-15 00:39:00.000000', 'consum', 0.0216, 'lps'),
	(405263, 124, '2015-02-15 00:39:01.000000', 'consum', 0.0214, 'lps'),
	(405264, 124, '2015-02-15 00:39:02.000000', 'consum', 0.0210, 'lps'),
	(405265, 124, '2015-02-15 00:39:03.000000', 'consum', 0.0211, 'lps'),
	(405266, 124, '2015-02-15 00:39:04.000000', 'consum', 0.0217, 'lps'),
	(405267, 124, '2015-02-15 00:39:05.000000', 'consum', 0.0216, 'lps'),
	(405268, 124, '2015-02-15 00:39:06.000000', 'consum', 0.0220, 'lps'),
	(405269, 124, '2015-02-15 00:39:07.000000', 'consum', 0.0218, 'lps'),
	(405270, 124, '2015-02-15 00:39:08.000000', 'consum', 0.0211, 'lps'),
	(405271, 124, '2015-02-15 00:39:09.000000', 'consum', 0.0214, 'lps'),
	(405272, 124, '2015-02-15 00:39:10.000000', 'consum', 0.0218, 'lps'),
	(405273, 124, '2015-02-15 00:39:11.000000', 'consum', 0.0212, 'lps'),
	(405274, 124, '2015-02-15 00:39:12.000000', 'consum', 0.0221, 'lps'),
	(405275, 124, '2015-02-15 00:39:13.000000', 'consum', 0.0210, 'lps'),
	(405276, 124, '2015-02-15 00:39:14.000000', 'consum', 0.0213, 'lps'),
	(405277, 124, '2015-02-15 00:39:15.000000', 'consum', 0.0216, 'lps'),
	(405278, 124, '2015-02-15 00:39:16.000000', 'consum', 0.0219, 'lps'),
	(405279, 124, '2015-02-15 00:39:17.000000', 'consum', 0.0212, 'lps'),
	(405280, 124, '2015-02-15 00:39:18.000000', 'consum', 0.0220, 'lps'),
	(405281, 124, '2015-02-15 00:39:19.000000', 'consum', 0.0219, 'lps'),
	(405282, 124, '2015-02-15 00:39:20.000000', 'consum', 0.0211, 'lps'),
	(405283, 124, '2015-02-15 00:39:21.000000', 'consum', 0.0213, 'lps'),
	(405284, 124, '2015-02-15 00:39:22.000000', 'consum', 0.0211, 'lps'),
	(405285, 124, '2015-02-15 00:39:23.000000', 'consum', 0.0219, 'lps'),
	(405286, 124, '2015-02-15 00:39:24.000000', 'consum', 0.0217, 'lps'),
	(405287, 124, '2015-02-15 00:39:25.000000', 'consum', 0.0220, 'lps'),
	(405288, 124, '2015-02-15 00:39:26.000000', 'consum', 0.0214, 'lps'),
	(405289, 124, '2015-02-15 00:39:27.000000', 'consum', 0.0212, 'lps'),
	(405290, 124, '2015-02-15 00:39:28.000000', 'consum', 0.0219, 'lps'),
	(405291, 124, '2015-02-15 00:39:29.000000', 'consum', 0.0217, 'lps'),
	(405292, 124, '2015-02-15 00:39:30.000000', 'consum', 0.0215, 'lps'),
	(405293, 124, '2015-02-15 00:39:31.000000', 'consum', 0.0218, 'lps'),
	(405294, 124, '2015-02-15 00:39:32.000000', 'consum', 0.0220, 'lps'),
	(405295, 124, '2015-02-15 00:39:33.000000', 'consum', 0.0215, 'lps'),
	(405296, 124, '2015-02-15 00:39:34.000000', 'consum', 0.0217, 'lps'),
	(405297, 124, '2015-02-15 00:39:35.000000', 'consum', 0.0219, 'lps'),
	(405298, 124, '2015-02-15 00:39:36.000000', 'consum', 0.0221, 'lps'),
	(405299, 124, '2015-02-15 00:39:37.000000', 'consum', 0.0215, 'lps'),
	(405300, 124, '2015-02-15 00:39:38.000000', 'consum', 0.0215, 'lps'),
	(405301, 124, '2015-02-15 00:39:39.000000', 'consum', 0.0219, 'lps'),
	(405302, 124, '2015-02-15 00:39:40.000000', 'consum', 0.0216, 'lps'),
	(405303, 124, '2015-02-15 00:39:41.000000', 'consum', 0.0215, 'lps'),
	(405304, 124, '2015-02-15 00:39:42.000000', 'consum', 0.0218, 'lps'),
	(405305, 124, '2015-02-15 00:39:43.000000', 'consum', 0.0212, 'lps'),
	(405306, 124, '2015-02-15 00:39:44.000000', 'consum', 0.0219, 'lps'),
	(405307, 124, '2015-02-15 00:39:45.000000', 'consum', 0.0214, 'lps'),
	(405308, 124, '2015-02-15 00:39:46.000000', 'consum', 0.0216, 'lps'),
	(405309, 124, '2015-02-15 00:39:47.000000', 'consum', 0.0215, 'lps'),
	(405310, 124, '2015-02-15 00:39:48.000000', 'consum', 0.0218, 'lps'),
	(405311, 124, '2015-02-15 00:39:49.000000', 'consum', 0.0212, 'lps'),
	(405312, 124, '2015-02-15 00:39:50.000000', 'consum', 0.0218, 'lps'),
	(405313, 124, '2015-02-15 00:39:51.000000', 'consum', 0.0211, 'lps'),
	(405314, 124, '2015-02-15 00:39:52.000000', 'consum', 0.0216, 'lps'),
	(405315, 124, '2015-02-15 00:39:53.000000', 'consum', 0.0213, 'lps'),
	(405316, 124, '2015-02-15 00:39:54.000000', 'consum', 0.0219, 'lps'),
	(405317, 124, '2015-02-15 00:39:55.000000', 'consum', 0.0212, 'lps'),
	(405318, 124, '2015-02-15 00:39:56.000000', 'consum', 0.0215, 'lps'),
	(405319, 124, '2015-02-15 00:39:57.000000', 'consum', 0.0220, 'lps'),
	(405320, 124, '2015-02-15 00:39:58.000000', 'consum', 0.0221, 'lps'),
	(405321, 124, '2015-02-15 00:39:59.000000', 'consum', 0.0210, 'lps'),
	(405322, 124, '2015-02-15 00:40:00.000000', 'consum', 0.0212, 'lps'),
	(405323, 124, '2015-02-15 00:40:01.000000', 'consum', 0.0211, 'lps'),
	(405324, 124, '2015-02-15 00:40:02.000000', 'consum', 0.0211, 'lps'),
	(405325, 124, '2015-02-15 00:40:03.000000', 'consum', 0.0211, 'lps'),
	(405326, 124, '2015-02-15 00:40:04.000000', 'consum', 0.0213, 'lps'),
	(405327, 124, '2015-02-15 00:40:05.000000', 'consum', 0.0220, 'lps'),
	(405328, 124, '2015-02-15 00:40:06.000000', 'consum', 0.0218, 'lps'),
	(405329, 124, '2015-02-15 00:40:07.000000', 'consum', 0.0210, 'lps'),
	(405330, 124, '2015-02-15 00:40:08.000000', 'consum', 0.0220, 'lps'),
	(405331, 124, '2015-02-15 00:40:09.000000', 'consum', 0.0212, 'lps'),
	(405332, 124, '2015-02-15 00:40:10.000000', 'consum', 0.0213, 'lps'),
	(405333, 124, '2015-02-15 00:40:11.000000', 'consum', 0.0211, 'lps'),
	(405334, 124, '2015-02-15 00:40:12.000000', 'consum', 0.0215, 'lps'),
	(405335, 124, '2015-02-15 00:40:13.000000', 'consum', 0.0211, 'lps'),
	(405336, 124, '2015-02-15 00:40:14.000000', 'consum', 0.0212, 'lps'),
	(405337, 124, '2015-02-15 00:40:15.000000', 'consum', 0.0217, 'lps'),
	(405338, 124, '2015-02-15 00:40:16.000000', 'consum', 0.0218, 'lps'),
	(405339, 124, '2015-02-15 00:40:17.000000', 'consum', 0.0214, 'lps'),
	(405340, 124, '2015-02-15 00:40:18.000000', 'consum', 0.0210, 'lps'),
	(405341, 124, '2015-02-15 00:40:19.000000', 'consum', 0.0220, 'lps'),
	(405342, 124, '2015-02-15 00:40:20.000000', 'consum', 0.0215, 'lps'),
	(405343, 124, '2015-02-15 00:40:21.000000', 'consum', 0.0214, 'lps'),
	(405344, 124, '2015-02-15 00:40:22.000000', 'consum', 0.0219, 'lps'),
	(405345, 124, '2015-02-15 00:40:23.000000', 'consum', 0.0218, 'lps'),
	(405346, 124, '2015-02-15 00:40:24.000000', 'consum', 0.0210, 'lps'),
	(405347, 124, '2015-02-15 00:40:25.000000', 'consum', 0.0211, 'lps'),
	(405348, 124, '2015-02-15 00:40:26.000000', 'consum', 0.0218, 'lps'),
	(405349, 124, '2015-02-15 00:40:27.000000', 'consum', 0.0221, 'lps'),
	(405350, 124, '2015-02-15 00:40:28.000000', 'consum', 0.0220, 'lps'),
	(405351, 124, '2015-02-15 00:40:29.000000', 'consum', 0.0213, 'lps'),
	(405352, 124, '2015-02-15 00:40:30.000000', 'consum', 0.0220, 'lps'),
	(405353, 124, '2015-02-15 00:40:31.000000', 'consum', 0.0216, 'lps'),
	(405354, 124, '2015-02-15 00:40:32.000000', 'consum', 0.0221, 'lps'),
	(405355, 124, '2015-02-15 00:40:33.000000', 'consum', 0.0211, 'lps'),
	(405356, 124, '2015-02-15 00:40:34.000000', 'consum', 0.0220, 'lps'),
	(405357, 124, '2015-02-15 00:40:35.000000', 'consum', 0.0210, 'lps'),
	(405358, 124, '2015-02-15 00:40:36.000000', 'consum', 0.0214, 'lps'),
	(405359, 124, '2015-02-15 00:40:37.000000', 'consum', 0.0220, 'lps'),
	(405360, 124, '2015-02-15 00:40:38.000000', 'consum', 0.0214, 'lps'),
	(405361, 124, '2015-02-15 00:40:39.000000', 'consum', 0.0211, 'lps'),
	(405362, 124, '2015-02-15 00:40:40.000000', 'consum', 0.0214, 'lps'),
	(405363, 124, '2015-02-15 00:40:41.000000', 'consum', 0.0218, 'lps'),
	(405364, 124, '2015-02-15 00:40:42.000000', 'consum', 0.0213, 'lps'),
	(405365, 124, '2015-02-15 00:40:43.000000', 'consum', 0.0215, 'lps'),
	(405366, 124, '2015-02-15 00:40:44.000000', 'consum', 0.0216, 'lps'),
	(405367, 124, '2015-02-15 00:40:45.000000', 'consum', 0.0211, 'lps'),
	(405368, 124, '2015-02-15 00:40:46.000000', 'consum', 0.0221, 'lps'),
	(405369, 124, '2015-02-15 00:40:47.000000', 'consum', 0.0217, 'lps'),
	(405370, 124, '2015-02-15 00:40:48.000000', 'consum', 0.0213, 'lps'),
	(405371, 124, '2015-02-15 00:40:49.000000', 'consum', 0.0215, 'lps'),
	(405372, 124, '2015-02-15 00:40:50.000000', 'consum', 0.0216, 'lps'),
	(405373, 124, '2015-02-15 00:40:51.000000', 'consum', 0.0214, 'lps'),
	(405374, 124, '2015-02-15 00:40:52.000000', 'consum', 0.0211, 'lps'),
	(405375, 124, '2015-02-15 00:40:53.000000', 'consum', 0.0216, 'lps'),
	(405376, 124, '2015-02-15 00:40:54.000000', 'consum', 0.0216, 'lps'),
	(405377, 124, '2015-02-15 00:40:55.000000', 'consum', 0.0219, 'lps'),
	(405378, 124, '2015-02-15 00:40:56.000000', 'consum', 0.0214, 'lps'),
	(405379, 124, '2015-02-15 00:40:57.000000', 'consum', 0.0214, 'lps'),
	(405380, 124, '2015-02-15 00:40:58.000000', 'consum', 0.0210, 'lps'),
	(405381, 124, '2015-02-15 00:40:59.000000', 'consum', 0.0220, 'lps'),
	(405382, 124, '2015-02-15 00:41:00.000000', 'consum', 0.0211, 'lps'),
	(405383, 124, '2015-02-15 00:41:01.000000', 'consum', 0.0213, 'lps'),
	(405384, 124, '2015-02-15 00:41:02.000000', 'consum', 0.0220, 'lps'),
	(405385, 124, '2015-02-15 00:41:03.000000', 'consum', 0.0215, 'lps'),
	(405386, 124, '2015-02-15 00:41:04.000000', 'consum', 0.0220, 'lps'),
	(405387, 124, '2015-02-15 00:41:05.000000', 'consum', 0.0220, 'lps'),
	(405388, 124, '2015-02-15 00:41:06.000000', 'consum', 0.0221, 'lps'),
	(405389, 124, '2015-02-15 00:41:07.000000', 'consum', 0.0221, 'lps'),
	(405390, 124, '2015-02-15 00:41:08.000000', 'consum', 0.0220, 'lps'),
	(405391, 124, '2015-02-15 00:41:09.000000', 'consum', 0.0217, 'lps'),
	(405392, 124, '2015-02-15 00:41:10.000000', 'consum', 0.0215, 'lps'),
	(405393, 124, '2015-02-15 00:41:11.000000', 'consum', 0.0215, 'lps'),
	(405394, 124, '2015-02-15 00:41:12.000000', 'consum', 0.0210, 'lps'),
	(405395, 124, '2015-02-15 00:41:13.000000', 'consum', 0.0219, 'lps'),
	(405396, 124, '2015-02-15 00:41:14.000000', 'consum', 0.0221, 'lps'),
	(405397, 124, '2015-02-15 00:41:15.000000', 'consum', 0.0213, 'lps'),
	(405398, 124, '2015-02-15 00:41:16.000000', 'consum', 0.0218, 'lps'),
	(405399, 124, '2015-02-15 00:41:17.000000', 'consum', 0.0216, 'lps'),
	(405400, 124, '2015-02-15 00:41:18.000000', 'consum', 0.0217, 'lps'),
	(405401, 124, '2015-02-15 00:41:19.000000', 'consum', 0.0217, 'lps'),
	(405402, 124, '2015-02-15 00:41:20.000000', 'consum', 0.0211, 'lps'),
	(405403, 124, '2015-02-15 00:41:21.000000', 'consum', 0.0217, 'lps'),
	(405404, 124, '2015-02-15 00:41:22.000000', 'consum', 0.0218, 'lps'),
	(405405, 124, '2015-02-15 00:41:23.000000', 'consum', 0.0219, 'lps'),
	(405406, 124, '2015-02-15 00:41:24.000000', 'consum', 0.0220, 'lps'),
	(405407, 124, '2015-02-15 00:41:25.000000', 'consum', 0.0210, 'lps'),
	(405408, 124, '2015-02-15 00:41:26.000000', 'consum', 0.0214, 'lps'),
	(405409, 124, '2015-02-15 00:41:27.000000', 'consum', 0.0220, 'lps'),
	(405410, 124, '2015-02-15 00:41:28.000000', 'consum', 0.0214, 'lps'),
	(405411, 124, '2015-02-15 00:41:29.000000', 'consum', 0.0211, 'lps'),
	(405412, 124, '2015-02-15 00:41:30.000000', 'consum', 0.0216, 'lps'),
	(405413, 124, '2015-02-15 00:41:31.000000', 'consum', 0.0213, 'lps'),
	(405414, 124, '2015-02-15 00:41:32.000000', 'consum', 0.0221, 'lps'),
	(405415, 124, '2015-02-15 00:41:33.000000', 'consum', 0.0218, 'lps'),
	(405416, 124, '2015-02-15 00:41:34.000000', 'consum', 0.0218, 'lps'),
	(405417, 124, '2015-02-15 00:41:35.000000', 'consum', 0.0217, 'lps'),
	(405418, 124, '2015-02-15 00:41:36.000000', 'consum', 0.0219, 'lps'),
	(405419, 124, '2015-02-15 00:41:37.000000', 'consum', 0.0221, 'lps'),
	(405420, 124, '2015-02-15 00:41:38.000000', 'consum', 0.0218, 'lps'),
	(405421, 124, '2015-02-15 00:41:39.000000', 'consum', 0.0216, 'lps'),
	(405422, 124, '2015-02-15 00:41:40.000000', 'consum', 0.0216, 'lps'),
	(405423, 124, '2015-02-15 00:41:41.000000', 'consum', 0.0212, 'lps'),
	(405424, 124, '2015-02-15 00:41:42.000000', 'consum', 0.0212, 'lps'),
	(405425, 124, '2015-02-15 00:41:43.000000', 'consum', 0.0216, 'lps'),
	(405426, 124, '2015-02-15 00:41:44.000000', 'consum', 0.0211, 'lps'),
	(405427, 124, '2015-02-15 00:41:45.000000', 'consum', 0.0220, 'lps'),
	(405428, 124, '2015-02-15 00:41:46.000000', 'consum', 0.0212, 'lps'),
	(405429, 124, '2015-02-15 00:41:47.000000', 'consum', 0.0212, 'lps'),
	(405430, 124, '2015-02-15 00:41:48.000000', 'consum', 0.0215, 'lps'),
	(405431, 124, '2015-02-15 00:41:49.000000', 'consum', 0.0219, 'lps'),
	(405432, 124, '2015-02-15 00:41:50.000000', 'consum', 0.0214, 'lps'),
	(405433, 124, '2015-02-15 00:41:51.000000', 'consum', 0.0218, 'lps'),
	(405434, 124, '2015-02-15 00:41:52.000000', 'consum', 0.0213, 'lps'),
	(405435, 124, '2015-02-15 00:41:53.000000', 'consum', 0.0213, 'lps'),
	(405436, 124, '2015-02-15 00:41:54.000000', 'consum', 0.0217, 'lps'),
	(405437, 124, '2015-02-15 00:41:55.000000', 'consum', 0.0213, 'lps'),
	(405438, 124, '2015-02-15 00:41:56.000000', 'consum', 0.0217, 'lps'),
	(405439, 124, '2015-02-15 00:41:57.000000', 'consum', 0.0213, 'lps'),
	(405440, 124, '2015-02-15 00:41:58.000000', 'consum', 0.0216, 'lps'),
	(405441, 124, '2015-02-15 00:41:59.000000', 'consum', 0.0221, 'lps'),
	(405442, 124, '2015-02-15 00:42:00.000000', 'consum', 0.0211, 'lps'),
	(405443, 124, '2015-02-15 00:42:01.000000', 'consum', 0.0219, 'lps'),
	(405444, 124, '2015-02-15 00:42:02.000000', 'consum', 0.0215, 'lps'),
	(405445, 124, '2015-02-15 00:42:03.000000', 'consum', 0.0219, 'lps'),
	(405446, 124, '2015-02-15 00:42:04.000000', 'consum', 0.0218, 'lps'),
	(405447, 124, '2015-02-15 00:42:05.000000', 'consum', 0.0211, 'lps'),
	(405448, 124, '2015-02-15 00:42:06.000000', 'consum', 0.0216, 'lps'),
	(405449, 124, '2015-02-15 00:42:07.000000', 'consum', 0.0213, 'lps'),
	(405450, 124, '2015-02-15 00:42:08.000000', 'consum', 0.0210, 'lps'),
	(405451, 124, '2015-02-15 00:42:09.000000', 'consum', 0.0210, 'lps'),
	(405452, 124, '2015-02-15 00:42:10.000000', 'consum', 0.0212, 'lps'),
	(405453, 124, '2015-02-15 00:42:11.000000', 'consum', 0.0220, 'lps'),
	(405454, 124, '2015-02-15 00:42:12.000000', 'consum', 0.0217, 'lps'),
	(405455, 124, '2015-02-15 00:42:13.000000', 'consum', 0.0216, 'lps'),
	(405456, 124, '2015-02-15 00:42:14.000000', 'consum', 0.0210, 'lps'),
	(405457, 124, '2015-02-15 00:42:15.000000', 'consum', 0.0216, 'lps'),
	(405458, 124, '2015-02-15 00:42:16.000000', 'consum', 0.0214, 'lps'),
	(405459, 124, '2015-02-15 00:42:17.000000', 'consum', 0.0215, 'lps'),
	(405460, 124, '2015-02-15 00:42:18.000000', 'consum', 0.0210, 'lps'),
	(405461, 124, '2015-02-15 00:42:19.000000', 'consum', 0.0221, 'lps'),
	(405462, 124, '2015-02-15 00:42:20.000000', 'consum', 0.0218, 'lps'),
	(405463, 124, '2015-02-15 00:42:21.000000', 'consum', 0.0215, 'lps'),
	(405464, 124, '2015-02-15 00:42:22.000000', 'consum', 0.0212, 'lps'),
	(405465, 124, '2015-02-15 00:42:23.000000', 'consum', 0.0217, 'lps'),
	(405466, 124, '2015-02-15 00:42:24.000000', 'consum', 0.0216, 'lps'),
	(405467, 124, '2015-02-15 00:42:25.000000', 'consum', 0.0219, 'lps'),
	(405468, 124, '2015-02-15 00:42:26.000000', 'consum', 0.0216, 'lps'),
	(405469, 124, '2015-02-15 00:42:27.000000', 'consum', 0.0212, 'lps'),
	(405470, 124, '2015-02-15 00:42:28.000000', 'consum', 0.0216, 'lps'),
	(405471, 124, '2015-02-15 00:42:29.000000', 'consum', 0.0210, 'lps'),
	(405472, 124, '2015-02-15 00:42:30.000000', 'consum', 0.0214, 'lps'),
	(405473, 124, '2015-02-15 00:42:31.000000', 'consum', 0.0221, 'lps'),
	(405474, 124, '2015-02-15 00:42:32.000000', 'consum', 0.0215, 'lps'),
	(405475, 124, '2015-02-15 00:42:33.000000', 'consum', 0.0218, 'lps'),
	(405476, 124, '2015-02-15 00:42:34.000000', 'consum', 0.0220, 'lps'),
	(405477, 124, '2015-02-15 00:42:35.000000', 'consum', 0.0214, 'lps'),
	(405478, 124, '2015-02-15 00:42:36.000000', 'consum', 0.0212, 'lps'),
	(405479, 124, '2015-02-15 00:42:37.000000', 'consum', 0.0211, 'lps'),
	(405480, 124, '2015-02-15 00:42:38.000000', 'consum', 0.0218, 'lps'),
	(405481, 124, '2015-02-15 00:42:39.000000', 'consum', 0.0215, 'lps'),
	(405482, 124, '2015-02-15 00:42:40.000000', 'consum', 0.0221, 'lps'),
	(405483, 124, '2015-02-15 00:42:41.000000', 'consum', 0.0217, 'lps'),
	(405484, 124, '2015-02-15 00:42:42.000000', 'consum', 0.0211, 'lps'),
	(405485, 124, '2015-02-15 00:42:43.000000', 'consum', 0.0218, 'lps'),
	(405486, 124, '2015-02-15 00:42:44.000000', 'consum', 0.0211, 'lps'),
	(405487, 124, '2015-02-15 00:42:45.000000', 'consum', 0.0217, 'lps'),
	(405488, 124, '2015-02-15 00:42:46.000000', 'consum', 0.0219, 'lps'),
	(405489, 124, '2015-02-15 00:42:47.000000', 'consum', 0.0221, 'lps'),
	(405490, 124, '2015-02-15 00:42:48.000000', 'consum', 0.0213, 'lps'),
	(405491, 124, '2015-02-15 00:42:49.000000', 'consum', 0.0218, 'lps'),
	(405492, 124, '2015-02-15 00:42:50.000000', 'consum', 0.0218, 'lps'),
	(405493, 124, '2015-02-15 00:42:51.000000', 'consum', 0.0216, 'lps'),
	(405494, 124, '2015-02-15 00:42:52.000000', 'consum', 0.0215, 'lps'),
	(405495, 124, '2015-02-15 00:42:53.000000', 'consum', 0.0219, 'lps'),
	(405496, 124, '2015-02-15 00:42:54.000000', 'consum', 0.0214, 'lps'),
	(405497, 124, '2015-02-15 00:42:55.000000', 'consum', 0.0215, 'lps'),
	(405498, 124, '2015-02-15 00:42:56.000000', 'consum', 0.0214, 'lps'),
	(405499, 124, '2015-02-15 00:42:57.000000', 'consum', 0.0216, 'lps'),
	(405500, 124, '2015-02-15 00:42:58.000000', 'consum', 0.0217, 'lps'),
	(405501, 124, '2015-02-15 00:42:59.000000', 'consum', 0.0213, 'lps'),
	(405502, 124, '2015-02-15 00:43:00.000000', 'consum', 0.0218, 'lps'),
	(405503, 124, '2015-02-15 00:43:01.000000', 'consum', 0.0218, 'lps'),
	(405504, 124, '2015-02-15 00:43:02.000000', 'consum', 0.0216, 'lps'),
	(405505, 124, '2015-02-15 00:43:03.000000', 'consum', 0.0214, 'lps'),
	(405506, 124, '2015-02-15 00:43:04.000000', 'consum', 0.0214, 'lps'),
	(405507, 124, '2015-02-15 00:43:05.000000', 'consum', 0.0218, 'lps'),
	(405508, 124, '2015-02-15 00:43:06.000000', 'consum', 0.0216, 'lps'),
	(405509, 124, '2015-02-15 00:43:07.000000', 'consum', 0.0216, 'lps'),
	(405510, 124, '2015-02-15 00:43:08.000000', 'consum', 0.0211, 'lps'),
	(405511, 124, '2015-02-15 00:43:09.000000', 'consum', 0.0219, 'lps'),
	(405512, 124, '2015-02-15 00:43:10.000000', 'consum', 0.0220, 'lps'),
	(405513, 124, '2015-02-15 00:43:11.000000', 'consum', 0.0219, 'lps'),
	(405514, 124, '2015-02-15 00:43:12.000000', 'consum', 0.0214, 'lps'),
	(405515, 124, '2015-02-15 00:43:13.000000', 'consum', 0.0214, 'lps'),
	(405516, 124, '2015-02-15 00:43:14.000000', 'consum', 0.0218, 'lps'),
	(405517, 124, '2015-02-15 00:43:15.000000', 'consum', 0.0217, 'lps'),
	(405518, 124, '2015-02-15 00:43:16.000000', 'consum', 0.0210, 'lps'),
	(405519, 124, '2015-02-15 00:43:17.000000', 'consum', 0.0211, 'lps'),
	(405520, 124, '2015-02-15 00:43:18.000000', 'consum', 0.0215, 'lps'),
	(405521, 124, '2015-02-15 00:43:19.000000', 'consum', 0.0210, 'lps'),
	(405522, 124, '2015-02-15 00:43:20.000000', 'consum', 0.0219, 'lps'),
	(405523, 124, '2015-02-15 00:43:21.000000', 'consum', 0.0221, 'lps'),
	(405524, 124, '2015-02-15 00:43:22.000000', 'consum', 0.0212, 'lps'),
	(405525, 124, '2015-02-15 00:43:23.000000', 'consum', 0.0212, 'lps'),
	(405526, 124, '2015-02-15 00:43:24.000000', 'consum', 0.0217, 'lps'),
	(405527, 124, '2015-02-15 00:43:25.000000', 'consum', 0.0212, 'lps'),
	(405528, 124, '2015-02-15 00:43:26.000000', 'consum', 0.0213, 'lps'),
	(405529, 124, '2015-02-15 00:43:27.000000', 'consum', 0.0218, 'lps'),
	(405530, 124, '2015-02-15 00:43:28.000000', 'consum', 0.0218, 'lps'),
	(405531, 124, '2015-02-15 00:43:29.000000', 'consum', 0.0217, 'lps'),
	(405532, 124, '2015-02-15 00:43:30.000000', 'consum', 0.0219, 'lps'),
	(405533, 124, '2015-02-15 00:43:31.000000', 'consum', 0.0211, 'lps'),
	(405534, 124, '2015-02-15 00:43:32.000000', 'consum', 0.0211, 'lps'),
	(405535, 124, '2015-02-15 00:43:33.000000', 'consum', 0.0214, 'lps'),
	(405536, 124, '2015-02-15 00:43:34.000000', 'consum', 0.0213, 'lps'),
	(405537, 124, '2015-02-15 00:43:35.000000', 'consum', 0.0217, 'lps'),
	(405538, 124, '2015-02-15 00:43:36.000000', 'consum', 0.0221, 'lps'),
	(405539, 124, '2015-02-15 00:43:37.000000', 'consum', 0.0212, 'lps'),
	(405540, 124, '2015-02-15 00:43:38.000000', 'consum', 0.0220, 'lps'),
	(405541, 124, '2015-02-15 00:43:39.000000', 'consum', 0.0220, 'lps'),
	(405542, 124, '2015-02-15 00:43:40.000000', 'consum', 0.0219, 'lps'),
	(405543, 124, '2015-02-15 00:43:41.000000', 'consum', 0.0214, 'lps'),
	(405544, 124, '2015-02-15 00:43:42.000000', 'consum', 0.0216, 'lps'),
	(405545, 124, '2015-02-15 00:43:43.000000', 'consum', 0.0215, 'lps'),
	(405546, 124, '2015-02-15 00:43:44.000000', 'consum', 0.0217, 'lps'),
	(405547, 124, '2015-02-15 00:43:45.000000', 'consum', 0.0217, 'lps'),
	(405548, 124, '2015-02-15 00:43:46.000000', 'consum', 0.0216, 'lps'),
	(405549, 124, '2015-02-15 00:43:47.000000', 'consum', 0.0216, 'lps'),
	(405550, 124, '2015-02-15 00:43:48.000000', 'consum', 0.0213, 'lps'),
	(405551, 124, '2015-02-15 00:43:49.000000', 'consum', 0.0220, 'lps'),
	(405552, 124, '2015-02-15 00:43:50.000000', 'consum', 0.0216, 'lps'),
	(405553, 124, '2015-02-15 00:43:51.000000', 'consum', 0.0210, 'lps'),
	(405554, 124, '2015-02-15 00:43:52.000000', 'consum', 0.0218, 'lps'),
	(405555, 124, '2015-02-15 00:43:53.000000', 'consum', 0.0213, 'lps'),
	(405556, 124, '2015-02-15 00:43:54.000000', 'consum', 0.0213, 'lps'),
	(405557, 124, '2015-02-15 00:43:55.000000', 'consum', 0.0219, 'lps'),
	(405558, 124, '2015-02-15 00:43:56.000000', 'consum', 0.0220, 'lps'),
	(405559, 124, '2015-02-15 00:43:57.000000', 'consum', 0.0211, 'lps'),
	(405560, 124, '2015-02-15 00:43:58.000000', 'consum', 0.0220, 'lps'),
	(405561, 124, '2015-02-15 00:43:59.000000', 'consum', 0.0211, 'lps'),
	(405562, 124, '2015-02-15 00:44:00.000000', 'consum', 0.0221, 'lps'),
	(405563, 124, '2015-02-15 00:44:01.000000', 'consum', 0.0213, 'lps'),
	(405564, 124, '2015-02-15 00:44:02.000000', 'consum', 0.0217, 'lps'),
	(405565, 124, '2015-02-15 00:44:03.000000', 'consum', 0.0215, 'lps'),
	(405566, 124, '2015-02-15 00:44:04.000000', 'consum', 0.0213, 'lps'),
	(405567, 124, '2015-02-15 00:44:05.000000', 'consum', 0.0210, 'lps'),
	(405568, 124, '2015-02-15 00:44:06.000000', 'consum', 0.0214, 'lps'),
	(405569, 124, '2015-02-15 00:44:07.000000', 'consum', 0.0217, 'lps'),
	(405570, 124, '2015-02-15 00:44:08.000000', 'consum', 0.0211, 'lps'),
	(405571, 124, '2015-02-15 00:44:09.000000', 'consum', 0.0217, 'lps'),
	(405572, 124, '2015-02-15 00:44:10.000000', 'consum', 0.0220, 'lps'),
	(405573, 124, '2015-02-15 00:44:11.000000', 'consum', 0.0217, 'lps'),
	(405574, 124, '2015-02-15 00:44:12.000000', 'consum', 0.0214, 'lps'),
	(405575, 124, '2015-02-15 00:44:13.000000', 'consum', 0.0211, 'lps'),
	(405576, 124, '2015-02-15 00:44:14.000000', 'consum', 0.0214, 'lps'),
	(405577, 124, '2015-02-15 00:44:15.000000', 'consum', 0.0215, 'lps'),
	(405578, 124, '2015-02-15 00:44:16.000000', 'consum', 0.0213, 'lps'),
	(405579, 124, '2015-02-15 00:44:17.000000', 'consum', 0.0221, 'lps'),
	(405580, 124, '2015-02-15 00:44:18.000000', 'consum', 0.0210, 'lps'),
	(405581, 124, '2015-02-15 00:44:19.000000', 'consum', 0.0214, 'lps'),
	(405582, 124, '2015-02-15 00:44:20.000000', 'consum', 0.0218, 'lps'),
	(405583, 124, '2015-02-15 00:44:21.000000', 'consum', 0.0214, 'lps'),
	(405584, 124, '2015-02-15 00:44:22.000000', 'consum', 0.0219, 'lps'),
	(405585, 124, '2015-02-15 00:44:23.000000', 'consum', 0.0220, 'lps'),
	(405586, 124, '2015-02-15 00:44:24.000000', 'consum', 0.0210, 'lps'),
	(405587, 124, '2015-02-15 00:44:25.000000', 'consum', 0.0218, 'lps'),
	(405588, 124, '2015-02-15 00:44:26.000000', 'consum', 0.0212, 'lps'),
	(405589, 124, '2015-02-15 00:44:27.000000', 'consum', 0.0221, 'lps'),
	(405590, 124, '2015-02-15 00:44:28.000000', 'consum', 0.0212, 'lps'),
	(405591, 124, '2015-02-15 00:44:29.000000', 'consum', 0.0212, 'lps'),
	(405592, 124, '2015-02-15 00:44:30.000000', 'consum', 0.0212, 'lps'),
	(405593, 124, '2015-02-15 00:44:31.000000', 'consum', 0.0215, 'lps'),
	(405594, 124, '2015-02-15 00:44:32.000000', 'consum', 0.0219, 'lps'),
	(405595, 124, '2015-02-15 00:44:33.000000', 'consum', 0.0214, 'lps'),
	(405596, 124, '2015-02-15 00:44:34.000000', 'consum', 0.0216, 'lps'),
	(405597, 124, '2015-02-15 00:44:35.000000', 'consum', 0.0218, 'lps'),
	(405598, 124, '2015-02-15 00:44:36.000000', 'consum', 0.0218, 'lps'),
	(405599, 124, '2015-02-15 00:44:37.000000', 'consum', 0.0217, 'lps'),
	(405600, 124, '2015-02-15 00:44:38.000000', 'consum', 0.0220, 'lps'),
	(405601, 124, '2015-02-15 00:44:39.000000', 'consum', 0.0217, 'lps'),
	(405602, 124, '2015-02-15 00:44:40.000000', 'consum', 0.0214, 'lps'),
	(405603, 124, '2015-02-15 00:44:41.000000', 'consum', 0.0210, 'lps'),
	(405604, 124, '2015-02-15 00:44:42.000000', 'consum', 0.0212, 'lps'),
	(405605, 124, '2015-02-15 00:44:43.000000', 'consum', 0.0218, 'lps'),
	(405606, 124, '2015-02-15 00:44:44.000000', 'consum', 0.0220, 'lps'),
	(405607, 124, '2015-02-15 00:44:45.000000', 'consum', 0.0214, 'lps'),
	(405608, 124, '2015-02-15 00:44:46.000000', 'consum', 0.0211, 'lps'),
	(405609, 124, '2015-02-15 00:44:47.000000', 'consum', 0.0217, 'lps'),
	(405610, 124, '2015-02-15 00:44:48.000000', 'consum', 0.0216, 'lps'),
	(405611, 124, '2015-02-15 00:44:49.000000', 'consum', 0.0210, 'lps'),
	(405612, 124, '2015-02-15 00:44:50.000000', 'consum', 0.0217, 'lps'),
	(405613, 124, '2015-02-15 00:44:51.000000', 'consum', 0.0211, 'lps'),
	(405614, 124, '2015-02-15 00:44:52.000000', 'consum', 0.0215, 'lps'),
	(405615, 124, '2015-02-15 00:44:53.000000', 'consum', 0.0210, 'lps'),
	(405616, 124, '2015-02-15 00:44:54.000000', 'consum', 0.0220, 'lps'),
	(405617, 124, '2015-02-15 00:44:55.000000', 'consum', 0.0210, 'lps'),
	(405618, 124, '2015-02-15 00:44:56.000000', 'consum', 0.0220, 'lps'),
	(405619, 124, '2015-02-15 00:44:57.000000', 'consum', 0.0210, 'lps'),
	(405620, 124, '2015-02-15 00:44:58.000000', 'consum', 0.0218, 'lps'),
	(405621, 124, '2015-02-15 00:44:59.000000', 'consum', 0.0212, 'lps'),
	(405622, 124, '2015-02-15 00:45:00.000000', 'consum', 0.0221, 'lps'),
	(405623, 124, '2015-02-15 00:45:01.000000', 'consum', 0.0214, 'lps'),
	(405624, 124, '2015-02-15 00:45:02.000000', 'consum', 0.0219, 'lps'),
	(405625, 124, '2015-02-15 00:45:03.000000', 'consum', 0.0219, 'lps'),
	(405626, 124, '2015-02-15 00:45:04.000000', 'consum', 0.0215, 'lps'),
	(405627, 124, '2015-02-15 00:45:05.000000', 'consum', 0.0212, 'lps'),
	(405628, 124, '2015-02-15 00:45:06.000000', 'consum', 0.0217, 'lps'),
	(405629, 124, '2015-02-15 00:45:07.000000', 'consum', 0.0216, 'lps'),
	(405630, 124, '2015-02-15 00:45:08.000000', 'consum', 0.0220, 'lps'),
	(405631, 124, '2015-02-15 00:45:09.000000', 'consum', 0.0217, 'lps'),
	(405632, 124, '2015-02-15 00:45:10.000000', 'consum', 0.0218, 'lps'),
	(405633, 124, '2015-02-15 00:45:11.000000', 'consum', 0.0215, 'lps'),
	(405634, 124, '2015-02-15 00:45:12.000000', 'consum', 0.0213, 'lps'),
	(405635, 124, '2015-02-15 00:45:13.000000', 'consum', 0.0220, 'lps'),
	(405636, 124, '2015-02-15 00:45:14.000000', 'consum', 0.0219, 'lps'),
	(405637, 124, '2015-02-15 00:45:15.000000', 'consum', 0.0211, 'lps'),
	(405638, 124, '2015-02-15 00:45:16.000000', 'consum', 0.0215, 'lps'),
	(405639, 124, '2015-02-15 00:45:17.000000', 'consum', 0.0221, 'lps'),
	(405640, 124, '2015-02-15 00:45:18.000000', 'consum', 0.0211, 'lps'),
	(405641, 124, '2015-02-15 00:45:19.000000', 'consum', 0.0210, 'lps'),
	(405642, 124, '2015-02-15 00:45:20.000000', 'consum', 0.0217, 'lps'),
	(405643, 124, '2015-02-15 00:45:21.000000', 'consum', 0.0211, 'lps'),
	(405644, 124, '2015-02-15 00:45:22.000000', 'consum', 0.0218, 'lps'),
	(405645, 124, '2015-02-15 00:45:23.000000', 'consum', 0.0213, 'lps'),
	(405646, 124, '2015-02-15 00:45:24.000000', 'consum', 0.0214, 'lps'),
	(405647, 124, '2015-02-15 00:45:25.000000', 'consum', 0.0219, 'lps'),
	(405648, 124, '2015-02-15 00:45:26.000000', 'consum', 0.0220, 'lps'),
	(405649, 124, '2015-02-15 00:45:27.000000', 'consum', 0.0221, 'lps'),
	(405650, 124, '2015-02-15 00:45:28.000000', 'consum', 0.0211, 'lps'),
	(405651, 124, '2015-02-15 00:45:29.000000', 'consum', 0.0217, 'lps'),
	(405652, 124, '2015-02-15 00:45:30.000000', 'consum', 0.0221, 'lps'),
	(405653, 124, '2015-02-15 00:45:31.000000', 'consum', 0.0219, 'lps'),
	(405654, 124, '2015-02-15 00:45:32.000000', 'consum', 0.0212, 'lps'),
	(405655, 124, '2015-02-15 00:45:33.000000', 'consum', 0.0217, 'lps'),
	(405656, 124, '2015-02-15 00:45:34.000000', 'consum', 0.0217, 'lps'),
	(405657, 124, '2015-02-15 00:45:35.000000', 'consum', 0.0210, 'lps'),
	(405658, 124, '2015-02-15 00:45:36.000000', 'consum', 0.0213, 'lps'),
	(405659, 124, '2015-02-15 00:45:37.000000', 'consum', 0.0215, 'lps'),
	(405660, 124, '2015-02-15 00:45:38.000000', 'consum', 0.0215, 'lps'),
	(405661, 124, '2015-02-15 00:45:39.000000', 'consum', 0.0220, 'lps'),
	(405662, 124, '2015-02-15 00:45:40.000000', 'consum', 0.0211, 'lps'),
	(405663, 124, '2015-02-15 00:45:41.000000', 'consum', 0.0210, 'lps'),
	(405664, 124, '2015-02-15 00:45:42.000000', 'consum', 0.0220, 'lps'),
	(405665, 124, '2015-02-15 00:45:43.000000', 'consum', 0.0210, 'lps'),
	(405666, 124, '2015-02-15 00:45:44.000000', 'consum', 0.0218, 'lps'),
	(405667, 124, '2015-02-15 00:45:45.000000', 'consum', 0.0213, 'lps'),
	(405668, 124, '2015-02-15 00:45:46.000000', 'consum', 0.0216, 'lps'),
	(405669, 124, '2015-02-15 00:45:47.000000', 'consum', 0.0220, 'lps'),
	(405670, 124, '2015-02-15 00:45:48.000000', 'consum', 0.0216, 'lps'),
	(405671, 124, '2015-02-15 00:45:49.000000', 'consum', 0.0211, 'lps'),
	(405672, 124, '2015-02-15 00:45:50.000000', 'consum', 0.0221, 'lps'),
	(405673, 124, '2015-02-15 00:45:51.000000', 'consum', 0.0217, 'lps'),
	(405674, 124, '2015-02-15 00:45:52.000000', 'consum', 0.0210, 'lps'),
	(405675, 124, '2015-02-15 00:45:53.000000', 'consum', 0.0214, 'lps'),
	(405676, 124, '2015-02-15 00:45:54.000000', 'consum', 0.0220, 'lps'),
	(405677, 124, '2015-02-15 00:45:55.000000', 'consum', 0.0211, 'lps'),
	(405678, 124, '2015-02-15 00:45:56.000000', 'consum', 0.0211, 'lps'),
	(405679, 124, '2015-02-15 00:45:57.000000', 'consum', 0.0214, 'lps'),
	(405680, 124, '2015-02-15 00:45:58.000000', 'consum', 0.0213, 'lps'),
	(405681, 124, '2015-02-15 00:45:59.000000', 'consum', 0.0213, 'lps'),
	(405682, 124, '2015-02-15 00:46:00.000000', 'consum', 0.0219, 'lps'),
	(405683, 124, '2015-02-15 00:46:01.000000', 'consum', 0.0211, 'lps'),
	(405684, 124, '2015-02-15 00:46:02.000000', 'consum', 0.0210, 'lps'),
	(405685, 124, '2015-02-15 00:46:03.000000', 'consum', 0.0221, 'lps'),
	(405686, 124, '2015-02-15 00:46:04.000000', 'consum', 0.0219, 'lps'),
	(405687, 124, '2015-02-15 00:46:05.000000', 'consum', 0.0221, 'lps'),
	(405688, 124, '2015-02-15 00:46:06.000000', 'consum', 0.0213, 'lps'),
	(405689, 124, '2015-02-15 00:46:07.000000', 'consum', 0.0216, 'lps'),
	(405690, 124, '2015-02-15 00:46:08.000000', 'consum', 0.0219, 'lps'),
	(405691, 124, '2015-02-15 00:46:09.000000', 'consum', 0.0215, 'lps'),
	(405692, 124, '2015-02-15 00:46:10.000000', 'consum', 0.0219, 'lps'),
	(405693, 124, '2015-02-15 00:46:11.000000', 'consum', 0.0219, 'lps'),
	(405694, 124, '2015-02-15 00:46:12.000000', 'consum', 0.0216, 'lps'),
	(405695, 124, '2015-02-15 00:46:13.000000', 'consum', 0.0212, 'lps'),
	(405696, 124, '2015-02-15 00:46:14.000000', 'consum', 0.0216, 'lps'),
	(405697, 124, '2015-02-15 00:46:15.000000', 'consum', 0.0211, 'lps'),
	(405698, 124, '2015-02-15 00:46:16.000000', 'consum', 0.0219, 'lps'),
	(405699, 124, '2015-02-15 00:46:17.000000', 'consum', 0.0217, 'lps'),
	(405700, 124, '2015-02-15 00:46:18.000000', 'consum', 0.0220, 'lps'),
	(405701, 124, '2015-02-15 00:46:19.000000', 'consum', 0.0216, 'lps'),
	(405702, 124, '2015-02-15 00:46:20.000000', 'consum', 0.0210, 'lps'),
	(405703, 124, '2015-02-15 00:46:21.000000', 'consum', 0.0216, 'lps'),
	(405704, 124, '2015-02-15 00:46:22.000000', 'consum', 0.0218, 'lps'),
	(405705, 124, '2015-02-15 00:46:23.000000', 'consum', 0.0219, 'lps'),
	(405706, 124, '2015-02-15 00:46:24.000000', 'consum', 0.0221, 'lps'),
	(405707, 124, '2015-02-15 00:46:25.000000', 'consum', 0.0213, 'lps'),
	(405708, 124, '2015-02-15 00:46:26.000000', 'consum', 0.0218, 'lps'),
	(405709, 124, '2015-02-15 00:46:27.000000', 'consum', 0.0218, 'lps'),
	(405710, 124, '2015-02-15 00:46:28.000000', 'consum', 0.0215, 'lps'),
	(405711, 124, '2015-02-15 00:46:29.000000', 'consum', 0.0211, 'lps'),
	(405712, 124, '2015-02-15 00:46:30.000000', 'consum', 0.0212, 'lps'),
	(405713, 124, '2015-02-15 00:46:31.000000', 'consum', 0.0218, 'lps'),
	(405714, 124, '2015-02-15 00:46:32.000000', 'consum', 0.0221, 'lps'),
	(405715, 124, '2015-02-15 00:46:33.000000', 'consum', 0.0216, 'lps'),
	(405716, 124, '2015-02-15 00:46:34.000000', 'consum', 0.0220, 'lps'),
	(405717, 124, '2015-02-15 00:46:35.000000', 'consum', 0.0220, 'lps'),
	(405718, 124, '2015-02-15 00:46:36.000000', 'consum', 0.0217, 'lps'),
	(405719, 124, '2015-02-15 00:46:37.000000', 'consum', 0.0217, 'lps'),
	(405720, 124, '2015-02-15 00:46:38.000000', 'consum', 0.0213, 'lps'),
	(405721, 124, '2015-02-15 00:46:39.000000', 'consum', 0.0214, 'lps'),
	(405722, 124, '2015-02-15 00:46:40.000000', 'consum', 0.0211, 'lps'),
	(405723, 124, '2015-02-15 00:46:41.000000', 'consum', 0.0214, 'lps'),
	(405724, 124, '2015-02-15 00:46:42.000000', 'consum', 0.0215, 'lps'),
	(405725, 124, '2015-02-15 00:46:43.000000', 'consum', 0.0210, 'lps'),
	(405726, 124, '2015-02-15 00:46:44.000000', 'consum', 0.0211, 'lps'),
	(405727, 124, '2015-02-15 00:46:45.000000', 'consum', 0.0214, 'lps'),
	(405728, 124, '2015-02-15 00:46:46.000000', 'consum', 0.0216, 'lps'),
	(405729, 124, '2015-02-15 00:46:47.000000', 'consum', 0.0217, 'lps'),
	(405730, 124, '2015-02-15 00:46:48.000000', 'consum', 0.0216, 'lps'),
	(405731, 124, '2015-02-15 00:46:49.000000', 'consum', 0.0219, 'lps'),
	(405732, 124, '2015-02-15 00:46:50.000000', 'consum', 0.0211, 'lps'),
	(405733, 124, '2015-02-15 00:46:51.000000', 'consum', 0.0215, 'lps'),
	(405734, 124, '2015-02-15 00:46:52.000000', 'consum', 0.0220, 'lps'),
	(405735, 124, '2015-02-15 00:46:53.000000', 'consum', 0.0210, 'lps'),
	(405736, 124, '2015-02-15 00:46:54.000000', 'consum', 0.0215, 'lps'),
	(405737, 124, '2015-02-15 00:46:55.000000', 'consum', 0.0213, 'lps'),
	(405738, 124, '2015-02-15 00:46:56.000000', 'consum', 0.0212, 'lps'),
	(405739, 124, '2015-02-15 00:46:57.000000', 'consum', 0.0211, 'lps'),
	(405740, 124, '2015-02-15 00:46:58.000000', 'consum', 0.0219, 'lps'),
	(405741, 124, '2015-02-15 00:46:59.000000', 'consum', 0.0220, 'lps'),
	(405742, 124, '2015-02-15 00:47:00.000000', 'consum', 0.0219, 'lps'),
	(405743, 124, '2015-02-15 00:47:01.000000', 'consum', 0.0213, 'lps'),
	(405744, 124, '2015-02-15 00:47:02.000000', 'consum', 0.0211, 'lps'),
	(405745, 124, '2015-02-15 00:47:03.000000', 'consum', 0.0217, 'lps'),
	(405746, 124, '2015-02-15 00:47:04.000000', 'consum', 0.0220, 'lps'),
	(405747, 124, '2015-02-15 00:47:05.000000', 'consum', 0.0217, 'lps'),
	(405748, 124, '2015-02-15 00:47:06.000000', 'consum', 0.0216, 'lps'),
	(405749, 124, '2015-02-15 00:47:07.000000', 'consum', 0.0217, 'lps'),
	(405750, 124, '2015-02-15 00:47:08.000000', 'consum', 0.0217, 'lps'),
	(405751, 124, '2015-02-15 00:47:09.000000', 'consum', 0.0212, 'lps'),
	(405752, 124, '2015-02-15 00:47:10.000000', 'consum', 0.0210, 'lps'),
	(405753, 124, '2015-02-15 00:47:11.000000', 'consum', 0.0216, 'lps'),
	(405754, 124, '2015-02-15 00:47:12.000000', 'consum', 0.0219, 'lps'),
	(405755, 124, '2015-02-15 00:47:13.000000', 'consum', 0.0213, 'lps'),
	(405756, 124, '2015-02-15 00:47:14.000000', 'consum', 0.0211, 'lps'),
	(405757, 124, '2015-02-15 00:47:15.000000', 'consum', 0.0219, 'lps'),
	(405758, 124, '2015-02-15 00:47:16.000000', 'consum', 0.0214, 'lps'),
	(405759, 124, '2015-02-15 00:47:17.000000', 'consum', 0.0216, 'lps'),
	(405760, 124, '2015-02-15 00:47:18.000000', 'consum', 0.0218, 'lps'),
	(405761, 124, '2015-02-15 00:47:19.000000', 'consum', 0.0218, 'lps'),
	(405762, 124, '2015-02-15 00:47:20.000000', 'consum', 0.0215, 'lps'),
	(405763, 124, '2015-02-15 00:47:21.000000', 'consum', 0.0214, 'lps'),
	(405764, 124, '2015-02-15 00:47:22.000000', 'consum', 0.0213, 'lps'),
	(405765, 124, '2015-02-15 00:47:23.000000', 'consum', 0.0213, 'lps'),
	(405766, 124, '2015-02-15 00:47:24.000000', 'consum', 0.0216, 'lps'),
	(405767, 124, '2015-02-15 00:47:25.000000', 'consum', 0.0220, 'lps'),
	(405768, 124, '2015-02-15 00:47:26.000000', 'consum', 0.0220, 'lps'),
	(405769, 124, '2015-02-15 00:47:27.000000', 'consum', 0.0217, 'lps'),
	(405770, 124, '2015-02-15 00:47:28.000000', 'consum', 0.0216, 'lps'),
	(405771, 124, '2015-02-15 00:47:29.000000', 'consum', 0.0219, 'lps'),
	(405772, 124, '2015-02-15 00:47:30.000000', 'consum', 0.0215, 'lps'),
	(405773, 124, '2015-02-15 00:47:31.000000', 'consum', 0.0220, 'lps'),
	(405774, 124, '2015-02-15 00:47:32.000000', 'consum', 0.0211, 'lps'),
	(405775, 124, '2015-02-15 00:47:33.000000', 'consum', 0.0220, 'lps'),
	(405776, 124, '2015-02-15 00:47:34.000000', 'consum', 0.0210, 'lps'),
	(405777, 124, '2015-02-15 00:47:35.000000', 'consum', 0.0217, 'lps'),
	(405778, 124, '2015-02-15 00:47:36.000000', 'consum', 0.0221, 'lps'),
	(405779, 124, '2015-02-15 00:47:37.000000', 'consum', 0.0210, 'lps'),
	(405780, 124, '2015-02-15 00:47:38.000000', 'consum', 0.0211, 'lps'),
	(405781, 124, '2015-02-15 00:47:39.000000', 'consum', 0.0218, 'lps'),
	(405782, 124, '2015-02-15 00:47:40.000000', 'consum', 0.0210, 'lps'),
	(405783, 124, '2015-02-15 00:47:41.000000', 'consum', 0.0211, 'lps'),
	(405784, 124, '2015-02-15 00:47:42.000000', 'consum', 0.0214, 'lps'),
	(405785, 124, '2015-02-15 00:47:43.000000', 'consum', 0.0218, 'lps'),
	(405786, 124, '2015-02-15 00:47:44.000000', 'consum', 0.0214, 'lps'),
	(405787, 124, '2015-02-15 00:47:45.000000', 'consum', 0.0219, 'lps'),
	(405788, 124, '2015-02-15 00:47:46.000000', 'consum', 0.0217, 'lps'),
	(405789, 124, '2015-02-15 00:47:47.000000', 'consum', 0.0219, 'lps'),
	(405790, 124, '2015-02-15 00:47:48.000000', 'consum', 0.0213, 'lps'),
	(405791, 124, '2015-02-15 00:47:49.000000', 'consum', 0.0220, 'lps'),
	(405792, 124, '2015-02-15 00:47:50.000000', 'consum', 0.0218, 'lps'),
	(405793, 124, '2015-02-15 00:47:51.000000', 'consum', 0.0220, 'lps'),
	(405794, 124, '2015-02-15 00:47:52.000000', 'consum', 0.0210, 'lps'),
	(405795, 124, '2015-02-15 00:47:53.000000', 'consum', 0.0219, 'lps'),
	(405796, 124, '2015-02-15 00:47:54.000000', 'consum', 0.0221, 'lps'),
	(405797, 124, '2015-02-15 00:47:55.000000', 'consum', 0.0211, 'lps'),
	(405798, 124, '2015-02-15 00:47:56.000000', 'consum', 0.0221, 'lps'),
	(405799, 124, '2015-02-15 00:47:57.000000', 'consum', 0.0214, 'lps'),
	(405800, 124, '2015-02-15 00:47:58.000000', 'consum', 0.0219, 'lps'),
	(405801, 124, '2015-02-15 00:47:59.000000', 'consum', 0.0211, 'lps'),
	(405802, 124, '2015-02-15 00:48:00.000000', 'consum', 0.0221, 'lps'),
	(405803, 124, '2015-02-15 00:48:01.000000', 'consum', 0.0218, 'lps'),
	(405804, 124, '2015-02-15 00:48:02.000000', 'consum', 0.0216, 'lps'),
	(405805, 124, '2015-02-15 00:48:03.000000', 'consum', 0.0216, 'lps'),
	(405806, 124, '2015-02-15 00:48:04.000000', 'consum', 0.0212, 'lps'),
	(405807, 124, '2015-02-15 00:48:05.000000', 'consum', 0.0213, 'lps'),
	(405808, 124, '2015-02-15 00:48:06.000000', 'consum', 0.0221, 'lps'),
	(405809, 124, '2015-02-15 00:48:07.000000', 'consum', 0.0219, 'lps'),
	(405810, 124, '2015-02-15 00:48:08.000000', 'consum', 0.0213, 'lps'),
	(405811, 124, '2015-02-15 00:48:09.000000', 'consum', 0.0220, 'lps'),
	(405812, 124, '2015-02-15 00:48:10.000000', 'consum', 0.0215, 'lps'),
	(405813, 124, '2015-02-15 00:48:11.000000', 'consum', 0.0219, 'lps'),
	(405814, 124, '2015-02-15 00:48:12.000000', 'consum', 0.0215, 'lps'),
	(405815, 124, '2015-02-15 00:48:13.000000', 'consum', 0.0211, 'lps'),
	(405816, 124, '2015-02-15 00:48:14.000000', 'consum', 0.0211, 'lps'),
	(405817, 124, '2015-02-15 00:48:15.000000', 'consum', 0.0212, 'lps'),
	(405818, 124, '2015-02-15 00:48:16.000000', 'consum', 0.0217, 'lps'),
	(405819, 124, '2015-02-15 00:48:17.000000', 'consum', 0.0216, 'lps'),
	(405820, 124, '2015-02-15 00:48:18.000000', 'consum', 0.0219, 'lps'),
	(405821, 124, '2015-02-15 00:48:19.000000', 'consum', 0.0214, 'lps'),
	(405822, 124, '2015-02-15 00:48:20.000000', 'consum', 0.0216, 'lps'),
	(405823, 124, '2015-02-15 00:48:21.000000', 'consum', 0.0217, 'lps'),
	(405824, 124, '2015-02-15 00:48:22.000000', 'consum', 0.0215, 'lps'),
	(405825, 124, '2015-02-15 00:48:23.000000', 'consum', 0.0216, 'lps'),
	(405826, 124, '2015-02-15 00:48:24.000000', 'consum', 0.0213, 'lps'),
	(405827, 124, '2015-02-15 00:48:25.000000', 'consum', 0.0221, 'lps'),
	(405828, 124, '2015-02-15 00:48:26.000000', 'consum', 0.0219, 'lps'),
	(405829, 124, '2015-02-15 00:48:27.000000', 'consum', 0.0213, 'lps'),
	(405830, 124, '2015-02-15 00:48:28.000000', 'consum', 0.0220, 'lps'),
	(405831, 124, '2015-02-15 00:48:29.000000', 'consum', 0.0215, 'lps'),
	(405832, 124, '2015-02-15 00:48:30.000000', 'consum', 0.0216, 'lps'),
	(405833, 124, '2015-02-15 00:48:31.000000', 'consum', 0.0217, 'lps'),
	(405834, 124, '2015-02-15 00:48:32.000000', 'consum', 0.0215, 'lps'),
	(405835, 124, '2015-02-15 00:48:33.000000', 'consum', 0.0213, 'lps'),
	(405836, 124, '2015-02-15 00:48:34.000000', 'consum', 0.0211, 'lps'),
	(405837, 124, '2015-02-15 00:48:35.000000', 'consum', 0.0219, 'lps'),
	(405838, 124, '2015-02-15 00:48:36.000000', 'consum', 0.0215, 'lps'),
	(405839, 124, '2015-02-15 00:48:37.000000', 'consum', 0.0220, 'lps'),
	(405840, 124, '2015-02-15 00:48:38.000000', 'consum', 0.0221, 'lps'),
	(405841, 124, '2015-02-15 00:48:39.000000', 'consum', 0.0213, 'lps'),
	(405842, 124, '2015-02-15 00:48:40.000000', 'consum', 0.0218, 'lps'),
	(405843, 124, '2015-02-15 00:48:41.000000', 'consum', 0.0214, 'lps'),
	(405844, 124, '2015-02-15 00:48:42.000000', 'consum', 0.0221, 'lps'),
	(405845, 124, '2015-02-15 00:48:43.000000', 'consum', 0.0217, 'lps'),
	(405846, 124, '2015-02-15 00:48:44.000000', 'consum', 0.0211, 'lps'),
	(405847, 124, '2015-02-15 00:48:45.000000', 'consum', 0.0219, 'lps'),
	(405848, 124, '2015-02-15 00:48:46.000000', 'consum', 0.0215, 'lps'),
	(405849, 124, '2015-02-15 00:48:47.000000', 'consum', 0.0221, 'lps'),
	(405850, 124, '2015-02-15 00:48:48.000000', 'consum', 0.0216, 'lps'),
	(405851, 124, '2015-02-15 00:48:49.000000', 'consum', 0.0221, 'lps'),
	(405852, 124, '2015-02-15 00:48:50.000000', 'consum', 0.0210, 'lps'),
	(405853, 124, '2015-02-15 00:48:51.000000', 'consum', 0.0212, 'lps'),
	(405854, 124, '2015-02-15 00:48:52.000000', 'consum', 0.0221, 'lps'),
	(405855, 124, '2015-02-15 00:48:53.000000', 'consum', 0.0210, 'lps'),
	(405856, 124, '2015-02-15 00:48:54.000000', 'consum', 0.0214, 'lps'),
	(405857, 124, '2015-02-15 00:48:55.000000', 'consum', 0.0220, 'lps'),
	(405858, 124, '2015-02-15 00:48:56.000000', 'consum', 0.0212, 'lps'),
	(405859, 124, '2015-02-15 00:48:57.000000', 'consum', 0.0213, 'lps'),
	(405860, 124, '2015-02-15 00:48:58.000000', 'consum', 0.0220, 'lps'),
	(405861, 124, '2015-02-15 00:48:59.000000', 'consum', 0.0214, 'lps'),
	(405862, 124, '2015-02-15 00:49:00.000000', 'consum', 0.0214, 'lps'),
	(405863, 124, '2015-02-15 00:49:01.000000', 'consum', 0.0218, 'lps'),
	(405864, 124, '2015-02-15 00:49:02.000000', 'consum', 0.0215, 'lps'),
	(405865, 124, '2015-02-15 00:49:03.000000', 'consum', 0.0221, 'lps'),
	(405866, 124, '2015-02-15 00:49:04.000000', 'consum', 0.0217, 'lps'),
	(405867, 124, '2015-02-15 00:49:05.000000', 'consum', 0.0213, 'lps'),
	(405868, 124, '2015-02-15 00:49:06.000000', 'consum', 0.0214, 'lps'),
	(405869, 124, '2015-02-15 00:49:07.000000', 'consum', 0.0211, 'lps'),
	(405870, 124, '2015-02-15 00:49:08.000000', 'consum', 0.0216, 'lps'),
	(405871, 124, '2015-02-15 00:49:09.000000', 'consum', 0.0214, 'lps'),
	(405872, 124, '2015-02-15 00:49:10.000000', 'consum', 0.0212, 'lps'),
	(405873, 124, '2015-02-15 00:49:11.000000', 'consum', 0.0220, 'lps'),
	(405874, 124, '2015-02-15 00:49:12.000000', 'consum', 0.0218, 'lps'),
	(405875, 124, '2015-02-15 00:49:13.000000', 'consum', 0.0220, 'lps'),
	(405876, 124, '2015-02-15 00:49:14.000000', 'consum', 0.0213, 'lps'),
	(405877, 124, '2015-02-15 00:49:15.000000', 'consum', 0.0219, 'lps'),
	(405878, 124, '2015-02-15 00:49:16.000000', 'consum', 0.0210, 'lps'),
	(405879, 124, '2015-02-15 00:49:17.000000', 'consum', 0.0218, 'lps'),
	(405880, 124, '2015-02-15 00:49:18.000000', 'consum', 0.0217, 'lps'),
	(405881, 124, '2015-02-15 00:49:19.000000', 'consum', 0.0221, 'lps'),
	(405882, 124, '2015-02-15 00:49:20.000000', 'consum', 0.0220, 'lps'),
	(405883, 124, '2015-02-15 00:49:21.000000', 'consum', 0.0214, 'lps'),
	(405884, 124, '2015-02-15 00:49:22.000000', 'consum', 0.0214, 'lps'),
	(405885, 124, '2015-02-15 00:49:23.000000', 'consum', 0.0217, 'lps'),
	(405886, 124, '2015-02-15 00:49:24.000000', 'consum', 0.0211, 'lps'),
	(405887, 124, '2015-02-15 00:49:25.000000', 'consum', 0.0219, 'lps'),
	(405888, 124, '2015-02-15 00:49:26.000000', 'consum', 0.0214, 'lps'),
	(405889, 124, '2015-02-15 00:49:27.000000', 'consum', 0.0216, 'lps'),
	(405890, 124, '2015-02-15 00:49:28.000000', 'consum', 0.0216, 'lps'),
	(405891, 124, '2015-02-15 00:49:29.000000', 'consum', 0.0212, 'lps'),
	(405892, 124, '2015-02-15 00:49:30.000000', 'consum', 0.0212, 'lps'),
	(405893, 124, '2015-02-15 00:49:31.000000', 'consum', 0.0216, 'lps'),
	(405894, 124, '2015-02-15 00:49:32.000000', 'consum', 0.0212, 'lps'),
	(405895, 124, '2015-02-15 00:49:33.000000', 'consum', 0.0215, 'lps'),
	(405896, 124, '2015-02-15 00:49:34.000000', 'consum', 0.0218, 'lps'),
	(405897, 124, '2015-02-15 00:49:35.000000', 'consum', 0.0221, 'lps'),
	(405898, 124, '2015-02-15 00:49:36.000000', 'consum', 0.0217, 'lps'),
	(405899, 124, '2015-02-15 00:49:37.000000', 'consum', 0.0213, 'lps'),
	(405900, 124, '2015-02-15 00:49:38.000000', 'consum', 0.0219, 'lps'),
	(405901, 124, '2015-02-15 00:49:39.000000', 'consum', 0.0219, 'lps'),
	(405902, 124, '2015-02-15 00:49:40.000000', 'consum', 0.0217, 'lps'),
	(405903, 124, '2015-02-15 00:49:41.000000', 'consum', 0.0221, 'lps'),
	(405904, 124, '2015-02-15 00:49:42.000000', 'consum', 0.0218, 'lps'),
	(405905, 124, '2015-02-15 00:49:43.000000', 'consum', 0.0216, 'lps'),
	(405906, 124, '2015-02-15 00:49:44.000000', 'consum', 0.0219, 'lps'),
	(405907, 124, '2015-02-15 00:49:45.000000', 'consum', 0.0213, 'lps'),
	(405908, 124, '2015-02-15 00:49:46.000000', 'consum', 0.0221, 'lps'),
	(405909, 124, '2015-02-15 00:49:47.000000', 'consum', 0.0221, 'lps'),
	(405910, 124, '2015-02-15 00:49:48.000000', 'consum', 0.0210, 'lps'),
	(405911, 124, '2015-02-15 00:49:49.000000', 'consum', 0.0211, 'lps'),
	(405912, 124, '2015-02-15 00:49:50.000000', 'consum', 0.0218, 'lps'),
	(405913, 124, '2015-02-15 00:49:51.000000', 'consum', 0.0211, 'lps'),
	(405914, 124, '2015-02-15 00:49:52.000000', 'consum', 0.0215, 'lps'),
	(405915, 124, '2015-02-15 00:49:53.000000', 'consum', 0.0220, 'lps'),
	(405916, 124, '2015-02-15 00:49:54.000000', 'consum', 0.0211, 'lps'),
	(405917, 124, '2015-02-15 00:49:55.000000', 'consum', 0.0210, 'lps'),
	(405918, 124, '2015-02-15 00:49:56.000000', 'consum', 0.0219, 'lps'),
	(405919, 124, '2015-02-15 00:49:57.000000', 'consum', 0.0221, 'lps'),
	(405920, 124, '2015-02-15 00:49:58.000000', 'consum', 0.0215, 'lps'),
	(405921, 124, '2015-02-15 00:49:59.000000', 'consum', 0.0211, 'lps'),
	(405922, 124, '2015-02-15 00:50:00.000000', 'consum', 0.0215, 'lps'),
	(405923, 124, '2015-02-15 00:50:01.000000', 'consum', 0.0221, 'lps'),
	(405924, 124, '2015-02-15 00:50:02.000000', 'consum', 0.0214, 'lps'),
	(405925, 124, '2015-02-15 00:50:03.000000', 'consum', 0.0211, 'lps'),
	(405926, 124, '2015-02-15 00:50:04.000000', 'consum', 0.0215, 'lps'),
	(405927, 124, '2015-02-15 00:50:05.000000', 'consum', 0.0219, 'lps'),
	(405928, 124, '2015-02-15 00:50:06.000000', 'consum', 0.0217, 'lps'),
	(405929, 124, '2015-02-15 00:50:07.000000', 'consum', 0.0217, 'lps'),
	(405930, 124, '2015-02-15 00:50:08.000000', 'consum', 0.0215, 'lps'),
	(405931, 124, '2015-02-15 00:50:09.000000', 'consum', 0.0214, 'lps'),
	(405932, 124, '2015-02-15 00:50:10.000000', 'consum', 0.0214, 'lps'),
	(405933, 124, '2015-02-15 00:50:11.000000', 'consum', 0.0221, 'lps'),
	(405934, 124, '2015-02-15 00:50:12.000000', 'consum', 0.0218, 'lps'),
	(405935, 124, '2015-02-15 00:50:13.000000', 'consum', 0.0217, 'lps'),
	(405936, 124, '2015-02-15 00:50:14.000000', 'consum', 0.0220, 'lps'),
	(405937, 124, '2015-02-15 00:50:15.000000', 'consum', 0.0215, 'lps'),
	(405938, 124, '2015-02-15 00:50:16.000000', 'consum', 0.0220, 'lps'),
	(405939, 124, '2015-02-15 00:50:17.000000', 'consum', 0.0220, 'lps'),
	(405940, 124, '2015-02-15 00:50:18.000000', 'consum', 0.0218, 'lps'),
	(405941, 124, '2015-02-15 00:50:19.000000', 'consum', 0.0220, 'lps'),
	(405942, 124, '2015-02-15 00:50:20.000000', 'consum', 0.0211, 'lps'),
	(405943, 124, '2015-02-15 00:50:21.000000', 'consum', 0.0212, 'lps'),
	(405944, 124, '2015-02-15 00:50:22.000000', 'consum', 0.0215, 'lps'),
	(405945, 124, '2015-02-15 00:50:23.000000', 'consum', 0.0218, 'lps'),
	(405946, 124, '2015-02-15 00:50:24.000000', 'consum', 0.0212, 'lps'),
	(405947, 124, '2015-02-15 00:50:25.000000', 'consum', 0.0218, 'lps'),
	(405948, 124, '2015-02-15 00:50:26.000000', 'consum', 0.0212, 'lps'),
	(405949, 124, '2015-02-15 00:50:27.000000', 'consum', 0.0220, 'lps'),
	(405950, 124, '2015-02-15 00:50:28.000000', 'consum', 0.0218, 'lps'),
	(405951, 124, '2015-02-15 00:50:29.000000', 'consum', 0.0210, 'lps'),
	(405952, 124, '2015-02-15 00:50:30.000000', 'consum', 0.0219, 'lps'),
	(405953, 124, '2015-02-15 00:50:31.000000', 'consum', 0.0211, 'lps'),
	(405954, 124, '2015-02-15 00:50:32.000000', 'consum', 0.0212, 'lps'),
	(405955, 124, '2015-02-15 00:50:33.000000', 'consum', 0.0218, 'lps'),
	(405956, 124, '2015-02-15 00:50:34.000000', 'consum', 0.0219, 'lps'),
	(405957, 124, '2015-02-15 00:50:35.000000', 'consum', 0.0210, 'lps'),
	(405958, 124, '2015-02-15 00:50:36.000000', 'consum', 0.0217, 'lps'),
	(405959, 124, '2015-02-15 00:50:37.000000', 'consum', 0.0221, 'lps'),
	(405960, 124, '2015-02-15 00:50:38.000000', 'consum', 0.0210, 'lps'),
	(405961, 124, '2015-02-15 00:50:39.000000', 'consum', 0.0211, 'lps'),
	(405962, 124, '2015-02-15 00:50:40.000000', 'consum', 0.0219, 'lps'),
	(405963, 124, '2015-02-15 00:50:41.000000', 'consum', 0.0215, 'lps'),
	(405964, 124, '2015-02-15 00:50:42.000000', 'consum', 0.0220, 'lps'),
	(405965, 124, '2015-02-15 00:50:43.000000', 'consum', 0.0221, 'lps'),
	(405966, 124, '2015-02-15 00:50:44.000000', 'consum', 0.0210, 'lps'),
	(405967, 124, '2015-02-15 00:50:45.000000', 'consum', 0.0216, 'lps'),
	(405968, 124, '2015-02-15 00:50:46.000000', 'consum', 0.0214, 'lps'),
	(405969, 124, '2015-02-15 00:50:47.000000', 'consum', 0.0214, 'lps'),
	(405970, 124, '2015-02-15 00:50:48.000000', 'consum', 0.0218, 'lps'),
	(405971, 124, '2015-02-15 00:50:49.000000', 'consum', 0.0213, 'lps'),
	(405972, 124, '2015-02-15 00:50:50.000000', 'consum', 0.0216, 'lps'),
	(405973, 124, '2015-02-15 00:50:51.000000', 'consum', 0.0218, 'lps'),
	(405974, 124, '2015-02-15 00:50:52.000000', 'consum', 0.0219, 'lps'),
	(405975, 124, '2015-02-15 00:50:53.000000', 'consum', 0.0210, 'lps'),
	(405976, 124, '2015-02-15 00:50:54.000000', 'consum', 0.0220, 'lps'),
	(405977, 124, '2015-02-15 00:50:55.000000', 'consum', 0.0210, 'lps'),
	(405978, 124, '2015-02-15 00:50:56.000000', 'consum', 0.0217, 'lps'),
	(405979, 124, '2015-02-15 00:50:57.000000', 'consum', 0.0211, 'lps'),
	(405980, 124, '2015-02-15 00:50:58.000000', 'consum', 0.0216, 'lps'),
	(405981, 124, '2015-02-15 00:50:59.000000', 'consum', 0.0213, 'lps'),
	(405982, 124, '2015-02-15 00:51:00.000000', 'consum', 0.0221, 'lps'),
	(405983, 124, '2015-02-15 00:51:01.000000', 'consum', 0.0221, 'lps'),
	(405984, 124, '2015-02-15 00:51:02.000000', 'consum', 0.0210, 'lps'),
	(405985, 124, '2015-02-15 00:51:03.000000', 'consum', 0.0211, 'lps'),
	(405986, 124, '2015-02-15 00:51:04.000000', 'consum', 0.0215, 'lps'),
	(405987, 124, '2015-02-15 00:51:05.000000', 'consum', 0.0221, 'lps'),
	(405988, 124, '2015-02-15 00:51:06.000000', 'consum', 0.0216, 'lps'),
	(405989, 124, '2015-02-15 00:51:07.000000', 'consum', 0.0218, 'lps'),
	(405990, 124, '2015-02-15 00:51:08.000000', 'consum', 0.0211, 'lps'),
	(405991, 124, '2015-02-15 00:51:09.000000', 'consum', 0.0214, 'lps'),
	(405992, 124, '2015-02-15 00:51:10.000000', 'consum', 0.0214, 'lps'),
	(405993, 124, '2015-02-15 00:51:11.000000', 'consum', 0.0219, 'lps'),
	(405994, 124, '2015-02-15 00:51:12.000000', 'consum', 0.0221, 'lps'),
	(405995, 124, '2015-02-15 00:51:13.000000', 'consum', 0.0215, 'lps'),
	(405996, 124, '2015-02-15 00:51:14.000000', 'consum', 0.0213, 'lps'),
	(405997, 124, '2015-02-15 00:51:15.000000', 'consum', 0.0211, 'lps'),
	(405998, 124, '2015-02-15 00:51:16.000000', 'consum', 0.0218, 'lps'),
	(405999, 124, '2015-02-15 00:51:17.000000', 'consum', 0.0210, 'lps'),
	(406000, 124, '2015-02-15 00:51:18.000000', 'consum', 0.0212, 'lps'),
	(406001, 124, '2015-02-15 00:51:19.000000', 'consum', 0.0218, 'lps'),
	(406002, 124, '2015-02-15 00:51:20.000000', 'consum', 0.0212, 'lps'),
	(406003, 124, '2015-02-15 00:51:21.000000', 'consum', 0.0218, 'lps'),
	(406004, 124, '2015-02-15 00:51:22.000000', 'consum', 0.0221, 'lps'),
	(406005, 124, '2015-02-15 00:51:23.000000', 'consum', 0.0217, 'lps'),
	(406006, 124, '2015-02-15 00:51:24.000000', 'consum', 0.0215, 'lps'),
	(406007, 124, '2015-02-15 00:51:25.000000', 'consum', 0.0211, 'lps'),
	(406008, 124, '2015-02-15 00:51:26.000000', 'consum', 0.0216, 'lps'),
	(406009, 124, '2015-02-15 00:51:27.000000', 'consum', 0.0212, 'lps'),
	(406010, 124, '2015-02-15 00:51:28.000000', 'consum', 0.0213, 'lps'),
	(406011, 124, '2015-02-15 00:51:29.000000', 'consum', 0.0219, 'lps'),
	(406012, 124, '2015-02-15 00:51:30.000000', 'consum', 0.0213, 'lps'),
	(406013, 124, '2015-02-15 00:51:31.000000', 'consum', 0.0210, 'lps'),
	(406014, 124, '2015-02-15 00:51:32.000000', 'consum', 0.0215, 'lps'),
	(406015, 124, '2015-02-15 00:51:33.000000', 'consum', 0.0221, 'lps'),
	(406016, 124, '2015-02-15 00:51:34.000000', 'consum', 0.0216, 'lps'),
	(406017, 124, '2015-02-15 00:51:35.000000', 'consum', 0.0219, 'lps'),
	(406018, 124, '2015-02-15 00:51:36.000000', 'consum', 0.0212, 'lps'),
	(406019, 124, '2015-02-15 00:51:37.000000', 'consum', 0.0218, 'lps'),
	(406020, 124, '2015-02-15 00:51:38.000000', 'consum', 0.0220, 'lps'),
	(406021, 124, '2015-02-15 00:51:39.000000', 'consum', 0.0213, 'lps'),
	(406022, 124, '2015-02-15 00:51:40.000000', 'consum', 0.0221, 'lps'),
	(406023, 124, '2015-02-15 00:51:41.000000', 'consum', 0.0221, 'lps'),
	(406024, 124, '2015-02-15 00:51:42.000000', 'consum', 0.0220, 'lps'),
	(406025, 124, '2015-02-15 00:51:43.000000', 'consum', 0.0215, 'lps'),
	(406026, 124, '2015-02-15 00:51:44.000000', 'consum', 0.0217, 'lps'),
	(406027, 124, '2015-02-15 00:51:45.000000', 'consum', 0.0220, 'lps'),
	(406028, 124, '2015-02-15 00:51:46.000000', 'consum', 0.0217, 'lps'),
	(406029, 124, '2015-02-15 00:51:47.000000', 'consum', 0.0213, 'lps'),
	(406030, 124, '2015-02-15 00:51:48.000000', 'consum', 0.0218, 'lps'),
	(406031, 124, '2015-02-15 00:51:49.000000', 'consum', 0.0215, 'lps'),
	(406032, 124, '2015-02-15 00:51:50.000000', 'consum', 0.0212, 'lps'),
	(406033, 124, '2015-02-15 00:51:51.000000', 'consum', 0.0218, 'lps'),
	(406034, 124, '2015-02-15 00:51:52.000000', 'consum', 0.0220, 'lps'),
	(406035, 124, '2015-02-15 00:51:53.000000', 'consum', 0.0213, 'lps'),
	(406036, 124, '2015-02-15 00:51:54.000000', 'consum', 0.0219, 'lps'),
	(406037, 124, '2015-02-15 00:51:55.000000', 'consum', 0.0221, 'lps'),
	(406038, 124, '2015-02-15 00:51:56.000000', 'consum', 0.0216, 'lps'),
	(406039, 124, '2015-02-15 00:51:57.000000', 'consum', 0.0218, 'lps'),
	(406040, 124, '2015-02-15 00:51:58.000000', 'consum', 0.0220, 'lps'),
	(406041, 124, '2015-02-15 00:51:59.000000', 'consum', 0.0213, 'lps'),
	(406042, 124, '2015-02-15 00:52:00.000000', 'consum', 0.0210, 'lps'),
	(406043, 124, '2015-02-15 00:52:01.000000', 'consum', 0.0210, 'lps'),
	(406044, 124, '2015-02-15 00:52:02.000000', 'consum', 0.0212, 'lps'),
	(406045, 124, '2015-02-15 00:52:03.000000', 'consum', 0.0210, 'lps'),
	(406046, 124, '2015-02-15 00:52:04.000000', 'consum', 0.0216, 'lps'),
	(406047, 124, '2015-02-15 00:52:05.000000', 'consum', 0.0215, 'lps'),
	(406048, 124, '2015-02-15 00:52:06.000000', 'consum', 0.0220, 'lps'),
	(406049, 124, '2015-02-15 00:52:07.000000', 'consum', 0.0221, 'lps'),
	(406050, 124, '2015-02-15 00:52:08.000000', 'consum', 0.0221, 'lps'),
	(406051, 124, '2015-02-15 00:52:09.000000', 'consum', 0.0210, 'lps'),
	(406052, 124, '2015-02-15 00:52:10.000000', 'consum', 0.0211, 'lps'),
	(406053, 124, '2015-02-15 00:52:11.000000', 'consum', 0.0219, 'lps'),
	(406054, 124, '2015-02-15 00:52:12.000000', 'consum', 0.0213, 'lps'),
	(406055, 124, '2015-02-15 00:52:13.000000', 'consum', 0.0213, 'lps'),
	(406056, 124, '2015-02-15 00:52:14.000000', 'consum', 0.0215, 'lps'),
	(406057, 124, '2015-02-15 00:52:15.000000', 'consum', 0.0213, 'lps'),
	(406058, 124, '2015-02-15 00:52:16.000000', 'consum', 0.0213, 'lps'),
	(406059, 124, '2015-02-15 00:52:17.000000', 'consum', 0.0215, 'lps'),
	(406060, 124, '2015-02-15 00:52:18.000000', 'consum', 0.0215, 'lps'),
	(406061, 124, '2015-02-15 00:52:19.000000', 'consum', 0.0219, 'lps'),
	(406062, 124, '2015-02-15 00:52:20.000000', 'consum', 0.0220, 'lps'),
	(406063, 124, '2015-02-15 00:52:21.000000', 'consum', 0.0218, 'lps'),
	(406064, 124, '2015-02-15 00:52:22.000000', 'consum', 0.0221, 'lps'),
	(406065, 124, '2015-02-15 00:52:23.000000', 'consum', 0.0219, 'lps'),
	(406066, 124, '2015-02-15 00:52:24.000000', 'consum', 0.0212, 'lps'),
	(406067, 124, '2015-02-15 00:52:25.000000', 'consum', 0.0214, 'lps'),
	(406068, 124, '2015-02-15 00:52:26.000000', 'consum', 0.0216, 'lps'),
	(406069, 124, '2015-02-15 00:52:27.000000', 'consum', 0.0213, 'lps'),
	(406070, 124, '2015-02-15 00:52:28.000000', 'consum', 0.0221, 'lps'),
	(406071, 124, '2015-02-15 00:52:29.000000', 'consum', 0.0221, 'lps'),
	(406072, 124, '2015-02-15 00:52:30.000000', 'consum', 0.0220, 'lps'),
	(406073, 124, '2015-02-15 00:52:31.000000', 'consum', 0.0218, 'lps'),
	(406074, 124, '2015-02-15 00:52:32.000000', 'consum', 0.0217, 'lps'),
	(406075, 124, '2015-02-15 00:52:33.000000', 'consum', 0.0221, 'lps'),
	(406076, 124, '2015-02-15 00:52:34.000000', 'consum', 0.0212, 'lps'),
	(406077, 124, '2015-02-15 00:52:35.000000', 'consum', 0.0221, 'lps'),
	(406078, 124, '2015-02-15 00:52:36.000000', 'consum', 0.0211, 'lps'),
	(406079, 124, '2015-02-15 00:52:37.000000', 'consum', 0.0218, 'lps'),
	(406080, 124, '2015-02-15 00:52:38.000000', 'consum', 0.0213, 'lps'),
	(406081, 124, '2015-02-15 00:52:39.000000', 'consum', 0.0215, 'lps'),
	(406082, 124, '2015-02-15 00:52:40.000000', 'consum', 0.0214, 'lps'),
	(406083, 124, '2015-02-15 00:52:41.000000', 'consum', 0.0214, 'lps'),
	(406084, 124, '2015-02-15 00:52:42.000000', 'consum', 0.0217, 'lps'),
	(406085, 124, '2015-02-15 00:52:43.000000', 'consum', 0.0213, 'lps'),
	(406086, 124, '2015-02-15 00:52:44.000000', 'consum', 0.0216, 'lps'),
	(406087, 124, '2015-02-15 00:52:45.000000', 'consum', 0.0217, 'lps'),
	(406088, 124, '2015-02-15 00:52:46.000000', 'consum', 0.0219, 'lps'),
	(406089, 124, '2015-02-15 00:52:47.000000', 'consum', 0.0220, 'lps'),
	(406090, 124, '2015-02-15 00:52:48.000000', 'consum', 0.0220, 'lps'),
	(406091, 124, '2015-02-15 00:52:49.000000', 'consum', 0.0221, 'lps'),
	(406092, 124, '2015-02-15 00:52:50.000000', 'consum', 0.0212, 'lps'),
	(406093, 124, '2015-02-15 00:52:51.000000', 'consum', 0.0212, 'lps'),
	(406094, 124, '2015-02-15 00:52:52.000000', 'consum', 0.0213, 'lps'),
	(406095, 124, '2015-02-15 00:52:53.000000', 'consum', 0.0219, 'lps'),
	(406096, 124, '2015-02-15 00:52:54.000000', 'consum', 0.0213, 'lps'),
	(406097, 124, '2015-02-15 00:52:55.000000', 'consum', 0.0220, 'lps'),
	(406098, 124, '2015-02-15 00:52:56.000000', 'consum', 0.0216, 'lps'),
	(406099, 124, '2015-02-15 00:52:57.000000', 'consum', 0.0212, 'lps'),
	(406100, 124, '2015-02-15 00:52:58.000000', 'consum', 0.0211, 'lps'),
	(406101, 124, '2015-02-15 00:52:59.000000', 'consum', 0.0213, 'lps'),
	(406102, 124, '2015-02-15 00:53:00.000000', 'consum', 0.0211, 'lps'),
	(406103, 124, '2015-02-15 00:53:01.000000', 'consum', 0.0218, 'lps'),
	(406104, 124, '2015-02-15 00:53:02.000000', 'consum', 0.0221, 'lps'),
	(406105, 124, '2015-02-15 00:53:03.000000', 'consum', 0.0219, 'lps'),
	(406106, 124, '2015-02-15 00:53:04.000000', 'consum', 0.0210, 'lps'),
	(406107, 124, '2015-02-15 00:53:05.000000', 'consum', 0.0210, 'lps'),
	(406108, 124, '2015-02-15 00:53:06.000000', 'consum', 0.0220, 'lps'),
	(406109, 124, '2015-02-15 00:53:07.000000', 'consum', 0.0211, 'lps'),
	(406110, 124, '2015-02-15 00:53:08.000000', 'consum', 0.0212, 'lps'),
	(406111, 124, '2015-02-15 00:53:09.000000', 'consum', 0.0219, 'lps'),
	(406112, 124, '2015-02-15 00:53:10.000000', 'consum', 0.0212, 'lps'),
	(406113, 124, '2015-02-15 00:53:11.000000', 'consum', 0.0216, 'lps'),
	(406114, 124, '2015-02-15 00:53:12.000000', 'consum', 0.0213, 'lps'),
	(406115, 124, '2015-02-15 00:53:13.000000', 'consum', 0.0219, 'lps'),
	(406116, 124, '2015-02-15 00:53:14.000000', 'consum', 0.0221, 'lps'),
	(406117, 124, '2015-02-15 00:53:15.000000', 'consum', 0.0217, 'lps'),
	(406118, 124, '2015-02-15 00:53:16.000000', 'consum', 0.0212, 'lps'),
	(406119, 124, '2015-02-15 00:53:17.000000', 'consum', 0.0210, 'lps'),
	(406120, 124, '2015-02-15 00:53:18.000000', 'consum', 0.0217, 'lps'),
	(406121, 124, '2015-02-15 00:53:19.000000', 'consum', 0.0211, 'lps'),
	(406122, 124, '2015-02-15 00:53:20.000000', 'consum', 0.0219, 'lps'),
	(406123, 124, '2015-02-15 00:53:21.000000', 'consum', 0.0215, 'lps'),
	(406124, 124, '2015-02-15 00:53:22.000000', 'consum', 0.0219, 'lps'),
	(406125, 124, '2015-02-15 00:53:23.000000', 'consum', 0.0217, 'lps'),
	(406126, 124, '2015-02-15 00:53:24.000000', 'consum', 0.0218, 'lps'),
	(406127, 124, '2015-02-15 00:53:25.000000', 'consum', 0.0217, 'lps'),
	(406128, 124, '2015-02-15 00:53:26.000000', 'consum', 0.0210, 'lps'),
	(406129, 124, '2015-02-15 00:53:27.000000', 'consum', 0.0216, 'lps'),
	(406130, 124, '2015-02-15 00:53:28.000000', 'consum', 0.0213, 'lps'),
	(406131, 124, '2015-02-15 00:53:29.000000', 'consum', 0.0210, 'lps'),
	(406132, 124, '2015-02-15 00:53:30.000000', 'consum', 0.0213, 'lps'),
	(406133, 124, '2015-02-15 00:53:31.000000', 'consum', 0.0212, 'lps'),
	(406134, 124, '2015-02-15 00:53:32.000000', 'consum', 0.0212, 'lps'),
	(406135, 124, '2015-02-15 00:53:33.000000', 'consum', 0.0216, 'lps'),
	(406136, 124, '2015-02-15 00:53:34.000000', 'consum', 0.0221, 'lps'),
	(406137, 124, '2015-02-15 00:53:35.000000', 'consum', 0.0210, 'lps'),
	(406138, 124, '2015-02-15 00:53:36.000000', 'consum', 0.0216, 'lps'),
	(406139, 124, '2015-02-15 00:53:37.000000', 'consum', 0.0218, 'lps'),
	(406140, 124, '2015-02-15 00:53:38.000000', 'consum', 0.0218, 'lps'),
	(406141, 124, '2015-02-15 00:53:39.000000', 'consum', 0.0215, 'lps'),
	(406142, 124, '2015-02-15 00:53:40.000000', 'consum', 0.0210, 'lps'),
	(406143, 124, '2015-02-15 00:53:41.000000', 'consum', 0.0221, 'lps'),
	(406144, 124, '2015-02-15 00:53:42.000000', 'consum', 0.0216, 'lps'),
	(406145, 124, '2015-02-15 00:53:43.000000', 'consum', 0.0221, 'lps'),
	(406146, 124, '2015-02-15 00:53:44.000000', 'consum', 0.0211, 'lps'),
	(406147, 124, '2015-02-15 00:53:45.000000', 'consum', 0.0220, 'lps'),
	(406148, 124, '2015-02-15 00:53:46.000000', 'consum', 0.0221, 'lps'),
	(406149, 124, '2015-02-15 00:53:47.000000', 'consum', 0.0212, 'lps'),
	(406150, 124, '2015-02-15 00:53:48.000000', 'consum', 0.0210, 'lps'),
	(406151, 124, '2015-02-15 00:53:49.000000', 'consum', 0.0216, 'lps'),
	(406152, 124, '2015-02-15 00:53:50.000000', 'consum', 0.0219, 'lps'),
	(406153, 124, '2015-02-15 00:53:51.000000', 'consum', 0.0212, 'lps'),
	(406154, 124, '2015-02-15 00:53:52.000000', 'consum', 0.0217, 'lps'),
	(406155, 124, '2015-02-15 00:53:53.000000', 'consum', 0.0216, 'lps'),
	(406156, 124, '2015-02-15 00:53:54.000000', 'consum', 0.0221, 'lps'),
	(406157, 124, '2015-02-15 00:53:55.000000', 'consum', 0.0213, 'lps'),
	(406158, 124, '2015-02-15 00:53:56.000000', 'consum', 0.0213, 'lps'),
	(406159, 124, '2015-02-15 00:53:57.000000', 'consum', 0.0217, 'lps'),
	(406160, 124, '2015-02-15 00:53:58.000000', 'consum', 0.0214, 'lps'),
	(406161, 124, '2015-02-15 00:53:59.000000', 'consum', 0.0210, 'lps'),
	(406162, 124, '2015-02-15 00:54:00.000000', 'consum', 0.0212, 'lps'),
	(406163, 124, '2015-02-15 00:54:01.000000', 'consum', 0.0218, 'lps'),
	(406164, 124, '2015-02-15 00:54:02.000000', 'consum', 0.0221, 'lps'),
	(406165, 124, '2015-02-15 00:54:03.000000', 'consum', 0.0216, 'lps'),
	(406166, 124, '2015-02-15 00:54:04.000000', 'consum', 0.0210, 'lps'),
	(406167, 124, '2015-02-15 00:54:05.000000', 'consum', 0.0216, 'lps'),
	(406168, 124, '2015-02-15 00:54:06.000000', 'consum', 0.0217, 'lps'),
	(406169, 124, '2015-02-15 00:54:07.000000', 'consum', 0.0214, 'lps'),
	(406170, 124, '2015-02-15 00:54:08.000000', 'consum', 0.0210, 'lps'),
	(406171, 124, '2015-02-15 00:54:09.000000', 'consum', 0.0212, 'lps'),
	(406172, 124, '2015-02-15 00:54:10.000000', 'consum', 0.0218, 'lps'),
	(406173, 124, '2015-02-15 00:54:11.000000', 'consum', 0.0220, 'lps'),
	(406174, 124, '2015-02-15 00:54:12.000000', 'consum', 0.0214, 'lps'),
	(406175, 124, '2015-02-15 00:54:13.000000', 'consum', 0.0212, 'lps'),
	(406176, 124, '2015-02-15 00:54:14.000000', 'consum', 0.0211, 'lps'),
	(406177, 124, '2015-02-15 00:54:15.000000', 'consum', 0.0218, 'lps'),
	(406178, 124, '2015-02-15 00:54:16.000000', 'consum', 0.0213, 'lps'),
	(406179, 124, '2015-02-15 00:54:17.000000', 'consum', 0.0215, 'lps'),
	(406180, 124, '2015-02-15 00:54:18.000000', 'consum', 0.0212, 'lps'),
	(406181, 124, '2015-02-15 00:54:19.000000', 'consum', 0.0218, 'lps'),
	(406182, 124, '2015-02-15 00:54:20.000000', 'consum', 0.0219, 'lps'),
	(406183, 124, '2015-02-15 00:54:21.000000', 'consum', 0.0211, 'lps'),
	(406184, 124, '2015-02-15 00:54:22.000000', 'consum', 0.0221, 'lps'),
	(406185, 124, '2015-02-15 00:54:23.000000', 'consum', 0.0216, 'lps'),
	(406186, 124, '2015-02-15 00:54:24.000000', 'consum', 0.0218, 'lps'),
	(406187, 124, '2015-02-15 00:54:25.000000', 'consum', 0.0210, 'lps'),
	(406188, 124, '2015-02-15 00:54:26.000000', 'consum', 0.0221, 'lps'),
	(406189, 124, '2015-02-15 00:54:27.000000', 'consum', 0.0217, 'lps'),
	(406190, 124, '2015-02-15 00:54:28.000000', 'consum', 0.0215, 'lps'),
	(406191, 124, '2015-02-15 00:54:29.000000', 'consum', 0.0214, 'lps'),
	(406192, 124, '2015-02-15 00:54:30.000000', 'consum', 0.0214, 'lps'),
	(406193, 124, '2015-02-15 00:54:31.000000', 'consum', 0.0219, 'lps'),
	(406194, 124, '2015-02-15 00:54:32.000000', 'consum', 0.0220, 'lps'),
	(406195, 124, '2015-02-15 00:54:33.000000', 'consum', 0.0220, 'lps'),
	(406196, 124, '2015-02-15 00:54:34.000000', 'consum', 0.0221, 'lps'),
	(406197, 124, '2015-02-15 00:54:35.000000', 'consum', 0.0210, 'lps'),
	(406198, 124, '2015-02-15 00:54:36.000000', 'consum', 0.0212, 'lps'),
	(406199, 124, '2015-02-15 00:54:37.000000', 'consum', 0.0210, 'lps'),
	(406200, 124, '2015-02-15 00:54:38.000000', 'consum', 0.0218, 'lps'),
	(406201, 124, '2015-02-15 00:54:39.000000', 'consum', 0.0215, 'lps'),
	(406202, 124, '2015-02-15 00:54:40.000000', 'consum', 0.0210, 'lps'),
	(406203, 124, '2015-02-15 00:54:41.000000', 'consum', 0.0218, 'lps'),
	(406204, 124, '2015-02-15 00:54:42.000000', 'consum', 0.0215, 'lps'),
	(406205, 124, '2015-02-15 00:54:43.000000', 'consum', 0.0213, 'lps'),
	(406206, 124, '2015-02-15 00:54:44.000000', 'consum', 0.0210, 'lps'),
	(406207, 124, '2015-02-15 00:54:45.000000', 'consum', 0.0214, 'lps'),
	(406208, 124, '2015-02-15 00:54:46.000000', 'consum', 0.0217, 'lps'),
	(406209, 124, '2015-02-15 00:54:47.000000', 'consum', 0.0220, 'lps'),
	(406210, 124, '2015-02-15 00:54:48.000000', 'consum', 0.0218, 'lps'),
	(406211, 124, '2015-02-15 00:54:49.000000', 'consum', 0.0219, 'lps'),
	(406212, 124, '2015-02-15 00:54:50.000000', 'consum', 0.0210, 'lps'),
	(406213, 124, '2015-02-15 00:54:51.000000', 'consum', 0.0217, 'lps'),
	(406214, 124, '2015-02-15 00:54:52.000000', 'consum', 0.0210, 'lps'),
	(406215, 124, '2015-02-15 00:54:53.000000', 'consum', 0.0212, 'lps'),
	(406216, 124, '2015-02-15 00:54:54.000000', 'consum', 0.0211, 'lps'),
	(406217, 124, '2015-02-15 00:54:55.000000', 'consum', 0.0220, 'lps'),
	(406218, 124, '2015-02-15 00:54:56.000000', 'consum', 0.0212, 'lps'),
	(406219, 124, '2015-02-15 00:54:57.000000', 'consum', 0.0212, 'lps'),
	(406220, 124, '2015-02-15 00:54:58.000000', 'consum', 0.0215, 'lps'),
	(406221, 124, '2015-02-15 00:54:59.000000', 'consum', 0.0217, 'lps'),
	(406222, 124, '2015-02-15 00:55:00.000000', 'consum', 0.0220, 'lps'),
	(406223, 124, '2015-02-15 00:55:01.000000', 'consum', 0.0215, 'lps'),
	(406224, 124, '2015-02-15 00:55:02.000000', 'consum', 0.0216, 'lps'),
	(406225, 124, '2015-02-15 00:55:03.000000', 'consum', 0.0213, 'lps'),
	(406226, 124, '2015-02-15 00:55:04.000000', 'consum', 0.0210, 'lps'),
	(406227, 124, '2015-02-15 00:55:05.000000', 'consum', 0.0213, 'lps'),
	(406228, 124, '2015-02-15 00:55:06.000000', 'consum', 0.0213, 'lps'),
	(406229, 124, '2015-02-15 00:55:07.000000', 'consum', 0.0216, 'lps'),
	(406230, 124, '2015-02-15 00:55:08.000000', 'consum', 0.0210, 'lps'),
	(406231, 124, '2015-02-15 00:55:09.000000', 'consum', 0.0213, 'lps'),
	(406232, 124, '2015-02-15 00:55:10.000000', 'consum', 0.0215, 'lps'),
	(406233, 124, '2015-02-15 00:55:11.000000', 'consum', 0.0213, 'lps'),
	(406234, 124, '2015-02-15 00:55:12.000000', 'consum', 0.0210, 'lps'),
	(406235, 124, '2015-02-15 00:55:13.000000', 'consum', 0.0216, 'lps'),
	(406236, 124, '2015-02-15 00:55:14.000000', 'consum', 0.0215, 'lps'),
	(406237, 124, '2015-02-15 00:55:15.000000', 'consum', 0.0216, 'lps'),
	(406238, 124, '2015-02-15 00:55:16.000000', 'consum', 0.0216, 'lps'),
	(406239, 124, '2015-02-15 00:55:17.000000', 'consum', 0.0210, 'lps'),
	(406240, 124, '2015-02-15 00:55:18.000000', 'consum', 0.0215, 'lps'),
	(406241, 124, '2015-02-15 00:55:19.000000', 'consum', 0.0211, 'lps'),
	(406242, 124, '2015-02-15 00:55:20.000000', 'consum', 0.0212, 'lps'),
	(406243, 124, '2015-02-15 00:55:21.000000', 'consum', 0.0220, 'lps'),
	(406244, 124, '2015-02-15 00:55:22.000000', 'consum', 0.0219, 'lps'),
	(406245, 124, '2015-02-15 00:55:23.000000', 'consum', 0.0214, 'lps'),
	(406246, 124, '2015-02-15 00:55:24.000000', 'consum', 0.0214, 'lps'),
	(406247, 124, '2015-02-15 00:55:25.000000', 'consum', 0.0217, 'lps'),
	(406248, 124, '2015-02-15 00:55:26.000000', 'consum', 0.0211, 'lps'),
	(406249, 124, '2015-02-15 00:55:27.000000', 'consum', 0.0219, 'lps'),
	(406250, 124, '2015-02-15 00:55:28.000000', 'consum', 0.0218, 'lps'),
	(406251, 124, '2015-02-15 00:55:29.000000', 'consum', 0.0210, 'lps'),
	(406252, 124, '2015-02-15 00:55:30.000000', 'consum', 0.0210, 'lps'),
	(406253, 124, '2015-02-15 00:55:31.000000', 'consum', 0.0212, 'lps'),
	(406254, 124, '2015-02-15 00:55:32.000000', 'consum', 0.0219, 'lps'),
	(406255, 124, '2015-02-15 00:55:33.000000', 'consum', 0.0216, 'lps'),
	(406256, 124, '2015-02-15 00:55:34.000000', 'consum', 0.0212, 'lps'),
	(406257, 124, '2015-02-15 00:55:35.000000', 'consum', 0.0215, 'lps'),
	(406258, 124, '2015-02-15 00:55:36.000000', 'consum', 0.0215, 'lps'),
	(406259, 124, '2015-02-15 00:55:37.000000', 'consum', 0.0211, 'lps'),
	(406260, 124, '2015-02-15 00:55:38.000000', 'consum', 0.0210, 'lps'),
	(406261, 124, '2015-02-15 00:55:39.000000', 'consum', 0.0220, 'lps'),
	(406262, 124, '2015-02-15 00:55:40.000000', 'consum', 0.0211, 'lps'),
	(406263, 124, '2015-02-15 00:55:41.000000', 'consum', 0.0212, 'lps'),
	(406264, 124, '2015-02-15 00:55:42.000000', 'consum', 0.0216, 'lps'),
	(406265, 124, '2015-02-15 00:55:43.000000', 'consum', 0.0213, 'lps'),
	(406266, 124, '2015-02-15 00:55:44.000000', 'consum', 0.0218, 'lps'),
	(406267, 124, '2015-02-15 00:55:45.000000', 'consum', 0.0216, 'lps'),
	(406268, 124, '2015-02-15 00:55:46.000000', 'consum', 0.0219, 'lps'),
	(406269, 124, '2015-02-15 00:55:47.000000', 'consum', 0.0213, 'lps'),
	(406270, 124, '2015-02-15 00:55:48.000000', 'consum', 0.0210, 'lps'),
	(406271, 124, '2015-02-15 00:55:49.000000', 'consum', 0.0214, 'lps'),
	(406272, 124, '2015-02-15 00:55:50.000000', 'consum', 0.0220, 'lps'),
	(406273, 124, '2015-02-15 00:55:51.000000', 'consum', 0.0211, 'lps'),
	(406274, 124, '2015-02-15 00:55:52.000000', 'consum', 0.0221, 'lps'),
	(406275, 124, '2015-02-15 00:55:53.000000', 'consum', 0.0215, 'lps'),
	(406276, 124, '2015-02-15 00:55:54.000000', 'consum', 0.0215, 'lps'),
	(406277, 124, '2015-02-15 00:55:55.000000', 'consum', 0.0219, 'lps'),
	(406278, 124, '2015-02-15 00:55:56.000000', 'consum', 0.0217, 'lps'),
	(406279, 124, '2015-02-15 00:55:57.000000', 'consum', 0.0219, 'lps'),
	(406280, 124, '2015-02-15 00:55:58.000000', 'consum', 0.0210, 'lps'),
	(406281, 124, '2015-02-15 00:55:59.000000', 'consum', 0.0220, 'lps'),
	(406282, 124, '2015-02-15 00:56:00.000000', 'consum', 0.0210, 'lps'),
	(406283, 124, '2015-02-15 00:56:01.000000', 'consum', 0.0220, 'lps'),
	(406284, 124, '2015-02-15 00:56:02.000000', 'consum', 0.0210, 'lps'),
	(406285, 124, '2015-02-15 00:56:03.000000', 'consum', 0.0218, 'lps'),
	(406286, 124, '2015-02-15 00:56:04.000000', 'consum', 0.0216, 'lps'),
	(406287, 124, '2015-02-15 00:56:05.000000', 'consum', 0.0214, 'lps'),
	(406288, 124, '2015-02-15 00:56:06.000000', 'consum', 0.0213, 'lps'),
	(406289, 124, '2015-02-15 00:56:07.000000', 'consum', 0.0212, 'lps'),
	(406290, 124, '2015-02-15 00:56:08.000000', 'consum', 0.0213, 'lps'),
	(406291, 124, '2015-02-15 00:56:09.000000', 'consum', 0.0221, 'lps'),
	(406292, 124, '2015-02-15 00:56:10.000000', 'consum', 0.0220, 'lps'),
	(406293, 124, '2015-02-15 00:56:11.000000', 'consum', 0.0217, 'lps'),
	(406294, 124, '2015-02-15 00:56:12.000000', 'consum', 0.0213, 'lps'),
	(406295, 124, '2015-02-15 00:56:13.000000', 'consum', 0.0215, 'lps'),
	(406296, 124, '2015-02-15 00:56:14.000000', 'consum', 0.0218, 'lps'),
	(406297, 124, '2015-02-15 00:56:15.000000', 'consum', 0.0220, 'lps'),
	(406298, 124, '2015-02-15 00:56:16.000000', 'consum', 0.0214, 'lps'),
	(406299, 124, '2015-02-15 00:56:17.000000', 'consum', 0.0214, 'lps'),
	(406300, 124, '2015-02-15 00:56:18.000000', 'consum', 0.0216, 'lps'),
	(406301, 124, '2015-02-15 00:56:19.000000', 'consum', 0.0217, 'lps'),
	(406302, 124, '2015-02-15 00:56:20.000000', 'consum', 0.0215, 'lps'),
	(406303, 124, '2015-02-15 00:56:21.000000', 'consum', 0.0216, 'lps'),
	(406304, 124, '2015-02-15 00:56:22.000000', 'consum', 0.0215, 'lps'),
	(406305, 124, '2015-02-15 00:56:23.000000', 'consum', 0.0214, 'lps'),
	(406306, 124, '2015-02-15 00:56:24.000000', 'consum', 0.0217, 'lps'),
	(406307, 124, '2015-02-15 00:56:25.000000', 'consum', 0.0211, 'lps'),
	(406308, 124, '2015-02-15 00:56:26.000000', 'consum', 0.0219, 'lps'),
	(406309, 124, '2015-02-15 00:56:27.000000', 'consum', 0.0217, 'lps'),
	(406310, 124, '2015-02-15 00:56:28.000000', 'consum', 0.0218, 'lps'),
	(406311, 124, '2015-02-15 00:56:29.000000', 'consum', 0.0217, 'lps'),
	(406312, 124, '2015-02-15 00:56:30.000000', 'consum', 0.0211, 'lps'),
	(406313, 124, '2015-02-15 00:56:31.000000', 'consum', 0.0216, 'lps'),
	(406314, 124, '2015-02-15 00:56:32.000000', 'consum', 0.0216, 'lps'),
	(406315, 124, '2015-02-15 00:56:33.000000', 'consum', 0.0220, 'lps'),
	(406316, 124, '2015-02-15 00:56:34.000000', 'consum', 0.0218, 'lps'),
	(406317, 124, '2015-02-15 00:56:35.000000', 'consum', 0.0221, 'lps'),
	(406318, 124, '2015-02-15 00:56:36.000000', 'consum', 0.0218, 'lps'),
	(406319, 124, '2015-02-15 00:56:37.000000', 'consum', 0.0218, 'lps'),
	(406320, 124, '2015-02-15 00:56:38.000000', 'consum', 0.0213, 'lps'),
	(406321, 124, '2015-02-15 00:56:39.000000', 'consum', 0.0214, 'lps'),
	(406322, 124, '2015-02-15 00:56:40.000000', 'consum', 0.0210, 'lps'),
	(406323, 124, '2015-02-15 00:56:41.000000', 'consum', 0.0212, 'lps'),
	(406324, 124, '2015-02-15 00:56:42.000000', 'consum', 0.0221, 'lps'),
	(406325, 124, '2015-02-15 00:56:43.000000', 'consum', 0.0211, 'lps'),
	(406326, 124, '2015-02-15 00:56:44.000000', 'consum', 0.0218, 'lps'),
	(406327, 124, '2015-02-15 00:56:45.000000', 'consum', 0.0211, 'lps'),
	(406328, 124, '2015-02-15 00:56:46.000000', 'consum', 0.0217, 'lps'),
	(406329, 124, '2015-02-15 00:56:47.000000', 'consum', 0.0220, 'lps'),
	(406330, 124, '2015-02-15 00:56:48.000000', 'consum', 0.0212, 'lps'),
	(406331, 124, '2015-02-15 00:56:49.000000', 'consum', 0.0217, 'lps'),
	(406332, 124, '2015-02-15 00:56:50.000000', 'consum', 0.0213, 'lps'),
	(406333, 124, '2015-02-15 00:56:51.000000', 'consum', 0.0216, 'lps'),
	(406334, 124, '2015-02-15 00:56:52.000000', 'consum', 0.0210, 'lps'),
	(406335, 124, '2015-02-15 00:56:53.000000', 'consum', 0.0214, 'lps'),
	(406336, 124, '2015-02-15 00:56:54.000000', 'consum', 0.0219, 'lps'),
	(406337, 124, '2015-02-15 00:56:55.000000', 'consum', 0.0221, 'lps'),
	(406338, 124, '2015-02-15 00:56:56.000000', 'consum', 0.0213, 'lps'),
	(406339, 124, '2015-02-15 00:56:57.000000', 'consum', 0.0216, 'lps'),
	(406340, 124, '2015-02-15 00:56:58.000000', 'consum', 0.0220, 'lps'),
	(406341, 124, '2015-02-15 00:56:59.000000', 'consum', 0.0220, 'lps'),
	(406342, 124, '2015-02-15 00:57:00.000000', 'consum', 0.0219, 'lps'),
	(406343, 124, '2015-02-15 00:57:01.000000', 'consum', 0.0213, 'lps'),
	(406344, 124, '2015-02-15 00:57:02.000000', 'consum', 0.0221, 'lps'),
	(406345, 124, '2015-02-15 00:57:03.000000', 'consum', 0.0221, 'lps'),
	(406346, 124, '2015-02-15 00:57:04.000000', 'consum', 0.0210, 'lps'),
	(406347, 124, '2015-02-15 00:57:05.000000', 'consum', 0.0211, 'lps'),
	(406348, 124, '2015-02-15 00:57:06.000000', 'consum', 0.0218, 'lps'),
	(406349, 124, '2015-02-15 00:57:07.000000', 'consum', 0.0211, 'lps'),
	(406350, 124, '2015-02-15 00:57:08.000000', 'consum', 0.0215, 'lps'),
	(406351, 124, '2015-02-15 00:57:09.000000', 'consum', 0.0220, 'lps'),
	(406352, 124, '2015-02-15 00:57:10.000000', 'consum', 0.0210, 'lps'),
	(406353, 124, '2015-02-15 00:57:11.000000', 'consum', 0.0216, 'lps'),
	(406354, 124, '2015-02-15 00:57:12.000000', 'consum', 0.0218, 'lps'),
	(406355, 124, '2015-02-15 00:57:13.000000', 'consum', 0.0220, 'lps'),
	(406356, 124, '2015-02-15 00:57:14.000000', 'consum', 0.0213, 'lps'),
	(406357, 124, '2015-02-15 00:57:15.000000', 'consum', 0.0219, 'lps'),
	(406358, 124, '2015-02-15 00:57:16.000000', 'consum', 0.0210, 'lps'),
	(406359, 124, '2015-02-15 00:57:17.000000', 'consum', 0.0220, 'lps'),
	(406360, 124, '2015-02-15 00:57:18.000000', 'consum', 0.0211, 'lps'),
	(406361, 124, '2015-02-15 00:57:19.000000', 'consum', 0.0212, 'lps'),
	(406362, 124, '2015-02-15 00:57:20.000000', 'consum', 0.0217, 'lps'),
	(406363, 124, '2015-02-15 00:57:21.000000', 'consum', 0.0214, 'lps'),
	(406364, 124, '2015-02-15 00:57:22.000000', 'consum', 0.0211, 'lps'),
	(406365, 124, '2015-02-15 00:57:23.000000', 'consum', 0.0215, 'lps'),
	(406366, 124, '2015-02-15 00:57:24.000000', 'consum', 0.0220, 'lps'),
	(406367, 124, '2015-02-15 00:57:25.000000', 'consum', 0.0211, 'lps'),
	(406368, 124, '2015-02-15 00:57:26.000000', 'consum', 0.0210, 'lps'),
	(406369, 124, '2015-02-15 00:57:27.000000', 'consum', 0.0217, 'lps'),
	(406370, 124, '2015-02-15 00:57:28.000000', 'consum', 0.0210, 'lps'),
	(406371, 124, '2015-02-15 00:57:29.000000', 'consum', 0.0215, 'lps'),
	(406372, 124, '2015-02-15 00:57:30.000000', 'consum', 0.0213, 'lps'),
	(406373, 124, '2015-02-15 00:57:31.000000', 'consum', 0.0219, 'lps'),
	(406374, 124, '2015-02-15 00:57:32.000000', 'consum', 0.0212, 'lps'),
	(406375, 124, '2015-02-15 00:57:33.000000', 'consum', 0.0219, 'lps'),
	(406376, 124, '2015-02-15 00:57:34.000000', 'consum', 0.0214, 'lps'),
	(406377, 124, '2015-02-15 00:57:35.000000', 'consum', 0.0214, 'lps'),
	(406378, 124, '2015-02-15 00:57:36.000000', 'consum', 0.0217, 'lps'),
	(406379, 124, '2015-02-15 00:57:37.000000', 'consum', 0.0212, 'lps'),
	(406380, 124, '2015-02-15 00:57:38.000000', 'consum', 0.0211, 'lps'),
	(406381, 124, '2015-02-15 00:57:39.000000', 'consum', 0.0219, 'lps'),
	(406382, 124, '2015-02-15 00:57:40.000000', 'consum', 0.0219, 'lps'),
	(406383, 124, '2015-02-15 00:57:41.000000', 'consum', 0.0217, 'lps'),
	(406384, 124, '2015-02-15 00:57:42.000000', 'consum', 0.0216, 'lps'),
	(406385, 124, '2015-02-15 00:57:43.000000', 'consum', 0.0220, 'lps'),
	(406386, 124, '2015-02-15 00:57:44.000000', 'consum', 0.0219, 'lps'),
	(406387, 124, '2015-02-15 00:57:45.000000', 'consum', 0.0215, 'lps'),
	(406388, 124, '2015-02-15 00:57:46.000000', 'consum', 0.0218, 'lps'),
	(406389, 124, '2015-02-15 00:57:47.000000', 'consum', 0.0213, 'lps'),
	(406390, 124, '2015-02-15 00:57:48.000000', 'consum', 0.0214, 'lps'),
	(406391, 124, '2015-02-15 00:57:49.000000', 'consum', 0.0210, 'lps'),
	(406392, 124, '2015-02-15 00:57:50.000000', 'consum', 0.0221, 'lps'),
	(406393, 124, '2015-02-15 00:57:51.000000', 'consum', 0.0219, 'lps'),
	(406394, 124, '2015-02-15 00:57:52.000000', 'consum', 0.0212, 'lps'),
	(406395, 124, '2015-02-15 00:57:53.000000', 'consum', 0.0214, 'lps'),
	(406396, 124, '2015-02-15 00:57:54.000000', 'consum', 0.0214, 'lps'),
	(406397, 124, '2015-02-15 00:57:55.000000', 'consum', 0.0219, 'lps'),
	(406398, 124, '2015-02-15 00:57:56.000000', 'consum', 0.0221, 'lps'),
	(406399, 124, '2015-02-15 00:57:57.000000', 'consum', 0.0214, 'lps'),
	(406400, 124, '2015-02-15 00:57:58.000000', 'consum', 0.0210, 'lps'),
	(406401, 124, '2015-02-15 00:57:59.000000', 'consum', 0.0220, 'lps'),
	(406402, 124, '2015-02-15 00:58:00.000000', 'consum', 0.0216, 'lps'),
	(406403, 124, '2015-02-15 00:58:01.000000', 'consum', 0.0219, 'lps'),
	(406404, 124, '2015-02-15 00:58:02.000000', 'consum', 0.0216, 'lps'),
	(406405, 124, '2015-02-15 00:58:03.000000', 'consum', 0.0214, 'lps'),
	(406406, 124, '2015-02-15 00:58:04.000000', 'consum', 0.0212, 'lps'),
	(406407, 124, '2015-02-15 00:58:05.000000', 'consum', 0.0219, 'lps'),
	(406408, 124, '2015-02-15 00:58:06.000000', 'consum', 0.0215, 'lps'),
	(406409, 124, '2015-02-15 00:58:07.000000', 'consum', 0.0219, 'lps'),
	(406410, 124, '2015-02-15 00:58:08.000000', 'consum', 0.0217, 'lps'),
	(406411, 124, '2015-02-15 00:58:09.000000', 'consum', 0.0220, 'lps'),
	(406412, 124, '2015-02-15 00:58:10.000000', 'consum', 0.0214, 'lps'),
	(406413, 124, '2015-02-15 00:58:11.000000', 'consum', 0.0211, 'lps'),
	(406414, 124, '2015-02-15 00:58:12.000000', 'consum', 0.0216, 'lps'),
	(406415, 124, '2015-02-15 00:58:13.000000', 'consum', 0.0216, 'lps'),
	(406416, 124, '2015-02-15 00:58:14.000000', 'consum', 0.0220, 'lps'),
	(406417, 124, '2015-02-15 00:58:15.000000', 'consum', 0.0221, 'lps'),
	(406418, 124, '2015-02-15 00:58:16.000000', 'consum', 0.0210, 'lps'),
	(406419, 124, '2015-02-15 00:58:17.000000', 'consum', 0.0215, 'lps'),
	(406420, 124, '2015-02-15 00:58:18.000000', 'consum', 0.0212, 'lps'),
	(406421, 124, '2015-02-15 00:58:19.000000', 'consum', 0.0216, 'lps'),
	(406422, 124, '2015-02-15 00:58:20.000000', 'consum', 0.0210, 'lps'),
	(406423, 124, '2015-02-15 00:58:21.000000', 'consum', 0.0218, 'lps'),
	(406424, 124, '2015-02-15 00:58:22.000000', 'consum', 0.0215, 'lps'),
	(406425, 124, '2015-02-15 00:58:23.000000', 'consum', 0.0213, 'lps'),
	(406426, 124, '2015-02-15 00:58:24.000000', 'consum', 0.0220, 'lps'),
	(406427, 124, '2015-02-15 00:58:25.000000', 'consum', 0.0214, 'lps'),
	(406428, 124, '2015-02-15 00:58:26.000000', 'consum', 0.0215, 'lps'),
	(406429, 124, '2015-02-15 00:58:27.000000', 'consum', 0.0211, 'lps'),
	(406430, 124, '2015-02-15 00:58:28.000000', 'consum', 0.0213, 'lps'),
	(406431, 124, '2015-02-15 00:58:29.000000', 'consum', 0.0210, 'lps'),
	(406432, 124, '2015-02-15 00:58:30.000000', 'consum', 0.0214, 'lps'),
	(406433, 124, '2015-02-15 00:58:31.000000', 'consum', 0.0217, 'lps'),
	(406434, 124, '2015-02-15 00:58:32.000000', 'consum', 0.0221, 'lps'),
	(406435, 124, '2015-02-15 00:58:33.000000', 'consum', 0.0220, 'lps'),
	(406436, 124, '2015-02-15 00:58:34.000000', 'consum', 0.0215, 'lps'),
	(406437, 124, '2015-02-15 00:58:35.000000', 'consum', 0.0218, 'lps'),
	(406438, 124, '2015-02-15 00:58:36.000000', 'consum', 0.0213, 'lps'),
	(406439, 124, '2015-02-15 00:58:37.000000', 'consum', 0.0212, 'lps'),
	(406440, 124, '2015-02-15 00:58:38.000000', 'consum', 0.0213, 'lps'),
	(406441, 124, '2015-02-15 00:58:39.000000', 'consum', 0.0218, 'lps'),
	(406442, 124, '2015-02-15 00:58:40.000000', 'consum', 0.0217, 'lps'),
	(406443, 124, '2015-02-15 00:58:41.000000', 'consum', 0.0221, 'lps'),
	(406444, 124, '2015-02-15 00:58:42.000000', 'consum', 0.0220, 'lps'),
	(406445, 124, '2015-02-15 00:58:43.000000', 'consum', 0.0215, 'lps'),
	(406446, 124, '2015-02-15 00:58:44.000000', 'consum', 0.0217, 'lps'),
	(406447, 124, '2015-02-15 00:58:45.000000', 'consum', 0.0219, 'lps'),
	(406448, 124, '2015-02-15 00:58:46.000000', 'consum', 0.0212, 'lps'),
	(406449, 124, '2015-02-15 00:58:47.000000', 'consum', 0.0218, 'lps'),
	(406450, 124, '2015-02-15 00:58:48.000000', 'consum', 0.0218, 'lps'),
	(406451, 124, '2015-02-15 00:58:49.000000', 'consum', 0.0216, 'lps'),
	(406452, 124, '2015-02-15 00:58:50.000000', 'consum', 0.0218, 'lps'),
	(406453, 124, '2015-02-15 00:58:51.000000', 'consum', 0.0219, 'lps'),
	(406454, 124, '2015-02-15 00:58:52.000000', 'consum', 0.0221, 'lps'),
	(406455, 124, '2015-02-15 00:58:53.000000', 'consum', 0.0214, 'lps'),
	(406456, 124, '2015-02-15 00:58:54.000000', 'consum', 0.0221, 'lps'),
	(406457, 124, '2015-02-15 00:58:55.000000', 'consum', 0.0218, 'lps'),
	(406458, 124, '2015-02-15 00:58:56.000000', 'consum', 0.0218, 'lps'),
	(406459, 124, '2015-02-15 00:58:57.000000', 'consum', 0.0214, 'lps'),
	(406460, 124, '2015-02-15 00:58:58.000000', 'consum', 0.0220, 'lps'),
	(406461, 124, '2015-02-15 00:58:59.000000', 'consum', 0.0212, 'lps'),
	(406462, 124, '2015-02-15 00:59:00.000000', 'consum', 0.0216, 'lps'),
	(406463, 124, '2015-02-15 00:59:01.000000', 'consum', 0.0220, 'lps'),
	(406464, 124, '2015-02-15 00:59:02.000000', 'consum', 0.0218, 'lps'),
	(406465, 124, '2015-02-15 00:59:03.000000', 'consum', 0.0221, 'lps'),
	(406466, 124, '2015-02-15 00:59:04.000000', 'consum', 0.0217, 'lps'),
	(406467, 124, '2015-02-15 00:59:05.000000', 'consum', 0.0212, 'lps'),
	(406468, 124, '2015-02-15 00:59:06.000000', 'consum', 0.0211, 'lps'),
	(406469, 124, '2015-02-15 00:59:07.000000', 'consum', 0.0210, 'lps'),
	(406470, 124, '2015-02-15 00:59:08.000000', 'consum', 0.0220, 'lps'),
	(406471, 124, '2015-02-15 00:59:09.000000', 'consum', 0.0213, 'lps'),
	(406472, 124, '2015-02-15 00:59:10.000000', 'consum', 0.0221, 'lps'),
	(406473, 124, '2015-02-15 00:59:11.000000', 'consum', 0.0218, 'lps'),
	(406474, 124, '2015-02-15 00:59:12.000000', 'consum', 0.0218, 'lps'),
	(406475, 124, '2015-02-15 00:59:13.000000', 'consum', 0.0216, 'lps'),
	(406476, 124, '2015-02-15 00:59:14.000000', 'consum', 0.0215, 'lps'),
	(406477, 124, '2015-02-15 00:59:15.000000', 'consum', 0.0218, 'lps'),
	(406478, 124, '2015-02-15 00:59:16.000000', 'consum', 0.0210, 'lps'),
	(406479, 124, '2015-02-15 00:59:17.000000', 'consum', 0.0211, 'lps'),
	(406480, 124, '2015-02-15 00:59:18.000000', 'consum', 0.0217, 'lps'),
	(406481, 124, '2015-02-15 00:59:19.000000', 'consum', 0.0219, 'lps'),
	(406482, 124, '2015-02-15 00:59:20.000000', 'consum', 0.0221, 'lps'),
	(406483, 124, '2015-02-15 00:59:21.000000', 'consum', 0.0213, 'lps'),
	(406484, 124, '2015-02-15 00:59:22.000000', 'consum', 0.0217, 'lps'),
	(406485, 124, '2015-02-15 00:59:23.000000', 'consum', 0.0215, 'lps'),
	(406486, 124, '2015-02-15 00:59:24.000000', 'consum', 0.0214, 'lps'),
	(406487, 124, '2015-02-15 00:59:25.000000', 'consum', 0.0215, 'lps'),
	(406488, 124, '2015-02-15 00:59:26.000000', 'consum', 0.0212, 'lps'),
	(406489, 124, '2015-02-15 00:59:27.000000', 'consum', 0.0218, 'lps'),
	(406490, 124, '2015-02-15 00:59:28.000000', 'consum', 0.0218, 'lps'),
	(406491, 124, '2015-02-15 00:59:29.000000', 'consum', 0.0217, 'lps'),
	(406492, 124, '2015-02-15 00:59:30.000000', 'consum', 0.0220, 'lps'),
	(406493, 124, '2015-02-15 00:59:31.000000', 'consum', 0.0216, 'lps'),
	(406494, 124, '2015-02-15 00:59:32.000000', 'consum', 0.0221, 'lps'),
	(406495, 124, '2015-02-15 00:59:33.000000', 'consum', 0.0214, 'lps'),
	(406496, 124, '2015-02-15 00:59:34.000000', 'consum', 0.0211, 'lps'),
	(406497, 124, '2015-02-15 00:59:35.000000', 'consum', 0.0212, 'lps'),
	(406498, 124, '2015-02-15 00:59:36.000000', 'consum', 0.0218, 'lps'),
	(406499, 124, '2015-02-15 00:59:37.000000', 'consum', 0.0221, 'lps'),
	(406500, 124, '2015-02-15 00:59:38.000000', 'consum', 0.0219, 'lps'),
	(406501, 124, '2015-02-15 00:59:39.000000', 'consum', 0.0210, 'lps'),
	(406502, 124, '2015-02-15 00:59:40.000000', 'consum', 0.0219, 'lps'),
	(406503, 124, '2015-02-15 00:59:41.000000', 'consum', 0.0221, 'lps'),
	(406504, 124, '2015-02-15 00:59:42.000000', 'consum', 0.0213, 'lps'),
	(406505, 124, '2015-02-15 00:59:43.000000', 'consum', 0.0216, 'lps'),
	(406506, 124, '2015-02-15 00:59:44.000000', 'consum', 0.0219, 'lps'),
	(406507, 124, '2015-02-15 00:59:45.000000', 'consum', 0.0216, 'lps'),
	(406508, 124, '2015-02-15 00:59:46.000000', 'consum', 0.0210, 'lps'),
	(406509, 124, '2015-02-15 00:59:47.000000', 'consum', 0.0219, 'lps'),
	(406510, 124, '2015-02-15 00:59:48.000000', 'consum', 0.0218, 'lps'),
	(406511, 124, '2015-02-15 00:59:49.000000', 'consum', 0.0211, 'lps'),
	(406512, 124, '2015-02-15 00:59:50.000000', 'consum', 0.0216, 'lps'),
	(406513, 124, '2015-02-15 00:59:51.000000', 'consum', 0.0212, 'lps'),
	(406514, 124, '2015-02-15 00:59:52.000000', 'consum', 0.0214, 'lps'),
	(406515, 124, '2015-02-15 00:59:53.000000', 'consum', 0.0214, 'lps'),
	(406516, 124, '2015-02-15 00:59:54.000000', 'consum', 0.0218, 'lps'),
	(406517, 124, '2015-02-15 00:59:55.000000', 'consum', 0.0216, 'lps'),
	(406518, 124, '2015-02-15 00:59:56.000000', 'consum', 0.0214, 'lps'),
	(406519, 124, '2015-02-15 00:59:57.000000', 'consum', 0.0212, 'lps'),
	(406520, 124, '2015-02-15 00:59:58.000000', 'consum', 0.0220, 'lps'),
	(406521, 124, '2015-02-15 00:59:59.000000', 'consum', 0.0221, 'lps'),
	(406522, 124, '2015-02-15 01:00:00.000000', 'consum', 0.0211, 'lps'),
	(406523, 124, '2015-02-15 01:00:01.000000', 'consum', 0.0218, 'lps'),
	(406524, 124, '2015-02-15 01:00:02.000000', 'consum', 0.0211, 'lps'),
	(406525, 124, '2015-02-15 01:00:03.000000', 'consum', 0.0216, 'lps'),
	(406526, 124, '2015-02-15 01:00:04.000000', 'consum', 0.0212, 'lps'),
	(406527, 124, '2015-02-15 01:00:05.000000', 'consum', 0.0216, 'lps'),
	(406528, 124, '2015-02-15 01:00:06.000000', 'consum', 0.0211, 'lps'),
	(406529, 124, '2015-02-15 01:00:07.000000', 'consum', 0.0219, 'lps'),
	(406530, 124, '2015-02-15 01:00:08.000000', 'consum', 0.0218, 'lps'),
	(406531, 124, '2015-02-15 01:00:09.000000', 'consum', 0.0210, 'lps'),
	(406532, 124, '2015-02-15 01:00:10.000000', 'consum', 0.0211, 'lps'),
	(406533, 124, '2015-02-15 01:00:11.000000', 'consum', 0.0217, 'lps'),
	(406534, 124, '2015-02-15 01:00:12.000000', 'consum', 0.0217, 'lps'),
	(406535, 124, '2015-02-15 01:00:13.000000', 'consum', 0.0211, 'lps'),
	(406536, 124, '2015-02-15 01:00:14.000000', 'consum', 0.0210, 'lps'),
	(406537, 124, '2015-02-15 01:00:15.000000', 'consum', 0.0218, 'lps'),
	(406538, 124, '2015-02-15 01:00:16.000000', 'consum', 0.0213, 'lps'),
	(406539, 124, '2015-02-15 01:00:17.000000', 'consum', 0.0214, 'lps'),
	(406540, 124, '2015-02-15 01:00:18.000000', 'consum', 0.0211, 'lps'),
	(406541, 124, '2015-02-15 01:00:19.000000', 'consum', 0.0213, 'lps'),
	(406542, 124, '2015-02-15 01:00:20.000000', 'consum', 0.0212, 'lps'),
	(406543, 124, '2015-02-15 01:00:21.000000', 'consum', 0.0212, 'lps'),
	(406544, 124, '2015-02-15 01:00:22.000000', 'consum', 0.0213, 'lps'),
	(406545, 124, '2015-02-15 01:00:23.000000', 'consum', 0.0220, 'lps'),
	(406546, 124, '2015-02-15 01:00:24.000000', 'consum', 0.0215, 'lps'),
	(406547, 124, '2015-02-15 01:00:25.000000', 'consum', 0.0217, 'lps'),
	(406548, 124, '2015-02-15 01:00:26.000000', 'consum', 0.0218, 'lps'),
	(406549, 124, '2015-02-15 01:00:27.000000', 'consum', 0.0219, 'lps'),
	(406550, 124, '2015-02-15 01:00:28.000000', 'consum', 0.0219, 'lps'),
	(406551, 124, '2015-02-15 01:00:29.000000', 'consum', 0.0215, 'lps'),
	(406552, 124, '2015-02-15 01:00:30.000000', 'consum', 0.0220, 'lps'),
	(406553, 124, '2015-02-15 01:00:31.000000', 'consum', 0.0210, 'lps'),
	(406554, 124, '2015-02-15 01:00:32.000000', 'consum', 0.0218, 'lps'),
	(406555, 124, '2015-02-15 01:00:33.000000', 'consum', 0.0212, 'lps'),
	(406556, 124, '2015-02-15 01:00:34.000000', 'consum', 0.0221, 'lps'),
	(406557, 124, '2015-02-15 01:00:35.000000', 'consum', 0.0211, 'lps'),
	(406558, 124, '2015-02-15 01:00:36.000000', 'consum', 0.0221, 'lps'),
	(406559, 124, '2015-02-15 01:00:37.000000', 'consum', 0.0214, 'lps'),
	(406560, 124, '2015-02-15 01:00:38.000000', 'consum', 0.0210, 'lps'),
	(406561, 124, '2015-02-15 01:00:39.000000', 'consum', 0.0210, 'lps'),
	(406562, 124, '2015-02-15 01:00:40.000000', 'consum', 0.0211, 'lps'),
	(406563, 124, '2015-02-15 01:00:41.000000', 'consum', 0.0217, 'lps'),
	(406564, 124, '2015-02-15 01:00:42.000000', 'consum', 0.0217, 'lps'),
	(406565, 124, '2015-02-15 01:00:43.000000', 'consum', 0.0215, 'lps'),
	(406566, 124, '2015-02-15 01:00:44.000000', 'consum', 0.0212, 'lps'),
	(406567, 124, '2015-02-15 01:00:45.000000', 'consum', 0.0216, 'lps'),
	(406568, 124, '2015-02-15 01:00:46.000000', 'consum', 0.0212, 'lps'),
	(406569, 124, '2015-02-15 01:00:47.000000', 'consum', 0.0217, 'lps'),
	(406570, 124, '2015-02-15 01:00:48.000000', 'consum', 0.0212, 'lps'),
	(406571, 124, '2015-02-15 01:00:49.000000', 'consum', 0.0213, 'lps'),
	(406572, 124, '2015-02-15 01:00:50.000000', 'consum', 0.0219, 'lps'),
	(406573, 124, '2015-02-15 01:00:51.000000', 'consum', 0.0221, 'lps'),
	(406574, 124, '2015-02-15 01:00:52.000000', 'consum', 0.0215, 'lps'),
	(406575, 124, '2015-02-15 01:00:53.000000', 'consum', 0.0217, 'lps'),
	(406576, 124, '2015-02-15 01:00:54.000000', 'consum', 0.0218, 'lps'),
	(406577, 124, '2015-02-15 01:00:55.000000', 'consum', 0.0215, 'lps'),
	(406578, 124, '2015-02-15 01:00:56.000000', 'consum', 0.0214, 'lps'),
	(406579, 124, '2015-02-15 01:00:57.000000', 'consum', 0.0213, 'lps'),
	(406580, 124, '2015-02-15 01:00:58.000000', 'consum', 0.0213, 'lps'),
	(406581, 124, '2015-02-15 01:00:59.000000', 'consum', 0.0219, 'lps'),
	(406582, 124, '2015-02-15 01:01:00.000000', 'consum', 0.0221, 'lps'),
	(406583, 124, '2015-02-15 01:01:01.000000', 'consum', 0.0216, 'lps'),
	(406584, 124, '2015-02-15 01:01:02.000000', 'consum', 0.0218, 'lps'),
	(406585, 124, '2015-02-15 01:01:03.000000', 'consum', 0.0220, 'lps'),
	(406586, 124, '2015-02-15 01:01:04.000000', 'consum', 0.0215, 'lps'),
	(406587, 124, '2015-02-15 01:01:05.000000', 'consum', 0.0217, 'lps'),
	(406588, 124, '2015-02-15 01:01:06.000000', 'consum', 0.0219, 'lps'),
	(406589, 124, '2015-02-15 01:01:07.000000', 'consum', 0.0211, 'lps'),
	(406590, 124, '2015-02-15 01:01:08.000000', 'consum', 0.0210, 'lps'),
	(406591, 124, '2015-02-15 01:01:09.000000', 'consum', 0.0221, 'lps'),
	(406592, 124, '2015-02-15 01:01:10.000000', 'consum', 0.0217, 'lps'),
	(406593, 124, '2015-02-15 01:01:11.000000', 'consum', 0.0212, 'lps'),
	(406594, 124, '2015-02-15 01:01:12.000000', 'consum', 0.0210, 'lps'),
	(406595, 124, '2015-02-15 01:01:13.000000', 'consum', 0.0219, 'lps'),
	(406596, 124, '2015-02-15 01:01:14.000000', 'consum', 0.0220, 'lps'),
	(406597, 124, '2015-02-15 01:01:15.000000', 'consum', 0.0210, 'lps'),
	(406598, 124, '2015-02-15 01:01:16.000000', 'consum', 0.0216, 'lps'),
	(406599, 124, '2015-02-15 01:01:17.000000', 'consum', 0.0217, 'lps'),
	(406600, 124, '2015-02-15 01:01:18.000000', 'consum', 0.0216, 'lps'),
	(406601, 124, '2015-02-15 01:01:19.000000', 'consum', 0.0220, 'lps'),
	(406602, 124, '2015-02-15 01:01:20.000000', 'consum', 0.0216, 'lps'),
	(406603, 124, '2015-02-15 01:01:21.000000', 'consum', 0.0210, 'lps'),
	(406604, 124, '2015-02-15 01:01:22.000000', 'consum', 0.0216, 'lps'),
	(406605, 124, '2015-02-15 01:01:23.000000', 'consum', 0.0218, 'lps'),
	(406606, 124, '2015-02-15 01:01:24.000000', 'consum', 0.0221, 'lps'),
	(406607, 124, '2015-02-15 01:01:25.000000', 'consum', 0.0218, 'lps'),
	(406608, 124, '2015-02-15 01:01:26.000000', 'consum', 0.0219, 'lps'),
	(406609, 124, '2015-02-15 01:01:27.000000', 'consum', 0.0217, 'lps'),
	(406610, 124, '2015-02-15 01:01:28.000000', 'consum', 0.0217, 'lps'),
	(406611, 124, '2015-02-15 01:01:29.000000', 'consum', 0.0215, 'lps'),
	(406612, 124, '2015-02-15 01:01:30.000000', 'consum', 0.0212, 'lps'),
	(406613, 124, '2015-02-15 01:01:31.000000', 'consum', 0.0218, 'lps'),
	(406614, 124, '2015-02-15 01:01:32.000000', 'consum', 0.0220, 'lps'),
	(406615, 124, '2015-02-15 01:01:33.000000', 'consum', 0.0215, 'lps'),
	(406616, 124, '2015-02-15 01:01:34.000000', 'consum', 0.0214, 'lps'),
	(406617, 124, '2015-02-15 01:01:35.000000', 'consum', 0.0218, 'lps'),
	(406618, 124, '2015-02-15 01:01:36.000000', 'consum', 0.0212, 'lps'),
	(406619, 124, '2015-02-15 01:01:37.000000', 'consum', 0.0210, 'lps'),
	(406620, 124, '2015-02-15 01:01:38.000000', 'consum', 0.0218, 'lps'),
	(406621, 124, '2015-02-15 01:01:39.000000', 'consum', 0.0214, 'lps'),
	(406622, 124, '2015-02-15 01:01:40.000000', 'consum', 0.0217, 'lps'),
	(406623, 124, '2015-02-15 01:01:41.000000', 'consum', 0.0211, 'lps'),
	(406624, 124, '2015-02-15 01:01:42.000000', 'consum', 0.0218, 'lps'),
	(406625, 124, '2015-02-15 01:01:43.000000', 'consum', 0.0213, 'lps'),
	(406626, 124, '2015-02-15 01:01:44.000000', 'consum', 0.0211, 'lps'),
	(406627, 124, '2015-02-15 01:01:45.000000', 'consum', 0.0219, 'lps'),
	(406628, 124, '2015-02-15 01:01:46.000000', 'consum', 0.0216, 'lps'),
	(406629, 124, '2015-02-15 01:01:47.000000', 'consum', 0.0212, 'lps'),
	(406630, 124, '2015-02-15 01:01:48.000000', 'consum', 0.0217, 'lps'),
	(406631, 124, '2015-02-15 01:01:49.000000', 'consum', 0.0214, 'lps'),
	(406632, 124, '2015-02-15 01:01:50.000000', 'consum', 0.0221, 'lps'),
	(406633, 124, '2015-02-15 01:01:51.000000', 'consum', 0.0216, 'lps'),
	(406634, 124, '2015-02-15 01:01:52.000000', 'consum', 0.0221, 'lps'),
	(406635, 124, '2015-02-15 01:01:53.000000', 'consum', 0.0213, 'lps'),
	(406636, 124, '2015-02-15 01:01:54.000000', 'consum', 0.0216, 'lps'),
	(406637, 124, '2015-02-15 01:01:55.000000', 'consum', 0.0221, 'lps'),
	(406638, 124, '2015-02-15 01:01:56.000000', 'consum', 0.0221, 'lps'),
	(406639, 124, '2015-02-15 01:01:57.000000', 'consum', 0.0210, 'lps'),
	(406640, 124, '2015-02-15 01:01:58.000000', 'consum', 0.0214, 'lps'),
	(406641, 124, '2015-02-15 01:01:59.000000', 'consum', 0.0218, 'lps'),
	(406642, 124, '2015-02-15 01:02:00.000000', 'consum', 0.0215, 'lps'),
	(406643, 124, '2015-02-15 01:02:01.000000', 'consum', 0.0212, 'lps'),
	(406644, 124, '2015-02-15 01:02:02.000000', 'consum', 0.0216, 'lps'),
	(406645, 124, '2015-02-15 01:02:03.000000', 'consum', 0.0221, 'lps'),
	(406646, 124, '2015-02-15 01:02:04.000000', 'consum', 0.0213, 'lps'),
	(406647, 124, '2015-02-15 01:02:05.000000', 'consum', 0.0217, 'lps'),
	(406648, 124, '2015-02-15 01:02:06.000000', 'consum', 0.0213, 'lps'),
	(406649, 124, '2015-02-15 01:02:07.000000', 'consum', 0.0214, 'lps'),
	(406650, 124, '2015-02-15 01:02:08.000000', 'consum', 0.0210, 'lps'),
	(406651, 124, '2015-02-15 01:02:09.000000', 'consum', 0.0213, 'lps'),
	(406652, 124, '2015-02-15 01:02:10.000000', 'consum', 0.0213, 'lps'),
	(406653, 124, '2015-02-15 01:02:11.000000', 'consum', 0.0215, 'lps'),
	(406654, 124, '2015-02-15 01:02:12.000000', 'consum', 0.0214, 'lps'),
	(406655, 124, '2015-02-15 01:02:13.000000', 'consum', 0.0215, 'lps'),
	(406656, 124, '2015-02-15 01:02:14.000000', 'consum', 0.0213, 'lps'),
	(406657, 124, '2015-02-15 01:02:15.000000', 'consum', 0.0212, 'lps'),
	(406658, 124, '2015-02-15 01:02:16.000000', 'consum', 0.0221, 'lps'),
	(406659, 124, '2015-02-15 01:02:17.000000', 'consum', 0.0213, 'lps'),
	(406660, 124, '2015-02-15 01:02:18.000000', 'consum', 0.0215, 'lps'),
	(406661, 124, '2015-02-15 01:02:19.000000', 'consum', 0.0215, 'lps'),
	(406662, 124, '2015-02-15 01:02:20.000000', 'consum', 0.0220, 'lps'),
	(406663, 124, '2015-02-15 01:02:21.000000', 'consum', 0.0221, 'lps'),
	(406664, 124, '2015-02-15 01:02:22.000000', 'consum', 0.0214, 'lps'),
	(406665, 124, '2015-02-15 01:02:23.000000', 'consum', 0.0219, 'lps'),
	(406666, 124, '2015-02-15 01:02:24.000000', 'consum', 0.0221, 'lps'),
	(406667, 124, '2015-02-15 01:02:25.000000', 'consum', 0.0214, 'lps'),
	(406668, 124, '2015-02-15 01:02:26.000000', 'consum', 0.0211, 'lps'),
	(406669, 124, '2015-02-15 01:02:27.000000', 'consum', 0.0215, 'lps'),
	(406670, 124, '2015-02-15 01:02:28.000000', 'consum', 0.0220, 'lps'),
	(406671, 124, '2015-02-15 01:02:29.000000', 'consum', 0.0221, 'lps'),
	(406672, 124, '2015-02-15 01:02:30.000000', 'consum', 0.0211, 'lps'),
	(406673, 124, '2015-02-15 01:02:31.000000', 'consum', 0.0219, 'lps'),
	(406674, 124, '2015-02-15 01:02:32.000000', 'consum', 0.0217, 'lps'),
	(406675, 124, '2015-02-15 01:02:33.000000', 'consum', 0.0220, 'lps'),
	(406676, 124, '2015-02-15 01:02:34.000000', 'consum', 0.0213, 'lps'),
	(406677, 124, '2015-02-15 01:02:35.000000', 'consum', 0.0219, 'lps'),
	(406678, 124, '2015-02-15 01:02:36.000000', 'consum', 0.0213, 'lps'),
	(406679, 124, '2015-02-15 01:02:37.000000', 'consum', 0.0210, 'lps'),
	(406680, 124, '2015-02-15 01:02:38.000000', 'consum', 0.0214, 'lps'),
	(406681, 124, '2015-02-15 01:02:39.000000', 'consum', 0.0217, 'lps'),
	(406682, 124, '2015-02-15 01:02:40.000000', 'consum', 0.0220, 'lps'),
	(406683, 124, '2015-02-15 01:02:41.000000', 'consum', 0.0218, 'lps'),
	(406684, 124, '2015-02-15 01:02:42.000000', 'consum', 0.0220, 'lps'),
	(406685, 124, '2015-02-15 01:02:43.000000', 'consum', 0.0213, 'lps'),
	(406686, 124, '2015-02-15 01:02:44.000000', 'consum', 0.0218, 'lps'),
	(406687, 124, '2015-02-15 01:02:45.000000', 'consum', 0.0219, 'lps'),
	(406688, 124, '2015-02-15 01:02:46.000000', 'consum', 0.0221, 'lps'),
	(406689, 124, '2015-02-15 01:02:47.000000', 'consum', 0.0213, 'lps'),
	(406690, 124, '2015-02-15 01:02:48.000000', 'consum', 0.0218, 'lps'),
	(406691, 124, '2015-02-15 01:02:49.000000', 'consum', 0.0216, 'lps'),
	(406692, 124, '2015-02-15 01:02:50.000000', 'consum', 0.0218, 'lps'),
	(406693, 124, '2015-02-15 01:02:51.000000', 'consum', 0.0221, 'lps'),
	(406694, 124, '2015-02-15 01:02:52.000000', 'consum', 0.0217, 'lps'),
	(406695, 124, '2015-02-15 01:02:53.000000', 'consum', 0.0210, 'lps'),
	(406696, 124, '2015-02-15 01:02:54.000000', 'consum', 0.0217, 'lps'),
	(406697, 124, '2015-02-15 01:02:55.000000', 'consum', 0.0220, 'lps'),
	(406698, 124, '2015-02-15 01:02:56.000000', 'consum', 0.0217, 'lps'),
	(406699, 124, '2015-02-15 01:02:57.000000', 'consum', 0.0215, 'lps'),
	(406700, 124, '2015-02-15 01:02:58.000000', 'consum', 0.0213, 'lps'),
	(406701, 124, '2015-02-15 01:02:59.000000', 'consum', 0.0210, 'lps'),
	(406702, 124, '2015-02-15 01:03:00.000000', 'consum', 0.0216, 'lps'),
	(406703, 124, '2015-02-15 01:03:01.000000', 'consum', 0.0215, 'lps'),
	(406704, 124, '2015-02-15 01:03:02.000000', 'consum', 0.0219, 'lps'),
	(406705, 124, '2015-02-15 01:03:03.000000', 'consum', 0.0215, 'lps'),
	(406706, 124, '2015-02-15 01:03:04.000000', 'consum', 0.0219, 'lps'),
	(406707, 124, '2015-02-15 01:03:05.000000', 'consum', 0.0218, 'lps'),
	(406708, 124, '2015-02-15 01:03:06.000000', 'consum', 0.0211, 'lps'),
	(406709, 124, '2015-02-15 01:03:07.000000', 'consum', 0.0217, 'lps'),
	(406710, 124, '2015-02-15 01:03:08.000000', 'consum', 0.0220, 'lps'),
	(406711, 124, '2015-02-15 01:03:09.000000', 'consum', 0.0213, 'lps'),
	(406712, 124, '2015-02-15 01:03:10.000000', 'consum', 0.0219, 'lps'),
	(406713, 124, '2015-02-15 01:03:11.000000', 'consum', 0.0213, 'lps'),
	(406714, 124, '2015-02-15 01:03:12.000000', 'consum', 0.0210, 'lps'),
	(406715, 124, '2015-02-15 01:03:13.000000', 'consum', 0.0215, 'lps'),
	(406716, 124, '2015-02-15 01:03:14.000000', 'consum', 0.0221, 'lps'),
	(406717, 124, '2015-02-15 01:03:15.000000', 'consum', 0.0214, 'lps'),
	(406718, 124, '2015-02-15 01:03:16.000000', 'consum', 0.0210, 'lps'),
	(406719, 124, '2015-02-15 01:03:17.000000', 'consum', 0.0212, 'lps'),
	(406720, 124, '2015-02-15 01:03:18.000000', 'consum', 0.0218, 'lps'),
	(406721, 124, '2015-02-15 01:03:19.000000', 'consum', 0.0220, 'lps'),
	(406722, 124, '2015-02-15 01:03:20.000000', 'consum', 0.0213, 'lps'),
	(406723, 124, '2015-02-15 01:03:21.000000', 'consum', 0.0220, 'lps'),
	(406724, 124, '2015-02-15 01:03:22.000000', 'consum', 0.0216, 'lps'),
	(406725, 124, '2015-02-15 01:03:23.000000', 'consum', 0.0212, 'lps'),
	(406726, 124, '2015-02-15 01:03:24.000000', 'consum', 0.0212, 'lps'),
	(406727, 124, '2015-02-15 01:03:25.000000', 'consum', 0.0215, 'lps'),
	(406728, 124, '2015-02-15 01:03:26.000000', 'consum', 0.0216, 'lps'),
	(406729, 124, '2015-02-15 01:03:27.000000', 'consum', 0.0216, 'lps'),
	(406730, 124, '2015-02-15 01:03:28.000000', 'consum', 0.0220, 'lps'),
	(406731, 124, '2015-02-15 01:03:29.000000', 'consum', 0.0220, 'lps'),
	(406732, 124, '2015-02-15 01:03:30.000000', 'consum', 0.0217, 'lps'),
	(406733, 124, '2015-02-15 01:03:31.000000', 'consum', 0.0217, 'lps'),
	(406734, 124, '2015-02-15 01:03:32.000000', 'consum', 0.0213, 'lps'),
	(406735, 124, '2015-02-15 01:03:33.000000', 'consum', 0.0217, 'lps'),
	(406736, 124, '2015-02-15 01:03:34.000000', 'consum', 0.0212, 'lps'),
	(406737, 124, '2015-02-15 01:03:35.000000', 'consum', 0.0211, 'lps'),
	(406738, 124, '2015-02-15 01:03:36.000000', 'consum', 0.0221, 'lps'),
	(406739, 124, '2015-02-15 01:03:37.000000', 'consum', 0.0217, 'lps'),
	(406740, 124, '2015-02-15 01:03:38.000000', 'consum', 0.0211, 'lps'),
	(406741, 124, '2015-02-15 01:03:39.000000', 'consum', 0.0220, 'lps'),
	(406742, 124, '2015-02-15 01:03:40.000000', 'consum', 0.0220, 'lps'),
	(406743, 124, '2015-02-15 01:03:41.000000', 'consum', 0.0219, 'lps'),
	(406744, 124, '2015-02-15 01:03:42.000000', 'consum', 0.0213, 'lps'),
	(406745, 124, '2015-02-15 01:03:43.000000', 'consum', 0.0210, 'lps'),
	(406746, 124, '2015-02-15 01:03:44.000000', 'consum', 0.0214, 'lps'),
	(406747, 124, '2015-02-15 01:03:45.000000', 'consum', 0.0219, 'lps'),
	(406748, 124, '2015-02-15 01:03:46.000000', 'consum', 0.0220, 'lps'),
	(406749, 124, '2015-02-15 01:03:47.000000', 'consum', 0.0210, 'lps'),
	(406750, 124, '2015-02-15 01:03:48.000000', 'consum', 0.0216, 'lps'),
	(406751, 124, '2015-02-15 01:03:49.000000', 'consum', 0.0215, 'lps'),
	(406752, 124, '2015-02-15 01:03:50.000000', 'consum', 0.0219, 'lps'),
	(406753, 124, '2015-02-15 01:03:51.000000', 'consum', 0.0214, 'lps'),
	(406754, 124, '2015-02-15 01:03:52.000000', 'consum', 0.0218, 'lps'),
	(406755, 124, '2015-02-15 01:03:53.000000', 'consum', 0.0212, 'lps'),
	(406756, 124, '2015-02-15 01:03:54.000000', 'consum', 0.0210, 'lps'),
	(406757, 124, '2015-02-15 01:03:55.000000', 'consum', 0.0217, 'lps'),
	(406758, 124, '2015-02-15 01:03:56.000000', 'consum', 0.0210, 'lps'),
	(406759, 124, '2015-02-15 01:03:57.000000', 'consum', 0.0214, 'lps'),
	(406760, 124, '2015-02-15 01:03:58.000000', 'consum', 0.0218, 'lps'),
	(406761, 124, '2015-02-15 01:03:59.000000', 'consum', 0.0214, 'lps'),
	(406762, 124, '2015-02-15 01:04:00.000000', 'consum', 0.0217, 'lps'),
	(406763, 124, '2015-02-15 01:04:01.000000', 'consum', 0.0221, 'lps'),
	(406764, 124, '2015-02-15 01:04:02.000000', 'consum', 0.0211, 'lps'),
	(406765, 124, '2015-02-15 01:04:03.000000', 'consum', 0.0218, 'lps'),
	(406766, 124, '2015-02-15 01:04:04.000000', 'consum', 0.0221, 'lps'),
	(406767, 124, '2015-02-15 01:04:05.000000', 'consum', 0.0220, 'lps'),
	(406768, 124, '2015-02-15 01:04:06.000000', 'consum', 0.0217, 'lps'),
	(406769, 124, '2015-02-15 01:04:07.000000', 'consum', 0.0213, 'lps'),
	(406770, 124, '2015-02-15 01:04:08.000000', 'consum', 0.0219, 'lps'),
	(406771, 124, '2015-02-15 01:04:09.000000', 'consum', 0.0220, 'lps'),
	(406772, 124, '2015-02-15 01:04:10.000000', 'consum', 0.0211, 'lps'),
	(406773, 124, '2015-02-15 01:04:11.000000', 'consum', 0.0221, 'lps'),
	(406774, 124, '2015-02-15 01:04:12.000000', 'consum', 0.0214, 'lps'),
	(406775, 124, '2015-02-15 01:04:13.000000', 'consum', 0.0221, 'lps'),
	(406776, 124, '2015-02-15 01:04:14.000000', 'consum', 0.0217, 'lps'),
	(406777, 124, '2015-02-15 01:04:15.000000', 'consum', 0.0215, 'lps'),
	(406778, 124, '2015-02-15 01:04:16.000000', 'consum', 0.0213, 'lps'),
	(406779, 124, '2015-02-15 01:04:17.000000', 'consum', 0.0211, 'lps'),
	(406780, 124, '2015-02-15 01:04:18.000000', 'consum', 0.0220, 'lps'),
	(406781, 124, '2015-02-15 01:04:19.000000', 'consum', 0.0220, 'lps'),
	(406782, 124, '2015-02-15 01:04:20.000000', 'consum', 0.0217, 'lps'),
	(406783, 124, '2015-02-15 01:04:21.000000', 'consum', 0.0215, 'lps'),
	(406784, 124, '2015-02-15 01:04:22.000000', 'consum', 0.0217, 'lps'),
	(406785, 124, '2015-02-15 01:04:23.000000', 'consum', 0.0219, 'lps'),
	(406786, 124, '2015-02-15 01:04:24.000000', 'consum', 0.0211, 'lps'),
	(406787, 124, '2015-02-15 01:04:25.000000', 'consum', 0.0210, 'lps'),
	(406788, 124, '2015-02-15 01:04:26.000000', 'consum', 0.0210, 'lps'),
	(406789, 124, '2015-02-15 01:04:27.000000', 'consum', 0.0221, 'lps'),
	(406790, 124, '2015-02-15 01:04:28.000000', 'consum', 0.0216, 'lps'),
	(406791, 124, '2015-02-15 01:04:29.000000', 'consum', 0.0210, 'lps'),
	(406792, 124, '2015-02-15 01:04:30.000000', 'consum', 0.0216, 'lps'),
	(406793, 124, '2015-02-15 01:04:31.000000', 'consum', 0.0218, 'lps'),
	(406794, 124, '2015-02-15 01:04:32.000000', 'consum', 0.0221, 'lps'),
	(406795, 124, '2015-02-15 01:04:33.000000', 'consum', 0.0216, 'lps'),
	(406796, 124, '2015-02-15 01:04:34.000000', 'consum', 0.0220, 'lps'),
	(406797, 124, '2015-02-15 01:04:35.000000', 'consum', 0.0220, 'lps'),
	(406798, 124, '2015-02-15 01:04:36.000000', 'consum', 0.0215, 'lps'),
	(406799, 124, '2015-02-15 01:04:37.000000', 'consum', 0.0221, 'lps'),
	(406800, 124, '2015-02-15 01:04:38.000000', 'consum', 0.0214, 'lps'),
	(406801, 124, '2015-02-15 01:04:39.000000', 'consum', 0.0219, 'lps'),
	(406802, 124, '2015-02-15 01:04:40.000000', 'consum', 0.0221, 'lps'),
	(406803, 124, '2015-02-15 01:04:41.000000', 'consum', 0.0214, 'lps'),
	(406804, 124, '2015-02-15 01:04:42.000000', 'consum', 0.0212, 'lps'),
	(406805, 124, '2015-02-15 01:04:43.000000', 'consum', 0.0217, 'lps'),
	(406806, 124, '2015-02-15 01:04:44.000000', 'consum', 0.0217, 'lps'),
	(406807, 124, '2015-02-15 01:04:45.000000', 'consum', 0.0212, 'lps'),
	(406808, 124, '2015-02-15 01:04:46.000000', 'consum', 0.0210, 'lps'),
	(406809, 124, '2015-02-15 01:04:47.000000', 'consum', 0.0218, 'lps'),
	(406810, 124, '2015-02-15 01:04:48.000000', 'consum', 0.0216, 'lps'),
	(406811, 124, '2015-02-15 01:04:49.000000', 'consum', 0.0217, 'lps'),
	(406812, 124, '2015-02-15 01:04:50.000000', 'consum', 0.0212, 'lps'),
	(406813, 124, '2015-02-15 01:04:51.000000', 'consum', 0.0214, 'lps'),
	(406814, 124, '2015-02-15 01:04:52.000000', 'consum', 0.0214, 'lps'),
	(406815, 124, '2015-02-15 01:04:53.000000', 'consum', 0.0216, 'lps'),
	(406816, 124, '2015-02-15 01:04:54.000000', 'consum', 0.0215, 'lps'),
	(406817, 124, '2015-02-15 01:04:55.000000', 'consum', 0.0219, 'lps'),
	(406818, 124, '2015-02-15 01:04:56.000000', 'consum', 0.0219, 'lps'),
	(406819, 124, '2015-02-15 01:04:57.000000', 'consum', 0.0213, 'lps'),
	(406820, 124, '2015-02-15 01:04:58.000000', 'consum', 0.0211, 'lps'),
	(406821, 124, '2015-02-15 01:04:59.000000', 'consum', 0.0221, 'lps'),
	(406822, 124, '2015-02-15 01:05:00.000000', 'consum', 0.0211, 'lps'),
	(406823, 124, '2015-02-15 01:05:01.000000', 'consum', 0.0221, 'lps'),
	(406824, 124, '2015-02-15 01:05:02.000000', 'consum', 0.0214, 'lps'),
	(406825, 124, '2015-02-15 01:05:03.000000', 'consum', 0.0221, 'lps'),
	(406826, 124, '2015-02-15 01:05:04.000000', 'consum', 0.0217, 'lps'),
	(406827, 124, '2015-02-15 01:05:05.000000', 'consum', 0.0214, 'lps'),
	(406828, 124, '2015-02-15 01:05:06.000000', 'consum', 0.0220, 'lps'),
	(406829, 124, '2015-02-15 01:05:07.000000', 'consum', 0.0215, 'lps'),
	(406830, 124, '2015-02-15 01:05:08.000000', 'consum', 0.0215, 'lps'),
	(406831, 124, '2015-02-15 01:05:09.000000', 'consum', 0.0220, 'lps'),
	(406832, 124, '2015-02-15 01:05:10.000000', 'consum', 0.0212, 'lps'),
	(406833, 124, '2015-02-15 01:05:11.000000', 'consum', 0.0214, 'lps'),
	(406834, 124, '2015-02-15 01:05:12.000000', 'consum', 0.0211, 'lps'),
	(406835, 124, '2015-02-15 01:05:13.000000', 'consum', 0.0215, 'lps'),
	(406836, 124, '2015-02-15 01:05:14.000000', 'consum', 0.0220, 'lps'),
	(406837, 124, '2015-02-15 01:05:15.000000', 'consum', 0.0210, 'lps'),
	(406838, 124, '2015-02-15 01:05:16.000000', 'consum', 0.0217, 'lps'),
	(406839, 124, '2015-02-15 01:05:17.000000', 'consum', 0.0211, 'lps'),
	(406840, 124, '2015-02-15 01:05:18.000000', 'consum', 0.0216, 'lps'),
	(406841, 124, '2015-02-15 01:05:19.000000', 'consum', 0.0214, 'lps'),
	(406842, 124, '2015-02-15 01:05:20.000000', 'consum', 0.0214, 'lps'),
	(406843, 124, '2015-02-15 01:05:21.000000', 'consum', 0.0218, 'lps'),
	(406844, 124, '2015-02-15 01:05:22.000000', 'consum', 0.0215, 'lps'),
	(406845, 124, '2015-02-15 01:05:23.000000', 'consum', 0.0221, 'lps'),
	(406846, 124, '2015-02-15 01:05:24.000000', 'consum', 0.0217, 'lps'),
	(406847, 124, '2015-02-15 01:05:25.000000', 'consum', 0.0210, 'lps'),
	(406848, 124, '2015-02-15 01:05:26.000000', 'consum', 0.0213, 'lps'),
	(406849, 124, '2015-02-15 01:05:27.000000', 'consum', 0.0217, 'lps'),
	(406850, 124, '2015-02-15 01:05:28.000000', 'consum', 0.0221, 'lps'),
	(406851, 124, '2015-02-15 01:05:29.000000', 'consum', 0.0212, 'lps'),
	(406852, 124, '2015-02-15 01:05:30.000000', 'consum', 0.0221, 'lps'),
	(406853, 124, '2015-02-15 01:05:31.000000', 'consum', 0.0214, 'lps'),
	(406854, 124, '2015-02-15 01:05:32.000000', 'consum', 0.0219, 'lps'),
	(406855, 124, '2015-02-15 01:05:33.000000', 'consum', 0.0210, 'lps'),
	(406856, 124, '2015-02-15 01:05:34.000000', 'consum', 0.0217, 'lps'),
	(406857, 124, '2015-02-15 01:05:35.000000', 'consum', 0.0210, 'lps'),
	(406858, 124, '2015-02-15 01:05:36.000000', 'consum', 0.0212, 'lps'),
	(406859, 124, '2015-02-15 01:05:37.000000', 'consum', 0.0221, 'lps'),
	(406860, 124, '2015-02-15 01:05:38.000000', 'consum', 0.0213, 'lps'),
	(406861, 124, '2015-02-15 01:05:39.000000', 'consum', 0.0217, 'lps'),
	(406862, 124, '2015-02-15 01:05:40.000000', 'consum', 0.0210, 'lps'),
	(406863, 124, '2015-02-15 01:05:41.000000', 'consum', 0.0216, 'lps'),
	(406864, 124, '2015-02-15 01:05:42.000000', 'consum', 0.0214, 'lps'),
	(406865, 124, '2015-02-15 01:05:43.000000', 'consum', 0.0212, 'lps'),
	(406866, 124, '2015-02-15 01:05:44.000000', 'consum', 0.0221, 'lps'),
	(406867, 124, '2015-02-15 01:05:45.000000', 'consum', 0.0210, 'lps'),
	(406868, 124, '2015-02-15 01:05:46.000000', 'consum', 0.0216, 'lps'),
	(406869, 124, '2015-02-15 01:05:47.000000', 'consum', 0.0215, 'lps'),
	(406870, 124, '2015-02-15 01:05:48.000000', 'consum', 0.0219, 'lps'),
	(406871, 124, '2015-02-15 01:05:49.000000', 'consum', 0.0215, 'lps'),
	(406872, 124, '2015-02-15 01:05:50.000000', 'consum', 0.0221, 'lps'),
	(406873, 124, '2015-02-15 01:05:51.000000', 'consum', 0.0214, 'lps'),
	(406874, 124, '2015-02-15 01:05:52.000000', 'consum', 0.0211, 'lps'),
	(406875, 124, '2015-02-15 01:05:53.000000', 'consum', 0.0216, 'lps'),
	(406876, 124, '2015-02-15 01:05:54.000000', 'consum', 0.0212, 'lps'),
	(406877, 124, '2015-02-15 01:05:55.000000', 'consum', 0.0215, 'lps'),
	(406878, 124, '2015-02-15 01:05:56.000000', 'consum', 0.0219, 'lps'),
	(406879, 124, '2015-02-15 01:05:57.000000', 'consum', 0.0216, 'lps'),
	(406880, 124, '2015-02-15 01:05:58.000000', 'consum', 0.0212, 'lps'),
	(406881, 124, '2015-02-15 01:05:59.000000', 'consum', 0.0216, 'lps'),
	(406882, 124, '2015-02-15 01:06:00.000000', 'consum', 0.0211, 'lps'),
	(406883, 124, '2015-02-15 01:06:01.000000', 'consum', 0.0211, 'lps'),
	(406884, 124, '2015-02-15 01:06:02.000000', 'consum', 0.0221, 'lps'),
	(406885, 124, '2015-02-15 01:06:03.000000', 'consum', 0.0218, 'lps'),
	(406886, 124, '2015-02-15 01:06:04.000000', 'consum', 0.0214, 'lps'),
	(406887, 124, '2015-02-15 01:06:05.000000', 'consum', 0.0210, 'lps'),
	(406888, 124, '2015-02-15 01:06:06.000000', 'consum', 0.0220, 'lps'),
	(406889, 124, '2015-02-15 01:06:07.000000', 'consum', 0.0213, 'lps'),
	(406890, 124, '2015-02-15 01:06:08.000000', 'consum', 0.0220, 'lps'),
	(406891, 124, '2015-02-15 01:06:09.000000', 'consum', 0.0215, 'lps'),
	(406892, 124, '2015-02-15 01:06:10.000000', 'consum', 0.0219, 'lps'),
	(406893, 124, '2015-02-15 01:06:11.000000', 'consum', 0.0217, 'lps'),
	(406894, 124, '2015-02-15 01:06:12.000000', 'consum', 0.0219, 'lps'),
	(406895, 124, '2015-02-15 01:06:13.000000', 'consum', 0.0210, 'lps'),
	(406896, 124, '2015-02-15 01:06:14.000000', 'consum', 0.0217, 'lps'),
	(406897, 124, '2015-02-15 01:06:15.000000', 'consum', 0.0212, 'lps'),
	(406898, 124, '2015-02-15 01:06:16.000000', 'consum', 0.0211, 'lps'),
	(406899, 124, '2015-02-15 01:06:17.000000', 'consum', 0.0211, 'lps'),
	(406900, 124, '2015-02-15 01:06:18.000000', 'consum', 0.0211, 'lps'),
	(406901, 124, '2015-02-15 01:06:19.000000', 'consum', 0.0215, 'lps'),
	(406902, 124, '2015-02-15 01:06:20.000000', 'consum', 0.0218, 'lps'),
	(406903, 124, '2015-02-15 01:06:21.000000', 'consum', 0.0211, 'lps'),
	(406904, 124, '2015-02-15 01:06:22.000000', 'consum', 0.0218, 'lps'),
	(406905, 124, '2015-02-15 01:06:23.000000', 'consum', 0.0220, 'lps'),
	(406906, 124, '2015-02-15 01:06:24.000000', 'consum', 0.0216, 'lps'),
	(406907, 124, '2015-02-15 01:06:25.000000', 'consum', 0.0221, 'lps'),
	(406908, 124, '2015-02-15 01:06:26.000000', 'consum', 0.0214, 'lps'),
	(406909, 124, '2015-02-15 01:06:27.000000', 'consum', 0.0219, 'lps'),
	(406910, 124, '2015-02-15 01:06:28.000000', 'consum', 0.0219, 'lps'),
	(406911, 124, '2015-02-15 01:06:29.000000', 'consum', 0.0218, 'lps'),
	(406912, 124, '2015-02-15 01:06:30.000000', 'consum', 0.0211, 'lps'),
	(406913, 124, '2015-02-15 01:06:31.000000', 'consum', 0.0216, 'lps'),
	(406914, 124, '2015-02-15 01:06:32.000000', 'consum', 0.0213, 'lps'),
	(406915, 124, '2015-02-15 01:06:33.000000', 'consum', 0.0218, 'lps'),
	(406916, 124, '2015-02-15 01:06:34.000000', 'consum', 0.0219, 'lps'),
	(406917, 124, '2015-02-15 01:06:35.000000', 'consum', 0.0220, 'lps'),
	(406918, 124, '2015-02-15 01:06:36.000000', 'consum', 0.0210, 'lps'),
	(406919, 124, '2015-02-15 01:06:37.000000', 'consum', 0.0215, 'lps'),
	(406920, 124, '2015-02-15 01:06:38.000000', 'consum', 0.0213, 'lps'),
	(406921, 124, '2015-02-15 01:06:39.000000', 'consum', 0.0211, 'lps'),
	(406922, 124, '2015-02-15 01:06:40.000000', 'consum', 0.0216, 'lps'),
	(406923, 124, '2015-02-15 01:06:41.000000', 'consum', 0.0213, 'lps'),
	(406924, 124, '2015-02-15 01:06:42.000000', 'consum', 0.0220, 'lps'),
	(406925, 124, '2015-02-15 01:06:43.000000', 'consum', 0.0215, 'lps'),
	(406926, 124, '2015-02-15 01:06:44.000000', 'consum', 0.0217, 'lps'),
	(406927, 124, '2015-02-15 01:06:45.000000', 'consum', 0.0221, 'lps'),
	(406928, 124, '2015-02-15 01:06:46.000000', 'consum', 0.0219, 'lps'),
	(406929, 124, '2015-02-15 01:06:47.000000', 'consum', 0.0212, 'lps'),
	(406930, 124, '2015-02-15 01:06:48.000000', 'consum', 0.0218, 'lps'),
	(406931, 124, '2015-02-15 01:06:49.000000', 'consum', 0.0219, 'lps'),
	(406932, 124, '2015-02-15 01:06:50.000000', 'consum', 0.0219, 'lps'),
	(406933, 124, '2015-02-15 01:06:51.000000', 'consum', 0.0217, 'lps'),
	(406934, 124, '2015-02-15 01:06:52.000000', 'consum', 0.0218, 'lps'),
	(406935, 124, '2015-02-15 01:06:53.000000', 'consum', 0.0217, 'lps'),
	(406936, 124, '2015-02-15 01:06:54.000000', 'consum', 0.0211, 'lps'),
	(406937, 124, '2015-02-15 01:06:55.000000', 'consum', 0.0216, 'lps'),
	(406938, 124, '2015-02-15 01:06:56.000000', 'consum', 0.0215, 'lps'),
	(406939, 124, '2015-02-15 01:06:57.000000', 'consum', 0.0218, 'lps'),
	(406940, 124, '2015-02-15 01:06:58.000000', 'consum', 0.0213, 'lps'),
	(406941, 124, '2015-02-15 01:06:59.000000', 'consum', 0.0212, 'lps'),
	(406942, 124, '2015-02-15 01:07:00.000000', 'consum', 0.0210, 'lps'),
	(406943, 124, '2015-02-15 01:07:01.000000', 'consum', 0.0217, 'lps'),
	(406944, 124, '2015-02-15 01:07:02.000000', 'consum', 0.0211, 'lps'),
	(406945, 124, '2015-02-15 01:07:03.000000', 'consum', 0.0218, 'lps'),
	(406946, 124, '2015-02-15 01:07:04.000000', 'consum', 0.0210, 'lps'),
	(406947, 124, '2015-02-15 01:07:05.000000', 'consum', 0.0212, 'lps'),
	(406948, 124, '2015-02-15 01:07:06.000000', 'consum', 0.0218, 'lps'),
	(406949, 124, '2015-02-15 01:07:07.000000', 'consum', 0.0210, 'lps'),
	(406950, 124, '2015-02-15 01:07:08.000000', 'consum', 0.0211, 'lps'),
	(406951, 124, '2015-02-15 01:07:09.000000', 'consum', 0.0216, 'lps'),
	(406952, 124, '2015-02-15 01:07:10.000000', 'consum', 0.0211, 'lps'),
	(406953, 124, '2015-02-15 01:07:11.000000', 'consum', 0.0211, 'lps'),
	(406954, 124, '2015-02-15 01:07:12.000000', 'consum', 0.0211, 'lps'),
	(406955, 124, '2015-02-15 01:07:13.000000', 'consum', 0.0212, 'lps'),
	(406956, 124, '2015-02-15 01:07:14.000000', 'consum', 0.0219, 'lps'),
	(406957, 124, '2015-02-15 01:07:15.000000', 'consum', 0.0215, 'lps'),
	(406958, 124, '2015-02-15 01:07:16.000000', 'consum', 0.0220, 'lps'),
	(406959, 124, '2015-02-15 01:07:17.000000', 'consum', 0.0210, 'lps'),
	(406960, 124, '2015-02-15 01:07:18.000000', 'consum', 0.0214, 'lps'),
	(406961, 124, '2015-02-15 01:07:19.000000', 'consum', 0.0220, 'lps'),
	(406962, 124, '2015-02-15 01:07:20.000000', 'consum', 0.0210, 'lps'),
	(406963, 124, '2015-02-15 01:07:21.000000', 'consum', 0.0219, 'lps'),
	(406964, 124, '2015-02-15 01:07:22.000000', 'consum', 0.0219, 'lps'),
	(406965, 124, '2015-02-15 01:07:23.000000', 'consum', 0.0217, 'lps'),
	(406966, 124, '2015-02-15 01:07:24.000000', 'consum', 0.0216, 'lps'),
	(406967, 124, '2015-02-15 01:07:25.000000', 'consum', 0.0211, 'lps'),
	(406968, 124, '2015-02-15 01:07:26.000000', 'consum', 0.0218, 'lps'),
	(406969, 124, '2015-02-15 01:07:27.000000', 'consum', 0.0213, 'lps'),
	(406970, 124, '2015-02-15 01:07:28.000000', 'consum', 0.0213, 'lps'),
	(406971, 124, '2015-02-15 01:07:29.000000', 'consum', 0.0216, 'lps'),
	(406972, 124, '2015-02-15 01:07:30.000000', 'consum', 0.0221, 'lps'),
	(406973, 124, '2015-02-15 01:07:31.000000', 'consum', 0.0211, 'lps'),
	(406974, 124, '2015-02-15 01:07:32.000000', 'consum', 0.0220, 'lps'),
	(406975, 124, '2015-02-15 01:07:33.000000', 'consum', 0.0220, 'lps'),
	(406976, 124, '2015-02-15 01:07:34.000000', 'consum', 0.0220, 'lps'),
	(406977, 124, '2015-02-15 01:07:35.000000', 'consum', 0.0218, 'lps'),
	(406978, 124, '2015-02-15 01:07:36.000000', 'consum', 0.0221, 'lps'),
	(406979, 124, '2015-02-15 01:07:37.000000', 'consum', 0.0215, 'lps'),
	(406980, 124, '2015-02-15 01:07:38.000000', 'consum', 0.0216, 'lps'),
	(406981, 124, '2015-02-15 01:07:39.000000', 'consum', 0.0213, 'lps'),
	(406982, 124, '2015-02-15 01:07:40.000000', 'consum', 0.0221, 'lps'),
	(406983, 124, '2015-02-15 01:07:41.000000', 'consum', 0.0218, 'lps'),
	(406984, 124, '2015-02-15 01:07:42.000000', 'consum', 0.0221, 'lps'),
	(406985, 124, '2015-02-15 01:07:43.000000', 'consum', 0.0215, 'lps'),
	(406986, 124, '2015-02-15 01:07:44.000000', 'consum', 0.0214, 'lps'),
	(406987, 124, '2015-02-15 01:07:45.000000', 'consum', 0.0214, 'lps'),
	(406988, 124, '2015-02-15 01:07:46.000000', 'consum', 0.0221, 'lps'),
	(406989, 124, '2015-02-15 01:07:47.000000', 'consum', 0.0217, 'lps'),
	(406990, 124, '2015-02-15 01:07:48.000000', 'consum', 0.0211, 'lps'),
	(406991, 124, '2015-02-15 01:07:49.000000', 'consum', 0.0219, 'lps'),
	(406992, 124, '2015-02-15 01:07:50.000000', 'consum', 0.0218, 'lps'),
	(406993, 124, '2015-02-15 01:07:51.000000', 'consum', 0.0221, 'lps'),
	(406994, 124, '2015-02-15 01:07:52.000000', 'consum', 0.0218, 'lps'),
	(406995, 124, '2015-02-15 01:07:53.000000', 'consum', 0.0218, 'lps'),
	(406996, 124, '2015-02-15 01:07:54.000000', 'consum', 0.0215, 'lps'),
	(406997, 124, '2015-02-15 01:07:55.000000', 'consum', 0.0210, 'lps'),
	(406998, 124, '2015-02-15 01:07:56.000000', 'consum', 0.0219, 'lps'),
	(406999, 124, '2015-02-15 01:07:57.000000', 'consum', 0.0221, 'lps'),
	(407000, 124, '2015-02-15 01:07:58.000000', 'consum', 0.0214, 'lps'),
	(407001, 124, '2015-02-15 01:07:59.000000', 'consum', 0.0211, 'lps'),
	(407002, 124, '2015-02-15 01:08:00.000000', 'consum', 0.0215, 'lps'),
	(407003, 124, '2015-02-15 01:08:01.000000', 'consum', 0.0220, 'lps'),
	(407004, 124, '2015-02-15 01:08:02.000000', 'consum', 0.0211, 'lps'),
	(407005, 124, '2015-02-15 01:08:03.000000', 'consum', 0.0210, 'lps'),
	(407006, 124, '2015-02-15 01:08:04.000000', 'consum', 0.0218, 'lps'),
	(407007, 125, '2015-02-15 00:00:00.000000', 'consum', 0.0217, 'lps'),
	(407008, 125, '2015-02-15 00:00:01.000000', 'consum', 0.0213, 'lps'),
	(407009, 125, '2015-02-15 00:00:02.000000', 'consum', 0.0220, 'lps'),
	(407010, 125, '2015-02-15 00:00:03.000000', 'consum', 0.0217, 'lps'),
	(407011, 125, '2015-02-15 00:00:04.000000', 'consum', 0.0217, 'lps'),
	(407012, 125, '2015-02-15 00:00:05.000000', 'consum', 0.0223, 'lps'),
	(407013, 125, '2015-02-15 00:00:06.000000', 'consum', 0.0220, 'lps'),
	(407014, 125, '2015-02-15 00:00:07.000000', 'consum', 0.0223, 'lps'),
	(407015, 125, '2015-02-15 00:00:08.000000', 'consum', 0.0210, 'lps'),
	(407016, 125, '2015-02-15 00:00:09.000000', 'consum', 0.0222, 'lps'),
	(407017, 125, '2015-02-15 00:00:10.000000', 'consum', 0.0222, 'lps'),
	(407018, 125, '2015-02-15 00:00:11.000000', 'consum', 0.0215, 'lps'),
	(407019, 125, '2015-02-15 00:00:12.000000', 'consum', 0.0218, 'lps'),
	(407020, 125, '2015-02-15 00:00:13.000000', 'consum', 0.0220, 'lps'),
	(407021, 125, '2015-02-15 00:00:14.000000', 'consum', 0.0216, 'lps'),
	(407022, 125, '2015-02-15 00:00:15.000000', 'consum', 0.0213, 'lps'),
	(407023, 125, '2015-02-15 00:00:16.000000', 'consum', 0.0225, 'lps'),
	(407024, 125, '2015-02-15 00:00:17.000000', 'consum', 0.0223, 'lps'),
	(407025, 125, '2015-02-15 00:00:18.000000', 'consum', 0.0214, 'lps'),
	(407026, 125, '2015-02-15 00:00:19.000000', 'consum', 0.0225, 'lps'),
	(407027, 125, '2015-02-15 00:00:20.000000', 'consum', 0.0222, 'lps'),
	(407028, 125, '2015-02-15 00:00:21.000000', 'consum', 0.0225, 'lps'),
	(407029, 125, '2015-02-15 00:00:22.000000', 'consum', 0.0215, 'lps'),
	(407030, 125, '2015-02-15 00:00:23.000000', 'consum', 0.0211, 'lps'),
	(407031, 125, '2015-02-15 00:00:24.000000', 'consum', 0.0214, 'lps'),
	(407032, 125, '2015-02-15 00:00:25.000000', 'consum', 0.0211, 'lps'),
	(407033, 125, '2015-02-15 00:00:26.000000', 'consum', 0.0220, 'lps'),
	(407034, 125, '2015-02-15 00:00:27.000000', 'consum', 0.0225, 'lps'),
	(407035, 125, '2015-02-15 00:00:28.000000', 'consum', 0.0220, 'lps'),
	(407036, 125, '2015-02-15 00:00:29.000000', 'consum', 0.0216, 'lps'),
	(407037, 125, '2015-02-15 00:00:30.000000', 'consum', 0.0212, 'lps'),
	(407038, 125, '2015-02-15 00:00:31.000000', 'consum', 0.0218, 'lps'),
	(407039, 125, '2015-02-15 00:00:32.000000', 'consum', 0.0212, 'lps'),
	(407040, 125, '2015-02-15 00:00:33.000000', 'consum', 0.0211, 'lps'),
	(407041, 125, '2015-02-15 00:00:34.000000', 'consum', 0.0210, 'lps'),
	(407042, 125, '2015-02-15 00:00:35.000000', 'consum', 0.0225, 'lps'),
	(407043, 125, '2015-02-15 00:00:36.000000', 'consum', 0.0217, 'lps'),
	(407044, 125, '2015-02-15 00:00:37.000000', 'consum', 0.0218, 'lps'),
	(407045, 125, '2015-02-15 00:00:38.000000', 'consum', 0.0211, 'lps'),
	(407046, 125, '2015-02-15 00:00:39.000000', 'consum', 0.0211, 'lps'),
	(407047, 125, '2015-02-15 00:00:40.000000', 'consum', 0.0211, 'lps'),
	(407048, 125, '2015-02-15 00:00:41.000000', 'consum', 0.0213, 'lps'),
	(407049, 125, '2015-02-15 00:00:42.000000', 'consum', 0.0224, 'lps'),
	(407050, 125, '2015-02-15 00:00:43.000000', 'consum', 0.0220, 'lps'),
	(407051, 125, '2015-02-15 00:00:44.000000', 'consum', 0.0218, 'lps'),
	(407052, 125, '2015-02-15 00:00:45.000000', 'consum', 0.0220, 'lps'),
	(407053, 125, '2015-02-15 00:00:46.000000', 'consum', 0.0219, 'lps'),
	(407054, 125, '2015-02-15 00:00:47.000000', 'consum', 0.0210, 'lps'),
	(407055, 125, '2015-02-15 00:00:48.000000', 'consum', 0.0218, 'lps'),
	(407056, 125, '2015-02-15 00:00:49.000000', 'consum', 0.0215, 'lps'),
	(407057, 125, '2015-02-15 00:00:50.000000', 'consum', 0.0214, 'lps'),
	(407058, 125, '2015-02-15 00:00:51.000000', 'consum', 0.0212, 'lps'),
	(407059, 125, '2015-02-15 00:00:52.000000', 'consum', 0.0211, 'lps'),
	(407060, 125, '2015-02-15 00:00:53.000000', 'consum', 0.0210, 'lps'),
	(407061, 125, '2015-02-15 00:00:54.000000', 'consum', 0.0226, 'lps'),
	(407062, 125, '2015-02-15 00:00:55.000000', 'consum', 0.0219, 'lps'),
	(407063, 125, '2015-02-15 00:00:56.000000', 'consum', 0.0225, 'lps'),
	(407064, 125, '2015-02-15 00:00:57.000000', 'consum', 0.0224, 'lps'),
	(407065, 125, '2015-02-15 00:00:58.000000', 'consum', 0.0221, 'lps'),
	(407066, 125, '2015-02-15 00:00:59.000000', 'consum', 0.0223, 'lps'),
	(407067, 125, '2015-02-15 00:01:00.000000', 'consum', 0.0223, 'lps'),
	(407068, 125, '2015-02-15 00:01:01.000000', 'consum', 0.0223, 'lps'),
	(407069, 125, '2015-02-15 00:01:02.000000', 'consum', 0.0216, 'lps'),
	(407070, 125, '2015-02-15 00:01:03.000000', 'consum', 0.0220, 'lps'),
	(407071, 125, '2015-02-15 00:01:04.000000', 'consum', 0.0211, 'lps'),
	(407072, 125, '2015-02-15 00:01:05.000000', 'consum', 0.0216, 'lps'),
	(407073, 125, '2015-02-15 00:01:06.000000', 'consum', 0.0221, 'lps'),
	(407074, 125, '2015-02-15 00:01:07.000000', 'consum', 0.0216, 'lps'),
	(407075, 125, '2015-02-15 00:01:08.000000', 'consum', 0.0223, 'lps'),
	(407076, 125, '2015-02-15 00:01:09.000000', 'consum', 0.0222, 'lps'),
	(407077, 125, '2015-02-15 00:01:10.000000', 'consum', 0.0216, 'lps'),
	(407078, 125, '2015-02-15 00:01:11.000000', 'consum', 0.0222, 'lps'),
	(407079, 125, '2015-02-15 00:01:12.000000', 'consum', 0.0216, 'lps'),
	(407080, 125, '2015-02-15 00:01:13.000000', 'consum', 0.0223, 'lps'),
	(407081, 125, '2015-02-15 00:01:14.000000', 'consum', 0.0225, 'lps'),
	(407082, 125, '2015-02-15 00:01:15.000000', 'consum', 0.0211, 'lps'),
	(407083, 125, '2015-02-15 00:01:16.000000', 'consum', 0.0222, 'lps'),
	(407084, 125, '2015-02-15 00:01:17.000000', 'consum', 0.0216, 'lps'),
	(407085, 125, '2015-02-15 00:01:18.000000', 'consum', 0.0220, 'lps'),
	(407086, 125, '2015-02-15 00:01:19.000000', 'consum', 0.0225, 'lps'),
	(407087, 125, '2015-02-15 00:01:20.000000', 'consum', 0.0224, 'lps'),
	(407088, 125, '2015-02-15 00:01:21.000000', 'consum', 0.0216, 'lps'),
	(407089, 125, '2015-02-15 00:01:22.000000', 'consum', 0.0217, 'lps'),
	(407090, 125, '2015-02-15 00:01:23.000000', 'consum', 0.0226, 'lps'),
	(407091, 125, '2015-02-15 00:01:24.000000', 'consum', 0.0220, 'lps'),
	(407092, 125, '2015-02-15 00:01:25.000000', 'consum', 0.0214, 'lps'),
	(407093, 125, '2015-02-15 00:01:26.000000', 'consum', 0.0215, 'lps'),
	(407094, 125, '2015-02-15 00:01:27.000000', 'consum', 0.0224, 'lps'),
	(407095, 125, '2015-02-15 00:01:28.000000', 'consum', 0.0213, 'lps'),
	(407096, 125, '2015-02-15 00:01:29.000000', 'consum', 0.0219, 'lps'),
	(407097, 125, '2015-02-15 00:01:30.000000', 'consum', 0.0212, 'lps'),
	(407098, 125, '2015-02-15 00:01:31.000000', 'consum', 0.0211, 'lps'),
	(407099, 125, '2015-02-15 00:01:32.000000', 'consum', 0.0225, 'lps'),
	(407100, 125, '2015-02-15 00:01:33.000000', 'consum', 0.0216, 'lps'),
	(407101, 125, '2015-02-15 00:01:34.000000', 'consum', 0.0212, 'lps'),
	(407102, 125, '2015-02-15 00:01:35.000000', 'consum', 0.0219, 'lps'),
	(407103, 125, '2015-02-15 00:01:36.000000', 'consum', 0.0214, 'lps'),
	(407104, 125, '2015-02-15 00:01:37.000000', 'consum', 0.0223, 'lps'),
	(407105, 125, '2015-02-15 00:01:38.000000', 'consum', 0.0212, 'lps'),
	(407106, 125, '2015-02-15 00:01:39.000000', 'consum', 0.0215, 'lps'),
	(407107, 125, '2015-02-15 00:01:40.000000', 'consum', 0.0213, 'lps'),
	(407108, 125, '2015-02-15 00:01:41.000000', 'consum', 0.0210, 'lps'),
	(407109, 125, '2015-02-15 00:01:42.000000', 'consum', 0.0217, 'lps'),
	(407110, 125, '2015-02-15 00:01:43.000000', 'consum', 0.0212, 'lps'),
	(407111, 125, '2015-02-15 00:01:44.000000', 'consum', 0.0217, 'lps'),
	(407112, 125, '2015-02-15 00:01:45.000000', 'consum', 0.0222, 'lps'),
	(407113, 125, '2015-02-15 00:01:46.000000', 'consum', 0.0216, 'lps'),
	(407114, 125, '2015-02-15 00:01:47.000000', 'consum', 0.0221, 'lps'),
	(407115, 125, '2015-02-15 00:01:48.000000', 'consum', 0.0215, 'lps'),
	(407116, 125, '2015-02-15 00:01:49.000000', 'consum', 0.0218, 'lps'),
	(407117, 125, '2015-02-15 00:01:50.000000', 'consum', 0.0219, 'lps'),
	(407118, 125, '2015-02-15 00:01:51.000000', 'consum', 0.0213, 'lps'),
	(407119, 125, '2015-02-15 00:01:52.000000', 'consum', 0.0215, 'lps'),
	(407120, 125, '2015-02-15 00:01:53.000000', 'consum', 0.0211, 'lps'),
	(407121, 125, '2015-02-15 00:01:54.000000', 'consum', 0.0217, 'lps'),
	(407122, 125, '2015-02-15 00:01:55.000000', 'consum', 0.0226, 'lps'),
	(407123, 125, '2015-02-15 00:01:56.000000', 'consum', 0.0220, 'lps'),
	(407124, 125, '2015-02-15 00:01:57.000000', 'consum', 0.0210, 'lps'),
	(407125, 125, '2015-02-15 00:01:58.000000', 'consum', 0.0217, 'lps'),
	(407126, 125, '2015-02-15 00:01:59.000000', 'consum', 0.0210, 'lps'),
	(407127, 125, '2015-02-15 00:02:00.000000', 'consum', 0.0222, 'lps'),
	(407128, 125, '2015-02-15 00:02:01.000000', 'consum', 0.0222, 'lps'),
	(407129, 125, '2015-02-15 00:02:02.000000', 'consum', 0.0216, 'lps'),
	(407130, 125, '2015-02-15 00:02:03.000000', 'consum', 0.0222, 'lps'),
	(407131, 125, '2015-02-15 00:02:04.000000', 'consum', 0.0219, 'lps'),
	(407132, 125, '2015-02-15 00:02:05.000000', 'consum', 0.0218, 'lps'),
	(407133, 125, '2015-02-15 00:02:06.000000', 'consum', 0.0225, 'lps'),
	(407134, 125, '2015-02-15 00:02:07.000000', 'consum', 0.0226, 'lps'),
	(407135, 125, '2015-02-15 00:02:08.000000', 'consum', 0.0210, 'lps'),
	(407136, 125, '2015-02-15 00:02:09.000000', 'consum', 0.0216, 'lps'),
	(407137, 125, '2015-02-15 00:02:10.000000', 'consum', 0.0224, 'lps'),
	(407138, 125, '2015-02-15 00:02:11.000000', 'consum', 0.0211, 'lps'),
	(407139, 125, '2015-02-15 00:02:12.000000', 'consum', 0.0226, 'lps'),
	(407140, 125, '2015-02-15 00:02:13.000000', 'consum', 0.0218, 'lps'),
	(407141, 125, '2015-02-15 00:02:14.000000', 'consum', 0.0218, 'lps'),
	(407142, 125, '2015-02-15 00:02:15.000000', 'consum', 0.0211, 'lps'),
	(407143, 125, '2015-02-15 00:02:16.000000', 'consum', 0.0224, 'lps'),
	(407144, 125, '2015-02-15 00:02:17.000000', 'consum', 0.0211, 'lps'),
	(407145, 125, '2015-02-15 00:02:18.000000', 'consum', 0.0225, 'lps'),
	(407146, 125, '2015-02-15 00:02:19.000000', 'consum', 0.0215, 'lps'),
	(407147, 125, '2015-02-15 00:02:20.000000', 'consum', 0.0223, 'lps'),
	(407148, 125, '2015-02-15 00:02:21.000000', 'consum', 0.0226, 'lps'),
	(407149, 125, '2015-02-15 00:02:22.000000', 'consum', 0.0217, 'lps'),
	(407150, 125, '2015-02-15 00:02:23.000000', 'consum', 0.0215, 'lps'),
	(407151, 125, '2015-02-15 00:02:24.000000', 'consum', 0.0217, 'lps'),
	(407152, 125, '2015-02-15 00:02:25.000000', 'consum', 0.0210, 'lps'),
	(407153, 125, '2015-02-15 00:02:26.000000', 'consum', 0.0225, 'lps'),
	(407154, 125, '2015-02-15 00:02:27.000000', 'consum', 0.0215, 'lps'),
	(407155, 125, '2015-02-15 00:02:28.000000', 'consum', 0.0211, 'lps'),
	(407156, 125, '2015-02-15 00:02:29.000000', 'consum', 0.0214, 'lps'),
	(407157, 125, '2015-02-15 00:02:30.000000', 'consum', 0.0214, 'lps'),
	(407158, 125, '2015-02-15 00:02:31.000000', 'consum', 0.0217, 'lps'),
	(407159, 125, '2015-02-15 00:02:32.000000', 'consum', 0.0216, 'lps'),
	(407160, 125, '2015-02-15 00:02:33.000000', 'consum', 0.0218, 'lps'),
	(407161, 125, '2015-02-15 00:02:34.000000', 'consum', 0.0217, 'lps'),
	(407162, 125, '2015-02-15 00:02:35.000000', 'consum', 0.0220, 'lps'),
	(407163, 125, '2015-02-15 00:02:36.000000', 'consum', 0.0224, 'lps'),
	(407164, 125, '2015-02-15 00:02:37.000000', 'consum', 0.0217, 'lps'),
	(407165, 125, '2015-02-15 00:02:38.000000', 'consum', 0.0222, 'lps'),
	(407166, 125, '2015-02-15 00:02:39.000000', 'consum', 0.0214, 'lps'),
	(407167, 125, '2015-02-15 00:02:40.000000', 'consum', 0.0211, 'lps'),
	(407168, 125, '2015-02-15 00:02:41.000000', 'consum', 0.0219, 'lps'),
	(407169, 125, '2015-02-15 00:02:42.000000', 'consum', 0.0222, 'lps'),
	(407170, 125, '2015-02-15 00:02:43.000000', 'consum', 0.0223, 'lps'),
	(407171, 125, '2015-02-15 00:02:44.000000', 'consum', 0.0226, 'lps'),
	(407172, 125, '2015-02-15 00:02:45.000000', 'consum', 0.0216, 'lps'),
	(407173, 125, '2015-02-15 00:02:46.000000', 'consum', 0.0226, 'lps'),
	(407174, 125, '2015-02-15 00:02:47.000000', 'consum', 0.0221, 'lps'),
	(407175, 125, '2015-02-15 00:02:48.000000', 'consum', 0.0220, 'lps'),
	(407176, 125, '2015-02-15 00:02:49.000000', 'consum', 0.0226, 'lps'),
	(407177, 125, '2015-02-15 00:02:50.000000', 'consum', 0.0210, 'lps'),
	(407178, 125, '2015-02-15 00:02:51.000000', 'consum', 0.0213, 'lps'),
	(407179, 125, '2015-02-15 00:02:52.000000', 'consum', 0.0226, 'lps'),
	(407180, 125, '2015-02-15 00:02:53.000000', 'consum', 0.0215, 'lps'),
	(407181, 125, '2015-02-15 00:02:54.000000', 'consum', 0.0221, 'lps'),
	(407182, 125, '2015-02-15 00:02:55.000000', 'consum', 0.0214, 'lps'),
	(407183, 125, '2015-02-15 00:02:56.000000', 'consum', 0.0217, 'lps'),
	(407184, 125, '2015-02-15 00:02:57.000000', 'consum', 0.0214, 'lps'),
	(407185, 125, '2015-02-15 00:02:58.000000', 'consum', 0.0226, 'lps'),
	(407186, 125, '2015-02-15 00:02:59.000000', 'consum', 0.0212, 'lps'),
	(407187, 125, '2015-02-15 00:03:00.000000', 'consum', 0.0224, 'lps'),
	(407188, 125, '2015-02-15 00:03:01.000000', 'consum', 0.0221, 'lps'),
	(407189, 125, '2015-02-15 00:03:02.000000', 'consum', 0.0226, 'lps'),
	(407190, 125, '2015-02-15 00:03:03.000000', 'consum', 0.0224, 'lps'),
	(407191, 125, '2015-02-15 00:03:04.000000', 'consum', 0.0216, 'lps'),
	(407192, 125, '2015-02-15 00:03:05.000000', 'consum', 0.0215, 'lps'),
	(407193, 125, '2015-02-15 00:03:06.000000', 'consum', 0.0215, 'lps'),
	(407194, 125, '2015-02-15 00:03:07.000000', 'consum', 0.0224, 'lps'),
	(407195, 125, '2015-02-15 00:03:08.000000', 'consum', 0.0213, 'lps'),
	(407196, 125, '2015-02-15 00:03:09.000000', 'consum', 0.0217, 'lps'),
	(407197, 125, '2015-02-15 00:03:10.000000', 'consum', 0.0221, 'lps'),
	(407198, 125, '2015-02-15 00:03:11.000000', 'consum', 0.0226, 'lps'),
	(407199, 125, '2015-02-15 00:03:12.000000', 'consum', 0.0224, 'lps'),
	(407200, 125, '2015-02-15 00:03:13.000000', 'consum', 0.0214, 'lps'),
	(407201, 125, '2015-02-15 00:03:14.000000', 'consum', 0.0225, 'lps'),
	(407202, 125, '2015-02-15 00:03:15.000000', 'consum', 0.0221, 'lps'),
	(407203, 125, '2015-02-15 00:03:16.000000', 'consum', 0.0220, 'lps'),
	(407204, 125, '2015-02-15 00:03:17.000000', 'consum', 0.0212, 'lps'),
	(407205, 125, '2015-02-15 00:03:18.000000', 'consum', 0.0224, 'lps'),
	(407206, 125, '2015-02-15 00:03:19.000000', 'consum', 0.0224, 'lps'),
	(407207, 125, '2015-02-15 00:03:20.000000', 'consum', 0.0222, 'lps'),
	(407208, 125, '2015-02-15 00:03:21.000000', 'consum', 0.0210, 'lps'),
	(407209, 125, '2015-02-15 00:03:22.000000', 'consum', 0.0211, 'lps'),
	(407210, 125, '2015-02-15 00:03:23.000000', 'consum', 0.0213, 'lps'),
	(407211, 125, '2015-02-15 00:03:24.000000', 'consum', 0.0224, 'lps'),
	(407212, 125, '2015-02-15 00:03:25.000000', 'consum', 0.0219, 'lps'),
	(407213, 125, '2015-02-15 00:03:26.000000', 'consum', 0.0216, 'lps'),
	(407214, 125, '2015-02-15 00:03:27.000000', 'consum', 0.0212, 'lps'),
	(407215, 125, '2015-02-15 00:03:28.000000', 'consum', 0.0222, 'lps'),
	(407216, 125, '2015-02-15 00:03:29.000000', 'consum', 0.0210, 'lps'),
	(407217, 125, '2015-02-15 00:03:30.000000', 'consum', 0.0211, 'lps'),
	(407218, 125, '2015-02-15 00:03:31.000000', 'consum', 0.0215, 'lps'),
	(407219, 125, '2015-02-15 00:03:32.000000', 'consum', 0.0216, 'lps'),
	(407220, 125, '2015-02-15 00:03:33.000000', 'consum', 0.0223, 'lps'),
	(407221, 125, '2015-02-15 00:03:34.000000', 'consum', 0.0225, 'lps'),
	(407222, 125, '2015-02-15 00:03:35.000000', 'consum', 0.0213, 'lps'),
	(407223, 125, '2015-02-15 00:03:36.000000', 'consum', 0.0214, 'lps'),
	(407224, 125, '2015-02-15 00:03:37.000000', 'consum', 0.0221, 'lps'),
	(407225, 125, '2015-02-15 00:03:38.000000', 'consum', 0.0218, 'lps'),
	(407226, 125, '2015-02-15 00:03:39.000000', 'consum', 0.0218, 'lps'),
	(407227, 125, '2015-02-15 00:03:40.000000', 'consum', 0.0210, 'lps'),
	(407228, 125, '2015-02-15 00:03:41.000000', 'consum', 0.0219, 'lps'),
	(407229, 125, '2015-02-15 00:03:42.000000', 'consum', 0.0222, 'lps'),
	(407230, 125, '2015-02-15 00:03:43.000000', 'consum', 0.0226, 'lps'),
	(407231, 125, '2015-02-15 00:03:44.000000', 'consum', 0.0222, 'lps'),
	(407232, 125, '2015-02-15 00:03:45.000000', 'consum', 0.0220, 'lps'),
	(407233, 125, '2015-02-15 00:03:46.000000', 'consum', 0.0225, 'lps'),
	(407234, 125, '2015-02-15 00:03:47.000000', 'consum', 0.0222, 'lps'),
	(407235, 125, '2015-02-15 00:03:48.000000', 'consum', 0.0225, 'lps'),
	(407236, 125, '2015-02-15 00:03:49.000000', 'consum', 0.0215, 'lps'),
	(407237, 125, '2015-02-15 00:03:50.000000', 'consum', 0.0226, 'lps'),
	(407238, 125, '2015-02-15 00:03:51.000000', 'consum', 0.0222, 'lps'),
	(407239, 125, '2015-02-15 00:03:52.000000', 'consum', 0.0226, 'lps'),
	(407240, 125, '2015-02-15 00:03:53.000000', 'consum', 0.0219, 'lps'),
	(407241, 125, '2015-02-15 00:03:54.000000', 'consum', 0.0223, 'lps'),
	(407242, 125, '2015-02-15 00:03:55.000000', 'consum', 0.0214, 'lps'),
	(407243, 125, '2015-02-15 00:03:56.000000', 'consum', 0.0210, 'lps'),
	(407244, 125, '2015-02-15 00:03:57.000000', 'consum', 0.0214, 'lps'),
	(407245, 125, '2015-02-15 00:03:58.000000', 'consum', 0.0214, 'lps'),
	(407246, 125, '2015-02-15 00:03:59.000000', 'consum', 0.0220, 'lps'),
	(407247, 125, '2015-02-15 00:04:00.000000', 'consum', 0.0214, 'lps'),
	(407248, 125, '2015-02-15 00:04:01.000000', 'consum', 0.0217, 'lps'),
	(407249, 125, '2015-02-15 00:04:02.000000', 'consum', 0.0217, 'lps'),
	(407250, 125, '2015-02-15 00:04:03.000000', 'consum', 0.0226, 'lps'),
	(407251, 125, '2015-02-15 00:04:04.000000', 'consum', 0.0215, 'lps'),
	(407252, 125, '2015-02-15 00:04:05.000000', 'consum', 0.0224, 'lps'),
	(407253, 125, '2015-02-15 00:04:06.000000', 'consum', 0.0214, 'lps'),
	(407254, 125, '2015-02-15 00:04:07.000000', 'consum', 0.0222, 'lps'),
	(407255, 125, '2015-02-15 00:04:08.000000', 'consum', 0.0225, 'lps'),
	(407256, 125, '2015-02-15 00:04:09.000000', 'consum', 0.0215, 'lps'),
	(407257, 125, '2015-02-15 00:04:10.000000', 'consum', 0.0210, 'lps'),
	(407258, 125, '2015-02-15 00:04:11.000000', 'consum', 0.0226, 'lps'),
	(407259, 125, '2015-02-15 00:04:12.000000', 'consum', 0.0224, 'lps'),
	(407260, 125, '2015-02-15 00:04:13.000000', 'consum', 0.0214, 'lps'),
	(407261, 125, '2015-02-15 00:04:14.000000', 'consum', 0.0225, 'lps'),
	(407262, 125, '2015-02-15 00:04:15.000000', 'consum', 0.0222, 'lps'),
	(407263, 125, '2015-02-15 00:04:16.000000', 'consum', 0.0225, 'lps'),
	(407264, 125, '2015-02-15 00:04:17.000000', 'consum', 0.0214, 'lps'),
	(407265, 125, '2015-02-15 00:04:18.000000', 'consum', 0.0219, 'lps'),
	(407266, 125, '2015-02-15 00:04:19.000000', 'consum', 0.0212, 'lps'),
	(407267, 125, '2015-02-15 00:04:20.000000', 'consum', 0.0211, 'lps'),
	(407268, 125, '2015-02-15 00:04:21.000000', 'consum', 0.0225, 'lps'),
	(407269, 125, '2015-02-15 00:04:22.000000', 'consum', 0.0216, 'lps'),
	(407270, 125, '2015-02-15 00:04:23.000000', 'consum', 0.0210, 'lps'),
	(407271, 125, '2015-02-15 00:04:24.000000', 'consum', 0.0226, 'lps'),
	(407272, 125, '2015-02-15 00:04:25.000000', 'consum', 0.0224, 'lps'),
	(407273, 125, '2015-02-15 00:04:26.000000', 'consum', 0.0215, 'lps'),
	(407274, 125, '2015-02-15 00:04:27.000000', 'consum', 0.0213, 'lps'),
	(407275, 125, '2015-02-15 00:04:28.000000', 'consum', 0.0224, 'lps'),
	(407276, 125, '2015-02-15 00:04:29.000000', 'consum', 0.0224, 'lps'),
	(407277, 125, '2015-02-15 00:04:30.000000', 'consum', 0.0218, 'lps'),
	(407278, 125, '2015-02-15 00:04:31.000000', 'consum', 0.0210, 'lps'),
	(407279, 125, '2015-02-15 00:04:32.000000', 'consum', 0.0222, 'lps'),
	(407280, 125, '2015-02-15 00:04:33.000000', 'consum', 0.0218, 'lps'),
	(407281, 125, '2015-02-15 00:04:34.000000', 'consum', 0.0215, 'lps'),
	(407282, 125, '2015-02-15 00:04:35.000000', 'consum', 0.0212, 'lps'),
	(407283, 125, '2015-02-15 00:04:36.000000', 'consum', 0.0220, 'lps'),
	(407284, 125, '2015-02-15 00:04:37.000000', 'consum', 0.0224, 'lps'),
	(407285, 125, '2015-02-15 00:04:38.000000', 'consum', 0.0214, 'lps'),
	(407286, 125, '2015-02-15 00:04:39.000000', 'consum', 0.0225, 'lps'),
	(407287, 125, '2015-02-15 00:04:40.000000', 'consum', 0.0221, 'lps'),
	(407288, 125, '2015-02-15 00:04:41.000000', 'consum', 0.0220, 'lps'),
	(407289, 125, '2015-02-15 00:04:42.000000', 'consum', 0.0226, 'lps'),
	(407290, 125, '2015-02-15 00:04:43.000000', 'consum', 0.0212, 'lps'),
	(407291, 125, '2015-02-15 00:04:44.000000', 'consum', 0.0224, 'lps'),
	(407292, 125, '2015-02-15 00:04:45.000000', 'consum', 0.0222, 'lps'),
	(407293, 125, '2015-02-15 00:04:46.000000', 'consum', 0.0213, 'lps'),
	(407294, 125, '2015-02-15 00:04:47.000000', 'consum', 0.0221, 'lps'),
	(407295, 125, '2015-02-15 00:04:48.000000', 'consum', 0.0223, 'lps'),
	(407296, 125, '2015-02-15 00:04:49.000000', 'consum', 0.0210, 'lps'),
	(407297, 125, '2015-02-15 00:04:50.000000', 'consum', 0.0223, 'lps'),
	(407298, 125, '2015-02-15 00:04:51.000000', 'consum', 0.0224, 'lps'),
	(407299, 125, '2015-02-15 00:04:52.000000', 'consum', 0.0226, 'lps'),
	(407300, 125, '2015-02-15 00:04:53.000000', 'consum', 0.0211, 'lps'),
	(407301, 125, '2015-02-15 00:04:54.000000', 'consum', 0.0221, 'lps'),
	(407302, 125, '2015-02-15 00:04:55.000000', 'consum', 0.0210, 'lps'),
	(407303, 125, '2015-02-15 00:04:56.000000', 'consum', 0.0213, 'lps'),
	(407304, 125, '2015-02-15 00:04:57.000000', 'consum', 0.0224, 'lps'),
	(407305, 125, '2015-02-15 00:04:58.000000', 'consum', 0.0219, 'lps'),
	(407306, 125, '2015-02-15 00:04:59.000000', 'consum', 0.0217, 'lps'),
	(407307, 125, '2015-02-15 00:05:00.000000', 'consum', 0.0217, 'lps'),
	(407308, 125, '2015-02-15 00:05:01.000000', 'consum', 0.0223, 'lps'),
	(407309, 125, '2015-02-15 00:05:02.000000', 'consum', 0.0222, 'lps'),
	(407310, 125, '2015-02-15 00:05:03.000000', 'consum', 0.0216, 'lps'),
	(407311, 125, '2015-02-15 00:05:04.000000', 'consum', 0.0221, 'lps'),
	(407312, 125, '2015-02-15 00:05:05.000000', 'consum', 0.0212, 'lps'),
	(407313, 125, '2015-02-15 00:05:06.000000', 'consum', 0.0220, 'lps'),
	(407314, 125, '2015-02-15 00:05:07.000000', 'consum', 0.0223, 'lps'),
	(407315, 125, '2015-02-15 00:05:08.000000', 'consum', 0.0210, 'lps'),
	(407316, 125, '2015-02-15 00:05:09.000000', 'consum', 0.0221, 'lps'),
	(407317, 125, '2015-02-15 00:05:10.000000', 'consum', 0.0216, 'lps'),
	(407318, 125, '2015-02-15 00:05:11.000000', 'consum', 0.0224, 'lps'),
	(407319, 125, '2015-02-15 00:05:12.000000', 'consum', 0.0211, 'lps'),
	(407320, 125, '2015-02-15 00:05:13.000000', 'consum', 0.0223, 'lps'),
	(407321, 125, '2015-02-15 00:05:14.000000', 'consum', 0.0224, 'lps'),
	(407322, 125, '2015-02-15 00:05:15.000000', 'consum', 0.0222, 'lps'),
	(407323, 125, '2015-02-15 00:05:16.000000', 'consum', 0.0212, 'lps'),
	(407324, 125, '2015-02-15 00:05:17.000000', 'consum', 0.0220, 'lps'),
	(407325, 125, '2015-02-15 00:05:18.000000', 'consum', 0.0220, 'lps'),
	(407326, 125, '2015-02-15 00:05:19.000000', 'consum', 0.0212, 'lps'),
	(407327, 125, '2015-02-15 00:05:20.000000', 'consum', 0.0225, 'lps'),
	(407328, 125, '2015-02-15 00:05:21.000000', 'consum', 0.0214, 'lps'),
	(407329, 125, '2015-02-15 00:05:22.000000', 'consum', 0.0217, 'lps'),
	(407330, 125, '2015-02-15 00:05:23.000000', 'consum', 0.0216, 'lps'),
	(407331, 125, '2015-02-15 00:05:24.000000', 'consum', 0.0220, 'lps'),
	(407332, 125, '2015-02-15 00:05:25.000000', 'consum', 0.0225, 'lps'),
	(407333, 125, '2015-02-15 00:05:26.000000', 'consum', 0.0224, 'lps'),
	(407334, 125, '2015-02-15 00:05:27.000000', 'consum', 0.0217, 'lps'),
	(407335, 125, '2015-02-15 00:05:28.000000', 'consum', 0.0219, 'lps'),
	(407336, 125, '2015-02-15 00:05:29.000000', 'consum', 0.0219, 'lps'),
	(407337, 125, '2015-02-15 00:05:30.000000', 'consum', 0.0211, 'lps'),
	(407338, 125, '2015-02-15 00:05:31.000000', 'consum', 0.0222, 'lps'),
	(407339, 125, '2015-02-15 00:05:32.000000', 'consum', 0.0219, 'lps'),
	(407340, 125, '2015-02-15 00:05:33.000000', 'consum', 0.0217, 'lps'),
	(407341, 125, '2015-02-15 00:05:34.000000', 'consum', 0.0220, 'lps'),
	(407342, 125, '2015-02-15 00:05:35.000000', 'consum', 0.0222, 'lps'),
	(407343, 125, '2015-02-15 00:05:36.000000', 'consum', 0.0225, 'lps'),
	(407344, 125, '2015-02-15 00:05:37.000000', 'consum', 0.0215, 'lps'),
	(407345, 125, '2015-02-15 00:05:38.000000', 'consum', 0.0223, 'lps'),
	(407346, 125, '2015-02-15 00:05:39.000000', 'consum', 0.0210, 'lps'),
	(407347, 125, '2015-02-15 00:05:40.000000', 'consum', 0.0221, 'lps'),
	(407348, 125, '2015-02-15 00:05:41.000000', 'consum', 0.0215, 'lps'),
	(407349, 125, '2015-02-15 00:05:42.000000', 'consum', 0.0220, 'lps'),
	(407350, 125, '2015-02-15 00:05:43.000000', 'consum', 0.0211, 'lps'),
	(407351, 125, '2015-02-15 00:05:44.000000', 'consum', 0.0220, 'lps'),
	(407352, 125, '2015-02-15 00:05:45.000000', 'consum', 0.0221, 'lps'),
	(407353, 125, '2015-02-15 00:05:46.000000', 'consum', 0.0222, 'lps'),
	(407354, 125, '2015-02-15 00:05:47.000000', 'consum', 0.0218, 'lps'),
	(407355, 125, '2015-02-15 00:05:48.000000', 'consum', 0.0214, 'lps'),
	(407356, 125, '2015-02-15 00:05:49.000000', 'consum', 0.0226, 'lps'),
	(407357, 125, '2015-02-15 00:05:50.000000', 'consum', 0.0225, 'lps'),
	(407358, 125, '2015-02-15 00:05:51.000000', 'consum', 0.0222, 'lps'),
	(407359, 125, '2015-02-15 00:05:52.000000', 'consum', 0.0226, 'lps'),
	(407360, 125, '2015-02-15 00:05:53.000000', 'consum', 0.0220, 'lps'),
	(407361, 125, '2015-02-15 00:05:54.000000', 'consum', 0.0213, 'lps'),
	(407362, 125, '2015-02-15 00:05:55.000000', 'consum', 0.0213, 'lps'),
	(407363, 125, '2015-02-15 00:05:56.000000', 'consum', 0.0214, 'lps'),
	(407364, 125, '2015-02-15 00:05:57.000000', 'consum', 0.0223, 'lps'),
	(407365, 125, '2015-02-15 00:05:58.000000', 'consum', 0.0211, 'lps'),
	(407366, 125, '2015-02-15 00:05:59.000000', 'consum', 0.0214, 'lps'),
	(407367, 125, '2015-02-15 00:06:00.000000', 'consum', 0.0224, 'lps'),
	(407368, 125, '2015-02-15 00:06:01.000000', 'consum', 0.0218, 'lps'),
	(407369, 125, '2015-02-15 00:06:02.000000', 'consum', 0.0226, 'lps'),
	(407370, 125, '2015-02-15 00:06:03.000000', 'consum', 0.0215, 'lps'),
	(407371, 125, '2015-02-15 00:06:04.000000', 'consum', 0.0223, 'lps'),
	(407372, 125, '2015-02-15 00:06:05.000000', 'consum', 0.0226, 'lps'),
	(407373, 125, '2015-02-15 00:06:06.000000', 'consum', 0.0219, 'lps'),
	(407374, 125, '2015-02-15 00:06:07.000000', 'consum', 0.0223, 'lps'),
	(407375, 125, '2015-02-15 00:06:08.000000', 'consum', 0.0215, 'lps'),
	(407376, 125, '2015-02-15 00:06:09.000000', 'consum', 0.0212, 'lps'),
	(407377, 125, '2015-02-15 00:06:10.000000', 'consum', 0.0225, 'lps'),
	(407378, 125, '2015-02-15 00:06:11.000000', 'consum', 0.0212, 'lps'),
	(407379, 125, '2015-02-15 00:06:12.000000', 'consum', 0.0224, 'lps'),
	(407380, 125, '2015-02-15 00:06:13.000000', 'consum', 0.0225, 'lps'),
	(407381, 125, '2015-02-15 00:06:14.000000', 'consum', 0.0224, 'lps'),
	(407382, 125, '2015-02-15 00:06:15.000000', 'consum', 0.0220, 'lps'),
	(407383, 125, '2015-02-15 00:06:16.000000', 'consum', 0.0218, 'lps'),
	(407384, 125, '2015-02-15 00:06:17.000000', 'consum', 0.0222, 'lps'),
	(407385, 125, '2015-02-15 00:06:18.000000', 'consum', 0.0212, 'lps'),
	(407386, 125, '2015-02-15 00:06:19.000000', 'consum', 0.0219, 'lps'),
	(407387, 125, '2015-02-15 00:06:20.000000', 'consum', 0.0217, 'lps'),
	(407388, 125, '2015-02-15 00:06:21.000000', 'consum', 0.0215, 'lps'),
	(407389, 125, '2015-02-15 00:06:22.000000', 'consum', 0.0218, 'lps'),
	(407390, 125, '2015-02-15 00:06:23.000000', 'consum', 0.0215, 'lps'),
	(407391, 125, '2015-02-15 00:06:24.000000', 'consum', 0.0214, 'lps'),
	(407392, 125, '2015-02-15 00:06:25.000000', 'consum', 0.0216, 'lps'),
	(407393, 125, '2015-02-15 00:06:26.000000', 'consum', 0.0210, 'lps'),
	(407394, 125, '2015-02-15 00:06:27.000000', 'consum', 0.0211, 'lps'),
	(407395, 125, '2015-02-15 00:06:28.000000', 'consum', 0.0216, 'lps'),
	(407396, 125, '2015-02-15 00:06:29.000000', 'consum', 0.0220, 'lps'),
	(407397, 125, '2015-02-15 00:06:30.000000', 'consum', 0.0223, 'lps'),
	(407398, 125, '2015-02-15 00:06:31.000000', 'consum', 0.0214, 'lps'),
	(407399, 125, '2015-02-15 00:06:32.000000', 'consum', 0.0225, 'lps'),
	(407400, 125, '2015-02-15 00:06:33.000000', 'consum', 0.0220, 'lps'),
	(407401, 125, '2015-02-15 00:06:34.000000', 'consum', 0.0218, 'lps'),
	(407402, 125, '2015-02-15 00:06:35.000000', 'consum', 0.0221, 'lps'),
	(407403, 125, '2015-02-15 00:06:36.000000', 'consum', 0.0224, 'lps'),
	(407404, 125, '2015-02-15 00:06:37.000000', 'consum', 0.0213, 'lps'),
	(407405, 125, '2015-02-15 00:06:38.000000', 'consum', 0.0217, 'lps'),
	(407406, 125, '2015-02-15 00:06:39.000000', 'consum', 0.0219, 'lps'),
	(407407, 125, '2015-02-15 00:06:40.000000', 'consum', 0.0218, 'lps'),
	(407408, 125, '2015-02-15 00:06:41.000000', 'consum', 0.0223, 'lps'),
	(407409, 125, '2015-02-15 00:06:42.000000', 'consum', 0.0218, 'lps'),
	(407410, 125, '2015-02-15 00:06:43.000000', 'consum', 0.0213, 'lps'),
	(407411, 125, '2015-02-15 00:06:44.000000', 'consum', 0.0216, 'lps'),
	(407412, 125, '2015-02-15 00:06:45.000000', 'consum', 0.0216, 'lps'),
	(407413, 125, '2015-02-15 00:06:46.000000', 'consum', 0.0222, 'lps'),
	(407414, 125, '2015-02-15 00:06:47.000000', 'consum', 0.0218, 'lps'),
	(407415, 125, '2015-02-15 00:06:48.000000', 'consum', 0.0213, 'lps'),
	(407416, 125, '2015-02-15 00:06:49.000000', 'consum', 0.0220, 'lps'),
	(407417, 125, '2015-02-15 00:06:50.000000', 'consum', 0.0216, 'lps'),
	(407418, 125, '2015-02-15 00:06:51.000000', 'consum', 0.0213, 'lps'),
	(407419, 125, '2015-02-15 00:06:52.000000', 'consum', 0.0225, 'lps'),
	(407420, 125, '2015-02-15 00:06:53.000000', 'consum', 0.0223, 'lps'),
	(407421, 125, '2015-02-15 00:06:54.000000', 'consum', 0.0213, 'lps'),
	(407422, 125, '2015-02-15 00:06:55.000000', 'consum', 0.0220, 'lps'),
	(407423, 125, '2015-02-15 00:06:56.000000', 'consum', 0.0220, 'lps'),
	(407424, 125, '2015-02-15 00:06:57.000000', 'consum', 0.0213, 'lps'),
	(407425, 125, '2015-02-15 00:06:58.000000', 'consum', 0.0213, 'lps'),
	(407426, 125, '2015-02-15 00:06:59.000000', 'consum', 0.0215, 'lps'),
	(407427, 125, '2015-02-15 00:07:00.000000', 'consum', 0.0226, 'lps'),
	(407428, 125, '2015-02-15 00:07:01.000000', 'consum', 0.0224, 'lps'),
	(407429, 125, '2015-02-15 00:07:02.000000', 'consum', 0.0218, 'lps'),
	(407430, 125, '2015-02-15 00:07:03.000000', 'consum', 0.0223, 'lps'),
	(407431, 125, '2015-02-15 00:07:04.000000', 'consum', 0.0217, 'lps'),
	(407432, 125, '2015-02-15 00:07:05.000000', 'consum', 0.0224, 'lps'),
	(407433, 125, '2015-02-15 00:07:06.000000', 'consum', 0.0225, 'lps'),
	(407434, 125, '2015-02-15 00:07:07.000000', 'consum', 0.0211, 'lps'),
	(407435, 125, '2015-02-15 00:07:08.000000', 'consum', 0.0222, 'lps'),
	(407436, 125, '2015-02-15 00:07:09.000000', 'consum', 0.0214, 'lps'),
	(407437, 125, '2015-02-15 00:07:10.000000', 'consum', 0.0214, 'lps'),
	(407438, 125, '2015-02-15 00:07:11.000000', 'consum', 0.0219, 'lps'),
	(407439, 125, '2015-02-15 00:07:12.000000', 'consum', 0.0226, 'lps'),
	(407440, 125, '2015-02-15 00:07:13.000000', 'consum', 0.0210, 'lps'),
	(407441, 125, '2015-02-15 00:07:14.000000', 'consum', 0.0215, 'lps'),
	(407442, 125, '2015-02-15 00:07:15.000000', 'consum', 0.0221, 'lps'),
	(407443, 125, '2015-02-15 00:07:16.000000', 'consum', 0.0213, 'lps'),
	(407444, 125, '2015-02-15 00:07:17.000000', 'consum', 0.0210, 'lps'),
	(407445, 125, '2015-02-15 00:07:18.000000', 'consum', 0.0217, 'lps'),
	(407446, 125, '2015-02-15 00:07:19.000000', 'consum', 0.0214, 'lps'),
	(407447, 125, '2015-02-15 00:07:20.000000', 'consum', 0.0210, 'lps'),
	(407448, 125, '2015-02-15 00:07:21.000000', 'consum', 0.0216, 'lps'),
	(407449, 125, '2015-02-15 00:07:22.000000', 'consum', 0.0222, 'lps'),
	(407450, 125, '2015-02-15 00:07:23.000000', 'consum', 0.0218, 'lps'),
	(407451, 125, '2015-02-15 00:07:24.000000', 'consum', 0.0216, 'lps'),
	(407452, 125, '2015-02-15 00:07:25.000000', 'consum', 0.0218, 'lps'),
	(407453, 125, '2015-02-15 00:07:26.000000', 'consum', 0.0213, 'lps'),
	(407454, 125, '2015-02-15 00:07:27.000000', 'consum', 0.0219, 'lps'),
	(407455, 125, '2015-02-15 00:07:28.000000', 'consum', 0.0212, 'lps'),
	(407456, 125, '2015-02-15 00:07:29.000000', 'consum', 0.0213, 'lps'),
	(407457, 125, '2015-02-15 00:07:30.000000', 'consum', 0.0219, 'lps'),
	(407458, 125, '2015-02-15 00:07:31.000000', 'consum', 0.0210, 'lps'),
	(407459, 125, '2015-02-15 00:07:32.000000', 'consum', 0.0218, 'lps'),
	(407460, 125, '2015-02-15 00:07:33.000000', 'consum', 0.0215, 'lps'),
	(407461, 125, '2015-02-15 00:07:34.000000', 'consum', 0.0215, 'lps'),
	(407462, 125, '2015-02-15 00:07:35.000000', 'consum', 0.0219, 'lps'),
	(407463, 125, '2015-02-15 00:07:36.000000', 'consum', 0.0225, 'lps'),
	(407464, 125, '2015-02-15 00:07:37.000000', 'consum', 0.0224, 'lps'),
	(407465, 125, '2015-02-15 00:07:38.000000', 'consum', 0.0220, 'lps'),
	(407466, 125, '2015-02-15 00:07:39.000000', 'consum', 0.0218, 'lps'),
	(407467, 125, '2015-02-15 00:07:40.000000', 'consum', 0.0221, 'lps'),
	(407468, 125, '2015-02-15 00:07:41.000000', 'consum', 0.0222, 'lps'),
	(407469, 125, '2015-02-15 00:07:42.000000', 'consum', 0.0221, 'lps'),
	(407470, 125, '2015-02-15 00:07:43.000000', 'consum', 0.0213, 'lps'),
	(407471, 125, '2015-02-15 00:07:44.000000', 'consum', 0.0224, 'lps'),
	(407472, 125, '2015-02-15 00:07:45.000000', 'consum', 0.0224, 'lps'),
	(407473, 125, '2015-02-15 00:07:46.000000', 'consum', 0.0221, 'lps'),
	(407474, 125, '2015-02-15 00:07:47.000000', 'consum', 0.0221, 'lps'),
	(407475, 125, '2015-02-15 00:07:48.000000', 'consum', 0.0217, 'lps'),
	(407476, 125, '2015-02-15 00:07:49.000000', 'consum', 0.0212, 'lps'),
	(407477, 125, '2015-02-15 00:07:50.000000', 'consum', 0.0215, 'lps'),
	(407478, 125, '2015-02-15 00:07:51.000000', 'consum', 0.0215, 'lps'),
	(407479, 125, '2015-02-15 00:07:52.000000', 'consum', 0.0221, 'lps'),
	(407480, 125, '2015-02-15 00:07:53.000000', 'consum', 0.0217, 'lps'),
	(407481, 125, '2015-02-15 00:07:54.000000', 'consum', 0.0213, 'lps'),
	(407482, 125, '2015-02-15 00:07:55.000000', 'consum', 0.0220, 'lps'),
	(407483, 125, '2015-02-15 00:07:56.000000', 'consum', 0.0218, 'lps'),
	(407484, 125, '2015-02-15 00:07:57.000000', 'consum', 0.0221, 'lps'),
	(407485, 125, '2015-02-15 00:07:58.000000', 'consum', 0.0224, 'lps'),
	(407486, 125, '2015-02-15 00:07:59.000000', 'consum', 0.0214, 'lps'),
	(407487, 125, '2015-02-15 00:08:00.000000', 'consum', 0.0223, 'lps'),
	(407488, 125, '2015-02-15 00:08:01.000000', 'consum', 0.0212, 'lps'),
	(407489, 125, '2015-02-15 00:08:02.000000', 'consum', 0.0217, 'lps'),
	(407490, 125, '2015-02-15 00:08:03.000000', 'consum', 0.0223, 'lps'),
	(407491, 125, '2015-02-15 00:08:04.000000', 'consum', 0.0220, 'lps'),
	(407492, 125, '2015-02-15 00:08:05.000000', 'consum', 0.0223, 'lps'),
	(407493, 125, '2015-02-15 00:08:06.000000', 'consum', 0.0226, 'lps'),
	(407494, 125, '2015-02-15 00:08:07.000000', 'consum', 0.0217, 'lps'),
	(407495, 125, '2015-02-15 00:08:08.000000', 'consum', 0.0217, 'lps'),
	(407496, 125, '2015-02-15 00:08:09.000000', 'consum', 0.0222, 'lps'),
	(407497, 125, '2015-02-15 00:08:10.000000', 'consum', 0.0216, 'lps'),
	(407498, 125, '2015-02-15 00:08:11.000000', 'consum', 0.0222, 'lps'),
	(407499, 125, '2015-02-15 00:08:12.000000', 'consum', 0.0218, 'lps'),
	(407500, 125, '2015-02-15 00:08:13.000000', 'consum', 0.0215, 'lps'),
	(407501, 125, '2015-02-15 00:08:14.000000', 'consum', 0.0213, 'lps'),
	(407502, 125, '2015-02-15 00:08:15.000000', 'consum', 0.0225, 'lps'),
	(407503, 125, '2015-02-15 00:08:16.000000', 'consum', 0.0210, 'lps'),
	(407504, 125, '2015-02-15 00:08:17.000000', 'consum', 0.0215, 'lps'),
	(407505, 125, '2015-02-15 00:08:18.000000', 'consum', 0.0218, 'lps'),
	(407506, 125, '2015-02-15 00:08:19.000000', 'consum', 0.0221, 'lps'),
	(407507, 125, '2015-02-15 00:08:20.000000', 'consum', 0.0222, 'lps'),
	(407508, 125, '2015-02-15 00:08:21.000000', 'consum', 0.0220, 'lps'),
	(407509, 125, '2015-02-15 00:08:22.000000', 'consum', 0.0226, 'lps'),
	(407510, 125, '2015-02-15 00:08:23.000000', 'consum', 0.0224, 'lps'),
	(407511, 125, '2015-02-15 00:08:24.000000', 'consum', 0.0219, 'lps'),
	(407512, 125, '2015-02-15 00:08:25.000000', 'consum', 0.0210, 'lps'),
	(407513, 125, '2015-02-15 00:08:26.000000', 'consum', 0.0219, 'lps'),
	(407514, 125, '2015-02-15 00:08:27.000000', 'consum', 0.0221, 'lps'),
	(407515, 125, '2015-02-15 00:08:28.000000', 'consum', 0.0224, 'lps'),
	(407516, 125, '2015-02-15 00:08:29.000000', 'consum', 0.0210, 'lps'),
	(407517, 125, '2015-02-15 00:08:30.000000', 'consum', 0.0222, 'lps'),
	(407518, 125, '2015-02-15 00:08:31.000000', 'consum', 0.0220, 'lps'),
	(407519, 125, '2015-02-15 00:08:32.000000', 'consum', 0.0223, 'lps'),
	(407520, 125, '2015-02-15 00:08:33.000000', 'consum', 0.0212, 'lps'),
	(407521, 125, '2015-02-15 00:08:34.000000', 'consum', 0.0216, 'lps'),
	(407522, 125, '2015-02-15 00:08:35.000000', 'consum', 0.0217, 'lps'),
	(407523, 125, '2015-02-15 00:08:36.000000', 'consum', 0.0226, 'lps'),
	(407524, 125, '2015-02-15 00:08:37.000000', 'consum', 0.0219, 'lps'),
	(407525, 125, '2015-02-15 00:08:38.000000', 'consum', 0.0226, 'lps'),
	(407526, 125, '2015-02-15 00:08:39.000000', 'consum', 0.0210, 'lps'),
	(407527, 125, '2015-02-15 00:08:40.000000', 'consum', 0.0215, 'lps'),
	(407528, 125, '2015-02-15 00:08:41.000000', 'consum', 0.0218, 'lps'),
	(407529, 125, '2015-02-15 00:08:42.000000', 'consum', 0.0219, 'lps'),
	(407530, 125, '2015-02-15 00:08:43.000000', 'consum', 0.0215, 'lps'),
	(407531, 125, '2015-02-15 00:08:44.000000', 'consum', 0.0223, 'lps'),
	(407532, 125, '2015-02-15 00:08:45.000000', 'consum', 0.0211, 'lps'),
	(407533, 125, '2015-02-15 00:08:46.000000', 'consum', 0.0211, 'lps'),
	(407534, 125, '2015-02-15 00:08:47.000000', 'consum', 0.0212, 'lps'),
	(407535, 125, '2015-02-15 00:08:48.000000', 'consum', 0.0216, 'lps'),
	(407536, 125, '2015-02-15 00:08:49.000000', 'consum', 0.0218, 'lps'),
	(407537, 125, '2015-02-15 00:08:50.000000', 'consum', 0.0218, 'lps'),
	(407538, 125, '2015-02-15 00:08:51.000000', 'consum', 0.0224, 'lps'),
	(407539, 125, '2015-02-15 00:08:52.000000', 'consum', 0.0222, 'lps'),
	(407540, 125, '2015-02-15 00:08:53.000000', 'consum', 0.0211, 'lps'),
	(407541, 125, '2015-02-15 00:08:54.000000', 'consum', 0.0214, 'lps'),
	(407542, 125, '2015-02-15 00:08:55.000000', 'consum', 0.0212, 'lps'),
	(407543, 125, '2015-02-15 00:08:56.000000', 'consum', 0.0224, 'lps'),
	(407544, 125, '2015-02-15 00:08:57.000000', 'consum', 0.0223, 'lps'),
	(407545, 125, '2015-02-15 00:08:58.000000', 'consum', 0.0215, 'lps'),
	(407546, 125, '2015-02-15 00:08:59.000000', 'consum', 0.0216, 'lps'),
	(407547, 125, '2015-02-15 00:09:00.000000', 'consum', 0.0225, 'lps'),
	(407548, 125, '2015-02-15 00:09:01.000000', 'consum', 0.0218, 'lps'),
	(407549, 125, '2015-02-15 00:09:02.000000', 'consum', 0.0222, 'lps'),
	(407550, 125, '2015-02-15 00:09:03.000000', 'consum', 0.0211, 'lps'),
	(407551, 125, '2015-02-15 00:09:04.000000', 'consum', 0.0216, 'lps'),
	(407552, 125, '2015-02-15 00:09:05.000000', 'consum', 0.0218, 'lps'),
	(407553, 125, '2015-02-15 00:09:06.000000', 'consum', 0.0215, 'lps'),
	(407554, 125, '2015-02-15 00:09:07.000000', 'consum', 0.0212, 'lps'),
	(407555, 125, '2015-02-15 00:09:08.000000', 'consum', 0.0223, 'lps'),
	(407556, 125, '2015-02-15 00:09:09.000000', 'consum', 0.0217, 'lps'),
	(407557, 125, '2015-02-15 00:09:10.000000', 'consum', 0.0225, 'lps'),
	(407558, 125, '2015-02-15 00:09:11.000000', 'consum', 0.0212, 'lps'),
	(407559, 125, '2015-02-15 00:09:12.000000', 'consum', 0.0212, 'lps'),
	(407560, 125, '2015-02-15 00:09:13.000000', 'consum', 0.0213, 'lps'),
	(407561, 125, '2015-02-15 00:09:14.000000', 'consum', 0.0221, 'lps'),
	(407562, 125, '2015-02-15 00:09:15.000000', 'consum', 0.0224, 'lps'),
	(407563, 125, '2015-02-15 00:09:16.000000', 'consum', 0.0210, 'lps'),
	(407564, 125, '2015-02-15 00:09:17.000000', 'consum', 0.0223, 'lps'),
	(407565, 125, '2015-02-15 00:09:18.000000', 'consum', 0.0222, 'lps'),
	(407566, 125, '2015-02-15 00:09:19.000000', 'consum', 0.0214, 'lps'),
	(407567, 125, '2015-02-15 00:09:20.000000', 'consum', 0.0214, 'lps'),
	(407568, 125, '2015-02-15 00:09:21.000000', 'consum', 0.0216, 'lps'),
	(407569, 125, '2015-02-15 00:09:22.000000', 'consum', 0.0212, 'lps'),
	(407570, 125, '2015-02-15 00:09:23.000000', 'consum', 0.0222, 'lps'),
	(407571, 125, '2015-02-15 00:09:24.000000', 'consum', 0.0212, 'lps'),
	(407572, 125, '2015-02-15 00:09:25.000000', 'consum', 0.0217, 'lps'),
	(407573, 125, '2015-02-15 00:09:26.000000', 'consum', 0.0222, 'lps'),
	(407574, 125, '2015-02-15 00:09:27.000000', 'consum', 0.0216, 'lps'),
	(407575, 125, '2015-02-15 00:09:28.000000', 'consum', 0.0220, 'lps'),
	(407576, 125, '2015-02-15 00:09:29.000000', 'consum', 0.0212, 'lps'),
	(407577, 125, '2015-02-15 00:09:30.000000', 'consum', 0.0222, 'lps'),
	(407578, 125, '2015-02-15 00:09:31.000000', 'consum', 0.0213, 'lps'),
	(407579, 125, '2015-02-15 00:09:32.000000', 'consum', 0.0226, 'lps'),
	(407580, 125, '2015-02-15 00:09:33.000000', 'consum', 0.0212, 'lps'),
	(407581, 125, '2015-02-15 00:09:34.000000', 'consum', 0.0225, 'lps'),
	(407582, 125, '2015-02-15 00:09:35.000000', 'consum', 0.0226, 'lps'),
	(407583, 125, '2015-02-15 00:09:36.000000', 'consum', 0.0214, 'lps'),
	(407584, 125, '2015-02-15 00:09:37.000000', 'consum', 0.0214, 'lps'),
	(407585, 125, '2015-02-15 00:09:38.000000', 'consum', 0.0218, 'lps'),
	(407586, 125, '2015-02-15 00:09:39.000000', 'consum', 0.0223, 'lps'),
	(407587, 125, '2015-02-15 00:09:40.000000', 'consum', 0.0219, 'lps'),
	(407588, 125, '2015-02-15 00:09:41.000000', 'consum', 0.0217, 'lps'),
	(407589, 125, '2015-02-15 00:09:42.000000', 'consum', 0.0217, 'lps'),
	(407590, 125, '2015-02-15 00:09:43.000000', 'consum', 0.0223, 'lps'),
	(407591, 125, '2015-02-15 00:09:44.000000', 'consum', 0.0221, 'lps'),
	(407592, 125, '2015-02-15 00:09:45.000000', 'consum', 0.0226, 'lps'),
	(407593, 125, '2015-02-15 00:09:46.000000', 'consum', 0.0223, 'lps'),
	(407594, 125, '2015-02-15 00:09:47.000000', 'consum', 0.0212, 'lps'),
	(407595, 125, '2015-02-15 00:09:48.000000', 'consum', 0.0217, 'lps'),
	(407596, 125, '2015-02-15 00:09:49.000000', 'consum', 0.0221, 'lps'),
	(407597, 125, '2015-02-15 00:09:50.000000', 'consum', 0.0211, 'lps'),
	(407598, 125, '2015-02-15 00:09:51.000000', 'consum', 0.0216, 'lps'),
	(407599, 125, '2015-02-15 00:09:52.000000', 'consum', 0.0221, 'lps'),
	(407600, 125, '2015-02-15 00:09:53.000000', 'consum', 0.0212, 'lps'),
	(407601, 125, '2015-02-15 00:09:54.000000', 'consum', 0.0222, 'lps'),
	(407602, 125, '2015-02-15 00:09:55.000000', 'consum', 0.0212, 'lps'),
	(407603, 125, '2015-02-15 00:09:56.000000', 'consum', 0.0220, 'lps'),
	(407604, 125, '2015-02-15 00:09:57.000000', 'consum', 0.0222, 'lps'),
	(407605, 125, '2015-02-15 00:09:58.000000', 'consum', 0.0222, 'lps'),
	(407606, 125, '2015-02-15 00:09:59.000000', 'consum', 0.0220, 'lps'),
	(407607, 125, '2015-02-15 00:10:00.000000', 'consum', 0.0222, 'lps'),
	(407608, 125, '2015-02-15 00:10:01.000000', 'consum', 0.0226, 'lps'),
	(407609, 125, '2015-02-15 00:10:02.000000', 'consum', 0.0218, 'lps'),
	(407610, 125, '2015-02-15 00:10:03.000000', 'consum', 0.0219, 'lps'),
	(407611, 125, '2015-02-15 00:10:04.000000', 'consum', 0.0216, 'lps'),
	(407612, 125, '2015-02-15 00:10:05.000000', 'consum', 0.0213, 'lps'),
	(407613, 125, '2015-02-15 00:10:06.000000', 'consum', 0.0226, 'lps'),
	(407614, 125, '2015-02-15 00:10:07.000000', 'consum', 0.0213, 'lps'),
	(407615, 125, '2015-02-15 00:10:08.000000', 'consum', 0.0226, 'lps'),
	(407616, 125, '2015-02-15 00:10:09.000000', 'consum', 0.0217, 'lps'),
	(407617, 125, '2015-02-15 00:10:10.000000', 'consum', 0.0214, 'lps'),
	(407618, 125, '2015-02-15 00:10:11.000000', 'consum', 0.0224, 'lps'),
	(407619, 125, '2015-02-15 00:10:12.000000', 'consum', 0.0219, 'lps'),
	(407620, 125, '2015-02-15 00:10:13.000000', 'consum', 0.0215, 'lps'),
	(407621, 125, '2015-02-15 00:10:14.000000', 'consum', 0.0226, 'lps'),
	(407622, 125, '2015-02-15 00:10:15.000000', 'consum', 0.0224, 'lps'),
	(407623, 125, '2015-02-15 00:10:16.000000', 'consum', 0.0214, 'lps'),
	(407624, 125, '2015-02-15 00:10:17.000000', 'consum', 0.0222, 'lps'),
	(407625, 125, '2015-02-15 00:10:18.000000', 'consum', 0.0226, 'lps'),
	(407626, 125, '2015-02-15 00:10:19.000000', 'consum', 0.0218, 'lps'),
	(407627, 125, '2015-02-15 00:10:20.000000', 'consum', 0.0222, 'lps'),
	(407628, 125, '2015-02-15 00:10:21.000000', 'consum', 0.0210, 'lps'),
	(407629, 125, '2015-02-15 00:10:22.000000', 'consum', 0.0210, 'lps'),
	(407630, 125, '2015-02-15 00:10:23.000000', 'consum', 0.0210, 'lps'),
	(407631, 125, '2015-02-15 00:10:24.000000', 'consum', 0.0210, 'lps'),
	(407632, 125, '2015-02-15 00:10:25.000000', 'consum', 0.0213, 'lps'),
	(407633, 125, '2015-02-15 00:10:26.000000', 'consum', 0.0222, 'lps'),
	(407634, 125, '2015-02-15 00:10:27.000000', 'consum', 0.0213, 'lps'),
	(407635, 125, '2015-02-15 00:10:28.000000', 'consum', 0.0224, 'lps'),
	(407636, 125, '2015-02-15 00:10:29.000000', 'consum', 0.0220, 'lps'),
	(407637, 125, '2015-02-15 00:10:30.000000', 'consum', 0.0217, 'lps'),
	(407638, 125, '2015-02-15 00:10:31.000000', 'consum', 0.0218, 'lps'),
	(407639, 125, '2015-02-15 00:10:32.000000', 'consum', 0.0211, 'lps'),
	(407640, 125, '2015-02-15 00:10:33.000000', 'consum', 0.0224, 'lps'),
	(407641, 125, '2015-02-15 00:10:34.000000', 'consum', 0.0210, 'lps'),
	(407642, 125, '2015-02-15 00:10:35.000000', 'consum', 0.0222, 'lps'),
	(407643, 125, '2015-02-15 00:10:36.000000', 'consum', 0.0217, 'lps'),
	(407644, 125, '2015-02-15 00:10:37.000000', 'consum', 0.0210, 'lps'),
	(407645, 125, '2015-02-15 00:10:38.000000', 'consum', 0.0225, 'lps'),
	(407646, 125, '2015-02-15 00:10:39.000000', 'consum', 0.0215, 'lps'),
	(407647, 125, '2015-02-15 00:10:40.000000', 'consum', 0.0210, 'lps'),
	(407648, 125, '2015-02-15 00:10:41.000000', 'consum', 0.0212, 'lps'),
	(407649, 125, '2015-02-15 00:10:42.000000', 'consum', 0.0220, 'lps'),
	(407650, 125, '2015-02-15 00:10:43.000000', 'consum', 0.0221, 'lps'),
	(407651, 125, '2015-02-15 00:10:44.000000', 'consum', 0.0218, 'lps'),
	(407652, 125, '2015-02-15 00:10:45.000000', 'consum', 0.0220, 'lps'),
	(407653, 125, '2015-02-15 00:10:46.000000', 'consum', 0.0216, 'lps'),
	(407654, 125, '2015-02-15 00:10:47.000000', 'consum', 0.0211, 'lps'),
	(407655, 125, '2015-02-15 00:10:48.000000', 'consum', 0.0214, 'lps'),
	(407656, 125, '2015-02-15 00:10:49.000000', 'consum', 0.0212, 'lps'),
	(407657, 125, '2015-02-15 00:10:50.000000', 'consum', 0.0226, 'lps'),
	(407658, 125, '2015-02-15 00:10:51.000000', 'consum', 0.0214, 'lps'),
	(407659, 125, '2015-02-15 00:10:52.000000', 'consum', 0.0217, 'lps'),
	(407660, 125, '2015-02-15 00:10:53.000000', 'consum', 0.0219, 'lps'),
	(407661, 125, '2015-02-15 00:10:54.000000', 'consum', 0.0216, 'lps'),
	(407662, 125, '2015-02-15 00:10:55.000000', 'consum', 0.0214, 'lps'),
	(407663, 125, '2015-02-15 00:10:56.000000', 'consum', 0.0212, 'lps'),
	(407664, 125, '2015-02-15 00:10:57.000000', 'consum', 0.0224, 'lps'),
	(407665, 125, '2015-02-15 00:10:58.000000', 'consum', 0.0224, 'lps'),
	(407666, 125, '2015-02-15 00:10:59.000000', 'consum', 0.0224, 'lps'),
	(407667, 125, '2015-02-15 00:11:00.000000', 'consum', 0.0218, 'lps'),
	(407668, 125, '2015-02-15 00:11:01.000000', 'consum', 0.0211, 'lps'),
	(407669, 125, '2015-02-15 00:11:02.000000', 'consum', 0.0223, 'lps'),
	(407670, 125, '2015-02-15 00:11:03.000000', 'consum', 0.0222, 'lps'),
	(407671, 125, '2015-02-15 00:11:04.000000', 'consum', 0.0216, 'lps'),
	(407672, 125, '2015-02-15 00:11:05.000000', 'consum', 0.0222, 'lps'),
	(407673, 125, '2015-02-15 00:11:06.000000', 'consum', 0.0216, 'lps'),
	(407674, 125, '2015-02-15 00:11:07.000000', 'consum', 0.0224, 'lps'),
	(407675, 125, '2015-02-15 00:11:08.000000', 'consum', 0.0210, 'lps'),
	(407676, 125, '2015-02-15 00:11:09.000000', 'consum', 0.0220, 'lps'),
	(407677, 125, '2015-02-15 00:11:10.000000', 'consum', 0.0226, 'lps'),
	(407678, 125, '2015-02-15 00:11:11.000000', 'consum', 0.0211, 'lps'),
	(407679, 125, '2015-02-15 00:11:12.000000', 'consum', 0.0216, 'lps'),
	(407680, 125, '2015-02-15 00:11:13.000000', 'consum', 0.0222, 'lps'),
	(407681, 125, '2015-02-15 00:11:14.000000', 'consum', 0.0219, 'lps'),
	(407682, 125, '2015-02-15 00:11:15.000000', 'consum', 0.0220, 'lps'),
	(407683, 125, '2015-02-15 00:11:16.000000', 'consum', 0.0217, 'lps'),
	(407684, 125, '2015-02-15 00:11:17.000000', 'consum', 0.0213, 'lps'),
	(407685, 125, '2015-02-15 00:11:18.000000', 'consum', 0.0224, 'lps'),
	(407686, 125, '2015-02-15 00:11:19.000000', 'consum', 0.0219, 'lps'),
	(407687, 125, '2015-02-15 00:11:20.000000', 'consum', 0.0212, 'lps'),
	(407688, 125, '2015-02-15 00:11:21.000000', 'consum', 0.0211, 'lps'),
	(407689, 125, '2015-02-15 00:11:22.000000', 'consum', 0.0210, 'lps'),
	(407690, 125, '2015-02-15 00:11:23.000000', 'consum', 0.0225, 'lps'),
	(407691, 125, '2015-02-15 00:11:24.000000', 'consum', 0.0219, 'lps'),
	(407692, 125, '2015-02-15 00:11:25.000000', 'consum', 0.0224, 'lps'),
	(407693, 125, '2015-02-15 00:11:26.000000', 'consum', 0.0222, 'lps'),
	(407694, 125, '2015-02-15 00:11:27.000000', 'consum', 0.0226, 'lps'),
	(407695, 125, '2015-02-15 00:11:28.000000', 'consum', 0.0222, 'lps'),
	(407696, 125, '2015-02-15 00:11:29.000000', 'consum', 0.0224, 'lps'),
	(407697, 125, '2015-02-15 00:11:30.000000', 'consum', 0.0210, 'lps'),
	(407698, 125, '2015-02-15 00:11:31.000000', 'consum', 0.0220, 'lps'),
	(407699, 125, '2015-02-15 00:11:32.000000', 'consum', 0.0224, 'lps'),
	(407700, 125, '2015-02-15 00:11:33.000000', 'consum', 0.0220, 'lps'),
	(407701, 125, '2015-02-15 00:11:34.000000', 'consum', 0.0216, 'lps'),
	(407702, 125, '2015-02-15 00:11:35.000000', 'consum', 0.0210, 'lps'),
	(407703, 125, '2015-02-15 00:11:36.000000', 'consum', 0.0210, 'lps'),
	(407704, 125, '2015-02-15 00:11:37.000000', 'consum', 0.0226, 'lps'),
	(407705, 125, '2015-02-15 00:11:38.000000', 'consum', 0.0225, 'lps'),
	(407706, 125, '2015-02-15 00:11:39.000000', 'consum', 0.0221, 'lps'),
	(407707, 125, '2015-02-15 00:11:40.000000', 'consum', 0.0219, 'lps'),
	(407708, 125, '2015-02-15 00:11:41.000000', 'consum', 0.0223, 'lps'),
	(407709, 125, '2015-02-15 00:11:42.000000', 'consum', 0.0215, 'lps'),
	(407710, 125, '2015-02-15 00:11:43.000000', 'consum', 0.0212, 'lps'),
	(407711, 125, '2015-02-15 00:11:44.000000', 'consum', 0.0224, 'lps'),
	(407712, 125, '2015-02-15 00:11:45.000000', 'consum', 0.0224, 'lps'),
	(407713, 125, '2015-02-15 00:11:46.000000', 'consum', 0.0223, 'lps'),
	(407714, 125, '2015-02-15 00:11:47.000000', 'consum', 0.0214, 'lps'),
	(407715, 125, '2015-02-15 00:11:48.000000', 'consum', 0.0210, 'lps'),
	(407716, 125, '2015-02-15 00:11:49.000000', 'consum', 0.0215, 'lps'),
	(407717, 125, '2015-02-15 00:11:50.000000', 'consum', 0.0220, 'lps'),
	(407718, 125, '2015-02-15 00:11:51.000000', 'consum', 0.0226, 'lps'),
	(407719, 125, '2015-02-15 00:11:52.000000', 'consum', 0.0212, 'lps'),
	(407720, 125, '2015-02-15 00:11:53.000000', 'consum', 0.0221, 'lps'),
	(407721, 125, '2015-02-15 00:11:54.000000', 'consum', 0.0210, 'lps'),
	(407722, 125, '2015-02-15 00:11:55.000000', 'consum', 0.0213, 'lps'),
	(407723, 125, '2015-02-15 00:11:56.000000', 'consum', 0.0224, 'lps'),
	(407724, 125, '2015-02-15 00:11:57.000000', 'consum', 0.0223, 'lps'),
	(407725, 125, '2015-02-15 00:11:58.000000', 'consum', 0.0213, 'lps'),
	(407726, 125, '2015-02-15 00:11:59.000000', 'consum', 0.0221, 'lps'),
	(407727, 125, '2015-02-15 00:12:00.000000', 'consum', 0.0222, 'lps'),
	(407728, 125, '2015-02-15 00:12:01.000000', 'consum', 0.0221, 'lps'),
	(407729, 125, '2015-02-15 00:12:02.000000', 'consum', 0.0215, 'lps'),
	(407730, 125, '2015-02-15 00:12:03.000000', 'consum', 0.0216, 'lps'),
	(407731, 125, '2015-02-15 00:12:04.000000', 'consum', 0.0210, 'lps'),
	(407732, 125, '2015-02-15 00:12:05.000000', 'consum', 0.0226, 'lps'),
	(407733, 125, '2015-02-15 00:12:06.000000', 'consum', 0.0221, 'lps'),
	(407734, 125, '2015-02-15 00:12:07.000000', 'consum', 0.0220, 'lps'),
	(407735, 125, '2015-02-15 00:12:08.000000', 'consum', 0.0226, 'lps'),
	(407736, 125, '2015-02-15 00:12:09.000000', 'consum', 0.0210, 'lps'),
	(407737, 125, '2015-02-15 00:12:10.000000', 'consum', 0.0214, 'lps'),
	(407738, 125, '2015-02-15 00:12:11.000000', 'consum', 0.0212, 'lps'),
	(407739, 125, '2015-02-15 00:12:12.000000', 'consum', 0.0210, 'lps'),
	(407740, 125, '2015-02-15 00:12:13.000000', 'consum', 0.0222, 'lps'),
	(407741, 125, '2015-02-15 00:12:14.000000', 'consum', 0.0220, 'lps'),
	(407742, 125, '2015-02-15 00:12:15.000000', 'consum', 0.0222, 'lps'),
	(407743, 125, '2015-02-15 00:12:16.000000', 'consum', 0.0224, 'lps'),
	(407744, 125, '2015-02-15 00:12:17.000000', 'consum', 0.0210, 'lps'),
	(407745, 125, '2015-02-15 00:12:18.000000', 'consum', 0.0218, 'lps'),
	(407746, 125, '2015-02-15 00:12:19.000000', 'consum', 0.0219, 'lps'),
	(407747, 125, '2015-02-15 00:12:20.000000', 'consum', 0.0216, 'lps'),
	(407748, 125, '2015-02-15 00:12:21.000000', 'consum', 0.0211, 'lps'),
	(407749, 125, '2015-02-15 00:12:22.000000', 'consum', 0.0216, 'lps'),
	(407750, 125, '2015-02-15 00:12:23.000000', 'consum', 0.0218, 'lps'),
	(407751, 125, '2015-02-15 00:12:24.000000', 'consum', 0.0218, 'lps'),
	(407752, 125, '2015-02-15 00:12:25.000000', 'consum', 0.0224, 'lps'),
	(407753, 125, '2015-02-15 00:12:26.000000', 'consum', 0.0223, 'lps'),
	(407754, 125, '2015-02-15 00:12:27.000000', 'consum', 0.0219, 'lps'),
	(407755, 125, '2015-02-15 00:12:28.000000', 'consum', 0.0213, 'lps'),
	(407756, 125, '2015-02-15 00:12:29.000000', 'consum', 0.0218, 'lps'),
	(407757, 125, '2015-02-15 00:12:30.000000', 'consum', 0.0223, 'lps'),
	(407758, 125, '2015-02-15 00:12:31.000000', 'consum', 0.0219, 'lps'),
	(407759, 125, '2015-02-15 00:12:32.000000', 'consum', 0.0217, 'lps'),
	(407760, 125, '2015-02-15 00:12:33.000000', 'consum', 0.0217, 'lps'),
	(407761, 125, '2015-02-15 00:12:34.000000', 'consum', 0.0210, 'lps'),
	(407762, 125, '2015-02-15 00:12:35.000000', 'consum', 0.0222, 'lps'),
	(407763, 125, '2015-02-15 00:12:36.000000', 'consum', 0.0220, 'lps'),
	(407764, 125, '2015-02-15 00:12:37.000000', 'consum', 0.0223, 'lps'),
	(407765, 125, '2015-02-15 00:12:38.000000', 'consum', 0.0211, 'lps'),
	(407766, 125, '2015-02-15 00:12:39.000000', 'consum', 0.0213, 'lps'),
	(407767, 125, '2015-02-15 00:12:40.000000', 'consum', 0.0220, 'lps'),
	(407768, 125, '2015-02-15 00:12:41.000000', 'consum', 0.0218, 'lps'),
	(407769, 125, '2015-02-15 00:12:42.000000', 'consum', 0.0222, 'lps'),
	(407770, 125, '2015-02-15 00:12:43.000000', 'consum', 0.0210, 'lps'),
	(407771, 125, '2015-02-15 00:12:44.000000', 'consum', 0.0226, 'lps'),
	(407772, 125, '2015-02-15 00:12:45.000000', 'consum', 0.0223, 'lps'),
	(407773, 125, '2015-02-15 00:12:46.000000', 'consum', 0.0210, 'lps'),
	(407774, 125, '2015-02-15 00:12:47.000000', 'consum', 0.0222, 'lps'),
	(407775, 125, '2015-02-15 00:12:48.000000', 'consum', 0.0222, 'lps'),
	(407776, 125, '2015-02-15 00:12:49.000000', 'consum', 0.0215, 'lps'),
	(407777, 125, '2015-02-15 00:12:50.000000', 'consum', 0.0219, 'lps'),
	(407778, 125, '2015-02-15 00:12:51.000000', 'consum', 0.0222, 'lps'),
	(407779, 125, '2015-02-15 00:12:52.000000', 'consum', 0.0226, 'lps'),
	(407780, 125, '2015-02-15 00:12:53.000000', 'consum', 0.0220, 'lps'),
	(407781, 125, '2015-02-15 00:12:54.000000', 'consum', 0.0214, 'lps'),
	(407782, 125, '2015-02-15 00:12:55.000000', 'consum', 0.0215, 'lps'),
	(407783, 125, '2015-02-15 00:12:56.000000', 'consum', 0.0210, 'lps'),
	(407784, 125, '2015-02-15 00:12:57.000000', 'consum', 0.0226, 'lps'),
	(407785, 125, '2015-02-15 00:12:58.000000', 'consum', 0.0224, 'lps'),
	(407786, 125, '2015-02-15 00:12:59.000000', 'consum', 0.0217, 'lps'),
	(407787, 125, '2015-02-15 00:13:00.000000', 'consum', 0.0219, 'lps'),
	(407788, 125, '2015-02-15 00:13:01.000000', 'consum', 0.0218, 'lps'),
	(407789, 125, '2015-02-15 00:13:02.000000', 'consum', 0.0224, 'lps'),
	(407790, 125, '2015-02-15 00:13:03.000000', 'consum', 0.0223, 'lps'),
	(407791, 125, '2015-02-15 00:13:04.000000', 'consum', 0.0215, 'lps'),
	(407792, 125, '2015-02-15 00:13:05.000000', 'consum', 0.0215, 'lps'),
	(407793, 125, '2015-02-15 00:13:06.000000', 'consum', 0.0220, 'lps'),
	(407794, 125, '2015-02-15 00:13:07.000000', 'consum', 0.0212, 'lps'),
	(407795, 125, '2015-02-15 00:13:08.000000', 'consum', 0.0225, 'lps'),
	(407796, 125, '2015-02-15 00:13:09.000000', 'consum', 0.0212, 'lps'),
	(407797, 125, '2015-02-15 00:13:10.000000', 'consum', 0.0210, 'lps'),
	(407798, 125, '2015-02-15 00:13:11.000000', 'consum', 0.0221, 'lps'),
	(407799, 125, '2015-02-15 00:13:12.000000', 'consum', 0.0213, 'lps'),
	(407800, 125, '2015-02-15 00:13:13.000000', 'consum', 0.0211, 'lps'),
	(407801, 125, '2015-02-15 00:13:14.000000', 'consum', 0.0225, 'lps'),
	(407802, 125, '2015-02-15 00:13:15.000000', 'consum', 0.0212, 'lps'),
	(407803, 125, '2015-02-15 00:13:16.000000', 'consum', 0.0212, 'lps'),
	(407804, 125, '2015-02-15 00:13:17.000000', 'consum', 0.0214, 'lps'),
	(407805, 125, '2015-02-15 00:13:18.000000', 'consum', 0.0222, 'lps'),
	(407806, 125, '2015-02-15 00:13:19.000000', 'consum', 0.0211, 'lps'),
	(407807, 125, '2015-02-15 00:13:20.000000', 'consum', 0.0212, 'lps'),
	(407808, 125, '2015-02-15 00:13:21.000000', 'consum', 0.0218, 'lps'),
	(407809, 125, '2015-02-15 00:13:22.000000', 'consum', 0.0212, 'lps'),
	(407810, 125, '2015-02-15 00:13:23.000000', 'consum', 0.0210, 'lps'),
	(407811, 125, '2015-02-15 00:13:24.000000', 'consum', 0.0225, 'lps'),
	(407812, 125, '2015-02-15 00:13:25.000000', 'consum', 0.0215, 'lps'),
	(407813, 125, '2015-02-15 00:13:26.000000', 'consum', 0.0225, 'lps'),
	(407814, 125, '2015-02-15 00:13:27.000000', 'consum', 0.0218, 'lps'),
	(407815, 125, '2015-02-15 00:13:28.000000', 'consum', 0.0223, 'lps'),
	(407816, 125, '2015-02-15 00:13:29.000000', 'consum', 0.0218, 'lps'),
	(407817, 125, '2015-02-15 00:13:30.000000', 'consum', 0.0213, 'lps'),
	(407818, 125, '2015-02-15 00:13:31.000000', 'consum', 0.0215, 'lps'),
	(407819, 125, '2015-02-15 00:13:32.000000', 'consum', 0.0213, 'lps'),
	(407820, 125, '2015-02-15 00:13:33.000000', 'consum', 0.0210, 'lps'),
	(407821, 125, '2015-02-15 00:13:34.000000', 'consum', 0.0217, 'lps'),
	(407822, 125, '2015-02-15 00:13:35.000000', 'consum', 0.0210, 'lps'),
	(407823, 125, '2015-02-15 00:13:36.000000', 'consum', 0.0225, 'lps'),
	(407824, 125, '2015-02-15 00:13:37.000000', 'consum', 0.0219, 'lps'),
	(407825, 125, '2015-02-15 00:13:38.000000', 'consum', 0.0210, 'lps'),
	(407826, 125, '2015-02-15 00:13:39.000000', 'consum', 0.0218, 'lps'),
	(407827, 125, '2015-02-15 00:13:40.000000', 'consum', 0.0216, 'lps'),
	(407828, 125, '2015-02-15 00:13:41.000000', 'consum', 0.0216, 'lps'),
	(407829, 125, '2015-02-15 00:13:42.000000', 'consum', 0.0222, 'lps'),
	(407830, 125, '2015-02-15 00:13:43.000000', 'consum', 0.0218, 'lps'),
	(407831, 125, '2015-02-15 00:13:44.000000', 'consum', 0.0217, 'lps'),
	(407832, 125, '2015-02-15 00:13:45.000000', 'consum', 0.0219, 'lps'),
	(407833, 125, '2015-02-15 00:13:46.000000', 'consum', 0.0216, 'lps'),
	(407834, 125, '2015-02-15 00:13:47.000000', 'consum', 0.0216, 'lps'),
	(407835, 125, '2015-02-15 00:13:48.000000', 'consum', 0.0223, 'lps'),
	(407836, 125, '2015-02-15 00:13:49.000000', 'consum', 0.0223, 'lps'),
	(407837, 125, '2015-02-15 00:13:50.000000', 'consum', 0.0218, 'lps'),
	(407838, 125, '2015-02-15 00:13:51.000000', 'consum', 0.0212, 'lps'),
	(407839, 125, '2015-02-15 00:13:52.000000', 'consum', 0.0213, 'lps'),
	(407840, 125, '2015-02-15 00:13:53.000000', 'consum', 0.0220, 'lps'),
	(407841, 125, '2015-02-15 00:13:54.000000', 'consum', 0.0217, 'lps'),
	(407842, 125, '2015-02-15 00:13:55.000000', 'consum', 0.0214, 'lps'),
	(407843, 125, '2015-02-15 00:13:56.000000', 'consum', 0.0213, 'lps'),
	(407844, 125, '2015-02-15 00:13:57.000000', 'consum', 0.0211, 'lps'),
	(407845, 125, '2015-02-15 00:13:58.000000', 'consum', 0.0224, 'lps'),
	(407846, 125, '2015-02-15 00:13:59.000000', 'consum', 0.0226, 'lps'),
	(407847, 125, '2015-02-15 00:14:00.000000', 'consum', 0.0214, 'lps'),
	(407848, 125, '2015-02-15 00:14:01.000000', 'consum', 0.0215, 'lps'),
	(407849, 125, '2015-02-15 00:14:02.000000', 'consum', 0.0225, 'lps'),
	(407850, 125, '2015-02-15 00:14:03.000000', 'consum', 0.0220, 'lps'),
	(407851, 125, '2015-02-15 00:14:04.000000', 'consum', 0.0217, 'lps'),
	(407852, 125, '2015-02-15 00:14:05.000000', 'consum', 0.0214, 'lps'),
	(407853, 125, '2015-02-15 00:14:06.000000', 'consum', 0.0226, 'lps'),
	(407854, 125, '2015-02-15 00:14:07.000000', 'consum', 0.0211, 'lps'),
	(407855, 125, '2015-02-15 00:14:08.000000', 'consum', 0.0219, 'lps'),
	(407856, 125, '2015-02-15 00:14:09.000000', 'consum', 0.0216, 'lps'),
	(407857, 125, '2015-02-15 00:14:10.000000', 'consum', 0.0216, 'lps'),
	(407858, 125, '2015-02-15 00:14:11.000000', 'consum', 0.0224, 'lps'),
	(407859, 125, '2015-02-15 00:14:12.000000', 'consum', 0.0210, 'lps'),
	(407860, 125, '2015-02-15 00:14:13.000000', 'consum', 0.0218, 'lps'),
	(407861, 125, '2015-02-15 00:14:14.000000', 'consum', 0.0219, 'lps'),
	(407862, 125, '2015-02-15 00:14:15.000000', 'consum', 0.0211, 'lps'),
	(407863, 125, '2015-02-15 00:14:16.000000', 'consum', 0.0226, 'lps'),
	(407864, 125, '2015-02-15 00:14:17.000000', 'consum', 0.0220, 'lps'),
	(407865, 125, '2015-02-15 00:14:18.000000', 'consum', 0.0210, 'lps'),
	(407866, 125, '2015-02-15 00:14:19.000000', 'consum', 0.0214, 'lps'),
	(407867, 125, '2015-02-15 00:14:20.000000', 'consum', 0.0216, 'lps'),
	(407868, 125, '2015-02-15 00:14:21.000000', 'consum', 0.0210, 'lps'),
	(407869, 125, '2015-02-15 00:14:22.000000', 'consum', 0.0212, 'lps'),
	(407870, 125, '2015-02-15 00:14:23.000000', 'consum', 0.0218, 'lps'),
	(407871, 125, '2015-02-15 00:14:24.000000', 'consum', 0.0213, 'lps'),
	(407872, 125, '2015-02-15 00:14:25.000000', 'consum', 0.0216, 'lps'),
	(407873, 125, '2015-02-15 00:14:26.000000', 'consum', 0.0215, 'lps'),
	(407874, 125, '2015-02-15 00:14:27.000000', 'consum', 0.0216, 'lps'),
	(407875, 125, '2015-02-15 00:14:28.000000', 'consum', 0.0211, 'lps'),
	(407876, 125, '2015-02-15 00:14:29.000000', 'consum', 0.0212, 'lps'),
	(407877, 125, '2015-02-15 00:14:30.000000', 'consum', 0.0219, 'lps'),
	(407878, 125, '2015-02-15 00:14:31.000000', 'consum', 0.0215, 'lps'),
	(407879, 125, '2015-02-15 00:14:32.000000', 'consum', 0.0226, 'lps'),
	(407880, 125, '2015-02-15 00:14:33.000000', 'consum', 0.0225, 'lps'),
	(407881, 125, '2015-02-15 00:14:34.000000', 'consum', 0.0220, 'lps'),
	(407882, 125, '2015-02-15 00:14:35.000000', 'consum', 0.0213, 'lps'),
	(407883, 125, '2015-02-15 00:14:36.000000', 'consum', 0.0216, 'lps'),
	(407884, 125, '2015-02-15 00:14:37.000000', 'consum', 0.0215, 'lps'),
	(407885, 125, '2015-02-15 00:14:38.000000', 'consum', 0.0216, 'lps'),
	(407886, 125, '2015-02-15 00:14:39.000000', 'consum', 0.0224, 'lps'),
	(407887, 125, '2015-02-15 00:14:40.000000', 'consum', 0.0213, 'lps'),
	(407888, 125, '2015-02-15 00:14:41.000000', 'consum', 0.0216, 'lps'),
	(407889, 125, '2015-02-15 00:14:42.000000', 'consum', 0.0215, 'lps'),
	(407890, 125, '2015-02-15 00:14:43.000000', 'consum', 0.0219, 'lps'),
	(407891, 125, '2015-02-15 00:14:44.000000', 'consum', 0.0224, 'lps'),
	(407892, 125, '2015-02-15 00:14:45.000000', 'consum', 0.0220, 'lps'),
	(407893, 125, '2015-02-15 00:14:46.000000', 'consum', 0.0219, 'lps'),
	(407894, 125, '2015-02-15 00:14:47.000000', 'consum', 0.0223, 'lps'),
	(407895, 125, '2015-02-15 00:14:48.000000', 'consum', 0.0217, 'lps'),
	(407896, 125, '2015-02-15 00:14:49.000000', 'consum', 0.0224, 'lps'),
	(407897, 125, '2015-02-15 00:14:50.000000', 'consum', 0.0225, 'lps'),
	(407898, 125, '2015-02-15 00:14:51.000000', 'consum', 0.0226, 'lps'),
	(407899, 125, '2015-02-15 00:14:52.000000', 'consum', 0.0212, 'lps'),
	(407900, 125, '2015-02-15 00:14:53.000000', 'consum', 0.0224, 'lps'),
	(407901, 125, '2015-02-15 00:14:54.000000', 'consum', 0.0224, 'lps'),
	(407902, 125, '2015-02-15 00:14:55.000000', 'consum', 0.0219, 'lps'),
	(407903, 125, '2015-02-15 00:14:56.000000', 'consum', 0.0215, 'lps'),
	(407904, 125, '2015-02-15 00:14:57.000000', 'consum', 0.0226, 'lps'),
	(407905, 125, '2015-02-15 00:14:58.000000', 'consum', 0.0223, 'lps'),
	(407906, 125, '2015-02-15 00:14:59.000000', 'consum', 0.0210, 'lps'),
	(407907, 125, '2015-02-15 00:15:00.000000', 'consum', 0.0225, 'lps'),
	(407908, 125, '2015-02-15 00:15:01.000000', 'consum', 0.0215, 'lps'),
	(407909, 125, '2015-02-15 00:15:02.000000', 'consum', 0.0225, 'lps'),
	(407910, 125, '2015-02-15 00:15:03.000000', 'consum', 0.0221, 'lps'),
	(407911, 125, '2015-02-15 00:15:04.000000', 'consum', 0.0222, 'lps'),
	(407912, 125, '2015-02-15 00:15:05.000000', 'consum', 0.0217, 'lps'),
	(407913, 125, '2015-02-15 00:15:06.000000', 'consum', 0.0210, 'lps'),
	(407914, 125, '2015-02-15 00:15:07.000000', 'consum', 0.0223, 'lps'),
	(407915, 125, '2015-02-15 00:15:08.000000', 'consum', 0.0223, 'lps'),
	(407916, 125, '2015-02-15 00:15:09.000000', 'consum', 0.0223, 'lps'),
	(407917, 125, '2015-02-15 00:15:10.000000', 'consum', 0.0217, 'lps'),
	(407918, 125, '2015-02-15 00:15:11.000000', 'consum', 0.0225, 'lps'),
	(407919, 125, '2015-02-15 00:15:12.000000', 'consum', 0.0212, 'lps'),
	(407920, 125, '2015-02-15 00:15:13.000000', 'consum', 0.0212, 'lps'),
	(407921, 125, '2015-02-15 00:15:14.000000', 'consum', 0.0213, 'lps'),
	(407922, 125, '2015-02-15 00:15:15.000000', 'consum', 0.0218, 'lps'),
	(407923, 125, '2015-02-15 00:15:16.000000', 'consum', 0.0211, 'lps'),
	(407924, 125, '2015-02-15 00:15:17.000000', 'consum', 0.0222, 'lps'),
	(407925, 125, '2015-02-15 00:15:18.000000', 'consum', 0.0219, 'lps'),
	(407926, 125, '2015-02-15 00:15:19.000000', 'consum', 0.0219, 'lps'),
	(407927, 125, '2015-02-15 00:15:20.000000', 'consum', 0.0210, 'lps'),
	(407928, 125, '2015-02-15 00:15:21.000000', 'consum', 0.0218, 'lps'),
	(407929, 125, '2015-02-15 00:15:22.000000', 'consum', 0.0218, 'lps'),
	(407930, 125, '2015-02-15 00:15:23.000000', 'consum', 0.0211, 'lps'),
	(407931, 125, '2015-02-15 00:15:24.000000', 'consum', 0.0222, 'lps'),
	(407932, 125, '2015-02-15 00:15:25.000000', 'consum', 0.0218, 'lps'),
	(407933, 125, '2015-02-15 00:15:26.000000', 'consum', 0.0215, 'lps'),
	(407934, 125, '2015-02-15 00:15:27.000000', 'consum', 0.0226, 'lps'),
	(407935, 125, '2015-02-15 00:15:28.000000', 'consum', 0.0226, 'lps'),
	(407936, 125, '2015-02-15 00:15:29.000000', 'consum', 0.0224, 'lps'),
	(407937, 125, '2015-02-15 00:15:30.000000', 'consum', 0.0214, 'lps'),
	(407938, 125, '2015-02-15 00:15:31.000000', 'consum', 0.0226, 'lps'),
	(407939, 125, '2015-02-15 00:15:32.000000', 'consum', 0.0210, 'lps'),
	(407940, 125, '2015-02-15 00:15:33.000000', 'consum', 0.0214, 'lps'),
	(407941, 125, '2015-02-15 00:15:34.000000', 'consum', 0.0215, 'lps'),
	(407942, 125, '2015-02-15 00:15:35.000000', 'consum', 0.0221, 'lps'),
	(407943, 125, '2015-02-15 00:15:36.000000', 'consum', 0.0216, 'lps'),
	(407944, 125, '2015-02-15 00:15:37.000000', 'consum', 0.0223, 'lps'),
	(407945, 125, '2015-02-15 00:15:38.000000', 'consum', 0.0210, 'lps'),
	(407946, 125, '2015-02-15 00:15:39.000000', 'consum', 0.0220, 'lps'),
	(407947, 125, '2015-02-15 00:15:40.000000', 'consum', 0.0211, 'lps'),
	(407948, 125, '2015-02-15 00:15:41.000000', 'consum', 0.0218, 'lps'),
	(407949, 125, '2015-02-15 00:15:42.000000', 'consum', 0.0215, 'lps'),
	(407950, 125, '2015-02-15 00:15:43.000000', 'consum', 0.0213, 'lps'),
	(407951, 125, '2015-02-15 00:15:44.000000', 'consum', 0.0225, 'lps'),
	(407952, 125, '2015-02-15 00:15:45.000000', 'consum', 0.0226, 'lps'),
	(407953, 125, '2015-02-15 00:15:46.000000', 'consum', 0.0213, 'lps'),
	(407954, 125, '2015-02-15 00:15:47.000000', 'consum', 0.0210, 'lps'),
	(407955, 125, '2015-02-15 00:15:48.000000', 'consum', 0.0219, 'lps'),
	(407956, 125, '2015-02-15 00:15:49.000000', 'consum', 0.0223, 'lps'),
	(407957, 125, '2015-02-15 00:15:50.000000', 'consum', 0.0215, 'lps'),
	(407958, 125, '2015-02-15 00:15:51.000000', 'consum', 0.0214, 'lps'),
	(407959, 125, '2015-02-15 00:15:52.000000', 'consum', 0.0214, 'lps'),
	(407960, 125, '2015-02-15 00:15:53.000000', 'consum', 0.0217, 'lps'),
	(407961, 125, '2015-02-15 00:15:54.000000', 'consum', 0.0217, 'lps'),
	(407962, 125, '2015-02-15 00:15:55.000000', 'consum', 0.0210, 'lps'),
	(407963, 125, '2015-02-15 00:15:56.000000', 'consum', 0.0222, 'lps'),
	(407964, 125, '2015-02-15 00:15:57.000000', 'consum', 0.0221, 'lps'),
	(407965, 125, '2015-02-15 00:15:58.000000', 'consum', 0.0212, 'lps'),
	(407966, 125, '2015-02-15 00:15:59.000000', 'consum', 0.0221, 'lps'),
	(407967, 125, '2015-02-15 00:16:00.000000', 'consum', 0.0226, 'lps'),
	(407968, 125, '2015-02-15 00:16:01.000000', 'consum', 0.0225, 'lps'),
	(407969, 125, '2015-02-15 00:16:02.000000', 'consum', 0.0220, 'lps'),
	(407970, 125, '2015-02-15 00:16:03.000000', 'consum', 0.0214, 'lps'),
	(407971, 125, '2015-02-15 00:16:04.000000', 'consum', 0.0219, 'lps'),
	(407972, 125, '2015-02-15 00:16:05.000000', 'consum', 0.0210, 'lps'),
	(407973, 125, '2015-02-15 00:16:06.000000', 'consum', 0.0218, 'lps'),
	(407974, 125, '2015-02-15 00:16:07.000000', 'consum', 0.0216, 'lps'),
	(407975, 125, '2015-02-15 00:16:08.000000', 'consum', 0.0217, 'lps'),
	(407976, 125, '2015-02-15 00:16:09.000000', 'consum', 0.0210, 'lps'),
	(407977, 125, '2015-02-15 00:16:10.000000', 'consum', 0.0222, 'lps'),
	(407978, 125, '2015-02-15 00:16:11.000000', 'consum', 0.0219, 'lps'),
	(407979, 125, '2015-02-15 00:16:12.000000', 'consum', 0.0221, 'lps'),
	(407980, 125, '2015-02-15 00:16:13.000000', 'consum', 0.0221, 'lps'),
	(407981, 125, '2015-02-15 00:16:14.000000', 'consum', 0.0217, 'lps'),
	(407982, 125, '2015-02-15 00:16:15.000000', 'consum', 0.0226, 'lps'),
	(407983, 125, '2015-02-15 00:16:16.000000', 'consum', 0.0222, 'lps'),
	(407984, 125, '2015-02-15 00:16:17.000000', 'consum', 0.0223, 'lps'),
	(407985, 125, '2015-02-15 00:16:18.000000', 'consum', 0.0221, 'lps'),
	(407986, 125, '2015-02-15 00:16:19.000000', 'consum', 0.0211, 'lps'),
	(407987, 125, '2015-02-15 00:16:20.000000', 'consum', 0.0216, 'lps'),
	(407988, 125, '2015-02-15 00:16:21.000000', 'consum', 0.0219, 'lps'),
	(407989, 125, '2015-02-15 00:16:22.000000', 'consum', 0.0220, 'lps'),
	(407990, 125, '2015-02-15 00:16:23.000000', 'consum', 0.0215, 'lps'),
	(407991, 125, '2015-02-15 00:16:24.000000', 'consum', 0.0226, 'lps'),
	(407992, 125, '2015-02-15 00:16:25.000000', 'consum', 0.0221, 'lps'),
	(407993, 125, '2015-02-15 00:16:26.000000', 'consum', 0.0221, 'lps'),
	(407994, 125, '2015-02-15 00:16:27.000000', 'consum', 0.0213, 'lps'),
	(407995, 125, '2015-02-15 00:16:28.000000', 'consum', 0.0226, 'lps'),
	(407996, 125, '2015-02-15 00:16:29.000000', 'consum', 0.0215, 'lps'),
	(407997, 125, '2015-02-15 00:16:30.000000', 'consum', 0.0223, 'lps'),
	(407998, 125, '2015-02-15 00:16:31.000000', 'consum', 0.0226, 'lps'),
	(407999, 125, '2015-02-15 00:16:32.000000', 'consum', 0.0217, 'lps'),
	(408000, 125, '2015-02-15 00:16:33.000000', 'consum', 0.0217, 'lps'),
	(408001, 125, '2015-02-15 00:16:34.000000', 'consum', 0.0221, 'lps'),
	(408002, 125, '2015-02-15 00:16:35.000000', 'consum', 0.0211, 'lps'),
	(408003, 125, '2015-02-15 00:16:36.000000', 'consum', 0.0217, 'lps'),
	(408004, 125, '2015-02-15 00:16:37.000000', 'consum', 0.0225, 'lps'),
	(408005, 125, '2015-02-15 00:16:38.000000', 'consum', 0.0213, 'lps'),
	(408006, 125, '2015-02-15 00:16:39.000000', 'consum', 0.0216, 'lps'),
	(408007, 125, '2015-02-15 00:16:40.000000', 'consum', 0.0214, 'lps'),
	(408008, 125, '2015-02-15 00:16:41.000000', 'consum', 0.0211, 'lps'),
	(408009, 125, '2015-02-15 00:16:42.000000', 'consum', 0.0220, 'lps'),
	(408010, 125, '2015-02-15 00:16:43.000000', 'consum', 0.0223, 'lps'),
	(408011, 125, '2015-02-15 00:16:44.000000', 'consum', 0.0214, 'lps'),
	(408012, 125, '2015-02-15 00:16:45.000000', 'consum', 0.0223, 'lps'),
	(408013, 125, '2015-02-15 00:16:46.000000', 'consum', 0.0213, 'lps'),
	(408014, 125, '2015-02-15 00:16:47.000000', 'consum', 0.0221, 'lps'),
	(408015, 125, '2015-02-15 00:16:48.000000', 'consum', 0.0224, 'lps'),
	(408016, 125, '2015-02-15 00:16:49.000000', 'consum', 0.0213, 'lps'),
	(408017, 125, '2015-02-15 00:16:50.000000', 'consum', 0.0218, 'lps'),
	(408018, 125, '2015-02-15 00:16:51.000000', 'consum', 0.0224, 'lps'),
	(408019, 125, '2015-02-15 00:16:52.000000', 'consum', 0.0221, 'lps'),
	(408020, 125, '2015-02-15 00:16:53.000000', 'consum', 0.0222, 'lps'),
	(408021, 125, '2015-02-15 00:16:54.000000', 'consum', 0.0224, 'lps'),
	(408022, 125, '2015-02-15 00:16:55.000000', 'consum', 0.0225, 'lps'),
	(408023, 125, '2015-02-15 00:16:56.000000', 'consum', 0.0212, 'lps'),
	(408024, 125, '2015-02-15 00:16:57.000000', 'consum', 0.0224, 'lps'),
	(408025, 125, '2015-02-15 00:16:58.000000', 'consum', 0.0225, 'lps'),
	(408026, 125, '2015-02-15 00:16:59.000000', 'consum', 0.0225, 'lps'),
	(408027, 125, '2015-02-15 00:17:00.000000', 'consum', 0.0226, 'lps'),
	(408028, 125, '2015-02-15 00:17:01.000000', 'consum', 0.0212, 'lps'),
	(408029, 125, '2015-02-15 00:17:02.000000', 'consum', 0.0220, 'lps'),
	(408030, 125, '2015-02-15 00:17:03.000000', 'consum', 0.0224, 'lps'),
	(408031, 125, '2015-02-15 00:17:04.000000', 'consum', 0.0213, 'lps'),
	(408032, 125, '2015-02-15 00:17:05.000000', 'consum', 0.0220, 'lps'),
	(408033, 125, '2015-02-15 00:17:06.000000', 'consum', 0.0217, 'lps'),
	(408034, 125, '2015-02-15 00:17:07.000000', 'consum', 0.0213, 'lps'),
	(408035, 125, '2015-02-15 00:17:08.000000', 'consum', 0.0225, 'lps'),
	(408036, 125, '2015-02-15 00:17:09.000000', 'consum', 0.0224, 'lps'),
	(408037, 125, '2015-02-15 00:17:10.000000', 'consum', 0.0218, 'lps'),
	(408038, 125, '2015-02-15 00:17:11.000000', 'consum', 0.0226, 'lps'),
	(408039, 125, '2015-02-15 00:17:12.000000', 'consum', 0.0215, 'lps'),
	(408040, 125, '2015-02-15 00:17:13.000000', 'consum', 0.0223, 'lps'),
	(408041, 125, '2015-02-15 00:17:14.000000', 'consum', 0.0225, 'lps'),
	(408042, 125, '2015-02-15 00:17:15.000000', 'consum', 0.0212, 'lps'),
	(408043, 125, '2015-02-15 00:17:16.000000', 'consum', 0.0212, 'lps'),
	(408044, 125, '2015-02-15 00:17:17.000000', 'consum', 0.0214, 'lps'),
	(408045, 125, '2015-02-15 00:17:18.000000', 'consum', 0.0223, 'lps'),
	(408046, 125, '2015-02-15 00:17:19.000000', 'consum', 0.0214, 'lps'),
	(408047, 125, '2015-02-15 00:17:20.000000', 'consum', 0.0223, 'lps'),
	(408048, 125, '2015-02-15 00:17:21.000000', 'consum', 0.0213, 'lps'),
	(408049, 125, '2015-02-15 00:17:22.000000', 'consum', 0.0223, 'lps'),
	(408050, 125, '2015-02-15 00:17:23.000000', 'consum', 0.0214, 'lps'),
	(408051, 125, '2015-02-15 00:17:24.000000', 'consum', 0.0210, 'lps'),
	(408052, 125, '2015-02-15 00:17:25.000000', 'consum', 0.0214, 'lps'),
	(408053, 125, '2015-02-15 00:17:26.000000', 'consum', 0.0214, 'lps'),
	(408054, 125, '2015-02-15 00:17:27.000000', 'consum', 0.0219, 'lps'),
	(408055, 125, '2015-02-15 00:17:28.000000', 'consum', 0.0225, 'lps'),
	(408056, 125, '2015-02-15 00:17:29.000000', 'consum', 0.0226, 'lps'),
	(408057, 125, '2015-02-15 00:17:30.000000', 'consum', 0.0211, 'lps'),
	(408058, 125, '2015-02-15 00:17:31.000000', 'consum', 0.0217, 'lps'),
	(408059, 125, '2015-02-15 00:17:32.000000', 'consum', 0.0226, 'lps'),
	(408060, 125, '2015-02-15 00:17:33.000000', 'consum', 0.0219, 'lps'),
	(408061, 125, '2015-02-15 00:17:34.000000', 'consum', 0.0223, 'lps'),
	(408062, 125, '2015-02-15 00:17:35.000000', 'consum', 0.0217, 'lps'),
	(408063, 125, '2015-02-15 00:17:36.000000', 'consum', 0.0224, 'lps'),
	(408064, 125, '2015-02-15 00:17:37.000000', 'consum', 0.0225, 'lps'),
	(408065, 125, '2015-02-15 00:17:38.000000', 'consum', 0.0224, 'lps'),
	(408066, 125, '2015-02-15 00:17:39.000000', 'consum', 0.0222, 'lps'),
	(408067, 125, '2015-02-15 00:17:40.000000', 'consum', 0.0226, 'lps'),
	(408068, 125, '2015-02-15 00:17:41.000000', 'consum', 0.0220, 'lps'),
	(408069, 125, '2015-02-15 00:17:42.000000', 'consum', 0.0215, 'lps'),
	(408070, 125, '2015-02-15 00:17:43.000000', 'consum', 0.0223, 'lps'),
	(408071, 125, '2015-02-15 00:17:44.000000', 'consum', 0.0224, 'lps'),
	(408072, 125, '2015-02-15 00:17:45.000000', 'consum', 0.0226, 'lps'),
	(408073, 125, '2015-02-15 00:17:46.000000', 'consum', 0.0214, 'lps'),
	(408074, 125, '2015-02-15 00:17:47.000000', 'consum', 0.0215, 'lps'),
	(408075, 125, '2015-02-15 00:17:48.000000', 'consum', 0.0223, 'lps'),
	(408076, 125, '2015-02-15 00:17:49.000000', 'consum', 0.0210, 'lps'),
	(408077, 125, '2015-02-15 00:17:50.000000', 'consum', 0.0223, 'lps'),
	(408078, 125, '2015-02-15 00:17:51.000000', 'consum', 0.0226, 'lps'),
	(408079, 125, '2015-02-15 00:17:52.000000', 'consum', 0.0216, 'lps'),
	(408080, 125, '2015-02-15 00:17:53.000000', 'consum', 0.0210, 'lps'),
	(408081, 125, '2015-02-15 00:17:54.000000', 'consum', 0.0210, 'lps'),
	(408082, 125, '2015-02-15 00:17:55.000000', 'consum', 0.0210, 'lps'),
	(408083, 125, '2015-02-15 00:17:56.000000', 'consum', 0.0212, 'lps'),
	(408084, 125, '2015-02-15 00:17:57.000000', 'consum', 0.0220, 'lps'),
	(408085, 125, '2015-02-15 00:17:58.000000', 'consum', 0.0220, 'lps'),
	(408086, 125, '2015-02-15 00:17:59.000000', 'consum', 0.0214, 'lps'),
	(408087, 125, '2015-02-15 00:18:00.000000', 'consum', 0.0217, 'lps'),
	(408088, 125, '2015-02-15 00:18:01.000000', 'consum', 0.0218, 'lps'),
	(408089, 125, '2015-02-15 00:18:02.000000', 'consum', 0.0213, 'lps'),
	(408090, 125, '2015-02-15 00:18:03.000000', 'consum', 0.0219, 'lps'),
	(408091, 125, '2015-02-15 00:18:04.000000', 'consum', 0.0213, 'lps'),
	(408092, 125, '2015-02-15 00:18:05.000000', 'consum', 0.0214, 'lps'),
	(408093, 125, '2015-02-15 00:18:06.000000', 'consum', 0.0223, 'lps'),
	(408094, 125, '2015-02-15 00:18:07.000000', 'consum', 0.0211, 'lps'),
	(408095, 125, '2015-02-15 00:18:08.000000', 'consum', 0.0212, 'lps'),
	(408096, 125, '2015-02-15 00:18:09.000000', 'consum', 0.0218, 'lps'),
	(408097, 125, '2015-02-15 00:18:10.000000', 'consum', 0.0211, 'lps'),
	(408098, 125, '2015-02-15 00:18:11.000000', 'consum', 0.0223, 'lps'),
	(408099, 125, '2015-02-15 00:18:12.000000', 'consum', 0.0221, 'lps'),
	(408100, 125, '2015-02-15 00:18:13.000000', 'consum', 0.0212, 'lps'),
	(408101, 125, '2015-02-15 00:18:14.000000', 'consum', 0.0222, 'lps'),
	(408102, 125, '2015-02-15 00:18:15.000000', 'consum', 0.0214, 'lps'),
	(408103, 125, '2015-02-15 00:18:16.000000', 'consum', 0.0212, 'lps'),
	(408104, 125, '2015-02-15 00:18:17.000000', 'consum', 0.0225, 'lps'),
	(408105, 125, '2015-02-15 00:18:18.000000', 'consum', 0.0211, 'lps'),
	(408106, 125, '2015-02-15 00:18:19.000000', 'consum', 0.0221, 'lps'),
	(408107, 125, '2015-02-15 00:18:20.000000', 'consum', 0.0212, 'lps'),
	(408108, 125, '2015-02-15 00:18:21.000000', 'consum', 0.0223, 'lps'),
	(408109, 125, '2015-02-15 00:18:22.000000', 'consum', 0.0218, 'lps'),
	(408110, 125, '2015-02-15 00:18:23.000000', 'consum', 0.0213, 'lps'),
	(408111, 125, '2015-02-15 00:18:24.000000', 'consum', 0.0218, 'lps'),
	(408112, 125, '2015-02-15 00:18:25.000000', 'consum', 0.0224, 'lps'),
	(408113, 125, '2015-02-15 00:18:26.000000', 'consum', 0.0221, 'lps'),
	(408114, 125, '2015-02-15 00:18:27.000000', 'consum', 0.0224, 'lps'),
	(408115, 125, '2015-02-15 00:18:28.000000', 'consum', 0.0213, 'lps'),
	(408116, 125, '2015-02-15 00:18:29.000000', 'consum', 0.0218, 'lps'),
	(408117, 125, '2015-02-15 00:18:30.000000', 'consum', 0.0226, 'lps'),
	(408118, 125, '2015-02-15 00:18:31.000000', 'consum', 0.0217, 'lps'),
	(408119, 125, '2015-02-15 00:18:32.000000', 'consum', 0.0211, 'lps'),
	(408120, 125, '2015-02-15 00:18:33.000000', 'consum', 0.0212, 'lps'),
	(408121, 125, '2015-02-15 00:18:34.000000', 'consum', 0.0220, 'lps'),
	(408122, 125, '2015-02-15 00:18:35.000000', 'consum', 0.0219, 'lps'),
	(408123, 125, '2015-02-15 00:18:36.000000', 'consum', 0.0210, 'lps'),
	(408124, 125, '2015-02-15 00:18:37.000000', 'consum', 0.0216, 'lps'),
	(408125, 125, '2015-02-15 00:18:38.000000', 'consum', 0.0225, 'lps'),
	(408126, 125, '2015-02-15 00:18:39.000000', 'consum', 0.0217, 'lps'),
	(408127, 125, '2015-02-15 00:18:40.000000', 'consum', 0.0218, 'lps'),
	(408128, 125, '2015-02-15 00:18:41.000000', 'consum', 0.0211, 'lps'),
	(408129, 125, '2015-02-15 00:18:42.000000', 'consum', 0.0225, 'lps'),
	(408130, 125, '2015-02-15 00:18:43.000000', 'consum', 0.0217, 'lps'),
	(408131, 125, '2015-02-15 00:18:44.000000', 'consum', 0.0217, 'lps'),
	(408132, 125, '2015-02-15 00:18:45.000000', 'consum', 0.0225, 'lps'),
	(408133, 125, '2015-02-15 00:18:46.000000', 'consum', 0.0211, 'lps'),
	(408134, 125, '2015-02-15 00:18:47.000000', 'consum', 0.0223, 'lps'),
	(408135, 125, '2015-02-15 00:18:48.000000', 'consum', 0.0221, 'lps'),
	(408136, 125, '2015-02-15 00:18:49.000000', 'consum', 0.0210, 'lps'),
	(408137, 125, '2015-02-15 00:18:50.000000', 'consum', 0.0210, 'lps'),
	(408138, 125, '2015-02-15 00:18:51.000000', 'consum', 0.0211, 'lps'),
	(408139, 125, '2015-02-15 00:18:52.000000', 'consum', 0.0214, 'lps'),
	(408140, 125, '2015-02-15 00:18:53.000000', 'consum', 0.0210, 'lps'),
	(408141, 125, '2015-02-15 00:18:54.000000', 'consum', 0.0218, 'lps'),
	(408142, 125, '2015-02-15 00:18:55.000000', 'consum', 0.0217, 'lps'),
	(408143, 125, '2015-02-15 00:18:56.000000', 'consum', 0.0219, 'lps'),
	(408144, 125, '2015-02-15 00:18:57.000000', 'consum', 0.0217, 'lps'),
	(408145, 125, '2015-02-15 00:18:58.000000', 'consum', 0.0218, 'lps'),
	(408146, 125, '2015-02-15 00:18:59.000000', 'consum', 0.0215, 'lps'),
	(408147, 125, '2015-02-15 00:19:00.000000', 'consum', 0.0226, 'lps'),
	(408148, 125, '2015-02-15 00:19:01.000000', 'consum', 0.0210, 'lps'),
	(408149, 125, '2015-02-15 00:19:02.000000', 'consum', 0.0211, 'lps'),
	(408150, 125, '2015-02-15 00:19:03.000000', 'consum', 0.0216, 'lps'),
	(408151, 125, '2015-02-15 00:19:04.000000', 'consum', 0.0221, 'lps'),
	(408152, 125, '2015-02-15 00:19:05.000000', 'consum', 0.0215, 'lps'),
	(408153, 125, '2015-02-15 00:19:06.000000', 'consum', 0.0217, 'lps'),
	(408154, 125, '2015-02-15 00:19:07.000000', 'consum', 0.0213, 'lps'),
	(408155, 125, '2015-02-15 00:19:08.000000', 'consum', 0.0221, 'lps'),
	(408156, 125, '2015-02-15 00:19:09.000000', 'consum', 0.0224, 'lps'),
	(408157, 125, '2015-02-15 00:19:10.000000', 'consum', 0.0213, 'lps'),
	(408158, 125, '2015-02-15 00:19:11.000000', 'consum', 0.0219, 'lps'),
	(408159, 125, '2015-02-15 00:19:12.000000', 'consum', 0.0210, 'lps'),
	(408160, 125, '2015-02-15 00:19:13.000000', 'consum', 0.0219, 'lps'),
	(408161, 125, '2015-02-15 00:19:14.000000', 'consum', 0.0220, 'lps'),
	(408162, 125, '2015-02-15 00:19:15.000000', 'consum', 0.0216, 'lps'),
	(408163, 125, '2015-02-15 00:19:16.000000', 'consum', 0.0213, 'lps'),
	(408164, 125, '2015-02-15 00:19:17.000000', 'consum', 0.0222, 'lps'),
	(408165, 125, '2015-02-15 00:19:18.000000', 'consum', 0.0213, 'lps'),
	(408166, 125, '2015-02-15 00:19:19.000000', 'consum', 0.0224, 'lps'),
	(408167, 125, '2015-02-15 00:19:20.000000', 'consum', 0.0219, 'lps'),
	(408168, 125, '2015-02-15 00:19:21.000000', 'consum', 0.0216, 'lps'),
	(408169, 125, '2015-02-15 00:19:22.000000', 'consum', 0.0210, 'lps'),
	(408170, 125, '2015-02-15 00:19:23.000000', 'consum', 0.0213, 'lps'),
	(408171, 125, '2015-02-15 00:19:24.000000', 'consum', 0.0222, 'lps'),
	(408172, 125, '2015-02-15 00:19:25.000000', 'consum', 0.0211, 'lps'),
	(408173, 125, '2015-02-15 00:19:26.000000', 'consum', 0.0216, 'lps'),
	(408174, 125, '2015-02-15 00:19:27.000000', 'consum', 0.0220, 'lps'),
	(408175, 125, '2015-02-15 00:19:28.000000', 'consum', 0.0210, 'lps'),
	(408176, 125, '2015-02-15 00:19:29.000000', 'consum', 0.0211, 'lps'),
	(408177, 125, '2015-02-15 00:19:30.000000', 'consum', 0.0218, 'lps'),
	(408178, 125, '2015-02-15 00:19:31.000000', 'consum', 0.0211, 'lps'),
	(408179, 125, '2015-02-15 00:19:32.000000', 'consum', 0.0225, 'lps'),
	(408180, 125, '2015-02-15 00:19:33.000000', 'consum', 0.0216, 'lps'),
	(408181, 125, '2015-02-15 00:19:34.000000', 'consum', 0.0214, 'lps'),
	(408182, 125, '2015-02-15 00:19:35.000000', 'consum', 0.0212, 'lps'),
	(408183, 125, '2015-02-15 00:19:36.000000', 'consum', 0.0225, 'lps'),
	(408184, 125, '2015-02-15 00:19:37.000000', 'consum', 0.0213, 'lps'),
	(408185, 125, '2015-02-15 00:19:38.000000', 'consum', 0.0214, 'lps'),
	(408186, 125, '2015-02-15 00:19:39.000000', 'consum', 0.0221, 'lps'),
	(408187, 125, '2015-02-15 00:19:40.000000', 'consum', 0.0220, 'lps'),
	(408188, 125, '2015-02-15 00:19:41.000000', 'consum', 0.0212, 'lps'),
	(408189, 125, '2015-02-15 00:19:42.000000', 'consum', 0.0224, 'lps'),
	(408190, 125, '2015-02-15 00:19:43.000000', 'consum', 0.0224, 'lps'),
	(408191, 125, '2015-02-15 00:19:44.000000', 'consum', 0.0219, 'lps'),
	(408192, 125, '2015-02-15 00:19:45.000000', 'consum', 0.0217, 'lps'),
	(408193, 125, '2015-02-15 00:19:46.000000', 'consum', 0.0216, 'lps'),
	(408194, 125, '2015-02-15 00:19:47.000000', 'consum', 0.0220, 'lps'),
	(408195, 125, '2015-02-15 00:19:48.000000', 'consum', 0.0210, 'lps'),
	(408196, 125, '2015-02-15 00:19:49.000000', 'consum', 0.0215, 'lps'),
	(408197, 125, '2015-02-15 00:19:50.000000', 'consum', 0.0218, 'lps'),
	(408198, 125, '2015-02-15 00:19:51.000000', 'consum', 0.0219, 'lps'),
	(408199, 125, '2015-02-15 00:19:52.000000', 'consum', 0.0213, 'lps'),
	(408200, 125, '2015-02-15 00:19:53.000000', 'consum', 0.0215, 'lps'),
	(408201, 125, '2015-02-15 00:19:54.000000', 'consum', 0.0212, 'lps'),
	(408202, 125, '2015-02-15 00:19:55.000000', 'consum', 0.0221, 'lps'),
	(408203, 125, '2015-02-15 00:19:56.000000', 'consum', 0.0226, 'lps'),
	(408204, 125, '2015-02-15 00:19:57.000000', 'consum', 0.0224, 'lps'),
	(408205, 125, '2015-02-15 00:19:58.000000', 'consum', 0.0214, 'lps'),
	(408206, 125, '2015-02-15 00:19:59.000000', 'consum', 0.0223, 'lps'),
	(408207, 125, '2015-02-15 00:20:00.000000', 'consum', 0.0211, 'lps'),
	(408208, 125, '2015-02-15 00:20:01.000000', 'consum', 0.0210, 'lps'),
	(408209, 125, '2015-02-15 00:20:02.000000', 'consum', 0.0226, 'lps'),
	(408210, 125, '2015-02-15 00:20:03.000000', 'consum', 0.0221, 'lps'),
	(408211, 125, '2015-02-15 00:20:04.000000', 'consum', 0.0217, 'lps'),
	(408212, 125, '2015-02-15 00:20:05.000000', 'consum', 0.0212, 'lps'),
	(408213, 125, '2015-02-15 00:20:06.000000', 'consum', 0.0219, 'lps'),
	(408214, 125, '2015-02-15 00:20:07.000000', 'consum', 0.0215, 'lps'),
	(408215, 125, '2015-02-15 00:20:08.000000', 'consum', 0.0224, 'lps'),
	(408216, 125, '2015-02-15 00:20:09.000000', 'consum', 0.0213, 'lps'),
	(408217, 125, '2015-02-15 00:20:10.000000', 'consum', 0.0221, 'lps'),
	(408218, 125, '2015-02-15 00:20:11.000000', 'consum', 0.0221, 'lps'),
	(408219, 125, '2015-02-15 00:20:12.000000', 'consum', 0.0215, 'lps'),
	(408220, 125, '2015-02-15 00:20:13.000000', 'consum', 0.0221, 'lps'),
	(408221, 125, '2015-02-15 00:20:14.000000', 'consum', 0.0218, 'lps'),
	(408222, 125, '2015-02-15 00:20:15.000000', 'consum', 0.0215, 'lps'),
	(408223, 125, '2015-02-15 00:20:16.000000', 'consum', 0.0211, 'lps'),
	(408224, 125, '2015-02-15 00:20:17.000000', 'consum', 0.0217, 'lps'),
	(408225, 125, '2015-02-15 00:20:18.000000', 'consum', 0.0226, 'lps'),
	(408226, 125, '2015-02-15 00:20:19.000000', 'consum', 0.0220, 'lps'),
	(408227, 125, '2015-02-15 00:20:20.000000', 'consum', 0.0211, 'lps'),
	(408228, 125, '2015-02-15 00:20:21.000000', 'consum', 0.0219, 'lps'),
	(408229, 125, '2015-02-15 00:20:22.000000', 'consum', 0.0220, 'lps'),
	(408230, 125, '2015-02-15 00:20:23.000000', 'consum', 0.0216, 'lps'),
	(408231, 125, '2015-02-15 00:20:24.000000', 'consum', 0.0212, 'lps'),
	(408232, 125, '2015-02-15 00:20:25.000000', 'consum', 0.0218, 'lps'),
	(408233, 125, '2015-02-15 00:20:26.000000', 'consum', 0.0226, 'lps'),
	(408234, 125, '2015-02-15 00:20:27.000000', 'consum', 0.0215, 'lps'),
	(408235, 125, '2015-02-15 00:20:28.000000', 'consum', 0.0224, 'lps'),
	(408236, 125, '2015-02-15 00:20:29.000000', 'consum', 0.0213, 'lps'),
	(408237, 125, '2015-02-15 00:20:30.000000', 'consum', 0.0219, 'lps'),
	(408238, 125, '2015-02-15 00:20:31.000000', 'consum', 0.0212, 'lps'),
	(408239, 125, '2015-02-15 00:20:32.000000', 'consum', 0.0226, 'lps'),
	(408240, 125, '2015-02-15 00:20:33.000000', 'consum', 0.0218, 'lps'),
	(408241, 125, '2015-02-15 00:20:34.000000', 'consum', 0.0219, 'lps'),
	(408242, 125, '2015-02-15 00:20:35.000000', 'consum', 0.0214, 'lps'),
	(408243, 125, '2015-02-15 00:20:36.000000', 'consum', 0.0221, 'lps'),
	(408244, 125, '2015-02-15 00:20:37.000000', 'consum', 0.0219, 'lps'),
	(408245, 125, '2015-02-15 00:20:38.000000', 'consum', 0.0222, 'lps'),
	(408246, 125, '2015-02-15 00:20:39.000000', 'consum', 0.0211, 'lps'),
	(408247, 125, '2015-02-15 00:20:40.000000', 'consum', 0.0214, 'lps'),
	(408248, 125, '2015-02-15 00:20:41.000000', 'consum', 0.0211, 'lps'),
	(408249, 125, '2015-02-15 00:20:42.000000', 'consum', 0.0219, 'lps'),
	(408250, 125, '2015-02-15 00:20:43.000000', 'consum', 0.0220, 'lps'),
	(408251, 125, '2015-02-15 00:20:44.000000', 'consum', 0.0214, 'lps'),
	(408252, 125, '2015-02-15 00:20:45.000000', 'consum', 0.0219, 'lps'),
	(408253, 125, '2015-02-15 00:20:46.000000', 'consum', 0.0210, 'lps'),
	(408254, 125, '2015-02-15 00:20:47.000000', 'consum', 0.0217, 'lps'),
	(408255, 125, '2015-02-15 00:20:48.000000', 'consum', 0.0211, 'lps'),
	(408256, 125, '2015-02-15 00:20:49.000000', 'consum', 0.0210, 'lps'),
	(408257, 125, '2015-02-15 00:20:50.000000', 'consum', 0.0226, 'lps'),
	(408258, 125, '2015-02-15 00:20:51.000000', 'consum', 0.0224, 'lps'),
	(408259, 125, '2015-02-15 00:20:52.000000', 'consum', 0.0215, 'lps'),
	(408260, 125, '2015-02-15 00:20:53.000000', 'consum', 0.0211, 'lps'),
	(408261, 125, '2015-02-15 00:20:54.000000', 'consum', 0.0217, 'lps'),
	(408262, 125, '2015-02-15 00:20:55.000000', 'consum', 0.0223, 'lps'),
	(408263, 125, '2015-02-15 00:20:56.000000', 'consum', 0.0224, 'lps'),
	(408264, 125, '2015-02-15 00:20:57.000000', 'consum', 0.0224, 'lps'),
	(408265, 125, '2015-02-15 00:20:58.000000', 'consum', 0.0219, 'lps'),
	(408266, 125, '2015-02-15 00:20:59.000000', 'consum', 0.0215, 'lps'),
	(408267, 125, '2015-02-15 00:21:00.000000', 'consum', 0.0210, 'lps'),
	(408268, 125, '2015-02-15 00:21:01.000000', 'consum', 0.0213, 'lps'),
	(408269, 125, '2015-02-15 00:21:02.000000', 'consum', 0.0225, 'lps'),
	(408270, 125, '2015-02-15 00:21:03.000000', 'consum', 0.0225, 'lps'),
	(408271, 125, '2015-02-15 00:21:04.000000', 'consum', 0.0224, 'lps'),
	(408272, 125, '2015-02-15 00:21:05.000000', 'consum', 0.0219, 'lps'),
	(408273, 125, '2015-02-15 00:21:06.000000', 'consum', 0.0214, 'lps'),
	(408274, 125, '2015-02-15 00:21:07.000000', 'consum', 0.0220, 'lps'),
	(408275, 125, '2015-02-15 00:21:08.000000', 'consum', 0.0215, 'lps'),
	(408276, 125, '2015-02-15 00:21:09.000000', 'consum', 0.0223, 'lps'),
	(408277, 125, '2015-02-15 00:21:10.000000', 'consum', 0.0210, 'lps'),
	(408278, 125, '2015-02-15 00:21:11.000000', 'consum', 0.0223, 'lps'),
	(408279, 125, '2015-02-15 00:21:12.000000', 'consum', 0.0224, 'lps'),
	(408280, 125, '2015-02-15 00:21:13.000000', 'consum', 0.0224, 'lps'),
	(408281, 125, '2015-02-15 00:21:14.000000', 'consum', 0.0222, 'lps'),
	(408282, 125, '2015-02-15 00:21:15.000000', 'consum', 0.0211, 'lps'),
	(408283, 125, '2015-02-15 00:21:16.000000', 'consum', 0.0212, 'lps'),
	(408284, 125, '2015-02-15 00:21:17.000000', 'consum', 0.0217, 'lps'),
	(408285, 125, '2015-02-15 00:21:18.000000', 'consum', 0.0222, 'lps'),
	(408286, 125, '2015-02-15 00:21:19.000000', 'consum', 0.0218, 'lps'),
	(408287, 125, '2015-02-15 00:21:20.000000', 'consum', 0.0213, 'lps'),
	(408288, 125, '2015-02-15 00:21:21.000000', 'consum', 0.0218, 'lps'),
	(408289, 125, '2015-02-15 00:21:22.000000', 'consum', 0.0223, 'lps'),
	(408290, 125, '2015-02-15 00:21:23.000000', 'consum', 0.0220, 'lps'),
	(408291, 125, '2015-02-15 00:21:24.000000', 'consum', 0.0220, 'lps'),
	(408292, 125, '2015-02-15 00:21:25.000000', 'consum', 0.0215, 'lps'),
	(408293, 125, '2015-02-15 00:21:26.000000', 'consum', 0.0223, 'lps'),
	(408294, 125, '2015-02-15 00:21:27.000000', 'consum', 0.0225, 'lps'),
	(408295, 125, '2015-02-15 00:21:28.000000', 'consum', 0.0214, 'lps'),
	(408296, 125, '2015-02-15 00:21:29.000000', 'consum', 0.0220, 'lps'),
	(408297, 125, '2015-02-15 00:21:30.000000', 'consum', 0.0213, 'lps'),
	(408298, 125, '2015-02-15 00:21:31.000000', 'consum', 0.0213, 'lps'),
	(408299, 125, '2015-02-15 00:21:32.000000', 'consum', 0.0218, 'lps'),
	(408300, 125, '2015-02-15 00:21:33.000000', 'consum', 0.0221, 'lps'),
	(408301, 125, '2015-02-15 00:21:34.000000', 'consum', 0.0211, 'lps'),
	(408302, 125, '2015-02-15 00:21:35.000000', 'consum', 0.0217, 'lps'),
	(408303, 125, '2015-02-15 00:21:36.000000', 'consum', 0.0222, 'lps'),
	(408304, 125, '2015-02-15 00:21:37.000000', 'consum', 0.0219, 'lps'),
	(408305, 125, '2015-02-15 00:21:38.000000', 'consum', 0.0217, 'lps'),
	(408306, 125, '2015-02-15 00:21:39.000000', 'consum', 0.0220, 'lps'),
	(408307, 125, '2015-02-15 00:21:40.000000', 'consum', 0.0221, 'lps'),
	(408308, 125, '2015-02-15 00:21:41.000000', 'consum', 0.0218, 'lps'),
	(408309, 125, '2015-02-15 00:21:42.000000', 'consum', 0.0217, 'lps'),
	(408310, 125, '2015-02-15 00:21:43.000000', 'consum', 0.0223, 'lps'),
	(408311, 125, '2015-02-15 00:21:44.000000', 'consum', 0.0219, 'lps'),
	(408312, 125, '2015-02-15 00:21:45.000000', 'consum', 0.0217, 'lps'),
	(408313, 125, '2015-02-15 00:21:46.000000', 'consum', 0.0217, 'lps'),
	(408314, 125, '2015-02-15 00:21:47.000000', 'consum', 0.0226, 'lps'),
	(408315, 125, '2015-02-15 00:21:48.000000', 'consum', 0.0217, 'lps'),
	(408316, 125, '2015-02-15 00:21:49.000000', 'consum', 0.0216, 'lps'),
	(408317, 125, '2015-02-15 00:21:50.000000', 'consum', 0.0219, 'lps'),
	(408318, 125, '2015-02-15 00:21:51.000000', 'consum', 0.0221, 'lps'),
	(408319, 125, '2015-02-15 00:21:52.000000', 'consum', 0.0222, 'lps'),
	(408320, 125, '2015-02-15 00:21:53.000000', 'consum', 0.0221, 'lps'),
	(408321, 125, '2015-02-15 00:21:54.000000', 'consum', 0.0212, 'lps'),
	(408322, 125, '2015-02-15 00:21:55.000000', 'consum', 0.0222, 'lps'),
	(408323, 125, '2015-02-15 00:21:56.000000', 'consum', 0.0215, 'lps'),
	(408324, 125, '2015-02-15 00:21:57.000000', 'consum', 0.0214, 'lps'),
	(408325, 125, '2015-02-15 00:21:58.000000', 'consum', 0.0215, 'lps'),
	(408326, 125, '2015-02-15 00:21:59.000000', 'consum', 0.0224, 'lps'),
	(408327, 125, '2015-02-15 00:22:00.000000', 'consum', 0.0213, 'lps'),
	(408328, 125, '2015-02-15 00:22:01.000000', 'consum', 0.0217, 'lps'),
	(408329, 125, '2015-02-15 00:22:02.000000', 'consum', 0.0222, 'lps'),
	(408330, 125, '2015-02-15 00:22:03.000000', 'consum', 0.0214, 'lps'),
	(408331, 125, '2015-02-15 00:22:04.000000', 'consum', 0.0211, 'lps'),
	(408332, 125, '2015-02-15 00:22:05.000000', 'consum', 0.0223, 'lps'),
	(408333, 125, '2015-02-15 00:22:06.000000', 'consum', 0.0221, 'lps'),
	(408334, 125, '2015-02-15 00:22:07.000000', 'consum', 0.0224, 'lps'),
	(408335, 125, '2015-02-15 00:22:08.000000', 'consum', 0.0215, 'lps'),
	(408336, 125, '2015-02-15 00:22:09.000000', 'consum', 0.0226, 'lps'),
	(408337, 125, '2015-02-15 00:22:10.000000', 'consum', 0.0225, 'lps'),
	(408338, 125, '2015-02-15 00:22:11.000000', 'consum', 0.0220, 'lps'),
	(408339, 125, '2015-02-15 00:22:12.000000', 'consum', 0.0216, 'lps'),
	(408340, 125, '2015-02-15 00:22:13.000000', 'consum', 0.0210, 'lps'),
	(408341, 125, '2015-02-15 00:22:14.000000', 'consum', 0.0225, 'lps'),
	(408342, 125, '2015-02-15 00:22:15.000000', 'consum', 0.0220, 'lps'),
	(408343, 125, '2015-02-15 00:22:16.000000', 'consum', 0.0213, 'lps'),
	(408344, 125, '2015-02-15 00:22:17.000000', 'consum', 0.0215, 'lps'),
	(408345, 125, '2015-02-15 00:22:18.000000', 'consum', 0.0211, 'lps'),
	(408346, 125, '2015-02-15 00:22:19.000000', 'consum', 0.0215, 'lps'),
	(408347, 125, '2015-02-15 00:22:20.000000', 'consum', 0.0214, 'lps'),
	(408348, 125, '2015-02-15 00:22:21.000000', 'consum', 0.0218, 'lps'),
	(408349, 125, '2015-02-15 00:22:22.000000', 'consum', 0.0223, 'lps'),
	(408350, 125, '2015-02-15 00:22:23.000000', 'consum', 0.0214, 'lps'),
	(408351, 125, '2015-02-15 00:22:24.000000', 'consum', 0.0211, 'lps'),
	(408352, 125, '2015-02-15 00:22:25.000000', 'consum', 0.0221, 'lps'),
	(408353, 125, '2015-02-15 00:22:26.000000', 'consum', 0.0226, 'lps'),
	(408354, 125, '2015-02-15 00:22:27.000000', 'consum', 0.0210, 'lps'),
	(408355, 125, '2015-02-15 00:22:28.000000', 'consum', 0.0211, 'lps'),
	(408356, 125, '2015-02-15 00:22:29.000000', 'consum', 0.0214, 'lps'),
	(408357, 125, '2015-02-15 00:22:30.000000', 'consum', 0.0212, 'lps'),
	(408358, 125, '2015-02-15 00:22:31.000000', 'consum', 0.0225, 'lps'),
	(408359, 125, '2015-02-15 00:22:32.000000', 'consum', 0.0213, 'lps'),
	(408360, 125, '2015-02-15 00:22:33.000000', 'consum', 0.0215, 'lps'),
	(408361, 125, '2015-02-15 00:22:34.000000', 'consum', 0.0210, 'lps'),
	(408362, 125, '2015-02-15 00:22:35.000000', 'consum', 0.0212, 'lps'),
	(408363, 125, '2015-02-15 00:22:36.000000', 'consum', 0.0218, 'lps'),
	(408364, 125, '2015-02-15 00:22:37.000000', 'consum', 0.0213, 'lps'),
	(408365, 125, '2015-02-15 00:22:38.000000', 'consum', 0.0220, 'lps'),
	(408366, 125, '2015-02-15 00:22:39.000000', 'consum', 0.0216, 'lps'),
	(408367, 125, '2015-02-15 00:22:40.000000', 'consum', 0.0226, 'lps'),
	(408368, 125, '2015-02-15 00:22:41.000000', 'consum', 0.0224, 'lps'),
	(408369, 125, '2015-02-15 00:22:42.000000', 'consum', 0.0214, 'lps'),
	(408370, 125, '2015-02-15 00:22:43.000000', 'consum', 0.0223, 'lps'),
	(408371, 125, '2015-02-15 00:22:44.000000', 'consum', 0.0212, 'lps'),
	(408372, 125, '2015-02-15 00:22:45.000000', 'consum', 0.0215, 'lps'),
	(408373, 125, '2015-02-15 00:22:46.000000', 'consum', 0.0214, 'lps'),
	(408374, 125, '2015-02-15 00:22:47.000000', 'consum', 0.0214, 'lps'),
	(408375, 125, '2015-02-15 00:22:48.000000', 'consum', 0.0221, 'lps'),
	(408376, 125, '2015-02-15 00:22:49.000000', 'consum', 0.0216, 'lps'),
	(408377, 125, '2015-02-15 00:22:50.000000', 'consum', 0.0210, 'lps'),
	(408378, 125, '2015-02-15 00:22:51.000000', 'consum', 0.0225, 'lps'),
	(408379, 125, '2015-02-15 00:22:52.000000', 'consum', 0.0218, 'lps'),
	(408380, 125, '2015-02-15 00:22:53.000000', 'consum', 0.0224, 'lps'),
	(408381, 125, '2015-02-15 00:22:54.000000', 'consum', 0.0219, 'lps'),
	(408382, 125, '2015-02-15 00:22:55.000000', 'consum', 0.0217, 'lps'),
	(408383, 125, '2015-02-15 00:22:56.000000', 'consum', 0.0216, 'lps'),
	(408384, 125, '2015-02-15 00:22:57.000000', 'consum', 0.0221, 'lps'),
	(408385, 125, '2015-02-15 00:22:58.000000', 'consum', 0.0213, 'lps'),
	(408386, 125, '2015-02-15 00:22:59.000000', 'consum', 0.0226, 'lps'),
	(408387, 125, '2015-02-15 00:23:00.000000', 'consum', 0.0213, 'lps'),
	(408388, 125, '2015-02-15 00:23:01.000000', 'consum', 0.0211, 'lps'),
	(408389, 125, '2015-02-15 00:23:02.000000', 'consum', 0.0224, 'lps'),
	(408390, 125, '2015-02-15 00:23:03.000000', 'consum', 0.0211, 'lps'),
	(408391, 125, '2015-02-15 00:23:04.000000', 'consum', 0.0223, 'lps'),
	(408392, 125, '2015-02-15 00:23:05.000000', 'consum', 0.0220, 'lps'),
	(408393, 125, '2015-02-15 00:23:06.000000', 'consum', 0.0223, 'lps'),
	(408394, 125, '2015-02-15 00:23:07.000000', 'consum', 0.0211, 'lps'),
	(408395, 125, '2015-02-15 00:23:08.000000', 'consum', 0.0226, 'lps'),
	(408396, 125, '2015-02-15 00:23:09.000000', 'consum', 0.0223, 'lps'),
	(408397, 125, '2015-02-15 00:23:10.000000', 'consum', 0.0224, 'lps'),
	(408398, 125, '2015-02-15 00:23:11.000000', 'consum', 0.0225, 'lps'),
	(408399, 125, '2015-02-15 00:23:12.000000', 'consum', 0.0210, 'lps'),
	(408400, 125, '2015-02-15 00:23:13.000000', 'consum', 0.0216, 'lps'),
	(408401, 125, '2015-02-15 00:23:14.000000', 'consum', 0.0224, 'lps'),
	(408402, 125, '2015-02-15 00:23:15.000000', 'consum', 0.0210, 'lps'),
	(408403, 125, '2015-02-15 00:23:16.000000', 'consum', 0.0222, 'lps'),
	(408404, 125, '2015-02-15 00:23:17.000000', 'consum', 0.0217, 'lps'),
	(408405, 125, '2015-02-15 00:23:18.000000', 'consum', 0.0210, 'lps'),
	(408406, 125, '2015-02-15 00:23:19.000000', 'consum', 0.0223, 'lps'),
	(408407, 125, '2015-02-15 00:23:20.000000', 'consum', 0.0226, 'lps'),
	(408408, 125, '2015-02-15 00:23:21.000000', 'consum', 0.0215, 'lps'),
	(408409, 125, '2015-02-15 00:23:22.000000', 'consum', 0.0224, 'lps'),
	(408410, 125, '2015-02-15 00:23:23.000000', 'consum', 0.0215, 'lps'),
	(408411, 125, '2015-02-15 00:23:24.000000', 'consum', 0.0210, 'lps'),
	(408412, 125, '2015-02-15 00:23:25.000000', 'consum', 0.0211, 'lps'),
	(408413, 125, '2015-02-15 00:23:26.000000', 'consum', 0.0218, 'lps'),
	(408414, 125, '2015-02-15 00:23:27.000000', 'consum', 0.0213, 'lps'),
	(408415, 125, '2015-02-15 00:23:28.000000', 'consum', 0.0219, 'lps'),
	(408416, 125, '2015-02-15 00:23:29.000000', 'consum', 0.0214, 'lps'),
	(408417, 125, '2015-02-15 00:23:30.000000', 'consum', 0.0218, 'lps'),
	(408418, 125, '2015-02-15 00:23:31.000000', 'consum', 0.0223, 'lps'),
	(408419, 125, '2015-02-15 00:23:32.000000', 'consum', 0.0217, 'lps'),
	(408420, 125, '2015-02-15 00:23:33.000000', 'consum', 0.0224, 'lps'),
	(408421, 125, '2015-02-15 00:23:34.000000', 'consum', 0.0224, 'lps'),
	(408422, 125, '2015-02-15 00:23:35.000000', 'consum', 0.0221, 'lps'),
	(408423, 125, '2015-02-15 00:23:36.000000', 'consum', 0.0225, 'lps'),
	(408424, 125, '2015-02-15 00:23:37.000000', 'consum', 0.0216, 'lps'),
	(408425, 125, '2015-02-15 00:23:38.000000', 'consum', 0.0214, 'lps'),
	(408426, 125, '2015-02-15 00:23:39.000000', 'consum', 0.0211, 'lps'),
	(408427, 125, '2015-02-15 00:23:40.000000', 'consum', 0.0221, 'lps'),
	(408428, 125, '2015-02-15 00:23:41.000000', 'consum', 0.0212, 'lps'),
	(408429, 125, '2015-02-15 00:23:42.000000', 'consum', 0.0221, 'lps'),
	(408430, 125, '2015-02-15 00:23:43.000000', 'consum', 0.0210, 'lps'),
	(408431, 125, '2015-02-15 00:23:44.000000', 'consum', 0.0212, 'lps'),
	(408432, 125, '2015-02-15 00:23:45.000000', 'consum', 0.0218, 'lps'),
	(408433, 125, '2015-02-15 00:23:46.000000', 'consum', 0.0214, 'lps'),
	(408434, 125, '2015-02-15 00:23:47.000000', 'consum', 0.0220, 'lps'),
	(408435, 125, '2015-02-15 00:23:48.000000', 'consum', 0.0218, 'lps'),
	(408436, 125, '2015-02-15 00:23:49.000000', 'consum', 0.0217, 'lps'),
	(408437, 125, '2015-02-15 00:23:50.000000', 'consum', 0.0225, 'lps'),
	(408438, 125, '2015-02-15 00:23:51.000000', 'consum', 0.0210, 'lps'),
	(408439, 125, '2015-02-15 00:23:52.000000', 'consum', 0.0219, 'lps'),
	(408440, 125, '2015-02-15 00:23:53.000000', 'consum', 0.0219, 'lps'),
	(408441, 125, '2015-02-15 00:23:54.000000', 'consum', 0.0213, 'lps'),
	(408442, 125, '2015-02-15 00:23:55.000000', 'consum', 0.0214, 'lps'),
	(408443, 125, '2015-02-15 00:23:56.000000', 'consum', 0.0224, 'lps'),
	(408444, 125, '2015-02-15 00:23:57.000000', 'consum', 0.0218, 'lps'),
	(408445, 125, '2015-02-15 00:23:58.000000', 'consum', 0.0226, 'lps'),
	(408446, 125, '2015-02-15 00:23:59.000000', 'consum', 0.0216, 'lps'),
	(408447, 125, '2015-02-15 00:24:00.000000', 'consum', 0.0224, 'lps'),
	(408448, 125, '2015-02-15 00:24:01.000000', 'consum', 0.0211, 'lps'),
	(408449, 125, '2015-02-15 00:24:02.000000', 'consum', 0.0225, 'lps'),
	(408450, 125, '2015-02-15 00:24:03.000000', 'consum', 0.0215, 'lps'),
	(408451, 125, '2015-02-15 00:24:04.000000', 'consum', 0.0223, 'lps'),
	(408452, 125, '2015-02-15 00:24:05.000000', 'consum', 0.0211, 'lps'),
	(408453, 125, '2015-02-15 00:24:06.000000', 'consum', 0.0210, 'lps'),
	(408454, 125, '2015-02-15 00:24:07.000000', 'consum', 0.0223, 'lps'),
	(408455, 125, '2015-02-15 00:24:08.000000', 'consum', 0.0211, 'lps'),
	(408456, 125, '2015-02-15 00:24:09.000000', 'consum', 0.0224, 'lps'),
	(408457, 125, '2015-02-15 00:24:10.000000', 'consum', 0.0210, 'lps'),
	(408458, 125, '2015-02-15 00:24:11.000000', 'consum', 0.0220, 'lps'),
	(408459, 125, '2015-02-15 00:24:12.000000', 'consum', 0.0226, 'lps'),
	(408460, 125, '2015-02-15 00:24:13.000000', 'consum', 0.0211, 'lps'),
	(408461, 125, '2015-02-15 00:24:14.000000', 'consum', 0.0216, 'lps'),
	(408462, 125, '2015-02-15 00:24:15.000000', 'consum', 0.0224, 'lps'),
	(408463, 125, '2015-02-15 00:24:16.000000', 'consum', 0.0225, 'lps'),
	(408464, 125, '2015-02-15 00:24:17.000000', 'consum', 0.0212, 'lps'),
	(408465, 125, '2015-02-15 00:24:18.000000', 'consum', 0.0226, 'lps'),
	(408466, 125, '2015-02-15 00:24:19.000000', 'consum', 0.0214, 'lps'),
	(408467, 125, '2015-02-15 00:24:20.000000', 'consum', 0.0219, 'lps'),
	(408468, 125, '2015-02-15 00:24:21.000000', 'consum', 0.0225, 'lps'),
	(408469, 125, '2015-02-15 00:24:22.000000', 'consum', 0.0224, 'lps'),
	(408470, 125, '2015-02-15 00:24:23.000000', 'consum', 0.0217, 'lps'),
	(408471, 125, '2015-02-15 00:24:24.000000', 'consum', 0.0223, 'lps'),
	(408472, 125, '2015-02-15 00:24:25.000000', 'consum', 0.0221, 'lps'),
	(408473, 125, '2015-02-15 00:24:26.000000', 'consum', 0.0224, 'lps'),
	(408474, 125, '2015-02-15 00:24:27.000000', 'consum', 0.0215, 'lps'),
	(408475, 125, '2015-02-15 00:24:28.000000', 'consum', 0.0211, 'lps'),
	(408476, 125, '2015-02-15 00:24:29.000000', 'consum', 0.0216, 'lps'),
	(408477, 125, '2015-02-15 00:24:30.000000', 'consum', 0.0221, 'lps'),
	(408478, 125, '2015-02-15 00:24:31.000000', 'consum', 0.0213, 'lps'),
	(408479, 125, '2015-02-15 00:24:32.000000', 'consum', 0.0226, 'lps'),
	(408480, 125, '2015-02-15 00:24:33.000000', 'consum', 0.0216, 'lps'),
	(408481, 125, '2015-02-15 00:24:34.000000', 'consum', 0.0225, 'lps'),
	(408482, 125, '2015-02-15 00:24:35.000000', 'consum', 0.0218, 'lps'),
	(408483, 125, '2015-02-15 00:24:36.000000', 'consum', 0.0221, 'lps'),
	(408484, 125, '2015-02-15 00:24:37.000000', 'consum', 0.0226, 'lps'),
	(408485, 125, '2015-02-15 00:24:38.000000', 'consum', 0.0221, 'lps'),
	(408486, 125, '2015-02-15 00:24:39.000000', 'consum', 0.0219, 'lps'),
	(408487, 125, '2015-02-15 00:24:40.000000', 'consum', 0.0223, 'lps'),
	(408488, 125, '2015-02-15 00:24:41.000000', 'consum', 0.0215, 'lps'),
	(408489, 125, '2015-02-15 00:24:42.000000', 'consum', 0.0212, 'lps'),
	(408490, 125, '2015-02-15 00:24:43.000000', 'consum', 0.0223, 'lps'),
	(408491, 125, '2015-02-15 00:24:44.000000', 'consum', 0.0220, 'lps'),
	(408492, 125, '2015-02-15 00:24:45.000000', 'consum', 0.0222, 'lps'),
	(408493, 125, '2015-02-15 00:24:46.000000', 'consum', 0.0222, 'lps'),
	(408494, 125, '2015-02-15 00:24:47.000000', 'consum', 0.0219, 'lps'),
	(408495, 125, '2015-02-15 00:24:48.000000', 'consum', 0.0217, 'lps'),
	(408496, 125, '2015-02-15 00:24:49.000000', 'consum', 0.0219, 'lps'),
	(408497, 125, '2015-02-15 00:24:50.000000', 'consum', 0.0219, 'lps'),
	(408498, 125, '2015-02-15 00:24:51.000000', 'consum', 0.0210, 'lps'),
	(408499, 125, '2015-02-15 00:24:52.000000', 'consum', 0.0219, 'lps'),
	(408500, 125, '2015-02-15 00:24:53.000000', 'consum', 0.0221, 'lps'),
	(408501, 125, '2015-02-15 00:24:54.000000', 'consum', 0.0223, 'lps'),
	(408502, 125, '2015-02-15 00:24:55.000000', 'consum', 0.0225, 'lps'),
	(408503, 125, '2015-02-15 00:24:56.000000', 'consum', 0.0212, 'lps'),
	(408504, 125, '2015-02-15 00:24:57.000000', 'consum', 0.0225, 'lps'),
	(408505, 125, '2015-02-15 00:24:58.000000', 'consum', 0.0212, 'lps'),
	(408506, 125, '2015-02-15 00:24:59.000000', 'consum', 0.0210, 'lps'),
	(408507, 125, '2015-02-15 00:25:00.000000', 'consum', 0.0223, 'lps'),
	(408508, 125, '2015-02-15 00:25:01.000000', 'consum', 0.0224, 'lps'),
	(408509, 125, '2015-02-15 00:25:02.000000', 'consum', 0.0225, 'lps'),
	(408510, 125, '2015-02-15 00:25:03.000000', 'consum', 0.0224, 'lps'),
	(408511, 125, '2015-02-15 00:25:04.000000', 'consum', 0.0219, 'lps'),
	(408512, 125, '2015-02-15 00:25:05.000000', 'consum', 0.0214, 'lps'),
	(408513, 125, '2015-02-15 00:25:06.000000', 'consum', 0.0222, 'lps'),
	(408514, 125, '2015-02-15 00:25:07.000000', 'consum', 0.0222, 'lps'),
	(408515, 125, '2015-02-15 00:25:08.000000', 'consum', 0.0217, 'lps'),
	(408516, 125, '2015-02-15 00:25:09.000000', 'consum', 0.0212, 'lps'),
	(408517, 125, '2015-02-15 00:25:10.000000', 'consum', 0.0216, 'lps'),
	(408518, 125, '2015-02-15 00:25:11.000000', 'consum', 0.0218, 'lps'),
	(408519, 125, '2015-02-15 00:25:12.000000', 'consum', 0.0216, 'lps'),
	(408520, 125, '2015-02-15 00:25:13.000000', 'consum', 0.0214, 'lps'),
	(408521, 125, '2015-02-15 00:25:14.000000', 'consum', 0.0215, 'lps'),
	(408522, 125, '2015-02-15 00:25:15.000000', 'consum', 0.0225, 'lps'),
	(408523, 125, '2015-02-15 00:25:16.000000', 'consum', 0.0217, 'lps'),
	(408524, 125, '2015-02-15 00:25:17.000000', 'consum', 0.0216, 'lps'),
	(408525, 125, '2015-02-15 00:25:18.000000', 'consum', 0.0223, 'lps'),
	(408526, 125, '2015-02-15 00:25:19.000000', 'consum', 0.0221, 'lps'),
	(408527, 125, '2015-02-15 00:25:20.000000', 'consum', 0.0212, 'lps'),
	(408528, 125, '2015-02-15 00:25:21.000000', 'consum', 0.0221, 'lps'),
	(408529, 125, '2015-02-15 00:25:22.000000', 'consum', 0.0224, 'lps'),
	(408530, 125, '2015-02-15 00:25:23.000000', 'consum', 0.0215, 'lps'),
	(408531, 125, '2015-02-15 00:25:24.000000', 'consum', 0.0211, 'lps'),
	(408532, 125, '2015-02-15 00:25:25.000000', 'consum', 0.0216, 'lps'),
	(408533, 125, '2015-02-15 00:25:26.000000', 'consum', 0.0221, 'lps'),
	(408534, 125, '2015-02-15 00:25:27.000000', 'consum', 0.0214, 'lps'),
	(408535, 125, '2015-02-15 00:25:28.000000', 'consum', 0.0216, 'lps'),
	(408536, 125, '2015-02-15 00:25:29.000000', 'consum', 0.0210, 'lps'),
	(408537, 125, '2015-02-15 00:25:30.000000', 'consum', 0.0210, 'lps'),
	(408538, 125, '2015-02-15 00:25:31.000000', 'consum', 0.0212, 'lps'),
	(408539, 125, '2015-02-15 00:25:32.000000', 'consum', 0.0221, 'lps'),
	(408540, 125, '2015-02-15 00:25:33.000000', 'consum', 0.0224, 'lps'),
	(408541, 125, '2015-02-15 00:25:34.000000', 'consum', 0.0214, 'lps'),
	(408542, 125, '2015-02-15 00:25:35.000000', 'consum', 0.0223, 'lps'),
	(408543, 125, '2015-02-15 00:25:36.000000', 'consum', 0.0211, 'lps'),
	(408544, 125, '2015-02-15 00:25:37.000000', 'consum', 0.0210, 'lps'),
	(408545, 125, '2015-02-15 00:25:38.000000', 'consum', 0.0223, 'lps'),
	(408546, 125, '2015-02-15 00:25:39.000000', 'consum', 0.0211, 'lps'),
	(408547, 125, '2015-02-15 00:25:40.000000', 'consum', 0.0226, 'lps'),
	(408548, 125, '2015-02-15 00:25:41.000000', 'consum', 0.0221, 'lps'),
	(408549, 125, '2015-02-15 00:25:42.000000', 'consum', 0.0218, 'lps'),
	(408550, 125, '2015-02-15 00:25:43.000000', 'consum', 0.0216, 'lps'),
	(408551, 125, '2015-02-15 00:25:44.000000', 'consum', 0.0219, 'lps'),
	(408552, 125, '2015-02-15 00:25:45.000000', 'consum', 0.0218, 'lps'),
	(408553, 125, '2015-02-15 00:25:46.000000', 'consum', 0.0223, 'lps'),
	(408554, 125, '2015-02-15 00:25:47.000000', 'consum', 0.0216, 'lps'),
	(408555, 125, '2015-02-15 00:25:48.000000', 'consum', 0.0222, 'lps'),
	(408556, 125, '2015-02-15 00:25:49.000000', 'consum', 0.0218, 'lps'),
	(408557, 125, '2015-02-15 00:25:50.000000', 'consum', 0.0214, 'lps'),
	(408558, 125, '2015-02-15 00:25:51.000000', 'consum', 0.0223, 'lps'),
	(408559, 125, '2015-02-15 00:25:52.000000', 'consum', 0.0211, 'lps'),
	(408560, 125, '2015-02-15 00:25:53.000000', 'consum', 0.0212, 'lps'),
	(408561, 125, '2015-02-15 00:25:54.000000', 'consum', 0.0217, 'lps'),
	(408562, 125, '2015-02-15 00:25:55.000000', 'consum', 0.0222, 'lps'),
	(408563, 125, '2015-02-15 00:25:56.000000', 'consum', 0.0217, 'lps'),
	(408564, 125, '2015-02-15 00:25:57.000000', 'consum', 0.0225, 'lps'),
	(408565, 125, '2015-02-15 00:25:58.000000', 'consum', 0.0214, 'lps'),
	(408566, 125, '2015-02-15 00:25:59.000000', 'consum', 0.0219, 'lps'),
	(408567, 125, '2015-02-15 00:26:00.000000', 'consum', 0.0226, 'lps'),
	(408568, 125, '2015-02-15 00:26:01.000000', 'consum', 0.0212, 'lps'),
	(408569, 125, '2015-02-15 00:26:02.000000', 'consum', 0.0224, 'lps'),
	(408570, 125, '2015-02-15 00:26:03.000000', 'consum', 0.0224, 'lps'),
	(408571, 125, '2015-02-15 00:26:04.000000', 'consum', 0.0220, 'lps'),
	(408572, 125, '2015-02-15 00:26:05.000000', 'consum', 0.0217, 'lps'),
	(408573, 125, '2015-02-15 00:26:06.000000', 'consum', 0.0219, 'lps'),
	(408574, 125, '2015-02-15 00:26:07.000000', 'consum', 0.0215, 'lps'),
	(408575, 125, '2015-02-15 00:26:08.000000', 'consum', 0.0210, 'lps'),
	(408576, 125, '2015-02-15 00:26:09.000000', 'consum', 0.0211, 'lps'),
	(408577, 125, '2015-02-15 00:26:10.000000', 'consum', 0.0216, 'lps'),
	(408578, 125, '2015-02-15 00:26:11.000000', 'consum', 0.0222, 'lps'),
	(408579, 125, '2015-02-15 00:26:12.000000', 'consum', 0.0217, 'lps'),
	(408580, 125, '2015-02-15 00:26:13.000000', 'consum', 0.0211, 'lps'),
	(408581, 125, '2015-02-15 00:26:14.000000', 'consum', 0.0226, 'lps'),
	(408582, 125, '2015-02-15 00:26:15.000000', 'consum', 0.0222, 'lps'),
	(408583, 125, '2015-02-15 00:26:16.000000', 'consum', 0.0220, 'lps'),
	(408584, 125, '2015-02-15 00:26:17.000000', 'consum', 0.0226, 'lps'),
	(408585, 125, '2015-02-15 00:26:18.000000', 'consum', 0.0225, 'lps'),
	(408586, 125, '2015-02-15 00:26:19.000000', 'consum', 0.0222, 'lps'),
	(408587, 125, '2015-02-15 00:26:20.000000', 'consum', 0.0210, 'lps'),
	(408588, 125, '2015-02-15 00:26:21.000000', 'consum', 0.0222, 'lps'),
	(408589, 125, '2015-02-15 00:26:22.000000', 'consum', 0.0223, 'lps'),
	(408590, 125, '2015-02-15 00:26:23.000000', 'consum', 0.0222, 'lps'),
	(408591, 125, '2015-02-15 00:26:24.000000', 'consum', 0.0213, 'lps'),
	(408592, 125, '2015-02-15 00:26:25.000000', 'consum', 0.0222, 'lps'),
	(408593, 125, '2015-02-15 00:26:26.000000', 'consum', 0.0213, 'lps'),
	(408594, 125, '2015-02-15 00:26:27.000000', 'consum', 0.0223, 'lps'),
	(408595, 125, '2015-02-15 00:26:28.000000', 'consum', 0.0214, 'lps'),
	(408596, 125, '2015-02-15 00:26:29.000000', 'consum', 0.0225, 'lps'),
	(408597, 125, '2015-02-15 00:26:30.000000', 'consum', 0.0222, 'lps'),
	(408598, 125, '2015-02-15 00:26:31.000000', 'consum', 0.0226, 'lps'),
	(408599, 125, '2015-02-15 00:26:32.000000', 'consum', 0.0222, 'lps'),
	(408600, 125, '2015-02-15 00:26:33.000000', 'consum', 0.0221, 'lps'),
	(408601, 125, '2015-02-15 00:26:34.000000', 'consum', 0.0213, 'lps'),
	(408602, 125, '2015-02-15 00:26:35.000000', 'consum', 0.0225, 'lps'),
	(408603, 125, '2015-02-15 00:26:36.000000', 'consum', 0.0226, 'lps'),
	(408604, 125, '2015-02-15 00:26:37.000000', 'consum', 0.0214, 'lps'),
	(408605, 125, '2015-02-15 00:26:38.000000', 'consum', 0.0214, 'lps'),
	(408606, 125, '2015-02-15 00:26:39.000000', 'consum', 0.0217, 'lps'),
	(408607, 125, '2015-02-15 00:26:40.000000', 'consum', 0.0219, 'lps'),
	(408608, 125, '2015-02-15 00:26:41.000000', 'consum', 0.0218, 'lps'),
	(408609, 125, '2015-02-15 00:26:42.000000', 'consum', 0.0223, 'lps'),
	(408610, 125, '2015-02-15 00:26:43.000000', 'consum', 0.0216, 'lps'),
	(408611, 125, '2015-02-15 00:26:44.000000', 'consum', 0.0218, 'lps'),
	(408612, 125, '2015-02-15 00:26:45.000000', 'consum', 0.0217, 'lps'),
	(408613, 125, '2015-02-15 00:26:46.000000', 'consum', 0.0221, 'lps'),
	(408614, 125, '2015-02-15 00:26:47.000000', 'consum', 0.0212, 'lps'),
	(408615, 125, '2015-02-15 00:26:48.000000', 'consum', 0.0219, 'lps'),
	(408616, 125, '2015-02-15 00:26:49.000000', 'consum', 0.0217, 'lps'),
	(408617, 125, '2015-02-15 00:26:50.000000', 'consum', 0.0219, 'lps'),
	(408618, 125, '2015-02-15 00:26:51.000000', 'consum', 0.0216, 'lps'),
	(408619, 125, '2015-02-15 00:26:52.000000', 'consum', 0.0212, 'lps'),
	(408620, 125, '2015-02-15 00:26:53.000000', 'consum', 0.0222, 'lps'),
	(408621, 125, '2015-02-15 00:26:54.000000', 'consum', 0.0214, 'lps'),
	(408622, 125, '2015-02-15 00:26:55.000000', 'consum', 0.0211, 'lps'),
	(408623, 125, '2015-02-15 00:26:56.000000', 'consum', 0.0222, 'lps'),
	(408624, 125, '2015-02-15 00:26:57.000000', 'consum', 0.0217, 'lps'),
	(408625, 125, '2015-02-15 00:26:58.000000', 'consum', 0.0224, 'lps'),
	(408626, 125, '2015-02-15 00:26:59.000000', 'consum', 0.0226, 'lps'),
	(408627, 125, '2015-02-15 00:27:00.000000', 'consum', 0.0215, 'lps'),
	(408628, 125, '2015-02-15 00:27:01.000000', 'consum', 0.0220, 'lps'),
	(408629, 125, '2015-02-15 00:27:02.000000', 'consum', 0.0210, 'lps'),
	(408630, 125, '2015-02-15 00:27:03.000000', 'consum', 0.0218, 'lps'),
	(408631, 125, '2015-02-15 00:27:04.000000', 'consum', 0.0216, 'lps'),
	(408632, 125, '2015-02-15 00:27:05.000000', 'consum', 0.0216, 'lps'),
	(408633, 125, '2015-02-15 00:27:06.000000', 'consum', 0.0221, 'lps'),
	(408634, 125, '2015-02-15 00:27:07.000000', 'consum', 0.0216, 'lps'),
	(408635, 125, '2015-02-15 00:27:08.000000', 'consum', 0.0226, 'lps'),
	(408636, 125, '2015-02-15 00:27:09.000000', 'consum', 0.0218, 'lps'),
	(408637, 125, '2015-02-15 00:27:10.000000', 'consum', 0.0219, 'lps'),
	(408638, 125, '2015-02-15 00:27:11.000000', 'consum', 0.0217, 'lps'),
	(408639, 125, '2015-02-15 00:27:12.000000', 'consum', 0.0218, 'lps'),
	(408640, 125, '2015-02-15 00:27:13.000000', 'consum', 0.0210, 'lps'),
	(408641, 125, '2015-02-15 00:27:14.000000', 'consum', 0.0224, 'lps'),
	(408642, 125, '2015-02-15 00:27:15.000000', 'consum', 0.0212, 'lps'),
	(408643, 125, '2015-02-15 00:27:16.000000', 'consum', 0.0211, 'lps'),
	(408644, 125, '2015-02-15 00:27:17.000000', 'consum', 0.0226, 'lps'),
	(408645, 125, '2015-02-15 00:27:18.000000', 'consum', 0.0222, 'lps'),
	(408646, 125, '2015-02-15 00:27:19.000000', 'consum', 0.0219, 'lps'),
	(408647, 125, '2015-02-15 00:27:20.000000', 'consum', 0.0222, 'lps'),
	(408648, 125, '2015-02-15 00:27:21.000000', 'consum', 0.0210, 'lps'),
	(408649, 125, '2015-02-15 00:27:22.000000', 'consum', 0.0225, 'lps'),
	(408650, 125, '2015-02-15 00:27:23.000000', 'consum', 0.0218, 'lps'),
	(408651, 125, '2015-02-15 00:27:24.000000', 'consum', 0.0222, 'lps'),
	(408652, 125, '2015-02-15 00:27:25.000000', 'consum', 0.0211, 'lps'),
	(408653, 125, '2015-02-15 00:27:26.000000', 'consum', 0.0215, 'lps'),
	(408654, 125, '2015-02-15 00:27:27.000000', 'consum', 0.0216, 'lps'),
	(408655, 125, '2015-02-15 00:27:28.000000', 'consum', 0.0223, 'lps'),
	(408656, 125, '2015-02-15 00:27:29.000000', 'consum', 0.0224, 'lps'),
	(408657, 125, '2015-02-15 00:27:30.000000', 'consum', 0.0226, 'lps'),
	(408658, 125, '2015-02-15 00:27:31.000000', 'consum', 0.0212, 'lps'),
	(408659, 125, '2015-02-15 00:27:32.000000', 'consum', 0.0225, 'lps'),
	(408660, 125, '2015-02-15 00:27:33.000000', 'consum', 0.0211, 'lps'),
	(408661, 125, '2015-02-15 00:27:34.000000', 'consum', 0.0222, 'lps'),
	(408662, 125, '2015-02-15 00:27:35.000000', 'consum', 0.0215, 'lps'),
	(408663, 125, '2015-02-15 00:27:36.000000', 'consum', 0.0217, 'lps'),
	(408664, 125, '2015-02-15 00:27:37.000000', 'consum', 0.0215, 'lps'),
	(408665, 125, '2015-02-15 00:27:38.000000', 'consum', 0.0213, 'lps'),
	(408666, 125, '2015-02-15 00:27:39.000000', 'consum', 0.0226, 'lps'),
	(408667, 125, '2015-02-15 00:27:40.000000', 'consum', 0.0217, 'lps'),
	(408668, 125, '2015-02-15 00:27:41.000000', 'consum', 0.0213, 'lps'),
	(408669, 125, '2015-02-15 00:27:42.000000', 'consum', 0.0221, 'lps'),
	(408670, 125, '2015-02-15 00:27:43.000000', 'consum', 0.0225, 'lps'),
	(408671, 125, '2015-02-15 00:27:44.000000', 'consum', 0.0215, 'lps'),
	(408672, 125, '2015-02-15 00:27:45.000000', 'consum', 0.0225, 'lps'),
	(408673, 125, '2015-02-15 00:27:46.000000', 'consum', 0.0221, 'lps'),
	(408674, 125, '2015-02-15 00:27:47.000000', 'consum', 0.0221, 'lps'),
	(408675, 125, '2015-02-15 00:27:48.000000', 'consum', 0.0215, 'lps'),
	(408676, 125, '2015-02-15 00:27:49.000000', 'consum', 0.0221, 'lps'),
	(408677, 125, '2015-02-15 00:27:50.000000', 'consum', 0.0213, 'lps'),
	(408678, 125, '2015-02-15 00:27:51.000000', 'consum', 0.0212, 'lps'),
	(408679, 125, '2015-02-15 00:27:52.000000', 'consum', 0.0211, 'lps'),
	(408680, 125, '2015-02-15 00:27:53.000000', 'consum', 0.0211, 'lps'),
	(408681, 125, '2015-02-15 00:27:54.000000', 'consum', 0.0210, 'lps'),
	(408682, 125, '2015-02-15 00:27:55.000000', 'consum', 0.0224, 'lps'),
	(408683, 125, '2015-02-15 00:27:56.000000', 'consum', 0.0212, 'lps'),
	(408684, 125, '2015-02-15 00:27:57.000000', 'consum', 0.0213, 'lps'),
	(408685, 125, '2015-02-15 00:27:58.000000', 'consum', 0.0220, 'lps'),
	(408686, 125, '2015-02-15 00:27:59.000000', 'consum', 0.0217, 'lps'),
	(408687, 125, '2015-02-15 00:28:00.000000', 'consum', 0.0215, 'lps'),
	(408688, 125, '2015-02-15 00:28:01.000000', 'consum', 0.0215, 'lps'),
	(408689, 125, '2015-02-15 00:28:02.000000', 'consum', 0.0219, 'lps'),
	(408690, 125, '2015-02-15 00:28:03.000000', 'consum', 0.0225, 'lps'),
	(408691, 125, '2015-02-15 00:28:04.000000', 'consum', 0.0226, 'lps'),
	(408692, 125, '2015-02-15 00:28:05.000000', 'consum', 0.0226, 'lps'),
	(408693, 125, '2015-02-15 00:28:06.000000', 'consum', 0.0226, 'lps'),
	(408694, 125, '2015-02-15 00:28:07.000000', 'consum', 0.0225, 'lps'),
	(408695, 125, '2015-02-15 00:28:08.000000', 'consum', 0.0221, 'lps'),
	(408696, 125, '2015-02-15 00:28:09.000000', 'consum', 0.0220, 'lps'),
	(408697, 125, '2015-02-15 00:28:10.000000', 'consum', 0.0210, 'lps'),
	(408698, 125, '2015-02-15 00:28:11.000000', 'consum', 0.0215, 'lps'),
	(408699, 125, '2015-02-15 00:28:12.000000', 'consum', 0.0219, 'lps'),
	(408700, 125, '2015-02-15 00:28:13.000000', 'consum', 0.0222, 'lps'),
	(408701, 125, '2015-02-15 00:28:14.000000', 'consum', 0.0210, 'lps'),
	(408702, 125, '2015-02-15 00:28:15.000000', 'consum', 0.0211, 'lps'),
	(408703, 125, '2015-02-15 00:28:16.000000', 'consum', 0.0213, 'lps'),
	(408704, 125, '2015-02-15 00:28:17.000000', 'consum', 0.0221, 'lps'),
	(408705, 125, '2015-02-15 00:28:18.000000', 'consum', 0.0225, 'lps'),
	(408706, 125, '2015-02-15 00:28:19.000000', 'consum', 0.0219, 'lps'),
	(408707, 125, '2015-02-15 00:28:20.000000', 'consum', 0.0226, 'lps'),
	(408708, 125, '2015-02-15 00:28:21.000000', 'consum', 0.0213, 'lps'),
	(408709, 125, '2015-02-15 00:28:22.000000', 'consum', 0.0211, 'lps'),
	(408710, 125, '2015-02-15 00:28:23.000000', 'consum', 0.0223, 'lps'),
	(408711, 125, '2015-02-15 00:28:24.000000', 'consum', 0.0221, 'lps'),
	(408712, 125, '2015-02-15 00:28:25.000000', 'consum', 0.0212, 'lps'),
	(408713, 125, '2015-02-15 00:28:26.000000', 'consum', 0.0222, 'lps'),
	(408714, 125, '2015-02-15 00:28:27.000000', 'consum', 0.0212, 'lps'),
	(408715, 125, '2015-02-15 00:28:28.000000', 'consum', 0.0217, 'lps'),
	(408716, 125, '2015-02-15 00:28:29.000000', 'consum', 0.0224, 'lps'),
	(408717, 125, '2015-02-15 00:28:30.000000', 'consum', 0.0225, 'lps'),
	(408718, 125, '2015-02-15 00:28:31.000000', 'consum', 0.0225, 'lps'),
	(408719, 125, '2015-02-15 00:28:32.000000', 'consum', 0.0226, 'lps'),
	(408720, 125, '2015-02-15 00:28:33.000000', 'consum', 0.0212, 'lps'),
	(408721, 125, '2015-02-15 00:28:34.000000', 'consum', 0.0224, 'lps'),
	(408722, 125, '2015-02-15 00:28:35.000000', 'consum', 0.0221, 'lps'),
	(408723, 125, '2015-02-15 00:28:36.000000', 'consum', 0.0226, 'lps'),
	(408724, 125, '2015-02-15 00:28:37.000000', 'consum', 0.0224, 'lps'),
	(408725, 125, '2015-02-15 00:28:38.000000', 'consum', 0.0216, 'lps'),
	(408726, 125, '2015-02-15 00:28:39.000000', 'consum', 0.0214, 'lps'),
	(408727, 125, '2015-02-15 00:28:40.000000', 'consum', 0.0214, 'lps'),
	(408728, 125, '2015-02-15 00:28:41.000000', 'consum', 0.0218, 'lps'),
	(408729, 125, '2015-02-15 00:28:42.000000', 'consum', 0.0221, 'lps'),
	(408730, 125, '2015-02-15 00:28:43.000000', 'consum', 0.0224, 'lps'),
	(408731, 125, '2015-02-15 00:28:44.000000', 'consum', 0.0213, 'lps'),
	(408732, 125, '2015-02-15 00:28:45.000000', 'consum', 0.0220, 'lps'),
	(408733, 125, '2015-02-15 00:28:46.000000', 'consum', 0.0215, 'lps'),
	(408734, 125, '2015-02-15 00:28:47.000000', 'consum', 0.0221, 'lps'),
	(408735, 125, '2015-02-15 00:28:48.000000', 'consum', 0.0220, 'lps'),
	(408736, 125, '2015-02-15 00:28:49.000000', 'consum', 0.0224, 'lps'),
	(408737, 125, '2015-02-15 00:28:50.000000', 'consum', 0.0219, 'lps'),
	(408738, 125, '2015-02-15 00:28:51.000000', 'consum', 0.0213, 'lps'),
	(408739, 125, '2015-02-15 00:28:52.000000', 'consum', 0.0214, 'lps'),
	(408740, 125, '2015-02-15 00:28:53.000000', 'consum', 0.0223, 'lps'),
	(408741, 125, '2015-02-15 00:28:54.000000', 'consum', 0.0214, 'lps'),
	(408742, 125, '2015-02-15 00:28:55.000000', 'consum', 0.0225, 'lps'),
	(408743, 125, '2015-02-15 00:28:56.000000', 'consum', 0.0221, 'lps'),
	(408744, 125, '2015-02-15 00:28:57.000000', 'consum', 0.0221, 'lps'),
	(408745, 125, '2015-02-15 00:28:58.000000', 'consum', 0.0217, 'lps'),
	(408746, 125, '2015-02-15 00:28:59.000000', 'consum', 0.0210, 'lps'),
	(408747, 125, '2015-02-15 00:29:00.000000', 'consum', 0.0225, 'lps'),
	(408748, 125, '2015-02-15 00:29:01.000000', 'consum', 0.0218, 'lps'),
	(408749, 125, '2015-02-15 00:29:02.000000', 'consum', 0.0223, 'lps'),
	(408750, 125, '2015-02-15 00:29:03.000000', 'consum', 0.0216, 'lps'),
	(408751, 125, '2015-02-15 00:29:04.000000', 'consum', 0.0219, 'lps'),
	(408752, 125, '2015-02-15 00:29:05.000000', 'consum', 0.0219, 'lps'),
	(408753, 125, '2015-02-15 00:29:06.000000', 'consum', 0.0213, 'lps'),
	(408754, 125, '2015-02-15 00:29:07.000000', 'consum', 0.0213, 'lps'),
	(408755, 125, '2015-02-15 00:29:08.000000', 'consum', 0.0219, 'lps'),
	(408756, 125, '2015-02-15 00:29:09.000000', 'consum', 0.0212, 'lps'),
	(408757, 125, '2015-02-15 00:29:10.000000', 'consum', 0.0211, 'lps'),
	(408758, 125, '2015-02-15 00:29:11.000000', 'consum', 0.0210, 'lps'),
	(408759, 125, '2015-02-15 00:29:12.000000', 'consum', 0.0224, 'lps'),
	(408760, 125, '2015-02-15 00:29:13.000000', 'consum', 0.0213, 'lps'),
	(408761, 125, '2015-02-15 00:29:14.000000', 'consum', 0.0215, 'lps'),
	(408762, 125, '2015-02-15 00:29:15.000000', 'consum', 0.0212, 'lps'),
	(408763, 125, '2015-02-15 00:29:16.000000', 'consum', 0.0222, 'lps'),
	(408764, 125, '2015-02-15 00:29:17.000000', 'consum', 0.0215, 'lps'),
	(408765, 125, '2015-02-15 00:29:18.000000', 'consum', 0.0217, 'lps'),
	(408766, 125, '2015-02-15 00:29:19.000000', 'consum', 0.0212, 'lps'),
	(408767, 125, '2015-02-15 00:29:20.000000', 'consum', 0.0219, 'lps'),
	(408768, 125, '2015-02-15 00:29:21.000000', 'consum', 0.0212, 'lps'),
	(408769, 125, '2015-02-15 00:29:22.000000', 'consum', 0.0212, 'lps'),
	(408770, 125, '2015-02-15 00:29:23.000000', 'consum', 0.0215, 'lps'),
	(408771, 125, '2015-02-15 00:29:24.000000', 'consum', 0.0214, 'lps'),
	(408772, 125, '2015-02-15 00:29:25.000000', 'consum', 0.0212, 'lps'),
	(408773, 125, '2015-02-15 00:29:26.000000', 'consum', 0.0211, 'lps'),
	(408774, 125, '2015-02-15 00:29:27.000000', 'consum', 0.0226, 'lps'),
	(408775, 125, '2015-02-15 00:29:28.000000', 'consum', 0.0220, 'lps'),
	(408776, 125, '2015-02-15 00:29:29.000000', 'consum', 0.0212, 'lps'),
	(408777, 125, '2015-02-15 00:29:30.000000', 'consum', 0.0226, 'lps'),
	(408778, 125, '2015-02-15 00:29:31.000000', 'consum', 0.0217, 'lps'),
	(408779, 125, '2015-02-15 00:29:32.000000', 'consum', 0.0213, 'lps'),
	(408780, 125, '2015-02-15 00:29:33.000000', 'consum', 0.0223, 'lps'),
	(408781, 125, '2015-02-15 00:29:34.000000', 'consum', 0.0217, 'lps'),
	(408782, 125, '2015-02-15 00:29:35.000000', 'consum', 0.0221, 'lps'),
	(408783, 125, '2015-02-15 00:29:36.000000', 'consum', 0.0210, 'lps'),
	(408784, 125, '2015-02-15 00:29:37.000000', 'consum', 0.0212, 'lps'),
	(408785, 125, '2015-02-15 00:29:38.000000', 'consum', 0.0223, 'lps'),
	(408786, 125, '2015-02-15 00:29:39.000000', 'consum', 0.0216, 'lps'),
	(408787, 125, '2015-02-15 00:29:40.000000', 'consum', 0.0217, 'lps'),
	(408788, 125, '2015-02-15 00:29:41.000000', 'consum', 0.0212, 'lps'),
	(408789, 125, '2015-02-15 00:29:42.000000', 'consum', 0.0218, 'lps'),
	(408790, 125, '2015-02-15 00:29:43.000000', 'consum', 0.0225, 'lps'),
	(408791, 125, '2015-02-15 00:29:44.000000', 'consum', 0.0213, 'lps'),
	(408792, 125, '2015-02-15 00:29:45.000000', 'consum', 0.0213, 'lps'),
	(408793, 125, '2015-02-15 00:29:46.000000', 'consum', 0.0216, 'lps'),
	(408794, 125, '2015-02-15 00:29:47.000000', 'consum', 0.0217, 'lps'),
	(408795, 125, '2015-02-15 00:29:48.000000', 'consum', 0.0224, 'lps'),
	(408796, 125, '2015-02-15 00:29:49.000000', 'consum', 0.0211, 'lps'),
	(408797, 125, '2015-02-15 00:29:50.000000', 'consum', 0.0224, 'lps'),
	(408798, 125, '2015-02-15 00:29:51.000000', 'consum', 0.0225, 'lps'),
	(408799, 125, '2015-02-15 00:29:52.000000', 'consum', 0.0210, 'lps'),
	(408800, 125, '2015-02-15 00:29:53.000000', 'consum', 0.0216, 'lps'),
	(408801, 125, '2015-02-15 00:29:54.000000', 'consum', 0.0224, 'lps'),
	(408802, 125, '2015-02-15 00:29:55.000000', 'consum', 0.0214, 'lps'),
	(408803, 125, '2015-02-15 00:29:56.000000', 'consum', 0.0219, 'lps'),
	(408804, 125, '2015-02-15 00:29:57.000000', 'consum', 0.0212, 'lps'),
	(408805, 125, '2015-02-15 00:29:58.000000', 'consum', 0.0210, 'lps'),
	(408806, 125, '2015-02-15 00:29:59.000000', 'consum', 0.0223, 'lps'),
	(408807, 125, '2015-02-15 00:30:00.000000', 'consum', 0.0221, 'lps'),
	(408808, 125, '2015-02-15 00:30:01.000000', 'consum', 0.0212, 'lps'),
	(408809, 125, '2015-02-15 00:30:02.000000', 'consum', 0.0220, 'lps'),
	(408810, 125, '2015-02-15 00:30:03.000000', 'consum', 0.0223, 'lps'),
	(408811, 125, '2015-02-15 00:30:04.000000', 'consum', 0.0210, 'lps'),
	(408812, 125, '2015-02-15 00:30:05.000000', 'consum', 0.0223, 'lps'),
	(408813, 125, '2015-02-15 00:30:06.000000', 'consum', 0.0224, 'lps'),
	(408814, 125, '2015-02-15 00:30:07.000000', 'consum', 0.0226, 'lps'),
	(408815, 125, '2015-02-15 00:30:08.000000', 'consum', 0.0213, 'lps'),
	(408816, 125, '2015-02-15 00:30:09.000000', 'consum', 0.0214, 'lps'),
	(408817, 125, '2015-02-15 00:30:10.000000', 'consum', 0.0219, 'lps'),
	(408818, 125, '2015-02-15 00:30:11.000000', 'consum', 0.0226, 'lps'),
	(408819, 125, '2015-02-15 00:30:12.000000', 'consum', 0.0213, 'lps'),
	(408820, 125, '2015-02-15 00:30:13.000000', 'consum', 0.0211, 'lps'),
	(408821, 125, '2015-02-15 00:30:14.000000', 'consum', 0.0222, 'lps'),
	(408822, 125, '2015-02-15 00:30:15.000000', 'consum', 0.0218, 'lps'),
	(408823, 125, '2015-02-15 00:30:16.000000', 'consum', 0.0213, 'lps'),
	(408824, 125, '2015-02-15 00:30:17.000000', 'consum', 0.0219, 'lps'),
	(408825, 125, '2015-02-15 00:30:18.000000', 'consum', 0.0211, 'lps'),
	(408826, 125, '2015-02-15 00:30:19.000000', 'consum', 0.0224, 'lps'),
	(408827, 125, '2015-02-15 00:30:20.000000', 'consum', 0.0210, 'lps'),
	(408828, 125, '2015-02-15 00:30:21.000000', 'consum', 0.0220, 'lps'),
	(408829, 125, '2015-02-15 00:30:22.000000', 'consum', 0.0210, 'lps'),
	(408830, 125, '2015-02-15 00:30:23.000000', 'consum', 0.0213, 'lps'),
	(408831, 125, '2015-02-15 00:30:24.000000', 'consum', 0.0224, 'lps'),
	(408832, 125, '2015-02-15 00:30:25.000000', 'consum', 0.0222, 'lps'),
	(408833, 125, '2015-02-15 00:30:26.000000', 'consum', 0.0210, 'lps'),
	(408834, 125, '2015-02-15 00:30:27.000000', 'consum', 0.0211, 'lps'),
	(408835, 125, '2015-02-15 00:30:28.000000', 'consum', 0.0215, 'lps'),
	(408836, 125, '2015-02-15 00:30:29.000000', 'consum', 0.0215, 'lps'),
	(408837, 125, '2015-02-15 00:30:30.000000', 'consum', 0.0221, 'lps'),
	(408838, 125, '2015-02-15 00:30:31.000000', 'consum', 0.0217, 'lps'),
	(408839, 125, '2015-02-15 00:30:32.000000', 'consum', 0.0213, 'lps'),
	(408840, 125, '2015-02-15 00:30:33.000000', 'consum', 0.0221, 'lps'),
	(408841, 125, '2015-02-15 00:30:34.000000', 'consum', 0.0223, 'lps'),
	(408842, 125, '2015-02-15 00:30:35.000000', 'consum', 0.0210, 'lps'),
	(408843, 125, '2015-02-15 00:30:36.000000', 'consum', 0.0221, 'lps'),
	(408844, 125, '2015-02-15 00:30:37.000000', 'consum', 0.0216, 'lps'),
	(408845, 125, '2015-02-15 00:30:38.000000', 'consum', 0.0222, 'lps'),
	(408846, 125, '2015-02-15 00:30:39.000000', 'consum', 0.0218, 'lps'),
	(408847, 125, '2015-02-15 00:30:40.000000', 'consum', 0.0214, 'lps'),
	(408848, 125, '2015-02-15 00:30:41.000000', 'consum', 0.0224, 'lps'),
	(408849, 125, '2015-02-15 00:30:42.000000', 'consum', 0.0217, 'lps'),
	(408850, 125, '2015-02-15 00:30:43.000000', 'consum', 0.0223, 'lps'),
	(408851, 125, '2015-02-15 00:30:44.000000', 'consum', 0.0219, 'lps'),
	(408852, 125, '2015-02-15 00:30:45.000000', 'consum', 0.0216, 'lps'),
	(408853, 125, '2015-02-15 00:30:46.000000', 'consum', 0.0212, 'lps'),
	(408854, 125, '2015-02-15 00:30:47.000000', 'consum', 0.0221, 'lps'),
	(408855, 125, '2015-02-15 00:30:48.000000', 'consum', 0.0224, 'lps'),
	(408856, 125, '2015-02-15 00:30:49.000000', 'consum', 0.0213, 'lps'),
	(408857, 125, '2015-02-15 00:30:50.000000', 'consum', 0.0218, 'lps'),
	(408858, 125, '2015-02-15 00:30:51.000000', 'consum', 0.0224, 'lps'),
	(408859, 125, '2015-02-15 00:30:52.000000', 'consum', 0.0221, 'lps'),
	(408860, 125, '2015-02-15 00:30:53.000000', 'consum', 0.0225, 'lps'),
	(408861, 125, '2015-02-15 00:30:54.000000', 'consum', 0.0219, 'lps'),
	(408862, 125, '2015-02-15 00:30:55.000000', 'consum', 0.0226, 'lps'),
	(408863, 125, '2015-02-15 00:30:56.000000', 'consum', 0.0214, 'lps'),
	(408864, 125, '2015-02-15 00:30:57.000000', 'consum', 0.0215, 'lps'),
	(408865, 125, '2015-02-15 00:30:58.000000', 'consum', 0.0225, 'lps'),
	(408866, 125, '2015-02-15 00:30:59.000000', 'consum', 0.0218, 'lps'),
	(408867, 125, '2015-02-15 00:31:00.000000', 'consum', 0.0225, 'lps'),
	(408868, 125, '2015-02-15 00:31:01.000000', 'consum', 0.0226, 'lps'),
	(408869, 125, '2015-02-15 00:31:02.000000', 'consum', 0.0212, 'lps'),
	(408870, 125, '2015-02-15 00:31:03.000000', 'consum', 0.0222, 'lps'),
	(408871, 125, '2015-02-15 00:31:04.000000', 'consum', 0.0216, 'lps'),
	(408872, 125, '2015-02-15 00:31:05.000000', 'consum', 0.0220, 'lps'),
	(408873, 125, '2015-02-15 00:31:06.000000', 'consum', 0.0210, 'lps'),
	(408874, 125, '2015-02-15 00:31:07.000000', 'consum', 0.0215, 'lps'),
	(408875, 125, '2015-02-15 00:31:08.000000', 'consum', 0.0217, 'lps'),
	(408876, 125, '2015-02-15 00:31:09.000000', 'consum', 0.0216, 'lps'),
	(408877, 125, '2015-02-15 00:31:10.000000', 'consum', 0.0218, 'lps'),
	(408878, 125, '2015-02-15 00:31:11.000000', 'consum', 0.0214, 'lps'),
	(408879, 125, '2015-02-15 00:31:12.000000', 'consum', 0.0224, 'lps'),
	(408880, 125, '2015-02-15 00:31:13.000000', 'consum', 0.0219, 'lps'),
	(408881, 125, '2015-02-15 00:31:14.000000', 'consum', 0.0215, 'lps'),
	(408882, 125, '2015-02-15 00:31:15.000000', 'consum', 0.0222, 'lps'),
	(408883, 125, '2015-02-15 00:31:16.000000', 'consum', 0.0223, 'lps'),
	(408884, 125, '2015-02-15 00:31:17.000000', 'consum', 0.0220, 'lps'),
	(408885, 125, '2015-02-15 00:31:18.000000', 'consum', 0.0224, 'lps'),
	(408886, 125, '2015-02-15 00:31:19.000000', 'consum', 0.0218, 'lps'),
	(408887, 125, '2015-02-15 00:31:20.000000', 'consum', 0.0224, 'lps'),
	(408888, 125, '2015-02-15 00:31:21.000000', 'consum', 0.0222, 'lps'),
	(408889, 125, '2015-02-15 00:31:22.000000', 'consum', 0.0210, 'lps'),
	(408890, 125, '2015-02-15 00:31:23.000000', 'consum', 0.0226, 'lps'),
	(408891, 125, '2015-02-15 00:31:24.000000', 'consum', 0.0224, 'lps'),
	(408892, 125, '2015-02-15 00:31:25.000000', 'consum', 0.0216, 'lps'),
	(408893, 125, '2015-02-15 00:31:26.000000', 'consum', 0.0214, 'lps'),
	(408894, 125, '2015-02-15 00:31:27.000000', 'consum', 0.0211, 'lps'),
	(408895, 125, '2015-02-15 00:31:28.000000', 'consum', 0.0224, 'lps'),
	(408896, 125, '2015-02-15 00:31:29.000000', 'consum', 0.0223, 'lps'),
	(408897, 125, '2015-02-15 00:31:30.000000', 'consum', 0.0220, 'lps'),
	(408898, 125, '2015-02-15 00:31:31.000000', 'consum', 0.0219, 'lps'),
	(408899, 125, '2015-02-15 00:31:32.000000', 'consum', 0.0210, 'lps'),
	(408900, 125, '2015-02-15 00:31:33.000000', 'consum', 0.0218, 'lps'),
	(408901, 125, '2015-02-15 00:31:34.000000', 'consum', 0.0215, 'lps'),
	(408902, 125, '2015-02-15 00:31:35.000000', 'consum', 0.0212, 'lps'),
	(408903, 125, '2015-02-15 00:31:36.000000', 'consum', 0.0225, 'lps'),
	(408904, 125, '2015-02-15 00:31:37.000000', 'consum', 0.0225, 'lps'),
	(408905, 125, '2015-02-15 00:31:38.000000', 'consum', 0.0223, 'lps'),
	(408906, 125, '2015-02-15 00:31:39.000000', 'consum', 0.0216, 'lps'),
	(408907, 125, '2015-02-15 00:31:40.000000', 'consum', 0.0216, 'lps'),
	(408908, 125, '2015-02-15 00:31:41.000000', 'consum', 0.0226, 'lps'),
	(408909, 125, '2015-02-15 00:31:42.000000', 'consum', 0.0218, 'lps'),
	(408910, 125, '2015-02-15 00:31:43.000000', 'consum', 0.0222, 'lps'),
	(408911, 125, '2015-02-15 00:31:44.000000', 'consum', 0.0212, 'lps'),
	(408912, 125, '2015-02-15 00:31:45.000000', 'consum', 0.0219, 'lps'),
	(408913, 125, '2015-02-15 00:31:46.000000', 'consum', 0.0215, 'lps'),
	(408914, 125, '2015-02-15 00:31:47.000000', 'consum', 0.0224, 'lps'),
	(408915, 125, '2015-02-15 00:31:48.000000', 'consum', 0.0214, 'lps'),
	(408916, 125, '2015-02-15 00:31:49.000000', 'consum', 0.0222, 'lps'),
	(408917, 125, '2015-02-15 00:31:50.000000', 'consum', 0.0226, 'lps'),
	(408918, 125, '2015-02-15 00:31:51.000000', 'consum', 0.0219, 'lps'),
	(408919, 125, '2015-02-15 00:31:52.000000', 'consum', 0.0223, 'lps'),
	(408920, 125, '2015-02-15 00:31:53.000000', 'consum', 0.0218, 'lps'),
	(408921, 125, '2015-02-15 00:31:54.000000', 'consum', 0.0210, 'lps'),
	(408922, 125, '2015-02-15 00:31:55.000000', 'consum', 0.0223, 'lps'),
	(408923, 125, '2015-02-15 00:31:56.000000', 'consum', 0.0221, 'lps'),
	(408924, 125, '2015-02-15 00:31:57.000000', 'consum', 0.0210, 'lps'),
	(408925, 125, '2015-02-15 00:31:58.000000', 'consum', 0.0212, 'lps'),
	(408926, 125, '2015-02-15 00:31:59.000000', 'consum', 0.0222, 'lps'),
	(408927, 125, '2015-02-15 00:32:00.000000', 'consum', 0.0214, 'lps'),
	(408928, 125, '2015-02-15 00:32:01.000000', 'consum', 0.0211, 'lps'),
	(408929, 125, '2015-02-15 00:32:02.000000', 'consum', 0.0222, 'lps'),
	(408930, 125, '2015-02-15 00:32:03.000000', 'consum', 0.0215, 'lps'),
	(408931, 125, '2015-02-15 00:32:04.000000', 'consum', 0.0215, 'lps'),
	(408932, 125, '2015-02-15 00:32:05.000000', 'consum', 0.0223, 'lps'),
	(408933, 125, '2015-02-15 00:32:06.000000', 'consum', 0.0226, 'lps'),
	(408934, 125, '2015-02-15 00:32:07.000000', 'consum', 0.0216, 'lps'),
	(408935, 125, '2015-02-15 00:32:08.000000', 'consum', 0.0226, 'lps'),
	(408936, 125, '2015-02-15 00:32:09.000000', 'consum', 0.0221, 'lps'),
	(408937, 125, '2015-02-15 00:32:10.000000', 'consum', 0.0217, 'lps'),
	(408938, 125, '2015-02-15 00:32:11.000000', 'consum', 0.0213, 'lps'),
	(408939, 125, '2015-02-15 00:32:12.000000', 'consum', 0.0222, 'lps'),
	(408940, 125, '2015-02-15 00:32:13.000000', 'consum', 0.0212, 'lps'),
	(408941, 125, '2015-02-15 00:32:14.000000', 'consum', 0.0215, 'lps'),
	(408942, 125, '2015-02-15 00:32:15.000000', 'consum', 0.0216, 'lps'),
	(408943, 125, '2015-02-15 00:32:16.000000', 'consum', 0.0223, 'lps'),
	(408944, 125, '2015-02-15 00:32:17.000000', 'consum', 0.0223, 'lps'),
	(408945, 125, '2015-02-15 00:32:18.000000', 'consum', 0.0221, 'lps'),
	(408946, 125, '2015-02-15 00:32:19.000000', 'consum', 0.0210, 'lps'),
	(408947, 125, '2015-02-15 00:32:20.000000', 'consum', 0.0213, 'lps'),
	(408948, 125, '2015-02-15 00:32:21.000000', 'consum', 0.0224, 'lps'),
	(408949, 125, '2015-02-15 00:32:22.000000', 'consum', 0.0219, 'lps'),
	(408950, 125, '2015-02-15 00:32:23.000000', 'consum', 0.0215, 'lps'),
	(408951, 125, '2015-02-15 00:32:24.000000', 'consum', 0.0210, 'lps'),
	(408952, 125, '2015-02-15 00:32:25.000000', 'consum', 0.0213, 'lps'),
	(408953, 125, '2015-02-15 00:32:26.000000', 'consum', 0.0223, 'lps'),
	(408954, 125, '2015-02-15 00:32:27.000000', 'consum', 0.0216, 'lps'),
	(408955, 125, '2015-02-15 00:32:28.000000', 'consum', 0.0219, 'lps'),
	(408956, 125, '2015-02-15 00:32:29.000000', 'consum', 0.0221, 'lps'),
	(408957, 125, '2015-02-15 00:32:30.000000', 'consum', 0.0220, 'lps'),
	(408958, 125, '2015-02-15 00:32:31.000000', 'consum', 0.0213, 'lps'),
	(408959, 125, '2015-02-15 00:32:32.000000', 'consum', 0.0210, 'lps'),
	(408960, 125, '2015-02-15 00:32:33.000000', 'consum', 0.0218, 'lps'),
	(408961, 125, '2015-02-15 00:32:34.000000', 'consum', 0.0216, 'lps'),
	(408962, 125, '2015-02-15 00:32:35.000000', 'consum', 0.0218, 'lps'),
	(408963, 125, '2015-02-15 00:32:36.000000', 'consum', 0.0216, 'lps'),
	(408964, 125, '2015-02-15 00:32:37.000000', 'consum', 0.0216, 'lps'),
	(408965, 125, '2015-02-15 00:32:38.000000', 'consum', 0.0224, 'lps'),
	(408966, 125, '2015-02-15 00:32:39.000000', 'consum', 0.0210, 'lps'),
	(408967, 125, '2015-02-15 00:32:40.000000', 'consum', 0.0219, 'lps'),
	(408968, 125, '2015-02-15 00:32:41.000000', 'consum', 0.0223, 'lps'),
	(408969, 125, '2015-02-15 00:32:42.000000', 'consum', 0.0212, 'lps'),
	(408970, 125, '2015-02-15 00:32:43.000000', 'consum', 0.0217, 'lps'),
	(408971, 125, '2015-02-15 00:32:44.000000', 'consum', 0.0221, 'lps'),
	(408972, 125, '2015-02-15 00:32:45.000000', 'consum', 0.0211, 'lps'),
	(408973, 125, '2015-02-15 00:32:46.000000', 'consum', 0.0216, 'lps'),
	(408974, 125, '2015-02-15 00:32:47.000000', 'consum', 0.0220, 'lps'),
	(408975, 125, '2015-02-15 00:32:48.000000', 'consum', 0.0224, 'lps'),
	(408976, 125, '2015-02-15 00:32:49.000000', 'consum', 0.0220, 'lps'),
	(408977, 125, '2015-02-15 00:32:50.000000', 'consum', 0.0216, 'lps'),
	(408978, 125, '2015-02-15 00:32:51.000000', 'consum', 0.0210, 'lps'),
	(408979, 125, '2015-02-15 00:32:52.000000', 'consum', 0.0226, 'lps'),
	(408980, 125, '2015-02-15 00:32:53.000000', 'consum', 0.0225, 'lps'),
	(408981, 125, '2015-02-15 00:32:54.000000', 'consum', 0.0217, 'lps'),
	(408982, 125, '2015-02-15 00:32:55.000000', 'consum', 0.0221, 'lps'),
	(408983, 125, '2015-02-15 00:32:56.000000', 'consum', 0.0210, 'lps'),
	(408984, 125, '2015-02-15 00:32:57.000000', 'consum', 0.0211, 'lps'),
	(408985, 125, '2015-02-15 00:32:58.000000', 'consum', 0.0214, 'lps'),
	(408986, 125, '2015-02-15 00:32:59.000000', 'consum', 0.0213, 'lps'),
	(408987, 125, '2015-02-15 00:33:00.000000', 'consum', 0.0213, 'lps'),
	(408988, 125, '2015-02-15 00:33:01.000000', 'consum', 0.0216, 'lps'),
	(408989, 125, '2015-02-15 00:33:02.000000', 'consum', 0.0217, 'lps'),
	(408990, 125, '2015-02-15 00:33:03.000000', 'consum', 0.0225, 'lps'),
	(408991, 125, '2015-02-15 00:33:04.000000', 'consum', 0.0213, 'lps'),
	(408992, 125, '2015-02-15 00:33:05.000000', 'consum', 0.0214, 'lps'),
	(408993, 125, '2015-02-15 00:33:06.000000', 'consum', 0.0222, 'lps'),
	(408994, 125, '2015-02-15 00:33:07.000000', 'consum', 0.0225, 'lps'),
	(408995, 125, '2015-02-15 00:33:08.000000', 'consum', 0.0214, 'lps'),
	(408996, 125, '2015-02-15 00:33:09.000000', 'consum', 0.0222, 'lps'),
	(408997, 125, '2015-02-15 00:33:10.000000', 'consum', 0.0223, 'lps'),
	(408998, 125, '2015-02-15 00:33:11.000000', 'consum', 0.0221, 'lps'),
	(408999, 125, '2015-02-15 00:33:12.000000', 'consum', 0.0226, 'lps'),
	(409000, 125, '2015-02-15 00:33:13.000000', 'consum', 0.0226, 'lps'),
	(409001, 125, '2015-02-15 00:33:14.000000', 'consum', 0.0226, 'lps'),
	(409002, 125, '2015-02-15 00:33:15.000000', 'consum', 0.0225, 'lps'),
	(409003, 125, '2015-02-15 00:33:16.000000', 'consum', 0.0219, 'lps'),
	(409004, 125, '2015-02-15 00:33:17.000000', 'consum', 0.0210, 'lps'),
	(409005, 125, '2015-02-15 00:33:18.000000', 'consum', 0.0218, 'lps'),
	(409006, 125, '2015-02-15 00:33:19.000000', 'consum', 0.0216, 'lps'),
	(409007, 125, '2015-02-15 00:33:20.000000', 'consum', 0.0219, 'lps'),
	(409008, 125, '2015-02-15 00:33:21.000000', 'consum', 0.0218, 'lps'),
	(409009, 125, '2015-02-15 00:33:22.000000', 'consum', 0.0223, 'lps'),
	(409010, 125, '2015-02-15 00:33:23.000000', 'consum', 0.0219, 'lps'),
	(409011, 125, '2015-02-15 00:33:24.000000', 'consum', 0.0215, 'lps'),
	(409012, 125, '2015-02-15 00:33:25.000000', 'consum', 0.0210, 'lps'),
	(409013, 125, '2015-02-15 00:33:26.000000', 'consum', 0.0210, 'lps'),
	(409014, 125, '2015-02-15 00:33:27.000000', 'consum', 0.0213, 'lps'),
	(409015, 125, '2015-02-15 00:33:28.000000', 'consum', 0.0224, 'lps'),
	(409016, 125, '2015-02-15 00:33:29.000000', 'consum', 0.0222, 'lps'),
	(409017, 125, '2015-02-15 00:33:30.000000', 'consum', 0.0226, 'lps'),
	(409018, 125, '2015-02-15 00:33:31.000000', 'consum', 0.0223, 'lps'),
	(409019, 125, '2015-02-15 00:33:32.000000', 'consum', 0.0211, 'lps'),
	(409020, 125, '2015-02-15 00:33:33.000000', 'consum', 0.0211, 'lps'),
	(409021, 125, '2015-02-15 00:33:34.000000', 'consum', 0.0213, 'lps'),
	(409022, 125, '2015-02-15 00:33:35.000000', 'consum', 0.0223, 'lps'),
	(409023, 125, '2015-02-15 00:33:36.000000', 'consum', 0.0215, 'lps'),
	(409024, 125, '2015-02-15 00:33:37.000000', 'consum', 0.0214, 'lps'),
	(409025, 125, '2015-02-15 00:33:38.000000', 'consum', 0.0216, 'lps'),
	(409026, 125, '2015-02-15 00:33:39.000000', 'consum', 0.0212, 'lps'),
	(409027, 125, '2015-02-15 00:33:40.000000', 'consum', 0.0219, 'lps'),
	(409028, 125, '2015-02-15 00:33:41.000000', 'consum', 0.0215, 'lps'),
	(409029, 125, '2015-02-15 00:33:42.000000', 'consum', 0.0226, 'lps'),
	(409030, 125, '2015-02-15 00:33:43.000000', 'consum', 0.0225, 'lps'),
	(409031, 125, '2015-02-15 00:33:44.000000', 'consum', 0.0222, 'lps'),
	(409032, 125, '2015-02-15 00:33:45.000000', 'consum', 0.0225, 'lps'),
	(409033, 125, '2015-02-15 00:33:46.000000', 'consum', 0.0213, 'lps'),
	(409034, 125, '2015-02-15 00:33:47.000000', 'consum', 0.0215, 'lps'),
	(409035, 125, '2015-02-15 00:33:48.000000', 'consum', 0.0210, 'lps'),
	(409036, 125, '2015-02-15 00:33:49.000000', 'consum', 0.0211, 'lps'),
	(409037, 125, '2015-02-15 00:33:50.000000', 'consum', 0.0216, 'lps'),
	(409038, 125, '2015-02-15 00:33:51.000000', 'consum', 0.0220, 'lps'),
	(409039, 125, '2015-02-15 00:33:52.000000', 'consum', 0.0224, 'lps'),
	(409040, 125, '2015-02-15 00:33:53.000000', 'consum', 0.0219, 'lps'),
	(409041, 125, '2015-02-15 00:33:54.000000', 'consum', 0.0212, 'lps'),
	(409042, 125, '2015-02-15 00:33:55.000000', 'consum', 0.0212, 'lps'),
	(409043, 125, '2015-02-15 00:33:56.000000', 'consum', 0.0215, 'lps'),
	(409044, 125, '2015-02-15 00:33:57.000000', 'consum', 0.0212, 'lps'),
	(409045, 125, '2015-02-15 00:33:58.000000', 'consum', 0.0222, 'lps'),
	(409046, 125, '2015-02-15 00:33:59.000000', 'consum', 0.0212, 'lps'),
	(409047, 125, '2015-02-15 00:34:00.000000', 'consum', 0.0222, 'lps'),
	(409048, 125, '2015-02-15 00:34:01.000000', 'consum', 0.0210, 'lps'),
	(409049, 125, '2015-02-15 00:34:02.000000', 'consum', 0.0210, 'lps'),
	(409050, 125, '2015-02-15 00:34:03.000000', 'consum', 0.0210, 'lps'),
	(409051, 125, '2015-02-15 00:34:04.000000', 'consum', 0.0211, 'lps'),
	(409052, 125, '2015-02-15 00:34:05.000000', 'consum', 0.0213, 'lps'),
	(409053, 125, '2015-02-15 00:34:06.000000', 'consum', 0.0226, 'lps'),
	(409054, 125, '2015-02-15 00:34:07.000000', 'consum', 0.0213, 'lps'),
	(409055, 125, '2015-02-15 00:34:08.000000', 'consum', 0.0211, 'lps'),
	(409056, 125, '2015-02-15 00:34:09.000000', 'consum', 0.0225, 'lps'),
	(409057, 125, '2015-02-15 00:34:10.000000', 'consum', 0.0212, 'lps'),
	(409058, 125, '2015-02-15 00:34:11.000000', 'consum', 0.0226, 'lps'),
	(409059, 125, '2015-02-15 00:34:12.000000', 'consum', 0.0218, 'lps'),
	(409060, 125, '2015-02-15 00:34:13.000000', 'consum', 0.0221, 'lps'),
	(409061, 125, '2015-02-15 00:34:14.000000', 'consum', 0.0222, 'lps'),
	(409062, 125, '2015-02-15 00:34:15.000000', 'consum', 0.0220, 'lps'),
	(409063, 125, '2015-02-15 00:34:16.000000', 'consum', 0.0224, 'lps'),
	(409064, 125, '2015-02-15 00:34:17.000000', 'consum', 0.0219, 'lps'),
	(409065, 125, '2015-02-15 00:34:18.000000', 'consum', 0.0211, 'lps'),
	(409066, 125, '2015-02-15 00:34:19.000000', 'consum', 0.0226, 'lps'),
	(409067, 125, '2015-02-15 00:34:20.000000', 'consum', 0.0216, 'lps'),
	(409068, 125, '2015-02-15 00:34:21.000000', 'consum', 0.0212, 'lps'),
	(409069, 125, '2015-02-15 00:34:22.000000', 'consum', 0.0219, 'lps'),
	(409070, 125, '2015-02-15 00:34:23.000000', 'consum', 0.0213, 'lps'),
	(409071, 125, '2015-02-15 00:34:24.000000', 'consum', 0.0219, 'lps'),
	(409072, 125, '2015-02-15 00:34:25.000000', 'consum', 0.0210, 'lps'),
	(409073, 125, '2015-02-15 00:34:26.000000', 'consum', 0.0218, 'lps'),
	(409074, 125, '2015-02-15 00:34:27.000000', 'consum', 0.0217, 'lps'),
	(409075, 125, '2015-02-15 00:34:28.000000', 'consum', 0.0223, 'lps'),
	(409076, 125, '2015-02-15 00:34:29.000000', 'consum', 0.0220, 'lps'),
	(409077, 125, '2015-02-15 00:34:30.000000', 'consum', 0.0221, 'lps'),
	(409078, 125, '2015-02-15 00:34:31.000000', 'consum', 0.0218, 'lps'),
	(409079, 125, '2015-02-15 00:34:32.000000', 'consum', 0.0219, 'lps'),
	(409080, 125, '2015-02-15 00:34:33.000000', 'consum', 0.0213, 'lps'),
	(409081, 125, '2015-02-15 00:34:34.000000', 'consum', 0.0215, 'lps'),
	(409082, 125, '2015-02-15 00:34:35.000000', 'consum', 0.0226, 'lps'),
	(409083, 125, '2015-02-15 00:34:36.000000', 'consum', 0.0226, 'lps'),
	(409084, 125, '2015-02-15 00:34:37.000000', 'consum', 0.0225, 'lps'),
	(409085, 125, '2015-02-15 00:34:38.000000', 'consum', 0.0222, 'lps'),
	(409086, 125, '2015-02-15 00:34:39.000000', 'consum', 0.0223, 'lps'),
	(409087, 125, '2015-02-15 00:34:40.000000', 'consum', 0.0225, 'lps'),
	(409088, 125, '2015-02-15 00:34:41.000000', 'consum', 0.0213, 'lps'),
	(409089, 125, '2015-02-15 00:34:42.000000', 'consum', 0.0213, 'lps'),
	(409090, 125, '2015-02-15 00:34:43.000000', 'consum', 0.0218, 'lps'),
	(409091, 125, '2015-02-15 00:34:44.000000', 'consum', 0.0222, 'lps'),
	(409092, 125, '2015-02-15 00:34:45.000000', 'consum', 0.0213, 'lps'),
	(409093, 125, '2015-02-15 00:34:46.000000', 'consum', 0.0224, 'lps'),
	(409094, 125, '2015-02-15 00:34:47.000000', 'consum', 0.0221, 'lps'),
	(409095, 125, '2015-02-15 00:34:48.000000', 'consum', 0.0222, 'lps'),
	(409096, 125, '2015-02-15 00:34:49.000000', 'consum', 0.0221, 'lps'),
	(409097, 125, '2015-02-15 00:34:50.000000', 'consum', 0.0212, 'lps'),
	(409098, 125, '2015-02-15 00:34:51.000000', 'consum', 0.0222, 'lps'),
	(409099, 125, '2015-02-15 00:34:52.000000', 'consum', 0.0214, 'lps'),
	(409100, 125, '2015-02-15 00:34:53.000000', 'consum', 0.0213, 'lps'),
	(409101, 125, '2015-02-15 00:34:54.000000', 'consum', 0.0213, 'lps'),
	(409102, 125, '2015-02-15 00:34:55.000000', 'consum', 0.0217, 'lps'),
	(409103, 125, '2015-02-15 00:34:56.000000', 'consum', 0.0220, 'lps'),
	(409104, 125, '2015-02-15 00:34:57.000000', 'consum', 0.0221, 'lps'),
	(409105, 125, '2015-02-15 00:34:58.000000', 'consum', 0.0218, 'lps'),
	(409106, 125, '2015-02-15 00:34:59.000000', 'consum', 0.0220, 'lps'),
	(409107, 125, '2015-02-15 00:35:00.000000', 'consum', 0.0218, 'lps'),
	(409108, 125, '2015-02-15 00:35:01.000000', 'consum', 0.0223, 'lps'),
	(409109, 125, '2015-02-15 00:35:02.000000', 'consum', 0.0214, 'lps'),
	(409110, 125, '2015-02-15 00:35:03.000000', 'consum', 0.0210, 'lps'),
	(409111, 125, '2015-02-15 00:35:04.000000', 'consum', 0.0214, 'lps'),
	(409112, 125, '2015-02-15 00:35:05.000000', 'consum', 0.0213, 'lps'),
	(409113, 125, '2015-02-15 00:35:06.000000', 'consum', 0.0213, 'lps'),
	(409114, 125, '2015-02-15 00:35:07.000000', 'consum', 0.0218, 'lps'),
	(409115, 125, '2015-02-15 00:35:08.000000', 'consum', 0.0226, 'lps'),
	(409116, 125, '2015-02-15 00:35:09.000000', 'consum', 0.0215, 'lps'),
	(409117, 125, '2015-02-15 00:35:10.000000', 'consum', 0.0219, 'lps'),
	(409118, 125, '2015-02-15 00:35:11.000000', 'consum', 0.0226, 'lps'),
	(409119, 125, '2015-02-15 00:35:12.000000', 'consum', 0.0210, 'lps'),
	(409120, 125, '2015-02-15 00:35:13.000000', 'consum', 0.0214, 'lps'),
	(409121, 125, '2015-02-15 00:35:14.000000', 'consum', 0.0212, 'lps'),
	(409122, 125, '2015-02-15 00:35:15.000000', 'consum', 0.0211, 'lps'),
	(409123, 125, '2015-02-15 00:35:16.000000', 'consum', 0.0210, 'lps'),
	(409124, 125, '2015-02-15 00:35:17.000000', 'consum', 0.0224, 'lps'),
	(409125, 125, '2015-02-15 00:35:18.000000', 'consum', 0.0211, 'lps'),
	(409126, 125, '2015-02-15 00:35:19.000000', 'consum', 0.0211, 'lps'),
	(409127, 125, '2015-02-15 00:35:20.000000', 'consum', 0.0226, 'lps'),
	(409128, 125, '2015-02-15 00:35:21.000000', 'consum', 0.0219, 'lps'),
	(409129, 125, '2015-02-15 00:35:22.000000', 'consum', 0.0224, 'lps'),
	(409130, 125, '2015-02-15 00:35:23.000000', 'consum', 0.0220, 'lps'),
	(409131, 125, '2015-02-15 00:35:24.000000', 'consum', 0.0221, 'lps'),
	(409132, 125, '2015-02-15 00:35:25.000000', 'consum', 0.0215, 'lps'),
	(409133, 125, '2015-02-15 00:35:26.000000', 'consum', 0.0222, 'lps'),
	(409134, 125, '2015-02-15 00:35:27.000000', 'consum', 0.0221, 'lps'),
	(409135, 125, '2015-02-15 00:35:28.000000', 'consum', 0.0212, 'lps'),
	(409136, 125, '2015-02-15 00:35:29.000000', 'consum', 0.0224, 'lps'),
	(409137, 125, '2015-02-15 00:35:30.000000', 'consum', 0.0221, 'lps'),
	(409138, 125, '2015-02-15 00:35:31.000000', 'consum', 0.0226, 'lps'),
	(409139, 125, '2015-02-15 00:35:32.000000', 'consum', 0.0222, 'lps'),
	(409140, 125, '2015-02-15 00:35:33.000000', 'consum', 0.0223, 'lps'),
	(409141, 125, '2015-02-15 00:35:34.000000', 'consum', 0.0220, 'lps'),
	(409142, 125, '2015-02-15 00:35:35.000000', 'consum', 0.0224, 'lps'),
	(409143, 125, '2015-02-15 00:35:36.000000', 'consum', 0.0216, 'lps'),
	(409144, 125, '2015-02-15 00:35:37.000000', 'consum', 0.0216, 'lps'),
	(409145, 125, '2015-02-15 00:35:38.000000', 'consum', 0.0222, 'lps'),
	(409146, 125, '2015-02-15 00:35:39.000000', 'consum', 0.0220, 'lps'),
	(409147, 125, '2015-02-15 00:35:40.000000', 'consum', 0.0224, 'lps'),
	(409148, 125, '2015-02-15 00:35:41.000000', 'consum', 0.0217, 'lps'),
	(409149, 125, '2015-02-15 00:35:42.000000', 'consum', 0.0222, 'lps'),
	(409150, 125, '2015-02-15 00:35:43.000000', 'consum', 0.0214, 'lps'),
	(409151, 125, '2015-02-15 00:35:44.000000', 'consum', 0.0212, 'lps'),
	(409152, 125, '2015-02-15 00:35:45.000000', 'consum', 0.0210, 'lps'),
	(409153, 125, '2015-02-15 00:35:46.000000', 'consum', 0.0222, 'lps'),
	(409154, 125, '2015-02-15 00:35:47.000000', 'consum', 0.0216, 'lps'),
	(409155, 125, '2015-02-15 00:35:48.000000', 'consum', 0.0224, 'lps'),
	(409156, 125, '2015-02-15 00:35:49.000000', 'consum', 0.0210, 'lps'),
	(409157, 125, '2015-02-15 00:35:50.000000', 'consum', 0.0220, 'lps'),
	(409158, 125, '2015-02-15 00:35:51.000000', 'consum', 0.0212, 'lps'),
	(409159, 125, '2015-02-15 00:35:52.000000', 'consum', 0.0221, 'lps'),
	(409160, 125, '2015-02-15 00:35:53.000000', 'consum', 0.0210, 'lps'),
	(409161, 125, '2015-02-15 00:35:54.000000', 'consum', 0.0213, 'lps'),
	(409162, 125, '2015-02-15 00:35:55.000000', 'consum', 0.0226, 'lps'),
	(409163, 125, '2015-02-15 00:35:56.000000', 'consum', 0.0212, 'lps'),
	(409164, 125, '2015-02-15 00:35:57.000000', 'consum', 0.0222, 'lps'),
	(409165, 125, '2015-02-15 00:35:58.000000', 'consum', 0.0214, 'lps'),
	(409166, 125, '2015-02-15 00:35:59.000000', 'consum', 0.0213, 'lps'),
	(409167, 125, '2015-02-15 00:36:00.000000', 'consum', 0.0215, 'lps'),
	(409168, 125, '2015-02-15 00:36:01.000000', 'consum', 0.0224, 'lps'),
	(409169, 125, '2015-02-15 00:36:02.000000', 'consum', 0.0216, 'lps'),
	(409170, 125, '2015-02-15 00:36:03.000000', 'consum', 0.0214, 'lps'),
	(409171, 125, '2015-02-15 00:36:04.000000', 'consum', 0.0215, 'lps'),
	(409172, 125, '2015-02-15 00:36:05.000000', 'consum', 0.0223, 'lps'),
	(409173, 125, '2015-02-15 00:36:06.000000', 'consum', 0.0210, 'lps'),
	(409174, 125, '2015-02-15 00:36:07.000000', 'consum', 0.0223, 'lps'),
	(409175, 125, '2015-02-15 00:36:08.000000', 'consum', 0.0222, 'lps'),
	(409176, 125, '2015-02-15 00:36:09.000000', 'consum', 0.0217, 'lps'),
	(409177, 125, '2015-02-15 00:36:10.000000', 'consum', 0.0225, 'lps'),
	(409178, 125, '2015-02-15 00:36:11.000000', 'consum', 0.0212, 'lps'),
	(409179, 125, '2015-02-15 00:36:12.000000', 'consum', 0.0211, 'lps'),
	(409180, 125, '2015-02-15 00:36:13.000000', 'consum', 0.0210, 'lps'),
	(409181, 125, '2015-02-15 00:36:14.000000', 'consum', 0.0223, 'lps'),
	(409182, 125, '2015-02-15 00:36:15.000000', 'consum', 0.0225, 'lps'),
	(409183, 125, '2015-02-15 00:36:16.000000', 'consum', 0.0214, 'lps'),
	(409184, 125, '2015-02-15 00:36:17.000000', 'consum', 0.0217, 'lps'),
	(409185, 125, '2015-02-15 00:36:18.000000', 'consum', 0.0217, 'lps'),
	(409186, 125, '2015-02-15 00:36:19.000000', 'consum', 0.0210, 'lps'),
	(409187, 125, '2015-02-15 00:36:20.000000', 'consum', 0.0222, 'lps'),
	(409188, 125, '2015-02-15 00:36:21.000000', 'consum', 0.0218, 'lps'),
	(409189, 125, '2015-02-15 00:36:22.000000', 'consum', 0.0215, 'lps'),
	(409190, 125, '2015-02-15 00:36:23.000000', 'consum', 0.0212, 'lps'),
	(409191, 125, '2015-02-15 00:36:24.000000', 'consum', 0.0222, 'lps'),
	(409192, 125, '2015-02-15 00:36:25.000000', 'consum', 0.0214, 'lps'),
	(409193, 125, '2015-02-15 00:36:26.000000', 'consum', 0.0210, 'lps'),
	(409194, 125, '2015-02-15 00:36:27.000000', 'consum', 0.0217, 'lps'),
	(409195, 125, '2015-02-15 00:36:28.000000', 'consum', 0.0211, 'lps'),
	(409196, 125, '2015-02-15 00:36:29.000000', 'consum', 0.0210, 'lps'),
	(409197, 125, '2015-02-15 00:36:30.000000', 'consum', 0.0210, 'lps'),
	(409198, 125, '2015-02-15 00:36:31.000000', 'consum', 0.0226, 'lps'),
	(409199, 125, '2015-02-15 00:36:32.000000', 'consum', 0.0222, 'lps'),
	(409200, 125, '2015-02-15 00:36:33.000000', 'consum', 0.0223, 'lps'),
	(409201, 125, '2015-02-15 00:36:34.000000', 'consum', 0.0223, 'lps'),
	(409202, 125, '2015-02-15 00:36:35.000000', 'consum', 0.0218, 'lps'),
	(409203, 125, '2015-02-15 00:36:36.000000', 'consum', 0.0214, 'lps'),
	(409204, 125, '2015-02-15 00:36:37.000000', 'consum', 0.0223, 'lps'),
	(409205, 125, '2015-02-15 00:36:38.000000', 'consum', 0.0212, 'lps'),
	(409206, 125, '2015-02-15 00:36:39.000000', 'consum', 0.0216, 'lps'),
	(409207, 125, '2015-02-15 00:36:40.000000', 'consum', 0.0217, 'lps'),
	(409208, 125, '2015-02-15 00:36:41.000000', 'consum', 0.0212, 'lps'),
	(409209, 125, '2015-02-15 00:36:42.000000', 'consum', 0.0216, 'lps'),
	(409210, 125, '2015-02-15 00:36:43.000000', 'consum', 0.0217, 'lps'),
	(409211, 125, '2015-02-15 00:36:44.000000', 'consum', 0.0226, 'lps'),
	(409212, 125, '2015-02-15 00:36:45.000000', 'consum', 0.0218, 'lps'),
	(409213, 125, '2015-02-15 00:36:46.000000', 'consum', 0.0220, 'lps'),
	(409214, 125, '2015-02-15 00:36:47.000000', 'consum', 0.0219, 'lps'),
	(409215, 125, '2015-02-15 00:36:48.000000', 'consum', 0.0210, 'lps'),
	(409216, 125, '2015-02-15 00:36:49.000000', 'consum', 0.0215, 'lps'),
	(409217, 125, '2015-02-15 00:36:50.000000', 'consum', 0.0220, 'lps'),
	(409218, 125, '2015-02-15 00:36:51.000000', 'consum', 0.0211, 'lps'),
	(409219, 125, '2015-02-15 00:36:52.000000', 'consum', 0.0221, 'lps'),
	(409220, 125, '2015-02-15 00:36:53.000000', 'consum', 0.0226, 'lps'),
	(409221, 125, '2015-02-15 00:36:54.000000', 'consum', 0.0224, 'lps'),
	(409222, 125, '2015-02-15 00:36:55.000000', 'consum', 0.0217, 'lps'),
	(409223, 125, '2015-02-15 00:36:56.000000', 'consum', 0.0218, 'lps'),
	(409224, 125, '2015-02-15 00:36:57.000000', 'consum', 0.0213, 'lps'),
	(409225, 125, '2015-02-15 00:36:58.000000', 'consum', 0.0221, 'lps'),
	(409226, 125, '2015-02-15 00:36:59.000000', 'consum', 0.0221, 'lps'),
	(409227, 125, '2015-02-15 00:37:00.000000', 'consum', 0.0217, 'lps'),
	(409228, 125, '2015-02-15 00:37:01.000000', 'consum', 0.0210, 'lps'),
	(409229, 125, '2015-02-15 00:37:02.000000', 'consum', 0.0225, 'lps'),
	(409230, 125, '2015-02-15 00:37:03.000000', 'consum', 0.0219, 'lps'),
	(409231, 125, '2015-02-15 00:37:04.000000', 'consum', 0.0226, 'lps'),
	(409232, 125, '2015-02-15 00:37:05.000000', 'consum', 0.0213, 'lps'),
	(409233, 125, '2015-02-15 00:37:06.000000', 'consum', 0.0212, 'lps'),
	(409234, 125, '2015-02-15 00:37:07.000000', 'consum', 0.0211, 'lps'),
	(409235, 125, '2015-02-15 00:37:08.000000', 'consum', 0.0226, 'lps'),
	(409236, 125, '2015-02-15 00:37:09.000000', 'consum', 0.0219, 'lps'),
	(409237, 125, '2015-02-15 00:37:10.000000', 'consum', 0.0224, 'lps'),
	(409238, 125, '2015-02-15 00:37:11.000000', 'consum', 0.0220, 'lps'),
	(409239, 125, '2015-02-15 00:37:12.000000', 'consum', 0.0218, 'lps'),
	(409240, 125, '2015-02-15 00:37:13.000000', 'consum', 0.0219, 'lps'),
	(409241, 125, '2015-02-15 00:37:14.000000', 'consum', 0.0217, 'lps'),
	(409242, 125, '2015-02-15 00:37:15.000000', 'consum', 0.0217, 'lps'),
	(409243, 125, '2015-02-15 00:37:16.000000', 'consum', 0.0226, 'lps'),
	(409244, 125, '2015-02-15 00:37:17.000000', 'consum', 0.0217, 'lps'),
	(409245, 125, '2015-02-15 00:37:18.000000', 'consum', 0.0216, 'lps'),
	(409246, 125, '2015-02-15 00:37:19.000000', 'consum', 0.0220, 'lps'),
	(409247, 125, '2015-02-15 00:37:20.000000', 'consum', 0.0223, 'lps'),
	(409248, 125, '2015-02-15 00:37:21.000000', 'consum', 0.0214, 'lps'),
	(409249, 125, '2015-02-15 00:37:22.000000', 'consum', 0.0225, 'lps'),
	(409250, 125, '2015-02-15 00:37:23.000000', 'consum', 0.0223, 'lps'),
	(409251, 125, '2015-02-15 00:37:24.000000', 'consum', 0.0212, 'lps'),
	(409252, 125, '2015-02-15 00:37:25.000000', 'consum', 0.0215, 'lps'),
	(409253, 125, '2015-02-15 00:37:26.000000', 'consum', 0.0215, 'lps'),
	(409254, 125, '2015-02-15 00:37:27.000000', 'consum', 0.0220, 'lps'),
	(409255, 125, '2015-02-15 00:37:28.000000', 'consum', 0.0212, 'lps'),
	(409256, 125, '2015-02-15 00:37:29.000000', 'consum', 0.0223, 'lps'),
	(409257, 125, '2015-02-15 00:37:30.000000', 'consum', 0.0217, 'lps'),
	(409258, 125, '2015-02-15 00:37:31.000000', 'consum', 0.0226, 'lps'),
	(409259, 125, '2015-02-15 00:37:32.000000', 'consum', 0.0218, 'lps'),
	(409260, 125, '2015-02-15 00:37:33.000000', 'consum', 0.0221, 'lps'),
	(409261, 125, '2015-02-15 00:37:34.000000', 'consum', 0.0221, 'lps'),
	(409262, 125, '2015-02-15 00:37:35.000000', 'consum', 0.0218, 'lps'),
	(409263, 125, '2015-02-15 00:37:36.000000', 'consum', 0.0219, 'lps'),
	(409264, 125, '2015-02-15 00:37:37.000000', 'consum', 0.0212, 'lps'),
	(409265, 125, '2015-02-15 00:37:38.000000', 'consum', 0.0210, 'lps'),
	(409266, 125, '2015-02-15 00:37:39.000000', 'consum', 0.0224, 'lps'),
	(409267, 125, '2015-02-15 00:37:40.000000', 'consum', 0.0213, 'lps'),
	(409268, 125, '2015-02-15 00:37:41.000000', 'consum', 0.0215, 'lps'),
	(409269, 125, '2015-02-15 00:37:42.000000', 'consum', 0.0210, 'lps'),
	(409270, 125, '2015-02-15 00:37:43.000000', 'consum', 0.0214, 'lps'),
	(409271, 125, '2015-02-15 00:37:44.000000', 'consum', 0.0211, 'lps'),
	(409272, 125, '2015-02-15 00:37:45.000000', 'consum', 0.0221, 'lps'),
	(409273, 125, '2015-02-15 00:37:46.000000', 'consum', 0.0211, 'lps'),
	(409274, 125, '2015-02-15 00:37:47.000000', 'consum', 0.0217, 'lps'),
	(409275, 125, '2015-02-15 00:37:48.000000', 'consum', 0.0226, 'lps'),
	(409276, 125, '2015-02-15 00:37:49.000000', 'consum', 0.0220, 'lps'),
	(409277, 125, '2015-02-15 00:37:50.000000', 'consum', 0.0213, 'lps'),
	(409278, 125, '2015-02-15 00:37:51.000000', 'consum', 0.0210, 'lps'),
	(409279, 125, '2015-02-15 00:37:52.000000', 'consum', 0.0221, 'lps'),
	(409280, 125, '2015-02-15 00:37:53.000000', 'consum', 0.0215, 'lps'),
	(409281, 125, '2015-02-15 00:37:54.000000', 'consum', 0.0217, 'lps'),
	(409282, 125, '2015-02-15 00:37:55.000000', 'consum', 0.0214, 'lps'),
	(409283, 125, '2015-02-15 00:37:56.000000', 'consum', 0.0210, 'lps'),
	(409284, 125, '2015-02-15 00:37:57.000000', 'consum', 0.0215, 'lps'),
	(409285, 125, '2015-02-15 00:37:58.000000', 'consum', 0.0220, 'lps'),
	(409286, 125, '2015-02-15 00:37:59.000000', 'consum', 0.0226, 'lps'),
	(409287, 125, '2015-02-15 00:38:00.000000', 'consum', 0.0226, 'lps'),
	(409288, 125, '2015-02-15 00:38:01.000000', 'consum', 0.0226, 'lps'),
	(409289, 125, '2015-02-15 00:38:02.000000', 'consum', 0.0210, 'lps'),
	(409290, 125, '2015-02-15 00:38:03.000000', 'consum', 0.0214, 'lps'),
	(409291, 125, '2015-02-15 00:38:04.000000', 'consum', 0.0211, 'lps'),
	(409292, 125, '2015-02-15 00:38:05.000000', 'consum', 0.0222, 'lps'),
	(409293, 125, '2015-02-15 00:38:06.000000', 'consum', 0.0217, 'lps'),
	(409294, 125, '2015-02-15 00:38:07.000000', 'consum', 0.0225, 'lps'),
	(409295, 125, '2015-02-15 00:38:08.000000', 'consum', 0.0212, 'lps'),
	(409296, 125, '2015-02-15 00:38:09.000000', 'consum', 0.0212, 'lps'),
	(409297, 125, '2015-02-15 00:38:10.000000', 'consum', 0.0212, 'lps'),
	(409298, 125, '2015-02-15 00:38:11.000000', 'consum', 0.0217, 'lps'),
	(409299, 125, '2015-02-15 00:38:12.000000', 'consum', 0.0223, 'lps'),
	(409300, 125, '2015-02-15 00:38:13.000000', 'consum', 0.0217, 'lps'),
	(409301, 125, '2015-02-15 00:38:14.000000', 'consum', 0.0210, 'lps'),
	(409302, 125, '2015-02-15 00:38:15.000000', 'consum', 0.0222, 'lps'),
	(409303, 125, '2015-02-15 00:38:16.000000', 'consum', 0.0221, 'lps'),
	(409304, 125, '2015-02-15 00:38:17.000000', 'consum', 0.0212, 'lps'),
	(409305, 125, '2015-02-15 00:38:18.000000', 'consum', 0.0221, 'lps'),
	(409306, 125, '2015-02-15 00:38:19.000000', 'consum', 0.0226, 'lps'),
	(409307, 125, '2015-02-15 00:38:20.000000', 'consum', 0.0224, 'lps'),
	(409308, 125, '2015-02-15 00:38:21.000000', 'consum', 0.0215, 'lps'),
	(409309, 125, '2015-02-15 00:38:22.000000', 'consum', 0.0211, 'lps'),
	(409310, 125, '2015-02-15 00:38:23.000000', 'consum', 0.0216, 'lps'),
	(409311, 125, '2015-02-15 00:38:24.000000', 'consum', 0.0220, 'lps'),
	(409312, 125, '2015-02-15 00:38:25.000000', 'consum', 0.0210, 'lps'),
	(409313, 125, '2015-02-15 00:38:26.000000', 'consum', 0.0214, 'lps'),
	(409314, 125, '2015-02-15 00:38:27.000000', 'consum', 0.0213, 'lps'),
	(409315, 125, '2015-02-15 00:38:28.000000', 'consum', 0.0213, 'lps'),
	(409316, 125, '2015-02-15 00:38:29.000000', 'consum', 0.0217, 'lps'),
	(409317, 125, '2015-02-15 00:38:30.000000', 'consum', 0.0220, 'lps'),
	(409318, 125, '2015-02-15 00:38:31.000000', 'consum', 0.0224, 'lps'),
	(409319, 125, '2015-02-15 00:38:32.000000', 'consum', 0.0215, 'lps'),
	(409320, 125, '2015-02-15 00:38:33.000000', 'consum', 0.0211, 'lps'),
	(409321, 125, '2015-02-15 00:38:34.000000', 'consum', 0.0218, 'lps'),
	(409322, 125, '2015-02-15 00:38:35.000000', 'consum', 0.0211, 'lps'),
	(409323, 125, '2015-02-15 00:38:36.000000', 'consum', 0.0211, 'lps'),
	(409324, 125, '2015-02-15 00:38:37.000000', 'consum', 0.0210, 'lps'),
	(409325, 125, '2015-02-15 00:38:38.000000', 'consum', 0.0226, 'lps'),
	(409326, 125, '2015-02-15 00:38:39.000000', 'consum', 0.0220, 'lps'),
	(409327, 125, '2015-02-15 00:38:40.000000', 'consum', 0.0215, 'lps'),
	(409328, 125, '2015-02-15 00:38:41.000000', 'consum', 0.0221, 'lps'),
	(409329, 125, '2015-02-15 00:38:42.000000', 'consum', 0.0219, 'lps'),
	(409330, 125, '2015-02-15 00:38:43.000000', 'consum', 0.0221, 'lps'),
	(409331, 125, '2015-02-15 00:38:44.000000', 'consum', 0.0222, 'lps'),
	(409332, 125, '2015-02-15 00:38:45.000000', 'consum', 0.0222, 'lps'),
	(409333, 125, '2015-02-15 00:38:46.000000', 'consum', 0.0215, 'lps'),
	(409334, 125, '2015-02-15 00:38:47.000000', 'consum', 0.0217, 'lps'),
	(409335, 125, '2015-02-15 00:38:48.000000', 'consum', 0.0215, 'lps'),
	(409336, 125, '2015-02-15 00:38:49.000000', 'consum', 0.0213, 'lps'),
	(409337, 125, '2015-02-15 00:38:50.000000', 'consum', 0.0212, 'lps'),
	(409338, 125, '2015-02-15 00:38:51.000000', 'consum', 0.0213, 'lps'),
	(409339, 125, '2015-02-15 00:38:52.000000', 'consum', 0.0216, 'lps'),
	(409340, 125, '2015-02-15 00:38:53.000000', 'consum', 0.0215, 'lps'),
	(409341, 125, '2015-02-15 00:38:54.000000', 'consum', 0.0219, 'lps'),
	(409342, 125, '2015-02-15 00:38:55.000000', 'consum', 0.0224, 'lps'),
	(409343, 125, '2015-02-15 00:38:56.000000', 'consum', 0.0217, 'lps'),
	(409344, 125, '2015-02-15 00:38:57.000000', 'consum', 0.0222, 'lps'),
	(409345, 125, '2015-02-15 00:38:58.000000', 'consum', 0.0215, 'lps'),
	(409346, 125, '2015-02-15 00:38:59.000000', 'consum', 0.0218, 'lps'),
	(409347, 125, '2015-02-15 00:39:00.000000', 'consum', 0.0216, 'lps'),
	(409348, 125, '2015-02-15 00:39:01.000000', 'consum', 0.0216, 'lps'),
	(409349, 125, '2015-02-15 00:39:02.000000', 'consum', 0.0225, 'lps'),
	(409350, 125, '2015-02-15 00:39:03.000000', 'consum', 0.0217, 'lps'),
	(409351, 125, '2015-02-15 00:39:04.000000', 'consum', 0.0215, 'lps'),
	(409352, 125, '2015-02-15 00:39:05.000000', 'consum', 0.0216, 'lps'),
	(409353, 125, '2015-02-15 00:39:06.000000', 'consum', 0.0225, 'lps'),
	(409354, 125, '2015-02-15 00:39:07.000000', 'consum', 0.0216, 'lps'),
	(409355, 125, '2015-02-15 00:39:08.000000', 'consum', 0.0213, 'lps'),
	(409356, 125, '2015-02-15 00:39:09.000000', 'consum', 0.0222, 'lps'),
	(409357, 125, '2015-02-15 00:39:10.000000', 'consum', 0.0214, 'lps'),
	(409358, 125, '2015-02-15 00:39:11.000000', 'consum', 0.0211, 'lps'),
	(409359, 125, '2015-02-15 00:39:12.000000', 'consum', 0.0218, 'lps'),
	(409360, 125, '2015-02-15 00:39:13.000000', 'consum', 0.0214, 'lps'),
	(409361, 125, '2015-02-15 00:39:14.000000', 'consum', 0.0225, 'lps'),
	(409362, 125, '2015-02-15 00:39:15.000000', 'consum', 0.0222, 'lps'),
	(409363, 125, '2015-02-15 00:39:16.000000', 'consum', 0.0210, 'lps'),
	(409364, 125, '2015-02-15 00:39:17.000000', 'consum', 0.0226, 'lps'),
	(409365, 125, '2015-02-15 00:39:18.000000', 'consum', 0.0221, 'lps'),
	(409366, 125, '2015-02-15 00:39:19.000000', 'consum', 0.0217, 'lps'),
	(409367, 125, '2015-02-15 00:39:20.000000', 'consum', 0.0212, 'lps'),
	(409368, 125, '2015-02-15 00:39:21.000000', 'consum', 0.0216, 'lps'),
	(409369, 125, '2015-02-15 00:39:22.000000', 'consum', 0.0218, 'lps'),
	(409370, 125, '2015-02-15 00:39:23.000000', 'consum', 0.0215, 'lps'),
	(409371, 125, '2015-02-15 00:39:24.000000', 'consum', 0.0211, 'lps'),
	(409372, 125, '2015-02-15 00:39:25.000000', 'consum', 0.0220, 'lps'),
	(409373, 125, '2015-02-15 00:39:26.000000', 'consum', 0.0223, 'lps'),
	(409374, 125, '2015-02-15 00:39:27.000000', 'consum', 0.0210, 'lps'),
	(409375, 125, '2015-02-15 00:39:28.000000', 'consum', 0.0224, 'lps'),
	(409376, 125, '2015-02-15 00:39:29.000000', 'consum', 0.0214, 'lps'),
	(409377, 125, '2015-02-15 00:39:30.000000', 'consum', 0.0220, 'lps'),
	(409378, 125, '2015-02-15 00:39:31.000000', 'consum', 0.0213, 'lps'),
	(409379, 125, '2015-02-15 00:39:32.000000', 'consum', 0.0215, 'lps'),
	(409380, 125, '2015-02-15 00:39:33.000000', 'consum', 0.0224, 'lps'),
	(409381, 125, '2015-02-15 00:39:34.000000', 'consum', 0.0217, 'lps'),
	(409382, 125, '2015-02-15 00:39:35.000000', 'consum', 0.0220, 'lps'),
	(409383, 125, '2015-02-15 00:39:36.000000', 'consum', 0.0224, 'lps'),
	(409384, 125, '2015-02-15 00:39:37.000000', 'consum', 0.0216, 'lps'),
	(409385, 125, '2015-02-15 00:39:38.000000', 'consum', 0.0213, 'lps'),
	(409386, 125, '2015-02-15 00:39:39.000000', 'consum', 0.0210, 'lps'),
	(409387, 125, '2015-02-15 00:39:40.000000', 'consum', 0.0220, 'lps'),
	(409388, 125, '2015-02-15 00:39:41.000000', 'consum', 0.0223, 'lps'),
	(409389, 125, '2015-02-15 00:39:42.000000', 'consum', 0.0212, 'lps'),
	(409390, 125, '2015-02-15 00:39:43.000000', 'consum', 0.0216, 'lps'),
	(409391, 125, '2015-02-15 00:39:44.000000', 'consum', 0.0218, 'lps'),
	(409392, 125, '2015-02-15 00:39:45.000000', 'consum', 0.0213, 'lps'),
	(409393, 125, '2015-02-15 00:39:46.000000', 'consum', 0.0221, 'lps'),
	(409394, 125, '2015-02-15 00:39:47.000000', 'consum', 0.0223, 'lps'),
	(409395, 125, '2015-02-15 00:39:48.000000', 'consum', 0.0226, 'lps'),
	(409396, 125, '2015-02-15 00:39:49.000000', 'consum', 0.0216, 'lps'),
	(409397, 125, '2015-02-15 00:39:50.000000', 'consum', 0.0210, 'lps'),
	(409398, 125, '2015-02-15 00:39:51.000000', 'consum', 0.0211, 'lps'),
	(409399, 125, '2015-02-15 00:39:52.000000', 'consum', 0.0213, 'lps'),
	(409400, 125, '2015-02-15 00:39:53.000000', 'consum', 0.0222, 'lps'),
	(409401, 125, '2015-02-15 00:39:54.000000', 'consum', 0.0211, 'lps'),
	(409402, 125, '2015-02-15 00:39:55.000000', 'consum', 0.0215, 'lps'),
	(409403, 125, '2015-02-15 00:39:56.000000', 'consum', 0.0215, 'lps'),
	(409404, 125, '2015-02-15 00:39:57.000000', 'consum', 0.0219, 'lps'),
	(409405, 125, '2015-02-15 00:39:58.000000', 'consum', 0.0224, 'lps'),
	(409406, 125, '2015-02-15 00:39:59.000000', 'consum', 0.0222, 'lps'),
	(409407, 125, '2015-02-15 00:40:00.000000', 'consum', 0.0226, 'lps'),
	(409408, 125, '2015-02-15 00:40:01.000000', 'consum', 0.0221, 'lps'),
	(409409, 125, '2015-02-15 00:40:02.000000', 'consum', 0.0217, 'lps'),
	(409410, 125, '2015-02-15 00:40:03.000000', 'consum', 0.0213, 'lps'),
	(409411, 125, '2015-02-15 00:40:04.000000', 'consum', 0.0223, 'lps'),
	(409412, 125, '2015-02-15 00:40:05.000000', 'consum', 0.0213, 'lps'),
	(409413, 125, '2015-02-15 00:40:06.000000', 'consum', 0.0222, 'lps'),
	(409414, 125, '2015-02-15 00:40:07.000000', 'consum', 0.0212, 'lps'),
	(409415, 125, '2015-02-15 00:40:08.000000', 'consum', 0.0216, 'lps'),
	(409416, 125, '2015-02-15 00:40:09.000000', 'consum', 0.0218, 'lps'),
	(409417, 125, '2015-02-15 00:40:10.000000', 'consum', 0.0214, 'lps'),
	(409418, 125, '2015-02-15 00:40:11.000000', 'consum', 0.0223, 'lps'),
	(409419, 125, '2015-02-15 00:40:12.000000', 'consum', 0.0215, 'lps'),
	(409420, 125, '2015-02-15 00:40:13.000000', 'consum', 0.0211, 'lps'),
	(409421, 125, '2015-02-15 00:40:14.000000', 'consum', 0.0219, 'lps'),
	(409422, 125, '2015-02-15 00:40:15.000000', 'consum', 0.0217, 'lps'),
	(409423, 125, '2015-02-15 00:40:16.000000', 'consum', 0.0221, 'lps'),
	(409424, 125, '2015-02-15 00:40:17.000000', 'consum', 0.0226, 'lps'),
	(409425, 125, '2015-02-15 00:40:18.000000', 'consum', 0.0223, 'lps'),
	(409426, 125, '2015-02-15 00:40:19.000000', 'consum', 0.0211, 'lps'),
	(409427, 125, '2015-02-15 00:40:20.000000', 'consum', 0.0212, 'lps'),
	(409428, 125, '2015-02-15 00:40:21.000000', 'consum', 0.0218, 'lps'),
	(409429, 125, '2015-02-15 00:40:22.000000', 'consum', 0.0211, 'lps'),
	(409430, 125, '2015-02-15 00:40:23.000000', 'consum', 0.0225, 'lps'),
	(409431, 125, '2015-02-15 00:40:24.000000', 'consum', 0.0213, 'lps'),
	(409432, 125, '2015-02-15 00:40:25.000000', 'consum', 0.0215, 'lps'),
	(409433, 125, '2015-02-15 00:40:26.000000', 'consum', 0.0226, 'lps'),
	(409434, 125, '2015-02-15 00:40:27.000000', 'consum', 0.0225, 'lps'),
	(409435, 125, '2015-02-15 00:40:28.000000', 'consum', 0.0218, 'lps'),
	(409436, 125, '2015-02-15 00:40:29.000000', 'consum', 0.0226, 'lps'),
	(409437, 125, '2015-02-15 00:40:30.000000', 'consum', 0.0215, 'lps'),
	(409438, 125, '2015-02-15 00:40:31.000000', 'consum', 0.0222, 'lps'),
	(409439, 125, '2015-02-15 00:40:32.000000', 'consum', 0.0222, 'lps'),
	(409440, 125, '2015-02-15 00:40:33.000000', 'consum', 0.0217, 'lps'),
	(409441, 125, '2015-02-15 00:40:34.000000', 'consum', 0.0226, 'lps'),
	(409442, 125, '2015-02-15 00:40:35.000000', 'consum', 0.0217, 'lps'),
	(409443, 125, '2015-02-15 00:40:36.000000', 'consum', 0.0217, 'lps'),
	(409444, 125, '2015-02-15 00:40:37.000000', 'consum', 0.0224, 'lps'),
	(409445, 125, '2015-02-15 00:40:38.000000', 'consum', 0.0224, 'lps'),
	(409446, 125, '2015-02-15 00:40:39.000000', 'consum', 0.0224, 'lps'),
	(409447, 125, '2015-02-15 00:40:40.000000', 'consum', 0.0220, 'lps'),
	(409448, 125, '2015-02-15 00:40:41.000000', 'consum', 0.0221, 'lps'),
	(409449, 125, '2015-02-15 00:40:42.000000', 'consum', 0.0215, 'lps'),
	(409450, 125, '2015-02-15 00:40:43.000000', 'consum', 0.0223, 'lps'),
	(409451, 125, '2015-02-15 00:40:44.000000', 'consum', 0.0224, 'lps'),
	(409452, 125, '2015-02-15 00:40:45.000000', 'consum', 0.0224, 'lps'),
	(409453, 125, '2015-02-15 00:40:46.000000', 'consum', 0.0224, 'lps'),
	(409454, 125, '2015-02-15 00:40:47.000000', 'consum', 0.0220, 'lps'),
	(409455, 125, '2015-02-15 00:40:48.000000', 'consum', 0.0218, 'lps'),
	(409456, 125, '2015-02-15 00:40:49.000000', 'consum', 0.0220, 'lps'),
	(409457, 125, '2015-02-15 00:40:50.000000', 'consum', 0.0222, 'lps'),
	(409458, 125, '2015-02-15 00:40:51.000000', 'consum', 0.0221, 'lps'),
	(409459, 125, '2015-02-15 00:40:52.000000', 'consum', 0.0214, 'lps'),
	(409460, 125, '2015-02-15 00:40:53.000000', 'consum', 0.0213, 'lps'),
	(409461, 125, '2015-02-15 00:40:54.000000', 'consum', 0.0215, 'lps'),
	(409462, 125, '2015-02-15 00:40:55.000000', 'consum', 0.0224, 'lps'),
	(409463, 125, '2015-02-15 00:40:56.000000', 'consum', 0.0217, 'lps'),
	(409464, 125, '2015-02-15 00:40:57.000000', 'consum', 0.0218, 'lps'),
	(409465, 125, '2015-02-15 00:40:58.000000', 'consum', 0.0214, 'lps'),
	(409466, 125, '2015-02-15 00:40:59.000000', 'consum', 0.0225, 'lps'),
	(409467, 125, '2015-02-15 00:41:00.000000', 'consum', 0.0221, 'lps'),
	(409468, 125, '2015-02-15 00:41:01.000000', 'consum', 0.0222, 'lps'),
	(409469, 125, '2015-02-15 00:41:02.000000', 'consum', 0.0220, 'lps'),
	(409470, 125, '2015-02-15 00:41:03.000000', 'consum', 0.0223, 'lps'),
	(409471, 125, '2015-02-15 00:41:04.000000', 'consum', 0.0214, 'lps'),
	(409472, 125, '2015-02-15 00:41:05.000000', 'consum', 0.0226, 'lps'),
	(409473, 125, '2015-02-15 00:41:06.000000', 'consum', 0.0210, 'lps'),
	(409474, 125, '2015-02-15 00:41:07.000000', 'consum', 0.0212, 'lps'),
	(409475, 125, '2015-02-15 00:41:08.000000', 'consum', 0.0222, 'lps'),
	(409476, 125, '2015-02-15 00:41:09.000000', 'consum', 0.0214, 'lps'),
	(409477, 125, '2015-02-15 00:41:10.000000', 'consum', 0.0226, 'lps'),
	(409478, 125, '2015-02-15 00:41:11.000000', 'consum', 0.0211, 'lps'),
	(409479, 125, '2015-02-15 00:41:12.000000', 'consum', 0.0220, 'lps'),
	(409480, 125, '2015-02-15 00:41:13.000000', 'consum', 0.0224, 'lps'),
	(409481, 125, '2015-02-15 00:41:14.000000', 'consum', 0.0217, 'lps'),
	(409482, 125, '2015-02-15 00:41:15.000000', 'consum', 0.0222, 'lps'),
	(409483, 125, '2015-02-15 00:41:16.000000', 'consum', 0.0212, 'lps'),
	(409484, 125, '2015-02-15 00:41:17.000000', 'consum', 0.0219, 'lps'),
	(409485, 125, '2015-02-15 00:41:18.000000', 'consum', 0.0215, 'lps'),
	(409486, 125, '2015-02-15 00:41:19.000000', 'consum', 0.0210, 'lps'),
	(409487, 125, '2015-02-15 00:41:20.000000', 'consum', 0.0211, 'lps'),
	(409488, 125, '2015-02-15 00:41:21.000000', 'consum', 0.0215, 'lps'),
	(409489, 125, '2015-02-15 00:41:22.000000', 'consum', 0.0218, 'lps'),
	(409490, 125, '2015-02-15 00:41:23.000000', 'consum', 0.0216, 'lps'),
	(409491, 125, '2015-02-15 00:41:24.000000', 'consum', 0.0216, 'lps'),
	(409492, 125, '2015-02-15 00:41:25.000000', 'consum', 0.0223, 'lps'),
	(409493, 125, '2015-02-15 00:41:26.000000', 'consum', 0.0224, 'lps'),
	(409494, 125, '2015-02-15 00:41:27.000000', 'consum', 0.0226, 'lps'),
	(409495, 125, '2015-02-15 00:41:28.000000', 'consum', 0.0214, 'lps'),
	(409496, 125, '2015-02-15 00:41:29.000000', 'consum', 0.0214, 'lps'),
	(409497, 125, '2015-02-15 00:41:30.000000', 'consum', 0.0220, 'lps'),
	(409498, 125, '2015-02-15 00:41:31.000000', 'consum', 0.0214, 'lps'),
	(409499, 125, '2015-02-15 00:41:32.000000', 'consum', 0.0217, 'lps'),
	(409500, 125, '2015-02-15 00:41:33.000000', 'consum', 0.0219, 'lps'),
	(409501, 125, '2015-02-15 00:41:34.000000', 'consum', 0.0216, 'lps'),
	(409502, 125, '2015-02-15 00:41:35.000000', 'consum', 0.0214, 'lps'),
	(409503, 125, '2015-02-15 00:41:36.000000', 'consum', 0.0213, 'lps'),
	(409504, 125, '2015-02-15 00:41:37.000000', 'consum', 0.0211, 'lps'),
	(409505, 125, '2015-02-15 00:41:38.000000', 'consum', 0.0225, 'lps'),
	(409506, 125, '2015-02-15 00:41:39.000000', 'consum', 0.0215, 'lps'),
	(409507, 125, '2015-02-15 00:41:40.000000', 'consum', 0.0226, 'lps'),
	(409508, 125, '2015-02-15 00:41:41.000000', 'consum', 0.0222, 'lps'),
	(409509, 125, '2015-02-15 00:41:42.000000', 'consum', 0.0221, 'lps'),
	(409510, 125, '2015-02-15 00:41:43.000000', 'consum', 0.0216, 'lps'),
	(409511, 125, '2015-02-15 00:41:44.000000', 'consum', 0.0223, 'lps'),
	(409512, 125, '2015-02-15 00:41:45.000000', 'consum', 0.0225, 'lps'),
	(409513, 125, '2015-02-15 00:41:46.000000', 'consum', 0.0212, 'lps'),
	(409514, 125, '2015-02-15 00:41:47.000000', 'consum', 0.0226, 'lps'),
	(409515, 125, '2015-02-15 00:41:48.000000', 'consum', 0.0215, 'lps'),
	(409516, 125, '2015-02-15 00:41:49.000000', 'consum', 0.0223, 'lps'),
	(409517, 125, '2015-02-15 00:41:50.000000', 'consum', 0.0210, 'lps'),
	(409518, 125, '2015-02-15 00:41:51.000000', 'consum', 0.0222, 'lps'),
	(409519, 125, '2015-02-15 00:41:52.000000', 'consum', 0.0219, 'lps'),
	(409520, 125, '2015-02-15 00:41:53.000000', 'consum', 0.0220, 'lps'),
	(409521, 125, '2015-02-15 00:41:54.000000', 'consum', 0.0217, 'lps'),
	(409522, 125, '2015-02-15 00:41:55.000000', 'consum', 0.0215, 'lps'),
	(409523, 125, '2015-02-15 00:41:56.000000', 'consum', 0.0213, 'lps'),
	(409524, 125, '2015-02-15 00:41:57.000000', 'consum', 0.0212, 'lps'),
	(409525, 125, '2015-02-15 00:41:58.000000', 'consum', 0.0212, 'lps'),
	(409526, 125, '2015-02-15 00:41:59.000000', 'consum', 0.0214, 'lps'),
	(409527, 125, '2015-02-15 00:42:00.000000', 'consum', 0.0226, 'lps'),
	(409528, 125, '2015-02-15 00:42:01.000000', 'consum', 0.0225, 'lps'),
	(409529, 125, '2015-02-15 00:42:02.000000', 'consum', 0.0220, 'lps'),
	(409530, 125, '2015-02-15 00:42:03.000000', 'consum', 0.0217, 'lps'),
	(409531, 125, '2015-02-15 00:42:04.000000', 'consum', 0.0214, 'lps'),
	(409532, 125, '2015-02-15 00:42:05.000000', 'consum', 0.0225, 'lps'),
	(409533, 125, '2015-02-15 00:42:06.000000', 'consum', 0.0226, 'lps'),
	(409534, 125, '2015-02-15 00:42:07.000000', 'consum', 0.0226, 'lps'),
	(409535, 125, '2015-02-15 00:42:08.000000', 'consum', 0.0210, 'lps'),
	(409536, 125, '2015-02-15 00:42:09.000000', 'consum', 0.0212, 'lps'),
	(409537, 125, '2015-02-15 00:42:10.000000', 'consum', 0.0223, 'lps'),
	(409538, 125, '2015-02-15 00:42:11.000000', 'consum', 0.0219, 'lps'),
	(409539, 125, '2015-02-15 00:42:12.000000', 'consum', 0.0214, 'lps'),
	(409540, 125, '2015-02-15 00:42:13.000000', 'consum', 0.0223, 'lps'),
	(409541, 125, '2015-02-15 00:42:14.000000', 'consum', 0.0212, 'lps'),
	(409542, 125, '2015-02-15 00:42:15.000000', 'consum', 0.0216, 'lps'),
	(409543, 125, '2015-02-15 00:42:16.000000', 'consum', 0.0215, 'lps'),
	(409544, 125, '2015-02-15 00:42:17.000000', 'consum', 0.0218, 'lps'),
	(409545, 125, '2015-02-15 00:42:18.000000', 'consum', 0.0217, 'lps'),
	(409546, 125, '2015-02-15 00:42:19.000000', 'consum', 0.0224, 'lps'),
	(409547, 125, '2015-02-15 00:42:20.000000', 'consum', 0.0224, 'lps'),
	(409548, 125, '2015-02-15 00:42:21.000000', 'consum', 0.0221, 'lps'),
	(409549, 125, '2015-02-15 00:42:22.000000', 'consum', 0.0223, 'lps'),
	(409550, 125, '2015-02-15 00:42:23.000000', 'consum', 0.0211, 'lps'),
	(409551, 125, '2015-02-15 00:42:24.000000', 'consum', 0.0210, 'lps'),
	(409552, 125, '2015-02-15 00:42:25.000000', 'consum', 0.0224, 'lps'),
	(409553, 125, '2015-02-15 00:42:26.000000', 'consum', 0.0213, 'lps'),
	(409554, 125, '2015-02-15 00:42:27.000000', 'consum', 0.0219, 'lps'),
	(409555, 125, '2015-02-15 00:42:28.000000', 'consum', 0.0210, 'lps'),
	(409556, 125, '2015-02-15 00:42:29.000000', 'consum', 0.0217, 'lps'),
	(409557, 125, '2015-02-15 00:42:30.000000', 'consum', 0.0212, 'lps'),
	(409558, 125, '2015-02-15 00:42:31.000000', 'consum', 0.0218, 'lps'),
	(409559, 125, '2015-02-15 00:42:32.000000', 'consum', 0.0225, 'lps'),
	(409560, 125, '2015-02-15 00:42:33.000000', 'consum', 0.0211, 'lps'),
	(409561, 125, '2015-02-15 00:42:34.000000', 'consum', 0.0223, 'lps'),
	(409562, 125, '2015-02-15 00:42:35.000000', 'consum', 0.0221, 'lps'),
	(409563, 125, '2015-02-15 00:42:36.000000', 'consum', 0.0211, 'lps'),
	(409564, 125, '2015-02-15 00:42:37.000000', 'consum', 0.0217, 'lps'),
	(409565, 125, '2015-02-15 00:42:38.000000', 'consum', 0.0225, 'lps'),
	(409566, 125, '2015-02-15 00:42:39.000000', 'consum', 0.0211, 'lps'),
	(409567, 125, '2015-02-15 00:42:40.000000', 'consum', 0.0224, 'lps'),
	(409568, 125, '2015-02-15 00:42:41.000000', 'consum', 0.0224, 'lps'),
	(409569, 125, '2015-02-15 00:42:42.000000', 'consum', 0.0222, 'lps'),
	(409570, 125, '2015-02-15 00:42:43.000000', 'consum', 0.0211, 'lps'),
	(409571, 125, '2015-02-15 00:42:44.000000', 'consum', 0.0216, 'lps'),
	(409572, 125, '2015-02-15 00:42:45.000000', 'consum', 0.0219, 'lps'),
	(409573, 125, '2015-02-15 00:42:46.000000', 'consum', 0.0222, 'lps'),
	(409574, 125, '2015-02-15 00:42:47.000000', 'consum', 0.0210, 'lps'),
	(409575, 125, '2015-02-15 00:42:48.000000', 'consum', 0.0224, 'lps'),
	(409576, 125, '2015-02-15 00:42:49.000000', 'consum', 0.0212, 'lps'),
	(409577, 125, '2015-02-15 00:42:50.000000', 'consum', 0.0212, 'lps'),
	(409578, 125, '2015-02-15 00:42:51.000000', 'consum', 0.0216, 'lps'),
	(409579, 125, '2015-02-15 00:42:52.000000', 'consum', 0.0217, 'lps'),
	(409580, 125, '2015-02-15 00:42:53.000000', 'consum', 0.0211, 'lps'),
	(409581, 125, '2015-02-15 00:42:54.000000', 'consum', 0.0213, 'lps'),
	(409582, 125, '2015-02-15 00:42:55.000000', 'consum', 0.0222, 'lps'),
	(409583, 125, '2015-02-15 00:42:56.000000', 'consum', 0.0210, 'lps'),
	(409584, 125, '2015-02-15 00:42:57.000000', 'consum', 0.0225, 'lps'),
	(409585, 125, '2015-02-15 00:42:58.000000', 'consum', 0.0216, 'lps'),
	(409586, 125, '2015-02-15 00:42:59.000000', 'consum', 0.0215, 'lps'),
	(409587, 125, '2015-02-15 00:43:00.000000', 'consum', 0.0219, 'lps'),
	(409588, 125, '2015-02-15 00:43:01.000000', 'consum', 0.0221, 'lps'),
	(409589, 125, '2015-02-15 00:43:02.000000', 'consum', 0.0222, 'lps'),
	(409590, 125, '2015-02-15 00:43:03.000000', 'consum', 0.0220, 'lps'),
	(409591, 125, '2015-02-15 00:43:04.000000', 'consum', 0.0224, 'lps'),
	(409592, 125, '2015-02-15 00:43:05.000000', 'consum', 0.0218, 'lps'),
	(409593, 125, '2015-02-15 00:43:06.000000', 'consum', 0.0225, 'lps'),
	(409594, 125, '2015-02-15 00:43:07.000000', 'consum', 0.0211, 'lps'),
	(409595, 125, '2015-02-15 00:43:08.000000', 'consum', 0.0220, 'lps'),
	(409596, 125, '2015-02-15 00:43:09.000000', 'consum', 0.0225, 'lps'),
	(409597, 125, '2015-02-15 00:43:10.000000', 'consum', 0.0223, 'lps'),
	(409598, 125, '2015-02-15 00:43:11.000000', 'consum', 0.0210, 'lps'),
	(409599, 125, '2015-02-15 00:43:12.000000', 'consum', 0.0226, 'lps'),
	(409600, 125, '2015-02-15 00:43:13.000000', 'consum', 0.0220, 'lps'),
	(409601, 125, '2015-02-15 00:43:14.000000', 'consum', 0.0211, 'lps'),
	(409602, 125, '2015-02-15 00:43:15.000000', 'consum', 0.0222, 'lps'),
	(409603, 125, '2015-02-15 00:43:16.000000', 'consum', 0.0216, 'lps'),
	(409604, 125, '2015-02-15 00:43:17.000000', 'consum', 0.0223, 'lps'),
	(409605, 125, '2015-02-15 00:43:18.000000', 'consum', 0.0224, 'lps'),
	(409606, 125, '2015-02-15 00:43:19.000000', 'consum', 0.0225, 'lps'),
	(409607, 125, '2015-02-15 00:43:20.000000', 'consum', 0.0210, 'lps'),
	(409608, 125, '2015-02-15 00:43:21.000000', 'consum', 0.0214, 'lps'),
	(409609, 125, '2015-02-15 00:43:22.000000', 'consum', 0.0214, 'lps'),
	(409610, 125, '2015-02-15 00:43:23.000000', 'consum', 0.0220, 'lps'),
	(409611, 125, '2015-02-15 00:43:24.000000', 'consum', 0.0216, 'lps'),
	(409612, 125, '2015-02-15 00:43:25.000000', 'consum', 0.0225, 'lps'),
	(409613, 125, '2015-02-15 00:43:26.000000', 'consum', 0.0217, 'lps'),
	(409614, 125, '2015-02-15 00:43:27.000000', 'consum', 0.0220, 'lps'),
	(409615, 125, '2015-02-15 00:43:28.000000', 'consum', 0.0219, 'lps'),
	(409616, 125, '2015-02-15 00:43:29.000000', 'consum', 0.0226, 'lps'),
	(409617, 125, '2015-02-15 00:43:30.000000', 'consum', 0.0212, 'lps'),
	(409618, 125, '2015-02-15 00:43:31.000000', 'consum', 0.0222, 'lps'),
	(409619, 125, '2015-02-15 00:43:32.000000', 'consum', 0.0216, 'lps'),
	(409620, 125, '2015-02-15 00:43:33.000000', 'consum', 0.0219, 'lps'),
	(409621, 125, '2015-02-15 00:43:34.000000', 'consum', 0.0222, 'lps'),
	(409622, 125, '2015-02-15 00:43:35.000000', 'consum', 0.0211, 'lps'),
	(409623, 125, '2015-02-15 00:43:36.000000', 'consum', 0.0214, 'lps'),
	(409624, 125, '2015-02-15 00:43:37.000000', 'consum', 0.0210, 'lps'),
	(409625, 125, '2015-02-15 00:43:38.000000', 'consum', 0.0213, 'lps'),
	(409626, 125, '2015-02-15 00:43:39.000000', 'consum', 0.0211, 'lps'),
	(409627, 125, '2015-02-15 00:43:40.000000', 'consum', 0.0222, 'lps'),
	(409628, 125, '2015-02-15 00:43:41.000000', 'consum', 0.0216, 'lps'),
	(409629, 125, '2015-02-15 00:43:42.000000', 'consum', 0.0223, 'lps'),
	(409630, 125, '2015-02-15 00:43:43.000000', 'consum', 0.0222, 'lps'),
	(409631, 125, '2015-02-15 00:43:44.000000', 'consum', 0.0214, 'lps'),
	(409632, 125, '2015-02-15 00:43:45.000000', 'consum', 0.0214, 'lps'),
	(409633, 125, '2015-02-15 00:43:46.000000', 'consum', 0.0218, 'lps'),
	(409634, 125, '2015-02-15 00:43:47.000000', 'consum', 0.0220, 'lps'),
	(409635, 125, '2015-02-15 00:43:48.000000', 'consum', 0.0219, 'lps'),
	(409636, 125, '2015-02-15 00:43:49.000000', 'consum', 0.0224, 'lps'),
	(409637, 125, '2015-02-15 00:43:50.000000', 'consum', 0.0223, 'lps'),
	(409638, 125, '2015-02-15 00:43:51.000000', 'consum', 0.0216, 'lps'),
	(409639, 125, '2015-02-15 00:43:52.000000', 'consum', 0.0217, 'lps'),
	(409640, 125, '2015-02-15 00:43:53.000000', 'consum', 0.0212, 'lps'),
	(409641, 125, '2015-02-15 00:43:54.000000', 'consum', 0.0218, 'lps'),
	(409642, 125, '2015-02-15 00:43:55.000000', 'consum', 0.0225, 'lps'),
	(409643, 125, '2015-02-15 00:43:56.000000', 'consum', 0.0213, 'lps'),
	(409644, 125, '2015-02-15 00:43:57.000000', 'consum', 0.0212, 'lps'),
	(409645, 125, '2015-02-15 00:43:58.000000', 'consum', 0.0213, 'lps'),
	(409646, 125, '2015-02-15 00:43:59.000000', 'consum', 0.0218, 'lps'),
	(409647, 125, '2015-02-15 00:44:00.000000', 'consum', 0.0210, 'lps'),
	(409648, 125, '2015-02-15 00:44:01.000000', 'consum', 0.0218, 'lps'),
	(409649, 125, '2015-02-15 00:44:02.000000', 'consum', 0.0217, 'lps'),
	(409650, 125, '2015-02-15 00:44:03.000000', 'consum', 0.0222, 'lps'),
	(409651, 125, '2015-02-15 00:44:04.000000', 'consum', 0.0217, 'lps'),
	(409652, 125, '2015-02-15 00:44:05.000000', 'consum', 0.0223, 'lps'),
	(409653, 125, '2015-02-15 00:44:06.000000', 'consum', 0.0223, 'lps'),
	(409654, 125, '2015-02-15 00:44:07.000000', 'consum', 0.0219, 'lps'),
	(409655, 125, '2015-02-15 00:44:08.000000', 'consum', 0.0217, 'lps'),
	(409656, 125, '2015-02-15 00:44:09.000000', 'consum', 0.0217, 'lps'),
	(409657, 125, '2015-02-15 00:44:10.000000', 'consum', 0.0226, 'lps'),
	(409658, 125, '2015-02-15 00:44:11.000000', 'consum', 0.0220, 'lps'),
	(409659, 125, '2015-02-15 00:44:12.000000', 'consum', 0.0211, 'lps'),
	(409660, 125, '2015-02-15 00:44:13.000000', 'consum', 0.0219, 'lps'),
	(409661, 125, '2015-02-15 00:44:14.000000', 'consum', 0.0220, 'lps'),
	(409662, 125, '2015-02-15 00:44:15.000000', 'consum', 0.0216, 'lps'),
	(409663, 125, '2015-02-15 00:44:16.000000', 'consum', 0.0211, 'lps'),
	(409664, 125, '2015-02-15 00:44:17.000000', 'consum', 0.0215, 'lps'),
	(409665, 125, '2015-02-15 00:44:18.000000', 'consum', 0.0217, 'lps'),
	(409666, 125, '2015-02-15 00:44:19.000000', 'consum', 0.0211, 'lps'),
	(409667, 125, '2015-02-15 00:44:20.000000', 'consum', 0.0213, 'lps'),
	(409668, 125, '2015-02-15 00:44:21.000000', 'consum', 0.0220, 'lps'),
	(409669, 125, '2015-02-15 00:44:22.000000', 'consum', 0.0218, 'lps'),
	(409670, 125, '2015-02-15 00:44:23.000000', 'consum', 0.0221, 'lps'),
	(409671, 125, '2015-02-15 00:44:24.000000', 'consum', 0.0226, 'lps'),
	(409672, 125, '2015-02-15 00:44:25.000000', 'consum', 0.0224, 'lps'),
	(409673, 125, '2015-02-15 00:44:26.000000', 'consum', 0.0216, 'lps'),
	(409674, 125, '2015-02-15 00:44:27.000000', 'consum', 0.0215, 'lps'),
	(409675, 125, '2015-02-15 00:44:28.000000', 'consum', 0.0219, 'lps'),
	(409676, 125, '2015-02-15 00:44:29.000000', 'consum', 0.0223, 'lps'),
	(409677, 125, '2015-02-15 00:44:30.000000', 'consum', 0.0214, 'lps'),
	(409678, 125, '2015-02-15 00:44:31.000000', 'consum', 0.0224, 'lps'),
	(409679, 125, '2015-02-15 00:44:32.000000', 'consum', 0.0218, 'lps'),
	(409680, 125, '2015-02-15 00:44:33.000000', 'consum', 0.0225, 'lps'),
	(409681, 125, '2015-02-15 00:44:34.000000', 'consum', 0.0212, 'lps'),
	(409682, 125, '2015-02-15 00:44:35.000000', 'consum', 0.0211, 'lps'),
	(409683, 125, '2015-02-15 00:44:36.000000', 'consum', 0.0223, 'lps'),
	(409684, 125, '2015-02-15 00:44:37.000000', 'consum', 0.0224, 'lps'),
	(409685, 125, '2015-02-15 00:44:38.000000', 'consum', 0.0224, 'lps'),
	(409686, 125, '2015-02-15 00:44:39.000000', 'consum', 0.0223, 'lps'),
	(409687, 125, '2015-02-15 00:44:40.000000', 'consum', 0.0216, 'lps'),
	(409688, 125, '2015-02-15 00:44:41.000000', 'consum', 0.0219, 'lps'),
	(409689, 125, '2015-02-15 00:44:42.000000', 'consum', 0.0219, 'lps'),
	(409690, 125, '2015-02-15 00:44:43.000000', 'consum', 0.0214, 'lps'),
	(409691, 125, '2015-02-15 00:44:44.000000', 'consum', 0.0218, 'lps'),
	(409692, 125, '2015-02-15 00:44:45.000000', 'consum', 0.0224, 'lps'),
	(409693, 125, '2015-02-15 00:44:46.000000', 'consum', 0.0223, 'lps'),
	(409694, 125, '2015-02-15 00:44:47.000000', 'consum', 0.0216, 'lps'),
	(409695, 125, '2015-02-15 00:44:48.000000', 'consum', 0.0219, 'lps'),
	(409696, 125, '2015-02-15 00:44:49.000000', 'consum', 0.0222, 'lps'),
	(409697, 125, '2015-02-15 00:44:50.000000', 'consum', 0.0224, 'lps'),
	(409698, 125, '2015-02-15 00:44:51.000000', 'consum', 0.0211, 'lps'),
	(409699, 125, '2015-02-15 00:44:52.000000', 'consum', 0.0224, 'lps'),
	(409700, 125, '2015-02-15 00:44:53.000000', 'consum', 0.0210, 'lps'),
	(409701, 125, '2015-02-15 00:44:54.000000', 'consum', 0.0220, 'lps'),
	(409702, 125, '2015-02-15 00:44:55.000000', 'consum', 0.0225, 'lps'),
	(409703, 125, '2015-02-15 00:44:56.000000', 'consum', 0.0221, 'lps'),
	(409704, 125, '2015-02-15 00:44:57.000000', 'consum', 0.0221, 'lps'),
	(409705, 125, '2015-02-15 00:44:58.000000', 'consum', 0.0214, 'lps'),
	(409706, 125, '2015-02-15 00:44:59.000000', 'consum', 0.0217, 'lps'),
	(409707, 125, '2015-02-15 00:45:00.000000', 'consum', 0.0216, 'lps'),
	(409708, 125, '2015-02-15 00:45:01.000000', 'consum', 0.0218, 'lps'),
	(409709, 125, '2015-02-15 00:45:02.000000', 'consum', 0.0214, 'lps'),
	(409710, 125, '2015-02-15 00:45:03.000000', 'consum', 0.0210, 'lps'),
	(409711, 125, '2015-02-15 00:45:04.000000', 'consum', 0.0215, 'lps'),
	(409712, 125, '2015-02-15 00:45:05.000000', 'consum', 0.0219, 'lps'),
	(409713, 125, '2015-02-15 00:45:06.000000', 'consum', 0.0221, 'lps'),
	(409714, 125, '2015-02-15 00:45:07.000000', 'consum', 0.0223, 'lps'),
	(409715, 125, '2015-02-15 00:45:08.000000', 'consum', 0.0224, 'lps'),
	(409716, 125, '2015-02-15 00:45:09.000000', 'consum', 0.0225, 'lps'),
	(409717, 125, '2015-02-15 00:45:10.000000', 'consum', 0.0212, 'lps'),
	(409718, 125, '2015-02-15 00:45:11.000000', 'consum', 0.0224, 'lps'),
	(409719, 125, '2015-02-15 00:45:12.000000', 'consum', 0.0223, 'lps'),
	(409720, 125, '2015-02-15 00:45:13.000000', 'consum', 0.0219, 'lps'),
	(409721, 125, '2015-02-15 00:45:14.000000', 'consum', 0.0216, 'lps'),
	(409722, 125, '2015-02-15 00:45:15.000000', 'consum', 0.0213, 'lps'),
	(409723, 125, '2015-02-15 00:45:16.000000', 'consum', 0.0223, 'lps'),
	(409724, 125, '2015-02-15 00:45:17.000000', 'consum', 0.0216, 'lps'),
	(409725, 125, '2015-02-15 00:45:18.000000', 'consum', 0.0220, 'lps'),
	(409726, 125, '2015-02-15 00:45:19.000000', 'consum', 0.0223, 'lps'),
	(409727, 125, '2015-02-15 00:45:20.000000', 'consum', 0.0213, 'lps'),
	(409728, 125, '2015-02-15 00:45:21.000000', 'consum', 0.0221, 'lps'),
	(409729, 125, '2015-02-15 00:45:22.000000', 'consum', 0.0221, 'lps'),
	(409730, 125, '2015-02-15 00:45:23.000000', 'consum', 0.0218, 'lps'),
	(409731, 125, '2015-02-15 00:45:24.000000', 'consum', 0.0217, 'lps'),
	(409732, 125, '2015-02-15 00:45:25.000000', 'consum', 0.0219, 'lps'),
	(409733, 125, '2015-02-15 00:45:26.000000', 'consum', 0.0220, 'lps'),
	(409734, 125, '2015-02-15 00:45:27.000000', 'consum', 0.0216, 'lps'),
	(409735, 125, '2015-02-15 00:45:28.000000', 'consum', 0.0212, 'lps'),
	(409736, 125, '2015-02-15 00:45:29.000000', 'consum', 0.0219, 'lps'),
	(409737, 125, '2015-02-15 00:45:30.000000', 'consum', 0.0217, 'lps'),
	(409738, 125, '2015-02-15 00:45:31.000000', 'consum', 0.0216, 'lps'),
	(409739, 125, '2015-02-15 00:45:32.000000', 'consum', 0.0222, 'lps'),
	(409740, 125, '2015-02-15 00:45:33.000000', 'consum', 0.0216, 'lps'),
	(409741, 125, '2015-02-15 00:45:34.000000', 'consum', 0.0223, 'lps'),
	(409742, 125, '2015-02-15 00:45:35.000000', 'consum', 0.0225, 'lps'),
	(409743, 125, '2015-02-15 00:45:36.000000', 'consum', 0.0210, 'lps'),
	(409744, 125, '2015-02-15 00:45:37.000000', 'consum', 0.0218, 'lps'),
	(409745, 125, '2015-02-15 00:45:38.000000', 'consum', 0.0216, 'lps'),
	(409746, 125, '2015-02-15 00:45:39.000000', 'consum', 0.0214, 'lps'),
	(409747, 125, '2015-02-15 00:45:40.000000', 'consum', 0.0216, 'lps'),
	(409748, 125, '2015-02-15 00:45:41.000000', 'consum', 0.0211, 'lps'),
	(409749, 125, '2015-02-15 00:45:42.000000', 'consum', 0.0213, 'lps'),
	(409750, 125, '2015-02-15 00:45:43.000000', 'consum', 0.0225, 'lps'),
	(409751, 125, '2015-02-15 00:45:44.000000', 'consum', 0.0223, 'lps'),
	(409752, 125, '2015-02-15 00:45:45.000000', 'consum', 0.0215, 'lps'),
	(409753, 125, '2015-02-15 00:45:46.000000', 'consum', 0.0213, 'lps'),
	(409754, 125, '2015-02-15 00:45:47.000000', 'consum', 0.0226, 'lps'),
	(409755, 125, '2015-02-15 00:45:48.000000', 'consum', 0.0216, 'lps'),
	(409756, 125, '2015-02-15 00:45:49.000000', 'consum', 0.0224, 'lps'),
	(409757, 125, '2015-02-15 00:45:50.000000', 'consum', 0.0211, 'lps'),
	(409758, 125, '2015-02-15 00:45:51.000000', 'consum', 0.0210, 'lps'),
	(409759, 125, '2015-02-15 00:45:52.000000', 'consum', 0.0222, 'lps'),
	(409760, 125, '2015-02-15 00:45:53.000000', 'consum', 0.0221, 'lps'),
	(409761, 125, '2015-02-15 00:45:54.000000', 'consum', 0.0212, 'lps'),
	(409762, 125, '2015-02-15 00:45:55.000000', 'consum', 0.0222, 'lps'),
	(409763, 125, '2015-02-15 00:45:56.000000', 'consum', 0.0214, 'lps'),
	(409764, 125, '2015-02-15 00:45:57.000000', 'consum', 0.0210, 'lps'),
	(409765, 125, '2015-02-15 00:45:58.000000', 'consum', 0.0215, 'lps'),
	(409766, 125, '2015-02-15 00:45:59.000000', 'consum', 0.0219, 'lps'),
	(409767, 125, '2015-02-15 00:46:00.000000', 'consum', 0.0223, 'lps'),
	(409768, 125, '2015-02-15 00:46:01.000000', 'consum', 0.0217, 'lps'),
	(409769, 125, '2015-02-15 00:46:02.000000', 'consum', 0.0221, 'lps'),
	(409770, 125, '2015-02-15 00:46:03.000000', 'consum', 0.0212, 'lps'),
	(409771, 125, '2015-02-15 00:46:04.000000', 'consum', 0.0220, 'lps'),
	(409772, 125, '2015-02-15 00:46:05.000000', 'consum', 0.0220, 'lps'),
	(409773, 125, '2015-02-15 00:46:06.000000', 'consum', 0.0214, 'lps'),
	(409774, 125, '2015-02-15 00:46:07.000000', 'consum', 0.0216, 'lps'),
	(409775, 125, '2015-02-15 00:46:08.000000', 'consum', 0.0212, 'lps'),
	(409776, 125, '2015-02-15 00:46:09.000000', 'consum', 0.0218, 'lps'),
	(409777, 125, '2015-02-15 00:46:10.000000', 'consum', 0.0214, 'lps'),
	(409778, 125, '2015-02-15 00:46:11.000000', 'consum', 0.0222, 'lps'),
	(409779, 125, '2015-02-15 00:46:12.000000', 'consum', 0.0224, 'lps'),
	(409780, 125, '2015-02-15 00:46:13.000000', 'consum', 0.0212, 'lps'),
	(409781, 125, '2015-02-15 00:46:14.000000', 'consum', 0.0212, 'lps'),
	(409782, 125, '2015-02-15 00:46:15.000000', 'consum', 0.0215, 'lps'),
	(409783, 125, '2015-02-15 00:46:16.000000', 'consum', 0.0212, 'lps'),
	(409784, 125, '2015-02-15 00:46:17.000000', 'consum', 0.0224, 'lps'),
	(409785, 125, '2015-02-15 00:46:18.000000', 'consum', 0.0223, 'lps'),
	(409786, 125, '2015-02-15 00:46:19.000000', 'consum', 0.0217, 'lps'),
	(409787, 125, '2015-02-15 00:46:20.000000', 'consum', 0.0222, 'lps'),
	(409788, 125, '2015-02-15 00:46:21.000000', 'consum', 0.0216, 'lps'),
	(409789, 125, '2015-02-15 00:46:22.000000', 'consum', 0.0222, 'lps'),
	(409790, 125, '2015-02-15 00:46:23.000000', 'consum', 0.0220, 'lps'),
	(409791, 125, '2015-02-15 00:46:24.000000', 'consum', 0.0224, 'lps'),
	(409792, 125, '2015-02-15 00:46:25.000000', 'consum', 0.0216, 'lps'),
	(409793, 125, '2015-02-15 00:46:26.000000', 'consum', 0.0215, 'lps'),
	(409794, 125, '2015-02-15 00:46:27.000000', 'consum', 0.0219, 'lps'),
	(409795, 125, '2015-02-15 00:46:28.000000', 'consum', 0.0221, 'lps'),
	(409796, 125, '2015-02-15 00:46:29.000000', 'consum', 0.0222, 'lps'),
	(409797, 125, '2015-02-15 00:46:30.000000', 'consum', 0.0219, 'lps'),
	(409798, 125, '2015-02-15 00:46:31.000000', 'consum', 0.0221, 'lps'),
	(409799, 125, '2015-02-15 00:46:32.000000', 'consum', 0.0220, 'lps'),
	(409800, 125, '2015-02-15 00:46:33.000000', 'consum', 0.0213, 'lps'),
	(409801, 125, '2015-02-15 00:46:34.000000', 'consum', 0.0212, 'lps'),
	(409802, 125, '2015-02-15 00:46:35.000000', 'consum', 0.0212, 'lps'),
	(409803, 125, '2015-02-15 00:46:36.000000', 'consum', 0.0215, 'lps'),
	(409804, 125, '2015-02-15 00:46:37.000000', 'consum', 0.0214, 'lps'),
	(409805, 125, '2015-02-15 00:46:38.000000', 'consum', 0.0212, 'lps'),
	(409806, 125, '2015-02-15 00:46:39.000000', 'consum', 0.0226, 'lps'),
	(409807, 125, '2015-02-15 00:46:40.000000', 'consum', 0.0218, 'lps'),
	(409808, 125, '2015-02-15 00:46:41.000000', 'consum', 0.0218, 'lps'),
	(409809, 125, '2015-02-15 00:46:42.000000', 'consum', 0.0212, 'lps'),
	(409810, 125, '2015-02-15 00:46:43.000000', 'consum', 0.0211, 'lps'),
	(409811, 125, '2015-02-15 00:46:44.000000', 'consum', 0.0210, 'lps'),
	(409812, 125, '2015-02-15 00:46:45.000000', 'consum', 0.0225, 'lps'),
	(409813, 125, '2015-02-15 00:46:46.000000', 'consum', 0.0219, 'lps'),
	(409814, 125, '2015-02-15 00:46:47.000000', 'consum', 0.0226, 'lps'),
	(409815, 125, '2015-02-15 00:46:48.000000', 'consum', 0.0213, 'lps'),
	(409816, 125, '2015-02-15 00:46:49.000000', 'consum', 0.0212, 'lps'),
	(409817, 125, '2015-02-15 00:46:50.000000', 'consum', 0.0210, 'lps'),
	(409818, 125, '2015-02-15 00:46:51.000000', 'consum', 0.0224, 'lps'),
	(409819, 125, '2015-02-15 00:46:52.000000', 'consum', 0.0210, 'lps'),
	(409820, 125, '2015-02-15 00:46:53.000000', 'consum', 0.0221, 'lps'),
	(409821, 125, '2015-02-15 00:46:54.000000', 'consum', 0.0215, 'lps'),
	(409822, 125, '2015-02-15 00:46:55.000000', 'consum', 0.0217, 'lps'),
	(409823, 125, '2015-02-15 00:46:56.000000', 'consum', 0.0214, 'lps'),
	(409824, 125, '2015-02-15 00:46:57.000000', 'consum', 0.0211, 'lps'),
	(409825, 125, '2015-02-15 00:46:58.000000', 'consum', 0.0219, 'lps'),
	(409826, 125, '2015-02-15 00:46:59.000000', 'consum', 0.0220, 'lps'),
	(409827, 125, '2015-02-15 00:47:00.000000', 'consum', 0.0215, 'lps'),
	(409828, 125, '2015-02-15 00:47:01.000000', 'consum', 0.0225, 'lps'),
	(409829, 125, '2015-02-15 00:47:02.000000', 'consum', 0.0219, 'lps'),
	(409830, 125, '2015-02-15 00:47:03.000000', 'consum', 0.0211, 'lps'),
	(409831, 125, '2015-02-15 00:47:04.000000', 'consum', 0.0221, 'lps'),
	(409832, 125, '2015-02-15 00:47:05.000000', 'consum', 0.0213, 'lps'),
	(409833, 125, '2015-02-15 00:47:06.000000', 'consum', 0.0224, 'lps'),
	(409834, 125, '2015-02-15 00:47:07.000000', 'consum', 0.0222, 'lps'),
	(409835, 125, '2015-02-15 00:47:08.000000', 'consum', 0.0213, 'lps'),
	(409836, 125, '2015-02-15 00:47:09.000000', 'consum', 0.0223, 'lps'),
	(409837, 125, '2015-02-15 00:47:10.000000', 'consum', 0.0213, 'lps'),
	(409838, 125, '2015-02-15 00:47:11.000000', 'consum', 0.0224, 'lps'),
	(409839, 125, '2015-02-15 00:47:12.000000', 'consum', 0.0217, 'lps'),
	(409840, 125, '2015-02-15 00:47:13.000000', 'consum', 0.0224, 'lps'),
	(409841, 125, '2015-02-15 00:47:14.000000', 'consum', 0.0223, 'lps'),
	(409842, 125, '2015-02-15 00:47:15.000000', 'consum', 0.0219, 'lps'),
	(409843, 125, '2015-02-15 00:47:16.000000', 'consum', 0.0214, 'lps'),
	(409844, 125, '2015-02-15 00:47:17.000000', 'consum', 0.0222, 'lps'),
	(409845, 125, '2015-02-15 00:47:18.000000', 'consum', 0.0223, 'lps'),
	(409846, 125, '2015-02-15 00:47:19.000000', 'consum', 0.0223, 'lps'),
	(409847, 125, '2015-02-15 00:47:20.000000', 'consum', 0.0219, 'lps'),
	(409848, 125, '2015-02-15 00:47:21.000000', 'consum', 0.0217, 'lps'),
	(409849, 125, '2015-02-15 00:47:22.000000', 'consum', 0.0217, 'lps'),
	(409850, 125, '2015-02-15 00:47:23.000000', 'consum', 0.0226, 'lps'),
	(409851, 125, '2015-02-15 00:47:24.000000', 'consum', 0.0216, 'lps'),
	(409852, 125, '2015-02-15 00:47:25.000000', 'consum', 0.0213, 'lps'),
	(409853, 125, '2015-02-15 00:47:26.000000', 'consum', 0.0221, 'lps'),
	(409854, 125, '2015-02-15 00:47:27.000000', 'consum', 0.0224, 'lps'),
	(409855, 125, '2015-02-15 00:47:28.000000', 'consum', 0.0214, 'lps'),
	(409856, 125, '2015-02-15 00:47:29.000000', 'consum', 0.0224, 'lps'),
	(409857, 125, '2015-02-15 00:47:30.000000', 'consum', 0.0217, 'lps'),
	(409858, 125, '2015-02-15 00:47:31.000000', 'consum', 0.0220, 'lps'),
	(409859, 125, '2015-02-15 00:47:32.000000', 'consum', 0.0222, 'lps'),
	(409860, 125, '2015-02-15 00:47:33.000000', 'consum', 0.0222, 'lps'),
	(409861, 125, '2015-02-15 00:47:34.000000', 'consum', 0.0217, 'lps'),
	(409862, 125, '2015-02-15 00:47:35.000000', 'consum', 0.0212, 'lps'),
	(409863, 125, '2015-02-15 00:47:36.000000', 'consum', 0.0218, 'lps'),
	(409864, 125, '2015-02-15 00:47:37.000000', 'consum', 0.0225, 'lps'),
	(409865, 125, '2015-02-15 00:47:38.000000', 'consum', 0.0226, 'lps'),
	(409866, 125, '2015-02-15 00:47:39.000000', 'consum', 0.0215, 'lps'),
	(409867, 125, '2015-02-15 00:47:40.000000', 'consum', 0.0218, 'lps'),
	(409868, 125, '2015-02-15 00:47:41.000000', 'consum', 0.0222, 'lps'),
	(409869, 125, '2015-02-15 00:47:42.000000', 'consum', 0.0210, 'lps'),
	(409870, 125, '2015-02-15 00:47:43.000000', 'consum', 0.0224, 'lps'),
	(409871, 125, '2015-02-15 00:47:44.000000', 'consum', 0.0216, 'lps'),
	(409872, 125, '2015-02-15 00:47:45.000000', 'consum', 0.0213, 'lps'),
	(409873, 125, '2015-02-15 00:47:46.000000', 'consum', 0.0224, 'lps'),
	(409874, 125, '2015-02-15 00:47:47.000000', 'consum', 0.0223, 'lps'),
	(409875, 125, '2015-02-15 00:47:48.000000', 'consum', 0.0215, 'lps'),
	(409876, 125, '2015-02-15 00:47:49.000000', 'consum', 0.0212, 'lps'),
	(409877, 125, '2015-02-15 00:47:50.000000', 'consum', 0.0225, 'lps'),
	(409878, 125, '2015-02-15 00:47:51.000000', 'consum', 0.0212, 'lps'),
	(409879, 125, '2015-02-15 00:47:52.000000', 'consum', 0.0226, 'lps'),
	(409880, 125, '2015-02-15 00:47:53.000000', 'consum', 0.0217, 'lps'),
	(409881, 125, '2015-02-15 00:47:54.000000', 'consum', 0.0215, 'lps'),
	(409882, 125, '2015-02-15 00:47:55.000000', 'consum', 0.0212, 'lps'),
	(409883, 125, '2015-02-15 00:47:56.000000', 'consum', 0.0225, 'lps'),
	(409884, 125, '2015-02-15 00:47:57.000000', 'consum', 0.0211, 'lps'),
	(409885, 125, '2015-02-15 00:47:58.000000', 'consum', 0.0221, 'lps'),
	(409886, 125, '2015-02-15 00:47:59.000000', 'consum', 0.0211, 'lps'),
	(409887, 125, '2015-02-15 00:48:00.000000', 'consum', 0.0216, 'lps'),
	(409888, 125, '2015-02-15 00:48:01.000000', 'consum', 0.0221, 'lps'),
	(409889, 125, '2015-02-15 00:48:02.000000', 'consum', 0.0215, 'lps'),
	(409890, 125, '2015-02-15 00:48:03.000000', 'consum', 0.0216, 'lps'),
	(409891, 125, '2015-02-15 00:48:04.000000', 'consum', 0.0212, 'lps'),
	(409892, 125, '2015-02-15 00:48:05.000000', 'consum', 0.0218, 'lps'),
	(409893, 125, '2015-02-15 00:48:06.000000', 'consum', 0.0212, 'lps'),
	(409894, 125, '2015-02-15 00:48:07.000000', 'consum', 0.0213, 'lps'),
	(409895, 125, '2015-02-15 00:48:08.000000', 'consum', 0.0218, 'lps'),
	(409896, 125, '2015-02-15 00:48:09.000000', 'consum', 0.0226, 'lps'),
	(409897, 125, '2015-02-15 00:48:10.000000', 'consum', 0.0217, 'lps'),
	(409898, 125, '2015-02-15 00:48:11.000000', 'consum', 0.0212, 'lps'),
	(409899, 125, '2015-02-15 00:48:12.000000', 'consum', 0.0219, 'lps'),
	(409900, 125, '2015-02-15 00:48:13.000000', 'consum', 0.0213, 'lps'),
	(409901, 125, '2015-02-15 00:48:14.000000', 'consum', 0.0218, 'lps'),
	(409902, 125, '2015-02-15 00:48:15.000000', 'consum', 0.0222, 'lps'),
	(409903, 125, '2015-02-15 00:48:16.000000', 'consum', 0.0215, 'lps'),
	(409904, 125, '2015-02-15 00:48:17.000000', 'consum', 0.0216, 'lps'),
	(409905, 125, '2015-02-15 00:48:18.000000', 'consum', 0.0226, 'lps'),
	(409906, 125, '2015-02-15 00:48:19.000000', 'consum', 0.0222, 'lps'),
	(409907, 125, '2015-02-15 00:48:20.000000', 'consum', 0.0223, 'lps'),
	(409908, 125, '2015-02-15 00:48:21.000000', 'consum', 0.0223, 'lps'),
	(409909, 125, '2015-02-15 00:48:22.000000', 'consum', 0.0218, 'lps'),
	(409910, 125, '2015-02-15 00:48:23.000000', 'consum', 0.0213, 'lps'),
	(409911, 125, '2015-02-15 00:48:24.000000', 'consum', 0.0216, 'lps'),
	(409912, 125, '2015-02-15 00:48:25.000000', 'consum', 0.0217, 'lps'),
	(409913, 125, '2015-02-15 00:48:26.000000', 'consum', 0.0210, 'lps'),
	(409914, 125, '2015-02-15 00:48:27.000000', 'consum', 0.0223, 'lps'),
	(409915, 125, '2015-02-15 00:48:28.000000', 'consum', 0.0223, 'lps'),
	(409916, 125, '2015-02-15 00:48:29.000000', 'consum', 0.0222, 'lps'),
	(409917, 125, '2015-02-15 00:48:30.000000', 'consum', 0.0212, 'lps'),
	(409918, 125, '2015-02-15 00:48:31.000000', 'consum', 0.0222, 'lps'),
	(409919, 125, '2015-02-15 00:48:32.000000', 'consum', 0.0210, 'lps'),
	(409920, 125, '2015-02-15 00:48:33.000000', 'consum', 0.0212, 'lps'),
	(409921, 125, '2015-02-15 00:48:34.000000', 'consum', 0.0217, 'lps'),
	(409922, 125, '2015-02-15 00:48:35.000000', 'consum', 0.0224, 'lps'),
	(409923, 125, '2015-02-15 00:48:36.000000', 'consum', 0.0224, 'lps'),
	(409924, 125, '2015-02-15 00:48:37.000000', 'consum', 0.0223, 'lps'),
	(409925, 125, '2015-02-15 00:48:38.000000', 'consum', 0.0216, 'lps'),
	(409926, 125, '2015-02-15 00:48:39.000000', 'consum', 0.0219, 'lps'),
	(409927, 125, '2015-02-15 00:48:40.000000', 'consum', 0.0218, 'lps'),
	(409928, 125, '2015-02-15 00:48:41.000000', 'consum', 0.0225, 'lps'),
	(409929, 125, '2015-02-15 00:48:42.000000', 'consum', 0.0212, 'lps'),
	(409930, 125, '2015-02-15 00:48:43.000000', 'consum', 0.0210, 'lps'),
	(409931, 125, '2015-02-15 00:48:44.000000', 'consum', 0.0219, 'lps'),
	(409932, 125, '2015-02-15 00:48:45.000000', 'consum', 0.0224, 'lps'),
	(409933, 125, '2015-02-15 00:48:46.000000', 'consum', 0.0220, 'lps'),
	(409934, 125, '2015-02-15 00:48:47.000000', 'consum', 0.0215, 'lps'),
	(409935, 125, '2015-02-15 00:48:48.000000', 'consum', 0.0226, 'lps'),
	(409936, 125, '2015-02-15 00:48:49.000000', 'consum', 0.0223, 'lps'),
	(409937, 125, '2015-02-15 00:48:50.000000', 'consum', 0.0211, 'lps'),
	(409938, 125, '2015-02-15 00:48:51.000000', 'consum', 0.0212, 'lps'),
	(409939, 125, '2015-02-15 00:48:52.000000', 'consum', 0.0215, 'lps'),
	(409940, 125, '2015-02-15 00:48:53.000000', 'consum', 0.0214, 'lps'),
	(409941, 125, '2015-02-15 00:48:54.000000', 'consum', 0.0215, 'lps'),
	(409942, 125, '2015-02-15 00:48:55.000000', 'consum', 0.0222, 'lps'),
	(409943, 125, '2015-02-15 00:48:56.000000', 'consum', 0.0224, 'lps'),
	(409944, 125, '2015-02-15 00:48:57.000000', 'consum', 0.0225, 'lps'),
	(409945, 125, '2015-02-15 00:48:58.000000', 'consum', 0.0211, 'lps'),
	(409946, 125, '2015-02-15 00:48:59.000000', 'consum', 0.0220, 'lps'),
	(409947, 125, '2015-02-15 00:49:00.000000', 'consum', 0.0224, 'lps'),
	(409948, 125, '2015-02-15 00:49:01.000000', 'consum', 0.0216, 'lps'),
	(409949, 125, '2015-02-15 00:49:02.000000', 'consum', 0.0215, 'lps'),
	(409950, 125, '2015-02-15 00:49:03.000000', 'consum', 0.0219, 'lps'),
	(409951, 125, '2015-02-15 00:49:04.000000', 'consum', 0.0223, 'lps'),
	(409952, 125, '2015-02-15 00:49:05.000000', 'consum', 0.0216, 'lps'),
	(409953, 125, '2015-02-15 00:49:06.000000', 'consum', 0.0216, 'lps'),
	(409954, 125, '2015-02-15 00:49:07.000000', 'consum', 0.0224, 'lps'),
	(409955, 125, '2015-02-15 00:49:08.000000', 'consum', 0.0212, 'lps'),
	(409956, 125, '2015-02-15 00:49:09.000000', 'consum', 0.0212, 'lps'),
	(409957, 125, '2015-02-15 00:49:10.000000', 'consum', 0.0216, 'lps'),
	(409958, 125, '2015-02-15 00:49:11.000000', 'consum', 0.0217, 'lps'),
	(409959, 125, '2015-02-15 00:49:12.000000', 'consum', 0.0210, 'lps'),
	(409960, 125, '2015-02-15 00:49:13.000000', 'consum', 0.0224, 'lps'),
	(409961, 125, '2015-02-15 00:49:14.000000', 'consum', 0.0211, 'lps'),
	(409962, 125, '2015-02-15 00:49:15.000000', 'consum', 0.0226, 'lps'),
	(409963, 125, '2015-02-15 00:49:16.000000', 'consum', 0.0217, 'lps'),
	(409964, 125, '2015-02-15 00:49:17.000000', 'consum', 0.0218, 'lps'),
	(409965, 125, '2015-02-15 00:49:18.000000', 'consum', 0.0210, 'lps'),
	(409966, 125, '2015-02-15 00:49:19.000000', 'consum', 0.0223, 'lps'),
	(409967, 125, '2015-02-15 00:49:20.000000', 'consum', 0.0224, 'lps'),
	(409968, 125, '2015-02-15 00:49:21.000000', 'consum', 0.0223, 'lps'),
	(409969, 125, '2015-02-15 00:49:22.000000', 'consum', 0.0215, 'lps'),
	(409970, 125, '2015-02-15 00:49:23.000000', 'consum', 0.0217, 'lps'),
	(409971, 125, '2015-02-15 00:49:24.000000', 'consum', 0.0213, 'lps'),
	(409972, 125, '2015-02-15 00:49:25.000000', 'consum', 0.0219, 'lps'),
	(409973, 125, '2015-02-15 00:49:26.000000', 'consum', 0.0214, 'lps'),
	(409974, 125, '2015-02-15 00:49:27.000000', 'consum', 0.0220, 'lps'),
	(409975, 125, '2015-02-15 00:49:28.000000', 'consum', 0.0216, 'lps'),
	(409976, 125, '2015-02-15 00:49:29.000000', 'consum', 0.0210, 'lps'),
	(409977, 125, '2015-02-15 00:49:30.000000', 'consum', 0.0211, 'lps'),
	(409978, 125, '2015-02-15 00:49:31.000000', 'consum', 0.0213, 'lps'),
	(409979, 125, '2015-02-15 00:49:32.000000', 'consum', 0.0224, 'lps'),
	(409980, 125, '2015-02-15 00:49:33.000000', 'consum', 0.0219, 'lps'),
	(409981, 125, '2015-02-15 00:49:34.000000', 'consum', 0.0213, 'lps'),
	(409982, 125, '2015-02-15 00:49:35.000000', 'consum', 0.0217, 'lps'),
	(409983, 125, '2015-02-15 00:49:36.000000', 'consum', 0.0218, 'lps'),
	(409984, 125, '2015-02-15 00:49:37.000000', 'consum', 0.0212, 'lps'),
	(409985, 125, '2015-02-15 00:49:38.000000', 'consum', 0.0214, 'lps'),
	(409986, 125, '2015-02-15 00:49:39.000000', 'consum', 0.0226, 'lps'),
	(409987, 125, '2015-02-15 00:49:40.000000', 'consum', 0.0210, 'lps'),
	(409988, 125, '2015-02-15 00:49:41.000000', 'consum', 0.0214, 'lps'),
	(409989, 125, '2015-02-15 00:49:42.000000', 'consum', 0.0213, 'lps'),
	(409990, 125, '2015-02-15 00:49:43.000000', 'consum', 0.0213, 'lps'),
	(409991, 125, '2015-02-15 00:49:44.000000', 'consum', 0.0219, 'lps'),
	(409992, 125, '2015-02-15 00:49:45.000000', 'consum', 0.0210, 'lps'),
	(409993, 125, '2015-02-15 00:49:46.000000', 'consum', 0.0220, 'lps'),
	(409994, 125, '2015-02-15 00:49:47.000000', 'consum', 0.0225, 'lps'),
	(409995, 125, '2015-02-15 00:49:48.000000', 'consum', 0.0224, 'lps'),
	(409996, 125, '2015-02-15 00:49:49.000000', 'consum', 0.0215, 'lps'),
	(409997, 125, '2015-02-15 00:49:50.000000', 'consum', 0.0214, 'lps'),
	(409998, 125, '2015-02-15 00:49:51.000000', 'consum', 0.0213, 'lps'),
	(409999, 125, '2015-02-15 00:49:52.000000', 'consum', 0.0216, 'lps'),
	(410000, 125, '2015-02-15 00:49:53.000000', 'consum', 0.0212, 'lps'),
	(410001, 125, '2015-02-15 00:49:54.000000', 'consum', 0.0222, 'lps'),
	(410002, 125, '2015-02-15 00:49:55.000000', 'consum', 0.0212, 'lps'),
	(410003, 125, '2015-02-15 00:49:56.000000', 'consum', 0.0219, 'lps'),
	(410004, 125, '2015-02-15 00:49:57.000000', 'consum', 0.0215, 'lps'),
	(410005, 125, '2015-02-15 00:49:58.000000', 'consum', 0.0210, 'lps'),
	(410006, 125, '2015-02-15 00:49:59.000000', 'consum', 0.0211, 'lps'),
	(410007, 125, '2015-02-15 00:50:00.000000', 'consum', 0.0216, 'lps'),
	(410008, 125, '2015-02-15 00:50:01.000000', 'consum', 0.0222, 'lps'),
	(410009, 125, '2015-02-15 00:50:02.000000', 'consum', 0.0218, 'lps'),
	(410010, 125, '2015-02-15 00:50:03.000000', 'consum', 0.0213, 'lps'),
	(410011, 125, '2015-02-15 00:50:04.000000', 'consum', 0.0220, 'lps'),
	(410012, 125, '2015-02-15 00:50:05.000000', 'consum', 0.0218, 'lps'),
	(410013, 125, '2015-02-15 00:50:06.000000', 'consum', 0.0218, 'lps'),
	(410014, 125, '2015-02-15 00:50:07.000000', 'consum', 0.0226, 'lps'),
	(410015, 125, '2015-02-15 00:50:08.000000', 'consum', 0.0218, 'lps'),
	(410016, 125, '2015-02-15 00:50:09.000000', 'consum', 0.0220, 'lps'),
	(410017, 125, '2015-02-15 00:50:10.000000', 'consum', 0.0217, 'lps'),
	(410018, 125, '2015-02-15 00:50:11.000000', 'consum', 0.0218, 'lps'),
	(410019, 125, '2015-02-15 00:50:12.000000', 'consum', 0.0213, 'lps'),
	(410020, 125, '2015-02-15 00:50:13.000000', 'consum', 0.0215, 'lps'),
	(410021, 125, '2015-02-15 00:50:14.000000', 'consum', 0.0213, 'lps'),
	(410022, 125, '2015-02-15 00:50:15.000000', 'consum', 0.0225, 'lps'),
	(410023, 125, '2015-02-15 00:50:16.000000', 'consum', 0.0224, 'lps'),
	(410024, 125, '2015-02-15 00:50:17.000000', 'consum', 0.0221, 'lps'),
	(410025, 125, '2015-02-15 00:50:18.000000', 'consum', 0.0224, 'lps'),
	(410026, 125, '2015-02-15 00:50:19.000000', 'consum', 0.0213, 'lps'),
	(410027, 125, '2015-02-15 00:50:20.000000', 'consum', 0.0216, 'lps'),
	(410028, 125, '2015-02-15 00:50:21.000000', 'consum', 0.0216, 'lps'),
	(410029, 125, '2015-02-15 00:50:22.000000', 'consum', 0.0220, 'lps'),
	(410030, 125, '2015-02-15 00:50:23.000000', 'consum', 0.0210, 'lps'),
	(410031, 125, '2015-02-15 00:50:24.000000', 'consum', 0.0215, 'lps'),
	(410032, 125, '2015-02-15 00:50:25.000000', 'consum', 0.0216, 'lps'),
	(410033, 125, '2015-02-15 00:50:26.000000', 'consum', 0.0211, 'lps'),
	(410034, 125, '2015-02-15 00:50:27.000000', 'consum', 0.0213, 'lps'),
	(410035, 125, '2015-02-15 00:50:28.000000', 'consum', 0.0224, 'lps'),
	(410036, 125, '2015-02-15 00:50:29.000000', 'consum', 0.0220, 'lps'),
	(410037, 125, '2015-02-15 00:50:30.000000', 'consum', 0.0218, 'lps'),
	(410038, 125, '2015-02-15 00:50:31.000000', 'consum', 0.0222, 'lps'),
	(410039, 125, '2015-02-15 00:50:32.000000', 'consum', 0.0213, 'lps'),
	(410040, 125, '2015-02-15 00:50:33.000000', 'consum', 0.0224, 'lps'),
	(410041, 125, '2015-02-15 00:50:34.000000', 'consum', 0.0221, 'lps'),
	(410042, 125, '2015-02-15 00:50:35.000000', 'consum', 0.0224, 'lps'),
	(410043, 125, '2015-02-15 00:50:36.000000', 'consum', 0.0212, 'lps'),
	(410044, 125, '2015-02-15 00:50:37.000000', 'consum', 0.0212, 'lps'),
	(410045, 125, '2015-02-15 00:50:38.000000', 'consum', 0.0214, 'lps'),
	(410046, 125, '2015-02-15 00:50:39.000000', 'consum', 0.0224, 'lps'),
	(410047, 125, '2015-02-15 00:50:40.000000', 'consum', 0.0217, 'lps'),
	(410048, 125, '2015-02-15 00:50:41.000000', 'consum', 0.0223, 'lps'),
	(410049, 125, '2015-02-15 00:50:42.000000', 'consum', 0.0217, 'lps'),
	(410050, 125, '2015-02-15 00:50:43.000000', 'consum', 0.0210, 'lps'),
	(410051, 125, '2015-02-15 00:50:44.000000', 'consum', 0.0222, 'lps'),
	(410052, 125, '2015-02-15 00:50:45.000000', 'consum', 0.0220, 'lps'),
	(410053, 125, '2015-02-15 00:50:46.000000', 'consum', 0.0223, 'lps'),
	(410054, 125, '2015-02-15 00:50:47.000000', 'consum', 0.0213, 'lps'),
	(410055, 125, '2015-02-15 00:50:48.000000', 'consum', 0.0219, 'lps'),
	(410056, 125, '2015-02-15 00:50:49.000000', 'consum', 0.0215, 'lps'),
	(410057, 125, '2015-02-15 00:50:50.000000', 'consum', 0.0226, 'lps'),
	(410058, 125, '2015-02-15 00:50:51.000000', 'consum', 0.0222, 'lps'),
	(410059, 125, '2015-02-15 00:50:52.000000', 'consum', 0.0222, 'lps'),
	(410060, 125, '2015-02-15 00:50:53.000000', 'consum', 0.0217, 'lps'),
	(410061, 125, '2015-02-15 00:50:54.000000', 'consum', 0.0211, 'lps'),
	(410062, 125, '2015-02-15 00:50:55.000000', 'consum', 0.0213, 'lps'),
	(410063, 125, '2015-02-15 00:50:56.000000', 'consum', 0.0220, 'lps'),
	(410064, 125, '2015-02-15 00:50:57.000000', 'consum', 0.0217, 'lps'),
	(410065, 125, '2015-02-15 00:50:58.000000', 'consum', 0.0216, 'lps'),
	(410066, 125, '2015-02-15 00:50:59.000000', 'consum', 0.0218, 'lps'),
	(410067, 125, '2015-02-15 00:51:00.000000', 'consum', 0.0218, 'lps'),
	(410068, 125, '2015-02-15 00:51:01.000000', 'consum', 0.0225, 'lps'),
	(410069, 125, '2015-02-15 00:51:02.000000', 'consum', 0.0212, 'lps'),
	(410070, 125, '2015-02-15 00:51:03.000000', 'consum', 0.0210, 'lps'),
	(410071, 125, '2015-02-15 00:51:04.000000', 'consum', 0.0220, 'lps'),
	(410072, 125, '2015-02-15 00:51:05.000000', 'consum', 0.0211, 'lps'),
	(410073, 125, '2015-02-15 00:51:06.000000', 'consum', 0.0218, 'lps'),
	(410074, 125, '2015-02-15 00:51:07.000000', 'consum', 0.0215, 'lps'),
	(410075, 125, '2015-02-15 00:51:08.000000', 'consum', 0.0210, 'lps'),
	(410076, 125, '2015-02-15 00:51:09.000000', 'consum', 0.0213, 'lps'),
	(410077, 125, '2015-02-15 00:51:10.000000', 'consum', 0.0226, 'lps'),
	(410078, 125, '2015-02-15 00:51:11.000000', 'consum', 0.0214, 'lps'),
	(410079, 125, '2015-02-15 00:51:12.000000', 'consum', 0.0217, 'lps'),
	(410080, 125, '2015-02-15 00:51:13.000000', 'consum', 0.0217, 'lps'),
	(410081, 125, '2015-02-15 00:51:14.000000', 'consum', 0.0221, 'lps'),
	(410082, 125, '2015-02-15 00:51:15.000000', 'consum', 0.0214, 'lps'),
	(410083, 125, '2015-02-15 00:51:16.000000', 'consum', 0.0215, 'lps'),
	(410084, 125, '2015-02-15 00:51:17.000000', 'consum', 0.0223, 'lps'),
	(410085, 125, '2015-02-15 00:51:18.000000', 'consum', 0.0226, 'lps'),
	(410086, 125, '2015-02-15 00:51:19.000000', 'consum', 0.0218, 'lps'),
	(410087, 125, '2015-02-15 00:51:20.000000', 'consum', 0.0221, 'lps'),
	(410088, 125, '2015-02-15 00:51:21.000000', 'consum', 0.0225, 'lps'),
	(410089, 125, '2015-02-15 00:51:22.000000', 'consum', 0.0216, 'lps'),
	(410090, 125, '2015-02-15 00:51:23.000000', 'consum', 0.0212, 'lps'),
	(410091, 125, '2015-02-15 00:51:24.000000', 'consum', 0.0218, 'lps'),
	(410092, 125, '2015-02-15 00:51:25.000000', 'consum', 0.0214, 'lps'),
	(410093, 125, '2015-02-15 00:51:26.000000', 'consum', 0.0222, 'lps'),
	(410094, 125, '2015-02-15 00:51:27.000000', 'consum', 0.0226, 'lps'),
	(410095, 125, '2015-02-15 00:51:28.000000', 'consum', 0.0222, 'lps'),
	(410096, 125, '2015-02-15 00:51:29.000000', 'consum', 0.0219, 'lps'),
	(410097, 125, '2015-02-15 00:51:30.000000', 'consum', 0.0220, 'lps'),
	(410098, 125, '2015-02-15 00:51:31.000000', 'consum', 0.0216, 'lps'),
	(410099, 125, '2015-02-15 00:51:32.000000', 'consum', 0.0213, 'lps'),
	(410100, 125, '2015-02-15 00:51:33.000000', 'consum', 0.0221, 'lps'),
	(410101, 125, '2015-02-15 00:51:34.000000', 'consum', 0.0225, 'lps'),
	(410102, 125, '2015-02-15 00:51:35.000000', 'consum', 0.0218, 'lps'),
	(410103, 125, '2015-02-15 00:51:36.000000', 'consum', 0.0224, 'lps'),
	(410104, 125, '2015-02-15 00:51:37.000000', 'consum', 0.0223, 'lps'),
	(410105, 125, '2015-02-15 00:51:38.000000', 'consum', 0.0216, 'lps'),
	(410106, 125, '2015-02-15 00:51:39.000000', 'consum', 0.0220, 'lps'),
	(410107, 125, '2015-02-15 00:51:40.000000', 'consum', 0.0224, 'lps'),
	(410108, 125, '2015-02-15 00:51:41.000000', 'consum', 0.0216, 'lps'),
	(410109, 125, '2015-02-15 00:51:42.000000', 'consum', 0.0218, 'lps'),
	(410110, 125, '2015-02-15 00:51:43.000000', 'consum', 0.0214, 'lps'),
	(410111, 125, '2015-02-15 00:51:44.000000', 'consum', 0.0223, 'lps'),
	(410112, 125, '2015-02-15 00:51:45.000000', 'consum', 0.0213, 'lps'),
	(410113, 125, '2015-02-15 00:51:46.000000', 'consum', 0.0220, 'lps'),
	(410114, 125, '2015-02-15 00:51:47.000000', 'consum', 0.0219, 'lps'),
	(410115, 125, '2015-02-15 00:51:48.000000', 'consum', 0.0223, 'lps'),
	(410116, 125, '2015-02-15 00:51:49.000000', 'consum', 0.0215, 'lps'),
	(410117, 125, '2015-02-15 00:51:50.000000', 'consum', 0.0216, 'lps'),
	(410118, 125, '2015-02-15 00:51:51.000000', 'consum', 0.0223, 'lps'),
	(410119, 125, '2015-02-15 00:51:52.000000', 'consum', 0.0225, 'lps'),
	(410120, 125, '2015-02-15 00:51:53.000000', 'consum', 0.0212, 'lps'),
	(410121, 125, '2015-02-15 00:51:54.000000', 'consum', 0.0224, 'lps'),
	(410122, 125, '2015-02-15 00:51:55.000000', 'consum', 0.0210, 'lps'),
	(410123, 125, '2015-02-15 00:51:56.000000', 'consum', 0.0218, 'lps'),
	(410124, 125, '2015-02-15 00:51:57.000000', 'consum', 0.0216, 'lps'),
	(410125, 125, '2015-02-15 00:51:58.000000', 'consum', 0.0217, 'lps'),
	(410126, 125, '2015-02-15 00:51:59.000000', 'consum', 0.0225, 'lps'),
	(410127, 125, '2015-02-15 00:52:00.000000', 'consum', 0.0217, 'lps'),
	(410128, 125, '2015-02-15 00:52:01.000000', 'consum', 0.0217, 'lps'),
	(410129, 125, '2015-02-15 00:52:02.000000', 'consum', 0.0225, 'lps'),
	(410130, 125, '2015-02-15 00:52:03.000000', 'consum', 0.0214, 'lps'),
	(410131, 125, '2015-02-15 00:52:04.000000', 'consum', 0.0219, 'lps'),
	(410132, 125, '2015-02-15 00:52:05.000000', 'consum', 0.0226, 'lps'),
	(410133, 125, '2015-02-15 00:52:06.000000', 'consum', 0.0211, 'lps'),
	(410134, 125, '2015-02-15 00:52:07.000000', 'consum', 0.0221, 'lps'),
	(410135, 125, '2015-02-15 00:52:08.000000', 'consum', 0.0210, 'lps'),
	(410136, 125, '2015-02-15 00:52:09.000000', 'consum', 0.0211, 'lps'),
	(410137, 125, '2015-02-15 00:52:10.000000', 'consum', 0.0214, 'lps'),
	(410138, 125, '2015-02-15 00:52:11.000000', 'consum', 0.0214, 'lps'),
	(410139, 125, '2015-02-15 00:52:12.000000', 'consum', 0.0216, 'lps'),
	(410140, 125, '2015-02-15 00:52:13.000000', 'consum', 0.0212, 'lps'),
	(410141, 125, '2015-02-15 00:52:14.000000', 'consum', 0.0222, 'lps'),
	(410142, 125, '2015-02-15 00:52:15.000000', 'consum', 0.0211, 'lps'),
	(410143, 125, '2015-02-15 00:52:16.000000', 'consum', 0.0214, 'lps'),
	(410144, 125, '2015-02-15 00:52:17.000000', 'consum', 0.0212, 'lps'),
	(410145, 125, '2015-02-15 00:52:18.000000', 'consum', 0.0224, 'lps'),
	(410146, 125, '2015-02-15 00:52:19.000000', 'consum', 0.0225, 'lps'),
	(410147, 125, '2015-02-15 00:52:20.000000', 'consum', 0.0210, 'lps'),
	(410148, 125, '2015-02-15 00:52:21.000000', 'consum', 0.0214, 'lps'),
	(410149, 125, '2015-02-15 00:52:22.000000', 'consum', 0.0213, 'lps'),
	(410150, 125, '2015-02-15 00:52:23.000000', 'consum', 0.0213, 'lps'),
	(410151, 125, '2015-02-15 00:52:24.000000', 'consum', 0.0217, 'lps'),
	(410152, 125, '2015-02-15 00:52:25.000000', 'consum', 0.0221, 'lps'),
	(410153, 125, '2015-02-15 00:52:26.000000', 'consum', 0.0212, 'lps'),
	(410154, 125, '2015-02-15 00:52:27.000000', 'consum', 0.0218, 'lps'),
	(410155, 125, '2015-02-15 00:52:28.000000', 'consum', 0.0213, 'lps'),
	(410156, 125, '2015-02-15 00:52:29.000000', 'consum', 0.0218, 'lps'),
	(410157, 125, '2015-02-15 00:52:30.000000', 'consum', 0.0225, 'lps'),
	(410158, 125, '2015-02-15 00:52:31.000000', 'consum', 0.0225, 'lps'),
	(410159, 125, '2015-02-15 00:52:32.000000', 'consum', 0.0210, 'lps'),
	(410160, 125, '2015-02-15 00:52:33.000000', 'consum', 0.0214, 'lps'),
	(410161, 125, '2015-02-15 00:52:34.000000', 'consum', 0.0215, 'lps'),
	(410162, 125, '2015-02-15 00:52:35.000000', 'consum', 0.0225, 'lps'),
	(410163, 125, '2015-02-15 00:52:36.000000', 'consum', 0.0216, 'lps'),
	(410164, 125, '2015-02-15 00:52:37.000000', 'consum', 0.0214, 'lps'),
	(410165, 125, '2015-02-15 00:52:38.000000', 'consum', 0.0211, 'lps'),
	(410166, 125, '2015-02-15 00:52:39.000000', 'consum', 0.0223, 'lps'),
	(410167, 125, '2015-02-15 00:52:40.000000', 'consum', 0.0219, 'lps'),
	(410168, 125, '2015-02-15 00:52:41.000000', 'consum', 0.0219, 'lps'),
	(410169, 125, '2015-02-15 00:52:42.000000', 'consum', 0.0212, 'lps'),
	(410170, 125, '2015-02-15 00:52:43.000000', 'consum', 0.0210, 'lps'),
	(410171, 125, '2015-02-15 00:52:44.000000', 'consum', 0.0219, 'lps'),
	(410172, 125, '2015-02-15 00:52:45.000000', 'consum', 0.0223, 'lps'),
	(410173, 125, '2015-02-15 00:52:46.000000', 'consum', 0.0215, 'lps'),
	(410174, 125, '2015-02-15 00:52:47.000000', 'consum', 0.0212, 'lps'),
	(410175, 125, '2015-02-15 00:52:48.000000', 'consum', 0.0223, 'lps'),
	(410176, 125, '2015-02-15 00:52:49.000000', 'consum', 0.0217, 'lps'),
	(410177, 125, '2015-02-15 00:52:50.000000', 'consum', 0.0225, 'lps'),
	(410178, 125, '2015-02-15 00:52:51.000000', 'consum', 0.0215, 'lps'),
	(410179, 125, '2015-02-15 00:52:52.000000', 'consum', 0.0223, 'lps'),
	(410180, 125, '2015-02-15 00:52:53.000000', 'consum', 0.0210, 'lps'),
	(410181, 125, '2015-02-15 00:52:54.000000', 'consum', 0.0222, 'lps'),
	(410182, 125, '2015-02-15 00:52:55.000000', 'consum', 0.0221, 'lps'),
	(410183, 125, '2015-02-15 00:52:56.000000', 'consum', 0.0213, 'lps'),
	(410184, 125, '2015-02-15 00:52:57.000000', 'consum', 0.0224, 'lps'),
	(410185, 125, '2015-02-15 00:52:58.000000', 'consum', 0.0223, 'lps'),
	(410186, 125, '2015-02-15 00:52:59.000000', 'consum', 0.0214, 'lps'),
	(410187, 125, '2015-02-15 00:53:00.000000', 'consum', 0.0211, 'lps'),
	(410188, 125, '2015-02-15 00:53:01.000000', 'consum', 0.0218, 'lps'),
	(410189, 125, '2015-02-15 00:53:02.000000', 'consum', 0.0214, 'lps'),
	(410190, 125, '2015-02-15 00:53:03.000000', 'consum', 0.0223, 'lps'),
	(410191, 125, '2015-02-15 00:53:04.000000', 'consum', 0.0212, 'lps'),
	(410192, 125, '2015-02-15 00:53:05.000000', 'consum', 0.0215, 'lps'),
	(410193, 125, '2015-02-15 00:53:06.000000', 'consum', 0.0211, 'lps'),
	(410194, 125, '2015-02-15 00:53:07.000000', 'consum', 0.0221, 'lps'),
	(410195, 125, '2015-02-15 00:53:08.000000', 'consum', 0.0211, 'lps'),
	(410196, 125, '2015-02-15 00:53:09.000000', 'consum', 0.0215, 'lps'),
	(410197, 125, '2015-02-15 00:53:10.000000', 'consum', 0.0218, 'lps'),
	(410198, 125, '2015-02-15 00:53:11.000000', 'consum', 0.0217, 'lps'),
	(410199, 125, '2015-02-15 00:53:12.000000', 'consum', 0.0223, 'lps'),
	(410200, 125, '2015-02-15 00:53:13.000000', 'consum', 0.0219, 'lps'),
	(410201, 125, '2015-02-15 00:53:14.000000', 'consum', 0.0216, 'lps'),
	(410202, 125, '2015-02-15 00:53:15.000000', 'consum', 0.0213, 'lps'),
	(410203, 125, '2015-02-15 00:53:16.000000', 'consum', 0.0226, 'lps'),
	(410204, 125, '2015-02-15 00:53:17.000000', 'consum', 0.0211, 'lps'),
	(410205, 125, '2015-02-15 00:53:18.000000', 'consum', 0.0220, 'lps'),
	(410206, 125, '2015-02-15 00:53:19.000000', 'consum', 0.0224, 'lps'),
	(410207, 125, '2015-02-15 00:53:20.000000', 'consum', 0.0215, 'lps'),
	(410208, 125, '2015-02-15 00:53:21.000000', 'consum', 0.0213, 'lps'),
	(410209, 125, '2015-02-15 00:53:22.000000', 'consum', 0.0225, 'lps'),
	(410210, 125, '2015-02-15 00:53:23.000000', 'consum', 0.0225, 'lps'),
	(410211, 125, '2015-02-15 00:53:24.000000', 'consum', 0.0223, 'lps'),
	(410212, 125, '2015-02-15 00:53:25.000000', 'consum', 0.0214, 'lps'),
	(410213, 125, '2015-02-15 00:53:26.000000', 'consum', 0.0224, 'lps'),
	(410214, 125, '2015-02-15 00:53:27.000000', 'consum', 0.0219, 'lps'),
	(410215, 125, '2015-02-15 00:53:28.000000', 'consum', 0.0213, 'lps'),
	(410216, 125, '2015-02-15 00:53:29.000000', 'consum', 0.0217, 'lps'),
	(410217, 125, '2015-02-15 00:53:30.000000', 'consum', 0.0220, 'lps'),
	(410218, 125, '2015-02-15 00:53:31.000000', 'consum', 0.0222, 'lps'),
	(410219, 125, '2015-02-15 00:53:32.000000', 'consum', 0.0225, 'lps'),
	(410220, 125, '2015-02-15 00:53:33.000000', 'consum', 0.0212, 'lps'),
	(410221, 125, '2015-02-15 00:53:34.000000', 'consum', 0.0212, 'lps'),
	(410222, 125, '2015-02-15 00:53:35.000000', 'consum', 0.0213, 'lps'),
	(410223, 125, '2015-02-15 00:53:36.000000', 'consum', 0.0221, 'lps'),
	(410224, 125, '2015-02-15 00:53:37.000000', 'consum', 0.0223, 'lps'),
	(410225, 125, '2015-02-15 00:53:38.000000', 'consum', 0.0210, 'lps'),
	(410226, 125, '2015-02-15 00:53:39.000000', 'consum', 0.0220, 'lps'),
	(410227, 125, '2015-02-15 00:53:40.000000', 'consum', 0.0210, 'lps'),
	(410228, 125, '2015-02-15 00:53:41.000000', 'consum', 0.0213, 'lps'),
	(410229, 125, '2015-02-15 00:53:42.000000', 'consum', 0.0211, 'lps'),
	(410230, 125, '2015-02-15 00:53:43.000000', 'consum', 0.0221, 'lps'),
	(410231, 125, '2015-02-15 00:53:44.000000', 'consum', 0.0214, 'lps'),
	(410232, 125, '2015-02-15 00:53:45.000000', 'consum', 0.0214, 'lps'),
	(410233, 125, '2015-02-15 00:53:46.000000', 'consum', 0.0217, 'lps'),
	(410234, 125, '2015-02-15 00:53:47.000000', 'consum', 0.0218, 'lps'),
	(410235, 125, '2015-02-15 00:53:48.000000', 'consum', 0.0212, 'lps'),
	(410236, 125, '2015-02-15 00:53:49.000000', 'consum', 0.0213, 'lps'),
	(410237, 125, '2015-02-15 00:53:50.000000', 'consum', 0.0220, 'lps'),
	(410238, 125, '2015-02-15 00:53:51.000000', 'consum', 0.0217, 'lps'),
	(410239, 125, '2015-02-15 00:53:52.000000', 'consum', 0.0216, 'lps'),
	(410240, 125, '2015-02-15 00:53:53.000000', 'consum', 0.0218, 'lps'),
	(410241, 125, '2015-02-15 00:53:54.000000', 'consum', 0.0215, 'lps'),
	(410242, 125, '2015-02-15 00:53:55.000000', 'consum', 0.0214, 'lps'),
	(410243, 125, '2015-02-15 00:53:56.000000', 'consum', 0.0213, 'lps'),
	(410244, 125, '2015-02-15 00:53:57.000000', 'consum', 0.0215, 'lps'),
	(410245, 125, '2015-02-15 00:53:58.000000', 'consum', 0.0225, 'lps'),
	(410246, 125, '2015-02-15 00:53:59.000000', 'consum', 0.0220, 'lps'),
	(410247, 125, '2015-02-15 00:54:00.000000', 'consum', 0.0214, 'lps'),
	(410248, 125, '2015-02-15 00:54:01.000000', 'consum', 0.0219, 'lps'),
	(410249, 125, '2015-02-15 00:54:02.000000', 'consum', 0.0225, 'lps'),
	(410250, 125, '2015-02-15 00:54:03.000000', 'consum', 0.0210, 'lps'),
	(410251, 125, '2015-02-15 00:54:04.000000', 'consum', 0.0216, 'lps'),
	(410252, 125, '2015-02-15 00:54:05.000000', 'consum', 0.0224, 'lps'),
	(410253, 125, '2015-02-15 00:54:06.000000', 'consum', 0.0211, 'lps'),
	(410254, 125, '2015-02-15 00:54:07.000000', 'consum', 0.0224, 'lps'),
	(410255, 125, '2015-02-15 00:54:08.000000', 'consum', 0.0226, 'lps'),
	(410256, 125, '2015-02-15 00:54:09.000000', 'consum', 0.0214, 'lps'),
	(410257, 125, '2015-02-15 00:54:10.000000', 'consum', 0.0217, 'lps'),
	(410258, 125, '2015-02-15 00:54:11.000000', 'consum', 0.0215, 'lps'),
	(410259, 125, '2015-02-15 00:54:12.000000', 'consum', 0.0217, 'lps'),
	(410260, 125, '2015-02-15 00:54:13.000000', 'consum', 0.0214, 'lps'),
	(410261, 125, '2015-02-15 00:54:14.000000', 'consum', 0.0224, 'lps'),
	(410262, 125, '2015-02-15 00:54:15.000000', 'consum', 0.0219, 'lps'),
	(410263, 125, '2015-02-15 00:54:16.000000', 'consum', 0.0212, 'lps'),
	(410264, 125, '2015-02-15 00:54:17.000000', 'consum', 0.0212, 'lps'),
	(410265, 125, '2015-02-15 00:54:18.000000', 'consum', 0.0215, 'lps'),
	(410266, 125, '2015-02-15 00:54:19.000000', 'consum', 0.0210, 'lps'),
	(410267, 125, '2015-02-15 00:54:20.000000', 'consum', 0.0213, 'lps'),
	(410268, 125, '2015-02-15 00:54:21.000000', 'consum', 0.0225, 'lps'),
	(410269, 125, '2015-02-15 00:54:22.000000', 'consum', 0.0211, 'lps'),
	(410270, 125, '2015-02-15 00:54:23.000000', 'consum', 0.0221, 'lps'),
	(410271, 125, '2015-02-15 00:54:24.000000', 'consum', 0.0211, 'lps'),
	(410272, 125, '2015-02-15 00:54:25.000000', 'consum', 0.0217, 'lps'),
	(410273, 125, '2015-02-15 00:54:26.000000', 'consum', 0.0226, 'lps'),
	(410274, 125, '2015-02-15 00:54:27.000000', 'consum', 0.0219, 'lps'),
	(410275, 125, '2015-02-15 00:54:28.000000', 'consum', 0.0222, 'lps'),
	(410276, 125, '2015-02-15 00:54:29.000000', 'consum', 0.0210, 'lps'),
	(410277, 125, '2015-02-15 00:54:30.000000', 'consum', 0.0224, 'lps'),
	(410278, 125, '2015-02-15 00:54:31.000000', 'consum', 0.0213, 'lps'),
	(410279, 125, '2015-02-15 00:54:32.000000', 'consum', 0.0220, 'lps'),
	(410280, 125, '2015-02-15 00:54:33.000000', 'consum', 0.0216, 'lps'),
	(410281, 125, '2015-02-15 00:54:34.000000', 'consum', 0.0211, 'lps'),
	(410282, 125, '2015-02-15 00:54:35.000000', 'consum', 0.0213, 'lps'),
	(410283, 125, '2015-02-15 00:54:36.000000', 'consum', 0.0222, 'lps'),
	(410284, 125, '2015-02-15 00:54:37.000000', 'consum', 0.0210, 'lps'),
	(410285, 125, '2015-02-15 00:54:38.000000', 'consum', 0.0210, 'lps'),
	(410286, 125, '2015-02-15 00:54:39.000000', 'consum', 0.0226, 'lps'),
	(410287, 125, '2015-02-15 00:54:40.000000', 'consum', 0.0223, 'lps'),
	(410288, 125, '2015-02-15 00:54:41.000000', 'consum', 0.0210, 'lps'),
	(410289, 125, '2015-02-15 00:54:42.000000', 'consum', 0.0223, 'lps'),
	(410290, 125, '2015-02-15 00:54:43.000000', 'consum', 0.0223, 'lps'),
	(410291, 125, '2015-02-15 00:54:44.000000', 'consum', 0.0220, 'lps'),
	(410292, 125, '2015-02-15 00:54:45.000000', 'consum', 0.0221, 'lps'),
	(410293, 125, '2015-02-15 00:54:46.000000', 'consum', 0.0218, 'lps'),
	(410294, 125, '2015-02-15 00:54:47.000000', 'consum', 0.0217, 'lps'),
	(410295, 125, '2015-02-15 00:54:48.000000', 'consum', 0.0223, 'lps'),
	(410296, 125, '2015-02-15 00:54:49.000000', 'consum', 0.0219, 'lps'),
	(410297, 125, '2015-02-15 00:54:50.000000', 'consum', 0.0215, 'lps'),
	(410298, 125, '2015-02-15 00:54:51.000000', 'consum', 0.0212, 'lps'),
	(410299, 125, '2015-02-15 00:54:52.000000', 'consum', 0.0221, 'lps'),
	(410300, 125, '2015-02-15 00:54:53.000000', 'consum', 0.0226, 'lps'),
	(410301, 125, '2015-02-15 00:54:54.000000', 'consum', 0.0221, 'lps'),
	(410302, 125, '2015-02-15 00:54:55.000000', 'consum', 0.0220, 'lps'),
	(410303, 125, '2015-02-15 00:54:56.000000', 'consum', 0.0225, 'lps'),
	(410304, 125, '2015-02-15 00:54:57.000000', 'consum', 0.0224, 'lps'),
	(410305, 125, '2015-02-15 00:54:58.000000', 'consum', 0.0218, 'lps'),
	(410306, 125, '2015-02-15 00:54:59.000000', 'consum', 0.0225, 'lps'),
	(410307, 125, '2015-02-15 00:55:00.000000', 'consum', 0.0212, 'lps'),
	(410308, 125, '2015-02-15 00:55:01.000000', 'consum', 0.0211, 'lps'),
	(410309, 125, '2015-02-15 00:55:02.000000', 'consum', 0.0223, 'lps'),
	(410310, 125, '2015-02-15 00:55:03.000000', 'consum', 0.0222, 'lps'),
	(410311, 125, '2015-02-15 00:55:04.000000', 'consum', 0.0215, 'lps'),
	(410312, 125, '2015-02-15 00:55:05.000000', 'consum', 0.0219, 'lps'),
	(410313, 125, '2015-02-15 00:55:06.000000', 'consum', 0.0220, 'lps'),
	(410314, 125, '2015-02-15 00:55:07.000000', 'consum', 0.0216, 'lps'),
	(410315, 125, '2015-02-15 00:55:08.000000', 'consum', 0.0213, 'lps'),
	(410316, 125, '2015-02-15 00:55:09.000000', 'consum', 0.0223, 'lps'),
	(410317, 125, '2015-02-15 00:55:10.000000', 'consum', 0.0217, 'lps'),
	(410318, 125, '2015-02-15 00:55:11.000000', 'consum', 0.0223, 'lps'),
	(410319, 125, '2015-02-15 00:55:12.000000', 'consum', 0.0220, 'lps'),
	(410320, 125, '2015-02-15 00:55:13.000000', 'consum', 0.0223, 'lps'),
	(410321, 125, '2015-02-15 00:55:14.000000', 'consum', 0.0212, 'lps'),
	(410322, 125, '2015-02-15 00:55:15.000000', 'consum', 0.0214, 'lps'),
	(410323, 125, '2015-02-15 00:55:16.000000', 'consum', 0.0226, 'lps'),
	(410324, 125, '2015-02-15 00:55:17.000000', 'consum', 0.0211, 'lps'),
	(410325, 125, '2015-02-15 00:55:18.000000', 'consum', 0.0216, 'lps'),
	(410326, 125, '2015-02-15 00:55:19.000000', 'consum', 0.0222, 'lps'),
	(410327, 125, '2015-02-15 00:55:20.000000', 'consum', 0.0216, 'lps'),
	(410328, 125, '2015-02-15 00:55:21.000000', 'consum', 0.0224, 'lps'),
	(410329, 125, '2015-02-15 00:55:22.000000', 'consum', 0.0226, 'lps'),
	(410330, 125, '2015-02-15 00:55:23.000000', 'consum', 0.0215, 'lps'),
	(410331, 125, '2015-02-15 00:55:24.000000', 'consum', 0.0220, 'lps'),
	(410332, 125, '2015-02-15 00:55:25.000000', 'consum', 0.0214, 'lps'),
	(410333, 125, '2015-02-15 00:55:26.000000', 'consum', 0.0216, 'lps'),
	(410334, 125, '2015-02-15 00:55:27.000000', 'consum', 0.0213, 'lps'),
	(410335, 125, '2015-02-15 00:55:28.000000', 'consum', 0.0223, 'lps'),
	(410336, 125, '2015-02-15 00:55:29.000000', 'consum', 0.0217, 'lps'),
	(410337, 125, '2015-02-15 00:55:30.000000', 'consum', 0.0224, 'lps'),
	(410338, 125, '2015-02-15 00:55:31.000000', 'consum', 0.0226, 'lps'),
	(410339, 125, '2015-02-15 00:55:32.000000', 'consum', 0.0212, 'lps'),
	(410340, 125, '2015-02-15 00:55:33.000000', 'consum', 0.0226, 'lps'),
	(410341, 125, '2015-02-15 00:55:34.000000', 'consum', 0.0214, 'lps'),
	(410342, 125, '2015-02-15 00:55:35.000000', 'consum', 0.0219, 'lps'),
	(410343, 125, '2015-02-15 00:55:36.000000', 'consum', 0.0226, 'lps'),
	(410344, 125, '2015-02-15 00:55:37.000000', 'consum', 0.0214, 'lps'),
	(410345, 125, '2015-02-15 00:55:38.000000', 'consum', 0.0216, 'lps'),
	(410346, 125, '2015-02-15 00:55:39.000000', 'consum', 0.0213, 'lps'),
	(410347, 125, '2015-02-15 00:55:40.000000', 'consum', 0.0223, 'lps'),
	(410348, 125, '2015-02-15 00:55:41.000000', 'consum', 0.0216, 'lps'),
	(410349, 125, '2015-02-15 00:55:42.000000', 'consum', 0.0217, 'lps'),
	(410350, 125, '2015-02-15 00:55:43.000000', 'consum', 0.0212, 'lps'),
	(410351, 125, '2015-02-15 00:55:44.000000', 'consum', 0.0215, 'lps'),
	(410352, 125, '2015-02-15 00:55:45.000000', 'consum', 0.0215, 'lps'),
	(410353, 125, '2015-02-15 00:55:46.000000', 'consum', 0.0219, 'lps'),
	(410354, 125, '2015-02-15 00:55:47.000000', 'consum', 0.0222, 'lps'),
	(410355, 125, '2015-02-15 00:55:48.000000', 'consum', 0.0210, 'lps'),
	(410356, 125, '2015-02-15 00:55:49.000000', 'consum', 0.0226, 'lps'),
	(410357, 125, '2015-02-15 00:55:50.000000', 'consum', 0.0222, 'lps'),
	(410358, 125, '2015-02-15 00:55:51.000000', 'consum', 0.0225, 'lps'),
	(410359, 125, '2015-02-15 00:55:52.000000', 'consum', 0.0212, 'lps'),
	(410360, 125, '2015-02-15 00:55:53.000000', 'consum', 0.0213, 'lps'),
	(410361, 125, '2015-02-15 00:55:54.000000', 'consum', 0.0216, 'lps'),
	(410362, 125, '2015-02-15 00:55:55.000000', 'consum', 0.0217, 'lps'),
	(410363, 125, '2015-02-15 00:55:56.000000', 'consum', 0.0210, 'lps'),
	(410364, 125, '2015-02-15 00:55:57.000000', 'consum', 0.0223, 'lps'),
	(410365, 125, '2015-02-15 00:55:58.000000', 'consum', 0.0225, 'lps'),
	(410366, 125, '2015-02-15 00:55:59.000000', 'consum', 0.0213, 'lps'),
	(410367, 125, '2015-02-15 00:56:00.000000', 'consum', 0.0212, 'lps'),
	(410368, 125, '2015-02-15 00:56:01.000000', 'consum', 0.0215, 'lps'),
	(410369, 125, '2015-02-15 00:56:02.000000', 'consum', 0.0211, 'lps'),
	(410370, 125, '2015-02-15 00:56:03.000000', 'consum', 0.0217, 'lps'),
	(410371, 125, '2015-02-15 00:56:04.000000', 'consum', 0.0226, 'lps'),
	(410372, 125, '2015-02-15 00:56:05.000000', 'consum', 0.0220, 'lps'),
	(410373, 125, '2015-02-15 00:56:06.000000', 'consum', 0.0212, 'lps'),
	(410374, 125, '2015-02-15 00:56:07.000000', 'consum', 0.0225, 'lps'),
	(410375, 125, '2015-02-15 00:56:08.000000', 'consum', 0.0211, 'lps'),
	(410376, 125, '2015-02-15 00:56:09.000000', 'consum', 0.0220, 'lps'),
	(410377, 125, '2015-02-15 00:56:10.000000', 'consum', 0.0225, 'lps'),
	(410378, 125, '2015-02-15 00:56:11.000000', 'consum', 0.0219, 'lps'),
	(410379, 125, '2015-02-15 00:56:12.000000', 'consum', 0.0213, 'lps'),
	(410380, 125, '2015-02-15 00:56:13.000000', 'consum', 0.0217, 'lps'),
	(410381, 125, '2015-02-15 00:56:14.000000', 'consum', 0.0217, 'lps'),
	(410382, 125, '2015-02-15 00:56:15.000000', 'consum', 0.0225, 'lps'),
	(410383, 125, '2015-02-15 00:56:16.000000', 'consum', 0.0212, 'lps'),
	(410384, 125, '2015-02-15 00:56:17.000000', 'consum', 0.0226, 'lps'),
	(410385, 125, '2015-02-15 00:56:18.000000', 'consum', 0.0217, 'lps'),
	(410386, 125, '2015-02-15 00:56:19.000000', 'consum', 0.0214, 'lps'),
	(410387, 125, '2015-02-15 00:56:20.000000', 'consum', 0.0212, 'lps'),
	(410388, 125, '2015-02-15 00:56:21.000000', 'consum', 0.0225, 'lps'),
	(410389, 125, '2015-02-15 00:56:22.000000', 'consum', 0.0211, 'lps'),
	(410390, 125, '2015-02-15 00:56:23.000000', 'consum', 0.0220, 'lps'),
	(410391, 125, '2015-02-15 00:56:24.000000', 'consum', 0.0226, 'lps'),
	(410392, 125, '2015-02-15 00:56:25.000000', 'consum', 0.0226, 'lps'),
	(410393, 125, '2015-02-15 00:56:26.000000', 'consum', 0.0224, 'lps'),
	(410394, 125, '2015-02-15 00:56:27.000000', 'consum', 0.0218, 'lps'),
	(410395, 125, '2015-02-15 00:56:28.000000', 'consum', 0.0224, 'lps'),
	(410396, 125, '2015-02-15 00:56:29.000000', 'consum', 0.0224, 'lps'),
	(410397, 125, '2015-02-15 00:56:30.000000', 'consum', 0.0221, 'lps'),
	(410398, 125, '2015-02-15 00:56:31.000000', 'consum', 0.0225, 'lps'),
	(410399, 125, '2015-02-15 00:56:32.000000', 'consum', 0.0216, 'lps'),
	(410400, 125, '2015-02-15 00:56:33.000000', 'consum', 0.0211, 'lps'),
	(410401, 125, '2015-02-15 00:56:34.000000', 'consum', 0.0218, 'lps'),
	(410402, 125, '2015-02-15 00:56:35.000000', 'consum', 0.0211, 'lps'),
	(410403, 125, '2015-02-15 00:56:36.000000', 'consum', 0.0211, 'lps'),
	(410404, 125, '2015-02-15 00:56:37.000000', 'consum', 0.0211, 'lps'),
	(410405, 125, '2015-02-15 00:56:38.000000', 'consum', 0.0215, 'lps'),
	(410406, 125, '2015-02-15 00:56:39.000000', 'consum', 0.0212, 'lps'),
	(410407, 125, '2015-02-15 00:56:40.000000', 'consum', 0.0226, 'lps'),
	(410408, 125, '2015-02-15 00:56:41.000000', 'consum', 0.0214, 'lps'),
	(410409, 125, '2015-02-15 00:56:42.000000', 'consum', 0.0219, 'lps'),
	(410410, 125, '2015-02-15 00:56:43.000000', 'consum', 0.0225, 'lps'),
	(410411, 125, '2015-02-15 00:56:44.000000', 'consum', 0.0223, 'lps'),
	(410412, 125, '2015-02-15 00:56:45.000000', 'consum', 0.0213, 'lps'),
	(410413, 125, '2015-02-15 00:56:46.000000', 'consum', 0.0223, 'lps'),
	(410414, 125, '2015-02-15 00:56:47.000000', 'consum', 0.0212, 'lps'),
	(410415, 125, '2015-02-15 00:56:48.000000', 'consum', 0.0219, 'lps'),
	(410416, 125, '2015-02-15 00:56:49.000000', 'consum', 0.0216, 'lps'),
	(410417, 125, '2015-02-15 00:56:50.000000', 'consum', 0.0211, 'lps'),
	(410418, 125, '2015-02-15 00:56:51.000000', 'consum', 0.0216, 'lps'),
	(410419, 125, '2015-02-15 00:56:52.000000', 'consum', 0.0221, 'lps'),
	(410420, 125, '2015-02-15 00:56:53.000000', 'consum', 0.0214, 'lps'),
	(410421, 125, '2015-02-15 00:56:54.000000', 'consum', 0.0213, 'lps'),
	(410422, 125, '2015-02-15 00:56:55.000000', 'consum', 0.0213, 'lps'),
	(410423, 125, '2015-02-15 00:56:56.000000', 'consum', 0.0215, 'lps'),
	(410424, 125, '2015-02-15 00:56:57.000000', 'consum', 0.0213, 'lps'),
	(410425, 125, '2015-02-15 00:56:58.000000', 'consum', 0.0226, 'lps'),
	(410426, 125, '2015-02-15 00:56:59.000000', 'consum', 0.0215, 'lps'),
	(410427, 125, '2015-02-15 00:57:00.000000', 'consum', 0.0219, 'lps'),
	(410428, 125, '2015-02-15 00:57:01.000000', 'consum', 0.0225, 'lps'),
	(410429, 125, '2015-02-15 00:57:02.000000', 'consum', 0.0225, 'lps'),
	(410430, 125, '2015-02-15 00:57:03.000000', 'consum', 0.0221, 'lps'),
	(410431, 125, '2015-02-15 00:57:04.000000', 'consum', 0.0223, 'lps'),
	(410432, 125, '2015-02-15 00:57:05.000000', 'consum', 0.0226, 'lps'),
	(410433, 125, '2015-02-15 00:57:06.000000', 'consum', 0.0217, 'lps'),
	(410434, 125, '2015-02-15 00:57:07.000000', 'consum', 0.0216, 'lps'),
	(410435, 125, '2015-02-15 00:57:08.000000', 'consum', 0.0219, 'lps'),
	(410436, 125, '2015-02-15 00:57:09.000000', 'consum', 0.0219, 'lps'),
	(410437, 125, '2015-02-15 00:57:10.000000', 'consum', 0.0213, 'lps'),
	(410438, 125, '2015-02-15 00:57:11.000000', 'consum', 0.0216, 'lps'),
	(410439, 125, '2015-02-15 00:57:12.000000', 'consum', 0.0212, 'lps'),
	(410440, 125, '2015-02-15 00:57:13.000000', 'consum', 0.0220, 'lps'),
	(410441, 125, '2015-02-15 00:57:14.000000', 'consum', 0.0222, 'lps'),
	(410442, 125, '2015-02-15 00:57:15.000000', 'consum', 0.0225, 'lps'),
	(410443, 125, '2015-02-15 00:57:16.000000', 'consum', 0.0212, 'lps'),
	(410444, 125, '2015-02-15 00:57:17.000000', 'consum', 0.0213, 'lps'),
	(410445, 125, '2015-02-15 00:57:18.000000', 'consum', 0.0218, 'lps'),
	(410446, 125, '2015-02-15 00:57:19.000000', 'consum', 0.0225, 'lps'),
	(410447, 125, '2015-02-15 00:57:20.000000', 'consum', 0.0225, 'lps'),
	(410448, 125, '2015-02-15 00:57:21.000000', 'consum', 0.0226, 'lps'),
	(410449, 125, '2015-02-15 00:57:22.000000', 'consum', 0.0212, 'lps'),
	(410450, 125, '2015-02-15 00:57:23.000000', 'consum', 0.0222, 'lps'),
	(410451, 125, '2015-02-15 00:57:24.000000', 'consum', 0.0214, 'lps'),
	(410452, 125, '2015-02-15 00:57:25.000000', 'consum', 0.0213, 'lps'),
	(410453, 125, '2015-02-15 00:57:26.000000', 'consum', 0.0213, 'lps'),
	(410454, 125, '2015-02-15 00:57:27.000000', 'consum', 0.0215, 'lps'),
	(410455, 125, '2015-02-15 00:57:28.000000', 'consum', 0.0212, 'lps'),
	(410456, 125, '2015-02-15 00:57:29.000000', 'consum', 0.0219, 'lps'),
	(410457, 125, '2015-02-15 00:57:30.000000', 'consum', 0.0218, 'lps'),
	(410458, 125, '2015-02-15 00:57:31.000000', 'consum', 0.0223, 'lps'),
	(410459, 125, '2015-02-15 00:57:32.000000', 'consum', 0.0219, 'lps'),
	(410460, 125, '2015-02-15 00:57:33.000000', 'consum', 0.0215, 'lps'),
	(410461, 125, '2015-02-15 00:57:34.000000', 'consum', 0.0225, 'lps'),
	(410462, 125, '2015-02-15 00:57:35.000000', 'consum', 0.0220, 'lps'),
	(410463, 125, '2015-02-15 00:57:36.000000', 'consum', 0.0216, 'lps'),
	(410464, 125, '2015-02-15 00:57:37.000000', 'consum', 0.0211, 'lps'),
	(410465, 125, '2015-02-15 00:57:38.000000', 'consum', 0.0216, 'lps'),
	(410466, 125, '2015-02-15 00:57:39.000000', 'consum', 0.0218, 'lps'),
	(410467, 125, '2015-02-15 00:57:40.000000', 'consum', 0.0218, 'lps'),
	(410468, 125, '2015-02-15 00:57:41.000000', 'consum', 0.0210, 'lps'),
	(410469, 125, '2015-02-15 00:57:42.000000', 'consum', 0.0218, 'lps'),
	(410470, 125, '2015-02-15 00:57:43.000000', 'consum', 0.0217, 'lps'),
	(410471, 125, '2015-02-15 00:57:44.000000', 'consum', 0.0223, 'lps'),
	(410472, 125, '2015-02-15 00:57:45.000000', 'consum', 0.0220, 'lps'),
	(410473, 125, '2015-02-15 00:57:46.000000', 'consum', 0.0220, 'lps'),
	(410474, 125, '2015-02-15 00:57:47.000000', 'consum', 0.0216, 'lps'),
	(410475, 125, '2015-02-15 00:57:48.000000', 'consum', 0.0226, 'lps'),
	(410476, 125, '2015-02-15 00:57:49.000000', 'consum', 0.0221, 'lps'),
	(410477, 125, '2015-02-15 00:57:50.000000', 'consum', 0.0219, 'lps'),
	(410478, 125, '2015-02-15 00:57:51.000000', 'consum', 0.0221, 'lps'),
	(410479, 125, '2015-02-15 00:57:52.000000', 'consum', 0.0222, 'lps'),
	(410480, 125, '2015-02-15 00:57:53.000000', 'consum', 0.0222, 'lps'),
	(410481, 125, '2015-02-15 00:57:54.000000', 'consum', 0.0216, 'lps'),
	(410482, 125, '2015-02-15 00:57:55.000000', 'consum', 0.0222, 'lps'),
	(410483, 125, '2015-02-15 00:57:56.000000', 'consum', 0.0216, 'lps'),
	(410484, 125, '2015-02-15 00:57:57.000000', 'consum', 0.0224, 'lps'),
	(410485, 125, '2015-02-15 00:57:58.000000', 'consum', 0.0212, 'lps'),
	(410486, 125, '2015-02-15 00:57:59.000000', 'consum', 0.0211, 'lps'),
	(410487, 125, '2015-02-15 00:58:00.000000', 'consum', 0.0211, 'lps'),
	(410488, 125, '2015-02-15 00:58:01.000000', 'consum', 0.0211, 'lps'),
	(410489, 125, '2015-02-15 00:58:02.000000', 'consum', 0.0215, 'lps'),
	(410490, 125, '2015-02-15 00:58:03.000000', 'consum', 0.0214, 'lps'),
	(410491, 125, '2015-02-15 00:58:04.000000', 'consum', 0.0217, 'lps'),
	(410492, 125, '2015-02-15 00:58:05.000000', 'consum', 0.0214, 'lps'),
	(410493, 125, '2015-02-15 00:58:06.000000', 'consum', 0.0226, 'lps'),
	(410494, 125, '2015-02-15 00:58:07.000000', 'consum', 0.0212, 'lps'),
	(410495, 125, '2015-02-15 00:58:08.000000', 'consum', 0.0222, 'lps'),
	(410496, 125, '2015-02-15 00:58:09.000000', 'consum', 0.0212, 'lps'),
	(410497, 125, '2015-02-15 00:58:10.000000', 'consum', 0.0222, 'lps'),
	(410498, 125, '2015-02-15 00:58:11.000000', 'consum', 0.0212, 'lps'),
	(410499, 125, '2015-02-15 00:58:12.000000', 'consum', 0.0219, 'lps'),
	(410500, 125, '2015-02-15 00:58:13.000000', 'consum', 0.0217, 'lps'),
	(410501, 125, '2015-02-15 00:58:14.000000', 'consum', 0.0216, 'lps'),
	(410502, 125, '2015-02-15 00:58:15.000000', 'consum', 0.0220, 'lps'),
	(410503, 125, '2015-02-15 00:58:16.000000', 'consum', 0.0224, 'lps'),
	(410504, 125, '2015-02-15 00:58:17.000000', 'consum', 0.0218, 'lps'),
	(410505, 125, '2015-02-15 00:58:18.000000', 'consum', 0.0224, 'lps'),
	(410506, 125, '2015-02-15 00:58:19.000000', 'consum', 0.0223, 'lps'),
	(410507, 125, '2015-02-15 00:58:20.000000', 'consum', 0.0216, 'lps'),
	(410508, 125, '2015-02-15 00:58:21.000000', 'consum', 0.0218, 'lps'),
	(410509, 125, '2015-02-15 00:58:22.000000', 'consum', 0.0215, 'lps'),
	(410510, 125, '2015-02-15 00:58:23.000000', 'consum', 0.0211, 'lps'),
	(410511, 125, '2015-02-15 00:58:24.000000', 'consum', 0.0219, 'lps'),
	(410512, 125, '2015-02-15 00:58:25.000000', 'consum', 0.0219, 'lps'),
	(410513, 125, '2015-02-15 00:58:26.000000', 'consum', 0.0210, 'lps'),
	(410514, 125, '2015-02-15 00:58:27.000000', 'consum', 0.0218, 'lps'),
	(410515, 125, '2015-02-15 00:58:28.000000', 'consum', 0.0217, 'lps'),
	(410516, 125, '2015-02-15 00:58:29.000000', 'consum', 0.0222, 'lps'),
	(410517, 125, '2015-02-15 00:58:30.000000', 'consum', 0.0217, 'lps'),
	(410518, 125, '2015-02-15 00:58:31.000000', 'consum', 0.0224, 'lps'),
	(410519, 125, '2015-02-15 00:58:32.000000', 'consum', 0.0226, 'lps'),
	(410520, 125, '2015-02-15 00:58:33.000000', 'consum', 0.0216, 'lps'),
	(410521, 125, '2015-02-15 00:58:34.000000', 'consum', 0.0226, 'lps'),
	(410522, 125, '2015-02-15 00:58:35.000000', 'consum', 0.0223, 'lps'),
	(410523, 125, '2015-02-15 00:58:36.000000', 'consum', 0.0210, 'lps'),
	(410524, 125, '2015-02-15 00:58:37.000000', 'consum', 0.0222, 'lps'),
	(410525, 125, '2015-02-15 00:58:38.000000', 'consum', 0.0219, 'lps'),
	(410526, 125, '2015-02-15 00:58:39.000000', 'consum', 0.0218, 'lps'),
	(410527, 125, '2015-02-15 00:58:40.000000', 'consum', 0.0224, 'lps'),
	(410528, 125, '2015-02-15 00:58:41.000000', 'consum', 0.0225, 'lps'),
	(410529, 125, '2015-02-15 00:58:42.000000', 'consum', 0.0225, 'lps'),
	(410530, 125, '2015-02-15 00:58:43.000000', 'consum', 0.0223, 'lps'),
	(410531, 125, '2015-02-15 00:58:44.000000', 'consum', 0.0216, 'lps'),
	(410532, 125, '2015-02-15 00:58:45.000000', 'consum', 0.0217, 'lps'),
	(410533, 125, '2015-02-15 00:58:46.000000', 'consum', 0.0226, 'lps'),
	(410534, 125, '2015-02-15 00:58:47.000000', 'consum', 0.0220, 'lps'),
	(410535, 125, '2015-02-15 00:58:48.000000', 'consum', 0.0210, 'lps'),
	(410536, 125, '2015-02-15 00:58:49.000000', 'consum', 0.0218, 'lps'),
	(410537, 125, '2015-02-15 00:58:50.000000', 'consum', 0.0214, 'lps'),
	(410538, 125, '2015-02-15 00:58:51.000000', 'consum', 0.0223, 'lps'),
	(410539, 125, '2015-02-15 00:58:52.000000', 'consum', 0.0214, 'lps'),
	(410540, 125, '2015-02-15 00:58:53.000000', 'consum', 0.0225, 'lps'),
	(410541, 125, '2015-02-15 00:58:54.000000', 'consum', 0.0225, 'lps'),
	(410542, 125, '2015-02-15 00:58:55.000000', 'consum', 0.0220, 'lps'),
	(410543, 125, '2015-02-15 00:58:56.000000', 'consum', 0.0217, 'lps'),
	(410544, 125, '2015-02-15 00:58:57.000000', 'consum', 0.0217, 'lps'),
	(410545, 125, '2015-02-15 00:58:58.000000', 'consum', 0.0222, 'lps'),
	(410546, 125, '2015-02-15 00:58:59.000000', 'consum', 0.0217, 'lps'),
	(410547, 125, '2015-02-15 00:59:00.000000', 'consum', 0.0226, 'lps'),
	(410548, 125, '2015-02-15 00:59:01.000000', 'consum', 0.0219, 'lps'),
	(410549, 125, '2015-02-15 00:59:02.000000', 'consum', 0.0223, 'lps'),
	(410550, 125, '2015-02-15 00:59:03.000000', 'consum', 0.0214, 'lps'),
	(410551, 125, '2015-02-15 00:59:04.000000', 'consum', 0.0211, 'lps'),
	(410552, 125, '2015-02-15 00:59:05.000000', 'consum', 0.0220, 'lps'),
	(410553, 125, '2015-02-15 00:59:06.000000', 'consum', 0.0222, 'lps'),
	(410554, 125, '2015-02-15 00:59:07.000000', 'consum', 0.0226, 'lps'),
	(410555, 125, '2015-02-15 00:59:08.000000', 'consum', 0.0219, 'lps'),
	(410556, 125, '2015-02-15 00:59:09.000000', 'consum', 0.0223, 'lps'),
	(410557, 125, '2015-02-15 00:59:10.000000', 'consum', 0.0215, 'lps'),
	(410558, 125, '2015-02-15 00:59:11.000000', 'consum', 0.0212, 'lps'),
	(410559, 125, '2015-02-15 00:59:12.000000', 'consum', 0.0224, 'lps'),
	(410560, 125, '2015-02-15 00:59:13.000000', 'consum', 0.0225, 'lps'),
	(410561, 125, '2015-02-15 00:59:14.000000', 'consum', 0.0210, 'lps'),
	(410562, 125, '2015-02-15 00:59:15.000000', 'consum', 0.0216, 'lps'),
	(410563, 125, '2015-02-15 00:59:16.000000', 'consum', 0.0224, 'lps'),
	(410564, 125, '2015-02-15 00:59:17.000000', 'consum', 0.0211, 'lps'),
	(410565, 125, '2015-02-15 00:59:18.000000', 'consum', 0.0224, 'lps'),
	(410566, 125, '2015-02-15 00:59:19.000000', 'consum', 0.0212, 'lps'),
	(410567, 125, '2015-02-15 00:59:20.000000', 'consum', 0.0226, 'lps'),
	(410568, 125, '2015-02-15 00:59:21.000000', 'consum', 0.0219, 'lps'),
	(410569, 125, '2015-02-15 00:59:22.000000', 'consum', 0.0225, 'lps'),
	(410570, 125, '2015-02-15 00:59:23.000000', 'consum', 0.0222, 'lps'),
	(410571, 125, '2015-02-15 00:59:24.000000', 'consum', 0.0225, 'lps'),
	(410572, 125, '2015-02-15 00:59:25.000000', 'consum', 0.0216, 'lps'),
	(410573, 125, '2015-02-15 00:59:26.000000', 'consum', 0.0214, 'lps'),
	(410574, 125, '2015-02-15 00:59:27.000000', 'consum', 0.0212, 'lps'),
	(410575, 125, '2015-02-15 00:59:28.000000', 'consum', 0.0210, 'lps'),
	(410576, 125, '2015-02-15 00:59:29.000000', 'consum', 0.0220, 'lps'),
	(410577, 125, '2015-02-15 00:59:30.000000', 'consum', 0.0226, 'lps'),
	(410578, 125, '2015-02-15 00:59:31.000000', 'consum', 0.0226, 'lps'),
	(410579, 125, '2015-02-15 00:59:32.000000', 'consum', 0.0211, 'lps'),
	(410580, 125, '2015-02-15 00:59:33.000000', 'consum', 0.0218, 'lps'),
	(410581, 125, '2015-02-15 00:59:34.000000', 'consum', 0.0212, 'lps'),
	(410582, 125, '2015-02-15 00:59:35.000000', 'consum', 0.0213, 'lps'),
	(410583, 125, '2015-02-15 00:59:36.000000', 'consum', 0.0222, 'lps'),
	(410584, 125, '2015-02-15 00:59:37.000000', 'consum', 0.0210, 'lps'),
	(410585, 125, '2015-02-15 00:59:38.000000', 'consum', 0.0225, 'lps'),
	(410586, 125, '2015-02-15 00:59:39.000000', 'consum', 0.0220, 'lps'),
	(410587, 125, '2015-02-15 00:59:40.000000', 'consum', 0.0212, 'lps'),
	(410588, 125, '2015-02-15 00:59:41.000000', 'consum', 0.0226, 'lps'),
	(410589, 125, '2015-02-15 00:59:42.000000', 'consum', 0.0217, 'lps'),
	(410590, 125, '2015-02-15 00:59:43.000000', 'consum', 0.0214, 'lps'),
	(410591, 125, '2015-02-15 00:59:44.000000', 'consum', 0.0210, 'lps'),
	(410592, 125, '2015-02-15 00:59:45.000000', 'consum', 0.0217, 'lps'),
	(410593, 125, '2015-02-15 00:59:46.000000', 'consum', 0.0226, 'lps'),
	(410594, 125, '2015-02-15 00:59:47.000000', 'consum', 0.0221, 'lps'),
	(410595, 125, '2015-02-15 00:59:48.000000', 'consum', 0.0218, 'lps'),
	(410596, 125, '2015-02-15 00:59:49.000000', 'consum', 0.0218, 'lps'),
	(410597, 125, '2015-02-15 00:59:50.000000', 'consum', 0.0224, 'lps'),
	(410598, 125, '2015-02-15 00:59:51.000000', 'consum', 0.0223, 'lps'),
	(410599, 125, '2015-02-15 00:59:52.000000', 'consum', 0.0218, 'lps'),
	(410600, 125, '2015-02-15 00:59:53.000000', 'consum', 0.0211, 'lps'),
	(410601, 125, '2015-02-15 00:59:54.000000', 'consum', 0.0210, 'lps'),
	(410602, 125, '2015-02-15 00:59:55.000000', 'consum', 0.0225, 'lps'),
	(410603, 125, '2015-02-15 00:59:56.000000', 'consum', 0.0216, 'lps'),
	(410604, 125, '2015-02-15 00:59:57.000000', 'consum', 0.0211, 'lps'),
	(410605, 125, '2015-02-15 00:59:58.000000', 'consum', 0.0218, 'lps'),
	(410606, 125, '2015-02-15 00:59:59.000000', 'consum', 0.0211, 'lps'),
	(410607, 125, '2015-02-15 01:00:00.000000', 'consum', 0.0225, 'lps'),
	(410608, 125, '2015-02-15 01:00:01.000000', 'consum', 0.0214, 'lps'),
	(410609, 125, '2015-02-15 01:00:02.000000', 'consum', 0.0220, 'lps'),
	(410610, 125, '2015-02-15 01:00:03.000000', 'consum', 0.0213, 'lps'),
	(410611, 125, '2015-02-15 01:00:04.000000', 'consum', 0.0214, 'lps'),
	(410612, 125, '2015-02-15 01:00:05.000000', 'consum', 0.0219, 'lps'),
	(410613, 125, '2015-02-15 01:00:06.000000', 'consum', 0.0212, 'lps'),
	(410614, 125, '2015-02-15 01:00:07.000000', 'consum', 0.0212, 'lps'),
	(410615, 125, '2015-02-15 01:00:08.000000', 'consum', 0.0212, 'lps'),
	(410616, 125, '2015-02-15 01:00:09.000000', 'consum', 0.0214, 'lps'),
	(410617, 125, '2015-02-15 01:00:10.000000', 'consum', 0.0210, 'lps'),
	(410618, 125, '2015-02-15 01:00:11.000000', 'consum', 0.0212, 'lps'),
	(410619, 125, '2015-02-15 01:00:12.000000', 'consum', 0.0224, 'lps'),
	(410620, 125, '2015-02-15 01:00:13.000000', 'consum', 0.0222, 'lps'),
	(410621, 125, '2015-02-15 01:00:14.000000', 'consum', 0.0210, 'lps'),
	(410622, 125, '2015-02-15 01:00:15.000000', 'consum', 0.0210, 'lps'),
	(410623, 125, '2015-02-15 01:00:16.000000', 'consum', 0.0226, 'lps'),
	(410624, 125, '2015-02-15 01:00:17.000000', 'consum', 0.0223, 'lps'),
	(410625, 125, '2015-02-15 01:00:18.000000', 'consum', 0.0210, 'lps'),
	(410626, 125, '2015-02-15 01:00:19.000000', 'consum', 0.0224, 'lps'),
	(410627, 125, '2015-02-15 01:00:20.000000', 'consum', 0.0211, 'lps'),
	(410628, 125, '2015-02-15 01:00:21.000000', 'consum', 0.0224, 'lps'),
	(410629, 125, '2015-02-15 01:00:22.000000', 'consum', 0.0226, 'lps'),
	(410630, 125, '2015-02-15 01:00:23.000000', 'consum', 0.0216, 'lps'),
	(410631, 125, '2015-02-15 01:00:24.000000', 'consum', 0.0224, 'lps'),
	(410632, 125, '2015-02-15 01:00:25.000000', 'consum', 0.0214, 'lps'),
	(410633, 125, '2015-02-15 01:00:26.000000', 'consum', 0.0224, 'lps'),
	(410634, 125, '2015-02-15 01:00:27.000000', 'consum', 0.0215, 'lps'),
	(410635, 125, '2015-02-15 01:00:28.000000', 'consum', 0.0210, 'lps'),
	(410636, 125, '2015-02-15 01:00:29.000000', 'consum', 0.0213, 'lps'),
	(410637, 125, '2015-02-15 01:00:30.000000', 'consum', 0.0225, 'lps'),
	(410638, 125, '2015-02-15 01:00:31.000000', 'consum', 0.0226, 'lps'),
	(410639, 125, '2015-02-15 01:00:32.000000', 'consum', 0.0211, 'lps'),
	(410640, 125, '2015-02-15 01:00:33.000000', 'consum', 0.0217, 'lps'),
	(410641, 125, '2015-02-15 01:00:34.000000', 'consum', 0.0210, 'lps'),
	(410642, 125, '2015-02-15 01:00:35.000000', 'consum', 0.0223, 'lps'),
	(410643, 125, '2015-02-15 01:00:36.000000', 'consum', 0.0224, 'lps'),
	(410644, 125, '2015-02-15 01:00:37.000000', 'consum', 0.0225, 'lps'),
	(410645, 125, '2015-02-15 01:00:38.000000', 'consum', 0.0226, 'lps'),
	(410646, 125, '2015-02-15 01:00:39.000000', 'consum', 0.0211, 'lps'),
	(410647, 125, '2015-02-15 01:00:40.000000', 'consum', 0.0219, 'lps'),
	(410648, 125, '2015-02-15 01:00:41.000000', 'consum', 0.0220, 'lps'),
	(410649, 125, '2015-02-15 01:00:42.000000', 'consum', 0.0215, 'lps'),
	(410650, 125, '2015-02-15 01:00:43.000000', 'consum', 0.0222, 'lps'),
	(410651, 125, '2015-02-15 01:00:44.000000', 'consum', 0.0222, 'lps'),
	(410652, 125, '2015-02-15 01:00:45.000000', 'consum', 0.0218, 'lps'),
	(410653, 125, '2015-02-15 01:00:46.000000', 'consum', 0.0212, 'lps'),
	(410654, 125, '2015-02-15 01:00:47.000000', 'consum', 0.0216, 'lps'),
	(410655, 125, '2015-02-15 01:00:48.000000', 'consum', 0.0218, 'lps'),
	(410656, 125, '2015-02-15 01:00:49.000000', 'consum', 0.0214, 'lps'),
	(410657, 125, '2015-02-15 01:00:50.000000', 'consum', 0.0224, 'lps'),
	(410658, 125, '2015-02-15 01:00:51.000000', 'consum', 0.0219, 'lps'),
	(410659, 125, '2015-02-15 01:00:52.000000', 'consum', 0.0214, 'lps'),
	(410660, 125, '2015-02-15 01:00:53.000000', 'consum', 0.0221, 'lps'),
	(410661, 125, '2015-02-15 01:00:54.000000', 'consum', 0.0219, 'lps'),
	(410662, 125, '2015-02-15 01:00:55.000000', 'consum', 0.0224, 'lps'),
	(410663, 125, '2015-02-15 01:00:56.000000', 'consum', 0.0218, 'lps'),
	(410664, 125, '2015-02-15 01:00:57.000000', 'consum', 0.0210, 'lps'),
	(410665, 125, '2015-02-15 01:00:58.000000', 'consum', 0.0217, 'lps'),
	(410666, 125, '2015-02-15 01:00:59.000000', 'consum', 0.0215, 'lps'),
	(410667, 125, '2015-02-15 01:01:00.000000', 'consum', 0.0214, 'lps'),
	(410668, 125, '2015-02-15 01:01:01.000000', 'consum', 0.0216, 'lps'),
	(410669, 125, '2015-02-15 01:01:02.000000', 'consum', 0.0210, 'lps'),
	(410670, 125, '2015-02-15 01:01:03.000000', 'consum', 0.0211, 'lps'),
	(410671, 125, '2015-02-15 01:01:04.000000', 'consum', 0.0216, 'lps'),
	(410672, 125, '2015-02-15 01:01:05.000000', 'consum', 0.0220, 'lps'),
	(410673, 125, '2015-02-15 01:01:06.000000', 'consum', 0.0226, 'lps'),
	(410674, 125, '2015-02-15 01:01:07.000000', 'consum', 0.0225, 'lps'),
	(410675, 125, '2015-02-15 01:01:08.000000', 'consum', 0.0222, 'lps'),
	(410676, 125, '2015-02-15 01:01:09.000000', 'consum', 0.0223, 'lps'),
	(410677, 125, '2015-02-15 01:01:10.000000', 'consum', 0.0225, 'lps'),
	(410678, 125, '2015-02-15 01:01:11.000000', 'consum', 0.0210, 'lps'),
	(410679, 125, '2015-02-15 01:01:12.000000', 'consum', 0.0217, 'lps'),
	(410680, 125, '2015-02-15 01:01:13.000000', 'consum', 0.0214, 'lps'),
	(410681, 125, '2015-02-15 01:01:14.000000', 'consum', 0.0225, 'lps'),
	(410682, 125, '2015-02-15 01:01:15.000000', 'consum', 0.0225, 'lps'),
	(410683, 125, '2015-02-15 01:01:16.000000', 'consum', 0.0220, 'lps'),
	(410684, 125, '2015-02-15 01:01:17.000000', 'consum', 0.0217, 'lps'),
	(410685, 125, '2015-02-15 01:01:18.000000', 'consum', 0.0216, 'lps'),
	(410686, 125, '2015-02-15 01:01:19.000000', 'consum', 0.0217, 'lps'),
	(410687, 125, '2015-02-15 01:01:20.000000', 'consum', 0.0213, 'lps'),
	(410688, 125, '2015-02-15 01:01:21.000000', 'consum', 0.0222, 'lps'),
	(410689, 125, '2015-02-15 01:01:22.000000', 'consum', 0.0210, 'lps'),
	(410690, 125, '2015-02-15 01:01:23.000000', 'consum', 0.0210, 'lps'),
	(410691, 125, '2015-02-15 01:01:24.000000', 'consum', 0.0211, 'lps'),
	(410692, 125, '2015-02-15 01:01:25.000000', 'consum', 0.0213, 'lps'),
	(410693, 125, '2015-02-15 01:01:26.000000', 'consum', 0.0223, 'lps'),
	(410694, 125, '2015-02-15 01:01:27.000000', 'consum', 0.0217, 'lps'),
	(410695, 125, '2015-02-15 01:01:28.000000', 'consum', 0.0224, 'lps'),
	(410696, 125, '2015-02-15 01:01:29.000000', 'consum', 0.0225, 'lps'),
	(410697, 125, '2015-02-15 01:01:30.000000', 'consum', 0.0224, 'lps'),
	(410698, 125, '2015-02-15 01:01:31.000000', 'consum', 0.0221, 'lps'),
	(410699, 125, '2015-02-15 01:01:32.000000', 'consum', 0.0222, 'lps'),
	(410700, 125, '2015-02-15 01:01:33.000000', 'consum', 0.0222, 'lps'),
	(410701, 125, '2015-02-15 01:01:34.000000', 'consum', 0.0216, 'lps'),
	(410702, 125, '2015-02-15 01:01:35.000000', 'consum', 0.0220, 'lps'),
	(410703, 125, '2015-02-15 01:01:36.000000', 'consum', 0.0211, 'lps'),
	(410704, 125, '2015-02-15 01:01:37.000000', 'consum', 0.0217, 'lps'),
	(410705, 125, '2015-02-15 01:01:38.000000', 'consum', 0.0211, 'lps'),
	(410706, 125, '2015-02-15 01:01:39.000000', 'consum', 0.0226, 'lps'),
	(410707, 125, '2015-02-15 01:01:40.000000', 'consum', 0.0223, 'lps'),
	(410708, 125, '2015-02-15 01:01:41.000000', 'consum', 0.0225, 'lps'),
	(410709, 125, '2015-02-15 01:01:42.000000', 'consum', 0.0211, 'lps'),
	(410710, 125, '2015-02-15 01:01:43.000000', 'consum', 0.0224, 'lps'),
	(410711, 125, '2015-02-15 01:01:44.000000', 'consum', 0.0226, 'lps'),
	(410712, 125, '2015-02-15 01:01:45.000000', 'consum', 0.0214, 'lps'),
	(410713, 125, '2015-02-15 01:01:46.000000', 'consum', 0.0216, 'lps'),
	(410714, 125, '2015-02-15 01:01:47.000000', 'consum', 0.0211, 'lps'),
	(410715, 125, '2015-02-15 01:01:48.000000', 'consum', 0.0215, 'lps'),
	(410716, 125, '2015-02-15 01:01:49.000000', 'consum', 0.0215, 'lps'),
	(410717, 125, '2015-02-15 01:01:50.000000', 'consum', 0.0222, 'lps'),
	(410718, 125, '2015-02-15 01:01:51.000000', 'consum', 0.0222, 'lps'),
	(410719, 125, '2015-02-15 01:01:52.000000', 'consum', 0.0216, 'lps'),
	(410720, 125, '2015-02-15 01:01:53.000000', 'consum', 0.0220, 'lps'),
	(410721, 125, '2015-02-15 01:01:54.000000', 'consum', 0.0212, 'lps'),
	(410722, 125, '2015-02-15 01:01:55.000000', 'consum', 0.0222, 'lps'),
	(410723, 125, '2015-02-15 01:01:56.000000', 'consum', 0.0213, 'lps'),
	(410724, 125, '2015-02-15 01:01:57.000000', 'consum', 0.0223, 'lps'),
	(410725, 125, '2015-02-15 01:01:58.000000', 'consum', 0.0215, 'lps'),
	(410726, 125, '2015-02-15 01:01:59.000000', 'consum', 0.0215, 'lps'),
	(410727, 125, '2015-02-15 01:02:00.000000', 'consum', 0.0221, 'lps'),
	(410728, 125, '2015-02-15 01:02:01.000000', 'consum', 0.0214, 'lps'),
	(410729, 125, '2015-02-15 01:02:02.000000', 'consum', 0.0217, 'lps'),
	(410730, 125, '2015-02-15 01:02:03.000000', 'consum', 0.0217, 'lps'),
	(410731, 125, '2015-02-15 01:02:04.000000', 'consum', 0.0226, 'lps'),
	(410732, 125, '2015-02-15 01:02:05.000000', 'consum', 0.0216, 'lps'),
	(410733, 125, '2015-02-15 01:02:06.000000', 'consum', 0.0225, 'lps'),
	(410734, 125, '2015-02-15 01:02:07.000000', 'consum', 0.0218, 'lps'),
	(410735, 125, '2015-02-15 01:02:08.000000', 'consum', 0.0223, 'lps'),
	(410736, 125, '2015-02-15 01:02:09.000000', 'consum', 0.0217, 'lps'),
	(410737, 125, '2015-02-15 01:02:10.000000', 'consum', 0.0223, 'lps'),
	(410738, 125, '2015-02-15 01:02:11.000000', 'consum', 0.0221, 'lps'),
	(410739, 125, '2015-02-15 01:02:12.000000', 'consum', 0.0225, 'lps'),
	(410740, 125, '2015-02-15 01:02:13.000000', 'consum', 0.0220, 'lps'),
	(410741, 125, '2015-02-15 01:02:14.000000', 'consum', 0.0217, 'lps'),
	(410742, 125, '2015-02-15 01:02:15.000000', 'consum', 0.0214, 'lps'),
	(410743, 125, '2015-02-15 01:02:16.000000', 'consum', 0.0210, 'lps'),
	(410744, 125, '2015-02-15 01:02:17.000000', 'consum', 0.0216, 'lps'),
	(410745, 125, '2015-02-15 01:02:18.000000', 'consum', 0.0221, 'lps'),
	(410746, 125, '2015-02-15 01:02:19.000000', 'consum', 0.0215, 'lps'),
	(410747, 125, '2015-02-15 01:02:20.000000', 'consum', 0.0221, 'lps'),
	(410748, 125, '2015-02-15 01:02:21.000000', 'consum', 0.0215, 'lps'),
	(410749, 125, '2015-02-15 01:02:22.000000', 'consum', 0.0219, 'lps'),
	(410750, 125, '2015-02-15 01:02:23.000000', 'consum', 0.0223, 'lps'),
	(410751, 125, '2015-02-15 01:02:24.000000', 'consum', 0.0213, 'lps'),
	(410752, 125, '2015-02-15 01:02:25.000000', 'consum', 0.0223, 'lps'),
	(410753, 125, '2015-02-15 01:02:26.000000', 'consum', 0.0216, 'lps'),
	(410754, 125, '2015-02-15 01:02:27.000000', 'consum', 0.0219, 'lps'),
	(410755, 125, '2015-02-15 01:02:28.000000', 'consum', 0.0222, 'lps'),
	(410756, 125, '2015-02-15 01:02:29.000000', 'consum', 0.0224, 'lps'),
	(410757, 125, '2015-02-15 01:02:30.000000', 'consum', 0.0226, 'lps'),
	(410758, 125, '2015-02-15 01:02:31.000000', 'consum', 0.0217, 'lps'),
	(410759, 125, '2015-02-15 01:02:32.000000', 'consum', 0.0214, 'lps'),
	(410760, 125, '2015-02-15 01:02:33.000000', 'consum', 0.0211, 'lps'),
	(410761, 125, '2015-02-15 01:02:34.000000', 'consum', 0.0220, 'lps'),
	(410762, 125, '2015-02-15 01:02:35.000000', 'consum', 0.0222, 'lps'),
	(410763, 125, '2015-02-15 01:02:36.000000', 'consum', 0.0224, 'lps'),
	(410764, 125, '2015-02-15 01:02:37.000000', 'consum', 0.0226, 'lps'),
	(410765, 125, '2015-02-15 01:02:38.000000', 'consum', 0.0215, 'lps'),
	(410766, 125, '2015-02-15 01:02:39.000000', 'consum', 0.0220, 'lps'),
	(410767, 125, '2015-02-15 01:02:40.000000', 'consum', 0.0212, 'lps'),
	(410768, 125, '2015-02-15 01:02:41.000000', 'consum', 0.0226, 'lps'),
	(410769, 125, '2015-02-15 01:02:42.000000', 'consum', 0.0214, 'lps'),
	(410770, 125, '2015-02-15 01:02:43.000000', 'consum', 0.0218, 'lps'),
	(410771, 125, '2015-02-15 01:02:44.000000', 'consum', 0.0220, 'lps'),
	(410772, 125, '2015-02-15 01:02:45.000000', 'consum', 0.0222, 'lps'),
	(410773, 125, '2015-02-15 01:02:46.000000', 'consum', 0.0222, 'lps'),
	(410774, 125, '2015-02-15 01:02:47.000000', 'consum', 0.0218, 'lps'),
	(410775, 125, '2015-02-15 01:02:48.000000', 'consum', 0.0214, 'lps'),
	(410776, 125, '2015-02-15 01:02:49.000000', 'consum', 0.0226, 'lps'),
	(410777, 125, '2015-02-15 01:02:50.000000', 'consum', 0.0225, 'lps'),
	(410778, 125, '2015-02-15 01:02:51.000000', 'consum', 0.0223, 'lps'),
	(410779, 125, '2015-02-15 01:02:52.000000', 'consum', 0.0213, 'lps'),
	(410780, 125, '2015-02-15 01:02:53.000000', 'consum', 0.0218, 'lps'),
	(410781, 125, '2015-02-15 01:02:54.000000', 'consum', 0.0211, 'lps'),
	(410782, 125, '2015-02-15 01:02:55.000000', 'consum', 0.0224, 'lps'),
	(410783, 125, '2015-02-15 01:02:56.000000', 'consum', 0.0225, 'lps'),
	(410784, 125, '2015-02-15 01:02:57.000000', 'consum', 0.0211, 'lps'),
	(410785, 125, '2015-02-15 01:02:58.000000', 'consum', 0.0223, 'lps'),
	(410786, 125, '2015-02-15 01:02:59.000000', 'consum', 0.0221, 'lps'),
	(410787, 125, '2015-02-15 01:03:00.000000', 'consum', 0.0210, 'lps'),
	(410788, 125, '2015-02-15 01:03:01.000000', 'consum', 0.0226, 'lps'),
	(410789, 125, '2015-02-15 01:03:02.000000', 'consum', 0.0222, 'lps'),
	(410790, 125, '2015-02-15 01:03:03.000000', 'consum', 0.0225, 'lps'),
	(410791, 125, '2015-02-15 01:03:04.000000', 'consum', 0.0216, 'lps'),
	(410792, 125, '2015-02-15 01:03:05.000000', 'consum', 0.0211, 'lps'),
	(410793, 125, '2015-02-15 01:03:06.000000', 'consum', 0.0214, 'lps'),
	(410794, 125, '2015-02-15 01:03:07.000000', 'consum', 0.0212, 'lps'),
	(410795, 125, '2015-02-15 01:03:08.000000', 'consum', 0.0223, 'lps'),
	(410796, 125, '2015-02-15 01:03:09.000000', 'consum', 0.0219, 'lps'),
	(410797, 125, '2015-02-15 01:03:10.000000', 'consum', 0.0219, 'lps'),
	(410798, 125, '2015-02-15 01:03:11.000000', 'consum', 0.0210, 'lps'),
	(410799, 125, '2015-02-15 01:03:12.000000', 'consum', 0.0218, 'lps'),
	(410800, 125, '2015-02-15 01:03:13.000000', 'consum', 0.0217, 'lps'),
	(410801, 125, '2015-02-15 01:03:14.000000', 'consum', 0.0223, 'lps'),
	(410802, 125, '2015-02-15 01:03:15.000000', 'consum', 0.0219, 'lps'),
	(410803, 125, '2015-02-15 01:03:16.000000', 'consum', 0.0218, 'lps'),
	(410804, 125, '2015-02-15 01:03:17.000000', 'consum', 0.0223, 'lps'),
	(410805, 125, '2015-02-15 01:03:18.000000', 'consum', 0.0215, 'lps'),
	(410806, 125, '2015-02-15 01:03:19.000000', 'consum', 0.0215, 'lps'),
	(410807, 125, '2015-02-15 01:03:20.000000', 'consum', 0.0223, 'lps'),
	(410808, 125, '2015-02-15 01:03:21.000000', 'consum', 0.0223, 'lps'),
	(410809, 125, '2015-02-15 01:03:22.000000', 'consum', 0.0220, 'lps'),
	(410810, 125, '2015-02-15 01:03:23.000000', 'consum', 0.0222, 'lps'),
	(410811, 125, '2015-02-15 01:03:24.000000', 'consum', 0.0226, 'lps'),
	(410812, 125, '2015-02-15 01:03:25.000000', 'consum', 0.0217, 'lps'),
	(410813, 125, '2015-02-15 01:03:26.000000', 'consum', 0.0214, 'lps'),
	(410814, 125, '2015-02-15 01:03:27.000000', 'consum', 0.0211, 'lps'),
	(410815, 125, '2015-02-15 01:03:28.000000', 'consum', 0.0222, 'lps'),
	(410816, 125, '2015-02-15 01:03:29.000000', 'consum', 0.0215, 'lps'),
	(410817, 125, '2015-02-15 01:03:30.000000', 'consum', 0.0218, 'lps'),
	(410818, 125, '2015-02-15 01:03:31.000000', 'consum', 0.0216, 'lps'),
	(410819, 125, '2015-02-15 01:03:32.000000', 'consum', 0.0217, 'lps'),
	(410820, 125, '2015-02-15 01:03:33.000000', 'consum', 0.0212, 'lps'),
	(410821, 125, '2015-02-15 01:03:34.000000', 'consum', 0.0215, 'lps'),
	(410822, 125, '2015-02-15 01:03:35.000000', 'consum', 0.0215, 'lps'),
	(410823, 125, '2015-02-15 01:03:36.000000', 'consum', 0.0217, 'lps'),
	(410824, 125, '2015-02-15 01:03:37.000000', 'consum', 0.0215, 'lps'),
	(410825, 125, '2015-02-15 01:03:38.000000', 'consum', 0.0216, 'lps'),
	(410826, 125, '2015-02-15 01:03:39.000000', 'consum', 0.0223, 'lps'),
	(410827, 125, '2015-02-15 01:03:40.000000', 'consum', 0.0224, 'lps'),
	(410828, 125, '2015-02-15 01:03:41.000000', 'consum', 0.0210, 'lps'),
	(410829, 125, '2015-02-15 01:03:42.000000', 'consum', 0.0216, 'lps'),
	(410830, 125, '2015-02-15 01:03:43.000000', 'consum', 0.0225, 'lps'),
	(410831, 125, '2015-02-15 01:03:44.000000', 'consum', 0.0215, 'lps'),
	(410832, 125, '2015-02-15 01:03:45.000000', 'consum', 0.0225, 'lps'),
	(410833, 125, '2015-02-15 01:03:46.000000', 'consum', 0.0218, 'lps'),
	(410834, 125, '2015-02-15 01:03:47.000000', 'consum', 0.0223, 'lps'),
	(410835, 125, '2015-02-15 01:03:48.000000', 'consum', 0.0220, 'lps'),
	(410836, 125, '2015-02-15 01:03:49.000000', 'consum', 0.0218, 'lps'),
	(410837, 125, '2015-02-15 01:03:50.000000', 'consum', 0.0224, 'lps'),
	(410838, 125, '2015-02-15 01:03:51.000000', 'consum', 0.0222, 'lps'),
	(410839, 125, '2015-02-15 01:03:52.000000', 'consum', 0.0210, 'lps'),
	(410840, 125, '2015-02-15 01:03:53.000000', 'consum', 0.0225, 'lps'),
	(410841, 125, '2015-02-15 01:03:54.000000', 'consum', 0.0216, 'lps'),
	(410842, 125, '2015-02-15 01:03:55.000000', 'consum', 0.0216, 'lps'),
	(410843, 125, '2015-02-15 01:03:56.000000', 'consum', 0.0220, 'lps'),
	(410844, 125, '2015-02-15 01:03:57.000000', 'consum', 0.0226, 'lps'),
	(410845, 125, '2015-02-15 01:03:58.000000', 'consum', 0.0226, 'lps'),
	(410846, 125, '2015-02-15 01:03:59.000000', 'consum', 0.0210, 'lps'),
	(410847, 125, '2015-02-15 01:04:00.000000', 'consum', 0.0215, 'lps'),
	(410848, 125, '2015-02-15 01:04:01.000000', 'consum', 0.0216, 'lps'),
	(410849, 125, '2015-02-15 01:04:02.000000', 'consum', 0.0211, 'lps'),
	(410850, 125, '2015-02-15 01:04:03.000000', 'consum', 0.0212, 'lps'),
	(410851, 125, '2015-02-15 01:04:04.000000', 'consum', 0.0220, 'lps'),
	(410852, 125, '2015-02-15 01:04:05.000000', 'consum', 0.0218, 'lps'),
	(410853, 125, '2015-02-15 01:04:06.000000', 'consum', 0.0220, 'lps'),
	(410854, 125, '2015-02-15 01:04:07.000000', 'consum', 0.0221, 'lps'),
	(410855, 125, '2015-02-15 01:04:08.000000', 'consum', 0.0216, 'lps'),
	(410856, 125, '2015-02-15 01:04:09.000000', 'consum', 0.0210, 'lps'),
	(410857, 125, '2015-02-15 01:04:10.000000', 'consum', 0.0225, 'lps'),
	(410858, 125, '2015-02-15 01:04:11.000000', 'consum', 0.0217, 'lps'),
	(410859, 125, '2015-02-15 01:04:12.000000', 'consum', 0.0219, 'lps'),
	(410860, 125, '2015-02-15 01:04:13.000000', 'consum', 0.0218, 'lps'),
	(410861, 125, '2015-02-15 01:04:14.000000', 'consum', 0.0224, 'lps'),
	(410862, 125, '2015-02-15 01:04:15.000000', 'consum', 0.0223, 'lps'),
	(410863, 125, '2015-02-15 01:04:16.000000', 'consum', 0.0217, 'lps'),
	(410864, 125, '2015-02-15 01:04:17.000000', 'consum', 0.0221, 'lps'),
	(410865, 125, '2015-02-15 01:04:18.000000', 'consum', 0.0213, 'lps'),
	(410866, 125, '2015-02-15 01:04:19.000000', 'consum', 0.0226, 'lps'),
	(410867, 125, '2015-02-15 01:04:20.000000', 'consum', 0.0214, 'lps'),
	(410868, 125, '2015-02-15 01:04:21.000000', 'consum', 0.0216, 'lps'),
	(410869, 125, '2015-02-15 01:04:22.000000', 'consum', 0.0210, 'lps'),
	(410870, 125, '2015-02-15 01:04:23.000000', 'consum', 0.0226, 'lps'),
	(410871, 125, '2015-02-15 01:04:24.000000', 'consum', 0.0224, 'lps'),
	(410872, 125, '2015-02-15 01:04:25.000000', 'consum', 0.0215, 'lps'),
	(410873, 125, '2015-02-15 01:04:26.000000', 'consum', 0.0212, 'lps'),
	(410874, 125, '2015-02-15 01:04:27.000000', 'consum', 0.0221, 'lps'),
	(410875, 125, '2015-02-15 01:04:28.000000', 'consum', 0.0226, 'lps'),
	(410876, 125, '2015-02-15 01:04:29.000000', 'consum', 0.0223, 'lps'),
	(410877, 125, '2015-02-15 01:04:30.000000', 'consum', 0.0210, 'lps'),
	(410878, 125, '2015-02-15 01:04:31.000000', 'consum', 0.0222, 'lps'),
	(410879, 125, '2015-02-15 01:04:32.000000', 'consum', 0.0222, 'lps'),
	(410880, 125, '2015-02-15 01:04:33.000000', 'consum', 0.0216, 'lps'),
	(410881, 125, '2015-02-15 01:04:34.000000', 'consum', 0.0223, 'lps'),
	(410882, 125, '2015-02-15 01:04:35.000000', 'consum', 0.0221, 'lps'),
	(410883, 125, '2015-02-15 01:04:36.000000', 'consum', 0.0210, 'lps'),
	(410884, 125, '2015-02-15 01:04:37.000000', 'consum', 0.0214, 'lps'),
	(410885, 125, '2015-02-15 01:04:38.000000', 'consum', 0.0211, 'lps'),
	(410886, 125, '2015-02-15 01:04:39.000000', 'consum', 0.0222, 'lps'),
	(410887, 125, '2015-02-15 01:04:40.000000', 'consum', 0.0216, 'lps'),
	(410888, 125, '2015-02-15 01:04:41.000000', 'consum', 0.0222, 'lps'),
	(410889, 125, '2015-02-15 01:04:42.000000', 'consum', 0.0218, 'lps'),
	(410890, 125, '2015-02-15 01:04:43.000000', 'consum', 0.0213, 'lps'),
	(410891, 125, '2015-02-15 01:04:44.000000', 'consum', 0.0221, 'lps'),
	(410892, 125, '2015-02-15 01:04:45.000000', 'consum', 0.0221, 'lps'),
	(410893, 125, '2015-02-15 01:04:46.000000', 'consum', 0.0217, 'lps'),
	(410894, 125, '2015-02-15 01:04:47.000000', 'consum', 0.0212, 'lps'),
	(410895, 125, '2015-02-15 01:04:48.000000', 'consum', 0.0218, 'lps'),
	(410896, 125, '2015-02-15 01:04:49.000000', 'consum', 0.0226, 'lps'),
	(410897, 125, '2015-02-15 01:04:50.000000', 'consum', 0.0217, 'lps'),
	(410898, 125, '2015-02-15 01:04:51.000000', 'consum', 0.0215, 'lps'),
	(410899, 125, '2015-02-15 01:04:52.000000', 'consum', 0.0214, 'lps'),
	(410900, 125, '2015-02-15 01:04:53.000000', 'consum', 0.0216, 'lps'),
	(410901, 125, '2015-02-15 01:04:54.000000', 'consum', 0.0210, 'lps'),
	(410902, 125, '2015-02-15 01:04:55.000000', 'consum', 0.0225, 'lps'),
	(410903, 125, '2015-02-15 01:04:56.000000', 'consum', 0.0220, 'lps'),
	(410904, 125, '2015-02-15 01:04:57.000000', 'consum', 0.0215, 'lps'),
	(410905, 125, '2015-02-15 01:04:58.000000', 'consum', 0.0222, 'lps'),
	(410906, 125, '2015-02-15 01:04:59.000000', 'consum', 0.0220, 'lps'),
	(410907, 125, '2015-02-15 01:05:00.000000', 'consum', 0.0211, 'lps'),
	(410908, 125, '2015-02-15 01:05:01.000000', 'consum', 0.0217, 'lps'),
	(410909, 125, '2015-02-15 01:05:02.000000', 'consum', 0.0224, 'lps'),
	(410910, 125, '2015-02-15 01:05:03.000000', 'consum', 0.0212, 'lps'),
	(410911, 125, '2015-02-15 01:05:04.000000', 'consum', 0.0211, 'lps'),
	(410912, 125, '2015-02-15 01:05:05.000000', 'consum', 0.0212, 'lps'),
	(410913, 125, '2015-02-15 01:05:06.000000', 'consum', 0.0214, 'lps'),
	(410914, 125, '2015-02-15 01:05:07.000000', 'consum', 0.0210, 'lps'),
	(410915, 125, '2015-02-15 01:05:08.000000', 'consum', 0.0214, 'lps'),
	(410916, 125, '2015-02-15 01:05:09.000000', 'consum', 0.0216, 'lps'),
	(410917, 125, '2015-02-15 01:05:10.000000', 'consum', 0.0226, 'lps'),
	(410918, 125, '2015-02-15 01:05:11.000000', 'consum', 0.0223, 'lps'),
	(410919, 125, '2015-02-15 01:05:12.000000', 'consum', 0.0210, 'lps'),
	(410920, 125, '2015-02-15 01:05:13.000000', 'consum', 0.0224, 'lps'),
	(410921, 125, '2015-02-15 01:05:14.000000', 'consum', 0.0214, 'lps'),
	(410922, 125, '2015-02-15 01:05:15.000000', 'consum', 0.0219, 'lps'),
	(410923, 125, '2015-02-15 01:05:16.000000', 'consum', 0.0210, 'lps'),
	(410924, 125, '2015-02-15 01:05:17.000000', 'consum', 0.0218, 'lps'),
	(410925, 125, '2015-02-15 01:05:18.000000', 'consum', 0.0218, 'lps'),
	(410926, 125, '2015-02-15 01:05:19.000000', 'consum', 0.0210, 'lps'),
	(410927, 125, '2015-02-15 01:05:20.000000', 'consum', 0.0221, 'lps'),
	(410928, 125, '2015-02-15 01:05:21.000000', 'consum', 0.0211, 'lps'),
	(410929, 125, '2015-02-15 01:05:22.000000', 'consum', 0.0220, 'lps'),
	(410930, 125, '2015-02-15 01:05:23.000000', 'consum', 0.0223, 'lps'),
	(410931, 125, '2015-02-15 01:05:24.000000', 'consum', 0.0211, 'lps'),
	(410932, 125, '2015-02-15 01:05:25.000000', 'consum', 0.0212, 'lps'),
	(410933, 125, '2015-02-15 01:05:26.000000', 'consum', 0.0215, 'lps'),
	(410934, 125, '2015-02-15 01:05:27.000000', 'consum', 0.0215, 'lps'),
	(410935, 125, '2015-02-15 01:05:28.000000', 'consum', 0.0221, 'lps'),
	(410936, 125, '2015-02-15 01:05:29.000000', 'consum', 0.0216, 'lps'),
	(410937, 125, '2015-02-15 01:05:30.000000', 'consum', 0.0223, 'lps'),
	(410938, 125, '2015-02-15 01:05:31.000000', 'consum', 0.0222, 'lps'),
	(410939, 125, '2015-02-15 01:05:32.000000', 'consum', 0.0218, 'lps'),
	(410940, 125, '2015-02-15 01:05:33.000000', 'consum', 0.0211, 'lps'),
	(410941, 125, '2015-02-15 01:05:34.000000', 'consum', 0.0212, 'lps'),
	(410942, 125, '2015-02-15 01:05:35.000000', 'consum', 0.0215, 'lps'),
	(410943, 125, '2015-02-15 01:05:36.000000', 'consum', 0.0214, 'lps'),
	(410944, 125, '2015-02-15 01:05:37.000000', 'consum', 0.0215, 'lps'),
	(410945, 125, '2015-02-15 01:05:38.000000', 'consum', 0.0225, 'lps'),
	(410946, 125, '2015-02-15 01:05:39.000000', 'consum', 0.0219, 'lps'),
	(410947, 125, '2015-02-15 01:05:40.000000', 'consum', 0.0225, 'lps'),
	(410948, 125, '2015-02-15 01:05:41.000000', 'consum', 0.0226, 'lps'),
	(410949, 125, '2015-02-15 01:05:42.000000', 'consum', 0.0212, 'lps'),
	(410950, 125, '2015-02-15 01:05:43.000000', 'consum', 0.0224, 'lps'),
	(410951, 125, '2015-02-15 01:05:44.000000', 'consum', 0.0224, 'lps'),
	(410952, 125, '2015-02-15 01:05:45.000000', 'consum', 0.0220, 'lps'),
	(410953, 125, '2015-02-15 01:05:46.000000', 'consum', 0.0220, 'lps'),
	(410954, 125, '2015-02-15 01:05:47.000000', 'consum', 0.0213, 'lps'),
	(410955, 125, '2015-02-15 01:05:48.000000', 'consum', 0.0214, 'lps'),
	(410956, 125, '2015-02-15 01:05:49.000000', 'consum', 0.0220, 'lps'),
	(410957, 125, '2015-02-15 01:05:50.000000', 'consum', 0.0213, 'lps'),
	(410958, 125, '2015-02-15 01:05:51.000000', 'consum', 0.0215, 'lps'),
	(410959, 125, '2015-02-15 01:05:52.000000', 'consum', 0.0210, 'lps'),
	(410960, 125, '2015-02-15 01:05:53.000000', 'consum', 0.0210, 'lps'),
	(410961, 125, '2015-02-15 01:05:54.000000', 'consum', 0.0210, 'lps'),
	(410962, 125, '2015-02-15 01:05:55.000000', 'consum', 0.0210, 'lps'),
	(410963, 125, '2015-02-15 01:05:56.000000', 'consum', 0.0211, 'lps'),
	(410964, 125, '2015-02-15 01:05:57.000000', 'consum', 0.0216, 'lps'),
	(410965, 125, '2015-02-15 01:05:58.000000', 'consum', 0.0220, 'lps'),
	(410966, 125, '2015-02-15 01:05:59.000000', 'consum', 0.0211, 'lps'),
	(410967, 125, '2015-02-15 01:06:00.000000', 'consum', 0.0217, 'lps'),
	(410968, 125, '2015-02-15 01:06:01.000000', 'consum', 0.0210, 'lps'),
	(410969, 125, '2015-02-15 01:06:02.000000', 'consum', 0.0221, 'lps'),
	(410970, 125, '2015-02-15 01:06:03.000000', 'consum', 0.0218, 'lps'),
	(410971, 125, '2015-02-15 01:06:04.000000', 'consum', 0.0215, 'lps'),
	(410972, 125, '2015-02-15 01:06:05.000000', 'consum', 0.0214, 'lps'),
	(410973, 125, '2015-02-15 01:06:06.000000', 'consum', 0.0215, 'lps'),
	(410974, 125, '2015-02-15 01:06:07.000000', 'consum', 0.0223, 'lps'),
	(410975, 125, '2015-02-15 01:06:08.000000', 'consum', 0.0225, 'lps'),
	(410976, 125, '2015-02-15 01:06:09.000000', 'consum', 0.0214, 'lps'),
	(410977, 125, '2015-02-15 01:06:10.000000', 'consum', 0.0221, 'lps'),
	(410978, 125, '2015-02-15 01:06:11.000000', 'consum', 0.0218, 'lps'),
	(410979, 125, '2015-02-15 01:06:12.000000', 'consum', 0.0220, 'lps'),
	(410980, 125, '2015-02-15 01:06:13.000000', 'consum', 0.0216, 'lps'),
	(410981, 125, '2015-02-15 01:06:14.000000', 'consum', 0.0213, 'lps'),
	(410982, 125, '2015-02-15 01:06:15.000000', 'consum', 0.0224, 'lps'),
	(410983, 125, '2015-02-15 01:06:16.000000', 'consum', 0.0222, 'lps'),
	(410984, 125, '2015-02-15 01:06:17.000000', 'consum', 0.0226, 'lps'),
	(410985, 125, '2015-02-15 01:06:18.000000', 'consum', 0.0223, 'lps'),
	(410986, 125, '2015-02-15 01:06:19.000000', 'consum', 0.0211, 'lps'),
	(410987, 125, '2015-02-15 01:06:20.000000', 'consum', 0.0211, 'lps'),
	(410988, 125, '2015-02-15 01:06:21.000000', 'consum', 0.0210, 'lps'),
	(410989, 125, '2015-02-15 01:06:22.000000', 'consum', 0.0226, 'lps'),
	(410990, 125, '2015-02-15 01:06:23.000000', 'consum', 0.0223, 'lps'),
	(410991, 125, '2015-02-15 01:06:24.000000', 'consum', 0.0225, 'lps'),
	(410992, 125, '2015-02-15 01:06:25.000000', 'consum', 0.0215, 'lps'),
	(410993, 125, '2015-02-15 01:06:26.000000', 'consum', 0.0226, 'lps'),
	(410994, 125, '2015-02-15 01:06:27.000000', 'consum', 0.0221, 'lps'),
	(410995, 125, '2015-02-15 01:06:28.000000', 'consum', 0.0221, 'lps'),
	(410996, 125, '2015-02-15 01:06:29.000000', 'consum', 0.0212, 'lps'),
	(410997, 125, '2015-02-15 01:06:30.000000', 'consum', 0.0223, 'lps'),
	(410998, 125, '2015-02-15 01:06:31.000000', 'consum', 0.0220, 'lps'),
	(410999, 125, '2015-02-15 01:06:32.000000', 'consum', 0.0222, 'lps'),
	(411000, 125, '2015-02-15 01:06:33.000000', 'consum', 0.0224, 'lps'),
	(411001, 125, '2015-02-15 01:06:34.000000', 'consum', 0.0224, 'lps'),
	(411002, 125, '2015-02-15 01:06:35.000000', 'consum', 0.0225, 'lps'),
	(411003, 125, '2015-02-15 01:06:36.000000', 'consum', 0.0224, 'lps'),
	(411004, 125, '2015-02-15 01:06:37.000000', 'consum', 0.0221, 'lps'),
	(411005, 125, '2015-02-15 01:06:38.000000', 'consum', 0.0222, 'lps'),
	(411006, 125, '2015-02-15 01:06:39.000000', 'consum', 0.0222, 'lps'),
	(411007, 125, '2015-02-15 01:06:40.000000', 'consum', 0.0217, 'lps'),
	(411008, 125, '2015-02-15 01:06:41.000000', 'consum', 0.0225, 'lps'),
	(411009, 125, '2015-02-15 01:06:42.000000', 'consum', 0.0215, 'lps'),
	(411010, 125, '2015-02-15 01:06:43.000000', 'consum', 0.0224, 'lps'),
	(411011, 125, '2015-02-15 01:06:44.000000', 'consum', 0.0215, 'lps'),
	(411012, 125, '2015-02-15 01:06:45.000000', 'consum', 0.0226, 'lps'),
	(411013, 125, '2015-02-15 01:06:46.000000', 'consum', 0.0210, 'lps'),
	(411014, 125, '2015-02-15 01:06:47.000000', 'consum', 0.0211, 'lps'),
	(411015, 125, '2015-02-15 01:06:48.000000', 'consum', 0.0217, 'lps'),
	(411016, 125, '2015-02-15 01:06:49.000000', 'consum', 0.0224, 'lps'),
	(411017, 125, '2015-02-15 01:06:50.000000', 'consum', 0.0226, 'lps'),
	(411018, 125, '2015-02-15 01:06:51.000000', 'consum', 0.0213, 'lps'),
	(411019, 125, '2015-02-15 01:06:52.000000', 'consum', 0.0213, 'lps'),
	(411020, 125, '2015-02-15 01:06:53.000000', 'consum', 0.0214, 'lps'),
	(411021, 125, '2015-02-15 01:06:54.000000', 'consum', 0.0224, 'lps'),
	(411022, 125, '2015-02-15 01:06:55.000000', 'consum', 0.0217, 'lps'),
	(411023, 125, '2015-02-15 01:06:56.000000', 'consum', 0.0219, 'lps'),
	(411024, 125, '2015-02-15 01:06:57.000000', 'consum', 0.0219, 'lps'),
	(411025, 125, '2015-02-15 01:06:58.000000', 'consum', 0.0213, 'lps'),
	(411026, 125, '2015-02-15 01:06:59.000000', 'consum', 0.0215, 'lps'),
	(411027, 125, '2015-02-15 01:07:00.000000', 'consum', 0.0210, 'lps'),
	(411028, 125, '2015-02-15 01:07:01.000000', 'consum', 0.0213, 'lps'),
	(411029, 125, '2015-02-15 01:07:02.000000', 'consum', 0.0226, 'lps'),
	(411030, 125, '2015-02-15 01:07:03.000000', 'consum', 0.0212, 'lps'),
	(411031, 125, '2015-02-15 01:07:04.000000', 'consum', 0.0225, 'lps'),
	(411032, 125, '2015-02-15 01:07:05.000000', 'consum', 0.0211, 'lps'),
	(411033, 125, '2015-02-15 01:07:06.000000', 'consum', 0.0220, 'lps'),
	(411034, 125, '2015-02-15 01:07:07.000000', 'consum', 0.0225, 'lps'),
	(411035, 125, '2015-02-15 01:07:08.000000', 'consum', 0.0221, 'lps'),
	(411036, 125, '2015-02-15 01:07:09.000000', 'consum', 0.0219, 'lps'),
	(411037, 125, '2015-02-15 01:07:10.000000', 'consum', 0.0222, 'lps'),
	(411038, 125, '2015-02-15 01:07:11.000000', 'consum', 0.0211, 'lps'),
	(411039, 125, '2015-02-15 01:07:12.000000', 'consum', 0.0212, 'lps'),
	(411040, 125, '2015-02-15 01:07:13.000000', 'consum', 0.0220, 'lps'),
	(411041, 125, '2015-02-15 01:07:14.000000', 'consum', 0.0219, 'lps'),
	(411042, 125, '2015-02-15 01:07:15.000000', 'consum', 0.0224, 'lps'),
	(411043, 125, '2015-02-15 01:07:16.000000', 'consum', 0.0222, 'lps'),
	(411044, 125, '2015-02-15 01:07:17.000000', 'consum', 0.0226, 'lps'),
	(411045, 125, '2015-02-15 01:07:18.000000', 'consum', 0.0221, 'lps'),
	(411046, 125, '2015-02-15 01:07:19.000000', 'consum', 0.0217, 'lps'),
	(411047, 125, '2015-02-15 01:07:20.000000', 'consum', 0.0212, 'lps'),
	(411048, 125, '2015-02-15 01:07:21.000000', 'consum', 0.0219, 'lps'),
	(411049, 125, '2015-02-15 01:07:22.000000', 'consum', 0.0216, 'lps'),
	(411050, 125, '2015-02-15 01:07:23.000000', 'consum', 0.0211, 'lps'),
	(411051, 125, '2015-02-15 01:07:24.000000', 'consum', 0.0216, 'lps'),
	(411052, 125, '2015-02-15 01:07:25.000000', 'consum', 0.0222, 'lps'),
	(411053, 125, '2015-02-15 01:07:26.000000', 'consum', 0.0216, 'lps'),
	(411054, 125, '2015-02-15 01:07:27.000000', 'consum', 0.0224, 'lps'),
	(411055, 125, '2015-02-15 01:07:28.000000', 'consum', 0.0210, 'lps'),
	(411056, 125, '2015-02-15 01:07:29.000000', 'consum', 0.0221, 'lps'),
	(411057, 125, '2015-02-15 01:07:30.000000', 'consum', 0.0215, 'lps'),
	(411058, 125, '2015-02-15 01:07:31.000000', 'consum', 0.0220, 'lps'),
	(411059, 125, '2015-02-15 01:07:32.000000', 'consum', 0.0211, 'lps'),
	(411060, 125, '2015-02-15 01:07:33.000000', 'consum', 0.0218, 'lps'),
	(411061, 125, '2015-02-15 01:07:34.000000', 'consum', 0.0215, 'lps'),
	(411062, 125, '2015-02-15 01:07:35.000000', 'consum', 0.0210, 'lps'),
	(411063, 125, '2015-02-15 01:07:36.000000', 'consum', 0.0214, 'lps'),
	(411064, 125, '2015-02-15 01:07:37.000000', 'consum', 0.0211, 'lps'),
	(411065, 125, '2015-02-15 01:07:38.000000', 'consum', 0.0222, 'lps'),
	(411066, 125, '2015-02-15 01:07:39.000000', 'consum', 0.0217, 'lps'),
	(411067, 125, '2015-02-15 01:07:40.000000', 'consum', 0.0226, 'lps'),
	(411068, 125, '2015-02-15 01:07:41.000000', 'consum', 0.0217, 'lps'),
	(411069, 125, '2015-02-15 01:07:42.000000', 'consum', 0.0215, 'lps'),
	(411070, 125, '2015-02-15 01:07:43.000000', 'consum', 0.0217, 'lps'),
	(411071, 125, '2015-02-15 01:07:44.000000', 'consum', 0.0212, 'lps'),
	(411072, 125, '2015-02-15 01:07:45.000000', 'consum', 0.0218, 'lps'),
	(411073, 125, '2015-02-15 01:07:46.000000', 'consum', 0.0225, 'lps'),
	(411074, 125, '2015-02-15 01:07:47.000000', 'consum', 0.0213, 'lps'),
	(411075, 125, '2015-02-15 01:07:48.000000', 'consum', 0.0213, 'lps'),
	(411076, 125, '2015-02-15 01:07:49.000000', 'consum', 0.0218, 'lps'),
	(411077, 125, '2015-02-15 01:07:50.000000', 'consum', 0.0222, 'lps'),
	(411078, 125, '2015-02-15 01:07:51.000000', 'consum', 0.0215, 'lps'),
	(411079, 125, '2015-02-15 01:07:52.000000', 'consum', 0.0214, 'lps'),
	(411080, 125, '2015-02-15 01:07:53.000000', 'consum', 0.0218, 'lps'),
	(411081, 125, '2015-02-15 01:07:54.000000', 'consum', 0.0220, 'lps'),
	(411082, 125, '2015-02-15 01:07:55.000000', 'consum', 0.0219, 'lps'),
	(411083, 125, '2015-02-15 01:07:56.000000', 'consum', 0.0225, 'lps'),
	(411084, 125, '2015-02-15 01:07:57.000000', 'consum', 0.0225, 'lps'),
	(411085, 125, '2015-02-15 01:07:58.000000', 'consum', 0.0224, 'lps'),
	(411086, 125, '2015-02-15 01:07:59.000000', 'consum', 0.0218, 'lps'),
	(411087, 125, '2015-02-15 01:08:00.000000', 'consum', 0.0225, 'lps'),
	(411088, 125, '2015-02-15 01:08:01.000000', 'consum', 0.0211, 'lps'),
	(411089, 125, '2015-02-15 01:08:02.000000', 'consum', 0.0222, 'lps'),
	(411090, 125, '2015-02-15 01:08:03.000000', 'consum', 0.0215, 'lps'),
	(411091, 125, '2015-02-15 01:08:04.000000', 'consum', 0.0218, 'lps'),
	(411092, 125, '2015-02-15 01:08:05.000000', 'consum', 0.0218, 'lps'),
	(411093, 125, '2015-02-15 01:08:06.000000', 'consum', 0.0225, 'lps'),
	(411094, 125, '2015-02-15 01:08:07.000000', 'consum', 0.0210, 'lps'),
	(411095, 125, '2015-02-15 01:08:08.000000', 'consum', 0.0216, 'lps'),
	(411096, 125, '2015-02-15 01:08:09.000000', 'consum', 0.0224, 'lps'),
	(411097, 125, '2015-02-15 01:08:10.000000', 'consum', 0.0214, 'lps'),
	(411098, 125, '2015-02-15 01:08:11.000000', 'consum', 0.0221, 'lps'),
	(411099, 125, '2015-02-15 01:08:12.000000', 'consum', 0.0221, 'lps'),
	(411100, 125, '2015-02-15 01:08:13.000000', 'consum', 0.0213, 'lps'),
	(411101, 125, '2015-02-15 01:08:14.000000', 'consum', 0.0226, 'lps'),
	(411102, 125, '2015-02-15 01:08:15.000000', 'consum', 0.0213, 'lps'),
	(411103, 125, '2015-02-15 01:08:16.000000', 'consum', 0.0212, 'lps'),
	(411104, 125, '2015-02-15 01:08:17.000000', 'consum', 0.0210, 'lps'),
	(411105, 125, '2015-02-15 01:08:18.000000', 'consum', 0.0223, 'lps'),
	(411106, 125, '2015-02-15 01:08:19.000000', 'consum', 0.0224, 'lps'),
	(411107, 125, '2015-02-15 01:08:20.000000', 'consum', 0.0223, 'lps'),
	(411108, 125, '2015-02-15 01:08:21.000000', 'consum', 0.0219, 'lps'),
	(411109, 125, '2015-02-15 01:08:22.000000', 'consum', 0.0214, 'lps'),
	(411110, 125, '2015-02-15 01:08:23.000000', 'consum', 0.0222, 'lps'),
	(411111, 125, '2015-02-15 01:08:24.000000', 'consum', 0.0222, 'lps'),
	(411112, 125, '2015-02-15 01:08:25.000000', 'consum', 0.0221, 'lps'),
	(411113, 125, '2015-02-15 01:08:26.000000', 'consum', 0.0211, 'lps'),
	(411114, 125, '2015-02-15 01:08:27.000000', 'consum', 0.0217, 'lps'),
	(411115, 125, '2015-02-15 01:08:28.000000', 'consum', 0.0224, 'lps'),
	(411116, 125, '2015-02-15 01:08:29.000000', 'consum', 0.0210, 'lps'),
	(411117, 125, '2015-02-15 01:08:30.000000', 'consum', 0.0218, 'lps'),
	(411118, 125, '2015-02-15 01:08:31.000000', 'consum', 0.0218, 'lps'),
	(411119, 125, '2015-02-15 01:08:32.000000', 'consum', 0.0210, 'lps'),
	(411120, 125, '2015-02-15 01:08:33.000000', 'consum', 0.0218, 'lps'),
	(411121, 125, '2015-02-15 01:08:34.000000', 'consum', 0.0219, 'lps'),
	(411122, 125, '2015-02-15 01:08:35.000000', 'consum', 0.0213, 'lps'),
	(411123, 125, '2015-02-15 01:08:36.000000', 'consum', 0.0218, 'lps'),
	(411124, 125, '2015-02-15 01:08:37.000000', 'consum', 0.0222, 'lps'),
	(411125, 125, '2015-02-15 01:08:38.000000', 'consum', 0.0213, 'lps'),
	(411126, 125, '2015-02-15 01:08:39.000000', 'consum', 0.0222, 'lps'),
	(411127, 125, '2015-02-15 01:08:40.000000', 'consum', 0.0213, 'lps'),
	(411128, 125, '2015-02-15 01:08:41.000000', 'consum', 0.0222, 'lps'),
	(411129, 125, '2015-02-15 01:08:42.000000', 'consum', 0.0210, 'lps'),
	(411130, 125, '2015-02-15 01:08:43.000000', 'consum', 0.0211, 'lps'),
	(411131, 125, '2015-02-15 01:08:44.000000', 'consum', 0.0215, 'lps'),
	(411132, 125, '2015-02-15 01:08:45.000000', 'consum', 0.0216, 'lps'),
	(411133, 125, '2015-02-15 01:08:46.000000', 'consum', 0.0223, 'lps'),
	(411134, 125, '2015-02-15 01:08:47.000000', 'consum', 0.0225, 'lps'),
	(411135, 125, '2015-02-15 01:08:48.000000', 'consum', 0.0213, 'lps'),
	(411136, 125, '2015-02-15 01:08:49.000000', 'consum', 0.0212, 'lps'),
	(411137, 125, '2015-02-15 01:08:50.000000', 'consum', 0.0214, 'lps'),
	(411138, 125, '2015-02-15 01:08:51.000000', 'consum', 0.0224, 'lps'),
	(411139, 125, '2015-02-15 01:08:52.000000', 'consum', 0.0215, 'lps'),
	(411140, 125, '2015-02-15 01:08:53.000000', 'consum', 0.0213, 'lps'),
	(411141, 125, '2015-02-15 01:08:54.000000', 'consum', 0.0211, 'lps'),
	(411142, 125, '2015-02-15 01:08:55.000000', 'consum', 0.0223, 'lps'),
	(411143, 125, '2015-02-15 01:08:56.000000', 'consum', 0.0223, 'lps'),
	(411144, 125, '2015-02-15 01:08:57.000000', 'consum', 0.0219, 'lps'),
	(411145, 125, '2015-02-15 01:08:58.000000', 'consum', 0.0214, 'lps'),
	(411146, 125, '2015-02-15 01:08:59.000000', 'consum', 0.0223, 'lps'),
	(411147, 125, '2015-02-15 01:09:00.000000', 'consum', 0.0212, 'lps'),
	(411148, 125, '2015-02-15 01:09:01.000000', 'consum', 0.0217, 'lps'),
	(411149, 125, '2015-02-15 01:09:02.000000', 'consum', 0.0219, 'lps'),
	(411150, 125, '2015-02-15 01:09:03.000000', 'consum', 0.0221, 'lps'),
	(411151, 125, '2015-02-15 01:09:04.000000', 'consum', 0.0221, 'lps'),
	(411152, 125, '2015-02-15 01:09:05.000000', 'consum', 0.0215, 'lps'),
	(411153, 125, '2015-02-15 01:09:06.000000', 'consum', 0.0218, 'lps'),
	(411154, 125, '2015-02-15 01:09:07.000000', 'consum', 0.0221, 'lps'),
	(411155, 125, '2015-02-15 01:09:08.000000', 'consum', 0.0221, 'lps'),
	(411156, 125, '2015-02-15 01:09:09.000000', 'consum', 0.0219, 'lps'),
	(411157, 125, '2015-02-15 01:09:10.000000', 'consum', 0.0220, 'lps'),
	(411158, 125, '2015-02-15 01:09:11.000000', 'consum', 0.0216, 'lps'),
	(411159, 125, '2015-02-15 01:09:12.000000', 'consum', 0.0210, 'lps'),
	(411160, 125, '2015-02-15 01:09:13.000000', 'consum', 0.0211, 'lps'),
	(411161, 125, '2015-02-15 01:09:14.000000', 'consum', 0.0214, 'lps'),
	(411162, 125, '2015-02-15 01:09:15.000000', 'consum', 0.0211, 'lps'),
	(411163, 125, '2015-02-15 01:09:16.000000', 'consum', 0.0221, 'lps'),
	(411164, 125, '2015-02-15 01:09:17.000000', 'consum', 0.0210, 'lps'),
	(411165, 125, '2015-02-15 01:09:18.000000', 'consum', 0.0210, 'lps'),
	(411166, 125, '2015-02-15 01:09:19.000000', 'consum', 0.0214, 'lps'),
	(411167, 125, '2015-02-15 01:09:20.000000', 'consum', 0.0213, 'lps'),
	(411168, 125, '2015-02-15 01:09:21.000000', 'consum', 0.0215, 'lps'),
	(411169, 125, '2015-02-15 01:09:22.000000', 'consum', 0.0223, 'lps'),
	(411170, 125, '2015-02-15 01:09:23.000000', 'consum', 0.0211, 'lps'),
	(411171, 125, '2015-02-15 01:09:24.000000', 'consum', 0.0212, 'lps'),
	(411172, 125, '2015-02-15 01:09:25.000000', 'consum', 0.0215, 'lps'),
	(411173, 125, '2015-02-15 01:09:26.000000', 'consum', 0.0213, 'lps'),
	(411174, 125, '2015-02-15 01:09:27.000000', 'consum', 0.0226, 'lps'),
	(411175, 125, '2015-02-15 01:09:28.000000', 'consum', 0.0216, 'lps'),
	(411176, 125, '2015-02-15 01:09:29.000000', 'consum', 0.0225, 'lps'),
	(411177, 125, '2015-02-15 01:09:30.000000', 'consum', 0.0218, 'lps'),
	(411178, 125, '2015-02-15 01:09:31.000000', 'consum', 0.0222, 'lps'),
	(411179, 125, '2015-02-15 01:09:32.000000', 'consum', 0.0212, 'lps'),
	(411180, 125, '2015-02-15 01:09:33.000000', 'consum', 0.0218, 'lps'),
	(411181, 125, '2015-02-15 01:09:34.000000', 'consum', 0.0226, 'lps'),
	(411182, 125, '2015-02-15 01:09:35.000000', 'consum', 0.0219, 'lps'),
	(411183, 125, '2015-02-15 01:09:36.000000', 'consum', 0.0221, 'lps'),
	(411184, 125, '2015-02-15 01:09:37.000000', 'consum', 0.0223, 'lps'),
	(411185, 125, '2015-02-15 01:09:38.000000', 'consum', 0.0225, 'lps'),
	(411186, 125, '2015-02-15 01:09:39.000000', 'consum', 0.0213, 'lps'),
	(411187, 125, '2015-02-15 01:09:40.000000', 'consum', 0.0214, 'lps'),
	(411188, 125, '2015-02-15 01:09:41.000000', 'consum', 0.0220, 'lps'),
	(411189, 125, '2015-02-15 01:09:42.000000', 'consum', 0.0214, 'lps'),
	(411190, 125, '2015-02-15 01:09:43.000000', 'consum', 0.0219, 'lps'),
	(411191, 125, '2015-02-15 01:09:44.000000', 'consum', 0.0210, 'lps'),
	(411192, 125, '2015-02-15 01:09:45.000000', 'consum', 0.0217, 'lps'),
	(411193, 125, '2015-02-15 01:09:46.000000', 'consum', 0.0213, 'lps'),
	(411194, 125, '2015-02-15 01:09:47.000000', 'consum', 0.0222, 'lps'),
	(411195, 125, '2015-02-15 01:09:48.000000', 'consum', 0.0211, 'lps'),
	(411196, 125, '2015-02-15 01:09:49.000000', 'consum', 0.0213, 'lps'),
	(411197, 125, '2015-02-15 01:09:50.000000', 'consum', 0.0221, 'lps'),
	(411198, 125, '2015-02-15 01:09:51.000000', 'consum', 0.0225, 'lps'),
	(411199, 125, '2015-02-15 01:09:52.000000', 'consum', 0.0218, 'lps'),
	(411200, 125, '2015-02-15 01:09:53.000000', 'consum', 0.0222, 'lps'),
	(411201, 125, '2015-02-15 01:09:54.000000', 'consum', 0.0210, 'lps'),
	(411202, 125, '2015-02-15 01:09:55.000000', 'consum', 0.0212, 'lps'),
	(411203, 125, '2015-02-15 01:09:56.000000', 'consum', 0.0220, 'lps'),
	(411204, 125, '2015-02-15 01:09:57.000000', 'consum', 0.0221, 'lps'),
	(411205, 125, '2015-02-15 01:09:58.000000', 'consum', 0.0217, 'lps'),
	(411206, 125, '2015-02-15 01:09:59.000000', 'consum', 0.0212, 'lps'),
	(411207, 125, '2015-02-15 01:10:00.000000', 'consum', 0.0215, 'lps'),
	(411208, 125, '2015-02-15 01:10:01.000000', 'consum', 0.0215, 'lps'),
	(411209, 125, '2015-02-15 01:10:02.000000', 'consum', 0.0219, 'lps'),
	(411210, 125, '2015-02-15 01:10:03.000000', 'consum', 0.0224, 'lps'),
	(411211, 125, '2015-02-15 01:10:04.000000', 'consum', 0.0220, 'lps'),
	(411212, 125, '2015-02-15 01:10:05.000000', 'consum', 0.0216, 'lps'),
	(411213, 125, '2015-02-15 01:10:06.000000', 'consum', 0.0213, 'lps'),
	(411214, 125, '2015-02-15 01:10:07.000000', 'consum', 0.0223, 'lps'),
	(411215, 125, '2015-02-15 01:10:08.000000', 'consum', 0.0217, 'lps'),
	(411216, 125, '2015-02-15 01:10:09.000000', 'consum', 0.0222, 'lps'),
	(411217, 125, '2015-02-15 01:10:10.000000', 'consum', 0.0218, 'lps'),
	(411218, 125, '2015-02-15 01:10:11.000000', 'consum', 0.0213, 'lps'),
	(411219, 125, '2015-02-15 01:10:12.000000', 'consum', 0.0217, 'lps'),
	(411220, 125, '2015-02-15 01:10:13.000000', 'consum', 0.0219, 'lps'),
	(411221, 125, '2015-02-15 01:10:14.000000', 'consum', 0.0220, 'lps'),
	(411222, 125, '2015-02-15 01:10:15.000000', 'consum', 0.0216, 'lps'),
	(411223, 125, '2015-02-15 01:10:16.000000', 'consum', 0.0210, 'lps'),
	(411224, 125, '2015-02-15 01:10:17.000000', 'consum', 0.0211, 'lps'),
	(411225, 125, '2015-02-15 01:10:18.000000', 'consum', 0.0214, 'lps'),
	(411226, 125, '2015-02-15 01:10:19.000000', 'consum', 0.0210, 'lps'),
	(411227, 125, '2015-02-15 01:10:20.000000', 'consum', 0.0215, 'lps'),
	(411228, 125, '2015-02-15 01:10:21.000000', 'consum', 0.0217, 'lps'),
	(411229, 125, '2015-02-15 01:10:22.000000', 'consum', 0.0216, 'lps'),
	(411230, 125, '2015-02-15 01:10:23.000000', 'consum', 0.0219, 'lps'),
	(411231, 125, '2015-02-15 01:10:24.000000', 'consum', 0.0221, 'lps'),
	(411232, 125, '2015-02-15 01:10:25.000000', 'consum', 0.0221, 'lps'),
	(411233, 125, '2015-02-15 01:10:26.000000', 'consum', 0.0214, 'lps'),
	(411234, 125, '2015-02-15 01:10:27.000000', 'consum', 0.0216, 'lps'),
	(411235, 125, '2015-02-15 01:10:28.000000', 'consum', 0.0226, 'lps'),
	(411236, 125, '2015-02-15 01:10:29.000000', 'consum', 0.0224, 'lps'),
	(411237, 125, '2015-02-15 01:10:30.000000', 'consum', 0.0217, 'lps'),
	(411238, 125, '2015-02-15 01:10:31.000000', 'consum', 0.0218, 'lps'),
	(411239, 125, '2015-02-15 01:10:32.000000', 'consum', 0.0212, 'lps'),
	(411240, 125, '2015-02-15 01:10:33.000000', 'consum', 0.0215, 'lps'),
	(411241, 125, '2015-02-15 01:10:34.000000', 'consum', 0.0213, 'lps'),
	(411242, 125, '2015-02-15 01:10:35.000000', 'consum', 0.0210, 'lps'),
	(411243, 125, '2015-02-15 01:10:36.000000', 'consum', 0.0220, 'lps'),
	(411244, 125, '2015-02-15 01:10:37.000000', 'consum', 0.0226, 'lps'),
	(411245, 125, '2015-02-15 01:10:38.000000', 'consum', 0.0211, 'lps'),
	(411246, 125, '2015-02-15 01:10:39.000000', 'consum', 0.0217, 'lps'),
	(411247, 125, '2015-02-15 01:10:40.000000', 'consum', 0.0226, 'lps'),
	(411248, 125, '2015-02-15 01:10:41.000000', 'consum', 0.0220, 'lps'),
	(411249, 125, '2015-02-15 01:10:42.000000', 'consum', 0.0211, 'lps'),
	(411250, 125, '2015-02-15 01:10:43.000000', 'consum', 0.0219, 'lps'),
	(411251, 125, '2015-02-15 01:10:44.000000', 'consum', 0.0219, 'lps'),
	(411252, 125, '2015-02-15 01:10:45.000000', 'consum', 0.0226, 'lps'),
	(411253, 125, '2015-02-15 01:10:46.000000', 'consum', 0.0216, 'lps'),
	(411254, 125, '2015-02-15 01:10:47.000000', 'consum', 0.0226, 'lps'),
	(411255, 125, '2015-02-15 01:10:48.000000', 'consum', 0.0220, 'lps'),
	(411256, 125, '2015-02-15 01:10:49.000000', 'consum', 0.0212, 'lps'),
	(411257, 125, '2015-02-15 01:10:50.000000', 'consum', 0.0224, 'lps'),
	(411258, 125, '2015-02-15 01:10:51.000000', 'consum', 0.0224, 'lps'),
	(411259, 125, '2015-02-15 01:10:52.000000', 'consum', 0.0223, 'lps'),
	(411260, 125, '2015-02-15 01:10:53.000000', 'consum', 0.0217, 'lps'),
	(411261, 125, '2015-02-15 01:10:54.000000', 'consum', 0.0223, 'lps'),
	(411262, 125, '2015-02-15 01:10:55.000000', 'consum', 0.0218, 'lps'),
	(411263, 125, '2015-02-15 01:10:56.000000', 'consum', 0.0214, 'lps'),
	(411264, 125, '2015-02-15 01:10:57.000000', 'consum', 0.0225, 'lps'),
	(411265, 125, '2015-02-15 01:10:58.000000', 'consum', 0.0219, 'lps'),
	(411266, 125, '2015-02-15 01:10:59.000000', 'consum', 0.0212, 'lps'),
	(411267, 125, '2015-02-15 01:11:00.000000', 'consum', 0.0212, 'lps'),
	(411268, 125, '2015-02-15 01:11:01.000000', 'consum', 0.0213, 'lps'),
	(411269, 125, '2015-02-15 01:11:02.000000', 'consum', 0.0220, 'lps'),
	(411270, 125, '2015-02-15 01:11:03.000000', 'consum', 0.0217, 'lps'),
	(411271, 125, '2015-02-15 01:11:04.000000', 'consum', 0.0217, 'lps'),
	(411272, 125, '2015-02-15 01:11:05.000000', 'consum', 0.0222, 'lps'),
	(411273, 125, '2015-02-15 01:11:06.000000', 'consum', 0.0215, 'lps'),
	(411274, 125, '2015-02-15 01:11:07.000000', 'consum', 0.0219, 'lps'),
	(411275, 125, '2015-02-15 01:11:08.000000', 'consum', 0.0221, 'lps'),
	(411276, 125, '2015-02-15 01:11:09.000000', 'consum', 0.0223, 'lps'),
	(411277, 125, '2015-02-15 01:11:10.000000', 'consum', 0.0225, 'lps'),
	(411278, 125, '2015-02-15 01:11:11.000000', 'consum', 0.0211, 'lps'),
	(411279, 125, '2015-02-15 01:11:12.000000', 'consum', 0.0225, 'lps'),
	(411280, 125, '2015-02-15 01:11:13.000000', 'consum', 0.0211, 'lps'),
	(411281, 125, '2015-02-15 01:11:14.000000', 'consum', 0.0223, 'lps'),
	(411282, 125, '2015-02-15 01:11:15.000000', 'consum', 0.0220, 'lps'),
	(411283, 125, '2015-02-15 01:11:16.000000', 'consum', 0.0222, 'lps'),
	(411284, 125, '2015-02-15 01:11:17.000000', 'consum', 0.0224, 'lps'),
	(411285, 125, '2015-02-15 01:11:18.000000', 'consum', 0.0210, 'lps'),
	(411286, 125, '2015-02-15 01:11:19.000000', 'consum', 0.0219, 'lps'),
	(411287, 125, '2015-02-15 01:11:20.000000', 'consum', 0.0223, 'lps'),
	(411288, 125, '2015-02-15 01:11:21.000000', 'consum', 0.0214, 'lps'),
	(411289, 125, '2015-02-15 01:11:22.000000', 'consum', 0.0226, 'lps'),
	(411290, 125, '2015-02-15 01:11:23.000000', 'consum', 0.0210, 'lps'),
	(411291, 125, '2015-02-15 01:11:24.000000', 'consum', 0.0213, 'lps'),
	(411292, 125, '2015-02-15 01:11:25.000000', 'consum', 0.0210, 'lps'),
	(411293, 125, '2015-02-15 01:11:26.000000', 'consum', 0.0220, 'lps'),
	(411294, 125, '2015-02-15 01:11:27.000000', 'consum', 0.0224, 'lps'),
	(411295, 125, '2015-02-15 01:11:28.000000', 'consum', 0.0216, 'lps'),
	(411296, 125, '2015-02-15 01:11:29.000000', 'consum', 0.0216, 'lps'),
	(411297, 125, '2015-02-15 01:11:30.000000', 'consum', 0.0225, 'lps'),
	(411298, 125, '2015-02-15 01:11:31.000000', 'consum', 0.0214, 'lps'),
	(411299, 125, '2015-02-15 01:11:32.000000', 'consum', 0.0220, 'lps'),
	(411300, 125, '2015-02-15 01:11:33.000000', 'consum', 0.0214, 'lps'),
	(411301, 125, '2015-02-15 01:11:34.000000', 'consum', 0.0220, 'lps'),
	(411302, 125, '2015-02-15 01:11:35.000000', 'consum', 0.0213, 'lps'),
	(411303, 125, '2015-02-15 01:11:36.000000', 'consum', 0.0211, 'lps'),
	(411304, 125, '2015-02-15 01:11:37.000000', 'consum', 0.0225, 'lps'),
	(411305, 125, '2015-02-15 01:11:38.000000', 'consum', 0.0213, 'lps'),
	(411306, 125, '2015-02-15 01:11:39.000000', 'consum', 0.0216, 'lps'),
	(411307, 125, '2015-02-15 01:11:40.000000', 'consum', 0.0213, 'lps'),
	(411308, 125, '2015-02-15 01:11:41.000000', 'consum', 0.0225, 'lps'),
	(411309, 125, '2015-02-15 01:11:42.000000', 'consum', 0.0210, 'lps'),
	(411310, 125, '2015-02-15 01:11:43.000000', 'consum', 0.0217, 'lps'),
	(411311, 125, '2015-02-15 01:11:44.000000', 'consum', 0.0213, 'lps'),
	(411312, 125, '2015-02-15 01:11:45.000000', 'consum', 0.0218, 'lps'),
	(411313, 125, '2015-02-15 01:11:46.000000', 'consum', 0.0225, 'lps'),
	(411314, 125, '2015-02-15 01:11:47.000000', 'consum', 0.0213, 'lps'),
	(411315, 125, '2015-02-15 01:11:48.000000', 'consum', 0.0213, 'lps'),
	(411316, 125, '2015-02-15 01:11:49.000000', 'consum', 0.0216, 'lps'),
	(411317, 125, '2015-02-15 01:11:50.000000', 'consum', 0.0216, 'lps'),
	(411318, 125, '2015-02-15 01:11:51.000000', 'consum', 0.0221, 'lps'),
	(411319, 125, '2015-02-15 01:11:52.000000', 'consum', 0.0214, 'lps'),
	(411320, 125, '2015-02-15 01:11:53.000000', 'consum', 0.0215, 'lps'),
	(411321, 125, '2015-02-15 01:11:54.000000', 'consum', 0.0224, 'lps'),
	(411322, 125, '2015-02-15 01:11:55.000000', 'consum', 0.0214, 'lps'),
	(411323, 125, '2015-02-15 01:11:56.000000', 'consum', 0.0222, 'lps'),
	(411324, 125, '2015-02-15 01:11:57.000000', 'consum', 0.0226, 'lps'),
	(411325, 125, '2015-02-15 01:11:58.000000', 'consum', 0.0220, 'lps'),
	(411326, 125, '2015-02-15 01:11:59.000000', 'consum', 0.0211, 'lps'),
	(411327, 125, '2015-02-15 01:12:00.000000', 'consum', 0.0222, 'lps'),
	(411328, 125, '2015-02-15 01:12:01.000000', 'consum', 0.0216, 'lps'),
	(411329, 125, '2015-02-15 01:12:02.000000', 'consum', 0.0221, 'lps'),
	(411330, 125, '2015-02-15 01:12:03.000000', 'consum', 0.0213, 'lps'),
	(411331, 125, '2015-02-15 01:12:04.000000', 'consum', 0.0225, 'lps'),
	(411332, 125, '2015-02-15 01:12:05.000000', 'consum', 0.0226, 'lps'),
	(411333, 125, '2015-02-15 01:12:06.000000', 'consum', 0.0213, 'lps'),
	(411334, 125, '2015-02-15 01:12:07.000000', 'consum', 0.0213, 'lps'),
	(411335, 125, '2015-02-15 01:12:08.000000', 'consum', 0.0213, 'lps'),
	(411336, 125, '2015-02-15 01:12:09.000000', 'consum', 0.0218, 'lps'),
	(411337, 125, '2015-02-15 01:12:10.000000', 'consum', 0.0225, 'lps'),
	(411338, 125, '2015-02-15 01:12:11.000000', 'consum', 0.0225, 'lps'),
	(411339, 125, '2015-02-15 01:12:12.000000', 'consum', 0.0225, 'lps'),
	(411340, 125, '2015-02-15 01:12:13.000000', 'consum', 0.0223, 'lps'),
	(411341, 125, '2015-02-15 01:12:14.000000', 'consum', 0.0216, 'lps'),
	(411342, 125, '2015-02-15 01:12:15.000000', 'consum', 0.0216, 'lps'),
	(411343, 125, '2015-02-15 01:12:16.000000', 'consum', 0.0224, 'lps'),
	(411344, 125, '2015-02-15 01:12:17.000000', 'consum', 0.0211, 'lps'),
	(411345, 125, '2015-02-15 01:12:18.000000', 'consum', 0.0225, 'lps'),
	(411346, 125, '2015-02-15 01:12:19.000000', 'consum', 0.0214, 'lps'),
	(411347, 125, '2015-02-15 01:12:20.000000', 'consum', 0.0222, 'lps'),
	(411348, 125, '2015-02-15 01:12:21.000000', 'consum', 0.0221, 'lps'),
	(411349, 125, '2015-02-15 01:12:22.000000', 'consum', 0.0215, 'lps'),
	(411350, 125, '2015-02-15 01:12:23.000000', 'consum', 0.0219, 'lps'),
	(411351, 125, '2015-02-15 01:12:24.000000', 'consum', 0.0222, 'lps'),
	(411352, 125, '2015-02-15 01:12:25.000000', 'consum', 0.0226, 'lps'),
	(411353, 125, '2015-02-15 01:12:26.000000', 'consum', 0.0222, 'lps'),
	(411354, 125, '2015-02-15 01:12:27.000000', 'consum', 0.0224, 'lps'),
	(411355, 125, '2015-02-15 01:12:28.000000', 'consum', 0.0226, 'lps'),
	(411356, 125, '2015-02-15 01:12:29.000000', 'consum', 0.0215, 'lps'),
	(411357, 125, '2015-02-15 01:12:30.000000', 'consum', 0.0223, 'lps'),
	(411358, 125, '2015-02-15 01:12:31.000000', 'consum', 0.0224, 'lps'),
	(411359, 125, '2015-02-15 01:12:32.000000', 'consum', 0.0224, 'lps'),
	(411360, 125, '2015-02-15 01:12:33.000000', 'consum', 0.0222, 'lps'),
	(411361, 125, '2015-02-15 01:12:34.000000', 'consum', 0.0212, 'lps'),
	(411362, 125, '2015-02-15 01:12:35.000000', 'consum', 0.0219, 'lps'),
	(411363, 125, '2015-02-15 01:12:36.000000', 'consum', 0.0216, 'lps'),
	(411364, 125, '2015-02-15 01:12:37.000000', 'consum', 0.0213, 'lps'),
	(411365, 125, '2015-02-15 01:12:38.000000', 'consum', 0.0210, 'lps'),
	(411366, 125, '2015-02-15 01:12:39.000000', 'consum', 0.0215, 'lps'),
	(411367, 125, '2015-02-15 01:12:40.000000', 'consum', 0.0218, 'lps'),
	(411368, 125, '2015-02-15 01:12:41.000000', 'consum', 0.0220, 'lps'),
	(411369, 125, '2015-02-15 01:12:42.000000', 'consum', 0.0219, 'lps'),
	(411370, 125, '2015-02-15 01:12:43.000000', 'consum', 0.0225, 'lps'),
	(411371, 125, '2015-02-15 01:12:44.000000', 'consum', 0.0224, 'lps'),
	(411372, 125, '2015-02-15 01:12:45.000000', 'consum', 0.0221, 'lps'),
	(411373, 125, '2015-02-15 01:12:46.000000', 'consum', 0.0222, 'lps'),
	(411374, 125, '2015-02-15 01:12:47.000000', 'consum', 0.0219, 'lps'),
	(411375, 125, '2015-02-15 01:12:48.000000', 'consum', 0.0219, 'lps'),
	(411376, 125, '2015-02-15 01:12:49.000000', 'consum', 0.0213, 'lps'),
	(411377, 125, '2015-02-15 01:12:50.000000', 'consum', 0.0214, 'lps'),
	(411378, 125, '2015-02-15 01:12:51.000000', 'consum', 0.0221, 'lps'),
	(411379, 125, '2015-02-15 01:12:52.000000', 'consum', 0.0220, 'lps'),
	(411380, 125, '2015-02-15 01:12:53.000000', 'consum', 0.0212, 'lps'),
	(411381, 125, '2015-02-15 01:12:54.000000', 'consum', 0.0225, 'lps'),
	(411382, 125, '2015-02-15 01:12:55.000000', 'consum', 0.0226, 'lps'),
	(411383, 125, '2015-02-15 01:12:56.000000', 'consum', 0.0214, 'lps'),
	(411384, 125, '2015-02-15 01:12:57.000000', 'consum', 0.0214, 'lps'),
	(411385, 125, '2015-02-15 01:12:58.000000', 'consum', 0.0218, 'lps'),
	(411386, 125, '2015-02-15 01:12:59.000000', 'consum', 0.0223, 'lps'),
	(411387, 125, '2015-02-15 01:13:00.000000', 'consum', 0.0215, 'lps'),
	(411388, 125, '2015-02-15 01:13:01.000000', 'consum', 0.0216, 'lps'),
	(411389, 125, '2015-02-15 01:13:02.000000', 'consum', 0.0210, 'lps'),
	(411390, 125, '2015-02-15 01:13:03.000000', 'consum', 0.0223, 'lps'),
	(411391, 125, '2015-02-15 01:13:04.000000', 'consum', 0.0211, 'lps'),
	(411392, 125, '2015-02-15 01:13:05.000000', 'consum', 0.0224, 'lps'),
	(411393, 125, '2015-02-15 01:13:06.000000', 'consum', 0.0212, 'lps'),
	(411394, 125, '2015-02-15 01:13:07.000000', 'consum', 0.0213, 'lps'),
	(411395, 125, '2015-02-15 01:13:08.000000', 'consum', 0.0220, 'lps'),
	(411396, 125, '2015-02-15 01:13:09.000000', 'consum', 0.0217, 'lps'),
	(411397, 125, '2015-02-15 01:13:10.000000', 'consum', 0.0217, 'lps'),
	(411398, 125, '2015-02-15 01:13:11.000000', 'consum', 0.0224, 'lps'),
	(411399, 125, '2015-02-15 01:13:12.000000', 'consum', 0.0224, 'lps'),
	(411400, 125, '2015-02-15 01:13:13.000000', 'consum', 0.0221, 'lps'),
	(411401, 125, '2015-02-15 01:13:14.000000', 'consum', 0.0225, 'lps'),
	(411402, 125, '2015-02-15 01:13:15.000000', 'consum', 0.0218, 'lps'),
	(411403, 125, '2015-02-15 01:13:16.000000', 'consum', 0.0224, 'lps'),
	(411404, 125, '2015-02-15 01:13:17.000000', 'consum', 0.0221, 'lps'),
	(411405, 125, '2015-02-15 01:13:18.000000', 'consum', 0.0223, 'lps'),
	(411406, 125, '2015-02-15 01:13:19.000000', 'consum', 0.0226, 'lps'),
	(411407, 125, '2015-02-15 01:13:20.000000', 'consum', 0.0219, 'lps'),
	(411408, 125, '2015-02-15 01:13:21.000000', 'consum', 0.0224, 'lps'),
	(411409, 125, '2015-02-15 01:13:22.000000', 'consum', 0.0219, 'lps'),
	(411410, 125, '2015-02-15 01:13:23.000000', 'consum', 0.0213, 'lps'),
	(411411, 125, '2015-02-15 01:13:24.000000', 'consum', 0.0218, 'lps'),
	(411412, 125, '2015-02-15 01:13:25.000000', 'consum', 0.0222, 'lps'),
	(411413, 125, '2015-02-15 01:13:26.000000', 'consum', 0.0212, 'lps'),
	(411414, 125, '2015-02-15 01:13:27.000000', 'consum', 0.0218, 'lps'),
	(411415, 125, '2015-02-15 01:13:28.000000', 'consum', 0.0212, 'lps'),
	(411416, 125, '2015-02-15 01:13:29.000000', 'consum', 0.0212, 'lps'),
	(411417, 125, '2015-02-15 01:13:30.000000', 'consum', 0.0213, 'lps'),
	(411418, 125, '2015-02-15 01:13:31.000000', 'consum', 0.0223, 'lps'),
	(411419, 125, '2015-02-15 01:13:32.000000', 'consum', 0.0214, 'lps'),
	(411420, 125, '2015-02-15 01:13:33.000000', 'consum', 0.0224, 'lps'),
	(411421, 125, '2015-02-15 01:13:34.000000', 'consum', 0.0218, 'lps'),
	(411422, 125, '2015-02-15 01:13:35.000000', 'consum', 0.0210, 'lps'),
	(411423, 125, '2015-02-15 01:13:36.000000', 'consum', 0.0220, 'lps'),
	(411424, 125, '2015-02-15 01:13:37.000000', 'consum', 0.0211, 'lps'),
	(411425, 125, '2015-02-15 01:13:38.000000', 'consum', 0.0220, 'lps'),
	(411426, 125, '2015-02-15 01:13:39.000000', 'consum', 0.0223, 'lps'),
	(411427, 125, '2015-02-15 01:13:40.000000', 'consum', 0.0226, 'lps'),
	(411428, 125, '2015-02-15 01:13:41.000000', 'consum', 0.0220, 'lps'),
	(411429, 125, '2015-02-15 01:13:42.000000', 'consum', 0.0212, 'lps'),
	(411430, 125, '2015-02-15 01:13:43.000000', 'consum', 0.0223, 'lps'),
	(411431, 125, '2015-02-15 01:13:44.000000', 'consum', 0.0217, 'lps'),
	(411432, 125, '2015-02-15 01:13:45.000000', 'consum', 0.0226, 'lps'),
	(411433, 125, '2015-02-15 01:13:46.000000', 'consum', 0.0220, 'lps'),
	(411434, 125, '2015-02-15 01:13:47.000000', 'consum', 0.0226, 'lps'),
	(411435, 125, '2015-02-15 01:13:48.000000', 'consum', 0.0211, 'lps'),
	(411436, 125, '2015-02-15 01:13:49.000000', 'consum', 0.0218, 'lps'),
	(411437, 125, '2015-02-15 01:13:50.000000', 'consum', 0.0212, 'lps'),
	(411438, 125, '2015-02-15 01:13:51.000000', 'consum', 0.0217, 'lps'),
	(411439, 125, '2015-02-15 01:13:52.000000', 'consum', 0.0220, 'lps'),
	(411440, 125, '2015-02-15 01:13:53.000000', 'consum', 0.0222, 'lps'),
	(411441, 125, '2015-02-15 01:13:54.000000', 'consum', 0.0225, 'lps'),
	(411442, 125, '2015-02-15 01:13:55.000000', 'consum', 0.0217, 'lps'),
	(411443, 125, '2015-02-15 01:13:56.000000', 'consum', 0.0216, 'lps'),
	(411444, 125, '2015-02-15 01:13:57.000000', 'consum', 0.0221, 'lps'),
	(411445, 125, '2015-02-15 01:13:58.000000', 'consum', 0.0213, 'lps'),
	(411446, 125, '2015-02-15 01:13:59.000000', 'consum', 0.0225, 'lps'),
	(411447, 125, '2015-02-15 01:14:00.000000', 'consum', 0.0226, 'lps'),
	(411448, 125, '2015-02-15 01:14:01.000000', 'consum', 0.0212, 'lps'),
	(411449, 125, '2015-02-15 01:14:02.000000', 'consum', 0.0221, 'lps'),
	(411450, 125, '2015-02-15 01:14:03.000000', 'consum', 0.0211, 'lps'),
	(411451, 125, '2015-02-15 01:14:04.000000', 'consum', 0.0216, 'lps'),
	(411452, 125, '2015-02-15 01:14:05.000000', 'consum', 0.0219, 'lps'),
	(411453, 125, '2015-02-15 01:14:06.000000', 'consum', 0.0220, 'lps'),
	(411454, 125, '2015-02-15 01:14:07.000000', 'consum', 0.0219, 'lps'),
	(411455, 125, '2015-02-15 01:14:08.000000', 'consum', 0.0222, 'lps'),
	(411456, 125, '2015-02-15 01:14:09.000000', 'consum', 0.0213, 'lps'),
	(411457, 125, '2015-02-15 01:14:10.000000', 'consum', 0.0224, 'lps'),
	(411458, 125, '2015-02-15 01:14:11.000000', 'consum', 0.0218, 'lps'),
	(411459, 125, '2015-02-15 01:14:12.000000', 'consum', 0.0226, 'lps'),
	(411460, 125, '2015-02-15 01:14:13.000000', 'consum', 0.0216, 'lps'),
	(411461, 125, '2015-02-15 01:14:14.000000', 'consum', 0.0226, 'lps'),
	(411462, 125, '2015-02-15 01:14:15.000000', 'consum', 0.0223, 'lps'),
	(411463, 125, '2015-02-15 01:14:16.000000', 'consum', 0.0225, 'lps'),
	(411464, 125, '2015-02-15 01:14:17.000000', 'consum', 0.0213, 'lps'),
	(411465, 125, '2015-02-15 01:14:18.000000', 'consum', 0.0214, 'lps'),
	(411466, 125, '2015-02-15 01:14:19.000000', 'consum', 0.0220, 'lps'),
	(411467, 125, '2015-02-15 01:14:20.000000', 'consum', 0.0216, 'lps'),
	(411468, 125, '2015-02-15 01:14:21.000000', 'consum', 0.0212, 'lps'),
	(411469, 125, '2015-02-15 01:14:22.000000', 'consum', 0.0217, 'lps'),
	(411470, 125, '2015-02-15 01:14:23.000000', 'consum', 0.0222, 'lps'),
	(411471, 125, '2015-02-15 01:14:24.000000', 'consum', 0.0215, 'lps'),
	(411472, 125, '2015-02-15 01:14:25.000000', 'consum', 0.0217, 'lps'),
	(411473, 125, '2015-02-15 01:14:26.000000', 'consum', 0.0213, 'lps'),
	(411474, 125, '2015-02-15 01:14:27.000000', 'consum', 0.0221, 'lps'),
	(411475, 125, '2015-02-15 01:14:28.000000', 'consum', 0.0222, 'lps'),
	(411476, 125, '2015-02-15 01:14:29.000000', 'consum', 0.0221, 'lps'),
	(411477, 125, '2015-02-15 01:14:30.000000', 'consum', 0.0213, 'lps'),
	(411478, 125, '2015-02-15 01:14:31.000000', 'consum', 0.0224, 'lps'),
	(411479, 125, '2015-02-15 01:14:32.000000', 'consum', 0.0224, 'lps'),
	(411480, 125, '2015-02-15 01:14:33.000000', 'consum', 0.0218, 'lps'),
	(411481, 125, '2015-02-15 01:14:34.000000', 'consum', 0.0211, 'lps'),
	(411482, 125, '2015-02-15 01:14:35.000000', 'consum', 0.0223, 'lps'),
	(411483, 125, '2015-02-15 01:14:36.000000', 'consum', 0.0222, 'lps'),
	(411484, 125, '2015-02-15 01:14:37.000000', 'consum', 0.0215, 'lps'),
	(411485, 125, '2015-02-15 01:14:38.000000', 'consum', 0.0215, 'lps'),
	(411486, 125, '2015-02-15 01:14:39.000000', 'consum', 0.0221, 'lps'),
	(411487, 125, '2015-02-15 01:14:40.000000', 'consum', 0.0217, 'lps'),
	(411488, 125, '2015-02-15 01:14:41.000000', 'consum', 0.0213, 'lps'),
	(411489, 125, '2015-02-15 01:14:42.000000', 'consum', 0.0220, 'lps'),
	(411490, 125, '2015-02-15 01:14:43.000000', 'consum', 0.0217, 'lps'),
	(411491, 125, '2015-02-15 01:14:44.000000', 'consum', 0.0217, 'lps'),
	(411492, 125, '2015-02-15 01:14:45.000000', 'consum', 0.0223, 'lps'),
	(411493, 125, '2015-02-15 01:14:46.000000', 'consum', 0.0222, 'lps'),
	(411494, 125, '2015-02-15 01:14:47.000000', 'consum', 0.0214, 'lps'),
	(411495, 125, '2015-02-15 01:14:48.000000', 'consum', 0.0213, 'lps'),
	(411496, 125, '2015-02-15 01:14:49.000000', 'consum', 0.0212, 'lps'),
	(411497, 125, '2015-02-15 01:14:50.000000', 'consum', 0.0211, 'lps'),
	(411498, 125, '2015-02-15 01:14:51.000000', 'consum', 0.0211, 'lps'),
	(411499, 125, '2015-02-15 01:14:52.000000', 'consum', 0.0211, 'lps'),
	(411500, 125, '2015-02-15 01:14:53.000000', 'consum', 0.0211, 'lps'),
	(411501, 125, '2015-02-15 01:14:54.000000', 'consum', 0.0216, 'lps'),
	(411502, 125, '2015-02-15 01:14:55.000000', 'consum', 0.0219, 'lps'),
	(411503, 125, '2015-02-15 01:14:56.000000', 'consum', 0.0219, 'lps'),
	(411504, 125, '2015-02-15 01:14:57.000000', 'consum', 0.0214, 'lps'),
	(411505, 125, '2015-02-15 01:14:58.000000', 'consum', 0.0221, 'lps'),
	(411506, 125, '2015-02-15 01:14:59.000000', 'consum', 0.0220, 'lps'),
	(411507, 125, '2015-02-15 01:15:00.000000', 'consum', 0.0226, 'lps'),
	(411508, 125, '2015-02-15 01:15:01.000000', 'consum', 0.0226, 'lps'),
	(411509, 125, '2015-02-15 01:15:02.000000', 'consum', 0.0225, 'lps'),
	(411510, 125, '2015-02-15 01:15:03.000000', 'consum', 0.0220, 'lps'),
	(411511, 125, '2015-02-15 01:15:04.000000', 'consum', 0.0215, 'lps'),
	(411512, 125, '2015-02-15 01:15:05.000000', 'consum', 0.0223, 'lps'),
	(411513, 125, '2015-02-15 01:15:06.000000', 'consum', 0.0211, 'lps'),
	(411514, 125, '2015-02-15 01:15:07.000000', 'consum', 0.0210, 'lps'),
	(411515, 125, '2015-02-15 01:15:08.000000', 'consum', 0.0224, 'lps'),
	(411516, 125, '2015-02-15 01:15:09.000000', 'consum', 0.0211, 'lps'),
	(411517, 125, '2015-02-15 01:15:10.000000', 'consum', 0.0211, 'lps'),
	(411518, 125, '2015-02-15 01:15:11.000000', 'consum', 0.0226, 'lps'),
	(411519, 125, '2015-02-15 01:15:12.000000', 'consum', 0.0220, 'lps'),
	(411520, 125, '2015-02-15 01:15:13.000000', 'consum', 0.0212, 'lps'),
	(411521, 125, '2015-02-15 01:15:14.000000', 'consum', 0.0224, 'lps'),
	(411522, 125, '2015-02-15 01:15:15.000000', 'consum', 0.0225, 'lps'),
	(411523, 125, '2015-02-15 01:15:16.000000', 'consum', 0.0210, 'lps'),
	(411524, 125, '2015-02-15 01:15:17.000000', 'consum', 0.0215, 'lps'),
	(411525, 125, '2015-02-15 01:15:18.000000', 'consum', 0.0219, 'lps'),
	(411526, 125, '2015-02-15 01:15:19.000000', 'consum', 0.0223, 'lps'),
	(411527, 125, '2015-02-15 01:15:20.000000', 'consum', 0.0216, 'lps'),
	(411528, 125, '2015-02-15 01:15:21.000000', 'consum', 0.0219, 'lps'),
	(411529, 125, '2015-02-15 01:15:22.000000', 'consum', 0.0218, 'lps'),
	(411530, 125, '2015-02-15 01:15:23.000000', 'consum', 0.0224, 'lps'),
	(411531, 125, '2015-02-15 01:15:24.000000', 'consum', 0.0224, 'lps'),
	(411532, 125, '2015-02-15 01:15:25.000000', 'consum', 0.0220, 'lps'),
	(411533, 125, '2015-02-15 01:15:26.000000', 'consum', 0.0217, 'lps'),
	(411534, 125, '2015-02-15 01:15:27.000000', 'consum', 0.0218, 'lps'),
	(411535, 125, '2015-02-15 01:15:28.000000', 'consum', 0.0210, 'lps'),
	(411536, 125, '2015-02-15 01:15:29.000000', 'consum', 0.0221, 'lps'),
	(411537, 125, '2015-02-15 01:15:30.000000', 'consum', 0.0214, 'lps'),
	(411538, 125, '2015-02-15 01:15:31.000000', 'consum', 0.0214, 'lps'),
	(411539, 125, '2015-02-15 01:15:32.000000', 'consum', 0.0218, 'lps'),
	(411540, 125, '2015-02-15 01:15:33.000000', 'consum', 0.0224, 'lps'),
	(411541, 125, '2015-02-15 01:15:34.000000', 'consum', 0.0222, 'lps'),
	(411542, 125, '2015-02-15 01:15:35.000000', 'consum', 0.0210, 'lps'),
	(411543, 125, '2015-02-15 01:15:36.000000', 'consum', 0.0210, 'lps'),
	(411544, 125, '2015-02-15 01:15:37.000000', 'consum', 0.0226, 'lps'),
	(411545, 125, '2015-02-15 01:15:38.000000', 'consum', 0.0225, 'lps'),
	(411546, 125, '2015-02-15 01:15:39.000000', 'consum', 0.0217, 'lps'),
	(411547, 125, '2015-02-15 01:15:40.000000', 'consum', 0.0220, 'lps'),
	(411548, 125, '2015-02-15 01:15:41.000000', 'consum', 0.0220, 'lps'),
	(411549, 125, '2015-02-15 01:15:42.000000', 'consum', 0.0215, 'lps'),
	(411550, 125, '2015-02-15 01:15:43.000000', 'consum', 0.0224, 'lps'),
	(411551, 125, '2015-02-15 01:15:44.000000', 'consum', 0.0212, 'lps'),
	(411552, 125, '2015-02-15 01:15:45.000000', 'consum', 0.0215, 'lps'),
	(411553, 125, '2015-02-15 01:15:46.000000', 'consum', 0.0211, 'lps'),
	(411554, 125, '2015-02-15 01:15:47.000000', 'consum', 0.0217, 'lps'),
	(411555, 125, '2015-02-15 01:15:48.000000', 'consum', 0.0224, 'lps'),
	(411556, 125, '2015-02-15 01:15:49.000000', 'consum', 0.0211, 'lps'),
	(411557, 125, '2015-02-15 01:15:50.000000', 'consum', 0.0224, 'lps'),
	(411558, 125, '2015-02-15 01:15:51.000000', 'consum', 0.0211, 'lps'),
	(411559, 125, '2015-02-15 01:15:52.000000', 'consum', 0.0224, 'lps'),
	(411560, 125, '2015-02-15 01:15:53.000000', 'consum', 0.0211, 'lps'),
	(411561, 125, '2015-02-15 01:15:54.000000', 'consum', 0.0222, 'lps'),
	(411562, 125, '2015-02-15 01:15:55.000000', 'consum', 0.0218, 'lps'),
	(411563, 125, '2015-02-15 01:15:56.000000', 'consum', 0.0214, 'lps'),
	(411564, 125, '2015-02-15 01:15:57.000000', 'consum', 0.0225, 'lps'),
	(411565, 125, '2015-02-15 01:15:58.000000', 'consum', 0.0220, 'lps'),
	(411566, 125, '2015-02-15 01:15:59.000000', 'consum', 0.0215, 'lps'),
	(411567, 125, '2015-02-15 01:16:00.000000', 'consum', 0.0226, 'lps'),
	(411568, 125, '2015-02-15 01:16:01.000000', 'consum', 0.0221, 'lps'),
	(411569, 125, '2015-02-15 01:16:02.000000', 'consum', 0.0220, 'lps'),
	(411570, 125, '2015-02-15 01:16:03.000000', 'consum', 0.0225, 'lps'),
	(411571, 125, '2015-02-15 01:16:04.000000', 'consum', 0.0224, 'lps'),
	(411572, 125, '2015-02-15 01:16:05.000000', 'consum', 0.0216, 'lps'),
	(411573, 125, '2015-02-15 01:16:06.000000', 'consum', 0.0214, 'lps'),
	(411574, 125, '2015-02-15 01:16:07.000000', 'consum', 0.0216, 'lps'),
	(411575, 125, '2015-02-15 01:16:08.000000', 'consum', 0.0212, 'lps'),
	(411576, 125, '2015-02-15 01:16:09.000000', 'consum', 0.0217, 'lps'),
	(411577, 125, '2015-02-15 01:16:10.000000', 'consum', 0.0225, 'lps'),
	(411578, 125, '2015-02-15 01:16:11.000000', 'consum', 0.0214, 'lps'),
	(411579, 125, '2015-02-15 01:16:12.000000', 'consum', 0.0219, 'lps'),
	(411580, 125, '2015-02-15 01:16:13.000000', 'consum', 0.0225, 'lps'),
	(411581, 125, '2015-02-15 01:16:14.000000', 'consum', 0.0210, 'lps'),
	(411582, 125, '2015-02-15 01:16:15.000000', 'consum', 0.0214, 'lps'),
	(411583, 125, '2015-02-15 01:16:16.000000', 'consum', 0.0216, 'lps'),
	(411584, 125, '2015-02-15 01:16:17.000000', 'consum', 0.0225, 'lps'),
	(411585, 125, '2015-02-15 01:16:18.000000', 'consum', 0.0220, 'lps'),
	(411586, 125, '2015-02-15 01:16:19.000000', 'consum', 0.0213, 'lps'),
	(411587, 125, '2015-02-15 01:16:20.000000', 'consum', 0.0215, 'lps'),
	(411588, 125, '2015-02-15 01:16:21.000000', 'consum', 0.0210, 'lps'),
	(411589, 125, '2015-02-15 01:16:22.000000', 'consum', 0.0212, 'lps'),
	(411590, 125, '2015-02-15 01:16:23.000000', 'consum', 0.0220, 'lps'),
	(411591, 125, '2015-02-15 01:16:24.000000', 'consum', 0.0220, 'lps'),
	(411592, 125, '2015-02-15 01:16:25.000000', 'consum', 0.0212, 'lps'),
	(411593, 125, '2015-02-15 01:16:26.000000', 'consum', 0.0210, 'lps'),
	(411594, 125, '2015-02-15 01:16:27.000000', 'consum', 0.0222, 'lps'),
	(411595, 125, '2015-02-15 01:16:28.000000', 'consum', 0.0217, 'lps'),
	(411596, 125, '2015-02-15 01:16:29.000000', 'consum', 0.0226, 'lps'),
	(411597, 125, '2015-02-15 01:16:30.000000', 'consum', 0.0219, 'lps'),
	(411598, 125, '2015-02-15 01:16:31.000000', 'consum', 0.0225, 'lps'),
	(411599, 125, '2015-02-15 01:16:32.000000', 'consum', 0.0223, 'lps'),
	(411600, 125, '2015-02-15 01:16:33.000000', 'consum', 0.0214, 'lps'),
	(411601, 125, '2015-02-15 01:16:34.000000', 'consum', 0.0210, 'lps'),
	(411602, 125, '2015-02-15 01:16:35.000000', 'consum', 0.0213, 'lps'),
	(411603, 125, '2015-02-15 01:16:36.000000', 'consum', 0.0226, 'lps'),
	(411604, 125, '2015-02-15 01:16:37.000000', 'consum', 0.0213, 'lps'),
	(411605, 125, '2015-02-15 01:16:38.000000', 'consum', 0.0214, 'lps'),
	(411606, 125, '2015-02-15 01:16:39.000000', 'consum', 0.0220, 'lps'),
	(411607, 125, '2015-02-15 01:16:40.000000', 'consum', 0.0214, 'lps'),
	(411608, 125, '2015-02-15 01:16:41.000000', 'consum', 0.0216, 'lps'),
	(411609, 125, '2015-02-15 01:16:42.000000', 'consum', 0.0213, 'lps'),
	(411610, 125, '2015-02-15 01:16:43.000000', 'consum', 0.0226, 'lps'),
	(411611, 125, '2015-02-15 01:16:44.000000', 'consum', 0.0212, 'lps'),
	(411612, 125, '2015-02-15 01:16:45.000000', 'consum', 0.0224, 'lps'),
	(411613, 125, '2015-02-15 01:16:46.000000', 'consum', 0.0221, 'lps'),
	(411614, 125, '2015-02-15 01:16:47.000000', 'consum', 0.0210, 'lps'),
	(411615, 125, '2015-02-15 01:16:48.000000', 'consum', 0.0225, 'lps'),
	(411616, 125, '2015-02-15 01:16:49.000000', 'consum', 0.0221, 'lps'),
	(411617, 125, '2015-02-15 01:16:50.000000', 'consum', 0.0219, 'lps'),
	(411618, 125, '2015-02-15 01:16:51.000000', 'consum', 0.0222, 'lps'),
	(411619, 125, '2015-02-15 01:16:52.000000', 'consum', 0.0226, 'lps'),
	(411620, 125, '2015-02-15 01:16:53.000000', 'consum', 0.0219, 'lps'),
	(411621, 125, '2015-02-15 01:16:54.000000', 'consum', 0.0210, 'lps'),
	(411622, 125, '2015-02-15 01:16:55.000000', 'consum', 0.0215, 'lps'),
	(411623, 125, '2015-02-15 01:16:56.000000', 'consum', 0.0221, 'lps'),
	(411624, 125, '2015-02-15 01:16:57.000000', 'consum', 0.0215, 'lps'),
	(411625, 125, '2015-02-15 01:16:58.000000', 'consum', 0.0218, 'lps'),
	(411626, 125, '2015-02-15 01:16:59.000000', 'consum', 0.0219, 'lps'),
	(411627, 125, '2015-02-15 01:17:00.000000', 'consum', 0.0215, 'lps'),
	(411628, 125, '2015-02-15 01:17:01.000000', 'consum', 0.0226, 'lps'),
	(411629, 125, '2015-02-15 01:17:02.000000', 'consum', 0.0224, 'lps'),
	(411630, 125, '2015-02-15 01:17:03.000000', 'consum', 0.0216, 'lps'),
	(411631, 125, '2015-02-15 01:17:04.000000', 'consum', 0.0216, 'lps'),
	(411632, 125, '2015-02-15 01:17:05.000000', 'consum', 0.0220, 'lps'),
	(411633, 125, '2015-02-15 01:17:06.000000', 'consum', 0.0211, 'lps'),
	(411634, 125, '2015-02-15 01:17:07.000000', 'consum', 0.0218, 'lps'),
	(411635, 125, '2015-02-15 01:17:08.000000', 'consum', 0.0212, 'lps'),
	(411636, 125, '2015-02-15 01:17:09.000000', 'consum', 0.0215, 'lps'),
	(411637, 125, '2015-02-15 01:17:10.000000', 'consum', 0.0211, 'lps'),
	(411638, 125, '2015-02-15 01:17:11.000000', 'consum', 0.0216, 'lps'),
	(411639, 125, '2015-02-15 01:17:12.000000', 'consum', 0.0224, 'lps'),
	(411640, 125, '2015-02-15 01:17:13.000000', 'consum', 0.0212, 'lps'),
	(411641, 125, '2015-02-15 01:17:14.000000', 'consum', 0.0226, 'lps'),
	(411642, 125, '2015-02-15 01:17:15.000000', 'consum', 0.0220, 'lps'),
	(411643, 125, '2015-02-15 01:17:16.000000', 'consum', 0.0210, 'lps'),
	(411644, 125, '2015-02-15 01:17:17.000000', 'consum', 0.0216, 'lps'),
	(411645, 125, '2015-02-15 01:17:18.000000', 'consum', 0.0224, 'lps'),
	(411646, 125, '2015-02-15 01:17:19.000000', 'consum', 0.0211, 'lps'),
	(411647, 125, '2015-02-15 01:17:20.000000', 'consum', 0.0223, 'lps'),
	(411648, 125, '2015-02-15 01:17:21.000000', 'consum', 0.0223, 'lps'),
	(411649, 125, '2015-02-15 01:17:22.000000', 'consum', 0.0218, 'lps'),
	(411650, 125, '2015-02-15 01:17:23.000000', 'consum', 0.0214, 'lps'),
	(411651, 125, '2015-02-15 01:17:24.000000', 'consum', 0.0223, 'lps'),
	(411652, 125, '2015-02-15 01:17:25.000000', 'consum', 0.0212, 'lps'),
	(411653, 125, '2015-02-15 01:17:26.000000', 'consum', 0.0217, 'lps'),
	(411654, 125, '2015-02-15 01:17:27.000000', 'consum', 0.0222, 'lps'),
	(411655, 125, '2015-02-15 01:17:28.000000', 'consum', 0.0215, 'lps'),
	(411656, 125, '2015-02-15 01:17:29.000000', 'consum', 0.0215, 'lps'),
	(411657, 125, '2015-02-15 01:17:30.000000', 'consum', 0.0224, 'lps'),
	(411658, 125, '2015-02-15 01:17:31.000000', 'consum', 0.0211, 'lps'),
	(411659, 125, '2015-02-15 01:17:32.000000', 'consum', 0.0210, 'lps'),
	(411660, 125, '2015-02-15 01:17:33.000000', 'consum', 0.0226, 'lps'),
	(411661, 125, '2015-02-15 01:17:34.000000', 'consum', 0.0219, 'lps'),
	(411662, 125, '2015-02-15 01:17:35.000000', 'consum', 0.0226, 'lps'),
	(411663, 125, '2015-02-15 01:17:36.000000', 'consum', 0.0214, 'lps'),
	(411664, 125, '2015-02-15 01:17:37.000000', 'consum', 0.0214, 'lps'),
	(411665, 125, '2015-02-15 01:17:38.000000', 'consum', 0.0220, 'lps'),
	(411666, 125, '2015-02-15 01:17:39.000000', 'consum', 0.0213, 'lps'),
	(411667, 125, '2015-02-15 01:17:40.000000', 'consum', 0.0215, 'lps'),
	(411668, 125, '2015-02-15 01:17:41.000000', 'consum', 0.0224, 'lps'),
	(411669, 125, '2015-02-15 01:17:42.000000', 'consum', 0.0215, 'lps'),
	(411670, 125, '2015-02-15 01:17:43.000000', 'consum', 0.0210, 'lps'),
	(411671, 125, '2015-02-15 01:17:44.000000', 'consum', 0.0212, 'lps'),
	(411672, 125, '2015-02-15 01:17:45.000000', 'consum', 0.0221, 'lps'),
	(411673, 125, '2015-02-15 01:17:46.000000', 'consum', 0.0224, 'lps'),
	(411674, 125, '2015-02-15 01:17:47.000000', 'consum', 0.0215, 'lps'),
	(411675, 125, '2015-02-15 01:17:48.000000', 'consum', 0.0211, 'lps'),
	(411676, 125, '2015-02-15 01:17:49.000000', 'consum', 0.0218, 'lps'),
	(411677, 125, '2015-02-15 01:17:50.000000', 'consum', 0.0213, 'lps'),
	(411678, 125, '2015-02-15 01:17:51.000000', 'consum', 0.0217, 'lps'),
	(411679, 125, '2015-02-15 01:17:52.000000', 'consum', 0.0221, 'lps'),
	(411680, 125, '2015-02-15 01:17:53.000000', 'consum', 0.0226, 'lps'),
	(411681, 125, '2015-02-15 01:17:54.000000', 'consum', 0.0225, 'lps'),
	(411682, 125, '2015-02-15 01:17:55.000000', 'consum', 0.0219, 'lps'),
	(411683, 125, '2015-02-15 01:17:56.000000', 'consum', 0.0210, 'lps'),
	(411684, 125, '2015-02-15 01:17:57.000000', 'consum', 0.0217, 'lps'),
	(411685, 125, '2015-02-15 01:17:58.000000', 'consum', 0.0211, 'lps'),
	(411686, 125, '2015-02-15 01:17:59.000000', 'consum', 0.0211, 'lps'),
	(411687, 125, '2015-02-15 01:18:00.000000', 'consum', 0.0213, 'lps'),
	(411688, 125, '2015-02-15 01:18:01.000000', 'consum', 0.0221, 'lps'),
	(411689, 125, '2015-02-15 01:18:02.000000', 'consum', 0.0224, 'lps'),
	(411690, 125, '2015-02-15 01:18:03.000000', 'consum', 0.0215, 'lps'),
	(411691, 125, '2015-02-15 01:18:04.000000', 'consum', 0.0211, 'lps'),
	(411692, 125, '2015-02-15 01:18:05.000000', 'consum', 0.0218, 'lps'),
	(411693, 125, '2015-02-15 01:18:06.000000', 'consum', 0.0211, 'lps'),
	(411694, 125, '2015-02-15 01:18:07.000000', 'consum', 0.0210, 'lps'),
	(411695, 125, '2015-02-15 01:18:08.000000', 'consum', 0.0222, 'lps'),
	(411696, 125, '2015-02-15 01:18:09.000000', 'consum', 0.0223, 'lps'),
	(411697, 125, '2015-02-15 01:18:10.000000', 'consum', 0.0221, 'lps'),
	(411698, 125, '2015-02-15 01:18:11.000000', 'consum', 0.0225, 'lps'),
	(411699, 125, '2015-02-15 01:18:12.000000', 'consum', 0.0219, 'lps'),
	(411700, 125, '2015-02-15 01:18:13.000000', 'consum', 0.0210, 'lps'),
	(411701, 125, '2015-02-15 01:18:14.000000', 'consum', 0.0218, 'lps'),
	(411702, 125, '2015-02-15 01:18:15.000000', 'consum', 0.0218, 'lps'),
	(411703, 125, '2015-02-15 01:18:16.000000', 'consum', 0.0226, 'lps'),
	(411704, 125, '2015-02-15 01:18:17.000000', 'consum', 0.0215, 'lps'),
	(411705, 125, '2015-02-15 01:18:18.000000', 'consum', 0.0223, 'lps'),
	(411706, 125, '2015-02-15 01:18:19.000000', 'consum', 0.0210, 'lps'),
	(411707, 125, '2015-02-15 01:18:20.000000', 'consum', 0.0221, 'lps'),
	(411708, 125, '2015-02-15 01:18:21.000000', 'consum', 0.0215, 'lps'),
	(411709, 125, '2015-02-15 01:18:22.000000', 'consum', 0.0218, 'lps'),
	(411710, 125, '2015-02-15 01:18:23.000000', 'consum', 0.0219, 'lps'),
	(411711, 125, '2015-02-15 01:18:24.000000', 'consum', 0.0214, 'lps'),
	(411712, 125, '2015-02-15 01:18:25.000000', 'consum', 0.0223, 'lps'),
	(411713, 125, '2015-02-15 01:18:26.000000', 'consum', 0.0210, 'lps'),
	(411714, 125, '2015-02-15 01:18:27.000000', 'consum', 0.0223, 'lps'),
	(411715, 125, '2015-02-15 01:18:28.000000', 'consum', 0.0226, 'lps'),
	(411716, 125, '2015-02-15 01:18:29.000000', 'consum', 0.0217, 'lps'),
	(411717, 125, '2015-02-15 01:18:30.000000', 'consum', 0.0215, 'lps'),
	(411718, 125, '2015-02-15 01:18:31.000000', 'consum', 0.0214, 'lps'),
	(411719, 125, '2015-02-15 01:18:32.000000', 'consum', 0.0215, 'lps'),
	(411720, 125, '2015-02-15 01:18:33.000000', 'consum', 0.0226, 'lps'),
	(411721, 125, '2015-02-15 01:18:34.000000', 'consum', 0.0223, 'lps'),
	(411722, 125, '2015-02-15 01:18:35.000000', 'consum', 0.0226, 'lps'),
	(411723, 125, '2015-02-15 01:18:36.000000', 'consum', 0.0217, 'lps'),
	(411724, 125, '2015-02-15 01:18:37.000000', 'consum', 0.0215, 'lps'),
	(411725, 125, '2015-02-15 01:18:38.000000', 'consum', 0.0217, 'lps'),
	(411726, 125, '2015-02-15 01:18:39.000000', 'consum', 0.0211, 'lps'),
	(411727, 125, '2015-02-15 01:18:40.000000', 'consum', 0.0212, 'lps'),
	(411728, 125, '2015-02-15 01:18:41.000000', 'consum', 0.0218, 'lps'),
	(411729, 125, '2015-02-15 01:18:42.000000', 'consum', 0.0211, 'lps'),
	(411730, 125, '2015-02-15 01:18:43.000000', 'consum', 0.0224, 'lps'),
	(411731, 125, '2015-02-15 01:18:44.000000', 'consum', 0.0226, 'lps'),
	(411732, 125, '2015-02-15 01:18:45.000000', 'consum', 0.0214, 'lps'),
	(411733, 125, '2015-02-15 01:18:46.000000', 'consum', 0.0216, 'lps'),
	(411734, 125, '2015-02-15 01:18:47.000000', 'consum', 0.0214, 'lps'),
	(411735, 125, '2015-02-15 01:18:48.000000', 'consum', 0.0211, 'lps'),
	(411736, 125, '2015-02-15 01:18:49.000000', 'consum', 0.0222, 'lps'),
	(411737, 125, '2015-02-15 01:18:50.000000', 'consum', 0.0216, 'lps'),
	(411738, 125, '2015-02-15 01:18:51.000000', 'consum', 0.0222, 'lps'),
	(411739, 125, '2015-02-15 01:18:52.000000', 'consum', 0.0218, 'lps'),
	(411740, 125, '2015-02-15 01:18:53.000000', 'consum', 0.0216, 'lps'),
	(411741, 125, '2015-02-15 01:18:54.000000', 'consum', 0.0215, 'lps'),
	(411742, 125, '2015-02-15 01:18:55.000000', 'consum', 0.0218, 'lps'),
	(411743, 125, '2015-02-15 01:18:56.000000', 'consum', 0.0217, 'lps'),
	(411744, 125, '2015-02-15 01:18:57.000000', 'consum', 0.0222, 'lps'),
	(411745, 125, '2015-02-15 01:18:58.000000', 'consum', 0.0217, 'lps'),
	(411746, 125, '2015-02-15 01:18:59.000000', 'consum', 0.0211, 'lps'),
	(411747, 125, '2015-02-15 01:19:00.000000', 'consum', 0.0226, 'lps'),
	(411748, 125, '2015-02-15 01:19:01.000000', 'consum', 0.0220, 'lps'),
	(411749, 125, '2015-02-15 01:19:02.000000', 'consum', 0.0215, 'lps'),
	(411750, 125, '2015-02-15 01:19:03.000000', 'consum', 0.0219, 'lps'),
	(411751, 125, '2015-02-15 01:19:04.000000', 'consum', 0.0225, 'lps'),
	(411752, 125, '2015-02-15 01:19:05.000000', 'consum', 0.0224, 'lps'),
	(411753, 125, '2015-02-15 01:19:06.000000', 'consum', 0.0219, 'lps'),
	(411754, 125, '2015-02-15 01:19:07.000000', 'consum', 0.0213, 'lps'),
	(411755, 125, '2015-02-15 01:19:08.000000', 'consum', 0.0214, 'lps'),
	(411756, 125, '2015-02-15 01:19:09.000000', 'consum', 0.0224, 'lps'),
	(411757, 125, '2015-02-15 01:19:10.000000', 'consum', 0.0219, 'lps'),
	(411758, 125, '2015-02-15 01:19:11.000000', 'consum', 0.0210, 'lps'),
	(411759, 125, '2015-02-15 01:19:12.000000', 'consum', 0.0220, 'lps'),
	(411760, 125, '2015-02-15 01:19:13.000000', 'consum', 0.0224, 'lps'),
	(411761, 125, '2015-02-15 01:19:14.000000', 'consum', 0.0216, 'lps'),
	(411762, 125, '2015-02-15 01:19:15.000000', 'consum', 0.0215, 'lps'),
	(411763, 125, '2015-02-15 01:19:16.000000', 'consum', 0.0218, 'lps'),
	(411764, 125, '2015-02-15 01:19:17.000000', 'consum', 0.0218, 'lps'),
	(411765, 125, '2015-02-15 01:19:18.000000', 'consum', 0.0211, 'lps'),
	(411766, 125, '2015-02-15 01:19:19.000000', 'consum', 0.0226, 'lps'),
	(411767, 125, '2015-02-15 01:19:20.000000', 'consum', 0.0221, 'lps'),
	(411768, 125, '2015-02-15 01:19:21.000000', 'consum', 0.0215, 'lps'),
	(411769, 125, '2015-02-15 01:19:22.000000', 'consum', 0.0222, 'lps'),
	(411770, 125, '2015-02-15 01:19:23.000000', 'consum', 0.0220, 'lps'),
	(411771, 125, '2015-02-15 01:19:24.000000', 'consum', 0.0223, 'lps'),
	(411772, 125, '2015-02-15 01:19:25.000000', 'consum', 0.0211, 'lps'),
	(411773, 125, '2015-02-15 01:19:26.000000', 'consum', 0.0211, 'lps'),
	(411774, 125, '2015-02-15 01:19:27.000000', 'consum', 0.0213, 'lps'),
	(411775, 125, '2015-02-15 01:19:28.000000', 'consum', 0.0223, 'lps'),
	(411776, 125, '2015-02-15 01:19:29.000000', 'consum', 0.0217, 'lps'),
	(411777, 125, '2015-02-15 01:19:30.000000', 'consum', 0.0223, 'lps'),
	(411778, 125, '2015-02-15 01:19:31.000000', 'consum', 0.0222, 'lps'),
	(411779, 125, '2015-02-15 01:19:32.000000', 'consum', 0.0211, 'lps'),
	(411780, 125, '2015-02-15 01:19:33.000000', 'consum', 0.0216, 'lps'),
	(411781, 125, '2015-02-15 01:19:34.000000', 'consum', 0.0219, 'lps'),
	(411782, 125, '2015-02-15 01:19:35.000000', 'consum', 0.0223, 'lps'),
	(411783, 125, '2015-02-15 01:19:36.000000', 'consum', 0.0211, 'lps'),
	(411784, 125, '2015-02-15 01:19:37.000000', 'consum', 0.0213, 'lps'),
	(411785, 125, '2015-02-15 01:19:38.000000', 'consum', 0.0222, 'lps'),
	(411786, 125, '2015-02-15 01:19:39.000000', 'consum', 0.0212, 'lps'),
	(411787, 125, '2015-02-15 01:19:40.000000', 'consum', 0.0218, 'lps'),
	(411788, 125, '2015-02-15 01:19:41.000000', 'consum', 0.0211, 'lps'),
	(411789, 125, '2015-02-15 01:19:42.000000', 'consum', 0.0226, 'lps'),
	(411790, 125, '2015-02-15 01:19:43.000000', 'consum', 0.0219, 'lps'),
	(411791, 125, '2015-02-15 01:19:44.000000', 'consum', 0.0226, 'lps'),
	(411792, 125, '2015-02-15 01:19:45.000000', 'consum', 0.0213, 'lps'),
	(411793, 125, '2015-02-15 01:19:46.000000', 'consum', 0.0210, 'lps'),
	(411794, 125, '2015-02-15 01:19:47.000000', 'consum', 0.0218, 'lps'),
	(411795, 125, '2015-02-15 01:19:48.000000', 'consum', 0.0218, 'lps'),
	(411796, 125, '2015-02-15 01:19:49.000000', 'consum', 0.0224, 'lps'),
	(411797, 125, '2015-02-15 01:19:50.000000', 'consum', 0.0224, 'lps'),
	(411798, 125, '2015-02-15 01:19:51.000000', 'consum', 0.0223, 'lps'),
	(411799, 125, '2015-02-15 01:19:52.000000', 'consum', 0.0214, 'lps'),
	(411800, 125, '2015-02-15 01:19:53.000000', 'consum', 0.0211, 'lps'),
	(411801, 125, '2015-02-15 01:19:54.000000', 'consum', 0.0220, 'lps'),
	(411802, 125, '2015-02-15 01:19:55.000000', 'consum', 0.0223, 'lps'),
	(411803, 125, '2015-02-15 01:19:56.000000', 'consum', 0.0211, 'lps'),
	(411804, 125, '2015-02-15 01:19:57.000000', 'consum', 0.0211, 'lps'),
	(411805, 125, '2015-02-15 01:19:58.000000', 'consum', 0.0214, 'lps'),
	(411806, 125, '2015-02-15 01:19:59.000000', 'consum', 0.0226, 'lps'),
	(411807, 125, '2015-02-15 01:20:00.000000', 'consum', 0.0226, 'lps'),
	(411808, 125, '2015-02-15 01:20:01.000000', 'consum', 0.0226, 'lps'),
	(411809, 125, '2015-02-15 01:20:02.000000', 'consum', 0.0210, 'lps'),
	(411810, 125, '2015-02-15 01:20:03.000000', 'consum', 0.0213, 'lps'),
	(411811, 125, '2015-02-15 01:20:04.000000', 'consum', 0.0225, 'lps'),
	(411812, 125, '2015-02-15 01:20:05.000000', 'consum', 0.0226, 'lps'),
	(411813, 125, '2015-02-15 01:20:06.000000', 'consum', 0.0213, 'lps'),
	(411814, 125, '2015-02-15 01:20:07.000000', 'consum', 0.0211, 'lps'),
	(411815, 125, '2015-02-15 01:20:08.000000', 'consum', 0.0224, 'lps'),
	(411816, 125, '2015-02-15 01:20:09.000000', 'consum', 0.0226, 'lps'),
	(411817, 125, '2015-02-15 01:20:10.000000', 'consum', 0.0213, 'lps'),
	(411818, 125, '2015-02-15 01:20:11.000000', 'consum', 0.0214, 'lps'),
	(411819, 125, '2015-02-15 01:20:12.000000', 'consum', 0.0220, 'lps'),
	(411820, 125, '2015-02-15 01:20:13.000000', 'consum', 0.0214, 'lps'),
	(411821, 125, '2015-02-15 01:20:14.000000', 'consum', 0.0220, 'lps'),
	(411822, 125, '2015-02-15 01:20:15.000000', 'consum', 0.0212, 'lps'),
	(411823, 125, '2015-02-15 01:20:16.000000', 'consum', 0.0210, 'lps'),
	(411824, 125, '2015-02-15 01:20:17.000000', 'consum', 0.0218, 'lps'),
	(411825, 125, '2015-02-15 01:20:18.000000', 'consum', 0.0219, 'lps'),
	(411826, 125, '2015-02-15 01:20:19.000000', 'consum', 0.0213, 'lps'),
	(411827, 125, '2015-02-15 01:20:20.000000', 'consum', 0.0217, 'lps'),
	(411828, 125, '2015-02-15 01:20:21.000000', 'consum', 0.0219, 'lps'),
	(411829, 125, '2015-02-15 01:20:22.000000', 'consum', 0.0219, 'lps'),
	(411830, 125, '2015-02-15 01:20:23.000000', 'consum', 0.0226, 'lps'),
	(411831, 125, '2015-02-15 01:20:24.000000', 'consum', 0.0212, 'lps'),
	(411832, 125, '2015-02-15 01:20:25.000000', 'consum', 0.0223, 'lps'),
	(411833, 125, '2015-02-15 01:20:26.000000', 'consum', 0.0220, 'lps'),
	(411834, 125, '2015-02-15 01:20:27.000000', 'consum', 0.0223, 'lps'),
	(411835, 125, '2015-02-15 01:20:28.000000', 'consum', 0.0211, 'lps'),
	(411836, 125, '2015-02-15 01:20:29.000000', 'consum', 0.0211, 'lps'),
	(411837, 125, '2015-02-15 01:20:30.000000', 'consum', 0.0211, 'lps'),
	(411838, 125, '2015-02-15 01:20:31.000000', 'consum', 0.0215, 'lps'),
	(411839, 125, '2015-02-15 01:20:32.000000', 'consum', 0.0215, 'lps'),
	(411840, 125, '2015-02-15 01:20:33.000000', 'consum', 0.0218, 'lps'),
	(411841, 125, '2015-02-15 01:20:34.000000', 'consum', 0.0221, 'lps'),
	(411842, 125, '2015-02-15 01:20:35.000000', 'consum', 0.0222, 'lps'),
	(411843, 125, '2015-02-15 01:20:36.000000', 'consum', 0.0222, 'lps'),
	(411844, 125, '2015-02-15 01:20:37.000000', 'consum', 0.0219, 'lps'),
	(411845, 125, '2015-02-15 01:20:38.000000', 'consum', 0.0220, 'lps'),
	(411846, 125, '2015-02-15 01:20:39.000000', 'consum', 0.0214, 'lps'),
	(411847, 125, '2015-02-15 01:20:40.000000', 'consum', 0.0218, 'lps'),
	(411848, 125, '2015-02-15 01:20:41.000000', 'consum', 0.0222, 'lps'),
	(411849, 125, '2015-02-15 01:20:42.000000', 'consum', 0.0211, 'lps'),
	(411850, 125, '2015-02-15 01:20:43.000000', 'consum', 0.0213, 'lps'),
	(411851, 125, '2015-02-15 01:20:44.000000', 'consum', 0.0224, 'lps'),
	(411852, 125, '2015-02-15 01:20:45.000000', 'consum', 0.0219, 'lps'),
	(411853, 125, '2015-02-15 01:20:46.000000', 'consum', 0.0213, 'lps'),
	(411854, 125, '2015-02-15 01:20:47.000000', 'consum', 0.0214, 'lps'),
	(411855, 125, '2015-02-15 01:20:48.000000', 'consum', 0.0225, 'lps'),
	(411856, 125, '2015-02-15 01:20:49.000000', 'consum', 0.0220, 'lps'),
	(411857, 125, '2015-02-15 01:20:50.000000', 'consum', 0.0216, 'lps'),
	(411858, 125, '2015-02-15 01:20:51.000000', 'consum', 0.0213, 'lps'),
	(411859, 125, '2015-02-15 01:20:52.000000', 'consum', 0.0221, 'lps'),
	(411860, 125, '2015-02-15 01:20:53.000000', 'consum', 0.0225, 'lps'),
	(411861, 125, '2015-02-15 01:20:54.000000', 'consum', 0.0216, 'lps'),
	(411862, 125, '2015-02-15 01:20:55.000000', 'consum', 0.0214, 'lps'),
	(411863, 125, '2015-02-15 01:20:56.000000', 'consum', 0.0211, 'lps'),
	(411864, 125, '2015-02-15 01:20:57.000000', 'consum', 0.0220, 'lps'),
	(411865, 125, '2015-02-15 01:20:58.000000', 'consum', 0.0222, 'lps'),
	(411866, 125, '2015-02-15 01:20:59.000000', 'consum', 0.0210, 'lps'),
	(411867, 125, '2015-02-15 01:21:00.000000', 'consum', 0.0224, 'lps'),
	(411868, 125, '2015-02-15 01:21:01.000000', 'consum', 0.0212, 'lps'),
	(411869, 125, '2015-02-15 01:21:02.000000', 'consum', 0.0211, 'lps'),
	(411870, 125, '2015-02-15 01:21:03.000000', 'consum', 0.0213, 'lps'),
	(411871, 125, '2015-02-15 01:21:04.000000', 'consum', 0.0220, 'lps'),
	(411872, 125, '2015-02-15 01:21:05.000000', 'consum', 0.0217, 'lps'),
	(411873, 125, '2015-02-15 01:21:06.000000', 'consum', 0.0218, 'lps'),
	(411874, 125, '2015-02-15 01:21:07.000000', 'consum', 0.0210, 'lps'),
	(411875, 125, '2015-02-15 01:21:08.000000', 'consum', 0.0221, 'lps'),
	(411876, 125, '2015-02-15 01:21:09.000000', 'consum', 0.0216, 'lps'),
	(411877, 125, '2015-02-15 01:21:10.000000', 'consum', 0.0225, 'lps'),
	(411878, 125, '2015-02-15 01:21:11.000000', 'consum', 0.0214, 'lps'),
	(411879, 125, '2015-02-15 01:21:12.000000', 'consum', 0.0220, 'lps'),
	(411880, 125, '2015-02-15 01:21:13.000000', 'consum', 0.0217, 'lps'),
	(411881, 125, '2015-02-15 01:21:14.000000', 'consum', 0.0214, 'lps'),
	(411882, 125, '2015-02-15 01:21:15.000000', 'consum', 0.0226, 'lps'),
	(411883, 125, '2015-02-15 01:21:16.000000', 'consum', 0.0210, 'lps'),
	(411884, 125, '2015-02-15 01:21:17.000000', 'consum', 0.0214, 'lps'),
	(411885, 125, '2015-02-15 01:21:18.000000', 'consum', 0.0215, 'lps'),
	(411886, 125, '2015-02-15 01:21:19.000000', 'consum', 0.0224, 'lps'),
	(411887, 125, '2015-02-15 01:21:20.000000', 'consum', 0.0212, 'lps'),
	(411888, 125, '2015-02-15 01:21:21.000000', 'consum', 0.0212, 'lps'),
	(411889, 125, '2015-02-15 01:21:22.000000', 'consum', 0.0216, 'lps'),
	(411890, 125, '2015-02-15 01:21:23.000000', 'consum', 0.0219, 'lps'),
	(411891, 125, '2015-02-15 01:21:24.000000', 'consum', 0.0218, 'lps'),
	(411892, 125, '2015-02-15 01:21:25.000000', 'consum', 0.0222, 'lps'),
	(411893, 125, '2015-02-15 01:21:26.000000', 'consum', 0.0216, 'lps'),
	(411894, 125, '2015-02-15 01:21:27.000000', 'consum', 0.0221, 'lps'),
	(411895, 125, '2015-02-15 01:21:28.000000', 'consum', 0.0213, 'lps'),
	(411896, 125, '2015-02-15 01:21:29.000000', 'consum', 0.0211, 'lps'),
	(411897, 125, '2015-02-15 01:21:30.000000', 'consum', 0.0222, 'lps'),
	(411898, 125, '2015-02-15 01:21:31.000000', 'consum', 0.0215, 'lps'),
	(411899, 125, '2015-02-15 01:21:32.000000', 'consum', 0.0218, 'lps'),
	(411900, 125, '2015-02-15 01:21:33.000000', 'consum', 0.0219, 'lps'),
	(411901, 125, '2015-02-15 01:21:34.000000', 'consum', 0.0214, 'lps'),
	(411902, 125, '2015-02-15 01:21:35.000000', 'consum', 0.0220, 'lps'),
	(411903, 125, '2015-02-15 01:21:36.000000', 'consum', 0.0217, 'lps'),
	(411904, 125, '2015-02-15 01:21:37.000000', 'consum', 0.0213, 'lps'),
	(411905, 125, '2015-02-15 01:21:38.000000', 'consum', 0.0221, 'lps'),
	(411906, 125, '2015-02-15 01:21:39.000000', 'consum', 0.0224, 'lps'),
	(411907, 125, '2015-02-15 01:21:40.000000', 'consum', 0.0213, 'lps'),
	(411908, 125, '2015-02-15 01:21:41.000000', 'consum', 0.0217, 'lps'),
	(411909, 125, '2015-02-15 01:21:42.000000', 'consum', 0.0221, 'lps'),
	(411910, 125, '2015-02-15 01:21:43.000000', 'consum', 0.0210, 'lps'),
	(411911, 125, '2015-02-15 01:21:44.000000', 'consum', 0.0226, 'lps'),
	(411912, 125, '2015-02-15 01:21:45.000000', 'consum', 0.0225, 'lps'),
	(411913, 125, '2015-02-15 01:21:46.000000', 'consum', 0.0221, 'lps'),
	(411914, 125, '2015-02-15 01:21:47.000000', 'consum', 0.0218, 'lps'),
	(411915, 125, '2015-02-15 01:21:48.000000', 'consum', 0.0217, 'lps'),
	(411916, 125, '2015-02-15 01:21:49.000000', 'consum', 0.0223, 'lps'),
	(411917, 125, '2015-02-15 01:21:50.000000', 'consum', 0.0222, 'lps'),
	(411918, 125, '2015-02-15 01:21:51.000000', 'consum', 0.0212, 'lps'),
	(411919, 125, '2015-02-15 01:21:52.000000', 'consum', 0.0218, 'lps'),
	(411920, 125, '2015-02-15 01:21:53.000000', 'consum', 0.0212, 'lps'),
	(411921, 125, '2015-02-15 01:21:54.000000', 'consum', 0.0213, 'lps'),
	(411922, 125, '2015-02-15 01:21:55.000000', 'consum', 0.0218, 'lps'),
	(411923, 125, '2015-02-15 01:21:56.000000', 'consum', 0.0211, 'lps'),
	(411924, 125, '2015-02-15 01:21:57.000000', 'consum', 0.0223, 'lps'),
	(411925, 125, '2015-02-15 01:21:58.000000', 'consum', 0.0221, 'lps'),
	(411926, 125, '2015-02-15 01:21:59.000000', 'consum', 0.0226, 'lps'),
	(411927, 125, '2015-02-15 01:22:00.000000', 'consum', 0.0224, 'lps'),
	(411928, 125, '2015-02-15 01:22:01.000000', 'consum', 0.0216, 'lps'),
	(411929, 125, '2015-02-15 01:22:02.000000', 'consum', 0.0213, 'lps'),
	(411930, 125, '2015-02-15 01:22:03.000000', 'consum', 0.0210, 'lps'),
	(411931, 125, '2015-02-15 01:22:04.000000', 'consum', 0.0218, 'lps'),
	(411932, 125, '2015-02-15 01:22:05.000000', 'consum', 0.0217, 'lps'),
	(411933, 125, '2015-02-15 01:22:06.000000', 'consum', 0.0221, 'lps'),
	(411934, 125, '2015-02-15 01:22:07.000000', 'consum', 0.0212, 'lps'),
	(411935, 125, '2015-02-15 01:22:08.000000', 'consum', 0.0222, 'lps'),
	(411936, 125, '2015-02-15 01:22:09.000000', 'consum', 0.0213, 'lps'),
	(411937, 125, '2015-02-15 01:22:10.000000', 'consum', 0.0224, 'lps'),
	(411938, 125, '2015-02-15 01:22:11.000000', 'consum', 0.0218, 'lps'),
	(411939, 125, '2015-02-15 01:22:12.000000', 'consum', 0.0210, 'lps'),
	(411940, 125, '2015-02-15 01:22:13.000000', 'consum', 0.0219, 'lps'),
	(411941, 125, '2015-02-15 01:22:14.000000', 'consum', 0.0224, 'lps'),
	(411942, 125, '2015-02-15 01:22:15.000000', 'consum', 0.0220, 'lps'),
	(411943, 125, '2015-02-15 01:22:16.000000', 'consum', 0.0217, 'lps'),
	(411944, 125, '2015-02-15 01:22:17.000000', 'consum', 0.0216, 'lps'),
	(411945, 125, '2015-02-15 01:22:18.000000', 'consum', 0.0218, 'lps'),
	(411946, 125, '2015-02-15 01:22:19.000000', 'consum', 0.0217, 'lps'),
	(411947, 125, '2015-02-15 01:22:20.000000', 'consum', 0.0220, 'lps'),
	(411948, 125, '2015-02-15 01:22:21.000000', 'consum', 0.0224, 'lps'),
	(411949, 125, '2015-02-15 01:22:22.000000', 'consum', 0.0218, 'lps'),
	(411950, 125, '2015-02-15 01:22:23.000000', 'consum', 0.0223, 'lps'),
	(411951, 125, '2015-02-15 01:22:24.000000', 'consum', 0.0217, 'lps'),
	(411952, 125, '2015-02-15 01:22:25.000000', 'consum', 0.0224, 'lps'),
	(411953, 125, '2015-02-15 01:22:26.000000', 'consum', 0.0224, 'lps'),
	(411954, 125, '2015-02-15 01:22:27.000000', 'consum', 0.0225, 'lps'),
	(411955, 125, '2015-02-15 01:22:28.000000', 'consum', 0.0224, 'lps'),
	(411956, 125, '2015-02-15 01:22:29.000000', 'consum', 0.0219, 'lps'),
	(411957, 125, '2015-02-15 01:22:30.000000', 'consum', 0.0214, 'lps'),
	(411958, 125, '2015-02-15 01:22:31.000000', 'consum', 0.0220, 'lps'),
	(411959, 125, '2015-02-15 01:22:32.000000', 'consum', 0.0217, 'lps'),
	(411960, 125, '2015-02-15 01:22:33.000000', 'consum', 0.0212, 'lps'),
	(411961, 125, '2015-02-15 01:22:34.000000', 'consum', 0.0217, 'lps'),
	(411962, 125, '2015-02-15 01:22:35.000000', 'consum', 0.0221, 'lps'),
	(411963, 125, '2015-02-15 01:22:36.000000', 'consum', 0.0214, 'lps'),
	(411964, 125, '2015-02-15 01:22:37.000000', 'consum', 0.0213, 'lps'),
	(411965, 125, '2015-02-15 01:22:38.000000', 'consum', 0.0215, 'lps'),
	(411966, 125, '2015-02-15 01:22:39.000000', 'consum', 0.0226, 'lps'),
	(411967, 125, '2015-02-15 01:22:40.000000', 'consum', 0.0223, 'lps'),
	(411968, 125, '2015-02-15 01:22:41.000000', 'consum', 0.0210, 'lps'),
	(411969, 125, '2015-02-15 01:22:42.000000', 'consum', 0.0222, 'lps'),
	(411970, 125, '2015-02-15 01:22:43.000000', 'consum', 0.0222, 'lps'),
	(411971, 125, '2015-02-15 01:22:44.000000', 'consum', 0.0218, 'lps'),
	(411972, 125, '2015-02-15 01:22:45.000000', 'consum', 0.0215, 'lps'),
	(411973, 125, '2015-02-15 01:22:46.000000', 'consum', 0.0212, 'lps'),
	(411974, 125, '2015-02-15 01:22:47.000000', 'consum', 0.0221, 'lps'),
	(411975, 125, '2015-02-15 01:22:48.000000', 'consum', 0.0225, 'lps'),
	(411976, 125, '2015-02-15 01:22:49.000000', 'consum', 0.0221, 'lps'),
	(411977, 125, '2015-02-15 01:22:50.000000', 'consum', 0.0218, 'lps'),
	(411978, 125, '2015-02-15 01:22:51.000000', 'consum', 0.0219, 'lps'),
	(411979, 125, '2015-02-15 01:22:52.000000', 'consum', 0.0212, 'lps'),
	(411980, 125, '2015-02-15 01:22:53.000000', 'consum', 0.0212, 'lps'),
	(411981, 125, '2015-02-15 01:22:54.000000', 'consum', 0.0213, 'lps'),
	(411982, 125, '2015-02-15 01:22:55.000000', 'consum', 0.0220, 'lps'),
	(411983, 125, '2015-02-15 01:22:56.000000', 'consum', 0.0217, 'lps'),
	(411984, 125, '2015-02-15 01:22:57.000000', 'consum', 0.0215, 'lps'),
	(411985, 125, '2015-02-15 01:22:58.000000', 'consum', 0.0214, 'lps'),
	(411986, 125, '2015-02-15 01:22:59.000000', 'consum', 0.0214, 'lps'),
	(411987, 125, '2015-02-15 01:23:00.000000', 'consum', 0.0222, 'lps'),
	(411988, 125, '2015-02-15 01:23:01.000000', 'consum', 0.0222, 'lps'),
	(411989, 125, '2015-02-15 01:23:02.000000', 'consum', 0.0220, 'lps'),
	(411990, 125, '2015-02-15 01:23:03.000000', 'consum', 0.0221, 'lps'),
	(411991, 125, '2015-02-15 01:23:04.000000', 'consum', 0.0221, 'lps'),
	(411992, 125, '2015-02-15 01:23:05.000000', 'consum', 0.0216, 'lps'),
	(411993, 125, '2015-02-15 01:23:06.000000', 'consum', 0.0225, 'lps'),
	(411994, 125, '2015-02-15 01:23:07.000000', 'consum', 0.0216, 'lps'),
	(411995, 125, '2015-02-15 01:23:08.000000', 'consum', 0.0214, 'lps'),
	(411996, 125, '2015-02-15 01:23:09.000000', 'consum', 0.0212, 'lps'),
	(411997, 125, '2015-02-15 01:23:10.000000', 'consum', 0.0224, 'lps'),
	(411998, 125, '2015-02-15 01:23:11.000000', 'consum', 0.0223, 'lps'),
	(411999, 125, '2015-02-15 01:23:12.000000', 'consum', 0.0215, 'lps'),
	(412000, 125, '2015-02-15 01:23:13.000000', 'consum', 0.0217, 'lps'),
	(412001, 125, '2015-02-15 01:23:14.000000', 'consum', 0.0211, 'lps'),
	(412002, 125, '2015-02-15 01:23:15.000000', 'consum', 0.0211, 'lps'),
	(412003, 125, '2015-02-15 01:23:16.000000', 'consum', 0.0214, 'lps'),
	(412004, 125, '2015-02-15 01:23:17.000000', 'consum', 0.0225, 'lps'),
	(412005, 125, '2015-02-15 01:23:18.000000', 'consum', 0.0225, 'lps'),
	(412006, 125, '2015-02-15 01:23:19.000000', 'consum', 0.0223, 'lps'),
	(412007, 125, '2015-02-15 01:23:20.000000', 'consum', 0.0214, 'lps'),
	(412008, 125, '2015-02-15 01:23:21.000000', 'consum', 0.0224, 'lps'),
	(412009, 125, '2015-02-15 01:23:22.000000', 'consum', 0.0217, 'lps'),
	(412010, 125, '2015-02-15 01:23:23.000000', 'consum', 0.0220, 'lps'),
	(412011, 125, '2015-02-15 01:23:24.000000', 'consum', 0.0225, 'lps'),
	(412012, 125, '2015-02-15 01:23:25.000000', 'consum', 0.0220, 'lps'),
	(412013, 125, '2015-02-15 01:23:26.000000', 'consum', 0.0215, 'lps'),
	(412014, 125, '2015-02-15 01:23:27.000000', 'consum', 0.0225, 'lps'),
	(412015, 125, '2015-02-15 01:23:28.000000', 'consum', 0.0218, 'lps'),
	(412016, 125, '2015-02-15 01:23:29.000000', 'consum', 0.0221, 'lps'),
	(412017, 125, '2015-02-15 01:23:30.000000', 'consum', 0.0211, 'lps'),
	(412018, 125, '2015-02-15 01:23:31.000000', 'consum', 0.0214, 'lps'),
	(412019, 125, '2015-02-15 01:23:32.000000', 'consum', 0.0210, 'lps'),
	(412020, 125, '2015-02-15 01:23:33.000000', 'consum', 0.0216, 'lps'),
	(412021, 125, '2015-02-15 01:23:34.000000', 'consum', 0.0222, 'lps'),
	(412022, 125, '2015-02-15 01:23:35.000000', 'consum', 0.0218, 'lps'),
	(412023, 125, '2015-02-15 01:23:36.000000', 'consum', 0.0215, 'lps'),
	(412024, 125, '2015-02-15 01:23:37.000000', 'consum', 0.0211, 'lps'),
	(412025, 125, '2015-02-15 01:23:38.000000', 'consum', 0.0220, 'lps'),
	(412026, 125, '2015-02-15 01:23:39.000000', 'consum', 0.0221, 'lps'),
	(412027, 125, '2015-02-15 01:23:40.000000', 'consum', 0.0220, 'lps'),
	(412028, 125, '2015-02-15 01:23:41.000000', 'consum', 0.0210, 'lps'),
	(412029, 125, '2015-02-15 01:23:42.000000', 'consum', 0.0212, 'lps'),
	(412030, 125, '2015-02-15 01:23:43.000000', 'consum', 0.0224, 'lps'),
	(412031, 125, '2015-02-15 01:23:44.000000', 'consum', 0.0224, 'lps'),
	(412032, 125, '2015-02-15 01:23:45.000000', 'consum', 0.0218, 'lps'),
	(412033, 125, '2015-02-15 01:23:46.000000', 'consum', 0.0212, 'lps'),
	(412034, 125, '2015-02-15 01:23:47.000000', 'consum', 0.0211, 'lps'),
	(412035, 125, '2015-02-15 01:23:48.000000', 'consum', 0.0210, 'lps'),
	(412036, 125, '2015-02-15 01:23:49.000000', 'consum', 0.0223, 'lps'),
	(412037, 125, '2015-02-15 01:23:50.000000', 'consum', 0.0225, 'lps'),
	(412038, 125, '2015-02-15 01:23:51.000000', 'consum', 0.0214, 'lps'),
	(412039, 125, '2015-02-15 01:23:52.000000', 'consum', 0.0219, 'lps'),
	(412040, 125, '2015-02-15 01:23:53.000000', 'consum', 0.0210, 'lps'),
	(412041, 125, '2015-02-15 01:23:54.000000', 'consum', 0.0219, 'lps'),
	(412042, 125, '2015-02-15 01:23:55.000000', 'consum', 0.0218, 'lps'),
	(412043, 125, '2015-02-15 01:23:56.000000', 'consum', 0.0225, 'lps'),
	(412044, 125, '2015-02-15 01:23:57.000000', 'consum', 0.0211, 'lps'),
	(412045, 125, '2015-02-15 01:23:58.000000', 'consum', 0.0220, 'lps'),
	(412046, 125, '2015-02-15 01:23:59.000000', 'consum', 0.0223, 'lps'),
	(412047, 125, '2015-02-15 01:24:00.000000', 'consum', 0.0211, 'lps'),
	(412048, 125, '2015-02-15 01:24:01.000000', 'consum', 0.0212, 'lps'),
	(412049, 125, '2015-02-15 01:24:02.000000', 'consum', 0.0218, 'lps'),
	(412050, 125, '2015-02-15 01:24:03.000000', 'consum', 0.0226, 'lps'),
	(412051, 125, '2015-02-15 01:24:04.000000', 'consum', 0.0214, 'lps'),
	(412052, 125, '2015-02-15 01:24:05.000000', 'consum', 0.0218, 'lps'),
	(412053, 125, '2015-02-15 01:24:06.000000', 'consum', 0.0222, 'lps'),
	(412054, 125, '2015-02-15 01:24:07.000000', 'consum', 0.0211, 'lps'),
	(412055, 125, '2015-02-15 01:24:08.000000', 'consum', 0.0216, 'lps'),
	(412056, 125, '2015-02-15 01:24:09.000000', 'consum', 0.0220, 'lps'),
	(412057, 125, '2015-02-15 01:24:10.000000', 'consum', 0.0225, 'lps'),
	(412058, 125, '2015-02-15 01:24:11.000000', 'consum', 0.0220, 'lps'),
	(412059, 125, '2015-02-15 01:24:12.000000', 'consum', 0.0218, 'lps'),
	(412060, 125, '2015-02-15 01:24:13.000000', 'consum', 0.0220, 'lps'),
	(412061, 125, '2015-02-15 01:24:14.000000', 'consum', 0.0218, 'lps'),
	(412062, 125, '2015-02-15 01:24:15.000000', 'consum', 0.0222, 'lps'),
	(412063, 125, '2015-02-15 01:24:16.000000', 'consum', 0.0212, 'lps'),
	(412064, 125, '2015-02-15 01:24:17.000000', 'consum', 0.0218, 'lps'),
	(412065, 125, '2015-02-15 01:24:18.000000', 'consum', 0.0226, 'lps'),
	(412066, 125, '2015-02-15 01:24:19.000000', 'consum', 0.0217, 'lps'),
	(412067, 125, '2015-02-15 01:24:20.000000', 'consum', 0.0215, 'lps'),
	(412068, 125, '2015-02-15 01:24:21.000000', 'consum', 0.0212, 'lps'),
	(412069, 125, '2015-02-15 01:24:22.000000', 'consum', 0.0226, 'lps'),
	(412070, 125, '2015-02-15 01:24:23.000000', 'consum', 0.0215, 'lps'),
	(412071, 125, '2015-02-15 01:24:24.000000', 'consum', 0.0223, 'lps'),
	(412072, 125, '2015-02-15 01:24:25.000000', 'consum', 0.0224, 'lps'),
	(412073, 125, '2015-02-15 01:24:26.000000', 'consum', 0.0224, 'lps'),
	(412074, 125, '2015-02-15 01:24:27.000000', 'consum', 0.0221, 'lps'),
	(412075, 125, '2015-02-15 01:24:28.000000', 'consum', 0.0224, 'lps'),
	(412076, 125, '2015-02-15 01:24:29.000000', 'consum', 0.0214, 'lps'),
	(412077, 125, '2015-02-15 01:24:30.000000', 'consum', 0.0221, 'lps'),
	(412078, 125, '2015-02-15 01:24:31.000000', 'consum', 0.0222, 'lps'),
	(412079, 125, '2015-02-15 01:24:32.000000', 'consum', 0.0220, 'lps'),
	(412080, 125, '2015-02-15 01:24:33.000000', 'consum', 0.0222, 'lps'),
	(412081, 125, '2015-02-15 01:24:34.000000', 'consum', 0.0225, 'lps'),
	(412082, 125, '2015-02-15 01:24:35.000000', 'consum', 0.0215, 'lps'),
	(412083, 125, '2015-02-15 01:24:36.000000', 'consum', 0.0210, 'lps'),
	(412084, 125, '2015-02-15 01:24:37.000000', 'consum', 0.0211, 'lps'),
	(412085, 125, '2015-02-15 01:24:38.000000', 'consum', 0.0215, 'lps'),
	(412086, 125, '2015-02-15 01:24:39.000000', 'consum', 0.0217, 'lps'),
	(412087, 125, '2015-02-15 01:24:40.000000', 'consum', 0.0212, 'lps'),
	(412088, 125, '2015-02-15 01:24:41.000000', 'consum', 0.0217, 'lps'),
	(412089, 125, '2015-02-15 01:24:42.000000', 'consum', 0.0222, 'lps'),
	(412090, 125, '2015-02-15 01:24:43.000000', 'consum', 0.0217, 'lps'),
	(412091, 125, '2015-02-15 01:24:44.000000', 'consum', 0.0224, 'lps'),
	(412092, 125, '2015-02-15 01:24:45.000000', 'consum', 0.0226, 'lps'),
	(412093, 125, '2015-02-15 01:24:46.000000', 'consum', 0.0213, 'lps'),
	(412094, 125, '2015-02-15 01:24:47.000000', 'consum', 0.0214, 'lps'),
	(412095, 125, '2015-02-15 01:24:48.000000', 'consum', 0.0220, 'lps'),
	(412096, 125, '2015-02-15 01:24:49.000000', 'consum', 0.0215, 'lps'),
	(412097, 125, '2015-02-15 01:24:50.000000', 'consum', 0.0224, 'lps'),
	(412098, 125, '2015-02-15 01:24:51.000000', 'consum', 0.0214, 'lps'),
	(412099, 125, '2015-02-15 01:24:52.000000', 'consum', 0.0222, 'lps'),
	(412100, 125, '2015-02-15 01:24:53.000000', 'consum', 0.0223, 'lps'),
	(412101, 125, '2015-02-15 01:24:54.000000', 'consum', 0.0225, 'lps'),
	(412102, 125, '2015-02-15 01:24:55.000000', 'consum', 0.0212, 'lps'),
	(412103, 125, '2015-02-15 01:24:56.000000', 'consum', 0.0225, 'lps'),
	(412104, 125, '2015-02-15 01:24:57.000000', 'consum', 0.0211, 'lps'),
	(412105, 125, '2015-02-15 01:24:58.000000', 'consum', 0.0222, 'lps'),
	(412106, 125, '2015-02-15 01:24:59.000000', 'consum', 0.0216, 'lps'),
	(412107, 125, '2015-02-15 01:25:00.000000', 'consum', 0.0221, 'lps'),
	(412108, 125, '2015-02-15 01:25:01.000000', 'consum', 0.0216, 'lps'),
	(412109, 125, '2015-02-15 01:25:02.000000', 'consum', 0.0222, 'lps'),
	(412110, 125, '2015-02-15 01:25:03.000000', 'consum', 0.0221, 'lps'),
	(412111, 125, '2015-02-15 01:25:04.000000', 'consum', 0.0212, 'lps'),
	(412112, 125, '2015-02-15 01:25:05.000000', 'consum', 0.0219, 'lps'),
	(412113, 125, '2015-02-15 01:25:06.000000', 'consum', 0.0219, 'lps'),
	(412114, 125, '2015-02-15 01:25:07.000000', 'consum', 0.0226, 'lps'),
	(412115, 125, '2015-02-15 01:25:08.000000', 'consum', 0.0212, 'lps'),
	(412116, 125, '2015-02-15 01:25:09.000000', 'consum', 0.0223, 'lps'),
	(412117, 125, '2015-02-15 01:25:10.000000', 'consum', 0.0218, 'lps'),
	(412118, 125, '2015-02-15 01:25:11.000000', 'consum', 0.0211, 'lps'),
	(412119, 125, '2015-02-15 01:25:12.000000', 'consum', 0.0211, 'lps'),
	(412120, 126, '2015-02-15 00:00:00.000000', 'consum', 0.0216, 'lps'),
	(412121, 126, '2015-02-15 00:00:01.000000', 'consum', 0.0220, 'lps'),
	(412122, 126, '2015-02-15 00:00:02.000000', 'consum', 0.0214, 'lps'),
	(412123, 126, '2015-02-15 00:00:03.000000', 'consum', 0.0217, 'lps'),
	(412124, 126, '2015-02-15 00:00:04.000000', 'consum', 0.0219, 'lps'),
	(412125, 126, '2015-02-15 00:00:05.000000', 'consum', 0.0218, 'lps'),
	(412126, 126, '2015-02-15 00:00:06.000000', 'consum', 0.0212, 'lps'),
	(412127, 126, '2015-02-15 00:00:07.000000', 'consum', 0.0210, 'lps'),
	(412128, 126, '2015-02-15 00:00:08.000000', 'consum', 0.0220, 'lps'),
	(412129, 126, '2015-02-15 00:00:09.000000', 'consum', 0.0219, 'lps'),
	(412130, 126, '2015-02-15 00:00:10.000000', 'consum', 0.0212, 'lps'),
	(412131, 126, '2015-02-15 00:00:11.000000', 'consum', 0.0218, 'lps'),
	(412132, 126, '2015-02-15 00:00:12.000000', 'consum', 0.0220, 'lps'),
	(412133, 126, '2015-02-15 00:00:13.000000', 'consum', 0.0221, 'lps'),
	(412134, 126, '2015-02-15 00:00:14.000000', 'consum', 0.0221, 'lps'),
	(412135, 126, '2015-02-15 00:00:15.000000', 'consum', 0.0219, 'lps'),
	(412136, 126, '2015-02-15 00:00:16.000000', 'consum', 0.0221, 'lps'),
	(412137, 126, '2015-02-15 00:00:17.000000', 'consum', 0.0223, 'lps'),
	(412138, 126, '2015-02-15 00:00:18.000000', 'consum', 0.0218, 'lps'),
	(412139, 126, '2015-02-15 00:00:19.000000', 'consum', 0.0210, 'lps'),
	(412140, 126, '2015-02-15 00:00:20.000000', 'consum', 0.0213, 'lps'),
	(412141, 126, '2015-02-15 00:00:21.000000', 'consum', 0.0212, 'lps'),
	(412142, 126, '2015-02-15 00:00:22.000000', 'consum', 0.0213, 'lps'),
	(412143, 126, '2015-02-15 00:00:23.000000', 'consum', 0.0220, 'lps'),
	(412144, 126, '2015-02-15 00:00:24.000000', 'consum', 0.0221, 'lps'),
	(412145, 126, '2015-02-15 00:00:25.000000', 'consum', 0.0221, 'lps'),
	(412146, 126, '2015-02-15 00:00:26.000000', 'consum', 0.0221, 'lps'),
	(412147, 126, '2015-02-15 00:00:27.000000', 'consum', 0.0220, 'lps'),
	(412148, 126, '2015-02-15 00:00:28.000000', 'consum', 0.0210, 'lps'),
	(412149, 126, '2015-02-15 00:00:29.000000', 'consum', 0.0222, 'lps'),
	(412150, 126, '2015-02-15 00:00:30.000000', 'consum', 0.0218, 'lps'),
	(412151, 126, '2015-02-15 00:00:31.000000', 'consum', 0.0212, 'lps'),
	(412152, 126, '2015-02-15 00:00:32.000000', 'consum', 0.0210, 'lps'),
	(412153, 126, '2015-02-15 00:00:33.000000', 'consum', 0.0221, 'lps'),
	(412154, 126, '2015-02-15 00:00:34.000000', 'consum', 0.0222, 'lps'),
	(412155, 126, '2015-02-15 00:00:35.000000', 'consum', 0.0210, 'lps'),
	(412156, 126, '2015-02-15 00:00:36.000000', 'consum', 0.0216, 'lps'),
	(412157, 126, '2015-02-15 00:00:37.000000', 'consum', 0.0213, 'lps'),
	(412158, 126, '2015-02-15 00:00:38.000000', 'consum', 0.0219, 'lps'),
	(412159, 126, '2015-02-15 00:00:39.000000', 'consum', 0.0221, 'lps'),
	(412160, 126, '2015-02-15 00:00:40.000000', 'consum', 0.0212, 'lps'),
	(412161, 126, '2015-02-15 00:00:41.000000', 'consum', 0.0213, 'lps'),
	(412162, 126, '2015-02-15 00:00:42.000000', 'consum', 0.0220, 'lps'),
	(412163, 126, '2015-02-15 00:00:43.000000', 'consum', 0.0222, 'lps'),
	(412164, 126, '2015-02-15 00:00:44.000000', 'consum', 0.0213, 'lps'),
	(412165, 126, '2015-02-15 00:00:45.000000', 'consum', 0.0219, 'lps'),
	(412166, 126, '2015-02-15 00:00:46.000000', 'consum', 0.0216, 'lps'),
	(412167, 126, '2015-02-15 00:00:47.000000', 'consum', 0.0216, 'lps'),
	(412168, 126, '2015-02-15 00:00:48.000000', 'consum', 0.0220, 'lps'),
	(412169, 126, '2015-02-15 00:00:49.000000', 'consum', 0.0215, 'lps'),
	(412170, 126, '2015-02-15 00:00:50.000000', 'consum', 0.0219, 'lps'),
	(412171, 126, '2015-02-15 00:00:51.000000', 'consum', 0.0214, 'lps'),
	(412172, 126, '2015-02-15 00:00:52.000000', 'consum', 0.0216, 'lps'),
	(412173, 126, '2015-02-15 00:00:53.000000', 'consum', 0.0215, 'lps'),
	(412174, 126, '2015-02-15 00:00:54.000000', 'consum', 0.0218, 'lps'),
	(412175, 126, '2015-02-15 00:00:55.000000', 'consum', 0.0223, 'lps'),
	(412176, 126, '2015-02-15 00:00:56.000000', 'consum', 0.0223, 'lps'),
	(412177, 126, '2015-02-15 00:00:57.000000', 'consum', 0.0223, 'lps'),
	(412178, 126, '2015-02-15 00:00:58.000000', 'consum', 0.0210, 'lps'),
	(412179, 126, '2015-02-15 00:00:59.000000', 'consum', 0.0211, 'lps'),
	(412180, 126, '2015-02-15 00:01:00.000000', 'consum', 0.0216, 'lps'),
	(412181, 126, '2015-02-15 00:01:01.000000', 'consum', 0.0222, 'lps'),
	(412182, 126, '2015-02-15 00:01:02.000000', 'consum', 0.0212, 'lps'),
	(412183, 126, '2015-02-15 00:01:03.000000', 'consum', 0.0214, 'lps'),
	(412184, 126, '2015-02-15 00:01:04.000000', 'consum', 0.0221, 'lps'),
	(412185, 126, '2015-02-15 00:01:05.000000', 'consum', 0.0215, 'lps'),
	(412186, 126, '2015-02-15 00:01:06.000000', 'consum', 0.0214, 'lps'),
	(412187, 126, '2015-02-15 00:01:07.000000', 'consum', 0.0218, 'lps'),
	(412188, 126, '2015-02-15 00:01:08.000000', 'consum', 0.0222, 'lps'),
	(412189, 126, '2015-02-15 00:01:09.000000', 'consum', 0.0220, 'lps'),
	(412190, 126, '2015-02-15 00:01:10.000000', 'consum', 0.0223, 'lps'),
	(412191, 126, '2015-02-15 00:01:11.000000', 'consum', 0.0218, 'lps'),
	(412192, 126, '2015-02-15 00:01:12.000000', 'consum', 0.0211, 'lps'),
	(412193, 126, '2015-02-15 00:01:13.000000', 'consum', 0.0220, 'lps'),
	(412194, 126, '2015-02-15 00:01:14.000000', 'consum', 0.0216, 'lps'),
	(412195, 126, '2015-02-15 00:01:15.000000', 'consum', 0.0212, 'lps'),
	(412196, 126, '2015-02-15 00:01:16.000000', 'consum', 0.0216, 'lps'),
	(412197, 126, '2015-02-15 00:01:17.000000', 'consum', 0.0219, 'lps'),
	(412198, 126, '2015-02-15 00:01:18.000000', 'consum', 0.0210, 'lps'),
	(412199, 126, '2015-02-15 00:01:19.000000', 'consum', 0.0212, 'lps'),
	(412200, 126, '2015-02-15 00:01:20.000000', 'consum', 0.0219, 'lps'),
	(412201, 126, '2015-02-15 00:01:21.000000', 'consum', 0.0221, 'lps'),
	(412202, 126, '2015-02-15 00:01:22.000000', 'consum', 0.0213, 'lps'),
	(412203, 126, '2015-02-15 00:01:23.000000', 'consum', 0.0219, 'lps'),
	(412204, 126, '2015-02-15 00:01:24.000000', 'consum', 0.0220, 'lps'),
	(412205, 126, '2015-02-15 00:01:25.000000', 'consum', 0.0220, 'lps'),
	(412206, 126, '2015-02-15 00:01:26.000000', 'consum', 0.0214, 'lps'),
	(412207, 126, '2015-02-15 00:01:27.000000', 'consum', 0.0216, 'lps'),
	(412208, 126, '2015-02-15 00:01:28.000000', 'consum', 0.0216, 'lps'),
	(412209, 126, '2015-02-15 00:01:29.000000', 'consum', 0.0222, 'lps'),
	(412210, 126, '2015-02-15 00:01:30.000000', 'consum', 0.0222, 'lps'),
	(412211, 126, '2015-02-15 00:01:31.000000', 'consum', 0.0222, 'lps'),
	(412212, 126, '2015-02-15 00:01:32.000000', 'consum', 0.0219, 'lps'),
	(412213, 126, '2015-02-15 00:01:33.000000', 'consum', 0.0221, 'lps'),
	(412214, 126, '2015-02-15 00:01:34.000000', 'consum', 0.0211, 'lps'),
	(412215, 126, '2015-02-15 00:01:35.000000', 'consum', 0.0222, 'lps'),
	(412216, 126, '2015-02-15 00:01:36.000000', 'consum', 0.0213, 'lps'),
	(412217, 126, '2015-02-15 00:01:37.000000', 'consum', 0.0215, 'lps'),
	(412218, 126, '2015-02-15 00:01:38.000000', 'consum', 0.0216, 'lps'),
	(412219, 126, '2015-02-15 00:01:39.000000', 'consum', 0.0211, 'lps'),
	(412220, 126, '2015-02-15 00:01:40.000000', 'consum', 0.0212, 'lps'),
	(412221, 126, '2015-02-15 00:01:41.000000', 'consum', 0.0215, 'lps'),
	(412222, 126, '2015-02-15 00:01:42.000000', 'consum', 0.0218, 'lps'),
	(412223, 126, '2015-02-15 00:01:43.000000', 'consum', 0.0220, 'lps'),
	(412224, 126, '2015-02-15 00:01:44.000000', 'consum', 0.0211, 'lps'),
	(412225, 126, '2015-02-15 00:01:45.000000', 'consum', 0.0211, 'lps'),
	(412226, 126, '2015-02-15 00:01:46.000000', 'consum', 0.0213, 'lps'),
	(412227, 126, '2015-02-15 00:01:47.000000', 'consum', 0.0210, 'lps'),
	(412228, 126, '2015-02-15 00:01:48.000000', 'consum', 0.0214, 'lps'),
	(412229, 126, '2015-02-15 00:01:49.000000', 'consum', 0.0216, 'lps'),
	(412230, 126, '2015-02-15 00:01:50.000000', 'consum', 0.0216, 'lps'),
	(412231, 126, '2015-02-15 00:01:51.000000', 'consum', 0.0222, 'lps'),
	(412232, 126, '2015-02-15 00:01:52.000000', 'consum', 0.0211, 'lps'),
	(412233, 126, '2015-02-15 00:01:53.000000', 'consum', 0.0223, 'lps'),
	(412234, 126, '2015-02-15 00:01:54.000000', 'consum', 0.0215, 'lps'),
	(412235, 126, '2015-02-15 00:01:55.000000', 'consum', 0.0212, 'lps'),
	(412236, 126, '2015-02-15 00:01:56.000000', 'consum', 0.0217, 'lps'),
	(412237, 126, '2015-02-15 00:01:57.000000', 'consum', 0.0211, 'lps'),
	(412238, 126, '2015-02-15 00:01:58.000000', 'consum', 0.0223, 'lps'),
	(412239, 126, '2015-02-15 00:01:59.000000', 'consum', 0.0218, 'lps'),
	(412240, 126, '2015-02-15 00:02:00.000000', 'consum', 0.0223, 'lps'),
	(412241, 126, '2015-02-15 00:02:01.000000', 'consum', 0.0210, 'lps'),
	(412242, 126, '2015-02-15 00:02:02.000000', 'consum', 0.0213, 'lps'),
	(412243, 126, '2015-02-15 00:02:03.000000', 'consum', 0.0214, 'lps'),
	(412244, 126, '2015-02-15 00:02:04.000000', 'consum', 0.0220, 'lps'),
	(412245, 126, '2015-02-15 00:02:05.000000', 'consum', 0.0221, 'lps'),
	(412246, 126, '2015-02-15 00:02:06.000000', 'consum', 0.0220, 'lps'),
	(412247, 126, '2015-02-15 00:02:07.000000', 'consum', 0.0212, 'lps'),
	(412248, 126, '2015-02-15 00:02:08.000000', 'consum', 0.0222, 'lps'),
	(412249, 126, '2015-02-15 00:02:09.000000', 'consum', 0.0220, 'lps'),
	(412250, 126, '2015-02-15 00:02:10.000000', 'consum', 0.0212, 'lps'),
	(412251, 126, '2015-02-15 00:02:11.000000', 'consum', 0.0219, 'lps'),
	(412252, 126, '2015-02-15 00:02:12.000000', 'consum', 0.0221, 'lps'),
	(412253, 126, '2015-02-15 00:02:13.000000', 'consum', 0.0212, 'lps'),
	(412254, 126, '2015-02-15 00:02:14.000000', 'consum', 0.0213, 'lps'),
	(412255, 126, '2015-02-15 00:02:15.000000', 'consum', 0.0222, 'lps'),
	(412256, 126, '2015-02-15 00:02:16.000000', 'consum', 0.0219, 'lps'),
	(412257, 126, '2015-02-15 00:02:17.000000', 'consum', 0.0218, 'lps'),
	(412258, 126, '2015-02-15 00:02:18.000000', 'consum', 0.0211, 'lps'),
	(412259, 126, '2015-02-15 00:02:19.000000', 'consum', 0.0218, 'lps'),
	(412260, 126, '2015-02-15 00:02:20.000000', 'consum', 0.0221, 'lps'),
	(412261, 126, '2015-02-15 00:02:21.000000', 'consum', 0.0211, 'lps'),
	(412262, 126, '2015-02-15 00:02:22.000000', 'consum', 0.0211, 'lps'),
	(412263, 126, '2015-02-15 00:02:23.000000', 'consum', 0.0214, 'lps'),
	(412264, 126, '2015-02-15 00:02:24.000000', 'consum', 0.0212, 'lps'),
	(412265, 126, '2015-02-15 00:02:25.000000', 'consum', 0.0210, 'lps'),
	(412266, 126, '2015-02-15 00:02:26.000000', 'consum', 0.0217, 'lps'),
	(412267, 126, '2015-02-15 00:02:27.000000', 'consum', 0.0218, 'lps'),
	(412268, 126, '2015-02-15 00:02:28.000000', 'consum', 0.0214, 'lps'),
	(412269, 126, '2015-02-15 00:02:29.000000', 'consum', 0.0222, 'lps'),
	(412270, 126, '2015-02-15 00:02:30.000000', 'consum', 0.0218, 'lps'),
	(412271, 126, '2015-02-15 00:02:31.000000', 'consum', 0.0212, 'lps'),
	(412272, 126, '2015-02-15 00:02:32.000000', 'consum', 0.0212, 'lps'),
	(412273, 126, '2015-02-15 00:02:33.000000', 'consum', 0.0216, 'lps'),
	(412274, 126, '2015-02-15 00:02:34.000000', 'consum', 0.0219, 'lps'),
	(412275, 126, '2015-02-15 00:02:35.000000', 'consum', 0.0211, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(412276, 126, '2015-02-15 00:02:36.000000', 'consum', 0.0217, 'lps'),
	(412277, 126, '2015-02-15 00:02:37.000000', 'consum', 0.0213, 'lps'),
	(412278, 126, '2015-02-15 00:02:38.000000', 'consum', 0.0217, 'lps'),
	(412279, 126, '2015-02-15 00:02:39.000000', 'consum', 0.0211, 'lps'),
	(412280, 126, '2015-02-15 00:02:40.000000', 'consum', 0.0220, 'lps'),
	(412281, 126, '2015-02-15 00:02:41.000000', 'consum', 0.0216, 'lps'),
	(412282, 126, '2015-02-15 00:02:42.000000', 'consum', 0.0210, 'lps'),
	(412283, 126, '2015-02-15 00:02:43.000000', 'consum', 0.0222, 'lps'),
	(412284, 126, '2015-02-15 00:02:44.000000', 'consum', 0.0212, 'lps'),
	(412285, 126, '2015-02-15 00:02:45.000000', 'consum', 0.0214, 'lps'),
	(412286, 126, '2015-02-15 00:02:46.000000', 'consum', 0.0223, 'lps'),
	(412287, 126, '2015-02-15 00:02:47.000000', 'consum', 0.0211, 'lps'),
	(412288, 126, '2015-02-15 00:02:48.000000', 'consum', 0.0215, 'lps'),
	(412289, 126, '2015-02-15 00:02:49.000000', 'consum', 0.0218, 'lps'),
	(412290, 126, '2015-02-15 00:02:50.000000', 'consum', 0.0210, 'lps'),
	(412291, 126, '2015-02-15 00:02:51.000000', 'consum', 0.0214, 'lps'),
	(412292, 126, '2015-02-15 00:02:52.000000', 'consum', 0.0215, 'lps'),
	(412293, 126, '2015-02-15 00:02:53.000000', 'consum', 0.0210, 'lps'),
	(412294, 126, '2015-02-15 00:02:54.000000', 'consum', 0.0223, 'lps'),
	(412295, 126, '2015-02-15 00:02:55.000000', 'consum', 0.0218, 'lps'),
	(412296, 126, '2015-02-15 00:02:56.000000', 'consum', 0.0214, 'lps'),
	(412297, 126, '2015-02-15 00:02:57.000000', 'consum', 0.0219, 'lps'),
	(412298, 126, '2015-02-15 00:02:58.000000', 'consum', 0.0215, 'lps'),
	(412299, 126, '2015-02-15 00:02:59.000000', 'consum', 0.0211, 'lps'),
	(412300, 126, '2015-02-15 00:03:00.000000', 'consum', 0.0213, 'lps'),
	(412301, 126, '2015-02-15 00:03:01.000000', 'consum', 0.0222, 'lps'),
	(412302, 126, '2015-02-15 00:03:02.000000', 'consum', 0.0218, 'lps'),
	(412303, 126, '2015-02-15 00:03:03.000000', 'consum', 0.0217, 'lps'),
	(412304, 126, '2015-02-15 00:03:04.000000', 'consum', 0.0220, 'lps'),
	(412305, 126, '2015-02-15 00:03:05.000000', 'consum', 0.0213, 'lps'),
	(412306, 126, '2015-02-15 00:03:06.000000', 'consum', 0.0223, 'lps'),
	(412307, 126, '2015-02-15 00:03:07.000000', 'consum', 0.0223, 'lps'),
	(412308, 126, '2015-02-15 00:03:08.000000', 'consum', 0.0210, 'lps'),
	(412309, 126, '2015-02-15 00:03:09.000000', 'consum', 0.0211, 'lps'),
	(412310, 126, '2015-02-15 00:03:10.000000', 'consum', 0.0217, 'lps'),
	(412311, 126, '2015-02-15 00:03:11.000000', 'consum', 0.0216, 'lps'),
	(412312, 126, '2015-02-15 00:03:12.000000', 'consum', 0.0219, 'lps'),
	(412313, 126, '2015-02-15 00:03:13.000000', 'consum', 0.0222, 'lps'),
	(412314, 126, '2015-02-15 00:03:14.000000', 'consum', 0.0216, 'lps'),
	(412315, 126, '2015-02-15 00:03:15.000000', 'consum', 0.0219, 'lps'),
	(412316, 126, '2015-02-15 00:03:16.000000', 'consum', 0.0222, 'lps'),
	(412317, 126, '2015-02-15 00:03:17.000000', 'consum', 0.0217, 'lps'),
	(412318, 126, '2015-02-15 00:03:18.000000', 'consum', 0.0211, 'lps'),
	(412319, 126, '2015-02-15 00:03:19.000000', 'consum', 0.0221, 'lps'),
	(412320, 126, '2015-02-15 00:03:20.000000', 'consum', 0.0219, 'lps'),
	(412321, 126, '2015-02-15 00:03:21.000000', 'consum', 0.0210, 'lps'),
	(412322, 126, '2015-02-15 00:03:22.000000', 'consum', 0.0210, 'lps'),
	(412323, 126, '2015-02-15 00:03:23.000000', 'consum', 0.0213, 'lps'),
	(412324, 126, '2015-02-15 00:03:24.000000', 'consum', 0.0211, 'lps'),
	(412325, 126, '2015-02-15 00:03:25.000000', 'consum', 0.0222, 'lps'),
	(412326, 126, '2015-02-15 00:03:26.000000', 'consum', 0.0211, 'lps'),
	(412327, 126, '2015-02-15 00:03:27.000000', 'consum', 0.0221, 'lps'),
	(412328, 126, '2015-02-15 00:03:28.000000', 'consum', 0.0219, 'lps'),
	(412329, 126, '2015-02-15 00:03:29.000000', 'consum', 0.0211, 'lps'),
	(412330, 126, '2015-02-15 00:03:30.000000', 'consum', 0.0218, 'lps'),
	(412331, 126, '2015-02-15 00:03:31.000000', 'consum', 0.0216, 'lps'),
	(412332, 126, '2015-02-15 00:03:32.000000', 'consum', 0.0217, 'lps'),
	(412333, 126, '2015-02-15 00:03:33.000000', 'consum', 0.0214, 'lps'),
	(412334, 126, '2015-02-15 00:03:34.000000', 'consum', 0.0222, 'lps'),
	(412335, 126, '2015-02-15 00:03:35.000000', 'consum', 0.0218, 'lps'),
	(412336, 126, '2015-02-15 00:03:36.000000', 'consum', 0.0213, 'lps'),
	(412337, 126, '2015-02-15 00:03:37.000000', 'consum', 0.0217, 'lps'),
	(412338, 126, '2015-02-15 00:03:38.000000', 'consum', 0.0223, 'lps'),
	(412339, 126, '2015-02-15 00:03:39.000000', 'consum', 0.0212, 'lps'),
	(412340, 126, '2015-02-15 00:03:40.000000', 'consum', 0.0223, 'lps'),
	(412341, 126, '2015-02-15 00:03:41.000000', 'consum', 0.0212, 'lps'),
	(412342, 126, '2015-02-15 00:03:42.000000', 'consum', 0.0211, 'lps'),
	(412343, 126, '2015-02-15 00:03:43.000000', 'consum', 0.0222, 'lps'),
	(412344, 126, '2015-02-15 00:03:44.000000', 'consum', 0.0214, 'lps'),
	(412345, 126, '2015-02-15 00:03:45.000000', 'consum', 0.0223, 'lps'),
	(412346, 126, '2015-02-15 00:03:46.000000', 'consum', 0.0221, 'lps'),
	(412347, 126, '2015-02-15 00:03:47.000000', 'consum', 0.0211, 'lps'),
	(412348, 126, '2015-02-15 00:03:48.000000', 'consum', 0.0212, 'lps'),
	(412349, 126, '2015-02-15 00:03:49.000000', 'consum', 0.0217, 'lps'),
	(412350, 126, '2015-02-15 00:03:50.000000', 'consum', 0.0211, 'lps'),
	(412351, 126, '2015-02-15 00:03:51.000000', 'consum', 0.0211, 'lps'),
	(412352, 126, '2015-02-15 00:03:52.000000', 'consum', 0.0211, 'lps'),
	(412353, 126, '2015-02-15 00:03:53.000000', 'consum', 0.0211, 'lps'),
	(412354, 126, '2015-02-15 00:03:54.000000', 'consum', 0.0213, 'lps'),
	(412355, 126, '2015-02-15 00:03:55.000000', 'consum', 0.0210, 'lps'),
	(412356, 126, '2015-02-15 00:03:56.000000', 'consum', 0.0217, 'lps'),
	(412357, 126, '2015-02-15 00:03:57.000000', 'consum', 0.0215, 'lps'),
	(412358, 126, '2015-02-15 00:03:58.000000', 'consum', 0.0214, 'lps'),
	(412359, 126, '2015-02-15 00:03:59.000000', 'consum', 0.0216, 'lps'),
	(412360, 126, '2015-02-15 00:04:00.000000', 'consum', 0.0215, 'lps'),
	(412361, 126, '2015-02-15 00:04:01.000000', 'consum', 0.0217, 'lps'),
	(412362, 126, '2015-02-15 00:04:02.000000', 'consum', 0.0216, 'lps'),
	(412363, 126, '2015-02-15 00:04:03.000000', 'consum', 0.0219, 'lps'),
	(412364, 126, '2015-02-15 00:04:04.000000', 'consum', 0.0212, 'lps'),
	(412365, 126, '2015-02-15 00:04:05.000000', 'consum', 0.0218, 'lps'),
	(412366, 126, '2015-02-15 00:04:06.000000', 'consum', 0.0220, 'lps'),
	(412367, 126, '2015-02-15 00:04:07.000000', 'consum', 0.0222, 'lps'),
	(412368, 126, '2015-02-15 00:04:08.000000', 'consum', 0.0211, 'lps'),
	(412369, 126, '2015-02-15 00:04:09.000000', 'consum', 0.0222, 'lps'),
	(412370, 126, '2015-02-15 00:04:10.000000', 'consum', 0.0211, 'lps'),
	(412371, 126, '2015-02-15 00:04:11.000000', 'consum', 0.0210, 'lps'),
	(412372, 126, '2015-02-15 00:04:12.000000', 'consum', 0.0219, 'lps'),
	(412373, 126, '2015-02-15 00:04:13.000000', 'consum', 0.0212, 'lps'),
	(412374, 126, '2015-02-15 00:04:14.000000', 'consum', 0.0210, 'lps'),
	(412375, 126, '2015-02-15 00:04:15.000000', 'consum', 0.0220, 'lps'),
	(412376, 126, '2015-02-15 00:04:16.000000', 'consum', 0.0215, 'lps'),
	(412377, 126, '2015-02-15 00:04:17.000000', 'consum', 0.0221, 'lps'),
	(412378, 126, '2015-02-15 00:04:18.000000', 'consum', 0.0220, 'lps'),
	(412379, 126, '2015-02-15 00:04:19.000000', 'consum', 0.0217, 'lps'),
	(412380, 126, '2015-02-15 00:04:20.000000', 'consum', 0.0214, 'lps'),
	(412381, 126, '2015-02-15 00:04:21.000000', 'consum', 0.0222, 'lps'),
	(412382, 126, '2015-02-15 00:04:22.000000', 'consum', 0.0216, 'lps'),
	(412383, 126, '2015-02-15 00:04:23.000000', 'consum', 0.0219, 'lps'),
	(412384, 126, '2015-02-15 00:04:24.000000', 'consum', 0.0211, 'lps'),
	(412385, 126, '2015-02-15 00:04:25.000000', 'consum', 0.0216, 'lps'),
	(412386, 126, '2015-02-15 00:04:26.000000', 'consum', 0.0210, 'lps'),
	(412387, 126, '2015-02-15 00:04:27.000000', 'consum', 0.0221, 'lps'),
	(412388, 126, '2015-02-15 00:04:28.000000', 'consum', 0.0222, 'lps'),
	(412389, 126, '2015-02-15 00:04:29.000000', 'consum', 0.0210, 'lps'),
	(412390, 126, '2015-02-15 00:04:30.000000', 'consum', 0.0219, 'lps'),
	(412391, 126, '2015-02-15 00:04:31.000000', 'consum', 0.0211, 'lps'),
	(412392, 126, '2015-02-15 00:04:32.000000', 'consum', 0.0215, 'lps'),
	(412393, 126, '2015-02-15 00:04:33.000000', 'consum', 0.0220, 'lps'),
	(412394, 126, '2015-02-15 00:04:34.000000', 'consum', 0.0217, 'lps'),
	(412395, 126, '2015-02-15 00:04:35.000000', 'consum', 0.0215, 'lps'),
	(412396, 126, '2015-02-15 00:04:36.000000', 'consum', 0.0217, 'lps'),
	(412397, 126, '2015-02-15 00:04:37.000000', 'consum', 0.0214, 'lps'),
	(412398, 126, '2015-02-15 00:04:38.000000', 'consum', 0.0211, 'lps'),
	(412399, 126, '2015-02-15 00:04:39.000000', 'consum', 0.0215, 'lps'),
	(412400, 126, '2015-02-15 00:04:40.000000', 'consum', 0.0220, 'lps'),
	(412401, 126, '2015-02-15 00:04:41.000000', 'consum', 0.0217, 'lps'),
	(412402, 126, '2015-02-15 00:04:42.000000', 'consum', 0.0214, 'lps'),
	(412403, 126, '2015-02-15 00:04:43.000000', 'consum', 0.0223, 'lps'),
	(412404, 126, '2015-02-15 00:04:44.000000', 'consum', 0.0211, 'lps'),
	(412405, 126, '2015-02-15 00:04:45.000000', 'consum', 0.0215, 'lps'),
	(412406, 126, '2015-02-15 00:04:46.000000', 'consum', 0.0222, 'lps'),
	(412407, 126, '2015-02-15 00:04:47.000000', 'consum', 0.0211, 'lps'),
	(412408, 126, '2015-02-15 00:04:48.000000', 'consum', 0.0223, 'lps'),
	(412409, 126, '2015-02-15 00:04:49.000000', 'consum', 0.0216, 'lps'),
	(412410, 126, '2015-02-15 00:04:50.000000', 'consum', 0.0217, 'lps'),
	(412411, 126, '2015-02-15 00:04:51.000000', 'consum', 0.0210, 'lps'),
	(412412, 126, '2015-02-15 00:04:52.000000', 'consum', 0.0221, 'lps'),
	(412413, 126, '2015-02-15 00:04:53.000000', 'consum', 0.0223, 'lps'),
	(412414, 126, '2015-02-15 00:04:54.000000', 'consum', 0.0215, 'lps'),
	(412415, 126, '2015-02-15 00:04:55.000000', 'consum', 0.0212, 'lps'),
	(412416, 126, '2015-02-15 00:04:56.000000', 'consum', 0.0216, 'lps'),
	(412417, 126, '2015-02-15 00:04:57.000000', 'consum', 0.0222, 'lps'),
	(412418, 126, '2015-02-15 00:04:58.000000', 'consum', 0.0223, 'lps'),
	(412419, 126, '2015-02-15 00:04:59.000000', 'consum', 0.0214, 'lps'),
	(412420, 126, '2015-02-15 00:05:00.000000', 'consum', 0.0217, 'lps'),
	(412421, 126, '2015-02-15 00:05:01.000000', 'consum', 0.0221, 'lps'),
	(412422, 126, '2015-02-15 00:05:02.000000', 'consum', 0.0218, 'lps'),
	(412423, 126, '2015-02-15 00:05:03.000000', 'consum', 0.0214, 'lps'),
	(412424, 126, '2015-02-15 00:05:04.000000', 'consum', 0.0210, 'lps'),
	(412425, 126, '2015-02-15 00:05:05.000000', 'consum', 0.0211, 'lps'),
	(412426, 126, '2015-02-15 00:05:06.000000', 'consum', 0.0214, 'lps'),
	(412427, 126, '2015-02-15 00:05:07.000000', 'consum', 0.0214, 'lps'),
	(412428, 126, '2015-02-15 00:05:08.000000', 'consum', 0.0218, 'lps'),
	(412429, 126, '2015-02-15 00:05:09.000000', 'consum', 0.0213, 'lps'),
	(412430, 126, '2015-02-15 00:05:10.000000', 'consum', 0.0214, 'lps'),
	(412431, 126, '2015-02-15 00:05:11.000000', 'consum', 0.0220, 'lps'),
	(412432, 126, '2015-02-15 00:05:12.000000', 'consum', 0.0223, 'lps'),
	(412433, 126, '2015-02-15 00:05:13.000000', 'consum', 0.0218, 'lps'),
	(412434, 126, '2015-02-15 00:05:14.000000', 'consum', 0.0212, 'lps'),
	(412435, 126, '2015-02-15 00:05:15.000000', 'consum', 0.0222, 'lps'),
	(412436, 126, '2015-02-15 00:05:16.000000', 'consum', 0.0223, 'lps'),
	(412437, 126, '2015-02-15 00:05:17.000000', 'consum', 0.0214, 'lps'),
	(412438, 126, '2015-02-15 00:05:18.000000', 'consum', 0.0217, 'lps'),
	(412439, 126, '2015-02-15 00:05:19.000000', 'consum', 0.0221, 'lps'),
	(412440, 126, '2015-02-15 00:05:20.000000', 'consum', 0.0214, 'lps'),
	(412441, 126, '2015-02-15 00:05:21.000000', 'consum', 0.0214, 'lps'),
	(412442, 126, '2015-02-15 00:05:22.000000', 'consum', 0.0217, 'lps'),
	(412443, 126, '2015-02-15 00:05:23.000000', 'consum', 0.0219, 'lps'),
	(412444, 126, '2015-02-15 00:05:24.000000', 'consum', 0.0223, 'lps'),
	(412445, 126, '2015-02-15 00:05:25.000000', 'consum', 0.0218, 'lps'),
	(412446, 126, '2015-02-15 00:05:26.000000', 'consum', 0.0213, 'lps'),
	(412447, 126, '2015-02-15 00:05:27.000000', 'consum', 0.0214, 'lps'),
	(412448, 126, '2015-02-15 00:05:28.000000', 'consum', 0.0223, 'lps'),
	(412449, 126, '2015-02-15 00:05:29.000000', 'consum', 0.0221, 'lps'),
	(412450, 126, '2015-02-15 00:05:30.000000', 'consum', 0.0213, 'lps'),
	(412451, 126, '2015-02-15 00:05:31.000000', 'consum', 0.0219, 'lps'),
	(412452, 126, '2015-02-15 00:05:32.000000', 'consum', 0.0220, 'lps'),
	(412453, 126, '2015-02-15 00:05:33.000000', 'consum', 0.0217, 'lps'),
	(412454, 126, '2015-02-15 00:05:34.000000', 'consum', 0.0217, 'lps'),
	(412455, 126, '2015-02-15 00:05:35.000000', 'consum', 0.0213, 'lps'),
	(412456, 126, '2015-02-15 00:05:36.000000', 'consum', 0.0215, 'lps'),
	(412457, 126, '2015-02-15 00:05:37.000000', 'consum', 0.0213, 'lps'),
	(412458, 126, '2015-02-15 00:05:38.000000', 'consum', 0.0212, 'lps'),
	(412459, 126, '2015-02-15 00:05:39.000000', 'consum', 0.0211, 'lps'),
	(412460, 126, '2015-02-15 00:05:40.000000', 'consum', 0.0210, 'lps'),
	(412461, 126, '2015-02-15 00:05:41.000000', 'consum', 0.0221, 'lps'),
	(412462, 126, '2015-02-15 00:05:42.000000', 'consum', 0.0222, 'lps'),
	(412463, 126, '2015-02-15 00:05:43.000000', 'consum', 0.0211, 'lps'),
	(412464, 126, '2015-02-15 00:05:44.000000', 'consum', 0.0220, 'lps'),
	(412465, 126, '2015-02-15 00:05:45.000000', 'consum', 0.0214, 'lps'),
	(412466, 126, '2015-02-15 00:05:46.000000', 'consum', 0.0218, 'lps'),
	(412467, 126, '2015-02-15 00:05:47.000000', 'consum', 0.0221, 'lps'),
	(412468, 126, '2015-02-15 00:05:48.000000', 'consum', 0.0217, 'lps'),
	(412469, 126, '2015-02-15 00:05:49.000000', 'consum', 0.0210, 'lps'),
	(412470, 126, '2015-02-15 00:05:50.000000', 'consum', 0.0216, 'lps'),
	(412471, 126, '2015-02-15 00:05:51.000000', 'consum', 0.0216, 'lps'),
	(412472, 126, '2015-02-15 00:05:52.000000', 'consum', 0.0219, 'lps'),
	(412473, 126, '2015-02-15 00:05:53.000000', 'consum', 0.0213, 'lps'),
	(412474, 126, '2015-02-15 00:05:54.000000', 'consum', 0.0210, 'lps'),
	(412475, 126, '2015-02-15 00:05:55.000000', 'consum', 0.0218, 'lps'),
	(412476, 126, '2015-02-15 00:05:56.000000', 'consum', 0.0220, 'lps'),
	(412477, 126, '2015-02-15 00:05:57.000000', 'consum', 0.0211, 'lps'),
	(412478, 126, '2015-02-15 00:05:58.000000', 'consum', 0.0211, 'lps'),
	(412479, 126, '2015-02-15 00:05:59.000000', 'consum', 0.0211, 'lps'),
	(412480, 126, '2015-02-15 00:06:00.000000', 'consum', 0.0216, 'lps'),
	(412481, 126, '2015-02-15 00:06:01.000000', 'consum', 0.0222, 'lps'),
	(412482, 126, '2015-02-15 00:06:02.000000', 'consum', 0.0211, 'lps'),
	(412483, 126, '2015-02-15 00:06:03.000000', 'consum', 0.0221, 'lps'),
	(412484, 126, '2015-02-15 00:06:04.000000', 'consum', 0.0219, 'lps'),
	(412485, 126, '2015-02-15 00:06:05.000000', 'consum', 0.0210, 'lps'),
	(412486, 126, '2015-02-15 00:06:06.000000', 'consum', 0.0210, 'lps'),
	(412487, 126, '2015-02-15 00:06:07.000000', 'consum', 0.0213, 'lps'),
	(412488, 126, '2015-02-15 00:06:08.000000', 'consum', 0.0223, 'lps'),
	(412489, 126, '2015-02-15 00:06:09.000000', 'consum', 0.0211, 'lps'),
	(412490, 126, '2015-02-15 00:06:10.000000', 'consum', 0.0219, 'lps'),
	(412491, 126, '2015-02-15 00:06:11.000000', 'consum', 0.0211, 'lps'),
	(412492, 126, '2015-02-15 00:06:12.000000', 'consum', 0.0217, 'lps'),
	(412493, 126, '2015-02-15 00:06:13.000000', 'consum', 0.0212, 'lps'),
	(412494, 126, '2015-02-15 00:06:14.000000', 'consum', 0.0215, 'lps'),
	(412495, 126, '2015-02-15 00:06:15.000000', 'consum', 0.0215, 'lps'),
	(412496, 126, '2015-02-15 00:06:16.000000', 'consum', 0.0223, 'lps'),
	(412497, 126, '2015-02-15 00:06:17.000000', 'consum', 0.0216, 'lps'),
	(412498, 126, '2015-02-15 00:06:18.000000', 'consum', 0.0217, 'lps'),
	(412499, 126, '2015-02-15 00:06:19.000000', 'consum', 0.0211, 'lps'),
	(412500, 126, '2015-02-15 00:06:20.000000', 'consum', 0.0211, 'lps'),
	(412501, 126, '2015-02-15 00:06:21.000000', 'consum', 0.0214, 'lps'),
	(412502, 126, '2015-02-15 00:06:22.000000', 'consum', 0.0210, 'lps'),
	(412503, 126, '2015-02-15 00:06:23.000000', 'consum', 0.0215, 'lps'),
	(412504, 126, '2015-02-15 00:06:24.000000', 'consum', 0.0222, 'lps'),
	(412505, 126, '2015-02-15 00:06:25.000000', 'consum', 0.0213, 'lps'),
	(412506, 126, '2015-02-15 00:06:26.000000', 'consum', 0.0217, 'lps'),
	(412507, 126, '2015-02-15 00:06:27.000000', 'consum', 0.0223, 'lps'),
	(412508, 126, '2015-02-15 00:06:28.000000', 'consum', 0.0210, 'lps'),
	(412509, 126, '2015-02-15 00:06:29.000000', 'consum', 0.0217, 'lps'),
	(412510, 126, '2015-02-15 00:06:30.000000', 'consum', 0.0216, 'lps'),
	(412511, 126, '2015-02-15 00:06:31.000000', 'consum', 0.0220, 'lps'),
	(412512, 126, '2015-02-15 00:06:32.000000', 'consum', 0.0214, 'lps'),
	(412513, 126, '2015-02-15 00:06:33.000000', 'consum', 0.0217, 'lps'),
	(412514, 126, '2015-02-15 00:06:34.000000', 'consum', 0.0216, 'lps'),
	(412515, 126, '2015-02-15 00:06:35.000000', 'consum', 0.0223, 'lps'),
	(412516, 126, '2015-02-15 00:06:36.000000', 'consum', 0.0213, 'lps'),
	(412517, 126, '2015-02-15 00:06:37.000000', 'consum', 0.0213, 'lps'),
	(412518, 126, '2015-02-15 00:06:38.000000', 'consum', 0.0219, 'lps'),
	(412519, 126, '2015-02-15 00:06:39.000000', 'consum', 0.0219, 'lps'),
	(412520, 126, '2015-02-15 00:06:40.000000', 'consum', 0.0216, 'lps'),
	(412521, 126, '2015-02-15 00:06:41.000000', 'consum', 0.0210, 'lps'),
	(412522, 126, '2015-02-15 00:06:42.000000', 'consum', 0.0210, 'lps'),
	(412523, 126, '2015-02-15 00:06:43.000000', 'consum', 0.0222, 'lps'),
	(412524, 126, '2015-02-15 00:06:44.000000', 'consum', 0.0216, 'lps'),
	(412525, 126, '2015-02-15 00:06:45.000000', 'consum', 0.0216, 'lps'),
	(412526, 126, '2015-02-15 00:06:46.000000', 'consum', 0.0223, 'lps'),
	(412527, 126, '2015-02-15 00:06:47.000000', 'consum', 0.0218, 'lps'),
	(412528, 126, '2015-02-15 00:06:48.000000', 'consum', 0.0210, 'lps'),
	(412529, 126, '2015-02-15 00:06:49.000000', 'consum', 0.0214, 'lps'),
	(412530, 126, '2015-02-15 00:06:50.000000', 'consum', 0.0219, 'lps'),
	(412531, 126, '2015-02-15 00:06:51.000000', 'consum', 0.0214, 'lps'),
	(412532, 126, '2015-02-15 00:06:52.000000', 'consum', 0.0216, 'lps'),
	(412533, 126, '2015-02-15 00:06:53.000000', 'consum', 0.0216, 'lps'),
	(412534, 126, '2015-02-15 00:06:54.000000', 'consum', 0.0223, 'lps'),
	(412535, 126, '2015-02-15 00:06:55.000000', 'consum', 0.0216, 'lps'),
	(412536, 126, '2015-02-15 00:06:56.000000', 'consum', 0.0214, 'lps'),
	(412537, 126, '2015-02-15 00:06:57.000000', 'consum', 0.0211, 'lps'),
	(412538, 126, '2015-02-15 00:06:58.000000', 'consum', 0.0221, 'lps'),
	(412539, 126, '2015-02-15 00:06:59.000000', 'consum', 0.0219, 'lps'),
	(412540, 126, '2015-02-15 00:07:00.000000', 'consum', 0.0222, 'lps'),
	(412541, 126, '2015-02-15 00:07:01.000000', 'consum', 0.0216, 'lps'),
	(412542, 126, '2015-02-15 00:07:02.000000', 'consum', 0.0221, 'lps'),
	(412543, 126, '2015-02-15 00:07:03.000000', 'consum', 0.0216, 'lps'),
	(412544, 126, '2015-02-15 00:07:04.000000', 'consum', 0.0221, 'lps'),
	(412545, 126, '2015-02-15 00:07:05.000000', 'consum', 0.0222, 'lps'),
	(412546, 126, '2015-02-15 00:07:06.000000', 'consum', 0.0210, 'lps'),
	(412547, 126, '2015-02-15 00:07:07.000000', 'consum', 0.0213, 'lps'),
	(412548, 126, '2015-02-15 00:07:08.000000', 'consum', 0.0215, 'lps'),
	(412549, 126, '2015-02-15 00:07:09.000000', 'consum', 0.0211, 'lps'),
	(412550, 126, '2015-02-15 00:07:10.000000', 'consum', 0.0216, 'lps'),
	(412551, 126, '2015-02-15 00:07:11.000000', 'consum', 0.0210, 'lps'),
	(412552, 126, '2015-02-15 00:07:12.000000', 'consum', 0.0221, 'lps'),
	(412553, 126, '2015-02-15 00:07:13.000000', 'consum', 0.0210, 'lps'),
	(412554, 126, '2015-02-15 00:07:14.000000', 'consum', 0.0218, 'lps'),
	(412555, 126, '2015-02-15 00:07:15.000000', 'consum', 0.0223, 'lps'),
	(412556, 126, '2015-02-15 00:07:16.000000', 'consum', 0.0210, 'lps'),
	(412557, 126, '2015-02-15 00:07:17.000000', 'consum', 0.0211, 'lps'),
	(412558, 126, '2015-02-15 00:07:18.000000', 'consum', 0.0219, 'lps'),
	(412559, 126, '2015-02-15 00:07:19.000000', 'consum', 0.0222, 'lps'),
	(412560, 126, '2015-02-15 00:07:20.000000', 'consum', 0.0215, 'lps'),
	(412561, 126, '2015-02-15 00:07:21.000000', 'consum', 0.0214, 'lps'),
	(412562, 126, '2015-02-15 00:07:22.000000', 'consum', 0.0215, 'lps'),
	(412563, 126, '2015-02-15 00:07:23.000000', 'consum', 0.0211, 'lps'),
	(412564, 126, '2015-02-15 00:07:24.000000', 'consum', 0.0213, 'lps'),
	(412565, 126, '2015-02-15 00:07:25.000000', 'consum', 0.0222, 'lps'),
	(412566, 126, '2015-02-15 00:07:26.000000', 'consum', 0.0218, 'lps'),
	(412567, 126, '2015-02-15 00:07:27.000000', 'consum', 0.0217, 'lps'),
	(412568, 126, '2015-02-15 00:07:28.000000', 'consum', 0.0222, 'lps'),
	(412569, 126, '2015-02-15 00:07:29.000000', 'consum', 0.0223, 'lps'),
	(412570, 126, '2015-02-15 00:07:30.000000', 'consum', 0.0223, 'lps'),
	(412571, 126, '2015-02-15 00:07:31.000000', 'consum', 0.0222, 'lps'),
	(412572, 126, '2015-02-15 00:07:32.000000', 'consum', 0.0217, 'lps'),
	(412573, 126, '2015-02-15 00:07:33.000000', 'consum', 0.0211, 'lps'),
	(412574, 126, '2015-02-15 00:07:34.000000', 'consum', 0.0222, 'lps'),
	(412575, 126, '2015-02-15 00:07:35.000000', 'consum', 0.0223, 'lps'),
	(412576, 126, '2015-02-15 00:07:36.000000', 'consum', 0.0215, 'lps'),
	(412577, 126, '2015-02-15 00:07:37.000000', 'consum', 0.0223, 'lps'),
	(412578, 126, '2015-02-15 00:07:38.000000', 'consum', 0.0221, 'lps'),
	(412579, 126, '2015-02-15 00:07:39.000000', 'consum', 0.0210, 'lps'),
	(412580, 126, '2015-02-15 00:07:40.000000', 'consum', 0.0220, 'lps'),
	(412581, 126, '2015-02-15 00:07:41.000000', 'consum', 0.0219, 'lps'),
	(412582, 126, '2015-02-15 00:07:42.000000', 'consum', 0.0210, 'lps'),
	(412583, 126, '2015-02-15 00:07:43.000000', 'consum', 0.0212, 'lps'),
	(412584, 126, '2015-02-15 00:07:44.000000', 'consum', 0.0221, 'lps'),
	(412585, 126, '2015-02-15 00:07:45.000000', 'consum', 0.0217, 'lps'),
	(412586, 126, '2015-02-15 00:07:46.000000', 'consum', 0.0211, 'lps'),
	(412587, 126, '2015-02-15 00:07:47.000000', 'consum', 0.0210, 'lps'),
	(412588, 126, '2015-02-15 00:07:48.000000', 'consum', 0.0221, 'lps'),
	(412589, 126, '2015-02-15 00:07:49.000000', 'consum', 0.0223, 'lps'),
	(412590, 126, '2015-02-15 00:07:50.000000', 'consum', 0.0217, 'lps'),
	(412591, 126, '2015-02-15 00:07:51.000000', 'consum', 0.0220, 'lps'),
	(412592, 126, '2015-02-15 00:07:52.000000', 'consum', 0.0210, 'lps'),
	(412593, 126, '2015-02-15 00:07:53.000000', 'consum', 0.0221, 'lps'),
	(412594, 126, '2015-02-15 00:07:54.000000', 'consum', 0.0212, 'lps'),
	(412595, 126, '2015-02-15 00:07:55.000000', 'consum', 0.0214, 'lps'),
	(412596, 126, '2015-02-15 00:07:56.000000', 'consum', 0.0223, 'lps'),
	(412597, 126, '2015-02-15 00:07:57.000000', 'consum', 0.0223, 'lps'),
	(412598, 126, '2015-02-15 00:07:58.000000', 'consum', 0.0223, 'lps'),
	(412599, 126, '2015-02-15 00:07:59.000000', 'consum', 0.0220, 'lps'),
	(412600, 126, '2015-02-15 00:08:00.000000', 'consum', 0.0223, 'lps'),
	(412601, 126, '2015-02-15 00:08:01.000000', 'consum', 0.0219, 'lps'),
	(412602, 126, '2015-02-15 00:08:02.000000', 'consum', 0.0216, 'lps'),
	(412603, 126, '2015-02-15 00:08:03.000000', 'consum', 0.0214, 'lps'),
	(412604, 126, '2015-02-15 00:08:04.000000', 'consum', 0.0212, 'lps'),
	(412605, 126, '2015-02-15 00:08:05.000000', 'consum', 0.0222, 'lps'),
	(412606, 126, '2015-02-15 00:08:06.000000', 'consum', 0.0222, 'lps'),
	(412607, 126, '2015-02-15 00:08:07.000000', 'consum', 0.0221, 'lps'),
	(412608, 126, '2015-02-15 00:08:08.000000', 'consum', 0.0215, 'lps'),
	(412609, 126, '2015-02-15 00:08:09.000000', 'consum', 0.0219, 'lps'),
	(412610, 126, '2015-02-15 00:08:10.000000', 'consum', 0.0223, 'lps'),
	(412611, 126, '2015-02-15 00:08:11.000000', 'consum', 0.0222, 'lps'),
	(412612, 126, '2015-02-15 00:08:12.000000', 'consum', 0.0217, 'lps'),
	(412613, 126, '2015-02-15 00:08:13.000000', 'consum', 0.0222, 'lps'),
	(412614, 126, '2015-02-15 00:08:14.000000', 'consum', 0.0222, 'lps'),
	(412615, 126, '2015-02-15 00:08:15.000000', 'consum', 0.0219, 'lps'),
	(412616, 126, '2015-02-15 00:08:16.000000', 'consum', 0.0221, 'lps'),
	(412617, 126, '2015-02-15 00:08:17.000000', 'consum', 0.0210, 'lps'),
	(412618, 126, '2015-02-15 00:08:18.000000', 'consum', 0.0219, 'lps'),
	(412619, 126, '2015-02-15 00:08:19.000000', 'consum', 0.0215, 'lps'),
	(412620, 126, '2015-02-15 00:08:20.000000', 'consum', 0.0220, 'lps'),
	(412621, 126, '2015-02-15 00:08:21.000000', 'consum', 0.0220, 'lps'),
	(412622, 126, '2015-02-15 00:08:22.000000', 'consum', 0.0215, 'lps'),
	(412623, 126, '2015-02-15 00:08:23.000000', 'consum', 0.0220, 'lps'),
	(412624, 126, '2015-02-15 00:08:24.000000', 'consum', 0.0216, 'lps'),
	(412625, 126, '2015-02-15 00:08:25.000000', 'consum', 0.0213, 'lps'),
	(412626, 126, '2015-02-15 00:08:26.000000', 'consum', 0.0219, 'lps'),
	(412627, 126, '2015-02-15 00:08:27.000000', 'consum', 0.0222, 'lps'),
	(412628, 126, '2015-02-15 00:08:28.000000', 'consum', 0.0212, 'lps'),
	(412629, 126, '2015-02-15 00:08:29.000000', 'consum', 0.0214, 'lps'),
	(412630, 126, '2015-02-15 00:08:30.000000', 'consum', 0.0223, 'lps'),
	(412631, 126, '2015-02-15 00:08:31.000000', 'consum', 0.0222, 'lps'),
	(412632, 126, '2015-02-15 00:08:32.000000', 'consum', 0.0216, 'lps'),
	(412633, 126, '2015-02-15 00:08:33.000000', 'consum', 0.0220, 'lps'),
	(412634, 126, '2015-02-15 00:08:34.000000', 'consum', 0.0214, 'lps'),
	(412635, 126, '2015-02-15 00:08:35.000000', 'consum', 0.0214, 'lps'),
	(412636, 126, '2015-02-15 00:08:36.000000', 'consum', 0.0220, 'lps'),
	(412637, 126, '2015-02-15 00:08:37.000000', 'consum', 0.0218, 'lps'),
	(412638, 126, '2015-02-15 00:08:38.000000', 'consum', 0.0223, 'lps'),
	(412639, 126, '2015-02-15 00:08:39.000000', 'consum', 0.0210, 'lps'),
	(412640, 126, '2015-02-15 00:08:40.000000', 'consum', 0.0214, 'lps'),
	(412641, 126, '2015-02-15 00:08:41.000000', 'consum', 0.0217, 'lps'),
	(412642, 126, '2015-02-15 00:08:42.000000', 'consum', 0.0217, 'lps'),
	(412643, 126, '2015-02-15 00:08:43.000000', 'consum', 0.0210, 'lps'),
	(412644, 126, '2015-02-15 00:08:44.000000', 'consum', 0.0218, 'lps'),
	(412645, 126, '2015-02-15 00:08:45.000000', 'consum', 0.0222, 'lps'),
	(412646, 126, '2015-02-15 00:08:46.000000', 'consum', 0.0220, 'lps'),
	(412647, 126, '2015-02-15 00:08:47.000000', 'consum', 0.0222, 'lps'),
	(412648, 126, '2015-02-15 00:08:48.000000', 'consum', 0.0215, 'lps'),
	(412649, 126, '2015-02-15 00:08:49.000000', 'consum', 0.0213, 'lps'),
	(412650, 126, '2015-02-15 00:08:50.000000', 'consum', 0.0210, 'lps'),
	(412651, 126, '2015-02-15 00:08:51.000000', 'consum', 0.0214, 'lps'),
	(412652, 126, '2015-02-15 00:08:52.000000', 'consum', 0.0219, 'lps'),
	(412653, 126, '2015-02-15 00:08:53.000000', 'consum', 0.0215, 'lps'),
	(412654, 126, '2015-02-15 00:08:54.000000', 'consum', 0.0221, 'lps'),
	(412655, 126, '2015-02-15 00:08:55.000000', 'consum', 0.0211, 'lps'),
	(412656, 126, '2015-02-15 00:08:56.000000', 'consum', 0.0221, 'lps'),
	(412657, 126, '2015-02-15 00:08:57.000000', 'consum', 0.0223, 'lps'),
	(412658, 126, '2015-02-15 00:08:58.000000', 'consum', 0.0214, 'lps'),
	(412659, 126, '2015-02-15 00:08:59.000000', 'consum', 0.0219, 'lps'),
	(412660, 126, '2015-02-15 00:09:00.000000', 'consum', 0.0214, 'lps'),
	(412661, 126, '2015-02-15 00:09:01.000000', 'consum', 0.0220, 'lps'),
	(412662, 126, '2015-02-15 00:09:02.000000', 'consum', 0.0218, 'lps'),
	(412663, 126, '2015-02-15 00:09:03.000000', 'consum', 0.0221, 'lps'),
	(412664, 126, '2015-02-15 00:09:04.000000', 'consum', 0.0214, 'lps'),
	(412665, 126, '2015-02-15 00:09:05.000000', 'consum', 0.0211, 'lps'),
	(412666, 126, '2015-02-15 00:09:06.000000', 'consum', 0.0217, 'lps'),
	(412667, 126, '2015-02-15 00:09:07.000000', 'consum', 0.0214, 'lps'),
	(412668, 126, '2015-02-15 00:09:08.000000', 'consum', 0.0211, 'lps'),
	(412669, 126, '2015-02-15 00:09:09.000000', 'consum', 0.0216, 'lps'),
	(412670, 126, '2015-02-15 00:09:10.000000', 'consum', 0.0210, 'lps'),
	(412671, 126, '2015-02-15 00:09:11.000000', 'consum', 0.0223, 'lps'),
	(412672, 126, '2015-02-15 00:09:12.000000', 'consum', 0.0216, 'lps'),
	(412673, 126, '2015-02-15 00:09:13.000000', 'consum', 0.0218, 'lps'),
	(412674, 126, '2015-02-15 00:09:14.000000', 'consum', 0.0219, 'lps'),
	(412675, 126, '2015-02-15 00:09:15.000000', 'consum', 0.0216, 'lps'),
	(412676, 126, '2015-02-15 00:09:16.000000', 'consum', 0.0216, 'lps'),
	(412677, 126, '2015-02-15 00:09:17.000000', 'consum', 0.0220, 'lps'),
	(412678, 126, '2015-02-15 00:09:18.000000', 'consum', 0.0217, 'lps'),
	(412679, 126, '2015-02-15 00:09:19.000000', 'consum', 0.0213, 'lps'),
	(412680, 126, '2015-02-15 00:09:20.000000', 'consum', 0.0219, 'lps'),
	(412681, 126, '2015-02-15 00:09:21.000000', 'consum', 0.0221, 'lps'),
	(412682, 126, '2015-02-15 00:09:22.000000', 'consum', 0.0221, 'lps'),
	(412683, 126, '2015-02-15 00:09:23.000000', 'consum', 0.0220, 'lps'),
	(412684, 126, '2015-02-15 00:09:24.000000', 'consum', 0.0215, 'lps'),
	(412685, 126, '2015-02-15 00:09:25.000000', 'consum', 0.0219, 'lps'),
	(412686, 126, '2015-02-15 00:09:26.000000', 'consum', 0.0212, 'lps'),
	(412687, 126, '2015-02-15 00:09:27.000000', 'consum', 0.0223, 'lps'),
	(412688, 126, '2015-02-15 00:09:28.000000', 'consum', 0.0211, 'lps'),
	(412689, 126, '2015-02-15 00:09:29.000000', 'consum', 0.0220, 'lps'),
	(412690, 126, '2015-02-15 00:09:30.000000', 'consum', 0.0214, 'lps'),
	(412691, 126, '2015-02-15 00:09:31.000000', 'consum', 0.0213, 'lps'),
	(412692, 126, '2015-02-15 00:09:32.000000', 'consum', 0.0216, 'lps'),
	(412693, 126, '2015-02-15 00:09:33.000000', 'consum', 0.0218, 'lps'),
	(412694, 126, '2015-02-15 00:09:34.000000', 'consum', 0.0218, 'lps'),
	(412695, 126, '2015-02-15 00:09:35.000000', 'consum', 0.0213, 'lps'),
	(412696, 126, '2015-02-15 00:09:36.000000', 'consum', 0.0215, 'lps'),
	(412697, 126, '2015-02-15 00:09:37.000000', 'consum', 0.0214, 'lps'),
	(412698, 126, '2015-02-15 00:09:38.000000', 'consum', 0.0216, 'lps'),
	(412699, 126, '2015-02-15 00:09:39.000000', 'consum', 0.0215, 'lps'),
	(412700, 126, '2015-02-15 00:09:40.000000', 'consum', 0.0215, 'lps'),
	(412701, 126, '2015-02-15 00:09:41.000000', 'consum', 0.0220, 'lps'),
	(412702, 126, '2015-02-15 00:09:42.000000', 'consum', 0.0219, 'lps'),
	(412703, 126, '2015-02-15 00:09:43.000000', 'consum', 0.0210, 'lps'),
	(412704, 126, '2015-02-15 00:09:44.000000', 'consum', 0.0212, 'lps'),
	(412705, 126, '2015-02-15 00:09:45.000000', 'consum', 0.0222, 'lps'),
	(412706, 126, '2015-02-15 00:09:46.000000', 'consum', 0.0223, 'lps'),
	(412707, 126, '2015-02-15 00:09:47.000000', 'consum', 0.0210, 'lps'),
	(412708, 126, '2015-02-15 00:09:48.000000', 'consum', 0.0215, 'lps'),
	(412709, 126, '2015-02-15 00:09:49.000000', 'consum', 0.0222, 'lps'),
	(412710, 126, '2015-02-15 00:09:50.000000', 'consum', 0.0213, 'lps'),
	(412711, 126, '2015-02-15 00:09:51.000000', 'consum', 0.0216, 'lps'),
	(412712, 126, '2015-02-15 00:09:52.000000', 'consum', 0.0220, 'lps'),
	(412713, 126, '2015-02-15 00:09:53.000000', 'consum', 0.0215, 'lps'),
	(412714, 126, '2015-02-15 00:09:54.000000', 'consum', 0.0219, 'lps'),
	(412715, 126, '2015-02-15 00:09:55.000000', 'consum', 0.0211, 'lps'),
	(412716, 126, '2015-02-15 00:09:56.000000', 'consum', 0.0217, 'lps'),
	(412717, 126, '2015-02-15 00:09:57.000000', 'consum', 0.0215, 'lps'),
	(412718, 126, '2015-02-15 00:09:58.000000', 'consum', 0.0213, 'lps'),
	(412719, 126, '2015-02-15 00:09:59.000000', 'consum', 0.0212, 'lps'),
	(412720, 126, '2015-02-15 00:10:00.000000', 'consum', 0.0210, 'lps'),
	(412721, 126, '2015-02-15 00:10:01.000000', 'consum', 0.0221, 'lps'),
	(412722, 126, '2015-02-15 00:10:02.000000', 'consum', 0.0222, 'lps'),
	(412723, 126, '2015-02-15 00:10:03.000000', 'consum', 0.0222, 'lps'),
	(412724, 126, '2015-02-15 00:10:04.000000', 'consum', 0.0221, 'lps'),
	(412725, 126, '2015-02-15 00:10:05.000000', 'consum', 0.0217, 'lps'),
	(412726, 126, '2015-02-15 00:10:06.000000', 'consum', 0.0212, 'lps'),
	(412727, 126, '2015-02-15 00:10:07.000000', 'consum', 0.0212, 'lps'),
	(412728, 126, '2015-02-15 00:10:08.000000', 'consum', 0.0214, 'lps'),
	(412729, 126, '2015-02-15 00:10:09.000000', 'consum', 0.0212, 'lps'),
	(412730, 126, '2015-02-15 00:10:10.000000', 'consum', 0.0220, 'lps'),
	(412731, 126, '2015-02-15 00:10:11.000000', 'consum', 0.0215, 'lps'),
	(412732, 126, '2015-02-15 00:10:12.000000', 'consum', 0.0219, 'lps'),
	(412733, 126, '2015-02-15 00:10:13.000000', 'consum', 0.0213, 'lps'),
	(412734, 126, '2015-02-15 00:10:14.000000', 'consum', 0.0213, 'lps'),
	(412735, 126, '2015-02-15 00:10:15.000000', 'consum', 0.0217, 'lps'),
	(412736, 126, '2015-02-15 00:10:16.000000', 'consum', 0.0223, 'lps'),
	(412737, 126, '2015-02-15 00:10:17.000000', 'consum', 0.0210, 'lps'),
	(412738, 126, '2015-02-15 00:10:18.000000', 'consum', 0.0214, 'lps'),
	(412739, 126, '2015-02-15 00:10:19.000000', 'consum', 0.0215, 'lps'),
	(412740, 126, '2015-02-15 00:10:20.000000', 'consum', 0.0211, 'lps'),
	(412741, 126, '2015-02-15 00:10:21.000000', 'consum', 0.0215, 'lps'),
	(412742, 126, '2015-02-15 00:10:22.000000', 'consum', 0.0219, 'lps'),
	(412743, 126, '2015-02-15 00:10:23.000000', 'consum', 0.0210, 'lps'),
	(412744, 126, '2015-02-15 00:10:24.000000', 'consum', 0.0213, 'lps'),
	(412745, 126, '2015-02-15 00:10:25.000000', 'consum', 0.0213, 'lps'),
	(412746, 126, '2015-02-15 00:10:26.000000', 'consum', 0.0213, 'lps'),
	(412747, 126, '2015-02-15 00:10:27.000000', 'consum', 0.0220, 'lps'),
	(412748, 126, '2015-02-15 00:10:28.000000', 'consum', 0.0220, 'lps'),
	(412749, 126, '2015-02-15 00:10:29.000000', 'consum', 0.0219, 'lps'),
	(412750, 126, '2015-02-15 00:10:30.000000', 'consum', 0.0211, 'lps'),
	(412751, 126, '2015-02-15 00:10:31.000000', 'consum', 0.0217, 'lps'),
	(412752, 126, '2015-02-15 00:10:32.000000', 'consum', 0.0213, 'lps'),
	(412753, 126, '2015-02-15 00:10:33.000000', 'consum', 0.0218, 'lps'),
	(412754, 126, '2015-02-15 00:10:34.000000', 'consum', 0.0216, 'lps'),
	(412755, 126, '2015-02-15 00:10:35.000000', 'consum', 0.0214, 'lps'),
	(412756, 126, '2015-02-15 00:10:36.000000', 'consum', 0.0213, 'lps'),
	(412757, 126, '2015-02-15 00:10:37.000000', 'consum', 0.0212, 'lps'),
	(412758, 126, '2015-02-15 00:10:38.000000', 'consum', 0.0212, 'lps'),
	(412759, 126, '2015-02-15 00:10:39.000000', 'consum', 0.0215, 'lps'),
	(412760, 126, '2015-02-15 00:10:40.000000', 'consum', 0.0215, 'lps'),
	(412761, 126, '2015-02-15 00:10:41.000000', 'consum', 0.0222, 'lps'),
	(412762, 126, '2015-02-15 00:10:42.000000', 'consum', 0.0212, 'lps'),
	(412763, 126, '2015-02-15 00:10:43.000000', 'consum', 0.0214, 'lps'),
	(412764, 126, '2015-02-15 00:10:44.000000', 'consum', 0.0210, 'lps'),
	(412765, 126, '2015-02-15 00:10:45.000000', 'consum', 0.0210, 'lps'),
	(412766, 126, '2015-02-15 00:10:46.000000', 'consum', 0.0214, 'lps'),
	(412767, 126, '2015-02-15 00:10:47.000000', 'consum', 0.0215, 'lps'),
	(412768, 126, '2015-02-15 00:10:48.000000', 'consum', 0.0211, 'lps'),
	(412769, 126, '2015-02-15 00:10:49.000000', 'consum', 0.0212, 'lps'),
	(412770, 126, '2015-02-15 00:10:50.000000', 'consum', 0.0220, 'lps'),
	(412771, 126, '2015-02-15 00:10:51.000000', 'consum', 0.0211, 'lps'),
	(412772, 126, '2015-02-15 00:10:52.000000', 'consum', 0.0215, 'lps'),
	(412773, 126, '2015-02-15 00:10:53.000000', 'consum', 0.0217, 'lps'),
	(412774, 126, '2015-02-15 00:10:54.000000', 'consum', 0.0217, 'lps'),
	(412775, 126, '2015-02-15 00:10:55.000000', 'consum', 0.0211, 'lps'),
	(412776, 126, '2015-02-15 00:10:56.000000', 'consum', 0.0210, 'lps'),
	(412777, 126, '2015-02-15 00:10:57.000000', 'consum', 0.0218, 'lps'),
	(412778, 126, '2015-02-15 00:10:58.000000', 'consum', 0.0211, 'lps'),
	(412779, 126, '2015-02-15 00:10:59.000000', 'consum', 0.0221, 'lps'),
	(412780, 126, '2015-02-15 00:11:00.000000', 'consum', 0.0219, 'lps'),
	(412781, 126, '2015-02-15 00:11:01.000000', 'consum', 0.0221, 'lps'),
	(412782, 126, '2015-02-15 00:11:02.000000', 'consum', 0.0213, 'lps'),
	(412783, 126, '2015-02-15 00:11:03.000000', 'consum', 0.0221, 'lps'),
	(412784, 126, '2015-02-15 00:11:04.000000', 'consum', 0.0215, 'lps'),
	(412785, 126, '2015-02-15 00:11:05.000000', 'consum', 0.0214, 'lps'),
	(412786, 126, '2015-02-15 00:11:06.000000', 'consum', 0.0217, 'lps'),
	(412787, 126, '2015-02-15 00:11:07.000000', 'consum', 0.0221, 'lps'),
	(412788, 126, '2015-02-15 00:11:08.000000', 'consum', 0.0216, 'lps'),
	(412789, 126, '2015-02-15 00:11:09.000000', 'consum', 0.0221, 'lps'),
	(412790, 126, '2015-02-15 00:11:10.000000', 'consum', 0.0221, 'lps'),
	(412791, 126, '2015-02-15 00:11:11.000000', 'consum', 0.0218, 'lps'),
	(412792, 126, '2015-02-15 00:11:12.000000', 'consum', 0.0216, 'lps'),
	(412793, 126, '2015-02-15 00:11:13.000000', 'consum', 0.0219, 'lps'),
	(412794, 126, '2015-02-15 00:11:14.000000', 'consum', 0.0223, 'lps'),
	(412795, 126, '2015-02-15 00:11:15.000000', 'consum', 0.0220, 'lps'),
	(412796, 126, '2015-02-15 00:11:16.000000', 'consum', 0.0223, 'lps'),
	(412797, 126, '2015-02-15 00:11:17.000000', 'consum', 0.0216, 'lps'),
	(412798, 126, '2015-02-15 00:11:18.000000', 'consum', 0.0215, 'lps'),
	(412799, 126, '2015-02-15 00:11:19.000000', 'consum', 0.0218, 'lps'),
	(412800, 126, '2015-02-15 00:11:20.000000', 'consum', 0.0222, 'lps'),
	(412801, 126, '2015-02-15 00:11:21.000000', 'consum', 0.0220, 'lps'),
	(412802, 126, '2015-02-15 00:11:22.000000', 'consum', 0.0223, 'lps'),
	(412803, 126, '2015-02-15 00:11:23.000000', 'consum', 0.0219, 'lps'),
	(412804, 126, '2015-02-15 00:11:24.000000', 'consum', 0.0215, 'lps'),
	(412805, 126, '2015-02-15 00:11:25.000000', 'consum', 0.0222, 'lps'),
	(412806, 126, '2015-02-15 00:11:26.000000', 'consum', 0.0213, 'lps'),
	(412807, 126, '2015-02-15 00:11:27.000000', 'consum', 0.0217, 'lps'),
	(412808, 126, '2015-02-15 00:11:28.000000', 'consum', 0.0222, 'lps'),
	(412809, 126, '2015-02-15 00:11:29.000000', 'consum', 0.0222, 'lps'),
	(412810, 126, '2015-02-15 00:11:30.000000', 'consum', 0.0220, 'lps'),
	(412811, 126, '2015-02-15 00:11:31.000000', 'consum', 0.0210, 'lps'),
	(412812, 126, '2015-02-15 00:11:32.000000', 'consum', 0.0211, 'lps'),
	(412813, 126, '2015-02-15 00:11:33.000000', 'consum', 0.0215, 'lps'),
	(412814, 126, '2015-02-15 00:11:34.000000', 'consum', 0.0217, 'lps'),
	(412815, 126, '2015-02-15 00:11:35.000000', 'consum', 0.0216, 'lps'),
	(412816, 126, '2015-02-15 00:11:36.000000', 'consum', 0.0219, 'lps'),
	(412817, 126, '2015-02-15 00:11:37.000000', 'consum', 0.0212, 'lps'),
	(412818, 126, '2015-02-15 00:11:38.000000', 'consum', 0.0219, 'lps'),
	(412819, 126, '2015-02-15 00:11:39.000000', 'consum', 0.0223, 'lps'),
	(412820, 126, '2015-02-15 00:11:40.000000', 'consum', 0.0221, 'lps'),
	(412821, 126, '2015-02-15 00:11:41.000000', 'consum', 0.0212, 'lps'),
	(412822, 126, '2015-02-15 00:11:42.000000', 'consum', 0.0217, 'lps'),
	(412823, 126, '2015-02-15 00:11:43.000000', 'consum', 0.0210, 'lps'),
	(412824, 126, '2015-02-15 00:11:44.000000', 'consum', 0.0218, 'lps'),
	(412825, 126, '2015-02-15 00:11:45.000000', 'consum', 0.0221, 'lps'),
	(412826, 126, '2015-02-15 00:11:46.000000', 'consum', 0.0215, 'lps'),
	(412827, 126, '2015-02-15 00:11:47.000000', 'consum', 0.0214, 'lps'),
	(412828, 126, '2015-02-15 00:11:48.000000', 'consum', 0.0218, 'lps'),
	(412829, 126, '2015-02-15 00:11:49.000000', 'consum', 0.0210, 'lps'),
	(412830, 126, '2015-02-15 00:11:50.000000', 'consum', 0.0216, 'lps'),
	(412831, 126, '2015-02-15 00:11:51.000000', 'consum', 0.0212, 'lps'),
	(412832, 126, '2015-02-15 00:11:52.000000', 'consum', 0.0215, 'lps'),
	(412833, 126, '2015-02-15 00:11:53.000000', 'consum', 0.0214, 'lps'),
	(412834, 126, '2015-02-15 00:11:54.000000', 'consum', 0.0218, 'lps'),
	(412835, 126, '2015-02-15 00:11:55.000000', 'consum', 0.0212, 'lps'),
	(412836, 126, '2015-02-15 00:11:56.000000', 'consum', 0.0222, 'lps'),
	(412837, 126, '2015-02-15 00:11:57.000000', 'consum', 0.0222, 'lps'),
	(412838, 126, '2015-02-15 00:11:58.000000', 'consum', 0.0223, 'lps'),
	(412839, 126, '2015-02-15 00:11:59.000000', 'consum', 0.0210, 'lps'),
	(412840, 126, '2015-02-15 00:12:00.000000', 'consum', 0.0215, 'lps'),
	(412841, 126, '2015-02-15 00:12:01.000000', 'consum', 0.0219, 'lps'),
	(412842, 126, '2015-02-15 00:12:02.000000', 'consum', 0.0212, 'lps'),
	(412843, 126, '2015-02-15 00:12:03.000000', 'consum', 0.0210, 'lps'),
	(412844, 126, '2015-02-15 00:12:04.000000', 'consum', 0.0217, 'lps'),
	(412845, 126, '2015-02-15 00:12:05.000000', 'consum', 0.0216, 'lps'),
	(412846, 126, '2015-02-15 00:12:06.000000', 'consum', 0.0222, 'lps'),
	(412847, 126, '2015-02-15 00:12:07.000000', 'consum', 0.0210, 'lps'),
	(412848, 126, '2015-02-15 00:12:08.000000', 'consum', 0.0217, 'lps'),
	(412849, 126, '2015-02-15 00:12:09.000000', 'consum', 0.0216, 'lps'),
	(412850, 126, '2015-02-15 00:12:10.000000', 'consum', 0.0221, 'lps'),
	(412851, 126, '2015-02-15 00:12:11.000000', 'consum', 0.0217, 'lps'),
	(412852, 126, '2015-02-15 00:12:12.000000', 'consum', 0.0214, 'lps'),
	(412853, 126, '2015-02-15 00:12:13.000000', 'consum', 0.0221, 'lps'),
	(412854, 126, '2015-02-15 00:12:14.000000', 'consum', 0.0215, 'lps'),
	(412855, 126, '2015-02-15 00:12:15.000000', 'consum', 0.0215, 'lps'),
	(412856, 126, '2015-02-15 00:12:16.000000', 'consum', 0.0219, 'lps'),
	(412857, 126, '2015-02-15 00:12:17.000000', 'consum', 0.0212, 'lps'),
	(412858, 126, '2015-02-15 00:12:18.000000', 'consum', 0.0223, 'lps'),
	(412859, 126, '2015-02-15 00:12:19.000000', 'consum', 0.0212, 'lps'),
	(412860, 126, '2015-02-15 00:12:20.000000', 'consum', 0.0211, 'lps'),
	(412861, 126, '2015-02-15 00:12:21.000000', 'consum', 0.0210, 'lps'),
	(412862, 126, '2015-02-15 00:12:22.000000', 'consum', 0.0223, 'lps'),
	(412863, 126, '2015-02-15 00:12:23.000000', 'consum', 0.0216, 'lps'),
	(412864, 126, '2015-02-15 00:12:24.000000', 'consum', 0.0218, 'lps'),
	(412865, 126, '2015-02-15 00:12:25.000000', 'consum', 0.0218, 'lps'),
	(412866, 126, '2015-02-15 00:12:26.000000', 'consum', 0.0212, 'lps'),
	(412867, 126, '2015-02-15 00:12:27.000000', 'consum', 0.0213, 'lps'),
	(412868, 126, '2015-02-15 00:12:28.000000', 'consum', 0.0216, 'lps'),
	(412869, 126, '2015-02-15 00:12:29.000000', 'consum', 0.0219, 'lps'),
	(412870, 126, '2015-02-15 00:12:30.000000', 'consum', 0.0223, 'lps'),
	(412871, 126, '2015-02-15 00:12:31.000000', 'consum', 0.0222, 'lps'),
	(412872, 126, '2015-02-15 00:12:32.000000', 'consum', 0.0215, 'lps'),
	(412873, 126, '2015-02-15 00:12:33.000000', 'consum', 0.0214, 'lps'),
	(412874, 126, '2015-02-15 00:12:34.000000', 'consum', 0.0215, 'lps'),
	(412875, 126, '2015-02-15 00:12:35.000000', 'consum', 0.0212, 'lps'),
	(412876, 126, '2015-02-15 00:12:36.000000', 'consum', 0.0219, 'lps'),
	(412877, 126, '2015-02-15 00:12:37.000000', 'consum', 0.0221, 'lps'),
	(412878, 126, '2015-02-15 00:12:38.000000', 'consum', 0.0210, 'lps'),
	(412879, 126, '2015-02-15 00:12:39.000000', 'consum', 0.0219, 'lps'),
	(412880, 126, '2015-02-15 00:12:40.000000', 'consum', 0.0213, 'lps'),
	(412881, 126, '2015-02-15 00:12:41.000000', 'consum', 0.0214, 'lps'),
	(412882, 126, '2015-02-15 00:12:42.000000', 'consum', 0.0222, 'lps'),
	(412883, 126, '2015-02-15 00:12:43.000000', 'consum', 0.0218, 'lps'),
	(412884, 126, '2015-02-15 00:12:44.000000', 'consum', 0.0212, 'lps'),
	(412885, 126, '2015-02-15 00:12:45.000000', 'consum', 0.0212, 'lps'),
	(412886, 126, '2015-02-15 00:12:46.000000', 'consum', 0.0212, 'lps'),
	(412887, 126, '2015-02-15 00:12:47.000000', 'consum', 0.0215, 'lps'),
	(412888, 126, '2015-02-15 00:12:48.000000', 'consum', 0.0216, 'lps'),
	(412889, 126, '2015-02-15 00:12:49.000000', 'consum', 0.0212, 'lps'),
	(412890, 126, '2015-02-15 00:12:50.000000', 'consum', 0.0216, 'lps'),
	(412891, 126, '2015-02-15 00:12:51.000000', 'consum', 0.0221, 'lps'),
	(412892, 126, '2015-02-15 00:12:52.000000', 'consum', 0.0221, 'lps'),
	(412893, 126, '2015-02-15 00:12:53.000000', 'consum', 0.0218, 'lps'),
	(412894, 126, '2015-02-15 00:12:54.000000', 'consum', 0.0215, 'lps'),
	(412895, 126, '2015-02-15 00:12:55.000000', 'consum', 0.0213, 'lps'),
	(412896, 126, '2015-02-15 00:12:56.000000', 'consum', 0.0222, 'lps'),
	(412897, 126, '2015-02-15 00:12:57.000000', 'consum', 0.0223, 'lps'),
	(412898, 126, '2015-02-15 00:12:58.000000', 'consum', 0.0210, 'lps'),
	(412899, 126, '2015-02-15 00:12:59.000000', 'consum', 0.0214, 'lps'),
	(412900, 126, '2015-02-15 00:13:00.000000', 'consum', 0.0214, 'lps'),
	(412901, 126, '2015-02-15 00:13:01.000000', 'consum', 0.0221, 'lps'),
	(412902, 126, '2015-02-15 00:13:02.000000', 'consum', 0.0210, 'lps'),
	(412903, 126, '2015-02-15 00:13:03.000000', 'consum', 0.0219, 'lps'),
	(412904, 126, '2015-02-15 00:13:04.000000', 'consum', 0.0212, 'lps'),
	(412905, 126, '2015-02-15 00:13:05.000000', 'consum', 0.0210, 'lps'),
	(412906, 126, '2015-02-15 00:13:06.000000', 'consum', 0.0219, 'lps'),
	(412907, 126, '2015-02-15 00:13:07.000000', 'consum', 0.0211, 'lps'),
	(412908, 126, '2015-02-15 00:13:08.000000', 'consum', 0.0216, 'lps'),
	(412909, 126, '2015-02-15 00:13:09.000000', 'consum', 0.0211, 'lps'),
	(412910, 126, '2015-02-15 00:13:10.000000', 'consum', 0.0211, 'lps'),
	(412911, 126, '2015-02-15 00:13:11.000000', 'consum', 0.0212, 'lps'),
	(412912, 126, '2015-02-15 00:13:12.000000', 'consum', 0.0219, 'lps'),
	(412913, 126, '2015-02-15 00:13:13.000000', 'consum', 0.0221, 'lps'),
	(412914, 126, '2015-02-15 00:13:14.000000', 'consum', 0.0212, 'lps'),
	(412915, 126, '2015-02-15 00:13:15.000000', 'consum', 0.0212, 'lps'),
	(412916, 126, '2015-02-15 00:13:16.000000', 'consum', 0.0217, 'lps'),
	(412917, 126, '2015-02-15 00:13:17.000000', 'consum', 0.0212, 'lps'),
	(412918, 126, '2015-02-15 00:13:18.000000', 'consum', 0.0213, 'lps'),
	(412919, 126, '2015-02-15 00:13:19.000000', 'consum', 0.0219, 'lps'),
	(412920, 126, '2015-02-15 00:13:20.000000', 'consum', 0.0217, 'lps'),
	(412921, 126, '2015-02-15 00:13:21.000000', 'consum', 0.0219, 'lps'),
	(412922, 126, '2015-02-15 00:13:22.000000', 'consum', 0.0222, 'lps'),
	(412923, 126, '2015-02-15 00:13:23.000000', 'consum', 0.0215, 'lps'),
	(412924, 126, '2015-02-15 00:13:24.000000', 'consum', 0.0215, 'lps'),
	(412925, 126, '2015-02-15 00:13:25.000000', 'consum', 0.0219, 'lps'),
	(412926, 126, '2015-02-15 00:13:26.000000', 'consum', 0.0215, 'lps'),
	(412927, 126, '2015-02-15 00:13:27.000000', 'consum', 0.0219, 'lps'),
	(412928, 126, '2015-02-15 00:13:28.000000', 'consum', 0.0213, 'lps'),
	(412929, 126, '2015-02-15 00:13:29.000000', 'consum', 0.0214, 'lps'),
	(412930, 126, '2015-02-15 00:13:30.000000', 'consum', 0.0222, 'lps'),
	(412931, 126, '2015-02-15 00:13:31.000000', 'consum', 0.0216, 'lps'),
	(412932, 126, '2015-02-15 00:13:32.000000', 'consum', 0.0219, 'lps'),
	(412933, 126, '2015-02-15 00:13:33.000000', 'consum', 0.0222, 'lps'),
	(412934, 126, '2015-02-15 00:13:34.000000', 'consum', 0.0215, 'lps'),
	(412935, 126, '2015-02-15 00:13:35.000000', 'consum', 0.0214, 'lps'),
	(412936, 126, '2015-02-15 00:13:36.000000', 'consum', 0.0215, 'lps'),
	(412937, 126, '2015-02-15 00:13:37.000000', 'consum', 0.0222, 'lps'),
	(412938, 126, '2015-02-15 00:13:38.000000', 'consum', 0.0217, 'lps'),
	(412939, 126, '2015-02-15 00:13:39.000000', 'consum', 0.0222, 'lps'),
	(412940, 126, '2015-02-15 00:13:40.000000', 'consum', 0.0220, 'lps'),
	(412941, 126, '2015-02-15 00:13:41.000000', 'consum', 0.0214, 'lps'),
	(412942, 126, '2015-02-15 00:13:42.000000', 'consum', 0.0211, 'lps'),
	(412943, 126, '2015-02-15 00:13:43.000000', 'consum', 0.0220, 'lps'),
	(412944, 126, '2015-02-15 00:13:44.000000', 'consum', 0.0214, 'lps'),
	(412945, 126, '2015-02-15 00:13:45.000000', 'consum', 0.0213, 'lps'),
	(412946, 126, '2015-02-15 00:13:46.000000', 'consum', 0.0216, 'lps'),
	(412947, 126, '2015-02-15 00:13:47.000000', 'consum', 0.0218, 'lps'),
	(412948, 126, '2015-02-15 00:13:48.000000', 'consum', 0.0219, 'lps'),
	(412949, 126, '2015-02-15 00:13:49.000000', 'consum', 0.0217, 'lps'),
	(412950, 126, '2015-02-15 00:13:50.000000', 'consum', 0.0219, 'lps'),
	(412951, 126, '2015-02-15 00:13:51.000000', 'consum', 0.0218, 'lps'),
	(412952, 126, '2015-02-15 00:13:52.000000', 'consum', 0.0211, 'lps'),
	(412953, 126, '2015-02-15 00:13:53.000000', 'consum', 0.0217, 'lps'),
	(412954, 126, '2015-02-15 00:13:54.000000', 'consum', 0.0218, 'lps'),
	(412955, 126, '2015-02-15 00:13:55.000000', 'consum', 0.0214, 'lps'),
	(412956, 126, '2015-02-15 00:13:56.000000', 'consum', 0.0219, 'lps'),
	(412957, 126, '2015-02-15 00:13:57.000000', 'consum', 0.0218, 'lps'),
	(412958, 126, '2015-02-15 00:13:58.000000', 'consum', 0.0210, 'lps'),
	(412959, 126, '2015-02-15 00:13:59.000000', 'consum', 0.0213, 'lps'),
	(412960, 126, '2015-02-15 00:14:00.000000', 'consum', 0.0213, 'lps'),
	(412961, 126, '2015-02-15 00:14:01.000000', 'consum', 0.0217, 'lps'),
	(412962, 126, '2015-02-15 00:14:02.000000', 'consum', 0.0223, 'lps'),
	(412963, 126, '2015-02-15 00:14:03.000000', 'consum', 0.0212, 'lps'),
	(412964, 126, '2015-02-15 00:14:04.000000', 'consum', 0.0221, 'lps'),
	(412965, 126, '2015-02-15 00:14:05.000000', 'consum', 0.0219, 'lps'),
	(412966, 126, '2015-02-15 00:14:06.000000', 'consum', 0.0223, 'lps'),
	(412967, 126, '2015-02-15 00:14:07.000000', 'consum', 0.0221, 'lps'),
	(412968, 126, '2015-02-15 00:14:08.000000', 'consum', 0.0213, 'lps'),
	(412969, 126, '2015-02-15 00:14:09.000000', 'consum', 0.0218, 'lps'),
	(412970, 126, '2015-02-15 00:14:10.000000', 'consum', 0.0215, 'lps'),
	(412971, 126, '2015-02-15 00:14:11.000000', 'consum', 0.0211, 'lps'),
	(412972, 126, '2015-02-15 00:14:12.000000', 'consum', 0.0213, 'lps'),
	(412973, 126, '2015-02-15 00:14:13.000000', 'consum', 0.0222, 'lps'),
	(412974, 126, '2015-02-15 00:14:14.000000', 'consum', 0.0222, 'lps'),
	(412975, 126, '2015-02-15 00:14:15.000000', 'consum', 0.0220, 'lps'),
	(412976, 126, '2015-02-15 00:14:16.000000', 'consum', 0.0212, 'lps'),
	(412977, 126, '2015-02-15 00:14:17.000000', 'consum', 0.0218, 'lps'),
	(412978, 126, '2015-02-15 00:14:18.000000', 'consum', 0.0217, 'lps'),
	(412979, 126, '2015-02-15 00:14:19.000000', 'consum', 0.0221, 'lps'),
	(412980, 126, '2015-02-15 00:14:20.000000', 'consum', 0.0218, 'lps'),
	(412981, 126, '2015-02-15 00:14:21.000000', 'consum', 0.0217, 'lps'),
	(412982, 126, '2015-02-15 00:14:22.000000', 'consum', 0.0222, 'lps'),
	(412983, 126, '2015-02-15 00:14:23.000000', 'consum', 0.0219, 'lps'),
	(412984, 126, '2015-02-15 00:14:24.000000', 'consum', 0.0221, 'lps'),
	(412985, 126, '2015-02-15 00:14:25.000000', 'consum', 0.0222, 'lps'),
	(412986, 126, '2015-02-15 00:14:26.000000', 'consum', 0.0213, 'lps'),
	(412987, 126, '2015-02-15 00:14:27.000000', 'consum', 0.0216, 'lps'),
	(412988, 126, '2015-02-15 00:14:28.000000', 'consum', 0.0216, 'lps'),
	(412989, 126, '2015-02-15 00:14:29.000000', 'consum', 0.0210, 'lps'),
	(412990, 126, '2015-02-15 00:14:30.000000', 'consum', 0.0220, 'lps'),
	(412991, 126, '2015-02-15 00:14:31.000000', 'consum', 0.0218, 'lps'),
	(412992, 126, '2015-02-15 00:14:32.000000', 'consum', 0.0219, 'lps'),
	(412993, 126, '2015-02-15 00:14:33.000000', 'consum', 0.0221, 'lps'),
	(412994, 126, '2015-02-15 00:14:34.000000', 'consum', 0.0221, 'lps'),
	(412995, 126, '2015-02-15 00:14:35.000000', 'consum', 0.0221, 'lps'),
	(412996, 126, '2015-02-15 00:14:36.000000', 'consum', 0.0220, 'lps'),
	(412997, 126, '2015-02-15 00:14:37.000000', 'consum', 0.0211, 'lps'),
	(412998, 126, '2015-02-15 00:14:38.000000', 'consum', 0.0214, 'lps'),
	(412999, 126, '2015-02-15 00:14:39.000000', 'consum', 0.0215, 'lps'),
	(413000, 126, '2015-02-15 00:14:40.000000', 'consum', 0.0210, 'lps'),
	(413001, 126, '2015-02-15 00:14:41.000000', 'consum', 0.0222, 'lps'),
	(413002, 126, '2015-02-15 00:14:42.000000', 'consum', 0.0214, 'lps'),
	(413003, 126, '2015-02-15 00:14:43.000000', 'consum', 0.0210, 'lps'),
	(413004, 126, '2015-02-15 00:14:44.000000', 'consum', 0.0212, 'lps'),
	(413005, 126, '2015-02-15 00:14:45.000000', 'consum', 0.0221, 'lps'),
	(413006, 126, '2015-02-15 00:14:46.000000', 'consum', 0.0217, 'lps'),
	(413007, 126, '2015-02-15 00:14:47.000000', 'consum', 0.0213, 'lps'),
	(413008, 126, '2015-02-15 00:14:48.000000', 'consum', 0.0220, 'lps'),
	(413009, 126, '2015-02-15 00:14:49.000000', 'consum', 0.0223, 'lps'),
	(413010, 126, '2015-02-15 00:14:50.000000', 'consum', 0.0217, 'lps'),
	(413011, 126, '2015-02-15 00:14:51.000000', 'consum', 0.0222, 'lps'),
	(413012, 126, '2015-02-15 00:14:52.000000', 'consum', 0.0222, 'lps'),
	(413013, 126, '2015-02-15 00:14:53.000000', 'consum', 0.0218, 'lps'),
	(413014, 126, '2015-02-15 00:14:54.000000', 'consum', 0.0215, 'lps'),
	(413015, 126, '2015-02-15 00:14:55.000000', 'consum', 0.0214, 'lps'),
	(413016, 126, '2015-02-15 00:14:56.000000', 'consum', 0.0213, 'lps'),
	(413017, 126, '2015-02-15 00:14:57.000000', 'consum', 0.0212, 'lps'),
	(413018, 126, '2015-02-15 00:14:58.000000', 'consum', 0.0214, 'lps'),
	(413019, 126, '2015-02-15 00:14:59.000000', 'consum', 0.0212, 'lps'),
	(413020, 126, '2015-02-15 00:15:00.000000', 'consum', 0.0220, 'lps'),
	(413021, 126, '2015-02-15 00:15:01.000000', 'consum', 0.0212, 'lps'),
	(413022, 126, '2015-02-15 00:15:02.000000', 'consum', 0.0220, 'lps'),
	(413023, 126, '2015-02-15 00:15:03.000000', 'consum', 0.0214, 'lps'),
	(413024, 126, '2015-02-15 00:15:04.000000', 'consum', 0.0212, 'lps'),
	(413025, 126, '2015-02-15 00:15:05.000000', 'consum', 0.0211, 'lps'),
	(413026, 126, '2015-02-15 00:15:06.000000', 'consum', 0.0223, 'lps'),
	(413027, 126, '2015-02-15 00:15:07.000000', 'consum', 0.0216, 'lps'),
	(413028, 126, '2015-02-15 00:15:08.000000', 'consum', 0.0217, 'lps'),
	(413029, 126, '2015-02-15 00:15:09.000000', 'consum', 0.0211, 'lps'),
	(413030, 126, '2015-02-15 00:15:10.000000', 'consum', 0.0211, 'lps'),
	(413031, 126, '2015-02-15 00:15:11.000000', 'consum', 0.0212, 'lps'),
	(413032, 126, '2015-02-15 00:15:12.000000', 'consum', 0.0216, 'lps'),
	(413033, 126, '2015-02-15 00:15:13.000000', 'consum', 0.0220, 'lps'),
	(413034, 126, '2015-02-15 00:15:14.000000', 'consum', 0.0216, 'lps'),
	(413035, 126, '2015-02-15 00:15:15.000000', 'consum', 0.0223, 'lps'),
	(413036, 126, '2015-02-15 00:15:16.000000', 'consum', 0.0217, 'lps'),
	(413037, 126, '2015-02-15 00:15:17.000000', 'consum', 0.0220, 'lps'),
	(413038, 126, '2015-02-15 00:15:18.000000', 'consum', 0.0213, 'lps'),
	(413039, 126, '2015-02-15 00:15:19.000000', 'consum', 0.0223, 'lps'),
	(413040, 126, '2015-02-15 00:15:20.000000', 'consum', 0.0212, 'lps'),
	(413041, 126, '2015-02-15 00:15:21.000000', 'consum', 0.0222, 'lps'),
	(413042, 126, '2015-02-15 00:15:22.000000', 'consum', 0.0222, 'lps'),
	(413043, 126, '2015-02-15 00:15:23.000000', 'consum', 0.0221, 'lps'),
	(413044, 126, '2015-02-15 00:15:24.000000', 'consum', 0.0216, 'lps'),
	(413045, 126, '2015-02-15 00:15:25.000000', 'consum', 0.0221, 'lps'),
	(413046, 126, '2015-02-15 00:15:26.000000', 'consum', 0.0220, 'lps'),
	(413047, 126, '2015-02-15 00:15:27.000000', 'consum', 0.0212, 'lps'),
	(413048, 126, '2015-02-15 00:15:28.000000', 'consum', 0.0218, 'lps'),
	(413049, 126, '2015-02-15 00:15:29.000000', 'consum', 0.0216, 'lps'),
	(413050, 126, '2015-02-15 00:15:30.000000', 'consum', 0.0216, 'lps'),
	(413051, 126, '2015-02-15 00:15:31.000000', 'consum', 0.0222, 'lps'),
	(413052, 126, '2015-02-15 00:15:32.000000', 'consum', 0.0210, 'lps'),
	(413053, 126, '2015-02-15 00:15:33.000000', 'consum', 0.0216, 'lps'),
	(413054, 126, '2015-02-15 00:15:34.000000', 'consum', 0.0213, 'lps'),
	(413055, 126, '2015-02-15 00:15:35.000000', 'consum', 0.0210, 'lps'),
	(413056, 126, '2015-02-15 00:15:36.000000', 'consum', 0.0213, 'lps'),
	(413057, 126, '2015-02-15 00:15:37.000000', 'consum', 0.0211, 'lps'),
	(413058, 126, '2015-02-15 00:15:38.000000', 'consum', 0.0222, 'lps'),
	(413059, 126, '2015-02-15 00:15:39.000000', 'consum', 0.0223, 'lps'),
	(413060, 126, '2015-02-15 00:15:40.000000', 'consum', 0.0214, 'lps'),
	(413061, 126, '2015-02-15 00:15:41.000000', 'consum', 0.0217, 'lps'),
	(413062, 126, '2015-02-15 00:15:42.000000', 'consum', 0.0221, 'lps'),
	(413063, 126, '2015-02-15 00:15:43.000000', 'consum', 0.0215, 'lps'),
	(413064, 126, '2015-02-15 00:15:44.000000', 'consum', 0.0215, 'lps'),
	(413065, 126, '2015-02-15 00:15:45.000000', 'consum', 0.0210, 'lps'),
	(413066, 126, '2015-02-15 00:15:46.000000', 'consum', 0.0223, 'lps'),
	(413067, 126, '2015-02-15 00:15:47.000000', 'consum', 0.0217, 'lps'),
	(413068, 126, '2015-02-15 00:15:48.000000', 'consum', 0.0221, 'lps'),
	(413069, 126, '2015-02-15 00:15:49.000000', 'consum', 0.0217, 'lps'),
	(413070, 126, '2015-02-15 00:15:50.000000', 'consum', 0.0215, 'lps'),
	(413071, 126, '2015-02-15 00:15:51.000000', 'consum', 0.0211, 'lps'),
	(413072, 126, '2015-02-15 00:15:52.000000', 'consum', 0.0218, 'lps'),
	(413073, 126, '2015-02-15 00:15:53.000000', 'consum', 0.0217, 'lps'),
	(413074, 126, '2015-02-15 00:15:54.000000', 'consum', 0.0222, 'lps'),
	(413075, 126, '2015-02-15 00:15:55.000000', 'consum', 0.0219, 'lps'),
	(413076, 126, '2015-02-15 00:15:56.000000', 'consum', 0.0223, 'lps'),
	(413077, 126, '2015-02-15 00:15:57.000000', 'consum', 0.0221, 'lps'),
	(413078, 126, '2015-02-15 00:15:58.000000', 'consum', 0.0210, 'lps'),
	(413079, 126, '2015-02-15 00:15:59.000000', 'consum', 0.0219, 'lps'),
	(413080, 126, '2015-02-15 00:16:00.000000', 'consum', 0.0217, 'lps'),
	(413081, 126, '2015-02-15 00:16:01.000000', 'consum', 0.0215, 'lps'),
	(413082, 126, '2015-02-15 00:16:02.000000', 'consum', 0.0216, 'lps'),
	(413083, 126, '2015-02-15 00:16:03.000000', 'consum', 0.0211, 'lps'),
	(413084, 126, '2015-02-15 00:16:04.000000', 'consum', 0.0214, 'lps'),
	(413085, 126, '2015-02-15 00:16:05.000000', 'consum', 0.0210, 'lps'),
	(413086, 126, '2015-02-15 00:16:06.000000', 'consum', 0.0214, 'lps'),
	(413087, 126, '2015-02-15 00:16:07.000000', 'consum', 0.0217, 'lps'),
	(413088, 126, '2015-02-15 00:16:08.000000', 'consum', 0.0220, 'lps'),
	(413089, 126, '2015-02-15 00:16:09.000000', 'consum', 0.0223, 'lps'),
	(413090, 126, '2015-02-15 00:16:10.000000', 'consum', 0.0219, 'lps'),
	(413091, 126, '2015-02-15 00:16:11.000000', 'consum', 0.0215, 'lps'),
	(413092, 126, '2015-02-15 00:16:12.000000', 'consum', 0.0221, 'lps'),
	(413093, 126, '2015-02-15 00:16:13.000000', 'consum', 0.0212, 'lps'),
	(413094, 126, '2015-02-15 00:16:14.000000', 'consum', 0.0215, 'lps'),
	(413095, 126, '2015-02-15 00:16:15.000000', 'consum', 0.0216, 'lps'),
	(413096, 126, '2015-02-15 00:16:16.000000', 'consum', 0.0210, 'lps'),
	(413097, 126, '2015-02-15 00:16:17.000000', 'consum', 0.0222, 'lps'),
	(413098, 126, '2015-02-15 00:16:18.000000', 'consum', 0.0213, 'lps'),
	(413099, 126, '2015-02-15 00:16:19.000000', 'consum', 0.0219, 'lps'),
	(413100, 126, '2015-02-15 00:16:20.000000', 'consum', 0.0218, 'lps'),
	(413101, 126, '2015-02-15 00:16:21.000000', 'consum', 0.0222, 'lps'),
	(413102, 126, '2015-02-15 00:16:22.000000', 'consum', 0.0217, 'lps'),
	(413103, 126, '2015-02-15 00:16:23.000000', 'consum', 0.0213, 'lps'),
	(413104, 126, '2015-02-15 00:16:24.000000', 'consum', 0.0218, 'lps'),
	(413105, 126, '2015-02-15 00:16:25.000000', 'consum', 0.0215, 'lps'),
	(413106, 126, '2015-02-15 00:16:26.000000', 'consum', 0.0223, 'lps'),
	(413107, 126, '2015-02-15 00:16:27.000000', 'consum', 0.0220, 'lps'),
	(413108, 126, '2015-02-15 00:16:28.000000', 'consum', 0.0220, 'lps'),
	(413109, 126, '2015-02-15 00:16:29.000000', 'consum', 0.0216, 'lps'),
	(413110, 126, '2015-02-15 00:16:30.000000', 'consum', 0.0212, 'lps'),
	(413111, 126, '2015-02-15 00:16:31.000000', 'consum', 0.0216, 'lps'),
	(413112, 126, '2015-02-15 00:16:32.000000', 'consum', 0.0218, 'lps'),
	(413113, 126, '2015-02-15 00:16:33.000000', 'consum', 0.0222, 'lps'),
	(413114, 126, '2015-02-15 00:16:34.000000', 'consum', 0.0219, 'lps'),
	(413115, 126, '2015-02-15 00:16:35.000000', 'consum', 0.0217, 'lps'),
	(413116, 126, '2015-02-15 00:16:36.000000', 'consum', 0.0221, 'lps'),
	(413117, 126, '2015-02-15 00:16:37.000000', 'consum', 0.0216, 'lps'),
	(413118, 126, '2015-02-15 00:16:38.000000', 'consum', 0.0221, 'lps'),
	(413119, 126, '2015-02-15 00:16:39.000000', 'consum', 0.0219, 'lps'),
	(413120, 126, '2015-02-15 00:16:40.000000', 'consum', 0.0223, 'lps'),
	(413121, 126, '2015-02-15 00:16:41.000000', 'consum', 0.0220, 'lps'),
	(413122, 126, '2015-02-15 00:16:42.000000', 'consum', 0.0223, 'lps'),
	(413123, 126, '2015-02-15 00:16:43.000000', 'consum', 0.0215, 'lps'),
	(413124, 126, '2015-02-15 00:16:44.000000', 'consum', 0.0210, 'lps'),
	(413125, 126, '2015-02-15 00:16:45.000000', 'consum', 0.0213, 'lps'),
	(413126, 126, '2015-02-15 00:16:46.000000', 'consum', 0.0222, 'lps'),
	(413127, 126, '2015-02-15 00:16:47.000000', 'consum', 0.0222, 'lps'),
	(413128, 126, '2015-02-15 00:16:48.000000', 'consum', 0.0220, 'lps'),
	(413129, 126, '2015-02-15 00:16:49.000000', 'consum', 0.0212, 'lps'),
	(413130, 126, '2015-02-15 00:16:50.000000', 'consum', 0.0218, 'lps'),
	(413131, 126, '2015-02-15 00:16:51.000000', 'consum', 0.0214, 'lps'),
	(413132, 126, '2015-02-15 00:16:52.000000', 'consum', 0.0223, 'lps'),
	(413133, 126, '2015-02-15 00:16:53.000000', 'consum', 0.0221, 'lps'),
	(413134, 126, '2015-02-15 00:16:54.000000', 'consum', 0.0214, 'lps'),
	(413135, 126, '2015-02-15 00:16:55.000000', 'consum', 0.0211, 'lps'),
	(413136, 126, '2015-02-15 00:16:56.000000', 'consum', 0.0217, 'lps'),
	(413137, 126, '2015-02-15 00:16:57.000000', 'consum', 0.0216, 'lps'),
	(413138, 126, '2015-02-15 00:16:58.000000', 'consum', 0.0221, 'lps'),
	(413139, 126, '2015-02-15 00:16:59.000000', 'consum', 0.0216, 'lps'),
	(413140, 126, '2015-02-15 00:17:00.000000', 'consum', 0.0221, 'lps'),
	(413141, 126, '2015-02-15 00:17:01.000000', 'consum', 0.0222, 'lps'),
	(413142, 126, '2015-02-15 00:17:02.000000', 'consum', 0.0223, 'lps'),
	(413143, 126, '2015-02-15 00:17:03.000000', 'consum', 0.0211, 'lps'),
	(413144, 126, '2015-02-15 00:17:04.000000', 'consum', 0.0220, 'lps'),
	(413145, 126, '2015-02-15 00:17:05.000000', 'consum', 0.0216, 'lps'),
	(413146, 126, '2015-02-15 00:17:06.000000', 'consum', 0.0223, 'lps'),
	(413147, 126, '2015-02-15 00:17:07.000000', 'consum', 0.0215, 'lps'),
	(413148, 126, '2015-02-15 00:17:08.000000', 'consum', 0.0213, 'lps'),
	(413149, 126, '2015-02-15 00:17:09.000000', 'consum', 0.0210, 'lps'),
	(413150, 126, '2015-02-15 00:17:10.000000', 'consum', 0.0214, 'lps'),
	(413151, 126, '2015-02-15 00:17:11.000000', 'consum', 0.0217, 'lps'),
	(413152, 126, '2015-02-15 00:17:12.000000', 'consum', 0.0218, 'lps'),
	(413153, 126, '2015-02-15 00:17:13.000000', 'consum', 0.0216, 'lps'),
	(413154, 126, '2015-02-15 00:17:14.000000', 'consum', 0.0217, 'lps'),
	(413155, 126, '2015-02-15 00:17:15.000000', 'consum', 0.0212, 'lps'),
	(413156, 126, '2015-02-15 00:17:16.000000', 'consum', 0.0214, 'lps'),
	(413157, 126, '2015-02-15 00:17:17.000000', 'consum', 0.0223, 'lps'),
	(413158, 126, '2015-02-15 00:17:18.000000', 'consum', 0.0222, 'lps'),
	(413159, 126, '2015-02-15 00:17:19.000000', 'consum', 0.0219, 'lps'),
	(413160, 126, '2015-02-15 00:17:20.000000', 'consum', 0.0220, 'lps'),
	(413161, 126, '2015-02-15 00:17:21.000000', 'consum', 0.0217, 'lps'),
	(413162, 126, '2015-02-15 00:17:22.000000', 'consum', 0.0217, 'lps'),
	(413163, 126, '2015-02-15 00:17:23.000000', 'consum', 0.0223, 'lps'),
	(413164, 126, '2015-02-15 00:17:24.000000', 'consum', 0.0212, 'lps'),
	(413165, 126, '2015-02-15 00:17:25.000000', 'consum', 0.0212, 'lps'),
	(413166, 126, '2015-02-15 00:17:26.000000', 'consum', 0.0212, 'lps'),
	(413167, 126, '2015-02-15 00:17:27.000000', 'consum', 0.0214, 'lps'),
	(413168, 126, '2015-02-15 00:17:28.000000', 'consum', 0.0212, 'lps'),
	(413169, 126, '2015-02-15 00:17:29.000000', 'consum', 0.0210, 'lps'),
	(413170, 126, '2015-02-15 00:17:30.000000', 'consum', 0.0216, 'lps'),
	(413171, 126, '2015-02-15 00:17:31.000000', 'consum', 0.0215, 'lps'),
	(413172, 126, '2015-02-15 00:17:32.000000', 'consum', 0.0215, 'lps'),
	(413173, 126, '2015-02-15 00:17:33.000000', 'consum', 0.0222, 'lps'),
	(413174, 126, '2015-02-15 00:17:34.000000', 'consum', 0.0215, 'lps'),
	(413175, 126, '2015-02-15 00:17:35.000000', 'consum', 0.0211, 'lps'),
	(413176, 126, '2015-02-15 00:17:36.000000', 'consum', 0.0217, 'lps'),
	(413177, 126, '2015-02-15 00:17:37.000000', 'consum', 0.0215, 'lps'),
	(413178, 126, '2015-02-15 00:17:38.000000', 'consum', 0.0212, 'lps'),
	(413179, 126, '2015-02-15 00:17:39.000000', 'consum', 0.0221, 'lps'),
	(413180, 126, '2015-02-15 00:17:40.000000', 'consum', 0.0216, 'lps'),
	(413181, 126, '2015-02-15 00:17:41.000000', 'consum', 0.0210, 'lps'),
	(413182, 126, '2015-02-15 00:17:42.000000', 'consum', 0.0217, 'lps'),
	(413183, 126, '2015-02-15 00:17:43.000000', 'consum', 0.0220, 'lps'),
	(413184, 126, '2015-02-15 00:17:44.000000', 'consum', 0.0213, 'lps'),
	(413185, 126, '2015-02-15 00:17:45.000000', 'consum', 0.0222, 'lps'),
	(413186, 126, '2015-02-15 00:17:46.000000', 'consum', 0.0219, 'lps'),
	(413187, 126, '2015-02-15 00:17:47.000000', 'consum', 0.0219, 'lps'),
	(413188, 126, '2015-02-15 00:17:48.000000', 'consum', 0.0217, 'lps'),
	(413189, 126, '2015-02-15 00:17:49.000000', 'consum', 0.0218, 'lps'),
	(413190, 126, '2015-02-15 00:17:50.000000', 'consum', 0.0215, 'lps'),
	(413191, 126, '2015-02-15 00:17:51.000000', 'consum', 0.0211, 'lps'),
	(413192, 126, '2015-02-15 00:17:52.000000', 'consum', 0.0215, 'lps'),
	(413193, 126, '2015-02-15 00:17:53.000000', 'consum', 0.0217, 'lps'),
	(413194, 126, '2015-02-15 00:17:54.000000', 'consum', 0.0218, 'lps'),
	(413195, 126, '2015-02-15 00:17:55.000000', 'consum', 0.0216, 'lps'),
	(413196, 126, '2015-02-15 00:17:56.000000', 'consum', 0.0217, 'lps'),
	(413197, 126, '2015-02-15 00:17:57.000000', 'consum', 0.0214, 'lps'),
	(413198, 126, '2015-02-15 00:17:58.000000', 'consum', 0.0211, 'lps'),
	(413199, 126, '2015-02-15 00:17:59.000000', 'consum', 0.0214, 'lps'),
	(413200, 126, '2015-02-15 00:18:00.000000', 'consum', 0.0214, 'lps'),
	(413201, 126, '2015-02-15 00:18:01.000000', 'consum', 0.0221, 'lps'),
	(413202, 126, '2015-02-15 00:18:02.000000', 'consum', 0.0210, 'lps'),
	(413203, 126, '2015-02-15 00:18:03.000000', 'consum', 0.0218, 'lps'),
	(413204, 126, '2015-02-15 00:18:04.000000', 'consum', 0.0223, 'lps'),
	(413205, 126, '2015-02-15 00:18:05.000000', 'consum', 0.0210, 'lps'),
	(413206, 126, '2015-02-15 00:18:06.000000', 'consum', 0.0213, 'lps'),
	(413207, 126, '2015-02-15 00:18:07.000000', 'consum', 0.0211, 'lps'),
	(413208, 126, '2015-02-15 00:18:08.000000', 'consum', 0.0222, 'lps'),
	(413209, 126, '2015-02-15 00:18:09.000000', 'consum', 0.0211, 'lps'),
	(413210, 126, '2015-02-15 00:18:10.000000', 'consum', 0.0220, 'lps'),
	(413211, 126, '2015-02-15 00:18:11.000000', 'consum', 0.0216, 'lps'),
	(413212, 126, '2015-02-15 00:18:12.000000', 'consum', 0.0223, 'lps'),
	(413213, 126, '2015-02-15 00:18:13.000000', 'consum', 0.0217, 'lps'),
	(413214, 126, '2015-02-15 00:18:14.000000', 'consum', 0.0219, 'lps'),
	(413215, 126, '2015-02-15 00:18:15.000000', 'consum', 0.0221, 'lps'),
	(413216, 126, '2015-02-15 00:18:16.000000', 'consum', 0.0212, 'lps'),
	(413217, 126, '2015-02-15 00:18:17.000000', 'consum', 0.0216, 'lps'),
	(413218, 126, '2015-02-15 00:18:18.000000', 'consum', 0.0222, 'lps'),
	(413219, 126, '2015-02-15 00:18:19.000000', 'consum', 0.0221, 'lps'),
	(413220, 126, '2015-02-15 00:18:20.000000', 'consum', 0.0217, 'lps'),
	(413221, 126, '2015-02-15 00:18:21.000000', 'consum', 0.0212, 'lps'),
	(413222, 126, '2015-02-15 00:18:22.000000', 'consum', 0.0214, 'lps'),
	(413223, 126, '2015-02-15 00:18:23.000000', 'consum', 0.0212, 'lps'),
	(413224, 126, '2015-02-15 00:18:24.000000', 'consum', 0.0222, 'lps'),
	(413225, 126, '2015-02-15 00:18:25.000000', 'consum', 0.0210, 'lps'),
	(413226, 126, '2015-02-15 00:18:26.000000', 'consum', 0.0215, 'lps'),
	(413227, 126, '2015-02-15 00:18:27.000000', 'consum', 0.0222, 'lps'),
	(413228, 126, '2015-02-15 00:18:28.000000', 'consum', 0.0213, 'lps'),
	(413229, 126, '2015-02-15 00:18:29.000000', 'consum', 0.0216, 'lps'),
	(413230, 126, '2015-02-15 00:18:30.000000', 'consum', 0.0221, 'lps'),
	(413231, 126, '2015-02-15 00:18:31.000000', 'consum', 0.0216, 'lps'),
	(413232, 126, '2015-02-15 00:18:32.000000', 'consum', 0.0223, 'lps'),
	(413233, 126, '2015-02-15 00:18:33.000000', 'consum', 0.0214, 'lps'),
	(413234, 126, '2015-02-15 00:18:34.000000', 'consum', 0.0220, 'lps'),
	(413235, 126, '2015-02-15 00:18:35.000000', 'consum', 0.0222, 'lps'),
	(413236, 126, '2015-02-15 00:18:36.000000', 'consum', 0.0212, 'lps'),
	(413237, 126, '2015-02-15 00:18:37.000000', 'consum', 0.0214, 'lps'),
	(413238, 126, '2015-02-15 00:18:38.000000', 'consum', 0.0211, 'lps'),
	(413239, 126, '2015-02-15 00:18:39.000000', 'consum', 0.0215, 'lps'),
	(413240, 126, '2015-02-15 00:18:40.000000', 'consum', 0.0219, 'lps'),
	(413241, 126, '2015-02-15 00:18:41.000000', 'consum', 0.0214, 'lps'),
	(413242, 126, '2015-02-15 00:18:42.000000', 'consum', 0.0218, 'lps'),
	(413243, 126, '2015-02-15 00:18:43.000000', 'consum', 0.0210, 'lps'),
	(413244, 126, '2015-02-15 00:18:44.000000', 'consum', 0.0213, 'lps'),
	(413245, 126, '2015-02-15 00:18:45.000000', 'consum', 0.0214, 'lps'),
	(413246, 126, '2015-02-15 00:18:46.000000', 'consum', 0.0220, 'lps'),
	(413247, 126, '2015-02-15 00:18:47.000000', 'consum', 0.0219, 'lps'),
	(413248, 126, '2015-02-15 00:18:48.000000', 'consum', 0.0215, 'lps'),
	(413249, 126, '2015-02-15 00:18:49.000000', 'consum', 0.0219, 'lps'),
	(413250, 126, '2015-02-15 00:18:50.000000', 'consum', 0.0214, 'lps'),
	(413251, 126, '2015-02-15 00:18:51.000000', 'consum', 0.0218, 'lps'),
	(413252, 126, '2015-02-15 00:18:52.000000', 'consum', 0.0222, 'lps'),
	(413253, 126, '2015-02-15 00:18:53.000000', 'consum', 0.0220, 'lps'),
	(413254, 126, '2015-02-15 00:18:54.000000', 'consum', 0.0211, 'lps'),
	(413255, 126, '2015-02-15 00:18:55.000000', 'consum', 0.0215, 'lps'),
	(413256, 126, '2015-02-15 00:18:56.000000', 'consum', 0.0218, 'lps'),
	(413257, 126, '2015-02-15 00:18:57.000000', 'consum', 0.0222, 'lps'),
	(413258, 126, '2015-02-15 00:18:58.000000', 'consum', 0.0216, 'lps'),
	(413259, 126, '2015-02-15 00:18:59.000000', 'consum', 0.0219, 'lps'),
	(413260, 126, '2015-02-15 00:19:00.000000', 'consum', 0.0212, 'lps'),
	(413261, 126, '2015-02-15 00:19:01.000000', 'consum', 0.0220, 'lps'),
	(413262, 126, '2015-02-15 00:19:02.000000', 'consum', 0.0214, 'lps'),
	(413263, 126, '2015-02-15 00:19:03.000000', 'consum', 0.0215, 'lps'),
	(413264, 126, '2015-02-15 00:19:04.000000', 'consum', 0.0223, 'lps'),
	(413265, 126, '2015-02-15 00:19:05.000000', 'consum', 0.0219, 'lps'),
	(413266, 126, '2015-02-15 00:19:06.000000', 'consum', 0.0216, 'lps'),
	(413267, 126, '2015-02-15 00:19:07.000000', 'consum', 0.0214, 'lps'),
	(413268, 126, '2015-02-15 00:19:08.000000', 'consum', 0.0213, 'lps'),
	(413269, 126, '2015-02-15 00:19:09.000000', 'consum', 0.0212, 'lps'),
	(413270, 126, '2015-02-15 00:19:10.000000', 'consum', 0.0212, 'lps'),
	(413271, 126, '2015-02-15 00:19:11.000000', 'consum', 0.0213, 'lps'),
	(413272, 126, '2015-02-15 00:19:12.000000', 'consum', 0.0222, 'lps'),
	(413273, 126, '2015-02-15 00:19:13.000000', 'consum', 0.0218, 'lps'),
	(413274, 126, '2015-02-15 00:19:14.000000', 'consum', 0.0215, 'lps'),
	(413275, 126, '2015-02-15 00:19:15.000000', 'consum', 0.0210, 'lps'),
	(413276, 126, '2015-02-15 00:19:16.000000', 'consum', 0.0212, 'lps'),
	(413277, 126, '2015-02-15 00:19:17.000000', 'consum', 0.0218, 'lps'),
	(413278, 126, '2015-02-15 00:19:18.000000', 'consum', 0.0219, 'lps'),
	(413279, 126, '2015-02-15 00:19:19.000000', 'consum', 0.0216, 'lps'),
	(413280, 126, '2015-02-15 00:19:20.000000', 'consum', 0.0212, 'lps'),
	(413281, 126, '2015-02-15 00:19:21.000000', 'consum', 0.0218, 'lps'),
	(413282, 126, '2015-02-15 00:19:22.000000', 'consum', 0.0217, 'lps'),
	(413283, 126, '2015-02-15 00:19:23.000000', 'consum', 0.0220, 'lps'),
	(413284, 126, '2015-02-15 00:19:24.000000', 'consum', 0.0211, 'lps'),
	(413285, 126, '2015-02-15 00:19:25.000000', 'consum', 0.0213, 'lps'),
	(413286, 126, '2015-02-15 00:19:26.000000', 'consum', 0.0223, 'lps'),
	(413287, 126, '2015-02-15 00:19:27.000000', 'consum', 0.0210, 'lps'),
	(413288, 126, '2015-02-15 00:19:28.000000', 'consum', 0.0213, 'lps'),
	(413289, 126, '2015-02-15 00:19:29.000000', 'consum', 0.0212, 'lps'),
	(413290, 126, '2015-02-15 00:19:30.000000', 'consum', 0.0211, 'lps'),
	(413291, 126, '2015-02-15 00:19:31.000000', 'consum', 0.0211, 'lps'),
	(413292, 126, '2015-02-15 00:19:32.000000', 'consum', 0.0213, 'lps'),
	(413293, 126, '2015-02-15 00:19:33.000000', 'consum', 0.0221, 'lps'),
	(413294, 126, '2015-02-15 00:19:34.000000', 'consum', 0.0216, 'lps'),
	(413295, 126, '2015-02-15 00:19:35.000000', 'consum', 0.0221, 'lps'),
	(413296, 126, '2015-02-15 00:19:36.000000', 'consum', 0.0219, 'lps'),
	(413297, 126, '2015-02-15 00:19:37.000000', 'consum', 0.0221, 'lps'),
	(413298, 126, '2015-02-15 00:19:38.000000', 'consum', 0.0212, 'lps'),
	(413299, 126, '2015-02-15 00:19:39.000000', 'consum', 0.0217, 'lps'),
	(413300, 126, '2015-02-15 00:19:40.000000', 'consum', 0.0211, 'lps'),
	(413301, 126, '2015-02-15 00:19:41.000000', 'consum', 0.0222, 'lps'),
	(413302, 126, '2015-02-15 00:19:42.000000', 'consum', 0.0213, 'lps'),
	(413303, 126, '2015-02-15 00:19:43.000000', 'consum', 0.0216, 'lps'),
	(413304, 126, '2015-02-15 00:19:44.000000', 'consum', 0.0216, 'lps'),
	(413305, 126, '2015-02-15 00:19:45.000000', 'consum', 0.0211, 'lps'),
	(413306, 126, '2015-02-15 00:19:46.000000', 'consum', 0.0223, 'lps'),
	(413307, 126, '2015-02-15 00:19:47.000000', 'consum', 0.0219, 'lps'),
	(413308, 126, '2015-02-15 00:19:48.000000', 'consum', 0.0216, 'lps'),
	(413309, 126, '2015-02-15 00:19:49.000000', 'consum', 0.0214, 'lps'),
	(413310, 126, '2015-02-15 00:19:50.000000', 'consum', 0.0213, 'lps'),
	(413311, 126, '2015-02-15 00:19:51.000000', 'consum', 0.0211, 'lps'),
	(413312, 126, '2015-02-15 00:19:52.000000', 'consum', 0.0221, 'lps'),
	(413313, 126, '2015-02-15 00:19:53.000000', 'consum', 0.0220, 'lps'),
	(413314, 126, '2015-02-15 00:19:54.000000', 'consum', 0.0213, 'lps'),
	(413315, 126, '2015-02-15 00:19:55.000000', 'consum', 0.0223, 'lps'),
	(413316, 126, '2015-02-15 00:19:56.000000', 'consum', 0.0211, 'lps'),
	(413317, 126, '2015-02-15 00:19:57.000000', 'consum', 0.0220, 'lps'),
	(413318, 126, '2015-02-15 00:19:58.000000', 'consum', 0.0214, 'lps'),
	(413319, 126, '2015-02-15 00:19:59.000000', 'consum', 0.0214, 'lps'),
	(413320, 126, '2015-02-15 00:20:00.000000', 'consum', 0.0221, 'lps'),
	(413321, 126, '2015-02-15 00:20:01.000000', 'consum', 0.0211, 'lps'),
	(413322, 126, '2015-02-15 00:20:02.000000', 'consum', 0.0212, 'lps'),
	(413323, 126, '2015-02-15 00:20:03.000000', 'consum', 0.0215, 'lps'),
	(413324, 126, '2015-02-15 00:20:04.000000', 'consum', 0.0218, 'lps'),
	(413325, 126, '2015-02-15 00:20:05.000000', 'consum', 0.0219, 'lps'),
	(413326, 126, '2015-02-15 00:20:06.000000', 'consum', 0.0219, 'lps'),
	(413327, 126, '2015-02-15 00:20:07.000000', 'consum', 0.0213, 'lps'),
	(413328, 126, '2015-02-15 00:20:08.000000', 'consum', 0.0215, 'lps'),
	(413329, 126, '2015-02-15 00:20:09.000000', 'consum', 0.0211, 'lps'),
	(413330, 126, '2015-02-15 00:20:10.000000', 'consum', 0.0216, 'lps'),
	(413331, 126, '2015-02-15 00:20:11.000000', 'consum', 0.0223, 'lps'),
	(413332, 126, '2015-02-15 00:20:12.000000', 'consum', 0.0214, 'lps'),
	(413333, 126, '2015-02-15 00:20:13.000000', 'consum', 0.0222, 'lps'),
	(413334, 126, '2015-02-15 00:20:14.000000', 'consum', 0.0217, 'lps'),
	(413335, 126, '2015-02-15 00:20:15.000000', 'consum', 0.0221, 'lps'),
	(413336, 126, '2015-02-15 00:20:16.000000', 'consum', 0.0218, 'lps'),
	(413337, 126, '2015-02-15 00:20:17.000000', 'consum', 0.0219, 'lps'),
	(413338, 126, '2015-02-15 00:20:18.000000', 'consum', 0.0216, 'lps'),
	(413339, 126, '2015-02-15 00:20:19.000000', 'consum', 0.0212, 'lps'),
	(413340, 126, '2015-02-15 00:20:20.000000', 'consum', 0.0217, 'lps'),
	(413341, 126, '2015-02-15 00:20:21.000000', 'consum', 0.0214, 'lps'),
	(413342, 126, '2015-02-15 00:20:22.000000', 'consum', 0.0222, 'lps'),
	(413343, 126, '2015-02-15 00:20:23.000000', 'consum', 0.0216, 'lps'),
	(413344, 126, '2015-02-15 00:20:24.000000', 'consum', 0.0219, 'lps'),
	(413345, 126, '2015-02-15 00:20:25.000000', 'consum', 0.0211, 'lps'),
	(413346, 126, '2015-02-15 00:20:26.000000', 'consum', 0.0216, 'lps'),
	(413347, 126, '2015-02-15 00:20:27.000000', 'consum', 0.0221, 'lps'),
	(413348, 126, '2015-02-15 00:20:28.000000', 'consum', 0.0223, 'lps'),
	(413349, 126, '2015-02-15 00:20:29.000000', 'consum', 0.0213, 'lps'),
	(413350, 126, '2015-02-15 00:20:30.000000', 'consum', 0.0215, 'lps'),
	(413351, 126, '2015-02-15 00:20:31.000000', 'consum', 0.0214, 'lps'),
	(413352, 126, '2015-02-15 00:20:32.000000', 'consum', 0.0215, 'lps'),
	(413353, 126, '2015-02-15 00:20:33.000000', 'consum', 0.0211, 'lps'),
	(413354, 126, '2015-02-15 00:20:34.000000', 'consum', 0.0211, 'lps'),
	(413355, 126, '2015-02-15 00:20:35.000000', 'consum', 0.0214, 'lps'),
	(413356, 126, '2015-02-15 00:20:36.000000', 'consum', 0.0214, 'lps'),
	(413357, 126, '2015-02-15 00:20:37.000000', 'consum', 0.0219, 'lps'),
	(413358, 126, '2015-02-15 00:20:38.000000', 'consum', 0.0216, 'lps'),
	(413359, 126, '2015-02-15 00:20:39.000000', 'consum', 0.0215, 'lps'),
	(413360, 126, '2015-02-15 00:20:40.000000', 'consum', 0.0215, 'lps'),
	(413361, 126, '2015-02-15 00:20:41.000000', 'consum', 0.0221, 'lps'),
	(413362, 126, '2015-02-15 00:20:42.000000', 'consum', 0.0222, 'lps'),
	(413363, 126, '2015-02-15 00:20:43.000000', 'consum', 0.0223, 'lps'),
	(413364, 126, '2015-02-15 00:20:44.000000', 'consum', 0.0211, 'lps'),
	(413365, 126, '2015-02-15 00:20:45.000000', 'consum', 0.0220, 'lps'),
	(413366, 126, '2015-02-15 00:20:46.000000', 'consum', 0.0214, 'lps'),
	(413367, 126, '2015-02-15 00:20:47.000000', 'consum', 0.0215, 'lps'),
	(413368, 126, '2015-02-15 00:20:48.000000', 'consum', 0.0210, 'lps'),
	(413369, 126, '2015-02-15 00:20:49.000000', 'consum', 0.0210, 'lps'),
	(413370, 126, '2015-02-15 00:20:50.000000', 'consum', 0.0211, 'lps'),
	(413371, 126, '2015-02-15 00:20:51.000000', 'consum', 0.0215, 'lps'),
	(413372, 126, '2015-02-15 00:20:52.000000', 'consum', 0.0218, 'lps'),
	(413373, 126, '2015-02-15 00:20:53.000000', 'consum', 0.0221, 'lps'),
	(413374, 126, '2015-02-15 00:20:54.000000', 'consum', 0.0213, 'lps'),
	(413375, 126, '2015-02-15 00:20:55.000000', 'consum', 0.0223, 'lps'),
	(413376, 126, '2015-02-15 00:20:56.000000', 'consum', 0.0222, 'lps'),
	(413377, 126, '2015-02-15 00:20:57.000000', 'consum', 0.0216, 'lps'),
	(413378, 126, '2015-02-15 00:20:58.000000', 'consum', 0.0222, 'lps'),
	(413379, 126, '2015-02-15 00:20:59.000000', 'consum', 0.0222, 'lps'),
	(413380, 126, '2015-02-15 00:21:00.000000', 'consum', 0.0222, 'lps'),
	(413381, 126, '2015-02-15 00:21:01.000000', 'consum', 0.0222, 'lps'),
	(413382, 126, '2015-02-15 00:21:02.000000', 'consum', 0.0218, 'lps'),
	(413383, 126, '2015-02-15 00:21:03.000000', 'consum', 0.0214, 'lps'),
	(413384, 126, '2015-02-15 00:21:04.000000', 'consum', 0.0223, 'lps'),
	(413385, 126, '2015-02-15 00:21:05.000000', 'consum', 0.0222, 'lps'),
	(413386, 126, '2015-02-15 00:21:06.000000', 'consum', 0.0217, 'lps'),
	(413387, 126, '2015-02-15 00:21:07.000000', 'consum', 0.0221, 'lps'),
	(413388, 126, '2015-02-15 00:21:08.000000', 'consum', 0.0220, 'lps'),
	(413389, 126, '2015-02-15 00:21:09.000000', 'consum', 0.0210, 'lps'),
	(413390, 126, '2015-02-15 00:21:10.000000', 'consum', 0.0211, 'lps'),
	(413391, 126, '2015-02-15 00:21:11.000000', 'consum', 0.0217, 'lps'),
	(413392, 126, '2015-02-15 00:21:12.000000', 'consum', 0.0212, 'lps'),
	(413393, 126, '2015-02-15 00:21:13.000000', 'consum', 0.0212, 'lps'),
	(413394, 126, '2015-02-15 00:21:14.000000', 'consum', 0.0218, 'lps'),
	(413395, 126, '2015-02-15 00:21:15.000000', 'consum', 0.0216, 'lps'),
	(413396, 126, '2015-02-15 00:21:16.000000', 'consum', 0.0214, 'lps'),
	(413397, 126, '2015-02-15 00:21:17.000000', 'consum', 0.0216, 'lps'),
	(413398, 126, '2015-02-15 00:21:18.000000', 'consum', 0.0212, 'lps'),
	(413399, 126, '2015-02-15 00:21:19.000000', 'consum', 0.0218, 'lps'),
	(413400, 126, '2015-02-15 00:21:20.000000', 'consum', 0.0217, 'lps'),
	(413401, 126, '2015-02-15 00:21:21.000000', 'consum', 0.0222, 'lps'),
	(413402, 126, '2015-02-15 00:21:22.000000', 'consum', 0.0221, 'lps'),
	(413403, 126, '2015-02-15 00:21:23.000000', 'consum', 0.0213, 'lps'),
	(413404, 126, '2015-02-15 00:21:24.000000', 'consum', 0.0210, 'lps'),
	(413405, 126, '2015-02-15 00:21:25.000000', 'consum', 0.0212, 'lps'),
	(413406, 126, '2015-02-15 00:21:26.000000', 'consum', 0.0210, 'lps'),
	(413407, 126, '2015-02-15 00:21:27.000000', 'consum', 0.0217, 'lps'),
	(413408, 126, '2015-02-15 00:21:28.000000', 'consum', 0.0217, 'lps'),
	(413409, 126, '2015-02-15 00:21:29.000000', 'consum', 0.0210, 'lps'),
	(413410, 126, '2015-02-15 00:21:30.000000', 'consum', 0.0218, 'lps'),
	(413411, 126, '2015-02-15 00:21:31.000000', 'consum', 0.0210, 'lps'),
	(413412, 126, '2015-02-15 00:21:32.000000', 'consum', 0.0212, 'lps'),
	(413413, 126, '2015-02-15 00:21:33.000000', 'consum', 0.0223, 'lps'),
	(413414, 126, '2015-02-15 00:21:34.000000', 'consum', 0.0211, 'lps'),
	(413415, 126, '2015-02-15 00:21:35.000000', 'consum', 0.0219, 'lps'),
	(413416, 126, '2015-02-15 00:21:36.000000', 'consum', 0.0211, 'lps'),
	(413417, 126, '2015-02-15 00:21:37.000000', 'consum', 0.0215, 'lps'),
	(413418, 126, '2015-02-15 00:21:38.000000', 'consum', 0.0220, 'lps'),
	(413419, 126, '2015-02-15 00:21:39.000000', 'consum', 0.0216, 'lps'),
	(413420, 126, '2015-02-15 00:21:40.000000', 'consum', 0.0210, 'lps'),
	(413421, 126, '2015-02-15 00:21:41.000000', 'consum', 0.0219, 'lps'),
	(413422, 126, '2015-02-15 00:21:42.000000', 'consum', 0.0217, 'lps'),
	(413423, 126, '2015-02-15 00:21:43.000000', 'consum', 0.0217, 'lps'),
	(413424, 126, '2015-02-15 00:21:44.000000', 'consum', 0.0211, 'lps'),
	(413425, 126, '2015-02-15 00:21:45.000000', 'consum', 0.0220, 'lps'),
	(413426, 126, '2015-02-15 00:21:46.000000', 'consum', 0.0219, 'lps'),
	(413427, 126, '2015-02-15 00:21:47.000000', 'consum', 0.0223, 'lps'),
	(413428, 126, '2015-02-15 00:21:48.000000', 'consum', 0.0223, 'lps'),
	(413429, 126, '2015-02-15 00:21:49.000000', 'consum', 0.0222, 'lps'),
	(413430, 126, '2015-02-15 00:21:50.000000', 'consum', 0.0217, 'lps'),
	(413431, 126, '2015-02-15 00:21:51.000000', 'consum', 0.0223, 'lps'),
	(413432, 126, '2015-02-15 00:21:52.000000', 'consum', 0.0213, 'lps'),
	(413433, 126, '2015-02-15 00:21:53.000000', 'consum', 0.0215, 'lps'),
	(413434, 126, '2015-02-15 00:21:54.000000', 'consum', 0.0211, 'lps'),
	(413435, 126, '2015-02-15 00:21:55.000000', 'consum', 0.0216, 'lps'),
	(413436, 126, '2015-02-15 00:21:56.000000', 'consum', 0.0211, 'lps'),
	(413437, 126, '2015-02-15 00:21:57.000000', 'consum', 0.0210, 'lps'),
	(413438, 126, '2015-02-15 00:21:58.000000', 'consum', 0.0220, 'lps'),
	(413439, 126, '2015-02-15 00:21:59.000000', 'consum', 0.0218, 'lps'),
	(413440, 126, '2015-02-15 00:22:00.000000', 'consum', 0.0220, 'lps'),
	(413441, 126, '2015-02-15 00:22:01.000000', 'consum', 0.0210, 'lps'),
	(413442, 126, '2015-02-15 00:22:02.000000', 'consum', 0.0223, 'lps'),
	(413443, 126, '2015-02-15 00:22:03.000000', 'consum', 0.0220, 'lps'),
	(413444, 126, '2015-02-15 00:22:04.000000', 'consum', 0.0222, 'lps'),
	(413445, 126, '2015-02-15 00:22:05.000000', 'consum', 0.0210, 'lps'),
	(413446, 126, '2015-02-15 00:22:06.000000', 'consum', 0.0220, 'lps'),
	(413447, 126, '2015-02-15 00:22:07.000000', 'consum', 0.0216, 'lps'),
	(413448, 126, '2015-02-15 00:22:08.000000', 'consum', 0.0223, 'lps'),
	(413449, 126, '2015-02-15 00:22:09.000000', 'consum', 0.0219, 'lps'),
	(413450, 126, '2015-02-15 00:22:10.000000', 'consum', 0.0216, 'lps'),
	(413451, 126, '2015-02-15 00:22:11.000000', 'consum', 0.0211, 'lps'),
	(413452, 126, '2015-02-15 00:22:12.000000', 'consum', 0.0212, 'lps'),
	(413453, 126, '2015-02-15 00:22:13.000000', 'consum', 0.0218, 'lps'),
	(413454, 126, '2015-02-15 00:22:14.000000', 'consum', 0.0217, 'lps'),
	(413455, 126, '2015-02-15 00:22:15.000000', 'consum', 0.0222, 'lps'),
	(413456, 126, '2015-02-15 00:22:16.000000', 'consum', 0.0222, 'lps'),
	(413457, 126, '2015-02-15 00:22:17.000000', 'consum', 0.0218, 'lps'),
	(413458, 126, '2015-02-15 00:22:18.000000', 'consum', 0.0217, 'lps'),
	(413459, 126, '2015-02-15 00:22:19.000000', 'consum', 0.0222, 'lps'),
	(413460, 126, '2015-02-15 00:22:20.000000', 'consum', 0.0218, 'lps'),
	(413461, 126, '2015-02-15 00:22:21.000000', 'consum', 0.0218, 'lps'),
	(413462, 126, '2015-02-15 00:22:22.000000', 'consum', 0.0213, 'lps'),
	(413463, 126, '2015-02-15 00:22:23.000000', 'consum', 0.0212, 'lps'),
	(413464, 126, '2015-02-15 00:22:24.000000', 'consum', 0.0215, 'lps'),
	(413465, 126, '2015-02-15 00:22:25.000000', 'consum', 0.0215, 'lps'),
	(413466, 126, '2015-02-15 00:22:26.000000', 'consum', 0.0219, 'lps'),
	(413467, 126, '2015-02-15 00:22:27.000000', 'consum', 0.0214, 'lps'),
	(413468, 126, '2015-02-15 00:22:28.000000', 'consum', 0.0219, 'lps'),
	(413469, 126, '2015-02-15 00:22:29.000000', 'consum', 0.0214, 'lps'),
	(413470, 126, '2015-02-15 00:22:30.000000', 'consum', 0.0218, 'lps'),
	(413471, 126, '2015-02-15 00:22:31.000000', 'consum', 0.0211, 'lps'),
	(413472, 126, '2015-02-15 00:22:32.000000', 'consum', 0.0217, 'lps'),
	(413473, 126, '2015-02-15 00:22:33.000000', 'consum', 0.0217, 'lps'),
	(413474, 126, '2015-02-15 00:22:34.000000', 'consum', 0.0210, 'lps'),
	(413475, 126, '2015-02-15 00:22:35.000000', 'consum', 0.0217, 'lps'),
	(413476, 126, '2015-02-15 00:22:36.000000', 'consum', 0.0218, 'lps'),
	(413477, 126, '2015-02-15 00:22:37.000000', 'consum', 0.0217, 'lps'),
	(413478, 126, '2015-02-15 00:22:38.000000', 'consum', 0.0220, 'lps'),
	(413479, 126, '2015-02-15 00:22:39.000000', 'consum', 0.0211, 'lps'),
	(413480, 126, '2015-02-15 00:22:40.000000', 'consum', 0.0212, 'lps'),
	(413481, 126, '2015-02-15 00:22:41.000000', 'consum', 0.0221, 'lps'),
	(413482, 126, '2015-02-15 00:22:42.000000', 'consum', 0.0215, 'lps'),
	(413483, 126, '2015-02-15 00:22:43.000000', 'consum', 0.0216, 'lps'),
	(413484, 126, '2015-02-15 00:22:44.000000', 'consum', 0.0213, 'lps'),
	(413485, 126, '2015-02-15 00:22:45.000000', 'consum', 0.0223, 'lps'),
	(413486, 126, '2015-02-15 00:22:46.000000', 'consum', 0.0223, 'lps'),
	(413487, 126, '2015-02-15 00:22:47.000000', 'consum', 0.0222, 'lps'),
	(413488, 126, '2015-02-15 00:22:48.000000', 'consum', 0.0218, 'lps'),
	(413489, 126, '2015-02-15 00:22:49.000000', 'consum', 0.0214, 'lps'),
	(413490, 126, '2015-02-15 00:22:50.000000', 'consum', 0.0219, 'lps'),
	(413491, 126, '2015-02-15 00:22:51.000000', 'consum', 0.0219, 'lps'),
	(413492, 126, '2015-02-15 00:22:52.000000', 'consum', 0.0211, 'lps'),
	(413493, 126, '2015-02-15 00:22:53.000000', 'consum', 0.0217, 'lps'),
	(413494, 126, '2015-02-15 00:22:54.000000', 'consum', 0.0216, 'lps'),
	(413495, 126, '2015-02-15 00:22:55.000000', 'consum', 0.0221, 'lps'),
	(413496, 126, '2015-02-15 00:22:56.000000', 'consum', 0.0217, 'lps'),
	(413497, 126, '2015-02-15 00:22:57.000000', 'consum', 0.0215, 'lps'),
	(413498, 126, '2015-02-15 00:22:58.000000', 'consum', 0.0212, 'lps'),
	(413499, 126, '2015-02-15 00:22:59.000000', 'consum', 0.0220, 'lps'),
	(413500, 126, '2015-02-15 00:23:00.000000', 'consum', 0.0211, 'lps'),
	(413501, 126, '2015-02-15 00:23:01.000000', 'consum', 0.0213, 'lps'),
	(413502, 126, '2015-02-15 00:23:02.000000', 'consum', 0.0212, 'lps'),
	(413503, 126, '2015-02-15 00:23:03.000000', 'consum', 0.0222, 'lps'),
	(413504, 126, '2015-02-15 00:23:04.000000', 'consum', 0.0210, 'lps'),
	(413505, 126, '2015-02-15 00:23:05.000000', 'consum', 0.0218, 'lps'),
	(413506, 126, '2015-02-15 00:23:06.000000', 'consum', 0.0222, 'lps'),
	(413507, 126, '2015-02-15 00:23:07.000000', 'consum', 0.0220, 'lps'),
	(413508, 126, '2015-02-15 00:23:08.000000', 'consum', 0.0210, 'lps'),
	(413509, 126, '2015-02-15 00:23:09.000000', 'consum', 0.0220, 'lps'),
	(413510, 126, '2015-02-15 00:23:10.000000', 'consum', 0.0220, 'lps'),
	(413511, 126, '2015-02-15 00:23:11.000000', 'consum', 0.0216, 'lps'),
	(413512, 126, '2015-02-15 00:23:12.000000', 'consum', 0.0212, 'lps'),
	(413513, 126, '2015-02-15 00:23:13.000000', 'consum', 0.0216, 'lps'),
	(413514, 126, '2015-02-15 00:23:14.000000', 'consum', 0.0218, 'lps'),
	(413515, 126, '2015-02-15 00:23:15.000000', 'consum', 0.0222, 'lps'),
	(413516, 126, '2015-02-15 00:23:16.000000', 'consum', 0.0218, 'lps'),
	(413517, 126, '2015-02-15 00:23:17.000000', 'consum', 0.0213, 'lps'),
	(413518, 126, '2015-02-15 00:23:18.000000', 'consum', 0.0215, 'lps'),
	(413519, 126, '2015-02-15 00:23:19.000000', 'consum', 0.0213, 'lps'),
	(413520, 126, '2015-02-15 00:23:20.000000', 'consum', 0.0211, 'lps'),
	(413521, 126, '2015-02-15 00:23:21.000000', 'consum', 0.0219, 'lps'),
	(413522, 126, '2015-02-15 00:23:22.000000', 'consum', 0.0212, 'lps'),
	(413523, 126, '2015-02-15 00:23:23.000000', 'consum', 0.0222, 'lps'),
	(413524, 126, '2015-02-15 00:23:24.000000', 'consum', 0.0221, 'lps'),
	(413525, 126, '2015-02-15 00:23:25.000000', 'consum', 0.0215, 'lps'),
	(413526, 126, '2015-02-15 00:23:26.000000', 'consum', 0.0217, 'lps'),
	(413527, 126, '2015-02-15 00:23:27.000000', 'consum', 0.0217, 'lps'),
	(413528, 126, '2015-02-15 00:23:28.000000', 'consum', 0.0210, 'lps'),
	(413529, 126, '2015-02-15 00:23:29.000000', 'consum', 0.0216, 'lps'),
	(413530, 126, '2015-02-15 00:23:30.000000', 'consum', 0.0214, 'lps'),
	(413531, 126, '2015-02-15 00:23:31.000000', 'consum', 0.0214, 'lps'),
	(413532, 126, '2015-02-15 00:23:32.000000', 'consum', 0.0215, 'lps'),
	(413533, 126, '2015-02-15 00:23:33.000000', 'consum', 0.0212, 'lps'),
	(413534, 126, '2015-02-15 00:23:34.000000', 'consum', 0.0220, 'lps'),
	(413535, 126, '2015-02-15 00:23:35.000000', 'consum', 0.0210, 'lps'),
	(413536, 126, '2015-02-15 00:23:36.000000', 'consum', 0.0212, 'lps'),
	(413537, 126, '2015-02-15 00:23:37.000000', 'consum', 0.0218, 'lps'),
	(413538, 126, '2015-02-15 00:23:38.000000', 'consum', 0.0217, 'lps'),
	(413539, 126, '2015-02-15 00:23:39.000000', 'consum', 0.0210, 'lps'),
	(413540, 126, '2015-02-15 00:23:40.000000', 'consum', 0.0214, 'lps'),
	(413541, 126, '2015-02-15 00:23:41.000000', 'consum', 0.0217, 'lps'),
	(413542, 126, '2015-02-15 00:23:42.000000', 'consum', 0.0220, 'lps'),
	(413543, 126, '2015-02-15 00:23:43.000000', 'consum', 0.0210, 'lps'),
	(413544, 126, '2015-02-15 00:23:44.000000', 'consum', 0.0212, 'lps'),
	(413545, 126, '2015-02-15 00:23:45.000000', 'consum', 0.0217, 'lps'),
	(413546, 126, '2015-02-15 00:23:46.000000', 'consum', 0.0214, 'lps'),
	(413547, 126, '2015-02-15 00:23:47.000000', 'consum', 0.0221, 'lps'),
	(413548, 126, '2015-02-15 00:23:48.000000', 'consum', 0.0211, 'lps'),
	(413549, 126, '2015-02-15 00:23:49.000000', 'consum', 0.0210, 'lps'),
	(413550, 126, '2015-02-15 00:23:50.000000', 'consum', 0.0221, 'lps'),
	(413551, 126, '2015-02-15 00:23:51.000000', 'consum', 0.0223, 'lps'),
	(413552, 126, '2015-02-15 00:23:52.000000', 'consum', 0.0217, 'lps'),
	(413553, 126, '2015-02-15 00:23:53.000000', 'consum', 0.0221, 'lps'),
	(413554, 126, '2015-02-15 00:23:54.000000', 'consum', 0.0217, 'lps'),
	(413555, 126, '2015-02-15 00:23:55.000000', 'consum', 0.0213, 'lps'),
	(413556, 126, '2015-02-15 00:23:56.000000', 'consum', 0.0218, 'lps'),
	(413557, 126, '2015-02-15 00:23:57.000000', 'consum', 0.0212, 'lps'),
	(413558, 126, '2015-02-15 00:23:58.000000', 'consum', 0.0212, 'lps'),
	(413559, 126, '2015-02-15 00:23:59.000000', 'consum', 0.0212, 'lps'),
	(413560, 126, '2015-02-15 00:24:00.000000', 'consum', 0.0217, 'lps'),
	(413561, 126, '2015-02-15 00:24:01.000000', 'consum', 0.0223, 'lps'),
	(413562, 126, '2015-02-15 00:24:02.000000', 'consum', 0.0212, 'lps'),
	(413563, 126, '2015-02-15 00:24:03.000000', 'consum', 0.0212, 'lps'),
	(413564, 126, '2015-02-15 00:24:04.000000', 'consum', 0.0213, 'lps'),
	(413565, 126, '2015-02-15 00:24:05.000000', 'consum', 0.0219, 'lps'),
	(413566, 126, '2015-02-15 00:24:06.000000', 'consum', 0.0218, 'lps'),
	(413567, 126, '2015-02-15 00:24:07.000000', 'consum', 0.0211, 'lps'),
	(413568, 126, '2015-02-15 00:24:08.000000', 'consum', 0.0221, 'lps'),
	(413569, 126, '2015-02-15 00:24:09.000000', 'consum', 0.0219, 'lps'),
	(413570, 126, '2015-02-15 00:24:10.000000', 'consum', 0.0222, 'lps'),
	(413571, 126, '2015-02-15 00:24:11.000000', 'consum', 0.0217, 'lps'),
	(413572, 126, '2015-02-15 00:24:12.000000', 'consum', 0.0222, 'lps'),
	(413573, 126, '2015-02-15 00:24:13.000000', 'consum', 0.0223, 'lps'),
	(413574, 126, '2015-02-15 00:24:14.000000', 'consum', 0.0223, 'lps'),
	(413575, 126, '2015-02-15 00:24:15.000000', 'consum', 0.0210, 'lps'),
	(413576, 126, '2015-02-15 00:24:16.000000', 'consum', 0.0212, 'lps'),
	(413577, 126, '2015-02-15 00:24:17.000000', 'consum', 0.0222, 'lps'),
	(413578, 126, '2015-02-15 00:24:18.000000', 'consum', 0.0221, 'lps'),
	(413579, 126, '2015-02-15 00:24:19.000000', 'consum', 0.0216, 'lps'),
	(413580, 126, '2015-02-15 00:24:20.000000', 'consum', 0.0220, 'lps'),
	(413581, 126, '2015-02-15 00:24:21.000000', 'consum', 0.0217, 'lps'),
	(413582, 126, '2015-02-15 00:24:22.000000', 'consum', 0.0214, 'lps'),
	(413583, 126, '2015-02-15 00:24:23.000000', 'consum', 0.0212, 'lps'),
	(413584, 126, '2015-02-15 00:24:24.000000', 'consum', 0.0219, 'lps'),
	(413585, 126, '2015-02-15 00:24:25.000000', 'consum', 0.0223, 'lps'),
	(413586, 126, '2015-02-15 00:24:26.000000', 'consum', 0.0220, 'lps'),
	(413587, 126, '2015-02-15 00:24:27.000000', 'consum', 0.0223, 'lps'),
	(413588, 126, '2015-02-15 00:24:28.000000', 'consum', 0.0218, 'lps'),
	(413589, 126, '2015-02-15 00:24:29.000000', 'consum', 0.0223, 'lps'),
	(413590, 126, '2015-02-15 00:24:30.000000', 'consum', 0.0223, 'lps'),
	(413591, 126, '2015-02-15 00:24:31.000000', 'consum', 0.0222, 'lps'),
	(413592, 126, '2015-02-15 00:24:32.000000', 'consum', 0.0220, 'lps'),
	(413593, 126, '2015-02-15 00:24:33.000000', 'consum', 0.0210, 'lps'),
	(413594, 126, '2015-02-15 00:24:34.000000', 'consum', 0.0222, 'lps'),
	(413595, 126, '2015-02-15 00:24:35.000000', 'consum', 0.0217, 'lps'),
	(413596, 126, '2015-02-15 00:24:36.000000', 'consum', 0.0220, 'lps'),
	(413597, 126, '2015-02-15 00:24:37.000000', 'consum', 0.0212, 'lps'),
	(413598, 126, '2015-02-15 00:24:38.000000', 'consum', 0.0219, 'lps'),
	(413599, 126, '2015-02-15 00:24:39.000000', 'consum', 0.0223, 'lps'),
	(413600, 126, '2015-02-15 00:24:40.000000', 'consum', 0.0221, 'lps'),
	(413601, 126, '2015-02-15 00:24:41.000000', 'consum', 0.0212, 'lps'),
	(413602, 126, '2015-02-15 00:24:42.000000', 'consum', 0.0217, 'lps'),
	(413603, 126, '2015-02-15 00:24:43.000000', 'consum', 0.0222, 'lps'),
	(413604, 126, '2015-02-15 00:24:44.000000', 'consum', 0.0211, 'lps'),
	(413605, 126, '2015-02-15 00:24:45.000000', 'consum', 0.0219, 'lps'),
	(413606, 126, '2015-02-15 00:24:46.000000', 'consum', 0.0210, 'lps'),
	(413607, 126, '2015-02-15 00:24:47.000000', 'consum', 0.0211, 'lps'),
	(413608, 126, '2015-02-15 00:24:48.000000', 'consum', 0.0218, 'lps'),
	(413609, 126, '2015-02-15 00:24:49.000000', 'consum', 0.0220, 'lps'),
	(413610, 126, '2015-02-15 00:24:50.000000', 'consum', 0.0222, 'lps'),
	(413611, 126, '2015-02-15 00:24:51.000000', 'consum', 0.0212, 'lps'),
	(413612, 126, '2015-02-15 00:24:52.000000', 'consum', 0.0214, 'lps'),
	(413613, 126, '2015-02-15 00:24:53.000000', 'consum', 0.0222, 'lps'),
	(413614, 126, '2015-02-15 00:24:54.000000', 'consum', 0.0219, 'lps'),
	(413615, 126, '2015-02-15 00:24:55.000000', 'consum', 0.0217, 'lps'),
	(413616, 126, '2015-02-15 00:24:56.000000', 'consum', 0.0218, 'lps'),
	(413617, 126, '2015-02-15 00:24:57.000000', 'consum', 0.0215, 'lps'),
	(413618, 126, '2015-02-15 00:24:58.000000', 'consum', 0.0211, 'lps'),
	(413619, 126, '2015-02-15 00:24:59.000000', 'consum', 0.0215, 'lps'),
	(413620, 126, '2015-02-15 00:25:00.000000', 'consum', 0.0217, 'lps'),
	(413621, 126, '2015-02-15 00:25:01.000000', 'consum', 0.0219, 'lps'),
	(413622, 126, '2015-02-15 00:25:02.000000', 'consum', 0.0220, 'lps'),
	(413623, 126, '2015-02-15 00:25:03.000000', 'consum', 0.0220, 'lps'),
	(413624, 126, '2015-02-15 00:25:04.000000', 'consum', 0.0215, 'lps'),
	(413625, 126, '2015-02-15 00:25:05.000000', 'consum', 0.0221, 'lps'),
	(413626, 126, '2015-02-15 00:25:06.000000', 'consum', 0.0223, 'lps'),
	(413627, 126, '2015-02-15 00:25:07.000000', 'consum', 0.0212, 'lps'),
	(413628, 126, '2015-02-15 00:25:08.000000', 'consum', 0.0212, 'lps'),
	(413629, 126, '2015-02-15 00:25:09.000000', 'consum', 0.0215, 'lps'),
	(413630, 126, '2015-02-15 00:25:10.000000', 'consum', 0.0215, 'lps'),
	(413631, 126, '2015-02-15 00:25:11.000000', 'consum', 0.0218, 'lps'),
	(413632, 126, '2015-02-15 00:25:12.000000', 'consum', 0.0210, 'lps'),
	(413633, 126, '2015-02-15 00:25:13.000000', 'consum', 0.0216, 'lps'),
	(413634, 126, '2015-02-15 00:25:14.000000', 'consum', 0.0223, 'lps'),
	(413635, 126, '2015-02-15 00:25:15.000000', 'consum', 0.0218, 'lps'),
	(413636, 126, '2015-02-15 00:25:16.000000', 'consum', 0.0210, 'lps'),
	(413637, 126, '2015-02-15 00:25:17.000000', 'consum', 0.0215, 'lps'),
	(413638, 126, '2015-02-15 00:25:18.000000', 'consum', 0.0221, 'lps'),
	(413639, 126, '2015-02-15 00:25:19.000000', 'consum', 0.0210, 'lps'),
	(413640, 126, '2015-02-15 00:25:20.000000', 'consum', 0.0220, 'lps'),
	(413641, 126, '2015-02-15 00:25:21.000000', 'consum', 0.0216, 'lps'),
	(413642, 126, '2015-02-15 00:25:22.000000', 'consum', 0.0214, 'lps'),
	(413643, 126, '2015-02-15 00:25:23.000000', 'consum', 0.0223, 'lps'),
	(413644, 126, '2015-02-15 00:25:24.000000', 'consum', 0.0222, 'lps'),
	(413645, 126, '2015-02-15 00:25:25.000000', 'consum', 0.0218, 'lps'),
	(413646, 126, '2015-02-15 00:25:26.000000', 'consum', 0.0213, 'lps'),
	(413647, 126, '2015-02-15 00:25:27.000000', 'consum', 0.0217, 'lps'),
	(413648, 126, '2015-02-15 00:25:28.000000', 'consum', 0.0221, 'lps'),
	(413649, 126, '2015-02-15 00:25:29.000000', 'consum', 0.0219, 'lps'),
	(413650, 126, '2015-02-15 00:25:30.000000', 'consum', 0.0222, 'lps'),
	(413651, 126, '2015-02-15 00:25:31.000000', 'consum', 0.0217, 'lps'),
	(413652, 126, '2015-02-15 00:25:32.000000', 'consum', 0.0220, 'lps'),
	(413653, 126, '2015-02-15 00:25:33.000000', 'consum', 0.0215, 'lps'),
	(413654, 126, '2015-02-15 00:25:34.000000', 'consum', 0.0216, 'lps'),
	(413655, 126, '2015-02-15 00:25:35.000000', 'consum', 0.0213, 'lps'),
	(413656, 126, '2015-02-15 00:25:36.000000', 'consum', 0.0222, 'lps'),
	(413657, 126, '2015-02-15 00:25:37.000000', 'consum', 0.0221, 'lps'),
	(413658, 126, '2015-02-15 00:25:38.000000', 'consum', 0.0213, 'lps'),
	(413659, 126, '2015-02-15 00:25:39.000000', 'consum', 0.0220, 'lps'),
	(413660, 126, '2015-02-15 00:25:40.000000', 'consum', 0.0210, 'lps'),
	(413661, 126, '2015-02-15 00:25:41.000000', 'consum', 0.0221, 'lps'),
	(413662, 126, '2015-02-15 00:25:42.000000', 'consum', 0.0211, 'lps'),
	(413663, 126, '2015-02-15 00:25:43.000000', 'consum', 0.0222, 'lps'),
	(413664, 126, '2015-02-15 00:25:44.000000', 'consum', 0.0214, 'lps'),
	(413665, 126, '2015-02-15 00:25:45.000000', 'consum', 0.0223, 'lps'),
	(413666, 126, '2015-02-15 00:25:46.000000', 'consum', 0.0221, 'lps'),
	(413667, 126, '2015-02-15 00:25:47.000000', 'consum', 0.0212, 'lps'),
	(413668, 126, '2015-02-15 00:25:48.000000', 'consum', 0.0216, 'lps'),
	(413669, 126, '2015-02-15 00:25:49.000000', 'consum', 0.0221, 'lps'),
	(413670, 126, '2015-02-15 00:25:50.000000', 'consum', 0.0220, 'lps'),
	(413671, 126, '2015-02-15 00:25:51.000000', 'consum', 0.0215, 'lps'),
	(413672, 126, '2015-02-15 00:25:52.000000', 'consum', 0.0218, 'lps'),
	(413673, 126, '2015-02-15 00:25:53.000000', 'consum', 0.0220, 'lps'),
	(413674, 126, '2015-02-15 00:25:54.000000', 'consum', 0.0210, 'lps'),
	(413675, 126, '2015-02-15 00:25:55.000000', 'consum', 0.0210, 'lps'),
	(413676, 126, '2015-02-15 00:25:56.000000', 'consum', 0.0223, 'lps'),
	(413677, 126, '2015-02-15 00:25:57.000000', 'consum', 0.0218, 'lps'),
	(413678, 126, '2015-02-15 00:25:58.000000', 'consum', 0.0212, 'lps'),
	(413679, 126, '2015-02-15 00:25:59.000000', 'consum', 0.0211, 'lps'),
	(413680, 126, '2015-02-15 00:26:00.000000', 'consum', 0.0210, 'lps'),
	(413681, 126, '2015-02-15 00:26:01.000000', 'consum', 0.0219, 'lps'),
	(413682, 126, '2015-02-15 00:26:02.000000', 'consum', 0.0216, 'lps'),
	(413683, 126, '2015-02-15 00:26:03.000000', 'consum', 0.0213, 'lps'),
	(413684, 126, '2015-02-15 00:26:04.000000', 'consum', 0.0222, 'lps'),
	(413685, 126, '2015-02-15 00:26:05.000000', 'consum', 0.0220, 'lps'),
	(413686, 126, '2015-02-15 00:26:06.000000', 'consum', 0.0223, 'lps'),
	(413687, 126, '2015-02-15 00:26:07.000000', 'consum', 0.0218, 'lps'),
	(413688, 126, '2015-02-15 00:26:08.000000', 'consum', 0.0212, 'lps'),
	(413689, 126, '2015-02-15 00:26:09.000000', 'consum', 0.0210, 'lps'),
	(413690, 126, '2015-02-15 00:26:10.000000', 'consum', 0.0218, 'lps'),
	(413691, 126, '2015-02-15 00:26:11.000000', 'consum', 0.0210, 'lps'),
	(413692, 126, '2015-02-15 00:26:12.000000', 'consum', 0.0212, 'lps'),
	(413693, 126, '2015-02-15 00:26:13.000000', 'consum', 0.0223, 'lps'),
	(413694, 126, '2015-02-15 00:26:14.000000', 'consum', 0.0213, 'lps'),
	(413695, 126, '2015-02-15 00:26:15.000000', 'consum', 0.0214, 'lps'),
	(413696, 126, '2015-02-15 00:26:16.000000', 'consum', 0.0223, 'lps'),
	(413697, 126, '2015-02-15 00:26:17.000000', 'consum', 0.0222, 'lps'),
	(413698, 126, '2015-02-15 00:26:18.000000', 'consum', 0.0217, 'lps'),
	(413699, 126, '2015-02-15 00:26:19.000000', 'consum', 0.0223, 'lps'),
	(413700, 126, '2015-02-15 00:26:20.000000', 'consum', 0.0213, 'lps'),
	(413701, 126, '2015-02-15 00:26:21.000000', 'consum', 0.0212, 'lps'),
	(413702, 126, '2015-02-15 00:26:22.000000', 'consum', 0.0214, 'lps'),
	(413703, 126, '2015-02-15 00:26:23.000000', 'consum', 0.0222, 'lps'),
	(413704, 126, '2015-02-15 00:26:24.000000', 'consum', 0.0217, 'lps'),
	(413705, 126, '2015-02-15 00:26:25.000000', 'consum', 0.0222, 'lps'),
	(413706, 126, '2015-02-15 00:26:26.000000', 'consum', 0.0223, 'lps'),
	(413707, 126, '2015-02-15 00:26:27.000000', 'consum', 0.0210, 'lps'),
	(413708, 126, '2015-02-15 00:26:28.000000', 'consum', 0.0212, 'lps'),
	(413709, 126, '2015-02-15 00:26:29.000000', 'consum', 0.0210, 'lps'),
	(413710, 126, '2015-02-15 00:26:30.000000', 'consum', 0.0218, 'lps'),
	(413711, 126, '2015-02-15 00:26:31.000000', 'consum', 0.0223, 'lps'),
	(413712, 126, '2015-02-15 00:26:32.000000', 'consum', 0.0221, 'lps'),
	(413713, 126, '2015-02-15 00:26:33.000000', 'consum', 0.0213, 'lps'),
	(413714, 126, '2015-02-15 00:26:34.000000', 'consum', 0.0221, 'lps'),
	(413715, 126, '2015-02-15 00:26:35.000000', 'consum', 0.0216, 'lps'),
	(413716, 126, '2015-02-15 00:26:36.000000', 'consum', 0.0220, 'lps'),
	(413717, 126, '2015-02-15 00:26:37.000000', 'consum', 0.0214, 'lps'),
	(413718, 126, '2015-02-15 00:26:38.000000', 'consum', 0.0215, 'lps'),
	(413719, 126, '2015-02-15 00:26:39.000000', 'consum', 0.0223, 'lps'),
	(413720, 126, '2015-02-15 00:26:40.000000', 'consum', 0.0218, 'lps'),
	(413721, 126, '2015-02-15 00:26:41.000000', 'consum', 0.0214, 'lps'),
	(413722, 126, '2015-02-15 00:26:42.000000', 'consum', 0.0220, 'lps'),
	(413723, 126, '2015-02-15 00:26:43.000000', 'consum', 0.0218, 'lps'),
	(413724, 126, '2015-02-15 00:26:44.000000', 'consum', 0.0223, 'lps'),
	(413725, 126, '2015-02-15 00:26:45.000000', 'consum', 0.0223, 'lps'),
	(413726, 126, '2015-02-15 00:26:46.000000', 'consum', 0.0222, 'lps'),
	(413727, 126, '2015-02-15 00:26:47.000000', 'consum', 0.0218, 'lps'),
	(413728, 126, '2015-02-15 00:26:48.000000', 'consum', 0.0215, 'lps'),
	(413729, 126, '2015-02-15 00:26:49.000000', 'consum', 0.0212, 'lps'),
	(413730, 126, '2015-02-15 00:26:50.000000', 'consum', 0.0217, 'lps'),
	(413731, 126, '2015-02-15 00:26:51.000000', 'consum', 0.0211, 'lps'),
	(413732, 126, '2015-02-15 00:26:52.000000', 'consum', 0.0211, 'lps'),
	(413733, 126, '2015-02-15 00:26:53.000000', 'consum', 0.0212, 'lps'),
	(413734, 126, '2015-02-15 00:26:54.000000', 'consum', 0.0218, 'lps'),
	(413735, 126, '2015-02-15 00:26:55.000000', 'consum', 0.0218, 'lps'),
	(413736, 126, '2015-02-15 00:26:56.000000', 'consum', 0.0211, 'lps'),
	(413737, 126, '2015-02-15 00:26:57.000000', 'consum', 0.0221, 'lps'),
	(413738, 126, '2015-02-15 00:26:58.000000', 'consum', 0.0221, 'lps'),
	(413739, 126, '2015-02-15 00:26:59.000000', 'consum', 0.0219, 'lps'),
	(413740, 126, '2015-02-15 00:27:00.000000', 'consum', 0.0220, 'lps'),
	(413741, 126, '2015-02-15 00:27:01.000000', 'consum', 0.0219, 'lps'),
	(413742, 126, '2015-02-15 00:27:02.000000', 'consum', 0.0211, 'lps'),
	(413743, 126, '2015-02-15 00:27:03.000000', 'consum', 0.0216, 'lps'),
	(413744, 126, '2015-02-15 00:27:04.000000', 'consum', 0.0211, 'lps'),
	(413745, 126, '2015-02-15 00:27:05.000000', 'consum', 0.0212, 'lps'),
	(413746, 126, '2015-02-15 00:27:06.000000', 'consum', 0.0216, 'lps'),
	(413747, 126, '2015-02-15 00:27:07.000000', 'consum', 0.0221, 'lps'),
	(413748, 126, '2015-02-15 00:27:08.000000', 'consum', 0.0219, 'lps'),
	(413749, 126, '2015-02-15 00:27:09.000000', 'consum', 0.0223, 'lps'),
	(413750, 126, '2015-02-15 00:27:10.000000', 'consum', 0.0221, 'lps'),
	(413751, 126, '2015-02-15 00:27:11.000000', 'consum', 0.0210, 'lps'),
	(413752, 126, '2015-02-15 00:27:12.000000', 'consum', 0.0221, 'lps'),
	(413753, 126, '2015-02-15 00:27:13.000000', 'consum', 0.0223, 'lps'),
	(413754, 126, '2015-02-15 00:27:14.000000', 'consum', 0.0217, 'lps'),
	(413755, 126, '2015-02-15 00:27:15.000000', 'consum', 0.0218, 'lps'),
	(413756, 126, '2015-02-15 00:27:16.000000', 'consum', 0.0216, 'lps'),
	(413757, 126, '2015-02-15 00:27:17.000000', 'consum', 0.0217, 'lps'),
	(413758, 126, '2015-02-15 00:27:18.000000', 'consum', 0.0215, 'lps'),
	(413759, 126, '2015-02-15 00:27:19.000000', 'consum', 0.0212, 'lps'),
	(413760, 126, '2015-02-15 00:27:20.000000', 'consum', 0.0221, 'lps'),
	(413761, 126, '2015-02-15 00:27:21.000000', 'consum', 0.0215, 'lps'),
	(413762, 126, '2015-02-15 00:27:22.000000', 'consum', 0.0219, 'lps'),
	(413763, 126, '2015-02-15 00:27:23.000000', 'consum', 0.0210, 'lps'),
	(413764, 126, '2015-02-15 00:27:24.000000', 'consum', 0.0214, 'lps'),
	(413765, 126, '2015-02-15 00:27:25.000000', 'consum', 0.0218, 'lps'),
	(413766, 126, '2015-02-15 00:27:26.000000', 'consum', 0.0221, 'lps'),
	(413767, 126, '2015-02-15 00:27:27.000000', 'consum', 0.0215, 'lps'),
	(413768, 126, '2015-02-15 00:27:28.000000', 'consum', 0.0218, 'lps'),
	(413769, 126, '2015-02-15 00:27:29.000000', 'consum', 0.0222, 'lps'),
	(413770, 126, '2015-02-15 00:27:30.000000', 'consum', 0.0216, 'lps'),
	(413771, 126, '2015-02-15 00:27:31.000000', 'consum', 0.0219, 'lps'),
	(413772, 126, '2015-02-15 00:27:32.000000', 'consum', 0.0222, 'lps'),
	(413773, 126, '2015-02-15 00:27:33.000000', 'consum', 0.0216, 'lps'),
	(413774, 126, '2015-02-15 00:27:34.000000', 'consum', 0.0219, 'lps'),
	(413775, 126, '2015-02-15 00:27:35.000000', 'consum', 0.0210, 'lps'),
	(413776, 126, '2015-02-15 00:27:36.000000', 'consum', 0.0212, 'lps'),
	(413777, 126, '2015-02-15 00:27:37.000000', 'consum', 0.0219, 'lps'),
	(413778, 126, '2015-02-15 00:27:38.000000', 'consum', 0.0221, 'lps'),
	(413779, 126, '2015-02-15 00:27:39.000000', 'consum', 0.0213, 'lps'),
	(413780, 126, '2015-02-15 00:27:40.000000', 'consum', 0.0221, 'lps'),
	(413781, 126, '2015-02-15 00:27:41.000000', 'consum', 0.0212, 'lps'),
	(413782, 126, '2015-02-15 00:27:42.000000', 'consum', 0.0215, 'lps'),
	(413783, 126, '2015-02-15 00:27:43.000000', 'consum', 0.0218, 'lps'),
	(413784, 126, '2015-02-15 00:27:44.000000', 'consum', 0.0220, 'lps'),
	(413785, 126, '2015-02-15 00:27:45.000000', 'consum', 0.0223, 'lps'),
	(413786, 126, '2015-02-15 00:27:46.000000', 'consum', 0.0216, 'lps'),
	(413787, 126, '2015-02-15 00:27:47.000000', 'consum', 0.0216, 'lps'),
	(413788, 126, '2015-02-15 00:27:48.000000', 'consum', 0.0223, 'lps'),
	(413789, 126, '2015-02-15 00:27:49.000000', 'consum', 0.0214, 'lps'),
	(413790, 126, '2015-02-15 00:27:50.000000', 'consum', 0.0223, 'lps'),
	(413791, 126, '2015-02-15 00:27:51.000000', 'consum', 0.0218, 'lps'),
	(413792, 126, '2015-02-15 00:27:52.000000', 'consum', 0.0213, 'lps'),
	(413793, 126, '2015-02-15 00:27:53.000000', 'consum', 0.0214, 'lps'),
	(413794, 126, '2015-02-15 00:27:54.000000', 'consum', 0.0221, 'lps'),
	(413795, 126, '2015-02-15 00:27:55.000000', 'consum', 0.0212, 'lps'),
	(413796, 126, '2015-02-15 00:27:56.000000', 'consum', 0.0215, 'lps'),
	(413797, 126, '2015-02-15 00:27:57.000000', 'consum', 0.0216, 'lps'),
	(413798, 126, '2015-02-15 00:27:58.000000', 'consum', 0.0211, 'lps'),
	(413799, 126, '2015-02-15 00:27:59.000000', 'consum', 0.0210, 'lps'),
	(413800, 126, '2015-02-15 00:28:00.000000', 'consum', 0.0223, 'lps'),
	(413801, 126, '2015-02-15 00:28:01.000000', 'consum', 0.0219, 'lps'),
	(413802, 126, '2015-02-15 00:28:02.000000', 'consum', 0.0217, 'lps'),
	(413803, 126, '2015-02-15 00:28:03.000000', 'consum', 0.0219, 'lps'),
	(413804, 126, '2015-02-15 00:28:04.000000', 'consum', 0.0222, 'lps'),
	(413805, 126, '2015-02-15 00:28:05.000000', 'consum', 0.0213, 'lps'),
	(413806, 126, '2015-02-15 00:28:06.000000', 'consum', 0.0218, 'lps'),
	(413807, 126, '2015-02-15 00:28:07.000000', 'consum', 0.0216, 'lps'),
	(413808, 126, '2015-02-15 00:28:08.000000', 'consum', 0.0214, 'lps'),
	(413809, 126, '2015-02-15 00:28:09.000000', 'consum', 0.0212, 'lps'),
	(413810, 126, '2015-02-15 00:28:10.000000', 'consum', 0.0222, 'lps'),
	(413811, 126, '2015-02-15 00:28:11.000000', 'consum', 0.0211, 'lps'),
	(413812, 126, '2015-02-15 00:28:12.000000', 'consum', 0.0222, 'lps'),
	(413813, 126, '2015-02-15 00:28:13.000000', 'consum', 0.0211, 'lps'),
	(413814, 126, '2015-02-15 00:28:14.000000', 'consum', 0.0219, 'lps'),
	(413815, 126, '2015-02-15 00:28:15.000000', 'consum', 0.0213, 'lps'),
	(413816, 126, '2015-02-15 00:28:16.000000', 'consum', 0.0213, 'lps'),
	(413817, 126, '2015-02-15 00:28:17.000000', 'consum', 0.0215, 'lps'),
	(413818, 126, '2015-02-15 00:28:18.000000', 'consum', 0.0214, 'lps'),
	(413819, 126, '2015-02-15 00:28:19.000000', 'consum', 0.0214, 'lps'),
	(413820, 126, '2015-02-15 00:28:20.000000', 'consum', 0.0220, 'lps'),
	(413821, 126, '2015-02-15 00:28:21.000000', 'consum', 0.0221, 'lps'),
	(413822, 126, '2015-02-15 00:28:22.000000', 'consum', 0.0220, 'lps'),
	(413823, 126, '2015-02-15 00:28:23.000000', 'consum', 0.0214, 'lps'),
	(413824, 126, '2015-02-15 00:28:24.000000', 'consum', 0.0215, 'lps'),
	(413825, 126, '2015-02-15 00:28:25.000000', 'consum', 0.0221, 'lps'),
	(413826, 126, '2015-02-15 00:28:26.000000', 'consum', 0.0211, 'lps'),
	(413827, 126, '2015-02-15 00:28:27.000000', 'consum', 0.0211, 'lps'),
	(413828, 126, '2015-02-15 00:28:28.000000', 'consum', 0.0211, 'lps'),
	(413829, 126, '2015-02-15 00:28:29.000000', 'consum', 0.0214, 'lps'),
	(413830, 126, '2015-02-15 00:28:30.000000', 'consum', 0.0213, 'lps'),
	(413831, 126, '2015-02-15 00:28:31.000000', 'consum', 0.0215, 'lps'),
	(413832, 126, '2015-02-15 00:28:32.000000', 'consum', 0.0212, 'lps'),
	(413833, 126, '2015-02-15 00:28:33.000000', 'consum', 0.0218, 'lps'),
	(413834, 126, '2015-02-15 00:28:34.000000', 'consum', 0.0215, 'lps'),
	(413835, 126, '2015-02-15 00:28:35.000000', 'consum', 0.0214, 'lps'),
	(413836, 126, '2015-02-15 00:28:36.000000', 'consum', 0.0214, 'lps'),
	(413837, 126, '2015-02-15 00:28:37.000000', 'consum', 0.0218, 'lps'),
	(413838, 126, '2015-02-15 00:28:38.000000', 'consum', 0.0223, 'lps'),
	(413839, 126, '2015-02-15 00:28:39.000000', 'consum', 0.0213, 'lps'),
	(413840, 126, '2015-02-15 00:28:40.000000', 'consum', 0.0213, 'lps'),
	(413841, 126, '2015-02-15 00:28:41.000000', 'consum', 0.0215, 'lps'),
	(413842, 126, '2015-02-15 00:28:42.000000', 'consum', 0.0215, 'lps'),
	(413843, 126, '2015-02-15 00:28:43.000000', 'consum', 0.0221, 'lps'),
	(413844, 126, '2015-02-15 00:28:44.000000', 'consum', 0.0221, 'lps'),
	(413845, 126, '2015-02-15 00:28:45.000000', 'consum', 0.0219, 'lps'),
	(413846, 126, '2015-02-15 00:28:46.000000', 'consum', 0.0210, 'lps'),
	(413847, 126, '2015-02-15 00:28:47.000000', 'consum', 0.0210, 'lps'),
	(413848, 126, '2015-02-15 00:28:48.000000', 'consum', 0.0211, 'lps'),
	(413849, 126, '2015-02-15 00:28:49.000000', 'consum', 0.0214, 'lps'),
	(413850, 126, '2015-02-15 00:28:50.000000', 'consum', 0.0216, 'lps'),
	(413851, 126, '2015-02-15 00:28:51.000000', 'consum', 0.0212, 'lps'),
	(413852, 126, '2015-02-15 00:28:52.000000', 'consum', 0.0216, 'lps'),
	(413853, 126, '2015-02-15 00:28:53.000000', 'consum', 0.0223, 'lps'),
	(413854, 126, '2015-02-15 00:28:54.000000', 'consum', 0.0212, 'lps'),
	(413855, 126, '2015-02-15 00:28:55.000000', 'consum', 0.0213, 'lps'),
	(413856, 126, '2015-02-15 00:28:56.000000', 'consum', 0.0218, 'lps'),
	(413857, 126, '2015-02-15 00:28:57.000000', 'consum', 0.0212, 'lps'),
	(413858, 126, '2015-02-15 00:28:58.000000', 'consum', 0.0211, 'lps'),
	(413859, 126, '2015-02-15 00:28:59.000000', 'consum', 0.0222, 'lps'),
	(413860, 126, '2015-02-15 00:29:00.000000', 'consum', 0.0214, 'lps'),
	(413861, 126, '2015-02-15 00:29:01.000000', 'consum', 0.0223, 'lps'),
	(413862, 126, '2015-02-15 00:29:02.000000', 'consum', 0.0219, 'lps'),
	(413863, 126, '2015-02-15 00:29:03.000000', 'consum', 0.0219, 'lps'),
	(413864, 126, '2015-02-15 00:29:04.000000', 'consum', 0.0212, 'lps'),
	(413865, 126, '2015-02-15 00:29:05.000000', 'consum', 0.0223, 'lps'),
	(413866, 126, '2015-02-15 00:29:06.000000', 'consum', 0.0214, 'lps'),
	(413867, 126, '2015-02-15 00:29:07.000000', 'consum', 0.0220, 'lps'),
	(413868, 126, '2015-02-15 00:29:08.000000', 'consum', 0.0219, 'lps'),
	(413869, 126, '2015-02-15 00:29:09.000000', 'consum', 0.0210, 'lps'),
	(413870, 126, '2015-02-15 00:29:10.000000', 'consum', 0.0212, 'lps'),
	(413871, 126, '2015-02-15 00:29:11.000000', 'consum', 0.0223, 'lps'),
	(413872, 126, '2015-02-15 00:29:12.000000', 'consum', 0.0213, 'lps'),
	(413873, 126, '2015-02-15 00:29:13.000000', 'consum', 0.0215, 'lps'),
	(413874, 126, '2015-02-15 00:29:14.000000', 'consum', 0.0214, 'lps'),
	(413875, 126, '2015-02-15 00:29:15.000000', 'consum', 0.0212, 'lps'),
	(413876, 126, '2015-02-15 00:29:16.000000', 'consum', 0.0210, 'lps'),
	(413877, 126, '2015-02-15 00:29:17.000000', 'consum', 0.0219, 'lps'),
	(413878, 126, '2015-02-15 00:29:18.000000', 'consum', 0.0214, 'lps'),
	(413879, 126, '2015-02-15 00:29:19.000000', 'consum', 0.0218, 'lps'),
	(413880, 126, '2015-02-15 00:29:20.000000', 'consum', 0.0210, 'lps'),
	(413881, 126, '2015-02-15 00:29:21.000000', 'consum', 0.0213, 'lps'),
	(413882, 126, '2015-02-15 00:29:22.000000', 'consum', 0.0211, 'lps'),
	(413883, 126, '2015-02-15 00:29:23.000000', 'consum', 0.0219, 'lps'),
	(413884, 126, '2015-02-15 00:29:24.000000', 'consum', 0.0214, 'lps'),
	(413885, 126, '2015-02-15 00:29:25.000000', 'consum', 0.0216, 'lps'),
	(413886, 126, '2015-02-15 00:29:26.000000', 'consum', 0.0216, 'lps'),
	(413887, 126, '2015-02-15 00:29:27.000000', 'consum', 0.0222, 'lps'),
	(413888, 126, '2015-02-15 00:29:28.000000', 'consum', 0.0223, 'lps'),
	(413889, 126, '2015-02-15 00:29:29.000000', 'consum', 0.0214, 'lps'),
	(413890, 126, '2015-02-15 00:29:30.000000', 'consum', 0.0216, 'lps'),
	(413891, 126, '2015-02-15 00:29:31.000000', 'consum', 0.0217, 'lps'),
	(413892, 126, '2015-02-15 00:29:32.000000', 'consum', 0.0214, 'lps'),
	(413893, 126, '2015-02-15 00:29:33.000000', 'consum', 0.0211, 'lps'),
	(413894, 126, '2015-02-15 00:29:34.000000', 'consum', 0.0215, 'lps'),
	(413895, 126, '2015-02-15 00:29:35.000000', 'consum', 0.0220, 'lps'),
	(413896, 126, '2015-02-15 00:29:36.000000', 'consum', 0.0216, 'lps'),
	(413897, 126, '2015-02-15 00:29:37.000000', 'consum', 0.0213, 'lps'),
	(413898, 126, '2015-02-15 00:29:38.000000', 'consum', 0.0219, 'lps'),
	(413899, 126, '2015-02-15 00:29:39.000000', 'consum', 0.0219, 'lps'),
	(413900, 126, '2015-02-15 00:29:40.000000', 'consum', 0.0214, 'lps'),
	(413901, 126, '2015-02-15 00:29:41.000000', 'consum', 0.0218, 'lps'),
	(413902, 126, '2015-02-15 00:29:42.000000', 'consum', 0.0223, 'lps'),
	(413903, 126, '2015-02-15 00:29:43.000000', 'consum', 0.0211, 'lps'),
	(413904, 126, '2015-02-15 00:29:44.000000', 'consum', 0.0219, 'lps'),
	(413905, 126, '2015-02-15 00:29:45.000000', 'consum', 0.0212, 'lps'),
	(413906, 126, '2015-02-15 00:29:46.000000', 'consum', 0.0219, 'lps'),
	(413907, 126, '2015-02-15 00:29:47.000000', 'consum', 0.0210, 'lps'),
	(413908, 126, '2015-02-15 00:29:48.000000', 'consum', 0.0211, 'lps'),
	(413909, 126, '2015-02-15 00:29:49.000000', 'consum', 0.0217, 'lps'),
	(413910, 126, '2015-02-15 00:29:50.000000', 'consum', 0.0211, 'lps'),
	(413911, 126, '2015-02-15 00:29:51.000000', 'consum', 0.0212, 'lps'),
	(413912, 126, '2015-02-15 00:29:52.000000', 'consum', 0.0216, 'lps'),
	(413913, 126, '2015-02-15 00:29:53.000000', 'consum', 0.0222, 'lps'),
	(413914, 126, '2015-02-15 00:29:54.000000', 'consum', 0.0212, 'lps'),
	(413915, 126, '2015-02-15 00:29:55.000000', 'consum', 0.0223, 'lps'),
	(413916, 126, '2015-02-15 00:29:56.000000', 'consum', 0.0214, 'lps'),
	(413917, 126, '2015-02-15 00:29:57.000000', 'consum', 0.0219, 'lps'),
	(413918, 126, '2015-02-15 00:29:58.000000', 'consum', 0.0216, 'lps'),
	(413919, 126, '2015-02-15 00:29:59.000000', 'consum', 0.0213, 'lps'),
	(413920, 126, '2015-02-15 00:30:00.000000', 'consum', 0.0220, 'lps'),
	(413921, 126, '2015-02-15 00:30:01.000000', 'consum', 0.0211, 'lps'),
	(413922, 126, '2015-02-15 00:30:02.000000', 'consum', 0.0213, 'lps'),
	(413923, 126, '2015-02-15 00:30:03.000000', 'consum', 0.0210, 'lps'),
	(413924, 126, '2015-02-15 00:30:04.000000', 'consum', 0.0214, 'lps'),
	(413925, 126, '2015-02-15 00:30:05.000000', 'consum', 0.0216, 'lps'),
	(413926, 126, '2015-02-15 00:30:06.000000', 'consum', 0.0214, 'lps'),
	(413927, 126, '2015-02-15 00:30:07.000000', 'consum', 0.0215, 'lps'),
	(413928, 126, '2015-02-15 00:30:08.000000', 'consum', 0.0222, 'lps'),
	(413929, 126, '2015-02-15 00:30:09.000000', 'consum', 0.0214, 'lps'),
	(413930, 126, '2015-02-15 00:30:10.000000', 'consum', 0.0223, 'lps'),
	(413931, 126, '2015-02-15 00:30:11.000000', 'consum', 0.0221, 'lps'),
	(413932, 126, '2015-02-15 00:30:12.000000', 'consum', 0.0213, 'lps'),
	(413933, 126, '2015-02-15 00:30:13.000000', 'consum', 0.0220, 'lps'),
	(413934, 126, '2015-02-15 00:30:14.000000', 'consum', 0.0222, 'lps'),
	(413935, 126, '2015-02-15 00:30:15.000000', 'consum', 0.0215, 'lps'),
	(413936, 126, '2015-02-15 00:30:16.000000', 'consum', 0.0211, 'lps'),
	(413937, 126, '2015-02-15 00:30:17.000000', 'consum', 0.0214, 'lps'),
	(413938, 126, '2015-02-15 00:30:18.000000', 'consum', 0.0214, 'lps'),
	(413939, 126, '2015-02-15 00:30:19.000000', 'consum', 0.0218, 'lps'),
	(413940, 126, '2015-02-15 00:30:20.000000', 'consum', 0.0210, 'lps'),
	(413941, 126, '2015-02-15 00:30:21.000000', 'consum', 0.0217, 'lps'),
	(413942, 126, '2015-02-15 00:30:22.000000', 'consum', 0.0217, 'lps'),
	(413943, 126, '2015-02-15 00:30:23.000000', 'consum', 0.0210, 'lps'),
	(413944, 126, '2015-02-15 00:30:24.000000', 'consum', 0.0220, 'lps'),
	(413945, 126, '2015-02-15 00:30:25.000000', 'consum', 0.0215, 'lps'),
	(413946, 126, '2015-02-15 00:30:26.000000', 'consum', 0.0220, 'lps'),
	(413947, 126, '2015-02-15 00:30:27.000000', 'consum', 0.0218, 'lps'),
	(413948, 126, '2015-02-15 00:30:28.000000', 'consum', 0.0219, 'lps'),
	(413949, 126, '2015-02-15 00:30:29.000000', 'consum', 0.0218, 'lps'),
	(413950, 126, '2015-02-15 00:30:30.000000', 'consum', 0.0222, 'lps'),
	(413951, 126, '2015-02-15 00:30:31.000000', 'consum', 0.0222, 'lps'),
	(413952, 126, '2015-02-15 00:30:32.000000', 'consum', 0.0219, 'lps'),
	(413953, 126, '2015-02-15 00:30:33.000000', 'consum', 0.0218, 'lps'),
	(413954, 126, '2015-02-15 00:30:34.000000', 'consum', 0.0211, 'lps'),
	(413955, 126, '2015-02-15 00:30:35.000000', 'consum', 0.0220, 'lps'),
	(413956, 126, '2015-02-15 00:30:36.000000', 'consum', 0.0214, 'lps'),
	(413957, 126, '2015-02-15 00:30:37.000000', 'consum', 0.0215, 'lps'),
	(413958, 126, '2015-02-15 00:30:38.000000', 'consum', 0.0223, 'lps'),
	(413959, 126, '2015-02-15 00:30:39.000000', 'consum', 0.0221, 'lps'),
	(413960, 126, '2015-02-15 00:30:40.000000', 'consum', 0.0223, 'lps'),
	(413961, 126, '2015-02-15 00:30:41.000000', 'consum', 0.0216, 'lps'),
	(413962, 126, '2015-02-15 00:30:42.000000', 'consum', 0.0215, 'lps'),
	(413963, 126, '2015-02-15 00:30:43.000000', 'consum', 0.0218, 'lps'),
	(413964, 126, '2015-02-15 00:30:44.000000', 'consum', 0.0221, 'lps'),
	(413965, 126, '2015-02-15 00:30:45.000000', 'consum', 0.0214, 'lps'),
	(413966, 126, '2015-02-15 00:30:46.000000', 'consum', 0.0213, 'lps'),
	(413967, 126, '2015-02-15 00:30:47.000000', 'consum', 0.0210, 'lps'),
	(413968, 126, '2015-02-15 00:30:48.000000', 'consum', 0.0218, 'lps'),
	(413969, 126, '2015-02-15 00:30:49.000000', 'consum', 0.0223, 'lps'),
	(413970, 126, '2015-02-15 00:30:50.000000', 'consum', 0.0210, 'lps'),
	(413971, 126, '2015-02-15 00:30:51.000000', 'consum', 0.0212, 'lps'),
	(413972, 126, '2015-02-15 00:30:52.000000', 'consum', 0.0221, 'lps'),
	(413973, 126, '2015-02-15 00:30:53.000000', 'consum', 0.0216, 'lps'),
	(413974, 126, '2015-02-15 00:30:54.000000', 'consum', 0.0222, 'lps'),
	(413975, 126, '2015-02-15 00:30:55.000000', 'consum', 0.0212, 'lps'),
	(413976, 126, '2015-02-15 00:30:56.000000', 'consum', 0.0214, 'lps'),
	(413977, 126, '2015-02-15 00:30:57.000000', 'consum', 0.0222, 'lps'),
	(413978, 126, '2015-02-15 00:30:58.000000', 'consum', 0.0218, 'lps'),
	(413979, 126, '2015-02-15 00:30:59.000000', 'consum', 0.0213, 'lps'),
	(413980, 126, '2015-02-15 00:31:00.000000', 'consum', 0.0217, 'lps'),
	(413981, 126, '2015-02-15 00:31:01.000000', 'consum', 0.0210, 'lps'),
	(413982, 126, '2015-02-15 00:31:02.000000', 'consum', 0.0216, 'lps'),
	(413983, 126, '2015-02-15 00:31:03.000000', 'consum', 0.0213, 'lps'),
	(413984, 126, '2015-02-15 00:31:04.000000', 'consum', 0.0220, 'lps'),
	(413985, 126, '2015-02-15 00:31:05.000000', 'consum', 0.0211, 'lps'),
	(413986, 126, '2015-02-15 00:31:06.000000', 'consum', 0.0212, 'lps'),
	(413987, 126, '2015-02-15 00:31:07.000000', 'consum', 0.0219, 'lps'),
	(413988, 126, '2015-02-15 00:31:08.000000', 'consum', 0.0222, 'lps'),
	(413989, 126, '2015-02-15 00:31:09.000000', 'consum', 0.0214, 'lps'),
	(413990, 126, '2015-02-15 00:31:10.000000', 'consum', 0.0223, 'lps'),
	(413991, 126, '2015-02-15 00:31:11.000000', 'consum', 0.0219, 'lps'),
	(413992, 126, '2015-02-15 00:31:12.000000', 'consum', 0.0220, 'lps'),
	(413993, 126, '2015-02-15 00:31:13.000000', 'consum', 0.0218, 'lps'),
	(413994, 126, '2015-02-15 00:31:14.000000', 'consum', 0.0222, 'lps'),
	(413995, 126, '2015-02-15 00:31:15.000000', 'consum', 0.0217, 'lps'),
	(413996, 126, '2015-02-15 00:31:16.000000', 'consum', 0.0222, 'lps'),
	(413997, 126, '2015-02-15 00:31:17.000000', 'consum', 0.0223, 'lps'),
	(413998, 126, '2015-02-15 00:31:18.000000', 'consum', 0.0212, 'lps'),
	(413999, 126, '2015-02-15 00:31:19.000000', 'consum', 0.0222, 'lps'),
	(414000, 126, '2015-02-15 00:31:20.000000', 'consum', 0.0210, 'lps'),
	(414001, 126, '2015-02-15 00:31:21.000000', 'consum', 0.0215, 'lps'),
	(414002, 126, '2015-02-15 00:31:22.000000', 'consum', 0.0221, 'lps'),
	(414003, 126, '2015-02-15 00:31:23.000000', 'consum', 0.0223, 'lps'),
	(414004, 126, '2015-02-15 00:31:24.000000', 'consum', 0.0217, 'lps'),
	(414005, 126, '2015-02-15 00:31:25.000000', 'consum', 0.0218, 'lps'),
	(414006, 126, '2015-02-15 00:31:26.000000', 'consum', 0.0214, 'lps'),
	(414007, 126, '2015-02-15 00:31:27.000000', 'consum', 0.0222, 'lps'),
	(414008, 126, '2015-02-15 00:31:28.000000', 'consum', 0.0217, 'lps'),
	(414009, 126, '2015-02-15 00:31:29.000000', 'consum', 0.0223, 'lps'),
	(414010, 126, '2015-02-15 00:31:30.000000', 'consum', 0.0212, 'lps'),
	(414011, 126, '2015-02-15 00:31:31.000000', 'consum', 0.0222, 'lps'),
	(414012, 126, '2015-02-15 00:31:32.000000', 'consum', 0.0211, 'lps'),
	(414013, 126, '2015-02-15 00:31:33.000000', 'consum', 0.0220, 'lps'),
	(414014, 126, '2015-02-15 00:31:34.000000', 'consum', 0.0217, 'lps'),
	(414015, 126, '2015-02-15 00:31:35.000000', 'consum', 0.0216, 'lps'),
	(414016, 126, '2015-02-15 00:31:36.000000', 'consum', 0.0218, 'lps'),
	(414017, 126, '2015-02-15 00:31:37.000000', 'consum', 0.0219, 'lps'),
	(414018, 126, '2015-02-15 00:31:38.000000', 'consum', 0.0217, 'lps'),
	(414019, 126, '2015-02-15 00:31:39.000000', 'consum', 0.0218, 'lps'),
	(414020, 126, '2015-02-15 00:31:40.000000', 'consum', 0.0216, 'lps'),
	(414021, 126, '2015-02-15 00:31:41.000000', 'consum', 0.0216, 'lps'),
	(414022, 126, '2015-02-15 00:31:42.000000', 'consum', 0.0221, 'lps'),
	(414023, 126, '2015-02-15 00:31:43.000000', 'consum', 0.0221, 'lps'),
	(414024, 126, '2015-02-15 00:31:44.000000', 'consum', 0.0219, 'lps'),
	(414025, 126, '2015-02-15 00:31:45.000000', 'consum', 0.0210, 'lps'),
	(414026, 126, '2015-02-15 00:31:46.000000', 'consum', 0.0223, 'lps'),
	(414027, 126, '2015-02-15 00:31:47.000000', 'consum', 0.0222, 'lps'),
	(414028, 126, '2015-02-15 00:31:48.000000', 'consum', 0.0215, 'lps'),
	(414029, 126, '2015-02-15 00:31:49.000000', 'consum', 0.0215, 'lps'),
	(414030, 126, '2015-02-15 00:31:50.000000', 'consum', 0.0221, 'lps'),
	(414031, 126, '2015-02-15 00:31:51.000000', 'consum', 0.0222, 'lps'),
	(414032, 126, '2015-02-15 00:31:52.000000', 'consum', 0.0210, 'lps'),
	(414033, 126, '2015-02-15 00:31:53.000000', 'consum', 0.0215, 'lps'),
	(414034, 126, '2015-02-15 00:31:54.000000', 'consum', 0.0223, 'lps'),
	(414035, 126, '2015-02-15 00:31:55.000000', 'consum', 0.0219, 'lps'),
	(414036, 126, '2015-02-15 00:31:56.000000', 'consum', 0.0215, 'lps'),
	(414037, 126, '2015-02-15 00:31:57.000000', 'consum', 0.0223, 'lps'),
	(414038, 126, '2015-02-15 00:31:58.000000', 'consum', 0.0219, 'lps'),
	(414039, 126, '2015-02-15 00:31:59.000000', 'consum', 0.0216, 'lps'),
	(414040, 126, '2015-02-15 00:32:00.000000', 'consum', 0.0215, 'lps'),
	(414041, 126, '2015-02-15 00:32:01.000000', 'consum', 0.0215, 'lps'),
	(414042, 126, '2015-02-15 00:32:02.000000', 'consum', 0.0220, 'lps'),
	(414043, 126, '2015-02-15 00:32:03.000000', 'consum', 0.0220, 'lps'),
	(414044, 126, '2015-02-15 00:32:04.000000', 'consum', 0.0217, 'lps'),
	(414045, 126, '2015-02-15 00:32:05.000000', 'consum', 0.0214, 'lps'),
	(414046, 126, '2015-02-15 00:32:06.000000', 'consum', 0.0212, 'lps'),
	(414047, 126, '2015-02-15 00:32:07.000000', 'consum', 0.0219, 'lps'),
	(414048, 126, '2015-02-15 00:32:08.000000', 'consum', 0.0211, 'lps'),
	(414049, 126, '2015-02-15 00:32:09.000000', 'consum', 0.0213, 'lps'),
	(414050, 126, '2015-02-15 00:32:10.000000', 'consum', 0.0210, 'lps'),
	(414051, 126, '2015-02-15 00:32:11.000000', 'consum', 0.0217, 'lps'),
	(414052, 126, '2015-02-15 00:32:12.000000', 'consum', 0.0217, 'lps'),
	(414053, 126, '2015-02-15 00:32:13.000000', 'consum', 0.0211, 'lps'),
	(414054, 126, '2015-02-15 00:32:14.000000', 'consum', 0.0210, 'lps'),
	(414055, 126, '2015-02-15 00:32:15.000000', 'consum', 0.0220, 'lps'),
	(414056, 126, '2015-02-15 00:32:16.000000', 'consum', 0.0218, 'lps'),
	(414057, 126, '2015-02-15 00:32:17.000000', 'consum', 0.0219, 'lps'),
	(414058, 126, '2015-02-15 00:32:18.000000', 'consum', 0.0220, 'lps'),
	(414059, 126, '2015-02-15 00:32:19.000000', 'consum', 0.0217, 'lps'),
	(414060, 126, '2015-02-15 00:32:20.000000', 'consum', 0.0217, 'lps'),
	(414061, 126, '2015-02-15 00:32:21.000000', 'consum', 0.0223, 'lps'),
	(414062, 126, '2015-02-15 00:32:22.000000', 'consum', 0.0213, 'lps'),
	(414063, 126, '2015-02-15 00:32:23.000000', 'consum', 0.0215, 'lps'),
	(414064, 126, '2015-02-15 00:32:24.000000', 'consum', 0.0211, 'lps'),
	(414065, 126, '2015-02-15 00:32:25.000000', 'consum', 0.0214, 'lps'),
	(414066, 126, '2015-02-15 00:32:26.000000', 'consum', 0.0213, 'lps'),
	(414067, 126, '2015-02-15 00:32:27.000000', 'consum', 0.0215, 'lps'),
	(414068, 126, '2015-02-15 00:32:28.000000', 'consum', 0.0212, 'lps'),
	(414069, 126, '2015-02-15 00:32:29.000000', 'consum', 0.0219, 'lps'),
	(414070, 126, '2015-02-15 00:32:30.000000', 'consum', 0.0223, 'lps'),
	(414071, 126, '2015-02-15 00:32:31.000000', 'consum', 0.0219, 'lps'),
	(414072, 126, '2015-02-15 00:32:32.000000', 'consum', 0.0219, 'lps'),
	(414073, 126, '2015-02-15 00:32:33.000000', 'consum', 0.0212, 'lps'),
	(414074, 126, '2015-02-15 00:32:34.000000', 'consum', 0.0210, 'lps'),
	(414075, 126, '2015-02-15 00:32:35.000000', 'consum', 0.0218, 'lps'),
	(414076, 126, '2015-02-15 00:32:36.000000', 'consum', 0.0222, 'lps'),
	(414077, 126, '2015-02-15 00:32:37.000000', 'consum', 0.0217, 'lps'),
	(414078, 126, '2015-02-15 00:32:38.000000', 'consum', 0.0210, 'lps'),
	(414079, 126, '2015-02-15 00:32:39.000000', 'consum', 0.0220, 'lps'),
	(414080, 126, '2015-02-15 00:32:40.000000', 'consum', 0.0217, 'lps'),
	(414081, 126, '2015-02-15 00:32:41.000000', 'consum', 0.0214, 'lps'),
	(414082, 126, '2015-02-15 00:32:42.000000', 'consum', 0.0211, 'lps'),
	(414083, 126, '2015-02-15 00:32:43.000000', 'consum', 0.0218, 'lps'),
	(414084, 126, '2015-02-15 00:32:44.000000', 'consum', 0.0218, 'lps'),
	(414085, 126, '2015-02-15 00:32:45.000000', 'consum', 0.0213, 'lps'),
	(414086, 126, '2015-02-15 00:32:46.000000', 'consum', 0.0218, 'lps'),
	(414087, 126, '2015-02-15 00:32:47.000000', 'consum', 0.0210, 'lps'),
	(414088, 126, '2015-02-15 00:32:48.000000', 'consum', 0.0218, 'lps'),
	(414089, 126, '2015-02-15 00:32:49.000000', 'consum', 0.0220, 'lps'),
	(414090, 126, '2015-02-15 00:32:50.000000', 'consum', 0.0211, 'lps'),
	(414091, 126, '2015-02-15 00:32:51.000000', 'consum', 0.0213, 'lps'),
	(414092, 126, '2015-02-15 00:32:52.000000', 'consum', 0.0220, 'lps'),
	(414093, 126, '2015-02-15 00:32:53.000000', 'consum', 0.0212, 'lps'),
	(414094, 126, '2015-02-15 00:32:54.000000', 'consum', 0.0216, 'lps'),
	(414095, 126, '2015-02-15 00:32:55.000000', 'consum', 0.0221, 'lps'),
	(414096, 126, '2015-02-15 00:32:56.000000', 'consum', 0.0220, 'lps'),
	(414097, 126, '2015-02-15 00:32:57.000000', 'consum', 0.0213, 'lps'),
	(414098, 126, '2015-02-15 00:32:58.000000', 'consum', 0.0222, 'lps'),
	(414099, 126, '2015-02-15 00:32:59.000000', 'consum', 0.0220, 'lps'),
	(414100, 126, '2015-02-15 00:33:00.000000', 'consum', 0.0210, 'lps'),
	(414101, 126, '2015-02-15 00:33:01.000000', 'consum', 0.0223, 'lps'),
	(414102, 126, '2015-02-15 00:33:02.000000', 'consum', 0.0218, 'lps'),
	(414103, 126, '2015-02-15 00:33:03.000000', 'consum', 0.0215, 'lps'),
	(414104, 126, '2015-02-15 00:33:04.000000', 'consum', 0.0222, 'lps'),
	(414105, 126, '2015-02-15 00:33:05.000000', 'consum', 0.0217, 'lps'),
	(414106, 126, '2015-02-15 00:33:06.000000', 'consum', 0.0221, 'lps'),
	(414107, 126, '2015-02-15 00:33:07.000000', 'consum', 0.0218, 'lps'),
	(414108, 126, '2015-02-15 00:33:08.000000', 'consum', 0.0216, 'lps'),
	(414109, 126, '2015-02-15 00:33:09.000000', 'consum', 0.0219, 'lps'),
	(414110, 126, '2015-02-15 00:33:10.000000', 'consum', 0.0223, 'lps'),
	(414111, 126, '2015-02-15 00:33:11.000000', 'consum', 0.0218, 'lps'),
	(414112, 126, '2015-02-15 00:33:12.000000', 'consum', 0.0214, 'lps'),
	(414113, 126, '2015-02-15 00:33:13.000000', 'consum', 0.0220, 'lps'),
	(414114, 126, '2015-02-15 00:33:14.000000', 'consum', 0.0219, 'lps'),
	(414115, 126, '2015-02-15 00:33:15.000000', 'consum', 0.0214, 'lps'),
	(414116, 126, '2015-02-15 00:33:16.000000', 'consum', 0.0217, 'lps'),
	(414117, 126, '2015-02-15 00:33:17.000000', 'consum', 0.0218, 'lps'),
	(414118, 126, '2015-02-15 00:33:18.000000', 'consum', 0.0216, 'lps'),
	(414119, 126, '2015-02-15 00:33:19.000000', 'consum', 0.0216, 'lps'),
	(414120, 126, '2015-02-15 00:33:20.000000', 'consum', 0.0211, 'lps'),
	(414121, 126, '2015-02-15 00:33:21.000000', 'consum', 0.0222, 'lps'),
	(414122, 126, '2015-02-15 00:33:22.000000', 'consum', 0.0214, 'lps'),
	(414123, 126, '2015-02-15 00:33:23.000000', 'consum', 0.0222, 'lps'),
	(414124, 126, '2015-02-15 00:33:24.000000', 'consum', 0.0215, 'lps'),
	(414125, 126, '2015-02-15 00:33:25.000000', 'consum', 0.0213, 'lps'),
	(414126, 126, '2015-02-15 00:33:26.000000', 'consum', 0.0210, 'lps'),
	(414127, 126, '2015-02-15 00:33:27.000000', 'consum', 0.0217, 'lps'),
	(414128, 126, '2015-02-15 00:33:28.000000', 'consum', 0.0219, 'lps'),
	(414129, 126, '2015-02-15 00:33:29.000000', 'consum', 0.0218, 'lps'),
	(414130, 126, '2015-02-15 00:33:30.000000', 'consum', 0.0210, 'lps'),
	(414131, 126, '2015-02-15 00:33:31.000000', 'consum', 0.0216, 'lps'),
	(414132, 126, '2015-02-15 00:33:32.000000', 'consum', 0.0210, 'lps'),
	(414133, 126, '2015-02-15 00:33:33.000000', 'consum', 0.0220, 'lps'),
	(414134, 126, '2015-02-15 00:33:34.000000', 'consum', 0.0221, 'lps'),
	(414135, 126, '2015-02-15 00:33:35.000000', 'consum', 0.0221, 'lps'),
	(414136, 126, '2015-02-15 00:33:36.000000', 'consum', 0.0219, 'lps'),
	(414137, 126, '2015-02-15 00:33:37.000000', 'consum', 0.0222, 'lps'),
	(414138, 126, '2015-02-15 00:33:38.000000', 'consum', 0.0216, 'lps'),
	(414139, 126, '2015-02-15 00:33:39.000000', 'consum', 0.0217, 'lps'),
	(414140, 126, '2015-02-15 00:33:40.000000', 'consum', 0.0216, 'lps'),
	(414141, 126, '2015-02-15 00:33:41.000000', 'consum', 0.0218, 'lps'),
	(414142, 126, '2015-02-15 00:33:42.000000', 'consum', 0.0220, 'lps'),
	(414143, 126, '2015-02-15 00:33:43.000000', 'consum', 0.0222, 'lps'),
	(414144, 126, '2015-02-15 00:33:44.000000', 'consum', 0.0213, 'lps'),
	(414145, 126, '2015-02-15 00:33:45.000000', 'consum', 0.0218, 'lps'),
	(414146, 126, '2015-02-15 00:33:46.000000', 'consum', 0.0212, 'lps'),
	(414147, 126, '2015-02-15 00:33:47.000000', 'consum', 0.0212, 'lps'),
	(414148, 126, '2015-02-15 00:33:48.000000', 'consum', 0.0212, 'lps'),
	(414149, 126, '2015-02-15 00:33:49.000000', 'consum', 0.0215, 'lps'),
	(414150, 126, '2015-02-15 00:33:50.000000', 'consum', 0.0216, 'lps'),
	(414151, 126, '2015-02-15 00:33:51.000000', 'consum', 0.0211, 'lps'),
	(414152, 126, '2015-02-15 00:33:52.000000', 'consum', 0.0212, 'lps'),
	(414153, 126, '2015-02-15 00:33:53.000000', 'consum', 0.0219, 'lps'),
	(414154, 126, '2015-02-15 00:33:54.000000', 'consum', 0.0222, 'lps'),
	(414155, 126, '2015-02-15 00:33:55.000000', 'consum', 0.0216, 'lps'),
	(414156, 126, '2015-02-15 00:33:56.000000', 'consum', 0.0219, 'lps'),
	(414157, 126, '2015-02-15 00:33:57.000000', 'consum', 0.0210, 'lps'),
	(414158, 126, '2015-02-15 00:33:58.000000', 'consum', 0.0223, 'lps'),
	(414159, 126, '2015-02-15 00:33:59.000000', 'consum', 0.0222, 'lps'),
	(414160, 126, '2015-02-15 00:34:00.000000', 'consum', 0.0218, 'lps'),
	(414161, 126, '2015-02-15 00:34:01.000000', 'consum', 0.0214, 'lps'),
	(414162, 126, '2015-02-15 00:34:02.000000', 'consum', 0.0220, 'lps'),
	(414163, 126, '2015-02-15 00:34:03.000000', 'consum', 0.0222, 'lps'),
	(414164, 126, '2015-02-15 00:34:04.000000', 'consum', 0.0211, 'lps'),
	(414165, 126, '2015-02-15 00:34:05.000000', 'consum', 0.0220, 'lps'),
	(414166, 126, '2015-02-15 00:34:06.000000', 'consum', 0.0217, 'lps'),
	(414167, 126, '2015-02-15 00:34:07.000000', 'consum', 0.0215, 'lps'),
	(414168, 126, '2015-02-15 00:34:08.000000', 'consum', 0.0213, 'lps'),
	(414169, 126, '2015-02-15 00:34:09.000000', 'consum', 0.0213, 'lps'),
	(414170, 126, '2015-02-15 00:34:10.000000', 'consum', 0.0214, 'lps'),
	(414171, 126, '2015-02-15 00:34:11.000000', 'consum', 0.0222, 'lps'),
	(414172, 126, '2015-02-15 00:34:12.000000', 'consum', 0.0219, 'lps'),
	(414173, 126, '2015-02-15 00:34:13.000000', 'consum', 0.0217, 'lps'),
	(414174, 126, '2015-02-15 00:34:14.000000', 'consum', 0.0218, 'lps'),
	(414175, 126, '2015-02-15 00:34:15.000000', 'consum', 0.0216, 'lps'),
	(414176, 126, '2015-02-15 00:34:16.000000', 'consum', 0.0216, 'lps'),
	(414177, 126, '2015-02-15 00:34:17.000000', 'consum', 0.0221, 'lps'),
	(414178, 126, '2015-02-15 00:34:18.000000', 'consum', 0.0221, 'lps'),
	(414179, 126, '2015-02-15 00:34:19.000000', 'consum', 0.0218, 'lps'),
	(414180, 126, '2015-02-15 00:34:20.000000', 'consum', 0.0218, 'lps'),
	(414181, 126, '2015-02-15 00:34:21.000000', 'consum', 0.0213, 'lps'),
	(414182, 126, '2015-02-15 00:34:22.000000', 'consum', 0.0215, 'lps'),
	(414183, 126, '2015-02-15 00:34:23.000000', 'consum', 0.0214, 'lps'),
	(414184, 126, '2015-02-15 00:34:24.000000', 'consum', 0.0214, 'lps'),
	(414185, 126, '2015-02-15 00:34:25.000000', 'consum', 0.0219, 'lps'),
	(414186, 126, '2015-02-15 00:34:26.000000', 'consum', 0.0216, 'lps'),
	(414187, 126, '2015-02-15 00:34:27.000000', 'consum', 0.0215, 'lps'),
	(414188, 126, '2015-02-15 00:34:28.000000', 'consum', 0.0214, 'lps'),
	(414189, 126, '2015-02-15 00:34:29.000000', 'consum', 0.0218, 'lps'),
	(414190, 126, '2015-02-15 00:34:30.000000', 'consum', 0.0223, 'lps'),
	(414191, 126, '2015-02-15 00:34:31.000000', 'consum', 0.0211, 'lps'),
	(414192, 126, '2015-02-15 00:34:32.000000', 'consum', 0.0217, 'lps'),
	(414193, 126, '2015-02-15 00:34:33.000000', 'consum', 0.0215, 'lps'),
	(414194, 126, '2015-02-15 00:34:34.000000', 'consum', 0.0213, 'lps'),
	(414195, 126, '2015-02-15 00:34:35.000000', 'consum', 0.0211, 'lps'),
	(414196, 126, '2015-02-15 00:34:36.000000', 'consum', 0.0220, 'lps'),
	(414197, 126, '2015-02-15 00:34:37.000000', 'consum', 0.0216, 'lps'),
	(414198, 126, '2015-02-15 00:34:38.000000', 'consum', 0.0223, 'lps'),
	(414199, 126, '2015-02-15 00:34:39.000000', 'consum', 0.0217, 'lps'),
	(414200, 126, '2015-02-15 00:34:40.000000', 'consum', 0.0218, 'lps'),
	(414201, 126, '2015-02-15 00:34:41.000000', 'consum', 0.0219, 'lps'),
	(414202, 126, '2015-02-15 00:34:42.000000', 'consum', 0.0214, 'lps'),
	(414203, 126, '2015-02-15 00:34:43.000000', 'consum', 0.0221, 'lps'),
	(414204, 126, '2015-02-15 00:34:44.000000', 'consum', 0.0211, 'lps'),
	(414205, 126, '2015-02-15 00:34:45.000000', 'consum', 0.0222, 'lps'),
	(414206, 126, '2015-02-15 00:34:46.000000', 'consum', 0.0214, 'lps'),
	(414207, 126, '2015-02-15 00:34:47.000000', 'consum', 0.0220, 'lps'),
	(414208, 126, '2015-02-15 00:34:48.000000', 'consum', 0.0220, 'lps'),
	(414209, 126, '2015-02-15 00:34:49.000000', 'consum', 0.0218, 'lps'),
	(414210, 126, '2015-02-15 00:34:50.000000', 'consum', 0.0221, 'lps'),
	(414211, 126, '2015-02-15 00:34:51.000000', 'consum', 0.0211, 'lps'),
	(414212, 126, '2015-02-15 00:34:52.000000', 'consum', 0.0214, 'lps'),
	(414213, 126, '2015-02-15 00:34:53.000000', 'consum', 0.0212, 'lps'),
	(414214, 126, '2015-02-15 00:34:54.000000', 'consum', 0.0220, 'lps'),
	(414215, 126, '2015-02-15 00:34:55.000000', 'consum', 0.0216, 'lps'),
	(414216, 126, '2015-02-15 00:34:56.000000', 'consum', 0.0211, 'lps'),
	(414217, 126, '2015-02-15 00:34:57.000000', 'consum', 0.0210, 'lps'),
	(414218, 126, '2015-02-15 00:34:58.000000', 'consum', 0.0221, 'lps'),
	(414219, 126, '2015-02-15 00:34:59.000000', 'consum', 0.0223, 'lps'),
	(414220, 126, '2015-02-15 00:35:00.000000', 'consum', 0.0216, 'lps'),
	(414221, 126, '2015-02-15 00:35:01.000000', 'consum', 0.0214, 'lps'),
	(414222, 126, '2015-02-15 00:35:02.000000', 'consum', 0.0212, 'lps'),
	(414223, 126, '2015-02-15 00:35:03.000000', 'consum', 0.0210, 'lps'),
	(414224, 126, '2015-02-15 00:35:04.000000', 'consum', 0.0218, 'lps'),
	(414225, 126, '2015-02-15 00:35:05.000000', 'consum', 0.0211, 'lps'),
	(414226, 126, '2015-02-15 00:35:06.000000', 'consum', 0.0216, 'lps'),
	(414227, 126, '2015-02-15 00:35:07.000000', 'consum', 0.0211, 'lps'),
	(414228, 126, '2015-02-15 00:35:08.000000', 'consum', 0.0210, 'lps'),
	(414229, 126, '2015-02-15 00:35:09.000000', 'consum', 0.0222, 'lps'),
	(414230, 126, '2015-02-15 00:35:10.000000', 'consum', 0.0214, 'lps'),
	(414231, 126, '2015-02-15 00:35:11.000000', 'consum', 0.0210, 'lps'),
	(414232, 126, '2015-02-15 00:35:12.000000', 'consum', 0.0213, 'lps'),
	(414233, 126, '2015-02-15 00:35:13.000000', 'consum', 0.0211, 'lps'),
	(414234, 126, '2015-02-15 00:35:14.000000', 'consum', 0.0222, 'lps'),
	(414235, 126, '2015-02-15 00:35:15.000000', 'consum', 0.0223, 'lps'),
	(414236, 126, '2015-02-15 00:35:16.000000', 'consum', 0.0211, 'lps'),
	(414237, 126, '2015-02-15 00:35:17.000000', 'consum', 0.0220, 'lps'),
	(414238, 126, '2015-02-15 00:35:18.000000', 'consum', 0.0215, 'lps'),
	(414239, 126, '2015-02-15 00:35:19.000000', 'consum', 0.0219, 'lps'),
	(414240, 126, '2015-02-15 00:35:20.000000', 'consum', 0.0213, 'lps'),
	(414241, 126, '2015-02-15 00:35:21.000000', 'consum', 0.0214, 'lps'),
	(414242, 126, '2015-02-15 00:35:22.000000', 'consum', 0.0221, 'lps'),
	(414243, 126, '2015-02-15 00:35:23.000000', 'consum', 0.0210, 'lps'),
	(414244, 126, '2015-02-15 00:35:24.000000', 'consum', 0.0222, 'lps'),
	(414245, 126, '2015-02-15 00:35:25.000000', 'consum', 0.0214, 'lps'),
	(414246, 126, '2015-02-15 00:35:26.000000', 'consum', 0.0222, 'lps'),
	(414247, 126, '2015-02-15 00:35:27.000000', 'consum', 0.0216, 'lps'),
	(414248, 126, '2015-02-15 00:35:28.000000', 'consum', 0.0219, 'lps'),
	(414249, 126, '2015-02-15 00:35:29.000000', 'consum', 0.0210, 'lps'),
	(414250, 126, '2015-02-15 00:35:30.000000', 'consum', 0.0211, 'lps'),
	(414251, 126, '2015-02-15 00:35:31.000000', 'consum', 0.0218, 'lps'),
	(414252, 126, '2015-02-15 00:35:32.000000', 'consum', 0.0216, 'lps'),
	(414253, 126, '2015-02-15 00:35:33.000000', 'consum', 0.0219, 'lps'),
	(414254, 126, '2015-02-15 00:35:34.000000', 'consum', 0.0210, 'lps'),
	(414255, 126, '2015-02-15 00:35:35.000000', 'consum', 0.0223, 'lps'),
	(414256, 126, '2015-02-15 00:35:36.000000', 'consum', 0.0219, 'lps'),
	(414257, 126, '2015-02-15 00:35:37.000000', 'consum', 0.0216, 'lps'),
	(414258, 126, '2015-02-15 00:35:38.000000', 'consum', 0.0214, 'lps'),
	(414259, 126, '2015-02-15 00:35:39.000000', 'consum', 0.0214, 'lps'),
	(414260, 126, '2015-02-15 00:35:40.000000', 'consum', 0.0219, 'lps'),
	(414261, 126, '2015-02-15 00:35:41.000000', 'consum', 0.0217, 'lps'),
	(414262, 126, '2015-02-15 00:35:42.000000', 'consum', 0.0215, 'lps'),
	(414263, 126, '2015-02-15 00:35:43.000000', 'consum', 0.0216, 'lps'),
	(414264, 126, '2015-02-15 00:35:44.000000', 'consum', 0.0210, 'lps'),
	(414265, 126, '2015-02-15 00:35:45.000000', 'consum', 0.0220, 'lps'),
	(414266, 126, '2015-02-15 00:35:46.000000', 'consum', 0.0218, 'lps'),
	(414267, 126, '2015-02-15 00:35:47.000000', 'consum', 0.0221, 'lps'),
	(414268, 126, '2015-02-15 00:35:48.000000', 'consum', 0.0214, 'lps'),
	(414269, 126, '2015-02-15 00:35:49.000000', 'consum', 0.0213, 'lps'),
	(414270, 126, '2015-02-15 00:35:50.000000', 'consum', 0.0213, 'lps'),
	(414271, 126, '2015-02-15 00:35:51.000000', 'consum', 0.0218, 'lps'),
	(414272, 126, '2015-02-15 00:35:52.000000', 'consum', 0.0212, 'lps'),
	(414273, 126, '2015-02-15 00:35:53.000000', 'consum', 0.0213, 'lps'),
	(414274, 126, '2015-02-15 00:35:54.000000', 'consum', 0.0217, 'lps'),
	(414275, 126, '2015-02-15 00:35:55.000000', 'consum', 0.0221, 'lps'),
	(414276, 126, '2015-02-15 00:35:56.000000', 'consum', 0.0219, 'lps'),
	(414277, 126, '2015-02-15 00:35:57.000000', 'consum', 0.0220, 'lps'),
	(414278, 126, '2015-02-15 00:35:58.000000', 'consum', 0.0223, 'lps'),
	(414279, 126, '2015-02-15 00:35:59.000000', 'consum', 0.0215, 'lps'),
	(414280, 126, '2015-02-15 00:36:00.000000', 'consum', 0.0212, 'lps'),
	(414281, 126, '2015-02-15 00:36:01.000000', 'consum', 0.0221, 'lps'),
	(414282, 126, '2015-02-15 00:36:02.000000', 'consum', 0.0215, 'lps'),
	(414283, 126, '2015-02-15 00:36:03.000000', 'consum', 0.0218, 'lps'),
	(414284, 126, '2015-02-15 00:36:04.000000', 'consum', 0.0222, 'lps'),
	(414285, 126, '2015-02-15 00:36:05.000000', 'consum', 0.0216, 'lps'),
	(414286, 126, '2015-02-15 00:36:06.000000', 'consum', 0.0218, 'lps'),
	(414287, 126, '2015-02-15 00:36:07.000000', 'consum', 0.0221, 'lps'),
	(414288, 126, '2015-02-15 00:36:08.000000', 'consum', 0.0213, 'lps'),
	(414289, 126, '2015-02-15 00:36:09.000000', 'consum', 0.0218, 'lps'),
	(414290, 126, '2015-02-15 00:36:10.000000', 'consum', 0.0217, 'lps'),
	(414291, 126, '2015-02-15 00:36:11.000000', 'consum', 0.0220, 'lps'),
	(414292, 126, '2015-02-15 00:36:12.000000', 'consum', 0.0211, 'lps'),
	(414293, 126, '2015-02-15 00:36:13.000000', 'consum', 0.0213, 'lps'),
	(414294, 126, '2015-02-15 00:36:14.000000', 'consum', 0.0210, 'lps'),
	(414295, 126, '2015-02-15 00:36:15.000000', 'consum', 0.0216, 'lps'),
	(414296, 126, '2015-02-15 00:36:16.000000', 'consum', 0.0211, 'lps'),
	(414297, 126, '2015-02-15 00:36:17.000000', 'consum', 0.0214, 'lps'),
	(414298, 126, '2015-02-15 00:36:18.000000', 'consum', 0.0211, 'lps'),
	(414299, 126, '2015-02-15 00:36:19.000000', 'consum', 0.0218, 'lps'),
	(414300, 126, '2015-02-15 00:36:20.000000', 'consum', 0.0219, 'lps'),
	(414301, 126, '2015-02-15 00:36:21.000000', 'consum', 0.0219, 'lps'),
	(414302, 126, '2015-02-15 00:36:22.000000', 'consum', 0.0212, 'lps'),
	(414303, 126, '2015-02-15 00:36:23.000000', 'consum', 0.0223, 'lps'),
	(414304, 126, '2015-02-15 00:36:24.000000', 'consum', 0.0213, 'lps'),
	(414305, 126, '2015-02-15 00:36:25.000000', 'consum', 0.0216, 'lps'),
	(414306, 126, '2015-02-15 00:36:26.000000', 'consum', 0.0216, 'lps'),
	(414307, 126, '2015-02-15 00:36:27.000000', 'consum', 0.0211, 'lps'),
	(414308, 126, '2015-02-15 00:36:28.000000', 'consum', 0.0222, 'lps'),
	(414309, 126, '2015-02-15 00:36:29.000000', 'consum', 0.0213, 'lps'),
	(414310, 126, '2015-02-15 00:36:30.000000', 'consum', 0.0219, 'lps'),
	(414311, 126, '2015-02-15 00:36:31.000000', 'consum', 0.0217, 'lps'),
	(414312, 126, '2015-02-15 00:36:32.000000', 'consum', 0.0220, 'lps'),
	(414313, 126, '2015-02-15 00:36:33.000000', 'consum', 0.0213, 'lps'),
	(414314, 126, '2015-02-15 00:36:34.000000', 'consum', 0.0220, 'lps'),
	(414315, 126, '2015-02-15 00:36:35.000000', 'consum', 0.0211, 'lps'),
	(414316, 126, '2015-02-15 00:36:36.000000', 'consum', 0.0215, 'lps'),
	(414317, 126, '2015-02-15 00:36:37.000000', 'consum', 0.0216, 'lps'),
	(414318, 126, '2015-02-15 00:36:38.000000', 'consum', 0.0213, 'lps'),
	(414319, 126, '2015-02-15 00:36:39.000000', 'consum', 0.0220, 'lps'),
	(414320, 126, '2015-02-15 00:36:40.000000', 'consum', 0.0210, 'lps'),
	(414321, 126, '2015-02-15 00:36:41.000000', 'consum', 0.0222, 'lps'),
	(414322, 126, '2015-02-15 00:36:42.000000', 'consum', 0.0214, 'lps'),
	(414323, 126, '2015-02-15 00:36:43.000000', 'consum', 0.0222, 'lps'),
	(414324, 126, '2015-02-15 00:36:44.000000', 'consum', 0.0216, 'lps'),
	(414325, 126, '2015-02-15 00:36:45.000000', 'consum', 0.0219, 'lps'),
	(414326, 126, '2015-02-15 00:36:46.000000', 'consum', 0.0223, 'lps'),
	(414327, 126, '2015-02-15 00:36:47.000000', 'consum', 0.0220, 'lps'),
	(414328, 126, '2015-02-15 00:36:48.000000', 'consum', 0.0223, 'lps'),
	(414329, 126, '2015-02-15 00:36:49.000000', 'consum', 0.0217, 'lps'),
	(414330, 126, '2015-02-15 00:36:50.000000', 'consum', 0.0222, 'lps'),
	(414331, 126, '2015-02-15 00:36:51.000000', 'consum', 0.0219, 'lps'),
	(414332, 126, '2015-02-15 00:36:52.000000', 'consum', 0.0221, 'lps'),
	(414333, 126, '2015-02-15 00:36:53.000000', 'consum', 0.0210, 'lps'),
	(414334, 126, '2015-02-15 00:36:54.000000', 'consum', 0.0218, 'lps'),
	(414335, 126, '2015-02-15 00:36:55.000000', 'consum', 0.0210, 'lps'),
	(414336, 126, '2015-02-15 00:36:56.000000', 'consum', 0.0214, 'lps'),
	(414337, 126, '2015-02-15 00:36:57.000000', 'consum', 0.0217, 'lps'),
	(414338, 126, '2015-02-15 00:36:58.000000', 'consum', 0.0218, 'lps'),
	(414339, 126, '2015-02-15 00:36:59.000000', 'consum', 0.0215, 'lps'),
	(414340, 126, '2015-02-15 00:37:00.000000', 'consum', 0.0213, 'lps'),
	(414341, 126, '2015-02-15 00:37:01.000000', 'consum', 0.0222, 'lps'),
	(414342, 126, '2015-02-15 00:37:02.000000', 'consum', 0.0222, 'lps'),
	(414343, 126, '2015-02-15 00:37:03.000000', 'consum', 0.0220, 'lps'),
	(414344, 126, '2015-02-15 00:37:04.000000', 'consum', 0.0223, 'lps'),
	(414345, 126, '2015-02-15 00:37:05.000000', 'consum', 0.0219, 'lps'),
	(414346, 126, '2015-02-15 00:37:06.000000', 'consum', 0.0217, 'lps'),
	(414347, 126, '2015-02-15 00:37:07.000000', 'consum', 0.0218, 'lps'),
	(414348, 126, '2015-02-15 00:37:08.000000', 'consum', 0.0216, 'lps'),
	(414349, 126, '2015-02-15 00:37:09.000000', 'consum', 0.0218, 'lps'),
	(414350, 126, '2015-02-15 00:37:10.000000', 'consum', 0.0217, 'lps'),
	(414351, 126, '2015-02-15 00:37:11.000000', 'consum', 0.0222, 'lps'),
	(414352, 126, '2015-02-15 00:37:12.000000', 'consum', 0.0221, 'lps'),
	(414353, 126, '2015-02-15 00:37:13.000000', 'consum', 0.0216, 'lps'),
	(414354, 126, '2015-02-15 00:37:14.000000', 'consum', 0.0223, 'lps'),
	(414355, 126, '2015-02-15 00:37:15.000000', 'consum', 0.0213, 'lps'),
	(414356, 126, '2015-02-15 00:37:16.000000', 'consum', 0.0214, 'lps'),
	(414357, 126, '2015-02-15 00:37:17.000000', 'consum', 0.0223, 'lps'),
	(414358, 126, '2015-02-15 00:37:18.000000', 'consum', 0.0220, 'lps'),
	(414359, 126, '2015-02-15 00:37:19.000000', 'consum', 0.0221, 'lps'),
	(414360, 126, '2015-02-15 00:37:20.000000', 'consum', 0.0210, 'lps'),
	(414361, 126, '2015-02-15 00:37:21.000000', 'consum', 0.0217, 'lps'),
	(414362, 126, '2015-02-15 00:37:22.000000', 'consum', 0.0219, 'lps'),
	(414363, 126, '2015-02-15 00:37:23.000000', 'consum', 0.0218, 'lps'),
	(414364, 126, '2015-02-15 00:37:24.000000', 'consum', 0.0213, 'lps'),
	(414365, 126, '2015-02-15 00:37:25.000000', 'consum', 0.0214, 'lps'),
	(414366, 126, '2015-02-15 00:37:26.000000', 'consum', 0.0221, 'lps'),
	(414367, 126, '2015-02-15 00:37:27.000000', 'consum', 0.0210, 'lps'),
	(414368, 126, '2015-02-15 00:37:28.000000', 'consum', 0.0221, 'lps'),
	(414369, 126, '2015-02-15 00:37:29.000000', 'consum', 0.0210, 'lps'),
	(414370, 126, '2015-02-15 00:37:30.000000', 'consum', 0.0219, 'lps'),
	(414371, 126, '2015-02-15 00:37:31.000000', 'consum', 0.0213, 'lps'),
	(414372, 126, '2015-02-15 00:37:32.000000', 'consum', 0.0211, 'lps'),
	(414373, 126, '2015-02-15 00:37:33.000000', 'consum', 0.0223, 'lps'),
	(414374, 126, '2015-02-15 00:37:34.000000', 'consum', 0.0214, 'lps'),
	(414375, 126, '2015-02-15 00:37:35.000000', 'consum', 0.0219, 'lps'),
	(414376, 126, '2015-02-15 00:37:36.000000', 'consum', 0.0217, 'lps'),
	(414377, 126, '2015-02-15 00:37:37.000000', 'consum', 0.0216, 'lps'),
	(414378, 126, '2015-02-15 00:37:38.000000', 'consum', 0.0223, 'lps'),
	(414379, 126, '2015-02-15 00:37:39.000000', 'consum', 0.0213, 'lps'),
	(414380, 126, '2015-02-15 00:37:40.000000', 'consum', 0.0214, 'lps'),
	(414381, 126, '2015-02-15 00:37:41.000000', 'consum', 0.0210, 'lps'),
	(414382, 126, '2015-02-15 00:37:42.000000', 'consum', 0.0211, 'lps'),
	(414383, 126, '2015-02-15 00:37:43.000000', 'consum', 0.0215, 'lps'),
	(414384, 126, '2015-02-15 00:37:44.000000', 'consum', 0.0217, 'lps'),
	(414385, 126, '2015-02-15 00:37:45.000000', 'consum', 0.0218, 'lps'),
	(414386, 126, '2015-02-15 00:37:46.000000', 'consum', 0.0214, 'lps'),
	(414387, 126, '2015-02-15 00:37:47.000000', 'consum', 0.0223, 'lps'),
	(414388, 126, '2015-02-15 00:37:48.000000', 'consum', 0.0219, 'lps'),
	(414389, 126, '2015-02-15 00:37:49.000000', 'consum', 0.0218, 'lps'),
	(414390, 126, '2015-02-15 00:37:50.000000', 'consum', 0.0211, 'lps'),
	(414391, 126, '2015-02-15 00:37:51.000000', 'consum', 0.0217, 'lps'),
	(414392, 126, '2015-02-15 00:37:52.000000', 'consum', 0.0214, 'lps'),
	(414393, 126, '2015-02-15 00:37:53.000000', 'consum', 0.0211, 'lps'),
	(414394, 126, '2015-02-15 00:37:54.000000', 'consum', 0.0218, 'lps'),
	(414395, 126, '2015-02-15 00:37:55.000000', 'consum', 0.0217, 'lps'),
	(414396, 126, '2015-02-15 00:37:56.000000', 'consum', 0.0211, 'lps'),
	(414397, 126, '2015-02-15 00:37:57.000000', 'consum', 0.0220, 'lps'),
	(414398, 126, '2015-02-15 00:37:58.000000', 'consum', 0.0216, 'lps'),
	(414399, 126, '2015-02-15 00:37:59.000000', 'consum', 0.0211, 'lps'),
	(414400, 126, '2015-02-15 00:38:00.000000', 'consum', 0.0210, 'lps'),
	(414401, 126, '2015-02-15 00:38:01.000000', 'consum', 0.0223, 'lps'),
	(414402, 126, '2015-02-15 00:38:02.000000', 'consum', 0.0219, 'lps'),
	(414403, 126, '2015-02-15 00:38:03.000000', 'consum', 0.0216, 'lps'),
	(414404, 126, '2015-02-15 00:38:04.000000', 'consum', 0.0215, 'lps'),
	(414405, 126, '2015-02-15 00:38:05.000000', 'consum', 0.0218, 'lps'),
	(414406, 126, '2015-02-15 00:38:06.000000', 'consum', 0.0220, 'lps'),
	(414407, 126, '2015-02-15 00:38:07.000000', 'consum', 0.0210, 'lps'),
	(414408, 126, '2015-02-15 00:38:08.000000', 'consum', 0.0221, 'lps'),
	(414409, 126, '2015-02-15 00:38:09.000000', 'consum', 0.0223, 'lps'),
	(414410, 126, '2015-02-15 00:38:10.000000', 'consum', 0.0214, 'lps'),
	(414411, 126, '2015-02-15 00:38:11.000000', 'consum', 0.0219, 'lps'),
	(414412, 126, '2015-02-15 00:38:12.000000', 'consum', 0.0217, 'lps'),
	(414413, 126, '2015-02-15 00:38:13.000000', 'consum', 0.0218, 'lps'),
	(414414, 126, '2015-02-15 00:38:14.000000', 'consum', 0.0214, 'lps'),
	(414415, 126, '2015-02-15 00:38:15.000000', 'consum', 0.0220, 'lps'),
	(414416, 126, '2015-02-15 00:38:16.000000', 'consum', 0.0223, 'lps'),
	(414417, 126, '2015-02-15 00:38:17.000000', 'consum', 0.0216, 'lps'),
	(414418, 126, '2015-02-15 00:38:18.000000', 'consum', 0.0215, 'lps'),
	(414419, 126, '2015-02-15 00:38:19.000000', 'consum', 0.0218, 'lps'),
	(414420, 126, '2015-02-15 00:38:20.000000', 'consum', 0.0220, 'lps'),
	(414421, 126, '2015-02-15 00:38:21.000000', 'consum', 0.0211, 'lps'),
	(414422, 126, '2015-02-15 00:38:22.000000', 'consum', 0.0212, 'lps'),
	(414423, 126, '2015-02-15 00:38:23.000000', 'consum', 0.0220, 'lps'),
	(414424, 126, '2015-02-15 00:38:24.000000', 'consum', 0.0223, 'lps'),
	(414425, 126, '2015-02-15 00:38:25.000000', 'consum', 0.0220, 'lps'),
	(414426, 126, '2015-02-15 00:38:26.000000', 'consum', 0.0220, 'lps'),
	(414427, 126, '2015-02-15 00:38:27.000000', 'consum', 0.0217, 'lps'),
	(414428, 126, '2015-02-15 00:38:28.000000', 'consum', 0.0215, 'lps'),
	(414429, 126, '2015-02-15 00:38:29.000000', 'consum', 0.0217, 'lps'),
	(414430, 126, '2015-02-15 00:38:30.000000', 'consum', 0.0213, 'lps'),
	(414431, 126, '2015-02-15 00:38:31.000000', 'consum', 0.0221, 'lps'),
	(414432, 126, '2015-02-15 00:38:32.000000', 'consum', 0.0216, 'lps'),
	(414433, 126, '2015-02-15 00:38:33.000000', 'consum', 0.0219, 'lps'),
	(414434, 126, '2015-02-15 00:38:34.000000', 'consum', 0.0210, 'lps'),
	(414435, 126, '2015-02-15 00:38:35.000000', 'consum', 0.0211, 'lps'),
	(414436, 126, '2015-02-15 00:38:36.000000', 'consum', 0.0215, 'lps'),
	(414437, 126, '2015-02-15 00:38:37.000000', 'consum', 0.0218, 'lps'),
	(414438, 126, '2015-02-15 00:38:38.000000', 'consum', 0.0221, 'lps'),
	(414439, 126, '2015-02-15 00:38:39.000000', 'consum', 0.0214, 'lps'),
	(414440, 126, '2015-02-15 00:38:40.000000', 'consum', 0.0212, 'lps'),
	(414441, 126, '2015-02-15 00:38:41.000000', 'consum', 0.0221, 'lps'),
	(414442, 126, '2015-02-15 00:38:42.000000', 'consum', 0.0219, 'lps'),
	(414443, 126, '2015-02-15 00:38:43.000000', 'consum', 0.0221, 'lps'),
	(414444, 126, '2015-02-15 00:38:44.000000', 'consum', 0.0213, 'lps'),
	(414445, 126, '2015-02-15 00:38:45.000000', 'consum', 0.0219, 'lps'),
	(414446, 126, '2015-02-15 00:38:46.000000', 'consum', 0.0218, 'lps'),
	(414447, 126, '2015-02-15 00:38:47.000000', 'consum', 0.0212, 'lps'),
	(414448, 126, '2015-02-15 00:38:48.000000', 'consum', 0.0210, 'lps'),
	(414449, 126, '2015-02-15 00:38:49.000000', 'consum', 0.0216, 'lps'),
	(414450, 126, '2015-02-15 00:38:50.000000', 'consum', 0.0215, 'lps'),
	(414451, 126, '2015-02-15 00:38:51.000000', 'consum', 0.0215, 'lps'),
	(414452, 126, '2015-02-15 00:38:52.000000', 'consum', 0.0220, 'lps'),
	(414453, 126, '2015-02-15 00:38:53.000000', 'consum', 0.0218, 'lps'),
	(414454, 126, '2015-02-15 00:38:54.000000', 'consum', 0.0219, 'lps'),
	(414455, 126, '2015-02-15 00:38:55.000000', 'consum', 0.0219, 'lps'),
	(414456, 126, '2015-02-15 00:38:56.000000', 'consum', 0.0215, 'lps'),
	(414457, 126, '2015-02-15 00:38:57.000000', 'consum', 0.0223, 'lps'),
	(414458, 126, '2015-02-15 00:38:58.000000', 'consum', 0.0217, 'lps'),
	(414459, 126, '2015-02-15 00:38:59.000000', 'consum', 0.0221, 'lps'),
	(414460, 126, '2015-02-15 00:39:00.000000', 'consum', 0.0216, 'lps'),
	(414461, 126, '2015-02-15 00:39:01.000000', 'consum', 0.0220, 'lps'),
	(414462, 126, '2015-02-15 00:39:02.000000', 'consum', 0.0215, 'lps'),
	(414463, 126, '2015-02-15 00:39:03.000000', 'consum', 0.0220, 'lps'),
	(414464, 126, '2015-02-15 00:39:04.000000', 'consum', 0.0216, 'lps'),
	(414465, 126, '2015-02-15 00:39:05.000000', 'consum', 0.0211, 'lps'),
	(414466, 126, '2015-02-15 00:39:06.000000', 'consum', 0.0210, 'lps'),
	(414467, 126, '2015-02-15 00:39:07.000000', 'consum', 0.0222, 'lps'),
	(414468, 126, '2015-02-15 00:39:08.000000', 'consum', 0.0217, 'lps'),
	(414469, 126, '2015-02-15 00:39:09.000000', 'consum', 0.0221, 'lps'),
	(414470, 126, '2015-02-15 00:39:10.000000', 'consum', 0.0219, 'lps'),
	(414471, 126, '2015-02-15 00:39:11.000000', 'consum', 0.0223, 'lps'),
	(414472, 126, '2015-02-15 00:39:12.000000', 'consum', 0.0220, 'lps'),
	(414473, 126, '2015-02-15 00:39:13.000000', 'consum', 0.0222, 'lps'),
	(414474, 126, '2015-02-15 00:39:14.000000', 'consum', 0.0212, 'lps'),
	(414475, 126, '2015-02-15 00:39:15.000000', 'consum', 0.0210, 'lps'),
	(414476, 126, '2015-02-15 00:39:16.000000', 'consum', 0.0222, 'lps'),
	(414477, 126, '2015-02-15 00:39:17.000000', 'consum', 0.0214, 'lps'),
	(414478, 126, '2015-02-15 00:39:18.000000', 'consum', 0.0223, 'lps'),
	(414479, 126, '2015-02-15 00:39:19.000000', 'consum', 0.0222, 'lps'),
	(414480, 126, '2015-02-15 00:39:20.000000', 'consum', 0.0216, 'lps'),
	(414481, 126, '2015-02-15 00:39:21.000000', 'consum', 0.0221, 'lps'),
	(414482, 126, '2015-02-15 00:39:22.000000', 'consum', 0.0218, 'lps'),
	(414483, 126, '2015-02-15 00:39:23.000000', 'consum', 0.0219, 'lps'),
	(414484, 126, '2015-02-15 00:39:24.000000', 'consum', 0.0215, 'lps'),
	(414485, 126, '2015-02-15 00:39:25.000000', 'consum', 0.0210, 'lps'),
	(414486, 126, '2015-02-15 00:39:26.000000', 'consum', 0.0211, 'lps'),
	(414487, 126, '2015-02-15 00:39:27.000000', 'consum', 0.0214, 'lps'),
	(414488, 126, '2015-02-15 00:39:28.000000', 'consum', 0.0215, 'lps'),
	(414489, 126, '2015-02-15 00:39:29.000000', 'consum', 0.0220, 'lps'),
	(414490, 126, '2015-02-15 00:39:30.000000', 'consum', 0.0221, 'lps'),
	(414491, 126, '2015-02-15 00:39:31.000000', 'consum', 0.0221, 'lps'),
	(414492, 126, '2015-02-15 00:39:32.000000', 'consum', 0.0217, 'lps'),
	(414493, 126, '2015-02-15 00:39:33.000000', 'consum', 0.0212, 'lps'),
	(414494, 126, '2015-02-15 00:39:34.000000', 'consum', 0.0216, 'lps'),
	(414495, 126, '2015-02-15 00:39:35.000000', 'consum', 0.0218, 'lps'),
	(414496, 126, '2015-02-15 00:39:36.000000', 'consum', 0.0218, 'lps'),
	(414497, 126, '2015-02-15 00:39:37.000000', 'consum', 0.0215, 'lps'),
	(414498, 126, '2015-02-15 00:39:38.000000', 'consum', 0.0210, 'lps'),
	(414499, 126, '2015-02-15 00:39:39.000000', 'consum', 0.0211, 'lps'),
	(414500, 126, '2015-02-15 00:39:40.000000', 'consum', 0.0215, 'lps'),
	(414501, 126, '2015-02-15 00:39:41.000000', 'consum', 0.0218, 'lps'),
	(414502, 126, '2015-02-15 00:39:42.000000', 'consum', 0.0220, 'lps'),
	(414503, 126, '2015-02-15 00:39:43.000000', 'consum', 0.0210, 'lps'),
	(414504, 126, '2015-02-15 00:39:44.000000', 'consum', 0.0222, 'lps'),
	(414505, 126, '2015-02-15 00:39:45.000000', 'consum', 0.0213, 'lps'),
	(414506, 126, '2015-02-15 00:39:46.000000', 'consum', 0.0219, 'lps'),
	(414507, 126, '2015-02-15 00:39:47.000000', 'consum', 0.0218, 'lps'),
	(414508, 126, '2015-02-15 00:39:48.000000', 'consum', 0.0211, 'lps'),
	(414509, 126, '2015-02-15 00:39:49.000000', 'consum', 0.0218, 'lps'),
	(414510, 126, '2015-02-15 00:39:50.000000', 'consum', 0.0220, 'lps'),
	(414511, 126, '2015-02-15 00:39:51.000000', 'consum', 0.0221, 'lps'),
	(414512, 126, '2015-02-15 00:39:52.000000', 'consum', 0.0223, 'lps'),
	(414513, 126, '2015-02-15 00:39:53.000000', 'consum', 0.0216, 'lps'),
	(414514, 126, '2015-02-15 00:39:54.000000', 'consum', 0.0213, 'lps'),
	(414515, 126, '2015-02-15 00:39:55.000000', 'consum', 0.0222, 'lps'),
	(414516, 126, '2015-02-15 00:39:56.000000', 'consum', 0.0218, 'lps'),
	(414517, 126, '2015-02-15 00:39:57.000000', 'consum', 0.0216, 'lps'),
	(414518, 126, '2015-02-15 00:39:58.000000', 'consum', 0.0218, 'lps'),
	(414519, 126, '2015-02-15 00:39:59.000000', 'consum', 0.0218, 'lps'),
	(414520, 126, '2015-02-15 00:40:00.000000', 'consum', 0.0211, 'lps'),
	(414521, 126, '2015-02-15 00:40:01.000000', 'consum', 0.0218, 'lps'),
	(414522, 126, '2015-02-15 00:40:02.000000', 'consum', 0.0223, 'lps'),
	(414523, 126, '2015-02-15 00:40:03.000000', 'consum', 0.0220, 'lps'),
	(414524, 126, '2015-02-15 00:40:04.000000', 'consum', 0.0210, 'lps'),
	(414525, 126, '2015-02-15 00:40:05.000000', 'consum', 0.0223, 'lps'),
	(414526, 126, '2015-02-15 00:40:06.000000', 'consum', 0.0221, 'lps'),
	(414527, 126, '2015-02-15 00:40:07.000000', 'consum', 0.0223, 'lps'),
	(414528, 126, '2015-02-15 00:40:08.000000', 'consum', 0.0216, 'lps'),
	(414529, 126, '2015-02-15 00:40:09.000000', 'consum', 0.0216, 'lps'),
	(414530, 126, '2015-02-15 00:40:10.000000', 'consum', 0.0221, 'lps'),
	(414531, 126, '2015-02-15 00:40:11.000000', 'consum', 0.0221, 'lps'),
	(414532, 126, '2015-02-15 00:40:12.000000', 'consum', 0.0217, 'lps'),
	(414533, 126, '2015-02-15 00:40:13.000000', 'consum', 0.0211, 'lps'),
	(414534, 126, '2015-02-15 00:40:14.000000', 'consum', 0.0211, 'lps'),
	(414535, 126, '2015-02-15 00:40:15.000000', 'consum', 0.0212, 'lps'),
	(414536, 126, '2015-02-15 00:40:16.000000', 'consum', 0.0218, 'lps'),
	(414537, 126, '2015-02-15 00:40:17.000000', 'consum', 0.0217, 'lps'),
	(414538, 126, '2015-02-15 00:40:18.000000', 'consum', 0.0222, 'lps'),
	(414539, 126, '2015-02-15 00:40:19.000000', 'consum', 0.0221, 'lps'),
	(414540, 126, '2015-02-15 00:40:20.000000', 'consum', 0.0214, 'lps'),
	(414541, 126, '2015-02-15 00:40:21.000000', 'consum', 0.0213, 'lps'),
	(414542, 126, '2015-02-15 00:40:22.000000', 'consum', 0.0214, 'lps'),
	(414543, 126, '2015-02-15 00:40:23.000000', 'consum', 0.0220, 'lps'),
	(414544, 126, '2015-02-15 00:40:24.000000', 'consum', 0.0220, 'lps'),
	(414545, 126, '2015-02-15 00:40:25.000000', 'consum', 0.0215, 'lps'),
	(414546, 126, '2015-02-15 00:40:26.000000', 'consum', 0.0223, 'lps'),
	(414547, 126, '2015-02-15 00:40:27.000000', 'consum', 0.0218, 'lps'),
	(414548, 126, '2015-02-15 00:40:28.000000', 'consum', 0.0210, 'lps'),
	(414549, 126, '2015-02-15 00:40:29.000000', 'consum', 0.0214, 'lps'),
	(414550, 126, '2015-02-15 00:40:30.000000', 'consum', 0.0219, 'lps'),
	(414551, 126, '2015-02-15 00:40:31.000000', 'consum', 0.0214, 'lps'),
	(414552, 126, '2015-02-15 00:40:32.000000', 'consum', 0.0216, 'lps'),
	(414553, 126, '2015-02-15 00:40:33.000000', 'consum', 0.0214, 'lps'),
	(414554, 126, '2015-02-15 00:40:34.000000', 'consum', 0.0215, 'lps'),
	(414555, 126, '2015-02-15 00:40:35.000000', 'consum', 0.0211, 'lps'),
	(414556, 126, '2015-02-15 00:40:36.000000', 'consum', 0.0211, 'lps'),
	(414557, 126, '2015-02-15 00:40:37.000000', 'consum', 0.0214, 'lps'),
	(414558, 126, '2015-02-15 00:40:38.000000', 'consum', 0.0214, 'lps'),
	(414559, 126, '2015-02-15 00:40:39.000000', 'consum', 0.0219, 'lps'),
	(414560, 126, '2015-02-15 00:40:40.000000', 'consum', 0.0213, 'lps'),
	(414561, 126, '2015-02-15 00:40:41.000000', 'consum', 0.0216, 'lps'),
	(414562, 126, '2015-02-15 00:40:42.000000', 'consum', 0.0215, 'lps'),
	(414563, 126, '2015-02-15 00:40:43.000000', 'consum', 0.0216, 'lps'),
	(414564, 126, '2015-02-15 00:40:44.000000', 'consum', 0.0213, 'lps'),
	(414565, 126, '2015-02-15 00:40:45.000000', 'consum', 0.0223, 'lps'),
	(414566, 126, '2015-02-15 00:40:46.000000', 'consum', 0.0211, 'lps'),
	(414567, 126, '2015-02-15 00:40:47.000000', 'consum', 0.0215, 'lps'),
	(414568, 126, '2015-02-15 00:40:48.000000', 'consum', 0.0221, 'lps'),
	(414569, 126, '2015-02-15 00:40:49.000000', 'consum', 0.0210, 'lps'),
	(414570, 126, '2015-02-15 00:40:50.000000', 'consum', 0.0217, 'lps'),
	(414571, 126, '2015-02-15 00:40:51.000000', 'consum', 0.0219, 'lps'),
	(414572, 126, '2015-02-15 00:40:52.000000', 'consum', 0.0218, 'lps'),
	(414573, 126, '2015-02-15 00:40:53.000000', 'consum', 0.0211, 'lps'),
	(414574, 126, '2015-02-15 00:40:54.000000', 'consum', 0.0219, 'lps'),
	(414575, 126, '2015-02-15 00:40:55.000000', 'consum', 0.0212, 'lps'),
	(414576, 126, '2015-02-15 00:40:56.000000', 'consum', 0.0219, 'lps'),
	(414577, 126, '2015-02-15 00:40:57.000000', 'consum', 0.0210, 'lps'),
	(414578, 126, '2015-02-15 00:40:58.000000', 'consum', 0.0223, 'lps'),
	(414579, 126, '2015-02-15 00:40:59.000000', 'consum', 0.0222, 'lps'),
	(414580, 126, '2015-02-15 00:41:00.000000', 'consum', 0.0218, 'lps'),
	(414581, 126, '2015-02-15 00:41:01.000000', 'consum', 0.0215, 'lps'),
	(414582, 126, '2015-02-15 00:41:02.000000', 'consum', 0.0223, 'lps'),
	(414583, 126, '2015-02-15 00:41:03.000000', 'consum', 0.0221, 'lps'),
	(414584, 126, '2015-02-15 00:41:04.000000', 'consum', 0.0212, 'lps'),
	(414585, 126, '2015-02-15 00:41:05.000000', 'consum', 0.0215, 'lps'),
	(414586, 126, '2015-02-15 00:41:06.000000', 'consum', 0.0216, 'lps'),
	(414587, 126, '2015-02-15 00:41:07.000000', 'consum', 0.0211, 'lps'),
	(414588, 126, '2015-02-15 00:41:08.000000', 'consum', 0.0210, 'lps'),
	(414589, 126, '2015-02-15 00:41:09.000000', 'consum', 0.0221, 'lps'),
	(414590, 126, '2015-02-15 00:41:10.000000', 'consum', 0.0211, 'lps'),
	(414591, 126, '2015-02-15 00:41:11.000000', 'consum', 0.0212, 'lps'),
	(414592, 126, '2015-02-15 00:41:12.000000', 'consum', 0.0218, 'lps'),
	(414593, 126, '2015-02-15 00:41:13.000000', 'consum', 0.0213, 'lps'),
	(414594, 126, '2015-02-15 00:41:14.000000', 'consum', 0.0219, 'lps'),
	(414595, 126, '2015-02-15 00:41:15.000000', 'consum', 0.0218, 'lps'),
	(414596, 126, '2015-02-15 00:41:16.000000', 'consum', 0.0223, 'lps'),
	(414597, 126, '2015-02-15 00:41:17.000000', 'consum', 0.0223, 'lps'),
	(414598, 126, '2015-02-15 00:41:18.000000', 'consum', 0.0223, 'lps'),
	(414599, 126, '2015-02-15 00:41:19.000000', 'consum', 0.0222, 'lps'),
	(414600, 126, '2015-02-15 00:41:20.000000', 'consum', 0.0217, 'lps'),
	(414601, 126, '2015-02-15 00:41:21.000000', 'consum', 0.0210, 'lps'),
	(414602, 126, '2015-02-15 00:41:22.000000', 'consum', 0.0217, 'lps'),
	(414603, 126, '2015-02-15 00:41:23.000000', 'consum', 0.0216, 'lps'),
	(414604, 126, '2015-02-15 00:41:24.000000', 'consum', 0.0221, 'lps'),
	(414605, 126, '2015-02-15 00:41:25.000000', 'consum', 0.0220, 'lps'),
	(414606, 126, '2015-02-15 00:41:26.000000', 'consum', 0.0215, 'lps'),
	(414607, 126, '2015-02-15 00:41:27.000000', 'consum', 0.0217, 'lps'),
	(414608, 126, '2015-02-15 00:41:28.000000', 'consum', 0.0216, 'lps'),
	(414609, 126, '2015-02-15 00:41:29.000000', 'consum', 0.0222, 'lps'),
	(414610, 126, '2015-02-15 00:41:30.000000', 'consum', 0.0222, 'lps'),
	(414611, 126, '2015-02-15 00:41:31.000000', 'consum', 0.0222, 'lps'),
	(414612, 126, '2015-02-15 00:41:32.000000', 'consum', 0.0221, 'lps'),
	(414613, 126, '2015-02-15 00:41:33.000000', 'consum', 0.0216, 'lps'),
	(414614, 126, '2015-02-15 00:41:34.000000', 'consum', 0.0221, 'lps'),
	(414615, 126, '2015-02-15 00:41:35.000000', 'consum', 0.0221, 'lps'),
	(414616, 126, '2015-02-15 00:41:36.000000', 'consum', 0.0215, 'lps'),
	(414617, 126, '2015-02-15 00:41:37.000000', 'consum', 0.0220, 'lps'),
	(414618, 126, '2015-02-15 00:41:38.000000', 'consum', 0.0214, 'lps'),
	(414619, 126, '2015-02-15 00:41:39.000000', 'consum', 0.0218, 'lps'),
	(414620, 126, '2015-02-15 00:41:40.000000', 'consum', 0.0223, 'lps'),
	(414621, 126, '2015-02-15 00:41:41.000000', 'consum', 0.0222, 'lps'),
	(414622, 126, '2015-02-15 00:41:42.000000', 'consum', 0.0220, 'lps'),
	(414623, 126, '2015-02-15 00:41:43.000000', 'consum', 0.0223, 'lps'),
	(414624, 126, '2015-02-15 00:41:44.000000', 'consum', 0.0217, 'lps'),
	(414625, 126, '2015-02-15 00:41:45.000000', 'consum', 0.0220, 'lps'),
	(414626, 126, '2015-02-15 00:41:46.000000', 'consum', 0.0211, 'lps'),
	(414627, 126, '2015-02-15 00:41:47.000000', 'consum', 0.0216, 'lps'),
	(414628, 126, '2015-02-15 00:41:48.000000', 'consum', 0.0221, 'lps'),
	(414629, 126, '2015-02-15 00:41:49.000000', 'consum', 0.0219, 'lps'),
	(414630, 126, '2015-02-15 00:41:50.000000', 'consum', 0.0223, 'lps'),
	(414631, 126, '2015-02-15 00:41:51.000000', 'consum', 0.0219, 'lps'),
	(414632, 126, '2015-02-15 00:41:52.000000', 'consum', 0.0218, 'lps'),
	(414633, 126, '2015-02-15 00:41:53.000000', 'consum', 0.0211, 'lps'),
	(414634, 126, '2015-02-15 00:41:54.000000', 'consum', 0.0218, 'lps'),
	(414635, 126, '2015-02-15 00:41:55.000000', 'consum', 0.0220, 'lps'),
	(414636, 126, '2015-02-15 00:41:56.000000', 'consum', 0.0222, 'lps'),
	(414637, 126, '2015-02-15 00:41:57.000000', 'consum', 0.0212, 'lps'),
	(414638, 126, '2015-02-15 00:41:58.000000', 'consum', 0.0214, 'lps'),
	(414639, 126, '2015-02-15 00:41:59.000000', 'consum', 0.0211, 'lps'),
	(414640, 126, '2015-02-15 00:42:00.000000', 'consum', 0.0218, 'lps'),
	(414641, 126, '2015-02-15 00:42:01.000000', 'consum', 0.0218, 'lps'),
	(414642, 126, '2015-02-15 00:42:02.000000', 'consum', 0.0215, 'lps'),
	(414643, 126, '2015-02-15 00:42:03.000000', 'consum', 0.0210, 'lps'),
	(414644, 126, '2015-02-15 00:42:04.000000', 'consum', 0.0223, 'lps'),
	(414645, 126, '2015-02-15 00:42:05.000000', 'consum', 0.0218, 'lps'),
	(414646, 126, '2015-02-15 00:42:06.000000', 'consum', 0.0212, 'lps'),
	(414647, 126, '2015-02-15 00:42:07.000000', 'consum', 0.0210, 'lps'),
	(414648, 126, '2015-02-15 00:42:08.000000', 'consum', 0.0218, 'lps'),
	(414649, 126, '2015-02-15 00:42:09.000000', 'consum', 0.0211, 'lps'),
	(414650, 126, '2015-02-15 00:42:10.000000', 'consum', 0.0220, 'lps'),
	(414651, 126, '2015-02-15 00:42:11.000000', 'consum', 0.0213, 'lps'),
	(414652, 126, '2015-02-15 00:42:12.000000', 'consum', 0.0223, 'lps'),
	(414653, 126, '2015-02-15 00:42:13.000000', 'consum', 0.0210, 'lps'),
	(414654, 126, '2015-02-15 00:42:14.000000', 'consum', 0.0214, 'lps'),
	(414655, 126, '2015-02-15 00:42:15.000000', 'consum', 0.0218, 'lps'),
	(414656, 126, '2015-02-15 00:42:16.000000', 'consum', 0.0222, 'lps'),
	(414657, 126, '2015-02-15 00:42:17.000000', 'consum', 0.0221, 'lps'),
	(414658, 126, '2015-02-15 00:42:18.000000', 'consum', 0.0214, 'lps'),
	(414659, 126, '2015-02-15 00:42:19.000000', 'consum', 0.0212, 'lps'),
	(414660, 126, '2015-02-15 00:42:20.000000', 'consum', 0.0210, 'lps'),
	(414661, 126, '2015-02-15 00:42:21.000000', 'consum', 0.0218, 'lps'),
	(414662, 126, '2015-02-15 00:42:22.000000', 'consum', 0.0221, 'lps'),
	(414663, 126, '2015-02-15 00:42:23.000000', 'consum', 0.0212, 'lps'),
	(414664, 126, '2015-02-15 00:42:24.000000', 'consum', 0.0219, 'lps'),
	(414665, 126, '2015-02-15 00:42:25.000000', 'consum', 0.0219, 'lps'),
	(414666, 126, '2015-02-15 00:42:26.000000', 'consum', 0.0215, 'lps'),
	(414667, 126, '2015-02-15 00:42:27.000000', 'consum', 0.0210, 'lps'),
	(414668, 126, '2015-02-15 00:42:28.000000', 'consum', 0.0210, 'lps'),
	(414669, 126, '2015-02-15 00:42:29.000000', 'consum', 0.0211, 'lps'),
	(414670, 126, '2015-02-15 00:42:30.000000', 'consum', 0.0214, 'lps'),
	(414671, 126, '2015-02-15 00:42:31.000000', 'consum', 0.0213, 'lps'),
	(414672, 126, '2015-02-15 00:42:32.000000', 'consum', 0.0216, 'lps'),
	(414673, 126, '2015-02-15 00:42:33.000000', 'consum', 0.0217, 'lps'),
	(414674, 126, '2015-02-15 00:42:34.000000', 'consum', 0.0213, 'lps'),
	(414675, 126, '2015-02-15 00:42:35.000000', 'consum', 0.0220, 'lps'),
	(414676, 126, '2015-02-15 00:42:36.000000', 'consum', 0.0222, 'lps'),
	(414677, 126, '2015-02-15 00:42:37.000000', 'consum', 0.0214, 'lps'),
	(414678, 126, '2015-02-15 00:42:38.000000', 'consum', 0.0221, 'lps'),
	(414679, 126, '2015-02-15 00:42:39.000000', 'consum', 0.0211, 'lps'),
	(414680, 126, '2015-02-15 00:42:40.000000', 'consum', 0.0212, 'lps'),
	(414681, 126, '2015-02-15 00:42:41.000000', 'consum', 0.0216, 'lps'),
	(414682, 126, '2015-02-15 00:42:42.000000', 'consum', 0.0220, 'lps'),
	(414683, 126, '2015-02-15 00:42:43.000000', 'consum', 0.0217, 'lps'),
	(414684, 126, '2015-02-15 00:42:44.000000', 'consum', 0.0216, 'lps'),
	(414685, 126, '2015-02-15 00:42:45.000000', 'consum', 0.0218, 'lps'),
	(414686, 126, '2015-02-15 00:42:46.000000', 'consum', 0.0218, 'lps'),
	(414687, 126, '2015-02-15 00:42:47.000000', 'consum', 0.0213, 'lps'),
	(414688, 126, '2015-02-15 00:42:48.000000', 'consum', 0.0215, 'lps'),
	(414689, 126, '2015-02-15 00:42:49.000000', 'consum', 0.0214, 'lps'),
	(414690, 126, '2015-02-15 00:42:50.000000', 'consum', 0.0214, 'lps'),
	(414691, 126, '2015-02-15 00:42:51.000000', 'consum', 0.0220, 'lps'),
	(414692, 126, '2015-02-15 00:42:52.000000', 'consum', 0.0218, 'lps'),
	(414693, 126, '2015-02-15 00:42:53.000000', 'consum', 0.0223, 'lps'),
	(414694, 126, '2015-02-15 00:42:54.000000', 'consum', 0.0221, 'lps'),
	(414695, 126, '2015-02-15 00:42:55.000000', 'consum', 0.0214, 'lps'),
	(414696, 126, '2015-02-15 00:42:56.000000', 'consum', 0.0213, 'lps'),
	(414697, 126, '2015-02-15 00:42:57.000000', 'consum', 0.0211, 'lps'),
	(414698, 126, '2015-02-15 00:42:58.000000', 'consum', 0.0223, 'lps'),
	(414699, 126, '2015-02-15 00:42:59.000000', 'consum', 0.0214, 'lps'),
	(414700, 126, '2015-02-15 00:43:00.000000', 'consum', 0.0219, 'lps'),
	(414701, 126, '2015-02-15 00:43:01.000000', 'consum', 0.0216, 'lps'),
	(414702, 126, '2015-02-15 00:43:02.000000', 'consum', 0.0213, 'lps'),
	(414703, 126, '2015-02-15 00:43:03.000000', 'consum', 0.0222, 'lps'),
	(414704, 126, '2015-02-15 00:43:04.000000', 'consum', 0.0218, 'lps'),
	(414705, 126, '2015-02-15 00:43:05.000000', 'consum', 0.0214, 'lps'),
	(414706, 126, '2015-02-15 00:43:06.000000', 'consum', 0.0223, 'lps'),
	(414707, 126, '2015-02-15 00:43:07.000000', 'consum', 0.0221, 'lps'),
	(414708, 126, '2015-02-15 00:43:08.000000', 'consum', 0.0211, 'lps'),
	(414709, 126, '2015-02-15 00:43:09.000000', 'consum', 0.0212, 'lps'),
	(414710, 126, '2015-02-15 00:43:10.000000', 'consum', 0.0215, 'lps'),
	(414711, 126, '2015-02-15 00:43:11.000000', 'consum', 0.0219, 'lps'),
	(414712, 126, '2015-02-15 00:43:12.000000', 'consum', 0.0210, 'lps'),
	(414713, 126, '2015-02-15 00:43:13.000000', 'consum', 0.0213, 'lps'),
	(414714, 126, '2015-02-15 00:43:14.000000', 'consum', 0.0211, 'lps'),
	(414715, 126, '2015-02-15 00:43:15.000000', 'consum', 0.0219, 'lps'),
	(414716, 126, '2015-02-15 00:43:16.000000', 'consum', 0.0210, 'lps'),
	(414717, 126, '2015-02-15 00:43:17.000000', 'consum', 0.0213, 'lps'),
	(414718, 126, '2015-02-15 00:43:18.000000', 'consum', 0.0211, 'lps'),
	(414719, 126, '2015-02-15 00:43:19.000000', 'consum', 0.0222, 'lps'),
	(414720, 126, '2015-02-15 00:43:20.000000', 'consum', 0.0223, 'lps'),
	(414721, 126, '2015-02-15 00:43:21.000000', 'consum', 0.0214, 'lps'),
	(414722, 126, '2015-02-15 00:43:22.000000', 'consum', 0.0220, 'lps'),
	(414723, 126, '2015-02-15 00:43:23.000000', 'consum', 0.0221, 'lps'),
	(414724, 126, '2015-02-15 00:43:24.000000', 'consum', 0.0219, 'lps'),
	(414725, 126, '2015-02-15 00:43:25.000000', 'consum', 0.0223, 'lps'),
	(414726, 126, '2015-02-15 00:43:26.000000', 'consum', 0.0219, 'lps'),
	(414727, 126, '2015-02-15 00:43:27.000000', 'consum', 0.0217, 'lps'),
	(414728, 126, '2015-02-15 00:43:28.000000', 'consum', 0.0218, 'lps'),
	(414729, 126, '2015-02-15 00:43:29.000000', 'consum', 0.0214, 'lps'),
	(414730, 126, '2015-02-15 00:43:30.000000', 'consum', 0.0223, 'lps'),
	(414731, 126, '2015-02-15 00:43:31.000000', 'consum', 0.0220, 'lps'),
	(414732, 126, '2015-02-15 00:43:32.000000', 'consum', 0.0223, 'lps'),
	(414733, 126, '2015-02-15 00:43:33.000000', 'consum', 0.0216, 'lps'),
	(414734, 126, '2015-02-15 00:43:34.000000', 'consum', 0.0214, 'lps'),
	(414735, 126, '2015-02-15 00:43:35.000000', 'consum', 0.0215, 'lps'),
	(414736, 126, '2015-02-15 00:43:36.000000', 'consum', 0.0222, 'lps'),
	(414737, 126, '2015-02-15 00:43:37.000000', 'consum', 0.0213, 'lps'),
	(414738, 126, '2015-02-15 00:43:38.000000', 'consum', 0.0219, 'lps'),
	(414739, 126, '2015-02-15 00:43:39.000000', 'consum', 0.0217, 'lps'),
	(414740, 126, '2015-02-15 00:43:40.000000', 'consum', 0.0218, 'lps'),
	(414741, 126, '2015-02-15 00:43:41.000000', 'consum', 0.0218, 'lps'),
	(414742, 126, '2015-02-15 00:43:42.000000', 'consum', 0.0211, 'lps'),
	(414743, 126, '2015-02-15 00:43:43.000000', 'consum', 0.0222, 'lps'),
	(414744, 126, '2015-02-15 00:43:44.000000', 'consum', 0.0223, 'lps'),
	(414745, 126, '2015-02-15 00:43:45.000000', 'consum', 0.0210, 'lps'),
	(414746, 126, '2015-02-15 00:43:46.000000', 'consum', 0.0216, 'lps'),
	(414747, 126, '2015-02-15 00:43:47.000000', 'consum', 0.0211, 'lps'),
	(414748, 126, '2015-02-15 00:43:48.000000', 'consum', 0.0213, 'lps'),
	(414749, 126, '2015-02-15 00:43:49.000000', 'consum', 0.0221, 'lps'),
	(414750, 126, '2015-02-15 00:43:50.000000', 'consum', 0.0213, 'lps'),
	(414751, 126, '2015-02-15 00:43:51.000000', 'consum', 0.0210, 'lps'),
	(414752, 126, '2015-02-15 00:43:52.000000', 'consum', 0.0212, 'lps'),
	(414753, 126, '2015-02-15 00:43:53.000000', 'consum', 0.0222, 'lps'),
	(414754, 126, '2015-02-15 00:43:54.000000', 'consum', 0.0221, 'lps'),
	(414755, 126, '2015-02-15 00:43:55.000000', 'consum', 0.0217, 'lps'),
	(414756, 126, '2015-02-15 00:43:56.000000', 'consum', 0.0213, 'lps'),
	(414757, 126, '2015-02-15 00:43:57.000000', 'consum', 0.0217, 'lps'),
	(414758, 126, '2015-02-15 00:43:58.000000', 'consum', 0.0211, 'lps'),
	(414759, 126, '2015-02-15 00:43:59.000000', 'consum', 0.0219, 'lps'),
	(414760, 126, '2015-02-15 00:44:00.000000', 'consum', 0.0213, 'lps'),
	(414761, 126, '2015-02-15 00:44:01.000000', 'consum', 0.0214, 'lps'),
	(414762, 126, '2015-02-15 00:44:02.000000', 'consum', 0.0220, 'lps'),
	(414763, 126, '2015-02-15 00:44:03.000000', 'consum', 0.0220, 'lps'),
	(414764, 126, '2015-02-15 00:44:04.000000', 'consum', 0.0216, 'lps'),
	(414765, 126, '2015-02-15 00:44:05.000000', 'consum', 0.0223, 'lps'),
	(414766, 126, '2015-02-15 00:44:06.000000', 'consum', 0.0217, 'lps'),
	(414767, 126, '2015-02-15 00:44:07.000000', 'consum', 0.0221, 'lps'),
	(414768, 126, '2015-02-15 00:44:08.000000', 'consum', 0.0217, 'lps'),
	(414769, 126, '2015-02-15 00:44:09.000000', 'consum', 0.0214, 'lps'),
	(414770, 126, '2015-02-15 00:44:10.000000', 'consum', 0.0222, 'lps'),
	(414771, 126, '2015-02-15 00:44:11.000000', 'consum', 0.0217, 'lps'),
	(414772, 126, '2015-02-15 00:44:12.000000', 'consum', 0.0211, 'lps'),
	(414773, 126, '2015-02-15 00:44:13.000000', 'consum', 0.0222, 'lps'),
	(414774, 126, '2015-02-15 00:44:14.000000', 'consum', 0.0210, 'lps'),
	(414775, 126, '2015-02-15 00:44:15.000000', 'consum', 0.0215, 'lps'),
	(414776, 126, '2015-02-15 00:44:16.000000', 'consum', 0.0223, 'lps'),
	(414777, 126, '2015-02-15 00:44:17.000000', 'consum', 0.0219, 'lps'),
	(414778, 126, '2015-02-15 00:44:18.000000', 'consum', 0.0216, 'lps'),
	(414779, 126, '2015-02-15 00:44:19.000000', 'consum', 0.0215, 'lps'),
	(414780, 126, '2015-02-15 00:44:20.000000', 'consum', 0.0216, 'lps'),
	(414781, 126, '2015-02-15 00:44:21.000000', 'consum', 0.0211, 'lps'),
	(414782, 126, '2015-02-15 00:44:22.000000', 'consum', 0.0212, 'lps'),
	(414783, 126, '2015-02-15 00:44:23.000000', 'consum', 0.0218, 'lps'),
	(414784, 126, '2015-02-15 00:44:24.000000', 'consum', 0.0214, 'lps'),
	(414785, 126, '2015-02-15 00:44:25.000000', 'consum', 0.0222, 'lps'),
	(414786, 126, '2015-02-15 00:44:26.000000', 'consum', 0.0219, 'lps'),
	(414787, 126, '2015-02-15 00:44:27.000000', 'consum', 0.0216, 'lps'),
	(414788, 126, '2015-02-15 00:44:28.000000', 'consum', 0.0216, 'lps'),
	(414789, 126, '2015-02-15 00:44:29.000000', 'consum', 0.0220, 'lps'),
	(414790, 126, '2015-02-15 00:44:30.000000', 'consum', 0.0215, 'lps'),
	(414791, 126, '2015-02-15 00:44:31.000000', 'consum', 0.0220, 'lps'),
	(414792, 126, '2015-02-15 00:44:32.000000', 'consum', 0.0218, 'lps'),
	(414793, 126, '2015-02-15 00:44:33.000000', 'consum', 0.0219, 'lps'),
	(414794, 126, '2015-02-15 00:44:34.000000', 'consum', 0.0218, 'lps'),
	(414795, 126, '2015-02-15 00:44:35.000000', 'consum', 0.0210, 'lps'),
	(414796, 126, '2015-02-15 00:44:36.000000', 'consum', 0.0213, 'lps'),
	(414797, 126, '2015-02-15 00:44:37.000000', 'consum', 0.0212, 'lps'),
	(414798, 126, '2015-02-15 00:44:38.000000', 'consum', 0.0210, 'lps'),
	(414799, 126, '2015-02-15 00:44:39.000000', 'consum', 0.0221, 'lps'),
	(414800, 126, '2015-02-15 00:44:40.000000', 'consum', 0.0222, 'lps'),
	(414801, 126, '2015-02-15 00:44:41.000000', 'consum', 0.0212, 'lps'),
	(414802, 126, '2015-02-15 00:44:42.000000', 'consum', 0.0210, 'lps'),
	(414803, 126, '2015-02-15 00:44:43.000000', 'consum', 0.0218, 'lps'),
	(414804, 126, '2015-02-15 00:44:44.000000', 'consum', 0.0211, 'lps'),
	(414805, 126, '2015-02-15 00:44:45.000000', 'consum', 0.0219, 'lps'),
	(414806, 126, '2015-02-15 00:44:46.000000', 'consum', 0.0223, 'lps'),
	(414807, 126, '2015-02-15 00:44:47.000000', 'consum', 0.0223, 'lps'),
	(414808, 126, '2015-02-15 00:44:48.000000', 'consum', 0.0220, 'lps'),
	(414809, 126, '2015-02-15 00:44:49.000000', 'consum', 0.0210, 'lps'),
	(414810, 126, '2015-02-15 00:44:50.000000', 'consum', 0.0223, 'lps'),
	(414811, 126, '2015-02-15 00:44:51.000000', 'consum', 0.0217, 'lps'),
	(414812, 126, '2015-02-15 00:44:52.000000', 'consum', 0.0223, 'lps'),
	(414813, 126, '2015-02-15 00:44:53.000000', 'consum', 0.0223, 'lps'),
	(414814, 126, '2015-02-15 00:44:54.000000', 'consum', 0.0212, 'lps'),
	(414815, 126, '2015-02-15 00:44:55.000000', 'consum', 0.0222, 'lps'),
	(414816, 126, '2015-02-15 00:44:56.000000', 'consum', 0.0222, 'lps'),
	(414817, 126, '2015-02-15 00:44:57.000000', 'consum', 0.0220, 'lps'),
	(414818, 126, '2015-02-15 00:44:58.000000', 'consum', 0.0212, 'lps'),
	(414819, 126, '2015-02-15 00:44:59.000000', 'consum', 0.0219, 'lps'),
	(414820, 126, '2015-02-15 00:45:00.000000', 'consum', 0.0220, 'lps'),
	(414821, 126, '2015-02-15 00:45:01.000000', 'consum', 0.0221, 'lps'),
	(414822, 126, '2015-02-15 00:45:02.000000', 'consum', 0.0222, 'lps'),
	(414823, 126, '2015-02-15 00:45:03.000000', 'consum', 0.0222, 'lps'),
	(414824, 126, '2015-02-15 00:45:04.000000', 'consum', 0.0221, 'lps'),
	(414825, 126, '2015-02-15 00:45:05.000000', 'consum', 0.0217, 'lps'),
	(414826, 126, '2015-02-15 00:45:06.000000', 'consum', 0.0210, 'lps'),
	(414827, 126, '2015-02-15 00:45:07.000000', 'consum', 0.0220, 'lps'),
	(414828, 126, '2015-02-15 00:45:08.000000', 'consum', 0.0219, 'lps'),
	(414829, 126, '2015-02-15 00:45:09.000000', 'consum', 0.0212, 'lps'),
	(414830, 126, '2015-02-15 00:45:10.000000', 'consum', 0.0219, 'lps'),
	(414831, 126, '2015-02-15 00:45:11.000000', 'consum', 0.0221, 'lps'),
	(414832, 126, '2015-02-15 00:45:12.000000', 'consum', 0.0211, 'lps'),
	(414833, 126, '2015-02-15 00:45:13.000000', 'consum', 0.0210, 'lps'),
	(414834, 126, '2015-02-15 00:45:14.000000', 'consum', 0.0222, 'lps'),
	(414835, 126, '2015-02-15 00:45:15.000000', 'consum', 0.0216, 'lps'),
	(414836, 126, '2015-02-15 00:45:16.000000', 'consum', 0.0217, 'lps'),
	(414837, 126, '2015-02-15 00:45:17.000000', 'consum', 0.0213, 'lps'),
	(414838, 126, '2015-02-15 00:45:18.000000', 'consum', 0.0220, 'lps'),
	(414839, 126, '2015-02-15 00:45:19.000000', 'consum', 0.0222, 'lps'),
	(414840, 126, '2015-02-15 00:45:20.000000', 'consum', 0.0215, 'lps'),
	(414841, 126, '2015-02-15 00:45:21.000000', 'consum', 0.0211, 'lps'),
	(414842, 126, '2015-02-15 00:45:22.000000', 'consum', 0.0216, 'lps'),
	(414843, 126, '2015-02-15 00:45:23.000000', 'consum', 0.0211, 'lps'),
	(414844, 126, '2015-02-15 00:45:24.000000', 'consum', 0.0223, 'lps'),
	(414845, 126, '2015-02-15 00:45:25.000000', 'consum', 0.0219, 'lps'),
	(414846, 126, '2015-02-15 00:45:26.000000', 'consum', 0.0214, 'lps'),
	(414847, 126, '2015-02-15 00:45:27.000000', 'consum', 0.0218, 'lps'),
	(414848, 126, '2015-02-15 00:45:28.000000', 'consum', 0.0213, 'lps'),
	(414849, 126, '2015-02-15 00:45:29.000000', 'consum', 0.0212, 'lps'),
	(414850, 126, '2015-02-15 00:45:30.000000', 'consum', 0.0214, 'lps'),
	(414851, 126, '2015-02-15 00:45:31.000000', 'consum', 0.0210, 'lps'),
	(414852, 126, '2015-02-15 00:45:32.000000', 'consum', 0.0211, 'lps'),
	(414853, 126, '2015-02-15 00:45:33.000000', 'consum', 0.0218, 'lps'),
	(414854, 126, '2015-02-15 00:45:34.000000', 'consum', 0.0220, 'lps'),
	(414855, 126, '2015-02-15 00:45:35.000000', 'consum', 0.0222, 'lps'),
	(414856, 126, '2015-02-15 00:45:36.000000', 'consum', 0.0211, 'lps'),
	(414857, 126, '2015-02-15 00:45:37.000000', 'consum', 0.0221, 'lps'),
	(414858, 126, '2015-02-15 00:45:38.000000', 'consum', 0.0222, 'lps'),
	(414859, 126, '2015-02-15 00:45:39.000000', 'consum', 0.0211, 'lps'),
	(414860, 126, '2015-02-15 00:45:40.000000', 'consum', 0.0221, 'lps'),
	(414861, 126, '2015-02-15 00:45:41.000000', 'consum', 0.0218, 'lps'),
	(414862, 126, '2015-02-15 00:45:42.000000', 'consum', 0.0219, 'lps'),
	(414863, 126, '2015-02-15 00:45:43.000000', 'consum', 0.0218, 'lps'),
	(414864, 126, '2015-02-15 00:45:44.000000', 'consum', 0.0211, 'lps'),
	(414865, 126, '2015-02-15 00:45:45.000000', 'consum', 0.0218, 'lps'),
	(414866, 126, '2015-02-15 00:45:46.000000', 'consum', 0.0221, 'lps'),
	(414867, 126, '2015-02-15 00:45:47.000000', 'consum', 0.0214, 'lps'),
	(414868, 126, '2015-02-15 00:45:48.000000', 'consum', 0.0210, 'lps'),
	(414869, 126, '2015-02-15 00:45:49.000000', 'consum', 0.0214, 'lps'),
	(414870, 126, '2015-02-15 00:45:50.000000', 'consum', 0.0218, 'lps'),
	(414871, 126, '2015-02-15 00:45:51.000000', 'consum', 0.0221, 'lps'),
	(414872, 126, '2015-02-15 00:45:52.000000', 'consum', 0.0214, 'lps'),
	(414873, 126, '2015-02-15 00:45:53.000000', 'consum', 0.0213, 'lps'),
	(414874, 126, '2015-02-15 00:45:54.000000', 'consum', 0.0214, 'lps'),
	(414875, 126, '2015-02-15 00:45:55.000000', 'consum', 0.0223, 'lps'),
	(414876, 126, '2015-02-15 00:45:56.000000', 'consum', 0.0219, 'lps'),
	(414877, 126, '2015-02-15 00:45:57.000000', 'consum', 0.0216, 'lps'),
	(414878, 126, '2015-02-15 00:45:58.000000', 'consum', 0.0215, 'lps'),
	(414879, 126, '2015-02-15 00:45:59.000000', 'consum', 0.0219, 'lps'),
	(414880, 126, '2015-02-15 00:46:00.000000', 'consum', 0.0223, 'lps'),
	(414881, 126, '2015-02-15 00:46:01.000000', 'consum', 0.0210, 'lps'),
	(414882, 126, '2015-02-15 00:46:02.000000', 'consum', 0.0212, 'lps'),
	(414883, 126, '2015-02-15 00:46:03.000000', 'consum', 0.0222, 'lps'),
	(414884, 126, '2015-02-15 00:46:04.000000', 'consum', 0.0223, 'lps'),
	(414885, 126, '2015-02-15 00:46:05.000000', 'consum', 0.0211, 'lps'),
	(414886, 126, '2015-02-15 00:46:06.000000', 'consum', 0.0218, 'lps'),
	(414887, 126, '2015-02-15 00:46:07.000000', 'consum', 0.0218, 'lps'),
	(414888, 126, '2015-02-15 00:46:08.000000', 'consum', 0.0214, 'lps'),
	(414889, 126, '2015-02-15 00:46:09.000000', 'consum', 0.0220, 'lps'),
	(414890, 126, '2015-02-15 00:46:10.000000', 'consum', 0.0223, 'lps'),
	(414891, 126, '2015-02-15 00:46:11.000000', 'consum', 0.0214, 'lps'),
	(414892, 126, '2015-02-15 00:46:12.000000', 'consum', 0.0222, 'lps'),
	(414893, 126, '2015-02-15 00:46:13.000000', 'consum', 0.0217, 'lps'),
	(414894, 126, '2015-02-15 00:46:14.000000', 'consum', 0.0221, 'lps'),
	(414895, 126, '2015-02-15 00:46:15.000000', 'consum', 0.0217, 'lps'),
	(414896, 126, '2015-02-15 00:46:16.000000', 'consum', 0.0211, 'lps'),
	(414897, 126, '2015-02-15 00:46:17.000000', 'consum', 0.0210, 'lps'),
	(414898, 126, '2015-02-15 00:46:18.000000', 'consum', 0.0220, 'lps'),
	(414899, 126, '2015-02-15 00:46:19.000000', 'consum', 0.0218, 'lps'),
	(414900, 126, '2015-02-15 00:46:20.000000', 'consum', 0.0221, 'lps'),
	(414901, 126, '2015-02-15 00:46:21.000000', 'consum', 0.0213, 'lps'),
	(414902, 126, '2015-02-15 00:46:22.000000', 'consum', 0.0223, 'lps'),
	(414903, 126, '2015-02-15 00:46:23.000000', 'consum', 0.0210, 'lps'),
	(414904, 126, '2015-02-15 00:46:24.000000', 'consum', 0.0214, 'lps'),
	(414905, 126, '2015-02-15 00:46:25.000000', 'consum', 0.0215, 'lps'),
	(414906, 126, '2015-02-15 00:46:26.000000', 'consum', 0.0210, 'lps'),
	(414907, 126, '2015-02-15 00:46:27.000000', 'consum', 0.0211, 'lps'),
	(414908, 126, '2015-02-15 00:46:28.000000', 'consum', 0.0215, 'lps'),
	(414909, 126, '2015-02-15 00:46:29.000000', 'consum', 0.0219, 'lps'),
	(414910, 126, '2015-02-15 00:46:30.000000', 'consum', 0.0212, 'lps'),
	(414911, 126, '2015-02-15 00:46:31.000000', 'consum', 0.0223, 'lps'),
	(414912, 126, '2015-02-15 00:46:32.000000', 'consum', 0.0212, 'lps'),
	(414913, 126, '2015-02-15 00:46:33.000000', 'consum', 0.0223, 'lps'),
	(414914, 126, '2015-02-15 00:46:34.000000', 'consum', 0.0215, 'lps'),
	(414915, 126, '2015-02-15 00:46:35.000000', 'consum', 0.0211, 'lps'),
	(414916, 126, '2015-02-15 00:46:36.000000', 'consum', 0.0213, 'lps'),
	(414917, 126, '2015-02-15 00:46:37.000000', 'consum', 0.0210, 'lps'),
	(414918, 126, '2015-02-15 00:46:38.000000', 'consum', 0.0215, 'lps'),
	(414919, 126, '2015-02-15 00:46:39.000000', 'consum', 0.0220, 'lps'),
	(414920, 126, '2015-02-15 00:46:40.000000', 'consum', 0.0218, 'lps'),
	(414921, 126, '2015-02-15 00:46:41.000000', 'consum', 0.0220, 'lps'),
	(414922, 126, '2015-02-15 00:46:42.000000', 'consum', 0.0223, 'lps'),
	(414923, 126, '2015-02-15 00:46:43.000000', 'consum', 0.0216, 'lps'),
	(414924, 126, '2015-02-15 00:46:44.000000', 'consum', 0.0216, 'lps'),
	(414925, 126, '2015-02-15 00:46:45.000000', 'consum', 0.0210, 'lps'),
	(414926, 126, '2015-02-15 00:46:46.000000', 'consum', 0.0219, 'lps'),
	(414927, 126, '2015-02-15 00:46:47.000000', 'consum', 0.0212, 'lps'),
	(414928, 126, '2015-02-15 00:46:48.000000', 'consum', 0.0222, 'lps'),
	(414929, 126, '2015-02-15 00:46:49.000000', 'consum', 0.0211, 'lps'),
	(414930, 126, '2015-02-15 00:46:50.000000', 'consum', 0.0219, 'lps'),
	(414931, 126, '2015-02-15 00:46:51.000000', 'consum', 0.0211, 'lps'),
	(414932, 126, '2015-02-15 00:46:52.000000', 'consum', 0.0217, 'lps'),
	(414933, 126, '2015-02-15 00:46:53.000000', 'consum', 0.0214, 'lps'),
	(414934, 126, '2015-02-15 00:46:54.000000', 'consum', 0.0210, 'lps'),
	(414935, 126, '2015-02-15 00:46:55.000000', 'consum', 0.0211, 'lps'),
	(414936, 126, '2015-02-15 00:46:56.000000', 'consum', 0.0215, 'lps'),
	(414937, 126, '2015-02-15 00:46:57.000000', 'consum', 0.0218, 'lps'),
	(414938, 126, '2015-02-15 00:46:58.000000', 'consum', 0.0221, 'lps'),
	(414939, 126, '2015-02-15 00:46:59.000000', 'consum', 0.0216, 'lps'),
	(414940, 126, '2015-02-15 00:47:00.000000', 'consum', 0.0221, 'lps'),
	(414941, 126, '2015-02-15 00:47:01.000000', 'consum', 0.0218, 'lps'),
	(414942, 126, '2015-02-15 00:47:02.000000', 'consum', 0.0216, 'lps'),
	(414943, 126, '2015-02-15 00:47:03.000000', 'consum', 0.0220, 'lps'),
	(414944, 126, '2015-02-15 00:47:04.000000', 'consum', 0.0212, 'lps'),
	(414945, 126, '2015-02-15 00:47:05.000000', 'consum', 0.0219, 'lps'),
	(414946, 126, '2015-02-15 00:47:06.000000', 'consum', 0.0221, 'lps'),
	(414947, 126, '2015-02-15 00:47:07.000000', 'consum', 0.0210, 'lps'),
	(414948, 126, '2015-02-15 00:47:08.000000', 'consum', 0.0220, 'lps'),
	(414949, 126, '2015-02-15 00:47:09.000000', 'consum', 0.0220, 'lps'),
	(414950, 126, '2015-02-15 00:47:10.000000', 'consum', 0.0218, 'lps'),
	(414951, 126, '2015-02-15 00:47:11.000000', 'consum', 0.0217, 'lps'),
	(414952, 126, '2015-02-15 00:47:12.000000', 'consum', 0.0223, 'lps'),
	(414953, 126, '2015-02-15 00:47:13.000000', 'consum', 0.0212, 'lps'),
	(414954, 126, '2015-02-15 00:47:14.000000', 'consum', 0.0210, 'lps'),
	(414955, 126, '2015-02-15 00:47:15.000000', 'consum', 0.0218, 'lps'),
	(414956, 126, '2015-02-15 00:47:16.000000', 'consum', 0.0223, 'lps'),
	(414957, 126, '2015-02-15 00:47:17.000000', 'consum', 0.0211, 'lps'),
	(414958, 126, '2015-02-15 00:47:18.000000', 'consum', 0.0215, 'lps'),
	(414959, 126, '2015-02-15 00:47:19.000000', 'consum', 0.0222, 'lps'),
	(414960, 126, '2015-02-15 00:47:20.000000', 'consum', 0.0211, 'lps'),
	(414961, 126, '2015-02-15 00:47:21.000000', 'consum', 0.0223, 'lps'),
	(414962, 126, '2015-02-15 00:47:22.000000', 'consum', 0.0216, 'lps'),
	(414963, 126, '2015-02-15 00:47:23.000000', 'consum', 0.0214, 'lps'),
	(414964, 126, '2015-02-15 00:47:24.000000', 'consum', 0.0214, 'lps'),
	(414965, 126, '2015-02-15 00:47:25.000000', 'consum', 0.0218, 'lps'),
	(414966, 126, '2015-02-15 00:47:26.000000', 'consum', 0.0223, 'lps'),
	(414967, 126, '2015-02-15 00:47:27.000000', 'consum', 0.0222, 'lps'),
	(414968, 126, '2015-02-15 00:47:28.000000', 'consum', 0.0221, 'lps'),
	(414969, 126, '2015-02-15 00:47:29.000000', 'consum', 0.0216, 'lps'),
	(414970, 126, '2015-02-15 00:47:30.000000', 'consum', 0.0222, 'lps'),
	(414971, 126, '2015-02-15 00:47:31.000000', 'consum', 0.0223, 'lps'),
	(414972, 126, '2015-02-15 00:47:32.000000', 'consum', 0.0211, 'lps'),
	(414973, 126, '2015-02-15 00:47:33.000000', 'consum', 0.0217, 'lps'),
	(414974, 126, '2015-02-15 00:47:34.000000', 'consum', 0.0216, 'lps'),
	(414975, 126, '2015-02-15 00:47:35.000000', 'consum', 0.0221, 'lps'),
	(414976, 126, '2015-02-15 00:47:36.000000', 'consum', 0.0219, 'lps'),
	(414977, 126, '2015-02-15 00:47:37.000000', 'consum', 0.0220, 'lps'),
	(414978, 126, '2015-02-15 00:47:38.000000', 'consum', 0.0223, 'lps'),
	(414979, 126, '2015-02-15 00:47:39.000000', 'consum', 0.0214, 'lps'),
	(414980, 126, '2015-02-15 00:47:40.000000', 'consum', 0.0221, 'lps'),
	(414981, 126, '2015-02-15 00:47:41.000000', 'consum', 0.0211, 'lps'),
	(414982, 126, '2015-02-15 00:47:42.000000', 'consum', 0.0210, 'lps'),
	(414983, 126, '2015-02-15 00:47:43.000000', 'consum', 0.0223, 'lps'),
	(414984, 126, '2015-02-15 00:47:44.000000', 'consum', 0.0219, 'lps'),
	(414985, 126, '2015-02-15 00:47:45.000000', 'consum', 0.0218, 'lps'),
	(414986, 126, '2015-02-15 00:47:46.000000', 'consum', 0.0222, 'lps'),
	(414987, 126, '2015-02-15 00:47:47.000000', 'consum', 0.0221, 'lps'),
	(414988, 126, '2015-02-15 00:47:48.000000', 'consum', 0.0212, 'lps'),
	(414989, 126, '2015-02-15 00:47:49.000000', 'consum', 0.0216, 'lps'),
	(414990, 126, '2015-02-15 00:47:50.000000', 'consum', 0.0222, 'lps'),
	(414991, 126, '2015-02-15 00:47:51.000000', 'consum', 0.0210, 'lps'),
	(414992, 126, '2015-02-15 00:47:52.000000', 'consum', 0.0215, 'lps'),
	(414993, 126, '2015-02-15 00:47:53.000000', 'consum', 0.0222, 'lps'),
	(414994, 126, '2015-02-15 00:47:54.000000', 'consum', 0.0215, 'lps'),
	(414995, 126, '2015-02-15 00:47:55.000000', 'consum', 0.0213, 'lps'),
	(414996, 126, '2015-02-15 00:47:56.000000', 'consum', 0.0210, 'lps'),
	(414997, 126, '2015-02-15 00:47:57.000000', 'consum', 0.0217, 'lps'),
	(414998, 126, '2015-02-15 00:47:58.000000', 'consum', 0.0218, 'lps'),
	(414999, 126, '2015-02-15 00:47:59.000000', 'consum', 0.0216, 'lps'),
	(415000, 126, '2015-02-15 00:48:00.000000', 'consum', 0.0215, 'lps'),
	(415001, 126, '2015-02-15 00:48:01.000000', 'consum', 0.0216, 'lps'),
	(415002, 126, '2015-02-15 00:48:02.000000', 'consum', 0.0212, 'lps'),
	(415003, 126, '2015-02-15 00:48:03.000000', 'consum', 0.0219, 'lps'),
	(415004, 126, '2015-02-15 00:48:04.000000', 'consum', 0.0220, 'lps'),
	(415005, 126, '2015-02-15 00:48:05.000000', 'consum', 0.0218, 'lps'),
	(415006, 126, '2015-02-15 00:48:06.000000', 'consum', 0.0222, 'lps'),
	(415007, 126, '2015-02-15 00:48:07.000000', 'consum', 0.0217, 'lps'),
	(415008, 126, '2015-02-15 00:48:08.000000', 'consum', 0.0222, 'lps'),
	(415009, 126, '2015-02-15 00:48:09.000000', 'consum', 0.0211, 'lps'),
	(415010, 126, '2015-02-15 00:48:10.000000', 'consum', 0.0218, 'lps'),
	(415011, 126, '2015-02-15 00:48:11.000000', 'consum', 0.0222, 'lps'),
	(415012, 126, '2015-02-15 00:48:12.000000', 'consum', 0.0219, 'lps'),
	(415013, 126, '2015-02-15 00:48:13.000000', 'consum', 0.0218, 'lps'),
	(415014, 126, '2015-02-15 00:48:14.000000', 'consum', 0.0211, 'lps'),
	(415015, 126, '2015-02-15 00:48:15.000000', 'consum', 0.0218, 'lps'),
	(415016, 126, '2015-02-15 00:48:16.000000', 'consum', 0.0221, 'lps'),
	(415017, 126, '2015-02-15 00:48:17.000000', 'consum', 0.0213, 'lps'),
	(415018, 126, '2015-02-15 00:48:18.000000', 'consum', 0.0222, 'lps'),
	(415019, 126, '2015-02-15 00:48:19.000000', 'consum', 0.0218, 'lps'),
	(415020, 126, '2015-02-15 00:48:20.000000', 'consum', 0.0214, 'lps'),
	(415021, 126, '2015-02-15 00:48:21.000000', 'consum', 0.0221, 'lps'),
	(415022, 126, '2015-02-15 00:48:22.000000', 'consum', 0.0213, 'lps'),
	(415023, 126, '2015-02-15 00:48:23.000000', 'consum', 0.0220, 'lps'),
	(415024, 126, '2015-02-15 00:48:24.000000', 'consum', 0.0210, 'lps'),
	(415025, 126, '2015-02-15 00:48:25.000000', 'consum', 0.0210, 'lps'),
	(415026, 126, '2015-02-15 00:48:26.000000', 'consum', 0.0222, 'lps'),
	(415027, 126, '2015-02-15 00:48:27.000000', 'consum', 0.0215, 'lps'),
	(415028, 126, '2015-02-15 00:48:28.000000', 'consum', 0.0212, 'lps'),
	(415029, 126, '2015-02-15 00:48:29.000000', 'consum', 0.0220, 'lps'),
	(415030, 126, '2015-02-15 00:48:30.000000', 'consum', 0.0214, 'lps'),
	(415031, 126, '2015-02-15 00:48:31.000000', 'consum', 0.0216, 'lps'),
	(415032, 126, '2015-02-15 00:48:32.000000', 'consum', 0.0212, 'lps'),
	(415033, 126, '2015-02-15 00:48:33.000000', 'consum', 0.0219, 'lps'),
	(415034, 126, '2015-02-15 00:48:34.000000', 'consum', 0.0221, 'lps'),
	(415035, 126, '2015-02-15 00:48:35.000000', 'consum', 0.0211, 'lps'),
	(415036, 126, '2015-02-15 00:48:36.000000', 'consum', 0.0211, 'lps'),
	(415037, 126, '2015-02-15 00:48:37.000000', 'consum', 0.0213, 'lps'),
	(415038, 126, '2015-02-15 00:48:38.000000', 'consum', 0.0220, 'lps'),
	(415039, 126, '2015-02-15 00:48:39.000000', 'consum', 0.0212, 'lps'),
	(415040, 126, '2015-02-15 00:48:40.000000', 'consum', 0.0219, 'lps'),
	(415041, 126, '2015-02-15 00:48:41.000000', 'consum', 0.0222, 'lps'),
	(415042, 126, '2015-02-15 00:48:42.000000', 'consum', 0.0214, 'lps'),
	(415043, 126, '2015-02-15 00:48:43.000000', 'consum', 0.0210, 'lps'),
	(415044, 126, '2015-02-15 00:48:44.000000', 'consum', 0.0213, 'lps'),
	(415045, 126, '2015-02-15 00:48:45.000000', 'consum', 0.0213, 'lps'),
	(415046, 126, '2015-02-15 00:48:46.000000', 'consum', 0.0213, 'lps'),
	(415047, 126, '2015-02-15 00:48:47.000000', 'consum', 0.0219, 'lps'),
	(415048, 126, '2015-02-15 00:48:48.000000', 'consum', 0.0218, 'lps'),
	(415049, 126, '2015-02-15 00:48:49.000000', 'consum', 0.0210, 'lps'),
	(415050, 126, '2015-02-15 00:48:50.000000', 'consum', 0.0212, 'lps'),
	(415051, 126, '2015-02-15 00:48:51.000000', 'consum', 0.0221, 'lps'),
	(415052, 126, '2015-02-15 00:48:52.000000', 'consum', 0.0219, 'lps'),
	(415053, 126, '2015-02-15 00:48:53.000000', 'consum', 0.0222, 'lps'),
	(415054, 126, '2015-02-15 00:48:54.000000', 'consum', 0.0214, 'lps'),
	(415055, 126, '2015-02-15 00:48:55.000000', 'consum', 0.0222, 'lps'),
	(415056, 126, '2015-02-15 00:48:56.000000', 'consum', 0.0219, 'lps'),
	(415057, 126, '2015-02-15 00:48:57.000000', 'consum', 0.0218, 'lps'),
	(415058, 126, '2015-02-15 00:48:58.000000', 'consum', 0.0222, 'lps'),
	(415059, 126, '2015-02-15 00:48:59.000000', 'consum', 0.0220, 'lps'),
	(415060, 126, '2015-02-15 00:49:00.000000', 'consum', 0.0223, 'lps'),
	(415061, 126, '2015-02-15 00:49:01.000000', 'consum', 0.0220, 'lps'),
	(415062, 126, '2015-02-15 00:49:02.000000', 'consum', 0.0221, 'lps'),
	(415063, 126, '2015-02-15 00:49:03.000000', 'consum', 0.0222, 'lps'),
	(415064, 126, '2015-02-15 00:49:04.000000', 'consum', 0.0210, 'lps'),
	(415065, 126, '2015-02-15 00:49:05.000000', 'consum', 0.0214, 'lps'),
	(415066, 126, '2015-02-15 00:49:06.000000', 'consum', 0.0217, 'lps'),
	(415067, 126, '2015-02-15 00:49:07.000000', 'consum', 0.0221, 'lps'),
	(415068, 126, '2015-02-15 00:49:08.000000', 'consum', 0.0218, 'lps'),
	(415069, 126, '2015-02-15 00:49:09.000000', 'consum', 0.0214, 'lps'),
	(415070, 126, '2015-02-15 00:49:10.000000', 'consum', 0.0222, 'lps'),
	(415071, 126, '2015-02-15 00:49:11.000000', 'consum', 0.0215, 'lps'),
	(415072, 126, '2015-02-15 00:49:12.000000', 'consum', 0.0216, 'lps'),
	(415073, 126, '2015-02-15 00:49:13.000000', 'consum', 0.0223, 'lps'),
	(415074, 126, '2015-02-15 00:49:14.000000', 'consum', 0.0216, 'lps'),
	(415075, 126, '2015-02-15 00:49:15.000000', 'consum', 0.0218, 'lps'),
	(415076, 126, '2015-02-15 00:49:16.000000', 'consum', 0.0215, 'lps'),
	(415077, 126, '2015-02-15 00:49:17.000000', 'consum', 0.0214, 'lps'),
	(415078, 126, '2015-02-15 00:49:18.000000', 'consum', 0.0214, 'lps'),
	(415079, 126, '2015-02-15 00:49:19.000000', 'consum', 0.0219, 'lps'),
	(415080, 126, '2015-02-15 00:49:20.000000', 'consum', 0.0216, 'lps'),
	(415081, 126, '2015-02-15 00:49:21.000000', 'consum', 0.0214, 'lps'),
	(415082, 126, '2015-02-15 00:49:22.000000', 'consum', 0.0214, 'lps'),
	(415083, 126, '2015-02-15 00:49:23.000000', 'consum', 0.0215, 'lps'),
	(415084, 126, '2015-02-15 00:49:24.000000', 'consum', 0.0212, 'lps'),
	(415085, 126, '2015-02-15 00:49:25.000000', 'consum', 0.0221, 'lps'),
	(415086, 126, '2015-02-15 00:49:26.000000', 'consum', 0.0215, 'lps'),
	(415087, 126, '2015-02-15 00:49:27.000000', 'consum', 0.0218, 'lps'),
	(415088, 126, '2015-02-15 00:49:28.000000', 'consum', 0.0221, 'lps'),
	(415089, 126, '2015-02-15 00:49:29.000000', 'consum', 0.0213, 'lps'),
	(415090, 126, '2015-02-15 00:49:30.000000', 'consum', 0.0220, 'lps'),
	(415091, 126, '2015-02-15 00:49:31.000000', 'consum', 0.0210, 'lps'),
	(415092, 126, '2015-02-15 00:49:32.000000', 'consum', 0.0223, 'lps'),
	(415093, 126, '2015-02-15 00:49:33.000000', 'consum', 0.0219, 'lps'),
	(415094, 126, '2015-02-15 00:49:34.000000', 'consum', 0.0217, 'lps'),
	(415095, 126, '2015-02-15 00:49:35.000000', 'consum', 0.0220, 'lps'),
	(415096, 126, '2015-02-15 00:49:36.000000', 'consum', 0.0223, 'lps'),
	(415097, 126, '2015-02-15 00:49:37.000000', 'consum', 0.0220, 'lps'),
	(415098, 126, '2015-02-15 00:49:38.000000', 'consum', 0.0219, 'lps'),
	(415099, 126, '2015-02-15 00:49:39.000000', 'consum', 0.0211, 'lps'),
	(415100, 126, '2015-02-15 00:49:40.000000', 'consum', 0.0216, 'lps'),
	(415101, 126, '2015-02-15 00:49:41.000000', 'consum', 0.0212, 'lps'),
	(415102, 126, '2015-02-15 00:49:42.000000', 'consum', 0.0217, 'lps'),
	(415103, 126, '2015-02-15 00:49:43.000000', 'consum', 0.0222, 'lps'),
	(415104, 126, '2015-02-15 00:49:44.000000', 'consum', 0.0211, 'lps'),
	(415105, 126, '2015-02-15 00:49:45.000000', 'consum', 0.0220, 'lps'),
	(415106, 126, '2015-02-15 00:49:46.000000', 'consum', 0.0218, 'lps'),
	(415107, 126, '2015-02-15 00:49:47.000000', 'consum', 0.0217, 'lps'),
	(415108, 126, '2015-02-15 00:49:48.000000', 'consum', 0.0210, 'lps'),
	(415109, 126, '2015-02-15 00:49:49.000000', 'consum', 0.0218, 'lps'),
	(415110, 126, '2015-02-15 00:49:50.000000', 'consum', 0.0223, 'lps'),
	(415111, 126, '2015-02-15 00:49:51.000000', 'consum', 0.0223, 'lps'),
	(415112, 126, '2015-02-15 00:49:52.000000', 'consum', 0.0220, 'lps'),
	(415113, 126, '2015-02-15 00:49:53.000000', 'consum', 0.0223, 'lps'),
	(415114, 126, '2015-02-15 00:49:54.000000', 'consum', 0.0219, 'lps'),
	(415115, 126, '2015-02-15 00:49:55.000000', 'consum', 0.0217, 'lps'),
	(415116, 126, '2015-02-15 00:49:56.000000', 'consum', 0.0217, 'lps'),
	(415117, 126, '2015-02-15 00:49:57.000000', 'consum', 0.0213, 'lps'),
	(415118, 126, '2015-02-15 00:49:58.000000', 'consum', 0.0216, 'lps'),
	(415119, 126, '2015-02-15 00:49:59.000000', 'consum', 0.0219, 'lps'),
	(415120, 126, '2015-02-15 00:50:00.000000', 'consum', 0.0223, 'lps'),
	(415121, 126, '2015-02-15 00:50:01.000000', 'consum', 0.0220, 'lps'),
	(415122, 126, '2015-02-15 00:50:02.000000', 'consum', 0.0221, 'lps'),
	(415123, 126, '2015-02-15 00:50:03.000000', 'consum', 0.0222, 'lps'),
	(415124, 126, '2015-02-15 00:50:04.000000', 'consum', 0.0222, 'lps'),
	(415125, 126, '2015-02-15 00:50:05.000000', 'consum', 0.0222, 'lps'),
	(415126, 126, '2015-02-15 00:50:06.000000', 'consum', 0.0219, 'lps'),
	(415127, 126, '2015-02-15 00:50:07.000000', 'consum', 0.0221, 'lps'),
	(415128, 126, '2015-02-15 00:50:08.000000', 'consum', 0.0210, 'lps'),
	(415129, 126, '2015-02-15 00:50:09.000000', 'consum', 0.0218, 'lps'),
	(415130, 126, '2015-02-15 00:50:10.000000', 'consum', 0.0223, 'lps'),
	(415131, 126, '2015-02-15 00:50:11.000000', 'consum', 0.0211, 'lps'),
	(415132, 126, '2015-02-15 00:50:12.000000', 'consum', 0.0218, 'lps'),
	(415133, 126, '2015-02-15 00:50:13.000000', 'consum', 0.0221, 'lps'),
	(415134, 126, '2015-02-15 00:50:14.000000', 'consum', 0.0212, 'lps'),
	(415135, 126, '2015-02-15 00:50:15.000000', 'consum', 0.0216, 'lps'),
	(415136, 126, '2015-02-15 00:50:16.000000', 'consum', 0.0219, 'lps'),
	(415137, 126, '2015-02-15 00:50:17.000000', 'consum', 0.0223, 'lps'),
	(415138, 126, '2015-02-15 00:50:18.000000', 'consum', 0.0220, 'lps'),
	(415139, 126, '2015-02-15 00:50:19.000000', 'consum', 0.0223, 'lps'),
	(415140, 126, '2015-02-15 00:50:20.000000', 'consum', 0.0219, 'lps'),
	(415141, 126, '2015-02-15 00:50:21.000000', 'consum', 0.0215, 'lps'),
	(415142, 126, '2015-02-15 00:50:22.000000', 'consum', 0.0223, 'lps'),
	(415143, 126, '2015-02-15 00:50:23.000000', 'consum', 0.0219, 'lps'),
	(415144, 126, '2015-02-15 00:50:24.000000', 'consum', 0.0215, 'lps'),
	(415145, 126, '2015-02-15 00:50:25.000000', 'consum', 0.0221, 'lps'),
	(415146, 126, '2015-02-15 00:50:26.000000', 'consum', 0.0211, 'lps'),
	(415147, 126, '2015-02-15 00:50:27.000000', 'consum', 0.0210, 'lps'),
	(415148, 126, '2015-02-15 00:50:28.000000', 'consum', 0.0221, 'lps'),
	(415149, 126, '2015-02-15 00:50:29.000000', 'consum', 0.0210, 'lps'),
	(415150, 126, '2015-02-15 00:50:30.000000', 'consum', 0.0220, 'lps'),
	(415151, 126, '2015-02-15 00:50:31.000000', 'consum', 0.0219, 'lps'),
	(415152, 126, '2015-02-15 00:50:32.000000', 'consum', 0.0212, 'lps'),
	(415153, 126, '2015-02-15 00:50:33.000000', 'consum', 0.0222, 'lps'),
	(415154, 126, '2015-02-15 00:50:34.000000', 'consum', 0.0221, 'lps'),
	(415155, 126, '2015-02-15 00:50:35.000000', 'consum', 0.0214, 'lps'),
	(415156, 126, '2015-02-15 00:50:36.000000', 'consum', 0.0213, 'lps'),
	(415157, 126, '2015-02-15 00:50:37.000000', 'consum', 0.0213, 'lps'),
	(415158, 126, '2015-02-15 00:50:38.000000', 'consum', 0.0215, 'lps'),
	(415159, 126, '2015-02-15 00:50:39.000000', 'consum', 0.0215, 'lps'),
	(415160, 126, '2015-02-15 00:50:40.000000', 'consum', 0.0220, 'lps'),
	(415161, 126, '2015-02-15 00:50:41.000000', 'consum', 0.0217, 'lps'),
	(415162, 126, '2015-02-15 00:50:42.000000', 'consum', 0.0217, 'lps'),
	(415163, 126, '2015-02-15 00:50:43.000000', 'consum', 0.0223, 'lps'),
	(415164, 126, '2015-02-15 00:50:44.000000', 'consum', 0.0212, 'lps'),
	(415165, 126, '2015-02-15 00:50:45.000000', 'consum', 0.0210, 'lps'),
	(415166, 126, '2015-02-15 00:50:46.000000', 'consum', 0.0221, 'lps'),
	(415167, 126, '2015-02-15 00:50:47.000000', 'consum', 0.0221, 'lps'),
	(415168, 126, '2015-02-15 00:50:48.000000', 'consum', 0.0217, 'lps'),
	(415169, 126, '2015-02-15 00:50:49.000000', 'consum', 0.0214, 'lps'),
	(415170, 126, '2015-02-15 00:50:50.000000', 'consum', 0.0211, 'lps'),
	(415171, 126, '2015-02-15 00:50:51.000000', 'consum', 0.0218, 'lps'),
	(415172, 126, '2015-02-15 00:50:52.000000', 'consum', 0.0221, 'lps'),
	(415173, 126, '2015-02-15 00:50:53.000000', 'consum', 0.0210, 'lps'),
	(415174, 126, '2015-02-15 00:50:54.000000', 'consum', 0.0220, 'lps'),
	(415175, 126, '2015-02-15 00:50:55.000000', 'consum', 0.0217, 'lps'),
	(415176, 126, '2015-02-15 00:50:56.000000', 'consum', 0.0217, 'lps'),
	(415177, 126, '2015-02-15 00:50:57.000000', 'consum', 0.0210, 'lps'),
	(415178, 126, '2015-02-15 00:50:58.000000', 'consum', 0.0217, 'lps'),
	(415179, 126, '2015-02-15 00:50:59.000000', 'consum', 0.0218, 'lps'),
	(415180, 126, '2015-02-15 00:51:00.000000', 'consum', 0.0214, 'lps'),
	(415181, 126, '2015-02-15 00:51:01.000000', 'consum', 0.0221, 'lps'),
	(415182, 126, '2015-02-15 00:51:02.000000', 'consum', 0.0210, 'lps'),
	(415183, 126, '2015-02-15 00:51:03.000000', 'consum', 0.0221, 'lps'),
	(415184, 126, '2015-02-15 00:51:04.000000', 'consum', 0.0211, 'lps'),
	(415185, 126, '2015-02-15 00:51:05.000000', 'consum', 0.0223, 'lps'),
	(415186, 126, '2015-02-15 00:51:06.000000', 'consum', 0.0216, 'lps'),
	(415187, 126, '2015-02-15 00:51:07.000000', 'consum', 0.0217, 'lps'),
	(415188, 126, '2015-02-15 00:51:08.000000', 'consum', 0.0215, 'lps'),
	(415189, 126, '2015-02-15 00:51:09.000000', 'consum', 0.0212, 'lps'),
	(415190, 126, '2015-02-15 00:51:10.000000', 'consum', 0.0219, 'lps'),
	(415191, 126, '2015-02-15 00:51:11.000000', 'consum', 0.0222, 'lps'),
	(415192, 126, '2015-02-15 00:51:12.000000', 'consum', 0.0215, 'lps'),
	(415193, 126, '2015-02-15 00:51:13.000000', 'consum', 0.0213, 'lps'),
	(415194, 126, '2015-02-15 00:51:14.000000', 'consum', 0.0223, 'lps'),
	(415195, 126, '2015-02-15 00:51:15.000000', 'consum', 0.0213, 'lps'),
	(415196, 126, '2015-02-15 00:51:16.000000', 'consum', 0.0214, 'lps'),
	(415197, 126, '2015-02-15 00:51:17.000000', 'consum', 0.0220, 'lps'),
	(415198, 126, '2015-02-15 00:51:18.000000', 'consum', 0.0221, 'lps'),
	(415199, 126, '2015-02-15 00:51:19.000000', 'consum', 0.0222, 'lps'),
	(415200, 126, '2015-02-15 00:51:20.000000', 'consum', 0.0223, 'lps'),
	(415201, 126, '2015-02-15 00:51:21.000000', 'consum', 0.0214, 'lps'),
	(415202, 126, '2015-02-15 00:51:22.000000', 'consum', 0.0216, 'lps'),
	(415203, 126, '2015-02-15 00:51:23.000000', 'consum', 0.0217, 'lps'),
	(415204, 126, '2015-02-15 00:51:24.000000', 'consum', 0.0214, 'lps'),
	(415205, 126, '2015-02-15 00:51:25.000000', 'consum', 0.0210, 'lps'),
	(415206, 126, '2015-02-15 00:51:26.000000', 'consum', 0.0210, 'lps'),
	(415207, 126, '2015-02-15 00:51:27.000000', 'consum', 0.0212, 'lps'),
	(415208, 126, '2015-02-15 00:51:28.000000', 'consum', 0.0221, 'lps'),
	(415209, 126, '2015-02-15 00:51:29.000000', 'consum', 0.0215, 'lps'),
	(415210, 126, '2015-02-15 00:51:30.000000', 'consum', 0.0219, 'lps'),
	(415211, 126, '2015-02-15 00:51:31.000000', 'consum', 0.0211, 'lps'),
	(415212, 126, '2015-02-15 00:51:32.000000', 'consum', 0.0218, 'lps'),
	(415213, 126, '2015-02-15 00:51:33.000000', 'consum', 0.0220, 'lps'),
	(415214, 126, '2015-02-15 00:51:34.000000', 'consum', 0.0222, 'lps'),
	(415215, 126, '2015-02-15 00:51:35.000000', 'consum', 0.0212, 'lps'),
	(415216, 126, '2015-02-15 00:51:36.000000', 'consum', 0.0214, 'lps'),
	(415217, 126, '2015-02-15 00:51:37.000000', 'consum', 0.0211, 'lps'),
	(415218, 126, '2015-02-15 00:51:38.000000', 'consum', 0.0215, 'lps'),
	(415219, 126, '2015-02-15 00:51:39.000000', 'consum', 0.0221, 'lps'),
	(415220, 126, '2015-02-15 00:51:40.000000', 'consum', 0.0220, 'lps'),
	(415221, 126, '2015-02-15 00:51:41.000000', 'consum', 0.0216, 'lps'),
	(415222, 126, '2015-02-15 00:51:42.000000', 'consum', 0.0222, 'lps'),
	(415223, 126, '2015-02-15 00:51:43.000000', 'consum', 0.0211, 'lps'),
	(415224, 126, '2015-02-15 00:51:44.000000', 'consum', 0.0221, 'lps'),
	(415225, 126, '2015-02-15 00:51:45.000000', 'consum', 0.0219, 'lps'),
	(415226, 126, '2015-02-15 00:51:46.000000', 'consum', 0.0211, 'lps'),
	(415227, 126, '2015-02-15 00:51:47.000000', 'consum', 0.0217, 'lps'),
	(415228, 126, '2015-02-15 00:51:48.000000', 'consum', 0.0216, 'lps'),
	(415229, 126, '2015-02-15 00:51:49.000000', 'consum', 0.0216, 'lps'),
	(415230, 126, '2015-02-15 00:51:50.000000', 'consum', 0.0212, 'lps'),
	(415231, 126, '2015-02-15 00:51:51.000000', 'consum', 0.0214, 'lps'),
	(415232, 126, '2015-02-15 00:51:52.000000', 'consum', 0.0212, 'lps'),
	(415233, 126, '2015-02-15 00:51:53.000000', 'consum', 0.0221, 'lps'),
	(415234, 126, '2015-02-15 00:51:54.000000', 'consum', 0.0219, 'lps'),
	(415235, 126, '2015-02-15 00:51:55.000000', 'consum', 0.0222, 'lps'),
	(415236, 126, '2015-02-15 00:51:56.000000', 'consum', 0.0215, 'lps'),
	(415237, 126, '2015-02-15 00:51:57.000000', 'consum', 0.0215, 'lps'),
	(415238, 126, '2015-02-15 00:51:58.000000', 'consum', 0.0221, 'lps'),
	(415239, 126, '2015-02-15 00:51:59.000000', 'consum', 0.0220, 'lps'),
	(415240, 126, '2015-02-15 00:52:00.000000', 'consum', 0.0213, 'lps'),
	(415241, 126, '2015-02-15 00:52:01.000000', 'consum', 0.0210, 'lps'),
	(415242, 126, '2015-02-15 00:52:02.000000', 'consum', 0.0214, 'lps'),
	(415243, 126, '2015-02-15 00:52:03.000000', 'consum', 0.0219, 'lps'),
	(415244, 126, '2015-02-15 00:52:04.000000', 'consum', 0.0214, 'lps'),
	(415245, 126, '2015-02-15 00:52:05.000000', 'consum', 0.0218, 'lps'),
	(415246, 126, '2015-02-15 00:52:06.000000', 'consum', 0.0210, 'lps'),
	(415247, 126, '2015-02-15 00:52:07.000000', 'consum', 0.0215, 'lps'),
	(415248, 126, '2015-02-15 00:52:08.000000', 'consum', 0.0223, 'lps'),
	(415249, 126, '2015-02-15 00:52:09.000000', 'consum', 0.0218, 'lps'),
	(415250, 126, '2015-02-15 00:52:10.000000', 'consum', 0.0211, 'lps'),
	(415251, 126, '2015-02-15 00:52:11.000000', 'consum', 0.0217, 'lps'),
	(415252, 126, '2015-02-15 00:52:12.000000', 'consum', 0.0218, 'lps'),
	(415253, 126, '2015-02-15 00:52:13.000000', 'consum', 0.0215, 'lps'),
	(415254, 126, '2015-02-15 00:52:14.000000', 'consum', 0.0210, 'lps'),
	(415255, 126, '2015-02-15 00:52:15.000000', 'consum', 0.0212, 'lps'),
	(415256, 126, '2015-02-15 00:52:16.000000', 'consum', 0.0219, 'lps'),
	(415257, 126, '2015-02-15 00:52:17.000000', 'consum', 0.0220, 'lps'),
	(415258, 126, '2015-02-15 00:52:18.000000', 'consum', 0.0222, 'lps'),
	(415259, 126, '2015-02-15 00:52:19.000000', 'consum', 0.0210, 'lps'),
	(415260, 126, '2015-02-15 00:52:20.000000', 'consum', 0.0219, 'lps'),
	(415261, 126, '2015-02-15 00:52:21.000000', 'consum', 0.0213, 'lps'),
	(415262, 126, '2015-02-15 00:52:22.000000', 'consum', 0.0211, 'lps'),
	(415263, 126, '2015-02-15 00:52:23.000000', 'consum', 0.0222, 'lps'),
	(415264, 126, '2015-02-15 00:52:24.000000', 'consum', 0.0223, 'lps'),
	(415265, 126, '2015-02-15 00:52:25.000000', 'consum', 0.0213, 'lps'),
	(415266, 126, '2015-02-15 00:52:26.000000', 'consum', 0.0213, 'lps'),
	(415267, 126, '2015-02-15 00:52:27.000000', 'consum', 0.0217, 'lps'),
	(415268, 126, '2015-02-15 00:52:28.000000', 'consum', 0.0223, 'lps'),
	(415269, 126, '2015-02-15 00:52:29.000000', 'consum', 0.0212, 'lps'),
	(415270, 126, '2015-02-15 00:52:30.000000', 'consum', 0.0211, 'lps'),
	(415271, 126, '2015-02-15 00:52:31.000000', 'consum', 0.0210, 'lps'),
	(415272, 126, '2015-02-15 00:52:32.000000', 'consum', 0.0219, 'lps'),
	(415273, 126, '2015-02-15 00:52:33.000000', 'consum', 0.0215, 'lps'),
	(415274, 126, '2015-02-15 00:52:34.000000', 'consum', 0.0222, 'lps'),
	(415275, 126, '2015-02-15 00:52:35.000000', 'consum', 0.0215, 'lps'),
	(415276, 126, '2015-02-15 00:52:36.000000', 'consum', 0.0212, 'lps'),
	(415277, 126, '2015-02-15 00:52:37.000000', 'consum', 0.0218, 'lps'),
	(415278, 126, '2015-02-15 00:52:38.000000', 'consum', 0.0220, 'lps'),
	(415279, 126, '2015-02-15 00:52:39.000000', 'consum', 0.0220, 'lps'),
	(415280, 126, '2015-02-15 00:52:40.000000', 'consum', 0.0216, 'lps'),
	(415281, 126, '2015-02-15 00:52:41.000000', 'consum', 0.0213, 'lps'),
	(415282, 126, '2015-02-15 00:52:42.000000', 'consum', 0.0219, 'lps'),
	(415283, 126, '2015-02-15 00:52:43.000000', 'consum', 0.0220, 'lps'),
	(415284, 126, '2015-02-15 00:52:44.000000', 'consum', 0.0221, 'lps'),
	(415285, 126, '2015-02-15 00:52:45.000000', 'consum', 0.0218, 'lps'),
	(415286, 126, '2015-02-15 00:52:46.000000', 'consum', 0.0219, 'lps'),
	(415287, 126, '2015-02-15 00:52:47.000000', 'consum', 0.0219, 'lps'),
	(415288, 126, '2015-02-15 00:52:48.000000', 'consum', 0.0214, 'lps'),
	(415289, 126, '2015-02-15 00:52:49.000000', 'consum', 0.0217, 'lps'),
	(415290, 126, '2015-02-15 00:52:50.000000', 'consum', 0.0221, 'lps'),
	(415291, 126, '2015-02-15 00:52:51.000000', 'consum', 0.0217, 'lps'),
	(415292, 126, '2015-02-15 00:52:52.000000', 'consum', 0.0210, 'lps'),
	(415293, 126, '2015-02-15 00:52:53.000000', 'consum', 0.0220, 'lps'),
	(415294, 126, '2015-02-15 00:52:54.000000', 'consum', 0.0217, 'lps'),
	(415295, 126, '2015-02-15 00:52:55.000000', 'consum', 0.0216, 'lps'),
	(415296, 126, '2015-02-15 00:52:56.000000', 'consum', 0.0220, 'lps'),
	(415297, 126, '2015-02-15 00:52:57.000000', 'consum', 0.0215, 'lps'),
	(415298, 126, '2015-02-15 00:52:58.000000', 'consum', 0.0217, 'lps'),
	(415299, 126, '2015-02-15 00:52:59.000000', 'consum', 0.0220, 'lps'),
	(415300, 126, '2015-02-15 00:53:00.000000', 'consum', 0.0222, 'lps'),
	(415301, 126, '2015-02-15 00:53:01.000000', 'consum', 0.0216, 'lps'),
	(415302, 126, '2015-02-15 00:53:02.000000', 'consum', 0.0216, 'lps'),
	(415303, 126, '2015-02-15 00:53:03.000000', 'consum', 0.0222, 'lps'),
	(415304, 126, '2015-02-15 00:53:04.000000', 'consum', 0.0210, 'lps'),
	(415305, 126, '2015-02-15 00:53:05.000000', 'consum', 0.0216, 'lps'),
	(415306, 126, '2015-02-15 00:53:06.000000', 'consum', 0.0214, 'lps'),
	(415307, 126, '2015-02-15 00:53:07.000000', 'consum', 0.0213, 'lps'),
	(415308, 126, '2015-02-15 00:53:08.000000', 'consum', 0.0213, 'lps'),
	(415309, 126, '2015-02-15 00:53:09.000000', 'consum', 0.0216, 'lps'),
	(415310, 126, '2015-02-15 00:53:10.000000', 'consum', 0.0217, 'lps'),
	(415311, 126, '2015-02-15 00:53:11.000000', 'consum', 0.0213, 'lps'),
	(415312, 126, '2015-02-15 00:53:12.000000', 'consum', 0.0220, 'lps'),
	(415313, 126, '2015-02-15 00:53:13.000000', 'consum', 0.0211, 'lps'),
	(415314, 126, '2015-02-15 00:53:14.000000', 'consum', 0.0212, 'lps'),
	(415315, 126, '2015-02-15 00:53:15.000000', 'consum', 0.0217, 'lps'),
	(415316, 126, '2015-02-15 00:53:16.000000', 'consum', 0.0213, 'lps'),
	(415317, 126, '2015-02-15 00:53:17.000000', 'consum', 0.0219, 'lps'),
	(415318, 126, '2015-02-15 00:53:18.000000', 'consum', 0.0216, 'lps'),
	(415319, 126, '2015-02-15 00:53:19.000000', 'consum', 0.0214, 'lps'),
	(415320, 126, '2015-02-15 00:53:20.000000', 'consum', 0.0215, 'lps'),
	(415321, 126, '2015-02-15 00:53:21.000000', 'consum', 0.0222, 'lps'),
	(415322, 126, '2015-02-15 00:53:22.000000', 'consum', 0.0213, 'lps'),
	(415323, 126, '2015-02-15 00:53:23.000000', 'consum', 0.0219, 'lps'),
	(415324, 126, '2015-02-15 00:53:24.000000', 'consum', 0.0216, 'lps'),
	(415325, 126, '2015-02-15 00:53:25.000000', 'consum', 0.0213, 'lps'),
	(415326, 126, '2015-02-15 00:53:26.000000', 'consum', 0.0210, 'lps'),
	(415327, 126, '2015-02-15 00:53:27.000000', 'consum', 0.0216, 'lps'),
	(415328, 126, '2015-02-15 00:53:28.000000', 'consum', 0.0211, 'lps'),
	(415329, 126, '2015-02-15 00:53:29.000000', 'consum', 0.0213, 'lps'),
	(415330, 126, '2015-02-15 00:53:30.000000', 'consum', 0.0223, 'lps'),
	(415331, 126, '2015-02-15 00:53:31.000000', 'consum', 0.0211, 'lps'),
	(415332, 126, '2015-02-15 00:53:32.000000', 'consum', 0.0217, 'lps'),
	(415333, 126, '2015-02-15 00:53:33.000000', 'consum', 0.0216, 'lps'),
	(415334, 126, '2015-02-15 00:53:34.000000', 'consum', 0.0218, 'lps'),
	(415335, 126, '2015-02-15 00:53:35.000000', 'consum', 0.0218, 'lps'),
	(415336, 126, '2015-02-15 00:53:36.000000', 'consum', 0.0215, 'lps'),
	(415337, 126, '2015-02-15 00:53:37.000000', 'consum', 0.0210, 'lps'),
	(415338, 126, '2015-02-15 00:53:38.000000', 'consum', 0.0223, 'lps'),
	(415339, 126, '2015-02-15 00:53:39.000000', 'consum', 0.0222, 'lps'),
	(415340, 126, '2015-02-15 00:53:40.000000', 'consum', 0.0216, 'lps'),
	(415341, 126, '2015-02-15 00:53:41.000000', 'consum', 0.0221, 'lps'),
	(415342, 126, '2015-02-15 00:53:42.000000', 'consum', 0.0216, 'lps'),
	(415343, 126, '2015-02-15 00:53:43.000000', 'consum', 0.0221, 'lps'),
	(415344, 126, '2015-02-15 00:53:44.000000', 'consum', 0.0222, 'lps'),
	(415345, 126, '2015-02-15 00:53:45.000000', 'consum', 0.0210, 'lps'),
	(415346, 126, '2015-02-15 00:53:46.000000', 'consum', 0.0215, 'lps'),
	(415347, 126, '2015-02-15 00:53:47.000000', 'consum', 0.0222, 'lps'),
	(415348, 126, '2015-02-15 00:53:48.000000', 'consum', 0.0215, 'lps'),
	(415349, 126, '2015-02-15 00:53:49.000000', 'consum', 0.0212, 'lps'),
	(415350, 126, '2015-02-15 00:53:50.000000', 'consum', 0.0219, 'lps'),
	(415351, 126, '2015-02-15 00:53:51.000000', 'consum', 0.0222, 'lps'),
	(415352, 126, '2015-02-15 00:53:52.000000', 'consum', 0.0218, 'lps'),
	(415353, 126, '2015-02-15 00:53:53.000000', 'consum', 0.0211, 'lps'),
	(415354, 126, '2015-02-15 00:53:54.000000', 'consum', 0.0220, 'lps'),
	(415355, 126, '2015-02-15 00:53:55.000000', 'consum', 0.0218, 'lps'),
	(415356, 126, '2015-02-15 00:53:56.000000', 'consum', 0.0220, 'lps'),
	(415357, 126, '2015-02-15 00:53:57.000000', 'consum', 0.0221, 'lps'),
	(415358, 126, '2015-02-15 00:53:58.000000', 'consum', 0.0223, 'lps'),
	(415359, 126, '2015-02-15 00:53:59.000000', 'consum', 0.0212, 'lps'),
	(415360, 126, '2015-02-15 00:54:00.000000', 'consum', 0.0211, 'lps'),
	(415361, 126, '2015-02-15 00:54:01.000000', 'consum', 0.0210, 'lps'),
	(415362, 126, '2015-02-15 00:54:02.000000', 'consum', 0.0219, 'lps'),
	(415363, 126, '2015-02-15 00:54:03.000000', 'consum', 0.0216, 'lps'),
	(415364, 126, '2015-02-15 00:54:04.000000', 'consum', 0.0213, 'lps'),
	(415365, 126, '2015-02-15 00:54:05.000000', 'consum', 0.0221, 'lps'),
	(415366, 126, '2015-02-15 00:54:06.000000', 'consum', 0.0215, 'lps'),
	(415367, 126, '2015-02-15 00:54:07.000000', 'consum', 0.0214, 'lps'),
	(415368, 126, '2015-02-15 00:54:08.000000', 'consum', 0.0218, 'lps'),
	(415369, 126, '2015-02-15 00:54:09.000000', 'consum', 0.0211, 'lps'),
	(415370, 126, '2015-02-15 00:54:10.000000', 'consum', 0.0217, 'lps'),
	(415371, 126, '2015-02-15 00:54:11.000000', 'consum', 0.0215, 'lps'),
	(415372, 126, '2015-02-15 00:54:12.000000', 'consum', 0.0216, 'lps'),
	(415373, 126, '2015-02-15 00:54:13.000000', 'consum', 0.0210, 'lps'),
	(415374, 126, '2015-02-15 00:54:14.000000', 'consum', 0.0219, 'lps'),
	(415375, 126, '2015-02-15 00:54:15.000000', 'consum', 0.0216, 'lps'),
	(415376, 126, '2015-02-15 00:54:16.000000', 'consum', 0.0214, 'lps'),
	(415377, 126, '2015-02-15 00:54:17.000000', 'consum', 0.0212, 'lps'),
	(415378, 126, '2015-02-15 00:54:18.000000', 'consum', 0.0223, 'lps'),
	(415379, 126, '2015-02-15 00:54:19.000000', 'consum', 0.0215, 'lps'),
	(415380, 126, '2015-02-15 00:54:20.000000', 'consum', 0.0221, 'lps'),
	(415381, 126, '2015-02-15 00:54:21.000000', 'consum', 0.0212, 'lps'),
	(415382, 126, '2015-02-15 00:54:22.000000', 'consum', 0.0213, 'lps'),
	(415383, 126, '2015-02-15 00:54:23.000000', 'consum', 0.0219, 'lps'),
	(415384, 126, '2015-02-15 00:54:24.000000', 'consum', 0.0221, 'lps'),
	(415385, 126, '2015-02-15 00:54:25.000000', 'consum', 0.0211, 'lps'),
	(415386, 126, '2015-02-15 00:54:26.000000', 'consum', 0.0222, 'lps'),
	(415387, 126, '2015-02-15 00:54:27.000000', 'consum', 0.0212, 'lps'),
	(415388, 126, '2015-02-15 00:54:28.000000', 'consum', 0.0212, 'lps'),
	(415389, 126, '2015-02-15 00:54:29.000000', 'consum', 0.0213, 'lps'),
	(415390, 126, '2015-02-15 00:54:30.000000', 'consum', 0.0223, 'lps'),
	(415391, 126, '2015-02-15 00:54:31.000000', 'consum', 0.0222, 'lps'),
	(415392, 126, '2015-02-15 00:54:32.000000', 'consum', 0.0219, 'lps'),
	(415393, 126, '2015-02-15 00:54:33.000000', 'consum', 0.0221, 'lps'),
	(415394, 126, '2015-02-15 00:54:34.000000', 'consum', 0.0223, 'lps'),
	(415395, 126, '2015-02-15 00:54:35.000000', 'consum', 0.0213, 'lps'),
	(415396, 126, '2015-02-15 00:54:36.000000', 'consum', 0.0215, 'lps'),
	(415397, 126, '2015-02-15 00:54:37.000000', 'consum', 0.0211, 'lps'),
	(415398, 126, '2015-02-15 00:54:38.000000', 'consum', 0.0218, 'lps'),
	(415399, 126, '2015-02-15 00:54:39.000000', 'consum', 0.0218, 'lps'),
	(415400, 126, '2015-02-15 00:54:40.000000', 'consum', 0.0211, 'lps'),
	(415401, 126, '2015-02-15 00:54:41.000000', 'consum', 0.0221, 'lps'),
	(415402, 126, '2015-02-15 00:54:42.000000', 'consum', 0.0219, 'lps'),
	(415403, 126, '2015-02-15 00:54:43.000000', 'consum', 0.0211, 'lps'),
	(415404, 126, '2015-02-15 00:54:44.000000', 'consum', 0.0217, 'lps'),
	(415405, 126, '2015-02-15 00:54:45.000000', 'consum', 0.0211, 'lps'),
	(415406, 126, '2015-02-15 00:54:46.000000', 'consum', 0.0212, 'lps'),
	(415407, 126, '2015-02-15 00:54:47.000000', 'consum', 0.0215, 'lps'),
	(415408, 126, '2015-02-15 00:54:48.000000', 'consum', 0.0215, 'lps'),
	(415409, 126, '2015-02-15 00:54:49.000000', 'consum', 0.0223, 'lps'),
	(415410, 126, '2015-02-15 00:54:50.000000', 'consum', 0.0215, 'lps'),
	(415411, 126, '2015-02-15 00:54:51.000000', 'consum', 0.0214, 'lps'),
	(415412, 126, '2015-02-15 00:54:52.000000', 'consum', 0.0214, 'lps'),
	(415413, 126, '2015-02-15 00:54:53.000000', 'consum', 0.0219, 'lps'),
	(415414, 126, '2015-02-15 00:54:54.000000', 'consum', 0.0217, 'lps'),
	(415415, 126, '2015-02-15 00:54:55.000000', 'consum', 0.0218, 'lps'),
	(415416, 126, '2015-02-15 00:54:56.000000', 'consum', 0.0215, 'lps'),
	(415417, 126, '2015-02-15 00:54:57.000000', 'consum', 0.0213, 'lps'),
	(415418, 126, '2015-02-15 00:54:58.000000', 'consum', 0.0211, 'lps'),
	(415419, 126, '2015-02-15 00:54:59.000000', 'consum', 0.0217, 'lps'),
	(415420, 126, '2015-02-15 00:55:00.000000', 'consum', 0.0218, 'lps'),
	(415421, 126, '2015-02-15 00:55:01.000000', 'consum', 0.0213, 'lps'),
	(415422, 126, '2015-02-15 00:55:02.000000', 'consum', 0.0218, 'lps'),
	(415423, 126, '2015-02-15 00:55:03.000000', 'consum', 0.0212, 'lps'),
	(415424, 126, '2015-02-15 00:55:04.000000', 'consum', 0.0223, 'lps'),
	(415425, 126, '2015-02-15 00:55:05.000000', 'consum', 0.0216, 'lps'),
	(415426, 126, '2015-02-15 00:55:06.000000', 'consum', 0.0216, 'lps'),
	(415427, 126, '2015-02-15 00:55:07.000000', 'consum', 0.0222, 'lps'),
	(415428, 126, '2015-02-15 00:55:08.000000', 'consum', 0.0211, 'lps'),
	(415429, 126, '2015-02-15 00:55:09.000000', 'consum', 0.0219, 'lps'),
	(415430, 126, '2015-02-15 00:55:10.000000', 'consum', 0.0214, 'lps'),
	(415431, 126, '2015-02-15 00:55:11.000000', 'consum', 0.0215, 'lps'),
	(415432, 126, '2015-02-15 00:55:12.000000', 'consum', 0.0211, 'lps'),
	(415433, 126, '2015-02-15 00:55:13.000000', 'consum', 0.0215, 'lps'),
	(415434, 126, '2015-02-15 00:55:14.000000', 'consum', 0.0220, 'lps'),
	(415435, 126, '2015-02-15 00:55:15.000000', 'consum', 0.0214, 'lps'),
	(415436, 126, '2015-02-15 00:55:16.000000', 'consum', 0.0217, 'lps'),
	(415437, 126, '2015-02-15 00:55:17.000000', 'consum', 0.0220, 'lps'),
	(415438, 126, '2015-02-15 00:55:18.000000', 'consum', 0.0210, 'lps'),
	(415439, 126, '2015-02-15 00:55:19.000000', 'consum', 0.0222, 'lps'),
	(415440, 126, '2015-02-15 00:55:20.000000', 'consum', 0.0216, 'lps'),
	(415441, 126, '2015-02-15 00:55:21.000000', 'consum', 0.0218, 'lps'),
	(415442, 126, '2015-02-15 00:55:22.000000', 'consum', 0.0220, 'lps'),
	(415443, 126, '2015-02-15 00:55:23.000000', 'consum', 0.0221, 'lps'),
	(415444, 126, '2015-02-15 00:55:24.000000', 'consum', 0.0222, 'lps'),
	(415445, 126, '2015-02-15 00:55:25.000000', 'consum', 0.0221, 'lps'),
	(415446, 126, '2015-02-15 00:55:26.000000', 'consum', 0.0219, 'lps'),
	(415447, 126, '2015-02-15 00:55:27.000000', 'consum', 0.0221, 'lps'),
	(415448, 126, '2015-02-15 00:55:28.000000', 'consum', 0.0211, 'lps'),
	(415449, 126, '2015-02-15 00:55:29.000000', 'consum', 0.0210, 'lps'),
	(415450, 126, '2015-02-15 00:55:30.000000', 'consum', 0.0220, 'lps'),
	(415451, 126, '2015-02-15 00:55:31.000000', 'consum', 0.0221, 'lps'),
	(415452, 126, '2015-02-15 00:55:32.000000', 'consum', 0.0219, 'lps'),
	(415453, 126, '2015-02-15 00:55:33.000000', 'consum', 0.0212, 'lps'),
	(415454, 126, '2015-02-15 00:55:34.000000', 'consum', 0.0218, 'lps'),
	(415455, 126, '2015-02-15 00:55:35.000000', 'consum', 0.0219, 'lps'),
	(415456, 126, '2015-02-15 00:55:36.000000', 'consum', 0.0215, 'lps'),
	(415457, 126, '2015-02-15 00:55:37.000000', 'consum', 0.0212, 'lps'),
	(415458, 126, '2015-02-15 00:55:38.000000', 'consum', 0.0216, 'lps'),
	(415459, 126, '2015-02-15 00:55:39.000000', 'consum', 0.0223, 'lps'),
	(415460, 126, '2015-02-15 00:55:40.000000', 'consum', 0.0216, 'lps'),
	(415461, 126, '2015-02-15 00:55:41.000000', 'consum', 0.0213, 'lps'),
	(415462, 126, '2015-02-15 00:55:42.000000', 'consum', 0.0210, 'lps'),
	(415463, 126, '2015-02-15 00:55:43.000000', 'consum', 0.0214, 'lps'),
	(415464, 126, '2015-02-15 00:55:44.000000', 'consum', 0.0215, 'lps'),
	(415465, 126, '2015-02-15 00:55:45.000000', 'consum', 0.0210, 'lps'),
	(415466, 126, '2015-02-15 00:55:46.000000', 'consum', 0.0211, 'lps'),
	(415467, 126, '2015-02-15 00:55:47.000000', 'consum', 0.0215, 'lps'),
	(415468, 126, '2015-02-15 00:55:48.000000', 'consum', 0.0218, 'lps'),
	(415469, 126, '2015-02-15 00:55:49.000000', 'consum', 0.0221, 'lps'),
	(415470, 126, '2015-02-15 00:55:50.000000', 'consum', 0.0215, 'lps'),
	(415471, 126, '2015-02-15 00:55:51.000000', 'consum', 0.0214, 'lps'),
	(415472, 126, '2015-02-15 00:55:52.000000', 'consum', 0.0216, 'lps'),
	(415473, 126, '2015-02-15 00:55:53.000000', 'consum', 0.0214, 'lps'),
	(415474, 126, '2015-02-15 00:55:54.000000', 'consum', 0.0212, 'lps'),
	(415475, 126, '2015-02-15 00:55:55.000000', 'consum', 0.0222, 'lps'),
	(415476, 126, '2015-02-15 00:55:56.000000', 'consum', 0.0223, 'lps'),
	(415477, 126, '2015-02-15 00:55:57.000000', 'consum', 0.0214, 'lps'),
	(415478, 126, '2015-02-15 00:55:58.000000', 'consum', 0.0216, 'lps'),
	(415479, 126, '2015-02-15 00:55:59.000000', 'consum', 0.0218, 'lps'),
	(415480, 126, '2015-02-15 00:56:00.000000', 'consum', 0.0216, 'lps'),
	(415481, 126, '2015-02-15 00:56:01.000000', 'consum', 0.0215, 'lps'),
	(415482, 126, '2015-02-15 00:56:02.000000', 'consum', 0.0220, 'lps'),
	(415483, 126, '2015-02-15 00:56:03.000000', 'consum', 0.0217, 'lps'),
	(415484, 126, '2015-02-15 00:56:04.000000', 'consum', 0.0215, 'lps'),
	(415485, 126, '2015-02-15 00:56:05.000000', 'consum', 0.0214, 'lps'),
	(415486, 126, '2015-02-15 00:56:06.000000', 'consum', 0.0216, 'lps'),
	(415487, 126, '2015-02-15 00:56:07.000000', 'consum', 0.0216, 'lps'),
	(415488, 126, '2015-02-15 00:56:08.000000', 'consum', 0.0222, 'lps'),
	(415489, 126, '2015-02-15 00:56:09.000000', 'consum', 0.0211, 'lps'),
	(415490, 126, '2015-02-15 00:56:10.000000', 'consum', 0.0223, 'lps'),
	(415491, 126, '2015-02-15 00:56:11.000000', 'consum', 0.0214, 'lps'),
	(415492, 126, '2015-02-15 00:56:12.000000', 'consum', 0.0220, 'lps'),
	(415493, 126, '2015-02-15 00:56:13.000000', 'consum', 0.0220, 'lps'),
	(415494, 126, '2015-02-15 00:56:14.000000', 'consum', 0.0218, 'lps'),
	(415495, 126, '2015-02-15 00:56:15.000000', 'consum', 0.0221, 'lps'),
	(415496, 126, '2015-02-15 00:56:16.000000', 'consum', 0.0211, 'lps'),
	(415497, 126, '2015-02-15 00:56:17.000000', 'consum', 0.0210, 'lps'),
	(415498, 126, '2015-02-15 00:56:18.000000', 'consum', 0.0210, 'lps'),
	(415499, 126, '2015-02-15 00:56:19.000000', 'consum', 0.0222, 'lps'),
	(415500, 126, '2015-02-15 00:56:20.000000', 'consum', 0.0217, 'lps'),
	(415501, 126, '2015-02-15 00:56:21.000000', 'consum', 0.0221, 'lps'),
	(415502, 126, '2015-02-15 00:56:22.000000', 'consum', 0.0219, 'lps'),
	(415503, 126, '2015-02-15 00:56:23.000000', 'consum', 0.0222, 'lps'),
	(415504, 126, '2015-02-15 00:56:24.000000', 'consum', 0.0217, 'lps'),
	(415505, 126, '2015-02-15 00:56:25.000000', 'consum', 0.0223, 'lps'),
	(415506, 126, '2015-02-15 00:56:26.000000', 'consum', 0.0213, 'lps'),
	(415507, 126, '2015-02-15 00:56:27.000000', 'consum', 0.0212, 'lps'),
	(415508, 126, '2015-02-15 00:56:28.000000', 'consum', 0.0214, 'lps'),
	(415509, 126, '2015-02-15 00:56:29.000000', 'consum', 0.0211, 'lps'),
	(415510, 126, '2015-02-15 00:56:30.000000', 'consum', 0.0218, 'lps'),
	(415511, 126, '2015-02-15 00:56:31.000000', 'consum', 0.0218, 'lps'),
	(415512, 126, '2015-02-15 00:56:32.000000', 'consum', 0.0212, 'lps'),
	(415513, 126, '2015-02-15 00:56:33.000000', 'consum', 0.0213, 'lps'),
	(415514, 126, '2015-02-15 00:56:34.000000', 'consum', 0.0216, 'lps'),
	(415515, 126, '2015-02-15 00:56:35.000000', 'consum', 0.0219, 'lps'),
	(415516, 126, '2015-02-15 00:56:36.000000', 'consum', 0.0210, 'lps'),
	(415517, 126, '2015-02-15 00:56:37.000000', 'consum', 0.0213, 'lps'),
	(415518, 126, '2015-02-15 00:56:38.000000', 'consum', 0.0210, 'lps'),
	(415519, 126, '2015-02-15 00:56:39.000000', 'consum', 0.0214, 'lps'),
	(415520, 126, '2015-02-15 00:56:40.000000', 'consum', 0.0216, 'lps'),
	(415521, 126, '2015-02-15 00:56:41.000000', 'consum', 0.0215, 'lps'),
	(415522, 126, '2015-02-15 00:56:42.000000', 'consum', 0.0218, 'lps'),
	(415523, 126, '2015-02-15 00:56:43.000000', 'consum', 0.0222, 'lps'),
	(415524, 126, '2015-02-15 00:56:44.000000', 'consum', 0.0218, 'lps'),
	(415525, 126, '2015-02-15 00:56:45.000000', 'consum', 0.0216, 'lps'),
	(415526, 126, '2015-02-15 00:56:46.000000', 'consum', 0.0217, 'lps'),
	(415527, 126, '2015-02-15 00:56:47.000000', 'consum', 0.0213, 'lps'),
	(415528, 126, '2015-02-15 00:56:48.000000', 'consum', 0.0216, 'lps'),
	(415529, 126, '2015-02-15 00:56:49.000000', 'consum', 0.0221, 'lps'),
	(415530, 126, '2015-02-15 00:56:50.000000', 'consum', 0.0216, 'lps'),
	(415531, 126, '2015-02-15 00:56:51.000000', 'consum', 0.0210, 'lps'),
	(415532, 126, '2015-02-15 00:56:52.000000', 'consum', 0.0222, 'lps'),
	(415533, 126, '2015-02-15 00:56:53.000000', 'consum', 0.0212, 'lps'),
	(415534, 126, '2015-02-15 00:56:54.000000', 'consum', 0.0214, 'lps'),
	(415535, 126, '2015-02-15 00:56:55.000000', 'consum', 0.0211, 'lps'),
	(415536, 126, '2015-02-15 00:56:56.000000', 'consum', 0.0215, 'lps'),
	(415537, 126, '2015-02-15 00:56:57.000000', 'consum', 0.0219, 'lps'),
	(415538, 126, '2015-02-15 00:56:58.000000', 'consum', 0.0213, 'lps'),
	(415539, 126, '2015-02-15 00:56:59.000000', 'consum', 0.0211, 'lps'),
	(415540, 126, '2015-02-15 00:57:00.000000', 'consum', 0.0220, 'lps'),
	(415541, 126, '2015-02-15 00:57:01.000000', 'consum', 0.0217, 'lps'),
	(415542, 126, '2015-02-15 00:57:02.000000', 'consum', 0.0216, 'lps'),
	(415543, 126, '2015-02-15 00:57:03.000000', 'consum', 0.0218, 'lps'),
	(415544, 126, '2015-02-15 00:57:04.000000', 'consum', 0.0219, 'lps'),
	(415545, 126, '2015-02-15 00:57:05.000000', 'consum', 0.0218, 'lps'),
	(415546, 126, '2015-02-15 00:57:06.000000', 'consum', 0.0211, 'lps'),
	(415547, 126, '2015-02-15 00:57:07.000000', 'consum', 0.0217, 'lps'),
	(415548, 126, '2015-02-15 00:57:08.000000', 'consum', 0.0215, 'lps'),
	(415549, 126, '2015-02-15 00:57:09.000000', 'consum', 0.0213, 'lps'),
	(415550, 126, '2015-02-15 00:57:10.000000', 'consum', 0.0212, 'lps'),
	(415551, 126, '2015-02-15 00:57:11.000000', 'consum', 0.0211, 'lps'),
	(415552, 126, '2015-02-15 00:57:12.000000', 'consum', 0.0222, 'lps'),
	(415553, 126, '2015-02-15 00:57:13.000000', 'consum', 0.0214, 'lps'),
	(415554, 126, '2015-02-15 00:57:14.000000', 'consum', 0.0221, 'lps'),
	(415555, 126, '2015-02-15 00:57:15.000000', 'consum', 0.0214, 'lps'),
	(415556, 126, '2015-02-15 00:57:16.000000', 'consum', 0.0210, 'lps'),
	(415557, 126, '2015-02-15 00:57:17.000000', 'consum', 0.0213, 'lps'),
	(415558, 126, '2015-02-15 00:57:18.000000', 'consum', 0.0210, 'lps'),
	(415559, 126, '2015-02-15 00:57:19.000000', 'consum', 0.0215, 'lps'),
	(415560, 126, '2015-02-15 00:57:20.000000', 'consum', 0.0223, 'lps'),
	(415561, 126, '2015-02-15 00:57:21.000000', 'consum', 0.0219, 'lps'),
	(415562, 126, '2015-02-15 00:57:22.000000', 'consum', 0.0217, 'lps'),
	(415563, 126, '2015-02-15 00:57:23.000000', 'consum', 0.0219, 'lps'),
	(415564, 126, '2015-02-15 00:57:24.000000', 'consum', 0.0221, 'lps'),
	(415565, 126, '2015-02-15 00:57:25.000000', 'consum', 0.0210, 'lps'),
	(415566, 126, '2015-02-15 00:57:26.000000', 'consum', 0.0220, 'lps'),
	(415567, 126, '2015-02-15 00:57:27.000000', 'consum', 0.0216, 'lps'),
	(415568, 126, '2015-02-15 00:57:28.000000', 'consum', 0.0212, 'lps'),
	(415569, 126, '2015-02-15 00:57:29.000000', 'consum', 0.0216, 'lps'),
	(415570, 126, '2015-02-15 00:57:30.000000', 'consum', 0.0221, 'lps'),
	(415571, 126, '2015-02-15 00:57:31.000000', 'consum', 0.0219, 'lps'),
	(415572, 126, '2015-02-15 00:57:32.000000', 'consum', 0.0210, 'lps'),
	(415573, 126, '2015-02-15 00:57:33.000000', 'consum', 0.0210, 'lps'),
	(415574, 126, '2015-02-15 00:57:34.000000', 'consum', 0.0223, 'lps'),
	(415575, 126, '2015-02-15 00:57:35.000000', 'consum', 0.0220, 'lps'),
	(415576, 126, '2015-02-15 00:57:36.000000', 'consum', 0.0222, 'lps'),
	(415577, 126, '2015-02-15 00:57:37.000000', 'consum', 0.0212, 'lps'),
	(415578, 126, '2015-02-15 00:57:38.000000', 'consum', 0.0215, 'lps'),
	(415579, 126, '2015-02-15 00:57:39.000000', 'consum', 0.0213, 'lps'),
	(415580, 126, '2015-02-15 00:57:40.000000', 'consum', 0.0212, 'lps'),
	(415581, 126, '2015-02-15 00:57:41.000000', 'consum', 0.0223, 'lps'),
	(415582, 126, '2015-02-15 00:57:42.000000', 'consum', 0.0215, 'lps'),
	(415583, 126, '2015-02-15 00:57:43.000000', 'consum', 0.0210, 'lps'),
	(415584, 126, '2015-02-15 00:57:44.000000', 'consum', 0.0222, 'lps'),
	(415585, 126, '2015-02-15 00:57:45.000000', 'consum', 0.0218, 'lps'),
	(415586, 126, '2015-02-15 00:57:46.000000', 'consum', 0.0212, 'lps'),
	(415587, 126, '2015-02-15 00:57:47.000000', 'consum', 0.0213, 'lps'),
	(415588, 126, '2015-02-15 00:57:48.000000', 'consum', 0.0219, 'lps'),
	(415589, 126, '2015-02-15 00:57:49.000000', 'consum', 0.0217, 'lps'),
	(415590, 126, '2015-02-15 00:57:50.000000', 'consum', 0.0221, 'lps'),
	(415591, 126, '2015-02-15 00:57:51.000000', 'consum', 0.0215, 'lps'),
	(415592, 126, '2015-02-15 00:57:52.000000', 'consum', 0.0216, 'lps'),
	(415593, 126, '2015-02-15 00:57:53.000000', 'consum', 0.0211, 'lps'),
	(415594, 126, '2015-02-15 00:57:54.000000', 'consum', 0.0212, 'lps'),
	(415595, 126, '2015-02-15 00:57:55.000000', 'consum', 0.0218, 'lps'),
	(415596, 126, '2015-02-15 00:57:56.000000', 'consum', 0.0215, 'lps'),
	(415597, 126, '2015-02-15 00:57:57.000000', 'consum', 0.0214, 'lps'),
	(415598, 126, '2015-02-15 00:57:58.000000', 'consum', 0.0214, 'lps'),
	(415599, 126, '2015-02-15 00:57:59.000000', 'consum', 0.0218, 'lps'),
	(415600, 126, '2015-02-15 00:58:00.000000', 'consum', 0.0212, 'lps'),
	(415601, 126, '2015-02-15 00:58:01.000000', 'consum', 0.0212, 'lps'),
	(415602, 126, '2015-02-15 00:58:02.000000', 'consum', 0.0213, 'lps'),
	(415603, 126, '2015-02-15 00:58:03.000000', 'consum', 0.0217, 'lps'),
	(415604, 126, '2015-02-15 00:58:04.000000', 'consum', 0.0212, 'lps'),
	(415605, 126, '2015-02-15 00:58:05.000000', 'consum', 0.0213, 'lps'),
	(415606, 126, '2015-02-15 00:58:06.000000', 'consum', 0.0220, 'lps'),
	(415607, 126, '2015-02-15 00:58:07.000000', 'consum', 0.0210, 'lps'),
	(415608, 126, '2015-02-15 00:58:08.000000', 'consum', 0.0210, 'lps'),
	(415609, 126, '2015-02-15 00:58:09.000000', 'consum', 0.0221, 'lps'),
	(415610, 126, '2015-02-15 00:58:10.000000', 'consum', 0.0210, 'lps'),
	(415611, 126, '2015-02-15 00:58:11.000000', 'consum', 0.0221, 'lps'),
	(415612, 126, '2015-02-15 00:58:12.000000', 'consum', 0.0221, 'lps'),
	(415613, 126, '2015-02-15 00:58:13.000000', 'consum', 0.0220, 'lps'),
	(415614, 126, '2015-02-15 00:58:14.000000', 'consum', 0.0214, 'lps'),
	(415615, 126, '2015-02-15 00:58:15.000000', 'consum', 0.0214, 'lps'),
	(415616, 126, '2015-02-15 00:58:16.000000', 'consum', 0.0219, 'lps'),
	(415617, 126, '2015-02-15 00:58:17.000000', 'consum', 0.0214, 'lps'),
	(415618, 126, '2015-02-15 00:58:18.000000', 'consum', 0.0219, 'lps'),
	(415619, 126, '2015-02-15 00:58:19.000000', 'consum', 0.0214, 'lps'),
	(415620, 126, '2015-02-15 00:58:20.000000', 'consum', 0.0218, 'lps'),
	(415621, 126, '2015-02-15 00:58:21.000000', 'consum', 0.0212, 'lps'),
	(415622, 126, '2015-02-15 00:58:22.000000', 'consum', 0.0210, 'lps'),
	(415623, 126, '2015-02-15 00:58:23.000000', 'consum', 0.0219, 'lps'),
	(415624, 126, '2015-02-15 00:58:24.000000', 'consum', 0.0213, 'lps'),
	(415625, 126, '2015-02-15 00:58:25.000000', 'consum', 0.0211, 'lps'),
	(415626, 126, '2015-02-15 00:58:26.000000', 'consum', 0.0223, 'lps'),
	(415627, 126, '2015-02-15 00:58:27.000000', 'consum', 0.0215, 'lps'),
	(415628, 126, '2015-02-15 00:58:28.000000', 'consum', 0.0212, 'lps'),
	(415629, 126, '2015-02-15 00:58:29.000000', 'consum', 0.0221, 'lps'),
	(415630, 126, '2015-02-15 00:58:30.000000', 'consum', 0.0214, 'lps'),
	(415631, 126, '2015-02-15 00:58:31.000000', 'consum', 0.0213, 'lps'),
	(415632, 126, '2015-02-15 00:58:32.000000', 'consum', 0.0213, 'lps'),
	(415633, 126, '2015-02-15 00:58:33.000000', 'consum', 0.0215, 'lps'),
	(415634, 126, '2015-02-15 00:58:34.000000', 'consum', 0.0212, 'lps'),
	(415635, 126, '2015-02-15 00:58:35.000000', 'consum', 0.0222, 'lps'),
	(415636, 126, '2015-02-15 00:58:36.000000', 'consum', 0.0223, 'lps'),
	(415637, 126, '2015-02-15 00:58:37.000000', 'consum', 0.0210, 'lps'),
	(415638, 126, '2015-02-15 00:58:38.000000', 'consum', 0.0214, 'lps'),
	(415639, 126, '2015-02-15 00:58:39.000000', 'consum', 0.0216, 'lps'),
	(415640, 126, '2015-02-15 00:58:40.000000', 'consum', 0.0213, 'lps'),
	(415641, 126, '2015-02-15 00:58:41.000000', 'consum', 0.0223, 'lps'),
	(415642, 126, '2015-02-15 00:58:42.000000', 'consum', 0.0210, 'lps'),
	(415643, 126, '2015-02-15 00:58:43.000000', 'consum', 0.0212, 'lps'),
	(415644, 126, '2015-02-15 00:58:44.000000', 'consum', 0.0223, 'lps'),
	(415645, 126, '2015-02-15 00:58:45.000000', 'consum', 0.0213, 'lps'),
	(415646, 126, '2015-02-15 00:58:46.000000', 'consum', 0.0214, 'lps'),
	(415647, 126, '2015-02-15 00:58:47.000000', 'consum', 0.0223, 'lps'),
	(415648, 126, '2015-02-15 00:58:48.000000', 'consum', 0.0219, 'lps'),
	(415649, 126, '2015-02-15 00:58:49.000000', 'consum', 0.0216, 'lps'),
	(415650, 126, '2015-02-15 00:58:50.000000', 'consum', 0.0213, 'lps'),
	(415651, 126, '2015-02-15 00:58:51.000000', 'consum', 0.0210, 'lps'),
	(415652, 126, '2015-02-15 00:58:52.000000', 'consum', 0.0213, 'lps'),
	(415653, 126, '2015-02-15 00:58:53.000000', 'consum', 0.0211, 'lps'),
	(415654, 126, '2015-02-15 00:58:54.000000', 'consum', 0.0220, 'lps'),
	(415655, 126, '2015-02-15 00:58:55.000000', 'consum', 0.0216, 'lps'),
	(415656, 126, '2015-02-15 00:58:56.000000', 'consum', 0.0210, 'lps'),
	(415657, 126, '2015-02-15 00:58:57.000000', 'consum', 0.0221, 'lps'),
	(415658, 126, '2015-02-15 00:58:58.000000', 'consum', 0.0211, 'lps'),
	(415659, 126, '2015-02-15 00:58:59.000000', 'consum', 0.0210, 'lps'),
	(415660, 126, '2015-02-15 00:59:00.000000', 'consum', 0.0219, 'lps'),
	(415661, 126, '2015-02-15 00:59:01.000000', 'consum', 0.0217, 'lps'),
	(415662, 126, '2015-02-15 00:59:02.000000', 'consum', 0.0217, 'lps'),
	(415663, 126, '2015-02-15 00:59:03.000000', 'consum', 0.0223, 'lps'),
	(415664, 126, '2015-02-15 00:59:04.000000', 'consum', 0.0215, 'lps'),
	(415665, 126, '2015-02-15 00:59:05.000000', 'consum', 0.0211, 'lps'),
	(415666, 126, '2015-02-15 00:59:06.000000', 'consum', 0.0214, 'lps'),
	(415667, 126, '2015-02-15 00:59:07.000000', 'consum', 0.0214, 'lps'),
	(415668, 126, '2015-02-15 00:59:08.000000', 'consum', 0.0216, 'lps'),
	(415669, 126, '2015-02-15 00:59:09.000000', 'consum', 0.0218, 'lps'),
	(415670, 126, '2015-02-15 00:59:10.000000', 'consum', 0.0215, 'lps'),
	(415671, 126, '2015-02-15 00:59:11.000000', 'consum', 0.0213, 'lps'),
	(415672, 126, '2015-02-15 00:59:12.000000', 'consum', 0.0222, 'lps'),
	(415673, 126, '2015-02-15 00:59:13.000000', 'consum', 0.0223, 'lps'),
	(415674, 126, '2015-02-15 00:59:14.000000', 'consum', 0.0223, 'lps'),
	(415675, 126, '2015-02-15 00:59:15.000000', 'consum', 0.0210, 'lps'),
	(415676, 126, '2015-02-15 00:59:16.000000', 'consum', 0.0214, 'lps'),
	(415677, 126, '2015-02-15 00:59:17.000000', 'consum', 0.0214, 'lps'),
	(415678, 126, '2015-02-15 00:59:18.000000', 'consum', 0.0219, 'lps'),
	(415679, 126, '2015-02-15 00:59:19.000000', 'consum', 0.0216, 'lps'),
	(415680, 126, '2015-02-15 00:59:20.000000', 'consum', 0.0214, 'lps'),
	(415681, 126, '2015-02-15 00:59:21.000000', 'consum', 0.0214, 'lps'),
	(415682, 126, '2015-02-15 00:59:22.000000', 'consum', 0.0216, 'lps'),
	(415683, 126, '2015-02-15 00:59:23.000000', 'consum', 0.0216, 'lps'),
	(415684, 126, '2015-02-15 00:59:24.000000', 'consum', 0.0220, 'lps'),
	(415685, 126, '2015-02-15 00:59:25.000000', 'consum', 0.0216, 'lps'),
	(415686, 126, '2015-02-15 00:59:26.000000', 'consum', 0.0211, 'lps'),
	(415687, 126, '2015-02-15 00:59:27.000000', 'consum', 0.0223, 'lps'),
	(415688, 126, '2015-02-15 00:59:28.000000', 'consum', 0.0219, 'lps'),
	(415689, 126, '2015-02-15 00:59:29.000000', 'consum', 0.0214, 'lps'),
	(415690, 126, '2015-02-15 00:59:30.000000', 'consum', 0.0218, 'lps'),
	(415691, 126, '2015-02-15 00:59:31.000000', 'consum', 0.0211, 'lps'),
	(415692, 126, '2015-02-15 00:59:32.000000', 'consum', 0.0218, 'lps'),
	(415693, 126, '2015-02-15 00:59:33.000000', 'consum', 0.0220, 'lps'),
	(415694, 126, '2015-02-15 00:59:34.000000', 'consum', 0.0210, 'lps'),
	(415695, 126, '2015-02-15 00:59:35.000000', 'consum', 0.0220, 'lps'),
	(415696, 126, '2015-02-15 00:59:36.000000', 'consum', 0.0219, 'lps'),
	(415697, 126, '2015-02-15 00:59:37.000000', 'consum', 0.0210, 'lps'),
	(415698, 126, '2015-02-15 00:59:38.000000', 'consum', 0.0214, 'lps'),
	(415699, 126, '2015-02-15 00:59:39.000000', 'consum', 0.0215, 'lps'),
	(415700, 126, '2015-02-15 00:59:40.000000', 'consum', 0.0223, 'lps'),
	(415701, 126, '2015-02-15 00:59:41.000000', 'consum', 0.0218, 'lps'),
	(415702, 126, '2015-02-15 00:59:42.000000', 'consum', 0.0214, 'lps'),
	(415703, 126, '2015-02-15 00:59:43.000000', 'consum', 0.0218, 'lps'),
	(415704, 126, '2015-02-15 00:59:44.000000', 'consum', 0.0212, 'lps'),
	(415705, 126, '2015-02-15 00:59:45.000000', 'consum', 0.0210, 'lps'),
	(415706, 126, '2015-02-15 00:59:46.000000', 'consum', 0.0220, 'lps'),
	(415707, 126, '2015-02-15 00:59:47.000000', 'consum', 0.0217, 'lps'),
	(415708, 126, '2015-02-15 00:59:48.000000', 'consum', 0.0217, 'lps'),
	(415709, 126, '2015-02-15 00:59:49.000000', 'consum', 0.0210, 'lps'),
	(415710, 126, '2015-02-15 00:59:50.000000', 'consum', 0.0216, 'lps'),
	(415711, 126, '2015-02-15 00:59:51.000000', 'consum', 0.0213, 'lps'),
	(415712, 126, '2015-02-15 00:59:52.000000', 'consum', 0.0223, 'lps'),
	(415713, 126, '2015-02-15 00:59:53.000000', 'consum', 0.0210, 'lps'),
	(415714, 126, '2015-02-15 00:59:54.000000', 'consum', 0.0212, 'lps'),
	(415715, 126, '2015-02-15 00:59:55.000000', 'consum', 0.0220, 'lps'),
	(415716, 126, '2015-02-15 00:59:56.000000', 'consum', 0.0213, 'lps'),
	(415717, 126, '2015-02-15 00:59:57.000000', 'consum', 0.0222, 'lps'),
	(415718, 126, '2015-02-15 00:59:58.000000', 'consum', 0.0223, 'lps'),
	(415719, 126, '2015-02-15 00:59:59.000000', 'consum', 0.0222, 'lps'),
	(415720, 126, '2015-02-15 01:00:00.000000', 'consum', 0.0219, 'lps'),
	(415721, 126, '2015-02-15 01:00:01.000000', 'consum', 0.0221, 'lps'),
	(415722, 126, '2015-02-15 01:00:02.000000', 'consum', 0.0223, 'lps'),
	(415723, 126, '2015-02-15 01:00:03.000000', 'consum', 0.0217, 'lps'),
	(415724, 126, '2015-02-15 01:00:04.000000', 'consum', 0.0217, 'lps'),
	(415725, 126, '2015-02-15 01:00:05.000000', 'consum', 0.0212, 'lps'),
	(415726, 126, '2015-02-15 01:00:06.000000', 'consum', 0.0213, 'lps'),
	(415727, 126, '2015-02-15 01:00:07.000000', 'consum', 0.0219, 'lps'),
	(415728, 126, '2015-02-15 01:00:08.000000', 'consum', 0.0221, 'lps'),
	(415729, 126, '2015-02-15 01:00:09.000000', 'consum', 0.0210, 'lps'),
	(415730, 126, '2015-02-15 01:00:10.000000', 'consum', 0.0218, 'lps'),
	(415731, 126, '2015-02-15 01:00:11.000000', 'consum', 0.0222, 'lps'),
	(415732, 126, '2015-02-15 01:00:12.000000', 'consum', 0.0221, 'lps'),
	(415733, 126, '2015-02-15 01:00:13.000000', 'consum', 0.0214, 'lps'),
	(415734, 126, '2015-02-15 01:00:14.000000', 'consum', 0.0212, 'lps'),
	(415735, 126, '2015-02-15 01:00:15.000000', 'consum', 0.0223, 'lps'),
	(415736, 126, '2015-02-15 01:00:16.000000', 'consum', 0.0214, 'lps'),
	(415737, 126, '2015-02-15 01:00:17.000000', 'consum', 0.0218, 'lps'),
	(415738, 126, '2015-02-15 01:00:18.000000', 'consum', 0.0212, 'lps'),
	(415739, 126, '2015-02-15 01:00:19.000000', 'consum', 0.0210, 'lps'),
	(415740, 126, '2015-02-15 01:00:20.000000', 'consum', 0.0218, 'lps'),
	(415741, 126, '2015-02-15 01:00:21.000000', 'consum', 0.0223, 'lps'),
	(415742, 126, '2015-02-15 01:00:22.000000', 'consum', 0.0210, 'lps'),
	(415743, 126, '2015-02-15 01:00:23.000000', 'consum', 0.0215, 'lps'),
	(415744, 126, '2015-02-15 01:00:24.000000', 'consum', 0.0218, 'lps'),
	(415745, 126, '2015-02-15 01:00:25.000000', 'consum', 0.0211, 'lps'),
	(415746, 126, '2015-02-15 01:00:26.000000', 'consum', 0.0218, 'lps'),
	(415747, 126, '2015-02-15 01:00:27.000000', 'consum', 0.0220, 'lps'),
	(415748, 126, '2015-02-15 01:00:28.000000', 'consum', 0.0222, 'lps'),
	(415749, 126, '2015-02-15 01:00:29.000000', 'consum', 0.0212, 'lps'),
	(415750, 126, '2015-02-15 01:00:30.000000', 'consum', 0.0212, 'lps'),
	(415751, 126, '2015-02-15 01:00:31.000000', 'consum', 0.0215, 'lps'),
	(415752, 126, '2015-02-15 01:00:32.000000', 'consum', 0.0214, 'lps'),
	(415753, 126, '2015-02-15 01:00:33.000000', 'consum', 0.0217, 'lps'),
	(415754, 126, '2015-02-15 01:00:34.000000', 'consum', 0.0219, 'lps'),
	(415755, 126, '2015-02-15 01:00:35.000000', 'consum', 0.0223, 'lps'),
	(415756, 126, '2015-02-15 01:00:36.000000', 'consum', 0.0217, 'lps'),
	(415757, 126, '2015-02-15 01:00:37.000000', 'consum', 0.0222, 'lps'),
	(415758, 126, '2015-02-15 01:00:38.000000', 'consum', 0.0222, 'lps'),
	(415759, 126, '2015-02-15 01:00:39.000000', 'consum', 0.0219, 'lps'),
	(415760, 126, '2015-02-15 01:00:40.000000', 'consum', 0.0218, 'lps'),
	(415761, 126, '2015-02-15 01:00:41.000000', 'consum', 0.0213, 'lps'),
	(415762, 126, '2015-02-15 01:00:42.000000', 'consum', 0.0213, 'lps'),
	(415763, 126, '2015-02-15 01:00:43.000000', 'consum', 0.0219, 'lps'),
	(415764, 126, '2015-02-15 01:00:44.000000', 'consum', 0.0219, 'lps'),
	(415765, 126, '2015-02-15 01:00:45.000000', 'consum', 0.0213, 'lps'),
	(415766, 126, '2015-02-15 01:00:46.000000', 'consum', 0.0211, 'lps'),
	(415767, 126, '2015-02-15 01:00:47.000000', 'consum', 0.0221, 'lps'),
	(415768, 126, '2015-02-15 01:00:48.000000', 'consum', 0.0223, 'lps'),
	(415769, 126, '2015-02-15 01:00:49.000000', 'consum', 0.0213, 'lps'),
	(415770, 126, '2015-02-15 01:00:50.000000', 'consum', 0.0213, 'lps'),
	(415771, 126, '2015-02-15 01:00:51.000000', 'consum', 0.0218, 'lps'),
	(415772, 126, '2015-02-15 01:00:52.000000', 'consum', 0.0215, 'lps'),
	(415773, 126, '2015-02-15 01:00:53.000000', 'consum', 0.0212, 'lps'),
	(415774, 126, '2015-02-15 01:00:54.000000', 'consum', 0.0217, 'lps'),
	(415775, 126, '2015-02-15 01:00:55.000000', 'consum', 0.0213, 'lps'),
	(415776, 126, '2015-02-15 01:00:56.000000', 'consum', 0.0220, 'lps'),
	(415777, 126, '2015-02-15 01:00:57.000000', 'consum', 0.0222, 'lps'),
	(415778, 126, '2015-02-15 01:00:58.000000', 'consum', 0.0212, 'lps'),
	(415779, 126, '2015-02-15 01:00:59.000000', 'consum', 0.0212, 'lps'),
	(415780, 126, '2015-02-15 01:01:00.000000', 'consum', 0.0216, 'lps'),
	(415781, 126, '2015-02-15 01:01:01.000000', 'consum', 0.0222, 'lps'),
	(415782, 126, '2015-02-15 01:01:02.000000', 'consum', 0.0222, 'lps'),
	(415783, 126, '2015-02-15 01:01:03.000000', 'consum', 0.0220, 'lps'),
	(415784, 126, '2015-02-15 01:01:04.000000', 'consum', 0.0213, 'lps'),
	(415785, 126, '2015-02-15 01:01:05.000000', 'consum', 0.0210, 'lps'),
	(415786, 126, '2015-02-15 01:01:06.000000', 'consum', 0.0216, 'lps'),
	(415787, 126, '2015-02-15 01:01:07.000000', 'consum', 0.0213, 'lps'),
	(415788, 126, '2015-02-15 01:01:08.000000', 'consum', 0.0222, 'lps'),
	(415789, 126, '2015-02-15 01:01:09.000000', 'consum', 0.0218, 'lps'),
	(415790, 126, '2015-02-15 01:01:10.000000', 'consum', 0.0214, 'lps'),
	(415791, 126, '2015-02-15 01:01:11.000000', 'consum', 0.0220, 'lps'),
	(415792, 126, '2015-02-15 01:01:12.000000', 'consum', 0.0222, 'lps'),
	(415793, 126, '2015-02-15 01:01:13.000000', 'consum', 0.0210, 'lps'),
	(415794, 126, '2015-02-15 01:01:14.000000', 'consum', 0.0217, 'lps'),
	(415795, 126, '2015-02-15 01:01:15.000000', 'consum', 0.0220, 'lps'),
	(415796, 126, '2015-02-15 01:01:16.000000', 'consum', 0.0210, 'lps'),
	(415797, 126, '2015-02-15 01:01:17.000000', 'consum', 0.0210, 'lps'),
	(415798, 126, '2015-02-15 01:01:18.000000', 'consum', 0.0211, 'lps'),
	(415799, 126, '2015-02-15 01:01:19.000000', 'consum', 0.0213, 'lps'),
	(415800, 126, '2015-02-15 01:01:20.000000', 'consum', 0.0211, 'lps'),
	(415801, 126, '2015-02-15 01:01:21.000000', 'consum', 0.0221, 'lps'),
	(415802, 126, '2015-02-15 01:01:22.000000', 'consum', 0.0218, 'lps'),
	(415803, 126, '2015-02-15 01:01:23.000000', 'consum', 0.0220, 'lps'),
	(415804, 126, '2015-02-15 01:01:24.000000', 'consum', 0.0220, 'lps'),
	(415805, 126, '2015-02-15 01:01:25.000000', 'consum', 0.0216, 'lps'),
	(415806, 126, '2015-02-15 01:01:26.000000', 'consum', 0.0214, 'lps'),
	(415807, 126, '2015-02-15 01:01:27.000000', 'consum', 0.0223, 'lps'),
	(415808, 126, '2015-02-15 01:01:28.000000', 'consum', 0.0223, 'lps'),
	(415809, 126, '2015-02-15 01:01:29.000000', 'consum', 0.0210, 'lps'),
	(415810, 126, '2015-02-15 01:01:30.000000', 'consum', 0.0211, 'lps'),
	(415811, 126, '2015-02-15 01:01:31.000000', 'consum', 0.0215, 'lps'),
	(415812, 126, '2015-02-15 01:01:32.000000', 'consum', 0.0218, 'lps'),
	(415813, 126, '2015-02-15 01:01:33.000000', 'consum', 0.0223, 'lps'),
	(415814, 126, '2015-02-15 01:01:34.000000', 'consum', 0.0211, 'lps'),
	(415815, 126, '2015-02-15 01:01:35.000000', 'consum', 0.0218, 'lps'),
	(415816, 126, '2015-02-15 01:01:36.000000', 'consum', 0.0219, 'lps'),
	(415817, 126, '2015-02-15 01:01:37.000000', 'consum', 0.0216, 'lps'),
	(415818, 126, '2015-02-15 01:01:38.000000', 'consum', 0.0215, 'lps'),
	(415819, 126, '2015-02-15 01:01:39.000000', 'consum', 0.0216, 'lps'),
	(415820, 126, '2015-02-15 01:01:40.000000', 'consum', 0.0214, 'lps'),
	(415821, 126, '2015-02-15 01:01:41.000000', 'consum', 0.0210, 'lps'),
	(415822, 126, '2015-02-15 01:01:42.000000', 'consum', 0.0215, 'lps'),
	(415823, 126, '2015-02-15 01:01:43.000000', 'consum', 0.0222, 'lps'),
	(415824, 126, '2015-02-15 01:01:44.000000', 'consum', 0.0211, 'lps'),
	(415825, 126, '2015-02-15 01:01:45.000000', 'consum', 0.0221, 'lps'),
	(415826, 126, '2015-02-15 01:01:46.000000', 'consum', 0.0222, 'lps'),
	(415827, 126, '2015-02-15 01:01:47.000000', 'consum', 0.0222, 'lps'),
	(415828, 126, '2015-02-15 01:01:48.000000', 'consum', 0.0220, 'lps'),
	(415829, 126, '2015-02-15 01:01:49.000000', 'consum', 0.0210, 'lps'),
	(415830, 126, '2015-02-15 01:01:50.000000', 'consum', 0.0210, 'lps'),
	(415831, 126, '2015-02-15 01:01:51.000000', 'consum', 0.0212, 'lps'),
	(415832, 126, '2015-02-15 01:01:52.000000', 'consum', 0.0220, 'lps'),
	(415833, 126, '2015-02-15 01:01:53.000000', 'consum', 0.0211, 'lps'),
	(415834, 126, '2015-02-15 01:01:54.000000', 'consum', 0.0212, 'lps'),
	(415835, 126, '2015-02-15 01:01:55.000000', 'consum', 0.0220, 'lps'),
	(415836, 126, '2015-02-15 01:01:56.000000', 'consum', 0.0213, 'lps'),
	(415837, 126, '2015-02-15 01:01:57.000000', 'consum', 0.0222, 'lps'),
	(415838, 126, '2015-02-15 01:01:58.000000', 'consum', 0.0218, 'lps'),
	(415839, 126, '2015-02-15 01:01:59.000000', 'consum', 0.0216, 'lps'),
	(415840, 126, '2015-02-15 01:02:00.000000', 'consum', 0.0215, 'lps'),
	(415841, 126, '2015-02-15 01:02:01.000000', 'consum', 0.0218, 'lps'),
	(415842, 126, '2015-02-15 01:02:02.000000', 'consum', 0.0220, 'lps'),
	(415843, 126, '2015-02-15 01:02:03.000000', 'consum', 0.0223, 'lps'),
	(415844, 126, '2015-02-15 01:02:04.000000', 'consum', 0.0218, 'lps'),
	(415845, 126, '2015-02-15 01:02:05.000000', 'consum', 0.0214, 'lps'),
	(415846, 126, '2015-02-15 01:02:06.000000', 'consum', 0.0217, 'lps'),
	(415847, 126, '2015-02-15 01:02:07.000000', 'consum', 0.0219, 'lps'),
	(415848, 126, '2015-02-15 01:02:08.000000', 'consum', 0.0210, 'lps'),
	(415849, 126, '2015-02-15 01:02:09.000000', 'consum', 0.0222, 'lps'),
	(415850, 126, '2015-02-15 01:02:10.000000', 'consum', 0.0217, 'lps'),
	(415851, 126, '2015-02-15 01:02:11.000000', 'consum', 0.0222, 'lps'),
	(415852, 126, '2015-02-15 01:02:12.000000', 'consum', 0.0223, 'lps'),
	(415853, 126, '2015-02-15 01:02:13.000000', 'consum', 0.0212, 'lps'),
	(415854, 126, '2015-02-15 01:02:14.000000', 'consum', 0.0210, 'lps'),
	(415855, 126, '2015-02-15 01:02:15.000000', 'consum', 0.0217, 'lps'),
	(415856, 126, '2015-02-15 01:02:16.000000', 'consum', 0.0219, 'lps'),
	(415857, 126, '2015-02-15 01:02:17.000000', 'consum', 0.0219, 'lps'),
	(415858, 126, '2015-02-15 01:02:18.000000', 'consum', 0.0215, 'lps'),
	(415859, 126, '2015-02-15 01:02:19.000000', 'consum', 0.0222, 'lps'),
	(415860, 126, '2015-02-15 01:02:20.000000', 'consum', 0.0213, 'lps'),
	(415861, 126, '2015-02-15 01:02:21.000000', 'consum', 0.0217, 'lps'),
	(415862, 126, '2015-02-15 01:02:22.000000', 'consum', 0.0223, 'lps'),
	(415863, 126, '2015-02-15 01:02:23.000000', 'consum', 0.0211, 'lps'),
	(415864, 126, '2015-02-15 01:02:24.000000', 'consum', 0.0221, 'lps'),
	(415865, 126, '2015-02-15 01:02:25.000000', 'consum', 0.0218, 'lps'),
	(415866, 126, '2015-02-15 01:02:26.000000', 'consum', 0.0219, 'lps'),
	(415867, 126, '2015-02-15 01:02:27.000000', 'consum', 0.0217, 'lps'),
	(415868, 126, '2015-02-15 01:02:28.000000', 'consum', 0.0219, 'lps'),
	(415869, 126, '2015-02-15 01:02:29.000000', 'consum', 0.0219, 'lps'),
	(415870, 126, '2015-02-15 01:02:30.000000', 'consum', 0.0213, 'lps'),
	(415871, 126, '2015-02-15 01:02:31.000000', 'consum', 0.0215, 'lps'),
	(415872, 126, '2015-02-15 01:02:32.000000', 'consum', 0.0213, 'lps'),
	(415873, 126, '2015-02-15 01:02:33.000000', 'consum', 0.0210, 'lps'),
	(415874, 126, '2015-02-15 01:02:34.000000', 'consum', 0.0216, 'lps'),
	(415875, 126, '2015-02-15 01:02:35.000000', 'consum', 0.0213, 'lps'),
	(415876, 126, '2015-02-15 01:02:36.000000', 'consum', 0.0220, 'lps'),
	(415877, 126, '2015-02-15 01:02:37.000000', 'consum', 0.0211, 'lps'),
	(415878, 126, '2015-02-15 01:02:38.000000', 'consum', 0.0211, 'lps'),
	(415879, 126, '2015-02-15 01:02:39.000000', 'consum', 0.0214, 'lps'),
	(415880, 126, '2015-02-15 01:02:40.000000', 'consum', 0.0215, 'lps'),
	(415881, 126, '2015-02-15 01:02:41.000000', 'consum', 0.0210, 'lps'),
	(415882, 126, '2015-02-15 01:02:42.000000', 'consum', 0.0223, 'lps'),
	(415883, 126, '2015-02-15 01:02:43.000000', 'consum', 0.0221, 'lps'),
	(415884, 126, '2015-02-15 01:02:44.000000', 'consum', 0.0210, 'lps'),
	(415885, 126, '2015-02-15 01:02:45.000000', 'consum', 0.0219, 'lps'),
	(415886, 126, '2015-02-15 01:02:46.000000', 'consum', 0.0214, 'lps'),
	(415887, 126, '2015-02-15 01:02:47.000000', 'consum', 0.0217, 'lps'),
	(415888, 126, '2015-02-15 01:02:48.000000', 'consum', 0.0221, 'lps'),
	(415889, 126, '2015-02-15 01:02:49.000000', 'consum', 0.0218, 'lps'),
	(415890, 126, '2015-02-15 01:02:50.000000', 'consum', 0.0214, 'lps'),
	(415891, 126, '2015-02-15 01:02:51.000000', 'consum', 0.0223, 'lps'),
	(415892, 126, '2015-02-15 01:02:52.000000', 'consum', 0.0220, 'lps'),
	(415893, 126, '2015-02-15 01:02:53.000000', 'consum', 0.0222, 'lps'),
	(415894, 126, '2015-02-15 01:02:54.000000', 'consum', 0.0213, 'lps'),
	(415895, 126, '2015-02-15 01:02:55.000000', 'consum', 0.0217, 'lps'),
	(415896, 126, '2015-02-15 01:02:56.000000', 'consum', 0.0221, 'lps'),
	(415897, 126, '2015-02-15 01:02:57.000000', 'consum', 0.0219, 'lps'),
	(415898, 126, '2015-02-15 01:02:58.000000', 'consum', 0.0223, 'lps'),
	(415899, 126, '2015-02-15 01:02:59.000000', 'consum', 0.0221, 'lps'),
	(415900, 126, '2015-02-15 01:03:00.000000', 'consum', 0.0210, 'lps'),
	(415901, 126, '2015-02-15 01:03:01.000000', 'consum', 0.0220, 'lps'),
	(415902, 126, '2015-02-15 01:03:02.000000', 'consum', 0.0219, 'lps'),
	(415903, 126, '2015-02-15 01:03:03.000000', 'consum', 0.0211, 'lps'),
	(415904, 126, '2015-02-15 01:03:04.000000', 'consum', 0.0216, 'lps'),
	(415905, 126, '2015-02-15 01:03:05.000000', 'consum', 0.0223, 'lps'),
	(415906, 126, '2015-02-15 01:03:06.000000', 'consum', 0.0217, 'lps'),
	(415907, 126, '2015-02-15 01:03:07.000000', 'consum', 0.0220, 'lps'),
	(415908, 126, '2015-02-15 01:03:08.000000', 'consum', 0.0212, 'lps'),
	(415909, 126, '2015-02-15 01:03:09.000000', 'consum', 0.0220, 'lps'),
	(415910, 126, '2015-02-15 01:03:10.000000', 'consum', 0.0211, 'lps'),
	(415911, 126, '2015-02-15 01:03:11.000000', 'consum', 0.0212, 'lps'),
	(415912, 126, '2015-02-15 01:03:12.000000', 'consum', 0.0219, 'lps'),
	(415913, 126, '2015-02-15 01:03:13.000000', 'consum', 0.0222, 'lps'),
	(415914, 126, '2015-02-15 01:03:14.000000', 'consum', 0.0214, 'lps'),
	(415915, 126, '2015-02-15 01:03:15.000000', 'consum', 0.0211, 'lps'),
	(415916, 126, '2015-02-15 01:03:16.000000', 'consum', 0.0218, 'lps'),
	(415917, 126, '2015-02-15 01:03:17.000000', 'consum', 0.0217, 'lps'),
	(415918, 126, '2015-02-15 01:03:18.000000', 'consum', 0.0221, 'lps'),
	(415919, 126, '2015-02-15 01:03:19.000000', 'consum', 0.0218, 'lps'),
	(415920, 126, '2015-02-15 01:03:20.000000', 'consum', 0.0216, 'lps'),
	(415921, 126, '2015-02-15 01:03:21.000000', 'consum', 0.0218, 'lps'),
	(415922, 126, '2015-02-15 01:03:22.000000', 'consum', 0.0219, 'lps'),
	(415923, 126, '2015-02-15 01:03:23.000000', 'consum', 0.0216, 'lps'),
	(415924, 126, '2015-02-15 01:03:24.000000', 'consum', 0.0216, 'lps'),
	(415925, 126, '2015-02-15 01:03:25.000000', 'consum', 0.0221, 'lps'),
	(415926, 126, '2015-02-15 01:03:26.000000', 'consum', 0.0220, 'lps'),
	(415927, 126, '2015-02-15 01:03:27.000000', 'consum', 0.0213, 'lps'),
	(415928, 126, '2015-02-15 01:03:28.000000', 'consum', 0.0223, 'lps'),
	(415929, 126, '2015-02-15 01:03:29.000000', 'consum', 0.0211, 'lps'),
	(415930, 126, '2015-02-15 01:03:30.000000', 'consum', 0.0218, 'lps'),
	(415931, 126, '2015-02-15 01:03:31.000000', 'consum', 0.0218, 'lps'),
	(415932, 126, '2015-02-15 01:03:32.000000', 'consum', 0.0215, 'lps'),
	(415933, 126, '2015-02-15 01:03:33.000000', 'consum', 0.0212, 'lps'),
	(415934, 126, '2015-02-15 01:03:34.000000', 'consum', 0.0217, 'lps'),
	(415935, 126, '2015-02-15 01:03:35.000000', 'consum', 0.0211, 'lps'),
	(415936, 126, '2015-02-15 01:03:36.000000', 'consum', 0.0210, 'lps'),
	(415937, 126, '2015-02-15 01:03:37.000000', 'consum', 0.0222, 'lps'),
	(415938, 126, '2015-02-15 01:03:38.000000', 'consum', 0.0215, 'lps'),
	(415939, 126, '2015-02-15 01:03:39.000000', 'consum', 0.0214, 'lps'),
	(415940, 126, '2015-02-15 01:03:40.000000', 'consum', 0.0214, 'lps'),
	(415941, 126, '2015-02-15 01:03:41.000000', 'consum', 0.0218, 'lps'),
	(415942, 126, '2015-02-15 01:03:42.000000', 'consum', 0.0211, 'lps'),
	(415943, 126, '2015-02-15 01:03:43.000000', 'consum', 0.0219, 'lps'),
	(415944, 126, '2015-02-15 01:03:44.000000', 'consum', 0.0211, 'lps'),
	(415945, 126, '2015-02-15 01:03:45.000000', 'consum', 0.0217, 'lps'),
	(415946, 126, '2015-02-15 01:03:46.000000', 'consum', 0.0216, 'lps'),
	(415947, 126, '2015-02-15 01:03:47.000000', 'consum', 0.0217, 'lps'),
	(415948, 126, '2015-02-15 01:03:48.000000', 'consum', 0.0215, 'lps'),
	(415949, 126, '2015-02-15 01:03:49.000000', 'consum', 0.0213, 'lps'),
	(415950, 126, '2015-02-15 01:03:50.000000', 'consum', 0.0210, 'lps'),
	(415951, 126, '2015-02-15 01:03:51.000000', 'consum', 0.0218, 'lps'),
	(415952, 126, '2015-02-15 01:03:52.000000', 'consum', 0.0222, 'lps'),
	(415953, 126, '2015-02-15 01:03:53.000000', 'consum', 0.0220, 'lps'),
	(415954, 126, '2015-02-15 01:03:54.000000', 'consum', 0.0222, 'lps'),
	(415955, 126, '2015-02-15 01:03:55.000000', 'consum', 0.0214, 'lps'),
	(415956, 126, '2015-02-15 01:03:56.000000', 'consum', 0.0223, 'lps'),
	(415957, 126, '2015-02-15 01:03:57.000000', 'consum', 0.0220, 'lps'),
	(415958, 126, '2015-02-15 01:03:58.000000', 'consum', 0.0222, 'lps'),
	(415959, 126, '2015-02-15 01:03:59.000000', 'consum', 0.0214, 'lps'),
	(415960, 126, '2015-02-15 01:04:00.000000', 'consum', 0.0220, 'lps'),
	(415961, 126, '2015-02-15 01:04:01.000000', 'consum', 0.0220, 'lps'),
	(415962, 126, '2015-02-15 01:04:02.000000', 'consum', 0.0217, 'lps'),
	(415963, 126, '2015-02-15 01:04:03.000000', 'consum', 0.0218, 'lps'),
	(415964, 126, '2015-02-15 01:04:04.000000', 'consum', 0.0212, 'lps'),
	(415965, 126, '2015-02-15 01:04:05.000000', 'consum', 0.0212, 'lps'),
	(415966, 126, '2015-02-15 01:04:06.000000', 'consum', 0.0215, 'lps'),
	(415967, 126, '2015-02-15 01:04:07.000000', 'consum', 0.0215, 'lps'),
	(415968, 126, '2015-02-15 01:04:08.000000', 'consum', 0.0222, 'lps'),
	(415969, 126, '2015-02-15 01:04:09.000000', 'consum', 0.0212, 'lps'),
	(415970, 126, '2015-02-15 01:04:10.000000', 'consum', 0.0212, 'lps'),
	(415971, 126, '2015-02-15 01:04:11.000000', 'consum', 0.0215, 'lps'),
	(415972, 126, '2015-02-15 01:04:12.000000', 'consum', 0.0217, 'lps'),
	(415973, 126, '2015-02-15 01:04:13.000000', 'consum', 0.0213, 'lps'),
	(415974, 126, '2015-02-15 01:04:14.000000', 'consum', 0.0222, 'lps'),
	(415975, 126, '2015-02-15 01:04:15.000000', 'consum', 0.0217, 'lps'),
	(415976, 126, '2015-02-15 01:04:16.000000', 'consum', 0.0211, 'lps'),
	(415977, 126, '2015-02-15 01:04:17.000000', 'consum', 0.0223, 'lps'),
	(415978, 126, '2015-02-15 01:04:18.000000', 'consum', 0.0218, 'lps'),
	(415979, 126, '2015-02-15 01:04:19.000000', 'consum', 0.0223, 'lps'),
	(415980, 126, '2015-02-15 01:04:20.000000', 'consum', 0.0223, 'lps'),
	(415981, 126, '2015-02-15 01:04:21.000000', 'consum', 0.0221, 'lps'),
	(415982, 126, '2015-02-15 01:04:22.000000', 'consum', 0.0216, 'lps'),
	(415983, 126, '2015-02-15 01:04:23.000000', 'consum', 0.0220, 'lps'),
	(415984, 126, '2015-02-15 01:04:24.000000', 'consum', 0.0214, 'lps'),
	(415985, 126, '2015-02-15 01:04:25.000000', 'consum', 0.0217, 'lps'),
	(415986, 126, '2015-02-15 01:04:26.000000', 'consum', 0.0218, 'lps'),
	(415987, 126, '2015-02-15 01:04:27.000000', 'consum', 0.0214, 'lps'),
	(415988, 126, '2015-02-15 01:04:28.000000', 'consum', 0.0221, 'lps'),
	(415989, 126, '2015-02-15 01:04:29.000000', 'consum', 0.0211, 'lps'),
	(415990, 126, '2015-02-15 01:04:30.000000', 'consum', 0.0212, 'lps'),
	(415991, 126, '2015-02-15 01:04:31.000000', 'consum', 0.0215, 'lps'),
	(415992, 126, '2015-02-15 01:04:32.000000', 'consum', 0.0217, 'lps'),
	(415993, 126, '2015-02-15 01:04:33.000000', 'consum', 0.0216, 'lps'),
	(415994, 126, '2015-02-15 01:04:34.000000', 'consum', 0.0222, 'lps'),
	(415995, 126, '2015-02-15 01:04:35.000000', 'consum', 0.0222, 'lps'),
	(415996, 126, '2015-02-15 01:04:36.000000', 'consum', 0.0221, 'lps'),
	(415997, 126, '2015-02-15 01:04:37.000000', 'consum', 0.0214, 'lps'),
	(415998, 126, '2015-02-15 01:04:38.000000', 'consum', 0.0214, 'lps'),
	(415999, 126, '2015-02-15 01:04:39.000000', 'consum', 0.0216, 'lps'),
	(416000, 126, '2015-02-15 01:04:40.000000', 'consum', 0.0214, 'lps'),
	(416001, 126, '2015-02-15 01:04:41.000000', 'consum', 0.0215, 'lps'),
	(416002, 126, '2015-02-15 01:04:42.000000', 'consum', 0.0223, 'lps'),
	(416003, 126, '2015-02-15 01:04:43.000000', 'consum', 0.0219, 'lps'),
	(416004, 126, '2015-02-15 01:04:44.000000', 'consum', 0.0218, 'lps'),
	(416005, 126, '2015-02-15 01:04:45.000000', 'consum', 0.0221, 'lps'),
	(416006, 126, '2015-02-15 01:04:46.000000', 'consum', 0.0214, 'lps'),
	(416007, 126, '2015-02-15 01:04:47.000000', 'consum', 0.0212, 'lps'),
	(416008, 126, '2015-02-15 01:04:48.000000', 'consum', 0.0221, 'lps'),
	(416009, 126, '2015-02-15 01:04:49.000000', 'consum', 0.0218, 'lps'),
	(416010, 126, '2015-02-15 01:04:50.000000', 'consum', 0.0218, 'lps'),
	(416011, 126, '2015-02-15 01:04:51.000000', 'consum', 0.0212, 'lps'),
	(416012, 126, '2015-02-15 01:04:52.000000', 'consum', 0.0213, 'lps'),
	(416013, 126, '2015-02-15 01:04:53.000000', 'consum', 0.0216, 'lps'),
	(416014, 126, '2015-02-15 01:04:54.000000', 'consum', 0.0220, 'lps'),
	(416015, 126, '2015-02-15 01:04:55.000000', 'consum', 0.0213, 'lps'),
	(416016, 126, '2015-02-15 01:04:56.000000', 'consum', 0.0223, 'lps'),
	(416017, 126, '2015-02-15 01:04:57.000000', 'consum', 0.0210, 'lps'),
	(416018, 126, '2015-02-15 01:04:58.000000', 'consum', 0.0213, 'lps'),
	(416019, 126, '2015-02-15 01:04:59.000000', 'consum', 0.0211, 'lps'),
	(416020, 126, '2015-02-15 01:05:00.000000', 'consum', 0.0221, 'lps'),
	(416021, 126, '2015-02-15 01:05:01.000000', 'consum', 0.0219, 'lps'),
	(416022, 126, '2015-02-15 01:05:02.000000', 'consum', 0.0223, 'lps'),
	(416023, 126, '2015-02-15 01:05:03.000000', 'consum', 0.0221, 'lps'),
	(416024, 126, '2015-02-15 01:05:04.000000', 'consum', 0.0210, 'lps'),
	(416025, 126, '2015-02-15 01:05:05.000000', 'consum', 0.0223, 'lps'),
	(416026, 126, '2015-02-15 01:05:06.000000', 'consum', 0.0219, 'lps'),
	(416027, 126, '2015-02-15 01:05:07.000000', 'consum', 0.0214, 'lps'),
	(416028, 126, '2015-02-15 01:05:08.000000', 'consum', 0.0220, 'lps'),
	(416029, 126, '2015-02-15 01:05:09.000000', 'consum', 0.0220, 'lps'),
	(416030, 126, '2015-02-15 01:05:10.000000', 'consum', 0.0215, 'lps'),
	(416031, 126, '2015-02-15 01:05:11.000000', 'consum', 0.0220, 'lps'),
	(416032, 126, '2015-02-15 01:05:12.000000', 'consum', 0.0219, 'lps'),
	(416033, 126, '2015-02-15 01:05:13.000000', 'consum', 0.0212, 'lps'),
	(416034, 126, '2015-02-15 01:05:14.000000', 'consum', 0.0222, 'lps'),
	(416035, 126, '2015-02-15 01:05:15.000000', 'consum', 0.0222, 'lps'),
	(416036, 126, '2015-02-15 01:05:16.000000', 'consum', 0.0220, 'lps'),
	(416037, 126, '2015-02-15 01:05:17.000000', 'consum', 0.0223, 'lps'),
	(416038, 126, '2015-02-15 01:05:18.000000', 'consum', 0.0220, 'lps'),
	(416039, 126, '2015-02-15 01:05:19.000000', 'consum', 0.0220, 'lps'),
	(416040, 126, '2015-02-15 01:05:20.000000', 'consum', 0.0216, 'lps'),
	(416041, 126, '2015-02-15 01:05:21.000000', 'consum', 0.0211, 'lps'),
	(416042, 126, '2015-02-15 01:05:22.000000', 'consum', 0.0213, 'lps'),
	(416043, 126, '2015-02-15 01:05:23.000000', 'consum', 0.0210, 'lps'),
	(416044, 126, '2015-02-15 01:05:24.000000', 'consum', 0.0212, 'lps'),
	(416045, 126, '2015-02-15 01:05:25.000000', 'consum', 0.0221, 'lps'),
	(416046, 126, '2015-02-15 01:05:26.000000', 'consum', 0.0217, 'lps'),
	(416047, 126, '2015-02-15 01:05:27.000000', 'consum', 0.0215, 'lps'),
	(416048, 126, '2015-02-15 01:05:28.000000', 'consum', 0.0214, 'lps'),
	(416049, 126, '2015-02-15 01:05:29.000000', 'consum', 0.0214, 'lps'),
	(416050, 126, '2015-02-15 01:05:30.000000', 'consum', 0.0218, 'lps'),
	(416051, 126, '2015-02-15 01:05:31.000000', 'consum', 0.0211, 'lps'),
	(416052, 126, '2015-02-15 01:05:32.000000', 'consum', 0.0220, 'lps'),
	(416053, 126, '2015-02-15 01:05:33.000000', 'consum', 0.0215, 'lps'),
	(416054, 126, '2015-02-15 01:05:34.000000', 'consum', 0.0219, 'lps'),
	(416055, 126, '2015-02-15 01:05:35.000000', 'consum', 0.0211, 'lps'),
	(416056, 126, '2015-02-15 01:05:36.000000', 'consum', 0.0217, 'lps'),
	(416057, 126, '2015-02-15 01:05:37.000000', 'consum', 0.0217, 'lps'),
	(416058, 126, '2015-02-15 01:05:38.000000', 'consum', 0.0223, 'lps'),
	(416059, 126, '2015-02-15 01:05:39.000000', 'consum', 0.0213, 'lps'),
	(416060, 126, '2015-02-15 01:05:40.000000', 'consum', 0.0214, 'lps'),
	(416061, 126, '2015-02-15 01:05:41.000000', 'consum', 0.0220, 'lps'),
	(416062, 126, '2015-02-15 01:05:42.000000', 'consum', 0.0221, 'lps'),
	(416063, 126, '2015-02-15 01:05:43.000000', 'consum', 0.0210, 'lps'),
	(416064, 126, '2015-02-15 01:05:44.000000', 'consum', 0.0218, 'lps'),
	(416065, 126, '2015-02-15 01:05:45.000000', 'consum', 0.0221, 'lps'),
	(416066, 126, '2015-02-15 01:05:46.000000', 'consum', 0.0214, 'lps'),
	(416067, 126, '2015-02-15 01:05:47.000000', 'consum', 0.0213, 'lps'),
	(416068, 126, '2015-02-15 01:05:48.000000', 'consum', 0.0211, 'lps'),
	(416069, 126, '2015-02-15 01:05:49.000000', 'consum', 0.0223, 'lps'),
	(416070, 126, '2015-02-15 01:05:50.000000', 'consum', 0.0217, 'lps'),
	(416071, 126, '2015-02-15 01:05:51.000000', 'consum', 0.0218, 'lps'),
	(416072, 126, '2015-02-15 01:05:52.000000', 'consum', 0.0216, 'lps'),
	(416073, 126, '2015-02-15 01:05:53.000000', 'consum', 0.0217, 'lps'),
	(416074, 126, '2015-02-15 01:05:54.000000', 'consum', 0.0212, 'lps'),
	(416075, 126, '2015-02-15 01:05:55.000000', 'consum', 0.0212, 'lps'),
	(416076, 126, '2015-02-15 01:05:56.000000', 'consum', 0.0218, 'lps'),
	(416077, 126, '2015-02-15 01:05:57.000000', 'consum', 0.0217, 'lps'),
	(416078, 126, '2015-02-15 01:05:58.000000', 'consum', 0.0219, 'lps'),
	(416079, 126, '2015-02-15 01:05:59.000000', 'consum', 0.0220, 'lps'),
	(416080, 126, '2015-02-15 01:06:00.000000', 'consum', 0.0221, 'lps'),
	(416081, 126, '2015-02-15 01:06:01.000000', 'consum', 0.0221, 'lps'),
	(416082, 126, '2015-02-15 01:06:02.000000', 'consum', 0.0217, 'lps'),
	(416083, 126, '2015-02-15 01:06:03.000000', 'consum', 0.0213, 'lps'),
	(416084, 126, '2015-02-15 01:06:04.000000', 'consum', 0.0219, 'lps'),
	(416085, 126, '2015-02-15 01:06:05.000000', 'consum', 0.0217, 'lps'),
	(416086, 126, '2015-02-15 01:06:06.000000', 'consum', 0.0218, 'lps'),
	(416087, 126, '2015-02-15 01:06:07.000000', 'consum', 0.0217, 'lps'),
	(416088, 126, '2015-02-15 01:06:08.000000', 'consum', 0.0220, 'lps'),
	(416089, 126, '2015-02-15 01:06:09.000000', 'consum', 0.0211, 'lps'),
	(416090, 126, '2015-02-15 01:06:10.000000', 'consum', 0.0214, 'lps'),
	(416091, 126, '2015-02-15 01:06:11.000000', 'consum', 0.0212, 'lps'),
	(416092, 126, '2015-02-15 01:06:12.000000', 'consum', 0.0223, 'lps'),
	(416093, 126, '2015-02-15 01:06:13.000000', 'consum', 0.0216, 'lps'),
	(416094, 126, '2015-02-15 01:06:14.000000', 'consum', 0.0212, 'lps'),
	(416095, 126, '2015-02-15 01:06:15.000000', 'consum', 0.0218, 'lps'),
	(416096, 126, '2015-02-15 01:06:16.000000', 'consum', 0.0217, 'lps'),
	(416097, 126, '2015-02-15 01:06:17.000000', 'consum', 0.0222, 'lps'),
	(416098, 126, '2015-02-15 01:06:18.000000', 'consum', 0.0221, 'lps'),
	(416099, 126, '2015-02-15 01:06:19.000000', 'consum', 0.0214, 'lps'),
	(416100, 126, '2015-02-15 01:06:20.000000', 'consum', 0.0211, 'lps'),
	(416101, 126, '2015-02-15 01:06:21.000000', 'consum', 0.0217, 'lps'),
	(416102, 126, '2015-02-15 01:06:22.000000', 'consum', 0.0216, 'lps'),
	(416103, 126, '2015-02-15 01:06:23.000000', 'consum', 0.0219, 'lps'),
	(416104, 126, '2015-02-15 01:06:24.000000', 'consum', 0.0211, 'lps'),
	(416105, 126, '2015-02-15 01:06:25.000000', 'consum', 0.0214, 'lps'),
	(416106, 126, '2015-02-15 01:06:26.000000', 'consum', 0.0216, 'lps'),
	(416107, 126, '2015-02-15 01:06:27.000000', 'consum', 0.0213, 'lps'),
	(416108, 126, '2015-02-15 01:06:28.000000', 'consum', 0.0223, 'lps'),
	(416109, 126, '2015-02-15 01:06:29.000000', 'consum', 0.0222, 'lps'),
	(416110, 126, '2015-02-15 01:06:30.000000', 'consum', 0.0219, 'lps'),
	(416111, 126, '2015-02-15 01:06:31.000000', 'consum', 0.0218, 'lps'),
	(416112, 126, '2015-02-15 01:06:32.000000', 'consum', 0.0211, 'lps'),
	(416113, 126, '2015-02-15 01:06:33.000000', 'consum', 0.0218, 'lps'),
	(416114, 126, '2015-02-15 01:06:34.000000', 'consum', 0.0221, 'lps'),
	(416115, 126, '2015-02-15 01:06:35.000000', 'consum', 0.0211, 'lps'),
	(416116, 126, '2015-02-15 01:06:36.000000', 'consum', 0.0214, 'lps'),
	(416117, 126, '2015-02-15 01:06:37.000000', 'consum', 0.0212, 'lps'),
	(416118, 126, '2015-02-15 01:06:38.000000', 'consum', 0.0223, 'lps'),
	(416119, 126, '2015-02-15 01:06:39.000000', 'consum', 0.0211, 'lps'),
	(416120, 126, '2015-02-15 01:06:40.000000', 'consum', 0.0221, 'lps'),
	(416121, 126, '2015-02-15 01:06:41.000000', 'consum', 0.0218, 'lps'),
	(416122, 126, '2015-02-15 01:06:42.000000', 'consum', 0.0219, 'lps'),
	(416123, 126, '2015-02-15 01:06:43.000000', 'consum', 0.0215, 'lps'),
	(416124, 126, '2015-02-15 01:06:44.000000', 'consum', 0.0212, 'lps'),
	(416125, 126, '2015-02-15 01:06:45.000000', 'consum', 0.0216, 'lps'),
	(416126, 126, '2015-02-15 01:06:46.000000', 'consum', 0.0210, 'lps'),
	(416127, 126, '2015-02-15 01:06:47.000000', 'consum', 0.0219, 'lps'),
	(416128, 126, '2015-02-15 01:06:48.000000', 'consum', 0.0215, 'lps'),
	(416129, 126, '2015-02-15 01:06:49.000000', 'consum', 0.0223, 'lps'),
	(416130, 126, '2015-02-15 01:06:50.000000', 'consum', 0.0219, 'lps'),
	(416131, 126, '2015-02-15 01:06:51.000000', 'consum', 0.0218, 'lps'),
	(416132, 126, '2015-02-15 01:06:52.000000', 'consum', 0.0220, 'lps'),
	(416133, 126, '2015-02-15 01:06:53.000000', 'consum', 0.0222, 'lps'),
	(416134, 126, '2015-02-15 01:06:54.000000', 'consum', 0.0214, 'lps'),
	(416135, 126, '2015-02-15 01:06:55.000000', 'consum', 0.0221, 'lps'),
	(416136, 126, '2015-02-15 01:06:56.000000', 'consum', 0.0213, 'lps'),
	(416137, 126, '2015-02-15 01:06:57.000000', 'consum', 0.0221, 'lps'),
	(416138, 126, '2015-02-15 01:06:58.000000', 'consum', 0.0215, 'lps'),
	(416139, 126, '2015-02-15 01:06:59.000000', 'consum', 0.0216, 'lps'),
	(416140, 126, '2015-02-15 01:07:00.000000', 'consum', 0.0213, 'lps'),
	(416141, 126, '2015-02-15 01:07:01.000000', 'consum', 0.0220, 'lps'),
	(416142, 126, '2015-02-15 01:07:02.000000', 'consum', 0.0211, 'lps'),
	(416143, 126, '2015-02-15 01:07:03.000000', 'consum', 0.0214, 'lps'),
	(416144, 126, '2015-02-15 01:07:04.000000', 'consum', 0.0211, 'lps'),
	(416145, 126, '2015-02-15 01:07:05.000000', 'consum', 0.0219, 'lps'),
	(416146, 126, '2015-02-15 01:07:06.000000', 'consum', 0.0212, 'lps'),
	(416147, 126, '2015-02-15 01:07:07.000000', 'consum', 0.0221, 'lps'),
	(416148, 126, '2015-02-15 01:07:08.000000', 'consum', 0.0218, 'lps'),
	(416149, 126, '2015-02-15 01:07:09.000000', 'consum', 0.0215, 'lps'),
	(416150, 126, '2015-02-15 01:07:10.000000', 'consum', 0.0214, 'lps'),
	(416151, 126, '2015-02-15 01:07:11.000000', 'consum', 0.0213, 'lps'),
	(416152, 126, '2015-02-15 01:07:12.000000', 'consum', 0.0215, 'lps'),
	(416153, 126, '2015-02-15 01:07:13.000000', 'consum', 0.0214, 'lps'),
	(416154, 126, '2015-02-15 01:07:14.000000', 'consum', 0.0215, 'lps'),
	(416155, 126, '2015-02-15 01:07:15.000000', 'consum', 0.0222, 'lps'),
	(416156, 126, '2015-02-15 01:07:16.000000', 'consum', 0.0213, 'lps'),
	(416157, 126, '2015-02-15 01:07:17.000000', 'consum', 0.0220, 'lps'),
	(416158, 126, '2015-02-15 01:07:18.000000', 'consum', 0.0223, 'lps'),
	(416159, 126, '2015-02-15 01:07:19.000000', 'consum', 0.0216, 'lps'),
	(416160, 126, '2015-02-15 01:07:20.000000', 'consum', 0.0215, 'lps'),
	(416161, 126, '2015-02-15 01:07:21.000000', 'consum', 0.0219, 'lps'),
	(416162, 126, '2015-02-15 01:07:22.000000', 'consum', 0.0214, 'lps'),
	(416163, 126, '2015-02-15 01:07:23.000000', 'consum', 0.0215, 'lps'),
	(416164, 126, '2015-02-15 01:07:24.000000', 'consum', 0.0223, 'lps'),
	(416165, 126, '2015-02-15 01:07:25.000000', 'consum', 0.0219, 'lps'),
	(416166, 126, '2015-02-15 01:07:26.000000', 'consum', 0.0218, 'lps'),
	(416167, 126, '2015-02-15 01:07:27.000000', 'consum', 0.0221, 'lps'),
	(416168, 126, '2015-02-15 01:07:28.000000', 'consum', 0.0217, 'lps'),
	(416169, 126, '2015-02-15 01:07:29.000000', 'consum', 0.0210, 'lps'),
	(416170, 126, '2015-02-15 01:07:30.000000', 'consum', 0.0216, 'lps'),
	(416171, 126, '2015-02-15 01:07:31.000000', 'consum', 0.0215, 'lps'),
	(416172, 126, '2015-02-15 01:07:32.000000', 'consum', 0.0216, 'lps'),
	(416173, 126, '2015-02-15 01:07:33.000000', 'consum', 0.0214, 'lps'),
	(416174, 126, '2015-02-15 01:07:34.000000', 'consum', 0.0210, 'lps'),
	(416175, 126, '2015-02-15 01:07:35.000000', 'consum', 0.0211, 'lps'),
	(416176, 126, '2015-02-15 01:07:36.000000', 'consum', 0.0218, 'lps'),
	(416177, 126, '2015-02-15 01:07:37.000000', 'consum', 0.0219, 'lps'),
	(416178, 126, '2015-02-15 01:07:38.000000', 'consum', 0.0216, 'lps'),
	(416179, 126, '2015-02-15 01:07:39.000000', 'consum', 0.0215, 'lps'),
	(416180, 126, '2015-02-15 01:07:40.000000', 'consum', 0.0215, 'lps'),
	(416181, 126, '2015-02-15 01:07:41.000000', 'consum', 0.0222, 'lps'),
	(416182, 126, '2015-02-15 01:07:42.000000', 'consum', 0.0215, 'lps'),
	(416183, 126, '2015-02-15 01:07:43.000000', 'consum', 0.0213, 'lps'),
	(416184, 126, '2015-02-15 01:07:44.000000', 'consum', 0.0210, 'lps'),
	(416185, 126, '2015-02-15 01:07:45.000000', 'consum', 0.0214, 'lps'),
	(416186, 126, '2015-02-15 01:07:46.000000', 'consum', 0.0218, 'lps'),
	(416187, 126, '2015-02-15 01:07:47.000000', 'consum', 0.0222, 'lps'),
	(416188, 126, '2015-02-15 01:07:48.000000', 'consum', 0.0221, 'lps'),
	(416189, 126, '2015-02-15 01:07:49.000000', 'consum', 0.0216, 'lps'),
	(416190, 126, '2015-02-15 01:07:50.000000', 'consum', 0.0220, 'lps'),
	(416191, 126, '2015-02-15 01:07:51.000000', 'consum', 0.0215, 'lps'),
	(416192, 126, '2015-02-15 01:07:52.000000', 'consum', 0.0218, 'lps'),
	(416193, 126, '2015-02-15 01:07:53.000000', 'consum', 0.0223, 'lps'),
	(416194, 126, '2015-02-15 01:07:54.000000', 'consum', 0.0221, 'lps'),
	(416195, 126, '2015-02-15 01:07:55.000000', 'consum', 0.0216, 'lps'),
	(416196, 126, '2015-02-15 01:07:56.000000', 'consum', 0.0218, 'lps'),
	(416197, 126, '2015-02-15 01:07:57.000000', 'consum', 0.0221, 'lps'),
	(416198, 126, '2015-02-15 01:07:58.000000', 'consum', 0.0213, 'lps'),
	(416199, 126, '2015-02-15 01:07:59.000000', 'consum', 0.0218, 'lps'),
	(416200, 126, '2015-02-15 01:08:00.000000', 'consum', 0.0217, 'lps'),
	(416201, 126, '2015-02-15 01:08:01.000000', 'consum', 0.0221, 'lps'),
	(416202, 126, '2015-02-15 01:08:02.000000', 'consum', 0.0215, 'lps'),
	(416203, 126, '2015-02-15 01:08:03.000000', 'consum', 0.0216, 'lps'),
	(416204, 126, '2015-02-15 01:08:04.000000', 'consum', 0.0211, 'lps'),
	(416205, 126, '2015-02-15 01:08:05.000000', 'consum', 0.0214, 'lps'),
	(416206, 126, '2015-02-15 01:08:06.000000', 'consum', 0.0212, 'lps'),
	(416207, 126, '2015-02-15 01:08:07.000000', 'consum', 0.0223, 'lps'),
	(416208, 126, '2015-02-15 01:08:08.000000', 'consum', 0.0213, 'lps'),
	(416209, 126, '2015-02-15 01:08:09.000000', 'consum', 0.0214, 'lps'),
	(416210, 126, '2015-02-15 01:08:10.000000', 'consum', 0.0210, 'lps'),
	(416211, 126, '2015-02-15 01:08:11.000000', 'consum', 0.0210, 'lps'),
	(416212, 126, '2015-02-15 01:08:12.000000', 'consum', 0.0212, 'lps'),
	(416213, 126, '2015-02-15 01:08:13.000000', 'consum', 0.0220, 'lps'),
	(416214, 126, '2015-02-15 01:08:14.000000', 'consum', 0.0211, 'lps'),
	(416215, 126, '2015-02-15 01:08:15.000000', 'consum', 0.0214, 'lps'),
	(416216, 126, '2015-02-15 01:08:16.000000', 'consum', 0.0214, 'lps'),
	(416217, 126, '2015-02-15 01:08:17.000000', 'consum', 0.0219, 'lps'),
	(416218, 126, '2015-02-15 01:08:18.000000', 'consum', 0.0215, 'lps'),
	(416219, 126, '2015-02-15 01:08:19.000000', 'consum', 0.0223, 'lps'),
	(416220, 126, '2015-02-15 01:08:20.000000', 'consum', 0.0218, 'lps'),
	(416221, 126, '2015-02-15 01:08:21.000000', 'consum', 0.0213, 'lps'),
	(416222, 126, '2015-02-15 01:08:22.000000', 'consum', 0.0216, 'lps'),
	(416223, 126, '2015-02-15 01:08:23.000000', 'consum', 0.0217, 'lps'),
	(416224, 126, '2015-02-15 01:08:24.000000', 'consum', 0.0213, 'lps'),
	(416225, 126, '2015-02-15 01:08:25.000000', 'consum', 0.0218, 'lps'),
	(416226, 126, '2015-02-15 01:08:26.000000', 'consum', 0.0214, 'lps'),
	(416227, 126, '2015-02-15 01:08:27.000000', 'consum', 0.0220, 'lps'),
	(416228, 126, '2015-02-15 01:08:28.000000', 'consum', 0.0221, 'lps'),
	(416229, 126, '2015-02-15 01:08:29.000000', 'consum', 0.0220, 'lps'),
	(416230, 126, '2015-02-15 01:08:30.000000', 'consum', 0.0216, 'lps'),
	(416231, 126, '2015-02-15 01:08:31.000000', 'consum', 0.0221, 'lps'),
	(416232, 126, '2015-02-15 01:08:32.000000', 'consum', 0.0223, 'lps'),
	(416233, 126, '2015-02-15 01:08:33.000000', 'consum', 0.0214, 'lps'),
	(416234, 126, '2015-02-15 01:08:34.000000', 'consum', 0.0218, 'lps'),
	(416235, 126, '2015-02-15 01:08:35.000000', 'consum', 0.0211, 'lps'),
	(416236, 126, '2015-02-15 01:08:36.000000', 'consum', 0.0218, 'lps'),
	(416237, 126, '2015-02-15 01:08:37.000000', 'consum', 0.0219, 'lps'),
	(416238, 126, '2015-02-15 01:08:38.000000', 'consum', 0.0220, 'lps'),
	(416239, 126, '2015-02-15 01:08:39.000000', 'consum', 0.0219, 'lps'),
	(416240, 126, '2015-02-15 01:08:40.000000', 'consum', 0.0212, 'lps'),
	(416241, 126, '2015-02-15 01:08:41.000000', 'consum', 0.0222, 'lps'),
	(416242, 126, '2015-02-15 01:08:42.000000', 'consum', 0.0221, 'lps'),
	(416243, 126, '2015-02-15 01:08:43.000000', 'consum', 0.0215, 'lps'),
	(416244, 126, '2015-02-15 01:08:44.000000', 'consum', 0.0218, 'lps'),
	(416245, 126, '2015-02-15 01:08:45.000000', 'consum', 0.0221, 'lps'),
	(416246, 126, '2015-02-15 01:08:46.000000', 'consum', 0.0214, 'lps'),
	(416247, 126, '2015-02-15 01:08:47.000000', 'consum', 0.0212, 'lps'),
	(416248, 126, '2015-02-15 01:08:48.000000', 'consum', 0.0221, 'lps'),
	(416249, 126, '2015-02-15 01:08:49.000000', 'consum', 0.0220, 'lps'),
	(416250, 126, '2015-02-15 01:08:50.000000', 'consum', 0.0211, 'lps'),
	(416251, 126, '2015-02-15 01:08:51.000000', 'consum', 0.0216, 'lps'),
	(416252, 126, '2015-02-15 01:08:52.000000', 'consum', 0.0221, 'lps'),
	(416253, 126, '2015-02-15 01:08:53.000000', 'consum', 0.0219, 'lps'),
	(416254, 126, '2015-02-15 01:08:54.000000', 'consum', 0.0221, 'lps'),
	(416255, 126, '2015-02-15 01:08:55.000000', 'consum', 0.0214, 'lps'),
	(416256, 126, '2015-02-15 01:08:56.000000', 'consum', 0.0210, 'lps'),
	(416257, 126, '2015-02-15 01:08:57.000000', 'consum', 0.0211, 'lps'),
	(416258, 126, '2015-02-15 01:08:58.000000', 'consum', 0.0218, 'lps'),
	(416259, 126, '2015-02-15 01:08:59.000000', 'consum', 0.0220, 'lps'),
	(416260, 126, '2015-02-15 01:09:00.000000', 'consum', 0.0221, 'lps'),
	(416261, 126, '2015-02-15 01:09:01.000000', 'consum', 0.0220, 'lps'),
	(416262, 126, '2015-02-15 01:09:02.000000', 'consum', 0.0216, 'lps'),
	(416263, 126, '2015-02-15 01:09:03.000000', 'consum', 0.0222, 'lps'),
	(416264, 126, '2015-02-15 01:09:04.000000', 'consum', 0.0212, 'lps'),
	(416265, 126, '2015-02-15 01:09:05.000000', 'consum', 0.0212, 'lps'),
	(416266, 126, '2015-02-15 01:09:06.000000', 'consum', 0.0216, 'lps'),
	(416267, 126, '2015-02-15 01:09:07.000000', 'consum', 0.0218, 'lps'),
	(416268, 126, '2015-02-15 01:09:08.000000', 'consum', 0.0220, 'lps'),
	(416269, 126, '2015-02-15 01:09:09.000000', 'consum', 0.0220, 'lps'),
	(416270, 126, '2015-02-15 01:09:10.000000', 'consum', 0.0218, 'lps'),
	(416271, 126, '2015-02-15 01:09:11.000000', 'consum', 0.0222, 'lps'),
	(416272, 126, '2015-02-15 01:09:12.000000', 'consum', 0.0219, 'lps'),
	(416273, 126, '2015-02-15 01:09:13.000000', 'consum', 0.0220, 'lps'),
	(416274, 126, '2015-02-15 01:09:14.000000', 'consum', 0.0221, 'lps'),
	(416275, 126, '2015-02-15 01:09:15.000000', 'consum', 0.0218, 'lps'),
	(416276, 126, '2015-02-15 01:09:16.000000', 'consum', 0.0217, 'lps'),
	(416277, 126, '2015-02-15 01:09:17.000000', 'consum', 0.0222, 'lps'),
	(416278, 126, '2015-02-15 01:09:18.000000', 'consum', 0.0222, 'lps'),
	(416279, 126, '2015-02-15 01:09:19.000000', 'consum', 0.0219, 'lps'),
	(416280, 126, '2015-02-15 01:09:20.000000', 'consum', 0.0221, 'lps'),
	(416281, 126, '2015-02-15 01:09:21.000000', 'consum', 0.0223, 'lps'),
	(416282, 126, '2015-02-15 01:09:22.000000', 'consum', 0.0215, 'lps'),
	(416283, 126, '2015-02-15 01:09:23.000000', 'consum', 0.0210, 'lps'),
	(416284, 126, '2015-02-15 01:09:24.000000', 'consum', 0.0211, 'lps'),
	(416285, 126, '2015-02-15 01:09:25.000000', 'consum', 0.0213, 'lps'),
	(416286, 126, '2015-02-15 01:09:26.000000', 'consum', 0.0212, 'lps'),
	(416287, 126, '2015-02-15 01:09:27.000000', 'consum', 0.0223, 'lps'),
	(416288, 126, '2015-02-15 01:09:28.000000', 'consum', 0.0214, 'lps'),
	(416289, 126, '2015-02-15 01:09:29.000000', 'consum', 0.0220, 'lps'),
	(416290, 126, '2015-02-15 01:09:30.000000', 'consum', 0.0219, 'lps'),
	(416291, 126, '2015-02-15 01:09:31.000000', 'consum', 0.0214, 'lps'),
	(416292, 126, '2015-02-15 01:09:32.000000', 'consum', 0.0218, 'lps'),
	(416293, 126, '2015-02-15 01:09:33.000000', 'consum', 0.0223, 'lps'),
	(416294, 126, '2015-02-15 01:09:34.000000', 'consum', 0.0211, 'lps'),
	(416295, 126, '2015-02-15 01:09:35.000000', 'consum', 0.0217, 'lps'),
	(416296, 126, '2015-02-15 01:09:36.000000', 'consum', 0.0216, 'lps'),
	(416297, 126, '2015-02-15 01:09:37.000000', 'consum', 0.0220, 'lps'),
	(416298, 126, '2015-02-15 01:09:38.000000', 'consum', 0.0216, 'lps'),
	(416299, 126, '2015-02-15 01:09:39.000000', 'consum', 0.0221, 'lps'),
	(416300, 126, '2015-02-15 01:09:40.000000', 'consum', 0.0223, 'lps'),
	(416301, 126, '2015-02-15 01:09:41.000000', 'consum', 0.0212, 'lps'),
	(416302, 126, '2015-02-15 01:09:42.000000', 'consum', 0.0222, 'lps'),
	(416303, 126, '2015-02-15 01:09:43.000000', 'consum', 0.0211, 'lps'),
	(416304, 126, '2015-02-15 01:09:44.000000', 'consum', 0.0223, 'lps'),
	(416305, 126, '2015-02-15 01:09:45.000000', 'consum', 0.0213, 'lps'),
	(416306, 126, '2015-02-15 01:09:46.000000', 'consum', 0.0216, 'lps'),
	(416307, 126, '2015-02-15 01:09:47.000000', 'consum', 0.0218, 'lps'),
	(416308, 126, '2015-02-15 01:09:48.000000', 'consum', 0.0216, 'lps'),
	(416309, 126, '2015-02-15 01:09:49.000000', 'consum', 0.0219, 'lps'),
	(416310, 126, '2015-02-15 01:09:50.000000', 'consum', 0.0223, 'lps'),
	(416311, 126, '2015-02-15 01:09:51.000000', 'consum', 0.0219, 'lps'),
	(416312, 126, '2015-02-15 01:09:52.000000', 'consum', 0.0218, 'lps'),
	(416313, 126, '2015-02-15 01:09:53.000000', 'consum', 0.0210, 'lps'),
	(416314, 126, '2015-02-15 01:09:54.000000', 'consum', 0.0214, 'lps'),
	(416315, 126, '2015-02-15 01:09:55.000000', 'consum', 0.0218, 'lps'),
	(416316, 126, '2015-02-15 01:09:56.000000', 'consum', 0.0210, 'lps'),
	(416317, 126, '2015-02-15 01:09:57.000000', 'consum', 0.0213, 'lps'),
	(416318, 126, '2015-02-15 01:09:58.000000', 'consum', 0.0210, 'lps'),
	(416319, 126, '2015-02-15 01:09:59.000000', 'consum', 0.0219, 'lps'),
	(416320, 126, '2015-02-15 01:10:00.000000', 'consum', 0.0211, 'lps'),
	(416321, 126, '2015-02-15 01:10:01.000000', 'consum', 0.0215, 'lps'),
	(416322, 126, '2015-02-15 01:10:02.000000', 'consum', 0.0221, 'lps'),
	(416323, 126, '2015-02-15 01:10:03.000000', 'consum', 0.0223, 'lps'),
	(416324, 126, '2015-02-15 01:10:04.000000', 'consum', 0.0215, 'lps'),
	(416325, 126, '2015-02-15 01:10:05.000000', 'consum', 0.0210, 'lps'),
	(416326, 126, '2015-02-15 01:10:06.000000', 'consum', 0.0210, 'lps'),
	(416327, 126, '2015-02-15 01:10:07.000000', 'consum', 0.0222, 'lps'),
	(416328, 126, '2015-02-15 01:10:08.000000', 'consum', 0.0215, 'lps'),
	(416329, 126, '2015-02-15 01:10:09.000000', 'consum', 0.0215, 'lps'),
	(416330, 126, '2015-02-15 01:10:10.000000', 'consum', 0.0221, 'lps'),
	(416331, 126, '2015-02-15 01:10:11.000000', 'consum', 0.0222, 'lps'),
	(416332, 126, '2015-02-15 01:10:12.000000', 'consum', 0.0211, 'lps'),
	(416333, 126, '2015-02-15 01:10:13.000000', 'consum', 0.0221, 'lps'),
	(416334, 126, '2015-02-15 01:10:14.000000', 'consum', 0.0221, 'lps'),
	(416335, 126, '2015-02-15 01:10:15.000000', 'consum', 0.0220, 'lps'),
	(416336, 126, '2015-02-15 01:10:16.000000', 'consum', 0.0212, 'lps'),
	(416337, 126, '2015-02-15 01:10:17.000000', 'consum', 0.0218, 'lps'),
	(416338, 126, '2015-02-15 01:10:18.000000', 'consum', 0.0215, 'lps'),
	(416339, 126, '2015-02-15 01:10:19.000000', 'consum', 0.0215, 'lps'),
	(416340, 126, '2015-02-15 01:10:20.000000', 'consum', 0.0218, 'lps'),
	(416341, 126, '2015-02-15 01:10:21.000000', 'consum', 0.0221, 'lps'),
	(416342, 126, '2015-02-15 01:10:22.000000', 'consum', 0.0215, 'lps'),
	(416343, 126, '2015-02-15 01:10:23.000000', 'consum', 0.0216, 'lps'),
	(416344, 126, '2015-02-15 01:10:24.000000', 'consum', 0.0211, 'lps'),
	(416345, 126, '2015-02-15 01:10:25.000000', 'consum', 0.0210, 'lps'),
	(416346, 126, '2015-02-15 01:10:26.000000', 'consum', 0.0210, 'lps'),
	(416347, 126, '2015-02-15 01:10:27.000000', 'consum', 0.0211, 'lps'),
	(416348, 126, '2015-02-15 01:10:28.000000', 'consum', 0.0213, 'lps'),
	(416349, 126, '2015-02-15 01:10:29.000000', 'consum', 0.0222, 'lps'),
	(416350, 126, '2015-02-15 01:10:30.000000', 'consum', 0.0220, 'lps'),
	(416351, 126, '2015-02-15 01:10:31.000000', 'consum', 0.0210, 'lps'),
	(416352, 126, '2015-02-15 01:10:32.000000', 'consum', 0.0222, 'lps'),
	(416353, 126, '2015-02-15 01:10:33.000000', 'consum', 0.0213, 'lps'),
	(416354, 126, '2015-02-15 01:10:34.000000', 'consum', 0.0221, 'lps'),
	(416355, 126, '2015-02-15 01:10:35.000000', 'consum', 0.0211, 'lps'),
	(416356, 126, '2015-02-15 01:10:36.000000', 'consum', 0.0212, 'lps'),
	(416357, 126, '2015-02-15 01:10:37.000000', 'consum', 0.0219, 'lps'),
	(416358, 126, '2015-02-15 01:10:38.000000', 'consum', 0.0219, 'lps'),
	(416359, 126, '2015-02-15 01:10:39.000000', 'consum', 0.0215, 'lps'),
	(416360, 126, '2015-02-15 01:10:40.000000', 'consum', 0.0210, 'lps'),
	(416361, 126, '2015-02-15 01:10:41.000000', 'consum', 0.0222, 'lps'),
	(416362, 126, '2015-02-15 01:10:42.000000', 'consum', 0.0214, 'lps'),
	(416363, 126, '2015-02-15 01:10:43.000000', 'consum', 0.0211, 'lps'),
	(416364, 126, '2015-02-15 01:10:44.000000', 'consum', 0.0216, 'lps'),
	(416365, 126, '2015-02-15 01:10:45.000000', 'consum', 0.0211, 'lps'),
	(416366, 126, '2015-02-15 01:10:46.000000', 'consum', 0.0223, 'lps'),
	(416367, 126, '2015-02-15 01:10:47.000000', 'consum', 0.0220, 'lps'),
	(416368, 126, '2015-02-15 01:10:48.000000', 'consum', 0.0218, 'lps'),
	(416369, 126, '2015-02-15 01:10:49.000000', 'consum', 0.0221, 'lps'),
	(416370, 126, '2015-02-15 01:10:50.000000', 'consum', 0.0212, 'lps'),
	(416371, 126, '2015-02-15 01:10:51.000000', 'consum', 0.0219, 'lps'),
	(416372, 126, '2015-02-15 01:10:52.000000', 'consum', 0.0220, 'lps'),
	(416373, 126, '2015-02-15 01:10:53.000000', 'consum', 0.0221, 'lps'),
	(416374, 126, '2015-02-15 01:10:54.000000', 'consum', 0.0218, 'lps'),
	(416375, 126, '2015-02-15 01:10:55.000000', 'consum', 0.0221, 'lps'),
	(416376, 126, '2015-02-15 01:10:56.000000', 'consum', 0.0211, 'lps'),
	(416377, 126, '2015-02-15 01:10:57.000000', 'consum', 0.0212, 'lps'),
	(416378, 126, '2015-02-15 01:10:58.000000', 'consum', 0.0219, 'lps'),
	(416379, 126, '2015-02-15 01:10:59.000000', 'consum', 0.0218, 'lps'),
	(416380, 126, '2015-02-15 01:11:00.000000', 'consum', 0.0212, 'lps'),
	(416381, 126, '2015-02-15 01:11:01.000000', 'consum', 0.0211, 'lps'),
	(416382, 126, '2015-02-15 01:11:02.000000', 'consum', 0.0221, 'lps'),
	(416383, 126, '2015-02-15 01:11:03.000000', 'consum', 0.0222, 'lps'),
	(416384, 126, '2015-02-15 01:11:04.000000', 'consum', 0.0211, 'lps'),
	(416385, 126, '2015-02-15 01:11:05.000000', 'consum', 0.0219, 'lps'),
	(416386, 126, '2015-02-15 01:11:06.000000', 'consum', 0.0212, 'lps'),
	(416387, 126, '2015-02-15 01:11:07.000000', 'consum', 0.0221, 'lps'),
	(416388, 126, '2015-02-15 01:11:08.000000', 'consum', 0.0218, 'lps'),
	(416389, 126, '2015-02-15 01:11:09.000000', 'consum', 0.0217, 'lps'),
	(416390, 126, '2015-02-15 01:11:10.000000', 'consum', 0.0220, 'lps'),
	(416391, 126, '2015-02-15 01:11:11.000000', 'consum', 0.0212, 'lps'),
	(416392, 126, '2015-02-15 01:11:12.000000', 'consum', 0.0221, 'lps'),
	(416393, 126, '2015-02-15 01:11:13.000000', 'consum', 0.0215, 'lps'),
	(416394, 126, '2015-02-15 01:11:14.000000', 'consum', 0.0218, 'lps'),
	(416395, 126, '2015-02-15 01:11:15.000000', 'consum', 0.0220, 'lps'),
	(416396, 126, '2015-02-15 01:11:16.000000', 'consum', 0.0222, 'lps'),
	(416397, 126, '2015-02-15 01:11:17.000000', 'consum', 0.0212, 'lps'),
	(416398, 126, '2015-02-15 01:11:18.000000', 'consum', 0.0213, 'lps'),
	(416399, 126, '2015-02-15 01:11:19.000000', 'consum', 0.0220, 'lps'),
	(416400, 126, '2015-02-15 01:11:20.000000', 'consum', 0.0222, 'lps'),
	(416401, 126, '2015-02-15 01:11:21.000000', 'consum', 0.0213, 'lps'),
	(416402, 126, '2015-02-15 01:11:22.000000', 'consum', 0.0217, 'lps'),
	(416403, 126, '2015-02-15 01:11:23.000000', 'consum', 0.0211, 'lps'),
	(416404, 126, '2015-02-15 01:11:24.000000', 'consum', 0.0222, 'lps'),
	(416405, 126, '2015-02-15 01:11:25.000000', 'consum', 0.0211, 'lps'),
	(416406, 126, '2015-02-15 01:11:26.000000', 'consum', 0.0221, 'lps'),
	(416407, 126, '2015-02-15 01:11:27.000000', 'consum', 0.0221, 'lps'),
	(416408, 126, '2015-02-15 01:11:28.000000', 'consum', 0.0219, 'lps'),
	(416409, 126, '2015-02-15 01:11:29.000000', 'consum', 0.0221, 'lps'),
	(416410, 126, '2015-02-15 01:11:30.000000', 'consum', 0.0212, 'lps'),
	(416411, 126, '2015-02-15 01:11:31.000000', 'consum', 0.0213, 'lps'),
	(416412, 126, '2015-02-15 01:11:32.000000', 'consum', 0.0223, 'lps'),
	(416413, 126, '2015-02-15 01:11:33.000000', 'consum', 0.0221, 'lps'),
	(416414, 126, '2015-02-15 01:11:34.000000', 'consum', 0.0216, 'lps'),
	(416415, 126, '2015-02-15 01:11:35.000000', 'consum', 0.0219, 'lps'),
	(416416, 126, '2015-02-15 01:11:36.000000', 'consum', 0.0212, 'lps'),
	(416417, 126, '2015-02-15 01:11:37.000000', 'consum', 0.0220, 'lps'),
	(416418, 126, '2015-02-15 01:11:38.000000', 'consum', 0.0215, 'lps'),
	(416419, 126, '2015-02-15 01:11:39.000000', 'consum', 0.0216, 'lps'),
	(416420, 126, '2015-02-15 01:11:40.000000', 'consum', 0.0215, 'lps'),
	(416421, 126, '2015-02-15 01:11:41.000000', 'consum', 0.0215, 'lps'),
	(416422, 126, '2015-02-15 01:11:42.000000', 'consum', 0.0223, 'lps'),
	(416423, 126, '2015-02-15 01:11:43.000000', 'consum', 0.0217, 'lps'),
	(416424, 126, '2015-02-15 01:11:44.000000', 'consum', 0.0221, 'lps'),
	(416425, 126, '2015-02-15 01:11:45.000000', 'consum', 0.0215, 'lps'),
	(416426, 126, '2015-02-15 01:11:46.000000', 'consum', 0.0217, 'lps'),
	(416427, 126, '2015-02-15 01:11:47.000000', 'consum', 0.0218, 'lps'),
	(416428, 126, '2015-02-15 01:11:48.000000', 'consum', 0.0214, 'lps'),
	(416429, 126, '2015-02-15 01:11:49.000000', 'consum', 0.0220, 'lps'),
	(416430, 126, '2015-02-15 01:11:50.000000', 'consum', 0.0223, 'lps'),
	(416431, 126, '2015-02-15 01:11:51.000000', 'consum', 0.0215, 'lps'),
	(416432, 126, '2015-02-15 01:11:52.000000', 'consum', 0.0210, 'lps'),
	(416433, 126, '2015-02-15 01:11:53.000000', 'consum', 0.0211, 'lps'),
	(416434, 126, '2015-02-15 01:11:54.000000', 'consum', 0.0215, 'lps'),
	(416435, 126, '2015-02-15 01:11:55.000000', 'consum', 0.0219, 'lps'),
	(416436, 126, '2015-02-15 01:11:56.000000', 'consum', 0.0214, 'lps'),
	(416437, 126, '2015-02-15 01:11:57.000000', 'consum', 0.0216, 'lps'),
	(416438, 126, '2015-02-15 01:11:58.000000', 'consum', 0.0213, 'lps'),
	(416439, 126, '2015-02-15 01:11:59.000000', 'consum', 0.0210, 'lps'),
	(416440, 126, '2015-02-15 01:12:00.000000', 'consum', 0.0214, 'lps'),
	(416441, 126, '2015-02-15 01:12:01.000000', 'consum', 0.0218, 'lps'),
	(416442, 126, '2015-02-15 01:12:02.000000', 'consum', 0.0210, 'lps'),
	(416443, 126, '2015-02-15 01:12:03.000000', 'consum', 0.0215, 'lps'),
	(416444, 126, '2015-02-15 01:12:04.000000', 'consum', 0.0223, 'lps'),
	(416445, 126, '2015-02-15 01:12:05.000000', 'consum', 0.0217, 'lps'),
	(416446, 126, '2015-02-15 01:12:06.000000', 'consum', 0.0221, 'lps'),
	(416447, 126, '2015-02-15 01:12:07.000000', 'consum', 0.0218, 'lps'),
	(416448, 126, '2015-02-15 01:12:08.000000', 'consum', 0.0214, 'lps'),
	(416449, 126, '2015-02-15 01:12:09.000000', 'consum', 0.0210, 'lps'),
	(416450, 126, '2015-02-15 01:12:10.000000', 'consum', 0.0210, 'lps'),
	(416451, 126, '2015-02-15 01:12:11.000000', 'consum', 0.0211, 'lps'),
	(416452, 126, '2015-02-15 01:12:12.000000', 'consum', 0.0217, 'lps'),
	(416453, 126, '2015-02-15 01:12:13.000000', 'consum', 0.0212, 'lps'),
	(416454, 126, '2015-02-15 01:12:14.000000', 'consum', 0.0216, 'lps'),
	(416455, 126, '2015-02-15 01:12:15.000000', 'consum', 0.0218, 'lps'),
	(416456, 126, '2015-02-15 01:12:16.000000', 'consum', 0.0217, 'lps'),
	(416457, 126, '2015-02-15 01:12:17.000000', 'consum', 0.0211, 'lps'),
	(416458, 126, '2015-02-15 01:12:18.000000', 'consum', 0.0223, 'lps'),
	(416459, 126, '2015-02-15 01:12:19.000000', 'consum', 0.0214, 'lps'),
	(416460, 126, '2015-02-15 01:12:20.000000', 'consum', 0.0220, 'lps'),
	(416461, 126, '2015-02-15 01:12:21.000000', 'consum', 0.0221, 'lps'),
	(416462, 126, '2015-02-15 01:12:22.000000', 'consum', 0.0222, 'lps'),
	(416463, 126, '2015-02-15 01:12:23.000000', 'consum', 0.0223, 'lps'),
	(416464, 126, '2015-02-15 01:12:24.000000', 'consum', 0.0210, 'lps'),
	(416465, 126, '2015-02-15 01:12:25.000000', 'consum', 0.0215, 'lps'),
	(416466, 126, '2015-02-15 01:12:26.000000', 'consum', 0.0222, 'lps'),
	(416467, 126, '2015-02-15 01:12:27.000000', 'consum', 0.0214, 'lps'),
	(416468, 126, '2015-02-15 01:12:28.000000', 'consum', 0.0221, 'lps'),
	(416469, 126, '2015-02-15 01:12:29.000000', 'consum', 0.0212, 'lps'),
	(416470, 126, '2015-02-15 01:12:30.000000', 'consum', 0.0214, 'lps'),
	(416471, 126, '2015-02-15 01:12:31.000000', 'consum', 0.0213, 'lps'),
	(416472, 126, '2015-02-15 01:12:32.000000', 'consum', 0.0213, 'lps'),
	(416473, 126, '2015-02-15 01:12:33.000000', 'consum', 0.0214, 'lps'),
	(416474, 126, '2015-02-15 01:12:34.000000', 'consum', 0.0210, 'lps'),
	(416475, 126, '2015-02-15 01:12:35.000000', 'consum', 0.0212, 'lps'),
	(416476, 126, '2015-02-15 01:12:36.000000', 'consum', 0.0219, 'lps'),
	(416477, 126, '2015-02-15 01:12:37.000000', 'consum', 0.0223, 'lps'),
	(416478, 126, '2015-02-15 01:12:38.000000', 'consum', 0.0220, 'lps'),
	(416479, 126, '2015-02-15 01:12:39.000000', 'consum', 0.0223, 'lps'),
	(416480, 126, '2015-02-15 01:12:40.000000', 'consum', 0.0215, 'lps'),
	(416481, 126, '2015-02-15 01:12:41.000000', 'consum', 0.0212, 'lps'),
	(416482, 126, '2015-02-15 01:12:42.000000', 'consum', 0.0221, 'lps'),
	(416483, 126, '2015-02-15 01:12:43.000000', 'consum', 0.0217, 'lps'),
	(416484, 126, '2015-02-15 01:12:44.000000', 'consum', 0.0210, 'lps'),
	(416485, 126, '2015-02-15 01:12:45.000000', 'consum', 0.0220, 'lps'),
	(416486, 126, '2015-02-15 01:12:46.000000', 'consum', 0.0216, 'lps'),
	(416487, 126, '2015-02-15 01:12:47.000000', 'consum', 0.0211, 'lps'),
	(416488, 126, '2015-02-15 01:12:48.000000', 'consum', 0.0212, 'lps'),
	(416489, 126, '2015-02-15 01:12:49.000000', 'consum', 0.0219, 'lps'),
	(416490, 126, '2015-02-15 01:12:50.000000', 'consum', 0.0219, 'lps'),
	(416491, 126, '2015-02-15 01:12:51.000000', 'consum', 0.0217, 'lps'),
	(416492, 126, '2015-02-15 01:12:52.000000', 'consum', 0.0217, 'lps'),
	(416493, 126, '2015-02-15 01:12:53.000000', 'consum', 0.0223, 'lps'),
	(416494, 126, '2015-02-15 01:12:54.000000', 'consum', 0.0213, 'lps'),
	(416495, 126, '2015-02-15 01:12:55.000000', 'consum', 0.0214, 'lps'),
	(416496, 126, '2015-02-15 01:12:56.000000', 'consum', 0.0210, 'lps'),
	(416497, 126, '2015-02-15 01:12:57.000000', 'consum', 0.0211, 'lps'),
	(416498, 126, '2015-02-15 01:12:58.000000', 'consum', 0.0216, 'lps'),
	(416499, 126, '2015-02-15 01:12:59.000000', 'consum', 0.0210, 'lps'),
	(416500, 126, '2015-02-15 01:13:00.000000', 'consum', 0.0219, 'lps'),
	(416501, 126, '2015-02-15 01:13:01.000000', 'consum', 0.0213, 'lps'),
	(416502, 126, '2015-02-15 01:13:02.000000', 'consum', 0.0213, 'lps'),
	(416503, 126, '2015-02-15 01:13:03.000000', 'consum', 0.0216, 'lps'),
	(416504, 126, '2015-02-15 01:13:04.000000', 'consum', 0.0218, 'lps'),
	(416505, 126, '2015-02-15 01:13:05.000000', 'consum', 0.0217, 'lps'),
	(416506, 126, '2015-02-15 01:13:06.000000', 'consum', 0.0222, 'lps'),
	(416507, 126, '2015-02-15 01:13:07.000000', 'consum', 0.0223, 'lps'),
	(416508, 126, '2015-02-15 01:13:08.000000', 'consum', 0.0211, 'lps'),
	(416509, 126, '2015-02-15 01:13:09.000000', 'consum', 0.0218, 'lps'),
	(416510, 126, '2015-02-15 01:13:10.000000', 'consum', 0.0220, 'lps'),
	(416511, 126, '2015-02-15 01:13:11.000000', 'consum', 0.0221, 'lps'),
	(416512, 126, '2015-02-15 01:13:12.000000', 'consum', 0.0223, 'lps'),
	(416513, 126, '2015-02-15 01:13:13.000000', 'consum', 0.0214, 'lps'),
	(416514, 126, '2015-02-15 01:13:14.000000', 'consum', 0.0219, 'lps'),
	(416515, 126, '2015-02-15 01:13:15.000000', 'consum', 0.0216, 'lps'),
	(416516, 126, '2015-02-15 01:13:16.000000', 'consum', 0.0213, 'lps'),
	(416517, 126, '2015-02-15 01:13:17.000000', 'consum', 0.0220, 'lps'),
	(416518, 126, '2015-02-15 01:13:18.000000', 'consum', 0.0212, 'lps'),
	(416519, 126, '2015-02-15 01:13:19.000000', 'consum', 0.0219, 'lps'),
	(416520, 126, '2015-02-15 01:13:20.000000', 'consum', 0.0221, 'lps'),
	(416521, 126, '2015-02-15 01:13:21.000000', 'consum', 0.0211, 'lps'),
	(416522, 126, '2015-02-15 01:13:22.000000', 'consum', 0.0223, 'lps'),
	(416523, 126, '2015-02-15 01:13:23.000000', 'consum', 0.0216, 'lps'),
	(416524, 126, '2015-02-15 01:13:24.000000', 'consum', 0.0218, 'lps'),
	(416525, 126, '2015-02-15 01:13:25.000000', 'consum', 0.0216, 'lps'),
	(416526, 126, '2015-02-15 01:13:26.000000', 'consum', 0.0217, 'lps'),
	(416527, 126, '2015-02-15 01:13:27.000000', 'consum', 0.0215, 'lps'),
	(416528, 126, '2015-02-15 01:13:28.000000', 'consum', 0.0214, 'lps'),
	(416529, 126, '2015-02-15 01:13:29.000000', 'consum', 0.0216, 'lps'),
	(416530, 126, '2015-02-15 01:13:30.000000', 'consum', 0.0215, 'lps'),
	(416531, 126, '2015-02-15 01:13:31.000000', 'consum', 0.0217, 'lps'),
	(416532, 126, '2015-02-15 01:13:32.000000', 'consum', 0.0214, 'lps'),
	(416533, 126, '2015-02-15 01:13:33.000000', 'consum', 0.0213, 'lps'),
	(416534, 126, '2015-02-15 01:13:34.000000', 'consum', 0.0211, 'lps'),
	(416535, 126, '2015-02-15 01:13:35.000000', 'consum', 0.0220, 'lps'),
	(416536, 126, '2015-02-15 01:13:36.000000', 'consum', 0.0218, 'lps'),
	(416537, 126, '2015-02-15 01:13:37.000000', 'consum', 0.0221, 'lps'),
	(416538, 126, '2015-02-15 01:13:38.000000', 'consum', 0.0212, 'lps'),
	(416539, 126, '2015-02-15 01:13:39.000000', 'consum', 0.0214, 'lps'),
	(416540, 126, '2015-02-15 01:13:40.000000', 'consum', 0.0213, 'lps'),
	(416541, 126, '2015-02-15 01:13:41.000000', 'consum', 0.0214, 'lps'),
	(416542, 126, '2015-02-15 01:13:42.000000', 'consum', 0.0219, 'lps'),
	(416543, 126, '2015-02-15 01:13:43.000000', 'consum', 0.0216, 'lps'),
	(416544, 126, '2015-02-15 01:13:44.000000', 'consum', 0.0215, 'lps'),
	(416545, 126, '2015-02-15 01:13:45.000000', 'consum', 0.0218, 'lps'),
	(416546, 126, '2015-02-15 01:13:46.000000', 'consum', 0.0220, 'lps'),
	(416547, 126, '2015-02-15 01:13:47.000000', 'consum', 0.0223, 'lps'),
	(416548, 126, '2015-02-15 01:13:48.000000', 'consum', 0.0215, 'lps'),
	(416549, 126, '2015-02-15 01:13:49.000000', 'consum', 0.0214, 'lps'),
	(416550, 126, '2015-02-15 01:13:50.000000', 'consum', 0.0214, 'lps'),
	(416551, 126, '2015-02-15 01:13:51.000000', 'consum', 0.0217, 'lps'),
	(416552, 126, '2015-02-15 01:13:52.000000', 'consum', 0.0222, 'lps'),
	(416553, 126, '2015-02-15 01:13:53.000000', 'consum', 0.0222, 'lps'),
	(416554, 126, '2015-02-15 01:13:54.000000', 'consum', 0.0222, 'lps'),
	(416555, 126, '2015-02-15 01:13:55.000000', 'consum', 0.0217, 'lps'),
	(416556, 126, '2015-02-15 01:13:56.000000', 'consum', 0.0210, 'lps'),
	(416557, 126, '2015-02-15 01:13:57.000000', 'consum', 0.0218, 'lps'),
	(416558, 126, '2015-02-15 01:13:58.000000', 'consum', 0.0210, 'lps'),
	(416559, 126, '2015-02-15 01:13:59.000000', 'consum', 0.0212, 'lps'),
	(416560, 126, '2015-02-15 01:14:00.000000', 'consum', 0.0222, 'lps'),
	(416561, 126, '2015-02-15 01:14:01.000000', 'consum', 0.0222, 'lps'),
	(416562, 126, '2015-02-15 01:14:02.000000', 'consum', 0.0219, 'lps'),
	(416563, 126, '2015-02-15 01:14:03.000000', 'consum', 0.0221, 'lps'),
	(416564, 126, '2015-02-15 01:14:04.000000', 'consum', 0.0210, 'lps'),
	(416565, 126, '2015-02-15 01:14:05.000000', 'consum', 0.0218, 'lps'),
	(416566, 126, '2015-02-15 01:14:06.000000', 'consum', 0.0223, 'lps'),
	(416567, 126, '2015-02-15 01:14:07.000000', 'consum', 0.0222, 'lps'),
	(416568, 126, '2015-02-15 01:14:08.000000', 'consum', 0.0221, 'lps'),
	(416569, 126, '2015-02-15 01:14:09.000000', 'consum', 0.0212, 'lps'),
	(416570, 126, '2015-02-15 01:14:10.000000', 'consum', 0.0216, 'lps'),
	(416571, 126, '2015-02-15 01:14:11.000000', 'consum', 0.0223, 'lps'),
	(416572, 126, '2015-02-15 01:14:12.000000', 'consum', 0.0214, 'lps'),
	(416573, 126, '2015-02-15 01:14:13.000000', 'consum', 0.0220, 'lps'),
	(416574, 126, '2015-02-15 01:14:14.000000', 'consum', 0.0220, 'lps'),
	(416575, 126, '2015-02-15 01:14:15.000000', 'consum', 0.0216, 'lps'),
	(416576, 126, '2015-02-15 01:14:16.000000', 'consum', 0.0212, 'lps'),
	(416577, 126, '2015-02-15 01:14:17.000000', 'consum', 0.0216, 'lps'),
	(416578, 126, '2015-02-15 01:14:18.000000', 'consum', 0.0221, 'lps'),
	(416579, 126, '2015-02-15 01:14:19.000000', 'consum', 0.0220, 'lps'),
	(416580, 126, '2015-02-15 01:14:20.000000', 'consum', 0.0213, 'lps'),
	(416581, 126, '2015-02-15 01:14:21.000000', 'consum', 0.0210, 'lps'),
	(416582, 126, '2015-02-15 01:14:22.000000', 'consum', 0.0215, 'lps'),
	(416583, 126, '2015-02-15 01:14:23.000000', 'consum', 0.0223, 'lps'),
	(416584, 126, '2015-02-15 01:14:24.000000', 'consum', 0.0218, 'lps'),
	(416585, 126, '2015-02-15 01:14:25.000000', 'consum', 0.0223, 'lps'),
	(416586, 126, '2015-02-15 01:14:26.000000', 'consum', 0.0212, 'lps'),
	(416587, 126, '2015-02-15 01:14:27.000000', 'consum', 0.0223, 'lps'),
	(416588, 126, '2015-02-15 01:14:28.000000', 'consum', 0.0215, 'lps'),
	(416589, 126, '2015-02-15 01:14:29.000000', 'consum', 0.0223, 'lps'),
	(416590, 126, '2015-02-15 01:14:30.000000', 'consum', 0.0219, 'lps'),
	(416591, 126, '2015-02-15 01:14:31.000000', 'consum', 0.0217, 'lps'),
	(416592, 126, '2015-02-15 01:14:32.000000', 'consum', 0.0218, 'lps'),
	(416593, 126, '2015-02-15 01:14:33.000000', 'consum', 0.0215, 'lps'),
	(416594, 126, '2015-02-15 01:14:34.000000', 'consum', 0.0211, 'lps'),
	(416595, 126, '2015-02-15 01:14:35.000000', 'consum', 0.0217, 'lps'),
	(416596, 126, '2015-02-15 01:14:36.000000', 'consum', 0.0212, 'lps'),
	(416597, 126, '2015-02-15 01:14:37.000000', 'consum', 0.0212, 'lps'),
	(416598, 126, '2015-02-15 01:14:38.000000', 'consum', 0.0218, 'lps'),
	(416599, 126, '2015-02-15 01:14:39.000000', 'consum', 0.0215, 'lps'),
	(416600, 126, '2015-02-15 01:14:40.000000', 'consum', 0.0213, 'lps'),
	(416601, 126, '2015-02-15 01:14:41.000000', 'consum', 0.0223, 'lps'),
	(416602, 126, '2015-02-15 01:14:42.000000', 'consum', 0.0223, 'lps'),
	(416603, 126, '2015-02-15 01:14:43.000000', 'consum', 0.0211, 'lps'),
	(416604, 126, '2015-02-15 01:14:44.000000', 'consum', 0.0219, 'lps'),
	(416605, 126, '2015-02-15 01:14:45.000000', 'consum', 0.0211, 'lps'),
	(416606, 126, '2015-02-15 01:14:46.000000', 'consum', 0.0217, 'lps'),
	(416607, 126, '2015-02-15 01:14:47.000000', 'consum', 0.0211, 'lps'),
	(416608, 126, '2015-02-15 01:14:48.000000', 'consum', 0.0212, 'lps'),
	(416609, 126, '2015-02-15 01:14:49.000000', 'consum', 0.0217, 'lps'),
	(416610, 126, '2015-02-15 01:14:50.000000', 'consum', 0.0211, 'lps'),
	(416611, 126, '2015-02-15 01:14:51.000000', 'consum', 0.0222, 'lps'),
	(416612, 126, '2015-02-15 01:14:52.000000', 'consum', 0.0213, 'lps'),
	(416613, 126, '2015-02-15 01:14:53.000000', 'consum', 0.0216, 'lps'),
	(416614, 126, '2015-02-15 01:14:54.000000', 'consum', 0.0217, 'lps'),
	(416615, 126, '2015-02-15 01:14:55.000000', 'consum', 0.0214, 'lps'),
	(416616, 126, '2015-02-15 01:14:56.000000', 'consum', 0.0210, 'lps'),
	(416617, 126, '2015-02-15 01:14:57.000000', 'consum', 0.0213, 'lps'),
	(416618, 126, '2015-02-15 01:14:58.000000', 'consum', 0.0212, 'lps'),
	(416619, 126, '2015-02-15 01:14:59.000000', 'consum', 0.0211, 'lps'),
	(416620, 126, '2015-02-15 01:15:00.000000', 'consum', 0.0223, 'lps'),
	(416621, 126, '2015-02-15 01:15:01.000000', 'consum', 0.0218, 'lps'),
	(416622, 126, '2015-02-15 01:15:02.000000', 'consum', 0.0210, 'lps'),
	(416623, 126, '2015-02-15 01:15:03.000000', 'consum', 0.0216, 'lps'),
	(416624, 126, '2015-02-15 01:15:04.000000', 'consum', 0.0211, 'lps'),
	(416625, 126, '2015-02-15 01:15:05.000000', 'consum', 0.0213, 'lps'),
	(416626, 126, '2015-02-15 01:15:06.000000', 'consum', 0.0221, 'lps'),
	(416627, 126, '2015-02-15 01:15:07.000000', 'consum', 0.0215, 'lps'),
	(416628, 126, '2015-02-15 01:15:08.000000', 'consum', 0.0216, 'lps'),
	(416629, 126, '2015-02-15 01:15:09.000000', 'consum', 0.0213, 'lps'),
	(416630, 126, '2015-02-15 01:15:10.000000', 'consum', 0.0219, 'lps'),
	(416631, 126, '2015-02-15 01:15:11.000000', 'consum', 0.0218, 'lps'),
	(416632, 126, '2015-02-15 01:15:12.000000', 'consum', 0.0213, 'lps'),
	(416633, 126, '2015-02-15 01:15:13.000000', 'consum', 0.0212, 'lps'),
	(416634, 126, '2015-02-15 01:15:14.000000', 'consum', 0.0215, 'lps'),
	(416635, 126, '2015-02-15 01:15:15.000000', 'consum', 0.0213, 'lps'),
	(416636, 126, '2015-02-15 01:15:16.000000', 'consum', 0.0211, 'lps'),
	(416637, 126, '2015-02-15 01:15:17.000000', 'consum', 0.0219, 'lps'),
	(416638, 126, '2015-02-15 01:15:18.000000', 'consum', 0.0211, 'lps'),
	(416639, 126, '2015-02-15 01:15:19.000000', 'consum', 0.0216, 'lps'),
	(416640, 126, '2015-02-15 01:15:20.000000', 'consum', 0.0222, 'lps'),
	(416641, 126, '2015-02-15 01:15:21.000000', 'consum', 0.0214, 'lps'),
	(416642, 126, '2015-02-15 01:15:22.000000', 'consum', 0.0221, 'lps'),
	(416643, 126, '2015-02-15 01:15:23.000000', 'consum', 0.0211, 'lps'),
	(416644, 126, '2015-02-15 01:15:24.000000', 'consum', 0.0210, 'lps'),
	(416645, 126, '2015-02-15 01:15:25.000000', 'consum', 0.0222, 'lps'),
	(416646, 126, '2015-02-15 01:15:26.000000', 'consum', 0.0212, 'lps'),
	(416647, 126, '2015-02-15 01:15:27.000000', 'consum', 0.0216, 'lps'),
	(416648, 126, '2015-02-15 01:15:28.000000', 'consum', 0.0221, 'lps'),
	(416649, 126, '2015-02-15 01:15:29.000000', 'consum', 0.0219, 'lps'),
	(416650, 126, '2015-02-15 01:15:30.000000', 'consum', 0.0221, 'lps'),
	(416651, 126, '2015-02-15 01:15:31.000000', 'consum', 0.0213, 'lps'),
	(416652, 126, '2015-02-15 01:15:32.000000', 'consum', 0.0219, 'lps'),
	(416653, 126, '2015-02-15 01:15:33.000000', 'consum', 0.0220, 'lps'),
	(416654, 126, '2015-02-15 01:15:34.000000', 'consum', 0.0217, 'lps'),
	(416655, 126, '2015-02-15 01:15:35.000000', 'consum', 0.0217, 'lps'),
	(416656, 126, '2015-02-15 01:15:36.000000', 'consum', 0.0210, 'lps'),
	(416657, 126, '2015-02-15 01:15:37.000000', 'consum', 0.0218, 'lps'),
	(416658, 126, '2015-02-15 01:15:38.000000', 'consum', 0.0220, 'lps'),
	(416659, 126, '2015-02-15 01:15:39.000000', 'consum', 0.0211, 'lps'),
	(416660, 126, '2015-02-15 01:15:40.000000', 'consum', 0.0212, 'lps'),
	(416661, 126, '2015-02-15 01:15:41.000000', 'consum', 0.0218, 'lps'),
	(416662, 126, '2015-02-15 01:15:42.000000', 'consum', 0.0216, 'lps'),
	(416663, 126, '2015-02-15 01:15:43.000000', 'consum', 0.0215, 'lps'),
	(416664, 126, '2015-02-15 01:15:44.000000', 'consum', 0.0219, 'lps'),
	(416665, 126, '2015-02-15 01:15:45.000000', 'consum', 0.0212, 'lps'),
	(416666, 126, '2015-02-15 01:15:46.000000', 'consum', 0.0223, 'lps'),
	(416667, 126, '2015-02-15 01:15:47.000000', 'consum', 0.0214, 'lps'),
	(416668, 126, '2015-02-15 01:15:48.000000', 'consum', 0.0219, 'lps'),
	(416669, 126, '2015-02-15 01:15:49.000000', 'consum', 0.0213, 'lps'),
	(416670, 126, '2015-02-15 01:15:50.000000', 'consum', 0.0215, 'lps'),
	(416671, 126, '2015-02-15 01:15:51.000000', 'consum', 0.0210, 'lps'),
	(416672, 126, '2015-02-15 01:15:52.000000', 'consum', 0.0212, 'lps'),
	(416673, 126, '2015-02-15 01:15:53.000000', 'consum', 0.0218, 'lps'),
	(416674, 126, '2015-02-15 01:15:54.000000', 'consum', 0.0217, 'lps'),
	(416675, 126, '2015-02-15 01:15:55.000000', 'consum', 0.0223, 'lps'),
	(416676, 126, '2015-02-15 01:15:56.000000', 'consum', 0.0213, 'lps'),
	(416677, 126, '2015-02-15 01:15:57.000000', 'consum', 0.0213, 'lps'),
	(416678, 126, '2015-02-15 01:15:58.000000', 'consum', 0.0216, 'lps'),
	(416679, 126, '2015-02-15 01:15:59.000000', 'consum', 0.0218, 'lps'),
	(416680, 126, '2015-02-15 01:16:00.000000', 'consum', 0.0217, 'lps'),
	(416681, 126, '2015-02-15 01:16:01.000000', 'consum', 0.0223, 'lps'),
	(416682, 126, '2015-02-15 01:16:02.000000', 'consum', 0.0212, 'lps'),
	(416683, 126, '2015-02-15 01:16:03.000000', 'consum', 0.0223, 'lps'),
	(416684, 126, '2015-02-15 01:16:04.000000', 'consum', 0.0212, 'lps'),
	(416685, 126, '2015-02-15 01:16:05.000000', 'consum', 0.0211, 'lps'),
	(416686, 126, '2015-02-15 01:16:06.000000', 'consum', 0.0223, 'lps'),
	(416687, 126, '2015-02-15 01:16:07.000000', 'consum', 0.0215, 'lps'),
	(416688, 126, '2015-02-15 01:16:08.000000', 'consum', 0.0213, 'lps'),
	(416689, 126, '2015-02-15 01:16:09.000000', 'consum', 0.0222, 'lps'),
	(416690, 126, '2015-02-15 01:16:10.000000', 'consum', 0.0222, 'lps'),
	(416691, 126, '2015-02-15 01:16:11.000000', 'consum', 0.0221, 'lps'),
	(416692, 126, '2015-02-15 01:16:12.000000', 'consum', 0.0216, 'lps'),
	(416693, 126, '2015-02-15 01:16:13.000000', 'consum', 0.0220, 'lps'),
	(416694, 126, '2015-02-15 01:16:14.000000', 'consum', 0.0216, 'lps'),
	(416695, 126, '2015-02-15 01:16:15.000000', 'consum', 0.0210, 'lps'),
	(416696, 126, '2015-02-15 01:16:16.000000', 'consum', 0.0219, 'lps'),
	(416697, 126, '2015-02-15 01:16:17.000000', 'consum', 0.0215, 'lps'),
	(416698, 126, '2015-02-15 01:16:18.000000', 'consum', 0.0223, 'lps'),
	(416699, 126, '2015-02-15 01:16:19.000000', 'consum', 0.0219, 'lps'),
	(416700, 126, '2015-02-15 01:16:20.000000', 'consum', 0.0214, 'lps'),
	(416701, 126, '2015-02-15 01:16:21.000000', 'consum', 0.0218, 'lps'),
	(416702, 126, '2015-02-15 01:16:22.000000', 'consum', 0.0211, 'lps'),
	(416703, 126, '2015-02-15 01:16:23.000000', 'consum', 0.0221, 'lps'),
	(416704, 126, '2015-02-15 01:16:24.000000', 'consum', 0.0220, 'lps'),
	(416705, 126, '2015-02-15 01:16:25.000000', 'consum', 0.0215, 'lps'),
	(416706, 126, '2015-02-15 01:16:26.000000', 'consum', 0.0219, 'lps'),
	(416707, 126, '2015-02-15 01:16:27.000000', 'consum', 0.0210, 'lps'),
	(416708, 126, '2015-02-15 01:16:28.000000', 'consum', 0.0214, 'lps'),
	(416709, 126, '2015-02-15 01:16:29.000000', 'consum', 0.0216, 'lps'),
	(416710, 126, '2015-02-15 01:16:30.000000', 'consum', 0.0214, 'lps'),
	(416711, 126, '2015-02-15 01:16:31.000000', 'consum', 0.0214, 'lps'),
	(416712, 126, '2015-02-15 01:16:32.000000', 'consum', 0.0218, 'lps'),
	(416713, 126, '2015-02-15 01:16:33.000000', 'consum', 0.0223, 'lps'),
	(416714, 126, '2015-02-15 01:16:34.000000', 'consum', 0.0210, 'lps'),
	(416715, 126, '2015-02-15 01:16:35.000000', 'consum', 0.0215, 'lps'),
	(416716, 126, '2015-02-15 01:16:36.000000', 'consum', 0.0219, 'lps'),
	(416717, 126, '2015-02-15 01:16:37.000000', 'consum', 0.0213, 'lps'),
	(416718, 126, '2015-02-15 01:16:38.000000', 'consum', 0.0214, 'lps'),
	(416719, 126, '2015-02-15 01:16:39.000000', 'consum', 0.0219, 'lps'),
	(416720, 126, '2015-02-15 01:16:40.000000', 'consum', 0.0219, 'lps'),
	(416721, 126, '2015-02-15 01:16:41.000000', 'consum', 0.0211, 'lps'),
	(416722, 126, '2015-02-15 01:16:42.000000', 'consum', 0.0219, 'lps'),
	(416723, 126, '2015-02-15 01:16:43.000000', 'consum', 0.0223, 'lps'),
	(416724, 126, '2015-02-15 01:16:44.000000', 'consum', 0.0221, 'lps'),
	(416725, 126, '2015-02-15 01:16:45.000000', 'consum', 0.0214, 'lps'),
	(416726, 126, '2015-02-15 01:16:46.000000', 'consum', 0.0222, 'lps'),
	(416727, 126, '2015-02-15 01:16:47.000000', 'consum', 0.0220, 'lps'),
	(416728, 126, '2015-02-15 01:16:48.000000', 'consum', 0.0210, 'lps'),
	(416729, 126, '2015-02-15 01:16:49.000000', 'consum', 0.0223, 'lps'),
	(416730, 126, '2015-02-15 01:16:50.000000', 'consum', 0.0221, 'lps'),
	(416731, 126, '2015-02-15 01:16:51.000000', 'consum', 0.0210, 'lps'),
	(416732, 126, '2015-02-15 01:16:52.000000', 'consum', 0.0221, 'lps'),
	(416733, 126, '2015-02-15 01:16:53.000000', 'consum', 0.0210, 'lps'),
	(416734, 126, '2015-02-15 01:16:54.000000', 'consum', 0.0217, 'lps'),
	(416735, 126, '2015-02-15 01:16:55.000000', 'consum', 0.0221, 'lps'),
	(416736, 126, '2015-02-15 01:16:56.000000', 'consum', 0.0214, 'lps'),
	(416737, 126, '2015-02-15 01:16:57.000000', 'consum', 0.0211, 'lps'),
	(416738, 126, '2015-02-15 01:16:58.000000', 'consum', 0.0217, 'lps'),
	(416739, 126, '2015-02-15 01:16:59.000000', 'consum', 0.0215, 'lps'),
	(416740, 126, '2015-02-15 01:17:00.000000', 'consum', 0.0216, 'lps'),
	(416741, 126, '2015-02-15 01:17:01.000000', 'consum', 0.0223, 'lps'),
	(416742, 126, '2015-02-15 01:17:02.000000', 'consum', 0.0218, 'lps'),
	(416743, 126, '2015-02-15 01:17:03.000000', 'consum', 0.0210, 'lps'),
	(416744, 126, '2015-02-15 01:17:04.000000', 'consum', 0.0213, 'lps'),
	(416745, 126, '2015-02-15 01:17:05.000000', 'consum', 0.0214, 'lps'),
	(416746, 126, '2015-02-15 01:17:06.000000', 'consum', 0.0220, 'lps'),
	(416747, 126, '2015-02-15 01:17:07.000000', 'consum', 0.0222, 'lps'),
	(416748, 126, '2015-02-15 01:17:08.000000', 'consum', 0.0213, 'lps'),
	(416749, 126, '2015-02-15 01:17:09.000000', 'consum', 0.0217, 'lps'),
	(416750, 126, '2015-02-15 01:17:10.000000', 'consum', 0.0223, 'lps'),
	(416751, 126, '2015-02-15 01:17:11.000000', 'consum', 0.0210, 'lps'),
	(416752, 126, '2015-02-15 01:17:12.000000', 'consum', 0.0214, 'lps'),
	(416753, 126, '2015-02-15 01:17:13.000000', 'consum', 0.0219, 'lps'),
	(416754, 126, '2015-02-15 01:17:14.000000', 'consum', 0.0213, 'lps'),
	(416755, 126, '2015-02-15 01:17:15.000000', 'consum', 0.0215, 'lps'),
	(416756, 126, '2015-02-15 01:17:16.000000', 'consum', 0.0212, 'lps'),
	(416757, 126, '2015-02-15 01:17:17.000000', 'consum', 0.0218, 'lps'),
	(416758, 126, '2015-02-15 01:17:18.000000', 'consum', 0.0215, 'lps'),
	(416759, 126, '2015-02-15 01:17:19.000000', 'consum', 0.0215, 'lps'),
	(416760, 126, '2015-02-15 01:17:20.000000', 'consum', 0.0218, 'lps'),
	(416761, 126, '2015-02-15 01:17:21.000000', 'consum', 0.0221, 'lps'),
	(416762, 126, '2015-02-15 01:17:22.000000', 'consum', 0.0213, 'lps'),
	(416763, 126, '2015-02-15 01:17:23.000000', 'consum', 0.0219, 'lps'),
	(416764, 126, '2015-02-15 01:17:24.000000', 'consum', 0.0222, 'lps'),
	(416765, 126, '2015-02-15 01:17:25.000000', 'consum', 0.0215, 'lps'),
	(416766, 126, '2015-02-15 01:17:26.000000', 'consum', 0.0214, 'lps'),
	(416767, 126, '2015-02-15 01:17:27.000000', 'consum', 0.0216, 'lps'),
	(416768, 126, '2015-02-15 01:17:28.000000', 'consum', 0.0212, 'lps'),
	(416769, 126, '2015-02-15 01:17:29.000000', 'consum', 0.0219, 'lps'),
	(416770, 126, '2015-02-15 01:17:30.000000', 'consum', 0.0219, 'lps'),
	(416771, 126, '2015-02-15 01:17:31.000000', 'consum', 0.0217, 'lps'),
	(416772, 126, '2015-02-15 01:17:32.000000', 'consum', 0.0216, 'lps'),
	(416773, 126, '2015-02-15 01:17:33.000000', 'consum', 0.0219, 'lps'),
	(416774, 126, '2015-02-15 01:17:34.000000', 'consum', 0.0211, 'lps'),
	(416775, 126, '2015-02-15 01:17:35.000000', 'consum', 0.0216, 'lps'),
	(416776, 126, '2015-02-15 01:17:36.000000', 'consum', 0.0210, 'lps'),
	(416777, 126, '2015-02-15 01:17:37.000000', 'consum', 0.0219, 'lps'),
	(416778, 126, '2015-02-15 01:17:38.000000', 'consum', 0.0214, 'lps'),
	(416779, 126, '2015-02-15 01:17:39.000000', 'consum', 0.0220, 'lps'),
	(416780, 126, '2015-02-15 01:17:40.000000', 'consum', 0.0218, 'lps'),
	(416781, 126, '2015-02-15 01:17:41.000000', 'consum', 0.0222, 'lps'),
	(416782, 126, '2015-02-15 01:17:42.000000', 'consum', 0.0217, 'lps'),
	(416783, 126, '2015-02-15 01:17:43.000000', 'consum', 0.0223, 'lps'),
	(416784, 126, '2015-02-15 01:17:44.000000', 'consum', 0.0214, 'lps'),
	(416785, 126, '2015-02-15 01:17:45.000000', 'consum', 0.0218, 'lps'),
	(416786, 126, '2015-02-15 01:17:46.000000', 'consum', 0.0213, 'lps'),
	(416787, 126, '2015-02-15 01:17:47.000000', 'consum', 0.0212, 'lps'),
	(416788, 126, '2015-02-15 01:17:48.000000', 'consum', 0.0215, 'lps'),
	(416789, 126, '2015-02-15 01:17:49.000000', 'consum', 0.0214, 'lps'),
	(416790, 126, '2015-02-15 01:17:50.000000', 'consum', 0.0216, 'lps'),
	(416791, 126, '2015-02-15 01:17:51.000000', 'consum', 0.0214, 'lps'),
	(416792, 126, '2015-02-15 01:17:52.000000', 'consum', 0.0214, 'lps'),
	(416793, 126, '2015-02-15 01:17:53.000000', 'consum', 0.0216, 'lps'),
	(416794, 126, '2015-02-15 01:17:54.000000', 'consum', 0.0216, 'lps'),
	(416795, 126, '2015-02-15 01:17:55.000000', 'consum', 0.0222, 'lps'),
	(416796, 126, '2015-02-15 01:17:56.000000', 'consum', 0.0211, 'lps'),
	(416797, 126, '2015-02-15 01:17:57.000000', 'consum', 0.0222, 'lps'),
	(416798, 126, '2015-02-15 01:17:58.000000', 'consum', 0.0223, 'lps'),
	(416799, 126, '2015-02-15 01:17:59.000000', 'consum', 0.0215, 'lps'),
	(416800, 126, '2015-02-15 01:18:00.000000', 'consum', 0.0222, 'lps'),
	(416801, 126, '2015-02-15 01:18:01.000000', 'consum', 0.0213, 'lps'),
	(416802, 126, '2015-02-15 01:18:02.000000', 'consum', 0.0218, 'lps'),
	(416803, 126, '2015-02-15 01:18:03.000000', 'consum', 0.0212, 'lps'),
	(416804, 126, '2015-02-15 01:18:04.000000', 'consum', 0.0214, 'lps'),
	(416805, 126, '2015-02-15 01:18:05.000000', 'consum', 0.0222, 'lps'),
	(416806, 126, '2015-02-15 01:18:06.000000', 'consum', 0.0216, 'lps'),
	(416807, 126, '2015-02-15 01:18:07.000000', 'consum', 0.0221, 'lps'),
	(416808, 126, '2015-02-15 01:18:08.000000', 'consum', 0.0218, 'lps'),
	(416809, 126, '2015-02-15 01:18:09.000000', 'consum', 0.0219, 'lps'),
	(416810, 126, '2015-02-15 01:18:10.000000', 'consum', 0.0215, 'lps'),
	(416811, 126, '2015-02-15 01:18:11.000000', 'consum', 0.0211, 'lps'),
	(416812, 126, '2015-02-15 01:18:12.000000', 'consum', 0.0215, 'lps'),
	(416813, 126, '2015-02-15 01:18:13.000000', 'consum', 0.0216, 'lps'),
	(416814, 126, '2015-02-15 01:18:14.000000', 'consum', 0.0214, 'lps'),
	(416815, 126, '2015-02-15 01:18:15.000000', 'consum', 0.0210, 'lps'),
	(416816, 126, '2015-02-15 01:18:16.000000', 'consum', 0.0213, 'lps'),
	(416817, 126, '2015-02-15 01:18:17.000000', 'consum', 0.0213, 'lps'),
	(416818, 126, '2015-02-15 01:18:18.000000', 'consum', 0.0216, 'lps'),
	(416819, 126, '2015-02-15 01:18:19.000000', 'consum', 0.0217, 'lps'),
	(416820, 126, '2015-02-15 01:18:20.000000', 'consum', 0.0212, 'lps'),
	(416821, 126, '2015-02-15 01:18:21.000000', 'consum', 0.0215, 'lps'),
	(416822, 126, '2015-02-15 01:18:22.000000', 'consum', 0.0215, 'lps'),
	(416823, 126, '2015-02-15 01:18:23.000000', 'consum', 0.0220, 'lps'),
	(416824, 126, '2015-02-15 01:18:24.000000', 'consum', 0.0217, 'lps'),
	(416825, 126, '2015-02-15 01:18:25.000000', 'consum', 0.0218, 'lps'),
	(416826, 126, '2015-02-15 01:18:26.000000', 'consum', 0.0213, 'lps'),
	(416827, 126, '2015-02-15 01:18:27.000000', 'consum', 0.0216, 'lps'),
	(416828, 126, '2015-02-15 01:18:28.000000', 'consum', 0.0216, 'lps'),
	(416829, 126, '2015-02-15 01:18:29.000000', 'consum', 0.0211, 'lps'),
	(416830, 126, '2015-02-15 01:18:30.000000', 'consum', 0.0210, 'lps'),
	(416831, 126, '2015-02-15 01:18:31.000000', 'consum', 0.0210, 'lps'),
	(416832, 126, '2015-02-15 01:18:32.000000', 'consum', 0.0221, 'lps'),
	(416833, 126, '2015-02-15 01:18:33.000000', 'consum', 0.0212, 'lps'),
	(416834, 126, '2015-02-15 01:18:34.000000', 'consum', 0.0214, 'lps'),
	(416835, 126, '2015-02-15 01:18:35.000000', 'consum', 0.0212, 'lps'),
	(416836, 126, '2015-02-15 01:18:36.000000', 'consum', 0.0210, 'lps'),
	(416837, 126, '2015-02-15 01:18:37.000000', 'consum', 0.0215, 'lps'),
	(416838, 126, '2015-02-15 01:18:38.000000', 'consum', 0.0210, 'lps'),
	(416839, 126, '2015-02-15 01:18:39.000000', 'consum', 0.0222, 'lps'),
	(416840, 126, '2015-02-15 01:18:40.000000', 'consum', 0.0215, 'lps'),
	(416841, 126, '2015-02-15 01:18:41.000000', 'consum', 0.0213, 'lps'),
	(416842, 126, '2015-02-15 01:18:42.000000', 'consum', 0.0210, 'lps'),
	(416843, 126, '2015-02-15 01:18:43.000000', 'consum', 0.0215, 'lps'),
	(416844, 126, '2015-02-15 01:18:44.000000', 'consum', 0.0222, 'lps'),
	(416845, 126, '2015-02-15 01:18:45.000000', 'consum', 0.0214, 'lps'),
	(416846, 126, '2015-02-15 01:18:46.000000', 'consum', 0.0221, 'lps'),
	(416847, 126, '2015-02-15 01:18:47.000000', 'consum', 0.0213, 'lps'),
	(416848, 126, '2015-02-15 01:18:48.000000', 'consum', 0.0220, 'lps'),
	(416849, 126, '2015-02-15 01:18:49.000000', 'consum', 0.0223, 'lps'),
	(416850, 126, '2015-02-15 01:18:50.000000', 'consum', 0.0219, 'lps'),
	(416851, 126, '2015-02-15 01:18:51.000000', 'consum', 0.0218, 'lps'),
	(416852, 126, '2015-02-15 01:18:52.000000', 'consum', 0.0220, 'lps'),
	(416853, 126, '2015-02-15 01:18:53.000000', 'consum', 0.0212, 'lps'),
	(416854, 126, '2015-02-15 01:18:54.000000', 'consum', 0.0217, 'lps'),
	(416855, 126, '2015-02-15 01:18:55.000000', 'consum', 0.0210, 'lps'),
	(416856, 126, '2015-02-15 01:18:56.000000', 'consum', 0.0219, 'lps'),
	(416857, 126, '2015-02-15 01:18:57.000000', 'consum', 0.0212, 'lps'),
	(416858, 126, '2015-02-15 01:18:58.000000', 'consum', 0.0222, 'lps'),
	(416859, 126, '2015-02-15 01:18:59.000000', 'consum', 0.0221, 'lps'),
	(416860, 126, '2015-02-15 01:19:00.000000', 'consum', 0.0217, 'lps'),
	(416861, 126, '2015-02-15 01:19:01.000000', 'consum', 0.0213, 'lps'),
	(416862, 126, '2015-02-15 01:19:02.000000', 'consum', 0.0220, 'lps'),
	(416863, 126, '2015-02-15 01:19:03.000000', 'consum', 0.0221, 'lps'),
	(416864, 126, '2015-02-15 01:19:04.000000', 'consum', 0.0221, 'lps'),
	(416865, 126, '2015-02-15 01:19:05.000000', 'consum', 0.0219, 'lps'),
	(416866, 126, '2015-02-15 01:19:06.000000', 'consum', 0.0221, 'lps'),
	(416867, 126, '2015-02-15 01:19:07.000000', 'consum', 0.0214, 'lps'),
	(416868, 126, '2015-02-15 01:19:08.000000', 'consum', 0.0223, 'lps'),
	(416869, 126, '2015-02-15 01:19:09.000000', 'consum', 0.0221, 'lps'),
	(416870, 126, '2015-02-15 01:19:10.000000', 'consum', 0.0215, 'lps'),
	(416871, 126, '2015-02-15 01:19:11.000000', 'consum', 0.0214, 'lps'),
	(416872, 126, '2015-02-15 01:19:12.000000', 'consum', 0.0216, 'lps'),
	(416873, 126, '2015-02-15 01:19:13.000000', 'consum', 0.0215, 'lps'),
	(416874, 126, '2015-02-15 01:19:14.000000', 'consum', 0.0216, 'lps'),
	(416875, 126, '2015-02-15 01:19:15.000000', 'consum', 0.0212, 'lps'),
	(416876, 126, '2015-02-15 01:19:16.000000', 'consum', 0.0216, 'lps'),
	(416877, 126, '2015-02-15 01:19:17.000000', 'consum', 0.0222, 'lps'),
	(416878, 126, '2015-02-15 01:19:18.000000', 'consum', 0.0211, 'lps'),
	(416879, 126, '2015-02-15 01:19:19.000000', 'consum', 0.0222, 'lps'),
	(416880, 126, '2015-02-15 01:19:20.000000', 'consum', 0.0212, 'lps'),
	(416881, 126, '2015-02-15 01:19:21.000000', 'consum', 0.0213, 'lps'),
	(416882, 126, '2015-02-15 01:19:22.000000', 'consum', 0.0220, 'lps'),
	(416883, 126, '2015-02-15 01:19:23.000000', 'consum', 0.0223, 'lps'),
	(416884, 126, '2015-02-15 01:19:24.000000', 'consum', 0.0216, 'lps'),
	(416885, 126, '2015-02-15 01:19:25.000000', 'consum', 0.0214, 'lps'),
	(416886, 126, '2015-02-15 01:19:26.000000', 'consum', 0.0215, 'lps'),
	(416887, 126, '2015-02-15 01:19:27.000000', 'consum', 0.0222, 'lps'),
	(416888, 126, '2015-02-15 01:19:28.000000', 'consum', 0.0212, 'lps'),
	(416889, 126, '2015-02-15 01:19:29.000000', 'consum', 0.0215, 'lps'),
	(416890, 126, '2015-02-15 01:19:30.000000', 'consum', 0.0215, 'lps'),
	(416891, 126, '2015-02-15 01:19:31.000000', 'consum', 0.0222, 'lps'),
	(416892, 126, '2015-02-15 01:19:32.000000', 'consum', 0.0212, 'lps'),
	(416893, 126, '2015-02-15 01:19:33.000000', 'consum', 0.0213, 'lps'),
	(416894, 126, '2015-02-15 01:19:34.000000', 'consum', 0.0218, 'lps'),
	(416895, 126, '2015-02-15 01:19:35.000000', 'consum', 0.0213, 'lps'),
	(416896, 126, '2015-02-15 01:19:36.000000', 'consum', 0.0215, 'lps'),
	(416897, 126, '2015-02-15 01:19:37.000000', 'consum', 0.0213, 'lps'),
	(416898, 126, '2015-02-15 01:19:38.000000', 'consum', 0.0213, 'lps'),
	(416899, 126, '2015-02-15 01:19:39.000000', 'consum', 0.0214, 'lps'),
	(416900, 126, '2015-02-15 01:19:40.000000', 'consum', 0.0223, 'lps'),
	(416901, 126, '2015-02-15 01:19:41.000000', 'consum', 0.0222, 'lps'),
	(416902, 126, '2015-02-15 01:19:42.000000', 'consum', 0.0215, 'lps'),
	(416903, 126, '2015-02-15 01:19:43.000000', 'consum', 0.0215, 'lps'),
	(416904, 126, '2015-02-15 01:19:44.000000', 'consum', 0.0218, 'lps'),
	(416905, 126, '2015-02-15 01:19:45.000000', 'consum', 0.0210, 'lps'),
	(416906, 126, '2015-02-15 01:19:46.000000', 'consum', 0.0215, 'lps'),
	(416907, 126, '2015-02-15 01:19:47.000000', 'consum', 0.0220, 'lps'),
	(416908, 126, '2015-02-15 01:19:48.000000', 'consum', 0.0216, 'lps'),
	(416909, 126, '2015-02-15 01:19:49.000000', 'consum', 0.0212, 'lps'),
	(416910, 126, '2015-02-15 01:19:50.000000', 'consum', 0.0218, 'lps'),
	(416911, 126, '2015-02-15 01:19:51.000000', 'consum', 0.0214, 'lps'),
	(416912, 126, '2015-02-15 01:19:52.000000', 'consum', 0.0220, 'lps'),
	(416913, 126, '2015-02-15 01:19:53.000000', 'consum', 0.0220, 'lps'),
	(416914, 126, '2015-02-15 01:19:54.000000', 'consum', 0.0217, 'lps'),
	(416915, 126, '2015-02-15 01:19:55.000000', 'consum', 0.0217, 'lps'),
	(416916, 126, '2015-02-15 01:19:56.000000', 'consum', 0.0211, 'lps'),
	(416917, 126, '2015-02-15 01:19:57.000000', 'consum', 0.0220, 'lps'),
	(416918, 126, '2015-02-15 01:19:58.000000', 'consum', 0.0216, 'lps'),
	(416919, 126, '2015-02-15 01:19:59.000000', 'consum', 0.0211, 'lps'),
	(416920, 126, '2015-02-15 01:20:00.000000', 'consum', 0.0210, 'lps'),
	(416921, 126, '2015-02-15 01:20:01.000000', 'consum', 0.0222, 'lps'),
	(416922, 126, '2015-02-15 01:20:02.000000', 'consum', 0.0217, 'lps'),
	(416923, 126, '2015-02-15 01:20:03.000000', 'consum', 0.0221, 'lps'),
	(416924, 126, '2015-02-15 01:20:04.000000', 'consum', 0.0218, 'lps'),
	(416925, 126, '2015-02-15 01:20:05.000000', 'consum', 0.0216, 'lps'),
	(416926, 126, '2015-02-15 01:20:06.000000', 'consum', 0.0215, 'lps'),
	(416927, 126, '2015-02-15 01:20:07.000000', 'consum', 0.0219, 'lps'),
	(416928, 126, '2015-02-15 01:20:08.000000', 'consum', 0.0213, 'lps'),
	(416929, 126, '2015-02-15 01:20:09.000000', 'consum', 0.0214, 'lps'),
	(416930, 126, '2015-02-15 01:20:10.000000', 'consum', 0.0221, 'lps'),
	(416931, 126, '2015-02-15 01:20:11.000000', 'consum', 0.0212, 'lps'),
	(416932, 126, '2015-02-15 01:20:12.000000', 'consum', 0.0216, 'lps'),
	(416933, 126, '2015-02-15 01:20:13.000000', 'consum', 0.0220, 'lps'),
	(416934, 126, '2015-02-15 01:20:14.000000', 'consum', 0.0214, 'lps'),
	(416935, 126, '2015-02-15 01:20:15.000000', 'consum', 0.0215, 'lps'),
	(416936, 126, '2015-02-15 01:20:16.000000', 'consum', 0.0211, 'lps'),
	(416937, 126, '2015-02-15 01:20:17.000000', 'consum', 0.0213, 'lps'),
	(416938, 126, '2015-02-15 01:20:18.000000', 'consum', 0.0221, 'lps'),
	(416939, 126, '2015-02-15 01:20:19.000000', 'consum', 0.0217, 'lps'),
	(416940, 126, '2015-02-15 01:20:20.000000', 'consum', 0.0212, 'lps'),
	(416941, 126, '2015-02-15 01:20:21.000000', 'consum', 0.0213, 'lps'),
	(416942, 126, '2015-02-15 01:20:22.000000', 'consum', 0.0221, 'lps'),
	(416943, 126, '2015-02-15 01:20:23.000000', 'consum', 0.0214, 'lps'),
	(416944, 126, '2015-02-15 01:20:24.000000', 'consum', 0.0223, 'lps'),
	(416945, 126, '2015-02-15 01:20:25.000000', 'consum', 0.0223, 'lps'),
	(416946, 126, '2015-02-15 01:20:26.000000', 'consum', 0.0210, 'lps'),
	(416947, 126, '2015-02-15 01:20:27.000000', 'consum', 0.0213, 'lps'),
	(416948, 126, '2015-02-15 01:20:28.000000', 'consum', 0.0210, 'lps'),
	(416949, 126, '2015-02-15 01:20:29.000000', 'consum', 0.0217, 'lps'),
	(416950, 126, '2015-02-15 01:20:30.000000', 'consum', 0.0215, 'lps'),
	(416951, 126, '2015-02-15 01:20:31.000000', 'consum', 0.0218, 'lps'),
	(416952, 126, '2015-02-15 01:20:32.000000', 'consum', 0.0218, 'lps'),
	(416953, 126, '2015-02-15 01:20:33.000000', 'consum', 0.0216, 'lps'),
	(416954, 126, '2015-02-15 01:20:34.000000', 'consum', 0.0214, 'lps'),
	(416955, 126, '2015-02-15 01:20:35.000000', 'consum', 0.0211, 'lps'),
	(416956, 126, '2015-02-15 01:20:36.000000', 'consum', 0.0220, 'lps'),
	(416957, 126, '2015-02-15 01:20:37.000000', 'consum', 0.0215, 'lps'),
	(416958, 126, '2015-02-15 01:20:38.000000', 'consum', 0.0218, 'lps'),
	(416959, 126, '2015-02-15 01:20:39.000000', 'consum', 0.0222, 'lps'),
	(416960, 126, '2015-02-15 01:20:40.000000', 'consum', 0.0217, 'lps'),
	(416961, 126, '2015-02-15 01:20:41.000000', 'consum', 0.0210, 'lps'),
	(416962, 126, '2015-02-15 01:20:42.000000', 'consum', 0.0217, 'lps'),
	(416963, 126, '2015-02-15 01:20:43.000000', 'consum', 0.0220, 'lps'),
	(416964, 126, '2015-02-15 01:20:44.000000', 'consum', 0.0211, 'lps'),
	(416965, 126, '2015-02-15 01:20:45.000000', 'consum', 0.0211, 'lps'),
	(416966, 126, '2015-02-15 01:20:46.000000', 'consum', 0.0215, 'lps'),
	(416967, 126, '2015-02-15 01:20:47.000000', 'consum', 0.0219, 'lps'),
	(416968, 126, '2015-02-15 01:20:48.000000', 'consum', 0.0214, 'lps'),
	(416969, 126, '2015-02-15 01:20:49.000000', 'consum', 0.0214, 'lps'),
	(416970, 126, '2015-02-15 01:20:50.000000', 'consum', 0.0221, 'lps'),
	(416971, 126, '2015-02-15 01:20:51.000000', 'consum', 0.0223, 'lps'),
	(416972, 126, '2015-02-15 01:20:52.000000', 'consum', 0.0216, 'lps'),
	(416973, 126, '2015-02-15 01:20:53.000000', 'consum', 0.0214, 'lps'),
	(416974, 126, '2015-02-15 01:20:54.000000', 'consum', 0.0212, 'lps'),
	(416975, 126, '2015-02-15 01:20:55.000000', 'consum', 0.0223, 'lps'),
	(416976, 126, '2015-02-15 01:20:56.000000', 'consum', 0.0216, 'lps'),
	(416977, 126, '2015-02-15 01:20:57.000000', 'consum', 0.0214, 'lps'),
	(416978, 126, '2015-02-15 01:20:58.000000', 'consum', 0.0212, 'lps'),
	(416979, 126, '2015-02-15 01:20:59.000000', 'consum', 0.0222, 'lps'),
	(416980, 126, '2015-02-15 01:21:00.000000', 'consum', 0.0223, 'lps'),
	(416981, 126, '2015-02-15 01:21:01.000000', 'consum', 0.0212, 'lps'),
	(416982, 126, '2015-02-15 01:21:02.000000', 'consum', 0.0221, 'lps'),
	(416983, 126, '2015-02-15 01:21:03.000000', 'consum', 0.0219, 'lps'),
	(416984, 126, '2015-02-15 01:21:04.000000', 'consum', 0.0210, 'lps'),
	(416985, 126, '2015-02-15 01:21:05.000000', 'consum', 0.0223, 'lps'),
	(416986, 126, '2015-02-15 01:21:06.000000', 'consum', 0.0220, 'lps'),
	(416987, 126, '2015-02-15 01:21:07.000000', 'consum', 0.0223, 'lps'),
	(416988, 126, '2015-02-15 01:21:08.000000', 'consum', 0.0218, 'lps'),
	(416989, 126, '2015-02-15 01:21:09.000000', 'consum', 0.0212, 'lps'),
	(416990, 126, '2015-02-15 01:21:10.000000', 'consum', 0.0210, 'lps'),
	(416991, 126, '2015-02-15 01:21:11.000000', 'consum', 0.0217, 'lps'),
	(416992, 126, '2015-02-15 01:21:12.000000', 'consum', 0.0218, 'lps'),
	(416993, 126, '2015-02-15 01:21:13.000000', 'consum', 0.0215, 'lps'),
	(416994, 126, '2015-02-15 01:21:14.000000', 'consum', 0.0214, 'lps'),
	(416995, 126, '2015-02-15 01:21:15.000000', 'consum', 0.0213, 'lps'),
	(416996, 126, '2015-02-15 01:21:16.000000', 'consum', 0.0216, 'lps'),
	(416997, 126, '2015-02-15 01:21:17.000000', 'consum', 0.0215, 'lps'),
	(416998, 126, '2015-02-15 01:21:18.000000', 'consum', 0.0218, 'lps'),
	(416999, 126, '2015-02-15 01:21:19.000000', 'consum', 0.0223, 'lps'),
	(417000, 126, '2015-02-15 01:21:20.000000', 'consum', 0.0221, 'lps'),
	(417001, 126, '2015-02-15 01:21:21.000000', 'consum', 0.0212, 'lps'),
	(417002, 126, '2015-02-15 01:21:22.000000', 'consum', 0.0216, 'lps'),
	(417003, 126, '2015-02-15 01:21:23.000000', 'consum', 0.0219, 'lps'),
	(417004, 126, '2015-02-15 01:21:24.000000', 'consum', 0.0212, 'lps'),
	(417005, 126, '2015-02-15 01:21:25.000000', 'consum', 0.0223, 'lps'),
	(417006, 126, '2015-02-15 01:21:26.000000', 'consum', 0.0211, 'lps'),
	(417007, 126, '2015-02-15 01:21:27.000000', 'consum', 0.0219, 'lps'),
	(417008, 126, '2015-02-15 01:21:28.000000', 'consum', 0.0223, 'lps'),
	(417009, 126, '2015-02-15 01:21:29.000000', 'consum', 0.0221, 'lps'),
	(417010, 126, '2015-02-15 01:21:30.000000', 'consum', 0.0213, 'lps'),
	(417011, 126, '2015-02-15 01:21:31.000000', 'consum', 0.0221, 'lps'),
	(417012, 126, '2015-02-15 01:21:32.000000', 'consum', 0.0214, 'lps'),
	(417013, 126, '2015-02-15 01:21:33.000000', 'consum', 0.0213, 'lps'),
	(417014, 126, '2015-02-15 01:21:34.000000', 'consum', 0.0212, 'lps'),
	(417015, 126, '2015-02-15 01:21:35.000000', 'consum', 0.0213, 'lps'),
	(417016, 126, '2015-02-15 01:21:36.000000', 'consum', 0.0218, 'lps'),
	(417017, 126, '2015-02-15 01:21:37.000000', 'consum', 0.0214, 'lps'),
	(417018, 126, '2015-02-15 01:21:38.000000', 'consum', 0.0219, 'lps'),
	(417019, 126, '2015-02-15 01:21:39.000000', 'consum', 0.0218, 'lps'),
	(417020, 126, '2015-02-15 01:21:40.000000', 'consum', 0.0210, 'lps'),
	(417021, 126, '2015-02-15 01:21:41.000000', 'consum', 0.0215, 'lps'),
	(417022, 126, '2015-02-15 01:21:42.000000', 'consum', 0.0219, 'lps'),
	(417023, 126, '2015-02-15 01:21:43.000000', 'consum', 0.0215, 'lps'),
	(417024, 126, '2015-02-15 01:21:44.000000', 'consum', 0.0220, 'lps'),
	(417025, 126, '2015-02-15 01:21:45.000000', 'consum', 0.0218, 'lps'),
	(417026, 126, '2015-02-15 01:21:46.000000', 'consum', 0.0221, 'lps'),
	(417027, 126, '2015-02-15 01:21:47.000000', 'consum', 0.0212, 'lps'),
	(417028, 126, '2015-02-15 01:21:48.000000', 'consum', 0.0219, 'lps'),
	(417029, 126, '2015-02-15 01:21:49.000000', 'consum', 0.0218, 'lps'),
	(417030, 126, '2015-02-15 01:21:50.000000', 'consum', 0.0210, 'lps'),
	(417031, 126, '2015-02-15 01:21:51.000000', 'consum', 0.0215, 'lps'),
	(417032, 126, '2015-02-15 01:21:52.000000', 'consum', 0.0223, 'lps'),
	(417033, 126, '2015-02-15 01:21:53.000000', 'consum', 0.0218, 'lps'),
	(417034, 126, '2015-02-15 01:21:54.000000', 'consum', 0.0213, 'lps'),
	(417035, 126, '2015-02-15 01:21:55.000000', 'consum', 0.0213, 'lps'),
	(417036, 126, '2015-02-15 01:21:56.000000', 'consum', 0.0219, 'lps'),
	(417037, 126, '2015-02-15 01:21:57.000000', 'consum', 0.0217, 'lps'),
	(417038, 126, '2015-02-15 01:21:58.000000', 'consum', 0.0217, 'lps'),
	(417039, 126, '2015-02-15 01:21:59.000000', 'consum', 0.0212, 'lps'),
	(417040, 126, '2015-02-15 01:22:00.000000', 'consum', 0.0213, 'lps'),
	(417041, 126, '2015-02-15 01:22:01.000000', 'consum', 0.0221, 'lps'),
	(417042, 126, '2015-02-15 01:22:02.000000', 'consum', 0.0213, 'lps'),
	(417043, 126, '2015-02-15 01:22:03.000000', 'consum', 0.0222, 'lps'),
	(417044, 126, '2015-02-15 01:22:04.000000', 'consum', 0.0219, 'lps'),
	(417045, 126, '2015-02-15 01:22:05.000000', 'consum', 0.0220, 'lps'),
	(417046, 126, '2015-02-15 01:22:06.000000', 'consum', 0.0218, 'lps'),
	(417047, 126, '2015-02-15 01:22:07.000000', 'consum', 0.0223, 'lps'),
	(417048, 126, '2015-02-15 01:22:08.000000', 'consum', 0.0222, 'lps'),
	(417049, 126, '2015-02-15 01:22:09.000000', 'consum', 0.0216, 'lps'),
	(417050, 126, '2015-02-15 01:22:10.000000', 'consum', 0.0218, 'lps'),
	(417051, 126, '2015-02-15 01:22:11.000000', 'consum', 0.0220, 'lps'),
	(417052, 126, '2015-02-15 01:22:12.000000', 'consum', 0.0223, 'lps'),
	(417053, 126, '2015-02-15 01:22:13.000000', 'consum', 0.0218, 'lps'),
	(417054, 126, '2015-02-15 01:22:14.000000', 'consum', 0.0212, 'lps'),
	(417055, 126, '2015-02-15 01:22:15.000000', 'consum', 0.0222, 'lps'),
	(417056, 126, '2015-02-15 01:22:16.000000', 'consum', 0.0211, 'lps'),
	(417057, 126, '2015-02-15 01:22:17.000000', 'consum', 0.0219, 'lps'),
	(417058, 126, '2015-02-15 01:22:18.000000', 'consum', 0.0213, 'lps'),
	(417059, 126, '2015-02-15 01:22:19.000000', 'consum', 0.0211, 'lps'),
	(417060, 126, '2015-02-15 01:22:20.000000', 'consum', 0.0223, 'lps'),
	(417061, 126, '2015-02-15 01:22:21.000000', 'consum', 0.0215, 'lps'),
	(417062, 126, '2015-02-15 01:22:22.000000', 'consum', 0.0210, 'lps'),
	(417063, 126, '2015-02-15 01:22:23.000000', 'consum', 0.0210, 'lps'),
	(417064, 126, '2015-02-15 01:22:24.000000', 'consum', 0.0211, 'lps'),
	(417065, 126, '2015-02-15 01:22:25.000000', 'consum', 0.0213, 'lps'),
	(417066, 126, '2015-02-15 01:22:26.000000', 'consum', 0.0211, 'lps'),
	(417067, 126, '2015-02-15 01:22:27.000000', 'consum', 0.0221, 'lps'),
	(417068, 126, '2015-02-15 01:22:28.000000', 'consum', 0.0222, 'lps'),
	(417069, 126, '2015-02-15 01:22:29.000000', 'consum', 0.0221, 'lps'),
	(417070, 126, '2015-02-15 01:22:30.000000', 'consum', 0.0215, 'lps'),
	(417071, 126, '2015-02-15 01:22:31.000000', 'consum', 0.0216, 'lps'),
	(417072, 126, '2015-02-15 01:22:32.000000', 'consum', 0.0213, 'lps'),
	(417073, 126, '2015-02-15 01:22:33.000000', 'consum', 0.0221, 'lps'),
	(417074, 126, '2015-02-15 01:22:34.000000', 'consum', 0.0216, 'lps'),
	(417075, 126, '2015-02-15 01:22:35.000000', 'consum', 0.0222, 'lps'),
	(417076, 126, '2015-02-15 01:22:36.000000', 'consum', 0.0210, 'lps'),
	(417077, 126, '2015-02-15 01:22:37.000000', 'consum', 0.0217, 'lps'),
	(417078, 126, '2015-02-15 01:22:38.000000', 'consum', 0.0215, 'lps'),
	(417079, 126, '2015-02-15 01:22:39.000000', 'consum', 0.0217, 'lps'),
	(417080, 126, '2015-02-15 01:22:40.000000', 'consum', 0.0215, 'lps'),
	(417081, 126, '2015-02-15 01:22:41.000000', 'consum', 0.0215, 'lps'),
	(417082, 126, '2015-02-15 01:22:42.000000', 'consum', 0.0221, 'lps'),
	(417083, 126, '2015-02-15 01:22:43.000000', 'consum', 0.0221, 'lps'),
	(417084, 126, '2015-02-15 01:22:44.000000', 'consum', 0.0219, 'lps'),
	(417085, 126, '2015-02-15 01:22:45.000000', 'consum', 0.0223, 'lps'),
	(417086, 126, '2015-02-15 01:22:46.000000', 'consum', 0.0220, 'lps'),
	(417087, 126, '2015-02-15 01:22:47.000000', 'consum', 0.0221, 'lps'),
	(417088, 126, '2015-02-15 01:22:48.000000', 'consum', 0.0223, 'lps'),
	(417089, 126, '2015-02-15 01:22:49.000000', 'consum', 0.0215, 'lps'),
	(417090, 126, '2015-02-15 01:22:50.000000', 'consum', 0.0223, 'lps'),
	(417091, 126, '2015-02-15 01:22:51.000000', 'consum', 0.0220, 'lps'),
	(417092, 126, '2015-02-15 01:22:52.000000', 'consum', 0.0222, 'lps'),
	(417093, 126, '2015-02-15 01:22:53.000000', 'consum', 0.0213, 'lps'),
	(417094, 126, '2015-02-15 01:22:54.000000', 'consum', 0.0218, 'lps'),
	(417095, 126, '2015-02-15 01:22:55.000000', 'consum', 0.0213, 'lps'),
	(417096, 126, '2015-02-15 01:22:56.000000', 'consum', 0.0216, 'lps'),
	(417097, 126, '2015-02-15 01:22:57.000000', 'consum', 0.0218, 'lps'),
	(417098, 126, '2015-02-15 01:22:58.000000', 'consum', 0.0220, 'lps'),
	(417099, 126, '2015-02-15 01:22:59.000000', 'consum', 0.0220, 'lps'),
	(417100, 126, '2015-02-15 01:23:00.000000', 'consum', 0.0216, 'lps'),
	(417101, 126, '2015-02-15 01:23:01.000000', 'consum', 0.0211, 'lps'),
	(417102, 126, '2015-02-15 01:23:02.000000', 'consum', 0.0211, 'lps'),
	(417103, 126, '2015-02-15 01:23:03.000000', 'consum', 0.0215, 'lps'),
	(417104, 126, '2015-02-15 01:23:04.000000', 'consum', 0.0215, 'lps'),
	(417105, 126, '2015-02-15 01:23:05.000000', 'consum', 0.0223, 'lps'),
	(417106, 126, '2015-02-15 01:23:06.000000', 'consum', 0.0218, 'lps'),
	(417107, 126, '2015-02-15 01:23:07.000000', 'consum', 0.0223, 'lps'),
	(417108, 126, '2015-02-15 01:23:08.000000', 'consum', 0.0212, 'lps'),
	(417109, 126, '2015-02-15 01:23:09.000000', 'consum', 0.0210, 'lps'),
	(417110, 126, '2015-02-15 01:23:10.000000', 'consum', 0.0220, 'lps'),
	(417111, 126, '2015-02-15 01:23:11.000000', 'consum', 0.0216, 'lps'),
	(417112, 126, '2015-02-15 01:23:12.000000', 'consum', 0.0210, 'lps'),
	(417113, 126, '2015-02-15 01:23:13.000000', 'consum', 0.0221, 'lps'),
	(417114, 126, '2015-02-15 01:23:14.000000', 'consum', 0.0223, 'lps'),
	(417115, 126, '2015-02-15 01:23:15.000000', 'consum', 0.0217, 'lps'),
	(417116, 126, '2015-02-15 01:23:16.000000', 'consum', 0.0219, 'lps'),
	(417117, 126, '2015-02-15 01:23:17.000000', 'consum', 0.0220, 'lps'),
	(417118, 126, '2015-02-15 01:23:18.000000', 'consum', 0.0220, 'lps'),
	(417119, 126, '2015-02-15 01:23:19.000000', 'consum', 0.0215, 'lps'),
	(417120, 126, '2015-02-15 01:23:20.000000', 'consum', 0.0220, 'lps'),
	(417121, 126, '2015-02-15 01:23:21.000000', 'consum', 0.0217, 'lps'),
	(417122, 126, '2015-02-15 01:23:22.000000', 'consum', 0.0215, 'lps'),
	(417123, 126, '2015-02-15 01:23:23.000000', 'consum', 0.0216, 'lps'),
	(417124, 126, '2015-02-15 01:23:24.000000', 'consum', 0.0211, 'lps'),
	(417125, 126, '2015-02-15 01:23:25.000000', 'consum', 0.0212, 'lps'),
	(417126, 126, '2015-02-15 01:23:26.000000', 'consum', 0.0219, 'lps'),
	(417127, 126, '2015-02-15 01:23:27.000000', 'consum', 0.0219, 'lps'),
	(417128, 126, '2015-02-15 01:23:28.000000', 'consum', 0.0213, 'lps'),
	(417129, 126, '2015-02-15 01:23:29.000000', 'consum', 0.0215, 'lps'),
	(417130, 126, '2015-02-15 01:23:30.000000', 'consum', 0.0213, 'lps'),
	(417131, 126, '2015-02-15 01:23:31.000000', 'consum', 0.0222, 'lps'),
	(417132, 126, '2015-02-15 01:23:32.000000', 'consum', 0.0221, 'lps'),
	(417133, 126, '2015-02-15 01:23:33.000000', 'consum', 0.0216, 'lps'),
	(417134, 126, '2015-02-15 01:23:34.000000', 'consum', 0.0222, 'lps'),
	(417135, 126, '2015-02-15 01:23:35.000000', 'consum', 0.0210, 'lps'),
	(417136, 126, '2015-02-15 01:23:36.000000', 'consum', 0.0218, 'lps'),
	(417137, 126, '2015-02-15 01:23:37.000000', 'consum', 0.0220, 'lps'),
	(417138, 126, '2015-02-15 01:23:38.000000', 'consum', 0.0223, 'lps'),
	(417139, 126, '2015-02-15 01:23:39.000000', 'consum', 0.0216, 'lps'),
	(417140, 126, '2015-02-15 01:23:40.000000', 'consum', 0.0216, 'lps'),
	(417141, 126, '2015-02-15 01:23:41.000000', 'consum', 0.0221, 'lps'),
	(417142, 126, '2015-02-15 01:23:42.000000', 'consum', 0.0221, 'lps'),
	(417143, 126, '2015-02-15 01:23:43.000000', 'consum', 0.0219, 'lps'),
	(417144, 126, '2015-02-15 01:23:44.000000', 'consum', 0.0221, 'lps'),
	(417145, 126, '2015-02-15 01:23:45.000000', 'consum', 0.0212, 'lps'),
	(417146, 126, '2015-02-15 01:23:46.000000', 'consum', 0.0215, 'lps'),
	(417147, 126, '2015-02-15 01:23:47.000000', 'consum', 0.0217, 'lps'),
	(417148, 126, '2015-02-15 01:23:48.000000', 'consum', 0.0214, 'lps'),
	(417149, 126, '2015-02-15 01:23:49.000000', 'consum', 0.0211, 'lps'),
	(417150, 126, '2015-02-15 01:23:50.000000', 'consum', 0.0216, 'lps'),
	(417151, 126, '2015-02-15 01:23:51.000000', 'consum', 0.0223, 'lps'),
	(417152, 126, '2015-02-15 01:23:52.000000', 'consum', 0.0216, 'lps'),
	(417153, 126, '2015-02-15 01:23:53.000000', 'consum', 0.0215, 'lps'),
	(417154, 126, '2015-02-15 01:23:54.000000', 'consum', 0.0216, 'lps'),
	(417155, 126, '2015-02-15 01:23:55.000000', 'consum', 0.0215, 'lps'),
	(417156, 126, '2015-02-15 01:23:56.000000', 'consum', 0.0215, 'lps'),
	(417157, 126, '2015-02-15 01:23:57.000000', 'consum', 0.0221, 'lps'),
	(417158, 126, '2015-02-15 01:23:58.000000', 'consum', 0.0222, 'lps'),
	(417159, 126, '2015-02-15 01:23:59.000000', 'consum', 0.0222, 'lps'),
	(417160, 126, '2015-02-15 01:24:00.000000', 'consum', 0.0223, 'lps'),
	(417161, 126, '2015-02-15 01:24:01.000000', 'consum', 0.0223, 'lps'),
	(417162, 126, '2015-02-15 01:24:02.000000', 'consum', 0.0210, 'lps'),
	(417163, 126, '2015-02-15 01:24:03.000000', 'consum', 0.0213, 'lps'),
	(417164, 126, '2015-02-15 01:24:04.000000', 'consum', 0.0212, 'lps'),
	(417165, 126, '2015-02-15 01:24:05.000000', 'consum', 0.0211, 'lps'),
	(417166, 126, '2015-02-15 01:24:06.000000', 'consum', 0.0223, 'lps'),
	(417167, 126, '2015-02-15 01:24:07.000000', 'consum', 0.0216, 'lps'),
	(417168, 126, '2015-02-15 01:24:08.000000', 'consum', 0.0214, 'lps'),
	(417169, 126, '2015-02-15 01:24:09.000000', 'consum', 0.0214, 'lps'),
	(417170, 126, '2015-02-15 01:24:10.000000', 'consum', 0.0220, 'lps'),
	(417171, 126, '2015-02-15 01:24:11.000000', 'consum', 0.0218, 'lps'),
	(417172, 126, '2015-02-15 01:24:12.000000', 'consum', 0.0220, 'lps'),
	(417173, 126, '2015-02-15 01:24:13.000000', 'consum', 0.0210, 'lps'),
	(417174, 126, '2015-02-15 01:24:14.000000', 'consum', 0.0220, 'lps'),
	(417175, 126, '2015-02-15 01:24:15.000000', 'consum', 0.0221, 'lps'),
	(417176, 126, '2015-02-15 01:24:16.000000', 'consum', 0.0219, 'lps'),
	(417177, 126, '2015-02-15 01:24:17.000000', 'consum', 0.0223, 'lps'),
	(417178, 126, '2015-02-15 01:24:18.000000', 'consum', 0.0222, 'lps'),
	(417179, 126, '2015-02-15 01:24:19.000000', 'consum', 0.0218, 'lps'),
	(417180, 126, '2015-02-15 01:24:20.000000', 'consum', 0.0216, 'lps'),
	(417181, 126, '2015-02-15 01:24:21.000000', 'consum', 0.0213, 'lps'),
	(417182, 126, '2015-02-15 01:24:22.000000', 'consum', 0.0210, 'lps'),
	(417183, 126, '2015-02-15 01:24:23.000000', 'consum', 0.0214, 'lps'),
	(417184, 126, '2015-02-15 01:24:24.000000', 'consum', 0.0218, 'lps'),
	(417185, 126, '2015-02-15 01:24:25.000000', 'consum', 0.0211, 'lps'),
	(417186, 126, '2015-02-15 01:24:26.000000', 'consum', 0.0220, 'lps'),
	(417187, 126, '2015-02-15 01:24:27.000000', 'consum', 0.0213, 'lps'),
	(417188, 126, '2015-02-15 01:24:28.000000', 'consum', 0.0210, 'lps'),
	(417189, 126, '2015-02-15 01:24:29.000000', 'consum', 0.0217, 'lps'),
	(417190, 126, '2015-02-15 01:24:30.000000', 'consum', 0.0215, 'lps'),
	(417191, 126, '2015-02-15 01:24:31.000000', 'consum', 0.0215, 'lps'),
	(417192, 126, '2015-02-15 01:24:32.000000', 'consum', 0.0222, 'lps'),
	(417193, 126, '2015-02-15 01:24:33.000000', 'consum', 0.0213, 'lps'),
	(417194, 126, '2015-02-15 01:24:34.000000', 'consum', 0.0216, 'lps'),
	(417195, 126, '2015-02-15 01:24:35.000000', 'consum', 0.0217, 'lps'),
	(417196, 126, '2015-02-15 01:24:36.000000', 'consum', 0.0216, 'lps'),
	(417197, 126, '2015-02-15 01:24:37.000000', 'consum', 0.0218, 'lps'),
	(417198, 126, '2015-02-15 01:24:38.000000', 'consum', 0.0220, 'lps'),
	(417199, 126, '2015-02-15 01:24:39.000000', 'consum', 0.0220, 'lps'),
	(417200, 126, '2015-02-15 01:24:40.000000', 'consum', 0.0219, 'lps'),
	(417201, 126, '2015-02-15 01:24:41.000000', 'consum', 0.0223, 'lps'),
	(417202, 126, '2015-02-15 01:24:42.000000', 'consum', 0.0220, 'lps'),
	(417203, 126, '2015-02-15 01:24:43.000000', 'consum', 0.0210, 'lps'),
	(417204, 126, '2015-02-15 01:24:44.000000', 'consum', 0.0221, 'lps'),
	(417205, 126, '2015-02-15 01:24:45.000000', 'consum', 0.0222, 'lps'),
	(417206, 126, '2015-02-15 01:24:46.000000', 'consum', 0.0211, 'lps'),
	(417207, 126, '2015-02-15 01:24:47.000000', 'consum', 0.0220, 'lps'),
	(417208, 126, '2015-02-15 01:24:48.000000', 'consum', 0.0218, 'lps'),
	(417209, 126, '2015-02-15 01:24:49.000000', 'consum', 0.0220, 'lps'),
	(417210, 126, '2015-02-15 01:24:50.000000', 'consum', 0.0210, 'lps'),
	(417211, 126, '2015-02-15 01:24:51.000000', 'consum', 0.0220, 'lps'),
	(417212, 126, '2015-02-15 01:24:52.000000', 'consum', 0.0219, 'lps'),
	(417213, 126, '2015-02-15 01:24:53.000000', 'consum', 0.0212, 'lps'),
	(417214, 126, '2015-02-15 01:24:54.000000', 'consum', 0.0222, 'lps'),
	(417215, 126, '2015-02-15 01:24:55.000000', 'consum', 0.0223, 'lps'),
	(417216, 126, '2015-02-15 01:24:56.000000', 'consum', 0.0211, 'lps'),
	(417217, 126, '2015-02-15 01:24:57.000000', 'consum', 0.0220, 'lps'),
	(417218, 126, '2015-02-15 01:24:58.000000', 'consum', 0.0215, 'lps'),
	(417219, 126, '2015-02-15 01:24:59.000000', 'consum', 0.0219, 'lps'),
	(417220, 126, '2015-02-15 01:25:00.000000', 'consum', 0.0214, 'lps'),
	(417221, 126, '2015-02-15 01:25:01.000000', 'consum', 0.0217, 'lps'),
	(417222, 126, '2015-02-15 01:25:02.000000', 'consum', 0.0221, 'lps'),
	(417223, 126, '2015-02-15 01:25:03.000000', 'consum', 0.0215, 'lps'),
	(417224, 126, '2015-02-15 01:25:04.000000', 'consum', 0.0216, 'lps'),
	(417225, 126, '2015-02-15 01:25:05.000000', 'consum', 0.0211, 'lps'),
	(417226, 126, '2015-02-15 01:25:06.000000', 'consum', 0.0214, 'lps'),
	(417227, 126, '2015-02-15 01:25:07.000000', 'consum', 0.0212, 'lps'),
	(417228, 126, '2015-02-15 01:25:08.000000', 'consum', 0.0210, 'lps'),
	(417229, 126, '2015-02-15 01:25:09.000000', 'consum', 0.0219, 'lps'),
	(417230, 126, '2015-02-15 01:25:10.000000', 'consum', 0.0211, 'lps'),
	(417231, 126, '2015-02-15 01:25:11.000000', 'consum', 0.0216, 'lps'),
	(417232, 126, '2015-02-15 01:25:12.000000', 'consum', 0.0212, 'lps'),
	(417233, 126, '2015-02-15 01:25:13.000000', 'consum', 0.0215, 'lps'),
	(417234, 126, '2015-02-15 01:25:14.000000', 'consum', 0.0217, 'lps'),
	(417235, 126, '2015-02-15 01:25:15.000000', 'consum', 0.0214, 'lps'),
	(417236, 126, '2015-02-15 01:25:16.000000', 'consum', 0.0212, 'lps'),
	(417237, 126, '2015-02-15 01:25:17.000000', 'consum', 0.0223, 'lps'),
	(417238, 126, '2015-02-15 01:25:18.000000', 'consum', 0.0215, 'lps'),
	(417239, 126, '2015-02-15 01:25:19.000000', 'consum', 0.0221, 'lps'),
	(417240, 126, '2015-02-15 01:25:20.000000', 'consum', 0.0223, 'lps'),
	(417241, 126, '2015-02-15 01:25:21.000000', 'consum', 0.0214, 'lps'),
	(417242, 126, '2015-02-15 01:25:22.000000', 'consum', 0.0220, 'lps'),
	(417243, 126, '2015-02-15 01:25:23.000000', 'consum', 0.0222, 'lps'),
	(417244, 126, '2015-02-15 01:25:24.000000', 'consum', 0.0210, 'lps'),
	(417245, 126, '2015-02-15 01:25:25.000000', 'consum', 0.0217, 'lps'),
	(417246, 126, '2015-02-15 01:25:26.000000', 'consum', 0.0220, 'lps'),
	(417247, 126, '2015-02-15 01:25:27.000000', 'consum', 0.0223, 'lps'),
	(417248, 126, '2015-02-15 01:25:28.000000', 'consum', 0.0220, 'lps'),
	(417249, 126, '2015-02-15 01:25:29.000000', 'consum', 0.0221, 'lps'),
	(417250, 126, '2015-02-15 01:25:30.000000', 'consum', 0.0223, 'lps'),
	(417251, 126, '2015-02-15 01:25:31.000000', 'consum', 0.0213, 'lps'),
	(417252, 126, '2015-02-15 01:25:32.000000', 'consum', 0.0213, 'lps'),
	(417253, 126, '2015-02-15 01:25:33.000000', 'consum', 0.0219, 'lps'),
	(417254, 126, '2015-02-15 01:25:34.000000', 'consum', 0.0216, 'lps'),
	(417255, 126, '2015-02-15 01:25:35.000000', 'consum', 0.0214, 'lps'),
	(417256, 126, '2015-02-15 01:25:36.000000', 'consum', 0.0212, 'lps'),
	(417257, 126, '2015-02-15 01:25:37.000000', 'consum', 0.0210, 'lps'),
	(417258, 126, '2015-02-15 01:25:38.000000', 'consum', 0.0220, 'lps'),
	(417259, 126, '2015-02-15 01:25:39.000000', 'consum', 0.0215, 'lps'),
	(417260, 126, '2015-02-15 01:25:40.000000', 'consum', 0.0220, 'lps'),
	(417261, 126, '2015-02-15 01:25:41.000000', 'consum', 0.0220, 'lps'),
	(417262, 126, '2015-02-15 01:25:42.000000', 'consum', 0.0215, 'lps'),
	(417263, 126, '2015-02-15 01:25:43.000000', 'consum', 0.0221, 'lps'),
	(417264, 126, '2015-02-15 01:25:44.000000', 'consum', 0.0222, 'lps'),
	(417265, 126, '2015-02-15 01:25:45.000000', 'consum', 0.0222, 'lps'),
	(417266, 126, '2015-02-15 01:25:46.000000', 'consum', 0.0220, 'lps'),
	(417267, 126, '2015-02-15 01:25:47.000000', 'consum', 0.0212, 'lps'),
	(417268, 126, '2015-02-15 01:25:48.000000', 'consum', 0.0217, 'lps'),
	(417269, 126, '2015-02-15 01:25:49.000000', 'consum', 0.0211, 'lps'),
	(417270, 126, '2015-02-15 01:25:50.000000', 'consum', 0.0222, 'lps'),
	(417271, 126, '2015-02-15 01:25:51.000000', 'consum', 0.0212, 'lps'),
	(417272, 126, '2015-02-15 01:25:52.000000', 'consum', 0.0215, 'lps'),
	(417273, 126, '2015-02-15 01:25:53.000000', 'consum', 0.0213, 'lps'),
	(417274, 126, '2015-02-15 01:25:54.000000', 'consum', 0.0212, 'lps'),
	(417275, 126, '2015-02-15 01:25:55.000000', 'consum', 0.0212, 'lps'),
	(417276, 126, '2015-02-15 01:25:56.000000', 'consum', 0.0212, 'lps'),
	(417277, 126, '2015-02-15 01:25:57.000000', 'consum', 0.0218, 'lps'),
	(417278, 126, '2015-02-15 01:25:58.000000', 'consum', 0.0213, 'lps'),
	(417279, 126, '2015-02-15 01:25:59.000000', 'consum', 0.0218, 'lps'),
	(417280, 126, '2015-02-15 01:26:00.000000', 'consum', 0.0211, 'lps'),
	(417281, 126, '2015-02-15 01:26:01.000000', 'consum', 0.0220, 'lps'),
	(417282, 126, '2015-02-15 01:26:02.000000', 'consum', 0.0215, 'lps'),
	(417283, 126, '2015-02-15 01:26:03.000000', 'consum', 0.0219, 'lps'),
	(417284, 126, '2015-02-15 01:26:04.000000', 'consum', 0.0214, 'lps'),
	(417285, 126, '2015-02-15 01:26:05.000000', 'consum', 0.0216, 'lps'),
	(417286, 126, '2015-02-15 01:26:06.000000', 'consum', 0.0214, 'lps'),
	(417287, 126, '2015-02-15 01:26:07.000000', 'consum', 0.0213, 'lps'),
	(417288, 126, '2015-02-15 01:26:08.000000', 'consum', 0.0213, 'lps'),
	(417289, 126, '2015-02-15 01:26:09.000000', 'consum', 0.0215, 'lps'),
	(417290, 126, '2015-02-15 01:26:10.000000', 'consum', 0.0214, 'lps'),
	(417291, 126, '2015-02-15 01:26:11.000000', 'consum', 0.0216, 'lps'),
	(417292, 126, '2015-02-15 01:26:12.000000', 'consum', 0.0212, 'lps'),
	(417293, 126, '2015-02-15 01:26:13.000000', 'consum', 0.0219, 'lps'),
	(417294, 126, '2015-02-15 01:26:14.000000', 'consum', 0.0222, 'lps'),
	(417295, 126, '2015-02-15 01:26:15.000000', 'consum', 0.0213, 'lps'),
	(417296, 126, '2015-02-15 01:26:16.000000', 'consum', 0.0219, 'lps'),
	(417297, 126, '2015-02-15 01:26:17.000000', 'consum', 0.0217, 'lps'),
	(417298, 126, '2015-02-15 01:26:18.000000', 'consum', 0.0221, 'lps'),
	(417299, 126, '2015-02-15 01:26:19.000000', 'consum', 0.0217, 'lps'),
	(417300, 126, '2015-02-15 01:26:20.000000', 'consum', 0.0210, 'lps'),
	(417301, 126, '2015-02-15 01:26:21.000000', 'consum', 0.0219, 'lps'),
	(417302, 126, '2015-02-15 01:26:22.000000', 'consum', 0.0215, 'lps'),
	(417303, 126, '2015-02-15 01:26:23.000000', 'consum', 0.0220, 'lps'),
	(417304, 126, '2015-02-15 01:26:24.000000', 'consum', 0.0219, 'lps'),
	(417305, 126, '2015-02-15 01:26:25.000000', 'consum', 0.0211, 'lps'),
	(417306, 126, '2015-02-15 01:26:26.000000', 'consum', 0.0215, 'lps'),
	(417307, 126, '2015-02-15 01:26:27.000000', 'consum', 0.0219, 'lps'),
	(417308, 126, '2015-02-15 01:26:28.000000', 'consum', 0.0212, 'lps'),
	(417309, 126, '2015-02-15 01:26:29.000000', 'consum', 0.0210, 'lps'),
	(417310, 126, '2015-02-15 01:26:30.000000', 'consum', 0.0215, 'lps'),
	(417311, 126, '2015-02-15 01:26:31.000000', 'consum', 0.0210, 'lps'),
	(417312, 126, '2015-02-15 01:26:32.000000', 'consum', 0.0210, 'lps'),
	(417313, 126, '2015-02-15 01:26:33.000000', 'consum', 0.0211, 'lps'),
	(417314, 126, '2015-02-15 01:26:34.000000', 'consum', 0.0213, 'lps'),
	(417315, 126, '2015-02-15 01:26:35.000000', 'consum', 0.0222, 'lps'),
	(417316, 126, '2015-02-15 01:26:36.000000', 'consum', 0.0222, 'lps'),
	(417317, 126, '2015-02-15 01:26:37.000000', 'consum', 0.0222, 'lps'),
	(417318, 126, '2015-02-15 01:26:38.000000', 'consum', 0.0217, 'lps'),
	(417319, 126, '2015-02-15 01:26:39.000000', 'consum', 0.0210, 'lps'),
	(417320, 126, '2015-02-15 01:26:40.000000', 'consum', 0.0219, 'lps'),
	(417321, 126, '2015-02-15 01:26:41.000000', 'consum', 0.0213, 'lps'),
	(417322, 126, '2015-02-15 01:26:42.000000', 'consum', 0.0212, 'lps'),
	(417323, 126, '2015-02-15 01:26:43.000000', 'consum', 0.0212, 'lps'),
	(417324, 126, '2015-02-15 01:26:44.000000', 'consum', 0.0214, 'lps'),
	(417325, 126, '2015-02-15 01:26:45.000000', 'consum', 0.0223, 'lps'),
	(417326, 126, '2015-02-15 01:26:46.000000', 'consum', 0.0223, 'lps'),
	(417327, 126, '2015-02-15 01:26:47.000000', 'consum', 0.0223, 'lps'),
	(417328, 126, '2015-02-15 01:26:48.000000', 'consum', 0.0221, 'lps'),
	(417329, 126, '2015-02-15 01:26:49.000000', 'consum', 0.0213, 'lps'),
	(417330, 126, '2015-02-15 01:26:50.000000', 'consum', 0.0220, 'lps'),
	(417331, 126, '2015-02-15 01:26:51.000000', 'consum', 0.0210, 'lps'),
	(417332, 126, '2015-02-15 01:26:52.000000', 'consum', 0.0210, 'lps'),
	(417333, 126, '2015-02-15 01:26:53.000000', 'consum', 0.0211, 'lps'),
	(417334, 126, '2015-02-15 01:26:54.000000', 'consum', 0.0215, 'lps'),
	(417335, 126, '2015-02-15 01:26:55.000000', 'consum', 0.0219, 'lps'),
	(417336, 126, '2015-02-15 01:26:56.000000', 'consum', 0.0211, 'lps'),
	(417337, 126, '2015-02-15 01:26:57.000000', 'consum', 0.0219, 'lps'),
	(417338, 126, '2015-02-15 01:26:58.000000', 'consum', 0.0210, 'lps'),
	(417339, 126, '2015-02-15 01:26:59.000000', 'consum', 0.0212, 'lps'),
	(417340, 126, '2015-02-15 01:27:00.000000', 'consum', 0.0218, 'lps'),
	(417341, 126, '2015-02-15 01:27:01.000000', 'consum', 0.0220, 'lps'),
	(417342, 126, '2015-02-15 01:27:02.000000', 'consum', 0.0220, 'lps'),
	(417343, 126, '2015-02-15 01:27:03.000000', 'consum', 0.0215, 'lps'),
	(417344, 126, '2015-02-15 01:27:04.000000', 'consum', 0.0222, 'lps'),
	(417345, 126, '2015-02-15 01:27:05.000000', 'consum', 0.0214, 'lps'),
	(417346, 126, '2015-02-15 01:27:06.000000', 'consum', 0.0222, 'lps'),
	(417347, 126, '2015-02-15 01:27:07.000000', 'consum', 0.0214, 'lps'),
	(417348, 126, '2015-02-15 01:27:08.000000', 'consum', 0.0211, 'lps'),
	(417349, 126, '2015-02-15 01:27:09.000000', 'consum', 0.0216, 'lps'),
	(417350, 126, '2015-02-15 01:27:10.000000', 'consum', 0.0210, 'lps'),
	(417351, 126, '2015-02-15 01:27:11.000000', 'consum', 0.0220, 'lps'),
	(417352, 126, '2015-02-15 01:27:12.000000', 'consum', 0.0220, 'lps'),
	(417353, 126, '2015-02-15 01:27:13.000000', 'consum', 0.0217, 'lps'),
	(417354, 126, '2015-02-15 01:27:14.000000', 'consum', 0.0215, 'lps'),
	(417355, 126, '2015-02-15 01:27:15.000000', 'consum', 0.0216, 'lps'),
	(417356, 126, '2015-02-15 01:27:16.000000', 'consum', 0.0223, 'lps'),
	(417357, 126, '2015-02-15 01:27:17.000000', 'consum', 0.0215, 'lps'),
	(417358, 126, '2015-02-15 01:27:18.000000', 'consum', 0.0210, 'lps'),
	(417359, 126, '2015-02-15 01:27:19.000000', 'consum', 0.0212, 'lps'),
	(417360, 126, '2015-02-15 01:27:20.000000', 'consum', 0.0218, 'lps'),
	(417361, 126, '2015-02-15 01:27:21.000000', 'consum', 0.0218, 'lps'),
	(417362, 126, '2015-02-15 01:27:22.000000', 'consum', 0.0210, 'lps'),
	(417363, 126, '2015-02-15 01:27:23.000000', 'consum', 0.0217, 'lps'),
	(417364, 126, '2015-02-15 01:27:24.000000', 'consum', 0.0218, 'lps'),
	(417365, 126, '2015-02-15 01:27:25.000000', 'consum', 0.0213, 'lps'),
	(417366, 126, '2015-02-15 01:27:26.000000', 'consum', 0.0217, 'lps'),
	(417367, 126, '2015-02-15 01:27:27.000000', 'consum', 0.0210, 'lps'),
	(417368, 126, '2015-02-15 01:27:28.000000', 'consum', 0.0216, 'lps'),
	(417369, 126, '2015-02-15 01:27:29.000000', 'consum', 0.0212, 'lps'),
	(417370, 126, '2015-02-15 01:27:30.000000', 'consum', 0.0216, 'lps'),
	(417371, 126, '2015-02-15 01:27:31.000000', 'consum', 0.0221, 'lps'),
	(417372, 126, '2015-02-15 01:27:32.000000', 'consum', 0.0221, 'lps'),
	(417373, 126, '2015-02-15 01:27:33.000000', 'consum', 0.0217, 'lps'),
	(417374, 126, '2015-02-15 01:27:34.000000', 'consum', 0.0214, 'lps'),
	(417375, 126, '2015-02-15 01:27:35.000000', 'consum', 0.0221, 'lps'),
	(417376, 126, '2015-02-15 01:27:36.000000', 'consum', 0.0213, 'lps'),
	(417377, 126, '2015-02-15 01:27:37.000000', 'consum', 0.0218, 'lps'),
	(417378, 126, '2015-02-15 01:27:38.000000', 'consum', 0.0217, 'lps'),
	(417379, 126, '2015-02-15 01:27:39.000000', 'consum', 0.0219, 'lps'),
	(417380, 126, '2015-02-15 01:27:40.000000', 'consum', 0.0220, 'lps'),
	(417381, 126, '2015-02-15 01:27:41.000000', 'consum', 0.0221, 'lps'),
	(417382, 126, '2015-02-15 01:27:42.000000', 'consum', 0.0221, 'lps'),
	(417383, 126, '2015-02-15 01:27:43.000000', 'consum', 0.0220, 'lps'),
	(417384, 126, '2015-02-15 01:27:44.000000', 'consum', 0.0211, 'lps'),
	(417385, 126, '2015-02-15 01:27:45.000000', 'consum', 0.0216, 'lps'),
	(417386, 126, '2015-02-15 01:27:46.000000', 'consum', 0.0210, 'lps'),
	(417387, 126, '2015-02-15 01:27:47.000000', 'consum', 0.0220, 'lps'),
	(417388, 126, '2015-02-15 01:27:48.000000', 'consum', 0.0216, 'lps'),
	(417389, 126, '2015-02-15 01:27:49.000000', 'consum', 0.0212, 'lps'),
	(417390, 126, '2015-02-15 01:27:50.000000', 'consum', 0.0216, 'lps'),
	(417391, 126, '2015-02-15 01:27:51.000000', 'consum', 0.0220, 'lps'),
	(417392, 126, '2015-02-15 01:27:52.000000', 'consum', 0.0213, 'lps'),
	(417393, 126, '2015-02-15 01:27:53.000000', 'consum', 0.0211, 'lps'),
	(417394, 126, '2015-02-15 01:27:54.000000', 'consum', 0.0219, 'lps'),
	(417395, 126, '2015-02-15 01:27:55.000000', 'consum', 0.0212, 'lps'),
	(417396, 126, '2015-02-15 01:27:56.000000', 'consum', 0.0222, 'lps'),
	(417397, 126, '2015-02-15 01:27:57.000000', 'consum', 0.0223, 'lps'),
	(417398, 126, '2015-02-15 01:27:58.000000', 'consum', 0.0212, 'lps'),
	(417399, 126, '2015-02-15 01:27:59.000000', 'consum', 0.0223, 'lps'),
	(417400, 126, '2015-02-15 01:28:00.000000', 'consum', 0.0214, 'lps'),
	(417401, 126, '2015-02-15 01:28:01.000000', 'consum', 0.0221, 'lps'),
	(417402, 126, '2015-02-15 01:28:02.000000', 'consum', 0.0223, 'lps'),
	(417403, 126, '2015-02-15 01:28:03.000000', 'consum', 0.0217, 'lps'),
	(417404, 126, '2015-02-15 01:28:04.000000', 'consum', 0.0219, 'lps'),
	(417405, 126, '2015-02-15 01:28:05.000000', 'consum', 0.0219, 'lps'),
	(417406, 126, '2015-02-15 01:28:06.000000', 'consum', 0.0215, 'lps'),
	(417407, 126, '2015-02-15 01:28:07.000000', 'consum', 0.0221, 'lps'),
	(417408, 126, '2015-02-15 01:28:08.000000', 'consum', 0.0210, 'lps'),
	(417409, 126, '2015-02-15 01:28:09.000000', 'consum', 0.0219, 'lps'),
	(417410, 126, '2015-02-15 01:28:10.000000', 'consum', 0.0214, 'lps'),
	(417411, 126, '2015-02-15 01:28:11.000000', 'consum', 0.0215, 'lps'),
	(417412, 126, '2015-02-15 01:28:12.000000', 'consum', 0.0212, 'lps'),
	(417413, 126, '2015-02-15 01:28:13.000000', 'consum', 0.0221, 'lps'),
	(417414, 126, '2015-02-15 01:28:14.000000', 'consum', 0.0216, 'lps'),
	(417415, 126, '2015-02-15 01:28:15.000000', 'consum', 0.0219, 'lps'),
	(417416, 126, '2015-02-15 01:28:16.000000', 'consum', 0.0213, 'lps'),
	(417417, 126, '2015-02-15 01:28:17.000000', 'consum', 0.0211, 'lps'),
	(417418, 126, '2015-02-15 01:28:18.000000', 'consum', 0.0221, 'lps'),
	(417419, 126, '2015-02-15 01:28:19.000000', 'consum', 0.0218, 'lps'),
	(417420, 126, '2015-02-15 01:28:20.000000', 'consum', 0.0221, 'lps'),
	(417421, 126, '2015-02-15 01:28:21.000000', 'consum', 0.0211, 'lps'),
	(417422, 126, '2015-02-15 01:28:22.000000', 'consum', 0.0212, 'lps'),
	(417423, 126, '2015-02-15 01:28:23.000000', 'consum', 0.0219, 'lps'),
	(417424, 126, '2015-02-15 01:28:24.000000', 'consum', 0.0219, 'lps'),
	(417425, 126, '2015-02-15 01:28:25.000000', 'consum', 0.0216, 'lps'),
	(417426, 126, '2015-02-15 01:28:26.000000', 'consum', 0.0211, 'lps'),
	(417427, 126, '2015-02-15 01:28:27.000000', 'consum', 0.0215, 'lps'),
	(417428, 126, '2015-02-15 01:28:28.000000', 'consum', 0.0217, 'lps'),
	(417429, 126, '2015-02-15 01:28:29.000000', 'consum', 0.0216, 'lps'),
	(417430, 126, '2015-02-15 01:28:30.000000', 'consum', 0.0220, 'lps'),
	(417431, 126, '2015-02-15 01:28:31.000000', 'consum', 0.0215, 'lps'),
	(417432, 126, '2015-02-15 01:28:32.000000', 'consum', 0.0221, 'lps'),
	(417433, 126, '2015-02-15 01:28:33.000000', 'consum', 0.0219, 'lps'),
	(417434, 126, '2015-02-15 01:28:34.000000', 'consum', 0.0212, 'lps'),
	(417435, 126, '2015-02-15 01:28:35.000000', 'consum', 0.0220, 'lps'),
	(417436, 126, '2015-02-15 01:28:36.000000', 'consum', 0.0214, 'lps'),
	(417437, 126, '2015-02-15 01:28:37.000000', 'consum', 0.0216, 'lps'),
	(417438, 126, '2015-02-15 01:28:38.000000', 'consum', 0.0211, 'lps'),
	(417439, 126, '2015-02-15 01:28:39.000000', 'consum', 0.0214, 'lps'),
	(417440, 126, '2015-02-15 01:28:40.000000', 'consum', 0.0212, 'lps'),
	(417441, 126, '2015-02-15 01:28:41.000000', 'consum', 0.0222, 'lps'),
	(417442, 126, '2015-02-15 01:28:42.000000', 'consum', 0.0222, 'lps'),
	(417443, 126, '2015-02-15 01:28:43.000000', 'consum', 0.0221, 'lps'),
	(417444, 126, '2015-02-15 01:28:44.000000', 'consum', 0.0217, 'lps'),
	(417445, 126, '2015-02-15 01:28:45.000000', 'consum', 0.0212, 'lps'),
	(417446, 126, '2015-02-15 01:28:46.000000', 'consum', 0.0211, 'lps'),
	(417447, 126, '2015-02-15 01:28:47.000000', 'consum', 0.0212, 'lps'),
	(417448, 126, '2015-02-15 01:28:48.000000', 'consum', 0.0216, 'lps'),
	(417449, 126, '2015-02-15 01:28:49.000000', 'consum', 0.0220, 'lps'),
	(417450, 126, '2015-02-15 01:28:50.000000', 'consum', 0.0215, 'lps'),
	(417451, 126, '2015-02-15 01:28:51.000000', 'consum', 0.0220, 'lps'),
	(417452, 126, '2015-02-15 01:28:52.000000', 'consum', 0.0217, 'lps'),
	(417453, 126, '2015-02-15 01:28:53.000000', 'consum', 0.0217, 'lps'),
	(417454, 126, '2015-02-15 01:28:54.000000', 'consum', 0.0221, 'lps'),
	(417455, 126, '2015-02-15 01:28:55.000000', 'consum', 0.0220, 'lps'),
	(417456, 126, '2015-02-15 01:28:56.000000', 'consum', 0.0214, 'lps'),
	(417457, 126, '2015-02-15 01:28:57.000000', 'consum', 0.0214, 'lps'),
	(417458, 126, '2015-02-15 01:28:58.000000', 'consum', 0.0218, 'lps'),
	(417459, 126, '2015-02-15 01:28:59.000000', 'consum', 0.0212, 'lps'),
	(417460, 126, '2015-02-15 01:29:00.000000', 'consum', 0.0212, 'lps'),
	(417461, 126, '2015-02-15 01:29:01.000000', 'consum', 0.0211, 'lps'),
	(417462, 126, '2015-02-15 01:29:02.000000', 'consum', 0.0210, 'lps'),
	(417463, 126, '2015-02-15 01:29:03.000000', 'consum', 0.0223, 'lps'),
	(417464, 126, '2015-02-15 01:29:04.000000', 'consum', 0.0218, 'lps'),
	(417465, 126, '2015-02-15 01:29:05.000000', 'consum', 0.0212, 'lps'),
	(417466, 126, '2015-02-15 01:29:06.000000', 'consum', 0.0211, 'lps'),
	(417467, 126, '2015-02-15 01:29:07.000000', 'consum', 0.0210, 'lps'),
	(417468, 126, '2015-02-15 01:29:08.000000', 'consum', 0.0220, 'lps'),
	(417469, 126, '2015-02-15 01:29:09.000000', 'consum', 0.0217, 'lps'),
	(417470, 126, '2015-02-15 01:29:10.000000', 'consum', 0.0217, 'lps'),
	(417471, 126, '2015-02-15 01:29:11.000000', 'consum', 0.0212, 'lps'),
	(417472, 126, '2015-02-15 01:29:12.000000', 'consum', 0.0211, 'lps'),
	(417473, 126, '2015-02-15 01:29:13.000000', 'consum', 0.0210, 'lps'),
	(417474, 126, '2015-02-15 01:29:14.000000', 'consum', 0.0221, 'lps'),
	(417475, 126, '2015-02-15 01:29:15.000000', 'consum', 0.0211, 'lps'),
	(417476, 126, '2015-02-15 01:29:16.000000', 'consum', 0.0211, 'lps'),
	(417477, 126, '2015-02-15 01:29:17.000000', 'consum', 0.0210, 'lps'),
	(417478, 126, '2015-02-15 01:29:18.000000', 'consum', 0.0223, 'lps'),
	(417479, 126, '2015-02-15 01:29:19.000000', 'consum', 0.0219, 'lps'),
	(417480, 126, '2015-02-15 01:29:20.000000', 'consum', 0.0217, 'lps'),
	(417481, 126, '2015-02-15 01:29:21.000000', 'consum', 0.0219, 'lps'),
	(417482, 126, '2015-02-15 01:29:22.000000', 'consum', 0.0220, 'lps'),
	(417483, 126, '2015-02-15 01:29:23.000000', 'consum', 0.0219, 'lps'),
	(417484, 126, '2015-02-15 01:29:24.000000', 'consum', 0.0211, 'lps'),
	(417485, 126, '2015-02-15 01:29:25.000000', 'consum', 0.0217, 'lps'),
	(417486, 126, '2015-02-15 01:29:26.000000', 'consum', 0.0216, 'lps'),
	(417487, 126, '2015-02-15 01:29:27.000000', 'consum', 0.0217, 'lps'),
	(417488, 126, '2015-02-15 01:29:28.000000', 'consum', 0.0213, 'lps'),
	(417489, 126, '2015-02-15 01:29:29.000000', 'consum', 0.0219, 'lps'),
	(417490, 126, '2015-02-15 01:29:30.000000', 'consum', 0.0220, 'lps'),
	(417491, 126, '2015-02-15 01:29:31.000000', 'consum', 0.0218, 'lps'),
	(417492, 126, '2015-02-15 01:29:32.000000', 'consum', 0.0223, 'lps'),
	(417493, 126, '2015-02-15 01:29:33.000000', 'consum', 0.0223, 'lps'),
	(417494, 126, '2015-02-15 01:29:34.000000', 'consum', 0.0221, 'lps'),
	(417495, 126, '2015-02-15 01:29:35.000000', 'consum', 0.0213, 'lps'),
	(417496, 126, '2015-02-15 01:29:36.000000', 'consum', 0.0220, 'lps'),
	(417497, 126, '2015-02-15 01:29:37.000000', 'consum', 0.0212, 'lps'),
	(417498, 126, '2015-02-15 01:29:38.000000', 'consum', 0.0217, 'lps'),
	(417499, 126, '2015-02-15 01:29:39.000000', 'consum', 0.0210, 'lps'),
	(417500, 126, '2015-02-15 01:29:40.000000', 'consum', 0.0219, 'lps'),
	(417501, 126, '2015-02-15 01:29:41.000000', 'consum', 0.0212, 'lps'),
	(417502, 126, '2015-02-15 01:29:42.000000', 'consum', 0.0223, 'lps'),
	(417503, 126, '2015-02-15 01:29:43.000000', 'consum', 0.0212, 'lps'),
	(417504, 126, '2015-02-15 01:29:44.000000', 'consum', 0.0212, 'lps'),
	(417505, 126, '2015-02-15 01:29:45.000000', 'consum', 0.0213, 'lps'),
	(417506, 126, '2015-02-15 01:29:46.000000', 'consum', 0.0218, 'lps'),
	(417507, 126, '2015-02-15 01:29:47.000000', 'consum', 0.0215, 'lps'),
	(417508, 126, '2015-02-15 01:29:48.000000', 'consum', 0.0212, 'lps'),
	(417509, 126, '2015-02-15 01:29:49.000000', 'consum', 0.0220, 'lps'),
	(417510, 126, '2015-02-15 01:29:50.000000', 'consum', 0.0210, 'lps'),
	(417511, 126, '2015-02-15 01:29:51.000000', 'consum', 0.0223, 'lps'),
	(417512, 126, '2015-02-15 01:29:52.000000', 'consum', 0.0222, 'lps'),
	(417513, 126, '2015-02-15 01:29:53.000000', 'consum', 0.0214, 'lps'),
	(417514, 126, '2015-02-15 01:29:54.000000', 'consum', 0.0212, 'lps'),
	(417515, 126, '2015-02-15 01:29:55.000000', 'consum', 0.0221, 'lps'),
	(417516, 126, '2015-02-15 01:29:56.000000', 'consum', 0.0218, 'lps'),
	(417517, 126, '2015-02-15 01:29:57.000000', 'consum', 0.0216, 'lps'),
	(417518, 126, '2015-02-15 01:29:58.000000', 'consum', 0.0218, 'lps'),
	(417519, 126, '2015-02-15 01:29:59.000000', 'consum', 0.0219, 'lps'),
	(417520, 126, '2015-02-15 01:30:00.000000', 'consum', 0.0218, 'lps'),
	(417521, 126, '2015-02-15 01:30:01.000000', 'consum', 0.0211, 'lps'),
	(417522, 126, '2015-02-15 01:30:02.000000', 'consum', 0.0217, 'lps'),
	(417523, 126, '2015-02-15 01:30:03.000000', 'consum', 0.0215, 'lps'),
	(417524, 126, '2015-02-15 01:30:04.000000', 'consum', 0.0213, 'lps'),
	(417525, 126, '2015-02-15 01:30:05.000000', 'consum', 0.0213, 'lps'),
	(417526, 126, '2015-02-15 01:30:06.000000', 'consum', 0.0214, 'lps'),
	(417527, 126, '2015-02-15 01:30:07.000000', 'consum', 0.0221, 'lps'),
	(417528, 126, '2015-02-15 01:30:08.000000', 'consum', 0.0212, 'lps'),
	(417529, 126, '2015-02-15 01:30:09.000000', 'consum', 0.0215, 'lps'),
	(417530, 126, '2015-02-15 01:30:10.000000', 'consum', 0.0218, 'lps'),
	(417531, 126, '2015-02-15 01:30:11.000000', 'consum', 0.0219, 'lps'),
	(417532, 126, '2015-02-15 01:30:12.000000', 'consum', 0.0218, 'lps'),
	(417533, 126, '2015-02-15 01:30:13.000000', 'consum', 0.0210, 'lps'),
	(417534, 126, '2015-02-15 01:30:14.000000', 'consum', 0.0214, 'lps'),
	(417535, 126, '2015-02-15 01:30:15.000000', 'consum', 0.0217, 'lps'),
	(417536, 126, '2015-02-15 01:30:16.000000', 'consum', 0.0220, 'lps'),
	(417537, 126, '2015-02-15 01:30:17.000000', 'consum', 0.0213, 'lps'),
	(417538, 126, '2015-02-15 01:30:18.000000', 'consum', 0.0221, 'lps'),
	(417539, 126, '2015-02-15 01:30:19.000000', 'consum', 0.0214, 'lps'),
	(417540, 126, '2015-02-15 01:30:20.000000', 'consum', 0.0212, 'lps'),
	(417541, 126, '2015-02-15 01:30:21.000000', 'consum', 0.0210, 'lps'),
	(417542, 126, '2015-02-15 01:30:22.000000', 'consum', 0.0216, 'lps'),
	(417543, 126, '2015-02-15 01:30:23.000000', 'consum', 0.0213, 'lps'),
	(417544, 126, '2015-02-15 01:30:24.000000', 'consum', 0.0223, 'lps'),
	(417545, 126, '2015-02-15 01:30:25.000000', 'consum', 0.0223, 'lps'),
	(417546, 126, '2015-02-15 01:30:26.000000', 'consum', 0.0210, 'lps'),
	(417547, 126, '2015-02-15 01:30:27.000000', 'consum', 0.0215, 'lps'),
	(417548, 126, '2015-02-15 01:30:28.000000', 'consum', 0.0219, 'lps'),
	(417549, 126, '2015-02-15 01:30:29.000000', 'consum', 0.0211, 'lps'),
	(417550, 126, '2015-02-15 01:30:30.000000', 'consum', 0.0219, 'lps'),
	(417551, 126, '2015-02-15 01:30:31.000000', 'consum', 0.0223, 'lps'),
	(417552, 126, '2015-02-15 01:30:32.000000', 'consum', 0.0221, 'lps'),
	(417553, 126, '2015-02-15 01:30:33.000000', 'consum', 0.0213, 'lps'),
	(417554, 126, '2015-02-15 01:30:34.000000', 'consum', 0.0218, 'lps'),
	(417555, 126, '2015-02-15 01:30:35.000000', 'consum', 0.0216, 'lps'),
	(417556, 126, '2015-02-15 01:30:36.000000', 'consum', 0.0217, 'lps'),
	(417557, 126, '2015-02-15 01:30:37.000000', 'consum', 0.0213, 'lps'),
	(417558, 126, '2015-02-15 01:30:38.000000', 'consum', 0.0217, 'lps'),
	(417559, 126, '2015-02-15 01:30:39.000000', 'consum', 0.0211, 'lps'),
	(417560, 126, '2015-02-15 01:30:40.000000', 'consum', 0.0220, 'lps'),
	(417561, 126, '2015-02-15 01:30:41.000000', 'consum', 0.0218, 'lps'),
	(417562, 126, '2015-02-15 01:30:42.000000', 'consum', 0.0220, 'lps'),
	(417563, 126, '2015-02-15 01:30:43.000000', 'consum', 0.0210, 'lps'),
	(417564, 126, '2015-02-15 01:30:44.000000', 'consum', 0.0220, 'lps'),
	(417565, 126, '2015-02-15 01:30:45.000000', 'consum', 0.0219, 'lps'),
	(417566, 126, '2015-02-15 01:30:46.000000', 'consum', 0.0213, 'lps'),
	(417567, 126, '2015-02-15 01:30:47.000000', 'consum', 0.0213, 'lps'),
	(417568, 126, '2015-02-15 01:30:48.000000', 'consum', 0.0216, 'lps'),
	(417569, 126, '2015-02-15 01:30:49.000000', 'consum', 0.0219, 'lps'),
	(417570, 126, '2015-02-15 01:30:50.000000', 'consum', 0.0221, 'lps'),
	(417571, 126, '2015-02-15 01:30:51.000000', 'consum', 0.0210, 'lps'),
	(417572, 126, '2015-02-15 01:30:52.000000', 'consum', 0.0221, 'lps'),
	(417573, 126, '2015-02-15 01:30:53.000000', 'consum', 0.0222, 'lps'),
	(417574, 126, '2015-02-15 01:30:54.000000', 'consum', 0.0212, 'lps'),
	(417575, 126, '2015-02-15 01:30:55.000000', 'consum', 0.0211, 'lps'),
	(417576, 126, '2015-02-15 01:30:56.000000', 'consum', 0.0210, 'lps'),
	(417577, 126, '2015-02-15 01:30:57.000000', 'consum', 0.0220, 'lps'),
	(417578, 126, '2015-02-15 01:30:58.000000', 'consum', 0.0220, 'lps'),
	(417579, 126, '2015-02-15 01:30:59.000000', 'consum', 0.0217, 'lps'),
	(417580, 126, '2015-02-15 01:31:00.000000', 'consum', 0.0216, 'lps'),
	(417581, 126, '2015-02-15 01:31:01.000000', 'consum', 0.0219, 'lps'),
	(417582, 126, '2015-02-15 01:31:02.000000', 'consum', 0.0211, 'lps'),
	(417583, 126, '2015-02-15 01:31:03.000000', 'consum', 0.0216, 'lps'),
	(417584, 126, '2015-02-15 01:31:04.000000', 'consum', 0.0223, 'lps'),
	(417585, 126, '2015-02-15 01:31:05.000000', 'consum', 0.0215, 'lps'),
	(417586, 126, '2015-02-15 01:31:06.000000', 'consum', 0.0213, 'lps'),
	(417587, 126, '2015-02-15 01:31:07.000000', 'consum', 0.0223, 'lps'),
	(417588, 126, '2015-02-15 01:31:08.000000', 'consum', 0.0210, 'lps'),
	(417589, 126, '2015-02-15 01:31:09.000000', 'consum', 0.0213, 'lps'),
	(417590, 126, '2015-02-15 01:31:10.000000', 'consum', 0.0211, 'lps'),
	(417591, 126, '2015-02-15 01:31:11.000000', 'consum', 0.0223, 'lps'),
	(417592, 126, '2015-02-15 01:31:12.000000', 'consum', 0.0215, 'lps'),
	(417593, 126, '2015-02-15 01:31:13.000000', 'consum', 0.0210, 'lps'),
	(417594, 126, '2015-02-15 01:31:14.000000', 'consum', 0.0212, 'lps'),
	(417595, 126, '2015-02-15 01:31:15.000000', 'consum', 0.0219, 'lps'),
	(417596, 126, '2015-02-15 01:31:16.000000', 'consum', 0.0222, 'lps'),
	(417597, 126, '2015-02-15 01:31:17.000000', 'consum', 0.0215, 'lps'),
	(417598, 126, '2015-02-15 01:31:18.000000', 'consum', 0.0214, 'lps'),
	(417599, 126, '2015-02-15 01:31:19.000000', 'consum', 0.0216, 'lps'),
	(417600, 126, '2015-02-15 01:31:20.000000', 'consum', 0.0213, 'lps'),
	(417601, 126, '2015-02-15 01:31:21.000000', 'consum', 0.0222, 'lps'),
	(417602, 126, '2015-02-15 01:31:22.000000', 'consum', 0.0220, 'lps'),
	(417603, 126, '2015-02-15 01:31:23.000000', 'consum', 0.0223, 'lps'),
	(417604, 126, '2015-02-15 01:31:24.000000', 'consum', 0.0217, 'lps'),
	(417605, 126, '2015-02-15 01:31:25.000000', 'consum', 0.0221, 'lps'),
	(417606, 126, '2015-02-15 01:31:26.000000', 'consum', 0.0218, 'lps'),
	(417607, 126, '2015-02-15 01:31:27.000000', 'consum', 0.0217, 'lps'),
	(417608, 126, '2015-02-15 01:31:28.000000', 'consum', 0.0222, 'lps'),
	(417609, 126, '2015-02-15 01:31:29.000000', 'consum', 0.0221, 'lps'),
	(417610, 126, '2015-02-15 01:31:30.000000', 'consum', 0.0215, 'lps'),
	(417611, 102, '2015-03-01 00:00:00.000000', 'consum', 0.0222, 'lps'),
	(417612, 102, '2015-03-01 00:00:01.000000', 'consum', 0.0227, 'lps'),
	(417613, 102, '2015-03-01 00:00:02.000000', 'consum', 0.0219, 'lps'),
	(417614, 102, '2015-03-01 00:00:03.000000', 'consum', 0.0223, 'lps'),
	(417615, 102, '2015-03-01 00:00:04.000000', 'consum', 0.0211, 'lps'),
	(417616, 102, '2015-03-01 00:00:05.000000', 'consum', 0.0214, 'lps'),
	(417617, 102, '2015-03-01 00:00:06.000000', 'consum', 0.0226, 'lps'),
	(417618, 102, '2015-03-01 00:00:07.000000', 'consum', 0.0222, 'lps'),
	(417619, 102, '2015-03-01 00:00:08.000000', 'consum', 0.0222, 'lps'),
	(417620, 102, '2015-03-01 00:00:09.000000', 'consum', 0.0213, 'lps'),
	(417621, 102, '2015-03-01 00:00:10.000000', 'consum', 0.0212, 'lps'),
	(417622, 102, '2015-03-01 00:00:11.000000', 'consum', 0.0210, 'lps'),
	(417623, 102, '2015-03-01 00:00:12.000000', 'consum', 0.0224, 'lps'),
	(417624, 102, '2015-03-01 00:00:13.000000', 'consum', 0.0223, 'lps'),
	(417625, 102, '2015-03-01 00:00:14.000000', 'consum', 0.0210, 'lps'),
	(417626, 102, '2015-03-01 00:00:15.000000', 'consum', 0.0215, 'lps'),
	(417627, 102, '2015-03-01 00:00:16.000000', 'consum', 0.0214, 'lps'),
	(417628, 102, '2015-03-01 00:00:17.000000', 'consum', 0.0217, 'lps'),
	(417629, 102, '2015-03-01 00:00:18.000000', 'consum', 0.0211, 'lps'),
	(417630, 102, '2015-03-01 00:00:19.000000', 'consum', 0.0216, 'lps'),
	(417631, 102, '2015-03-01 00:00:20.000000', 'consum', 0.0216, 'lps'),
	(417632, 102, '2015-03-01 00:00:21.000000', 'consum', 0.0222, 'lps'),
	(417633, 102, '2015-03-01 00:00:22.000000', 'consum', 0.0213, 'lps'),
	(417634, 102, '2015-03-01 00:00:23.000000', 'consum', 0.0210, 'lps'),
	(417635, 102, '2015-03-01 00:00:24.000000', 'consum', 0.0223, 'lps'),
	(417636, 102, '2015-03-01 00:00:25.000000', 'consum', 0.0215, 'lps'),
	(417637, 102, '2015-03-01 00:00:26.000000', 'consum', 0.0214, 'lps'),
	(417638, 102, '2015-03-01 00:00:27.000000', 'consum', 0.0217, 'lps'),
	(417639, 102, '2015-03-01 00:00:28.000000', 'consum', 0.0212, 'lps'),
	(417640, 102, '2015-03-01 00:00:29.000000', 'consum', 0.0219, 'lps'),
	(417641, 102, '2015-03-01 00:00:30.000000', 'consum', 0.0212, 'lps'),
	(417642, 102, '2015-03-01 00:00:31.000000', 'consum', 0.0211, 'lps'),
	(417643, 102, '2015-03-01 00:00:32.000000', 'consum', 0.0213, 'lps'),
	(417644, 102, '2015-03-01 00:00:33.000000', 'consum', 0.0219, 'lps'),
	(417645, 102, '2015-03-01 00:00:34.000000', 'consum', 0.0210, 'lps'),
	(417646, 102, '2015-03-01 00:00:35.000000', 'consum', 0.0220, 'lps'),
	(417647, 102, '2015-03-01 00:00:36.000000', 'consum', 0.0223, 'lps'),
	(417648, 102, '2015-03-01 00:00:37.000000', 'consum', 0.0224, 'lps'),
	(417649, 102, '2015-03-01 00:00:38.000000', 'consum', 0.0222, 'lps'),
	(417650, 102, '2015-03-01 00:00:39.000000', 'consum', 0.0227, 'lps'),
	(417651, 102, '2015-03-01 00:00:40.000000', 'consum', 0.0222, 'lps'),
	(417652, 102, '2015-03-01 00:00:41.000000', 'consum', 0.0219, 'lps'),
	(417653, 102, '2015-03-01 00:00:42.000000', 'consum', 0.0220, 'lps'),
	(417654, 102, '2015-03-01 00:00:43.000000', 'consum', 0.0214, 'lps'),
	(417655, 102, '2015-03-01 00:00:44.000000', 'consum', 0.0218, 'lps'),
	(417656, 102, '2015-03-01 00:00:45.000000', 'consum', 0.0221, 'lps'),
	(417657, 102, '2015-03-01 00:00:46.000000', 'consum', 0.0221, 'lps'),
	(417658, 102, '2015-03-01 00:00:47.000000', 'consum', 0.0214, 'lps'),
	(417659, 102, '2015-03-01 00:00:48.000000', 'consum', 0.0218, 'lps'),
	(417660, 102, '2015-03-01 00:00:49.000000', 'consum', 0.0215, 'lps'),
	(417661, 102, '2015-03-01 00:00:50.000000', 'consum', 0.0214, 'lps'),
	(417662, 102, '2015-03-01 00:00:51.000000', 'consum', 0.0215, 'lps'),
	(417663, 102, '2015-03-01 00:00:52.000000', 'consum', 0.0225, 'lps'),
	(417664, 102, '2015-03-01 00:00:53.000000', 'consum', 0.0228, 'lps'),
	(417665, 102, '2015-03-01 00:00:54.000000', 'consum', 0.0214, 'lps'),
	(417666, 102, '2015-03-01 00:00:55.000000', 'consum', 0.0220, 'lps'),
	(417667, 102, '2015-03-01 00:00:56.000000', 'consum', 0.0227, 'lps'),
	(417668, 102, '2015-03-01 00:00:57.000000', 'consum', 0.0224, 'lps'),
	(417669, 102, '2015-03-01 00:00:58.000000', 'consum', 0.0210, 'lps'),
	(417670, 102, '2015-03-01 00:00:59.000000', 'consum', 0.0210, 'lps'),
	(417671, 102, '2015-03-01 00:01:00.000000', 'consum', 0.0228, 'lps'),
	(417672, 102, '2015-03-01 00:01:01.000000', 'consum', 0.0223, 'lps'),
	(417673, 102, '2015-03-01 00:01:02.000000', 'consum', 0.0220, 'lps'),
	(417674, 102, '2015-03-01 00:01:03.000000', 'consum', 0.0223, 'lps'),
	(417675, 102, '2015-03-01 00:01:04.000000', 'consum', 0.0225, 'lps'),
	(417676, 102, '2015-03-01 00:01:05.000000', 'consum', 0.0225, 'lps'),
	(417677, 102, '2015-03-01 00:01:06.000000', 'consum', 0.0220, 'lps'),
	(417678, 102, '2015-03-01 00:01:07.000000', 'consum', 0.0218, 'lps'),
	(417679, 102, '2015-03-01 00:01:08.000000', 'consum', 0.0219, 'lps'),
	(417680, 102, '2015-03-01 00:01:09.000000', 'consum', 0.0212, 'lps'),
	(417681, 102, '2015-03-01 00:01:10.000000', 'consum', 0.0213, 'lps'),
	(417682, 102, '2015-03-01 00:01:11.000000', 'consum', 0.0220, 'lps'),
	(417683, 102, '2015-03-01 00:01:12.000000', 'consum', 0.0210, 'lps'),
	(417684, 102, '2015-03-01 00:01:13.000000', 'consum', 0.0220, 'lps'),
	(417685, 102, '2015-03-01 00:01:14.000000', 'consum', 0.0221, 'lps'),
	(417686, 102, '2015-03-01 00:01:15.000000', 'consum', 0.0218, 'lps'),
	(417687, 102, '2015-03-01 00:01:16.000000', 'consum', 0.0216, 'lps'),
	(417688, 102, '2015-03-01 00:01:17.000000', 'consum', 0.0215, 'lps'),
	(417689, 102, '2015-03-01 00:01:18.000000', 'consum', 0.0220, 'lps'),
	(417690, 102, '2015-03-01 00:01:19.000000', 'consum', 0.0226, 'lps'),
	(417691, 102, '2015-03-01 00:01:20.000000', 'consum', 0.0220, 'lps'),
	(417692, 102, '2015-03-01 00:01:21.000000', 'consum', 0.0213, 'lps'),
	(417693, 102, '2015-03-01 00:01:22.000000', 'consum', 0.0213, 'lps'),
	(417694, 102, '2015-03-01 00:01:23.000000', 'consum', 0.0218, 'lps'),
	(417695, 102, '2015-03-01 00:01:24.000000', 'consum', 0.0222, 'lps'),
	(417696, 102, '2015-03-01 00:01:25.000000', 'consum', 0.0226, 'lps'),
	(417697, 102, '2015-03-01 00:01:26.000000', 'consum', 0.0213, 'lps'),
	(417698, 102, '2015-03-01 00:01:27.000000', 'consum', 0.0219, 'lps'),
	(417699, 102, '2015-03-01 00:01:28.000000', 'consum', 0.0225, 'lps'),
	(417700, 102, '2015-03-01 00:01:29.000000', 'consum', 0.0220, 'lps'),
	(417701, 102, '2015-03-01 00:01:30.000000', 'consum', 0.0214, 'lps'),
	(417702, 102, '2015-03-01 00:01:31.000000', 'consum', 0.0223, 'lps'),
	(417703, 102, '2015-03-01 00:01:32.000000', 'consum', 0.0223, 'lps'),
	(417704, 102, '2015-03-01 00:01:33.000000', 'consum', 0.0217, 'lps'),
	(417705, 102, '2015-03-01 00:01:34.000000', 'consum', 0.0226, 'lps'),
	(417706, 102, '2015-03-01 00:01:35.000000', 'consum', 0.0210, 'lps'),
	(417707, 102, '2015-03-01 00:01:36.000000', 'consum', 0.0223, 'lps'),
	(417708, 102, '2015-03-01 00:01:37.000000', 'consum', 0.0214, 'lps'),
	(417709, 102, '2015-03-01 00:01:38.000000', 'consum', 0.0213, 'lps'),
	(417710, 102, '2015-03-01 00:01:39.000000', 'consum', 0.0211, 'lps'),
	(417711, 102, '2015-03-01 00:01:40.000000', 'consum', 0.0227, 'lps'),
	(417712, 102, '2015-03-01 00:01:41.000000', 'consum', 0.0215, 'lps'),
	(417713, 102, '2015-03-01 00:01:42.000000', 'consum', 0.0221, 'lps'),
	(417714, 102, '2015-03-01 00:01:43.000000', 'consum', 0.0213, 'lps'),
	(417715, 102, '2015-03-01 00:01:44.000000', 'consum', 0.0210, 'lps'),
	(417716, 102, '2015-03-01 00:01:45.000000', 'consum', 0.0222, 'lps'),
	(417717, 102, '2015-03-01 00:01:46.000000', 'consum', 0.0212, 'lps'),
	(417718, 102, '2015-03-01 00:01:47.000000', 'consum', 0.0224, 'lps'),
	(417719, 102, '2015-03-01 00:01:48.000000', 'consum', 0.0216, 'lps'),
	(417720, 102, '2015-03-01 00:01:49.000000', 'consum', 0.0218, 'lps'),
	(417721, 102, '2015-03-01 00:01:50.000000', 'consum', 0.0210, 'lps'),
	(417722, 102, '2015-03-01 00:01:51.000000', 'consum', 0.0228, 'lps'),
	(417723, 102, '2015-03-01 00:01:52.000000', 'consum', 0.0219, 'lps'),
	(417724, 102, '2015-03-01 00:01:53.000000', 'consum', 0.0223, 'lps'),
	(417725, 102, '2015-03-01 00:01:54.000000', 'consum', 0.0227, 'lps'),
	(417726, 102, '2015-03-01 00:01:55.000000', 'consum', 0.0217, 'lps'),
	(417727, 102, '2015-03-01 00:01:56.000000', 'consum', 0.0214, 'lps'),
	(417728, 102, '2015-03-01 00:01:57.000000', 'consum', 0.0210, 'lps'),
	(417729, 102, '2015-03-01 00:01:58.000000', 'consum', 0.0217, 'lps'),
	(417730, 102, '2015-03-01 00:01:59.000000', 'consum', 0.0228, 'lps'),
	(417731, 102, '2015-03-01 00:02:00.000000', 'consum', 0.0220, 'lps'),
	(417732, 102, '2015-03-01 00:02:01.000000', 'consum', 0.0228, 'lps'),
	(417733, 102, '2015-03-01 00:02:02.000000', 'consum', 0.0227, 'lps'),
	(417734, 102, '2015-03-01 00:02:03.000000', 'consum', 0.0222, 'lps'),
	(417735, 102, '2015-03-01 00:02:04.000000', 'consum', 0.0221, 'lps'),
	(417736, 102, '2015-03-01 00:02:05.000000', 'consum', 0.0210, 'lps'),
	(417737, 102, '2015-03-01 00:02:06.000000', 'consum', 0.0218, 'lps'),
	(417738, 102, '2015-03-01 00:02:07.000000', 'consum', 0.0228, 'lps'),
	(417739, 102, '2015-03-01 00:02:08.000000', 'consum', 0.0218, 'lps'),
	(417740, 102, '2015-03-01 00:02:09.000000', 'consum', 0.0214, 'lps'),
	(417741, 102, '2015-03-01 00:02:10.000000', 'consum', 0.0210, 'lps'),
	(417742, 102, '2015-03-01 00:02:11.000000', 'consum', 0.0216, 'lps'),
	(417743, 102, '2015-03-01 00:02:12.000000', 'consum', 0.0222, 'lps'),
	(417744, 102, '2015-03-01 00:02:13.000000', 'consum', 0.0212, 'lps'),
	(417745, 102, '2015-03-01 00:02:14.000000', 'consum', 0.0225, 'lps'),
	(417746, 102, '2015-03-01 00:02:15.000000', 'consum', 0.0218, 'lps'),
	(417747, 102, '2015-03-01 00:02:16.000000', 'consum', 0.0227, 'lps'),
	(417748, 102, '2015-03-01 00:02:17.000000', 'consum', 0.0213, 'lps'),
	(417749, 102, '2015-03-01 00:02:18.000000', 'consum', 0.0212, 'lps'),
	(417750, 102, '2015-03-01 00:02:19.000000', 'consum', 0.0213, 'lps'),
	(417751, 102, '2015-03-01 00:02:20.000000', 'consum', 0.0218, 'lps'),
	(417752, 102, '2015-03-01 00:02:21.000000', 'consum', 0.0222, 'lps'),
	(417753, 102, '2015-03-01 00:02:22.000000', 'consum', 0.0228, 'lps'),
	(417754, 102, '2015-03-01 00:02:23.000000', 'consum', 0.0224, 'lps'),
	(417755, 102, '2015-03-01 00:02:24.000000', 'consum', 0.0228, 'lps'),
	(417756, 102, '2015-03-01 00:02:25.000000', 'consum', 0.0216, 'lps'),
	(417757, 102, '2015-03-01 00:02:26.000000', 'consum', 0.0227, 'lps'),
	(417758, 102, '2015-03-01 00:02:27.000000', 'consum', 0.0217, 'lps'),
	(417759, 102, '2015-03-01 00:02:28.000000', 'consum', 0.0217, 'lps'),
	(417760, 102, '2015-03-01 00:02:29.000000', 'consum', 0.0223, 'lps'),
	(417761, 102, '2015-03-01 00:02:30.000000', 'consum', 0.0214, 'lps'),
	(417762, 102, '2015-03-01 00:02:31.000000', 'consum', 0.0212, 'lps'),
	(417763, 102, '2015-03-01 00:02:32.000000', 'consum', 0.0228, 'lps'),
	(417764, 102, '2015-03-01 00:02:33.000000', 'consum', 0.0213, 'lps'),
	(417765, 102, '2015-03-01 00:02:34.000000', 'consum', 0.0214, 'lps'),
	(417766, 102, '2015-03-01 00:02:35.000000', 'consum', 0.0220, 'lps'),
	(417767, 102, '2015-03-01 00:02:36.000000', 'consum', 0.0228, 'lps'),
	(417768, 102, '2015-03-01 00:02:37.000000', 'consum', 0.0210, 'lps'),
	(417769, 102, '2015-03-01 00:02:38.000000', 'consum', 0.0217, 'lps'),
	(417770, 102, '2015-03-01 00:02:39.000000', 'consum', 0.0225, 'lps'),
	(417771, 102, '2015-03-01 00:02:40.000000', 'consum', 0.0224, 'lps'),
	(417772, 102, '2015-03-01 00:02:41.000000', 'consum', 0.0217, 'lps'),
	(417773, 102, '2015-03-01 00:02:42.000000', 'consum', 0.0222, 'lps'),
	(417774, 102, '2015-03-01 00:02:43.000000', 'consum', 0.0211, 'lps'),
	(417775, 102, '2015-03-01 00:02:44.000000', 'consum', 0.0220, 'lps'),
	(417776, 102, '2015-03-01 00:02:45.000000', 'consum', 0.0217, 'lps'),
	(417777, 102, '2015-03-01 00:02:46.000000', 'consum', 0.0215, 'lps'),
	(417778, 102, '2015-03-01 00:02:47.000000', 'consum', 0.0216, 'lps'),
	(417779, 102, '2015-03-01 00:02:48.000000', 'consum', 0.0224, 'lps'),
	(417780, 102, '2015-03-01 00:02:49.000000', 'consum', 0.0223, 'lps'),
	(417781, 102, '2015-03-01 00:02:50.000000', 'consum', 0.0214, 'lps'),
	(417782, 102, '2015-03-01 00:02:51.000000', 'consum', 0.0210, 'lps'),
	(417783, 102, '2015-03-01 00:02:52.000000', 'consum', 0.0219, 'lps'),
	(417784, 102, '2015-03-01 00:02:53.000000', 'consum', 0.0218, 'lps'),
	(417785, 102, '2015-03-01 00:02:54.000000', 'consum', 0.0220, 'lps'),
	(417786, 102, '2015-03-01 00:02:55.000000', 'consum', 0.0220, 'lps'),
	(417787, 102, '2015-03-01 00:02:56.000000', 'consum', 0.0227, 'lps'),
	(417788, 102, '2015-03-01 00:02:57.000000', 'consum', 0.0229, 'lps'),
	(417789, 102, '2015-03-01 00:02:58.000000', 'consum', 0.0213, 'lps'),
	(417790, 102, '2015-03-01 00:02:59.000000', 'consum', 0.0228, 'lps'),
	(417791, 102, '2015-03-01 00:03:00.000000', 'consum', 0.0211, 'lps'),
	(417792, 102, '2015-03-01 00:03:01.000000', 'consum', 0.0221, 'lps'),
	(417793, 102, '2015-03-01 00:03:02.000000', 'consum', 0.0225, 'lps'),
	(417794, 102, '2015-03-01 00:03:03.000000', 'consum', 0.0212, 'lps'),
	(417795, 102, '2015-03-01 00:03:04.000000', 'consum', 0.0216, 'lps'),
	(417796, 102, '2015-03-01 00:03:05.000000', 'consum', 0.0216, 'lps'),
	(417797, 102, '2015-03-01 00:03:06.000000', 'consum', 0.0220, 'lps'),
	(417798, 102, '2015-03-01 00:03:07.000000', 'consum', 0.0221, 'lps'),
	(417799, 102, '2015-03-01 00:03:08.000000', 'consum', 0.0217, 'lps'),
	(417800, 102, '2015-03-01 00:03:09.000000', 'consum', 0.0214, 'lps'),
	(417801, 102, '2015-03-01 00:03:10.000000', 'consum', 0.0227, 'lps'),
	(417802, 102, '2015-03-01 00:03:11.000000', 'consum', 0.0223, 'lps'),
	(417803, 102, '2015-03-01 00:03:12.000000', 'consum', 0.0225, 'lps'),
	(417804, 102, '2015-03-01 00:03:13.000000', 'consum', 0.0228, 'lps'),
	(417805, 102, '2015-03-01 00:03:14.000000', 'consum', 0.0215, 'lps'),
	(417806, 102, '2015-03-01 00:03:15.000000', 'consum', 0.0220, 'lps'),
	(417807, 102, '2015-03-01 00:03:16.000000', 'consum', 0.0228, 'lps'),
	(417808, 102, '2015-03-01 00:03:17.000000', 'consum', 0.0210, 'lps'),
	(417809, 102, '2015-03-01 00:03:18.000000', 'consum', 0.0217, 'lps'),
	(417810, 102, '2015-03-01 00:03:19.000000', 'consum', 0.0223, 'lps'),
	(417811, 102, '2015-03-01 00:03:20.000000', 'consum', 0.0215, 'lps'),
	(417812, 102, '2015-03-01 00:03:21.000000', 'consum', 0.0218, 'lps'),
	(417813, 102, '2015-03-01 00:03:22.000000', 'consum', 0.0215, 'lps'),
	(417814, 102, '2015-03-01 00:03:23.000000', 'consum', 0.0211, 'lps'),
	(417815, 102, '2015-03-01 00:03:24.000000', 'consum', 0.0219, 'lps'),
	(417816, 102, '2015-03-01 00:03:25.000000', 'consum', 0.0215, 'lps'),
	(417817, 102, '2015-03-01 00:03:26.000000', 'consum', 0.0227, 'lps'),
	(417818, 102, '2015-03-01 00:03:27.000000', 'consum', 0.0223, 'lps'),
	(417819, 102, '2015-03-01 00:03:28.000000', 'consum', 0.0223, 'lps'),
	(417820, 102, '2015-03-01 00:03:29.000000', 'consum', 0.0216, 'lps'),
	(417821, 102, '2015-03-01 00:03:30.000000', 'consum', 0.0221, 'lps'),
	(417822, 102, '2015-03-01 00:03:31.000000', 'consum', 0.0228, 'lps'),
	(417823, 102, '2015-03-01 00:03:32.000000', 'consum', 0.0228, 'lps'),
	(417824, 102, '2015-03-01 00:03:33.000000', 'consum', 0.0228, 'lps'),
	(417825, 102, '2015-03-01 00:03:34.000000', 'consum', 0.0224, 'lps'),
	(417826, 102, '2015-03-01 00:03:35.000000', 'consum', 0.0229, 'lps'),
	(417827, 102, '2015-03-01 00:03:36.000000', 'consum', 0.0224, 'lps'),
	(417828, 102, '2015-03-01 00:03:37.000000', 'consum', 0.0224, 'lps'),
	(417829, 102, '2015-03-01 00:03:38.000000', 'consum', 0.0216, 'lps'),
	(417830, 102, '2015-03-01 00:03:39.000000', 'consum', 0.0219, 'lps'),
	(417831, 102, '2015-03-01 00:03:40.000000', 'consum', 0.0220, 'lps'),
	(417832, 102, '2015-03-01 00:03:41.000000', 'consum', 0.0211, 'lps'),
	(417833, 102, '2015-03-01 00:03:42.000000', 'consum', 0.0227, 'lps'),
	(417834, 102, '2015-03-01 00:03:43.000000', 'consum', 0.0210, 'lps'),
	(417835, 102, '2015-03-01 00:03:44.000000', 'consum', 0.0222, 'lps'),
	(417836, 102, '2015-03-01 00:03:45.000000', 'consum', 0.0211, 'lps'),
	(417837, 102, '2015-03-01 00:03:46.000000', 'consum', 0.0218, 'lps'),
	(417838, 102, '2015-03-01 00:03:47.000000', 'consum', 0.0229, 'lps'),
	(417839, 102, '2015-03-01 00:03:48.000000', 'consum', 0.0222, 'lps'),
	(417840, 102, '2015-03-01 00:03:49.000000', 'consum', 0.0212, 'lps'),
	(417841, 102, '2015-03-01 00:03:50.000000', 'consum', 0.0226, 'lps'),
	(417842, 102, '2015-03-01 00:03:51.000000', 'consum', 0.0224, 'lps'),
	(417843, 102, '2015-03-01 00:03:52.000000', 'consum', 0.0213, 'lps'),
	(417844, 102, '2015-03-01 00:03:53.000000', 'consum', 0.0224, 'lps'),
	(417845, 102, '2015-03-01 00:03:54.000000', 'consum', 0.0210, 'lps'),
	(417846, 102, '2015-03-01 00:03:55.000000', 'consum', 0.0210, 'lps'),
	(417847, 102, '2015-03-01 00:03:56.000000', 'consum', 0.0212, 'lps'),
	(417848, 102, '2015-03-01 00:03:57.000000', 'consum', 0.0219, 'lps'),
	(417849, 102, '2015-03-01 00:03:58.000000', 'consum', 0.0229, 'lps'),
	(417850, 102, '2015-03-01 00:03:59.000000', 'consum', 0.0218, 'lps'),
	(417851, 102, '2015-03-01 00:04:00.000000', 'consum', 0.0215, 'lps'),
	(417852, 102, '2015-03-01 00:04:01.000000', 'consum', 0.0211, 'lps'),
	(417853, 102, '2015-03-01 00:04:02.000000', 'consum', 0.0221, 'lps'),
	(417854, 102, '2015-03-01 00:04:03.000000', 'consum', 0.0220, 'lps'),
	(417855, 102, '2015-03-01 00:04:04.000000', 'consum', 0.0210, 'lps'),
	(417856, 102, '2015-03-01 00:04:05.000000', 'consum', 0.0221, 'lps'),
	(417857, 102, '2015-03-01 00:04:06.000000', 'consum', 0.0225, 'lps'),
	(417858, 102, '2015-03-01 00:04:07.000000', 'consum', 0.0212, 'lps'),
	(417859, 102, '2015-03-01 00:04:08.000000', 'consum', 0.0216, 'lps'),
	(417860, 102, '2015-03-01 00:04:09.000000', 'consum', 0.0215, 'lps'),
	(417861, 102, '2015-03-01 00:04:10.000000', 'consum', 0.0218, 'lps'),
	(417862, 102, '2015-03-01 00:04:11.000000', 'consum', 0.0214, 'lps'),
	(417863, 102, '2015-03-01 00:04:12.000000', 'consum', 0.0229, 'lps'),
	(417864, 102, '2015-03-01 00:04:13.000000', 'consum', 0.0212, 'lps'),
	(417865, 102, '2015-03-01 00:04:14.000000', 'consum', 0.0224, 'lps'),
	(417866, 102, '2015-03-01 00:04:15.000000', 'consum', 0.0214, 'lps'),
	(417867, 102, '2015-03-01 00:04:16.000000', 'consum', 0.0227, 'lps'),
	(417868, 102, '2015-03-01 00:04:17.000000', 'consum', 0.0225, 'lps'),
	(417869, 102, '2015-03-01 00:04:18.000000', 'consum', 0.0213, 'lps'),
	(417870, 102, '2015-03-01 00:04:19.000000', 'consum', 0.0223, 'lps'),
	(417871, 102, '2015-03-01 00:04:20.000000', 'consum', 0.0224, 'lps'),
	(417872, 102, '2015-03-01 00:04:21.000000', 'consum', 0.0224, 'lps'),
	(417873, 102, '2015-03-01 00:04:22.000000', 'consum', 0.0216, 'lps'),
	(417874, 102, '2015-03-01 00:04:23.000000', 'consum', 0.0218, 'lps'),
	(417875, 102, '2015-03-01 00:04:24.000000', 'consum', 0.0212, 'lps'),
	(417876, 102, '2015-03-01 00:04:25.000000', 'consum', 0.0220, 'lps'),
	(417877, 102, '2015-03-01 00:04:26.000000', 'consum', 0.0211, 'lps'),
	(417878, 102, '2015-03-01 00:04:27.000000', 'consum', 0.0227, 'lps'),
	(417879, 102, '2015-03-01 00:04:28.000000', 'consum', 0.0213, 'lps'),
	(417880, 102, '2015-03-01 00:04:29.000000', 'consum', 0.0212, 'lps'),
	(417881, 102, '2015-03-01 00:04:30.000000', 'consum', 0.0214, 'lps'),
	(417882, 102, '2015-03-01 00:04:31.000000', 'consum', 0.0223, 'lps'),
	(417883, 102, '2015-03-01 00:04:32.000000', 'consum', 0.0225, 'lps'),
	(417884, 102, '2015-03-01 00:04:33.000000', 'consum', 0.0227, 'lps'),
	(417885, 102, '2015-03-01 00:04:34.000000', 'consum', 0.0229, 'lps'),
	(417886, 102, '2015-03-01 00:04:35.000000', 'consum', 0.0214, 'lps'),
	(417887, 102, '2015-03-01 00:04:36.000000', 'consum', 0.0212, 'lps'),
	(417888, 102, '2015-03-01 00:04:37.000000', 'consum', 0.0211, 'lps'),
	(417889, 102, '2015-03-01 00:04:38.000000', 'consum', 0.0210, 'lps'),
	(417890, 102, '2015-03-01 00:04:39.000000', 'consum', 0.0228, 'lps'),
	(417891, 102, '2015-03-01 00:04:40.000000', 'consum', 0.0219, 'lps'),
	(417892, 102, '2015-03-01 00:04:41.000000', 'consum', 0.0221, 'lps'),
	(417893, 102, '2015-03-01 00:04:42.000000', 'consum', 0.0221, 'lps'),
	(417894, 102, '2015-03-01 00:04:43.000000', 'consum', 0.0210, 'lps'),
	(417895, 102, '2015-03-01 00:04:44.000000', 'consum', 0.0217, 'lps'),
	(417896, 102, '2015-03-01 00:04:45.000000', 'consum', 0.0228, 'lps'),
	(417897, 102, '2015-03-01 00:04:46.000000', 'consum', 0.0217, 'lps'),
	(417898, 102, '2015-03-01 00:04:47.000000', 'consum', 0.0212, 'lps'),
	(417899, 102, '2015-03-01 00:04:48.000000', 'consum', 0.0221, 'lps'),
	(417900, 102, '2015-03-01 00:04:49.000000', 'consum', 0.0217, 'lps'),
	(417901, 102, '2015-03-01 00:04:50.000000', 'consum', 0.0213, 'lps'),
	(417902, 102, '2015-03-01 00:04:51.000000', 'consum', 0.0226, 'lps'),
	(417903, 102, '2015-03-01 00:04:52.000000', 'consum', 0.0222, 'lps'),
	(417904, 102, '2015-03-01 00:04:53.000000', 'consum', 0.0222, 'lps'),
	(417905, 102, '2015-03-01 00:04:54.000000', 'consum', 0.0213, 'lps'),
	(417906, 102, '2015-03-01 00:04:55.000000', 'consum', 0.0211, 'lps'),
	(417907, 102, '2015-03-01 00:04:56.000000', 'consum', 0.0227, 'lps'),
	(417908, 102, '2015-03-01 00:04:57.000000', 'consum', 0.0211, 'lps'),
	(417909, 102, '2015-03-01 00:04:58.000000', 'consum', 0.0223, 'lps'),
	(417910, 102, '2015-03-01 00:04:59.000000', 'consum', 0.0215, 'lps'),
	(417911, 102, '2015-03-01 00:05:00.000000', 'consum', 0.0217, 'lps'),
	(417912, 102, '2015-03-01 00:05:01.000000', 'consum', 0.0229, 'lps'),
	(417913, 102, '2015-03-01 00:05:02.000000', 'consum', 0.0223, 'lps'),
	(417914, 102, '2015-03-01 00:05:03.000000', 'consum', 0.0220, 'lps'),
	(417915, 102, '2015-03-01 00:05:04.000000', 'consum', 0.0222, 'lps'),
	(417916, 102, '2015-03-01 00:05:05.000000', 'consum', 0.0222, 'lps'),
	(417917, 102, '2015-03-01 00:05:06.000000', 'consum', 0.0212, 'lps'),
	(417918, 102, '2015-03-01 00:05:07.000000', 'consum', 0.0225, 'lps'),
	(417919, 102, '2015-03-01 00:05:08.000000', 'consum', 0.0221, 'lps'),
	(417920, 102, '2015-03-01 00:05:09.000000', 'consum', 0.0221, 'lps'),
	(417921, 102, '2015-03-01 00:05:10.000000', 'consum', 0.0212, 'lps'),
	(417922, 102, '2015-03-01 00:05:11.000000', 'consum', 0.0229, 'lps'),
	(417923, 102, '2015-03-01 00:05:12.000000', 'consum', 0.0219, 'lps'),
	(417924, 102, '2015-03-01 00:05:13.000000', 'consum', 0.0219, 'lps'),
	(417925, 102, '2015-03-01 00:05:14.000000', 'consum', 0.0226, 'lps'),
	(417926, 102, '2015-03-01 00:05:15.000000', 'consum', 0.0226, 'lps'),
	(417927, 102, '2015-03-01 00:05:16.000000', 'consum', 0.0220, 'lps'),
	(417928, 102, '2015-03-01 00:05:17.000000', 'consum', 0.0216, 'lps'),
	(417929, 102, '2015-03-01 00:05:18.000000', 'consum', 0.0228, 'lps'),
	(417930, 102, '2015-03-01 00:05:19.000000', 'consum', 0.0221, 'lps'),
	(417931, 102, '2015-03-01 00:05:20.000000', 'consum', 0.0215, 'lps'),
	(417932, 102, '2015-03-01 00:05:21.000000', 'consum', 0.0220, 'lps'),
	(417933, 102, '2015-03-01 00:05:22.000000', 'consum', 0.0228, 'lps'),
	(417934, 102, '2015-03-01 00:05:23.000000', 'consum', 0.0229, 'lps'),
	(417935, 102, '2015-03-01 00:05:24.000000', 'consum', 0.0210, 'lps'),
	(417936, 102, '2015-03-01 00:05:25.000000', 'consum', 0.0216, 'lps'),
	(417937, 102, '2015-03-01 00:05:26.000000', 'consum', 0.0219, 'lps'),
	(417938, 102, '2015-03-01 00:05:27.000000', 'consum', 0.0220, 'lps'),
	(417939, 102, '2015-03-01 00:05:28.000000', 'consum', 0.0210, 'lps'),
	(417940, 102, '2015-03-01 00:05:29.000000', 'consum', 0.0223, 'lps'),
	(417941, 102, '2015-03-01 00:05:30.000000', 'consum', 0.0214, 'lps'),
	(417942, 102, '2015-03-01 00:05:31.000000', 'consum', 0.0211, 'lps'),
	(417943, 102, '2015-03-01 00:05:32.000000', 'consum', 0.0223, 'lps'),
	(417944, 102, '2015-03-01 00:05:33.000000', 'consum', 0.0214, 'lps'),
	(417945, 102, '2015-03-01 00:05:34.000000', 'consum', 0.0211, 'lps'),
	(417946, 102, '2015-03-01 00:05:35.000000', 'consum', 0.0225, 'lps'),
	(417947, 102, '2015-03-01 00:05:36.000000', 'consum', 0.0220, 'lps'),
	(417948, 102, '2015-03-01 00:05:37.000000', 'consum', 0.0217, 'lps'),
	(417949, 102, '2015-03-01 00:05:38.000000', 'consum', 0.0214, 'lps'),
	(417950, 102, '2015-03-01 00:05:39.000000', 'consum', 0.0211, 'lps'),
	(417951, 102, '2015-03-01 00:05:40.000000', 'consum', 0.0221, 'lps'),
	(417952, 102, '2015-03-01 00:05:41.000000', 'consum', 0.0224, 'lps'),
	(417953, 102, '2015-03-01 00:05:42.000000', 'consum', 0.0229, 'lps'),
	(417954, 102, '2015-03-01 00:05:43.000000', 'consum', 0.0221, 'lps'),
	(417955, 102, '2015-03-01 00:05:44.000000', 'consum', 0.0210, 'lps'),
	(417956, 102, '2015-03-01 00:05:45.000000', 'consum', 0.0219, 'lps'),
	(417957, 102, '2015-03-01 00:05:46.000000', 'consum', 0.0213, 'lps'),
	(417958, 102, '2015-03-01 00:05:47.000000', 'consum', 0.0218, 'lps'),
	(417959, 102, '2015-03-01 00:05:48.000000', 'consum', 0.0221, 'lps'),
	(417960, 102, '2015-03-01 00:05:49.000000', 'consum', 0.0221, 'lps'),
	(417961, 102, '2015-03-01 00:05:50.000000', 'consum', 0.0212, 'lps'),
	(417962, 102, '2015-03-01 00:05:51.000000', 'consum', 0.0227, 'lps'),
	(417963, 102, '2015-03-01 00:05:52.000000', 'consum', 0.0212, 'lps'),
	(417964, 102, '2015-03-01 00:05:53.000000', 'consum', 0.0228, 'lps'),
	(417965, 102, '2015-03-01 00:05:54.000000', 'consum', 0.0216, 'lps'),
	(417966, 102, '2015-03-01 00:05:55.000000', 'consum', 0.0227, 'lps'),
	(417967, 102, '2015-03-01 00:05:56.000000', 'consum', 0.0216, 'lps'),
	(417968, 102, '2015-03-01 00:05:57.000000', 'consum', 0.0229, 'lps'),
	(417969, 102, '2015-03-01 00:05:58.000000', 'consum', 0.0229, 'lps'),
	(417970, 102, '2015-03-01 00:05:59.000000', 'consum', 0.0229, 'lps'),
	(417971, 102, '2015-03-01 00:06:00.000000', 'consum', 0.0228, 'lps'),
	(417972, 102, '2015-03-01 00:06:01.000000', 'consum', 0.0224, 'lps'),
	(417973, 102, '2015-03-01 00:06:02.000000', 'consum', 0.0227, 'lps'),
	(417974, 102, '2015-03-01 00:06:03.000000', 'consum', 0.0211, 'lps'),
	(417975, 102, '2015-03-01 00:06:04.000000', 'consum', 0.0227, 'lps'),
	(417976, 102, '2015-03-01 00:06:05.000000', 'consum', 0.0210, 'lps'),
	(417977, 102, '2015-03-01 00:06:06.000000', 'consum', 0.0221, 'lps'),
	(417978, 102, '2015-03-01 00:06:07.000000', 'consum', 0.0224, 'lps'),
	(417979, 102, '2015-03-01 00:06:08.000000', 'consum', 0.0210, 'lps'),
	(417980, 102, '2015-03-01 00:06:09.000000', 'consum', 0.0228, 'lps'),
	(417981, 102, '2015-03-01 00:06:10.000000', 'consum', 0.0219, 'lps'),
	(417982, 102, '2015-03-01 00:06:11.000000', 'consum', 0.0222, 'lps'),
	(417983, 102, '2015-03-01 00:06:12.000000', 'consum', 0.0222, 'lps'),
	(417984, 102, '2015-03-01 00:06:13.000000', 'consum', 0.0214, 'lps'),
	(417985, 102, '2015-03-01 00:06:14.000000', 'consum', 0.0217, 'lps'),
	(417986, 102, '2015-03-01 00:06:15.000000', 'consum', 0.0210, 'lps'),
	(417987, 102, '2015-03-01 00:06:16.000000', 'consum', 0.0213, 'lps'),
	(417988, 102, '2015-03-01 00:06:17.000000', 'consum', 0.0226, 'lps'),
	(417989, 102, '2015-03-01 00:06:18.000000', 'consum', 0.0220, 'lps'),
	(417990, 102, '2015-03-01 00:06:19.000000', 'consum', 0.0213, 'lps'),
	(417991, 102, '2015-03-01 00:06:20.000000', 'consum', 0.0217, 'lps'),
	(417992, 102, '2015-03-01 00:06:21.000000', 'consum', 0.0215, 'lps'),
	(417993, 102, '2015-03-01 00:06:22.000000', 'consum', 0.0215, 'lps'),
	(417994, 102, '2015-03-01 00:06:23.000000', 'consum', 0.0222, 'lps'),
	(417995, 102, '2015-03-01 00:06:24.000000', 'consum', 0.0215, 'lps'),
	(417996, 102, '2015-03-01 00:06:25.000000', 'consum', 0.0219, 'lps'),
	(417997, 102, '2015-03-01 00:06:26.000000', 'consum', 0.0221, 'lps'),
	(417998, 102, '2015-03-01 00:06:27.000000', 'consum', 0.0218, 'lps'),
	(417999, 102, '2015-03-01 00:06:28.000000', 'consum', 0.0219, 'lps'),
	(418000, 102, '2015-03-01 00:06:29.000000', 'consum', 0.0229, 'lps'),
	(418001, 102, '2015-03-01 00:06:30.000000', 'consum', 0.0221, 'lps'),
	(418002, 102, '2015-03-01 00:06:31.000000', 'consum', 0.0228, 'lps'),
	(418003, 102, '2015-03-01 00:06:32.000000', 'consum', 0.0226, 'lps'),
	(418004, 102, '2015-03-01 00:06:33.000000', 'consum', 0.0217, 'lps'),
	(418005, 102, '2015-03-01 00:06:34.000000', 'consum', 0.0218, 'lps'),
	(418006, 102, '2015-03-01 00:06:35.000000', 'consum', 0.0229, 'lps'),
	(418007, 102, '2015-03-01 00:06:36.000000', 'consum', 0.0220, 'lps'),
	(418008, 102, '2015-03-01 00:06:37.000000', 'consum', 0.0226, 'lps'),
	(418009, 102, '2015-03-01 00:06:38.000000', 'consum', 0.0221, 'lps'),
	(418010, 102, '2015-03-01 00:06:39.000000', 'consum', 0.0216, 'lps'),
	(418011, 102, '2015-03-01 00:06:40.000000', 'consum', 0.0227, 'lps'),
	(418012, 102, '2015-03-01 00:06:41.000000', 'consum', 0.0217, 'lps'),
	(418013, 102, '2015-03-01 00:06:42.000000', 'consum', 0.0216, 'lps'),
	(418014, 102, '2015-03-01 00:06:43.000000', 'consum', 0.0217, 'lps'),
	(418015, 102, '2015-03-01 00:06:44.000000', 'consum', 0.0210, 'lps'),
	(418016, 102, '2015-03-01 00:06:45.000000', 'consum', 0.0210, 'lps'),
	(418017, 102, '2015-03-01 00:06:46.000000', 'consum', 0.0229, 'lps'),
	(418018, 102, '2015-03-01 00:06:47.000000', 'consum', 0.0228, 'lps'),
	(418019, 102, '2015-03-01 00:06:48.000000', 'consum', 0.0222, 'lps'),
	(418020, 102, '2015-03-01 00:06:49.000000', 'consum', 0.0218, 'lps'),
	(418021, 102, '2015-03-01 00:06:50.000000', 'consum', 0.0213, 'lps'),
	(418022, 102, '2015-03-01 00:06:51.000000', 'consum', 0.0220, 'lps'),
	(418023, 102, '2015-03-01 00:06:52.000000', 'consum', 0.0212, 'lps'),
	(418024, 102, '2015-03-01 00:06:53.000000', 'consum', 0.0229, 'lps'),
	(418025, 102, '2015-03-01 00:06:54.000000', 'consum', 0.0221, 'lps'),
	(418026, 102, '2015-03-01 00:06:55.000000', 'consum', 0.0227, 'lps'),
	(418027, 102, '2015-03-01 00:06:56.000000', 'consum', 0.0221, 'lps'),
	(418028, 102, '2015-03-01 00:06:57.000000', 'consum', 0.0218, 'lps'),
	(418029, 102, '2015-03-01 00:06:58.000000', 'consum', 0.0217, 'lps'),
	(418030, 102, '2015-03-01 00:06:59.000000', 'consum', 0.0220, 'lps'),
	(418031, 102, '2015-03-01 00:07:00.000000', 'consum', 0.0221, 'lps'),
	(418032, 102, '2015-03-01 00:07:01.000000', 'consum', 0.0216, 'lps'),
	(418033, 102, '2015-03-01 00:07:02.000000', 'consum', 0.0228, 'lps'),
	(418034, 102, '2015-03-01 00:07:03.000000', 'consum', 0.0221, 'lps'),
	(418035, 102, '2015-03-01 00:07:04.000000', 'consum', 0.0213, 'lps'),
	(418036, 102, '2015-03-01 00:07:05.000000', 'consum', 0.0213, 'lps'),
	(418037, 102, '2015-03-01 00:07:06.000000', 'consum', 0.0215, 'lps'),
	(418038, 102, '2015-03-01 00:07:07.000000', 'consum', 0.0229, 'lps'),
	(418039, 102, '2015-03-01 00:07:08.000000', 'consum', 0.0229, 'lps'),
	(418040, 102, '2015-03-01 00:07:09.000000', 'consum', 0.0227, 'lps'),
	(418041, 102, '2015-03-01 00:07:10.000000', 'consum', 0.0221, 'lps'),
	(418042, 102, '2015-03-01 00:07:11.000000', 'consum', 0.0215, 'lps'),
	(418043, 102, '2015-03-01 00:07:12.000000', 'consum', 0.0222, 'lps'),
	(418044, 102, '2015-03-01 00:07:13.000000', 'consum', 0.0217, 'lps'),
	(418045, 102, '2015-03-01 00:07:14.000000', 'consum', 0.0227, 'lps'),
	(418046, 102, '2015-03-01 00:07:15.000000', 'consum', 0.0216, 'lps'),
	(418047, 102, '2015-03-01 00:07:16.000000', 'consum', 0.0229, 'lps'),
	(418048, 102, '2015-03-01 00:07:17.000000', 'consum', 0.0227, 'lps'),
	(418049, 102, '2015-03-01 00:07:18.000000', 'consum', 0.0218, 'lps'),
	(418050, 102, '2015-03-01 00:07:19.000000', 'consum', 0.0221, 'lps'),
	(418051, 102, '2015-03-01 00:07:20.000000', 'consum', 0.0223, 'lps'),
	(418052, 102, '2015-03-01 00:07:21.000000', 'consum', 0.0220, 'lps'),
	(418053, 102, '2015-03-01 00:07:22.000000', 'consum', 0.0224, 'lps'),
	(418054, 102, '2015-03-01 00:07:23.000000', 'consum', 0.0228, 'lps'),
	(418055, 102, '2015-03-01 00:07:24.000000', 'consum', 0.0219, 'lps'),
	(418056, 102, '2015-03-01 00:07:25.000000', 'consum', 0.0223, 'lps'),
	(418057, 102, '2015-03-01 00:07:26.000000', 'consum', 0.0227, 'lps'),
	(418058, 102, '2015-03-01 00:07:27.000000', 'consum', 0.0218, 'lps'),
	(418059, 102, '2015-03-01 00:07:28.000000', 'consum', 0.0217, 'lps'),
	(418060, 102, '2015-03-01 00:07:29.000000', 'consum', 0.0223, 'lps'),
	(418061, 102, '2015-03-01 00:07:30.000000', 'consum', 0.0216, 'lps'),
	(418062, 102, '2015-03-01 00:07:31.000000', 'consum', 0.0219, 'lps'),
	(418063, 102, '2015-03-01 00:07:32.000000', 'consum', 0.0216, 'lps'),
	(418064, 102, '2015-03-01 00:07:33.000000', 'consum', 0.0217, 'lps'),
	(418065, 102, '2015-03-01 00:07:34.000000', 'consum', 0.0225, 'lps'),
	(418066, 102, '2015-03-01 00:07:35.000000', 'consum', 0.0227, 'lps'),
	(418067, 102, '2015-03-01 00:07:36.000000', 'consum', 0.0228, 'lps'),
	(418068, 102, '2015-03-01 00:07:37.000000', 'consum', 0.0229, 'lps'),
	(418069, 102, '2015-03-01 00:07:38.000000', 'consum', 0.0213, 'lps'),
	(418070, 102, '2015-03-01 00:07:39.000000', 'consum', 0.0227, 'lps'),
	(418071, 102, '2015-03-01 00:07:40.000000', 'consum', 0.0228, 'lps'),
	(418072, 102, '2015-03-01 00:07:41.000000', 'consum', 0.0228, 'lps'),
	(418073, 102, '2015-03-01 00:07:42.000000', 'consum', 0.0229, 'lps'),
	(418074, 102, '2015-03-01 00:07:43.000000', 'consum', 0.0229, 'lps'),
	(418075, 102, '2015-03-01 00:07:44.000000', 'consum', 0.0211, 'lps'),
	(418076, 102, '2015-03-01 00:07:45.000000', 'consum', 0.0216, 'lps'),
	(418077, 102, '2015-03-01 00:07:46.000000', 'consum', 0.0218, 'lps'),
	(418078, 102, '2015-03-01 00:07:47.000000', 'consum', 0.0211, 'lps'),
	(418079, 102, '2015-03-01 00:07:48.000000', 'consum', 0.0214, 'lps'),
	(418080, 102, '2015-03-01 00:07:49.000000', 'consum', 0.0226, 'lps'),
	(418081, 102, '2015-03-01 00:07:50.000000', 'consum', 0.0221, 'lps'),
	(418082, 102, '2015-03-01 00:07:51.000000', 'consum', 0.0215, 'lps'),
	(418083, 102, '2015-03-01 00:07:52.000000', 'consum', 0.0225, 'lps'),
	(418084, 102, '2015-03-01 00:07:53.000000', 'consum', 0.0210, 'lps'),
	(418085, 102, '2015-03-01 00:07:54.000000', 'consum', 0.0226, 'lps'),
	(418086, 102, '2015-03-01 00:07:55.000000', 'consum', 0.0211, 'lps'),
	(418087, 102, '2015-03-01 00:07:56.000000', 'consum', 0.0227, 'lps'),
	(418088, 102, '2015-03-01 00:07:57.000000', 'consum', 0.0211, 'lps'),
	(418089, 102, '2015-03-01 00:07:58.000000', 'consum', 0.0224, 'lps'),
	(418090, 102, '2015-03-01 00:07:59.000000', 'consum', 0.0219, 'lps'),
	(418091, 102, '2015-03-01 00:08:00.000000', 'consum', 0.0215, 'lps'),
	(418092, 102, '2015-03-01 00:08:01.000000', 'consum', 0.0225, 'lps'),
	(418093, 102, '2015-03-01 00:08:02.000000', 'consum', 0.0213, 'lps'),
	(418094, 102, '2015-03-01 00:08:03.000000', 'consum', 0.0218, 'lps'),
	(418095, 102, '2015-03-01 00:08:04.000000', 'consum', 0.0224, 'lps'),
	(418096, 102, '2015-03-01 00:08:05.000000', 'consum', 0.0216, 'lps'),
	(418097, 102, '2015-03-01 00:08:06.000000', 'consum', 0.0220, 'lps'),
	(418098, 102, '2015-03-01 00:08:07.000000', 'consum', 0.0221, 'lps'),
	(418099, 102, '2015-03-01 00:08:08.000000', 'consum', 0.0215, 'lps'),
	(418100, 102, '2015-03-01 00:08:09.000000', 'consum', 0.0224, 'lps'),
	(418101, 102, '2015-03-01 00:08:10.000000', 'consum', 0.0223, 'lps'),
	(418102, 102, '2015-03-01 00:08:11.000000', 'consum', 0.0214, 'lps'),
	(418103, 102, '2015-03-01 00:08:12.000000', 'consum', 0.0213, 'lps'),
	(418104, 102, '2015-03-01 00:08:13.000000', 'consum', 0.0211, 'lps'),
	(418105, 102, '2015-03-01 00:08:14.000000', 'consum', 0.0227, 'lps'),
	(418106, 102, '2015-03-01 00:08:15.000000', 'consum', 0.0212, 'lps'),
	(418107, 102, '2015-03-01 00:08:16.000000', 'consum', 0.0210, 'lps'),
	(418108, 102, '2015-03-01 00:08:17.000000', 'consum', 0.0223, 'lps'),
	(418109, 102, '2015-03-01 00:08:18.000000', 'consum', 0.0218, 'lps'),
	(418110, 102, '2015-03-01 00:08:19.000000', 'consum', 0.0210, 'lps'),
	(418111, 102, '2015-03-01 00:08:20.000000', 'consum', 0.0225, 'lps'),
	(418112, 102, '2015-03-01 00:08:21.000000', 'consum', 0.0226, 'lps'),
	(418113, 102, '2015-03-01 00:08:22.000000', 'consum', 0.0225, 'lps'),
	(418114, 102, '2015-03-01 00:08:23.000000', 'consum', 0.0218, 'lps'),
	(418115, 102, '2015-03-01 00:08:24.000000', 'consum', 0.0224, 'lps'),
	(418116, 102, '2015-03-01 00:08:25.000000', 'consum', 0.0216, 'lps'),
	(418117, 102, '2015-03-01 00:08:26.000000', 'consum', 0.0219, 'lps'),
	(418118, 102, '2015-03-01 00:08:27.000000', 'consum', 0.0219, 'lps'),
	(418119, 102, '2015-03-01 00:08:28.000000', 'consum', 0.0226, 'lps'),
	(418120, 102, '2015-03-01 00:08:29.000000', 'consum', 0.0225, 'lps'),
	(418121, 102, '2015-03-01 00:08:30.000000', 'consum', 0.0219, 'lps'),
	(418122, 102, '2015-03-01 00:08:31.000000', 'consum', 0.0229, 'lps'),
	(418123, 102, '2015-03-01 00:08:32.000000', 'consum', 0.0219, 'lps'),
	(418124, 102, '2015-03-01 00:08:33.000000', 'consum', 0.0216, 'lps'),
	(418125, 102, '2015-03-01 00:08:34.000000', 'consum', 0.0217, 'lps'),
	(418126, 102, '2015-03-01 00:08:35.000000', 'consum', 0.0227, 'lps'),
	(418127, 102, '2015-03-01 00:08:36.000000', 'consum', 0.0214, 'lps'),
	(418128, 102, '2015-03-01 00:08:37.000000', 'consum', 0.0220, 'lps'),
	(418129, 102, '2015-03-01 00:08:38.000000', 'consum', 0.0226, 'lps'),
	(418130, 102, '2015-03-01 00:08:39.000000', 'consum', 0.0222, 'lps'),
	(418131, 102, '2015-03-01 00:08:40.000000', 'consum', 0.0224, 'lps'),
	(418132, 102, '2015-03-01 00:08:41.000000', 'consum', 0.0225, 'lps'),
	(418133, 102, '2015-03-01 00:08:42.000000', 'consum', 0.0221, 'lps'),
	(418134, 102, '2015-03-01 00:08:43.000000', 'consum', 0.0223, 'lps'),
	(418135, 102, '2015-03-01 00:08:44.000000', 'consum', 0.0223, 'lps'),
	(418136, 102, '2015-03-01 00:08:45.000000', 'consum', 0.0215, 'lps'),
	(418137, 102, '2015-03-01 00:08:46.000000', 'consum', 0.0219, 'lps'),
	(418138, 102, '2015-03-01 00:08:47.000000', 'consum', 0.0217, 'lps'),
	(418139, 102, '2015-03-01 00:08:48.000000', 'consum', 0.0222, 'lps'),
	(418140, 102, '2015-03-01 00:08:49.000000', 'consum', 0.0226, 'lps'),
	(418141, 102, '2015-03-01 00:08:50.000000', 'consum', 0.0218, 'lps'),
	(418142, 102, '2015-03-01 00:08:51.000000', 'consum', 0.0221, 'lps'),
	(418143, 102, '2015-03-01 00:08:52.000000', 'consum', 0.0221, 'lps'),
	(418144, 102, '2015-03-01 00:08:53.000000', 'consum', 0.0215, 'lps'),
	(418145, 102, '2015-03-01 00:08:54.000000', 'consum', 0.0219, 'lps'),
	(418146, 102, '2015-03-01 00:08:55.000000', 'consum', 0.0222, 'lps'),
	(418147, 102, '2015-03-01 00:08:56.000000', 'consum', 0.0221, 'lps'),
	(418148, 102, '2015-03-01 00:08:57.000000', 'consum', 0.0213, 'lps'),
	(418149, 102, '2015-03-01 00:08:58.000000', 'consum', 0.0212, 'lps'),
	(418150, 102, '2015-03-01 00:08:59.000000', 'consum', 0.0210, 'lps'),
	(418151, 102, '2015-03-01 00:09:00.000000', 'consum', 0.0226, 'lps'),
	(418152, 102, '2015-03-01 00:09:01.000000', 'consum', 0.0210, 'lps'),
	(418153, 102, '2015-03-01 00:09:02.000000', 'consum', 0.0220, 'lps'),
	(418154, 102, '2015-03-01 00:09:03.000000', 'consum', 0.0224, 'lps'),
	(418155, 102, '2015-03-01 00:09:04.000000', 'consum', 0.0228, 'lps'),
	(418156, 102, '2015-03-01 00:09:05.000000', 'consum', 0.0221, 'lps'),
	(418157, 102, '2015-03-01 00:09:06.000000', 'consum', 0.0228, 'lps'),
	(418158, 102, '2015-03-01 00:09:07.000000', 'consum', 0.0211, 'lps'),
	(418159, 102, '2015-03-01 00:09:08.000000', 'consum', 0.0219, 'lps'),
	(418160, 102, '2015-03-01 00:09:09.000000', 'consum', 0.0215, 'lps'),
	(418161, 102, '2015-03-01 00:09:10.000000', 'consum', 0.0229, 'lps'),
	(418162, 102, '2015-03-01 00:09:11.000000', 'consum', 0.0229, 'lps'),
	(418163, 102, '2015-03-01 00:09:12.000000', 'consum', 0.0227, 'lps'),
	(418164, 102, '2015-03-01 00:09:13.000000', 'consum', 0.0221, 'lps'),
	(418165, 102, '2015-03-01 00:09:14.000000', 'consum', 0.0213, 'lps'),
	(418166, 102, '2015-03-01 00:09:15.000000', 'consum', 0.0214, 'lps'),
	(418167, 102, '2015-03-01 00:09:16.000000', 'consum', 0.0219, 'lps'),
	(418168, 102, '2015-03-01 00:09:17.000000', 'consum', 0.0225, 'lps'),
	(418169, 102, '2015-03-01 00:09:18.000000', 'consum', 0.0217, 'lps'),
	(418170, 102, '2015-03-01 00:09:19.000000', 'consum', 0.0223, 'lps'),
	(418171, 102, '2015-03-01 00:09:20.000000', 'consum', 0.0213, 'lps'),
	(418172, 102, '2015-03-01 00:09:21.000000', 'consum', 0.0226, 'lps'),
	(418173, 102, '2015-03-01 00:09:22.000000', 'consum', 0.0221, 'lps'),
	(418174, 102, '2015-03-01 00:09:23.000000', 'consum', 0.0217, 'lps'),
	(418175, 102, '2015-03-01 00:09:24.000000', 'consum', 0.0213, 'lps'),
	(418176, 102, '2015-03-01 00:09:25.000000', 'consum', 0.0223, 'lps'),
	(418177, 102, '2015-03-01 00:09:26.000000', 'consum', 0.0228, 'lps'),
	(418178, 102, '2015-03-01 00:09:27.000000', 'consum', 0.0222, 'lps'),
	(418179, 102, '2015-03-01 00:09:28.000000', 'consum', 0.0216, 'lps'),
	(418180, 102, '2015-03-01 00:09:29.000000', 'consum', 0.0223, 'lps'),
	(418181, 102, '2015-03-01 00:09:30.000000', 'consum', 0.0217, 'lps'),
	(418182, 102, '2015-03-01 00:09:31.000000', 'consum', 0.0227, 'lps'),
	(418183, 102, '2015-03-01 00:09:32.000000', 'consum', 0.0216, 'lps'),
	(418184, 102, '2015-03-01 00:09:33.000000', 'consum', 0.0210, 'lps'),
	(418185, 102, '2015-03-01 00:09:34.000000', 'consum', 0.0211, 'lps'),
	(418186, 102, '2015-03-01 00:09:35.000000', 'consum', 0.0217, 'lps'),
	(418187, 102, '2015-03-01 00:09:36.000000', 'consum', 0.0222, 'lps'),
	(418188, 102, '2015-03-01 00:09:37.000000', 'consum', 0.0228, 'lps'),
	(418189, 102, '2015-03-01 00:09:38.000000', 'consum', 0.0226, 'lps'),
	(418190, 102, '2015-03-01 00:09:39.000000', 'consum', 0.0217, 'lps'),
	(418191, 102, '2015-03-01 00:09:40.000000', 'consum', 0.0217, 'lps'),
	(418192, 102, '2015-03-01 00:09:41.000000', 'consum', 0.0225, 'lps'),
	(418193, 102, '2015-03-01 00:09:42.000000', 'consum', 0.0224, 'lps'),
	(418194, 102, '2015-03-01 00:09:43.000000', 'consum', 0.0218, 'lps'),
	(418195, 102, '2015-03-01 00:09:44.000000', 'consum', 0.0225, 'lps'),
	(418196, 102, '2015-03-01 00:09:45.000000', 'consum', 0.0224, 'lps'),
	(418197, 102, '2015-03-01 00:09:46.000000', 'consum', 0.0215, 'lps'),
	(418198, 102, '2015-03-01 00:09:47.000000', 'consum', 0.0213, 'lps'),
	(418199, 102, '2015-03-01 00:09:48.000000', 'consum', 0.0212, 'lps'),
	(418200, 102, '2015-03-01 00:09:49.000000', 'consum', 0.0210, 'lps'),
	(418201, 102, '2015-03-01 00:09:50.000000', 'consum', 0.0223, 'lps'),
	(418202, 102, '2015-03-01 00:09:51.000000', 'consum', 0.0217, 'lps'),
	(418203, 102, '2015-03-01 00:09:52.000000', 'consum', 0.0227, 'lps'),
	(418204, 102, '2015-03-01 00:09:53.000000', 'consum', 0.0215, 'lps'),
	(418205, 102, '2015-03-01 00:09:54.000000', 'consum', 0.0225, 'lps'),
	(418206, 102, '2015-03-01 00:09:55.000000', 'consum', 0.0211, 'lps'),
	(418207, 102, '2015-03-01 00:09:56.000000', 'consum', 0.0211, 'lps'),
	(418208, 102, '2015-03-01 00:09:57.000000', 'consum', 0.0229, 'lps'),
	(418209, 102, '2015-03-01 00:09:58.000000', 'consum', 0.0226, 'lps'),
	(418210, 102, '2015-03-01 00:09:59.000000', 'consum', 0.0212, 'lps'),
	(418211, 102, '2015-03-01 00:10:00.000000', 'consum', 0.0211, 'lps'),
	(418212, 102, '2015-03-01 00:10:01.000000', 'consum', 0.0212, 'lps'),
	(418213, 102, '2015-03-01 00:10:02.000000', 'consum', 0.0215, 'lps'),
	(418214, 102, '2015-03-01 00:10:03.000000', 'consum', 0.0211, 'lps'),
	(418215, 102, '2015-03-01 00:10:04.000000', 'consum', 0.0219, 'lps'),
	(418216, 102, '2015-03-01 00:10:05.000000', 'consum', 0.0215, 'lps'),
	(418217, 102, '2015-03-01 00:10:06.000000', 'consum', 0.0228, 'lps'),
	(418218, 102, '2015-03-01 00:10:07.000000', 'consum', 0.0227, 'lps'),
	(418219, 102, '2015-03-01 00:10:08.000000', 'consum', 0.0219, 'lps'),
	(418220, 102, '2015-03-01 00:10:09.000000', 'consum', 0.0225, 'lps'),
	(418221, 102, '2015-03-01 00:10:10.000000', 'consum', 0.0219, 'lps'),
	(418222, 102, '2015-03-01 00:10:11.000000', 'consum', 0.0229, 'lps'),
	(418223, 102, '2015-03-01 00:10:12.000000', 'consum', 0.0221, 'lps'),
	(418224, 102, '2015-03-01 00:10:13.000000', 'consum', 0.0226, 'lps'),
	(418225, 102, '2015-03-01 00:10:14.000000', 'consum', 0.0220, 'lps'),
	(418226, 102, '2015-03-01 00:10:15.000000', 'consum', 0.0210, 'lps'),
	(418227, 102, '2015-03-01 00:10:16.000000', 'consum', 0.0220, 'lps'),
	(418228, 102, '2015-03-01 00:10:17.000000', 'consum', 0.0223, 'lps'),
	(418229, 102, '2015-03-01 00:10:18.000000', 'consum', 0.0225, 'lps'),
	(418230, 102, '2015-03-01 00:10:19.000000', 'consum', 0.0227, 'lps'),
	(418231, 102, '2015-03-01 00:10:20.000000', 'consum', 0.0212, 'lps'),
	(418232, 102, '2015-03-01 00:10:21.000000', 'consum', 0.0227, 'lps'),
	(418233, 102, '2015-03-01 00:10:22.000000', 'consum', 0.0210, 'lps'),
	(418234, 102, '2015-03-01 00:10:23.000000', 'consum', 0.0220, 'lps'),
	(418235, 102, '2015-03-01 00:10:24.000000', 'consum', 0.0222, 'lps'),
	(418236, 102, '2015-03-01 00:10:25.000000', 'consum', 0.0220, 'lps'),
	(418237, 102, '2015-03-01 00:10:26.000000', 'consum', 0.0224, 'lps'),
	(418238, 102, '2015-03-01 00:10:27.000000', 'consum', 0.0229, 'lps'),
	(418239, 102, '2015-03-01 00:10:28.000000', 'consum', 0.0225, 'lps'),
	(418240, 102, '2015-03-01 00:10:29.000000', 'consum', 0.0227, 'lps'),
	(418241, 102, '2015-03-01 00:10:30.000000', 'consum', 0.0210, 'lps'),
	(418242, 102, '2015-03-01 00:10:31.000000', 'consum', 0.0219, 'lps'),
	(418243, 102, '2015-03-01 00:10:32.000000', 'consum', 0.0216, 'lps'),
	(418244, 102, '2015-03-01 00:10:33.000000', 'consum', 0.0214, 'lps'),
	(418245, 102, '2015-03-01 00:10:34.000000', 'consum', 0.0212, 'lps'),
	(418246, 102, '2015-03-01 00:10:35.000000', 'consum', 0.0227, 'lps'),
	(418247, 102, '2015-03-01 00:10:36.000000', 'consum', 0.0229, 'lps'),
	(418248, 102, '2015-03-01 00:10:37.000000', 'consum', 0.0217, 'lps'),
	(418249, 102, '2015-03-01 00:10:38.000000', 'consum', 0.0228, 'lps'),
	(418250, 102, '2015-03-01 00:10:39.000000', 'consum', 0.0219, 'lps'),
	(418251, 102, '2015-03-01 00:10:40.000000', 'consum', 0.0220, 'lps'),
	(418252, 102, '2015-03-01 00:10:41.000000', 'consum', 0.0213, 'lps'),
	(418253, 102, '2015-03-01 00:10:42.000000', 'consum', 0.0216, 'lps'),
	(418254, 102, '2015-03-01 00:10:43.000000', 'consum', 0.0210, 'lps'),
	(418255, 102, '2015-03-01 00:10:44.000000', 'consum', 0.0215, 'lps'),
	(418256, 102, '2015-03-01 00:10:45.000000', 'consum', 0.0215, 'lps'),
	(418257, 102, '2015-03-01 00:10:46.000000', 'consum', 0.0219, 'lps'),
	(418258, 102, '2015-03-01 00:10:47.000000', 'consum', 0.0222, 'lps'),
	(418259, 102, '2015-03-01 00:10:48.000000', 'consum', 0.0222, 'lps'),
	(418260, 102, '2015-03-01 00:10:49.000000', 'consum', 0.0217, 'lps'),
	(418261, 102, '2015-03-01 00:10:50.000000', 'consum', 0.0228, 'lps'),
	(418262, 102, '2015-03-01 00:10:51.000000', 'consum', 0.0221, 'lps'),
	(418263, 102, '2015-03-01 00:10:52.000000', 'consum', 0.0211, 'lps'),
	(418264, 102, '2015-03-01 00:10:53.000000', 'consum', 0.0224, 'lps'),
	(418265, 102, '2015-03-01 00:10:54.000000', 'consum', 0.0216, 'lps'),
	(418266, 102, '2015-03-01 00:10:55.000000', 'consum', 0.0220, 'lps'),
	(418267, 102, '2015-03-01 00:10:56.000000', 'consum', 0.0223, 'lps'),
	(418268, 102, '2015-03-01 00:10:57.000000', 'consum', 0.0224, 'lps'),
	(418269, 102, '2015-03-01 00:10:58.000000', 'consum', 0.0222, 'lps'),
	(418270, 102, '2015-03-01 00:10:59.000000', 'consum', 0.0210, 'lps'),
	(418271, 102, '2015-03-01 00:11:00.000000', 'consum', 0.0213, 'lps'),
	(418272, 102, '2015-03-01 00:11:01.000000', 'consum', 0.0226, 'lps'),
	(418273, 102, '2015-03-01 00:11:02.000000', 'consum', 0.0223, 'lps'),
	(418274, 102, '2015-03-01 00:11:03.000000', 'consum', 0.0226, 'lps'),
	(418275, 102, '2015-03-01 00:11:04.000000', 'consum', 0.0211, 'lps'),
	(418276, 102, '2015-03-01 00:11:05.000000', 'consum', 0.0226, 'lps'),
	(418277, 102, '2015-03-01 00:11:06.000000', 'consum', 0.0229, 'lps'),
	(418278, 102, '2015-03-01 00:11:07.000000', 'consum', 0.0219, 'lps'),
	(418279, 102, '2015-03-01 00:11:08.000000', 'consum', 0.0220, 'lps'),
	(418280, 102, '2015-03-01 00:11:09.000000', 'consum', 0.0210, 'lps'),
	(418281, 102, '2015-03-01 00:11:10.000000', 'consum', 0.0220, 'lps'),
	(418282, 102, '2015-03-01 00:11:11.000000', 'consum', 0.0221, 'lps'),
	(418283, 102, '2015-03-01 00:11:12.000000', 'consum', 0.0215, 'lps'),
	(418284, 102, '2015-03-01 00:11:13.000000', 'consum', 0.0221, 'lps'),
	(418285, 102, '2015-03-01 00:11:14.000000', 'consum', 0.0214, 'lps'),
	(418286, 102, '2015-03-01 00:11:15.000000', 'consum', 0.0216, 'lps'),
	(418287, 102, '2015-03-01 00:11:16.000000', 'consum', 0.0227, 'lps'),
	(418288, 102, '2015-03-01 00:11:17.000000', 'consum', 0.0220, 'lps'),
	(418289, 102, '2015-03-01 00:11:18.000000', 'consum', 0.0210, 'lps'),
	(418290, 102, '2015-03-01 00:11:19.000000', 'consum', 0.0221, 'lps'),
	(418291, 102, '2015-03-01 00:11:20.000000', 'consum', 0.0226, 'lps'),
	(418292, 102, '2015-03-01 00:11:21.000000', 'consum', 0.0216, 'lps'),
	(418293, 102, '2015-03-01 00:11:22.000000', 'consum', 0.0214, 'lps'),
	(418294, 102, '2015-03-01 00:11:23.000000', 'consum', 0.0211, 'lps'),
	(418295, 102, '2015-03-01 00:11:24.000000', 'consum', 0.0222, 'lps'),
	(418296, 102, '2015-03-01 00:11:25.000000', 'consum', 0.0228, 'lps'),
	(418297, 102, '2015-03-01 00:11:26.000000', 'consum', 0.0227, 'lps'),
	(418298, 102, '2015-03-01 00:11:27.000000', 'consum', 0.0218, 'lps'),
	(418299, 102, '2015-03-01 00:11:28.000000', 'consum', 0.0221, 'lps'),
	(418300, 102, '2015-03-01 00:11:29.000000', 'consum', 0.0222, 'lps'),
	(418301, 102, '2015-03-01 00:11:30.000000', 'consum', 0.0218, 'lps'),
	(418302, 102, '2015-03-01 00:11:31.000000', 'consum', 0.0213, 'lps'),
	(418303, 102, '2015-03-01 00:11:32.000000', 'consum', 0.0223, 'lps'),
	(418304, 102, '2015-03-01 00:11:33.000000', 'consum', 0.0226, 'lps'),
	(418305, 102, '2015-03-01 00:11:34.000000', 'consum', 0.0212, 'lps'),
	(418306, 102, '2015-03-01 00:11:35.000000', 'consum', 0.0213, 'lps'),
	(418307, 102, '2015-03-01 00:11:36.000000', 'consum', 0.0219, 'lps'),
	(418308, 102, '2015-03-01 00:11:37.000000', 'consum', 0.0228, 'lps'),
	(418309, 102, '2015-03-01 00:11:38.000000', 'consum', 0.0211, 'lps'),
	(418310, 102, '2015-03-01 00:11:39.000000', 'consum', 0.0223, 'lps'),
	(418311, 102, '2015-03-01 00:11:40.000000', 'consum', 0.0212, 'lps'),
	(418312, 102, '2015-03-01 00:11:41.000000', 'consum', 0.0221, 'lps'),
	(418313, 102, '2015-03-01 00:11:42.000000', 'consum', 0.0219, 'lps'),
	(418314, 102, '2015-03-01 00:11:43.000000', 'consum', 0.0223, 'lps'),
	(418315, 102, '2015-03-01 00:11:44.000000', 'consum', 0.0210, 'lps'),
	(418316, 102, '2015-03-01 00:11:45.000000', 'consum', 0.0212, 'lps'),
	(418317, 102, '2015-03-01 00:11:46.000000', 'consum', 0.0222, 'lps'),
	(418318, 102, '2015-03-01 00:11:47.000000', 'consum', 0.0221, 'lps'),
	(418319, 102, '2015-03-01 00:11:48.000000', 'consum', 0.0229, 'lps'),
	(418320, 102, '2015-03-01 00:11:49.000000', 'consum', 0.0214, 'lps'),
	(418321, 102, '2015-03-01 00:11:50.000000', 'consum', 0.0213, 'lps'),
	(418322, 102, '2015-03-01 00:11:51.000000', 'consum', 0.0213, 'lps'),
	(418323, 102, '2015-03-01 00:11:52.000000', 'consum', 0.0215, 'lps'),
	(418324, 102, '2015-03-01 00:11:53.000000', 'consum', 0.0228, 'lps'),
	(418325, 102, '2015-03-01 00:11:54.000000', 'consum', 0.0226, 'lps'),
	(418326, 102, '2015-03-01 00:11:55.000000', 'consum', 0.0215, 'lps'),
	(418327, 102, '2015-03-01 00:11:56.000000', 'consum', 0.0229, 'lps'),
	(418328, 102, '2015-03-01 00:11:57.000000', 'consum', 0.0210, 'lps'),
	(418329, 102, '2015-03-01 00:11:58.000000', 'consum', 0.0212, 'lps'),
	(418330, 102, '2015-03-01 00:11:59.000000', 'consum', 0.0220, 'lps'),
	(418331, 102, '2015-03-01 00:12:00.000000', 'consum', 0.0214, 'lps'),
	(418332, 102, '2015-03-01 00:12:01.000000', 'consum', 0.0220, 'lps'),
	(418333, 102, '2015-03-01 00:12:02.000000', 'consum', 0.0211, 'lps'),
	(418334, 102, '2015-03-01 00:12:03.000000', 'consum', 0.0227, 'lps'),
	(418335, 102, '2015-03-01 00:12:04.000000', 'consum', 0.0229, 'lps'),
	(418336, 102, '2015-03-01 00:12:05.000000', 'consum', 0.0216, 'lps'),
	(418337, 102, '2015-03-01 00:12:06.000000', 'consum', 0.0224, 'lps'),
	(418338, 102, '2015-03-01 00:12:07.000000', 'consum', 0.0223, 'lps'),
	(418339, 102, '2015-03-01 00:12:08.000000', 'consum', 0.0214, 'lps'),
	(418340, 102, '2015-03-01 00:12:09.000000', 'consum', 0.0229, 'lps'),
	(418341, 102, '2015-03-01 00:12:10.000000', 'consum', 0.0214, 'lps'),
	(418342, 102, '2015-03-01 00:12:11.000000', 'consum', 0.0216, 'lps'),
	(418343, 102, '2015-03-01 00:12:12.000000', 'consum', 0.0227, 'lps'),
	(418344, 102, '2015-03-01 00:12:13.000000', 'consum', 0.0218, 'lps'),
	(418345, 102, '2015-03-01 00:12:14.000000', 'consum', 0.0220, 'lps'),
	(418346, 102, '2015-03-01 00:12:15.000000', 'consum', 0.0217, 'lps'),
	(418347, 102, '2015-03-01 00:12:16.000000', 'consum', 0.0214, 'lps'),
	(418348, 102, '2015-03-01 00:12:17.000000', 'consum', 0.0211, 'lps'),
	(418349, 102, '2015-03-01 00:12:18.000000', 'consum', 0.0223, 'lps'),
	(418350, 102, '2015-03-01 00:12:19.000000', 'consum', 0.0214, 'lps'),
	(418351, 102, '2015-03-01 00:12:20.000000', 'consum', 0.0212, 'lps'),
	(418352, 102, '2015-03-01 00:12:21.000000', 'consum', 0.0226, 'lps'),
	(418353, 102, '2015-03-01 00:12:22.000000', 'consum', 0.0227, 'lps'),
	(418354, 102, '2015-03-01 00:12:23.000000', 'consum', 0.0226, 'lps'),
	(418355, 102, '2015-03-01 00:12:24.000000', 'consum', 0.0219, 'lps'),
	(418356, 102, '2015-03-01 00:12:25.000000', 'consum', 0.0210, 'lps'),
	(418357, 102, '2015-03-01 00:12:26.000000', 'consum', 0.0223, 'lps'),
	(418358, 102, '2015-03-01 00:12:27.000000', 'consum', 0.0214, 'lps'),
	(418359, 102, '2015-03-01 00:12:28.000000', 'consum', 0.0212, 'lps'),
	(418360, 102, '2015-03-01 00:12:29.000000', 'consum', 0.0227, 'lps'),
	(418361, 102, '2015-03-01 00:12:30.000000', 'consum', 0.0210, 'lps'),
	(418362, 102, '2015-03-01 00:12:31.000000', 'consum', 0.0218, 'lps'),
	(418363, 102, '2015-03-01 00:12:32.000000', 'consum', 0.0212, 'lps'),
	(418364, 102, '2015-03-01 00:12:33.000000', 'consum', 0.0216, 'lps'),
	(418365, 102, '2015-03-01 00:12:34.000000', 'consum', 0.0215, 'lps'),
	(418366, 102, '2015-03-01 00:12:35.000000', 'consum', 0.0216, 'lps'),
	(418367, 102, '2015-03-01 00:12:36.000000', 'consum', 0.0226, 'lps'),
	(418368, 102, '2015-03-01 00:12:37.000000', 'consum', 0.0211, 'lps'),
	(418369, 102, '2015-03-01 00:12:38.000000', 'consum', 0.0210, 'lps'),
	(418370, 102, '2015-03-01 00:12:39.000000', 'consum', 0.0228, 'lps'),
	(418371, 102, '2015-03-01 00:12:40.000000', 'consum', 0.0219, 'lps'),
	(418372, 102, '2015-03-01 00:12:41.000000', 'consum', 0.0221, 'lps'),
	(418373, 102, '2015-03-01 00:12:42.000000', 'consum', 0.0218, 'lps'),
	(418374, 102, '2015-03-01 00:12:43.000000', 'consum', 0.0218, 'lps'),
	(418375, 102, '2015-03-01 00:12:44.000000', 'consum', 0.0225, 'lps'),
	(418376, 102, '2015-03-01 00:12:45.000000', 'consum', 0.0221, 'lps'),
	(418377, 102, '2015-03-01 00:12:46.000000', 'consum', 0.0221, 'lps'),
	(418378, 102, '2015-03-01 00:12:47.000000', 'consum', 0.0211, 'lps'),
	(418379, 102, '2015-03-01 00:12:48.000000', 'consum', 0.0225, 'lps'),
	(418380, 102, '2015-03-01 00:12:49.000000', 'consum', 0.0223, 'lps'),
	(418381, 102, '2015-03-01 00:12:50.000000', 'consum', 0.0228, 'lps'),
	(418382, 102, '2015-03-01 00:12:51.000000', 'consum', 0.0223, 'lps'),
	(418383, 102, '2015-03-01 00:12:52.000000', 'consum', 0.0222, 'lps'),
	(418384, 102, '2015-03-01 00:12:53.000000', 'consum', 0.0210, 'lps'),
	(418385, 102, '2015-03-01 00:12:54.000000', 'consum', 0.0214, 'lps'),
	(418386, 102, '2015-03-01 00:12:55.000000', 'consum', 0.0210, 'lps'),
	(418387, 102, '2015-03-01 00:12:56.000000', 'consum', 0.0219, 'lps'),
	(418388, 102, '2015-03-01 00:12:57.000000', 'consum', 0.0214, 'lps'),
	(418389, 102, '2015-03-01 00:12:58.000000', 'consum', 0.0224, 'lps'),
	(418390, 102, '2015-03-01 00:12:59.000000', 'consum', 0.0228, 'lps'),
	(418391, 102, '2015-03-01 00:13:00.000000', 'consum', 0.0219, 'lps'),
	(418392, 102, '2015-03-01 00:13:01.000000', 'consum', 0.0222, 'lps'),
	(418393, 102, '2015-03-01 00:13:02.000000', 'consum', 0.0221, 'lps'),
	(418394, 102, '2015-03-01 00:13:03.000000', 'consum', 0.0212, 'lps'),
	(418395, 102, '2015-03-01 00:13:04.000000', 'consum', 0.0228, 'lps'),
	(418396, 102, '2015-03-01 00:13:05.000000', 'consum', 0.0214, 'lps'),
	(418397, 102, '2015-03-01 00:13:06.000000', 'consum', 0.0216, 'lps'),
	(418398, 102, '2015-03-01 00:13:07.000000', 'consum', 0.0228, 'lps'),
	(418399, 102, '2015-03-01 00:13:08.000000', 'consum', 0.0223, 'lps'),
	(418400, 102, '2015-03-01 00:13:09.000000', 'consum', 0.0222, 'lps'),
	(418401, 102, '2015-03-01 00:13:10.000000', 'consum', 0.0210, 'lps'),
	(418402, 102, '2015-03-01 00:13:11.000000', 'consum', 0.0217, 'lps'),
	(418403, 102, '2015-03-01 00:13:12.000000', 'consum', 0.0225, 'lps'),
	(418404, 102, '2015-03-01 00:13:13.000000', 'consum', 0.0223, 'lps'),
	(418405, 102, '2015-03-01 00:13:14.000000', 'consum', 0.0211, 'lps'),
	(418406, 102, '2015-03-01 00:13:15.000000', 'consum', 0.0217, 'lps'),
	(418407, 102, '2015-03-01 00:13:16.000000', 'consum', 0.0222, 'lps'),
	(418408, 102, '2015-03-01 00:13:17.000000', 'consum', 0.0212, 'lps'),
	(418409, 102, '2015-03-01 00:13:18.000000', 'consum', 0.0221, 'lps'),
	(418410, 102, '2015-03-01 00:13:19.000000', 'consum', 0.0223, 'lps'),
	(418411, 102, '2015-03-01 00:13:20.000000', 'consum', 0.0220, 'lps'),
	(418412, 102, '2015-03-01 00:13:21.000000', 'consum', 0.0220, 'lps'),
	(418413, 102, '2015-03-01 00:13:22.000000', 'consum', 0.0213, 'lps'),
	(418414, 102, '2015-03-01 00:13:23.000000', 'consum', 0.0213, 'lps'),
	(418415, 102, '2015-03-01 00:13:24.000000', 'consum', 0.0218, 'lps'),
	(418416, 102, '2015-03-01 00:13:25.000000', 'consum', 0.0221, 'lps'),
	(418417, 102, '2015-03-01 00:13:26.000000', 'consum', 0.0221, 'lps'),
	(418418, 102, '2015-03-01 00:13:27.000000', 'consum', 0.0212, 'lps'),
	(418419, 102, '2015-03-01 00:13:28.000000', 'consum', 0.0227, 'lps'),
	(418420, 102, '2015-03-01 00:13:29.000000', 'consum', 0.0211, 'lps'),
	(418421, 102, '2015-03-01 00:13:30.000000', 'consum', 0.0225, 'lps'),
	(418422, 102, '2015-03-01 00:13:31.000000', 'consum', 0.0222, 'lps'),
	(418423, 102, '2015-03-01 00:13:32.000000', 'consum', 0.0225, 'lps'),
	(418424, 102, '2015-03-01 00:13:33.000000', 'consum', 0.0211, 'lps'),
	(418425, 102, '2015-03-01 00:13:34.000000', 'consum', 0.0228, 'lps'),
	(418426, 102, '2015-03-01 00:13:35.000000', 'consum', 0.0219, 'lps'),
	(418427, 102, '2015-03-01 00:13:36.000000', 'consum', 0.0222, 'lps'),
	(418428, 102, '2015-03-01 00:13:37.000000', 'consum', 0.0222, 'lps'),
	(418429, 102, '2015-03-01 00:13:38.000000', 'consum', 0.0216, 'lps'),
	(418430, 102, '2015-03-01 00:13:39.000000', 'consum', 0.0226, 'lps'),
	(418431, 102, '2015-03-01 00:13:40.000000', 'consum', 0.0211, 'lps'),
	(418432, 102, '2015-03-01 00:13:41.000000', 'consum', 0.0226, 'lps'),
	(418433, 102, '2015-03-01 00:13:42.000000', 'consum', 0.0227, 'lps'),
	(418434, 102, '2015-03-01 00:13:43.000000', 'consum', 0.0210, 'lps'),
	(418435, 102, '2015-03-01 00:13:44.000000', 'consum', 0.0217, 'lps'),
	(418436, 102, '2015-03-01 00:13:45.000000', 'consum', 0.0228, 'lps'),
	(418437, 102, '2015-03-01 00:13:46.000000', 'consum', 0.0217, 'lps'),
	(418438, 102, '2015-03-01 00:13:47.000000', 'consum', 0.0212, 'lps'),
	(418439, 102, '2015-03-01 00:13:48.000000', 'consum', 0.0220, 'lps'),
	(418440, 102, '2015-03-01 00:13:49.000000', 'consum', 0.0216, 'lps'),
	(418441, 102, '2015-03-01 00:13:50.000000', 'consum', 0.0229, 'lps'),
	(418442, 102, '2015-03-01 00:13:51.000000', 'consum', 0.0226, 'lps'),
	(418443, 102, '2015-03-01 00:13:52.000000', 'consum', 0.0216, 'lps'),
	(418444, 102, '2015-03-01 00:13:53.000000', 'consum', 0.0212, 'lps'),
	(418445, 102, '2015-03-01 00:13:54.000000', 'consum', 0.0223, 'lps'),
	(418446, 102, '2015-03-01 00:13:55.000000', 'consum', 0.0228, 'lps'),
	(418447, 102, '2015-03-01 00:13:56.000000', 'consum', 0.0221, 'lps'),
	(418448, 102, '2015-03-01 00:13:57.000000', 'consum', 0.0214, 'lps'),
	(418449, 102, '2015-03-01 00:13:58.000000', 'consum', 0.0215, 'lps'),
	(418450, 102, '2015-03-01 00:13:59.000000', 'consum', 0.0223, 'lps'),
	(418451, 102, '2015-03-01 00:14:00.000000', 'consum', 0.0223, 'lps'),
	(418452, 102, '2015-03-01 00:14:01.000000', 'consum', 0.0215, 'lps'),
	(418453, 102, '2015-03-01 00:14:02.000000', 'consum', 0.0218, 'lps'),
	(418454, 102, '2015-03-01 00:14:03.000000', 'consum', 0.0215, 'lps'),
	(418455, 102, '2015-03-01 00:14:04.000000', 'consum', 0.0212, 'lps'),
	(418456, 102, '2015-03-01 00:14:05.000000', 'consum', 0.0226, 'lps'),
	(418457, 102, '2015-03-01 00:14:06.000000', 'consum', 0.0224, 'lps'),
	(418458, 102, '2015-03-01 00:14:07.000000', 'consum', 0.0214, 'lps'),
	(418459, 102, '2015-03-01 00:14:08.000000', 'consum', 0.0229, 'lps'),
	(418460, 102, '2015-03-01 00:14:09.000000', 'consum', 0.0211, 'lps'),
	(418461, 102, '2015-03-01 00:14:10.000000', 'consum', 0.0220, 'lps'),
	(418462, 102, '2015-03-01 00:14:11.000000', 'consum', 0.0217, 'lps'),
	(418463, 102, '2015-03-01 00:14:12.000000', 'consum', 0.0214, 'lps'),
	(418464, 102, '2015-03-01 00:14:13.000000', 'consum', 0.0213, 'lps'),
	(418465, 102, '2015-03-01 00:14:14.000000', 'consum', 0.0211, 'lps'),
	(418466, 102, '2015-03-01 00:14:15.000000', 'consum', 0.0225, 'lps'),
	(418467, 102, '2015-03-01 00:14:16.000000', 'consum', 0.0225, 'lps'),
	(418468, 102, '2015-03-01 00:14:17.000000', 'consum', 0.0221, 'lps'),
	(418469, 102, '2015-03-01 00:14:18.000000', 'consum', 0.0220, 'lps'),
	(418470, 102, '2015-03-01 00:14:19.000000', 'consum', 0.0229, 'lps'),
	(418471, 102, '2015-03-01 00:14:20.000000', 'consum', 0.0213, 'lps'),
	(418472, 102, '2015-03-01 00:14:21.000000', 'consum', 0.0211, 'lps'),
	(418473, 102, '2015-03-01 00:14:22.000000', 'consum', 0.0227, 'lps'),
	(418474, 102, '2015-03-01 00:14:23.000000', 'consum', 0.0213, 'lps'),
	(418475, 102, '2015-03-01 00:14:24.000000', 'consum', 0.0215, 'lps'),
	(418476, 102, '2015-03-01 00:14:25.000000', 'consum', 0.0227, 'lps'),
	(418477, 102, '2015-03-01 00:14:26.000000', 'consum', 0.0221, 'lps'),
	(418478, 102, '2015-03-01 00:14:27.000000', 'consum', 0.0212, 'lps'),
	(418479, 102, '2015-03-01 00:14:28.000000', 'consum', 0.0227, 'lps'),
	(418480, 102, '2015-03-01 00:14:29.000000', 'consum', 0.0211, 'lps'),
	(418481, 102, '2015-03-01 00:14:30.000000', 'consum', 0.0223, 'lps'),
	(418482, 102, '2015-03-01 00:14:31.000000', 'consum', 0.0215, 'lps'),
	(418483, 102, '2015-03-01 00:14:32.000000', 'consum', 0.0213, 'lps'),
	(418484, 102, '2015-03-01 00:14:33.000000', 'consum', 0.0214, 'lps'),
	(418485, 102, '2015-03-01 00:14:34.000000', 'consum', 0.0219, 'lps'),
	(418486, 102, '2015-03-01 00:14:35.000000', 'consum', 0.0226, 'lps'),
	(418487, 102, '2015-03-01 00:14:36.000000', 'consum', 0.0223, 'lps'),
	(418488, 102, '2015-03-01 00:14:37.000000', 'consum', 0.0227, 'lps'),
	(418489, 102, '2015-03-01 00:14:38.000000', 'consum', 0.0215, 'lps'),
	(418490, 102, '2015-03-01 00:14:39.000000', 'consum', 0.0224, 'lps'),
	(418491, 102, '2015-03-01 00:14:40.000000', 'consum', 0.0227, 'lps'),
	(418492, 102, '2015-03-01 00:14:41.000000', 'consum', 0.0215, 'lps'),
	(418493, 102, '2015-03-01 00:14:42.000000', 'consum', 0.0225, 'lps'),
	(418494, 102, '2015-03-01 00:14:43.000000', 'consum', 0.0227, 'lps'),
	(418495, 102, '2015-03-01 00:14:44.000000', 'consum', 0.0214, 'lps'),
	(418496, 102, '2015-03-01 00:14:45.000000', 'consum', 0.0218, 'lps'),
	(418497, 102, '2015-03-01 00:14:46.000000', 'consum', 0.0218, 'lps'),
	(418498, 102, '2015-03-01 00:14:47.000000', 'consum', 0.0228, 'lps'),
	(418499, 102, '2015-03-01 00:14:48.000000', 'consum', 0.0215, 'lps'),
	(418500, 102, '2015-03-01 00:14:49.000000', 'consum', 0.0223, 'lps'),
	(418501, 102, '2015-03-01 00:14:50.000000', 'consum', 0.0218, 'lps'),
	(418502, 102, '2015-03-01 00:14:51.000000', 'consum', 0.0213, 'lps'),
	(418503, 102, '2015-03-01 00:14:52.000000', 'consum', 0.0223, 'lps'),
	(418504, 102, '2015-03-01 00:14:53.000000', 'consum', 0.0226, 'lps'),
	(418505, 102, '2015-03-01 00:14:54.000000', 'consum', 0.0212, 'lps'),
	(418506, 102, '2015-03-01 00:14:55.000000', 'consum', 0.0213, 'lps'),
	(418507, 102, '2015-03-01 00:14:56.000000', 'consum', 0.0218, 'lps'),
	(418508, 102, '2015-03-01 00:14:57.000000', 'consum', 0.0220, 'lps'),
	(418509, 102, '2015-03-01 00:14:58.000000', 'consum', 0.0218, 'lps'),
	(418510, 102, '2015-03-01 00:14:59.000000', 'consum', 0.0219, 'lps'),
	(418511, 102, '2015-03-01 00:15:00.000000', 'consum', 0.0212, 'lps'),
	(418512, 102, '2015-03-01 00:15:01.000000', 'consum', 0.0215, 'lps'),
	(418513, 102, '2015-03-01 00:15:02.000000', 'consum', 0.0227, 'lps'),
	(418514, 102, '2015-03-01 00:15:03.000000', 'consum', 0.0222, 'lps'),
	(418515, 102, '2015-03-01 00:15:04.000000', 'consum', 0.0221, 'lps'),
	(418516, 102, '2015-03-01 00:15:05.000000', 'consum', 0.0228, 'lps'),
	(418517, 102, '2015-03-01 00:15:06.000000', 'consum', 0.0227, 'lps'),
	(418518, 102, '2015-03-01 00:15:07.000000', 'consum', 0.0223, 'lps'),
	(418519, 102, '2015-03-01 00:15:08.000000', 'consum', 0.0225, 'lps'),
	(418520, 102, '2015-03-01 00:15:09.000000', 'consum', 0.0227, 'lps'),
	(418521, 102, '2015-03-01 00:15:10.000000', 'consum', 0.0229, 'lps'),
	(418522, 102, '2015-03-01 00:15:11.000000', 'consum', 0.0215, 'lps'),
	(418523, 102, '2015-03-01 00:15:12.000000', 'consum', 0.0219, 'lps'),
	(418524, 102, '2015-03-01 00:15:13.000000', 'consum', 0.0222, 'lps'),
	(418525, 102, '2015-03-01 00:15:14.000000', 'consum', 0.0221, 'lps'),
	(418526, 102, '2015-03-01 00:15:15.000000', 'consum', 0.0212, 'lps'),
	(418527, 102, '2015-03-01 00:15:16.000000', 'consum', 0.0225, 'lps'),
	(418528, 102, '2015-03-01 00:15:17.000000', 'consum', 0.0223, 'lps'),
	(418529, 102, '2015-03-01 00:15:18.000000', 'consum', 0.0227, 'lps'),
	(418530, 102, '2015-03-01 00:15:19.000000', 'consum', 0.0216, 'lps'),
	(418531, 102, '2015-03-01 00:15:20.000000', 'consum', 0.0211, 'lps'),
	(418532, 102, '2015-03-01 00:15:21.000000', 'consum', 0.0216, 'lps'),
	(418533, 102, '2015-03-01 00:15:22.000000', 'consum', 0.0217, 'lps'),
	(418534, 102, '2015-03-01 00:15:23.000000', 'consum', 0.0229, 'lps'),
	(418535, 102, '2015-03-01 00:15:24.000000', 'consum', 0.0224, 'lps'),
	(418536, 102, '2015-03-01 00:15:25.000000', 'consum', 0.0224, 'lps'),
	(418537, 102, '2015-03-01 00:15:26.000000', 'consum', 0.0218, 'lps'),
	(418538, 102, '2015-03-01 00:15:27.000000', 'consum', 0.0229, 'lps'),
	(418539, 102, '2015-03-01 00:15:28.000000', 'consum', 0.0222, 'lps'),
	(418540, 102, '2015-03-01 00:15:29.000000', 'consum', 0.0212, 'lps'),
	(418541, 102, '2015-03-01 00:15:30.000000', 'consum', 0.0224, 'lps'),
	(418542, 102, '2015-03-01 00:15:31.000000', 'consum', 0.0216, 'lps'),
	(418543, 102, '2015-03-01 00:15:32.000000', 'consum', 0.0219, 'lps'),
	(418544, 102, '2015-03-01 00:15:33.000000', 'consum', 0.0219, 'lps'),
	(418545, 102, '2015-03-01 00:15:34.000000', 'consum', 0.0225, 'lps'),
	(418546, 102, '2015-03-01 00:15:35.000000', 'consum', 0.0221, 'lps'),
	(418547, 102, '2015-03-01 00:15:36.000000', 'consum', 0.0221, 'lps'),
	(418548, 102, '2015-03-01 00:15:37.000000', 'consum', 0.0210, 'lps'),
	(418549, 102, '2015-03-01 00:15:38.000000', 'consum', 0.0218, 'lps'),
	(418550, 102, '2015-03-01 00:15:39.000000', 'consum', 0.0211, 'lps'),
	(418551, 102, '2015-03-01 00:15:40.000000', 'consum', 0.0211, 'lps'),
	(418552, 102, '2015-03-01 00:15:41.000000', 'consum', 0.0213, 'lps'),
	(418553, 102, '2015-03-01 00:15:42.000000', 'consum', 0.0224, 'lps'),
	(418554, 102, '2015-03-01 00:15:43.000000', 'consum', 0.0212, 'lps'),
	(418555, 102, '2015-03-01 00:15:44.000000', 'consum', 0.0218, 'lps'),
	(418556, 102, '2015-03-01 00:15:45.000000', 'consum', 0.0224, 'lps'),
	(418557, 102, '2015-03-01 00:15:46.000000', 'consum', 0.0217, 'lps'),
	(418558, 102, '2015-03-01 00:15:47.000000', 'consum', 0.0223, 'lps'),
	(418559, 102, '2015-03-01 00:15:48.000000', 'consum', 0.0213, 'lps'),
	(418560, 102, '2015-03-01 00:15:49.000000', 'consum', 0.0228, 'lps'),
	(418561, 102, '2015-03-01 00:15:50.000000', 'consum', 0.0229, 'lps'),
	(418562, 102, '2015-03-01 00:15:51.000000', 'consum', 0.0214, 'lps'),
	(418563, 102, '2015-03-01 00:15:52.000000', 'consum', 0.0211, 'lps'),
	(418564, 102, '2015-03-01 00:15:53.000000', 'consum', 0.0224, 'lps'),
	(418565, 102, '2015-03-01 00:15:54.000000', 'consum', 0.0217, 'lps'),
	(418566, 102, '2015-03-01 00:15:55.000000', 'consum', 0.0226, 'lps'),
	(418567, 102, '2015-03-01 00:15:56.000000', 'consum', 0.0229, 'lps'),
	(418568, 102, '2015-03-01 00:15:57.000000', 'consum', 0.0218, 'lps'),
	(418569, 102, '2015-03-01 00:15:58.000000', 'consum', 0.0214, 'lps'),
	(418570, 102, '2015-03-01 00:15:59.000000', 'consum', 0.0224, 'lps'),
	(418571, 102, '2015-03-01 00:16:00.000000', 'consum', 0.0210, 'lps'),
	(418572, 102, '2015-03-01 00:16:01.000000', 'consum', 0.0227, 'lps'),
	(418573, 102, '2015-03-01 00:16:02.000000', 'consum', 0.0218, 'lps'),
	(418574, 102, '2015-03-01 00:16:03.000000', 'consum', 0.0217, 'lps'),
	(418575, 102, '2015-03-01 00:16:04.000000', 'consum', 0.0221, 'lps'),
	(418576, 102, '2015-03-01 00:16:05.000000', 'consum', 0.0226, 'lps'),
	(418577, 102, '2015-03-01 00:16:06.000000', 'consum', 0.0216, 'lps'),
	(418578, 102, '2015-03-01 00:16:07.000000', 'consum', 0.0212, 'lps'),
	(418579, 102, '2015-03-01 00:16:08.000000', 'consum', 0.0222, 'lps'),
	(418580, 102, '2015-03-01 00:16:09.000000', 'consum', 0.0227, 'lps'),
	(418581, 102, '2015-03-01 00:16:10.000000', 'consum', 0.0219, 'lps'),
	(418582, 102, '2015-03-01 00:16:11.000000', 'consum', 0.0224, 'lps'),
	(418583, 102, '2015-03-01 00:16:12.000000', 'consum', 0.0212, 'lps'),
	(418584, 102, '2015-03-01 00:16:13.000000', 'consum', 0.0221, 'lps'),
	(418585, 102, '2015-03-01 00:16:14.000000', 'consum', 0.0219, 'lps'),
	(418586, 102, '2015-03-01 00:16:15.000000', 'consum', 0.0222, 'lps'),
	(418587, 102, '2015-03-01 00:16:16.000000', 'consum', 0.0223, 'lps'),
	(418588, 102, '2015-03-01 00:16:17.000000', 'consum', 0.0221, 'lps'),
	(418589, 102, '2015-03-01 00:16:18.000000', 'consum', 0.0227, 'lps'),
	(418590, 102, '2015-03-01 00:16:19.000000', 'consum', 0.0222, 'lps'),
	(418591, 102, '2015-03-01 00:16:20.000000', 'consum', 0.0217, 'lps'),
	(418592, 102, '2015-03-01 00:16:21.000000', 'consum', 0.0212, 'lps'),
	(418593, 102, '2015-03-01 00:16:22.000000', 'consum', 0.0219, 'lps'),
	(418594, 102, '2015-03-01 00:16:23.000000', 'consum', 0.0229, 'lps'),
	(418595, 102, '2015-03-01 00:16:24.000000', 'consum', 0.0219, 'lps'),
	(418596, 102, '2015-03-01 00:16:25.000000', 'consum', 0.0220, 'lps'),
	(418597, 102, '2015-03-01 00:16:26.000000', 'consum', 0.0213, 'lps'),
	(418598, 102, '2015-03-01 00:16:27.000000', 'consum', 0.0214, 'lps'),
	(418599, 102, '2015-03-01 00:16:28.000000', 'consum', 0.0223, 'lps'),
	(418600, 102, '2015-03-01 00:16:29.000000', 'consum', 0.0224, 'lps'),
	(418601, 102, '2015-03-01 00:16:30.000000', 'consum', 0.0220, 'lps'),
	(418602, 102, '2015-03-01 00:16:31.000000', 'consum', 0.0219, 'lps'),
	(418603, 102, '2015-03-01 00:16:32.000000', 'consum', 0.0227, 'lps'),
	(418604, 102, '2015-03-01 00:16:33.000000', 'consum', 0.0227, 'lps'),
	(418605, 102, '2015-03-01 00:16:34.000000', 'consum', 0.0226, 'lps'),
	(418606, 102, '2015-03-01 00:16:35.000000', 'consum', 0.0219, 'lps'),
	(418607, 102, '2015-03-01 00:16:36.000000', 'consum', 0.0227, 'lps'),
	(418608, 102, '2015-03-01 00:16:37.000000', 'consum', 0.0228, 'lps'),
	(418609, 102, '2015-03-01 00:16:38.000000', 'consum', 0.0229, 'lps'),
	(418610, 102, '2015-03-01 00:16:39.000000', 'consum', 0.0212, 'lps'),
	(418611, 102, '2015-03-01 00:16:40.000000', 'consum', 0.0224, 'lps'),
	(418612, 102, '2015-03-01 00:16:41.000000', 'consum', 0.0216, 'lps'),
	(418613, 102, '2015-03-01 00:16:42.000000', 'consum', 0.0215, 'lps'),
	(418614, 102, '2015-03-01 00:16:43.000000', 'consum', 0.0220, 'lps'),
	(418615, 102, '2015-03-01 00:16:44.000000', 'consum', 0.0224, 'lps'),
	(418616, 102, '2015-03-01 00:16:45.000000', 'consum', 0.0211, 'lps'),
	(418617, 102, '2015-03-01 00:16:46.000000', 'consum', 0.0211, 'lps'),
	(418618, 102, '2015-03-01 00:16:47.000000', 'consum', 0.0216, 'lps'),
	(418619, 102, '2015-03-01 00:16:48.000000', 'consum', 0.0217, 'lps'),
	(418620, 102, '2015-03-01 00:16:49.000000', 'consum', 0.0228, 'lps'),
	(418621, 102, '2015-03-01 00:16:50.000000', 'consum', 0.0219, 'lps'),
	(418622, 102, '2015-03-01 00:16:51.000000', 'consum', 0.0220, 'lps'),
	(418623, 102, '2015-03-01 00:16:52.000000', 'consum', 0.0216, 'lps'),
	(418624, 102, '2015-03-01 00:16:53.000000', 'consum', 0.0211, 'lps'),
	(418625, 102, '2015-03-01 00:16:54.000000', 'consum', 0.0217, 'lps'),
	(418626, 102, '2015-03-01 00:16:55.000000', 'consum', 0.0221, 'lps'),
	(418627, 102, '2015-03-01 00:16:56.000000', 'consum', 0.0226, 'lps'),
	(418628, 102, '2015-03-01 00:16:57.000000', 'consum', 0.0218, 'lps'),
	(418629, 102, '2015-03-01 00:16:58.000000', 'consum', 0.0222, 'lps'),
	(418630, 102, '2015-03-01 00:16:59.000000', 'consum', 0.0225, 'lps'),
	(418631, 102, '2015-03-01 00:17:00.000000', 'consum', 0.0210, 'lps'),
	(418632, 102, '2015-03-01 00:17:01.000000', 'consum', 0.0226, 'lps'),
	(418633, 102, '2015-03-01 00:17:02.000000', 'consum', 0.0212, 'lps'),
	(418634, 102, '2015-03-01 00:17:03.000000', 'consum', 0.0213, 'lps'),
	(418635, 102, '2015-03-01 00:17:04.000000', 'consum', 0.0217, 'lps'),
	(418636, 102, '2015-03-01 00:17:05.000000', 'consum', 0.0219, 'lps'),
	(418637, 102, '2015-03-01 00:17:06.000000', 'consum', 0.0213, 'lps'),
	(418638, 102, '2015-03-01 00:17:07.000000', 'consum', 0.0217, 'lps'),
	(418639, 102, '2015-03-01 00:17:08.000000', 'consum', 0.0219, 'lps'),
	(418640, 102, '2015-03-01 00:17:09.000000', 'consum', 0.0212, 'lps'),
	(418641, 102, '2015-03-01 00:17:10.000000', 'consum', 0.0214, 'lps'),
	(418642, 102, '2015-03-01 00:17:11.000000', 'consum', 0.0226, 'lps'),
	(418643, 102, '2015-03-01 00:17:12.000000', 'consum', 0.0216, 'lps'),
	(418644, 102, '2015-03-01 00:17:13.000000', 'consum', 0.0212, 'lps'),
	(418645, 102, '2015-03-01 00:17:14.000000', 'consum', 0.0225, 'lps'),
	(418646, 102, '2015-03-01 00:17:15.000000', 'consum', 0.0220, 'lps'),
	(418647, 102, '2015-03-01 00:17:16.000000', 'consum', 0.0217, 'lps'),
	(418648, 102, '2015-03-01 00:17:17.000000', 'consum', 0.0212, 'lps'),
	(418649, 102, '2015-03-01 00:17:18.000000', 'consum', 0.0222, 'lps'),
	(418650, 102, '2015-03-01 00:17:19.000000', 'consum', 0.0222, 'lps'),
	(418651, 102, '2015-03-01 00:17:20.000000', 'consum', 0.0215, 'lps'),
	(418652, 102, '2015-03-01 00:17:21.000000', 'consum', 0.0220, 'lps'),
	(418653, 102, '2015-03-01 00:17:22.000000', 'consum', 0.0224, 'lps'),
	(418654, 102, '2015-03-01 00:17:23.000000', 'consum', 0.0210, 'lps'),
	(418655, 102, '2015-03-01 00:17:24.000000', 'consum', 0.0211, 'lps'),
	(418656, 102, '2015-03-01 00:17:25.000000', 'consum', 0.0212, 'lps'),
	(418657, 102, '2015-03-01 00:17:26.000000', 'consum', 0.0221, 'lps'),
	(418658, 102, '2015-03-01 00:17:27.000000', 'consum', 0.0218, 'lps'),
	(418659, 102, '2015-03-01 00:17:28.000000', 'consum', 0.0220, 'lps'),
	(418660, 102, '2015-03-01 00:17:29.000000', 'consum', 0.0213, 'lps'),
	(418661, 102, '2015-03-01 00:17:30.000000', 'consum', 0.0216, 'lps'),
	(418662, 102, '2015-03-01 00:17:31.000000', 'consum', 0.0213, 'lps'),
	(418663, 102, '2015-03-01 00:17:32.000000', 'consum', 0.0225, 'lps'),
	(418664, 102, '2015-03-01 00:17:33.000000', 'consum', 0.0219, 'lps'),
	(418665, 102, '2015-03-01 00:17:34.000000', 'consum', 0.0228, 'lps'),
	(418666, 102, '2015-03-01 00:17:35.000000', 'consum', 0.0217, 'lps'),
	(418667, 102, '2015-03-01 00:17:36.000000', 'consum', 0.0228, 'lps'),
	(418668, 102, '2015-03-01 00:17:37.000000', 'consum', 0.0220, 'lps'),
	(418669, 102, '2015-03-01 00:17:38.000000', 'consum', 0.0226, 'lps'),
	(418670, 102, '2015-03-01 00:17:39.000000', 'consum', 0.0223, 'lps'),
	(418671, 102, '2015-03-01 00:17:40.000000', 'consum', 0.0227, 'lps'),
	(418672, 102, '2015-03-01 00:17:41.000000', 'consum', 0.0215, 'lps'),
	(418673, 102, '2015-03-01 00:17:42.000000', 'consum', 0.0227, 'lps'),
	(418674, 102, '2015-03-01 00:17:43.000000', 'consum', 0.0219, 'lps'),
	(418675, 102, '2015-03-01 00:17:44.000000', 'consum', 0.0225, 'lps'),
	(418676, 102, '2015-03-01 00:17:45.000000', 'consum', 0.0219, 'lps'),
	(418677, 102, '2015-03-01 00:17:46.000000', 'consum', 0.0229, 'lps'),
	(418678, 102, '2015-03-01 00:17:47.000000', 'consum', 0.0221, 'lps'),
	(418679, 102, '2015-03-01 00:17:48.000000', 'consum', 0.0226, 'lps'),
	(418680, 102, '2015-03-01 00:17:49.000000', 'consum', 0.0220, 'lps'),
	(418681, 102, '2015-03-01 00:17:50.000000', 'consum', 0.0213, 'lps'),
	(418682, 102, '2015-03-01 00:17:51.000000', 'consum', 0.0215, 'lps'),
	(418683, 102, '2015-03-01 00:17:52.000000', 'consum', 0.0226, 'lps'),
	(418684, 102, '2015-03-01 00:17:53.000000', 'consum', 0.0217, 'lps'),
	(418685, 102, '2015-03-01 00:17:54.000000', 'consum', 0.0217, 'lps'),
	(418686, 102, '2015-03-01 00:17:55.000000', 'consum', 0.0225, 'lps'),
	(418687, 102, '2015-03-01 00:17:56.000000', 'consum', 0.0225, 'lps'),
	(418688, 102, '2015-03-01 00:17:57.000000', 'consum', 0.0218, 'lps'),
	(418689, 102, '2015-03-01 00:17:58.000000', 'consum', 0.0228, 'lps'),
	(418690, 102, '2015-03-01 00:17:59.000000', 'consum', 0.0214, 'lps'),
	(418691, 102, '2015-03-01 00:18:00.000000', 'consum', 0.0217, 'lps'),
	(418692, 102, '2015-03-01 00:18:01.000000', 'consum', 0.0213, 'lps'),
	(418693, 102, '2015-03-01 00:18:02.000000', 'consum', 0.0226, 'lps'),
	(418694, 102, '2015-03-01 00:18:03.000000', 'consum', 0.0220, 'lps'),
	(418695, 102, '2015-03-01 00:18:04.000000', 'consum', 0.0215, 'lps'),
	(418696, 102, '2015-03-01 00:18:05.000000', 'consum', 0.0223, 'lps'),
	(418697, 102, '2015-03-01 00:18:06.000000', 'consum', 0.0220, 'lps'),
	(418698, 102, '2015-03-01 00:18:07.000000', 'consum', 0.0223, 'lps'),
	(418699, 102, '2015-03-01 00:18:08.000000', 'consum', 0.0226, 'lps'),
	(418700, 102, '2015-03-01 00:18:09.000000', 'consum', 0.0213, 'lps'),
	(418701, 102, '2015-03-01 00:18:10.000000', 'consum', 0.0214, 'lps'),
	(418702, 102, '2015-03-01 00:18:11.000000', 'consum', 0.0225, 'lps'),
	(418703, 102, '2015-03-01 00:18:12.000000', 'consum', 0.0212, 'lps'),
	(418704, 102, '2015-03-01 00:18:13.000000', 'consum', 0.0216, 'lps'),
	(418705, 102, '2015-03-01 00:18:14.000000', 'consum', 0.0216, 'lps'),
	(418706, 102, '2015-03-01 00:18:15.000000', 'consum', 0.0220, 'lps'),
	(418707, 102, '2015-03-01 00:18:16.000000', 'consum', 0.0223, 'lps'),
	(418708, 102, '2015-03-01 00:18:17.000000', 'consum', 0.0228, 'lps'),
	(418709, 102, '2015-03-01 00:18:18.000000', 'consum', 0.0219, 'lps'),
	(418710, 102, '2015-03-01 00:18:19.000000', 'consum', 0.0224, 'lps'),
	(418711, 102, '2015-03-01 00:18:20.000000', 'consum', 0.0212, 'lps'),
	(418712, 102, '2015-03-01 00:18:21.000000', 'consum', 0.0217, 'lps'),
	(418713, 102, '2015-03-01 00:18:22.000000', 'consum', 0.0223, 'lps'),
	(418714, 102, '2015-03-01 00:18:23.000000', 'consum', 0.0211, 'lps'),
	(418715, 102, '2015-03-01 00:18:24.000000', 'consum', 0.0219, 'lps'),
	(418716, 102, '2015-03-01 00:18:25.000000', 'consum', 0.0211, 'lps'),
	(418717, 102, '2015-03-01 00:18:26.000000', 'consum', 0.0229, 'lps'),
	(418718, 102, '2015-03-01 00:18:27.000000', 'consum', 0.0223, 'lps'),
	(418719, 102, '2015-03-01 00:18:28.000000', 'consum', 0.0217, 'lps'),
	(418720, 102, '2015-03-01 00:18:29.000000', 'consum', 0.0226, 'lps'),
	(418721, 102, '2015-03-01 00:18:30.000000', 'consum', 0.0229, 'lps'),
	(418722, 102, '2015-03-01 00:18:31.000000', 'consum', 0.0217, 'lps'),
	(418723, 102, '2015-03-01 00:18:32.000000', 'consum', 0.0211, 'lps'),
	(418724, 102, '2015-03-01 00:18:33.000000', 'consum', 0.0212, 'lps'),
	(418725, 102, '2015-03-01 00:18:34.000000', 'consum', 0.0221, 'lps'),
	(418726, 102, '2015-03-01 00:18:35.000000', 'consum', 0.0216, 'lps'),
	(418727, 102, '2015-03-01 00:18:36.000000', 'consum', 0.0229, 'lps'),
	(418728, 102, '2015-03-01 00:18:37.000000', 'consum', 0.0229, 'lps'),
	(418729, 102, '2015-03-01 00:18:38.000000', 'consum', 0.0228, 'lps'),
	(418730, 102, '2015-03-01 00:18:39.000000', 'consum', 0.0224, 'lps'),
	(418731, 102, '2015-03-01 00:18:40.000000', 'consum', 0.0227, 'lps'),
	(418732, 102, '2015-03-01 00:18:41.000000', 'consum', 0.0212, 'lps'),
	(418733, 102, '2015-03-01 00:18:42.000000', 'consum', 0.0229, 'lps'),
	(418734, 102, '2015-03-01 00:18:43.000000', 'consum', 0.0218, 'lps'),
	(418735, 102, '2015-03-01 00:18:44.000000', 'consum', 0.0215, 'lps'),
	(418736, 102, '2015-03-01 00:18:45.000000', 'consum', 0.0212, 'lps'),
	(418737, 102, '2015-03-01 00:18:46.000000', 'consum', 0.0226, 'lps'),
	(418738, 102, '2015-03-01 00:18:47.000000', 'consum', 0.0225, 'lps'),
	(418739, 102, '2015-03-01 00:18:48.000000', 'consum', 0.0218, 'lps'),
	(418740, 102, '2015-03-01 00:18:49.000000', 'consum', 0.0224, 'lps'),
	(418741, 102, '2015-03-01 00:18:50.000000', 'consum', 0.0219, 'lps'),
	(418742, 102, '2015-03-01 00:18:51.000000', 'consum', 0.0212, 'lps'),
	(418743, 102, '2015-03-01 00:18:52.000000', 'consum', 0.0215, 'lps'),
	(418744, 102, '2015-03-01 00:18:53.000000', 'consum', 0.0228, 'lps'),
	(418745, 102, '2015-03-01 00:18:54.000000', 'consum', 0.0227, 'lps'),
	(418746, 102, '2015-03-01 00:18:55.000000', 'consum', 0.0222, 'lps'),
	(418747, 102, '2015-03-01 00:18:56.000000', 'consum', 0.0219, 'lps'),
	(418748, 102, '2015-03-01 00:18:57.000000', 'consum', 0.0219, 'lps'),
	(418749, 102, '2015-03-01 00:18:58.000000', 'consum', 0.0229, 'lps'),
	(418750, 102, '2015-03-01 00:18:59.000000', 'consum', 0.0218, 'lps'),
	(418751, 102, '2015-03-01 00:19:00.000000', 'consum', 0.0213, 'lps'),
	(418752, 102, '2015-03-01 00:19:01.000000', 'consum', 0.0220, 'lps'),
	(418753, 102, '2015-03-01 00:19:02.000000', 'consum', 0.0214, 'lps'),
	(418754, 102, '2015-03-01 00:19:03.000000', 'consum', 0.0222, 'lps'),
	(418755, 102, '2015-03-01 00:19:04.000000', 'consum', 0.0216, 'lps'),
	(418756, 102, '2015-03-01 00:19:05.000000', 'consum', 0.0226, 'lps'),
	(418757, 102, '2015-03-01 00:19:06.000000', 'consum', 0.0210, 'lps'),
	(418758, 102, '2015-03-01 00:19:07.000000', 'consum', 0.0224, 'lps'),
	(418759, 102, '2015-03-01 00:19:08.000000', 'consum', 0.0219, 'lps'),
	(418760, 102, '2015-03-01 00:19:09.000000', 'consum', 0.0215, 'lps'),
	(418761, 102, '2015-03-01 00:19:10.000000', 'consum', 0.0210, 'lps'),
	(418762, 102, '2015-03-01 00:19:11.000000', 'consum', 0.0213, 'lps'),
	(418763, 102, '2015-03-01 00:19:12.000000', 'consum', 0.0227, 'lps'),
	(418764, 102, '2015-03-01 00:19:13.000000', 'consum', 0.0227, 'lps'),
	(418765, 102, '2015-03-01 00:19:14.000000', 'consum', 0.0223, 'lps'),
	(418766, 102, '2015-03-01 00:19:15.000000', 'consum', 0.0227, 'lps'),
	(418767, 102, '2015-03-01 00:19:16.000000', 'consum', 0.0214, 'lps'),
	(418768, 102, '2015-03-01 00:19:17.000000', 'consum', 0.0222, 'lps'),
	(418769, 102, '2015-03-01 00:19:18.000000', 'consum', 0.0218, 'lps'),
	(418770, 102, '2015-03-01 00:19:19.000000', 'consum', 0.0214, 'lps'),
	(418771, 102, '2015-03-01 00:19:20.000000', 'consum', 0.0228, 'lps'),
	(418772, 102, '2015-03-01 00:19:21.000000', 'consum', 0.0229, 'lps'),
	(418773, 102, '2015-03-01 00:19:22.000000', 'consum', 0.0210, 'lps'),
	(418774, 102, '2015-03-01 00:19:23.000000', 'consum', 0.0215, 'lps'),
	(418775, 102, '2015-03-01 00:19:24.000000', 'consum', 0.0215, 'lps'),
	(418776, 102, '2015-03-01 00:19:25.000000', 'consum', 0.0220, 'lps'),
	(418777, 102, '2015-03-01 00:19:26.000000', 'consum', 0.0227, 'lps'),
	(418778, 102, '2015-03-01 00:19:27.000000', 'consum', 0.0224, 'lps'),
	(418779, 102, '2015-03-01 00:19:28.000000', 'consum', 0.0229, 'lps'),
	(418780, 102, '2015-03-01 00:19:29.000000', 'consum', 0.0225, 'lps'),
	(418781, 102, '2015-03-01 00:19:30.000000', 'consum', 0.0228, 'lps'),
	(418782, 102, '2015-03-01 00:19:31.000000', 'consum', 0.0215, 'lps'),
	(418783, 102, '2015-03-01 00:19:32.000000', 'consum', 0.0224, 'lps'),
	(418784, 102, '2015-03-01 00:19:33.000000', 'consum', 0.0222, 'lps'),
	(418785, 102, '2015-03-01 00:19:34.000000', 'consum', 0.0211, 'lps'),
	(418786, 102, '2015-03-01 00:19:35.000000', 'consum', 0.0220, 'lps'),
	(418787, 102, '2015-03-01 00:19:36.000000', 'consum', 0.0216, 'lps'),
	(418788, 102, '2015-03-01 00:19:37.000000', 'consum', 0.0229, 'lps'),
	(418789, 102, '2015-03-01 00:19:38.000000', 'consum', 0.0211, 'lps'),
	(418790, 102, '2015-03-01 00:19:39.000000', 'consum', 0.0216, 'lps'),
	(418791, 102, '2015-03-01 00:19:40.000000', 'consum', 0.0220, 'lps'),
	(418792, 102, '2015-03-01 00:19:41.000000', 'consum', 0.0221, 'lps'),
	(418793, 102, '2015-03-01 00:19:42.000000', 'consum', 0.0214, 'lps'),
	(418794, 102, '2015-03-01 00:19:43.000000', 'consum', 0.0218, 'lps'),
	(418795, 102, '2015-03-01 00:19:44.000000', 'consum', 0.0220, 'lps'),
	(418796, 102, '2015-03-01 00:19:45.000000', 'consum', 0.0214, 'lps'),
	(418797, 102, '2015-03-01 00:19:46.000000', 'consum', 0.0222, 'lps'),
	(418798, 102, '2015-03-01 00:19:47.000000', 'consum', 0.0216, 'lps'),
	(418799, 102, '2015-03-01 00:19:48.000000', 'consum', 0.0227, 'lps'),
	(418800, 102, '2015-03-01 00:19:49.000000', 'consum', 0.0219, 'lps'),
	(418801, 102, '2015-03-01 00:19:50.000000', 'consum', 0.0223, 'lps'),
	(418802, 102, '2015-03-01 00:19:51.000000', 'consum', 0.0227, 'lps'),
	(418803, 102, '2015-03-01 00:19:52.000000', 'consum', 0.0216, 'lps'),
	(418804, 102, '2015-03-01 00:19:53.000000', 'consum', 0.0211, 'lps'),
	(418805, 102, '2015-03-01 00:19:54.000000', 'consum', 0.0217, 'lps'),
	(418806, 102, '2015-03-01 00:19:55.000000', 'consum', 0.0221, 'lps'),
	(418807, 102, '2015-03-01 00:19:56.000000', 'consum', 0.0224, 'lps'),
	(418808, 102, '2015-03-01 00:19:57.000000', 'consum', 0.0229, 'lps'),
	(418809, 102, '2015-03-01 00:19:58.000000', 'consum', 0.0222, 'lps'),
	(418810, 102, '2015-03-01 00:19:59.000000', 'consum', 0.0215, 'lps'),
	(418811, 102, '2015-03-01 00:20:00.000000', 'consum', 0.0220, 'lps'),
	(418812, 102, '2015-03-01 00:20:01.000000', 'consum', 0.0226, 'lps'),
	(418813, 102, '2015-03-01 00:20:02.000000', 'consum', 0.0218, 'lps'),
	(418814, 102, '2015-03-01 00:20:03.000000', 'consum', 0.0224, 'lps'),
	(418815, 102, '2015-03-01 00:20:04.000000', 'consum', 0.0215, 'lps'),
	(418816, 102, '2015-03-01 00:20:05.000000', 'consum', 0.0216, 'lps'),
	(418817, 102, '2015-03-01 00:20:06.000000', 'consum', 0.0222, 'lps'),
	(418818, 102, '2015-03-01 00:20:07.000000', 'consum', 0.0216, 'lps'),
	(418819, 102, '2015-03-01 00:20:08.000000', 'consum', 0.0224, 'lps'),
	(418820, 102, '2015-03-01 00:20:09.000000', 'consum', 0.0220, 'lps'),
	(418821, 102, '2015-03-01 00:20:10.000000', 'consum', 0.0220, 'lps'),
	(418822, 102, '2015-03-01 00:20:11.000000', 'consum', 0.0212, 'lps'),
	(418823, 102, '2015-03-01 00:20:12.000000', 'consum', 0.0211, 'lps'),
	(418824, 102, '2015-03-01 00:20:13.000000', 'consum', 0.0229, 'lps'),
	(418825, 102, '2015-03-01 00:20:14.000000', 'consum', 0.0220, 'lps'),
	(418826, 102, '2015-03-01 00:20:15.000000', 'consum', 0.0226, 'lps'),
	(418827, 102, '2015-03-01 00:20:16.000000', 'consum', 0.0222, 'lps'),
	(418828, 102, '2015-03-01 00:20:17.000000', 'consum', 0.0220, 'lps'),
	(418829, 102, '2015-03-01 00:20:18.000000', 'consum', 0.0224, 'lps'),
	(418830, 102, '2015-03-01 00:20:19.000000', 'consum', 0.0212, 'lps'),
	(418831, 102, '2015-03-01 00:20:20.000000', 'consum', 0.0219, 'lps'),
	(418832, 102, '2015-03-01 00:20:21.000000', 'consum', 0.0229, 'lps'),
	(418833, 102, '2015-03-01 00:20:22.000000', 'consum', 0.0218, 'lps'),
	(418834, 102, '2015-03-01 00:20:23.000000', 'consum', 0.0215, 'lps'),
	(418835, 102, '2015-03-01 00:20:24.000000', 'consum', 0.0211, 'lps'),
	(418836, 102, '2015-03-01 00:20:25.000000', 'consum', 0.0222, 'lps'),
	(418837, 102, '2015-03-01 00:20:26.000000', 'consum', 0.0227, 'lps'),
	(418838, 102, '2015-03-01 00:20:27.000000', 'consum', 0.0220, 'lps'),
	(418839, 102, '2015-03-01 00:20:28.000000', 'consum', 0.0229, 'lps'),
	(418840, 102, '2015-03-01 00:20:29.000000', 'consum', 0.0217, 'lps'),
	(418841, 102, '2015-03-01 00:20:30.000000', 'consum', 0.0229, 'lps'),
	(418842, 102, '2015-03-01 00:20:31.000000', 'consum', 0.0222, 'lps'),
	(418843, 102, '2015-03-01 00:20:32.000000', 'consum', 0.0216, 'lps'),
	(418844, 102, '2015-03-01 00:20:33.000000', 'consum', 0.0224, 'lps'),
	(418845, 102, '2015-03-01 00:20:34.000000', 'consum', 0.0223, 'lps'),
	(418846, 102, '2015-03-01 00:20:35.000000', 'consum', 0.0214, 'lps'),
	(418847, 102, '2015-03-01 00:20:36.000000', 'consum', 0.0210, 'lps'),
	(418848, 102, '2015-03-01 00:20:37.000000', 'consum', 0.0217, 'lps'),
	(418849, 102, '2015-03-01 00:20:38.000000', 'consum', 0.0228, 'lps'),
	(418850, 102, '2015-03-01 00:20:39.000000', 'consum', 0.0217, 'lps'),
	(418851, 102, '2015-03-01 00:20:40.000000', 'consum', 0.0211, 'lps'),
	(418852, 102, '2015-03-01 00:20:41.000000', 'consum', 0.0217, 'lps'),
	(418853, 102, '2015-03-01 00:20:42.000000', 'consum', 0.0220, 'lps'),
	(418854, 102, '2015-03-01 00:20:43.000000', 'consum', 0.0222, 'lps'),
	(418855, 102, '2015-03-01 00:20:44.000000', 'consum', 0.0218, 'lps'),
	(418856, 102, '2015-03-01 00:20:45.000000', 'consum', 0.0217, 'lps'),
	(418857, 102, '2015-03-01 00:20:46.000000', 'consum', 0.0222, 'lps'),
	(418858, 102, '2015-03-01 00:20:47.000000', 'consum', 0.0227, 'lps'),
	(418859, 102, '2015-03-01 00:20:48.000000', 'consum', 0.0221, 'lps'),
	(418860, 102, '2015-03-01 00:20:49.000000', 'consum', 0.0214, 'lps'),
	(418861, 102, '2015-03-01 00:20:50.000000', 'consum', 0.0218, 'lps'),
	(418862, 102, '2015-03-01 00:20:51.000000', 'consum', 0.0219, 'lps'),
	(418863, 102, '2015-03-01 00:20:52.000000', 'consum', 0.0212, 'lps'),
	(418864, 102, '2015-03-01 00:20:53.000000', 'consum', 0.0214, 'lps'),
	(418865, 102, '2015-03-01 00:20:54.000000', 'consum', 0.0224, 'lps'),
	(418866, 102, '2015-03-01 00:20:55.000000', 'consum', 0.0210, 'lps'),
	(418867, 102, '2015-03-01 00:20:56.000000', 'consum', 0.0227, 'lps'),
	(418868, 102, '2015-03-01 00:20:57.000000', 'consum', 0.0217, 'lps'),
	(418869, 102, '2015-03-01 00:20:58.000000', 'consum', 0.0215, 'lps'),
	(418870, 102, '2015-03-01 00:20:59.000000', 'consum', 0.0214, 'lps'),
	(418871, 102, '2015-03-01 00:21:00.000000', 'consum', 0.0213, 'lps'),
	(418872, 102, '2015-03-01 00:21:01.000000', 'consum', 0.0216, 'lps'),
	(418873, 102, '2015-03-01 00:21:02.000000', 'consum', 0.0211, 'lps'),
	(418874, 102, '2015-03-01 00:21:03.000000', 'consum', 0.0216, 'lps'),
	(418875, 102, '2015-03-01 00:21:04.000000', 'consum', 0.0219, 'lps'),
	(418876, 102, '2015-03-01 00:21:05.000000', 'consum', 0.0217, 'lps'),
	(418877, 102, '2015-03-01 00:21:06.000000', 'consum', 0.0218, 'lps'),
	(418878, 102, '2015-03-01 00:21:07.000000', 'consum', 0.0228, 'lps'),
	(418879, 102, '2015-03-01 00:21:08.000000', 'consum', 0.0218, 'lps'),
	(418880, 102, '2015-03-01 00:21:09.000000', 'consum', 0.0215, 'lps'),
	(418881, 102, '2015-03-01 00:21:10.000000', 'consum', 0.0213, 'lps'),
	(418882, 102, '2015-03-01 00:21:11.000000', 'consum', 0.0210, 'lps'),
	(418883, 102, '2015-03-01 00:21:12.000000', 'consum', 0.0223, 'lps'),
	(418884, 102, '2015-03-01 00:21:13.000000', 'consum', 0.0214, 'lps'),
	(418885, 102, '2015-03-01 00:21:14.000000', 'consum', 0.0212, 'lps'),
	(418886, 102, '2015-03-01 00:21:15.000000', 'consum', 0.0228, 'lps'),
	(418887, 102, '2015-03-01 00:21:16.000000', 'consum', 0.0216, 'lps'),
	(418888, 102, '2015-03-01 00:21:17.000000', 'consum', 0.0226, 'lps'),
	(418889, 102, '2015-03-01 00:21:18.000000', 'consum', 0.0211, 'lps'),
	(418890, 102, '2015-03-01 00:21:19.000000', 'consum', 0.0226, 'lps'),
	(418891, 102, '2015-03-01 00:21:20.000000', 'consum', 0.0211, 'lps'),
	(418892, 102, '2015-03-01 00:21:21.000000', 'consum', 0.0227, 'lps'),
	(418893, 102, '2015-03-01 00:21:22.000000', 'consum', 0.0214, 'lps'),
	(418894, 102, '2015-03-01 00:21:23.000000', 'consum', 0.0216, 'lps'),
	(418895, 102, '2015-03-01 00:21:24.000000', 'consum', 0.0210, 'lps'),
	(418896, 102, '2015-03-01 00:21:25.000000', 'consum', 0.0213, 'lps'),
	(418897, 102, '2015-03-01 00:21:26.000000', 'consum', 0.0224, 'lps'),
	(418898, 102, '2015-03-01 00:21:27.000000', 'consum', 0.0212, 'lps'),
	(418899, 102, '2015-03-01 00:21:28.000000', 'consum', 0.0219, 'lps'),
	(418900, 102, '2015-03-01 00:21:29.000000', 'consum', 0.0229, 'lps'),
	(418901, 102, '2015-03-01 00:21:30.000000', 'consum', 0.0220, 'lps'),
	(418902, 102, '2015-03-01 00:21:31.000000', 'consum', 0.0224, 'lps'),
	(418903, 102, '2015-03-01 00:21:32.000000', 'consum', 0.0229, 'lps'),
	(418904, 102, '2015-03-01 00:21:33.000000', 'consum', 0.0225, 'lps'),
	(418905, 102, '2015-03-01 00:21:34.000000', 'consum', 0.0227, 'lps'),
	(418906, 102, '2015-03-01 00:21:35.000000', 'consum', 0.0211, 'lps'),
	(418907, 102, '2015-03-01 00:21:36.000000', 'consum', 0.0223, 'lps'),
	(418908, 102, '2015-03-01 00:21:37.000000', 'consum', 0.0213, 'lps'),
	(418909, 102, '2015-03-01 00:21:38.000000', 'consum', 0.0228, 'lps'),
	(418910, 102, '2015-03-01 00:21:39.000000', 'consum', 0.0229, 'lps'),
	(418911, 102, '2015-03-01 00:21:40.000000', 'consum', 0.0215, 'lps'),
	(418912, 102, '2015-03-01 00:21:41.000000', 'consum', 0.0215, 'lps'),
	(418913, 102, '2015-03-01 00:21:42.000000', 'consum', 0.0224, 'lps'),
	(418914, 102, '2015-03-01 00:21:43.000000', 'consum', 0.0223, 'lps'),
	(418915, 102, '2015-03-01 00:21:44.000000', 'consum', 0.0215, 'lps'),
	(418916, 102, '2015-03-01 00:21:45.000000', 'consum', 0.0216, 'lps'),
	(418917, 102, '2015-03-01 00:21:46.000000', 'consum', 0.0226, 'lps'),
	(418918, 102, '2015-03-01 00:21:47.000000', 'consum', 0.0210, 'lps'),
	(418919, 102, '2015-03-01 00:21:48.000000', 'consum', 0.0224, 'lps'),
	(418920, 102, '2015-03-01 00:21:49.000000', 'consum', 0.0221, 'lps'),
	(418921, 102, '2015-03-01 00:21:50.000000', 'consum', 0.0221, 'lps'),
	(418922, 102, '2015-03-01 00:21:51.000000', 'consum', 0.0215, 'lps'),
	(418923, 102, '2015-03-01 00:21:52.000000', 'consum', 0.0220, 'lps'),
	(418924, 102, '2015-03-01 00:21:53.000000', 'consum', 0.0227, 'lps'),
	(418925, 102, '2015-03-01 00:21:54.000000', 'consum', 0.0227, 'lps'),
	(418926, 102, '2015-03-01 00:21:55.000000', 'consum', 0.0225, 'lps'),
	(418927, 102, '2015-03-01 00:21:56.000000', 'consum', 0.0212, 'lps'),
	(418928, 102, '2015-03-01 00:21:57.000000', 'consum', 0.0216, 'lps'),
	(418929, 102, '2015-03-01 00:21:58.000000', 'consum', 0.0217, 'lps'),
	(418930, 102, '2015-03-01 00:21:59.000000', 'consum', 0.0224, 'lps'),
	(418931, 102, '2015-03-01 00:22:00.000000', 'consum', 0.0221, 'lps'),
	(418932, 102, '2015-03-01 00:22:01.000000', 'consum', 0.0223, 'lps'),
	(418933, 102, '2015-03-01 00:22:02.000000', 'consum', 0.0221, 'lps'),
	(418934, 102, '2015-03-01 00:22:03.000000', 'consum', 0.0227, 'lps'),
	(418935, 102, '2015-03-01 00:22:04.000000', 'consum', 0.0225, 'lps'),
	(418936, 102, '2015-03-01 00:22:05.000000', 'consum', 0.0212, 'lps'),
	(418937, 102, '2015-03-01 00:22:06.000000', 'consum', 0.0217, 'lps'),
	(418938, 102, '2015-03-01 00:22:07.000000', 'consum', 0.0221, 'lps'),
	(418939, 102, '2015-03-01 00:22:08.000000', 'consum', 0.0222, 'lps'),
	(418940, 102, '2015-03-01 00:22:09.000000', 'consum', 0.0219, 'lps'),
	(418941, 102, '2015-03-01 00:22:10.000000', 'consum', 0.0218, 'lps'),
	(418942, 102, '2015-03-01 00:22:11.000000', 'consum', 0.0222, 'lps'),
	(418943, 102, '2015-03-01 00:22:12.000000', 'consum', 0.0229, 'lps'),
	(418944, 102, '2015-03-01 00:22:13.000000', 'consum', 0.0229, 'lps'),
	(418945, 102, '2015-03-01 00:22:14.000000', 'consum', 0.0226, 'lps'),
	(418946, 102, '2015-03-01 00:22:15.000000', 'consum', 0.0217, 'lps'),
	(418947, 102, '2015-03-01 00:22:16.000000', 'consum', 0.0217, 'lps'),
	(418948, 102, '2015-03-01 00:22:17.000000', 'consum', 0.0225, 'lps'),
	(418949, 102, '2015-03-01 00:22:18.000000', 'consum', 0.0223, 'lps'),
	(418950, 102, '2015-03-01 00:22:19.000000', 'consum', 0.0212, 'lps'),
	(418951, 102, '2015-03-01 00:22:20.000000', 'consum', 0.0220, 'lps'),
	(418952, 102, '2015-03-01 00:22:21.000000', 'consum', 0.0214, 'lps'),
	(418953, 102, '2015-03-01 00:22:22.000000', 'consum', 0.0219, 'lps'),
	(418954, 102, '2015-03-01 00:22:23.000000', 'consum', 0.0227, 'lps'),
	(418955, 102, '2015-03-01 00:22:24.000000', 'consum', 0.0227, 'lps'),
	(418956, 102, '2015-03-01 00:22:25.000000', 'consum', 0.0225, 'lps'),
	(418957, 102, '2015-03-01 00:22:26.000000', 'consum', 0.0213, 'lps'),
	(418958, 102, '2015-03-01 00:22:27.000000', 'consum', 0.0223, 'lps'),
	(418959, 102, '2015-03-01 00:22:28.000000', 'consum', 0.0227, 'lps'),
	(418960, 102, '2015-03-01 00:22:29.000000', 'consum', 0.0215, 'lps'),
	(418961, 102, '2015-03-01 00:22:30.000000', 'consum', 0.0223, 'lps'),
	(418962, 102, '2015-03-01 00:22:31.000000', 'consum', 0.0221, 'lps'),
	(418963, 102, '2015-03-01 00:22:32.000000', 'consum', 0.0225, 'lps'),
	(418964, 102, '2015-03-01 00:22:33.000000', 'consum', 0.0215, 'lps'),
	(418965, 102, '2015-03-01 00:22:34.000000', 'consum', 0.0229, 'lps'),
	(418966, 102, '2015-03-01 00:22:35.000000', 'consum', 0.0211, 'lps'),
	(418967, 102, '2015-03-01 00:22:36.000000', 'consum', 0.0218, 'lps'),
	(418968, 102, '2015-03-01 00:22:37.000000', 'consum', 0.0226, 'lps'),
	(418969, 102, '2015-03-01 00:22:38.000000', 'consum', 0.0227, 'lps'),
	(418970, 102, '2015-03-01 00:22:39.000000', 'consum', 0.0226, 'lps'),
	(418971, 102, '2015-03-01 00:22:40.000000', 'consum', 0.0222, 'lps'),
	(418972, 102, '2015-03-01 00:22:41.000000', 'consum', 0.0224, 'lps'),
	(418973, 102, '2015-03-01 00:22:42.000000', 'consum', 0.0221, 'lps'),
	(418974, 102, '2015-03-01 00:22:43.000000', 'consum', 0.0226, 'lps'),
	(418975, 102, '2015-03-01 00:22:44.000000', 'consum', 0.0219, 'lps'),
	(418976, 102, '2015-03-01 00:22:45.000000', 'consum', 0.0224, 'lps'),
	(418977, 102, '2015-03-01 00:22:46.000000', 'consum', 0.0215, 'lps'),
	(418978, 102, '2015-03-01 00:22:47.000000', 'consum', 0.0213, 'lps'),
	(418979, 102, '2015-03-01 00:22:48.000000', 'consum', 0.0210, 'lps'),
	(418980, 102, '2015-03-01 00:22:49.000000', 'consum', 0.0221, 'lps'),
	(418981, 102, '2015-03-01 00:22:50.000000', 'consum', 0.0228, 'lps'),
	(418982, 102, '2015-03-01 00:22:51.000000', 'consum', 0.0225, 'lps'),
	(418983, 102, '2015-03-01 00:22:52.000000', 'consum', 0.0211, 'lps'),
	(418984, 102, '2015-03-01 00:22:53.000000', 'consum', 0.0210, 'lps'),
	(418985, 102, '2015-03-01 00:22:54.000000', 'consum', 0.0211, 'lps'),
	(418986, 102, '2015-03-01 00:22:55.000000', 'consum', 0.0212, 'lps'),
	(418987, 102, '2015-03-01 00:22:56.000000', 'consum', 0.0219, 'lps'),
	(418988, 102, '2015-03-01 00:22:57.000000', 'consum', 0.0227, 'lps'),
	(418989, 102, '2015-03-01 00:22:58.000000', 'consum', 0.0211, 'lps'),
	(418990, 102, '2015-03-01 00:22:59.000000', 'consum', 0.0226, 'lps'),
	(418991, 102, '2015-03-01 00:23:00.000000', 'consum', 0.0225, 'lps'),
	(418992, 102, '2015-03-01 00:23:01.000000', 'consum', 0.0216, 'lps'),
	(418993, 102, '2015-03-01 00:23:02.000000', 'consum', 0.0218, 'lps'),
	(418994, 102, '2015-03-01 00:23:03.000000', 'consum', 0.0210, 'lps'),
	(418995, 102, '2015-03-01 00:23:04.000000', 'consum', 0.0227, 'lps'),
	(418996, 102, '2015-03-01 00:23:05.000000', 'consum', 0.0217, 'lps'),
	(418997, 102, '2015-03-01 00:23:06.000000', 'consum', 0.0214, 'lps'),
	(418998, 102, '2015-03-01 00:23:07.000000', 'consum', 0.0229, 'lps'),
	(418999, 102, '2015-03-01 00:23:08.000000', 'consum', 0.0215, 'lps'),
	(419000, 102, '2015-03-01 00:23:09.000000', 'consum', 0.0217, 'lps'),
	(419001, 102, '2015-03-01 00:23:10.000000', 'consum', 0.0211, 'lps'),
	(419002, 102, '2015-03-01 00:23:11.000000', 'consum', 0.0214, 'lps'),
	(419003, 102, '2015-03-01 00:23:12.000000', 'consum', 0.0228, 'lps'),
	(419004, 102, '2015-03-01 00:23:13.000000', 'consum', 0.0229, 'lps'),
	(419005, 102, '2015-03-01 00:23:14.000000', 'consum', 0.0210, 'lps'),
	(419006, 102, '2015-03-01 00:23:15.000000', 'consum', 0.0215, 'lps'),
	(419007, 102, '2015-03-01 00:23:16.000000', 'consum', 0.0216, 'lps'),
	(419008, 102, '2015-03-01 00:23:17.000000', 'consum', 0.0224, 'lps'),
	(419009, 102, '2015-03-01 00:23:18.000000', 'consum', 0.0225, 'lps'),
	(419010, 102, '2015-03-01 00:23:19.000000', 'consum', 0.0223, 'lps'),
	(419011, 102, '2015-03-01 00:23:20.000000', 'consum', 0.0229, 'lps'),
	(419012, 102, '2015-03-01 00:23:21.000000', 'consum', 0.0228, 'lps'),
	(419013, 102, '2015-03-01 00:23:22.000000', 'consum', 0.0222, 'lps'),
	(419014, 102, '2015-03-01 00:23:23.000000', 'consum', 0.0217, 'lps'),
	(419015, 102, '2015-03-01 00:23:24.000000', 'consum', 0.0228, 'lps'),
	(419016, 102, '2015-03-01 00:23:25.000000', 'consum', 0.0219, 'lps'),
	(419017, 102, '2015-03-01 00:23:26.000000', 'consum', 0.0223, 'lps'),
	(419018, 102, '2015-03-01 00:23:27.000000', 'consum', 0.0227, 'lps'),
	(419019, 102, '2015-03-01 00:23:28.000000', 'consum', 0.0218, 'lps'),
	(419020, 102, '2015-03-01 00:23:29.000000', 'consum', 0.0217, 'lps'),
	(419021, 102, '2015-03-01 00:23:30.000000', 'consum', 0.0224, 'lps'),
	(419022, 102, '2015-03-01 00:23:31.000000', 'consum', 0.0219, 'lps'),
	(419023, 102, '2015-03-01 00:23:32.000000', 'consum', 0.0213, 'lps'),
	(419024, 102, '2015-03-01 00:23:33.000000', 'consum', 0.0217, 'lps'),
	(419025, 102, '2015-03-01 00:23:34.000000', 'consum', 0.0216, 'lps'),
	(419026, 102, '2015-03-01 00:23:35.000000', 'consum', 0.0220, 'lps'),
	(419027, 102, '2015-03-01 00:23:36.000000', 'consum', 0.0225, 'lps'),
	(419028, 102, '2015-03-01 00:23:37.000000', 'consum', 0.0214, 'lps'),
	(419029, 102, '2015-03-01 00:23:38.000000', 'consum', 0.0226, 'lps'),
	(419030, 102, '2015-03-01 00:23:39.000000', 'consum', 0.0219, 'lps'),
	(419031, 102, '2015-03-01 00:23:40.000000', 'consum', 0.0226, 'lps'),
	(419032, 102, '2015-03-01 00:23:41.000000', 'consum', 0.0226, 'lps'),
	(419033, 102, '2015-03-01 00:23:42.000000', 'consum', 0.0221, 'lps'),
	(419034, 102, '2015-03-01 00:23:43.000000', 'consum', 0.0216, 'lps'),
	(419035, 102, '2015-03-01 00:23:44.000000', 'consum', 0.0210, 'lps'),
	(419036, 102, '2015-03-01 00:23:45.000000', 'consum', 0.0211, 'lps'),
	(419037, 102, '2015-03-01 00:23:46.000000', 'consum', 0.0217, 'lps'),
	(419038, 102, '2015-03-01 00:23:47.000000', 'consum', 0.0221, 'lps'),
	(419039, 102, '2015-03-01 00:23:48.000000', 'consum', 0.0224, 'lps'),
	(419040, 102, '2015-03-01 00:23:49.000000', 'consum', 0.0210, 'lps'),
	(419041, 102, '2015-03-01 00:23:50.000000', 'consum', 0.0226, 'lps'),
	(419042, 102, '2015-03-01 00:23:51.000000', 'consum', 0.0210, 'lps'),
	(419043, 102, '2015-03-01 00:23:52.000000', 'consum', 0.0225, 'lps'),
	(419044, 102, '2015-03-01 00:23:53.000000', 'consum', 0.0225, 'lps'),
	(419045, 102, '2015-03-01 00:23:54.000000', 'consum', 0.0220, 'lps'),
	(419046, 102, '2015-03-01 00:23:55.000000', 'consum', 0.0214, 'lps'),
	(419047, 102, '2015-03-01 00:23:56.000000', 'consum', 0.0220, 'lps'),
	(419048, 102, '2015-03-01 00:23:57.000000', 'consum', 0.0228, 'lps'),
	(419049, 102, '2015-03-01 00:23:58.000000', 'consum', 0.0211, 'lps'),
	(419050, 102, '2015-03-01 00:23:59.000000', 'consum', 0.0222, 'lps'),
	(419051, 102, '2015-03-01 00:24:00.000000', 'consum', 0.0228, 'lps'),
	(419052, 102, '2015-03-01 00:24:01.000000', 'consum', 0.0226, 'lps'),
	(419053, 102, '2015-03-01 00:24:02.000000', 'consum', 0.0214, 'lps'),
	(419054, 102, '2015-03-01 00:24:03.000000', 'consum', 0.0223, 'lps'),
	(419055, 102, '2015-03-01 00:24:04.000000', 'consum', 0.0225, 'lps'),
	(419056, 102, '2015-03-01 00:24:05.000000', 'consum', 0.0224, 'lps'),
	(419057, 102, '2015-03-01 00:24:06.000000', 'consum', 0.0218, 'lps'),
	(419058, 102, '2015-03-01 00:24:07.000000', 'consum', 0.0228, 'lps'),
	(419059, 102, '2015-03-01 00:24:08.000000', 'consum', 0.0215, 'lps'),
	(419060, 102, '2015-03-01 00:24:09.000000', 'consum', 0.0222, 'lps'),
	(419061, 102, '2015-03-01 00:24:10.000000', 'consum', 0.0216, 'lps'),
	(419062, 102, '2015-03-01 00:24:11.000000', 'consum', 0.0223, 'lps'),
	(419063, 102, '2015-03-01 00:24:12.000000', 'consum', 0.0217, 'lps'),
	(419064, 102, '2015-03-01 00:24:13.000000', 'consum', 0.0225, 'lps'),
	(419065, 102, '2015-03-01 00:24:14.000000', 'consum', 0.0228, 'lps'),
	(419066, 102, '2015-03-01 00:24:15.000000', 'consum', 0.0214, 'lps'),
	(419067, 102, '2015-03-01 00:24:16.000000', 'consum', 0.0217, 'lps'),
	(419068, 102, '2015-03-01 00:24:17.000000', 'consum', 0.0215, 'lps'),
	(419069, 102, '2015-03-01 00:24:18.000000', 'consum', 0.0214, 'lps'),
	(419070, 102, '2015-03-01 00:24:19.000000', 'consum', 0.0213, 'lps'),
	(419071, 102, '2015-03-01 00:24:20.000000', 'consum', 0.0215, 'lps'),
	(419072, 102, '2015-03-01 00:24:21.000000', 'consum', 0.0228, 'lps'),
	(419073, 102, '2015-03-01 00:24:22.000000', 'consum', 0.0226, 'lps'),
	(419074, 102, '2015-03-01 00:24:23.000000', 'consum', 0.0213, 'lps'),
	(419075, 102, '2015-03-01 00:24:24.000000', 'consum', 0.0221, 'lps'),
	(419076, 102, '2015-03-01 00:24:25.000000', 'consum', 0.0215, 'lps'),
	(419077, 102, '2015-03-01 00:24:26.000000', 'consum', 0.0221, 'lps'),
	(419078, 102, '2015-03-01 00:24:27.000000', 'consum', 0.0211, 'lps'),
	(419079, 102, '2015-03-01 00:24:28.000000', 'consum', 0.0222, 'lps'),
	(419080, 102, '2015-03-01 00:24:29.000000', 'consum', 0.0227, 'lps'),
	(419081, 102, '2015-03-01 00:24:30.000000', 'consum', 0.0219, 'lps'),
	(419082, 102, '2015-03-01 00:24:31.000000', 'consum', 0.0225, 'lps'),
	(419083, 102, '2015-03-01 00:24:32.000000', 'consum', 0.0218, 'lps'),
	(419084, 102, '2015-03-01 00:24:33.000000', 'consum', 0.0228, 'lps'),
	(419085, 102, '2015-03-01 00:24:34.000000', 'consum', 0.0213, 'lps'),
	(419086, 102, '2015-03-01 00:24:35.000000', 'consum', 0.0214, 'lps'),
	(419087, 102, '2015-03-01 00:24:36.000000', 'consum', 0.0219, 'lps'),
	(419088, 102, '2015-03-01 00:24:37.000000', 'consum', 0.0225, 'lps'),
	(419089, 102, '2015-03-01 00:24:38.000000', 'consum', 0.0219, 'lps'),
	(419090, 102, '2015-03-01 00:24:39.000000', 'consum', 0.0212, 'lps'),
	(419091, 102, '2015-03-01 00:24:40.000000', 'consum', 0.0211, 'lps'),
	(419092, 102, '2015-03-01 00:24:41.000000', 'consum', 0.0229, 'lps'),
	(419093, 102, '2015-03-01 00:24:42.000000', 'consum', 0.0222, 'lps'),
	(419094, 102, '2015-03-01 00:24:43.000000', 'consum', 0.0213, 'lps'),
	(419095, 102, '2015-03-01 00:24:44.000000', 'consum', 0.0212, 'lps'),
	(419096, 102, '2015-03-01 00:24:45.000000', 'consum', 0.0229, 'lps'),
	(419097, 102, '2015-03-01 00:24:46.000000', 'consum', 0.0220, 'lps'),
	(419098, 102, '2015-03-01 00:24:47.000000', 'consum', 0.0222, 'lps'),
	(419099, 102, '2015-03-01 00:24:48.000000', 'consum', 0.0222, 'lps'),
	(419100, 102, '2015-03-01 00:24:49.000000', 'consum', 0.0216, 'lps'),
	(419101, 102, '2015-03-01 00:24:50.000000', 'consum', 0.0222, 'lps'),
	(419102, 102, '2015-03-01 00:24:51.000000', 'consum', 0.0213, 'lps'),
	(419103, 102, '2015-03-01 00:24:52.000000', 'consum', 0.0212, 'lps'),
	(419104, 102, '2015-03-01 00:24:53.000000', 'consum', 0.0228, 'lps'),
	(419105, 102, '2015-03-01 00:24:54.000000', 'consum', 0.0215, 'lps'),
	(419106, 102, '2015-03-01 00:24:55.000000', 'consum', 0.0223, 'lps'),
	(419107, 102, '2015-03-01 00:24:56.000000', 'consum', 0.0218, 'lps'),
	(419108, 102, '2015-03-01 00:24:57.000000', 'consum', 0.0214, 'lps'),
	(419109, 102, '2015-03-01 00:24:58.000000', 'consum', 0.0225, 'lps'),
	(419110, 102, '2015-03-01 00:24:59.000000', 'consum', 0.0216, 'lps'),
	(419111, 102, '2015-03-01 00:25:00.000000', 'consum', 0.0212, 'lps'),
	(419112, 102, '2015-03-01 00:25:01.000000', 'consum', 0.0226, 'lps'),
	(419113, 102, '2015-03-01 00:25:02.000000', 'consum', 0.0223, 'lps'),
	(419114, 102, '2015-03-01 00:25:03.000000', 'consum', 0.0227, 'lps'),
	(419115, 102, '2015-03-01 00:25:04.000000', 'consum', 0.0215, 'lps'),
	(419116, 102, '2015-03-01 00:25:05.000000', 'consum', 0.0225, 'lps'),
	(419117, 102, '2015-03-01 00:25:06.000000', 'consum', 0.0213, 'lps'),
	(419118, 102, '2015-03-01 00:25:07.000000', 'consum', 0.0220, 'lps'),
	(419119, 102, '2015-03-01 00:25:08.000000', 'consum', 0.0211, 'lps'),
	(419120, 102, '2015-03-01 00:25:09.000000', 'consum', 0.0224, 'lps'),
	(419121, 102, '2015-03-01 00:25:10.000000', 'consum', 0.0220, 'lps'),
	(419122, 102, '2015-03-01 00:25:11.000000', 'consum', 0.0218, 'lps'),
	(419123, 102, '2015-03-01 00:25:12.000000', 'consum', 0.0218, 'lps'),
	(419124, 102, '2015-03-01 00:25:13.000000', 'consum', 0.0229, 'lps'),
	(419125, 102, '2015-03-01 00:25:14.000000', 'consum', 0.0222, 'lps'),
	(419126, 102, '2015-03-01 00:25:15.000000', 'consum', 0.0211, 'lps'),
	(419127, 102, '2015-03-01 00:25:16.000000', 'consum', 0.0221, 'lps'),
	(419128, 102, '2015-03-01 00:25:17.000000', 'consum', 0.0224, 'lps'),
	(419129, 102, '2015-03-01 00:25:18.000000', 'consum', 0.0228, 'lps'),
	(419130, 102, '2015-03-01 00:25:19.000000', 'consum', 0.0215, 'lps'),
	(419131, 102, '2015-03-01 00:25:20.000000', 'consum', 0.0224, 'lps'),
	(419132, 102, '2015-03-01 00:25:21.000000', 'consum', 0.0225, 'lps'),
	(419133, 102, '2015-03-01 00:25:22.000000', 'consum', 0.0225, 'lps'),
	(419134, 102, '2015-03-01 00:25:23.000000', 'consum', 0.0218, 'lps'),
	(419135, 102, '2015-03-01 00:25:24.000000', 'consum', 0.0226, 'lps'),
	(419136, 102, '2015-03-01 00:25:25.000000', 'consum', 0.0226, 'lps'),
	(419137, 102, '2015-03-01 00:25:26.000000', 'consum', 0.0221, 'lps'),
	(419138, 102, '2015-03-01 00:25:27.000000', 'consum', 0.0220, 'lps'),
	(419139, 102, '2015-03-01 00:25:28.000000', 'consum', 0.0226, 'lps'),
	(419140, 102, '2015-03-01 00:25:29.000000', 'consum', 0.0219, 'lps'),
	(419141, 102, '2015-03-01 00:25:30.000000', 'consum', 0.0229, 'lps'),
	(419142, 102, '2015-03-01 00:25:31.000000', 'consum', 0.0218, 'lps'),
	(419143, 102, '2015-03-01 00:25:32.000000', 'consum', 0.0212, 'lps'),
	(419144, 102, '2015-03-01 00:25:33.000000', 'consum', 0.0216, 'lps'),
	(419145, 102, '2015-03-01 00:25:34.000000', 'consum', 0.0217, 'lps'),
	(419146, 102, '2015-03-01 00:25:35.000000', 'consum', 0.0229, 'lps'),
	(419147, 102, '2015-03-01 00:25:36.000000', 'consum', 0.0221, 'lps'),
	(419148, 102, '2015-03-01 00:25:37.000000', 'consum', 0.0229, 'lps'),
	(419149, 102, '2015-03-01 00:25:38.000000', 'consum', 0.0214, 'lps'),
	(419150, 102, '2015-03-01 00:25:39.000000', 'consum', 0.0213, 'lps'),
	(419151, 102, '2015-03-01 00:25:40.000000', 'consum', 0.0213, 'lps'),
	(419152, 102, '2015-03-01 00:25:41.000000', 'consum', 0.0217, 'lps'),
	(419153, 102, '2015-03-01 00:25:42.000000', 'consum', 0.0216, 'lps'),
	(419154, 102, '2015-03-01 00:25:43.000000', 'consum', 0.0218, 'lps'),
	(419155, 102, '2015-03-01 00:25:44.000000', 'consum', 0.0213, 'lps'),
	(419156, 102, '2015-03-01 00:25:45.000000', 'consum', 0.0222, 'lps'),
	(419157, 102, '2015-03-01 00:25:46.000000', 'consum', 0.0221, 'lps'),
	(419158, 102, '2015-03-01 00:25:47.000000', 'consum', 0.0211, 'lps'),
	(419159, 102, '2015-03-01 00:25:48.000000', 'consum', 0.0220, 'lps'),
	(419160, 102, '2015-03-01 00:25:49.000000', 'consum', 0.0218, 'lps'),
	(419161, 102, '2015-03-01 00:25:50.000000', 'consum', 0.0221, 'lps'),
	(419162, 102, '2015-03-01 00:25:51.000000', 'consum', 0.0222, 'lps'),
	(419163, 102, '2015-03-01 00:25:52.000000', 'consum', 0.0217, 'lps'),
	(419164, 102, '2015-03-01 00:25:53.000000', 'consum', 0.0228, 'lps'),
	(419165, 102, '2015-03-01 00:25:54.000000', 'consum', 0.0219, 'lps'),
	(419166, 102, '2015-03-01 00:25:55.000000', 'consum', 0.0223, 'lps'),
	(419167, 102, '2015-03-01 00:25:56.000000', 'consum', 0.0227, 'lps'),
	(419168, 102, '2015-03-01 00:25:57.000000', 'consum', 0.0215, 'lps'),
	(419169, 102, '2015-03-01 00:25:58.000000', 'consum', 0.0228, 'lps'),
	(419170, 102, '2015-03-01 00:25:59.000000', 'consum', 0.0224, 'lps'),
	(419171, 102, '2015-03-01 00:26:00.000000', 'consum', 0.0227, 'lps'),
	(419172, 102, '2015-03-01 00:26:01.000000', 'consum', 0.0213, 'lps'),
	(419173, 102, '2015-03-01 00:26:02.000000', 'consum', 0.0214, 'lps'),
	(419174, 102, '2015-03-01 00:26:03.000000', 'consum', 0.0221, 'lps'),
	(419175, 102, '2015-03-01 00:26:04.000000', 'consum', 0.0214, 'lps'),
	(419176, 102, '2015-03-01 00:26:05.000000', 'consum', 0.0217, 'lps'),
	(419177, 102, '2015-03-01 00:26:06.000000', 'consum', 0.0213, 'lps'),
	(419178, 102, '2015-03-01 00:26:07.000000', 'consum', 0.0226, 'lps'),
	(419179, 102, '2015-03-01 00:26:08.000000', 'consum', 0.0223, 'lps'),
	(419180, 102, '2015-03-01 00:26:09.000000', 'consum', 0.0225, 'lps'),
	(419181, 102, '2015-03-01 00:26:10.000000', 'consum', 0.0228, 'lps'),
	(419182, 102, '2015-03-01 00:26:11.000000', 'consum', 0.0213, 'lps'),
	(419183, 102, '2015-03-01 00:26:12.000000', 'consum', 0.0214, 'lps'),
	(419184, 102, '2015-03-01 00:26:13.000000', 'consum', 0.0221, 'lps'),
	(419185, 102, '2015-03-01 00:26:14.000000', 'consum', 0.0212, 'lps'),
	(419186, 102, '2015-03-01 00:26:15.000000', 'consum', 0.0227, 'lps'),
	(419187, 102, '2015-03-01 00:26:16.000000', 'consum', 0.0210, 'lps'),
	(419188, 102, '2015-03-01 00:26:17.000000', 'consum', 0.0220, 'lps'),
	(419189, 102, '2015-03-01 00:26:18.000000', 'consum', 0.0219, 'lps'),
	(419190, 102, '2015-03-01 00:26:19.000000', 'consum', 0.0225, 'lps'),
	(419191, 102, '2015-03-01 00:26:20.000000', 'consum', 0.0219, 'lps'),
	(419192, 102, '2015-03-01 00:26:21.000000', 'consum', 0.0212, 'lps'),
	(419193, 102, '2015-03-01 00:26:22.000000', 'consum', 0.0214, 'lps'),
	(419194, 102, '2015-03-01 00:26:23.000000', 'consum', 0.0224, 'lps'),
	(419195, 102, '2015-03-01 00:26:24.000000', 'consum', 0.0229, 'lps'),
	(419196, 102, '2015-03-01 00:26:25.000000', 'consum', 0.0225, 'lps'),
	(419197, 102, '2015-03-01 00:26:26.000000', 'consum', 0.0227, 'lps'),
	(419198, 102, '2015-03-01 00:26:27.000000', 'consum', 0.0211, 'lps'),
	(419199, 102, '2015-03-01 00:26:28.000000', 'consum', 0.0225, 'lps'),
	(419200, 102, '2015-03-01 00:26:29.000000', 'consum', 0.0222, 'lps'),
	(419201, 102, '2015-03-01 00:26:30.000000', 'consum', 0.0226, 'lps'),
	(419202, 102, '2015-03-01 00:26:31.000000', 'consum', 0.0216, 'lps'),
	(419203, 102, '2015-03-01 00:26:32.000000', 'consum', 0.0210, 'lps'),
	(419204, 102, '2015-03-01 00:26:33.000000', 'consum', 0.0213, 'lps'),
	(419205, 102, '2015-03-01 00:26:34.000000', 'consum', 0.0226, 'lps'),
	(419206, 102, '2015-03-01 00:26:35.000000', 'consum', 0.0220, 'lps'),
	(419207, 102, '2015-03-01 00:26:36.000000', 'consum', 0.0212, 'lps'),
	(419208, 102, '2015-03-01 00:26:37.000000', 'consum', 0.0213, 'lps'),
	(419209, 102, '2015-03-01 00:26:38.000000', 'consum', 0.0217, 'lps'),
	(419210, 102, '2015-03-01 00:26:39.000000', 'consum', 0.0219, 'lps'),
	(419211, 102, '2015-03-01 00:26:40.000000', 'consum', 0.0212, 'lps'),
	(419212, 102, '2015-03-01 00:26:41.000000', 'consum', 0.0216, 'lps'),
	(419213, 102, '2015-03-01 00:26:42.000000', 'consum', 0.0212, 'lps'),
	(419214, 102, '2015-03-01 00:26:43.000000', 'consum', 0.0224, 'lps'),
	(419215, 102, '2015-03-01 00:26:44.000000', 'consum', 0.0215, 'lps'),
	(419216, 102, '2015-03-01 00:26:45.000000', 'consum', 0.0211, 'lps'),
	(419217, 102, '2015-03-01 00:26:46.000000', 'consum', 0.0224, 'lps'),
	(419218, 102, '2015-03-01 00:26:47.000000', 'consum', 0.0215, 'lps'),
	(419219, 102, '2015-03-01 00:26:48.000000', 'consum', 0.0216, 'lps'),
	(419220, 102, '2015-03-01 00:26:49.000000', 'consum', 0.0225, 'lps'),
	(419221, 102, '2015-03-01 00:26:50.000000', 'consum', 0.0225, 'lps'),
	(419222, 102, '2015-03-01 00:26:51.000000', 'consum', 0.0222, 'lps'),
	(419223, 102, '2015-03-01 00:26:52.000000', 'consum', 0.0227, 'lps'),
	(419224, 102, '2015-03-01 00:26:53.000000', 'consum', 0.0220, 'lps'),
	(419225, 102, '2015-03-01 00:26:54.000000', 'consum', 0.0228, 'lps'),
	(419226, 102, '2015-03-01 00:26:55.000000', 'consum', 0.0229, 'lps'),
	(419227, 102, '2015-03-01 00:26:56.000000', 'consum', 0.0214, 'lps'),
	(419228, 102, '2015-03-01 00:26:57.000000', 'consum', 0.0214, 'lps'),
	(419229, 102, '2015-03-01 00:26:58.000000', 'consum', 0.0219, 'lps'),
	(419230, 102, '2015-03-01 00:26:59.000000', 'consum', 0.0222, 'lps'),
	(419231, 102, '2015-03-01 00:27:00.000000', 'consum', 0.0223, 'lps'),
	(419232, 102, '2015-03-01 00:27:01.000000', 'consum', 0.0219, 'lps'),
	(419233, 102, '2015-03-01 00:27:02.000000', 'consum', 0.0218, 'lps'),
	(419234, 102, '2015-03-01 00:27:03.000000', 'consum', 0.0223, 'lps'),
	(419235, 102, '2015-03-01 00:27:04.000000', 'consum', 0.0212, 'lps'),
	(419236, 102, '2015-03-01 00:27:05.000000', 'consum', 0.0221, 'lps'),
	(419237, 102, '2015-03-01 00:27:06.000000', 'consum', 0.0221, 'lps'),
	(419238, 102, '2015-03-01 00:27:07.000000', 'consum', 0.0212, 'lps'),
	(419239, 102, '2015-03-01 00:27:08.000000', 'consum', 0.0226, 'lps'),
	(419240, 102, '2015-03-01 00:27:09.000000', 'consum', 0.0227, 'lps'),
	(419241, 102, '2015-03-01 00:27:10.000000', 'consum', 0.0226, 'lps'),
	(419242, 102, '2015-03-01 00:27:11.000000', 'consum', 0.0221, 'lps'),
	(419243, 102, '2015-03-01 00:27:12.000000', 'consum', 0.0217, 'lps'),
	(419244, 102, '2015-03-01 00:27:13.000000', 'consum', 0.0210, 'lps'),
	(419245, 102, '2015-03-01 00:27:14.000000', 'consum', 0.0212, 'lps'),
	(419246, 102, '2015-03-01 00:27:15.000000', 'consum', 0.0219, 'lps'),
	(419247, 102, '2015-03-01 00:27:16.000000', 'consum', 0.0210, 'lps'),
	(419248, 102, '2015-03-01 00:27:17.000000', 'consum', 0.0223, 'lps'),
	(419249, 102, '2015-03-01 00:27:18.000000', 'consum', 0.0215, 'lps'),
	(419250, 102, '2015-03-01 00:27:19.000000', 'consum', 0.0215, 'lps'),
	(419251, 102, '2015-03-01 00:27:20.000000', 'consum', 0.0222, 'lps'),
	(419252, 102, '2015-03-01 00:27:21.000000', 'consum', 0.0215, 'lps'),
	(419253, 102, '2015-03-01 00:27:22.000000', 'consum', 0.0220, 'lps'),
	(419254, 102, '2015-03-01 00:27:23.000000', 'consum', 0.0226, 'lps'),
	(419255, 102, '2015-03-01 00:27:24.000000', 'consum', 0.0219, 'lps'),
	(419256, 102, '2015-03-01 00:27:25.000000', 'consum', 0.0227, 'lps'),
	(419257, 102, '2015-03-01 00:27:26.000000', 'consum', 0.0229, 'lps'),
	(419258, 102, '2015-03-01 00:27:27.000000', 'consum', 0.0215, 'lps'),
	(419259, 102, '2015-03-01 00:27:28.000000', 'consum', 0.0219, 'lps'),
	(419260, 102, '2015-03-01 00:27:29.000000', 'consum', 0.0218, 'lps'),
	(419261, 102, '2015-03-01 00:27:30.000000', 'consum', 0.0226, 'lps'),
	(419262, 102, '2015-03-01 00:27:31.000000', 'consum', 0.0226, 'lps'),
	(419263, 102, '2015-03-01 00:27:32.000000', 'consum', 0.0223, 'lps'),
	(419264, 102, '2015-03-01 00:27:33.000000', 'consum', 0.0228, 'lps'),
	(419265, 102, '2015-03-01 00:27:34.000000', 'consum', 0.0219, 'lps'),
	(419266, 102, '2015-03-01 00:27:35.000000', 'consum', 0.0225, 'lps'),
	(419267, 102, '2015-03-01 00:27:36.000000', 'consum', 0.0217, 'lps'),
	(419268, 102, '2015-03-01 00:27:37.000000', 'consum', 0.0219, 'lps'),
	(419269, 102, '2015-03-01 00:27:38.000000', 'consum', 0.0214, 'lps'),
	(419270, 102, '2015-03-01 00:27:39.000000', 'consum', 0.0226, 'lps'),
	(419271, 102, '2015-03-01 00:27:40.000000', 'consum', 0.0220, 'lps'),
	(419272, 102, '2015-03-01 00:27:41.000000', 'consum', 0.0229, 'lps'),
	(419273, 102, '2015-03-01 00:27:42.000000', 'consum', 0.0215, 'lps'),
	(419274, 102, '2015-03-01 00:27:43.000000', 'consum', 0.0220, 'lps'),
	(419275, 102, '2015-03-01 00:27:44.000000', 'consum', 0.0225, 'lps'),
	(419276, 102, '2015-03-01 00:27:45.000000', 'consum', 0.0215, 'lps'),
	(419277, 102, '2015-03-01 00:27:46.000000', 'consum', 0.0212, 'lps'),
	(419278, 102, '2015-03-01 00:27:47.000000', 'consum', 0.0223, 'lps'),
	(419279, 102, '2015-03-01 00:27:48.000000', 'consum', 0.0212, 'lps'),
	(419280, 102, '2015-03-01 00:27:49.000000', 'consum', 0.0222, 'lps'),
	(419281, 102, '2015-03-01 00:27:50.000000', 'consum', 0.0223, 'lps'),
	(419282, 102, '2015-03-01 00:27:51.000000', 'consum', 0.0221, 'lps'),
	(419283, 102, '2015-03-01 00:27:52.000000', 'consum', 0.0227, 'lps'),
	(419284, 102, '2015-03-01 00:27:53.000000', 'consum', 0.0223, 'lps'),
	(419285, 102, '2015-03-01 00:27:54.000000', 'consum', 0.0222, 'lps'),
	(419286, 102, '2015-03-01 00:27:55.000000', 'consum', 0.0211, 'lps'),
	(419287, 102, '2015-03-01 00:27:56.000000', 'consum', 0.0218, 'lps'),
	(419288, 102, '2015-03-01 00:27:57.000000', 'consum', 0.0211, 'lps'),
	(419289, 102, '2015-03-01 00:27:58.000000', 'consum', 0.0212, 'lps'),
	(419290, 102, '2015-03-01 00:27:59.000000', 'consum', 0.0217, 'lps'),
	(419291, 102, '2015-03-01 00:28:00.000000', 'consum', 0.0219, 'lps'),
	(419292, 102, '2015-03-01 00:28:01.000000', 'consum', 0.0216, 'lps'),
	(419293, 102, '2015-03-01 00:28:02.000000', 'consum', 0.0212, 'lps'),
	(419294, 102, '2015-03-01 00:28:03.000000', 'consum', 0.0222, 'lps'),
	(419295, 102, '2015-03-01 00:28:04.000000', 'consum', 0.0227, 'lps'),
	(419296, 102, '2015-03-01 00:28:05.000000', 'consum', 0.0218, 'lps'),
	(419297, 102, '2015-03-01 00:28:06.000000', 'consum', 0.0219, 'lps'),
	(419298, 102, '2015-03-01 00:28:07.000000', 'consum', 0.0213, 'lps'),
	(419299, 102, '2015-03-01 00:28:08.000000', 'consum', 0.0218, 'lps'),
	(419300, 102, '2015-03-01 00:28:09.000000', 'consum', 0.0220, 'lps'),
	(419301, 102, '2015-03-01 00:28:10.000000', 'consum', 0.0218, 'lps'),
	(419302, 102, '2015-03-01 00:28:11.000000', 'consum', 0.0220, 'lps'),
	(419303, 102, '2015-03-01 00:28:12.000000', 'consum', 0.0216, 'lps'),
	(419304, 102, '2015-03-01 00:28:13.000000', 'consum', 0.0229, 'lps'),
	(419305, 102, '2015-03-01 00:28:14.000000', 'consum', 0.0228, 'lps'),
	(419306, 102, '2015-03-01 00:28:15.000000', 'consum', 0.0223, 'lps'),
	(419307, 102, '2015-03-01 00:28:16.000000', 'consum', 0.0223, 'lps'),
	(419308, 102, '2015-03-01 00:28:17.000000', 'consum', 0.0218, 'lps'),
	(419309, 102, '2015-03-01 00:28:18.000000', 'consum', 0.0210, 'lps'),
	(419310, 102, '2015-03-01 00:28:19.000000', 'consum', 0.0225, 'lps'),
	(419311, 102, '2015-03-01 00:28:20.000000', 'consum', 0.0226, 'lps'),
	(419312, 102, '2015-03-01 00:28:21.000000', 'consum', 0.0227, 'lps'),
	(419313, 102, '2015-03-01 00:28:22.000000', 'consum', 0.0228, 'lps'),
	(419314, 102, '2015-03-01 00:28:23.000000', 'consum', 0.0229, 'lps'),
	(419315, 102, '2015-03-01 00:28:24.000000', 'consum', 0.0212, 'lps'),
	(419316, 102, '2015-03-01 00:28:25.000000', 'consum', 0.0223, 'lps'),
	(419317, 102, '2015-03-01 00:28:26.000000', 'consum', 0.0229, 'lps'),
	(419318, 102, '2015-03-01 00:28:27.000000', 'consum', 0.0227, 'lps'),
	(419319, 102, '2015-03-01 00:28:28.000000', 'consum', 0.0220, 'lps'),
	(419320, 102, '2015-03-01 00:28:29.000000', 'consum', 0.0229, 'lps'),
	(419321, 102, '2015-03-01 00:28:30.000000', 'consum', 0.0214, 'lps'),
	(419322, 102, '2015-03-01 00:28:31.000000', 'consum', 0.0214, 'lps'),
	(419323, 102, '2015-03-01 00:28:32.000000', 'consum', 0.0217, 'lps'),
	(419324, 102, '2015-03-01 00:28:33.000000', 'consum', 0.0213, 'lps'),
	(419325, 102, '2015-03-01 00:28:34.000000', 'consum', 0.0226, 'lps'),
	(419326, 102, '2015-03-01 00:28:35.000000', 'consum', 0.0220, 'lps'),
	(419327, 102, '2015-03-01 00:28:36.000000', 'consum', 0.0212, 'lps'),
	(419328, 102, '2015-03-01 00:28:37.000000', 'consum', 0.0211, 'lps'),
	(419329, 102, '2015-03-01 00:28:38.000000', 'consum', 0.0210, 'lps'),
	(419330, 102, '2015-03-01 00:28:39.000000', 'consum', 0.0226, 'lps'),
	(419331, 102, '2015-03-01 00:28:40.000000', 'consum', 0.0213, 'lps'),
	(419332, 102, '2015-03-01 00:28:41.000000', 'consum', 0.0217, 'lps'),
	(419333, 102, '2015-03-01 00:28:42.000000', 'consum', 0.0218, 'lps'),
	(419334, 102, '2015-03-01 00:28:43.000000', 'consum', 0.0227, 'lps'),
	(419335, 102, '2015-03-01 00:28:44.000000', 'consum', 0.0210, 'lps'),
	(419336, 102, '2015-03-01 00:28:45.000000', 'consum', 0.0222, 'lps'),
	(419337, 102, '2015-03-01 00:28:46.000000', 'consum', 0.0210, 'lps'),
	(419338, 102, '2015-03-01 00:28:47.000000', 'consum', 0.0213, 'lps'),
	(419339, 102, '2015-03-01 00:28:48.000000', 'consum', 0.0225, 'lps'),
	(419340, 102, '2015-03-01 00:28:49.000000', 'consum', 0.0218, 'lps'),
	(419341, 102, '2015-03-01 00:28:50.000000', 'consum', 0.0226, 'lps'),
	(419342, 102, '2015-03-01 00:28:51.000000', 'consum', 0.0225, 'lps'),
	(419343, 102, '2015-03-01 00:28:52.000000', 'consum', 0.0220, 'lps'),
	(419344, 102, '2015-03-01 00:28:53.000000', 'consum', 0.0213, 'lps'),
	(419345, 102, '2015-03-01 00:28:54.000000', 'consum', 0.0216, 'lps'),
	(419346, 102, '2015-03-01 00:28:55.000000', 'consum', 0.0210, 'lps'),
	(419347, 102, '2015-03-01 00:28:56.000000', 'consum', 0.0213, 'lps'),
	(419348, 102, '2015-03-01 00:28:57.000000', 'consum', 0.0226, 'lps'),
	(419349, 102, '2015-03-01 00:28:58.000000', 'consum', 0.0220, 'lps'),
	(419350, 102, '2015-03-01 00:28:59.000000', 'consum', 0.0213, 'lps'),
	(419351, 102, '2015-03-01 00:29:00.000000', 'consum', 0.0216, 'lps'),
	(419352, 102, '2015-03-01 00:29:01.000000', 'consum', 0.0210, 'lps'),
	(419353, 102, '2015-03-01 00:29:02.000000', 'consum', 0.0211, 'lps'),
	(419354, 102, '2015-03-01 00:29:03.000000', 'consum', 0.0219, 'lps'),
	(419355, 102, '2015-03-01 00:29:04.000000', 'consum', 0.0210, 'lps'),
	(419356, 102, '2015-03-01 00:29:05.000000', 'consum', 0.0224, 'lps'),
	(419357, 102, '2015-03-01 00:29:06.000000', 'consum', 0.0222, 'lps'),
	(419358, 102, '2015-03-01 00:29:07.000000', 'consum', 0.0226, 'lps'),
	(419359, 102, '2015-03-01 00:29:08.000000', 'consum', 0.0215, 'lps'),
	(419360, 102, '2015-03-01 00:29:09.000000', 'consum', 0.0229, 'lps'),
	(419361, 102, '2015-03-01 00:29:10.000000', 'consum', 0.0229, 'lps'),
	(419362, 102, '2015-03-01 00:29:11.000000', 'consum', 0.0210, 'lps'),
	(419363, 102, '2015-03-01 00:29:12.000000', 'consum', 0.0212, 'lps'),
	(419364, 102, '2015-03-01 00:29:13.000000', 'consum', 0.0219, 'lps'),
	(419365, 102, '2015-03-01 00:29:14.000000', 'consum', 0.0211, 'lps'),
	(419366, 102, '2015-03-01 00:29:15.000000', 'consum', 0.0210, 'lps'),
	(419367, 102, '2015-03-01 00:29:16.000000', 'consum', 0.0226, 'lps'),
	(419368, 102, '2015-03-01 00:29:17.000000', 'consum', 0.0210, 'lps'),
	(419369, 102, '2015-03-01 00:29:18.000000', 'consum', 0.0222, 'lps'),
	(419370, 102, '2015-03-01 00:29:19.000000', 'consum', 0.0229, 'lps'),
	(419371, 102, '2015-03-01 00:29:20.000000', 'consum', 0.0212, 'lps'),
	(419372, 102, '2015-03-01 00:29:21.000000', 'consum', 0.0223, 'lps'),
	(419373, 102, '2015-03-01 00:29:22.000000', 'consum', 0.0211, 'lps'),
	(419374, 102, '2015-03-01 00:29:23.000000', 'consum', 0.0216, 'lps'),
	(419375, 102, '2015-03-01 00:29:24.000000', 'consum', 0.0217, 'lps'),
	(419376, 102, '2015-03-01 00:29:25.000000', 'consum', 0.0229, 'lps'),
	(419377, 102, '2015-03-01 00:29:26.000000', 'consum', 0.0223, 'lps'),
	(419378, 102, '2015-03-01 00:29:27.000000', 'consum', 0.0220, 'lps'),
	(419379, 102, '2015-03-01 00:29:28.000000', 'consum', 0.0223, 'lps'),
	(419380, 102, '2015-03-01 00:29:29.000000', 'consum', 0.0222, 'lps'),
	(419381, 102, '2015-03-01 00:29:30.000000', 'consum', 0.0214, 'lps'),
	(419382, 102, '2015-03-01 00:29:31.000000', 'consum', 0.0214, 'lps'),
	(419383, 102, '2015-03-01 00:29:32.000000', 'consum', 0.0216, 'lps'),
	(419384, 102, '2015-03-01 00:29:33.000000', 'consum', 0.0211, 'lps'),
	(419385, 102, '2015-03-01 00:29:34.000000', 'consum', 0.0218, 'lps'),
	(419386, 102, '2015-03-01 00:29:35.000000', 'consum', 0.0227, 'lps'),
	(419387, 102, '2015-03-01 00:29:36.000000', 'consum', 0.0213, 'lps'),
	(419388, 102, '2015-03-01 00:29:37.000000', 'consum', 0.0215, 'lps'),
	(419389, 102, '2015-03-01 00:29:38.000000', 'consum', 0.0225, 'lps'),
	(419390, 102, '2015-03-01 00:29:39.000000', 'consum', 0.0210, 'lps'),
	(419391, 102, '2015-03-01 00:29:40.000000', 'consum', 0.0225, 'lps'),
	(419392, 102, '2015-03-01 00:29:41.000000', 'consum', 0.0225, 'lps'),
	(419393, 102, '2015-03-01 00:29:42.000000', 'consum', 0.0222, 'lps'),
	(419394, 102, '2015-03-01 00:29:43.000000', 'consum', 0.0226, 'lps'),
	(419395, 102, '2015-03-01 00:29:44.000000', 'consum', 0.0213, 'lps'),
	(419396, 102, '2015-03-01 00:29:45.000000', 'consum', 0.0217, 'lps'),
	(419397, 102, '2015-03-01 00:29:46.000000', 'consum', 0.0218, 'lps'),
	(419398, 102, '2015-03-01 00:29:47.000000', 'consum', 0.0211, 'lps'),
	(419399, 102, '2015-03-01 00:29:48.000000', 'consum', 0.0229, 'lps'),
	(419400, 102, '2015-03-01 00:29:49.000000', 'consum', 0.0221, 'lps'),
	(419401, 102, '2015-03-01 00:29:50.000000', 'consum', 0.0212, 'lps'),
	(419402, 102, '2015-03-01 00:29:51.000000', 'consum', 0.0226, 'lps'),
	(419403, 102, '2015-03-01 00:29:52.000000', 'consum', 0.0225, 'lps'),
	(419404, 102, '2015-03-01 00:29:53.000000', 'consum', 0.0217, 'lps'),
	(419405, 102, '2015-03-01 00:29:54.000000', 'consum', 0.0219, 'lps'),
	(419406, 102, '2015-03-01 00:29:55.000000', 'consum', 0.0215, 'lps'),
	(419407, 102, '2015-03-01 00:29:56.000000', 'consum', 0.0210, 'lps'),
	(419408, 102, '2015-03-01 00:29:57.000000', 'consum', 0.0213, 'lps'),
	(419409, 102, '2015-03-01 00:29:58.000000', 'consum', 0.0228, 'lps'),
	(419410, 102, '2015-03-01 00:29:59.000000', 'consum', 0.0210, 'lps'),
	(419411, 102, '2015-03-01 00:30:00.000000', 'consum', 0.0216, 'lps'),
	(419412, 102, '2015-03-01 00:30:01.000000', 'consum', 0.0223, 'lps'),
	(419413, 102, '2015-03-01 00:30:02.000000', 'consum', 0.0217, 'lps'),
	(419414, 102, '2015-03-01 00:30:03.000000', 'consum', 0.0228, 'lps'),
	(419415, 102, '2015-03-01 00:30:04.000000', 'consum', 0.0218, 'lps'),
	(419416, 102, '2015-03-01 00:30:05.000000', 'consum', 0.0218, 'lps'),
	(419417, 102, '2015-03-01 00:30:06.000000', 'consum', 0.0225, 'lps'),
	(419418, 102, '2015-03-01 00:30:07.000000', 'consum', 0.0224, 'lps'),
	(419419, 102, '2015-03-01 00:30:08.000000', 'consum', 0.0212, 'lps'),
	(419420, 102, '2015-03-01 00:30:09.000000', 'consum', 0.0221, 'lps'),
	(419421, 102, '2015-03-01 00:30:10.000000', 'consum', 0.0220, 'lps'),
	(419422, 102, '2015-03-01 00:30:11.000000', 'consum', 0.0228, 'lps'),
	(419423, 102, '2015-03-01 00:30:12.000000', 'consum', 0.0228, 'lps'),
	(419424, 102, '2015-03-01 00:30:13.000000', 'consum', 0.0229, 'lps'),
	(419425, 102, '2015-03-01 00:30:14.000000', 'consum', 0.0211, 'lps'),
	(419426, 102, '2015-03-01 00:30:15.000000', 'consum', 0.0218, 'lps'),
	(419427, 102, '2015-03-01 00:30:16.000000', 'consum', 0.0229, 'lps'),
	(419428, 102, '2015-03-01 00:30:17.000000', 'consum', 0.0220, 'lps'),
	(419429, 102, '2015-03-01 00:30:18.000000', 'consum', 0.0224, 'lps'),
	(419430, 102, '2015-03-01 00:30:19.000000', 'consum', 0.0210, 'lps'),
	(419431, 102, '2015-03-01 00:30:20.000000', 'consum', 0.0211, 'lps'),
	(419432, 102, '2015-03-01 00:30:21.000000', 'consum', 0.0213, 'lps'),
	(419433, 102, '2015-03-01 00:30:22.000000', 'consum', 0.0224, 'lps'),
	(419434, 102, '2015-03-01 00:30:23.000000', 'consum', 0.0212, 'lps'),
	(419435, 102, '2015-03-01 00:30:24.000000', 'consum', 0.0218, 'lps'),
	(419436, 102, '2015-03-01 00:30:25.000000', 'consum', 0.0225, 'lps'),
	(419437, 102, '2015-03-01 00:30:26.000000', 'consum', 0.0220, 'lps'),
	(419438, 102, '2015-03-01 00:30:27.000000', 'consum', 0.0218, 'lps'),
	(419439, 102, '2015-03-01 00:30:28.000000', 'consum', 0.0218, 'lps'),
	(419440, 102, '2015-03-01 00:30:29.000000', 'consum', 0.0228, 'lps'),
	(419441, 102, '2015-03-01 00:30:30.000000', 'consum', 0.0214, 'lps'),
	(419442, 102, '2015-03-01 00:30:31.000000', 'consum', 0.0218, 'lps'),
	(419443, 102, '2015-03-01 00:30:32.000000', 'consum', 0.0217, 'lps'),
	(419444, 102, '2015-03-01 00:30:33.000000', 'consum', 0.0223, 'lps'),
	(419445, 102, '2015-03-01 00:30:34.000000', 'consum', 0.0213, 'lps'),
	(419446, 102, '2015-03-01 00:30:35.000000', 'consum', 0.0226, 'lps'),
	(419447, 102, '2015-03-01 00:30:36.000000', 'consum', 0.0223, 'lps'),
	(419448, 102, '2015-03-01 00:30:37.000000', 'consum', 0.0226, 'lps'),
	(419449, 102, '2015-03-01 00:30:38.000000', 'consum', 0.0214, 'lps'),
	(419450, 102, '2015-03-01 00:30:39.000000', 'consum', 0.0222, 'lps'),
	(419451, 102, '2015-03-01 00:30:40.000000', 'consum', 0.0219, 'lps'),
	(419452, 102, '2015-03-01 00:30:41.000000', 'consum', 0.0221, 'lps'),
	(419453, 102, '2015-03-01 00:30:42.000000', 'consum', 0.0216, 'lps'),
	(419454, 102, '2015-03-01 00:30:43.000000', 'consum', 0.0210, 'lps'),
	(419455, 102, '2015-03-01 00:30:44.000000', 'consum', 0.0211, 'lps'),
	(419456, 102, '2015-03-01 00:30:45.000000', 'consum', 0.0215, 'lps'),
	(419457, 102, '2015-03-01 00:30:46.000000', 'consum', 0.0215, 'lps'),
	(419458, 102, '2015-03-01 00:30:47.000000', 'consum', 0.0218, 'lps'),
	(419459, 102, '2015-03-01 00:30:48.000000', 'consum', 0.0216, 'lps'),
	(419460, 102, '2015-03-01 00:30:49.000000', 'consum', 0.0215, 'lps'),
	(419461, 102, '2015-03-01 00:30:50.000000', 'consum', 0.0219, 'lps'),
	(419462, 102, '2015-03-01 00:30:51.000000', 'consum', 0.0220, 'lps'),
	(419463, 102, '2015-03-01 00:30:52.000000', 'consum', 0.0213, 'lps'),
	(419464, 102, '2015-03-01 00:30:53.000000', 'consum', 0.0216, 'lps'),
	(419465, 102, '2015-03-01 00:30:54.000000', 'consum', 0.0212, 'lps'),
	(419466, 102, '2015-03-01 00:30:55.000000', 'consum', 0.0221, 'lps'),
	(419467, 102, '2015-03-01 00:30:56.000000', 'consum', 0.0221, 'lps'),
	(419468, 102, '2015-03-01 00:30:57.000000', 'consum', 0.0212, 'lps'),
	(419469, 102, '2015-03-01 00:30:58.000000', 'consum', 0.0226, 'lps'),
	(419470, 102, '2015-03-01 00:30:59.000000', 'consum', 0.0224, 'lps'),
	(419471, 102, '2015-03-01 00:31:00.000000', 'consum', 0.0214, 'lps'),
	(419472, 102, '2015-03-01 00:31:01.000000', 'consum', 0.0227, 'lps'),
	(419473, 102, '2015-03-01 00:31:02.000000', 'consum', 0.0224, 'lps'),
	(419474, 102, '2015-03-01 00:31:03.000000', 'consum', 0.0211, 'lps'),
	(419475, 102, '2015-03-01 00:31:04.000000', 'consum', 0.0212, 'lps'),
	(419476, 102, '2015-03-01 00:31:05.000000', 'consum', 0.0220, 'lps'),
	(419477, 102, '2015-03-01 00:31:06.000000', 'consum', 0.0212, 'lps'),
	(419478, 102, '2015-03-01 00:31:07.000000', 'consum', 0.0212, 'lps'),
	(419479, 102, '2015-03-01 00:31:08.000000', 'consum', 0.0216, 'lps'),
	(419480, 102, '2015-03-01 00:31:09.000000', 'consum', 0.0212, 'lps'),
	(419481, 102, '2015-03-01 00:31:10.000000', 'consum', 0.0224, 'lps'),
	(419482, 102, '2015-03-01 00:31:11.000000', 'consum', 0.0216, 'lps'),
	(419483, 102, '2015-03-01 00:31:12.000000', 'consum', 0.0215, 'lps'),
	(419484, 102, '2015-03-01 00:31:13.000000', 'consum', 0.0221, 'lps'),
	(419485, 102, '2015-03-01 00:31:14.000000', 'consum', 0.0228, 'lps'),
	(419486, 102, '2015-03-01 00:31:15.000000', 'consum', 0.0210, 'lps'),
	(419487, 102, '2015-03-01 00:31:16.000000', 'consum', 0.0214, 'lps'),
	(419488, 102, '2015-03-01 00:31:17.000000', 'consum', 0.0211, 'lps'),
	(419489, 102, '2015-03-01 00:31:18.000000', 'consum', 0.0224, 'lps'),
	(419490, 102, '2015-03-01 00:31:19.000000', 'consum', 0.0219, 'lps'),
	(419491, 102, '2015-03-01 00:31:20.000000', 'consum', 0.0211, 'lps'),
	(419492, 102, '2015-03-01 00:31:21.000000', 'consum', 0.0229, 'lps'),
	(419493, 102, '2015-03-01 00:31:22.000000', 'consum', 0.0223, 'lps'),
	(419494, 102, '2015-03-01 00:31:23.000000', 'consum', 0.0217, 'lps'),
	(419495, 102, '2015-03-01 00:31:24.000000', 'consum', 0.0229, 'lps'),
	(419496, 102, '2015-03-01 00:31:25.000000', 'consum', 0.0224, 'lps'),
	(419497, 102, '2015-03-01 00:31:26.000000', 'consum', 0.0221, 'lps'),
	(419498, 102, '2015-03-01 00:31:27.000000', 'consum', 0.0226, 'lps'),
	(419499, 102, '2015-03-01 00:31:28.000000', 'consum', 0.0218, 'lps'),
	(419500, 102, '2015-03-01 00:31:29.000000', 'consum', 0.0220, 'lps'),
	(419501, 102, '2015-03-01 00:31:30.000000', 'consum', 0.0219, 'lps'),
	(419502, 102, '2015-03-01 00:31:31.000000', 'consum', 0.0224, 'lps'),
	(419503, 102, '2015-03-01 00:31:32.000000', 'consum', 0.0212, 'lps'),
	(419504, 102, '2015-03-01 00:31:33.000000', 'consum', 0.0220, 'lps'),
	(419505, 102, '2015-03-01 00:31:34.000000', 'consum', 0.0216, 'lps'),
	(419506, 102, '2015-03-01 00:31:35.000000', 'consum', 0.0228, 'lps'),
	(419507, 102, '2015-03-01 00:31:36.000000', 'consum', 0.0224, 'lps'),
	(419508, 102, '2015-03-01 00:31:37.000000', 'consum', 0.0227, 'lps'),
	(419509, 102, '2015-03-01 00:31:38.000000', 'consum', 0.0214, 'lps'),
	(419510, 102, '2015-03-01 00:31:39.000000', 'consum', 0.0219, 'lps'),
	(419511, 102, '2015-03-01 00:31:40.000000', 'consum', 0.0223, 'lps'),
	(419512, 102, '2015-03-01 00:31:41.000000', 'consum', 0.0229, 'lps'),
	(419513, 102, '2015-03-01 00:31:42.000000', 'consum', 0.0227, 'lps'),
	(419514, 102, '2015-03-01 00:31:43.000000', 'consum', 0.0216, 'lps'),
	(419515, 102, '2015-03-01 00:31:44.000000', 'consum', 0.0211, 'lps'),
	(419516, 102, '2015-03-01 00:31:45.000000', 'consum', 0.0218, 'lps'),
	(419517, 102, '2015-03-01 00:31:46.000000', 'consum', 0.0226, 'lps'),
	(419518, 102, '2015-03-01 00:31:47.000000', 'consum', 0.0229, 'lps'),
	(419519, 102, '2015-03-01 00:31:48.000000', 'consum', 0.0218, 'lps'),
	(419520, 102, '2015-03-01 00:31:49.000000', 'consum', 0.0212, 'lps'),
	(419521, 102, '2015-03-01 00:31:50.000000', 'consum', 0.0217, 'lps'),
	(419522, 102, '2015-03-01 00:31:51.000000', 'consum', 0.0220, 'lps'),
	(419523, 102, '2015-03-01 00:31:52.000000', 'consum', 0.0218, 'lps'),
	(419524, 102, '2015-03-01 00:31:53.000000', 'consum', 0.0221, 'lps'),
	(419525, 102, '2015-03-01 00:31:54.000000', 'consum', 0.0221, 'lps'),
	(419526, 102, '2015-03-01 00:31:55.000000', 'consum', 0.0213, 'lps'),
	(419527, 102, '2015-03-01 00:31:56.000000', 'consum', 0.0211, 'lps'),
	(419528, 102, '2015-03-01 00:31:57.000000', 'consum', 0.0227, 'lps'),
	(419529, 102, '2015-03-01 00:31:58.000000', 'consum', 0.0213, 'lps'),
	(419530, 102, '2015-03-01 00:31:59.000000', 'consum', 0.0214, 'lps'),
	(419531, 102, '2015-03-01 00:32:00.000000', 'consum', 0.0221, 'lps'),
	(419532, 102, '2015-03-01 00:32:01.000000', 'consum', 0.0213, 'lps'),
	(419533, 102, '2015-03-01 00:32:02.000000', 'consum', 0.0213, 'lps'),
	(419534, 102, '2015-03-01 00:32:03.000000', 'consum', 0.0216, 'lps'),
	(419535, 102, '2015-03-01 00:32:04.000000', 'consum', 0.0211, 'lps'),
	(419536, 102, '2015-03-01 00:32:05.000000', 'consum', 0.0220, 'lps'),
	(419537, 102, '2015-03-01 00:32:06.000000', 'consum', 0.0216, 'lps'),
	(419538, 102, '2015-03-01 00:32:07.000000', 'consum', 0.0212, 'lps'),
	(419539, 102, '2015-03-01 00:32:08.000000', 'consum', 0.0221, 'lps'),
	(419540, 102, '2015-03-01 00:32:09.000000', 'consum', 0.0220, 'lps'),
	(419541, 102, '2015-03-01 00:32:10.000000', 'consum', 0.0229, 'lps'),
	(419542, 102, '2015-03-01 00:32:11.000000', 'consum', 0.0214, 'lps'),
	(419543, 102, '2015-03-01 00:32:12.000000', 'consum', 0.0215, 'lps'),
	(419544, 102, '2015-03-01 00:32:13.000000', 'consum', 0.0223, 'lps'),
	(419545, 102, '2015-03-01 00:32:14.000000', 'consum', 0.0219, 'lps'),
	(419546, 102, '2015-03-01 00:32:15.000000', 'consum', 0.0216, 'lps'),
	(419547, 102, '2015-03-01 00:32:16.000000', 'consum', 0.0213, 'lps'),
	(419548, 102, '2015-03-01 00:32:17.000000', 'consum', 0.0229, 'lps'),
	(419549, 102, '2015-03-01 00:32:18.000000', 'consum', 0.0215, 'lps'),
	(419550, 102, '2015-03-01 00:32:19.000000', 'consum', 0.0217, 'lps'),
	(419551, 102, '2015-03-01 00:32:20.000000', 'consum', 0.0213, 'lps'),
	(419552, 102, '2015-03-01 00:32:21.000000', 'consum', 0.0225, 'lps'),
	(419553, 102, '2015-03-01 00:32:22.000000', 'consum', 0.0217, 'lps'),
	(419554, 102, '2015-03-01 00:32:23.000000', 'consum', 0.0220, 'lps'),
	(419555, 102, '2015-03-01 00:32:24.000000', 'consum', 0.0217, 'lps'),
	(419556, 102, '2015-03-01 00:32:25.000000', 'consum', 0.0218, 'lps'),
	(419557, 102, '2015-03-01 00:32:26.000000', 'consum', 0.0229, 'lps'),
	(419558, 102, '2015-03-01 00:32:27.000000', 'consum', 0.0221, 'lps'),
	(419559, 102, '2015-03-01 00:32:28.000000', 'consum', 0.0227, 'lps'),
	(419560, 102, '2015-03-01 00:32:29.000000', 'consum', 0.0225, 'lps'),
	(419561, 102, '2015-03-01 00:32:30.000000', 'consum', 0.0214, 'lps'),
	(419562, 102, '2015-03-01 00:32:31.000000', 'consum', 0.0226, 'lps'),
	(419563, 102, '2015-03-01 00:32:32.000000', 'consum', 0.0217, 'lps'),
	(419564, 102, '2015-03-01 00:32:33.000000', 'consum', 0.0218, 'lps'),
	(419565, 102, '2015-03-01 00:32:34.000000', 'consum', 0.0210, 'lps'),
	(419566, 102, '2015-03-01 00:32:35.000000', 'consum', 0.0226, 'lps'),
	(419567, 102, '2015-03-01 00:32:36.000000', 'consum', 0.0212, 'lps'),
	(419568, 102, '2015-03-01 00:32:37.000000', 'consum', 0.0229, 'lps'),
	(419569, 102, '2015-03-01 00:32:38.000000', 'consum', 0.0223, 'lps'),
	(419570, 102, '2015-03-01 00:32:39.000000', 'consum', 0.0218, 'lps'),
	(419571, 102, '2015-03-01 00:32:40.000000', 'consum', 0.0210, 'lps'),
	(419572, 102, '2015-03-01 00:32:41.000000', 'consum', 0.0227, 'lps'),
	(419573, 102, '2015-03-01 00:32:42.000000', 'consum', 0.0216, 'lps'),
	(419574, 102, '2015-03-01 00:32:43.000000', 'consum', 0.0211, 'lps'),
	(419575, 102, '2015-03-01 00:32:44.000000', 'consum', 0.0215, 'lps'),
	(419576, 102, '2015-03-01 00:32:45.000000', 'consum', 0.0211, 'lps'),
	(419577, 102, '2015-03-01 00:32:46.000000', 'consum', 0.0224, 'lps'),
	(419578, 102, '2015-03-01 00:32:47.000000', 'consum', 0.0216, 'lps'),
	(419579, 102, '2015-03-01 00:32:48.000000', 'consum', 0.0218, 'lps'),
	(419580, 102, '2015-03-01 00:32:49.000000', 'consum', 0.0211, 'lps'),
	(419581, 102, '2015-03-01 00:32:50.000000', 'consum', 0.0213, 'lps'),
	(419582, 102, '2015-03-01 00:32:51.000000', 'consum', 0.0224, 'lps'),
	(419583, 102, '2015-03-01 00:32:52.000000', 'consum', 0.0210, 'lps'),
	(419584, 102, '2015-03-01 00:32:53.000000', 'consum', 0.0210, 'lps'),
	(419585, 102, '2015-03-01 00:32:54.000000', 'consum', 0.0210, 'lps'),
	(419586, 102, '2015-03-01 00:32:55.000000', 'consum', 0.0211, 'lps'),
	(419587, 102, '2015-03-01 00:32:56.000000', 'consum', 0.0214, 'lps'),
	(419588, 102, '2015-03-01 00:32:57.000000', 'consum', 0.0227, 'lps'),
	(419589, 102, '2015-03-01 00:32:58.000000', 'consum', 0.0223, 'lps'),
	(419590, 102, '2015-03-01 00:32:59.000000', 'consum', 0.0224, 'lps'),
	(419591, 102, '2015-03-01 00:33:00.000000', 'consum', 0.0224, 'lps'),
	(419592, 102, '2015-03-01 00:33:01.000000', 'consum', 0.0218, 'lps'),
	(419593, 102, '2015-03-01 00:33:02.000000', 'consum', 0.0227, 'lps'),
	(419594, 102, '2015-03-01 00:33:03.000000', 'consum', 0.0212, 'lps'),
	(419595, 102, '2015-03-01 00:33:04.000000', 'consum', 0.0210, 'lps'),
	(419596, 102, '2015-03-01 00:33:05.000000', 'consum', 0.0222, 'lps'),
	(419597, 102, '2015-03-01 00:33:06.000000', 'consum', 0.0213, 'lps'),
	(419598, 102, '2015-03-01 00:33:07.000000', 'consum', 0.0228, 'lps'),
	(419599, 102, '2015-03-01 00:33:08.000000', 'consum', 0.0211, 'lps'),
	(419600, 102, '2015-03-01 00:33:09.000000', 'consum', 0.0220, 'lps'),
	(419601, 102, '2015-03-01 00:33:10.000000', 'consum', 0.0220, 'lps'),
	(419602, 102, '2015-03-01 00:33:11.000000', 'consum', 0.0228, 'lps'),
	(419603, 102, '2015-03-01 00:33:12.000000', 'consum', 0.0213, 'lps'),
	(419604, 102, '2015-03-01 00:33:13.000000', 'consum', 0.0211, 'lps'),
	(419605, 102, '2015-03-01 00:33:14.000000', 'consum', 0.0228, 'lps'),
	(419606, 102, '2015-03-01 00:33:15.000000', 'consum', 0.0217, 'lps'),
	(419607, 102, '2015-03-01 00:33:16.000000', 'consum', 0.0212, 'lps'),
	(419608, 102, '2015-03-01 00:33:17.000000', 'consum', 0.0218, 'lps'),
	(419609, 102, '2015-03-01 00:33:18.000000', 'consum', 0.0225, 'lps'),
	(419610, 102, '2015-03-01 00:33:19.000000', 'consum', 0.0222, 'lps'),
	(419611, 102, '2015-03-01 00:33:20.000000', 'consum', 0.0224, 'lps'),
	(419612, 102, '2015-03-01 00:33:21.000000', 'consum', 0.0226, 'lps'),
	(419613, 102, '2015-03-01 00:33:22.000000', 'consum', 0.0226, 'lps'),
	(419614, 102, '2015-03-01 00:33:23.000000', 'consum', 0.0224, 'lps'),
	(419615, 102, '2015-03-01 00:33:24.000000', 'consum', 0.0214, 'lps'),
	(419616, 102, '2015-03-01 00:33:25.000000', 'consum', 0.0229, 'lps'),
	(419617, 102, '2015-03-01 00:33:26.000000', 'consum', 0.0211, 'lps'),
	(419618, 102, '2015-03-01 00:33:27.000000', 'consum', 0.0221, 'lps'),
	(419619, 102, '2015-03-01 00:33:28.000000', 'consum', 0.0221, 'lps'),
	(419620, 102, '2015-03-01 00:33:29.000000', 'consum', 0.0211, 'lps'),
	(419621, 102, '2015-03-01 00:33:30.000000', 'consum', 0.0225, 'lps'),
	(419622, 102, '2015-03-01 00:33:31.000000', 'consum', 0.0220, 'lps'),
	(419623, 102, '2015-03-01 00:33:32.000000', 'consum', 0.0217, 'lps'),
	(419624, 102, '2015-03-01 00:33:33.000000', 'consum', 0.0215, 'lps'),
	(419625, 102, '2015-03-01 00:33:34.000000', 'consum', 0.0214, 'lps'),
	(419626, 102, '2015-03-01 00:33:35.000000', 'consum', 0.0218, 'lps'),
	(419627, 102, '2015-03-01 00:33:36.000000', 'consum', 0.0217, 'lps'),
	(419628, 102, '2015-03-01 00:33:37.000000', 'consum', 0.0222, 'lps'),
	(419629, 102, '2015-03-01 00:33:38.000000', 'consum', 0.0210, 'lps'),
	(419630, 102, '2015-03-01 00:33:39.000000', 'consum', 0.0216, 'lps'),
	(419631, 102, '2015-03-01 00:33:40.000000', 'consum', 0.0219, 'lps'),
	(419632, 102, '2015-03-01 00:33:41.000000', 'consum', 0.0216, 'lps'),
	(419633, 102, '2015-03-01 00:33:42.000000', 'consum', 0.0213, 'lps'),
	(419634, 102, '2015-03-01 00:33:43.000000', 'consum', 0.0229, 'lps'),
	(419635, 102, '2015-03-01 00:33:44.000000', 'consum', 0.0216, 'lps'),
	(419636, 102, '2015-03-01 00:33:45.000000', 'consum', 0.0222, 'lps'),
	(419637, 102, '2015-03-01 00:33:46.000000', 'consum', 0.0213, 'lps'),
	(419638, 102, '2015-03-01 00:33:47.000000', 'consum', 0.0212, 'lps'),
	(419639, 102, '2015-03-01 00:33:48.000000', 'consum', 0.0210, 'lps'),
	(419640, 102, '2015-03-01 00:33:49.000000', 'consum', 0.0226, 'lps'),
	(419641, 102, '2015-03-01 00:33:50.000000', 'consum', 0.0229, 'lps'),
	(419642, 102, '2015-03-01 00:33:51.000000', 'consum', 0.0219, 'lps'),
	(419643, 102, '2015-03-01 00:33:52.000000', 'consum', 0.0218, 'lps'),
	(419644, 102, '2015-03-01 00:33:53.000000', 'consum', 0.0224, 'lps'),
	(419645, 102, '2015-03-01 00:33:54.000000', 'consum', 0.0216, 'lps'),
	(419646, 102, '2015-03-01 00:33:55.000000', 'consum', 0.0218, 'lps'),
	(419647, 102, '2015-03-01 00:33:56.000000', 'consum', 0.0214, 'lps'),
	(419648, 102, '2015-03-01 00:33:57.000000', 'consum', 0.0225, 'lps'),
	(419649, 102, '2015-03-01 00:33:58.000000', 'consum', 0.0213, 'lps'),
	(419650, 102, '2015-03-01 00:33:59.000000', 'consum', 0.0223, 'lps'),
	(419651, 102, '2015-03-01 00:34:00.000000', 'consum', 0.0226, 'lps'),
	(419652, 102, '2015-03-01 00:34:01.000000', 'consum', 0.0210, 'lps'),
	(419653, 102, '2015-03-01 00:34:02.000000', 'consum', 0.0223, 'lps'),
	(419654, 102, '2015-03-01 00:34:03.000000', 'consum', 0.0217, 'lps'),
	(419655, 102, '2015-03-01 00:34:04.000000', 'consum', 0.0226, 'lps'),
	(419656, 102, '2015-03-01 00:34:05.000000', 'consum', 0.0229, 'lps'),
	(419657, 102, '2015-03-01 00:34:06.000000', 'consum', 0.0216, 'lps'),
	(419658, 102, '2015-03-01 00:34:07.000000', 'consum', 0.0225, 'lps'),
	(419659, 102, '2015-03-01 00:34:08.000000', 'consum', 0.0227, 'lps'),
	(419660, 102, '2015-03-01 00:34:09.000000', 'consum', 0.0229, 'lps'),
	(419661, 102, '2015-03-01 00:34:10.000000', 'consum', 0.0217, 'lps'),
	(419662, 102, '2015-03-01 00:34:11.000000', 'consum', 0.0227, 'lps'),
	(419663, 102, '2015-03-01 00:34:12.000000', 'consum', 0.0217, 'lps'),
	(419664, 102, '2015-03-01 00:34:13.000000', 'consum', 0.0212, 'lps'),
	(419665, 102, '2015-03-01 00:34:14.000000', 'consum', 0.0222, 'lps'),
	(419666, 102, '2015-03-01 00:34:15.000000', 'consum', 0.0223, 'lps'),
	(419667, 102, '2015-03-01 00:34:16.000000', 'consum', 0.0221, 'lps'),
	(419668, 102, '2015-03-01 00:34:17.000000', 'consum', 0.0224, 'lps'),
	(419669, 102, '2015-03-01 00:34:18.000000', 'consum', 0.0227, 'lps'),
	(419670, 102, '2015-03-01 00:34:19.000000', 'consum', 0.0214, 'lps'),
	(419671, 102, '2015-03-01 00:34:20.000000', 'consum', 0.0220, 'lps'),
	(419672, 102, '2015-03-01 00:34:21.000000', 'consum', 0.0210, 'lps'),
	(419673, 102, '2015-03-01 00:34:22.000000', 'consum', 0.0220, 'lps'),
	(419674, 102, '2015-03-01 00:34:23.000000', 'consum', 0.0219, 'lps'),
	(419675, 102, '2015-03-01 00:34:24.000000', 'consum', 0.0226, 'lps'),
	(419676, 102, '2015-03-01 00:34:25.000000', 'consum', 0.0223, 'lps'),
	(419677, 102, '2015-03-01 00:34:26.000000', 'consum', 0.0229, 'lps'),
	(419678, 102, '2015-03-01 00:34:27.000000', 'consum', 0.0227, 'lps'),
	(419679, 102, '2015-03-01 00:34:28.000000', 'consum', 0.0219, 'lps'),
	(419680, 102, '2015-03-01 00:34:29.000000', 'consum', 0.0222, 'lps'),
	(419681, 102, '2015-03-01 00:34:30.000000', 'consum', 0.0223, 'lps'),
	(419682, 102, '2015-03-01 00:34:31.000000', 'consum', 0.0222, 'lps'),
	(419683, 102, '2015-03-01 00:34:32.000000', 'consum', 0.0210, 'lps'),
	(419684, 102, '2015-03-01 00:34:33.000000', 'consum', 0.0213, 'lps'),
	(419685, 102, '2015-03-01 00:34:34.000000', 'consum', 0.0226, 'lps'),
	(419686, 102, '2015-03-01 00:34:35.000000', 'consum', 0.0222, 'lps'),
	(419687, 102, '2015-03-01 00:34:36.000000', 'consum', 0.0221, 'lps'),
	(419688, 102, '2015-03-01 00:34:37.000000', 'consum', 0.0211, 'lps'),
	(419689, 102, '2015-03-01 00:34:38.000000', 'consum', 0.0220, 'lps'),
	(419690, 102, '2015-03-01 00:34:39.000000', 'consum', 0.0221, 'lps'),
	(419691, 102, '2015-03-01 00:34:40.000000', 'consum', 0.0213, 'lps'),
	(419692, 102, '2015-03-01 00:34:41.000000', 'consum', 0.0211, 'lps'),
	(419693, 102, '2015-03-01 00:34:42.000000', 'consum', 0.0210, 'lps'),
	(419694, 102, '2015-03-01 00:34:43.000000', 'consum', 0.0226, 'lps'),
	(419695, 102, '2015-03-01 00:34:44.000000', 'consum', 0.0229, 'lps'),
	(419696, 102, '2015-03-01 00:34:45.000000', 'consum', 0.0219, 'lps'),
	(419697, 102, '2015-03-01 00:34:46.000000', 'consum', 0.0217, 'lps'),
	(419698, 102, '2015-03-01 00:34:47.000000', 'consum', 0.0220, 'lps'),
	(419699, 102, '2015-03-01 00:34:48.000000', 'consum', 0.0220, 'lps'),
	(419700, 102, '2015-03-01 00:34:49.000000', 'consum', 0.0210, 'lps'),
	(419701, 102, '2015-03-01 00:34:50.000000', 'consum', 0.0219, 'lps'),
	(419702, 102, '2015-03-01 00:34:51.000000', 'consum', 0.0217, 'lps'),
	(419703, 102, '2015-03-01 00:34:52.000000', 'consum', 0.0218, 'lps'),
	(419704, 102, '2015-03-01 00:34:53.000000', 'consum', 0.0210, 'lps'),
	(419705, 102, '2015-03-01 00:34:54.000000', 'consum', 0.0226, 'lps'),
	(419706, 102, '2015-03-01 00:34:55.000000', 'consum', 0.0211, 'lps'),
	(419707, 102, '2015-03-01 00:34:56.000000', 'consum', 0.0228, 'lps'),
	(419708, 102, '2015-03-01 00:34:57.000000', 'consum', 0.0215, 'lps'),
	(419709, 102, '2015-03-01 00:34:58.000000', 'consum', 0.0223, 'lps'),
	(419710, 102, '2015-03-01 00:34:59.000000', 'consum', 0.0221, 'lps'),
	(419711, 102, '2015-03-01 00:35:00.000000', 'consum', 0.0228, 'lps'),
	(419712, 102, '2015-03-01 00:35:01.000000', 'consum', 0.0226, 'lps'),
	(419713, 102, '2015-03-01 00:35:02.000000', 'consum', 0.0215, 'lps'),
	(419714, 102, '2015-03-01 00:35:03.000000', 'consum', 0.0210, 'lps'),
	(419715, 102, '2015-03-01 00:35:04.000000', 'consum', 0.0213, 'lps'),
	(419716, 102, '2015-03-01 00:35:05.000000', 'consum', 0.0224, 'lps'),
	(419717, 102, '2015-03-01 00:35:06.000000', 'consum', 0.0215, 'lps'),
	(419718, 102, '2015-03-01 00:35:07.000000', 'consum', 0.0214, 'lps'),
	(419719, 102, '2015-03-01 00:35:08.000000', 'consum', 0.0215, 'lps'),
	(419720, 102, '2015-03-01 00:35:09.000000', 'consum', 0.0221, 'lps'),
	(419721, 102, '2015-03-01 00:35:10.000000', 'consum', 0.0213, 'lps'),
	(419722, 102, '2015-03-01 00:35:11.000000', 'consum', 0.0211, 'lps'),
	(419723, 102, '2015-03-01 00:35:12.000000', 'consum', 0.0225, 'lps'),
	(419724, 102, '2015-03-01 00:35:13.000000', 'consum', 0.0223, 'lps'),
	(419725, 102, '2015-03-01 00:35:14.000000', 'consum', 0.0213, 'lps'),
	(419726, 102, '2015-03-01 00:35:15.000000', 'consum', 0.0225, 'lps'),
	(419727, 102, '2015-03-01 00:35:16.000000', 'consum', 0.0216, 'lps'),
	(419728, 102, '2015-03-01 00:35:17.000000', 'consum', 0.0215, 'lps'),
	(419729, 102, '2015-03-01 00:35:18.000000', 'consum', 0.0219, 'lps'),
	(419730, 102, '2015-03-01 00:35:19.000000', 'consum', 0.0220, 'lps'),
	(419731, 102, '2015-03-01 00:35:20.000000', 'consum', 0.0213, 'lps'),
	(419732, 102, '2015-03-01 00:35:21.000000', 'consum', 0.0215, 'lps'),
	(419733, 102, '2015-03-01 00:35:22.000000', 'consum', 0.0227, 'lps'),
	(419734, 102, '2015-03-01 00:35:23.000000', 'consum', 0.0222, 'lps'),
	(419735, 102, '2015-03-01 00:35:24.000000', 'consum', 0.0219, 'lps'),
	(419736, 102, '2015-03-01 00:35:25.000000', 'consum', 0.0221, 'lps'),
	(419737, 102, '2015-03-01 00:35:26.000000', 'consum', 0.0218, 'lps'),
	(419738, 102, '2015-03-01 00:35:27.000000', 'consum', 0.0218, 'lps'),
	(419739, 102, '2015-03-01 00:35:28.000000', 'consum', 0.0225, 'lps'),
	(419740, 102, '2015-03-01 00:35:29.000000', 'consum', 0.0222, 'lps'),
	(419741, 102, '2015-03-01 00:35:30.000000', 'consum', 0.0227, 'lps'),
	(419742, 102, '2015-03-01 00:35:31.000000', 'consum', 0.0220, 'lps'),
	(419743, 102, '2015-03-01 00:35:32.000000', 'consum', 0.0229, 'lps'),
	(419744, 102, '2015-03-01 00:35:33.000000', 'consum', 0.0215, 'lps'),
	(419745, 102, '2015-03-01 00:35:34.000000', 'consum', 0.0219, 'lps'),
	(419746, 102, '2015-03-01 00:35:35.000000', 'consum', 0.0219, 'lps'),
	(419747, 102, '2015-03-01 00:35:36.000000', 'consum', 0.0210, 'lps'),
	(419748, 102, '2015-03-01 00:35:37.000000', 'consum', 0.0221, 'lps'),
	(419749, 102, '2015-03-01 00:35:38.000000', 'consum', 0.0229, 'lps'),
	(419750, 102, '2015-03-01 00:35:39.000000', 'consum', 0.0229, 'lps'),
	(419751, 102, '2015-03-01 00:35:40.000000', 'consum', 0.0211, 'lps'),
	(419752, 102, '2015-03-01 00:35:41.000000', 'consum', 0.0217, 'lps'),
	(419753, 102, '2015-03-01 00:35:42.000000', 'consum', 0.0221, 'lps'),
	(419754, 102, '2015-03-01 00:35:43.000000', 'consum', 0.0228, 'lps'),
	(419755, 102, '2015-03-01 00:35:44.000000', 'consum', 0.0224, 'lps'),
	(419756, 102, '2015-03-01 00:35:45.000000', 'consum', 0.0210, 'lps'),
	(419757, 102, '2015-03-01 00:35:46.000000', 'consum', 0.0227, 'lps'),
	(419758, 102, '2015-03-01 00:35:47.000000', 'consum', 0.0217, 'lps'),
	(419759, 102, '2015-03-01 00:35:48.000000', 'consum', 0.0214, 'lps'),
	(419760, 102, '2015-03-01 00:35:49.000000', 'consum', 0.0229, 'lps'),
	(419761, 102, '2015-03-01 00:35:50.000000', 'consum', 0.0212, 'lps'),
	(419762, 102, '2015-03-01 00:35:51.000000', 'consum', 0.0227, 'lps'),
	(419763, 102, '2015-03-01 00:35:52.000000', 'consum', 0.0226, 'lps'),
	(419764, 102, '2015-03-01 00:35:53.000000', 'consum', 0.0221, 'lps'),
	(419765, 102, '2015-03-01 00:35:54.000000', 'consum', 0.0219, 'lps'),
	(419766, 102, '2015-03-01 00:35:55.000000', 'consum', 0.0220, 'lps'),
	(419767, 102, '2015-03-01 00:35:56.000000', 'consum', 0.0214, 'lps'),
	(419768, 102, '2015-03-01 00:35:57.000000', 'consum', 0.0220, 'lps'),
	(419769, 102, '2015-03-01 00:35:58.000000', 'consum', 0.0211, 'lps'),
	(419770, 102, '2015-03-01 00:35:59.000000', 'consum', 0.0222, 'lps'),
	(419771, 102, '2015-03-01 00:36:00.000000', 'consum', 0.0210, 'lps'),
	(419772, 102, '2015-03-01 00:36:01.000000', 'consum', 0.0214, 'lps'),
	(419773, 102, '2015-03-01 00:36:02.000000', 'consum', 0.0210, 'lps'),
	(419774, 102, '2015-03-01 00:36:03.000000', 'consum', 0.0218, 'lps'),
	(419775, 102, '2015-03-01 00:36:04.000000', 'consum', 0.0211, 'lps'),
	(419776, 102, '2015-03-01 00:36:05.000000', 'consum', 0.0212, 'lps'),
	(419777, 102, '2015-03-01 00:36:06.000000', 'consum', 0.0217, 'lps'),
	(419778, 102, '2015-03-01 00:36:07.000000', 'consum', 0.0218, 'lps'),
	(419779, 102, '2015-03-01 00:36:08.000000', 'consum', 0.0211, 'lps'),
	(419780, 102, '2015-03-01 00:36:09.000000', 'consum', 0.0212, 'lps'),
	(419781, 102, '2015-03-01 00:36:10.000000', 'consum', 0.0216, 'lps'),
	(419782, 102, '2015-03-01 00:36:11.000000', 'consum', 0.0217, 'lps'),
	(419783, 102, '2015-03-01 00:36:12.000000', 'consum', 0.0225, 'lps'),
	(419784, 102, '2015-03-01 00:36:13.000000', 'consum', 0.0226, 'lps'),
	(419785, 102, '2015-03-01 00:36:14.000000', 'consum', 0.0223, 'lps'),
	(419786, 102, '2015-03-01 00:36:15.000000', 'consum', 0.0210, 'lps'),
	(419787, 102, '2015-03-01 00:36:16.000000', 'consum', 0.0229, 'lps'),
	(419788, 102, '2015-03-01 00:36:17.000000', 'consum', 0.0227, 'lps'),
	(419789, 102, '2015-03-01 00:36:18.000000', 'consum', 0.0218, 'lps'),
	(419790, 102, '2015-03-01 00:36:19.000000', 'consum', 0.0218, 'lps'),
	(419791, 102, '2015-03-01 00:36:20.000000', 'consum', 0.0229, 'lps'),
	(419792, 102, '2015-03-01 00:36:21.000000', 'consum', 0.0222, 'lps'),
	(419793, 102, '2015-03-01 00:36:22.000000', 'consum', 0.0213, 'lps'),
	(419794, 102, '2015-03-01 00:36:23.000000', 'consum', 0.0211, 'lps'),
	(419795, 102, '2015-03-01 00:36:24.000000', 'consum', 0.0225, 'lps'),
	(419796, 102, '2015-03-01 00:36:25.000000', 'consum', 0.0223, 'lps'),
	(419797, 102, '2015-03-01 00:36:26.000000', 'consum', 0.0211, 'lps'),
	(419798, 102, '2015-03-01 00:36:27.000000', 'consum', 0.0215, 'lps'),
	(419799, 102, '2015-03-01 00:36:28.000000', 'consum', 0.0215, 'lps'),
	(419800, 102, '2015-03-01 00:36:29.000000', 'consum', 0.0217, 'lps'),
	(419801, 102, '2015-03-01 00:36:30.000000', 'consum', 0.0213, 'lps'),
	(419802, 102, '2015-03-01 00:36:31.000000', 'consum', 0.0224, 'lps'),
	(419803, 102, '2015-03-01 00:36:32.000000', 'consum', 0.0211, 'lps'),
	(419804, 102, '2015-03-01 00:36:33.000000', 'consum', 0.0214, 'lps'),
	(419805, 102, '2015-03-01 00:36:34.000000', 'consum', 0.0228, 'lps'),
	(419806, 102, '2015-03-01 00:36:35.000000', 'consum', 0.0210, 'lps'),
	(419807, 102, '2015-03-01 00:36:36.000000', 'consum', 0.0215, 'lps'),
	(419808, 102, '2015-03-01 00:36:37.000000', 'consum', 0.0217, 'lps'),
	(419809, 102, '2015-03-01 00:36:38.000000', 'consum', 0.0211, 'lps'),
	(419810, 102, '2015-03-01 00:36:39.000000', 'consum', 0.0214, 'lps'),
	(419811, 102, '2015-03-01 00:36:40.000000', 'consum', 0.0228, 'lps'),
	(419812, 102, '2015-03-01 00:36:41.000000', 'consum', 0.0226, 'lps'),
	(419813, 102, '2015-03-01 00:36:42.000000', 'consum', 0.0218, 'lps'),
	(419814, 102, '2015-03-01 00:36:43.000000', 'consum', 0.0223, 'lps'),
	(419815, 102, '2015-03-01 00:36:44.000000', 'consum', 0.0210, 'lps'),
	(419816, 102, '2015-03-01 00:36:45.000000', 'consum', 0.0213, 'lps'),
	(419817, 102, '2015-03-01 00:36:46.000000', 'consum', 0.0223, 'lps'),
	(419818, 102, '2015-03-01 00:36:47.000000', 'consum', 0.0229, 'lps'),
	(419819, 102, '2015-03-01 00:36:48.000000', 'consum', 0.0227, 'lps'),
	(419820, 102, '2015-03-01 00:36:49.000000', 'consum', 0.0217, 'lps'),
	(419821, 102, '2015-03-01 00:36:50.000000', 'consum', 0.0213, 'lps'),
	(419822, 102, '2015-03-01 00:36:51.000000', 'consum', 0.0226, 'lps'),
	(419823, 102, '2015-03-01 00:36:52.000000', 'consum', 0.0220, 'lps'),
	(419824, 102, '2015-03-01 00:36:53.000000', 'consum', 0.0212, 'lps'),
	(419825, 102, '2015-03-01 00:36:54.000000', 'consum', 0.0213, 'lps'),
	(419826, 102, '2015-03-01 00:36:55.000000', 'consum', 0.0218, 'lps'),
	(419827, 102, '2015-03-01 00:36:56.000000', 'consum', 0.0222, 'lps'),
	(419828, 102, '2015-03-01 00:36:57.000000', 'consum', 0.0224, 'lps'),
	(419829, 102, '2015-03-01 00:36:58.000000', 'consum', 0.0228, 'lps'),
	(419830, 102, '2015-03-01 00:36:59.000000', 'consum', 0.0218, 'lps'),
	(419831, 102, '2015-03-01 00:37:00.000000', 'consum', 0.0218, 'lps'),
	(419832, 102, '2015-03-01 00:37:01.000000', 'consum', 0.0223, 'lps'),
	(419833, 102, '2015-03-01 00:37:02.000000', 'consum', 0.0213, 'lps'),
	(419834, 102, '2015-03-01 00:37:03.000000', 'consum', 0.0227, 'lps'),
	(419835, 102, '2015-03-01 00:37:04.000000', 'consum', 0.0224, 'lps'),
	(419836, 102, '2015-03-01 00:37:05.000000', 'consum', 0.0211, 'lps'),
	(419837, 102, '2015-03-01 00:37:06.000000', 'consum', 0.0214, 'lps'),
	(419838, 102, '2015-03-01 00:37:07.000000', 'consum', 0.0228, 'lps'),
	(419839, 102, '2015-03-01 00:37:08.000000', 'consum', 0.0226, 'lps'),
	(419840, 102, '2015-03-01 00:37:09.000000', 'consum', 0.0219, 'lps'),
	(419841, 102, '2015-03-01 00:37:10.000000', 'consum', 0.0226, 'lps'),
	(419842, 102, '2015-03-01 00:37:11.000000', 'consum', 0.0223, 'lps'),
	(419843, 102, '2015-03-01 00:37:12.000000', 'consum', 0.0227, 'lps'),
	(419844, 102, '2015-03-01 00:37:13.000000', 'consum', 0.0217, 'lps'),
	(419845, 102, '2015-03-01 00:37:14.000000', 'consum', 0.0214, 'lps'),
	(419846, 102, '2015-03-01 00:37:15.000000', 'consum', 0.0229, 'lps'),
	(419847, 102, '2015-03-01 00:37:16.000000', 'consum', 0.0216, 'lps'),
	(419848, 102, '2015-03-01 00:37:17.000000', 'consum', 0.0221, 'lps'),
	(419849, 102, '2015-03-01 00:37:18.000000', 'consum', 0.0210, 'lps'),
	(419850, 102, '2015-03-01 00:37:19.000000', 'consum', 0.0216, 'lps'),
	(419851, 102, '2015-03-01 00:37:20.000000', 'consum', 0.0223, 'lps'),
	(419852, 102, '2015-03-01 00:37:21.000000', 'consum', 0.0215, 'lps'),
	(419853, 102, '2015-03-01 00:37:22.000000', 'consum', 0.0217, 'lps'),
	(419854, 102, '2015-03-01 00:37:23.000000', 'consum', 0.0229, 'lps'),
	(419855, 102, '2015-03-01 00:37:24.000000', 'consum', 0.0227, 'lps'),
	(419856, 102, '2015-03-01 00:37:25.000000', 'consum', 0.0219, 'lps'),
	(419857, 102, '2015-03-01 00:37:26.000000', 'consum', 0.0223, 'lps'),
	(419858, 102, '2015-03-01 00:37:27.000000', 'consum', 0.0211, 'lps'),
	(419859, 102, '2015-03-01 00:37:28.000000', 'consum', 0.0214, 'lps'),
	(419860, 102, '2015-03-01 00:37:29.000000', 'consum', 0.0210, 'lps'),
	(419861, 102, '2015-03-01 00:37:30.000000', 'consum', 0.0217, 'lps'),
	(419862, 102, '2015-03-01 00:37:31.000000', 'consum', 0.0226, 'lps'),
	(419863, 102, '2015-03-01 00:37:32.000000', 'consum', 0.0229, 'lps'),
	(419864, 102, '2015-03-01 00:37:33.000000', 'consum', 0.0218, 'lps'),
	(419865, 102, '2015-03-01 00:37:34.000000', 'consum', 0.0214, 'lps'),
	(419866, 102, '2015-03-01 00:37:35.000000', 'consum', 0.0227, 'lps'),
	(419867, 102, '2015-03-01 00:37:36.000000', 'consum', 0.0224, 'lps'),
	(419868, 102, '2015-03-01 00:37:37.000000', 'consum', 0.0227, 'lps'),
	(419869, 102, '2015-03-01 00:37:38.000000', 'consum', 0.0215, 'lps'),
	(419870, 102, '2015-03-01 00:37:39.000000', 'consum', 0.0226, 'lps'),
	(419871, 102, '2015-03-01 00:37:40.000000', 'consum', 0.0213, 'lps'),
	(419872, 102, '2015-03-01 00:37:41.000000', 'consum', 0.0219, 'lps'),
	(419873, 102, '2015-03-01 00:37:42.000000', 'consum', 0.0228, 'lps'),
	(419874, 102, '2015-03-01 00:37:43.000000', 'consum', 0.0212, 'lps'),
	(419875, 102, '2015-03-01 00:37:44.000000', 'consum', 0.0228, 'lps'),
	(419876, 102, '2015-03-01 00:37:45.000000', 'consum', 0.0215, 'lps'),
	(419877, 102, '2015-03-01 00:37:46.000000', 'consum', 0.0219, 'lps'),
	(419878, 102, '2015-03-01 00:37:47.000000', 'consum', 0.0221, 'lps'),
	(419879, 102, '2015-03-01 00:37:48.000000', 'consum', 0.0217, 'lps'),
	(419880, 102, '2015-03-01 00:37:49.000000', 'consum', 0.0215, 'lps'),
	(419881, 102, '2015-03-01 00:37:50.000000', 'consum', 0.0213, 'lps'),
	(419882, 102, '2015-03-01 00:37:51.000000', 'consum', 0.0211, 'lps'),
	(419883, 102, '2015-03-01 00:37:52.000000', 'consum', 0.0228, 'lps'),
	(419884, 102, '2015-03-01 00:37:53.000000', 'consum', 0.0215, 'lps'),
	(419885, 102, '2015-03-01 00:37:54.000000', 'consum', 0.0223, 'lps'),
	(419886, 102, '2015-03-01 00:37:55.000000', 'consum', 0.0220, 'lps'),
	(419887, 102, '2015-03-01 00:37:56.000000', 'consum', 0.0220, 'lps'),
	(419888, 102, '2015-03-01 00:37:57.000000', 'consum', 0.0213, 'lps'),
	(419889, 102, '2015-03-01 00:37:58.000000', 'consum', 0.0213, 'lps'),
	(419890, 102, '2015-03-01 00:37:59.000000', 'consum', 0.0219, 'lps'),
	(419891, 102, '2015-03-01 00:38:00.000000', 'consum', 0.0226, 'lps'),
	(419892, 102, '2015-03-01 00:38:01.000000', 'consum', 0.0222, 'lps'),
	(419893, 102, '2015-03-01 00:38:02.000000', 'consum', 0.0223, 'lps'),
	(419894, 102, '2015-03-01 00:38:03.000000', 'consum', 0.0222, 'lps'),
	(419895, 102, '2015-03-01 00:38:04.000000', 'consum', 0.0229, 'lps'),
	(419896, 102, '2015-03-01 00:38:05.000000', 'consum', 0.0211, 'lps'),
	(419897, 102, '2015-03-01 00:38:06.000000', 'consum', 0.0217, 'lps'),
	(419898, 102, '2015-03-01 00:38:07.000000', 'consum', 0.0225, 'lps'),
	(419899, 102, '2015-03-01 00:38:08.000000', 'consum', 0.0224, 'lps'),
	(419900, 102, '2015-03-01 00:38:09.000000', 'consum', 0.0213, 'lps'),
	(419901, 102, '2015-03-01 00:38:10.000000', 'consum', 0.0224, 'lps'),
	(419902, 102, '2015-03-01 00:38:11.000000', 'consum', 0.0214, 'lps'),
	(419903, 102, '2015-03-01 00:38:12.000000', 'consum', 0.0226, 'lps'),
	(419904, 102, '2015-03-01 00:38:13.000000', 'consum', 0.0219, 'lps'),
	(419905, 102, '2015-03-01 00:38:14.000000', 'consum', 0.0229, 'lps'),
	(419906, 102, '2015-03-01 00:38:15.000000', 'consum', 0.0219, 'lps'),
	(419907, 102, '2015-03-01 00:38:16.000000', 'consum', 0.0219, 'lps'),
	(419908, 102, '2015-03-01 00:38:17.000000', 'consum', 0.0228, 'lps'),
	(419909, 102, '2015-03-01 00:38:18.000000', 'consum', 0.0214, 'lps'),
	(419910, 102, '2015-03-01 00:38:19.000000', 'consum', 0.0216, 'lps'),
	(419911, 102, '2015-03-01 00:38:20.000000', 'consum', 0.0228, 'lps'),
	(419912, 102, '2015-03-01 00:38:21.000000', 'consum', 0.0223, 'lps'),
	(419913, 102, '2015-03-01 00:38:22.000000', 'consum', 0.0220, 'lps'),
	(419914, 102, '2015-03-01 00:38:23.000000', 'consum', 0.0222, 'lps'),
	(419915, 102, '2015-03-01 00:38:24.000000', 'consum', 0.0223, 'lps'),
	(419916, 102, '2015-03-01 00:38:25.000000', 'consum', 0.0217, 'lps'),
	(419917, 102, '2015-03-01 00:38:26.000000', 'consum', 0.0229, 'lps'),
	(419918, 102, '2015-03-01 00:38:27.000000', 'consum', 0.0222, 'lps'),
	(419919, 102, '2015-03-01 00:38:28.000000', 'consum', 0.0215, 'lps'),
	(419920, 102, '2015-03-01 00:38:29.000000', 'consum', 0.0217, 'lps'),
	(419921, 102, '2015-03-01 00:38:30.000000', 'consum', 0.0213, 'lps'),
	(419922, 102, '2015-03-01 00:38:31.000000', 'consum', 0.0226, 'lps'),
	(419923, 102, '2015-03-01 00:38:32.000000', 'consum', 0.0218, 'lps'),
	(419924, 102, '2015-03-01 00:38:33.000000', 'consum', 0.0223, 'lps'),
	(419925, 102, '2015-03-01 00:38:34.000000', 'consum', 0.0212, 'lps'),
	(419926, 102, '2015-03-01 00:38:35.000000', 'consum', 0.0223, 'lps'),
	(419927, 102, '2015-03-01 00:38:36.000000', 'consum', 0.0229, 'lps'),
	(419928, 102, '2015-03-01 00:38:37.000000', 'consum', 0.0225, 'lps'),
	(419929, 102, '2015-03-01 00:38:38.000000', 'consum', 0.0210, 'lps'),
	(419930, 102, '2015-03-01 00:38:39.000000', 'consum', 0.0224, 'lps'),
	(419931, 102, '2015-03-01 00:38:40.000000', 'consum', 0.0221, 'lps'),
	(419932, 102, '2015-03-01 00:38:41.000000', 'consum', 0.0225, 'lps'),
	(419933, 102, '2015-03-01 00:38:42.000000', 'consum', 0.0210, 'lps'),
	(419934, 102, '2015-03-01 00:38:43.000000', 'consum', 0.0225, 'lps'),
	(419935, 102, '2015-03-01 00:38:44.000000', 'consum', 0.0225, 'lps'),
	(419936, 102, '2015-03-01 00:38:45.000000', 'consum', 0.0222, 'lps'),
	(419937, 102, '2015-03-01 00:38:46.000000', 'consum', 0.0225, 'lps'),
	(419938, 102, '2015-03-01 00:38:47.000000', 'consum', 0.0210, 'lps'),
	(419939, 102, '2015-03-01 00:38:48.000000', 'consum', 0.0224, 'lps'),
	(419940, 102, '2015-03-01 00:38:49.000000', 'consum', 0.0222, 'lps'),
	(419941, 102, '2015-03-01 00:38:50.000000', 'consum', 0.0210, 'lps'),
	(419942, 102, '2015-03-01 00:38:51.000000', 'consum', 0.0213, 'lps'),
	(419943, 102, '2015-03-01 00:38:52.000000', 'consum', 0.0225, 'lps'),
	(419944, 102, '2015-03-01 00:38:53.000000', 'consum', 0.0216, 'lps'),
	(419945, 102, '2015-03-01 00:38:54.000000', 'consum', 0.0216, 'lps'),
	(419946, 102, '2015-03-01 00:38:55.000000', 'consum', 0.0224, 'lps'),
	(419947, 102, '2015-03-01 00:38:56.000000', 'consum', 0.0223, 'lps'),
	(419948, 102, '2015-03-01 00:38:57.000000', 'consum', 0.0211, 'lps'),
	(419949, 102, '2015-03-01 00:38:58.000000', 'consum', 0.0217, 'lps'),
	(419950, 102, '2015-03-01 00:38:59.000000', 'consum', 0.0223, 'lps'),
	(419951, 102, '2015-03-01 00:39:00.000000', 'consum', 0.0213, 'lps'),
	(419952, 102, '2015-03-01 00:39:01.000000', 'consum', 0.0226, 'lps'),
	(419953, 102, '2015-03-01 00:39:02.000000', 'consum', 0.0224, 'lps'),
	(419954, 102, '2015-03-01 00:39:03.000000', 'consum', 0.0211, 'lps'),
	(419955, 102, '2015-03-01 00:39:04.000000', 'consum', 0.0213, 'lps'),
	(419956, 102, '2015-03-01 00:39:05.000000', 'consum', 0.0225, 'lps'),
	(419957, 102, '2015-03-01 00:39:06.000000', 'consum', 0.0214, 'lps'),
	(419958, 102, '2015-03-01 00:39:07.000000', 'consum', 0.0226, 'lps'),
	(419959, 102, '2015-03-01 00:39:08.000000', 'consum', 0.0217, 'lps'),
	(419960, 102, '2015-03-01 00:39:09.000000', 'consum', 0.0218, 'lps'),
	(419961, 102, '2015-03-01 00:39:10.000000', 'consum', 0.0229, 'lps'),
	(419962, 102, '2015-03-01 00:39:11.000000', 'consum', 0.0223, 'lps'),
	(419963, 102, '2015-03-01 00:39:12.000000', 'consum', 0.0217, 'lps'),
	(419964, 102, '2015-03-01 00:39:13.000000', 'consum', 0.0229, 'lps'),
	(419965, 102, '2015-03-01 00:39:14.000000', 'consum', 0.0224, 'lps'),
	(419966, 102, '2015-03-01 00:39:15.000000', 'consum', 0.0224, 'lps'),
	(419967, 102, '2015-03-01 00:39:16.000000', 'consum', 0.0218, 'lps'),
	(419968, 102, '2015-03-01 00:39:17.000000', 'consum', 0.0229, 'lps'),
	(419969, 102, '2015-03-01 00:39:18.000000', 'consum', 0.0219, 'lps'),
	(419970, 102, '2015-03-01 00:39:19.000000', 'consum', 0.0222, 'lps'),
	(419971, 102, '2015-03-01 00:39:20.000000', 'consum', 0.0222, 'lps'),
	(419972, 102, '2015-03-01 00:39:21.000000', 'consum', 0.0214, 'lps'),
	(419973, 102, '2015-03-01 00:39:22.000000', 'consum', 0.0215, 'lps'),
	(419974, 102, '2015-03-01 00:39:23.000000', 'consum', 0.0223, 'lps'),
	(419975, 102, '2015-03-01 00:39:24.000000', 'consum', 0.0223, 'lps'),
	(419976, 102, '2015-03-01 00:39:25.000000', 'consum', 0.0214, 'lps'),
	(419977, 102, '2015-03-01 00:39:26.000000', 'consum', 0.0213, 'lps'),
	(419978, 102, '2015-03-01 00:39:27.000000', 'consum', 0.0215, 'lps'),
	(419979, 102, '2015-03-01 00:39:28.000000', 'consum', 0.0223, 'lps'),
	(419980, 102, '2015-03-01 00:39:29.000000', 'consum', 0.0222, 'lps'),
	(419981, 102, '2015-03-01 00:39:30.000000', 'consum', 0.0213, 'lps'),
	(419982, 102, '2015-03-01 00:39:31.000000', 'consum', 0.0227, 'lps'),
	(419983, 102, '2015-03-01 00:39:32.000000', 'consum', 0.0229, 'lps'),
	(419984, 102, '2015-03-01 00:39:33.000000', 'consum', 0.0212, 'lps'),
	(419985, 102, '2015-03-01 00:39:34.000000', 'consum', 0.0224, 'lps'),
	(419986, 102, '2015-03-01 00:39:35.000000', 'consum', 0.0216, 'lps'),
	(419987, 102, '2015-03-01 00:39:36.000000', 'consum', 0.0220, 'lps'),
	(419988, 102, '2015-03-01 00:39:37.000000', 'consum', 0.0220, 'lps'),
	(419989, 102, '2015-03-01 00:39:38.000000', 'consum', 0.0210, 'lps'),
	(419990, 102, '2015-03-01 00:39:39.000000', 'consum', 0.0220, 'lps'),
	(419991, 102, '2015-03-01 00:39:40.000000', 'consum', 0.0220, 'lps'),
	(419992, 102, '2015-03-01 00:39:41.000000', 'consum', 0.0210, 'lps'),
	(419993, 102, '2015-03-01 00:39:42.000000', 'consum', 0.0222, 'lps'),
	(419994, 102, '2015-03-01 00:39:43.000000', 'consum', 0.0229, 'lps'),
	(419995, 102, '2015-03-01 00:39:44.000000', 'consum', 0.0229, 'lps'),
	(419996, 102, '2015-03-01 00:39:45.000000', 'consum', 0.0227, 'lps'),
	(419997, 102, '2015-03-01 00:39:46.000000', 'consum', 0.0222, 'lps'),
	(419998, 102, '2015-03-01 00:39:47.000000', 'consum', 0.0219, 'lps'),
	(419999, 102, '2015-03-01 00:39:48.000000', 'consum', 0.0217, 'lps'),
	(420000, 102, '2015-03-01 00:39:49.000000', 'consum', 0.0220, 'lps'),
	(420001, 102, '2015-03-01 00:39:50.000000', 'consum', 0.0220, 'lps'),
	(420002, 102, '2015-03-01 00:39:51.000000', 'consum', 0.0210, 'lps'),
	(420003, 102, '2015-03-01 00:39:52.000000', 'consum', 0.0221, 'lps'),
	(420004, 102, '2015-03-01 00:39:53.000000', 'consum', 0.0224, 'lps'),
	(420005, 102, '2015-03-01 00:39:54.000000', 'consum', 0.0228, 'lps'),
	(420006, 102, '2015-03-01 00:39:55.000000', 'consum', 0.0221, 'lps'),
	(420007, 102, '2015-03-01 00:39:56.000000', 'consum', 0.0228, 'lps'),
	(420008, 102, '2015-03-01 00:39:57.000000', 'consum', 0.0211, 'lps'),
	(420009, 102, '2015-03-01 00:39:58.000000', 'consum', 0.0219, 'lps'),
	(420010, 102, '2015-03-01 00:39:59.000000', 'consum', 0.0215, 'lps'),
	(420011, 102, '2015-03-01 00:40:00.000000', 'consum', 0.0226, 'lps'),
	(420012, 102, '2015-03-01 00:40:01.000000', 'consum', 0.0216, 'lps'),
	(420013, 102, '2015-03-01 00:40:02.000000', 'consum', 0.0215, 'lps'),
	(420014, 102, '2015-03-01 00:40:03.000000', 'consum', 0.0215, 'lps'),
	(420015, 102, '2015-03-01 00:40:04.000000', 'consum', 0.0222, 'lps'),
	(420016, 102, '2015-03-01 00:40:05.000000', 'consum', 0.0215, 'lps'),
	(420017, 102, '2015-03-01 00:40:06.000000', 'consum', 0.0219, 'lps'),
	(420018, 102, '2015-03-01 00:40:07.000000', 'consum', 0.0221, 'lps'),
	(420019, 102, '2015-03-01 00:40:08.000000', 'consum', 0.0218, 'lps'),
	(420020, 102, '2015-03-01 00:40:09.000000', 'consum', 0.0219, 'lps'),
	(420021, 102, '2015-03-01 00:40:10.000000', 'consum', 0.0229, 'lps'),
	(420022, 102, '2015-03-01 00:40:11.000000', 'consum', 0.0219, 'lps'),
	(420023, 102, '2015-03-01 00:40:12.000000', 'consum', 0.0221, 'lps'),
	(420024, 102, '2015-03-01 00:40:13.000000', 'consum', 0.0217, 'lps'),
	(420025, 102, '2015-03-01 00:40:14.000000', 'consum', 0.0214, 'lps'),
	(420026, 102, '2015-03-01 00:40:15.000000', 'consum', 0.0229, 'lps'),
	(420027, 102, '2015-03-01 00:40:16.000000', 'consum', 0.0215, 'lps'),
	(420028, 102, '2015-03-01 00:40:17.000000', 'consum', 0.0217, 'lps'),
	(420029, 102, '2015-03-01 00:40:18.000000', 'consum', 0.0229, 'lps'),
	(420030, 102, '2015-03-01 00:40:19.000000', 'consum', 0.0226, 'lps'),
	(420031, 102, '2015-03-01 00:40:20.000000', 'consum', 0.0214, 'lps'),
	(420032, 102, '2015-03-01 00:40:21.000000', 'consum', 0.0221, 'lps'),
	(420033, 102, '2015-03-01 00:40:22.000000', 'consum', 0.0214, 'lps'),
	(420034, 102, '2015-03-01 00:40:23.000000', 'consum', 0.0216, 'lps'),
	(420035, 102, '2015-03-01 00:40:24.000000', 'consum', 0.0228, 'lps'),
	(420036, 102, '2015-03-01 00:40:25.000000', 'consum', 0.0223, 'lps'),
	(420037, 102, '2015-03-01 00:40:26.000000', 'consum', 0.0221, 'lps'),
	(420038, 102, '2015-03-01 00:40:27.000000', 'consum', 0.0229, 'lps'),
	(420039, 102, '2015-03-01 00:40:28.000000', 'consum', 0.0212, 'lps'),
	(420040, 102, '2015-03-01 00:40:29.000000', 'consum', 0.0223, 'lps'),
	(420041, 102, '2015-03-01 00:40:30.000000', 'consum', 0.0228, 'lps'),
	(420042, 102, '2015-03-01 00:40:31.000000', 'consum', 0.0223, 'lps'),
	(420043, 102, '2015-03-01 00:40:32.000000', 'consum', 0.0222, 'lps'),
	(420044, 102, '2015-03-01 00:40:33.000000', 'consum', 0.0210, 'lps'),
	(420045, 102, '2015-03-01 00:40:34.000000', 'consum', 0.0217, 'lps'),
	(420046, 102, '2015-03-01 00:40:35.000000', 'consum', 0.0222, 'lps'),
	(420047, 102, '2015-03-01 00:40:36.000000', 'consum', 0.0211, 'lps'),
	(420048, 102, '2015-03-01 00:40:37.000000', 'consum', 0.0221, 'lps'),
	(420049, 102, '2015-03-01 00:40:38.000000', 'consum', 0.0220, 'lps'),
	(420050, 102, '2015-03-01 00:40:39.000000', 'consum', 0.0210, 'lps'),
	(420051, 102, '2015-03-01 00:40:40.000000', 'consum', 0.0219, 'lps'),
	(420052, 102, '2015-03-01 00:40:41.000000', 'consum', 0.0214, 'lps'),
	(420053, 102, '2015-03-01 00:40:42.000000', 'consum', 0.0224, 'lps'),
	(420054, 102, '2015-03-01 00:40:43.000000', 'consum', 0.0229, 'lps'),
	(420055, 102, '2015-03-01 00:40:44.000000', 'consum', 0.0225, 'lps'),
	(420056, 102, '2015-03-01 00:40:45.000000', 'consum', 0.0226, 'lps'),
	(420057, 102, '2015-03-01 00:40:46.000000', 'consum', 0.0227, 'lps'),
	(420058, 102, '2015-03-01 00:40:47.000000', 'consum', 0.0225, 'lps'),
	(420059, 102, '2015-03-01 00:40:48.000000', 'consum', 0.0216, 'lps'),
	(420060, 102, '2015-03-01 00:40:49.000000', 'consum', 0.0217, 'lps'),
	(420061, 102, '2015-03-01 00:40:50.000000', 'consum', 0.0225, 'lps'),
	(420062, 102, '2015-03-01 00:40:51.000000', 'consum', 0.0226, 'lps'),
	(420063, 102, '2015-03-01 00:40:52.000000', 'consum', 0.0227, 'lps'),
	(420064, 102, '2015-03-01 00:40:53.000000', 'consum', 0.0225, 'lps'),
	(420065, 102, '2015-03-01 00:40:54.000000', 'consum', 0.0217, 'lps'),
	(420066, 102, '2015-03-01 00:40:55.000000', 'consum', 0.0219, 'lps'),
	(420067, 102, '2015-03-01 00:40:56.000000', 'consum', 0.0214, 'lps'),
	(420068, 102, '2015-03-01 00:40:57.000000', 'consum', 0.0223, 'lps'),
	(420069, 102, '2015-03-01 00:40:58.000000', 'consum', 0.0226, 'lps'),
	(420070, 102, '2015-03-01 00:40:59.000000', 'consum', 0.0229, 'lps'),
	(420071, 102, '2015-03-01 00:41:00.000000', 'consum', 0.0217, 'lps'),
	(420072, 102, '2015-03-01 00:41:01.000000', 'consum', 0.0229, 'lps'),
	(420073, 102, '2015-03-01 00:41:02.000000', 'consum', 0.0223, 'lps'),
	(420074, 102, '2015-03-01 00:41:03.000000', 'consum', 0.0221, 'lps'),
	(420075, 102, '2015-03-01 00:41:04.000000', 'consum', 0.0224, 'lps'),
	(420076, 102, '2015-03-01 00:41:05.000000', 'consum', 0.0227, 'lps'),
	(420077, 102, '2015-03-01 00:41:06.000000', 'consum', 0.0214, 'lps'),
	(420078, 102, '2015-03-01 00:41:07.000000', 'consum', 0.0222, 'lps'),
	(420079, 102, '2015-03-01 00:41:08.000000', 'consum', 0.0217, 'lps'),
	(420080, 102, '2015-03-01 00:41:09.000000', 'consum', 0.0228, 'lps'),
	(420081, 102, '2015-03-01 00:41:10.000000', 'consum', 0.0222, 'lps'),
	(420082, 102, '2015-03-01 00:41:11.000000', 'consum', 0.0215, 'lps'),
	(420083, 102, '2015-03-01 00:41:12.000000', 'consum', 0.0220, 'lps'),
	(420084, 102, '2015-03-01 00:41:13.000000', 'consum', 0.0226, 'lps'),
	(420085, 102, '2015-03-01 00:41:14.000000', 'consum', 0.0219, 'lps'),
	(420086, 102, '2015-03-01 00:41:15.000000', 'consum', 0.0229, 'lps'),
	(420087, 102, '2015-03-01 00:41:16.000000', 'consum', 0.0218, 'lps'),
	(420088, 102, '2015-03-01 00:41:17.000000', 'consum', 0.0215, 'lps'),
	(420089, 102, '2015-03-01 00:41:18.000000', 'consum', 0.0211, 'lps'),
	(420090, 102, '2015-03-01 00:41:19.000000', 'consum', 0.0218, 'lps'),
	(420091, 102, '2015-03-01 00:41:20.000000', 'consum', 0.0210, 'lps'),
	(420092, 102, '2015-03-01 00:41:21.000000', 'consum', 0.0226, 'lps'),
	(420093, 102, '2015-03-01 00:41:22.000000', 'consum', 0.0210, 'lps'),
	(420094, 102, '2015-03-01 00:41:23.000000', 'consum', 0.0223, 'lps'),
	(420095, 102, '2015-03-01 00:41:24.000000', 'consum', 0.0216, 'lps'),
	(420096, 102, '2015-03-01 00:41:25.000000', 'consum', 0.0220, 'lps'),
	(420097, 102, '2015-03-01 00:41:26.000000', 'consum', 0.0223, 'lps'),
	(420098, 102, '2015-03-01 00:41:27.000000', 'consum', 0.0226, 'lps'),
	(420099, 102, '2015-03-01 00:41:28.000000', 'consum', 0.0213, 'lps'),
	(420100, 102, '2015-03-01 00:41:29.000000', 'consum', 0.0217, 'lps'),
	(420101, 102, '2015-03-01 00:41:30.000000', 'consum', 0.0218, 'lps'),
	(420102, 102, '2015-03-01 00:41:31.000000', 'consum', 0.0228, 'lps'),
	(420103, 102, '2015-03-01 00:41:32.000000', 'consum', 0.0216, 'lps'),
	(420104, 102, '2015-03-01 00:41:33.000000', 'consum', 0.0226, 'lps'),
	(420105, 102, '2015-03-01 00:41:34.000000', 'consum', 0.0215, 'lps'),
	(420106, 102, '2015-03-01 00:41:35.000000', 'consum', 0.0227, 'lps'),
	(420107, 102, '2015-03-01 00:41:36.000000', 'consum', 0.0221, 'lps'),
	(420108, 102, '2015-03-01 00:41:37.000000', 'consum', 0.0215, 'lps'),
	(420109, 102, '2015-03-01 00:41:38.000000', 'consum', 0.0222, 'lps'),
	(420110, 102, '2015-03-01 00:41:39.000000', 'consum', 0.0214, 'lps'),
	(420111, 102, '2015-03-01 00:41:40.000000', 'consum', 0.0217, 'lps'),
	(420112, 102, '2015-03-01 00:41:41.000000', 'consum', 0.0213, 'lps'),
	(420113, 102, '2015-03-01 00:41:42.000000', 'consum', 0.0222, 'lps'),
	(420114, 102, '2015-03-01 00:41:43.000000', 'consum', 0.0223, 'lps'),
	(420115, 102, '2015-03-01 00:41:44.000000', 'consum', 0.0218, 'lps'),
	(420116, 102, '2015-03-01 00:41:45.000000', 'consum', 0.0212, 'lps'),
	(420117, 102, '2015-03-01 00:41:46.000000', 'consum', 0.0217, 'lps'),
	(420118, 102, '2015-03-01 00:41:47.000000', 'consum', 0.0219, 'lps'),
	(420119, 102, '2015-03-01 00:41:48.000000', 'consum', 0.0214, 'lps'),
	(420120, 102, '2015-03-01 00:41:49.000000', 'consum', 0.0224, 'lps'),
	(420121, 102, '2015-03-01 00:41:50.000000', 'consum', 0.0227, 'lps'),
	(420122, 102, '2015-03-01 00:41:51.000000', 'consum', 0.0217, 'lps'),
	(420123, 102, '2015-03-01 00:41:52.000000', 'consum', 0.0211, 'lps'),
	(420124, 102, '2015-03-01 00:41:53.000000', 'consum', 0.0216, 'lps'),
	(420125, 102, '2015-03-01 00:41:54.000000', 'consum', 0.0219, 'lps'),
	(420126, 102, '2015-03-01 00:41:55.000000', 'consum', 0.0214, 'lps'),
	(420127, 102, '2015-03-01 00:41:56.000000', 'consum', 0.0227, 'lps'),
	(420128, 102, '2015-03-01 00:41:57.000000', 'consum', 0.0223, 'lps'),
	(420129, 102, '2015-03-01 00:41:58.000000', 'consum', 0.0222, 'lps'),
	(420130, 102, '2015-03-01 00:41:59.000000', 'consum', 0.0215, 'lps'),
	(420131, 102, '2015-03-01 00:42:00.000000', 'consum', 0.0216, 'lps'),
	(420132, 102, '2015-03-01 00:42:01.000000', 'consum', 0.0228, 'lps'),
	(420133, 102, '2015-03-01 00:42:02.000000', 'consum', 0.0220, 'lps'),
	(420134, 102, '2015-03-01 00:42:03.000000', 'consum', 0.0227, 'lps'),
	(420135, 102, '2015-03-01 00:42:04.000000', 'consum', 0.0226, 'lps'),
	(420136, 102, '2015-03-01 00:42:05.000000', 'consum', 0.0221, 'lps'),
	(420137, 102, '2015-03-01 00:42:06.000000', 'consum', 0.0217, 'lps'),
	(420138, 102, '2015-03-01 00:42:07.000000', 'consum', 0.0213, 'lps'),
	(420139, 102, '2015-03-01 00:42:08.000000', 'consum', 0.0223, 'lps'),
	(420140, 102, '2015-03-01 00:42:09.000000', 'consum', 0.0229, 'lps'),
	(420141, 102, '2015-03-01 00:42:10.000000', 'consum', 0.0226, 'lps'),
	(420142, 102, '2015-03-01 00:42:11.000000', 'consum', 0.0214, 'lps'),
	(420143, 102, '2015-03-01 00:42:12.000000', 'consum', 0.0220, 'lps'),
	(420144, 102, '2015-03-01 00:42:13.000000', 'consum', 0.0211, 'lps'),
	(420145, 102, '2015-03-01 00:42:14.000000', 'consum', 0.0226, 'lps'),
	(420146, 102, '2015-03-01 00:42:15.000000', 'consum', 0.0225, 'lps'),
	(420147, 102, '2015-03-01 00:42:16.000000', 'consum', 0.0219, 'lps'),
	(420148, 102, '2015-03-01 00:42:17.000000', 'consum', 0.0210, 'lps'),
	(420149, 102, '2015-03-01 00:42:18.000000', 'consum', 0.0223, 'lps'),
	(420150, 102, '2015-03-01 00:42:19.000000', 'consum', 0.0216, 'lps'),
	(420151, 102, '2015-03-01 00:42:20.000000', 'consum', 0.0221, 'lps'),
	(420152, 102, '2015-03-01 00:42:21.000000', 'consum', 0.0229, 'lps'),
	(420153, 102, '2015-03-01 00:42:22.000000', 'consum', 0.0214, 'lps'),
	(420154, 102, '2015-03-01 00:42:23.000000', 'consum', 0.0210, 'lps'),
	(420155, 102, '2015-03-01 00:42:24.000000', 'consum', 0.0221, 'lps'),
	(420156, 102, '2015-03-01 00:42:25.000000', 'consum', 0.0223, 'lps'),
	(420157, 102, '2015-03-01 00:42:26.000000', 'consum', 0.0225, 'lps'),
	(420158, 102, '2015-03-01 00:42:27.000000', 'consum', 0.0227, 'lps'),
	(420159, 102, '2015-03-01 00:42:28.000000', 'consum', 0.0211, 'lps'),
	(420160, 102, '2015-03-01 00:42:29.000000', 'consum', 0.0222, 'lps'),
	(420161, 102, '2015-03-01 00:42:30.000000', 'consum', 0.0228, 'lps'),
	(420162, 102, '2015-03-01 00:42:31.000000', 'consum', 0.0227, 'lps'),
	(420163, 102, '2015-03-01 00:42:32.000000', 'consum', 0.0218, 'lps'),
	(420164, 102, '2015-03-01 00:42:33.000000', 'consum', 0.0222, 'lps'),
	(420165, 102, '2015-03-01 00:42:34.000000', 'consum', 0.0224, 'lps'),
	(420166, 102, '2015-03-01 00:42:35.000000', 'consum', 0.0227, 'lps'),
	(420167, 102, '2015-03-01 00:42:36.000000', 'consum', 0.0211, 'lps'),
	(420168, 102, '2015-03-01 00:42:37.000000', 'consum', 0.0225, 'lps'),
	(420169, 102, '2015-03-01 00:42:38.000000', 'consum', 0.0222, 'lps'),
	(420170, 102, '2015-03-01 00:42:39.000000', 'consum', 0.0228, 'lps'),
	(420171, 102, '2015-03-01 00:42:40.000000', 'consum', 0.0224, 'lps'),
	(420172, 102, '2015-03-01 00:42:41.000000', 'consum', 0.0224, 'lps'),
	(420173, 102, '2015-03-01 00:42:42.000000', 'consum', 0.0221, 'lps'),
	(420174, 102, '2015-03-01 00:42:43.000000', 'consum', 0.0224, 'lps'),
	(420175, 102, '2015-03-01 00:42:44.000000', 'consum', 0.0228, 'lps'),
	(420176, 102, '2015-03-01 00:42:45.000000', 'consum', 0.0218, 'lps'),
	(420177, 102, '2015-03-01 00:42:46.000000', 'consum', 0.0216, 'lps'),
	(420178, 102, '2015-03-01 00:42:47.000000', 'consum', 0.0216, 'lps'),
	(420179, 102, '2015-03-01 00:42:48.000000', 'consum', 0.0223, 'lps'),
	(420180, 102, '2015-03-01 00:42:49.000000', 'consum', 0.0218, 'lps'),
	(420181, 102, '2015-03-01 00:42:50.000000', 'consum', 0.0212, 'lps'),
	(420182, 102, '2015-03-01 00:42:51.000000', 'consum', 0.0217, 'lps'),
	(420183, 102, '2015-03-01 00:42:52.000000', 'consum', 0.0219, 'lps'),
	(420184, 102, '2015-03-01 00:42:53.000000', 'consum', 0.0213, 'lps'),
	(420185, 102, '2015-03-01 00:42:54.000000', 'consum', 0.0221, 'lps'),
	(420186, 102, '2015-03-01 00:42:55.000000', 'consum', 0.0214, 'lps'),
	(420187, 102, '2015-03-01 00:42:56.000000', 'consum', 0.0219, 'lps'),
	(420188, 102, '2015-03-01 00:42:57.000000', 'consum', 0.0223, 'lps'),
	(420189, 102, '2015-03-01 00:42:58.000000', 'consum', 0.0211, 'lps'),
	(420190, 102, '2015-03-01 00:42:59.000000', 'consum', 0.0213, 'lps'),
	(420191, 102, '2015-03-01 00:43:00.000000', 'consum', 0.0222, 'lps'),
	(420192, 102, '2015-03-01 00:43:01.000000', 'consum', 0.0225, 'lps'),
	(420193, 102, '2015-03-01 00:43:02.000000', 'consum', 0.0227, 'lps'),
	(420194, 102, '2015-03-01 00:43:03.000000', 'consum', 0.0211, 'lps'),
	(420195, 102, '2015-03-01 00:43:04.000000', 'consum', 0.0225, 'lps'),
	(420196, 102, '2015-03-01 00:43:05.000000', 'consum', 0.0222, 'lps'),
	(420197, 102, '2015-03-01 00:43:06.000000', 'consum', 0.0227, 'lps'),
	(420198, 102, '2015-03-01 00:43:07.000000', 'consum', 0.0217, 'lps'),
	(420199, 102, '2015-03-01 00:43:08.000000', 'consum', 0.0217, 'lps'),
	(420200, 102, '2015-03-01 00:43:09.000000', 'consum', 0.0225, 'lps'),
	(420201, 102, '2015-03-01 00:43:10.000000', 'consum', 0.0223, 'lps'),
	(420202, 102, '2015-03-01 00:43:11.000000', 'consum', 0.0211, 'lps'),
	(420203, 102, '2015-03-01 00:43:12.000000', 'consum', 0.0218, 'lps'),
	(420204, 102, '2015-03-01 00:43:13.000000', 'consum', 0.0226, 'lps'),
	(420205, 102, '2015-03-01 00:43:14.000000', 'consum', 0.0225, 'lps'),
	(420206, 102, '2015-03-01 00:43:15.000000', 'consum', 0.0219, 'lps'),
	(420207, 102, '2015-03-01 00:43:16.000000', 'consum', 0.0229, 'lps'),
	(420208, 102, '2015-03-01 00:43:17.000000', 'consum', 0.0222, 'lps'),
	(420209, 102, '2015-03-01 00:43:18.000000', 'consum', 0.0210, 'lps'),
	(420210, 102, '2015-03-01 00:43:19.000000', 'consum', 0.0214, 'lps'),
	(420211, 102, '2015-03-01 00:43:20.000000', 'consum', 0.0211, 'lps'),
	(420212, 102, '2015-03-01 00:43:21.000000', 'consum', 0.0224, 'lps'),
	(420213, 102, '2015-03-01 00:43:22.000000', 'consum', 0.0217, 'lps'),
	(420214, 102, '2015-03-01 00:43:23.000000', 'consum', 0.0226, 'lps'),
	(420215, 102, '2015-03-01 00:43:24.000000', 'consum', 0.0227, 'lps'),
	(420216, 102, '2015-03-01 00:43:25.000000', 'consum', 0.0227, 'lps'),
	(420217, 102, '2015-03-01 00:43:26.000000', 'consum', 0.0227, 'lps'),
	(420218, 102, '2015-03-01 00:43:27.000000', 'consum', 0.0224, 'lps'),
	(420219, 102, '2015-03-01 00:43:28.000000', 'consum', 0.0210, 'lps'),
	(420220, 102, '2015-03-01 00:43:29.000000', 'consum', 0.0227, 'lps'),
	(420221, 102, '2015-03-01 00:43:30.000000', 'consum', 0.0215, 'lps'),
	(420222, 102, '2015-03-01 00:43:31.000000', 'consum', 0.0224, 'lps'),
	(420223, 102, '2015-03-01 00:43:32.000000', 'consum', 0.0228, 'lps'),
	(420224, 102, '2015-03-01 00:43:33.000000', 'consum', 0.0218, 'lps'),
	(420225, 102, '2015-03-01 00:43:34.000000', 'consum', 0.0214, 'lps'),
	(420226, 102, '2015-03-01 00:43:35.000000', 'consum', 0.0228, 'lps'),
	(420227, 102, '2015-03-01 00:43:36.000000', 'consum', 0.0227, 'lps'),
	(420228, 102, '2015-03-01 00:43:37.000000', 'consum', 0.0225, 'lps'),
	(420229, 102, '2015-03-01 00:43:38.000000', 'consum', 0.0211, 'lps'),
	(420230, 102, '2015-03-01 00:43:39.000000', 'consum', 0.0212, 'lps'),
	(420231, 102, '2015-03-01 00:43:40.000000', 'consum', 0.0216, 'lps'),
	(420232, 102, '2015-03-01 00:43:41.000000', 'consum', 0.0216, 'lps'),
	(420233, 102, '2015-03-01 00:43:42.000000', 'consum', 0.0222, 'lps'),
	(420234, 102, '2015-03-01 00:43:43.000000', 'consum', 0.0212, 'lps'),
	(420235, 102, '2015-03-01 00:43:44.000000', 'consum', 0.0224, 'lps'),
	(420236, 102, '2015-03-01 00:43:45.000000', 'consum', 0.0213, 'lps'),
	(420237, 102, '2015-03-01 00:43:46.000000', 'consum', 0.0225, 'lps'),
	(420238, 102, '2015-03-01 00:43:47.000000', 'consum', 0.0218, 'lps'),
	(420239, 102, '2015-03-01 00:43:48.000000', 'consum', 0.0225, 'lps'),
	(420240, 102, '2015-03-01 00:43:49.000000', 'consum', 0.0219, 'lps'),
	(420241, 102, '2015-03-01 00:43:50.000000', 'consum', 0.0213, 'lps'),
	(420242, 102, '2015-03-01 00:43:51.000000', 'consum', 0.0216, 'lps'),
	(420243, 102, '2015-03-01 00:43:52.000000', 'consum', 0.0212, 'lps'),
	(420244, 102, '2015-03-01 00:43:53.000000', 'consum', 0.0223, 'lps'),
	(420245, 102, '2015-03-01 00:43:54.000000', 'consum', 0.0210, 'lps'),
	(420246, 102, '2015-03-01 00:43:55.000000', 'consum', 0.0213, 'lps'),
	(420247, 102, '2015-03-01 00:43:56.000000', 'consum', 0.0226, 'lps'),
	(420248, 102, '2015-03-01 00:43:57.000000', 'consum', 0.0218, 'lps'),
	(420249, 102, '2015-03-01 00:43:58.000000', 'consum', 0.0225, 'lps'),
	(420250, 102, '2015-03-01 00:43:59.000000', 'consum', 0.0220, 'lps'),
	(420251, 102, '2015-03-01 00:44:00.000000', 'consum', 0.0217, 'lps'),
	(420252, 102, '2015-03-01 00:44:01.000000', 'consum', 0.0215, 'lps'),
	(420253, 102, '2015-03-01 00:44:02.000000', 'consum', 0.0216, 'lps'),
	(420254, 102, '2015-03-01 00:44:03.000000', 'consum', 0.0225, 'lps'),
	(420255, 102, '2015-03-01 00:44:04.000000', 'consum', 0.0229, 'lps'),
	(420256, 102, '2015-03-01 00:44:05.000000', 'consum', 0.0219, 'lps'),
	(420257, 102, '2015-03-01 00:44:06.000000', 'consum', 0.0217, 'lps'),
	(420258, 102, '2015-03-01 00:44:07.000000', 'consum', 0.0218, 'lps'),
	(420259, 102, '2015-03-01 00:44:08.000000', 'consum', 0.0210, 'lps'),
	(420260, 102, '2015-03-01 00:44:09.000000', 'consum', 0.0229, 'lps'),
	(420261, 102, '2015-03-01 00:44:10.000000', 'consum', 0.0223, 'lps'),
	(420262, 102, '2015-03-01 00:44:11.000000', 'consum', 0.0219, 'lps'),
	(420263, 102, '2015-03-01 00:44:12.000000', 'consum', 0.0216, 'lps'),
	(420264, 102, '2015-03-01 00:44:13.000000', 'consum', 0.0213, 'lps'),
	(420265, 102, '2015-03-01 00:44:14.000000', 'consum', 0.0228, 'lps'),
	(420266, 102, '2015-03-01 00:44:15.000000', 'consum', 0.0213, 'lps'),
	(420267, 102, '2015-03-01 00:44:16.000000', 'consum', 0.0212, 'lps'),
	(420268, 102, '2015-03-01 00:44:17.000000', 'consum', 0.0229, 'lps'),
	(420269, 102, '2015-03-01 00:44:18.000000', 'consum', 0.0222, 'lps'),
	(420270, 102, '2015-03-01 00:44:19.000000', 'consum', 0.0212, 'lps'),
	(420271, 102, '2015-03-01 00:44:20.000000', 'consum', 0.0226, 'lps'),
	(420272, 102, '2015-03-01 00:44:21.000000', 'consum', 0.0224, 'lps'),
	(420273, 102, '2015-03-01 00:44:22.000000', 'consum', 0.0213, 'lps'),
	(420274, 102, '2015-03-01 00:44:23.000000', 'consum', 0.0223, 'lps'),
	(420275, 102, '2015-03-01 00:44:24.000000', 'consum', 0.0225, 'lps'),
	(420276, 102, '2015-03-01 00:44:25.000000', 'consum', 0.0227, 'lps'),
	(420277, 102, '2015-03-01 00:44:26.000000', 'consum', 0.0229, 'lps'),
	(420278, 102, '2015-03-01 00:44:27.000000', 'consum', 0.0218, 'lps'),
	(420279, 102, '2015-03-01 00:44:28.000000', 'consum', 0.0211, 'lps'),
	(420280, 102, '2015-03-01 00:44:29.000000', 'consum', 0.0213, 'lps'),
	(420281, 102, '2015-03-01 00:44:30.000000', 'consum', 0.0222, 'lps'),
	(420282, 102, '2015-03-01 00:44:31.000000', 'consum', 0.0220, 'lps'),
	(420283, 102, '2015-03-01 00:44:32.000000', 'consum', 0.0223, 'lps'),
	(420284, 102, '2015-03-01 00:44:33.000000', 'consum', 0.0229, 'lps'),
	(420285, 102, '2015-03-01 00:44:34.000000', 'consum', 0.0225, 'lps'),
	(420286, 102, '2015-03-01 00:44:35.000000', 'consum', 0.0227, 'lps'),
	(420287, 102, '2015-03-01 00:44:36.000000', 'consum', 0.0214, 'lps'),
	(420288, 102, '2015-03-01 00:44:37.000000', 'consum', 0.0217, 'lps'),
	(420289, 102, '2015-03-01 00:44:38.000000', 'consum', 0.0214, 'lps'),
	(420290, 102, '2015-03-01 00:44:39.000000', 'consum', 0.0228, 'lps'),
	(420291, 102, '2015-03-01 00:44:40.000000', 'consum', 0.0229, 'lps'),
	(420292, 102, '2015-03-01 00:44:41.000000', 'consum', 0.0210, 'lps'),
	(420293, 102, '2015-03-01 00:44:42.000000', 'consum', 0.0215, 'lps'),
	(420294, 102, '2015-03-01 00:44:43.000000', 'consum', 0.0217, 'lps'),
	(420295, 102, '2015-03-01 00:44:44.000000', 'consum', 0.0210, 'lps'),
	(420296, 102, '2015-03-01 00:44:45.000000', 'consum', 0.0211, 'lps'),
	(420297, 102, '2015-03-01 00:44:46.000000', 'consum', 0.0213, 'lps'),
	(420298, 102, '2015-03-01 00:44:47.000000', 'consum', 0.0225, 'lps'),
	(420299, 102, '2015-03-01 00:44:48.000000', 'consum', 0.0213, 'lps'),
	(420300, 102, '2015-03-01 00:44:49.000000', 'consum', 0.0223, 'lps'),
	(420301, 102, '2015-03-01 00:44:50.000000', 'consum', 0.0227, 'lps'),
	(420302, 102, '2015-03-01 00:44:51.000000', 'consum', 0.0217, 'lps'),
	(420303, 102, '2015-03-01 00:44:52.000000', 'consum', 0.0212, 'lps'),
	(420304, 102, '2015-03-01 00:44:53.000000', 'consum', 0.0221, 'lps'),
	(420305, 102, '2015-03-01 00:44:54.000000', 'consum', 0.0221, 'lps'),
	(420306, 102, '2015-03-01 00:44:55.000000', 'consum', 0.0212, 'lps'),
	(420307, 102, '2015-03-01 00:44:56.000000', 'consum', 0.0226, 'lps'),
	(420308, 102, '2015-03-01 00:44:57.000000', 'consum', 0.0223, 'lps'),
	(420309, 102, '2015-03-01 00:44:58.000000', 'consum', 0.0210, 'lps'),
	(420310, 102, '2015-03-01 00:44:59.000000', 'consum', 0.0212, 'lps'),
	(420311, 102, '2015-03-01 00:45:00.000000', 'consum', 0.0221, 'lps'),
	(420312, 102, '2015-03-01 00:45:01.000000', 'consum', 0.0219, 'lps'),
	(420313, 102, '2015-03-01 00:45:02.000000', 'consum', 0.0224, 'lps'),
	(420314, 102, '2015-03-01 00:45:03.000000', 'consum', 0.0213, 'lps'),
	(420315, 102, '2015-03-01 00:45:04.000000', 'consum', 0.0225, 'lps'),
	(420316, 102, '2015-03-01 00:45:05.000000', 'consum', 0.0213, 'lps'),
	(420317, 102, '2015-03-01 00:45:06.000000', 'consum', 0.0222, 'lps'),
	(420318, 102, '2015-03-01 00:45:07.000000', 'consum', 0.0221, 'lps'),
	(420319, 102, '2015-03-01 00:45:08.000000', 'consum', 0.0229, 'lps'),
	(420320, 102, '2015-03-01 00:45:09.000000', 'consum', 0.0212, 'lps'),
	(420321, 102, '2015-03-01 00:45:10.000000', 'consum', 0.0226, 'lps'),
	(420322, 102, '2015-03-01 00:45:11.000000', 'consum', 0.0223, 'lps'),
	(420323, 102, '2015-03-01 00:45:12.000000', 'consum', 0.0229, 'lps'),
	(420324, 102, '2015-03-01 00:45:13.000000', 'consum', 0.0225, 'lps'),
	(420325, 102, '2015-03-01 00:45:14.000000', 'consum', 0.0228, 'lps'),
	(420326, 102, '2015-03-01 00:45:15.000000', 'consum', 0.0216, 'lps'),
	(420327, 102, '2015-03-01 00:45:16.000000', 'consum', 0.0226, 'lps'),
	(420328, 102, '2015-03-01 00:45:17.000000', 'consum', 0.0213, 'lps'),
	(420329, 102, '2015-03-01 00:45:18.000000', 'consum', 0.0216, 'lps'),
	(420330, 102, '2015-03-01 00:45:19.000000', 'consum', 0.0214, 'lps'),
	(420331, 102, '2015-03-01 00:45:20.000000', 'consum', 0.0213, 'lps'),
	(420332, 102, '2015-03-01 00:45:21.000000', 'consum', 0.0214, 'lps'),
	(420333, 102, '2015-03-01 00:45:22.000000', 'consum', 0.0220, 'lps'),
	(420334, 102, '2015-03-01 00:45:23.000000', 'consum', 0.0229, 'lps'),
	(420335, 102, '2015-03-01 00:45:24.000000', 'consum', 0.0215, 'lps'),
	(420336, 102, '2015-03-01 00:45:25.000000', 'consum', 0.0219, 'lps'),
	(420337, 102, '2015-03-01 00:45:26.000000', 'consum', 0.0220, 'lps'),
	(420338, 102, '2015-03-01 00:45:27.000000', 'consum', 0.0216, 'lps'),
	(420339, 102, '2015-03-01 00:45:28.000000', 'consum', 0.0228, 'lps'),
	(420340, 102, '2015-03-01 00:45:29.000000', 'consum', 0.0222, 'lps'),
	(420341, 102, '2015-03-01 00:45:30.000000', 'consum', 0.0218, 'lps'),
	(420342, 102, '2015-03-01 00:45:31.000000', 'consum', 0.0215, 'lps'),
	(420343, 102, '2015-03-01 00:45:32.000000', 'consum', 0.0210, 'lps'),
	(420344, 102, '2015-03-01 00:45:33.000000', 'consum', 0.0215, 'lps'),
	(420345, 102, '2015-03-01 00:45:34.000000', 'consum', 0.0217, 'lps'),
	(420346, 102, '2015-03-01 00:45:35.000000', 'consum', 0.0229, 'lps'),
	(420347, 102, '2015-03-01 00:45:36.000000', 'consum', 0.0225, 'lps'),
	(420348, 102, '2015-03-01 00:45:37.000000', 'consum', 0.0229, 'lps'),
	(420349, 102, '2015-03-01 00:45:38.000000', 'consum', 0.0218, 'lps'),
	(420350, 102, '2015-03-01 00:45:39.000000', 'consum', 0.0217, 'lps'),
	(420351, 102, '2015-03-01 00:45:40.000000', 'consum', 0.0221, 'lps'),
	(420352, 102, '2015-03-01 00:45:41.000000', 'consum', 0.0223, 'lps'),
	(420353, 102, '2015-03-01 00:45:42.000000', 'consum', 0.0224, 'lps'),
	(420354, 102, '2015-03-01 00:45:43.000000', 'consum', 0.0221, 'lps'),
	(420355, 102, '2015-03-01 00:45:44.000000', 'consum', 0.0223, 'lps'),
	(420356, 102, '2015-03-01 00:45:45.000000', 'consum', 0.0224, 'lps'),
	(420357, 102, '2015-03-01 00:45:46.000000', 'consum', 0.0219, 'lps'),
	(420358, 102, '2015-03-01 00:45:47.000000', 'consum', 0.0213, 'lps'),
	(420359, 102, '2015-03-01 00:45:48.000000', 'consum', 0.0221, 'lps'),
	(420360, 102, '2015-03-01 00:45:49.000000', 'consum', 0.0215, 'lps'),
	(420361, 102, '2015-03-01 00:45:50.000000', 'consum', 0.0224, 'lps'),
	(420362, 102, '2015-03-01 00:45:51.000000', 'consum', 0.0226, 'lps'),
	(420363, 102, '2015-03-01 00:45:52.000000', 'consum', 0.0228, 'lps'),
	(420364, 102, '2015-03-01 00:45:53.000000', 'consum', 0.0212, 'lps'),
	(420365, 102, '2015-03-01 00:45:54.000000', 'consum', 0.0228, 'lps'),
	(420366, 102, '2015-03-01 00:45:55.000000', 'consum', 0.0212, 'lps'),
	(420367, 102, '2015-03-01 00:45:56.000000', 'consum', 0.0227, 'lps'),
	(420368, 102, '2015-03-01 00:45:57.000000', 'consum', 0.0211, 'lps'),
	(420369, 102, '2015-03-01 00:45:58.000000', 'consum', 0.0224, 'lps'),
	(420370, 102, '2015-03-01 00:45:59.000000', 'consum', 0.0218, 'lps'),
	(420371, 102, '2015-03-01 00:46:00.000000', 'consum', 0.0226, 'lps'),
	(420372, 102, '2015-03-01 00:46:01.000000', 'consum', 0.0210, 'lps'),
	(420373, 102, '2015-03-01 00:46:02.000000', 'consum', 0.0220, 'lps'),
	(420374, 102, '2015-03-01 00:46:03.000000', 'consum', 0.0222, 'lps'),
	(420375, 102, '2015-03-01 00:46:04.000000', 'consum', 0.0219, 'lps'),
	(420376, 102, '2015-03-01 00:46:05.000000', 'consum', 0.0220, 'lps'),
	(420377, 102, '2015-03-01 00:46:06.000000', 'consum', 0.0216, 'lps'),
	(420378, 102, '2015-03-01 00:46:07.000000', 'consum', 0.0228, 'lps'),
	(420379, 102, '2015-03-01 00:46:08.000000', 'consum', 0.0222, 'lps'),
	(420380, 102, '2015-03-01 00:46:09.000000', 'consum', 0.0218, 'lps'),
	(420381, 102, '2015-03-01 00:46:10.000000', 'consum', 0.0212, 'lps'),
	(420382, 102, '2015-03-01 00:46:11.000000', 'consum', 0.0219, 'lps'),
	(420383, 102, '2015-03-01 00:46:12.000000', 'consum', 0.0229, 'lps'),
	(420384, 102, '2015-03-01 00:46:13.000000', 'consum', 0.0219, 'lps'),
	(420385, 102, '2015-03-01 00:46:14.000000', 'consum', 0.0217, 'lps'),
	(420386, 102, '2015-03-01 00:46:15.000000', 'consum', 0.0218, 'lps'),
	(420387, 102, '2015-03-01 00:46:16.000000', 'consum', 0.0210, 'lps'),
	(420388, 102, '2015-03-01 00:46:17.000000', 'consum', 0.0228, 'lps'),
	(420389, 102, '2015-03-01 00:46:18.000000', 'consum', 0.0219, 'lps'),
	(420390, 102, '2015-03-01 00:46:19.000000', 'consum', 0.0224, 'lps'),
	(420391, 102, '2015-03-01 00:46:20.000000', 'consum', 0.0212, 'lps'),
	(420392, 102, '2015-03-01 00:46:21.000000', 'consum', 0.0218, 'lps'),
	(420393, 102, '2015-03-01 00:46:22.000000', 'consum', 0.0224, 'lps'),
	(420394, 102, '2015-03-01 00:46:23.000000', 'consum', 0.0217, 'lps'),
	(420395, 102, '2015-03-01 00:46:24.000000', 'consum', 0.0224, 'lps'),
	(420396, 102, '2015-03-01 00:46:25.000000', 'consum', 0.0218, 'lps'),
	(420397, 102, '2015-03-01 00:46:26.000000', 'consum', 0.0227, 'lps'),
	(420398, 102, '2015-03-01 00:46:27.000000', 'consum', 0.0215, 'lps'),
	(420399, 102, '2015-03-01 00:46:28.000000', 'consum', 0.0224, 'lps'),
	(420400, 102, '2015-03-01 00:46:29.000000', 'consum', 0.0223, 'lps'),
	(420401, 102, '2015-03-01 00:46:30.000000', 'consum', 0.0215, 'lps'),
	(420402, 102, '2015-03-01 00:46:31.000000', 'consum', 0.0218, 'lps'),
	(420403, 102, '2015-03-01 00:46:32.000000', 'consum', 0.0213, 'lps'),
	(420404, 102, '2015-03-01 00:46:33.000000', 'consum', 0.0224, 'lps'),
	(420405, 102, '2015-03-01 00:46:34.000000', 'consum', 0.0211, 'lps'),
	(420406, 102, '2015-03-01 00:46:35.000000', 'consum', 0.0213, 'lps'),
	(420407, 102, '2015-03-01 00:46:36.000000', 'consum', 0.0221, 'lps'),
	(420408, 102, '2015-03-01 00:46:37.000000', 'consum', 0.0219, 'lps'),
	(420409, 102, '2015-03-01 00:46:38.000000', 'consum', 0.0220, 'lps'),
	(420410, 102, '2015-03-01 00:46:39.000000', 'consum', 0.0212, 'lps'),
	(420411, 102, '2015-03-01 00:46:40.000000', 'consum', 0.0214, 'lps'),
	(420412, 102, '2015-03-01 00:46:41.000000', 'consum', 0.0224, 'lps'),
	(420413, 102, '2015-03-01 00:46:42.000000', 'consum', 0.0228, 'lps'),
	(420414, 102, '2015-03-01 00:46:43.000000', 'consum', 0.0221, 'lps'),
	(420415, 102, '2015-03-01 00:46:44.000000', 'consum', 0.0228, 'lps'),
	(420416, 102, '2015-03-01 00:46:45.000000', 'consum', 0.0210, 'lps'),
	(420417, 102, '2015-03-01 00:46:46.000000', 'consum', 0.0215, 'lps'),
	(420418, 102, '2015-03-01 00:46:47.000000', 'consum', 0.0218, 'lps'),
	(420419, 102, '2015-03-01 00:46:48.000000', 'consum', 0.0213, 'lps'),
	(420420, 102, '2015-03-01 00:46:49.000000', 'consum', 0.0220, 'lps'),
	(420421, 102, '2015-03-01 00:46:50.000000', 'consum', 0.0214, 'lps'),
	(420422, 102, '2015-03-01 00:46:51.000000', 'consum', 0.0218, 'lps'),
	(420423, 102, '2015-03-01 00:46:52.000000', 'consum', 0.0221, 'lps'),
	(420424, 102, '2015-03-01 00:46:53.000000', 'consum', 0.0219, 'lps'),
	(420425, 102, '2015-03-01 00:46:54.000000', 'consum', 0.0222, 'lps'),
	(420426, 102, '2015-03-01 00:46:55.000000', 'consum', 0.0224, 'lps'),
	(420427, 102, '2015-03-01 00:46:56.000000', 'consum', 0.0223, 'lps'),
	(420428, 102, '2015-03-01 00:46:57.000000', 'consum', 0.0216, 'lps'),
	(420429, 102, '2015-03-01 00:46:58.000000', 'consum', 0.0220, 'lps'),
	(420430, 102, '2015-03-01 00:46:59.000000', 'consum', 0.0225, 'lps'),
	(420431, 102, '2015-03-01 00:47:00.000000', 'consum', 0.0213, 'lps'),
	(420432, 102, '2015-03-01 00:47:01.000000', 'consum', 0.0223, 'lps'),
	(420433, 102, '2015-03-01 00:47:02.000000', 'consum', 0.0225, 'lps'),
	(420434, 102, '2015-03-01 00:47:03.000000', 'consum', 0.0227, 'lps'),
	(420435, 102, '2015-03-01 00:47:04.000000', 'consum', 0.0211, 'lps'),
	(420436, 102, '2015-03-01 00:47:05.000000', 'consum', 0.0226, 'lps'),
	(420437, 102, '2015-03-01 00:47:06.000000', 'consum', 0.0226, 'lps'),
	(420438, 102, '2015-03-01 00:47:07.000000', 'consum', 0.0223, 'lps'),
	(420439, 102, '2015-03-01 00:47:08.000000', 'consum', 0.0227, 'lps'),
	(420440, 102, '2015-03-01 00:47:09.000000', 'consum', 0.0218, 'lps'),
	(420441, 102, '2015-03-01 00:47:10.000000', 'consum', 0.0220, 'lps'),
	(420442, 102, '2015-03-01 00:47:11.000000', 'consum', 0.0217, 'lps'),
	(420443, 102, '2015-03-01 00:47:12.000000', 'consum', 0.0216, 'lps'),
	(420444, 102, '2015-03-01 00:47:13.000000', 'consum', 0.0219, 'lps'),
	(420445, 102, '2015-03-01 00:47:14.000000', 'consum', 0.0217, 'lps'),
	(420446, 102, '2015-03-01 00:47:15.000000', 'consum', 0.0217, 'lps'),
	(420447, 102, '2015-03-01 00:47:16.000000', 'consum', 0.0225, 'lps'),
	(420448, 102, '2015-03-01 00:47:17.000000', 'consum', 0.0224, 'lps'),
	(420449, 102, '2015-03-01 00:47:18.000000', 'consum', 0.0216, 'lps'),
	(420450, 102, '2015-03-01 00:47:19.000000', 'consum', 0.0219, 'lps'),
	(420451, 102, '2015-03-01 00:47:20.000000', 'consum', 0.0218, 'lps'),
	(420452, 102, '2015-03-01 00:47:21.000000', 'consum', 0.0224, 'lps'),
	(420453, 102, '2015-03-01 00:47:22.000000', 'consum', 0.0217, 'lps'),
	(420454, 102, '2015-03-01 00:47:23.000000', 'consum', 0.0223, 'lps'),
	(420455, 102, '2015-03-01 00:47:24.000000', 'consum', 0.0216, 'lps'),
	(420456, 102, '2015-03-01 00:47:25.000000', 'consum', 0.0219, 'lps'),
	(420457, 102, '2015-03-01 00:47:26.000000', 'consum', 0.0218, 'lps'),
	(420458, 102, '2015-03-01 00:47:27.000000', 'consum', 0.0225, 'lps'),
	(420459, 102, '2015-03-01 00:47:28.000000', 'consum', 0.0220, 'lps'),
	(420460, 102, '2015-03-01 00:47:29.000000', 'consum', 0.0218, 'lps'),
	(420461, 102, '2015-03-01 00:47:30.000000', 'consum', 0.0218, 'lps'),
	(420462, 102, '2015-03-01 00:47:31.000000', 'consum', 0.0226, 'lps'),
	(420463, 102, '2015-03-01 00:47:32.000000', 'consum', 0.0227, 'lps'),
	(420464, 102, '2015-03-01 00:47:33.000000', 'consum', 0.0229, 'lps'),
	(420465, 102, '2015-03-01 00:47:34.000000', 'consum', 0.0214, 'lps'),
	(420466, 102, '2015-03-01 00:47:35.000000', 'consum', 0.0215, 'lps'),
	(420467, 102, '2015-03-01 00:47:36.000000', 'consum', 0.0220, 'lps'),
	(420468, 102, '2015-03-01 00:47:37.000000', 'consum', 0.0228, 'lps'),
	(420469, 102, '2015-03-01 00:47:38.000000', 'consum', 0.0211, 'lps'),
	(420470, 102, '2015-03-01 00:47:39.000000', 'consum', 0.0219, 'lps'),
	(420471, 102, '2015-03-01 00:47:40.000000', 'consum', 0.0214, 'lps'),
	(420472, 102, '2015-03-01 00:47:41.000000', 'consum', 0.0223, 'lps'),
	(420473, 102, '2015-03-01 00:47:42.000000', 'consum', 0.0222, 'lps'),
	(420474, 102, '2015-03-01 00:47:43.000000', 'consum', 0.0211, 'lps'),
	(420475, 102, '2015-03-01 00:47:44.000000', 'consum', 0.0223, 'lps'),
	(420476, 102, '2015-03-01 00:47:45.000000', 'consum', 0.0229, 'lps'),
	(420477, 102, '2015-03-01 00:47:46.000000', 'consum', 0.0210, 'lps'),
	(420478, 102, '2015-03-01 00:47:47.000000', 'consum', 0.0211, 'lps'),
	(420479, 102, '2015-03-01 00:47:48.000000', 'consum', 0.0218, 'lps'),
	(420480, 102, '2015-03-01 00:47:49.000000', 'consum', 0.0226, 'lps'),
	(420481, 102, '2015-03-01 00:47:50.000000', 'consum', 0.0227, 'lps'),
	(420482, 102, '2015-03-01 00:47:51.000000', 'consum', 0.0229, 'lps'),
	(420483, 102, '2015-03-01 00:47:52.000000', 'consum', 0.0213, 'lps'),
	(420484, 102, '2015-03-01 00:47:53.000000', 'consum', 0.0229, 'lps'),
	(420485, 102, '2015-03-01 00:47:54.000000', 'consum', 0.0218, 'lps'),
	(420486, 102, '2015-03-01 00:47:55.000000', 'consum', 0.0212, 'lps'),
	(420487, 102, '2015-03-01 00:47:56.000000', 'consum', 0.0217, 'lps'),
	(420488, 102, '2015-03-01 00:47:57.000000', 'consum', 0.0220, 'lps'),
	(420489, 102, '2015-03-01 00:47:58.000000', 'consum', 0.0219, 'lps'),
	(420490, 102, '2015-03-01 00:47:59.000000', 'consum', 0.0224, 'lps'),
	(420491, 102, '2015-03-01 00:48:00.000000', 'consum', 0.0213, 'lps'),
	(420492, 102, '2015-03-01 00:48:01.000000', 'consum', 0.0225, 'lps'),
	(420493, 102, '2015-03-01 00:48:02.000000', 'consum', 0.0217, 'lps'),
	(420494, 102, '2015-03-01 00:48:03.000000', 'consum', 0.0220, 'lps'),
	(420495, 102, '2015-03-01 00:48:04.000000', 'consum', 0.0218, 'lps'),
	(420496, 102, '2015-03-01 00:48:05.000000', 'consum', 0.0221, 'lps'),
	(420497, 102, '2015-03-01 00:48:06.000000', 'consum', 0.0220, 'lps'),
	(420498, 102, '2015-03-01 00:48:07.000000', 'consum', 0.0229, 'lps'),
	(420499, 102, '2015-03-01 00:48:08.000000', 'consum', 0.0216, 'lps'),
	(420500, 102, '2015-03-01 00:48:09.000000', 'consum', 0.0223, 'lps'),
	(420501, 102, '2015-03-01 00:48:10.000000', 'consum', 0.0217, 'lps'),
	(420502, 102, '2015-03-01 00:48:11.000000', 'consum', 0.0225, 'lps'),
	(420503, 102, '2015-03-01 00:48:12.000000', 'consum', 0.0228, 'lps'),
	(420504, 102, '2015-03-01 00:48:13.000000', 'consum', 0.0213, 'lps'),
	(420505, 102, '2015-03-01 00:48:14.000000', 'consum', 0.0212, 'lps'),
	(420506, 102, '2015-03-01 00:48:15.000000', 'consum', 0.0229, 'lps'),
	(420507, 102, '2015-03-01 00:48:16.000000', 'consum', 0.0223, 'lps'),
	(420508, 102, '2015-03-01 00:48:17.000000', 'consum', 0.0219, 'lps'),
	(420509, 102, '2015-03-01 00:48:18.000000', 'consum', 0.0215, 'lps'),
	(420510, 102, '2015-03-01 00:48:19.000000', 'consum', 0.0210, 'lps'),
	(420511, 102, '2015-03-01 00:48:20.000000', 'consum', 0.0215, 'lps'),
	(420512, 102, '2015-03-01 00:48:21.000000', 'consum', 0.0214, 'lps'),
	(420513, 102, '2015-03-01 00:48:22.000000', 'consum', 0.0215, 'lps'),
	(420514, 102, '2015-03-01 00:48:23.000000', 'consum', 0.0226, 'lps'),
	(420515, 102, '2015-03-01 00:48:24.000000', 'consum', 0.0216, 'lps'),
	(420516, 102, '2015-03-01 00:48:25.000000', 'consum', 0.0212, 'lps'),
	(420517, 102, '2015-03-01 00:48:26.000000', 'consum', 0.0222, 'lps'),
	(420518, 102, '2015-03-01 00:48:27.000000', 'consum', 0.0226, 'lps'),
	(420519, 102, '2015-03-01 00:48:28.000000', 'consum', 0.0211, 'lps'),
	(420520, 102, '2015-03-01 00:48:29.000000', 'consum', 0.0211, 'lps'),
	(420521, 102, '2015-03-01 00:48:30.000000', 'consum', 0.0212, 'lps'),
	(420522, 102, '2015-03-01 00:48:31.000000', 'consum', 0.0216, 'lps'),
	(420523, 102, '2015-03-01 00:48:32.000000', 'consum', 0.0213, 'lps'),
	(420524, 102, '2015-03-01 00:48:33.000000', 'consum', 0.0210, 'lps'),
	(420525, 102, '2015-03-01 00:48:34.000000', 'consum', 0.0221, 'lps'),
	(420526, 102, '2015-03-01 00:48:35.000000', 'consum', 0.0227, 'lps'),
	(420527, 102, '2015-03-01 00:48:36.000000', 'consum', 0.0221, 'lps'),
	(420528, 102, '2015-03-01 00:48:37.000000', 'consum', 0.0215, 'lps'),
	(420529, 102, '2015-03-01 00:48:38.000000', 'consum', 0.0221, 'lps'),
	(420530, 102, '2015-03-01 00:48:39.000000', 'consum', 0.0211, 'lps'),
	(420531, 102, '2015-03-01 00:48:40.000000', 'consum', 0.0223, 'lps'),
	(420532, 102, '2015-03-01 00:48:41.000000', 'consum', 0.0210, 'lps'),
	(420533, 102, '2015-03-01 00:48:42.000000', 'consum', 0.0215, 'lps'),
	(420534, 102, '2015-03-01 00:48:43.000000', 'consum', 0.0213, 'lps'),
	(420535, 102, '2015-03-01 00:48:44.000000', 'consum', 0.0229, 'lps'),
	(420536, 102, '2015-03-01 00:48:45.000000', 'consum', 0.0219, 'lps'),
	(420537, 102, '2015-03-01 00:48:46.000000', 'consum', 0.0220, 'lps'),
	(420538, 102, '2015-03-01 00:48:47.000000', 'consum', 0.0210, 'lps'),
	(420539, 102, '2015-03-01 00:48:48.000000', 'consum', 0.0223, 'lps'),
	(420540, 102, '2015-03-01 00:48:49.000000', 'consum', 0.0216, 'lps'),
	(420541, 102, '2015-03-01 00:48:50.000000', 'consum', 0.0223, 'lps'),
	(420542, 102, '2015-03-01 00:48:51.000000', 'consum', 0.0214, 'lps'),
	(420543, 102, '2015-03-01 00:48:52.000000', 'consum', 0.0215, 'lps'),
	(420544, 102, '2015-03-01 00:48:53.000000', 'consum', 0.0221, 'lps'),
	(420545, 102, '2015-03-01 00:48:54.000000', 'consum', 0.0212, 'lps'),
	(420546, 102, '2015-03-01 00:48:55.000000', 'consum', 0.0229, 'lps'),
	(420547, 102, '2015-03-01 00:48:56.000000', 'consum', 0.0217, 'lps'),
	(420548, 102, '2015-03-01 00:48:57.000000', 'consum', 0.0229, 'lps'),
	(420549, 102, '2015-03-01 00:48:58.000000', 'consum', 0.0223, 'lps'),
	(420550, 102, '2015-03-01 00:48:59.000000', 'consum', 0.0218, 'lps'),
	(420551, 102, '2015-03-01 00:49:00.000000', 'consum', 0.0214, 'lps'),
	(420552, 102, '2015-03-01 00:49:01.000000', 'consum', 0.0225, 'lps'),
	(420553, 102, '2015-03-01 00:49:02.000000', 'consum', 0.0215, 'lps'),
	(420554, 102, '2015-03-01 00:49:03.000000', 'consum', 0.0210, 'lps'),
	(420555, 102, '2015-03-01 00:49:04.000000', 'consum', 0.0214, 'lps'),
	(420556, 102, '2015-03-01 00:49:05.000000', 'consum', 0.0212, 'lps'),
	(420557, 102, '2015-03-01 00:49:06.000000', 'consum', 0.0227, 'lps'),
	(420558, 102, '2015-03-01 00:49:07.000000', 'consum', 0.0210, 'lps'),
	(420559, 102, '2015-03-01 00:49:08.000000', 'consum', 0.0220, 'lps'),
	(420560, 102, '2015-03-01 00:49:09.000000', 'consum', 0.0221, 'lps'),
	(420561, 102, '2015-03-01 00:49:10.000000', 'consum', 0.0214, 'lps'),
	(420562, 102, '2015-03-01 00:49:11.000000', 'consum', 0.0217, 'lps'),
	(420563, 102, '2015-03-01 00:49:12.000000', 'consum', 0.0214, 'lps'),
	(420564, 102, '2015-03-01 00:49:13.000000', 'consum', 0.0228, 'lps'),
	(420565, 102, '2015-03-01 00:49:14.000000', 'consum', 0.0228, 'lps'),
	(420566, 102, '2015-03-01 00:49:15.000000', 'consum', 0.0227, 'lps'),
	(420567, 102, '2015-03-01 00:49:16.000000', 'consum', 0.0224, 'lps'),
	(420568, 102, '2015-03-01 00:49:17.000000', 'consum', 0.0226, 'lps'),
	(420569, 102, '2015-03-01 00:49:18.000000', 'consum', 0.0210, 'lps'),
	(420570, 102, '2015-03-01 00:49:19.000000', 'consum', 0.0224, 'lps'),
	(420571, 102, '2015-03-01 00:49:20.000000', 'consum', 0.0219, 'lps'),
	(420572, 102, '2015-03-01 00:49:21.000000', 'consum', 0.0216, 'lps'),
	(420573, 102, '2015-03-01 00:49:22.000000', 'consum', 0.0210, 'lps'),
	(420574, 102, '2015-03-01 00:49:23.000000', 'consum', 0.0216, 'lps'),
	(420575, 102, '2015-03-01 00:49:24.000000', 'consum', 0.0218, 'lps'),
	(420576, 102, '2015-03-01 00:49:25.000000', 'consum', 0.0212, 'lps'),
	(420577, 102, '2015-03-01 00:49:26.000000', 'consum', 0.0219, 'lps'),
	(420578, 102, '2015-03-01 00:49:27.000000', 'consum', 0.0229, 'lps'),
	(420579, 102, '2015-03-01 00:49:28.000000', 'consum', 0.0218, 'lps'),
	(420580, 102, '2015-03-01 00:49:29.000000', 'consum', 0.0215, 'lps'),
	(420581, 102, '2015-03-01 00:49:30.000000', 'consum', 0.0229, 'lps'),
	(420582, 102, '2015-03-01 00:49:31.000000', 'consum', 0.0211, 'lps'),
	(420583, 102, '2015-03-01 00:49:32.000000', 'consum', 0.0220, 'lps'),
	(420584, 102, '2015-03-01 00:49:33.000000', 'consum', 0.0215, 'lps'),
	(420585, 102, '2015-03-01 00:49:34.000000', 'consum', 0.0228, 'lps'),
	(420586, 102, '2015-03-01 00:49:35.000000', 'consum', 0.0223, 'lps'),
	(420587, 102, '2015-03-01 00:49:36.000000', 'consum', 0.0222, 'lps'),
	(420588, 102, '2015-03-01 00:49:37.000000', 'consum', 0.0212, 'lps'),
	(420589, 102, '2015-03-01 00:49:38.000000', 'consum', 0.0224, 'lps'),
	(420590, 102, '2015-03-01 00:49:39.000000', 'consum', 0.0214, 'lps'),
	(420591, 102, '2015-03-01 00:49:40.000000', 'consum', 0.0228, 'lps'),
	(420592, 102, '2015-03-01 00:49:41.000000', 'consum', 0.0228, 'lps'),
	(420593, 102, '2015-03-01 00:49:42.000000', 'consum', 0.0226, 'lps'),
	(420594, 102, '2015-03-01 00:49:43.000000', 'consum', 0.0218, 'lps'),
	(420595, 102, '2015-03-01 00:49:44.000000', 'consum', 0.0222, 'lps'),
	(420596, 102, '2015-03-01 00:49:45.000000', 'consum', 0.0228, 'lps'),
	(420597, 102, '2015-03-01 00:49:46.000000', 'consum', 0.0223, 'lps'),
	(420598, 102, '2015-03-01 00:49:47.000000', 'consum', 0.0220, 'lps'),
	(420599, 102, '2015-03-01 00:49:48.000000', 'consum', 0.0224, 'lps'),
	(420600, 102, '2015-03-01 00:49:49.000000', 'consum', 0.0228, 'lps'),
	(420601, 102, '2015-03-01 00:49:50.000000', 'consum', 0.0221, 'lps'),
	(420602, 102, '2015-03-01 00:49:51.000000', 'consum', 0.0229, 'lps'),
	(420603, 102, '2015-03-01 00:49:52.000000', 'consum', 0.0213, 'lps'),
	(420604, 102, '2015-03-01 00:49:53.000000', 'consum', 0.0229, 'lps'),
	(420605, 102, '2015-03-01 00:49:54.000000', 'consum', 0.0216, 'lps'),
	(420606, 102, '2015-03-01 00:49:55.000000', 'consum', 0.0224, 'lps'),
	(420607, 102, '2015-03-01 00:49:56.000000', 'consum', 0.0221, 'lps'),
	(420608, 102, '2015-03-01 00:49:57.000000', 'consum', 0.0224, 'lps'),
	(420609, 102, '2015-03-01 00:49:58.000000', 'consum', 0.0229, 'lps'),
	(420610, 102, '2015-03-01 00:49:59.000000', 'consum', 0.0224, 'lps'),
	(420611, 102, '2015-03-01 00:50:00.000000', 'consum', 0.0222, 'lps'),
	(420612, 102, '2015-03-01 00:50:01.000000', 'consum', 0.0210, 'lps'),
	(420613, 102, '2015-03-01 00:50:02.000000', 'consum', 0.0213, 'lps'),
	(420614, 102, '2015-03-01 00:50:03.000000', 'consum', 0.0228, 'lps'),
	(420615, 102, '2015-03-01 00:50:04.000000', 'consum', 0.0228, 'lps'),
	(420616, 102, '2015-03-01 00:50:05.000000', 'consum', 0.0210, 'lps'),
	(420617, 102, '2015-03-01 00:50:06.000000', 'consum', 0.0214, 'lps'),
	(420618, 102, '2015-03-01 00:50:07.000000', 'consum', 0.0212, 'lps'),
	(420619, 102, '2015-03-01 00:50:08.000000', 'consum', 0.0227, 'lps'),
	(420620, 102, '2015-03-01 00:50:09.000000', 'consum', 0.0211, 'lps'),
	(420621, 102, '2015-03-01 00:50:10.000000', 'consum', 0.0223, 'lps'),
	(420622, 102, '2015-03-01 00:50:11.000000', 'consum', 0.0214, 'lps'),
	(420623, 102, '2015-03-01 00:50:12.000000', 'consum', 0.0229, 'lps'),
	(420624, 102, '2015-03-01 00:50:13.000000', 'consum', 0.0214, 'lps'),
	(420625, 102, '2015-03-01 00:50:14.000000', 'consum', 0.0214, 'lps'),
	(420626, 102, '2015-03-01 00:50:15.000000', 'consum', 0.0218, 'lps'),
	(420627, 102, '2015-03-01 00:50:16.000000', 'consum', 0.0219, 'lps'),
	(420628, 102, '2015-03-01 00:50:17.000000', 'consum', 0.0229, 'lps'),
	(420629, 102, '2015-03-01 00:50:18.000000', 'consum', 0.0222, 'lps'),
	(420630, 102, '2015-03-01 00:50:19.000000', 'consum', 0.0212, 'lps'),
	(420631, 102, '2015-03-01 00:50:20.000000', 'consum', 0.0224, 'lps'),
	(420632, 102, '2015-03-01 00:50:21.000000', 'consum', 0.0215, 'lps'),
	(420633, 102, '2015-03-01 00:50:22.000000', 'consum', 0.0215, 'lps'),
	(420634, 102, '2015-03-01 00:50:23.000000', 'consum', 0.0221, 'lps'),
	(420635, 102, '2015-03-01 00:50:24.000000', 'consum', 0.0211, 'lps'),
	(420636, 102, '2015-03-01 00:50:25.000000', 'consum', 0.0221, 'lps'),
	(420637, 102, '2015-03-01 00:50:26.000000', 'consum', 0.0222, 'lps'),
	(420638, 102, '2015-03-01 00:50:27.000000', 'consum', 0.0218, 'lps'),
	(420639, 102, '2015-03-01 00:50:28.000000', 'consum', 0.0214, 'lps'),
	(420640, 102, '2015-03-01 00:50:29.000000', 'consum', 0.0228, 'lps'),
	(420641, 102, '2015-03-01 00:50:30.000000', 'consum', 0.0228, 'lps'),
	(420642, 102, '2015-03-01 00:50:31.000000', 'consum', 0.0225, 'lps'),
	(420643, 102, '2015-03-01 00:50:32.000000', 'consum', 0.0213, 'lps'),
	(420644, 102, '2015-03-01 00:50:33.000000', 'consum', 0.0222, 'lps'),
	(420645, 102, '2015-03-01 00:50:34.000000', 'consum', 0.0219, 'lps'),
	(420646, 102, '2015-03-01 00:50:35.000000', 'consum', 0.0219, 'lps'),
	(420647, 102, '2015-03-01 00:50:36.000000', 'consum', 0.0229, 'lps'),
	(420648, 102, '2015-03-01 00:50:37.000000', 'consum', 0.0221, 'lps'),
	(420649, 102, '2015-03-01 00:50:38.000000', 'consum', 0.0225, 'lps'),
	(420650, 102, '2015-03-01 00:50:39.000000', 'consum', 0.0215, 'lps'),
	(420651, 102, '2015-03-01 00:50:40.000000', 'consum', 0.0211, 'lps'),
	(420652, 102, '2015-03-01 00:50:41.000000', 'consum', 0.0220, 'lps'),
	(420653, 102, '2015-03-01 00:50:42.000000', 'consum', 0.0217, 'lps'),
	(420654, 102, '2015-03-01 00:50:43.000000', 'consum', 0.0215, 'lps'),
	(420655, 102, '2015-03-01 00:50:44.000000', 'consum', 0.0217, 'lps'),
	(420656, 102, '2015-03-01 00:50:45.000000', 'consum', 0.0229, 'lps'),
	(420657, 102, '2015-03-01 00:50:46.000000', 'consum', 0.0223, 'lps'),
	(420658, 102, '2015-03-01 00:50:47.000000', 'consum', 0.0218, 'lps'),
	(420659, 102, '2015-03-01 00:50:48.000000', 'consum', 0.0211, 'lps'),
	(420660, 102, '2015-03-01 00:50:49.000000', 'consum', 0.0212, 'lps'),
	(420661, 102, '2015-03-01 00:50:50.000000', 'consum', 0.0218, 'lps'),
	(420662, 102, '2015-03-01 00:50:51.000000', 'consum', 0.0225, 'lps'),
	(420663, 102, '2015-03-01 00:50:52.000000', 'consum', 0.0222, 'lps'),
	(420664, 102, '2015-03-01 00:50:53.000000', 'consum', 0.0224, 'lps'),
	(420665, 102, '2015-03-01 00:50:54.000000', 'consum', 0.0224, 'lps'),
	(420666, 102, '2015-03-01 00:50:55.000000', 'consum', 0.0219, 'lps'),
	(420667, 102, '2015-03-01 00:50:56.000000', 'consum', 0.0215, 'lps'),
	(420668, 102, '2015-03-01 00:50:57.000000', 'consum', 0.0226, 'lps'),
	(420669, 102, '2015-03-01 00:50:58.000000', 'consum', 0.0217, 'lps'),
	(420670, 102, '2015-03-01 00:50:59.000000', 'consum', 0.0219, 'lps'),
	(420671, 102, '2015-03-01 00:51:00.000000', 'consum', 0.0214, 'lps'),
	(420672, 102, '2015-03-01 00:51:01.000000', 'consum', 0.0221, 'lps'),
	(420673, 102, '2015-03-01 00:51:02.000000', 'consum', 0.0215, 'lps'),
	(420674, 102, '2015-03-01 00:51:03.000000', 'consum', 0.0224, 'lps'),
	(420675, 102, '2015-03-01 00:51:04.000000', 'consum', 0.0225, 'lps'),
	(420676, 102, '2015-03-01 00:51:05.000000', 'consum', 0.0222, 'lps'),
	(420677, 102, '2015-03-01 00:51:06.000000', 'consum', 0.0225, 'lps'),
	(420678, 102, '2015-03-01 00:51:07.000000', 'consum', 0.0229, 'lps'),
	(420679, 102, '2015-03-01 00:51:08.000000', 'consum', 0.0221, 'lps'),
	(420680, 102, '2015-03-01 00:51:09.000000', 'consum', 0.0210, 'lps'),
	(420681, 102, '2015-03-01 00:51:10.000000', 'consum', 0.0216, 'lps'),
	(420682, 102, '2015-03-01 00:51:11.000000', 'consum', 0.0222, 'lps'),
	(420683, 102, '2015-03-01 00:51:12.000000', 'consum', 0.0212, 'lps'),
	(420684, 102, '2015-03-01 00:51:13.000000', 'consum', 0.0226, 'lps'),
	(420685, 102, '2015-03-01 00:51:14.000000', 'consum', 0.0222, 'lps'),
	(420686, 102, '2015-03-01 00:51:15.000000', 'consum', 0.0223, 'lps'),
	(420687, 102, '2015-03-01 00:51:16.000000', 'consum', 0.0219, 'lps'),
	(420688, 102, '2015-03-01 00:51:17.000000', 'consum', 0.0219, 'lps'),
	(420689, 102, '2015-03-01 00:51:18.000000', 'consum', 0.0228, 'lps'),
	(420690, 102, '2015-03-01 00:51:19.000000', 'consum', 0.0213, 'lps'),
	(420691, 102, '2015-03-01 00:51:20.000000', 'consum', 0.0210, 'lps'),
	(420692, 102, '2015-03-01 00:51:21.000000', 'consum', 0.0223, 'lps'),
	(420693, 102, '2015-03-01 00:51:22.000000', 'consum', 0.0217, 'lps'),
	(420694, 102, '2015-03-01 00:51:23.000000', 'consum', 0.0224, 'lps'),
	(420695, 102, '2015-03-01 00:51:24.000000', 'consum', 0.0221, 'lps'),
	(420696, 102, '2015-03-01 00:51:25.000000', 'consum', 0.0221, 'lps'),
	(420697, 102, '2015-03-01 00:51:26.000000', 'consum', 0.0215, 'lps'),
	(420698, 102, '2015-03-01 00:51:27.000000', 'consum', 0.0222, 'lps'),
	(420699, 102, '2015-03-01 00:51:28.000000', 'consum', 0.0214, 'lps'),
	(420700, 102, '2015-03-01 00:51:29.000000', 'consum', 0.0217, 'lps'),
	(420701, 102, '2015-03-01 00:51:30.000000', 'consum', 0.0213, 'lps'),
	(420702, 102, '2015-03-01 00:51:31.000000', 'consum', 0.0223, 'lps'),
	(420703, 102, '2015-03-01 00:51:32.000000', 'consum', 0.0228, 'lps'),
	(420704, 102, '2015-03-01 00:51:33.000000', 'consum', 0.0221, 'lps'),
	(420705, 102, '2015-03-01 00:51:34.000000', 'consum', 0.0213, 'lps'),
	(420706, 102, '2015-03-01 00:51:35.000000', 'consum', 0.0210, 'lps'),
	(420707, 102, '2015-03-01 00:51:36.000000', 'consum', 0.0222, 'lps'),
	(420708, 102, '2015-03-01 00:51:37.000000', 'consum', 0.0229, 'lps'),
	(420709, 102, '2015-03-01 00:51:38.000000', 'consum', 0.0212, 'lps'),
	(420710, 102, '2015-03-01 00:51:39.000000', 'consum', 0.0223, 'lps'),
	(420711, 102, '2015-03-01 00:51:40.000000', 'consum', 0.0211, 'lps'),
	(420712, 102, '2015-03-01 00:51:41.000000', 'consum', 0.0215, 'lps'),
	(420713, 102, '2015-03-01 00:51:42.000000', 'consum', 0.0211, 'lps'),
	(420714, 102, '2015-03-01 00:51:43.000000', 'consum', 0.0220, 'lps'),
	(420715, 102, '2015-03-01 00:51:44.000000', 'consum', 0.0218, 'lps'),
	(420716, 102, '2015-03-01 00:51:45.000000', 'consum', 0.0221, 'lps'),
	(420717, 102, '2015-03-01 00:51:46.000000', 'consum', 0.0223, 'lps'),
	(420718, 102, '2015-03-01 00:51:47.000000', 'consum', 0.0221, 'lps'),
	(420719, 102, '2015-03-01 00:51:48.000000', 'consum', 0.0225, 'lps'),
	(420720, 102, '2015-03-01 00:51:49.000000', 'consum', 0.0215, 'lps'),
	(420721, 102, '2015-03-01 00:51:50.000000', 'consum', 0.0212, 'lps'),
	(420722, 102, '2015-03-01 00:51:51.000000', 'consum', 0.0222, 'lps'),
	(420723, 102, '2015-03-01 00:51:52.000000', 'consum', 0.0225, 'lps'),
	(420724, 102, '2015-03-01 00:51:53.000000', 'consum', 0.0211, 'lps'),
	(420725, 102, '2015-03-01 00:51:54.000000', 'consum', 0.0228, 'lps'),
	(420726, 102, '2015-03-01 00:51:55.000000', 'consum', 0.0218, 'lps'),
	(420727, 102, '2015-03-01 00:51:56.000000', 'consum', 0.0217, 'lps'),
	(420728, 102, '2015-03-01 00:51:57.000000', 'consum', 0.0223, 'lps'),
	(420729, 102, '2015-03-01 00:51:58.000000', 'consum', 0.0215, 'lps'),
	(420730, 102, '2015-03-01 00:51:59.000000', 'consum', 0.0214, 'lps'),
	(420731, 102, '2015-03-01 00:52:00.000000', 'consum', 0.0216, 'lps'),
	(420732, 102, '2015-03-01 00:52:01.000000', 'consum', 0.0210, 'lps'),
	(420733, 102, '2015-03-01 00:52:02.000000', 'consum', 0.0213, 'lps'),
	(420734, 102, '2015-03-01 00:52:03.000000', 'consum', 0.0223, 'lps'),
	(420735, 102, '2015-03-01 00:52:04.000000', 'consum', 0.0228, 'lps'),
	(420736, 102, '2015-03-01 00:52:05.000000', 'consum', 0.0221, 'lps'),
	(420737, 102, '2015-03-01 00:52:06.000000', 'consum', 0.0212, 'lps'),
	(420738, 102, '2015-03-01 00:52:07.000000', 'consum', 0.0226, 'lps'),
	(420739, 102, '2015-03-01 00:52:08.000000', 'consum', 0.0223, 'lps'),
	(420740, 102, '2015-03-01 00:52:09.000000', 'consum', 0.0211, 'lps'),
	(420741, 102, '2015-03-01 00:52:10.000000', 'consum', 0.0216, 'lps'),
	(420742, 102, '2015-03-01 00:52:11.000000', 'consum', 0.0216, 'lps'),
	(420743, 102, '2015-03-01 00:52:12.000000', 'consum', 0.0222, 'lps'),
	(420744, 102, '2015-03-01 00:52:13.000000', 'consum', 0.0214, 'lps'),
	(420745, 102, '2015-03-01 00:52:14.000000', 'consum', 0.0214, 'lps'),
	(420746, 102, '2015-03-01 00:52:15.000000', 'consum', 0.0218, 'lps'),
	(420747, 102, '2015-03-01 00:52:16.000000', 'consum', 0.0219, 'lps'),
	(420748, 102, '2015-03-01 00:52:17.000000', 'consum', 0.0229, 'lps'),
	(420749, 102, '2015-03-01 00:52:18.000000', 'consum', 0.0222, 'lps'),
	(420750, 102, '2015-03-01 00:52:19.000000', 'consum', 0.0212, 'lps'),
	(420751, 102, '2015-03-01 00:52:20.000000', 'consum', 0.0225, 'lps'),
	(420752, 102, '2015-03-01 00:52:21.000000', 'consum', 0.0221, 'lps'),
	(420753, 102, '2015-03-01 00:52:22.000000', 'consum', 0.0220, 'lps'),
	(420754, 102, '2015-03-01 00:52:23.000000', 'consum', 0.0229, 'lps'),
	(420755, 102, '2015-03-01 00:52:24.000000', 'consum', 0.0214, 'lps'),
	(420756, 102, '2015-03-01 00:52:25.000000', 'consum', 0.0214, 'lps'),
	(420757, 102, '2015-03-01 00:52:26.000000', 'consum', 0.0218, 'lps'),
	(420758, 102, '2015-03-01 00:52:27.000000', 'consum', 0.0218, 'lps'),
	(420759, 102, '2015-03-01 00:52:28.000000', 'consum', 0.0228, 'lps'),
	(420760, 102, '2015-03-01 00:52:29.000000', 'consum', 0.0215, 'lps'),
	(420761, 102, '2015-03-01 00:52:30.000000', 'consum', 0.0222, 'lps'),
	(420762, 102, '2015-03-01 00:52:31.000000', 'consum', 0.0215, 'lps'),
	(420763, 102, '2015-03-01 00:52:32.000000', 'consum', 0.0220, 'lps'),
	(420764, 102, '2015-03-01 00:52:33.000000', 'consum', 0.0224, 'lps'),
	(420765, 102, '2015-03-01 00:52:34.000000', 'consum', 0.0212, 'lps'),
	(420766, 102, '2015-03-01 00:52:35.000000', 'consum', 0.0217, 'lps'),
	(420767, 102, '2015-03-01 00:52:36.000000', 'consum', 0.0219, 'lps'),
	(420768, 102, '2015-03-01 00:52:37.000000', 'consum', 0.0216, 'lps'),
	(420769, 102, '2015-03-01 00:52:38.000000', 'consum', 0.0215, 'lps'),
	(420770, 102, '2015-03-01 00:52:39.000000', 'consum', 0.0216, 'lps'),
	(420771, 102, '2015-03-01 00:52:40.000000', 'consum', 0.0227, 'lps'),
	(420772, 102, '2015-03-01 00:52:41.000000', 'consum', 0.0216, 'lps'),
	(420773, 102, '2015-03-01 00:52:42.000000', 'consum', 0.0210, 'lps'),
	(420774, 102, '2015-03-01 00:52:43.000000', 'consum', 0.0214, 'lps'),
	(420775, 102, '2015-03-01 00:52:44.000000', 'consum', 0.0210, 'lps'),
	(420776, 102, '2015-03-01 00:52:45.000000', 'consum', 0.0216, 'lps'),
	(420777, 102, '2015-03-01 00:52:46.000000', 'consum', 0.0223, 'lps'),
	(420778, 102, '2015-03-01 00:52:47.000000', 'consum', 0.0218, 'lps'),
	(420779, 102, '2015-03-01 00:52:48.000000', 'consum', 0.0211, 'lps'),
	(420780, 102, '2015-03-01 00:52:49.000000', 'consum', 0.0213, 'lps'),
	(420781, 102, '2015-03-01 00:52:50.000000', 'consum', 0.0220, 'lps'),
	(420782, 102, '2015-03-01 00:52:51.000000', 'consum', 0.0214, 'lps'),
	(420783, 102, '2015-03-01 00:52:52.000000', 'consum', 0.0220, 'lps'),
	(420784, 102, '2015-03-01 00:52:53.000000', 'consum', 0.0228, 'lps'),
	(420785, 102, '2015-03-01 00:52:54.000000', 'consum', 0.0211, 'lps'),
	(420786, 102, '2015-03-01 00:52:55.000000', 'consum', 0.0221, 'lps'),
	(420787, 102, '2015-03-01 00:52:56.000000', 'consum', 0.0224, 'lps'),
	(420788, 102, '2015-03-01 00:52:57.000000', 'consum', 0.0226, 'lps'),
	(420789, 102, '2015-03-01 00:52:58.000000', 'consum', 0.0227, 'lps'),
	(420790, 102, '2015-03-01 00:52:59.000000', 'consum', 0.0210, 'lps'),
	(420791, 102, '2015-03-01 00:53:00.000000', 'consum', 0.0219, 'lps'),
	(420792, 102, '2015-03-01 00:53:01.000000', 'consum', 0.0215, 'lps'),
	(420793, 102, '2015-03-01 00:53:02.000000', 'consum', 0.0229, 'lps'),
	(420794, 102, '2015-03-01 00:53:03.000000', 'consum', 0.0229, 'lps'),
	(420795, 102, '2015-03-01 00:53:04.000000', 'consum', 0.0210, 'lps'),
	(420796, 102, '2015-03-01 00:53:05.000000', 'consum', 0.0214, 'lps'),
	(420797, 102, '2015-03-01 00:53:06.000000', 'consum', 0.0212, 'lps'),
	(420798, 102, '2015-03-01 00:53:07.000000', 'consum', 0.0227, 'lps'),
	(420799, 102, '2015-03-01 00:53:08.000000', 'consum', 0.0228, 'lps'),
	(420800, 102, '2015-03-01 00:53:09.000000', 'consum', 0.0213, 'lps'),
	(420801, 102, '2015-03-01 00:53:10.000000', 'consum', 0.0228, 'lps'),
	(420802, 102, '2015-03-01 00:53:11.000000', 'consum', 0.0213, 'lps'),
	(420803, 102, '2015-03-01 00:53:12.000000', 'consum', 0.0212, 'lps'),
	(420804, 102, '2015-03-01 00:53:13.000000', 'consum', 0.0211, 'lps'),
	(420805, 102, '2015-03-01 00:53:14.000000', 'consum', 0.0229, 'lps'),
	(420806, 102, '2015-03-01 00:53:15.000000', 'consum', 0.0223, 'lps'),
	(420807, 102, '2015-03-01 00:53:16.000000', 'consum', 0.0219, 'lps'),
	(420808, 102, '2015-03-01 00:53:17.000000', 'consum', 0.0214, 'lps'),
	(420809, 102, '2015-03-01 00:53:18.000000', 'consum', 0.0227, 'lps'),
	(420810, 102, '2015-03-01 00:53:19.000000', 'consum', 0.0221, 'lps'),
	(420811, 102, '2015-03-01 00:53:20.000000', 'consum', 0.0213, 'lps'),
	(420812, 102, '2015-03-01 00:53:21.000000', 'consum', 0.0216, 'lps'),
	(420813, 102, '2015-03-01 00:53:22.000000', 'consum', 0.0211, 'lps'),
	(420814, 102, '2015-03-01 00:53:23.000000', 'consum', 0.0215, 'lps'),
	(420815, 102, '2015-03-01 00:53:24.000000', 'consum', 0.0213, 'lps'),
	(420816, 102, '2015-03-01 00:53:25.000000', 'consum', 0.0211, 'lps'),
	(420817, 102, '2015-03-01 00:53:26.000000', 'consum', 0.0228, 'lps'),
	(420818, 102, '2015-03-01 00:53:27.000000', 'consum', 0.0218, 'lps'),
	(420819, 102, '2015-03-01 00:53:28.000000', 'consum', 0.0215, 'lps'),
	(420820, 102, '2015-03-01 00:53:29.000000', 'consum', 0.0211, 'lps'),
	(420821, 102, '2015-03-01 00:53:30.000000', 'consum', 0.0223, 'lps'),
	(420822, 102, '2015-03-01 00:53:31.000000', 'consum', 0.0211, 'lps'),
	(420823, 102, '2015-03-01 00:53:32.000000', 'consum', 0.0217, 'lps'),
	(420824, 102, '2015-03-01 00:53:33.000000', 'consum', 0.0222, 'lps'),
	(420825, 102, '2015-03-01 00:53:34.000000', 'consum', 0.0229, 'lps'),
	(420826, 102, '2015-03-01 00:53:35.000000', 'consum', 0.0211, 'lps'),
	(420827, 102, '2015-03-01 00:53:36.000000', 'consum', 0.0218, 'lps'),
	(420828, 102, '2015-03-01 00:53:37.000000', 'consum', 0.0226, 'lps'),
	(420829, 102, '2015-03-01 00:53:38.000000', 'consum', 0.0227, 'lps'),
	(420830, 102, '2015-03-01 00:53:39.000000', 'consum', 0.0229, 'lps'),
	(420831, 102, '2015-03-01 00:53:40.000000', 'consum', 0.0213, 'lps'),
	(420832, 102, '2015-03-01 00:53:41.000000', 'consum', 0.0229, 'lps'),
	(420833, 102, '2015-03-01 00:53:42.000000', 'consum', 0.0218, 'lps'),
	(420834, 102, '2015-03-01 00:53:43.000000', 'consum', 0.0214, 'lps'),
	(420835, 102, '2015-03-01 00:53:44.000000', 'consum', 0.0224, 'lps'),
	(420836, 102, '2015-03-01 00:53:45.000000', 'consum', 0.0210, 'lps'),
	(420837, 102, '2015-03-01 00:53:46.000000', 'consum', 0.0228, 'lps'),
	(420838, 102, '2015-03-01 00:53:47.000000', 'consum', 0.0220, 'lps'),
	(420839, 102, '2015-03-01 00:53:48.000000', 'consum', 0.0226, 'lps'),
	(420840, 102, '2015-03-01 00:53:49.000000', 'consum', 0.0221, 'lps'),
	(420841, 102, '2015-03-01 00:53:50.000000', 'consum', 0.0220, 'lps'),
	(420842, 102, '2015-03-01 00:53:51.000000', 'consum', 0.0224, 'lps'),
	(420843, 102, '2015-03-01 00:53:52.000000', 'consum', 0.0212, 'lps'),
	(420844, 102, '2015-03-01 00:53:53.000000', 'consum', 0.0220, 'lps'),
	(420845, 102, '2015-03-01 00:53:54.000000', 'consum', 0.0215, 'lps'),
	(420846, 102, '2015-03-01 00:53:55.000000', 'consum', 0.0225, 'lps'),
	(420847, 102, '2015-03-01 00:53:56.000000', 'consum', 0.0212, 'lps'),
	(420848, 102, '2015-03-01 00:53:57.000000', 'consum', 0.0214, 'lps'),
	(420849, 102, '2015-03-01 00:53:58.000000', 'consum', 0.0225, 'lps'),
	(420850, 102, '2015-03-01 00:53:59.000000', 'consum', 0.0215, 'lps'),
	(420851, 102, '2015-03-01 00:54:00.000000', 'consum', 0.0227, 'lps'),
	(420852, 102, '2015-03-01 00:54:01.000000', 'consum', 0.0224, 'lps'),
	(420853, 102, '2015-03-01 00:54:02.000000', 'consum', 0.0226, 'lps'),
	(420854, 102, '2015-03-01 00:54:03.000000', 'consum', 0.0211, 'lps'),
	(420855, 102, '2015-03-01 00:54:04.000000', 'consum', 0.0226, 'lps'),
	(420856, 102, '2015-03-01 00:54:05.000000', 'consum', 0.0227, 'lps'),
	(420857, 102, '2015-03-01 00:54:06.000000', 'consum', 0.0229, 'lps'),
	(420858, 102, '2015-03-01 00:54:07.000000', 'consum', 0.0216, 'lps'),
	(420859, 102, '2015-03-01 00:54:08.000000', 'consum', 0.0221, 'lps'),
	(420860, 102, '2015-03-01 00:54:09.000000', 'consum', 0.0210, 'lps'),
	(420861, 102, '2015-03-01 00:54:10.000000', 'consum', 0.0215, 'lps'),
	(420862, 102, '2015-03-01 00:54:11.000000', 'consum', 0.0218, 'lps'),
	(420863, 102, '2015-03-01 00:54:12.000000', 'consum', 0.0216, 'lps'),
	(420864, 102, '2015-03-01 00:54:13.000000', 'consum', 0.0216, 'lps'),
	(420865, 102, '2015-03-01 00:54:14.000000', 'consum', 0.0224, 'lps'),
	(420866, 102, '2015-03-01 00:54:15.000000', 'consum', 0.0220, 'lps'),
	(420867, 102, '2015-03-01 00:54:16.000000', 'consum', 0.0218, 'lps'),
	(420868, 102, '2015-03-01 00:54:17.000000', 'consum', 0.0220, 'lps'),
	(420869, 102, '2015-03-01 00:54:18.000000', 'consum', 0.0216, 'lps'),
	(420870, 102, '2015-03-01 00:54:19.000000', 'consum', 0.0213, 'lps'),
	(420871, 102, '2015-03-01 00:54:20.000000', 'consum', 0.0227, 'lps'),
	(420872, 102, '2015-03-01 00:54:21.000000', 'consum', 0.0228, 'lps'),
	(420873, 102, '2015-03-01 00:54:22.000000', 'consum', 0.0226, 'lps'),
	(420874, 102, '2015-03-01 00:54:23.000000', 'consum', 0.0218, 'lps'),
	(420875, 102, '2015-03-01 00:54:24.000000', 'consum', 0.0225, 'lps'),
	(420876, 102, '2015-03-01 00:54:25.000000', 'consum', 0.0218, 'lps'),
	(420877, 102, '2015-03-01 00:54:26.000000', 'consum', 0.0226, 'lps'),
	(420878, 102, '2015-03-01 00:54:27.000000', 'consum', 0.0226, 'lps'),
	(420879, 102, '2015-03-01 00:54:28.000000', 'consum', 0.0225, 'lps'),
	(420880, 102, '2015-03-01 00:54:29.000000', 'consum', 0.0217, 'lps'),
	(420881, 102, '2015-03-01 00:54:30.000000', 'consum', 0.0222, 'lps'),
	(420882, 102, '2015-03-01 00:54:31.000000', 'consum', 0.0226, 'lps'),
	(420883, 102, '2015-03-01 00:54:32.000000', 'consum', 0.0216, 'lps'),
	(420884, 102, '2015-03-01 00:54:33.000000', 'consum', 0.0214, 'lps'),
	(420885, 102, '2015-03-01 00:54:34.000000', 'consum', 0.0213, 'lps'),
	(420886, 102, '2015-03-01 00:54:35.000000', 'consum', 0.0211, 'lps'),
	(420887, 102, '2015-03-01 00:54:36.000000', 'consum', 0.0226, 'lps'),
	(420888, 102, '2015-03-01 00:54:37.000000', 'consum', 0.0228, 'lps'),
	(420889, 102, '2015-03-01 00:54:38.000000', 'consum', 0.0214, 'lps'),
	(420890, 102, '2015-03-01 00:54:39.000000', 'consum', 0.0214, 'lps'),
	(420891, 102, '2015-03-01 00:54:40.000000', 'consum', 0.0222, 'lps'),
	(420892, 102, '2015-03-01 00:54:41.000000', 'consum', 0.0215, 'lps'),
	(420893, 102, '2015-03-01 00:54:42.000000', 'consum', 0.0222, 'lps'),
	(420894, 102, '2015-03-01 00:54:43.000000', 'consum', 0.0216, 'lps'),
	(420895, 102, '2015-03-01 00:54:44.000000', 'consum', 0.0225, 'lps'),
	(420896, 102, '2015-03-01 00:54:45.000000', 'consum', 0.0226, 'lps'),
	(420897, 102, '2015-03-01 00:54:46.000000', 'consum', 0.0227, 'lps'),
	(420898, 102, '2015-03-01 00:54:47.000000', 'consum', 0.0229, 'lps'),
	(420899, 102, '2015-03-01 00:54:48.000000', 'consum', 0.0212, 'lps'),
	(420900, 102, '2015-03-01 00:54:49.000000', 'consum', 0.0224, 'lps'),
	(420901, 102, '2015-03-01 00:54:50.000000', 'consum', 0.0213, 'lps'),
	(420902, 102, '2015-03-01 00:54:51.000000', 'consum', 0.0223, 'lps'),
	(420903, 102, '2015-03-01 00:54:52.000000', 'consum', 0.0227, 'lps'),
	(420904, 102, '2015-03-01 00:54:53.000000', 'consum', 0.0218, 'lps'),
	(420905, 102, '2015-03-01 00:54:54.000000', 'consum', 0.0218, 'lps'),
	(420906, 102, '2015-03-01 00:54:55.000000', 'consum', 0.0227, 'lps'),
	(420907, 102, '2015-03-01 00:54:56.000000', 'consum', 0.0213, 'lps'),
	(420908, 102, '2015-03-01 00:54:57.000000', 'consum', 0.0212, 'lps'),
	(420909, 102, '2015-03-01 00:54:58.000000', 'consum', 0.0212, 'lps'),
	(420910, 102, '2015-03-01 00:54:59.000000', 'consum', 0.0214, 'lps'),
	(420911, 102, '2015-03-01 00:55:00.000000', 'consum', 0.0224, 'lps'),
	(420912, 102, '2015-03-01 00:55:01.000000', 'consum', 0.0211, 'lps'),
	(420913, 102, '2015-03-01 00:55:02.000000', 'consum', 0.0210, 'lps'),
	(420914, 102, '2015-03-01 00:55:03.000000', 'consum', 0.0210, 'lps'),
	(420915, 102, '2015-03-01 00:55:04.000000', 'consum', 0.0210, 'lps'),
	(420916, 102, '2015-03-01 00:55:05.000000', 'consum', 0.0211, 'lps'),
	(420917, 102, '2015-03-01 00:55:06.000000', 'consum', 0.0215, 'lps'),
	(420918, 102, '2015-03-01 00:55:07.000000', 'consum', 0.0213, 'lps'),
	(420919, 102, '2015-03-01 00:55:08.000000', 'consum', 0.0211, 'lps'),
	(420920, 102, '2015-03-01 00:55:09.000000', 'consum', 0.0228, 'lps'),
	(420921, 102, '2015-03-01 00:55:10.000000', 'consum', 0.0216, 'lps'),
	(420922, 102, '2015-03-01 00:55:11.000000', 'consum', 0.0227, 'lps'),
	(420923, 102, '2015-03-01 00:55:12.000000', 'consum', 0.0218, 'lps'),
	(420924, 102, '2015-03-01 00:55:13.000000', 'consum', 0.0220, 'lps'),
	(420925, 102, '2015-03-01 00:55:14.000000', 'consum', 0.0216, 'lps'),
	(420926, 102, '2015-03-01 00:55:15.000000', 'consum', 0.0229, 'lps'),
	(420927, 102, '2015-03-01 00:55:16.000000', 'consum', 0.0211, 'lps'),
	(420928, 102, '2015-03-01 00:55:17.000000', 'consum', 0.0215, 'lps'),
	(420929, 102, '2015-03-01 00:55:18.000000', 'consum', 0.0213, 'lps'),
	(420930, 102, '2015-03-01 00:55:19.000000', 'consum', 0.0229, 'lps'),
	(420931, 102, '2015-03-01 00:55:20.000000', 'consum', 0.0218, 'lps'),
	(420932, 102, '2015-03-01 00:55:21.000000', 'consum', 0.0214, 'lps'),
	(420933, 102, '2015-03-01 00:55:22.000000', 'consum', 0.0225, 'lps'),
	(420934, 102, '2015-03-01 00:55:23.000000', 'consum', 0.0213, 'lps'),
	(420935, 102, '2015-03-01 00:55:24.000000', 'consum', 0.0221, 'lps'),
	(420936, 102, '2015-03-01 00:55:25.000000', 'consum', 0.0218, 'lps'),
	(420937, 102, '2015-03-01 00:55:26.000000', 'consum', 0.0218, 'lps'),
	(420938, 102, '2015-03-01 00:55:27.000000', 'consum', 0.0227, 'lps'),
	(420939, 102, '2015-03-01 00:55:28.000000', 'consum', 0.0211, 'lps'),
	(420940, 102, '2015-03-01 00:55:29.000000', 'consum', 0.0226, 'lps'),
	(420941, 102, '2015-03-01 00:55:30.000000', 'consum', 0.0224, 'lps'),
	(420942, 102, '2015-03-01 00:55:31.000000', 'consum', 0.0216, 'lps'),
	(420943, 102, '2015-03-01 00:55:32.000000', 'consum', 0.0218, 'lps'),
	(420944, 102, '2015-03-01 00:55:33.000000', 'consum', 0.0211, 'lps'),
	(420945, 102, '2015-03-01 00:55:34.000000', 'consum', 0.0211, 'lps'),
	(420946, 102, '2015-03-01 00:55:35.000000', 'consum', 0.0215, 'lps'),
	(420947, 102, '2015-03-01 00:55:36.000000', 'consum', 0.0229, 'lps'),
	(420948, 102, '2015-03-01 00:55:37.000000', 'consum', 0.0214, 'lps'),
	(420949, 102, '2015-03-01 00:55:38.000000', 'consum', 0.0210, 'lps'),
	(420950, 102, '2015-03-01 00:55:39.000000', 'consum', 0.0221, 'lps'),
	(420951, 102, '2015-03-01 00:55:40.000000', 'consum', 0.0224, 'lps'),
	(420952, 102, '2015-03-01 00:55:41.000000', 'consum', 0.0228, 'lps'),
	(420953, 102, '2015-03-01 00:55:42.000000', 'consum', 0.0218, 'lps'),
	(420954, 102, '2015-03-01 00:55:43.000000', 'consum', 0.0217, 'lps'),
	(420955, 102, '2015-03-01 00:55:44.000000', 'consum', 0.0223, 'lps'),
	(420956, 102, '2015-03-01 00:55:45.000000', 'consum', 0.0213, 'lps'),
	(420957, 102, '2015-03-01 00:55:46.000000', 'consum', 0.0227, 'lps'),
	(420958, 102, '2015-03-01 00:55:47.000000', 'consum', 0.0225, 'lps'),
	(420959, 102, '2015-03-01 00:55:48.000000', 'consum', 0.0215, 'lps'),
	(420960, 102, '2015-03-01 00:55:49.000000', 'consum', 0.0212, 'lps'),
	(420961, 102, '2015-03-01 00:55:50.000000', 'consum', 0.0225, 'lps'),
	(420962, 102, '2015-03-01 00:55:51.000000', 'consum', 0.0217, 'lps'),
	(420963, 102, '2015-03-01 00:55:52.000000', 'consum', 0.0224, 'lps'),
	(420964, 102, '2015-03-01 00:55:53.000000', 'consum', 0.0217, 'lps'),
	(420965, 102, '2015-03-01 00:55:54.000000', 'consum', 0.0224, 'lps'),
	(420966, 102, '2015-03-01 00:55:55.000000', 'consum', 0.0221, 'lps'),
	(420967, 102, '2015-03-01 00:55:56.000000', 'consum', 0.0223, 'lps'),
	(420968, 102, '2015-03-01 00:55:57.000000', 'consum', 0.0224, 'lps'),
	(420969, 102, '2015-03-01 00:55:58.000000', 'consum', 0.0219, 'lps'),
	(420970, 102, '2015-03-01 00:55:59.000000', 'consum', 0.0213, 'lps'),
	(420971, 102, '2015-03-01 00:56:00.000000', 'consum', 0.0218, 'lps'),
	(420972, 102, '2015-03-01 00:56:01.000000', 'consum', 0.0224, 'lps'),
	(420973, 102, '2015-03-01 00:56:02.000000', 'consum', 0.0214, 'lps'),
	(420974, 102, '2015-03-01 00:56:03.000000', 'consum', 0.0212, 'lps'),
	(420975, 102, '2015-03-01 00:56:04.000000', 'consum', 0.0225, 'lps'),
	(420976, 102, '2015-03-01 00:56:05.000000', 'consum', 0.0222, 'lps'),
	(420977, 102, '2015-03-01 00:56:06.000000', 'consum', 0.0225, 'lps'),
	(420978, 102, '2015-03-01 00:56:07.000000', 'consum', 0.0211, 'lps'),
	(420979, 102, '2015-03-01 00:56:08.000000', 'consum', 0.0228, 'lps'),
	(420980, 102, '2015-03-01 00:56:09.000000', 'consum', 0.0220, 'lps'),
	(420981, 102, '2015-03-01 00:56:10.000000', 'consum', 0.0225, 'lps'),
	(420982, 102, '2015-03-01 00:56:11.000000', 'consum', 0.0218, 'lps'),
	(420983, 102, '2015-03-01 00:56:12.000000', 'consum', 0.0223, 'lps'),
	(420984, 102, '2015-03-01 00:56:13.000000', 'consum', 0.0211, 'lps'),
	(420985, 102, '2015-03-01 00:56:14.000000', 'consum', 0.0217, 'lps'),
	(420986, 102, '2015-03-01 00:56:15.000000', 'consum', 0.0222, 'lps'),
	(420987, 102, '2015-03-01 00:56:16.000000', 'consum', 0.0211, 'lps'),
	(420988, 102, '2015-03-01 00:56:17.000000', 'consum', 0.0220, 'lps'),
	(420989, 102, '2015-03-01 00:56:18.000000', 'consum', 0.0216, 'lps'),
	(420990, 102, '2015-03-01 00:56:19.000000', 'consum', 0.0212, 'lps'),
	(420991, 102, '2015-03-01 00:56:20.000000', 'consum', 0.0220, 'lps'),
	(420992, 102, '2015-03-01 00:56:21.000000', 'consum', 0.0214, 'lps'),
	(420993, 102, '2015-03-01 00:56:22.000000', 'consum', 0.0223, 'lps'),
	(420994, 102, '2015-03-01 00:56:23.000000', 'consum', 0.0224, 'lps'),
	(420995, 102, '2015-03-01 00:56:24.000000', 'consum', 0.0221, 'lps'),
	(420996, 102, '2015-03-01 00:56:25.000000', 'consum', 0.0224, 'lps'),
	(420997, 102, '2015-03-01 00:56:26.000000', 'consum', 0.0226, 'lps'),
	(420998, 102, '2015-03-01 00:56:27.000000', 'consum', 0.0229, 'lps'),
	(420999, 102, '2015-03-01 00:56:28.000000', 'consum', 0.0218, 'lps'),
	(421000, 102, '2015-03-01 00:56:29.000000', 'consum', 0.0214, 'lps'),
	(421001, 102, '2015-03-01 00:56:30.000000', 'consum', 0.0226, 'lps'),
	(421002, 102, '2015-03-01 00:56:31.000000', 'consum', 0.0219, 'lps'),
	(421003, 102, '2015-03-01 00:56:32.000000', 'consum', 0.0227, 'lps'),
	(421004, 102, '2015-03-01 00:56:33.000000', 'consum', 0.0227, 'lps'),
	(421005, 102, '2015-03-01 00:56:34.000000', 'consum', 0.0227, 'lps'),
	(421006, 102, '2015-03-01 00:56:35.000000', 'consum', 0.0224, 'lps'),
	(421007, 102, '2015-03-01 00:56:36.000000', 'consum', 0.0211, 'lps'),
	(421008, 102, '2015-03-01 00:56:37.000000', 'consum', 0.0213, 'lps'),
	(421009, 102, '2015-03-01 00:56:38.000000', 'consum', 0.0222, 'lps'),
	(421010, 102, '2015-03-01 00:56:39.000000', 'consum', 0.0220, 'lps'),
	(421011, 102, '2015-03-01 00:56:40.000000', 'consum', 0.0227, 'lps'),
	(421012, 102, '2015-03-01 00:56:41.000000', 'consum', 0.0224, 'lps'),
	(421013, 102, '2015-03-01 00:56:42.000000', 'consum', 0.0228, 'lps'),
	(421014, 102, '2015-03-01 00:56:43.000000', 'consum', 0.0220, 'lps'),
	(421015, 102, '2015-03-01 00:56:44.000000', 'consum', 0.0225, 'lps'),
	(421016, 102, '2015-03-01 00:56:45.000000', 'consum', 0.0215, 'lps'),
	(421017, 102, '2015-03-01 00:56:46.000000', 'consum', 0.0211, 'lps'),
	(421018, 102, '2015-03-01 00:56:47.000000', 'consum', 0.0223, 'lps'),
	(421019, 102, '2015-03-01 00:56:48.000000', 'consum', 0.0210, 'lps'),
	(421020, 102, '2015-03-01 00:56:49.000000', 'consum', 0.0211, 'lps'),
	(421021, 102, '2015-03-01 00:56:50.000000', 'consum', 0.0218, 'lps'),
	(421022, 102, '2015-03-01 00:56:51.000000', 'consum', 0.0225, 'lps'),
	(421023, 102, '2015-03-01 00:56:52.000000', 'consum', 0.0224, 'lps'),
	(421024, 102, '2015-03-01 00:56:53.000000', 'consum', 0.0216, 'lps'),
	(421025, 102, '2015-03-01 00:56:54.000000', 'consum', 0.0219, 'lps'),
	(421026, 102, '2015-03-01 00:56:55.000000', 'consum', 0.0218, 'lps'),
	(421027, 102, '2015-03-01 00:56:56.000000', 'consum', 0.0221, 'lps'),
	(421028, 102, '2015-03-01 00:56:57.000000', 'consum', 0.0224, 'lps'),
	(421029, 102, '2015-03-01 00:56:58.000000', 'consum', 0.0227, 'lps'),
	(421030, 102, '2015-03-01 00:56:59.000000', 'consum', 0.0211, 'lps'),
	(421031, 102, '2015-03-01 00:57:00.000000', 'consum', 0.0228, 'lps'),
	(421032, 102, '2015-03-01 00:57:01.000000', 'consum', 0.0216, 'lps'),
	(421033, 102, '2015-03-01 00:57:02.000000', 'consum', 0.0224, 'lps'),
	(421034, 102, '2015-03-01 00:57:03.000000', 'consum', 0.0226, 'lps'),
	(421035, 102, '2015-03-01 00:57:04.000000', 'consum', 0.0228, 'lps'),
	(421036, 102, '2015-03-01 00:57:05.000000', 'consum', 0.0211, 'lps'),
	(421037, 102, '2015-03-01 00:57:06.000000', 'consum', 0.0224, 'lps'),
	(421038, 102, '2015-03-01 00:57:07.000000', 'consum', 0.0217, 'lps'),
	(421039, 102, '2015-03-01 00:57:08.000000', 'consum', 0.0223, 'lps'),
	(421040, 102, '2015-03-01 00:57:09.000000', 'consum', 0.0215, 'lps'),
	(421041, 102, '2015-03-01 00:57:10.000000', 'consum', 0.0216, 'lps'),
	(421042, 102, '2015-03-01 00:57:11.000000', 'consum', 0.0227, 'lps'),
	(421043, 102, '2015-03-01 00:57:12.000000', 'consum', 0.0215, 'lps'),
	(421044, 102, '2015-03-01 00:57:13.000000', 'consum', 0.0227, 'lps'),
	(421045, 102, '2015-03-01 00:57:14.000000', 'consum', 0.0219, 'lps'),
	(421046, 102, '2015-03-01 00:57:15.000000', 'consum', 0.0224, 'lps'),
	(421047, 102, '2015-03-01 00:57:16.000000', 'consum', 0.0216, 'lps'),
	(421048, 102, '2015-03-01 00:57:17.000000', 'consum', 0.0217, 'lps'),
	(421049, 102, '2015-03-01 00:57:18.000000', 'consum', 0.0227, 'lps'),
	(421050, 102, '2015-03-01 00:57:19.000000', 'consum', 0.0214, 'lps'),
	(421051, 102, '2015-03-01 00:57:20.000000', 'consum', 0.0222, 'lps'),
	(421052, 102, '2015-03-01 00:57:21.000000', 'consum', 0.0217, 'lps'),
	(421053, 102, '2015-03-01 00:57:22.000000', 'consum', 0.0228, 'lps'),
	(421054, 102, '2015-03-01 00:57:23.000000', 'consum', 0.0219, 'lps'),
	(421055, 102, '2015-03-01 00:57:24.000000', 'consum', 0.0222, 'lps'),
	(421056, 102, '2015-03-01 00:57:25.000000', 'consum', 0.0222, 'lps'),
	(421057, 102, '2015-03-01 00:57:26.000000', 'consum', 0.0217, 'lps'),
	(421058, 102, '2015-03-01 00:57:27.000000', 'consum', 0.0229, 'lps'),
	(421059, 102, '2015-03-01 00:57:28.000000', 'consum', 0.0222, 'lps'),
	(421060, 102, '2015-03-01 00:57:29.000000', 'consum', 0.0216, 'lps'),
	(421061, 102, '2015-03-01 00:57:30.000000', 'consum', 0.0224, 'lps'),
	(421062, 102, '2015-03-01 00:57:31.000000', 'consum', 0.0222, 'lps'),
	(421063, 102, '2015-03-01 00:57:32.000000', 'consum', 0.0211, 'lps'),
	(421064, 102, '2015-03-01 00:57:33.000000', 'consum', 0.0217, 'lps'),
	(421065, 102, '2015-03-01 00:57:34.000000', 'consum', 0.0224, 'lps'),
	(421066, 102, '2015-03-01 00:57:35.000000', 'consum', 0.0220, 'lps'),
	(421067, 102, '2015-03-01 00:57:36.000000', 'consum', 0.0218, 'lps'),
	(421068, 102, '2015-03-01 00:57:37.000000', 'consum', 0.0219, 'lps'),
	(421069, 102, '2015-03-01 00:57:38.000000', 'consum', 0.0213, 'lps'),
	(421070, 102, '2015-03-01 00:57:39.000000', 'consum', 0.0216, 'lps'),
	(421071, 102, '2015-03-01 00:57:40.000000', 'consum', 0.0215, 'lps'),
	(421072, 102, '2015-03-01 00:57:41.000000', 'consum', 0.0215, 'lps'),
	(421073, 102, '2015-03-01 00:57:42.000000', 'consum', 0.0221, 'lps'),
	(421074, 102, '2015-03-01 00:57:43.000000', 'consum', 0.0213, 'lps'),
	(421075, 102, '2015-03-01 00:57:44.000000', 'consum', 0.0210, 'lps'),
	(421076, 102, '2015-03-01 00:57:45.000000', 'consum', 0.0221, 'lps'),
	(421077, 102, '2015-03-01 00:57:46.000000', 'consum', 0.0226, 'lps'),
	(421078, 102, '2015-03-01 00:57:47.000000', 'consum', 0.0217, 'lps'),
	(421079, 102, '2015-03-01 00:57:48.000000', 'consum', 0.0220, 'lps'),
	(421080, 102, '2015-03-01 00:57:49.000000', 'consum', 0.0217, 'lps'),
	(421081, 102, '2015-03-01 00:57:50.000000', 'consum', 0.0217, 'lps'),
	(421082, 102, '2015-03-01 00:57:51.000000', 'consum', 0.0226, 'lps'),
	(421083, 102, '2015-03-01 00:57:52.000000', 'consum', 0.0228, 'lps'),
	(421084, 102, '2015-03-01 00:57:53.000000', 'consum', 0.0212, 'lps'),
	(421085, 102, '2015-03-01 00:57:54.000000', 'consum', 0.0227, 'lps'),
	(421086, 102, '2015-03-01 00:57:55.000000', 'consum', 0.0229, 'lps'),
	(421087, 102, '2015-03-01 00:57:56.000000', 'consum', 0.0216, 'lps'),
	(421088, 102, '2015-03-01 00:57:57.000000', 'consum', 0.0223, 'lps'),
	(421089, 102, '2015-03-01 00:57:58.000000', 'consum', 0.0218, 'lps'),
	(421090, 102, '2015-03-01 00:57:59.000000', 'consum', 0.0212, 'lps'),
	(421091, 102, '2015-03-01 00:58:00.000000', 'consum', 0.0216, 'lps'),
	(421092, 102, '2015-03-01 00:58:01.000000', 'consum', 0.0215, 'lps'),
	(421093, 102, '2015-03-01 00:58:02.000000', 'consum', 0.0219, 'lps'),
	(421094, 102, '2015-03-01 00:58:03.000000', 'consum', 0.0220, 'lps'),
	(421095, 102, '2015-03-01 00:58:04.000000', 'consum', 0.0211, 'lps'),
	(421096, 102, '2015-03-01 00:58:05.000000', 'consum', 0.0228, 'lps'),
	(421097, 102, '2015-03-01 00:58:06.000000', 'consum', 0.0217, 'lps'),
	(421098, 102, '2015-03-01 00:58:07.000000', 'consum', 0.0212, 'lps'),
	(421099, 102, '2015-03-01 00:58:08.000000', 'consum', 0.0221, 'lps'),
	(421100, 102, '2015-03-01 00:58:09.000000', 'consum', 0.0218, 'lps'),
	(421101, 102, '2015-03-01 00:58:10.000000', 'consum', 0.0217, 'lps'),
	(421102, 102, '2015-03-01 00:58:11.000000', 'consum', 0.0221, 'lps'),
	(421103, 102, '2015-03-01 00:58:12.000000', 'consum', 0.0227, 'lps'),
	(421104, 102, '2015-03-01 00:58:13.000000', 'consum', 0.0222, 'lps'),
	(421105, 102, '2015-03-01 00:58:14.000000', 'consum', 0.0217, 'lps'),
	(421106, 102, '2015-03-01 00:58:15.000000', 'consum', 0.0211, 'lps'),
	(421107, 102, '2015-03-01 00:58:16.000000', 'consum', 0.0213, 'lps'),
	(421108, 102, '2015-03-01 00:58:17.000000', 'consum', 0.0224, 'lps'),
	(421109, 102, '2015-03-01 00:58:18.000000', 'consum', 0.0210, 'lps'),
	(421110, 102, '2015-03-01 00:58:19.000000', 'consum', 0.0210, 'lps'),
	(421111, 102, '2015-03-01 00:58:20.000000', 'consum', 0.0228, 'lps'),
	(421112, 102, '2015-03-01 00:58:21.000000', 'consum', 0.0222, 'lps'),
	(421113, 102, '2015-03-01 00:58:22.000000', 'consum', 0.0214, 'lps'),
	(421114, 102, '2015-03-01 00:58:23.000000', 'consum', 0.0218, 'lps'),
	(421115, 102, '2015-03-01 00:58:24.000000', 'consum', 0.0217, 'lps'),
	(421116, 102, '2015-03-01 00:58:25.000000', 'consum', 0.0221, 'lps'),
	(421117, 102, '2015-03-01 00:58:26.000000', 'consum', 0.0226, 'lps'),
	(421118, 102, '2015-03-01 00:58:27.000000', 'consum', 0.0217, 'lps'),
	(421119, 102, '2015-03-01 00:58:28.000000', 'consum', 0.0217, 'lps'),
	(421120, 102, '2015-03-01 00:58:29.000000', 'consum', 0.0226, 'lps'),
	(421121, 102, '2015-03-01 00:58:30.000000', 'consum', 0.0229, 'lps'),
	(421122, 102, '2015-03-01 00:58:31.000000', 'consum', 0.0219, 'lps'),
	(421123, 102, '2015-03-01 00:58:32.000000', 'consum', 0.0218, 'lps'),
	(421124, 102, '2015-03-01 00:58:33.000000', 'consum', 0.0223, 'lps'),
	(421125, 102, '2015-03-01 00:58:34.000000', 'consum', 0.0210, 'lps'),
	(421126, 102, '2015-03-01 00:58:35.000000', 'consum', 0.0213, 'lps'),
	(421127, 102, '2015-03-01 00:58:36.000000', 'consum', 0.0225, 'lps'),
	(421128, 102, '2015-03-01 00:58:37.000000', 'consum', 0.0217, 'lps'),
	(421129, 102, '2015-03-01 00:58:38.000000', 'consum', 0.0220, 'lps'),
	(421130, 102, '2015-03-01 00:58:39.000000', 'consum', 0.0219, 'lps'),
	(421131, 102, '2015-03-01 00:58:40.000000', 'consum', 0.0225, 'lps'),
	(421132, 102, '2015-03-01 00:58:41.000000', 'consum', 0.0220, 'lps'),
	(421133, 102, '2015-03-01 00:58:42.000000', 'consum', 0.0213, 'lps'),
	(421134, 102, '2015-03-01 00:58:43.000000', 'consum', 0.0218, 'lps'),
	(421135, 102, '2015-03-01 00:58:44.000000', 'consum', 0.0222, 'lps'),
	(421136, 102, '2015-03-01 00:58:45.000000', 'consum', 0.0224, 'lps'),
	(421137, 102, '2015-03-01 00:58:46.000000', 'consum', 0.0226, 'lps'),
	(421138, 102, '2015-03-01 00:58:47.000000', 'consum', 0.0227, 'lps'),
	(421139, 102, '2015-03-01 00:58:48.000000', 'consum', 0.0210, 'lps'),
	(421140, 102, '2015-03-01 00:58:49.000000', 'consum', 0.0219, 'lps'),
	(421141, 102, '2015-03-01 00:58:50.000000', 'consum', 0.0215, 'lps'),
	(421142, 102, '2015-03-01 00:58:51.000000', 'consum', 0.0229, 'lps'),
	(421143, 102, '2015-03-01 00:58:52.000000', 'consum', 0.0211, 'lps'),
	(421144, 102, '2015-03-01 00:58:53.000000', 'consum', 0.0216, 'lps'),
	(421145, 102, '2015-03-01 00:58:54.000000', 'consum', 0.0220, 'lps'),
	(421146, 102, '2015-03-01 00:58:55.000000', 'consum', 0.0223, 'lps'),
	(421147, 102, '2015-03-01 00:58:56.000000', 'consum', 0.0223, 'lps'),
	(421148, 102, '2015-03-01 00:58:57.000000', 'consum', 0.0219, 'lps'),
	(421149, 102, '2015-03-01 00:58:58.000000', 'consum', 0.0218, 'lps'),
	(421150, 102, '2015-03-01 00:58:59.000000', 'consum', 0.0220, 'lps'),
	(421151, 102, '2015-03-01 00:59:00.000000', 'consum', 0.0219, 'lps'),
	(421152, 102, '2015-03-01 00:59:01.000000', 'consum', 0.0223, 'lps'),
	(421153, 102, '2015-03-01 00:59:02.000000', 'consum', 0.0211, 'lps'),
	(421154, 102, '2015-03-01 00:59:03.000000', 'consum', 0.0215, 'lps'),
	(421155, 102, '2015-03-01 00:59:04.000000', 'consum', 0.0212, 'lps'),
	(421156, 102, '2015-03-01 00:59:05.000000', 'consum', 0.0225, 'lps'),
	(421157, 102, '2015-03-01 00:59:06.000000', 'consum', 0.0222, 'lps'),
	(421158, 102, '2015-03-01 00:59:07.000000', 'consum', 0.0225, 'lps'),
	(421159, 102, '2015-03-01 00:59:08.000000', 'consum', 0.0210, 'lps'),
	(421160, 102, '2015-03-01 00:59:09.000000', 'consum', 0.0224, 'lps'),
	(421161, 102, '2015-03-01 00:59:10.000000', 'consum', 0.0220, 'lps'),
	(421162, 102, '2015-03-01 00:59:11.000000', 'consum', 0.0218, 'lps'),
	(421163, 102, '2015-03-01 00:59:12.000000', 'consum', 0.0222, 'lps'),
	(421164, 102, '2015-03-01 00:59:13.000000', 'consum', 0.0226, 'lps'),
	(421165, 102, '2015-03-01 00:59:14.000000', 'consum', 0.0215, 'lps'),
	(421166, 102, '2015-03-01 00:59:15.000000', 'consum', 0.0229, 'lps'),
	(421167, 102, '2015-03-01 00:59:16.000000', 'consum', 0.0210, 'lps'),
	(421168, 102, '2015-03-01 00:59:17.000000', 'consum', 0.0214, 'lps'),
	(421169, 102, '2015-03-01 00:59:18.000000', 'consum', 0.0211, 'lps'),
	(421170, 102, '2015-03-01 00:59:19.000000', 'consum', 0.0221, 'lps'),
	(421171, 102, '2015-03-01 00:59:20.000000', 'consum', 0.0225, 'lps'),
	(421172, 102, '2015-03-01 00:59:21.000000', 'consum', 0.0212, 'lps'),
	(421173, 102, '2015-03-01 00:59:22.000000', 'consum', 0.0214, 'lps'),
	(421174, 102, '2015-03-01 00:59:23.000000', 'consum', 0.0226, 'lps'),
	(421175, 102, '2015-03-01 00:59:24.000000', 'consum', 0.0218, 'lps'),
	(421176, 102, '2015-03-01 00:59:25.000000', 'consum', 0.0222, 'lps'),
	(421177, 102, '2015-03-01 00:59:26.000000', 'consum', 0.0228, 'lps'),
	(421178, 102, '2015-03-01 00:59:27.000000', 'consum', 0.0222, 'lps'),
	(421179, 102, '2015-03-01 00:59:28.000000', 'consum', 0.0218, 'lps'),
	(421180, 102, '2015-03-01 00:59:29.000000', 'consum', 0.0213, 'lps'),
	(421181, 102, '2015-03-01 00:59:30.000000', 'consum', 0.0222, 'lps'),
	(421182, 102, '2015-03-01 00:59:31.000000', 'consum', 0.0224, 'lps'),
	(421183, 102, '2015-03-01 00:59:32.000000', 'consum', 0.0222, 'lps'),
	(421184, 102, '2015-03-01 00:59:33.000000', 'consum', 0.0211, 'lps'),
	(421185, 102, '2015-03-01 00:59:34.000000', 'consum', 0.0217, 'lps'),
	(421186, 102, '2015-03-01 00:59:35.000000', 'consum', 0.0224, 'lps'),
	(421187, 102, '2015-03-01 00:59:36.000000', 'consum', 0.0218, 'lps'),
	(421188, 102, '2015-03-01 00:59:37.000000', 'consum', 0.0211, 'lps'),
	(421189, 102, '2015-03-01 00:59:38.000000', 'consum', 0.0211, 'lps'),
	(421190, 102, '2015-03-01 00:59:39.000000', 'consum', 0.0213, 'lps'),
	(421191, 102, '2015-03-01 00:59:40.000000', 'consum', 0.0221, 'lps'),
	(421192, 102, '2015-03-01 00:59:41.000000', 'consum', 0.0215, 'lps'),
	(421193, 102, '2015-03-01 00:59:42.000000', 'consum', 0.0226, 'lps'),
	(421194, 102, '2015-03-01 00:59:43.000000', 'consum', 0.0213, 'lps'),
	(421195, 102, '2015-03-01 00:59:44.000000', 'consum', 0.0219, 'lps'),
	(421196, 102, '2015-03-01 00:59:45.000000', 'consum', 0.0226, 'lps'),
	(421197, 102, '2015-03-01 00:59:46.000000', 'consum', 0.0225, 'lps'),
	(421198, 102, '2015-03-01 00:59:47.000000', 'consum', 0.0215, 'lps'),
	(421199, 102, '2015-03-01 00:59:48.000000', 'consum', 0.0210, 'lps'),
	(421200, 102, '2015-03-01 00:59:49.000000', 'consum', 0.0218, 'lps'),
	(421201, 102, '2015-03-01 00:59:50.000000', 'consum', 0.0210, 'lps'),
	(421202, 102, '2015-03-01 00:59:51.000000', 'consum', 0.0224, 'lps'),
	(421203, 102, '2015-03-01 00:59:52.000000', 'consum', 0.0222, 'lps'),
	(421204, 102, '2015-03-01 00:59:53.000000', 'consum', 0.0229, 'lps'),
	(421205, 102, '2015-03-01 00:59:54.000000', 'consum', 0.0210, 'lps'),
	(421206, 102, '2015-03-01 00:59:55.000000', 'consum', 0.0211, 'lps'),
	(421207, 102, '2015-03-01 00:59:56.000000', 'consum', 0.0217, 'lps'),
	(421208, 102, '2015-03-01 00:59:57.000000', 'consum', 0.0223, 'lps'),
	(421209, 102, '2015-03-01 00:59:58.000000', 'consum', 0.0215, 'lps'),
	(421210, 102, '2015-03-01 00:59:59.000000', 'consum', 0.0216, 'lps'),
	(421211, 102, '2015-03-01 01:00:00.000000', 'consum', 0.0224, 'lps'),
	(421212, 102, '2015-03-01 01:00:01.000000', 'consum', 0.0225, 'lps'),
	(421213, 102, '2015-03-01 01:00:02.000000', 'consum', 0.0222, 'lps'),
	(421214, 102, '2015-03-01 01:00:03.000000', 'consum', 0.0226, 'lps'),
	(421215, 102, '2015-03-01 01:00:04.000000', 'consum', 0.0213, 'lps'),
	(421216, 102, '2015-03-01 01:00:05.000000', 'consum', 0.0217, 'lps'),
	(421217, 102, '2015-03-01 01:00:06.000000', 'consum', 0.0219, 'lps'),
	(421218, 102, '2015-03-01 01:00:07.000000', 'consum', 0.0213, 'lps'),
	(421219, 102, '2015-03-01 01:00:08.000000', 'consum', 0.0219, 'lps'),
	(421220, 102, '2015-03-01 01:00:09.000000', 'consum', 0.0228, 'lps'),
	(421221, 102, '2015-03-01 01:00:10.000000', 'consum', 0.0213, 'lps'),
	(421222, 102, '2015-03-01 01:00:11.000000', 'consum', 0.0229, 'lps'),
	(421223, 102, '2015-03-01 01:00:12.000000', 'consum', 0.0219, 'lps'),
	(421224, 102, '2015-03-01 01:00:13.000000', 'consum', 0.0220, 'lps'),
	(421225, 102, '2015-03-01 01:00:14.000000', 'consum', 0.0211, 'lps'),
	(421226, 102, '2015-03-01 01:00:15.000000', 'consum', 0.0227, 'lps'),
	(421227, 102, '2015-03-01 01:00:16.000000', 'consum', 0.0213, 'lps'),
	(421228, 102, '2015-03-01 01:00:17.000000', 'consum', 0.0214, 'lps'),
	(421229, 102, '2015-03-01 01:00:18.000000', 'consum', 0.0220, 'lps'),
	(421230, 102, '2015-03-01 01:00:19.000000', 'consum', 0.0210, 'lps'),
	(421231, 102, '2015-03-01 01:00:20.000000', 'consum', 0.0221, 'lps'),
	(421232, 102, '2015-03-01 01:00:21.000000', 'consum', 0.0225, 'lps'),
	(421233, 102, '2015-03-01 01:00:22.000000', 'consum', 0.0212, 'lps'),
	(421234, 102, '2015-03-01 01:00:23.000000', 'consum', 0.0217, 'lps'),
	(421235, 102, '2015-03-01 01:00:24.000000', 'consum', 0.0217, 'lps'),
	(421236, 102, '2015-03-01 01:00:25.000000', 'consum', 0.0228, 'lps'),
	(421237, 102, '2015-03-01 01:00:26.000000', 'consum', 0.0216, 'lps'),
	(421238, 102, '2015-03-01 01:00:27.000000', 'consum', 0.0229, 'lps'),
	(421239, 102, '2015-03-01 01:00:28.000000', 'consum', 0.0228, 'lps'),
	(421240, 102, '2015-03-01 01:00:29.000000', 'consum', 0.0220, 'lps'),
	(421241, 102, '2015-03-01 01:00:30.000000', 'consum', 0.0210, 'lps'),
	(421242, 102, '2015-03-01 01:00:31.000000', 'consum', 0.0220, 'lps'),
	(421243, 102, '2015-03-01 01:00:32.000000', 'consum', 0.0219, 'lps'),
	(421244, 102, '2015-03-01 01:00:33.000000', 'consum', 0.0226, 'lps'),
	(421245, 102, '2015-03-01 01:00:34.000000', 'consum', 0.0222, 'lps'),
	(421246, 102, '2015-03-01 01:00:35.000000', 'consum', 0.0223, 'lps'),
	(421247, 102, '2015-03-01 01:00:36.000000', 'consum', 0.0222, 'lps'),
	(421248, 102, '2015-03-01 01:00:37.000000', 'consum', 0.0229, 'lps'),
	(421249, 102, '2015-03-01 01:00:38.000000', 'consum', 0.0229, 'lps'),
	(421250, 102, '2015-03-01 01:00:39.000000', 'consum', 0.0229, 'lps'),
	(421251, 102, '2015-03-01 01:00:40.000000', 'consum', 0.0211, 'lps'),
	(421252, 102, '2015-03-01 01:00:41.000000', 'consum', 0.0215, 'lps'),
	(421253, 102, '2015-03-01 01:00:42.000000', 'consum', 0.0214, 'lps'),
	(421254, 102, '2015-03-01 01:00:43.000000', 'consum', 0.0214, 'lps'),
	(421255, 102, '2015-03-01 01:00:44.000000', 'consum', 0.0219, 'lps'),
	(421256, 102, '2015-03-01 01:00:45.000000', 'consum', 0.0224, 'lps'),
	(421257, 102, '2015-03-01 01:00:46.000000', 'consum', 0.0211, 'lps'),
	(421258, 102, '2015-03-01 01:00:47.000000', 'consum', 0.0216, 'lps'),
	(421259, 102, '2015-03-01 01:00:48.000000', 'consum', 0.0218, 'lps'),
	(421260, 102, '2015-03-01 01:00:49.000000', 'consum', 0.0210, 'lps'),
	(421261, 102, '2015-03-01 01:00:50.000000', 'consum', 0.0228, 'lps'),
	(421262, 102, '2015-03-01 01:00:51.000000', 'consum', 0.0218, 'lps'),
	(421263, 102, '2015-03-01 01:00:52.000000', 'consum', 0.0219, 'lps'),
	(421264, 102, '2015-03-01 01:00:53.000000', 'consum', 0.0210, 'lps'),
	(421265, 102, '2015-03-01 01:00:54.000000', 'consum', 0.0225, 'lps'),
	(421266, 102, '2015-03-01 01:00:55.000000', 'consum', 0.0227, 'lps'),
	(421267, 102, '2015-03-01 01:00:56.000000', 'consum', 0.0227, 'lps'),
	(421268, 102, '2015-03-01 01:00:57.000000', 'consum', 0.0227, 'lps'),
	(421269, 102, '2015-03-01 01:00:58.000000', 'consum', 0.0224, 'lps'),
	(421270, 102, '2015-03-01 01:00:59.000000', 'consum', 0.0210, 'lps'),
	(421271, 102, '2015-03-01 01:01:00.000000', 'consum', 0.0226, 'lps'),
	(421272, 102, '2015-03-01 01:01:01.000000', 'consum', 0.0212, 'lps'),
	(421273, 102, '2015-03-01 01:01:02.000000', 'consum', 0.0211, 'lps'),
	(421274, 102, '2015-03-01 01:01:03.000000', 'consum', 0.0212, 'lps'),
	(421275, 102, '2015-03-01 01:01:04.000000', 'consum', 0.0218, 'lps'),
	(421276, 102, '2015-03-01 01:01:05.000000', 'consum', 0.0225, 'lps'),
	(421277, 102, '2015-03-01 01:01:06.000000', 'consum', 0.0219, 'lps'),
	(421278, 102, '2015-03-01 01:01:07.000000', 'consum', 0.0210, 'lps'),
	(421279, 102, '2015-03-01 01:01:08.000000', 'consum', 0.0224, 'lps'),
	(421280, 102, '2015-03-01 01:01:09.000000', 'consum', 0.0220, 'lps'),
	(421281, 102, '2015-03-01 01:01:10.000000', 'consum', 0.0219, 'lps'),
	(421282, 102, '2015-03-01 01:01:11.000000', 'consum', 0.0227, 'lps'),
	(421283, 102, '2015-03-01 01:01:12.000000', 'consum', 0.0226, 'lps'),
	(421284, 102, '2015-03-01 01:01:13.000000', 'consum', 0.0220, 'lps'),
	(421285, 102, '2015-03-01 01:01:14.000000', 'consum', 0.0212, 'lps'),
	(421286, 102, '2015-03-01 01:01:15.000000', 'consum', 0.0210, 'lps'),
	(421287, 102, '2015-03-01 01:01:16.000000', 'consum', 0.0224, 'lps'),
	(421288, 102, '2015-03-01 01:01:17.000000', 'consum', 0.0221, 'lps'),
	(421289, 102, '2015-03-01 01:01:18.000000', 'consum', 0.0223, 'lps'),
	(421290, 102, '2015-03-01 01:01:19.000000', 'consum', 0.0225, 'lps'),
	(421291, 102, '2015-03-01 01:01:20.000000', 'consum', 0.0224, 'lps'),
	(421292, 102, '2015-03-01 01:01:21.000000', 'consum', 0.0215, 'lps'),
	(421293, 102, '2015-03-01 01:01:22.000000', 'consum', 0.0213, 'lps'),
	(421294, 102, '2015-03-01 01:01:23.000000', 'consum', 0.0210, 'lps'),
	(421295, 102, '2015-03-01 01:01:24.000000', 'consum', 0.0223, 'lps'),
	(421296, 102, '2015-03-01 01:01:25.000000', 'consum', 0.0216, 'lps'),
	(421297, 102, '2015-03-01 01:01:26.000000', 'consum', 0.0223, 'lps'),
	(421298, 102, '2015-03-01 01:01:27.000000', 'consum', 0.0214, 'lps'),
	(421299, 102, '2015-03-01 01:01:28.000000', 'consum', 0.0214, 'lps'),
	(421300, 102, '2015-03-01 01:01:29.000000', 'consum', 0.0217, 'lps'),
	(421301, 102, '2015-03-01 01:01:30.000000', 'consum', 0.0214, 'lps'),
	(421302, 102, '2015-03-01 01:01:31.000000', 'consum', 0.0228, 'lps'),
	(421303, 102, '2015-03-01 01:01:32.000000', 'consum', 0.0211, 'lps'),
	(421304, 102, '2015-03-01 01:01:33.000000', 'consum', 0.0219, 'lps'),
	(421305, 102, '2015-03-01 01:01:34.000000', 'consum', 0.0214, 'lps'),
	(421306, 102, '2015-03-01 01:01:35.000000', 'consum', 0.0223, 'lps'),
	(421307, 102, '2015-03-01 01:01:36.000000', 'consum', 0.0225, 'lps'),
	(421308, 102, '2015-03-01 01:01:37.000000', 'consum', 0.0227, 'lps'),
	(421309, 102, '2015-03-01 01:01:38.000000', 'consum', 0.0229, 'lps'),
	(421310, 102, '2015-03-01 01:01:39.000000', 'consum', 0.0216, 'lps'),
	(421311, 102, '2015-03-01 01:01:40.000000', 'consum', 0.0222, 'lps'),
	(421312, 102, '2015-03-01 01:01:41.000000', 'consum', 0.0215, 'lps'),
	(421313, 102, '2015-03-01 01:01:42.000000', 'consum', 0.0216, 'lps'),
	(421314, 102, '2015-03-01 01:01:43.000000', 'consum', 0.0228, 'lps'),
	(421315, 102, '2015-03-01 01:01:44.000000', 'consum', 0.0222, 'lps'),
	(421316, 102, '2015-03-01 01:01:45.000000', 'consum', 0.0216, 'lps'),
	(421317, 102, '2015-03-01 01:01:46.000000', 'consum', 0.0226, 'lps'),
	(421318, 102, '2015-03-01 01:01:47.000000', 'consum', 0.0211, 'lps'),
	(421319, 102, '2015-03-01 01:01:48.000000', 'consum', 0.0210, 'lps'),
	(421320, 102, '2015-03-01 01:01:49.000000', 'consum', 0.0225, 'lps'),
	(421321, 102, '2015-03-01 01:01:50.000000', 'consum', 0.0227, 'lps'),
	(421322, 102, '2015-03-01 01:01:51.000000', 'consum', 0.0212, 'lps'),
	(421323, 102, '2015-03-01 01:01:52.000000', 'consum', 0.0228, 'lps'),
	(421324, 102, '2015-03-01 01:01:53.000000', 'consum', 0.0217, 'lps'),
	(421325, 102, '2015-03-01 01:01:54.000000', 'consum', 0.0228, 'lps'),
	(421326, 102, '2015-03-01 01:01:55.000000', 'consum', 0.0222, 'lps'),
	(421327, 102, '2015-03-01 01:01:56.000000', 'consum', 0.0217, 'lps'),
	(421328, 102, '2015-03-01 01:01:57.000000', 'consum', 0.0210, 'lps'),
	(421329, 102, '2015-03-01 01:01:58.000000', 'consum', 0.0228, 'lps'),
	(421330, 102, '2015-03-01 01:01:59.000000', 'consum', 0.0219, 'lps'),
	(421331, 102, '2015-03-01 01:02:00.000000', 'consum', 0.0223, 'lps'),
	(421332, 102, '2015-03-01 01:02:01.000000', 'consum', 0.0210, 'lps'),
	(421333, 102, '2015-03-01 01:02:02.000000', 'consum', 0.0229, 'lps'),
	(421334, 102, '2015-03-01 01:02:03.000000', 'consum', 0.0228, 'lps'),
	(421335, 102, '2015-03-01 01:02:04.000000', 'consum', 0.0222, 'lps'),
	(421336, 102, '2015-03-01 01:02:05.000000', 'consum', 0.0218, 'lps'),
	(421337, 102, '2015-03-01 01:02:06.000000', 'consum', 0.0213, 'lps'),
	(421338, 102, '2015-03-01 01:02:07.000000', 'consum', 0.0223, 'lps'),
	(421339, 102, '2015-03-01 01:02:08.000000', 'consum', 0.0225, 'lps'),
	(421340, 102, '2015-03-01 01:02:09.000000', 'consum', 0.0227, 'lps'),
	(421341, 102, '2015-03-01 01:02:10.000000', 'consum', 0.0229, 'lps'),
	(421342, 102, '2015-03-01 01:02:11.000000', 'consum', 0.0217, 'lps'),
	(421343, 102, '2015-03-01 01:02:12.000000', 'consum', 0.0227, 'lps'),
	(421344, 102, '2015-03-01 01:02:13.000000', 'consum', 0.0214, 'lps'),
	(421345, 102, '2015-03-01 01:02:14.000000', 'consum', 0.0221, 'lps'),
	(421346, 102, '2015-03-01 01:02:15.000000', 'consum', 0.0211, 'lps'),
	(421347, 102, '2015-03-01 01:02:16.000000', 'consum', 0.0225, 'lps'),
	(421348, 102, '2015-03-01 01:02:17.000000', 'consum', 0.0222, 'lps'),
	(421349, 102, '2015-03-01 01:02:18.000000', 'consum', 0.0224, 'lps'),
	(421350, 102, '2015-03-01 01:02:19.000000', 'consum', 0.0225, 'lps'),
	(421351, 102, '2015-03-01 01:02:20.000000', 'consum', 0.0224, 'lps'),
	(421352, 102, '2015-03-01 01:02:21.000000', 'consum', 0.0214, 'lps'),
	(421353, 102, '2015-03-01 01:02:22.000000', 'consum', 0.0211, 'lps'),
	(421354, 102, '2015-03-01 01:02:23.000000', 'consum', 0.0223, 'lps'),
	(421355, 102, '2015-03-01 01:02:24.000000', 'consum', 0.0213, 'lps'),
	(421356, 102, '2015-03-01 01:02:25.000000', 'consum', 0.0225, 'lps'),
	(421357, 102, '2015-03-01 01:02:26.000000', 'consum', 0.0217, 'lps'),
	(421358, 102, '2015-03-01 01:02:27.000000', 'consum', 0.0221, 'lps'),
	(421359, 102, '2015-03-01 01:02:28.000000', 'consum', 0.0226, 'lps'),
	(421360, 102, '2015-03-01 01:02:29.000000', 'consum', 0.0216, 'lps'),
	(421361, 102, '2015-03-01 01:02:30.000000', 'consum', 0.0214, 'lps'),
	(421362, 102, '2015-03-01 01:02:31.000000', 'consum', 0.0213, 'lps'),
	(421363, 102, '2015-03-01 01:02:32.000000', 'consum', 0.0212, 'lps'),
	(421364, 102, '2015-03-01 01:02:33.000000', 'consum', 0.0213, 'lps'),
	(421365, 102, '2015-03-01 01:02:34.000000', 'consum', 0.0219, 'lps'),
	(421366, 102, '2015-03-01 01:02:35.000000', 'consum', 0.0225, 'lps'),
	(421367, 102, '2015-03-01 01:02:36.000000', 'consum', 0.0218, 'lps'),
	(421368, 102, '2015-03-01 01:02:37.000000', 'consum', 0.0228, 'lps'),
	(421369, 102, '2015-03-01 01:02:38.000000', 'consum', 0.0213, 'lps'),
	(421370, 102, '2015-03-01 01:02:39.000000', 'consum', 0.0215, 'lps'),
	(421371, 102, '2015-03-01 01:02:40.000000', 'consum', 0.0226, 'lps'),
	(421372, 102, '2015-03-01 01:02:41.000000', 'consum', 0.0214, 'lps'),
	(421373, 102, '2015-03-01 01:02:42.000000', 'consum', 0.0225, 'lps'),
	(421374, 102, '2015-03-01 01:02:43.000000', 'consum', 0.0213, 'lps'),
	(421375, 102, '2015-03-01 01:02:44.000000', 'consum', 0.0221, 'lps'),
	(421376, 102, '2015-03-01 01:02:45.000000', 'consum', 0.0216, 'lps'),
	(421377, 102, '2015-03-01 01:02:46.000000', 'consum', 0.0228, 'lps'),
	(421378, 102, '2015-03-01 01:02:47.000000', 'consum', 0.0220, 'lps'),
	(421379, 102, '2015-03-01 01:02:48.000000', 'consum', 0.0210, 'lps'),
	(421380, 102, '2015-03-01 01:02:49.000000', 'consum', 0.0219, 'lps'),
	(421381, 102, '2015-03-01 01:02:50.000000', 'consum', 0.0215, 'lps'),
	(421382, 102, '2015-03-01 01:02:51.000000', 'consum', 0.0229, 'lps'),
	(421383, 102, '2015-03-01 01:02:52.000000', 'consum', 0.0212, 'lps'),
	(421384, 102, '2015-03-01 01:02:53.000000', 'consum', 0.0223, 'lps'),
	(421385, 102, '2015-03-01 01:02:54.000000', 'consum', 0.0228, 'lps'),
	(421386, 102, '2015-03-01 01:02:55.000000', 'consum', 0.0222, 'lps'),
	(421387, 102, '2015-03-01 01:02:56.000000', 'consum', 0.0217, 'lps'),
	(421388, 102, '2015-03-01 01:02:57.000000', 'consum', 0.0210, 'lps'),
	(421389, 102, '2015-03-01 01:02:58.000000', 'consum', 0.0227, 'lps'),
	(421390, 102, '2015-03-01 01:02:59.000000', 'consum', 0.0218, 'lps'),
	(421391, 102, '2015-03-01 01:03:00.000000', 'consum', 0.0219, 'lps'),
	(421392, 102, '2015-03-01 01:03:01.000000', 'consum', 0.0213, 'lps'),
	(421393, 102, '2015-03-01 01:03:02.000000', 'consum', 0.0216, 'lps'),
	(421394, 102, '2015-03-01 01:03:03.000000', 'consum', 0.0211, 'lps'),
	(421395, 102, '2015-03-01 01:03:04.000000', 'consum', 0.0219, 'lps'),
	(421396, 102, '2015-03-01 01:03:05.000000', 'consum', 0.0211, 'lps'),
	(421397, 102, '2015-03-01 01:03:06.000000', 'consum', 0.0228, 'lps'),
	(421398, 102, '2015-03-01 01:03:07.000000', 'consum', 0.0216, 'lps'),
	(421399, 102, '2015-03-01 01:03:08.000000', 'consum', 0.0229, 'lps'),
	(421400, 102, '2015-03-01 01:03:09.000000', 'consum', 0.0229, 'lps'),
	(421401, 102, '2015-03-01 01:03:10.000000', 'consum', 0.0227, 'lps'),
	(421402, 102, '2015-03-01 01:03:11.000000', 'consum', 0.0219, 'lps'),
	(421403, 102, '2015-03-01 01:03:12.000000', 'consum', 0.0223, 'lps'),
	(421404, 102, '2015-03-01 01:03:13.000000', 'consum', 0.0229, 'lps'),
	(421405, 102, '2015-03-01 01:03:14.000000', 'consum', 0.0227, 'lps'),
	(421406, 102, '2015-03-01 01:03:15.000000', 'consum', 0.0218, 'lps'),
	(421407, 102, '2015-03-01 01:03:16.000000', 'consum', 0.0219, 'lps'),
	(421408, 102, '2015-03-01 01:03:17.000000', 'consum', 0.0212, 'lps'),
	(421409, 102, '2015-03-01 01:03:18.000000', 'consum', 0.0213, 'lps'),
	(421410, 102, '2015-03-01 01:03:19.000000', 'consum', 0.0221, 'lps'),
	(421411, 102, '2015-03-01 01:03:20.000000', 'consum', 0.0217, 'lps'),
	(421412, 102, '2015-03-01 01:03:21.000000', 'consum', 0.0210, 'lps'),
	(421413, 102, '2015-03-01 01:03:22.000000', 'consum', 0.0210, 'lps'),
	(421414, 102, '2015-03-01 01:03:23.000000', 'consum', 0.0212, 'lps'),
	(421415, 102, '2015-03-01 01:03:24.000000', 'consum', 0.0220, 'lps'),
	(421416, 102, '2015-03-01 01:03:25.000000', 'consum', 0.0216, 'lps'),
	(421417, 102, '2015-03-01 01:03:26.000000', 'consum', 0.0229, 'lps'),
	(421418, 102, '2015-03-01 01:03:27.000000', 'consum', 0.0229, 'lps'),
	(421419, 102, '2015-03-01 01:03:28.000000', 'consum', 0.0226, 'lps'),
	(421420, 102, '2015-03-01 01:03:29.000000', 'consum', 0.0214, 'lps'),
	(421421, 102, '2015-03-01 01:03:30.000000', 'consum', 0.0221, 'lps'),
	(421422, 102, '2015-03-01 01:03:31.000000', 'consum', 0.0216, 'lps'),
	(421423, 102, '2015-03-01 01:03:32.000000', 'consum', 0.0228, 'lps'),
	(421424, 102, '2015-03-01 01:03:33.000000', 'consum', 0.0220, 'lps'),
	(421425, 102, '2015-03-01 01:03:34.000000', 'consum', 0.0228, 'lps'),
	(421426, 102, '2015-03-01 01:03:35.000000', 'consum', 0.0229, 'lps'),
	(421427, 102, '2015-03-01 01:03:36.000000', 'consum', 0.0214, 'lps'),
	(421428, 102, '2015-03-01 01:03:37.000000', 'consum', 0.0214, 'lps'),
	(421429, 102, '2015-03-01 01:03:38.000000', 'consum', 0.0219, 'lps'),
	(421430, 102, '2015-03-01 01:03:39.000000', 'consum', 0.0222, 'lps'),
	(421431, 102, '2015-03-01 01:03:40.000000', 'consum', 0.0224, 'lps'),
	(421432, 102, '2015-03-01 01:03:41.000000', 'consum', 0.0226, 'lps'),
	(421433, 102, '2015-03-01 01:03:42.000000', 'consum', 0.0228, 'lps'),
	(421434, 102, '2015-03-01 01:03:43.000000', 'consum', 0.0214, 'lps'),
	(421435, 102, '2015-03-01 01:03:44.000000', 'consum', 0.0215, 'lps'),
	(421436, 102, '2015-03-01 01:03:45.000000', 'consum', 0.0224, 'lps'),
	(421437, 102, '2015-03-01 01:03:46.000000', 'consum', 0.0227, 'lps'),
	(421438, 102, '2015-03-01 01:03:47.000000', 'consum', 0.0211, 'lps'),
	(421439, 102, '2015-03-01 01:03:48.000000', 'consum', 0.0225, 'lps'),
	(421440, 102, '2015-03-01 01:03:49.000000', 'consum', 0.0222, 'lps'),
	(421441, 102, '2015-03-01 01:03:50.000000', 'consum', 0.0228, 'lps'),
	(421442, 102, '2015-03-01 01:03:51.000000', 'consum', 0.0223, 'lps'),
	(421443, 102, '2015-03-01 01:03:52.000000', 'consum', 0.0220, 'lps'),
	(421444, 102, '2015-03-01 01:03:53.000000', 'consum', 0.0221, 'lps'),
	(421445, 102, '2015-03-01 01:03:54.000000', 'consum', 0.0217, 'lps'),
	(421446, 102, '2015-03-01 01:03:55.000000', 'consum', 0.0213, 'lps'),
	(421447, 102, '2015-03-01 01:03:56.000000', 'consum', 0.0223, 'lps'),
	(421448, 102, '2015-03-01 01:03:57.000000', 'consum', 0.0229, 'lps'),
	(421449, 102, '2015-03-01 01:03:58.000000', 'consum', 0.0224, 'lps'),
	(421450, 102, '2015-03-01 01:03:59.000000', 'consum', 0.0224, 'lps'),
	(421451, 102, '2015-03-01 01:04:00.000000', 'consum', 0.0218, 'lps'),
	(421452, 102, '2015-03-01 01:04:01.000000', 'consum', 0.0227, 'lps'),
	(421453, 102, '2015-03-01 01:04:02.000000', 'consum', 0.0213, 'lps'),
	(421454, 102, '2015-03-01 01:04:03.000000', 'consum', 0.0216, 'lps'),
	(421455, 102, '2015-03-01 01:04:04.000000', 'consum', 0.0229, 'lps'),
	(421456, 102, '2015-03-01 01:04:05.000000', 'consum', 0.0210, 'lps'),
	(421457, 102, '2015-03-01 01:04:06.000000', 'consum', 0.0213, 'lps'),
	(421458, 102, '2015-03-01 01:04:07.000000', 'consum', 0.0223, 'lps'),
	(421459, 102, '2015-03-01 01:04:08.000000', 'consum', 0.0210, 'lps'),
	(421460, 102, '2015-03-01 01:04:09.000000', 'consum', 0.0228, 'lps'),
	(421461, 102, '2015-03-01 01:04:10.000000', 'consum', 0.0224, 'lps'),
	(421462, 102, '2015-03-01 01:04:11.000000', 'consum', 0.0225, 'lps'),
	(421463, 102, '2015-03-01 01:04:12.000000', 'consum', 0.0225, 'lps'),
	(421464, 102, '2015-03-01 01:04:13.000000', 'consum', 0.0220, 'lps'),
	(421465, 102, '2015-03-01 01:04:14.000000', 'consum', 0.0216, 'lps'),
	(421466, 102, '2015-03-01 01:04:15.000000', 'consum', 0.0228, 'lps'),
	(421467, 102, '2015-03-01 01:04:16.000000', 'consum', 0.0226, 'lps'),
	(421468, 102, '2015-03-01 01:04:17.000000', 'consum', 0.0214, 'lps'),
	(421469, 102, '2015-03-01 01:04:18.000000', 'consum', 0.0223, 'lps'),
	(421470, 102, '2015-03-01 01:04:19.000000', 'consum', 0.0222, 'lps'),
	(421471, 102, '2015-03-01 01:04:20.000000', 'consum', 0.0215, 'lps'),
	(421472, 102, '2015-03-01 01:04:21.000000', 'consum', 0.0217, 'lps'),
	(421473, 102, '2015-03-01 01:04:22.000000', 'consum', 0.0210, 'lps'),
	(421474, 102, '2015-03-01 01:04:23.000000', 'consum', 0.0212, 'lps'),
	(421475, 102, '2015-03-01 01:04:24.000000', 'consum', 0.0220, 'lps'),
	(421476, 102, '2015-03-01 01:04:25.000000', 'consum', 0.0213, 'lps'),
	(421477, 102, '2015-03-01 01:04:26.000000', 'consum', 0.0215, 'lps'),
	(421478, 102, '2015-03-01 01:04:27.000000', 'consum', 0.0226, 'lps'),
	(421479, 102, '2015-03-01 01:04:28.000000', 'consum', 0.0215, 'lps'),
	(421480, 102, '2015-03-01 01:04:29.000000', 'consum', 0.0227, 'lps'),
	(421481, 102, '2015-03-01 01:04:30.000000', 'consum', 0.0223, 'lps'),
	(421482, 102, '2015-03-01 01:04:31.000000', 'consum', 0.0223, 'lps'),
	(421483, 102, '2015-03-01 01:04:32.000000', 'consum', 0.0216, 'lps'),
	(421484, 102, '2015-03-01 01:04:33.000000', 'consum', 0.0223, 'lps'),
	(421485, 102, '2015-03-01 01:04:34.000000', 'consum', 0.0219, 'lps'),
	(421486, 102, '2015-03-01 01:04:35.000000', 'consum', 0.0215, 'lps'),
	(421487, 102, '2015-03-01 01:04:36.000000', 'consum', 0.0227, 'lps'),
	(421488, 102, '2015-03-01 01:04:37.000000', 'consum', 0.0223, 'lps'),
	(421489, 102, '2015-03-01 01:04:38.000000', 'consum', 0.0223, 'lps'),
	(421490, 102, '2015-03-01 01:04:39.000000', 'consum', 0.0218, 'lps'),
	(421491, 102, '2015-03-01 01:04:40.000000', 'consum', 0.0229, 'lps'),
	(421492, 102, '2015-03-01 01:04:41.000000', 'consum', 0.0224, 'lps'),
	(421493, 102, '2015-03-01 01:04:42.000000', 'consum', 0.0223, 'lps'),
	(421494, 102, '2015-03-01 01:04:43.000000', 'consum', 0.0212, 'lps'),
	(421495, 102, '2015-03-01 01:04:44.000000', 'consum', 0.0221, 'lps'),
	(421496, 102, '2015-03-01 01:04:45.000000', 'consum', 0.0220, 'lps'),
	(421497, 102, '2015-03-01 01:04:46.000000', 'consum', 0.0228, 'lps'),
	(421498, 102, '2015-03-01 01:04:47.000000', 'consum', 0.0228, 'lps'),
	(421499, 102, '2015-03-01 01:04:48.000000', 'consum', 0.0210, 'lps'),
	(421500, 102, '2015-03-01 01:04:49.000000', 'consum', 0.0215, 'lps'),
	(421501, 102, '2015-03-01 01:04:50.000000', 'consum', 0.0215, 'lps'),
	(421502, 102, '2015-03-01 01:04:51.000000', 'consum', 0.0221, 'lps'),
	(421503, 102, '2015-03-01 01:04:52.000000', 'consum', 0.0211, 'lps'),
	(421504, 102, '2015-03-01 01:04:53.000000', 'consum', 0.0223, 'lps'),
	(421505, 102, '2015-03-01 01:04:54.000000', 'consum', 0.0211, 'lps'),
	(421506, 102, '2015-03-01 01:04:55.000000', 'consum', 0.0216, 'lps'),
	(421507, 102, '2015-03-01 01:04:56.000000', 'consum', 0.0219, 'lps'),
	(421508, 102, '2015-03-01 01:04:57.000000', 'consum', 0.0215, 'lps'),
	(421509, 102, '2015-03-01 01:04:58.000000', 'consum', 0.0211, 'lps'),
	(421510, 102, '2015-03-01 01:04:59.000000', 'consum', 0.0220, 'lps'),
	(421511, 102, '2015-03-01 01:05:00.000000', 'consum', 0.0217, 'lps'),
	(421512, 102, '2015-03-01 01:05:01.000000', 'consum', 0.0218, 'lps'),
	(421513, 102, '2015-03-01 01:05:02.000000', 'consum', 0.0226, 'lps'),
	(421514, 102, '2015-03-01 01:05:03.000000', 'consum', 0.0228, 'lps'),
	(421515, 102, '2015-03-01 01:05:04.000000', 'consum', 0.0214, 'lps'),
	(421516, 102, '2015-03-01 01:05:05.000000', 'consum', 0.0216, 'lps'),
	(421517, 102, '2015-03-01 01:05:06.000000', 'consum', 0.0228, 'lps'),
	(421518, 102, '2015-03-01 01:05:07.000000', 'consum', 0.0224, 'lps'),
	(421519, 102, '2015-03-01 01:05:08.000000', 'consum', 0.0226, 'lps'),
	(421520, 102, '2015-03-01 01:05:09.000000', 'consum', 0.0227, 'lps'),
	(421521, 102, '2015-03-01 01:05:10.000000', 'consum', 0.0229, 'lps'),
	(421522, 102, '2015-03-01 01:05:11.000000', 'consum', 0.0212, 'lps'),
	(421523, 102, '2015-03-01 01:05:12.000000', 'consum', 0.0224, 'lps'),
	(421524, 102, '2015-03-01 01:05:13.000000', 'consum', 0.0217, 'lps'),
	(421525, 102, '2015-03-01 01:05:14.000000', 'consum', 0.0221, 'lps'),
	(421526, 102, '2015-03-01 01:05:15.000000', 'consum', 0.0225, 'lps'),
	(421527, 102, '2015-03-01 01:05:16.000000', 'consum', 0.0212, 'lps'),
	(421528, 102, '2015-03-01 01:05:17.000000', 'consum', 0.0214, 'lps'),
	(421529, 102, '2015-03-01 01:05:18.000000', 'consum', 0.0227, 'lps'),
	(421530, 102, '2015-03-01 01:05:19.000000', 'consum', 0.0225, 'lps'),
	(421531, 102, '2015-03-01 01:05:20.000000', 'consum', 0.0211, 'lps'),
	(421532, 102, '2015-03-01 01:05:21.000000', 'consum', 0.0212, 'lps'),
	(421533, 102, '2015-03-01 01:05:22.000000', 'consum', 0.0219, 'lps'),
	(421534, 102, '2015-03-01 01:05:23.000000', 'consum', 0.0229, 'lps'),
	(421535, 102, '2015-03-01 01:05:24.000000', 'consum', 0.0217, 'lps'),
	(421536, 102, '2015-03-01 01:05:25.000000', 'consum', 0.0227, 'lps'),
	(421537, 102, '2015-03-01 01:05:26.000000', 'consum', 0.0218, 'lps'),
	(421538, 102, '2015-03-01 01:05:27.000000', 'consum', 0.0217, 'lps'),
	(421539, 102, '2015-03-01 01:05:28.000000', 'consum', 0.0222, 'lps'),
	(421540, 102, '2015-03-01 01:05:29.000000', 'consum', 0.0210, 'lps'),
	(421541, 102, '2015-03-01 01:05:30.000000', 'consum', 0.0216, 'lps'),
	(421542, 102, '2015-03-01 01:05:31.000000', 'consum', 0.0219, 'lps'),
	(421543, 102, '2015-03-01 01:05:32.000000', 'consum', 0.0218, 'lps'),
	(421544, 102, '2015-03-01 01:05:33.000000', 'consum', 0.0225, 'lps'),
	(421545, 102, '2015-03-01 01:05:34.000000', 'consum', 0.0222, 'lps'),
	(421546, 102, '2015-03-01 01:05:35.000000', 'consum', 0.0223, 'lps'),
	(421547, 102, '2015-03-01 01:05:36.000000', 'consum', 0.0221, 'lps'),
	(421548, 102, '2015-03-01 01:05:37.000000', 'consum', 0.0225, 'lps'),
	(421549, 102, '2015-03-01 01:05:38.000000', 'consum', 0.0214, 'lps'),
	(421550, 102, '2015-03-01 01:05:39.000000', 'consum', 0.0225, 'lps'),
	(421551, 102, '2015-03-01 01:05:40.000000', 'consum', 0.0213, 'lps'),
	(421552, 102, '2015-03-01 01:05:41.000000', 'consum', 0.0221, 'lps'),
	(421553, 102, '2015-03-01 01:05:42.000000', 'consum', 0.0218, 'lps'),
	(421554, 102, '2015-03-01 01:05:43.000000', 'consum', 0.0215, 'lps'),
	(421555, 102, '2015-03-01 01:05:44.000000', 'consum', 0.0214, 'lps'),
	(421556, 102, '2015-03-01 01:05:45.000000', 'consum', 0.0216, 'lps'),
	(421557, 102, '2015-03-01 01:05:46.000000', 'consum', 0.0226, 'lps'),
	(421558, 102, '2015-03-01 01:05:47.000000', 'consum', 0.0214, 'lps'),
	(421559, 102, '2015-03-01 01:05:48.000000', 'consum', 0.0223, 'lps'),
	(421560, 102, '2015-03-01 01:05:49.000000', 'consum', 0.0225, 'lps'),
	(421561, 102, '2015-03-01 01:05:50.000000', 'consum', 0.0225, 'lps'),
	(421562, 102, '2015-03-01 01:05:51.000000', 'consum', 0.0221, 'lps'),
	(421563, 102, '2015-03-01 01:05:52.000000', 'consum', 0.0220, 'lps'),
	(421564, 102, '2015-03-01 01:05:53.000000', 'consum', 0.0226, 'lps'),
	(421565, 102, '2015-03-01 01:05:54.000000', 'consum', 0.0223, 'lps'),
	(421566, 102, '2015-03-01 01:05:55.000000', 'consum', 0.0228, 'lps'),
	(421567, 102, '2015-03-01 01:05:56.000000', 'consum', 0.0222, 'lps'),
	(421568, 102, '2015-03-01 01:05:57.000000', 'consum', 0.0217, 'lps'),
	(421569, 102, '2015-03-01 01:05:58.000000', 'consum', 0.0227, 'lps'),
	(421570, 102, '2015-03-01 01:05:59.000000', 'consum', 0.0215, 'lps'),
	(421571, 102, '2015-03-01 01:06:00.000000', 'consum', 0.0226, 'lps'),
	(421572, 102, '2015-03-01 01:06:01.000000', 'consum', 0.0215, 'lps'),
	(421573, 102, '2015-03-01 01:06:02.000000', 'consum', 0.0227, 'lps'),
	(421574, 102, '2015-03-01 01:06:03.000000', 'consum', 0.0221, 'lps'),
	(421575, 102, '2015-03-01 01:06:04.000000', 'consum', 0.0215, 'lps'),
	(421576, 102, '2015-03-01 01:06:05.000000', 'consum', 0.0221, 'lps'),
	(421577, 102, '2015-03-01 01:06:06.000000', 'consum', 0.0213, 'lps'),
	(421578, 102, '2015-03-01 01:06:07.000000', 'consum', 0.0212, 'lps'),
	(421579, 102, '2015-03-01 01:06:08.000000', 'consum', 0.0229, 'lps'),
	(421580, 102, '2015-03-01 01:06:09.000000', 'consum', 0.0222, 'lps'),
	(421581, 102, '2015-03-01 01:06:10.000000', 'consum', 0.0214, 'lps'),
	(421582, 102, '2015-03-01 01:06:11.000000', 'consum', 0.0212, 'lps'),
	(421583, 102, '2015-03-01 01:06:12.000000', 'consum', 0.0229, 'lps'),
	(421584, 102, '2015-03-01 01:06:13.000000', 'consum', 0.0222, 'lps'),
	(421585, 102, '2015-03-01 01:06:14.000000', 'consum', 0.0212, 'lps'),
	(421586, 102, '2015-03-01 01:06:15.000000', 'consum', 0.0225, 'lps'),
	(421587, 102, '2015-03-01 01:06:16.000000', 'consum', 0.0221, 'lps'),
	(421588, 102, '2015-03-01 01:06:17.000000', 'consum', 0.0219, 'lps'),
	(421589, 102, '2015-03-01 01:06:18.000000', 'consum', 0.0224, 'lps'),
	(421590, 102, '2015-03-01 01:06:19.000000', 'consum', 0.0215, 'lps'),
	(421591, 102, '2015-03-01 01:06:20.000000', 'consum', 0.0211, 'lps'),
	(421592, 102, '2015-03-01 01:06:21.000000', 'consum', 0.0219, 'lps'),
	(421593, 102, '2015-03-01 01:06:22.000000', 'consum', 0.0214, 'lps'),
	(421594, 102, '2015-03-01 01:06:23.000000', 'consum', 0.0225, 'lps'),
	(421595, 102, '2015-03-01 01:06:24.000000', 'consum', 0.0212, 'lps'),
	(421596, 102, '2015-03-01 01:06:25.000000', 'consum', 0.0214, 'lps'),
	(421597, 102, '2015-03-01 01:06:26.000000', 'consum', 0.0225, 'lps'),
	(421598, 102, '2015-03-01 01:06:27.000000', 'consum', 0.0216, 'lps'),
	(421599, 102, '2015-03-01 01:06:28.000000', 'consum', 0.0212, 'lps'),
	(421600, 102, '2015-03-01 01:06:29.000000', 'consum', 0.0225, 'lps'),
	(421601, 102, '2015-03-01 01:06:30.000000', 'consum', 0.0219, 'lps'),
	(421602, 102, '2015-03-01 01:06:31.000000', 'consum', 0.0229, 'lps'),
	(421603, 102, '2015-03-01 01:06:32.000000', 'consum', 0.0221, 'lps'),
	(421604, 102, '2015-03-01 01:06:33.000000', 'consum', 0.0226, 'lps'),
	(421605, 102, '2015-03-01 01:06:34.000000', 'consum', 0.0220, 'lps'),
	(421606, 102, '2015-03-01 01:06:35.000000', 'consum', 0.0211, 'lps'),
	(421607, 102, '2015-03-01 01:06:36.000000', 'consum', 0.0228, 'lps'),
	(421608, 102, '2015-03-01 01:06:37.000000', 'consum', 0.0215, 'lps'),
	(421609, 102, '2015-03-01 01:06:38.000000', 'consum', 0.0220, 'lps'),
	(421610, 102, '2015-03-01 01:06:39.000000', 'consum', 0.0228, 'lps'),
	(421611, 102, '2015-03-01 01:06:40.000000', 'consum', 0.0229, 'lps'),
	(421612, 102, '2015-03-01 01:06:41.000000', 'consum', 0.0212, 'lps'),
	(421613, 102, '2015-03-01 01:06:42.000000', 'consum', 0.0223, 'lps'),
	(421614, 102, '2015-03-01 01:06:43.000000', 'consum', 0.0229, 'lps'),
	(421615, 102, '2015-03-01 01:06:44.000000', 'consum', 0.0227, 'lps'),
	(421616, 102, '2015-03-01 01:06:45.000000', 'consum', 0.0218, 'lps'),
	(421617, 102, '2015-03-01 01:06:46.000000', 'consum', 0.0219, 'lps'),
	(421618, 102, '2015-03-01 01:06:47.000000', 'consum', 0.0211, 'lps'),
	(421619, 102, '2015-03-01 01:06:48.000000', 'consum', 0.0210, 'lps'),
	(421620, 102, '2015-03-01 01:06:49.000000', 'consum', 0.0226, 'lps'),
	(421621, 102, '2015-03-01 01:06:50.000000', 'consum', 0.0212, 'lps'),
	(421622, 102, '2015-03-01 01:06:51.000000', 'consum', 0.0211, 'lps'),
	(421623, 102, '2015-03-01 01:06:52.000000', 'consum', 0.0210, 'lps'),
	(421624, 102, '2015-03-01 01:06:53.000000', 'consum', 0.0228, 'lps'),
	(421625, 102, '2015-03-01 01:06:54.000000', 'consum', 0.0221, 'lps'),
	(421626, 102, '2015-03-01 01:06:55.000000', 'consum', 0.0211, 'lps'),
	(421627, 102, '2015-03-01 01:06:56.000000', 'consum', 0.0223, 'lps'),
	(421628, 102, '2015-03-01 01:06:57.000000', 'consum', 0.0213, 'lps'),
	(421629, 102, '2015-03-01 01:06:58.000000', 'consum', 0.0225, 'lps'),
	(421630, 102, '2015-03-01 01:06:59.000000', 'consum', 0.0217, 'lps'),
	(421631, 102, '2015-03-01 01:07:00.000000', 'consum', 0.0222, 'lps'),
	(421632, 102, '2015-03-01 01:07:01.000000', 'consum', 0.0210, 'lps'),
	(421633, 102, '2015-03-01 01:07:02.000000', 'consum', 0.0211, 'lps'),
	(421634, 102, '2015-03-01 01:07:03.000000', 'consum', 0.0219, 'lps'),
	(421635, 102, '2015-03-01 01:07:04.000000', 'consum', 0.0211, 'lps'),
	(421636, 102, '2015-03-01 01:07:05.000000', 'consum', 0.0227, 'lps'),
	(421637, 102, '2015-03-01 01:07:06.000000', 'consum', 0.0215, 'lps'),
	(421638, 102, '2015-03-01 01:07:07.000000', 'consum', 0.0223, 'lps'),
	(421639, 102, '2015-03-01 01:07:08.000000', 'consum', 0.0220, 'lps'),
	(421640, 102, '2015-03-01 01:07:09.000000', 'consum', 0.0221, 'lps'),
	(421641, 102, '2015-03-01 01:07:10.000000', 'consum', 0.0216, 'lps'),
	(421642, 102, '2015-03-01 01:07:11.000000', 'consum', 0.0229, 'lps'),
	(421643, 102, '2015-03-01 01:07:12.000000', 'consum', 0.0226, 'lps'),
	(421644, 102, '2015-03-01 01:07:13.000000', 'consum', 0.0212, 'lps'),
	(421645, 102, '2015-03-01 01:07:14.000000', 'consum', 0.0213, 'lps'),
	(421646, 102, '2015-03-01 01:07:15.000000', 'consum', 0.0220, 'lps'),
	(421647, 102, '2015-03-01 01:07:16.000000', 'consum', 0.0213, 'lps'),
	(421648, 102, '2015-03-01 01:07:17.000000', 'consum', 0.0213, 'lps'),
	(421649, 102, '2015-03-01 01:07:18.000000', 'consum', 0.0219, 'lps'),
	(421650, 102, '2015-03-01 01:07:19.000000', 'consum', 0.0227, 'lps'),
	(421651, 102, '2015-03-01 01:07:20.000000', 'consum', 0.0229, 'lps'),
	(421652, 102, '2015-03-01 01:07:21.000000', 'consum', 0.0214, 'lps'),
	(421653, 102, '2015-03-01 01:07:22.000000', 'consum', 0.0213, 'lps'),
	(421654, 102, '2015-03-01 01:07:23.000000', 'consum', 0.0215, 'lps'),
	(421655, 102, '2015-03-01 01:07:24.000000', 'consum', 0.0225, 'lps'),
	(421656, 102, '2015-03-01 01:07:25.000000', 'consum', 0.0229, 'lps'),
	(421657, 102, '2015-03-01 01:07:26.000000', 'consum', 0.0222, 'lps'),
	(421658, 102, '2015-03-01 01:07:27.000000', 'consum', 0.0213, 'lps'),
	(421659, 102, '2015-03-01 01:07:28.000000', 'consum', 0.0210, 'lps'),
	(421660, 102, '2015-03-01 01:07:29.000000', 'consum', 0.0221, 'lps'),
	(421661, 102, '2015-03-01 01:07:30.000000', 'consum', 0.0225, 'lps'),
	(421662, 102, '2015-03-01 01:07:31.000000', 'consum', 0.0212, 'lps'),
	(421663, 102, '2015-03-01 01:07:32.000000', 'consum', 0.0218, 'lps'),
	(421664, 102, '2015-03-01 01:07:33.000000', 'consum', 0.0221, 'lps'),
	(421665, 102, '2015-03-01 01:07:34.000000', 'consum', 0.0225, 'lps'),
	(421666, 102, '2015-03-01 01:07:35.000000', 'consum', 0.0229, 'lps'),
	(421667, 102, '2015-03-01 01:07:36.000000', 'consum', 0.0222, 'lps'),
	(421668, 102, '2015-03-01 01:07:37.000000', 'consum', 0.0215, 'lps'),
	(421669, 102, '2015-03-01 01:07:38.000000', 'consum', 0.0220, 'lps'),
	(421670, 102, '2015-03-01 01:07:39.000000', 'consum', 0.0226, 'lps'),
	(421671, 102, '2015-03-01 01:07:40.000000', 'consum', 0.0217, 'lps'),
	(421672, 102, '2015-03-01 01:07:41.000000', 'consum', 0.0221, 'lps'),
	(421673, 102, '2015-03-01 01:07:42.000000', 'consum', 0.0225, 'lps'),
	(421674, 102, '2015-03-01 01:07:43.000000', 'consum', 0.0229, 'lps'),
	(421675, 102, '2015-03-01 01:07:44.000000', 'consum', 0.0223, 'lps'),
	(421676, 102, '2015-03-01 01:07:45.000000', 'consum', 0.0219, 'lps'),
	(421677, 102, '2015-03-01 01:07:46.000000', 'consum', 0.0217, 'lps'),
	(421678, 102, '2015-03-01 01:07:47.000000', 'consum', 0.0219, 'lps'),
	(421679, 102, '2015-03-01 01:07:48.000000', 'consum', 0.0214, 'lps'),
	(421680, 102, '2015-03-01 01:07:49.000000', 'consum', 0.0223, 'lps'),
	(421681, 102, '2015-03-01 01:07:50.000000', 'consum', 0.0223, 'lps'),
	(421682, 102, '2015-03-01 01:07:51.000000', 'consum', 0.0216, 'lps'),
	(421683, 102, '2015-03-01 01:07:52.000000', 'consum', 0.0224, 'lps'),
	(421684, 102, '2015-03-01 01:07:53.000000', 'consum', 0.0221, 'lps'),
	(421685, 102, '2015-03-01 01:07:54.000000', 'consum', 0.0223, 'lps'),
	(421686, 102, '2015-03-01 01:07:55.000000', 'consum', 0.0222, 'lps'),
	(421687, 102, '2015-03-01 01:07:56.000000', 'consum', 0.0210, 'lps'),
	(421688, 102, '2015-03-01 01:07:57.000000', 'consum', 0.0218, 'lps'),
	(421689, 102, '2015-03-01 01:07:58.000000', 'consum', 0.0228, 'lps'),
	(421690, 102, '2015-03-01 01:07:59.000000', 'consum', 0.0217, 'lps'),
	(421691, 102, '2015-03-01 01:08:00.000000', 'consum', 0.0210, 'lps'),
	(421692, 102, '2015-03-01 01:08:01.000000', 'consum', 0.0212, 'lps'),
	(421693, 102, '2015-03-01 01:08:02.000000', 'consum', 0.0220, 'lps'),
	(421694, 102, '2015-03-01 01:08:03.000000', 'consum', 0.0213, 'lps'),
	(421695, 102, '2015-03-01 01:08:04.000000', 'consum', 0.0216, 'lps'),
	(421696, 102, '2015-03-01 01:08:05.000000', 'consum', 0.0213, 'lps'),
	(421697, 102, '2015-03-01 01:08:06.000000', 'consum', 0.0226, 'lps'),
	(421698, 102, '2015-03-01 01:08:07.000000', 'consum', 0.0221, 'lps'),
	(421699, 102, '2015-03-01 01:08:08.000000', 'consum', 0.0216, 'lps'),
	(421700, 102, '2015-03-01 01:08:09.000000', 'consum', 0.0229, 'lps'),
	(421701, 102, '2015-03-01 01:08:10.000000', 'consum', 0.0227, 'lps'),
	(421702, 102, '2015-03-01 01:08:11.000000', 'consum', 0.0221, 'lps'),
	(421703, 102, '2015-03-01 01:08:12.000000', 'consum', 0.0213, 'lps'),
	(421704, 102, '2015-03-01 01:08:13.000000', 'consum', 0.0212, 'lps'),
	(421705, 102, '2015-03-01 01:08:14.000000', 'consum', 0.0212, 'lps'),
	(421706, 102, '2015-03-01 01:08:15.000000', 'consum', 0.0213, 'lps'),
	(421707, 102, '2015-03-01 01:08:16.000000', 'consum', 0.0220, 'lps'),
	(421708, 102, '2015-03-01 01:08:17.000000', 'consum', 0.0210, 'lps'),
	(421709, 102, '2015-03-01 01:08:18.000000', 'consum', 0.0224, 'lps'),
	(421710, 102, '2015-03-01 01:08:19.000000', 'consum', 0.0217, 'lps'),
	(421711, 102, '2015-03-01 01:08:20.000000', 'consum', 0.0226, 'lps'),
	(421712, 102, '2015-03-01 01:08:21.000000', 'consum', 0.0228, 'lps'),
	(421713, 102, '2015-03-01 01:08:22.000000', 'consum', 0.0214, 'lps'),
	(421714, 102, '2015-03-01 01:08:23.000000', 'consum', 0.0217, 'lps'),
	(421715, 102, '2015-03-01 01:08:24.000000', 'consum', 0.0215, 'lps'),
	(421716, 102, '2015-03-01 01:08:25.000000', 'consum', 0.0212, 'lps'),
	(421717, 102, '2015-03-01 01:08:26.000000', 'consum', 0.0225, 'lps'),
	(421718, 102, '2015-03-01 01:08:27.000000', 'consum', 0.0221, 'lps'),
	(421719, 102, '2015-03-01 01:08:28.000000', 'consum', 0.0219, 'lps'),
	(421720, 102, '2015-03-01 01:08:29.000000', 'consum', 0.0224, 'lps'),
	(421721, 102, '2015-03-01 01:08:30.000000', 'consum', 0.0214, 'lps'),
	(421722, 102, '2015-03-01 01:08:31.000000', 'consum', 0.0227, 'lps'),
	(421723, 102, '2015-03-01 01:08:32.000000', 'consum', 0.0222, 'lps'),
	(421724, 102, '2015-03-01 01:08:33.000000', 'consum', 0.0221, 'lps'),
	(421725, 102, '2015-03-01 01:08:34.000000', 'consum', 0.0228, 'lps'),
	(421726, 102, '2015-03-01 01:08:35.000000', 'consum', 0.0227, 'lps'),
	(421727, 102, '2015-03-01 01:08:36.000000', 'consum', 0.0221, 'lps'),
	(421728, 102, '2015-03-01 01:08:37.000000', 'consum', 0.0215, 'lps'),
	(421729, 102, '2015-03-01 01:08:38.000000', 'consum', 0.0221, 'lps'),
	(421730, 102, '2015-03-01 01:08:39.000000', 'consum', 0.0212, 'lps'),
	(421731, 102, '2015-03-01 01:08:40.000000', 'consum', 0.0228, 'lps'),
	(421732, 102, '2015-03-01 01:08:41.000000', 'consum', 0.0215, 'lps'),
	(421733, 102, '2015-03-01 01:08:42.000000', 'consum', 0.0223, 'lps'),
	(421734, 102, '2015-03-01 01:08:43.000000', 'consum', 0.0219, 'lps'),
	(421735, 102, '2015-03-01 01:08:44.000000', 'consum', 0.0215, 'lps'),
	(421736, 102, '2015-03-01 01:08:45.000000', 'consum', 0.0228, 'lps'),
	(421737, 102, '2015-03-01 01:08:46.000000', 'consum', 0.0225, 'lps'),
	(421738, 102, '2015-03-01 01:08:47.000000', 'consum', 0.0214, 'lps'),
	(421739, 102, '2015-03-01 01:08:48.000000', 'consum', 0.0225, 'lps'),
	(421740, 102, '2015-03-01 01:08:49.000000', 'consum', 0.0212, 'lps'),
	(421741, 102, '2015-03-01 01:08:50.000000', 'consum', 0.0218, 'lps'),
	(421742, 102, '2015-03-01 01:08:51.000000', 'consum', 0.0224, 'lps'),
	(421743, 102, '2015-03-01 01:08:52.000000', 'consum', 0.0215, 'lps'),
	(421744, 102, '2015-03-01 01:08:53.000000', 'consum', 0.0216, 'lps'),
	(421745, 102, '2015-03-01 01:08:54.000000', 'consum', 0.0224, 'lps'),
	(421746, 102, '2015-03-01 01:08:55.000000', 'consum', 0.0225, 'lps'),
	(421747, 102, '2015-03-01 01:08:56.000000', 'consum', 0.0220, 'lps'),
	(421748, 102, '2015-03-01 01:08:57.000000', 'consum', 0.0216, 'lps'),
	(421749, 102, '2015-03-01 01:08:58.000000', 'consum', 0.0211, 'lps'),
	(421750, 102, '2015-03-01 01:08:59.000000', 'consum', 0.0219, 'lps'),
	(421751, 102, '2015-03-01 01:09:00.000000', 'consum', 0.0214, 'lps'),
	(421752, 102, '2015-03-01 01:09:01.000000', 'consum', 0.0220, 'lps'),
	(421753, 102, '2015-03-01 01:09:02.000000', 'consum', 0.0229, 'lps'),
	(421754, 102, '2015-03-01 01:09:03.000000', 'consum', 0.0218, 'lps'),
	(421755, 102, '2015-03-01 01:09:04.000000', 'consum', 0.0211, 'lps'),
	(421756, 102, '2015-03-01 01:09:05.000000', 'consum', 0.0211, 'lps'),
	(421757, 102, '2015-03-01 01:09:06.000000', 'consum', 0.0212, 'lps'),
	(421758, 102, '2015-03-01 01:09:07.000000', 'consum', 0.0217, 'lps'),
	(421759, 102, '2015-03-01 01:09:08.000000', 'consum', 0.0222, 'lps'),
	(421760, 102, '2015-03-01 01:09:09.000000', 'consum', 0.0228, 'lps'),
	(421761, 102, '2015-03-01 01:09:10.000000', 'consum', 0.0227, 'lps'),
	(421762, 102, '2015-03-01 01:09:11.000000', 'consum', 0.0218, 'lps'),
	(421763, 102, '2015-03-01 01:09:12.000000', 'consum', 0.0223, 'lps'),
	(421764, 102, '2015-03-01 01:09:13.000000', 'consum', 0.0229, 'lps'),
	(421765, 102, '2015-03-01 01:09:14.000000', 'consum', 0.0228, 'lps'),
	(421766, 102, '2015-03-01 01:09:15.000000', 'consum', 0.0221, 'lps'),
	(421767, 102, '2015-03-01 01:09:16.000000', 'consum', 0.0213, 'lps'),
	(421768, 102, '2015-03-01 01:09:17.000000', 'consum', 0.0212, 'lps'),
	(421769, 102, '2015-03-01 01:09:18.000000', 'consum', 0.0212, 'lps'),
	(421770, 102, '2015-03-01 01:09:19.000000', 'consum', 0.0215, 'lps'),
	(421771, 102, '2015-03-01 01:09:20.000000', 'consum', 0.0210, 'lps'),
	(421772, 102, '2015-03-01 01:09:21.000000', 'consum', 0.0214, 'lps'),
	(421773, 102, '2015-03-01 01:09:22.000000', 'consum', 0.0210, 'lps'),
	(421774, 102, '2015-03-01 01:09:23.000000', 'consum', 0.0221, 'lps'),
	(421775, 102, '2015-03-01 01:09:24.000000', 'consum', 0.0225, 'lps'),
	(421776, 102, '2015-03-01 01:09:25.000000', 'consum', 0.0214, 'lps'),
	(421777, 102, '2015-03-01 01:09:26.000000', 'consum', 0.0223, 'lps'),
	(421778, 102, '2015-03-01 01:09:27.000000', 'consum', 0.0225, 'lps'),
	(421779, 102, '2015-03-01 01:09:28.000000', 'consum', 0.0225, 'lps'),
	(421780, 102, '2015-03-01 01:09:29.000000', 'consum', 0.0222, 'lps'),
	(421781, 102, '2015-03-01 01:09:30.000000', 'consum', 0.0223, 'lps'),
	(421782, 102, '2015-03-01 01:09:31.000000', 'consum', 0.0220, 'lps'),
	(421783, 102, '2015-03-01 01:09:32.000000', 'consum', 0.0222, 'lps'),
	(421784, 102, '2015-03-01 01:09:33.000000', 'consum', 0.0220, 'lps'),
	(421785, 102, '2015-03-01 01:09:34.000000', 'consum', 0.0227, 'lps'),
	(421786, 102, '2015-03-01 01:09:35.000000', 'consum', 0.0222, 'lps'),
	(421787, 102, '2015-03-01 01:09:36.000000', 'consum', 0.0222, 'lps'),
	(421788, 102, '2015-03-01 01:09:37.000000', 'consum', 0.0215, 'lps'),
	(421789, 102, '2015-03-01 01:09:38.000000', 'consum', 0.0220, 'lps'),
	(421790, 102, '2015-03-01 01:09:39.000000', 'consum', 0.0223, 'lps'),
	(421791, 102, '2015-03-01 01:09:40.000000', 'consum', 0.0227, 'lps'),
	(421792, 102, '2015-03-01 01:09:41.000000', 'consum', 0.0215, 'lps'),
	(421793, 102, '2015-03-01 01:09:42.000000', 'consum', 0.0224, 'lps'),
	(421794, 102, '2015-03-01 01:09:43.000000', 'consum', 0.0224, 'lps'),
	(421795, 102, '2015-03-01 01:09:44.000000', 'consum', 0.0222, 'lps'),
	(421796, 102, '2015-03-01 01:09:45.000000', 'consum', 0.0228, 'lps'),
	(421797, 102, '2015-03-01 01:09:46.000000', 'consum', 0.0224, 'lps'),
	(421798, 102, '2015-03-01 01:09:47.000000', 'consum', 0.0225, 'lps'),
	(421799, 102, '2015-03-01 01:09:48.000000', 'consum', 0.0224, 'lps'),
	(421800, 102, '2015-03-01 01:09:49.000000', 'consum', 0.0214, 'lps'),
	(421801, 102, '2015-03-01 01:09:50.000000', 'consum', 0.0211, 'lps'),
	(421802, 102, '2015-03-01 01:09:51.000000', 'consum', 0.0222, 'lps'),
	(421803, 102, '2015-03-01 01:09:52.000000', 'consum', 0.0210, 'lps'),
	(421804, 102, '2015-03-01 01:09:53.000000', 'consum', 0.0212, 'lps'),
	(421805, 102, '2015-03-01 01:09:54.000000', 'consum', 0.0221, 'lps'),
	(421806, 102, '2015-03-01 01:09:55.000000', 'consum', 0.0221, 'lps'),
	(421807, 102, '2015-03-01 01:09:56.000000', 'consum', 0.0210, 'lps'),
	(421808, 102, '2015-03-01 01:09:57.000000', 'consum', 0.0219, 'lps'),
	(421809, 102, '2015-03-01 01:09:58.000000', 'consum', 0.0216, 'lps'),
	(421810, 102, '2015-03-01 01:09:59.000000', 'consum', 0.0214, 'lps'),
	(421811, 102, '2015-03-01 01:10:00.000000', 'consum', 0.0214, 'lps'),
	(421812, 102, '2015-03-01 01:10:01.000000', 'consum', 0.0215, 'lps'),
	(421813, 102, '2015-03-01 01:10:02.000000', 'consum', 0.0224, 'lps'),
	(421814, 102, '2015-03-01 01:10:03.000000', 'consum', 0.0227, 'lps'),
	(421815, 102, '2015-03-01 01:10:04.000000', 'consum', 0.0211, 'lps'),
	(421816, 102, '2015-03-01 01:10:05.000000', 'consum', 0.0228, 'lps'),
	(421817, 102, '2015-03-01 01:10:06.000000', 'consum', 0.0215, 'lps'),
	(421818, 102, '2015-03-01 01:10:07.000000', 'consum', 0.0222, 'lps'),
	(421819, 102, '2015-03-01 01:10:08.000000', 'consum', 0.0214, 'lps'),
	(421820, 102, '2015-03-01 01:10:09.000000', 'consum', 0.0216, 'lps'),
	(421821, 102, '2015-03-01 01:10:10.000000', 'consum', 0.0210, 'lps'),
	(421822, 102, '2015-03-01 01:10:11.000000', 'consum', 0.0210, 'lps'),
	(421823, 102, '2015-03-01 01:10:12.000000', 'consum', 0.0211, 'lps'),
	(421824, 102, '2015-03-01 01:10:13.000000', 'consum', 0.0216, 'lps'),
	(421825, 102, '2015-03-01 01:10:14.000000', 'consum', 0.0216, 'lps'),
	(421826, 102, '2015-03-01 01:10:15.000000', 'consum', 0.0225, 'lps'),
	(421827, 102, '2015-03-01 01:10:16.000000', 'consum', 0.0229, 'lps'),
	(421828, 102, '2015-03-01 01:10:17.000000', 'consum', 0.0217, 'lps'),
	(421829, 102, '2015-03-01 01:10:18.000000', 'consum', 0.0229, 'lps'),
	(421830, 102, '2015-03-01 01:10:19.000000', 'consum', 0.0223, 'lps'),
	(421831, 102, '2015-03-01 01:10:20.000000', 'consum', 0.0220, 'lps'),
	(421832, 102, '2015-03-01 01:10:21.000000', 'consum', 0.0221, 'lps'),
	(421833, 102, '2015-03-01 01:10:22.000000', 'consum', 0.0217, 'lps'),
	(421834, 102, '2015-03-01 01:10:23.000000', 'consum', 0.0213, 'lps'),
	(421835, 102, '2015-03-01 01:10:24.000000', 'consum', 0.0222, 'lps'),
	(421836, 102, '2015-03-01 01:10:25.000000', 'consum', 0.0223, 'lps'),
	(421837, 102, '2015-03-01 01:10:26.000000', 'consum', 0.0221, 'lps'),
	(421838, 102, '2015-03-01 01:10:27.000000', 'consum', 0.0224, 'lps'),
	(421839, 102, '2015-03-01 01:10:28.000000', 'consum', 0.0227, 'lps'),
	(421840, 102, '2015-03-01 01:10:29.000000', 'consum', 0.0214, 'lps'),
	(421841, 102, '2015-03-01 01:10:30.000000', 'consum', 0.0219, 'lps'),
	(421842, 102, '2015-03-01 01:10:31.000000', 'consum', 0.0222, 'lps'),
	(421843, 102, '2015-03-01 01:10:32.000000', 'consum', 0.0227, 'lps'),
	(421844, 102, '2015-03-01 01:10:33.000000', 'consum', 0.0217, 'lps'),
	(421845, 102, '2015-03-01 01:10:34.000000', 'consum', 0.0216, 'lps'),
	(421846, 102, '2015-03-01 01:10:35.000000', 'consum', 0.0220, 'lps'),
	(421847, 102, '2015-03-01 01:10:36.000000', 'consum', 0.0221, 'lps'),
	(421848, 102, '2015-03-01 01:10:37.000000', 'consum', 0.0217, 'lps'),
	(421849, 102, '2015-03-01 01:10:38.000000', 'consum', 0.0210, 'lps'),
	(421850, 102, '2015-03-01 01:10:39.000000', 'consum', 0.0213, 'lps'),
	(421851, 102, '2015-03-01 01:10:40.000000', 'consum', 0.0223, 'lps'),
	(421852, 102, '2015-03-01 01:10:41.000000', 'consum', 0.0227, 'lps'),
	(421853, 102, '2015-03-01 01:10:42.000000', 'consum', 0.0217, 'lps'),
	(421854, 102, '2015-03-01 01:10:43.000000', 'consum', 0.0213, 'lps'),
	(421855, 102, '2015-03-01 01:10:44.000000', 'consum', 0.0224, 'lps'),
	(421856, 102, '2015-03-01 01:10:45.000000', 'consum', 0.0214, 'lps'),
	(421857, 102, '2015-03-01 01:10:46.000000', 'consum', 0.0229, 'lps'),
	(421858, 102, '2015-03-01 01:10:47.000000', 'consum', 0.0212, 'lps'),
	(421859, 102, '2015-03-01 01:10:48.000000', 'consum', 0.0224, 'lps'),
	(421860, 102, '2015-03-01 01:10:49.000000', 'consum', 0.0216, 'lps'),
	(421861, 102, '2015-03-01 01:10:50.000000', 'consum', 0.0219, 'lps'),
	(421862, 102, '2015-03-01 01:10:51.000000', 'consum', 0.0214, 'lps'),
	(421863, 102, '2015-03-01 01:10:52.000000', 'consum', 0.0227, 'lps'),
	(421864, 102, '2015-03-01 01:10:53.000000', 'consum', 0.0220, 'lps'),
	(421865, 102, '2015-03-01 01:10:54.000000', 'consum', 0.0212, 'lps'),
	(421866, 102, '2015-03-01 01:10:55.000000', 'consum', 0.0211, 'lps'),
	(421867, 102, '2015-03-01 01:10:56.000000', 'consum', 0.0227, 'lps'),
	(421868, 102, '2015-03-01 01:10:57.000000', 'consum', 0.0213, 'lps'),
	(421869, 102, '2015-03-01 01:10:58.000000', 'consum', 0.0213, 'lps'),
	(421870, 102, '2015-03-01 01:10:59.000000', 'consum', 0.0219, 'lps'),
	(421871, 102, '2015-03-01 01:11:00.000000', 'consum', 0.0226, 'lps'),
	(421872, 102, '2015-03-01 01:11:01.000000', 'consum', 0.0222, 'lps'),
	(421873, 102, '2015-03-01 01:11:02.000000', 'consum', 0.0225, 'lps'),
	(421874, 102, '2015-03-01 01:11:03.000000', 'consum', 0.0229, 'lps'),
	(421875, 102, '2015-03-01 01:11:04.000000', 'consum', 0.0220, 'lps'),
	(421876, 102, '2015-03-01 01:11:05.000000', 'consum', 0.0224, 'lps'),
	(421877, 102, '2015-03-01 01:11:06.000000', 'consum', 0.0210, 'lps'),
	(421878, 102, '2015-03-01 01:11:07.000000', 'consum', 0.0210, 'lps'),
	(421879, 102, '2015-03-01 01:11:08.000000', 'consum', 0.0228, 'lps'),
	(421880, 102, '2015-03-01 01:11:09.000000', 'consum', 0.0221, 'lps'),
	(421881, 102, '2015-03-01 01:11:10.000000', 'consum', 0.0212, 'lps'),
	(421882, 102, '2015-03-01 01:11:11.000000', 'consum', 0.0229, 'lps'),
	(421883, 102, '2015-03-01 01:11:12.000000', 'consum', 0.0220, 'lps'),
	(421884, 102, '2015-03-01 01:11:13.000000', 'consum', 0.0224, 'lps'),
	(421885, 102, '2015-03-01 01:11:14.000000', 'consum', 0.0229, 'lps'),
	(421886, 102, '2015-03-01 01:11:15.000000', 'consum', 0.0223, 'lps'),
	(421887, 102, '2015-03-01 01:11:16.000000', 'consum', 0.0220, 'lps'),
	(421888, 102, '2015-03-01 01:11:17.000000', 'consum', 0.0221, 'lps'),
	(421889, 102, '2015-03-01 01:11:18.000000', 'consum', 0.0217, 'lps'),
	(421890, 102, '2015-03-01 01:11:19.000000', 'consum', 0.0210, 'lps'),
	(421891, 102, '2015-03-01 01:11:20.000000', 'consum', 0.0210, 'lps'),
	(421892, 102, '2015-03-01 01:11:21.000000', 'consum', 0.0211, 'lps'),
	(421893, 102, '2015-03-01 01:11:22.000000', 'consum', 0.0217, 'lps'),
	(421894, 102, '2015-03-01 01:11:23.000000', 'consum', 0.0221, 'lps'),
	(421895, 102, '2015-03-01 01:11:24.000000', 'consum', 0.0223, 'lps'),
	(421896, 102, '2015-03-01 01:11:25.000000', 'consum', 0.0224, 'lps'),
	(421897, 102, '2015-03-01 01:11:26.000000', 'consum', 0.0223, 'lps'),
	(421898, 102, '2015-03-01 01:11:27.000000', 'consum', 0.0212, 'lps'),
	(421899, 102, '2015-03-01 01:11:28.000000', 'consum', 0.0221, 'lps'),
	(421900, 102, '2015-03-01 01:11:29.000000', 'consum', 0.0221, 'lps'),
	(421901, 102, '2015-03-01 01:11:30.000000', 'consum', 0.0212, 'lps'),
	(421902, 102, '2015-03-01 01:11:31.000000', 'consum', 0.0226, 'lps'),
	(421903, 102, '2015-03-01 01:11:32.000000', 'consum', 0.0225, 'lps'),
	(421904, 102, '2015-03-01 01:11:33.000000', 'consum', 0.0217, 'lps'),
	(421905, 102, '2015-03-01 01:11:34.000000', 'consum', 0.0222, 'lps'),
	(421906, 102, '2015-03-01 01:11:35.000000', 'consum', 0.0228, 'lps'),
	(421907, 102, '2015-03-01 01:11:36.000000', 'consum', 0.0227, 'lps'),
	(421908, 102, '2015-03-01 01:11:37.000000', 'consum', 0.0219, 'lps'),
	(421909, 102, '2015-03-01 01:11:38.000000', 'consum', 0.0225, 'lps'),
	(421910, 102, '2015-03-01 01:11:39.000000', 'consum', 0.0217, 'lps'),
	(421911, 102, '2015-03-01 01:11:40.000000', 'consum', 0.0223, 'lps'),
	(421912, 102, '2015-03-01 01:11:41.000000', 'consum', 0.0214, 'lps'),
	(421913, 102, '2015-03-01 01:11:42.000000', 'consum', 0.0210, 'lps'),
	(421914, 102, '2015-03-01 01:11:43.000000', 'consum', 0.0220, 'lps'),
	(421915, 102, '2015-03-01 01:11:44.000000', 'consum', 0.0222, 'lps'),
	(421916, 102, '2015-03-01 01:11:45.000000', 'consum', 0.0218, 'lps'),
	(421917, 102, '2015-03-01 01:11:46.000000', 'consum', 0.0217, 'lps'),
	(421918, 102, '2015-03-01 01:11:47.000000', 'consum', 0.0219, 'lps'),
	(421919, 102, '2015-03-01 01:11:48.000000', 'consum', 0.0213, 'lps'),
	(421920, 102, '2015-03-01 01:11:49.000000', 'consum', 0.0221, 'lps'),
	(421921, 102, '2015-03-01 01:11:50.000000', 'consum', 0.0218, 'lps'),
	(421922, 102, '2015-03-01 01:11:51.000000', 'consum', 0.0214, 'lps'),
	(421923, 102, '2015-03-01 01:11:52.000000', 'consum', 0.0210, 'lps'),
	(421924, 102, '2015-03-01 01:11:53.000000', 'consum', 0.0215, 'lps'),
	(421925, 102, '2015-03-01 01:11:54.000000', 'consum', 0.0217, 'lps'),
	(421926, 102, '2015-03-01 01:11:55.000000', 'consum', 0.0229, 'lps'),
	(421927, 102, '2015-03-01 01:11:56.000000', 'consum', 0.0224, 'lps'),
	(421928, 102, '2015-03-01 01:11:57.000000', 'consum', 0.0224, 'lps'),
	(421929, 102, '2015-03-01 01:11:58.000000', 'consum', 0.0220, 'lps'),
	(421930, 102, '2015-03-01 01:11:59.000000', 'consum', 0.0220, 'lps'),
	(421931, 102, '2015-03-01 01:12:00.000000', 'consum', 0.0227, 'lps'),
	(421932, 102, '2015-03-01 01:12:01.000000', 'consum', 0.0226, 'lps'),
	(421933, 102, '2015-03-01 01:12:02.000000', 'consum', 0.0219, 'lps'),
	(421934, 102, '2015-03-01 01:12:03.000000', 'consum', 0.0210, 'lps'),
	(421935, 102, '2015-03-01 01:12:04.000000', 'consum', 0.0223, 'lps'),
	(421936, 102, '2015-03-01 01:12:05.000000', 'consum', 0.0214, 'lps'),
	(421937, 102, '2015-03-01 01:12:06.000000', 'consum', 0.0214, 'lps'),
	(421938, 102, '2015-03-01 01:12:07.000000', 'consum', 0.0217, 'lps'),
	(421939, 123, '2015-03-01 00:00:00.000000', 'consum', 0.0213, 'lps'),
	(421940, 123, '2015-03-01 00:00:01.000000', 'consum', 0.0222, 'lps'),
	(421941, 123, '2015-03-01 00:00:02.000000', 'consum', 0.0212, 'lps'),
	(421942, 123, '2015-03-01 00:00:03.000000', 'consum', 0.0210, 'lps'),
	(421943, 123, '2015-03-01 00:00:04.000000', 'consum', 0.0219, 'lps'),
	(421944, 123, '2015-03-01 00:00:05.000000', 'consum', 0.0214, 'lps'),
	(421945, 123, '2015-03-01 00:00:06.000000', 'consum', 0.0215, 'lps'),
	(421946, 123, '2015-03-01 00:00:07.000000', 'consum', 0.0214, 'lps'),
	(421947, 123, '2015-03-01 00:00:08.000000', 'consum', 0.0213, 'lps'),
	(421948, 123, '2015-03-01 00:00:09.000000', 'consum', 0.0214, 'lps'),
	(421949, 123, '2015-03-01 00:00:10.000000', 'consum', 0.0221, 'lps'),
	(421950, 123, '2015-03-01 00:00:11.000000', 'consum', 0.0217, 'lps'),
	(421951, 123, '2015-03-01 00:00:12.000000', 'consum', 0.0211, 'lps'),
	(421952, 123, '2015-03-01 00:00:13.000000', 'consum', 0.0219, 'lps'),
	(421953, 123, '2015-03-01 00:00:14.000000', 'consum', 0.0215, 'lps'),
	(421954, 123, '2015-03-01 00:00:15.000000', 'consum', 0.0219, 'lps'),
	(421955, 123, '2015-03-01 00:00:16.000000', 'consum', 0.0217, 'lps'),
	(421956, 123, '2015-03-01 00:00:17.000000', 'consum', 0.0216, 'lps'),
	(421957, 123, '2015-03-01 00:00:18.000000', 'consum', 0.0220, 'lps'),
	(421958, 123, '2015-03-01 00:00:19.000000', 'consum', 0.0219, 'lps'),
	(421959, 123, '2015-03-01 00:00:20.000000', 'consum', 0.0210, 'lps'),
	(421960, 123, '2015-03-01 00:00:21.000000', 'consum', 0.0212, 'lps'),
	(421961, 123, '2015-03-01 00:00:22.000000', 'consum', 0.0217, 'lps'),
	(421962, 123, '2015-03-01 00:00:23.000000', 'consum', 0.0217, 'lps'),
	(421963, 123, '2015-03-01 00:00:24.000000', 'consum', 0.0222, 'lps'),
	(421964, 123, '2015-03-01 00:00:25.000000', 'consum', 0.0210, 'lps'),
	(421965, 123, '2015-03-01 00:00:26.000000', 'consum', 0.0215, 'lps'),
	(421966, 123, '2015-03-01 00:00:27.000000', 'consum', 0.0210, 'lps'),
	(421967, 123, '2015-03-01 00:00:28.000000', 'consum', 0.0210, 'lps'),
	(421968, 123, '2015-03-01 00:00:29.000000', 'consum', 0.0222, 'lps'),
	(421969, 123, '2015-03-01 00:00:30.000000', 'consum', 0.0219, 'lps'),
	(421970, 123, '2015-03-01 00:00:31.000000', 'consum', 0.0218, 'lps'),
	(421971, 123, '2015-03-01 00:00:32.000000', 'consum', 0.0210, 'lps'),
	(421972, 123, '2015-03-01 00:00:33.000000', 'consum', 0.0212, 'lps'),
	(421973, 123, '2015-03-01 00:00:34.000000', 'consum', 0.0221, 'lps'),
	(421974, 123, '2015-03-01 00:00:35.000000', 'consum', 0.0222, 'lps'),
	(421975, 123, '2015-03-01 00:00:36.000000', 'consum', 0.0211, 'lps'),
	(421976, 123, '2015-03-01 00:00:37.000000', 'consum', 0.0216, 'lps'),
	(421977, 123, '2015-03-01 00:00:38.000000', 'consum', 0.0215, 'lps'),
	(421978, 123, '2015-03-01 00:00:39.000000', 'consum', 0.0216, 'lps'),
	(421979, 123, '2015-03-01 00:00:40.000000', 'consum', 0.0215, 'lps'),
	(421980, 123, '2015-03-01 00:00:41.000000', 'consum', 0.0214, 'lps'),
	(421981, 123, '2015-03-01 00:00:42.000000', 'consum', 0.0217, 'lps'),
	(421982, 123, '2015-03-01 00:00:43.000000', 'consum', 0.0219, 'lps'),
	(421983, 123, '2015-03-01 00:00:44.000000', 'consum', 0.0211, 'lps'),
	(421984, 123, '2015-03-01 00:00:45.000000', 'consum', 0.0211, 'lps'),
	(421985, 123, '2015-03-01 00:00:46.000000', 'consum', 0.0216, 'lps'),
	(421986, 123, '2015-03-01 00:00:47.000000', 'consum', 0.0210, 'lps'),
	(421987, 123, '2015-03-01 00:00:48.000000', 'consum', 0.0221, 'lps'),
	(421988, 123, '2015-03-01 00:00:49.000000', 'consum', 0.0210, 'lps'),
	(421989, 123, '2015-03-01 00:00:50.000000', 'consum', 0.0218, 'lps'),
	(421990, 123, '2015-03-01 00:00:51.000000', 'consum', 0.0213, 'lps'),
	(421991, 123, '2015-03-01 00:00:52.000000', 'consum', 0.0214, 'lps'),
	(421992, 123, '2015-03-01 00:00:53.000000', 'consum', 0.0221, 'lps'),
	(421993, 123, '2015-03-01 00:00:54.000000', 'consum', 0.0214, 'lps'),
	(421994, 123, '2015-03-01 00:00:55.000000', 'consum', 0.0210, 'lps'),
	(421995, 123, '2015-03-01 00:00:56.000000', 'consum', 0.0210, 'lps'),
	(421996, 123, '2015-03-01 00:00:57.000000', 'consum', 0.0213, 'lps'),
	(421997, 123, '2015-03-01 00:00:58.000000', 'consum', 0.0210, 'lps'),
	(421998, 123, '2015-03-01 00:00:59.000000', 'consum', 0.0216, 'lps'),
	(421999, 123, '2015-03-01 00:01:00.000000', 'consum', 0.0215, 'lps'),
	(422000, 123, '2015-03-01 00:01:01.000000', 'consum', 0.0218, 'lps'),
	(422001, 123, '2015-03-01 00:01:02.000000', 'consum', 0.0222, 'lps'),
	(422002, 123, '2015-03-01 00:01:03.000000', 'consum', 0.0220, 'lps'),
	(422003, 123, '2015-03-01 00:01:04.000000', 'consum', 0.0210, 'lps'),
	(422004, 123, '2015-03-01 00:01:05.000000', 'consum', 0.0221, 'lps'),
	(422005, 123, '2015-03-01 00:01:06.000000', 'consum', 0.0211, 'lps'),
	(422006, 123, '2015-03-01 00:01:07.000000', 'consum', 0.0212, 'lps'),
	(422007, 123, '2015-03-01 00:01:08.000000', 'consum', 0.0215, 'lps'),
	(422008, 123, '2015-03-01 00:01:09.000000', 'consum', 0.0219, 'lps'),
	(422009, 123, '2015-03-01 00:01:10.000000', 'consum', 0.0211, 'lps'),
	(422010, 123, '2015-03-01 00:01:11.000000', 'consum', 0.0218, 'lps'),
	(422011, 123, '2015-03-01 00:01:12.000000', 'consum', 0.0220, 'lps'),
	(422012, 123, '2015-03-01 00:01:13.000000', 'consum', 0.0211, 'lps'),
	(422013, 123, '2015-03-01 00:01:14.000000', 'consum', 0.0210, 'lps'),
	(422014, 123, '2015-03-01 00:01:15.000000', 'consum', 0.0210, 'lps'),
	(422015, 123, '2015-03-01 00:01:16.000000', 'consum', 0.0220, 'lps'),
	(422016, 123, '2015-03-01 00:01:17.000000', 'consum', 0.0211, 'lps'),
	(422017, 123, '2015-03-01 00:01:18.000000', 'consum', 0.0213, 'lps'),
	(422018, 123, '2015-03-01 00:01:19.000000', 'consum', 0.0221, 'lps'),
	(422019, 123, '2015-03-01 00:01:20.000000', 'consum', 0.0217, 'lps'),
	(422020, 123, '2015-03-01 00:01:21.000000', 'consum', 0.0213, 'lps'),
	(422021, 123, '2015-03-01 00:01:22.000000', 'consum', 0.0218, 'lps'),
	(422022, 123, '2015-03-01 00:01:23.000000', 'consum', 0.0214, 'lps'),
	(422023, 123, '2015-03-01 00:01:24.000000', 'consum', 0.0221, 'lps'),
	(422024, 123, '2015-03-01 00:01:25.000000', 'consum', 0.0213, 'lps'),
	(422025, 123, '2015-03-01 00:01:26.000000', 'consum', 0.0218, 'lps'),
	(422026, 123, '2015-03-01 00:01:27.000000', 'consum', 0.0218, 'lps'),
	(422027, 123, '2015-03-01 00:01:28.000000', 'consum', 0.0212, 'lps'),
	(422028, 123, '2015-03-01 00:01:29.000000', 'consum', 0.0222, 'lps'),
	(422029, 123, '2015-03-01 00:01:30.000000', 'consum', 0.0211, 'lps'),
	(422030, 123, '2015-03-01 00:01:31.000000', 'consum', 0.0222, 'lps'),
	(422031, 123, '2015-03-01 00:01:32.000000', 'consum', 0.0212, 'lps'),
	(422032, 123, '2015-03-01 00:01:33.000000', 'consum', 0.0212, 'lps'),
	(422033, 123, '2015-03-01 00:01:34.000000', 'consum', 0.0216, 'lps'),
	(422034, 123, '2015-03-01 00:01:35.000000', 'consum', 0.0219, 'lps'),
	(422035, 123, '2015-03-01 00:01:36.000000', 'consum', 0.0212, 'lps'),
	(422036, 123, '2015-03-01 00:01:37.000000', 'consum', 0.0221, 'lps'),
	(422037, 123, '2015-03-01 00:01:38.000000', 'consum', 0.0219, 'lps'),
	(422038, 123, '2015-03-01 00:01:39.000000', 'consum', 0.0222, 'lps'),
	(422039, 123, '2015-03-01 00:01:40.000000', 'consum', 0.0218, 'lps'),
	(422040, 123, '2015-03-01 00:01:41.000000', 'consum', 0.0214, 'lps'),
	(422041, 123, '2015-03-01 00:01:42.000000', 'consum', 0.0221, 'lps'),
	(422042, 123, '2015-03-01 00:01:43.000000', 'consum', 0.0213, 'lps'),
	(422043, 123, '2015-03-01 00:01:44.000000', 'consum', 0.0219, 'lps'),
	(422044, 123, '2015-03-01 00:01:45.000000', 'consum', 0.0222, 'lps'),
	(422045, 123, '2015-03-01 00:01:46.000000', 'consum', 0.0218, 'lps'),
	(422046, 123, '2015-03-01 00:01:47.000000', 'consum', 0.0214, 'lps'),
	(422047, 123, '2015-03-01 00:01:48.000000', 'consum', 0.0220, 'lps'),
	(422048, 123, '2015-03-01 00:01:49.000000', 'consum', 0.0211, 'lps'),
	(422049, 123, '2015-03-01 00:01:50.000000', 'consum', 0.0222, 'lps'),
	(422050, 123, '2015-03-01 00:01:51.000000', 'consum', 0.0215, 'lps'),
	(422051, 123, '2015-03-01 00:01:52.000000', 'consum', 0.0214, 'lps'),
	(422052, 123, '2015-03-01 00:01:53.000000', 'consum', 0.0217, 'lps'),
	(422053, 123, '2015-03-01 00:01:54.000000', 'consum', 0.0220, 'lps'),
	(422054, 123, '2015-03-01 00:01:55.000000', 'consum', 0.0211, 'lps'),
	(422055, 123, '2015-03-01 00:01:56.000000', 'consum', 0.0212, 'lps'),
	(422056, 123, '2015-03-01 00:01:57.000000', 'consum', 0.0217, 'lps'),
	(422057, 123, '2015-03-01 00:01:58.000000', 'consum', 0.0216, 'lps'),
	(422058, 123, '2015-03-01 00:01:59.000000', 'consum', 0.0218, 'lps'),
	(422059, 123, '2015-03-01 00:02:00.000000', 'consum', 0.0221, 'lps'),
	(422060, 123, '2015-03-01 00:02:01.000000', 'consum', 0.0217, 'lps'),
	(422061, 123, '2015-03-01 00:02:02.000000', 'consum', 0.0222, 'lps'),
	(422062, 123, '2015-03-01 00:02:03.000000', 'consum', 0.0213, 'lps'),
	(422063, 123, '2015-03-01 00:02:04.000000', 'consum', 0.0214, 'lps'),
	(422064, 123, '2015-03-01 00:02:05.000000', 'consum', 0.0221, 'lps'),
	(422065, 123, '2015-03-01 00:02:06.000000', 'consum', 0.0215, 'lps'),
	(422066, 123, '2015-03-01 00:02:07.000000', 'consum', 0.0217, 'lps'),
	(422067, 123, '2015-03-01 00:02:08.000000', 'consum', 0.0217, 'lps'),
	(422068, 123, '2015-03-01 00:02:09.000000', 'consum', 0.0210, 'lps'),
	(422069, 123, '2015-03-01 00:02:10.000000', 'consum', 0.0216, 'lps'),
	(422070, 123, '2015-03-01 00:02:11.000000', 'consum', 0.0215, 'lps'),
	(422071, 123, '2015-03-01 00:02:12.000000', 'consum', 0.0219, 'lps'),
	(422072, 123, '2015-03-01 00:02:13.000000', 'consum', 0.0211, 'lps'),
	(422073, 123, '2015-03-01 00:02:14.000000', 'consum', 0.0218, 'lps'),
	(422074, 123, '2015-03-01 00:02:15.000000', 'consum', 0.0220, 'lps'),
	(422075, 123, '2015-03-01 00:02:16.000000', 'consum', 0.0212, 'lps'),
	(422076, 123, '2015-03-01 00:02:17.000000', 'consum', 0.0215, 'lps'),
	(422077, 123, '2015-03-01 00:02:18.000000', 'consum', 0.0217, 'lps'),
	(422078, 123, '2015-03-01 00:02:19.000000', 'consum', 0.0218, 'lps'),
	(422079, 123, '2015-03-01 00:02:20.000000', 'consum', 0.0214, 'lps'),
	(422080, 123, '2015-03-01 00:02:21.000000', 'consum', 0.0222, 'lps'),
	(422081, 123, '2015-03-01 00:02:22.000000', 'consum', 0.0220, 'lps'),
	(422082, 123, '2015-03-01 00:02:23.000000', 'consum', 0.0210, 'lps'),
	(422083, 123, '2015-03-01 00:02:24.000000', 'consum', 0.0221, 'lps'),
	(422084, 123, '2015-03-01 00:02:25.000000', 'consum', 0.0214, 'lps'),
	(422085, 123, '2015-03-01 00:02:26.000000', 'consum', 0.0211, 'lps'),
	(422086, 123, '2015-03-01 00:02:27.000000', 'consum', 0.0216, 'lps'),
	(422087, 123, '2015-03-01 00:02:28.000000', 'consum', 0.0212, 'lps'),
	(422088, 123, '2015-03-01 00:02:29.000000', 'consum', 0.0214, 'lps'),
	(422089, 123, '2015-03-01 00:02:30.000000', 'consum', 0.0213, 'lps'),
	(422090, 123, '2015-03-01 00:02:31.000000', 'consum', 0.0213, 'lps'),
	(422091, 123, '2015-03-01 00:02:32.000000', 'consum', 0.0218, 'lps'),
	(422092, 123, '2015-03-01 00:02:33.000000', 'consum', 0.0214, 'lps'),
	(422093, 123, '2015-03-01 00:02:34.000000', 'consum', 0.0220, 'lps'),
	(422094, 123, '2015-03-01 00:02:35.000000', 'consum', 0.0211, 'lps'),
	(422095, 123, '2015-03-01 00:02:36.000000', 'consum', 0.0222, 'lps'),
	(422096, 123, '2015-03-01 00:02:37.000000', 'consum', 0.0216, 'lps'),
	(422097, 123, '2015-03-01 00:02:38.000000', 'consum', 0.0220, 'lps'),
	(422098, 123, '2015-03-01 00:02:39.000000', 'consum', 0.0215, 'lps'),
	(422099, 123, '2015-03-01 00:02:40.000000', 'consum', 0.0217, 'lps'),
	(422100, 123, '2015-03-01 00:02:41.000000', 'consum', 0.0220, 'lps'),
	(422101, 123, '2015-03-01 00:02:42.000000', 'consum', 0.0212, 'lps'),
	(422102, 123, '2015-03-01 00:02:43.000000', 'consum', 0.0218, 'lps'),
	(422103, 123, '2015-03-01 00:02:44.000000', 'consum', 0.0217, 'lps'),
	(422104, 123, '2015-03-01 00:02:45.000000', 'consum', 0.0222, 'lps'),
	(422105, 123, '2015-03-01 00:02:46.000000', 'consum', 0.0212, 'lps'),
	(422106, 123, '2015-03-01 00:02:47.000000', 'consum', 0.0222, 'lps'),
	(422107, 123, '2015-03-01 00:02:48.000000', 'consum', 0.0211, 'lps'),
	(422108, 123, '2015-03-01 00:02:49.000000', 'consum', 0.0219, 'lps'),
	(422109, 123, '2015-03-01 00:02:50.000000', 'consum', 0.0214, 'lps'),
	(422110, 123, '2015-03-01 00:02:51.000000', 'consum', 0.0218, 'lps'),
	(422111, 123, '2015-03-01 00:02:52.000000', 'consum', 0.0213, 'lps'),
	(422112, 123, '2015-03-01 00:02:53.000000', 'consum', 0.0215, 'lps'),
	(422113, 123, '2015-03-01 00:02:54.000000', 'consum', 0.0212, 'lps'),
	(422114, 123, '2015-03-01 00:02:55.000000', 'consum', 0.0219, 'lps'),
	(422115, 123, '2015-03-01 00:02:56.000000', 'consum', 0.0212, 'lps'),
	(422116, 123, '2015-03-01 00:02:57.000000', 'consum', 0.0219, 'lps'),
	(422117, 123, '2015-03-01 00:02:58.000000', 'consum', 0.0211, 'lps'),
	(422118, 123, '2015-03-01 00:02:59.000000', 'consum', 0.0213, 'lps'),
	(422119, 123, '2015-03-01 00:03:00.000000', 'consum', 0.0211, 'lps'),
	(422120, 123, '2015-03-01 00:03:01.000000', 'consum', 0.0218, 'lps'),
	(422121, 123, '2015-03-01 00:03:02.000000', 'consum', 0.0221, 'lps'),
	(422122, 123, '2015-03-01 00:03:03.000000', 'consum', 0.0215, 'lps'),
	(422123, 123, '2015-03-01 00:03:04.000000', 'consum', 0.0214, 'lps'),
	(422124, 123, '2015-03-01 00:03:05.000000', 'consum', 0.0218, 'lps'),
	(422125, 123, '2015-03-01 00:03:06.000000', 'consum', 0.0213, 'lps'),
	(422126, 123, '2015-03-01 00:03:07.000000', 'consum', 0.0212, 'lps'),
	(422127, 123, '2015-03-01 00:03:08.000000', 'consum', 0.0214, 'lps'),
	(422128, 123, '2015-03-01 00:03:09.000000', 'consum', 0.0211, 'lps'),
	(422129, 123, '2015-03-01 00:03:10.000000', 'consum', 0.0218, 'lps'),
	(422130, 123, '2015-03-01 00:03:11.000000', 'consum', 0.0222, 'lps'),
	(422131, 123, '2015-03-01 00:03:12.000000', 'consum', 0.0218, 'lps'),
	(422132, 123, '2015-03-01 00:03:13.000000', 'consum', 0.0217, 'lps'),
	(422133, 123, '2015-03-01 00:03:14.000000', 'consum', 0.0221, 'lps'),
	(422134, 123, '2015-03-01 00:03:15.000000', 'consum', 0.0220, 'lps'),
	(422135, 123, '2015-03-01 00:03:16.000000', 'consum', 0.0211, 'lps'),
	(422136, 123, '2015-03-01 00:03:17.000000', 'consum', 0.0213, 'lps'),
	(422137, 123, '2015-03-01 00:03:18.000000', 'consum', 0.0210, 'lps'),
	(422138, 123, '2015-03-01 00:03:19.000000', 'consum', 0.0216, 'lps'),
	(422139, 123, '2015-03-01 00:03:20.000000', 'consum', 0.0212, 'lps'),
	(422140, 123, '2015-03-01 00:03:21.000000', 'consum', 0.0216, 'lps'),
	(422141, 123, '2015-03-01 00:03:22.000000', 'consum', 0.0221, 'lps'),
	(422142, 123, '2015-03-01 00:03:23.000000', 'consum', 0.0210, 'lps'),
	(422143, 123, '2015-03-01 00:03:24.000000', 'consum', 0.0215, 'lps'),
	(422144, 123, '2015-03-01 00:03:25.000000', 'consum', 0.0211, 'lps'),
	(422145, 123, '2015-03-01 00:03:26.000000', 'consum', 0.0213, 'lps'),
	(422146, 123, '2015-03-01 00:03:27.000000', 'consum', 0.0220, 'lps'),
	(422147, 123, '2015-03-01 00:03:28.000000', 'consum', 0.0216, 'lps'),
	(422148, 123, '2015-03-01 00:03:29.000000', 'consum', 0.0222, 'lps'),
	(422149, 123, '2015-03-01 00:03:30.000000', 'consum', 0.0212, 'lps'),
	(422150, 123, '2015-03-01 00:03:31.000000', 'consum', 0.0213, 'lps'),
	(422151, 123, '2015-03-01 00:03:32.000000', 'consum', 0.0217, 'lps'),
	(422152, 123, '2015-03-01 00:03:33.000000', 'consum', 0.0213, 'lps'),
	(422153, 123, '2015-03-01 00:03:34.000000', 'consum', 0.0218, 'lps'),
	(422154, 123, '2015-03-01 00:03:35.000000', 'consum', 0.0215, 'lps'),
	(422155, 123, '2015-03-01 00:03:36.000000', 'consum', 0.0211, 'lps'),
	(422156, 123, '2015-03-01 00:03:37.000000', 'consum', 0.0212, 'lps'),
	(422157, 123, '2015-03-01 00:03:38.000000', 'consum', 0.0220, 'lps'),
	(422158, 123, '2015-03-01 00:03:39.000000', 'consum', 0.0213, 'lps'),
	(422159, 123, '2015-03-01 00:03:40.000000', 'consum', 0.0210, 'lps'),
	(422160, 123, '2015-03-01 00:03:41.000000', 'consum', 0.0213, 'lps'),
	(422161, 123, '2015-03-01 00:03:42.000000', 'consum', 0.0213, 'lps'),
	(422162, 123, '2015-03-01 00:03:43.000000', 'consum', 0.0218, 'lps'),
	(422163, 123, '2015-03-01 00:03:44.000000', 'consum', 0.0213, 'lps'),
	(422164, 123, '2015-03-01 00:03:45.000000', 'consum', 0.0217, 'lps'),
	(422165, 123, '2015-03-01 00:03:46.000000', 'consum', 0.0222, 'lps'),
	(422166, 123, '2015-03-01 00:03:47.000000', 'consum', 0.0222, 'lps'),
	(422167, 123, '2015-03-01 00:03:48.000000', 'consum', 0.0212, 'lps'),
	(422168, 123, '2015-03-01 00:03:49.000000', 'consum', 0.0221, 'lps'),
	(422169, 123, '2015-03-01 00:03:50.000000', 'consum', 0.0210, 'lps'),
	(422170, 123, '2015-03-01 00:03:51.000000', 'consum', 0.0214, 'lps'),
	(422171, 123, '2015-03-01 00:03:52.000000', 'consum', 0.0220, 'lps'),
	(422172, 123, '2015-03-01 00:03:53.000000', 'consum', 0.0221, 'lps'),
	(422173, 123, '2015-03-01 00:03:54.000000', 'consum', 0.0211, 'lps'),
	(422174, 123, '2015-03-01 00:03:55.000000', 'consum', 0.0221, 'lps'),
	(422175, 123, '2015-03-01 00:03:56.000000', 'consum', 0.0212, 'lps'),
	(422176, 123, '2015-03-01 00:03:57.000000', 'consum', 0.0213, 'lps'),
	(422177, 123, '2015-03-01 00:03:58.000000', 'consum', 0.0221, 'lps'),
	(422178, 123, '2015-03-01 00:03:59.000000', 'consum', 0.0215, 'lps'),
	(422179, 123, '2015-03-01 00:04:00.000000', 'consum', 0.0215, 'lps'),
	(422180, 123, '2015-03-01 00:04:01.000000', 'consum', 0.0220, 'lps'),
	(422181, 123, '2015-03-01 00:04:02.000000', 'consum', 0.0219, 'lps'),
	(422182, 123, '2015-03-01 00:04:03.000000', 'consum', 0.0212, 'lps'),
	(422183, 123, '2015-03-01 00:04:04.000000', 'consum', 0.0219, 'lps'),
	(422184, 123, '2015-03-01 00:04:05.000000', 'consum', 0.0212, 'lps'),
	(422185, 123, '2015-03-01 00:04:06.000000', 'consum', 0.0218, 'lps'),
	(422186, 123, '2015-03-01 00:04:07.000000', 'consum', 0.0220, 'lps'),
	(422187, 123, '2015-03-01 00:04:08.000000', 'consum', 0.0221, 'lps'),
	(422188, 123, '2015-03-01 00:04:09.000000', 'consum', 0.0213, 'lps'),
	(422189, 123, '2015-03-01 00:04:10.000000', 'consum', 0.0217, 'lps'),
	(422190, 123, '2015-03-01 00:04:11.000000', 'consum', 0.0222, 'lps'),
	(422191, 123, '2015-03-01 00:04:12.000000', 'consum', 0.0210, 'lps'),
	(422192, 123, '2015-03-01 00:04:13.000000', 'consum', 0.0215, 'lps'),
	(422193, 123, '2015-03-01 00:04:14.000000', 'consum', 0.0222, 'lps'),
	(422194, 123, '2015-03-01 00:04:15.000000', 'consum', 0.0217, 'lps'),
	(422195, 123, '2015-03-01 00:04:16.000000', 'consum', 0.0221, 'lps'),
	(422196, 123, '2015-03-01 00:04:17.000000', 'consum', 0.0218, 'lps'),
	(422197, 123, '2015-03-01 00:04:18.000000', 'consum', 0.0219, 'lps'),
	(422198, 123, '2015-03-01 00:04:19.000000', 'consum', 0.0218, 'lps'),
	(422199, 123, '2015-03-01 00:04:20.000000', 'consum', 0.0212, 'lps'),
	(422200, 123, '2015-03-01 00:04:21.000000', 'consum', 0.0210, 'lps'),
	(422201, 123, '2015-03-01 00:04:22.000000', 'consum', 0.0214, 'lps'),
	(422202, 123, '2015-03-01 00:04:23.000000', 'consum', 0.0221, 'lps'),
	(422203, 123, '2015-03-01 00:04:24.000000', 'consum', 0.0213, 'lps'),
	(422204, 123, '2015-03-01 00:04:25.000000', 'consum', 0.0217, 'lps'),
	(422205, 123, '2015-03-01 00:04:26.000000', 'consum', 0.0211, 'lps'),
	(422206, 123, '2015-03-01 00:04:27.000000', 'consum', 0.0222, 'lps'),
	(422207, 123, '2015-03-01 00:04:28.000000', 'consum', 0.0216, 'lps'),
	(422208, 123, '2015-03-01 00:04:29.000000', 'consum', 0.0215, 'lps'),
	(422209, 123, '2015-03-01 00:04:30.000000', 'consum', 0.0218, 'lps'),
	(422210, 123, '2015-03-01 00:04:31.000000', 'consum', 0.0221, 'lps'),
	(422211, 123, '2015-03-01 00:04:32.000000', 'consum', 0.0217, 'lps'),
	(422212, 123, '2015-03-01 00:04:33.000000', 'consum', 0.0213, 'lps'),
	(422213, 123, '2015-03-01 00:04:34.000000', 'consum', 0.0215, 'lps'),
	(422214, 123, '2015-03-01 00:04:35.000000', 'consum', 0.0216, 'lps'),
	(422215, 123, '2015-03-01 00:04:36.000000', 'consum', 0.0213, 'lps'),
	(422216, 123, '2015-03-01 00:04:37.000000', 'consum', 0.0221, 'lps'),
	(422217, 123, '2015-03-01 00:04:38.000000', 'consum', 0.0215, 'lps'),
	(422218, 123, '2015-03-01 00:04:39.000000', 'consum', 0.0216, 'lps'),
	(422219, 123, '2015-03-01 00:04:40.000000', 'consum', 0.0212, 'lps'),
	(422220, 123, '2015-03-01 00:04:41.000000', 'consum', 0.0216, 'lps'),
	(422221, 123, '2015-03-01 00:04:42.000000', 'consum', 0.0222, 'lps'),
	(422222, 123, '2015-03-01 00:04:43.000000', 'consum', 0.0215, 'lps'),
	(422223, 123, '2015-03-01 00:04:44.000000', 'consum', 0.0222, 'lps'),
	(422224, 123, '2015-03-01 00:04:45.000000', 'consum', 0.0220, 'lps'),
	(422225, 123, '2015-03-01 00:04:46.000000', 'consum', 0.0210, 'lps'),
	(422226, 123, '2015-03-01 00:04:47.000000', 'consum', 0.0222, 'lps'),
	(422227, 123, '2015-03-01 00:04:48.000000', 'consum', 0.0215, 'lps'),
	(422228, 123, '2015-03-01 00:04:49.000000', 'consum', 0.0215, 'lps'),
	(422229, 123, '2015-03-01 00:04:50.000000', 'consum', 0.0218, 'lps'),
	(422230, 123, '2015-03-01 00:04:51.000000', 'consum', 0.0210, 'lps'),
	(422231, 123, '2015-03-01 00:04:52.000000', 'consum', 0.0215, 'lps'),
	(422232, 123, '2015-03-01 00:04:53.000000', 'consum', 0.0221, 'lps'),
	(422233, 123, '2015-03-01 00:04:54.000000', 'consum', 0.0210, 'lps'),
	(422234, 123, '2015-03-01 00:04:55.000000', 'consum', 0.0219, 'lps'),
	(422235, 123, '2015-03-01 00:04:56.000000', 'consum', 0.0215, 'lps'),
	(422236, 123, '2015-03-01 00:04:57.000000', 'consum', 0.0221, 'lps'),
	(422237, 123, '2015-03-01 00:04:58.000000', 'consum', 0.0213, 'lps'),
	(422238, 123, '2015-03-01 00:04:59.000000', 'consum', 0.0216, 'lps'),
	(422239, 123, '2015-03-01 00:05:00.000000', 'consum', 0.0219, 'lps'),
	(422240, 123, '2015-03-01 00:05:01.000000', 'consum', 0.0213, 'lps'),
	(422241, 123, '2015-03-01 00:05:02.000000', 'consum', 0.0211, 'lps'),
	(422242, 123, '2015-03-01 00:05:03.000000', 'consum', 0.0218, 'lps'),
	(422243, 123, '2015-03-01 00:05:04.000000', 'consum', 0.0222, 'lps'),
	(422244, 123, '2015-03-01 00:05:05.000000', 'consum', 0.0220, 'lps'),
	(422245, 123, '2015-03-01 00:05:06.000000', 'consum', 0.0214, 'lps'),
	(422246, 123, '2015-03-01 00:05:07.000000', 'consum', 0.0213, 'lps'),
	(422247, 123, '2015-03-01 00:05:08.000000', 'consum', 0.0213, 'lps'),
	(422248, 123, '2015-03-01 00:05:09.000000', 'consum', 0.0218, 'lps'),
	(422249, 123, '2015-03-01 00:05:10.000000', 'consum', 0.0213, 'lps'),
	(422250, 123, '2015-03-01 00:05:11.000000', 'consum', 0.0216, 'lps'),
	(422251, 123, '2015-03-01 00:05:12.000000', 'consum', 0.0217, 'lps'),
	(422252, 123, '2015-03-01 00:05:13.000000', 'consum', 0.0216, 'lps'),
	(422253, 123, '2015-03-01 00:05:14.000000', 'consum', 0.0218, 'lps'),
	(422254, 123, '2015-03-01 00:05:15.000000', 'consum', 0.0222, 'lps'),
	(422255, 123, '2015-03-01 00:05:16.000000', 'consum', 0.0218, 'lps'),
	(422256, 123, '2015-03-01 00:05:17.000000', 'consum', 0.0215, 'lps'),
	(422257, 123, '2015-03-01 00:05:18.000000', 'consum', 0.0212, 'lps'),
	(422258, 123, '2015-03-01 00:05:19.000000', 'consum', 0.0219, 'lps'),
	(422259, 123, '2015-03-01 00:05:20.000000', 'consum', 0.0221, 'lps'),
	(422260, 123, '2015-03-01 00:05:21.000000', 'consum', 0.0215, 'lps'),
	(422261, 123, '2015-03-01 00:05:22.000000', 'consum', 0.0216, 'lps'),
	(422262, 123, '2015-03-01 00:05:23.000000', 'consum', 0.0213, 'lps'),
	(422263, 123, '2015-03-01 00:05:24.000000', 'consum', 0.0219, 'lps'),
	(422264, 123, '2015-03-01 00:05:25.000000', 'consum', 0.0222, 'lps'),
	(422265, 123, '2015-03-01 00:05:26.000000', 'consum', 0.0215, 'lps'),
	(422266, 123, '2015-03-01 00:05:27.000000', 'consum', 0.0213, 'lps'),
	(422267, 123, '2015-03-01 00:05:28.000000', 'consum', 0.0212, 'lps'),
	(422268, 123, '2015-03-01 00:05:29.000000', 'consum', 0.0210, 'lps'),
	(422269, 123, '2015-03-01 00:05:30.000000', 'consum', 0.0216, 'lps'),
	(422270, 123, '2015-03-01 00:05:31.000000', 'consum', 0.0216, 'lps'),
	(422271, 123, '2015-03-01 00:05:32.000000', 'consum', 0.0221, 'lps'),
	(422272, 123, '2015-03-01 00:05:33.000000', 'consum', 0.0221, 'lps'),
	(422273, 123, '2015-03-01 00:05:34.000000', 'consum', 0.0221, 'lps'),
	(422274, 123, '2015-03-01 00:05:35.000000', 'consum', 0.0218, 'lps'),
	(422275, 123, '2015-03-01 00:05:36.000000', 'consum', 0.0218, 'lps'),
	(422276, 123, '2015-03-01 00:05:37.000000', 'consum', 0.0214, 'lps'),
	(422277, 123, '2015-03-01 00:05:38.000000', 'consum', 0.0217, 'lps'),
	(422278, 123, '2015-03-01 00:05:39.000000', 'consum', 0.0210, 'lps'),
	(422279, 123, '2015-03-01 00:05:40.000000', 'consum', 0.0216, 'lps'),
	(422280, 123, '2015-03-01 00:05:41.000000', 'consum', 0.0213, 'lps'),
	(422281, 123, '2015-03-01 00:05:42.000000', 'consum', 0.0222, 'lps'),
	(422282, 123, '2015-03-01 00:05:43.000000', 'consum', 0.0210, 'lps'),
	(422283, 123, '2015-03-01 00:05:44.000000', 'consum', 0.0215, 'lps'),
	(422284, 123, '2015-03-01 00:05:45.000000', 'consum', 0.0219, 'lps'),
	(422285, 123, '2015-03-01 00:05:46.000000', 'consum', 0.0216, 'lps'),
	(422286, 123, '2015-03-01 00:05:47.000000', 'consum', 0.0213, 'lps'),
	(422287, 123, '2015-03-01 00:05:48.000000', 'consum', 0.0210, 'lps'),
	(422288, 123, '2015-03-01 00:05:49.000000', 'consum', 0.0211, 'lps'),
	(422289, 123, '2015-03-01 00:05:50.000000', 'consum', 0.0219, 'lps'),
	(422290, 123, '2015-03-01 00:05:51.000000', 'consum', 0.0211, 'lps'),
	(422291, 123, '2015-03-01 00:05:52.000000', 'consum', 0.0214, 'lps'),
	(422292, 123, '2015-03-01 00:05:53.000000', 'consum', 0.0214, 'lps'),
	(422293, 123, '2015-03-01 00:05:54.000000', 'consum', 0.0221, 'lps'),
	(422294, 123, '2015-03-01 00:05:55.000000', 'consum', 0.0212, 'lps'),
	(422295, 123, '2015-03-01 00:05:56.000000', 'consum', 0.0215, 'lps'),
	(422296, 123, '2015-03-01 00:05:57.000000', 'consum', 0.0217, 'lps'),
	(422297, 123, '2015-03-01 00:05:58.000000', 'consum', 0.0218, 'lps'),
	(422298, 123, '2015-03-01 00:05:59.000000', 'consum', 0.0218, 'lps'),
	(422299, 123, '2015-03-01 00:06:00.000000', 'consum', 0.0210, 'lps'),
	(422300, 123, '2015-03-01 00:06:01.000000', 'consum', 0.0214, 'lps'),
	(422301, 123, '2015-03-01 00:06:02.000000', 'consum', 0.0217, 'lps'),
	(422302, 123, '2015-03-01 00:06:03.000000', 'consum', 0.0221, 'lps'),
	(422303, 123, '2015-03-01 00:06:04.000000', 'consum', 0.0220, 'lps'),
	(422304, 123, '2015-03-01 00:06:05.000000', 'consum', 0.0214, 'lps'),
	(422305, 123, '2015-03-01 00:06:06.000000', 'consum', 0.0211, 'lps'),
	(422306, 123, '2015-03-01 00:06:07.000000', 'consum', 0.0218, 'lps'),
	(422307, 123, '2015-03-01 00:06:08.000000', 'consum', 0.0221, 'lps'),
	(422308, 123, '2015-03-01 00:06:09.000000', 'consum', 0.0217, 'lps'),
	(422309, 123, '2015-03-01 00:06:10.000000', 'consum', 0.0213, 'lps'),
	(422310, 123, '2015-03-01 00:06:11.000000', 'consum', 0.0216, 'lps'),
	(422311, 123, '2015-03-01 00:06:12.000000', 'consum', 0.0217, 'lps'),
	(422312, 123, '2015-03-01 00:06:13.000000', 'consum', 0.0216, 'lps'),
	(422313, 123, '2015-03-01 00:06:14.000000', 'consum', 0.0221, 'lps'),
	(422314, 123, '2015-03-01 00:06:15.000000', 'consum', 0.0219, 'lps'),
	(422315, 123, '2015-03-01 00:06:16.000000', 'consum', 0.0222, 'lps'),
	(422316, 123, '2015-03-01 00:06:17.000000', 'consum', 0.0221, 'lps'),
	(422317, 123, '2015-03-01 00:06:18.000000', 'consum', 0.0213, 'lps'),
	(422318, 123, '2015-03-01 00:06:19.000000', 'consum', 0.0220, 'lps'),
	(422319, 123, '2015-03-01 00:06:20.000000', 'consum', 0.0214, 'lps'),
	(422320, 123, '2015-03-01 00:06:21.000000', 'consum', 0.0211, 'lps'),
	(422321, 123, '2015-03-01 00:06:22.000000', 'consum', 0.0217, 'lps'),
	(422322, 123, '2015-03-01 00:06:23.000000', 'consum', 0.0217, 'lps'),
	(422323, 123, '2015-03-01 00:06:24.000000', 'consum', 0.0211, 'lps'),
	(422324, 123, '2015-03-01 00:06:25.000000', 'consum', 0.0220, 'lps'),
	(422325, 123, '2015-03-01 00:06:26.000000', 'consum', 0.0221, 'lps'),
	(422326, 123, '2015-03-01 00:06:27.000000', 'consum', 0.0221, 'lps'),
	(422327, 123, '2015-03-01 00:06:28.000000', 'consum', 0.0219, 'lps'),
	(422328, 123, '2015-03-01 00:06:29.000000', 'consum', 0.0210, 'lps'),
	(422329, 123, '2015-03-01 00:06:30.000000', 'consum', 0.0212, 'lps'),
	(422330, 123, '2015-03-01 00:06:31.000000', 'consum', 0.0217, 'lps'),
	(422331, 123, '2015-03-01 00:06:32.000000', 'consum', 0.0213, 'lps'),
	(422332, 123, '2015-03-01 00:06:33.000000', 'consum', 0.0218, 'lps'),
	(422333, 123, '2015-03-01 00:06:34.000000', 'consum', 0.0217, 'lps'),
	(422334, 123, '2015-03-01 00:06:35.000000', 'consum', 0.0219, 'lps'),
	(422335, 123, '2015-03-01 00:06:36.000000', 'consum', 0.0211, 'lps'),
	(422336, 123, '2015-03-01 00:06:37.000000', 'consum', 0.0213, 'lps'),
	(422337, 123, '2015-03-01 00:06:38.000000', 'consum', 0.0212, 'lps'),
	(422338, 123, '2015-03-01 00:06:39.000000', 'consum', 0.0210, 'lps'),
	(422339, 123, '2015-03-01 00:06:40.000000', 'consum', 0.0216, 'lps'),
	(422340, 123, '2015-03-01 00:06:41.000000', 'consum', 0.0216, 'lps'),
	(422341, 123, '2015-03-01 00:06:42.000000', 'consum', 0.0222, 'lps'),
	(422342, 123, '2015-03-01 00:06:43.000000', 'consum', 0.0214, 'lps'),
	(422343, 123, '2015-03-01 00:06:44.000000', 'consum', 0.0219, 'lps'),
	(422344, 123, '2015-03-01 00:06:45.000000', 'consum', 0.0217, 'lps'),
	(422345, 123, '2015-03-01 00:06:46.000000', 'consum', 0.0219, 'lps'),
	(422346, 123, '2015-03-01 00:06:47.000000', 'consum', 0.0222, 'lps'),
	(422347, 123, '2015-03-01 00:06:48.000000', 'consum', 0.0216, 'lps'),
	(422348, 123, '2015-03-01 00:06:49.000000', 'consum', 0.0217, 'lps'),
	(422349, 123, '2015-03-01 00:06:50.000000', 'consum', 0.0216, 'lps'),
	(422350, 123, '2015-03-01 00:06:51.000000', 'consum', 0.0221, 'lps'),
	(422351, 123, '2015-03-01 00:06:52.000000', 'consum', 0.0219, 'lps'),
	(422352, 123, '2015-03-01 00:06:53.000000', 'consum', 0.0211, 'lps'),
	(422353, 123, '2015-03-01 00:06:54.000000', 'consum', 0.0212, 'lps'),
	(422354, 123, '2015-03-01 00:06:55.000000', 'consum', 0.0220, 'lps'),
	(422355, 123, '2015-03-01 00:06:56.000000', 'consum', 0.0215, 'lps'),
	(422356, 123, '2015-03-01 00:06:57.000000', 'consum', 0.0218, 'lps'),
	(422357, 123, '2015-03-01 00:06:58.000000', 'consum', 0.0221, 'lps'),
	(422358, 123, '2015-03-01 00:06:59.000000', 'consum', 0.0218, 'lps'),
	(422359, 123, '2015-03-01 00:07:00.000000', 'consum', 0.0218, 'lps'),
	(422360, 123, '2015-03-01 00:07:01.000000', 'consum', 0.0211, 'lps'),
	(422361, 123, '2015-03-01 00:07:02.000000', 'consum', 0.0218, 'lps'),
	(422362, 123, '2015-03-01 00:07:03.000000', 'consum', 0.0221, 'lps'),
	(422363, 123, '2015-03-01 00:07:04.000000', 'consum', 0.0215, 'lps'),
	(422364, 123, '2015-03-01 00:07:05.000000', 'consum', 0.0218, 'lps'),
	(422365, 123, '2015-03-01 00:07:06.000000', 'consum', 0.0221, 'lps'),
	(422366, 123, '2015-03-01 00:07:07.000000', 'consum', 0.0214, 'lps'),
	(422367, 123, '2015-03-01 00:07:08.000000', 'consum', 0.0210, 'lps'),
	(422368, 123, '2015-03-01 00:07:09.000000', 'consum', 0.0214, 'lps'),
	(422369, 123, '2015-03-01 00:07:10.000000', 'consum', 0.0218, 'lps'),
	(422370, 123, '2015-03-01 00:07:11.000000', 'consum', 0.0212, 'lps'),
	(422371, 123, '2015-03-01 00:07:12.000000', 'consum', 0.0220, 'lps'),
	(422372, 123, '2015-03-01 00:07:13.000000', 'consum', 0.0217, 'lps'),
	(422373, 123, '2015-03-01 00:07:14.000000', 'consum', 0.0216, 'lps'),
	(422374, 123, '2015-03-01 00:07:15.000000', 'consum', 0.0221, 'lps'),
	(422375, 123, '2015-03-01 00:07:16.000000', 'consum', 0.0220, 'lps'),
	(422376, 123, '2015-03-01 00:07:17.000000', 'consum', 0.0215, 'lps'),
	(422377, 123, '2015-03-01 00:07:18.000000', 'consum', 0.0217, 'lps'),
	(422378, 123, '2015-03-01 00:07:19.000000', 'consum', 0.0219, 'lps'),
	(422379, 123, '2015-03-01 00:07:20.000000', 'consum', 0.0221, 'lps'),
	(422380, 123, '2015-03-01 00:07:21.000000', 'consum', 0.0213, 'lps'),
	(422381, 123, '2015-03-01 00:07:22.000000', 'consum', 0.0219, 'lps'),
	(422382, 123, '2015-03-01 00:07:23.000000', 'consum', 0.0222, 'lps'),
	(422383, 123, '2015-03-01 00:07:24.000000', 'consum', 0.0214, 'lps'),
	(422384, 123, '2015-03-01 00:07:25.000000', 'consum', 0.0210, 'lps'),
	(422385, 123, '2015-03-01 00:07:26.000000', 'consum', 0.0222, 'lps'),
	(422386, 123, '2015-03-01 00:07:27.000000', 'consum', 0.0219, 'lps'),
	(422387, 123, '2015-03-01 00:07:28.000000', 'consum', 0.0222, 'lps'),
	(422388, 123, '2015-03-01 00:07:29.000000', 'consum', 0.0215, 'lps'),
	(422389, 123, '2015-03-01 00:07:30.000000', 'consum', 0.0213, 'lps'),
	(422390, 123, '2015-03-01 00:07:31.000000', 'consum', 0.0211, 'lps'),
	(422391, 123, '2015-03-01 00:07:32.000000', 'consum', 0.0221, 'lps'),
	(422392, 123, '2015-03-01 00:07:33.000000', 'consum', 0.0221, 'lps'),
	(422393, 123, '2015-03-01 00:07:34.000000', 'consum', 0.0220, 'lps'),
	(422394, 123, '2015-03-01 00:07:35.000000', 'consum', 0.0215, 'lps'),
	(422395, 123, '2015-03-01 00:07:36.000000', 'consum', 0.0220, 'lps'),
	(422396, 123, '2015-03-01 00:07:37.000000', 'consum', 0.0218, 'lps'),
	(422397, 123, '2015-03-01 00:07:38.000000', 'consum', 0.0210, 'lps'),
	(422398, 123, '2015-03-01 00:07:39.000000', 'consum', 0.0222, 'lps'),
	(422399, 123, '2015-03-01 00:07:40.000000', 'consum', 0.0220, 'lps'),
	(422400, 123, '2015-03-01 00:07:41.000000', 'consum', 0.0213, 'lps'),
	(422401, 123, '2015-03-01 00:07:42.000000', 'consum', 0.0221, 'lps'),
	(422402, 123, '2015-03-01 00:07:43.000000', 'consum', 0.0217, 'lps'),
	(422403, 123, '2015-03-01 00:07:44.000000', 'consum', 0.0211, 'lps'),
	(422404, 123, '2015-03-01 00:07:45.000000', 'consum', 0.0210, 'lps'),
	(422405, 123, '2015-03-01 00:07:46.000000', 'consum', 0.0222, 'lps'),
	(422406, 123, '2015-03-01 00:07:47.000000', 'consum', 0.0215, 'lps'),
	(422407, 123, '2015-03-01 00:07:48.000000', 'consum', 0.0213, 'lps'),
	(422408, 123, '2015-03-01 00:07:49.000000', 'consum', 0.0211, 'lps'),
	(422409, 123, '2015-03-01 00:07:50.000000', 'consum', 0.0218, 'lps'),
	(422410, 123, '2015-03-01 00:07:51.000000', 'consum', 0.0221, 'lps'),
	(422411, 123, '2015-03-01 00:07:52.000000', 'consum', 0.0217, 'lps'),
	(422412, 123, '2015-03-01 00:07:53.000000', 'consum', 0.0213, 'lps'),
	(422413, 123, '2015-03-01 00:07:54.000000', 'consum', 0.0219, 'lps'),
	(422414, 123, '2015-03-01 00:07:55.000000', 'consum', 0.0218, 'lps'),
	(422415, 123, '2015-03-01 00:07:56.000000', 'consum', 0.0211, 'lps'),
	(422416, 123, '2015-03-01 00:07:57.000000', 'consum', 0.0218, 'lps'),
	(422417, 123, '2015-03-01 00:07:58.000000', 'consum', 0.0210, 'lps'),
	(422418, 123, '2015-03-01 00:07:59.000000', 'consum', 0.0211, 'lps'),
	(422419, 123, '2015-03-01 00:08:00.000000', 'consum', 0.0215, 'lps'),
	(422420, 123, '2015-03-01 00:08:01.000000', 'consum', 0.0220, 'lps'),
	(422421, 123, '2015-03-01 00:08:02.000000', 'consum', 0.0220, 'lps'),
	(422422, 123, '2015-03-01 00:08:03.000000', 'consum', 0.0216, 'lps'),
	(422423, 123, '2015-03-01 00:08:04.000000', 'consum', 0.0212, 'lps'),
	(422424, 123, '2015-03-01 00:08:05.000000', 'consum', 0.0214, 'lps'),
	(422425, 123, '2015-03-01 00:08:06.000000', 'consum', 0.0213, 'lps'),
	(422426, 123, '2015-03-01 00:08:07.000000', 'consum', 0.0213, 'lps'),
	(422427, 123, '2015-03-01 00:08:08.000000', 'consum', 0.0217, 'lps'),
	(422428, 123, '2015-03-01 00:08:09.000000', 'consum', 0.0212, 'lps'),
	(422429, 123, '2015-03-01 00:08:10.000000', 'consum', 0.0210, 'lps'),
	(422430, 123, '2015-03-01 00:08:11.000000', 'consum', 0.0219, 'lps'),
	(422431, 123, '2015-03-01 00:08:12.000000', 'consum', 0.0215, 'lps'),
	(422432, 123, '2015-03-01 00:08:13.000000', 'consum', 0.0222, 'lps'),
	(422433, 123, '2015-03-01 00:08:14.000000', 'consum', 0.0215, 'lps'),
	(422434, 123, '2015-03-01 00:08:15.000000', 'consum', 0.0213, 'lps'),
	(422435, 123, '2015-03-01 00:08:16.000000', 'consum', 0.0212, 'lps'),
	(422436, 123, '2015-03-01 00:08:17.000000', 'consum', 0.0210, 'lps'),
	(422437, 123, '2015-03-01 00:08:18.000000', 'consum', 0.0220, 'lps'),
	(422438, 123, '2015-03-01 00:08:19.000000', 'consum', 0.0220, 'lps'),
	(422439, 123, '2015-03-01 00:08:20.000000', 'consum', 0.0218, 'lps'),
	(422440, 123, '2015-03-01 00:08:21.000000', 'consum', 0.0218, 'lps'),
	(422441, 123, '2015-03-01 00:08:22.000000', 'consum', 0.0216, 'lps'),
	(422442, 123, '2015-03-01 00:08:23.000000', 'consum', 0.0216, 'lps'),
	(422443, 123, '2015-03-01 00:08:24.000000', 'consum', 0.0211, 'lps'),
	(422444, 123, '2015-03-01 00:08:25.000000', 'consum', 0.0221, 'lps'),
	(422445, 123, '2015-03-01 00:08:26.000000', 'consum', 0.0211, 'lps'),
	(422446, 123, '2015-03-01 00:08:27.000000', 'consum', 0.0210, 'lps'),
	(422447, 123, '2015-03-01 00:08:28.000000', 'consum', 0.0218, 'lps'),
	(422448, 123, '2015-03-01 00:08:29.000000', 'consum', 0.0214, 'lps'),
	(422449, 123, '2015-03-01 00:08:30.000000', 'consum', 0.0219, 'lps'),
	(422450, 123, '2015-03-01 00:08:31.000000', 'consum', 0.0217, 'lps'),
	(422451, 123, '2015-03-01 00:08:32.000000', 'consum', 0.0219, 'lps'),
	(422452, 123, '2015-03-01 00:08:33.000000', 'consum', 0.0220, 'lps'),
	(422453, 123, '2015-03-01 00:08:34.000000', 'consum', 0.0221, 'lps'),
	(422454, 123, '2015-03-01 00:08:35.000000', 'consum', 0.0222, 'lps'),
	(422455, 123, '2015-03-01 00:08:36.000000', 'consum', 0.0210, 'lps'),
	(422456, 123, '2015-03-01 00:08:37.000000', 'consum', 0.0216, 'lps'),
	(422457, 123, '2015-03-01 00:08:38.000000', 'consum', 0.0214, 'lps'),
	(422458, 123, '2015-03-01 00:08:39.000000', 'consum', 0.0212, 'lps'),
	(422459, 123, '2015-03-01 00:08:40.000000', 'consum', 0.0221, 'lps'),
	(422460, 123, '2015-03-01 00:08:41.000000', 'consum', 0.0221, 'lps'),
	(422461, 123, '2015-03-01 00:08:42.000000', 'consum', 0.0218, 'lps'),
	(422462, 123, '2015-03-01 00:08:43.000000', 'consum', 0.0220, 'lps'),
	(422463, 123, '2015-03-01 00:08:44.000000', 'consum', 0.0211, 'lps'),
	(422464, 123, '2015-03-01 00:08:45.000000', 'consum', 0.0213, 'lps'),
	(422465, 123, '2015-03-01 00:08:46.000000', 'consum', 0.0219, 'lps'),
	(422466, 123, '2015-03-01 00:08:47.000000', 'consum', 0.0221, 'lps'),
	(422467, 123, '2015-03-01 00:08:48.000000', 'consum', 0.0213, 'lps'),
	(422468, 123, '2015-03-01 00:08:49.000000', 'consum', 0.0218, 'lps'),
	(422469, 123, '2015-03-01 00:08:50.000000', 'consum', 0.0216, 'lps'),
	(422470, 123, '2015-03-01 00:08:51.000000', 'consum', 0.0218, 'lps'),
	(422471, 123, '2015-03-01 00:08:52.000000', 'consum', 0.0219, 'lps'),
	(422472, 123, '2015-03-01 00:08:53.000000', 'consum', 0.0216, 'lps'),
	(422473, 123, '2015-03-01 00:08:54.000000', 'consum', 0.0215, 'lps'),
	(422474, 123, '2015-03-01 00:08:55.000000', 'consum', 0.0217, 'lps'),
	(422475, 123, '2015-03-01 00:08:56.000000', 'consum', 0.0219, 'lps'),
	(422476, 123, '2015-03-01 00:08:57.000000', 'consum', 0.0220, 'lps'),
	(422477, 123, '2015-03-01 00:08:58.000000', 'consum', 0.0221, 'lps'),
	(422478, 123, '2015-03-01 00:08:59.000000', 'consum', 0.0221, 'lps'),
	(422479, 123, '2015-03-01 00:09:00.000000', 'consum', 0.0222, 'lps'),
	(422480, 123, '2015-03-01 00:09:01.000000', 'consum', 0.0210, 'lps'),
	(422481, 123, '2015-03-01 00:09:02.000000', 'consum', 0.0215, 'lps'),
	(422482, 123, '2015-03-01 00:09:03.000000', 'consum', 0.0222, 'lps'),
	(422483, 123, '2015-03-01 00:09:04.000000', 'consum', 0.0215, 'lps'),
	(422484, 123, '2015-03-01 00:09:05.000000', 'consum', 0.0215, 'lps'),
	(422485, 123, '2015-03-01 00:09:06.000000', 'consum', 0.0218, 'lps'),
	(422486, 123, '2015-03-01 00:09:07.000000', 'consum', 0.0211, 'lps'),
	(422487, 123, '2015-03-01 00:09:08.000000', 'consum', 0.0215, 'lps'),
	(422488, 123, '2015-03-01 00:09:09.000000', 'consum', 0.0222, 'lps'),
	(422489, 123, '2015-03-01 00:09:10.000000', 'consum', 0.0214, 'lps'),
	(422490, 123, '2015-03-01 00:09:11.000000', 'consum', 0.0210, 'lps'),
	(422491, 123, '2015-03-01 00:09:12.000000', 'consum', 0.0210, 'lps'),
	(422492, 123, '2015-03-01 00:09:13.000000', 'consum', 0.0210, 'lps'),
	(422493, 123, '2015-03-01 00:09:14.000000', 'consum', 0.0210, 'lps'),
	(422494, 123, '2015-03-01 00:09:15.000000', 'consum', 0.0211, 'lps'),
	(422495, 123, '2015-03-01 00:09:16.000000', 'consum', 0.0215, 'lps'),
	(422496, 123, '2015-03-01 00:09:17.000000', 'consum', 0.0221, 'lps'),
	(422497, 123, '2015-03-01 00:09:18.000000', 'consum', 0.0213, 'lps'),
	(422498, 123, '2015-03-01 00:09:19.000000', 'consum', 0.0216, 'lps'),
	(422499, 123, '2015-03-01 00:09:20.000000', 'consum', 0.0218, 'lps'),
	(422500, 123, '2015-03-01 00:09:21.000000', 'consum', 0.0222, 'lps'),
	(422501, 123, '2015-03-01 00:09:22.000000', 'consum', 0.0219, 'lps'),
	(422502, 123, '2015-03-01 00:09:23.000000', 'consum', 0.0220, 'lps'),
	(422503, 123, '2015-03-01 00:09:24.000000', 'consum', 0.0219, 'lps'),
	(422504, 123, '2015-03-01 00:09:25.000000', 'consum', 0.0214, 'lps'),
	(422505, 123, '2015-03-01 00:09:26.000000', 'consum', 0.0217, 'lps'),
	(422506, 123, '2015-03-01 00:09:27.000000', 'consum', 0.0222, 'lps'),
	(422507, 123, '2015-03-01 00:09:28.000000', 'consum', 0.0220, 'lps'),
	(422508, 123, '2015-03-01 00:09:29.000000', 'consum', 0.0215, 'lps'),
	(422509, 123, '2015-03-01 00:09:30.000000', 'consum', 0.0217, 'lps'),
	(422510, 123, '2015-03-01 00:09:31.000000', 'consum', 0.0217, 'lps'),
	(422511, 123, '2015-03-01 00:09:32.000000', 'consum', 0.0212, 'lps'),
	(422512, 123, '2015-03-01 00:09:33.000000', 'consum', 0.0213, 'lps'),
	(422513, 123, '2015-03-01 00:09:34.000000', 'consum', 0.0220, 'lps'),
	(422514, 123, '2015-03-01 00:09:35.000000', 'consum', 0.0211, 'lps'),
	(422515, 123, '2015-03-01 00:09:36.000000', 'consum', 0.0211, 'lps'),
	(422516, 123, '2015-03-01 00:09:37.000000', 'consum', 0.0213, 'lps'),
	(422517, 123, '2015-03-01 00:09:38.000000', 'consum', 0.0211, 'lps'),
	(422518, 123, '2015-03-01 00:09:39.000000', 'consum', 0.0218, 'lps'),
	(422519, 123, '2015-03-01 00:09:40.000000', 'consum', 0.0211, 'lps'),
	(422520, 123, '2015-03-01 00:09:41.000000', 'consum', 0.0214, 'lps'),
	(422521, 123, '2015-03-01 00:09:42.000000', 'consum', 0.0217, 'lps'),
	(422522, 123, '2015-03-01 00:09:43.000000', 'consum', 0.0218, 'lps'),
	(422523, 123, '2015-03-01 00:09:44.000000', 'consum', 0.0216, 'lps'),
	(422524, 123, '2015-03-01 00:09:45.000000', 'consum', 0.0218, 'lps'),
	(422525, 123, '2015-03-01 00:09:46.000000', 'consum', 0.0219, 'lps'),
	(422526, 123, '2015-03-01 00:09:47.000000', 'consum', 0.0217, 'lps'),
	(422527, 123, '2015-03-01 00:09:48.000000', 'consum', 0.0221, 'lps'),
	(422528, 123, '2015-03-01 00:09:49.000000', 'consum', 0.0218, 'lps'),
	(422529, 123, '2015-03-01 00:09:50.000000', 'consum', 0.0218, 'lps'),
	(422530, 123, '2015-03-01 00:09:51.000000', 'consum', 0.0211, 'lps'),
	(422531, 123, '2015-03-01 00:09:52.000000', 'consum', 0.0219, 'lps'),
	(422532, 123, '2015-03-01 00:09:53.000000', 'consum', 0.0213, 'lps'),
	(422533, 123, '2015-03-01 00:09:54.000000', 'consum', 0.0211, 'lps'),
	(422534, 123, '2015-03-01 00:09:55.000000', 'consum', 0.0219, 'lps'),
	(422535, 123, '2015-03-01 00:09:56.000000', 'consum', 0.0213, 'lps'),
	(422536, 123, '2015-03-01 00:09:57.000000', 'consum', 0.0210, 'lps'),
	(422537, 123, '2015-03-01 00:09:58.000000', 'consum', 0.0217, 'lps'),
	(422538, 123, '2015-03-01 00:09:59.000000', 'consum', 0.0219, 'lps'),
	(422539, 123, '2015-03-01 00:10:00.000000', 'consum', 0.0222, 'lps'),
	(422540, 123, '2015-03-01 00:10:01.000000', 'consum', 0.0217, 'lps'),
	(422541, 123, '2015-03-01 00:10:02.000000', 'consum', 0.0222, 'lps'),
	(422542, 123, '2015-03-01 00:10:03.000000', 'consum', 0.0222, 'lps'),
	(422543, 123, '2015-03-01 00:10:04.000000', 'consum', 0.0210, 'lps'),
	(422544, 123, '2015-03-01 00:10:05.000000', 'consum', 0.0213, 'lps'),
	(422545, 123, '2015-03-01 00:10:06.000000', 'consum', 0.0212, 'lps'),
	(422546, 123, '2015-03-01 00:10:07.000000', 'consum', 0.0213, 'lps'),
	(422547, 123, '2015-03-01 00:10:08.000000', 'consum', 0.0217, 'lps'),
	(422548, 123, '2015-03-01 00:10:09.000000', 'consum', 0.0212, 'lps'),
	(422549, 123, '2015-03-01 00:10:10.000000', 'consum', 0.0214, 'lps'),
	(422550, 123, '2015-03-01 00:10:11.000000', 'consum', 0.0210, 'lps'),
	(422551, 123, '2015-03-01 00:10:12.000000', 'consum', 0.0211, 'lps'),
	(422552, 123, '2015-03-01 00:10:13.000000', 'consum', 0.0217, 'lps'),
	(422553, 123, '2015-03-01 00:10:14.000000', 'consum', 0.0216, 'lps'),
	(422554, 123, '2015-03-01 00:10:15.000000', 'consum', 0.0217, 'lps'),
	(422555, 123, '2015-03-01 00:10:16.000000', 'consum', 0.0218, 'lps'),
	(422556, 123, '2015-03-01 00:10:17.000000', 'consum', 0.0214, 'lps'),
	(422557, 123, '2015-03-01 00:10:18.000000', 'consum', 0.0220, 'lps'),
	(422558, 123, '2015-03-01 00:10:19.000000', 'consum', 0.0211, 'lps'),
	(422559, 123, '2015-03-01 00:10:20.000000', 'consum', 0.0210, 'lps'),
	(422560, 123, '2015-03-01 00:10:21.000000', 'consum', 0.0220, 'lps'),
	(422561, 123, '2015-03-01 00:10:22.000000', 'consum', 0.0210, 'lps'),
	(422562, 123, '2015-03-01 00:10:23.000000', 'consum', 0.0218, 'lps'),
	(422563, 123, '2015-03-01 00:10:24.000000', 'consum', 0.0214, 'lps'),
	(422564, 123, '2015-03-01 00:10:25.000000', 'consum', 0.0219, 'lps'),
	(422565, 123, '2015-03-01 00:10:26.000000', 'consum', 0.0216, 'lps'),
	(422566, 123, '2015-03-01 00:10:27.000000', 'consum', 0.0214, 'lps'),
	(422567, 123, '2015-03-01 00:10:28.000000', 'consum', 0.0214, 'lps'),
	(422568, 123, '2015-03-01 00:10:29.000000', 'consum', 0.0219, 'lps'),
	(422569, 123, '2015-03-01 00:10:30.000000', 'consum', 0.0216, 'lps'),
	(422570, 123, '2015-03-01 00:10:31.000000', 'consum', 0.0212, 'lps'),
	(422571, 123, '2015-03-01 00:10:32.000000', 'consum', 0.0217, 'lps'),
	(422572, 123, '2015-03-01 00:10:33.000000', 'consum', 0.0212, 'lps'),
	(422573, 123, '2015-03-01 00:10:34.000000', 'consum', 0.0213, 'lps'),
	(422574, 123, '2015-03-01 00:10:35.000000', 'consum', 0.0218, 'lps'),
	(422575, 123, '2015-03-01 00:10:36.000000', 'consum', 0.0216, 'lps'),
	(422576, 123, '2015-03-01 00:10:37.000000', 'consum', 0.0217, 'lps'),
	(422577, 123, '2015-03-01 00:10:38.000000', 'consum', 0.0214, 'lps'),
	(422578, 123, '2015-03-01 00:10:39.000000', 'consum', 0.0221, 'lps'),
	(422579, 123, '2015-03-01 00:10:40.000000', 'consum', 0.0215, 'lps'),
	(422580, 123, '2015-03-01 00:10:41.000000', 'consum', 0.0216, 'lps'),
	(422581, 123, '2015-03-01 00:10:42.000000', 'consum', 0.0211, 'lps'),
	(422582, 123, '2015-03-01 00:10:43.000000', 'consum', 0.0213, 'lps'),
	(422583, 123, '2015-03-01 00:10:44.000000', 'consum', 0.0210, 'lps'),
	(422584, 123, '2015-03-01 00:10:45.000000', 'consum', 0.0215, 'lps'),
	(422585, 123, '2015-03-01 00:10:46.000000', 'consum', 0.0222, 'lps'),
	(422586, 123, '2015-03-01 00:10:47.000000', 'consum', 0.0218, 'lps'),
	(422587, 123, '2015-03-01 00:10:48.000000', 'consum', 0.0211, 'lps'),
	(422588, 123, '2015-03-01 00:10:49.000000', 'consum', 0.0221, 'lps'),
	(422589, 123, '2015-03-01 00:10:50.000000', 'consum', 0.0221, 'lps'),
	(422590, 123, '2015-03-01 00:10:51.000000', 'consum', 0.0221, 'lps'),
	(422591, 123, '2015-03-01 00:10:52.000000', 'consum', 0.0220, 'lps'),
	(422592, 123, '2015-03-01 00:10:53.000000', 'consum', 0.0212, 'lps'),
	(422593, 123, '2015-03-01 00:10:54.000000', 'consum', 0.0218, 'lps'),
	(422594, 123, '2015-03-01 00:10:55.000000', 'consum', 0.0219, 'lps'),
	(422595, 123, '2015-03-01 00:10:56.000000', 'consum', 0.0217, 'lps'),
	(422596, 123, '2015-03-01 00:10:57.000000', 'consum', 0.0220, 'lps'),
	(422597, 123, '2015-03-01 00:10:58.000000', 'consum', 0.0214, 'lps'),
	(422598, 123, '2015-03-01 00:10:59.000000', 'consum', 0.0211, 'lps'),
	(422599, 123, '2015-03-01 00:11:00.000000', 'consum', 0.0219, 'lps'),
	(422600, 123, '2015-03-01 00:11:01.000000', 'consum', 0.0212, 'lps'),
	(422601, 123, '2015-03-01 00:11:02.000000', 'consum', 0.0219, 'lps'),
	(422602, 123, '2015-03-01 00:11:03.000000', 'consum', 0.0212, 'lps'),
	(422603, 123, '2015-03-01 00:11:04.000000', 'consum', 0.0218, 'lps'),
	(422604, 123, '2015-03-01 00:11:05.000000', 'consum', 0.0219, 'lps'),
	(422605, 123, '2015-03-01 00:11:06.000000', 'consum', 0.0219, 'lps'),
	(422606, 123, '2015-03-01 00:11:07.000000', 'consum', 0.0215, 'lps'),
	(422607, 123, '2015-03-01 00:11:08.000000', 'consum', 0.0221, 'lps'),
	(422608, 123, '2015-03-01 00:11:09.000000', 'consum', 0.0211, 'lps'),
	(422609, 123, '2015-03-01 00:11:10.000000', 'consum', 0.0220, 'lps'),
	(422610, 123, '2015-03-01 00:11:11.000000', 'consum', 0.0221, 'lps'),
	(422611, 123, '2015-03-01 00:11:12.000000', 'consum', 0.0210, 'lps'),
	(422612, 123, '2015-03-01 00:11:13.000000', 'consum', 0.0217, 'lps'),
	(422613, 123, '2015-03-01 00:11:14.000000', 'consum', 0.0217, 'lps'),
	(422614, 123, '2015-03-01 00:11:15.000000', 'consum', 0.0212, 'lps'),
	(422615, 123, '2015-03-01 00:11:16.000000', 'consum', 0.0211, 'lps'),
	(422616, 123, '2015-03-01 00:11:17.000000', 'consum', 0.0213, 'lps'),
	(422617, 123, '2015-03-01 00:11:18.000000', 'consum', 0.0219, 'lps'),
	(422618, 123, '2015-03-01 00:11:19.000000', 'consum', 0.0222, 'lps'),
	(422619, 123, '2015-03-01 00:11:20.000000', 'consum', 0.0219, 'lps'),
	(422620, 123, '2015-03-01 00:11:21.000000', 'consum', 0.0218, 'lps'),
	(422621, 123, '2015-03-01 00:11:22.000000', 'consum', 0.0222, 'lps'),
	(422622, 123, '2015-03-01 00:11:23.000000', 'consum', 0.0221, 'lps'),
	(422623, 123, '2015-03-01 00:11:24.000000', 'consum', 0.0216, 'lps'),
	(422624, 123, '2015-03-01 00:11:25.000000', 'consum', 0.0210, 'lps'),
	(422625, 123, '2015-03-01 00:11:26.000000', 'consum', 0.0217, 'lps'),
	(422626, 123, '2015-03-01 00:11:27.000000', 'consum', 0.0220, 'lps'),
	(422627, 123, '2015-03-01 00:11:28.000000', 'consum', 0.0211, 'lps'),
	(422628, 123, '2015-03-01 00:11:29.000000', 'consum', 0.0214, 'lps'),
	(422629, 123, '2015-03-01 00:11:30.000000', 'consum', 0.0213, 'lps'),
	(422630, 123, '2015-03-01 00:11:31.000000', 'consum', 0.0212, 'lps'),
	(422631, 123, '2015-03-01 00:11:32.000000', 'consum', 0.0213, 'lps'),
	(422632, 123, '2015-03-01 00:11:33.000000', 'consum', 0.0219, 'lps'),
	(422633, 123, '2015-03-01 00:11:34.000000', 'consum', 0.0210, 'lps'),
	(422634, 123, '2015-03-01 00:11:35.000000', 'consum', 0.0219, 'lps'),
	(422635, 123, '2015-03-01 00:11:36.000000', 'consum', 0.0218, 'lps'),
	(422636, 123, '2015-03-01 00:11:37.000000', 'consum', 0.0210, 'lps'),
	(422637, 123, '2015-03-01 00:11:38.000000', 'consum', 0.0213, 'lps'),
	(422638, 123, '2015-03-01 00:11:39.000000', 'consum', 0.0211, 'lps'),
	(422639, 123, '2015-03-01 00:11:40.000000', 'consum', 0.0220, 'lps'),
	(422640, 123, '2015-03-01 00:11:41.000000', 'consum', 0.0220, 'lps'),
	(422641, 123, '2015-03-01 00:11:42.000000', 'consum', 0.0216, 'lps'),
	(422642, 123, '2015-03-01 00:11:43.000000', 'consum', 0.0213, 'lps'),
	(422643, 123, '2015-03-01 00:11:44.000000', 'consum', 0.0218, 'lps'),
	(422644, 123, '2015-03-01 00:11:45.000000', 'consum', 0.0215, 'lps'),
	(422645, 123, '2015-03-01 00:11:46.000000', 'consum', 0.0213, 'lps'),
	(422646, 123, '2015-03-01 00:11:47.000000', 'consum', 0.0210, 'lps'),
	(422647, 123, '2015-03-01 00:11:48.000000', 'consum', 0.0213, 'lps'),
	(422648, 123, '2015-03-01 00:11:49.000000', 'consum', 0.0215, 'lps'),
	(422649, 123, '2015-03-01 00:11:50.000000', 'consum', 0.0213, 'lps'),
	(422650, 123, '2015-03-01 00:11:51.000000', 'consum', 0.0211, 'lps'),
	(422651, 123, '2015-03-01 00:11:52.000000', 'consum', 0.0218, 'lps'),
	(422652, 123, '2015-03-01 00:11:53.000000', 'consum', 0.0222, 'lps'),
	(422653, 123, '2015-03-01 00:11:54.000000', 'consum', 0.0222, 'lps'),
	(422654, 123, '2015-03-01 00:11:55.000000', 'consum', 0.0221, 'lps'),
	(422655, 123, '2015-03-01 00:11:56.000000', 'consum', 0.0216, 'lps'),
	(422656, 123, '2015-03-01 00:11:57.000000', 'consum', 0.0222, 'lps'),
	(422657, 123, '2015-03-01 00:11:58.000000', 'consum', 0.0210, 'lps'),
	(422658, 123, '2015-03-01 00:11:59.000000', 'consum', 0.0217, 'lps'),
	(422659, 123, '2015-03-01 00:12:00.000000', 'consum', 0.0219, 'lps'),
	(422660, 123, '2015-03-01 00:12:01.000000', 'consum', 0.0221, 'lps'),
	(422661, 123, '2015-03-01 00:12:02.000000', 'consum', 0.0210, 'lps'),
	(422662, 123, '2015-03-01 00:12:03.000000', 'consum', 0.0220, 'lps'),
	(422663, 123, '2015-03-01 00:12:04.000000', 'consum', 0.0220, 'lps'),
	(422664, 123, '2015-03-01 00:12:05.000000', 'consum', 0.0216, 'lps'),
	(422665, 123, '2015-03-01 00:12:06.000000', 'consum', 0.0213, 'lps'),
	(422666, 123, '2015-03-01 00:12:07.000000', 'consum', 0.0220, 'lps'),
	(422667, 123, '2015-03-01 00:12:08.000000', 'consum', 0.0214, 'lps'),
	(422668, 123, '2015-03-01 00:12:09.000000', 'consum', 0.0213, 'lps'),
	(422669, 123, '2015-03-01 00:12:10.000000', 'consum', 0.0212, 'lps'),
	(422670, 123, '2015-03-01 00:12:11.000000', 'consum', 0.0212, 'lps'),
	(422671, 123, '2015-03-01 00:12:12.000000', 'consum', 0.0214, 'lps'),
	(422672, 123, '2015-03-01 00:12:13.000000', 'consum', 0.0213, 'lps'),
	(422673, 123, '2015-03-01 00:12:14.000000', 'consum', 0.0211, 'lps'),
	(422674, 123, '2015-03-01 00:12:15.000000', 'consum', 0.0222, 'lps'),
	(422675, 123, '2015-03-01 00:12:16.000000', 'consum', 0.0214, 'lps'),
	(422676, 123, '2015-03-01 00:12:17.000000', 'consum', 0.0222, 'lps'),
	(422677, 123, '2015-03-01 00:12:18.000000', 'consum', 0.0218, 'lps'),
	(422678, 123, '2015-03-01 00:12:19.000000', 'consum', 0.0216, 'lps'),
	(422679, 123, '2015-03-01 00:12:20.000000', 'consum', 0.0214, 'lps'),
	(422680, 123, '2015-03-01 00:12:21.000000', 'consum', 0.0214, 'lps'),
	(422681, 123, '2015-03-01 00:12:22.000000', 'consum', 0.0217, 'lps'),
	(422682, 123, '2015-03-01 00:12:23.000000', 'consum', 0.0222, 'lps'),
	(422683, 123, '2015-03-01 00:12:24.000000', 'consum', 0.0210, 'lps'),
	(422684, 123, '2015-03-01 00:12:25.000000', 'consum', 0.0216, 'lps'),
	(422685, 123, '2015-03-01 00:12:26.000000', 'consum', 0.0211, 'lps'),
	(422686, 123, '2015-03-01 00:12:27.000000', 'consum', 0.0212, 'lps'),
	(422687, 123, '2015-03-01 00:12:28.000000', 'consum', 0.0219, 'lps'),
	(422688, 123, '2015-03-01 00:12:29.000000', 'consum', 0.0222, 'lps'),
	(422689, 123, '2015-03-01 00:12:30.000000', 'consum', 0.0219, 'lps'),
	(422690, 123, '2015-03-01 00:12:31.000000', 'consum', 0.0217, 'lps'),
	(422691, 123, '2015-03-01 00:12:32.000000', 'consum', 0.0219, 'lps'),
	(422692, 123, '2015-03-01 00:12:33.000000', 'consum', 0.0210, 'lps'),
	(422693, 123, '2015-03-01 00:12:34.000000', 'consum', 0.0220, 'lps'),
	(422694, 123, '2015-03-01 00:12:35.000000', 'consum', 0.0210, 'lps'),
	(422695, 123, '2015-03-01 00:12:36.000000', 'consum', 0.0221, 'lps'),
	(422696, 123, '2015-03-01 00:12:37.000000', 'consum', 0.0211, 'lps'),
	(422697, 123, '2015-03-01 00:12:38.000000', 'consum', 0.0222, 'lps'),
	(422698, 123, '2015-03-01 00:12:39.000000', 'consum', 0.0217, 'lps'),
	(422699, 123, '2015-03-01 00:12:40.000000', 'consum', 0.0220, 'lps'),
	(422700, 123, '2015-03-01 00:12:41.000000', 'consum', 0.0213, 'lps'),
	(422701, 123, '2015-03-01 00:12:42.000000', 'consum', 0.0210, 'lps'),
	(422702, 123, '2015-03-01 00:12:43.000000', 'consum', 0.0212, 'lps'),
	(422703, 123, '2015-03-01 00:12:44.000000', 'consum', 0.0211, 'lps'),
	(422704, 123, '2015-03-01 00:12:45.000000', 'consum', 0.0220, 'lps'),
	(422705, 123, '2015-03-01 00:12:46.000000', 'consum', 0.0221, 'lps'),
	(422706, 123, '2015-03-01 00:12:47.000000', 'consum', 0.0222, 'lps'),
	(422707, 123, '2015-03-01 00:12:48.000000', 'consum', 0.0213, 'lps'),
	(422708, 123, '2015-03-01 00:12:49.000000', 'consum', 0.0214, 'lps'),
	(422709, 123, '2015-03-01 00:12:50.000000', 'consum', 0.0222, 'lps'),
	(422710, 123, '2015-03-01 00:12:51.000000', 'consum', 0.0217, 'lps'),
	(422711, 123, '2015-03-01 00:12:52.000000', 'consum', 0.0212, 'lps'),
	(422712, 123, '2015-03-01 00:12:53.000000', 'consum', 0.0213, 'lps'),
	(422713, 123, '2015-03-01 00:12:54.000000', 'consum', 0.0217, 'lps'),
	(422714, 123, '2015-03-01 00:12:55.000000', 'consum', 0.0212, 'lps'),
	(422715, 123, '2015-03-01 00:12:56.000000', 'consum', 0.0210, 'lps'),
	(422716, 123, '2015-03-01 00:12:57.000000', 'consum', 0.0220, 'lps'),
	(422717, 123, '2015-03-01 00:12:58.000000', 'consum', 0.0222, 'lps'),
	(422718, 123, '2015-03-01 00:12:59.000000', 'consum', 0.0212, 'lps'),
	(422719, 123, '2015-03-01 00:13:00.000000', 'consum', 0.0212, 'lps'),
	(422720, 123, '2015-03-01 00:13:01.000000', 'consum', 0.0214, 'lps'),
	(422721, 123, '2015-03-01 00:13:02.000000', 'consum', 0.0211, 'lps'),
	(422722, 123, '2015-03-01 00:13:03.000000', 'consum', 0.0215, 'lps'),
	(422723, 123, '2015-03-01 00:13:04.000000', 'consum', 0.0222, 'lps'),
	(422724, 123, '2015-03-01 00:13:05.000000', 'consum', 0.0215, 'lps'),
	(422725, 123, '2015-03-01 00:13:06.000000', 'consum', 0.0215, 'lps'),
	(422726, 123, '2015-03-01 00:13:07.000000', 'consum', 0.0219, 'lps'),
	(422727, 123, '2015-03-01 00:13:08.000000', 'consum', 0.0215, 'lps'),
	(422728, 123, '2015-03-01 00:13:09.000000', 'consum', 0.0210, 'lps'),
	(422729, 123, '2015-03-01 00:13:10.000000', 'consum', 0.0220, 'lps'),
	(422730, 123, '2015-03-01 00:13:11.000000', 'consum', 0.0222, 'lps'),
	(422731, 123, '2015-03-01 00:13:12.000000', 'consum', 0.0214, 'lps'),
	(422732, 123, '2015-03-01 00:13:13.000000', 'consum', 0.0220, 'lps'),
	(422733, 123, '2015-03-01 00:13:14.000000', 'consum', 0.0211, 'lps'),
	(422734, 123, '2015-03-01 00:13:15.000000', 'consum', 0.0212, 'lps'),
	(422735, 123, '2015-03-01 00:13:16.000000', 'consum', 0.0218, 'lps'),
	(422736, 123, '2015-03-01 00:13:17.000000', 'consum', 0.0216, 'lps'),
	(422737, 123, '2015-03-01 00:13:18.000000', 'consum', 0.0216, 'lps'),
	(422738, 123, '2015-03-01 00:13:19.000000', 'consum', 0.0222, 'lps'),
	(422739, 123, '2015-03-01 00:13:20.000000', 'consum', 0.0215, 'lps'),
	(422740, 123, '2015-03-01 00:13:21.000000', 'consum', 0.0214, 'lps'),
	(422741, 123, '2015-03-01 00:13:22.000000', 'consum', 0.0213, 'lps'),
	(422742, 123, '2015-03-01 00:13:23.000000', 'consum', 0.0214, 'lps'),
	(422743, 123, '2015-03-01 00:13:24.000000', 'consum', 0.0220, 'lps'),
	(422744, 123, '2015-03-01 00:13:25.000000', 'consum', 0.0212, 'lps'),
	(422745, 123, '2015-03-01 00:13:26.000000', 'consum', 0.0215, 'lps'),
	(422746, 123, '2015-03-01 00:13:27.000000', 'consum', 0.0217, 'lps'),
	(422747, 123, '2015-03-01 00:13:28.000000', 'consum', 0.0220, 'lps'),
	(422748, 123, '2015-03-01 00:13:29.000000', 'consum', 0.0210, 'lps'),
	(422749, 123, '2015-03-01 00:13:30.000000', 'consum', 0.0219, 'lps'),
	(422750, 123, '2015-03-01 00:13:31.000000', 'consum', 0.0219, 'lps'),
	(422751, 123, '2015-03-01 00:13:32.000000', 'consum', 0.0213, 'lps'),
	(422752, 123, '2015-03-01 00:13:33.000000', 'consum', 0.0214, 'lps'),
	(422753, 123, '2015-03-01 00:13:34.000000', 'consum', 0.0220, 'lps'),
	(422754, 123, '2015-03-01 00:13:35.000000', 'consum', 0.0211, 'lps'),
	(422755, 123, '2015-03-01 00:13:36.000000', 'consum', 0.0210, 'lps'),
	(422756, 123, '2015-03-01 00:13:37.000000', 'consum', 0.0222, 'lps'),
	(422757, 123, '2015-03-01 00:13:38.000000', 'consum', 0.0218, 'lps'),
	(422758, 123, '2015-03-01 00:13:39.000000', 'consum', 0.0213, 'lps'),
	(422759, 123, '2015-03-01 00:13:40.000000', 'consum', 0.0217, 'lps'),
	(422760, 123, '2015-03-01 00:13:41.000000', 'consum', 0.0221, 'lps'),
	(422761, 123, '2015-03-01 00:13:42.000000', 'consum', 0.0218, 'lps'),
	(422762, 123, '2015-03-01 00:13:43.000000', 'consum', 0.0220, 'lps'),
	(422763, 123, '2015-03-01 00:13:44.000000', 'consum', 0.0222, 'lps'),
	(422764, 123, '2015-03-01 00:13:45.000000', 'consum', 0.0214, 'lps'),
	(422765, 123, '2015-03-01 00:13:46.000000', 'consum', 0.0220, 'lps'),
	(422766, 123, '2015-03-01 00:13:47.000000', 'consum', 0.0210, 'lps'),
	(422767, 123, '2015-03-01 00:13:48.000000', 'consum', 0.0219, 'lps'),
	(422768, 123, '2015-03-01 00:13:49.000000', 'consum', 0.0215, 'lps'),
	(422769, 123, '2015-03-01 00:13:50.000000', 'consum', 0.0222, 'lps'),
	(422770, 123, '2015-03-01 00:13:51.000000', 'consum', 0.0218, 'lps'),
	(422771, 123, '2015-03-01 00:13:52.000000', 'consum', 0.0216, 'lps'),
	(422772, 123, '2015-03-01 00:13:53.000000', 'consum', 0.0213, 'lps'),
	(422773, 123, '2015-03-01 00:13:54.000000', 'consum', 0.0211, 'lps'),
	(422774, 123, '2015-03-01 00:13:55.000000', 'consum', 0.0217, 'lps'),
	(422775, 123, '2015-03-01 00:13:56.000000', 'consum', 0.0215, 'lps'),
	(422776, 123, '2015-03-01 00:13:57.000000', 'consum', 0.0217, 'lps'),
	(422777, 123, '2015-03-01 00:13:58.000000', 'consum', 0.0219, 'lps'),
	(422778, 123, '2015-03-01 00:13:59.000000', 'consum', 0.0219, 'lps'),
	(422779, 123, '2015-03-01 00:14:00.000000', 'consum', 0.0215, 'lps'),
	(422780, 123, '2015-03-01 00:14:01.000000', 'consum', 0.0222, 'lps'),
	(422781, 123, '2015-03-01 00:14:02.000000', 'consum', 0.0217, 'lps'),
	(422782, 123, '2015-03-01 00:14:03.000000', 'consum', 0.0220, 'lps'),
	(422783, 123, '2015-03-01 00:14:04.000000', 'consum', 0.0217, 'lps'),
	(422784, 123, '2015-03-01 00:14:05.000000', 'consum', 0.0215, 'lps'),
	(422785, 123, '2015-03-01 00:14:06.000000', 'consum', 0.0213, 'lps'),
	(422786, 123, '2015-03-01 00:14:07.000000', 'consum', 0.0211, 'lps'),
	(422787, 123, '2015-03-01 00:14:08.000000', 'consum', 0.0221, 'lps'),
	(422788, 123, '2015-03-01 00:14:09.000000', 'consum', 0.0210, 'lps'),
	(422789, 123, '2015-03-01 00:14:10.000000', 'consum', 0.0216, 'lps'),
	(422790, 123, '2015-03-01 00:14:11.000000', 'consum', 0.0213, 'lps'),
	(422791, 123, '2015-03-01 00:14:12.000000', 'consum', 0.0222, 'lps'),
	(422792, 123, '2015-03-01 00:14:13.000000', 'consum', 0.0222, 'lps'),
	(422793, 123, '2015-03-01 00:14:14.000000', 'consum', 0.0210, 'lps'),
	(422794, 123, '2015-03-01 00:14:15.000000', 'consum', 0.0213, 'lps'),
	(422795, 123, '2015-03-01 00:14:16.000000', 'consum', 0.0213, 'lps'),
	(422796, 123, '2015-03-01 00:14:17.000000', 'consum', 0.0214, 'lps'),
	(422797, 123, '2015-03-01 00:14:18.000000', 'consum', 0.0211, 'lps'),
	(422798, 123, '2015-03-01 00:14:19.000000', 'consum', 0.0214, 'lps'),
	(422799, 123, '2015-03-01 00:14:20.000000', 'consum', 0.0218, 'lps'),
	(422800, 123, '2015-03-01 00:14:21.000000', 'consum', 0.0222, 'lps'),
	(422801, 123, '2015-03-01 00:14:22.000000', 'consum', 0.0221, 'lps'),
	(422802, 123, '2015-03-01 00:14:23.000000', 'consum', 0.0218, 'lps'),
	(422803, 123, '2015-03-01 00:14:24.000000', 'consum', 0.0218, 'lps'),
	(422804, 123, '2015-03-01 00:14:25.000000', 'consum', 0.0212, 'lps'),
	(422805, 123, '2015-03-01 00:14:26.000000', 'consum', 0.0210, 'lps'),
	(422806, 123, '2015-03-01 00:14:27.000000', 'consum', 0.0219, 'lps'),
	(422807, 123, '2015-03-01 00:14:28.000000', 'consum', 0.0218, 'lps'),
	(422808, 123, '2015-03-01 00:14:29.000000', 'consum', 0.0220, 'lps'),
	(422809, 123, '2015-03-01 00:14:30.000000', 'consum', 0.0211, 'lps'),
	(422810, 123, '2015-03-01 00:14:31.000000', 'consum', 0.0210, 'lps'),
	(422811, 123, '2015-03-01 00:14:32.000000', 'consum', 0.0222, 'lps'),
	(422812, 123, '2015-03-01 00:14:33.000000', 'consum', 0.0218, 'lps'),
	(422813, 123, '2015-03-01 00:14:34.000000', 'consum', 0.0216, 'lps'),
	(422814, 123, '2015-03-01 00:14:35.000000', 'consum', 0.0214, 'lps'),
	(422815, 123, '2015-03-01 00:14:36.000000', 'consum', 0.0214, 'lps'),
	(422816, 123, '2015-03-01 00:14:37.000000', 'consum', 0.0220, 'lps'),
	(422817, 123, '2015-03-01 00:14:38.000000', 'consum', 0.0222, 'lps'),
	(422818, 123, '2015-03-01 00:14:39.000000', 'consum', 0.0215, 'lps'),
	(422819, 123, '2015-03-01 00:14:40.000000', 'consum', 0.0212, 'lps'),
	(422820, 123, '2015-03-01 00:14:41.000000', 'consum', 0.0217, 'lps'),
	(422821, 123, '2015-03-01 00:14:42.000000', 'consum', 0.0214, 'lps'),
	(422822, 123, '2015-03-01 00:14:43.000000', 'consum', 0.0210, 'lps'),
	(422823, 123, '2015-03-01 00:14:44.000000', 'consum', 0.0210, 'lps'),
	(422824, 123, '2015-03-01 00:14:45.000000', 'consum', 0.0213, 'lps'),
	(422825, 123, '2015-03-01 00:14:46.000000', 'consum', 0.0210, 'lps'),
	(422826, 123, '2015-03-01 00:14:47.000000', 'consum', 0.0215, 'lps'),
	(422827, 123, '2015-03-01 00:14:48.000000', 'consum', 0.0210, 'lps'),
	(422828, 123, '2015-03-01 00:14:49.000000', 'consum', 0.0220, 'lps'),
	(422829, 123, '2015-03-01 00:14:50.000000', 'consum', 0.0210, 'lps'),
	(422830, 123, '2015-03-01 00:14:51.000000', 'consum', 0.0220, 'lps'),
	(422831, 123, '2015-03-01 00:14:52.000000', 'consum', 0.0222, 'lps'),
	(422832, 123, '2015-03-01 00:14:53.000000', 'consum', 0.0214, 'lps'),
	(422833, 123, '2015-03-01 00:14:54.000000', 'consum', 0.0222, 'lps'),
	(422834, 123, '2015-03-01 00:14:55.000000', 'consum', 0.0217, 'lps'),
	(422835, 123, '2015-03-01 00:14:56.000000', 'consum', 0.0211, 'lps'),
	(422836, 123, '2015-03-01 00:14:57.000000', 'consum', 0.0221, 'lps'),
	(422837, 123, '2015-03-01 00:14:58.000000', 'consum', 0.0222, 'lps'),
	(422838, 123, '2015-03-01 00:14:59.000000', 'consum', 0.0211, 'lps'),
	(422839, 123, '2015-03-01 00:15:00.000000', 'consum', 0.0221, 'lps'),
	(422840, 123, '2015-03-01 00:15:01.000000', 'consum', 0.0221, 'lps'),
	(422841, 123, '2015-03-01 00:15:02.000000', 'consum', 0.0219, 'lps'),
	(422842, 123, '2015-03-01 00:15:03.000000', 'consum', 0.0212, 'lps'),
	(422843, 123, '2015-03-01 00:15:04.000000', 'consum', 0.0221, 'lps'),
	(422844, 123, '2015-03-01 00:15:05.000000', 'consum', 0.0217, 'lps'),
	(422845, 123, '2015-03-01 00:15:06.000000', 'consum', 0.0212, 'lps'),
	(422846, 123, '2015-03-01 00:15:07.000000', 'consum', 0.0214, 'lps'),
	(422847, 123, '2015-03-01 00:15:08.000000', 'consum', 0.0212, 'lps'),
	(422848, 123, '2015-03-01 00:15:09.000000', 'consum', 0.0220, 'lps'),
	(422849, 123, '2015-03-01 00:15:10.000000', 'consum', 0.0216, 'lps'),
	(422850, 123, '2015-03-01 00:15:11.000000', 'consum', 0.0212, 'lps'),
	(422851, 123, '2015-03-01 00:15:12.000000', 'consum', 0.0215, 'lps'),
	(422852, 123, '2015-03-01 00:15:13.000000', 'consum', 0.0216, 'lps'),
	(422853, 123, '2015-03-01 00:15:14.000000', 'consum', 0.0212, 'lps'),
	(422854, 123, '2015-03-01 00:15:15.000000', 'consum', 0.0217, 'lps'),
	(422855, 123, '2015-03-01 00:15:16.000000', 'consum', 0.0212, 'lps'),
	(422856, 123, '2015-03-01 00:15:17.000000', 'consum', 0.0214, 'lps'),
	(422857, 123, '2015-03-01 00:15:18.000000', 'consum', 0.0210, 'lps'),
	(422858, 123, '2015-03-01 00:15:19.000000', 'consum', 0.0213, 'lps'),
	(422859, 123, '2015-03-01 00:15:20.000000', 'consum', 0.0213, 'lps'),
	(422860, 123, '2015-03-01 00:15:21.000000', 'consum', 0.0215, 'lps'),
	(422861, 123, '2015-03-01 00:15:22.000000', 'consum', 0.0214, 'lps'),
	(422862, 123, '2015-03-01 00:15:23.000000', 'consum', 0.0215, 'lps'),
	(422863, 123, '2015-03-01 00:15:24.000000', 'consum', 0.0210, 'lps'),
	(422864, 123, '2015-03-01 00:15:25.000000', 'consum', 0.0221, 'lps'),
	(422865, 123, '2015-03-01 00:15:26.000000', 'consum', 0.0212, 'lps'),
	(422866, 123, '2015-03-01 00:15:27.000000', 'consum', 0.0216, 'lps'),
	(422867, 123, '2015-03-01 00:15:28.000000', 'consum', 0.0220, 'lps'),
	(422868, 123, '2015-03-01 00:15:29.000000', 'consum', 0.0216, 'lps'),
	(422869, 123, '2015-03-01 00:15:30.000000', 'consum', 0.0210, 'lps'),
	(422870, 123, '2015-03-01 00:15:31.000000', 'consum', 0.0217, 'lps'),
	(422871, 123, '2015-03-01 00:15:32.000000', 'consum', 0.0210, 'lps'),
	(422872, 123, '2015-03-01 00:15:33.000000', 'consum', 0.0215, 'lps'),
	(422873, 123, '2015-03-01 00:15:34.000000', 'consum', 0.0221, 'lps'),
	(422874, 123, '2015-03-01 00:15:35.000000', 'consum', 0.0211, 'lps'),
	(422875, 123, '2015-03-01 00:15:36.000000', 'consum', 0.0222, 'lps'),
	(422876, 123, '2015-03-01 00:15:37.000000', 'consum', 0.0217, 'lps'),
	(422877, 123, '2015-03-01 00:15:38.000000', 'consum', 0.0210, 'lps'),
	(422878, 123, '2015-03-01 00:15:39.000000', 'consum', 0.0213, 'lps'),
	(422879, 123, '2015-03-01 00:15:40.000000', 'consum', 0.0214, 'lps'),
	(422880, 123, '2015-03-01 00:15:41.000000', 'consum', 0.0220, 'lps'),
	(422881, 123, '2015-03-01 00:15:42.000000', 'consum', 0.0211, 'lps'),
	(422882, 123, '2015-03-01 00:15:43.000000', 'consum', 0.0212, 'lps'),
	(422883, 123, '2015-03-01 00:15:44.000000', 'consum', 0.0218, 'lps'),
	(422884, 123, '2015-03-01 00:15:45.000000', 'consum', 0.0216, 'lps'),
	(422885, 123, '2015-03-01 00:15:46.000000', 'consum', 0.0216, 'lps'),
	(422886, 123, '2015-03-01 00:15:47.000000', 'consum', 0.0211, 'lps'),
	(422887, 123, '2015-03-01 00:15:48.000000', 'consum', 0.0222, 'lps'),
	(422888, 123, '2015-03-01 00:15:49.000000', 'consum', 0.0217, 'lps'),
	(422889, 123, '2015-03-01 00:15:50.000000', 'consum', 0.0221, 'lps'),
	(422890, 123, '2015-03-01 00:15:51.000000', 'consum', 0.0221, 'lps'),
	(422891, 123, '2015-03-01 00:15:52.000000', 'consum', 0.0218, 'lps'),
	(422892, 123, '2015-03-01 00:15:53.000000', 'consum', 0.0217, 'lps'),
	(422893, 123, '2015-03-01 00:15:54.000000', 'consum', 0.0222, 'lps'),
	(422894, 123, '2015-03-01 00:15:55.000000', 'consum', 0.0222, 'lps'),
	(422895, 123, '2015-03-01 00:15:56.000000', 'consum', 0.0222, 'lps'),
	(422896, 123, '2015-03-01 00:15:57.000000', 'consum', 0.0222, 'lps'),
	(422897, 123, '2015-03-01 00:15:58.000000', 'consum', 0.0221, 'lps'),
	(422898, 123, '2015-03-01 00:15:59.000000', 'consum', 0.0216, 'lps'),
	(422899, 123, '2015-03-01 00:16:00.000000', 'consum', 0.0220, 'lps'),
	(422900, 123, '2015-03-01 00:16:01.000000', 'consum', 0.0216, 'lps'),
	(422901, 123, '2015-03-01 00:16:02.000000', 'consum', 0.0212, 'lps'),
	(422902, 123, '2015-03-01 00:16:03.000000', 'consum', 0.0213, 'lps'),
	(422903, 123, '2015-03-01 00:16:04.000000', 'consum', 0.0221, 'lps'),
	(422904, 123, '2015-03-01 00:16:05.000000', 'consum', 0.0216, 'lps'),
	(422905, 123, '2015-03-01 00:16:06.000000', 'consum', 0.0210, 'lps'),
	(422906, 123, '2015-03-01 00:16:07.000000', 'consum', 0.0219, 'lps'),
	(422907, 123, '2015-03-01 00:16:08.000000', 'consum', 0.0217, 'lps'),
	(422908, 123, '2015-03-01 00:16:09.000000', 'consum', 0.0218, 'lps'),
	(422909, 123, '2015-03-01 00:16:10.000000', 'consum', 0.0215, 'lps'),
	(422910, 123, '2015-03-01 00:16:11.000000', 'consum', 0.0213, 'lps'),
	(422911, 123, '2015-03-01 00:16:12.000000', 'consum', 0.0222, 'lps'),
	(422912, 123, '2015-03-01 00:16:13.000000', 'consum', 0.0221, 'lps'),
	(422913, 123, '2015-03-01 00:16:14.000000', 'consum', 0.0218, 'lps'),
	(422914, 123, '2015-03-01 00:16:15.000000', 'consum', 0.0220, 'lps'),
	(422915, 123, '2015-03-01 00:16:16.000000', 'consum', 0.0220, 'lps'),
	(422916, 123, '2015-03-01 00:16:17.000000', 'consum', 0.0218, 'lps'),
	(422917, 123, '2015-03-01 00:16:18.000000', 'consum', 0.0221, 'lps'),
	(422918, 123, '2015-03-01 00:16:19.000000', 'consum', 0.0216, 'lps'),
	(422919, 123, '2015-03-01 00:16:20.000000', 'consum', 0.0220, 'lps'),
	(422920, 123, '2015-03-01 00:16:21.000000', 'consum', 0.0218, 'lps'),
	(422921, 123, '2015-03-01 00:16:22.000000', 'consum', 0.0221, 'lps'),
	(422922, 123, '2015-03-01 00:16:23.000000', 'consum', 0.0213, 'lps'),
	(422923, 123, '2015-03-01 00:16:24.000000', 'consum', 0.0218, 'lps'),
	(422924, 123, '2015-03-01 00:16:25.000000', 'consum', 0.0216, 'lps'),
	(422925, 123, '2015-03-01 00:16:26.000000', 'consum', 0.0219, 'lps'),
	(422926, 123, '2015-03-01 00:16:27.000000', 'consum', 0.0210, 'lps'),
	(422927, 123, '2015-03-01 00:16:28.000000', 'consum', 0.0222, 'lps'),
	(422928, 123, '2015-03-01 00:16:29.000000', 'consum', 0.0221, 'lps'),
	(422929, 123, '2015-03-01 00:16:30.000000', 'consum', 0.0215, 'lps'),
	(422930, 123, '2015-03-01 00:16:31.000000', 'consum', 0.0214, 'lps'),
	(422931, 123, '2015-03-01 00:16:32.000000', 'consum', 0.0215, 'lps'),
	(422932, 123, '2015-03-01 00:16:33.000000', 'consum', 0.0211, 'lps'),
	(422933, 123, '2015-03-01 00:16:34.000000', 'consum', 0.0216, 'lps'),
	(422934, 123, '2015-03-01 00:16:35.000000', 'consum', 0.0210, 'lps'),
	(422935, 123, '2015-03-01 00:16:36.000000', 'consum', 0.0220, 'lps'),
	(422936, 123, '2015-03-01 00:16:37.000000', 'consum', 0.0219, 'lps'),
	(422937, 123, '2015-03-01 00:16:38.000000', 'consum', 0.0215, 'lps'),
	(422938, 123, '2015-03-01 00:16:39.000000', 'consum', 0.0220, 'lps'),
	(422939, 123, '2015-03-01 00:16:40.000000', 'consum', 0.0221, 'lps'),
	(422940, 123, '2015-03-01 00:16:41.000000', 'consum', 0.0222, 'lps'),
	(422941, 123, '2015-03-01 00:16:42.000000', 'consum', 0.0211, 'lps'),
	(422942, 123, '2015-03-01 00:16:43.000000', 'consum', 0.0218, 'lps'),
	(422943, 123, '2015-03-01 00:16:44.000000', 'consum', 0.0222, 'lps'),
	(422944, 123, '2015-03-01 00:16:45.000000', 'consum', 0.0222, 'lps'),
	(422945, 123, '2015-03-01 00:16:46.000000', 'consum', 0.0219, 'lps'),
	(422946, 123, '2015-03-01 00:16:47.000000', 'consum', 0.0219, 'lps'),
	(422947, 123, '2015-03-01 00:16:48.000000', 'consum', 0.0218, 'lps'),
	(422948, 123, '2015-03-01 00:16:49.000000', 'consum', 0.0210, 'lps'),
	(422949, 123, '2015-03-01 00:16:50.000000', 'consum', 0.0212, 'lps'),
	(422950, 123, '2015-03-01 00:16:51.000000', 'consum', 0.0219, 'lps'),
	(422951, 123, '2015-03-01 00:16:52.000000', 'consum', 0.0210, 'lps'),
	(422952, 123, '2015-03-01 00:16:53.000000', 'consum', 0.0222, 'lps'),
	(422953, 123, '2015-03-01 00:16:54.000000', 'consum', 0.0221, 'lps'),
	(422954, 123, '2015-03-01 00:16:55.000000', 'consum', 0.0215, 'lps'),
	(422955, 123, '2015-03-01 00:16:56.000000', 'consum', 0.0217, 'lps'),
	(422956, 123, '2015-03-01 00:16:57.000000', 'consum', 0.0215, 'lps'),
	(422957, 123, '2015-03-01 00:16:58.000000', 'consum', 0.0218, 'lps'),
	(422958, 123, '2015-03-01 00:16:59.000000', 'consum', 0.0219, 'lps'),
	(422959, 123, '2015-03-01 00:17:00.000000', 'consum', 0.0222, 'lps'),
	(422960, 123, '2015-03-01 00:17:01.000000', 'consum', 0.0215, 'lps'),
	(422961, 123, '2015-03-01 00:17:02.000000', 'consum', 0.0212, 'lps'),
	(422962, 123, '2015-03-01 00:17:03.000000', 'consum', 0.0220, 'lps'),
	(422963, 123, '2015-03-01 00:17:04.000000', 'consum', 0.0214, 'lps'),
	(422964, 123, '2015-03-01 00:17:05.000000', 'consum', 0.0212, 'lps'),
	(422965, 123, '2015-03-01 00:17:06.000000', 'consum', 0.0211, 'lps'),
	(422966, 123, '2015-03-01 00:17:07.000000', 'consum', 0.0222, 'lps'),
	(422967, 123, '2015-03-01 00:17:08.000000', 'consum', 0.0216, 'lps'),
	(422968, 123, '2015-03-01 00:17:09.000000', 'consum', 0.0219, 'lps'),
	(422969, 123, '2015-03-01 00:17:10.000000', 'consum', 0.0222, 'lps'),
	(422970, 123, '2015-03-01 00:17:11.000000', 'consum', 0.0219, 'lps'),
	(422971, 123, '2015-03-01 00:17:12.000000', 'consum', 0.0217, 'lps'),
	(422972, 123, '2015-03-01 00:17:13.000000', 'consum', 0.0220, 'lps'),
	(422973, 123, '2015-03-01 00:17:14.000000', 'consum', 0.0215, 'lps'),
	(422974, 123, '2015-03-01 00:17:15.000000', 'consum', 0.0217, 'lps'),
	(422975, 123, '2015-03-01 00:17:16.000000', 'consum', 0.0218, 'lps'),
	(422976, 123, '2015-03-01 00:17:17.000000', 'consum', 0.0218, 'lps'),
	(422977, 123, '2015-03-01 00:17:18.000000', 'consum', 0.0214, 'lps'),
	(422978, 123, '2015-03-01 00:17:19.000000', 'consum', 0.0217, 'lps'),
	(422979, 123, '2015-03-01 00:17:20.000000', 'consum', 0.0221, 'lps'),
	(422980, 123, '2015-03-01 00:17:21.000000', 'consum', 0.0218, 'lps'),
	(422981, 123, '2015-03-01 00:17:22.000000', 'consum', 0.0217, 'lps'),
	(422982, 123, '2015-03-01 00:17:23.000000', 'consum', 0.0221, 'lps'),
	(422983, 123, '2015-03-01 00:17:24.000000', 'consum', 0.0218, 'lps'),
	(422984, 123, '2015-03-01 00:17:25.000000', 'consum', 0.0218, 'lps'),
	(422985, 123, '2015-03-01 00:17:26.000000', 'consum', 0.0213, 'lps'),
	(422986, 123, '2015-03-01 00:17:27.000000', 'consum', 0.0215, 'lps'),
	(422987, 123, '2015-03-01 00:17:28.000000', 'consum', 0.0214, 'lps'),
	(422988, 123, '2015-03-01 00:17:29.000000', 'consum', 0.0215, 'lps'),
	(422989, 123, '2015-03-01 00:17:30.000000', 'consum', 0.0210, 'lps'),
	(422990, 123, '2015-03-01 00:17:31.000000', 'consum', 0.0211, 'lps'),
	(422991, 123, '2015-03-01 00:17:32.000000', 'consum', 0.0212, 'lps'),
	(422992, 123, '2015-03-01 00:17:33.000000', 'consum', 0.0220, 'lps'),
	(422993, 123, '2015-03-01 00:17:34.000000', 'consum', 0.0214, 'lps'),
	(422994, 123, '2015-03-01 00:17:35.000000', 'consum', 0.0214, 'lps'),
	(422995, 123, '2015-03-01 00:17:36.000000', 'consum', 0.0219, 'lps'),
	(422996, 123, '2015-03-01 00:17:37.000000', 'consum', 0.0218, 'lps'),
	(422997, 123, '2015-03-01 00:17:38.000000', 'consum', 0.0211, 'lps'),
	(422998, 123, '2015-03-01 00:17:39.000000', 'consum', 0.0217, 'lps'),
	(422999, 123, '2015-03-01 00:17:40.000000', 'consum', 0.0216, 'lps'),
	(423000, 123, '2015-03-01 00:17:41.000000', 'consum', 0.0221, 'lps'),
	(423001, 123, '2015-03-01 00:17:42.000000', 'consum', 0.0219, 'lps'),
	(423002, 123, '2015-03-01 00:17:43.000000', 'consum', 0.0212, 'lps'),
	(423003, 123, '2015-03-01 00:17:44.000000', 'consum', 0.0217, 'lps'),
	(423004, 123, '2015-03-01 00:17:45.000000', 'consum', 0.0213, 'lps'),
	(423005, 123, '2015-03-01 00:17:46.000000', 'consum', 0.0218, 'lps'),
	(423006, 123, '2015-03-01 00:17:47.000000', 'consum', 0.0214, 'lps'),
	(423007, 123, '2015-03-01 00:17:48.000000', 'consum', 0.0222, 'lps'),
	(423008, 123, '2015-03-01 00:17:49.000000', 'consum', 0.0218, 'lps'),
	(423009, 123, '2015-03-01 00:17:50.000000', 'consum', 0.0213, 'lps'),
	(423010, 123, '2015-03-01 00:17:51.000000', 'consum', 0.0217, 'lps'),
	(423011, 123, '2015-03-01 00:17:52.000000', 'consum', 0.0210, 'lps'),
	(423012, 123, '2015-03-01 00:17:53.000000', 'consum', 0.0216, 'lps'),
	(423013, 123, '2015-03-01 00:17:54.000000', 'consum', 0.0213, 'lps'),
	(423014, 123, '2015-03-01 00:17:55.000000', 'consum', 0.0220, 'lps'),
	(423015, 123, '2015-03-01 00:17:56.000000', 'consum', 0.0214, 'lps'),
	(423016, 123, '2015-03-01 00:17:57.000000', 'consum', 0.0212, 'lps'),
	(423017, 123, '2015-03-01 00:17:58.000000', 'consum', 0.0220, 'lps'),
	(423018, 123, '2015-03-01 00:17:59.000000', 'consum', 0.0219, 'lps'),
	(423019, 123, '2015-03-01 00:18:00.000000', 'consum', 0.0222, 'lps'),
	(423020, 123, '2015-03-01 00:18:01.000000', 'consum', 0.0219, 'lps'),
	(423021, 123, '2015-03-01 00:18:02.000000', 'consum', 0.0222, 'lps'),
	(423022, 123, '2015-03-01 00:18:03.000000', 'consum', 0.0214, 'lps'),
	(423023, 123, '2015-03-01 00:18:04.000000', 'consum', 0.0220, 'lps'),
	(423024, 123, '2015-03-01 00:18:05.000000', 'consum', 0.0212, 'lps'),
	(423025, 123, '2015-03-01 00:18:06.000000', 'consum', 0.0216, 'lps'),
	(423026, 123, '2015-03-01 00:18:07.000000', 'consum', 0.0210, 'lps'),
	(423027, 123, '2015-03-01 00:18:08.000000', 'consum', 0.0218, 'lps'),
	(423028, 123, '2015-03-01 00:18:09.000000', 'consum', 0.0222, 'lps'),
	(423029, 123, '2015-03-01 00:18:10.000000', 'consum', 0.0222, 'lps'),
	(423030, 123, '2015-03-01 00:18:11.000000', 'consum', 0.0222, 'lps'),
	(423031, 123, '2015-03-01 00:18:12.000000', 'consum', 0.0222, 'lps'),
	(423032, 123, '2015-03-01 00:18:13.000000', 'consum', 0.0221, 'lps'),
	(423033, 123, '2015-03-01 00:18:14.000000', 'consum', 0.0218, 'lps'),
	(423034, 123, '2015-03-01 00:18:15.000000', 'consum', 0.0214, 'lps'),
	(423035, 123, '2015-03-01 00:18:16.000000', 'consum', 0.0210, 'lps'),
	(423036, 123, '2015-03-01 00:18:17.000000', 'consum', 0.0222, 'lps'),
	(423037, 123, '2015-03-01 00:18:18.000000', 'consum', 0.0220, 'lps'),
	(423038, 123, '2015-03-01 00:18:19.000000', 'consum', 0.0212, 'lps'),
	(423039, 123, '2015-03-01 00:18:20.000000', 'consum', 0.0217, 'lps'),
	(423040, 123, '2015-03-01 00:18:21.000000', 'consum', 0.0214, 'lps'),
	(423041, 123, '2015-03-01 00:18:22.000000', 'consum', 0.0221, 'lps'),
	(423042, 123, '2015-03-01 00:18:23.000000', 'consum', 0.0216, 'lps'),
	(423043, 123, '2015-03-01 00:18:24.000000', 'consum', 0.0221, 'lps'),
	(423044, 123, '2015-03-01 00:18:25.000000', 'consum', 0.0210, 'lps'),
	(423045, 123, '2015-03-01 00:18:26.000000', 'consum', 0.0213, 'lps'),
	(423046, 123, '2015-03-01 00:18:27.000000', 'consum', 0.0214, 'lps'),
	(423047, 123, '2015-03-01 00:18:28.000000', 'consum', 0.0219, 'lps'),
	(423048, 123, '2015-03-01 00:18:29.000000', 'consum', 0.0220, 'lps'),
	(423049, 123, '2015-03-01 00:18:30.000000', 'consum', 0.0221, 'lps'),
	(423050, 123, '2015-03-01 00:18:31.000000', 'consum', 0.0211, 'lps'),
	(423051, 123, '2015-03-01 00:18:32.000000', 'consum', 0.0219, 'lps'),
	(423052, 123, '2015-03-01 00:18:33.000000', 'consum', 0.0214, 'lps'),
	(423053, 123, '2015-03-01 00:18:34.000000', 'consum', 0.0216, 'lps'),
	(423054, 123, '2015-03-01 00:18:35.000000', 'consum', 0.0215, 'lps'),
	(423055, 123, '2015-03-01 00:18:36.000000', 'consum', 0.0218, 'lps'),
	(423056, 123, '2015-03-01 00:18:37.000000', 'consum', 0.0210, 'lps'),
	(423057, 123, '2015-03-01 00:18:38.000000', 'consum', 0.0211, 'lps'),
	(423058, 123, '2015-03-01 00:18:39.000000', 'consum', 0.0216, 'lps'),
	(423059, 123, '2015-03-01 00:18:40.000000', 'consum', 0.0213, 'lps'),
	(423060, 123, '2015-03-01 00:18:41.000000', 'consum', 0.0218, 'lps'),
	(423061, 123, '2015-03-01 00:18:42.000000', 'consum', 0.0216, 'lps'),
	(423062, 123, '2015-03-01 00:18:43.000000', 'consum', 0.0217, 'lps'),
	(423063, 123, '2015-03-01 00:18:44.000000', 'consum', 0.0213, 'lps'),
	(423064, 123, '2015-03-01 00:18:45.000000', 'consum', 0.0217, 'lps'),
	(423065, 123, '2015-03-01 00:18:46.000000', 'consum', 0.0210, 'lps'),
	(423066, 123, '2015-03-01 00:18:47.000000', 'consum', 0.0218, 'lps'),
	(423067, 123, '2015-03-01 00:18:48.000000', 'consum', 0.0213, 'lps'),
	(423068, 123, '2015-03-01 00:18:49.000000', 'consum', 0.0211, 'lps'),
	(423069, 123, '2015-03-01 00:18:50.000000', 'consum', 0.0221, 'lps'),
	(423070, 123, '2015-03-01 00:18:51.000000', 'consum', 0.0210, 'lps'),
	(423071, 123, '2015-03-01 00:18:52.000000', 'consum', 0.0218, 'lps'),
	(423072, 123, '2015-03-01 00:18:53.000000', 'consum', 0.0211, 'lps'),
	(423073, 123, '2015-03-01 00:18:54.000000', 'consum', 0.0216, 'lps'),
	(423074, 123, '2015-03-01 00:18:55.000000', 'consum', 0.0211, 'lps'),
	(423075, 123, '2015-03-01 00:18:56.000000', 'consum', 0.0211, 'lps'),
	(423076, 123, '2015-03-01 00:18:57.000000', 'consum', 0.0213, 'lps'),
	(423077, 123, '2015-03-01 00:18:58.000000', 'consum', 0.0221, 'lps'),
	(423078, 123, '2015-03-01 00:18:59.000000', 'consum', 0.0218, 'lps'),
	(423079, 123, '2015-03-01 00:19:00.000000', 'consum', 0.0220, 'lps'),
	(423080, 123, '2015-03-01 00:19:01.000000', 'consum', 0.0222, 'lps'),
	(423081, 123, '2015-03-01 00:19:02.000000', 'consum', 0.0214, 'lps'),
	(423082, 123, '2015-03-01 00:19:03.000000', 'consum', 0.0220, 'lps'),
	(423083, 123, '2015-03-01 00:19:04.000000', 'consum', 0.0222, 'lps'),
	(423084, 123, '2015-03-01 00:19:05.000000', 'consum', 0.0215, 'lps'),
	(423085, 123, '2015-03-01 00:19:06.000000', 'consum', 0.0211, 'lps'),
	(423086, 123, '2015-03-01 00:19:07.000000', 'consum', 0.0217, 'lps'),
	(423087, 123, '2015-03-01 00:19:08.000000', 'consum', 0.0213, 'lps'),
	(423088, 123, '2015-03-01 00:19:09.000000', 'consum', 0.0218, 'lps'),
	(423089, 123, '2015-03-01 00:19:10.000000', 'consum', 0.0215, 'lps'),
	(423090, 123, '2015-03-01 00:19:11.000000', 'consum', 0.0211, 'lps'),
	(423091, 123, '2015-03-01 00:19:12.000000', 'consum', 0.0214, 'lps'),
	(423092, 123, '2015-03-01 00:19:13.000000', 'consum', 0.0215, 'lps'),
	(423093, 123, '2015-03-01 00:19:14.000000', 'consum', 0.0221, 'lps'),
	(423094, 123, '2015-03-01 00:19:15.000000', 'consum', 0.0214, 'lps'),
	(423095, 123, '2015-03-01 00:19:16.000000', 'consum', 0.0211, 'lps'),
	(423096, 123, '2015-03-01 00:19:17.000000', 'consum', 0.0215, 'lps'),
	(423097, 123, '2015-03-01 00:19:18.000000', 'consum', 0.0219, 'lps'),
	(423098, 123, '2015-03-01 00:19:19.000000', 'consum', 0.0215, 'lps'),
	(423099, 123, '2015-03-01 00:19:20.000000', 'consum', 0.0222, 'lps'),
	(423100, 123, '2015-03-01 00:19:21.000000', 'consum', 0.0215, 'lps'),
	(423101, 123, '2015-03-01 00:19:22.000000', 'consum', 0.0212, 'lps'),
	(423102, 123, '2015-03-01 00:19:23.000000', 'consum', 0.0219, 'lps'),
	(423103, 123, '2015-03-01 00:19:24.000000', 'consum', 0.0211, 'lps'),
	(423104, 123, '2015-03-01 00:19:25.000000', 'consum', 0.0216, 'lps'),
	(423105, 123, '2015-03-01 00:19:26.000000', 'consum', 0.0222, 'lps'),
	(423106, 123, '2015-03-01 00:19:27.000000', 'consum', 0.0216, 'lps'),
	(423107, 123, '2015-03-01 00:19:28.000000', 'consum', 0.0216, 'lps'),
	(423108, 123, '2015-03-01 00:19:29.000000', 'consum', 0.0211, 'lps'),
	(423109, 123, '2015-03-01 00:19:30.000000', 'consum', 0.0210, 'lps'),
	(423110, 123, '2015-03-01 00:19:31.000000', 'consum', 0.0220, 'lps'),
	(423111, 123, '2015-03-01 00:19:32.000000', 'consum', 0.0210, 'lps'),
	(423112, 123, '2015-03-01 00:19:33.000000', 'consum', 0.0218, 'lps'),
	(423113, 123, '2015-03-01 00:19:34.000000', 'consum', 0.0214, 'lps'),
	(423114, 123, '2015-03-01 00:19:35.000000', 'consum', 0.0217, 'lps'),
	(423115, 123, '2015-03-01 00:19:36.000000', 'consum', 0.0222, 'lps'),
	(423116, 123, '2015-03-01 00:19:37.000000', 'consum', 0.0212, 'lps'),
	(423117, 123, '2015-03-01 00:19:38.000000', 'consum', 0.0221, 'lps'),
	(423118, 123, '2015-03-01 00:19:39.000000', 'consum', 0.0221, 'lps'),
	(423119, 123, '2015-03-01 00:19:40.000000', 'consum', 0.0220, 'lps'),
	(423120, 123, '2015-03-01 00:19:41.000000', 'consum', 0.0214, 'lps'),
	(423121, 123, '2015-03-01 00:19:42.000000', 'consum', 0.0214, 'lps'),
	(423122, 123, '2015-03-01 00:19:43.000000', 'consum', 0.0220, 'lps'),
	(423123, 123, '2015-03-01 00:19:44.000000', 'consum', 0.0221, 'lps'),
	(423124, 123, '2015-03-01 00:19:45.000000', 'consum', 0.0211, 'lps'),
	(423125, 123, '2015-03-01 00:19:46.000000', 'consum', 0.0222, 'lps'),
	(423126, 123, '2015-03-01 00:19:47.000000', 'consum', 0.0214, 'lps'),
	(423127, 123, '2015-03-01 00:19:48.000000', 'consum', 0.0210, 'lps'),
	(423128, 123, '2015-03-01 00:19:49.000000', 'consum', 0.0222, 'lps'),
	(423129, 123, '2015-03-01 00:19:50.000000', 'consum', 0.0221, 'lps'),
	(423130, 123, '2015-03-01 00:19:51.000000', 'consum', 0.0216, 'lps'),
	(423131, 123, '2015-03-01 00:19:52.000000', 'consum', 0.0219, 'lps'),
	(423132, 123, '2015-03-01 00:19:53.000000', 'consum', 0.0212, 'lps'),
	(423133, 123, '2015-03-01 00:19:54.000000', 'consum', 0.0220, 'lps'),
	(423134, 123, '2015-03-01 00:19:55.000000', 'consum', 0.0216, 'lps'),
	(423135, 123, '2015-03-01 00:19:56.000000', 'consum', 0.0211, 'lps'),
	(423136, 123, '2015-03-01 00:19:57.000000', 'consum', 0.0212, 'lps'),
	(423137, 123, '2015-03-01 00:19:58.000000', 'consum', 0.0215, 'lps'),
	(423138, 123, '2015-03-01 00:19:59.000000', 'consum', 0.0216, 'lps'),
	(423139, 123, '2015-03-01 00:20:00.000000', 'consum', 0.0213, 'lps'),
	(423140, 123, '2015-03-01 00:20:01.000000', 'consum', 0.0219, 'lps'),
	(423141, 123, '2015-03-01 00:20:02.000000', 'consum', 0.0222, 'lps'),
	(423142, 123, '2015-03-01 00:20:03.000000', 'consum', 0.0217, 'lps'),
	(423143, 123, '2015-03-01 00:20:04.000000', 'consum', 0.0212, 'lps'),
	(423144, 123, '2015-03-01 00:20:05.000000', 'consum', 0.0222, 'lps'),
	(423145, 123, '2015-03-01 00:20:06.000000', 'consum', 0.0214, 'lps'),
	(423146, 123, '2015-03-01 00:20:07.000000', 'consum', 0.0222, 'lps'),
	(423147, 123, '2015-03-01 00:20:08.000000', 'consum', 0.0218, 'lps'),
	(423148, 123, '2015-03-01 00:20:09.000000', 'consum', 0.0216, 'lps'),
	(423149, 123, '2015-03-01 00:20:10.000000', 'consum', 0.0216, 'lps'),
	(423150, 123, '2015-03-01 00:20:11.000000', 'consum', 0.0221, 'lps'),
	(423151, 123, '2015-03-01 00:20:12.000000', 'consum', 0.0222, 'lps'),
	(423152, 123, '2015-03-01 00:20:13.000000', 'consum', 0.0211, 'lps'),
	(423153, 123, '2015-03-01 00:20:14.000000', 'consum', 0.0219, 'lps'),
	(423154, 123, '2015-03-01 00:20:15.000000', 'consum', 0.0215, 'lps'),
	(423155, 123, '2015-03-01 00:20:16.000000', 'consum', 0.0222, 'lps'),
	(423156, 123, '2015-03-01 00:20:17.000000', 'consum', 0.0215, 'lps'),
	(423157, 123, '2015-03-01 00:20:18.000000', 'consum', 0.0212, 'lps'),
	(423158, 123, '2015-03-01 00:20:19.000000', 'consum', 0.0221, 'lps'),
	(423159, 123, '2015-03-01 00:20:20.000000', 'consum', 0.0219, 'lps'),
	(423160, 123, '2015-03-01 00:20:21.000000', 'consum', 0.0212, 'lps'),
	(423161, 123, '2015-03-01 00:20:22.000000', 'consum', 0.0217, 'lps'),
	(423162, 123, '2015-03-01 00:20:23.000000', 'consum', 0.0213, 'lps'),
	(423163, 123, '2015-03-01 00:20:24.000000', 'consum', 0.0217, 'lps'),
	(423164, 123, '2015-03-01 00:20:25.000000', 'consum', 0.0212, 'lps'),
	(423165, 123, '2015-03-01 00:20:26.000000', 'consum', 0.0211, 'lps'),
	(423166, 123, '2015-03-01 00:20:27.000000', 'consum', 0.0222, 'lps'),
	(423167, 123, '2015-03-01 00:20:28.000000', 'consum', 0.0217, 'lps'),
	(423168, 123, '2015-03-01 00:20:29.000000', 'consum', 0.0211, 'lps'),
	(423169, 123, '2015-03-01 00:20:30.000000', 'consum', 0.0218, 'lps'),
	(423170, 123, '2015-03-01 00:20:31.000000', 'consum', 0.0221, 'lps'),
	(423171, 123, '2015-03-01 00:20:32.000000', 'consum', 0.0216, 'lps'),
	(423172, 123, '2015-03-01 00:20:33.000000', 'consum', 0.0222, 'lps'),
	(423173, 123, '2015-03-01 00:20:34.000000', 'consum', 0.0211, 'lps'),
	(423174, 123, '2015-03-01 00:20:35.000000', 'consum', 0.0220, 'lps'),
	(423175, 123, '2015-03-01 00:20:36.000000', 'consum', 0.0220, 'lps'),
	(423176, 123, '2015-03-01 00:20:37.000000', 'consum', 0.0214, 'lps'),
	(423177, 123, '2015-03-01 00:20:38.000000', 'consum', 0.0217, 'lps'),
	(423178, 123, '2015-03-01 00:20:39.000000', 'consum', 0.0220, 'lps'),
	(423179, 123, '2015-03-01 00:20:40.000000', 'consum', 0.0212, 'lps'),
	(423180, 123, '2015-03-01 00:20:41.000000', 'consum', 0.0219, 'lps'),
	(423181, 123, '2015-03-01 00:20:42.000000', 'consum', 0.0222, 'lps'),
	(423182, 123, '2015-03-01 00:20:43.000000', 'consum', 0.0219, 'lps'),
	(423183, 123, '2015-03-01 00:20:44.000000', 'consum', 0.0221, 'lps'),
	(423184, 123, '2015-03-01 00:20:45.000000', 'consum', 0.0222, 'lps'),
	(423185, 123, '2015-03-01 00:20:46.000000', 'consum', 0.0212, 'lps'),
	(423186, 123, '2015-03-01 00:20:47.000000', 'consum', 0.0222, 'lps'),
	(423187, 123, '2015-03-01 00:20:48.000000', 'consum', 0.0214, 'lps'),
	(423188, 123, '2015-03-01 00:20:49.000000', 'consum', 0.0221, 'lps'),
	(423189, 123, '2015-03-01 00:20:50.000000', 'consum', 0.0214, 'lps'),
	(423190, 123, '2015-03-01 00:20:51.000000', 'consum', 0.0210, 'lps'),
	(423191, 123, '2015-03-01 00:20:52.000000', 'consum', 0.0210, 'lps'),
	(423192, 123, '2015-03-01 00:20:53.000000', 'consum', 0.0211, 'lps'),
	(423193, 123, '2015-03-01 00:20:54.000000', 'consum', 0.0217, 'lps'),
	(423194, 123, '2015-03-01 00:20:55.000000', 'consum', 0.0216, 'lps'),
	(423195, 123, '2015-03-01 00:20:56.000000', 'consum', 0.0219, 'lps'),
	(423196, 123, '2015-03-01 00:20:57.000000', 'consum', 0.0210, 'lps'),
	(423197, 123, '2015-03-01 00:20:58.000000', 'consum', 0.0210, 'lps'),
	(423198, 123, '2015-03-01 00:20:59.000000', 'consum', 0.0210, 'lps'),
	(423199, 123, '2015-03-01 00:21:00.000000', 'consum', 0.0210, 'lps'),
	(423200, 123, '2015-03-01 00:21:01.000000', 'consum', 0.0210, 'lps'),
	(423201, 123, '2015-03-01 00:21:02.000000', 'consum', 0.0213, 'lps'),
	(423202, 123, '2015-03-01 00:21:03.000000', 'consum', 0.0222, 'lps'),
	(423203, 123, '2015-03-01 00:21:04.000000', 'consum', 0.0213, 'lps'),
	(423204, 123, '2015-03-01 00:21:05.000000', 'consum', 0.0215, 'lps'),
	(423205, 123, '2015-03-01 00:21:06.000000', 'consum', 0.0213, 'lps'),
	(423206, 123, '2015-03-01 00:21:07.000000', 'consum', 0.0211, 'lps'),
	(423207, 123, '2015-03-01 00:21:08.000000', 'consum', 0.0220, 'lps'),
	(423208, 123, '2015-03-01 00:21:09.000000', 'consum', 0.0217, 'lps'),
	(423209, 123, '2015-03-01 00:21:10.000000', 'consum', 0.0215, 'lps'),
	(423210, 123, '2015-03-01 00:21:11.000000', 'consum', 0.0214, 'lps'),
	(423211, 123, '2015-03-01 00:21:12.000000', 'consum', 0.0214, 'lps'),
	(423212, 123, '2015-03-01 00:21:13.000000', 'consum', 0.0222, 'lps'),
	(423213, 123, '2015-03-01 00:21:14.000000', 'consum', 0.0219, 'lps'),
	(423214, 123, '2015-03-01 00:21:15.000000', 'consum', 0.0220, 'lps'),
	(423215, 123, '2015-03-01 00:21:16.000000', 'consum', 0.0220, 'lps'),
	(423216, 123, '2015-03-01 00:21:17.000000', 'consum', 0.0216, 'lps'),
	(423217, 123, '2015-03-01 00:21:18.000000', 'consum', 0.0211, 'lps'),
	(423218, 123, '2015-03-01 00:21:19.000000', 'consum', 0.0211, 'lps'),
	(423219, 123, '2015-03-01 00:21:20.000000', 'consum', 0.0212, 'lps'),
	(423220, 123, '2015-03-01 00:21:21.000000', 'consum', 0.0216, 'lps'),
	(423221, 123, '2015-03-01 00:21:22.000000', 'consum', 0.0222, 'lps'),
	(423222, 123, '2015-03-01 00:21:23.000000', 'consum', 0.0212, 'lps'),
	(423223, 123, '2015-03-01 00:21:24.000000', 'consum', 0.0212, 'lps'),
	(423224, 123, '2015-03-01 00:21:25.000000', 'consum', 0.0214, 'lps'),
	(423225, 123, '2015-03-01 00:21:26.000000', 'consum', 0.0214, 'lps'),
	(423226, 123, '2015-03-01 00:21:27.000000', 'consum', 0.0216, 'lps'),
	(423227, 123, '2015-03-01 00:21:28.000000', 'consum', 0.0214, 'lps'),
	(423228, 123, '2015-03-01 00:21:29.000000', 'consum', 0.0214, 'lps'),
	(423229, 123, '2015-03-01 00:21:30.000000', 'consum', 0.0220, 'lps'),
	(423230, 123, '2015-03-01 00:21:31.000000', 'consum', 0.0222, 'lps'),
	(423231, 123, '2015-03-01 00:21:32.000000', 'consum', 0.0212, 'lps'),
	(423232, 123, '2015-03-01 00:21:33.000000', 'consum', 0.0214, 'lps'),
	(423233, 123, '2015-03-01 00:21:34.000000', 'consum', 0.0211, 'lps'),
	(423234, 123, '2015-03-01 00:21:35.000000', 'consum', 0.0214, 'lps'),
	(423235, 123, '2015-03-01 00:21:36.000000', 'consum', 0.0217, 'lps'),
	(423236, 123, '2015-03-01 00:21:37.000000', 'consum', 0.0220, 'lps'),
	(423237, 123, '2015-03-01 00:21:38.000000', 'consum', 0.0215, 'lps'),
	(423238, 123, '2015-03-01 00:21:39.000000', 'consum', 0.0218, 'lps'),
	(423239, 123, '2015-03-01 00:21:40.000000', 'consum', 0.0222, 'lps'),
	(423240, 123, '2015-03-01 00:21:41.000000', 'consum', 0.0220, 'lps'),
	(423241, 123, '2015-03-01 00:21:42.000000', 'consum', 0.0214, 'lps'),
	(423242, 123, '2015-03-01 00:21:43.000000', 'consum', 0.0211, 'lps'),
	(423243, 123, '2015-03-01 00:21:44.000000', 'consum', 0.0217, 'lps'),
	(423244, 123, '2015-03-01 00:21:45.000000', 'consum', 0.0218, 'lps'),
	(423245, 123, '2015-03-01 00:21:46.000000', 'consum', 0.0215, 'lps'),
	(423246, 123, '2015-03-01 00:21:47.000000', 'consum', 0.0211, 'lps'),
	(423247, 123, '2015-03-01 00:21:48.000000', 'consum', 0.0216, 'lps'),
	(423248, 123, '2015-03-01 00:21:49.000000', 'consum', 0.0211, 'lps'),
	(423249, 123, '2015-03-01 00:21:50.000000', 'consum', 0.0222, 'lps'),
	(423250, 123, '2015-03-01 00:21:51.000000', 'consum', 0.0216, 'lps'),
	(423251, 123, '2015-03-01 00:21:52.000000', 'consum', 0.0219, 'lps'),
	(423252, 123, '2015-03-01 00:21:53.000000', 'consum', 0.0211, 'lps'),
	(423253, 123, '2015-03-01 00:21:54.000000', 'consum', 0.0215, 'lps'),
	(423254, 123, '2015-03-01 00:21:55.000000', 'consum', 0.0218, 'lps'),
	(423255, 123, '2015-03-01 00:21:56.000000', 'consum', 0.0210, 'lps'),
	(423256, 123, '2015-03-01 00:21:57.000000', 'consum', 0.0212, 'lps'),
	(423257, 123, '2015-03-01 00:21:58.000000', 'consum', 0.0221, 'lps'),
	(423258, 123, '2015-03-01 00:21:59.000000', 'consum', 0.0220, 'lps'),
	(423259, 123, '2015-03-01 00:22:00.000000', 'consum', 0.0215, 'lps'),
	(423260, 123, '2015-03-01 00:22:01.000000', 'consum', 0.0218, 'lps'),
	(423261, 123, '2015-03-01 00:22:02.000000', 'consum', 0.0221, 'lps'),
	(423262, 123, '2015-03-01 00:22:03.000000', 'consum', 0.0215, 'lps'),
	(423263, 123, '2015-03-01 00:22:04.000000', 'consum', 0.0218, 'lps'),
	(423264, 123, '2015-03-01 00:22:05.000000', 'consum', 0.0222, 'lps'),
	(423265, 123, '2015-03-01 00:22:06.000000', 'consum', 0.0219, 'lps'),
	(423266, 123, '2015-03-01 00:22:07.000000', 'consum', 0.0219, 'lps'),
	(423267, 123, '2015-03-01 00:22:08.000000', 'consum', 0.0217, 'lps'),
	(423268, 123, '2015-03-01 00:22:09.000000', 'consum', 0.0218, 'lps'),
	(423269, 123, '2015-03-01 00:22:10.000000', 'consum', 0.0218, 'lps'),
	(423270, 123, '2015-03-01 00:22:11.000000', 'consum', 0.0212, 'lps'),
	(423271, 123, '2015-03-01 00:22:12.000000', 'consum', 0.0210, 'lps'),
	(423272, 123, '2015-03-01 00:22:13.000000', 'consum', 0.0215, 'lps'),
	(423273, 123, '2015-03-01 00:22:14.000000', 'consum', 0.0213, 'lps'),
	(423274, 123, '2015-03-01 00:22:15.000000', 'consum', 0.0220, 'lps'),
	(423275, 123, '2015-03-01 00:22:16.000000', 'consum', 0.0215, 'lps'),
	(423276, 123, '2015-03-01 00:22:17.000000', 'consum', 0.0216, 'lps'),
	(423277, 123, '2015-03-01 00:22:18.000000', 'consum', 0.0213, 'lps'),
	(423278, 123, '2015-03-01 00:22:19.000000', 'consum', 0.0220, 'lps'),
	(423279, 123, '2015-03-01 00:22:20.000000', 'consum', 0.0211, 'lps'),
	(423280, 123, '2015-03-01 00:22:21.000000', 'consum', 0.0215, 'lps'),
	(423281, 123, '2015-03-01 00:22:22.000000', 'consum', 0.0217, 'lps'),
	(423282, 123, '2015-03-01 00:22:23.000000', 'consum', 0.0218, 'lps'),
	(423283, 123, '2015-03-01 00:22:24.000000', 'consum', 0.0215, 'lps'),
	(423284, 123, '2015-03-01 00:22:25.000000', 'consum', 0.0214, 'lps'),
	(423285, 123, '2015-03-01 00:22:26.000000', 'consum', 0.0213, 'lps'),
	(423286, 123, '2015-03-01 00:22:27.000000', 'consum', 0.0215, 'lps'),
	(423287, 123, '2015-03-01 00:22:28.000000', 'consum', 0.0213, 'lps'),
	(423288, 123, '2015-03-01 00:22:29.000000', 'consum', 0.0212, 'lps'),
	(423289, 123, '2015-03-01 00:22:30.000000', 'consum', 0.0211, 'lps'),
	(423290, 123, '2015-03-01 00:22:31.000000', 'consum', 0.0221, 'lps'),
	(423291, 123, '2015-03-01 00:22:32.000000', 'consum', 0.0212, 'lps'),
	(423292, 123, '2015-03-01 00:22:33.000000', 'consum', 0.0212, 'lps'),
	(423293, 123, '2015-03-01 00:22:34.000000', 'consum', 0.0215, 'lps'),
	(423294, 123, '2015-03-01 00:22:35.000000', 'consum', 0.0218, 'lps'),
	(423295, 123, '2015-03-01 00:22:36.000000', 'consum', 0.0220, 'lps'),
	(423296, 123, '2015-03-01 00:22:37.000000', 'consum', 0.0213, 'lps'),
	(423297, 123, '2015-03-01 00:22:38.000000', 'consum', 0.0219, 'lps'),
	(423298, 123, '2015-03-01 00:22:39.000000', 'consum', 0.0221, 'lps'),
	(423299, 123, '2015-03-01 00:22:40.000000', 'consum', 0.0214, 'lps'),
	(423300, 123, '2015-03-01 00:22:41.000000', 'consum', 0.0210, 'lps'),
	(423301, 123, '2015-03-01 00:22:42.000000', 'consum', 0.0211, 'lps'),
	(423302, 123, '2015-03-01 00:22:43.000000', 'consum', 0.0217, 'lps'),
	(423303, 123, '2015-03-01 00:22:44.000000', 'consum', 0.0214, 'lps'),
	(423304, 123, '2015-03-01 00:22:45.000000', 'consum', 0.0222, 'lps'),
	(423305, 123, '2015-03-01 00:22:46.000000', 'consum', 0.0220, 'lps'),
	(423306, 123, '2015-03-01 00:22:47.000000', 'consum', 0.0210, 'lps'),
	(423307, 123, '2015-03-01 00:22:48.000000', 'consum', 0.0222, 'lps'),
	(423308, 123, '2015-03-01 00:22:49.000000', 'consum', 0.0219, 'lps'),
	(423309, 123, '2015-03-01 00:22:50.000000', 'consum', 0.0218, 'lps'),
	(423310, 123, '2015-03-01 00:22:51.000000', 'consum', 0.0212, 'lps'),
	(423311, 123, '2015-03-01 00:22:52.000000', 'consum', 0.0220, 'lps'),
	(423312, 123, '2015-03-01 00:22:53.000000', 'consum', 0.0216, 'lps'),
	(423313, 123, '2015-03-01 00:22:54.000000', 'consum', 0.0213, 'lps'),
	(423314, 123, '2015-03-01 00:22:55.000000', 'consum', 0.0220, 'lps'),
	(423315, 123, '2015-03-01 00:22:56.000000', 'consum', 0.0210, 'lps'),
	(423316, 123, '2015-03-01 00:22:57.000000', 'consum', 0.0210, 'lps'),
	(423317, 123, '2015-03-01 00:22:58.000000', 'consum', 0.0221, 'lps'),
	(423318, 123, '2015-03-01 00:22:59.000000', 'consum', 0.0213, 'lps'),
	(423319, 123, '2015-03-01 00:23:00.000000', 'consum', 0.0219, 'lps'),
	(423320, 123, '2015-03-01 00:23:01.000000', 'consum', 0.0221, 'lps'),
	(423321, 123, '2015-03-01 00:23:02.000000', 'consum', 0.0212, 'lps'),
	(423322, 123, '2015-03-01 00:23:03.000000', 'consum', 0.0213, 'lps'),
	(423323, 123, '2015-03-01 00:23:04.000000', 'consum', 0.0221, 'lps'),
	(423324, 123, '2015-03-01 00:23:05.000000', 'consum', 0.0218, 'lps'),
	(423325, 123, '2015-03-01 00:23:06.000000', 'consum', 0.0216, 'lps'),
	(423326, 123, '2015-03-01 00:23:07.000000', 'consum', 0.0217, 'lps'),
	(423327, 123, '2015-03-01 00:23:08.000000', 'consum', 0.0213, 'lps'),
	(423328, 123, '2015-03-01 00:23:09.000000', 'consum', 0.0218, 'lps'),
	(423329, 123, '2015-03-01 00:23:10.000000', 'consum', 0.0215, 'lps'),
	(423330, 123, '2015-03-01 00:23:11.000000', 'consum', 0.0210, 'lps'),
	(423331, 123, '2015-03-01 00:23:12.000000', 'consum', 0.0212, 'lps'),
	(423332, 123, '2015-03-01 00:23:13.000000', 'consum', 0.0218, 'lps'),
	(423333, 123, '2015-03-01 00:23:14.000000', 'consum', 0.0219, 'lps'),
	(423334, 123, '2015-03-01 00:23:15.000000', 'consum', 0.0218, 'lps'),
	(423335, 123, '2015-03-01 00:23:16.000000', 'consum', 0.0213, 'lps'),
	(423336, 123, '2015-03-01 00:23:17.000000', 'consum', 0.0211, 'lps'),
	(423337, 123, '2015-03-01 00:23:18.000000', 'consum', 0.0222, 'lps'),
	(423338, 123, '2015-03-01 00:23:19.000000', 'consum', 0.0215, 'lps'),
	(423339, 123, '2015-03-01 00:23:20.000000', 'consum', 0.0211, 'lps'),
	(423340, 123, '2015-03-01 00:23:21.000000', 'consum', 0.0214, 'lps'),
	(423341, 123, '2015-03-01 00:23:22.000000', 'consum', 0.0217, 'lps'),
	(423342, 123, '2015-03-01 00:23:23.000000', 'consum', 0.0219, 'lps'),
	(423343, 123, '2015-03-01 00:23:24.000000', 'consum', 0.0220, 'lps'),
	(423344, 123, '2015-03-01 00:23:25.000000', 'consum', 0.0211, 'lps'),
	(423345, 123, '2015-03-01 00:23:26.000000', 'consum', 0.0221, 'lps'),
	(423346, 123, '2015-03-01 00:23:27.000000', 'consum', 0.0210, 'lps'),
	(423347, 123, '2015-03-01 00:23:28.000000', 'consum', 0.0219, 'lps'),
	(423348, 123, '2015-03-01 00:23:29.000000', 'consum', 0.0214, 'lps'),
	(423349, 123, '2015-03-01 00:23:30.000000', 'consum', 0.0216, 'lps'),
	(423350, 123, '2015-03-01 00:23:31.000000', 'consum', 0.0218, 'lps'),
	(423351, 123, '2015-03-01 00:23:32.000000', 'consum', 0.0218, 'lps'),
	(423352, 123, '2015-03-01 00:23:33.000000', 'consum', 0.0212, 'lps'),
	(423353, 123, '2015-03-01 00:23:34.000000', 'consum', 0.0211, 'lps'),
	(423354, 123, '2015-03-01 00:23:35.000000', 'consum', 0.0211, 'lps'),
	(423355, 123, '2015-03-01 00:23:36.000000', 'consum', 0.0212, 'lps'),
	(423356, 123, '2015-03-01 00:23:37.000000', 'consum', 0.0218, 'lps'),
	(423357, 123, '2015-03-01 00:23:38.000000', 'consum', 0.0220, 'lps'),
	(423358, 123, '2015-03-01 00:23:39.000000', 'consum', 0.0220, 'lps'),
	(423359, 123, '2015-03-01 00:23:40.000000', 'consum', 0.0220, 'lps'),
	(423360, 123, '2015-03-01 00:23:41.000000', 'consum', 0.0216, 'lps'),
	(423361, 123, '2015-03-01 00:23:42.000000', 'consum', 0.0212, 'lps'),
	(423362, 123, '2015-03-01 00:23:43.000000', 'consum', 0.0217, 'lps'),
	(423363, 123, '2015-03-01 00:23:44.000000', 'consum', 0.0210, 'lps'),
	(423364, 123, '2015-03-01 00:23:45.000000', 'consum', 0.0217, 'lps'),
	(423365, 123, '2015-03-01 00:23:46.000000', 'consum', 0.0220, 'lps'),
	(423366, 123, '2015-03-01 00:23:47.000000', 'consum', 0.0213, 'lps'),
	(423367, 123, '2015-03-01 00:23:48.000000', 'consum', 0.0220, 'lps'),
	(423368, 123, '2015-03-01 00:23:49.000000', 'consum', 0.0214, 'lps'),
	(423369, 123, '2015-03-01 00:23:50.000000', 'consum', 0.0211, 'lps'),
	(423370, 123, '2015-03-01 00:23:51.000000', 'consum', 0.0219, 'lps'),
	(423371, 123, '2015-03-01 00:23:52.000000', 'consum', 0.0212, 'lps'),
	(423372, 123, '2015-03-01 00:23:53.000000', 'consum', 0.0221, 'lps'),
	(423373, 123, '2015-03-01 00:23:54.000000', 'consum', 0.0220, 'lps'),
	(423374, 123, '2015-03-01 00:23:55.000000', 'consum', 0.0214, 'lps'),
	(423375, 123, '2015-03-01 00:23:56.000000', 'consum', 0.0212, 'lps'),
	(423376, 123, '2015-03-01 00:23:57.000000', 'consum', 0.0211, 'lps'),
	(423377, 123, '2015-03-01 00:23:58.000000', 'consum', 0.0220, 'lps'),
	(423378, 123, '2015-03-01 00:23:59.000000', 'consum', 0.0218, 'lps'),
	(423379, 123, '2015-03-01 00:24:00.000000', 'consum', 0.0210, 'lps'),
	(423380, 123, '2015-03-01 00:24:01.000000', 'consum', 0.0211, 'lps'),
	(423381, 123, '2015-03-01 00:24:02.000000', 'consum', 0.0215, 'lps'),
	(423382, 123, '2015-03-01 00:24:03.000000', 'consum', 0.0220, 'lps'),
	(423383, 123, '2015-03-01 00:24:04.000000', 'consum', 0.0218, 'lps'),
	(423384, 123, '2015-03-01 00:24:05.000000', 'consum', 0.0211, 'lps'),
	(423385, 123, '2015-03-01 00:24:06.000000', 'consum', 0.0214, 'lps'),
	(423386, 123, '2015-03-01 00:24:07.000000', 'consum', 0.0218, 'lps'),
	(423387, 123, '2015-03-01 00:24:08.000000', 'consum', 0.0210, 'lps'),
	(423388, 123, '2015-03-01 00:24:09.000000', 'consum', 0.0212, 'lps'),
	(423389, 123, '2015-03-01 00:24:10.000000', 'consum', 0.0221, 'lps'),
	(423390, 123, '2015-03-01 00:24:11.000000', 'consum', 0.0221, 'lps'),
	(423391, 123, '2015-03-01 00:24:12.000000', 'consum', 0.0220, 'lps'),
	(423392, 123, '2015-03-01 00:24:13.000000', 'consum', 0.0215, 'lps'),
	(423393, 123, '2015-03-01 00:24:14.000000', 'consum', 0.0218, 'lps'),
	(423394, 123, '2015-03-01 00:24:15.000000', 'consum', 0.0210, 'lps'),
	(423395, 123, '2015-03-01 00:24:16.000000', 'consum', 0.0213, 'lps'),
	(423396, 123, '2015-03-01 00:24:17.000000', 'consum', 0.0210, 'lps'),
	(423397, 123, '2015-03-01 00:24:18.000000', 'consum', 0.0216, 'lps'),
	(423398, 123, '2015-03-01 00:24:19.000000', 'consum', 0.0214, 'lps'),
	(423399, 123, '2015-03-01 00:24:20.000000', 'consum', 0.0213, 'lps'),
	(423400, 123, '2015-03-01 00:24:21.000000', 'consum', 0.0212, 'lps'),
	(423401, 123, '2015-03-01 00:24:22.000000', 'consum', 0.0213, 'lps'),
	(423402, 123, '2015-03-01 00:24:23.000000', 'consum', 0.0221, 'lps'),
	(423403, 123, '2015-03-01 00:24:24.000000', 'consum', 0.0215, 'lps'),
	(423404, 123, '2015-03-01 00:24:25.000000', 'consum', 0.0216, 'lps'),
	(423405, 123, '2015-03-01 00:24:26.000000', 'consum', 0.0214, 'lps'),
	(423406, 123, '2015-03-01 00:24:27.000000', 'consum', 0.0212, 'lps'),
	(423407, 123, '2015-03-01 00:24:28.000000', 'consum', 0.0219, 'lps'),
	(423408, 123, '2015-03-01 00:24:29.000000', 'consum', 0.0213, 'lps'),
	(423409, 123, '2015-03-01 00:24:30.000000', 'consum', 0.0211, 'lps'),
	(423410, 123, '2015-03-01 00:24:31.000000', 'consum', 0.0219, 'lps'),
	(423411, 123, '2015-03-01 00:24:32.000000', 'consum', 0.0214, 'lps'),
	(423412, 123, '2015-03-01 00:24:33.000000', 'consum', 0.0214, 'lps'),
	(423413, 123, '2015-03-01 00:24:34.000000', 'consum', 0.0221, 'lps'),
	(423414, 123, '2015-03-01 00:24:35.000000', 'consum', 0.0216, 'lps'),
	(423415, 123, '2015-03-01 00:24:36.000000', 'consum', 0.0218, 'lps'),
	(423416, 123, '2015-03-01 00:24:37.000000', 'consum', 0.0221, 'lps'),
	(423417, 123, '2015-03-01 00:24:38.000000', 'consum', 0.0215, 'lps'),
	(423418, 123, '2015-03-01 00:24:39.000000', 'consum', 0.0216, 'lps'),
	(423419, 123, '2015-03-01 00:24:40.000000', 'consum', 0.0212, 'lps'),
	(423420, 123, '2015-03-01 00:24:41.000000', 'consum', 0.0217, 'lps'),
	(423421, 123, '2015-03-01 00:24:42.000000', 'consum', 0.0211, 'lps'),
	(423422, 123, '2015-03-01 00:24:43.000000', 'consum', 0.0220, 'lps'),
	(423423, 123, '2015-03-01 00:24:44.000000', 'consum', 0.0221, 'lps'),
	(423424, 123, '2015-03-01 00:24:45.000000', 'consum', 0.0221, 'lps'),
	(423425, 123, '2015-03-01 00:24:46.000000', 'consum', 0.0221, 'lps'),
	(423426, 123, '2015-03-01 00:24:47.000000', 'consum', 0.0220, 'lps'),
	(423427, 123, '2015-03-01 00:24:48.000000', 'consum', 0.0213, 'lps'),
	(423428, 123, '2015-03-01 00:24:49.000000', 'consum', 0.0221, 'lps'),
	(423429, 123, '2015-03-01 00:24:50.000000', 'consum', 0.0217, 'lps'),
	(423430, 123, '2015-03-01 00:24:51.000000', 'consum', 0.0212, 'lps'),
	(423431, 123, '2015-03-01 00:24:52.000000', 'consum', 0.0211, 'lps'),
	(423432, 123, '2015-03-01 00:24:53.000000', 'consum', 0.0213, 'lps'),
	(423433, 123, '2015-03-01 00:24:54.000000', 'consum', 0.0210, 'lps'),
	(423434, 123, '2015-03-01 00:24:55.000000', 'consum', 0.0212, 'lps'),
	(423435, 123, '2015-03-01 00:24:56.000000', 'consum', 0.0219, 'lps'),
	(423436, 123, '2015-03-01 00:24:57.000000', 'consum', 0.0214, 'lps'),
	(423437, 123, '2015-03-01 00:24:58.000000', 'consum', 0.0214, 'lps'),
	(423438, 123, '2015-03-01 00:24:59.000000', 'consum', 0.0218, 'lps'),
	(423439, 123, '2015-03-01 00:25:00.000000', 'consum', 0.0212, 'lps'),
	(423440, 123, '2015-03-01 00:25:01.000000', 'consum', 0.0210, 'lps'),
	(423441, 123, '2015-03-01 00:25:02.000000', 'consum', 0.0216, 'lps'),
	(423442, 123, '2015-03-01 00:25:03.000000', 'consum', 0.0216, 'lps'),
	(423443, 123, '2015-03-01 00:25:04.000000', 'consum', 0.0222, 'lps'),
	(423444, 123, '2015-03-01 00:25:05.000000', 'consum', 0.0215, 'lps'),
	(423445, 123, '2015-03-01 00:25:06.000000', 'consum', 0.0211, 'lps'),
	(423446, 123, '2015-03-01 00:25:07.000000', 'consum', 0.0212, 'lps'),
	(423447, 123, '2015-03-01 00:25:08.000000', 'consum', 0.0220, 'lps'),
	(423448, 123, '2015-03-01 00:25:09.000000', 'consum', 0.0214, 'lps'),
	(423449, 123, '2015-03-01 00:25:10.000000', 'consum', 0.0216, 'lps'),
	(423450, 123, '2015-03-01 00:25:11.000000', 'consum', 0.0214, 'lps'),
	(423451, 123, '2015-03-01 00:25:12.000000', 'consum', 0.0211, 'lps'),
	(423452, 123, '2015-03-01 00:25:13.000000', 'consum', 0.0220, 'lps'),
	(423453, 123, '2015-03-01 00:25:14.000000', 'consum', 0.0215, 'lps'),
	(423454, 123, '2015-03-01 00:25:15.000000', 'consum', 0.0221, 'lps'),
	(423455, 123, '2015-03-01 00:25:16.000000', 'consum', 0.0212, 'lps'),
	(423456, 123, '2015-03-01 00:25:17.000000', 'consum', 0.0211, 'lps'),
	(423457, 123, '2015-03-01 00:25:18.000000', 'consum', 0.0213, 'lps'),
	(423458, 123, '2015-03-01 00:25:19.000000', 'consum', 0.0219, 'lps'),
	(423459, 123, '2015-03-01 00:25:20.000000', 'consum', 0.0210, 'lps'),
	(423460, 123, '2015-03-01 00:25:21.000000', 'consum', 0.0221, 'lps'),
	(423461, 123, '2015-03-01 00:25:22.000000', 'consum', 0.0213, 'lps'),
	(423462, 123, '2015-03-01 00:25:23.000000', 'consum', 0.0220, 'lps'),
	(423463, 123, '2015-03-01 00:25:24.000000', 'consum', 0.0212, 'lps'),
	(423464, 123, '2015-03-01 00:25:25.000000', 'consum', 0.0215, 'lps'),
	(423465, 123, '2015-03-01 00:25:26.000000', 'consum', 0.0219, 'lps'),
	(423466, 123, '2015-03-01 00:25:27.000000', 'consum', 0.0211, 'lps'),
	(423467, 123, '2015-03-01 00:25:28.000000', 'consum', 0.0218, 'lps'),
	(423468, 123, '2015-03-01 00:25:29.000000', 'consum', 0.0219, 'lps'),
	(423469, 123, '2015-03-01 00:25:30.000000', 'consum', 0.0219, 'lps'),
	(423470, 123, '2015-03-01 00:25:31.000000', 'consum', 0.0217, 'lps'),
	(423471, 123, '2015-03-01 00:25:32.000000', 'consum', 0.0217, 'lps'),
	(423472, 123, '2015-03-01 00:25:33.000000', 'consum', 0.0211, 'lps'),
	(423473, 123, '2015-03-01 00:25:34.000000', 'consum', 0.0222, 'lps'),
	(423474, 123, '2015-03-01 00:25:35.000000', 'consum', 0.0213, 'lps'),
	(423475, 123, '2015-03-01 00:25:36.000000', 'consum', 0.0218, 'lps'),
	(423476, 123, '2015-03-01 00:25:37.000000', 'consum', 0.0216, 'lps'),
	(423477, 123, '2015-03-01 00:25:38.000000', 'consum', 0.0214, 'lps'),
	(423478, 123, '2015-03-01 00:25:39.000000', 'consum', 0.0212, 'lps'),
	(423479, 123, '2015-03-01 00:25:40.000000', 'consum', 0.0210, 'lps'),
	(423480, 123, '2015-03-01 00:25:41.000000', 'consum', 0.0217, 'lps'),
	(423481, 123, '2015-03-01 00:25:42.000000', 'consum', 0.0221, 'lps'),
	(423482, 123, '2015-03-01 00:25:43.000000', 'consum', 0.0218, 'lps'),
	(423483, 123, '2015-03-01 00:25:44.000000', 'consum', 0.0216, 'lps'),
	(423484, 123, '2015-03-01 00:25:45.000000', 'consum', 0.0215, 'lps'),
	(423485, 123, '2015-03-01 00:25:46.000000', 'consum', 0.0220, 'lps'),
	(423486, 123, '2015-03-01 00:25:47.000000', 'consum', 0.0220, 'lps'),
	(423487, 123, '2015-03-01 00:25:48.000000', 'consum', 0.0215, 'lps'),
	(423488, 123, '2015-03-01 00:25:49.000000', 'consum', 0.0220, 'lps'),
	(423489, 123, '2015-03-01 00:25:50.000000', 'consum', 0.0218, 'lps'),
	(423490, 123, '2015-03-01 00:25:51.000000', 'consum', 0.0220, 'lps'),
	(423491, 123, '2015-03-01 00:25:52.000000', 'consum', 0.0211, 'lps'),
	(423492, 123, '2015-03-01 00:25:53.000000', 'consum', 0.0213, 'lps'),
	(423493, 123, '2015-03-01 00:25:54.000000', 'consum', 0.0222, 'lps'),
	(423494, 123, '2015-03-01 00:25:55.000000', 'consum', 0.0221, 'lps'),
	(423495, 123, '2015-03-01 00:25:56.000000', 'consum', 0.0219, 'lps'),
	(423496, 123, '2015-03-01 00:25:57.000000', 'consum', 0.0210, 'lps'),
	(423497, 123, '2015-03-01 00:25:58.000000', 'consum', 0.0221, 'lps'),
	(423498, 123, '2015-03-01 00:25:59.000000', 'consum', 0.0212, 'lps'),
	(423499, 123, '2015-03-01 00:26:00.000000', 'consum', 0.0215, 'lps'),
	(423500, 123, '2015-03-01 00:26:01.000000', 'consum', 0.0214, 'lps'),
	(423501, 123, '2015-03-01 00:26:02.000000', 'consum', 0.0219, 'lps'),
	(423502, 123, '2015-03-01 00:26:03.000000', 'consum', 0.0214, 'lps'),
	(423503, 123, '2015-03-01 00:26:04.000000', 'consum', 0.0218, 'lps'),
	(423504, 123, '2015-03-01 00:26:05.000000', 'consum', 0.0214, 'lps'),
	(423505, 123, '2015-03-01 00:26:06.000000', 'consum', 0.0219, 'lps'),
	(423506, 123, '2015-03-01 00:26:07.000000', 'consum', 0.0217, 'lps'),
	(423507, 123, '2015-03-01 00:26:08.000000', 'consum', 0.0219, 'lps'),
	(423508, 123, '2015-03-01 00:26:09.000000', 'consum', 0.0222, 'lps'),
	(423509, 123, '2015-03-01 00:26:10.000000', 'consum', 0.0215, 'lps'),
	(423510, 123, '2015-03-01 00:26:11.000000', 'consum', 0.0214, 'lps'),
	(423511, 123, '2015-03-01 00:26:12.000000', 'consum', 0.0216, 'lps'),
	(423512, 123, '2015-03-01 00:26:13.000000', 'consum', 0.0217, 'lps'),
	(423513, 123, '2015-03-01 00:26:14.000000', 'consum', 0.0214, 'lps'),
	(423514, 123, '2015-03-01 00:26:15.000000', 'consum', 0.0221, 'lps'),
	(423515, 123, '2015-03-01 00:26:16.000000', 'consum', 0.0215, 'lps'),
	(423516, 123, '2015-03-01 00:26:17.000000', 'consum', 0.0215, 'lps'),
	(423517, 123, '2015-03-01 00:26:18.000000', 'consum', 0.0210, 'lps'),
	(423518, 123, '2015-03-01 00:26:19.000000', 'consum', 0.0220, 'lps'),
	(423519, 123, '2015-03-01 00:26:20.000000', 'consum', 0.0221, 'lps'),
	(423520, 123, '2015-03-01 00:26:21.000000', 'consum', 0.0222, 'lps'),
	(423521, 123, '2015-03-01 00:26:22.000000', 'consum', 0.0213, 'lps'),
	(423522, 123, '2015-03-01 00:26:23.000000', 'consum', 0.0217, 'lps'),
	(423523, 123, '2015-03-01 00:26:24.000000', 'consum', 0.0222, 'lps'),
	(423524, 123, '2015-03-01 00:26:25.000000', 'consum', 0.0210, 'lps'),
	(423525, 123, '2015-03-01 00:26:26.000000', 'consum', 0.0214, 'lps'),
	(423526, 123, '2015-03-01 00:26:27.000000', 'consum', 0.0216, 'lps'),
	(423527, 123, '2015-03-01 00:26:28.000000', 'consum', 0.0215, 'lps'),
	(423528, 123, '2015-03-01 00:26:29.000000', 'consum', 0.0217, 'lps'),
	(423529, 123, '2015-03-01 00:26:30.000000', 'consum', 0.0220, 'lps'),
	(423530, 123, '2015-03-01 00:26:31.000000', 'consum', 0.0213, 'lps'),
	(423531, 123, '2015-03-01 00:26:32.000000', 'consum', 0.0210, 'lps'),
	(423532, 123, '2015-03-01 00:26:33.000000', 'consum', 0.0212, 'lps'),
	(423533, 123, '2015-03-01 00:26:34.000000', 'consum', 0.0219, 'lps'),
	(423534, 123, '2015-03-01 00:26:35.000000', 'consum', 0.0214, 'lps'),
	(423535, 123, '2015-03-01 00:26:36.000000', 'consum', 0.0214, 'lps'),
	(423536, 123, '2015-03-01 00:26:37.000000', 'consum', 0.0219, 'lps'),
	(423537, 123, '2015-03-01 00:26:38.000000', 'consum', 0.0216, 'lps'),
	(423538, 123, '2015-03-01 00:26:39.000000', 'consum', 0.0216, 'lps'),
	(423539, 123, '2015-03-01 00:26:40.000000', 'consum', 0.0221, 'lps'),
	(423540, 123, '2015-03-01 00:26:41.000000', 'consum', 0.0222, 'lps'),
	(423541, 123, '2015-03-01 00:26:42.000000', 'consum', 0.0213, 'lps'),
	(423542, 123, '2015-03-01 00:26:43.000000', 'consum', 0.0214, 'lps'),
	(423543, 123, '2015-03-01 00:26:44.000000', 'consum', 0.0222, 'lps'),
	(423544, 123, '2015-03-01 00:26:45.000000', 'consum', 0.0221, 'lps'),
	(423545, 123, '2015-03-01 00:26:46.000000', 'consum', 0.0215, 'lps'),
	(423546, 123, '2015-03-01 00:26:47.000000', 'consum', 0.0215, 'lps'),
	(423547, 123, '2015-03-01 00:26:48.000000', 'consum', 0.0220, 'lps'),
	(423548, 123, '2015-03-01 00:26:49.000000', 'consum', 0.0220, 'lps'),
	(423549, 123, '2015-03-01 00:26:50.000000', 'consum', 0.0218, 'lps'),
	(423550, 123, '2015-03-01 00:26:51.000000', 'consum', 0.0220, 'lps'),
	(423551, 123, '2015-03-01 00:26:52.000000', 'consum', 0.0212, 'lps'),
	(423552, 123, '2015-03-01 00:26:53.000000', 'consum', 0.0215, 'lps'),
	(423553, 123, '2015-03-01 00:26:54.000000', 'consum', 0.0219, 'lps'),
	(423554, 123, '2015-03-01 00:26:55.000000', 'consum', 0.0212, 'lps'),
	(423555, 123, '2015-03-01 00:26:56.000000', 'consum', 0.0219, 'lps'),
	(423556, 123, '2015-03-01 00:26:57.000000', 'consum', 0.0211, 'lps'),
	(423557, 123, '2015-03-01 00:26:58.000000', 'consum', 0.0213, 'lps'),
	(423558, 123, '2015-03-01 00:26:59.000000', 'consum', 0.0210, 'lps'),
	(423559, 123, '2015-03-01 00:27:00.000000', 'consum', 0.0214, 'lps'),
	(423560, 123, '2015-03-01 00:27:01.000000', 'consum', 0.0217, 'lps'),
	(423561, 123, '2015-03-01 00:27:02.000000', 'consum', 0.0220, 'lps'),
	(423562, 123, '2015-03-01 00:27:03.000000', 'consum', 0.0214, 'lps'),
	(423563, 123, '2015-03-01 00:27:04.000000', 'consum', 0.0212, 'lps'),
	(423564, 123, '2015-03-01 00:27:05.000000', 'consum', 0.0222, 'lps'),
	(423565, 123, '2015-03-01 00:27:06.000000', 'consum', 0.0214, 'lps'),
	(423566, 123, '2015-03-01 00:27:07.000000', 'consum', 0.0218, 'lps'),
	(423567, 123, '2015-03-01 00:27:08.000000', 'consum', 0.0212, 'lps'),
	(423568, 123, '2015-03-01 00:27:09.000000', 'consum', 0.0213, 'lps'),
	(423569, 123, '2015-03-01 00:27:10.000000', 'consum', 0.0216, 'lps'),
	(423570, 123, '2015-03-01 00:27:11.000000', 'consum', 0.0220, 'lps'),
	(423571, 123, '2015-03-01 00:27:12.000000', 'consum', 0.0216, 'lps'),
	(423572, 123, '2015-03-01 00:27:13.000000', 'consum', 0.0222, 'lps'),
	(423573, 123, '2015-03-01 00:27:14.000000', 'consum', 0.0214, 'lps'),
	(423574, 123, '2015-03-01 00:27:15.000000', 'consum', 0.0220, 'lps'),
	(423575, 123, '2015-03-01 00:27:16.000000', 'consum', 0.0210, 'lps'),
	(423576, 123, '2015-03-01 00:27:17.000000', 'consum', 0.0221, 'lps'),
	(423577, 123, '2015-03-01 00:27:18.000000', 'consum', 0.0211, 'lps'),
	(423578, 123, '2015-03-01 00:27:19.000000', 'consum', 0.0222, 'lps'),
	(423579, 123, '2015-03-01 00:27:20.000000', 'consum', 0.0214, 'lps'),
	(423580, 123, '2015-03-01 00:27:21.000000', 'consum', 0.0222, 'lps'),
	(423581, 123, '2015-03-01 00:27:22.000000', 'consum', 0.0220, 'lps'),
	(423582, 123, '2015-03-01 00:27:23.000000', 'consum', 0.0212, 'lps'),
	(423583, 123, '2015-03-01 00:27:24.000000', 'consum', 0.0215, 'lps'),
	(423584, 123, '2015-03-01 00:27:25.000000', 'consum', 0.0216, 'lps'),
	(423585, 123, '2015-03-01 00:27:26.000000', 'consum', 0.0215, 'lps'),
	(423586, 123, '2015-03-01 00:27:27.000000', 'consum', 0.0214, 'lps'),
	(423587, 123, '2015-03-01 00:27:28.000000', 'consum', 0.0218, 'lps'),
	(423588, 123, '2015-03-01 00:27:29.000000', 'consum', 0.0213, 'lps'),
	(423589, 123, '2015-03-01 00:27:30.000000', 'consum', 0.0214, 'lps'),
	(423590, 123, '2015-03-01 00:27:31.000000', 'consum', 0.0222, 'lps'),
	(423591, 123, '2015-03-01 00:27:32.000000', 'consum', 0.0219, 'lps'),
	(423592, 123, '2015-03-01 00:27:33.000000', 'consum', 0.0219, 'lps'),
	(423593, 123, '2015-03-01 00:27:34.000000', 'consum', 0.0217, 'lps'),
	(423594, 123, '2015-03-01 00:27:35.000000', 'consum', 0.0219, 'lps'),
	(423595, 123, '2015-03-01 00:27:36.000000', 'consum', 0.0222, 'lps'),
	(423596, 123, '2015-03-01 00:27:37.000000', 'consum', 0.0215, 'lps'),
	(423597, 123, '2015-03-01 00:27:38.000000', 'consum', 0.0213, 'lps'),
	(423598, 123, '2015-03-01 00:27:39.000000', 'consum', 0.0211, 'lps'),
	(423599, 123, '2015-03-01 00:27:40.000000', 'consum', 0.0220, 'lps'),
	(423600, 123, '2015-03-01 00:27:41.000000', 'consum', 0.0219, 'lps'),
	(423601, 123, '2015-03-01 00:27:42.000000', 'consum', 0.0212, 'lps'),
	(423602, 123, '2015-03-01 00:27:43.000000', 'consum', 0.0219, 'lps'),
	(423603, 123, '2015-03-01 00:27:44.000000', 'consum', 0.0212, 'lps'),
	(423604, 123, '2015-03-01 00:27:45.000000', 'consum', 0.0218, 'lps'),
	(423605, 123, '2015-03-01 00:27:46.000000', 'consum', 0.0220, 'lps'),
	(423606, 123, '2015-03-01 00:27:47.000000', 'consum', 0.0211, 'lps'),
	(423607, 123, '2015-03-01 00:27:48.000000', 'consum', 0.0210, 'lps'),
	(423608, 123, '2015-03-01 00:27:49.000000', 'consum', 0.0220, 'lps'),
	(423609, 123, '2015-03-01 00:27:50.000000', 'consum', 0.0222, 'lps'),
	(423610, 123, '2015-03-01 00:27:51.000000', 'consum', 0.0213, 'lps'),
	(423611, 123, '2015-03-01 00:27:52.000000', 'consum', 0.0216, 'lps'),
	(423612, 123, '2015-03-01 00:27:53.000000', 'consum', 0.0221, 'lps'),
	(423613, 123, '2015-03-01 00:27:54.000000', 'consum', 0.0219, 'lps'),
	(423614, 123, '2015-03-01 00:27:55.000000', 'consum', 0.0211, 'lps'),
	(423615, 123, '2015-03-01 00:27:56.000000', 'consum', 0.0216, 'lps'),
	(423616, 123, '2015-03-01 00:27:57.000000', 'consum', 0.0222, 'lps'),
	(423617, 123, '2015-03-01 00:27:58.000000', 'consum', 0.0213, 'lps'),
	(423618, 123, '2015-03-01 00:27:59.000000', 'consum', 0.0215, 'lps'),
	(423619, 123, '2015-03-01 00:28:00.000000', 'consum', 0.0213, 'lps'),
	(423620, 123, '2015-03-01 00:28:01.000000', 'consum', 0.0213, 'lps'),
	(423621, 123, '2015-03-01 00:28:02.000000', 'consum', 0.0217, 'lps'),
	(423622, 123, '2015-03-01 00:28:03.000000', 'consum', 0.0222, 'lps'),
	(423623, 123, '2015-03-01 00:28:04.000000', 'consum', 0.0222, 'lps'),
	(423624, 123, '2015-03-01 00:28:05.000000', 'consum', 0.0222, 'lps'),
	(423625, 123, '2015-03-01 00:28:06.000000', 'consum', 0.0222, 'lps'),
	(423626, 123, '2015-03-01 00:28:07.000000', 'consum', 0.0210, 'lps'),
	(423627, 123, '2015-03-01 00:28:08.000000', 'consum', 0.0214, 'lps'),
	(423628, 123, '2015-03-01 00:28:09.000000', 'consum', 0.0214, 'lps'),
	(423629, 123, '2015-03-01 00:28:10.000000', 'consum', 0.0222, 'lps'),
	(423630, 123, '2015-03-01 00:28:11.000000', 'consum', 0.0220, 'lps'),
	(423631, 123, '2015-03-01 00:28:12.000000', 'consum', 0.0222, 'lps'),
	(423632, 123, '2015-03-01 00:28:13.000000', 'consum', 0.0215, 'lps'),
	(423633, 123, '2015-03-01 00:28:14.000000', 'consum', 0.0213, 'lps'),
	(423634, 123, '2015-03-01 00:28:15.000000', 'consum', 0.0212, 'lps'),
	(423635, 123, '2015-03-01 00:28:16.000000', 'consum', 0.0222, 'lps'),
	(423636, 123, '2015-03-01 00:28:17.000000', 'consum', 0.0211, 'lps'),
	(423637, 123, '2015-03-01 00:28:18.000000', 'consum', 0.0222, 'lps'),
	(423638, 123, '2015-03-01 00:28:19.000000', 'consum', 0.0213, 'lps'),
	(423639, 123, '2015-03-01 00:28:20.000000', 'consum', 0.0218, 'lps'),
	(423640, 123, '2015-03-01 00:28:21.000000', 'consum', 0.0213, 'lps'),
	(423641, 123, '2015-03-01 00:28:22.000000', 'consum', 0.0217, 'lps'),
	(423642, 123, '2015-03-01 00:28:23.000000', 'consum', 0.0210, 'lps'),
	(423643, 123, '2015-03-01 00:28:24.000000', 'consum', 0.0216, 'lps'),
	(423644, 123, '2015-03-01 00:28:25.000000', 'consum', 0.0214, 'lps'),
	(423645, 123, '2015-03-01 00:28:26.000000', 'consum', 0.0213, 'lps'),
	(423646, 123, '2015-03-01 00:28:27.000000', 'consum', 0.0215, 'lps'),
	(423647, 123, '2015-03-01 00:28:28.000000', 'consum', 0.0212, 'lps'),
	(423648, 123, '2015-03-01 00:28:29.000000', 'consum', 0.0218, 'lps'),
	(423649, 123, '2015-03-01 00:28:30.000000', 'consum', 0.0219, 'lps'),
	(423650, 123, '2015-03-01 00:28:31.000000', 'consum', 0.0218, 'lps'),
	(423651, 123, '2015-03-01 00:28:32.000000', 'consum', 0.0211, 'lps'),
	(423652, 123, '2015-03-01 00:28:33.000000', 'consum', 0.0217, 'lps'),
	(423653, 123, '2015-03-01 00:28:34.000000', 'consum', 0.0218, 'lps'),
	(423654, 123, '2015-03-01 00:28:35.000000', 'consum', 0.0217, 'lps'),
	(423655, 123, '2015-03-01 00:28:36.000000', 'consum', 0.0219, 'lps'),
	(423656, 123, '2015-03-01 00:28:37.000000', 'consum', 0.0211, 'lps'),
	(423657, 123, '2015-03-01 00:28:38.000000', 'consum', 0.0214, 'lps'),
	(423658, 123, '2015-03-01 00:28:39.000000', 'consum', 0.0216, 'lps'),
	(423659, 123, '2015-03-01 00:28:40.000000', 'consum', 0.0214, 'lps'),
	(423660, 123, '2015-03-01 00:28:41.000000', 'consum', 0.0215, 'lps'),
	(423661, 123, '2015-03-01 00:28:42.000000', 'consum', 0.0221, 'lps'),
	(423662, 123, '2015-03-01 00:28:43.000000', 'consum', 0.0211, 'lps'),
	(423663, 123, '2015-03-01 00:28:44.000000', 'consum', 0.0211, 'lps'),
	(423664, 123, '2015-03-01 00:28:45.000000', 'consum', 0.0210, 'lps'),
	(423665, 123, '2015-03-01 00:28:46.000000', 'consum', 0.0210, 'lps'),
	(423666, 123, '2015-03-01 00:28:47.000000', 'consum', 0.0221, 'lps'),
	(423667, 123, '2015-03-01 00:28:48.000000', 'consum', 0.0213, 'lps'),
	(423668, 123, '2015-03-01 00:28:49.000000', 'consum', 0.0219, 'lps'),
	(423669, 123, '2015-03-01 00:28:50.000000', 'consum', 0.0221, 'lps'),
	(423670, 123, '2015-03-01 00:28:51.000000', 'consum', 0.0215, 'lps'),
	(423671, 123, '2015-03-01 00:28:52.000000', 'consum', 0.0212, 'lps'),
	(423672, 123, '2015-03-01 00:28:53.000000', 'consum', 0.0218, 'lps'),
	(423673, 123, '2015-03-01 00:28:54.000000', 'consum', 0.0219, 'lps'),
	(423674, 123, '2015-03-01 00:28:55.000000', 'consum', 0.0220, 'lps'),
	(423675, 123, '2015-03-01 00:28:56.000000', 'consum', 0.0220, 'lps'),
	(423676, 123, '2015-03-01 00:28:57.000000', 'consum', 0.0217, 'lps'),
	(423677, 123, '2015-03-01 00:28:58.000000', 'consum', 0.0215, 'lps'),
	(423678, 123, '2015-03-01 00:28:59.000000', 'consum', 0.0215, 'lps'),
	(423679, 123, '2015-03-01 00:29:00.000000', 'consum', 0.0222, 'lps'),
	(423680, 123, '2015-03-01 00:29:01.000000', 'consum', 0.0217, 'lps'),
	(423681, 123, '2015-03-01 00:29:02.000000', 'consum', 0.0220, 'lps'),
	(423682, 123, '2015-03-01 00:29:03.000000', 'consum', 0.0217, 'lps'),
	(423683, 123, '2015-03-01 00:29:04.000000', 'consum', 0.0212, 'lps'),
	(423684, 123, '2015-03-01 00:29:05.000000', 'consum', 0.0213, 'lps'),
	(423685, 123, '2015-03-01 00:29:06.000000', 'consum', 0.0218, 'lps'),
	(423686, 123, '2015-03-01 00:29:07.000000', 'consum', 0.0218, 'lps'),
	(423687, 123, '2015-03-01 00:29:08.000000', 'consum', 0.0213, 'lps'),
	(423688, 123, '2015-03-01 00:29:09.000000', 'consum', 0.0213, 'lps'),
	(423689, 123, '2015-03-01 00:29:10.000000', 'consum', 0.0216, 'lps'),
	(423690, 123, '2015-03-01 00:29:11.000000', 'consum', 0.0219, 'lps'),
	(423691, 123, '2015-03-01 00:29:12.000000', 'consum', 0.0212, 'lps'),
	(423692, 123, '2015-03-01 00:29:13.000000', 'consum', 0.0220, 'lps'),
	(423693, 123, '2015-03-01 00:29:14.000000', 'consum', 0.0215, 'lps'),
	(423694, 123, '2015-03-01 00:29:15.000000', 'consum', 0.0221, 'lps'),
	(423695, 123, '2015-03-01 00:29:16.000000', 'consum', 0.0221, 'lps'),
	(423696, 123, '2015-03-01 00:29:17.000000', 'consum', 0.0221, 'lps'),
	(423697, 123, '2015-03-01 00:29:18.000000', 'consum', 0.0219, 'lps'),
	(423698, 123, '2015-03-01 00:29:19.000000', 'consum', 0.0210, 'lps'),
	(423699, 123, '2015-03-01 00:29:20.000000', 'consum', 0.0221, 'lps'),
	(423700, 123, '2015-03-01 00:29:21.000000', 'consum', 0.0213, 'lps'),
	(423701, 123, '2015-03-01 00:29:22.000000', 'consum', 0.0219, 'lps'),
	(423702, 123, '2015-03-01 00:29:23.000000', 'consum', 0.0222, 'lps'),
	(423703, 123, '2015-03-01 00:29:24.000000', 'consum', 0.0218, 'lps'),
	(423704, 123, '2015-03-01 00:29:25.000000', 'consum', 0.0215, 'lps'),
	(423705, 123, '2015-03-01 00:29:26.000000', 'consum', 0.0212, 'lps'),
	(423706, 123, '2015-03-01 00:29:27.000000', 'consum', 0.0217, 'lps'),
	(423707, 123, '2015-03-01 00:29:28.000000', 'consum', 0.0214, 'lps'),
	(423708, 123, '2015-03-01 00:29:29.000000', 'consum', 0.0222, 'lps'),
	(423709, 123, '2015-03-01 00:29:30.000000', 'consum', 0.0218, 'lps'),
	(423710, 123, '2015-03-01 00:29:31.000000', 'consum', 0.0215, 'lps'),
	(423711, 123, '2015-03-01 00:29:32.000000', 'consum', 0.0213, 'lps'),
	(423712, 123, '2015-03-01 00:29:33.000000', 'consum', 0.0222, 'lps'),
	(423713, 123, '2015-03-01 00:29:34.000000', 'consum', 0.0210, 'lps'),
	(423714, 123, '2015-03-01 00:29:35.000000', 'consum', 0.0212, 'lps'),
	(423715, 123, '2015-03-01 00:29:36.000000', 'consum', 0.0220, 'lps'),
	(423716, 123, '2015-03-01 00:29:37.000000', 'consum', 0.0218, 'lps'),
	(423717, 123, '2015-03-01 00:29:38.000000', 'consum', 0.0218, 'lps'),
	(423718, 123, '2015-03-01 00:29:39.000000', 'consum', 0.0216, 'lps'),
	(423719, 123, '2015-03-01 00:29:40.000000', 'consum', 0.0215, 'lps'),
	(423720, 123, '2015-03-01 00:29:41.000000', 'consum', 0.0217, 'lps'),
	(423721, 123, '2015-03-01 00:29:42.000000', 'consum', 0.0218, 'lps'),
	(423722, 123, '2015-03-01 00:29:43.000000', 'consum', 0.0218, 'lps'),
	(423723, 123, '2015-03-01 00:29:44.000000', 'consum', 0.0212, 'lps'),
	(423724, 123, '2015-03-01 00:29:45.000000', 'consum', 0.0211, 'lps'),
	(423725, 123, '2015-03-01 00:29:46.000000', 'consum', 0.0220, 'lps'),
	(423726, 123, '2015-03-01 00:29:47.000000', 'consum', 0.0220, 'lps'),
	(423727, 123, '2015-03-01 00:29:48.000000', 'consum', 0.0219, 'lps'),
	(423728, 123, '2015-03-01 00:29:49.000000', 'consum', 0.0222, 'lps'),
	(423729, 123, '2015-03-01 00:29:50.000000', 'consum', 0.0221, 'lps'),
	(423730, 123, '2015-03-01 00:29:51.000000', 'consum', 0.0216, 'lps'),
	(423731, 123, '2015-03-01 00:29:52.000000', 'consum', 0.0220, 'lps'),
	(423732, 123, '2015-03-01 00:29:53.000000', 'consum', 0.0215, 'lps'),
	(423733, 123, '2015-03-01 00:29:54.000000', 'consum', 0.0219, 'lps'),
	(423734, 123, '2015-03-01 00:29:55.000000', 'consum', 0.0216, 'lps'),
	(423735, 123, '2015-03-01 00:29:56.000000', 'consum', 0.0214, 'lps'),
	(423736, 123, '2015-03-01 00:29:57.000000', 'consum', 0.0212, 'lps'),
	(423737, 123, '2015-03-01 00:29:58.000000', 'consum', 0.0221, 'lps'),
	(423738, 123, '2015-03-01 00:29:59.000000', 'consum', 0.0222, 'lps'),
	(423739, 123, '2015-03-01 00:30:00.000000', 'consum', 0.0210, 'lps'),
	(423740, 123, '2015-03-01 00:30:01.000000', 'consum', 0.0213, 'lps'),
	(423741, 123, '2015-03-01 00:30:02.000000', 'consum', 0.0214, 'lps'),
	(423742, 123, '2015-03-01 00:30:03.000000', 'consum', 0.0221, 'lps'),
	(423743, 123, '2015-03-01 00:30:04.000000', 'consum', 0.0216, 'lps'),
	(423744, 123, '2015-03-01 00:30:05.000000', 'consum', 0.0218, 'lps'),
	(423745, 123, '2015-03-01 00:30:06.000000', 'consum', 0.0220, 'lps'),
	(423746, 123, '2015-03-01 00:30:07.000000', 'consum', 0.0211, 'lps'),
	(423747, 123, '2015-03-01 00:30:08.000000', 'consum', 0.0222, 'lps'),
	(423748, 123, '2015-03-01 00:30:09.000000', 'consum', 0.0219, 'lps'),
	(423749, 123, '2015-03-01 00:30:10.000000', 'consum', 0.0216, 'lps'),
	(423750, 123, '2015-03-01 00:30:11.000000', 'consum', 0.0216, 'lps'),
	(423751, 123, '2015-03-01 00:30:12.000000', 'consum', 0.0221, 'lps'),
	(423752, 123, '2015-03-01 00:30:13.000000', 'consum', 0.0211, 'lps'),
	(423753, 123, '2015-03-01 00:30:14.000000', 'consum', 0.0219, 'lps'),
	(423754, 123, '2015-03-01 00:30:15.000000', 'consum', 0.0213, 'lps'),
	(423755, 123, '2015-03-01 00:30:16.000000', 'consum', 0.0214, 'lps'),
	(423756, 123, '2015-03-01 00:30:17.000000', 'consum', 0.0220, 'lps'),
	(423757, 123, '2015-03-01 00:30:18.000000', 'consum', 0.0222, 'lps'),
	(423758, 123, '2015-03-01 00:30:19.000000', 'consum', 0.0215, 'lps'),
	(423759, 123, '2015-03-01 00:30:20.000000', 'consum', 0.0213, 'lps'),
	(423760, 123, '2015-03-01 00:30:21.000000', 'consum', 0.0210, 'lps'),
	(423761, 123, '2015-03-01 00:30:22.000000', 'consum', 0.0213, 'lps'),
	(423762, 123, '2015-03-01 00:30:23.000000', 'consum', 0.0212, 'lps'),
	(423763, 123, '2015-03-01 00:30:24.000000', 'consum', 0.0213, 'lps'),
	(423764, 123, '2015-03-01 00:30:25.000000', 'consum', 0.0217, 'lps'),
	(423765, 123, '2015-03-01 00:30:26.000000', 'consum', 0.0213, 'lps'),
	(423766, 123, '2015-03-01 00:30:27.000000', 'consum', 0.0219, 'lps'),
	(423767, 123, '2015-03-01 00:30:28.000000', 'consum', 0.0218, 'lps'),
	(423768, 123, '2015-03-01 00:30:29.000000', 'consum', 0.0210, 'lps'),
	(423769, 123, '2015-03-01 00:30:30.000000', 'consum', 0.0214, 'lps'),
	(423770, 123, '2015-03-01 00:30:31.000000', 'consum', 0.0219, 'lps'),
	(423771, 123, '2015-03-01 00:30:32.000000', 'consum', 0.0214, 'lps'),
	(423772, 123, '2015-03-01 00:30:33.000000', 'consum', 0.0219, 'lps'),
	(423773, 123, '2015-03-01 00:30:34.000000', 'consum', 0.0219, 'lps'),
	(423774, 123, '2015-03-01 00:30:35.000000', 'consum', 0.0213, 'lps'),
	(423775, 123, '2015-03-01 00:30:36.000000', 'consum', 0.0213, 'lps'),
	(423776, 123, '2015-03-01 00:30:37.000000', 'consum', 0.0215, 'lps'),
	(423777, 123, '2015-03-01 00:30:38.000000', 'consum', 0.0214, 'lps'),
	(423778, 123, '2015-03-01 00:30:39.000000', 'consum', 0.0217, 'lps'),
	(423779, 123, '2015-03-01 00:30:40.000000', 'consum', 0.0219, 'lps'),
	(423780, 123, '2015-03-01 00:30:41.000000', 'consum', 0.0221, 'lps'),
	(423781, 123, '2015-03-01 00:30:42.000000', 'consum', 0.0213, 'lps'),
	(423782, 123, '2015-03-01 00:30:43.000000', 'consum', 0.0219, 'lps'),
	(423783, 123, '2015-03-01 00:30:44.000000', 'consum', 0.0218, 'lps'),
	(423784, 123, '2015-03-01 00:30:45.000000', 'consum', 0.0213, 'lps'),
	(423785, 123, '2015-03-01 00:30:46.000000', 'consum', 0.0212, 'lps'),
	(423786, 123, '2015-03-01 00:30:47.000000', 'consum', 0.0215, 'lps'),
	(423787, 123, '2015-03-01 00:30:48.000000', 'consum', 0.0215, 'lps'),
	(423788, 123, '2015-03-01 00:30:49.000000', 'consum', 0.0219, 'lps'),
	(423789, 123, '2015-03-01 00:30:50.000000', 'consum', 0.0215, 'lps'),
	(423790, 123, '2015-03-01 00:30:51.000000', 'consum', 0.0221, 'lps'),
	(423791, 123, '2015-03-01 00:30:52.000000', 'consum', 0.0214, 'lps'),
	(423792, 123, '2015-03-01 00:30:53.000000', 'consum', 0.0221, 'lps'),
	(423793, 123, '2015-03-01 00:30:54.000000', 'consum', 0.0214, 'lps'),
	(423794, 123, '2015-03-01 00:30:55.000000', 'consum', 0.0213, 'lps'),
	(423795, 123, '2015-03-01 00:30:56.000000', 'consum', 0.0210, 'lps'),
	(423796, 123, '2015-03-01 00:30:57.000000', 'consum', 0.0218, 'lps'),
	(423797, 123, '2015-03-01 00:30:58.000000', 'consum', 0.0211, 'lps'),
	(423798, 123, '2015-03-01 00:30:59.000000', 'consum', 0.0217, 'lps'),
	(423799, 123, '2015-03-01 00:31:00.000000', 'consum', 0.0218, 'lps'),
	(423800, 123, '2015-03-01 00:31:01.000000', 'consum', 0.0214, 'lps'),
	(423801, 123, '2015-03-01 00:31:02.000000', 'consum', 0.0220, 'lps'),
	(423802, 123, '2015-03-01 00:31:03.000000', 'consum', 0.0211, 'lps'),
	(423803, 123, '2015-03-01 00:31:04.000000', 'consum', 0.0210, 'lps'),
	(423804, 123, '2015-03-01 00:31:05.000000', 'consum', 0.0221, 'lps'),
	(423805, 123, '2015-03-01 00:31:06.000000', 'consum', 0.0213, 'lps'),
	(423806, 123, '2015-03-01 00:31:07.000000', 'consum', 0.0218, 'lps'),
	(423807, 123, '2015-03-01 00:31:08.000000', 'consum', 0.0216, 'lps'),
	(423808, 123, '2015-03-01 00:31:09.000000', 'consum', 0.0215, 'lps'),
	(423809, 123, '2015-03-01 00:31:10.000000', 'consum', 0.0217, 'lps'),
	(423810, 123, '2015-03-01 00:31:11.000000', 'consum', 0.0218, 'lps'),
	(423811, 123, '2015-03-01 00:31:12.000000', 'consum', 0.0215, 'lps'),
	(423812, 123, '2015-03-01 00:31:13.000000', 'consum', 0.0213, 'lps'),
	(423813, 123, '2015-03-01 00:31:14.000000', 'consum', 0.0212, 'lps'),
	(423814, 123, '2015-03-01 00:31:15.000000', 'consum', 0.0211, 'lps'),
	(423815, 123, '2015-03-01 00:31:16.000000', 'consum', 0.0220, 'lps'),
	(423816, 123, '2015-03-01 00:31:17.000000', 'consum', 0.0221, 'lps'),
	(423817, 123, '2015-03-01 00:31:18.000000', 'consum', 0.0222, 'lps'),
	(423818, 123, '2015-03-01 00:31:19.000000', 'consum', 0.0212, 'lps'),
	(423819, 123, '2015-03-01 00:31:20.000000', 'consum', 0.0222, 'lps'),
	(423820, 123, '2015-03-01 00:31:21.000000', 'consum', 0.0215, 'lps'),
	(423821, 123, '2015-03-01 00:31:22.000000', 'consum', 0.0210, 'lps'),
	(423822, 123, '2015-03-01 00:31:23.000000', 'consum', 0.0220, 'lps'),
	(423823, 123, '2015-03-01 00:31:24.000000', 'consum', 0.0212, 'lps'),
	(423824, 123, '2015-03-01 00:31:25.000000', 'consum', 0.0213, 'lps'),
	(423825, 123, '2015-03-01 00:31:26.000000', 'consum', 0.0222, 'lps'),
	(423826, 123, '2015-03-01 00:31:27.000000', 'consum', 0.0210, 'lps'),
	(423827, 123, '2015-03-01 00:31:28.000000', 'consum', 0.0212, 'lps'),
	(423828, 123, '2015-03-01 00:31:29.000000', 'consum', 0.0222, 'lps'),
	(423829, 123, '2015-03-01 00:31:30.000000', 'consum', 0.0212, 'lps'),
	(423830, 123, '2015-03-01 00:31:31.000000', 'consum', 0.0211, 'lps'),
	(423831, 123, '2015-03-01 00:31:32.000000', 'consum', 0.0222, 'lps'),
	(423832, 123, '2015-03-01 00:31:33.000000', 'consum', 0.0215, 'lps'),
	(423833, 123, '2015-03-01 00:31:34.000000', 'consum', 0.0213, 'lps'),
	(423834, 123, '2015-03-01 00:31:35.000000', 'consum', 0.0211, 'lps'),
	(423835, 123, '2015-03-01 00:31:36.000000', 'consum', 0.0219, 'lps'),
	(423836, 123, '2015-03-01 00:31:37.000000', 'consum', 0.0214, 'lps'),
	(423837, 123, '2015-03-01 00:31:38.000000', 'consum', 0.0214, 'lps'),
	(423838, 123, '2015-03-01 00:31:39.000000', 'consum', 0.0221, 'lps'),
	(423839, 123, '2015-03-01 00:31:40.000000', 'consum', 0.0216, 'lps'),
	(423840, 123, '2015-03-01 00:31:41.000000', 'consum', 0.0217, 'lps'),
	(423841, 123, '2015-03-01 00:31:42.000000', 'consum', 0.0216, 'lps'),
	(423842, 123, '2015-03-01 00:31:43.000000', 'consum', 0.0221, 'lps'),
	(423843, 123, '2015-03-01 00:31:44.000000', 'consum', 0.0220, 'lps'),
	(423844, 123, '2015-03-01 00:31:45.000000', 'consum', 0.0213, 'lps'),
	(423845, 123, '2015-03-01 00:31:46.000000', 'consum', 0.0222, 'lps'),
	(423846, 123, '2015-03-01 00:31:47.000000', 'consum', 0.0222, 'lps'),
	(423847, 123, '2015-03-01 00:31:48.000000', 'consum', 0.0211, 'lps'),
	(423848, 123, '2015-03-01 00:31:49.000000', 'consum', 0.0217, 'lps'),
	(423849, 123, '2015-03-01 00:31:50.000000', 'consum', 0.0215, 'lps'),
	(423850, 123, '2015-03-01 00:31:51.000000', 'consum', 0.0217, 'lps'),
	(423851, 123, '2015-03-01 00:31:52.000000', 'consum', 0.0216, 'lps'),
	(423852, 123, '2015-03-01 00:31:53.000000', 'consum', 0.0221, 'lps'),
	(423853, 123, '2015-03-01 00:31:54.000000', 'consum', 0.0219, 'lps'),
	(423854, 123, '2015-03-01 00:31:55.000000', 'consum', 0.0212, 'lps'),
	(423855, 123, '2015-03-01 00:31:56.000000', 'consum', 0.0220, 'lps'),
	(423856, 123, '2015-03-01 00:31:57.000000', 'consum', 0.0215, 'lps'),
	(423857, 123, '2015-03-01 00:31:58.000000', 'consum', 0.0220, 'lps'),
	(423858, 123, '2015-03-01 00:31:59.000000', 'consum', 0.0218, 'lps'),
	(423859, 123, '2015-03-01 00:32:00.000000', 'consum', 0.0221, 'lps'),
	(423860, 123, '2015-03-01 00:32:01.000000', 'consum', 0.0214, 'lps'),
	(423861, 123, '2015-03-01 00:32:02.000000', 'consum', 0.0211, 'lps'),
	(423862, 123, '2015-03-01 00:32:03.000000', 'consum', 0.0218, 'lps'),
	(423863, 123, '2015-03-01 00:32:04.000000', 'consum', 0.0219, 'lps'),
	(423864, 123, '2015-03-01 00:32:05.000000', 'consum', 0.0219, 'lps'),
	(423865, 123, '2015-03-01 00:32:06.000000', 'consum', 0.0217, 'lps'),
	(423866, 123, '2015-03-01 00:32:07.000000', 'consum', 0.0216, 'lps'),
	(423867, 123, '2015-03-01 00:32:08.000000', 'consum', 0.0220, 'lps'),
	(423868, 123, '2015-03-01 00:32:09.000000', 'consum', 0.0216, 'lps'),
	(423869, 123, '2015-03-01 00:32:10.000000', 'consum', 0.0213, 'lps'),
	(423870, 123, '2015-03-01 00:32:11.000000', 'consum', 0.0217, 'lps'),
	(423871, 123, '2015-03-01 00:32:12.000000', 'consum', 0.0213, 'lps'),
	(423872, 123, '2015-03-01 00:32:13.000000', 'consum', 0.0215, 'lps'),
	(423873, 123, '2015-03-01 00:32:14.000000', 'consum', 0.0215, 'lps'),
	(423874, 123, '2015-03-01 00:32:15.000000', 'consum', 0.0219, 'lps'),
	(423875, 123, '2015-03-01 00:32:16.000000', 'consum', 0.0217, 'lps'),
	(423876, 123, '2015-03-01 00:32:17.000000', 'consum', 0.0219, 'lps'),
	(423877, 123, '2015-03-01 00:32:18.000000', 'consum', 0.0222, 'lps'),
	(423878, 123, '2015-03-01 00:32:19.000000', 'consum', 0.0215, 'lps'),
	(423879, 123, '2015-03-01 00:32:20.000000', 'consum', 0.0214, 'lps'),
	(423880, 123, '2015-03-01 00:32:21.000000', 'consum', 0.0217, 'lps'),
	(423881, 123, '2015-03-01 00:32:22.000000', 'consum', 0.0218, 'lps'),
	(423882, 123, '2015-03-01 00:32:23.000000', 'consum', 0.0218, 'lps'),
	(423883, 123, '2015-03-01 00:32:24.000000', 'consum', 0.0211, 'lps'),
	(423884, 123, '2015-03-01 00:32:25.000000', 'consum', 0.0220, 'lps'),
	(423885, 123, '2015-03-01 00:32:26.000000', 'consum', 0.0219, 'lps'),
	(423886, 123, '2015-03-01 00:32:27.000000', 'consum', 0.0213, 'lps'),
	(423887, 123, '2015-03-01 00:32:28.000000', 'consum', 0.0211, 'lps'),
	(423888, 123, '2015-03-01 00:32:29.000000', 'consum', 0.0218, 'lps'),
	(423889, 123, '2015-03-01 00:32:30.000000', 'consum', 0.0221, 'lps'),
	(423890, 123, '2015-03-01 00:32:31.000000', 'consum', 0.0215, 'lps'),
	(423891, 123, '2015-03-01 00:32:32.000000', 'consum', 0.0215, 'lps'),
	(423892, 123, '2015-03-01 00:32:33.000000', 'consum', 0.0222, 'lps'),
	(423893, 123, '2015-03-01 00:32:34.000000', 'consum', 0.0218, 'lps'),
	(423894, 123, '2015-03-01 00:32:35.000000', 'consum', 0.0214, 'lps'),
	(423895, 123, '2015-03-01 00:32:36.000000', 'consum', 0.0217, 'lps'),
	(423896, 123, '2015-03-01 00:32:37.000000', 'consum', 0.0210, 'lps'),
	(423897, 123, '2015-03-01 00:32:38.000000', 'consum', 0.0213, 'lps'),
	(423898, 123, '2015-03-01 00:32:39.000000', 'consum', 0.0214, 'lps'),
	(423899, 123, '2015-03-01 00:32:40.000000', 'consum', 0.0220, 'lps'),
	(423900, 123, '2015-03-01 00:32:41.000000', 'consum', 0.0222, 'lps'),
	(423901, 123, '2015-03-01 00:32:42.000000', 'consum', 0.0214, 'lps'),
	(423902, 123, '2015-03-01 00:32:43.000000', 'consum', 0.0210, 'lps'),
	(423903, 123, '2015-03-01 00:32:44.000000', 'consum', 0.0211, 'lps'),
	(423904, 123, '2015-03-01 00:32:45.000000', 'consum', 0.0214, 'lps'),
	(423905, 123, '2015-03-01 00:32:46.000000', 'consum', 0.0214, 'lps'),
	(423906, 123, '2015-03-01 00:32:47.000000', 'consum', 0.0220, 'lps'),
	(423907, 123, '2015-03-01 00:32:48.000000', 'consum', 0.0211, 'lps'),
	(423908, 123, '2015-03-01 00:32:49.000000', 'consum', 0.0211, 'lps'),
	(423909, 123, '2015-03-01 00:32:50.000000', 'consum', 0.0212, 'lps'),
	(423910, 123, '2015-03-01 00:32:51.000000', 'consum', 0.0216, 'lps'),
	(423911, 123, '2015-03-01 00:32:52.000000', 'consum', 0.0222, 'lps'),
	(423912, 123, '2015-03-01 00:32:53.000000', 'consum', 0.0216, 'lps'),
	(423913, 123, '2015-03-01 00:32:54.000000', 'consum', 0.0214, 'lps'),
	(423914, 123, '2015-03-01 00:32:55.000000', 'consum', 0.0214, 'lps'),
	(423915, 123, '2015-03-01 00:32:56.000000', 'consum', 0.0220, 'lps'),
	(423916, 123, '2015-03-01 00:32:57.000000', 'consum', 0.0222, 'lps'),
	(423917, 123, '2015-03-01 00:32:58.000000', 'consum', 0.0215, 'lps'),
	(423918, 123, '2015-03-01 00:32:59.000000', 'consum', 0.0214, 'lps'),
	(423919, 123, '2015-03-01 00:33:00.000000', 'consum', 0.0213, 'lps'),
	(423920, 123, '2015-03-01 00:33:01.000000', 'consum', 0.0215, 'lps'),
	(423921, 123, '2015-03-01 00:33:02.000000', 'consum', 0.0215, 'lps'),
	(423922, 123, '2015-03-01 00:33:03.000000', 'consum', 0.0218, 'lps'),
	(423923, 123, '2015-03-01 00:33:04.000000', 'consum', 0.0222, 'lps'),
	(423924, 123, '2015-03-01 00:33:05.000000', 'consum', 0.0222, 'lps'),
	(423925, 123, '2015-03-01 00:33:06.000000', 'consum', 0.0222, 'lps'),
	(423926, 123, '2015-03-01 00:33:07.000000', 'consum', 0.0220, 'lps'),
	(423927, 123, '2015-03-01 00:33:08.000000', 'consum', 0.0212, 'lps'),
	(423928, 123, '2015-03-01 00:33:09.000000', 'consum', 0.0217, 'lps'),
	(423929, 123, '2015-03-01 00:33:10.000000', 'consum', 0.0214, 'lps'),
	(423930, 123, '2015-03-01 00:33:11.000000', 'consum', 0.0222, 'lps'),
	(423931, 123, '2015-03-01 00:33:12.000000', 'consum', 0.0221, 'lps'),
	(423932, 123, '2015-03-01 00:33:13.000000', 'consum', 0.0217, 'lps'),
	(423933, 123, '2015-03-01 00:33:14.000000', 'consum', 0.0210, 'lps'),
	(423934, 123, '2015-03-01 00:33:15.000000', 'consum', 0.0215, 'lps'),
	(423935, 123, '2015-03-01 00:33:16.000000', 'consum', 0.0222, 'lps'),
	(423936, 123, '2015-03-01 00:33:17.000000', 'consum', 0.0216, 'lps'),
	(423937, 123, '2015-03-01 00:33:18.000000', 'consum', 0.0221, 'lps'),
	(423938, 123, '2015-03-01 00:33:19.000000', 'consum', 0.0218, 'lps'),
	(423939, 123, '2015-03-01 00:33:20.000000', 'consum', 0.0218, 'lps'),
	(423940, 123, '2015-03-01 00:33:21.000000', 'consum', 0.0214, 'lps'),
	(423941, 123, '2015-03-01 00:33:22.000000', 'consum', 0.0218, 'lps'),
	(423942, 123, '2015-03-01 00:33:23.000000', 'consum', 0.0212, 'lps'),
	(423943, 123, '2015-03-01 00:33:24.000000', 'consum', 0.0213, 'lps'),
	(423944, 123, '2015-03-01 00:33:25.000000', 'consum', 0.0216, 'lps'),
	(423945, 123, '2015-03-01 00:33:26.000000', 'consum', 0.0221, 'lps'),
	(423946, 123, '2015-03-01 00:33:27.000000', 'consum', 0.0222, 'lps'),
	(423947, 123, '2015-03-01 00:33:28.000000', 'consum', 0.0213, 'lps'),
	(423948, 123, '2015-03-01 00:33:29.000000', 'consum', 0.0212, 'lps'),
	(423949, 123, '2015-03-01 00:33:30.000000', 'consum', 0.0214, 'lps'),
	(423950, 123, '2015-03-01 00:33:31.000000', 'consum', 0.0210, 'lps'),
	(423951, 123, '2015-03-01 00:33:32.000000', 'consum', 0.0212, 'lps'),
	(423952, 123, '2015-03-01 00:33:33.000000', 'consum', 0.0220, 'lps'),
	(423953, 123, '2015-03-01 00:33:34.000000', 'consum', 0.0214, 'lps'),
	(423954, 123, '2015-03-01 00:33:35.000000', 'consum', 0.0217, 'lps'),
	(423955, 123, '2015-03-01 00:33:36.000000', 'consum', 0.0217, 'lps'),
	(423956, 123, '2015-03-01 00:33:37.000000', 'consum', 0.0214, 'lps'),
	(423957, 123, '2015-03-01 00:33:38.000000', 'consum', 0.0211, 'lps'),
	(423958, 123, '2015-03-01 00:33:39.000000', 'consum', 0.0214, 'lps'),
	(423959, 123, '2015-03-01 00:33:40.000000', 'consum', 0.0213, 'lps'),
	(423960, 123, '2015-03-01 00:33:41.000000', 'consum', 0.0215, 'lps'),
	(423961, 123, '2015-03-01 00:33:42.000000', 'consum', 0.0214, 'lps'),
	(423962, 123, '2015-03-01 00:33:43.000000', 'consum', 0.0217, 'lps'),
	(423963, 123, '2015-03-01 00:33:44.000000', 'consum', 0.0219, 'lps'),
	(423964, 123, '2015-03-01 00:33:45.000000', 'consum', 0.0210, 'lps'),
	(423965, 123, '2015-03-01 00:33:46.000000', 'consum', 0.0222, 'lps'),
	(423966, 123, '2015-03-01 00:33:47.000000', 'consum', 0.0216, 'lps'),
	(423967, 123, '2015-03-01 00:33:48.000000', 'consum', 0.0221, 'lps'),
	(423968, 123, '2015-03-01 00:33:49.000000', 'consum', 0.0218, 'lps'),
	(423969, 123, '2015-03-01 00:33:50.000000', 'consum', 0.0220, 'lps'),
	(423970, 123, '2015-03-01 00:33:51.000000', 'consum', 0.0212, 'lps'),
	(423971, 123, '2015-03-01 00:33:52.000000', 'consum', 0.0214, 'lps'),
	(423972, 123, '2015-03-01 00:33:53.000000', 'consum', 0.0213, 'lps'),
	(423973, 123, '2015-03-01 00:33:54.000000', 'consum', 0.0212, 'lps'),
	(423974, 123, '2015-03-01 00:33:55.000000', 'consum', 0.0212, 'lps'),
	(423975, 123, '2015-03-01 00:33:56.000000', 'consum', 0.0213, 'lps'),
	(423976, 123, '2015-03-01 00:33:57.000000', 'consum', 0.0222, 'lps'),
	(423977, 123, '2015-03-01 00:33:58.000000', 'consum', 0.0222, 'lps'),
	(423978, 123, '2015-03-01 00:33:59.000000', 'consum', 0.0222, 'lps'),
	(423979, 123, '2015-03-01 00:34:00.000000', 'consum', 0.0221, 'lps'),
	(423980, 123, '2015-03-01 00:34:01.000000', 'consum', 0.0217, 'lps'),
	(423981, 123, '2015-03-01 00:34:02.000000', 'consum', 0.0211, 'lps'),
	(423982, 123, '2015-03-01 00:34:03.000000', 'consum', 0.0210, 'lps'),
	(423983, 123, '2015-03-01 00:34:04.000000', 'consum', 0.0220, 'lps'),
	(423984, 123, '2015-03-01 00:34:05.000000', 'consum', 0.0219, 'lps'),
	(423985, 123, '2015-03-01 00:34:06.000000', 'consum', 0.0215, 'lps'),
	(423986, 123, '2015-03-01 00:34:07.000000', 'consum', 0.0210, 'lps'),
	(423987, 123, '2015-03-01 00:34:08.000000', 'consum', 0.0218, 'lps'),
	(423988, 123, '2015-03-01 00:34:09.000000', 'consum', 0.0213, 'lps'),
	(423989, 123, '2015-03-01 00:34:10.000000', 'consum', 0.0216, 'lps'),
	(423990, 123, '2015-03-01 00:34:11.000000', 'consum', 0.0218, 'lps'),
	(423991, 123, '2015-03-01 00:34:12.000000', 'consum', 0.0221, 'lps'),
	(423992, 123, '2015-03-01 00:34:13.000000', 'consum', 0.0212, 'lps'),
	(423993, 123, '2015-03-01 00:34:14.000000', 'consum', 0.0217, 'lps'),
	(423994, 123, '2015-03-01 00:34:15.000000', 'consum', 0.0211, 'lps'),
	(423995, 123, '2015-03-01 00:34:16.000000', 'consum', 0.0220, 'lps'),
	(423996, 123, '2015-03-01 00:34:17.000000', 'consum', 0.0220, 'lps'),
	(423997, 123, '2015-03-01 00:34:18.000000', 'consum', 0.0219, 'lps'),
	(423998, 123, '2015-03-01 00:34:19.000000', 'consum', 0.0222, 'lps'),
	(423999, 123, '2015-03-01 00:34:20.000000', 'consum', 0.0221, 'lps'),
	(424000, 123, '2015-03-01 00:34:21.000000', 'consum', 0.0215, 'lps'),
	(424001, 123, '2015-03-01 00:34:22.000000', 'consum', 0.0218, 'lps'),
	(424002, 123, '2015-03-01 00:34:23.000000', 'consum', 0.0219, 'lps'),
	(424003, 123, '2015-03-01 00:34:24.000000', 'consum', 0.0219, 'lps'),
	(424004, 123, '2015-03-01 00:34:25.000000', 'consum', 0.0217, 'lps'),
	(424005, 123, '2015-03-01 00:34:26.000000', 'consum', 0.0220, 'lps'),
	(424006, 123, '2015-03-01 00:34:27.000000', 'consum', 0.0211, 'lps'),
	(424007, 123, '2015-03-01 00:34:28.000000', 'consum', 0.0212, 'lps'),
	(424008, 123, '2015-03-01 00:34:29.000000', 'consum', 0.0219, 'lps'),
	(424009, 123, '2015-03-01 00:34:30.000000', 'consum', 0.0222, 'lps'),
	(424010, 123, '2015-03-01 00:34:31.000000', 'consum', 0.0217, 'lps'),
	(424011, 123, '2015-03-01 00:34:32.000000', 'consum', 0.0210, 'lps'),
	(424012, 123, '2015-03-01 00:34:33.000000', 'consum', 0.0216, 'lps'),
	(424013, 123, '2015-03-01 00:34:34.000000', 'consum', 0.0216, 'lps'),
	(424014, 123, '2015-03-01 00:34:35.000000', 'consum', 0.0220, 'lps'),
	(424015, 123, '2015-03-01 00:34:36.000000', 'consum', 0.0219, 'lps'),
	(424016, 123, '2015-03-01 00:34:37.000000', 'consum', 0.0211, 'lps'),
	(424017, 123, '2015-03-01 00:34:38.000000', 'consum', 0.0217, 'lps'),
	(424018, 123, '2015-03-01 00:34:39.000000', 'consum', 0.0213, 'lps'),
	(424019, 123, '2015-03-01 00:34:40.000000', 'consum', 0.0218, 'lps'),
	(424020, 123, '2015-03-01 00:34:41.000000', 'consum', 0.0217, 'lps'),
	(424021, 123, '2015-03-01 00:34:42.000000', 'consum', 0.0210, 'lps'),
	(424022, 123, '2015-03-01 00:34:43.000000', 'consum', 0.0214, 'lps'),
	(424023, 123, '2015-03-01 00:34:44.000000', 'consum', 0.0216, 'lps'),
	(424024, 123, '2015-03-01 00:34:45.000000', 'consum', 0.0216, 'lps'),
	(424025, 123, '2015-03-01 00:34:46.000000', 'consum', 0.0211, 'lps'),
	(424026, 123, '2015-03-01 00:34:47.000000', 'consum', 0.0211, 'lps'),
	(424027, 123, '2015-03-01 00:34:48.000000', 'consum', 0.0212, 'lps'),
	(424028, 123, '2015-03-01 00:34:49.000000', 'consum', 0.0219, 'lps'),
	(424029, 123, '2015-03-01 00:34:50.000000', 'consum', 0.0210, 'lps'),
	(424030, 123, '2015-03-01 00:34:51.000000', 'consum', 0.0222, 'lps'),
	(424031, 123, '2015-03-01 00:34:52.000000', 'consum', 0.0217, 'lps'),
	(424032, 123, '2015-03-01 00:34:53.000000', 'consum', 0.0210, 'lps'),
	(424033, 123, '2015-03-01 00:34:54.000000', 'consum', 0.0217, 'lps'),
	(424034, 123, '2015-03-01 00:34:55.000000', 'consum', 0.0221, 'lps'),
	(424035, 123, '2015-03-01 00:34:56.000000', 'consum', 0.0215, 'lps'),
	(424036, 123, '2015-03-01 00:34:57.000000', 'consum', 0.0218, 'lps'),
	(424037, 123, '2015-03-01 00:34:58.000000', 'consum', 0.0220, 'lps'),
	(424038, 123, '2015-03-01 00:34:59.000000', 'consum', 0.0212, 'lps'),
	(424039, 123, '2015-03-01 00:35:00.000000', 'consum', 0.0218, 'lps'),
	(424040, 123, '2015-03-01 00:35:01.000000', 'consum', 0.0217, 'lps'),
	(424041, 123, '2015-03-01 00:35:02.000000', 'consum', 0.0210, 'lps'),
	(424042, 123, '2015-03-01 00:35:03.000000', 'consum', 0.0213, 'lps'),
	(424043, 123, '2015-03-01 00:35:04.000000', 'consum', 0.0216, 'lps'),
	(424044, 123, '2015-03-01 00:35:05.000000', 'consum', 0.0215, 'lps'),
	(424045, 123, '2015-03-01 00:35:06.000000', 'consum', 0.0219, 'lps'),
	(424046, 123, '2015-03-01 00:35:07.000000', 'consum', 0.0213, 'lps'),
	(424047, 123, '2015-03-01 00:35:08.000000', 'consum', 0.0212, 'lps'),
	(424048, 123, '2015-03-01 00:35:09.000000', 'consum', 0.0213, 'lps'),
	(424049, 123, '2015-03-01 00:35:10.000000', 'consum', 0.0220, 'lps'),
	(424050, 123, '2015-03-01 00:35:11.000000', 'consum', 0.0211, 'lps'),
	(424051, 123, '2015-03-01 00:35:12.000000', 'consum', 0.0214, 'lps'),
	(424052, 123, '2015-03-01 00:35:13.000000', 'consum', 0.0211, 'lps'),
	(424053, 123, '2015-03-01 00:35:14.000000', 'consum', 0.0219, 'lps'),
	(424054, 123, '2015-03-01 00:35:15.000000', 'consum', 0.0211, 'lps'),
	(424055, 123, '2015-03-01 00:35:16.000000', 'consum', 0.0216, 'lps'),
	(424056, 123, '2015-03-01 00:35:17.000000', 'consum', 0.0213, 'lps'),
	(424057, 123, '2015-03-01 00:35:18.000000', 'consum', 0.0220, 'lps'),
	(424058, 123, '2015-03-01 00:35:19.000000', 'consum', 0.0214, 'lps'),
	(424059, 123, '2015-03-01 00:35:20.000000', 'consum', 0.0212, 'lps'),
	(424060, 123, '2015-03-01 00:35:21.000000', 'consum', 0.0221, 'lps'),
	(424061, 123, '2015-03-01 00:35:22.000000', 'consum', 0.0219, 'lps'),
	(424062, 123, '2015-03-01 00:35:23.000000', 'consum', 0.0211, 'lps'),
	(424063, 123, '2015-03-01 00:35:24.000000', 'consum', 0.0213, 'lps'),
	(424064, 123, '2015-03-01 00:35:25.000000', 'consum', 0.0210, 'lps'),
	(424065, 123, '2015-03-01 00:35:26.000000', 'consum', 0.0217, 'lps'),
	(424066, 123, '2015-03-01 00:35:27.000000', 'consum', 0.0217, 'lps'),
	(424067, 123, '2015-03-01 00:35:28.000000', 'consum', 0.0211, 'lps'),
	(424068, 123, '2015-03-01 00:35:29.000000', 'consum', 0.0210, 'lps'),
	(424069, 123, '2015-03-01 00:35:30.000000', 'consum', 0.0220, 'lps'),
	(424070, 123, '2015-03-01 00:35:31.000000', 'consum', 0.0221, 'lps'),
	(424071, 123, '2015-03-01 00:35:32.000000', 'consum', 0.0222, 'lps'),
	(424072, 123, '2015-03-01 00:35:33.000000', 'consum', 0.0212, 'lps'),
	(424073, 123, '2015-03-01 00:35:34.000000', 'consum', 0.0212, 'lps'),
	(424074, 123, '2015-03-01 00:35:35.000000', 'consum', 0.0215, 'lps'),
	(424075, 123, '2015-03-01 00:35:36.000000', 'consum', 0.0216, 'lps'),
	(424076, 123, '2015-03-01 00:35:37.000000', 'consum', 0.0212, 'lps'),
	(424077, 123, '2015-03-01 00:35:38.000000', 'consum', 0.0216, 'lps'),
	(424078, 123, '2015-03-01 00:35:39.000000', 'consum', 0.0210, 'lps'),
	(424079, 123, '2015-03-01 00:35:40.000000', 'consum', 0.0216, 'lps'),
	(424080, 123, '2015-03-01 00:35:41.000000', 'consum', 0.0217, 'lps'),
	(424081, 123, '2015-03-01 00:35:42.000000', 'consum', 0.0215, 'lps'),
	(424082, 123, '2015-03-01 00:35:43.000000', 'consum', 0.0212, 'lps'),
	(424083, 123, '2015-03-01 00:35:44.000000', 'consum', 0.0219, 'lps'),
	(424084, 123, '2015-03-01 00:35:45.000000', 'consum', 0.0212, 'lps'),
	(424085, 123, '2015-03-01 00:35:46.000000', 'consum', 0.0220, 'lps'),
	(424086, 123, '2015-03-01 00:35:47.000000', 'consum', 0.0213, 'lps'),
	(424087, 123, '2015-03-01 00:35:48.000000', 'consum', 0.0211, 'lps'),
	(424088, 123, '2015-03-01 00:35:49.000000', 'consum', 0.0218, 'lps'),
	(424089, 123, '2015-03-01 00:35:50.000000', 'consum', 0.0210, 'lps'),
	(424090, 123, '2015-03-01 00:35:51.000000', 'consum', 0.0211, 'lps'),
	(424091, 123, '2015-03-01 00:35:52.000000', 'consum', 0.0216, 'lps'),
	(424092, 123, '2015-03-01 00:35:53.000000', 'consum', 0.0211, 'lps'),
	(424093, 123, '2015-03-01 00:35:54.000000', 'consum', 0.0212, 'lps'),
	(424094, 123, '2015-03-01 00:35:55.000000', 'consum', 0.0219, 'lps'),
	(424095, 123, '2015-03-01 00:35:56.000000', 'consum', 0.0220, 'lps'),
	(424096, 123, '2015-03-01 00:35:57.000000', 'consum', 0.0211, 'lps'),
	(424097, 123, '2015-03-01 00:35:58.000000', 'consum', 0.0222, 'lps'),
	(424098, 123, '2015-03-01 00:35:59.000000', 'consum', 0.0218, 'lps'),
	(424099, 123, '2015-03-01 00:36:00.000000', 'consum', 0.0214, 'lps'),
	(424100, 123, '2015-03-01 00:36:01.000000', 'consum', 0.0221, 'lps'),
	(424101, 123, '2015-03-01 00:36:02.000000', 'consum', 0.0211, 'lps'),
	(424102, 123, '2015-03-01 00:36:03.000000', 'consum', 0.0211, 'lps'),
	(424103, 123, '2015-03-01 00:36:04.000000', 'consum', 0.0211, 'lps'),
	(424104, 123, '2015-03-01 00:36:05.000000', 'consum', 0.0212, 'lps'),
	(424105, 123, '2015-03-01 00:36:06.000000', 'consum', 0.0219, 'lps'),
	(424106, 123, '2015-03-01 00:36:07.000000', 'consum', 0.0211, 'lps'),
	(424107, 123, '2015-03-01 00:36:08.000000', 'consum', 0.0214, 'lps'),
	(424108, 123, '2015-03-01 00:36:09.000000', 'consum', 0.0215, 'lps'),
	(424109, 123, '2015-03-01 00:36:10.000000', 'consum', 0.0212, 'lps'),
	(424110, 123, '2015-03-01 00:36:11.000000', 'consum', 0.0217, 'lps'),
	(424111, 123, '2015-03-01 00:36:12.000000', 'consum', 0.0213, 'lps'),
	(424112, 123, '2015-03-01 00:36:13.000000', 'consum', 0.0217, 'lps'),
	(424113, 123, '2015-03-01 00:36:14.000000', 'consum', 0.0212, 'lps'),
	(424114, 123, '2015-03-01 00:36:15.000000', 'consum', 0.0214, 'lps'),
	(424115, 123, '2015-03-01 00:36:16.000000', 'consum', 0.0210, 'lps'),
	(424116, 123, '2015-03-01 00:36:17.000000', 'consum', 0.0211, 'lps'),
	(424117, 123, '2015-03-01 00:36:18.000000', 'consum', 0.0214, 'lps'),
	(424118, 123, '2015-03-01 00:36:19.000000', 'consum', 0.0216, 'lps'),
	(424119, 123, '2015-03-01 00:36:20.000000', 'consum', 0.0217, 'lps'),
	(424120, 123, '2015-03-01 00:36:21.000000', 'consum', 0.0213, 'lps'),
	(424121, 123, '2015-03-01 00:36:22.000000', 'consum', 0.0219, 'lps'),
	(424122, 123, '2015-03-01 00:36:23.000000', 'consum', 0.0220, 'lps'),
	(424123, 123, '2015-03-01 00:36:24.000000', 'consum', 0.0222, 'lps'),
	(424124, 123, '2015-03-01 00:36:25.000000', 'consum', 0.0212, 'lps'),
	(424125, 123, '2015-03-01 00:36:26.000000', 'consum', 0.0212, 'lps'),
	(424126, 123, '2015-03-01 00:36:27.000000', 'consum', 0.0212, 'lps'),
	(424127, 123, '2015-03-01 00:36:28.000000', 'consum', 0.0216, 'lps'),
	(424128, 123, '2015-03-01 00:36:29.000000', 'consum', 0.0221, 'lps'),
	(424129, 123, '2015-03-01 00:36:30.000000', 'consum', 0.0222, 'lps'),
	(424130, 123, '2015-03-01 00:36:31.000000', 'consum', 0.0213, 'lps'),
	(424131, 123, '2015-03-01 00:36:32.000000', 'consum', 0.0216, 'lps'),
	(424132, 123, '2015-03-01 00:36:33.000000', 'consum', 0.0218, 'lps'),
	(424133, 123, '2015-03-01 00:36:34.000000', 'consum', 0.0219, 'lps'),
	(424134, 123, '2015-03-01 00:36:35.000000', 'consum', 0.0220, 'lps'),
	(424135, 123, '2015-03-01 00:36:36.000000', 'consum', 0.0220, 'lps'),
	(424136, 123, '2015-03-01 00:36:37.000000', 'consum', 0.0218, 'lps'),
	(424137, 123, '2015-03-01 00:36:38.000000', 'consum', 0.0220, 'lps'),
	(424138, 123, '2015-03-01 00:36:39.000000', 'consum', 0.0211, 'lps'),
	(424139, 123, '2015-03-01 00:36:40.000000', 'consum', 0.0211, 'lps'),
	(424140, 123, '2015-03-01 00:36:41.000000', 'consum', 0.0213, 'lps'),
	(424141, 123, '2015-03-01 00:36:42.000000', 'consum', 0.0210, 'lps'),
	(424142, 123, '2015-03-01 00:36:43.000000', 'consum', 0.0215, 'lps'),
	(424143, 123, '2015-03-01 00:36:44.000000', 'consum', 0.0211, 'lps'),
	(424144, 123, '2015-03-01 00:36:45.000000', 'consum', 0.0211, 'lps'),
	(424145, 123, '2015-03-01 00:36:46.000000', 'consum', 0.0211, 'lps'),
	(424146, 123, '2015-03-01 00:36:47.000000', 'consum', 0.0215, 'lps'),
	(424147, 123, '2015-03-01 00:36:48.000000', 'consum', 0.0218, 'lps'),
	(424148, 123, '2015-03-01 00:36:49.000000', 'consum', 0.0212, 'lps'),
	(424149, 123, '2015-03-01 00:36:50.000000', 'consum', 0.0219, 'lps'),
	(424150, 123, '2015-03-01 00:36:51.000000', 'consum', 0.0213, 'lps'),
	(424151, 123, '2015-03-01 00:36:52.000000', 'consum', 0.0211, 'lps'),
	(424152, 123, '2015-03-01 00:36:53.000000', 'consum', 0.0220, 'lps'),
	(424153, 123, '2015-03-01 00:36:54.000000', 'consum', 0.0219, 'lps'),
	(424154, 123, '2015-03-01 00:36:55.000000', 'consum', 0.0213, 'lps'),
	(424155, 123, '2015-03-01 00:36:56.000000', 'consum', 0.0210, 'lps'),
	(424156, 123, '2015-03-01 00:36:57.000000', 'consum', 0.0216, 'lps'),
	(424157, 123, '2015-03-01 00:36:58.000000', 'consum', 0.0214, 'lps'),
	(424158, 123, '2015-03-01 00:36:59.000000', 'consum', 0.0212, 'lps'),
	(424159, 123, '2015-03-01 00:37:00.000000', 'consum', 0.0210, 'lps'),
	(424160, 123, '2015-03-01 00:37:01.000000', 'consum', 0.0216, 'lps'),
	(424161, 123, '2015-03-01 00:37:02.000000', 'consum', 0.0215, 'lps'),
	(424162, 123, '2015-03-01 00:37:03.000000', 'consum', 0.0217, 'lps'),
	(424163, 123, '2015-03-01 00:37:04.000000', 'consum', 0.0219, 'lps'),
	(424164, 123, '2015-03-01 00:37:05.000000', 'consum', 0.0222, 'lps'),
	(424165, 123, '2015-03-01 00:37:06.000000', 'consum', 0.0219, 'lps'),
	(424166, 123, '2015-03-01 00:37:07.000000', 'consum', 0.0216, 'lps'),
	(424167, 123, '2015-03-01 00:37:08.000000', 'consum', 0.0213, 'lps'),
	(424168, 123, '2015-03-01 00:37:09.000000', 'consum', 0.0211, 'lps'),
	(424169, 123, '2015-03-01 00:37:10.000000', 'consum', 0.0216, 'lps'),
	(424170, 123, '2015-03-01 00:37:11.000000', 'consum', 0.0214, 'lps'),
	(424171, 123, '2015-03-01 00:37:12.000000', 'consum', 0.0210, 'lps'),
	(424172, 123, '2015-03-01 00:37:13.000000', 'consum', 0.0214, 'lps'),
	(424173, 123, '2015-03-01 00:37:14.000000', 'consum', 0.0215, 'lps'),
	(424174, 123, '2015-03-01 00:37:15.000000', 'consum', 0.0211, 'lps'),
	(424175, 123, '2015-03-01 00:37:16.000000', 'consum', 0.0213, 'lps'),
	(424176, 123, '2015-03-01 00:37:17.000000', 'consum', 0.0221, 'lps'),
	(424177, 123, '2015-03-01 00:37:18.000000', 'consum', 0.0220, 'lps'),
	(424178, 123, '2015-03-01 00:37:19.000000', 'consum', 0.0213, 'lps'),
	(424179, 123, '2015-03-01 00:37:20.000000', 'consum', 0.0211, 'lps'),
	(424180, 123, '2015-03-01 00:37:21.000000', 'consum', 0.0217, 'lps'),
	(424181, 123, '2015-03-01 00:37:22.000000', 'consum', 0.0218, 'lps'),
	(424182, 123, '2015-03-01 00:37:23.000000', 'consum', 0.0217, 'lps'),
	(424183, 123, '2015-03-01 00:37:24.000000', 'consum', 0.0221, 'lps'),
	(424184, 123, '2015-03-01 00:37:25.000000', 'consum', 0.0218, 'lps'),
	(424185, 123, '2015-03-01 00:37:26.000000', 'consum', 0.0218, 'lps'),
	(424186, 123, '2015-03-01 00:37:27.000000', 'consum', 0.0215, 'lps'),
	(424187, 123, '2015-03-01 00:37:28.000000', 'consum', 0.0212, 'lps'),
	(424188, 123, '2015-03-01 00:37:29.000000', 'consum', 0.0218, 'lps'),
	(424189, 123, '2015-03-01 00:37:30.000000', 'consum', 0.0218, 'lps'),
	(424190, 123, '2015-03-01 00:37:31.000000', 'consum', 0.0215, 'lps'),
	(424191, 123, '2015-03-01 00:37:32.000000', 'consum', 0.0222, 'lps'),
	(424192, 123, '2015-03-01 00:37:33.000000', 'consum', 0.0217, 'lps'),
	(424193, 123, '2015-03-01 00:37:34.000000', 'consum', 0.0210, 'lps'),
	(424194, 123, '2015-03-01 00:37:35.000000', 'consum', 0.0215, 'lps'),
	(424195, 123, '2015-03-01 00:37:36.000000', 'consum', 0.0210, 'lps'),
	(424196, 123, '2015-03-01 00:37:37.000000', 'consum', 0.0210, 'lps'),
	(424197, 123, '2015-03-01 00:37:38.000000', 'consum', 0.0221, 'lps'),
	(424198, 123, '2015-03-01 00:37:39.000000', 'consum', 0.0215, 'lps'),
	(424199, 123, '2015-03-01 00:37:40.000000', 'consum', 0.0217, 'lps'),
	(424200, 123, '2015-03-01 00:37:41.000000', 'consum', 0.0215, 'lps'),
	(424201, 123, '2015-03-01 00:37:42.000000', 'consum', 0.0217, 'lps'),
	(424202, 123, '2015-03-01 00:37:43.000000', 'consum', 0.0216, 'lps'),
	(424203, 123, '2015-03-01 00:37:44.000000', 'consum', 0.0218, 'lps'),
	(424204, 123, '2015-03-01 00:37:45.000000', 'consum', 0.0210, 'lps'),
	(424205, 123, '2015-03-01 00:37:46.000000', 'consum', 0.0222, 'lps'),
	(424206, 123, '2015-03-01 00:37:47.000000', 'consum', 0.0219, 'lps'),
	(424207, 123, '2015-03-01 00:37:48.000000', 'consum', 0.0221, 'lps'),
	(424208, 123, '2015-03-01 00:37:49.000000', 'consum', 0.0212, 'lps'),
	(424209, 123, '2015-03-01 00:37:50.000000', 'consum', 0.0213, 'lps'),
	(424210, 123, '2015-03-01 00:37:51.000000', 'consum', 0.0219, 'lps'),
	(424211, 123, '2015-03-01 00:37:52.000000', 'consum', 0.0210, 'lps'),
	(424212, 123, '2015-03-01 00:37:53.000000', 'consum', 0.0221, 'lps'),
	(424213, 123, '2015-03-01 00:37:54.000000', 'consum', 0.0212, 'lps'),
	(424214, 123, '2015-03-01 00:37:55.000000', 'consum', 0.0217, 'lps'),
	(424215, 123, '2015-03-01 00:37:56.000000', 'consum', 0.0211, 'lps'),
	(424216, 123, '2015-03-01 00:37:57.000000', 'consum', 0.0220, 'lps'),
	(424217, 123, '2015-03-01 00:37:58.000000', 'consum', 0.0218, 'lps'),
	(424218, 123, '2015-03-01 00:37:59.000000', 'consum', 0.0221, 'lps'),
	(424219, 123, '2015-03-01 00:38:00.000000', 'consum', 0.0215, 'lps'),
	(424220, 123, '2015-03-01 00:38:01.000000', 'consum', 0.0215, 'lps'),
	(424221, 123, '2015-03-01 00:38:02.000000', 'consum', 0.0219, 'lps'),
	(424222, 123, '2015-03-01 00:38:03.000000', 'consum', 0.0218, 'lps'),
	(424223, 123, '2015-03-01 00:38:04.000000', 'consum', 0.0210, 'lps'),
	(424224, 123, '2015-03-01 00:38:05.000000', 'consum', 0.0211, 'lps'),
	(424225, 123, '2015-03-01 00:38:06.000000', 'consum', 0.0217, 'lps'),
	(424226, 123, '2015-03-01 00:38:07.000000', 'consum', 0.0215, 'lps'),
	(424227, 123, '2015-03-01 00:38:08.000000', 'consum', 0.0217, 'lps'),
	(424228, 123, '2015-03-01 00:38:09.000000', 'consum', 0.0215, 'lps'),
	(424229, 123, '2015-03-01 00:38:10.000000', 'consum', 0.0214, 'lps'),
	(424230, 123, '2015-03-01 00:38:11.000000', 'consum', 0.0218, 'lps'),
	(424231, 123, '2015-03-01 00:38:12.000000', 'consum', 0.0210, 'lps'),
	(424232, 123, '2015-03-01 00:38:13.000000', 'consum', 0.0211, 'lps'),
	(424233, 123, '2015-03-01 00:38:14.000000', 'consum', 0.0219, 'lps'),
	(424234, 123, '2015-03-01 00:38:15.000000', 'consum', 0.0212, 'lps'),
	(424235, 123, '2015-03-01 00:38:16.000000', 'consum', 0.0219, 'lps'),
	(424236, 123, '2015-03-01 00:38:17.000000', 'consum', 0.0222, 'lps'),
	(424237, 123, '2015-03-01 00:38:18.000000', 'consum', 0.0219, 'lps'),
	(424238, 123, '2015-03-01 00:38:19.000000', 'consum', 0.0217, 'lps'),
	(424239, 123, '2015-03-01 00:38:20.000000', 'consum', 0.0221, 'lps'),
	(424240, 123, '2015-03-01 00:38:21.000000', 'consum', 0.0220, 'lps'),
	(424241, 123, '2015-03-01 00:38:22.000000', 'consum', 0.0212, 'lps'),
	(424242, 123, '2015-03-01 00:38:23.000000', 'consum', 0.0216, 'lps'),
	(424243, 123, '2015-03-01 00:38:24.000000', 'consum', 0.0221, 'lps'),
	(424244, 123, '2015-03-01 00:38:25.000000', 'consum', 0.0211, 'lps'),
	(424245, 123, '2015-03-01 00:38:26.000000', 'consum', 0.0221, 'lps'),
	(424246, 123, '2015-03-01 00:38:27.000000', 'consum', 0.0211, 'lps'),
	(424247, 123, '2015-03-01 00:38:28.000000', 'consum', 0.0221, 'lps'),
	(424248, 123, '2015-03-01 00:38:29.000000', 'consum', 0.0222, 'lps'),
	(424249, 123, '2015-03-01 00:38:30.000000', 'consum', 0.0214, 'lps'),
	(424250, 123, '2015-03-01 00:38:31.000000', 'consum', 0.0218, 'lps'),
	(424251, 123, '2015-03-01 00:38:32.000000', 'consum', 0.0216, 'lps'),
	(424252, 123, '2015-03-01 00:38:33.000000', 'consum', 0.0213, 'lps'),
	(424253, 123, '2015-03-01 00:38:34.000000', 'consum', 0.0221, 'lps'),
	(424254, 123, '2015-03-01 00:38:35.000000', 'consum', 0.0219, 'lps'),
	(424255, 123, '2015-03-01 00:38:36.000000', 'consum', 0.0221, 'lps'),
	(424256, 123, '2015-03-01 00:38:37.000000', 'consum', 0.0214, 'lps'),
	(424257, 123, '2015-03-01 00:38:38.000000', 'consum', 0.0211, 'lps'),
	(424258, 123, '2015-03-01 00:38:39.000000', 'consum', 0.0217, 'lps'),
	(424259, 123, '2015-03-01 00:38:40.000000', 'consum', 0.0217, 'lps'),
	(424260, 123, '2015-03-01 00:38:41.000000', 'consum', 0.0211, 'lps'),
	(424261, 123, '2015-03-01 00:38:42.000000', 'consum', 0.0222, 'lps'),
	(424262, 123, '2015-03-01 00:38:43.000000', 'consum', 0.0212, 'lps'),
	(424263, 123, '2015-03-01 00:38:44.000000', 'consum', 0.0213, 'lps'),
	(424264, 123, '2015-03-01 00:38:45.000000', 'consum', 0.0218, 'lps'),
	(424265, 123, '2015-03-01 00:38:46.000000', 'consum', 0.0218, 'lps'),
	(424266, 123, '2015-03-01 00:38:47.000000', 'consum', 0.0210, 'lps'),
	(424267, 123, '2015-03-01 00:38:48.000000', 'consum', 0.0216, 'lps'),
	(424268, 123, '2015-03-01 00:38:49.000000', 'consum', 0.0213, 'lps'),
	(424269, 123, '2015-03-01 00:38:50.000000', 'consum', 0.0220, 'lps'),
	(424270, 123, '2015-03-01 00:38:51.000000', 'consum', 0.0214, 'lps'),
	(424271, 123, '2015-03-01 00:38:52.000000', 'consum', 0.0212, 'lps'),
	(424272, 123, '2015-03-01 00:38:53.000000', 'consum', 0.0221, 'lps'),
	(424273, 123, '2015-03-01 00:38:54.000000', 'consum', 0.0221, 'lps'),
	(424274, 123, '2015-03-01 00:38:55.000000', 'consum', 0.0221, 'lps'),
	(424275, 123, '2015-03-01 00:38:56.000000', 'consum', 0.0220, 'lps'),
	(424276, 123, '2015-03-01 00:38:57.000000', 'consum', 0.0214, 'lps'),
	(424277, 123, '2015-03-01 00:38:58.000000', 'consum', 0.0211, 'lps'),
	(424278, 123, '2015-03-01 00:38:59.000000', 'consum', 0.0220, 'lps'),
	(424279, 123, '2015-03-01 00:39:00.000000', 'consum', 0.0217, 'lps'),
	(424280, 123, '2015-03-01 00:39:01.000000', 'consum', 0.0215, 'lps'),
	(424281, 123, '2015-03-01 00:39:02.000000', 'consum', 0.0216, 'lps'),
	(424282, 123, '2015-03-01 00:39:03.000000', 'consum', 0.0213, 'lps'),
	(424283, 123, '2015-03-01 00:39:04.000000', 'consum', 0.0221, 'lps'),
	(424284, 123, '2015-03-01 00:39:05.000000', 'consum', 0.0216, 'lps'),
	(424285, 123, '2015-03-01 00:39:06.000000', 'consum', 0.0222, 'lps'),
	(424286, 123, '2015-03-01 00:39:07.000000', 'consum', 0.0212, 'lps'),
	(424287, 123, '2015-03-01 00:39:08.000000', 'consum', 0.0213, 'lps'),
	(424288, 123, '2015-03-01 00:39:09.000000', 'consum', 0.0218, 'lps'),
	(424289, 123, '2015-03-01 00:39:10.000000', 'consum', 0.0216, 'lps'),
	(424290, 123, '2015-03-01 00:39:11.000000', 'consum', 0.0218, 'lps'),
	(424291, 123, '2015-03-01 00:39:12.000000', 'consum', 0.0217, 'lps'),
	(424292, 123, '2015-03-01 00:39:13.000000', 'consum', 0.0220, 'lps'),
	(424293, 123, '2015-03-01 00:39:14.000000', 'consum', 0.0217, 'lps'),
	(424294, 123, '2015-03-01 00:39:15.000000', 'consum', 0.0212, 'lps'),
	(424295, 123, '2015-03-01 00:39:16.000000', 'consum', 0.0216, 'lps'),
	(424296, 123, '2015-03-01 00:39:17.000000', 'consum', 0.0218, 'lps'),
	(424297, 123, '2015-03-01 00:39:18.000000', 'consum', 0.0221, 'lps'),
	(424298, 123, '2015-03-01 00:39:19.000000', 'consum', 0.0217, 'lps'),
	(424299, 123, '2015-03-01 00:39:20.000000', 'consum', 0.0213, 'lps'),
	(424300, 123, '2015-03-01 00:39:21.000000', 'consum', 0.0215, 'lps'),
	(424301, 123, '2015-03-01 00:39:22.000000', 'consum', 0.0213, 'lps'),
	(424302, 123, '2015-03-01 00:39:23.000000', 'consum', 0.0213, 'lps'),
	(424303, 123, '2015-03-01 00:39:24.000000', 'consum', 0.0216, 'lps'),
	(424304, 123, '2015-03-01 00:39:25.000000', 'consum', 0.0219, 'lps'),
	(424305, 123, '2015-03-01 00:39:26.000000', 'consum', 0.0212, 'lps'),
	(424306, 123, '2015-03-01 00:39:27.000000', 'consum', 0.0217, 'lps'),
	(424307, 123, '2015-03-01 00:39:28.000000', 'consum', 0.0215, 'lps'),
	(424308, 123, '2015-03-01 00:39:29.000000', 'consum', 0.0212, 'lps'),
	(424309, 123, '2015-03-01 00:39:30.000000', 'consum', 0.0222, 'lps'),
	(424310, 123, '2015-03-01 00:39:31.000000', 'consum', 0.0210, 'lps'),
	(424311, 123, '2015-03-01 00:39:32.000000', 'consum', 0.0216, 'lps'),
	(424312, 123, '2015-03-01 00:39:33.000000', 'consum', 0.0215, 'lps'),
	(424313, 123, '2015-03-01 00:39:34.000000', 'consum', 0.0217, 'lps'),
	(424314, 123, '2015-03-01 00:39:35.000000', 'consum', 0.0218, 'lps'),
	(424315, 123, '2015-03-01 00:39:36.000000', 'consum', 0.0214, 'lps'),
	(424316, 123, '2015-03-01 00:39:37.000000', 'consum', 0.0220, 'lps'),
	(424317, 123, '2015-03-01 00:39:38.000000', 'consum', 0.0210, 'lps'),
	(424318, 123, '2015-03-01 00:39:39.000000', 'consum', 0.0220, 'lps'),
	(424319, 123, '2015-03-01 00:39:40.000000', 'consum', 0.0220, 'lps'),
	(424320, 123, '2015-03-01 00:39:41.000000', 'consum', 0.0218, 'lps'),
	(424321, 123, '2015-03-01 00:39:42.000000', 'consum', 0.0222, 'lps'),
	(424322, 123, '2015-03-01 00:39:43.000000', 'consum', 0.0221, 'lps'),
	(424323, 123, '2015-03-01 00:39:44.000000', 'consum', 0.0216, 'lps'),
	(424324, 123, '2015-03-01 00:39:45.000000', 'consum', 0.0219, 'lps'),
	(424325, 123, '2015-03-01 00:39:46.000000', 'consum', 0.0210, 'lps'),
	(424326, 123, '2015-03-01 00:39:47.000000', 'consum', 0.0213, 'lps'),
	(424327, 123, '2015-03-01 00:39:48.000000', 'consum', 0.0212, 'lps'),
	(424328, 123, '2015-03-01 00:39:49.000000', 'consum', 0.0210, 'lps'),
	(424329, 123, '2015-03-01 00:39:50.000000', 'consum', 0.0219, 'lps'),
	(424330, 123, '2015-03-01 00:39:51.000000', 'consum', 0.0217, 'lps'),
	(424331, 123, '2015-03-01 00:39:52.000000', 'consum', 0.0219, 'lps'),
	(424332, 123, '2015-03-01 00:39:53.000000', 'consum', 0.0218, 'lps'),
	(424333, 123, '2015-03-01 00:39:54.000000', 'consum', 0.0214, 'lps'),
	(424334, 123, '2015-03-01 00:39:55.000000', 'consum', 0.0220, 'lps'),
	(424335, 123, '2015-03-01 00:39:56.000000', 'consum', 0.0221, 'lps'),
	(424336, 123, '2015-03-01 00:39:57.000000', 'consum', 0.0212, 'lps'),
	(424337, 123, '2015-03-01 00:39:58.000000', 'consum', 0.0210, 'lps'),
	(424338, 123, '2015-03-01 00:39:59.000000', 'consum', 0.0218, 'lps'),
	(424339, 123, '2015-03-01 00:40:00.000000', 'consum', 0.0212, 'lps'),
	(424340, 123, '2015-03-01 00:40:01.000000', 'consum', 0.0210, 'lps'),
	(424341, 123, '2015-03-01 00:40:02.000000', 'consum', 0.0218, 'lps'),
	(424342, 123, '2015-03-01 00:40:03.000000', 'consum', 0.0210, 'lps'),
	(424343, 123, '2015-03-01 00:40:04.000000', 'consum', 0.0212, 'lps'),
	(424344, 123, '2015-03-01 00:40:05.000000', 'consum', 0.0220, 'lps'),
	(424345, 123, '2015-03-01 00:40:06.000000', 'consum', 0.0215, 'lps'),
	(424346, 123, '2015-03-01 00:40:07.000000', 'consum', 0.0221, 'lps'),
	(424347, 123, '2015-03-01 00:40:08.000000', 'consum', 0.0222, 'lps'),
	(424348, 123, '2015-03-01 00:40:09.000000', 'consum', 0.0213, 'lps'),
	(424349, 123, '2015-03-01 00:40:10.000000', 'consum', 0.0214, 'lps'),
	(424350, 123, '2015-03-01 00:40:11.000000', 'consum', 0.0210, 'lps'),
	(424351, 123, '2015-03-01 00:40:12.000000', 'consum', 0.0210, 'lps'),
	(424352, 123, '2015-03-01 00:40:13.000000', 'consum', 0.0212, 'lps'),
	(424353, 123, '2015-03-01 00:40:14.000000', 'consum', 0.0220, 'lps'),
	(424354, 123, '2015-03-01 00:40:15.000000', 'consum', 0.0214, 'lps'),
	(424355, 123, '2015-03-01 00:40:16.000000', 'consum', 0.0216, 'lps'),
	(424356, 123, '2015-03-01 00:40:17.000000', 'consum', 0.0213, 'lps'),
	(424357, 123, '2015-03-01 00:40:18.000000', 'consum', 0.0221, 'lps'),
	(424358, 123, '2015-03-01 00:40:19.000000', 'consum', 0.0216, 'lps'),
	(424359, 123, '2015-03-01 00:40:20.000000', 'consum', 0.0222, 'lps'),
	(424360, 123, '2015-03-01 00:40:21.000000', 'consum', 0.0215, 'lps'),
	(424361, 123, '2015-03-01 00:40:22.000000', 'consum', 0.0212, 'lps'),
	(424362, 123, '2015-03-01 00:40:23.000000', 'consum', 0.0220, 'lps'),
	(424363, 123, '2015-03-01 00:40:24.000000', 'consum', 0.0212, 'lps'),
	(424364, 123, '2015-03-01 00:40:25.000000', 'consum', 0.0219, 'lps'),
	(424365, 123, '2015-03-01 00:40:26.000000', 'consum', 0.0222, 'lps'),
	(424366, 123, '2015-03-01 00:40:27.000000', 'consum', 0.0218, 'lps'),
	(424367, 123, '2015-03-01 00:40:28.000000', 'consum', 0.0216, 'lps'),
	(424368, 123, '2015-03-01 00:40:29.000000', 'consum', 0.0216, 'lps'),
	(424369, 123, '2015-03-01 00:40:30.000000', 'consum', 0.0222, 'lps'),
	(424370, 123, '2015-03-01 00:40:31.000000', 'consum', 0.0215, 'lps'),
	(424371, 123, '2015-03-01 00:40:32.000000', 'consum', 0.0210, 'lps'),
	(424372, 123, '2015-03-01 00:40:33.000000', 'consum', 0.0221, 'lps'),
	(424373, 123, '2015-03-01 00:40:34.000000', 'consum', 0.0217, 'lps'),
	(424374, 123, '2015-03-01 00:40:35.000000', 'consum', 0.0222, 'lps'),
	(424375, 123, '2015-03-01 00:40:36.000000', 'consum', 0.0212, 'lps'),
	(424376, 123, '2015-03-01 00:40:37.000000', 'consum', 0.0222, 'lps'),
	(424377, 123, '2015-03-01 00:40:38.000000', 'consum', 0.0213, 'lps'),
	(424378, 123, '2015-03-01 00:40:39.000000', 'consum', 0.0216, 'lps'),
	(424379, 123, '2015-03-01 00:40:40.000000', 'consum', 0.0220, 'lps'),
	(424380, 123, '2015-03-01 00:40:41.000000', 'consum', 0.0215, 'lps'),
	(424381, 123, '2015-03-01 00:40:42.000000', 'consum', 0.0220, 'lps'),
	(424382, 123, '2015-03-01 00:40:43.000000', 'consum', 0.0221, 'lps'),
	(424383, 123, '2015-03-01 00:40:44.000000', 'consum', 0.0220, 'lps'),
	(424384, 123, '2015-03-01 00:40:45.000000', 'consum', 0.0214, 'lps'),
	(424385, 123, '2015-03-01 00:40:46.000000', 'consum', 0.0214, 'lps'),
	(424386, 123, '2015-03-01 00:40:47.000000', 'consum', 0.0219, 'lps'),
	(424387, 123, '2015-03-01 00:40:48.000000', 'consum', 0.0216, 'lps'),
	(424388, 123, '2015-03-01 00:40:49.000000', 'consum', 0.0214, 'lps'),
	(424389, 123, '2015-03-01 00:40:50.000000', 'consum', 0.0214, 'lps'),
	(424390, 123, '2015-03-01 00:40:51.000000', 'consum', 0.0217, 'lps'),
	(424391, 123, '2015-03-01 00:40:52.000000', 'consum', 0.0222, 'lps'),
	(424392, 123, '2015-03-01 00:40:53.000000', 'consum', 0.0210, 'lps'),
	(424393, 123, '2015-03-01 00:40:54.000000', 'consum', 0.0214, 'lps'),
	(424394, 123, '2015-03-01 00:40:55.000000', 'consum', 0.0217, 'lps'),
	(424395, 123, '2015-03-01 00:40:56.000000', 'consum', 0.0220, 'lps'),
	(424396, 123, '2015-03-01 00:40:57.000000', 'consum', 0.0212, 'lps'),
	(424397, 123, '2015-03-01 00:40:58.000000', 'consum', 0.0217, 'lps'),
	(424398, 123, '2015-03-01 00:40:59.000000', 'consum', 0.0215, 'lps'),
	(424399, 123, '2015-03-01 00:41:00.000000', 'consum', 0.0214, 'lps'),
	(424400, 123, '2015-03-01 00:41:01.000000', 'consum', 0.0215, 'lps'),
	(424401, 123, '2015-03-01 00:41:02.000000', 'consum', 0.0210, 'lps'),
	(424402, 123, '2015-03-01 00:41:03.000000', 'consum', 0.0221, 'lps'),
	(424403, 123, '2015-03-01 00:41:04.000000', 'consum', 0.0216, 'lps'),
	(424404, 123, '2015-03-01 00:41:05.000000', 'consum', 0.0219, 'lps'),
	(424405, 123, '2015-03-01 00:41:06.000000', 'consum', 0.0214, 'lps'),
	(424406, 123, '2015-03-01 00:41:07.000000', 'consum', 0.0214, 'lps'),
	(424407, 123, '2015-03-01 00:41:08.000000', 'consum', 0.0217, 'lps'),
	(424408, 123, '2015-03-01 00:41:09.000000', 'consum', 0.0210, 'lps'),
	(424409, 123, '2015-03-01 00:41:10.000000', 'consum', 0.0213, 'lps'),
	(424410, 123, '2015-03-01 00:41:11.000000', 'consum', 0.0214, 'lps'),
	(424411, 123, '2015-03-01 00:41:12.000000', 'consum', 0.0222, 'lps'),
	(424412, 123, '2015-03-01 00:41:13.000000', 'consum', 0.0221, 'lps'),
	(424413, 123, '2015-03-01 00:41:14.000000', 'consum', 0.0215, 'lps'),
	(424414, 123, '2015-03-01 00:41:15.000000', 'consum', 0.0214, 'lps'),
	(424415, 123, '2015-03-01 00:41:16.000000', 'consum', 0.0218, 'lps'),
	(424416, 123, '2015-03-01 00:41:17.000000', 'consum', 0.0212, 'lps'),
	(424417, 123, '2015-03-01 00:41:18.000000', 'consum', 0.0222, 'lps'),
	(424418, 123, '2015-03-01 00:41:19.000000', 'consum', 0.0213, 'lps'),
	(424419, 123, '2015-03-01 00:41:20.000000', 'consum', 0.0216, 'lps'),
	(424420, 123, '2015-03-01 00:41:21.000000', 'consum', 0.0220, 'lps'),
	(424421, 123, '2015-03-01 00:41:22.000000', 'consum', 0.0215, 'lps'),
	(424422, 123, '2015-03-01 00:41:23.000000', 'consum', 0.0217, 'lps'),
	(424423, 123, '2015-03-01 00:41:24.000000', 'consum', 0.0217, 'lps'),
	(424424, 123, '2015-03-01 00:41:25.000000', 'consum', 0.0211, 'lps'),
	(424425, 123, '2015-03-01 00:41:26.000000', 'consum', 0.0210, 'lps'),
	(424426, 123, '2015-03-01 00:41:27.000000', 'consum', 0.0219, 'lps'),
	(424427, 123, '2015-03-01 00:41:28.000000', 'consum', 0.0216, 'lps'),
	(424428, 123, '2015-03-01 00:41:29.000000', 'consum', 0.0215, 'lps'),
	(424429, 123, '2015-03-01 00:41:30.000000', 'consum', 0.0217, 'lps'),
	(424430, 123, '2015-03-01 00:41:31.000000', 'consum', 0.0218, 'lps'),
	(424431, 123, '2015-03-01 00:41:32.000000', 'consum', 0.0214, 'lps'),
	(424432, 123, '2015-03-01 00:41:33.000000', 'consum', 0.0210, 'lps'),
	(424433, 123, '2015-03-01 00:41:34.000000', 'consum', 0.0210, 'lps'),
	(424434, 123, '2015-03-01 00:41:35.000000', 'consum', 0.0212, 'lps'),
	(424435, 123, '2015-03-01 00:41:36.000000', 'consum', 0.0218, 'lps'),
	(424436, 123, '2015-03-01 00:41:37.000000', 'consum', 0.0222, 'lps'),
	(424437, 123, '2015-03-01 00:41:38.000000', 'consum', 0.0217, 'lps'),
	(424438, 123, '2015-03-01 00:41:39.000000', 'consum', 0.0210, 'lps'),
	(424439, 123, '2015-03-01 00:41:40.000000', 'consum', 0.0215, 'lps'),
	(424440, 123, '2015-03-01 00:41:41.000000', 'consum', 0.0212, 'lps'),
	(424441, 123, '2015-03-01 00:41:42.000000', 'consum', 0.0218, 'lps'),
	(424442, 123, '2015-03-01 00:41:43.000000', 'consum', 0.0219, 'lps'),
	(424443, 123, '2015-03-01 00:41:44.000000', 'consum', 0.0218, 'lps'),
	(424444, 123, '2015-03-01 00:41:45.000000', 'consum', 0.0212, 'lps'),
	(424445, 123, '2015-03-01 00:41:46.000000', 'consum', 0.0222, 'lps'),
	(424446, 123, '2015-03-01 00:41:47.000000', 'consum', 0.0213, 'lps'),
	(424447, 123, '2015-03-01 00:41:48.000000', 'consum', 0.0215, 'lps'),
	(424448, 123, '2015-03-01 00:41:49.000000', 'consum', 0.0213, 'lps'),
	(424449, 123, '2015-03-01 00:41:50.000000', 'consum', 0.0211, 'lps'),
	(424450, 123, '2015-03-01 00:41:51.000000', 'consum', 0.0220, 'lps'),
	(424451, 123, '2015-03-01 00:41:52.000000', 'consum', 0.0219, 'lps'),
	(424452, 123, '2015-03-01 00:41:53.000000', 'consum', 0.0212, 'lps'),
	(424453, 123, '2015-03-01 00:41:54.000000', 'consum', 0.0219, 'lps'),
	(424454, 123, '2015-03-01 00:41:55.000000', 'consum', 0.0210, 'lps'),
	(424455, 123, '2015-03-01 00:41:56.000000', 'consum', 0.0210, 'lps'),
	(424456, 123, '2015-03-01 00:41:57.000000', 'consum', 0.0211, 'lps'),
	(424457, 123, '2015-03-01 00:41:58.000000', 'consum', 0.0216, 'lps'),
	(424458, 123, '2015-03-01 00:41:59.000000', 'consum', 0.0212, 'lps'),
	(424459, 123, '2015-03-01 00:42:00.000000', 'consum', 0.0214, 'lps'),
	(424460, 123, '2015-03-01 00:42:01.000000', 'consum', 0.0212, 'lps'),
	(424461, 123, '2015-03-01 00:42:02.000000', 'consum', 0.0220, 'lps'),
	(424462, 123, '2015-03-01 00:42:03.000000', 'consum', 0.0216, 'lps'),
	(424463, 123, '2015-03-01 00:42:04.000000', 'consum', 0.0211, 'lps'),
	(424464, 123, '2015-03-01 00:42:05.000000', 'consum', 0.0210, 'lps'),
	(424465, 123, '2015-03-01 00:42:06.000000', 'consum', 0.0222, 'lps'),
	(424466, 123, '2015-03-01 00:42:07.000000', 'consum', 0.0216, 'lps'),
	(424467, 123, '2015-03-01 00:42:08.000000', 'consum', 0.0219, 'lps'),
	(424468, 123, '2015-03-01 00:42:09.000000', 'consum', 0.0212, 'lps'),
	(424469, 123, '2015-03-01 00:42:10.000000', 'consum', 0.0217, 'lps'),
	(424470, 123, '2015-03-01 00:42:11.000000', 'consum', 0.0216, 'lps'),
	(424471, 123, '2015-03-01 00:42:12.000000', 'consum', 0.0221, 'lps'),
	(424472, 123, '2015-03-01 00:42:13.000000', 'consum', 0.0219, 'lps'),
	(424473, 123, '2015-03-01 00:42:14.000000', 'consum', 0.0222, 'lps'),
	(424474, 123, '2015-03-01 00:42:15.000000', 'consum', 0.0218, 'lps'),
	(424475, 123, '2015-03-01 00:42:16.000000', 'consum', 0.0216, 'lps'),
	(424476, 123, '2015-03-01 00:42:17.000000', 'consum', 0.0214, 'lps'),
	(424477, 123, '2015-03-01 00:42:18.000000', 'consum', 0.0214, 'lps'),
	(424478, 123, '2015-03-01 00:42:19.000000', 'consum', 0.0219, 'lps'),
	(424479, 123, '2015-03-01 00:42:20.000000', 'consum', 0.0219, 'lps'),
	(424480, 123, '2015-03-01 00:42:21.000000', 'consum', 0.0214, 'lps'),
	(424481, 123, '2015-03-01 00:42:22.000000', 'consum', 0.0217, 'lps'),
	(424482, 123, '2015-03-01 00:42:23.000000', 'consum', 0.0222, 'lps'),
	(424483, 123, '2015-03-01 00:42:24.000000', 'consum', 0.0211, 'lps'),
	(424484, 123, '2015-03-01 00:42:25.000000', 'consum', 0.0216, 'lps'),
	(424485, 123, '2015-03-01 00:42:26.000000', 'consum', 0.0212, 'lps'),
	(424486, 123, '2015-03-01 00:42:27.000000', 'consum', 0.0217, 'lps'),
	(424487, 123, '2015-03-01 00:42:28.000000', 'consum', 0.0211, 'lps'),
	(424488, 123, '2015-03-01 00:42:29.000000', 'consum', 0.0220, 'lps'),
	(424489, 123, '2015-03-01 00:42:30.000000', 'consum', 0.0220, 'lps'),
	(424490, 123, '2015-03-01 00:42:31.000000', 'consum', 0.0217, 'lps'),
	(424491, 123, '2015-03-01 00:42:32.000000', 'consum', 0.0215, 'lps'),
	(424492, 123, '2015-03-01 00:42:33.000000', 'consum', 0.0215, 'lps'),
	(424493, 123, '2015-03-01 00:42:34.000000', 'consum', 0.0219, 'lps'),
	(424494, 123, '2015-03-01 00:42:35.000000', 'consum', 0.0216, 'lps'),
	(424495, 123, '2015-03-01 00:42:36.000000', 'consum', 0.0213, 'lps'),
	(424496, 123, '2015-03-01 00:42:37.000000', 'consum', 0.0219, 'lps'),
	(424497, 123, '2015-03-01 00:42:38.000000', 'consum', 0.0222, 'lps'),
	(424498, 123, '2015-03-01 00:42:39.000000', 'consum', 0.0216, 'lps'),
	(424499, 123, '2015-03-01 00:42:40.000000', 'consum', 0.0217, 'lps'),
	(424500, 123, '2015-03-01 00:42:41.000000', 'consum', 0.0217, 'lps'),
	(424501, 123, '2015-03-01 00:42:42.000000', 'consum', 0.0212, 'lps'),
	(424502, 123, '2015-03-01 00:42:43.000000', 'consum', 0.0210, 'lps'),
	(424503, 123, '2015-03-01 00:42:44.000000', 'consum', 0.0219, 'lps'),
	(424504, 123, '2015-03-01 00:42:45.000000', 'consum', 0.0215, 'lps'),
	(424505, 123, '2015-03-01 00:42:46.000000', 'consum', 0.0221, 'lps'),
	(424506, 123, '2015-03-01 00:42:47.000000', 'consum', 0.0213, 'lps'),
	(424507, 123, '2015-03-01 00:42:48.000000', 'consum', 0.0216, 'lps'),
	(424508, 123, '2015-03-01 00:42:49.000000', 'consum', 0.0222, 'lps'),
	(424509, 123, '2015-03-01 00:42:50.000000', 'consum', 0.0212, 'lps'),
	(424510, 123, '2015-03-01 00:42:51.000000', 'consum', 0.0222, 'lps'),
	(424511, 123, '2015-03-01 00:42:52.000000', 'consum', 0.0214, 'lps'),
	(424512, 123, '2015-03-01 00:42:53.000000', 'consum', 0.0221, 'lps'),
	(424513, 123, '2015-03-01 00:42:54.000000', 'consum', 0.0214, 'lps'),
	(424514, 123, '2015-03-01 00:42:55.000000', 'consum', 0.0212, 'lps'),
	(424515, 123, '2015-03-01 00:42:56.000000', 'consum', 0.0221, 'lps'),
	(424516, 123, '2015-03-01 00:42:57.000000', 'consum', 0.0219, 'lps'),
	(424517, 123, '2015-03-01 00:42:58.000000', 'consum', 0.0222, 'lps'),
	(424518, 123, '2015-03-01 00:42:59.000000', 'consum', 0.0221, 'lps'),
	(424519, 123, '2015-03-01 00:43:00.000000', 'consum', 0.0213, 'lps'),
	(424520, 123, '2015-03-01 00:43:01.000000', 'consum', 0.0218, 'lps'),
	(424521, 123, '2015-03-01 00:43:02.000000', 'consum', 0.0217, 'lps'),
	(424522, 123, '2015-03-01 00:43:03.000000', 'consum', 0.0221, 'lps'),
	(424523, 123, '2015-03-01 00:43:04.000000', 'consum', 0.0220, 'lps'),
	(424524, 123, '2015-03-01 00:43:05.000000', 'consum', 0.0216, 'lps'),
	(424525, 123, '2015-03-01 00:43:06.000000', 'consum', 0.0220, 'lps'),
	(424526, 123, '2015-03-01 00:43:07.000000', 'consum', 0.0217, 'lps'),
	(424527, 123, '2015-03-01 00:43:08.000000', 'consum', 0.0216, 'lps'),
	(424528, 123, '2015-03-01 00:43:09.000000', 'consum', 0.0220, 'lps'),
	(424529, 123, '2015-03-01 00:43:10.000000', 'consum', 0.0215, 'lps'),
	(424530, 123, '2015-03-01 00:43:11.000000', 'consum', 0.0219, 'lps'),
	(424531, 123, '2015-03-01 00:43:12.000000', 'consum', 0.0214, 'lps'),
	(424532, 123, '2015-03-01 00:43:13.000000', 'consum', 0.0216, 'lps'),
	(424533, 123, '2015-03-01 00:43:14.000000', 'consum', 0.0218, 'lps'),
	(424534, 123, '2015-03-01 00:43:15.000000', 'consum', 0.0218, 'lps'),
	(424535, 123, '2015-03-01 00:43:16.000000', 'consum', 0.0213, 'lps'),
	(424536, 123, '2015-03-01 00:43:17.000000', 'consum', 0.0217, 'lps'),
	(424537, 123, '2015-03-01 00:43:18.000000', 'consum', 0.0220, 'lps'),
	(424538, 123, '2015-03-01 00:43:19.000000', 'consum', 0.0217, 'lps'),
	(424539, 123, '2015-03-01 00:43:20.000000', 'consum', 0.0213, 'lps'),
	(424540, 123, '2015-03-01 00:43:21.000000', 'consum', 0.0220, 'lps'),
	(424541, 123, '2015-03-01 00:43:22.000000', 'consum', 0.0210, 'lps'),
	(424542, 123, '2015-03-01 00:43:23.000000', 'consum', 0.0222, 'lps'),
	(424543, 123, '2015-03-01 00:43:24.000000', 'consum', 0.0217, 'lps'),
	(424544, 123, '2015-03-01 00:43:25.000000', 'consum', 0.0222, 'lps'),
	(424545, 123, '2015-03-01 00:43:26.000000', 'consum', 0.0222, 'lps'),
	(424546, 123, '2015-03-01 00:43:27.000000', 'consum', 0.0211, 'lps'),
	(424547, 123, '2015-03-01 00:43:28.000000', 'consum', 0.0219, 'lps'),
	(424548, 123, '2015-03-01 00:43:29.000000', 'consum', 0.0214, 'lps'),
	(424549, 123, '2015-03-01 00:43:30.000000', 'consum', 0.0215, 'lps'),
	(424550, 123, '2015-03-01 00:43:31.000000', 'consum', 0.0222, 'lps'),
	(424551, 123, '2015-03-01 00:43:32.000000', 'consum', 0.0217, 'lps'),
	(424552, 123, '2015-03-01 00:43:33.000000', 'consum', 0.0222, 'lps'),
	(424553, 123, '2015-03-01 00:43:34.000000', 'consum', 0.0210, 'lps'),
	(424554, 123, '2015-03-01 00:43:35.000000', 'consum', 0.0213, 'lps'),
	(424555, 123, '2015-03-01 00:43:36.000000', 'consum', 0.0212, 'lps'),
	(424556, 123, '2015-03-01 00:43:37.000000', 'consum', 0.0212, 'lps'),
	(424557, 123, '2015-03-01 00:43:38.000000', 'consum', 0.0216, 'lps'),
	(424558, 123, '2015-03-01 00:43:39.000000', 'consum', 0.0210, 'lps'),
	(424559, 123, '2015-03-01 00:43:40.000000', 'consum', 0.0216, 'lps'),
	(424560, 123, '2015-03-01 00:43:41.000000', 'consum', 0.0216, 'lps'),
	(424561, 123, '2015-03-01 00:43:42.000000', 'consum', 0.0221, 'lps'),
	(424562, 123, '2015-03-01 00:43:43.000000', 'consum', 0.0222, 'lps'),
	(424563, 123, '2015-03-01 00:43:44.000000', 'consum', 0.0211, 'lps'),
	(424564, 123, '2015-03-01 00:43:45.000000', 'consum', 0.0221, 'lps'),
	(424565, 123, '2015-03-01 00:43:46.000000', 'consum', 0.0222, 'lps'),
	(424566, 123, '2015-03-01 00:43:47.000000', 'consum', 0.0211, 'lps'),
	(424567, 123, '2015-03-01 00:43:48.000000', 'consum', 0.0220, 'lps'),
	(424568, 123, '2015-03-01 00:43:49.000000', 'consum', 0.0219, 'lps'),
	(424569, 123, '2015-03-01 00:43:50.000000', 'consum', 0.0210, 'lps'),
	(424570, 123, '2015-03-01 00:43:51.000000', 'consum', 0.0212, 'lps'),
	(424571, 123, '2015-03-01 00:43:52.000000', 'consum', 0.0218, 'lps'),
	(424572, 123, '2015-03-01 00:43:53.000000', 'consum', 0.0219, 'lps'),
	(424573, 123, '2015-03-01 00:43:54.000000', 'consum', 0.0218, 'lps'),
	(424574, 123, '2015-03-01 00:43:55.000000', 'consum', 0.0213, 'lps'),
	(424575, 123, '2015-03-01 00:43:56.000000', 'consum', 0.0211, 'lps'),
	(424576, 123, '2015-03-01 00:43:57.000000', 'consum', 0.0222, 'lps'),
	(424577, 123, '2015-03-01 00:43:58.000000', 'consum', 0.0216, 'lps'),
	(424578, 123, '2015-03-01 00:43:59.000000', 'consum', 0.0217, 'lps'),
	(424579, 123, '2015-03-01 00:44:00.000000', 'consum', 0.0215, 'lps'),
	(424580, 123, '2015-03-01 00:44:01.000000', 'consum', 0.0214, 'lps'),
	(424581, 123, '2015-03-01 00:44:02.000000', 'consum', 0.0214, 'lps'),
	(424582, 123, '2015-03-01 00:44:03.000000', 'consum', 0.0220, 'lps'),
	(424583, 123, '2015-03-01 00:44:04.000000', 'consum', 0.0211, 'lps'),
	(424584, 123, '2015-03-01 00:44:05.000000', 'consum', 0.0221, 'lps'),
	(424585, 123, '2015-03-01 00:44:06.000000', 'consum', 0.0213, 'lps'),
	(424586, 123, '2015-03-01 00:44:07.000000', 'consum', 0.0217, 'lps'),
	(424587, 123, '2015-03-01 00:44:08.000000', 'consum', 0.0211, 'lps'),
	(424588, 123, '2015-03-01 00:44:09.000000', 'consum', 0.0210, 'lps'),
	(424589, 123, '2015-03-01 00:44:10.000000', 'consum', 0.0217, 'lps'),
	(424590, 123, '2015-03-01 00:44:11.000000', 'consum', 0.0221, 'lps'),
	(424591, 123, '2015-03-01 00:44:12.000000', 'consum', 0.0219, 'lps'),
	(424592, 123, '2015-03-01 00:44:13.000000', 'consum', 0.0222, 'lps'),
	(424593, 123, '2015-03-01 00:44:14.000000', 'consum', 0.0218, 'lps'),
	(424594, 123, '2015-03-01 00:44:15.000000', 'consum', 0.0214, 'lps'),
	(424595, 123, '2015-03-01 00:44:16.000000', 'consum', 0.0218, 'lps'),
	(424596, 123, '2015-03-01 00:44:17.000000', 'consum', 0.0214, 'lps'),
	(424597, 123, '2015-03-01 00:44:18.000000', 'consum', 0.0219, 'lps'),
	(424598, 123, '2015-03-01 00:44:19.000000', 'consum', 0.0219, 'lps'),
	(424599, 123, '2015-03-01 00:44:20.000000', 'consum', 0.0217, 'lps'),
	(424600, 123, '2015-03-01 00:44:21.000000', 'consum', 0.0215, 'lps'),
	(424601, 123, '2015-03-01 00:44:22.000000', 'consum', 0.0215, 'lps'),
	(424602, 123, '2015-03-01 00:44:23.000000', 'consum', 0.0221, 'lps'),
	(424603, 123, '2015-03-01 00:44:24.000000', 'consum', 0.0211, 'lps'),
	(424604, 123, '2015-03-01 00:44:25.000000', 'consum', 0.0210, 'lps'),
	(424605, 123, '2015-03-01 00:44:26.000000', 'consum', 0.0220, 'lps'),
	(424606, 123, '2015-03-01 00:44:27.000000', 'consum', 0.0221, 'lps'),
	(424607, 123, '2015-03-01 00:44:28.000000', 'consum', 0.0210, 'lps'),
	(424608, 123, '2015-03-01 00:44:29.000000', 'consum', 0.0218, 'lps'),
	(424609, 123, '2015-03-01 00:44:30.000000', 'consum', 0.0210, 'lps'),
	(424610, 123, '2015-03-01 00:44:31.000000', 'consum', 0.0214, 'lps'),
	(424611, 123, '2015-03-01 00:44:32.000000', 'consum', 0.0216, 'lps'),
	(424612, 123, '2015-03-01 00:44:33.000000', 'consum', 0.0215, 'lps'),
	(424613, 123, '2015-03-01 00:44:34.000000', 'consum', 0.0219, 'lps'),
	(424614, 123, '2015-03-01 00:44:35.000000', 'consum', 0.0212, 'lps'),
	(424615, 123, '2015-03-01 00:44:36.000000', 'consum', 0.0210, 'lps'),
	(424616, 123, '2015-03-01 00:44:37.000000', 'consum', 0.0214, 'lps'),
	(424617, 123, '2015-03-01 00:44:38.000000', 'consum', 0.0218, 'lps'),
	(424618, 123, '2015-03-01 00:44:39.000000', 'consum', 0.0215, 'lps'),
	(424619, 123, '2015-03-01 00:44:40.000000', 'consum', 0.0222, 'lps'),
	(424620, 123, '2015-03-01 00:44:41.000000', 'consum', 0.0219, 'lps'),
	(424621, 123, '2015-03-01 00:44:42.000000', 'consum', 0.0219, 'lps'),
	(424622, 123, '2015-03-01 00:44:43.000000', 'consum', 0.0215, 'lps'),
	(424623, 123, '2015-03-01 00:44:44.000000', 'consum', 0.0210, 'lps'),
	(424624, 123, '2015-03-01 00:44:45.000000', 'consum', 0.0222, 'lps'),
	(424625, 123, '2015-03-01 00:44:46.000000', 'consum', 0.0219, 'lps'),
	(424626, 123, '2015-03-01 00:44:47.000000', 'consum', 0.0217, 'lps'),
	(424627, 123, '2015-03-01 00:44:48.000000', 'consum', 0.0221, 'lps'),
	(424628, 123, '2015-03-01 00:44:49.000000', 'consum', 0.0219, 'lps'),
	(424629, 123, '2015-03-01 00:44:50.000000', 'consum', 0.0210, 'lps'),
	(424630, 123, '2015-03-01 00:44:51.000000', 'consum', 0.0221, 'lps'),
	(424631, 123, '2015-03-01 00:44:52.000000', 'consum', 0.0212, 'lps'),
	(424632, 123, '2015-03-01 00:44:53.000000', 'consum', 0.0214, 'lps'),
	(424633, 123, '2015-03-01 00:44:54.000000', 'consum', 0.0210, 'lps'),
	(424634, 123, '2015-03-01 00:44:55.000000', 'consum', 0.0213, 'lps'),
	(424635, 123, '2015-03-01 00:44:56.000000', 'consum', 0.0214, 'lps'),
	(424636, 123, '2015-03-01 00:44:57.000000', 'consum', 0.0218, 'lps'),
	(424637, 123, '2015-03-01 00:44:58.000000', 'consum', 0.0215, 'lps'),
	(424638, 123, '2015-03-01 00:44:59.000000', 'consum', 0.0213, 'lps'),
	(424639, 123, '2015-03-01 00:45:00.000000', 'consum', 0.0221, 'lps'),
	(424640, 123, '2015-03-01 00:45:01.000000', 'consum', 0.0216, 'lps'),
	(424641, 123, '2015-03-01 00:45:02.000000', 'consum', 0.0211, 'lps'),
	(424642, 123, '2015-03-01 00:45:03.000000', 'consum', 0.0221, 'lps'),
	(424643, 123, '2015-03-01 00:45:04.000000', 'consum', 0.0210, 'lps'),
	(424644, 123, '2015-03-01 00:45:05.000000', 'consum', 0.0218, 'lps'),
	(424645, 123, '2015-03-01 00:45:06.000000', 'consum', 0.0213, 'lps'),
	(424646, 123, '2015-03-01 00:45:07.000000', 'consum', 0.0211, 'lps'),
	(424647, 123, '2015-03-01 00:45:08.000000', 'consum', 0.0222, 'lps'),
	(424648, 123, '2015-03-01 00:45:09.000000', 'consum', 0.0217, 'lps'),
	(424649, 123, '2015-03-01 00:45:10.000000', 'consum', 0.0220, 'lps'),
	(424650, 123, '2015-03-01 00:45:11.000000', 'consum', 0.0215, 'lps'),
	(424651, 123, '2015-03-01 00:45:12.000000', 'consum', 0.0219, 'lps'),
	(424652, 123, '2015-03-01 00:45:13.000000', 'consum', 0.0213, 'lps'),
	(424653, 123, '2015-03-01 00:45:14.000000', 'consum', 0.0214, 'lps'),
	(424654, 123, '2015-03-01 00:45:15.000000', 'consum', 0.0221, 'lps'),
	(424655, 123, '2015-03-01 00:45:16.000000', 'consum', 0.0213, 'lps'),
	(424656, 123, '2015-03-01 00:45:17.000000', 'consum', 0.0220, 'lps'),
	(424657, 123, '2015-03-01 00:45:18.000000', 'consum', 0.0211, 'lps'),
	(424658, 123, '2015-03-01 00:45:19.000000', 'consum', 0.0210, 'lps'),
	(424659, 123, '2015-03-01 00:45:20.000000', 'consum', 0.0211, 'lps'),
	(424660, 123, '2015-03-01 00:45:21.000000', 'consum', 0.0213, 'lps'),
	(424661, 123, '2015-03-01 00:45:22.000000', 'consum', 0.0210, 'lps'),
	(424662, 123, '2015-03-01 00:45:23.000000', 'consum', 0.0213, 'lps'),
	(424663, 123, '2015-03-01 00:45:24.000000', 'consum', 0.0212, 'lps'),
	(424664, 123, '2015-03-01 00:45:25.000000', 'consum', 0.0211, 'lps'),
	(424665, 123, '2015-03-01 00:45:26.000000', 'consum', 0.0212, 'lps'),
	(424666, 123, '2015-03-01 00:45:27.000000', 'consum', 0.0218, 'lps'),
	(424667, 123, '2015-03-01 00:45:28.000000', 'consum', 0.0219, 'lps'),
	(424668, 123, '2015-03-01 00:45:29.000000', 'consum', 0.0216, 'lps'),
	(424669, 123, '2015-03-01 00:45:30.000000', 'consum', 0.0213, 'lps'),
	(424670, 123, '2015-03-01 00:45:31.000000', 'consum', 0.0222, 'lps'),
	(424671, 123, '2015-03-01 00:45:32.000000', 'consum', 0.0221, 'lps'),
	(424672, 123, '2015-03-01 00:45:33.000000', 'consum', 0.0217, 'lps'),
	(424673, 123, '2015-03-01 00:45:34.000000', 'consum', 0.0213, 'lps'),
	(424674, 123, '2015-03-01 00:45:35.000000', 'consum', 0.0216, 'lps'),
	(424675, 123, '2015-03-01 00:45:36.000000', 'consum', 0.0219, 'lps'),
	(424676, 123, '2015-03-01 00:45:37.000000', 'consum', 0.0212, 'lps'),
	(424677, 123, '2015-03-01 00:45:38.000000', 'consum', 0.0220, 'lps'),
	(424678, 123, '2015-03-01 00:45:39.000000', 'consum', 0.0215, 'lps'),
	(424679, 123, '2015-03-01 00:45:40.000000', 'consum', 0.0220, 'lps'),
	(424680, 123, '2015-03-01 00:45:41.000000', 'consum', 0.0220, 'lps'),
	(424681, 123, '2015-03-01 00:45:42.000000', 'consum', 0.0217, 'lps'),
	(424682, 123, '2015-03-01 00:45:43.000000', 'consum', 0.0217, 'lps'),
	(424683, 123, '2015-03-01 00:45:44.000000', 'consum', 0.0211, 'lps'),
	(424684, 123, '2015-03-01 00:45:45.000000', 'consum', 0.0218, 'lps'),
	(424685, 123, '2015-03-01 00:45:46.000000', 'consum', 0.0210, 'lps'),
	(424686, 123, '2015-03-01 00:45:47.000000', 'consum', 0.0210, 'lps'),
	(424687, 123, '2015-03-01 00:45:48.000000', 'consum', 0.0214, 'lps'),
	(424688, 123, '2015-03-01 00:45:49.000000', 'consum', 0.0216, 'lps'),
	(424689, 123, '2015-03-01 00:45:50.000000', 'consum', 0.0215, 'lps'),
	(424690, 123, '2015-03-01 00:45:51.000000', 'consum', 0.0216, 'lps'),
	(424691, 123, '2015-03-01 00:45:52.000000', 'consum', 0.0216, 'lps'),
	(424692, 123, '2015-03-01 00:45:53.000000', 'consum', 0.0220, 'lps'),
	(424693, 123, '2015-03-01 00:45:54.000000', 'consum', 0.0217, 'lps'),
	(424694, 123, '2015-03-01 00:45:55.000000', 'consum', 0.0215, 'lps'),
	(424695, 123, '2015-03-01 00:45:56.000000', 'consum', 0.0217, 'lps'),
	(424696, 123, '2015-03-01 00:45:57.000000', 'consum', 0.0214, 'lps'),
	(424697, 123, '2015-03-01 00:45:58.000000', 'consum', 0.0211, 'lps'),
	(424698, 123, '2015-03-01 00:45:59.000000', 'consum', 0.0218, 'lps'),
	(424699, 123, '2015-03-01 00:46:00.000000', 'consum', 0.0222, 'lps'),
	(424700, 123, '2015-03-01 00:46:01.000000', 'consum', 0.0220, 'lps'),
	(424701, 123, '2015-03-01 00:46:02.000000', 'consum', 0.0212, 'lps'),
	(424702, 123, '2015-03-01 00:46:03.000000', 'consum', 0.0214, 'lps'),
	(424703, 123, '2015-03-01 00:46:04.000000', 'consum', 0.0212, 'lps'),
	(424704, 123, '2015-03-01 00:46:05.000000', 'consum', 0.0220, 'lps'),
	(424705, 123, '2015-03-01 00:46:06.000000', 'consum', 0.0219, 'lps'),
	(424706, 123, '2015-03-01 00:46:07.000000', 'consum', 0.0210, 'lps'),
	(424707, 123, '2015-03-01 00:46:08.000000', 'consum', 0.0221, 'lps'),
	(424708, 123, '2015-03-01 00:46:09.000000', 'consum', 0.0217, 'lps'),
	(424709, 123, '2015-03-01 00:46:10.000000', 'consum', 0.0211, 'lps'),
	(424710, 123, '2015-03-01 00:46:11.000000', 'consum', 0.0221, 'lps'),
	(424711, 123, '2015-03-01 00:46:12.000000', 'consum', 0.0210, 'lps'),
	(424712, 123, '2015-03-01 00:46:13.000000', 'consum', 0.0216, 'lps'),
	(424713, 123, '2015-03-01 00:46:14.000000', 'consum', 0.0217, 'lps'),
	(424714, 123, '2015-03-01 00:46:15.000000', 'consum', 0.0211, 'lps'),
	(424715, 123, '2015-03-01 00:46:16.000000', 'consum', 0.0222, 'lps'),
	(424716, 123, '2015-03-01 00:46:17.000000', 'consum', 0.0215, 'lps'),
	(424717, 123, '2015-03-01 00:46:18.000000', 'consum', 0.0213, 'lps'),
	(424718, 123, '2015-03-01 00:46:19.000000', 'consum', 0.0211, 'lps'),
	(424719, 123, '2015-03-01 00:46:20.000000', 'consum', 0.0218, 'lps'),
	(424720, 123, '2015-03-01 00:46:21.000000', 'consum', 0.0222, 'lps'),
	(424721, 123, '2015-03-01 00:46:22.000000', 'consum', 0.0222, 'lps'),
	(424722, 123, '2015-03-01 00:46:23.000000', 'consum', 0.0220, 'lps'),
	(424723, 123, '2015-03-01 00:46:24.000000', 'consum', 0.0210, 'lps'),
	(424724, 123, '2015-03-01 00:46:25.000000', 'consum', 0.0222, 'lps'),
	(424725, 123, '2015-03-01 00:46:26.000000', 'consum', 0.0218, 'lps'),
	(424726, 123, '2015-03-01 00:46:27.000000', 'consum', 0.0216, 'lps'),
	(424727, 123, '2015-03-01 00:46:28.000000', 'consum', 0.0215, 'lps'),
	(424728, 123, '2015-03-01 00:46:29.000000', 'consum', 0.0216, 'lps'),
	(424729, 123, '2015-03-01 00:46:30.000000', 'consum', 0.0215, 'lps'),
	(424730, 123, '2015-03-01 00:46:31.000000', 'consum', 0.0215, 'lps'),
	(424731, 123, '2015-03-01 00:46:32.000000', 'consum', 0.0210, 'lps'),
	(424732, 123, '2015-03-01 00:46:33.000000', 'consum', 0.0222, 'lps'),
	(424733, 123, '2015-03-01 00:46:34.000000', 'consum', 0.0217, 'lps'),
	(424734, 123, '2015-03-01 00:46:35.000000', 'consum', 0.0210, 'lps'),
	(424735, 123, '2015-03-01 00:46:36.000000', 'consum', 0.0217, 'lps'),
	(424736, 123, '2015-03-01 00:46:37.000000', 'consum', 0.0219, 'lps'),
	(424737, 123, '2015-03-01 00:46:38.000000', 'consum', 0.0219, 'lps'),
	(424738, 123, '2015-03-01 00:46:39.000000', 'consum', 0.0218, 'lps'),
	(424739, 123, '2015-03-01 00:46:40.000000', 'consum', 0.0221, 'lps'),
	(424740, 123, '2015-03-01 00:46:41.000000', 'consum', 0.0215, 'lps'),
	(424741, 123, '2015-03-01 00:46:42.000000', 'consum', 0.0218, 'lps'),
	(424742, 123, '2015-03-01 00:46:43.000000', 'consum', 0.0221, 'lps'),
	(424743, 123, '2015-03-01 00:46:44.000000', 'consum', 0.0214, 'lps'),
	(424744, 123, '2015-03-01 00:46:45.000000', 'consum', 0.0212, 'lps'),
	(424745, 123, '2015-03-01 00:46:46.000000', 'consum', 0.0222, 'lps'),
	(424746, 123, '2015-03-01 00:46:47.000000', 'consum', 0.0213, 'lps'),
	(424747, 123, '2015-03-01 00:46:48.000000', 'consum', 0.0217, 'lps'),
	(424748, 123, '2015-03-01 00:46:49.000000', 'consum', 0.0220, 'lps'),
	(424749, 123, '2015-03-01 00:46:50.000000', 'consum', 0.0216, 'lps'),
	(424750, 123, '2015-03-01 00:46:51.000000', 'consum', 0.0221, 'lps'),
	(424751, 123, '2015-03-01 00:46:52.000000', 'consum', 0.0222, 'lps'),
	(424752, 123, '2015-03-01 00:46:53.000000', 'consum', 0.0211, 'lps'),
	(424753, 123, '2015-03-01 00:46:54.000000', 'consum', 0.0219, 'lps'),
	(424754, 123, '2015-03-01 00:46:55.000000', 'consum', 0.0215, 'lps'),
	(424755, 123, '2015-03-01 00:46:56.000000', 'consum', 0.0220, 'lps'),
	(424756, 123, '2015-03-01 00:46:57.000000', 'consum', 0.0218, 'lps'),
	(424757, 123, '2015-03-01 00:46:58.000000', 'consum', 0.0221, 'lps'),
	(424758, 123, '2015-03-01 00:46:59.000000', 'consum', 0.0217, 'lps'),
	(424759, 123, '2015-03-01 00:47:00.000000', 'consum', 0.0214, 'lps'),
	(424760, 123, '2015-03-01 00:47:01.000000', 'consum', 0.0219, 'lps'),
	(424761, 123, '2015-03-01 00:47:02.000000', 'consum', 0.0219, 'lps'),
	(424762, 123, '2015-03-01 00:47:03.000000', 'consum', 0.0215, 'lps'),
	(424763, 123, '2015-03-01 00:47:04.000000', 'consum', 0.0210, 'lps'),
	(424764, 123, '2015-03-01 00:47:05.000000', 'consum', 0.0222, 'lps'),
	(424765, 123, '2015-03-01 00:47:06.000000', 'consum', 0.0218, 'lps'),
	(424766, 123, '2015-03-01 00:47:07.000000', 'consum', 0.0213, 'lps'),
	(424767, 123, '2015-03-01 00:47:08.000000', 'consum', 0.0215, 'lps'),
	(424768, 123, '2015-03-01 00:47:09.000000', 'consum', 0.0216, 'lps'),
	(424769, 123, '2015-03-01 00:47:10.000000', 'consum', 0.0210, 'lps'),
	(424770, 123, '2015-03-01 00:47:11.000000', 'consum', 0.0218, 'lps'),
	(424771, 123, '2015-03-01 00:47:12.000000', 'consum', 0.0214, 'lps'),
	(424772, 123, '2015-03-01 00:47:13.000000', 'consum', 0.0220, 'lps'),
	(424773, 123, '2015-03-01 00:47:14.000000', 'consum', 0.0222, 'lps'),
	(424774, 123, '2015-03-01 00:47:15.000000', 'consum', 0.0215, 'lps'),
	(424775, 123, '2015-03-01 00:47:16.000000', 'consum', 0.0211, 'lps'),
	(424776, 123, '2015-03-01 00:47:17.000000', 'consum', 0.0213, 'lps'),
	(424777, 123, '2015-03-01 00:47:18.000000', 'consum', 0.0212, 'lps'),
	(424778, 123, '2015-03-01 00:47:19.000000', 'consum', 0.0211, 'lps'),
	(424779, 123, '2015-03-01 00:47:20.000000', 'consum', 0.0221, 'lps'),
	(424780, 123, '2015-03-01 00:47:21.000000', 'consum', 0.0212, 'lps'),
	(424781, 123, '2015-03-01 00:47:22.000000', 'consum', 0.0212, 'lps'),
	(424782, 123, '2015-03-01 00:47:23.000000', 'consum', 0.0216, 'lps'),
	(424783, 123, '2015-03-01 00:47:24.000000', 'consum', 0.0221, 'lps'),
	(424784, 123, '2015-03-01 00:47:25.000000', 'consum', 0.0221, 'lps'),
	(424785, 123, '2015-03-01 00:47:26.000000', 'consum', 0.0218, 'lps'),
	(424786, 123, '2015-03-01 00:47:27.000000', 'consum', 0.0219, 'lps'),
	(424787, 123, '2015-03-01 00:47:28.000000', 'consum', 0.0217, 'lps'),
	(424788, 123, '2015-03-01 00:47:29.000000', 'consum', 0.0218, 'lps'),
	(424789, 123, '2015-03-01 00:47:30.000000', 'consum', 0.0216, 'lps'),
	(424790, 123, '2015-03-01 00:47:31.000000', 'consum', 0.0219, 'lps'),
	(424791, 123, '2015-03-01 00:47:32.000000', 'consum', 0.0212, 'lps'),
	(424792, 123, '2015-03-01 00:47:33.000000', 'consum', 0.0217, 'lps'),
	(424793, 123, '2015-03-01 00:47:34.000000', 'consum', 0.0216, 'lps'),
	(424794, 123, '2015-03-01 00:47:35.000000', 'consum', 0.0217, 'lps'),
	(424795, 123, '2015-03-01 00:47:36.000000', 'consum', 0.0216, 'lps'),
	(424796, 123, '2015-03-01 00:47:37.000000', 'consum', 0.0218, 'lps'),
	(424797, 123, '2015-03-01 00:47:38.000000', 'consum', 0.0219, 'lps'),
	(424798, 123, '2015-03-01 00:47:39.000000', 'consum', 0.0220, 'lps'),
	(424799, 123, '2015-03-01 00:47:40.000000', 'consum', 0.0219, 'lps'),
	(424800, 123, '2015-03-01 00:47:41.000000', 'consum', 0.0211, 'lps'),
	(424801, 123, '2015-03-01 00:47:42.000000', 'consum', 0.0218, 'lps'),
	(424802, 123, '2015-03-01 00:47:43.000000', 'consum', 0.0220, 'lps'),
	(424803, 123, '2015-03-01 00:47:44.000000', 'consum', 0.0213, 'lps'),
	(424804, 123, '2015-03-01 00:47:45.000000', 'consum', 0.0218, 'lps'),
	(424805, 123, '2015-03-01 00:47:46.000000', 'consum', 0.0218, 'lps'),
	(424806, 123, '2015-03-01 00:47:47.000000', 'consum', 0.0214, 'lps'),
	(424807, 123, '2015-03-01 00:47:48.000000', 'consum', 0.0217, 'lps'),
	(424808, 123, '2015-03-01 00:47:49.000000', 'consum', 0.0222, 'lps'),
	(424809, 123, '2015-03-01 00:47:50.000000', 'consum', 0.0210, 'lps'),
	(424810, 123, '2015-03-01 00:47:51.000000', 'consum', 0.0213, 'lps'),
	(424811, 123, '2015-03-01 00:47:52.000000', 'consum', 0.0215, 'lps'),
	(424812, 123, '2015-03-01 00:47:53.000000', 'consum', 0.0212, 'lps'),
	(424813, 123, '2015-03-01 00:47:54.000000', 'consum', 0.0220, 'lps'),
	(424814, 123, '2015-03-01 00:47:55.000000', 'consum', 0.0214, 'lps'),
	(424815, 123, '2015-03-01 00:47:56.000000', 'consum', 0.0214, 'lps'),
	(424816, 123, '2015-03-01 00:47:57.000000', 'consum', 0.0218, 'lps'),
	(424817, 123, '2015-03-01 00:47:58.000000', 'consum', 0.0214, 'lps'),
	(424818, 123, '2015-03-01 00:47:59.000000', 'consum', 0.0219, 'lps'),
	(424819, 123, '2015-03-01 00:48:00.000000', 'consum', 0.0218, 'lps'),
	(424820, 123, '2015-03-01 00:48:01.000000', 'consum', 0.0222, 'lps'),
	(424821, 123, '2015-03-01 00:48:02.000000', 'consum', 0.0220, 'lps'),
	(424822, 123, '2015-03-01 00:48:03.000000', 'consum', 0.0211, 'lps'),
	(424823, 123, '2015-03-01 00:48:04.000000', 'consum', 0.0212, 'lps'),
	(424824, 123, '2015-03-01 00:48:05.000000', 'consum', 0.0220, 'lps'),
	(424825, 123, '2015-03-01 00:48:06.000000', 'consum', 0.0213, 'lps'),
	(424826, 123, '2015-03-01 00:48:07.000000', 'consum', 0.0222, 'lps'),
	(424827, 123, '2015-03-01 00:48:08.000000', 'consum', 0.0222, 'lps'),
	(424828, 123, '2015-03-01 00:48:09.000000', 'consum', 0.0210, 'lps'),
	(424829, 123, '2015-03-01 00:48:10.000000', 'consum', 0.0214, 'lps'),
	(424830, 123, '2015-03-01 00:48:11.000000', 'consum', 0.0215, 'lps'),
	(424831, 123, '2015-03-01 00:48:12.000000', 'consum', 0.0211, 'lps'),
	(424832, 123, '2015-03-01 00:48:13.000000', 'consum', 0.0215, 'lps'),
	(424833, 123, '2015-03-01 00:48:14.000000', 'consum', 0.0219, 'lps'),
	(424834, 123, '2015-03-01 00:48:15.000000', 'consum', 0.0216, 'lps'),
	(424835, 123, '2015-03-01 00:48:16.000000', 'consum', 0.0214, 'lps'),
	(424836, 123, '2015-03-01 00:48:17.000000', 'consum', 0.0212, 'lps'),
	(424837, 123, '2015-03-01 00:48:18.000000', 'consum', 0.0221, 'lps'),
	(424838, 123, '2015-03-01 00:48:19.000000', 'consum', 0.0220, 'lps'),
	(424839, 123, '2015-03-01 00:48:20.000000', 'consum', 0.0215, 'lps'),
	(424840, 123, '2015-03-01 00:48:21.000000', 'consum', 0.0216, 'lps'),
	(424841, 123, '2015-03-01 00:48:22.000000', 'consum', 0.0215, 'lps'),
	(424842, 123, '2015-03-01 00:48:23.000000', 'consum', 0.0218, 'lps'),
	(424843, 123, '2015-03-01 00:48:24.000000', 'consum', 0.0210, 'lps'),
	(424844, 123, '2015-03-01 00:48:25.000000', 'consum', 0.0212, 'lps'),
	(424845, 123, '2015-03-01 00:48:26.000000', 'consum', 0.0221, 'lps'),
	(424846, 123, '2015-03-01 00:48:27.000000', 'consum', 0.0222, 'lps'),
	(424847, 123, '2015-03-01 00:48:28.000000', 'consum', 0.0210, 'lps'),
	(424848, 123, '2015-03-01 00:48:29.000000', 'consum', 0.0213, 'lps'),
	(424849, 123, '2015-03-01 00:48:30.000000', 'consum', 0.0213, 'lps'),
	(424850, 123, '2015-03-01 00:48:31.000000', 'consum', 0.0214, 'lps'),
	(424851, 123, '2015-03-01 00:48:32.000000', 'consum', 0.0212, 'lps'),
	(424852, 123, '2015-03-01 00:48:33.000000', 'consum', 0.0220, 'lps'),
	(424853, 123, '2015-03-01 00:48:34.000000', 'consum', 0.0217, 'lps'),
	(424854, 123, '2015-03-01 00:48:35.000000', 'consum', 0.0215, 'lps'),
	(424855, 123, '2015-03-01 00:48:36.000000', 'consum', 0.0213, 'lps'),
	(424856, 123, '2015-03-01 00:48:37.000000', 'consum', 0.0211, 'lps'),
	(424857, 123, '2015-03-01 00:48:38.000000', 'consum', 0.0220, 'lps'),
	(424858, 123, '2015-03-01 00:48:39.000000', 'consum', 0.0218, 'lps'),
	(424859, 123, '2015-03-01 00:48:40.000000', 'consum', 0.0222, 'lps'),
	(424860, 123, '2015-03-01 00:48:41.000000', 'consum', 0.0218, 'lps'),
	(424861, 123, '2015-03-01 00:48:42.000000', 'consum', 0.0214, 'lps'),
	(424862, 123, '2015-03-01 00:48:43.000000', 'consum', 0.0219, 'lps'),
	(424863, 123, '2015-03-01 00:48:44.000000', 'consum', 0.0218, 'lps'),
	(424864, 123, '2015-03-01 00:48:45.000000', 'consum', 0.0212, 'lps'),
	(424865, 123, '2015-03-01 00:48:46.000000', 'consum', 0.0210, 'lps'),
	(424866, 123, '2015-03-01 00:48:47.000000', 'consum', 0.0216, 'lps'),
	(424867, 123, '2015-03-01 00:48:48.000000', 'consum', 0.0217, 'lps'),
	(424868, 123, '2015-03-01 00:48:49.000000', 'consum', 0.0212, 'lps'),
	(424869, 123, '2015-03-01 00:48:50.000000', 'consum', 0.0214, 'lps'),
	(424870, 123, '2015-03-01 00:48:51.000000', 'consum', 0.0212, 'lps'),
	(424871, 123, '2015-03-01 00:48:52.000000', 'consum', 0.0219, 'lps'),
	(424872, 123, '2015-03-01 00:48:53.000000', 'consum', 0.0213, 'lps'),
	(424873, 123, '2015-03-01 00:48:54.000000', 'consum', 0.0210, 'lps'),
	(424874, 123, '2015-03-01 00:48:55.000000', 'consum', 0.0216, 'lps'),
	(424875, 123, '2015-03-01 00:48:56.000000', 'consum', 0.0215, 'lps'),
	(424876, 123, '2015-03-01 00:48:57.000000', 'consum', 0.0216, 'lps'),
	(424877, 123, '2015-03-01 00:48:58.000000', 'consum', 0.0215, 'lps'),
	(424878, 123, '2015-03-01 00:48:59.000000', 'consum', 0.0214, 'lps'),
	(424879, 123, '2015-03-01 00:49:00.000000', 'consum', 0.0218, 'lps'),
	(424880, 123, '2015-03-01 00:49:01.000000', 'consum', 0.0212, 'lps'),
	(424881, 123, '2015-03-01 00:49:02.000000', 'consum', 0.0210, 'lps'),
	(424882, 123, '2015-03-01 00:49:03.000000', 'consum', 0.0218, 'lps'),
	(424883, 123, '2015-03-01 00:49:04.000000', 'consum', 0.0211, 'lps'),
	(424884, 123, '2015-03-01 00:49:05.000000', 'consum', 0.0215, 'lps'),
	(424885, 123, '2015-03-01 00:49:06.000000', 'consum', 0.0210, 'lps'),
	(424886, 123, '2015-03-01 00:49:07.000000', 'consum', 0.0221, 'lps'),
	(424887, 123, '2015-03-01 00:49:08.000000', 'consum', 0.0213, 'lps'),
	(424888, 123, '2015-03-01 00:49:09.000000', 'consum', 0.0217, 'lps'),
	(424889, 123, '2015-03-01 00:49:10.000000', 'consum', 0.0211, 'lps'),
	(424890, 123, '2015-03-01 00:49:11.000000', 'consum', 0.0222, 'lps'),
	(424891, 123, '2015-03-01 00:49:12.000000', 'consum', 0.0214, 'lps'),
	(424892, 123, '2015-03-01 00:49:13.000000', 'consum', 0.0220, 'lps'),
	(424893, 123, '2015-03-01 00:49:14.000000', 'consum', 0.0211, 'lps'),
	(424894, 123, '2015-03-01 00:49:15.000000', 'consum', 0.0211, 'lps'),
	(424895, 123, '2015-03-01 00:49:16.000000', 'consum', 0.0214, 'lps'),
	(424896, 123, '2015-03-01 00:49:17.000000', 'consum', 0.0212, 'lps'),
	(424897, 123, '2015-03-01 00:49:18.000000', 'consum', 0.0222, 'lps'),
	(424898, 123, '2015-03-01 00:49:19.000000', 'consum', 0.0212, 'lps'),
	(424899, 123, '2015-03-01 00:49:20.000000', 'consum', 0.0211, 'lps'),
	(424900, 123, '2015-03-01 00:49:21.000000', 'consum', 0.0222, 'lps'),
	(424901, 123, '2015-03-01 00:49:22.000000', 'consum', 0.0217, 'lps'),
	(424902, 123, '2015-03-01 00:49:23.000000', 'consum', 0.0221, 'lps'),
	(424903, 123, '2015-03-01 00:49:24.000000', 'consum', 0.0220, 'lps'),
	(424904, 123, '2015-03-01 00:49:25.000000', 'consum', 0.0216, 'lps'),
	(424905, 123, '2015-03-01 00:49:26.000000', 'consum', 0.0221, 'lps'),
	(424906, 123, '2015-03-01 00:49:27.000000', 'consum', 0.0211, 'lps'),
	(424907, 123, '2015-03-01 00:49:28.000000', 'consum', 0.0221, 'lps'),
	(424908, 123, '2015-03-01 00:49:29.000000', 'consum', 0.0210, 'lps'),
	(424909, 123, '2015-03-01 00:49:30.000000', 'consum', 0.0216, 'lps'),
	(424910, 123, '2015-03-01 00:49:31.000000', 'consum', 0.0215, 'lps'),
	(424911, 123, '2015-03-01 00:49:32.000000', 'consum', 0.0217, 'lps'),
	(424912, 123, '2015-03-01 00:49:33.000000', 'consum', 0.0219, 'lps'),
	(424913, 123, '2015-03-01 00:49:34.000000', 'consum', 0.0210, 'lps'),
	(424914, 123, '2015-03-01 00:49:35.000000', 'consum', 0.0219, 'lps'),
	(424915, 123, '2015-03-01 00:49:36.000000', 'consum', 0.0218, 'lps'),
	(424916, 123, '2015-03-01 00:49:37.000000', 'consum', 0.0212, 'lps'),
	(424917, 123, '2015-03-01 00:49:38.000000', 'consum', 0.0221, 'lps'),
	(424918, 123, '2015-03-01 00:49:39.000000', 'consum', 0.0221, 'lps'),
	(424919, 123, '2015-03-01 00:49:40.000000', 'consum', 0.0217, 'lps'),
	(424920, 123, '2015-03-01 00:49:41.000000', 'consum', 0.0215, 'lps'),
	(424921, 123, '2015-03-01 00:49:42.000000', 'consum', 0.0215, 'lps'),
	(424922, 123, '2015-03-01 00:49:43.000000', 'consum', 0.0218, 'lps'),
	(424923, 123, '2015-03-01 00:49:44.000000', 'consum', 0.0211, 'lps'),
	(424924, 123, '2015-03-01 00:49:45.000000', 'consum', 0.0219, 'lps'),
	(424925, 123, '2015-03-01 00:49:46.000000', 'consum', 0.0212, 'lps'),
	(424926, 123, '2015-03-01 00:49:47.000000', 'consum', 0.0221, 'lps'),
	(424927, 123, '2015-03-01 00:49:48.000000', 'consum', 0.0221, 'lps'),
	(424928, 123, '2015-03-01 00:49:49.000000', 'consum', 0.0218, 'lps'),
	(424929, 123, '2015-03-01 00:49:50.000000', 'consum', 0.0217, 'lps'),
	(424930, 123, '2015-03-01 00:49:51.000000', 'consum', 0.0221, 'lps'),
	(424931, 123, '2015-03-01 00:49:52.000000', 'consum', 0.0220, 'lps'),
	(424932, 123, '2015-03-01 00:49:53.000000', 'consum', 0.0215, 'lps'),
	(424933, 123, '2015-03-01 00:49:54.000000', 'consum', 0.0219, 'lps'),
	(424934, 123, '2015-03-01 00:49:55.000000', 'consum', 0.0215, 'lps'),
	(424935, 123, '2015-03-01 00:49:56.000000', 'consum', 0.0222, 'lps'),
	(424936, 123, '2015-03-01 00:49:57.000000', 'consum', 0.0216, 'lps'),
	(424937, 123, '2015-03-01 00:49:58.000000', 'consum', 0.0217, 'lps'),
	(424938, 123, '2015-03-01 00:49:59.000000', 'consum', 0.0214, 'lps'),
	(424939, 123, '2015-03-01 00:50:00.000000', 'consum', 0.0221, 'lps'),
	(424940, 123, '2015-03-01 00:50:01.000000', 'consum', 0.0217, 'lps'),
	(424941, 123, '2015-03-01 00:50:02.000000', 'consum', 0.0212, 'lps'),
	(424942, 123, '2015-03-01 00:50:03.000000', 'consum', 0.0211, 'lps'),
	(424943, 123, '2015-03-01 00:50:04.000000', 'consum', 0.0222, 'lps'),
	(424944, 123, '2015-03-01 00:50:05.000000', 'consum', 0.0218, 'lps'),
	(424945, 123, '2015-03-01 00:50:06.000000', 'consum', 0.0212, 'lps'),
	(424946, 123, '2015-03-01 00:50:07.000000', 'consum', 0.0210, 'lps'),
	(424947, 123, '2015-03-01 00:50:08.000000', 'consum', 0.0219, 'lps'),
	(424948, 123, '2015-03-01 00:50:09.000000', 'consum', 0.0217, 'lps'),
	(424949, 123, '2015-03-01 00:50:10.000000', 'consum', 0.0219, 'lps'),
	(424950, 123, '2015-03-01 00:50:11.000000', 'consum', 0.0219, 'lps'),
	(424951, 123, '2015-03-01 00:50:12.000000', 'consum', 0.0214, 'lps'),
	(424952, 123, '2015-03-01 00:50:13.000000', 'consum', 0.0220, 'lps'),
	(424953, 123, '2015-03-01 00:50:14.000000', 'consum', 0.0222, 'lps'),
	(424954, 123, '2015-03-01 00:50:15.000000', 'consum', 0.0215, 'lps'),
	(424955, 123, '2015-03-01 00:50:16.000000', 'consum', 0.0212, 'lps'),
	(424956, 123, '2015-03-01 00:50:17.000000', 'consum', 0.0220, 'lps'),
	(424957, 123, '2015-03-01 00:50:18.000000', 'consum', 0.0213, 'lps'),
	(424958, 123, '2015-03-01 00:50:19.000000', 'consum', 0.0211, 'lps'),
	(424959, 123, '2015-03-01 00:50:20.000000', 'consum', 0.0220, 'lps'),
	(424960, 123, '2015-03-01 00:50:21.000000', 'consum', 0.0218, 'lps'),
	(424961, 123, '2015-03-01 00:50:22.000000', 'consum', 0.0218, 'lps'),
	(424962, 123, '2015-03-01 00:50:23.000000', 'consum', 0.0217, 'lps'),
	(424963, 123, '2015-03-01 00:50:24.000000', 'consum', 0.0220, 'lps'),
	(424964, 123, '2015-03-01 00:50:25.000000', 'consum', 0.0213, 'lps'),
	(424965, 123, '2015-03-01 00:50:26.000000', 'consum', 0.0210, 'lps'),
	(424966, 123, '2015-03-01 00:50:27.000000', 'consum', 0.0212, 'lps'),
	(424967, 123, '2015-03-01 00:50:28.000000', 'consum', 0.0210, 'lps'),
	(424968, 123, '2015-03-01 00:50:29.000000', 'consum', 0.0217, 'lps'),
	(424969, 123, '2015-03-01 00:50:30.000000', 'consum', 0.0218, 'lps'),
	(424970, 123, '2015-03-01 00:50:31.000000', 'consum', 0.0217, 'lps'),
	(424971, 123, '2015-03-01 00:50:32.000000', 'consum', 0.0220, 'lps'),
	(424972, 123, '2015-03-01 00:50:33.000000', 'consum', 0.0214, 'lps'),
	(424973, 123, '2015-03-01 00:50:34.000000', 'consum', 0.0215, 'lps'),
	(424974, 123, '2015-03-01 00:50:35.000000', 'consum', 0.0221, 'lps'),
	(424975, 123, '2015-03-01 00:50:36.000000', 'consum', 0.0212, 'lps'),
	(424976, 123, '2015-03-01 00:50:37.000000', 'consum', 0.0215, 'lps'),
	(424977, 123, '2015-03-01 00:50:38.000000', 'consum', 0.0217, 'lps'),
	(424978, 123, '2015-03-01 00:50:39.000000', 'consum', 0.0218, 'lps'),
	(424979, 123, '2015-03-01 00:50:40.000000', 'consum', 0.0214, 'lps'),
	(424980, 123, '2015-03-01 00:50:41.000000', 'consum', 0.0222, 'lps'),
	(424981, 123, '2015-03-01 00:50:42.000000', 'consum', 0.0217, 'lps'),
	(424982, 123, '2015-03-01 00:50:43.000000', 'consum', 0.0222, 'lps'),
	(424983, 123, '2015-03-01 00:50:44.000000', 'consum', 0.0213, 'lps'),
	(424984, 123, '2015-03-01 00:50:45.000000', 'consum', 0.0217, 'lps'),
	(424985, 123, '2015-03-01 00:50:46.000000', 'consum', 0.0220, 'lps'),
	(424986, 123, '2015-03-01 00:50:47.000000', 'consum', 0.0214, 'lps'),
	(424987, 123, '2015-03-01 00:50:48.000000', 'consum', 0.0212, 'lps'),
	(424988, 123, '2015-03-01 00:50:49.000000', 'consum', 0.0210, 'lps'),
	(424989, 123, '2015-03-01 00:50:50.000000', 'consum', 0.0217, 'lps'),
	(424990, 123, '2015-03-01 00:50:51.000000', 'consum', 0.0218, 'lps'),
	(424991, 123, '2015-03-01 00:50:52.000000', 'consum', 0.0219, 'lps'),
	(424992, 123, '2015-03-01 00:50:53.000000', 'consum', 0.0218, 'lps'),
	(424993, 123, '2015-03-01 00:50:54.000000', 'consum', 0.0211, 'lps'),
	(424994, 123, '2015-03-01 00:50:55.000000', 'consum', 0.0216, 'lps'),
	(424995, 123, '2015-03-01 00:50:56.000000', 'consum', 0.0210, 'lps'),
	(424996, 123, '2015-03-01 00:50:57.000000', 'consum', 0.0221, 'lps'),
	(424997, 123, '2015-03-01 00:50:58.000000', 'consum', 0.0215, 'lps'),
	(424998, 123, '2015-03-01 00:50:59.000000', 'consum', 0.0213, 'lps'),
	(424999, 123, '2015-03-01 00:51:00.000000', 'consum', 0.0213, 'lps'),
	(425000, 123, '2015-03-01 00:51:01.000000', 'consum', 0.0215, 'lps'),
	(425001, 123, '2015-03-01 00:51:02.000000', 'consum', 0.0213, 'lps'),
	(425002, 123, '2015-03-01 00:51:03.000000', 'consum', 0.0213, 'lps'),
	(425003, 123, '2015-03-01 00:51:04.000000', 'consum', 0.0213, 'lps'),
	(425004, 123, '2015-03-01 00:51:05.000000', 'consum', 0.0220, 'lps'),
	(425005, 123, '2015-03-01 00:51:06.000000', 'consum', 0.0211, 'lps'),
	(425006, 123, '2015-03-01 00:51:07.000000', 'consum', 0.0210, 'lps'),
	(425007, 123, '2015-03-01 00:51:08.000000', 'consum', 0.0210, 'lps'),
	(425008, 123, '2015-03-01 00:51:09.000000', 'consum', 0.0221, 'lps'),
	(425009, 123, '2015-03-01 00:51:10.000000', 'consum', 0.0215, 'lps'),
	(425010, 123, '2015-03-01 00:51:11.000000', 'consum', 0.0217, 'lps'),
	(425011, 123, '2015-03-01 00:51:12.000000', 'consum', 0.0216, 'lps'),
	(425012, 123, '2015-03-01 00:51:13.000000', 'consum', 0.0222, 'lps'),
	(425013, 123, '2015-03-01 00:51:14.000000', 'consum', 0.0211, 'lps'),
	(425014, 123, '2015-03-01 00:51:15.000000', 'consum', 0.0218, 'lps'),
	(425015, 123, '2015-03-01 00:51:16.000000', 'consum', 0.0210, 'lps'),
	(425016, 123, '2015-03-01 00:51:17.000000', 'consum', 0.0214, 'lps'),
	(425017, 123, '2015-03-01 00:51:18.000000', 'consum', 0.0216, 'lps'),
	(425018, 123, '2015-03-01 00:51:19.000000', 'consum', 0.0217, 'lps'),
	(425019, 123, '2015-03-01 00:51:20.000000', 'consum', 0.0212, 'lps'),
	(425020, 123, '2015-03-01 00:51:21.000000', 'consum', 0.0214, 'lps'),
	(425021, 123, '2015-03-01 00:51:22.000000', 'consum', 0.0211, 'lps'),
	(425022, 123, '2015-03-01 00:51:23.000000', 'consum', 0.0216, 'lps'),
	(425023, 123, '2015-03-01 00:51:24.000000', 'consum', 0.0211, 'lps'),
	(425024, 123, '2015-03-01 00:51:25.000000', 'consum', 0.0213, 'lps'),
	(425025, 123, '2015-03-01 00:51:26.000000', 'consum', 0.0221, 'lps'),
	(425026, 123, '2015-03-01 00:51:27.000000', 'consum', 0.0220, 'lps'),
	(425027, 123, '2015-03-01 00:51:28.000000', 'consum', 0.0212, 'lps'),
	(425028, 123, '2015-03-01 00:51:29.000000', 'consum', 0.0216, 'lps'),
	(425029, 123, '2015-03-01 00:51:30.000000', 'consum', 0.0222, 'lps'),
	(425030, 123, '2015-03-01 00:51:31.000000', 'consum', 0.0212, 'lps'),
	(425031, 123, '2015-03-01 00:51:32.000000', 'consum', 0.0213, 'lps'),
	(425032, 123, '2015-03-01 00:51:33.000000', 'consum', 0.0218, 'lps'),
	(425033, 123, '2015-03-01 00:51:34.000000', 'consum', 0.0214, 'lps'),
	(425034, 123, '2015-03-01 00:51:35.000000', 'consum', 0.0221, 'lps'),
	(425035, 123, '2015-03-01 00:51:36.000000', 'consum', 0.0216, 'lps'),
	(425036, 123, '2015-03-01 00:51:37.000000', 'consum', 0.0218, 'lps'),
	(425037, 123, '2015-03-01 00:51:38.000000', 'consum', 0.0221, 'lps'),
	(425038, 123, '2015-03-01 00:51:39.000000', 'consum', 0.0217, 'lps'),
	(425039, 123, '2015-03-01 00:51:40.000000', 'consum', 0.0211, 'lps'),
	(425040, 123, '2015-03-01 00:51:41.000000', 'consum', 0.0221, 'lps'),
	(425041, 123, '2015-03-01 00:51:42.000000', 'consum', 0.0212, 'lps'),
	(425042, 123, '2015-03-01 00:51:43.000000', 'consum', 0.0211, 'lps'),
	(425043, 123, '2015-03-01 00:51:44.000000', 'consum', 0.0212, 'lps'),
	(425044, 123, '2015-03-01 00:51:45.000000', 'consum', 0.0217, 'lps'),
	(425045, 123, '2015-03-01 00:51:46.000000', 'consum', 0.0214, 'lps'),
	(425046, 123, '2015-03-01 00:51:47.000000', 'consum', 0.0211, 'lps'),
	(425047, 123, '2015-03-01 00:51:48.000000', 'consum', 0.0215, 'lps'),
	(425048, 123, '2015-03-01 00:51:49.000000', 'consum', 0.0218, 'lps'),
	(425049, 123, '2015-03-01 00:51:50.000000', 'consum', 0.0210, 'lps'),
	(425050, 123, '2015-03-01 00:51:51.000000', 'consum', 0.0215, 'lps'),
	(425051, 123, '2015-03-01 00:51:52.000000', 'consum', 0.0220, 'lps'),
	(425052, 123, '2015-03-01 00:51:53.000000', 'consum', 0.0221, 'lps'),
	(425053, 123, '2015-03-01 00:51:54.000000', 'consum', 0.0210, 'lps'),
	(425054, 123, '2015-03-01 00:51:55.000000', 'consum', 0.0215, 'lps'),
	(425055, 123, '2015-03-01 00:51:56.000000', 'consum', 0.0212, 'lps'),
	(425056, 123, '2015-03-01 00:51:57.000000', 'consum', 0.0215, 'lps'),
	(425057, 123, '2015-03-01 00:51:58.000000', 'consum', 0.0220, 'lps'),
	(425058, 123, '2015-03-01 00:51:59.000000', 'consum', 0.0217, 'lps'),
	(425059, 123, '2015-03-01 00:52:00.000000', 'consum', 0.0217, 'lps'),
	(425060, 123, '2015-03-01 00:52:01.000000', 'consum', 0.0212, 'lps'),
	(425061, 123, '2015-03-01 00:52:02.000000', 'consum', 0.0213, 'lps'),
	(425062, 123, '2015-03-01 00:52:03.000000', 'consum', 0.0221, 'lps'),
	(425063, 123, '2015-03-01 00:52:04.000000', 'consum', 0.0215, 'lps'),
	(425064, 123, '2015-03-01 00:52:05.000000', 'consum', 0.0215, 'lps'),
	(425065, 123, '2015-03-01 00:52:06.000000', 'consum', 0.0210, 'lps'),
	(425066, 123, '2015-03-01 00:52:07.000000', 'consum', 0.0221, 'lps'),
	(425067, 123, '2015-03-01 00:52:08.000000', 'consum', 0.0215, 'lps'),
	(425068, 123, '2015-03-01 00:52:09.000000', 'consum', 0.0214, 'lps'),
	(425069, 123, '2015-03-01 00:52:10.000000', 'consum', 0.0213, 'lps'),
	(425070, 123, '2015-03-01 00:52:11.000000', 'consum', 0.0217, 'lps'),
	(425071, 123, '2015-03-01 00:52:12.000000', 'consum', 0.0211, 'lps'),
	(425072, 123, '2015-03-01 00:52:13.000000', 'consum', 0.0218, 'lps'),
	(425073, 123, '2015-03-01 00:52:14.000000', 'consum', 0.0210, 'lps'),
	(425074, 123, '2015-03-01 00:52:15.000000', 'consum', 0.0210, 'lps'),
	(425075, 123, '2015-03-01 00:52:16.000000', 'consum', 0.0213, 'lps'),
	(425076, 123, '2015-03-01 00:52:17.000000', 'consum', 0.0213, 'lps'),
	(425077, 123, '2015-03-01 00:52:18.000000', 'consum', 0.0214, 'lps'),
	(425078, 123, '2015-03-01 00:52:19.000000', 'consum', 0.0221, 'lps'),
	(425079, 123, '2015-03-01 00:52:20.000000', 'consum', 0.0215, 'lps'),
	(425080, 123, '2015-03-01 00:52:21.000000', 'consum', 0.0217, 'lps'),
	(425081, 123, '2015-03-01 00:52:22.000000', 'consum', 0.0218, 'lps'),
	(425082, 123, '2015-03-01 00:52:23.000000', 'consum', 0.0218, 'lps'),
	(425083, 123, '2015-03-01 00:52:24.000000', 'consum', 0.0211, 'lps'),
	(425084, 123, '2015-03-01 00:52:25.000000', 'consum', 0.0217, 'lps'),
	(425085, 123, '2015-03-01 00:52:26.000000', 'consum', 0.0217, 'lps'),
	(425086, 123, '2015-03-01 00:52:27.000000', 'consum', 0.0211, 'lps'),
	(425087, 123, '2015-03-01 00:52:28.000000', 'consum', 0.0222, 'lps'),
	(425088, 123, '2015-03-01 00:52:29.000000', 'consum', 0.0213, 'lps'),
	(425089, 123, '2015-03-01 00:52:30.000000', 'consum', 0.0217, 'lps'),
	(425090, 123, '2015-03-01 00:52:31.000000', 'consum', 0.0210, 'lps'),
	(425091, 123, '2015-03-01 00:52:32.000000', 'consum', 0.0218, 'lps'),
	(425092, 123, '2015-03-01 00:52:33.000000', 'consum', 0.0221, 'lps'),
	(425093, 123, '2015-03-01 00:52:34.000000', 'consum', 0.0216, 'lps'),
	(425094, 123, '2015-03-01 00:52:35.000000', 'consum', 0.0222, 'lps'),
	(425095, 123, '2015-03-01 00:52:36.000000', 'consum', 0.0212, 'lps'),
	(425096, 123, '2015-03-01 00:52:37.000000', 'consum', 0.0211, 'lps'),
	(425097, 123, '2015-03-01 00:52:38.000000', 'consum', 0.0221, 'lps'),
	(425098, 123, '2015-03-01 00:52:39.000000', 'consum', 0.0212, 'lps'),
	(425099, 123, '2015-03-01 00:52:40.000000', 'consum', 0.0212, 'lps'),
	(425100, 123, '2015-03-01 00:52:41.000000', 'consum', 0.0217, 'lps'),
	(425101, 123, '2015-03-01 00:52:42.000000', 'consum', 0.0213, 'lps'),
	(425102, 123, '2015-03-01 00:52:43.000000', 'consum', 0.0217, 'lps'),
	(425103, 123, '2015-03-01 00:52:44.000000', 'consum', 0.0210, 'lps'),
	(425104, 123, '2015-03-01 00:52:45.000000', 'consum', 0.0215, 'lps'),
	(425105, 123, '2015-03-01 00:52:46.000000', 'consum', 0.0222, 'lps'),
	(425106, 123, '2015-03-01 00:52:47.000000', 'consum', 0.0217, 'lps'),
	(425107, 123, '2015-03-01 00:52:48.000000', 'consum', 0.0221, 'lps'),
	(425108, 123, '2015-03-01 00:52:49.000000', 'consum', 0.0222, 'lps'),
	(425109, 123, '2015-03-01 00:52:50.000000', 'consum', 0.0221, 'lps'),
	(425110, 123, '2015-03-01 00:52:51.000000', 'consum', 0.0218, 'lps'),
	(425111, 123, '2015-03-01 00:52:52.000000', 'consum', 0.0219, 'lps'),
	(425112, 123, '2015-03-01 00:52:53.000000', 'consum', 0.0217, 'lps'),
	(425113, 123, '2015-03-01 00:52:54.000000', 'consum', 0.0218, 'lps'),
	(425114, 123, '2015-03-01 00:52:55.000000', 'consum', 0.0218, 'lps'),
	(425115, 123, '2015-03-01 00:52:56.000000', 'consum', 0.0213, 'lps'),
	(425116, 123, '2015-03-01 00:52:57.000000', 'consum', 0.0212, 'lps'),
	(425117, 123, '2015-03-01 00:52:58.000000', 'consum', 0.0214, 'lps'),
	(425118, 123, '2015-03-01 00:52:59.000000', 'consum', 0.0212, 'lps'),
	(425119, 123, '2015-03-01 00:53:00.000000', 'consum', 0.0222, 'lps'),
	(425120, 123, '2015-03-01 00:53:01.000000', 'consum', 0.0210, 'lps'),
	(425121, 123, '2015-03-01 00:53:02.000000', 'consum', 0.0213, 'lps'),
	(425122, 123, '2015-03-01 00:53:03.000000', 'consum', 0.0214, 'lps'),
	(425123, 123, '2015-03-01 00:53:04.000000', 'consum', 0.0221, 'lps'),
	(425124, 123, '2015-03-01 00:53:05.000000', 'consum', 0.0213, 'lps'),
	(425125, 123, '2015-03-01 00:53:06.000000', 'consum', 0.0220, 'lps'),
	(425126, 123, '2015-03-01 00:53:07.000000', 'consum', 0.0210, 'lps'),
	(425127, 123, '2015-03-01 00:53:08.000000', 'consum', 0.0210, 'lps'),
	(425128, 123, '2015-03-01 00:53:09.000000', 'consum', 0.0222, 'lps'),
	(425129, 123, '2015-03-01 00:53:10.000000', 'consum', 0.0219, 'lps'),
	(425130, 123, '2015-03-01 00:53:11.000000', 'consum', 0.0218, 'lps'),
	(425131, 123, '2015-03-01 00:53:12.000000', 'consum', 0.0222, 'lps'),
	(425132, 123, '2015-03-01 00:53:13.000000', 'consum', 0.0210, 'lps'),
	(425133, 123, '2015-03-01 00:53:14.000000', 'consum', 0.0214, 'lps'),
	(425134, 123, '2015-03-01 00:53:15.000000', 'consum', 0.0219, 'lps'),
	(425135, 123, '2015-03-01 00:53:16.000000', 'consum', 0.0214, 'lps'),
	(425136, 123, '2015-03-01 00:53:17.000000', 'consum', 0.0220, 'lps'),
	(425137, 123, '2015-03-01 00:53:18.000000', 'consum', 0.0220, 'lps'),
	(425138, 123, '2015-03-01 00:53:19.000000', 'consum', 0.0218, 'lps'),
	(425139, 123, '2015-03-01 00:53:20.000000', 'consum', 0.0221, 'lps'),
	(425140, 123, '2015-03-01 00:53:21.000000', 'consum', 0.0216, 'lps'),
	(425141, 123, '2015-03-01 00:53:22.000000', 'consum', 0.0220, 'lps'),
	(425142, 123, '2015-03-01 00:53:23.000000', 'consum', 0.0216, 'lps'),
	(425143, 123, '2015-03-01 00:53:24.000000', 'consum', 0.0210, 'lps'),
	(425144, 123, '2015-03-01 00:53:25.000000', 'consum', 0.0218, 'lps'),
	(425145, 123, '2015-03-01 00:53:26.000000', 'consum', 0.0210, 'lps'),
	(425146, 123, '2015-03-01 00:53:27.000000', 'consum', 0.0216, 'lps'),
	(425147, 123, '2015-03-01 00:53:28.000000', 'consum', 0.0213, 'lps'),
	(425148, 123, '2015-03-01 00:53:29.000000', 'consum', 0.0221, 'lps'),
	(425149, 123, '2015-03-01 00:53:30.000000', 'consum', 0.0219, 'lps'),
	(425150, 123, '2015-03-01 00:53:31.000000', 'consum', 0.0210, 'lps'),
	(425151, 123, '2015-03-01 00:53:32.000000', 'consum', 0.0220, 'lps'),
	(425152, 123, '2015-03-01 00:53:33.000000', 'consum', 0.0221, 'lps'),
	(425153, 123, '2015-03-01 00:53:34.000000', 'consum', 0.0212, 'lps'),
	(425154, 123, '2015-03-01 00:53:35.000000', 'consum', 0.0212, 'lps'),
	(425155, 123, '2015-03-01 00:53:36.000000', 'consum', 0.0215, 'lps'),
	(425156, 123, '2015-03-01 00:53:37.000000', 'consum', 0.0219, 'lps'),
	(425157, 123, '2015-03-01 00:53:38.000000', 'consum', 0.0211, 'lps'),
	(425158, 123, '2015-03-01 00:53:39.000000', 'consum', 0.0214, 'lps'),
	(425159, 123, '2015-03-01 00:53:40.000000', 'consum', 0.0214, 'lps'),
	(425160, 123, '2015-03-01 00:53:41.000000', 'consum', 0.0219, 'lps'),
	(425161, 123, '2015-03-01 00:53:42.000000', 'consum', 0.0216, 'lps'),
	(425162, 123, '2015-03-01 00:53:43.000000', 'consum', 0.0217, 'lps'),
	(425163, 123, '2015-03-01 00:53:44.000000', 'consum', 0.0212, 'lps'),
	(425164, 123, '2015-03-01 00:53:45.000000', 'consum', 0.0213, 'lps'),
	(425165, 123, '2015-03-01 00:53:46.000000', 'consum', 0.0220, 'lps'),
	(425166, 123, '2015-03-01 00:53:47.000000', 'consum', 0.0213, 'lps'),
	(425167, 123, '2015-03-01 00:53:48.000000', 'consum', 0.0221, 'lps'),
	(425168, 123, '2015-03-01 00:53:49.000000', 'consum', 0.0218, 'lps'),
	(425169, 123, '2015-03-01 00:53:50.000000', 'consum', 0.0215, 'lps'),
	(425170, 123, '2015-03-01 00:53:51.000000', 'consum', 0.0214, 'lps'),
	(425171, 123, '2015-03-01 00:53:52.000000', 'consum', 0.0214, 'lps'),
	(425172, 123, '2015-03-01 00:53:53.000000', 'consum', 0.0221, 'lps'),
	(425173, 123, '2015-03-01 00:53:54.000000', 'consum', 0.0213, 'lps'),
	(425174, 123, '2015-03-01 00:53:55.000000', 'consum', 0.0217, 'lps'),
	(425175, 123, '2015-03-01 00:53:56.000000', 'consum', 0.0212, 'lps'),
	(425176, 123, '2015-03-01 00:53:57.000000', 'consum', 0.0210, 'lps'),
	(425177, 123, '2015-03-01 00:53:58.000000', 'consum', 0.0221, 'lps'),
	(425178, 123, '2015-03-01 00:53:59.000000', 'consum', 0.0213, 'lps'),
	(425179, 123, '2015-03-01 00:54:00.000000', 'consum', 0.0217, 'lps'),
	(425180, 123, '2015-03-01 00:54:01.000000', 'consum', 0.0212, 'lps'),
	(425181, 123, '2015-03-01 00:54:02.000000', 'consum', 0.0211, 'lps'),
	(425182, 123, '2015-03-01 00:54:03.000000', 'consum', 0.0222, 'lps'),
	(425183, 123, '2015-03-01 00:54:04.000000', 'consum', 0.0217, 'lps'),
	(425184, 123, '2015-03-01 00:54:05.000000', 'consum', 0.0210, 'lps'),
	(425185, 123, '2015-03-01 00:54:06.000000', 'consum', 0.0216, 'lps'),
	(425186, 123, '2015-03-01 00:54:07.000000', 'consum', 0.0214, 'lps'),
	(425187, 123, '2015-03-01 00:54:08.000000', 'consum', 0.0213, 'lps'),
	(425188, 123, '2015-03-01 00:54:09.000000', 'consum', 0.0214, 'lps'),
	(425189, 123, '2015-03-01 00:54:10.000000', 'consum', 0.0210, 'lps'),
	(425190, 123, '2015-03-01 00:54:11.000000', 'consum', 0.0222, 'lps'),
	(425191, 123, '2015-03-01 00:54:12.000000', 'consum', 0.0220, 'lps'),
	(425192, 123, '2015-03-01 00:54:13.000000', 'consum', 0.0212, 'lps'),
	(425193, 123, '2015-03-01 00:54:14.000000', 'consum', 0.0215, 'lps'),
	(425194, 123, '2015-03-01 00:54:15.000000', 'consum', 0.0217, 'lps'),
	(425195, 123, '2015-03-01 00:54:16.000000', 'consum', 0.0219, 'lps'),
	(425196, 123, '2015-03-01 00:54:17.000000', 'consum', 0.0221, 'lps'),
	(425197, 123, '2015-03-01 00:54:18.000000', 'consum', 0.0210, 'lps'),
	(425198, 123, '2015-03-01 00:54:19.000000', 'consum', 0.0219, 'lps'),
	(425199, 123, '2015-03-01 00:54:20.000000', 'consum', 0.0216, 'lps'),
	(425200, 123, '2015-03-01 00:54:21.000000', 'consum', 0.0214, 'lps'),
	(425201, 123, '2015-03-01 00:54:22.000000', 'consum', 0.0210, 'lps'),
	(425202, 123, '2015-03-01 00:54:23.000000', 'consum', 0.0214, 'lps'),
	(425203, 123, '2015-03-01 00:54:24.000000', 'consum', 0.0217, 'lps'),
	(425204, 123, '2015-03-01 00:54:25.000000', 'consum', 0.0222, 'lps'),
	(425205, 123, '2015-03-01 00:54:26.000000', 'consum', 0.0211, 'lps'),
	(425206, 123, '2015-03-01 00:54:27.000000', 'consum', 0.0216, 'lps'),
	(425207, 123, '2015-03-01 00:54:28.000000', 'consum', 0.0211, 'lps'),
	(425208, 123, '2015-03-01 00:54:29.000000', 'consum', 0.0214, 'lps'),
	(425209, 123, '2015-03-01 00:54:30.000000', 'consum', 0.0211, 'lps'),
	(425210, 123, '2015-03-01 00:54:31.000000', 'consum', 0.0217, 'lps'),
	(425211, 123, '2015-03-01 00:54:32.000000', 'consum', 0.0215, 'lps'),
	(425212, 123, '2015-03-01 00:54:33.000000', 'consum', 0.0216, 'lps'),
	(425213, 123, '2015-03-01 00:54:34.000000', 'consum', 0.0211, 'lps'),
	(425214, 123, '2015-03-01 00:54:35.000000', 'consum', 0.0213, 'lps'),
	(425215, 123, '2015-03-01 00:54:36.000000', 'consum', 0.0222, 'lps'),
	(425216, 123, '2015-03-01 00:54:37.000000', 'consum', 0.0221, 'lps'),
	(425217, 123, '2015-03-01 00:54:38.000000', 'consum', 0.0217, 'lps'),
	(425218, 123, '2015-03-01 00:54:39.000000', 'consum', 0.0211, 'lps'),
	(425219, 123, '2015-03-01 00:54:40.000000', 'consum', 0.0221, 'lps'),
	(425220, 123, '2015-03-01 00:54:41.000000', 'consum', 0.0212, 'lps'),
	(425221, 123, '2015-03-01 00:54:42.000000', 'consum', 0.0213, 'lps'),
	(425222, 123, '2015-03-01 00:54:43.000000', 'consum', 0.0219, 'lps'),
	(425223, 123, '2015-03-01 00:54:44.000000', 'consum', 0.0219, 'lps'),
	(425224, 123, '2015-03-01 00:54:45.000000', 'consum', 0.0218, 'lps'),
	(425225, 123, '2015-03-01 00:54:46.000000', 'consum', 0.0210, 'lps'),
	(425226, 123, '2015-03-01 00:54:47.000000', 'consum', 0.0210, 'lps'),
	(425227, 123, '2015-03-01 00:54:48.000000', 'consum', 0.0212, 'lps'),
	(425228, 123, '2015-03-01 00:54:49.000000', 'consum', 0.0222, 'lps'),
	(425229, 123, '2015-03-01 00:54:50.000000', 'consum', 0.0212, 'lps'),
	(425230, 123, '2015-03-01 00:54:51.000000', 'consum', 0.0211, 'lps'),
	(425231, 123, '2015-03-01 00:54:52.000000', 'consum', 0.0220, 'lps'),
	(425232, 123, '2015-03-01 00:54:53.000000', 'consum', 0.0222, 'lps'),
	(425233, 123, '2015-03-01 00:54:54.000000', 'consum', 0.0211, 'lps'),
	(425234, 123, '2015-03-01 00:54:55.000000', 'consum', 0.0219, 'lps'),
	(425235, 123, '2015-03-01 00:54:56.000000', 'consum', 0.0216, 'lps'),
	(425236, 123, '2015-03-01 00:54:57.000000', 'consum', 0.0210, 'lps'),
	(425237, 123, '2015-03-01 00:54:58.000000', 'consum', 0.0222, 'lps'),
	(425238, 123, '2015-03-01 00:54:59.000000', 'consum', 0.0216, 'lps'),
	(425239, 123, '2015-03-01 00:55:00.000000', 'consum', 0.0216, 'lps'),
	(425240, 123, '2015-03-01 00:55:01.000000', 'consum', 0.0213, 'lps'),
	(425241, 123, '2015-03-01 00:55:02.000000', 'consum', 0.0218, 'lps'),
	(425242, 123, '2015-03-01 00:55:03.000000', 'consum', 0.0218, 'lps'),
	(425243, 123, '2015-03-01 00:55:04.000000', 'consum', 0.0214, 'lps'),
	(425244, 123, '2015-03-01 00:55:05.000000', 'consum', 0.0217, 'lps'),
	(425245, 123, '2015-03-01 00:55:06.000000', 'consum', 0.0222, 'lps'),
	(425246, 123, '2015-03-01 00:55:07.000000', 'consum', 0.0210, 'lps'),
	(425247, 123, '2015-03-01 00:55:08.000000', 'consum', 0.0214, 'lps'),
	(425248, 123, '2015-03-01 00:55:09.000000', 'consum', 0.0216, 'lps'),
	(425249, 123, '2015-03-01 00:55:10.000000', 'consum', 0.0218, 'lps'),
	(425250, 123, '2015-03-01 00:55:11.000000', 'consum', 0.0220, 'lps'),
	(425251, 123, '2015-03-01 00:55:12.000000', 'consum', 0.0220, 'lps'),
	(425252, 123, '2015-03-01 00:55:13.000000', 'consum', 0.0221, 'lps'),
	(425253, 123, '2015-03-01 00:55:14.000000', 'consum', 0.0222, 'lps'),
	(425254, 123, '2015-03-01 00:55:15.000000', 'consum', 0.0212, 'lps'),
	(425255, 123, '2015-03-01 00:55:16.000000', 'consum', 0.0221, 'lps'),
	(425256, 123, '2015-03-01 00:55:17.000000', 'consum', 0.0222, 'lps'),
	(425257, 123, '2015-03-01 00:55:18.000000', 'consum', 0.0213, 'lps'),
	(425258, 123, '2015-03-01 00:55:19.000000', 'consum', 0.0213, 'lps'),
	(425259, 123, '2015-03-01 00:55:20.000000', 'consum', 0.0216, 'lps'),
	(425260, 123, '2015-03-01 00:55:21.000000', 'consum', 0.0221, 'lps'),
	(425261, 123, '2015-03-01 00:55:22.000000', 'consum', 0.0220, 'lps'),
	(425262, 123, '2015-03-01 00:55:23.000000', 'consum', 0.0215, 'lps'),
	(425263, 123, '2015-03-01 00:55:24.000000', 'consum', 0.0216, 'lps'),
	(425264, 123, '2015-03-01 00:55:25.000000', 'consum', 0.0216, 'lps'),
	(425265, 123, '2015-03-01 00:55:26.000000', 'consum', 0.0220, 'lps'),
	(425266, 123, '2015-03-01 00:55:27.000000', 'consum', 0.0217, 'lps'),
	(425267, 123, '2015-03-01 00:55:28.000000', 'consum', 0.0216, 'lps'),
	(425268, 123, '2015-03-01 00:55:29.000000', 'consum', 0.0221, 'lps'),
	(425269, 123, '2015-03-01 00:55:30.000000', 'consum', 0.0219, 'lps'),
	(425270, 123, '2015-03-01 00:55:31.000000', 'consum', 0.0211, 'lps'),
	(425271, 123, '2015-03-01 00:55:32.000000', 'consum', 0.0213, 'lps'),
	(425272, 123, '2015-03-01 00:55:33.000000', 'consum', 0.0210, 'lps'),
	(425273, 123, '2015-03-01 00:55:34.000000', 'consum', 0.0213, 'lps'),
	(425274, 123, '2015-03-01 00:55:35.000000', 'consum', 0.0212, 'lps'),
	(425275, 123, '2015-03-01 00:55:36.000000', 'consum', 0.0213, 'lps'),
	(425276, 123, '2015-03-01 00:55:37.000000', 'consum', 0.0219, 'lps'),
	(425277, 123, '2015-03-01 00:55:38.000000', 'consum', 0.0219, 'lps'),
	(425278, 123, '2015-03-01 00:55:39.000000', 'consum', 0.0217, 'lps'),
	(425279, 123, '2015-03-01 00:55:40.000000', 'consum', 0.0217, 'lps'),
	(425280, 123, '2015-03-01 00:55:41.000000', 'consum', 0.0214, 'lps'),
	(425281, 123, '2015-03-01 00:55:42.000000', 'consum', 0.0220, 'lps'),
	(425282, 123, '2015-03-01 00:55:43.000000', 'consum', 0.0210, 'lps'),
	(425283, 123, '2015-03-01 00:55:44.000000', 'consum', 0.0219, 'lps'),
	(425284, 123, '2015-03-01 00:55:45.000000', 'consum', 0.0218, 'lps'),
	(425285, 123, '2015-03-01 00:55:46.000000', 'consum', 0.0210, 'lps'),
	(425286, 123, '2015-03-01 00:55:47.000000', 'consum', 0.0214, 'lps'),
	(425287, 123, '2015-03-01 00:55:48.000000', 'consum', 0.0217, 'lps'),
	(425288, 123, '2015-03-01 00:55:49.000000', 'consum', 0.0219, 'lps'),
	(425289, 123, '2015-03-01 00:55:50.000000', 'consum', 0.0211, 'lps'),
	(425290, 123, '2015-03-01 00:55:51.000000', 'consum', 0.0212, 'lps'),
	(425291, 123, '2015-03-01 00:55:52.000000', 'consum', 0.0217, 'lps'),
	(425292, 123, '2015-03-01 00:55:53.000000', 'consum', 0.0213, 'lps'),
	(425293, 123, '2015-03-01 00:55:54.000000', 'consum', 0.0218, 'lps'),
	(425294, 123, '2015-03-01 00:55:55.000000', 'consum', 0.0215, 'lps'),
	(425295, 123, '2015-03-01 00:55:56.000000', 'consum', 0.0212, 'lps'),
	(425296, 123, '2015-03-01 00:55:57.000000', 'consum', 0.0220, 'lps'),
	(425297, 123, '2015-03-01 00:55:58.000000', 'consum', 0.0216, 'lps'),
	(425298, 123, '2015-03-01 00:55:59.000000', 'consum', 0.0222, 'lps'),
	(425299, 123, '2015-03-01 00:56:00.000000', 'consum', 0.0212, 'lps'),
	(425300, 123, '2015-03-01 00:56:01.000000', 'consum', 0.0214, 'lps'),
	(425301, 123, '2015-03-01 00:56:02.000000', 'consum', 0.0210, 'lps'),
	(425302, 123, '2015-03-01 00:56:03.000000', 'consum', 0.0222, 'lps'),
	(425303, 123, '2015-03-01 00:56:04.000000', 'consum', 0.0222, 'lps'),
	(425304, 123, '2015-03-01 00:56:05.000000', 'consum', 0.0222, 'lps'),
	(425305, 123, '2015-03-01 00:56:06.000000', 'consum', 0.0219, 'lps'),
	(425306, 123, '2015-03-01 00:56:07.000000', 'consum', 0.0221, 'lps'),
	(425307, 123, '2015-03-01 00:56:08.000000', 'consum', 0.0210, 'lps'),
	(425308, 123, '2015-03-01 00:56:09.000000', 'consum', 0.0219, 'lps'),
	(425309, 123, '2015-03-01 00:56:10.000000', 'consum', 0.0217, 'lps'),
	(425310, 123, '2015-03-01 00:56:11.000000', 'consum', 0.0216, 'lps'),
	(425311, 123, '2015-03-01 00:56:12.000000', 'consum', 0.0219, 'lps'),
	(425312, 123, '2015-03-01 00:56:13.000000', 'consum', 0.0211, 'lps'),
	(425313, 123, '2015-03-01 00:56:14.000000', 'consum', 0.0216, 'lps'),
	(425314, 123, '2015-03-01 00:56:15.000000', 'consum', 0.0212, 'lps'),
	(425315, 123, '2015-03-01 00:56:16.000000', 'consum', 0.0213, 'lps'),
	(425316, 123, '2015-03-01 00:56:17.000000', 'consum', 0.0210, 'lps'),
	(425317, 123, '2015-03-01 00:56:18.000000', 'consum', 0.0211, 'lps'),
	(425318, 123, '2015-03-01 00:56:19.000000', 'consum', 0.0219, 'lps'),
	(425319, 123, '2015-03-01 00:56:20.000000', 'consum', 0.0212, 'lps'),
	(425320, 123, '2015-03-01 00:56:21.000000', 'consum', 0.0218, 'lps'),
	(425321, 123, '2015-03-01 00:56:22.000000', 'consum', 0.0221, 'lps'),
	(425322, 123, '2015-03-01 00:56:23.000000', 'consum', 0.0216, 'lps'),
	(425323, 123, '2015-03-01 00:56:24.000000', 'consum', 0.0218, 'lps'),
	(425324, 123, '2015-03-01 00:56:25.000000', 'consum', 0.0221, 'lps'),
	(425325, 123, '2015-03-01 00:56:26.000000', 'consum', 0.0214, 'lps'),
	(425326, 123, '2015-03-01 00:56:27.000000', 'consum', 0.0211, 'lps'),
	(425327, 123, '2015-03-01 00:56:28.000000', 'consum', 0.0215, 'lps'),
	(425328, 123, '2015-03-01 00:56:29.000000', 'consum', 0.0221, 'lps'),
	(425329, 123, '2015-03-01 00:56:30.000000', 'consum', 0.0210, 'lps'),
	(425330, 123, '2015-03-01 00:56:31.000000', 'consum', 0.0218, 'lps'),
	(425331, 123, '2015-03-01 00:56:32.000000', 'consum', 0.0222, 'lps'),
	(425332, 123, '2015-03-01 00:56:33.000000', 'consum', 0.0222, 'lps'),
	(425333, 123, '2015-03-01 00:56:34.000000', 'consum', 0.0222, 'lps'),
	(425334, 123, '2015-03-01 00:56:35.000000', 'consum', 0.0221, 'lps'),
	(425335, 123, '2015-03-01 00:56:36.000000', 'consum', 0.0217, 'lps'),
	(425336, 123, '2015-03-01 00:56:37.000000', 'consum', 0.0214, 'lps'),
	(425337, 123, '2015-03-01 00:56:38.000000', 'consum', 0.0222, 'lps'),
	(425338, 123, '2015-03-01 00:56:39.000000', 'consum', 0.0221, 'lps'),
	(425339, 123, '2015-03-01 00:56:40.000000', 'consum', 0.0214, 'lps'),
	(425340, 123, '2015-03-01 00:56:41.000000', 'consum', 0.0212, 'lps'),
	(425341, 123, '2015-03-01 00:56:42.000000', 'consum', 0.0222, 'lps'),
	(425342, 123, '2015-03-01 00:56:43.000000', 'consum', 0.0211, 'lps'),
	(425343, 123, '2015-03-01 00:56:44.000000', 'consum', 0.0217, 'lps'),
	(425344, 123, '2015-03-01 00:56:45.000000', 'consum', 0.0220, 'lps'),
	(425345, 123, '2015-03-01 00:56:46.000000', 'consum', 0.0212, 'lps'),
	(425346, 123, '2015-03-01 00:56:47.000000', 'consum', 0.0216, 'lps'),
	(425347, 123, '2015-03-01 00:56:48.000000', 'consum', 0.0222, 'lps'),
	(425348, 123, '2015-03-01 00:56:49.000000', 'consum', 0.0213, 'lps'),
	(425349, 123, '2015-03-01 00:56:50.000000', 'consum', 0.0215, 'lps'),
	(425350, 123, '2015-03-01 00:56:51.000000', 'consum', 0.0215, 'lps'),
	(425351, 123, '2015-03-01 00:56:52.000000', 'consum', 0.0221, 'lps'),
	(425352, 123, '2015-03-01 00:56:53.000000', 'consum', 0.0213, 'lps'),
	(425353, 123, '2015-03-01 00:56:54.000000', 'consum', 0.0215, 'lps'),
	(425354, 123, '2015-03-01 00:56:55.000000', 'consum', 0.0214, 'lps'),
	(425355, 123, '2015-03-01 00:56:56.000000', 'consum', 0.0218, 'lps'),
	(425356, 123, '2015-03-01 00:56:57.000000', 'consum', 0.0212, 'lps'),
	(425357, 123, '2015-03-01 00:56:58.000000', 'consum', 0.0221, 'lps'),
	(425358, 123, '2015-03-01 00:56:59.000000', 'consum', 0.0221, 'lps'),
	(425359, 123, '2015-03-01 00:57:00.000000', 'consum', 0.0221, 'lps'),
	(425360, 123, '2015-03-01 00:57:01.000000', 'consum', 0.0220, 'lps'),
	(425361, 123, '2015-03-01 00:57:02.000000', 'consum', 0.0214, 'lps'),
	(425362, 123, '2015-03-01 00:57:03.000000', 'consum', 0.0212, 'lps'),
	(425363, 123, '2015-03-01 00:57:04.000000', 'consum', 0.0221, 'lps'),
	(425364, 123, '2015-03-01 00:57:05.000000', 'consum', 0.0220, 'lps'),
	(425365, 123, '2015-03-01 00:57:06.000000', 'consum', 0.0217, 'lps'),
	(425366, 123, '2015-03-01 00:57:07.000000', 'consum', 0.0213, 'lps'),
	(425367, 123, '2015-03-01 00:57:08.000000', 'consum', 0.0218, 'lps'),
	(425368, 123, '2015-03-01 00:57:09.000000', 'consum', 0.0217, 'lps'),
	(425369, 123, '2015-03-01 00:57:10.000000', 'consum', 0.0219, 'lps'),
	(425370, 123, '2015-03-01 00:57:11.000000', 'consum', 0.0221, 'lps'),
	(425371, 123, '2015-03-01 00:57:12.000000', 'consum', 0.0214, 'lps'),
	(425372, 123, '2015-03-01 00:57:13.000000', 'consum', 0.0212, 'lps'),
	(425373, 123, '2015-03-01 00:57:14.000000', 'consum', 0.0219, 'lps'),
	(425374, 123, '2015-03-01 00:57:15.000000', 'consum', 0.0212, 'lps'),
	(425375, 123, '2015-03-01 00:57:16.000000', 'consum', 0.0218, 'lps'),
	(425376, 123, '2015-03-01 00:57:17.000000', 'consum', 0.0219, 'lps'),
	(425377, 123, '2015-03-01 00:57:18.000000', 'consum', 0.0221, 'lps'),
	(425378, 123, '2015-03-01 00:57:19.000000', 'consum', 0.0222, 'lps'),
	(425379, 123, '2015-03-01 00:57:20.000000', 'consum', 0.0212, 'lps'),
	(425380, 123, '2015-03-01 00:57:21.000000', 'consum', 0.0210, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(425381, 123, '2015-03-01 00:57:22.000000', 'consum', 0.0220, 'lps'),
	(425382, 123, '2015-03-01 00:57:23.000000', 'consum', 0.0219, 'lps'),
	(425383, 123, '2015-03-01 00:57:24.000000', 'consum', 0.0214, 'lps'),
	(425384, 123, '2015-03-01 00:57:25.000000', 'consum', 0.0216, 'lps'),
	(425385, 123, '2015-03-01 00:57:26.000000', 'consum', 0.0217, 'lps'),
	(425386, 123, '2015-03-01 00:57:27.000000', 'consum', 0.0214, 'lps'),
	(425387, 123, '2015-03-01 00:57:28.000000', 'consum', 0.0210, 'lps'),
	(425388, 123, '2015-03-01 00:57:29.000000', 'consum', 0.0210, 'lps'),
	(425389, 123, '2015-03-01 00:57:30.000000', 'consum', 0.0213, 'lps'),
	(425390, 123, '2015-03-01 00:57:31.000000', 'consum', 0.0212, 'lps'),
	(425391, 123, '2015-03-01 00:57:32.000000', 'consum', 0.0212, 'lps'),
	(425392, 123, '2015-03-01 00:57:33.000000', 'consum', 0.0212, 'lps'),
	(425393, 123, '2015-03-01 00:57:34.000000', 'consum', 0.0217, 'lps'),
	(425394, 123, '2015-03-01 00:57:35.000000', 'consum', 0.0211, 'lps'),
	(425395, 123, '2015-03-01 00:57:36.000000', 'consum', 0.0211, 'lps'),
	(425396, 123, '2015-03-01 00:57:37.000000', 'consum', 0.0210, 'lps'),
	(425397, 123, '2015-03-01 00:57:38.000000', 'consum', 0.0220, 'lps'),
	(425398, 123, '2015-03-01 00:57:39.000000', 'consum', 0.0211, 'lps'),
	(425399, 123, '2015-03-01 00:57:40.000000', 'consum', 0.0211, 'lps'),
	(425400, 123, '2015-03-01 00:57:41.000000', 'consum', 0.0211, 'lps'),
	(425401, 123, '2015-03-01 00:57:42.000000', 'consum', 0.0214, 'lps'),
	(425402, 123, '2015-03-01 00:57:43.000000', 'consum', 0.0216, 'lps'),
	(425403, 123, '2015-03-01 00:57:44.000000', 'consum', 0.0212, 'lps'),
	(425404, 123, '2015-03-01 00:57:45.000000', 'consum', 0.0217, 'lps'),
	(425405, 123, '2015-03-01 00:57:46.000000', 'consum', 0.0216, 'lps'),
	(425406, 123, '2015-03-01 00:57:47.000000', 'consum', 0.0216, 'lps'),
	(425407, 123, '2015-03-01 00:57:48.000000', 'consum', 0.0222, 'lps'),
	(425408, 123, '2015-03-01 00:57:49.000000', 'consum', 0.0215, 'lps'),
	(425409, 123, '2015-03-01 00:57:50.000000', 'consum', 0.0214, 'lps'),
	(425410, 123, '2015-03-01 00:57:51.000000', 'consum', 0.0215, 'lps'),
	(425411, 123, '2015-03-01 00:57:52.000000', 'consum', 0.0210, 'lps'),
	(425412, 123, '2015-03-01 00:57:53.000000', 'consum', 0.0222, 'lps'),
	(425413, 123, '2015-03-01 00:57:54.000000', 'consum', 0.0217, 'lps'),
	(425414, 123, '2015-03-01 00:57:55.000000', 'consum', 0.0212, 'lps'),
	(425415, 123, '2015-03-01 00:57:56.000000', 'consum', 0.0213, 'lps'),
	(425416, 123, '2015-03-01 00:57:57.000000', 'consum', 0.0218, 'lps'),
	(425417, 123, '2015-03-01 00:57:58.000000', 'consum', 0.0216, 'lps'),
	(425418, 123, '2015-03-01 00:57:59.000000', 'consum', 0.0216, 'lps'),
	(425419, 123, '2015-03-01 00:58:00.000000', 'consum', 0.0210, 'lps'),
	(425420, 123, '2015-03-01 00:58:01.000000', 'consum', 0.0216, 'lps'),
	(425421, 123, '2015-03-01 00:58:02.000000', 'consum', 0.0218, 'lps'),
	(425422, 123, '2015-03-01 00:58:03.000000', 'consum', 0.0218, 'lps'),
	(425423, 123, '2015-03-01 00:58:04.000000', 'consum', 0.0216, 'lps'),
	(425424, 123, '2015-03-01 00:58:05.000000', 'consum', 0.0213, 'lps'),
	(425425, 123, '2015-03-01 00:58:06.000000', 'consum', 0.0222, 'lps'),
	(425426, 123, '2015-03-01 00:58:07.000000', 'consum', 0.0211, 'lps'),
	(425427, 123, '2015-03-01 00:58:08.000000', 'consum', 0.0219, 'lps'),
	(425428, 123, '2015-03-01 00:58:09.000000', 'consum', 0.0214, 'lps'),
	(425429, 123, '2015-03-01 00:58:10.000000', 'consum', 0.0213, 'lps'),
	(425430, 123, '2015-03-01 00:58:11.000000', 'consum', 0.0216, 'lps'),
	(425431, 123, '2015-03-01 00:58:12.000000', 'consum', 0.0218, 'lps'),
	(425432, 123, '2015-03-01 00:58:13.000000', 'consum', 0.0221, 'lps'),
	(425433, 123, '2015-03-01 00:58:14.000000', 'consum', 0.0215, 'lps'),
	(425434, 123, '2015-03-01 00:58:15.000000', 'consum', 0.0213, 'lps'),
	(425435, 123, '2015-03-01 00:58:16.000000', 'consum', 0.0214, 'lps'),
	(425436, 123, '2015-03-01 00:58:17.000000', 'consum', 0.0220, 'lps'),
	(425437, 123, '2015-03-01 00:58:18.000000', 'consum', 0.0222, 'lps'),
	(425438, 123, '2015-03-01 00:58:19.000000', 'consum', 0.0215, 'lps'),
	(425439, 123, '2015-03-01 00:58:20.000000', 'consum', 0.0210, 'lps'),
	(425440, 123, '2015-03-01 00:58:21.000000', 'consum', 0.0212, 'lps'),
	(425441, 123, '2015-03-01 00:58:22.000000', 'consum', 0.0218, 'lps'),
	(425442, 123, '2015-03-01 00:58:23.000000', 'consum', 0.0217, 'lps'),
	(425443, 123, '2015-03-01 00:58:24.000000', 'consum', 0.0211, 'lps'),
	(425444, 123, '2015-03-01 00:58:25.000000', 'consum', 0.0221, 'lps'),
	(425445, 123, '2015-03-01 00:58:26.000000', 'consum', 0.0211, 'lps'),
	(425446, 123, '2015-03-01 00:58:27.000000', 'consum', 0.0221, 'lps'),
	(425447, 123, '2015-03-01 00:58:28.000000', 'consum', 0.0211, 'lps'),
	(425448, 123, '2015-03-01 00:58:29.000000', 'consum', 0.0222, 'lps'),
	(425449, 123, '2015-03-01 00:58:30.000000', 'consum', 0.0213, 'lps'),
	(425450, 123, '2015-03-01 00:58:31.000000', 'consum', 0.0216, 'lps'),
	(425451, 123, '2015-03-01 00:58:32.000000', 'consum', 0.0219, 'lps'),
	(425452, 123, '2015-03-01 00:58:33.000000', 'consum', 0.0213, 'lps'),
	(425453, 123, '2015-03-01 00:58:34.000000', 'consum', 0.0212, 'lps'),
	(425454, 123, '2015-03-01 00:58:35.000000', 'consum', 0.0222, 'lps'),
	(425455, 123, '2015-03-01 00:58:36.000000', 'consum', 0.0213, 'lps'),
	(425456, 123, '2015-03-01 00:58:37.000000', 'consum', 0.0217, 'lps'),
	(425457, 123, '2015-03-01 00:58:38.000000', 'consum', 0.0221, 'lps'),
	(425458, 123, '2015-03-01 00:58:39.000000', 'consum', 0.0221, 'lps'),
	(425459, 123, '2015-03-01 00:58:40.000000', 'consum', 0.0219, 'lps'),
	(425460, 123, '2015-03-01 00:58:41.000000', 'consum', 0.0222, 'lps'),
	(425461, 123, '2015-03-01 00:58:42.000000', 'consum', 0.0220, 'lps'),
	(425462, 123, '2015-03-01 00:58:43.000000', 'consum', 0.0222, 'lps'),
	(425463, 123, '2015-03-01 00:58:44.000000', 'consum', 0.0213, 'lps'),
	(425464, 123, '2015-03-01 00:58:45.000000', 'consum', 0.0218, 'lps'),
	(425465, 123, '2015-03-01 00:58:46.000000', 'consum', 0.0213, 'lps'),
	(425466, 123, '2015-03-01 00:58:47.000000', 'consum', 0.0215, 'lps'),
	(425467, 123, '2015-03-01 00:58:48.000000', 'consum', 0.0212, 'lps'),
	(425468, 123, '2015-03-01 00:58:49.000000', 'consum', 0.0219, 'lps'),
	(425469, 123, '2015-03-01 00:58:50.000000', 'consum', 0.0213, 'lps'),
	(425470, 123, '2015-03-01 00:58:51.000000', 'consum', 0.0211, 'lps'),
	(425471, 123, '2015-03-01 00:58:52.000000', 'consum', 0.0217, 'lps'),
	(425472, 123, '2015-03-01 00:58:53.000000', 'consum', 0.0220, 'lps'),
	(425473, 123, '2015-03-01 00:58:54.000000', 'consum', 0.0211, 'lps'),
	(425474, 123, '2015-03-01 00:58:55.000000', 'consum', 0.0213, 'lps'),
	(425475, 123, '2015-03-01 00:58:56.000000', 'consum', 0.0211, 'lps'),
	(425476, 123, '2015-03-01 00:58:57.000000', 'consum', 0.0218, 'lps'),
	(425477, 123, '2015-03-01 00:58:58.000000', 'consum', 0.0222, 'lps'),
	(425478, 123, '2015-03-01 00:58:59.000000', 'consum', 0.0218, 'lps'),
	(425479, 123, '2015-03-01 00:59:00.000000', 'consum', 0.0217, 'lps'),
	(425480, 123, '2015-03-01 00:59:01.000000', 'consum', 0.0221, 'lps'),
	(425481, 123, '2015-03-01 00:59:02.000000', 'consum', 0.0218, 'lps'),
	(425482, 123, '2015-03-01 00:59:03.000000', 'consum', 0.0219, 'lps'),
	(425483, 123, '2015-03-01 00:59:04.000000', 'consum', 0.0218, 'lps'),
	(425484, 123, '2015-03-01 00:59:05.000000', 'consum', 0.0212, 'lps'),
	(425485, 123, '2015-03-01 00:59:06.000000', 'consum', 0.0222, 'lps'),
	(425486, 123, '2015-03-01 00:59:07.000000', 'consum', 0.0213, 'lps'),
	(425487, 123, '2015-03-01 00:59:08.000000', 'consum', 0.0216, 'lps'),
	(425488, 123, '2015-03-01 00:59:09.000000', 'consum', 0.0218, 'lps'),
	(425489, 123, '2015-03-01 00:59:10.000000', 'consum', 0.0217, 'lps'),
	(425490, 123, '2015-03-01 00:59:11.000000', 'consum', 0.0212, 'lps'),
	(425491, 123, '2015-03-01 00:59:12.000000', 'consum', 0.0211, 'lps'),
	(425492, 123, '2015-03-01 00:59:13.000000', 'consum', 0.0210, 'lps'),
	(425493, 123, '2015-03-01 00:59:14.000000', 'consum', 0.0222, 'lps'),
	(425494, 123, '2015-03-01 00:59:15.000000', 'consum', 0.0218, 'lps'),
	(425495, 123, '2015-03-01 00:59:16.000000', 'consum', 0.0213, 'lps'),
	(425496, 123, '2015-03-01 00:59:17.000000', 'consum', 0.0215, 'lps'),
	(425497, 123, '2015-03-01 00:59:18.000000', 'consum', 0.0214, 'lps'),
	(425498, 123, '2015-03-01 00:59:19.000000', 'consum', 0.0217, 'lps'),
	(425499, 123, '2015-03-01 00:59:20.000000', 'consum', 0.0220, 'lps'),
	(425500, 123, '2015-03-01 00:59:21.000000', 'consum', 0.0213, 'lps'),
	(425501, 123, '2015-03-01 00:59:22.000000', 'consum', 0.0220, 'lps'),
	(425502, 123, '2015-03-01 00:59:23.000000', 'consum', 0.0214, 'lps'),
	(425503, 123, '2015-03-01 00:59:24.000000', 'consum', 0.0212, 'lps'),
	(425504, 123, '2015-03-01 00:59:25.000000', 'consum', 0.0211, 'lps'),
	(425505, 123, '2015-03-01 00:59:26.000000', 'consum', 0.0221, 'lps'),
	(425506, 123, '2015-03-01 00:59:27.000000', 'consum', 0.0210, 'lps'),
	(425507, 123, '2015-03-01 00:59:28.000000', 'consum', 0.0219, 'lps'),
	(425508, 123, '2015-03-01 00:59:29.000000', 'consum', 0.0214, 'lps'),
	(425509, 123, '2015-03-01 00:59:30.000000', 'consum', 0.0219, 'lps'),
	(425510, 123, '2015-03-01 00:59:31.000000', 'consum', 0.0217, 'lps'),
	(425511, 123, '2015-03-01 00:59:32.000000', 'consum', 0.0218, 'lps'),
	(425512, 123, '2015-03-01 00:59:33.000000', 'consum', 0.0216, 'lps'),
	(425513, 123, '2015-03-01 00:59:34.000000', 'consum', 0.0219, 'lps'),
	(425514, 123, '2015-03-01 00:59:35.000000', 'consum', 0.0221, 'lps'),
	(425515, 123, '2015-03-01 00:59:36.000000', 'consum', 0.0216, 'lps'),
	(425516, 123, '2015-03-01 00:59:37.000000', 'consum', 0.0218, 'lps'),
	(425517, 123, '2015-03-01 00:59:38.000000', 'consum', 0.0221, 'lps'),
	(425518, 123, '2015-03-01 00:59:39.000000', 'consum', 0.0214, 'lps'),
	(425519, 123, '2015-03-01 00:59:40.000000', 'consum', 0.0212, 'lps'),
	(425520, 123, '2015-03-01 00:59:41.000000', 'consum', 0.0220, 'lps'),
	(425521, 123, '2015-03-01 00:59:42.000000', 'consum', 0.0218, 'lps'),
	(425522, 123, '2015-03-01 00:59:43.000000', 'consum', 0.0218, 'lps'),
	(425523, 123, '2015-03-01 00:59:44.000000', 'consum', 0.0215, 'lps'),
	(425524, 123, '2015-03-01 00:59:45.000000', 'consum', 0.0210, 'lps'),
	(425525, 123, '2015-03-01 00:59:46.000000', 'consum', 0.0211, 'lps'),
	(425526, 123, '2015-03-01 00:59:47.000000', 'consum', 0.0212, 'lps'),
	(425527, 123, '2015-03-01 00:59:48.000000', 'consum', 0.0221, 'lps'),
	(425528, 123, '2015-03-01 00:59:49.000000', 'consum', 0.0217, 'lps'),
	(425529, 123, '2015-03-01 00:59:50.000000', 'consum', 0.0215, 'lps'),
	(425530, 123, '2015-03-01 00:59:51.000000', 'consum', 0.0212, 'lps'),
	(425531, 123, '2015-03-01 00:59:52.000000', 'consum', 0.0220, 'lps'),
	(425532, 123, '2015-03-01 00:59:53.000000', 'consum', 0.0213, 'lps'),
	(425533, 123, '2015-03-01 00:59:54.000000', 'consum', 0.0211, 'lps'),
	(425534, 123, '2015-03-01 00:59:55.000000', 'consum', 0.0220, 'lps'),
	(425535, 123, '2015-03-01 00:59:56.000000', 'consum', 0.0218, 'lps'),
	(425536, 123, '2015-03-01 00:59:57.000000', 'consum', 0.0221, 'lps'),
	(425537, 123, '2015-03-01 00:59:58.000000', 'consum', 0.0216, 'lps'),
	(425538, 123, '2015-03-01 00:59:59.000000', 'consum', 0.0221, 'lps'),
	(425539, 123, '2015-03-01 01:00:00.000000', 'consum', 0.0222, 'lps'),
	(425540, 123, '2015-03-01 01:00:01.000000', 'consum', 0.0211, 'lps'),
	(425541, 123, '2015-03-01 01:00:02.000000', 'consum', 0.0218, 'lps'),
	(425542, 123, '2015-03-01 01:00:03.000000', 'consum', 0.0220, 'lps'),
	(425543, 123, '2015-03-01 01:00:04.000000', 'consum', 0.0213, 'lps'),
	(425544, 123, '2015-03-01 01:00:05.000000', 'consum', 0.0219, 'lps'),
	(425545, 123, '2015-03-01 01:00:06.000000', 'consum', 0.0221, 'lps'),
	(425546, 123, '2015-03-01 01:00:07.000000', 'consum', 0.0213, 'lps'),
	(425547, 123, '2015-03-01 01:00:08.000000', 'consum', 0.0218, 'lps'),
	(425548, 123, '2015-03-01 01:00:09.000000', 'consum', 0.0217, 'lps'),
	(425549, 123, '2015-03-01 01:00:10.000000', 'consum', 0.0221, 'lps'),
	(425550, 123, '2015-03-01 01:00:11.000000', 'consum', 0.0217, 'lps'),
	(425551, 123, '2015-03-01 01:00:12.000000', 'consum', 0.0212, 'lps'),
	(425552, 123, '2015-03-01 01:00:13.000000', 'consum', 0.0213, 'lps'),
	(425553, 123, '2015-03-01 01:00:14.000000', 'consum', 0.0218, 'lps'),
	(425554, 123, '2015-03-01 01:00:15.000000', 'consum', 0.0218, 'lps'),
	(425555, 123, '2015-03-01 01:00:16.000000', 'consum', 0.0212, 'lps'),
	(425556, 123, '2015-03-01 01:00:17.000000', 'consum', 0.0222, 'lps'),
	(425557, 123, '2015-03-01 01:00:18.000000', 'consum', 0.0214, 'lps'),
	(425558, 123, '2015-03-01 01:00:19.000000', 'consum', 0.0220, 'lps'),
	(425559, 123, '2015-03-01 01:00:20.000000', 'consum', 0.0210, 'lps'),
	(425560, 123, '2015-03-01 01:00:21.000000', 'consum', 0.0219, 'lps'),
	(425561, 123, '2015-03-01 01:00:22.000000', 'consum', 0.0217, 'lps'),
	(425562, 123, '2015-03-01 01:00:23.000000', 'consum', 0.0220, 'lps'),
	(425563, 123, '2015-03-01 01:00:24.000000', 'consum', 0.0212, 'lps'),
	(425564, 123, '2015-03-01 01:00:25.000000', 'consum', 0.0218, 'lps'),
	(425565, 123, '2015-03-01 01:00:26.000000', 'consum', 0.0216, 'lps'),
	(425566, 123, '2015-03-01 01:00:27.000000', 'consum', 0.0220, 'lps'),
	(425567, 123, '2015-03-01 01:00:28.000000', 'consum', 0.0213, 'lps'),
	(425568, 123, '2015-03-01 01:00:29.000000', 'consum', 0.0211, 'lps'),
	(425569, 123, '2015-03-01 01:00:30.000000', 'consum', 0.0218, 'lps'),
	(425570, 123, '2015-03-01 01:00:31.000000', 'consum', 0.0221, 'lps'),
	(425571, 123, '2015-03-01 01:00:32.000000', 'consum', 0.0215, 'lps'),
	(425572, 123, '2015-03-01 01:00:33.000000', 'consum', 0.0217, 'lps'),
	(425573, 123, '2015-03-01 01:00:34.000000', 'consum', 0.0217, 'lps'),
	(425574, 123, '2015-03-01 01:00:35.000000', 'consum', 0.0210, 'lps'),
	(425575, 123, '2015-03-01 01:00:36.000000', 'consum', 0.0216, 'lps'),
	(425576, 123, '2015-03-01 01:00:37.000000', 'consum', 0.0214, 'lps'),
	(425577, 123, '2015-03-01 01:00:38.000000', 'consum', 0.0211, 'lps'),
	(425578, 123, '2015-03-01 01:00:39.000000', 'consum', 0.0218, 'lps'),
	(425579, 123, '2015-03-01 01:00:40.000000', 'consum', 0.0222, 'lps'),
	(425580, 123, '2015-03-01 01:00:41.000000', 'consum', 0.0221, 'lps'),
	(425581, 123, '2015-03-01 01:00:42.000000', 'consum', 0.0217, 'lps'),
	(425582, 123, '2015-03-01 01:00:43.000000', 'consum', 0.0213, 'lps'),
	(425583, 123, '2015-03-01 01:00:44.000000', 'consum', 0.0217, 'lps'),
	(425584, 123, '2015-03-01 01:00:45.000000', 'consum', 0.0210, 'lps'),
	(425585, 123, '2015-03-01 01:00:46.000000', 'consum', 0.0216, 'lps'),
	(425586, 123, '2015-03-01 01:00:47.000000', 'consum', 0.0215, 'lps'),
	(425587, 123, '2015-03-01 01:00:48.000000', 'consum', 0.0216, 'lps'),
	(425588, 123, '2015-03-01 01:00:49.000000', 'consum', 0.0212, 'lps'),
	(425589, 123, '2015-03-01 01:00:50.000000', 'consum', 0.0214, 'lps'),
	(425590, 123, '2015-03-01 01:00:51.000000', 'consum', 0.0215, 'lps'),
	(425591, 123, '2015-03-01 01:00:52.000000', 'consum', 0.0221, 'lps'),
	(425592, 123, '2015-03-01 01:00:53.000000', 'consum', 0.0212, 'lps'),
	(425593, 123, '2015-03-01 01:00:54.000000', 'consum', 0.0213, 'lps'),
	(425594, 123, '2015-03-01 01:00:55.000000', 'consum', 0.0220, 'lps'),
	(425595, 123, '2015-03-01 01:00:56.000000', 'consum', 0.0212, 'lps'),
	(425596, 123, '2015-03-01 01:00:57.000000', 'consum', 0.0216, 'lps'),
	(425597, 123, '2015-03-01 01:00:58.000000', 'consum', 0.0221, 'lps'),
	(425598, 123, '2015-03-01 01:00:59.000000', 'consum', 0.0221, 'lps'),
	(425599, 123, '2015-03-01 01:01:00.000000', 'consum', 0.0220, 'lps'),
	(425600, 123, '2015-03-01 01:01:01.000000', 'consum', 0.0215, 'lps'),
	(425601, 123, '2015-03-01 01:01:02.000000', 'consum', 0.0217, 'lps'),
	(425602, 123, '2015-03-01 01:01:03.000000', 'consum', 0.0220, 'lps'),
	(425603, 123, '2015-03-01 01:01:04.000000', 'consum', 0.0212, 'lps'),
	(425604, 123, '2015-03-01 01:01:05.000000', 'consum', 0.0216, 'lps'),
	(425605, 123, '2015-03-01 01:01:06.000000', 'consum', 0.0220, 'lps'),
	(425606, 123, '2015-03-01 01:01:07.000000', 'consum', 0.0219, 'lps'),
	(425607, 123, '2015-03-01 01:01:08.000000', 'consum', 0.0211, 'lps'),
	(425608, 123, '2015-03-01 01:01:09.000000', 'consum', 0.0213, 'lps'),
	(425609, 123, '2015-03-01 01:01:10.000000', 'consum', 0.0211, 'lps'),
	(425610, 123, '2015-03-01 01:01:11.000000', 'consum', 0.0218, 'lps'),
	(425611, 123, '2015-03-01 01:01:12.000000', 'consum', 0.0221, 'lps'),
	(425612, 123, '2015-03-01 01:01:13.000000', 'consum', 0.0216, 'lps'),
	(425613, 123, '2015-03-01 01:01:14.000000', 'consum', 0.0222, 'lps'),
	(425614, 123, '2015-03-01 01:01:15.000000', 'consum', 0.0213, 'lps'),
	(425615, 123, '2015-03-01 01:01:16.000000', 'consum', 0.0216, 'lps'),
	(425616, 123, '2015-03-01 01:01:17.000000', 'consum', 0.0217, 'lps'),
	(425617, 123, '2015-03-01 01:01:18.000000', 'consum', 0.0214, 'lps'),
	(425618, 123, '2015-03-01 01:01:19.000000', 'consum', 0.0212, 'lps'),
	(425619, 123, '2015-03-01 01:01:20.000000', 'consum', 0.0221, 'lps'),
	(425620, 123, '2015-03-01 01:01:21.000000', 'consum', 0.0220, 'lps'),
	(425621, 123, '2015-03-01 01:01:22.000000', 'consum', 0.0213, 'lps'),
	(425622, 123, '2015-03-01 01:01:23.000000', 'consum', 0.0210, 'lps'),
	(425623, 123, '2015-03-01 01:01:24.000000', 'consum', 0.0213, 'lps'),
	(425624, 123, '2015-03-01 01:01:25.000000', 'consum', 0.0215, 'lps'),
	(425625, 123, '2015-03-01 01:01:26.000000', 'consum', 0.0212, 'lps'),
	(425626, 123, '2015-03-01 01:01:27.000000', 'consum', 0.0219, 'lps'),
	(425627, 123, '2015-03-01 01:01:28.000000', 'consum', 0.0212, 'lps'),
	(425628, 123, '2015-03-01 01:01:29.000000', 'consum', 0.0219, 'lps'),
	(425629, 123, '2015-03-01 01:01:30.000000', 'consum', 0.0210, 'lps'),
	(425630, 123, '2015-03-01 01:01:31.000000', 'consum', 0.0221, 'lps'),
	(425631, 123, '2015-03-01 01:01:32.000000', 'consum', 0.0213, 'lps'),
	(425632, 123, '2015-03-01 01:01:33.000000', 'consum', 0.0219, 'lps'),
	(425633, 123, '2015-03-01 01:01:34.000000', 'consum', 0.0222, 'lps'),
	(425634, 123, '2015-03-01 01:01:35.000000', 'consum', 0.0215, 'lps'),
	(425635, 123, '2015-03-01 01:01:36.000000', 'consum', 0.0212, 'lps'),
	(425636, 123, '2015-03-01 01:01:37.000000', 'consum', 0.0221, 'lps'),
	(425637, 123, '2015-03-01 01:01:38.000000', 'consum', 0.0221, 'lps'),
	(425638, 123, '2015-03-01 01:01:39.000000', 'consum', 0.0218, 'lps'),
	(425639, 123, '2015-03-01 01:01:40.000000', 'consum', 0.0216, 'lps'),
	(425640, 123, '2015-03-01 01:01:41.000000', 'consum', 0.0219, 'lps'),
	(425641, 123, '2015-03-01 01:01:42.000000', 'consum', 0.0212, 'lps'),
	(425642, 123, '2015-03-01 01:01:43.000000', 'consum', 0.0217, 'lps'),
	(425643, 123, '2015-03-01 01:01:44.000000', 'consum', 0.0216, 'lps'),
	(425644, 123, '2015-03-01 01:01:45.000000', 'consum', 0.0220, 'lps'),
	(425645, 123, '2015-03-01 01:01:46.000000', 'consum', 0.0215, 'lps'),
	(425646, 123, '2015-03-01 01:01:47.000000', 'consum', 0.0218, 'lps'),
	(425647, 123, '2015-03-01 01:01:48.000000', 'consum', 0.0212, 'lps'),
	(425648, 123, '2015-03-01 01:01:49.000000', 'consum', 0.0222, 'lps'),
	(425649, 123, '2015-03-01 01:01:50.000000', 'consum', 0.0210, 'lps'),
	(425650, 123, '2015-03-01 01:01:51.000000', 'consum', 0.0217, 'lps'),
	(425651, 123, '2015-03-01 01:01:52.000000', 'consum', 0.0216, 'lps'),
	(425652, 123, '2015-03-01 01:01:53.000000', 'consum', 0.0222, 'lps'),
	(425653, 123, '2015-03-01 01:01:54.000000', 'consum', 0.0213, 'lps'),
	(425654, 123, '2015-03-01 01:01:55.000000', 'consum', 0.0216, 'lps'),
	(425655, 123, '2015-03-01 01:01:56.000000', 'consum', 0.0219, 'lps'),
	(425656, 123, '2015-03-01 01:01:57.000000', 'consum', 0.0212, 'lps'),
	(425657, 123, '2015-03-01 01:01:58.000000', 'consum', 0.0220, 'lps'),
	(425658, 123, '2015-03-01 01:01:59.000000', 'consum', 0.0216, 'lps'),
	(425659, 123, '2015-03-01 01:02:00.000000', 'consum', 0.0222, 'lps'),
	(425660, 123, '2015-03-01 01:02:01.000000', 'consum', 0.0215, 'lps'),
	(425661, 123, '2015-03-01 01:02:02.000000', 'consum', 0.0211, 'lps'),
	(425662, 123, '2015-03-01 01:02:03.000000', 'consum', 0.0215, 'lps'),
	(425663, 123, '2015-03-01 01:02:04.000000', 'consum', 0.0217, 'lps'),
	(425664, 123, '2015-03-01 01:02:05.000000', 'consum', 0.0219, 'lps'),
	(425665, 123, '2015-03-01 01:02:06.000000', 'consum', 0.0210, 'lps'),
	(425666, 123, '2015-03-01 01:02:07.000000', 'consum', 0.0210, 'lps'),
	(425667, 123, '2015-03-01 01:02:08.000000', 'consum', 0.0222, 'lps'),
	(425668, 123, '2015-03-01 01:02:09.000000', 'consum', 0.0219, 'lps'),
	(425669, 123, '2015-03-01 01:02:10.000000', 'consum', 0.0220, 'lps'),
	(425670, 123, '2015-03-01 01:02:11.000000', 'consum', 0.0218, 'lps'),
	(425671, 123, '2015-03-01 01:02:12.000000', 'consum', 0.0210, 'lps'),
	(425672, 123, '2015-03-01 01:02:13.000000', 'consum', 0.0210, 'lps'),
	(425673, 123, '2015-03-01 01:02:14.000000', 'consum', 0.0211, 'lps'),
	(425674, 123, '2015-03-01 01:02:15.000000', 'consum', 0.0218, 'lps'),
	(425675, 123, '2015-03-01 01:02:16.000000', 'consum', 0.0220, 'lps'),
	(425676, 123, '2015-03-01 01:02:17.000000', 'consum', 0.0210, 'lps'),
	(425677, 123, '2015-03-01 01:02:18.000000', 'consum', 0.0220, 'lps'),
	(425678, 123, '2015-03-01 01:02:19.000000', 'consum', 0.0220, 'lps'),
	(425679, 123, '2015-03-01 01:02:20.000000', 'consum', 0.0219, 'lps'),
	(425680, 123, '2015-03-01 01:02:21.000000', 'consum', 0.0213, 'lps'),
	(425681, 123, '2015-03-01 01:02:22.000000', 'consum', 0.0222, 'lps'),
	(425682, 123, '2015-03-01 01:02:23.000000', 'consum', 0.0212, 'lps'),
	(425683, 123, '2015-03-01 01:02:24.000000', 'consum', 0.0210, 'lps'),
	(425684, 123, '2015-03-01 01:02:25.000000', 'consum', 0.0215, 'lps'),
	(425685, 123, '2015-03-01 01:02:26.000000', 'consum', 0.0213, 'lps'),
	(425686, 123, '2015-03-01 01:02:27.000000', 'consum', 0.0220, 'lps'),
	(425687, 123, '2015-03-01 01:02:28.000000', 'consum', 0.0215, 'lps'),
	(425688, 123, '2015-03-01 01:02:29.000000', 'consum', 0.0217, 'lps'),
	(425689, 123, '2015-03-01 01:02:30.000000', 'consum', 0.0218, 'lps'),
	(425690, 123, '2015-03-01 01:02:31.000000', 'consum', 0.0217, 'lps'),
	(425691, 123, '2015-03-01 01:02:32.000000', 'consum', 0.0221, 'lps'),
	(425692, 123, '2015-03-01 01:02:33.000000', 'consum', 0.0217, 'lps'),
	(425693, 123, '2015-03-01 01:02:34.000000', 'consum', 0.0214, 'lps'),
	(425694, 123, '2015-03-01 01:02:35.000000', 'consum', 0.0211, 'lps'),
	(425695, 123, '2015-03-01 01:02:36.000000', 'consum', 0.0217, 'lps'),
	(425696, 123, '2015-03-01 01:02:37.000000', 'consum', 0.0214, 'lps'),
	(425697, 123, '2015-03-01 01:02:38.000000', 'consum', 0.0211, 'lps'),
	(425698, 123, '2015-03-01 01:02:39.000000', 'consum', 0.0217, 'lps'),
	(425699, 123, '2015-03-01 01:02:40.000000', 'consum', 0.0214, 'lps'),
	(425700, 123, '2015-03-01 01:02:41.000000', 'consum', 0.0213, 'lps'),
	(425701, 123, '2015-03-01 01:02:42.000000', 'consum', 0.0211, 'lps'),
	(425702, 123, '2015-03-01 01:02:43.000000', 'consum', 0.0221, 'lps'),
	(425703, 123, '2015-03-01 01:02:44.000000', 'consum', 0.0210, 'lps'),
	(425704, 123, '2015-03-01 01:02:45.000000', 'consum', 0.0215, 'lps'),
	(425705, 123, '2015-03-01 01:02:46.000000', 'consum', 0.0211, 'lps'),
	(425706, 123, '2015-03-01 01:02:47.000000', 'consum', 0.0212, 'lps'),
	(425707, 123, '2015-03-01 01:02:48.000000', 'consum', 0.0218, 'lps'),
	(425708, 123, '2015-03-01 01:02:49.000000', 'consum', 0.0218, 'lps'),
	(425709, 123, '2015-03-01 01:02:50.000000', 'consum', 0.0215, 'lps'),
	(425710, 123, '2015-03-01 01:02:51.000000', 'consum', 0.0213, 'lps'),
	(425711, 123, '2015-03-01 01:02:52.000000', 'consum', 0.0221, 'lps'),
	(425712, 123, '2015-03-01 01:02:53.000000', 'consum', 0.0216, 'lps'),
	(425713, 123, '2015-03-01 01:02:54.000000', 'consum', 0.0211, 'lps'),
	(425714, 123, '2015-03-01 01:02:55.000000', 'consum', 0.0222, 'lps'),
	(425715, 123, '2015-03-01 01:02:56.000000', 'consum', 0.0215, 'lps'),
	(425716, 123, '2015-03-01 01:02:57.000000', 'consum', 0.0213, 'lps'),
	(425717, 123, '2015-03-01 01:02:58.000000', 'consum', 0.0210, 'lps'),
	(425718, 123, '2015-03-01 01:02:59.000000', 'consum', 0.0217, 'lps'),
	(425719, 123, '2015-03-01 01:03:00.000000', 'consum', 0.0217, 'lps'),
	(425720, 123, '2015-03-01 01:03:01.000000', 'consum', 0.0213, 'lps'),
	(425721, 123, '2015-03-01 01:03:02.000000', 'consum', 0.0216, 'lps'),
	(425722, 123, '2015-03-01 01:03:03.000000', 'consum', 0.0220, 'lps'),
	(425723, 123, '2015-03-01 01:03:04.000000', 'consum', 0.0218, 'lps'),
	(425724, 123, '2015-03-01 01:03:05.000000', 'consum', 0.0217, 'lps'),
	(425725, 123, '2015-03-01 01:03:06.000000', 'consum', 0.0212, 'lps'),
	(425726, 123, '2015-03-01 01:03:07.000000', 'consum', 0.0211, 'lps'),
	(425727, 123, '2015-03-01 01:03:08.000000', 'consum', 0.0211, 'lps'),
	(425728, 123, '2015-03-01 01:03:09.000000', 'consum', 0.0211, 'lps'),
	(425729, 123, '2015-03-01 01:03:10.000000', 'consum', 0.0211, 'lps'),
	(425730, 123, '2015-03-01 01:03:11.000000', 'consum', 0.0215, 'lps'),
	(425731, 123, '2015-03-01 01:03:12.000000', 'consum', 0.0219, 'lps'),
	(425732, 123, '2015-03-01 01:03:13.000000', 'consum', 0.0213, 'lps'),
	(425733, 123, '2015-03-01 01:03:14.000000', 'consum', 0.0213, 'lps'),
	(425734, 123, '2015-03-01 01:03:15.000000', 'consum', 0.0218, 'lps'),
	(425735, 123, '2015-03-01 01:03:16.000000', 'consum', 0.0215, 'lps'),
	(425736, 123, '2015-03-01 01:03:17.000000', 'consum', 0.0211, 'lps'),
	(425737, 123, '2015-03-01 01:03:18.000000', 'consum', 0.0212, 'lps'),
	(425738, 123, '2015-03-01 01:03:19.000000', 'consum', 0.0217, 'lps'),
	(425739, 123, '2015-03-01 01:03:20.000000', 'consum', 0.0214, 'lps'),
	(425740, 123, '2015-03-01 01:03:21.000000', 'consum', 0.0210, 'lps'),
	(425741, 123, '2015-03-01 01:03:22.000000', 'consum', 0.0210, 'lps'),
	(425742, 123, '2015-03-01 01:03:23.000000', 'consum', 0.0211, 'lps'),
	(425743, 123, '2015-03-01 01:03:24.000000', 'consum', 0.0214, 'lps'),
	(425744, 123, '2015-03-01 01:03:25.000000', 'consum', 0.0216, 'lps'),
	(425745, 123, '2015-03-01 01:03:26.000000', 'consum', 0.0216, 'lps'),
	(425746, 123, '2015-03-01 01:03:27.000000', 'consum', 0.0220, 'lps'),
	(425747, 123, '2015-03-01 01:03:28.000000', 'consum', 0.0218, 'lps'),
	(425748, 123, '2015-03-01 01:03:29.000000', 'consum', 0.0222, 'lps'),
	(425749, 123, '2015-03-01 01:03:30.000000', 'consum', 0.0221, 'lps'),
	(425750, 123, '2015-03-01 01:03:31.000000', 'consum', 0.0216, 'lps'),
	(425751, 123, '2015-03-01 01:03:32.000000', 'consum', 0.0220, 'lps'),
	(425752, 123, '2015-03-01 01:03:33.000000', 'consum', 0.0217, 'lps'),
	(425753, 123, '2015-03-01 01:03:34.000000', 'consum', 0.0216, 'lps'),
	(425754, 123, '2015-03-01 01:03:35.000000', 'consum', 0.0220, 'lps'),
	(425755, 123, '2015-03-01 01:03:36.000000', 'consum', 0.0215, 'lps'),
	(425756, 123, '2015-03-01 01:03:37.000000', 'consum', 0.0217, 'lps'),
	(425757, 123, '2015-03-01 01:03:38.000000', 'consum', 0.0220, 'lps'),
	(425758, 123, '2015-03-01 01:03:39.000000', 'consum', 0.0212, 'lps'),
	(425759, 123, '2015-03-01 01:03:40.000000', 'consum', 0.0218, 'lps'),
	(425760, 123, '2015-03-01 01:03:41.000000', 'consum', 0.0218, 'lps'),
	(425761, 123, '2015-03-01 01:03:42.000000', 'consum', 0.0213, 'lps'),
	(425762, 123, '2015-03-01 01:03:43.000000', 'consum', 0.0214, 'lps'),
	(425763, 123, '2015-03-01 01:03:44.000000', 'consum', 0.0210, 'lps'),
	(425764, 123, '2015-03-01 01:03:45.000000', 'consum', 0.0211, 'lps'),
	(425765, 123, '2015-03-01 01:03:46.000000', 'consum', 0.0216, 'lps'),
	(425766, 123, '2015-03-01 01:03:47.000000', 'consum', 0.0212, 'lps'),
	(425767, 123, '2015-03-01 01:03:48.000000', 'consum', 0.0213, 'lps'),
	(425768, 123, '2015-03-01 01:03:49.000000', 'consum', 0.0221, 'lps'),
	(425769, 123, '2015-03-01 01:03:50.000000', 'consum', 0.0219, 'lps'),
	(425770, 123, '2015-03-01 01:03:51.000000', 'consum', 0.0221, 'lps'),
	(425771, 123, '2015-03-01 01:03:52.000000', 'consum', 0.0214, 'lps'),
	(425772, 123, '2015-03-01 01:03:53.000000', 'consum', 0.0222, 'lps'),
	(425773, 123, '2015-03-01 01:03:54.000000', 'consum', 0.0218, 'lps'),
	(425774, 123, '2015-03-01 01:03:55.000000', 'consum', 0.0215, 'lps'),
	(425775, 123, '2015-03-01 01:03:56.000000', 'consum', 0.0212, 'lps'),
	(425776, 123, '2015-03-01 01:03:57.000000', 'consum', 0.0218, 'lps'),
	(425777, 123, '2015-03-01 01:03:58.000000', 'consum', 0.0218, 'lps'),
	(425778, 123, '2015-03-01 01:03:59.000000', 'consum', 0.0216, 'lps'),
	(425779, 123, '2015-03-01 01:04:00.000000', 'consum', 0.0216, 'lps'),
	(425780, 123, '2015-03-01 01:04:01.000000', 'consum', 0.0222, 'lps'),
	(425781, 123, '2015-03-01 01:04:02.000000', 'consum', 0.0212, 'lps'),
	(425782, 123, '2015-03-01 01:04:03.000000', 'consum', 0.0211, 'lps'),
	(425783, 123, '2015-03-01 01:04:04.000000', 'consum', 0.0212, 'lps'),
	(425784, 123, '2015-03-01 01:04:05.000000', 'consum', 0.0214, 'lps'),
	(425785, 123, '2015-03-01 01:04:06.000000', 'consum', 0.0213, 'lps'),
	(425786, 123, '2015-03-01 01:04:07.000000', 'consum', 0.0212, 'lps'),
	(425787, 123, '2015-03-01 01:04:08.000000', 'consum', 0.0212, 'lps'),
	(425788, 123, '2015-03-01 01:04:09.000000', 'consum', 0.0213, 'lps'),
	(425789, 123, '2015-03-01 01:04:10.000000', 'consum', 0.0220, 'lps'),
	(425790, 123, '2015-03-01 01:04:11.000000', 'consum', 0.0212, 'lps'),
	(425791, 123, '2015-03-01 01:04:12.000000', 'consum', 0.0219, 'lps'),
	(425792, 123, '2015-03-01 01:04:13.000000', 'consum', 0.0222, 'lps'),
	(425793, 123, '2015-03-01 01:04:14.000000', 'consum', 0.0218, 'lps'),
	(425794, 123, '2015-03-01 01:04:15.000000', 'consum', 0.0213, 'lps'),
	(425795, 123, '2015-03-01 01:04:16.000000', 'consum', 0.0217, 'lps'),
	(425796, 123, '2015-03-01 01:04:17.000000', 'consum', 0.0221, 'lps'),
	(425797, 123, '2015-03-01 01:04:18.000000', 'consum', 0.0219, 'lps'),
	(425798, 123, '2015-03-01 01:04:19.000000', 'consum', 0.0221, 'lps'),
	(425799, 123, '2015-03-01 01:04:20.000000', 'consum', 0.0215, 'lps'),
	(425800, 123, '2015-03-01 01:04:21.000000', 'consum', 0.0216, 'lps'),
	(425801, 123, '2015-03-01 01:04:22.000000', 'consum', 0.0211, 'lps'),
	(425802, 123, '2015-03-01 01:04:23.000000', 'consum', 0.0211, 'lps'),
	(425803, 123, '2015-03-01 01:04:24.000000', 'consum', 0.0214, 'lps'),
	(425804, 123, '2015-03-01 01:04:25.000000', 'consum', 0.0213, 'lps'),
	(425805, 123, '2015-03-01 01:04:26.000000', 'consum', 0.0212, 'lps'),
	(425806, 123, '2015-03-01 01:04:27.000000', 'consum', 0.0212, 'lps'),
	(425807, 123, '2015-03-01 01:04:28.000000', 'consum', 0.0215, 'lps'),
	(425808, 123, '2015-03-01 01:04:29.000000', 'consum', 0.0215, 'lps'),
	(425809, 123, '2015-03-01 01:04:30.000000', 'consum', 0.0219, 'lps'),
	(425810, 123, '2015-03-01 01:04:31.000000', 'consum', 0.0218, 'lps'),
	(425811, 123, '2015-03-01 01:04:32.000000', 'consum', 0.0210, 'lps'),
	(425812, 123, '2015-03-01 01:04:33.000000', 'consum', 0.0210, 'lps'),
	(425813, 123, '2015-03-01 01:04:34.000000', 'consum', 0.0213, 'lps'),
	(425814, 123, '2015-03-01 01:04:35.000000', 'consum', 0.0210, 'lps'),
	(425815, 123, '2015-03-01 01:04:36.000000', 'consum', 0.0217, 'lps'),
	(425816, 123, '2015-03-01 01:04:37.000000', 'consum', 0.0218, 'lps'),
	(425817, 123, '2015-03-01 01:04:38.000000', 'consum', 0.0219, 'lps'),
	(425818, 123, '2015-03-01 01:04:39.000000', 'consum', 0.0215, 'lps'),
	(425819, 123, '2015-03-01 01:04:40.000000', 'consum', 0.0210, 'lps'),
	(425820, 123, '2015-03-01 01:04:41.000000', 'consum', 0.0221, 'lps'),
	(425821, 123, '2015-03-01 01:04:42.000000', 'consum', 0.0215, 'lps'),
	(425822, 123, '2015-03-01 01:04:43.000000', 'consum', 0.0216, 'lps'),
	(425823, 123, '2015-03-01 01:04:44.000000', 'consum', 0.0222, 'lps'),
	(425824, 123, '2015-03-01 01:04:45.000000', 'consum', 0.0217, 'lps'),
	(425825, 123, '2015-03-01 01:04:46.000000', 'consum', 0.0222, 'lps'),
	(425826, 123, '2015-03-01 01:04:47.000000', 'consum', 0.0211, 'lps'),
	(425827, 123, '2015-03-01 01:04:48.000000', 'consum', 0.0217, 'lps'),
	(425828, 123, '2015-03-01 01:04:49.000000', 'consum', 0.0216, 'lps'),
	(425829, 123, '2015-03-01 01:04:50.000000', 'consum', 0.0222, 'lps'),
	(425830, 123, '2015-03-01 01:04:51.000000', 'consum', 0.0213, 'lps'),
	(425831, 123, '2015-03-01 01:04:52.000000', 'consum', 0.0215, 'lps'),
	(425832, 123, '2015-03-01 01:04:53.000000', 'consum', 0.0214, 'lps'),
	(425833, 123, '2015-03-01 01:04:54.000000', 'consum', 0.0215, 'lps'),
	(425834, 123, '2015-03-01 01:04:55.000000', 'consum', 0.0212, 'lps'),
	(425835, 123, '2015-03-01 01:04:56.000000', 'consum', 0.0218, 'lps'),
	(425836, 123, '2015-03-01 01:04:57.000000', 'consum', 0.0220, 'lps'),
	(425837, 123, '2015-03-01 01:04:58.000000', 'consum', 0.0210, 'lps'),
	(425838, 123, '2015-03-01 01:04:59.000000', 'consum', 0.0219, 'lps'),
	(425839, 123, '2015-03-01 01:05:00.000000', 'consum', 0.0217, 'lps'),
	(425840, 123, '2015-03-01 01:05:01.000000', 'consum', 0.0217, 'lps'),
	(425841, 123, '2015-03-01 01:05:02.000000', 'consum', 0.0213, 'lps'),
	(425842, 123, '2015-03-01 01:05:03.000000', 'consum', 0.0216, 'lps'),
	(425843, 123, '2015-03-01 01:05:04.000000', 'consum', 0.0217, 'lps'),
	(425844, 123, '2015-03-01 01:05:05.000000', 'consum', 0.0216, 'lps'),
	(425845, 123, '2015-03-01 01:05:06.000000', 'consum', 0.0221, 'lps'),
	(425846, 123, '2015-03-01 01:05:07.000000', 'consum', 0.0221, 'lps'),
	(425847, 123, '2015-03-01 01:05:08.000000', 'consum', 0.0220, 'lps'),
	(425848, 123, '2015-03-01 01:05:09.000000', 'consum', 0.0214, 'lps'),
	(425849, 123, '2015-03-01 01:05:10.000000', 'consum', 0.0213, 'lps'),
	(425850, 123, '2015-03-01 01:05:11.000000', 'consum', 0.0212, 'lps'),
	(425851, 123, '2015-03-01 01:05:12.000000', 'consum', 0.0212, 'lps'),
	(425852, 123, '2015-03-01 01:05:13.000000', 'consum', 0.0216, 'lps'),
	(425853, 123, '2015-03-01 01:05:14.000000', 'consum', 0.0210, 'lps'),
	(425854, 123, '2015-03-01 01:05:15.000000', 'consum', 0.0217, 'lps'),
	(425855, 123, '2015-03-01 01:05:16.000000', 'consum', 0.0218, 'lps'),
	(425856, 123, '2015-03-01 01:05:17.000000', 'consum', 0.0219, 'lps'),
	(425857, 123, '2015-03-01 01:05:18.000000', 'consum', 0.0217, 'lps'),
	(425858, 123, '2015-03-01 01:05:19.000000', 'consum', 0.0221, 'lps'),
	(425859, 123, '2015-03-01 01:05:20.000000', 'consum', 0.0216, 'lps'),
	(425860, 123, '2015-03-01 01:05:21.000000', 'consum', 0.0210, 'lps'),
	(425861, 123, '2015-03-01 01:05:22.000000', 'consum', 0.0218, 'lps'),
	(425862, 123, '2015-03-01 01:05:23.000000', 'consum', 0.0213, 'lps'),
	(425863, 123, '2015-03-01 01:05:24.000000', 'consum', 0.0211, 'lps'),
	(425864, 123, '2015-03-01 01:05:25.000000', 'consum', 0.0210, 'lps'),
	(425865, 123, '2015-03-01 01:05:26.000000', 'consum', 0.0220, 'lps'),
	(425866, 123, '2015-03-01 01:05:27.000000', 'consum', 0.0219, 'lps'),
	(425867, 123, '2015-03-01 01:05:28.000000', 'consum', 0.0213, 'lps'),
	(425868, 123, '2015-03-01 01:05:29.000000', 'consum', 0.0211, 'lps'),
	(425869, 123, '2015-03-01 01:05:30.000000', 'consum', 0.0222, 'lps'),
	(425870, 123, '2015-03-01 01:05:31.000000', 'consum', 0.0216, 'lps'),
	(425871, 123, '2015-03-01 01:05:32.000000', 'consum', 0.0215, 'lps'),
	(425872, 123, '2015-03-01 01:05:33.000000', 'consum', 0.0220, 'lps'),
	(425873, 123, '2015-03-01 01:05:34.000000', 'consum', 0.0220, 'lps'),
	(425874, 123, '2015-03-01 01:05:35.000000', 'consum', 0.0218, 'lps'),
	(425875, 123, '2015-03-01 01:05:36.000000', 'consum', 0.0220, 'lps'),
	(425876, 123, '2015-03-01 01:05:37.000000', 'consum', 0.0211, 'lps'),
	(425877, 123, '2015-03-01 01:05:38.000000', 'consum', 0.0222, 'lps'),
	(425878, 123, '2015-03-01 01:05:39.000000', 'consum', 0.0218, 'lps'),
	(425879, 123, '2015-03-01 01:05:40.000000', 'consum', 0.0215, 'lps'),
	(425880, 123, '2015-03-01 01:05:41.000000', 'consum', 0.0210, 'lps'),
	(425881, 123, '2015-03-01 01:05:42.000000', 'consum', 0.0210, 'lps'),
	(425882, 123, '2015-03-01 01:05:43.000000', 'consum', 0.0222, 'lps'),
	(425883, 123, '2015-03-01 01:05:44.000000', 'consum', 0.0219, 'lps'),
	(425884, 123, '2015-03-01 01:05:45.000000', 'consum', 0.0218, 'lps'),
	(425885, 123, '2015-03-01 01:05:46.000000', 'consum', 0.0222, 'lps'),
	(425886, 123, '2015-03-01 01:05:47.000000', 'consum', 0.0211, 'lps'),
	(425887, 123, '2015-03-01 01:05:48.000000', 'consum', 0.0219, 'lps'),
	(425888, 123, '2015-03-01 01:05:49.000000', 'consum', 0.0212, 'lps'),
	(425889, 123, '2015-03-01 01:05:50.000000', 'consum', 0.0221, 'lps'),
	(425890, 123, '2015-03-01 01:05:51.000000', 'consum', 0.0218, 'lps'),
	(425891, 123, '2015-03-01 01:05:52.000000', 'consum', 0.0218, 'lps'),
	(425892, 123, '2015-03-01 01:05:53.000000', 'consum', 0.0214, 'lps'),
	(425893, 123, '2015-03-01 01:05:54.000000', 'consum', 0.0219, 'lps'),
	(425894, 123, '2015-03-01 01:05:55.000000', 'consum', 0.0217, 'lps'),
	(425895, 123, '2015-03-01 01:05:56.000000', 'consum', 0.0220, 'lps'),
	(425896, 123, '2015-03-01 01:05:57.000000', 'consum', 0.0214, 'lps'),
	(425897, 123, '2015-03-01 01:05:58.000000', 'consum', 0.0211, 'lps'),
	(425898, 123, '2015-03-01 01:05:59.000000', 'consum', 0.0218, 'lps'),
	(425899, 123, '2015-03-01 01:06:00.000000', 'consum', 0.0210, 'lps'),
	(425900, 123, '2015-03-01 01:06:01.000000', 'consum', 0.0213, 'lps'),
	(425901, 123, '2015-03-01 01:06:02.000000', 'consum', 0.0212, 'lps'),
	(425902, 123, '2015-03-01 01:06:03.000000', 'consum', 0.0210, 'lps'),
	(425903, 123, '2015-03-01 01:06:04.000000', 'consum', 0.0220, 'lps'),
	(425904, 123, '2015-03-01 01:06:05.000000', 'consum', 0.0218, 'lps'),
	(425905, 123, '2015-03-01 01:06:06.000000', 'consum', 0.0211, 'lps'),
	(425906, 123, '2015-03-01 01:06:07.000000', 'consum', 0.0215, 'lps'),
	(425907, 123, '2015-03-01 01:06:08.000000', 'consum', 0.0219, 'lps'),
	(425908, 123, '2015-03-01 01:06:09.000000', 'consum', 0.0214, 'lps'),
	(425909, 123, '2015-03-01 01:06:10.000000', 'consum', 0.0217, 'lps'),
	(425910, 123, '2015-03-01 01:06:11.000000', 'consum', 0.0222, 'lps'),
	(425911, 123, '2015-03-01 01:06:12.000000', 'consum', 0.0211, 'lps'),
	(425912, 123, '2015-03-01 01:06:13.000000', 'consum', 0.0216, 'lps'),
	(425913, 123, '2015-03-01 01:06:14.000000', 'consum', 0.0213, 'lps'),
	(425914, 123, '2015-03-01 01:06:15.000000', 'consum', 0.0219, 'lps'),
	(425915, 123, '2015-03-01 01:06:16.000000', 'consum', 0.0219, 'lps'),
	(425916, 123, '2015-03-01 01:06:17.000000', 'consum', 0.0219, 'lps'),
	(425917, 123, '2015-03-01 01:06:18.000000', 'consum', 0.0213, 'lps'),
	(425918, 123, '2015-03-01 01:06:19.000000', 'consum', 0.0214, 'lps'),
	(425919, 123, '2015-03-01 01:06:20.000000', 'consum', 0.0219, 'lps'),
	(425920, 123, '2015-03-01 01:06:21.000000', 'consum', 0.0219, 'lps'),
	(425921, 123, '2015-03-01 01:06:22.000000', 'consum', 0.0217, 'lps'),
	(425922, 123, '2015-03-01 01:06:23.000000', 'consum', 0.0215, 'lps'),
	(425923, 123, '2015-03-01 01:06:24.000000', 'consum', 0.0218, 'lps'),
	(425924, 123, '2015-03-01 01:06:25.000000', 'consum', 0.0220, 'lps'),
	(425925, 123, '2015-03-01 01:06:26.000000', 'consum', 0.0212, 'lps'),
	(425926, 123, '2015-03-01 01:06:27.000000', 'consum', 0.0215, 'lps'),
	(425927, 123, '2015-03-01 01:06:28.000000', 'consum', 0.0219, 'lps'),
	(425928, 123, '2015-03-01 01:06:29.000000', 'consum', 0.0211, 'lps'),
	(425929, 123, '2015-03-01 01:06:30.000000', 'consum', 0.0217, 'lps'),
	(425930, 123, '2015-03-01 01:06:31.000000', 'consum', 0.0216, 'lps'),
	(425931, 123, '2015-03-01 01:06:32.000000', 'consum', 0.0221, 'lps'),
	(425932, 123, '2015-03-01 01:06:33.000000', 'consum', 0.0222, 'lps'),
	(425933, 123, '2015-03-01 01:06:34.000000', 'consum', 0.0210, 'lps'),
	(425934, 123, '2015-03-01 01:06:35.000000', 'consum', 0.0213, 'lps'),
	(425935, 123, '2015-03-01 01:06:36.000000', 'consum', 0.0213, 'lps'),
	(425936, 123, '2015-03-01 01:06:37.000000', 'consum', 0.0215, 'lps'),
	(425937, 123, '2015-03-01 01:06:38.000000', 'consum', 0.0215, 'lps'),
	(425938, 123, '2015-03-01 01:06:39.000000', 'consum', 0.0220, 'lps'),
	(425939, 123, '2015-03-01 01:06:40.000000', 'consum', 0.0219, 'lps'),
	(425940, 123, '2015-03-01 01:06:41.000000', 'consum', 0.0213, 'lps'),
	(425941, 123, '2015-03-01 01:06:42.000000', 'consum', 0.0222, 'lps'),
	(425942, 123, '2015-03-01 01:06:43.000000', 'consum', 0.0213, 'lps'),
	(425943, 123, '2015-03-01 01:06:44.000000', 'consum', 0.0215, 'lps'),
	(425944, 123, '2015-03-01 01:06:45.000000', 'consum', 0.0212, 'lps'),
	(425945, 123, '2015-03-01 01:06:46.000000', 'consum', 0.0218, 'lps'),
	(425946, 123, '2015-03-01 01:06:47.000000', 'consum', 0.0220, 'lps'),
	(425947, 123, '2015-03-01 01:06:48.000000', 'consum', 0.0212, 'lps'),
	(425948, 123, '2015-03-01 01:06:49.000000', 'consum', 0.0215, 'lps'),
	(425949, 123, '2015-03-01 01:06:50.000000', 'consum', 0.0219, 'lps'),
	(425950, 123, '2015-03-01 01:06:51.000000', 'consum', 0.0211, 'lps'),
	(425951, 123, '2015-03-01 01:06:52.000000', 'consum', 0.0215, 'lps'),
	(425952, 123, '2015-03-01 01:06:53.000000', 'consum', 0.0221, 'lps'),
	(425953, 123, '2015-03-01 01:06:54.000000', 'consum', 0.0222, 'lps'),
	(425954, 123, '2015-03-01 01:06:55.000000', 'consum', 0.0212, 'lps'),
	(425955, 123, '2015-03-01 01:06:56.000000', 'consum', 0.0210, 'lps'),
	(425956, 123, '2015-03-01 01:06:57.000000', 'consum', 0.0218, 'lps'),
	(425957, 123, '2015-03-01 01:06:58.000000', 'consum', 0.0213, 'lps'),
	(425958, 123, '2015-03-01 01:06:59.000000', 'consum', 0.0213, 'lps'),
	(425959, 123, '2015-03-01 01:07:00.000000', 'consum', 0.0217, 'lps'),
	(425960, 123, '2015-03-01 01:07:01.000000', 'consum', 0.0211, 'lps'),
	(425961, 123, '2015-03-01 01:07:02.000000', 'consum', 0.0219, 'lps'),
	(425962, 123, '2015-03-01 01:07:03.000000', 'consum', 0.0215, 'lps'),
	(425963, 123, '2015-03-01 01:07:04.000000', 'consum', 0.0220, 'lps'),
	(425964, 123, '2015-03-01 01:07:05.000000', 'consum', 0.0222, 'lps'),
	(425965, 123, '2015-03-01 01:07:06.000000', 'consum', 0.0212, 'lps'),
	(425966, 123, '2015-03-01 01:07:07.000000', 'consum', 0.0213, 'lps'),
	(425967, 123, '2015-03-01 01:07:08.000000', 'consum', 0.0219, 'lps'),
	(425968, 123, '2015-03-01 01:07:09.000000', 'consum', 0.0222, 'lps'),
	(425969, 123, '2015-03-01 01:07:10.000000', 'consum', 0.0217, 'lps'),
	(425970, 123, '2015-03-01 01:07:11.000000', 'consum', 0.0222, 'lps'),
	(425971, 123, '2015-03-01 01:07:12.000000', 'consum', 0.0222, 'lps'),
	(425972, 123, '2015-03-01 01:07:13.000000', 'consum', 0.0210, 'lps'),
	(425973, 123, '2015-03-01 01:07:14.000000', 'consum', 0.0214, 'lps'),
	(425974, 123, '2015-03-01 01:07:15.000000', 'consum', 0.0218, 'lps'),
	(425975, 123, '2015-03-01 01:07:16.000000', 'consum', 0.0212, 'lps'),
	(425976, 123, '2015-03-01 01:07:17.000000', 'consum', 0.0210, 'lps'),
	(425977, 123, '2015-03-01 01:07:18.000000', 'consum', 0.0218, 'lps'),
	(425978, 123, '2015-03-01 01:07:19.000000', 'consum', 0.0212, 'lps'),
	(425979, 123, '2015-03-01 01:07:20.000000', 'consum', 0.0210, 'lps'),
	(425980, 123, '2015-03-01 01:07:21.000000', 'consum', 0.0218, 'lps'),
	(425981, 123, '2015-03-01 01:07:22.000000', 'consum', 0.0211, 'lps'),
	(425982, 123, '2015-03-01 01:07:23.000000', 'consum', 0.0218, 'lps'),
	(425983, 123, '2015-03-01 01:07:24.000000', 'consum', 0.0220, 'lps'),
	(425984, 123, '2015-03-01 01:07:25.000000', 'consum', 0.0222, 'lps'),
	(425985, 123, '2015-03-01 01:07:26.000000', 'consum', 0.0216, 'lps'),
	(425986, 123, '2015-03-01 01:07:27.000000', 'consum', 0.0218, 'lps'),
	(425987, 123, '2015-03-01 01:07:28.000000', 'consum', 0.0218, 'lps'),
	(425988, 123, '2015-03-01 01:07:29.000000', 'consum', 0.0214, 'lps'),
	(425989, 123, '2015-03-01 01:07:30.000000', 'consum', 0.0221, 'lps'),
	(425990, 123, '2015-03-01 01:07:31.000000', 'consum', 0.0215, 'lps'),
	(425991, 123, '2015-03-01 01:07:32.000000', 'consum', 0.0213, 'lps'),
	(425992, 123, '2015-03-01 01:07:33.000000', 'consum', 0.0210, 'lps'),
	(425993, 123, '2015-03-01 01:07:34.000000', 'consum', 0.0217, 'lps'),
	(425994, 123, '2015-03-01 01:07:35.000000', 'consum', 0.0220, 'lps'),
	(425995, 123, '2015-03-01 01:07:36.000000', 'consum', 0.0214, 'lps'),
	(425996, 123, '2015-03-01 01:07:37.000000', 'consum', 0.0213, 'lps'),
	(425997, 123, '2015-03-01 01:07:38.000000', 'consum', 0.0213, 'lps'),
	(425998, 123, '2015-03-01 01:07:39.000000', 'consum', 0.0218, 'lps'),
	(425999, 123, '2015-03-01 01:07:40.000000', 'consum', 0.0214, 'lps'),
	(426000, 123, '2015-03-01 01:07:41.000000', 'consum', 0.0218, 'lps'),
	(426001, 123, '2015-03-01 01:07:42.000000', 'consum', 0.0215, 'lps'),
	(426002, 123, '2015-03-01 01:07:43.000000', 'consum', 0.0212, 'lps'),
	(426003, 123, '2015-03-01 01:07:44.000000', 'consum', 0.0219, 'lps'),
	(426004, 123, '2015-03-01 01:07:45.000000', 'consum', 0.0211, 'lps'),
	(426005, 123, '2015-03-01 01:07:46.000000', 'consum', 0.0212, 'lps'),
	(426006, 123, '2015-03-01 01:07:47.000000', 'consum', 0.0218, 'lps'),
	(426007, 123, '2015-03-01 01:07:48.000000', 'consum', 0.0218, 'lps'),
	(426008, 123, '2015-03-01 01:07:49.000000', 'consum', 0.0216, 'lps'),
	(426009, 123, '2015-03-01 01:07:50.000000', 'consum', 0.0216, 'lps'),
	(426010, 123, '2015-03-01 01:07:51.000000', 'consum', 0.0222, 'lps'),
	(426011, 123, '2015-03-01 01:07:52.000000', 'consum', 0.0211, 'lps'),
	(426012, 123, '2015-03-01 01:07:53.000000', 'consum', 0.0222, 'lps'),
	(426013, 123, '2015-03-01 01:07:54.000000', 'consum', 0.0216, 'lps'),
	(426014, 123, '2015-03-01 01:07:55.000000', 'consum', 0.0215, 'lps'),
	(426015, 123, '2015-03-01 01:07:56.000000', 'consum', 0.0219, 'lps'),
	(426016, 123, '2015-03-01 01:07:57.000000', 'consum', 0.0215, 'lps'),
	(426017, 123, '2015-03-01 01:07:58.000000', 'consum', 0.0221, 'lps'),
	(426018, 123, '2015-03-01 01:07:59.000000', 'consum', 0.0211, 'lps'),
	(426019, 123, '2015-03-01 01:08:00.000000', 'consum', 0.0222, 'lps'),
	(426020, 123, '2015-03-01 01:08:01.000000', 'consum', 0.0215, 'lps'),
	(426021, 123, '2015-03-01 01:08:02.000000', 'consum', 0.0214, 'lps'),
	(426022, 123, '2015-03-01 01:08:03.000000', 'consum', 0.0216, 'lps'),
	(426023, 123, '2015-03-01 01:08:04.000000', 'consum', 0.0215, 'lps'),
	(426024, 123, '2015-03-01 01:08:05.000000', 'consum', 0.0217, 'lps'),
	(426025, 123, '2015-03-01 01:08:06.000000', 'consum', 0.0216, 'lps'),
	(426026, 123, '2015-03-01 01:08:07.000000', 'consum', 0.0222, 'lps'),
	(426027, 123, '2015-03-01 01:08:08.000000', 'consum', 0.0214, 'lps'),
	(426028, 123, '2015-03-01 01:08:09.000000', 'consum', 0.0217, 'lps'),
	(426029, 123, '2015-03-01 01:08:10.000000', 'consum', 0.0211, 'lps'),
	(426030, 123, '2015-03-01 01:08:11.000000', 'consum', 0.0219, 'lps'),
	(426031, 123, '2015-03-01 01:08:12.000000', 'consum', 0.0215, 'lps'),
	(426032, 123, '2015-03-01 01:08:13.000000', 'consum', 0.0220, 'lps'),
	(426033, 123, '2015-03-01 01:08:14.000000', 'consum', 0.0222, 'lps'),
	(426034, 123, '2015-03-01 01:08:15.000000', 'consum', 0.0211, 'lps'),
	(426035, 123, '2015-03-01 01:08:16.000000', 'consum', 0.0221, 'lps'),
	(426036, 123, '2015-03-01 01:08:17.000000', 'consum', 0.0211, 'lps'),
	(426037, 123, '2015-03-01 01:08:18.000000', 'consum', 0.0219, 'lps'),
	(426038, 123, '2015-03-01 01:08:19.000000', 'consum', 0.0214, 'lps'),
	(426039, 123, '2015-03-01 01:08:20.000000', 'consum', 0.0218, 'lps'),
	(426040, 123, '2015-03-01 01:08:21.000000', 'consum', 0.0213, 'lps'),
	(426041, 123, '2015-03-01 01:08:22.000000', 'consum', 0.0213, 'lps'),
	(426042, 123, '2015-03-01 01:08:23.000000', 'consum', 0.0216, 'lps'),
	(426043, 123, '2015-03-01 01:08:24.000000', 'consum', 0.0220, 'lps'),
	(426044, 123, '2015-03-01 01:08:25.000000', 'consum', 0.0215, 'lps'),
	(426045, 123, '2015-03-01 01:08:26.000000', 'consum', 0.0220, 'lps'),
	(426046, 123, '2015-03-01 01:08:27.000000', 'consum', 0.0221, 'lps'),
	(426047, 123, '2015-03-01 01:08:28.000000', 'consum', 0.0220, 'lps'),
	(426048, 123, '2015-03-01 01:08:29.000000', 'consum', 0.0214, 'lps'),
	(426049, 123, '2015-03-01 01:08:30.000000', 'consum', 0.0212, 'lps'),
	(426050, 123, '2015-03-01 01:08:31.000000', 'consum', 0.0211, 'lps'),
	(426051, 123, '2015-03-01 01:08:32.000000', 'consum', 0.0222, 'lps'),
	(426052, 123, '2015-03-01 01:08:33.000000', 'consum', 0.0217, 'lps'),
	(426053, 123, '2015-03-01 01:08:34.000000', 'consum', 0.0219, 'lps'),
	(426054, 123, '2015-03-01 01:08:35.000000', 'consum', 0.0212, 'lps'),
	(426055, 123, '2015-03-01 01:08:36.000000', 'consum', 0.0219, 'lps'),
	(426056, 123, '2015-03-01 01:08:37.000000', 'consum', 0.0222, 'lps'),
	(426057, 123, '2015-03-01 01:08:38.000000', 'consum', 0.0218, 'lps'),
	(426058, 123, '2015-03-01 01:08:39.000000', 'consum', 0.0217, 'lps'),
	(426059, 123, '2015-03-01 01:08:40.000000', 'consum', 0.0219, 'lps'),
	(426060, 123, '2015-03-01 01:08:41.000000', 'consum', 0.0221, 'lps'),
	(426061, 123, '2015-03-01 01:08:42.000000', 'consum', 0.0215, 'lps'),
	(426062, 123, '2015-03-01 01:08:43.000000', 'consum', 0.0213, 'lps'),
	(426063, 123, '2015-03-01 01:08:44.000000', 'consum', 0.0213, 'lps'),
	(426064, 123, '2015-03-01 01:08:45.000000', 'consum', 0.0214, 'lps'),
	(426065, 123, '2015-03-01 01:08:46.000000', 'consum', 0.0222, 'lps'),
	(426066, 123, '2015-03-01 01:08:47.000000', 'consum', 0.0219, 'lps'),
	(426067, 123, '2015-03-01 01:08:48.000000', 'consum', 0.0222, 'lps'),
	(426068, 123, '2015-03-01 01:08:49.000000', 'consum', 0.0216, 'lps'),
	(426069, 123, '2015-03-01 01:08:50.000000', 'consum', 0.0217, 'lps'),
	(426070, 123, '2015-03-01 01:08:51.000000', 'consum', 0.0217, 'lps'),
	(426071, 123, '2015-03-01 01:08:52.000000', 'consum', 0.0221, 'lps'),
	(426072, 123, '2015-03-01 01:08:53.000000', 'consum', 0.0220, 'lps'),
	(426073, 123, '2015-03-01 01:08:54.000000', 'consum', 0.0216, 'lps'),
	(426074, 123, '2015-03-01 01:08:55.000000', 'consum', 0.0211, 'lps'),
	(426075, 123, '2015-03-01 01:08:56.000000', 'consum', 0.0220, 'lps'),
	(426076, 123, '2015-03-01 01:08:57.000000', 'consum', 0.0222, 'lps'),
	(426077, 123, '2015-03-01 01:08:58.000000', 'consum', 0.0214, 'lps'),
	(426078, 123, '2015-03-01 01:08:59.000000', 'consum', 0.0219, 'lps'),
	(426079, 123, '2015-03-01 01:09:00.000000', 'consum', 0.0217, 'lps'),
	(426080, 123, '2015-03-01 01:09:01.000000', 'consum', 0.0218, 'lps'),
	(426081, 123, '2015-03-01 01:09:02.000000', 'consum', 0.0217, 'lps'),
	(426082, 123, '2015-03-01 01:09:03.000000', 'consum', 0.0220, 'lps'),
	(426083, 123, '2015-03-01 01:09:04.000000', 'consum', 0.0216, 'lps'),
	(426084, 123, '2015-03-01 01:09:05.000000', 'consum', 0.0212, 'lps'),
	(426085, 123, '2015-03-01 01:09:06.000000', 'consum', 0.0212, 'lps'),
	(426086, 123, '2015-03-01 01:09:07.000000', 'consum', 0.0216, 'lps'),
	(426087, 123, '2015-03-01 01:09:08.000000', 'consum', 0.0220, 'lps'),
	(426088, 123, '2015-03-01 01:09:09.000000', 'consum', 0.0219, 'lps'),
	(426089, 123, '2015-03-01 01:09:10.000000', 'consum', 0.0211, 'lps'),
	(426090, 123, '2015-03-01 01:09:11.000000', 'consum', 0.0213, 'lps'),
	(426091, 123, '2015-03-01 01:09:12.000000', 'consum', 0.0212, 'lps'),
	(426092, 123, '2015-03-01 01:09:13.000000', 'consum', 0.0212, 'lps'),
	(426093, 123, '2015-03-01 01:09:14.000000', 'consum', 0.0212, 'lps'),
	(426094, 123, '2015-03-01 01:09:15.000000', 'consum', 0.0215, 'lps'),
	(426095, 123, '2015-03-01 01:09:16.000000', 'consum', 0.0219, 'lps'),
	(426096, 123, '2015-03-01 01:09:17.000000', 'consum', 0.0211, 'lps'),
	(426097, 123, '2015-03-01 01:09:18.000000', 'consum', 0.0216, 'lps'),
	(426098, 123, '2015-03-01 01:09:19.000000', 'consum', 0.0211, 'lps'),
	(426099, 123, '2015-03-01 01:09:20.000000', 'consum', 0.0212, 'lps'),
	(426100, 123, '2015-03-01 01:09:21.000000', 'consum', 0.0218, 'lps'),
	(426101, 123, '2015-03-01 01:09:22.000000', 'consum', 0.0218, 'lps'),
	(426102, 123, '2015-03-01 01:09:23.000000', 'consum', 0.0214, 'lps'),
	(426103, 123, '2015-03-01 01:09:24.000000', 'consum', 0.0219, 'lps'),
	(426104, 123, '2015-03-01 01:09:25.000000', 'consum', 0.0217, 'lps'),
	(426105, 123, '2015-03-01 01:09:26.000000', 'consum', 0.0218, 'lps'),
	(426106, 123, '2015-03-01 01:09:27.000000', 'consum', 0.0219, 'lps'),
	(426107, 123, '2015-03-01 01:09:28.000000', 'consum', 0.0217, 'lps'),
	(426108, 123, '2015-03-01 01:09:29.000000', 'consum', 0.0218, 'lps'),
	(426109, 123, '2015-03-01 01:09:30.000000', 'consum', 0.0216, 'lps'),
	(426110, 123, '2015-03-01 01:09:31.000000', 'consum', 0.0215, 'lps'),
	(426111, 123, '2015-03-01 01:09:32.000000', 'consum', 0.0220, 'lps'),
	(426112, 123, '2015-03-01 01:09:33.000000', 'consum', 0.0219, 'lps'),
	(426113, 123, '2015-03-01 01:09:34.000000', 'consum', 0.0211, 'lps'),
	(426114, 123, '2015-03-01 01:09:35.000000', 'consum', 0.0217, 'lps'),
	(426115, 123, '2015-03-01 01:09:36.000000', 'consum', 0.0215, 'lps'),
	(426116, 123, '2015-03-01 01:09:37.000000', 'consum', 0.0213, 'lps'),
	(426117, 123, '2015-03-01 01:09:38.000000', 'consum', 0.0213, 'lps'),
	(426118, 123, '2015-03-01 01:09:39.000000', 'consum', 0.0216, 'lps'),
	(426119, 123, '2015-03-01 01:09:40.000000', 'consum', 0.0219, 'lps'),
	(426120, 123, '2015-03-01 01:09:41.000000', 'consum', 0.0212, 'lps'),
	(426121, 123, '2015-03-01 01:09:42.000000', 'consum', 0.0220, 'lps'),
	(426122, 123, '2015-03-01 01:09:43.000000', 'consum', 0.0216, 'lps'),
	(426123, 123, '2015-03-01 01:09:44.000000', 'consum', 0.0211, 'lps'),
	(426124, 123, '2015-03-01 01:09:45.000000', 'consum', 0.0221, 'lps'),
	(426125, 123, '2015-03-01 01:09:46.000000', 'consum', 0.0212, 'lps'),
	(426126, 123, '2015-03-01 01:09:47.000000', 'consum', 0.0213, 'lps'),
	(426127, 123, '2015-03-01 01:09:48.000000', 'consum', 0.0221, 'lps'),
	(426128, 123, '2015-03-01 01:09:49.000000', 'consum', 0.0215, 'lps'),
	(426129, 123, '2015-03-01 01:09:50.000000', 'consum', 0.0219, 'lps'),
	(426130, 123, '2015-03-01 01:09:51.000000', 'consum', 0.0211, 'lps'),
	(426131, 123, '2015-03-01 01:09:52.000000', 'consum', 0.0215, 'lps'),
	(426132, 123, '2015-03-01 01:09:53.000000', 'consum', 0.0218, 'lps'),
	(426133, 123, '2015-03-01 01:09:54.000000', 'consum', 0.0213, 'lps'),
	(426134, 123, '2015-03-01 01:09:55.000000', 'consum', 0.0213, 'lps'),
	(426135, 123, '2015-03-01 01:09:56.000000', 'consum', 0.0216, 'lps'),
	(426136, 123, '2015-03-01 01:09:57.000000', 'consum', 0.0218, 'lps'),
	(426137, 123, '2015-03-01 01:09:58.000000', 'consum', 0.0222, 'lps'),
	(426138, 123, '2015-03-01 01:09:59.000000', 'consum', 0.0220, 'lps'),
	(426139, 123, '2015-03-01 01:10:00.000000', 'consum', 0.0212, 'lps'),
	(426140, 123, '2015-03-01 01:10:01.000000', 'consum', 0.0215, 'lps'),
	(426141, 123, '2015-03-01 01:10:02.000000', 'consum', 0.0215, 'lps'),
	(426142, 123, '2015-03-01 01:10:03.000000', 'consum', 0.0210, 'lps'),
	(426143, 123, '2015-03-01 01:10:04.000000', 'consum', 0.0222, 'lps'),
	(426144, 123, '2015-03-01 01:10:05.000000', 'consum', 0.0218, 'lps'),
	(426145, 123, '2015-03-01 01:10:06.000000', 'consum', 0.0216, 'lps'),
	(426146, 123, '2015-03-01 01:10:07.000000', 'consum', 0.0216, 'lps'),
	(426147, 123, '2015-03-01 01:10:08.000000', 'consum', 0.0210, 'lps'),
	(426148, 123, '2015-03-01 01:10:09.000000', 'consum', 0.0216, 'lps'),
	(426149, 123, '2015-03-01 01:10:10.000000', 'consum', 0.0217, 'lps'),
	(426150, 123, '2015-03-01 01:10:11.000000', 'consum', 0.0212, 'lps'),
	(426151, 123, '2015-03-01 01:10:12.000000', 'consum', 0.0213, 'lps'),
	(426152, 123, '2015-03-01 01:10:13.000000', 'consum', 0.0222, 'lps'),
	(426153, 123, '2015-03-01 01:10:14.000000', 'consum', 0.0219, 'lps'),
	(426154, 123, '2015-03-01 01:10:15.000000', 'consum', 0.0222, 'lps'),
	(426155, 123, '2015-03-01 01:10:16.000000', 'consum', 0.0217, 'lps'),
	(426156, 123, '2015-03-01 01:10:17.000000', 'consum', 0.0221, 'lps'),
	(426157, 123, '2015-03-01 01:10:18.000000', 'consum', 0.0220, 'lps'),
	(426158, 123, '2015-03-01 01:10:19.000000', 'consum', 0.0213, 'lps'),
	(426159, 123, '2015-03-01 01:10:20.000000', 'consum', 0.0220, 'lps'),
	(426160, 123, '2015-03-01 01:10:21.000000', 'consum', 0.0215, 'lps'),
	(426161, 123, '2015-03-01 01:10:22.000000', 'consum', 0.0217, 'lps'),
	(426162, 123, '2015-03-01 01:10:23.000000', 'consum', 0.0219, 'lps'),
	(426163, 123, '2015-03-01 01:10:24.000000', 'consum', 0.0221, 'lps'),
	(426164, 123, '2015-03-01 01:10:25.000000', 'consum', 0.0212, 'lps'),
	(426165, 123, '2015-03-01 01:10:26.000000', 'consum', 0.0213, 'lps'),
	(426166, 123, '2015-03-01 01:10:27.000000', 'consum', 0.0220, 'lps'),
	(426167, 123, '2015-03-01 01:10:28.000000', 'consum', 0.0213, 'lps'),
	(426168, 123, '2015-03-01 01:10:29.000000', 'consum', 0.0220, 'lps'),
	(426169, 123, '2015-03-01 01:10:30.000000', 'consum', 0.0214, 'lps'),
	(426170, 123, '2015-03-01 01:10:31.000000', 'consum', 0.0212, 'lps'),
	(426171, 123, '2015-03-01 01:10:32.000000', 'consum', 0.0211, 'lps'),
	(426172, 123, '2015-03-01 01:10:33.000000', 'consum', 0.0219, 'lps'),
	(426173, 123, '2015-03-01 01:10:34.000000', 'consum', 0.0217, 'lps'),
	(426174, 123, '2015-03-01 01:10:35.000000', 'consum', 0.0217, 'lps'),
	(426175, 123, '2015-03-01 01:10:36.000000', 'consum', 0.0213, 'lps'),
	(426176, 123, '2015-03-01 01:10:37.000000', 'consum', 0.0218, 'lps'),
	(426177, 123, '2015-03-01 01:10:38.000000', 'consum', 0.0214, 'lps'),
	(426178, 123, '2015-03-01 01:10:39.000000', 'consum', 0.0219, 'lps'),
	(426179, 123, '2015-03-01 01:10:40.000000', 'consum', 0.0216, 'lps'),
	(426180, 123, '2015-03-01 01:10:41.000000', 'consum', 0.0215, 'lps'),
	(426181, 123, '2015-03-01 01:10:42.000000', 'consum', 0.0216, 'lps'),
	(426182, 123, '2015-03-01 01:10:43.000000', 'consum', 0.0215, 'lps'),
	(426183, 123, '2015-03-01 01:10:44.000000', 'consum', 0.0218, 'lps'),
	(426184, 123, '2015-03-01 01:10:45.000000', 'consum', 0.0210, 'lps'),
	(426185, 123, '2015-03-01 01:10:46.000000', 'consum', 0.0210, 'lps'),
	(426186, 123, '2015-03-01 01:10:47.000000', 'consum', 0.0213, 'lps'),
	(426187, 123, '2015-03-01 01:10:48.000000', 'consum', 0.0212, 'lps'),
	(426188, 123, '2015-03-01 01:10:49.000000', 'consum', 0.0212, 'lps'),
	(426189, 123, '2015-03-01 01:10:50.000000', 'consum', 0.0216, 'lps'),
	(426190, 123, '2015-03-01 01:10:51.000000', 'consum', 0.0218, 'lps'),
	(426191, 123, '2015-03-01 01:10:52.000000', 'consum', 0.0221, 'lps'),
	(426192, 123, '2015-03-01 01:10:53.000000', 'consum', 0.0214, 'lps'),
	(426193, 123, '2015-03-01 01:10:54.000000', 'consum', 0.0212, 'lps'),
	(426194, 123, '2015-03-01 01:10:55.000000', 'consum', 0.0222, 'lps'),
	(426195, 123, '2015-03-01 01:10:56.000000', 'consum', 0.0214, 'lps'),
	(426196, 123, '2015-03-01 01:10:57.000000', 'consum', 0.0217, 'lps'),
	(426197, 123, '2015-03-01 01:10:58.000000', 'consum', 0.0210, 'lps'),
	(426198, 123, '2015-03-01 01:10:59.000000', 'consum', 0.0216, 'lps'),
	(426199, 123, '2015-03-01 01:11:00.000000', 'consum', 0.0214, 'lps'),
	(426200, 123, '2015-03-01 01:11:01.000000', 'consum', 0.0211, 'lps'),
	(426201, 123, '2015-03-01 01:11:02.000000', 'consum', 0.0217, 'lps'),
	(426202, 123, '2015-03-01 01:11:03.000000', 'consum', 0.0215, 'lps'),
	(426203, 123, '2015-03-01 01:11:04.000000', 'consum', 0.0216, 'lps'),
	(426204, 123, '2015-03-01 01:11:05.000000', 'consum', 0.0211, 'lps'),
	(426205, 123, '2015-03-01 01:11:06.000000', 'consum', 0.0211, 'lps'),
	(426206, 123, '2015-03-01 01:11:07.000000', 'consum', 0.0211, 'lps'),
	(426207, 123, '2015-03-01 01:11:08.000000', 'consum', 0.0213, 'lps'),
	(426208, 123, '2015-03-01 01:11:09.000000', 'consum', 0.0210, 'lps'),
	(426209, 123, '2015-03-01 01:11:10.000000', 'consum', 0.0214, 'lps'),
	(426210, 123, '2015-03-01 01:11:11.000000', 'consum', 0.0217, 'lps'),
	(426211, 123, '2015-03-01 01:11:12.000000', 'consum', 0.0210, 'lps'),
	(426212, 123, '2015-03-01 01:11:13.000000', 'consum', 0.0213, 'lps'),
	(426213, 123, '2015-03-01 01:11:14.000000', 'consum', 0.0213, 'lps'),
	(426214, 123, '2015-03-01 01:11:15.000000', 'consum', 0.0217, 'lps'),
	(426215, 123, '2015-03-01 01:11:16.000000', 'consum', 0.0212, 'lps'),
	(426216, 123, '2015-03-01 01:11:17.000000', 'consum', 0.0213, 'lps'),
	(426217, 123, '2015-03-01 01:11:18.000000', 'consum', 0.0217, 'lps'),
	(426218, 123, '2015-03-01 01:11:19.000000', 'consum', 0.0213, 'lps'),
	(426219, 123, '2015-03-01 01:11:20.000000', 'consum', 0.0215, 'lps'),
	(426220, 123, '2015-03-01 01:11:21.000000', 'consum', 0.0213, 'lps'),
	(426221, 123, '2015-03-01 01:11:22.000000', 'consum', 0.0212, 'lps'),
	(426222, 123, '2015-03-01 01:11:23.000000', 'consum', 0.0222, 'lps'),
	(426223, 123, '2015-03-01 01:11:24.000000', 'consum', 0.0216, 'lps'),
	(426224, 123, '2015-03-01 01:11:25.000000', 'consum', 0.0216, 'lps'),
	(426225, 123, '2015-03-01 01:11:26.000000', 'consum', 0.0221, 'lps'),
	(426226, 123, '2015-03-01 01:11:27.000000', 'consum', 0.0210, 'lps'),
	(426227, 123, '2015-03-01 01:11:28.000000', 'consum', 0.0217, 'lps'),
	(426228, 123, '2015-03-01 01:11:29.000000', 'consum', 0.0219, 'lps'),
	(426229, 123, '2015-03-01 01:11:30.000000', 'consum', 0.0222, 'lps'),
	(426230, 123, '2015-03-01 01:11:31.000000', 'consum', 0.0218, 'lps'),
	(426231, 123, '2015-03-01 01:11:32.000000', 'consum', 0.0214, 'lps'),
	(426232, 123, '2015-03-01 01:11:33.000000', 'consum', 0.0220, 'lps'),
	(426233, 123, '2015-03-01 01:11:34.000000', 'consum', 0.0220, 'lps'),
	(426234, 123, '2015-03-01 01:11:35.000000', 'consum', 0.0221, 'lps'),
	(426235, 123, '2015-03-01 01:11:36.000000', 'consum', 0.0220, 'lps'),
	(426236, 123, '2015-03-01 01:11:37.000000', 'consum', 0.0217, 'lps'),
	(426237, 123, '2015-03-01 01:11:38.000000', 'consum', 0.0214, 'lps'),
	(426238, 123, '2015-03-01 01:11:39.000000', 'consum', 0.0221, 'lps'),
	(426239, 123, '2015-03-01 01:11:40.000000', 'consum', 0.0217, 'lps'),
	(426240, 123, '2015-03-01 01:11:41.000000', 'consum', 0.0212, 'lps'),
	(426241, 123, '2015-03-01 01:11:42.000000', 'consum', 0.0211, 'lps'),
	(426242, 123, '2015-03-01 01:11:43.000000', 'consum', 0.0210, 'lps'),
	(426243, 123, '2015-03-01 01:11:44.000000', 'consum', 0.0222, 'lps'),
	(426244, 123, '2015-03-01 01:11:45.000000', 'consum', 0.0216, 'lps'),
	(426245, 123, '2015-03-01 01:11:46.000000', 'consum', 0.0221, 'lps'),
	(426246, 123, '2015-03-01 01:11:47.000000', 'consum', 0.0219, 'lps'),
	(426247, 123, '2015-03-01 01:11:48.000000', 'consum', 0.0221, 'lps'),
	(426248, 123, '2015-03-01 01:11:49.000000', 'consum', 0.0216, 'lps'),
	(426249, 123, '2015-03-01 01:11:50.000000', 'consum', 0.0217, 'lps'),
	(426250, 123, '2015-03-01 01:11:51.000000', 'consum', 0.0217, 'lps'),
	(426251, 123, '2015-03-01 01:11:52.000000', 'consum', 0.0210, 'lps'),
	(426252, 123, '2015-03-01 01:11:53.000000', 'consum', 0.0217, 'lps'),
	(426253, 123, '2015-03-01 01:11:54.000000', 'consum', 0.0217, 'lps'),
	(426254, 123, '2015-03-01 01:11:55.000000', 'consum', 0.0213, 'lps'),
	(426255, 123, '2015-03-01 01:11:56.000000', 'consum', 0.0219, 'lps'),
	(426256, 123, '2015-03-01 01:11:57.000000', 'consum', 0.0221, 'lps'),
	(426257, 123, '2015-03-01 01:11:58.000000', 'consum', 0.0213, 'lps'),
	(426258, 123, '2015-03-01 01:11:59.000000', 'consum', 0.0218, 'lps'),
	(426259, 123, '2015-03-01 01:12:00.000000', 'consum', 0.0216, 'lps'),
	(426260, 123, '2015-03-01 01:12:01.000000', 'consum', 0.0216, 'lps'),
	(426261, 123, '2015-03-01 01:12:02.000000', 'consum', 0.0222, 'lps'),
	(426262, 123, '2015-03-01 01:12:03.000000', 'consum', 0.0213, 'lps'),
	(426263, 123, '2015-03-01 01:12:04.000000', 'consum', 0.0217, 'lps'),
	(426264, 123, '2015-03-01 01:12:05.000000', 'consum', 0.0211, 'lps'),
	(426265, 123, '2015-03-01 01:12:06.000000', 'consum', 0.0220, 'lps'),
	(426266, 123, '2015-03-01 01:12:07.000000', 'consum', 0.0220, 'lps'),
	(426267, 123, '2015-03-01 01:12:08.000000', 'consum', 0.0217, 'lps'),
	(426268, 123, '2015-03-01 01:12:09.000000', 'consum', 0.0216, 'lps'),
	(426269, 123, '2015-03-01 01:12:10.000000', 'consum', 0.0220, 'lps'),
	(426270, 123, '2015-03-01 01:12:11.000000', 'consum', 0.0217, 'lps'),
	(426271, 123, '2015-03-01 01:12:12.000000', 'consum', 0.0216, 'lps'),
	(426272, 123, '2015-03-01 01:12:13.000000', 'consum', 0.0220, 'lps'),
	(426273, 123, '2015-03-01 01:12:14.000000', 'consum', 0.0215, 'lps'),
	(426274, 123, '2015-03-01 01:12:15.000000', 'consum', 0.0218, 'lps'),
	(426275, 123, '2015-03-01 01:12:16.000000', 'consum', 0.0222, 'lps'),
	(426276, 123, '2015-03-01 01:12:17.000000', 'consum', 0.0210, 'lps'),
	(426277, 123, '2015-03-01 01:12:18.000000', 'consum', 0.0211, 'lps'),
	(426278, 123, '2015-03-01 01:12:19.000000', 'consum', 0.0217, 'lps'),
	(426279, 123, '2015-03-01 01:12:20.000000', 'consum', 0.0215, 'lps'),
	(426280, 123, '2015-03-01 01:12:21.000000', 'consum', 0.0214, 'lps'),
	(426281, 123, '2015-03-01 01:12:22.000000', 'consum', 0.0218, 'lps'),
	(426282, 123, '2015-03-01 01:12:23.000000', 'consum', 0.0210, 'lps'),
	(426283, 123, '2015-03-01 01:12:24.000000', 'consum', 0.0213, 'lps'),
	(426284, 123, '2015-03-01 01:12:25.000000', 'consum', 0.0211, 'lps'),
	(426285, 123, '2015-03-01 01:12:26.000000', 'consum', 0.0221, 'lps'),
	(426286, 123, '2015-03-01 01:12:27.000000', 'consum', 0.0211, 'lps'),
	(426287, 123, '2015-03-01 01:12:28.000000', 'consum', 0.0220, 'lps'),
	(426288, 123, '2015-03-01 01:12:29.000000', 'consum', 0.0220, 'lps'),
	(426289, 123, '2015-03-01 01:12:30.000000', 'consum', 0.0216, 'lps'),
	(426290, 123, '2015-03-01 01:12:31.000000', 'consum', 0.0212, 'lps'),
	(426291, 123, '2015-03-01 01:12:32.000000', 'consum', 0.0215, 'lps'),
	(426292, 123, '2015-03-01 01:12:33.000000', 'consum', 0.0217, 'lps'),
	(426293, 123, '2015-03-01 01:12:34.000000', 'consum', 0.0217, 'lps'),
	(426294, 123, '2015-03-01 01:12:35.000000', 'consum', 0.0211, 'lps'),
	(426295, 123, '2015-03-01 01:12:36.000000', 'consum', 0.0210, 'lps'),
	(426296, 123, '2015-03-01 01:12:37.000000', 'consum', 0.0219, 'lps'),
	(426297, 123, '2015-03-01 01:12:38.000000', 'consum', 0.0215, 'lps'),
	(426298, 123, '2015-03-01 01:12:39.000000', 'consum', 0.0210, 'lps'),
	(426299, 123, '2015-03-01 01:12:40.000000', 'consum', 0.0222, 'lps'),
	(426300, 123, '2015-03-01 01:12:41.000000', 'consum', 0.0219, 'lps'),
	(426301, 123, '2015-03-01 01:12:42.000000', 'consum', 0.0221, 'lps'),
	(426302, 123, '2015-03-01 01:12:43.000000', 'consum', 0.0222, 'lps'),
	(426303, 123, '2015-03-01 01:12:44.000000', 'consum', 0.0214, 'lps'),
	(426304, 123, '2015-03-01 01:12:45.000000', 'consum', 0.0220, 'lps'),
	(426305, 123, '2015-03-01 01:12:46.000000', 'consum', 0.0220, 'lps'),
	(426306, 123, '2015-03-01 01:12:47.000000', 'consum', 0.0221, 'lps'),
	(426307, 123, '2015-03-01 01:12:48.000000', 'consum', 0.0222, 'lps'),
	(426308, 123, '2015-03-01 01:12:49.000000', 'consum', 0.0211, 'lps'),
	(426309, 123, '2015-03-01 01:12:50.000000', 'consum', 0.0218, 'lps'),
	(426310, 123, '2015-03-01 01:12:51.000000', 'consum', 0.0221, 'lps'),
	(426311, 123, '2015-03-01 01:12:52.000000', 'consum', 0.0215, 'lps'),
	(426312, 123, '2015-03-01 01:12:53.000000', 'consum', 0.0217, 'lps'),
	(426313, 123, '2015-03-01 01:12:54.000000', 'consum', 0.0216, 'lps'),
	(426314, 123, '2015-03-01 01:12:55.000000', 'consum', 0.0222, 'lps'),
	(426315, 123, '2015-03-01 01:12:56.000000', 'consum', 0.0212, 'lps'),
	(426316, 123, '2015-03-01 01:12:57.000000', 'consum', 0.0210, 'lps'),
	(426317, 123, '2015-03-01 01:12:58.000000', 'consum', 0.0218, 'lps'),
	(426318, 123, '2015-03-01 01:12:59.000000', 'consum', 0.0213, 'lps'),
	(426319, 123, '2015-03-01 01:13:00.000000', 'consum', 0.0212, 'lps'),
	(426320, 123, '2015-03-01 01:13:01.000000', 'consum', 0.0214, 'lps'),
	(426321, 123, '2015-03-01 01:13:02.000000', 'consum', 0.0211, 'lps'),
	(426322, 123, '2015-03-01 01:13:03.000000', 'consum', 0.0215, 'lps'),
	(426323, 123, '2015-03-01 01:13:04.000000', 'consum', 0.0220, 'lps'),
	(426324, 123, '2015-03-01 01:13:05.000000', 'consum', 0.0218, 'lps'),
	(426325, 123, '2015-03-01 01:13:06.000000', 'consum', 0.0222, 'lps'),
	(426326, 123, '2015-03-01 01:13:07.000000', 'consum', 0.0219, 'lps'),
	(426327, 123, '2015-03-01 01:13:08.000000', 'consum', 0.0220, 'lps'),
	(426328, 123, '2015-03-01 01:13:09.000000', 'consum', 0.0210, 'lps'),
	(426329, 123, '2015-03-01 01:13:10.000000', 'consum', 0.0216, 'lps'),
	(426330, 123, '2015-03-01 01:13:11.000000', 'consum', 0.0218, 'lps'),
	(426331, 123, '2015-03-01 01:13:12.000000', 'consum', 0.0218, 'lps'),
	(426332, 123, '2015-03-01 01:13:13.000000', 'consum', 0.0213, 'lps'),
	(426333, 123, '2015-03-01 01:13:14.000000', 'consum', 0.0216, 'lps'),
	(426334, 123, '2015-03-01 01:13:15.000000', 'consum', 0.0216, 'lps'),
	(426335, 123, '2015-03-01 01:13:16.000000', 'consum', 0.0210, 'lps'),
	(426336, 123, '2015-03-01 01:13:17.000000', 'consum', 0.0221, 'lps'),
	(426337, 123, '2015-03-01 01:13:18.000000', 'consum', 0.0213, 'lps'),
	(426338, 123, '2015-03-01 01:13:19.000000', 'consum', 0.0216, 'lps'),
	(426339, 123, '2015-03-01 01:13:20.000000', 'consum', 0.0220, 'lps'),
	(426340, 123, '2015-03-01 01:13:21.000000', 'consum', 0.0215, 'lps'),
	(426341, 123, '2015-03-01 01:13:22.000000', 'consum', 0.0220, 'lps'),
	(426342, 123, '2015-03-01 01:13:23.000000', 'consum', 0.0220, 'lps'),
	(426343, 123, '2015-03-01 01:13:24.000000', 'consum', 0.0217, 'lps'),
	(426344, 123, '2015-03-01 01:13:25.000000', 'consum', 0.0215, 'lps'),
	(426345, 123, '2015-03-01 01:13:26.000000', 'consum', 0.0213, 'lps'),
	(426346, 123, '2015-03-01 01:13:27.000000', 'consum', 0.0210, 'lps'),
	(426347, 123, '2015-03-01 01:13:28.000000', 'consum', 0.0217, 'lps'),
	(426348, 123, '2015-03-01 01:13:29.000000', 'consum', 0.0217, 'lps'),
	(426349, 123, '2015-03-01 01:13:30.000000', 'consum', 0.0213, 'lps'),
	(426350, 123, '2015-03-01 01:13:31.000000', 'consum', 0.0217, 'lps'),
	(426351, 123, '2015-03-01 01:13:32.000000', 'consum', 0.0213, 'lps'),
	(426352, 123, '2015-03-01 01:13:33.000000', 'consum', 0.0214, 'lps'),
	(426353, 123, '2015-03-01 01:13:34.000000', 'consum', 0.0222, 'lps'),
	(426354, 123, '2015-03-01 01:13:35.000000', 'consum', 0.0219, 'lps'),
	(426355, 123, '2015-03-01 01:13:36.000000', 'consum', 0.0221, 'lps'),
	(426356, 123, '2015-03-01 01:13:37.000000', 'consum', 0.0211, 'lps'),
	(426357, 123, '2015-03-01 01:13:38.000000', 'consum', 0.0211, 'lps'),
	(426358, 123, '2015-03-01 01:13:39.000000', 'consum', 0.0211, 'lps'),
	(426359, 123, '2015-03-01 01:13:40.000000', 'consum', 0.0214, 'lps'),
	(426360, 123, '2015-03-01 01:13:41.000000', 'consum', 0.0214, 'lps'),
	(426361, 123, '2015-03-01 01:13:42.000000', 'consum', 0.0220, 'lps'),
	(426362, 123, '2015-03-01 01:13:43.000000', 'consum', 0.0222, 'lps'),
	(426363, 123, '2015-03-01 01:13:44.000000', 'consum', 0.0214, 'lps'),
	(426364, 123, '2015-03-01 01:13:45.000000', 'consum', 0.0218, 'lps'),
	(426365, 123, '2015-03-01 01:13:46.000000', 'consum', 0.0216, 'lps'),
	(426366, 123, '2015-03-01 01:13:47.000000', 'consum', 0.0216, 'lps'),
	(426367, 123, '2015-03-01 01:13:48.000000', 'consum', 0.0221, 'lps'),
	(426368, 123, '2015-03-01 01:13:49.000000', 'consum', 0.0220, 'lps'),
	(426369, 123, '2015-03-01 01:13:50.000000', 'consum', 0.0218, 'lps'),
	(426370, 123, '2015-03-01 01:13:51.000000', 'consum', 0.0219, 'lps'),
	(426371, 123, '2015-03-01 01:13:52.000000', 'consum', 0.0217, 'lps'),
	(426372, 123, '2015-03-01 01:13:53.000000', 'consum', 0.0221, 'lps'),
	(426373, 123, '2015-03-01 01:13:54.000000', 'consum', 0.0219, 'lps'),
	(426374, 123, '2015-03-01 01:13:55.000000', 'consum', 0.0210, 'lps'),
	(426375, 123, '2015-03-01 01:13:56.000000', 'consum', 0.0221, 'lps'),
	(426376, 123, '2015-03-01 01:13:57.000000', 'consum', 0.0214, 'lps'),
	(426377, 123, '2015-03-01 01:13:58.000000', 'consum', 0.0222, 'lps'),
	(426378, 123, '2015-03-01 01:13:59.000000', 'consum', 0.0220, 'lps'),
	(426379, 123, '2015-03-01 01:14:00.000000', 'consum', 0.0210, 'lps'),
	(426380, 123, '2015-03-01 01:14:01.000000', 'consum', 0.0221, 'lps'),
	(426381, 123, '2015-03-01 01:14:02.000000', 'consum', 0.0211, 'lps'),
	(426382, 123, '2015-03-01 01:14:03.000000', 'consum', 0.0212, 'lps'),
	(426383, 123, '2015-03-01 01:14:04.000000', 'consum', 0.0214, 'lps'),
	(426384, 123, '2015-03-01 01:14:05.000000', 'consum', 0.0213, 'lps'),
	(426385, 123, '2015-03-01 01:14:06.000000', 'consum', 0.0215, 'lps'),
	(426386, 123, '2015-03-01 01:14:07.000000', 'consum', 0.0213, 'lps'),
	(426387, 123, '2015-03-01 01:14:08.000000', 'consum', 0.0222, 'lps'),
	(426388, 123, '2015-03-01 01:14:09.000000', 'consum', 0.0210, 'lps'),
	(426389, 123, '2015-03-01 01:14:10.000000', 'consum', 0.0214, 'lps'),
	(426390, 123, '2015-03-01 01:14:11.000000', 'consum', 0.0219, 'lps'),
	(426391, 123, '2015-03-01 01:14:12.000000', 'consum', 0.0217, 'lps'),
	(426392, 123, '2015-03-01 01:14:13.000000', 'consum', 0.0218, 'lps'),
	(426393, 123, '2015-03-01 01:14:14.000000', 'consum', 0.0217, 'lps'),
	(426394, 123, '2015-03-01 01:14:15.000000', 'consum', 0.0210, 'lps'),
	(426395, 123, '2015-03-01 01:14:16.000000', 'consum', 0.0213, 'lps'),
	(426396, 123, '2015-03-01 01:14:17.000000', 'consum', 0.0211, 'lps'),
	(426397, 123, '2015-03-01 01:14:18.000000', 'consum', 0.0210, 'lps'),
	(426398, 123, '2015-03-01 01:14:19.000000', 'consum', 0.0218, 'lps'),
	(426399, 123, '2015-03-01 01:14:20.000000', 'consum', 0.0214, 'lps'),
	(426400, 123, '2015-03-01 01:14:21.000000', 'consum', 0.0218, 'lps'),
	(426401, 123, '2015-03-01 01:14:22.000000', 'consum', 0.0214, 'lps'),
	(426402, 123, '2015-03-01 01:14:23.000000', 'consum', 0.0219, 'lps'),
	(426403, 123, '2015-03-01 01:14:24.000000', 'consum', 0.0219, 'lps'),
	(426404, 123, '2015-03-01 01:14:25.000000', 'consum', 0.0215, 'lps'),
	(426405, 123, '2015-03-01 01:14:26.000000', 'consum', 0.0220, 'lps'),
	(426406, 123, '2015-03-01 01:14:27.000000', 'consum', 0.0221, 'lps'),
	(426407, 123, '2015-03-01 01:14:28.000000', 'consum', 0.0211, 'lps'),
	(426408, 123, '2015-03-01 01:14:29.000000', 'consum', 0.0218, 'lps'),
	(426409, 123, '2015-03-01 01:14:30.000000', 'consum', 0.0210, 'lps'),
	(426410, 123, '2015-03-01 01:14:31.000000', 'consum', 0.0211, 'lps'),
	(426411, 123, '2015-03-01 01:14:32.000000', 'consum', 0.0217, 'lps'),
	(426412, 123, '2015-03-01 01:14:33.000000', 'consum', 0.0215, 'lps'),
	(426413, 123, '2015-03-01 01:14:34.000000', 'consum', 0.0214, 'lps'),
	(426414, 123, '2015-03-01 01:14:35.000000', 'consum', 0.0215, 'lps'),
	(426415, 123, '2015-03-01 01:14:36.000000', 'consum', 0.0211, 'lps'),
	(426416, 123, '2015-03-01 01:14:37.000000', 'consum', 0.0215, 'lps'),
	(426417, 123, '2015-03-01 01:14:38.000000', 'consum', 0.0220, 'lps'),
	(426418, 123, '2015-03-01 01:14:39.000000', 'consum', 0.0217, 'lps'),
	(426419, 123, '2015-03-01 01:14:40.000000', 'consum', 0.0216, 'lps'),
	(426420, 123, '2015-03-01 01:14:41.000000', 'consum', 0.0220, 'lps'),
	(426421, 123, '2015-03-01 01:14:42.000000', 'consum', 0.0215, 'lps'),
	(426422, 123, '2015-03-01 01:14:43.000000', 'consum', 0.0221, 'lps'),
	(426423, 123, '2015-03-01 01:14:44.000000', 'consum', 0.0212, 'lps'),
	(426424, 123, '2015-03-01 01:14:45.000000', 'consum', 0.0212, 'lps'),
	(426425, 123, '2015-03-01 01:14:46.000000', 'consum', 0.0215, 'lps'),
	(426426, 123, '2015-03-01 01:14:47.000000', 'consum', 0.0216, 'lps'),
	(426427, 123, '2015-03-01 01:14:48.000000', 'consum', 0.0214, 'lps'),
	(426428, 123, '2015-03-01 01:14:49.000000', 'consum', 0.0210, 'lps'),
	(426429, 123, '2015-03-01 01:14:50.000000', 'consum', 0.0213, 'lps'),
	(426430, 123, '2015-03-01 01:14:51.000000', 'consum', 0.0212, 'lps'),
	(426431, 123, '2015-03-01 01:14:52.000000', 'consum', 0.0212, 'lps'),
	(426432, 123, '2015-03-01 01:14:53.000000', 'consum', 0.0215, 'lps'),
	(426433, 123, '2015-03-01 01:14:54.000000', 'consum', 0.0217, 'lps'),
	(426434, 123, '2015-03-01 01:14:55.000000', 'consum', 0.0219, 'lps'),
	(426435, 123, '2015-03-01 01:14:56.000000', 'consum', 0.0219, 'lps'),
	(426436, 123, '2015-03-01 01:14:57.000000', 'consum', 0.0217, 'lps'),
	(426437, 123, '2015-03-01 01:14:58.000000', 'consum', 0.0219, 'lps'),
	(426438, 123, '2015-03-01 01:14:59.000000', 'consum', 0.0210, 'lps'),
	(426439, 123, '2015-03-01 01:15:00.000000', 'consum', 0.0220, 'lps'),
	(426440, 123, '2015-03-01 01:15:01.000000', 'consum', 0.0210, 'lps'),
	(426441, 123, '2015-03-01 01:15:02.000000', 'consum', 0.0217, 'lps'),
	(426442, 123, '2015-03-01 01:15:03.000000', 'consum', 0.0210, 'lps'),
	(426443, 123, '2015-03-01 01:15:04.000000', 'consum', 0.0213, 'lps'),
	(426444, 123, '2015-03-01 01:15:05.000000', 'consum', 0.0213, 'lps'),
	(426445, 123, '2015-03-01 01:15:06.000000', 'consum', 0.0219, 'lps'),
	(426446, 123, '2015-03-01 01:15:07.000000', 'consum', 0.0217, 'lps'),
	(426447, 123, '2015-03-01 01:15:08.000000', 'consum', 0.0219, 'lps'),
	(426448, 123, '2015-03-01 01:15:09.000000', 'consum', 0.0211, 'lps'),
	(426449, 123, '2015-03-01 01:15:10.000000', 'consum', 0.0214, 'lps'),
	(426450, 123, '2015-03-01 01:15:11.000000', 'consum', 0.0213, 'lps'),
	(426451, 123, '2015-03-01 01:15:12.000000', 'consum', 0.0216, 'lps'),
	(426452, 123, '2015-03-01 01:15:13.000000', 'consum', 0.0218, 'lps'),
	(426453, 123, '2015-03-01 01:15:14.000000', 'consum', 0.0217, 'lps'),
	(426454, 123, '2015-03-01 01:15:15.000000', 'consum', 0.0222, 'lps'),
	(426455, 123, '2015-03-01 01:15:16.000000', 'consum', 0.0212, 'lps'),
	(426456, 123, '2015-03-01 01:15:17.000000', 'consum', 0.0211, 'lps'),
	(426457, 123, '2015-03-01 01:15:18.000000', 'consum', 0.0211, 'lps'),
	(426458, 123, '2015-03-01 01:15:19.000000', 'consum', 0.0222, 'lps'),
	(426459, 123, '2015-03-01 01:15:20.000000', 'consum', 0.0217, 'lps'),
	(426460, 123, '2015-03-01 01:15:21.000000', 'consum', 0.0221, 'lps'),
	(426461, 123, '2015-03-01 01:15:22.000000', 'consum', 0.0218, 'lps'),
	(426462, 123, '2015-03-01 01:15:23.000000', 'consum', 0.0220, 'lps'),
	(426463, 123, '2015-03-01 01:15:24.000000', 'consum', 0.0210, 'lps'),
	(426464, 123, '2015-03-01 01:15:25.000000', 'consum', 0.0218, 'lps'),
	(426465, 123, '2015-03-01 01:15:26.000000', 'consum', 0.0211, 'lps'),
	(426466, 123, '2015-03-01 01:15:27.000000', 'consum', 0.0217, 'lps'),
	(426467, 123, '2015-03-01 01:15:28.000000', 'consum', 0.0218, 'lps'),
	(426468, 123, '2015-03-01 01:15:29.000000', 'consum', 0.0218, 'lps'),
	(426469, 123, '2015-03-01 01:15:30.000000', 'consum', 0.0211, 'lps'),
	(426470, 123, '2015-03-01 01:15:31.000000', 'consum', 0.0218, 'lps'),
	(426471, 123, '2015-03-01 01:15:32.000000', 'consum', 0.0222, 'lps'),
	(426472, 123, '2015-03-01 01:15:33.000000', 'consum', 0.0221, 'lps'),
	(426473, 123, '2015-03-01 01:15:34.000000', 'consum', 0.0214, 'lps'),
	(426474, 123, '2015-03-01 01:15:35.000000', 'consum', 0.0213, 'lps'),
	(426475, 123, '2015-03-01 01:15:36.000000', 'consum', 0.0214, 'lps'),
	(426476, 123, '2015-03-01 01:15:37.000000', 'consum', 0.0222, 'lps'),
	(426477, 123, '2015-03-01 01:15:38.000000', 'consum', 0.0219, 'lps'),
	(426478, 123, '2015-03-01 01:15:39.000000', 'consum', 0.0220, 'lps'),
	(426479, 123, '2015-03-01 01:15:40.000000', 'consum', 0.0222, 'lps'),
	(426480, 123, '2015-03-01 01:15:41.000000', 'consum', 0.0213, 'lps'),
	(426481, 123, '2015-03-01 01:15:42.000000', 'consum', 0.0214, 'lps'),
	(426482, 123, '2015-03-01 01:15:43.000000', 'consum', 0.0222, 'lps'),
	(426483, 123, '2015-03-01 01:15:44.000000', 'consum', 0.0222, 'lps'),
	(426484, 123, '2015-03-01 01:15:45.000000', 'consum', 0.0219, 'lps'),
	(426485, 123, '2015-03-01 01:15:46.000000', 'consum', 0.0219, 'lps'),
	(426486, 123, '2015-03-01 01:15:47.000000', 'consum', 0.0217, 'lps'),
	(426487, 123, '2015-03-01 01:15:48.000000', 'consum', 0.0219, 'lps'),
	(426488, 123, '2015-03-01 01:15:49.000000', 'consum', 0.0219, 'lps'),
	(426489, 123, '2015-03-01 01:15:50.000000', 'consum', 0.0216, 'lps'),
	(426490, 123, '2015-03-01 01:15:51.000000', 'consum', 0.0216, 'lps'),
	(426491, 123, '2015-03-01 01:15:52.000000', 'consum', 0.0221, 'lps'),
	(426492, 123, '2015-03-01 01:15:53.000000', 'consum', 0.0222, 'lps'),
	(426493, 123, '2015-03-01 01:15:54.000000', 'consum', 0.0210, 'lps'),
	(426494, 123, '2015-03-01 01:15:55.000000', 'consum', 0.0216, 'lps'),
	(426495, 123, '2015-03-01 01:15:56.000000', 'consum', 0.0211, 'lps'),
	(426496, 123, '2015-03-01 01:15:57.000000', 'consum', 0.0213, 'lps'),
	(426497, 123, '2015-03-01 01:15:58.000000', 'consum', 0.0222, 'lps'),
	(426498, 123, '2015-03-01 01:15:59.000000', 'consum', 0.0211, 'lps'),
	(426499, 123, '2015-03-01 01:16:00.000000', 'consum', 0.0217, 'lps'),
	(426500, 123, '2015-03-01 01:16:01.000000', 'consum', 0.0215, 'lps'),
	(426501, 123, '2015-03-01 01:16:02.000000', 'consum', 0.0216, 'lps'),
	(426502, 123, '2015-03-01 01:16:03.000000', 'consum', 0.0214, 'lps'),
	(426503, 123, '2015-03-01 01:16:04.000000', 'consum', 0.0212, 'lps'),
	(426504, 123, '2015-03-01 01:16:05.000000', 'consum', 0.0221, 'lps'),
	(426505, 123, '2015-03-01 01:16:06.000000', 'consum', 0.0220, 'lps'),
	(426506, 123, '2015-03-01 01:16:07.000000', 'consum', 0.0213, 'lps'),
	(426507, 123, '2015-03-01 01:16:08.000000', 'consum', 0.0210, 'lps'),
	(426508, 123, '2015-03-01 01:16:09.000000', 'consum', 0.0214, 'lps'),
	(426509, 123, '2015-03-01 01:16:10.000000', 'consum', 0.0220, 'lps'),
	(426510, 123, '2015-03-01 01:16:11.000000', 'consum', 0.0220, 'lps'),
	(426511, 123, '2015-03-01 01:16:12.000000', 'consum', 0.0218, 'lps'),
	(426512, 123, '2015-03-01 01:16:13.000000', 'consum', 0.0221, 'lps'),
	(426513, 123, '2015-03-01 01:16:14.000000', 'consum', 0.0217, 'lps'),
	(426514, 123, '2015-03-01 01:16:15.000000', 'consum', 0.0222, 'lps'),
	(426515, 123, '2015-03-01 01:16:16.000000', 'consum', 0.0214, 'lps'),
	(426516, 123, '2015-03-01 01:16:17.000000', 'consum', 0.0218, 'lps'),
	(426517, 123, '2015-03-01 01:16:18.000000', 'consum', 0.0214, 'lps'),
	(426518, 123, '2015-03-01 01:16:19.000000', 'consum', 0.0220, 'lps'),
	(426519, 123, '2015-03-01 01:16:20.000000', 'consum', 0.0211, 'lps'),
	(426520, 123, '2015-03-01 01:16:21.000000', 'consum', 0.0222, 'lps'),
	(426521, 123, '2015-03-01 01:16:22.000000', 'consum', 0.0217, 'lps'),
	(426522, 123, '2015-03-01 01:16:23.000000', 'consum', 0.0222, 'lps'),
	(426523, 123, '2015-03-01 01:16:24.000000', 'consum', 0.0222, 'lps'),
	(426524, 123, '2015-03-01 01:16:25.000000', 'consum', 0.0210, 'lps'),
	(426525, 123, '2015-03-01 01:16:26.000000', 'consum', 0.0212, 'lps'),
	(426526, 123, '2015-03-01 01:16:27.000000', 'consum', 0.0210, 'lps'),
	(426527, 123, '2015-03-01 01:16:28.000000', 'consum', 0.0214, 'lps'),
	(426528, 123, '2015-03-01 01:16:29.000000', 'consum', 0.0220, 'lps'),
	(426529, 123, '2015-03-01 01:16:30.000000', 'consum', 0.0221, 'lps'),
	(426530, 123, '2015-03-01 01:16:31.000000', 'consum', 0.0212, 'lps'),
	(426531, 123, '2015-03-01 01:16:32.000000', 'consum', 0.0213, 'lps'),
	(426532, 123, '2015-03-01 01:16:33.000000', 'consum', 0.0219, 'lps'),
	(426533, 123, '2015-03-01 01:16:34.000000', 'consum', 0.0221, 'lps'),
	(426534, 123, '2015-03-01 01:16:35.000000', 'consum', 0.0212, 'lps'),
	(426535, 123, '2015-03-01 01:16:36.000000', 'consum', 0.0213, 'lps'),
	(426536, 123, '2015-03-01 01:16:37.000000', 'consum', 0.0221, 'lps'),
	(426537, 123, '2015-03-01 01:16:38.000000', 'consum', 0.0216, 'lps'),
	(426538, 123, '2015-03-01 01:16:39.000000', 'consum', 0.0220, 'lps'),
	(426539, 123, '2015-03-01 01:16:40.000000', 'consum', 0.0218, 'lps'),
	(426540, 123, '2015-03-01 01:16:41.000000', 'consum', 0.0219, 'lps'),
	(426541, 123, '2015-03-01 01:16:42.000000', 'consum', 0.0218, 'lps'),
	(426542, 123, '2015-03-01 01:16:43.000000', 'consum', 0.0210, 'lps'),
	(426543, 123, '2015-03-01 01:16:44.000000', 'consum', 0.0214, 'lps'),
	(426544, 123, '2015-03-01 01:16:45.000000', 'consum', 0.0217, 'lps'),
	(426545, 123, '2015-03-01 01:16:46.000000', 'consum', 0.0220, 'lps'),
	(426546, 123, '2015-03-01 01:16:47.000000', 'consum', 0.0213, 'lps'),
	(426547, 123, '2015-03-01 01:16:48.000000', 'consum', 0.0211, 'lps'),
	(426548, 123, '2015-03-01 01:16:49.000000', 'consum', 0.0217, 'lps'),
	(426549, 123, '2015-03-01 01:16:50.000000', 'consum', 0.0218, 'lps'),
	(426550, 123, '2015-03-01 01:16:51.000000', 'consum', 0.0214, 'lps'),
	(426551, 123, '2015-03-01 01:16:52.000000', 'consum', 0.0222, 'lps'),
	(426552, 123, '2015-03-01 01:16:53.000000', 'consum', 0.0220, 'lps'),
	(426553, 123, '2015-03-01 01:16:54.000000', 'consum', 0.0212, 'lps'),
	(426554, 123, '2015-03-01 01:16:55.000000', 'consum', 0.0214, 'lps'),
	(426555, 123, '2015-03-01 01:16:56.000000', 'consum', 0.0214, 'lps'),
	(426556, 123, '2015-03-01 01:16:57.000000', 'consum', 0.0216, 'lps'),
	(426557, 123, '2015-03-01 01:16:58.000000', 'consum', 0.0217, 'lps'),
	(426558, 123, '2015-03-01 01:16:59.000000', 'consum', 0.0215, 'lps'),
	(426559, 123, '2015-03-01 01:17:00.000000', 'consum', 0.0214, 'lps'),
	(426560, 123, '2015-03-01 01:17:01.000000', 'consum', 0.0215, 'lps'),
	(426561, 123, '2015-03-01 01:17:02.000000', 'consum', 0.0210, 'lps'),
	(426562, 123, '2015-03-01 01:17:03.000000', 'consum', 0.0220, 'lps'),
	(426563, 123, '2015-03-01 01:17:04.000000', 'consum', 0.0212, 'lps'),
	(426564, 123, '2015-03-01 01:17:05.000000', 'consum', 0.0215, 'lps'),
	(426565, 123, '2015-03-01 01:17:06.000000', 'consum', 0.0217, 'lps'),
	(426566, 123, '2015-03-01 01:17:07.000000', 'consum', 0.0217, 'lps'),
	(426567, 123, '2015-03-01 01:17:08.000000', 'consum', 0.0213, 'lps'),
	(426568, 123, '2015-03-01 01:17:09.000000', 'consum', 0.0216, 'lps'),
	(426569, 123, '2015-03-01 01:17:10.000000', 'consum', 0.0219, 'lps'),
	(426570, 123, '2015-03-01 01:17:11.000000', 'consum', 0.0210, 'lps'),
	(426571, 123, '2015-03-01 01:17:12.000000', 'consum', 0.0222, 'lps'),
	(426572, 123, '2015-03-01 01:17:13.000000', 'consum', 0.0218, 'lps'),
	(426573, 123, '2015-03-01 01:17:14.000000', 'consum', 0.0215, 'lps'),
	(426574, 123, '2015-03-01 01:17:15.000000', 'consum', 0.0212, 'lps'),
	(426575, 123, '2015-03-01 01:17:16.000000', 'consum', 0.0219, 'lps'),
	(426576, 123, '2015-03-01 01:17:17.000000', 'consum', 0.0210, 'lps'),
	(426577, 123, '2015-03-01 01:17:18.000000', 'consum', 0.0210, 'lps'),
	(426578, 123, '2015-03-01 01:17:19.000000', 'consum', 0.0221, 'lps'),
	(426579, 123, '2015-03-01 01:17:20.000000', 'consum', 0.0216, 'lps'),
	(426580, 123, '2015-03-01 01:17:21.000000', 'consum', 0.0220, 'lps'),
	(426581, 123, '2015-03-01 01:17:22.000000', 'consum', 0.0217, 'lps'),
	(426582, 123, '2015-03-01 01:17:23.000000', 'consum', 0.0213, 'lps'),
	(426583, 123, '2015-03-01 01:17:24.000000', 'consum', 0.0219, 'lps'),
	(426584, 123, '2015-03-01 01:17:25.000000', 'consum', 0.0219, 'lps'),
	(426585, 123, '2015-03-01 01:17:26.000000', 'consum', 0.0218, 'lps'),
	(426586, 123, '2015-03-01 01:17:27.000000', 'consum', 0.0220, 'lps'),
	(426587, 123, '2015-03-01 01:17:28.000000', 'consum', 0.0214, 'lps'),
	(426588, 123, '2015-03-01 01:17:29.000000', 'consum', 0.0213, 'lps'),
	(426589, 123, '2015-03-01 01:17:30.000000', 'consum', 0.0215, 'lps'),
	(426590, 123, '2015-03-01 01:17:31.000000', 'consum', 0.0211, 'lps'),
	(426591, 123, '2015-03-01 01:17:32.000000', 'consum', 0.0213, 'lps'),
	(426592, 123, '2015-03-01 01:17:33.000000', 'consum', 0.0212, 'lps'),
	(426593, 123, '2015-03-01 01:17:34.000000', 'consum', 0.0212, 'lps'),
	(426594, 123, '2015-03-01 01:17:35.000000', 'consum', 0.0213, 'lps'),
	(426595, 123, '2015-03-01 01:17:36.000000', 'consum', 0.0218, 'lps'),
	(426596, 123, '2015-03-01 01:17:37.000000', 'consum', 0.0217, 'lps'),
	(426597, 123, '2015-03-01 01:17:38.000000', 'consum', 0.0219, 'lps'),
	(426598, 123, '2015-03-01 01:17:39.000000', 'consum', 0.0212, 'lps'),
	(426599, 123, '2015-03-01 01:17:40.000000', 'consum', 0.0217, 'lps'),
	(426600, 123, '2015-03-01 01:17:41.000000', 'consum', 0.0212, 'lps'),
	(426601, 123, '2015-03-01 01:17:42.000000', 'consum', 0.0215, 'lps'),
	(426602, 123, '2015-03-01 01:17:43.000000', 'consum', 0.0216, 'lps'),
	(426603, 123, '2015-03-01 01:17:44.000000', 'consum', 0.0213, 'lps'),
	(426604, 123, '2015-03-01 01:17:45.000000', 'consum', 0.0220, 'lps'),
	(426605, 123, '2015-03-01 01:17:46.000000', 'consum', 0.0212, 'lps'),
	(426606, 123, '2015-03-01 01:17:47.000000', 'consum', 0.0216, 'lps'),
	(426607, 123, '2015-03-01 01:17:48.000000', 'consum', 0.0210, 'lps'),
	(426608, 123, '2015-03-01 01:17:49.000000', 'consum', 0.0217, 'lps'),
	(426609, 123, '2015-03-01 01:17:50.000000', 'consum', 0.0219, 'lps'),
	(426610, 123, '2015-03-01 01:17:51.000000', 'consum', 0.0222, 'lps'),
	(426611, 123, '2015-03-01 01:17:52.000000', 'consum', 0.0218, 'lps'),
	(426612, 123, '2015-03-01 01:17:53.000000', 'consum', 0.0214, 'lps'),
	(426613, 123, '2015-03-01 01:17:54.000000', 'consum', 0.0219, 'lps'),
	(426614, 123, '2015-03-01 01:17:55.000000', 'consum', 0.0220, 'lps'),
	(426615, 123, '2015-03-01 01:17:56.000000', 'consum', 0.0219, 'lps'),
	(426616, 123, '2015-03-01 01:17:57.000000', 'consum', 0.0212, 'lps'),
	(426617, 123, '2015-03-01 01:17:58.000000', 'consum', 0.0222, 'lps'),
	(426618, 123, '2015-03-01 01:17:59.000000', 'consum', 0.0222, 'lps'),
	(426619, 123, '2015-03-01 01:18:00.000000', 'consum', 0.0210, 'lps'),
	(426620, 123, '2015-03-01 01:18:01.000000', 'consum', 0.0215, 'lps'),
	(426621, 123, '2015-03-01 01:18:02.000000', 'consum', 0.0221, 'lps'),
	(426622, 123, '2015-03-01 01:18:03.000000', 'consum', 0.0213, 'lps'),
	(426623, 123, '2015-03-01 01:18:04.000000', 'consum', 0.0218, 'lps'),
	(426624, 123, '2015-03-01 01:18:05.000000', 'consum', 0.0217, 'lps'),
	(426625, 123, '2015-03-01 01:18:06.000000', 'consum', 0.0220, 'lps'),
	(426626, 123, '2015-03-01 01:18:07.000000', 'consum', 0.0212, 'lps'),
	(426627, 123, '2015-03-01 01:18:08.000000', 'consum', 0.0216, 'lps'),
	(426628, 123, '2015-03-01 01:18:09.000000', 'consum', 0.0210, 'lps'),
	(426629, 123, '2015-03-01 01:18:10.000000', 'consum', 0.0219, 'lps'),
	(426630, 123, '2015-03-01 01:18:11.000000', 'consum', 0.0214, 'lps'),
	(426631, 123, '2015-03-01 01:18:12.000000', 'consum', 0.0220, 'lps'),
	(426632, 123, '2015-03-01 01:18:13.000000', 'consum', 0.0219, 'lps'),
	(426633, 123, '2015-03-01 01:18:14.000000', 'consum', 0.0214, 'lps'),
	(426634, 123, '2015-03-01 01:18:15.000000', 'consum', 0.0215, 'lps'),
	(426635, 123, '2015-03-01 01:18:16.000000', 'consum', 0.0213, 'lps'),
	(426636, 123, '2015-03-01 01:18:17.000000', 'consum', 0.0212, 'lps'),
	(426637, 123, '2015-03-01 01:18:18.000000', 'consum', 0.0221, 'lps'),
	(426638, 123, '2015-03-01 01:18:19.000000', 'consum', 0.0221, 'lps'),
	(426639, 123, '2015-03-01 01:18:20.000000', 'consum', 0.0221, 'lps'),
	(426640, 123, '2015-03-01 01:18:21.000000', 'consum', 0.0221, 'lps'),
	(426641, 123, '2015-03-01 01:18:22.000000', 'consum', 0.0216, 'lps'),
	(426642, 123, '2015-03-01 01:18:23.000000', 'consum', 0.0221, 'lps'),
	(426643, 123, '2015-03-01 01:18:24.000000', 'consum', 0.0210, 'lps'),
	(426644, 123, '2015-03-01 01:18:25.000000', 'consum', 0.0217, 'lps'),
	(426645, 123, '2015-03-01 01:18:26.000000', 'consum', 0.0217, 'lps'),
	(426646, 123, '2015-03-01 01:18:27.000000', 'consum', 0.0211, 'lps'),
	(426647, 123, '2015-03-01 01:18:28.000000', 'consum', 0.0222, 'lps'),
	(426648, 123, '2015-03-01 01:18:29.000000', 'consum', 0.0217, 'lps'),
	(426649, 123, '2015-03-01 01:18:30.000000', 'consum', 0.0219, 'lps'),
	(426650, 123, '2015-03-01 01:18:31.000000', 'consum', 0.0212, 'lps'),
	(426651, 123, '2015-03-01 01:18:32.000000', 'consum', 0.0218, 'lps'),
	(426652, 123, '2015-03-01 01:18:33.000000', 'consum', 0.0218, 'lps'),
	(426653, 123, '2015-03-01 01:18:34.000000', 'consum', 0.0213, 'lps'),
	(426654, 123, '2015-03-01 01:18:35.000000', 'consum', 0.0215, 'lps'),
	(426655, 123, '2015-03-01 01:18:36.000000', 'consum', 0.0212, 'lps'),
	(426656, 123, '2015-03-01 01:18:37.000000', 'consum', 0.0219, 'lps'),
	(426657, 123, '2015-03-01 01:18:38.000000', 'consum', 0.0210, 'lps'),
	(426658, 123, '2015-03-01 01:18:39.000000', 'consum', 0.0222, 'lps'),
	(426659, 123, '2015-03-01 01:18:40.000000', 'consum', 0.0220, 'lps'),
	(426660, 123, '2015-03-01 01:18:41.000000', 'consum', 0.0212, 'lps'),
	(426661, 123, '2015-03-01 01:18:42.000000', 'consum', 0.0215, 'lps'),
	(426662, 123, '2015-03-01 01:18:43.000000', 'consum', 0.0218, 'lps'),
	(426663, 123, '2015-03-01 01:18:44.000000', 'consum', 0.0222, 'lps'),
	(426664, 123, '2015-03-01 01:18:45.000000', 'consum', 0.0221, 'lps'),
	(426665, 123, '2015-03-01 01:18:46.000000', 'consum', 0.0215, 'lps'),
	(426666, 123, '2015-03-01 01:18:47.000000', 'consum', 0.0215, 'lps'),
	(426667, 123, '2015-03-01 01:18:48.000000', 'consum', 0.0210, 'lps'),
	(426668, 123, '2015-03-01 01:18:49.000000', 'consum', 0.0220, 'lps'),
	(426669, 123, '2015-03-01 01:18:50.000000', 'consum', 0.0210, 'lps'),
	(426670, 123, '2015-03-01 01:18:51.000000', 'consum', 0.0220, 'lps'),
	(426671, 123, '2015-03-01 01:18:52.000000', 'consum', 0.0221, 'lps'),
	(426672, 123, '2015-03-01 01:18:53.000000', 'consum', 0.0211, 'lps'),
	(426673, 123, '2015-03-01 01:18:54.000000', 'consum', 0.0219, 'lps'),
	(426674, 123, '2015-03-01 01:18:55.000000', 'consum', 0.0216, 'lps'),
	(426675, 123, '2015-03-01 01:18:56.000000', 'consum', 0.0211, 'lps'),
	(426676, 123, '2015-03-01 01:18:57.000000', 'consum', 0.0210, 'lps'),
	(426677, 123, '2015-03-01 01:18:58.000000', 'consum', 0.0211, 'lps'),
	(426678, 123, '2015-03-01 01:18:59.000000', 'consum', 0.0212, 'lps'),
	(426679, 123, '2015-03-01 01:19:00.000000', 'consum', 0.0219, 'lps'),
	(426680, 123, '2015-03-01 01:19:01.000000', 'consum', 0.0211, 'lps'),
	(426681, 123, '2015-03-01 01:19:02.000000', 'consum', 0.0212, 'lps'),
	(426682, 123, '2015-03-01 01:19:03.000000', 'consum', 0.0219, 'lps'),
	(426683, 123, '2015-03-01 01:19:04.000000', 'consum', 0.0213, 'lps'),
	(426684, 123, '2015-03-01 01:19:05.000000', 'consum', 0.0221, 'lps'),
	(426685, 123, '2015-03-01 01:19:06.000000', 'consum', 0.0218, 'lps'),
	(426686, 123, '2015-03-01 01:19:07.000000', 'consum', 0.0219, 'lps'),
	(426687, 123, '2015-03-01 01:19:08.000000', 'consum', 0.0216, 'lps'),
	(426688, 123, '2015-03-01 01:19:09.000000', 'consum', 0.0216, 'lps'),
	(426689, 123, '2015-03-01 01:19:10.000000', 'consum', 0.0222, 'lps'),
	(426690, 123, '2015-03-01 01:19:11.000000', 'consum', 0.0215, 'lps'),
	(426691, 123, '2015-03-01 01:19:12.000000', 'consum', 0.0210, 'lps'),
	(426692, 123, '2015-03-01 01:19:13.000000', 'consum', 0.0222, 'lps'),
	(426693, 123, '2015-03-01 01:19:14.000000', 'consum', 0.0220, 'lps'),
	(426694, 123, '2015-03-01 01:19:15.000000', 'consum', 0.0222, 'lps'),
	(426695, 123, '2015-03-01 01:19:16.000000', 'consum', 0.0216, 'lps'),
	(426696, 123, '2015-03-01 01:19:17.000000', 'consum', 0.0217, 'lps'),
	(426697, 123, '2015-03-01 01:19:18.000000', 'consum', 0.0215, 'lps'),
	(426698, 123, '2015-03-01 01:19:19.000000', 'consum', 0.0212, 'lps'),
	(426699, 123, '2015-03-01 01:19:20.000000', 'consum', 0.0222, 'lps'),
	(426700, 123, '2015-03-01 01:19:21.000000', 'consum', 0.0210, 'lps'),
	(426701, 123, '2015-03-01 01:19:22.000000', 'consum', 0.0215, 'lps'),
	(426702, 123, '2015-03-01 01:19:23.000000', 'consum', 0.0222, 'lps'),
	(426703, 123, '2015-03-01 01:19:24.000000', 'consum', 0.0216, 'lps'),
	(426704, 123, '2015-03-01 01:19:25.000000', 'consum', 0.0220, 'lps'),
	(426705, 123, '2015-03-01 01:19:26.000000', 'consum', 0.0214, 'lps'),
	(426706, 123, '2015-03-01 01:19:27.000000', 'consum', 0.0216, 'lps'),
	(426707, 123, '2015-03-01 01:19:28.000000', 'consum', 0.0214, 'lps'),
	(426708, 123, '2015-03-01 01:19:29.000000', 'consum', 0.0211, 'lps'),
	(426709, 123, '2015-03-01 01:19:30.000000', 'consum', 0.0218, 'lps'),
	(426710, 123, '2015-03-01 01:19:31.000000', 'consum', 0.0219, 'lps'),
	(426711, 123, '2015-03-01 01:19:32.000000', 'consum', 0.0222, 'lps'),
	(426712, 123, '2015-03-01 01:19:33.000000', 'consum', 0.0217, 'lps'),
	(426713, 123, '2015-03-01 01:19:34.000000', 'consum', 0.0210, 'lps'),
	(426714, 123, '2015-03-01 01:19:35.000000', 'consum', 0.0213, 'lps'),
	(426715, 123, '2015-03-01 01:19:36.000000', 'consum', 0.0213, 'lps'),
	(426716, 123, '2015-03-01 01:19:37.000000', 'consum', 0.0217, 'lps'),
	(426717, 123, '2015-03-01 01:19:38.000000', 'consum', 0.0222, 'lps'),
	(426718, 123, '2015-03-01 01:19:39.000000', 'consum', 0.0211, 'lps'),
	(426719, 123, '2015-03-01 01:19:40.000000', 'consum', 0.0217, 'lps'),
	(426720, 123, '2015-03-01 01:19:41.000000', 'consum', 0.0220, 'lps'),
	(426721, 123, '2015-03-01 01:19:42.000000', 'consum', 0.0211, 'lps'),
	(426722, 123, '2015-03-01 01:19:43.000000', 'consum', 0.0210, 'lps'),
	(426723, 123, '2015-03-01 01:19:44.000000', 'consum', 0.0210, 'lps'),
	(426724, 123, '2015-03-01 01:19:45.000000', 'consum', 0.0212, 'lps'),
	(426725, 123, '2015-03-01 01:19:46.000000', 'consum', 0.0218, 'lps'),
	(426726, 123, '2015-03-01 01:19:47.000000', 'consum', 0.0220, 'lps'),
	(426727, 123, '2015-03-01 01:19:48.000000', 'consum', 0.0222, 'lps'),
	(426728, 123, '2015-03-01 01:19:49.000000', 'consum', 0.0216, 'lps'),
	(426729, 123, '2015-03-01 01:19:50.000000', 'consum', 0.0218, 'lps'),
	(426730, 123, '2015-03-01 01:19:51.000000', 'consum', 0.0220, 'lps'),
	(426731, 123, '2015-03-01 01:19:52.000000', 'consum', 0.0221, 'lps'),
	(426732, 123, '2015-03-01 01:19:53.000000', 'consum', 0.0212, 'lps'),
	(426733, 123, '2015-03-01 01:19:54.000000', 'consum', 0.0211, 'lps'),
	(426734, 123, '2015-03-01 01:19:55.000000', 'consum', 0.0222, 'lps'),
	(426735, 123, '2015-03-01 01:19:56.000000', 'consum', 0.0219, 'lps'),
	(426736, 123, '2015-03-01 01:19:57.000000', 'consum', 0.0216, 'lps'),
	(426737, 123, '2015-03-01 01:19:58.000000', 'consum', 0.0216, 'lps'),
	(426738, 123, '2015-03-01 01:19:59.000000', 'consum', 0.0221, 'lps'),
	(426739, 123, '2015-03-01 01:20:00.000000', 'consum', 0.0222, 'lps'),
	(426740, 123, '2015-03-01 01:20:01.000000', 'consum', 0.0210, 'lps'),
	(426741, 123, '2015-03-01 01:20:02.000000', 'consum', 0.0215, 'lps'),
	(426742, 123, '2015-03-01 01:20:03.000000', 'consum', 0.0211, 'lps'),
	(426743, 123, '2015-03-01 01:20:04.000000', 'consum', 0.0212, 'lps'),
	(426744, 123, '2015-03-01 01:20:05.000000', 'consum', 0.0219, 'lps'),
	(426745, 123, '2015-03-01 01:20:06.000000', 'consum', 0.0221, 'lps'),
	(426746, 123, '2015-03-01 01:20:07.000000', 'consum', 0.0215, 'lps'),
	(426747, 123, '2015-03-01 01:20:08.000000', 'consum', 0.0216, 'lps'),
	(426748, 123, '2015-03-01 01:20:09.000000', 'consum', 0.0211, 'lps'),
	(426749, 123, '2015-03-01 01:20:10.000000', 'consum', 0.0211, 'lps'),
	(426750, 123, '2015-03-01 01:20:11.000000', 'consum', 0.0211, 'lps'),
	(426751, 123, '2015-03-01 01:20:12.000000', 'consum', 0.0212, 'lps'),
	(426752, 123, '2015-03-01 01:20:13.000000', 'consum', 0.0218, 'lps'),
	(426753, 123, '2015-03-01 01:20:14.000000', 'consum', 0.0219, 'lps'),
	(426754, 123, '2015-03-01 01:20:15.000000', 'consum', 0.0218, 'lps'),
	(426755, 123, '2015-03-01 01:20:16.000000', 'consum', 0.0211, 'lps'),
	(426756, 123, '2015-03-01 01:20:17.000000', 'consum', 0.0217, 'lps'),
	(426757, 123, '2015-03-01 01:20:18.000000', 'consum', 0.0215, 'lps'),
	(426758, 123, '2015-03-01 01:20:19.000000', 'consum', 0.0216, 'lps'),
	(426759, 123, '2015-03-01 01:20:20.000000', 'consum', 0.0211, 'lps'),
	(426760, 123, '2015-03-01 01:20:21.000000', 'consum', 0.0211, 'lps'),
	(426761, 123, '2015-03-01 01:20:22.000000', 'consum', 0.0214, 'lps'),
	(426762, 123, '2015-03-01 01:20:23.000000', 'consum', 0.0213, 'lps'),
	(426763, 123, '2015-03-01 01:20:24.000000', 'consum', 0.0215, 'lps'),
	(426764, 123, '2015-03-01 01:20:25.000000', 'consum', 0.0211, 'lps'),
	(426765, 123, '2015-03-01 01:20:26.000000', 'consum', 0.0217, 'lps'),
	(426766, 123, '2015-03-01 01:20:27.000000', 'consum', 0.0214, 'lps'),
	(426767, 123, '2015-03-01 01:20:28.000000', 'consum', 0.0222, 'lps'),
	(426768, 123, '2015-03-01 01:20:29.000000', 'consum', 0.0221, 'lps'),
	(426769, 123, '2015-03-01 01:20:30.000000', 'consum', 0.0216, 'lps'),
	(426770, 123, '2015-03-01 01:20:31.000000', 'consum', 0.0210, 'lps'),
	(426771, 123, '2015-03-01 01:20:32.000000', 'consum', 0.0215, 'lps'),
	(426772, 123, '2015-03-01 01:20:33.000000', 'consum', 0.0210, 'lps'),
	(426773, 123, '2015-03-01 01:20:34.000000', 'consum', 0.0211, 'lps'),
	(426774, 123, '2015-03-01 01:20:35.000000', 'consum', 0.0214, 'lps'),
	(426775, 123, '2015-03-01 01:20:36.000000', 'consum', 0.0215, 'lps'),
	(426776, 123, '2015-03-01 01:20:37.000000', 'consum', 0.0221, 'lps'),
	(426777, 123, '2015-03-01 01:20:38.000000', 'consum', 0.0215, 'lps'),
	(426778, 123, '2015-03-01 01:20:39.000000', 'consum', 0.0215, 'lps'),
	(426779, 123, '2015-03-01 01:20:40.000000', 'consum', 0.0219, 'lps'),
	(426780, 123, '2015-03-01 01:20:41.000000', 'consum', 0.0213, 'lps'),
	(426781, 123, '2015-03-01 01:20:42.000000', 'consum', 0.0215, 'lps'),
	(426782, 123, '2015-03-01 01:20:43.000000', 'consum', 0.0212, 'lps'),
	(426783, 123, '2015-03-01 01:20:44.000000', 'consum', 0.0220, 'lps'),
	(426784, 123, '2015-03-01 01:20:45.000000', 'consum', 0.0213, 'lps'),
	(426785, 123, '2015-03-01 01:20:46.000000', 'consum', 0.0210, 'lps'),
	(426786, 123, '2015-03-01 01:20:47.000000', 'consum', 0.0216, 'lps'),
	(426787, 123, '2015-03-01 01:20:48.000000', 'consum', 0.0214, 'lps'),
	(426788, 123, '2015-03-01 01:20:49.000000', 'consum', 0.0213, 'lps'),
	(426789, 123, '2015-03-01 01:20:50.000000', 'consum', 0.0215, 'lps'),
	(426790, 123, '2015-03-01 01:20:51.000000', 'consum', 0.0210, 'lps'),
	(426791, 123, '2015-03-01 01:20:52.000000', 'consum', 0.0211, 'lps'),
	(426792, 123, '2015-03-01 01:20:53.000000', 'consum', 0.0215, 'lps'),
	(426793, 123, '2015-03-01 01:20:54.000000', 'consum', 0.0221, 'lps'),
	(426794, 123, '2015-03-01 01:20:55.000000', 'consum', 0.0210, 'lps'),
	(426795, 123, '2015-03-01 01:20:56.000000', 'consum', 0.0217, 'lps'),
	(426796, 123, '2015-03-01 01:20:57.000000', 'consum', 0.0218, 'lps'),
	(426797, 123, '2015-03-01 01:20:58.000000', 'consum', 0.0217, 'lps'),
	(426798, 123, '2015-03-01 01:20:59.000000', 'consum', 0.0210, 'lps'),
	(426799, 123, '2015-03-01 01:21:00.000000', 'consum', 0.0216, 'lps'),
	(426800, 123, '2015-03-01 01:21:01.000000', 'consum', 0.0215, 'lps'),
	(426801, 123, '2015-03-01 01:21:02.000000', 'consum', 0.0217, 'lps'),
	(426802, 123, '2015-03-01 01:21:03.000000', 'consum', 0.0217, 'lps'),
	(426803, 123, '2015-03-01 01:21:04.000000', 'consum', 0.0211, 'lps'),
	(426804, 123, '2015-03-01 01:21:05.000000', 'consum', 0.0219, 'lps'),
	(426805, 123, '2015-03-01 01:21:06.000000', 'consum', 0.0217, 'lps'),
	(426806, 123, '2015-03-01 01:21:07.000000', 'consum', 0.0217, 'lps'),
	(426807, 123, '2015-03-01 01:21:08.000000', 'consum', 0.0211, 'lps'),
	(426808, 123, '2015-03-01 01:21:09.000000', 'consum', 0.0221, 'lps'),
	(426809, 123, '2015-03-01 01:21:10.000000', 'consum', 0.0210, 'lps'),
	(426810, 123, '2015-03-01 01:21:11.000000', 'consum', 0.0219, 'lps'),
	(426811, 123, '2015-03-01 01:21:12.000000', 'consum', 0.0213, 'lps'),
	(426812, 123, '2015-03-01 01:21:13.000000', 'consum', 0.0213, 'lps'),
	(426813, 123, '2015-03-01 01:21:14.000000', 'consum', 0.0217, 'lps'),
	(426814, 123, '2015-03-01 01:21:15.000000', 'consum', 0.0211, 'lps'),
	(426815, 123, '2015-03-01 01:21:16.000000', 'consum', 0.0218, 'lps'),
	(426816, 123, '2015-03-01 01:21:17.000000', 'consum', 0.0222, 'lps'),
	(426817, 123, '2015-03-01 01:21:18.000000', 'consum', 0.0222, 'lps'),
	(426818, 123, '2015-03-01 01:21:19.000000', 'consum', 0.0221, 'lps'),
	(426819, 123, '2015-03-01 01:21:20.000000', 'consum', 0.0216, 'lps'),
	(426820, 123, '2015-03-01 01:21:21.000000', 'consum', 0.0220, 'lps'),
	(426821, 123, '2015-03-01 01:21:22.000000', 'consum', 0.0215, 'lps'),
	(426822, 123, '2015-03-01 01:21:23.000000', 'consum', 0.0221, 'lps'),
	(426823, 123, '2015-03-01 01:21:24.000000', 'consum', 0.0212, 'lps'),
	(426824, 123, '2015-03-01 01:21:25.000000', 'consum', 0.0214, 'lps'),
	(426825, 123, '2015-03-01 01:21:26.000000', 'consum', 0.0211, 'lps'),
	(426826, 123, '2015-03-01 01:21:27.000000', 'consum', 0.0218, 'lps'),
	(426827, 123, '2015-03-01 01:21:28.000000', 'consum', 0.0220, 'lps'),
	(426828, 123, '2015-03-01 01:21:29.000000', 'consum', 0.0222, 'lps'),
	(426829, 123, '2015-03-01 01:21:30.000000', 'consum', 0.0216, 'lps'),
	(426830, 123, '2015-03-01 01:21:31.000000', 'consum', 0.0219, 'lps'),
	(426831, 123, '2015-03-01 01:21:32.000000', 'consum', 0.0222, 'lps'),
	(426832, 123, '2015-03-01 01:21:33.000000', 'consum', 0.0219, 'lps'),
	(426833, 123, '2015-03-01 01:21:34.000000', 'consum', 0.0219, 'lps'),
	(426834, 123, '2015-03-01 01:21:35.000000', 'consum', 0.0215, 'lps'),
	(426835, 123, '2015-03-01 01:21:36.000000', 'consum', 0.0221, 'lps'),
	(426836, 123, '2015-03-01 01:21:37.000000', 'consum', 0.0213, 'lps'),
	(426837, 123, '2015-03-01 01:21:38.000000', 'consum', 0.0217, 'lps'),
	(426838, 123, '2015-03-01 01:21:39.000000', 'consum', 0.0211, 'lps'),
	(426839, 123, '2015-03-01 01:21:40.000000', 'consum', 0.0220, 'lps'),
	(426840, 123, '2015-03-01 01:21:41.000000', 'consum', 0.0218, 'lps'),
	(426841, 123, '2015-03-01 01:21:42.000000', 'consum', 0.0221, 'lps'),
	(426842, 123, '2015-03-01 01:21:43.000000', 'consum', 0.0216, 'lps'),
	(426843, 123, '2015-03-01 01:21:44.000000', 'consum', 0.0220, 'lps'),
	(426844, 123, '2015-03-01 01:21:45.000000', 'consum', 0.0216, 'lps'),
	(426845, 123, '2015-03-01 01:21:46.000000', 'consum', 0.0210, 'lps'),
	(426846, 123, '2015-03-01 01:21:47.000000', 'consum', 0.0219, 'lps'),
	(426847, 123, '2015-03-01 01:21:48.000000', 'consum', 0.0215, 'lps'),
	(426848, 123, '2015-03-01 01:21:49.000000', 'consum', 0.0211, 'lps'),
	(426849, 123, '2015-03-01 01:21:50.000000', 'consum', 0.0212, 'lps'),
	(426850, 123, '2015-03-01 01:21:51.000000', 'consum', 0.0218, 'lps'),
	(426851, 123, '2015-03-01 01:21:52.000000', 'consum', 0.0219, 'lps'),
	(426852, 123, '2015-03-01 01:21:53.000000', 'consum', 0.0218, 'lps'),
	(426853, 123, '2015-03-01 01:21:54.000000', 'consum', 0.0212, 'lps'),
	(426854, 123, '2015-03-01 01:21:55.000000', 'consum', 0.0210, 'lps'),
	(426855, 123, '2015-03-01 01:21:56.000000', 'consum', 0.0217, 'lps'),
	(426856, 123, '2015-03-01 01:21:57.000000', 'consum', 0.0218, 'lps'),
	(426857, 123, '2015-03-01 01:21:58.000000', 'consum', 0.0217, 'lps'),
	(426858, 123, '2015-03-01 01:21:59.000000', 'consum', 0.0211, 'lps'),
	(426859, 123, '2015-03-01 01:22:00.000000', 'consum', 0.0217, 'lps'),
	(426860, 123, '2015-03-01 01:22:01.000000', 'consum', 0.0220, 'lps'),
	(426861, 123, '2015-03-01 01:22:02.000000', 'consum', 0.0212, 'lps'),
	(426862, 123, '2015-03-01 01:22:03.000000', 'consum', 0.0215, 'lps'),
	(426863, 123, '2015-03-01 01:22:04.000000', 'consum', 0.0216, 'lps'),
	(426864, 123, '2015-03-01 01:22:05.000000', 'consum', 0.0214, 'lps'),
	(426865, 123, '2015-03-01 01:22:06.000000', 'consum', 0.0213, 'lps'),
	(426866, 123, '2015-03-01 01:22:07.000000', 'consum', 0.0211, 'lps'),
	(426867, 123, '2015-03-01 01:22:08.000000', 'consum', 0.0220, 'lps'),
	(426868, 123, '2015-03-01 01:22:09.000000', 'consum', 0.0219, 'lps'),
	(426869, 123, '2015-03-01 01:22:10.000000', 'consum', 0.0213, 'lps'),
	(426870, 123, '2015-03-01 01:22:11.000000', 'consum', 0.0212, 'lps'),
	(426871, 123, '2015-03-01 01:22:12.000000', 'consum', 0.0210, 'lps'),
	(426872, 123, '2015-03-01 01:22:13.000000', 'consum', 0.0217, 'lps'),
	(426873, 123, '2015-03-01 01:22:14.000000', 'consum', 0.0222, 'lps'),
	(426874, 123, '2015-03-01 01:22:15.000000', 'consum', 0.0222, 'lps'),
	(426875, 123, '2015-03-01 01:22:16.000000', 'consum', 0.0210, 'lps'),
	(426876, 123, '2015-03-01 01:22:17.000000', 'consum', 0.0215, 'lps'),
	(426877, 123, '2015-03-01 01:22:18.000000', 'consum', 0.0219, 'lps'),
	(426878, 123, '2015-03-01 01:22:19.000000', 'consum', 0.0217, 'lps'),
	(426879, 123, '2015-03-01 01:22:20.000000', 'consum', 0.0219, 'lps'),
	(426880, 123, '2015-03-01 01:22:21.000000', 'consum', 0.0219, 'lps'),
	(426881, 123, '2015-03-01 01:22:22.000000', 'consum', 0.0216, 'lps'),
	(426882, 123, '2015-03-01 01:22:23.000000', 'consum', 0.0214, 'lps'),
	(426883, 123, '2015-03-01 01:22:24.000000', 'consum', 0.0212, 'lps'),
	(426884, 123, '2015-03-01 01:22:25.000000', 'consum', 0.0220, 'lps'),
	(426885, 123, '2015-03-01 01:22:26.000000', 'consum', 0.0217, 'lps'),
	(426886, 123, '2015-03-01 01:22:27.000000', 'consum', 0.0215, 'lps'),
	(426887, 123, '2015-03-01 01:22:28.000000', 'consum', 0.0214, 'lps'),
	(426888, 123, '2015-03-01 01:22:29.000000', 'consum', 0.0214, 'lps'),
	(426889, 123, '2015-03-01 01:22:30.000000', 'consum', 0.0220, 'lps'),
	(426890, 123, '2015-03-01 01:22:31.000000', 'consum', 0.0212, 'lps'),
	(426891, 123, '2015-03-01 01:22:32.000000', 'consum', 0.0213, 'lps'),
	(426892, 123, '2015-03-01 01:22:33.000000', 'consum', 0.0220, 'lps'),
	(426893, 123, '2015-03-01 01:22:34.000000', 'consum', 0.0213, 'lps'),
	(426894, 123, '2015-03-01 01:22:35.000000', 'consum', 0.0220, 'lps'),
	(426895, 123, '2015-03-01 01:22:36.000000', 'consum', 0.0215, 'lps'),
	(426896, 123, '2015-03-01 01:22:37.000000', 'consum', 0.0216, 'lps'),
	(426897, 123, '2015-03-01 01:22:38.000000', 'consum', 0.0214, 'lps'),
	(426898, 123, '2015-03-01 01:22:39.000000', 'consum', 0.0211, 'lps'),
	(426899, 123, '2015-03-01 01:22:40.000000', 'consum', 0.0217, 'lps'),
	(426900, 123, '2015-03-01 01:22:41.000000', 'consum', 0.0216, 'lps'),
	(426901, 123, '2015-03-01 01:22:42.000000', 'consum', 0.0221, 'lps'),
	(426902, 123, '2015-03-01 01:22:43.000000', 'consum', 0.0222, 'lps'),
	(426903, 123, '2015-03-01 01:22:44.000000', 'consum', 0.0210, 'lps'),
	(426904, 123, '2015-03-01 01:22:45.000000', 'consum', 0.0216, 'lps'),
	(426905, 123, '2015-03-01 01:22:46.000000', 'consum', 0.0213, 'lps'),
	(426906, 123, '2015-03-01 01:22:47.000000', 'consum', 0.0221, 'lps'),
	(426907, 123, '2015-03-01 01:22:48.000000', 'consum', 0.0215, 'lps'),
	(426908, 123, '2015-03-01 01:22:49.000000', 'consum', 0.0219, 'lps'),
	(426909, 123, '2015-03-01 01:22:50.000000', 'consum', 0.0212, 'lps'),
	(426910, 123, '2015-03-01 01:22:51.000000', 'consum', 0.0219, 'lps'),
	(426911, 123, '2015-03-01 01:22:52.000000', 'consum', 0.0211, 'lps'),
	(426912, 123, '2015-03-01 01:22:53.000000', 'consum', 0.0214, 'lps'),
	(426913, 123, '2015-03-01 01:22:54.000000', 'consum', 0.0216, 'lps'),
	(426914, 123, '2015-03-01 01:22:55.000000', 'consum', 0.0213, 'lps'),
	(426915, 123, '2015-03-01 01:22:56.000000', 'consum', 0.0211, 'lps'),
	(426916, 123, '2015-03-01 01:22:57.000000', 'consum', 0.0216, 'lps'),
	(426917, 123, '2015-03-01 01:22:58.000000', 'consum', 0.0214, 'lps'),
	(426918, 123, '2015-03-01 01:22:59.000000', 'consum', 0.0213, 'lps'),
	(426919, 123, '2015-03-01 01:23:00.000000', 'consum', 0.0211, 'lps'),
	(426920, 123, '2015-03-01 01:23:01.000000', 'consum', 0.0220, 'lps'),
	(426921, 123, '2015-03-01 01:23:02.000000', 'consum', 0.0218, 'lps'),
	(426922, 123, '2015-03-01 01:23:03.000000', 'consum', 0.0210, 'lps'),
	(426923, 123, '2015-03-01 01:23:04.000000', 'consum', 0.0210, 'lps'),
	(426924, 123, '2015-03-01 01:23:05.000000', 'consum', 0.0213, 'lps'),
	(426925, 123, '2015-03-01 01:23:06.000000', 'consum', 0.0212, 'lps'),
	(426926, 123, '2015-03-01 01:23:07.000000', 'consum', 0.0212, 'lps'),
	(426927, 123, '2015-03-01 01:23:08.000000', 'consum', 0.0213, 'lps'),
	(426928, 123, '2015-03-01 01:23:09.000000', 'consum', 0.0219, 'lps'),
	(426929, 123, '2015-03-01 01:23:10.000000', 'consum', 0.0210, 'lps'),
	(426930, 123, '2015-03-01 01:23:11.000000', 'consum', 0.0222, 'lps'),
	(426931, 123, '2015-03-01 01:23:12.000000', 'consum', 0.0217, 'lps'),
	(426932, 123, '2015-03-01 01:23:13.000000', 'consum', 0.0210, 'lps'),
	(426933, 123, '2015-03-01 01:23:14.000000', 'consum', 0.0217, 'lps'),
	(426934, 123, '2015-03-01 01:23:15.000000', 'consum', 0.0218, 'lps'),
	(426935, 123, '2015-03-01 01:23:16.000000', 'consum', 0.0215, 'lps'),
	(426936, 123, '2015-03-01 01:23:17.000000', 'consum', 0.0213, 'lps'),
	(426937, 123, '2015-03-01 01:23:18.000000', 'consum', 0.0221, 'lps'),
	(426938, 123, '2015-03-01 01:23:19.000000', 'consum', 0.0220, 'lps'),
	(426939, 123, '2015-03-01 01:23:20.000000', 'consum', 0.0214, 'lps'),
	(426940, 123, '2015-03-01 01:23:21.000000', 'consum', 0.0215, 'lps'),
	(426941, 123, '2015-03-01 01:23:22.000000', 'consum', 0.0210, 'lps'),
	(426942, 123, '2015-03-01 01:23:23.000000', 'consum', 0.0222, 'lps'),
	(426943, 123, '2015-03-01 01:23:24.000000', 'consum', 0.0216, 'lps'),
	(426944, 123, '2015-03-01 01:23:25.000000', 'consum', 0.0220, 'lps'),
	(426945, 123, '2015-03-01 01:23:26.000000', 'consum', 0.0215, 'lps'),
	(426946, 123, '2015-03-01 01:23:27.000000', 'consum', 0.0218, 'lps'),
	(426947, 123, '2015-03-01 01:23:28.000000', 'consum', 0.0210, 'lps'),
	(426948, 123, '2015-03-01 01:23:29.000000', 'consum', 0.0212, 'lps'),
	(426949, 123, '2015-03-01 01:23:30.000000', 'consum', 0.0222, 'lps'),
	(426950, 123, '2015-03-01 01:23:31.000000', 'consum', 0.0211, 'lps'),
	(426951, 123, '2015-03-01 01:23:32.000000', 'consum', 0.0219, 'lps'),
	(426952, 123, '2015-03-01 01:23:33.000000', 'consum', 0.0214, 'lps'),
	(426953, 123, '2015-03-01 01:23:34.000000', 'consum', 0.0218, 'lps'),
	(426954, 123, '2015-03-01 01:23:35.000000', 'consum', 0.0210, 'lps'),
	(426955, 123, '2015-03-01 01:23:36.000000', 'consum', 0.0214, 'lps'),
	(426956, 123, '2015-03-01 01:23:37.000000', 'consum', 0.0216, 'lps'),
	(426957, 123, '2015-03-01 01:23:38.000000', 'consum', 0.0215, 'lps'),
	(426958, 123, '2015-03-01 01:23:39.000000', 'consum', 0.0218, 'lps'),
	(426959, 123, '2015-03-01 01:23:40.000000', 'consum', 0.0221, 'lps'),
	(426960, 123, '2015-03-01 01:23:41.000000', 'consum', 0.0216, 'lps'),
	(426961, 123, '2015-03-01 01:23:42.000000', 'consum', 0.0220, 'lps'),
	(426962, 123, '2015-03-01 01:23:43.000000', 'consum', 0.0216, 'lps'),
	(426963, 123, '2015-03-01 01:23:44.000000', 'consum', 0.0213, 'lps'),
	(426964, 123, '2015-03-01 01:23:45.000000', 'consum', 0.0219, 'lps'),
	(426965, 123, '2015-03-01 01:23:46.000000', 'consum', 0.0222, 'lps'),
	(426966, 123, '2015-03-01 01:23:47.000000', 'consum', 0.0218, 'lps'),
	(426967, 123, '2015-03-01 01:23:48.000000', 'consum', 0.0214, 'lps'),
	(426968, 123, '2015-03-01 01:23:49.000000', 'consum', 0.0220, 'lps'),
	(426969, 123, '2015-03-01 01:23:50.000000', 'consum', 0.0220, 'lps'),
	(426970, 123, '2015-03-01 01:23:51.000000', 'consum', 0.0221, 'lps'),
	(426971, 123, '2015-03-01 01:23:52.000000', 'consum', 0.0221, 'lps'),
	(426972, 123, '2015-03-01 01:23:53.000000', 'consum', 0.0219, 'lps'),
	(426973, 123, '2015-03-01 01:23:54.000000', 'consum', 0.0222, 'lps'),
	(426974, 123, '2015-03-01 01:23:55.000000', 'consum', 0.0220, 'lps'),
	(426975, 123, '2015-03-01 01:23:56.000000', 'consum', 0.0210, 'lps'),
	(426976, 123, '2015-03-01 01:23:57.000000', 'consum', 0.0219, 'lps'),
	(426977, 123, '2015-03-01 01:23:58.000000', 'consum', 0.0218, 'lps'),
	(426978, 123, '2015-03-01 01:23:59.000000', 'consum', 0.0210, 'lps'),
	(426979, 123, '2015-03-01 01:24:00.000000', 'consum', 0.0211, 'lps'),
	(426980, 123, '2015-03-01 01:24:01.000000', 'consum', 0.0216, 'lps'),
	(426981, 123, '2015-03-01 01:24:02.000000', 'consum', 0.0212, 'lps'),
	(426982, 123, '2015-03-01 01:24:03.000000', 'consum', 0.0213, 'lps'),
	(426983, 123, '2015-03-01 01:24:04.000000', 'consum', 0.0210, 'lps'),
	(426984, 123, '2015-03-01 01:24:05.000000', 'consum', 0.0214, 'lps'),
	(426985, 123, '2015-03-01 01:24:06.000000', 'consum', 0.0218, 'lps'),
	(426986, 123, '2015-03-01 01:24:07.000000', 'consum', 0.0212, 'lps'),
	(426987, 123, '2015-03-01 01:24:08.000000', 'consum', 0.0221, 'lps'),
	(426988, 123, '2015-03-01 01:24:09.000000', 'consum', 0.0220, 'lps'),
	(426989, 123, '2015-03-01 01:24:10.000000', 'consum', 0.0217, 'lps'),
	(426990, 123, '2015-03-01 01:24:11.000000', 'consum', 0.0213, 'lps'),
	(426991, 123, '2015-03-01 01:24:12.000000', 'consum', 0.0217, 'lps'),
	(426992, 123, '2015-03-01 01:24:13.000000', 'consum', 0.0212, 'lps'),
	(426993, 123, '2015-03-01 01:24:14.000000', 'consum', 0.0210, 'lps'),
	(426994, 123, '2015-03-01 01:24:15.000000', 'consum', 0.0219, 'lps'),
	(426995, 123, '2015-03-01 01:24:16.000000', 'consum', 0.0218, 'lps'),
	(426996, 123, '2015-03-01 01:24:17.000000', 'consum', 0.0222, 'lps'),
	(426997, 123, '2015-03-01 01:24:18.000000', 'consum', 0.0221, 'lps'),
	(426998, 123, '2015-03-01 01:24:19.000000', 'consum', 0.0218, 'lps'),
	(426999, 123, '2015-03-01 01:24:20.000000', 'consum', 0.0218, 'lps'),
	(427000, 123, '2015-03-01 01:24:21.000000', 'consum', 0.0212, 'lps'),
	(427001, 123, '2015-03-01 01:24:22.000000', 'consum', 0.0221, 'lps'),
	(427002, 123, '2015-03-01 01:24:23.000000', 'consum', 0.0211, 'lps'),
	(427003, 123, '2015-03-01 01:24:24.000000', 'consum', 0.0218, 'lps'),
	(427004, 123, '2015-03-01 01:24:25.000000', 'consum', 0.0211, 'lps'),
	(427005, 123, '2015-03-01 01:24:26.000000', 'consum', 0.0217, 'lps'),
	(427006, 123, '2015-03-01 01:24:27.000000', 'consum', 0.0217, 'lps'),
	(427007, 123, '2015-03-01 01:24:28.000000', 'consum', 0.0212, 'lps'),
	(427008, 123, '2015-03-01 01:24:29.000000', 'consum', 0.0213, 'lps'),
	(427009, 123, '2015-03-01 01:24:30.000000', 'consum', 0.0217, 'lps'),
	(427010, 123, '2015-03-01 01:24:31.000000', 'consum', 0.0213, 'lps'),
	(427011, 123, '2015-03-01 01:24:32.000000', 'consum', 0.0215, 'lps'),
	(427012, 123, '2015-03-01 01:24:33.000000', 'consum', 0.0213, 'lps'),
	(427013, 123, '2015-03-01 01:24:34.000000', 'consum', 0.0211, 'lps'),
	(427014, 123, '2015-03-01 01:24:35.000000', 'consum', 0.0222, 'lps'),
	(427015, 123, '2015-03-01 01:24:36.000000', 'consum', 0.0212, 'lps'),
	(427016, 123, '2015-03-01 01:24:37.000000', 'consum', 0.0212, 'lps'),
	(427017, 123, '2015-03-01 01:24:38.000000', 'consum', 0.0216, 'lps'),
	(427018, 123, '2015-03-01 01:24:39.000000', 'consum', 0.0221, 'lps'),
	(427019, 123, '2015-03-01 01:24:40.000000', 'consum', 0.0210, 'lps'),
	(427020, 123, '2015-03-01 01:24:41.000000', 'consum', 0.0214, 'lps'),
	(427021, 123, '2015-03-01 01:24:42.000000', 'consum', 0.0219, 'lps'),
	(427022, 123, '2015-03-01 01:24:43.000000', 'consum', 0.0215, 'lps'),
	(427023, 123, '2015-03-01 01:24:44.000000', 'consum', 0.0212, 'lps'),
	(427024, 123, '2015-03-01 01:24:45.000000', 'consum', 0.0217, 'lps'),
	(427025, 123, '2015-03-01 01:24:46.000000', 'consum', 0.0213, 'lps'),
	(427026, 123, '2015-03-01 01:24:47.000000', 'consum', 0.0217, 'lps'),
	(427027, 123, '2015-03-01 01:24:48.000000', 'consum', 0.0213, 'lps'),
	(427028, 123, '2015-03-01 01:24:49.000000', 'consum', 0.0214, 'lps'),
	(427029, 123, '2015-03-01 01:24:50.000000', 'consum', 0.0210, 'lps'),
	(427030, 123, '2015-03-01 01:24:51.000000', 'consum', 0.0212, 'lps'),
	(427031, 123, '2015-03-01 01:24:52.000000', 'consum', 0.0222, 'lps'),
	(427032, 123, '2015-03-01 01:24:53.000000', 'consum', 0.0210, 'lps'),
	(427033, 123, '2015-03-01 01:24:54.000000', 'consum', 0.0214, 'lps'),
	(427034, 123, '2015-03-01 01:24:55.000000', 'consum', 0.0217, 'lps'),
	(427035, 123, '2015-03-01 01:24:56.000000', 'consum', 0.0222, 'lps'),
	(427036, 123, '2015-03-01 01:24:57.000000', 'consum', 0.0222, 'lps'),
	(427037, 123, '2015-03-01 01:24:58.000000', 'consum', 0.0211, 'lps'),
	(427038, 123, '2015-03-01 01:24:59.000000', 'consum', 0.0215, 'lps'),
	(427039, 123, '2015-03-01 01:25:00.000000', 'consum', 0.0222, 'lps'),
	(427040, 123, '2015-03-01 01:25:01.000000', 'consum', 0.0214, 'lps'),
	(427041, 123, '2015-03-01 01:25:02.000000', 'consum', 0.0222, 'lps'),
	(427042, 123, '2015-03-01 01:25:03.000000', 'consum', 0.0218, 'lps'),
	(427043, 123, '2015-03-01 01:25:04.000000', 'consum', 0.0214, 'lps'),
	(427044, 123, '2015-03-01 01:25:05.000000', 'consum', 0.0219, 'lps'),
	(427045, 123, '2015-03-01 01:25:06.000000', 'consum', 0.0218, 'lps'),
	(427046, 123, '2015-03-01 01:25:07.000000', 'consum', 0.0211, 'lps'),
	(427047, 123, '2015-03-01 01:25:08.000000', 'consum', 0.0219, 'lps'),
	(427048, 123, '2015-03-01 01:25:09.000000', 'consum', 0.0211, 'lps'),
	(427049, 123, '2015-03-01 01:25:10.000000', 'consum', 0.0215, 'lps'),
	(427050, 123, '2015-03-01 01:25:11.000000', 'consum', 0.0221, 'lps'),
	(427051, 123, '2015-03-01 01:25:12.000000', 'consum', 0.0222, 'lps'),
	(427052, 123, '2015-03-01 01:25:13.000000', 'consum', 0.0214, 'lps'),
	(427053, 123, '2015-03-01 01:25:14.000000', 'consum', 0.0221, 'lps'),
	(427054, 123, '2015-03-01 01:25:15.000000', 'consum', 0.0212, 'lps'),
	(427055, 123, '2015-03-01 01:25:16.000000', 'consum', 0.0214, 'lps'),
	(427056, 123, '2015-03-01 01:25:17.000000', 'consum', 0.0211, 'lps'),
	(427057, 123, '2015-03-01 01:25:18.000000', 'consum', 0.0218, 'lps'),
	(427058, 123, '2015-03-01 01:25:19.000000', 'consum', 0.0219, 'lps'),
	(427059, 123, '2015-03-01 01:25:20.000000', 'consum', 0.0220, 'lps'),
	(427060, 123, '2015-03-01 01:25:21.000000', 'consum', 0.0222, 'lps'),
	(427061, 123, '2015-03-01 01:25:22.000000', 'consum', 0.0213, 'lps'),
	(427062, 123, '2015-03-01 01:25:23.000000', 'consum', 0.0216, 'lps'),
	(427063, 123, '2015-03-01 01:25:24.000000', 'consum', 0.0220, 'lps'),
	(427064, 123, '2015-03-01 01:25:25.000000', 'consum', 0.0217, 'lps'),
	(427065, 123, '2015-03-01 01:25:26.000000', 'consum', 0.0213, 'lps'),
	(427066, 123, '2015-03-01 01:25:27.000000', 'consum', 0.0218, 'lps'),
	(427067, 123, '2015-03-01 01:25:28.000000', 'consum', 0.0217, 'lps'),
	(427068, 123, '2015-03-01 01:25:29.000000', 'consum', 0.0220, 'lps'),
	(427069, 123, '2015-03-01 01:25:30.000000', 'consum', 0.0215, 'lps'),
	(427070, 123, '2015-03-01 01:25:31.000000', 'consum', 0.0219, 'lps'),
	(427071, 123, '2015-03-01 01:25:32.000000', 'consum', 0.0212, 'lps'),
	(427072, 123, '2015-03-01 01:25:33.000000', 'consum', 0.0222, 'lps'),
	(427073, 123, '2015-03-01 01:25:34.000000', 'consum', 0.0212, 'lps'),
	(427074, 123, '2015-03-01 01:25:35.000000', 'consum', 0.0211, 'lps'),
	(427075, 123, '2015-03-01 01:25:36.000000', 'consum', 0.0221, 'lps'),
	(427076, 123, '2015-03-01 01:25:37.000000', 'consum', 0.0211, 'lps'),
	(427077, 123, '2015-03-01 01:25:38.000000', 'consum', 0.0222, 'lps'),
	(427078, 123, '2015-03-01 01:25:39.000000', 'consum', 0.0215, 'lps'),
	(427079, 123, '2015-03-01 01:25:40.000000', 'consum', 0.0214, 'lps'),
	(427080, 123, '2015-03-01 01:25:41.000000', 'consum', 0.0215, 'lps'),
	(427081, 123, '2015-03-01 01:25:42.000000', 'consum', 0.0211, 'lps'),
	(427082, 123, '2015-03-01 01:25:43.000000', 'consum', 0.0213, 'lps'),
	(427083, 123, '2015-03-01 01:25:44.000000', 'consum', 0.0211, 'lps'),
	(427084, 123, '2015-03-01 01:25:45.000000', 'consum', 0.0220, 'lps'),
	(427085, 123, '2015-03-01 01:25:46.000000', 'consum', 0.0219, 'lps'),
	(427086, 123, '2015-03-01 01:25:47.000000', 'consum', 0.0211, 'lps'),
	(427087, 123, '2015-03-01 01:25:48.000000', 'consum', 0.0216, 'lps'),
	(427088, 123, '2015-03-01 01:25:49.000000', 'consum', 0.0210, 'lps'),
	(427089, 123, '2015-03-01 01:25:50.000000', 'consum', 0.0218, 'lps'),
	(427090, 123, '2015-03-01 01:25:51.000000', 'consum', 0.0212, 'lps'),
	(427091, 123, '2015-03-01 01:25:52.000000', 'consum', 0.0222, 'lps'),
	(427092, 123, '2015-03-01 01:25:53.000000', 'consum', 0.0214, 'lps'),
	(427093, 123, '2015-03-01 01:25:54.000000', 'consum', 0.0220, 'lps'),
	(427094, 123, '2015-03-01 01:25:55.000000', 'consum', 0.0220, 'lps'),
	(427095, 123, '2015-03-01 01:25:56.000000', 'consum', 0.0220, 'lps'),
	(427096, 123, '2015-03-01 01:25:57.000000', 'consum', 0.0217, 'lps'),
	(427097, 123, '2015-03-01 01:25:58.000000', 'consum', 0.0216, 'lps'),
	(427098, 123, '2015-03-01 01:25:59.000000', 'consum', 0.0220, 'lps'),
	(427099, 123, '2015-03-01 01:26:00.000000', 'consum', 0.0214, 'lps'),
	(427100, 123, '2015-03-01 01:26:01.000000', 'consum', 0.0215, 'lps'),
	(427101, 123, '2015-03-01 01:26:02.000000', 'consum', 0.0210, 'lps'),
	(427102, 123, '2015-03-01 01:26:03.000000', 'consum', 0.0210, 'lps'),
	(427103, 123, '2015-03-01 01:26:04.000000', 'consum', 0.0222, 'lps'),
	(427104, 123, '2015-03-01 01:26:05.000000', 'consum', 0.0217, 'lps'),
	(427105, 123, '2015-03-01 01:26:06.000000', 'consum', 0.0211, 'lps'),
	(427106, 123, '2015-03-01 01:26:07.000000', 'consum', 0.0222, 'lps'),
	(427107, 123, '2015-03-01 01:26:08.000000', 'consum', 0.0216, 'lps'),
	(427108, 123, '2015-03-01 01:26:09.000000', 'consum', 0.0218, 'lps'),
	(427109, 123, '2015-03-01 01:26:10.000000', 'consum', 0.0220, 'lps'),
	(427110, 123, '2015-03-01 01:26:11.000000', 'consum', 0.0221, 'lps'),
	(427111, 123, '2015-03-01 01:26:12.000000', 'consum', 0.0210, 'lps'),
	(427112, 123, '2015-03-01 01:26:13.000000', 'consum', 0.0219, 'lps'),
	(427113, 123, '2015-03-01 01:26:14.000000', 'consum', 0.0214, 'lps'),
	(427114, 123, '2015-03-01 01:26:15.000000', 'consum', 0.0219, 'lps'),
	(427115, 123, '2015-03-01 01:26:16.000000', 'consum', 0.0217, 'lps'),
	(427116, 123, '2015-03-01 01:26:17.000000', 'consum', 0.0219, 'lps'),
	(427117, 123, '2015-03-01 01:26:18.000000', 'consum', 0.0221, 'lps'),
	(427118, 123, '2015-03-01 01:26:19.000000', 'consum', 0.0213, 'lps'),
	(427119, 123, '2015-03-01 01:26:20.000000', 'consum', 0.0218, 'lps'),
	(427120, 123, '2015-03-01 01:26:21.000000', 'consum', 0.0215, 'lps'),
	(427121, 123, '2015-03-01 01:26:22.000000', 'consum', 0.0210, 'lps'),
	(427122, 123, '2015-03-01 01:26:23.000000', 'consum', 0.0211, 'lps'),
	(427123, 123, '2015-03-01 01:26:24.000000', 'consum', 0.0216, 'lps'),
	(427124, 123, '2015-03-01 01:26:25.000000', 'consum', 0.0212, 'lps'),
	(427125, 123, '2015-03-01 01:26:26.000000', 'consum', 0.0216, 'lps'),
	(427126, 123, '2015-03-01 01:26:27.000000', 'consum', 0.0222, 'lps'),
	(427127, 123, '2015-03-01 01:26:28.000000', 'consum', 0.0213, 'lps'),
	(427128, 123, '2015-03-01 01:26:29.000000', 'consum', 0.0216, 'lps'),
	(427129, 123, '2015-03-01 01:26:30.000000', 'consum', 0.0216, 'lps'),
	(427130, 123, '2015-03-01 01:26:31.000000', 'consum', 0.0212, 'lps'),
	(427131, 123, '2015-03-01 01:26:32.000000', 'consum', 0.0213, 'lps'),
	(427132, 123, '2015-03-01 01:26:33.000000', 'consum', 0.0219, 'lps'),
	(427133, 123, '2015-03-01 01:26:34.000000', 'consum', 0.0222, 'lps'),
	(427134, 123, '2015-03-01 01:26:35.000000', 'consum', 0.0219, 'lps'),
	(427135, 123, '2015-03-01 01:26:36.000000', 'consum', 0.0219, 'lps'),
	(427136, 123, '2015-03-01 01:26:37.000000', 'consum', 0.0215, 'lps'),
	(427137, 123, '2015-03-01 01:26:38.000000', 'consum', 0.0220, 'lps'),
	(427138, 123, '2015-03-01 01:26:39.000000', 'consum', 0.0210, 'lps'),
	(427139, 123, '2015-03-01 01:26:40.000000', 'consum', 0.0216, 'lps'),
	(427140, 123, '2015-03-01 01:26:41.000000', 'consum', 0.0217, 'lps'),
	(427141, 123, '2015-03-01 01:26:42.000000', 'consum', 0.0213, 'lps'),
	(427142, 123, '2015-03-01 01:26:43.000000', 'consum', 0.0218, 'lps'),
	(427143, 123, '2015-03-01 01:26:44.000000', 'consum', 0.0214, 'lps'),
	(427144, 123, '2015-03-01 01:26:45.000000', 'consum', 0.0221, 'lps'),
	(427145, 123, '2015-03-01 01:26:46.000000', 'consum', 0.0213, 'lps'),
	(427146, 123, '2015-03-01 01:26:47.000000', 'consum', 0.0219, 'lps'),
	(427147, 123, '2015-03-01 01:26:48.000000', 'consum', 0.0219, 'lps'),
	(427148, 123, '2015-03-01 01:26:49.000000', 'consum', 0.0219, 'lps'),
	(427149, 123, '2015-03-01 01:26:50.000000', 'consum', 0.0213, 'lps'),
	(427150, 123, '2015-03-01 01:26:51.000000', 'consum', 0.0212, 'lps'),
	(427151, 123, '2015-03-01 01:26:52.000000', 'consum', 0.0210, 'lps'),
	(427152, 123, '2015-03-01 01:26:53.000000', 'consum', 0.0221, 'lps'),
	(427153, 123, '2015-03-01 01:26:54.000000', 'consum', 0.0210, 'lps'),
	(427154, 123, '2015-03-01 01:26:55.000000', 'consum', 0.0216, 'lps'),
	(427155, 123, '2015-03-01 01:26:56.000000', 'consum', 0.0218, 'lps'),
	(427156, 123, '2015-03-01 01:26:57.000000', 'consum', 0.0216, 'lps'),
	(427157, 123, '2015-03-01 01:26:58.000000', 'consum', 0.0218, 'lps'),
	(427158, 123, '2015-03-01 01:26:59.000000', 'consum', 0.0220, 'lps'),
	(427159, 123, '2015-03-01 01:27:00.000000', 'consum', 0.0211, 'lps'),
	(427160, 123, '2015-03-01 01:27:01.000000', 'consum', 0.0211, 'lps'),
	(427161, 123, '2015-03-01 01:27:02.000000', 'consum', 0.0212, 'lps'),
	(427162, 123, '2015-03-01 01:27:03.000000', 'consum', 0.0219, 'lps'),
	(427163, 123, '2015-03-01 01:27:04.000000', 'consum', 0.0222, 'lps'),
	(427164, 123, '2015-03-01 01:27:05.000000', 'consum', 0.0216, 'lps'),
	(427165, 123, '2015-03-01 01:27:06.000000', 'consum', 0.0219, 'lps'),
	(427166, 123, '2015-03-01 01:27:07.000000', 'consum', 0.0211, 'lps'),
	(427167, 123, '2015-03-01 01:27:08.000000', 'consum', 0.0216, 'lps'),
	(427168, 123, '2015-03-01 01:27:09.000000', 'consum', 0.0222, 'lps'),
	(427169, 123, '2015-03-01 01:27:10.000000', 'consum', 0.0214, 'lps'),
	(427170, 123, '2015-03-01 01:27:11.000000', 'consum', 0.0221, 'lps'),
	(427171, 123, '2015-03-01 01:27:12.000000', 'consum', 0.0212, 'lps'),
	(427172, 123, '2015-03-01 01:27:13.000000', 'consum', 0.0217, 'lps'),
	(427173, 123, '2015-03-01 01:27:14.000000', 'consum', 0.0211, 'lps'),
	(427174, 123, '2015-03-01 01:27:15.000000', 'consum', 0.0222, 'lps'),
	(427175, 123, '2015-03-01 01:27:16.000000', 'consum', 0.0215, 'lps'),
	(427176, 123, '2015-03-01 01:27:17.000000', 'consum', 0.0214, 'lps'),
	(427177, 123, '2015-03-01 01:27:18.000000', 'consum', 0.0214, 'lps'),
	(427178, 123, '2015-03-01 01:27:19.000000', 'consum', 0.0219, 'lps'),
	(427179, 123, '2015-03-01 01:27:20.000000', 'consum', 0.0218, 'lps'),
	(427180, 123, '2015-03-01 01:27:21.000000', 'consum', 0.0211, 'lps'),
	(427181, 123, '2015-03-01 01:27:22.000000', 'consum', 0.0216, 'lps'),
	(427182, 123, '2015-03-01 01:27:23.000000', 'consum', 0.0212, 'lps'),
	(427183, 123, '2015-03-01 01:27:24.000000', 'consum', 0.0215, 'lps'),
	(427184, 123, '2015-03-01 01:27:25.000000', 'consum', 0.0219, 'lps'),
	(427185, 123, '2015-03-01 01:27:26.000000', 'consum', 0.0213, 'lps'),
	(427186, 123, '2015-03-01 01:27:27.000000', 'consum', 0.0210, 'lps'),
	(427187, 123, '2015-03-01 01:27:28.000000', 'consum', 0.0215, 'lps'),
	(427188, 123, '2015-03-01 01:27:29.000000', 'consum', 0.0212, 'lps'),
	(427189, 123, '2015-03-01 01:27:30.000000', 'consum', 0.0216, 'lps'),
	(427190, 123, '2015-03-01 01:27:31.000000', 'consum', 0.0222, 'lps'),
	(427191, 123, '2015-03-01 01:27:32.000000', 'consum', 0.0216, 'lps'),
	(427192, 123, '2015-03-01 01:27:33.000000', 'consum', 0.0214, 'lps'),
	(427193, 123, '2015-03-01 01:27:34.000000', 'consum', 0.0214, 'lps'),
	(427194, 124, '2015-03-01 00:00:00.000000', 'consum', 0.0218, 'lps'),
	(427195, 124, '2015-03-01 00:00:01.000000', 'consum', 0.0229, 'lps'),
	(427196, 124, '2015-03-01 00:00:02.000000', 'consum', 0.0230, 'lps'),
	(427197, 124, '2015-03-01 00:00:03.000000', 'consum', 0.0227, 'lps'),
	(427198, 124, '2015-03-01 00:00:04.000000', 'consum', 0.0235, 'lps'),
	(427199, 124, '2015-03-01 00:00:05.000000', 'consum', 0.0232, 'lps'),
	(427200, 124, '2015-03-01 00:00:06.000000', 'consum', 0.0220, 'lps'),
	(427201, 124, '2015-03-01 00:00:07.000000', 'consum', 0.0222, 'lps'),
	(427202, 124, '2015-03-01 00:00:08.000000', 'consum', 0.0215, 'lps'),
	(427203, 124, '2015-03-01 00:00:09.000000', 'consum', 0.0226, 'lps'),
	(427204, 124, '2015-03-01 00:00:10.000000', 'consum', 0.0222, 'lps'),
	(427205, 124, '2015-03-01 00:00:11.000000', 'consum', 0.0223, 'lps'),
	(427206, 124, '2015-03-01 00:00:12.000000', 'consum', 0.0212, 'lps'),
	(427207, 124, '2015-03-01 00:00:13.000000', 'consum', 0.0234, 'lps'),
	(427208, 124, '2015-03-01 00:00:14.000000', 'consum', 0.0221, 'lps'),
	(427209, 124, '2015-03-01 00:00:15.000000', 'consum', 0.0221, 'lps'),
	(427210, 124, '2015-03-01 00:00:16.000000', 'consum', 0.0231, 'lps'),
	(427211, 124, '2015-03-01 00:00:17.000000', 'consum', 0.0231, 'lps'),
	(427212, 124, '2015-03-01 00:00:18.000000', 'consum', 0.0225, 'lps'),
	(427213, 124, '2015-03-01 00:00:19.000000', 'consum', 0.0222, 'lps'),
	(427214, 124, '2015-03-01 00:00:20.000000', 'consum', 0.0228, 'lps'),
	(427215, 124, '2015-03-01 00:00:21.000000', 'consum', 0.0211, 'lps'),
	(427216, 124, '2015-03-01 00:00:22.000000', 'consum', 0.0214, 'lps'),
	(427217, 124, '2015-03-01 00:00:23.000000', 'consum', 0.0227, 'lps'),
	(427218, 124, '2015-03-01 00:00:24.000000', 'consum', 0.0233, 'lps'),
	(427219, 124, '2015-03-01 00:00:25.000000', 'consum', 0.0222, 'lps'),
	(427220, 124, '2015-03-01 00:00:26.000000', 'consum', 0.0227, 'lps'),
	(427221, 124, '2015-03-01 00:00:27.000000', 'consum', 0.0232, 'lps'),
	(427222, 124, '2015-03-01 00:00:28.000000', 'consum', 0.0220, 'lps'),
	(427223, 124, '2015-03-01 00:00:29.000000', 'consum', 0.0218, 'lps'),
	(427224, 124, '2015-03-01 00:00:30.000000', 'consum', 0.0220, 'lps'),
	(427225, 124, '2015-03-01 00:00:31.000000', 'consum', 0.0210, 'lps'),
	(427226, 124, '2015-03-01 00:00:32.000000', 'consum', 0.0233, 'lps'),
	(427227, 124, '2015-03-01 00:00:33.000000', 'consum', 0.0223, 'lps'),
	(427228, 124, '2015-03-01 00:00:34.000000', 'consum', 0.0233, 'lps'),
	(427229, 124, '2015-03-01 00:00:35.000000', 'consum', 0.0232, 'lps'),
	(427230, 124, '2015-03-01 00:00:36.000000', 'consum', 0.0225, 'lps'),
	(427231, 124, '2015-03-01 00:00:37.000000', 'consum', 0.0220, 'lps'),
	(427232, 124, '2015-03-01 00:00:38.000000', 'consum', 0.0216, 'lps'),
	(427233, 124, '2015-03-01 00:00:39.000000', 'consum', 0.0211, 'lps'),
	(427234, 124, '2015-03-01 00:00:40.000000', 'consum', 0.0225, 'lps'),
	(427235, 124, '2015-03-01 00:00:41.000000', 'consum', 0.0228, 'lps'),
	(427236, 124, '2015-03-01 00:00:42.000000', 'consum', 0.0231, 'lps'),
	(427237, 124, '2015-03-01 00:00:43.000000', 'consum', 0.0211, 'lps'),
	(427238, 124, '2015-03-01 00:00:44.000000', 'consum', 0.0228, 'lps'),
	(427239, 124, '2015-03-01 00:00:45.000000', 'consum', 0.0221, 'lps'),
	(427240, 124, '2015-03-01 00:00:46.000000', 'consum', 0.0211, 'lps'),
	(427241, 124, '2015-03-01 00:00:47.000000', 'consum', 0.0210, 'lps'),
	(427242, 124, '2015-03-01 00:00:48.000000', 'consum', 0.0231, 'lps'),
	(427243, 124, '2015-03-01 00:00:49.000000', 'consum', 0.0211, 'lps'),
	(427244, 124, '2015-03-01 00:00:50.000000', 'consum', 0.0233, 'lps'),
	(427245, 124, '2015-03-01 00:00:51.000000', 'consum', 0.0217, 'lps'),
	(427246, 124, '2015-03-01 00:00:52.000000', 'consum', 0.0230, 'lps'),
	(427247, 124, '2015-03-01 00:00:53.000000', 'consum', 0.0235, 'lps'),
	(427248, 124, '2015-03-01 00:00:54.000000', 'consum', 0.0226, 'lps'),
	(427249, 124, '2015-03-01 00:00:55.000000', 'consum', 0.0215, 'lps'),
	(427250, 124, '2015-03-01 00:00:56.000000', 'consum', 0.0214, 'lps'),
	(427251, 124, '2015-03-01 00:00:57.000000', 'consum', 0.0216, 'lps'),
	(427252, 124, '2015-03-01 00:00:58.000000', 'consum', 0.0228, 'lps'),
	(427253, 124, '2015-03-01 00:00:59.000000', 'consum', 0.0232, 'lps'),
	(427254, 124, '2015-03-01 00:01:00.000000', 'consum', 0.0215, 'lps'),
	(427255, 124, '2015-03-01 00:01:01.000000', 'consum', 0.0221, 'lps'),
	(427256, 124, '2015-03-01 00:01:02.000000', 'consum', 0.0225, 'lps'),
	(427257, 124, '2015-03-01 00:01:03.000000', 'consum', 0.0226, 'lps'),
	(427258, 124, '2015-03-01 00:01:04.000000', 'consum', 0.0221, 'lps'),
	(427259, 124, '2015-03-01 00:01:05.000000', 'consum', 0.0218, 'lps'),
	(427260, 124, '2015-03-01 00:01:06.000000', 'consum', 0.0217, 'lps'),
	(427261, 124, '2015-03-01 00:01:07.000000', 'consum', 0.0222, 'lps'),
	(427262, 124, '2015-03-01 00:01:08.000000', 'consum', 0.0225, 'lps'),
	(427263, 124, '2015-03-01 00:01:09.000000', 'consum', 0.0221, 'lps'),
	(427264, 124, '2015-03-01 00:01:10.000000', 'consum', 0.0219, 'lps'),
	(427265, 124, '2015-03-01 00:01:11.000000', 'consum', 0.0225, 'lps'),
	(427266, 124, '2015-03-01 00:01:12.000000', 'consum', 0.0233, 'lps'),
	(427267, 124, '2015-03-01 00:01:13.000000', 'consum', 0.0229, 'lps'),
	(427268, 124, '2015-03-01 00:01:14.000000', 'consum', 0.0234, 'lps'),
	(427269, 124, '2015-03-01 00:01:15.000000', 'consum', 0.0224, 'lps'),
	(427270, 124, '2015-03-01 00:01:16.000000', 'consum', 0.0234, 'lps'),
	(427271, 124, '2015-03-01 00:01:17.000000', 'consum', 0.0234, 'lps'),
	(427272, 124, '2015-03-01 00:01:18.000000', 'consum', 0.0210, 'lps'),
	(427273, 124, '2015-03-01 00:01:19.000000', 'consum', 0.0214, 'lps'),
	(427274, 124, '2015-03-01 00:01:20.000000', 'consum', 0.0229, 'lps'),
	(427275, 124, '2015-03-01 00:01:21.000000', 'consum', 0.0218, 'lps'),
	(427276, 124, '2015-03-01 00:01:22.000000', 'consum', 0.0218, 'lps'),
	(427277, 124, '2015-03-01 00:01:23.000000', 'consum', 0.0227, 'lps'),
	(427278, 124, '2015-03-01 00:01:24.000000', 'consum', 0.0218, 'lps'),
	(427279, 124, '2015-03-01 00:01:25.000000', 'consum', 0.0227, 'lps'),
	(427280, 124, '2015-03-01 00:01:26.000000', 'consum', 0.0220, 'lps'),
	(427281, 124, '2015-03-01 00:01:27.000000', 'consum', 0.0210, 'lps'),
	(427282, 124, '2015-03-01 00:01:28.000000', 'consum', 0.0232, 'lps'),
	(427283, 124, '2015-03-01 00:01:29.000000', 'consum', 0.0217, 'lps'),
	(427284, 124, '2015-03-01 00:01:30.000000', 'consum', 0.0232, 'lps'),
	(427285, 124, '2015-03-01 00:01:31.000000', 'consum', 0.0222, 'lps'),
	(427286, 124, '2015-03-01 00:01:32.000000', 'consum', 0.0229, 'lps'),
	(427287, 124, '2015-03-01 00:01:33.000000', 'consum', 0.0219, 'lps'),
	(427288, 124, '2015-03-01 00:01:34.000000', 'consum', 0.0223, 'lps'),
	(427289, 124, '2015-03-01 00:01:35.000000', 'consum', 0.0224, 'lps'),
	(427290, 124, '2015-03-01 00:01:36.000000', 'consum', 0.0214, 'lps'),
	(427291, 124, '2015-03-01 00:01:37.000000', 'consum', 0.0214, 'lps'),
	(427292, 124, '2015-03-01 00:01:38.000000', 'consum', 0.0218, 'lps'),
	(427293, 124, '2015-03-01 00:01:39.000000', 'consum', 0.0213, 'lps'),
	(427294, 124, '2015-03-01 00:01:40.000000', 'consum', 0.0229, 'lps'),
	(427295, 124, '2015-03-01 00:01:41.000000', 'consum', 0.0216, 'lps'),
	(427296, 124, '2015-03-01 00:01:42.000000', 'consum', 0.0212, 'lps'),
	(427297, 124, '2015-03-01 00:01:43.000000', 'consum', 0.0229, 'lps'),
	(427298, 124, '2015-03-01 00:01:44.000000', 'consum', 0.0222, 'lps'),
	(427299, 124, '2015-03-01 00:01:45.000000', 'consum', 0.0213, 'lps'),
	(427300, 124, '2015-03-01 00:01:46.000000', 'consum', 0.0216, 'lps'),
	(427301, 124, '2015-03-01 00:01:47.000000', 'consum', 0.0232, 'lps'),
	(427302, 124, '2015-03-01 00:01:48.000000', 'consum', 0.0225, 'lps'),
	(427303, 124, '2015-03-01 00:01:49.000000', 'consum', 0.0217, 'lps'),
	(427304, 124, '2015-03-01 00:01:50.000000', 'consum', 0.0228, 'lps'),
	(427305, 124, '2015-03-01 00:01:51.000000', 'consum', 0.0228, 'lps'),
	(427306, 124, '2015-03-01 00:01:52.000000', 'consum', 0.0221, 'lps'),
	(427307, 124, '2015-03-01 00:01:53.000000', 'consum', 0.0211, 'lps'),
	(427308, 124, '2015-03-01 00:01:54.000000', 'consum', 0.0233, 'lps'),
	(427309, 124, '2015-03-01 00:01:55.000000', 'consum', 0.0219, 'lps'),
	(427310, 124, '2015-03-01 00:01:56.000000', 'consum', 0.0212, 'lps'),
	(427311, 124, '2015-03-01 00:01:57.000000', 'consum', 0.0222, 'lps'),
	(427312, 124, '2015-03-01 00:01:58.000000', 'consum', 0.0235, 'lps'),
	(427313, 124, '2015-03-01 00:01:59.000000', 'consum', 0.0224, 'lps'),
	(427314, 124, '2015-03-01 00:02:00.000000', 'consum', 0.0231, 'lps'),
	(427315, 124, '2015-03-01 00:02:01.000000', 'consum', 0.0223, 'lps'),
	(427316, 124, '2015-03-01 00:02:02.000000', 'consum', 0.0212, 'lps'),
	(427317, 124, '2015-03-01 00:02:03.000000', 'consum', 0.0234, 'lps'),
	(427318, 124, '2015-03-01 00:02:04.000000', 'consum', 0.0218, 'lps'),
	(427319, 124, '2015-03-01 00:02:05.000000', 'consum', 0.0232, 'lps'),
	(427320, 124, '2015-03-01 00:02:06.000000', 'consum', 0.0218, 'lps'),
	(427321, 124, '2015-03-01 00:02:07.000000', 'consum', 0.0210, 'lps'),
	(427322, 124, '2015-03-01 00:02:08.000000', 'consum', 0.0213, 'lps'),
	(427323, 124, '2015-03-01 00:02:09.000000', 'consum', 0.0225, 'lps'),
	(427324, 124, '2015-03-01 00:02:10.000000', 'consum', 0.0223, 'lps'),
	(427325, 124, '2015-03-01 00:02:11.000000', 'consum', 0.0233, 'lps'),
	(427326, 124, '2015-03-01 00:02:12.000000', 'consum', 0.0235, 'lps'),
	(427327, 124, '2015-03-01 00:02:13.000000', 'consum', 0.0215, 'lps'),
	(427328, 124, '2015-03-01 00:02:14.000000', 'consum', 0.0212, 'lps'),
	(427329, 124, '2015-03-01 00:02:15.000000', 'consum', 0.0232, 'lps'),
	(427330, 124, '2015-03-01 00:02:16.000000', 'consum', 0.0211, 'lps'),
	(427331, 124, '2015-03-01 00:02:17.000000', 'consum', 0.0227, 'lps'),
	(427332, 124, '2015-03-01 00:02:18.000000', 'consum', 0.0213, 'lps'),
	(427333, 124, '2015-03-01 00:02:19.000000', 'consum', 0.0227, 'lps'),
	(427334, 124, '2015-03-01 00:02:20.000000', 'consum', 0.0234, 'lps'),
	(427335, 124, '2015-03-01 00:02:21.000000', 'consum', 0.0229, 'lps'),
	(427336, 124, '2015-03-01 00:02:22.000000', 'consum', 0.0233, 'lps'),
	(427337, 124, '2015-03-01 00:02:23.000000', 'consum', 0.0218, 'lps'),
	(427338, 124, '2015-03-01 00:02:24.000000', 'consum', 0.0233, 'lps'),
	(427339, 124, '2015-03-01 00:02:25.000000', 'consum', 0.0223, 'lps'),
	(427340, 124, '2015-03-01 00:02:26.000000', 'consum', 0.0234, 'lps'),
	(427341, 124, '2015-03-01 00:02:27.000000', 'consum', 0.0211, 'lps'),
	(427342, 124, '2015-03-01 00:02:28.000000', 'consum', 0.0223, 'lps'),
	(427343, 124, '2015-03-01 00:02:29.000000', 'consum', 0.0219, 'lps'),
	(427344, 124, '2015-03-01 00:02:30.000000', 'consum', 0.0216, 'lps'),
	(427345, 124, '2015-03-01 00:02:31.000000', 'consum', 0.0214, 'lps'),
	(427346, 124, '2015-03-01 00:02:32.000000', 'consum', 0.0211, 'lps'),
	(427347, 124, '2015-03-01 00:02:33.000000', 'consum', 0.0232, 'lps'),
	(427348, 124, '2015-03-01 00:02:34.000000', 'consum', 0.0211, 'lps'),
	(427349, 124, '2015-03-01 00:02:35.000000', 'consum', 0.0231, 'lps'),
	(427350, 124, '2015-03-01 00:02:36.000000', 'consum', 0.0231, 'lps'),
	(427351, 124, '2015-03-01 00:02:37.000000', 'consum', 0.0227, 'lps'),
	(427352, 124, '2015-03-01 00:02:38.000000', 'consum', 0.0232, 'lps'),
	(427353, 124, '2015-03-01 00:02:39.000000', 'consum', 0.0217, 'lps'),
	(427354, 124, '2015-03-01 00:02:40.000000', 'consum', 0.0234, 'lps'),
	(427355, 124, '2015-03-01 00:02:41.000000', 'consum', 0.0228, 'lps'),
	(427356, 124, '2015-03-01 00:02:42.000000', 'consum', 0.0232, 'lps'),
	(427357, 124, '2015-03-01 00:02:43.000000', 'consum', 0.0212, 'lps'),
	(427358, 124, '2015-03-01 00:02:44.000000', 'consum', 0.0235, 'lps'),
	(427359, 124, '2015-03-01 00:02:45.000000', 'consum', 0.0225, 'lps'),
	(427360, 124, '2015-03-01 00:02:46.000000', 'consum', 0.0211, 'lps'),
	(427361, 124, '2015-03-01 00:02:47.000000', 'consum', 0.0222, 'lps'),
	(427362, 124, '2015-03-01 00:02:48.000000', 'consum', 0.0213, 'lps'),
	(427363, 124, '2015-03-01 00:02:49.000000', 'consum', 0.0219, 'lps'),
	(427364, 124, '2015-03-01 00:02:50.000000', 'consum', 0.0220, 'lps'),
	(427365, 124, '2015-03-01 00:02:51.000000', 'consum', 0.0232, 'lps'),
	(427366, 124, '2015-03-01 00:02:52.000000', 'consum', 0.0213, 'lps'),
	(427367, 124, '2015-03-01 00:02:53.000000', 'consum', 0.0213, 'lps'),
	(427368, 124, '2015-03-01 00:02:54.000000', 'consum', 0.0215, 'lps'),
	(427369, 124, '2015-03-01 00:02:55.000000', 'consum', 0.0227, 'lps'),
	(427370, 124, '2015-03-01 00:02:56.000000', 'consum', 0.0229, 'lps'),
	(427371, 124, '2015-03-01 00:02:57.000000', 'consum', 0.0228, 'lps'),
	(427372, 124, '2015-03-01 00:02:58.000000', 'consum', 0.0216, 'lps'),
	(427373, 124, '2015-03-01 00:02:59.000000', 'consum', 0.0215, 'lps'),
	(427374, 124, '2015-03-01 00:03:00.000000', 'consum', 0.0216, 'lps'),
	(427375, 124, '2015-03-01 00:03:01.000000', 'consum', 0.0224, 'lps'),
	(427376, 124, '2015-03-01 00:03:02.000000', 'consum', 0.0213, 'lps'),
	(427377, 124, '2015-03-01 00:03:03.000000', 'consum', 0.0235, 'lps'),
	(427378, 124, '2015-03-01 00:03:04.000000', 'consum', 0.0222, 'lps'),
	(427379, 124, '2015-03-01 00:03:05.000000', 'consum', 0.0220, 'lps'),
	(427380, 124, '2015-03-01 00:03:06.000000', 'consum', 0.0226, 'lps'),
	(427381, 124, '2015-03-01 00:03:07.000000', 'consum', 0.0233, 'lps'),
	(427382, 124, '2015-03-01 00:03:08.000000', 'consum', 0.0225, 'lps'),
	(427383, 124, '2015-03-01 00:03:09.000000', 'consum', 0.0216, 'lps'),
	(427384, 124, '2015-03-01 00:03:10.000000', 'consum', 0.0221, 'lps'),
	(427385, 124, '2015-03-01 00:03:11.000000', 'consum', 0.0221, 'lps'),
	(427386, 124, '2015-03-01 00:03:12.000000', 'consum', 0.0232, 'lps'),
	(427387, 124, '2015-03-01 00:03:13.000000', 'consum', 0.0212, 'lps'),
	(427388, 124, '2015-03-01 00:03:14.000000', 'consum', 0.0230, 'lps'),
	(427389, 124, '2015-03-01 00:03:15.000000', 'consum', 0.0228, 'lps'),
	(427390, 124, '2015-03-01 00:03:16.000000', 'consum', 0.0214, 'lps'),
	(427391, 124, '2015-03-01 00:03:17.000000', 'consum', 0.0227, 'lps'),
	(427392, 124, '2015-03-01 00:03:18.000000', 'consum', 0.0232, 'lps'),
	(427393, 124, '2015-03-01 00:03:19.000000', 'consum', 0.0218, 'lps'),
	(427394, 124, '2015-03-01 00:03:20.000000', 'consum', 0.0211, 'lps'),
	(427395, 124, '2015-03-01 00:03:21.000000', 'consum', 0.0216, 'lps'),
	(427396, 124, '2015-03-01 00:03:22.000000', 'consum', 0.0213, 'lps'),
	(427397, 124, '2015-03-01 00:03:23.000000', 'consum', 0.0232, 'lps'),
	(427398, 124, '2015-03-01 00:03:24.000000', 'consum', 0.0234, 'lps'),
	(427399, 124, '2015-03-01 00:03:25.000000', 'consum', 0.0211, 'lps'),
	(427400, 124, '2015-03-01 00:03:26.000000', 'consum', 0.0222, 'lps'),
	(427401, 124, '2015-03-01 00:03:27.000000', 'consum', 0.0215, 'lps'),
	(427402, 124, '2015-03-01 00:03:28.000000', 'consum', 0.0225, 'lps'),
	(427403, 124, '2015-03-01 00:03:29.000000', 'consum', 0.0221, 'lps'),
	(427404, 124, '2015-03-01 00:03:30.000000', 'consum', 0.0220, 'lps'),
	(427405, 124, '2015-03-01 00:03:31.000000', 'consum', 0.0227, 'lps'),
	(427406, 124, '2015-03-01 00:03:32.000000', 'consum', 0.0213, 'lps'),
	(427407, 124, '2015-03-01 00:03:33.000000', 'consum', 0.0226, 'lps'),
	(427408, 124, '2015-03-01 00:03:34.000000', 'consum', 0.0229, 'lps'),
	(427409, 124, '2015-03-01 00:03:35.000000', 'consum', 0.0233, 'lps'),
	(427410, 124, '2015-03-01 00:03:36.000000', 'consum', 0.0216, 'lps'),
	(427411, 124, '2015-03-01 00:03:37.000000', 'consum', 0.0225, 'lps'),
	(427412, 124, '2015-03-01 00:03:38.000000', 'consum', 0.0216, 'lps'),
	(427413, 124, '2015-03-01 00:03:39.000000', 'consum', 0.0221, 'lps'),
	(427414, 124, '2015-03-01 00:03:40.000000', 'consum', 0.0220, 'lps'),
	(427415, 124, '2015-03-01 00:03:41.000000', 'consum', 0.0228, 'lps'),
	(427416, 124, '2015-03-01 00:03:42.000000', 'consum', 0.0218, 'lps'),
	(427417, 124, '2015-03-01 00:03:43.000000', 'consum', 0.0222, 'lps'),
	(427418, 124, '2015-03-01 00:03:44.000000', 'consum', 0.0222, 'lps'),
	(427419, 124, '2015-03-01 00:03:45.000000', 'consum', 0.0232, 'lps'),
	(427420, 124, '2015-03-01 00:03:46.000000', 'consum', 0.0235, 'lps'),
	(427421, 124, '2015-03-01 00:03:47.000000', 'consum', 0.0218, 'lps'),
	(427422, 124, '2015-03-01 00:03:48.000000', 'consum', 0.0228, 'lps'),
	(427423, 124, '2015-03-01 00:03:49.000000', 'consum', 0.0224, 'lps'),
	(427424, 124, '2015-03-01 00:03:50.000000', 'consum', 0.0228, 'lps'),
	(427425, 124, '2015-03-01 00:03:51.000000', 'consum', 0.0231, 'lps'),
	(427426, 124, '2015-03-01 00:03:52.000000', 'consum', 0.0235, 'lps'),
	(427427, 124, '2015-03-01 00:03:53.000000', 'consum', 0.0223, 'lps'),
	(427428, 124, '2015-03-01 00:03:54.000000', 'consum', 0.0225, 'lps'),
	(427429, 124, '2015-03-01 00:03:55.000000', 'consum', 0.0221, 'lps'),
	(427430, 124, '2015-03-01 00:03:56.000000', 'consum', 0.0219, 'lps'),
	(427431, 124, '2015-03-01 00:03:57.000000', 'consum', 0.0224, 'lps'),
	(427432, 124, '2015-03-01 00:03:58.000000', 'consum', 0.0226, 'lps'),
	(427433, 124, '2015-03-01 00:03:59.000000', 'consum', 0.0222, 'lps'),
	(427434, 124, '2015-03-01 00:04:00.000000', 'consum', 0.0225, 'lps'),
	(427435, 124, '2015-03-01 00:04:01.000000', 'consum', 0.0224, 'lps'),
	(427436, 124, '2015-03-01 00:04:02.000000', 'consum', 0.0232, 'lps'),
	(427437, 124, '2015-03-01 00:04:03.000000', 'consum', 0.0229, 'lps'),
	(427438, 124, '2015-03-01 00:04:04.000000', 'consum', 0.0213, 'lps'),
	(427439, 124, '2015-03-01 00:04:05.000000', 'consum', 0.0222, 'lps'),
	(427440, 124, '2015-03-01 00:04:06.000000', 'consum', 0.0233, 'lps'),
	(427441, 124, '2015-03-01 00:04:07.000000', 'consum', 0.0211, 'lps'),
	(427442, 124, '2015-03-01 00:04:08.000000', 'consum', 0.0224, 'lps'),
	(427443, 124, '2015-03-01 00:04:09.000000', 'consum', 0.0227, 'lps'),
	(427444, 124, '2015-03-01 00:04:10.000000', 'consum', 0.0227, 'lps'),
	(427445, 124, '2015-03-01 00:04:11.000000', 'consum', 0.0219, 'lps'),
	(427446, 124, '2015-03-01 00:04:12.000000', 'consum', 0.0229, 'lps'),
	(427447, 124, '2015-03-01 00:04:13.000000', 'consum', 0.0228, 'lps'),
	(427448, 124, '2015-03-01 00:04:14.000000', 'consum', 0.0217, 'lps'),
	(427449, 124, '2015-03-01 00:04:15.000000', 'consum', 0.0217, 'lps'),
	(427450, 124, '2015-03-01 00:04:16.000000', 'consum', 0.0226, 'lps'),
	(427451, 124, '2015-03-01 00:04:17.000000', 'consum', 0.0217, 'lps'),
	(427452, 124, '2015-03-01 00:04:18.000000', 'consum', 0.0222, 'lps'),
	(427453, 124, '2015-03-01 00:04:19.000000', 'consum', 0.0224, 'lps'),
	(427454, 124, '2015-03-01 00:04:20.000000', 'consum', 0.0220, 'lps'),
	(427455, 124, '2015-03-01 00:04:21.000000', 'consum', 0.0217, 'lps'),
	(427456, 124, '2015-03-01 00:04:22.000000', 'consum', 0.0217, 'lps'),
	(427457, 124, '2015-03-01 00:04:23.000000', 'consum', 0.0225, 'lps'),
	(427458, 124, '2015-03-01 00:04:24.000000', 'consum', 0.0210, 'lps'),
	(427459, 124, '2015-03-01 00:04:25.000000', 'consum', 0.0220, 'lps'),
	(427460, 124, '2015-03-01 00:04:26.000000', 'consum', 0.0210, 'lps'),
	(427461, 124, '2015-03-01 00:04:27.000000', 'consum', 0.0229, 'lps'),
	(427462, 124, '2015-03-01 00:04:28.000000', 'consum', 0.0229, 'lps'),
	(427463, 124, '2015-03-01 00:04:29.000000', 'consum', 0.0222, 'lps'),
	(427464, 124, '2015-03-01 00:04:30.000000', 'consum', 0.0215, 'lps'),
	(427465, 124, '2015-03-01 00:04:31.000000', 'consum', 0.0226, 'lps'),
	(427466, 124, '2015-03-01 00:04:32.000000', 'consum', 0.0222, 'lps'),
	(427467, 124, '2015-03-01 00:04:33.000000', 'consum', 0.0222, 'lps'),
	(427468, 124, '2015-03-01 00:04:34.000000', 'consum', 0.0235, 'lps'),
	(427469, 124, '2015-03-01 00:04:35.000000', 'consum', 0.0221, 'lps'),
	(427470, 124, '2015-03-01 00:04:36.000000', 'consum', 0.0216, 'lps'),
	(427471, 124, '2015-03-01 00:04:37.000000', 'consum', 0.0235, 'lps'),
	(427472, 124, '2015-03-01 00:04:38.000000', 'consum', 0.0215, 'lps'),
	(427473, 124, '2015-03-01 00:04:39.000000', 'consum', 0.0211, 'lps'),
	(427474, 124, '2015-03-01 00:04:40.000000', 'consum', 0.0227, 'lps'),
	(427475, 124, '2015-03-01 00:04:41.000000', 'consum', 0.0213, 'lps'),
	(427476, 124, '2015-03-01 00:04:42.000000', 'consum', 0.0229, 'lps'),
	(427477, 124, '2015-03-01 00:04:43.000000', 'consum', 0.0215, 'lps'),
	(427478, 124, '2015-03-01 00:04:44.000000', 'consum', 0.0233, 'lps'),
	(427479, 124, '2015-03-01 00:04:45.000000', 'consum', 0.0234, 'lps'),
	(427480, 124, '2015-03-01 00:04:46.000000', 'consum', 0.0233, 'lps'),
	(427481, 124, '2015-03-01 00:04:47.000000', 'consum', 0.0227, 'lps'),
	(427482, 124, '2015-03-01 00:04:48.000000', 'consum', 0.0227, 'lps'),
	(427483, 124, '2015-03-01 00:04:49.000000', 'consum', 0.0219, 'lps'),
	(427484, 124, '2015-03-01 00:04:50.000000', 'consum', 0.0229, 'lps'),
	(427485, 124, '2015-03-01 00:04:51.000000', 'consum', 0.0228, 'lps'),
	(427486, 124, '2015-03-01 00:04:52.000000', 'consum', 0.0217, 'lps'),
	(427487, 124, '2015-03-01 00:04:53.000000', 'consum', 0.0219, 'lps'),
	(427488, 124, '2015-03-01 00:04:54.000000', 'consum', 0.0234, 'lps'),
	(427489, 124, '2015-03-01 00:04:55.000000', 'consum', 0.0227, 'lps'),
	(427490, 124, '2015-03-01 00:04:56.000000', 'consum', 0.0223, 'lps'),
	(427491, 124, '2015-03-01 00:04:57.000000', 'consum', 0.0225, 'lps'),
	(427492, 124, '2015-03-01 00:04:58.000000', 'consum', 0.0219, 'lps'),
	(427493, 124, '2015-03-01 00:04:59.000000', 'consum', 0.0211, 'lps'),
	(427494, 124, '2015-03-01 00:05:00.000000', 'consum', 0.0214, 'lps'),
	(427495, 124, '2015-03-01 00:05:01.000000', 'consum', 0.0230, 'lps'),
	(427496, 124, '2015-03-01 00:05:02.000000', 'consum', 0.0219, 'lps'),
	(427497, 124, '2015-03-01 00:05:03.000000', 'consum', 0.0221, 'lps'),
	(427498, 124, '2015-03-01 00:05:04.000000', 'consum', 0.0215, 'lps'),
	(427499, 124, '2015-03-01 00:05:05.000000', 'consum', 0.0226, 'lps'),
	(427500, 124, '2015-03-01 00:05:06.000000', 'consum', 0.0224, 'lps'),
	(427501, 124, '2015-03-01 00:05:07.000000', 'consum', 0.0234, 'lps'),
	(427502, 124, '2015-03-01 00:05:08.000000', 'consum', 0.0233, 'lps'),
	(427503, 124, '2015-03-01 00:05:09.000000', 'consum', 0.0231, 'lps'),
	(427504, 124, '2015-03-01 00:05:10.000000', 'consum', 0.0220, 'lps'),
	(427505, 124, '2015-03-01 00:05:11.000000', 'consum', 0.0221, 'lps'),
	(427506, 124, '2015-03-01 00:05:12.000000', 'consum', 0.0213, 'lps'),
	(427507, 124, '2015-03-01 00:05:13.000000', 'consum', 0.0216, 'lps'),
	(427508, 124, '2015-03-01 00:05:14.000000', 'consum', 0.0232, 'lps'),
	(427509, 124, '2015-03-01 00:05:15.000000', 'consum', 0.0226, 'lps'),
	(427510, 124, '2015-03-01 00:05:16.000000', 'consum', 0.0224, 'lps'),
	(427511, 124, '2015-03-01 00:05:17.000000', 'consum', 0.0232, 'lps'),
	(427512, 124, '2015-03-01 00:05:18.000000', 'consum', 0.0228, 'lps'),
	(427513, 124, '2015-03-01 00:05:19.000000', 'consum', 0.0235, 'lps'),
	(427514, 124, '2015-03-01 00:05:20.000000', 'consum', 0.0230, 'lps'),
	(427515, 124, '2015-03-01 00:05:21.000000', 'consum', 0.0233, 'lps'),
	(427516, 124, '2015-03-01 00:05:22.000000', 'consum', 0.0215, 'lps'),
	(427517, 124, '2015-03-01 00:05:23.000000', 'consum', 0.0218, 'lps'),
	(427518, 124, '2015-03-01 00:05:24.000000', 'consum', 0.0210, 'lps'),
	(427519, 124, '2015-03-01 00:05:25.000000', 'consum', 0.0213, 'lps'),
	(427520, 124, '2015-03-01 00:05:26.000000', 'consum', 0.0225, 'lps'),
	(427521, 124, '2015-03-01 00:05:27.000000', 'consum', 0.0223, 'lps'),
	(427522, 124, '2015-03-01 00:05:28.000000', 'consum', 0.0233, 'lps'),
	(427523, 124, '2015-03-01 00:05:29.000000', 'consum', 0.0234, 'lps'),
	(427524, 124, '2015-03-01 00:05:30.000000', 'consum', 0.0233, 'lps'),
	(427525, 124, '2015-03-01 00:05:31.000000', 'consum', 0.0229, 'lps'),
	(427526, 124, '2015-03-01 00:05:32.000000', 'consum', 0.0212, 'lps'),
	(427527, 124, '2015-03-01 00:05:33.000000', 'consum', 0.0213, 'lps'),
	(427528, 124, '2015-03-01 00:05:34.000000', 'consum', 0.0221, 'lps'),
	(427529, 124, '2015-03-01 00:05:35.000000', 'consum', 0.0230, 'lps'),
	(427530, 124, '2015-03-01 00:05:36.000000', 'consum', 0.0224, 'lps'),
	(427531, 124, '2015-03-01 00:05:37.000000', 'consum', 0.0220, 'lps'),
	(427532, 124, '2015-03-01 00:05:38.000000', 'consum', 0.0218, 'lps'),
	(427533, 124, '2015-03-01 00:05:39.000000', 'consum', 0.0222, 'lps'),
	(427534, 124, '2015-03-01 00:05:40.000000', 'consum', 0.0221, 'lps'),
	(427535, 124, '2015-03-01 00:05:41.000000', 'consum', 0.0229, 'lps'),
	(427536, 124, '2015-03-01 00:05:42.000000', 'consum', 0.0221, 'lps'),
	(427537, 124, '2015-03-01 00:05:43.000000', 'consum', 0.0232, 'lps'),
	(427538, 124, '2015-03-01 00:05:44.000000', 'consum', 0.0212, 'lps'),
	(427539, 124, '2015-03-01 00:05:45.000000', 'consum', 0.0234, 'lps'),
	(427540, 124, '2015-03-01 00:05:46.000000', 'consum', 0.0218, 'lps'),
	(427541, 124, '2015-03-01 00:05:47.000000', 'consum', 0.0230, 'lps'),
	(427542, 124, '2015-03-01 00:05:48.000000', 'consum', 0.0211, 'lps'),
	(427543, 124, '2015-03-01 00:05:49.000000', 'consum', 0.0233, 'lps'),
	(427544, 124, '2015-03-01 00:05:50.000000', 'consum', 0.0220, 'lps'),
	(427545, 124, '2015-03-01 00:05:51.000000', 'consum', 0.0217, 'lps'),
	(427546, 124, '2015-03-01 00:05:52.000000', 'consum', 0.0214, 'lps'),
	(427547, 124, '2015-03-01 00:05:53.000000', 'consum', 0.0235, 'lps'),
	(427548, 124, '2015-03-01 00:05:54.000000', 'consum', 0.0219, 'lps'),
	(427549, 124, '2015-03-01 00:05:55.000000', 'consum', 0.0233, 'lps'),
	(427550, 124, '2015-03-01 00:05:56.000000', 'consum', 0.0220, 'lps'),
	(427551, 124, '2015-03-01 00:05:57.000000', 'consum', 0.0217, 'lps'),
	(427552, 124, '2015-03-01 00:05:58.000000', 'consum', 0.0217, 'lps'),
	(427553, 124, '2015-03-01 00:05:59.000000', 'consum', 0.0224, 'lps'),
	(427554, 124, '2015-03-01 00:06:00.000000', 'consum', 0.0233, 'lps'),
	(427555, 124, '2015-03-01 00:06:01.000000', 'consum', 0.0231, 'lps'),
	(427556, 124, '2015-03-01 00:06:02.000000', 'consum', 0.0223, 'lps'),
	(427557, 124, '2015-03-01 00:06:03.000000', 'consum', 0.0212, 'lps'),
	(427558, 124, '2015-03-01 00:06:04.000000', 'consum', 0.0233, 'lps'),
	(427559, 124, '2015-03-01 00:06:05.000000', 'consum', 0.0215, 'lps'),
	(427560, 124, '2015-03-01 00:06:06.000000', 'consum', 0.0218, 'lps'),
	(427561, 124, '2015-03-01 00:06:07.000000', 'consum', 0.0210, 'lps'),
	(427562, 124, '2015-03-01 00:06:08.000000', 'consum', 0.0214, 'lps'),
	(427563, 124, '2015-03-01 00:06:09.000000', 'consum', 0.0228, 'lps'),
	(427564, 124, '2015-03-01 00:06:10.000000', 'consum', 0.0212, 'lps'),
	(427565, 124, '2015-03-01 00:06:11.000000', 'consum', 0.0219, 'lps'),
	(427566, 124, '2015-03-01 00:06:12.000000', 'consum', 0.0224, 'lps'),
	(427567, 124, '2015-03-01 00:06:13.000000', 'consum', 0.0225, 'lps'),
	(427568, 124, '2015-03-01 00:06:14.000000', 'consum', 0.0218, 'lps'),
	(427569, 124, '2015-03-01 00:06:15.000000', 'consum', 0.0231, 'lps'),
	(427570, 124, '2015-03-01 00:06:16.000000', 'consum', 0.0213, 'lps'),
	(427571, 124, '2015-03-01 00:06:17.000000', 'consum', 0.0215, 'lps'),
	(427572, 124, '2015-03-01 00:06:18.000000', 'consum', 0.0227, 'lps'),
	(427573, 124, '2015-03-01 00:06:19.000000', 'consum', 0.0229, 'lps'),
	(427574, 124, '2015-03-01 00:06:20.000000', 'consum', 0.0228, 'lps'),
	(427575, 124, '2015-03-01 00:06:21.000000', 'consum', 0.0219, 'lps'),
	(427576, 124, '2015-03-01 00:06:22.000000', 'consum', 0.0226, 'lps'),
	(427577, 124, '2015-03-01 00:06:23.000000', 'consum', 0.0211, 'lps'),
	(427578, 124, '2015-03-01 00:06:24.000000', 'consum', 0.0220, 'lps'),
	(427579, 124, '2015-03-01 00:06:25.000000', 'consum', 0.0230, 'lps'),
	(427580, 124, '2015-03-01 00:06:26.000000', 'consum', 0.0232, 'lps'),
	(427581, 124, '2015-03-01 00:06:27.000000', 'consum', 0.0232, 'lps'),
	(427582, 124, '2015-03-01 00:06:28.000000', 'consum', 0.0227, 'lps'),
	(427583, 124, '2015-03-01 00:06:29.000000', 'consum', 0.0232, 'lps'),
	(427584, 124, '2015-03-01 00:06:30.000000', 'consum', 0.0217, 'lps'),
	(427585, 124, '2015-03-01 00:06:31.000000', 'consum', 0.0232, 'lps'),
	(427586, 124, '2015-03-01 00:06:32.000000', 'consum', 0.0220, 'lps'),
	(427587, 124, '2015-03-01 00:06:33.000000', 'consum', 0.0219, 'lps'),
	(427588, 124, '2015-03-01 00:06:34.000000', 'consum', 0.0228, 'lps'),
	(427589, 124, '2015-03-01 00:06:35.000000', 'consum', 0.0221, 'lps'),
	(427590, 124, '2015-03-01 00:06:36.000000', 'consum', 0.0211, 'lps'),
	(427591, 124, '2015-03-01 00:06:37.000000', 'consum', 0.0210, 'lps'),
	(427592, 124, '2015-03-01 00:06:38.000000', 'consum', 0.0231, 'lps'),
	(427593, 124, '2015-03-01 00:06:39.000000', 'consum', 0.0212, 'lps'),
	(427594, 124, '2015-03-01 00:06:40.000000', 'consum', 0.0235, 'lps'),
	(427595, 124, '2015-03-01 00:06:41.000000', 'consum', 0.0228, 'lps'),
	(427596, 124, '2015-03-01 00:06:42.000000', 'consum', 0.0223, 'lps'),
	(427597, 124, '2015-03-01 00:06:43.000000', 'consum', 0.0221, 'lps'),
	(427598, 124, '2015-03-01 00:06:44.000000', 'consum', 0.0228, 'lps'),
	(427599, 124, '2015-03-01 00:06:45.000000', 'consum', 0.0217, 'lps'),
	(427600, 124, '2015-03-01 00:06:46.000000', 'consum', 0.0215, 'lps'),
	(427601, 124, '2015-03-01 00:06:47.000000', 'consum', 0.0217, 'lps'),
	(427602, 124, '2015-03-01 00:06:48.000000', 'consum', 0.0231, 'lps'),
	(427603, 124, '2015-03-01 00:06:49.000000', 'consum', 0.0215, 'lps'),
	(427604, 124, '2015-03-01 00:06:50.000000', 'consum', 0.0225, 'lps'),
	(427605, 124, '2015-03-01 00:06:51.000000', 'consum', 0.0217, 'lps'),
	(427606, 124, '2015-03-01 00:06:52.000000', 'consum', 0.0226, 'lps'),
	(427607, 124, '2015-03-01 00:06:53.000000', 'consum', 0.0217, 'lps'),
	(427608, 124, '2015-03-01 00:06:54.000000', 'consum', 0.0223, 'lps'),
	(427609, 124, '2015-03-01 00:06:55.000000', 'consum', 0.0231, 'lps'),
	(427610, 124, '2015-03-01 00:06:56.000000', 'consum', 0.0223, 'lps'),
	(427611, 124, '2015-03-01 00:06:57.000000', 'consum', 0.0212, 'lps'),
	(427612, 124, '2015-03-01 00:06:58.000000', 'consum', 0.0232, 'lps'),
	(427613, 124, '2015-03-01 00:06:59.000000', 'consum', 0.0214, 'lps'),
	(427614, 124, '2015-03-01 00:07:00.000000', 'consum', 0.0215, 'lps'),
	(427615, 124, '2015-03-01 00:07:01.000000', 'consum', 0.0223, 'lps'),
	(427616, 124, '2015-03-01 00:07:02.000000', 'consum', 0.0210, 'lps'),
	(427617, 124, '2015-03-01 00:07:03.000000', 'consum', 0.0225, 'lps'),
	(427618, 124, '2015-03-01 00:07:04.000000', 'consum', 0.0230, 'lps'),
	(427619, 124, '2015-03-01 00:07:05.000000', 'consum', 0.0216, 'lps'),
	(427620, 124, '2015-03-01 00:07:06.000000', 'consum', 0.0233, 'lps'),
	(427621, 124, '2015-03-01 00:07:07.000000', 'consum', 0.0230, 'lps'),
	(427622, 124, '2015-03-01 00:07:08.000000', 'consum', 0.0213, 'lps'),
	(427623, 124, '2015-03-01 00:07:09.000000', 'consum', 0.0217, 'lps'),
	(427624, 124, '2015-03-01 00:07:10.000000', 'consum', 0.0211, 'lps'),
	(427625, 124, '2015-03-01 00:07:11.000000', 'consum', 0.0219, 'lps'),
	(427626, 124, '2015-03-01 00:07:12.000000', 'consum', 0.0230, 'lps'),
	(427627, 124, '2015-03-01 00:07:13.000000', 'consum', 0.0230, 'lps'),
	(427628, 124, '2015-03-01 00:07:14.000000', 'consum', 0.0223, 'lps'),
	(427629, 124, '2015-03-01 00:07:15.000000', 'consum', 0.0216, 'lps'),
	(427630, 124, '2015-03-01 00:07:16.000000', 'consum', 0.0227, 'lps'),
	(427631, 124, '2015-03-01 00:07:17.000000', 'consum', 0.0225, 'lps'),
	(427632, 124, '2015-03-01 00:07:18.000000', 'consum', 0.0210, 'lps'),
	(427633, 124, '2015-03-01 00:07:19.000000', 'consum', 0.0216, 'lps'),
	(427634, 124, '2015-03-01 00:07:20.000000', 'consum', 0.0216, 'lps'),
	(427635, 124, '2015-03-01 00:07:21.000000', 'consum', 0.0222, 'lps'),
	(427636, 124, '2015-03-01 00:07:22.000000', 'consum', 0.0225, 'lps'),
	(427637, 124, '2015-03-01 00:07:23.000000', 'consum', 0.0224, 'lps'),
	(427638, 124, '2015-03-01 00:07:24.000000', 'consum', 0.0210, 'lps'),
	(427639, 124, '2015-03-01 00:07:25.000000', 'consum', 0.0220, 'lps'),
	(427640, 124, '2015-03-01 00:07:26.000000', 'consum', 0.0235, 'lps'),
	(427641, 124, '2015-03-01 00:07:27.000000', 'consum', 0.0227, 'lps'),
	(427642, 124, '2015-03-01 00:07:28.000000', 'consum', 0.0222, 'lps'),
	(427643, 124, '2015-03-01 00:07:29.000000', 'consum', 0.0219, 'lps'),
	(427644, 124, '2015-03-01 00:07:30.000000', 'consum', 0.0220, 'lps'),
	(427645, 124, '2015-03-01 00:07:31.000000', 'consum', 0.0231, 'lps'),
	(427646, 124, '2015-03-01 00:07:32.000000', 'consum', 0.0234, 'lps'),
	(427647, 124, '2015-03-01 00:07:33.000000', 'consum', 0.0217, 'lps'),
	(427648, 124, '2015-03-01 00:07:34.000000', 'consum', 0.0227, 'lps'),
	(427649, 124, '2015-03-01 00:07:35.000000', 'consum', 0.0220, 'lps'),
	(427650, 124, '2015-03-01 00:07:36.000000', 'consum', 0.0210, 'lps'),
	(427651, 124, '2015-03-01 00:07:37.000000', 'consum', 0.0233, 'lps'),
	(427652, 124, '2015-03-01 00:07:38.000000', 'consum', 0.0221, 'lps'),
	(427653, 124, '2015-03-01 00:07:39.000000', 'consum', 0.0224, 'lps'),
	(427654, 124, '2015-03-01 00:07:40.000000', 'consum', 0.0218, 'lps'),
	(427655, 124, '2015-03-01 00:07:41.000000', 'consum', 0.0212, 'lps'),
	(427656, 124, '2015-03-01 00:07:42.000000', 'consum', 0.0222, 'lps'),
	(427657, 124, '2015-03-01 00:07:43.000000', 'consum', 0.0214, 'lps'),
	(427658, 124, '2015-03-01 00:07:44.000000', 'consum', 0.0219, 'lps'),
	(427659, 124, '2015-03-01 00:07:45.000000', 'consum', 0.0215, 'lps'),
	(427660, 124, '2015-03-01 00:07:46.000000', 'consum', 0.0212, 'lps'),
	(427661, 124, '2015-03-01 00:07:47.000000', 'consum', 0.0232, 'lps'),
	(427662, 124, '2015-03-01 00:07:48.000000', 'consum', 0.0234, 'lps'),
	(427663, 124, '2015-03-01 00:07:49.000000', 'consum', 0.0215, 'lps'),
	(427664, 124, '2015-03-01 00:07:50.000000', 'consum', 0.0212, 'lps'),
	(427665, 124, '2015-03-01 00:07:51.000000', 'consum', 0.0235, 'lps'),
	(427666, 124, '2015-03-01 00:07:52.000000', 'consum', 0.0224, 'lps'),
	(427667, 124, '2015-03-01 00:07:53.000000', 'consum', 0.0233, 'lps'),
	(427668, 124, '2015-03-01 00:07:54.000000', 'consum', 0.0228, 'lps'),
	(427669, 124, '2015-03-01 00:07:55.000000', 'consum', 0.0235, 'lps'),
	(427670, 124, '2015-03-01 00:07:56.000000', 'consum', 0.0229, 'lps'),
	(427671, 124, '2015-03-01 00:07:57.000000', 'consum', 0.0230, 'lps'),
	(427672, 124, '2015-03-01 00:07:58.000000', 'consum', 0.0229, 'lps'),
	(427673, 124, '2015-03-01 00:07:59.000000', 'consum', 0.0218, 'lps'),
	(427674, 124, '2015-03-01 00:08:00.000000', 'consum', 0.0219, 'lps'),
	(427675, 124, '2015-03-01 00:08:01.000000', 'consum', 0.0234, 'lps'),
	(427676, 124, '2015-03-01 00:08:02.000000', 'consum', 0.0222, 'lps'),
	(427677, 124, '2015-03-01 00:08:03.000000', 'consum', 0.0226, 'lps'),
	(427678, 124, '2015-03-01 00:08:04.000000', 'consum', 0.0230, 'lps'),
	(427679, 124, '2015-03-01 00:08:05.000000', 'consum', 0.0235, 'lps'),
	(427680, 124, '2015-03-01 00:08:06.000000', 'consum', 0.0222, 'lps'),
	(427681, 124, '2015-03-01 00:08:07.000000', 'consum', 0.0223, 'lps'),
	(427682, 124, '2015-03-01 00:08:08.000000', 'consum', 0.0212, 'lps'),
	(427683, 124, '2015-03-01 00:08:09.000000', 'consum', 0.0234, 'lps'),
	(427684, 124, '2015-03-01 00:08:10.000000', 'consum', 0.0221, 'lps'),
	(427685, 124, '2015-03-01 00:08:11.000000', 'consum', 0.0221, 'lps'),
	(427686, 124, '2015-03-01 00:08:12.000000', 'consum', 0.0233, 'lps'),
	(427687, 124, '2015-03-01 00:08:13.000000', 'consum', 0.0212, 'lps'),
	(427688, 124, '2015-03-01 00:08:14.000000', 'consum', 0.0232, 'lps'),
	(427689, 124, '2015-03-01 00:08:15.000000', 'consum', 0.0235, 'lps'),
	(427690, 124, '2015-03-01 00:08:16.000000', 'consum', 0.0219, 'lps'),
	(427691, 124, '2015-03-01 00:08:17.000000', 'consum', 0.0231, 'lps'),
	(427692, 124, '2015-03-01 00:08:18.000000', 'consum', 0.0210, 'lps'),
	(427693, 124, '2015-03-01 00:08:19.000000', 'consum', 0.0226, 'lps'),
	(427694, 124, '2015-03-01 00:08:20.000000', 'consum', 0.0215, 'lps'),
	(427695, 124, '2015-03-01 00:08:21.000000', 'consum', 0.0210, 'lps'),
	(427696, 124, '2015-03-01 00:08:22.000000', 'consum', 0.0223, 'lps'),
	(427697, 124, '2015-03-01 00:08:23.000000', 'consum', 0.0223, 'lps'),
	(427698, 124, '2015-03-01 00:08:24.000000', 'consum', 0.0210, 'lps'),
	(427699, 124, '2015-03-01 00:08:25.000000', 'consum', 0.0224, 'lps'),
	(427700, 124, '2015-03-01 00:08:26.000000', 'consum', 0.0227, 'lps'),
	(427701, 124, '2015-03-01 00:08:27.000000', 'consum', 0.0228, 'lps'),
	(427702, 124, '2015-03-01 00:08:28.000000', 'consum', 0.0224, 'lps'),
	(427703, 124, '2015-03-01 00:08:29.000000', 'consum', 0.0228, 'lps'),
	(427704, 124, '2015-03-01 00:08:30.000000', 'consum', 0.0231, 'lps'),
	(427705, 124, '2015-03-01 00:08:31.000000', 'consum', 0.0234, 'lps'),
	(427706, 124, '2015-03-01 00:08:32.000000', 'consum', 0.0217, 'lps'),
	(427707, 124, '2015-03-01 00:08:33.000000', 'consum', 0.0223, 'lps'),
	(427708, 124, '2015-03-01 00:08:34.000000', 'consum', 0.0231, 'lps'),
	(427709, 124, '2015-03-01 00:08:35.000000', 'consum', 0.0224, 'lps'),
	(427710, 124, '2015-03-01 00:08:36.000000', 'consum', 0.0217, 'lps'),
	(427711, 124, '2015-03-01 00:08:37.000000', 'consum', 0.0228, 'lps'),
	(427712, 124, '2015-03-01 00:08:38.000000', 'consum', 0.0229, 'lps'),
	(427713, 124, '2015-03-01 00:08:39.000000', 'consum', 0.0224, 'lps'),
	(427714, 124, '2015-03-01 00:08:40.000000', 'consum', 0.0226, 'lps'),
	(427715, 124, '2015-03-01 00:08:41.000000', 'consum', 0.0222, 'lps'),
	(427716, 124, '2015-03-01 00:08:42.000000', 'consum', 0.0221, 'lps'),
	(427717, 124, '2015-03-01 00:08:43.000000', 'consum', 0.0229, 'lps'),
	(427718, 124, '2015-03-01 00:08:44.000000', 'consum', 0.0221, 'lps'),
	(427719, 124, '2015-03-01 00:08:45.000000', 'consum', 0.0235, 'lps'),
	(427720, 124, '2015-03-01 00:08:46.000000', 'consum', 0.0222, 'lps'),
	(427721, 124, '2015-03-01 00:08:47.000000', 'consum', 0.0225, 'lps'),
	(427722, 124, '2015-03-01 00:08:48.000000', 'consum', 0.0222, 'lps'),
	(427723, 124, '2015-03-01 00:08:49.000000', 'consum', 0.0228, 'lps'),
	(427724, 124, '2015-03-01 00:08:50.000000', 'consum', 0.0235, 'lps'),
	(427725, 124, '2015-03-01 00:08:51.000000', 'consum', 0.0233, 'lps'),
	(427726, 124, '2015-03-01 00:08:52.000000', 'consum', 0.0222, 'lps'),
	(427727, 124, '2015-03-01 00:08:53.000000', 'consum', 0.0228, 'lps'),
	(427728, 124, '2015-03-01 00:08:54.000000', 'consum', 0.0211, 'lps'),
	(427729, 124, '2015-03-01 00:08:55.000000', 'consum', 0.0215, 'lps'),
	(427730, 124, '2015-03-01 00:08:56.000000', 'consum', 0.0233, 'lps'),
	(427731, 124, '2015-03-01 00:08:57.000000', 'consum', 0.0231, 'lps'),
	(427732, 124, '2015-03-01 00:08:58.000000', 'consum', 0.0220, 'lps'),
	(427733, 124, '2015-03-01 00:08:59.000000', 'consum', 0.0225, 'lps'),
	(427734, 124, '2015-03-01 00:09:00.000000', 'consum', 0.0228, 'lps'),
	(427735, 124, '2015-03-01 00:09:01.000000', 'consum', 0.0232, 'lps'),
	(427736, 124, '2015-03-01 00:09:02.000000', 'consum', 0.0211, 'lps'),
	(427737, 124, '2015-03-01 00:09:03.000000', 'consum', 0.0230, 'lps'),
	(427738, 124, '2015-03-01 00:09:04.000000', 'consum', 0.0228, 'lps'),
	(427739, 124, '2015-03-01 00:09:05.000000', 'consum', 0.0214, 'lps'),
	(427740, 124, '2015-03-01 00:09:06.000000', 'consum', 0.0228, 'lps'),
	(427741, 124, '2015-03-01 00:09:07.000000', 'consum', 0.0210, 'lps'),
	(427742, 124, '2015-03-01 00:09:08.000000', 'consum', 0.0235, 'lps'),
	(427743, 124, '2015-03-01 00:09:09.000000', 'consum', 0.0233, 'lps'),
	(427744, 124, '2015-03-01 00:09:10.000000', 'consum', 0.0223, 'lps'),
	(427745, 124, '2015-03-01 00:09:11.000000', 'consum', 0.0235, 'lps'),
	(427746, 124, '2015-03-01 00:09:12.000000', 'consum', 0.0217, 'lps'),
	(427747, 124, '2015-03-01 00:09:13.000000', 'consum', 0.0223, 'lps'),
	(427748, 124, '2015-03-01 00:09:14.000000', 'consum', 0.0226, 'lps'),
	(427749, 124, '2015-03-01 00:09:15.000000', 'consum', 0.0228, 'lps'),
	(427750, 124, '2015-03-01 00:09:16.000000', 'consum', 0.0225, 'lps'),
	(427751, 124, '2015-03-01 00:09:17.000000', 'consum', 0.0234, 'lps'),
	(427752, 124, '2015-03-01 00:09:18.000000', 'consum', 0.0230, 'lps'),
	(427753, 124, '2015-03-01 00:09:19.000000', 'consum', 0.0214, 'lps'),
	(427754, 124, '2015-03-01 00:09:20.000000', 'consum', 0.0224, 'lps'),
	(427755, 124, '2015-03-01 00:09:21.000000', 'consum', 0.0215, 'lps'),
	(427756, 124, '2015-03-01 00:09:22.000000', 'consum', 0.0218, 'lps'),
	(427757, 124, '2015-03-01 00:09:23.000000', 'consum', 0.0211, 'lps'),
	(427758, 124, '2015-03-01 00:09:24.000000', 'consum', 0.0219, 'lps'),
	(427759, 124, '2015-03-01 00:09:25.000000', 'consum', 0.0224, 'lps'),
	(427760, 124, '2015-03-01 00:09:26.000000', 'consum', 0.0229, 'lps'),
	(427761, 124, '2015-03-01 00:09:27.000000', 'consum', 0.0211, 'lps'),
	(427762, 124, '2015-03-01 00:09:28.000000', 'consum', 0.0212, 'lps'),
	(427763, 124, '2015-03-01 00:09:29.000000', 'consum', 0.0216, 'lps'),
	(427764, 124, '2015-03-01 00:09:30.000000', 'consum', 0.0210, 'lps'),
	(427765, 124, '2015-03-01 00:09:31.000000', 'consum', 0.0216, 'lps'),
	(427766, 124, '2015-03-01 00:09:32.000000', 'consum', 0.0217, 'lps'),
	(427767, 124, '2015-03-01 00:09:33.000000', 'consum', 0.0228, 'lps'),
	(427768, 124, '2015-03-01 00:09:34.000000', 'consum', 0.0227, 'lps'),
	(427769, 124, '2015-03-01 00:09:35.000000', 'consum', 0.0216, 'lps'),
	(427770, 124, '2015-03-01 00:09:36.000000', 'consum', 0.0213, 'lps'),
	(427771, 124, '2015-03-01 00:09:37.000000', 'consum', 0.0210, 'lps'),
	(427772, 124, '2015-03-01 00:09:38.000000', 'consum', 0.0227, 'lps'),
	(427773, 124, '2015-03-01 00:09:39.000000', 'consum', 0.0217, 'lps'),
	(427774, 124, '2015-03-01 00:09:40.000000', 'consum', 0.0220, 'lps'),
	(427775, 124, '2015-03-01 00:09:41.000000', 'consum', 0.0213, 'lps'),
	(427776, 124, '2015-03-01 00:09:42.000000', 'consum', 0.0221, 'lps'),
	(427777, 124, '2015-03-01 00:09:43.000000', 'consum', 0.0233, 'lps'),
	(427778, 124, '2015-03-01 00:09:44.000000', 'consum', 0.0212, 'lps'),
	(427779, 124, '2015-03-01 00:09:45.000000', 'consum', 0.0231, 'lps'),
	(427780, 124, '2015-03-01 00:09:46.000000', 'consum', 0.0231, 'lps'),
	(427781, 124, '2015-03-01 00:09:47.000000', 'consum', 0.0226, 'lps'),
	(427782, 124, '2015-03-01 00:09:48.000000', 'consum', 0.0227, 'lps'),
	(427783, 124, '2015-03-01 00:09:49.000000', 'consum', 0.0221, 'lps'),
	(427784, 124, '2015-03-01 00:09:50.000000', 'consum', 0.0215, 'lps'),
	(427785, 124, '2015-03-01 00:09:51.000000', 'consum', 0.0229, 'lps'),
	(427786, 124, '2015-03-01 00:09:52.000000', 'consum', 0.0211, 'lps'),
	(427787, 124, '2015-03-01 00:09:53.000000', 'consum', 0.0213, 'lps'),
	(427788, 124, '2015-03-01 00:09:54.000000', 'consum', 0.0222, 'lps'),
	(427789, 124, '2015-03-01 00:09:55.000000', 'consum', 0.0210, 'lps'),
	(427790, 124, '2015-03-01 00:09:56.000000', 'consum', 0.0226, 'lps'),
	(427791, 124, '2015-03-01 00:09:57.000000', 'consum', 0.0211, 'lps'),
	(427792, 124, '2015-03-01 00:09:58.000000', 'consum', 0.0219, 'lps'),
	(427793, 124, '2015-03-01 00:09:59.000000', 'consum', 0.0229, 'lps'),
	(427794, 124, '2015-03-01 00:10:00.000000', 'consum', 0.0228, 'lps'),
	(427795, 124, '2015-03-01 00:10:01.000000', 'consum', 0.0214, 'lps'),
	(427796, 124, '2015-03-01 00:10:02.000000', 'consum', 0.0229, 'lps'),
	(427797, 124, '2015-03-01 00:10:03.000000', 'consum', 0.0216, 'lps'),
	(427798, 124, '2015-03-01 00:10:04.000000', 'consum', 0.0235, 'lps'),
	(427799, 124, '2015-03-01 00:10:05.000000', 'consum', 0.0215, 'lps'),
	(427800, 124, '2015-03-01 00:10:06.000000', 'consum', 0.0214, 'lps'),
	(427801, 124, '2015-03-01 00:10:07.000000', 'consum', 0.0213, 'lps'),
	(427802, 124, '2015-03-01 00:10:08.000000', 'consum', 0.0214, 'lps'),
	(427803, 124, '2015-03-01 00:10:09.000000', 'consum', 0.0220, 'lps'),
	(427804, 124, '2015-03-01 00:10:10.000000', 'consum', 0.0223, 'lps'),
	(427805, 124, '2015-03-01 00:10:11.000000', 'consum', 0.0220, 'lps'),
	(427806, 124, '2015-03-01 00:10:12.000000', 'consum', 0.0221, 'lps'),
	(427807, 124, '2015-03-01 00:10:13.000000', 'consum', 0.0235, 'lps'),
	(427808, 124, '2015-03-01 00:10:14.000000', 'consum', 0.0226, 'lps'),
	(427809, 124, '2015-03-01 00:10:15.000000', 'consum', 0.0214, 'lps'),
	(427810, 124, '2015-03-01 00:10:16.000000', 'consum', 0.0210, 'lps'),
	(427811, 124, '2015-03-01 00:10:17.000000', 'consum', 0.0224, 'lps'),
	(427812, 124, '2015-03-01 00:10:18.000000', 'consum', 0.0230, 'lps'),
	(427813, 124, '2015-03-01 00:10:19.000000', 'consum', 0.0216, 'lps'),
	(427814, 124, '2015-03-01 00:10:20.000000', 'consum', 0.0231, 'lps'),
	(427815, 124, '2015-03-01 00:10:21.000000', 'consum', 0.0219, 'lps'),
	(427816, 124, '2015-03-01 00:10:22.000000', 'consum', 0.0218, 'lps'),
	(427817, 124, '2015-03-01 00:10:23.000000', 'consum', 0.0225, 'lps'),
	(427818, 124, '2015-03-01 00:10:24.000000', 'consum', 0.0234, 'lps'),
	(427819, 124, '2015-03-01 00:10:25.000000', 'consum', 0.0210, 'lps'),
	(427820, 124, '2015-03-01 00:10:26.000000', 'consum', 0.0215, 'lps'),
	(427821, 124, '2015-03-01 00:10:27.000000', 'consum', 0.0211, 'lps'),
	(427822, 124, '2015-03-01 00:10:28.000000', 'consum', 0.0228, 'lps'),
	(427823, 124, '2015-03-01 00:10:29.000000', 'consum', 0.0216, 'lps'),
	(427824, 124, '2015-03-01 00:10:30.000000', 'consum', 0.0213, 'lps'),
	(427825, 124, '2015-03-01 00:10:31.000000', 'consum', 0.0234, 'lps'),
	(427826, 124, '2015-03-01 00:10:32.000000', 'consum', 0.0218, 'lps'),
	(427827, 124, '2015-03-01 00:10:33.000000', 'consum', 0.0231, 'lps'),
	(427828, 124, '2015-03-01 00:10:34.000000', 'consum', 0.0211, 'lps'),
	(427829, 124, '2015-03-01 00:10:35.000000', 'consum', 0.0231, 'lps'),
	(427830, 124, '2015-03-01 00:10:36.000000', 'consum', 0.0234, 'lps'),
	(427831, 124, '2015-03-01 00:10:37.000000', 'consum', 0.0218, 'lps'),
	(427832, 124, '2015-03-01 00:10:38.000000', 'consum', 0.0231, 'lps'),
	(427833, 124, '2015-03-01 00:10:39.000000', 'consum', 0.0211, 'lps'),
	(427834, 124, '2015-03-01 00:10:40.000000', 'consum', 0.0232, 'lps'),
	(427835, 124, '2015-03-01 00:10:41.000000', 'consum', 0.0214, 'lps'),
	(427836, 124, '2015-03-01 00:10:42.000000', 'consum', 0.0215, 'lps'),
	(427837, 124, '2015-03-01 00:10:43.000000', 'consum', 0.0226, 'lps'),
	(427838, 124, '2015-03-01 00:10:44.000000', 'consum', 0.0221, 'lps'),
	(427839, 124, '2015-03-01 00:10:45.000000', 'consum', 0.0219, 'lps'),
	(427840, 124, '2015-03-01 00:10:46.000000', 'consum', 0.0223, 'lps'),
	(427841, 124, '2015-03-01 00:10:47.000000', 'consum', 0.0222, 'lps'),
	(427842, 124, '2015-03-01 00:10:48.000000', 'consum', 0.0231, 'lps'),
	(427843, 124, '2015-03-01 00:10:49.000000', 'consum', 0.0227, 'lps'),
	(427844, 124, '2015-03-01 00:10:50.000000', 'consum', 0.0234, 'lps'),
	(427845, 124, '2015-03-01 00:10:51.000000', 'consum', 0.0227, 'lps'),
	(427846, 124, '2015-03-01 00:10:52.000000', 'consum', 0.0223, 'lps'),
	(427847, 124, '2015-03-01 00:10:53.000000', 'consum', 0.0223, 'lps'),
	(427848, 124, '2015-03-01 00:10:54.000000', 'consum', 0.0212, 'lps'),
	(427849, 124, '2015-03-01 00:10:55.000000', 'consum', 0.0232, 'lps'),
	(427850, 124, '2015-03-01 00:10:56.000000', 'consum', 0.0212, 'lps'),
	(427851, 124, '2015-03-01 00:10:57.000000', 'consum', 0.0231, 'lps'),
	(427852, 124, '2015-03-01 00:10:58.000000', 'consum', 0.0232, 'lps'),
	(427853, 124, '2015-03-01 00:10:59.000000', 'consum', 0.0230, 'lps'),
	(427854, 124, '2015-03-01 00:11:00.000000', 'consum', 0.0218, 'lps'),
	(427855, 124, '2015-03-01 00:11:01.000000', 'consum', 0.0217, 'lps'),
	(427856, 124, '2015-03-01 00:11:02.000000', 'consum', 0.0224, 'lps'),
	(427857, 124, '2015-03-01 00:11:03.000000', 'consum', 0.0232, 'lps'),
	(427858, 124, '2015-03-01 00:11:04.000000', 'consum', 0.0225, 'lps'),
	(427859, 124, '2015-03-01 00:11:05.000000', 'consum', 0.0221, 'lps'),
	(427860, 124, '2015-03-01 00:11:06.000000', 'consum', 0.0218, 'lps'),
	(427861, 124, '2015-03-01 00:11:07.000000', 'consum', 0.0220, 'lps'),
	(427862, 124, '2015-03-01 00:11:08.000000', 'consum', 0.0234, 'lps'),
	(427863, 124, '2015-03-01 00:11:09.000000', 'consum', 0.0225, 'lps'),
	(427864, 124, '2015-03-01 00:11:10.000000', 'consum', 0.0213, 'lps'),
	(427865, 124, '2015-03-01 00:11:11.000000', 'consum', 0.0231, 'lps'),
	(427866, 124, '2015-03-01 00:11:12.000000', 'consum', 0.0229, 'lps'),
	(427867, 124, '2015-03-01 00:11:13.000000', 'consum', 0.0216, 'lps'),
	(427868, 124, '2015-03-01 00:11:14.000000', 'consum', 0.0235, 'lps'),
	(427869, 124, '2015-03-01 00:11:15.000000', 'consum', 0.0213, 'lps'),
	(427870, 124, '2015-03-01 00:11:16.000000', 'consum', 0.0228, 'lps'),
	(427871, 124, '2015-03-01 00:11:17.000000', 'consum', 0.0214, 'lps'),
	(427872, 124, '2015-03-01 00:11:18.000000', 'consum', 0.0231, 'lps'),
	(427873, 124, '2015-03-01 00:11:19.000000', 'consum', 0.0223, 'lps'),
	(427874, 124, '2015-03-01 00:11:20.000000', 'consum', 0.0214, 'lps'),
	(427875, 124, '2015-03-01 00:11:21.000000', 'consum', 0.0215, 'lps'),
	(427876, 124, '2015-03-01 00:11:22.000000', 'consum', 0.0225, 'lps'),
	(427877, 124, '2015-03-01 00:11:23.000000', 'consum', 0.0220, 'lps'),
	(427878, 124, '2015-03-01 00:11:24.000000', 'consum', 0.0213, 'lps'),
	(427879, 124, '2015-03-01 00:11:25.000000', 'consum', 0.0222, 'lps'),
	(427880, 124, '2015-03-01 00:11:26.000000', 'consum', 0.0211, 'lps'),
	(427881, 124, '2015-03-01 00:11:27.000000', 'consum', 0.0232, 'lps'),
	(427882, 124, '2015-03-01 00:11:28.000000', 'consum', 0.0211, 'lps'),
	(427883, 124, '2015-03-01 00:11:29.000000', 'consum', 0.0228, 'lps'),
	(427884, 124, '2015-03-01 00:11:30.000000', 'consum', 0.0222, 'lps'),
	(427885, 124, '2015-03-01 00:11:31.000000', 'consum', 0.0214, 'lps'),
	(427886, 124, '2015-03-01 00:11:32.000000', 'consum', 0.0222, 'lps'),
	(427887, 124, '2015-03-01 00:11:33.000000', 'consum', 0.0230, 'lps'),
	(427888, 124, '2015-03-01 00:11:34.000000', 'consum', 0.0224, 'lps'),
	(427889, 124, '2015-03-01 00:11:35.000000', 'consum', 0.0220, 'lps'),
	(427890, 124, '2015-03-01 00:11:36.000000', 'consum', 0.0218, 'lps'),
	(427891, 124, '2015-03-01 00:11:37.000000', 'consum', 0.0222, 'lps'),
	(427892, 124, '2015-03-01 00:11:38.000000', 'consum', 0.0221, 'lps'),
	(427893, 124, '2015-03-01 00:11:39.000000', 'consum', 0.0230, 'lps'),
	(427894, 124, '2015-03-01 00:11:40.000000', 'consum', 0.0225, 'lps'),
	(427895, 124, '2015-03-01 00:11:41.000000', 'consum', 0.0225, 'lps'),
	(427896, 124, '2015-03-01 00:11:42.000000', 'consum', 0.0216, 'lps'),
	(427897, 124, '2015-03-01 00:11:43.000000', 'consum', 0.0219, 'lps'),
	(427898, 124, '2015-03-01 00:11:44.000000', 'consum', 0.0212, 'lps'),
	(427899, 124, '2015-03-01 00:11:45.000000', 'consum', 0.0218, 'lps'),
	(427900, 124, '2015-03-01 00:11:46.000000', 'consum', 0.0222, 'lps'),
	(427901, 124, '2015-03-01 00:11:47.000000', 'consum', 0.0218, 'lps'),
	(427902, 124, '2015-03-01 00:11:48.000000', 'consum', 0.0215, 'lps'),
	(427903, 124, '2015-03-01 00:11:49.000000', 'consum', 0.0212, 'lps'),
	(427904, 124, '2015-03-01 00:11:50.000000', 'consum', 0.0232, 'lps'),
	(427905, 124, '2015-03-01 00:11:51.000000', 'consum', 0.0210, 'lps'),
	(427906, 124, '2015-03-01 00:11:52.000000', 'consum', 0.0224, 'lps'),
	(427907, 124, '2015-03-01 00:11:53.000000', 'consum', 0.0228, 'lps'),
	(427908, 124, '2015-03-01 00:11:54.000000', 'consum', 0.0231, 'lps'),
	(427909, 124, '2015-03-01 00:11:55.000000', 'consum', 0.0211, 'lps'),
	(427910, 124, '2015-03-01 00:11:56.000000', 'consum', 0.0229, 'lps'),
	(427911, 124, '2015-03-01 00:11:57.000000', 'consum', 0.0226, 'lps'),
	(427912, 124, '2015-03-01 00:11:58.000000', 'consum', 0.0233, 'lps'),
	(427913, 124, '2015-03-01 00:11:59.000000', 'consum', 0.0224, 'lps'),
	(427914, 124, '2015-03-01 00:12:00.000000', 'consum', 0.0214, 'lps'),
	(427915, 124, '2015-03-01 00:12:01.000000', 'consum', 0.0214, 'lps'),
	(427916, 124, '2015-03-01 00:12:02.000000', 'consum', 0.0219, 'lps'),
	(427917, 124, '2015-03-01 00:12:03.000000', 'consum', 0.0215, 'lps'),
	(427918, 124, '2015-03-01 00:12:04.000000', 'consum', 0.0211, 'lps'),
	(427919, 124, '2015-03-01 00:12:05.000000', 'consum', 0.0227, 'lps'),
	(427920, 124, '2015-03-01 00:12:06.000000', 'consum', 0.0215, 'lps'),
	(427921, 124, '2015-03-01 00:12:07.000000', 'consum', 0.0235, 'lps'),
	(427922, 124, '2015-03-01 00:12:08.000000', 'consum', 0.0215, 'lps'),
	(427923, 124, '2015-03-01 00:12:09.000000', 'consum', 0.0215, 'lps'),
	(427924, 124, '2015-03-01 00:12:10.000000', 'consum', 0.0222, 'lps'),
	(427925, 124, '2015-03-01 00:12:11.000000', 'consum', 0.0227, 'lps'),
	(427926, 124, '2015-03-01 00:12:12.000000', 'consum', 0.0233, 'lps'),
	(427927, 124, '2015-03-01 00:12:13.000000', 'consum', 0.0221, 'lps'),
	(427928, 124, '2015-03-01 00:12:14.000000', 'consum', 0.0226, 'lps'),
	(427929, 124, '2015-03-01 00:12:15.000000', 'consum', 0.0230, 'lps'),
	(427930, 124, '2015-03-01 00:12:16.000000', 'consum', 0.0211, 'lps'),
	(427931, 124, '2015-03-01 00:12:17.000000', 'consum', 0.0233, 'lps'),
	(427932, 124, '2015-03-01 00:12:18.000000', 'consum', 0.0220, 'lps'),
	(427933, 124, '2015-03-01 00:12:19.000000', 'consum', 0.0217, 'lps'),
	(427934, 124, '2015-03-01 00:12:20.000000', 'consum', 0.0217, 'lps'),
	(427935, 124, '2015-03-01 00:12:21.000000', 'consum', 0.0224, 'lps'),
	(427936, 124, '2015-03-01 00:12:22.000000', 'consum', 0.0234, 'lps'),
	(427937, 124, '2015-03-01 00:12:23.000000', 'consum', 0.0234, 'lps'),
	(427938, 124, '2015-03-01 00:12:24.000000', 'consum', 0.0233, 'lps'),
	(427939, 124, '2015-03-01 00:12:25.000000', 'consum', 0.0228, 'lps'),
	(427940, 124, '2015-03-01 00:12:26.000000', 'consum', 0.0233, 'lps'),
	(427941, 124, '2015-03-01 00:12:27.000000', 'consum', 0.0220, 'lps'),
	(427942, 124, '2015-03-01 00:12:28.000000', 'consum', 0.0216, 'lps'),
	(427943, 124, '2015-03-01 00:12:29.000000', 'consum', 0.0212, 'lps'),
	(427944, 124, '2015-03-01 00:12:30.000000', 'consum', 0.0229, 'lps'),
	(427945, 124, '2015-03-01 00:12:31.000000', 'consum', 0.0220, 'lps'),
	(427946, 124, '2015-03-01 00:12:32.000000', 'consum', 0.0228, 'lps'),
	(427947, 124, '2015-03-01 00:12:33.000000', 'consum', 0.0220, 'lps'),
	(427948, 124, '2015-03-01 00:12:34.000000', 'consum', 0.0231, 'lps'),
	(427949, 124, '2015-03-01 00:12:35.000000', 'consum', 0.0234, 'lps'),
	(427950, 124, '2015-03-01 00:12:36.000000', 'consum', 0.0216, 'lps'),
	(427951, 124, '2015-03-01 00:12:37.000000', 'consum', 0.0219, 'lps'),
	(427952, 124, '2015-03-01 00:12:38.000000', 'consum', 0.0210, 'lps'),
	(427953, 124, '2015-03-01 00:12:39.000000', 'consum', 0.0213, 'lps'),
	(427954, 124, '2015-03-01 00:12:40.000000', 'consum', 0.0225, 'lps'),
	(427955, 124, '2015-03-01 00:12:41.000000', 'consum', 0.0223, 'lps'),
	(427956, 124, '2015-03-01 00:12:42.000000', 'consum', 0.0233, 'lps'),
	(427957, 124, '2015-03-01 00:12:43.000000', 'consum', 0.0235, 'lps'),
	(427958, 124, '2015-03-01 00:12:44.000000', 'consum', 0.0211, 'lps'),
	(427959, 124, '2015-03-01 00:12:45.000000', 'consum', 0.0221, 'lps'),
	(427960, 124, '2015-03-01 00:12:46.000000', 'consum', 0.0211, 'lps'),
	(427961, 124, '2015-03-01 00:12:47.000000', 'consum', 0.0233, 'lps'),
	(427962, 124, '2015-03-01 00:12:48.000000', 'consum', 0.0218, 'lps'),
	(427963, 124, '2015-03-01 00:12:49.000000', 'consum', 0.0235, 'lps'),
	(427964, 124, '2015-03-01 00:12:50.000000', 'consum', 0.0232, 'lps'),
	(427965, 124, '2015-03-01 00:12:51.000000', 'consum', 0.0220, 'lps'),
	(427966, 124, '2015-03-01 00:12:52.000000', 'consum', 0.0219, 'lps'),
	(427967, 124, '2015-03-01 00:12:53.000000', 'consum', 0.0227, 'lps'),
	(427968, 124, '2015-03-01 00:12:54.000000', 'consum', 0.0218, 'lps'),
	(427969, 124, '2015-03-01 00:12:55.000000', 'consum', 0.0225, 'lps'),
	(427970, 124, '2015-03-01 00:12:56.000000', 'consum', 0.0210, 'lps'),
	(427971, 124, '2015-03-01 00:12:57.000000', 'consum', 0.0216, 'lps'),
	(427972, 124, '2015-03-01 00:12:58.000000', 'consum', 0.0217, 'lps'),
	(427973, 124, '2015-03-01 00:12:59.000000', 'consum', 0.0224, 'lps'),
	(427974, 124, '2015-03-01 00:13:00.000000', 'consum', 0.0235, 'lps'),
	(427975, 124, '2015-03-01 00:13:01.000000', 'consum', 0.0217, 'lps'),
	(427976, 124, '2015-03-01 00:13:02.000000', 'consum', 0.0221, 'lps'),
	(427977, 124, '2015-03-01 00:13:03.000000', 'consum', 0.0219, 'lps'),
	(427978, 124, '2015-03-01 00:13:04.000000', 'consum', 0.0223, 'lps'),
	(427979, 124, '2015-03-01 00:13:05.000000', 'consum', 0.0223, 'lps'),
	(427980, 124, '2015-03-01 00:13:06.000000', 'consum', 0.0234, 'lps'),
	(427981, 124, '2015-03-01 00:13:07.000000', 'consum', 0.0215, 'lps'),
	(427982, 124, '2015-03-01 00:13:08.000000', 'consum', 0.0217, 'lps'),
	(427983, 124, '2015-03-01 00:13:09.000000', 'consum', 0.0229, 'lps'),
	(427984, 124, '2015-03-01 00:13:10.000000', 'consum', 0.0232, 'lps'),
	(427985, 124, '2015-03-01 00:13:11.000000', 'consum', 0.0212, 'lps'),
	(427986, 124, '2015-03-01 00:13:12.000000', 'consum', 0.0233, 'lps'),
	(427987, 124, '2015-03-01 00:13:13.000000', 'consum', 0.0214, 'lps'),
	(427988, 124, '2015-03-01 00:13:14.000000', 'consum', 0.0213, 'lps'),
	(427989, 124, '2015-03-01 00:13:15.000000', 'consum', 0.0212, 'lps'),
	(427990, 124, '2015-03-01 00:13:16.000000', 'consum', 0.0215, 'lps'),
	(427991, 124, '2015-03-01 00:13:17.000000', 'consum', 0.0229, 'lps'),
	(427992, 124, '2015-03-01 00:13:18.000000', 'consum', 0.0211, 'lps'),
	(427993, 124, '2015-03-01 00:13:19.000000', 'consum', 0.0210, 'lps'),
	(427994, 124, '2015-03-01 00:13:20.000000', 'consum', 0.0233, 'lps'),
	(427995, 124, '2015-03-01 00:13:21.000000', 'consum', 0.0222, 'lps'),
	(427996, 124, '2015-03-01 00:13:22.000000', 'consum', 0.0227, 'lps'),
	(427997, 124, '2015-03-01 00:13:23.000000', 'consum', 0.0234, 'lps'),
	(427998, 124, '2015-03-01 00:13:24.000000', 'consum', 0.0229, 'lps'),
	(427999, 124, '2015-03-01 00:13:25.000000', 'consum', 0.0232, 'lps'),
	(428000, 124, '2015-03-01 00:13:26.000000', 'consum', 0.0214, 'lps'),
	(428001, 124, '2015-03-01 00:13:27.000000', 'consum', 0.0214, 'lps'),
	(428002, 124, '2015-03-01 00:13:28.000000', 'consum', 0.0221, 'lps'),
	(428003, 124, '2015-03-01 00:13:29.000000', 'consum', 0.0227, 'lps'),
	(428004, 124, '2015-03-01 00:13:30.000000', 'consum', 0.0235, 'lps'),
	(428005, 124, '2015-03-01 00:13:31.000000', 'consum', 0.0234, 'lps'),
	(428006, 124, '2015-03-01 00:13:32.000000', 'consum', 0.0231, 'lps'),
	(428007, 124, '2015-03-01 00:13:33.000000', 'consum', 0.0215, 'lps'),
	(428008, 124, '2015-03-01 00:13:34.000000', 'consum', 0.0225, 'lps'),
	(428009, 124, '2015-03-01 00:13:35.000000', 'consum', 0.0220, 'lps'),
	(428010, 124, '2015-03-01 00:13:36.000000', 'consum', 0.0217, 'lps'),
	(428011, 124, '2015-03-01 00:13:37.000000', 'consum', 0.0212, 'lps'),
	(428012, 124, '2015-03-01 00:13:38.000000', 'consum', 0.0227, 'lps'),
	(428013, 124, '2015-03-01 00:13:39.000000', 'consum', 0.0210, 'lps'),
	(428014, 124, '2015-03-01 00:13:40.000000', 'consum', 0.0214, 'lps'),
	(428015, 124, '2015-03-01 00:13:41.000000', 'consum', 0.0230, 'lps'),
	(428016, 124, '2015-03-01 00:13:42.000000', 'consum', 0.0219, 'lps'),
	(428017, 124, '2015-03-01 00:13:43.000000', 'consum', 0.0223, 'lps'),
	(428018, 124, '2015-03-01 00:13:44.000000', 'consum', 0.0223, 'lps'),
	(428019, 124, '2015-03-01 00:13:45.000000', 'consum', 0.0212, 'lps'),
	(428020, 124, '2015-03-01 00:13:46.000000', 'consum', 0.0230, 'lps'),
	(428021, 124, '2015-03-01 00:13:47.000000', 'consum', 0.0230, 'lps'),
	(428022, 124, '2015-03-01 00:13:48.000000', 'consum', 0.0222, 'lps'),
	(428023, 124, '2015-03-01 00:13:49.000000', 'consum', 0.0211, 'lps'),
	(428024, 124, '2015-03-01 00:13:50.000000', 'consum', 0.0230, 'lps'),
	(428025, 124, '2015-03-01 00:13:51.000000', 'consum', 0.0232, 'lps'),
	(428026, 124, '2015-03-01 00:13:52.000000', 'consum', 0.0233, 'lps'),
	(428027, 124, '2015-03-01 00:13:53.000000', 'consum', 0.0232, 'lps'),
	(428028, 124, '2015-03-01 00:13:54.000000', 'consum', 0.0226, 'lps'),
	(428029, 124, '2015-03-01 00:13:55.000000', 'consum', 0.0225, 'lps'),
	(428030, 124, '2015-03-01 00:13:56.000000', 'consum', 0.0213, 'lps'),
	(428031, 124, '2015-03-01 00:13:57.000000', 'consum', 0.0230, 'lps'),
	(428032, 124, '2015-03-01 00:13:58.000000', 'consum', 0.0224, 'lps'),
	(428033, 124, '2015-03-01 00:13:59.000000', 'consum', 0.0220, 'lps'),
	(428034, 124, '2015-03-01 00:14:00.000000', 'consum', 0.0220, 'lps'),
	(428035, 124, '2015-03-01 00:14:01.000000', 'consum', 0.0232, 'lps'),
	(428036, 124, '2015-03-01 00:14:02.000000', 'consum', 0.0235, 'lps'),
	(428037, 124, '2015-03-01 00:14:03.000000', 'consum', 0.0218, 'lps'),
	(428038, 124, '2015-03-01 00:14:04.000000', 'consum', 0.0230, 'lps'),
	(428039, 124, '2015-03-01 00:14:05.000000', 'consum', 0.0232, 'lps'),
	(428040, 124, '2015-03-01 00:14:06.000000', 'consum', 0.0211, 'lps'),
	(428041, 124, '2015-03-01 00:14:07.000000', 'consum', 0.0228, 'lps'),
	(428042, 124, '2015-03-01 00:14:08.000000', 'consum', 0.0218, 'lps'),
	(428043, 124, '2015-03-01 00:14:09.000000', 'consum', 0.0223, 'lps'),
	(428044, 124, '2015-03-01 00:14:10.000000', 'consum', 0.0223, 'lps'),
	(428045, 124, '2015-03-01 00:14:11.000000', 'consum', 0.0213, 'lps'),
	(428046, 124, '2015-03-01 00:14:12.000000', 'consum', 0.0212, 'lps'),
	(428047, 124, '2015-03-01 00:14:13.000000', 'consum', 0.0211, 'lps'),
	(428048, 124, '2015-03-01 00:14:14.000000', 'consum', 0.0234, 'lps'),
	(428049, 124, '2015-03-01 00:14:15.000000', 'consum', 0.0226, 'lps'),
	(428050, 124, '2015-03-01 00:14:16.000000', 'consum', 0.0218, 'lps'),
	(428051, 124, '2015-03-01 00:14:17.000000', 'consum', 0.0230, 'lps'),
	(428052, 124, '2015-03-01 00:14:18.000000', 'consum', 0.0234, 'lps'),
	(428053, 124, '2015-03-01 00:14:19.000000', 'consum', 0.0218, 'lps'),
	(428054, 124, '2015-03-01 00:14:20.000000', 'consum', 0.0230, 'lps'),
	(428055, 124, '2015-03-01 00:14:21.000000', 'consum', 0.0235, 'lps'),
	(428056, 124, '2015-03-01 00:14:22.000000', 'consum', 0.0224, 'lps'),
	(428057, 124, '2015-03-01 00:14:23.000000', 'consum', 0.0233, 'lps'),
	(428058, 124, '2015-03-01 00:14:24.000000', 'consum', 0.0228, 'lps'),
	(428059, 124, '2015-03-01 00:14:25.000000', 'consum', 0.0233, 'lps'),
	(428060, 124, '2015-03-01 00:14:26.000000', 'consum', 0.0220, 'lps'),
	(428061, 124, '2015-03-01 00:14:27.000000', 'consum', 0.0218, 'lps'),
	(428062, 124, '2015-03-01 00:14:28.000000', 'consum', 0.0221, 'lps'),
	(428063, 124, '2015-03-01 00:14:29.000000', 'consum', 0.0214, 'lps'),
	(428064, 124, '2015-03-01 00:14:30.000000', 'consum', 0.0225, 'lps'),
	(428065, 124, '2015-03-01 00:14:31.000000', 'consum', 0.0219, 'lps'),
	(428066, 124, '2015-03-01 00:14:32.000000', 'consum', 0.0212, 'lps'),
	(428067, 124, '2015-03-01 00:14:33.000000', 'consum', 0.0221, 'lps'),
	(428068, 124, '2015-03-01 00:14:34.000000', 'consum', 0.0234, 'lps'),
	(428069, 124, '2015-03-01 00:14:35.000000', 'consum', 0.0217, 'lps'),
	(428070, 124, '2015-03-01 00:14:36.000000', 'consum', 0.0225, 'lps'),
	(428071, 124, '2015-03-01 00:14:37.000000', 'consum', 0.0215, 'lps'),
	(428072, 124, '2015-03-01 00:14:38.000000', 'consum', 0.0215, 'lps'),
	(428073, 124, '2015-03-01 00:14:39.000000', 'consum', 0.0219, 'lps'),
	(428074, 124, '2015-03-01 00:14:40.000000', 'consum', 0.0215, 'lps'),
	(428075, 124, '2015-03-01 00:14:41.000000', 'consum', 0.0210, 'lps'),
	(428076, 124, '2015-03-01 00:14:42.000000', 'consum', 0.0222, 'lps'),
	(428077, 124, '2015-03-01 00:14:43.000000', 'consum', 0.0218, 'lps'),
	(428078, 124, '2015-03-01 00:14:44.000000', 'consum', 0.0214, 'lps'),
	(428079, 124, '2015-03-01 00:14:45.000000', 'consum', 0.0232, 'lps'),
	(428080, 124, '2015-03-01 00:14:46.000000', 'consum', 0.0229, 'lps'),
	(428081, 124, '2015-03-01 00:14:47.000000', 'consum', 0.0215, 'lps'),
	(428082, 124, '2015-03-01 00:14:48.000000', 'consum', 0.0230, 'lps'),
	(428083, 124, '2015-03-01 00:14:49.000000', 'consum', 0.0217, 'lps'),
	(428084, 124, '2015-03-01 00:14:50.000000', 'consum', 0.0213, 'lps'),
	(428085, 124, '2015-03-01 00:14:51.000000', 'consum', 0.0228, 'lps'),
	(428086, 124, '2015-03-01 00:14:52.000000', 'consum', 0.0216, 'lps'),
	(428087, 124, '2015-03-01 00:14:53.000000', 'consum', 0.0211, 'lps'),
	(428088, 124, '2015-03-01 00:14:54.000000', 'consum', 0.0225, 'lps'),
	(428089, 124, '2015-03-01 00:14:55.000000', 'consum', 0.0230, 'lps'),
	(428090, 124, '2015-03-01 00:14:56.000000', 'consum', 0.0211, 'lps'),
	(428091, 124, '2015-03-01 00:14:57.000000', 'consum', 0.0211, 'lps'),
	(428092, 124, '2015-03-01 00:14:58.000000', 'consum', 0.0211, 'lps'),
	(428093, 124, '2015-03-01 00:14:59.000000', 'consum', 0.0211, 'lps'),
	(428094, 124, '2015-03-01 00:15:00.000000', 'consum', 0.0215, 'lps'),
	(428095, 124, '2015-03-01 00:15:01.000000', 'consum', 0.0232, 'lps'),
	(428096, 124, '2015-03-01 00:15:02.000000', 'consum', 0.0226, 'lps'),
	(428097, 124, '2015-03-01 00:15:03.000000', 'consum', 0.0224, 'lps'),
	(428098, 124, '2015-03-01 00:15:04.000000', 'consum', 0.0235, 'lps'),
	(428099, 124, '2015-03-01 00:15:05.000000', 'consum', 0.0213, 'lps'),
	(428100, 124, '2015-03-01 00:15:06.000000', 'consum', 0.0230, 'lps'),
	(428101, 124, '2015-03-01 00:15:07.000000', 'consum', 0.0222, 'lps'),
	(428102, 124, '2015-03-01 00:15:08.000000', 'consum', 0.0212, 'lps'),
	(428103, 124, '2015-03-01 00:15:09.000000', 'consum', 0.0211, 'lps'),
	(428104, 124, '2015-03-01 00:15:10.000000', 'consum', 0.0210, 'lps'),
	(428105, 124, '2015-03-01 00:15:11.000000', 'consum', 0.0233, 'lps'),
	(428106, 124, '2015-03-01 00:15:12.000000', 'consum', 0.0223, 'lps'),
	(428107, 124, '2015-03-01 00:15:13.000000', 'consum', 0.0229, 'lps'),
	(428108, 124, '2015-03-01 00:15:14.000000', 'consum', 0.0217, 'lps'),
	(428109, 124, '2015-03-01 00:15:15.000000', 'consum', 0.0214, 'lps'),
	(428110, 124, '2015-03-01 00:15:16.000000', 'consum', 0.0235, 'lps'),
	(428111, 124, '2015-03-01 00:15:17.000000', 'consum', 0.0219, 'lps'),
	(428112, 124, '2015-03-01 00:15:18.000000', 'consum', 0.0234, 'lps'),
	(428113, 124, '2015-03-01 00:15:19.000000', 'consum', 0.0224, 'lps'),
	(428114, 124, '2015-03-01 00:15:20.000000', 'consum', 0.0234, 'lps'),
	(428115, 124, '2015-03-01 00:15:21.000000', 'consum', 0.0211, 'lps'),
	(428116, 124, '2015-03-01 00:15:22.000000', 'consum', 0.0221, 'lps'),
	(428117, 124, '2015-03-01 00:15:23.000000', 'consum', 0.0213, 'lps'),
	(428118, 124, '2015-03-01 00:15:24.000000', 'consum', 0.0216, 'lps'),
	(428119, 124, '2015-03-01 00:15:25.000000', 'consum', 0.0233, 'lps'),
	(428120, 124, '2015-03-01 00:15:26.000000', 'consum', 0.0231, 'lps'),
	(428121, 124, '2015-03-01 00:15:27.000000', 'consum', 0.0217, 'lps'),
	(428122, 124, '2015-03-01 00:15:28.000000', 'consum', 0.0210, 'lps'),
	(428123, 124, '2015-03-01 00:15:29.000000', 'consum', 0.0216, 'lps'),
	(428124, 124, '2015-03-01 00:15:30.000000', 'consum', 0.0214, 'lps'),
	(428125, 124, '2015-03-01 00:15:31.000000', 'consum', 0.0213, 'lps'),
	(428126, 124, '2015-03-01 00:15:32.000000', 'consum', 0.0212, 'lps'),
	(428127, 124, '2015-03-01 00:15:33.000000', 'consum', 0.0212, 'lps'),
	(428128, 124, '2015-03-01 00:15:34.000000', 'consum', 0.0216, 'lps'),
	(428129, 124, '2015-03-01 00:15:35.000000', 'consum', 0.0235, 'lps'),
	(428130, 124, '2015-03-01 00:15:36.000000', 'consum', 0.0213, 'lps'),
	(428131, 124, '2015-03-01 00:15:37.000000', 'consum', 0.0227, 'lps'),
	(428132, 124, '2015-03-01 00:15:38.000000', 'consum', 0.0211, 'lps'),
	(428133, 124, '2015-03-01 00:15:39.000000', 'consum', 0.0216, 'lps'),
	(428134, 124, '2015-03-01 00:15:40.000000', 'consum', 0.0213, 'lps'),
	(428135, 124, '2015-03-01 00:15:41.000000', 'consum', 0.0230, 'lps'),
	(428136, 124, '2015-03-01 00:15:42.000000', 'consum', 0.0226, 'lps'),
	(428137, 124, '2015-03-01 00:15:43.000000', 'consum', 0.0228, 'lps'),
	(428138, 124, '2015-03-01 00:15:44.000000', 'consum', 0.0230, 'lps'),
	(428139, 124, '2015-03-01 00:15:45.000000', 'consum', 0.0228, 'lps'),
	(428140, 124, '2015-03-01 00:15:46.000000', 'consum', 0.0217, 'lps'),
	(428141, 124, '2015-03-01 00:15:47.000000', 'consum', 0.0217, 'lps'),
	(428142, 124, '2015-03-01 00:15:48.000000', 'consum', 0.0226, 'lps'),
	(428143, 124, '2015-03-01 00:15:49.000000', 'consum', 0.0216, 'lps'),
	(428144, 124, '2015-03-01 00:15:50.000000', 'consum', 0.0217, 'lps'),
	(428145, 124, '2015-03-01 00:15:51.000000', 'consum', 0.0230, 'lps'),
	(428146, 124, '2015-03-01 00:15:52.000000', 'consum', 0.0235, 'lps'),
	(428147, 124, '2015-03-01 00:15:53.000000', 'consum', 0.0224, 'lps'),
	(428148, 124, '2015-03-01 00:15:54.000000', 'consum', 0.0231, 'lps'),
	(428149, 124, '2015-03-01 00:15:55.000000', 'consum', 0.0222, 'lps'),
	(428150, 124, '2015-03-01 00:15:56.000000', 'consum', 0.0235, 'lps'),
	(428151, 124, '2015-03-01 00:15:57.000000', 'consum', 0.0221, 'lps'),
	(428152, 124, '2015-03-01 00:15:58.000000', 'consum', 0.0218, 'lps'),
	(428153, 124, '2015-03-01 00:15:59.000000', 'consum', 0.0215, 'lps'),
	(428154, 124, '2015-03-01 00:16:00.000000', 'consum', 0.0211, 'lps'),
	(428155, 124, '2015-03-01 00:16:01.000000', 'consum', 0.0226, 'lps'),
	(428156, 124, '2015-03-01 00:16:02.000000', 'consum', 0.0211, 'lps'),
	(428157, 124, '2015-03-01 00:16:03.000000', 'consum', 0.0217, 'lps'),
	(428158, 124, '2015-03-01 00:16:04.000000', 'consum', 0.0219, 'lps'),
	(428159, 124, '2015-03-01 00:16:05.000000', 'consum', 0.0235, 'lps'),
	(428160, 124, '2015-03-01 00:16:06.000000', 'consum', 0.0229, 'lps'),
	(428161, 124, '2015-03-01 00:16:07.000000', 'consum', 0.0232, 'lps'),
	(428162, 124, '2015-03-01 00:16:08.000000', 'consum', 0.0210, 'lps'),
	(428163, 124, '2015-03-01 00:16:09.000000', 'consum', 0.0224, 'lps'),
	(428164, 124, '2015-03-01 00:16:10.000000', 'consum', 0.0227, 'lps'),
	(428165, 124, '2015-03-01 00:16:11.000000', 'consum', 0.0227, 'lps'),
	(428166, 124, '2015-03-01 00:16:12.000000', 'consum', 0.0221, 'lps'),
	(428167, 124, '2015-03-01 00:16:13.000000', 'consum', 0.0213, 'lps'),
	(428168, 124, '2015-03-01 00:16:14.000000', 'consum', 0.0217, 'lps'),
	(428169, 124, '2015-03-01 00:16:15.000000', 'consum', 0.0211, 'lps'),
	(428170, 124, '2015-03-01 00:16:16.000000', 'consum', 0.0220, 'lps'),
	(428171, 124, '2015-03-01 00:16:17.000000', 'consum', 0.0233, 'lps'),
	(428172, 124, '2015-03-01 00:16:18.000000', 'consum', 0.0216, 'lps'),
	(428173, 124, '2015-03-01 00:16:19.000000', 'consum', 0.0222, 'lps'),
	(428174, 124, '2015-03-01 00:16:20.000000', 'consum', 0.0229, 'lps'),
	(428175, 124, '2015-03-01 00:16:21.000000', 'consum', 0.0216, 'lps'),
	(428176, 124, '2015-03-01 00:16:22.000000', 'consum', 0.0234, 'lps'),
	(428177, 124, '2015-03-01 00:16:23.000000', 'consum', 0.0211, 'lps'),
	(428178, 124, '2015-03-01 00:16:24.000000', 'consum', 0.0221, 'lps'),
	(428179, 124, '2015-03-01 00:16:25.000000', 'consum', 0.0234, 'lps'),
	(428180, 124, '2015-03-01 00:16:26.000000', 'consum', 0.0223, 'lps'),
	(428181, 124, '2015-03-01 00:16:27.000000', 'consum', 0.0228, 'lps'),
	(428182, 124, '2015-03-01 00:16:28.000000', 'consum', 0.0210, 'lps'),
	(428183, 124, '2015-03-01 00:16:29.000000', 'consum', 0.0235, 'lps'),
	(428184, 124, '2015-03-01 00:16:30.000000', 'consum', 0.0231, 'lps'),
	(428185, 124, '2015-03-01 00:16:31.000000', 'consum', 0.0215, 'lps'),
	(428186, 124, '2015-03-01 00:16:32.000000', 'consum', 0.0223, 'lps'),
	(428187, 124, '2015-03-01 00:16:33.000000', 'consum', 0.0210, 'lps'),
	(428188, 124, '2015-03-01 00:16:34.000000', 'consum', 0.0223, 'lps'),
	(428189, 124, '2015-03-01 00:16:35.000000', 'consum', 0.0225, 'lps'),
	(428190, 124, '2015-03-01 00:16:36.000000', 'consum', 0.0220, 'lps'),
	(428191, 124, '2015-03-01 00:16:37.000000', 'consum', 0.0216, 'lps'),
	(428192, 124, '2015-03-01 00:16:38.000000', 'consum', 0.0210, 'lps'),
	(428193, 124, '2015-03-01 00:16:39.000000', 'consum', 0.0220, 'lps'),
	(428194, 124, '2015-03-01 00:16:40.000000', 'consum', 0.0232, 'lps'),
	(428195, 124, '2015-03-01 00:16:41.000000', 'consum', 0.0213, 'lps'),
	(428196, 124, '2015-03-01 00:16:42.000000', 'consum', 0.0211, 'lps'),
	(428197, 124, '2015-03-01 00:16:43.000000', 'consum', 0.0232, 'lps'),
	(428198, 124, '2015-03-01 00:16:44.000000', 'consum', 0.0215, 'lps'),
	(428199, 124, '2015-03-01 00:16:45.000000', 'consum', 0.0221, 'lps'),
	(428200, 124, '2015-03-01 00:16:46.000000', 'consum', 0.0223, 'lps'),
	(428201, 124, '2015-03-01 00:16:47.000000', 'consum', 0.0218, 'lps'),
	(428202, 124, '2015-03-01 00:16:48.000000', 'consum', 0.0213, 'lps'),
	(428203, 124, '2015-03-01 00:16:49.000000', 'consum', 0.0227, 'lps'),
	(428204, 124, '2015-03-01 00:16:50.000000', 'consum', 0.0232, 'lps'),
	(428205, 124, '2015-03-01 00:16:51.000000', 'consum', 0.0219, 'lps'),
	(428206, 124, '2015-03-01 00:16:52.000000', 'consum', 0.0213, 'lps'),
	(428207, 124, '2015-03-01 00:16:53.000000', 'consum', 0.0228, 'lps'),
	(428208, 124, '2015-03-01 00:16:54.000000', 'consum', 0.0212, 'lps'),
	(428209, 124, '2015-03-01 00:16:55.000000', 'consum', 0.0221, 'lps'),
	(428210, 124, '2015-03-01 00:16:56.000000', 'consum', 0.0231, 'lps'),
	(428211, 124, '2015-03-01 00:16:57.000000', 'consum', 0.0230, 'lps'),
	(428212, 124, '2015-03-01 00:16:58.000000', 'consum', 0.0223, 'lps'),
	(428213, 124, '2015-03-01 00:16:59.000000', 'consum', 0.0216, 'lps'),
	(428214, 124, '2015-03-01 00:17:00.000000', 'consum', 0.0228, 'lps'),
	(428215, 124, '2015-03-01 00:17:01.000000', 'consum', 0.0229, 'lps'),
	(428216, 124, '2015-03-01 00:17:02.000000', 'consum', 0.0227, 'lps'),
	(428217, 124, '2015-03-01 00:17:03.000000', 'consum', 0.0213, 'lps'),
	(428218, 124, '2015-03-01 00:17:04.000000', 'consum', 0.0227, 'lps'),
	(428219, 124, '2015-03-01 00:17:05.000000', 'consum', 0.0232, 'lps'),
	(428220, 124, '2015-03-01 00:17:06.000000', 'consum', 0.0217, 'lps'),
	(428221, 124, '2015-03-01 00:17:07.000000', 'consum', 0.0232, 'lps'),
	(428222, 124, '2015-03-01 00:17:08.000000', 'consum', 0.0224, 'lps'),
	(428223, 124, '2015-03-01 00:17:09.000000', 'consum', 0.0212, 'lps'),
	(428224, 124, '2015-03-01 00:17:10.000000', 'consum', 0.0231, 'lps'),
	(428225, 124, '2015-03-01 00:17:11.000000', 'consum', 0.0234, 'lps'),
	(428226, 124, '2015-03-01 00:17:12.000000', 'consum', 0.0213, 'lps'),
	(428227, 124, '2015-03-01 00:17:13.000000', 'consum', 0.0231, 'lps'),
	(428228, 124, '2015-03-01 00:17:14.000000', 'consum', 0.0228, 'lps'),
	(428229, 124, '2015-03-01 00:17:15.000000', 'consum', 0.0212, 'lps'),
	(428230, 124, '2015-03-01 00:17:16.000000', 'consum', 0.0217, 'lps'),
	(428231, 124, '2015-03-01 00:17:17.000000', 'consum', 0.0215, 'lps'),
	(428232, 124, '2015-03-01 00:17:18.000000', 'consum', 0.0215, 'lps'),
	(428233, 124, '2015-03-01 00:17:19.000000', 'consum', 0.0219, 'lps'),
	(428234, 124, '2015-03-01 00:17:20.000000', 'consum', 0.0217, 'lps'),
	(428235, 124, '2015-03-01 00:17:21.000000', 'consum', 0.0217, 'lps'),
	(428236, 124, '2015-03-01 00:17:22.000000', 'consum', 0.0226, 'lps'),
	(428237, 124, '2015-03-01 00:17:23.000000', 'consum', 0.0218, 'lps'),
	(428238, 124, '2015-03-01 00:17:24.000000', 'consum', 0.0226, 'lps'),
	(428239, 124, '2015-03-01 00:17:25.000000', 'consum', 0.0217, 'lps'),
	(428240, 124, '2015-03-01 00:17:26.000000', 'consum', 0.0223, 'lps'),
	(428241, 124, '2015-03-01 00:17:27.000000', 'consum', 0.0226, 'lps'),
	(428242, 124, '2015-03-01 00:17:28.000000', 'consum', 0.0227, 'lps'),
	(428243, 124, '2015-03-01 00:17:29.000000', 'consum', 0.0223, 'lps'),
	(428244, 124, '2015-03-01 00:17:30.000000', 'consum', 0.0225, 'lps'),
	(428245, 124, '2015-03-01 00:17:31.000000', 'consum', 0.0221, 'lps'),
	(428246, 124, '2015-03-01 00:17:32.000000', 'consum', 0.0219, 'lps'),
	(428247, 124, '2015-03-01 00:17:33.000000', 'consum', 0.0224, 'lps'),
	(428248, 124, '2015-03-01 00:17:34.000000', 'consum', 0.0226, 'lps'),
	(428249, 124, '2015-03-01 00:17:35.000000', 'consum', 0.0221, 'lps'),
	(428250, 124, '2015-03-01 00:17:36.000000', 'consum', 0.0220, 'lps'),
	(428251, 124, '2015-03-01 00:17:37.000000', 'consum', 0.0226, 'lps'),
	(428252, 124, '2015-03-01 00:17:38.000000', 'consum', 0.0235, 'lps'),
	(428253, 124, '2015-03-01 00:17:39.000000', 'consum', 0.0210, 'lps'),
	(428254, 124, '2015-03-01 00:17:40.000000', 'consum', 0.0212, 'lps'),
	(428255, 124, '2015-03-01 00:17:41.000000', 'consum', 0.0222, 'lps'),
	(428256, 124, '2015-03-01 00:17:42.000000', 'consum', 0.0214, 'lps'),
	(428257, 124, '2015-03-01 00:17:43.000000', 'consum', 0.0220, 'lps'),
	(428258, 124, '2015-03-01 00:17:44.000000', 'consum', 0.0221, 'lps'),
	(428259, 124, '2015-03-01 00:17:45.000000', 'consum', 0.0235, 'lps'),
	(428260, 124, '2015-03-01 00:17:46.000000', 'consum', 0.0226, 'lps'),
	(428261, 124, '2015-03-01 00:17:47.000000', 'consum', 0.0214, 'lps'),
	(428262, 124, '2015-03-01 00:17:48.000000', 'consum', 0.0211, 'lps'),
	(428263, 124, '2015-03-01 00:17:49.000000', 'consum', 0.0229, 'lps'),
	(428264, 124, '2015-03-01 00:17:50.000000', 'consum', 0.0225, 'lps'),
	(428265, 124, '2015-03-01 00:17:51.000000', 'consum', 0.0227, 'lps'),
	(428266, 124, '2015-03-01 00:17:52.000000', 'consum', 0.0227, 'lps'),
	(428267, 124, '2015-03-01 00:17:53.000000', 'consum', 0.0217, 'lps'),
	(428268, 124, '2015-03-01 00:17:54.000000', 'consum', 0.0220, 'lps'),
	(428269, 124, '2015-03-01 00:17:55.000000', 'consum', 0.0215, 'lps'),
	(428270, 124, '2015-03-01 00:17:56.000000', 'consum', 0.0233, 'lps'),
	(428271, 124, '2015-03-01 00:17:57.000000', 'consum', 0.0229, 'lps'),
	(428272, 124, '2015-03-01 00:17:58.000000', 'consum', 0.0212, 'lps'),
	(428273, 124, '2015-03-01 00:17:59.000000', 'consum', 0.0217, 'lps'),
	(428274, 124, '2015-03-01 00:18:00.000000', 'consum', 0.0211, 'lps'),
	(428275, 124, '2015-03-01 00:18:01.000000', 'consum', 0.0222, 'lps'),
	(428276, 124, '2015-03-01 00:18:02.000000', 'consum', 0.0215, 'lps'),
	(428277, 124, '2015-03-01 00:18:03.000000', 'consum', 0.0225, 'lps'),
	(428278, 124, '2015-03-01 00:18:04.000000', 'consum', 0.0221, 'lps'),
	(428279, 124, '2015-03-01 00:18:05.000000', 'consum', 0.0219, 'lps'),
	(428280, 124, '2015-03-01 00:18:06.000000', 'consum', 0.0222, 'lps'),
	(428281, 124, '2015-03-01 00:18:07.000000', 'consum', 0.0217, 'lps'),
	(428282, 124, '2015-03-01 00:18:08.000000', 'consum', 0.0235, 'lps'),
	(428283, 124, '2015-03-01 00:18:09.000000', 'consum', 0.0213, 'lps'),
	(428284, 124, '2015-03-01 00:18:10.000000', 'consum', 0.0226, 'lps'),
	(428285, 124, '2015-03-01 00:18:11.000000', 'consum', 0.0230, 'lps'),
	(428286, 124, '2015-03-01 00:18:12.000000', 'consum', 0.0212, 'lps'),
	(428287, 124, '2015-03-01 00:18:13.000000', 'consum', 0.0212, 'lps'),
	(428288, 124, '2015-03-01 00:18:14.000000', 'consum', 0.0213, 'lps'),
	(428289, 124, '2015-03-01 00:18:15.000000', 'consum', 0.0221, 'lps'),
	(428290, 124, '2015-03-01 00:18:16.000000', 'consum', 0.0231, 'lps'),
	(428291, 124, '2015-03-01 00:18:17.000000', 'consum', 0.0231, 'lps'),
	(428292, 124, '2015-03-01 00:18:18.000000', 'consum', 0.0227, 'lps'),
	(428293, 124, '2015-03-01 00:18:19.000000', 'consum', 0.0232, 'lps'),
	(428294, 124, '2015-03-01 00:18:20.000000', 'consum', 0.0216, 'lps'),
	(428295, 124, '2015-03-01 00:18:21.000000', 'consum', 0.0228, 'lps'),
	(428296, 124, '2015-03-01 00:18:22.000000', 'consum', 0.0229, 'lps'),
	(428297, 124, '2015-03-01 00:18:23.000000', 'consum', 0.0228, 'lps'),
	(428298, 124, '2015-03-01 00:18:24.000000', 'consum', 0.0217, 'lps'),
	(428299, 124, '2015-03-01 00:18:25.000000', 'consum', 0.0217, 'lps'),
	(428300, 124, '2015-03-01 00:18:26.000000', 'consum', 0.0224, 'lps'),
	(428301, 124, '2015-03-01 00:18:27.000000', 'consum', 0.0235, 'lps'),
	(428302, 124, '2015-03-01 00:18:28.000000', 'consum', 0.0216, 'lps'),
	(428303, 124, '2015-03-01 00:18:29.000000', 'consum', 0.0215, 'lps'),
	(428304, 124, '2015-03-01 00:18:30.000000', 'consum', 0.0217, 'lps'),
	(428305, 124, '2015-03-01 00:18:31.000000', 'consum', 0.0232, 'lps'),
	(428306, 124, '2015-03-01 00:18:32.000000', 'consum', 0.0221, 'lps'),
	(428307, 124, '2015-03-01 00:18:33.000000', 'consum', 0.0228, 'lps'),
	(428308, 124, '2015-03-01 00:18:34.000000', 'consum', 0.0213, 'lps'),
	(428309, 124, '2015-03-01 00:18:35.000000', 'consum', 0.0223, 'lps'),
	(428310, 124, '2015-03-01 00:18:36.000000', 'consum', 0.0216, 'lps'),
	(428311, 124, '2015-03-01 00:18:37.000000', 'consum', 0.0226, 'lps'),
	(428312, 124, '2015-03-01 00:18:38.000000', 'consum', 0.0221, 'lps'),
	(428313, 124, '2015-03-01 00:18:39.000000', 'consum', 0.0218, 'lps'),
	(428314, 124, '2015-03-01 00:18:40.000000', 'consum', 0.0217, 'lps'),
	(428315, 124, '2015-03-01 00:18:41.000000', 'consum', 0.0224, 'lps'),
	(428316, 124, '2015-03-01 00:18:42.000000', 'consum', 0.0230, 'lps'),
	(428317, 124, '2015-03-01 00:18:43.000000', 'consum', 0.0219, 'lps'),
	(428318, 124, '2015-03-01 00:18:44.000000', 'consum', 0.0219, 'lps'),
	(428319, 124, '2015-03-01 00:18:45.000000', 'consum', 0.0228, 'lps'),
	(428320, 124, '2015-03-01 00:18:46.000000', 'consum', 0.0223, 'lps'),
	(428321, 124, '2015-03-01 00:18:47.000000', 'consum', 0.0222, 'lps'),
	(428322, 124, '2015-03-01 00:18:48.000000', 'consum', 0.0232, 'lps'),
	(428323, 124, '2015-03-01 00:18:49.000000', 'consum', 0.0234, 'lps'),
	(428324, 124, '2015-03-01 00:18:50.000000', 'consum', 0.0235, 'lps'),
	(428325, 124, '2015-03-01 00:18:51.000000', 'consum', 0.0214, 'lps'),
	(428326, 124, '2015-03-01 00:18:52.000000', 'consum', 0.0232, 'lps'),
	(428327, 124, '2015-03-01 00:18:53.000000', 'consum', 0.0230, 'lps'),
	(428328, 124, '2015-03-01 00:18:54.000000', 'consum', 0.0220, 'lps'),
	(428329, 124, '2015-03-01 00:18:55.000000', 'consum', 0.0227, 'lps'),
	(428330, 124, '2015-03-01 00:18:56.000000', 'consum', 0.0215, 'lps'),
	(428331, 124, '2015-03-01 00:18:57.000000', 'consum', 0.0234, 'lps'),
	(428332, 124, '2015-03-01 00:18:58.000000', 'consum', 0.0213, 'lps'),
	(428333, 124, '2015-03-01 00:18:59.000000', 'consum', 0.0231, 'lps'),
	(428334, 124, '2015-03-01 00:19:00.000000', 'consum', 0.0230, 'lps'),
	(428335, 124, '2015-03-01 00:19:01.000000', 'consum', 0.0221, 'lps'),
	(428336, 124, '2015-03-01 00:19:02.000000', 'consum', 0.0232, 'lps'),
	(428337, 124, '2015-03-01 00:19:03.000000', 'consum', 0.0233, 'lps'),
	(428338, 124, '2015-03-01 00:19:04.000000', 'consum', 0.0210, 'lps'),
	(428339, 124, '2015-03-01 00:19:05.000000', 'consum', 0.0219, 'lps'),
	(428340, 124, '2015-03-01 00:19:06.000000', 'consum', 0.0230, 'lps'),
	(428341, 124, '2015-03-01 00:19:07.000000', 'consum', 0.0233, 'lps'),
	(428342, 124, '2015-03-01 00:19:08.000000', 'consum', 0.0212, 'lps'),
	(428343, 124, '2015-03-01 00:19:09.000000', 'consum', 0.0231, 'lps'),
	(428344, 124, '2015-03-01 00:19:10.000000', 'consum', 0.0231, 'lps'),
	(428345, 124, '2015-03-01 00:19:11.000000', 'consum', 0.0226, 'lps'),
	(428346, 124, '2015-03-01 00:19:12.000000', 'consum', 0.0229, 'lps'),
	(428347, 124, '2015-03-01 00:19:13.000000', 'consum', 0.0231, 'lps'),
	(428348, 124, '2015-03-01 00:19:14.000000', 'consum', 0.0233, 'lps'),
	(428349, 124, '2015-03-01 00:19:15.000000', 'consum', 0.0234, 'lps'),
	(428350, 124, '2015-03-01 00:19:16.000000', 'consum', 0.0211, 'lps'),
	(428351, 124, '2015-03-01 00:19:17.000000', 'consum', 0.0220, 'lps'),
	(428352, 124, '2015-03-01 00:19:18.000000', 'consum', 0.0231, 'lps'),
	(428353, 124, '2015-03-01 00:19:19.000000', 'consum', 0.0210, 'lps'),
	(428354, 124, '2015-03-01 00:19:20.000000', 'consum', 0.0225, 'lps'),
	(428355, 124, '2015-03-01 00:19:21.000000', 'consum', 0.0233, 'lps'),
	(428356, 124, '2015-03-01 00:19:22.000000', 'consum', 0.0228, 'lps'),
	(428357, 124, '2015-03-01 00:19:23.000000', 'consum', 0.0234, 'lps'),
	(428358, 124, '2015-03-01 00:19:24.000000', 'consum', 0.0223, 'lps'),
	(428359, 124, '2015-03-01 00:19:25.000000', 'consum', 0.0230, 'lps'),
	(428360, 124, '2015-03-01 00:19:26.000000', 'consum', 0.0219, 'lps'),
	(428361, 124, '2015-03-01 00:19:27.000000', 'consum', 0.0220, 'lps'),
	(428362, 124, '2015-03-01 00:19:28.000000', 'consum', 0.0234, 'lps'),
	(428363, 124, '2015-03-01 00:19:29.000000', 'consum', 0.0223, 'lps'),
	(428364, 124, '2015-03-01 00:19:30.000000', 'consum', 0.0230, 'lps'),
	(428365, 124, '2015-03-01 00:19:31.000000', 'consum', 0.0219, 'lps'),
	(428366, 124, '2015-03-01 00:19:32.000000', 'consum', 0.0223, 'lps'),
	(428367, 124, '2015-03-01 00:19:33.000000', 'consum', 0.0222, 'lps'),
	(428368, 124, '2015-03-01 00:19:34.000000', 'consum', 0.0233, 'lps'),
	(428369, 124, '2015-03-01 00:19:35.000000', 'consum', 0.0211, 'lps'),
	(428370, 124, '2015-03-01 00:19:36.000000', 'consum', 0.0225, 'lps'),
	(428371, 124, '2015-03-01 00:19:37.000000', 'consum', 0.0229, 'lps'),
	(428372, 124, '2015-03-01 00:19:38.000000', 'consum', 0.0210, 'lps'),
	(428373, 124, '2015-03-01 00:19:39.000000', 'consum', 0.0232, 'lps'),
	(428374, 124, '2015-03-01 00:19:40.000000', 'consum', 0.0216, 'lps'),
	(428375, 124, '2015-03-01 00:19:41.000000', 'consum', 0.0226, 'lps'),
	(428376, 124, '2015-03-01 00:19:42.000000', 'consum', 0.0219, 'lps'),
	(428377, 124, '2015-03-01 00:19:43.000000', 'consum', 0.0210, 'lps'),
	(428378, 124, '2015-03-01 00:19:44.000000', 'consum', 0.0210, 'lps'),
	(428379, 124, '2015-03-01 00:19:45.000000', 'consum', 0.0235, 'lps'),
	(428380, 124, '2015-03-01 00:19:46.000000', 'consum', 0.0230, 'lps'),
	(428381, 124, '2015-03-01 00:19:47.000000', 'consum', 0.0211, 'lps'),
	(428382, 124, '2015-03-01 00:19:48.000000', 'consum', 0.0235, 'lps'),
	(428383, 124, '2015-03-01 00:19:49.000000', 'consum', 0.0229, 'lps'),
	(428384, 124, '2015-03-01 00:19:50.000000', 'consum', 0.0231, 'lps'),
	(428385, 124, '2015-03-01 00:19:51.000000', 'consum', 0.0229, 'lps'),
	(428386, 124, '2015-03-01 00:19:52.000000', 'consum', 0.0219, 'lps'),
	(428387, 124, '2015-03-01 00:19:53.000000', 'consum', 0.0226, 'lps'),
	(428388, 124, '2015-03-01 00:19:54.000000', 'consum', 0.0235, 'lps'),
	(428389, 124, '2015-03-01 00:19:55.000000', 'consum', 0.0235, 'lps'),
	(428390, 124, '2015-03-01 00:19:56.000000', 'consum', 0.0210, 'lps'),
	(428391, 124, '2015-03-01 00:19:57.000000', 'consum', 0.0213, 'lps'),
	(428392, 124, '2015-03-01 00:19:58.000000', 'consum', 0.0226, 'lps'),
	(428393, 124, '2015-03-01 00:19:59.000000', 'consum', 0.0231, 'lps'),
	(428394, 124, '2015-03-01 00:20:00.000000', 'consum', 0.0214, 'lps'),
	(428395, 124, '2015-03-01 00:20:01.000000', 'consum', 0.0218, 'lps'),
	(428396, 124, '2015-03-01 00:20:02.000000', 'consum', 0.0214, 'lps'),
	(428397, 124, '2015-03-01 00:20:03.000000', 'consum', 0.0233, 'lps'),
	(428398, 124, '2015-03-01 00:20:04.000000', 'consum', 0.0235, 'lps'),
	(428399, 124, '2015-03-01 00:20:05.000000', 'consum', 0.0213, 'lps'),
	(428400, 124, '2015-03-01 00:20:06.000000', 'consum', 0.0228, 'lps'),
	(428401, 124, '2015-03-01 00:20:07.000000', 'consum', 0.0213, 'lps'),
	(428402, 124, '2015-03-01 00:20:08.000000', 'consum', 0.0225, 'lps'),
	(428403, 124, '2015-03-01 00:20:09.000000', 'consum', 0.0223, 'lps'),
	(428404, 124, '2015-03-01 00:20:10.000000', 'consum', 0.0233, 'lps'),
	(428405, 124, '2015-03-01 00:20:11.000000', 'consum', 0.0235, 'lps'),
	(428406, 124, '2015-03-01 00:20:12.000000', 'consum', 0.0212, 'lps'),
	(428407, 124, '2015-03-01 00:20:13.000000', 'consum', 0.0226, 'lps'),
	(428408, 124, '2015-03-01 00:20:14.000000', 'consum', 0.0233, 'lps'),
	(428409, 124, '2015-03-01 00:20:15.000000', 'consum', 0.0222, 'lps'),
	(428410, 124, '2015-03-01 00:20:16.000000', 'consum', 0.0231, 'lps'),
	(428411, 124, '2015-03-01 00:20:17.000000', 'consum', 0.0226, 'lps'),
	(428412, 124, '2015-03-01 00:20:18.000000', 'consum', 0.0226, 'lps'),
	(428413, 124, '2015-03-01 00:20:19.000000', 'consum', 0.0217, 'lps'),
	(428414, 124, '2015-03-01 00:20:20.000000', 'consum', 0.0223, 'lps'),
	(428415, 124, '2015-03-01 00:20:21.000000', 'consum', 0.0227, 'lps'),
	(428416, 124, '2015-03-01 00:20:22.000000', 'consum', 0.0232, 'lps'),
	(428417, 124, '2015-03-01 00:20:23.000000', 'consum', 0.0219, 'lps'),
	(428418, 124, '2015-03-01 00:20:24.000000', 'consum', 0.0213, 'lps'),
	(428419, 124, '2015-03-01 00:20:25.000000', 'consum', 0.0225, 'lps'),
	(428420, 124, '2015-03-01 00:20:26.000000', 'consum', 0.0227, 'lps'),
	(428421, 124, '2015-03-01 00:20:27.000000', 'consum', 0.0222, 'lps'),
	(428422, 124, '2015-03-01 00:20:28.000000', 'consum', 0.0219, 'lps'),
	(428423, 124, '2015-03-01 00:20:29.000000', 'consum', 0.0220, 'lps'),
	(428424, 124, '2015-03-01 00:20:30.000000', 'consum', 0.0235, 'lps'),
	(428425, 124, '2015-03-01 00:20:31.000000', 'consum', 0.0227, 'lps'),
	(428426, 124, '2015-03-01 00:20:32.000000', 'consum', 0.0222, 'lps'),
	(428427, 124, '2015-03-01 00:20:33.000000', 'consum', 0.0216, 'lps'),
	(428428, 124, '2015-03-01 00:20:34.000000', 'consum', 0.0234, 'lps'),
	(428429, 124, '2015-03-01 00:20:35.000000', 'consum', 0.0234, 'lps'),
	(428430, 124, '2015-03-01 00:20:36.000000', 'consum', 0.0232, 'lps'),
	(428431, 124, '2015-03-01 00:20:37.000000', 'consum', 0.0222, 'lps'),
	(428432, 124, '2015-03-01 00:20:38.000000', 'consum', 0.0233, 'lps'),
	(428433, 124, '2015-03-01 00:20:39.000000', 'consum', 0.0235, 'lps'),
	(428434, 124, '2015-03-01 00:20:40.000000', 'consum', 0.0217, 'lps'),
	(428435, 124, '2015-03-01 00:20:41.000000', 'consum', 0.0222, 'lps'),
	(428436, 124, '2015-03-01 00:20:42.000000', 'consum', 0.0221, 'lps'),
	(428437, 124, '2015-03-01 00:20:43.000000', 'consum', 0.0232, 'lps'),
	(428438, 124, '2015-03-01 00:20:44.000000', 'consum', 0.0210, 'lps'),
	(428439, 124, '2015-03-01 00:20:45.000000', 'consum', 0.0221, 'lps'),
	(428440, 124, '2015-03-01 00:20:46.000000', 'consum', 0.0216, 'lps'),
	(428441, 124, '2015-03-01 00:20:47.000000', 'consum', 0.0230, 'lps'),
	(428442, 124, '2015-03-01 00:20:48.000000', 'consum', 0.0218, 'lps'),
	(428443, 124, '2015-03-01 00:20:49.000000', 'consum', 0.0214, 'lps'),
	(428444, 124, '2015-03-01 00:20:50.000000', 'consum', 0.0233, 'lps'),
	(428445, 124, '2015-03-01 00:20:51.000000', 'consum', 0.0212, 'lps'),
	(428446, 124, '2015-03-01 00:20:52.000000', 'consum', 0.0226, 'lps'),
	(428447, 124, '2015-03-01 00:20:53.000000', 'consum', 0.0235, 'lps'),
	(428448, 124, '2015-03-01 00:20:54.000000', 'consum', 0.0211, 'lps'),
	(428449, 124, '2015-03-01 00:20:55.000000', 'consum', 0.0215, 'lps'),
	(428450, 124, '2015-03-01 00:20:56.000000', 'consum', 0.0234, 'lps'),
	(428451, 124, '2015-03-01 00:20:57.000000', 'consum', 0.0212, 'lps'),
	(428452, 124, '2015-03-01 00:20:58.000000', 'consum', 0.0227, 'lps'),
	(428453, 124, '2015-03-01 00:20:59.000000', 'consum', 0.0211, 'lps'),
	(428454, 124, '2015-03-01 00:21:00.000000', 'consum', 0.0214, 'lps'),
	(428455, 124, '2015-03-01 00:21:01.000000', 'consum', 0.0231, 'lps'),
	(428456, 124, '2015-03-01 00:21:02.000000', 'consum', 0.0224, 'lps'),
	(428457, 124, '2015-03-01 00:21:03.000000', 'consum', 0.0218, 'lps'),
	(428458, 124, '2015-03-01 00:21:04.000000', 'consum', 0.0233, 'lps'),
	(428459, 124, '2015-03-01 00:21:05.000000', 'consum', 0.0225, 'lps'),
	(428460, 124, '2015-03-01 00:21:06.000000', 'consum', 0.0214, 'lps'),
	(428461, 124, '2015-03-01 00:21:07.000000', 'consum', 0.0214, 'lps'),
	(428462, 124, '2015-03-01 00:21:08.000000', 'consum', 0.0219, 'lps'),
	(428463, 124, '2015-03-01 00:21:09.000000', 'consum', 0.0215, 'lps'),
	(428464, 124, '2015-03-01 00:21:10.000000', 'consum', 0.0211, 'lps'),
	(428465, 124, '2015-03-01 00:21:11.000000', 'consum', 0.0227, 'lps'),
	(428466, 124, '2015-03-01 00:21:12.000000', 'consum', 0.0213, 'lps'),
	(428467, 124, '2015-03-01 00:21:13.000000', 'consum', 0.0227, 'lps'),
	(428468, 124, '2015-03-01 00:21:14.000000', 'consum', 0.0234, 'lps'),
	(428469, 124, '2015-03-01 00:21:15.000000', 'consum', 0.0229, 'lps'),
	(428470, 124, '2015-03-01 00:21:16.000000', 'consum', 0.0231, 'lps'),
	(428471, 124, '2015-03-01 00:21:17.000000', 'consum', 0.0235, 'lps'),
	(428472, 124, '2015-03-01 00:21:18.000000', 'consum', 0.0220, 'lps'),
	(428473, 124, '2015-03-01 00:21:19.000000', 'consum', 0.0211, 'lps'),
	(428474, 124, '2015-03-01 00:21:20.000000', 'consum', 0.0210, 'lps'),
	(428475, 124, '2015-03-01 00:21:21.000000', 'consum', 0.0234, 'lps'),
	(428476, 124, '2015-03-01 00:21:22.000000', 'consum', 0.0228, 'lps'),
	(428477, 124, '2015-03-01 00:21:23.000000', 'consum', 0.0228, 'lps'),
	(428478, 124, '2015-03-01 00:21:24.000000', 'consum', 0.0219, 'lps'),
	(428479, 124, '2015-03-01 00:21:25.000000', 'consum', 0.0228, 'lps'),
	(428480, 124, '2015-03-01 00:21:26.000000', 'consum', 0.0223, 'lps'),
	(428481, 124, '2015-03-01 00:21:27.000000', 'consum', 0.0220, 'lps'),
	(428482, 124, '2015-03-01 00:21:28.000000', 'consum', 0.0223, 'lps'),
	(428483, 124, '2015-03-01 00:21:29.000000', 'consum', 0.0218, 'lps'),
	(428484, 124, '2015-03-01 00:21:30.000000', 'consum', 0.0212, 'lps'),
	(428485, 124, '2015-03-01 00:21:31.000000', 'consum', 0.0224, 'lps'),
	(428486, 124, '2015-03-01 00:21:32.000000', 'consum', 0.0220, 'lps'),
	(428487, 124, '2015-03-01 00:21:33.000000', 'consum', 0.0219, 'lps'),
	(428488, 124, '2015-03-01 00:21:34.000000', 'consum', 0.0227, 'lps'),
	(428489, 124, '2015-03-01 00:21:35.000000', 'consum', 0.0215, 'lps'),
	(428490, 124, '2015-03-01 00:21:36.000000', 'consum', 0.0211, 'lps'),
	(428491, 124, '2015-03-01 00:21:37.000000', 'consum', 0.0227, 'lps'),
	(428492, 124, '2015-03-01 00:21:38.000000', 'consum', 0.0213, 'lps'),
	(428493, 124, '2015-03-01 00:21:39.000000', 'consum', 0.0229, 'lps'),
	(428494, 124, '2015-03-01 00:21:40.000000', 'consum', 0.0217, 'lps'),
	(428495, 124, '2015-03-01 00:21:41.000000', 'consum', 0.0213, 'lps'),
	(428496, 124, '2015-03-01 00:21:42.000000', 'consum', 0.0231, 'lps'),
	(428497, 124, '2015-03-01 00:21:43.000000', 'consum', 0.0229, 'lps'),
	(428498, 124, '2015-03-01 00:21:44.000000', 'consum', 0.0217, 'lps'),
	(428499, 124, '2015-03-01 00:21:45.000000', 'consum', 0.0216, 'lps'),
	(428500, 124, '2015-03-01 00:21:46.000000', 'consum', 0.0219, 'lps'),
	(428501, 124, '2015-03-01 00:21:47.000000', 'consum', 0.0211, 'lps'),
	(428502, 124, '2015-03-01 00:21:48.000000', 'consum', 0.0217, 'lps'),
	(428503, 124, '2015-03-01 00:21:49.000000', 'consum', 0.0213, 'lps'),
	(428504, 124, '2015-03-01 00:21:50.000000', 'consum', 0.0231, 'lps'),
	(428505, 124, '2015-03-01 00:21:51.000000', 'consum', 0.0231, 'lps'),
	(428506, 124, '2015-03-01 00:21:52.000000', 'consum', 0.0225, 'lps'),
	(428507, 124, '2015-03-01 00:21:53.000000', 'consum', 0.0221, 'lps'),
	(428508, 124, '2015-03-01 00:21:54.000000', 'consum', 0.0220, 'lps'),
	(428509, 124, '2015-03-01 00:21:55.000000', 'consum', 0.0227, 'lps'),
	(428510, 124, '2015-03-01 00:21:56.000000', 'consum', 0.0216, 'lps'),
	(428511, 124, '2015-03-01 00:21:57.000000', 'consum', 0.0214, 'lps'),
	(428512, 124, '2015-03-01 00:21:58.000000', 'consum', 0.0213, 'lps'),
	(428513, 124, '2015-03-01 00:21:59.000000', 'consum', 0.0214, 'lps'),
	(428514, 124, '2015-03-01 00:22:00.000000', 'consum', 0.0222, 'lps'),
	(428515, 124, '2015-03-01 00:22:01.000000', 'consum', 0.0232, 'lps'),
	(428516, 124, '2015-03-01 00:22:02.000000', 'consum', 0.0234, 'lps'),
	(428517, 124, '2015-03-01 00:22:03.000000', 'consum', 0.0210, 'lps'),
	(428518, 124, '2015-03-01 00:22:04.000000', 'consum', 0.0217, 'lps'),
	(428519, 124, '2015-03-01 00:22:05.000000', 'consum', 0.0219, 'lps'),
	(428520, 124, '2015-03-01 00:22:06.000000', 'consum', 0.0210, 'lps'),
	(428521, 124, '2015-03-01 00:22:07.000000', 'consum', 0.0233, 'lps'),
	(428522, 124, '2015-03-01 00:22:08.000000', 'consum', 0.0223, 'lps'),
	(428523, 124, '2015-03-01 00:22:09.000000', 'consum', 0.0232, 'lps'),
	(428524, 124, '2015-03-01 00:22:10.000000', 'consum', 0.0232, 'lps'),
	(428525, 124, '2015-03-01 00:22:11.000000', 'consum', 0.0225, 'lps'),
	(428526, 124, '2015-03-01 00:22:12.000000', 'consum', 0.0222, 'lps'),
	(428527, 124, '2015-03-01 00:22:13.000000', 'consum', 0.0225, 'lps'),
	(428528, 124, '2015-03-01 00:22:14.000000', 'consum', 0.0225, 'lps'),
	(428529, 124, '2015-03-01 00:22:15.000000', 'consum', 0.0211, 'lps'),
	(428530, 124, '2015-03-01 00:22:16.000000', 'consum', 0.0226, 'lps'),
	(428531, 124, '2015-03-01 00:22:17.000000', 'consum', 0.0232, 'lps'),
	(428532, 124, '2015-03-01 00:22:18.000000', 'consum', 0.0223, 'lps'),
	(428533, 124, '2015-03-01 00:22:19.000000', 'consum', 0.0210, 'lps'),
	(428534, 124, '2015-03-01 00:22:20.000000', 'consum', 0.0223, 'lps'),
	(428535, 124, '2015-03-01 00:22:21.000000', 'consum', 0.0221, 'lps'),
	(428536, 124, '2015-03-01 00:22:22.000000', 'consum', 0.0229, 'lps'),
	(428537, 124, '2015-03-01 00:22:23.000000', 'consum', 0.0220, 'lps'),
	(428538, 124, '2015-03-01 00:22:24.000000', 'consum', 0.0231, 'lps'),
	(428539, 124, '2015-03-01 00:22:25.000000', 'consum', 0.0234, 'lps'),
	(428540, 124, '2015-03-01 00:22:26.000000', 'consum', 0.0216, 'lps'),
	(428541, 124, '2015-03-01 00:22:27.000000', 'consum', 0.0218, 'lps'),
	(428542, 124, '2015-03-01 00:22:28.000000', 'consum', 0.0233, 'lps'),
	(428543, 124, '2015-03-01 00:22:29.000000', 'consum', 0.0225, 'lps'),
	(428544, 124, '2015-03-01 00:22:30.000000', 'consum', 0.0215, 'lps'),
	(428545, 124, '2015-03-01 00:22:31.000000', 'consum', 0.0217, 'lps'),
	(428546, 124, '2015-03-01 00:22:32.000000', 'consum', 0.0232, 'lps'),
	(428547, 124, '2015-03-01 00:22:33.000000', 'consum', 0.0221, 'lps'),
	(428548, 124, '2015-03-01 00:22:34.000000', 'consum', 0.0226, 'lps'),
	(428549, 124, '2015-03-01 00:22:35.000000', 'consum', 0.0231, 'lps'),
	(428550, 124, '2015-03-01 00:22:36.000000', 'consum', 0.0214, 'lps'),
	(428551, 124, '2015-03-01 00:22:37.000000', 'consum', 0.0222, 'lps'),
	(428552, 124, '2015-03-01 00:22:38.000000', 'consum', 0.0231, 'lps'),
	(428553, 124, '2015-03-01 00:22:39.000000', 'consum', 0.0228, 'lps'),
	(428554, 124, '2015-03-01 00:22:40.000000', 'consum', 0.0210, 'lps'),
	(428555, 124, '2015-03-01 00:22:41.000000', 'consum', 0.0234, 'lps'),
	(428556, 124, '2015-03-01 00:22:42.000000', 'consum', 0.0226, 'lps'),
	(428557, 124, '2015-03-01 00:22:43.000000', 'consum', 0.0220, 'lps'),
	(428558, 124, '2015-03-01 00:22:44.000000', 'consum', 0.0211, 'lps'),
	(428559, 124, '2015-03-01 00:22:45.000000', 'consum', 0.0212, 'lps'),
	(428560, 124, '2015-03-01 00:22:46.000000', 'consum', 0.0218, 'lps'),
	(428561, 124, '2015-03-01 00:22:47.000000', 'consum', 0.0218, 'lps'),
	(428562, 124, '2015-03-01 00:22:48.000000', 'consum', 0.0225, 'lps'),
	(428563, 124, '2015-03-01 00:22:49.000000', 'consum', 0.0235, 'lps'),
	(428564, 124, '2015-03-01 00:22:50.000000', 'consum', 0.0215, 'lps'),
	(428565, 124, '2015-03-01 00:22:51.000000', 'consum', 0.0210, 'lps'),
	(428566, 124, '2015-03-01 00:22:52.000000', 'consum', 0.0223, 'lps'),
	(428567, 124, '2015-03-01 00:22:53.000000', 'consum', 0.0222, 'lps'),
	(428568, 124, '2015-03-01 00:22:54.000000', 'consum', 0.0233, 'lps'),
	(428569, 124, '2015-03-01 00:22:55.000000', 'consum', 0.0212, 'lps'),
	(428570, 124, '2015-03-01 00:22:56.000000', 'consum', 0.0229, 'lps'),
	(428571, 124, '2015-03-01 00:22:57.000000', 'consum', 0.0222, 'lps'),
	(428572, 124, '2015-03-01 00:22:58.000000', 'consum', 0.0214, 'lps'),
	(428573, 124, '2015-03-01 00:22:59.000000', 'consum', 0.0220, 'lps'),
	(428574, 124, '2015-03-01 00:23:00.000000', 'consum', 0.0224, 'lps'),
	(428575, 124, '2015-03-01 00:23:01.000000', 'consum', 0.0222, 'lps'),
	(428576, 124, '2015-03-01 00:23:02.000000', 'consum', 0.0230, 'lps'),
	(428577, 124, '2015-03-01 00:23:03.000000', 'consum', 0.0224, 'lps'),
	(428578, 124, '2015-03-01 00:23:04.000000', 'consum', 0.0219, 'lps'),
	(428579, 124, '2015-03-01 00:23:05.000000', 'consum', 0.0213, 'lps'),
	(428580, 124, '2015-03-01 00:23:06.000000', 'consum', 0.0225, 'lps'),
	(428581, 124, '2015-03-01 00:23:07.000000', 'consum', 0.0224, 'lps'),
	(428582, 124, '2015-03-01 00:23:08.000000', 'consum', 0.0210, 'lps'),
	(428583, 124, '2015-03-01 00:23:09.000000', 'consum', 0.0218, 'lps'),
	(428584, 124, '2015-03-01 00:23:10.000000', 'consum', 0.0228, 'lps'),
	(428585, 124, '2015-03-01 00:23:11.000000', 'consum', 0.0224, 'lps'),
	(428586, 124, '2015-03-01 00:23:12.000000', 'consum', 0.0224, 'lps'),
	(428587, 124, '2015-03-01 00:23:13.000000', 'consum', 0.0213, 'lps'),
	(428588, 124, '2015-03-01 00:23:14.000000', 'consum', 0.0210, 'lps'),
	(428589, 124, '2015-03-01 00:23:15.000000', 'consum', 0.0229, 'lps'),
	(428590, 124, '2015-03-01 00:23:16.000000', 'consum', 0.0228, 'lps'),
	(428591, 124, '2015-03-01 00:23:17.000000', 'consum', 0.0216, 'lps'),
	(428592, 124, '2015-03-01 00:23:18.000000', 'consum', 0.0212, 'lps'),
	(428593, 124, '2015-03-01 00:23:19.000000', 'consum', 0.0229, 'lps'),
	(428594, 124, '2015-03-01 00:23:20.000000', 'consum', 0.0222, 'lps'),
	(428595, 124, '2015-03-01 00:23:21.000000', 'consum', 0.0212, 'lps'),
	(428596, 124, '2015-03-01 00:23:22.000000', 'consum', 0.0212, 'lps'),
	(428597, 124, '2015-03-01 00:23:23.000000', 'consum', 0.0216, 'lps'),
	(428598, 124, '2015-03-01 00:23:24.000000', 'consum', 0.0231, 'lps'),
	(428599, 124, '2015-03-01 00:23:25.000000', 'consum', 0.0223, 'lps'),
	(428600, 124, '2015-03-01 00:23:26.000000', 'consum', 0.0211, 'lps'),
	(428601, 124, '2015-03-01 00:23:27.000000', 'consum', 0.0230, 'lps'),
	(428602, 124, '2015-03-01 00:23:28.000000', 'consum', 0.0229, 'lps'),
	(428603, 124, '2015-03-01 00:23:29.000000', 'consum', 0.0220, 'lps'),
	(428604, 124, '2015-03-01 00:23:30.000000', 'consum', 0.0230, 'lps'),
	(428605, 124, '2015-03-01 00:23:31.000000', 'consum', 0.0226, 'lps'),
	(428606, 124, '2015-03-01 00:23:32.000000', 'consum', 0.0233, 'lps'),
	(428607, 124, '2015-03-01 00:23:33.000000', 'consum', 0.0224, 'lps'),
	(428608, 124, '2015-03-01 00:23:34.000000', 'consum', 0.0214, 'lps'),
	(428609, 124, '2015-03-01 00:23:35.000000', 'consum', 0.0213, 'lps'),
	(428610, 124, '2015-03-01 00:23:36.000000', 'consum', 0.0213, 'lps'),
	(428611, 124, '2015-03-01 00:23:37.000000', 'consum', 0.0217, 'lps'),
	(428612, 124, '2015-03-01 00:23:38.000000', 'consum', 0.0210, 'lps'),
	(428613, 124, '2015-03-01 00:23:39.000000', 'consum', 0.0216, 'lps'),
	(428614, 124, '2015-03-01 00:23:40.000000', 'consum', 0.0212, 'lps'),
	(428615, 124, '2015-03-01 00:23:41.000000', 'consum', 0.0232, 'lps'),
	(428616, 124, '2015-03-01 00:23:42.000000', 'consum', 0.0234, 'lps'),
	(428617, 124, '2015-03-01 00:23:43.000000', 'consum', 0.0212, 'lps'),
	(428618, 124, '2015-03-01 00:23:44.000000', 'consum', 0.0227, 'lps'),
	(428619, 124, '2015-03-01 00:23:45.000000', 'consum', 0.0212, 'lps'),
	(428620, 124, '2015-03-01 00:23:46.000000', 'consum', 0.0223, 'lps'),
	(428621, 124, '2015-03-01 00:23:47.000000', 'consum', 0.0218, 'lps'),
	(428622, 124, '2015-03-01 00:23:48.000000', 'consum', 0.0235, 'lps'),
	(428623, 124, '2015-03-01 00:23:49.000000', 'consum', 0.0234, 'lps'),
	(428624, 124, '2015-03-01 00:23:50.000000', 'consum', 0.0230, 'lps'),
	(428625, 124, '2015-03-01 00:23:51.000000', 'consum', 0.0211, 'lps'),
	(428626, 124, '2015-03-01 00:23:52.000000', 'consum', 0.0210, 'lps'),
	(428627, 124, '2015-03-01 00:23:53.000000', 'consum', 0.0233, 'lps'),
	(428628, 124, '2015-03-01 00:23:54.000000', 'consum', 0.0220, 'lps'),
	(428629, 124, '2015-03-01 00:23:55.000000', 'consum', 0.0220, 'lps'),
	(428630, 124, '2015-03-01 00:23:56.000000', 'consum', 0.0228, 'lps'),
	(428631, 124, '2015-03-01 00:23:57.000000', 'consum', 0.0221, 'lps'),
	(428632, 124, '2015-03-01 00:23:58.000000', 'consum', 0.0234, 'lps'),
	(428633, 124, '2015-03-01 00:23:59.000000', 'consum', 0.0223, 'lps'),
	(428634, 124, '2015-03-01 00:24:00.000000', 'consum', 0.0228, 'lps'),
	(428635, 124, '2015-03-01 00:24:01.000000', 'consum', 0.0235, 'lps'),
	(428636, 124, '2015-03-01 00:24:02.000000', 'consum', 0.0230, 'lps'),
	(428637, 124, '2015-03-01 00:24:03.000000', 'consum', 0.0234, 'lps'),
	(428638, 124, '2015-03-01 00:24:04.000000', 'consum', 0.0220, 'lps'),
	(428639, 124, '2015-03-01 00:24:05.000000', 'consum', 0.0216, 'lps'),
	(428640, 124, '2015-03-01 00:24:06.000000', 'consum', 0.0210, 'lps'),
	(428641, 124, '2015-03-01 00:24:07.000000', 'consum', 0.0216, 'lps'),
	(428642, 124, '2015-03-01 00:24:08.000000', 'consum', 0.0217, 'lps'),
	(428643, 124, '2015-03-01 00:24:09.000000', 'consum', 0.0228, 'lps'),
	(428644, 124, '2015-03-01 00:24:10.000000', 'consum', 0.0226, 'lps'),
	(428645, 124, '2015-03-01 00:24:11.000000', 'consum', 0.0211, 'lps'),
	(428646, 124, '2015-03-01 00:24:12.000000', 'consum', 0.0218, 'lps'),
	(428647, 124, '2015-03-01 00:24:13.000000', 'consum', 0.0221, 'lps'),
	(428648, 124, '2015-03-01 00:24:14.000000', 'consum', 0.0215, 'lps'),
	(428649, 124, '2015-03-01 00:24:15.000000', 'consum', 0.0228, 'lps'),
	(428650, 124, '2015-03-01 00:24:16.000000', 'consum', 0.0234, 'lps'),
	(428651, 124, '2015-03-01 00:24:17.000000', 'consum', 0.0225, 'lps'),
	(428652, 124, '2015-03-01 00:24:18.000000', 'consum', 0.0214, 'lps'),
	(428653, 124, '2015-03-01 00:24:19.000000', 'consum', 0.0211, 'lps'),
	(428654, 124, '2015-03-01 00:24:20.000000', 'consum', 0.0229, 'lps'),
	(428655, 124, '2015-03-01 00:24:21.000000', 'consum', 0.0225, 'lps'),
	(428656, 124, '2015-03-01 00:24:22.000000', 'consum', 0.0230, 'lps'),
	(428657, 124, '2015-03-01 00:24:23.000000', 'consum', 0.0212, 'lps'),
	(428658, 124, '2015-03-01 00:24:24.000000', 'consum', 0.0213, 'lps'),
	(428659, 124, '2015-03-01 00:24:25.000000', 'consum', 0.0219, 'lps'),
	(428660, 124, '2015-03-01 00:24:26.000000', 'consum', 0.0219, 'lps'),
	(428661, 124, '2015-03-01 00:24:27.000000', 'consum', 0.0230, 'lps'),
	(428662, 124, '2015-03-01 00:24:28.000000', 'consum', 0.0231, 'lps'),
	(428663, 124, '2015-03-01 00:24:29.000000', 'consum', 0.0229, 'lps'),
	(428664, 124, '2015-03-01 00:24:30.000000', 'consum', 0.0217, 'lps'),
	(428665, 124, '2015-03-01 00:24:31.000000', 'consum', 0.0214, 'lps'),
	(428666, 124, '2015-03-01 00:24:32.000000', 'consum', 0.0234, 'lps'),
	(428667, 124, '2015-03-01 00:24:33.000000', 'consum', 0.0215, 'lps'),
	(428668, 124, '2015-03-01 00:24:34.000000', 'consum', 0.0215, 'lps'),
	(428669, 124, '2015-03-01 00:24:35.000000', 'consum', 0.0221, 'lps'),
	(428670, 124, '2015-03-01 00:24:36.000000', 'consum', 0.0225, 'lps'),
	(428671, 124, '2015-03-01 00:24:37.000000', 'consum', 0.0227, 'lps'),
	(428672, 124, '2015-03-01 00:24:38.000000', 'consum', 0.0222, 'lps'),
	(428673, 124, '2015-03-01 00:24:39.000000', 'consum', 0.0222, 'lps'),
	(428674, 124, '2015-03-01 00:24:40.000000', 'consum', 0.0233, 'lps'),
	(428675, 124, '2015-03-01 00:24:41.000000', 'consum', 0.0213, 'lps'),
	(428676, 124, '2015-03-01 00:24:42.000000', 'consum', 0.0234, 'lps'),
	(428677, 124, '2015-03-01 00:24:43.000000', 'consum', 0.0216, 'lps'),
	(428678, 124, '2015-03-01 00:24:44.000000', 'consum', 0.0222, 'lps'),
	(428679, 124, '2015-03-01 00:24:45.000000', 'consum', 0.0226, 'lps'),
	(428680, 124, '2015-03-01 00:24:46.000000', 'consum', 0.0228, 'lps'),
	(428681, 124, '2015-03-01 00:24:47.000000', 'consum', 0.0227, 'lps'),
	(428682, 124, '2015-03-01 00:24:48.000000', 'consum', 0.0215, 'lps'),
	(428683, 124, '2015-03-01 00:24:49.000000', 'consum', 0.0235, 'lps'),
	(428684, 124, '2015-03-01 00:24:50.000000', 'consum', 0.0218, 'lps'),
	(428685, 124, '2015-03-01 00:24:51.000000', 'consum', 0.0228, 'lps'),
	(428686, 124, '2015-03-01 00:24:52.000000', 'consum', 0.0224, 'lps'),
	(428687, 124, '2015-03-01 00:24:53.000000', 'consum', 0.0227, 'lps'),
	(428688, 124, '2015-03-01 00:24:54.000000', 'consum', 0.0225, 'lps'),
	(428689, 124, '2015-03-01 00:24:55.000000', 'consum', 0.0212, 'lps'),
	(428690, 124, '2015-03-01 00:24:56.000000', 'consum', 0.0227, 'lps'),
	(428691, 124, '2015-03-01 00:24:57.000000', 'consum', 0.0235, 'lps'),
	(428692, 124, '2015-03-01 00:24:58.000000', 'consum', 0.0234, 'lps'),
	(428693, 124, '2015-03-01 00:24:59.000000', 'consum', 0.0228, 'lps'),
	(428694, 124, '2015-03-01 00:25:00.000000', 'consum', 0.0227, 'lps'),
	(428695, 124, '2015-03-01 00:25:01.000000', 'consum', 0.0219, 'lps'),
	(428696, 124, '2015-03-01 00:25:02.000000', 'consum', 0.0230, 'lps'),
	(428697, 124, '2015-03-01 00:25:03.000000', 'consum', 0.0232, 'lps'),
	(428698, 124, '2015-03-01 00:25:04.000000', 'consum', 0.0235, 'lps'),
	(428699, 124, '2015-03-01 00:25:05.000000', 'consum', 0.0215, 'lps'),
	(428700, 124, '2015-03-01 00:25:06.000000', 'consum', 0.0214, 'lps'),
	(428701, 124, '2015-03-01 00:25:07.000000', 'consum', 0.0215, 'lps'),
	(428702, 124, '2015-03-01 00:25:08.000000', 'consum', 0.0224, 'lps'),
	(428703, 124, '2015-03-01 00:25:09.000000', 'consum', 0.0213, 'lps'),
	(428704, 124, '2015-03-01 00:25:10.000000', 'consum', 0.0210, 'lps'),
	(428705, 124, '2015-03-01 00:25:11.000000', 'consum', 0.0226, 'lps'),
	(428706, 124, '2015-03-01 00:25:12.000000', 'consum', 0.0214, 'lps'),
	(428707, 124, '2015-03-01 00:25:13.000000', 'consum', 0.0233, 'lps'),
	(428708, 124, '2015-03-01 00:25:14.000000', 'consum', 0.0235, 'lps'),
	(428709, 124, '2015-03-01 00:25:15.000000', 'consum', 0.0216, 'lps'),
	(428710, 124, '2015-03-01 00:25:16.000000', 'consum', 0.0219, 'lps'),
	(428711, 124, '2015-03-01 00:25:17.000000', 'consum', 0.0234, 'lps'),
	(428712, 124, '2015-03-01 00:25:18.000000', 'consum', 0.0228, 'lps'),
	(428713, 124, '2015-03-01 00:25:19.000000', 'consum', 0.0228, 'lps'),
	(428714, 124, '2015-03-01 00:25:20.000000', 'consum', 0.0219, 'lps'),
	(428715, 124, '2015-03-01 00:25:21.000000', 'consum', 0.0229, 'lps'),
	(428716, 124, '2015-03-01 00:25:22.000000', 'consum', 0.0227, 'lps'),
	(428717, 124, '2015-03-01 00:25:23.000000', 'consum', 0.0212, 'lps'),
	(428718, 124, '2015-03-01 00:25:24.000000', 'consum', 0.0219, 'lps'),
	(428719, 124, '2015-03-01 00:25:25.000000', 'consum', 0.0226, 'lps'),
	(428720, 124, '2015-03-01 00:25:26.000000', 'consum', 0.0213, 'lps'),
	(428721, 124, '2015-03-01 00:25:27.000000', 'consum', 0.0227, 'lps'),
	(428722, 124, '2015-03-01 00:25:28.000000', 'consum', 0.0235, 'lps'),
	(428723, 124, '2015-03-01 00:25:29.000000', 'consum', 0.0231, 'lps'),
	(428724, 124, '2015-03-01 00:25:30.000000', 'consum', 0.0214, 'lps'),
	(428725, 124, '2015-03-01 00:25:31.000000', 'consum', 0.0221, 'lps'),
	(428726, 124, '2015-03-01 00:25:32.000000', 'consum', 0.0226, 'lps'),
	(428727, 124, '2015-03-01 00:25:33.000000', 'consum', 0.0231, 'lps'),
	(428728, 124, '2015-03-01 00:25:34.000000', 'consum', 0.0217, 'lps'),
	(428729, 124, '2015-03-01 00:25:35.000000', 'consum', 0.0233, 'lps'),
	(428730, 124, '2015-03-01 00:25:36.000000', 'consum', 0.0228, 'lps'),
	(428731, 124, '2015-03-01 00:25:37.000000', 'consum', 0.0233, 'lps'),
	(428732, 124, '2015-03-01 00:25:38.000000', 'consum', 0.0217, 'lps'),
	(428733, 124, '2015-03-01 00:25:39.000000', 'consum', 0.0230, 'lps'),
	(428734, 124, '2015-03-01 00:25:40.000000', 'consum', 0.0235, 'lps'),
	(428735, 124, '2015-03-01 00:25:41.000000', 'consum', 0.0226, 'lps'),
	(428736, 124, '2015-03-01 00:25:42.000000', 'consum', 0.0216, 'lps'),
	(428737, 124, '2015-03-01 00:25:43.000000', 'consum', 0.0220, 'lps'),
	(428738, 124, '2015-03-01 00:25:44.000000', 'consum', 0.0214, 'lps'),
	(428739, 124, '2015-03-01 00:25:45.000000', 'consum', 0.0225, 'lps'),
	(428740, 124, '2015-03-01 00:25:46.000000', 'consum', 0.0225, 'lps'),
	(428741, 124, '2015-03-01 00:25:47.000000', 'consum', 0.0213, 'lps'),
	(428742, 124, '2015-03-01 00:25:48.000000', 'consum', 0.0231, 'lps'),
	(428743, 124, '2015-03-01 00:25:49.000000', 'consum', 0.0231, 'lps'),
	(428744, 124, '2015-03-01 00:25:50.000000', 'consum', 0.0225, 'lps'),
	(428745, 124, '2015-03-01 00:25:51.000000', 'consum', 0.0222, 'lps'),
	(428746, 124, '2015-03-01 00:25:52.000000', 'consum', 0.0228, 'lps'),
	(428747, 124, '2015-03-01 00:25:53.000000', 'consum', 0.0210, 'lps'),
	(428748, 124, '2015-03-01 00:25:54.000000', 'consum', 0.0234, 'lps'),
	(428749, 124, '2015-03-01 00:25:55.000000', 'consum', 0.0226, 'lps'),
	(428750, 124, '2015-03-01 00:25:56.000000', 'consum', 0.0218, 'lps'),
	(428751, 124, '2015-03-01 00:25:57.000000', 'consum', 0.0230, 'lps'),
	(428752, 124, '2015-03-01 00:25:58.000000', 'consum', 0.0235, 'lps'),
	(428753, 124, '2015-03-01 00:25:59.000000', 'consum', 0.0221, 'lps'),
	(428754, 124, '2015-03-01 00:26:00.000000', 'consum', 0.0219, 'lps'),
	(428755, 124, '2015-03-01 00:26:01.000000', 'consum', 0.0221, 'lps'),
	(428756, 124, '2015-03-01 00:26:02.000000', 'consum', 0.0214, 'lps'),
	(428757, 124, '2015-03-01 00:26:03.000000', 'consum', 0.0222, 'lps'),
	(428758, 124, '2015-03-01 00:26:04.000000', 'consum', 0.0232, 'lps'),
	(428759, 124, '2015-03-01 00:26:05.000000', 'consum', 0.0231, 'lps'),
	(428760, 124, '2015-03-01 00:26:06.000000', 'consum', 0.0226, 'lps'),
	(428761, 124, '2015-03-01 00:26:07.000000', 'consum', 0.0226, 'lps'),
	(428762, 124, '2015-03-01 00:26:08.000000', 'consum', 0.0217, 'lps'),
	(428763, 124, '2015-03-01 00:26:09.000000', 'consum', 0.0224, 'lps'),
	(428764, 124, '2015-03-01 00:26:10.000000', 'consum', 0.0233, 'lps'),
	(428765, 124, '2015-03-01 00:26:11.000000', 'consum', 0.0233, 'lps'),
	(428766, 124, '2015-03-01 00:26:12.000000', 'consum', 0.0231, 'lps'),
	(428767, 124, '2015-03-01 00:26:13.000000', 'consum', 0.0218, 'lps'),
	(428768, 124, '2015-03-01 00:26:14.000000', 'consum', 0.0215, 'lps'),
	(428769, 124, '2015-03-01 00:26:15.000000', 'consum', 0.0235, 'lps'),
	(428770, 124, '2015-03-01 00:26:16.000000', 'consum', 0.0220, 'lps'),
	(428771, 124, '2015-03-01 00:26:17.000000', 'consum', 0.0235, 'lps'),
	(428772, 124, '2015-03-01 00:26:18.000000', 'consum', 0.0229, 'lps'),
	(428773, 124, '2015-03-01 00:26:19.000000', 'consum', 0.0230, 'lps'),
	(428774, 124, '2015-03-01 00:26:20.000000', 'consum', 0.0230, 'lps'),
	(428775, 124, '2015-03-01 00:26:21.000000', 'consum', 0.0221, 'lps'),
	(428776, 124, '2015-03-01 00:26:22.000000', 'consum', 0.0234, 'lps'),
	(428777, 124, '2015-03-01 00:26:23.000000', 'consum', 0.0217, 'lps'),
	(428778, 124, '2015-03-01 00:26:24.000000', 'consum', 0.0226, 'lps'),
	(428779, 124, '2015-03-01 00:26:25.000000', 'consum', 0.0219, 'lps'),
	(428780, 124, '2015-03-01 00:26:26.000000', 'consum', 0.0233, 'lps'),
	(428781, 124, '2015-03-01 00:26:27.000000', 'consum', 0.0221, 'lps'),
	(428782, 124, '2015-03-01 00:26:28.000000', 'consum', 0.0221, 'lps'),
	(428783, 124, '2015-03-01 00:26:29.000000', 'consum', 0.0231, 'lps'),
	(428784, 124, '2015-03-01 00:26:30.000000', 'consum', 0.0234, 'lps'),
	(428785, 124, '2015-03-01 00:26:31.000000', 'consum', 0.0212, 'lps'),
	(428786, 124, '2015-03-01 00:26:32.000000', 'consum', 0.0229, 'lps'),
	(428787, 124, '2015-03-01 00:26:33.000000', 'consum', 0.0222, 'lps'),
	(428788, 124, '2015-03-01 00:26:34.000000', 'consum', 0.0211, 'lps'),
	(428789, 124, '2015-03-01 00:26:35.000000', 'consum', 0.0234, 'lps'),
	(428790, 124, '2015-03-01 00:26:36.000000', 'consum', 0.0221, 'lps'),
	(428791, 124, '2015-03-01 00:26:37.000000', 'consum', 0.0220, 'lps'),
	(428792, 124, '2015-03-01 00:26:38.000000', 'consum', 0.0230, 'lps'),
	(428793, 124, '2015-03-01 00:26:39.000000', 'consum', 0.0227, 'lps'),
	(428794, 124, '2015-03-01 00:26:40.000000', 'consum', 0.0235, 'lps'),
	(428795, 124, '2015-03-01 00:26:41.000000', 'consum', 0.0232, 'lps'),
	(428796, 124, '2015-03-01 00:26:42.000000', 'consum', 0.0222, 'lps'),
	(428797, 124, '2015-03-01 00:26:43.000000', 'consum', 0.0229, 'lps'),
	(428798, 124, '2015-03-01 00:26:44.000000', 'consum', 0.0217, 'lps'),
	(428799, 124, '2015-03-01 00:26:45.000000', 'consum', 0.0216, 'lps'),
	(428800, 124, '2015-03-01 00:26:46.000000', 'consum', 0.0217, 'lps'),
	(428801, 124, '2015-03-01 00:26:47.000000', 'consum', 0.0231, 'lps'),
	(428802, 124, '2015-03-01 00:26:48.000000', 'consum', 0.0213, 'lps'),
	(428803, 124, '2015-03-01 00:26:49.000000', 'consum', 0.0218, 'lps'),
	(428804, 124, '2015-03-01 00:26:50.000000', 'consum', 0.0213, 'lps'),
	(428805, 124, '2015-03-01 00:26:51.000000', 'consum', 0.0229, 'lps'),
	(428806, 124, '2015-03-01 00:26:52.000000', 'consum', 0.0218, 'lps'),
	(428807, 124, '2015-03-01 00:26:53.000000', 'consum', 0.0220, 'lps'),
	(428808, 124, '2015-03-01 00:26:54.000000', 'consum', 0.0211, 'lps'),
	(428809, 124, '2015-03-01 00:26:55.000000', 'consum', 0.0210, 'lps'),
	(428810, 124, '2015-03-01 00:26:56.000000', 'consum', 0.0210, 'lps'),
	(428811, 124, '2015-03-01 00:26:57.000000', 'consum', 0.0235, 'lps'),
	(428812, 124, '2015-03-01 00:26:58.000000', 'consum', 0.0233, 'lps'),
	(428813, 124, '2015-03-01 00:26:59.000000', 'consum', 0.0222, 'lps'),
	(428814, 124, '2015-03-01 00:27:00.000000', 'consum', 0.0230, 'lps'),
	(428815, 124, '2015-03-01 00:27:01.000000', 'consum', 0.0220, 'lps'),
	(428816, 124, '2015-03-01 00:27:02.000000', 'consum', 0.0227, 'lps'),
	(428817, 124, '2015-03-01 00:27:03.000000', 'consum', 0.0212, 'lps'),
	(428818, 124, '2015-03-01 00:27:04.000000', 'consum', 0.0223, 'lps'),
	(428819, 124, '2015-03-01 00:27:05.000000', 'consum', 0.0216, 'lps'),
	(428820, 124, '2015-03-01 00:27:06.000000', 'consum', 0.0229, 'lps'),
	(428821, 124, '2015-03-01 00:27:07.000000', 'consum', 0.0234, 'lps'),
	(428822, 124, '2015-03-01 00:27:08.000000', 'consum', 0.0222, 'lps'),
	(428823, 124, '2015-03-01 00:27:09.000000', 'consum', 0.0223, 'lps'),
	(428824, 124, '2015-03-01 00:27:10.000000', 'consum', 0.0213, 'lps'),
	(428825, 124, '2015-03-01 00:27:11.000000', 'consum', 0.0213, 'lps'),
	(428826, 124, '2015-03-01 00:27:12.000000', 'consum', 0.0217, 'lps'),
	(428827, 124, '2015-03-01 00:27:13.000000', 'consum', 0.0235, 'lps'),
	(428828, 124, '2015-03-01 00:27:14.000000', 'consum', 0.0211, 'lps'),
	(428829, 124, '2015-03-01 00:27:15.000000', 'consum', 0.0218, 'lps'),
	(428830, 124, '2015-03-01 00:27:16.000000', 'consum', 0.0222, 'lps'),
	(428831, 124, '2015-03-01 00:27:17.000000', 'consum', 0.0221, 'lps'),
	(428832, 124, '2015-03-01 00:27:18.000000', 'consum', 0.0229, 'lps'),
	(428833, 124, '2015-03-01 00:27:19.000000', 'consum', 0.0221, 'lps'),
	(428834, 124, '2015-03-01 00:27:20.000000', 'consum', 0.0233, 'lps'),
	(428835, 124, '2015-03-01 00:27:21.000000', 'consum', 0.0214, 'lps'),
	(428836, 124, '2015-03-01 00:27:22.000000', 'consum', 0.0213, 'lps'),
	(428837, 124, '2015-03-01 00:27:23.000000', 'consum', 0.0215, 'lps'),
	(428838, 124, '2015-03-01 00:27:24.000000', 'consum', 0.0228, 'lps'),
	(428839, 124, '2015-03-01 00:27:25.000000', 'consum', 0.0233, 'lps'),
	(428840, 124, '2015-03-01 00:27:26.000000', 'consum', 0.0219, 'lps'),
	(428841, 124, '2015-03-01 00:27:27.000000', 'consum', 0.0213, 'lps'),
	(428842, 124, '2015-03-01 00:27:28.000000', 'consum', 0.0223, 'lps'),
	(428843, 124, '2015-03-01 00:27:29.000000', 'consum', 0.0216, 'lps'),
	(428844, 124, '2015-03-01 00:27:30.000000', 'consum', 0.0227, 'lps'),
	(428845, 124, '2015-03-01 00:27:31.000000', 'consum', 0.0226, 'lps'),
	(428846, 124, '2015-03-01 00:27:32.000000', 'consum', 0.0213, 'lps'),
	(428847, 124, '2015-03-01 00:27:33.000000', 'consum', 0.0230, 'lps'),
	(428848, 124, '2015-03-01 00:27:34.000000', 'consum', 0.0222, 'lps'),
	(428849, 124, '2015-03-01 00:27:35.000000', 'consum', 0.0210, 'lps'),
	(428850, 124, '2015-03-01 00:27:36.000000', 'consum', 0.0227, 'lps'),
	(428851, 124, '2015-03-01 00:27:37.000000', 'consum', 0.0217, 'lps'),
	(428852, 124, '2015-03-01 00:27:38.000000', 'consum', 0.0222, 'lps'),
	(428853, 124, '2015-03-01 00:27:39.000000', 'consum', 0.0225, 'lps'),
	(428854, 124, '2015-03-01 00:27:40.000000', 'consum', 0.0221, 'lps'),
	(428855, 124, '2015-03-01 00:27:41.000000', 'consum', 0.0221, 'lps'),
	(428856, 124, '2015-03-01 00:27:42.000000', 'consum', 0.0233, 'lps'),
	(428857, 124, '2015-03-01 00:27:43.000000', 'consum', 0.0213, 'lps'),
	(428858, 124, '2015-03-01 00:27:44.000000', 'consum', 0.0234, 'lps'),
	(428859, 124, '2015-03-01 00:27:45.000000', 'consum', 0.0218, 'lps'),
	(428860, 124, '2015-03-01 00:27:46.000000', 'consum', 0.0229, 'lps'),
	(428861, 124, '2015-03-01 00:27:47.000000', 'consum', 0.0232, 'lps'),
	(428862, 124, '2015-03-01 00:27:48.000000', 'consum', 0.0235, 'lps'),
	(428863, 124, '2015-03-01 00:27:49.000000', 'consum', 0.0220, 'lps'),
	(428864, 124, '2015-03-01 00:27:50.000000', 'consum', 0.0235, 'lps'),
	(428865, 124, '2015-03-01 00:27:51.000000', 'consum', 0.0229, 'lps'),
	(428866, 124, '2015-03-01 00:27:52.000000', 'consum', 0.0232, 'lps'),
	(428867, 124, '2015-03-01 00:27:53.000000', 'consum', 0.0235, 'lps'),
	(428868, 124, '2015-03-01 00:27:54.000000', 'consum', 0.0218, 'lps'),
	(428869, 124, '2015-03-01 00:27:55.000000', 'consum', 0.0229, 'lps'),
	(428870, 124, '2015-03-01 00:27:56.000000', 'consum', 0.0228, 'lps'),
	(428871, 124, '2015-03-01 00:27:57.000000', 'consum', 0.0220, 'lps'),
	(428872, 124, '2015-03-01 00:27:58.000000', 'consum', 0.0230, 'lps'),
	(428873, 124, '2015-03-01 00:27:59.000000', 'consum', 0.0230, 'lps'),
	(428874, 124, '2015-03-01 00:28:00.000000', 'consum', 0.0225, 'lps'),
	(428875, 124, '2015-03-01 00:28:01.000000', 'consum', 0.0226, 'lps'),
	(428876, 124, '2015-03-01 00:28:02.000000', 'consum', 0.0220, 'lps'),
	(428877, 124, '2015-03-01 00:28:03.000000', 'consum', 0.0214, 'lps'),
	(428878, 124, '2015-03-01 00:28:04.000000', 'consum', 0.0223, 'lps'),
	(428879, 124, '2015-03-01 00:28:05.000000', 'consum', 0.0213, 'lps'),
	(428880, 124, '2015-03-01 00:28:06.000000', 'consum', 0.0210, 'lps'),
	(428881, 124, '2015-03-01 00:28:07.000000', 'consum', 0.0231, 'lps'),
	(428882, 124, '2015-03-01 00:28:08.000000', 'consum', 0.0235, 'lps'),
	(428883, 124, '2015-03-01 00:28:09.000000', 'consum', 0.0220, 'lps'),
	(428884, 124, '2015-03-01 00:28:10.000000', 'consum', 0.0211, 'lps'),
	(428885, 124, '2015-03-01 00:28:11.000000', 'consum', 0.0213, 'lps'),
	(428886, 124, '2015-03-01 00:28:12.000000', 'consum', 0.0222, 'lps'),
	(428887, 124, '2015-03-01 00:28:13.000000', 'consum', 0.0234, 'lps'),
	(428888, 124, '2015-03-01 00:28:14.000000', 'consum', 0.0217, 'lps'),
	(428889, 124, '2015-03-01 00:28:15.000000', 'consum', 0.0224, 'lps'),
	(428890, 124, '2015-03-01 00:28:16.000000', 'consum', 0.0210, 'lps'),
	(428891, 124, '2015-03-01 00:28:17.000000', 'consum', 0.0218, 'lps'),
	(428892, 124, '2015-03-01 00:28:18.000000', 'consum', 0.0225, 'lps'),
	(428893, 124, '2015-03-01 00:28:19.000000', 'consum', 0.0211, 'lps'),
	(428894, 124, '2015-03-01 00:28:20.000000', 'consum', 0.0220, 'lps'),
	(428895, 124, '2015-03-01 00:28:21.000000', 'consum', 0.0235, 'lps'),
	(428896, 124, '2015-03-01 00:28:22.000000', 'consum', 0.0225, 'lps'),
	(428897, 124, '2015-03-01 00:28:23.000000', 'consum', 0.0211, 'lps'),
	(428898, 124, '2015-03-01 00:28:24.000000', 'consum', 0.0224, 'lps'),
	(428899, 124, '2015-03-01 00:28:25.000000', 'consum', 0.0224, 'lps'),
	(428900, 124, '2015-03-01 00:28:26.000000', 'consum', 0.0214, 'lps'),
	(428901, 124, '2015-03-01 00:28:27.000000', 'consum', 0.0214, 'lps'),
	(428902, 124, '2015-03-01 00:28:28.000000', 'consum', 0.0216, 'lps'),
	(428903, 124, '2015-03-01 00:28:29.000000', 'consum', 0.0232, 'lps'),
	(428904, 124, '2015-03-01 00:28:30.000000', 'consum', 0.0221, 'lps'),
	(428905, 124, '2015-03-01 00:28:31.000000', 'consum', 0.0228, 'lps'),
	(428906, 124, '2015-03-01 00:28:32.000000', 'consum', 0.0214, 'lps'),
	(428907, 124, '2015-03-01 00:28:33.000000', 'consum', 0.0231, 'lps'),
	(428908, 124, '2015-03-01 00:28:34.000000', 'consum', 0.0222, 'lps'),
	(428909, 124, '2015-03-01 00:28:35.000000', 'consum', 0.0235, 'lps'),
	(428910, 124, '2015-03-01 00:28:36.000000', 'consum', 0.0223, 'lps'),
	(428911, 124, '2015-03-01 00:28:37.000000', 'consum', 0.0226, 'lps'),
	(428912, 124, '2015-03-01 00:28:38.000000', 'consum', 0.0227, 'lps'),
	(428913, 124, '2015-03-01 00:28:39.000000', 'consum', 0.0221, 'lps'),
	(428914, 124, '2015-03-01 00:28:40.000000', 'consum', 0.0215, 'lps'),
	(428915, 124, '2015-03-01 00:28:41.000000', 'consum', 0.0228, 'lps'),
	(428916, 124, '2015-03-01 00:28:42.000000', 'consum', 0.0234, 'lps'),
	(428917, 124, '2015-03-01 00:28:43.000000', 'consum', 0.0223, 'lps'),
	(428918, 124, '2015-03-01 00:28:44.000000', 'consum', 0.0232, 'lps'),
	(428919, 124, '2015-03-01 00:28:45.000000', 'consum', 0.0227, 'lps'),
	(428920, 124, '2015-03-01 00:28:46.000000', 'consum', 0.0231, 'lps'),
	(428921, 124, '2015-03-01 00:28:47.000000', 'consum', 0.0210, 'lps'),
	(428922, 124, '2015-03-01 00:28:48.000000', 'consum', 0.0228, 'lps'),
	(428923, 124, '2015-03-01 00:28:49.000000', 'consum', 0.0220, 'lps'),
	(428924, 124, '2015-03-01 00:28:50.000000', 'consum', 0.0233, 'lps'),
	(428925, 124, '2015-03-01 00:28:51.000000', 'consum', 0.0219, 'lps'),
	(428926, 124, '2015-03-01 00:28:52.000000', 'consum', 0.0213, 'lps'),
	(428927, 124, '2015-03-01 00:28:53.000000', 'consum', 0.0223, 'lps'),
	(428928, 124, '2015-03-01 00:28:54.000000', 'consum', 0.0214, 'lps'),
	(428929, 124, '2015-03-01 00:28:55.000000', 'consum', 0.0220, 'lps'),
	(428930, 124, '2015-03-01 00:28:56.000000', 'consum', 0.0221, 'lps'),
	(428931, 124, '2015-03-01 00:28:57.000000', 'consum', 0.0211, 'lps'),
	(428932, 124, '2015-03-01 00:28:58.000000', 'consum', 0.0232, 'lps'),
	(428933, 124, '2015-03-01 00:28:59.000000', 'consum', 0.0214, 'lps'),
	(428934, 124, '2015-03-01 00:29:00.000000', 'consum', 0.0215, 'lps'),
	(428935, 124, '2015-03-01 00:29:01.000000', 'consum', 0.0224, 'lps'),
	(428936, 124, '2015-03-01 00:29:02.000000', 'consum', 0.0216, 'lps'),
	(428937, 124, '2015-03-01 00:29:03.000000', 'consum', 0.0222, 'lps'),
	(428938, 124, '2015-03-01 00:29:04.000000', 'consum', 0.0227, 'lps'),
	(428939, 124, '2015-03-01 00:29:05.000000', 'consum', 0.0235, 'lps'),
	(428940, 124, '2015-03-01 00:29:06.000000', 'consum', 0.0230, 'lps'),
	(428941, 124, '2015-03-01 00:29:07.000000', 'consum', 0.0210, 'lps'),
	(428942, 124, '2015-03-01 00:29:08.000000', 'consum', 0.0229, 'lps'),
	(428943, 124, '2015-03-01 00:29:09.000000', 'consum', 0.0226, 'lps'),
	(428944, 124, '2015-03-01 00:29:10.000000', 'consum', 0.0233, 'lps'),
	(428945, 124, '2015-03-01 00:29:11.000000', 'consum', 0.0227, 'lps'),
	(428946, 124, '2015-03-01 00:29:12.000000', 'consum', 0.0225, 'lps'),
	(428947, 124, '2015-03-01 00:29:13.000000', 'consum', 0.0235, 'lps'),
	(428948, 124, '2015-03-01 00:29:14.000000', 'consum', 0.0211, 'lps'),
	(428949, 124, '2015-03-01 00:29:15.000000', 'consum', 0.0219, 'lps'),
	(428950, 124, '2015-03-01 00:29:16.000000', 'consum', 0.0227, 'lps'),
	(428951, 124, '2015-03-01 00:29:17.000000', 'consum', 0.0215, 'lps'),
	(428952, 124, '2015-03-01 00:29:18.000000', 'consum', 0.0210, 'lps'),
	(428953, 124, '2015-03-01 00:29:19.000000', 'consum', 0.0222, 'lps'),
	(428954, 124, '2015-03-01 00:29:20.000000', 'consum', 0.0221, 'lps'),
	(428955, 124, '2015-03-01 00:29:21.000000', 'consum', 0.0228, 'lps'),
	(428956, 124, '2015-03-01 00:29:22.000000', 'consum', 0.0216, 'lps'),
	(428957, 124, '2015-03-01 00:29:23.000000', 'consum', 0.0210, 'lps'),
	(428958, 124, '2015-03-01 00:29:24.000000', 'consum', 0.0221, 'lps'),
	(428959, 124, '2015-03-01 00:29:25.000000', 'consum', 0.0215, 'lps'),
	(428960, 124, '2015-03-01 00:29:26.000000', 'consum', 0.0226, 'lps'),
	(428961, 124, '2015-03-01 00:29:27.000000', 'consum', 0.0225, 'lps'),
	(428962, 124, '2015-03-01 00:29:28.000000', 'consum', 0.0213, 'lps'),
	(428963, 124, '2015-03-01 00:29:29.000000', 'consum', 0.0229, 'lps'),
	(428964, 124, '2015-03-01 00:29:30.000000', 'consum', 0.0220, 'lps'),
	(428965, 124, '2015-03-01 00:29:31.000000', 'consum', 0.0230, 'lps'),
	(428966, 124, '2015-03-01 00:29:32.000000', 'consum', 0.0227, 'lps'),
	(428967, 124, '2015-03-01 00:29:33.000000', 'consum', 0.0210, 'lps'),
	(428968, 124, '2015-03-01 00:29:34.000000', 'consum', 0.0210, 'lps'),
	(428969, 124, '2015-03-01 00:29:35.000000', 'consum', 0.0210, 'lps'),
	(428970, 124, '2015-03-01 00:29:36.000000', 'consum', 0.0211, 'lps'),
	(428971, 124, '2015-03-01 00:29:37.000000', 'consum', 0.0218, 'lps'),
	(428972, 124, '2015-03-01 00:29:38.000000', 'consum', 0.0219, 'lps'),
	(428973, 124, '2015-03-01 00:29:39.000000', 'consum', 0.0234, 'lps'),
	(428974, 124, '2015-03-01 00:29:40.000000', 'consum', 0.0226, 'lps'),
	(428975, 124, '2015-03-01 00:29:41.000000', 'consum', 0.0217, 'lps'),
	(428976, 124, '2015-03-01 00:29:42.000000', 'consum', 0.0224, 'lps'),
	(428977, 124, '2015-03-01 00:29:43.000000', 'consum', 0.0233, 'lps'),
	(428978, 124, '2015-03-01 00:29:44.000000', 'consum', 0.0233, 'lps'),
	(428979, 124, '2015-03-01 00:29:45.000000', 'consum', 0.0231, 'lps'),
	(428980, 124, '2015-03-01 00:29:46.000000', 'consum', 0.0221, 'lps'),
	(428981, 124, '2015-03-01 00:29:47.000000', 'consum', 0.0226, 'lps'),
	(428982, 124, '2015-03-01 00:29:48.000000', 'consum', 0.0231, 'lps'),
	(428983, 124, '2015-03-01 00:29:49.000000', 'consum', 0.0215, 'lps'),
	(428984, 124, '2015-03-01 00:29:50.000000', 'consum', 0.0225, 'lps'),
	(428985, 124, '2015-03-01 00:29:51.000000', 'consum', 0.0218, 'lps'),
	(428986, 124, '2015-03-01 00:29:52.000000', 'consum', 0.0233, 'lps'),
	(428987, 124, '2015-03-01 00:29:53.000000', 'consum', 0.0225, 'lps'),
	(428988, 124, '2015-03-01 00:29:54.000000', 'consum', 0.0213, 'lps'),
	(428989, 124, '2015-03-01 00:29:55.000000', 'consum', 0.0235, 'lps'),
	(428990, 124, '2015-03-01 00:29:56.000000', 'consum', 0.0221, 'lps'),
	(428991, 124, '2015-03-01 00:29:57.000000', 'consum', 0.0218, 'lps'),
	(428992, 124, '2015-03-01 00:29:58.000000', 'consum', 0.0216, 'lps'),
	(428993, 124, '2015-03-01 00:29:59.000000', 'consum', 0.0218, 'lps'),
	(428994, 124, '2015-03-01 00:30:00.000000', 'consum', 0.0234, 'lps'),
	(428995, 124, '2015-03-01 00:30:01.000000', 'consum', 0.0226, 'lps'),
	(428996, 124, '2015-03-01 00:30:02.000000', 'consum', 0.0218, 'lps'),
	(428997, 124, '2015-03-01 00:30:03.000000', 'consum', 0.0228, 'lps'),
	(428998, 124, '2015-03-01 00:30:04.000000', 'consum', 0.0223, 'lps'),
	(428999, 124, '2015-03-01 00:30:05.000000', 'consum', 0.0225, 'lps'),
	(429000, 124, '2015-03-01 00:30:06.000000', 'consum', 0.0219, 'lps'),
	(429001, 124, '2015-03-01 00:30:07.000000', 'consum', 0.0235, 'lps'),
	(429002, 124, '2015-03-01 00:30:08.000000', 'consum', 0.0231, 'lps'),
	(429003, 124, '2015-03-01 00:30:09.000000', 'consum', 0.0217, 'lps'),
	(429004, 124, '2015-03-01 00:30:10.000000', 'consum', 0.0231, 'lps'),
	(429005, 124, '2015-03-01 00:30:11.000000', 'consum', 0.0218, 'lps'),
	(429006, 124, '2015-03-01 00:30:12.000000', 'consum', 0.0215, 'lps'),
	(429007, 124, '2015-03-01 00:30:13.000000', 'consum', 0.0211, 'lps'),
	(429008, 124, '2015-03-01 00:30:14.000000', 'consum', 0.0228, 'lps'),
	(429009, 124, '2015-03-01 00:30:15.000000', 'consum', 0.0218, 'lps'),
	(429010, 124, '2015-03-01 00:30:16.000000', 'consum', 0.0222, 'lps'),
	(429011, 124, '2015-03-01 00:30:17.000000', 'consum', 0.0223, 'lps'),
	(429012, 124, '2015-03-01 00:30:18.000000', 'consum', 0.0211, 'lps'),
	(429013, 124, '2015-03-01 00:30:19.000000', 'consum', 0.0231, 'lps'),
	(429014, 124, '2015-03-01 00:30:20.000000', 'consum', 0.0231, 'lps'),
	(429015, 124, '2015-03-01 00:30:21.000000', 'consum', 0.0229, 'lps'),
	(429016, 124, '2015-03-01 00:30:22.000000', 'consum', 0.0217, 'lps'),
	(429017, 124, '2015-03-01 00:30:23.000000', 'consum', 0.0213, 'lps'),
	(429018, 124, '2015-03-01 00:30:24.000000', 'consum', 0.0231, 'lps'),
	(429019, 124, '2015-03-01 00:30:25.000000', 'consum', 0.0230, 'lps'),
	(429020, 124, '2015-03-01 00:30:26.000000', 'consum', 0.0221, 'lps'),
	(429021, 124, '2015-03-01 00:30:27.000000', 'consum', 0.0230, 'lps'),
	(429022, 124, '2015-03-01 00:30:28.000000', 'consum', 0.0225, 'lps'),
	(429023, 124, '2015-03-01 00:30:29.000000', 'consum', 0.0226, 'lps'),
	(429024, 124, '2015-03-01 00:30:30.000000', 'consum', 0.0220, 'lps'),
	(429025, 124, '2015-03-01 00:30:31.000000', 'consum', 0.0212, 'lps'),
	(429026, 124, '2015-03-01 00:30:32.000000', 'consum', 0.0216, 'lps'),
	(429027, 124, '2015-03-01 00:30:33.000000', 'consum', 0.0234, 'lps'),
	(429028, 124, '2015-03-01 00:30:34.000000', 'consum', 0.0210, 'lps'),
	(429029, 124, '2015-03-01 00:30:35.000000', 'consum', 0.0217, 'lps'),
	(429030, 124, '2015-03-01 00:30:36.000000', 'consum', 0.0219, 'lps'),
	(429031, 124, '2015-03-01 00:30:37.000000', 'consum', 0.0235, 'lps'),
	(429032, 124, '2015-03-01 00:30:38.000000', 'consum', 0.0231, 'lps'),
	(429033, 124, '2015-03-01 00:30:39.000000', 'consum', 0.0212, 'lps'),
	(429034, 124, '2015-03-01 00:30:40.000000', 'consum', 0.0211, 'lps'),
	(429035, 124, '2015-03-01 00:30:41.000000', 'consum', 0.0234, 'lps'),
	(429036, 124, '2015-03-01 00:30:42.000000', 'consum', 0.0226, 'lps'),
	(429037, 124, '2015-03-01 00:30:43.000000', 'consum', 0.0216, 'lps'),
	(429038, 124, '2015-03-01 00:30:44.000000', 'consum', 0.0221, 'lps'),
	(429039, 124, '2015-03-01 00:30:45.000000', 'consum', 0.0219, 'lps'),
	(429040, 124, '2015-03-01 00:30:46.000000', 'consum', 0.0224, 'lps'),
	(429041, 124, '2015-03-01 00:30:47.000000', 'consum', 0.0228, 'lps'),
	(429042, 124, '2015-03-01 00:30:48.000000', 'consum', 0.0232, 'lps'),
	(429043, 124, '2015-03-01 00:30:49.000000', 'consum', 0.0216, 'lps'),
	(429044, 124, '2015-03-01 00:30:50.000000', 'consum', 0.0226, 'lps'),
	(429045, 124, '2015-03-01 00:30:51.000000', 'consum', 0.0221, 'lps'),
	(429046, 124, '2015-03-01 00:30:52.000000', 'consum', 0.0216, 'lps'),
	(429047, 124, '2015-03-01 00:30:53.000000', 'consum', 0.0235, 'lps'),
	(429048, 124, '2015-03-01 00:30:54.000000', 'consum', 0.0211, 'lps'),
	(429049, 124, '2015-03-01 00:30:55.000000', 'consum', 0.0221, 'lps'),
	(429050, 124, '2015-03-01 00:30:56.000000', 'consum', 0.0211, 'lps'),
	(429051, 124, '2015-03-01 00:30:57.000000', 'consum', 0.0234, 'lps'),
	(429052, 124, '2015-03-01 00:30:58.000000', 'consum', 0.0222, 'lps'),
	(429053, 124, '2015-03-01 00:30:59.000000', 'consum', 0.0225, 'lps'),
	(429054, 124, '2015-03-01 00:31:00.000000', 'consum', 0.0224, 'lps'),
	(429055, 124, '2015-03-01 00:31:01.000000', 'consum', 0.0211, 'lps'),
	(429056, 124, '2015-03-01 00:31:02.000000', 'consum', 0.0225, 'lps'),
	(429057, 124, '2015-03-01 00:31:03.000000', 'consum', 0.0231, 'lps'),
	(429058, 124, '2015-03-01 00:31:04.000000', 'consum', 0.0218, 'lps'),
	(429059, 124, '2015-03-01 00:31:05.000000', 'consum', 0.0213, 'lps'),
	(429060, 124, '2015-03-01 00:31:06.000000', 'consum', 0.0227, 'lps'),
	(429061, 124, '2015-03-01 00:31:07.000000', 'consum', 0.0234, 'lps'),
	(429062, 124, '2015-03-01 00:31:08.000000', 'consum', 0.0228, 'lps'),
	(429063, 124, '2015-03-01 00:31:09.000000', 'consum', 0.0230, 'lps'),
	(429064, 124, '2015-03-01 00:31:10.000000', 'consum', 0.0228, 'lps'),
	(429065, 124, '2015-03-01 00:31:11.000000', 'consum', 0.0217, 'lps'),
	(429066, 124, '2015-03-01 00:31:12.000000', 'consum', 0.0215, 'lps'),
	(429067, 124, '2015-03-01 00:31:13.000000', 'consum', 0.0217, 'lps'),
	(429068, 124, '2015-03-01 00:31:14.000000', 'consum', 0.0230, 'lps'),
	(429069, 124, '2015-03-01 00:31:15.000000', 'consum', 0.0235, 'lps'),
	(429070, 124, '2015-03-01 00:31:16.000000', 'consum', 0.0226, 'lps'),
	(429071, 124, '2015-03-01 00:31:17.000000', 'consum', 0.0213, 'lps'),
	(429072, 124, '2015-03-01 00:31:18.000000', 'consum', 0.0231, 'lps'),
	(429073, 124, '2015-03-01 00:31:19.000000', 'consum', 0.0229, 'lps'),
	(429074, 124, '2015-03-01 00:31:20.000000', 'consum', 0.0214, 'lps'),
	(429075, 124, '2015-03-01 00:31:21.000000', 'consum', 0.0228, 'lps'),
	(429076, 124, '2015-03-01 00:31:22.000000', 'consum', 0.0210, 'lps'),
	(429077, 124, '2015-03-01 00:31:23.000000', 'consum', 0.0232, 'lps'),
	(429078, 124, '2015-03-01 00:31:24.000000', 'consum', 0.0219, 'lps'),
	(429079, 124, '2015-03-01 00:31:25.000000', 'consum', 0.0215, 'lps'),
	(429080, 124, '2015-03-01 00:31:26.000000', 'consum', 0.0210, 'lps'),
	(429081, 124, '2015-03-01 00:31:27.000000', 'consum', 0.0220, 'lps'),
	(429082, 124, '2015-03-01 00:31:28.000000', 'consum', 0.0210, 'lps'),
	(429083, 124, '2015-03-01 00:31:29.000000', 'consum', 0.0230, 'lps'),
	(429084, 124, '2015-03-01 00:31:30.000000', 'consum', 0.0232, 'lps'),
	(429085, 124, '2015-03-01 00:31:31.000000', 'consum', 0.0235, 'lps'),
	(429086, 124, '2015-03-01 00:31:32.000000', 'consum', 0.0216, 'lps'),
	(429087, 124, '2015-03-01 00:31:33.000000', 'consum', 0.0221, 'lps'),
	(429088, 124, '2015-03-01 00:31:34.000000', 'consum', 0.0219, 'lps'),
	(429089, 124, '2015-03-01 00:31:35.000000', 'consum', 0.0224, 'lps'),
	(429090, 124, '2015-03-01 00:31:36.000000', 'consum', 0.0226, 'lps'),
	(429091, 124, '2015-03-01 00:31:37.000000', 'consum', 0.0221, 'lps'),
	(429092, 124, '2015-03-01 00:31:38.000000', 'consum', 0.0220, 'lps'),
	(429093, 124, '2015-03-01 00:31:39.000000', 'consum', 0.0225, 'lps'),
	(429094, 124, '2015-03-01 00:31:40.000000', 'consum', 0.0232, 'lps'),
	(429095, 124, '2015-03-01 00:31:41.000000', 'consum', 0.0222, 'lps'),
	(429096, 124, '2015-03-01 00:31:42.000000', 'consum', 0.0231, 'lps'),
	(429097, 124, '2015-03-01 00:31:43.000000', 'consum', 0.0228, 'lps'),
	(429098, 124, '2015-03-01 00:31:44.000000', 'consum', 0.0213, 'lps'),
	(429099, 124, '2015-03-01 00:31:45.000000', 'consum', 0.0221, 'lps'),
	(429100, 124, '2015-03-01 00:31:46.000000', 'consum', 0.0233, 'lps'),
	(429101, 124, '2015-03-01 00:31:47.000000', 'consum', 0.0214, 'lps'),
	(429102, 124, '2015-03-01 00:31:48.000000', 'consum', 0.0212, 'lps'),
	(429103, 124, '2015-03-01 00:31:49.000000', 'consum', 0.0233, 'lps'),
	(429104, 124, '2015-03-01 00:31:50.000000', 'consum', 0.0218, 'lps'),
	(429105, 124, '2015-03-01 00:31:51.000000', 'consum', 0.0231, 'lps'),
	(429106, 124, '2015-03-01 00:31:52.000000', 'consum', 0.0216, 'lps'),
	(429107, 124, '2015-03-01 00:31:53.000000', 'consum', 0.0231, 'lps'),
	(429108, 124, '2015-03-01 00:31:54.000000', 'consum', 0.0217, 'lps'),
	(429109, 124, '2015-03-01 00:31:55.000000', 'consum', 0.0235, 'lps'),
	(429110, 124, '2015-03-01 00:31:56.000000', 'consum', 0.0211, 'lps'),
	(429111, 124, '2015-03-01 00:31:57.000000', 'consum', 0.0219, 'lps'),
	(429112, 124, '2015-03-01 00:31:58.000000', 'consum', 0.0225, 'lps'),
	(429113, 124, '2015-03-01 00:31:59.000000', 'consum', 0.0232, 'lps'),
	(429114, 124, '2015-03-01 00:32:00.000000', 'consum', 0.0223, 'lps'),
	(429115, 124, '2015-03-01 00:32:01.000000', 'consum', 0.0211, 'lps'),
	(429116, 124, '2015-03-01 00:32:02.000000', 'consum', 0.0229, 'lps'),
	(429117, 124, '2015-03-01 00:32:03.000000', 'consum', 0.0222, 'lps'),
	(429118, 124, '2015-03-01 00:32:04.000000', 'consum', 0.0216, 'lps'),
	(429119, 124, '2015-03-01 00:32:05.000000', 'consum', 0.0231, 'lps'),
	(429120, 124, '2015-03-01 00:32:06.000000', 'consum', 0.0218, 'lps'),
	(429121, 124, '2015-03-01 00:32:07.000000', 'consum', 0.0215, 'lps'),
	(429122, 124, '2015-03-01 00:32:08.000000', 'consum', 0.0212, 'lps'),
	(429123, 124, '2015-03-01 00:32:09.000000', 'consum', 0.0232, 'lps'),
	(429124, 124, '2015-03-01 00:32:10.000000', 'consum', 0.0210, 'lps'),
	(429125, 124, '2015-03-01 00:32:11.000000', 'consum', 0.0222, 'lps'),
	(429126, 124, '2015-03-01 00:32:12.000000', 'consum', 0.0217, 'lps'),
	(429127, 124, '2015-03-01 00:32:13.000000', 'consum', 0.0235, 'lps'),
	(429128, 124, '2015-03-01 00:32:14.000000', 'consum', 0.0211, 'lps'),
	(429129, 124, '2015-03-01 00:32:15.000000', 'consum', 0.0217, 'lps'),
	(429130, 124, '2015-03-01 00:32:16.000000', 'consum', 0.0219, 'lps'),
	(429131, 124, '2015-03-01 00:32:17.000000', 'consum', 0.0233, 'lps'),
	(429132, 124, '2015-03-01 00:32:18.000000', 'consum', 0.0221, 'lps'),
	(429133, 124, '2015-03-01 00:32:19.000000', 'consum', 0.0224, 'lps'),
	(429134, 124, '2015-03-01 00:32:20.000000', 'consum', 0.0221, 'lps'),
	(429135, 124, '2015-03-01 00:32:21.000000', 'consum', 0.0225, 'lps'),
	(429136, 124, '2015-03-01 00:32:22.000000', 'consum', 0.0225, 'lps'),
	(429137, 124, '2015-03-01 00:32:23.000000', 'consum', 0.0213, 'lps'),
	(429138, 124, '2015-03-01 00:32:24.000000', 'consum', 0.0235, 'lps'),
	(429139, 124, '2015-03-01 00:32:25.000000', 'consum', 0.0222, 'lps'),
	(429140, 124, '2015-03-01 00:32:26.000000', 'consum', 0.0223, 'lps'),
	(429141, 124, '2015-03-01 00:32:27.000000', 'consum', 0.0211, 'lps'),
	(429142, 124, '2015-03-01 00:32:28.000000', 'consum', 0.0231, 'lps'),
	(429143, 124, '2015-03-01 00:32:29.000000', 'consum', 0.0232, 'lps'),
	(429144, 124, '2015-03-01 00:32:30.000000', 'consum', 0.0231, 'lps'),
	(429145, 124, '2015-03-01 00:32:31.000000', 'consum', 0.0223, 'lps'),
	(429146, 124, '2015-03-01 00:32:32.000000', 'consum', 0.0214, 'lps'),
	(429147, 124, '2015-03-01 00:32:33.000000', 'consum', 0.0215, 'lps'),
	(429148, 124, '2015-03-01 00:32:34.000000', 'consum', 0.0226, 'lps'),
	(429149, 124, '2015-03-01 00:32:35.000000', 'consum', 0.0221, 'lps'),
	(429150, 124, '2015-03-01 00:32:36.000000', 'consum', 0.0221, 'lps'),
	(429151, 124, '2015-03-01 00:32:37.000000', 'consum', 0.0230, 'lps'),
	(429152, 124, '2015-03-01 00:32:38.000000', 'consum', 0.0226, 'lps'),
	(429153, 124, '2015-03-01 00:32:39.000000', 'consum', 0.0230, 'lps'),
	(429154, 124, '2015-03-01 00:32:40.000000', 'consum', 0.0235, 'lps'),
	(429155, 124, '2015-03-01 00:32:41.000000', 'consum', 0.0226, 'lps'),
	(429156, 124, '2015-03-01 00:32:42.000000', 'consum', 0.0216, 'lps'),
	(429157, 124, '2015-03-01 00:32:43.000000', 'consum', 0.0217, 'lps'),
	(429158, 124, '2015-03-01 00:32:44.000000', 'consum', 0.0228, 'lps'),
	(429159, 124, '2015-03-01 00:32:45.000000', 'consum', 0.0229, 'lps'),
	(429160, 124, '2015-03-01 00:32:46.000000', 'consum', 0.0223, 'lps'),
	(429161, 124, '2015-03-01 00:32:47.000000', 'consum', 0.0221, 'lps'),
	(429162, 124, '2015-03-01 00:32:48.000000', 'consum', 0.0224, 'lps'),
	(429163, 124, '2015-03-01 00:32:49.000000', 'consum', 0.0224, 'lps'),
	(429164, 124, '2015-03-01 00:32:50.000000', 'consum', 0.0213, 'lps'),
	(429165, 124, '2015-03-01 00:32:51.000000', 'consum', 0.0233, 'lps'),
	(429166, 124, '2015-03-01 00:32:52.000000', 'consum', 0.0215, 'lps'),
	(429167, 124, '2015-03-01 00:32:53.000000', 'consum', 0.0217, 'lps'),
	(429168, 124, '2015-03-01 00:32:54.000000', 'consum', 0.0232, 'lps'),
	(429169, 124, '2015-03-01 00:32:55.000000', 'consum', 0.0219, 'lps'),
	(429170, 124, '2015-03-01 00:32:56.000000', 'consum', 0.0215, 'lps'),
	(429171, 124, '2015-03-01 00:32:57.000000', 'consum', 0.0210, 'lps'),
	(429172, 124, '2015-03-01 00:32:58.000000', 'consum', 0.0223, 'lps'),
	(429173, 124, '2015-03-01 00:32:59.000000', 'consum', 0.0221, 'lps'),
	(429174, 124, '2015-03-01 00:33:00.000000', 'consum', 0.0228, 'lps'),
	(429175, 124, '2015-03-01 00:33:01.000000', 'consum', 0.0216, 'lps'),
	(429176, 124, '2015-03-01 00:33:02.000000', 'consum', 0.0212, 'lps'),
	(429177, 124, '2015-03-01 00:33:03.000000', 'consum', 0.0228, 'lps'),
	(429178, 124, '2015-03-01 00:33:04.000000', 'consum', 0.0219, 'lps'),
	(429179, 124, '2015-03-01 00:33:05.000000', 'consum', 0.0224, 'lps'),
	(429180, 124, '2015-03-01 00:33:06.000000', 'consum', 0.0228, 'lps'),
	(429181, 124, '2015-03-01 00:33:07.000000', 'consum', 0.0233, 'lps'),
	(429182, 124, '2015-03-01 00:33:08.000000', 'consum', 0.0220, 'lps'),
	(429183, 124, '2015-03-01 00:33:09.000000', 'consum', 0.0219, 'lps'),
	(429184, 124, '2015-03-01 00:33:10.000000', 'consum', 0.0224, 'lps'),
	(429185, 124, '2015-03-01 00:33:11.000000', 'consum', 0.0229, 'lps'),
	(429186, 124, '2015-03-01 00:33:12.000000', 'consum', 0.0211, 'lps'),
	(429187, 124, '2015-03-01 00:33:13.000000', 'consum', 0.0210, 'lps'),
	(429188, 124, '2015-03-01 00:33:14.000000', 'consum', 0.0232, 'lps'),
	(429189, 124, '2015-03-01 00:33:15.000000', 'consum', 0.0217, 'lps'),
	(429190, 124, '2015-03-01 00:33:16.000000', 'consum', 0.0230, 'lps'),
	(429191, 124, '2015-03-01 00:33:17.000000', 'consum', 0.0214, 'lps'),
	(429192, 124, '2015-03-01 00:33:18.000000', 'consum', 0.0220, 'lps'),
	(429193, 124, '2015-03-01 00:33:19.000000', 'consum', 0.0222, 'lps'),
	(429194, 124, '2015-03-01 00:33:20.000000', 'consum', 0.0216, 'lps'),
	(429195, 124, '2015-03-01 00:33:21.000000', 'consum', 0.0231, 'lps'),
	(429196, 124, '2015-03-01 00:33:22.000000', 'consum', 0.0217, 'lps'),
	(429197, 124, '2015-03-01 00:33:23.000000', 'consum', 0.0210, 'lps'),
	(429198, 124, '2015-03-01 00:33:24.000000', 'consum', 0.0214, 'lps'),
	(429199, 124, '2015-03-01 00:33:25.000000', 'consum', 0.0230, 'lps'),
	(429200, 124, '2015-03-01 00:33:26.000000', 'consum', 0.0220, 'lps'),
	(429201, 124, '2015-03-01 00:33:27.000000', 'consum', 0.0228, 'lps'),
	(429202, 124, '2015-03-01 00:33:28.000000', 'consum', 0.0219, 'lps'),
	(429203, 124, '2015-03-01 00:33:29.000000', 'consum', 0.0227, 'lps'),
	(429204, 124, '2015-03-01 00:33:30.000000', 'consum', 0.0217, 'lps'),
	(429205, 124, '2015-03-01 00:33:31.000000', 'consum', 0.0219, 'lps'),
	(429206, 124, '2015-03-01 00:33:32.000000', 'consum', 0.0234, 'lps'),
	(429207, 124, '2015-03-01 00:33:33.000000', 'consum', 0.0226, 'lps'),
	(429208, 124, '2015-03-01 00:33:34.000000', 'consum', 0.0217, 'lps'),
	(429209, 124, '2015-03-01 00:33:35.000000', 'consum', 0.0224, 'lps'),
	(429210, 124, '2015-03-01 00:33:36.000000', 'consum', 0.0233, 'lps'),
	(429211, 124, '2015-03-01 00:33:37.000000', 'consum', 0.0232, 'lps'),
	(429212, 124, '2015-03-01 00:33:38.000000', 'consum', 0.0227, 'lps'),
	(429213, 124, '2015-03-01 00:33:39.000000', 'consum', 0.0230, 'lps'),
	(429214, 124, '2015-03-01 00:33:40.000000', 'consum', 0.0234, 'lps'),
	(429215, 124, '2015-03-01 00:33:41.000000', 'consum', 0.0216, 'lps'),
	(429216, 124, '2015-03-01 00:33:42.000000', 'consum', 0.0221, 'lps'),
	(429217, 124, '2015-03-01 00:33:43.000000', 'consum', 0.0221, 'lps'),
	(429218, 124, '2015-03-01 00:33:44.000000', 'consum', 0.0234, 'lps'),
	(429219, 124, '2015-03-01 00:33:45.000000', 'consum', 0.0217, 'lps'),
	(429220, 124, '2015-03-01 00:33:46.000000', 'consum', 0.0227, 'lps'),
	(429221, 124, '2015-03-01 00:33:47.000000', 'consum', 0.0221, 'lps'),
	(429222, 124, '2015-03-01 00:33:48.000000', 'consum', 0.0218, 'lps'),
	(429223, 124, '2015-03-01 00:33:49.000000', 'consum', 0.0214, 'lps'),
	(429224, 124, '2015-03-01 00:33:50.000000', 'consum', 0.0233, 'lps'),
	(429225, 124, '2015-03-01 00:33:51.000000', 'consum', 0.0235, 'lps'),
	(429226, 124, '2015-03-01 00:33:52.000000', 'consum', 0.0215, 'lps'),
	(429227, 124, '2015-03-01 00:33:53.000000', 'consum', 0.0211, 'lps'),
	(429228, 124, '2015-03-01 00:33:54.000000', 'consum', 0.0226, 'lps'),
	(429229, 124, '2015-03-01 00:33:55.000000', 'consum', 0.0212, 'lps'),
	(429230, 124, '2015-03-01 00:33:56.000000', 'consum', 0.0224, 'lps'),
	(429231, 124, '2015-03-01 00:33:57.000000', 'consum', 0.0221, 'lps'),
	(429232, 124, '2015-03-01 00:33:58.000000', 'consum', 0.0224, 'lps'),
	(429233, 124, '2015-03-01 00:33:59.000000', 'consum', 0.0221, 'lps'),
	(429234, 124, '2015-03-01 00:34:00.000000', 'consum', 0.0225, 'lps'),
	(429235, 124, '2015-03-01 00:34:01.000000', 'consum', 0.0225, 'lps'),
	(429236, 124, '2015-03-01 00:34:02.000000', 'consum', 0.0213, 'lps'),
	(429237, 124, '2015-03-01 00:34:03.000000', 'consum', 0.0234, 'lps'),
	(429238, 124, '2015-03-01 00:34:04.000000', 'consum', 0.0220, 'lps'),
	(429239, 124, '2015-03-01 00:34:05.000000', 'consum', 0.0211, 'lps'),
	(429240, 124, '2015-03-01 00:34:06.000000', 'consum', 0.0211, 'lps'),
	(429241, 124, '2015-03-01 00:34:07.000000', 'consum', 0.0214, 'lps'),
	(429242, 124, '2015-03-01 00:34:08.000000', 'consum', 0.0227, 'lps'),
	(429243, 124, '2015-03-01 00:34:09.000000', 'consum', 0.0232, 'lps'),
	(429244, 124, '2015-03-01 00:34:10.000000', 'consum', 0.0219, 'lps'),
	(429245, 124, '2015-03-01 00:34:11.000000', 'consum', 0.0215, 'lps'),
	(429246, 124, '2015-03-01 00:34:12.000000', 'consum', 0.0235, 'lps'),
	(429247, 124, '2015-03-01 00:34:13.000000', 'consum', 0.0216, 'lps'),
	(429248, 124, '2015-03-01 00:34:14.000000', 'consum', 0.0216, 'lps'),
	(429249, 124, '2015-03-01 00:34:15.000000', 'consum', 0.0223, 'lps'),
	(429250, 124, '2015-03-01 00:34:16.000000', 'consum', 0.0231, 'lps'),
	(429251, 124, '2015-03-01 00:34:17.000000', 'consum', 0.0226, 'lps'),
	(429252, 124, '2015-03-01 00:34:18.000000', 'consum', 0.0227, 'lps'),
	(429253, 124, '2015-03-01 00:34:19.000000', 'consum', 0.0222, 'lps'),
	(429254, 124, '2015-03-01 00:34:20.000000', 'consum', 0.0218, 'lps'),
	(429255, 124, '2015-03-01 00:34:21.000000', 'consum', 0.0216, 'lps'),
	(429256, 124, '2015-03-01 00:34:22.000000', 'consum', 0.0217, 'lps'),
	(429257, 124, '2015-03-01 00:34:23.000000', 'consum', 0.0229, 'lps'),
	(429258, 124, '2015-03-01 00:34:24.000000', 'consum', 0.0230, 'lps'),
	(429259, 124, '2015-03-01 00:34:25.000000', 'consum', 0.0228, 'lps'),
	(429260, 124, '2015-03-01 00:34:26.000000', 'consum', 0.0213, 'lps'),
	(429261, 124, '2015-03-01 00:34:27.000000', 'consum', 0.0225, 'lps'),
	(429262, 124, '2015-03-01 00:34:28.000000', 'consum', 0.0225, 'lps'),
	(429263, 124, '2015-03-01 00:34:29.000000', 'consum', 0.0212, 'lps'),
	(429264, 124, '2015-03-01 00:34:30.000000', 'consum', 0.0229, 'lps'),
	(429265, 124, '2015-03-01 00:34:31.000000', 'consum', 0.0221, 'lps'),
	(429266, 124, '2015-03-01 00:34:32.000000', 'consum', 0.0234, 'lps'),
	(429267, 124, '2015-03-01 00:34:33.000000', 'consum', 0.0222, 'lps'),
	(429268, 124, '2015-03-01 00:34:34.000000', 'consum', 0.0222, 'lps'),
	(429269, 124, '2015-03-01 00:34:35.000000', 'consum', 0.0235, 'lps'),
	(429270, 124, '2015-03-01 00:34:36.000000', 'consum', 0.0223, 'lps'),
	(429271, 124, '2015-03-01 00:34:37.000000', 'consum', 0.0226, 'lps'),
	(429272, 124, '2015-03-01 00:34:38.000000', 'consum', 0.0224, 'lps'),
	(429273, 124, '2015-03-01 00:34:39.000000', 'consum', 0.0231, 'lps'),
	(429274, 124, '2015-03-01 00:34:40.000000', 'consum', 0.0225, 'lps'),
	(429275, 124, '2015-03-01 00:34:41.000000', 'consum', 0.0220, 'lps'),
	(429276, 124, '2015-03-01 00:34:42.000000', 'consum', 0.0215, 'lps'),
	(429277, 124, '2015-03-01 00:34:43.000000', 'consum', 0.0234, 'lps'),
	(429278, 124, '2015-03-01 00:34:44.000000', 'consum', 0.0210, 'lps'),
	(429279, 124, '2015-03-01 00:34:45.000000', 'consum', 0.0217, 'lps'),
	(429280, 124, '2015-03-01 00:34:46.000000', 'consum', 0.0219, 'lps'),
	(429281, 124, '2015-03-01 00:34:47.000000', 'consum', 0.0233, 'lps'),
	(429282, 124, '2015-03-01 00:34:48.000000', 'consum', 0.0221, 'lps'),
	(429283, 124, '2015-03-01 00:34:49.000000', 'consum', 0.0224, 'lps'),
	(429284, 124, '2015-03-01 00:34:50.000000', 'consum', 0.0223, 'lps'),
	(429285, 124, '2015-03-01 00:34:51.000000', 'consum', 0.0231, 'lps'),
	(429286, 124, '2015-03-01 00:34:52.000000', 'consum', 0.0227, 'lps'),
	(429287, 124, '2015-03-01 00:34:53.000000', 'consum', 0.0231, 'lps'),
	(429288, 124, '2015-03-01 00:34:54.000000', 'consum', 0.0214, 'lps'),
	(429289, 124, '2015-03-01 00:34:55.000000', 'consum', 0.0221, 'lps'),
	(429290, 124, '2015-03-01 00:34:56.000000', 'consum', 0.0224, 'lps'),
	(429291, 124, '2015-03-01 00:34:57.000000', 'consum', 0.0222, 'lps'),
	(429292, 124, '2015-03-01 00:34:58.000000', 'consum', 0.0231, 'lps'),
	(429293, 124, '2015-03-01 00:34:59.000000', 'consum', 0.0226, 'lps'),
	(429294, 124, '2015-03-01 00:35:00.000000', 'consum', 0.0229, 'lps'),
	(429295, 124, '2015-03-01 00:35:01.000000', 'consum', 0.0230, 'lps'),
	(429296, 124, '2015-03-01 00:35:02.000000', 'consum', 0.0226, 'lps'),
	(429297, 124, '2015-03-01 00:35:03.000000', 'consum', 0.0232, 'lps'),
	(429298, 124, '2015-03-01 00:35:04.000000', 'consum', 0.0221, 'lps'),
	(429299, 124, '2015-03-01 00:35:05.000000', 'consum', 0.0223, 'lps'),
	(429300, 124, '2015-03-01 00:35:06.000000', 'consum', 0.0218, 'lps'),
	(429301, 124, '2015-03-01 00:35:07.000000', 'consum', 0.0211, 'lps'),
	(429302, 124, '2015-03-01 00:35:08.000000', 'consum', 0.0219, 'lps'),
	(429303, 124, '2015-03-01 00:35:09.000000', 'consum', 0.0226, 'lps'),
	(429304, 124, '2015-03-01 00:35:10.000000', 'consum', 0.0213, 'lps'),
	(429305, 124, '2015-03-01 00:35:11.000000', 'consum', 0.0227, 'lps'),
	(429306, 124, '2015-03-01 00:35:12.000000', 'consum', 0.0234, 'lps'),
	(429307, 124, '2015-03-01 00:35:13.000000', 'consum', 0.0229, 'lps'),
	(429308, 124, '2015-03-01 00:35:14.000000', 'consum', 0.0235, 'lps'),
	(429309, 124, '2015-03-01 00:35:15.000000', 'consum', 0.0224, 'lps'),
	(429310, 124, '2015-03-01 00:35:16.000000', 'consum', 0.0234, 'lps'),
	(429311, 124, '2015-03-01 00:35:17.000000', 'consum', 0.0234, 'lps'),
	(429312, 124, '2015-03-01 00:35:18.000000', 'consum', 0.0235, 'lps'),
	(429313, 124, '2015-03-01 00:35:19.000000', 'consum', 0.0235, 'lps'),
	(429314, 124, '2015-03-01 00:35:20.000000', 'consum', 0.0234, 'lps'),
	(429315, 124, '2015-03-01 00:35:21.000000', 'consum', 0.0232, 'lps'),
	(429316, 124, '2015-03-01 00:35:22.000000', 'consum', 0.0223, 'lps'),
	(429317, 124, '2015-03-01 00:35:23.000000', 'consum', 0.0234, 'lps'),
	(429318, 124, '2015-03-01 00:35:24.000000', 'consum', 0.0215, 'lps'),
	(429319, 124, '2015-03-01 00:35:25.000000', 'consum', 0.0214, 'lps'),
	(429320, 124, '2015-03-01 00:35:26.000000', 'consum', 0.0216, 'lps'),
	(429321, 124, '2015-03-01 00:35:27.000000', 'consum', 0.0228, 'lps'),
	(429322, 124, '2015-03-01 00:35:28.000000', 'consum', 0.0232, 'lps'),
	(429323, 124, '2015-03-01 00:35:29.000000', 'consum', 0.0213, 'lps'),
	(429324, 124, '2015-03-01 00:35:30.000000', 'consum', 0.0213, 'lps'),
	(429325, 124, '2015-03-01 00:35:31.000000', 'consum', 0.0216, 'lps'),
	(429326, 124, '2015-03-01 00:35:32.000000', 'consum', 0.0232, 'lps'),
	(429327, 124, '2015-03-01 00:35:33.000000', 'consum', 0.0225, 'lps'),
	(429328, 124, '2015-03-01 00:35:34.000000', 'consum', 0.0217, 'lps'),
	(429329, 124, '2015-03-01 00:35:35.000000', 'consum', 0.0229, 'lps'),
	(429330, 124, '2015-03-01 00:35:36.000000', 'consum', 0.0232, 'lps'),
	(429331, 124, '2015-03-01 00:35:37.000000', 'consum', 0.0212, 'lps'),
	(429332, 124, '2015-03-01 00:35:38.000000', 'consum', 0.0233, 'lps'),
	(429333, 124, '2015-03-01 00:35:39.000000', 'consum', 0.0216, 'lps'),
	(429334, 124, '2015-03-01 00:35:40.000000', 'consum', 0.0221, 'lps'),
	(429335, 124, '2015-03-01 00:35:41.000000', 'consum', 0.0222, 'lps'),
	(429336, 124, '2015-03-01 00:35:42.000000', 'consum', 0.0212, 'lps'),
	(429337, 124, '2015-03-01 00:35:43.000000', 'consum', 0.0235, 'lps'),
	(429338, 124, '2015-03-01 00:35:44.000000', 'consum', 0.0225, 'lps'),
	(429339, 124, '2015-03-01 00:35:45.000000', 'consum', 0.0212, 'lps'),
	(429340, 124, '2015-03-01 00:35:46.000000', 'consum', 0.0225, 'lps'),
	(429341, 124, '2015-03-01 00:35:47.000000', 'consum', 0.0231, 'lps'),
	(429342, 124, '2015-03-01 00:35:48.000000', 'consum', 0.0217, 'lps'),
	(429343, 124, '2015-03-01 00:35:49.000000', 'consum', 0.0210, 'lps'),
	(429344, 124, '2015-03-01 00:35:50.000000', 'consum', 0.0214, 'lps'),
	(429345, 124, '2015-03-01 00:35:51.000000', 'consum', 0.0230, 'lps'),
	(429346, 124, '2015-03-01 00:35:52.000000', 'consum', 0.0221, 'lps'),
	(429347, 124, '2015-03-01 00:35:53.000000', 'consum', 0.0232, 'lps'),
	(429348, 124, '2015-03-01 00:35:54.000000', 'consum', 0.0235, 'lps'),
	(429349, 124, '2015-03-01 00:35:55.000000', 'consum', 0.0216, 'lps'),
	(429350, 124, '2015-03-01 00:35:56.000000', 'consum', 0.0217, 'lps'),
	(429351, 124, '2015-03-01 00:35:57.000000', 'consum', 0.0229, 'lps'),
	(429352, 124, '2015-03-01 00:35:58.000000', 'consum', 0.0232, 'lps'),
	(429353, 124, '2015-03-01 00:35:59.000000', 'consum', 0.0212, 'lps'),
	(429354, 124, '2015-03-01 00:36:00.000000', 'consum', 0.0233, 'lps'),
	(429355, 124, '2015-03-01 00:36:01.000000', 'consum', 0.0216, 'lps'),
	(429356, 124, '2015-03-01 00:36:02.000000', 'consum', 0.0222, 'lps'),
	(429357, 124, '2015-03-01 00:36:03.000000', 'consum', 0.0228, 'lps'),
	(429358, 124, '2015-03-01 00:36:04.000000', 'consum', 0.0213, 'lps'),
	(429359, 124, '2015-03-01 00:36:05.000000', 'consum', 0.0224, 'lps'),
	(429360, 124, '2015-03-01 00:36:06.000000', 'consum', 0.0219, 'lps'),
	(429361, 124, '2015-03-01 00:36:07.000000', 'consum', 0.0212, 'lps'),
	(429362, 124, '2015-03-01 00:36:08.000000', 'consum', 0.0220, 'lps'),
	(429363, 124, '2015-03-01 00:36:09.000000', 'consum', 0.0228, 'lps'),
	(429364, 124, '2015-03-01 00:36:10.000000', 'consum', 0.0220, 'lps'),
	(429365, 124, '2015-03-01 00:36:11.000000', 'consum', 0.0234, 'lps'),
	(429366, 124, '2015-03-01 00:36:12.000000', 'consum', 0.0220, 'lps'),
	(429367, 124, '2015-03-01 00:36:13.000000', 'consum', 0.0214, 'lps'),
	(429368, 124, '2015-03-01 00:36:14.000000', 'consum', 0.0229, 'lps'),
	(429369, 124, '2015-03-01 00:36:15.000000', 'consum', 0.0216, 'lps'),
	(429370, 124, '2015-03-01 00:36:16.000000', 'consum', 0.0233, 'lps'),
	(429371, 124, '2015-03-01 00:36:17.000000', 'consum', 0.0231, 'lps'),
	(429372, 124, '2015-03-01 00:36:18.000000', 'consum', 0.0221, 'lps'),
	(429373, 124, '2015-03-01 00:36:19.000000', 'consum', 0.0227, 'lps'),
	(429374, 124, '2015-03-01 00:36:20.000000', 'consum', 0.0210, 'lps'),
	(429375, 124, '2015-03-01 00:36:21.000000', 'consum', 0.0213, 'lps'),
	(429376, 124, '2015-03-01 00:36:22.000000', 'consum', 0.0226, 'lps'),
	(429377, 124, '2015-03-01 00:36:23.000000', 'consum', 0.0228, 'lps'),
	(429378, 124, '2015-03-01 00:36:24.000000', 'consum', 0.0225, 'lps'),
	(429379, 124, '2015-03-01 00:36:25.000000', 'consum', 0.0233, 'lps'),
	(429380, 124, '2015-03-01 00:36:26.000000', 'consum', 0.0228, 'lps'),
	(429381, 124, '2015-03-01 00:36:27.000000', 'consum', 0.0234, 'lps'),
	(429382, 124, '2015-03-01 00:36:28.000000', 'consum', 0.0222, 'lps'),
	(429383, 124, '2015-03-01 00:36:29.000000', 'consum', 0.0224, 'lps'),
	(429384, 124, '2015-03-01 00:36:30.000000', 'consum', 0.0218, 'lps'),
	(429385, 124, '2015-03-01 00:36:31.000000', 'consum', 0.0210, 'lps'),
	(429386, 124, '2015-03-01 00:36:32.000000', 'consum', 0.0213, 'lps'),
	(429387, 124, '2015-03-01 00:36:33.000000', 'consum', 0.0223, 'lps'),
	(429388, 124, '2015-03-01 00:36:34.000000', 'consum', 0.0217, 'lps'),
	(429389, 124, '2015-03-01 00:36:35.000000', 'consum', 0.0232, 'lps'),
	(429390, 124, '2015-03-01 00:36:36.000000', 'consum', 0.0222, 'lps'),
	(429391, 124, '2015-03-01 00:36:37.000000', 'consum', 0.0229, 'lps'),
	(429392, 124, '2015-03-01 00:36:38.000000', 'consum', 0.0219, 'lps'),
	(429393, 124, '2015-03-01 00:36:39.000000', 'consum', 0.0223, 'lps'),
	(429394, 124, '2015-03-01 00:36:40.000000', 'consum', 0.0223, 'lps'),
	(429395, 124, '2015-03-01 00:36:41.000000', 'consum', 0.0212, 'lps'),
	(429396, 124, '2015-03-01 00:36:42.000000', 'consum', 0.0234, 'lps'),
	(429397, 124, '2015-03-01 00:36:43.000000', 'consum', 0.0220, 'lps'),
	(429398, 124, '2015-03-01 00:36:44.000000', 'consum', 0.0215, 'lps'),
	(429399, 124, '2015-03-01 00:36:45.000000', 'consum', 0.0233, 'lps'),
	(429400, 124, '2015-03-01 00:36:46.000000', 'consum', 0.0230, 'lps'),
	(429401, 124, '2015-03-01 00:36:47.000000', 'consum', 0.0218, 'lps'),
	(429402, 124, '2015-03-01 00:36:48.000000', 'consum', 0.0214, 'lps'),
	(429403, 124, '2015-03-01 00:36:49.000000', 'consum', 0.0232, 'lps'),
	(429404, 124, '2015-03-01 00:36:50.000000', 'consum', 0.0230, 'lps'),
	(429405, 124, '2015-03-01 00:36:51.000000', 'consum', 0.0218, 'lps'),
	(429406, 124, '2015-03-01 00:36:52.000000', 'consum', 0.0219, 'lps'),
	(429407, 124, '2015-03-01 00:36:53.000000', 'consum', 0.0230, 'lps'),
	(429408, 124, '2015-03-01 00:36:54.000000', 'consum', 0.0230, 'lps'),
	(429409, 124, '2015-03-01 00:36:55.000000', 'consum', 0.0227, 'lps'),
	(429410, 124, '2015-03-01 00:36:56.000000', 'consum', 0.0235, 'lps'),
	(429411, 124, '2015-03-01 00:36:57.000000', 'consum', 0.0232, 'lps'),
	(429412, 124, '2015-03-01 00:36:58.000000', 'consum', 0.0218, 'lps'),
	(429413, 124, '2015-03-01 00:36:59.000000', 'consum', 0.0210, 'lps'),
	(429414, 124, '2015-03-01 00:37:00.000000', 'consum', 0.0216, 'lps'),
	(429415, 124, '2015-03-01 00:37:01.000000', 'consum', 0.0212, 'lps'),
	(429416, 124, '2015-03-01 00:37:02.000000', 'consum', 0.0227, 'lps'),
	(429417, 124, '2015-03-01 00:37:03.000000', 'consum', 0.0215, 'lps'),
	(429418, 124, '2015-03-01 00:37:04.000000', 'consum', 0.0235, 'lps'),
	(429419, 124, '2015-03-01 00:37:05.000000', 'consum', 0.0217, 'lps'),
	(429420, 124, '2015-03-01 00:37:06.000000', 'consum', 0.0221, 'lps'),
	(429421, 124, '2015-03-01 00:37:07.000000', 'consum', 0.0217, 'lps'),
	(429422, 124, '2015-03-01 00:37:08.000000', 'consum', 0.0216, 'lps'),
	(429423, 124, '2015-03-01 00:37:09.000000', 'consum', 0.0218, 'lps'),
	(429424, 124, '2015-03-01 00:37:10.000000', 'consum', 0.0230, 'lps'),
	(429425, 124, '2015-03-01 00:37:11.000000', 'consum', 0.0212, 'lps'),
	(429426, 124, '2015-03-01 00:37:12.000000', 'consum', 0.0213, 'lps'),
	(429427, 124, '2015-03-01 00:37:13.000000', 'consum', 0.0220, 'lps'),
	(429428, 124, '2015-03-01 00:37:14.000000', 'consum', 0.0223, 'lps'),
	(429429, 124, '2015-03-01 00:37:15.000000', 'consum', 0.0221, 'lps'),
	(429430, 124, '2015-03-01 00:37:16.000000', 'consum', 0.0225, 'lps'),
	(429431, 124, '2015-03-01 00:37:17.000000', 'consum', 0.0225, 'lps'),
	(429432, 124, '2015-03-01 00:37:18.000000', 'consum', 0.0217, 'lps'),
	(429433, 124, '2015-03-01 00:37:19.000000', 'consum', 0.0225, 'lps'),
	(429434, 124, '2015-03-01 00:37:20.000000', 'consum', 0.0212, 'lps'),
	(429435, 124, '2015-03-01 00:37:21.000000', 'consum', 0.0230, 'lps'),
	(429436, 124, '2015-03-01 00:37:22.000000', 'consum', 0.0224, 'lps'),
	(429437, 124, '2015-03-01 00:37:23.000000', 'consum', 0.0223, 'lps'),
	(429438, 124, '2015-03-01 00:37:24.000000', 'consum', 0.0230, 'lps'),
	(429439, 124, '2015-03-01 00:37:25.000000', 'consum', 0.0223, 'lps'),
	(429440, 124, '2015-03-01 00:37:26.000000', 'consum', 0.0214, 'lps'),
	(429441, 124, '2015-03-01 00:37:27.000000', 'consum', 0.0220, 'lps'),
	(429442, 124, '2015-03-01 00:37:28.000000', 'consum', 0.0220, 'lps'),
	(429443, 124, '2015-03-01 00:37:29.000000', 'consum', 0.0230, 'lps'),
	(429444, 124, '2015-03-01 00:37:30.000000', 'consum', 0.0228, 'lps'),
	(429445, 124, '2015-03-01 00:37:31.000000', 'consum', 0.0213, 'lps'),
	(429446, 124, '2015-03-01 00:37:32.000000', 'consum', 0.0227, 'lps'),
	(429447, 124, '2015-03-01 00:37:33.000000', 'consum', 0.0232, 'lps'),
	(429448, 124, '2015-03-01 00:37:34.000000', 'consum', 0.0219, 'lps'),
	(429449, 124, '2015-03-01 00:37:35.000000', 'consum', 0.0217, 'lps'),
	(429450, 124, '2015-03-01 00:37:36.000000', 'consum', 0.0217, 'lps'),
	(429451, 124, '2015-03-01 00:37:37.000000', 'consum', 0.0224, 'lps'),
	(429452, 124, '2015-03-01 00:37:38.000000', 'consum', 0.0234, 'lps'),
	(429453, 124, '2015-03-01 00:37:39.000000', 'consum', 0.0235, 'lps'),
	(429454, 124, '2015-03-01 00:37:40.000000', 'consum', 0.0212, 'lps'),
	(429455, 124, '2015-03-01 00:37:41.000000', 'consum', 0.0223, 'lps'),
	(429456, 124, '2015-03-01 00:37:42.000000', 'consum', 0.0216, 'lps'),
	(429457, 124, '2015-03-01 00:37:43.000000', 'consum', 0.0231, 'lps'),
	(429458, 124, '2015-03-01 00:37:44.000000', 'consum', 0.0217, 'lps'),
	(429459, 124, '2015-03-01 00:37:45.000000', 'consum', 0.0210, 'lps'),
	(429460, 124, '2015-03-01 00:37:46.000000', 'consum', 0.0216, 'lps'),
	(429461, 124, '2015-03-01 00:37:47.000000', 'consum', 0.0215, 'lps'),
	(429462, 124, '2015-03-01 00:37:48.000000', 'consum', 0.0219, 'lps'),
	(429463, 124, '2015-03-01 00:37:49.000000', 'consum', 0.0211, 'lps'),
	(429464, 124, '2015-03-01 00:37:50.000000', 'consum', 0.0218, 'lps'),
	(429465, 124, '2015-03-01 00:37:51.000000', 'consum', 0.0219, 'lps'),
	(429466, 124, '2015-03-01 00:37:52.000000', 'consum', 0.0231, 'lps'),
	(429467, 124, '2015-03-01 00:37:53.000000', 'consum', 0.0235, 'lps'),
	(429468, 124, '2015-03-01 00:37:54.000000', 'consum', 0.0223, 'lps'),
	(429469, 124, '2015-03-01 00:37:55.000000', 'consum', 0.0226, 'lps'),
	(429470, 124, '2015-03-01 00:37:56.000000', 'consum', 0.0227, 'lps'),
	(429471, 124, '2015-03-01 00:37:57.000000', 'consum', 0.0221, 'lps'),
	(429472, 124, '2015-03-01 00:37:58.000000', 'consum', 0.0216, 'lps'),
	(429473, 124, '2015-03-01 00:37:59.000000', 'consum', 0.0232, 'lps'),
	(429474, 124, '2015-03-01 00:38:00.000000', 'consum', 0.0226, 'lps'),
	(429475, 124, '2015-03-01 00:38:01.000000', 'consum', 0.0222, 'lps'),
	(429476, 124, '2015-03-01 00:38:02.000000', 'consum', 0.0223, 'lps'),
	(429477, 124, '2015-03-01 00:38:03.000000', 'consum', 0.0216, 'lps'),
	(429478, 124, '2015-03-01 00:38:04.000000', 'consum', 0.0225, 'lps'),
	(429479, 124, '2015-03-01 00:38:05.000000', 'consum', 0.0216, 'lps'),
	(429480, 124, '2015-03-01 00:38:06.000000', 'consum', 0.0220, 'lps'),
	(429481, 124, '2015-03-01 00:38:07.000000', 'consum', 0.0219, 'lps'),
	(429482, 124, '2015-03-01 00:38:08.000000', 'consum', 0.0227, 'lps'),
	(429483, 124, '2015-03-01 00:38:09.000000', 'consum', 0.0213, 'lps'),
	(429484, 124, '2015-03-01 00:38:10.000000', 'consum', 0.0230, 'lps'),
	(429485, 124, '2015-03-01 00:38:11.000000', 'consum', 0.0221, 'lps'),
	(429486, 124, '2015-03-01 00:38:12.000000', 'consum', 0.0231, 'lps'),
	(429487, 124, '2015-03-01 00:38:13.000000', 'consum', 0.0230, 'lps'),
	(429488, 124, '2015-03-01 00:38:14.000000', 'consum', 0.0223, 'lps'),
	(429489, 124, '2015-03-01 00:38:15.000000', 'consum', 0.0216, 'lps'),
	(429490, 124, '2015-03-01 00:38:16.000000', 'consum', 0.0229, 'lps'),
	(429491, 124, '2015-03-01 00:38:17.000000', 'consum', 0.0232, 'lps'),
	(429492, 124, '2015-03-01 00:38:18.000000', 'consum', 0.0215, 'lps'),
	(429493, 124, '2015-03-01 00:38:19.000000', 'consum', 0.0220, 'lps'),
	(429494, 124, '2015-03-01 00:38:20.000000', 'consum', 0.0218, 'lps'),
	(429495, 124, '2015-03-01 00:38:21.000000', 'consum', 0.0222, 'lps'),
	(429496, 124, '2015-03-01 00:38:22.000000', 'consum', 0.0222, 'lps'),
	(429497, 124, '2015-03-01 00:38:23.000000', 'consum', 0.0231, 'lps'),
	(429498, 124, '2015-03-01 00:38:24.000000', 'consum', 0.0230, 'lps'),
	(429499, 124, '2015-03-01 00:38:25.000000', 'consum', 0.0222, 'lps'),
	(429500, 124, '2015-03-01 00:38:26.000000', 'consum', 0.0235, 'lps'),
	(429501, 124, '2015-03-01 00:38:27.000000', 'consum', 0.0224, 'lps'),
	(429502, 124, '2015-03-01 00:38:28.000000', 'consum', 0.0230, 'lps'),
	(429503, 124, '2015-03-01 00:38:29.000000', 'consum', 0.0215, 'lps'),
	(429504, 124, '2015-03-01 00:38:30.000000', 'consum', 0.0227, 'lps'),
	(429505, 124, '2015-03-01 00:38:31.000000', 'consum', 0.0229, 'lps'),
	(429506, 124, '2015-03-01 00:38:32.000000', 'consum', 0.0229, 'lps'),
	(429507, 124, '2015-03-01 00:38:33.000000', 'consum', 0.0224, 'lps'),
	(429508, 124, '2015-03-01 00:38:34.000000', 'consum', 0.0221, 'lps'),
	(429509, 124, '2015-03-01 00:38:35.000000', 'consum', 0.0225, 'lps'),
	(429510, 124, '2015-03-01 00:38:36.000000', 'consum', 0.0226, 'lps'),
	(429511, 124, '2015-03-01 00:38:37.000000', 'consum', 0.0220, 'lps'),
	(429512, 124, '2015-03-01 00:38:38.000000', 'consum', 0.0214, 'lps'),
	(429513, 124, '2015-03-01 00:38:39.000000', 'consum', 0.0223, 'lps'),
	(429514, 124, '2015-03-01 00:38:40.000000', 'consum', 0.0214, 'lps'),
	(429515, 124, '2015-03-01 00:38:41.000000', 'consum', 0.0216, 'lps'),
	(429516, 124, '2015-03-01 00:38:42.000000', 'consum', 0.0230, 'lps'),
	(429517, 124, '2015-03-01 00:38:43.000000', 'consum', 0.0213, 'lps'),
	(429518, 124, '2015-03-01 00:38:44.000000', 'consum', 0.0217, 'lps'),
	(429519, 124, '2015-03-01 00:38:45.000000', 'consum', 0.0235, 'lps'),
	(429520, 124, '2015-03-01 00:38:46.000000', 'consum', 0.0213, 'lps'),
	(429521, 124, '2015-03-01 00:38:47.000000', 'consum', 0.0227, 'lps'),
	(429522, 124, '2015-03-01 00:38:48.000000', 'consum', 0.0234, 'lps'),
	(429523, 124, '2015-03-01 00:38:49.000000', 'consum', 0.0229, 'lps'),
	(429524, 124, '2015-03-01 00:38:50.000000', 'consum', 0.0231, 'lps'),
	(429525, 124, '2015-03-01 00:38:51.000000', 'consum', 0.0233, 'lps'),
	(429526, 124, '2015-03-01 00:38:52.000000', 'consum', 0.0212, 'lps'),
	(429527, 124, '2015-03-01 00:38:53.000000', 'consum', 0.0229, 'lps'),
	(429528, 124, '2015-03-01 00:38:54.000000', 'consum', 0.0220, 'lps'),
	(429529, 124, '2015-03-01 00:38:55.000000', 'consum', 0.0229, 'lps'),
	(429530, 124, '2015-03-01 00:38:56.000000', 'consum', 0.0225, 'lps'),
	(429531, 124, '2015-03-01 00:38:57.000000', 'consum', 0.0228, 'lps'),
	(429532, 124, '2015-03-01 00:38:58.000000', 'consum', 0.0231, 'lps'),
	(429533, 124, '2015-03-01 00:38:59.000000', 'consum', 0.0233, 'lps'),
	(429534, 124, '2015-03-01 00:39:00.000000', 'consum', 0.0210, 'lps'),
	(429535, 124, '2015-03-01 00:39:01.000000', 'consum', 0.0220, 'lps'),
	(429536, 124, '2015-03-01 00:39:02.000000', 'consum', 0.0234, 'lps'),
	(429537, 124, '2015-03-01 00:39:03.000000', 'consum', 0.0223, 'lps'),
	(429538, 124, '2015-03-01 00:39:04.000000', 'consum', 0.0229, 'lps'),
	(429539, 124, '2015-03-01 00:39:05.000000', 'consum', 0.0215, 'lps'),
	(429540, 124, '2015-03-01 00:39:06.000000', 'consum', 0.0230, 'lps'),
	(429541, 124, '2015-03-01 00:39:07.000000', 'consum', 0.0217, 'lps'),
	(429542, 124, '2015-03-01 00:39:08.000000', 'consum', 0.0214, 'lps'),
	(429543, 124, '2015-03-01 00:39:09.000000', 'consum', 0.0234, 'lps'),
	(429544, 124, '2015-03-01 00:39:10.000000', 'consum', 0.0216, 'lps'),
	(429545, 124, '2015-03-01 00:39:11.000000', 'consum', 0.0220, 'lps'),
	(429546, 124, '2015-03-01 00:39:12.000000', 'consum', 0.0215, 'lps'),
	(429547, 124, '2015-03-01 00:39:13.000000', 'consum', 0.0234, 'lps'),
	(429548, 124, '2015-03-01 00:39:14.000000', 'consum', 0.0210, 'lps'),
	(429549, 124, '2015-03-01 00:39:15.000000', 'consum', 0.0217, 'lps'),
	(429550, 124, '2015-03-01 00:39:16.000000', 'consum', 0.0217, 'lps'),
	(429551, 124, '2015-03-01 00:39:17.000000', 'consum', 0.0228, 'lps'),
	(429552, 124, '2015-03-01 00:39:18.000000', 'consum', 0.0224, 'lps'),
	(429553, 124, '2015-03-01 00:39:19.000000', 'consum', 0.0228, 'lps'),
	(429554, 124, '2015-03-01 00:39:20.000000', 'consum', 0.0234, 'lps'),
	(429555, 124, '2015-03-01 00:39:21.000000', 'consum', 0.0221, 'lps'),
	(429556, 124, '2015-03-01 00:39:22.000000', 'consum', 0.0223, 'lps'),
	(429557, 124, '2015-03-01 00:39:23.000000', 'consum', 0.0214, 'lps'),
	(429558, 124, '2015-03-01 00:39:24.000000', 'consum', 0.0219, 'lps'),
	(429559, 124, '2015-03-01 00:39:25.000000', 'consum', 0.0216, 'lps'),
	(429560, 124, '2015-03-01 00:39:26.000000', 'consum', 0.0214, 'lps'),
	(429561, 124, '2015-03-01 00:39:27.000000', 'consum', 0.0211, 'lps'),
	(429562, 124, '2015-03-01 00:39:28.000000', 'consum', 0.0231, 'lps'),
	(429563, 124, '2015-03-01 00:39:29.000000', 'consum', 0.0234, 'lps'),
	(429564, 124, '2015-03-01 00:39:30.000000', 'consum', 0.0214, 'lps'),
	(429565, 124, '2015-03-01 00:39:31.000000', 'consum', 0.0211, 'lps'),
	(429566, 124, '2015-03-01 00:39:32.000000', 'consum', 0.0231, 'lps'),
	(429567, 124, '2015-03-01 00:39:33.000000', 'consum', 0.0234, 'lps'),
	(429568, 124, '2015-03-01 00:39:34.000000', 'consum', 0.0215, 'lps'),
	(429569, 124, '2015-03-01 00:39:35.000000', 'consum', 0.0216, 'lps'),
	(429570, 124, '2015-03-01 00:39:36.000000', 'consum', 0.0227, 'lps'),
	(429571, 124, '2015-03-01 00:39:37.000000', 'consum', 0.0223, 'lps'),
	(429572, 124, '2015-03-01 00:39:38.000000', 'consum', 0.0224, 'lps'),
	(429573, 124, '2015-03-01 00:39:39.000000', 'consum', 0.0215, 'lps'),
	(429574, 124, '2015-03-01 00:39:40.000000', 'consum', 0.0221, 'lps'),
	(429575, 124, '2015-03-01 00:39:41.000000', 'consum', 0.0224, 'lps'),
	(429576, 124, '2015-03-01 00:39:42.000000', 'consum', 0.0221, 'lps'),
	(429577, 124, '2015-03-01 00:39:43.000000', 'consum', 0.0225, 'lps'),
	(429578, 124, '2015-03-01 00:39:44.000000', 'consum', 0.0227, 'lps'),
	(429579, 124, '2015-03-01 00:39:45.000000', 'consum', 0.0223, 'lps'),
	(429580, 124, '2015-03-01 00:39:46.000000', 'consum', 0.0226, 'lps'),
	(429581, 124, '2015-03-01 00:39:47.000000', 'consum', 0.0225, 'lps'),
	(429582, 124, '2015-03-01 00:39:48.000000', 'consum', 0.0212, 'lps'),
	(429583, 124, '2015-03-01 00:39:49.000000', 'consum', 0.0226, 'lps'),
	(429584, 124, '2015-03-01 00:39:50.000000', 'consum', 0.0235, 'lps'),
	(429585, 124, '2015-03-01 00:39:51.000000', 'consum', 0.0233, 'lps'),
	(429586, 124, '2015-03-01 00:39:52.000000', 'consum', 0.0223, 'lps'),
	(429587, 124, '2015-03-01 00:39:53.000000', 'consum', 0.0210, 'lps'),
	(429588, 124, '2015-03-01 00:39:54.000000', 'consum', 0.0221, 'lps'),
	(429589, 124, '2015-03-01 00:39:55.000000', 'consum', 0.0216, 'lps'),
	(429590, 124, '2015-03-01 00:39:56.000000', 'consum', 0.0232, 'lps'),
	(429591, 124, '2015-03-01 00:39:57.000000', 'consum', 0.0226, 'lps'),
	(429592, 124, '2015-03-01 00:39:58.000000', 'consum', 0.0224, 'lps'),
	(429593, 124, '2015-03-01 00:39:59.000000', 'consum', 0.0232, 'lps'),
	(429594, 124, '2015-03-01 00:40:00.000000', 'consum', 0.0228, 'lps'),
	(429595, 124, '2015-03-01 00:40:01.000000', 'consum', 0.0233, 'lps'),
	(429596, 124, '2015-03-01 00:40:02.000000', 'consum', 0.0221, 'lps'),
	(429597, 124, '2015-03-01 00:40:03.000000', 'consum', 0.0224, 'lps'),
	(429598, 124, '2015-03-01 00:40:04.000000', 'consum', 0.0219, 'lps'),
	(429599, 124, '2015-03-01 00:40:05.000000', 'consum', 0.0215, 'lps'),
	(429600, 124, '2015-03-01 00:40:06.000000', 'consum', 0.0234, 'lps'),
	(429601, 124, '2015-03-01 00:40:07.000000', 'consum', 0.0213, 'lps'),
	(429602, 124, '2015-03-01 00:40:08.000000', 'consum', 0.0231, 'lps'),
	(429603, 124, '2015-03-01 00:40:09.000000', 'consum', 0.0228, 'lps'),
	(429604, 124, '2015-03-01 00:40:10.000000', 'consum', 0.0210, 'lps'),
	(429605, 124, '2015-03-01 00:40:11.000000', 'consum', 0.0235, 'lps'),
	(429606, 124, '2015-03-01 00:40:12.000000', 'consum', 0.0231, 'lps'),
	(429607, 124, '2015-03-01 00:40:13.000000', 'consum', 0.0216, 'lps'),
	(429608, 124, '2015-03-01 00:40:14.000000', 'consum', 0.0227, 'lps'),
	(429609, 124, '2015-03-01 00:40:15.000000', 'consum', 0.0227, 'lps'),
	(429610, 124, '2015-03-01 00:40:16.000000', 'consum', 0.0220, 'lps'),
	(429611, 124, '2015-03-01 00:40:17.000000', 'consum', 0.0234, 'lps'),
	(429612, 124, '2015-03-01 00:40:18.000000', 'consum', 0.0221, 'lps'),
	(429613, 124, '2015-03-01 00:40:19.000000', 'consum', 0.0223, 'lps'),
	(429614, 124, '2015-03-01 00:40:20.000000', 'consum', 0.0213, 'lps'),
	(429615, 124, '2015-03-01 00:40:21.000000', 'consum', 0.0216, 'lps'),
	(429616, 124, '2015-03-01 00:40:22.000000', 'consum', 0.0229, 'lps'),
	(429617, 124, '2015-03-01 00:40:23.000000', 'consum', 0.0210, 'lps'),
	(429618, 124, '2015-03-01 00:40:24.000000', 'consum', 0.0230, 'lps'),
	(429619, 124, '2015-03-01 00:40:25.000000', 'consum', 0.0234, 'lps'),
	(429620, 124, '2015-03-01 00:40:26.000000', 'consum', 0.0219, 'lps'),
	(429621, 124, '2015-03-01 00:40:27.000000', 'consum', 0.0211, 'lps'),
	(429622, 124, '2015-03-01 00:40:28.000000', 'consum', 0.0212, 'lps'),
	(429623, 124, '2015-03-01 00:40:29.000000', 'consum', 0.0220, 'lps'),
	(429624, 124, '2015-03-01 00:40:30.000000', 'consum', 0.0229, 'lps'),
	(429625, 124, '2015-03-01 00:40:31.000000', 'consum', 0.0222, 'lps'),
	(429626, 124, '2015-03-01 00:40:32.000000', 'consum', 0.0213, 'lps'),
	(429627, 124, '2015-03-01 00:40:33.000000', 'consum', 0.0214, 'lps'),
	(429628, 124, '2015-03-01 00:40:34.000000', 'consum', 0.0223, 'lps'),
	(429629, 124, '2015-03-01 00:40:35.000000', 'consum', 0.0213, 'lps'),
	(429630, 124, '2015-03-01 00:40:36.000000', 'consum', 0.0211, 'lps'),
	(429631, 124, '2015-03-01 00:40:37.000000', 'consum', 0.0234, 'lps'),
	(429632, 124, '2015-03-01 00:40:38.000000', 'consum', 0.0223, 'lps'),
	(429633, 124, '2015-03-01 00:40:39.000000', 'consum', 0.0227, 'lps'),
	(429634, 124, '2015-03-01 00:40:40.000000', 'consum', 0.0234, 'lps'),
	(429635, 124, '2015-03-01 00:40:41.000000', 'consum', 0.0225, 'lps'),
	(429636, 124, '2015-03-01 00:40:42.000000', 'consum', 0.0215, 'lps'),
	(429637, 124, '2015-03-01 00:40:43.000000', 'consum', 0.0217, 'lps'),
	(429638, 124, '2015-03-01 00:40:44.000000', 'consum', 0.0232, 'lps'),
	(429639, 124, '2015-03-01 00:40:45.000000', 'consum', 0.0218, 'lps'),
	(429640, 124, '2015-03-01 00:40:46.000000', 'consum', 0.0211, 'lps'),
	(429641, 124, '2015-03-01 00:40:47.000000', 'consum', 0.0219, 'lps'),
	(429642, 124, '2015-03-01 00:40:48.000000', 'consum', 0.0225, 'lps'),
	(429643, 124, '2015-03-01 00:40:49.000000', 'consum', 0.0233, 'lps'),
	(429644, 124, '2015-03-01 00:40:50.000000', 'consum', 0.0228, 'lps'),
	(429645, 124, '2015-03-01 00:40:51.000000', 'consum', 0.0232, 'lps'),
	(429646, 124, '2015-03-01 00:40:52.000000', 'consum', 0.0215, 'lps'),
	(429647, 124, '2015-03-01 00:40:53.000000', 'consum', 0.0222, 'lps'),
	(429648, 124, '2015-03-01 00:40:54.000000', 'consum', 0.0229, 'lps'),
	(429649, 124, '2015-03-01 00:40:55.000000', 'consum', 0.0216, 'lps'),
	(429650, 124, '2015-03-01 00:40:56.000000', 'consum', 0.0211, 'lps'),
	(429651, 124, '2015-03-01 00:40:57.000000', 'consum', 0.0222, 'lps'),
	(429652, 124, '2015-03-01 00:40:58.000000', 'consum', 0.0218, 'lps'),
	(429653, 124, '2015-03-01 00:40:59.000000', 'consum', 0.0211, 'lps'),
	(429654, 124, '2015-03-01 00:41:00.000000', 'consum', 0.0221, 'lps'),
	(429655, 124, '2015-03-01 00:41:01.000000', 'consum', 0.0234, 'lps'),
	(429656, 124, '2015-03-01 00:41:02.000000', 'consum', 0.0220, 'lps'),
	(429657, 124, '2015-03-01 00:41:03.000000', 'consum', 0.0213, 'lps'),
	(429658, 124, '2015-03-01 00:41:04.000000', 'consum', 0.0224, 'lps'),
	(429659, 124, '2015-03-01 00:41:05.000000', 'consum', 0.0219, 'lps'),
	(429660, 124, '2015-03-01 00:41:06.000000', 'consum', 0.0212, 'lps'),
	(429661, 124, '2015-03-01 00:41:07.000000', 'consum', 0.0219, 'lps'),
	(429662, 124, '2015-03-01 00:41:08.000000', 'consum', 0.0224, 'lps'),
	(429663, 124, '2015-03-01 00:41:09.000000', 'consum', 0.0228, 'lps'),
	(429664, 124, '2015-03-01 00:41:10.000000', 'consum', 0.0231, 'lps'),
	(429665, 124, '2015-03-01 00:41:11.000000', 'consum', 0.0235, 'lps'),
	(429666, 124, '2015-03-01 00:41:12.000000', 'consum', 0.0219, 'lps'),
	(429667, 124, '2015-03-01 00:41:13.000000', 'consum', 0.0210, 'lps'),
	(429668, 124, '2015-03-01 00:41:14.000000', 'consum', 0.0235, 'lps'),
	(429669, 124, '2015-03-01 00:41:15.000000', 'consum', 0.0232, 'lps'),
	(429670, 124, '2015-03-01 00:41:16.000000', 'consum', 0.0219, 'lps'),
	(429671, 124, '2015-03-01 00:41:17.000000', 'consum', 0.0217, 'lps'),
	(429672, 124, '2015-03-01 00:41:18.000000', 'consum', 0.0215, 'lps'),
	(429673, 124, '2015-03-01 00:41:19.000000', 'consum', 0.0217, 'lps'),
	(429674, 124, '2015-03-01 00:41:20.000000', 'consum', 0.0231, 'lps'),
	(429675, 124, '2015-03-01 00:41:21.000000', 'consum', 0.0217, 'lps'),
	(429676, 124, '2015-03-01 00:41:22.000000', 'consum', 0.0234, 'lps'),
	(429677, 124, '2015-03-01 00:41:23.000000', 'consum', 0.0233, 'lps'),
	(429678, 124, '2015-03-01 00:41:24.000000', 'consum', 0.0226, 'lps'),
	(429679, 124, '2015-03-01 00:41:25.000000', 'consum', 0.0224, 'lps'),
	(429680, 124, '2015-03-01 00:41:26.000000', 'consum', 0.0229, 'lps'),
	(429681, 124, '2015-03-01 00:41:27.000000', 'consum', 0.0215, 'lps'),
	(429682, 124, '2015-03-01 00:41:28.000000', 'consum', 0.0228, 'lps'),
	(429683, 124, '2015-03-01 00:41:29.000000', 'consum', 0.0234, 'lps'),
	(429684, 124, '2015-03-01 00:41:30.000000', 'consum', 0.0224, 'lps'),
	(429685, 124, '2015-03-01 00:41:31.000000', 'consum', 0.0235, 'lps'),
	(429686, 124, '2015-03-01 00:41:32.000000', 'consum', 0.0214, 'lps'),
	(429687, 124, '2015-03-01 00:41:33.000000', 'consum', 0.0211, 'lps'),
	(429688, 124, '2015-03-01 00:41:34.000000', 'consum', 0.0226, 'lps'),
	(429689, 124, '2015-03-01 00:41:35.000000', 'consum', 0.0211, 'lps'),
	(429690, 124, '2015-03-01 00:41:36.000000', 'consum', 0.0220, 'lps'),
	(429691, 124, '2015-03-01 00:41:37.000000', 'consum', 0.0231, 'lps'),
	(429692, 124, '2015-03-01 00:41:38.000000', 'consum', 0.0233, 'lps'),
	(429693, 124, '2015-03-01 00:41:39.000000', 'consum', 0.0210, 'lps'),
	(429694, 124, '2015-03-01 00:41:40.000000', 'consum', 0.0219, 'lps'),
	(429695, 124, '2015-03-01 00:41:41.000000', 'consum', 0.0231, 'lps'),
	(429696, 124, '2015-03-01 00:41:42.000000', 'consum', 0.0211, 'lps'),
	(429697, 124, '2015-03-01 00:41:43.000000', 'consum', 0.0229, 'lps'),
	(429698, 124, '2015-03-01 00:41:44.000000', 'consum', 0.0226, 'lps'),
	(429699, 124, '2015-03-01 00:41:45.000000', 'consum', 0.0234, 'lps'),
	(429700, 124, '2015-03-01 00:41:46.000000', 'consum', 0.0232, 'lps'),
	(429701, 124, '2015-03-01 00:41:47.000000', 'consum', 0.0220, 'lps'),
	(429702, 124, '2015-03-01 00:41:48.000000', 'consum', 0.0222, 'lps'),
	(429703, 124, '2015-03-01 00:41:49.000000', 'consum', 0.0212, 'lps'),
	(429704, 124, '2015-03-01 00:41:50.000000', 'consum', 0.0212, 'lps'),
	(429705, 124, '2015-03-01 00:41:51.000000', 'consum', 0.0213, 'lps'),
	(429706, 124, '2015-03-01 00:41:52.000000', 'consum', 0.0221, 'lps'),
	(429707, 124, '2015-03-01 00:41:53.000000', 'consum', 0.0230, 'lps'),
	(429708, 124, '2015-03-01 00:41:54.000000', 'consum', 0.0227, 'lps'),
	(429709, 124, '2015-03-01 00:41:55.000000', 'consum', 0.0233, 'lps'),
	(429710, 124, '2015-03-01 00:41:56.000000', 'consum', 0.0224, 'lps'),
	(429711, 124, '2015-03-01 00:41:57.000000', 'consum', 0.0235, 'lps'),
	(429712, 124, '2015-03-01 00:41:58.000000', 'consum', 0.0219, 'lps'),
	(429713, 124, '2015-03-01 00:41:59.000000', 'consum', 0.0230, 'lps'),
	(429714, 124, '2015-03-01 00:42:00.000000', 'consum', 0.0234, 'lps'),
	(429715, 124, '2015-03-01 00:42:01.000000', 'consum', 0.0216, 'lps'),
	(429716, 124, '2015-03-01 00:42:02.000000', 'consum', 0.0219, 'lps'),
	(429717, 124, '2015-03-01 00:42:03.000000', 'consum', 0.0215, 'lps'),
	(429718, 124, '2015-03-01 00:42:04.000000', 'consum', 0.0233, 'lps'),
	(429719, 124, '2015-03-01 00:42:05.000000', 'consum', 0.0231, 'lps'),
	(429720, 124, '2015-03-01 00:42:06.000000', 'consum', 0.0221, 'lps'),
	(429721, 124, '2015-03-01 00:42:07.000000', 'consum', 0.0228, 'lps'),
	(429722, 124, '2015-03-01 00:42:08.000000', 'consum', 0.0214, 'lps'),
	(429723, 124, '2015-03-01 00:42:09.000000', 'consum', 0.0231, 'lps'),
	(429724, 124, '2015-03-01 00:42:10.000000', 'consum', 0.0225, 'lps'),
	(429725, 124, '2015-03-01 00:42:11.000000', 'consum', 0.0220, 'lps'),
	(429726, 124, '2015-03-01 00:42:12.000000', 'consum', 0.0219, 'lps'),
	(429727, 124, '2015-03-01 00:42:13.000000', 'consum', 0.0223, 'lps'),
	(429728, 124, '2015-03-01 00:42:14.000000', 'consum', 0.0225, 'lps'),
	(429729, 124, '2015-03-01 00:42:15.000000', 'consum', 0.0219, 'lps'),
	(429730, 124, '2015-03-01 00:42:16.000000', 'consum', 0.0211, 'lps'),
	(429731, 124, '2015-03-01 00:42:17.000000', 'consum', 0.0215, 'lps'),
	(429732, 124, '2015-03-01 00:42:18.000000', 'consum', 0.0232, 'lps'),
	(429733, 124, '2015-03-01 00:42:19.000000', 'consum', 0.0226, 'lps'),
	(429734, 124, '2015-03-01 00:42:20.000000', 'consum', 0.0227, 'lps'),
	(429735, 124, '2015-03-01 00:42:21.000000', 'consum', 0.0220, 'lps'),
	(429736, 124, '2015-03-01 00:42:22.000000', 'consum', 0.0210, 'lps'),
	(429737, 124, '2015-03-01 00:42:23.000000', 'consum', 0.0234, 'lps'),
	(429738, 124, '2015-03-01 00:42:24.000000', 'consum', 0.0224, 'lps'),
	(429739, 124, '2015-03-01 00:42:25.000000', 'consum', 0.0210, 'lps'),
	(429740, 124, '2015-03-01 00:42:26.000000', 'consum', 0.0221, 'lps'),
	(429741, 124, '2015-03-01 00:42:27.000000', 'consum', 0.0214, 'lps'),
	(429742, 124, '2015-03-01 00:42:28.000000', 'consum', 0.0223, 'lps'),
	(429743, 124, '2015-03-01 00:42:29.000000', 'consum', 0.0210, 'lps'),
	(429744, 124, '2015-03-01 00:42:30.000000', 'consum', 0.0224, 'lps'),
	(429745, 124, '2015-03-01 00:42:31.000000', 'consum', 0.0227, 'lps'),
	(429746, 124, '2015-03-01 00:42:32.000000', 'consum', 0.0231, 'lps'),
	(429747, 124, '2015-03-01 00:42:33.000000', 'consum', 0.0235, 'lps'),
	(429748, 124, '2015-03-01 00:42:34.000000', 'consum', 0.0221, 'lps'),
	(429749, 124, '2015-03-01 00:42:35.000000', 'consum', 0.0217, 'lps'),
	(429750, 124, '2015-03-01 00:42:36.000000', 'consum', 0.0211, 'lps'),
	(429751, 124, '2015-03-01 00:42:37.000000', 'consum', 0.0222, 'lps'),
	(429752, 124, '2015-03-01 00:42:38.000000', 'consum', 0.0214, 'lps'),
	(429753, 124, '2015-03-01 00:42:39.000000', 'consum', 0.0221, 'lps'),
	(429754, 124, '2015-03-01 00:42:40.000000', 'consum', 0.0228, 'lps'),
	(429755, 124, '2015-03-01 00:42:41.000000', 'consum', 0.0215, 'lps'),
	(429756, 124, '2015-03-01 00:42:42.000000', 'consum', 0.0235, 'lps'),
	(429757, 124, '2015-03-01 00:42:43.000000', 'consum', 0.0217, 'lps'),
	(429758, 124, '2015-03-01 00:42:44.000000', 'consum', 0.0220, 'lps'),
	(429759, 124, '2015-03-01 00:42:45.000000', 'consum', 0.0214, 'lps'),
	(429760, 124, '2015-03-01 00:42:46.000000', 'consum', 0.0225, 'lps'),
	(429761, 124, '2015-03-01 00:42:47.000000', 'consum', 0.0222, 'lps'),
	(429762, 124, '2015-03-01 00:42:48.000000', 'consum', 0.0228, 'lps'),
	(429763, 124, '2015-03-01 00:42:49.000000', 'consum', 0.0212, 'lps'),
	(429764, 124, '2015-03-01 00:42:50.000000', 'consum', 0.0216, 'lps'),
	(429765, 124, '2015-03-01 00:42:51.000000', 'consum', 0.0212, 'lps'),
	(429766, 124, '2015-03-01 00:42:52.000000', 'consum', 0.0226, 'lps'),
	(429767, 124, '2015-03-01 00:42:53.000000', 'consum', 0.0234, 'lps'),
	(429768, 124, '2015-03-01 00:42:54.000000', 'consum', 0.0230, 'lps'),
	(429769, 124, '2015-03-01 00:42:55.000000', 'consum', 0.0211, 'lps'),
	(429770, 124, '2015-03-01 00:42:56.000000', 'consum', 0.0210, 'lps'),
	(429771, 124, '2015-03-01 00:42:57.000000', 'consum', 0.0230, 'lps'),
	(429772, 124, '2015-03-01 00:42:58.000000', 'consum', 0.0210, 'lps'),
	(429773, 124, '2015-03-01 00:42:59.000000', 'consum', 0.0226, 'lps'),
	(429774, 124, '2015-03-01 00:43:00.000000', 'consum', 0.0213, 'lps'),
	(429775, 124, '2015-03-01 00:43:01.000000', 'consum', 0.0230, 'lps'),
	(429776, 124, '2015-03-01 00:43:02.000000', 'consum', 0.0225, 'lps'),
	(429777, 124, '2015-03-01 00:43:03.000000', 'consum', 0.0226, 'lps'),
	(429778, 124, '2015-03-01 00:43:04.000000', 'consum', 0.0218, 'lps'),
	(429779, 124, '2015-03-01 00:43:05.000000', 'consum', 0.0229, 'lps'),
	(429780, 124, '2015-03-01 00:43:06.000000', 'consum', 0.0230, 'lps'),
	(429781, 124, '2015-03-01 00:43:07.000000', 'consum', 0.0227, 'lps'),
	(429782, 124, '2015-03-01 00:43:08.000000', 'consum', 0.0234, 'lps'),
	(429783, 124, '2015-03-01 00:43:09.000000', 'consum', 0.0229, 'lps'),
	(429784, 124, '2015-03-01 00:43:10.000000', 'consum', 0.0231, 'lps'),
	(429785, 124, '2015-03-01 00:43:11.000000', 'consum', 0.0235, 'lps'),
	(429786, 124, '2015-03-01 00:43:12.000000', 'consum', 0.0221, 'lps'),
	(429787, 124, '2015-03-01 00:43:13.000000', 'consum', 0.0214, 'lps'),
	(429788, 124, '2015-03-01 00:43:14.000000', 'consum', 0.0225, 'lps'),
	(429789, 124, '2015-03-01 00:43:15.000000', 'consum', 0.0223, 'lps'),
	(429790, 124, '2015-03-01 00:43:16.000000', 'consum', 0.0230, 'lps'),
	(429791, 124, '2015-03-01 00:43:17.000000', 'consum', 0.0221, 'lps'),
	(429792, 124, '2015-03-01 00:43:18.000000', 'consum', 0.0228, 'lps'),
	(429793, 124, '2015-03-01 00:43:19.000000', 'consum', 0.0217, 'lps'),
	(429794, 124, '2015-03-01 00:43:20.000000', 'consum', 0.0218, 'lps'),
	(429795, 124, '2015-03-01 00:43:21.000000', 'consum', 0.0228, 'lps'),
	(429796, 124, '2015-03-01 00:43:22.000000', 'consum', 0.0224, 'lps'),
	(429797, 124, '2015-03-01 00:43:23.000000', 'consum', 0.0230, 'lps'),
	(429798, 124, '2015-03-01 00:43:24.000000', 'consum', 0.0213, 'lps'),
	(429799, 124, '2015-03-01 00:43:25.000000', 'consum', 0.0217, 'lps'),
	(429800, 124, '2015-03-01 00:43:26.000000', 'consum', 0.0211, 'lps'),
	(429801, 124, '2015-03-01 00:43:27.000000', 'consum', 0.0220, 'lps'),
	(429802, 124, '2015-03-01 00:43:28.000000', 'consum', 0.0232, 'lps'),
	(429803, 124, '2015-03-01 00:43:29.000000', 'consum', 0.0213, 'lps'),
	(429804, 124, '2015-03-01 00:43:30.000000', 'consum', 0.0211, 'lps'),
	(429805, 124, '2015-03-01 00:43:31.000000', 'consum', 0.0234, 'lps'),
	(429806, 124, '2015-03-01 00:43:32.000000', 'consum', 0.0223, 'lps'),
	(429807, 124, '2015-03-01 00:43:33.000000', 'consum', 0.0227, 'lps'),
	(429808, 124, '2015-03-01 00:43:34.000000', 'consum', 0.0234, 'lps'),
	(429809, 124, '2015-03-01 00:43:35.000000', 'consum', 0.0226, 'lps'),
	(429810, 124, '2015-03-01 00:43:36.000000', 'consum', 0.0217, 'lps'),
	(429811, 124, '2015-03-01 00:43:37.000000', 'consum', 0.0224, 'lps'),
	(429812, 124, '2015-03-01 00:43:38.000000', 'consum', 0.0235, 'lps'),
	(429813, 124, '2015-03-01 00:43:39.000000', 'consum', 0.0216, 'lps'),
	(429814, 124, '2015-03-01 00:43:40.000000', 'consum', 0.0218, 'lps'),
	(429815, 124, '2015-03-01 00:43:41.000000', 'consum', 0.0231, 'lps'),
	(429816, 124, '2015-03-01 00:43:42.000000', 'consum', 0.0213, 'lps'),
	(429817, 124, '2015-03-01 00:43:43.000000', 'consum', 0.0216, 'lps'),
	(429818, 124, '2015-03-01 00:43:44.000000', 'consum', 0.0232, 'lps'),
	(429819, 124, '2015-03-01 00:43:45.000000', 'consum', 0.0225, 'lps'),
	(429820, 124, '2015-03-01 00:43:46.000000', 'consum', 0.0218, 'lps'),
	(429821, 124, '2015-03-01 00:43:47.000000', 'consum', 0.0231, 'lps'),
	(429822, 124, '2015-03-01 00:43:48.000000', 'consum', 0.0214, 'lps'),
	(429823, 124, '2015-03-01 00:43:49.000000', 'consum', 0.0218, 'lps'),
	(429824, 124, '2015-03-01 00:43:50.000000', 'consum', 0.0214, 'lps'),
	(429825, 124, '2015-03-01 00:43:51.000000', 'consum', 0.0233, 'lps'),
	(429826, 124, '2015-03-01 00:43:52.000000', 'consum', 0.0211, 'lps'),
	(429827, 124, '2015-03-01 00:43:53.000000', 'consum', 0.0221, 'lps'),
	(429828, 124, '2015-03-01 00:43:54.000000', 'consum', 0.0213, 'lps'),
	(429829, 124, '2015-03-01 00:43:55.000000', 'consum', 0.0216, 'lps'),
	(429830, 124, '2015-03-01 00:43:56.000000', 'consum', 0.0232, 'lps'),
	(429831, 124, '2015-03-01 00:43:57.000000', 'consum', 0.0223, 'lps'),
	(429832, 124, '2015-03-01 00:43:58.000000', 'consum', 0.0212, 'lps'),
	(429833, 124, '2015-03-01 00:43:59.000000', 'consum', 0.0232, 'lps'),
	(429834, 124, '2015-03-01 00:44:00.000000', 'consum', 0.0235, 'lps'),
	(429835, 124, '2015-03-01 00:44:01.000000', 'consum', 0.0219, 'lps'),
	(429836, 124, '2015-03-01 00:44:02.000000', 'consum', 0.0234, 'lps'),
	(429837, 124, '2015-03-01 00:44:03.000000', 'consum', 0.0225, 'lps'),
	(429838, 124, '2015-03-01 00:44:04.000000', 'consum', 0.0213, 'lps'),
	(429839, 124, '2015-03-01 00:44:05.000000', 'consum', 0.0231, 'lps'),
	(429840, 124, '2015-03-01 00:44:06.000000', 'consum', 0.0228, 'lps'),
	(429841, 124, '2015-03-01 00:44:07.000000', 'consum', 0.0214, 'lps'),
	(429842, 124, '2015-03-01 00:44:08.000000', 'consum', 0.0228, 'lps'),
	(429843, 124, '2015-03-01 00:44:09.000000', 'consum', 0.0210, 'lps'),
	(429844, 124, '2015-03-01 00:44:10.000000', 'consum', 0.0234, 'lps'),
	(429845, 124, '2015-03-01 00:44:11.000000', 'consum', 0.0229, 'lps'),
	(429846, 124, '2015-03-01 00:44:12.000000', 'consum', 0.0230, 'lps'),
	(429847, 124, '2015-03-01 00:44:13.000000', 'consum', 0.0230, 'lps'),
	(429848, 124, '2015-03-01 00:44:14.000000', 'consum', 0.0223, 'lps'),
	(429849, 124, '2015-03-01 00:44:15.000000', 'consum', 0.0215, 'lps'),
	(429850, 124, '2015-03-01 00:44:16.000000', 'consum', 0.0224, 'lps'),
	(429851, 124, '2015-03-01 00:44:17.000000', 'consum', 0.0213, 'lps'),
	(429852, 124, '2015-03-01 00:44:18.000000', 'consum', 0.0234, 'lps'),
	(429853, 124, '2015-03-01 00:44:19.000000', 'consum', 0.0217, 'lps'),
	(429854, 124, '2015-03-01 00:44:20.000000', 'consum', 0.0225, 'lps'),
	(429855, 124, '2015-03-01 00:44:21.000000', 'consum', 0.0212, 'lps'),
	(429856, 124, '2015-03-01 00:44:22.000000', 'consum', 0.0227, 'lps'),
	(429857, 124, '2015-03-01 00:44:23.000000', 'consum', 0.0214, 'lps'),
	(429858, 124, '2015-03-01 00:44:24.000000', 'consum', 0.0230, 'lps'),
	(429859, 124, '2015-03-01 00:44:25.000000', 'consum', 0.0222, 'lps'),
	(429860, 124, '2015-03-01 00:44:26.000000', 'consum', 0.0212, 'lps'),
	(429861, 124, '2015-03-01 00:44:27.000000', 'consum', 0.0233, 'lps'),
	(429862, 124, '2015-03-01 00:44:28.000000', 'consum', 0.0216, 'lps'),
	(429863, 124, '2015-03-01 00:44:29.000000', 'consum', 0.0223, 'lps'),
	(429864, 124, '2015-03-01 00:44:30.000000', 'consum', 0.0234, 'lps'),
	(429865, 124, '2015-03-01 00:44:31.000000', 'consum', 0.0210, 'lps'),
	(429866, 124, '2015-03-01 00:44:32.000000', 'consum', 0.0219, 'lps'),
	(429867, 124, '2015-03-01 00:44:33.000000', 'consum', 0.0228, 'lps'),
	(429868, 124, '2015-03-01 00:44:34.000000', 'consum', 0.0221, 'lps'),
	(429869, 124, '2015-03-01 00:44:35.000000', 'consum', 0.0211, 'lps'),
	(429870, 124, '2015-03-01 00:44:36.000000', 'consum', 0.0233, 'lps'),
	(429871, 124, '2015-03-01 00:44:37.000000', 'consum', 0.0222, 'lps'),
	(429872, 124, '2015-03-01 00:44:38.000000', 'consum', 0.0225, 'lps'),
	(429873, 124, '2015-03-01 00:44:39.000000', 'consum', 0.0224, 'lps'),
	(429874, 124, '2015-03-01 00:44:40.000000', 'consum', 0.0234, 'lps'),
	(429875, 124, '2015-03-01 00:44:41.000000', 'consum', 0.0211, 'lps'),
	(429876, 124, '2015-03-01 00:44:42.000000', 'consum', 0.0220, 'lps'),
	(429877, 124, '2015-03-01 00:44:43.000000', 'consum', 0.0233, 'lps'),
	(429878, 124, '2015-03-01 00:44:44.000000', 'consum', 0.0218, 'lps'),
	(429879, 124, '2015-03-01 00:44:45.000000', 'consum', 0.0233, 'lps'),
	(429880, 124, '2015-03-01 00:44:46.000000', 'consum', 0.0222, 'lps'),
	(429881, 124, '2015-03-01 00:44:47.000000', 'consum', 0.0231, 'lps'),
	(429882, 124, '2015-03-01 00:44:48.000000', 'consum', 0.0225, 'lps'),
	(429883, 124, '2015-03-01 00:44:49.000000', 'consum', 0.0221, 'lps'),
	(429884, 124, '2015-03-01 00:44:50.000000', 'consum', 0.0223, 'lps'),
	(429885, 124, '2015-03-01 00:44:51.000000', 'consum', 0.0216, 'lps'),
	(429886, 124, '2015-03-01 00:44:52.000000', 'consum', 0.0225, 'lps'),
	(429887, 124, '2015-03-01 00:44:53.000000', 'consum', 0.0219, 'lps'),
	(429888, 124, '2015-03-01 00:44:54.000000', 'consum', 0.0235, 'lps'),
	(429889, 124, '2015-03-01 00:44:55.000000', 'consum', 0.0232, 'lps'),
	(429890, 124, '2015-03-01 00:44:56.000000', 'consum', 0.0219, 'lps'),
	(429891, 124, '2015-03-01 00:44:57.000000', 'consum', 0.0215, 'lps'),
	(429892, 124, '2015-03-01 00:44:58.000000', 'consum', 0.0234, 'lps'),
	(429893, 124, '2015-03-01 00:44:59.000000', 'consum', 0.0211, 'lps'),
	(429894, 124, '2015-03-01 00:45:00.000000', 'consum', 0.0220, 'lps'),
	(429895, 124, '2015-03-01 00:45:01.000000', 'consum', 0.0234, 'lps'),
	(429896, 124, '2015-03-01 00:45:02.000000', 'consum', 0.0222, 'lps'),
	(429897, 124, '2015-03-01 00:45:03.000000', 'consum', 0.0223, 'lps'),
	(429898, 124, '2015-03-01 00:45:04.000000', 'consum', 0.0214, 'lps'),
	(429899, 124, '2015-03-01 00:45:05.000000', 'consum', 0.0216, 'lps'),
	(429900, 124, '2015-03-01 00:45:06.000000', 'consum', 0.0231, 'lps'),
	(429901, 124, '2015-03-01 00:45:07.000000', 'consum', 0.0220, 'lps'),
	(429902, 124, '2015-03-01 00:45:08.000000', 'consum', 0.0222, 'lps'),
	(429903, 124, '2015-03-01 00:45:09.000000', 'consum', 0.0214, 'lps'),
	(429904, 124, '2015-03-01 00:45:10.000000', 'consum', 0.0222, 'lps'),
	(429905, 124, '2015-03-01 00:45:11.000000', 'consum', 0.0231, 'lps'),
	(429906, 124, '2015-03-01 00:45:12.000000', 'consum', 0.0230, 'lps'),
	(429907, 124, '2015-03-01 00:45:13.000000', 'consum', 0.0219, 'lps'),
	(429908, 124, '2015-03-01 00:45:14.000000', 'consum', 0.0223, 'lps'),
	(429909, 124, '2015-03-01 00:45:15.000000', 'consum', 0.0222, 'lps'),
	(429910, 124, '2015-03-01 00:45:16.000000', 'consum', 0.0231, 'lps'),
	(429911, 124, '2015-03-01 00:45:17.000000', 'consum', 0.0228, 'lps'),
	(429912, 124, '2015-03-01 00:45:18.000000', 'consum', 0.0211, 'lps'),
	(429913, 124, '2015-03-01 00:45:19.000000', 'consum', 0.0215, 'lps'),
	(429914, 124, '2015-03-01 00:45:20.000000', 'consum', 0.0231, 'lps'),
	(429915, 124, '2015-03-01 00:45:21.000000', 'consum', 0.0224, 'lps'),
	(429916, 124, '2015-03-01 00:45:22.000000', 'consum', 0.0216, 'lps'),
	(429917, 124, '2015-03-01 00:45:23.000000', 'consum', 0.0224, 'lps'),
	(429918, 124, '2015-03-01 00:45:24.000000', 'consum', 0.0211, 'lps'),
	(429919, 124, '2015-03-01 00:45:25.000000', 'consum', 0.0227, 'lps'),
	(429920, 124, '2015-03-01 00:45:26.000000', 'consum', 0.0215, 'lps'),
	(429921, 124, '2015-03-01 00:45:27.000000', 'consum', 0.0211, 'lps'),
	(429922, 124, '2015-03-01 00:45:28.000000', 'consum', 0.0224, 'lps'),
	(429923, 124, '2015-03-01 00:45:29.000000', 'consum', 0.0226, 'lps'),
	(429924, 124, '2015-03-01 00:45:30.000000', 'consum', 0.0222, 'lps'),
	(429925, 124, '2015-03-01 00:45:31.000000', 'consum', 0.0221, 'lps'),
	(429926, 124, '2015-03-01 00:45:32.000000', 'consum', 0.0233, 'lps'),
	(429927, 124, '2015-03-01 00:45:33.000000', 'consum', 0.0211, 'lps'),
	(429928, 124, '2015-03-01 00:45:34.000000', 'consum', 0.0226, 'lps'),
	(429929, 124, '2015-03-01 00:45:35.000000', 'consum', 0.0235, 'lps'),
	(429930, 124, '2015-03-01 00:45:36.000000', 'consum', 0.0210, 'lps'),
	(429931, 124, '2015-03-01 00:45:37.000000', 'consum', 0.0215, 'lps'),
	(429932, 124, '2015-03-01 00:45:38.000000', 'consum', 0.0234, 'lps'),
	(429933, 124, '2015-03-01 00:45:39.000000', 'consum', 0.0212, 'lps'),
	(429934, 124, '2015-03-01 00:45:40.000000', 'consum', 0.0226, 'lps'),
	(429935, 124, '2015-03-01 00:45:41.000000', 'consum', 0.0234, 'lps'),
	(429936, 124, '2015-03-01 00:45:42.000000', 'consum', 0.0231, 'lps'),
	(429937, 124, '2015-03-01 00:45:43.000000', 'consum', 0.0215, 'lps'),
	(429938, 124, '2015-03-01 00:45:44.000000', 'consum', 0.0226, 'lps'),
	(429939, 124, '2015-03-01 00:45:45.000000', 'consum', 0.0223, 'lps'),
	(429940, 124, '2015-03-01 00:45:46.000000', 'consum', 0.0226, 'lps'),
	(429941, 124, '2015-03-01 00:45:47.000000', 'consum', 0.0226, 'lps'),
	(429942, 124, '2015-03-01 00:45:48.000000', 'consum', 0.0215, 'lps'),
	(429943, 124, '2015-03-01 00:45:49.000000', 'consum', 0.0214, 'lps'),
	(429944, 124, '2015-03-01 00:45:50.000000', 'consum', 0.0217, 'lps'),
	(429945, 124, '2015-03-01 00:45:51.000000', 'consum', 0.0233, 'lps'),
	(429946, 124, '2015-03-01 00:45:52.000000', 'consum', 0.0227, 'lps'),
	(429947, 124, '2015-03-01 00:45:53.000000', 'consum', 0.0226, 'lps'),
	(429948, 124, '2015-03-01 00:45:54.000000', 'consum', 0.0212, 'lps'),
	(429949, 124, '2015-03-01 00:45:55.000000', 'consum', 0.0224, 'lps'),
	(429950, 124, '2015-03-01 00:45:56.000000', 'consum', 0.0224, 'lps'),
	(429951, 124, '2015-03-01 00:45:57.000000', 'consum', 0.0214, 'lps'),
	(429952, 124, '2015-03-01 00:45:58.000000', 'consum', 0.0214, 'lps'),
	(429953, 124, '2015-03-01 00:45:59.000000', 'consum', 0.0217, 'lps'),
	(429954, 124, '2015-03-01 00:46:00.000000', 'consum', 0.0233, 'lps'),
	(429955, 124, '2015-03-01 00:46:01.000000', 'consum', 0.0228, 'lps'),
	(429956, 124, '2015-03-01 00:46:02.000000', 'consum', 0.0233, 'lps'),
	(429957, 124, '2015-03-01 00:46:03.000000', 'consum', 0.0218, 'lps'),
	(429958, 124, '2015-03-01 00:46:04.000000', 'consum', 0.0235, 'lps'),
	(429959, 124, '2015-03-01 00:46:05.000000', 'consum', 0.0231, 'lps'),
	(429960, 124, '2015-03-01 00:46:06.000000', 'consum', 0.0216, 'lps'),
	(429961, 124, '2015-03-01 00:46:07.000000', 'consum', 0.0231, 'lps'),
	(429962, 124, '2015-03-01 00:46:08.000000', 'consum', 0.0218, 'lps'),
	(429963, 124, '2015-03-01 00:46:09.000000', 'consum', 0.0212, 'lps'),
	(429964, 124, '2015-03-01 00:46:10.000000', 'consum', 0.0225, 'lps'),
	(429965, 124, '2015-03-01 00:46:11.000000', 'consum', 0.0228, 'lps'),
	(429966, 124, '2015-03-01 00:46:12.000000', 'consum', 0.0227, 'lps'),
	(429967, 124, '2015-03-01 00:46:13.000000', 'consum', 0.0215, 'lps'),
	(429968, 124, '2015-03-01 00:46:14.000000', 'consum', 0.0210, 'lps'),
	(429969, 124, '2015-03-01 00:46:15.000000', 'consum', 0.0222, 'lps'),
	(429970, 124, '2015-03-01 00:46:16.000000', 'consum', 0.0221, 'lps'),
	(429971, 124, '2015-03-01 00:46:17.000000', 'consum', 0.0228, 'lps'),
	(429972, 124, '2015-03-01 00:46:18.000000', 'consum', 0.0216, 'lps'),
	(429973, 124, '2015-03-01 00:46:19.000000', 'consum', 0.0210, 'lps'),
	(429974, 124, '2015-03-01 00:46:20.000000', 'consum', 0.0222, 'lps'),
	(429975, 124, '2015-03-01 00:46:21.000000', 'consum', 0.0216, 'lps'),
	(429976, 124, '2015-03-01 00:46:22.000000', 'consum', 0.0233, 'lps'),
	(429977, 124, '2015-03-01 00:46:23.000000', 'consum', 0.0228, 'lps'),
	(429978, 124, '2015-03-01 00:46:24.000000', 'consum', 0.0233, 'lps'),
	(429979, 124, '2015-03-01 00:46:25.000000', 'consum', 0.0217, 'lps'),
	(429980, 124, '2015-03-01 00:46:26.000000', 'consum', 0.0229, 'lps'),
	(429981, 124, '2015-03-01 00:46:27.000000', 'consum', 0.0235, 'lps'),
	(429982, 124, '2015-03-01 00:46:28.000000', 'consum', 0.0224, 'lps'),
	(429983, 124, '2015-03-01 00:46:29.000000', 'consum', 0.0231, 'lps'),
	(429984, 124, '2015-03-01 00:46:30.000000', 'consum', 0.0224, 'lps'),
	(429985, 124, '2015-03-01 00:46:31.000000', 'consum', 0.0218, 'lps'),
	(429986, 124, '2015-03-01 00:46:32.000000', 'consum', 0.0232, 'lps'),
	(429987, 124, '2015-03-01 00:46:33.000000', 'consum', 0.0219, 'lps'),
	(429988, 124, '2015-03-01 00:46:34.000000', 'consum', 0.0217, 'lps'),
	(429989, 124, '2015-03-01 00:46:35.000000', 'consum', 0.0219, 'lps'),
	(429990, 124, '2015-03-01 00:46:36.000000', 'consum', 0.0234, 'lps'),
	(429991, 124, '2015-03-01 00:46:37.000000', 'consum', 0.0226, 'lps'),
	(429992, 124, '2015-03-01 00:46:38.000000', 'consum', 0.0217, 'lps'),
	(429993, 124, '2015-03-01 00:46:39.000000', 'consum', 0.0226, 'lps'),
	(429994, 124, '2015-03-01 00:46:40.000000', 'consum', 0.0214, 'lps'),
	(429995, 124, '2015-03-01 00:46:41.000000', 'consum', 0.0211, 'lps'),
	(429996, 124, '2015-03-01 00:46:42.000000', 'consum', 0.0229, 'lps'),
	(429997, 124, '2015-03-01 00:46:43.000000', 'consum', 0.0224, 'lps'),
	(429998, 124, '2015-03-01 00:46:44.000000', 'consum', 0.0226, 'lps'),
	(429999, 124, '2015-03-01 00:46:45.000000', 'consum', 0.0219, 'lps'),
	(430000, 124, '2015-03-01 00:46:46.000000', 'consum', 0.0210, 'lps'),
	(430001, 124, '2015-03-01 00:46:47.000000', 'consum', 0.0234, 'lps'),
	(430002, 124, '2015-03-01 00:46:48.000000', 'consum', 0.0227, 'lps'),
	(430003, 124, '2015-03-01 00:46:49.000000', 'consum', 0.0225, 'lps'),
	(430004, 124, '2015-03-01 00:46:50.000000', 'consum', 0.0233, 'lps'),
	(430005, 124, '2015-03-01 00:46:51.000000', 'consum', 0.0228, 'lps'),
	(430006, 124, '2015-03-01 00:46:52.000000', 'consum', 0.0232, 'lps'),
	(430007, 124, '2015-03-01 00:46:53.000000', 'consum', 0.0216, 'lps'),
	(430008, 124, '2015-03-01 00:46:54.000000', 'consum', 0.0225, 'lps'),
	(430009, 124, '2015-03-01 00:46:55.000000', 'consum', 0.0216, 'lps'),
	(430010, 124, '2015-03-01 00:46:56.000000', 'consum', 0.0219, 'lps'),
	(430011, 124, '2015-03-01 00:46:57.000000', 'consum', 0.0214, 'lps'),
	(430012, 124, '2015-03-01 00:46:58.000000', 'consum', 0.0231, 'lps'),
	(430013, 124, '2015-03-01 00:46:59.000000', 'consum', 0.0223, 'lps'),
	(430014, 124, '2015-03-01 00:47:00.000000', 'consum', 0.0215, 'lps'),
	(430015, 124, '2015-03-01 00:47:01.000000', 'consum', 0.0220, 'lps'),
	(430016, 124, '2015-03-01 00:47:02.000000', 'consum', 0.0222, 'lps'),
	(430017, 124, '2015-03-01 00:47:03.000000', 'consum', 0.0214, 'lps'),
	(430018, 124, '2015-03-01 00:47:04.000000', 'consum', 0.0219, 'lps'),
	(430019, 124, '2015-03-01 00:47:05.000000', 'consum', 0.0217, 'lps'),
	(430020, 124, '2015-03-01 00:47:06.000000', 'consum', 0.0218, 'lps'),
	(430021, 124, '2015-03-01 00:47:07.000000', 'consum', 0.0233, 'lps'),
	(430022, 124, '2015-03-01 00:47:08.000000', 'consum', 0.0220, 'lps'),
	(430023, 124, '2015-03-01 00:47:09.000000', 'consum', 0.0218, 'lps'),
	(430024, 124, '2015-03-01 00:47:10.000000', 'consum', 0.0223, 'lps'),
	(430025, 124, '2015-03-01 00:47:11.000000', 'consum', 0.0222, 'lps'),
	(430026, 124, '2015-03-01 00:47:12.000000', 'consum', 0.0234, 'lps'),
	(430027, 124, '2015-03-01 00:47:13.000000', 'consum', 0.0218, 'lps'),
	(430028, 124, '2015-03-01 00:47:14.000000', 'consum', 0.0227, 'lps'),
	(430029, 124, '2015-03-01 00:47:15.000000', 'consum', 0.0222, 'lps'),
	(430030, 124, '2015-03-01 00:47:16.000000', 'consum', 0.0220, 'lps'),
	(430031, 124, '2015-03-01 00:47:17.000000', 'consum', 0.0226, 'lps'),
	(430032, 124, '2015-03-01 00:47:18.000000', 'consum', 0.0232, 'lps'),
	(430033, 124, '2015-03-01 00:47:19.000000', 'consum', 0.0219, 'lps'),
	(430034, 124, '2015-03-01 00:47:20.000000', 'consum', 0.0219, 'lps'),
	(430035, 124, '2015-03-01 00:47:21.000000', 'consum', 0.0226, 'lps'),
	(430036, 124, '2015-03-01 00:47:22.000000', 'consum', 0.0213, 'lps'),
	(430037, 124, '2015-03-01 00:47:23.000000', 'consum', 0.0227, 'lps'),
	(430038, 124, '2015-03-01 00:47:24.000000', 'consum', 0.0210, 'lps'),
	(430039, 124, '2015-03-01 00:47:25.000000', 'consum', 0.0210, 'lps'),
	(430040, 124, '2015-03-01 00:47:26.000000', 'consum', 0.0211, 'lps'),
	(430041, 124, '2015-03-01 00:47:27.000000', 'consum', 0.0214, 'lps'),
	(430042, 124, '2015-03-01 00:47:28.000000', 'consum', 0.0230, 'lps'),
	(430043, 124, '2015-03-01 00:47:29.000000', 'consum', 0.0219, 'lps'),
	(430044, 124, '2015-03-01 00:47:30.000000', 'consum', 0.0222, 'lps'),
	(430045, 124, '2015-03-01 00:47:31.000000', 'consum', 0.0217, 'lps'),
	(430046, 124, '2015-03-01 00:47:32.000000', 'consum', 0.0210, 'lps'),
	(430047, 124, '2015-03-01 00:47:33.000000', 'consum', 0.0216, 'lps'),
	(430048, 124, '2015-03-01 00:47:34.000000', 'consum', 0.0214, 'lps'),
	(430049, 124, '2015-03-01 00:47:35.000000', 'consum', 0.0211, 'lps'),
	(430050, 124, '2015-03-01 00:47:36.000000', 'consum', 0.0231, 'lps'),
	(430051, 124, '2015-03-01 00:47:37.000000', 'consum', 0.0210, 'lps'),
	(430052, 124, '2015-03-01 00:47:38.000000', 'consum', 0.0224, 'lps'),
	(430053, 124, '2015-03-01 00:47:39.000000', 'consum', 0.0229, 'lps'),
	(430054, 124, '2015-03-01 00:47:40.000000', 'consum', 0.0211, 'lps'),
	(430055, 124, '2015-03-01 00:47:41.000000', 'consum', 0.0235, 'lps'),
	(430056, 124, '2015-03-01 00:47:42.000000', 'consum', 0.0230, 'lps'),
	(430057, 124, '2015-03-01 00:47:43.000000', 'consum', 0.0234, 'lps'),
	(430058, 124, '2015-03-01 00:47:44.000000', 'consum', 0.0219, 'lps'),
	(430059, 124, '2015-03-01 00:47:45.000000', 'consum', 0.0235, 'lps'),
	(430060, 124, '2015-03-01 00:47:46.000000', 'consum', 0.0230, 'lps'),
	(430061, 124, '2015-03-01 00:47:47.000000', 'consum', 0.0210, 'lps'),
	(430062, 124, '2015-03-01 00:47:48.000000', 'consum', 0.0227, 'lps'),
	(430063, 124, '2015-03-01 00:47:49.000000', 'consum', 0.0219, 'lps'),
	(430064, 124, '2015-03-01 00:47:50.000000', 'consum', 0.0230, 'lps'),
	(430065, 124, '2015-03-01 00:47:51.000000', 'consum', 0.0233, 'lps'),
	(430066, 124, '2015-03-01 00:47:52.000000', 'consum', 0.0212, 'lps'),
	(430067, 124, '2015-03-01 00:47:53.000000', 'consum', 0.0232, 'lps'),
	(430068, 124, '2015-03-01 00:47:54.000000', 'consum', 0.0234, 'lps'),
	(430069, 124, '2015-03-01 00:47:55.000000', 'consum', 0.0214, 'lps'),
	(430070, 124, '2015-03-01 00:47:56.000000', 'consum', 0.0211, 'lps'),
	(430071, 124, '2015-03-01 00:47:57.000000', 'consum', 0.0229, 'lps'),
	(430072, 124, '2015-03-01 00:47:58.000000', 'consum', 0.0225, 'lps'),
	(430073, 124, '2015-03-01 00:47:59.000000', 'consum', 0.0227, 'lps'),
	(430074, 124, '2015-03-01 00:48:00.000000', 'consum', 0.0227, 'lps'),
	(430075, 124, '2015-03-01 00:48:01.000000', 'consum', 0.0217, 'lps'),
	(430076, 124, '2015-03-01 00:48:02.000000', 'consum', 0.0219, 'lps'),
	(430077, 124, '2015-03-01 00:48:03.000000', 'consum', 0.0210, 'lps'),
	(430078, 124, '2015-03-01 00:48:04.000000', 'consum', 0.0210, 'lps'),
	(430079, 124, '2015-03-01 00:48:05.000000', 'consum', 0.0211, 'lps'),
	(430080, 124, '2015-03-01 00:48:06.000000', 'consum', 0.0214, 'lps'),
	(430081, 124, '2015-03-01 00:48:07.000000', 'consum', 0.0229, 'lps'),
	(430082, 124, '2015-03-01 00:48:08.000000', 'consum', 0.0216, 'lps'),
	(430083, 124, '2015-03-01 00:48:09.000000', 'consum', 0.0210, 'lps'),
	(430084, 124, '2015-03-01 00:48:10.000000', 'consum', 0.0217, 'lps'),
	(430085, 124, '2015-03-01 00:48:11.000000', 'consum', 0.0218, 'lps'),
	(430086, 124, '2015-03-01 00:48:12.000000', 'consum', 0.0231, 'lps'),
	(430087, 124, '2015-03-01 00:48:13.000000', 'consum', 0.0211, 'lps'),
	(430088, 124, '2015-03-01 00:48:14.000000', 'consum', 0.0233, 'lps'),
	(430089, 124, '2015-03-01 00:48:15.000000', 'consum', 0.0219, 'lps'),
	(430090, 124, '2015-03-01 00:48:16.000000', 'consum', 0.0212, 'lps'),
	(430091, 124, '2015-03-01 00:48:17.000000', 'consum', 0.0219, 'lps'),
	(430092, 124, '2015-03-01 00:48:18.000000', 'consum', 0.0225, 'lps'),
	(430093, 124, '2015-03-01 00:48:19.000000', 'consum', 0.0230, 'lps'),
	(430094, 124, '2015-03-01 00:48:20.000000', 'consum', 0.0216, 'lps'),
	(430095, 124, '2015-03-01 00:48:21.000000', 'consum', 0.0231, 'lps'),
	(430096, 124, '2015-03-01 00:48:22.000000', 'consum', 0.0222, 'lps'),
	(430097, 124, '2015-03-01 00:48:23.000000', 'consum', 0.0230, 'lps'),
	(430098, 124, '2015-03-01 00:48:24.000000', 'consum', 0.0225, 'lps'),
	(430099, 124, '2015-03-01 00:48:25.000000', 'consum', 0.0223, 'lps'),
	(430100, 124, '2015-03-01 00:48:26.000000', 'consum', 0.0232, 'lps'),
	(430101, 124, '2015-03-01 00:48:27.000000', 'consum', 0.0229, 'lps'),
	(430102, 124, '2015-03-01 00:48:28.000000', 'consum', 0.0213, 'lps'),
	(430103, 124, '2015-03-01 00:48:29.000000', 'consum', 0.0220, 'lps'),
	(430104, 124, '2015-03-01 00:48:30.000000', 'consum', 0.0228, 'lps'),
	(430105, 124, '2015-03-01 00:48:31.000000', 'consum', 0.0218, 'lps'),
	(430106, 124, '2015-03-01 00:48:32.000000', 'consum', 0.0224, 'lps'),
	(430107, 124, '2015-03-01 00:48:33.000000', 'consum', 0.0229, 'lps'),
	(430108, 124, '2015-03-01 00:48:34.000000', 'consum', 0.0212, 'lps'),
	(430109, 124, '2015-03-01 00:48:35.000000', 'consum', 0.0214, 'lps'),
	(430110, 124, '2015-03-01 00:48:36.000000', 'consum', 0.0224, 'lps'),
	(430111, 124, '2015-03-01 00:48:37.000000', 'consum', 0.0216, 'lps'),
	(430112, 124, '2015-03-01 00:48:38.000000', 'consum', 0.0225, 'lps'),
	(430113, 124, '2015-03-01 00:48:39.000000', 'consum', 0.0217, 'lps'),
	(430114, 124, '2015-03-01 00:48:40.000000', 'consum', 0.0226, 'lps'),
	(430115, 124, '2015-03-01 00:48:41.000000', 'consum', 0.0217, 'lps'),
	(430116, 124, '2015-03-01 00:48:42.000000', 'consum', 0.0225, 'lps'),
	(430117, 124, '2015-03-01 00:48:43.000000', 'consum', 0.0210, 'lps'),
	(430118, 124, '2015-03-01 00:48:44.000000', 'consum', 0.0217, 'lps'),
	(430119, 124, '2015-03-01 00:48:45.000000', 'consum', 0.0222, 'lps'),
	(430120, 124, '2015-03-01 00:48:46.000000', 'consum', 0.0223, 'lps'),
	(430121, 124, '2015-03-01 00:48:47.000000', 'consum', 0.0213, 'lps'),
	(430122, 124, '2015-03-01 00:48:48.000000', 'consum', 0.0211, 'lps'),
	(430123, 124, '2015-03-01 00:48:49.000000', 'consum', 0.0233, 'lps'),
	(430124, 124, '2015-03-01 00:48:50.000000', 'consum', 0.0218, 'lps'),
	(430125, 124, '2015-03-01 00:48:51.000000', 'consum', 0.0235, 'lps'),
	(430126, 124, '2015-03-01 00:48:52.000000', 'consum', 0.0231, 'lps'),
	(430127, 124, '2015-03-01 00:48:53.000000', 'consum', 0.0215, 'lps'),
	(430128, 124, '2015-03-01 00:48:54.000000', 'consum', 0.0225, 'lps'),
	(430129, 124, '2015-03-01 00:48:55.000000', 'consum', 0.0217, 'lps'),
	(430130, 124, '2015-03-01 00:48:56.000000', 'consum', 0.0225, 'lps'),
	(430131, 124, '2015-03-01 00:48:57.000000', 'consum', 0.0216, 'lps'),
	(430132, 124, '2015-03-01 00:48:58.000000', 'consum', 0.0221, 'lps'),
	(430133, 124, '2015-03-01 00:48:59.000000', 'consum', 0.0222, 'lps'),
	(430134, 124, '2015-03-01 00:49:00.000000', 'consum', 0.0211, 'lps'),
	(430135, 124, '2015-03-01 00:49:01.000000', 'consum', 0.0233, 'lps'),
	(430136, 124, '2015-03-01 00:49:02.000000', 'consum', 0.0218, 'lps'),
	(430137, 124, '2015-03-01 00:49:03.000000', 'consum', 0.0234, 'lps'),
	(430138, 124, '2015-03-01 00:49:04.000000', 'consum', 0.0227, 'lps'),
	(430139, 124, '2015-03-01 00:49:05.000000', 'consum', 0.0223, 'lps'),
	(430140, 124, '2015-03-01 00:49:06.000000', 'consum', 0.0225, 'lps'),
	(430141, 124, '2015-03-01 00:49:07.000000', 'consum', 0.0223, 'lps'),
	(430142, 124, '2015-03-01 00:49:08.000000', 'consum', 0.0227, 'lps'),
	(430143, 124, '2015-03-01 00:49:09.000000', 'consum', 0.0232, 'lps'),
	(430144, 124, '2015-03-01 00:49:10.000000', 'consum', 0.0218, 'lps'),
	(430145, 124, '2015-03-01 00:49:11.000000', 'consum', 0.0210, 'lps'),
	(430146, 124, '2015-03-01 00:49:12.000000', 'consum', 0.0212, 'lps'),
	(430147, 124, '2015-03-01 00:49:13.000000', 'consum', 0.0220, 'lps'),
	(430148, 124, '2015-03-01 00:49:14.000000', 'consum', 0.0230, 'lps'),
	(430149, 124, '2015-03-01 00:49:15.000000', 'consum', 0.0228, 'lps'),
	(430150, 124, '2015-03-01 00:49:16.000000', 'consum', 0.0214, 'lps'),
	(430151, 124, '2015-03-01 00:49:17.000000', 'consum', 0.0230, 'lps'),
	(430152, 124, '2015-03-01 00:49:18.000000', 'consum', 0.0220, 'lps'),
	(430153, 124, '2015-03-01 00:49:19.000000', 'consum', 0.0226, 'lps'),
	(430154, 124, '2015-03-01 00:49:20.000000', 'consum', 0.0234, 'lps'),
	(430155, 124, '2015-03-01 00:49:21.000000', 'consum', 0.0229, 'lps'),
	(430156, 124, '2015-03-01 00:49:22.000000', 'consum', 0.0210, 'lps'),
	(430157, 124, '2015-03-01 00:49:23.000000', 'consum', 0.0233, 'lps'),
	(430158, 124, '2015-03-01 00:49:24.000000', 'consum', 0.0219, 'lps'),
	(430159, 124, '2015-03-01 00:49:25.000000', 'consum', 0.0214, 'lps'),
	(430160, 124, '2015-03-01 00:49:26.000000', 'consum', 0.0228, 'lps'),
	(430161, 124, '2015-03-01 00:49:27.000000', 'consum', 0.0211, 'lps'),
	(430162, 124, '2015-03-01 00:49:28.000000', 'consum', 0.0215, 'lps'),
	(430163, 124, '2015-03-01 00:49:29.000000', 'consum', 0.0230, 'lps'),
	(430164, 124, '2015-03-01 00:49:30.000000', 'consum', 0.0219, 'lps'),
	(430165, 124, '2015-03-01 00:49:31.000000', 'consum', 0.0222, 'lps'),
	(430166, 124, '2015-03-01 00:49:32.000000', 'consum', 0.0215, 'lps'),
	(430167, 124, '2015-03-01 00:49:33.000000', 'consum', 0.0229, 'lps'),
	(430168, 124, '2015-03-01 00:49:34.000000', 'consum', 0.0211, 'lps'),
	(430169, 124, '2015-03-01 00:49:35.000000', 'consum', 0.0234, 'lps'),
	(430170, 124, '2015-03-01 00:49:36.000000', 'consum', 0.0227, 'lps'),
	(430171, 124, '2015-03-01 00:49:37.000000', 'consum', 0.0223, 'lps'),
	(430172, 124, '2015-03-01 00:49:38.000000', 'consum', 0.0225, 'lps'),
	(430173, 124, '2015-03-01 00:49:39.000000', 'consum', 0.0219, 'lps'),
	(430174, 124, '2015-03-01 00:49:40.000000', 'consum', 0.0213, 'lps'),
	(430175, 124, '2015-03-01 00:49:41.000000', 'consum', 0.0222, 'lps'),
	(430176, 124, '2015-03-01 00:49:42.000000', 'consum', 0.0211, 'lps'),
	(430177, 124, '2015-03-01 00:49:43.000000', 'consum', 0.0229, 'lps'),
	(430178, 124, '2015-03-01 00:49:44.000000', 'consum', 0.0228, 'lps'),
	(430179, 124, '2015-03-01 00:49:45.000000', 'consum', 0.0216, 'lps'),
	(430180, 124, '2015-03-01 00:49:46.000000', 'consum', 0.0211, 'lps'),
	(430181, 124, '2015-03-01 00:49:47.000000', 'consum', 0.0226, 'lps'),
	(430182, 124, '2015-03-01 00:49:48.000000', 'consum', 0.0234, 'lps'),
	(430183, 124, '2015-03-01 00:49:49.000000', 'consum', 0.0232, 'lps'),
	(430184, 124, '2015-03-01 00:49:50.000000', 'consum', 0.0223, 'lps'),
	(430185, 124, '2015-03-01 00:49:51.000000', 'consum', 0.0210, 'lps'),
	(430186, 124, '2015-03-01 00:49:52.000000', 'consum', 0.0224, 'lps'),
	(430187, 124, '2015-03-01 00:49:53.000000', 'consum', 0.0228, 'lps'),
	(430188, 124, '2015-03-01 00:49:54.000000', 'consum', 0.0231, 'lps'),
	(430189, 124, '2015-03-01 00:49:55.000000', 'consum', 0.0235, 'lps'),
	(430190, 124, '2015-03-01 00:49:56.000000', 'consum', 0.0222, 'lps'),
	(430191, 124, '2015-03-01 00:49:57.000000', 'consum', 0.0221, 'lps'),
	(430192, 124, '2015-03-01 00:49:58.000000', 'consum', 0.0229, 'lps'),
	(430193, 124, '2015-03-01 00:49:59.000000', 'consum', 0.0221, 'lps'),
	(430194, 124, '2015-03-01 00:50:00.000000', 'consum', 0.0235, 'lps'),
	(430195, 124, '2015-03-01 00:50:01.000000', 'consum', 0.0224, 'lps'),
	(430196, 124, '2015-03-01 00:50:02.000000', 'consum', 0.0233, 'lps'),
	(430197, 124, '2015-03-01 00:50:03.000000', 'consum', 0.0229, 'lps'),
	(430198, 124, '2015-03-01 00:50:04.000000', 'consum', 0.0211, 'lps'),
	(430199, 124, '2015-03-01 00:50:05.000000', 'consum', 0.0212, 'lps'),
	(430200, 124, '2015-03-01 00:50:06.000000', 'consum', 0.0217, 'lps'),
	(430201, 124, '2015-03-01 00:50:07.000000', 'consum', 0.0215, 'lps'),
	(430202, 124, '2015-03-01 00:50:08.000000', 'consum', 0.0214, 'lps'),
	(430203, 124, '2015-03-01 00:50:09.000000', 'consum', 0.0214, 'lps'),
	(430204, 124, '2015-03-01 00:50:10.000000', 'consum', 0.0219, 'lps'),
	(430205, 124, '2015-03-01 00:50:11.000000', 'consum', 0.0219, 'lps'),
	(430206, 124, '2015-03-01 00:50:12.000000', 'consum', 0.0227, 'lps'),
	(430207, 124, '2015-03-01 00:50:13.000000', 'consum', 0.0218, 'lps'),
	(430208, 124, '2015-03-01 00:50:14.000000', 'consum', 0.0223, 'lps'),
	(430209, 124, '2015-03-01 00:50:15.000000', 'consum', 0.0228, 'lps'),
	(430210, 124, '2015-03-01 00:50:16.000000', 'consum', 0.0210, 'lps'),
	(430211, 124, '2015-03-01 00:50:17.000000', 'consum', 0.0235, 'lps'),
	(430212, 124, '2015-03-01 00:50:18.000000', 'consum', 0.0230, 'lps'),
	(430213, 124, '2015-03-01 00:50:19.000000', 'consum', 0.0210, 'lps'),
	(430214, 124, '2015-03-01 00:50:20.000000', 'consum', 0.0230, 'lps'),
	(430215, 124, '2015-03-01 00:50:21.000000', 'consum', 0.0230, 'lps'),
	(430216, 124, '2015-03-01 00:50:22.000000', 'consum', 0.0227, 'lps'),
	(430217, 124, '2015-03-01 00:50:23.000000', 'consum', 0.0234, 'lps'),
	(430218, 124, '2015-03-01 00:50:24.000000', 'consum', 0.0228, 'lps'),
	(430219, 124, '2015-03-01 00:50:25.000000', 'consum', 0.0229, 'lps'),
	(430220, 124, '2015-03-01 00:50:26.000000', 'consum', 0.0225, 'lps'),
	(430221, 124, '2015-03-01 00:50:27.000000', 'consum', 0.0229, 'lps'),
	(430222, 124, '2015-03-01 00:50:28.000000', 'consum', 0.0210, 'lps'),
	(430223, 124, '2015-03-01 00:50:29.000000', 'consum', 0.0231, 'lps'),
	(430224, 124, '2015-03-01 00:50:30.000000', 'consum', 0.0212, 'lps'),
	(430225, 124, '2015-03-01 00:50:31.000000', 'consum', 0.0233, 'lps'),
	(430226, 124, '2015-03-01 00:50:32.000000', 'consum', 0.0217, 'lps'),
	(430227, 124, '2015-03-01 00:50:33.000000', 'consum', 0.0227, 'lps'),
	(430228, 124, '2015-03-01 00:50:34.000000', 'consum', 0.0222, 'lps'),
	(430229, 124, '2015-03-01 00:50:35.000000', 'consum', 0.0221, 'lps'),
	(430230, 124, '2015-03-01 00:50:36.000000', 'consum', 0.0230, 'lps'),
	(430231, 124, '2015-03-01 00:50:37.000000', 'consum', 0.0227, 'lps'),
	(430232, 124, '2015-03-01 00:50:38.000000', 'consum', 0.0233, 'lps'),
	(430233, 124, '2015-03-01 00:50:39.000000', 'consum', 0.0222, 'lps'),
	(430234, 124, '2015-03-01 00:50:40.000000', 'consum', 0.0228, 'lps'),
	(430235, 124, '2015-03-01 00:50:41.000000', 'consum', 0.0211, 'lps'),
	(430236, 124, '2015-03-01 00:50:42.000000', 'consum', 0.0216, 'lps'),
	(430237, 124, '2015-03-01 00:50:43.000000', 'consum', 0.0211, 'lps'),
	(430238, 124, '2015-03-01 00:50:44.000000', 'consum', 0.0225, 'lps'),
	(430239, 124, '2015-03-01 00:50:45.000000', 'consum', 0.0228, 'lps'),
	(430240, 124, '2015-03-01 00:50:46.000000', 'consum', 0.0229, 'lps'),
	(430241, 124, '2015-03-01 00:50:47.000000', 'consum', 0.0228, 'lps'),
	(430242, 124, '2015-03-01 00:50:48.000000', 'consum', 0.0217, 'lps'),
	(430243, 124, '2015-03-01 00:50:49.000000', 'consum', 0.0216, 'lps'),
	(430244, 124, '2015-03-01 00:50:50.000000', 'consum', 0.0221, 'lps'),
	(430245, 124, '2015-03-01 00:50:51.000000', 'consum', 0.0223, 'lps'),
	(430246, 124, '2015-03-01 00:50:52.000000', 'consum', 0.0213, 'lps'),
	(430247, 124, '2015-03-01 00:50:53.000000', 'consum', 0.0216, 'lps'),
	(430248, 124, '2015-03-01 00:50:54.000000', 'consum', 0.0228, 'lps'),
	(430249, 124, '2015-03-01 00:50:55.000000', 'consum', 0.0233, 'lps'),
	(430250, 124, '2015-03-01 00:50:56.000000', 'consum', 0.0220, 'lps'),
	(430251, 124, '2015-03-01 00:50:57.000000', 'consum', 0.0216, 'lps'),
	(430252, 124, '2015-03-01 00:50:58.000000', 'consum', 0.0212, 'lps'),
	(430253, 124, '2015-03-01 00:50:59.000000', 'consum', 0.0227, 'lps'),
	(430254, 124, '2015-03-01 00:51:00.000000', 'consum', 0.0214, 'lps'),
	(430255, 124, '2015-03-01 00:51:01.000000', 'consum', 0.0230, 'lps'),
	(430256, 124, '2015-03-01 00:51:02.000000', 'consum', 0.0223, 'lps'),
	(430257, 124, '2015-03-01 00:51:03.000000', 'consum', 0.0212, 'lps'),
	(430258, 124, '2015-03-01 00:51:04.000000', 'consum', 0.0235, 'lps'),
	(430259, 124, '2015-03-01 00:51:05.000000', 'consum', 0.0225, 'lps'),
	(430260, 124, '2015-03-01 00:51:06.000000', 'consum', 0.0235, 'lps'),
	(430261, 124, '2015-03-01 00:51:07.000000', 'consum', 0.0216, 'lps'),
	(430262, 124, '2015-03-01 00:51:08.000000', 'consum', 0.0214, 'lps'),
	(430263, 124, '2015-03-01 00:51:09.000000', 'consum', 0.0214, 'lps'),
	(430264, 124, '2015-03-01 00:51:10.000000', 'consum', 0.0218, 'lps'),
	(430265, 124, '2015-03-01 00:51:11.000000', 'consum', 0.0212, 'lps'),
	(430266, 124, '2015-03-01 00:51:12.000000', 'consum', 0.0225, 'lps'),
	(430267, 124, '2015-03-01 00:51:13.000000', 'consum', 0.0226, 'lps'),
	(430268, 124, '2015-03-01 00:51:14.000000', 'consum', 0.0219, 'lps'),
	(430269, 124, '2015-03-01 00:51:15.000000', 'consum', 0.0233, 'lps'),
	(430270, 124, '2015-03-01 00:51:16.000000', 'consum', 0.0220, 'lps'),
	(430271, 124, '2015-03-01 00:51:17.000000', 'consum', 0.0218, 'lps'),
	(430272, 124, '2015-03-01 00:51:18.000000', 'consum', 0.0221, 'lps'),
	(430273, 124, '2015-03-01 00:51:19.000000', 'consum', 0.0215, 'lps'),
	(430274, 124, '2015-03-01 00:51:20.000000', 'consum', 0.0228, 'lps'),
	(430275, 124, '2015-03-01 00:51:21.000000', 'consum', 0.0234, 'lps'),
	(430276, 124, '2015-03-01 00:51:22.000000', 'consum', 0.0224, 'lps'),
	(430277, 124, '2015-03-01 00:51:23.000000', 'consum', 0.0210, 'lps'),
	(430278, 124, '2015-03-01 00:51:24.000000', 'consum', 0.0221, 'lps'),
	(430279, 124, '2015-03-01 00:51:25.000000', 'consum', 0.0213, 'lps'),
	(430280, 124, '2015-03-01 00:51:26.000000', 'consum', 0.0219, 'lps'),
	(430281, 124, '2015-03-01 00:51:27.000000', 'consum', 0.0219, 'lps'),
	(430282, 124, '2015-03-01 00:51:28.000000', 'consum', 0.0231, 'lps'),
	(430283, 124, '2015-03-01 00:51:29.000000', 'consum', 0.0210, 'lps'),
	(430284, 124, '2015-03-01 00:51:30.000000', 'consum', 0.0224, 'lps'),
	(430285, 124, '2015-03-01 00:51:31.000000', 'consum', 0.0227, 'lps'),
	(430286, 124, '2015-03-01 00:51:32.000000', 'consum', 0.0230, 'lps'),
	(430287, 124, '2015-03-01 00:51:33.000000', 'consum', 0.0234, 'lps'),
	(430288, 124, '2015-03-01 00:51:34.000000', 'consum', 0.0216, 'lps'),
	(430289, 124, '2015-03-01 00:51:35.000000', 'consum', 0.0223, 'lps'),
	(430290, 124, '2015-03-01 00:51:36.000000', 'consum', 0.0231, 'lps'),
	(430291, 124, '2015-03-01 00:51:37.000000', 'consum', 0.0223, 'lps'),
	(430292, 124, '2015-03-01 00:51:38.000000', 'consum', 0.0213, 'lps'),
	(430293, 124, '2015-03-01 00:51:39.000000', 'consum', 0.0212, 'lps'),
	(430294, 124, '2015-03-01 00:51:40.000000', 'consum', 0.0211, 'lps'),
	(430295, 124, '2015-03-01 00:51:41.000000', 'consum', 0.0212, 'lps'),
	(430296, 124, '2015-03-01 00:51:42.000000', 'consum', 0.0215, 'lps'),
	(430297, 124, '2015-03-01 00:51:43.000000', 'consum', 0.0229, 'lps'),
	(430298, 124, '2015-03-01 00:51:44.000000', 'consum', 0.0212, 'lps'),
	(430299, 124, '2015-03-01 00:51:45.000000', 'consum', 0.0216, 'lps'),
	(430300, 124, '2015-03-01 00:51:46.000000', 'consum', 0.0210, 'lps'),
	(430301, 124, '2015-03-01 00:51:47.000000', 'consum', 0.0220, 'lps'),
	(430302, 124, '2015-03-01 00:51:48.000000', 'consum', 0.0231, 'lps'),
	(430303, 124, '2015-03-01 00:51:49.000000', 'consum', 0.0210, 'lps'),
	(430304, 124, '2015-03-01 00:51:50.000000', 'consum', 0.0227, 'lps'),
	(430305, 124, '2015-03-01 00:51:51.000000', 'consum', 0.0214, 'lps'),
	(430306, 124, '2015-03-01 00:51:52.000000', 'consum', 0.0232, 'lps'),
	(430307, 124, '2015-03-01 00:51:53.000000', 'consum', 0.0230, 'lps'),
	(430308, 124, '2015-03-01 00:51:54.000000', 'consum', 0.0218, 'lps'),
	(430309, 124, '2015-03-01 00:51:55.000000', 'consum', 0.0217, 'lps'),
	(430310, 124, '2015-03-01 00:51:56.000000', 'consum', 0.0220, 'lps'),
	(430311, 124, '2015-03-01 00:51:57.000000', 'consum', 0.0215, 'lps'),
	(430312, 124, '2015-03-01 00:51:58.000000', 'consum', 0.0230, 'lps'),
	(430313, 124, '2015-03-01 00:51:59.000000', 'consum', 0.0217, 'lps'),
	(430314, 124, '2015-03-01 00:52:00.000000', 'consum', 0.0215, 'lps'),
	(430315, 124, '2015-03-01 00:52:01.000000', 'consum', 0.0211, 'lps'),
	(430316, 124, '2015-03-01 00:52:02.000000', 'consum', 0.0228, 'lps'),
	(430317, 124, '2015-03-01 00:52:03.000000', 'consum', 0.0218, 'lps'),
	(430318, 124, '2015-03-01 00:52:04.000000', 'consum', 0.0223, 'lps'),
	(430319, 124, '2015-03-01 00:52:05.000000', 'consum', 0.0227, 'lps'),
	(430320, 124, '2015-03-01 00:52:06.000000', 'consum', 0.0228, 'lps'),
	(430321, 124, '2015-03-01 00:52:07.000000', 'consum', 0.0226, 'lps'),
	(430322, 124, '2015-03-01 00:52:08.000000', 'consum', 0.0211, 'lps'),
	(430323, 124, '2015-03-01 00:52:09.000000', 'consum', 0.0217, 'lps'),
	(430324, 124, '2015-03-01 00:52:10.000000', 'consum', 0.0219, 'lps'),
	(430325, 124, '2015-03-01 00:52:11.000000', 'consum', 0.0235, 'lps'),
	(430326, 124, '2015-03-01 00:52:12.000000', 'consum', 0.0228, 'lps'),
	(430327, 124, '2015-03-01 00:52:13.000000', 'consum', 0.0225, 'lps'),
	(430328, 124, '2015-03-01 00:52:14.000000', 'consum', 0.0233, 'lps'),
	(430329, 124, '2015-03-01 00:52:15.000000', 'consum', 0.0228, 'lps'),
	(430330, 124, '2015-03-01 00:52:16.000000', 'consum', 0.0231, 'lps'),
	(430331, 124, '2015-03-01 00:52:17.000000', 'consum', 0.0211, 'lps'),
	(430332, 124, '2015-03-01 00:52:18.000000', 'consum', 0.0231, 'lps'),
	(430333, 124, '2015-03-01 00:52:19.000000', 'consum', 0.0235, 'lps'),
	(430334, 124, '2015-03-01 00:52:20.000000', 'consum', 0.0220, 'lps'),
	(430335, 124, '2015-03-01 00:52:21.000000', 'consum', 0.0213, 'lps'),
	(430336, 124, '2015-03-01 00:52:22.000000', 'consum', 0.0220, 'lps'),
	(430337, 124, '2015-03-01 00:52:23.000000', 'consum', 0.0227, 'lps'),
	(430338, 124, '2015-03-01 00:52:24.000000', 'consum', 0.0213, 'lps'),
	(430339, 124, '2015-03-01 00:52:25.000000', 'consum', 0.0227, 'lps'),
	(430340, 124, '2015-03-01 00:52:26.000000', 'consum', 0.0210, 'lps'),
	(430341, 124, '2015-03-01 00:52:27.000000', 'consum', 0.0210, 'lps'),
	(430342, 124, '2015-03-01 00:52:28.000000', 'consum', 0.0235, 'lps'),
	(430343, 124, '2015-03-01 00:52:29.000000', 'consum', 0.0234, 'lps'),
	(430344, 124, '2015-03-01 00:52:30.000000', 'consum', 0.0231, 'lps'),
	(430345, 124, '2015-03-01 00:52:31.000000', 'consum', 0.0214, 'lps'),
	(430346, 124, '2015-03-01 00:52:32.000000', 'consum', 0.0219, 'lps'),
	(430347, 124, '2015-03-01 00:52:33.000000', 'consum', 0.0220, 'lps'),
	(430348, 124, '2015-03-01 00:52:34.000000', 'consum', 0.0233, 'lps'),
	(430349, 124, '2015-03-01 00:52:35.000000', 'consum', 0.0219, 'lps'),
	(430350, 124, '2015-03-01 00:52:36.000000', 'consum', 0.0212, 'lps'),
	(430351, 124, '2015-03-01 00:52:37.000000', 'consum', 0.0220, 'lps'),
	(430352, 124, '2015-03-01 00:52:38.000000', 'consum', 0.0227, 'lps'),
	(430353, 124, '2015-03-01 00:52:39.000000', 'consum', 0.0212, 'lps'),
	(430354, 124, '2015-03-01 00:52:40.000000', 'consum', 0.0223, 'lps'),
	(430355, 124, '2015-03-01 00:52:41.000000', 'consum', 0.0219, 'lps'),
	(430356, 124, '2015-03-01 00:52:42.000000', 'consum', 0.0213, 'lps'),
	(430357, 124, '2015-03-01 00:52:43.000000', 'consum', 0.0228, 'lps'),
	(430358, 124, '2015-03-01 00:52:44.000000', 'consum', 0.0212, 'lps'),
	(430359, 124, '2015-03-01 00:52:45.000000', 'consum', 0.0217, 'lps'),
	(430360, 124, '2015-03-01 00:52:46.000000', 'consum', 0.0215, 'lps'),
	(430361, 124, '2015-03-01 00:52:47.000000', 'consum', 0.0212, 'lps'),
	(430362, 124, '2015-03-01 00:52:48.000000', 'consum', 0.0234, 'lps'),
	(430363, 124, '2015-03-01 00:52:49.000000', 'consum', 0.0219, 'lps'),
	(430364, 124, '2015-03-01 00:52:50.000000', 'consum', 0.0235, 'lps'),
	(430365, 124, '2015-03-01 00:52:51.000000', 'consum', 0.0231, 'lps'),
	(430366, 124, '2015-03-01 00:52:52.000000', 'consum', 0.0216, 'lps'),
	(430367, 124, '2015-03-01 00:52:53.000000', 'consum', 0.0228, 'lps'),
	(430368, 124, '2015-03-01 00:52:54.000000', 'consum', 0.0231, 'lps'),
	(430369, 124, '2015-03-01 00:52:55.000000', 'consum', 0.0234, 'lps'),
	(430370, 124, '2015-03-01 00:52:56.000000', 'consum', 0.0218, 'lps'),
	(430371, 124, '2015-03-01 00:52:57.000000', 'consum', 0.0228, 'lps'),
	(430372, 124, '2015-03-01 00:52:58.000000', 'consum', 0.0224, 'lps'),
	(430373, 124, '2015-03-01 00:52:59.000000', 'consum', 0.0227, 'lps'),
	(430374, 124, '2015-03-01 00:53:00.000000', 'consum', 0.0228, 'lps'),
	(430375, 124, '2015-03-01 00:53:01.000000', 'consum', 0.0226, 'lps'),
	(430376, 124, '2015-03-01 00:53:02.000000', 'consum', 0.0233, 'lps'),
	(430377, 124, '2015-03-01 00:53:03.000000', 'consum', 0.0225, 'lps'),
	(430378, 124, '2015-03-01 00:53:04.000000', 'consum', 0.0219, 'lps'),
	(430379, 124, '2015-03-01 00:53:05.000000', 'consum', 0.0235, 'lps'),
	(430380, 124, '2015-03-01 00:53:06.000000', 'consum', 0.0230, 'lps'),
	(430381, 124, '2015-03-01 00:53:07.000000', 'consum', 0.0234, 'lps'),
	(430382, 124, '2015-03-01 00:53:08.000000', 'consum', 0.0222, 'lps'),
	(430383, 124, '2015-03-01 00:53:09.000000', 'consum', 0.0221, 'lps'),
	(430384, 124, '2015-03-01 00:53:10.000000', 'consum', 0.0232, 'lps'),
	(430385, 124, '2015-03-01 00:53:11.000000', 'consum', 0.0235, 'lps'),
	(430386, 124, '2015-03-01 00:53:12.000000', 'consum', 0.0219, 'lps'),
	(430387, 124, '2015-03-01 00:53:13.000000', 'consum', 0.0233, 'lps'),
	(430388, 124, '2015-03-01 00:53:14.000000', 'consum', 0.0217, 'lps'),
	(430389, 124, '2015-03-01 00:53:15.000000', 'consum', 0.0231, 'lps'),
	(430390, 124, '2015-03-01 00:53:16.000000', 'consum', 0.0216, 'lps'),
	(430391, 124, '2015-03-01 00:53:17.000000', 'consum', 0.0229, 'lps'),
	(430392, 124, '2015-03-01 00:53:18.000000', 'consum', 0.0234, 'lps'),
	(430393, 124, '2015-03-01 00:53:19.000000', 'consum', 0.0223, 'lps'),
	(430394, 124, '2015-03-01 00:53:20.000000', 'consum', 0.0231, 'lps'),
	(430395, 124, '2015-03-01 00:53:21.000000', 'consum', 0.0225, 'lps'),
	(430396, 124, '2015-03-01 00:53:22.000000', 'consum', 0.0220, 'lps'),
	(430397, 124, '2015-03-01 00:53:23.000000', 'consum', 0.0217, 'lps'),
	(430398, 124, '2015-03-01 00:53:24.000000', 'consum', 0.0216, 'lps'),
	(430399, 124, '2015-03-01 00:53:25.000000', 'consum', 0.0217, 'lps'),
	(430400, 124, '2015-03-01 00:53:26.000000', 'consum', 0.0228, 'lps'),
	(430401, 124, '2015-03-01 00:53:27.000000', 'consum', 0.0228, 'lps'),
	(430402, 124, '2015-03-01 00:53:28.000000', 'consum', 0.0220, 'lps'),
	(430403, 124, '2015-03-01 00:53:29.000000', 'consum', 0.0233, 'lps'),
	(430404, 124, '2015-03-01 00:53:30.000000', 'consum', 0.0218, 'lps'),
	(430405, 124, '2015-03-01 00:53:31.000000', 'consum', 0.0233, 'lps'),
	(430406, 124, '2015-03-01 00:53:32.000000', 'consum', 0.0222, 'lps'),
	(430407, 124, '2015-03-01 00:53:33.000000', 'consum', 0.0229, 'lps'),
	(430408, 124, '2015-03-01 00:53:34.000000', 'consum', 0.0219, 'lps'),
	(430409, 124, '2015-03-01 00:53:35.000000', 'consum', 0.0222, 'lps'),
	(430410, 124, '2015-03-01 00:53:36.000000', 'consum', 0.0216, 'lps'),
	(430411, 124, '2015-03-01 00:53:37.000000', 'consum', 0.0233, 'lps'),
	(430412, 124, '2015-03-01 00:53:38.000000', 'consum', 0.0231, 'lps'),
	(430413, 124, '2015-03-01 00:53:39.000000', 'consum', 0.0219, 'lps'),
	(430414, 124, '2015-03-01 00:53:40.000000', 'consum', 0.0218, 'lps'),
	(430415, 124, '2015-03-01 00:53:41.000000', 'consum', 0.0223, 'lps'),
	(430416, 124, '2015-03-01 00:53:42.000000', 'consum', 0.0225, 'lps'),
	(430417, 124, '2015-03-01 00:53:43.000000', 'consum', 0.0223, 'lps'),
	(430418, 124, '2015-03-01 00:53:44.000000', 'consum', 0.0228, 'lps'),
	(430419, 124, '2015-03-01 00:53:45.000000', 'consum', 0.0235, 'lps'),
	(430420, 124, '2015-03-01 00:53:46.000000', 'consum', 0.0228, 'lps'),
	(430421, 124, '2015-03-01 00:53:47.000000', 'consum', 0.0229, 'lps'),
	(430422, 124, '2015-03-01 00:53:48.000000', 'consum', 0.0224, 'lps'),
	(430423, 124, '2015-03-01 00:53:49.000000', 'consum', 0.0225, 'lps'),
	(430424, 124, '2015-03-01 00:53:50.000000', 'consum', 0.0218, 'lps'),
	(430425, 124, '2015-03-01 00:53:51.000000', 'consum', 0.0229, 'lps'),
	(430426, 124, '2015-03-01 00:53:52.000000', 'consum', 0.0233, 'lps'),
	(430427, 124, '2015-03-01 00:53:53.000000', 'consum', 0.0213, 'lps'),
	(430428, 124, '2015-03-01 00:53:54.000000', 'consum', 0.0210, 'lps'),
	(430429, 124, '2015-03-01 00:53:55.000000', 'consum', 0.0228, 'lps'),
	(430430, 124, '2015-03-01 00:53:56.000000', 'consum', 0.0221, 'lps'),
	(430431, 124, '2015-03-01 00:53:57.000000', 'consum', 0.0212, 'lps'),
	(430432, 124, '2015-03-01 00:53:58.000000', 'consum', 0.0214, 'lps'),
	(430433, 124, '2015-03-01 00:53:59.000000', 'consum', 0.0225, 'lps'),
	(430434, 124, '2015-03-01 00:54:00.000000', 'consum', 0.0219, 'lps'),
	(430435, 124, '2015-03-01 00:54:01.000000', 'consum', 0.0212, 'lps'),
	(430436, 124, '2015-03-01 00:54:02.000000', 'consum', 0.0219, 'lps'),
	(430437, 124, '2015-03-01 00:54:03.000000', 'consum', 0.0224, 'lps'),
	(430438, 124, '2015-03-01 00:54:04.000000', 'consum', 0.0228, 'lps'),
	(430439, 124, '2015-03-01 00:54:05.000000', 'consum', 0.0233, 'lps'),
	(430440, 124, '2015-03-01 00:54:06.000000', 'consum', 0.0218, 'lps'),
	(430441, 124, '2015-03-01 00:54:07.000000', 'consum', 0.0235, 'lps'),
	(430442, 124, '2015-03-01 00:54:08.000000', 'consum', 0.0233, 'lps'),
	(430443, 124, '2015-03-01 00:54:09.000000', 'consum', 0.0224, 'lps'),
	(430444, 124, '2015-03-01 00:54:10.000000', 'consum', 0.0213, 'lps'),
	(430445, 124, '2015-03-01 00:54:11.000000', 'consum', 0.0234, 'lps'),
	(430446, 124, '2015-03-01 00:54:12.000000', 'consum', 0.0219, 'lps'),
	(430447, 124, '2015-03-01 00:54:13.000000', 'consum', 0.0210, 'lps'),
	(430448, 124, '2015-03-01 00:54:14.000000', 'consum', 0.0233, 'lps'),
	(430449, 124, '2015-03-01 00:54:15.000000', 'consum', 0.0224, 'lps'),
	(430450, 124, '2015-03-01 00:54:16.000000', 'consum', 0.0211, 'lps'),
	(430451, 124, '2015-03-01 00:54:17.000000', 'consum', 0.0224, 'lps'),
	(430452, 124, '2015-03-01 00:54:18.000000', 'consum', 0.0226, 'lps'),
	(430453, 124, '2015-03-01 00:54:19.000000', 'consum', 0.0224, 'lps'),
	(430454, 124, '2015-03-01 00:54:20.000000', 'consum', 0.0233, 'lps'),
	(430455, 124, '2015-03-01 00:54:21.000000', 'consum', 0.0229, 'lps'),
	(430456, 124, '2015-03-01 00:54:22.000000', 'consum', 0.0211, 'lps'),
	(430457, 124, '2015-03-01 00:54:23.000000', 'consum', 0.0211, 'lps'),
	(430458, 124, '2015-03-01 00:54:24.000000', 'consum', 0.0213, 'lps'),
	(430459, 124, '2015-03-01 00:54:25.000000', 'consum', 0.0220, 'lps'),
	(430460, 124, '2015-03-01 00:54:26.000000', 'consum', 0.0227, 'lps'),
	(430461, 124, '2015-03-01 00:54:27.000000', 'consum', 0.0214, 'lps'),
	(430462, 124, '2015-03-01 00:54:28.000000', 'consum', 0.0232, 'lps'),
	(430463, 124, '2015-03-01 00:54:29.000000', 'consum', 0.0229, 'lps'),
	(430464, 124, '2015-03-01 00:54:30.000000', 'consum', 0.0215, 'lps'),
	(430465, 124, '2015-03-01 00:54:31.000000', 'consum', 0.0228, 'lps'),
	(430466, 124, '2015-03-01 00:54:32.000000', 'consum', 0.0211, 'lps'),
	(430467, 124, '2015-03-01 00:54:33.000000', 'consum', 0.0212, 'lps'),
	(430468, 124, '2015-03-01 00:54:34.000000', 'consum', 0.0216, 'lps'),
	(430469, 124, '2015-03-01 00:54:35.000000', 'consum', 0.0235, 'lps'),
	(430470, 124, '2015-03-01 00:54:36.000000', 'consum', 0.0213, 'lps'),
	(430471, 124, '2015-03-01 00:54:37.000000', 'consum', 0.0230, 'lps'),
	(430472, 124, '2015-03-01 00:54:38.000000', 'consum', 0.0223, 'lps'),
	(430473, 124, '2015-03-01 00:54:39.000000', 'consum', 0.0216, 'lps'),
	(430474, 124, '2015-03-01 00:54:40.000000', 'consum', 0.0228, 'lps'),
	(430475, 124, '2015-03-01 00:54:41.000000', 'consum', 0.0228, 'lps'),
	(430476, 124, '2015-03-01 00:54:42.000000', 'consum', 0.0222, 'lps'),
	(430477, 124, '2015-03-01 00:54:43.000000', 'consum', 0.0218, 'lps'),
	(430478, 124, '2015-03-01 00:54:44.000000', 'consum', 0.0212, 'lps'),
	(430479, 124, '2015-03-01 00:54:45.000000', 'consum', 0.0222, 'lps'),
	(430480, 124, '2015-03-01 00:54:46.000000', 'consum', 0.0215, 'lps'),
	(430481, 124, '2015-03-01 00:54:47.000000', 'consum', 0.0224, 'lps'),
	(430482, 124, '2015-03-01 00:54:48.000000', 'consum', 0.0215, 'lps'),
	(430483, 124, '2015-03-01 00:54:49.000000', 'consum', 0.0218, 'lps'),
	(430484, 124, '2015-03-01 00:54:50.000000', 'consum', 0.0211, 'lps'),
	(430485, 124, '2015-03-01 00:54:51.000000', 'consum', 0.0216, 'lps'),
	(430486, 124, '2015-03-01 00:54:52.000000', 'consum', 0.0211, 'lps'),
	(430487, 124, '2015-03-01 00:54:53.000000', 'consum', 0.0225, 'lps'),
	(430488, 124, '2015-03-01 00:54:54.000000', 'consum', 0.0228, 'lps'),
	(430489, 124, '2015-03-01 00:54:55.000000', 'consum', 0.0233, 'lps'),
	(430490, 124, '2015-03-01 00:54:56.000000', 'consum', 0.0217, 'lps'),
	(430491, 124, '2015-03-01 00:54:57.000000', 'consum', 0.0229, 'lps'),
	(430492, 124, '2015-03-01 00:54:58.000000', 'consum', 0.0233, 'lps'),
	(430493, 124, '2015-03-01 00:54:59.000000', 'consum', 0.0214, 'lps'),
	(430494, 124, '2015-03-01 00:55:00.000000', 'consum', 0.0216, 'lps'),
	(430495, 124, '2015-03-01 00:55:01.000000', 'consum', 0.0227, 'lps'),
	(430496, 124, '2015-03-01 00:55:02.000000', 'consum', 0.0224, 'lps'),
	(430497, 124, '2015-03-01 00:55:03.000000', 'consum', 0.0233, 'lps'),
	(430498, 124, '2015-03-01 00:55:04.000000', 'consum', 0.0229, 'lps'),
	(430499, 124, '2015-03-01 00:55:05.000000', 'consum', 0.0211, 'lps'),
	(430500, 124, '2015-03-01 00:55:06.000000', 'consum', 0.0211, 'lps'),
	(430501, 124, '2015-03-01 00:55:07.000000', 'consum', 0.0211, 'lps'),
	(430502, 124, '2015-03-01 00:55:08.000000', 'consum', 0.0212, 'lps'),
	(430503, 124, '2015-03-01 00:55:09.000000', 'consum', 0.0220, 'lps'),
	(430504, 124, '2015-03-01 00:55:10.000000', 'consum', 0.0228, 'lps'),
	(430505, 124, '2015-03-01 00:55:11.000000', 'consum', 0.0219, 'lps'),
	(430506, 124, '2015-03-01 00:55:12.000000', 'consum', 0.0227, 'lps'),
	(430507, 124, '2015-03-01 00:55:13.000000', 'consum', 0.0217, 'lps'),
	(430508, 124, '2015-03-01 00:55:14.000000', 'consum', 0.0220, 'lps'),
	(430509, 124, '2015-03-01 00:55:15.000000', 'consum', 0.0214, 'lps'),
	(430510, 124, '2015-03-01 00:55:16.000000', 'consum', 0.0225, 'lps'),
	(430511, 124, '2015-03-01 00:55:17.000000', 'consum', 0.0222, 'lps'),
	(430512, 124, '2015-03-01 00:55:18.000000', 'consum', 0.0228, 'lps'),
	(430513, 124, '2015-03-01 00:55:19.000000', 'consum', 0.0210, 'lps'),
	(430514, 124, '2015-03-01 00:55:20.000000', 'consum', 0.0234, 'lps'),
	(430515, 124, '2015-03-01 00:55:21.000000', 'consum', 0.0229, 'lps'),
	(430516, 124, '2015-03-01 00:55:22.000000', 'consum', 0.0232, 'lps'),
	(430517, 124, '2015-03-01 00:55:23.000000', 'consum', 0.0210, 'lps'),
	(430518, 124, '2015-03-01 00:55:24.000000', 'consum', 0.0224, 'lps'),
	(430519, 124, '2015-03-01 00:55:25.000000', 'consum', 0.0227, 'lps'),
	(430520, 124, '2015-03-01 00:55:26.000000', 'consum', 0.0227, 'lps'),
	(430521, 124, '2015-03-01 00:55:27.000000', 'consum', 0.0220, 'lps'),
	(430522, 124, '2015-03-01 00:55:28.000000', 'consum', 0.0233, 'lps'),
	(430523, 124, '2015-03-01 00:55:29.000000', 'consum', 0.0220, 'lps'),
	(430524, 124, '2015-03-01 00:55:30.000000', 'consum', 0.0216, 'lps'),
	(430525, 124, '2015-03-01 00:55:31.000000', 'consum', 0.0211, 'lps'),
	(430526, 124, '2015-03-01 00:55:32.000000', 'consum', 0.0221, 'lps'),
	(430527, 124, '2015-03-01 00:55:33.000000', 'consum', 0.0214, 'lps'),
	(430528, 124, '2015-03-01 00:55:34.000000', 'consum', 0.0222, 'lps'),
	(430529, 124, '2015-03-01 00:55:35.000000', 'consum', 0.0233, 'lps'),
	(430530, 124, '2015-03-01 00:55:36.000000', 'consum', 0.0210, 'lps'),
	(430531, 124, '2015-03-01 00:55:37.000000', 'consum', 0.0221, 'lps'),
	(430532, 124, '2015-03-01 00:55:38.000000', 'consum', 0.0215, 'lps'),
	(430533, 124, '2015-03-01 00:55:39.000000', 'consum', 0.0226, 'lps'),
	(430534, 124, '2015-03-01 00:55:40.000000', 'consum', 0.0223, 'lps'),
	(430535, 124, '2015-03-01 00:55:41.000000', 'consum', 0.0229, 'lps'),
	(430536, 124, '2015-03-01 00:55:42.000000', 'consum', 0.0213, 'lps'),
	(430537, 124, '2015-03-01 00:55:43.000000', 'consum', 0.0221, 'lps'),
	(430538, 124, '2015-03-01 00:55:44.000000', 'consum', 0.0231, 'lps'),
	(430539, 124, '2015-03-01 00:55:45.000000', 'consum', 0.0229, 'lps'),
	(430540, 124, '2015-03-01 00:55:46.000000', 'consum', 0.0219, 'lps'),
	(430541, 124, '2015-03-01 00:55:47.000000', 'consum', 0.0224, 'lps'),
	(430542, 124, '2015-03-01 00:55:48.000000', 'consum', 0.0226, 'lps'),
	(430543, 124, '2015-03-01 00:55:49.000000', 'consum', 0.0221, 'lps'),
	(430544, 124, '2015-03-01 00:55:50.000000', 'consum', 0.0221, 'lps'),
	(430545, 124, '2015-03-01 00:55:51.000000', 'consum', 0.0230, 'lps'),
	(430546, 124, '2015-03-01 00:55:52.000000', 'consum', 0.0227, 'lps'),
	(430547, 124, '2015-03-01 00:55:53.000000', 'consum', 0.0234, 'lps'),
	(430548, 124, '2015-03-01 00:55:54.000000', 'consum', 0.0228, 'lps'),
	(430549, 124, '2015-03-01 00:55:55.000000', 'consum', 0.0228, 'lps'),
	(430550, 124, '2015-03-01 00:55:56.000000', 'consum', 0.0219, 'lps'),
	(430551, 124, '2015-03-01 00:55:57.000000', 'consum', 0.0228, 'lps'),
	(430552, 124, '2015-03-01 00:55:58.000000', 'consum', 0.0224, 'lps'),
	(430553, 124, '2015-03-01 00:55:59.000000', 'consum', 0.0224, 'lps'),
	(430554, 124, '2015-03-01 00:56:00.000000', 'consum', 0.0213, 'lps'),
	(430555, 124, '2015-03-01 00:56:01.000000', 'consum', 0.0234, 'lps'),
	(430556, 124, '2015-03-01 00:56:02.000000', 'consum', 0.0217, 'lps'),
	(430557, 124, '2015-03-01 00:56:03.000000', 'consum', 0.0227, 'lps'),
	(430558, 124, '2015-03-01 00:56:04.000000', 'consum', 0.0223, 'lps'),
	(430559, 124, '2015-03-01 00:56:05.000000', 'consum', 0.0224, 'lps'),
	(430560, 124, '2015-03-01 00:56:06.000000', 'consum', 0.0214, 'lps'),
	(430561, 124, '2015-03-01 00:56:07.000000', 'consum', 0.0216, 'lps'),
	(430562, 124, '2015-03-01 00:56:08.000000', 'consum', 0.0228, 'lps'),
	(430563, 124, '2015-03-01 00:56:09.000000', 'consum', 0.0232, 'lps'),
	(430564, 124, '2015-03-01 00:56:10.000000', 'consum', 0.0214, 'lps'),
	(430565, 124, '2015-03-01 00:56:11.000000', 'consum', 0.0215, 'lps'),
	(430566, 124, '2015-03-01 00:56:12.000000', 'consum', 0.0223, 'lps'),
	(430567, 124, '2015-03-01 00:56:13.000000', 'consum', 0.0210, 'lps'),
	(430568, 124, '2015-03-01 00:56:14.000000', 'consum', 0.0222, 'lps'),
	(430569, 124, '2015-03-01 00:56:15.000000', 'consum', 0.0219, 'lps'),
	(430570, 124, '2015-03-01 00:56:16.000000', 'consum', 0.0221, 'lps'),
	(430571, 124, '2015-03-01 00:56:17.000000', 'consum', 0.0213, 'lps'),
	(430572, 124, '2015-03-01 00:56:18.000000', 'consum', 0.0216, 'lps'),
	(430573, 124, '2015-03-01 00:56:19.000000', 'consum', 0.0232, 'lps'),
	(430574, 124, '2015-03-01 00:56:20.000000', 'consum', 0.0227, 'lps'),
	(430575, 124, '2015-03-01 00:56:21.000000', 'consum', 0.0227, 'lps'),
	(430576, 124, '2015-03-01 00:56:22.000000', 'consum', 0.0221, 'lps'),
	(430577, 124, '2015-03-01 00:56:23.000000', 'consum', 0.0213, 'lps'),
	(430578, 124, '2015-03-01 00:56:24.000000', 'consum', 0.0218, 'lps'),
	(430579, 124, '2015-03-01 00:56:25.000000', 'consum', 0.0218, 'lps'),
	(430580, 124, '2015-03-01 00:56:26.000000', 'consum', 0.0224, 'lps'),
	(430581, 124, '2015-03-01 00:56:27.000000', 'consum', 0.0232, 'lps'),
	(430582, 124, '2015-03-01 00:56:28.000000', 'consum', 0.0225, 'lps'),
	(430583, 124, '2015-03-01 00:56:29.000000', 'consum', 0.0220, 'lps'),
	(430584, 124, '2015-03-01 00:56:30.000000', 'consum', 0.0214, 'lps'),
	(430585, 124, '2015-03-01 00:56:31.000000', 'consum', 0.0227, 'lps'),
	(430586, 124, '2015-03-01 00:56:32.000000', 'consum', 0.0230, 'lps'),
	(430587, 124, '2015-03-01 00:56:33.000000', 'consum', 0.0234, 'lps'),
	(430588, 124, '2015-03-01 00:56:34.000000', 'consum', 0.0221, 'lps'),
	(430589, 124, '2015-03-01 00:56:35.000000', 'consum', 0.0219, 'lps'),
	(430590, 124, '2015-03-01 00:56:36.000000', 'consum', 0.0222, 'lps'),
	(430591, 124, '2015-03-01 00:56:37.000000', 'consum', 0.0218, 'lps'),
	(430592, 124, '2015-03-01 00:56:38.000000', 'consum', 0.0213, 'lps'),
	(430593, 124, '2015-03-01 00:56:39.000000', 'consum', 0.0227, 'lps'),
	(430594, 124, '2015-03-01 00:56:40.000000', 'consum', 0.0211, 'lps'),
	(430595, 124, '2015-03-01 00:56:41.000000', 'consum', 0.0216, 'lps'),
	(430596, 124, '2015-03-01 00:56:42.000000', 'consum', 0.0211, 'lps'),
	(430597, 124, '2015-03-01 00:56:43.000000', 'consum', 0.0224, 'lps'),
	(430598, 124, '2015-03-01 00:56:44.000000', 'consum', 0.0227, 'lps'),
	(430599, 124, '2015-03-01 00:56:45.000000', 'consum', 0.0227, 'lps'),
	(430600, 124, '2015-03-01 00:56:46.000000', 'consum', 0.0219, 'lps'),
	(430601, 124, '2015-03-01 00:56:47.000000', 'consum', 0.0229, 'lps'),
	(430602, 124, '2015-03-01 00:56:48.000000', 'consum', 0.0228, 'lps'),
	(430603, 124, '2015-03-01 00:56:49.000000', 'consum', 0.0219, 'lps'),
	(430604, 124, '2015-03-01 00:56:50.000000', 'consum', 0.0225, 'lps'),
	(430605, 124, '2015-03-01 00:56:51.000000', 'consum', 0.0234, 'lps'),
	(430606, 124, '2015-03-01 00:56:52.000000', 'consum', 0.0232, 'lps'),
	(430607, 124, '2015-03-01 00:56:53.000000', 'consum', 0.0222, 'lps'),
	(430608, 124, '2015-03-01 00:56:54.000000', 'consum', 0.0231, 'lps'),
	(430609, 124, '2015-03-01 00:56:55.000000', 'consum', 0.0229, 'lps'),
	(430610, 124, '2015-03-01 00:56:56.000000', 'consum', 0.0216, 'lps'),
	(430611, 124, '2015-03-01 00:56:57.000000', 'consum', 0.0235, 'lps'),
	(430612, 124, '2015-03-01 00:56:58.000000', 'consum', 0.0213, 'lps'),
	(430613, 124, '2015-03-01 00:56:59.000000', 'consum', 0.0227, 'lps'),
	(430614, 124, '2015-03-01 00:57:00.000000', 'consum', 0.0211, 'lps'),
	(430615, 124, '2015-03-01 00:57:01.000000', 'consum', 0.0214, 'lps'),
	(430616, 124, '2015-03-01 00:57:02.000000', 'consum', 0.0228, 'lps'),
	(430617, 124, '2015-03-01 00:57:03.000000', 'consum', 0.0210, 'lps'),
	(430618, 124, '2015-03-01 00:57:04.000000', 'consum', 0.0210, 'lps'),
	(430619, 124, '2015-03-01 00:57:05.000000', 'consum', 0.0211, 'lps'),
	(430620, 124, '2015-03-01 00:57:06.000000', 'consum', 0.0215, 'lps'),
	(430621, 124, '2015-03-01 00:57:07.000000', 'consum', 0.0234, 'lps'),
	(430622, 124, '2015-03-01 00:57:08.000000', 'consum', 0.0210, 'lps'),
	(430623, 124, '2015-03-01 00:57:09.000000', 'consum', 0.0218, 'lps'),
	(430624, 124, '2015-03-01 00:57:10.000000', 'consum', 0.0222, 'lps'),
	(430625, 124, '2015-03-01 00:57:11.000000', 'consum', 0.0220, 'lps'),
	(430626, 124, '2015-03-01 00:57:12.000000', 'consum', 0.0224, 'lps'),
	(430627, 124, '2015-03-01 00:57:13.000000', 'consum', 0.0227, 'lps'),
	(430628, 124, '2015-03-01 00:57:14.000000', 'consum', 0.0227, 'lps'),
	(430629, 124, '2015-03-01 00:57:15.000000', 'consum', 0.0220, 'lps'),
	(430630, 124, '2015-03-01 00:57:16.000000', 'consum', 0.0235, 'lps'),
	(430631, 124, '2015-03-01 00:57:17.000000', 'consum', 0.0227, 'lps'),
	(430632, 124, '2015-03-01 00:57:18.000000', 'consum', 0.0218, 'lps'),
	(430633, 124, '2015-03-01 00:57:19.000000', 'consum', 0.0229, 'lps'),
	(430634, 124, '2015-03-01 00:57:20.000000', 'consum', 0.0229, 'lps'),
	(430635, 124, '2015-03-01 00:57:21.000000', 'consum', 0.0221, 'lps'),
	(430636, 124, '2015-03-01 00:57:22.000000', 'consum', 0.0210, 'lps'),
	(430637, 124, '2015-03-01 00:57:23.000000', 'consum', 0.0229, 'lps'),
	(430638, 124, '2015-03-01 00:57:24.000000', 'consum', 0.0228, 'lps'),
	(430639, 124, '2015-03-01 00:57:25.000000', 'consum', 0.0216, 'lps'),
	(430640, 124, '2015-03-01 00:57:26.000000', 'consum', 0.0212, 'lps'),
	(430641, 124, '2015-03-01 00:57:27.000000', 'consum', 0.0227, 'lps'),
	(430642, 124, '2015-03-01 00:57:28.000000', 'consum', 0.0214, 'lps'),
	(430643, 124, '2015-03-01 00:57:29.000000', 'consum', 0.0232, 'lps'),
	(430644, 124, '2015-03-01 00:57:30.000000', 'consum', 0.0230, 'lps'),
	(430645, 124, '2015-03-01 00:57:31.000000', 'consum', 0.0218, 'lps'),
	(430646, 124, '2015-03-01 00:57:32.000000', 'consum', 0.0215, 'lps'),
	(430647, 124, '2015-03-01 00:57:33.000000', 'consum', 0.0215, 'lps'),
	(430648, 124, '2015-03-01 00:57:34.000000', 'consum', 0.0218, 'lps'),
	(430649, 124, '2015-03-01 00:57:35.000000', 'consum', 0.0235, 'lps'),
	(430650, 124, '2015-03-01 00:57:36.000000', 'consum', 0.0232, 'lps'),
	(430651, 124, '2015-03-01 00:57:37.000000', 'consum', 0.0223, 'lps'),
	(430652, 124, '2015-03-01 00:57:38.000000', 'consum', 0.0234, 'lps'),
	(430653, 124, '2015-03-01 00:57:39.000000', 'consum', 0.0215, 'lps'),
	(430654, 124, '2015-03-01 00:57:40.000000', 'consum', 0.0213, 'lps'),
	(430655, 124, '2015-03-01 00:57:41.000000', 'consum', 0.0213, 'lps'),
	(430656, 124, '2015-03-01 00:57:42.000000', 'consum', 0.0214, 'lps'),
	(430657, 124, '2015-03-01 00:57:43.000000', 'consum', 0.0223, 'lps'),
	(430658, 124, '2015-03-01 00:57:44.000000', 'consum', 0.0213, 'lps'),
	(430659, 124, '2015-03-01 00:57:45.000000', 'consum', 0.0211, 'lps'),
	(430660, 124, '2015-03-01 00:57:46.000000', 'consum', 0.0235, 'lps'),
	(430661, 124, '2015-03-01 00:57:47.000000', 'consum', 0.0225, 'lps'),
	(430662, 124, '2015-03-01 00:57:48.000000', 'consum', 0.0212, 'lps'),
	(430663, 124, '2015-03-01 00:57:49.000000', 'consum', 0.0227, 'lps'),
	(430664, 124, '2015-03-01 00:57:50.000000', 'consum', 0.0212, 'lps'),
	(430665, 124, '2015-03-01 00:57:51.000000', 'consum', 0.0221, 'lps'),
	(430666, 124, '2015-03-01 00:57:52.000000', 'consum', 0.0233, 'lps'),
	(430667, 124, '2015-03-01 00:57:53.000000', 'consum', 0.0215, 'lps'),
	(430668, 124, '2015-03-01 00:57:54.000000', 'consum', 0.0217, 'lps'),
	(430669, 124, '2015-03-01 00:57:55.000000', 'consum', 0.0232, 'lps'),
	(430670, 124, '2015-03-01 00:57:56.000000', 'consum', 0.0222, 'lps'),
	(430671, 124, '2015-03-01 00:57:57.000000', 'consum', 0.0228, 'lps'),
	(430672, 124, '2015-03-01 00:57:58.000000', 'consum', 0.0216, 'lps'),
	(430673, 124, '2015-03-01 00:57:59.000000', 'consum', 0.0210, 'lps'),
	(430674, 124, '2015-03-01 00:58:00.000000', 'consum', 0.0220, 'lps'),
	(430675, 124, '2015-03-01 00:58:01.000000', 'consum', 0.0232, 'lps'),
	(430676, 124, '2015-03-01 00:58:02.000000', 'consum', 0.0216, 'lps'),
	(430677, 124, '2015-03-01 00:58:03.000000', 'consum', 0.0223, 'lps'),
	(430678, 124, '2015-03-01 00:58:04.000000', 'consum', 0.0235, 'lps'),
	(430679, 124, '2015-03-01 00:58:05.000000', 'consum', 0.0216, 'lps'),
	(430680, 124, '2015-03-01 00:58:06.000000', 'consum', 0.0219, 'lps'),
	(430681, 124, '2015-03-01 00:58:07.000000', 'consum', 0.0210, 'lps'),
	(430682, 124, '2015-03-01 00:58:08.000000', 'consum', 0.0210, 'lps'),
	(430683, 124, '2015-03-01 00:58:09.000000', 'consum', 0.0211, 'lps'),
	(430684, 124, '2015-03-01 00:58:10.000000', 'consum', 0.0216, 'lps'),
	(430685, 124, '2015-03-01 00:58:11.000000', 'consum', 0.0235, 'lps'),
	(430686, 124, '2015-03-01 00:58:12.000000', 'consum', 0.0215, 'lps'),
	(430687, 124, '2015-03-01 00:58:13.000000', 'consum', 0.0214, 'lps'),
	(430688, 124, '2015-03-01 00:58:14.000000', 'consum', 0.0215, 'lps'),
	(430689, 124, '2015-03-01 00:58:15.000000', 'consum', 0.0222, 'lps'),
	(430690, 124, '2015-03-01 00:58:16.000000', 'consum', 0.0229, 'lps'),
	(430691, 124, '2015-03-01 00:58:17.000000', 'consum', 0.0219, 'lps'),
	(430692, 124, '2015-03-01 00:58:18.000000', 'consum', 0.0225, 'lps'),
	(430693, 124, '2015-03-01 00:58:19.000000', 'consum', 0.0234, 'lps'),
	(430694, 124, '2015-03-01 00:58:20.000000', 'consum', 0.0231, 'lps'),
	(430695, 124, '2015-03-01 00:58:21.000000', 'consum', 0.0217, 'lps'),
	(430696, 124, '2015-03-01 00:58:22.000000', 'consum', 0.0235, 'lps'),
	(430697, 124, '2015-03-01 00:58:23.000000', 'consum', 0.0213, 'lps'),
	(430698, 124, '2015-03-01 00:58:24.000000', 'consum', 0.0226, 'lps'),
	(430699, 124, '2015-03-01 00:58:25.000000', 'consum', 0.0229, 'lps'),
	(430700, 124, '2015-03-01 00:58:26.000000', 'consum', 0.0234, 'lps'),
	(430701, 124, '2015-03-01 00:58:27.000000', 'consum', 0.0222, 'lps'),
	(430702, 124, '2015-03-01 00:58:28.000000', 'consum', 0.0224, 'lps'),
	(430703, 124, '2015-03-01 00:58:29.000000', 'consum', 0.0218, 'lps'),
	(430704, 124, '2015-03-01 00:58:30.000000', 'consum', 0.0210, 'lps'),
	(430705, 124, '2015-03-01 00:58:31.000000', 'consum', 0.0212, 'lps'),
	(430706, 124, '2015-03-01 00:58:32.000000', 'consum', 0.0221, 'lps'),
	(430707, 124, '2015-03-01 00:58:33.000000', 'consum', 0.0235, 'lps'),
	(430708, 124, '2015-03-01 00:58:34.000000', 'consum', 0.0223, 'lps'),
	(430709, 124, '2015-03-01 00:58:35.000000', 'consum', 0.0227, 'lps'),
	(430710, 124, '2015-03-01 00:58:36.000000', 'consum', 0.0229, 'lps'),
	(430711, 124, '2015-03-01 00:58:37.000000', 'consum', 0.0231, 'lps'),
	(430712, 124, '2015-03-01 00:58:38.000000', 'consum', 0.0231, 'lps'),
	(430713, 124, '2015-03-01 00:58:39.000000', 'consum', 0.0225, 'lps'),
	(430714, 124, '2015-03-01 00:58:40.000000', 'consum', 0.0223, 'lps'),
	(430715, 124, '2015-03-01 00:58:41.000000', 'consum', 0.0230, 'lps'),
	(430716, 124, '2015-03-01 00:58:42.000000', 'consum', 0.0221, 'lps'),
	(430717, 124, '2015-03-01 00:58:43.000000', 'consum', 0.0233, 'lps'),
	(430718, 124, '2015-03-01 00:58:44.000000', 'consum', 0.0212, 'lps'),
	(430719, 124, '2015-03-01 00:58:45.000000', 'consum', 0.0232, 'lps'),
	(430720, 124, '2015-03-01 00:58:46.000000', 'consum', 0.0211, 'lps'),
	(430721, 124, '2015-03-01 00:58:47.000000', 'consum', 0.0225, 'lps'),
	(430722, 124, '2015-03-01 00:58:48.000000', 'consum', 0.0230, 'lps'),
	(430723, 124, '2015-03-01 00:58:49.000000', 'consum', 0.0216, 'lps'),
	(430724, 124, '2015-03-01 00:58:50.000000', 'consum', 0.0233, 'lps'),
	(430725, 124, '2015-03-01 00:58:51.000000', 'consum', 0.0229, 'lps'),
	(430726, 124, '2015-03-01 00:58:52.000000', 'consum', 0.0234, 'lps'),
	(430727, 124, '2015-03-01 00:58:53.000000', 'consum', 0.0224, 'lps'),
	(430728, 124, '2015-03-01 00:58:54.000000', 'consum', 0.0233, 'lps'),
	(430729, 124, '2015-03-01 00:58:55.000000', 'consum', 0.0232, 'lps'),
	(430730, 124, '2015-03-01 00:58:56.000000', 'consum', 0.0227, 'lps'),
	(430731, 124, '2015-03-01 00:58:57.000000', 'consum', 0.0227, 'lps'),
	(430732, 124, '2015-03-01 00:58:58.000000', 'consum', 0.0218, 'lps'),
	(430733, 124, '2015-03-01 00:58:59.000000', 'consum', 0.0225, 'lps'),
	(430734, 124, '2015-03-01 00:59:00.000000', 'consum', 0.0210, 'lps'),
	(430735, 124, '2015-03-01 00:59:01.000000', 'consum', 0.0217, 'lps'),
	(430736, 124, '2015-03-01 00:59:02.000000', 'consum', 0.0219, 'lps'),
	(430737, 124, '2015-03-01 00:59:03.000000', 'consum', 0.0235, 'lps'),
	(430738, 124, '2015-03-01 00:59:04.000000', 'consum', 0.0233, 'lps'),
	(430739, 124, '2015-03-01 00:59:05.000000', 'consum', 0.0222, 'lps'),
	(430740, 124, '2015-03-01 00:59:06.000000', 'consum', 0.0226, 'lps'),
	(430741, 124, '2015-03-01 00:59:07.000000', 'consum', 0.0231, 'lps'),
	(430742, 124, '2015-03-01 00:59:08.000000', 'consum', 0.0214, 'lps'),
	(430743, 124, '2015-03-01 00:59:09.000000', 'consum', 0.0219, 'lps'),
	(430744, 124, '2015-03-01 00:59:10.000000', 'consum', 0.0219, 'lps'),
	(430745, 124, '2015-03-01 00:59:11.000000', 'consum', 0.0227, 'lps'),
	(430746, 124, '2015-03-01 00:59:12.000000', 'consum', 0.0217, 'lps'),
	(430747, 124, '2015-03-01 00:59:13.000000', 'consum', 0.0221, 'lps'),
	(430748, 124, '2015-03-01 00:59:14.000000', 'consum', 0.0218, 'lps'),
	(430749, 124, '2015-03-01 00:59:15.000000', 'consum', 0.0218, 'lps'),
	(430750, 124, '2015-03-01 00:59:16.000000', 'consum', 0.0228, 'lps'),
	(430751, 124, '2015-03-01 00:59:17.000000', 'consum', 0.0224, 'lps'),
	(430752, 124, '2015-03-01 00:59:18.000000', 'consum', 0.0224, 'lps'),
	(430753, 124, '2015-03-01 00:59:19.000000', 'consum', 0.0214, 'lps'),
	(430754, 124, '2015-03-01 00:59:20.000000', 'consum', 0.0214, 'lps'),
	(430755, 124, '2015-03-01 00:59:21.000000', 'consum', 0.0217, 'lps'),
	(430756, 124, '2015-03-01 00:59:22.000000', 'consum', 0.0235, 'lps'),
	(430757, 124, '2015-03-01 00:59:23.000000', 'consum', 0.0212, 'lps'),
	(430758, 124, '2015-03-01 00:59:24.000000', 'consum', 0.0222, 'lps'),
	(430759, 124, '2015-03-01 00:59:25.000000', 'consum', 0.0214, 'lps'),
	(430760, 124, '2015-03-01 00:59:26.000000', 'consum', 0.0219, 'lps'),
	(430761, 124, '2015-03-01 00:59:27.000000', 'consum', 0.0218, 'lps'),
	(430762, 124, '2015-03-01 00:59:28.000000', 'consum', 0.0224, 'lps'),
	(430763, 124, '2015-03-01 00:59:29.000000', 'consum', 0.0230, 'lps'),
	(430764, 124, '2015-03-01 00:59:30.000000', 'consum', 0.0216, 'lps'),
	(430765, 124, '2015-03-01 00:59:31.000000', 'consum', 0.0233, 'lps'),
	(430766, 124, '2015-03-01 00:59:32.000000', 'consum', 0.0231, 'lps'),
	(430767, 124, '2015-03-01 00:59:33.000000', 'consum', 0.0221, 'lps'),
	(430768, 124, '2015-03-01 00:59:34.000000', 'consum', 0.0229, 'lps'),
	(430769, 124, '2015-03-01 00:59:35.000000', 'consum', 0.0220, 'lps'),
	(430770, 124, '2015-03-01 00:59:36.000000', 'consum', 0.0229, 'lps'),
	(430771, 124, '2015-03-01 00:59:37.000000', 'consum', 0.0224, 'lps'),
	(430772, 124, '2015-03-01 00:59:38.000000', 'consum', 0.0223, 'lps'),
	(430773, 124, '2015-03-01 00:59:39.000000', 'consum', 0.0233, 'lps'),
	(430774, 124, '2015-03-01 00:59:40.000000', 'consum', 0.0235, 'lps'),
	(430775, 124, '2015-03-01 00:59:41.000000', 'consum', 0.0216, 'lps'),
	(430776, 124, '2015-03-01 00:59:42.000000', 'consum', 0.0215, 'lps'),
	(430777, 124, '2015-03-01 00:59:43.000000', 'consum', 0.0220, 'lps'),
	(430778, 124, '2015-03-01 00:59:44.000000', 'consum', 0.0220, 'lps'),
	(430779, 124, '2015-03-01 00:59:45.000000', 'consum', 0.0229, 'lps'),
	(430780, 124, '2015-03-01 00:59:46.000000', 'consum', 0.0223, 'lps'),
	(430781, 124, '2015-03-01 00:59:47.000000', 'consum', 0.0220, 'lps'),
	(430782, 124, '2015-03-01 00:59:48.000000', 'consum', 0.0220, 'lps'),
	(430783, 124, '2015-03-01 00:59:49.000000', 'consum', 0.0232, 'lps'),
	(430784, 124, '2015-03-01 00:59:50.000000', 'consum', 0.0211, 'lps'),
	(430785, 124, '2015-03-01 00:59:51.000000', 'consum', 0.0229, 'lps'),
	(430786, 124, '2015-03-01 00:59:52.000000', 'consum', 0.0224, 'lps'),
	(430787, 124, '2015-03-01 00:59:53.000000', 'consum', 0.0222, 'lps'),
	(430788, 124, '2015-03-01 00:59:54.000000', 'consum', 0.0227, 'lps'),
	(430789, 124, '2015-03-01 00:59:55.000000', 'consum', 0.0211, 'lps'),
	(430790, 124, '2015-03-01 00:59:56.000000', 'consum', 0.0216, 'lps'),
	(430791, 124, '2015-03-01 00:59:57.000000', 'consum', 0.0213, 'lps'),
	(430792, 124, '2015-03-01 00:59:58.000000', 'consum', 0.0231, 'lps'),
	(430793, 124, '2015-03-01 00:59:59.000000', 'consum', 0.0231, 'lps'),
	(430794, 124, '2015-03-01 01:00:00.000000', 'consum', 0.0227, 'lps'),
	(430795, 124, '2015-03-01 01:00:01.000000', 'consum', 0.0230, 'lps'),
	(430796, 124, '2015-03-01 01:00:02.000000', 'consum', 0.0210, 'lps'),
	(430797, 124, '2015-03-01 01:00:03.000000', 'consum', 0.0228, 'lps'),
	(430798, 124, '2015-03-01 01:00:04.000000', 'consum', 0.0224, 'lps'),
	(430799, 124, '2015-03-01 01:00:05.000000', 'consum', 0.0225, 'lps'),
	(430800, 124, '2015-03-01 01:00:06.000000', 'consum', 0.0217, 'lps'),
	(430801, 124, '2015-03-01 01:00:07.000000', 'consum', 0.0225, 'lps'),
	(430802, 124, '2015-03-01 01:00:08.000000', 'consum', 0.0215, 'lps'),
	(430803, 124, '2015-03-01 01:00:09.000000', 'consum', 0.0218, 'lps'),
	(430804, 124, '2015-03-01 01:00:10.000000', 'consum', 0.0233, 'lps'),
	(430805, 124, '2015-03-01 01:00:11.000000', 'consum', 0.0223, 'lps'),
	(430806, 124, '2015-03-01 01:00:12.000000', 'consum', 0.0232, 'lps'),
	(430807, 124, '2015-03-01 01:00:13.000000', 'consum', 0.0231, 'lps'),
	(430808, 124, '2015-03-01 01:00:14.000000', 'consum', 0.0221, 'lps'),
	(430809, 124, '2015-03-01 01:00:15.000000', 'consum', 0.0231, 'lps'),
	(430810, 124, '2015-03-01 01:00:16.000000', 'consum', 0.0229, 'lps'),
	(430811, 124, '2015-03-01 01:00:17.000000', 'consum', 0.0217, 'lps'),
	(430812, 124, '2015-03-01 01:00:18.000000', 'consum', 0.0216, 'lps'),
	(430813, 124, '2015-03-01 01:00:19.000000', 'consum', 0.0218, 'lps'),
	(430814, 124, '2015-03-01 01:00:20.000000', 'consum', 0.0233, 'lps'),
	(430815, 124, '2015-03-01 01:00:21.000000', 'consum', 0.0222, 'lps'),
	(430816, 124, '2015-03-01 01:00:22.000000', 'consum', 0.0228, 'lps'),
	(430817, 124, '2015-03-01 01:00:23.000000', 'consum', 0.0213, 'lps'),
	(430818, 124, '2015-03-01 01:00:24.000000', 'consum', 0.0224, 'lps'),
	(430819, 124, '2015-03-01 01:00:25.000000', 'consum', 0.0217, 'lps'),
	(430820, 124, '2015-03-01 01:00:26.000000', 'consum', 0.0231, 'lps'),
	(430821, 124, '2015-03-01 01:00:27.000000', 'consum', 0.0218, 'lps'),
	(430822, 124, '2015-03-01 01:00:28.000000', 'consum', 0.0213, 'lps'),
	(430823, 124, '2015-03-01 01:00:29.000000', 'consum', 0.0228, 'lps'),
	(430824, 124, '2015-03-01 01:00:30.000000', 'consum', 0.0215, 'lps'),
	(430825, 124, '2015-03-01 01:00:31.000000', 'consum', 0.0232, 'lps'),
	(430826, 124, '2015-03-01 01:00:32.000000', 'consum', 0.0227, 'lps'),
	(430827, 124, '2015-03-01 01:00:33.000000', 'consum', 0.0228, 'lps'),
	(430828, 124, '2015-03-01 01:00:34.000000', 'consum', 0.0226, 'lps'),
	(430829, 124, '2015-03-01 01:00:35.000000', 'consum', 0.0234, 'lps'),
	(430830, 124, '2015-03-01 01:00:36.000000', 'consum', 0.0231, 'lps'),
	(430831, 124, '2015-03-01 01:00:37.000000', 'consum', 0.0220, 'lps'),
	(430832, 124, '2015-03-01 01:00:38.000000', 'consum', 0.0222, 'lps'),
	(430833, 124, '2015-03-01 01:00:39.000000', 'consum', 0.0215, 'lps'),
	(430834, 124, '2015-03-01 01:00:40.000000', 'consum', 0.0225, 'lps'),
	(430835, 124, '2015-03-01 01:00:41.000000', 'consum', 0.0219, 'lps'),
	(430836, 124, '2015-03-01 01:00:42.000000', 'consum', 0.0212, 'lps'),
	(430837, 124, '2015-03-01 01:00:43.000000', 'consum', 0.0218, 'lps'),
	(430838, 124, '2015-03-01 01:00:44.000000', 'consum', 0.0218, 'lps'),
	(430839, 124, '2015-03-01 01:00:45.000000', 'consum', 0.0229, 'lps'),
	(430840, 124, '2015-03-01 01:00:46.000000', 'consum', 0.0227, 'lps'),
	(430841, 124, '2015-03-01 01:00:47.000000', 'consum', 0.0214, 'lps'),
	(430842, 124, '2015-03-01 01:00:48.000000', 'consum', 0.0233, 'lps'),
	(430843, 124, '2015-03-01 01:00:49.000000', 'consum', 0.0232, 'lps'),
	(430844, 124, '2015-03-01 01:00:50.000000', 'consum', 0.0227, 'lps'),
	(430845, 124, '2015-03-01 01:00:51.000000', 'consum', 0.0232, 'lps'),
	(430846, 124, '2015-03-01 01:00:52.000000', 'consum', 0.0214, 'lps'),
	(430847, 124, '2015-03-01 01:00:53.000000', 'consum', 0.0218, 'lps'),
	(430848, 124, '2015-03-01 01:00:54.000000', 'consum', 0.0212, 'lps'),
	(430849, 124, '2015-03-01 01:00:55.000000', 'consum', 0.0222, 'lps'),
	(430850, 124, '2015-03-01 01:00:56.000000', 'consum', 0.0213, 'lps'),
	(430851, 124, '2015-03-01 01:00:57.000000', 'consum', 0.0216, 'lps'),
	(430852, 124, '2015-03-01 01:00:58.000000', 'consum', 0.0232, 'lps'),
	(430853, 124, '2015-03-01 01:00:59.000000', 'consum', 0.0222, 'lps'),
	(430854, 124, '2015-03-01 01:01:00.000000', 'consum', 0.0231, 'lps'),
	(430855, 124, '2015-03-01 01:01:01.000000', 'consum', 0.0228, 'lps'),
	(430856, 124, '2015-03-01 01:01:02.000000', 'consum', 0.0235, 'lps'),
	(430857, 124, '2015-03-01 01:01:03.000000', 'consum', 0.0233, 'lps'),
	(430858, 124, '2015-03-01 01:01:04.000000', 'consum', 0.0225, 'lps'),
	(430859, 124, '2015-03-01 01:01:05.000000', 'consum', 0.0214, 'lps'),
	(430860, 124, '2015-03-01 01:01:06.000000', 'consum', 0.0212, 'lps'),
	(430861, 124, '2015-03-01 01:01:07.000000', 'consum', 0.0233, 'lps'),
	(430862, 124, '2015-03-01 01:01:08.000000', 'consum', 0.0218, 'lps'),
	(430863, 124, '2015-03-01 01:01:09.000000', 'consum', 0.0231, 'lps'),
	(430864, 124, '2015-03-01 01:01:10.000000', 'consum', 0.0215, 'lps'),
	(430865, 124, '2015-03-01 01:01:11.000000', 'consum', 0.0226, 'lps'),
	(430866, 124, '2015-03-01 01:01:12.000000', 'consum', 0.0221, 'lps'),
	(430867, 124, '2015-03-01 01:01:13.000000', 'consum', 0.0218, 'lps'),
	(430868, 124, '2015-03-01 01:01:14.000000', 'consum', 0.0220, 'lps'),
	(430869, 124, '2015-03-01 01:01:15.000000', 'consum', 0.0233, 'lps'),
	(430870, 124, '2015-03-01 01:01:16.000000', 'consum', 0.0219, 'lps'),
	(430871, 124, '2015-03-01 01:01:17.000000', 'consum', 0.0213, 'lps'),
	(430872, 124, '2015-03-01 01:01:18.000000', 'consum', 0.0226, 'lps'),
	(430873, 124, '2015-03-01 01:01:19.000000', 'consum', 0.0228, 'lps'),
	(430874, 124, '2015-03-01 01:01:20.000000', 'consum', 0.0228, 'lps'),
	(430875, 124, '2015-03-01 01:01:21.000000', 'consum', 0.0218, 'lps'),
	(430876, 124, '2015-03-01 01:01:22.000000', 'consum', 0.0223, 'lps'),
	(430877, 124, '2015-03-01 01:01:23.000000', 'consum', 0.0227, 'lps'),
	(430878, 124, '2015-03-01 01:01:24.000000', 'consum', 0.0231, 'lps'),
	(430879, 124, '2015-03-01 01:01:25.000000', 'consum', 0.0211, 'lps'),
	(430880, 124, '2015-03-01 01:01:26.000000', 'consum', 0.0229, 'lps'),
	(430881, 124, '2015-03-01 01:01:27.000000', 'consum', 0.0227, 'lps'),
	(430882, 124, '2015-03-01 01:01:28.000000', 'consum', 0.0213, 'lps'),
	(430883, 124, '2015-03-01 01:01:29.000000', 'consum', 0.0225, 'lps'),
	(430884, 124, '2015-03-01 01:01:30.000000', 'consum', 0.0227, 'lps'),
	(430885, 124, '2015-03-01 01:01:31.000000', 'consum', 0.0223, 'lps'),
	(430886, 124, '2015-03-01 01:01:32.000000', 'consum', 0.0224, 'lps'),
	(430887, 124, '2015-03-01 01:01:33.000000', 'consum', 0.0217, 'lps'),
	(430888, 124, '2015-03-01 01:01:34.000000', 'consum', 0.0228, 'lps'),
	(430889, 124, '2015-03-01 01:01:35.000000', 'consum', 0.0230, 'lps'),
	(430890, 124, '2015-03-01 01:01:36.000000', 'consum', 0.0229, 'lps'),
	(430891, 124, '2015-03-01 01:01:37.000000', 'consum', 0.0218, 'lps'),
	(430892, 124, '2015-03-01 01:01:38.000000', 'consum', 0.0222, 'lps'),
	(430893, 124, '2015-03-01 01:01:39.000000', 'consum', 0.0218, 'lps'),
	(430894, 124, '2015-03-01 01:01:40.000000', 'consum', 0.0215, 'lps'),
	(430895, 124, '2015-03-01 01:01:41.000000', 'consum', 0.0211, 'lps'),
	(430896, 124, '2015-03-01 01:01:42.000000', 'consum', 0.0229, 'lps'),
	(430897, 124, '2015-03-01 01:01:43.000000', 'consum', 0.0222, 'lps'),
	(430898, 124, '2015-03-01 01:01:44.000000', 'consum', 0.0215, 'lps'),
	(430899, 124, '2015-03-01 01:01:45.000000', 'consum', 0.0224, 'lps'),
	(430900, 124, '2015-03-01 01:01:46.000000', 'consum', 0.0213, 'lps'),
	(430901, 124, '2015-03-01 01:01:47.000000', 'consum', 0.0235, 'lps'),
	(430902, 124, '2015-03-01 01:01:48.000000', 'consum', 0.0223, 'lps'),
	(430903, 124, '2015-03-01 01:01:49.000000', 'consum', 0.0228, 'lps'),
	(430904, 124, '2015-03-01 01:01:50.000000', 'consum', 0.0210, 'lps'),
	(430905, 124, '2015-03-01 01:01:51.000000', 'consum', 0.0235, 'lps'),
	(430906, 124, '2015-03-01 01:01:52.000000', 'consum', 0.0230, 'lps'),
	(430907, 124, '2015-03-01 01:01:53.000000', 'consum', 0.0234, 'lps'),
	(430908, 124, '2015-03-01 01:01:54.000000', 'consum', 0.0220, 'lps'),
	(430909, 124, '2015-03-01 01:01:55.000000', 'consum', 0.0214, 'lps'),
	(430910, 124, '2015-03-01 01:01:56.000000', 'consum', 0.0226, 'lps'),
	(430911, 124, '2015-03-01 01:01:57.000000', 'consum', 0.0225, 'lps'),
	(430912, 124, '2015-03-01 01:01:58.000000', 'consum', 0.0214, 'lps'),
	(430913, 124, '2015-03-01 01:01:59.000000', 'consum', 0.0210, 'lps'),
	(430914, 124, '2015-03-01 01:02:00.000000', 'consum', 0.0224, 'lps'),
	(430915, 124, '2015-03-01 01:02:01.000000', 'consum', 0.0231, 'lps'),
	(430916, 124, '2015-03-01 01:02:02.000000', 'consum', 0.0220, 'lps'),
	(430917, 124, '2015-03-01 01:02:03.000000', 'consum', 0.0222, 'lps'),
	(430918, 124, '2015-03-01 01:02:04.000000', 'consum', 0.0217, 'lps'),
	(430919, 124, '2015-03-01 01:02:05.000000', 'consum', 0.0235, 'lps'),
	(430920, 124, '2015-03-01 01:02:06.000000', 'consum', 0.0235, 'lps'),
	(430921, 124, '2015-03-01 01:02:07.000000', 'consum', 0.0234, 'lps'),
	(430922, 124, '2015-03-01 01:02:08.000000', 'consum', 0.0231, 'lps'),
	(430923, 124, '2015-03-01 01:02:09.000000', 'consum', 0.0216, 'lps'),
	(430924, 124, '2015-03-01 01:02:10.000000', 'consum', 0.0230, 'lps'),
	(430925, 124, '2015-03-01 01:02:11.000000', 'consum', 0.0216, 'lps'),
	(430926, 124, '2015-03-01 01:02:12.000000', 'consum', 0.0233, 'lps'),
	(430927, 124, '2015-03-01 01:02:13.000000', 'consum', 0.0226, 'lps'),
	(430928, 124, '2015-03-01 01:02:14.000000', 'consum', 0.0225, 'lps'),
	(430929, 124, '2015-03-01 01:02:15.000000', 'consum', 0.0211, 'lps'),
	(430930, 124, '2015-03-01 01:02:16.000000', 'consum', 0.0223, 'lps'),
	(430931, 124, '2015-03-01 01:02:17.000000', 'consum', 0.0219, 'lps'),
	(430932, 124, '2015-03-01 01:02:18.000000', 'consum', 0.0217, 'lps'),
	(430933, 124, '2015-03-01 01:02:19.000000', 'consum', 0.0218, 'lps'),
	(430934, 124, '2015-03-01 01:02:20.000000', 'consum', 0.0231, 'lps'),
	(430935, 124, '2015-03-01 01:02:21.000000', 'consum', 0.0213, 'lps'),
	(430936, 124, '2015-03-01 01:02:22.000000', 'consum', 0.0216, 'lps'),
	(430937, 124, '2015-03-01 01:02:23.000000', 'consum', 0.0231, 'lps'),
	(430938, 124, '2015-03-01 01:02:24.000000', 'consum', 0.0217, 'lps'),
	(430939, 124, '2015-03-01 01:02:25.000000', 'consum', 0.0211, 'lps'),
	(430940, 124, '2015-03-01 01:02:26.000000', 'consum', 0.0221, 'lps'),
	(430941, 124, '2015-03-01 01:02:27.000000', 'consum', 0.0235, 'lps'),
	(430942, 124, '2015-03-01 01:02:28.000000', 'consum', 0.0223, 'lps'),
	(430943, 124, '2015-03-01 01:02:29.000000', 'consum', 0.0229, 'lps'),
	(430944, 124, '2015-03-01 01:02:30.000000', 'consum', 0.0213, 'lps'),
	(430945, 124, '2015-03-01 01:02:31.000000', 'consum', 0.0222, 'lps'),
	(430946, 124, '2015-03-01 01:02:32.000000', 'consum', 0.0234, 'lps'),
	(430947, 124, '2015-03-01 01:02:33.000000', 'consum', 0.0218, 'lps'),
	(430948, 124, '2015-03-01 01:02:34.000000', 'consum', 0.0228, 'lps'),
	(430949, 124, '2015-03-01 01:02:35.000000', 'consum', 0.0226, 'lps'),
	(430950, 124, '2015-03-01 01:02:36.000000', 'consum', 0.0210, 'lps'),
	(430951, 124, '2015-03-01 01:02:37.000000', 'consum', 0.0216, 'lps'),
	(430952, 124, '2015-03-01 01:02:38.000000', 'consum', 0.0215, 'lps'),
	(430953, 124, '2015-03-01 01:02:39.000000', 'consum', 0.0216, 'lps'),
	(430954, 124, '2015-03-01 01:02:40.000000', 'consum', 0.0226, 'lps'),
	(430955, 124, '2015-03-01 01:02:41.000000', 'consum', 0.0220, 'lps'),
	(430956, 124, '2015-03-01 01:02:42.000000', 'consum', 0.0214, 'lps'),
	(430957, 124, '2015-03-01 01:02:43.000000', 'consum', 0.0226, 'lps'),
	(430958, 124, '2015-03-01 01:02:44.000000', 'consum', 0.0226, 'lps'),
	(430959, 124, '2015-03-01 01:02:45.000000', 'consum', 0.0217, 'lps'),
	(430960, 124, '2015-03-01 01:02:46.000000', 'consum', 0.0222, 'lps'),
	(430961, 124, '2015-03-01 01:02:47.000000', 'consum', 0.0226, 'lps'),
	(430962, 124, '2015-03-01 01:02:48.000000', 'consum', 0.0229, 'lps'),
	(430963, 124, '2015-03-01 01:02:49.000000', 'consum', 0.0229, 'lps'),
	(430964, 124, '2015-03-01 01:02:50.000000', 'consum', 0.0221, 'lps'),
	(430965, 124, '2015-03-01 01:02:51.000000', 'consum', 0.0212, 'lps'),
	(430966, 124, '2015-03-01 01:02:52.000000', 'consum', 0.0214, 'lps'),
	(430967, 124, '2015-03-01 01:02:53.000000', 'consum', 0.0221, 'lps'),
	(430968, 124, '2015-03-01 01:02:54.000000', 'consum', 0.0231, 'lps'),
	(430969, 124, '2015-03-01 01:02:55.000000', 'consum', 0.0227, 'lps'),
	(430970, 124, '2015-03-01 01:02:56.000000', 'consum', 0.0210, 'lps'),
	(430971, 124, '2015-03-01 01:02:57.000000', 'consum', 0.0210, 'lps'),
	(430972, 124, '2015-03-01 01:02:58.000000', 'consum', 0.0210, 'lps'),
	(430973, 124, '2015-03-01 01:02:59.000000', 'consum', 0.0210, 'lps'),
	(430974, 124, '2015-03-01 01:03:00.000000', 'consum', 0.0213, 'lps'),
	(430975, 124, '2015-03-01 01:03:01.000000', 'consum', 0.0224, 'lps'),
	(430976, 124, '2015-03-01 01:03:02.000000', 'consum', 0.0218, 'lps'),
	(430977, 124, '2015-03-01 01:03:03.000000', 'consum', 0.0211, 'lps'),
	(430978, 124, '2015-03-01 01:03:04.000000', 'consum', 0.0218, 'lps'),
	(430979, 124, '2015-03-01 01:03:05.000000', 'consum', 0.0221, 'lps'),
	(430980, 124, '2015-03-01 01:03:06.000000', 'consum', 0.0216, 'lps'),
	(430981, 124, '2015-03-01 01:03:07.000000', 'consum', 0.0232, 'lps'),
	(430982, 124, '2015-03-01 01:03:08.000000', 'consum', 0.0226, 'lps'),
	(430983, 124, '2015-03-01 01:03:09.000000', 'consum', 0.0225, 'lps'),
	(430984, 124, '2015-03-01 01:03:10.000000', 'consum', 0.0210, 'lps'),
	(430985, 124, '2015-03-01 01:03:11.000000', 'consum', 0.0220, 'lps'),
	(430986, 124, '2015-03-01 01:03:12.000000', 'consum', 0.0232, 'lps'),
	(430987, 124, '2015-03-01 01:03:13.000000', 'consum', 0.0212, 'lps'),
	(430988, 124, '2015-03-01 01:03:14.000000', 'consum', 0.0234, 'lps'),
	(430989, 124, '2015-03-01 01:03:15.000000', 'consum', 0.0218, 'lps'),
	(430990, 124, '2015-03-01 01:03:16.000000', 'consum', 0.0232, 'lps'),
	(430991, 124, '2015-03-01 01:03:17.000000', 'consum', 0.0219, 'lps'),
	(430992, 124, '2015-03-01 01:03:18.000000', 'consum', 0.0215, 'lps'),
	(430993, 124, '2015-03-01 01:03:19.000000', 'consum', 0.0210, 'lps'),
	(430994, 124, '2015-03-01 01:03:20.000000', 'consum', 0.0222, 'lps'),
	(430995, 124, '2015-03-01 01:03:21.000000', 'consum', 0.0219, 'lps'),
	(430996, 124, '2015-03-01 01:03:22.000000', 'consum', 0.0219, 'lps'),
	(430997, 124, '2015-03-01 01:03:23.000000', 'consum', 0.0230, 'lps'),
	(430998, 124, '2015-03-01 01:03:24.000000', 'consum', 0.0229, 'lps'),
	(430999, 124, '2015-03-01 01:03:25.000000', 'consum', 0.0222, 'lps'),
	(431000, 124, '2015-03-01 01:03:26.000000', 'consum', 0.0214, 'lps'),
	(431001, 124, '2015-03-01 01:03:27.000000', 'consum', 0.0218, 'lps'),
	(431002, 124, '2015-03-01 01:03:28.000000', 'consum', 0.0215, 'lps'),
	(431003, 124, '2015-03-01 01:03:29.000000', 'consum', 0.0235, 'lps'),
	(431004, 124, '2015-03-01 01:03:30.000000', 'consum', 0.0216, 'lps'),
	(431005, 124, '2015-03-01 01:03:31.000000', 'consum', 0.0218, 'lps'),
	(431006, 124, '2015-03-01 01:03:32.000000', 'consum', 0.0231, 'lps'),
	(431007, 124, '2015-03-01 01:03:33.000000', 'consum', 0.0215, 'lps'),
	(431008, 124, '2015-03-01 01:03:34.000000', 'consum', 0.0226, 'lps'),
	(431009, 124, '2015-03-01 01:03:35.000000', 'consum', 0.0223, 'lps'),
	(431010, 124, '2015-03-01 01:03:36.000000', 'consum', 0.0228, 'lps'),
	(431011, 124, '2015-03-01 01:03:37.000000', 'consum', 0.0235, 'lps'),
	(431012, 124, '2015-03-01 01:03:38.000000', 'consum', 0.0227, 'lps'),
	(431013, 124, '2015-03-01 01:03:39.000000', 'consum', 0.0224, 'lps'),
	(431014, 124, '2015-03-01 01:03:40.000000', 'consum', 0.0229, 'lps'),
	(431015, 124, '2015-03-01 01:03:41.000000', 'consum', 0.0211, 'lps'),
	(431016, 124, '2015-03-01 01:03:42.000000', 'consum', 0.0212, 'lps'),
	(431017, 124, '2015-03-01 01:03:43.000000', 'consum', 0.0217, 'lps'),
	(431018, 124, '2015-03-01 01:03:44.000000', 'consum', 0.0215, 'lps'),
	(431019, 124, '2015-03-01 01:03:45.000000', 'consum', 0.0213, 'lps'),
	(431020, 124, '2015-03-01 01:03:46.000000', 'consum', 0.0212, 'lps'),
	(431021, 124, '2015-03-01 01:03:47.000000', 'consum', 0.0211, 'lps'),
	(431022, 124, '2015-03-01 01:03:48.000000', 'consum', 0.0211, 'lps'),
	(431023, 124, '2015-03-01 01:03:49.000000', 'consum', 0.0212, 'lps'),
	(431024, 124, '2015-03-01 01:03:50.000000', 'consum', 0.0215, 'lps'),
	(431025, 124, '2015-03-01 01:03:51.000000', 'consum', 0.0230, 'lps'),
	(431026, 124, '2015-03-01 01:03:52.000000', 'consum', 0.0220, 'lps'),
	(431027, 124, '2015-03-01 01:03:53.000000', 'consum', 0.0223, 'lps'),
	(431028, 124, '2015-03-01 01:03:54.000000', 'consum', 0.0223, 'lps'),
	(431029, 124, '2015-03-01 01:03:55.000000', 'consum', 0.0235, 'lps'),
	(431030, 124, '2015-03-01 01:03:56.000000', 'consum', 0.0218, 'lps'),
	(431031, 124, '2015-03-01 01:03:57.000000', 'consum', 0.0228, 'lps'),
	(431032, 124, '2015-03-01 01:03:58.000000', 'consum', 0.0223, 'lps'),
	(431033, 124, '2015-03-01 01:03:59.000000', 'consum', 0.0224, 'lps'),
	(431034, 124, '2015-03-01 01:04:00.000000', 'consum', 0.0215, 'lps'),
	(431035, 124, '2015-03-01 01:04:01.000000', 'consum', 0.0221, 'lps'),
	(431036, 124, '2015-03-01 01:04:02.000000', 'consum', 0.0224, 'lps'),
	(431037, 124, '2015-03-01 01:04:03.000000', 'consum', 0.0220, 'lps'),
	(431038, 124, '2015-03-01 01:04:04.000000', 'consum', 0.0219, 'lps'),
	(431039, 124, '2015-03-01 01:04:05.000000', 'consum', 0.0227, 'lps'),
	(431040, 124, '2015-03-01 01:04:06.000000', 'consum', 0.0216, 'lps'),
	(431041, 124, '2015-03-01 01:04:07.000000', 'consum', 0.0214, 'lps'),
	(431042, 124, '2015-03-01 01:04:08.000000', 'consum', 0.0215, 'lps'),
	(431043, 124, '2015-03-01 01:04:09.000000', 'consum', 0.0222, 'lps'),
	(431044, 124, '2015-03-01 01:04:10.000000', 'consum', 0.0230, 'lps'),
	(431045, 124, '2015-03-01 01:04:11.000000', 'consum', 0.0220, 'lps'),
	(431046, 124, '2015-03-01 01:04:12.000000', 'consum', 0.0230, 'lps'),
	(431047, 124, '2015-03-01 01:04:13.000000', 'consum', 0.0226, 'lps'),
	(431048, 124, '2015-03-01 01:04:14.000000', 'consum', 0.0230, 'lps'),
	(431049, 124, '2015-03-01 01:04:15.000000', 'consum', 0.0210, 'lps'),
	(431050, 124, '2015-03-01 01:04:16.000000', 'consum', 0.0229, 'lps'),
	(431051, 124, '2015-03-01 01:04:17.000000', 'consum', 0.0227, 'lps'),
	(431052, 124, '2015-03-01 01:04:18.000000', 'consum', 0.0215, 'lps'),
	(431053, 124, '2015-03-01 01:04:19.000000', 'consum', 0.0233, 'lps'),
	(431054, 124, '2015-03-01 01:04:20.000000', 'consum', 0.0210, 'lps'),
	(431055, 124, '2015-03-01 01:04:21.000000', 'consum', 0.0217, 'lps'),
	(431056, 124, '2015-03-01 01:04:22.000000', 'consum', 0.0222, 'lps'),
	(431057, 124, '2015-03-01 01:04:23.000000', 'consum', 0.0223, 'lps'),
	(431058, 124, '2015-03-01 01:04:24.000000', 'consum', 0.0214, 'lps'),
	(431059, 124, '2015-03-01 01:04:25.000000', 'consum', 0.0217, 'lps'),
	(431060, 124, '2015-03-01 01:04:26.000000', 'consum', 0.0234, 'lps'),
	(431061, 124, '2015-03-01 01:04:27.000000', 'consum', 0.0231, 'lps'),
	(431062, 124, '2015-03-01 01:04:28.000000', 'consum', 0.0217, 'lps'),
	(431063, 124, '2015-03-01 01:04:29.000000', 'consum', 0.0235, 'lps'),
	(431064, 124, '2015-03-01 01:04:30.000000', 'consum', 0.0210, 'lps'),
	(431065, 124, '2015-03-01 01:04:31.000000', 'consum', 0.0214, 'lps'),
	(431066, 124, '2015-03-01 01:04:32.000000', 'consum', 0.0232, 'lps'),
	(431067, 124, '2015-03-01 01:04:33.000000', 'consum', 0.0228, 'lps'),
	(431068, 124, '2015-03-01 01:04:34.000000', 'consum', 0.0211, 'lps'),
	(431069, 124, '2015-03-01 01:04:35.000000', 'consum', 0.0211, 'lps'),
	(431070, 124, '2015-03-01 01:04:36.000000', 'consum', 0.0214, 'lps'),
	(431071, 124, '2015-03-01 01:04:37.000000', 'consum', 0.0228, 'lps'),
	(431072, 124, '2015-03-01 01:04:38.000000', 'consum', 0.0210, 'lps'),
	(431073, 124, '2015-03-01 01:04:39.000000', 'consum', 0.0210, 'lps'),
	(431074, 124, '2015-03-01 01:04:40.000000', 'consum', 0.0211, 'lps'),
	(431075, 124, '2015-03-01 01:04:41.000000', 'consum', 0.0216, 'lps'),
	(431076, 124, '2015-03-01 01:04:42.000000', 'consum', 0.0212, 'lps'),
	(431077, 124, '2015-03-01 01:04:43.000000', 'consum', 0.0229, 'lps'),
	(431078, 124, '2015-03-01 01:04:44.000000', 'consum', 0.0220, 'lps'),
	(431079, 124, '2015-03-01 01:04:45.000000', 'consum', 0.0231, 'lps'),
	(431080, 124, '2015-03-01 01:04:46.000000', 'consum', 0.0232, 'lps'),
	(431081, 124, '2015-03-01 01:04:47.000000', 'consum', 0.0230, 'lps'),
	(431082, 124, '2015-03-01 01:04:48.000000', 'consum', 0.0222, 'lps'),
	(431083, 124, '2015-03-01 01:04:49.000000', 'consum', 0.0234, 'lps'),
	(431084, 124, '2015-03-01 01:04:50.000000', 'consum', 0.0218, 'lps'),
	(431085, 124, '2015-03-01 01:04:51.000000', 'consum', 0.0232, 'lps'),
	(431086, 124, '2015-03-01 01:04:52.000000', 'consum', 0.0215, 'lps'),
	(431087, 124, '2015-03-01 01:04:53.000000', 'consum', 0.0223, 'lps'),
	(431088, 124, '2015-03-01 01:04:54.000000', 'consum', 0.0233, 'lps'),
	(431089, 124, '2015-03-01 01:04:55.000000', 'consum', 0.0235, 'lps'),
	(431090, 124, '2015-03-01 01:04:56.000000', 'consum', 0.0216, 'lps'),
	(431091, 124, '2015-03-01 01:04:57.000000', 'consum', 0.0216, 'lps'),
	(431092, 124, '2015-03-01 01:04:58.000000', 'consum', 0.0222, 'lps'),
	(431093, 124, '2015-03-01 01:04:59.000000', 'consum', 0.0229, 'lps'),
	(431094, 124, '2015-03-01 01:05:00.000000', 'consum', 0.0217, 'lps'),
	(431095, 124, '2015-03-01 01:05:01.000000', 'consum', 0.0216, 'lps'),
	(431096, 124, '2015-03-01 01:05:02.000000', 'consum', 0.0218, 'lps'),
	(431097, 124, '2015-03-01 01:05:03.000000', 'consum', 0.0232, 'lps'),
	(431098, 124, '2015-03-01 01:05:04.000000', 'consum', 0.0221, 'lps'),
	(431099, 124, '2015-03-01 01:05:05.000000', 'consum', 0.0224, 'lps'),
	(431100, 124, '2015-03-01 01:05:06.000000', 'consum', 0.0222, 'lps'),
	(431101, 124, '2015-03-01 01:05:07.000000', 'consum', 0.0228, 'lps'),
	(431102, 124, '2015-03-01 01:05:08.000000', 'consum', 0.0212, 'lps'),
	(431103, 124, '2015-03-01 01:05:09.000000', 'consum', 0.0218, 'lps'),
	(431104, 124, '2015-03-01 01:05:10.000000', 'consum', 0.0218, 'lps'),
	(431105, 124, '2015-03-01 01:05:11.000000', 'consum', 0.0226, 'lps'),
	(431106, 124, '2015-03-01 01:05:12.000000', 'consum', 0.0215, 'lps'),
	(431107, 124, '2015-03-01 01:05:13.000000', 'consum', 0.0215, 'lps'),
	(431108, 124, '2015-03-01 01:05:14.000000', 'consum', 0.0221, 'lps'),
	(431109, 124, '2015-03-01 01:05:15.000000', 'consum', 0.0222, 'lps'),
	(431110, 124, '2015-03-01 01:05:16.000000', 'consum', 0.0212, 'lps'),
	(431111, 124, '2015-03-01 01:05:17.000000', 'consum', 0.0212, 'lps'),
	(431112, 124, '2015-03-01 01:05:18.000000', 'consum', 0.0214, 'lps'),
	(431113, 124, '2015-03-01 01:05:19.000000', 'consum', 0.0225, 'lps'),
	(431114, 124, '2015-03-01 01:05:20.000000', 'consum', 0.0220, 'lps'),
	(431115, 124, '2015-03-01 01:05:21.000000', 'consum', 0.0217, 'lps'),
	(431116, 124, '2015-03-01 01:05:22.000000', 'consum', 0.0217, 'lps'),
	(431117, 124, '2015-03-01 01:05:23.000000', 'consum', 0.0222, 'lps'),
	(431118, 124, '2015-03-01 01:05:24.000000', 'consum', 0.0225, 'lps'),
	(431119, 124, '2015-03-01 01:05:25.000000', 'consum', 0.0221, 'lps'),
	(431120, 124, '2015-03-01 01:05:26.000000', 'consum', 0.0223, 'lps'),
	(431121, 124, '2015-03-01 01:05:27.000000', 'consum', 0.0218, 'lps'),
	(431122, 124, '2015-03-01 01:05:28.000000', 'consum', 0.0235, 'lps'),
	(431123, 124, '2015-03-01 01:05:29.000000', 'consum', 0.0232, 'lps'),
	(431124, 124, '2015-03-01 01:05:30.000000', 'consum', 0.0221, 'lps'),
	(431125, 124, '2015-03-01 01:05:31.000000', 'consum', 0.0226, 'lps'),
	(431126, 124, '2015-03-01 01:05:32.000000', 'consum', 0.0230, 'lps'),
	(431127, 124, '2015-03-01 01:05:33.000000', 'consum', 0.0210, 'lps'),
	(431128, 124, '2015-03-01 01:05:34.000000', 'consum', 0.0231, 'lps'),
	(431129, 124, '2015-03-01 01:05:35.000000', 'consum', 0.0210, 'lps'),
	(431130, 124, '2015-03-01 01:05:36.000000', 'consum', 0.0225, 'lps'),
	(431131, 124, '2015-03-01 01:05:37.000000', 'consum', 0.0234, 'lps'),
	(431132, 124, '2015-03-01 01:05:38.000000', 'consum', 0.0232, 'lps'),
	(431133, 124, '2015-03-01 01:05:39.000000', 'consum', 0.0223, 'lps'),
	(431134, 124, '2015-03-01 01:05:40.000000', 'consum', 0.0212, 'lps'),
	(431135, 124, '2015-03-01 01:05:41.000000', 'consum', 0.0231, 'lps'),
	(431136, 124, '2015-03-01 01:05:42.000000', 'consum', 0.0233, 'lps'),
	(431137, 124, '2015-03-01 01:05:43.000000', 'consum', 0.0212, 'lps'),
	(431138, 124, '2015-03-01 01:05:44.000000', 'consum', 0.0227, 'lps'),
	(431139, 124, '2015-03-01 01:05:45.000000', 'consum', 0.0212, 'lps'),
	(431140, 124, '2015-03-01 01:05:46.000000', 'consum', 0.0221, 'lps'),
	(431141, 124, '2015-03-01 01:05:47.000000', 'consum', 0.0235, 'lps'),
	(431142, 124, '2015-03-01 01:05:48.000000', 'consum', 0.0223, 'lps'),
	(431143, 124, '2015-03-01 01:05:49.000000', 'consum', 0.0226, 'lps'),
	(431144, 124, '2015-03-01 01:05:50.000000', 'consum', 0.0227, 'lps'),
	(431145, 124, '2015-03-01 01:05:51.000000', 'consum', 0.0221, 'lps'),
	(431146, 124, '2015-03-01 01:05:52.000000', 'consum', 0.0216, 'lps'),
	(431147, 124, '2015-03-01 01:05:53.000000', 'consum', 0.0232, 'lps'),
	(431148, 124, '2015-03-01 01:05:54.000000', 'consum', 0.0226, 'lps'),
	(431149, 124, '2015-03-01 01:05:55.000000', 'consum', 0.0224, 'lps'),
	(431150, 124, '2015-03-01 01:05:56.000000', 'consum', 0.0232, 'lps'),
	(431151, 124, '2015-03-01 01:05:57.000000', 'consum', 0.0227, 'lps'),
	(431152, 124, '2015-03-01 01:05:58.000000', 'consum', 0.0228, 'lps'),
	(431153, 124, '2015-03-01 01:05:59.000000', 'consum', 0.0224, 'lps'),
	(431154, 124, '2015-03-01 01:06:00.000000', 'consum', 0.0225, 'lps'),
	(431155, 124, '2015-03-01 01:06:01.000000', 'consum', 0.0219, 'lps'),
	(431156, 124, '2015-03-01 01:06:02.000000', 'consum', 0.0212, 'lps'),
	(431157, 124, '2015-03-01 01:06:03.000000', 'consum', 0.0217, 'lps'),
	(431158, 124, '2015-03-01 01:06:04.000000', 'consum', 0.0216, 'lps'),
	(431159, 124, '2015-03-01 01:06:05.000000', 'consum', 0.0216, 'lps'),
	(431160, 124, '2015-03-01 01:06:06.000000', 'consum', 0.0226, 'lps'),
	(431161, 124, '2015-03-01 01:06:07.000000', 'consum', 0.0218, 'lps'),
	(431162, 124, '2015-03-01 01:06:08.000000', 'consum', 0.0230, 'lps'),
	(431163, 124, '2015-03-01 01:06:09.000000', 'consum', 0.0233, 'lps'),
	(431164, 124, '2015-03-01 01:06:10.000000', 'consum', 0.0213, 'lps'),
	(431165, 124, '2015-03-01 01:06:11.000000', 'consum', 0.0233, 'lps'),
	(431166, 124, '2015-03-01 01:06:12.000000', 'consum', 0.0216, 'lps'),
	(431167, 124, '2015-03-01 01:06:13.000000', 'consum', 0.0222, 'lps'),
	(431168, 124, '2015-03-01 01:06:14.000000', 'consum', 0.0227, 'lps'),
	(431169, 124, '2015-03-01 01:06:15.000000', 'consum', 0.0235, 'lps'),
	(431170, 124, '2015-03-01 01:06:16.000000', 'consum', 0.0231, 'lps'),
	(431171, 124, '2015-03-01 01:06:17.000000', 'consum', 0.0217, 'lps'),
	(431172, 124, '2015-03-01 01:06:18.000000', 'consum', 0.0232, 'lps'),
	(431173, 124, '2015-03-01 01:06:19.000000', 'consum', 0.0221, 'lps'),
	(431174, 124, '2015-03-01 01:06:20.000000', 'consum', 0.0225, 'lps'),
	(431175, 124, '2015-03-01 01:06:21.000000', 'consum', 0.0227, 'lps'),
	(431176, 124, '2015-03-01 01:06:22.000000', 'consum', 0.0225, 'lps'),
	(431177, 124, '2015-03-01 01:06:23.000000', 'consum', 0.0234, 'lps'),
	(431178, 124, '2015-03-01 01:06:24.000000', 'consum', 0.0233, 'lps'),
	(431179, 124, '2015-03-01 01:06:25.000000', 'consum', 0.0228, 'lps'),
	(431180, 124, '2015-03-01 01:06:26.000000', 'consum', 0.0232, 'lps'),
	(431181, 124, '2015-03-01 01:06:27.000000', 'consum', 0.0216, 'lps'),
	(431182, 124, '2015-03-01 01:06:28.000000', 'consum', 0.0225, 'lps'),
	(431183, 124, '2015-03-01 01:06:29.000000', 'consum', 0.0214, 'lps'),
	(431184, 124, '2015-03-01 01:06:30.000000', 'consum', 0.0212, 'lps'),
	(431185, 124, '2015-03-01 01:06:31.000000', 'consum', 0.0235, 'lps'),
	(431186, 124, '2015-03-01 01:06:32.000000', 'consum', 0.0228, 'lps'),
	(431187, 124, '2015-03-01 01:06:33.000000', 'consum', 0.0222, 'lps'),
	(431188, 124, '2015-03-01 01:06:34.000000', 'consum', 0.0217, 'lps'),
	(431189, 124, '2015-03-01 01:06:35.000000', 'consum', 0.0210, 'lps'),
	(431190, 124, '2015-03-01 01:06:36.000000', 'consum', 0.0216, 'lps'),
	(431191, 124, '2015-03-01 01:06:37.000000', 'consum', 0.0214, 'lps'),
	(431192, 124, '2015-03-01 01:06:38.000000', 'consum', 0.0211, 'lps'),
	(431193, 124, '2015-03-01 01:06:39.000000', 'consum', 0.0230, 'lps'),
	(431194, 124, '2015-03-01 01:06:40.000000', 'consum', 0.0228, 'lps'),
	(431195, 124, '2015-03-01 01:06:41.000000', 'consum', 0.0217, 'lps'),
	(431196, 124, '2015-03-01 01:06:42.000000', 'consum', 0.0216, 'lps'),
	(431197, 124, '2015-03-01 01:06:43.000000', 'consum', 0.0220, 'lps'),
	(431198, 124, '2015-03-01 01:06:44.000000', 'consum', 0.0216, 'lps'),
	(431199, 124, '2015-03-01 01:06:45.000000', 'consum', 0.0212, 'lps'),
	(431200, 124, '2015-03-01 01:06:46.000000', 'consum', 0.0228, 'lps'),
	(431201, 124, '2015-03-01 01:06:47.000000', 'consum', 0.0218, 'lps'),
	(431202, 124, '2015-03-01 01:06:48.000000', 'consum', 0.0220, 'lps'),
	(431203, 124, '2015-03-01 01:06:49.000000', 'consum', 0.0210, 'lps'),
	(431204, 124, '2015-03-01 01:06:50.000000', 'consum', 0.0234, 'lps'),
	(431205, 124, '2015-03-01 01:06:51.000000', 'consum', 0.0225, 'lps'),
	(431206, 124, '2015-03-01 01:06:52.000000', 'consum', 0.0215, 'lps'),
	(431207, 124, '2015-03-01 01:06:53.000000', 'consum', 0.0218, 'lps'),
	(431208, 124, '2015-03-01 01:06:54.000000', 'consum', 0.0234, 'lps'),
	(431209, 124, '2015-03-01 01:06:55.000000', 'consum', 0.0227, 'lps'),
	(431210, 124, '2015-03-01 01:06:56.000000', 'consum', 0.0226, 'lps'),
	(431211, 124, '2015-03-01 01:06:57.000000', 'consum', 0.0213, 'lps'),
	(431212, 124, '2015-03-01 01:06:58.000000', 'consum', 0.0230, 'lps'),
	(431213, 124, '2015-03-01 01:06:59.000000', 'consum', 0.0225, 'lps'),
	(431214, 124, '2015-03-01 01:07:00.000000', 'consum', 0.0223, 'lps'),
	(431215, 124, '2015-03-01 01:07:01.000000', 'consum', 0.0229, 'lps'),
	(431216, 124, '2015-03-01 01:07:02.000000', 'consum', 0.0217, 'lps'),
	(431217, 124, '2015-03-01 01:07:03.000000', 'consum', 0.0215, 'lps'),
	(431218, 124, '2015-03-01 01:07:04.000000', 'consum', 0.0212, 'lps'),
	(431219, 124, '2015-03-01 01:07:05.000000', 'consum', 0.0234, 'lps'),
	(431220, 124, '2015-03-01 01:07:06.000000', 'consum', 0.0219, 'lps'),
	(431221, 124, '2015-03-01 01:07:07.000000', 'consum', 0.0211, 'lps'),
	(431222, 124, '2015-03-01 01:07:08.000000', 'consum', 0.0213, 'lps'),
	(431223, 124, '2015-03-01 01:07:09.000000', 'consum', 0.0225, 'lps'),
	(431224, 124, '2015-03-01 01:07:10.000000', 'consum', 0.0222, 'lps'),
	(431225, 124, '2015-03-01 01:07:11.000000', 'consum', 0.0225, 'lps'),
	(431226, 124, '2015-03-01 01:07:12.000000', 'consum', 0.0225, 'lps'),
	(431227, 124, '2015-03-01 01:07:13.000000', 'consum', 0.0214, 'lps'),
	(431228, 124, '2015-03-01 01:07:14.000000', 'consum', 0.0211, 'lps'),
	(431229, 124, '2015-03-01 01:07:15.000000', 'consum', 0.0229, 'lps'),
	(431230, 124, '2015-03-01 01:07:16.000000', 'consum', 0.0227, 'lps'),
	(431231, 124, '2015-03-01 01:07:17.000000', 'consum', 0.0212, 'lps'),
	(431232, 124, '2015-03-01 01:07:18.000000', 'consum', 0.0222, 'lps'),
	(431233, 124, '2015-03-01 01:07:19.000000', 'consum', 0.0210, 'lps'),
	(431234, 124, '2015-03-01 01:07:20.000000', 'consum', 0.0229, 'lps'),
	(431235, 124, '2015-03-01 01:07:21.000000', 'consum', 0.0228, 'lps'),
	(431236, 124, '2015-03-01 01:07:22.000000', 'consum', 0.0215, 'lps'),
	(431237, 124, '2015-03-01 01:07:23.000000', 'consum', 0.0210, 'lps'),
	(431238, 124, '2015-03-01 01:07:24.000000', 'consum', 0.0218, 'lps'),
	(431239, 124, '2015-03-01 01:07:25.000000', 'consum', 0.0228, 'lps'),
	(431240, 124, '2015-03-01 01:07:26.000000', 'consum', 0.0223, 'lps'),
	(431241, 124, '2015-03-01 01:07:27.000000', 'consum', 0.0220, 'lps'),
	(431242, 124, '2015-03-01 01:07:28.000000', 'consum', 0.0222, 'lps'),
	(431243, 124, '2015-03-01 01:07:29.000000', 'consum', 0.0216, 'lps'),
	(431244, 124, '2015-03-01 01:07:30.000000', 'consum', 0.0231, 'lps'),
	(431245, 124, '2015-03-01 01:07:31.000000', 'consum', 0.0219, 'lps'),
	(431246, 124, '2015-03-01 01:07:32.000000', 'consum', 0.0217, 'lps'),
	(431247, 124, '2015-03-01 01:07:33.000000', 'consum', 0.0219, 'lps'),
	(431248, 124, '2015-03-01 01:07:34.000000', 'consum', 0.0210, 'lps'),
	(431249, 124, '2015-03-01 01:07:35.000000', 'consum', 0.0210, 'lps'),
	(431250, 124, '2015-03-01 01:07:36.000000', 'consum', 0.0211, 'lps'),
	(431251, 124, '2015-03-01 01:07:37.000000', 'consum', 0.0213, 'lps'),
	(431252, 124, '2015-03-01 01:07:38.000000', 'consum', 0.0222, 'lps'),
	(431253, 124, '2015-03-01 01:07:39.000000', 'consum', 0.0210, 'lps'),
	(431254, 124, '2015-03-01 01:07:40.000000', 'consum', 0.0225, 'lps'),
	(431255, 124, '2015-03-01 01:07:41.000000', 'consum', 0.0235, 'lps'),
	(431256, 124, '2015-03-01 01:07:42.000000', 'consum', 0.0212, 'lps'),
	(431257, 124, '2015-03-01 01:07:43.000000', 'consum', 0.0222, 'lps'),
	(431258, 124, '2015-03-01 01:07:44.000000', 'consum', 0.0213, 'lps'),
	(431259, 124, '2015-03-01 01:07:45.000000', 'consum', 0.0217, 'lps'),
	(431260, 124, '2015-03-01 01:07:46.000000', 'consum', 0.0235, 'lps'),
	(431261, 124, '2015-03-01 01:07:47.000000', 'consum', 0.0210, 'lps'),
	(431262, 124, '2015-03-01 01:07:48.000000', 'consum', 0.0212, 'lps'),
	(431263, 124, '2015-03-01 01:07:49.000000', 'consum', 0.0223, 'lps'),
	(431264, 124, '2015-03-01 01:07:50.000000', 'consum', 0.0216, 'lps'),
	(431265, 124, '2015-03-01 01:07:51.000000', 'consum', 0.0230, 'lps'),
	(431266, 124, '2015-03-01 01:07:52.000000', 'consum', 0.0213, 'lps'),
	(431267, 124, '2015-03-01 01:07:53.000000', 'consum', 0.0218, 'lps'),
	(431268, 124, '2015-03-01 01:07:54.000000', 'consum', 0.0214, 'lps'),
	(431269, 124, '2015-03-01 01:07:55.000000', 'consum', 0.0232, 'lps'),
	(431270, 124, '2015-03-01 01:07:56.000000', 'consum', 0.0229, 'lps'),
	(431271, 124, '2015-03-01 01:07:57.000000', 'consum', 0.0217, 'lps'),
	(431272, 124, '2015-03-01 01:07:58.000000', 'consum', 0.0212, 'lps'),
	(431273, 124, '2015-03-01 01:07:59.000000', 'consum', 0.0225, 'lps'),
	(431274, 124, '2015-03-01 01:08:00.000000', 'consum', 0.0227, 'lps'),
	(431275, 124, '2015-03-01 01:08:01.000000', 'consum', 0.0224, 'lps'),
	(431276, 124, '2015-03-01 01:08:02.000000', 'consum', 0.0230, 'lps'),
	(431277, 124, '2015-03-01 01:08:03.000000', 'consum', 0.0218, 'lps'),
	(431278, 124, '2015-03-01 01:08:04.000000', 'consum', 0.0217, 'lps'),
	(431279, 124, '2015-03-01 01:08:05.000000', 'consum', 0.0222, 'lps'),
	(431280, 124, '2015-03-01 01:08:06.000000', 'consum', 0.0224, 'lps'),
	(431281, 124, '2015-03-01 01:08:07.000000', 'consum', 0.0219, 'lps'),
	(431282, 124, '2015-03-01 01:08:08.000000', 'consum', 0.0212, 'lps'),
	(431283, 124, '2015-03-01 01:08:09.000000', 'consum', 0.0221, 'lps'),
	(431284, 124, '2015-03-01 01:08:10.000000', 'consum', 0.0234, 'lps'),
	(431285, 124, '2015-03-01 01:08:11.000000', 'consum', 0.0221, 'lps'),
	(431286, 124, '2015-03-01 01:08:12.000000', 'consum', 0.0216, 'lps'),
	(431287, 124, '2015-03-01 01:08:13.000000', 'consum', 0.0211, 'lps'),
	(431288, 124, '2015-03-01 01:08:14.000000', 'consum', 0.0220, 'lps'),
	(431289, 124, '2015-03-01 01:08:15.000000', 'consum', 0.0232, 'lps'),
	(431290, 124, '2015-03-01 01:08:16.000000', 'consum', 0.0213, 'lps'),
	(431291, 124, '2015-03-01 01:08:17.000000', 'consum', 0.0211, 'lps'),
	(431292, 124, '2015-03-01 01:08:18.000000', 'consum', 0.0235, 'lps'),
	(431293, 124, '2015-03-01 01:08:19.000000', 'consum', 0.0227, 'lps'),
	(431294, 124, '2015-03-01 01:08:20.000000', 'consum', 0.0221, 'lps'),
	(431295, 124, '2015-03-01 01:08:21.000000', 'consum', 0.0215, 'lps'),
	(431296, 124, '2015-03-01 01:08:22.000000', 'consum', 0.0226, 'lps'),
	(431297, 124, '2015-03-01 01:08:23.000000', 'consum', 0.0226, 'lps'),
	(431298, 124, '2015-03-01 01:08:24.000000', 'consum', 0.0216, 'lps'),
	(431299, 124, '2015-03-01 01:08:25.000000', 'consum', 0.0218, 'lps'),
	(431300, 124, '2015-03-01 01:08:26.000000', 'consum', 0.0232, 'lps'),
	(431301, 124, '2015-03-01 01:08:27.000000', 'consum', 0.0220, 'lps'),
	(431302, 124, '2015-03-01 01:08:28.000000', 'consum', 0.0221, 'lps'),
	(431303, 124, '2015-03-01 01:08:29.000000', 'consum', 0.0234, 'lps'),
	(431304, 124, '2015-03-01 01:08:30.000000', 'consum', 0.0219, 'lps'),
	(431305, 124, '2015-03-01 01:08:31.000000', 'consum', 0.0235, 'lps'),
	(431306, 124, '2015-03-01 01:08:32.000000', 'consum', 0.0232, 'lps'),
	(431307, 124, '2015-03-01 01:08:33.000000', 'consum', 0.0221, 'lps'),
	(431308, 124, '2015-03-01 01:08:34.000000', 'consum', 0.0223, 'lps'),
	(431309, 124, '2015-03-01 01:08:35.000000', 'consum', 0.0216, 'lps'),
	(431310, 124, '2015-03-01 01:08:36.000000', 'consum', 0.0230, 'lps'),
	(431311, 124, '2015-03-01 01:08:37.000000', 'consum', 0.0215, 'lps'),
	(431312, 124, '2015-03-01 01:08:38.000000', 'consum', 0.0224, 'lps'),
	(431313, 124, '2015-03-01 01:08:39.000000', 'consum', 0.0217, 'lps'),
	(431314, 124, '2015-03-01 01:08:40.000000', 'consum', 0.0229, 'lps'),
	(431315, 124, '2015-03-01 01:08:41.000000', 'consum', 0.0231, 'lps'),
	(431316, 124, '2015-03-01 01:08:42.000000', 'consum', 0.0233, 'lps'),
	(431317, 124, '2015-03-01 01:08:43.000000', 'consum', 0.0210, 'lps'),
	(431318, 124, '2015-03-01 01:08:44.000000', 'consum', 0.0221, 'lps'),
	(431319, 124, '2015-03-01 01:08:45.000000', 'consum', 0.0212, 'lps'),
	(431320, 124, '2015-03-01 01:08:46.000000', 'consum', 0.0214, 'lps'),
	(431321, 124, '2015-03-01 01:08:47.000000', 'consum', 0.0226, 'lps'),
	(431322, 124, '2015-03-01 01:08:48.000000', 'consum', 0.0224, 'lps'),
	(431323, 124, '2015-03-01 01:08:49.000000', 'consum', 0.0232, 'lps'),
	(431324, 124, '2015-03-01 01:08:50.000000', 'consum', 0.0226, 'lps'),
	(431325, 124, '2015-03-01 01:08:51.000000', 'consum', 0.0227, 'lps'),
	(431326, 124, '2015-03-01 01:08:52.000000', 'consum', 0.0219, 'lps'),
	(431327, 124, '2015-03-01 01:08:53.000000', 'consum', 0.0229, 'lps'),
	(431328, 124, '2015-03-01 01:08:54.000000', 'consum', 0.0230, 'lps'),
	(431329, 124, '2015-03-01 01:08:55.000000', 'consum', 0.0228, 'lps'),
	(431330, 124, '2015-03-01 01:08:56.000000', 'consum', 0.0212, 'lps'),
	(431331, 124, '2015-03-01 01:08:57.000000', 'consum', 0.0221, 'lps'),
	(431332, 124, '2015-03-01 01:08:58.000000', 'consum', 0.0232, 'lps'),
	(431333, 124, '2015-03-01 01:08:59.000000', 'consum', 0.0211, 'lps'),
	(431334, 124, '2015-03-01 01:09:00.000000', 'consum', 0.0226, 'lps'),
	(431335, 124, '2015-03-01 01:09:01.000000', 'consum', 0.0235, 'lps'),
	(431336, 124, '2015-03-01 01:09:02.000000', 'consum', 0.0235, 'lps'),
	(431337, 124, '2015-03-01 01:09:03.000000', 'consum', 0.0211, 'lps'),
	(431338, 124, '2015-03-01 01:09:04.000000', 'consum', 0.0219, 'lps'),
	(431339, 124, '2015-03-01 01:09:05.000000', 'consum', 0.0225, 'lps'),
	(431340, 124, '2015-03-01 01:09:06.000000', 'consum', 0.0231, 'lps'),
	(431341, 124, '2015-03-01 01:09:07.000000', 'consum', 0.0220, 'lps'),
	(431342, 124, '2015-03-01 01:09:08.000000', 'consum', 0.0225, 'lps'),
	(431343, 124, '2015-03-01 01:09:09.000000', 'consum', 0.0227, 'lps'),
	(431344, 124, '2015-03-01 01:09:10.000000', 'consum', 0.0224, 'lps'),
	(431345, 124, '2015-03-01 01:09:11.000000', 'consum', 0.0228, 'lps'),
	(431346, 124, '2015-03-01 01:09:12.000000', 'consum', 0.0210, 'lps'),
	(431347, 124, '2015-03-01 01:09:13.000000', 'consum', 0.0233, 'lps'),
	(431348, 124, '2015-03-01 01:09:14.000000', 'consum', 0.0223, 'lps'),
	(431349, 124, '2015-03-01 01:09:15.000000', 'consum', 0.0233, 'lps'),
	(431350, 124, '2015-03-01 01:09:16.000000', 'consum', 0.0232, 'lps'),
	(431351, 124, '2015-03-01 01:09:17.000000', 'consum', 0.0228, 'lps'),
	(431352, 124, '2015-03-01 01:09:18.000000', 'consum', 0.0235, 'lps'),
	(431353, 124, '2015-03-01 01:09:19.000000', 'consum', 0.0227, 'lps'),
	(431354, 124, '2015-03-01 01:09:20.000000', 'consum', 0.0220, 'lps'),
	(431355, 124, '2015-03-01 01:09:21.000000', 'consum', 0.0210, 'lps'),
	(431356, 124, '2015-03-01 01:09:22.000000', 'consum', 0.0234, 'lps'),
	(431357, 124, '2015-03-01 01:09:23.000000', 'consum', 0.0227, 'lps'),
	(431358, 124, '2015-03-01 01:09:24.000000', 'consum', 0.0223, 'lps'),
	(431359, 124, '2015-03-01 01:09:25.000000', 'consum', 0.0225, 'lps'),
	(431360, 124, '2015-03-01 01:09:26.000000', 'consum', 0.0220, 'lps'),
	(431361, 124, '2015-03-01 01:09:27.000000', 'consum', 0.0217, 'lps'),
	(431362, 124, '2015-03-01 01:09:28.000000', 'consum', 0.0215, 'lps'),
	(431363, 124, '2015-03-01 01:09:29.000000', 'consum', 0.0215, 'lps'),
	(431364, 124, '2015-03-01 01:09:30.000000', 'consum', 0.0220, 'lps'),
	(431365, 124, '2015-03-01 01:09:31.000000', 'consum', 0.0221, 'lps'),
	(431366, 124, '2015-03-01 01:09:32.000000', 'consum', 0.0233, 'lps'),
	(431367, 124, '2015-03-01 01:09:33.000000', 'consum', 0.0215, 'lps'),
	(431368, 124, '2015-03-01 01:09:34.000000', 'consum', 0.0220, 'lps'),
	(431369, 124, '2015-03-01 01:09:35.000000', 'consum', 0.0219, 'lps'),
	(431370, 124, '2015-03-01 01:09:36.000000', 'consum', 0.0224, 'lps'),
	(431371, 124, '2015-03-01 01:09:37.000000', 'consum', 0.0230, 'lps'),
	(431372, 124, '2015-03-01 01:09:38.000000', 'consum', 0.0216, 'lps'),
	(431373, 124, '2015-03-01 01:09:39.000000', 'consum', 0.0233, 'lps'),
	(431374, 124, '2015-03-01 01:09:40.000000', 'consum', 0.0229, 'lps'),
	(431375, 124, '2015-03-01 01:09:41.000000', 'consum', 0.0210, 'lps'),
	(431376, 124, '2015-03-01 01:09:42.000000', 'consum', 0.0232, 'lps'),
	(431377, 124, '2015-03-01 01:09:43.000000', 'consum', 0.0215, 'lps'),
	(431378, 124, '2015-03-01 01:09:44.000000', 'consum', 0.0224, 'lps'),
	(431379, 124, '2015-03-01 01:09:45.000000', 'consum', 0.0214, 'lps'),
	(431380, 124, '2015-03-01 01:09:46.000000', 'consum', 0.0211, 'lps'),
	(431381, 124, '2015-03-01 01:09:47.000000', 'consum', 0.0233, 'lps'),
	(431382, 124, '2015-03-01 01:09:48.000000', 'consum', 0.0216, 'lps'),
	(431383, 124, '2015-03-01 01:09:49.000000', 'consum', 0.0222, 'lps'),
	(431384, 124, '2015-03-01 01:09:50.000000', 'consum', 0.0229, 'lps'),
	(431385, 124, '2015-03-01 01:09:51.000000', 'consum', 0.0218, 'lps'),
	(431386, 124, '2015-03-01 01:09:52.000000', 'consum', 0.0219, 'lps'),
	(431387, 124, '2015-03-01 01:09:53.000000', 'consum', 0.0233, 'lps'),
	(431388, 124, '2015-03-01 01:09:54.000000', 'consum', 0.0220, 'lps'),
	(431389, 124, '2015-03-01 01:09:55.000000', 'consum', 0.0215, 'lps'),
	(431390, 124, '2015-03-01 01:09:56.000000', 'consum', 0.0235, 'lps'),
	(431391, 124, '2015-03-01 01:09:57.000000', 'consum', 0.0214, 'lps'),
	(431392, 124, '2015-03-01 01:09:58.000000', 'consum', 0.0210, 'lps'),
	(431393, 124, '2015-03-01 01:09:59.000000', 'consum', 0.0222, 'lps'),
	(431394, 124, '2015-03-01 01:10:00.000000', 'consum', 0.0221, 'lps'),
	(431395, 124, '2015-03-01 01:10:01.000000', 'consum', 0.0227, 'lps'),
	(431396, 124, '2015-03-01 01:10:02.000000', 'consum', 0.0212, 'lps'),
	(431397, 124, '2015-03-01 01:10:03.000000', 'consum', 0.0222, 'lps'),
	(431398, 124, '2015-03-01 01:10:04.000000', 'consum', 0.0214, 'lps'),
	(431399, 124, '2015-03-01 01:10:05.000000', 'consum', 0.0218, 'lps'),
	(431400, 124, '2015-03-01 01:10:06.000000', 'consum', 0.0214, 'lps'),
	(431401, 124, '2015-03-01 01:10:07.000000', 'consum', 0.0231, 'lps'),
	(431402, 124, '2015-03-01 01:10:08.000000', 'consum', 0.0225, 'lps'),
	(431403, 124, '2015-03-01 01:10:09.000000', 'consum', 0.0225, 'lps'),
	(431404, 124, '2015-03-01 01:10:10.000000', 'consum', 0.0213, 'lps'),
	(431405, 124, '2015-03-01 01:10:11.000000', 'consum', 0.0231, 'lps'),
	(431406, 124, '2015-03-01 01:10:12.000000', 'consum', 0.0229, 'lps'),
	(431407, 124, '2015-03-01 01:10:13.000000', 'consum', 0.0218, 'lps'),
	(431408, 124, '2015-03-01 01:10:14.000000', 'consum', 0.0219, 'lps'),
	(431409, 124, '2015-03-01 01:10:15.000000', 'consum', 0.0233, 'lps'),
	(431410, 124, '2015-03-01 01:10:16.000000', 'consum', 0.0221, 'lps'),
	(431411, 124, '2015-03-01 01:10:17.000000', 'consum', 0.0223, 'lps'),
	(431412, 124, '2015-03-01 01:10:18.000000', 'consum', 0.0214, 'lps'),
	(431413, 124, '2015-03-01 01:10:19.000000', 'consum', 0.0219, 'lps'),
	(431414, 124, '2015-03-01 01:10:20.000000', 'consum', 0.0218, 'lps'),
	(431415, 124, '2015-03-01 01:10:21.000000', 'consum', 0.0222, 'lps'),
	(431416, 124, '2015-03-01 01:10:22.000000', 'consum', 0.0222, 'lps'),
	(431417, 124, '2015-03-01 01:10:23.000000', 'consum', 0.0232, 'lps'),
	(431418, 124, '2015-03-01 01:10:24.000000', 'consum', 0.0233, 'lps'),
	(431419, 124, '2015-03-01 01:10:25.000000', 'consum', 0.0234, 'lps'),
	(431420, 124, '2015-03-01 01:10:26.000000', 'consum', 0.0210, 'lps'),
	(431421, 124, '2015-03-01 01:10:27.000000', 'consum', 0.0216, 'lps'),
	(431422, 124, '2015-03-01 01:10:28.000000', 'consum', 0.0213, 'lps'),
	(431423, 124, '2015-03-01 01:10:29.000000', 'consum', 0.0233, 'lps'),
	(431424, 124, '2015-03-01 01:10:30.000000', 'consum', 0.0216, 'lps'),
	(431425, 124, '2015-03-01 01:10:31.000000', 'consum', 0.0220, 'lps'),
	(431426, 124, '2015-03-01 01:10:32.000000', 'consum', 0.0218, 'lps'),
	(431427, 124, '2015-03-01 01:10:33.000000', 'consum', 0.0222, 'lps'),
	(431428, 124, '2015-03-01 01:10:34.000000', 'consum', 0.0219, 'lps'),
	(431429, 124, '2015-03-01 01:10:35.000000', 'consum', 0.0221, 'lps'),
	(431430, 124, '2015-03-01 01:10:36.000000', 'consum', 0.0211, 'lps'),
	(431431, 124, '2015-03-01 01:10:37.000000', 'consum', 0.0210, 'lps'),
	(431432, 124, '2015-03-01 01:10:38.000000', 'consum', 0.0234, 'lps'),
	(431433, 124, '2015-03-01 01:10:39.000000', 'consum', 0.0226, 'lps'),
	(431434, 124, '2015-03-01 01:10:40.000000', 'consum', 0.0219, 'lps'),
	(431435, 124, '2015-03-01 01:10:41.000000', 'consum', 0.0231, 'lps'),
	(431436, 124, '2015-03-01 01:10:42.000000', 'consum', 0.0211, 'lps'),
	(431437, 124, '2015-03-01 01:10:43.000000', 'consum', 0.0232, 'lps'),
	(431438, 124, '2015-03-01 01:10:44.000000', 'consum', 0.0213, 'lps'),
	(431439, 124, '2015-03-01 01:10:45.000000', 'consum', 0.0210, 'lps'),
	(431440, 124, '2015-03-01 01:10:46.000000', 'consum', 0.0230, 'lps'),
	(431441, 124, '2015-03-01 01:10:47.000000', 'consum', 0.0231, 'lps'),
	(431442, 124, '2015-03-01 01:10:48.000000', 'consum', 0.0228, 'lps'),
	(431443, 124, '2015-03-01 01:10:49.000000', 'consum', 0.0213, 'lps'),
	(431444, 124, '2015-03-01 01:10:50.000000', 'consum', 0.0221, 'lps'),
	(431445, 124, '2015-03-01 01:10:51.000000', 'consum', 0.0233, 'lps'),
	(431446, 124, '2015-03-01 01:10:52.000000', 'consum', 0.0214, 'lps'),
	(431447, 124, '2015-03-01 01:10:53.000000', 'consum', 0.0212, 'lps'),
	(431448, 124, '2015-03-01 01:10:54.000000', 'consum', 0.0211, 'lps'),
	(431449, 124, '2015-03-01 01:10:55.000000', 'consum', 0.0235, 'lps'),
	(431450, 124, '2015-03-01 01:10:56.000000', 'consum', 0.0228, 'lps'),
	(431451, 124, '2015-03-01 01:10:57.000000', 'consum', 0.0226, 'lps'),
	(431452, 124, '2015-03-01 01:10:58.000000', 'consum', 0.0235, 'lps'),
	(431453, 124, '2015-03-01 01:10:59.000000', 'consum', 0.0235, 'lps'),
	(431454, 124, '2015-03-01 01:11:00.000000', 'consum', 0.0211, 'lps'),
	(431455, 124, '2015-03-01 01:11:01.000000', 'consum', 0.0220, 'lps'),
	(431456, 124, '2015-03-01 01:11:02.000000', 'consum', 0.0228, 'lps'),
	(431457, 124, '2015-03-01 01:11:03.000000', 'consum', 0.0218, 'lps'),
	(431458, 124, '2015-03-01 01:11:04.000000', 'consum', 0.0224, 'lps'),
	(431459, 124, '2015-03-01 01:11:05.000000', 'consum', 0.0231, 'lps'),
	(431460, 124, '2015-03-01 01:11:06.000000', 'consum', 0.0221, 'lps'),
	(431461, 124, '2015-03-01 01:11:07.000000', 'consum', 0.0227, 'lps'),
	(431462, 124, '2015-03-01 01:11:08.000000', 'consum', 0.0212, 'lps'),
	(431463, 124, '2015-03-01 01:11:09.000000', 'consum', 0.0223, 'lps'),
	(431464, 124, '2015-03-01 01:11:10.000000', 'consum', 0.0215, 'lps'),
	(431465, 124, '2015-03-01 01:11:11.000000', 'consum', 0.0223, 'lps'),
	(431466, 124, '2015-03-01 01:11:12.000000', 'consum', 0.0210, 'lps'),
	(431467, 124, '2015-03-01 01:11:13.000000', 'consum', 0.0223, 'lps'),
	(431468, 124, '2015-03-01 01:11:14.000000', 'consum', 0.0223, 'lps'),
	(431469, 124, '2015-03-01 01:11:15.000000', 'consum', 0.0210, 'lps'),
	(431470, 124, '2015-03-01 01:11:16.000000', 'consum', 0.0222, 'lps'),
	(431471, 124, '2015-03-01 01:11:17.000000', 'consum', 0.0221, 'lps'),
	(431472, 124, '2015-03-01 01:11:18.000000', 'consum', 0.0227, 'lps'),
	(431473, 124, '2015-03-01 01:11:19.000000', 'consum', 0.0212, 'lps'),
	(431474, 124, '2015-03-01 01:11:20.000000', 'consum', 0.0220, 'lps'),
	(431475, 124, '2015-03-01 01:11:21.000000', 'consum', 0.0231, 'lps'),
	(431476, 124, '2015-03-01 01:11:22.000000', 'consum', 0.0232, 'lps'),
	(431477, 124, '2015-03-01 01:11:23.000000', 'consum', 0.0232, 'lps'),
	(431478, 124, '2015-03-01 01:11:24.000000', 'consum', 0.0227, 'lps'),
	(431479, 124, '2015-03-01 01:11:25.000000', 'consum', 0.0229, 'lps'),
	(431480, 124, '2015-03-01 01:11:26.000000', 'consum', 0.0228, 'lps'),
	(431481, 124, '2015-03-01 01:11:27.000000', 'consum', 0.0219, 'lps'),
	(431482, 124, '2015-03-01 01:11:28.000000', 'consum', 0.0225, 'lps'),
	(431483, 124, '2015-03-01 01:11:29.000000', 'consum', 0.0234, 'lps'),
	(431484, 124, '2015-03-01 01:11:30.000000', 'consum', 0.0235, 'lps'),
	(431485, 124, '2015-03-01 01:11:31.000000', 'consum', 0.0211, 'lps'),
	(431486, 124, '2015-03-01 01:11:32.000000', 'consum', 0.0217, 'lps'),
	(431487, 124, '2015-03-01 01:11:33.000000', 'consum', 0.0217, 'lps'),
	(431488, 124, '2015-03-01 01:11:34.000000', 'consum', 0.0223, 'lps'),
	(431489, 124, '2015-03-01 01:11:35.000000', 'consum', 0.0229, 'lps'),
	(431490, 124, '2015-03-01 01:11:36.000000', 'consum', 0.0216, 'lps'),
	(431491, 124, '2015-03-01 01:11:37.000000', 'consum', 0.0234, 'lps'),
	(431492, 124, '2015-03-01 01:11:38.000000', 'consum', 0.0210, 'lps'),
	(431493, 124, '2015-03-01 01:11:39.000000', 'consum', 0.0214, 'lps'),
	(431494, 124, '2015-03-01 01:11:40.000000', 'consum', 0.0233, 'lps'),
	(431495, 124, '2015-03-01 01:11:41.000000', 'consum', 0.0235, 'lps'),
	(431496, 124, '2015-03-01 01:11:42.000000', 'consum', 0.0214, 'lps'),
	(431497, 124, '2015-03-01 01:11:43.000000', 'consum', 0.0233, 'lps'),
	(431498, 124, '2015-03-01 01:11:44.000000', 'consum', 0.0211, 'lps'),
	(431499, 124, '2015-03-01 01:11:45.000000', 'consum', 0.0224, 'lps'),
	(431500, 124, '2015-03-01 01:11:46.000000', 'consum', 0.0224, 'lps'),
	(431501, 124, '2015-03-01 01:11:47.000000', 'consum', 0.0214, 'lps'),
	(431502, 124, '2015-03-01 01:11:48.000000', 'consum', 0.0216, 'lps'),
	(431503, 124, '2015-03-01 01:11:49.000000', 'consum', 0.0228, 'lps'),
	(431504, 124, '2015-03-01 01:11:50.000000', 'consum', 0.0230, 'lps'),
	(431505, 124, '2015-03-01 01:11:51.000000', 'consum', 0.0228, 'lps'),
	(431506, 124, '2015-03-01 01:11:52.000000', 'consum', 0.0218, 'lps'),
	(431507, 124, '2015-03-01 01:11:53.000000', 'consum', 0.0222, 'lps'),
	(431508, 124, '2015-03-01 01:11:54.000000', 'consum', 0.0221, 'lps'),
	(431509, 124, '2015-03-01 01:11:55.000000', 'consum', 0.0229, 'lps'),
	(431510, 124, '2015-03-01 01:11:56.000000', 'consum', 0.0218, 'lps'),
	(431511, 124, '2015-03-01 01:11:57.000000', 'consum', 0.0222, 'lps'),
	(431512, 124, '2015-03-01 01:11:58.000000', 'consum', 0.0220, 'lps'),
	(431513, 124, '2015-03-01 01:11:59.000000', 'consum', 0.0225, 'lps'),
	(431514, 124, '2015-03-01 01:12:00.000000', 'consum', 0.0231, 'lps'),
	(431515, 124, '2015-03-01 01:12:01.000000', 'consum', 0.0218, 'lps'),
	(431516, 124, '2015-03-01 01:12:02.000000', 'consum', 0.0213, 'lps'),
	(431517, 124, '2015-03-01 01:12:03.000000', 'consum', 0.0227, 'lps'),
	(431518, 124, '2015-03-01 01:12:04.000000', 'consum', 0.0235, 'lps'),
	(431519, 124, '2015-03-01 01:12:05.000000', 'consum', 0.0230, 'lps'),
	(431520, 124, '2015-03-01 01:12:06.000000', 'consum', 0.0213, 'lps'),
	(431521, 124, '2015-03-01 01:12:07.000000', 'consum', 0.0216, 'lps'),
	(431522, 124, '2015-03-01 01:12:08.000000', 'consum', 0.0231, 'lps'),
	(431523, 124, '2015-03-01 01:12:09.000000', 'consum', 0.0219, 'lps'),
	(431524, 124, '2015-03-01 01:12:10.000000', 'consum', 0.0220, 'lps'),
	(431525, 124, '2015-03-01 01:12:11.000000', 'consum', 0.0233, 'lps'),
	(431526, 124, '2015-03-01 01:12:12.000000', 'consum', 0.0218, 'lps'),
	(431527, 124, '2015-03-01 01:12:13.000000', 'consum', 0.0234, 'lps'),
	(431528, 124, '2015-03-01 01:12:14.000000', 'consum', 0.0228, 'lps'),
	(431529, 124, '2015-03-01 01:12:15.000000', 'consum', 0.0228, 'lps'),
	(431530, 124, '2015-03-01 01:12:16.000000', 'consum', 0.0220, 'lps'),
	(431531, 124, '2015-03-01 01:12:17.000000', 'consum', 0.0234, 'lps'),
	(431532, 124, '2015-03-01 01:12:18.000000', 'consum', 0.0220, 'lps'),
	(431533, 124, '2015-03-01 01:12:19.000000', 'consum', 0.0217, 'lps'),
	(431534, 124, '2015-03-01 01:12:20.000000', 'consum', 0.0213, 'lps'),
	(431535, 124, '2015-03-01 01:12:21.000000', 'consum', 0.0231, 'lps'),
	(431536, 124, '2015-03-01 01:12:22.000000', 'consum', 0.0228, 'lps'),
	(431537, 124, '2015-03-01 01:12:23.000000', 'consum', 0.0211, 'lps'),
	(431538, 124, '2015-03-01 01:12:24.000000', 'consum', 0.0214, 'lps'),
	(431539, 124, '2015-03-01 01:12:25.000000', 'consum', 0.0228, 'lps'),
	(431540, 124, '2015-03-01 01:12:26.000000', 'consum', 0.0211, 'lps'),
	(431541, 124, '2015-03-01 01:12:27.000000', 'consum', 0.0213, 'lps'),
	(431542, 124, '2015-03-01 01:12:28.000000', 'consum', 0.0224, 'lps'),
	(431543, 124, '2015-03-01 01:12:29.000000', 'consum', 0.0219, 'lps'),
	(431544, 124, '2015-03-01 01:12:30.000000', 'consum', 0.0212, 'lps'),
	(431545, 124, '2015-03-01 01:12:31.000000', 'consum', 0.0219, 'lps'),
	(431546, 124, '2015-03-01 01:12:32.000000', 'consum', 0.0223, 'lps'),
	(431547, 124, '2015-03-01 01:12:33.000000', 'consum', 0.0225, 'lps'),
	(431548, 124, '2015-03-01 01:12:34.000000', 'consum', 0.0218, 'lps'),
	(431549, 124, '2015-03-01 01:12:35.000000', 'consum', 0.0233, 'lps'),
	(431550, 124, '2015-03-01 01:12:36.000000', 'consum', 0.0223, 'lps'),
	(431551, 124, '2015-03-01 01:12:37.000000', 'consum', 0.0234, 'lps'),
	(431552, 124, '2015-03-01 01:12:38.000000', 'consum', 0.0211, 'lps'),
	(431553, 124, '2015-03-01 01:12:39.000000', 'consum', 0.0223, 'lps'),
	(431554, 124, '2015-03-01 01:12:40.000000', 'consum', 0.0219, 'lps'),
	(431555, 124, '2015-03-01 01:12:41.000000', 'consum', 0.0218, 'lps'),
	(431556, 124, '2015-03-01 01:12:42.000000', 'consum', 0.0225, 'lps'),
	(431557, 124, '2015-03-01 01:12:43.000000', 'consum', 0.0234, 'lps'),
	(431558, 124, '2015-03-01 01:12:44.000000', 'consum', 0.0232, 'lps'),
	(431559, 124, '2015-03-01 01:12:45.000000', 'consum', 0.0223, 'lps'),
	(431560, 124, '2015-03-01 01:12:46.000000', 'consum', 0.0212, 'lps'),
	(431561, 124, '2015-03-01 01:12:47.000000', 'consum', 0.0230, 'lps'),
	(431562, 124, '2015-03-01 01:12:48.000000', 'consum', 0.0230, 'lps'),
	(431563, 124, '2015-03-01 01:12:49.000000', 'consum', 0.0223, 'lps'),
	(431564, 124, '2015-03-01 01:12:50.000000', 'consum', 0.0216, 'lps'),
	(431565, 124, '2015-03-01 01:12:51.000000', 'consum', 0.0226, 'lps'),
	(431566, 124, '2015-03-01 01:12:52.000000', 'consum', 0.0222, 'lps'),
	(431567, 124, '2015-03-01 01:12:53.000000', 'consum', 0.0222, 'lps'),
	(431568, 124, '2015-03-01 01:12:54.000000', 'consum', 0.0233, 'lps'),
	(431569, 124, '2015-03-01 01:12:55.000000', 'consum', 0.0212, 'lps'),
	(431570, 124, '2015-03-01 01:12:56.000000', 'consum', 0.0230, 'lps'),
	(431571, 124, '2015-03-01 01:12:57.000000', 'consum', 0.0225, 'lps'),
	(431572, 124, '2015-03-01 01:12:58.000000', 'consum', 0.0226, 'lps'),
	(431573, 124, '2015-03-01 01:12:59.000000', 'consum', 0.0220, 'lps'),
	(431574, 124, '2015-03-01 01:13:00.000000', 'consum', 0.0214, 'lps'),
	(431575, 124, '2015-03-01 01:13:01.000000', 'consum', 0.0224, 'lps'),
	(431576, 124, '2015-03-01 01:13:02.000000', 'consum', 0.0216, 'lps'),
	(431577, 124, '2015-03-01 01:13:03.000000', 'consum', 0.0225, 'lps'),
	(431578, 124, '2015-03-01 01:13:04.000000', 'consum', 0.0217, 'lps'),
	(431579, 124, '2015-03-01 01:13:05.000000', 'consum', 0.0224, 'lps'),
	(431580, 124, '2015-03-01 01:13:06.000000', 'consum', 0.0235, 'lps'),
	(431581, 124, '2015-03-01 01:13:07.000000', 'consum', 0.0217, 'lps'),
	(431582, 124, '2015-03-01 01:13:08.000000', 'consum', 0.0222, 'lps'),
	(431583, 124, '2015-03-01 01:13:09.000000', 'consum', 0.0222, 'lps'),
	(431584, 124, '2015-03-01 01:13:10.000000', 'consum', 0.0235, 'lps'),
	(431585, 124, '2015-03-01 01:13:11.000000', 'consum', 0.0222, 'lps'),
	(431586, 124, '2015-03-01 01:13:12.000000', 'consum', 0.0220, 'lps'),
	(431587, 124, '2015-03-01 01:13:13.000000', 'consum', 0.0227, 'lps'),
	(431588, 124, '2015-03-01 01:13:14.000000', 'consum', 0.0213, 'lps'),
	(431589, 124, '2015-03-01 01:13:15.000000', 'consum', 0.0228, 'lps'),
	(431590, 124, '2015-03-01 01:13:16.000000', 'consum', 0.0210, 'lps'),
	(431591, 124, '2015-03-01 01:13:17.000000', 'consum', 0.0210, 'lps'),
	(431592, 124, '2015-03-01 01:13:18.000000', 'consum', 0.0212, 'lps'),
	(431593, 124, '2015-03-01 01:13:19.000000', 'consum', 0.0220, 'lps'),
	(431594, 124, '2015-03-01 01:13:20.000000', 'consum', 0.0229, 'lps'),
	(431595, 124, '2015-03-01 01:13:21.000000', 'consum', 0.0221, 'lps'),
	(431596, 124, '2015-03-01 01:13:22.000000', 'consum', 0.0211, 'lps'),
	(431597, 124, '2015-03-01 01:13:23.000000', 'consum', 0.0234, 'lps'),
	(431598, 124, '2015-03-01 01:13:24.000000', 'consum', 0.0222, 'lps'),
	(431599, 124, '2015-03-01 01:13:25.000000', 'consum', 0.0224, 'lps'),
	(431600, 124, '2015-03-01 01:13:26.000000', 'consum', 0.0220, 'lps'),
	(431601, 124, '2015-03-01 01:13:27.000000', 'consum', 0.0219, 'lps'),
	(431602, 124, '2015-03-01 01:13:28.000000', 'consum', 0.0226, 'lps'),
	(431603, 124, '2015-03-01 01:13:29.000000', 'consum', 0.0212, 'lps'),
	(431604, 124, '2015-03-01 01:13:30.000000', 'consum', 0.0223, 'lps'),
	(431605, 124, '2015-03-01 01:13:31.000000', 'consum', 0.0219, 'lps'),
	(431606, 124, '2015-03-01 01:13:32.000000', 'consum', 0.0216, 'lps'),
	(431607, 124, '2015-03-01 01:13:33.000000', 'consum', 0.0215, 'lps'),
	(431608, 124, '2015-03-01 01:13:34.000000', 'consum', 0.0218, 'lps'),
	(431609, 124, '2015-03-01 01:13:35.000000', 'consum', 0.0234, 'lps'),
	(431610, 124, '2015-03-01 01:13:36.000000', 'consum', 0.0228, 'lps'),
	(431611, 124, '2015-03-01 01:13:37.000000', 'consum', 0.0229, 'lps'),
	(431612, 124, '2015-03-01 01:13:38.000000', 'consum', 0.0225, 'lps'),
	(431613, 124, '2015-03-01 01:13:39.000000', 'consum', 0.0230, 'lps'),
	(431614, 124, '2015-03-01 01:13:40.000000', 'consum', 0.0213, 'lps'),
	(431615, 124, '2015-03-01 01:13:41.000000', 'consum', 0.0217, 'lps'),
	(431616, 124, '2015-03-01 01:13:42.000000', 'consum', 0.0235, 'lps'),
	(431617, 124, '2015-03-01 01:13:43.000000', 'consum', 0.0210, 'lps'),
	(431618, 124, '2015-03-01 01:13:44.000000', 'consum', 0.0214, 'lps'),
	(431619, 124, '2015-03-01 01:13:45.000000', 'consum', 0.0233, 'lps'),
	(431620, 124, '2015-03-01 01:13:46.000000', 'consum', 0.0232, 'lps'),
	(431621, 124, '2015-03-01 01:13:47.000000', 'consum', 0.0228, 'lps'),
	(431622, 124, '2015-03-01 01:13:48.000000', 'consum', 0.0235, 'lps'),
	(431623, 124, '2015-03-01 01:13:49.000000', 'consum', 0.0230, 'lps'),
	(431624, 124, '2015-03-01 01:13:50.000000', 'consum', 0.0210, 'lps'),
	(431625, 124, '2015-03-01 01:13:51.000000', 'consum', 0.0227, 'lps'),
	(431626, 124, '2015-03-01 01:13:52.000000', 'consum', 0.0219, 'lps'),
	(431627, 124, '2015-03-01 01:13:53.000000', 'consum', 0.0229, 'lps'),
	(431628, 124, '2015-03-01 01:13:54.000000', 'consum', 0.0229, 'lps'),
	(431629, 124, '2015-03-01 01:13:55.000000', 'consum', 0.0221, 'lps'),
	(431630, 124, '2015-03-01 01:13:56.000000', 'consum', 0.0233, 'lps'),
	(431631, 124, '2015-03-01 01:13:57.000000', 'consum', 0.0216, 'lps'),
	(431632, 124, '2015-03-01 01:13:58.000000', 'consum', 0.0224, 'lps'),
	(431633, 124, '2015-03-01 01:13:59.000000', 'consum', 0.0235, 'lps'),
	(431634, 124, '2015-03-01 01:14:00.000000', 'consum', 0.0217, 'lps'),
	(431635, 124, '2015-03-01 01:14:01.000000', 'consum', 0.0222, 'lps'),
	(431636, 124, '2015-03-01 01:14:02.000000', 'consum', 0.0223, 'lps'),
	(431637, 124, '2015-03-01 01:14:03.000000', 'consum', 0.0214, 'lps'),
	(431638, 124, '2015-03-01 01:14:04.000000', 'consum', 0.0219, 'lps'),
	(431639, 124, '2015-03-01 01:14:05.000000', 'consum', 0.0218, 'lps'),
	(431640, 124, '2015-03-01 01:14:06.000000', 'consum', 0.0221, 'lps'),
	(431641, 124, '2015-03-01 01:14:07.000000', 'consum', 0.0218, 'lps'),
	(431642, 124, '2015-03-01 01:14:08.000000', 'consum', 0.0217, 'lps'),
	(431643, 124, '2015-03-01 01:14:09.000000', 'consum', 0.0222, 'lps'),
	(431644, 124, '2015-03-01 01:14:10.000000', 'consum', 0.0223, 'lps'),
	(431645, 124, '2015-03-01 01:14:11.000000', 'consum', 0.0215, 'lps'),
	(431646, 124, '2015-03-01 01:14:12.000000', 'consum', 0.0223, 'lps'),
	(431647, 124, '2015-03-01 01:14:13.000000', 'consum', 0.0233, 'lps'),
	(431648, 124, '2015-03-01 01:14:14.000000', 'consum', 0.0233, 'lps'),
	(431649, 124, '2015-03-01 01:14:15.000000', 'consum', 0.0231, 'lps'),
	(431650, 124, '2015-03-01 01:14:16.000000', 'consum', 0.0220, 'lps'),
	(431651, 124, '2015-03-01 01:14:17.000000', 'consum', 0.0225, 'lps'),
	(431652, 124, '2015-03-01 01:14:18.000000', 'consum', 0.0230, 'lps'),
	(431653, 124, '2015-03-01 01:14:19.000000', 'consum', 0.0213, 'lps'),
	(431654, 124, '2015-03-01 01:14:20.000000', 'consum', 0.0216, 'lps'),
	(431655, 124, '2015-03-01 01:14:21.000000', 'consum', 0.0231, 'lps'),
	(431656, 124, '2015-03-01 01:14:22.000000', 'consum', 0.0222, 'lps'),
	(431657, 124, '2015-03-01 01:14:23.000000', 'consum', 0.0230, 'lps'),
	(431658, 124, '2015-03-01 01:14:24.000000', 'consum', 0.0226, 'lps'),
	(431659, 124, '2015-03-01 01:14:25.000000', 'consum', 0.0229, 'lps'),
	(431660, 124, '2015-03-01 01:14:26.000000', 'consum', 0.0231, 'lps'),
	(431661, 124, '2015-03-01 01:14:27.000000', 'consum', 0.0234, 'lps'),
	(431662, 124, '2015-03-01 01:14:28.000000', 'consum', 0.0214, 'lps'),
	(431663, 124, '2015-03-01 01:14:29.000000', 'consum', 0.0213, 'lps'),
	(431664, 124, '2015-03-01 01:14:30.000000', 'consum', 0.0212, 'lps'),
	(431665, 124, '2015-03-01 01:14:31.000000', 'consum', 0.0213, 'lps'),
	(431666, 124, '2015-03-01 01:14:32.000000', 'consum', 0.0218, 'lps'),
	(431667, 124, '2015-03-01 01:14:33.000000', 'consum', 0.0215, 'lps'),
	(431668, 124, '2015-03-01 01:14:34.000000', 'consum', 0.0214, 'lps'),
	(431669, 124, '2015-03-01 01:14:35.000000', 'consum', 0.0214, 'lps'),
	(431670, 124, '2015-03-01 01:14:36.000000', 'consum', 0.0218, 'lps'),
	(431671, 124, '2015-03-01 01:14:37.000000', 'consum', 0.0213, 'lps'),
	(431672, 124, '2015-03-01 01:14:38.000000', 'consum', 0.0226, 'lps'),
	(431673, 124, '2015-03-01 01:14:39.000000', 'consum', 0.0231, 'lps'),
	(431674, 124, '2015-03-01 01:14:40.000000', 'consum', 0.0214, 'lps'),
	(431675, 124, '2015-03-01 01:14:41.000000', 'consum', 0.0222, 'lps'),
	(431676, 124, '2015-03-01 01:14:42.000000', 'consum', 0.0230, 'lps'),
	(431677, 124, '2015-03-01 01:14:43.000000', 'consum', 0.0223, 'lps'),
	(431678, 124, '2015-03-01 01:14:44.000000', 'consum', 0.0217, 'lps'),
	(431679, 124, '2015-03-01 01:14:45.000000', 'consum', 0.0232, 'lps'),
	(431680, 124, '2015-03-01 01:14:46.000000', 'consum', 0.0222, 'lps'),
	(431681, 124, '2015-03-01 01:14:47.000000', 'consum', 0.0230, 'lps'),
	(431682, 124, '2015-03-01 01:14:48.000000', 'consum', 0.0222, 'lps'),
	(431683, 124, '2015-03-01 01:14:49.000000', 'consum', 0.0211, 'lps'),
	(431684, 124, '2015-03-01 01:14:50.000000', 'consum', 0.0230, 'lps'),
	(431685, 124, '2015-03-01 01:14:51.000000', 'consum', 0.0233, 'lps'),
	(431686, 124, '2015-03-01 01:14:52.000000', 'consum', 0.0210, 'lps'),
	(431687, 124, '2015-03-01 01:14:53.000000', 'consum', 0.0220, 'lps'),
	(431688, 124, '2015-03-01 01:14:54.000000', 'consum', 0.0210, 'lps'),
	(431689, 124, '2015-03-01 01:14:55.000000', 'consum', 0.0232, 'lps'),
	(431690, 124, '2015-03-01 01:14:56.000000', 'consum', 0.0218, 'lps'),
	(431691, 124, '2015-03-01 01:14:57.000000', 'consum', 0.0210, 'lps'),
	(431692, 124, '2015-03-01 01:14:58.000000', 'consum', 0.0211, 'lps'),
	(431693, 124, '2015-03-01 01:14:59.000000', 'consum', 0.0217, 'lps'),
	(431694, 124, '2015-03-01 01:15:00.000000', 'consum', 0.0214, 'lps'),
	(431695, 124, '2015-03-01 01:15:01.000000', 'consum', 0.0212, 'lps'),
	(431696, 124, '2015-03-01 01:15:02.000000', 'consum', 0.0210, 'lps'),
	(431697, 124, '2015-03-01 01:15:03.000000', 'consum', 0.0227, 'lps'),
	(431698, 124, '2015-03-01 01:15:04.000000', 'consum', 0.0221, 'lps'),
	(431699, 124, '2015-03-01 01:15:05.000000', 'consum', 0.0213, 'lps'),
	(431700, 124, '2015-03-01 01:15:06.000000', 'consum', 0.0218, 'lps'),
	(431701, 124, '2015-03-01 01:15:07.000000', 'consum', 0.0215, 'lps'),
	(431702, 124, '2015-03-01 01:15:08.000000', 'consum', 0.0211, 'lps'),
	(431703, 124, '2015-03-01 01:15:09.000000', 'consum', 0.0226, 'lps'),
	(431704, 124, '2015-03-01 01:15:10.000000', 'consum', 0.0211, 'lps'),
	(431705, 124, '2015-03-01 01:15:11.000000', 'consum', 0.0219, 'lps'),
	(431706, 124, '2015-03-01 01:15:12.000000', 'consum', 0.0229, 'lps'),
	(431707, 124, '2015-03-01 01:15:13.000000', 'consum', 0.0223, 'lps'),
	(431708, 124, '2015-03-01 01:15:14.000000', 'consum', 0.0218, 'lps'),
	(431709, 124, '2015-03-01 01:15:15.000000', 'consum', 0.0214, 'lps'),
	(431710, 124, '2015-03-01 01:15:16.000000', 'consum', 0.0232, 'lps'),
	(431711, 124, '2015-03-01 01:15:17.000000', 'consum', 0.0231, 'lps'),
	(431712, 124, '2015-03-01 01:15:18.000000', 'consum', 0.0221, 'lps'),
	(431713, 124, '2015-03-01 01:15:19.000000', 'consum', 0.0231, 'lps'),
	(431714, 124, '2015-03-01 01:15:20.000000', 'consum', 0.0230, 'lps'),
	(431715, 124, '2015-03-01 01:15:21.000000', 'consum', 0.0222, 'lps'),
	(431716, 124, '2015-03-01 01:15:22.000000', 'consum', 0.0235, 'lps'),
	(431717, 124, '2015-03-01 01:15:23.000000', 'consum', 0.0222, 'lps'),
	(431718, 124, '2015-03-01 01:15:24.000000', 'consum', 0.0220, 'lps'),
	(431719, 124, '2015-03-01 01:15:25.000000', 'consum', 0.0225, 'lps'),
	(431720, 124, '2015-03-01 01:15:26.000000', 'consum', 0.0230, 'lps'),
	(431721, 124, '2015-03-01 01:15:27.000000', 'consum', 0.0215, 'lps'),
	(431722, 124, '2015-03-01 01:15:28.000000', 'consum', 0.0228, 'lps'),
	(431723, 124, '2015-03-01 01:15:29.000000', 'consum', 0.0231, 'lps'),
	(431724, 124, '2015-03-01 01:15:30.000000', 'consum', 0.0211, 'lps'),
	(431725, 124, '2015-03-01 01:15:31.000000', 'consum', 0.0228, 'lps'),
	(431726, 124, '2015-03-01 01:15:32.000000', 'consum', 0.0221, 'lps'),
	(431727, 124, '2015-03-01 01:15:33.000000', 'consum', 0.0211, 'lps'),
	(431728, 124, '2015-03-01 01:15:34.000000', 'consum', 0.0210, 'lps'),
	(431729, 124, '2015-03-01 01:15:35.000000', 'consum', 0.0233, 'lps'),
	(431730, 124, '2015-03-01 01:15:36.000000', 'consum', 0.0220, 'lps'),
	(431731, 124, '2015-03-01 01:15:37.000000', 'consum', 0.0218, 'lps'),
	(431732, 124, '2015-03-01 01:15:38.000000', 'consum', 0.0219, 'lps'),
	(431733, 124, '2015-03-01 01:15:39.000000', 'consum', 0.0233, 'lps'),
	(431734, 124, '2015-03-01 01:15:40.000000', 'consum', 0.0220, 'lps'),
	(431735, 124, '2015-03-01 01:15:41.000000', 'consum', 0.0219, 'lps'),
	(431736, 124, '2015-03-01 01:15:42.000000', 'consum', 0.0226, 'lps'),
	(431737, 124, '2015-03-01 01:15:43.000000', 'consum', 0.0211, 'lps'),
	(431738, 124, '2015-03-01 01:15:44.000000', 'consum', 0.0219, 'lps'),
	(431739, 124, '2015-03-01 01:15:45.000000', 'consum', 0.0228, 'lps'),
	(431740, 124, '2015-03-01 01:15:46.000000', 'consum', 0.0219, 'lps'),
	(431741, 124, '2015-03-01 01:15:47.000000', 'consum', 0.0227, 'lps'),
	(431742, 124, '2015-03-01 01:15:48.000000', 'consum', 0.0219, 'lps'),
	(431743, 124, '2015-03-01 01:15:49.000000', 'consum', 0.0228, 'lps'),
	(431744, 124, '2015-03-01 01:15:50.000000', 'consum', 0.0224, 'lps'),
	(431745, 124, '2015-03-01 01:15:51.000000', 'consum', 0.0226, 'lps'),
	(431746, 124, '2015-03-01 01:15:52.000000', 'consum', 0.0221, 'lps'),
	(431747, 124, '2015-03-01 01:15:53.000000', 'consum', 0.0219, 'lps'),
	(431748, 124, '2015-03-01 01:15:54.000000', 'consum', 0.0222, 'lps'),
	(431749, 124, '2015-03-01 01:15:55.000000', 'consum', 0.0219, 'lps'),
	(431750, 124, '2015-03-01 01:15:56.000000', 'consum', 0.0220, 'lps'),
	(431751, 124, '2015-03-01 01:15:57.000000', 'consum', 0.0233, 'lps'),
	(431752, 124, '2015-03-01 01:15:58.000000', 'consum', 0.0218, 'lps'),
	(431753, 124, '2015-03-01 01:15:59.000000', 'consum', 0.0233, 'lps'),
	(431754, 124, '2015-03-01 01:16:00.000000', 'consum', 0.0225, 'lps'),
	(431755, 124, '2015-03-01 01:16:01.000000', 'consum', 0.0217, 'lps'),
	(431756, 124, '2015-03-01 01:16:02.000000', 'consum', 0.0227, 'lps'),
	(431757, 124, '2015-03-01 01:16:03.000000', 'consum', 0.0222, 'lps'),
	(431758, 124, '2015-03-01 01:16:04.000000', 'consum', 0.0219, 'lps'),
	(431759, 124, '2015-03-01 01:16:05.000000', 'consum', 0.0219, 'lps'),
	(431760, 124, '2015-03-01 01:16:06.000000', 'consum', 0.0230, 'lps'),
	(431761, 124, '2015-03-01 01:16:07.000000', 'consum', 0.0229, 'lps'),
	(431762, 124, '2015-03-01 01:16:08.000000', 'consum', 0.0223, 'lps'),
	(431763, 124, '2015-03-01 01:16:09.000000', 'consum', 0.0215, 'lps'),
	(431764, 124, '2015-03-01 01:16:10.000000', 'consum', 0.0223, 'lps'),
	(431765, 124, '2015-03-01 01:16:11.000000', 'consum', 0.0234, 'lps'),
	(431766, 124, '2015-03-01 01:16:12.000000', 'consum', 0.0215, 'lps'),
	(431767, 124, '2015-03-01 01:16:13.000000', 'consum', 0.0214, 'lps'),
	(431768, 124, '2015-03-01 01:16:14.000000', 'consum', 0.0216, 'lps'),
	(431769, 124, '2015-03-01 01:16:15.000000', 'consum', 0.0229, 'lps'),
	(431770, 124, '2015-03-01 01:16:16.000000', 'consum', 0.0233, 'lps'),
	(431771, 124, '2015-03-01 01:16:17.000000', 'consum', 0.0220, 'lps'),
	(431772, 124, '2015-03-01 01:16:18.000000', 'consum', 0.0216, 'lps'),
	(431773, 124, '2015-03-01 01:16:19.000000', 'consum', 0.0211, 'lps'),
	(431774, 124, '2015-03-01 01:16:20.000000', 'consum', 0.0221, 'lps'),
	(431775, 124, '2015-03-01 01:16:21.000000', 'consum', 0.0214, 'lps'),
	(431776, 124, '2015-03-01 01:16:22.000000', 'consum', 0.0221, 'lps'),
	(431777, 124, '2015-03-01 01:16:23.000000', 'consum', 0.0227, 'lps'),
	(431778, 124, '2015-03-01 01:16:24.000000', 'consum', 0.0235, 'lps'),
	(431779, 124, '2015-03-01 01:16:25.000000', 'consum', 0.0210, 'lps'),
	(431780, 124, '2015-03-01 01:16:26.000000', 'consum', 0.0213, 'lps'),
	(431781, 124, '2015-03-01 01:16:27.000000', 'consum', 0.0227, 'lps'),
	(431782, 124, '2015-03-01 01:16:28.000000', 'consum', 0.0231, 'lps'),
	(431783, 124, '2015-03-01 01:16:29.000000', 'consum', 0.0216, 'lps'),
	(431784, 124, '2015-03-01 01:16:30.000000', 'consum', 0.0227, 'lps'),
	(431785, 124, '2015-03-01 01:16:31.000000', 'consum', 0.0225, 'lps'),
	(431786, 124, '2015-03-01 01:16:32.000000', 'consum', 0.0234, 'lps'),
	(431787, 124, '2015-03-01 01:16:33.000000', 'consum', 0.0234, 'lps'),
	(431788, 124, '2015-03-01 01:16:34.000000', 'consum', 0.0233, 'lps'),
	(431789, 124, '2015-03-01 01:16:35.000000', 'consum', 0.0229, 'lps'),
	(431790, 124, '2015-03-01 01:16:36.000000', 'consum', 0.0235, 'lps'),
	(431791, 124, '2015-03-01 01:16:37.000000', 'consum', 0.0228, 'lps'),
	(431792, 124, '2015-03-01 01:16:38.000000', 'consum', 0.0226, 'lps'),
	(431793, 124, '2015-03-01 01:16:39.000000', 'consum', 0.0210, 'lps'),
	(431794, 124, '2015-03-01 01:16:40.000000', 'consum', 0.0214, 'lps'),
	(431795, 124, '2015-03-01 01:16:41.000000', 'consum', 0.0229, 'lps'),
	(431796, 124, '2015-03-01 01:16:42.000000', 'consum', 0.0215, 'lps'),
	(431797, 124, '2015-03-01 01:16:43.000000', 'consum', 0.0230, 'lps'),
	(431798, 124, '2015-03-01 01:16:44.000000', 'consum', 0.0218, 'lps'),
	(431799, 124, '2015-03-01 01:16:45.000000', 'consum', 0.0216, 'lps'),
	(431800, 124, '2015-03-01 01:16:46.000000', 'consum', 0.0218, 'lps'),
	(431801, 124, '2015-03-01 01:16:47.000000', 'consum', 0.0232, 'lps'),
	(431802, 124, '2015-03-01 01:16:48.000000', 'consum', 0.0218, 'lps'),
	(431803, 124, '2015-03-01 01:16:49.000000', 'consum', 0.0211, 'lps'),
	(431804, 124, '2015-03-01 01:16:50.000000', 'consum', 0.0215, 'lps'),
	(431805, 124, '2015-03-01 01:16:51.000000', 'consum', 0.0210, 'lps'),
	(431806, 124, '2015-03-01 01:16:52.000000', 'consum', 0.0219, 'lps'),
	(431807, 124, '2015-03-01 01:16:53.000000', 'consum', 0.0228, 'lps'),
	(431808, 124, '2015-03-01 01:16:54.000000', 'consum', 0.0224, 'lps'),
	(431809, 124, '2015-03-01 01:16:55.000000', 'consum', 0.0226, 'lps'),
	(431810, 124, '2015-03-01 01:16:56.000000', 'consum', 0.0224, 'lps'),
	(431811, 124, '2015-03-01 01:16:57.000000', 'consum', 0.0232, 'lps'),
	(431812, 124, '2015-03-01 01:16:58.000000', 'consum', 0.0228, 'lps'),
	(431813, 124, '2015-03-01 01:16:59.000000', 'consum', 0.0234, 'lps'),
	(431814, 124, '2015-03-01 01:17:00.000000', 'consum', 0.0225, 'lps'),
	(431815, 124, '2015-03-01 01:17:01.000000', 'consum', 0.0211, 'lps'),
	(431816, 124, '2015-03-01 01:17:02.000000', 'consum', 0.0224, 'lps'),
	(431817, 124, '2015-03-01 01:17:03.000000', 'consum', 0.0227, 'lps'),
	(431818, 124, '2015-03-01 01:17:04.000000', 'consum', 0.0225, 'lps'),
	(431819, 124, '2015-03-01 01:17:05.000000', 'consum', 0.0235, 'lps'),
	(431820, 124, '2015-03-01 01:17:06.000000', 'consum', 0.0214, 'lps'),
	(431821, 124, '2015-03-01 01:17:07.000000', 'consum', 0.0231, 'lps'),
	(431822, 124, '2015-03-01 01:17:08.000000', 'consum', 0.0226, 'lps'),
	(431823, 124, '2015-03-01 01:17:09.000000', 'consum', 0.0228, 'lps'),
	(431824, 124, '2015-03-01 01:17:10.000000', 'consum', 0.0225, 'lps'),
	(431825, 124, '2015-03-01 01:17:11.000000', 'consum', 0.0232, 'lps'),
	(431826, 124, '2015-03-01 01:17:12.000000', 'consum', 0.0224, 'lps'),
	(431827, 124, '2015-03-01 01:17:13.000000', 'consum', 0.0216, 'lps'),
	(431828, 124, '2015-03-01 01:17:14.000000', 'consum', 0.0222, 'lps'),
	(431829, 124, '2015-03-01 01:17:15.000000', 'consum', 0.0226, 'lps'),
	(431830, 124, '2015-03-01 01:17:16.000000', 'consum', 0.0231, 'lps'),
	(431831, 124, '2015-03-01 01:17:17.000000', 'consum', 0.0214, 'lps'),
	(431832, 124, '2015-03-01 01:17:18.000000', 'consum', 0.0221, 'lps'),
	(431833, 124, '2015-03-01 01:17:19.000000', 'consum', 0.0226, 'lps'),
	(431834, 124, '2015-03-01 01:17:20.000000', 'consum', 0.0233, 'lps'),
	(431835, 124, '2015-03-01 01:17:21.000000', 'consum', 0.0224, 'lps'),
	(431836, 124, '2015-03-01 01:17:22.000000', 'consum', 0.0212, 'lps'),
	(431837, 124, '2015-03-01 01:17:23.000000', 'consum', 0.0232, 'lps'),
	(431838, 124, '2015-03-01 01:17:24.000000', 'consum', 0.0235, 'lps'),
	(431839, 124, '2015-03-01 01:17:25.000000', 'consum', 0.0216, 'lps'),
	(431840, 124, '2015-03-01 01:17:26.000000', 'consum', 0.0221, 'lps'),
	(431841, 124, '2015-03-01 01:17:27.000000', 'consum', 0.0218, 'lps'),
	(431842, 124, '2015-03-01 01:17:28.000000', 'consum', 0.0220, 'lps'),
	(431843, 124, '2015-03-01 01:17:29.000000', 'consum', 0.0212, 'lps'),
	(431844, 124, '2015-03-01 01:17:30.000000', 'consum', 0.0213, 'lps'),
	(431845, 124, '2015-03-01 01:17:31.000000', 'consum', 0.0222, 'lps'),
	(431846, 124, '2015-03-01 01:17:32.000000', 'consum', 0.0234, 'lps'),
	(431847, 124, '2015-03-01 01:17:33.000000', 'consum', 0.0215, 'lps'),
	(431848, 124, '2015-03-01 01:17:34.000000', 'consum', 0.0218, 'lps'),
	(431849, 124, '2015-03-01 01:17:35.000000', 'consum', 0.0235, 'lps'),
	(431850, 124, '2015-03-01 01:17:36.000000', 'consum', 0.0235, 'lps'),
	(431851, 124, '2015-03-01 01:17:37.000000', 'consum', 0.0235, 'lps'),
	(431852, 124, '2015-03-01 01:17:38.000000', 'consum', 0.0232, 'lps'),
	(431853, 124, '2015-03-01 01:17:39.000000', 'consum', 0.0219, 'lps'),
	(431854, 124, '2015-03-01 01:17:40.000000', 'consum', 0.0218, 'lps'),
	(431855, 124, '2015-03-01 01:17:41.000000', 'consum', 0.0224, 'lps'),
	(431856, 124, '2015-03-01 01:17:42.000000', 'consum', 0.0227, 'lps'),
	(431857, 124, '2015-03-01 01:17:43.000000', 'consum', 0.0231, 'lps'),
	(431858, 124, '2015-03-01 01:17:44.000000', 'consum', 0.0212, 'lps'),
	(431859, 124, '2015-03-01 01:17:45.000000', 'consum', 0.0235, 'lps'),
	(431860, 124, '2015-03-01 01:17:46.000000', 'consum', 0.0224, 'lps'),
	(431861, 124, '2015-03-01 01:17:47.000000', 'consum', 0.0234, 'lps'),
	(431862, 124, '2015-03-01 01:17:48.000000', 'consum', 0.0210, 'lps'),
	(431863, 124, '2015-03-01 01:17:49.000000', 'consum', 0.0216, 'lps'),
	(431864, 124, '2015-03-01 01:17:50.000000', 'consum', 0.0213, 'lps'),
	(431865, 124, '2015-03-01 01:17:51.000000', 'consum', 0.0233, 'lps'),
	(431866, 124, '2015-03-01 01:17:52.000000', 'consum', 0.0212, 'lps'),
	(431867, 124, '2015-03-01 01:17:53.000000', 'consum', 0.0233, 'lps'),
	(431868, 124, '2015-03-01 01:17:54.000000', 'consum', 0.0213, 'lps'),
	(431869, 124, '2015-03-01 01:17:55.000000', 'consum', 0.0234, 'lps'),
	(431870, 124, '2015-03-01 01:17:56.000000', 'consum', 0.0220, 'lps'),
	(431871, 124, '2015-03-01 01:17:57.000000', 'consum', 0.0214, 'lps'),
	(431872, 124, '2015-03-01 01:17:58.000000', 'consum', 0.0227, 'lps'),
	(431873, 124, '2015-03-01 01:17:59.000000', 'consum', 0.0231, 'lps'),
	(431874, 124, '2015-03-01 01:18:00.000000', 'consum', 0.0212, 'lps'),
	(431875, 124, '2015-03-01 01:18:01.000000', 'consum', 0.0211, 'lps'),
	(431876, 124, '2015-03-01 01:18:02.000000', 'consum', 0.0235, 'lps'),
	(431877, 124, '2015-03-01 01:18:03.000000', 'consum', 0.0229, 'lps'),
	(431878, 124, '2015-03-01 01:18:04.000000', 'consum', 0.0228, 'lps'),
	(431879, 124, '2015-03-01 01:18:05.000000', 'consum', 0.0219, 'lps'),
	(431880, 124, '2015-03-01 01:18:06.000000', 'consum', 0.0229, 'lps'),
	(431881, 124, '2015-03-01 01:18:07.000000', 'consum', 0.0226, 'lps'),
	(431882, 124, '2015-03-01 01:18:08.000000', 'consum', 0.0232, 'lps'),
	(431883, 124, '2015-03-01 01:18:09.000000', 'consum', 0.0222, 'lps'),
	(431884, 124, '2015-03-01 01:18:10.000000', 'consum', 0.0228, 'lps'),
	(431885, 124, '2015-03-01 01:18:11.000000', 'consum', 0.0214, 'lps'),
	(431886, 124, '2015-03-01 01:18:12.000000', 'consum', 0.0229, 'lps'),
	(431887, 124, '2015-03-01 01:18:13.000000', 'consum', 0.0213, 'lps'),
	(431888, 124, '2015-03-01 01:18:14.000000', 'consum', 0.0223, 'lps'),
	(431889, 124, '2015-03-01 01:18:15.000000', 'consum', 0.0215, 'lps'),
	(431890, 124, '2015-03-01 01:18:16.000000', 'consum', 0.0223, 'lps'),
	(431891, 124, '2015-03-01 01:18:17.000000', 'consum', 0.0231, 'lps'),
	(431892, 124, '2015-03-01 01:18:18.000000', 'consum', 0.0228, 'lps'),
	(431893, 124, '2015-03-01 01:18:19.000000', 'consum', 0.0211, 'lps'),
	(431894, 124, '2015-03-01 01:18:20.000000', 'consum', 0.0214, 'lps'),
	(431895, 124, '2015-03-01 01:18:21.000000', 'consum', 0.0227, 'lps'),
	(431896, 124, '2015-03-01 01:18:22.000000', 'consum', 0.0232, 'lps'),
	(431897, 124, '2015-03-01 01:18:23.000000', 'consum', 0.0218, 'lps'),
	(431898, 124, '2015-03-01 01:18:24.000000', 'consum', 0.0210, 'lps'),
	(431899, 124, '2015-03-01 01:18:25.000000', 'consum', 0.0212, 'lps'),
	(431900, 124, '2015-03-01 01:18:26.000000', 'consum', 0.0220, 'lps'),
	(431901, 124, '2015-03-01 01:18:27.000000', 'consum', 0.0229, 'lps'),
	(431902, 124, '2015-03-01 01:18:28.000000', 'consum', 0.0221, 'lps'),
	(431903, 124, '2015-03-01 01:18:29.000000', 'consum', 0.0212, 'lps'),
	(431904, 124, '2015-03-01 01:18:30.000000', 'consum', 0.0213, 'lps'),
	(431905, 124, '2015-03-01 01:18:31.000000', 'consum', 0.0221, 'lps'),
	(431906, 124, '2015-03-01 01:18:32.000000', 'consum', 0.0229, 'lps'),
	(431907, 124, '2015-03-01 01:18:33.000000', 'consum', 0.0221, 'lps'),
	(431908, 124, '2015-03-01 01:18:34.000000', 'consum', 0.0235, 'lps'),
	(431909, 124, '2015-03-01 01:18:35.000000', 'consum', 0.0223, 'lps'),
	(431910, 124, '2015-03-01 01:18:36.000000', 'consum', 0.0225, 'lps'),
	(431911, 124, '2015-03-01 01:18:37.000000', 'consum', 0.0223, 'lps'),
	(431912, 124, '2015-03-01 01:18:38.000000', 'consum', 0.0231, 'lps'),
	(431913, 124, '2015-03-01 01:18:39.000000', 'consum', 0.0225, 'lps'),
	(431914, 124, '2015-03-01 01:18:40.000000', 'consum', 0.0221, 'lps'),
	(431915, 124, '2015-03-01 01:18:41.000000', 'consum', 0.0221, 'lps'),
	(431916, 124, '2015-03-01 01:18:42.000000', 'consum', 0.0230, 'lps'),
	(431917, 124, '2015-03-01 01:18:43.000000', 'consum', 0.0229, 'lps'),
	(431918, 124, '2015-03-01 01:18:44.000000', 'consum', 0.0218, 'lps'),
	(431919, 124, '2015-03-01 01:18:45.000000', 'consum', 0.0220, 'lps'),
	(431920, 124, '2015-03-01 01:18:46.000000', 'consum', 0.0212, 'lps'),
	(431921, 124, '2015-03-01 01:18:47.000000', 'consum', 0.0217, 'lps'),
	(431922, 124, '2015-03-01 01:18:48.000000', 'consum', 0.0210, 'lps'),
	(431923, 124, '2015-03-01 01:18:49.000000', 'consum', 0.0218, 'lps'),
	(431924, 124, '2015-03-01 01:18:50.000000', 'consum', 0.0225, 'lps'),
	(431925, 124, '2015-03-01 01:18:51.000000', 'consum', 0.0210, 'lps'),
	(431926, 124, '2015-03-01 01:18:52.000000', 'consum', 0.0218, 'lps'),
	(431927, 124, '2015-03-01 01:18:53.000000', 'consum', 0.0222, 'lps'),
	(431928, 124, '2015-03-01 01:18:54.000000', 'consum', 0.0221, 'lps'),
	(431929, 124, '2015-03-01 01:18:55.000000', 'consum', 0.0231, 'lps'),
	(431930, 124, '2015-03-01 01:18:56.000000', 'consum', 0.0230, 'lps'),
	(431931, 124, '2015-03-01 01:18:57.000000', 'consum', 0.0222, 'lps'),
	(431932, 124, '2015-03-01 01:18:58.000000', 'consum', 0.0234, 'lps'),
	(431933, 124, '2015-03-01 01:18:59.000000', 'consum', 0.0218, 'lps'),
	(431934, 124, '2015-03-01 01:19:00.000000', 'consum', 0.0229, 'lps'),
	(431935, 124, '2015-03-01 01:19:01.000000', 'consum', 0.0233, 'lps'),
	(431936, 124, '2015-03-01 01:19:02.000000', 'consum', 0.0213, 'lps'),
	(431937, 124, '2015-03-01 01:19:03.000000', 'consum', 0.0210, 'lps'),
	(431938, 124, '2015-03-01 01:19:04.000000', 'consum', 0.0229, 'lps'),
	(431939, 124, '2015-03-01 01:19:05.000000', 'consum', 0.0227, 'lps'),
	(431940, 124, '2015-03-01 01:19:06.000000', 'consum', 0.0211, 'lps'),
	(431941, 124, '2015-03-01 01:19:07.000000', 'consum', 0.0217, 'lps'),
	(431942, 124, '2015-03-01 01:19:08.000000', 'consum', 0.0216, 'lps'),
	(431943, 124, '2015-03-01 01:19:09.000000', 'consum', 0.0218, 'lps'),
	(431944, 124, '2015-03-01 01:19:10.000000', 'consum', 0.0235, 'lps'),
	(431945, 124, '2015-03-01 01:19:11.000000', 'consum', 0.0232, 'lps'),
	(431946, 124, '2015-03-01 01:19:12.000000', 'consum', 0.0222, 'lps'),
	(431947, 124, '2015-03-01 01:19:13.000000', 'consum', 0.0228, 'lps'),
	(431948, 124, '2015-03-01 01:19:14.000000', 'consum', 0.0214, 'lps'),
	(431949, 124, '2015-03-01 01:19:15.000000', 'consum', 0.0227, 'lps'),
	(431950, 124, '2015-03-01 01:19:16.000000', 'consum', 0.0232, 'lps'),
	(431951, 124, '2015-03-01 01:19:17.000000', 'consum', 0.0218, 'lps'),
	(431952, 124, '2015-03-01 01:19:18.000000', 'consum', 0.0235, 'lps'),
	(431953, 124, '2015-03-01 01:19:19.000000', 'consum', 0.0232, 'lps'),
	(431954, 124, '2015-03-01 01:19:20.000000', 'consum', 0.0223, 'lps'),
	(431955, 124, '2015-03-01 01:19:21.000000', 'consum', 0.0233, 'lps'),
	(431956, 124, '2015-03-01 01:19:22.000000', 'consum', 0.0210, 'lps'),
	(431957, 124, '2015-03-01 01:19:23.000000', 'consum', 0.0217, 'lps'),
	(431958, 124, '2015-03-01 01:19:24.000000', 'consum', 0.0223, 'lps'),
	(431959, 124, '2015-03-01 01:19:25.000000', 'consum', 0.0227, 'lps'),
	(431960, 124, '2015-03-01 01:19:26.000000', 'consum', 0.0231, 'lps'),
	(431961, 124, '2015-03-01 01:19:27.000000', 'consum', 0.0211, 'lps'),
	(431962, 124, '2015-03-01 01:19:28.000000', 'consum', 0.0230, 'lps'),
	(431963, 124, '2015-03-01 01:19:29.000000', 'consum', 0.0229, 'lps'),
	(431964, 124, '2015-03-01 01:19:30.000000', 'consum', 0.0221, 'lps'),
	(431965, 124, '2015-03-01 01:19:31.000000', 'consum', 0.0235, 'lps'),
	(431966, 124, '2015-03-01 01:19:32.000000', 'consum', 0.0225, 'lps'),
	(431967, 124, '2015-03-01 01:19:33.000000', 'consum', 0.0212, 'lps'),
	(431968, 124, '2015-03-01 01:19:34.000000', 'consum', 0.0225, 'lps'),
	(431969, 124, '2015-03-01 01:19:35.000000', 'consum', 0.0227, 'lps'),
	(431970, 124, '2015-03-01 01:19:36.000000', 'consum', 0.0223, 'lps'),
	(431971, 124, '2015-03-01 01:19:37.000000', 'consum', 0.0228, 'lps'),
	(431972, 124, '2015-03-01 01:19:38.000000', 'consum', 0.0233, 'lps'),
	(431973, 124, '2015-03-01 01:19:39.000000', 'consum', 0.0222, 'lps'),
	(431974, 124, '2015-03-01 01:19:40.000000', 'consum', 0.0225, 'lps'),
	(431975, 124, '2015-03-01 01:19:41.000000', 'consum', 0.0223, 'lps'),
	(431976, 124, '2015-03-01 01:19:42.000000', 'consum', 0.0232, 'lps'),
	(431977, 124, '2015-03-01 01:19:43.000000', 'consum', 0.0228, 'lps'),
	(431978, 124, '2015-03-01 01:19:44.000000', 'consum', 0.0235, 'lps'),
	(431979, 124, '2015-03-01 01:19:45.000000', 'consum', 0.0231, 'lps'),
	(431980, 124, '2015-03-01 01:19:46.000000', 'consum', 0.0212, 'lps'),
	(431981, 124, '2015-03-01 01:19:47.000000', 'consum', 0.0212, 'lps'),
	(431982, 124, '2015-03-01 01:19:48.000000', 'consum', 0.0215, 'lps'),
	(431983, 124, '2015-03-01 01:19:49.000000', 'consum', 0.0230, 'lps'),
	(431984, 124, '2015-03-01 01:19:50.000000', 'consum', 0.0218, 'lps'),
	(431985, 124, '2015-03-01 01:19:51.000000', 'consum', 0.0218, 'lps'),
	(431986, 124, '2015-03-01 01:19:52.000000', 'consum', 0.0223, 'lps'),
	(431987, 124, '2015-03-01 01:19:53.000000', 'consum', 0.0226, 'lps'),
	(431988, 124, '2015-03-01 01:19:54.000000', 'consum', 0.0225, 'lps'),
	(431989, 124, '2015-03-01 01:19:55.000000', 'consum', 0.0212, 'lps'),
	(431990, 124, '2015-03-01 01:19:56.000000', 'consum', 0.0228, 'lps'),
	(431991, 124, '2015-03-01 01:19:57.000000', 'consum', 0.0218, 'lps'),
	(431992, 124, '2015-03-01 01:19:58.000000', 'consum', 0.0223, 'lps'),
	(431993, 124, '2015-03-01 01:19:59.000000', 'consum', 0.0224, 'lps'),
	(431994, 124, '2015-03-01 01:20:00.000000', 'consum', 0.0215, 'lps'),
	(431995, 124, '2015-03-01 01:20:01.000000', 'consum', 0.0220, 'lps'),
	(431996, 124, '2015-03-01 01:20:02.000000', 'consum', 0.0220, 'lps'),
	(431997, 124, '2015-03-01 01:20:03.000000', 'consum', 0.0229, 'lps'),
	(431998, 124, '2015-03-01 01:20:04.000000', 'consum', 0.0225, 'lps'),
	(431999, 124, '2015-03-01 01:20:05.000000', 'consum', 0.0226, 'lps'),
	(432000, 124, '2015-03-01 01:20:06.000000', 'consum', 0.0222, 'lps'),
	(432001, 124, '2015-03-01 01:20:07.000000', 'consum', 0.0220, 'lps'),
	(432002, 124, '2015-03-01 01:20:08.000000', 'consum', 0.0226, 'lps'),
	(432003, 124, '2015-03-01 01:20:09.000000', 'consum', 0.0234, 'lps'),
	(432004, 124, '2015-03-01 01:20:10.000000', 'consum', 0.0231, 'lps'),
	(432005, 124, '2015-03-01 01:20:11.000000', 'consum', 0.0219, 'lps'),
	(432006, 124, '2015-03-01 01:20:12.000000', 'consum', 0.0218, 'lps'),
	(432007, 124, '2015-03-01 01:20:13.000000', 'consum', 0.0222, 'lps'),
	(432008, 124, '2015-03-01 01:20:14.000000', 'consum', 0.0220, 'lps'),
	(432009, 124, '2015-03-01 01:20:15.000000', 'consum', 0.0224, 'lps'),
	(432010, 124, '2015-03-01 01:20:16.000000', 'consum', 0.0226, 'lps'),
	(432011, 124, '2015-03-01 01:20:17.000000', 'consum', 0.0224, 'lps'),
	(432012, 124, '2015-03-01 01:20:18.000000', 'consum', 0.0231, 'lps'),
	(432013, 124, '2015-03-01 01:20:19.000000', 'consum', 0.0222, 'lps'),
	(432014, 124, '2015-03-01 01:20:20.000000', 'consum', 0.0232, 'lps'),
	(432015, 124, '2015-03-01 01:20:21.000000', 'consum', 0.0233, 'lps'),
	(432016, 124, '2015-03-01 01:20:22.000000', 'consum', 0.0210, 'lps'),
	(432017, 124, '2015-03-01 01:20:23.000000', 'consum', 0.0216, 'lps'),
	(432018, 124, '2015-03-01 01:20:24.000000', 'consum', 0.0217, 'lps'),
	(432019, 124, '2015-03-01 01:20:25.000000', 'consum', 0.0225, 'lps'),
	(432020, 124, '2015-03-01 01:20:26.000000', 'consum', 0.0213, 'lps'),
	(432021, 124, '2015-03-01 01:20:27.000000', 'consum', 0.0233, 'lps'),
	(432022, 124, '2015-03-01 01:20:28.000000', 'consum', 0.0214, 'lps'),
	(432023, 124, '2015-03-01 01:20:29.000000', 'consum', 0.0214, 'lps'),
	(432024, 124, '2015-03-01 01:20:30.000000', 'consum', 0.0218, 'lps'),
	(432025, 124, '2015-03-01 01:20:31.000000', 'consum', 0.0211, 'lps'),
	(432026, 124, '2015-03-01 01:20:32.000000', 'consum', 0.0217, 'lps'),
	(432027, 124, '2015-03-01 01:20:33.000000', 'consum', 0.0216, 'lps'),
	(432028, 124, '2015-03-01 01:20:34.000000', 'consum', 0.0222, 'lps'),
	(432029, 124, '2015-03-01 01:20:35.000000', 'consum', 0.0224, 'lps'),
	(432030, 124, '2015-03-01 01:20:36.000000', 'consum', 0.0220, 'lps'),
	(432031, 124, '2015-03-01 01:20:37.000000', 'consum', 0.0218, 'lps'),
	(432032, 124, '2015-03-01 01:20:38.000000', 'consum', 0.0222, 'lps'),
	(432033, 124, '2015-03-01 01:20:39.000000', 'consum', 0.0219, 'lps'),
	(432034, 124, '2015-03-01 01:20:40.000000', 'consum', 0.0222, 'lps'),
	(432035, 124, '2015-03-01 01:20:41.000000', 'consum', 0.0215, 'lps'),
	(432036, 124, '2015-03-01 01:20:42.000000', 'consum', 0.0224, 'lps'),
	(432037, 124, '2015-03-01 01:20:43.000000', 'consum', 0.0216, 'lps'),
	(432038, 124, '2015-03-01 01:20:44.000000', 'consum', 0.0222, 'lps'),
	(432039, 124, '2015-03-01 01:20:45.000000', 'consum', 0.0227, 'lps'),
	(432040, 124, '2015-03-01 01:20:46.000000', 'consum', 0.0233, 'lps'),
	(432041, 124, '2015-03-01 01:20:47.000000', 'consum', 0.0225, 'lps'),
	(432042, 124, '2015-03-01 01:20:48.000000', 'consum', 0.0217, 'lps'),
	(432043, 124, '2015-03-01 01:20:49.000000', 'consum', 0.0223, 'lps'),
	(432044, 124, '2015-03-01 01:20:50.000000', 'consum', 0.0231, 'lps'),
	(432045, 124, '2015-03-01 01:20:51.000000', 'consum', 0.0226, 'lps'),
	(432046, 124, '2015-03-01 01:20:52.000000', 'consum', 0.0225, 'lps'),
	(432047, 124, '2015-03-01 01:20:53.000000', 'consum', 0.0214, 'lps'),
	(432048, 124, '2015-03-01 01:20:54.000000', 'consum', 0.0234, 'lps'),
	(432049, 124, '2015-03-01 01:20:55.000000', 'consum', 0.0217, 'lps'),
	(432050, 124, '2015-03-01 01:20:56.000000', 'consum', 0.0223, 'lps'),
	(432051, 124, '2015-03-01 01:20:57.000000', 'consum', 0.0229, 'lps'),
	(432052, 124, '2015-03-01 01:20:58.000000', 'consum', 0.0214, 'lps'),
	(432053, 124, '2015-03-01 01:20:59.000000', 'consum', 0.0227, 'lps'),
	(432054, 124, '2015-03-01 01:21:00.000000', 'consum', 0.0230, 'lps'),
	(432055, 124, '2015-03-01 01:21:01.000000', 'consum', 0.0232, 'lps'),
	(432056, 124, '2015-03-01 01:21:02.000000', 'consum', 0.0210, 'lps'),
	(432057, 124, '2015-03-01 01:21:03.000000', 'consum', 0.0223, 'lps'),
	(432058, 124, '2015-03-01 01:21:04.000000', 'consum', 0.0225, 'lps'),
	(432059, 124, '2015-03-01 01:21:05.000000', 'consum', 0.0220, 'lps'),
	(432060, 124, '2015-03-01 01:21:06.000000', 'consum', 0.0214, 'lps'),
	(432061, 124, '2015-03-01 01:21:07.000000', 'consum', 0.0225, 'lps'),
	(432062, 124, '2015-03-01 01:21:08.000000', 'consum', 0.0223, 'lps'),
	(432063, 124, '2015-03-01 01:21:09.000000', 'consum', 0.0233, 'lps'),
	(432064, 124, '2015-03-01 01:21:10.000000', 'consum', 0.0231, 'lps'),
	(432065, 124, '2015-03-01 01:21:11.000000', 'consum', 0.0222, 'lps'),
	(432066, 124, '2015-03-01 01:21:12.000000', 'consum', 0.0233, 'lps'),
	(432067, 124, '2015-03-01 01:21:13.000000', 'consum', 0.0213, 'lps'),
	(432068, 124, '2015-03-01 01:21:14.000000', 'consum', 0.0232, 'lps'),
	(432069, 124, '2015-03-01 01:21:15.000000', 'consum', 0.0210, 'lps'),
	(432070, 124, '2015-03-01 01:21:16.000000', 'consum', 0.0222, 'lps'),
	(432071, 124, '2015-03-01 01:21:17.000000', 'consum', 0.0219, 'lps'),
	(432072, 124, '2015-03-01 01:21:18.000000', 'consum', 0.0219, 'lps'),
	(432073, 124, '2015-03-01 01:21:19.000000', 'consum', 0.0230, 'lps'),
	(432074, 124, '2015-03-01 01:21:20.000000', 'consum', 0.0228, 'lps'),
	(432075, 124, '2015-03-01 01:21:21.000000', 'consum', 0.0218, 'lps'),
	(432076, 124, '2015-03-01 01:21:22.000000', 'consum', 0.0220, 'lps'),
	(432077, 124, '2015-03-01 01:21:23.000000', 'consum', 0.0210, 'lps'),
	(432078, 124, '2015-03-01 01:21:24.000000', 'consum', 0.0231, 'lps'),
	(432079, 124, '2015-03-01 01:21:25.000000', 'consum', 0.0215, 'lps'),
	(432080, 124, '2015-03-01 01:21:26.000000', 'consum', 0.0224, 'lps'),
	(432081, 124, '2015-03-01 01:21:27.000000', 'consum', 0.0212, 'lps'),
	(432082, 124, '2015-03-01 01:21:28.000000', 'consum', 0.0229, 'lps'),
	(432083, 124, '2015-03-01 01:21:29.000000', 'consum', 0.0225, 'lps'),
	(432084, 124, '2015-03-01 01:21:30.000000', 'consum', 0.0226, 'lps'),
	(432085, 124, '2015-03-01 01:21:31.000000', 'consum', 0.0222, 'lps'),
	(432086, 124, '2015-03-01 01:21:32.000000', 'consum', 0.0219, 'lps'),
	(432087, 124, '2015-03-01 01:21:33.000000', 'consum', 0.0223, 'lps'),
	(432088, 124, '2015-03-01 01:21:34.000000', 'consum', 0.0221, 'lps'),
	(432089, 124, '2015-03-01 01:21:35.000000', 'consum', 0.0226, 'lps'),
	(432090, 124, '2015-03-01 01:21:36.000000', 'consum', 0.0234, 'lps'),
	(432091, 124, '2015-03-01 01:21:37.000000', 'consum', 0.0228, 'lps'),
	(432092, 124, '2015-03-01 01:21:38.000000', 'consum', 0.0228, 'lps'),
	(432093, 124, '2015-03-01 01:21:39.000000', 'consum', 0.0222, 'lps'),
	(432094, 124, '2015-03-01 01:21:40.000000', 'consum', 0.0215, 'lps'),
	(432095, 124, '2015-03-01 01:21:41.000000', 'consum', 0.0227, 'lps'),
	(432096, 124, '2015-03-01 01:21:42.000000', 'consum', 0.0228, 'lps'),
	(432097, 124, '2015-03-01 01:21:43.000000', 'consum', 0.0224, 'lps'),
	(432098, 124, '2015-03-01 01:21:44.000000', 'consum', 0.0227, 'lps'),
	(432099, 124, '2015-03-01 01:21:45.000000', 'consum', 0.0228, 'lps'),
	(432100, 124, '2015-03-01 01:21:46.000000', 'consum', 0.0223, 'lps'),
	(432101, 124, '2015-03-01 01:21:47.000000', 'consum', 0.0220, 'lps'),
	(432102, 124, '2015-03-01 01:21:48.000000', 'consum', 0.0224, 'lps'),
	(432103, 124, '2015-03-01 01:21:49.000000', 'consum', 0.0221, 'lps'),
	(432104, 124, '2015-03-01 01:21:50.000000', 'consum', 0.0227, 'lps'),
	(432105, 124, '2015-03-01 01:21:51.000000', 'consum', 0.0235, 'lps'),
	(432106, 124, '2015-03-01 01:21:52.000000', 'consum', 0.0232, 'lps'),
	(432107, 124, '2015-03-01 01:21:53.000000', 'consum', 0.0219, 'lps'),
	(432108, 124, '2015-03-01 01:21:54.000000', 'consum', 0.0218, 'lps'),
	(432109, 124, '2015-03-01 01:21:55.000000', 'consum', 0.0221, 'lps'),
	(432110, 124, '2015-03-01 01:21:56.000000', 'consum', 0.0218, 'lps'),
	(432111, 124, '2015-03-01 01:21:57.000000', 'consum', 0.0217, 'lps'),
	(432112, 124, '2015-03-01 01:21:58.000000', 'consum', 0.0222, 'lps'),
	(432113, 124, '2015-03-01 01:21:59.000000', 'consum', 0.0225, 'lps'),
	(432114, 124, '2015-03-01 01:22:00.000000', 'consum', 0.0222, 'lps'),
	(432115, 124, '2015-03-01 01:22:01.000000', 'consum', 0.0223, 'lps'),
	(432116, 124, '2015-03-01 01:22:02.000000', 'consum', 0.0217, 'lps'),
	(432117, 124, '2015-03-01 01:22:03.000000', 'consum', 0.0231, 'lps'),
	(432118, 124, '2015-03-01 01:22:04.000000', 'consum', 0.0218, 'lps'),
	(432119, 124, '2015-03-01 01:22:05.000000', 'consum', 0.0213, 'lps'),
	(432120, 124, '2015-03-01 01:22:06.000000', 'consum', 0.0229, 'lps'),
	(432121, 124, '2015-03-01 01:22:07.000000', 'consum', 0.0216, 'lps'),
	(432122, 124, '2015-03-01 01:22:08.000000', 'consum', 0.0211, 'lps'),
	(432123, 124, '2015-03-01 01:22:09.000000', 'consum', 0.0222, 'lps'),
	(432124, 124, '2015-03-01 01:22:10.000000', 'consum', 0.0218, 'lps'),
	(432125, 124, '2015-03-01 01:22:11.000000', 'consum', 0.0214, 'lps'),
	(432126, 124, '2015-03-01 01:22:12.000000', 'consum', 0.0234, 'lps'),
	(432127, 124, '2015-03-01 01:22:13.000000', 'consum', 0.0211, 'lps'),
	(432128, 124, '2015-03-01 01:22:14.000000', 'consum', 0.0223, 'lps'),
	(432129, 124, '2015-03-01 01:22:15.000000', 'consum', 0.0220, 'lps'),
	(432130, 124, '2015-03-01 01:22:16.000000', 'consum', 0.0223, 'lps'),
	(432131, 124, '2015-03-01 01:22:17.000000', 'consum', 0.0221, 'lps'),
	(432132, 124, '2015-03-01 01:22:18.000000', 'consum', 0.0224, 'lps'),
	(432133, 124, '2015-03-01 01:22:19.000000', 'consum', 0.0221, 'lps'),
	(432134, 124, '2015-03-01 01:22:20.000000', 'consum', 0.0223, 'lps'),
	(432135, 124, '2015-03-01 01:22:21.000000', 'consum', 0.0218, 'lps'),
	(432136, 124, '2015-03-01 01:22:22.000000', 'consum', 0.0210, 'lps'),
	(432137, 124, '2015-03-01 01:22:23.000000', 'consum', 0.0215, 'lps'),
	(432138, 124, '2015-03-01 01:22:24.000000', 'consum', 0.0235, 'lps'),
	(432139, 124, '2015-03-01 01:22:25.000000', 'consum', 0.0216, 'lps'),
	(432140, 124, '2015-03-01 01:22:26.000000', 'consum', 0.0219, 'lps'),
	(432141, 124, '2015-03-01 01:22:27.000000', 'consum', 0.0210, 'lps'),
	(432142, 124, '2015-03-01 01:22:28.000000', 'consum', 0.0211, 'lps'),
	(432143, 124, '2015-03-01 01:22:29.000000', 'consum', 0.0214, 'lps'),
	(432144, 124, '2015-03-01 01:22:30.000000', 'consum', 0.0230, 'lps'),
	(432145, 124, '2015-03-01 01:22:31.000000', 'consum', 0.0218, 'lps'),
	(432146, 124, '2015-03-01 01:22:32.000000', 'consum', 0.0216, 'lps'),
	(432147, 124, '2015-03-01 01:22:33.000000', 'consum', 0.0218, 'lps'),
	(432148, 124, '2015-03-01 01:22:34.000000', 'consum', 0.0231, 'lps'),
	(432149, 124, '2015-03-01 01:22:35.000000', 'consum', 0.0212, 'lps'),
	(432150, 124, '2015-03-01 01:22:36.000000', 'consum', 0.0213, 'lps'),
	(432151, 124, '2015-03-01 01:22:37.000000', 'consum', 0.0217, 'lps'),
	(432152, 124, '2015-03-01 01:22:38.000000', 'consum', 0.0212, 'lps'),
	(432153, 124, '2015-03-01 01:22:39.000000', 'consum', 0.0226, 'lps'),
	(432154, 124, '2015-03-01 01:22:40.000000', 'consum', 0.0233, 'lps'),
	(432155, 124, '2015-03-01 01:22:41.000000', 'consum', 0.0224, 'lps'),
	(432156, 124, '2015-03-01 01:22:42.000000', 'consum', 0.0213, 'lps'),
	(432157, 124, '2015-03-01 01:22:43.000000', 'consum', 0.0233, 'lps'),
	(432158, 124, '2015-03-01 01:22:44.000000', 'consum', 0.0215, 'lps'),
	(432159, 124, '2015-03-01 01:22:45.000000', 'consum', 0.0217, 'lps'),
	(432160, 124, '2015-03-01 01:22:46.000000', 'consum', 0.0232, 'lps'),
	(432161, 124, '2015-03-01 01:22:47.000000', 'consum', 0.0222, 'lps'),
	(432162, 124, '2015-03-01 01:22:48.000000', 'consum', 0.0232, 'lps'),
	(432163, 124, '2015-03-01 01:22:49.000000', 'consum', 0.0230, 'lps'),
	(432164, 124, '2015-03-01 01:22:50.000000', 'consum', 0.0218, 'lps'),
	(432165, 124, '2015-03-01 01:22:51.000000', 'consum', 0.0216, 'lps'),
	(432166, 124, '2015-03-01 01:22:52.000000', 'consum', 0.0218, 'lps'),
	(432167, 124, '2015-03-01 01:22:53.000000', 'consum', 0.0230, 'lps'),
	(432168, 124, '2015-03-01 01:22:54.000000', 'consum', 0.0212, 'lps'),
	(432169, 124, '2015-03-01 01:22:55.000000', 'consum', 0.0210, 'lps'),
	(432170, 124, '2015-03-01 01:22:56.000000', 'consum', 0.0230, 'lps'),
	(432171, 124, '2015-03-01 01:22:57.000000', 'consum', 0.0234, 'lps'),
	(432172, 124, '2015-03-01 01:22:58.000000', 'consum', 0.0218, 'lps'),
	(432173, 124, '2015-03-01 01:22:59.000000', 'consum', 0.0230, 'lps'),
	(432174, 124, '2015-03-01 01:23:00.000000', 'consum', 0.0235, 'lps'),
	(432175, 124, '2015-03-01 01:23:01.000000', 'consum', 0.0224, 'lps'),
	(432176, 124, '2015-03-01 01:23:02.000000', 'consum', 0.0231, 'lps'),
	(432177, 124, '2015-03-01 01:23:03.000000', 'consum', 0.0222, 'lps'),
	(432178, 124, '2015-03-01 01:23:04.000000', 'consum', 0.0232, 'lps'),
	(432179, 124, '2015-03-01 01:23:05.000000', 'consum', 0.0232, 'lps'),
	(432180, 124, '2015-03-01 01:23:06.000000', 'consum', 0.0228, 'lps'),
	(432181, 124, '2015-03-01 01:23:07.000000', 'consum', 0.0234, 'lps'),
	(432182, 124, '2015-03-01 01:23:08.000000', 'consum', 0.0226, 'lps'),
	(432183, 124, '2015-03-01 01:23:09.000000', 'consum', 0.0219, 'lps'),
	(432184, 124, '2015-03-01 01:23:10.000000', 'consum', 0.0233, 'lps'),
	(432185, 124, '2015-03-01 01:23:11.000000', 'consum', 0.0219, 'lps'),
	(432186, 124, '2015-03-01 01:23:12.000000', 'consum', 0.0215, 'lps'),
	(432187, 124, '2015-03-01 01:23:13.000000', 'consum', 0.0233, 'lps'),
	(432188, 124, '2015-03-01 01:23:14.000000', 'consum', 0.0233, 'lps'),
	(432189, 124, '2015-03-01 01:23:15.000000', 'consum', 0.0232, 'lps'),
	(432190, 124, '2015-03-01 01:23:16.000000', 'consum', 0.0225, 'lps'),
	(432191, 124, '2015-03-01 01:23:17.000000', 'consum', 0.0219, 'lps'),
	(432192, 124, '2015-03-01 01:23:18.000000', 'consum', 0.0235, 'lps'),
	(432193, 124, '2015-03-01 01:23:19.000000', 'consum', 0.0231, 'lps'),
	(432194, 124, '2015-03-01 01:23:20.000000', 'consum', 0.0215, 'lps'),
	(432195, 124, '2015-03-01 01:23:21.000000', 'consum', 0.0223, 'lps'),
	(432196, 124, '2015-03-01 01:23:22.000000', 'consum', 0.0234, 'lps'),
	(432197, 124, '2015-03-01 01:23:23.000000', 'consum', 0.0213, 'lps'),
	(432198, 124, '2015-03-01 01:23:24.000000', 'consum', 0.0232, 'lps'),
	(432199, 124, '2015-03-01 01:23:25.000000', 'consum', 0.0233, 'lps'),
	(432200, 124, '2015-03-01 01:23:26.000000', 'consum', 0.0210, 'lps'),
	(432201, 124, '2015-03-01 01:23:27.000000', 'consum', 0.0218, 'lps'),
	(432202, 124, '2015-03-01 01:23:28.000000', 'consum', 0.0223, 'lps'),
	(432203, 124, '2015-03-01 01:23:29.000000', 'consum', 0.0225, 'lps'),
	(432204, 124, '2015-03-01 01:23:30.000000', 'consum', 0.0221, 'lps'),
	(432205, 124, '2015-03-01 01:23:31.000000', 'consum', 0.0222, 'lps'),
	(432206, 124, '2015-03-01 01:23:32.000000', 'consum', 0.0235, 'lps'),
	(432207, 124, '2015-03-01 01:23:33.000000', 'consum', 0.0224, 'lps'),
	(432208, 124, '2015-03-01 01:23:34.000000', 'consum', 0.0232, 'lps'),
	(432209, 124, '2015-03-01 01:23:35.000000', 'consum', 0.0225, 'lps'),
	(432210, 124, '2015-03-01 01:23:36.000000', 'consum', 0.0221, 'lps'),
	(432211, 124, '2015-03-01 01:23:37.000000', 'consum', 0.0219, 'lps'),
	(432212, 124, '2015-03-01 01:23:38.000000', 'consum', 0.0222, 'lps'),
	(432213, 124, '2015-03-01 01:23:39.000000', 'consum', 0.0219, 'lps'),
	(432214, 124, '2015-03-01 01:23:40.000000', 'consum', 0.0218, 'lps'),
	(432215, 124, '2015-03-01 01:23:41.000000', 'consum', 0.0223, 'lps'),
	(432216, 124, '2015-03-01 01:23:42.000000', 'consum', 0.0227, 'lps'),
	(432217, 124, '2015-03-01 01:23:43.000000', 'consum', 0.0230, 'lps'),
	(432218, 124, '2015-03-01 01:23:44.000000', 'consum', 0.0233, 'lps'),
	(432219, 124, '2015-03-01 01:23:45.000000', 'consum', 0.0216, 'lps'),
	(432220, 124, '2015-03-01 01:23:46.000000', 'consum', 0.0220, 'lps'),
	(432221, 124, '2015-03-01 01:23:47.000000', 'consum', 0.0218, 'lps'),
	(432222, 124, '2015-03-01 01:23:48.000000', 'consum', 0.0221, 'lps'),
	(432223, 124, '2015-03-01 01:23:49.000000', 'consum', 0.0215, 'lps'),
	(432224, 124, '2015-03-01 01:23:50.000000', 'consum', 0.0228, 'lps'),
	(432225, 124, '2015-03-01 01:23:51.000000', 'consum', 0.0234, 'lps'),
	(432226, 124, '2015-03-01 01:23:52.000000', 'consum', 0.0225, 'lps'),
	(432227, 124, '2015-03-01 01:23:53.000000', 'consum', 0.0213, 'lps'),
	(432228, 124, '2015-03-01 01:23:54.000000', 'consum', 0.0233, 'lps'),
	(432229, 124, '2015-03-01 01:23:55.000000', 'consum', 0.0210, 'lps'),
	(432230, 124, '2015-03-01 01:23:56.000000', 'consum', 0.0223, 'lps'),
	(432231, 124, '2015-03-01 01:23:57.000000', 'consum', 0.0221, 'lps'),
	(432232, 124, '2015-03-01 01:23:58.000000', 'consum', 0.0229, 'lps'),
	(432233, 124, '2015-03-01 01:23:59.000000', 'consum', 0.0219, 'lps'),
	(432234, 124, '2015-03-01 01:24:00.000000', 'consum', 0.0224, 'lps'),
	(432235, 124, '2015-03-01 01:24:01.000000', 'consum', 0.0229, 'lps'),
	(432236, 124, '2015-03-01 01:24:02.000000', 'consum', 0.0211, 'lps'),
	(432237, 124, '2015-03-01 01:24:03.000000', 'consum', 0.0210, 'lps'),
	(432238, 124, '2015-03-01 01:24:04.000000', 'consum', 0.0235, 'lps'),
	(432239, 124, '2015-03-01 01:24:05.000000', 'consum', 0.0232, 'lps'),
	(432240, 124, '2015-03-01 01:24:06.000000', 'consum', 0.0218, 'lps'),
	(432241, 124, '2015-03-01 01:24:07.000000', 'consum', 0.0213, 'lps'),
	(432242, 124, '2015-03-01 01:24:08.000000', 'consum', 0.0225, 'lps'),
	(432243, 124, '2015-03-01 01:24:09.000000', 'consum', 0.0223, 'lps'),
	(432244, 124, '2015-03-01 01:24:10.000000', 'consum', 0.0233, 'lps'),
	(432245, 124, '2015-03-01 01:24:11.000000', 'consum', 0.0232, 'lps'),
	(432246, 124, '2015-03-01 01:24:12.000000', 'consum', 0.0226, 'lps'),
	(432247, 124, '2015-03-01 01:24:13.000000', 'consum', 0.0225, 'lps'),
	(432248, 124, '2015-03-01 01:24:14.000000', 'consum', 0.0212, 'lps'),
	(432249, 124, '2015-03-01 01:24:15.000000', 'consum', 0.0228, 'lps'),
	(432250, 124, '2015-03-01 01:24:16.000000', 'consum', 0.0216, 'lps'),
	(432251, 124, '2015-03-01 01:24:17.000000', 'consum', 0.0212, 'lps'),
	(432252, 124, '2015-03-01 01:24:18.000000', 'consum', 0.0230, 'lps'),
	(432253, 124, '2015-03-01 01:24:19.000000', 'consum', 0.0227, 'lps'),
	(432254, 124, '2015-03-01 01:24:20.000000', 'consum', 0.0233, 'lps'),
	(432255, 124, '2015-03-01 01:24:21.000000', 'consum', 0.0224, 'lps'),
	(432256, 124, '2015-03-01 01:24:22.000000', 'consum', 0.0210, 'lps'),
	(432257, 124, '2015-03-01 01:24:23.000000', 'consum', 0.0223, 'lps'),
	(432258, 124, '2015-03-01 01:24:24.000000', 'consum', 0.0221, 'lps'),
	(432259, 124, '2015-03-01 01:24:25.000000', 'consum', 0.0229, 'lps'),
	(432260, 124, '2015-03-01 01:24:26.000000', 'consum', 0.0221, 'lps'),
	(432261, 124, '2015-03-01 01:24:27.000000', 'consum', 0.0232, 'lps'),
	(432262, 124, '2015-03-01 01:24:28.000000', 'consum', 0.0210, 'lps'),
	(432263, 124, '2015-03-01 01:24:29.000000', 'consum', 0.0224, 'lps'),
	(432264, 124, '2015-03-01 01:24:30.000000', 'consum', 0.0229, 'lps'),
	(432265, 124, '2015-03-01 01:24:31.000000', 'consum', 0.0212, 'lps'),
	(432266, 124, '2015-03-01 01:24:32.000000', 'consum', 0.0213, 'lps'),
	(432267, 124, '2015-03-01 01:24:33.000000', 'consum', 0.0219, 'lps'),
	(432268, 124, '2015-03-01 01:24:34.000000', 'consum', 0.0222, 'lps'),
	(432269, 124, '2015-03-01 01:24:35.000000', 'consum', 0.0216, 'lps'),
	(432270, 124, '2015-03-01 01:24:36.000000', 'consum', 0.0231, 'lps'),
	(432271, 124, '2015-03-01 01:24:37.000000', 'consum', 0.0221, 'lps'),
	(432272, 124, '2015-03-01 01:24:38.000000', 'consum', 0.0227, 'lps'),
	(432273, 124, '2015-03-01 01:24:39.000000', 'consum', 0.0235, 'lps'),
	(432274, 124, '2015-03-01 01:24:40.000000', 'consum', 0.0235, 'lps'),
	(432275, 124, '2015-03-01 01:24:41.000000', 'consum', 0.0210, 'lps'),
	(432276, 124, '2015-03-01 01:24:42.000000', 'consum', 0.0210, 'lps'),
	(432277, 124, '2015-03-01 01:24:43.000000', 'consum', 0.0212, 'lps'),
	(432278, 124, '2015-03-01 01:24:44.000000', 'consum', 0.0219, 'lps'),
	(432279, 124, '2015-03-01 01:24:45.000000', 'consum', 0.0223, 'lps'),
	(432280, 124, '2015-03-01 01:24:46.000000', 'consum', 0.0222, 'lps'),
	(432281, 124, '2015-03-01 01:24:47.000000', 'consum', 0.0231, 'lps'),
	(432282, 124, '2015-03-01 01:24:48.000000', 'consum', 0.0231, 'lps'),
	(432283, 124, '2015-03-01 01:24:49.000000', 'consum', 0.0223, 'lps'),
	(432284, 124, '2015-03-01 01:24:50.000000', 'consum', 0.0213, 'lps'),
	(432285, 124, '2015-03-01 01:24:51.000000', 'consum', 0.0213, 'lps'),
	(432286, 124, '2015-03-01 01:24:52.000000', 'consum', 0.0216, 'lps'),
	(432287, 124, '2015-03-01 01:24:53.000000', 'consum', 0.0230, 'lps'),
	(432288, 124, '2015-03-01 01:24:54.000000', 'consum', 0.0215, 'lps'),
	(432289, 124, '2015-03-01 01:24:55.000000', 'consum', 0.0229, 'lps'),
	(432290, 124, '2015-03-01 01:24:56.000000', 'consum', 0.0211, 'lps'),
	(432291, 124, '2015-03-01 01:24:57.000000', 'consum', 0.0210, 'lps'),
	(432292, 124, '2015-03-01 01:24:58.000000', 'consum', 0.0210, 'lps'),
	(432293, 124, '2015-03-01 01:24:59.000000', 'consum', 0.0210, 'lps'),
	(432294, 124, '2015-03-01 01:25:00.000000', 'consum', 0.0234, 'lps'),
	(432295, 124, '2015-03-01 01:25:01.000000', 'consum', 0.0228, 'lps'),
	(432296, 124, '2015-03-01 01:25:02.000000', 'consum', 0.0230, 'lps'),
	(432297, 124, '2015-03-01 01:25:03.000000', 'consum', 0.0230, 'lps'),
	(432298, 124, '2015-03-01 01:25:04.000000', 'consum', 0.0223, 'lps'),
	(432299, 124, '2015-03-01 01:25:05.000000', 'consum', 0.0218, 'lps'),
	(432300, 124, '2015-03-01 01:25:06.000000', 'consum', 0.0211, 'lps'),
	(432301, 124, '2015-03-01 01:25:07.000000', 'consum', 0.0219, 'lps'),
	(432302, 124, '2015-03-01 01:25:08.000000', 'consum', 0.0225, 'lps'),
	(432303, 124, '2015-03-01 01:25:09.000000', 'consum', 0.0233, 'lps'),
	(432304, 124, '2015-03-01 01:25:10.000000', 'consum', 0.0228, 'lps'),
	(432305, 124, '2015-03-01 01:25:11.000000', 'consum', 0.0232, 'lps'),
	(432306, 124, '2015-03-01 01:25:12.000000', 'consum', 0.0214, 'lps'),
	(432307, 124, '2015-03-01 01:25:13.000000', 'consum', 0.0218, 'lps'),
	(432308, 124, '2015-03-01 01:25:14.000000', 'consum', 0.0212, 'lps'),
	(432309, 124, '2015-03-01 01:25:15.000000', 'consum', 0.0221, 'lps'),
	(432310, 124, '2015-03-01 01:25:16.000000', 'consum', 0.0233, 'lps'),
	(432311, 124, '2015-03-01 01:25:17.000000', 'consum', 0.0217, 'lps'),
	(432312, 124, '2015-03-01 01:25:18.000000', 'consum', 0.0228, 'lps'),
	(432313, 124, '2015-03-01 01:25:19.000000', 'consum', 0.0227, 'lps'),
	(432314, 124, '2015-03-01 01:25:20.000000', 'consum', 0.0216, 'lps'),
	(432315, 124, '2015-03-01 01:25:21.000000', 'consum', 0.0215, 'lps'),
	(432316, 124, '2015-03-01 01:25:22.000000', 'consum', 0.0217, 'lps'),
	(432317, 124, '2015-03-01 01:25:23.000000', 'consum', 0.0231, 'lps'),
	(432318, 124, '2015-03-01 01:25:24.000000', 'consum', 0.0218, 'lps'),
	(432319, 124, '2015-03-01 01:25:25.000000', 'consum', 0.0215, 'lps'),
	(432320, 124, '2015-03-01 01:25:26.000000', 'consum', 0.0234, 'lps'),
	(432321, 124, '2015-03-01 01:25:27.000000', 'consum', 0.0211, 'lps'),
	(432322, 124, '2015-03-01 01:25:28.000000', 'consum', 0.0224, 'lps'),
	(432323, 124, '2015-03-01 01:25:29.000000', 'consum', 0.0223, 'lps'),
	(432324, 124, '2015-03-01 01:25:30.000000', 'consum', 0.0234, 'lps'),
	(432325, 124, '2015-03-01 01:25:31.000000', 'consum', 0.0212, 'lps'),
	(432326, 124, '2015-03-01 01:25:32.000000', 'consum', 0.0228, 'lps'),
	(432327, 124, '2015-03-01 01:25:33.000000', 'consum', 0.0217, 'lps'),
	(432328, 124, '2015-03-01 01:25:34.000000', 'consum', 0.0217, 'lps'),
	(432329, 124, '2015-03-01 01:25:35.000000', 'consum', 0.0225, 'lps'),
	(432330, 124, '2015-03-01 01:25:36.000000', 'consum', 0.0214, 'lps'),
	(432331, 124, '2015-03-01 01:25:37.000000', 'consum', 0.0235, 'lps'),
	(432332, 124, '2015-03-01 01:25:38.000000', 'consum', 0.0221, 'lps'),
	(432333, 124, '2015-03-01 01:25:39.000000', 'consum', 0.0218, 'lps'),
	(432334, 124, '2015-03-01 01:25:40.000000', 'consum', 0.0215, 'lps'),
	(432335, 124, '2015-03-01 01:25:41.000000', 'consum', 0.0212, 'lps'),
	(432336, 124, '2015-03-01 01:25:42.000000', 'consum', 0.0231, 'lps'),
	(432337, 124, '2015-03-01 01:25:43.000000', 'consum', 0.0232, 'lps'),
	(432338, 124, '2015-03-01 01:25:44.000000', 'consum', 0.0232, 'lps'),
	(432339, 124, '2015-03-01 01:25:45.000000', 'consum', 0.0228, 'lps'),
	(432340, 124, '2015-03-01 01:25:46.000000', 'consum', 0.0235, 'lps'),
	(432341, 124, '2015-03-01 01:25:47.000000', 'consum', 0.0228, 'lps'),
	(432342, 124, '2015-03-01 01:25:48.000000', 'consum', 0.0226, 'lps'),
	(432343, 124, '2015-03-01 01:25:49.000000', 'consum', 0.0210, 'lps'),
	(432344, 124, '2015-03-01 01:25:50.000000', 'consum', 0.0213, 'lps'),
	(432345, 124, '2015-03-01 01:25:51.000000', 'consum', 0.0227, 'lps'),
	(432346, 124, '2015-03-01 01:25:52.000000', 'consum', 0.0233, 'lps'),
	(432347, 124, '2015-03-01 01:25:53.000000', 'consum', 0.0225, 'lps'),
	(432348, 124, '2015-03-01 01:25:54.000000', 'consum', 0.0216, 'lps'),
	(432349, 124, '2015-03-01 01:25:55.000000', 'consum', 0.0223, 'lps'),
	(432350, 124, '2015-03-01 01:25:56.000000', 'consum', 0.0229, 'lps'),
	(432351, 124, '2015-03-01 01:25:57.000000', 'consum', 0.0213, 'lps'),
	(432352, 124, '2015-03-01 01:25:58.000000', 'consum', 0.0224, 'lps'),
	(432353, 124, '2015-03-01 01:25:59.000000', 'consum', 0.0218, 'lps'),
	(432354, 124, '2015-03-01 01:26:00.000000', 'consum', 0.0210, 'lps'),
	(432355, 124, '2015-03-01 01:26:01.000000', 'consum', 0.0211, 'lps'),
	(432356, 124, '2015-03-01 01:26:02.000000', 'consum', 0.0216, 'lps'),
	(432357, 124, '2015-03-01 01:26:03.000000', 'consum', 0.0212, 'lps'),
	(432358, 124, '2015-03-01 01:26:04.000000', 'consum', 0.0229, 'lps'),
	(432359, 124, '2015-03-01 01:26:05.000000', 'consum', 0.0219, 'lps'),
	(432360, 124, '2015-03-01 01:26:06.000000', 'consum', 0.0225, 'lps'),
	(432361, 124, '2015-03-01 01:26:07.000000', 'consum', 0.0232, 'lps'),
	(432362, 124, '2015-03-01 01:26:08.000000', 'consum', 0.0226, 'lps'),
	(432363, 124, '2015-03-01 01:26:09.000000', 'consum', 0.0221, 'lps'),
	(432364, 124, '2015-03-01 01:26:10.000000', 'consum', 0.0221, 'lps'),
	(432365, 124, '2015-03-01 01:26:11.000000', 'consum', 0.0230, 'lps'),
	(432366, 124, '2015-03-01 01:26:12.000000', 'consum', 0.0226, 'lps'),
	(432367, 124, '2015-03-01 01:26:13.000000', 'consum', 0.0232, 'lps'),
	(432368, 124, '2015-03-01 01:26:14.000000', 'consum', 0.0218, 'lps'),
	(432369, 124, '2015-03-01 01:26:15.000000', 'consum', 0.0211, 'lps'),
	(432370, 124, '2015-03-01 01:26:16.000000', 'consum', 0.0218, 'lps'),
	(432371, 124, '2015-03-01 01:26:17.000000', 'consum', 0.0222, 'lps'),
	(432372, 124, '2015-03-01 01:26:18.000000', 'consum', 0.0219, 'lps'),
	(432373, 124, '2015-03-01 01:26:19.000000', 'consum', 0.0219, 'lps'),
	(432374, 124, '2015-03-01 01:26:20.000000', 'consum', 0.0231, 'lps'),
	(432375, 124, '2015-03-01 01:26:21.000000', 'consum', 0.0235, 'lps'),
	(432376, 124, '2015-03-01 01:26:22.000000', 'consum', 0.0220, 'lps'),
	(432377, 124, '2015-03-01 01:26:23.000000', 'consum', 0.0213, 'lps'),
	(432378, 124, '2015-03-01 01:26:24.000000', 'consum', 0.0220, 'lps'),
	(432379, 124, '2015-03-01 01:26:25.000000', 'consum', 0.0225, 'lps'),
	(432380, 124, '2015-03-01 01:26:26.000000', 'consum', 0.0229, 'lps'),
	(432381, 124, '2015-03-01 01:26:27.000000', 'consum', 0.0210, 'lps'),
	(432382, 124, '2015-03-01 01:26:28.000000', 'consum', 0.0229, 'lps'),
	(432383, 124, '2015-03-01 01:26:29.000000', 'consum', 0.0229, 'lps'),
	(432384, 124, '2015-03-01 01:26:30.000000', 'consum', 0.0224, 'lps'),
	(432385, 124, '2015-03-01 01:26:31.000000', 'consum', 0.0224, 'lps'),
	(432386, 124, '2015-03-01 01:26:32.000000', 'consum', 0.0211, 'lps'),
	(432387, 124, '2015-03-01 01:26:33.000000', 'consum', 0.0227, 'lps'),
	(432388, 124, '2015-03-01 01:26:34.000000', 'consum', 0.0214, 'lps'),
	(432389, 124, '2015-03-01 01:26:35.000000', 'consum', 0.0229, 'lps'),
	(432390, 124, '2015-03-01 01:26:36.000000', 'consum', 0.0218, 'lps'),
	(432391, 124, '2015-03-01 01:26:37.000000', 'consum', 0.0220, 'lps'),
	(432392, 124, '2015-03-01 01:26:38.000000', 'consum', 0.0235, 'lps'),
	(432393, 124, '2015-03-01 01:26:39.000000', 'consum', 0.0230, 'lps'),
	(432394, 124, '2015-03-01 01:26:40.000000', 'consum', 0.0234, 'lps'),
	(432395, 124, '2015-03-01 01:26:41.000000', 'consum', 0.0217, 'lps'),
	(432396, 124, '2015-03-01 01:26:42.000000', 'consum', 0.0228, 'lps'),
	(432397, 124, '2015-03-01 01:26:43.000000', 'consum', 0.0226, 'lps'),
	(432398, 124, '2015-03-01 01:26:44.000000', 'consum', 0.0211, 'lps'),
	(432399, 124, '2015-03-01 01:26:45.000000', 'consum', 0.0219, 'lps'),
	(432400, 124, '2015-03-01 01:26:46.000000', 'consum', 0.0225, 'lps'),
	(432401, 124, '2015-03-01 01:26:47.000000', 'consum', 0.0234, 'lps'),
	(432402, 124, '2015-03-01 01:26:48.000000', 'consum', 0.0233, 'lps'),
	(432403, 124, '2015-03-01 01:26:49.000000', 'consum', 0.0229, 'lps'),
	(432404, 124, '2015-03-01 01:26:50.000000', 'consum', 0.0210, 'lps'),
	(432405, 124, '2015-03-01 01:26:51.000000', 'consum', 0.0229, 'lps'),
	(432406, 124, '2015-03-01 01:26:52.000000', 'consum', 0.0230, 'lps'),
	(432407, 124, '2015-03-01 01:26:53.000000', 'consum', 0.0228, 'lps'),
	(432408, 124, '2015-03-01 01:26:54.000000', 'consum', 0.0215, 'lps'),
	(432409, 124, '2015-03-01 01:26:55.000000', 'consum', 0.0232, 'lps'),
	(432410, 124, '2015-03-01 01:26:56.000000', 'consum', 0.0228, 'lps'),
	(432411, 124, '2015-03-01 01:26:57.000000', 'consum', 0.0210, 'lps'),
	(432412, 124, '2015-03-01 01:26:58.000000', 'consum', 0.0233, 'lps'),
	(432413, 124, '2015-03-01 01:26:59.000000', 'consum', 0.0220, 'lps'),
	(432414, 124, '2015-03-01 01:27:00.000000', 'consum', 0.0218, 'lps'),
	(432415, 124, '2015-03-01 01:27:01.000000', 'consum', 0.0221, 'lps'),
	(432416, 124, '2015-03-01 01:27:02.000000', 'consum', 0.0214, 'lps'),
	(432417, 124, '2015-03-01 01:27:03.000000', 'consum', 0.0224, 'lps'),
	(432418, 124, '2015-03-01 01:27:04.000000', 'consum', 0.0218, 'lps'),
	(432419, 124, '2015-03-01 01:27:05.000000', 'consum', 0.0210, 'lps'),
	(432420, 124, '2015-03-01 01:27:06.000000', 'consum', 0.0235, 'lps'),
	(432421, 124, '2015-03-01 01:27:07.000000', 'consum', 0.0232, 'lps'),
	(432422, 124, '2015-03-01 01:27:08.000000', 'consum', 0.0221, 'lps'),
	(432423, 124, '2015-03-01 01:27:09.000000', 'consum', 0.0225, 'lps'),
	(432424, 124, '2015-03-01 01:27:10.000000', 'consum', 0.0229, 'lps'),
	(432425, 124, '2015-03-01 01:27:11.000000', 'consum', 0.0231, 'lps'),
	(432426, 124, '2015-03-01 01:27:12.000000', 'consum', 0.0232, 'lps'),
	(432427, 124, '2015-03-01 01:27:13.000000', 'consum', 0.0232, 'lps'),
	(432428, 124, '2015-03-01 01:27:14.000000', 'consum', 0.0229, 'lps'),
	(432429, 124, '2015-03-01 01:27:15.000000', 'consum', 0.0215, 'lps'),
	(432430, 124, '2015-03-01 01:27:16.000000', 'consum', 0.0228, 'lps'),
	(432431, 124, '2015-03-01 01:27:17.000000', 'consum', 0.0234, 'lps'),
	(432432, 124, '2015-03-01 01:27:18.000000', 'consum', 0.0224, 'lps'),
	(432433, 124, '2015-03-01 01:27:19.000000', 'consum', 0.0210, 'lps'),
	(432434, 124, '2015-03-01 01:27:20.000000', 'consum', 0.0219, 'lps'),
	(432435, 124, '2015-03-01 01:27:21.000000', 'consum', 0.0229, 'lps'),
	(432436, 124, '2015-03-01 01:27:22.000000', 'consum', 0.0228, 'lps'),
	(432437, 124, '2015-03-01 01:27:23.000000', 'consum', 0.0215, 'lps'),
	(432438, 124, '2015-03-01 01:27:24.000000', 'consum', 0.0210, 'lps'),
	(432439, 124, '2015-03-01 01:27:25.000000', 'consum', 0.0222, 'lps'),
	(432440, 124, '2015-03-01 01:27:26.000000', 'consum', 0.0220, 'lps'),
	(432441, 124, '2015-03-01 01:27:27.000000', 'consum', 0.0221, 'lps'),
	(432442, 124, '2015-03-01 01:27:28.000000', 'consum', 0.0212, 'lps'),
	(432443, 124, '2015-03-01 01:27:29.000000', 'consum', 0.0211, 'lps'),
	(432444, 124, '2015-03-01 01:27:30.000000', 'consum', 0.0235, 'lps'),
	(432445, 124, '2015-03-01 01:27:31.000000', 'consum', 0.0228, 'lps'),
	(432446, 124, '2015-03-01 01:27:32.000000', 'consum', 0.0225, 'lps'),
	(432447, 124, '2015-03-01 01:27:33.000000', 'consum', 0.0232, 'lps'),
	(432448, 124, '2015-03-01 01:27:34.000000', 'consum', 0.0225, 'lps'),
	(432449, 124, '2015-03-01 01:27:35.000000', 'consum', 0.0219, 'lps'),
	(432450, 124, '2015-03-01 01:27:36.000000', 'consum', 0.0211, 'lps'),
	(432451, 124, '2015-03-01 01:27:37.000000', 'consum', 0.0214, 'lps'),
	(432452, 124, '2015-03-01 01:27:38.000000', 'consum', 0.0226, 'lps'),
	(432453, 124, '2015-03-01 01:27:39.000000', 'consum', 0.0226, 'lps'),
	(432454, 124, '2015-03-01 01:27:40.000000', 'consum', 0.0219, 'lps'),
	(432455, 124, '2015-03-01 01:27:41.000000', 'consum', 0.0233, 'lps'),
	(432456, 124, '2015-03-01 01:27:42.000000', 'consum', 0.0218, 'lps'),
	(432457, 124, '2015-03-01 01:27:43.000000', 'consum', 0.0210, 'lps'),
	(432458, 124, '2015-03-01 01:27:44.000000', 'consum', 0.0212, 'lps'),
	(432459, 124, '2015-03-01 01:27:45.000000', 'consum', 0.0221, 'lps'),
	(432460, 124, '2015-03-01 01:27:46.000000', 'consum', 0.0235, 'lps'),
	(432461, 124, '2015-03-01 01:27:47.000000', 'consum', 0.0222, 'lps'),
	(432462, 124, '2015-03-01 01:27:48.000000', 'consum', 0.0221, 'lps'),
	(432463, 124, '2015-03-01 01:27:49.000000', 'consum', 0.0232, 'lps'),
	(432464, 124, '2015-03-01 01:27:50.000000', 'consum', 0.0210, 'lps'),
	(432465, 124, '2015-03-01 01:27:51.000000', 'consum', 0.0221, 'lps'),
	(432466, 124, '2015-03-01 01:27:52.000000', 'consum', 0.0213, 'lps'),
	(432467, 124, '2015-03-01 01:27:53.000000', 'consum', 0.0220, 'lps'),
	(432468, 124, '2015-03-01 01:27:54.000000', 'consum', 0.0223, 'lps'),
	(432469, 124, '2015-03-01 01:27:55.000000', 'consum', 0.0223, 'lps'),
	(432470, 124, '2015-03-01 01:27:56.000000', 'consum', 0.0233, 'lps'),
	(432471, 124, '2015-03-01 01:27:57.000000', 'consum', 0.0212, 'lps'),
	(432472, 124, '2015-03-01 01:27:58.000000', 'consum', 0.0227, 'lps'),
	(432473, 124, '2015-03-01 01:27:59.000000', 'consum', 0.0213, 'lps'),
	(432474, 124, '2015-03-01 01:28:00.000000', 'consum', 0.0224, 'lps'),
	(432475, 124, '2015-03-01 01:28:01.000000', 'consum', 0.0223, 'lps'),
	(432476, 124, '2015-03-01 01:28:02.000000', 'consum', 0.0232, 'lps'),
	(432477, 124, '2015-03-01 01:28:03.000000', 'consum', 0.0229, 'lps'),
	(432478, 124, '2015-03-01 01:28:04.000000', 'consum', 0.0216, 'lps'),
	(432479, 124, '2015-03-01 01:28:05.000000', 'consum', 0.0233, 'lps'),
	(432480, 124, '2015-03-01 01:28:06.000000', 'consum', 0.0229, 'lps'),
	(432481, 124, '2015-03-01 01:28:07.000000', 'consum', 0.0213, 'lps'),
	(432482, 124, '2015-03-01 01:28:08.000000', 'consum', 0.0221, 'lps'),
	(432483, 124, '2015-03-01 01:28:09.000000', 'consum', 0.0227, 'lps'),
	(432484, 124, '2015-03-01 01:28:10.000000', 'consum', 0.0214, 'lps'),
	(432485, 124, '2015-03-01 01:28:11.000000', 'consum', 0.0230, 'lps'),
	(432486, 124, '2015-03-01 01:28:12.000000', 'consum', 0.0221, 'lps'),
	(432487, 124, '2015-03-01 01:28:13.000000', 'consum', 0.0230, 'lps'),
	(432488, 124, '2015-03-01 01:28:14.000000', 'consum', 0.0225, 'lps'),
	(432489, 124, '2015-03-01 01:28:15.000000', 'consum', 0.0225, 'lps'),
	(432490, 124, '2015-03-01 01:28:16.000000', 'consum', 0.0217, 'lps'),
	(432491, 124, '2015-03-01 01:28:17.000000', 'consum', 0.0224, 'lps'),
	(432492, 124, '2015-03-01 01:28:18.000000', 'consum', 0.0210, 'lps'),
	(432493, 124, '2015-03-01 01:28:19.000000', 'consum', 0.0218, 'lps'),
	(432494, 124, '2015-03-01 01:28:20.000000', 'consum', 0.0224, 'lps'),
	(432495, 124, '2015-03-01 01:28:21.000000', 'consum', 0.0230, 'lps'),
	(432496, 124, '2015-03-01 01:28:22.000000', 'consum', 0.0217, 'lps'),
	(432497, 124, '2015-03-01 01:28:23.000000', 'consum', 0.0211, 'lps'),
	(432498, 124, '2015-03-01 01:28:24.000000', 'consum', 0.0219, 'lps'),
	(432499, 124, '2015-03-01 01:28:25.000000', 'consum', 0.0228, 'lps'),
	(432500, 124, '2015-03-01 01:28:26.000000', 'consum', 0.0223, 'lps'),
	(432501, 124, '2015-03-01 01:28:27.000000', 'consum', 0.0220, 'lps'),
	(432502, 124, '2015-03-01 01:28:28.000000', 'consum', 0.0221, 'lps'),
	(432503, 124, '2015-03-01 01:28:29.000000', 'consum', 0.0234, 'lps'),
	(432504, 124, '2015-03-01 01:28:30.000000', 'consum', 0.0222, 'lps'),
	(432505, 124, '2015-03-01 01:28:31.000000', 'consum', 0.0226, 'lps'),
	(432506, 124, '2015-03-01 01:28:32.000000', 'consum', 0.0226, 'lps'),
	(432507, 124, '2015-03-01 01:28:33.000000', 'consum', 0.0218, 'lps'),
	(432508, 124, '2015-03-01 01:28:34.000000', 'consum', 0.0229, 'lps'),
	(432509, 124, '2015-03-01 01:28:35.000000', 'consum', 0.0230, 'lps'),
	(432510, 124, '2015-03-01 01:28:36.000000', 'consum', 0.0226, 'lps'),
	(432511, 124, '2015-03-01 01:28:37.000000', 'consum', 0.0233, 'lps'),
	(432512, 124, '2015-03-01 01:28:38.000000', 'consum', 0.0223, 'lps'),
	(432513, 124, '2015-03-01 01:28:39.000000', 'consum', 0.0232, 'lps'),
	(432514, 124, '2015-03-01 01:28:40.000000', 'consum', 0.0232, 'lps'),
	(432515, 124, '2015-03-01 01:28:41.000000', 'consum', 0.0227, 'lps'),
	(432516, 124, '2015-03-01 01:28:42.000000', 'consum', 0.0231, 'lps'),
	(432517, 124, '2015-03-01 01:28:43.000000', 'consum', 0.0211, 'lps'),
	(432518, 124, '2015-03-01 01:28:44.000000', 'consum', 0.0231, 'lps'),
	(432519, 124, '2015-03-01 01:28:45.000000', 'consum', 0.0235, 'lps'),
	(432520, 124, '2015-03-01 01:28:46.000000', 'consum', 0.0221, 'lps'),
	(432521, 124, '2015-03-01 01:28:47.000000', 'consum', 0.0214, 'lps'),
	(432522, 124, '2015-03-01 01:28:48.000000', 'consum', 0.0225, 'lps'),
	(432523, 124, '2015-03-01 01:28:49.000000', 'consum', 0.0222, 'lps'),
	(432524, 124, '2015-03-01 01:28:50.000000', 'consum', 0.0227, 'lps'),
	(432525, 124, '2015-03-01 01:28:51.000000', 'consum', 0.0231, 'lps'),
	(432526, 124, '2015-03-01 01:28:52.000000', 'consum', 0.0213, 'lps'),
	(432527, 124, '2015-03-01 01:28:53.000000', 'consum', 0.0213, 'lps'),
	(432528, 124, '2015-03-01 01:28:54.000000', 'consum', 0.0218, 'lps'),
	(432529, 124, '2015-03-01 01:28:55.000000', 'consum', 0.0216, 'lps'),
	(432530, 124, '2015-03-01 01:28:56.000000', 'consum', 0.0215, 'lps'),
	(432531, 124, '2015-03-01 01:28:57.000000', 'consum', 0.0218, 'lps'),
	(432532, 124, '2015-03-01 01:28:58.000000', 'consum', 0.0235, 'lps'),
	(432533, 124, '2015-03-01 01:28:59.000000', 'consum', 0.0233, 'lps'),
	(432534, 124, '2015-03-01 01:29:00.000000', 'consum', 0.0227, 'lps'),
	(432535, 124, '2015-03-01 01:29:01.000000', 'consum', 0.0225, 'lps'),
	(432536, 124, '2015-03-01 01:29:02.000000', 'consum', 0.0210, 'lps'),
	(432537, 124, '2015-03-01 01:29:03.000000', 'consum', 0.0217, 'lps'),
	(432538, 124, '2015-03-01 01:29:04.000000', 'consum', 0.0220, 'lps'),
	(432539, 124, '2015-03-01 01:29:05.000000', 'consum', 0.0213, 'lps'),
	(432540, 124, '2015-03-01 01:29:06.000000', 'consum', 0.0223, 'lps'),
	(432541, 124, '2015-03-01 01:29:07.000000', 'consum', 0.0212, 'lps'),
	(432542, 124, '2015-03-01 01:29:08.000000', 'consum', 0.0210, 'lps'),
	(432543, 124, '2015-03-01 01:29:09.000000', 'consum', 0.0231, 'lps'),
	(432544, 124, '2015-03-01 01:29:10.000000', 'consum', 0.0212, 'lps'),
	(432545, 124, '2015-03-01 01:29:11.000000', 'consum', 0.0233, 'lps'),
	(432546, 124, '2015-03-01 01:29:12.000000', 'consum', 0.0216, 'lps'),
	(432547, 124, '2015-03-01 01:29:13.000000', 'consum', 0.0225, 'lps'),
	(432548, 124, '2015-03-01 01:29:14.000000', 'consum', 0.0215, 'lps'),
	(432549, 124, '2015-03-01 01:29:15.000000', 'consum', 0.0218, 'lps'),
	(432550, 124, '2015-03-01 01:29:16.000000', 'consum', 0.0234, 'lps'),
	(432551, 124, '2015-03-01 01:29:17.000000', 'consum', 0.0228, 'lps'),
	(432552, 124, '2015-03-01 01:29:18.000000', 'consum', 0.0231, 'lps'),
	(432553, 124, '2015-03-01 01:29:19.000000', 'consum', 0.0232, 'lps'),
	(432554, 124, '2015-03-01 01:29:20.000000', 'consum', 0.0234, 'lps'),
	(432555, 124, '2015-03-01 01:29:21.000000', 'consum', 0.0210, 'lps'),
	(432556, 124, '2015-03-01 01:29:22.000000', 'consum', 0.0217, 'lps'),
	(432557, 124, '2015-03-01 01:29:23.000000', 'consum', 0.0219, 'lps'),
	(432558, 124, '2015-03-01 01:29:24.000000', 'consum', 0.0235, 'lps'),
	(432559, 124, '2015-03-01 01:29:25.000000', 'consum', 0.0230, 'lps'),
	(432560, 124, '2015-03-01 01:29:26.000000', 'consum', 0.0211, 'lps'),
	(432561, 124, '2015-03-01 01:29:27.000000', 'consum', 0.0234, 'lps'),
	(432562, 124, '2015-03-01 01:29:28.000000', 'consum', 0.0224, 'lps'),
	(432563, 124, '2015-03-01 01:29:29.000000', 'consum', 0.0235, 'lps'),
	(432564, 124, '2015-03-01 01:29:30.000000', 'consum', 0.0214, 'lps'),
	(432565, 124, '2015-03-01 01:29:31.000000', 'consum', 0.0210, 'lps'),
	(432566, 124, '2015-03-01 01:29:32.000000', 'consum', 0.0222, 'lps'),
	(432567, 124, '2015-03-01 01:29:33.000000', 'consum', 0.0221, 'lps'),
	(432568, 124, '2015-03-01 01:29:34.000000', 'consum', 0.0228, 'lps'),
	(432569, 124, '2015-03-01 01:29:35.000000', 'consum', 0.0214, 'lps'),
	(432570, 124, '2015-03-01 01:29:36.000000', 'consum', 0.0228, 'lps'),
	(432571, 124, '2015-03-01 01:29:37.000000', 'consum', 0.0210, 'lps'),
	(432572, 124, '2015-03-01 01:29:38.000000', 'consum', 0.0235, 'lps'),
	(432573, 124, '2015-03-01 01:29:39.000000', 'consum', 0.0233, 'lps'),
	(432574, 124, '2015-03-01 01:29:40.000000', 'consum', 0.0223, 'lps'),
	(432575, 124, '2015-03-01 01:29:41.000000', 'consum', 0.0231, 'lps'),
	(432576, 124, '2015-03-01 01:29:42.000000', 'consum', 0.0226, 'lps'),
	(432577, 124, '2015-03-01 01:29:43.000000', 'consum', 0.0228, 'lps'),
	(432578, 124, '2015-03-01 01:29:44.000000', 'consum', 0.0226, 'lps'),
	(432579, 124, '2015-03-01 01:29:45.000000', 'consum', 0.0212, 'lps'),
	(432580, 124, '2015-03-01 01:29:46.000000', 'consum', 0.0224, 'lps'),
	(432581, 124, '2015-03-01 01:29:47.000000', 'consum', 0.0223, 'lps'),
	(432582, 124, '2015-03-01 01:29:48.000000', 'consum', 0.0232, 'lps'),
	(432583, 124, '2015-03-01 01:29:49.000000', 'consum', 0.0231, 'lps'),
	(432584, 124, '2015-03-01 01:29:50.000000', 'consum', 0.0225, 'lps'),
	(432585, 124, '2015-03-01 01:29:51.000000', 'consum', 0.0220, 'lps'),
	(432586, 124, '2015-03-01 01:29:52.000000', 'consum', 0.0217, 'lps'),
	(432587, 124, '2015-03-01 01:29:53.000000', 'consum', 0.0217, 'lps'),
	(432588, 124, '2015-03-01 01:29:54.000000', 'consum', 0.0222, 'lps'),
	(432589, 124, '2015-03-01 01:29:55.000000', 'consum', 0.0223, 'lps'),
	(432590, 124, '2015-03-01 01:29:56.000000', 'consum', 0.0214, 'lps'),
	(432591, 124, '2015-03-01 01:29:57.000000', 'consum', 0.0218, 'lps'),
	(432592, 124, '2015-03-01 01:29:58.000000', 'consum', 0.0212, 'lps'),
	(432593, 124, '2015-03-01 01:29:59.000000', 'consum', 0.0223, 'lps'),
	(432594, 124, '2015-03-01 01:30:00.000000', 'consum', 0.0217, 'lps'),
	(432595, 124, '2015-03-01 01:30:01.000000', 'consum', 0.0232, 'lps'),
	(432596, 124, '2015-03-01 01:30:02.000000', 'consum', 0.0223, 'lps'),
	(432597, 124, '2015-03-01 01:30:03.000000', 'consum', 0.0235, 'lps'),
	(432598, 124, '2015-03-01 01:30:04.000000', 'consum', 0.0217, 'lps'),
	(432599, 124, '2015-03-01 01:30:05.000000', 'consum', 0.0223, 'lps'),
	(432600, 124, '2015-03-01 01:30:06.000000', 'consum', 0.0229, 'lps'),
	(432601, 124, '2015-03-01 01:30:07.000000', 'consum', 0.0216, 'lps'),
	(432602, 124, '2015-03-01 01:30:08.000000', 'consum', 0.0233, 'lps'),
	(432603, 124, '2015-03-01 01:30:09.000000', 'consum', 0.0232, 'lps'),
	(432604, 124, '2015-03-01 01:30:10.000000', 'consum', 0.0225, 'lps'),
	(432605, 124, '2015-03-01 01:30:11.000000', 'consum', 0.0220, 'lps'),
	(432606, 124, '2015-03-01 01:30:12.000000', 'consum', 0.0214, 'lps'),
	(432607, 124, '2015-03-01 01:30:13.000000', 'consum', 0.0227, 'lps'),
	(432608, 124, '2015-03-01 01:30:14.000000', 'consum', 0.0230, 'lps'),
	(432609, 124, '2015-03-01 01:30:15.000000', 'consum', 0.0233, 'lps'),
	(432610, 124, '2015-03-01 01:30:16.000000', 'consum', 0.0215, 'lps'),
	(432611, 124, '2015-03-01 01:30:17.000000', 'consum', 0.0220, 'lps'),
	(432612, 124, '2015-03-01 01:30:18.000000', 'consum', 0.0220, 'lps'),
	(432613, 124, '2015-03-01 01:30:19.000000', 'consum', 0.0228, 'lps'),
	(432614, 124, '2015-03-01 01:30:20.000000', 'consum', 0.0220, 'lps'),
	(432615, 124, '2015-03-01 01:30:21.000000', 'consum', 0.0234, 'lps'),
	(432616, 124, '2015-03-01 01:30:22.000000', 'consum', 0.0221, 'lps'),
	(432617, 124, '2015-03-01 01:30:23.000000', 'consum', 0.0218, 'lps'),
	(432618, 124, '2015-03-01 01:30:24.000000', 'consum', 0.0218, 'lps'),
	(432619, 124, '2015-03-01 01:30:25.000000', 'consum', 0.0227, 'lps'),
	(432620, 124, '2015-03-01 01:30:26.000000', 'consum', 0.0219, 'lps'),
	(432621, 124, '2015-03-01 01:30:27.000000', 'consum', 0.0231, 'lps'),
	(432622, 124, '2015-03-01 01:30:28.000000', 'consum', 0.0211, 'lps'),
	(432623, 124, '2015-03-01 01:30:29.000000', 'consum', 0.0231, 'lps'),
	(432624, 124, '2015-03-01 01:30:30.000000', 'consum', 0.0235, 'lps'),
	(432625, 124, '2015-03-01 01:30:31.000000', 'consum', 0.0221, 'lps'),
	(432626, 124, '2015-03-01 01:30:32.000000', 'consum', 0.0216, 'lps'),
	(432627, 124, '2015-03-01 01:30:33.000000', 'consum', 0.0232, 'lps'),
	(432628, 124, '2015-03-01 01:30:34.000000', 'consum', 0.0227, 'lps'),
	(432629, 124, '2015-03-01 01:30:35.000000', 'consum', 0.0229, 'lps'),
	(432630, 124, '2015-03-01 01:30:36.000000', 'consum', 0.0227, 'lps'),
	(432631, 124, '2015-03-01 01:30:37.000000', 'consum', 0.0213, 'lps'),
	(432632, 124, '2015-03-01 01:30:38.000000', 'consum', 0.0225, 'lps'),
	(432633, 124, '2015-03-01 01:30:39.000000', 'consum', 0.0224, 'lps'),
	(432634, 124, '2015-03-01 01:30:40.000000', 'consum', 0.0213, 'lps'),
	(432635, 124, '2015-03-01 01:30:41.000000', 'consum', 0.0233, 'lps'),
	(432636, 124, '2015-03-01 01:30:42.000000', 'consum', 0.0212, 'lps'),
	(432637, 124, '2015-03-01 01:30:43.000000', 'consum', 0.0229, 'lps'),
	(432638, 124, '2015-03-01 01:30:44.000000', 'consum', 0.0221, 'lps'),
	(432639, 124, '2015-03-01 01:30:45.000000', 'consum', 0.0211, 'lps'),
	(432640, 124, '2015-03-01 01:30:46.000000', 'consum', 0.0234, 'lps'),
	(432641, 124, '2015-03-01 01:30:47.000000', 'consum', 0.0222, 'lps'),
	(432642, 124, '2015-03-01 01:30:48.000000', 'consum', 0.0227, 'lps'),
	(432643, 124, '2015-03-01 01:30:49.000000', 'consum', 0.0233, 'lps'),
	(432644, 124, '2015-03-01 01:30:50.000000', 'consum', 0.0220, 'lps'),
	(432645, 124, '2015-03-01 01:30:51.000000', 'consum', 0.0219, 'lps'),
	(432646, 124, '2015-03-01 01:30:52.000000', 'consum', 0.0226, 'lps'),
	(432647, 124, '2015-03-01 01:30:53.000000', 'consum', 0.0211, 'lps'),
	(432648, 124, '2015-03-01 01:30:54.000000', 'consum', 0.0218, 'lps'),
	(432649, 124, '2015-03-01 01:30:55.000000', 'consum', 0.0223, 'lps'),
	(432650, 124, '2015-03-01 01:30:56.000000', 'consum', 0.0225, 'lps'),
	(432651, 124, '2015-03-01 01:30:57.000000', 'consum', 0.0222, 'lps'),
	(432652, 124, '2015-03-01 01:30:58.000000', 'consum', 0.0224, 'lps'),
	(432653, 124, '2015-03-01 01:30:59.000000', 'consum', 0.0220, 'lps'),
	(432654, 124, '2015-03-01 01:31:00.000000', 'consum', 0.0219, 'lps'),
	(432655, 124, '2015-03-01 01:31:01.000000', 'consum', 0.0226, 'lps'),
	(432656, 124, '2015-03-01 01:31:02.000000', 'consum', 0.0213, 'lps'),
	(432657, 124, '2015-03-01 01:31:03.000000', 'consum', 0.0226, 'lps'),
	(432658, 124, '2015-03-01 01:31:04.000000', 'consum', 0.0232, 'lps'),
	(432659, 124, '2015-03-01 01:31:05.000000', 'consum', 0.0220, 'lps'),
	(432660, 124, '2015-03-01 01:31:06.000000', 'consum', 0.0222, 'lps'),
	(432661, 124, '2015-03-01 01:31:07.000000', 'consum', 0.0215, 'lps'),
	(432662, 124, '2015-03-01 01:31:08.000000', 'consum', 0.0223, 'lps'),
	(432663, 124, '2015-03-01 01:31:09.000000', 'consum', 0.0233, 'lps'),
	(432664, 124, '2015-03-01 01:31:10.000000', 'consum', 0.0212, 'lps'),
	(432665, 124, '2015-03-01 01:31:11.000000', 'consum', 0.0227, 'lps'),
	(432666, 124, '2015-03-01 01:31:12.000000', 'consum', 0.0213, 'lps'),
	(432667, 124, '2015-03-01 01:31:13.000000', 'consum', 0.0228, 'lps'),
	(432668, 124, '2015-03-01 01:31:14.000000', 'consum', 0.0213, 'lps'),
	(432669, 124, '2015-03-01 01:31:15.000000', 'consum', 0.0223, 'lps'),
	(432670, 124, '2015-03-01 01:31:16.000000', 'consum', 0.0213, 'lps'),
	(432671, 124, '2015-03-01 01:31:17.000000', 'consum', 0.0214, 'lps'),
	(432672, 124, '2015-03-01 01:31:18.000000', 'consum', 0.0220, 'lps'),
	(432673, 124, '2015-03-01 01:31:19.000000', 'consum', 0.0222, 'lps'),
	(432674, 124, '2015-03-01 01:31:20.000000', 'consum', 0.0215, 'lps'),
	(432675, 124, '2015-03-01 01:31:21.000000', 'consum', 0.0228, 'lps'),
	(432676, 124, '2015-03-01 01:31:22.000000', 'consum', 0.0230, 'lps'),
	(432677, 124, '2015-03-01 01:31:23.000000', 'consum', 0.0232, 'lps'),
	(432678, 124, '2015-03-01 01:31:24.000000', 'consum', 0.0210, 'lps'),
	(432679, 124, '2015-03-01 01:31:25.000000', 'consum', 0.0222, 'lps'),
	(432680, 124, '2015-03-01 01:31:26.000000', 'consum', 0.0219, 'lps'),
	(432681, 124, '2015-03-01 01:31:27.000000', 'consum', 0.0218, 'lps'),
	(432682, 124, '2015-03-01 01:31:28.000000', 'consum', 0.0225, 'lps'),
	(432683, 124, '2015-03-01 01:31:29.000000', 'consum', 0.0235, 'lps'),
	(432684, 124, '2015-03-01 01:31:30.000000', 'consum', 0.0212, 'lps'),
	(432685, 124, '2015-03-01 01:31:31.000000', 'consum', 0.0225, 'lps'),
	(432686, 124, '2015-03-01 01:31:32.000000', 'consum', 0.0226, 'lps'),
	(432687, 124, '2015-03-01 01:31:33.000000', 'consum', 0.0221, 'lps'),
	(432688, 124, '2015-03-01 01:31:34.000000', 'consum', 0.0215, 'lps'),
	(432689, 124, '2015-03-01 01:31:35.000000', 'consum', 0.0229, 'lps'),
	(432690, 124, '2015-03-01 01:31:36.000000', 'consum', 0.0213, 'lps'),
	(432691, 124, '2015-03-01 01:31:37.000000', 'consum', 0.0221, 'lps'),
	(432692, 124, '2015-03-01 01:31:38.000000', 'consum', 0.0228, 'lps'),
	(432693, 124, '2015-03-01 01:31:39.000000', 'consum', 0.0219, 'lps'),
	(432694, 124, '2015-03-01 01:31:40.000000', 'consum', 0.0225, 'lps'),
	(432695, 124, '2015-03-01 01:31:41.000000', 'consum', 0.0233, 'lps'),
	(432696, 124, '2015-03-01 01:31:42.000000', 'consum', 0.0229, 'lps'),
	(432697, 124, '2015-03-01 01:31:43.000000', 'consum', 0.0211, 'lps'),
	(432698, 124, '2015-03-01 01:31:44.000000', 'consum', 0.0211, 'lps'),
	(432699, 124, '2015-03-01 01:31:45.000000', 'consum', 0.0211, 'lps'),
	(432700, 124, '2015-03-01 01:31:46.000000', 'consum', 0.0211, 'lps'),
	(432701, 124, '2015-03-01 01:31:47.000000', 'consum', 0.0214, 'lps'),
	(432702, 124, '2015-03-01 01:31:48.000000', 'consum', 0.0228, 'lps'),
	(432703, 124, '2015-03-01 01:31:49.000000', 'consum', 0.0212, 'lps'),
	(432704, 124, '2015-03-01 01:31:50.000000', 'consum', 0.0216, 'lps'),
	(432705, 124, '2015-03-01 01:31:51.000000', 'consum', 0.0211, 'lps'),
	(432706, 124, '2015-03-01 01:31:52.000000', 'consum', 0.0222, 'lps'),
	(432707, 124, '2015-03-01 01:31:53.000000', 'consum', 0.0217, 'lps'),
	(432708, 124, '2015-03-01 01:31:54.000000', 'consum', 0.0235, 'lps'),
	(432709, 124, '2015-03-01 01:31:55.000000', 'consum', 0.0211, 'lps'),
	(432710, 124, '2015-03-01 01:31:56.000000', 'consum', 0.0216, 'lps'),
	(432711, 124, '2015-03-01 01:31:57.000000', 'consum', 0.0213, 'lps'),
	(432712, 124, '2015-03-01 01:31:58.000000', 'consum', 0.0234, 'lps'),
	(432713, 124, '2015-03-01 01:31:59.000000', 'consum', 0.0216, 'lps'),
	(432714, 124, '2015-03-01 01:32:00.000000', 'consum', 0.0223, 'lps'),
	(432715, 124, '2015-03-01 01:32:01.000000', 'consum', 0.0232, 'lps'),
	(432716, 124, '2015-03-01 01:32:02.000000', 'consum', 0.0227, 'lps'),
	(432717, 124, '2015-03-01 01:32:03.000000', 'consum', 0.0231, 'lps'),
	(432718, 124, '2015-03-01 01:32:04.000000', 'consum', 0.0211, 'lps'),
	(432719, 124, '2015-03-01 01:32:05.000000', 'consum', 0.0231, 'lps'),
	(432720, 124, '2015-03-01 01:32:06.000000', 'consum', 0.0233, 'lps'),
	(432721, 124, '2015-03-01 01:32:07.000000', 'consum', 0.0214, 'lps'),
	(432722, 124, '2015-03-01 01:32:08.000000', 'consum', 0.0211, 'lps'),
	(432723, 124, '2015-03-01 01:32:09.000000', 'consum', 0.0231, 'lps'),
	(432724, 124, '2015-03-01 01:32:10.000000', 'consum', 0.0232, 'lps'),
	(432725, 124, '2015-03-01 01:32:11.000000', 'consum', 0.0233, 'lps'),
	(432726, 124, '2015-03-01 01:32:12.000000', 'consum', 0.0232, 'lps'),
	(432727, 124, '2015-03-01 01:32:13.000000', 'consum', 0.0228, 'lps'),
	(432728, 124, '2015-03-01 01:32:14.000000', 'consum', 0.0232, 'lps'),
	(432729, 124, '2015-03-01 01:32:15.000000', 'consum', 0.0217, 'lps'),
	(432730, 124, '2015-03-01 01:32:16.000000', 'consum', 0.0229, 'lps'),
	(432731, 124, '2015-03-01 01:32:17.000000', 'consum', 0.0234, 'lps'),
	(432732, 124, '2015-03-01 01:32:18.000000', 'consum', 0.0220, 'lps'),
	(432733, 124, '2015-03-01 01:32:19.000000', 'consum', 0.0214, 'lps'),
	(432734, 124, '2015-03-01 01:32:20.000000', 'consum', 0.0227, 'lps'),
	(432735, 124, '2015-03-01 01:32:21.000000', 'consum', 0.0233, 'lps'),
	(432736, 124, '2015-03-01 01:32:22.000000', 'consum', 0.0221, 'lps'),
	(432737, 124, '2015-03-01 01:32:23.000000', 'consum', 0.0225, 'lps'),
	(432738, 124, '2015-03-01 01:32:24.000000', 'consum', 0.0225, 'lps'),
	(432739, 124, '2015-03-01 01:32:25.000000', 'consum', 0.0215, 'lps'),
	(432740, 124, '2015-03-01 01:32:26.000000', 'consum', 0.0217, 'lps'),
	(432741, 124, '2015-03-01 01:32:27.000000', 'consum', 0.0228, 'lps'),
	(432742, 124, '2015-03-01 01:32:28.000000', 'consum', 0.0229, 'lps'),
	(432743, 124, '2015-03-01 01:32:29.000000', 'consum', 0.0227, 'lps'),
	(432744, 124, '2015-03-01 01:32:30.000000', 'consum', 0.0211, 'lps'),
	(432745, 124, '2015-03-01 01:32:31.000000', 'consum', 0.0217, 'lps'),
	(432746, 124, '2015-03-01 01:32:32.000000', 'consum', 0.0217, 'lps'),
	(432747, 124, '2015-03-01 01:32:33.000000', 'consum', 0.0223, 'lps'),
	(432748, 124, '2015-03-01 01:32:34.000000', 'consum', 0.0228, 'lps'),
	(432749, 124, '2015-03-01 01:32:35.000000', 'consum', 0.0210, 'lps'),
	(432750, 124, '2015-03-01 01:32:36.000000', 'consum', 0.0233, 'lps'),
	(432751, 124, '2015-03-01 01:32:37.000000', 'consum', 0.0221, 'lps'),
	(432752, 124, '2015-03-01 01:32:38.000000', 'consum', 0.0224, 'lps'),
	(432753, 124, '2015-03-01 01:32:39.000000', 'consum', 0.0222, 'lps'),
	(432754, 124, '2015-03-01 01:32:40.000000', 'consum', 0.0228, 'lps'),
	(432755, 124, '2015-03-01 01:32:41.000000', 'consum', 0.0211, 'lps'),
	(432756, 124, '2015-03-01 01:32:42.000000', 'consum', 0.0215, 'lps'),
	(432757, 124, '2015-03-01 01:32:43.000000', 'consum', 0.0231, 'lps'),
	(432758, 124, '2015-03-01 01:32:44.000000', 'consum', 0.0222, 'lps'),
	(432759, 124, '2015-03-01 01:32:45.000000', 'consum', 0.0210, 'lps'),
	(432760, 124, '2015-03-01 01:32:46.000000', 'consum', 0.0227, 'lps'),
	(432761, 124, '2015-03-01 01:32:47.000000', 'consum', 0.0216, 'lps'),
	(432762, 124, '2015-03-01 01:32:48.000000', 'consum', 0.0215, 'lps'),
	(432763, 124, '2015-03-01 01:32:49.000000', 'consum', 0.0219, 'lps'),
	(432764, 124, '2015-03-01 01:32:50.000000', 'consum', 0.0213, 'lps'),
	(432765, 124, '2015-03-01 01:32:51.000000', 'consum', 0.0223, 'lps'),
	(432766, 124, '2015-03-01 01:32:52.000000', 'consum', 0.0217, 'lps'),
	(432767, 124, '2015-03-01 01:32:53.000000', 'consum', 0.0233, 'lps'),
	(432768, 124, '2015-03-01 01:32:54.000000', 'consum', 0.0224, 'lps'),
	(432769, 124, '2015-03-01 01:32:55.000000', 'consum', 0.0212, 'lps'),
	(432770, 124, '2015-03-01 01:32:56.000000', 'consum', 0.0231, 'lps'),
	(432771, 124, '2015-03-01 01:32:57.000000', 'consum', 0.0231, 'lps'),
	(432772, 124, '2015-03-01 01:32:58.000000', 'consum', 0.0225, 'lps'),
	(432773, 124, '2015-03-01 01:32:59.000000', 'consum', 0.0225, 'lps'),
	(432774, 124, '2015-03-01 01:33:00.000000', 'consum', 0.0214, 'lps'),
	(432775, 124, '2015-03-01 01:33:01.000000', 'consum', 0.0211, 'lps'),
	(432776, 124, '2015-03-01 01:33:02.000000', 'consum', 0.0231, 'lps'),
	(432777, 124, '2015-03-01 01:33:03.000000', 'consum', 0.0235, 'lps'),
	(432778, 124, '2015-03-01 01:33:04.000000', 'consum', 0.0220, 'lps'),
	(432779, 124, '2015-03-01 01:33:05.000000', 'consum', 0.0235, 'lps'),
	(432780, 124, '2015-03-01 01:33:06.000000', 'consum', 0.0230, 'lps'),
	(432781, 124, '2015-03-01 01:33:07.000000', 'consum', 0.0235, 'lps'),
	(432782, 124, '2015-03-01 01:33:08.000000', 'consum', 0.0222, 'lps'),
	(432783, 124, '2015-03-01 01:33:09.000000', 'consum', 0.0223, 'lps'),
	(432784, 124, '2015-03-01 01:33:10.000000', 'consum', 0.0212, 'lps'),
	(432785, 124, '2015-03-01 01:33:11.000000', 'consum', 0.0235, 'lps'),
	(432786, 124, '2015-03-01 01:33:12.000000', 'consum', 0.0225, 'lps'),
	(432787, 124, '2015-03-01 01:33:13.000000', 'consum', 0.0210, 'lps'),
	(432788, 124, '2015-03-01 01:33:14.000000', 'consum', 0.0217, 'lps'),
	(432789, 124, '2015-03-01 01:33:15.000000', 'consum', 0.0219, 'lps'),
	(432790, 124, '2015-03-01 01:33:16.000000', 'consum', 0.0235, 'lps'),
	(432791, 124, '2015-03-01 01:33:17.000000', 'consum', 0.0230, 'lps'),
	(432792, 124, '2015-03-01 01:33:18.000000', 'consum', 0.0210, 'lps'),
	(432793, 124, '2015-03-01 01:33:19.000000', 'consum', 0.0229, 'lps'),
	(432794, 124, '2015-03-01 01:33:20.000000', 'consum', 0.0229, 'lps'),
	(432795, 124, '2015-03-01 01:33:21.000000', 'consum', 0.0221, 'lps'),
	(432796, 124, '2015-03-01 01:33:22.000000', 'consum', 0.0233, 'lps'),
	(432797, 124, '2015-03-01 01:33:23.000000', 'consum', 0.0217, 'lps'),
	(432798, 124, '2015-03-01 01:33:24.000000', 'consum', 0.0226, 'lps'),
	(432799, 124, '2015-03-01 01:33:25.000000', 'consum', 0.0217, 'lps'),
	(432800, 124, '2015-03-01 01:33:26.000000', 'consum', 0.0225, 'lps'),
	(432801, 124, '2015-03-01 01:33:27.000000', 'consum', 0.0212, 'lps'),
	(432802, 124, '2015-03-01 01:33:28.000000', 'consum', 0.0226, 'lps'),
	(432803, 124, '2015-03-01 01:33:29.000000', 'consum', 0.0234, 'lps'),
	(432804, 124, '2015-03-01 01:33:30.000000', 'consum', 0.0232, 'lps'),
	(432805, 124, '2015-03-01 01:33:31.000000', 'consum', 0.0222, 'lps'),
	(432806, 124, '2015-03-01 01:33:32.000000', 'consum', 0.0232, 'lps'),
	(432807, 124, '2015-03-01 01:33:33.000000', 'consum', 0.0229, 'lps'),
	(432808, 124, '2015-03-01 01:33:34.000000', 'consum', 0.0217, 'lps'),
	(432809, 124, '2015-03-01 01:33:35.000000', 'consum', 0.0213, 'lps'),
	(432810, 124, '2015-03-01 01:33:36.000000', 'consum', 0.0230, 'lps'),
	(432811, 124, '2015-03-01 01:33:37.000000', 'consum', 0.0223, 'lps'),
	(432812, 124, '2015-03-01 01:33:38.000000', 'consum', 0.0217, 'lps'),
	(432813, 124, '2015-03-01 01:33:39.000000', 'consum', 0.0230, 'lps'),
	(432814, 124, '2015-03-01 01:33:40.000000', 'consum', 0.0215, 'lps'),
	(432815, 124, '2015-03-01 01:33:41.000000', 'consum', 0.0224, 'lps'),
	(432816, 124, '2015-03-01 01:33:42.000000', 'consum', 0.0217, 'lps'),
	(432817, 124, '2015-03-01 01:33:43.000000', 'consum', 0.0227, 'lps'),
	(432818, 124, '2015-03-01 01:33:44.000000', 'consum', 0.0222, 'lps'),
	(432819, 124, '2015-03-01 01:33:45.000000', 'consum', 0.0222, 'lps'),
	(432820, 124, '2015-03-01 01:33:46.000000', 'consum', 0.0232, 'lps'),
	(432821, 124, '2015-03-01 01:33:47.000000', 'consum', 0.0232, 'lps'),
	(432822, 124, '2015-03-01 01:33:48.000000', 'consum', 0.0229, 'lps'),
	(432823, 124, '2015-03-01 01:33:49.000000', 'consum', 0.0214, 'lps'),
	(432824, 124, '2015-03-01 01:33:50.000000', 'consum', 0.0226, 'lps'),
	(432825, 124, '2015-03-01 01:33:51.000000', 'consum', 0.0225, 'lps'),
	(432826, 124, '2015-03-01 01:33:52.000000', 'consum', 0.0213, 'lps'),
	(432827, 124, '2015-03-01 01:33:53.000000', 'consum', 0.0232, 'lps'),
	(432828, 124, '2015-03-01 01:33:54.000000', 'consum', 0.0234, 'lps'),
	(432829, 124, '2015-03-01 01:33:55.000000', 'consum', 0.0214, 'lps'),
	(432830, 124, '2015-03-01 01:33:56.000000', 'consum', 0.0210, 'lps'),
	(432831, 124, '2015-03-01 01:33:57.000000', 'consum', 0.0225, 'lps'),
	(432832, 124, '2015-03-01 01:33:58.000000', 'consum', 0.0231, 'lps'),
	(432833, 124, '2015-03-01 01:33:59.000000', 'consum', 0.0220, 'lps'),
	(432834, 124, '2015-03-01 01:34:00.000000', 'consum', 0.0225, 'lps'),
	(432835, 124, '2015-03-01 01:34:01.000000', 'consum', 0.0226, 'lps'),
	(432836, 124, '2015-03-01 01:34:02.000000', 'consum', 0.0223, 'lps'),
	(432837, 124, '2015-03-01 01:34:03.000000', 'consum', 0.0225, 'lps'),
	(432838, 124, '2015-03-01 01:34:04.000000', 'consum', 0.0220, 'lps'),
	(432839, 124, '2015-03-01 01:34:05.000000', 'consum', 0.0217, 'lps'),
	(432840, 124, '2015-03-01 01:34:06.000000', 'consum', 0.0216, 'lps'),
	(432841, 124, '2015-03-01 01:34:07.000000', 'consum', 0.0221, 'lps'),
	(432842, 124, '2015-03-01 01:34:08.000000', 'consum', 0.0219, 'lps'),
	(432843, 124, '2015-03-01 01:34:09.000000', 'consum', 0.0222, 'lps'),
	(432844, 124, '2015-03-01 01:34:10.000000', 'consum', 0.0217, 'lps'),
	(432845, 124, '2015-03-01 01:34:11.000000', 'consum', 0.0213, 'lps'),
	(432846, 124, '2015-03-01 01:34:12.000000', 'consum', 0.0227, 'lps'),
	(432847, 124, '2015-03-01 01:34:13.000000', 'consum', 0.0234, 'lps'),
	(432848, 124, '2015-03-01 01:34:14.000000', 'consum', 0.0229, 'lps'),
	(432849, 124, '2015-03-01 01:34:15.000000', 'consum', 0.0234, 'lps'),
	(432850, 124, '2015-03-01 01:34:16.000000', 'consum', 0.0222, 'lps'),
	(432851, 124, '2015-03-01 01:34:17.000000', 'consum', 0.0225, 'lps'),
	(432852, 124, '2015-03-01 01:34:18.000000', 'consum', 0.0221, 'lps'),
	(432853, 124, '2015-03-01 01:34:19.000000', 'consum', 0.0221, 'lps'),
	(432854, 124, '2015-03-01 01:34:20.000000', 'consum', 0.0232, 'lps'),
	(432855, 124, '2015-03-01 01:34:21.000000', 'consum', 0.0211, 'lps'),
	(432856, 124, '2015-03-01 01:34:22.000000', 'consum', 0.0226, 'lps'),
	(432857, 124, '2015-03-01 01:34:23.000000', 'consum', 0.0212, 'lps'),
	(432858, 124, '2015-03-01 01:34:24.000000', 'consum', 0.0224, 'lps'),
	(432859, 124, '2015-03-01 01:34:25.000000', 'consum', 0.0221, 'lps'),
	(432860, 124, '2015-03-01 01:34:26.000000', 'consum', 0.0226, 'lps'),
	(432861, 124, '2015-03-01 01:34:27.000000', 'consum', 0.0229, 'lps'),
	(432862, 124, '2015-03-01 01:34:28.000000', 'consum', 0.0233, 'lps'),
	(432863, 124, '2015-03-01 01:34:29.000000', 'consum', 0.0215, 'lps'),
	(432864, 124, '2015-03-01 01:34:30.000000', 'consum', 0.0218, 'lps'),
	(432865, 124, '2015-03-01 01:34:31.000000', 'consum', 0.0212, 'lps'),
	(432866, 124, '2015-03-01 01:34:32.000000', 'consum', 0.0219, 'lps'),
	(432867, 124, '2015-03-01 01:34:33.000000', 'consum', 0.0227, 'lps'),
	(432868, 124, '2015-03-01 01:34:34.000000', 'consum', 0.0216, 'lps'),
	(432869, 124, '2015-03-01 01:34:35.000000', 'consum', 0.0216, 'lps'),
	(432870, 124, '2015-03-01 01:34:36.000000', 'consum', 0.0223, 'lps'),
	(432871, 124, '2015-03-01 01:34:37.000000', 'consum', 0.0232, 'lps'),
	(432872, 124, '2015-03-01 01:34:38.000000', 'consum', 0.0230, 'lps'),
	(432873, 124, '2015-03-01 01:34:39.000000', 'consum', 0.0219, 'lps'),
	(432874, 124, '2015-03-01 01:34:40.000000', 'consum', 0.0220, 'lps'),
	(432875, 124, '2015-03-01 01:34:41.000000', 'consum', 0.0235, 'lps'),
	(432876, 124, '2015-03-01 01:34:42.000000', 'consum', 0.0228, 'lps'),
	(432877, 124, '2015-03-01 01:34:43.000000', 'consum', 0.0224, 'lps'),
	(432878, 124, '2015-03-01 01:34:44.000000', 'consum', 0.0226, 'lps'),
	(432879, 124, '2015-03-01 01:34:45.000000', 'consum', 0.0222, 'lps'),
	(432880, 124, '2015-03-01 01:34:46.000000', 'consum', 0.0221, 'lps'),
	(432881, 124, '2015-03-01 01:34:47.000000', 'consum', 0.0232, 'lps'),
	(432882, 124, '2015-03-01 01:34:48.000000', 'consum', 0.0234, 'lps'),
	(432883, 124, '2015-03-01 01:34:49.000000', 'consum', 0.0213, 'lps'),
	(432884, 124, '2015-03-01 01:34:50.000000', 'consum', 0.0230, 'lps'),
	(432885, 124, '2015-03-01 01:34:51.000000', 'consum', 0.0226, 'lps'),
	(432886, 124, '2015-03-01 01:34:52.000000', 'consum', 0.0228, 'lps'),
	(432887, 124, '2015-03-01 01:34:53.000000', 'consum', 0.0227, 'lps'),
	(432888, 124, '2015-03-01 01:34:54.000000', 'consum', 0.0216, 'lps'),
	(432889, 124, '2015-03-01 01:34:55.000000', 'consum', 0.0215, 'lps'),
	(432890, 124, '2015-03-01 01:34:56.000000', 'consum', 0.0219, 'lps'),
	(432891, 124, '2015-03-01 01:34:57.000000', 'consum', 0.0215, 'lps'),
	(432892, 124, '2015-03-01 01:34:58.000000', 'consum', 0.0235, 'lps'),
	(432893, 124, '2015-03-01 01:34:59.000000', 'consum', 0.0215, 'lps'),
	(432894, 124, '2015-03-01 01:35:00.000000', 'consum', 0.0215, 'lps'),
	(432895, 124, '2015-03-01 01:35:01.000000', 'consum', 0.0219, 'lps'),
	(432896, 124, '2015-03-01 01:35:02.000000', 'consum', 0.0212, 'lps'),
	(432897, 124, '2015-03-01 01:35:03.000000', 'consum', 0.0223, 'lps'),
	(432898, 124, '2015-03-01 01:35:04.000000', 'consum', 0.0215, 'lps'),
	(432899, 124, '2015-03-01 01:35:05.000000', 'consum', 0.0225, 'lps'),
	(432900, 124, '2015-03-01 01:35:06.000000', 'consum', 0.0216, 'lps'),
	(432901, 124, '2015-03-01 01:35:07.000000', 'consum', 0.0223, 'lps'),
	(432902, 124, '2015-03-01 01:35:08.000000', 'consum', 0.0232, 'lps'),
	(432903, 124, '2015-03-01 01:35:09.000000', 'consum', 0.0228, 'lps'),
	(432904, 124, '2015-03-01 01:35:10.000000', 'consum', 0.0235, 'lps'),
	(432905, 124, '2015-03-01 01:35:11.000000', 'consum', 0.0231, 'lps'),
	(432906, 124, '2015-03-01 01:35:12.000000', 'consum', 0.0214, 'lps'),
	(432907, 124, '2015-03-01 01:35:13.000000', 'consum', 0.0220, 'lps'),
	(432908, 124, '2015-03-01 01:35:14.000000', 'consum', 0.0223, 'lps'),
	(432909, 124, '2015-03-01 01:35:15.000000', 'consum', 0.0219, 'lps'),
	(432910, 124, '2015-03-01 01:35:16.000000', 'consum', 0.0216, 'lps'),
	(432911, 124, '2015-03-01 01:35:17.000000', 'consum', 0.0212, 'lps'),
	(432912, 124, '2015-03-01 01:35:18.000000', 'consum', 0.0230, 'lps'),
	(432913, 124, '2015-03-01 01:35:19.000000', 'consum', 0.0226, 'lps'),
	(432914, 124, '2015-03-01 01:35:20.000000', 'consum', 0.0232, 'lps'),
	(432915, 124, '2015-03-01 01:35:21.000000', 'consum', 0.0220, 'lps'),
	(432916, 124, '2015-03-01 01:35:22.000000', 'consum', 0.0220, 'lps'),
	(432917, 124, '2015-03-01 01:35:23.000000', 'consum', 0.0230, 'lps'),
	(432918, 124, '2015-03-01 01:35:24.000000', 'consum', 0.0229, 'lps'),
	(432919, 124, '2015-03-01 01:35:25.000000', 'consum', 0.0218, 'lps'),
	(432920, 124, '2015-03-01 01:35:26.000000', 'consum', 0.0221, 'lps'),
	(432921, 124, '2015-03-01 01:35:27.000000', 'consum', 0.0216, 'lps'),
	(432922, 124, '2015-03-01 01:35:28.000000', 'consum', 0.0234, 'lps'),
	(432923, 124, '2015-03-01 01:35:29.000000', 'consum', 0.0233, 'lps'),
	(432924, 124, '2015-03-01 01:35:30.000000', 'consum', 0.0227, 'lps'),
	(432925, 124, '2015-03-01 01:35:31.000000', 'consum', 0.0225, 'lps'),
	(432926, 124, '2015-03-01 01:35:32.000000', 'consum', 0.0211, 'lps'),
	(432927, 124, '2015-03-01 01:35:33.000000', 'consum', 0.0224, 'lps'),
	(432928, 124, '2015-03-01 01:35:34.000000', 'consum', 0.0224, 'lps'),
	(432929, 124, '2015-03-01 01:35:35.000000', 'consum', 0.0212, 'lps'),
	(432930, 124, '2015-03-01 01:35:36.000000', 'consum', 0.0231, 'lps'),
	(432931, 124, '2015-03-01 01:35:37.000000', 'consum', 0.0233, 'lps'),
	(432932, 124, '2015-03-01 01:35:38.000000', 'consum', 0.0235, 'lps'),
	(432933, 124, '2015-03-01 01:35:39.000000', 'consum', 0.0213, 'lps'),
	(432934, 124, '2015-03-01 01:35:40.000000', 'consum', 0.0228, 'lps'),
	(432935, 124, '2015-03-01 01:35:41.000000', 'consum', 0.0216, 'lps'),
	(432936, 124, '2015-03-01 01:35:42.000000', 'consum', 0.0210, 'lps'),
	(432937, 124, '2015-03-01 01:35:43.000000', 'consum', 0.0220, 'lps'),
	(432938, 124, '2015-03-01 01:35:44.000000', 'consum', 0.0233, 'lps'),
	(432939, 124, '2015-03-01 01:35:45.000000', 'consum', 0.0216, 'lps'),
	(432940, 124, '2015-03-01 01:35:46.000000', 'consum', 0.0227, 'lps'),
	(432941, 124, '2015-03-01 01:35:47.000000', 'consum', 0.0224, 'lps'),
	(432942, 124, '2015-03-01 01:35:48.000000', 'consum', 0.0228, 'lps'),
	(432943, 124, '2015-03-01 01:35:49.000000', 'consum', 0.0233, 'lps'),
	(432944, 124, '2015-03-01 01:35:50.000000', 'consum', 0.0218, 'lps'),
	(432945, 124, '2015-03-01 01:35:51.000000', 'consum', 0.0234, 'lps'),
	(432946, 124, '2015-03-01 01:35:52.000000', 'consum', 0.0229, 'lps'),
	(432947, 124, '2015-03-01 01:35:53.000000', 'consum', 0.0210, 'lps'),
	(432948, 124, '2015-03-01 01:35:54.000000', 'consum', 0.0228, 'lps'),
	(432949, 124, '2015-03-01 01:35:55.000000', 'consum', 0.0223, 'lps'),
	(432950, 124, '2015-03-01 01:35:56.000000', 'consum', 0.0223, 'lps'),
	(432951, 124, '2015-03-01 01:35:57.000000', 'consum', 0.0211, 'lps'),
	(432952, 124, '2015-03-01 01:35:58.000000', 'consum', 0.0229, 'lps'),
	(432953, 124, '2015-03-01 01:35:59.000000', 'consum', 0.0222, 'lps'),
	(432954, 124, '2015-03-01 01:36:00.000000', 'consum', 0.0216, 'lps'),
	(432955, 124, '2015-03-01 01:36:01.000000', 'consum', 0.0228, 'lps'),
	(432956, 124, '2015-03-01 01:36:02.000000', 'consum', 0.0232, 'lps'),
	(432957, 124, '2015-03-01 01:36:03.000000', 'consum', 0.0215, 'lps'),
	(432958, 124, '2015-03-01 01:36:04.000000', 'consum', 0.0221, 'lps'),
	(432959, 124, '2015-03-01 01:36:05.000000', 'consum', 0.0223, 'lps'),
	(432960, 124, '2015-03-01 01:36:06.000000', 'consum', 0.0215, 'lps'),
	(432961, 124, '2015-03-01 01:36:07.000000', 'consum', 0.0226, 'lps'),
	(432962, 124, '2015-03-01 01:36:08.000000', 'consum', 0.0224, 'lps'),
	(432963, 124, '2015-03-01 01:36:09.000000', 'consum', 0.0229, 'lps'),
	(432964, 124, '2015-03-01 01:36:10.000000', 'consum', 0.0215, 'lps'),
	(432965, 124, '2015-03-01 01:36:11.000000', 'consum', 0.0230, 'lps'),
	(432966, 124, '2015-03-01 01:36:12.000000', 'consum', 0.0217, 'lps'),
	(432967, 124, '2015-03-01 01:36:13.000000', 'consum', 0.0235, 'lps'),
	(432968, 124, '2015-03-01 01:36:14.000000', 'consum', 0.0214, 'lps'),
	(432969, 124, '2015-03-01 01:36:15.000000', 'consum', 0.0230, 'lps'),
	(432970, 124, '2015-03-01 01:36:16.000000', 'consum', 0.0223, 'lps'),
	(432971, 124, '2015-03-01 01:36:17.000000', 'consum', 0.0213, 'lps'),
	(432972, 124, '2015-03-01 01:36:18.000000', 'consum', 0.0213, 'lps'),
	(432973, 124, '2015-03-01 01:36:19.000000', 'consum', 0.0216, 'lps'),
	(432974, 124, '2015-03-01 01:36:20.000000', 'consum', 0.0232, 'lps'),
	(432975, 124, '2015-03-01 01:36:21.000000', 'consum', 0.0223, 'lps'),
	(432976, 124, '2015-03-01 01:36:22.000000', 'consum', 0.0210, 'lps'),
	(432977, 124, '2015-03-01 01:36:23.000000', 'consum', 0.0222, 'lps'),
	(432978, 124, '2015-03-01 01:36:24.000000', 'consum', 0.0221, 'lps'),
	(432979, 124, '2015-03-01 01:36:25.000000', 'consum', 0.0229, 'lps'),
	(432980, 124, '2015-03-01 01:36:26.000000', 'consum', 0.0219, 'lps'),
	(432981, 124, '2015-03-01 01:36:27.000000', 'consum', 0.0226, 'lps'),
	(432982, 124, '2015-03-01 01:36:28.000000', 'consum', 0.0213, 'lps'),
	(432983, 124, '2015-03-01 01:36:29.000000', 'consum', 0.0229, 'lps'),
	(432984, 124, '2015-03-01 01:36:30.000000', 'consum', 0.0216, 'lps'),
	(432985, 124, '2015-03-01 01:36:31.000000', 'consum', 0.0211, 'lps'),
	(432986, 124, '2015-03-01 01:36:32.000000', 'consum', 0.0222, 'lps'),
	(432987, 124, '2015-03-01 01:36:33.000000', 'consum', 0.0215, 'lps'),
	(432988, 124, '2015-03-01 01:36:34.000000', 'consum', 0.0226, 'lps'),
	(432989, 124, '2015-03-01 01:36:35.000000', 'consum', 0.0223, 'lps'),
	(432990, 124, '2015-03-01 01:36:36.000000', 'consum', 0.0229, 'lps'),
	(432991, 124, '2015-03-01 01:36:37.000000', 'consum', 0.0214, 'lps'),
	(432992, 124, '2015-03-01 01:36:38.000000', 'consum', 0.0227, 'lps'),
	(432993, 124, '2015-03-01 01:36:39.000000', 'consum', 0.0232, 'lps'),
	(432994, 124, '2015-03-01 01:36:40.000000', 'consum', 0.0214, 'lps'),
	(432995, 124, '2015-03-01 01:36:41.000000', 'consum', 0.0219, 'lps'),
	(432996, 124, '2015-03-01 01:36:42.000000', 'consum', 0.0219, 'lps'),
	(432997, 124, '2015-03-01 01:36:43.000000', 'consum', 0.0226, 'lps'),
	(432998, 124, '2015-03-01 01:36:44.000000', 'consum', 0.0212, 'lps'),
	(432999, 124, '2015-03-01 01:36:45.000000', 'consum', 0.0226, 'lps'),
	(433000, 124, '2015-03-01 01:36:46.000000', 'consum', 0.0233, 'lps'),
	(433001, 124, '2015-03-01 01:36:47.000000', 'consum', 0.0225, 'lps'),
	(433002, 124, '2015-03-01 01:36:48.000000', 'consum', 0.0218, 'lps'),
	(433003, 124, '2015-03-01 01:36:49.000000', 'consum', 0.0228, 'lps'),
	(433004, 124, '2015-03-01 01:36:50.000000', 'consum', 0.0228, 'lps'),
	(433005, 124, '2015-03-01 01:36:51.000000', 'consum', 0.0219, 'lps'),
	(433006, 124, '2015-03-01 01:36:52.000000', 'consum', 0.0226, 'lps'),
	(433007, 124, '2015-03-01 01:36:53.000000', 'consum', 0.0214, 'lps'),
	(433008, 124, '2015-03-01 01:36:54.000000', 'consum', 0.0234, 'lps'),
	(433009, 124, '2015-03-01 01:36:55.000000', 'consum', 0.0215, 'lps'),
	(433010, 124, '2015-03-01 01:36:56.000000', 'consum', 0.0215, 'lps'),
	(433011, 124, '2015-03-01 01:36:57.000000', 'consum', 0.0221, 'lps'),
	(433012, 124, '2015-03-01 01:36:58.000000', 'consum', 0.0226, 'lps'),
	(433013, 124, '2015-03-01 01:36:59.000000', 'consum', 0.0229, 'lps'),
	(433014, 124, '2015-03-01 01:37:00.000000', 'consum', 0.0232, 'lps'),
	(433015, 124, '2015-03-01 01:37:01.000000', 'consum', 0.0211, 'lps'),
	(433016, 124, '2015-03-01 01:37:02.000000', 'consum', 0.0229, 'lps'),
	(433017, 124, '2015-03-01 01:37:03.000000', 'consum', 0.0223, 'lps'),
	(433018, 124, '2015-03-01 01:37:04.000000', 'consum', 0.0221, 'lps'),
	(433019, 124, '2015-03-01 01:37:05.000000', 'consum', 0.0225, 'lps'),
	(433020, 124, '2015-03-01 01:37:06.000000', 'consum', 0.0225, 'lps'),
	(433021, 124, '2015-03-01 01:37:07.000000', 'consum', 0.0215, 'lps'),
	(433022, 124, '2015-03-01 01:37:08.000000', 'consum', 0.0218, 'lps'),
	(433023, 124, '2015-03-01 01:37:09.000000', 'consum', 0.0211, 'lps'),
	(433024, 124, '2015-03-01 01:37:10.000000', 'consum', 0.0214, 'lps'),
	(433025, 124, '2015-03-01 01:37:11.000000', 'consum', 0.0229, 'lps'),
	(433026, 124, '2015-03-01 01:37:12.000000', 'consum', 0.0217, 'lps'),
	(433027, 124, '2015-03-01 01:37:13.000000', 'consum', 0.0214, 'lps'),
	(433028, 124, '2015-03-01 01:37:14.000000', 'consum', 0.0210, 'lps'),
	(433029, 124, '2015-03-01 01:37:15.000000', 'consum', 0.0224, 'lps'),
	(433030, 124, '2015-03-01 01:37:16.000000', 'consum', 0.0230, 'lps'),
	(433031, 124, '2015-03-01 01:37:17.000000', 'consum', 0.0216, 'lps'),
	(433032, 124, '2015-03-01 01:37:18.000000', 'consum', 0.0231, 'lps'),
	(433033, 124, '2015-03-01 01:37:19.000000', 'consum', 0.0219, 'lps'),
	(433034, 124, '2015-03-01 01:37:20.000000', 'consum', 0.0218, 'lps'),
	(433035, 124, '2015-03-01 01:37:21.000000', 'consum', 0.0223, 'lps'),
	(433036, 124, '2015-03-01 01:37:22.000000', 'consum', 0.0228, 'lps'),
	(433037, 124, '2015-03-01 01:37:23.000000', 'consum', 0.0233, 'lps'),
	(433038, 124, '2015-03-01 01:37:24.000000', 'consum', 0.0221, 'lps'),
	(433039, 124, '2015-03-01 01:37:25.000000', 'consum', 0.0224, 'lps'),
	(433040, 124, '2015-03-01 01:37:26.000000', 'consum', 0.0220, 'lps'),
	(433041, 124, '2015-03-01 01:37:27.000000', 'consum', 0.0218, 'lps'),
	(433042, 124, '2015-03-01 01:37:28.000000', 'consum', 0.0222, 'lps'),
	(433043, 124, '2015-03-01 01:37:29.000000', 'consum', 0.0221, 'lps'),
	(433044, 124, '2015-03-01 01:37:30.000000', 'consum', 0.0227, 'lps'),
	(433045, 124, '2015-03-01 01:37:31.000000', 'consum', 0.0210, 'lps'),
	(433046, 124, '2015-03-01 01:37:32.000000', 'consum', 0.0213, 'lps'),
	(433047, 124, '2015-03-01 01:37:33.000000', 'consum', 0.0224, 'lps'),
	(433048, 124, '2015-03-01 01:37:34.000000', 'consum', 0.0220, 'lps'),
	(433049, 124, '2015-03-01 01:37:35.000000', 'consum', 0.0218, 'lps'),
	(433050, 124, '2015-03-01 01:37:36.000000', 'consum', 0.0219, 'lps'),
	(433051, 124, '2015-03-01 01:37:37.000000', 'consum', 0.0233, 'lps'),
	(433052, 124, '2015-03-01 01:37:38.000000', 'consum', 0.0221, 'lps'),
	(433053, 124, '2015-03-01 01:37:39.000000', 'consum', 0.0221, 'lps'),
	(433054, 124, '2015-03-01 01:37:40.000000', 'consum', 0.0233, 'lps'),
	(433055, 124, '2015-03-01 01:37:41.000000', 'consum', 0.0215, 'lps'),
	(433056, 124, '2015-03-01 01:37:42.000000', 'consum', 0.0220, 'lps'),
	(433057, 124, '2015-03-01 01:37:43.000000', 'consum', 0.0218, 'lps'),
	(433058, 124, '2015-03-01 01:37:44.000000', 'consum', 0.0222, 'lps'),
	(433059, 125, '2015-03-01 00:00:00.000000', 'consum', 0.0224, 'lps'),
	(433060, 125, '2015-03-01 00:00:01.000000', 'consum', 0.0226, 'lps'),
	(433061, 125, '2015-03-01 00:00:02.000000', 'consum', 0.0218, 'lps'),
	(433062, 125, '2015-03-01 00:00:03.000000', 'consum', 0.0216, 'lps'),
	(433063, 125, '2015-03-01 00:00:04.000000', 'consum', 0.0219, 'lps'),
	(433064, 125, '2015-03-01 00:00:05.000000', 'consum', 0.0221, 'lps'),
	(433065, 125, '2015-03-01 00:00:06.000000', 'consum', 0.0221, 'lps'),
	(433066, 125, '2015-03-01 00:00:07.000000', 'consum', 0.0217, 'lps'),
	(433067, 125, '2015-03-01 00:00:08.000000', 'consum', 0.0212, 'lps'),
	(433068, 125, '2015-03-01 00:00:09.000000', 'consum', 0.0215, 'lps'),
	(433069, 125, '2015-03-01 00:00:10.000000', 'consum', 0.0214, 'lps'),
	(433070, 125, '2015-03-01 00:00:11.000000', 'consum', 0.0214, 'lps'),
	(433071, 125, '2015-03-01 00:00:12.000000', 'consum', 0.0220, 'lps'),
	(433072, 125, '2015-03-01 00:00:13.000000', 'consum', 0.0215, 'lps'),
	(433073, 125, '2015-03-01 00:00:14.000000', 'consum', 0.0220, 'lps'),
	(433074, 125, '2015-03-01 00:00:15.000000', 'consum', 0.0213, 'lps'),
	(433075, 125, '2015-03-01 00:00:16.000000', 'consum', 0.0211, 'lps'),
	(433076, 125, '2015-03-01 00:00:17.000000', 'consum', 0.0223, 'lps'),
	(433077, 125, '2015-03-01 00:00:18.000000', 'consum', 0.0221, 'lps'),
	(433078, 125, '2015-03-01 00:00:19.000000', 'consum', 0.0211, 'lps'),
	(433079, 125, '2015-03-01 00:00:20.000000', 'consum', 0.0215, 'lps'),
	(433080, 125, '2015-03-01 00:00:21.000000', 'consum', 0.0218, 'lps'),
	(433081, 125, '2015-03-01 00:00:22.000000', 'consum', 0.0216, 'lps'),
	(433082, 125, '2015-03-01 00:00:23.000000', 'consum', 0.0218, 'lps'),
	(433083, 125, '2015-03-01 00:00:24.000000', 'consum', 0.0216, 'lps'),
	(433084, 125, '2015-03-01 00:00:25.000000', 'consum', 0.0216, 'lps'),
	(433085, 125, '2015-03-01 00:00:26.000000', 'consum', 0.0222, 'lps'),
	(433086, 125, '2015-03-01 00:00:27.000000', 'consum', 0.0217, 'lps'),
	(433087, 125, '2015-03-01 00:00:28.000000', 'consum', 0.0210, 'lps'),
	(433088, 125, '2015-03-01 00:00:29.000000', 'consum', 0.0224, 'lps'),
	(433089, 125, '2015-03-01 00:00:30.000000', 'consum', 0.0212, 'lps'),
	(433090, 125, '2015-03-01 00:00:31.000000', 'consum', 0.0215, 'lps'),
	(433091, 125, '2015-03-01 00:00:32.000000', 'consum', 0.0210, 'lps'),
	(433092, 125, '2015-03-01 00:00:33.000000', 'consum', 0.0214, 'lps'),
	(433093, 125, '2015-03-01 00:00:34.000000', 'consum', 0.0213, 'lps'),
	(433094, 125, '2015-03-01 00:00:35.000000', 'consum', 0.0212, 'lps'),
	(433095, 125, '2015-03-01 00:00:36.000000', 'consum', 0.0215, 'lps'),
	(433096, 125, '2015-03-01 00:00:37.000000', 'consum', 0.0226, 'lps'),
	(433097, 125, '2015-03-01 00:00:38.000000', 'consum', 0.0226, 'lps'),
	(433098, 125, '2015-03-01 00:00:39.000000', 'consum', 0.0226, 'lps'),
	(433099, 125, '2015-03-01 00:00:40.000000', 'consum', 0.0226, 'lps'),
	(433100, 125, '2015-03-01 00:00:41.000000', 'consum', 0.0226, 'lps'),
	(433101, 125, '2015-03-01 00:00:42.000000', 'consum', 0.0224, 'lps'),
	(433102, 125, '2015-03-01 00:00:43.000000', 'consum', 0.0215, 'lps'),
	(433103, 125, '2015-03-01 00:00:44.000000', 'consum', 0.0210, 'lps'),
	(433104, 125, '2015-03-01 00:00:45.000000', 'consum', 0.0213, 'lps'),
	(433105, 125, '2015-03-01 00:00:46.000000', 'consum', 0.0225, 'lps'),
	(433106, 125, '2015-03-01 00:00:47.000000', 'consum', 0.0211, 'lps'),
	(433107, 125, '2015-03-01 00:00:48.000000', 'consum', 0.0220, 'lps'),
	(433108, 125, '2015-03-01 00:00:49.000000', 'consum', 0.0222, 'lps'),
	(433109, 125, '2015-03-01 00:00:50.000000', 'consum', 0.0210, 'lps'),
	(433110, 125, '2015-03-01 00:00:51.000000', 'consum', 0.0222, 'lps'),
	(433111, 125, '2015-03-01 00:00:52.000000', 'consum', 0.0221, 'lps'),
	(433112, 125, '2015-03-01 00:00:53.000000', 'consum', 0.0211, 'lps'),
	(433113, 125, '2015-03-01 00:00:54.000000', 'consum', 0.0218, 'lps'),
	(433114, 125, '2015-03-01 00:00:55.000000', 'consum', 0.0214, 'lps'),
	(433115, 125, '2015-03-01 00:00:56.000000', 'consum', 0.0221, 'lps'),
	(433116, 125, '2015-03-01 00:00:57.000000', 'consum', 0.0221, 'lps'),
	(433117, 125, '2015-03-01 00:00:58.000000', 'consum', 0.0216, 'lps'),
	(433118, 125, '2015-03-01 00:00:59.000000', 'consum', 0.0225, 'lps'),
	(433119, 125, '2015-03-01 00:01:00.000000', 'consum', 0.0217, 'lps'),
	(433120, 125, '2015-03-01 00:01:01.000000', 'consum', 0.0216, 'lps'),
	(433121, 125, '2015-03-01 00:01:02.000000', 'consum', 0.0220, 'lps'),
	(433122, 125, '2015-03-01 00:01:03.000000', 'consum', 0.0224, 'lps'),
	(433123, 125, '2015-03-01 00:01:04.000000', 'consum', 0.0218, 'lps'),
	(433124, 125, '2015-03-01 00:01:05.000000', 'consum', 0.0210, 'lps'),
	(433125, 125, '2015-03-01 00:01:06.000000', 'consum', 0.0221, 'lps'),
	(433126, 125, '2015-03-01 00:01:07.000000', 'consum', 0.0211, 'lps'),
	(433127, 125, '2015-03-01 00:01:08.000000', 'consum', 0.0220, 'lps'),
	(433128, 125, '2015-03-01 00:01:09.000000', 'consum', 0.0222, 'lps'),
	(433129, 125, '2015-03-01 00:01:10.000000', 'consum', 0.0223, 'lps'),
	(433130, 125, '2015-03-01 00:01:11.000000', 'consum', 0.0223, 'lps'),
	(433131, 125, '2015-03-01 00:01:12.000000', 'consum', 0.0217, 'lps'),
	(433132, 125, '2015-03-01 00:01:13.000000', 'consum', 0.0210, 'lps'),
	(433133, 125, '2015-03-01 00:01:14.000000', 'consum', 0.0221, 'lps'),
	(433134, 125, '2015-03-01 00:01:15.000000', 'consum', 0.0214, 'lps'),
	(433135, 125, '2015-03-01 00:01:16.000000', 'consum', 0.0213, 'lps'),
	(433136, 125, '2015-03-01 00:01:17.000000', 'consum', 0.0217, 'lps'),
	(433137, 125, '2015-03-01 00:01:18.000000', 'consum', 0.0217, 'lps'),
	(433138, 125, '2015-03-01 00:01:19.000000', 'consum', 0.0210, 'lps'),
	(433139, 125, '2015-03-01 00:01:20.000000', 'consum', 0.0220, 'lps'),
	(433140, 125, '2015-03-01 00:01:21.000000', 'consum', 0.0212, 'lps'),
	(433141, 125, '2015-03-01 00:01:22.000000', 'consum', 0.0225, 'lps'),
	(433142, 125, '2015-03-01 00:01:23.000000', 'consum', 0.0213, 'lps'),
	(433143, 125, '2015-03-01 00:01:24.000000', 'consum', 0.0211, 'lps'),
	(433144, 125, '2015-03-01 00:01:25.000000', 'consum', 0.0224, 'lps'),
	(433145, 125, '2015-03-01 00:01:26.000000', 'consum', 0.0211, 'lps'),
	(433146, 125, '2015-03-01 00:01:27.000000', 'consum', 0.0224, 'lps'),
	(433147, 125, '2015-03-01 00:01:28.000000', 'consum', 0.0224, 'lps'),
	(433148, 125, '2015-03-01 00:01:29.000000', 'consum', 0.0225, 'lps'),
	(433149, 125, '2015-03-01 00:01:30.000000', 'consum', 0.0224, 'lps'),
	(433150, 125, '2015-03-01 00:01:31.000000', 'consum', 0.0220, 'lps'),
	(433151, 125, '2015-03-01 00:01:32.000000', 'consum', 0.0220, 'lps'),
	(433152, 125, '2015-03-01 00:01:33.000000', 'consum', 0.0212, 'lps'),
	(433153, 125, '2015-03-01 00:01:34.000000', 'consum', 0.0223, 'lps'),
	(433154, 125, '2015-03-01 00:01:35.000000', 'consum', 0.0220, 'lps'),
	(433155, 125, '2015-03-01 00:01:36.000000', 'consum', 0.0219, 'lps'),
	(433156, 125, '2015-03-01 00:01:37.000000', 'consum', 0.0212, 'lps'),
	(433157, 125, '2015-03-01 00:01:38.000000', 'consum', 0.0225, 'lps'),
	(433158, 125, '2015-03-01 00:01:39.000000', 'consum', 0.0212, 'lps'),
	(433159, 125, '2015-03-01 00:01:40.000000', 'consum', 0.0211, 'lps'),
	(433160, 125, '2015-03-01 00:01:41.000000', 'consum', 0.0224, 'lps'),
	(433161, 125, '2015-03-01 00:01:42.000000', 'consum', 0.0226, 'lps'),
	(433162, 125, '2015-03-01 00:01:43.000000', 'consum', 0.0214, 'lps'),
	(433163, 125, '2015-03-01 00:01:44.000000', 'consum', 0.0218, 'lps'),
	(433164, 125, '2015-03-01 00:01:45.000000', 'consum', 0.0220, 'lps'),
	(433165, 125, '2015-03-01 00:01:46.000000', 'consum', 0.0219, 'lps'),
	(433166, 125, '2015-03-01 00:01:47.000000', 'consum', 0.0226, 'lps'),
	(433167, 125, '2015-03-01 00:01:48.000000', 'consum', 0.0213, 'lps'),
	(433168, 125, '2015-03-01 00:01:49.000000', 'consum', 0.0214, 'lps'),
	(433169, 125, '2015-03-01 00:01:50.000000', 'consum', 0.0218, 'lps'),
	(433170, 125, '2015-03-01 00:01:51.000000', 'consum', 0.0221, 'lps'),
	(433171, 125, '2015-03-01 00:01:52.000000', 'consum', 0.0225, 'lps'),
	(433172, 125, '2015-03-01 00:01:53.000000', 'consum', 0.0219, 'lps'),
	(433173, 125, '2015-03-01 00:01:54.000000', 'consum', 0.0226, 'lps'),
	(433174, 125, '2015-03-01 00:01:55.000000', 'consum', 0.0214, 'lps'),
	(433175, 125, '2015-03-01 00:01:56.000000', 'consum', 0.0217, 'lps'),
	(433176, 125, '2015-03-01 00:01:57.000000', 'consum', 0.0214, 'lps'),
	(433177, 125, '2015-03-01 00:01:58.000000', 'consum', 0.0210, 'lps'),
	(433178, 125, '2015-03-01 00:01:59.000000', 'consum', 0.0217, 'lps'),
	(433179, 125, '2015-03-01 00:02:00.000000', 'consum', 0.0212, 'lps'),
	(433180, 125, '2015-03-01 00:02:01.000000', 'consum', 0.0214, 'lps'),
	(433181, 125, '2015-03-01 00:02:02.000000', 'consum', 0.0225, 'lps'),
	(433182, 125, '2015-03-01 00:02:03.000000', 'consum', 0.0223, 'lps'),
	(433183, 125, '2015-03-01 00:02:04.000000', 'consum', 0.0215, 'lps'),
	(433184, 125, '2015-03-01 00:02:05.000000', 'consum', 0.0211, 'lps'),
	(433185, 125, '2015-03-01 00:02:06.000000', 'consum', 0.0220, 'lps'),
	(433186, 125, '2015-03-01 00:02:07.000000', 'consum', 0.0223, 'lps'),
	(433187, 125, '2015-03-01 00:02:08.000000', 'consum', 0.0213, 'lps'),
	(433188, 125, '2015-03-01 00:02:09.000000', 'consum', 0.0219, 'lps'),
	(433189, 125, '2015-03-01 00:02:10.000000', 'consum', 0.0214, 'lps'),
	(433190, 125, '2015-03-01 00:02:11.000000', 'consum', 0.0220, 'lps'),
	(433191, 125, '2015-03-01 00:02:12.000000', 'consum', 0.0214, 'lps'),
	(433192, 125, '2015-03-01 00:02:13.000000', 'consum', 0.0217, 'lps'),
	(433193, 125, '2015-03-01 00:02:14.000000', 'consum', 0.0218, 'lps'),
	(433194, 125, '2015-03-01 00:02:15.000000', 'consum', 0.0213, 'lps'),
	(433195, 125, '2015-03-01 00:02:16.000000', 'consum', 0.0218, 'lps'),
	(433196, 125, '2015-03-01 00:02:17.000000', 'consum', 0.0224, 'lps'),
	(433197, 125, '2015-03-01 00:02:18.000000', 'consum', 0.0222, 'lps'),
	(433198, 125, '2015-03-01 00:02:19.000000', 'consum', 0.0211, 'lps'),
	(433199, 125, '2015-03-01 00:02:20.000000', 'consum', 0.0216, 'lps'),
	(433200, 125, '2015-03-01 00:02:21.000000', 'consum', 0.0217, 'lps'),
	(433201, 125, '2015-03-01 00:02:22.000000', 'consum', 0.0213, 'lps'),
	(433202, 125, '2015-03-01 00:02:23.000000', 'consum', 0.0220, 'lps'),
	(433203, 125, '2015-03-01 00:02:24.000000', 'consum', 0.0218, 'lps'),
	(433204, 125, '2015-03-01 00:02:25.000000', 'consum', 0.0220, 'lps'),
	(433205, 125, '2015-03-01 00:02:26.000000', 'consum', 0.0218, 'lps'),
	(433206, 125, '2015-03-01 00:02:27.000000', 'consum', 0.0221, 'lps'),
	(433207, 125, '2015-03-01 00:02:28.000000', 'consum', 0.0225, 'lps'),
	(433208, 125, '2015-03-01 00:02:29.000000', 'consum', 0.0216, 'lps'),
	(433209, 125, '2015-03-01 00:02:30.000000', 'consum', 0.0216, 'lps'),
	(433210, 125, '2015-03-01 00:02:31.000000', 'consum', 0.0223, 'lps'),
	(433211, 125, '2015-03-01 00:02:32.000000', 'consum', 0.0223, 'lps'),
	(433212, 125, '2015-03-01 00:02:33.000000', 'consum', 0.0218, 'lps'),
	(433213, 125, '2015-03-01 00:02:34.000000', 'consum', 0.0213, 'lps'),
	(433214, 125, '2015-03-01 00:02:35.000000', 'consum', 0.0218, 'lps'),
	(433215, 125, '2015-03-01 00:02:36.000000', 'consum', 0.0225, 'lps'),
	(433216, 125, '2015-03-01 00:02:37.000000', 'consum', 0.0211, 'lps'),
	(433217, 125, '2015-03-01 00:02:38.000000', 'consum', 0.0220, 'lps'),
	(433218, 125, '2015-03-01 00:02:39.000000', 'consum', 0.0225, 'lps'),
	(433219, 125, '2015-03-01 00:02:40.000000', 'consum', 0.0220, 'lps'),
	(433220, 125, '2015-03-01 00:02:41.000000', 'consum', 0.0216, 'lps'),
	(433221, 125, '2015-03-01 00:02:42.000000', 'consum', 0.0210, 'lps'),
	(433222, 125, '2015-03-01 00:02:43.000000', 'consum', 0.0211, 'lps'),
	(433223, 125, '2015-03-01 00:02:44.000000', 'consum', 0.0216, 'lps'),
	(433224, 125, '2015-03-01 00:02:45.000000', 'consum', 0.0221, 'lps'),
	(433225, 125, '2015-03-01 00:02:46.000000', 'consum', 0.0211, 'lps'),
	(433226, 125, '2015-03-01 00:02:47.000000', 'consum', 0.0217, 'lps'),
	(433227, 125, '2015-03-01 00:02:48.000000', 'consum', 0.0226, 'lps'),
	(433228, 125, '2015-03-01 00:02:49.000000', 'consum', 0.0219, 'lps'),
	(433229, 125, '2015-03-01 00:02:50.000000', 'consum', 0.0222, 'lps'),
	(433230, 125, '2015-03-01 00:02:51.000000', 'consum', 0.0213, 'lps'),
	(433231, 125, '2015-03-01 00:02:52.000000', 'consum', 0.0222, 'lps'),
	(433232, 125, '2015-03-01 00:02:53.000000', 'consum', 0.0211, 'lps'),
	(433233, 125, '2015-03-01 00:02:54.000000', 'consum', 0.0215, 'lps'),
	(433234, 125, '2015-03-01 00:02:55.000000', 'consum', 0.0214, 'lps'),
	(433235, 125, '2015-03-01 00:02:56.000000', 'consum', 0.0215, 'lps'),
	(433236, 125, '2015-03-01 00:02:57.000000', 'consum', 0.0225, 'lps'),
	(433237, 125, '2015-03-01 00:02:58.000000', 'consum', 0.0220, 'lps'),
	(433238, 125, '2015-03-01 00:02:59.000000', 'consum', 0.0214, 'lps'),
	(433239, 125, '2015-03-01 00:03:00.000000', 'consum', 0.0216, 'lps'),
	(433240, 125, '2015-03-01 00:03:01.000000', 'consum', 0.0214, 'lps'),
	(433241, 125, '2015-03-01 00:03:02.000000', 'consum', 0.0212, 'lps'),
	(433242, 125, '2015-03-01 00:03:03.000000', 'consum', 0.0224, 'lps'),
	(433243, 125, '2015-03-01 00:03:04.000000', 'consum', 0.0223, 'lps'),
	(433244, 125, '2015-03-01 00:03:05.000000', 'consum', 0.0218, 'lps'),
	(433245, 125, '2015-03-01 00:03:06.000000', 'consum', 0.0210, 'lps'),
	(433246, 125, '2015-03-01 00:03:07.000000', 'consum', 0.0223, 'lps'),
	(433247, 125, '2015-03-01 00:03:08.000000', 'consum', 0.0221, 'lps'),
	(433248, 125, '2015-03-01 00:03:09.000000', 'consum', 0.0212, 'lps'),
	(433249, 125, '2015-03-01 00:03:10.000000', 'consum', 0.0221, 'lps'),
	(433250, 125, '2015-03-01 00:03:11.000000', 'consum', 0.0225, 'lps'),
	(433251, 125, '2015-03-01 00:03:12.000000', 'consum', 0.0218, 'lps'),
	(433252, 125, '2015-03-01 00:03:13.000000', 'consum', 0.0224, 'lps'),
	(433253, 125, '2015-03-01 00:03:14.000000', 'consum', 0.0222, 'lps'),
	(433254, 125, '2015-03-01 00:03:15.000000', 'consum', 0.0210, 'lps'),
	(433255, 125, '2015-03-01 00:03:16.000000', 'consum', 0.0225, 'lps'),
	(433256, 125, '2015-03-01 00:03:17.000000', 'consum', 0.0217, 'lps'),
	(433257, 125, '2015-03-01 00:03:18.000000', 'consum', 0.0219, 'lps'),
	(433258, 125, '2015-03-01 00:03:19.000000', 'consum', 0.0216, 'lps'),
	(433259, 125, '2015-03-01 00:03:20.000000', 'consum', 0.0214, 'lps'),
	(433260, 125, '2015-03-01 00:03:21.000000', 'consum', 0.0214, 'lps'),
	(433261, 125, '2015-03-01 00:03:22.000000', 'consum', 0.0219, 'lps'),
	(433262, 125, '2015-03-01 00:03:23.000000', 'consum', 0.0211, 'lps'),
	(433263, 125, '2015-03-01 00:03:24.000000', 'consum', 0.0219, 'lps'),
	(433264, 125, '2015-03-01 00:03:25.000000', 'consum', 0.0218, 'lps'),
	(433265, 125, '2015-03-01 00:03:26.000000', 'consum', 0.0226, 'lps'),
	(433266, 125, '2015-03-01 00:03:27.000000', 'consum', 0.0215, 'lps'),
	(433267, 125, '2015-03-01 00:03:28.000000', 'consum', 0.0223, 'lps'),
	(433268, 125, '2015-03-01 00:03:29.000000', 'consum', 0.0224, 'lps'),
	(433269, 125, '2015-03-01 00:03:30.000000', 'consum', 0.0226, 'lps'),
	(433270, 125, '2015-03-01 00:03:31.000000', 'consum', 0.0214, 'lps'),
	(433271, 125, '2015-03-01 00:03:32.000000', 'consum', 0.0215, 'lps'),
	(433272, 125, '2015-03-01 00:03:33.000000', 'consum', 0.0224, 'lps'),
	(433273, 125, '2015-03-01 00:03:34.000000', 'consum', 0.0217, 'lps'),
	(433274, 125, '2015-03-01 00:03:35.000000', 'consum', 0.0219, 'lps'),
	(433275, 125, '2015-03-01 00:03:36.000000', 'consum', 0.0218, 'lps'),
	(433276, 125, '2015-03-01 00:03:37.000000', 'consum', 0.0221, 'lps'),
	(433277, 125, '2015-03-01 00:03:38.000000', 'consum', 0.0210, 'lps'),
	(433278, 125, '2015-03-01 00:03:39.000000', 'consum', 0.0211, 'lps'),
	(433279, 125, '2015-03-01 00:03:40.000000', 'consum', 0.0217, 'lps'),
	(433280, 125, '2015-03-01 00:03:41.000000', 'consum', 0.0224, 'lps'),
	(433281, 125, '2015-03-01 00:03:42.000000', 'consum', 0.0210, 'lps'),
	(433282, 125, '2015-03-01 00:03:43.000000', 'consum', 0.0217, 'lps'),
	(433283, 125, '2015-03-01 00:03:44.000000', 'consum', 0.0214, 'lps'),
	(433284, 125, '2015-03-01 00:03:45.000000', 'consum', 0.0224, 'lps'),
	(433285, 125, '2015-03-01 00:03:46.000000', 'consum', 0.0220, 'lps'),
	(433286, 125, '2015-03-01 00:03:47.000000', 'consum', 0.0216, 'lps'),
	(433287, 125, '2015-03-01 00:03:48.000000', 'consum', 0.0210, 'lps'),
	(433288, 125, '2015-03-01 00:03:49.000000', 'consum', 0.0212, 'lps'),
	(433289, 125, '2015-03-01 00:03:50.000000', 'consum', 0.0218, 'lps'),
	(433290, 125, '2015-03-01 00:03:51.000000', 'consum', 0.0211, 'lps'),
	(433291, 125, '2015-03-01 00:03:52.000000', 'consum', 0.0225, 'lps'),
	(433292, 125, '2015-03-01 00:03:53.000000', 'consum', 0.0216, 'lps'),
	(433293, 125, '2015-03-01 00:03:54.000000', 'consum', 0.0214, 'lps'),
	(433294, 125, '2015-03-01 00:03:55.000000', 'consum', 0.0210, 'lps'),
	(433295, 125, '2015-03-01 00:03:56.000000', 'consum', 0.0216, 'lps'),
	(433296, 125, '2015-03-01 00:03:57.000000', 'consum', 0.0226, 'lps'),
	(433297, 125, '2015-03-01 00:03:58.000000', 'consum', 0.0218, 'lps'),
	(433298, 125, '2015-03-01 00:03:59.000000', 'consum', 0.0221, 'lps'),
	(433299, 125, '2015-03-01 00:04:00.000000', 'consum', 0.0225, 'lps'),
	(433300, 125, '2015-03-01 00:04:01.000000', 'consum', 0.0218, 'lps'),
	(433301, 125, '2015-03-01 00:04:02.000000', 'consum', 0.0223, 'lps'),
	(433302, 125, '2015-03-01 00:04:03.000000', 'consum', 0.0218, 'lps'),
	(433303, 125, '2015-03-01 00:04:04.000000', 'consum', 0.0211, 'lps'),
	(433304, 125, '2015-03-01 00:04:05.000000', 'consum', 0.0210, 'lps'),
	(433305, 125, '2015-03-01 00:04:06.000000', 'consum', 0.0222, 'lps'),
	(433306, 125, '2015-03-01 00:04:07.000000', 'consum', 0.0221, 'lps'),
	(433307, 125, '2015-03-01 00:04:08.000000', 'consum', 0.0213, 'lps'),
	(433308, 125, '2015-03-01 00:04:09.000000', 'consum', 0.0224, 'lps'),
	(433309, 125, '2015-03-01 00:04:10.000000', 'consum', 0.0222, 'lps'),
	(433310, 125, '2015-03-01 00:04:11.000000', 'consum', 0.0213, 'lps'),
	(433311, 125, '2015-03-01 00:04:12.000000', 'consum', 0.0223, 'lps'),
	(433312, 125, '2015-03-01 00:04:13.000000', 'consum', 0.0215, 'lps'),
	(433313, 125, '2015-03-01 00:04:14.000000', 'consum', 0.0213, 'lps'),
	(433314, 125, '2015-03-01 00:04:15.000000', 'consum', 0.0211, 'lps'),
	(433315, 125, '2015-03-01 00:04:16.000000', 'consum', 0.0224, 'lps'),
	(433316, 125, '2015-03-01 00:04:17.000000', 'consum', 0.0224, 'lps'),
	(433317, 125, '2015-03-01 00:04:18.000000', 'consum', 0.0224, 'lps'),
	(433318, 125, '2015-03-01 00:04:19.000000', 'consum', 0.0222, 'lps'),
	(433319, 125, '2015-03-01 00:04:20.000000', 'consum', 0.0226, 'lps'),
	(433320, 125, '2015-03-01 00:04:21.000000', 'consum', 0.0223, 'lps'),
	(433321, 125, '2015-03-01 00:04:22.000000', 'consum', 0.0211, 'lps'),
	(433322, 125, '2015-03-01 00:04:23.000000', 'consum', 0.0226, 'lps'),
	(433323, 125, '2015-03-01 00:04:24.000000', 'consum', 0.0220, 'lps'),
	(433324, 125, '2015-03-01 00:04:25.000000', 'consum', 0.0211, 'lps'),
	(433325, 125, '2015-03-01 00:04:26.000000', 'consum', 0.0221, 'lps'),
	(433326, 125, '2015-03-01 00:04:27.000000', 'consum', 0.0212, 'lps'),
	(433327, 125, '2015-03-01 00:04:28.000000', 'consum', 0.0221, 'lps'),
	(433328, 125, '2015-03-01 00:04:29.000000', 'consum', 0.0225, 'lps'),
	(433329, 125, '2015-03-01 00:04:30.000000', 'consum', 0.0220, 'lps'),
	(433330, 125, '2015-03-01 00:04:31.000000', 'consum', 0.0217, 'lps'),
	(433331, 125, '2015-03-01 00:04:32.000000', 'consum', 0.0212, 'lps'),
	(433332, 125, '2015-03-01 00:04:33.000000', 'consum', 0.0218, 'lps'),
	(433333, 125, '2015-03-01 00:04:34.000000', 'consum', 0.0211, 'lps'),
	(433334, 125, '2015-03-01 00:04:35.000000', 'consum', 0.0224, 'lps'),
	(433335, 125, '2015-03-01 00:04:36.000000', 'consum', 0.0211, 'lps'),
	(433336, 125, '2015-03-01 00:04:37.000000', 'consum', 0.0223, 'lps'),
	(433337, 125, '2015-03-01 00:04:38.000000', 'consum', 0.0223, 'lps'),
	(433338, 125, '2015-03-01 00:04:39.000000', 'consum', 0.0219, 'lps'),
	(433339, 125, '2015-03-01 00:04:40.000000', 'consum', 0.0216, 'lps'),
	(433340, 125, '2015-03-01 00:04:41.000000', 'consum', 0.0213, 'lps'),
	(433341, 125, '2015-03-01 00:04:42.000000', 'consum', 0.0210, 'lps'),
	(433342, 125, '2015-03-01 00:04:43.000000', 'consum', 0.0218, 'lps'),
	(433343, 125, '2015-03-01 00:04:44.000000', 'consum', 0.0215, 'lps'),
	(433344, 125, '2015-03-01 00:04:45.000000', 'consum', 0.0212, 'lps'),
	(433345, 125, '2015-03-01 00:04:46.000000', 'consum', 0.0221, 'lps'),
	(433346, 125, '2015-03-01 00:04:47.000000', 'consum', 0.0211, 'lps'),
	(433347, 125, '2015-03-01 00:04:48.000000', 'consum', 0.0216, 'lps'),
	(433348, 125, '2015-03-01 00:04:49.000000', 'consum', 0.0222, 'lps'),
	(433349, 125, '2015-03-01 00:04:50.000000', 'consum', 0.0217, 'lps'),
	(433350, 125, '2015-03-01 00:04:51.000000', 'consum', 0.0226, 'lps'),
	(433351, 125, '2015-03-01 00:04:52.000000', 'consum', 0.0218, 'lps'),
	(433352, 125, '2015-03-01 00:04:53.000000', 'consum', 0.0220, 'lps'),
	(433353, 125, '2015-03-01 00:04:54.000000', 'consum', 0.0220, 'lps'),
	(433354, 125, '2015-03-01 00:04:55.000000', 'consum', 0.0214, 'lps'),
	(433355, 125, '2015-03-01 00:04:56.000000', 'consum', 0.0216, 'lps'),
	(433356, 125, '2015-03-01 00:04:57.000000', 'consum', 0.0214, 'lps'),
	(433357, 125, '2015-03-01 00:04:58.000000', 'consum', 0.0211, 'lps'),
	(433358, 125, '2015-03-01 00:04:59.000000', 'consum', 0.0220, 'lps'),
	(433359, 125, '2015-03-01 00:05:00.000000', 'consum', 0.0225, 'lps'),
	(433360, 125, '2015-03-01 00:05:01.000000', 'consum', 0.0222, 'lps'),
	(433361, 125, '2015-03-01 00:05:02.000000', 'consum', 0.0225, 'lps'),
	(433362, 125, '2015-03-01 00:05:03.000000', 'consum', 0.0214, 'lps'),
	(433363, 125, '2015-03-01 00:05:04.000000', 'consum', 0.0220, 'lps'),
	(433364, 125, '2015-03-01 00:05:05.000000', 'consum', 0.0213, 'lps'),
	(433365, 125, '2015-03-01 00:05:06.000000', 'consum', 0.0215, 'lps'),
	(433366, 125, '2015-03-01 00:05:07.000000', 'consum', 0.0225, 'lps'),
	(433367, 125, '2015-03-01 00:05:08.000000', 'consum', 0.0218, 'lps'),
	(433368, 125, '2015-03-01 00:05:09.000000', 'consum', 0.0224, 'lps'),
	(433369, 125, '2015-03-01 00:05:10.000000', 'consum', 0.0224, 'lps'),
	(433370, 125, '2015-03-01 00:05:11.000000', 'consum', 0.0221, 'lps'),
	(433371, 125, '2015-03-01 00:05:12.000000', 'consum', 0.0224, 'lps'),
	(433372, 125, '2015-03-01 00:05:13.000000', 'consum', 0.0213, 'lps'),
	(433373, 125, '2015-03-01 00:05:14.000000', 'consum', 0.0218, 'lps'),
	(433374, 125, '2015-03-01 00:05:15.000000', 'consum', 0.0225, 'lps'),
	(433375, 125, '2015-03-01 00:05:16.000000', 'consum', 0.0226, 'lps'),
	(433376, 125, '2015-03-01 00:05:17.000000', 'consum', 0.0213, 'lps'),
	(433377, 125, '2015-03-01 00:05:18.000000', 'consum', 0.0212, 'lps'),
	(433378, 125, '2015-03-01 00:05:19.000000', 'consum', 0.0210, 'lps'),
	(433379, 125, '2015-03-01 00:05:20.000000', 'consum', 0.0222, 'lps'),
	(433380, 125, '2015-03-01 00:05:21.000000', 'consum', 0.0220, 'lps'),
	(433381, 125, '2015-03-01 00:05:22.000000', 'consum', 0.0225, 'lps'),
	(433382, 125, '2015-03-01 00:05:23.000000', 'consum', 0.0221, 'lps'),
	(433383, 125, '2015-03-01 00:05:24.000000', 'consum', 0.0222, 'lps'),
	(433384, 125, '2015-03-01 00:05:25.000000', 'consum', 0.0221, 'lps'),
	(433385, 125, '2015-03-01 00:05:26.000000', 'consum', 0.0211, 'lps'),
	(433386, 125, '2015-03-01 00:05:27.000000', 'consum', 0.0216, 'lps'),
	(433387, 125, '2015-03-01 00:05:28.000000', 'consum', 0.0222, 'lps'),
	(433388, 125, '2015-03-01 00:05:29.000000', 'consum', 0.0216, 'lps'),
	(433389, 125, '2015-03-01 00:05:30.000000', 'consum', 0.0225, 'lps'),
	(433390, 125, '2015-03-01 00:05:31.000000', 'consum', 0.0214, 'lps'),
	(433391, 125, '2015-03-01 00:05:32.000000', 'consum', 0.0222, 'lps'),
	(433392, 125, '2015-03-01 00:05:33.000000', 'consum', 0.0222, 'lps'),
	(433393, 125, '2015-03-01 00:05:34.000000', 'consum', 0.0219, 'lps'),
	(433394, 125, '2015-03-01 00:05:35.000000', 'consum', 0.0219, 'lps'),
	(433395, 125, '2015-03-01 00:05:36.000000', 'consum', 0.0212, 'lps'),
	(433396, 125, '2015-03-01 00:05:37.000000', 'consum', 0.0210, 'lps'),
	(433397, 125, '2015-03-01 00:05:38.000000', 'consum', 0.0223, 'lps'),
	(433398, 125, '2015-03-01 00:05:39.000000', 'consum', 0.0225, 'lps'),
	(433399, 125, '2015-03-01 00:05:40.000000', 'consum', 0.0210, 'lps'),
	(433400, 125, '2015-03-01 00:05:41.000000', 'consum', 0.0216, 'lps'),
	(433401, 125, '2015-03-01 00:05:42.000000', 'consum', 0.0224, 'lps'),
	(433402, 125, '2015-03-01 00:05:43.000000', 'consum', 0.0213, 'lps'),
	(433403, 125, '2015-03-01 00:05:44.000000', 'consum', 0.0216, 'lps'),
	(433404, 125, '2015-03-01 00:05:45.000000', 'consum', 0.0217, 'lps'),
	(433405, 125, '2015-03-01 00:05:46.000000', 'consum', 0.0224, 'lps'),
	(433406, 125, '2015-03-01 00:05:47.000000', 'consum', 0.0211, 'lps'),
	(433407, 125, '2015-03-01 00:05:48.000000', 'consum', 0.0224, 'lps'),
	(433408, 125, '2015-03-01 00:05:49.000000', 'consum', 0.0225, 'lps'),
	(433409, 125, '2015-03-01 00:05:50.000000', 'consum', 0.0211, 'lps'),
	(433410, 125, '2015-03-01 00:05:51.000000', 'consum', 0.0223, 'lps'),
	(433411, 125, '2015-03-01 00:05:52.000000', 'consum', 0.0221, 'lps'),
	(433412, 125, '2015-03-01 00:05:53.000000', 'consum', 0.0226, 'lps'),
	(433413, 125, '2015-03-01 00:05:54.000000', 'consum', 0.0225, 'lps'),
	(433414, 125, '2015-03-01 00:05:55.000000', 'consum', 0.0218, 'lps'),
	(433415, 125, '2015-03-01 00:05:56.000000', 'consum', 0.0222, 'lps'),
	(433416, 125, '2015-03-01 00:05:57.000000', 'consum', 0.0213, 'lps'),
	(433417, 125, '2015-03-01 00:05:58.000000', 'consum', 0.0225, 'lps'),
	(433418, 125, '2015-03-01 00:05:59.000000', 'consum', 0.0210, 'lps'),
	(433419, 125, '2015-03-01 00:06:00.000000', 'consum', 0.0214, 'lps'),
	(433420, 125, '2015-03-01 00:06:01.000000', 'consum', 0.0212, 'lps'),
	(433421, 125, '2015-03-01 00:06:02.000000', 'consum', 0.0211, 'lps'),
	(433422, 125, '2015-03-01 00:06:03.000000', 'consum', 0.0225, 'lps'),
	(433423, 125, '2015-03-01 00:06:04.000000', 'consum', 0.0216, 'lps'),
	(433424, 125, '2015-03-01 00:06:05.000000', 'consum', 0.0210, 'lps'),
	(433425, 125, '2015-03-01 00:06:06.000000', 'consum', 0.0210, 'lps'),
	(433426, 125, '2015-03-01 00:06:07.000000', 'consum', 0.0226, 'lps'),
	(433427, 125, '2015-03-01 00:06:08.000000', 'consum', 0.0225, 'lps'),
	(433428, 125, '2015-03-01 00:06:09.000000', 'consum', 0.0220, 'lps'),
	(433429, 125, '2015-03-01 00:06:10.000000', 'consum', 0.0216, 'lps'),
	(433430, 125, '2015-03-01 00:06:11.000000', 'consum', 0.0211, 'lps'),
	(433431, 125, '2015-03-01 00:06:12.000000', 'consum', 0.0214, 'lps'),
	(433432, 125, '2015-03-01 00:06:13.000000', 'consum', 0.0210, 'lps'),
	(433433, 125, '2015-03-01 00:06:14.000000', 'consum', 0.0217, 'lps'),
	(433434, 125, '2015-03-01 00:06:15.000000', 'consum', 0.0210, 'lps'),
	(433435, 125, '2015-03-01 00:06:16.000000', 'consum', 0.0225, 'lps'),
	(433436, 125, '2015-03-01 00:06:17.000000', 'consum', 0.0215, 'lps'),
	(433437, 125, '2015-03-01 00:06:18.000000', 'consum', 0.0225, 'lps'),
	(433438, 125, '2015-03-01 00:06:19.000000', 'consum', 0.0218, 'lps'),
	(433439, 125, '2015-03-01 00:06:20.000000', 'consum', 0.0223, 'lps'),
	(433440, 125, '2015-03-01 00:06:21.000000', 'consum', 0.0220, 'lps'),
	(433441, 125, '2015-03-01 00:06:22.000000', 'consum', 0.0219, 'lps'),
	(433442, 125, '2015-03-01 00:06:23.000000', 'consum', 0.0210, 'lps'),
	(433443, 125, '2015-03-01 00:06:24.000000', 'consum', 0.0218, 'lps'),
	(433444, 125, '2015-03-01 00:06:25.000000', 'consum', 0.0217, 'lps'),
	(433445, 125, '2015-03-01 00:06:26.000000', 'consum', 0.0222, 'lps'),
	(433446, 125, '2015-03-01 00:06:27.000000', 'consum', 0.0213, 'lps'),
	(433447, 125, '2015-03-01 00:06:28.000000', 'consum', 0.0223, 'lps'),
	(433448, 125, '2015-03-01 00:06:29.000000', 'consum', 0.0216, 'lps'),
	(433449, 125, '2015-03-01 00:06:30.000000', 'consum', 0.0218, 'lps'),
	(433450, 125, '2015-03-01 00:06:31.000000', 'consum', 0.0217, 'lps'),
	(433451, 125, '2015-03-01 00:06:32.000000', 'consum', 0.0221, 'lps'),
	(433452, 125, '2015-03-01 00:06:33.000000', 'consum', 0.0212, 'lps'),
	(433453, 125, '2015-03-01 00:06:34.000000', 'consum', 0.0219, 'lps'),
	(433454, 125, '2015-03-01 00:06:35.000000', 'consum', 0.0216, 'lps'),
	(433455, 125, '2015-03-01 00:06:36.000000', 'consum', 0.0213, 'lps'),
	(433456, 125, '2015-03-01 00:06:37.000000', 'consum', 0.0210, 'lps'),
	(433457, 125, '2015-03-01 00:06:38.000000', 'consum', 0.0216, 'lps'),
	(433458, 125, '2015-03-01 00:06:39.000000', 'consum', 0.0224, 'lps'),
	(433459, 125, '2015-03-01 00:06:40.000000', 'consum', 0.0212, 'lps'),
	(433460, 125, '2015-03-01 00:06:41.000000', 'consum', 0.0211, 'lps'),
	(433461, 125, '2015-03-01 00:06:42.000000', 'consum', 0.0226, 'lps'),
	(433462, 125, '2015-03-01 00:06:43.000000', 'consum', 0.0221, 'lps'),
	(433463, 125, '2015-03-01 00:06:44.000000', 'consum', 0.0217, 'lps'),
	(433464, 125, '2015-03-01 00:06:45.000000', 'consum', 0.0210, 'lps'),
	(433465, 125, '2015-03-01 00:06:46.000000', 'consum', 0.0210, 'lps'),
	(433466, 125, '2015-03-01 00:06:47.000000', 'consum', 0.0211, 'lps'),
	(433467, 125, '2015-03-01 00:06:48.000000', 'consum', 0.0214, 'lps'),
	(433468, 125, '2015-03-01 00:06:49.000000', 'consum', 0.0211, 'lps'),
	(433469, 125, '2015-03-01 00:06:50.000000', 'consum', 0.0222, 'lps'),
	(433470, 125, '2015-03-01 00:06:51.000000', 'consum', 0.0216, 'lps'),
	(433471, 125, '2015-03-01 00:06:52.000000', 'consum', 0.0220, 'lps'),
	(433472, 125, '2015-03-01 00:06:53.000000', 'consum', 0.0224, 'lps'),
	(433473, 125, '2015-03-01 00:06:54.000000', 'consum', 0.0220, 'lps'),
	(433474, 125, '2015-03-01 00:06:55.000000', 'consum', 0.0217, 'lps'),
	(433475, 125, '2015-03-01 00:06:56.000000', 'consum', 0.0217, 'lps'),
	(433476, 125, '2015-03-01 00:06:57.000000', 'consum', 0.0222, 'lps'),
	(433477, 125, '2015-03-01 00:06:58.000000', 'consum', 0.0215, 'lps'),
	(433478, 125, '2015-03-01 00:06:59.000000', 'consum', 0.0218, 'lps'),
	(433479, 125, '2015-03-01 00:07:00.000000', 'consum', 0.0216, 'lps'),
	(433480, 125, '2015-03-01 00:07:01.000000', 'consum', 0.0220, 'lps'),
	(433481, 125, '2015-03-01 00:07:02.000000', 'consum', 0.0222, 'lps'),
	(433482, 125, '2015-03-01 00:07:03.000000', 'consum', 0.0226, 'lps'),
	(433483, 125, '2015-03-01 00:07:04.000000', 'consum', 0.0218, 'lps'),
	(433484, 125, '2015-03-01 00:07:05.000000', 'consum', 0.0220, 'lps'),
	(433485, 125, '2015-03-01 00:07:06.000000', 'consum', 0.0219, 'lps'),
	(433486, 125, '2015-03-01 00:07:07.000000', 'consum', 0.0225, 'lps'),
	(433487, 125, '2015-03-01 00:07:08.000000', 'consum', 0.0225, 'lps'),
	(433488, 125, '2015-03-01 00:07:09.000000', 'consum', 0.0225, 'lps'),
	(433489, 125, '2015-03-01 00:07:10.000000', 'consum', 0.0221, 'lps'),
	(433490, 125, '2015-03-01 00:07:11.000000', 'consum', 0.0223, 'lps'),
	(433491, 125, '2015-03-01 00:07:12.000000', 'consum', 0.0223, 'lps'),
	(433492, 125, '2015-03-01 00:07:13.000000', 'consum', 0.0221, 'lps'),
	(433493, 125, '2015-03-01 00:07:14.000000', 'consum', 0.0210, 'lps'),
	(433494, 125, '2015-03-01 00:07:15.000000', 'consum', 0.0213, 'lps'),
	(433495, 125, '2015-03-01 00:07:16.000000', 'consum', 0.0224, 'lps'),
	(433496, 125, '2015-03-01 00:07:17.000000', 'consum', 0.0219, 'lps'),
	(433497, 125, '2015-03-01 00:07:18.000000', 'consum', 0.0216, 'lps'),
	(433498, 125, '2015-03-01 00:07:19.000000', 'consum', 0.0213, 'lps'),
	(433499, 125, '2015-03-01 00:07:20.000000', 'consum', 0.0226, 'lps'),
	(433500, 125, '2015-03-01 00:07:21.000000', 'consum', 0.0211, 'lps'),
	(433501, 125, '2015-03-01 00:07:22.000000', 'consum', 0.0219, 'lps'),
	(433502, 125, '2015-03-01 00:07:23.000000', 'consum', 0.0219, 'lps'),
	(433503, 125, '2015-03-01 00:07:24.000000', 'consum', 0.0211, 'lps'),
	(433504, 125, '2015-03-01 00:07:25.000000', 'consum', 0.0222, 'lps'),
	(433505, 125, '2015-03-01 00:07:26.000000', 'consum', 0.0219, 'lps'),
	(433506, 125, '2015-03-01 00:07:27.000000', 'consum', 0.0218, 'lps'),
	(433507, 125, '2015-03-01 00:07:28.000000', 'consum', 0.0226, 'lps'),
	(433508, 125, '2015-03-01 00:07:29.000000', 'consum', 0.0212, 'lps'),
	(433509, 125, '2015-03-01 00:07:30.000000', 'consum', 0.0224, 'lps'),
	(433510, 125, '2015-03-01 00:07:31.000000', 'consum', 0.0222, 'lps'),
	(433511, 125, '2015-03-01 00:07:32.000000', 'consum', 0.0214, 'lps'),
	(433512, 125, '2015-03-01 00:07:33.000000', 'consum', 0.0211, 'lps'),
	(433513, 125, '2015-03-01 00:07:34.000000', 'consum', 0.0222, 'lps'),
	(433514, 125, '2015-03-01 00:07:35.000000', 'consum', 0.0216, 'lps'),
	(433515, 125, '2015-03-01 00:07:36.000000', 'consum', 0.0222, 'lps'),
	(433516, 125, '2015-03-01 00:07:37.000000', 'consum', 0.0217, 'lps'),
	(433517, 125, '2015-03-01 00:07:38.000000', 'consum', 0.0211, 'lps'),
	(433518, 125, '2015-03-01 00:07:39.000000', 'consum', 0.0211, 'lps'),
	(433519, 125, '2015-03-01 00:07:40.000000', 'consum', 0.0213, 'lps'),
	(433520, 125, '2015-03-01 00:07:41.000000', 'consum', 0.0221, 'lps'),
	(433521, 125, '2015-03-01 00:07:42.000000', 'consum', 0.0225, 'lps'),
	(433522, 125, '2015-03-01 00:07:43.000000', 'consum', 0.0218, 'lps'),
	(433523, 125, '2015-03-01 00:07:44.000000', 'consum', 0.0223, 'lps'),
	(433524, 125, '2015-03-01 00:07:45.000000', 'consum', 0.0216, 'lps'),
	(433525, 125, '2015-03-01 00:07:46.000000', 'consum', 0.0217, 'lps'),
	(433526, 125, '2015-03-01 00:07:47.000000', 'consum', 0.0213, 'lps'),
	(433527, 125, '2015-03-01 00:07:48.000000', 'consum', 0.0223, 'lps'),
	(433528, 125, '2015-03-01 00:07:49.000000', 'consum', 0.0213, 'lps'),
	(433529, 125, '2015-03-01 00:07:50.000000', 'consum', 0.0221, 'lps'),
	(433530, 125, '2015-03-01 00:07:51.000000', 'consum', 0.0224, 'lps'),
	(433531, 125, '2015-03-01 00:07:52.000000', 'consum', 0.0214, 'lps'),
	(433532, 125, '2015-03-01 00:07:53.000000', 'consum', 0.0222, 'lps'),
	(433533, 125, '2015-03-01 00:07:54.000000', 'consum', 0.0225, 'lps'),
	(433534, 125, '2015-03-01 00:07:55.000000', 'consum', 0.0214, 'lps'),
	(433535, 125, '2015-03-01 00:07:56.000000', 'consum', 0.0222, 'lps'),
	(433536, 125, '2015-03-01 00:07:57.000000', 'consum', 0.0222, 'lps'),
	(433537, 125, '2015-03-01 00:07:58.000000', 'consum', 0.0217, 'lps'),
	(433538, 125, '2015-03-01 00:07:59.000000', 'consum', 0.0226, 'lps'),
	(433539, 125, '2015-03-01 00:08:00.000000', 'consum', 0.0221, 'lps'),
	(433540, 125, '2015-03-01 00:08:01.000000', 'consum', 0.0216, 'lps'),
	(433541, 125, '2015-03-01 00:08:02.000000', 'consum', 0.0223, 'lps'),
	(433542, 125, '2015-03-01 00:08:03.000000', 'consum', 0.0225, 'lps'),
	(433543, 125, '2015-03-01 00:08:04.000000', 'consum', 0.0213, 'lps'),
	(433544, 125, '2015-03-01 00:08:05.000000', 'consum', 0.0213, 'lps'),
	(433545, 125, '2015-03-01 00:08:06.000000', 'consum', 0.0218, 'lps'),
	(433546, 125, '2015-03-01 00:08:07.000000', 'consum', 0.0225, 'lps'),
	(433547, 125, '2015-03-01 00:08:08.000000', 'consum', 0.0211, 'lps'),
	(433548, 125, '2015-03-01 00:08:09.000000', 'consum', 0.0220, 'lps'),
	(433549, 125, '2015-03-01 00:08:10.000000', 'consum', 0.0226, 'lps'),
	(433550, 125, '2015-03-01 00:08:11.000000', 'consum', 0.0224, 'lps'),
	(433551, 125, '2015-03-01 00:08:12.000000', 'consum', 0.0216, 'lps'),
	(433552, 125, '2015-03-01 00:08:13.000000', 'consum', 0.0214, 'lps'),
	(433553, 125, '2015-03-01 00:08:14.000000', 'consum', 0.0213, 'lps'),
	(433554, 125, '2015-03-01 00:08:15.000000', 'consum', 0.0214, 'lps'),
	(433555, 125, '2015-03-01 00:08:16.000000', 'consum', 0.0222, 'lps'),
	(433556, 125, '2015-03-01 00:08:17.000000', 'consum', 0.0223, 'lps'),
	(433557, 125, '2015-03-01 00:08:18.000000', 'consum', 0.0225, 'lps'),
	(433558, 125, '2015-03-01 00:08:19.000000', 'consum', 0.0211, 'lps'),
	(433559, 125, '2015-03-01 00:08:20.000000', 'consum', 0.0223, 'lps'),
	(433560, 125, '2015-03-01 00:08:21.000000', 'consum', 0.0221, 'lps'),
	(433561, 125, '2015-03-01 00:08:22.000000', 'consum', 0.0226, 'lps'),
	(433562, 125, '2015-03-01 00:08:23.000000', 'consum', 0.0222, 'lps'),
	(433563, 125, '2015-03-01 00:08:24.000000', 'consum', 0.0226, 'lps'),
	(433564, 125, '2015-03-01 00:08:25.000000', 'consum', 0.0218, 'lps'),
	(433565, 125, '2015-03-01 00:08:26.000000', 'consum', 0.0219, 'lps'),
	(433566, 125, '2015-03-01 00:08:27.000000', 'consum', 0.0215, 'lps'),
	(433567, 125, '2015-03-01 00:08:28.000000', 'consum', 0.0211, 'lps'),
	(433568, 125, '2015-03-01 00:08:29.000000', 'consum', 0.0215, 'lps'),
	(433569, 125, '2015-03-01 00:08:30.000000', 'consum', 0.0215, 'lps'),
	(433570, 125, '2015-03-01 00:08:31.000000', 'consum', 0.0220, 'lps'),
	(433571, 125, '2015-03-01 00:08:32.000000', 'consum', 0.0213, 'lps'),
	(433572, 125, '2015-03-01 00:08:33.000000', 'consum', 0.0210, 'lps'),
	(433573, 125, '2015-03-01 00:08:34.000000', 'consum', 0.0221, 'lps'),
	(433574, 125, '2015-03-01 00:08:35.000000', 'consum', 0.0215, 'lps'),
	(433575, 125, '2015-03-01 00:08:36.000000', 'consum', 0.0220, 'lps'),
	(433576, 125, '2015-03-01 00:08:37.000000', 'consum', 0.0211, 'lps'),
	(433577, 125, '2015-03-01 00:08:38.000000', 'consum', 0.0217, 'lps'),
	(433578, 125, '2015-03-01 00:08:39.000000', 'consum', 0.0211, 'lps'),
	(433579, 125, '2015-03-01 00:08:40.000000', 'consum', 0.0212, 'lps'),
	(433580, 125, '2015-03-01 00:08:41.000000', 'consum', 0.0219, 'lps'),
	(433581, 125, '2015-03-01 00:08:42.000000', 'consum', 0.0213, 'lps'),
	(433582, 125, '2015-03-01 00:08:43.000000', 'consum', 0.0214, 'lps'),
	(433583, 125, '2015-03-01 00:08:44.000000', 'consum', 0.0223, 'lps'),
	(433584, 125, '2015-03-01 00:08:45.000000', 'consum', 0.0214, 'lps'),
	(433585, 125, '2015-03-01 00:08:46.000000', 'consum', 0.0222, 'lps'),
	(433586, 125, '2015-03-01 00:08:47.000000', 'consum', 0.0211, 'lps'),
	(433587, 125, '2015-03-01 00:08:48.000000', 'consum', 0.0210, 'lps'),
	(433588, 125, '2015-03-01 00:08:49.000000', 'consum', 0.0210, 'lps'),
	(433589, 125, '2015-03-01 00:08:50.000000', 'consum', 0.0211, 'lps'),
	(433590, 125, '2015-03-01 00:08:51.000000', 'consum', 0.0213, 'lps'),
	(433591, 125, '2015-03-01 00:08:52.000000', 'consum', 0.0225, 'lps'),
	(433592, 125, '2015-03-01 00:08:53.000000', 'consum', 0.0210, 'lps'),
	(433593, 125, '2015-03-01 00:08:54.000000', 'consum', 0.0213, 'lps'),
	(433594, 125, '2015-03-01 00:08:55.000000', 'consum', 0.0211, 'lps'),
	(433595, 125, '2015-03-01 00:08:56.000000', 'consum', 0.0223, 'lps'),
	(433596, 125, '2015-03-01 00:08:57.000000', 'consum', 0.0222, 'lps'),
	(433597, 125, '2015-03-01 00:08:58.000000', 'consum', 0.0215, 'lps'),
	(433598, 125, '2015-03-01 00:08:59.000000', 'consum', 0.0217, 'lps'),
	(433599, 125, '2015-03-01 00:09:00.000000', 'consum', 0.0212, 'lps'),
	(433600, 125, '2015-03-01 00:09:01.000000', 'consum', 0.0217, 'lps'),
	(433601, 125, '2015-03-01 00:09:02.000000', 'consum', 0.0224, 'lps'),
	(433602, 125, '2015-03-01 00:09:03.000000', 'consum', 0.0225, 'lps'),
	(433603, 125, '2015-03-01 00:09:04.000000', 'consum', 0.0211, 'lps'),
	(433604, 125, '2015-03-01 00:09:05.000000', 'consum', 0.0219, 'lps'),
	(433605, 125, '2015-03-01 00:09:06.000000', 'consum', 0.0220, 'lps'),
	(433606, 125, '2015-03-01 00:09:07.000000', 'consum', 0.0218, 'lps'),
	(433607, 125, '2015-03-01 00:09:08.000000', 'consum', 0.0218, 'lps'),
	(433608, 125, '2015-03-01 00:09:09.000000', 'consum', 0.0226, 'lps'),
	(433609, 125, '2015-03-01 00:09:10.000000', 'consum', 0.0215, 'lps'),
	(433610, 125, '2015-03-01 00:09:11.000000', 'consum', 0.0224, 'lps'),
	(433611, 125, '2015-03-01 00:09:12.000000', 'consum', 0.0215, 'lps'),
	(433612, 125, '2015-03-01 00:09:13.000000', 'consum', 0.0225, 'lps'),
	(433613, 125, '2015-03-01 00:09:14.000000', 'consum', 0.0219, 'lps'),
	(433614, 125, '2015-03-01 00:09:15.000000', 'consum', 0.0213, 'lps'),
	(433615, 125, '2015-03-01 00:09:16.000000', 'consum', 0.0217, 'lps'),
	(433616, 125, '2015-03-01 00:09:17.000000', 'consum', 0.0216, 'lps'),
	(433617, 125, '2015-03-01 00:09:18.000000', 'consum', 0.0220, 'lps'),
	(433618, 125, '2015-03-01 00:09:19.000000', 'consum', 0.0226, 'lps'),
	(433619, 125, '2015-03-01 00:09:20.000000', 'consum', 0.0211, 'lps'),
	(433620, 125, '2015-03-01 00:09:21.000000', 'consum', 0.0219, 'lps'),
	(433621, 125, '2015-03-01 00:09:22.000000', 'consum', 0.0218, 'lps'),
	(433622, 125, '2015-03-01 00:09:23.000000', 'consum', 0.0223, 'lps'),
	(433623, 125, '2015-03-01 00:09:24.000000', 'consum', 0.0218, 'lps'),
	(433624, 125, '2015-03-01 00:09:25.000000', 'consum', 0.0211, 'lps'),
	(433625, 125, '2015-03-01 00:09:26.000000', 'consum', 0.0224, 'lps'),
	(433626, 125, '2015-03-01 00:09:27.000000', 'consum', 0.0211, 'lps'),
	(433627, 125, '2015-03-01 00:09:28.000000', 'consum', 0.0224, 'lps'),
	(433628, 125, '2015-03-01 00:09:29.000000', 'consum', 0.0212, 'lps'),
	(433629, 125, '2015-03-01 00:09:30.000000', 'consum', 0.0226, 'lps'),
	(433630, 125, '2015-03-01 00:09:31.000000', 'consum', 0.0219, 'lps'),
	(433631, 125, '2015-03-01 00:09:32.000000', 'consum', 0.0222, 'lps'),
	(433632, 125, '2015-03-01 00:09:33.000000', 'consum', 0.0211, 'lps'),
	(433633, 125, '2015-03-01 00:09:34.000000', 'consum', 0.0213, 'lps'),
	(433634, 125, '2015-03-01 00:09:35.000000', 'consum', 0.0222, 'lps'),
	(433635, 125, '2015-03-01 00:09:36.000000', 'consum', 0.0212, 'lps'),
	(433636, 125, '2015-03-01 00:09:37.000000', 'consum', 0.0216, 'lps'),
	(433637, 125, '2015-03-01 00:09:38.000000', 'consum', 0.0218, 'lps'),
	(433638, 125, '2015-03-01 00:09:39.000000', 'consum', 0.0216, 'lps'),
	(433639, 125, '2015-03-01 00:09:40.000000', 'consum', 0.0215, 'lps'),
	(433640, 125, '2015-03-01 00:09:41.000000', 'consum', 0.0220, 'lps'),
	(433641, 125, '2015-03-01 00:09:42.000000', 'consum', 0.0226, 'lps'),
	(433642, 125, '2015-03-01 00:09:43.000000', 'consum', 0.0212, 'lps'),
	(433643, 125, '2015-03-01 00:09:44.000000', 'consum', 0.0224, 'lps'),
	(433644, 125, '2015-03-01 00:09:45.000000', 'consum', 0.0221, 'lps'),
	(433645, 125, '2015-03-01 00:09:46.000000', 'consum', 0.0210, 'lps'),
	(433646, 125, '2015-03-01 00:09:47.000000', 'consum', 0.0225, 'lps'),
	(433647, 125, '2015-03-01 00:09:48.000000', 'consum', 0.0217, 'lps'),
	(433648, 125, '2015-03-01 00:09:49.000000', 'consum', 0.0220, 'lps'),
	(433649, 125, '2015-03-01 00:09:50.000000', 'consum', 0.0224, 'lps'),
	(433650, 125, '2015-03-01 00:09:51.000000', 'consum', 0.0213, 'lps'),
	(433651, 125, '2015-03-01 00:09:52.000000', 'consum', 0.0219, 'lps'),
	(433652, 125, '2015-03-01 00:09:53.000000', 'consum', 0.0211, 'lps'),
	(433653, 125, '2015-03-01 00:09:54.000000', 'consum', 0.0225, 'lps'),
	(433654, 125, '2015-03-01 00:09:55.000000', 'consum', 0.0212, 'lps'),
	(433655, 125, '2015-03-01 00:09:56.000000', 'consum', 0.0211, 'lps'),
	(433656, 125, '2015-03-01 00:09:57.000000', 'consum', 0.0225, 'lps'),
	(433657, 125, '2015-03-01 00:09:58.000000', 'consum', 0.0216, 'lps'),
	(433658, 125, '2015-03-01 00:09:59.000000', 'consum', 0.0211, 'lps'),
	(433659, 125, '2015-03-01 00:10:00.000000', 'consum', 0.0214, 'lps'),
	(433660, 125, '2015-03-01 00:10:01.000000', 'consum', 0.0211, 'lps'),
	(433661, 125, '2015-03-01 00:10:02.000000', 'consum', 0.0220, 'lps'),
	(433662, 125, '2015-03-01 00:10:03.000000', 'consum', 0.0224, 'lps'),
	(433663, 125, '2015-03-01 00:10:04.000000', 'consum', 0.0218, 'lps'),
	(433664, 125, '2015-03-01 00:10:05.000000', 'consum', 0.0223, 'lps'),
	(433665, 125, '2015-03-01 00:10:06.000000', 'consum', 0.0217, 'lps'),
	(433666, 125, '2015-03-01 00:10:07.000000', 'consum', 0.0223, 'lps'),
	(433667, 125, '2015-03-01 00:10:08.000000', 'consum', 0.0222, 'lps'),
	(433668, 125, '2015-03-01 00:10:09.000000', 'consum', 0.0214, 'lps'),
	(433669, 125, '2015-03-01 00:10:10.000000', 'consum', 0.0212, 'lps'),
	(433670, 125, '2015-03-01 00:10:11.000000', 'consum', 0.0210, 'lps'),
	(433671, 125, '2015-03-01 00:10:12.000000', 'consum', 0.0219, 'lps'),
	(433672, 125, '2015-03-01 00:10:13.000000', 'consum', 0.0223, 'lps'),
	(433673, 125, '2015-03-01 00:10:14.000000', 'consum', 0.0213, 'lps'),
	(433674, 125, '2015-03-01 00:10:15.000000', 'consum', 0.0219, 'lps'),
	(433675, 125, '2015-03-01 00:10:16.000000', 'consum', 0.0215, 'lps'),
	(433676, 125, '2015-03-01 00:10:17.000000', 'consum', 0.0223, 'lps'),
	(433677, 125, '2015-03-01 00:10:18.000000', 'consum', 0.0211, 'lps'),
	(433678, 125, '2015-03-01 00:10:19.000000', 'consum', 0.0210, 'lps'),
	(433679, 125, '2015-03-01 00:10:20.000000', 'consum', 0.0224, 'lps'),
	(433680, 125, '2015-03-01 00:10:21.000000', 'consum', 0.0212, 'lps'),
	(433681, 125, '2015-03-01 00:10:22.000000', 'consum', 0.0213, 'lps'),
	(433682, 125, '2015-03-01 00:10:23.000000', 'consum', 0.0219, 'lps'),
	(433683, 125, '2015-03-01 00:10:24.000000', 'consum', 0.0211, 'lps'),
	(433684, 125, '2015-03-01 00:10:25.000000', 'consum', 0.0224, 'lps'),
	(433685, 125, '2015-03-01 00:10:26.000000', 'consum', 0.0224, 'lps'),
	(433686, 125, '2015-03-01 00:10:27.000000', 'consum', 0.0225, 'lps'),
	(433687, 125, '2015-03-01 00:10:28.000000', 'consum', 0.0226, 'lps'),
	(433688, 125, '2015-03-01 00:10:29.000000', 'consum', 0.0226, 'lps'),
	(433689, 125, '2015-03-01 00:10:30.000000', 'consum', 0.0212, 'lps'),
	(433690, 125, '2015-03-01 00:10:31.000000', 'consum', 0.0221, 'lps'),
	(433691, 125, '2015-03-01 00:10:32.000000', 'consum', 0.0210, 'lps'),
	(433692, 125, '2015-03-01 00:10:33.000000', 'consum', 0.0212, 'lps'),
	(433693, 125, '2015-03-01 00:10:34.000000', 'consum', 0.0218, 'lps'),
	(433694, 125, '2015-03-01 00:10:35.000000', 'consum', 0.0212, 'lps'),
	(433695, 125, '2015-03-01 00:10:36.000000', 'consum', 0.0215, 'lps'),
	(433696, 125, '2015-03-01 00:10:37.000000', 'consum', 0.0212, 'lps'),
	(433697, 125, '2015-03-01 00:10:38.000000', 'consum', 0.0223, 'lps'),
	(433698, 125, '2015-03-01 00:10:39.000000', 'consum', 0.0216, 'lps'),
	(433699, 125, '2015-03-01 00:10:40.000000', 'consum', 0.0220, 'lps'),
	(433700, 125, '2015-03-01 00:10:41.000000', 'consum', 0.0210, 'lps'),
	(433701, 125, '2015-03-01 00:10:42.000000', 'consum', 0.0215, 'lps'),
	(433702, 125, '2015-03-01 00:10:43.000000', 'consum', 0.0218, 'lps'),
	(433703, 125, '2015-03-01 00:10:44.000000', 'consum', 0.0217, 'lps'),
	(433704, 125, '2015-03-01 00:10:45.000000', 'consum', 0.0222, 'lps'),
	(433705, 125, '2015-03-01 00:10:46.000000', 'consum', 0.0217, 'lps'),
	(433706, 125, '2015-03-01 00:10:47.000000', 'consum', 0.0210, 'lps'),
	(433707, 125, '2015-03-01 00:10:48.000000', 'consum', 0.0221, 'lps'),
	(433708, 125, '2015-03-01 00:10:49.000000', 'consum', 0.0215, 'lps'),
	(433709, 125, '2015-03-01 00:10:50.000000', 'consum', 0.0220, 'lps'),
	(433710, 125, '2015-03-01 00:10:51.000000', 'consum', 0.0210, 'lps'),
	(433711, 125, '2015-03-01 00:10:52.000000', 'consum', 0.0214, 'lps'),
	(433712, 125, '2015-03-01 00:10:53.000000', 'consum', 0.0213, 'lps'),
	(433713, 125, '2015-03-01 00:10:54.000000', 'consum', 0.0214, 'lps'),
	(433714, 125, '2015-03-01 00:10:55.000000', 'consum', 0.0221, 'lps'),
	(433715, 125, '2015-03-01 00:10:56.000000', 'consum', 0.0219, 'lps'),
	(433716, 125, '2015-03-01 00:10:57.000000', 'consum', 0.0224, 'lps'),
	(433717, 125, '2015-03-01 00:10:58.000000', 'consum', 0.0218, 'lps'),
	(433718, 125, '2015-03-01 00:10:59.000000', 'consum', 0.0211, 'lps'),
	(433719, 125, '2015-03-01 00:11:00.000000', 'consum', 0.0225, 'lps'),
	(433720, 125, '2015-03-01 00:11:01.000000', 'consum', 0.0216, 'lps'),
	(433721, 125, '2015-03-01 00:11:02.000000', 'consum', 0.0210, 'lps'),
	(433722, 125, '2015-03-01 00:11:03.000000', 'consum', 0.0210, 'lps'),
	(433723, 125, '2015-03-01 00:11:04.000000', 'consum', 0.0211, 'lps'),
	(433724, 125, '2015-03-01 00:11:05.000000', 'consum', 0.0214, 'lps'),
	(433725, 125, '2015-03-01 00:11:06.000000', 'consum', 0.0211, 'lps'),
	(433726, 125, '2015-03-01 00:11:07.000000', 'consum', 0.0219, 'lps'),
	(433727, 125, '2015-03-01 00:11:08.000000', 'consum', 0.0221, 'lps'),
	(433728, 125, '2015-03-01 00:11:09.000000', 'consum', 0.0223, 'lps'),
	(433729, 125, '2015-03-01 00:11:10.000000', 'consum', 0.0222, 'lps'),
	(433730, 125, '2015-03-01 00:11:11.000000', 'consum', 0.0216, 'lps'),
	(433731, 125, '2015-03-01 00:11:12.000000', 'consum', 0.0223, 'lps'),
	(433732, 125, '2015-03-01 00:11:13.000000', 'consum', 0.0220, 'lps'),
	(433733, 125, '2015-03-01 00:11:14.000000', 'consum', 0.0224, 'lps'),
	(433734, 125, '2015-03-01 00:11:15.000000', 'consum', 0.0217, 'lps'),
	(433735, 125, '2015-03-01 00:11:16.000000', 'consum', 0.0220, 'lps'),
	(433736, 125, '2015-03-01 00:11:17.000000', 'consum', 0.0222, 'lps'),
	(433737, 125, '2015-03-01 00:11:18.000000', 'consum', 0.0222, 'lps'),
	(433738, 125, '2015-03-01 00:11:19.000000', 'consum', 0.0218, 'lps'),
	(433739, 125, '2015-03-01 00:11:20.000000', 'consum', 0.0215, 'lps'),
	(433740, 125, '2015-03-01 00:11:21.000000', 'consum', 0.0211, 'lps'),
	(433741, 125, '2015-03-01 00:11:22.000000', 'consum', 0.0216, 'lps'),
	(433742, 125, '2015-03-01 00:11:23.000000', 'consum', 0.0223, 'lps'),
	(433743, 125, '2015-03-01 00:11:24.000000', 'consum', 0.0224, 'lps'),
	(433744, 125, '2015-03-01 00:11:25.000000', 'consum', 0.0225, 'lps'),
	(433745, 125, '2015-03-01 00:11:26.000000', 'consum', 0.0224, 'lps'),
	(433746, 125, '2015-03-01 00:11:27.000000', 'consum', 0.0220, 'lps'),
	(433747, 125, '2015-03-01 00:11:28.000000', 'consum', 0.0220, 'lps'),
	(433748, 125, '2015-03-01 00:11:29.000000', 'consum', 0.0213, 'lps'),
	(433749, 125, '2015-03-01 00:11:30.000000', 'consum', 0.0213, 'lps'),
	(433750, 125, '2015-03-01 00:11:31.000000', 'consum', 0.0215, 'lps'),
	(433751, 125, '2015-03-01 00:11:32.000000', 'consum', 0.0225, 'lps'),
	(433752, 125, '2015-03-01 00:11:33.000000', 'consum', 0.0222, 'lps'),
	(433753, 125, '2015-03-01 00:11:34.000000', 'consum', 0.0225, 'lps'),
	(433754, 125, '2015-03-01 00:11:35.000000', 'consum', 0.0217, 'lps'),
	(433755, 125, '2015-03-01 00:11:36.000000', 'consum', 0.0215, 'lps'),
	(433756, 125, '2015-03-01 00:11:37.000000', 'consum', 0.0216, 'lps'),
	(433757, 125, '2015-03-01 00:11:38.000000', 'consum', 0.0223, 'lps'),
	(433758, 125, '2015-03-01 00:11:39.000000', 'consum', 0.0226, 'lps'),
	(433759, 125, '2015-03-01 00:11:40.000000', 'consum', 0.0219, 'lps'),
	(433760, 125, '2015-03-01 00:11:41.000000', 'consum', 0.0221, 'lps'),
	(433761, 125, '2015-03-01 00:11:42.000000', 'consum', 0.0225, 'lps'),
	(433762, 125, '2015-03-01 00:11:43.000000', 'consum', 0.0216, 'lps'),
	(433763, 125, '2015-03-01 00:11:44.000000', 'consum', 0.0213, 'lps'),
	(433764, 125, '2015-03-01 00:11:45.000000', 'consum', 0.0225, 'lps'),
	(433765, 125, '2015-03-01 00:11:46.000000', 'consum', 0.0223, 'lps'),
	(433766, 125, '2015-03-01 00:11:47.000000', 'consum', 0.0216, 'lps'),
	(433767, 125, '2015-03-01 00:11:48.000000', 'consum', 0.0217, 'lps'),
	(433768, 125, '2015-03-01 00:11:49.000000', 'consum', 0.0212, 'lps'),
	(433769, 125, '2015-03-01 00:11:50.000000', 'consum', 0.0216, 'lps'),
	(433770, 125, '2015-03-01 00:11:51.000000', 'consum', 0.0215, 'lps'),
	(433771, 125, '2015-03-01 00:11:52.000000', 'consum', 0.0221, 'lps'),
	(433772, 125, '2015-03-01 00:11:53.000000', 'consum', 0.0214, 'lps'),
	(433773, 125, '2015-03-01 00:11:54.000000', 'consum', 0.0217, 'lps'),
	(433774, 125, '2015-03-01 00:11:55.000000', 'consum', 0.0217, 'lps'),
	(433775, 125, '2015-03-01 00:11:56.000000', 'consum', 0.0222, 'lps'),
	(433776, 125, '2015-03-01 00:11:57.000000', 'consum', 0.0218, 'lps'),
	(433777, 125, '2015-03-01 00:11:58.000000', 'consum', 0.0213, 'lps'),
	(433778, 125, '2015-03-01 00:11:59.000000', 'consum', 0.0221, 'lps'),
	(433779, 125, '2015-03-01 00:12:00.000000', 'consum', 0.0221, 'lps'),
	(433780, 125, '2015-03-01 00:12:01.000000', 'consum', 0.0214, 'lps'),
	(433781, 125, '2015-03-01 00:12:02.000000', 'consum', 0.0215, 'lps'),
	(433782, 125, '2015-03-01 00:12:03.000000', 'consum', 0.0225, 'lps'),
	(433783, 125, '2015-03-01 00:12:04.000000', 'consum', 0.0221, 'lps'),
	(433784, 125, '2015-03-01 00:12:05.000000', 'consum', 0.0218, 'lps'),
	(433785, 125, '2015-03-01 00:12:06.000000', 'consum', 0.0217, 'lps'),
	(433786, 125, '2015-03-01 00:12:07.000000', 'consum', 0.0222, 'lps'),
	(433787, 125, '2015-03-01 00:12:08.000000', 'consum', 0.0218, 'lps'),
	(433788, 125, '2015-03-01 00:12:09.000000', 'consum', 0.0212, 'lps'),
	(433789, 125, '2015-03-01 00:12:10.000000', 'consum', 0.0215, 'lps'),
	(433790, 125, '2015-03-01 00:12:11.000000', 'consum', 0.0211, 'lps'),
	(433791, 125, '2015-03-01 00:12:12.000000', 'consum', 0.0219, 'lps'),
	(433792, 125, '2015-03-01 00:12:13.000000', 'consum', 0.0216, 'lps'),
	(433793, 125, '2015-03-01 00:12:14.000000', 'consum', 0.0214, 'lps'),
	(433794, 125, '2015-03-01 00:12:15.000000', 'consum', 0.0214, 'lps'),
	(433795, 125, '2015-03-01 00:12:16.000000', 'consum', 0.0220, 'lps'),
	(433796, 125, '2015-03-01 00:12:17.000000', 'consum', 0.0212, 'lps'),
	(433797, 125, '2015-03-01 00:12:18.000000', 'consum', 0.0224, 'lps'),
	(433798, 125, '2015-03-01 00:12:19.000000', 'consum', 0.0223, 'lps'),
	(433799, 125, '2015-03-01 00:12:20.000000', 'consum', 0.0218, 'lps'),
	(433800, 125, '2015-03-01 00:12:21.000000', 'consum', 0.0210, 'lps'),
	(433801, 125, '2015-03-01 00:12:22.000000', 'consum', 0.0220, 'lps'),
	(433802, 125, '2015-03-01 00:12:23.000000', 'consum', 0.0212, 'lps'),
	(433803, 125, '2015-03-01 00:12:24.000000', 'consum', 0.0223, 'lps'),
	(433804, 125, '2015-03-01 00:12:25.000000', 'consum', 0.0218, 'lps'),
	(433805, 125, '2015-03-01 00:12:26.000000', 'consum', 0.0211, 'lps'),
	(433806, 125, '2015-03-01 00:12:27.000000', 'consum', 0.0210, 'lps'),
	(433807, 125, '2015-03-01 00:12:28.000000', 'consum', 0.0222, 'lps'),
	(433808, 125, '2015-03-01 00:12:29.000000', 'consum', 0.0220, 'lps'),
	(433809, 125, '2015-03-01 00:12:30.000000', 'consum', 0.0210, 'lps'),
	(433810, 125, '2015-03-01 00:12:31.000000', 'consum', 0.0212, 'lps'),
	(433811, 125, '2015-03-01 00:12:32.000000', 'consum', 0.0223, 'lps'),
	(433812, 125, '2015-03-01 00:12:33.000000', 'consum', 0.0217, 'lps'),
	(433813, 125, '2015-03-01 00:12:34.000000', 'consum', 0.0223, 'lps'),
	(433814, 125, '2015-03-01 00:12:35.000000', 'consum', 0.0223, 'lps'),
	(433815, 125, '2015-03-01 00:12:36.000000', 'consum', 0.0216, 'lps'),
	(433816, 125, '2015-03-01 00:12:37.000000', 'consum', 0.0221, 'lps'),
	(433817, 125, '2015-03-01 00:12:38.000000', 'consum', 0.0212, 'lps'),
	(433818, 125, '2015-03-01 00:12:39.000000', 'consum', 0.0222, 'lps'),
	(433819, 125, '2015-03-01 00:12:40.000000', 'consum', 0.0215, 'lps'),
	(433820, 125, '2015-03-01 00:12:41.000000', 'consum', 0.0214, 'lps'),
	(433821, 125, '2015-03-01 00:12:42.000000', 'consum', 0.0218, 'lps'),
	(433822, 125, '2015-03-01 00:12:43.000000', 'consum', 0.0222, 'lps'),
	(433823, 125, '2015-03-01 00:12:44.000000', 'consum', 0.0213, 'lps'),
	(433824, 125, '2015-03-01 00:12:45.000000', 'consum', 0.0224, 'lps'),
	(433825, 125, '2015-03-01 00:12:46.000000', 'consum', 0.0219, 'lps'),
	(433826, 125, '2015-03-01 00:12:47.000000', 'consum', 0.0213, 'lps'),
	(433827, 125, '2015-03-01 00:12:48.000000', 'consum', 0.0218, 'lps'),
	(433828, 125, '2015-03-01 00:12:49.000000', 'consum', 0.0222, 'lps'),
	(433829, 125, '2015-03-01 00:12:50.000000', 'consum', 0.0213, 'lps'),
	(433830, 125, '2015-03-01 00:12:51.000000', 'consum', 0.0222, 'lps'),
	(433831, 125, '2015-03-01 00:12:52.000000', 'consum', 0.0211, 'lps'),
	(433832, 125, '2015-03-01 00:12:53.000000', 'consum', 0.0214, 'lps'),
	(433833, 125, '2015-03-01 00:12:54.000000', 'consum', 0.0210, 'lps'),
	(433834, 125, '2015-03-01 00:12:55.000000', 'consum', 0.0218, 'lps'),
	(433835, 125, '2015-03-01 00:12:56.000000', 'consum', 0.0213, 'lps'),
	(433836, 125, '2015-03-01 00:12:57.000000', 'consum', 0.0222, 'lps'),
	(433837, 125, '2015-03-01 00:12:58.000000', 'consum', 0.0226, 'lps'),
	(433838, 125, '2015-03-01 00:12:59.000000', 'consum', 0.0218, 'lps'),
	(433839, 125, '2015-03-01 00:13:00.000000', 'consum', 0.0223, 'lps'),
	(433840, 125, '2015-03-01 00:13:01.000000', 'consum', 0.0216, 'lps'),
	(433841, 125, '2015-03-01 00:13:02.000000', 'consum', 0.0217, 'lps'),
	(433842, 125, '2015-03-01 00:13:03.000000', 'consum', 0.0213, 'lps'),
	(433843, 125, '2015-03-01 00:13:04.000000', 'consum', 0.0219, 'lps'),
	(433844, 125, '2015-03-01 00:13:05.000000', 'consum', 0.0213, 'lps'),
	(433845, 125, '2015-03-01 00:13:06.000000', 'consum', 0.0217, 'lps'),
	(433846, 125, '2015-03-01 00:13:07.000000', 'consum', 0.0217, 'lps'),
	(433847, 125, '2015-03-01 00:13:08.000000', 'consum', 0.0210, 'lps'),
	(433848, 125, '2015-03-01 00:13:09.000000', 'consum', 0.0221, 'lps'),
	(433849, 125, '2015-03-01 00:13:10.000000', 'consum', 0.0218, 'lps'),
	(433850, 125, '2015-03-01 00:13:11.000000', 'consum', 0.0214, 'lps'),
	(433851, 125, '2015-03-01 00:13:12.000000', 'consum', 0.0226, 'lps'),
	(433852, 125, '2015-03-01 00:13:13.000000', 'consum', 0.0211, 'lps'),
	(433853, 125, '2015-03-01 00:13:14.000000', 'consum', 0.0218, 'lps'),
	(433854, 125, '2015-03-01 00:13:15.000000', 'consum', 0.0211, 'lps'),
	(433855, 125, '2015-03-01 00:13:16.000000', 'consum', 0.0211, 'lps'),
	(433856, 125, '2015-03-01 00:13:17.000000', 'consum', 0.0213, 'lps'),
	(433857, 125, '2015-03-01 00:13:18.000000', 'consum', 0.0223, 'lps'),
	(433858, 125, '2015-03-01 00:13:19.000000', 'consum', 0.0213, 'lps'),
	(433859, 125, '2015-03-01 00:13:20.000000', 'consum', 0.0221, 'lps'),
	(433860, 125, '2015-03-01 00:13:21.000000', 'consum', 0.0223, 'lps'),
	(433861, 125, '2015-03-01 00:13:22.000000', 'consum', 0.0226, 'lps'),
	(433862, 125, '2015-03-01 00:13:23.000000', 'consum', 0.0218, 'lps'),
	(433863, 125, '2015-03-01 00:13:24.000000', 'consum', 0.0217, 'lps'),
	(433864, 125, '2015-03-01 00:13:25.000000', 'consum', 0.0222, 'lps'),
	(433865, 125, '2015-03-01 00:13:26.000000', 'consum', 0.0218, 'lps'),
	(433866, 125, '2015-03-01 00:13:27.000000', 'consum', 0.0211, 'lps'),
	(433867, 125, '2015-03-01 00:13:28.000000', 'consum', 0.0211, 'lps'),
	(433868, 125, '2015-03-01 00:13:29.000000', 'consum', 0.0213, 'lps'),
	(433869, 125, '2015-03-01 00:13:30.000000', 'consum', 0.0221, 'lps'),
	(433870, 125, '2015-03-01 00:13:31.000000', 'consum', 0.0221, 'lps'),
	(433871, 125, '2015-03-01 00:13:32.000000', 'consum', 0.0218, 'lps'),
	(433872, 125, '2015-03-01 00:13:33.000000', 'consum', 0.0217, 'lps'),
	(433873, 125, '2015-03-01 00:13:34.000000', 'consum', 0.0219, 'lps'),
	(433874, 125, '2015-03-01 00:13:35.000000', 'consum', 0.0220, 'lps'),
	(433875, 125, '2015-03-01 00:13:36.000000', 'consum', 0.0215, 'lps'),
	(433876, 125, '2015-03-01 00:13:37.000000', 'consum', 0.0224, 'lps'),
	(433877, 125, '2015-03-01 00:13:38.000000', 'consum', 0.0215, 'lps'),
	(433878, 125, '2015-03-01 00:13:39.000000', 'consum', 0.0211, 'lps'),
	(433879, 125, '2015-03-01 00:13:40.000000', 'consum', 0.0217, 'lps'),
	(433880, 125, '2015-03-01 00:13:41.000000', 'consum', 0.0210, 'lps'),
	(433881, 125, '2015-03-01 00:13:42.000000', 'consum', 0.0223, 'lps'),
	(433882, 125, '2015-03-01 00:13:43.000000', 'consum', 0.0223, 'lps'),
	(433883, 125, '2015-03-01 00:13:44.000000', 'consum', 0.0220, 'lps'),
	(433884, 125, '2015-03-01 00:13:45.000000', 'consum', 0.0221, 'lps'),
	(433885, 125, '2015-03-01 00:13:46.000000', 'consum', 0.0218, 'lps'),
	(433886, 125, '2015-03-01 00:13:47.000000', 'consum', 0.0218, 'lps'),
	(433887, 125, '2015-03-01 00:13:48.000000', 'consum', 0.0225, 'lps'),
	(433888, 125, '2015-03-01 00:13:49.000000', 'consum', 0.0226, 'lps'),
	(433889, 125, '2015-03-01 00:13:50.000000', 'consum', 0.0215, 'lps'),
	(433890, 125, '2015-03-01 00:13:51.000000', 'consum', 0.0222, 'lps'),
	(433891, 125, '2015-03-01 00:13:52.000000', 'consum', 0.0220, 'lps'),
	(433892, 125, '2015-03-01 00:13:53.000000', 'consum', 0.0224, 'lps'),
	(433893, 125, '2015-03-01 00:13:54.000000', 'consum', 0.0218, 'lps'),
	(433894, 125, '2015-03-01 00:13:55.000000', 'consum', 0.0210, 'lps'),
	(433895, 125, '2015-03-01 00:13:56.000000', 'consum', 0.0217, 'lps'),
	(433896, 125, '2015-03-01 00:13:57.000000', 'consum', 0.0212, 'lps'),
	(433897, 125, '2015-03-01 00:13:58.000000', 'consum', 0.0219, 'lps'),
	(433898, 125, '2015-03-01 00:13:59.000000', 'consum', 0.0213, 'lps'),
	(433899, 125, '2015-03-01 00:14:00.000000', 'consum', 0.0217, 'lps'),
	(433900, 125, '2015-03-01 00:14:01.000000', 'consum', 0.0219, 'lps'),
	(433901, 125, '2015-03-01 00:14:02.000000', 'consum', 0.0217, 'lps'),
	(433902, 125, '2015-03-01 00:14:03.000000', 'consum', 0.0217, 'lps'),
	(433903, 125, '2015-03-01 00:14:04.000000', 'consum', 0.0225, 'lps'),
	(433904, 125, '2015-03-01 00:14:05.000000', 'consum', 0.0216, 'lps'),
	(433905, 125, '2015-03-01 00:14:06.000000', 'consum', 0.0226, 'lps'),
	(433906, 125, '2015-03-01 00:14:07.000000', 'consum', 0.0224, 'lps'),
	(433907, 125, '2015-03-01 00:14:08.000000', 'consum', 0.0215, 'lps'),
	(433908, 125, '2015-03-01 00:14:09.000000', 'consum', 0.0211, 'lps'),
	(433909, 125, '2015-03-01 00:14:10.000000', 'consum', 0.0218, 'lps'),
	(433910, 125, '2015-03-01 00:14:11.000000', 'consum', 0.0212, 'lps'),
	(433911, 125, '2015-03-01 00:14:12.000000', 'consum', 0.0212, 'lps'),
	(433912, 125, '2015-03-01 00:14:13.000000', 'consum', 0.0217, 'lps'),
	(433913, 125, '2015-03-01 00:14:14.000000', 'consum', 0.0223, 'lps'),
	(433914, 125, '2015-03-01 00:14:15.000000', 'consum', 0.0218, 'lps'),
	(433915, 125, '2015-03-01 00:14:16.000000', 'consum', 0.0212, 'lps'),
	(433916, 125, '2015-03-01 00:14:17.000000', 'consum', 0.0214, 'lps'),
	(433917, 125, '2015-03-01 00:14:18.000000', 'consum', 0.0226, 'lps'),
	(433918, 125, '2015-03-01 00:14:19.000000', 'consum', 0.0211, 'lps'),
	(433919, 125, '2015-03-01 00:14:20.000000', 'consum', 0.0218, 'lps'),
	(433920, 125, '2015-03-01 00:14:21.000000', 'consum', 0.0212, 'lps'),
	(433921, 125, '2015-03-01 00:14:22.000000', 'consum', 0.0214, 'lps'),
	(433922, 125, '2015-03-01 00:14:23.000000', 'consum', 0.0224, 'lps'),
	(433923, 125, '2015-03-01 00:14:24.000000', 'consum', 0.0217, 'lps'),
	(433924, 125, '2015-03-01 00:14:25.000000', 'consum', 0.0220, 'lps'),
	(433925, 125, '2015-03-01 00:14:26.000000', 'consum', 0.0222, 'lps'),
	(433926, 125, '2015-03-01 00:14:27.000000', 'consum', 0.0223, 'lps'),
	(433927, 125, '2015-03-01 00:14:28.000000', 'consum', 0.0221, 'lps'),
	(433928, 125, '2015-03-01 00:14:29.000000', 'consum', 0.0213, 'lps'),
	(433929, 125, '2015-03-01 00:14:30.000000', 'consum', 0.0224, 'lps'),
	(433930, 125, '2015-03-01 00:14:31.000000', 'consum', 0.0222, 'lps'),
	(433931, 125, '2015-03-01 00:14:32.000000', 'consum', 0.0210, 'lps'),
	(433932, 125, '2015-03-01 00:14:33.000000', 'consum', 0.0225, 'lps'),
	(433933, 125, '2015-03-01 00:14:34.000000', 'consum', 0.0217, 'lps'),
	(433934, 125, '2015-03-01 00:14:35.000000', 'consum', 0.0219, 'lps'),
	(433935, 125, '2015-03-01 00:14:36.000000', 'consum', 0.0215, 'lps'),
	(433936, 125, '2015-03-01 00:14:37.000000', 'consum', 0.0210, 'lps'),
	(433937, 125, '2015-03-01 00:14:38.000000', 'consum', 0.0215, 'lps'),
	(433938, 125, '2015-03-01 00:14:39.000000', 'consum', 0.0215, 'lps'),
	(433939, 125, '2015-03-01 00:14:40.000000', 'consum', 0.0222, 'lps'),
	(433940, 125, '2015-03-01 00:14:41.000000', 'consum', 0.0223, 'lps'),
	(433941, 125, '2015-03-01 00:14:42.000000', 'consum', 0.0220, 'lps'),
	(433942, 125, '2015-03-01 00:14:43.000000', 'consum', 0.0224, 'lps'),
	(433943, 125, '2015-03-01 00:14:44.000000', 'consum', 0.0217, 'lps'),
	(433944, 125, '2015-03-01 00:14:45.000000', 'consum', 0.0220, 'lps'),
	(433945, 125, '2015-03-01 00:14:46.000000', 'consum', 0.0222, 'lps'),
	(433946, 125, '2015-03-01 00:14:47.000000', 'consum', 0.0223, 'lps'),
	(433947, 125, '2015-03-01 00:14:48.000000', 'consum', 0.0223, 'lps'),
	(433948, 125, '2015-03-01 00:14:49.000000', 'consum', 0.0221, 'lps'),
	(433949, 125, '2015-03-01 00:14:50.000000', 'consum', 0.0226, 'lps'),
	(433950, 125, '2015-03-01 00:14:51.000000', 'consum', 0.0224, 'lps'),
	(433951, 125, '2015-03-01 00:14:52.000000', 'consum', 0.0216, 'lps'),
	(433952, 125, '2015-03-01 00:14:53.000000', 'consum', 0.0213, 'lps'),
	(433953, 125, '2015-03-01 00:14:54.000000', 'consum', 0.0226, 'lps'),
	(433954, 125, '2015-03-01 00:14:55.000000', 'consum', 0.0215, 'lps'),
	(433955, 125, '2015-03-01 00:14:56.000000', 'consum', 0.0220, 'lps'),
	(433956, 125, '2015-03-01 00:14:57.000000', 'consum', 0.0213, 'lps'),
	(433957, 125, '2015-03-01 00:14:58.000000', 'consum', 0.0211, 'lps'),
	(433958, 125, '2015-03-01 00:14:59.000000', 'consum', 0.0223, 'lps'),
	(433959, 125, '2015-03-01 00:15:00.000000', 'consum', 0.0224, 'lps'),
	(433960, 125, '2015-03-01 00:15:01.000000', 'consum', 0.0223, 'lps'),
	(433961, 125, '2015-03-01 00:15:02.000000', 'consum', 0.0217, 'lps'),
	(433962, 125, '2015-03-01 00:15:03.000000', 'consum', 0.0225, 'lps'),
	(433963, 125, '2015-03-01 00:15:04.000000', 'consum', 0.0212, 'lps'),
	(433964, 125, '2015-03-01 00:15:05.000000', 'consum', 0.0210, 'lps'),
	(433965, 125, '2015-03-01 00:15:06.000000', 'consum', 0.0222, 'lps'),
	(433966, 125, '2015-03-01 00:15:07.000000', 'consum', 0.0220, 'lps'),
	(433967, 125, '2015-03-01 00:15:08.000000', 'consum', 0.0224, 'lps'),
	(433968, 125, '2015-03-01 00:15:09.000000', 'consum', 0.0214, 'lps'),
	(433969, 125, '2015-03-01 00:15:10.000000', 'consum', 0.0225, 'lps'),
	(433970, 125, '2015-03-01 00:15:11.000000', 'consum', 0.0223, 'lps'),
	(433971, 125, '2015-03-01 00:15:12.000000', 'consum', 0.0214, 'lps'),
	(433972, 125, '2015-03-01 00:15:13.000000', 'consum', 0.0225, 'lps'),
	(433973, 125, '2015-03-01 00:15:14.000000', 'consum', 0.0222, 'lps'),
	(433974, 125, '2015-03-01 00:15:15.000000', 'consum', 0.0210, 'lps'),
	(433975, 125, '2015-03-01 00:15:16.000000', 'consum', 0.0223, 'lps'),
	(433976, 125, '2015-03-01 00:15:17.000000', 'consum', 0.0224, 'lps'),
	(433977, 125, '2015-03-01 00:15:18.000000', 'consum', 0.0225, 'lps'),
	(433978, 125, '2015-03-01 00:15:19.000000', 'consum', 0.0226, 'lps'),
	(433979, 125, '2015-03-01 00:15:20.000000', 'consum', 0.0212, 'lps'),
	(433980, 125, '2015-03-01 00:15:21.000000', 'consum', 0.0224, 'lps'),
	(433981, 125, '2015-03-01 00:15:22.000000', 'consum', 0.0225, 'lps'),
	(433982, 125, '2015-03-01 00:15:23.000000', 'consum', 0.0225, 'lps'),
	(433983, 125, '2015-03-01 00:15:24.000000', 'consum', 0.0226, 'lps'),
	(433984, 125, '2015-03-01 00:15:25.000000', 'consum', 0.0225, 'lps'),
	(433985, 125, '2015-03-01 00:15:26.000000', 'consum', 0.0223, 'lps'),
	(433986, 125, '2015-03-01 00:15:27.000000', 'consum', 0.0215, 'lps'),
	(433987, 125, '2015-03-01 00:15:28.000000', 'consum', 0.0210, 'lps'),
	(433988, 125, '2015-03-01 00:15:29.000000', 'consum', 0.0213, 'lps'),
	(433989, 125, '2015-03-01 00:15:30.000000', 'consum', 0.0226, 'lps'),
	(433990, 125, '2015-03-01 00:15:31.000000', 'consum', 0.0216, 'lps'),
	(433991, 125, '2015-03-01 00:15:32.000000', 'consum', 0.0223, 'lps'),
	(433992, 125, '2015-03-01 00:15:33.000000', 'consum', 0.0225, 'lps'),
	(433993, 125, '2015-03-01 00:15:34.000000', 'consum', 0.0213, 'lps'),
	(433994, 125, '2015-03-01 00:15:35.000000', 'consum', 0.0212, 'lps'),
	(433995, 125, '2015-03-01 00:15:36.000000', 'consum', 0.0215, 'lps'),
	(433996, 125, '2015-03-01 00:15:37.000000', 'consum', 0.0211, 'lps'),
	(433997, 125, '2015-03-01 00:15:38.000000', 'consum', 0.0219, 'lps'),
	(433998, 125, '2015-03-01 00:15:39.000000', 'consum', 0.0217, 'lps'),
	(433999, 125, '2015-03-01 00:15:40.000000', 'consum', 0.0218, 'lps'),
	(434000, 125, '2015-03-01 00:15:41.000000', 'consum', 0.0214, 'lps'),
	(434001, 125, '2015-03-01 00:15:42.000000', 'consum', 0.0221, 'lps'),
	(434002, 125, '2015-03-01 00:15:43.000000', 'consum', 0.0220, 'lps'),
	(434003, 125, '2015-03-01 00:15:44.000000', 'consum', 0.0210, 'lps'),
	(434004, 125, '2015-03-01 00:15:45.000000', 'consum', 0.0215, 'lps'),
	(434005, 125, '2015-03-01 00:15:46.000000', 'consum', 0.0217, 'lps'),
	(434006, 125, '2015-03-01 00:15:47.000000', 'consum', 0.0213, 'lps'),
	(434007, 125, '2015-03-01 00:15:48.000000', 'consum', 0.0221, 'lps'),
	(434008, 125, '2015-03-01 00:15:49.000000', 'consum', 0.0223, 'lps'),
	(434009, 125, '2015-03-01 00:15:50.000000', 'consum', 0.0210, 'lps'),
	(434010, 125, '2015-03-01 00:15:51.000000', 'consum', 0.0221, 'lps'),
	(434011, 125, '2015-03-01 00:15:52.000000', 'consum', 0.0214, 'lps'),
	(434012, 125, '2015-03-01 00:15:53.000000', 'consum', 0.0216, 'lps'),
	(434013, 125, '2015-03-01 00:15:54.000000', 'consum', 0.0226, 'lps'),
	(434014, 125, '2015-03-01 00:15:55.000000', 'consum', 0.0224, 'lps'),
	(434015, 125, '2015-03-01 00:15:56.000000', 'consum', 0.0214, 'lps'),
	(434016, 125, '2015-03-01 00:15:57.000000', 'consum', 0.0224, 'lps'),
	(434017, 125, '2015-03-01 00:15:58.000000', 'consum', 0.0216, 'lps'),
	(434018, 125, '2015-03-01 00:15:59.000000', 'consum', 0.0217, 'lps'),
	(434019, 125, '2015-03-01 00:16:00.000000', 'consum', 0.0211, 'lps'),
	(434020, 125, '2015-03-01 00:16:01.000000', 'consum', 0.0210, 'lps'),
	(434021, 125, '2015-03-01 00:16:02.000000', 'consum', 0.0224, 'lps'),
	(434022, 125, '2015-03-01 00:16:03.000000', 'consum', 0.0213, 'lps'),
	(434023, 125, '2015-03-01 00:16:04.000000', 'consum', 0.0216, 'lps'),
	(434024, 125, '2015-03-01 00:16:05.000000', 'consum', 0.0215, 'lps'),
	(434025, 125, '2015-03-01 00:16:06.000000', 'consum', 0.0217, 'lps'),
	(434026, 125, '2015-03-01 00:16:07.000000', 'consum', 0.0214, 'lps'),
	(434027, 125, '2015-03-01 00:16:08.000000', 'consum', 0.0226, 'lps'),
	(434028, 125, '2015-03-01 00:16:09.000000', 'consum', 0.0212, 'lps'),
	(434029, 125, '2015-03-01 00:16:10.000000', 'consum', 0.0223, 'lps'),
	(434030, 125, '2015-03-01 00:16:11.000000', 'consum', 0.0217, 'lps'),
	(434031, 125, '2015-03-01 00:16:12.000000', 'consum', 0.0225, 'lps'),
	(434032, 125, '2015-03-01 00:16:13.000000', 'consum', 0.0214, 'lps'),
	(434033, 125, '2015-03-01 00:16:14.000000', 'consum', 0.0220, 'lps'),
	(434034, 125, '2015-03-01 00:16:15.000000', 'consum', 0.0212, 'lps'),
	(434035, 125, '2015-03-01 00:16:16.000000', 'consum', 0.0225, 'lps'),
	(434036, 125, '2015-03-01 00:16:17.000000', 'consum', 0.0213, 'lps'),
	(434037, 125, '2015-03-01 00:16:18.000000', 'consum', 0.0215, 'lps'),
	(434038, 125, '2015-03-01 00:16:19.000000', 'consum', 0.0226, 'lps'),
	(434039, 125, '2015-03-01 00:16:20.000000', 'consum', 0.0224, 'lps'),
	(434040, 125, '2015-03-01 00:16:21.000000', 'consum', 0.0217, 'lps'),
	(434041, 125, '2015-03-01 00:16:22.000000', 'consum', 0.0221, 'lps'),
	(434042, 125, '2015-03-01 00:16:23.000000', 'consum', 0.0210, 'lps'),
	(434043, 125, '2015-03-01 00:16:24.000000', 'consum', 0.0212, 'lps'),
	(434044, 125, '2015-03-01 00:16:25.000000', 'consum', 0.0219, 'lps'),
	(434045, 125, '2015-03-01 00:16:26.000000', 'consum', 0.0216, 'lps'),
	(434046, 125, '2015-03-01 00:16:27.000000', 'consum', 0.0215, 'lps'),
	(434047, 125, '2015-03-01 00:16:28.000000', 'consum', 0.0216, 'lps'),
	(434048, 125, '2015-03-01 00:16:29.000000', 'consum', 0.0225, 'lps'),
	(434049, 125, '2015-03-01 00:16:30.000000', 'consum', 0.0215, 'lps'),
	(434050, 125, '2015-03-01 00:16:31.000000', 'consum', 0.0211, 'lps'),
	(434051, 125, '2015-03-01 00:16:32.000000', 'consum', 0.0216, 'lps'),
	(434052, 125, '2015-03-01 00:16:33.000000', 'consum', 0.0219, 'lps'),
	(434053, 125, '2015-03-01 00:16:34.000000', 'consum', 0.0223, 'lps'),
	(434054, 125, '2015-03-01 00:16:35.000000', 'consum', 0.0213, 'lps'),
	(434055, 125, '2015-03-01 00:16:36.000000', 'consum', 0.0222, 'lps'),
	(434056, 125, '2015-03-01 00:16:37.000000', 'consum', 0.0226, 'lps'),
	(434057, 125, '2015-03-01 00:16:38.000000', 'consum', 0.0220, 'lps'),
	(434058, 125, '2015-03-01 00:16:39.000000', 'consum', 0.0214, 'lps'),
	(434059, 125, '2015-03-01 00:16:40.000000', 'consum', 0.0219, 'lps'),
	(434060, 125, '2015-03-01 00:16:41.000000', 'consum', 0.0225, 'lps'),
	(434061, 125, '2015-03-01 00:16:42.000000', 'consum', 0.0222, 'lps'),
	(434062, 125, '2015-03-01 00:16:43.000000', 'consum', 0.0212, 'lps'),
	(434063, 125, '2015-03-01 00:16:44.000000', 'consum', 0.0218, 'lps'),
	(434064, 125, '2015-03-01 00:16:45.000000', 'consum', 0.0226, 'lps'),
	(434065, 125, '2015-03-01 00:16:46.000000', 'consum', 0.0217, 'lps'),
	(434066, 125, '2015-03-01 00:16:47.000000', 'consum', 0.0214, 'lps'),
	(434067, 125, '2015-03-01 00:16:48.000000', 'consum', 0.0210, 'lps'),
	(434068, 125, '2015-03-01 00:16:49.000000', 'consum', 0.0216, 'lps'),
	(434069, 125, '2015-03-01 00:16:50.000000', 'consum', 0.0224, 'lps'),
	(434070, 125, '2015-03-01 00:16:51.000000', 'consum', 0.0226, 'lps'),
	(434071, 125, '2015-03-01 00:16:52.000000', 'consum', 0.0217, 'lps'),
	(434072, 125, '2015-03-01 00:16:53.000000', 'consum', 0.0214, 'lps'),
	(434073, 125, '2015-03-01 00:16:54.000000', 'consum', 0.0210, 'lps'),
	(434074, 125, '2015-03-01 00:16:55.000000', 'consum', 0.0217, 'lps'),
	(434075, 125, '2015-03-01 00:16:56.000000', 'consum', 0.0226, 'lps'),
	(434076, 125, '2015-03-01 00:16:57.000000', 'consum', 0.0220, 'lps'),
	(434077, 125, '2015-03-01 00:16:58.000000', 'consum', 0.0211, 'lps'),
	(434078, 125, '2015-03-01 00:16:59.000000', 'consum', 0.0222, 'lps'),
	(434079, 125, '2015-03-01 00:17:00.000000', 'consum', 0.0215, 'lps'),
	(434080, 125, '2015-03-01 00:17:01.000000', 'consum', 0.0218, 'lps'),
	(434081, 125, '2015-03-01 00:17:02.000000', 'consum', 0.0218, 'lps'),
	(434082, 125, '2015-03-01 00:17:03.000000', 'consum', 0.0226, 'lps'),
	(434083, 125, '2015-03-01 00:17:04.000000', 'consum', 0.0216, 'lps'),
	(434084, 125, '2015-03-01 00:17:05.000000', 'consum', 0.0211, 'lps'),
	(434085, 125, '2015-03-01 00:17:06.000000', 'consum', 0.0212, 'lps'),
	(434086, 125, '2015-03-01 00:17:07.000000', 'consum', 0.0217, 'lps'),
	(434087, 125, '2015-03-01 00:17:08.000000', 'consum', 0.0226, 'lps'),
	(434088, 125, '2015-03-01 00:17:09.000000', 'consum', 0.0215, 'lps'),
	(434089, 125, '2015-03-01 00:17:10.000000', 'consum', 0.0221, 'lps'),
	(434090, 125, '2015-03-01 00:17:11.000000', 'consum', 0.0218, 'lps'),
	(434091, 125, '2015-03-01 00:17:12.000000', 'consum', 0.0218, 'lps'),
	(434092, 125, '2015-03-01 00:17:13.000000', 'consum', 0.0226, 'lps'),
	(434093, 125, '2015-03-01 00:17:14.000000', 'consum', 0.0216, 'lps'),
	(434094, 125, '2015-03-01 00:17:15.000000', 'consum', 0.0226, 'lps'),
	(434095, 125, '2015-03-01 00:17:16.000000', 'consum', 0.0220, 'lps'),
	(434096, 125, '2015-03-01 00:17:17.000000', 'consum', 0.0215, 'lps'),
	(434097, 125, '2015-03-01 00:17:18.000000', 'consum', 0.0222, 'lps'),
	(434098, 125, '2015-03-01 00:17:19.000000', 'consum', 0.0223, 'lps'),
	(434099, 125, '2015-03-01 00:17:20.000000', 'consum', 0.0219, 'lps'),
	(434100, 125, '2015-03-01 00:17:21.000000', 'consum', 0.0219, 'lps'),
	(434101, 125, '2015-03-01 00:17:22.000000', 'consum', 0.0210, 'lps'),
	(434102, 125, '2015-03-01 00:17:23.000000', 'consum', 0.0216, 'lps'),
	(434103, 125, '2015-03-01 00:17:24.000000', 'consum', 0.0226, 'lps'),
	(434104, 125, '2015-03-01 00:17:25.000000', 'consum', 0.0221, 'lps'),
	(434105, 125, '2015-03-01 00:17:26.000000', 'consum', 0.0215, 'lps'),
	(434106, 125, '2015-03-01 00:17:27.000000', 'consum', 0.0223, 'lps'),
	(434107, 125, '2015-03-01 00:17:28.000000', 'consum', 0.0224, 'lps'),
	(434108, 125, '2015-03-01 00:17:29.000000', 'consum', 0.0226, 'lps'),
	(434109, 125, '2015-03-01 00:17:30.000000', 'consum', 0.0213, 'lps'),
	(434110, 125, '2015-03-01 00:17:31.000000', 'consum', 0.0213, 'lps'),
	(434111, 125, '2015-03-01 00:17:32.000000', 'consum', 0.0216, 'lps'),
	(434112, 125, '2015-03-01 00:17:33.000000', 'consum', 0.0214, 'lps'),
	(434113, 125, '2015-03-01 00:17:34.000000', 'consum', 0.0211, 'lps'),
	(434114, 125, '2015-03-01 00:17:35.000000', 'consum', 0.0224, 'lps'),
	(434115, 125, '2015-03-01 00:17:36.000000', 'consum', 0.0224, 'lps'),
	(434116, 125, '2015-03-01 00:17:37.000000', 'consum', 0.0221, 'lps'),
	(434117, 125, '2015-03-01 00:17:38.000000', 'consum', 0.0223, 'lps'),
	(434118, 125, '2015-03-01 00:17:39.000000', 'consum', 0.0210, 'lps'),
	(434119, 125, '2015-03-01 00:17:40.000000', 'consum', 0.0221, 'lps'),
	(434120, 125, '2015-03-01 00:17:41.000000', 'consum', 0.0215, 'lps'),
	(434121, 125, '2015-03-01 00:17:42.000000', 'consum', 0.0218, 'lps'),
	(434122, 125, '2015-03-01 00:17:43.000000', 'consum', 0.0219, 'lps'),
	(434123, 125, '2015-03-01 00:17:44.000000', 'consum', 0.0216, 'lps'),
	(434124, 125, '2015-03-01 00:17:45.000000', 'consum', 0.0211, 'lps'),
	(434125, 125, '2015-03-01 00:17:46.000000', 'consum', 0.0216, 'lps'),
	(434126, 125, '2015-03-01 00:17:47.000000', 'consum', 0.0219, 'lps'),
	(434127, 125, '2015-03-01 00:17:48.000000', 'consum', 0.0222, 'lps'),
	(434128, 125, '2015-03-01 00:17:49.000000', 'consum', 0.0210, 'lps'),
	(434129, 125, '2015-03-01 00:17:50.000000', 'consum', 0.0224, 'lps'),
	(434130, 125, '2015-03-01 00:17:51.000000', 'consum', 0.0213, 'lps'),
	(434131, 125, '2015-03-01 00:17:52.000000', 'consum', 0.0217, 'lps'),
	(434132, 125, '2015-03-01 00:17:53.000000', 'consum', 0.0219, 'lps'),
	(434133, 125, '2015-03-01 00:17:54.000000', 'consum', 0.0218, 'lps'),
	(434134, 125, '2015-03-01 00:17:55.000000', 'consum', 0.0222, 'lps'),
	(434135, 125, '2015-03-01 00:17:56.000000', 'consum', 0.0214, 'lps'),
	(434136, 125, '2015-03-01 00:17:57.000000', 'consum', 0.0210, 'lps'),
	(434137, 125, '2015-03-01 00:17:58.000000', 'consum', 0.0218, 'lps'),
	(434138, 125, '2015-03-01 00:17:59.000000', 'consum', 0.0217, 'lps'),
	(434139, 125, '2015-03-01 00:18:00.000000', 'consum', 0.0221, 'lps'),
	(434140, 125, '2015-03-01 00:18:01.000000', 'consum', 0.0212, 'lps'),
	(434141, 125, '2015-03-01 00:18:02.000000', 'consum', 0.0220, 'lps'),
	(434142, 125, '2015-03-01 00:18:03.000000', 'consum', 0.0219, 'lps'),
	(434143, 125, '2015-03-01 00:18:04.000000', 'consum', 0.0210, 'lps'),
	(434144, 125, '2015-03-01 00:18:05.000000', 'consum', 0.0217, 'lps'),
	(434145, 125, '2015-03-01 00:18:06.000000', 'consum', 0.0211, 'lps'),
	(434146, 125, '2015-03-01 00:18:07.000000', 'consum', 0.0212, 'lps'),
	(434147, 125, '2015-03-01 00:18:08.000000', 'consum', 0.0219, 'lps'),
	(434148, 125, '2015-03-01 00:18:09.000000', 'consum', 0.0216, 'lps'),
	(434149, 125, '2015-03-01 00:18:10.000000', 'consum', 0.0213, 'lps'),
	(434150, 125, '2015-03-01 00:18:11.000000', 'consum', 0.0222, 'lps'),
	(434151, 125, '2015-03-01 00:18:12.000000', 'consum', 0.0213, 'lps'),
	(434152, 125, '2015-03-01 00:18:13.000000', 'consum', 0.0221, 'lps'),
	(434153, 125, '2015-03-01 00:18:14.000000', 'consum', 0.0226, 'lps'),
	(434154, 125, '2015-03-01 00:18:15.000000', 'consum', 0.0220, 'lps'),
	(434155, 125, '2015-03-01 00:18:16.000000', 'consum', 0.0214, 'lps'),
	(434156, 125, '2015-03-01 00:18:17.000000', 'consum', 0.0219, 'lps'),
	(434157, 125, '2015-03-01 00:18:18.000000', 'consum', 0.0210, 'lps'),
	(434158, 125, '2015-03-01 00:18:19.000000', 'consum', 0.0216, 'lps'),
	(434159, 125, '2015-03-01 00:18:20.000000', 'consum', 0.0222, 'lps'),
	(434160, 125, '2015-03-01 00:18:21.000000', 'consum', 0.0221, 'lps'),
	(434161, 125, '2015-03-01 00:18:22.000000', 'consum', 0.0210, 'lps'),
	(434162, 125, '2015-03-01 00:18:23.000000', 'consum', 0.0214, 'lps'),
	(434163, 125, '2015-03-01 00:18:24.000000', 'consum', 0.0211, 'lps'),
	(434164, 125, '2015-03-01 00:18:25.000000', 'consum', 0.0223, 'lps'),
	(434165, 125, '2015-03-01 00:18:26.000000', 'consum', 0.0218, 'lps'),
	(434166, 125, '2015-03-01 00:18:27.000000', 'consum', 0.0215, 'lps'),
	(434167, 125, '2015-03-01 00:18:28.000000', 'consum', 0.0210, 'lps'),
	(434168, 125, '2015-03-01 00:18:29.000000', 'consum', 0.0215, 'lps'),
	(434169, 125, '2015-03-01 00:18:30.000000', 'consum', 0.0216, 'lps'),
	(434170, 125, '2015-03-01 00:18:31.000000', 'consum', 0.0224, 'lps'),
	(434171, 125, '2015-03-01 00:18:32.000000', 'consum', 0.0214, 'lps'),
	(434172, 125, '2015-03-01 00:18:33.000000', 'consum', 0.0220, 'lps'),
	(434173, 125, '2015-03-01 00:18:34.000000', 'consum', 0.0217, 'lps'),
	(434174, 125, '2015-03-01 00:18:35.000000', 'consum', 0.0215, 'lps'),
	(434175, 125, '2015-03-01 00:18:36.000000', 'consum', 0.0215, 'lps'),
	(434176, 125, '2015-03-01 00:18:37.000000', 'consum', 0.0218, 'lps'),
	(434177, 125, '2015-03-01 00:18:38.000000', 'consum', 0.0220, 'lps'),
	(434178, 125, '2015-03-01 00:18:39.000000', 'consum', 0.0219, 'lps'),
	(434179, 125, '2015-03-01 00:18:40.000000', 'consum', 0.0225, 'lps'),
	(434180, 125, '2015-03-01 00:18:41.000000', 'consum', 0.0223, 'lps'),
	(434181, 125, '2015-03-01 00:18:42.000000', 'consum', 0.0216, 'lps'),
	(434182, 125, '2015-03-01 00:18:43.000000', 'consum', 0.0217, 'lps'),
	(434183, 125, '2015-03-01 00:18:44.000000', 'consum', 0.0213, 'lps'),
	(434184, 125, '2015-03-01 00:18:45.000000', 'consum', 0.0220, 'lps'),
	(434185, 125, '2015-03-01 00:18:46.000000', 'consum', 0.0217, 'lps'),
	(434186, 125, '2015-03-01 00:18:47.000000', 'consum', 0.0218, 'lps'),
	(434187, 125, '2015-03-01 00:18:48.000000', 'consum', 0.0226, 'lps'),
	(434188, 125, '2015-03-01 00:18:49.000000', 'consum', 0.0219, 'lps'),
	(434189, 125, '2015-03-01 00:18:50.000000', 'consum', 0.0222, 'lps'),
	(434190, 125, '2015-03-01 00:18:51.000000', 'consum', 0.0226, 'lps'),
	(434191, 125, '2015-03-01 00:18:52.000000', 'consum', 0.0223, 'lps'),
	(434192, 125, '2015-03-01 00:18:53.000000', 'consum', 0.0210, 'lps'),
	(434193, 125, '2015-03-01 00:18:54.000000', 'consum', 0.0221, 'lps'),
	(434194, 125, '2015-03-01 00:18:55.000000', 'consum', 0.0215, 'lps'),
	(434195, 125, '2015-03-01 00:18:56.000000', 'consum', 0.0219, 'lps'),
	(434196, 125, '2015-03-01 00:18:57.000000', 'consum', 0.0222, 'lps'),
	(434197, 125, '2015-03-01 00:18:58.000000', 'consum', 0.0212, 'lps'),
	(434198, 125, '2015-03-01 00:18:59.000000', 'consum', 0.0217, 'lps'),
	(434199, 125, '2015-03-01 00:19:00.000000', 'consum', 0.0225, 'lps'),
	(434200, 125, '2015-03-01 00:19:01.000000', 'consum', 0.0211, 'lps'),
	(434201, 125, '2015-03-01 00:19:02.000000', 'consum', 0.0224, 'lps'),
	(434202, 125, '2015-03-01 00:19:03.000000', 'consum', 0.0225, 'lps'),
	(434203, 125, '2015-03-01 00:19:04.000000', 'consum', 0.0211, 'lps'),
	(434204, 125, '2015-03-01 00:19:05.000000', 'consum', 0.0222, 'lps'),
	(434205, 125, '2015-03-01 00:19:06.000000', 'consum', 0.0215, 'lps'),
	(434206, 125, '2015-03-01 00:19:07.000000', 'consum', 0.0215, 'lps'),
	(434207, 125, '2015-03-01 00:19:08.000000', 'consum', 0.0223, 'lps'),
	(434208, 125, '2015-03-01 00:19:09.000000', 'consum', 0.0224, 'lps'),
	(434209, 125, '2015-03-01 00:19:10.000000', 'consum', 0.0210, 'lps'),
	(434210, 125, '2015-03-01 00:19:11.000000', 'consum', 0.0218, 'lps'),
	(434211, 125, '2015-03-01 00:19:12.000000', 'consum', 0.0216, 'lps'),
	(434212, 125, '2015-03-01 00:19:13.000000', 'consum', 0.0216, 'lps'),
	(434213, 125, '2015-03-01 00:19:14.000000', 'consum', 0.0223, 'lps'),
	(434214, 125, '2015-03-01 00:19:15.000000', 'consum', 0.0224, 'lps'),
	(434215, 125, '2015-03-01 00:19:16.000000', 'consum', 0.0223, 'lps'),
	(434216, 125, '2015-03-01 00:19:17.000000', 'consum', 0.0216, 'lps'),
	(434217, 125, '2015-03-01 00:19:18.000000', 'consum', 0.0221, 'lps'),
	(434218, 125, '2015-03-01 00:19:19.000000', 'consum', 0.0214, 'lps'),
	(434219, 125, '2015-03-01 00:19:20.000000', 'consum', 0.0215, 'lps'),
	(434220, 125, '2015-03-01 00:19:21.000000', 'consum', 0.0222, 'lps'),
	(434221, 125, '2015-03-01 00:19:22.000000', 'consum', 0.0223, 'lps'),
	(434222, 125, '2015-03-01 00:19:23.000000', 'consum', 0.0222, 'lps'),
	(434223, 125, '2015-03-01 00:19:24.000000', 'consum', 0.0215, 'lps'),
	(434224, 125, '2015-03-01 00:19:25.000000', 'consum', 0.0214, 'lps'),
	(434225, 125, '2015-03-01 00:19:26.000000', 'consum', 0.0217, 'lps'),
	(434226, 125, '2015-03-01 00:19:27.000000', 'consum', 0.0217, 'lps'),
	(434227, 125, '2015-03-01 00:19:28.000000', 'consum', 0.0223, 'lps'),
	(434228, 125, '2015-03-01 00:19:29.000000', 'consum', 0.0222, 'lps'),
	(434229, 125, '2015-03-01 00:19:30.000000', 'consum', 0.0214, 'lps'),
	(434230, 125, '2015-03-01 00:19:31.000000', 'consum', 0.0210, 'lps'),
	(434231, 125, '2015-03-01 00:19:32.000000', 'consum', 0.0215, 'lps'),
	(434232, 125, '2015-03-01 00:19:33.000000', 'consum', 0.0220, 'lps'),
	(434233, 125, '2015-03-01 00:19:34.000000', 'consum', 0.0212, 'lps'),
	(434234, 125, '2015-03-01 00:19:35.000000', 'consum', 0.0223, 'lps'),
	(434235, 125, '2015-03-01 00:19:36.000000', 'consum', 0.0219, 'lps'),
	(434236, 125, '2015-03-01 00:19:37.000000', 'consum', 0.0219, 'lps'),
	(434237, 125, '2015-03-01 00:19:38.000000', 'consum', 0.0225, 'lps'),
	(434238, 125, '2015-03-01 00:19:39.000000', 'consum', 0.0210, 'lps'),
	(434239, 125, '2015-03-01 00:19:40.000000', 'consum', 0.0215, 'lps'),
	(434240, 125, '2015-03-01 00:19:41.000000', 'consum', 0.0221, 'lps'),
	(434241, 125, '2015-03-01 00:19:42.000000', 'consum', 0.0213, 'lps'),
	(434242, 125, '2015-03-01 00:19:43.000000', 'consum', 0.0213, 'lps'),
	(434243, 125, '2015-03-01 00:19:44.000000', 'consum', 0.0214, 'lps'),
	(434244, 125, '2015-03-01 00:19:45.000000', 'consum', 0.0224, 'lps'),
	(434245, 125, '2015-03-01 00:19:46.000000', 'consum', 0.0218, 'lps'),
	(434246, 125, '2015-03-01 00:19:47.000000', 'consum', 0.0224, 'lps'),
	(434247, 125, '2015-03-01 00:19:48.000000', 'consum', 0.0222, 'lps'),
	(434248, 125, '2015-03-01 00:19:49.000000', 'consum', 0.0212, 'lps'),
	(434249, 125, '2015-03-01 00:19:50.000000', 'consum', 0.0218, 'lps'),
	(434250, 125, '2015-03-01 00:19:51.000000', 'consum', 0.0213, 'lps'),
	(434251, 125, '2015-03-01 00:19:52.000000', 'consum', 0.0215, 'lps'),
	(434252, 125, '2015-03-01 00:19:53.000000', 'consum', 0.0211, 'lps'),
	(434253, 125, '2015-03-01 00:19:54.000000', 'consum', 0.0217, 'lps'),
	(434254, 125, '2015-03-01 00:19:55.000000', 'consum', 0.0225, 'lps'),
	(434255, 125, '2015-03-01 00:19:56.000000', 'consum', 0.0213, 'lps'),
	(434256, 125, '2015-03-01 00:19:57.000000', 'consum', 0.0217, 'lps'),
	(434257, 125, '2015-03-01 00:19:58.000000', 'consum', 0.0217, 'lps'),
	(434258, 125, '2015-03-01 00:19:59.000000', 'consum', 0.0210, 'lps'),
	(434259, 125, '2015-03-01 00:20:00.000000', 'consum', 0.0222, 'lps'),
	(434260, 125, '2015-03-01 00:20:01.000000', 'consum', 0.0221, 'lps'),
	(434261, 125, '2015-03-01 00:20:02.000000', 'consum', 0.0212, 'lps'),
	(434262, 125, '2015-03-01 00:20:03.000000', 'consum', 0.0219, 'lps'),
	(434263, 125, '2015-03-01 00:20:04.000000', 'consum', 0.0219, 'lps'),
	(434264, 125, '2015-03-01 00:20:05.000000', 'consum', 0.0225, 'lps'),
	(434265, 125, '2015-03-01 00:20:06.000000', 'consum', 0.0226, 'lps'),
	(434266, 125, '2015-03-01 00:20:07.000000', 'consum', 0.0213, 'lps'),
	(434267, 125, '2015-03-01 00:20:08.000000', 'consum', 0.0225, 'lps'),
	(434268, 125, '2015-03-01 00:20:09.000000', 'consum', 0.0212, 'lps'),
	(434269, 125, '2015-03-01 00:20:10.000000', 'consum', 0.0226, 'lps'),
	(434270, 125, '2015-03-01 00:20:11.000000', 'consum', 0.0217, 'lps'),
	(434271, 125, '2015-03-01 00:20:12.000000', 'consum', 0.0212, 'lps'),
	(434272, 125, '2015-03-01 00:20:13.000000', 'consum', 0.0218, 'lps'),
	(434273, 125, '2015-03-01 00:20:14.000000', 'consum', 0.0226, 'lps'),
	(434274, 125, '2015-03-01 00:20:15.000000', 'consum', 0.0218, 'lps'),
	(434275, 125, '2015-03-01 00:20:16.000000', 'consum', 0.0220, 'lps'),
	(434276, 125, '2015-03-01 00:20:17.000000', 'consum', 0.0220, 'lps'),
	(434277, 125, '2015-03-01 00:20:18.000000', 'consum', 0.0212, 'lps'),
	(434278, 125, '2015-03-01 00:20:19.000000', 'consum', 0.0226, 'lps'),
	(434279, 125, '2015-03-01 00:20:20.000000', 'consum', 0.0214, 'lps'),
	(434280, 125, '2015-03-01 00:20:21.000000', 'consum', 0.0218, 'lps'),
	(434281, 125, '2015-03-01 00:20:22.000000', 'consum', 0.0223, 'lps'),
	(434282, 125, '2015-03-01 00:20:23.000000', 'consum', 0.0215, 'lps'),
	(434283, 125, '2015-03-01 00:20:24.000000', 'consum', 0.0214, 'lps'),
	(434284, 125, '2015-03-01 00:20:25.000000', 'consum', 0.0214, 'lps'),
	(434285, 125, '2015-03-01 00:20:26.000000', 'consum', 0.0219, 'lps'),
	(434286, 125, '2015-03-01 00:20:27.000000', 'consum', 0.0226, 'lps'),
	(434287, 125, '2015-03-01 00:20:28.000000', 'consum', 0.0213, 'lps'),
	(434288, 125, '2015-03-01 00:20:29.000000', 'consum', 0.0212, 'lps'),
	(434289, 125, '2015-03-01 00:20:30.000000', 'consum', 0.0211, 'lps'),
	(434290, 125, '2015-03-01 00:20:31.000000', 'consum', 0.0226, 'lps'),
	(434291, 125, '2015-03-01 00:20:32.000000', 'consum', 0.0220, 'lps'),
	(434292, 125, '2015-03-01 00:20:33.000000', 'consum', 0.0214, 'lps'),
	(434293, 125, '2015-03-01 00:20:34.000000', 'consum', 0.0216, 'lps'),
	(434294, 125, '2015-03-01 00:20:35.000000', 'consum', 0.0211, 'lps'),
	(434295, 125, '2015-03-01 00:20:36.000000', 'consum', 0.0217, 'lps'),
	(434296, 125, '2015-03-01 00:20:37.000000', 'consum', 0.0224, 'lps'),
	(434297, 125, '2015-03-01 00:20:38.000000', 'consum', 0.0210, 'lps'),
	(434298, 125, '2015-03-01 00:20:39.000000', 'consum', 0.0219, 'lps'),
	(434299, 125, '2015-03-01 00:20:40.000000', 'consum', 0.0221, 'lps'),
	(434300, 125, '2015-03-01 00:20:41.000000', 'consum', 0.0223, 'lps'),
	(434301, 125, '2015-03-01 00:20:42.000000', 'consum', 0.0226, 'lps'),
	(434302, 125, '2015-03-01 00:20:43.000000', 'consum', 0.0215, 'lps'),
	(434303, 125, '2015-03-01 00:20:44.000000', 'consum', 0.0221, 'lps'),
	(434304, 125, '2015-03-01 00:20:45.000000', 'consum', 0.0217, 'lps'),
	(434305, 125, '2015-03-01 00:20:46.000000', 'consum', 0.0211, 'lps'),
	(434306, 125, '2015-03-01 00:20:47.000000', 'consum', 0.0215, 'lps'),
	(434307, 125, '2015-03-01 00:20:48.000000', 'consum', 0.0213, 'lps'),
	(434308, 125, '2015-03-01 00:20:49.000000', 'consum', 0.0226, 'lps'),
	(434309, 125, '2015-03-01 00:20:50.000000', 'consum', 0.0217, 'lps'),
	(434310, 125, '2015-03-01 00:20:51.000000', 'consum', 0.0212, 'lps'),
	(434311, 125, '2015-03-01 00:20:52.000000', 'consum', 0.0218, 'lps'),
	(434312, 125, '2015-03-01 00:20:53.000000', 'consum', 0.0212, 'lps'),
	(434313, 125, '2015-03-01 00:20:54.000000', 'consum', 0.0211, 'lps'),
	(434314, 125, '2015-03-01 00:20:55.000000', 'consum', 0.0212, 'lps'),
	(434315, 125, '2015-03-01 00:20:56.000000', 'consum', 0.0214, 'lps'),
	(434316, 125, '2015-03-01 00:20:57.000000', 'consum', 0.0211, 'lps'),
	(434317, 125, '2015-03-01 00:20:58.000000', 'consum', 0.0219, 'lps'),
	(434318, 125, '2015-03-01 00:20:59.000000', 'consum', 0.0217, 'lps'),
	(434319, 125, '2015-03-01 00:21:00.000000', 'consum', 0.0220, 'lps'),
	(434320, 125, '2015-03-01 00:21:01.000000', 'consum', 0.0222, 'lps'),
	(434321, 125, '2015-03-01 00:21:02.000000', 'consum', 0.0222, 'lps'),
	(434322, 125, '2015-03-01 00:21:03.000000', 'consum', 0.0217, 'lps'),
	(434323, 125, '2015-03-01 00:21:04.000000', 'consum', 0.0226, 'lps'),
	(434324, 125, '2015-03-01 00:21:05.000000', 'consum', 0.0219, 'lps'),
	(434325, 125, '2015-03-01 00:21:06.000000', 'consum', 0.0210, 'lps'),
	(434326, 125, '2015-03-01 00:21:07.000000', 'consum', 0.0215, 'lps'),
	(434327, 125, '2015-03-01 00:21:08.000000', 'consum', 0.0218, 'lps'),
	(434328, 125, '2015-03-01 00:21:09.000000', 'consum', 0.0218, 'lps'),
	(434329, 125, '2015-03-01 00:21:10.000000', 'consum', 0.0211, 'lps'),
	(434330, 125, '2015-03-01 00:21:11.000000', 'consum', 0.0224, 'lps'),
	(434331, 125, '2015-03-01 00:21:12.000000', 'consum', 0.0211, 'lps'),
	(434332, 125, '2015-03-01 00:21:13.000000', 'consum', 0.0224, 'lps'),
	(434333, 125, '2015-03-01 00:21:14.000000', 'consum', 0.0225, 'lps'),
	(434334, 125, '2015-03-01 00:21:15.000000', 'consum', 0.0211, 'lps'),
	(434335, 125, '2015-03-01 00:21:16.000000', 'consum', 0.0219, 'lps'),
	(434336, 125, '2015-03-01 00:21:17.000000', 'consum', 0.0221, 'lps'),
	(434337, 125, '2015-03-01 00:21:18.000000', 'consum', 0.0222, 'lps'),
	(434338, 125, '2015-03-01 00:21:19.000000', 'consum', 0.0219, 'lps'),
	(434339, 125, '2015-03-01 00:21:20.000000', 'consum', 0.0218, 'lps'),
	(434340, 125, '2015-03-01 00:21:21.000000', 'consum', 0.0210, 'lps'),
	(434341, 125, '2015-03-01 00:21:22.000000', 'consum', 0.0217, 'lps'),
	(434342, 125, '2015-03-01 00:21:23.000000', 'consum', 0.0214, 'lps'),
	(434343, 125, '2015-03-01 00:21:24.000000', 'consum', 0.0210, 'lps'),
	(434344, 125, '2015-03-01 00:21:25.000000', 'consum', 0.0213, 'lps'),
	(434345, 125, '2015-03-01 00:21:26.000000', 'consum', 0.0210, 'lps'),
	(434346, 125, '2015-03-01 00:21:27.000000', 'consum', 0.0219, 'lps'),
	(434347, 125, '2015-03-01 00:21:28.000000', 'consum', 0.0222, 'lps'),
	(434348, 125, '2015-03-01 00:21:29.000000', 'consum', 0.0224, 'lps'),
	(434349, 125, '2015-03-01 00:21:30.000000', 'consum', 0.0211, 'lps'),
	(434350, 125, '2015-03-01 00:21:31.000000', 'consum', 0.0225, 'lps'),
	(434351, 125, '2015-03-01 00:21:32.000000', 'consum', 0.0215, 'lps'),
	(434352, 125, '2015-03-01 00:21:33.000000', 'consum', 0.0222, 'lps'),
	(434353, 125, '2015-03-01 00:21:34.000000', 'consum', 0.0224, 'lps'),
	(434354, 125, '2015-03-01 00:21:35.000000', 'consum', 0.0211, 'lps'),
	(434355, 125, '2015-03-01 00:21:36.000000', 'consum', 0.0223, 'lps'),
	(434356, 125, '2015-03-01 00:21:37.000000', 'consum', 0.0222, 'lps'),
	(434357, 125, '2015-03-01 00:21:38.000000', 'consum', 0.0214, 'lps'),
	(434358, 125, '2015-03-01 00:21:39.000000', 'consum', 0.0212, 'lps'),
	(434359, 125, '2015-03-01 00:21:40.000000', 'consum', 0.0224, 'lps'),
	(434360, 125, '2015-03-01 00:21:41.000000', 'consum', 0.0223, 'lps'),
	(434361, 125, '2015-03-01 00:21:42.000000', 'consum', 0.0216, 'lps'),
	(434362, 125, '2015-03-01 00:21:43.000000', 'consum', 0.0220, 'lps'),
	(434363, 125, '2015-03-01 00:21:44.000000', 'consum', 0.0226, 'lps'),
	(434364, 125, '2015-03-01 00:21:45.000000', 'consum', 0.0226, 'lps'),
	(434365, 125, '2015-03-01 00:21:46.000000', 'consum', 0.0210, 'lps'),
	(434366, 125, '2015-03-01 00:21:47.000000', 'consum', 0.0214, 'lps'),
	(434367, 125, '2015-03-01 00:21:48.000000', 'consum', 0.0212, 'lps'),
	(434368, 125, '2015-03-01 00:21:49.000000', 'consum', 0.0225, 'lps'),
	(434369, 125, '2015-03-01 00:21:50.000000', 'consum', 0.0212, 'lps'),
	(434370, 125, '2015-03-01 00:21:51.000000', 'consum', 0.0226, 'lps'),
	(434371, 125, '2015-03-01 00:21:52.000000', 'consum', 0.0215, 'lps'),
	(434372, 125, '2015-03-01 00:21:53.000000', 'consum', 0.0224, 'lps'),
	(434373, 125, '2015-03-01 00:21:54.000000', 'consum', 0.0216, 'lps'),
	(434374, 125, '2015-03-01 00:21:55.000000', 'consum', 0.0213, 'lps'),
	(434375, 125, '2015-03-01 00:21:56.000000', 'consum', 0.0224, 'lps'),
	(434376, 125, '2015-03-01 00:21:57.000000', 'consum', 0.0221, 'lps'),
	(434377, 125, '2015-03-01 00:21:58.000000', 'consum', 0.0223, 'lps'),
	(434378, 125, '2015-03-01 00:21:59.000000', 'consum', 0.0211, 'lps'),
	(434379, 125, '2015-03-01 00:22:00.000000', 'consum', 0.0225, 'lps'),
	(434380, 125, '2015-03-01 00:22:01.000000', 'consum', 0.0215, 'lps'),
	(434381, 125, '2015-03-01 00:22:02.000000', 'consum', 0.0225, 'lps'),
	(434382, 125, '2015-03-01 00:22:03.000000', 'consum', 0.0220, 'lps'),
	(434383, 125, '2015-03-01 00:22:04.000000', 'consum', 0.0214, 'lps'),
	(434384, 125, '2015-03-01 00:22:05.000000', 'consum', 0.0220, 'lps'),
	(434385, 125, '2015-03-01 00:22:06.000000', 'consum', 0.0211, 'lps'),
	(434386, 125, '2015-03-01 00:22:07.000000', 'consum', 0.0223, 'lps'),
	(434387, 125, '2015-03-01 00:22:08.000000', 'consum', 0.0220, 'lps'),
	(434388, 125, '2015-03-01 00:22:09.000000', 'consum', 0.0223, 'lps'),
	(434389, 125, '2015-03-01 00:22:10.000000', 'consum', 0.0212, 'lps'),
	(434390, 125, '2015-03-01 00:22:11.000000', 'consum', 0.0216, 'lps'),
	(434391, 125, '2015-03-01 00:22:12.000000', 'consum', 0.0217, 'lps'),
	(434392, 125, '2015-03-01 00:22:13.000000', 'consum', 0.0211, 'lps'),
	(434393, 125, '2015-03-01 00:22:14.000000', 'consum', 0.0212, 'lps'),
	(434394, 125, '2015-03-01 00:22:15.000000', 'consum', 0.0215, 'lps'),
	(434395, 125, '2015-03-01 00:22:16.000000', 'consum', 0.0216, 'lps'),
	(434396, 125, '2015-03-01 00:22:17.000000', 'consum', 0.0222, 'lps'),
	(434397, 125, '2015-03-01 00:22:18.000000', 'consum', 0.0220, 'lps'),
	(434398, 125, '2015-03-01 00:22:19.000000', 'consum', 0.0225, 'lps'),
	(434399, 125, '2015-03-01 00:22:20.000000', 'consum', 0.0221, 'lps'),
	(434400, 125, '2015-03-01 00:22:21.000000', 'consum', 0.0223, 'lps'),
	(434401, 125, '2015-03-01 00:22:22.000000', 'consum', 0.0222, 'lps'),
	(434402, 125, '2015-03-01 00:22:23.000000', 'consum', 0.0215, 'lps'),
	(434403, 125, '2015-03-01 00:22:24.000000', 'consum', 0.0219, 'lps'),
	(434404, 125, '2015-03-01 00:22:25.000000', 'consum', 0.0220, 'lps'),
	(434405, 125, '2015-03-01 00:22:26.000000', 'consum', 0.0219, 'lps'),
	(434406, 125, '2015-03-01 00:22:27.000000', 'consum', 0.0223, 'lps'),
	(434407, 125, '2015-03-01 00:22:28.000000', 'consum', 0.0217, 'lps'),
	(434408, 125, '2015-03-01 00:22:29.000000', 'consum', 0.0221, 'lps'),
	(434409, 125, '2015-03-01 00:22:30.000000', 'consum', 0.0211, 'lps'),
	(434410, 125, '2015-03-01 00:22:31.000000', 'consum', 0.0216, 'lps'),
	(434411, 125, '2015-03-01 00:22:32.000000', 'consum', 0.0223, 'lps'),
	(434412, 125, '2015-03-01 00:22:33.000000', 'consum', 0.0223, 'lps'),
	(434413, 125, '2015-03-01 00:22:34.000000', 'consum', 0.0220, 'lps'),
	(434414, 125, '2015-03-01 00:22:35.000000', 'consum', 0.0220, 'lps'),
	(434415, 125, '2015-03-01 00:22:36.000000', 'consum', 0.0214, 'lps'),
	(434416, 125, '2015-03-01 00:22:37.000000', 'consum', 0.0216, 'lps'),
	(434417, 125, '2015-03-01 00:22:38.000000', 'consum', 0.0212, 'lps'),
	(434418, 125, '2015-03-01 00:22:39.000000', 'consum', 0.0221, 'lps'),
	(434419, 125, '2015-03-01 00:22:40.000000', 'consum', 0.0224, 'lps'),
	(434420, 125, '2015-03-01 00:22:41.000000', 'consum', 0.0212, 'lps'),
	(434421, 125, '2015-03-01 00:22:42.000000', 'consum', 0.0214, 'lps'),
	(434422, 125, '2015-03-01 00:22:43.000000', 'consum', 0.0225, 'lps'),
	(434423, 125, '2015-03-01 00:22:44.000000', 'consum', 0.0221, 'lps'),
	(434424, 125, '2015-03-01 00:22:45.000000', 'consum', 0.0221, 'lps'),
	(434425, 125, '2015-03-01 00:22:46.000000', 'consum', 0.0216, 'lps'),
	(434426, 125, '2015-03-01 00:22:47.000000', 'consum', 0.0225, 'lps'),
	(434427, 125, '2015-03-01 00:22:48.000000', 'consum', 0.0214, 'lps'),
	(434428, 125, '2015-03-01 00:22:49.000000', 'consum', 0.0222, 'lps'),
	(434429, 125, '2015-03-01 00:22:50.000000', 'consum', 0.0223, 'lps'),
	(434430, 125, '2015-03-01 00:22:51.000000', 'consum', 0.0223, 'lps'),
	(434431, 125, '2015-03-01 00:22:52.000000', 'consum', 0.0220, 'lps'),
	(434432, 125, '2015-03-01 00:22:53.000000', 'consum', 0.0222, 'lps'),
	(434433, 125, '2015-03-01 00:22:54.000000', 'consum', 0.0222, 'lps'),
	(434434, 125, '2015-03-01 00:22:55.000000', 'consum', 0.0218, 'lps'),
	(434435, 125, '2015-03-01 00:22:56.000000', 'consum', 0.0216, 'lps'),
	(434436, 125, '2015-03-01 00:22:57.000000', 'consum', 0.0214, 'lps'),
	(434437, 125, '2015-03-01 00:22:58.000000', 'consum', 0.0212, 'lps'),
	(434438, 125, '2015-03-01 00:22:59.000000', 'consum', 0.0211, 'lps'),
	(434439, 125, '2015-03-01 00:23:00.000000', 'consum', 0.0226, 'lps'),
	(434440, 125, '2015-03-01 00:23:01.000000', 'consum', 0.0220, 'lps'),
	(434441, 125, '2015-03-01 00:23:02.000000', 'consum', 0.0213, 'lps'),
	(434442, 125, '2015-03-01 00:23:03.000000', 'consum', 0.0212, 'lps'),
	(434443, 125, '2015-03-01 00:23:04.000000', 'consum', 0.0210, 'lps'),
	(434444, 125, '2015-03-01 00:23:05.000000', 'consum', 0.0223, 'lps'),
	(434445, 125, '2015-03-01 00:23:06.000000', 'consum', 0.0223, 'lps'),
	(434446, 125, '2015-03-01 00:23:07.000000', 'consum', 0.0219, 'lps'),
	(434447, 125, '2015-03-01 00:23:08.000000', 'consum', 0.0219, 'lps'),
	(434448, 125, '2015-03-01 00:23:09.000000', 'consum', 0.0212, 'lps'),
	(434449, 125, '2015-03-01 00:23:10.000000', 'consum', 0.0226, 'lps'),
	(434450, 125, '2015-03-01 00:23:11.000000', 'consum', 0.0216, 'lps'),
	(434451, 125, '2015-03-01 00:23:12.000000', 'consum', 0.0211, 'lps'),
	(434452, 125, '2015-03-01 00:23:13.000000', 'consum', 0.0214, 'lps'),
	(434453, 125, '2015-03-01 00:23:14.000000', 'consum', 0.0212, 'lps'),
	(434454, 125, '2015-03-01 00:23:15.000000', 'consum', 0.0224, 'lps'),
	(434455, 125, '2015-03-01 00:23:16.000000', 'consum', 0.0223, 'lps'),
	(434456, 125, '2015-03-01 00:23:17.000000', 'consum', 0.0217, 'lps'),
	(434457, 125, '2015-03-01 00:23:18.000000', 'consum', 0.0226, 'lps'),
	(434458, 125, '2015-03-01 00:23:19.000000', 'consum', 0.0215, 'lps'),
	(434459, 125, '2015-03-01 00:23:20.000000', 'consum', 0.0221, 'lps'),
	(434460, 125, '2015-03-01 00:23:21.000000', 'consum', 0.0219, 'lps'),
	(434461, 125, '2015-03-01 00:23:22.000000', 'consum', 0.0223, 'lps'),
	(434462, 125, '2015-03-01 00:23:23.000000', 'consum', 0.0216, 'lps'),
	(434463, 125, '2015-03-01 00:23:24.000000', 'consum', 0.0215, 'lps'),
	(434464, 125, '2015-03-01 00:23:25.000000', 'consum', 0.0218, 'lps'),
	(434465, 125, '2015-03-01 00:23:26.000000', 'consum', 0.0221, 'lps'),
	(434466, 125, '2015-03-01 00:23:27.000000', 'consum', 0.0221, 'lps'),
	(434467, 125, '2015-03-01 00:23:28.000000', 'consum', 0.0217, 'lps'),
	(434468, 125, '2015-03-01 00:23:29.000000', 'consum', 0.0214, 'lps'),
	(434469, 125, '2015-03-01 00:23:30.000000', 'consum', 0.0225, 'lps'),
	(434470, 125, '2015-03-01 00:23:31.000000', 'consum', 0.0222, 'lps'),
	(434471, 125, '2015-03-01 00:23:32.000000', 'consum', 0.0210, 'lps'),
	(434472, 125, '2015-03-01 00:23:33.000000', 'consum', 0.0225, 'lps'),
	(434473, 125, '2015-03-01 00:23:34.000000', 'consum', 0.0216, 'lps'),
	(434474, 125, '2015-03-01 00:23:35.000000', 'consum', 0.0213, 'lps'),
	(434475, 125, '2015-03-01 00:23:36.000000', 'consum', 0.0226, 'lps'),
	(434476, 125, '2015-03-01 00:23:37.000000', 'consum', 0.0211, 'lps'),
	(434477, 125, '2015-03-01 00:23:38.000000', 'consum', 0.0221, 'lps'),
	(434478, 125, '2015-03-01 00:23:39.000000', 'consum', 0.0211, 'lps'),
	(434479, 125, '2015-03-01 00:23:40.000000', 'consum', 0.0218, 'lps'),
	(434480, 125, '2015-03-01 00:23:41.000000', 'consum', 0.0212, 'lps'),
	(434481, 125, '2015-03-01 00:23:42.000000', 'consum', 0.0215, 'lps'),
	(434482, 125, '2015-03-01 00:23:43.000000', 'consum', 0.0212, 'lps'),
	(434483, 125, '2015-03-01 00:23:44.000000', 'consum', 0.0222, 'lps'),
	(434484, 125, '2015-03-01 00:23:45.000000', 'consum', 0.0213, 'lps'),
	(434485, 125, '2015-03-01 00:23:46.000000', 'consum', 0.0223, 'lps'),
	(434486, 125, '2015-03-01 00:23:47.000000', 'consum', 0.0218, 'lps'),
	(434487, 125, '2015-03-01 00:23:48.000000', 'consum', 0.0226, 'lps'),
	(434488, 125, '2015-03-01 00:23:49.000000', 'consum', 0.0214, 'lps'),
	(434489, 125, '2015-03-01 00:23:50.000000', 'consum', 0.0219, 'lps'),
	(434490, 125, '2015-03-01 00:23:51.000000', 'consum', 0.0210, 'lps'),
	(434491, 125, '2015-03-01 00:23:52.000000', 'consum', 0.0219, 'lps'),
	(434492, 125, '2015-03-01 00:23:53.000000', 'consum', 0.0219, 'lps'),
	(434493, 125, '2015-03-01 00:23:54.000000', 'consum', 0.0211, 'lps'),
	(434494, 125, '2015-03-01 00:23:55.000000', 'consum', 0.0224, 'lps'),
	(434495, 125, '2015-03-01 00:23:56.000000', 'consum', 0.0224, 'lps'),
	(434496, 125, '2015-03-01 00:23:57.000000', 'consum', 0.0224, 'lps'),
	(434497, 125, '2015-03-01 00:23:58.000000', 'consum', 0.0220, 'lps'),
	(434498, 125, '2015-03-01 00:23:59.000000', 'consum', 0.0218, 'lps'),
	(434499, 125, '2015-03-01 00:24:00.000000', 'consum', 0.0221, 'lps'),
	(434500, 125, '2015-03-01 00:24:01.000000', 'consum', 0.0226, 'lps'),
	(434501, 125, '2015-03-01 00:24:02.000000', 'consum', 0.0224, 'lps'),
	(434502, 125, '2015-03-01 00:24:03.000000', 'consum', 0.0215, 'lps'),
	(434503, 125, '2015-03-01 00:24:04.000000', 'consum', 0.0211, 'lps'),
	(434504, 125, '2015-03-01 00:24:05.000000', 'consum', 0.0217, 'lps'),
	(434505, 125, '2015-03-01 00:24:06.000000', 'consum', 0.0224, 'lps'),
	(434506, 125, '2015-03-01 00:24:07.000000', 'consum', 0.0225, 'lps'),
	(434507, 125, '2015-03-01 00:24:08.000000', 'consum', 0.0210, 'lps'),
	(434508, 125, '2015-03-01 00:24:09.000000', 'consum', 0.0215, 'lps'),
	(434509, 125, '2015-03-01 00:24:10.000000', 'consum', 0.0220, 'lps'),
	(434510, 125, '2015-03-01 00:24:11.000000', 'consum', 0.0213, 'lps'),
	(434511, 125, '2015-03-01 00:24:12.000000', 'consum', 0.0226, 'lps'),
	(434512, 125, '2015-03-01 00:24:13.000000', 'consum', 0.0216, 'lps'),
	(434513, 125, '2015-03-01 00:24:14.000000', 'consum', 0.0210, 'lps'),
	(434514, 125, '2015-03-01 00:24:15.000000', 'consum', 0.0211, 'lps'),
	(434515, 125, '2015-03-01 00:24:16.000000', 'consum', 0.0212, 'lps'),
	(434516, 125, '2015-03-01 00:24:17.000000', 'consum', 0.0221, 'lps'),
	(434517, 125, '2015-03-01 00:24:18.000000', 'consum', 0.0223, 'lps'),
	(434518, 125, '2015-03-01 00:24:19.000000', 'consum', 0.0211, 'lps'),
	(434519, 125, '2015-03-01 00:24:20.000000', 'consum', 0.0226, 'lps'),
	(434520, 125, '2015-03-01 00:24:21.000000', 'consum', 0.0220, 'lps'),
	(434521, 125, '2015-03-01 00:24:22.000000', 'consum', 0.0210, 'lps'),
	(434522, 125, '2015-03-01 00:24:23.000000', 'consum', 0.0218, 'lps'),
	(434523, 125, '2015-03-01 00:24:24.000000', 'consum', 0.0215, 'lps'),
	(434524, 125, '2015-03-01 00:24:25.000000', 'consum', 0.0211, 'lps'),
	(434525, 125, '2015-03-01 00:24:26.000000', 'consum', 0.0217, 'lps'),
	(434526, 125, '2015-03-01 00:24:27.000000', 'consum', 0.0225, 'lps'),
	(434527, 125, '2015-03-01 00:24:28.000000', 'consum', 0.0213, 'lps'),
	(434528, 125, '2015-03-01 00:24:29.000000', 'consum', 0.0216, 'lps'),
	(434529, 125, '2015-03-01 00:24:30.000000', 'consum', 0.0215, 'lps'),
	(434530, 125, '2015-03-01 00:24:31.000000', 'consum', 0.0219, 'lps'),
	(434531, 125, '2015-03-01 00:24:32.000000', 'consum', 0.0221, 'lps'),
	(434532, 125, '2015-03-01 00:24:33.000000', 'consum', 0.0223, 'lps'),
	(434533, 125, '2015-03-01 00:24:34.000000', 'consum', 0.0223, 'lps'),
	(434534, 125, '2015-03-01 00:24:35.000000', 'consum', 0.0223, 'lps'),
	(434535, 125, '2015-03-01 00:24:36.000000', 'consum', 0.0216, 'lps'),
	(434536, 125, '2015-03-01 00:24:37.000000', 'consum', 0.0221, 'lps'),
	(434537, 125, '2015-03-01 00:24:38.000000', 'consum', 0.0213, 'lps'),
	(434538, 125, '2015-03-01 00:24:39.000000', 'consum', 0.0224, 'lps'),
	(434539, 125, '2015-03-01 00:24:40.000000', 'consum', 0.0223, 'lps'),
	(434540, 125, '2015-03-01 00:24:41.000000', 'consum', 0.0217, 'lps'),
	(434541, 125, '2015-03-01 00:24:42.000000', 'consum', 0.0221, 'lps'),
	(434542, 125, '2015-03-01 00:24:43.000000', 'consum', 0.0213, 'lps'),
	(434543, 125, '2015-03-01 00:24:44.000000', 'consum', 0.0224, 'lps'),
	(434544, 125, '2015-03-01 00:24:45.000000', 'consum', 0.0221, 'lps'),
	(434545, 125, '2015-03-01 00:24:46.000000', 'consum', 0.0222, 'lps'),
	(434546, 125, '2015-03-01 00:24:47.000000', 'consum', 0.0224, 'lps'),
	(434547, 125, '2015-03-01 00:24:48.000000', 'consum', 0.0226, 'lps'),
	(434548, 125, '2015-03-01 00:24:49.000000', 'consum', 0.0213, 'lps'),
	(434549, 125, '2015-03-01 00:24:50.000000', 'consum', 0.0213, 'lps'),
	(434550, 125, '2015-03-01 00:24:51.000000', 'consum', 0.0218, 'lps'),
	(434551, 125, '2015-03-01 00:24:52.000000', 'consum', 0.0222, 'lps'),
	(434552, 125, '2015-03-01 00:24:53.000000', 'consum', 0.0213, 'lps'),
	(434553, 125, '2015-03-01 00:24:54.000000', 'consum', 0.0224, 'lps'),
	(434554, 125, '2015-03-01 00:24:55.000000', 'consum', 0.0222, 'lps'),
	(434555, 125, '2015-03-01 00:24:56.000000', 'consum', 0.0210, 'lps'),
	(434556, 125, '2015-03-01 00:24:57.000000', 'consum', 0.0224, 'lps'),
	(434557, 125, '2015-03-01 00:24:58.000000', 'consum', 0.0214, 'lps'),
	(434558, 125, '2015-03-01 00:24:59.000000', 'consum', 0.0224, 'lps'),
	(434559, 125, '2015-03-01 00:25:00.000000', 'consum', 0.0217, 'lps'),
	(434560, 125, '2015-03-01 00:25:01.000000', 'consum', 0.0221, 'lps'),
	(434561, 125, '2015-03-01 00:25:02.000000', 'consum', 0.0226, 'lps'),
	(434562, 125, '2015-03-01 00:25:03.000000', 'consum', 0.0224, 'lps'),
	(434563, 125, '2015-03-01 00:25:04.000000', 'consum', 0.0213, 'lps'),
	(434564, 125, '2015-03-01 00:25:05.000000', 'consum', 0.0221, 'lps'),
	(434565, 125, '2015-03-01 00:25:06.000000', 'consum', 0.0223, 'lps'),
	(434566, 125, '2015-03-01 00:25:07.000000', 'consum', 0.0224, 'lps'),
	(434567, 125, '2015-03-01 00:25:08.000000', 'consum', 0.0210, 'lps'),
	(434568, 125, '2015-03-01 00:25:09.000000', 'consum', 0.0216, 'lps'),
	(434569, 125, '2015-03-01 00:25:10.000000', 'consum', 0.0210, 'lps'),
	(434570, 125, '2015-03-01 00:25:11.000000', 'consum', 0.0224, 'lps'),
	(434571, 125, '2015-03-01 00:25:12.000000', 'consum', 0.0212, 'lps'),
	(434572, 125, '2015-03-01 00:25:13.000000', 'consum', 0.0215, 'lps'),
	(434573, 125, '2015-03-01 00:25:14.000000', 'consum', 0.0211, 'lps'),
	(434574, 125, '2015-03-01 00:25:15.000000', 'consum', 0.0217, 'lps'),
	(434575, 125, '2015-03-01 00:25:16.000000', 'consum', 0.0226, 'lps'),
	(434576, 125, '2015-03-01 00:25:17.000000', 'consum', 0.0219, 'lps'),
	(434577, 125, '2015-03-01 00:25:18.000000', 'consum', 0.0223, 'lps'),
	(434578, 125, '2015-03-01 00:25:19.000000', 'consum', 0.0216, 'lps'),
	(434579, 125, '2015-03-01 00:25:20.000000', 'consum', 0.0218, 'lps'),
	(434580, 125, '2015-03-01 00:25:21.000000', 'consum', 0.0215, 'lps'),
	(434581, 125, '2015-03-01 00:25:22.000000', 'consum', 0.0211, 'lps'),
	(434582, 125, '2015-03-01 00:25:23.000000', 'consum', 0.0219, 'lps'),
	(434583, 125, '2015-03-01 00:25:24.000000', 'consum', 0.0216, 'lps'),
	(434584, 125, '2015-03-01 00:25:25.000000', 'consum', 0.0214, 'lps'),
	(434585, 125, '2015-03-01 00:25:26.000000', 'consum', 0.0212, 'lps'),
	(434586, 125, '2015-03-01 00:25:27.000000', 'consum', 0.0225, 'lps'),
	(434587, 125, '2015-03-01 00:25:28.000000', 'consum', 0.0212, 'lps'),
	(434588, 125, '2015-03-01 00:25:29.000000', 'consum', 0.0211, 'lps'),
	(434589, 125, '2015-03-01 00:25:30.000000', 'consum', 0.0210, 'lps'),
	(434590, 125, '2015-03-01 00:25:31.000000', 'consum', 0.0224, 'lps'),
	(434591, 125, '2015-03-01 00:25:32.000000', 'consum', 0.0212, 'lps'),
	(434592, 125, '2015-03-01 00:25:33.000000', 'consum', 0.0212, 'lps'),
	(434593, 125, '2015-03-01 00:25:34.000000', 'consum', 0.0216, 'lps'),
	(434594, 125, '2015-03-01 00:25:35.000000', 'consum', 0.0218, 'lps'),
	(434595, 125, '2015-03-01 00:25:36.000000', 'consum', 0.0213, 'lps'),
	(434596, 125, '2015-03-01 00:25:37.000000', 'consum', 0.0218, 'lps'),
	(434597, 125, '2015-03-01 00:25:38.000000', 'consum', 0.0210, 'lps'),
	(434598, 125, '2015-03-01 00:25:39.000000', 'consum', 0.0221, 'lps'),
	(434599, 125, '2015-03-01 00:25:40.000000', 'consum', 0.0215, 'lps'),
	(434600, 125, '2015-03-01 00:25:41.000000', 'consum', 0.0218, 'lps'),
	(434601, 125, '2015-03-01 00:25:42.000000', 'consum', 0.0218, 'lps'),
	(434602, 125, '2015-03-01 00:25:43.000000', 'consum', 0.0226, 'lps'),
	(434603, 125, '2015-03-01 00:25:44.000000', 'consum', 0.0215, 'lps'),
	(434604, 125, '2015-03-01 00:25:45.000000', 'consum', 0.0222, 'lps'),
	(434605, 125, '2015-03-01 00:25:46.000000', 'consum', 0.0222, 'lps'),
	(434606, 125, '2015-03-01 00:25:47.000000', 'consum', 0.0216, 'lps'),
	(434607, 125, '2015-03-01 00:25:48.000000', 'consum', 0.0224, 'lps'),
	(434608, 125, '2015-03-01 00:25:49.000000', 'consum', 0.0212, 'lps'),
	(434609, 125, '2015-03-01 00:25:50.000000', 'consum', 0.0210, 'lps'),
	(434610, 125, '2015-03-01 00:25:51.000000', 'consum', 0.0224, 'lps'),
	(434611, 125, '2015-03-01 00:25:52.000000', 'consum', 0.0210, 'lps'),
	(434612, 125, '2015-03-01 00:25:53.000000', 'consum', 0.0221, 'lps'),
	(434613, 125, '2015-03-01 00:25:54.000000', 'consum', 0.0216, 'lps'),
	(434614, 125, '2015-03-01 00:25:55.000000', 'consum', 0.0224, 'lps'),
	(434615, 125, '2015-03-01 00:25:56.000000', 'consum', 0.0210, 'lps'),
	(434616, 125, '2015-03-01 00:25:57.000000', 'consum', 0.0219, 'lps'),
	(434617, 125, '2015-03-01 00:25:58.000000', 'consum', 0.0221, 'lps'),
	(434618, 125, '2015-03-01 00:25:59.000000', 'consum', 0.0223, 'lps'),
	(434619, 125, '2015-03-01 00:26:00.000000', 'consum', 0.0224, 'lps'),
	(434620, 125, '2015-03-01 00:26:01.000000', 'consum', 0.0224, 'lps'),
	(434621, 125, '2015-03-01 00:26:02.000000', 'consum', 0.0223, 'lps'),
	(434622, 125, '2015-03-01 00:26:03.000000', 'consum', 0.0218, 'lps'),
	(434623, 125, '2015-03-01 00:26:04.000000', 'consum', 0.0226, 'lps'),
	(434624, 125, '2015-03-01 00:26:05.000000', 'consum', 0.0216, 'lps'),
	(434625, 125, '2015-03-01 00:26:06.000000', 'consum', 0.0211, 'lps'),
	(434626, 125, '2015-03-01 00:26:07.000000', 'consum', 0.0214, 'lps'),
	(434627, 125, '2015-03-01 00:26:08.000000', 'consum', 0.0211, 'lps'),
	(434628, 125, '2015-03-01 00:26:09.000000', 'consum', 0.0219, 'lps'),
	(434629, 125, '2015-03-01 00:26:10.000000', 'consum', 0.0218, 'lps'),
	(434630, 125, '2015-03-01 00:26:11.000000', 'consum', 0.0225, 'lps'),
	(434631, 125, '2015-03-01 00:26:12.000000', 'consum', 0.0211, 'lps'),
	(434632, 125, '2015-03-01 00:26:13.000000', 'consum', 0.0220, 'lps'),
	(434633, 125, '2015-03-01 00:26:14.000000', 'consum', 0.0225, 'lps'),
	(434634, 125, '2015-03-01 00:26:15.000000', 'consum', 0.0222, 'lps'),
	(434635, 125, '2015-03-01 00:26:16.000000', 'consum', 0.0224, 'lps'),
	(434636, 125, '2015-03-01 00:26:17.000000', 'consum', 0.0210, 'lps'),
	(434637, 125, '2015-03-01 00:26:18.000000', 'consum', 0.0218, 'lps'),
	(434638, 125, '2015-03-01 00:26:19.000000', 'consum', 0.0220, 'lps'),
	(434639, 125, '2015-03-01 00:26:20.000000', 'consum', 0.0217, 'lps'),
	(434640, 125, '2015-03-01 00:26:21.000000', 'consum', 0.0218, 'lps'),
	(434641, 125, '2015-03-01 00:26:22.000000', 'consum', 0.0213, 'lps'),
	(434642, 125, '2015-03-01 00:26:23.000000', 'consum', 0.0216, 'lps'),
	(434643, 125, '2015-03-01 00:26:24.000000', 'consum', 0.0217, 'lps'),
	(434644, 125, '2015-03-01 00:26:25.000000', 'consum', 0.0225, 'lps'),
	(434645, 125, '2015-03-01 00:26:26.000000', 'consum', 0.0213, 'lps'),
	(434646, 125, '2015-03-01 00:26:27.000000', 'consum', 0.0217, 'lps'),
	(434647, 125, '2015-03-01 00:26:28.000000', 'consum', 0.0218, 'lps'),
	(434648, 125, '2015-03-01 00:26:29.000000', 'consum', 0.0214, 'lps'),
	(434649, 125, '2015-03-01 00:26:30.000000', 'consum', 0.0221, 'lps'),
	(434650, 125, '2015-03-01 00:26:31.000000', 'consum', 0.0222, 'lps'),
	(434651, 125, '2015-03-01 00:26:32.000000', 'consum', 0.0220, 'lps'),
	(434652, 125, '2015-03-01 00:26:33.000000', 'consum', 0.0225, 'lps'),
	(434653, 125, '2015-03-01 00:26:34.000000', 'consum', 0.0220, 'lps'),
	(434654, 125, '2015-03-01 00:26:35.000000', 'consum', 0.0216, 'lps'),
	(434655, 125, '2015-03-01 00:26:36.000000', 'consum', 0.0226, 'lps'),
	(434656, 125, '2015-03-01 00:26:37.000000', 'consum', 0.0221, 'lps'),
	(434657, 125, '2015-03-01 00:26:38.000000', 'consum', 0.0221, 'lps'),
	(434658, 125, '2015-03-01 00:26:39.000000', 'consum', 0.0213, 'lps'),
	(434659, 125, '2015-03-01 00:26:40.000000', 'consum', 0.0226, 'lps'),
	(434660, 125, '2015-03-01 00:26:41.000000', 'consum', 0.0213, 'lps'),
	(434661, 125, '2015-03-01 00:26:42.000000', 'consum', 0.0212, 'lps'),
	(434662, 125, '2015-03-01 00:26:43.000000', 'consum', 0.0213, 'lps'),
	(434663, 125, '2015-03-01 00:26:44.000000', 'consum', 0.0219, 'lps'),
	(434664, 125, '2015-03-01 00:26:45.000000', 'consum', 0.0213, 'lps'),
	(434665, 125, '2015-03-01 00:26:46.000000', 'consum', 0.0214, 'lps'),
	(434666, 125, '2015-03-01 00:26:47.000000', 'consum', 0.0221, 'lps'),
	(434667, 125, '2015-03-01 00:26:48.000000', 'consum', 0.0218, 'lps'),
	(434668, 125, '2015-03-01 00:26:49.000000', 'consum', 0.0220, 'lps'),
	(434669, 125, '2015-03-01 00:26:50.000000', 'consum', 0.0220, 'lps'),
	(434670, 125, '2015-03-01 00:26:51.000000', 'consum', 0.0212, 'lps'),
	(434671, 125, '2015-03-01 00:26:52.000000', 'consum', 0.0225, 'lps'),
	(434672, 125, '2015-03-01 00:26:53.000000', 'consum', 0.0210, 'lps'),
	(434673, 125, '2015-03-01 00:26:54.000000', 'consum', 0.0218, 'lps'),
	(434674, 125, '2015-03-01 00:26:55.000000', 'consum', 0.0218, 'lps'),
	(434675, 125, '2015-03-01 00:26:56.000000', 'consum', 0.0225, 'lps'),
	(434676, 125, '2015-03-01 00:26:57.000000', 'consum', 0.0212, 'lps'),
	(434677, 125, '2015-03-01 00:26:58.000000', 'consum', 0.0224, 'lps'),
	(434678, 125, '2015-03-01 00:26:59.000000', 'consum', 0.0223, 'lps'),
	(434679, 125, '2015-03-01 00:27:00.000000', 'consum', 0.0220, 'lps'),
	(434680, 125, '2015-03-01 00:27:01.000000', 'consum', 0.0219, 'lps'),
	(434681, 125, '2015-03-01 00:27:02.000000', 'consum', 0.0224, 'lps'),
	(434682, 125, '2015-03-01 00:27:03.000000', 'consum', 0.0221, 'lps'),
	(434683, 125, '2015-03-01 00:27:04.000000', 'consum', 0.0222, 'lps'),
	(434684, 125, '2015-03-01 00:27:05.000000', 'consum', 0.0223, 'lps'),
	(434685, 125, '2015-03-01 00:27:06.000000', 'consum', 0.0223, 'lps'),
	(434686, 125, '2015-03-01 00:27:07.000000', 'consum', 0.0218, 'lps'),
	(434687, 125, '2015-03-01 00:27:08.000000', 'consum', 0.0213, 'lps'),
	(434688, 125, '2015-03-01 00:27:09.000000', 'consum', 0.0218, 'lps'),
	(434689, 125, '2015-03-01 00:27:10.000000', 'consum', 0.0226, 'lps'),
	(434690, 125, '2015-03-01 00:27:11.000000', 'consum', 0.0214, 'lps'),
	(434691, 125, '2015-03-01 00:27:12.000000', 'consum', 0.0215, 'lps'),
	(434692, 125, '2015-03-01 00:27:13.000000', 'consum', 0.0226, 'lps'),
	(434693, 125, '2015-03-01 00:27:14.000000', 'consum', 0.0224, 'lps'),
	(434694, 125, '2015-03-01 00:27:15.000000', 'consum', 0.0214, 'lps'),
	(434695, 125, '2015-03-01 00:27:16.000000', 'consum', 0.0222, 'lps'),
	(434696, 125, '2015-03-01 00:27:17.000000', 'consum', 0.0226, 'lps'),
	(434697, 125, '2015-03-01 00:27:18.000000', 'consum', 0.0219, 'lps'),
	(434698, 125, '2015-03-01 00:27:19.000000', 'consum', 0.0225, 'lps'),
	(434699, 125, '2015-03-01 00:27:20.000000', 'consum', 0.0225, 'lps'),
	(434700, 125, '2015-03-01 00:27:21.000000', 'consum', 0.0224, 'lps'),
	(434701, 125, '2015-03-01 00:27:22.000000', 'consum', 0.0218, 'lps'),
	(434702, 125, '2015-03-01 00:27:23.000000', 'consum', 0.0224, 'lps'),
	(434703, 125, '2015-03-01 00:27:24.000000', 'consum', 0.0225, 'lps'),
	(434704, 125, '2015-03-01 00:27:25.000000', 'consum', 0.0210, 'lps'),
	(434705, 125, '2015-03-01 00:27:26.000000', 'consum', 0.0215, 'lps'),
	(434706, 125, '2015-03-01 00:27:27.000000', 'consum', 0.0219, 'lps'),
	(434707, 125, '2015-03-01 00:27:28.000000', 'consum', 0.0222, 'lps'),
	(434708, 125, '2015-03-01 00:27:29.000000', 'consum', 0.0212, 'lps'),
	(434709, 125, '2015-03-01 00:27:30.000000', 'consum', 0.0218, 'lps'),
	(434710, 125, '2015-03-01 00:27:31.000000', 'consum', 0.0210, 'lps'),
	(434711, 125, '2015-03-01 00:27:32.000000', 'consum', 0.0220, 'lps'),
	(434712, 125, '2015-03-01 00:27:33.000000', 'consum', 0.0210, 'lps'),
	(434713, 125, '2015-03-01 00:27:34.000000', 'consum', 0.0214, 'lps'),
	(434714, 125, '2015-03-01 00:27:35.000000', 'consum', 0.0214, 'lps'),
	(434715, 125, '2015-03-01 00:27:36.000000', 'consum', 0.0218, 'lps'),
	(434716, 125, '2015-03-01 00:27:37.000000', 'consum', 0.0223, 'lps'),
	(434717, 125, '2015-03-01 00:27:38.000000', 'consum', 0.0216, 'lps'),
	(434718, 125, '2015-03-01 00:27:39.000000', 'consum', 0.0218, 'lps'),
	(434719, 125, '2015-03-01 00:27:40.000000', 'consum', 0.0214, 'lps'),
	(434720, 125, '2015-03-01 00:27:41.000000', 'consum', 0.0210, 'lps'),
	(434721, 125, '2015-03-01 00:27:42.000000', 'consum', 0.0213, 'lps'),
	(434722, 125, '2015-03-01 00:27:43.000000', 'consum', 0.0226, 'lps'),
	(434723, 125, '2015-03-01 00:27:44.000000', 'consum', 0.0213, 'lps'),
	(434724, 125, '2015-03-01 00:27:45.000000', 'consum', 0.0213, 'lps'),
	(434725, 125, '2015-03-01 00:27:46.000000', 'consum', 0.0216, 'lps'),
	(434726, 125, '2015-03-01 00:27:47.000000', 'consum', 0.0214, 'lps'),
	(434727, 125, '2015-03-01 00:27:48.000000', 'consum', 0.0212, 'lps'),
	(434728, 125, '2015-03-01 00:27:49.000000', 'consum', 0.0224, 'lps'),
	(434729, 125, '2015-03-01 00:27:50.000000', 'consum', 0.0210, 'lps'),
	(434730, 125, '2015-03-01 00:27:51.000000', 'consum', 0.0217, 'lps'),
	(434731, 125, '2015-03-01 00:27:52.000000', 'consum', 0.0214, 'lps'),
	(434732, 125, '2015-03-01 00:27:53.000000', 'consum', 0.0224, 'lps'),
	(434733, 125, '2015-03-01 00:27:54.000000', 'consum', 0.0217, 'lps'),
	(434734, 125, '2015-03-01 00:27:55.000000', 'consum', 0.0220, 'lps'),
	(434735, 125, '2015-03-01 00:27:56.000000', 'consum', 0.0225, 'lps'),
	(434736, 125, '2015-03-01 00:27:57.000000', 'consum', 0.0218, 'lps'),
	(434737, 125, '2015-03-01 00:27:58.000000', 'consum', 0.0226, 'lps'),
	(434738, 125, '2015-03-01 00:27:59.000000', 'consum', 0.0213, 'lps'),
	(434739, 125, '2015-03-01 00:28:00.000000', 'consum', 0.0210, 'lps'),
	(434740, 125, '2015-03-01 00:28:01.000000', 'consum', 0.0222, 'lps'),
	(434741, 125, '2015-03-01 00:28:02.000000', 'consum', 0.0220, 'lps'),
	(434742, 125, '2015-03-01 00:28:03.000000', 'consum', 0.0221, 'lps'),
	(434743, 125, '2015-03-01 00:28:04.000000', 'consum', 0.0221, 'lps'),
	(434744, 125, '2015-03-01 00:28:05.000000', 'consum', 0.0214, 'lps'),
	(434745, 125, '2015-03-01 00:28:06.000000', 'consum', 0.0216, 'lps'),
	(434746, 125, '2015-03-01 00:28:07.000000', 'consum', 0.0210, 'lps'),
	(434747, 125, '2015-03-01 00:28:08.000000', 'consum', 0.0225, 'lps'),
	(434748, 125, '2015-03-01 00:28:09.000000', 'consum', 0.0219, 'lps'),
	(434749, 125, '2015-03-01 00:28:10.000000', 'consum', 0.0212, 'lps'),
	(434750, 125, '2015-03-01 00:28:11.000000', 'consum', 0.0210, 'lps'),
	(434751, 125, '2015-03-01 00:28:12.000000', 'consum', 0.0222, 'lps'),
	(434752, 125, '2015-03-01 00:28:13.000000', 'consum', 0.0219, 'lps'),
	(434753, 125, '2015-03-01 00:28:14.000000', 'consum', 0.0220, 'lps'),
	(434754, 125, '2015-03-01 00:28:15.000000', 'consum', 0.0218, 'lps'),
	(434755, 125, '2015-03-01 00:28:16.000000', 'consum', 0.0220, 'lps'),
	(434756, 125, '2015-03-01 00:28:17.000000', 'consum', 0.0219, 'lps'),
	(434757, 125, '2015-03-01 00:28:18.000000', 'consum', 0.0225, 'lps'),
	(434758, 125, '2015-03-01 00:28:19.000000', 'consum', 0.0223, 'lps'),
	(434759, 125, '2015-03-01 00:28:20.000000', 'consum', 0.0217, 'lps'),
	(434760, 125, '2015-03-01 00:28:21.000000', 'consum', 0.0220, 'lps'),
	(434761, 125, '2015-03-01 00:28:22.000000', 'consum', 0.0223, 'lps'),
	(434762, 125, '2015-03-01 00:28:23.000000', 'consum', 0.0214, 'lps'),
	(434763, 125, '2015-03-01 00:28:24.000000', 'consum', 0.0224, 'lps'),
	(434764, 125, '2015-03-01 00:28:25.000000', 'consum', 0.0217, 'lps'),
	(434765, 125, '2015-03-01 00:28:26.000000', 'consum', 0.0221, 'lps'),
	(434766, 125, '2015-03-01 00:28:27.000000', 'consum', 0.0212, 'lps'),
	(434767, 125, '2015-03-01 00:28:28.000000', 'consum', 0.0220, 'lps'),
	(434768, 125, '2015-03-01 00:28:29.000000', 'consum', 0.0222, 'lps'),
	(434769, 125, '2015-03-01 00:28:30.000000', 'consum', 0.0223, 'lps'),
	(434770, 125, '2015-03-01 00:28:31.000000', 'consum', 0.0223, 'lps'),
	(434771, 125, '2015-03-01 00:28:32.000000', 'consum', 0.0218, 'lps'),
	(434772, 125, '2015-03-01 00:28:33.000000', 'consum', 0.0211, 'lps'),
	(434773, 125, '2015-03-01 00:28:34.000000', 'consum', 0.0224, 'lps'),
	(434774, 125, '2015-03-01 00:28:35.000000', 'consum', 0.0212, 'lps'),
	(434775, 125, '2015-03-01 00:28:36.000000', 'consum', 0.0212, 'lps'),
	(434776, 125, '2015-03-01 00:28:37.000000', 'consum', 0.0215, 'lps'),
	(434777, 125, '2015-03-01 00:28:38.000000', 'consum', 0.0213, 'lps'),
	(434778, 125, '2015-03-01 00:28:39.000000', 'consum', 0.0225, 'lps'),
	(434779, 125, '2015-03-01 00:28:40.000000', 'consum', 0.0226, 'lps'),
	(434780, 125, '2015-03-01 00:28:41.000000', 'consum', 0.0213, 'lps'),
	(434781, 125, '2015-03-01 00:28:42.000000', 'consum', 0.0213, 'lps'),
	(434782, 125, '2015-03-01 00:28:43.000000', 'consum', 0.0214, 'lps'),
	(434783, 125, '2015-03-01 00:28:44.000000', 'consum', 0.0223, 'lps'),
	(434784, 125, '2015-03-01 00:28:45.000000', 'consum', 0.0210, 'lps'),
	(434785, 125, '2015-03-01 00:28:46.000000', 'consum', 0.0225, 'lps'),
	(434786, 125, '2015-03-01 00:28:47.000000', 'consum', 0.0215, 'lps'),
	(434787, 125, '2015-03-01 00:28:48.000000', 'consum', 0.0224, 'lps'),
	(434788, 125, '2015-03-01 00:28:49.000000', 'consum', 0.0216, 'lps'),
	(434789, 125, '2015-03-01 00:28:50.000000', 'consum', 0.0217, 'lps'),
	(434790, 125, '2015-03-01 00:28:51.000000', 'consum', 0.0225, 'lps'),
	(434791, 125, '2015-03-01 00:28:52.000000', 'consum', 0.0214, 'lps'),
	(434792, 125, '2015-03-01 00:28:53.000000', 'consum', 0.0218, 'lps'),
	(434793, 125, '2015-03-01 00:28:54.000000', 'consum', 0.0224, 'lps'),
	(434794, 125, '2015-03-01 00:28:55.000000', 'consum', 0.0220, 'lps'),
	(434795, 125, '2015-03-01 00:28:56.000000', 'consum', 0.0222, 'lps'),
	(434796, 125, '2015-03-01 00:28:57.000000', 'consum', 0.0220, 'lps'),
	(434797, 125, '2015-03-01 00:28:58.000000', 'consum', 0.0225, 'lps'),
	(434798, 125, '2015-03-01 00:28:59.000000', 'consum', 0.0223, 'lps'),
	(434799, 125, '2015-03-01 00:29:00.000000', 'consum', 0.0211, 'lps'),
	(434800, 125, '2015-03-01 00:29:01.000000', 'consum', 0.0211, 'lps'),
	(434801, 125, '2015-03-01 00:29:02.000000', 'consum', 0.0214, 'lps'),
	(434802, 125, '2015-03-01 00:29:03.000000', 'consum', 0.0210, 'lps'),
	(434803, 125, '2015-03-01 00:29:04.000000', 'consum', 0.0217, 'lps'),
	(434804, 125, '2015-03-01 00:29:05.000000', 'consum', 0.0212, 'lps'),
	(434805, 125, '2015-03-01 00:29:06.000000', 'consum', 0.0214, 'lps'),
	(434806, 125, '2015-03-01 00:29:07.000000', 'consum', 0.0210, 'lps'),
	(434807, 125, '2015-03-01 00:29:08.000000', 'consum', 0.0213, 'lps'),
	(434808, 125, '2015-03-01 00:29:09.000000', 'consum', 0.0210, 'lps'),
	(434809, 125, '2015-03-01 00:29:10.000000', 'consum', 0.0220, 'lps'),
	(434810, 125, '2015-03-01 00:29:11.000000', 'consum', 0.0226, 'lps'),
	(434811, 125, '2015-03-01 00:29:12.000000', 'consum', 0.0210, 'lps'),
	(434812, 125, '2015-03-01 00:29:13.000000', 'consum', 0.0214, 'lps'),
	(434813, 125, '2015-03-01 00:29:14.000000', 'consum', 0.0215, 'lps'),
	(434814, 125, '2015-03-01 00:29:15.000000', 'consum', 0.0220, 'lps'),
	(434815, 125, '2015-03-01 00:29:16.000000', 'consum', 0.0214, 'lps'),
	(434816, 125, '2015-03-01 00:29:17.000000', 'consum', 0.0218, 'lps'),
	(434817, 125, '2015-03-01 00:29:18.000000', 'consum', 0.0219, 'lps'),
	(434818, 125, '2015-03-01 00:29:19.000000', 'consum', 0.0217, 'lps'),
	(434819, 125, '2015-03-01 00:29:20.000000', 'consum', 0.0216, 'lps'),
	(434820, 125, '2015-03-01 00:29:21.000000', 'consum', 0.0222, 'lps'),
	(434821, 125, '2015-03-01 00:29:22.000000', 'consum', 0.0216, 'lps'),
	(434822, 125, '2015-03-01 00:29:23.000000', 'consum', 0.0225, 'lps'),
	(434823, 125, '2015-03-01 00:29:24.000000', 'consum', 0.0213, 'lps'),
	(434824, 125, '2015-03-01 00:29:25.000000', 'consum', 0.0215, 'lps'),
	(434825, 125, '2015-03-01 00:29:26.000000', 'consum', 0.0210, 'lps'),
	(434826, 125, '2015-03-01 00:29:27.000000', 'consum', 0.0211, 'lps'),
	(434827, 125, '2015-03-01 00:29:28.000000', 'consum', 0.0215, 'lps'),
	(434828, 125, '2015-03-01 00:29:29.000000', 'consum', 0.0218, 'lps'),
	(434829, 125, '2015-03-01 00:29:30.000000', 'consum', 0.0217, 'lps'),
	(434830, 125, '2015-03-01 00:29:31.000000', 'consum', 0.0223, 'lps'),
	(434831, 125, '2015-03-01 00:29:32.000000', 'consum', 0.0221, 'lps'),
	(434832, 125, '2015-03-01 00:29:33.000000', 'consum', 0.0225, 'lps'),
	(434833, 125, '2015-03-01 00:29:34.000000', 'consum', 0.0219, 'lps'),
	(434834, 125, '2015-03-01 00:29:35.000000', 'consum', 0.0212, 'lps'),
	(434835, 125, '2015-03-01 00:29:36.000000', 'consum', 0.0225, 'lps'),
	(434836, 125, '2015-03-01 00:29:37.000000', 'consum', 0.0211, 'lps'),
	(434837, 125, '2015-03-01 00:29:38.000000', 'consum', 0.0221, 'lps'),
	(434838, 125, '2015-03-01 00:29:39.000000', 'consum', 0.0213, 'lps'),
	(434839, 125, '2015-03-01 00:29:40.000000', 'consum', 0.0226, 'lps'),
	(434840, 125, '2015-03-01 00:29:41.000000', 'consum', 0.0214, 'lps'),
	(434841, 125, '2015-03-01 00:29:42.000000', 'consum', 0.0216, 'lps'),
	(434842, 125, '2015-03-01 00:29:43.000000', 'consum', 0.0213, 'lps'),
	(434843, 125, '2015-03-01 00:29:44.000000', 'consum', 0.0224, 'lps'),
	(434844, 125, '2015-03-01 00:29:45.000000', 'consum', 0.0219, 'lps'),
	(434845, 125, '2015-03-01 00:29:46.000000', 'consum', 0.0213, 'lps'),
	(434846, 125, '2015-03-01 00:29:47.000000', 'consum', 0.0217, 'lps'),
	(434847, 125, '2015-03-01 00:29:48.000000', 'consum', 0.0217, 'lps'),
	(434848, 125, '2015-03-01 00:29:49.000000', 'consum', 0.0211, 'lps'),
	(434849, 125, '2015-03-01 00:29:50.000000', 'consum', 0.0225, 'lps'),
	(434850, 125, '2015-03-01 00:29:51.000000', 'consum', 0.0216, 'lps'),
	(434851, 125, '2015-03-01 00:29:52.000000', 'consum', 0.0214, 'lps'),
	(434852, 125, '2015-03-01 00:29:53.000000', 'consum', 0.0212, 'lps'),
	(434853, 125, '2015-03-01 00:29:54.000000', 'consum', 0.0225, 'lps'),
	(434854, 125, '2015-03-01 00:29:55.000000', 'consum', 0.0211, 'lps'),
	(434855, 125, '2015-03-01 00:29:56.000000', 'consum', 0.0221, 'lps'),
	(434856, 125, '2015-03-01 00:29:57.000000', 'consum', 0.0214, 'lps'),
	(434857, 125, '2015-03-01 00:29:58.000000', 'consum', 0.0213, 'lps'),
	(434858, 125, '2015-03-01 00:29:59.000000', 'consum', 0.0212, 'lps'),
	(434859, 125, '2015-03-01 00:30:00.000000', 'consum', 0.0213, 'lps'),
	(434860, 125, '2015-03-01 00:30:01.000000', 'consum', 0.0220, 'lps'),
	(434861, 125, '2015-03-01 00:30:02.000000', 'consum', 0.0219, 'lps'),
	(434862, 125, '2015-03-01 00:30:03.000000', 'consum', 0.0223, 'lps'),
	(434863, 125, '2015-03-01 00:30:04.000000', 'consum', 0.0217, 'lps'),
	(434864, 125, '2015-03-01 00:30:05.000000', 'consum', 0.0224, 'lps'),
	(434865, 125, '2015-03-01 00:30:06.000000', 'consum', 0.0223, 'lps'),
	(434866, 125, '2015-03-01 00:30:07.000000', 'consum', 0.0217, 'lps'),
	(434867, 125, '2015-03-01 00:30:08.000000', 'consum', 0.0224, 'lps'),
	(434868, 125, '2015-03-01 00:30:09.000000', 'consum', 0.0226, 'lps'),
	(434869, 125, '2015-03-01 00:30:10.000000', 'consum', 0.0214, 'lps'),
	(434870, 125, '2015-03-01 00:30:11.000000', 'consum', 0.0219, 'lps'),
	(434871, 125, '2015-03-01 00:30:12.000000', 'consum', 0.0223, 'lps'),
	(434872, 125, '2015-03-01 00:30:13.000000', 'consum', 0.0215, 'lps'),
	(434873, 125, '2015-03-01 00:30:14.000000', 'consum', 0.0214, 'lps'),
	(434874, 125, '2015-03-01 00:30:15.000000', 'consum', 0.0214, 'lps'),
	(434875, 125, '2015-03-01 00:30:16.000000', 'consum', 0.0219, 'lps'),
	(434876, 125, '2015-03-01 00:30:17.000000', 'consum', 0.0210, 'lps'),
	(434877, 125, '2015-03-01 00:30:18.000000', 'consum', 0.0218, 'lps'),
	(434878, 125, '2015-03-01 00:30:19.000000', 'consum', 0.0214, 'lps'),
	(434879, 125, '2015-03-01 00:30:20.000000', 'consum', 0.0226, 'lps'),
	(434880, 125, '2015-03-01 00:30:21.000000', 'consum', 0.0226, 'lps'),
	(434881, 125, '2015-03-01 00:30:22.000000', 'consum', 0.0210, 'lps'),
	(434882, 125, '2015-03-01 00:30:23.000000', 'consum', 0.0211, 'lps'),
	(434883, 125, '2015-03-01 00:30:24.000000', 'consum', 0.0219, 'lps'),
	(434884, 125, '2015-03-01 00:30:25.000000', 'consum', 0.0215, 'lps'),
	(434885, 125, '2015-03-01 00:30:26.000000', 'consum', 0.0212, 'lps'),
	(434886, 125, '2015-03-01 00:30:27.000000', 'consum', 0.0219, 'lps'),
	(434887, 125, '2015-03-01 00:30:28.000000', 'consum', 0.0219, 'lps'),
	(434888, 125, '2015-03-01 00:30:29.000000', 'consum', 0.0210, 'lps'),
	(434889, 125, '2015-03-01 00:30:30.000000', 'consum', 0.0216, 'lps'),
	(434890, 125, '2015-03-01 00:30:31.000000', 'consum', 0.0225, 'lps'),
	(434891, 125, '2015-03-01 00:30:32.000000', 'consum', 0.0217, 'lps'),
	(434892, 125, '2015-03-01 00:30:33.000000', 'consum', 0.0215, 'lps'),
	(434893, 125, '2015-03-01 00:30:34.000000', 'consum', 0.0215, 'lps'),
	(434894, 125, '2015-03-01 00:30:35.000000', 'consum', 0.0223, 'lps'),
	(434895, 125, '2015-03-01 00:30:36.000000', 'consum', 0.0223, 'lps'),
	(434896, 125, '2015-03-01 00:30:37.000000', 'consum', 0.0221, 'lps'),
	(434897, 125, '2015-03-01 00:30:38.000000', 'consum', 0.0210, 'lps'),
	(434898, 125, '2015-03-01 00:30:39.000000', 'consum', 0.0212, 'lps'),
	(434899, 125, '2015-03-01 00:30:40.000000', 'consum', 0.0218, 'lps'),
	(434900, 125, '2015-03-01 00:30:41.000000', 'consum', 0.0212, 'lps'),
	(434901, 125, '2015-03-01 00:30:42.000000', 'consum', 0.0212, 'lps'),
	(434902, 125, '2015-03-01 00:30:43.000000', 'consum', 0.0216, 'lps'),
	(434903, 125, '2015-03-01 00:30:44.000000', 'consum', 0.0216, 'lps'),
	(434904, 125, '2015-03-01 00:30:45.000000', 'consum', 0.0222, 'lps'),
	(434905, 125, '2015-03-01 00:30:46.000000', 'consum', 0.0221, 'lps'),
	(434906, 125, '2015-03-01 00:30:47.000000', 'consum', 0.0210, 'lps'),
	(434907, 125, '2015-03-01 00:30:48.000000', 'consum', 0.0213, 'lps'),
	(434908, 125, '2015-03-01 00:30:49.000000', 'consum', 0.0224, 'lps'),
	(434909, 125, '2015-03-01 00:30:50.000000', 'consum', 0.0221, 'lps'),
	(434910, 125, '2015-03-01 00:30:51.000000', 'consum', 0.0224, 'lps'),
	(434911, 125, '2015-03-01 00:30:52.000000', 'consum', 0.0214, 'lps'),
	(434912, 125, '2015-03-01 00:30:53.000000', 'consum', 0.0222, 'lps'),
	(434913, 125, '2015-03-01 00:30:54.000000', 'consum', 0.0223, 'lps'),
	(434914, 125, '2015-03-01 00:30:55.000000', 'consum', 0.0225, 'lps'),
	(434915, 125, '2015-03-01 00:30:56.000000', 'consum', 0.0212, 'lps'),
	(434916, 125, '2015-03-01 00:30:57.000000', 'consum', 0.0210, 'lps'),
	(434917, 125, '2015-03-01 00:30:58.000000', 'consum', 0.0221, 'lps'),
	(434918, 125, '2015-03-01 00:30:59.000000', 'consum', 0.0213, 'lps'),
	(434919, 125, '2015-03-01 00:31:00.000000', 'consum', 0.0226, 'lps'),
	(434920, 125, '2015-03-01 00:31:01.000000', 'consum', 0.0214, 'lps'),
	(434921, 125, '2015-03-01 00:31:02.000000', 'consum', 0.0216, 'lps'),
	(434922, 125, '2015-03-01 00:31:03.000000', 'consum', 0.0210, 'lps'),
	(434923, 125, '2015-03-01 00:31:04.000000', 'consum', 0.0213, 'lps'),
	(434924, 125, '2015-03-01 00:31:05.000000', 'consum', 0.0223, 'lps'),
	(434925, 125, '2015-03-01 00:31:06.000000', 'consum', 0.0215, 'lps'),
	(434926, 125, '2015-03-01 00:31:07.000000', 'consum', 0.0214, 'lps'),
	(434927, 125, '2015-03-01 00:31:08.000000', 'consum', 0.0216, 'lps'),
	(434928, 125, '2015-03-01 00:31:09.000000', 'consum', 0.0212, 'lps'),
	(434929, 125, '2015-03-01 00:31:10.000000', 'consum', 0.0218, 'lps'),
	(434930, 125, '2015-03-01 00:31:11.000000', 'consum', 0.0213, 'lps'),
	(434931, 125, '2015-03-01 00:31:12.000000', 'consum', 0.0215, 'lps'),
	(434932, 125, '2015-03-01 00:31:13.000000', 'consum', 0.0212, 'lps'),
	(434933, 125, '2015-03-01 00:31:14.000000', 'consum', 0.0222, 'lps'),
	(434934, 125, '2015-03-01 00:31:15.000000', 'consum', 0.0214, 'lps'),
	(434935, 125, '2015-03-01 00:31:16.000000', 'consum', 0.0213, 'lps'),
	(434936, 125, '2015-03-01 00:31:17.000000', 'consum', 0.0213, 'lps'),
	(434937, 125, '2015-03-01 00:31:18.000000', 'consum', 0.0215, 'lps'),
	(434938, 125, '2015-03-01 00:31:19.000000', 'consum', 0.0226, 'lps'),
	(434939, 125, '2015-03-01 00:31:20.000000', 'consum', 0.0224, 'lps'),
	(434940, 125, '2015-03-01 00:31:21.000000', 'consum', 0.0216, 'lps'),
	(434941, 125, '2015-03-01 00:31:22.000000', 'consum', 0.0216, 'lps'),
	(434942, 125, '2015-03-01 00:31:23.000000', 'consum', 0.0221, 'lps'),
	(434943, 125, '2015-03-01 00:31:24.000000', 'consum', 0.0213, 'lps'),
	(434944, 125, '2015-03-01 00:31:25.000000', 'consum', 0.0226, 'lps'),
	(434945, 125, '2015-03-01 00:31:26.000000', 'consum', 0.0215, 'lps'),
	(434946, 125, '2015-03-01 00:31:27.000000', 'consum', 0.0220, 'lps'),
	(434947, 125, '2015-03-01 00:31:28.000000', 'consum', 0.0212, 'lps'),
	(434948, 125, '2015-03-01 00:31:29.000000', 'consum', 0.0225, 'lps'),
	(434949, 125, '2015-03-01 00:31:30.000000', 'consum', 0.0211, 'lps'),
	(434950, 125, '2015-03-01 00:31:31.000000', 'consum', 0.0223, 'lps'),
	(434951, 125, '2015-03-01 00:31:32.000000', 'consum', 0.0223, 'lps'),
	(434952, 125, '2015-03-01 00:31:33.000000', 'consum', 0.0216, 'lps'),
	(434953, 125, '2015-03-01 00:31:34.000000', 'consum', 0.0219, 'lps'),
	(434954, 125, '2015-03-01 00:31:35.000000', 'consum', 0.0221, 'lps'),
	(434955, 125, '2015-03-01 00:31:36.000000', 'consum', 0.0222, 'lps'),
	(434956, 125, '2015-03-01 00:31:37.000000', 'consum', 0.0222, 'lps'),
	(434957, 125, '2015-03-01 00:31:38.000000', 'consum', 0.0218, 'lps'),
	(434958, 125, '2015-03-01 00:31:39.000000', 'consum', 0.0211, 'lps'),
	(434959, 125, '2015-03-01 00:31:40.000000', 'consum', 0.0211, 'lps'),
	(434960, 125, '2015-03-01 00:31:41.000000', 'consum', 0.0213, 'lps'),
	(434961, 125, '2015-03-01 00:31:42.000000', 'consum', 0.0223, 'lps'),
	(434962, 125, '2015-03-01 00:31:43.000000', 'consum', 0.0214, 'lps'),
	(434963, 125, '2015-03-01 00:31:44.000000', 'consum', 0.0210, 'lps'),
	(434964, 125, '2015-03-01 00:31:45.000000', 'consum', 0.0215, 'lps'),
	(434965, 125, '2015-03-01 00:31:46.000000', 'consum', 0.0218, 'lps'),
	(434966, 125, '2015-03-01 00:31:47.000000', 'consum', 0.0219, 'lps'),
	(434967, 125, '2015-03-01 00:31:48.000000', 'consum', 0.0214, 'lps'),
	(434968, 125, '2015-03-01 00:31:49.000000', 'consum', 0.0221, 'lps'),
	(434969, 125, '2015-03-01 00:31:50.000000', 'consum', 0.0220, 'lps'),
	(434970, 125, '2015-03-01 00:31:51.000000', 'consum', 0.0225, 'lps'),
	(434971, 125, '2015-03-01 00:31:52.000000', 'consum', 0.0224, 'lps'),
	(434972, 125, '2015-03-01 00:31:53.000000', 'consum', 0.0220, 'lps'),
	(434973, 125, '2015-03-01 00:31:54.000000', 'consum', 0.0216, 'lps'),
	(434974, 125, '2015-03-01 00:31:55.000000', 'consum', 0.0210, 'lps'),
	(434975, 125, '2015-03-01 00:31:56.000000', 'consum', 0.0212, 'lps'),
	(434976, 125, '2015-03-01 00:31:57.000000', 'consum', 0.0219, 'lps'),
	(434977, 125, '2015-03-01 00:31:58.000000', 'consum', 0.0215, 'lps'),
	(434978, 125, '2015-03-01 00:31:59.000000', 'consum', 0.0210, 'lps'),
	(434979, 125, '2015-03-01 00:32:00.000000', 'consum', 0.0212, 'lps'),
	(434980, 125, '2015-03-01 00:32:01.000000', 'consum', 0.0219, 'lps'),
	(434981, 125, '2015-03-01 00:32:02.000000', 'consum', 0.0215, 'lps'),
	(434982, 125, '2015-03-01 00:32:03.000000', 'consum', 0.0211, 'lps'),
	(434983, 125, '2015-03-01 00:32:04.000000', 'consum', 0.0215, 'lps'),
	(434984, 125, '2015-03-01 00:32:05.000000', 'consum', 0.0217, 'lps'),
	(434985, 125, '2015-03-01 00:32:06.000000', 'consum', 0.0213, 'lps'),
	(434986, 125, '2015-03-01 00:32:07.000000', 'consum', 0.0220, 'lps'),
	(434987, 125, '2015-03-01 00:32:08.000000', 'consum', 0.0218, 'lps'),
	(434988, 125, '2015-03-01 00:32:09.000000', 'consum', 0.0220, 'lps'),
	(434989, 125, '2015-03-01 00:32:10.000000', 'consum', 0.0221, 'lps'),
	(434990, 125, '2015-03-01 00:32:11.000000', 'consum', 0.0217, 'lps'),
	(434991, 125, '2015-03-01 00:32:12.000000', 'consum', 0.0211, 'lps'),
	(434992, 125, '2015-03-01 00:32:13.000000', 'consum', 0.0213, 'lps'),
	(434993, 125, '2015-03-01 00:32:14.000000', 'consum', 0.0224, 'lps'),
	(434994, 125, '2015-03-01 00:32:15.000000', 'consum', 0.0219, 'lps'),
	(434995, 125, '2015-03-01 00:32:16.000000', 'consum', 0.0215, 'lps'),
	(434996, 125, '2015-03-01 00:32:17.000000', 'consum', 0.0224, 'lps'),
	(434997, 125, '2015-03-01 00:32:18.000000', 'consum', 0.0213, 'lps'),
	(434998, 125, '2015-03-01 00:32:19.000000', 'consum', 0.0219, 'lps'),
	(434999, 125, '2015-03-01 00:32:20.000000', 'consum', 0.0211, 'lps'),
	(435000, 125, '2015-03-01 00:32:21.000000', 'consum', 0.0225, 'lps'),
	(435001, 125, '2015-03-01 00:32:22.000000', 'consum', 0.0214, 'lps'),
	(435002, 125, '2015-03-01 00:32:23.000000', 'consum', 0.0221, 'lps'),
	(435003, 125, '2015-03-01 00:32:24.000000', 'consum', 0.0219, 'lps'),
	(435004, 125, '2015-03-01 00:32:25.000000', 'consum', 0.0220, 'lps'),
	(435005, 125, '2015-03-01 00:32:26.000000', 'consum', 0.0217, 'lps'),
	(435006, 125, '2015-03-01 00:32:27.000000', 'consum', 0.0218, 'lps'),
	(435007, 125, '2015-03-01 00:32:28.000000', 'consum', 0.0210, 'lps'),
	(435008, 125, '2015-03-01 00:32:29.000000', 'consum', 0.0222, 'lps'),
	(435009, 125, '2015-03-01 00:32:30.000000', 'consum', 0.0217, 'lps'),
	(435010, 125, '2015-03-01 00:32:31.000000', 'consum', 0.0212, 'lps'),
	(435011, 125, '2015-03-01 00:32:32.000000', 'consum', 0.0216, 'lps'),
	(435012, 125, '2015-03-01 00:32:33.000000', 'consum', 0.0218, 'lps'),
	(435013, 125, '2015-03-01 00:32:34.000000', 'consum', 0.0214, 'lps'),
	(435014, 125, '2015-03-01 00:32:35.000000', 'consum', 0.0226, 'lps'),
	(435015, 125, '2015-03-01 00:32:36.000000', 'consum', 0.0224, 'lps'),
	(435016, 125, '2015-03-01 00:32:37.000000', 'consum', 0.0219, 'lps'),
	(435017, 125, '2015-03-01 00:32:38.000000', 'consum', 0.0212, 'lps'),
	(435018, 125, '2015-03-01 00:32:39.000000', 'consum', 0.0210, 'lps'),
	(435019, 125, '2015-03-01 00:32:40.000000', 'consum', 0.0221, 'lps'),
	(435020, 125, '2015-03-01 00:32:41.000000', 'consum', 0.0214, 'lps'),
	(435021, 125, '2015-03-01 00:32:42.000000', 'consum', 0.0216, 'lps'),
	(435022, 125, '2015-03-01 00:32:43.000000', 'consum', 0.0211, 'lps'),
	(435023, 125, '2015-03-01 00:32:44.000000', 'consum', 0.0216, 'lps'),
	(435024, 125, '2015-03-01 00:32:45.000000', 'consum', 0.0221, 'lps'),
	(435025, 125, '2015-03-01 00:32:46.000000', 'consum', 0.0212, 'lps'),
	(435026, 125, '2015-03-01 00:32:47.000000', 'consum', 0.0223, 'lps'),
	(435027, 125, '2015-03-01 00:32:48.000000', 'consum', 0.0216, 'lps'),
	(435028, 125, '2015-03-01 00:32:49.000000', 'consum', 0.0219, 'lps'),
	(435029, 125, '2015-03-01 00:32:50.000000', 'consum', 0.0221, 'lps'),
	(435030, 125, '2015-03-01 00:32:51.000000', 'consum', 0.0222, 'lps'),
	(435031, 125, '2015-03-01 00:32:52.000000', 'consum', 0.0219, 'lps'),
	(435032, 125, '2015-03-01 00:32:53.000000', 'consum', 0.0219, 'lps'),
	(435033, 125, '2015-03-01 00:32:54.000000', 'consum', 0.0212, 'lps'),
	(435034, 125, '2015-03-01 00:32:55.000000', 'consum', 0.0213, 'lps'),
	(435035, 125, '2015-03-01 00:32:56.000000', 'consum', 0.0216, 'lps'),
	(435036, 125, '2015-03-01 00:32:57.000000', 'consum', 0.0217, 'lps'),
	(435037, 125, '2015-03-01 00:32:58.000000', 'consum', 0.0225, 'lps'),
	(435038, 125, '2015-03-01 00:32:59.000000', 'consum', 0.0214, 'lps'),
	(435039, 125, '2015-03-01 00:33:00.000000', 'consum', 0.0218, 'lps'),
	(435040, 125, '2015-03-01 00:33:01.000000', 'consum', 0.0223, 'lps'),
	(435041, 125, '2015-03-01 00:33:02.000000', 'consum', 0.0217, 'lps'),
	(435042, 125, '2015-03-01 00:33:03.000000', 'consum', 0.0224, 'lps'),
	(435043, 125, '2015-03-01 00:33:04.000000', 'consum', 0.0210, 'lps'),
	(435044, 125, '2015-03-01 00:33:05.000000', 'consum', 0.0216, 'lps'),
	(435045, 125, '2015-03-01 00:33:06.000000', 'consum', 0.0226, 'lps'),
	(435046, 125, '2015-03-01 00:33:07.000000', 'consum', 0.0221, 'lps'),
	(435047, 125, '2015-03-01 00:33:08.000000', 'consum', 0.0217, 'lps'),
	(435048, 125, '2015-03-01 00:33:09.000000', 'consum', 0.0215, 'lps'),
	(435049, 125, '2015-03-01 00:33:10.000000', 'consum', 0.0212, 'lps'),
	(435050, 125, '2015-03-01 00:33:11.000000', 'consum', 0.0222, 'lps'),
	(435051, 125, '2015-03-01 00:33:12.000000', 'consum', 0.0213, 'lps'),
	(435052, 125, '2015-03-01 00:33:13.000000', 'consum', 0.0225, 'lps'),
	(435053, 125, '2015-03-01 00:33:14.000000', 'consum', 0.0223, 'lps'),
	(435054, 125, '2015-03-01 00:33:15.000000', 'consum', 0.0217, 'lps'),
	(435055, 125, '2015-03-01 00:33:16.000000', 'consum', 0.0220, 'lps'),
	(435056, 125, '2015-03-01 00:33:17.000000', 'consum', 0.0226, 'lps'),
	(435057, 125, '2015-03-01 00:33:18.000000', 'consum', 0.0223, 'lps'),
	(435058, 125, '2015-03-01 00:33:19.000000', 'consum', 0.0213, 'lps'),
	(435059, 125, '2015-03-01 00:33:20.000000', 'consum', 0.0221, 'lps'),
	(435060, 125, '2015-03-01 00:33:21.000000', 'consum', 0.0221, 'lps'),
	(435061, 125, '2015-03-01 00:33:22.000000', 'consum', 0.0218, 'lps'),
	(435062, 125, '2015-03-01 00:33:23.000000', 'consum', 0.0214, 'lps'),
	(435063, 125, '2015-03-01 00:33:24.000000', 'consum', 0.0226, 'lps'),
	(435064, 125, '2015-03-01 00:33:25.000000', 'consum', 0.0211, 'lps'),
	(435065, 125, '2015-03-01 00:33:26.000000', 'consum', 0.0216, 'lps'),
	(435066, 125, '2015-03-01 00:33:27.000000', 'consum', 0.0220, 'lps'),
	(435067, 125, '2015-03-01 00:33:28.000000', 'consum', 0.0225, 'lps'),
	(435068, 125, '2015-03-01 00:33:29.000000', 'consum', 0.0225, 'lps'),
	(435069, 125, '2015-03-01 00:33:30.000000', 'consum', 0.0220, 'lps'),
	(435070, 125, '2015-03-01 00:33:31.000000', 'consum', 0.0217, 'lps'),
	(435071, 125, '2015-03-01 00:33:32.000000', 'consum', 0.0215, 'lps'),
	(435072, 125, '2015-03-01 00:33:33.000000', 'consum', 0.0213, 'lps'),
	(435073, 125, '2015-03-01 00:33:34.000000', 'consum', 0.0210, 'lps'),
	(435074, 125, '2015-03-01 00:33:35.000000', 'consum', 0.0221, 'lps'),
	(435075, 125, '2015-03-01 00:33:36.000000', 'consum', 0.0215, 'lps'),
	(435076, 125, '2015-03-01 00:33:37.000000', 'consum', 0.0218, 'lps'),
	(435077, 125, '2015-03-01 00:33:38.000000', 'consum', 0.0218, 'lps'),
	(435078, 125, '2015-03-01 00:33:39.000000', 'consum', 0.0211, 'lps'),
	(435079, 125, '2015-03-01 00:33:40.000000', 'consum', 0.0210, 'lps'),
	(435080, 125, '2015-03-01 00:33:41.000000', 'consum', 0.0223, 'lps'),
	(435081, 125, '2015-03-01 00:33:42.000000', 'consum', 0.0223, 'lps'),
	(435082, 125, '2015-03-01 00:33:43.000000', 'consum', 0.0219, 'lps'),
	(435083, 125, '2015-03-01 00:33:44.000000', 'consum', 0.0217, 'lps'),
	(435084, 125, '2015-03-01 00:33:45.000000', 'consum', 0.0217, 'lps'),
	(435085, 125, '2015-03-01 00:33:46.000000', 'consum', 0.0211, 'lps'),
	(435086, 125, '2015-03-01 00:33:47.000000', 'consum', 0.0210, 'lps'),
	(435087, 125, '2015-03-01 00:33:48.000000', 'consum', 0.0223, 'lps'),
	(435088, 125, '2015-03-01 00:33:49.000000', 'consum', 0.0210, 'lps'),
	(435089, 125, '2015-03-01 00:33:50.000000', 'consum', 0.0222, 'lps'),
	(435090, 125, '2015-03-01 00:33:51.000000', 'consum', 0.0219, 'lps'),
	(435091, 125, '2015-03-01 00:33:52.000000', 'consum', 0.0220, 'lps'),
	(435092, 125, '2015-03-01 00:33:53.000000', 'consum', 0.0217, 'lps'),
	(435093, 125, '2015-03-01 00:33:54.000000', 'consum', 0.0216, 'lps'),
	(435094, 125, '2015-03-01 00:33:55.000000', 'consum', 0.0219, 'lps'),
	(435095, 125, '2015-03-01 00:33:56.000000', 'consum', 0.0221, 'lps'),
	(435096, 125, '2015-03-01 00:33:57.000000', 'consum', 0.0221, 'lps'),
	(435097, 125, '2015-03-01 00:33:58.000000', 'consum', 0.0215, 'lps'),
	(435098, 125, '2015-03-01 00:33:59.000000', 'consum', 0.0221, 'lps'),
	(435099, 125, '2015-03-01 00:34:00.000000', 'consum', 0.0216, 'lps'),
	(435100, 125, '2015-03-01 00:34:01.000000', 'consum', 0.0225, 'lps'),
	(435101, 125, '2015-03-01 00:34:02.000000', 'consum', 0.0217, 'lps'),
	(435102, 125, '2015-03-01 00:34:03.000000', 'consum', 0.0217, 'lps'),
	(435103, 125, '2015-03-01 00:34:04.000000', 'consum', 0.0223, 'lps'),
	(435104, 125, '2015-03-01 00:34:05.000000', 'consum', 0.0219, 'lps'),
	(435105, 125, '2015-03-01 00:34:06.000000', 'consum', 0.0220, 'lps'),
	(435106, 125, '2015-03-01 00:34:07.000000', 'consum', 0.0215, 'lps'),
	(435107, 125, '2015-03-01 00:34:08.000000', 'consum', 0.0222, 'lps'),
	(435108, 125, '2015-03-01 00:34:09.000000', 'consum', 0.0220, 'lps'),
	(435109, 125, '2015-03-01 00:34:10.000000', 'consum', 0.0226, 'lps'),
	(435110, 125, '2015-03-01 00:34:11.000000', 'consum', 0.0226, 'lps'),
	(435111, 125, '2015-03-01 00:34:12.000000', 'consum', 0.0226, 'lps'),
	(435112, 125, '2015-03-01 00:34:13.000000', 'consum', 0.0210, 'lps'),
	(435113, 125, '2015-03-01 00:34:14.000000', 'consum', 0.0213, 'lps'),
	(435114, 125, '2015-03-01 00:34:15.000000', 'consum', 0.0226, 'lps'),
	(435115, 125, '2015-03-01 00:34:16.000000', 'consum', 0.0214, 'lps'),
	(435116, 125, '2015-03-01 00:34:17.000000', 'consum', 0.0218, 'lps'),
	(435117, 125, '2015-03-01 00:34:18.000000', 'consum', 0.0219, 'lps'),
	(435118, 125, '2015-03-01 00:34:19.000000', 'consum', 0.0215, 'lps'),
	(435119, 125, '2015-03-01 00:34:20.000000', 'consum', 0.0224, 'lps'),
	(435120, 125, '2015-03-01 00:34:21.000000', 'consum', 0.0217, 'lps'),
	(435121, 125, '2015-03-01 00:34:22.000000', 'consum', 0.0218, 'lps'),
	(435122, 125, '2015-03-01 00:34:23.000000', 'consum', 0.0214, 'lps'),
	(435123, 125, '2015-03-01 00:34:24.000000', 'consum', 0.0222, 'lps'),
	(435124, 125, '2015-03-01 00:34:25.000000', 'consum', 0.0224, 'lps'),
	(435125, 125, '2015-03-01 00:34:26.000000', 'consum', 0.0210, 'lps'),
	(435126, 125, '2015-03-01 00:34:27.000000', 'consum', 0.0220, 'lps'),
	(435127, 125, '2015-03-01 00:34:28.000000', 'consum', 0.0211, 'lps'),
	(435128, 125, '2015-03-01 00:34:29.000000', 'consum', 0.0217, 'lps'),
	(435129, 125, '2015-03-01 00:34:30.000000', 'consum', 0.0226, 'lps'),
	(435130, 125, '2015-03-01 00:34:31.000000', 'consum', 0.0220, 'lps'),
	(435131, 125, '2015-03-01 00:34:32.000000', 'consum', 0.0213, 'lps'),
	(435132, 125, '2015-03-01 00:34:33.000000', 'consum', 0.0213, 'lps'),
	(435133, 125, '2015-03-01 00:34:34.000000', 'consum', 0.0215, 'lps'),
	(435134, 125, '2015-03-01 00:34:35.000000', 'consum', 0.0212, 'lps'),
	(435135, 125, '2015-03-01 00:34:36.000000', 'consum', 0.0220, 'lps'),
	(435136, 125, '2015-03-01 00:34:37.000000', 'consum', 0.0221, 'lps'),
	(435137, 125, '2015-03-01 00:34:38.000000', 'consum', 0.0218, 'lps'),
	(435138, 125, '2015-03-01 00:34:39.000000', 'consum', 0.0220, 'lps'),
	(435139, 125, '2015-03-01 00:34:40.000000', 'consum', 0.0217, 'lps'),
	(435140, 125, '2015-03-01 00:34:41.000000', 'consum', 0.0216, 'lps'),
	(435141, 125, '2015-03-01 00:34:42.000000', 'consum', 0.0218, 'lps'),
	(435142, 125, '2015-03-01 00:34:43.000000', 'consum', 0.0215, 'lps'),
	(435143, 125, '2015-03-01 00:34:44.000000', 'consum', 0.0212, 'lps'),
	(435144, 125, '2015-03-01 00:34:45.000000', 'consum', 0.0222, 'lps'),
	(435145, 125, '2015-03-01 00:34:46.000000', 'consum', 0.0213, 'lps'),
	(435146, 125, '2015-03-01 00:34:47.000000', 'consum', 0.0224, 'lps'),
	(435147, 125, '2015-03-01 00:34:48.000000', 'consum', 0.0219, 'lps'),
	(435148, 125, '2015-03-01 00:34:49.000000', 'consum', 0.0214, 'lps'),
	(435149, 125, '2015-03-01 00:34:50.000000', 'consum', 0.0221, 'lps'),
	(435150, 125, '2015-03-01 00:34:51.000000', 'consum', 0.0220, 'lps'),
	(435151, 125, '2015-03-01 00:34:52.000000', 'consum', 0.0210, 'lps'),
	(435152, 125, '2015-03-01 00:34:53.000000', 'consum', 0.0216, 'lps'),
	(435153, 125, '2015-03-01 00:34:54.000000', 'consum', 0.0221, 'lps'),
	(435154, 125, '2015-03-01 00:34:55.000000', 'consum', 0.0213, 'lps'),
	(435155, 125, '2015-03-01 00:34:56.000000', 'consum', 0.0212, 'lps'),
	(435156, 125, '2015-03-01 00:34:57.000000', 'consum', 0.0226, 'lps'),
	(435157, 125, '2015-03-01 00:34:58.000000', 'consum', 0.0217, 'lps'),
	(435158, 125, '2015-03-01 00:34:59.000000', 'consum', 0.0215, 'lps'),
	(435159, 125, '2015-03-01 00:35:00.000000', 'consum', 0.0217, 'lps'),
	(435160, 125, '2015-03-01 00:35:01.000000', 'consum', 0.0210, 'lps'),
	(435161, 125, '2015-03-01 00:35:02.000000', 'consum', 0.0223, 'lps'),
	(435162, 125, '2015-03-01 00:35:03.000000', 'consum', 0.0210, 'lps'),
	(435163, 125, '2015-03-01 00:35:04.000000', 'consum', 0.0222, 'lps'),
	(435164, 125, '2015-03-01 00:35:05.000000', 'consum', 0.0218, 'lps'),
	(435165, 125, '2015-03-01 00:35:06.000000', 'consum', 0.0216, 'lps'),
	(435166, 125, '2015-03-01 00:35:07.000000', 'consum', 0.0216, 'lps'),
	(435167, 125, '2015-03-01 00:35:08.000000', 'consum', 0.0221, 'lps'),
	(435168, 125, '2015-03-01 00:35:09.000000', 'consum', 0.0213, 'lps'),
	(435169, 125, '2015-03-01 00:35:10.000000', 'consum', 0.0210, 'lps'),
	(435170, 125, '2015-03-01 00:35:11.000000', 'consum', 0.0219, 'lps'),
	(435171, 125, '2015-03-01 00:35:12.000000', 'consum', 0.0220, 'lps'),
	(435172, 125, '2015-03-01 00:35:13.000000', 'consum', 0.0218, 'lps'),
	(435173, 125, '2015-03-01 00:35:14.000000', 'consum', 0.0219, 'lps'),
	(435174, 125, '2015-03-01 00:35:15.000000', 'consum', 0.0215, 'lps'),
	(435175, 125, '2015-03-01 00:35:16.000000', 'consum', 0.0210, 'lps'),
	(435176, 125, '2015-03-01 00:35:17.000000', 'consum', 0.0211, 'lps'),
	(435177, 125, '2015-03-01 00:35:18.000000', 'consum', 0.0215, 'lps'),
	(435178, 125, '2015-03-01 00:35:19.000000', 'consum', 0.0216, 'lps'),
	(435179, 125, '2015-03-01 00:35:20.000000', 'consum', 0.0224, 'lps'),
	(435180, 125, '2015-03-01 00:35:21.000000', 'consum', 0.0213, 'lps'),
	(435181, 125, '2015-03-01 00:35:22.000000', 'consum', 0.0219, 'lps'),
	(435182, 125, '2015-03-01 00:35:23.000000', 'consum', 0.0212, 'lps'),
	(435183, 125, '2015-03-01 00:35:24.000000', 'consum', 0.0211, 'lps'),
	(435184, 125, '2015-03-01 00:35:25.000000', 'consum', 0.0225, 'lps'),
	(435185, 125, '2015-03-01 00:35:26.000000', 'consum', 0.0213, 'lps'),
	(435186, 125, '2015-03-01 00:35:27.000000', 'consum', 0.0216, 'lps'),
	(435187, 125, '2015-03-01 00:35:28.000000', 'consum', 0.0214, 'lps'),
	(435188, 125, '2015-03-01 00:35:29.000000', 'consum', 0.0214, 'lps'),
	(435189, 125, '2015-03-01 00:35:30.000000', 'consum', 0.0216, 'lps'),
	(435190, 125, '2015-03-01 00:35:31.000000', 'consum', 0.0214, 'lps'),
	(435191, 125, '2015-03-01 00:35:32.000000', 'consum', 0.0210, 'lps'),
	(435192, 125, '2015-03-01 00:35:33.000000', 'consum', 0.0215, 'lps'),
	(435193, 125, '2015-03-01 00:35:34.000000', 'consum', 0.0220, 'lps'),
	(435194, 125, '2015-03-01 00:35:35.000000', 'consum', 0.0212, 'lps'),
	(435195, 125, '2015-03-01 00:35:36.000000', 'consum', 0.0222, 'lps'),
	(435196, 125, '2015-03-01 00:35:37.000000', 'consum', 0.0217, 'lps'),
	(435197, 125, '2015-03-01 00:35:38.000000', 'consum', 0.0224, 'lps'),
	(435198, 125, '2015-03-01 00:35:39.000000', 'consum', 0.0224, 'lps'),
	(435199, 125, '2015-03-01 00:35:40.000000', 'consum', 0.0223, 'lps'),
	(435200, 125, '2015-03-01 00:35:41.000000', 'consum', 0.0218, 'lps'),
	(435201, 125, '2015-03-01 00:35:42.000000', 'consum', 0.0210, 'lps'),
	(435202, 125, '2015-03-01 00:35:43.000000', 'consum', 0.0222, 'lps'),
	(435203, 125, '2015-03-01 00:35:44.000000', 'consum', 0.0218, 'lps'),
	(435204, 125, '2015-03-01 00:35:45.000000', 'consum', 0.0217, 'lps'),
	(435205, 125, '2015-03-01 00:35:46.000000', 'consum', 0.0218, 'lps'),
	(435206, 125, '2015-03-01 00:35:47.000000', 'consum', 0.0214, 'lps'),
	(435207, 125, '2015-03-01 00:35:48.000000', 'consum', 0.0223, 'lps'),
	(435208, 125, '2015-03-01 00:35:49.000000', 'consum', 0.0214, 'lps'),
	(435209, 125, '2015-03-01 00:35:50.000000', 'consum', 0.0210, 'lps'),
	(435210, 125, '2015-03-01 00:35:51.000000', 'consum', 0.0213, 'lps'),
	(435211, 125, '2015-03-01 00:35:52.000000', 'consum', 0.0210, 'lps'),
	(435212, 125, '2015-03-01 00:35:53.000000', 'consum', 0.0217, 'lps'),
	(435213, 125, '2015-03-01 00:35:54.000000', 'consum', 0.0212, 'lps'),
	(435214, 125, '2015-03-01 00:35:55.000000', 'consum', 0.0216, 'lps'),
	(435215, 125, '2015-03-01 00:35:56.000000', 'consum', 0.0217, 'lps'),
	(435216, 125, '2015-03-01 00:35:57.000000', 'consum', 0.0211, 'lps'),
	(435217, 125, '2015-03-01 00:35:58.000000', 'consum', 0.0211, 'lps'),
	(435218, 125, '2015-03-01 00:35:59.000000', 'consum', 0.0212, 'lps'),
	(435219, 125, '2015-03-01 00:36:00.000000', 'consum', 0.0217, 'lps'),
	(435220, 125, '2015-03-01 00:36:01.000000', 'consum', 0.0222, 'lps'),
	(435221, 125, '2015-03-01 00:36:02.000000', 'consum', 0.0218, 'lps'),
	(435222, 125, '2015-03-01 00:36:03.000000', 'consum', 0.0214, 'lps'),
	(435223, 125, '2015-03-01 00:36:04.000000', 'consum', 0.0225, 'lps'),
	(435224, 125, '2015-03-01 00:36:05.000000', 'consum', 0.0220, 'lps'),
	(435225, 125, '2015-03-01 00:36:06.000000', 'consum', 0.0215, 'lps'),
	(435226, 125, '2015-03-01 00:36:07.000000', 'consum', 0.0222, 'lps'),
	(435227, 125, '2015-03-01 00:36:08.000000', 'consum', 0.0222, 'lps'),
	(435228, 125, '2015-03-01 00:36:09.000000', 'consum', 0.0217, 'lps'),
	(435229, 125, '2015-03-01 00:36:10.000000', 'consum', 0.0211, 'lps'),
	(435230, 125, '2015-03-01 00:36:11.000000', 'consum', 0.0226, 'lps'),
	(435231, 125, '2015-03-01 00:36:12.000000', 'consum', 0.0220, 'lps'),
	(435232, 125, '2015-03-01 00:36:13.000000', 'consum', 0.0211, 'lps'),
	(435233, 125, '2015-03-01 00:36:14.000000', 'consum', 0.0222, 'lps'),
	(435234, 125, '2015-03-01 00:36:15.000000', 'consum', 0.0216, 'lps'),
	(435235, 125, '2015-03-01 00:36:16.000000', 'consum', 0.0222, 'lps'),
	(435236, 125, '2015-03-01 00:36:17.000000', 'consum', 0.0216, 'lps'),
	(435237, 125, '2015-03-01 00:36:18.000000', 'consum', 0.0224, 'lps'),
	(435238, 125, '2015-03-01 00:36:19.000000', 'consum', 0.0226, 'lps'),
	(435239, 125, '2015-03-01 00:36:20.000000', 'consum', 0.0217, 'lps'),
	(435240, 125, '2015-03-01 00:36:21.000000', 'consum', 0.0214, 'lps'),
	(435241, 125, '2015-03-01 00:36:22.000000', 'consum', 0.0210, 'lps'),
	(435242, 125, '2015-03-01 00:36:23.000000', 'consum', 0.0214, 'lps'),
	(435243, 125, '2015-03-01 00:36:24.000000', 'consum', 0.0212, 'lps'),
	(435244, 125, '2015-03-01 00:36:25.000000', 'consum', 0.0212, 'lps'),
	(435245, 125, '2015-03-01 00:36:26.000000', 'consum', 0.0211, 'lps'),
	(435246, 125, '2015-03-01 00:36:27.000000', 'consum', 0.0212, 'lps'),
	(435247, 125, '2015-03-01 00:36:28.000000', 'consum', 0.0217, 'lps'),
	(435248, 125, '2015-03-01 00:36:29.000000', 'consum', 0.0224, 'lps'),
	(435249, 125, '2015-03-01 00:36:30.000000', 'consum', 0.0223, 'lps'),
	(435250, 125, '2015-03-01 00:36:31.000000', 'consum', 0.0217, 'lps'),
	(435251, 125, '2015-03-01 00:36:32.000000', 'consum', 0.0224, 'lps'),
	(435252, 125, '2015-03-01 00:36:33.000000', 'consum', 0.0210, 'lps'),
	(435253, 125, '2015-03-01 00:36:34.000000', 'consum', 0.0219, 'lps'),
	(435254, 125, '2015-03-01 00:36:35.000000', 'consum', 0.0220, 'lps'),
	(435255, 125, '2015-03-01 00:36:36.000000', 'consum', 0.0219, 'lps'),
	(435256, 125, '2015-03-01 00:36:37.000000', 'consum', 0.0225, 'lps'),
	(435257, 125, '2015-03-01 00:36:38.000000', 'consum', 0.0224, 'lps'),
	(435258, 125, '2015-03-01 00:36:39.000000', 'consum', 0.0218, 'lps'),
	(435259, 125, '2015-03-01 00:36:40.000000', 'consum', 0.0225, 'lps'),
	(435260, 125, '2015-03-01 00:36:41.000000', 'consum', 0.0211, 'lps'),
	(435261, 125, '2015-03-01 00:36:42.000000', 'consum', 0.0223, 'lps'),
	(435262, 125, '2015-03-01 00:36:43.000000', 'consum', 0.0222, 'lps'),
	(435263, 125, '2015-03-01 00:36:44.000000', 'consum', 0.0212, 'lps'),
	(435264, 125, '2015-03-01 00:36:45.000000', 'consum', 0.0221, 'lps'),
	(435265, 125, '2015-03-01 00:36:46.000000', 'consum', 0.0226, 'lps'),
	(435266, 125, '2015-03-01 00:36:47.000000', 'consum', 0.0221, 'lps'),
	(435267, 125, '2015-03-01 00:36:48.000000', 'consum', 0.0220, 'lps'),
	(435268, 125, '2015-03-01 00:36:49.000000', 'consum', 0.0210, 'lps'),
	(435269, 125, '2015-03-01 00:36:50.000000', 'consum', 0.0214, 'lps'),
	(435270, 125, '2015-03-01 00:36:51.000000', 'consum', 0.0214, 'lps'),
	(435271, 125, '2015-03-01 00:36:52.000000', 'consum', 0.0219, 'lps'),
	(435272, 125, '2015-03-01 00:36:53.000000', 'consum', 0.0224, 'lps'),
	(435273, 125, '2015-03-01 00:36:54.000000', 'consum', 0.0220, 'lps'),
	(435274, 125, '2015-03-01 00:36:55.000000', 'consum', 0.0221, 'lps'),
	(435275, 125, '2015-03-01 00:36:56.000000', 'consum', 0.0217, 'lps'),
	(435276, 125, '2015-03-01 00:36:57.000000', 'consum', 0.0212, 'lps'),
	(435277, 125, '2015-03-01 00:36:58.000000', 'consum', 0.0217, 'lps'),
	(435278, 125, '2015-03-01 00:36:59.000000', 'consum', 0.0223, 'lps'),
	(435279, 125, '2015-03-01 00:37:00.000000', 'consum', 0.0222, 'lps'),
	(435280, 125, '2015-03-01 00:37:01.000000', 'consum', 0.0214, 'lps'),
	(435281, 125, '2015-03-01 00:37:02.000000', 'consum', 0.0212, 'lps'),
	(435282, 125, '2015-03-01 00:37:03.000000', 'consum', 0.0225, 'lps'),
	(435283, 125, '2015-03-01 00:37:04.000000', 'consum', 0.0212, 'lps'),
	(435284, 125, '2015-03-01 00:37:05.000000', 'consum', 0.0226, 'lps'),
	(435285, 125, '2015-03-01 00:37:06.000000', 'consum', 0.0217, 'lps'),
	(435286, 125, '2015-03-01 00:37:07.000000', 'consum', 0.0216, 'lps'),
	(435287, 125, '2015-03-01 00:37:08.000000', 'consum', 0.0219, 'lps'),
	(435288, 125, '2015-03-01 00:37:09.000000', 'consum', 0.0222, 'lps'),
	(435289, 125, '2015-03-01 00:37:10.000000', 'consum', 0.0224, 'lps'),
	(435290, 125, '2015-03-01 00:37:11.000000', 'consum', 0.0210, 'lps'),
	(435291, 125, '2015-03-01 00:37:12.000000', 'consum', 0.0221, 'lps'),
	(435292, 125, '2015-03-01 00:37:13.000000', 'consum', 0.0214, 'lps'),
	(435293, 125, '2015-03-01 00:37:14.000000', 'consum', 0.0213, 'lps'),
	(435294, 125, '2015-03-01 00:37:15.000000', 'consum', 0.0214, 'lps'),
	(435295, 125, '2015-03-01 00:37:16.000000', 'consum', 0.0223, 'lps'),
	(435296, 125, '2015-03-01 00:37:17.000000', 'consum', 0.0214, 'lps'),
	(435297, 125, '2015-03-01 00:37:18.000000', 'consum', 0.0222, 'lps'),
	(435298, 125, '2015-03-01 00:37:19.000000', 'consum', 0.0225, 'lps'),
	(435299, 125, '2015-03-01 00:37:20.000000', 'consum', 0.0217, 'lps'),
	(435300, 125, '2015-03-01 00:37:21.000000', 'consum', 0.0217, 'lps'),
	(435301, 125, '2015-03-01 00:37:22.000000', 'consum', 0.0224, 'lps'),
	(435302, 125, '2015-03-01 00:37:23.000000', 'consum', 0.0225, 'lps'),
	(435303, 125, '2015-03-01 00:37:24.000000', 'consum', 0.0211, 'lps'),
	(435304, 125, '2015-03-01 00:37:25.000000', 'consum', 0.0222, 'lps'),
	(435305, 125, '2015-03-01 00:37:26.000000', 'consum', 0.0214, 'lps'),
	(435306, 125, '2015-03-01 00:37:27.000000', 'consum', 0.0213, 'lps'),
	(435307, 125, '2015-03-01 00:37:28.000000', 'consum', 0.0214, 'lps'),
	(435308, 125, '2015-03-01 00:37:29.000000', 'consum', 0.0219, 'lps'),
	(435309, 125, '2015-03-01 00:37:30.000000', 'consum', 0.0210, 'lps'),
	(435310, 125, '2015-03-01 00:37:31.000000', 'consum', 0.0220, 'lps'),
	(435311, 125, '2015-03-01 00:37:32.000000', 'consum', 0.0223, 'lps'),
	(435312, 125, '2015-03-01 00:37:33.000000', 'consum', 0.0214, 'lps'),
	(435313, 125, '2015-03-01 00:37:34.000000', 'consum', 0.0226, 'lps'),
	(435314, 125, '2015-03-01 00:37:35.000000', 'consum', 0.0226, 'lps'),
	(435315, 125, '2015-03-01 00:37:36.000000', 'consum', 0.0226, 'lps'),
	(435316, 125, '2015-03-01 00:37:37.000000', 'consum', 0.0225, 'lps'),
	(435317, 125, '2015-03-01 00:37:38.000000', 'consum', 0.0221, 'lps'),
	(435318, 125, '2015-03-01 00:37:39.000000', 'consum', 0.0220, 'lps'),
	(435319, 125, '2015-03-01 00:37:40.000000', 'consum', 0.0210, 'lps'),
	(435320, 125, '2015-03-01 00:37:41.000000', 'consum', 0.0217, 'lps'),
	(435321, 125, '2015-03-01 00:37:42.000000', 'consum', 0.0210, 'lps'),
	(435322, 125, '2015-03-01 00:37:43.000000', 'consum', 0.0222, 'lps'),
	(435323, 125, '2015-03-01 00:37:44.000000', 'consum', 0.0221, 'lps'),
	(435324, 125, '2015-03-01 00:37:45.000000', 'consum', 0.0211, 'lps'),
	(435325, 125, '2015-03-01 00:37:46.000000', 'consum', 0.0218, 'lps'),
	(435326, 125, '2015-03-01 00:37:47.000000', 'consum', 0.0215, 'lps'),
	(435327, 125, '2015-03-01 00:37:48.000000', 'consum', 0.0225, 'lps'),
	(435328, 125, '2015-03-01 00:37:49.000000', 'consum', 0.0223, 'lps'),
	(435329, 125, '2015-03-01 00:37:50.000000', 'consum', 0.0212, 'lps'),
	(435330, 125, '2015-03-01 00:37:51.000000', 'consum', 0.0216, 'lps'),
	(435331, 125, '2015-03-01 00:37:52.000000', 'consum', 0.0217, 'lps'),
	(435332, 125, '2015-03-01 00:37:53.000000', 'consum', 0.0212, 'lps'),
	(435333, 125, '2015-03-01 00:37:54.000000', 'consum', 0.0215, 'lps'),
	(435334, 125, '2015-03-01 00:37:55.000000', 'consum', 0.0214, 'lps'),
	(435335, 125, '2015-03-01 00:37:56.000000', 'consum', 0.0217, 'lps'),
	(435336, 125, '2015-03-01 00:37:57.000000', 'consum', 0.0213, 'lps'),
	(435337, 125, '2015-03-01 00:37:58.000000', 'consum', 0.0224, 'lps'),
	(435338, 125, '2015-03-01 00:37:59.000000', 'consum', 0.0222, 'lps'),
	(435339, 125, '2015-03-01 00:38:00.000000', 'consum', 0.0225, 'lps'),
	(435340, 125, '2015-03-01 00:38:01.000000', 'consum', 0.0219, 'lps'),
	(435341, 125, '2015-03-01 00:38:02.000000', 'consum', 0.0225, 'lps'),
	(435342, 125, '2015-03-01 00:38:03.000000', 'consum', 0.0210, 'lps'),
	(435343, 125, '2015-03-01 00:38:04.000000', 'consum', 0.0215, 'lps'),
	(435344, 125, '2015-03-01 00:38:05.000000', 'consum', 0.0219, 'lps'),
	(435345, 125, '2015-03-01 00:38:06.000000', 'consum', 0.0224, 'lps'),
	(435346, 125, '2015-03-01 00:38:07.000000', 'consum', 0.0218, 'lps'),
	(435347, 125, '2015-03-01 00:38:08.000000', 'consum', 0.0224, 'lps'),
	(435348, 125, '2015-03-01 00:38:09.000000', 'consum', 0.0226, 'lps'),
	(435349, 125, '2015-03-01 00:38:10.000000', 'consum', 0.0212, 'lps'),
	(435350, 125, '2015-03-01 00:38:11.000000', 'consum', 0.0222, 'lps'),
	(435351, 125, '2015-03-01 00:38:12.000000', 'consum', 0.0217, 'lps'),
	(435352, 125, '2015-03-01 00:38:13.000000', 'consum', 0.0225, 'lps'),
	(435353, 125, '2015-03-01 00:38:14.000000', 'consum', 0.0212, 'lps'),
	(435354, 125, '2015-03-01 00:38:15.000000', 'consum', 0.0212, 'lps'),
	(435355, 125, '2015-03-01 00:38:16.000000', 'consum', 0.0213, 'lps'),
	(435356, 125, '2015-03-01 00:38:17.000000', 'consum', 0.0220, 'lps'),
	(435357, 125, '2015-03-01 00:38:18.000000', 'consum', 0.0219, 'lps'),
	(435358, 125, '2015-03-01 00:38:19.000000', 'consum', 0.0223, 'lps'),
	(435359, 125, '2015-03-01 00:38:20.000000', 'consum', 0.0214, 'lps'),
	(435360, 125, '2015-03-01 00:38:21.000000', 'consum', 0.0210, 'lps'),
	(435361, 125, '2015-03-01 00:38:22.000000', 'consum', 0.0217, 'lps'),
	(435362, 125, '2015-03-01 00:38:23.000000', 'consum', 0.0226, 'lps'),
	(435363, 125, '2015-03-01 00:38:24.000000', 'consum', 0.0219, 'lps'),
	(435364, 125, '2015-03-01 00:38:25.000000', 'consum', 0.0226, 'lps'),
	(435365, 125, '2015-03-01 00:38:26.000000', 'consum', 0.0213, 'lps'),
	(435366, 125, '2015-03-01 00:38:27.000000', 'consum', 0.0226, 'lps'),
	(435367, 125, '2015-03-01 00:38:28.000000', 'consum', 0.0213, 'lps'),
	(435368, 125, '2015-03-01 00:38:29.000000', 'consum', 0.0213, 'lps'),
	(435369, 125, '2015-03-01 00:38:30.000000', 'consum', 0.0218, 'lps'),
	(435370, 125, '2015-03-01 00:38:31.000000', 'consum', 0.0223, 'lps'),
	(435371, 125, '2015-03-01 00:38:32.000000', 'consum', 0.0220, 'lps'),
	(435372, 125, '2015-03-01 00:38:33.000000', 'consum', 0.0218, 'lps'),
	(435373, 125, '2015-03-01 00:38:34.000000', 'consum', 0.0224, 'lps'),
	(435374, 125, '2015-03-01 00:38:35.000000', 'consum', 0.0220, 'lps'),
	(435375, 125, '2015-03-01 00:38:36.000000', 'consum', 0.0218, 'lps'),
	(435376, 125, '2015-03-01 00:38:37.000000', 'consum', 0.0220, 'lps'),
	(435377, 125, '2015-03-01 00:38:38.000000', 'consum', 0.0218, 'lps'),
	(435378, 125, '2015-03-01 00:38:39.000000', 'consum', 0.0224, 'lps'),
	(435379, 125, '2015-03-01 00:38:40.000000', 'consum', 0.0219, 'lps'),
	(435380, 125, '2015-03-01 00:38:41.000000', 'consum', 0.0216, 'lps'),
	(435381, 125, '2015-03-01 00:38:42.000000', 'consum', 0.0214, 'lps'),
	(435382, 125, '2015-03-01 00:38:43.000000', 'consum', 0.0210, 'lps'),
	(435383, 125, '2015-03-01 00:38:44.000000', 'consum', 0.0217, 'lps'),
	(435384, 125, '2015-03-01 00:38:45.000000', 'consum', 0.0212, 'lps'),
	(435385, 125, '2015-03-01 00:38:46.000000', 'consum', 0.0216, 'lps'),
	(435386, 125, '2015-03-01 00:38:47.000000', 'consum', 0.0218, 'lps'),
	(435387, 125, '2015-03-01 00:38:48.000000', 'consum', 0.0213, 'lps'),
	(435388, 125, '2015-03-01 00:38:49.000000', 'consum', 0.0221, 'lps'),
	(435389, 125, '2015-03-01 00:38:50.000000', 'consum', 0.0220, 'lps'),
	(435390, 125, '2015-03-01 00:38:51.000000', 'consum', 0.0213, 'lps'),
	(435391, 125, '2015-03-01 00:38:52.000000', 'consum', 0.0212, 'lps'),
	(435392, 125, '2015-03-01 00:38:53.000000', 'consum', 0.0226, 'lps'),
	(435393, 125, '2015-03-01 00:38:54.000000', 'consum', 0.0220, 'lps'),
	(435394, 125, '2015-03-01 00:38:55.000000', 'consum', 0.0226, 'lps'),
	(435395, 125, '2015-03-01 00:38:56.000000', 'consum', 0.0211, 'lps'),
	(435396, 125, '2015-03-01 00:38:57.000000', 'consum', 0.0219, 'lps'),
	(435397, 125, '2015-03-01 00:38:58.000000', 'consum', 0.0218, 'lps'),
	(435398, 125, '2015-03-01 00:38:59.000000', 'consum', 0.0222, 'lps'),
	(435399, 125, '2015-03-01 00:39:00.000000', 'consum', 0.0214, 'lps'),
	(435400, 125, '2015-03-01 00:39:01.000000', 'consum', 0.0210, 'lps'),
	(435401, 125, '2015-03-01 00:39:02.000000', 'consum', 0.0216, 'lps'),
	(435402, 125, '2015-03-01 00:39:03.000000', 'consum', 0.0226, 'lps'),
	(435403, 125, '2015-03-01 00:39:04.000000', 'consum', 0.0219, 'lps'),
	(435404, 125, '2015-03-01 00:39:05.000000', 'consum', 0.0226, 'lps'),
	(435405, 125, '2015-03-01 00:39:06.000000', 'consum', 0.0211, 'lps'),
	(435406, 125, '2015-03-01 00:39:07.000000', 'consum', 0.0217, 'lps'),
	(435407, 125, '2015-03-01 00:39:08.000000', 'consum', 0.0211, 'lps'),
	(435408, 125, '2015-03-01 00:39:09.000000', 'consum', 0.0212, 'lps'),
	(435409, 125, '2015-03-01 00:39:10.000000', 'consum', 0.0216, 'lps'),
	(435410, 125, '2015-03-01 00:39:11.000000', 'consum', 0.0220, 'lps'),
	(435411, 125, '2015-03-01 00:39:12.000000', 'consum', 0.0222, 'lps'),
	(435412, 125, '2015-03-01 00:39:13.000000', 'consum', 0.0225, 'lps'),
	(435413, 125, '2015-03-01 00:39:14.000000', 'consum', 0.0214, 'lps'),
	(435414, 125, '2015-03-01 00:39:15.000000', 'consum', 0.0222, 'lps'),
	(435415, 125, '2015-03-01 00:39:16.000000', 'consum', 0.0225, 'lps'),
	(435416, 125, '2015-03-01 00:39:17.000000', 'consum', 0.0214, 'lps'),
	(435417, 125, '2015-03-01 00:39:18.000000', 'consum', 0.0220, 'lps'),
	(435418, 125, '2015-03-01 00:39:19.000000', 'consum', 0.0213, 'lps'),
	(435419, 125, '2015-03-01 00:39:20.000000', 'consum', 0.0214, 'lps'),
	(435420, 125, '2015-03-01 00:39:21.000000', 'consum', 0.0220, 'lps'),
	(435421, 125, '2015-03-01 00:39:22.000000', 'consum', 0.0216, 'lps'),
	(435422, 125, '2015-03-01 00:39:23.000000', 'consum', 0.0226, 'lps'),
	(435423, 125, '2015-03-01 00:39:24.000000', 'consum', 0.0222, 'lps'),
	(435424, 125, '2015-03-01 00:39:25.000000', 'consum', 0.0224, 'lps'),
	(435425, 125, '2015-03-01 00:39:26.000000', 'consum', 0.0226, 'lps'),
	(435426, 125, '2015-03-01 00:39:27.000000', 'consum', 0.0216, 'lps'),
	(435427, 125, '2015-03-01 00:39:28.000000', 'consum', 0.0210, 'lps'),
	(435428, 125, '2015-03-01 00:39:29.000000', 'consum', 0.0226, 'lps'),
	(435429, 125, '2015-03-01 00:39:30.000000', 'consum', 0.0222, 'lps'),
	(435430, 125, '2015-03-01 00:39:31.000000', 'consum', 0.0221, 'lps'),
	(435431, 125, '2015-03-01 00:39:32.000000', 'consum', 0.0215, 'lps'),
	(435432, 125, '2015-03-01 00:39:33.000000', 'consum', 0.0221, 'lps'),
	(435433, 125, '2015-03-01 00:39:34.000000', 'consum', 0.0213, 'lps'),
	(435434, 125, '2015-03-01 00:39:35.000000', 'consum', 0.0212, 'lps'),
	(435435, 125, '2015-03-01 00:39:36.000000', 'consum', 0.0210, 'lps'),
	(435436, 125, '2015-03-01 00:39:37.000000', 'consum', 0.0221, 'lps'),
	(435437, 125, '2015-03-01 00:39:38.000000', 'consum', 0.0213, 'lps'),
	(435438, 125, '2015-03-01 00:39:39.000000', 'consum', 0.0213, 'lps'),
	(435439, 125, '2015-03-01 00:39:40.000000', 'consum', 0.0214, 'lps'),
	(435440, 125, '2015-03-01 00:39:41.000000', 'consum', 0.0221, 'lps'),
	(435441, 125, '2015-03-01 00:39:42.000000', 'consum', 0.0221, 'lps'),
	(435442, 125, '2015-03-01 00:39:43.000000', 'consum', 0.0215, 'lps'),
	(435443, 125, '2015-03-01 00:39:44.000000', 'consum', 0.0218, 'lps'),
	(435444, 125, '2015-03-01 00:39:45.000000', 'consum', 0.0219, 'lps'),
	(435445, 125, '2015-03-01 00:39:46.000000', 'consum', 0.0216, 'lps'),
	(435446, 125, '2015-03-01 00:39:47.000000', 'consum', 0.0212, 'lps'),
	(435447, 125, '2015-03-01 00:39:48.000000', 'consum', 0.0219, 'lps'),
	(435448, 125, '2015-03-01 00:39:49.000000', 'consum', 0.0217, 'lps'),
	(435449, 125, '2015-03-01 00:39:50.000000', 'consum', 0.0216, 'lps'),
	(435450, 125, '2015-03-01 00:39:51.000000', 'consum', 0.0221, 'lps'),
	(435451, 125, '2015-03-01 00:39:52.000000', 'consum', 0.0214, 'lps'),
	(435452, 125, '2015-03-01 00:39:53.000000', 'consum', 0.0214, 'lps'),
	(435453, 125, '2015-03-01 00:39:54.000000', 'consum', 0.0216, 'lps'),
	(435454, 125, '2015-03-01 00:39:55.000000', 'consum', 0.0215, 'lps'),
	(435455, 125, '2015-03-01 00:39:56.000000', 'consum', 0.0218, 'lps'),
	(435456, 125, '2015-03-01 00:39:57.000000', 'consum', 0.0215, 'lps'),
	(435457, 125, '2015-03-01 00:39:58.000000', 'consum', 0.0215, 'lps'),
	(435458, 125, '2015-03-01 00:39:59.000000', 'consum', 0.0218, 'lps'),
	(435459, 125, '2015-03-01 00:40:00.000000', 'consum', 0.0218, 'lps'),
	(435460, 125, '2015-03-01 00:40:01.000000', 'consum', 0.0212, 'lps'),
	(435461, 125, '2015-03-01 00:40:02.000000', 'consum', 0.0213, 'lps'),
	(435462, 125, '2015-03-01 00:40:03.000000', 'consum', 0.0219, 'lps'),
	(435463, 125, '2015-03-01 00:40:04.000000', 'consum', 0.0211, 'lps'),
	(435464, 125, '2015-03-01 00:40:05.000000', 'consum', 0.0225, 'lps'),
	(435465, 125, '2015-03-01 00:40:06.000000', 'consum', 0.0216, 'lps'),
	(435466, 125, '2015-03-01 00:40:07.000000', 'consum', 0.0226, 'lps'),
	(435467, 125, '2015-03-01 00:40:08.000000', 'consum', 0.0224, 'lps'),
	(435468, 125, '2015-03-01 00:40:09.000000', 'consum', 0.0215, 'lps'),
	(435469, 125, '2015-03-01 00:40:10.000000', 'consum', 0.0225, 'lps'),
	(435470, 125, '2015-03-01 00:40:11.000000', 'consum', 0.0221, 'lps'),
	(435471, 125, '2015-03-01 00:40:12.000000', 'consum', 0.0223, 'lps'),
	(435472, 125, '2015-03-01 00:40:13.000000', 'consum', 0.0222, 'lps'),
	(435473, 125, '2015-03-01 00:40:14.000000', 'consum', 0.0214, 'lps'),
	(435474, 125, '2015-03-01 00:40:15.000000', 'consum', 0.0214, 'lps'),
	(435475, 125, '2015-03-01 00:40:16.000000', 'consum', 0.0218, 'lps'),
	(435476, 125, '2015-03-01 00:40:17.000000', 'consum', 0.0222, 'lps'),
	(435477, 125, '2015-03-01 00:40:18.000000', 'consum', 0.0211, 'lps'),
	(435478, 125, '2015-03-01 00:40:19.000000', 'consum', 0.0216, 'lps'),
	(435479, 125, '2015-03-01 00:40:20.000000', 'consum', 0.0220, 'lps'),
	(435480, 125, '2015-03-01 00:40:21.000000', 'consum', 0.0210, 'lps'),
	(435481, 125, '2015-03-01 00:40:22.000000', 'consum', 0.0211, 'lps'),
	(435482, 125, '2015-03-01 00:40:23.000000', 'consum', 0.0218, 'lps'),
	(435483, 125, '2015-03-01 00:40:24.000000', 'consum', 0.0214, 'lps'),
	(435484, 125, '2015-03-01 00:40:25.000000', 'consum', 0.0222, 'lps'),
	(435485, 125, '2015-03-01 00:40:26.000000', 'consum', 0.0224, 'lps'),
	(435486, 125, '2015-03-01 00:40:27.000000', 'consum', 0.0212, 'lps'),
	(435487, 125, '2015-03-01 00:40:28.000000', 'consum', 0.0212, 'lps'),
	(435488, 125, '2015-03-01 00:40:29.000000', 'consum', 0.0214, 'lps'),
	(435489, 125, '2015-03-01 00:40:30.000000', 'consum', 0.0224, 'lps'),
	(435490, 125, '2015-03-01 00:40:31.000000', 'consum', 0.0219, 'lps'),
	(435491, 125, '2015-03-01 00:40:32.000000', 'consum', 0.0215, 'lps'),
	(435492, 125, '2015-03-01 00:40:33.000000', 'consum', 0.0222, 'lps'),
	(435493, 125, '2015-03-01 00:40:34.000000', 'consum', 0.0223, 'lps'),
	(435494, 125, '2015-03-01 00:40:35.000000', 'consum', 0.0221, 'lps'),
	(435495, 125, '2015-03-01 00:40:36.000000', 'consum', 0.0212, 'lps'),
	(435496, 125, '2015-03-01 00:40:37.000000', 'consum', 0.0222, 'lps'),
	(435497, 125, '2015-03-01 00:40:38.000000', 'consum', 0.0211, 'lps'),
	(435498, 125, '2015-03-01 00:40:39.000000', 'consum', 0.0217, 'lps'),
	(435499, 125, '2015-03-01 00:40:40.000000', 'consum', 0.0222, 'lps'),
	(435500, 125, '2015-03-01 00:40:41.000000', 'consum', 0.0217, 'lps'),
	(435501, 125, '2015-03-01 00:40:42.000000', 'consum', 0.0211, 'lps'),
	(435502, 125, '2015-03-01 00:40:43.000000', 'consum', 0.0226, 'lps'),
	(435503, 125, '2015-03-01 00:40:44.000000', 'consum', 0.0219, 'lps'),
	(435504, 125, '2015-03-01 00:40:45.000000', 'consum', 0.0223, 'lps'),
	(435505, 125, '2015-03-01 00:40:46.000000', 'consum', 0.0218, 'lps'),
	(435506, 125, '2015-03-01 00:40:47.000000', 'consum', 0.0211, 'lps'),
	(435507, 125, '2015-03-01 00:40:48.000000', 'consum', 0.0210, 'lps'),
	(435508, 125, '2015-03-01 00:40:49.000000', 'consum', 0.0221, 'lps'),
	(435509, 125, '2015-03-01 00:40:50.000000', 'consum', 0.0216, 'lps'),
	(435510, 125, '2015-03-01 00:40:51.000000', 'consum', 0.0224, 'lps'),
	(435511, 125, '2015-03-01 00:40:52.000000', 'consum', 0.0211, 'lps'),
	(435512, 125, '2015-03-01 00:40:53.000000', 'consum', 0.0226, 'lps'),
	(435513, 125, '2015-03-01 00:40:54.000000', 'consum', 0.0221, 'lps'),
	(435514, 125, '2015-03-01 00:40:55.000000', 'consum', 0.0215, 'lps'),
	(435515, 125, '2015-03-01 00:40:56.000000', 'consum', 0.0221, 'lps'),
	(435516, 125, '2015-03-01 00:40:57.000000', 'consum', 0.0214, 'lps'),
	(435517, 125, '2015-03-01 00:40:58.000000', 'consum', 0.0217, 'lps'),
	(435518, 125, '2015-03-01 00:40:59.000000', 'consum', 0.0216, 'lps'),
	(435519, 125, '2015-03-01 00:41:00.000000', 'consum', 0.0219, 'lps'),
	(435520, 125, '2015-03-01 00:41:01.000000', 'consum', 0.0221, 'lps'),
	(435521, 125, '2015-03-01 00:41:02.000000', 'consum', 0.0220, 'lps'),
	(435522, 125, '2015-03-01 00:41:03.000000', 'consum', 0.0213, 'lps'),
	(435523, 125, '2015-03-01 00:41:04.000000', 'consum', 0.0213, 'lps'),
	(435524, 125, '2015-03-01 00:41:05.000000', 'consum', 0.0217, 'lps'),
	(435525, 125, '2015-03-01 00:41:06.000000', 'consum', 0.0217, 'lps'),
	(435526, 125, '2015-03-01 00:41:07.000000', 'consum', 0.0223, 'lps'),
	(435527, 125, '2015-03-01 00:41:08.000000', 'consum', 0.0224, 'lps'),
	(435528, 125, '2015-03-01 00:41:09.000000', 'consum', 0.0222, 'lps'),
	(435529, 125, '2015-03-01 00:41:10.000000', 'consum', 0.0214, 'lps'),
	(435530, 125, '2015-03-01 00:41:11.000000', 'consum', 0.0226, 'lps'),
	(435531, 125, '2015-03-01 00:41:12.000000', 'consum', 0.0211, 'lps'),
	(435532, 125, '2015-03-01 00:41:13.000000', 'consum', 0.0219, 'lps'),
	(435533, 125, '2015-03-01 00:41:14.000000', 'consum', 0.0217, 'lps'),
	(435534, 125, '2015-03-01 00:41:15.000000', 'consum', 0.0220, 'lps'),
	(435535, 125, '2015-03-01 00:41:16.000000', 'consum', 0.0220, 'lps'),
	(435536, 125, '2015-03-01 00:41:17.000000', 'consum', 0.0215, 'lps'),
	(435537, 125, '2015-03-01 00:41:18.000000', 'consum', 0.0224, 'lps'),
	(435538, 125, '2015-03-01 00:41:19.000000', 'consum', 0.0213, 'lps'),
	(435539, 125, '2015-03-01 00:41:20.000000', 'consum', 0.0219, 'lps'),
	(435540, 125, '2015-03-01 00:41:21.000000', 'consum', 0.0210, 'lps'),
	(435541, 125, '2015-03-01 00:41:22.000000', 'consum', 0.0219, 'lps'),
	(435542, 125, '2015-03-01 00:41:23.000000', 'consum', 0.0222, 'lps'),
	(435543, 125, '2015-03-01 00:41:24.000000', 'consum', 0.0226, 'lps'),
	(435544, 125, '2015-03-01 00:41:25.000000', 'consum', 0.0221, 'lps'),
	(435545, 125, '2015-03-01 00:41:26.000000', 'consum', 0.0219, 'lps'),
	(435546, 125, '2015-03-01 00:41:27.000000', 'consum', 0.0222, 'lps'),
	(435547, 125, '2015-03-01 00:41:28.000000', 'consum', 0.0225, 'lps'),
	(435548, 125, '2015-03-01 00:41:29.000000', 'consum', 0.0214, 'lps'),
	(435549, 125, '2015-03-01 00:41:30.000000', 'consum', 0.0221, 'lps'),
	(435550, 125, '2015-03-01 00:41:31.000000', 'consum', 0.0221, 'lps'),
	(435551, 125, '2015-03-01 00:41:32.000000', 'consum', 0.0214, 'lps'),
	(435552, 125, '2015-03-01 00:41:33.000000', 'consum', 0.0214, 'lps'),
	(435553, 125, '2015-03-01 00:41:34.000000', 'consum', 0.0219, 'lps'),
	(435554, 125, '2015-03-01 00:41:35.000000', 'consum', 0.0210, 'lps'),
	(435555, 125, '2015-03-01 00:41:36.000000', 'consum', 0.0219, 'lps'),
	(435556, 125, '2015-03-01 00:41:37.000000', 'consum', 0.0220, 'lps'),
	(435557, 125, '2015-03-01 00:41:38.000000', 'consum', 0.0217, 'lps'),
	(435558, 125, '2015-03-01 00:41:39.000000', 'consum', 0.0213, 'lps'),
	(435559, 125, '2015-03-01 00:41:40.000000', 'consum', 0.0225, 'lps'),
	(435560, 125, '2015-03-01 00:41:41.000000', 'consum', 0.0224, 'lps'),
	(435561, 125, '2015-03-01 00:41:42.000000', 'consum', 0.0219, 'lps'),
	(435562, 125, '2015-03-01 00:41:43.000000', 'consum', 0.0213, 'lps'),
	(435563, 125, '2015-03-01 00:41:44.000000', 'consum', 0.0216, 'lps'),
	(435564, 125, '2015-03-01 00:41:45.000000', 'consum', 0.0213, 'lps'),
	(435565, 125, '2015-03-01 00:41:46.000000', 'consum', 0.0225, 'lps'),
	(435566, 125, '2015-03-01 00:41:47.000000', 'consum', 0.0225, 'lps'),
	(435567, 125, '2015-03-01 00:41:48.000000', 'consum', 0.0224, 'lps'),
	(435568, 125, '2015-03-01 00:41:49.000000', 'consum', 0.0216, 'lps'),
	(435569, 125, '2015-03-01 00:41:50.000000', 'consum', 0.0219, 'lps'),
	(435570, 125, '2015-03-01 00:41:51.000000', 'consum', 0.0221, 'lps'),
	(435571, 125, '2015-03-01 00:41:52.000000', 'consum', 0.0219, 'lps'),
	(435572, 125, '2015-03-01 00:41:53.000000', 'consum', 0.0225, 'lps'),
	(435573, 125, '2015-03-01 00:41:54.000000', 'consum', 0.0222, 'lps'),
	(435574, 125, '2015-03-01 00:41:55.000000', 'consum', 0.0211, 'lps'),
	(435575, 125, '2015-03-01 00:41:56.000000', 'consum', 0.0214, 'lps'),
	(435576, 125, '2015-03-01 00:41:57.000000', 'consum', 0.0210, 'lps'),
	(435577, 125, '2015-03-01 00:41:58.000000', 'consum', 0.0213, 'lps'),
	(435578, 125, '2015-03-01 00:41:59.000000', 'consum', 0.0210, 'lps'),
	(435579, 125, '2015-03-01 00:42:00.000000', 'consum', 0.0218, 'lps'),
	(435580, 125, '2015-03-01 00:42:01.000000', 'consum', 0.0218, 'lps'),
	(435581, 125, '2015-03-01 00:42:02.000000', 'consum', 0.0211, 'lps'),
	(435582, 125, '2015-03-01 00:42:03.000000', 'consum', 0.0222, 'lps'),
	(435583, 125, '2015-03-01 00:42:04.000000', 'consum', 0.0217, 'lps'),
	(435584, 125, '2015-03-01 00:42:05.000000', 'consum', 0.0226, 'lps'),
	(435585, 125, '2015-03-01 00:42:06.000000', 'consum', 0.0219, 'lps'),
	(435586, 125, '2015-03-01 00:42:07.000000', 'consum', 0.0225, 'lps'),
	(435587, 125, '2015-03-01 00:42:08.000000', 'consum', 0.0226, 'lps'),
	(435588, 125, '2015-03-01 00:42:09.000000', 'consum', 0.0226, 'lps'),
	(435589, 125, '2015-03-01 00:42:10.000000', 'consum', 0.0225, 'lps'),
	(435590, 125, '2015-03-01 00:42:11.000000', 'consum', 0.0222, 'lps'),
	(435591, 125, '2015-03-01 00:42:12.000000', 'consum', 0.0224, 'lps'),
	(435592, 125, '2015-03-01 00:42:13.000000', 'consum', 0.0226, 'lps'),
	(435593, 125, '2015-03-01 00:42:14.000000', 'consum', 0.0217, 'lps'),
	(435594, 125, '2015-03-01 00:42:15.000000', 'consum', 0.0216, 'lps'),
	(435595, 125, '2015-03-01 00:42:16.000000', 'consum', 0.0216, 'lps'),
	(435596, 125, '2015-03-01 00:42:17.000000', 'consum', 0.0224, 'lps'),
	(435597, 125, '2015-03-01 00:42:18.000000', 'consum', 0.0213, 'lps'),
	(435598, 125, '2015-03-01 00:42:19.000000', 'consum', 0.0217, 'lps'),
	(435599, 125, '2015-03-01 00:42:20.000000', 'consum', 0.0221, 'lps'),
	(435600, 125, '2015-03-01 00:42:21.000000', 'consum', 0.0224, 'lps'),
	(435601, 125, '2015-03-01 00:42:22.000000', 'consum', 0.0215, 'lps'),
	(435602, 125, '2015-03-01 00:42:23.000000', 'consum', 0.0211, 'lps'),
	(435603, 125, '2015-03-01 00:42:24.000000', 'consum', 0.0218, 'lps'),
	(435604, 125, '2015-03-01 00:42:25.000000', 'consum', 0.0214, 'lps'),
	(435605, 125, '2015-03-01 00:42:26.000000', 'consum', 0.0221, 'lps'),
	(435606, 125, '2015-03-01 00:42:27.000000', 'consum', 0.0221, 'lps'),
	(435607, 125, '2015-03-01 00:42:28.000000', 'consum', 0.0214, 'lps'),
	(435608, 125, '2015-03-01 00:42:29.000000', 'consum', 0.0216, 'lps'),
	(435609, 125, '2015-03-01 00:42:30.000000', 'consum', 0.0210, 'lps'),
	(435610, 125, '2015-03-01 00:42:31.000000', 'consum', 0.0212, 'lps'),
	(435611, 125, '2015-03-01 00:42:32.000000', 'consum', 0.0217, 'lps'),
	(435612, 125, '2015-03-01 00:42:33.000000', 'consum', 0.0225, 'lps'),
	(435613, 125, '2015-03-01 00:42:34.000000', 'consum', 0.0214, 'lps'),
	(435614, 125, '2015-03-01 00:42:35.000000', 'consum', 0.0218, 'lps'),
	(435615, 125, '2015-03-01 00:42:36.000000', 'consum', 0.0223, 'lps'),
	(435616, 125, '2015-03-01 00:42:37.000000', 'consum', 0.0216, 'lps'),
	(435617, 125, '2015-03-01 00:42:38.000000', 'consum', 0.0218, 'lps'),
	(435618, 125, '2015-03-01 00:42:39.000000', 'consum', 0.0218, 'lps'),
	(435619, 125, '2015-03-01 00:42:40.000000', 'consum', 0.0225, 'lps'),
	(435620, 125, '2015-03-01 00:42:41.000000', 'consum', 0.0212, 'lps'),
	(435621, 125, '2015-03-01 00:42:42.000000', 'consum', 0.0211, 'lps'),
	(435622, 125, '2015-03-01 00:42:43.000000', 'consum', 0.0223, 'lps'),
	(435623, 125, '2015-03-01 00:42:44.000000', 'consum', 0.0222, 'lps'),
	(435624, 125, '2015-03-01 00:42:45.000000', 'consum', 0.0217, 'lps'),
	(435625, 125, '2015-03-01 00:42:46.000000', 'consum', 0.0225, 'lps'),
	(435626, 125, '2015-03-01 00:42:47.000000', 'consum', 0.0215, 'lps'),
	(435627, 125, '2015-03-01 00:42:48.000000', 'consum', 0.0225, 'lps'),
	(435628, 125, '2015-03-01 00:42:49.000000', 'consum', 0.0219, 'lps'),
	(435629, 125, '2015-03-01 00:42:50.000000', 'consum', 0.0226, 'lps'),
	(435630, 125, '2015-03-01 00:42:51.000000', 'consum', 0.0211, 'lps'),
	(435631, 125, '2015-03-01 00:42:52.000000', 'consum', 0.0221, 'lps'),
	(435632, 125, '2015-03-01 00:42:53.000000', 'consum', 0.0210, 'lps'),
	(435633, 125, '2015-03-01 00:42:54.000000', 'consum', 0.0213, 'lps'),
	(435634, 125, '2015-03-01 00:42:55.000000', 'consum', 0.0225, 'lps'),
	(435635, 125, '2015-03-01 00:42:56.000000', 'consum', 0.0224, 'lps'),
	(435636, 125, '2015-03-01 00:42:57.000000', 'consum', 0.0218, 'lps'),
	(435637, 125, '2015-03-01 00:42:58.000000', 'consum', 0.0226, 'lps'),
	(435638, 125, '2015-03-01 00:42:59.000000', 'consum', 0.0215, 'lps'),
	(435639, 125, '2015-03-01 00:43:00.000000', 'consum', 0.0220, 'lps'),
	(435640, 125, '2015-03-01 00:43:01.000000', 'consum', 0.0214, 'lps'),
	(435641, 125, '2015-03-01 00:43:02.000000', 'consum', 0.0219, 'lps'),
	(435642, 125, '2015-03-01 00:43:03.000000', 'consum', 0.0224, 'lps'),
	(435643, 125, '2015-03-01 00:43:04.000000', 'consum', 0.0219, 'lps'),
	(435644, 125, '2015-03-01 00:43:05.000000', 'consum', 0.0213, 'lps'),
	(435645, 125, '2015-03-01 00:43:06.000000', 'consum', 0.0215, 'lps'),
	(435646, 125, '2015-03-01 00:43:07.000000', 'consum', 0.0211, 'lps'),
	(435647, 125, '2015-03-01 00:43:08.000000', 'consum', 0.0218, 'lps'),
	(435648, 125, '2015-03-01 00:43:09.000000', 'consum', 0.0212, 'lps'),
	(435649, 125, '2015-03-01 00:43:10.000000', 'consum', 0.0215, 'lps'),
	(435650, 125, '2015-03-01 00:43:11.000000', 'consum', 0.0213, 'lps'),
	(435651, 125, '2015-03-01 00:43:12.000000', 'consum', 0.0225, 'lps'),
	(435652, 125, '2015-03-01 00:43:13.000000', 'consum', 0.0211, 'lps'),
	(435653, 125, '2015-03-01 00:43:14.000000', 'consum', 0.0222, 'lps'),
	(435654, 125, '2015-03-01 00:43:15.000000', 'consum', 0.0216, 'lps'),
	(435655, 125, '2015-03-01 00:43:16.000000', 'consum', 0.0219, 'lps'),
	(435656, 125, '2015-03-01 00:43:17.000000', 'consum', 0.0223, 'lps'),
	(435657, 125, '2015-03-01 00:43:18.000000', 'consum', 0.0215, 'lps'),
	(435658, 125, '2015-03-01 00:43:19.000000', 'consum', 0.0214, 'lps'),
	(435659, 125, '2015-03-01 00:43:20.000000', 'consum', 0.0215, 'lps'),
	(435660, 125, '2015-03-01 00:43:21.000000', 'consum', 0.0225, 'lps'),
	(435661, 125, '2015-03-01 00:43:22.000000', 'consum', 0.0217, 'lps'),
	(435662, 125, '2015-03-01 00:43:23.000000', 'consum', 0.0219, 'lps'),
	(435663, 125, '2015-03-01 00:43:24.000000', 'consum', 0.0218, 'lps'),
	(435664, 125, '2015-03-01 00:43:25.000000', 'consum', 0.0224, 'lps'),
	(435665, 125, '2015-03-01 00:43:26.000000', 'consum', 0.0221, 'lps'),
	(435666, 125, '2015-03-01 00:43:27.000000', 'consum', 0.0225, 'lps'),
	(435667, 125, '2015-03-01 00:43:28.000000', 'consum', 0.0217, 'lps'),
	(435668, 125, '2015-03-01 00:43:29.000000', 'consum', 0.0219, 'lps'),
	(435669, 125, '2015-03-01 00:43:30.000000', 'consum', 0.0215, 'lps'),
	(435670, 125, '2015-03-01 00:43:31.000000', 'consum', 0.0225, 'lps'),
	(435671, 125, '2015-03-01 00:43:32.000000', 'consum', 0.0223, 'lps'),
	(435672, 125, '2015-03-01 00:43:33.000000', 'consum', 0.0211, 'lps'),
	(435673, 125, '2015-03-01 00:43:34.000000', 'consum', 0.0226, 'lps'),
	(435674, 125, '2015-03-01 00:43:35.000000', 'consum', 0.0221, 'lps'),
	(435675, 125, '2015-03-01 00:43:36.000000', 'consum', 0.0218, 'lps'),
	(435676, 125, '2015-03-01 00:43:37.000000', 'consum', 0.0218, 'lps'),
	(435677, 125, '2015-03-01 00:43:38.000000', 'consum', 0.0226, 'lps'),
	(435678, 125, '2015-03-01 00:43:39.000000', 'consum', 0.0216, 'lps'),
	(435679, 125, '2015-03-01 00:43:40.000000', 'consum', 0.0225, 'lps'),
	(435680, 125, '2015-03-01 00:43:41.000000', 'consum', 0.0218, 'lps'),
	(435681, 125, '2015-03-01 00:43:42.000000', 'consum', 0.0221, 'lps'),
	(435682, 125, '2015-03-01 00:43:43.000000', 'consum', 0.0226, 'lps'),
	(435683, 125, '2015-03-01 00:43:44.000000', 'consum', 0.0221, 'lps'),
	(435684, 125, '2015-03-01 00:43:45.000000', 'consum', 0.0221, 'lps'),
	(435685, 125, '2015-03-01 00:43:46.000000', 'consum', 0.0214, 'lps'),
	(435686, 125, '2015-03-01 00:43:47.000000', 'consum', 0.0214, 'lps'),
	(435687, 125, '2015-03-01 00:43:48.000000', 'consum', 0.0219, 'lps'),
	(435688, 125, '2015-03-01 00:43:49.000000', 'consum', 0.0211, 'lps'),
	(435689, 125, '2015-03-01 00:43:50.000000', 'consum', 0.0224, 'lps'),
	(435690, 125, '2015-03-01 00:43:51.000000', 'consum', 0.0223, 'lps'),
	(435691, 125, '2015-03-01 00:43:52.000000', 'consum', 0.0216, 'lps'),
	(435692, 125, '2015-03-01 00:43:53.000000', 'consum', 0.0218, 'lps'),
	(435693, 125, '2015-03-01 00:43:54.000000', 'consum', 0.0217, 'lps'),
	(435694, 125, '2015-03-01 00:43:55.000000', 'consum', 0.0223, 'lps'),
	(435695, 125, '2015-03-01 00:43:56.000000', 'consum', 0.0220, 'lps'),
	(435696, 125, '2015-03-01 00:43:57.000000', 'consum', 0.0222, 'lps'),
	(435697, 125, '2015-03-01 00:43:58.000000', 'consum', 0.0223, 'lps'),
	(435698, 125, '2015-03-01 00:43:59.000000', 'consum', 0.0224, 'lps'),
	(435699, 125, '2015-03-01 00:44:00.000000', 'consum', 0.0222, 'lps'),
	(435700, 125, '2015-03-01 00:44:01.000000', 'consum', 0.0211, 'lps'),
	(435701, 125, '2015-03-01 00:44:02.000000', 'consum', 0.0216, 'lps'),
	(435702, 125, '2015-03-01 00:44:03.000000', 'consum', 0.0217, 'lps'),
	(435703, 125, '2015-03-01 00:44:04.000000', 'consum', 0.0214, 'lps'),
	(435704, 125, '2015-03-01 00:44:05.000000', 'consum', 0.0226, 'lps'),
	(435705, 125, '2015-03-01 00:44:06.000000', 'consum', 0.0210, 'lps'),
	(435706, 125, '2015-03-01 00:44:07.000000', 'consum', 0.0215, 'lps'),
	(435707, 125, '2015-03-01 00:44:08.000000', 'consum', 0.0217, 'lps'),
	(435708, 125, '2015-03-01 00:44:09.000000', 'consum', 0.0216, 'lps'),
	(435709, 125, '2015-03-01 00:44:10.000000', 'consum', 0.0217, 'lps'),
	(435710, 125, '2015-03-01 00:44:11.000000', 'consum', 0.0213, 'lps'),
	(435711, 125, '2015-03-01 00:44:12.000000', 'consum', 0.0221, 'lps'),
	(435712, 125, '2015-03-01 00:44:13.000000', 'consum', 0.0224, 'lps'),
	(435713, 125, '2015-03-01 00:44:14.000000', 'consum', 0.0211, 'lps'),
	(435714, 125, '2015-03-01 00:44:15.000000', 'consum', 0.0224, 'lps'),
	(435715, 125, '2015-03-01 00:44:16.000000', 'consum', 0.0211, 'lps'),
	(435716, 125, '2015-03-01 00:44:17.000000', 'consum', 0.0223, 'lps'),
	(435717, 125, '2015-03-01 00:44:18.000000', 'consum', 0.0222, 'lps'),
	(435718, 125, '2015-03-01 00:44:19.000000', 'consum', 0.0215, 'lps'),
	(435719, 125, '2015-03-01 00:44:20.000000', 'consum', 0.0217, 'lps'),
	(435720, 125, '2015-03-01 00:44:21.000000', 'consum', 0.0214, 'lps'),
	(435721, 125, '2015-03-01 00:44:22.000000', 'consum', 0.0224, 'lps'),
	(435722, 125, '2015-03-01 00:44:23.000000', 'consum', 0.0220, 'lps'),
	(435723, 125, '2015-03-01 00:44:24.000000', 'consum', 0.0216, 'lps'),
	(435724, 125, '2015-03-01 00:44:25.000000', 'consum', 0.0211, 'lps'),
	(435725, 125, '2015-03-01 00:44:26.000000', 'consum', 0.0214, 'lps'),
	(435726, 125, '2015-03-01 00:44:27.000000', 'consum', 0.0226, 'lps'),
	(435727, 125, '2015-03-01 00:44:28.000000', 'consum', 0.0213, 'lps'),
	(435728, 125, '2015-03-01 00:44:29.000000', 'consum', 0.0213, 'lps'),
	(435729, 125, '2015-03-01 00:44:30.000000', 'consum', 0.0214, 'lps'),
	(435730, 125, '2015-03-01 00:44:31.000000', 'consum', 0.0223, 'lps'),
	(435731, 125, '2015-03-01 00:44:32.000000', 'consum', 0.0211, 'lps'),
	(435732, 125, '2015-03-01 00:44:33.000000', 'consum', 0.0210, 'lps'),
	(435733, 125, '2015-03-01 00:44:34.000000', 'consum', 0.0223, 'lps'),
	(435734, 125, '2015-03-01 00:44:35.000000', 'consum', 0.0211, 'lps'),
	(435735, 125, '2015-03-01 00:44:36.000000', 'consum', 0.0226, 'lps'),
	(435736, 125, '2015-03-01 00:44:37.000000', 'consum', 0.0219, 'lps'),
	(435737, 125, '2015-03-01 00:44:38.000000', 'consum', 0.0224, 'lps'),
	(435738, 125, '2015-03-01 00:44:39.000000', 'consum', 0.0222, 'lps'),
	(435739, 125, '2015-03-01 00:44:40.000000', 'consum', 0.0211, 'lps'),
	(435740, 125, '2015-03-01 00:44:41.000000', 'consum', 0.0212, 'lps'),
	(435741, 125, '2015-03-01 00:44:42.000000', 'consum', 0.0217, 'lps'),
	(435742, 125, '2015-03-01 00:44:43.000000', 'consum', 0.0224, 'lps'),
	(435743, 125, '2015-03-01 00:44:44.000000', 'consum', 0.0226, 'lps'),
	(435744, 125, '2015-03-01 00:44:45.000000', 'consum', 0.0213, 'lps'),
	(435745, 125, '2015-03-01 00:44:46.000000', 'consum', 0.0212, 'lps'),
	(435746, 125, '2015-03-01 00:44:47.000000', 'consum', 0.0212, 'lps'),
	(435747, 125, '2015-03-01 00:44:48.000000', 'consum', 0.0214, 'lps'),
	(435748, 125, '2015-03-01 00:44:49.000000', 'consum', 0.0226, 'lps'),
	(435749, 125, '2015-03-01 00:44:50.000000', 'consum', 0.0225, 'lps'),
	(435750, 125, '2015-03-01 00:44:51.000000', 'consum', 0.0220, 'lps'),
	(435751, 125, '2015-03-01 00:44:52.000000', 'consum', 0.0217, 'lps'),
	(435752, 125, '2015-03-01 00:44:53.000000', 'consum', 0.0215, 'lps'),
	(435753, 125, '2015-03-01 00:44:54.000000', 'consum', 0.0215, 'lps'),
	(435754, 125, '2015-03-01 00:44:55.000000', 'consum', 0.0220, 'lps'),
	(435755, 125, '2015-03-01 00:44:56.000000', 'consum', 0.0213, 'lps'),
	(435756, 125, '2015-03-01 00:44:57.000000', 'consum', 0.0213, 'lps'),
	(435757, 125, '2015-03-01 00:44:58.000000', 'consum', 0.0217, 'lps'),
	(435758, 125, '2015-03-01 00:44:59.000000', 'consum', 0.0220, 'lps'),
	(435759, 125, '2015-03-01 00:45:00.000000', 'consum', 0.0223, 'lps'),
	(435760, 125, '2015-03-01 00:45:01.000000', 'consum', 0.0226, 'lps'),
	(435761, 125, '2015-03-01 00:45:02.000000', 'consum', 0.0218, 'lps'),
	(435762, 125, '2015-03-01 00:45:03.000000', 'consum', 0.0220, 'lps'),
	(435763, 125, '2015-03-01 00:45:04.000000', 'consum', 0.0220, 'lps'),
	(435764, 125, '2015-03-01 00:45:05.000000', 'consum', 0.0215, 'lps'),
	(435765, 125, '2015-03-01 00:45:06.000000', 'consum', 0.0222, 'lps'),
	(435766, 125, '2015-03-01 00:45:07.000000', 'consum', 0.0221, 'lps'),
	(435767, 125, '2015-03-01 00:45:08.000000', 'consum', 0.0213, 'lps'),
	(435768, 125, '2015-03-01 00:45:09.000000', 'consum', 0.0211, 'lps'),
	(435769, 125, '2015-03-01 00:45:10.000000', 'consum', 0.0221, 'lps'),
	(435770, 125, '2015-03-01 00:45:11.000000', 'consum', 0.0214, 'lps'),
	(435771, 125, '2015-03-01 00:45:12.000000', 'consum', 0.0215, 'lps'),
	(435772, 125, '2015-03-01 00:45:13.000000', 'consum', 0.0224, 'lps'),
	(435773, 125, '2015-03-01 00:45:14.000000', 'consum', 0.0212, 'lps'),
	(435774, 125, '2015-03-01 00:45:15.000000', 'consum', 0.0214, 'lps'),
	(435775, 125, '2015-03-01 00:45:16.000000', 'consum', 0.0225, 'lps'),
	(435776, 125, '2015-03-01 00:45:17.000000', 'consum', 0.0221, 'lps'),
	(435777, 125, '2015-03-01 00:45:18.000000', 'consum', 0.0221, 'lps'),
	(435778, 125, '2015-03-01 00:45:19.000000', 'consum', 0.0218, 'lps'),
	(435779, 125, '2015-03-01 00:45:20.000000', 'consum', 0.0214, 'lps'),
	(435780, 125, '2015-03-01 00:45:21.000000', 'consum', 0.0225, 'lps'),
	(435781, 125, '2015-03-01 00:45:22.000000', 'consum', 0.0223, 'lps'),
	(435782, 125, '2015-03-01 00:45:23.000000', 'consum', 0.0212, 'lps'),
	(435783, 125, '2015-03-01 00:45:24.000000', 'consum', 0.0216, 'lps'),
	(435784, 125, '2015-03-01 00:45:25.000000', 'consum', 0.0219, 'lps'),
	(435785, 125, '2015-03-01 00:45:26.000000', 'consum', 0.0218, 'lps'),
	(435786, 125, '2015-03-01 00:45:27.000000', 'consum', 0.0225, 'lps'),
	(435787, 125, '2015-03-01 00:45:28.000000', 'consum', 0.0211, 'lps'),
	(435788, 125, '2015-03-01 00:45:29.000000', 'consum', 0.0220, 'lps'),
	(435789, 125, '2015-03-01 00:45:30.000000', 'consum', 0.0224, 'lps'),
	(435790, 125, '2015-03-01 00:45:31.000000', 'consum', 0.0217, 'lps'),
	(435791, 125, '2015-03-01 00:45:32.000000', 'consum', 0.0218, 'lps'),
	(435792, 125, '2015-03-01 00:45:33.000000', 'consum', 0.0215, 'lps'),
	(435793, 125, '2015-03-01 00:45:34.000000', 'consum', 0.0210, 'lps'),
	(435794, 125, '2015-03-01 00:45:35.000000', 'consum', 0.0212, 'lps'),
	(435795, 125, '2015-03-01 00:45:36.000000', 'consum', 0.0221, 'lps'),
	(435796, 125, '2015-03-01 00:45:37.000000', 'consum', 0.0210, 'lps'),
	(435797, 125, '2015-03-01 00:45:38.000000', 'consum', 0.0210, 'lps'),
	(435798, 125, '2015-03-01 00:45:39.000000', 'consum', 0.0213, 'lps'),
	(435799, 125, '2015-03-01 00:45:40.000000', 'consum', 0.0223, 'lps'),
	(435800, 125, '2015-03-01 00:45:41.000000', 'consum', 0.0217, 'lps'),
	(435801, 125, '2015-03-01 00:45:42.000000', 'consum', 0.0221, 'lps'),
	(435802, 125, '2015-03-01 00:45:43.000000', 'consum', 0.0213, 'lps'),
	(435803, 125, '2015-03-01 00:45:44.000000', 'consum', 0.0225, 'lps'),
	(435804, 125, '2015-03-01 00:45:45.000000', 'consum', 0.0226, 'lps'),
	(435805, 125, '2015-03-01 00:45:46.000000', 'consum', 0.0210, 'lps'),
	(435806, 125, '2015-03-01 00:45:47.000000', 'consum', 0.0216, 'lps'),
	(435807, 125, '2015-03-01 00:45:48.000000', 'consum', 0.0223, 'lps'),
	(435808, 125, '2015-03-01 00:45:49.000000', 'consum', 0.0224, 'lps'),
	(435809, 125, '2015-03-01 00:45:50.000000', 'consum', 0.0225, 'lps'),
	(435810, 125, '2015-03-01 00:45:51.000000', 'consum', 0.0210, 'lps'),
	(435811, 125, '2015-03-01 00:45:52.000000', 'consum', 0.0215, 'lps'),
	(435812, 125, '2015-03-01 00:45:53.000000', 'consum', 0.0219, 'lps'),
	(435813, 125, '2015-03-01 00:45:54.000000', 'consum', 0.0223, 'lps'),
	(435814, 125, '2015-03-01 00:45:55.000000', 'consum', 0.0215, 'lps'),
	(435815, 125, '2015-03-01 00:45:56.000000', 'consum', 0.0214, 'lps'),
	(435816, 125, '2015-03-01 00:45:57.000000', 'consum', 0.0215, 'lps'),
	(435817, 125, '2015-03-01 00:45:58.000000', 'consum', 0.0223, 'lps'),
	(435818, 125, '2015-03-01 00:45:59.000000', 'consum', 0.0211, 'lps'),
	(435819, 125, '2015-03-01 00:46:00.000000', 'consum', 0.0225, 'lps'),
	(435820, 125, '2015-03-01 00:46:01.000000', 'consum', 0.0215, 'lps'),
	(435821, 125, '2015-03-01 00:46:02.000000', 'consum', 0.0226, 'lps'),
	(435822, 125, '2015-03-01 00:46:03.000000', 'consum', 0.0225, 'lps'),
	(435823, 125, '2015-03-01 00:46:04.000000', 'consum', 0.0218, 'lps'),
	(435824, 125, '2015-03-01 00:46:05.000000', 'consum', 0.0224, 'lps'),
	(435825, 125, '2015-03-01 00:46:06.000000', 'consum', 0.0220, 'lps'),
	(435826, 125, '2015-03-01 00:46:07.000000', 'consum', 0.0222, 'lps'),
	(435827, 125, '2015-03-01 00:46:08.000000', 'consum', 0.0222, 'lps'),
	(435828, 125, '2015-03-01 00:46:09.000000', 'consum', 0.0219, 'lps'),
	(435829, 125, '2015-03-01 00:46:10.000000', 'consum', 0.0218, 'lps'),
	(435830, 125, '2015-03-01 00:46:11.000000', 'consum', 0.0223, 'lps'),
	(435831, 125, '2015-03-01 00:46:12.000000', 'consum', 0.0216, 'lps'),
	(435832, 125, '2015-03-01 00:46:13.000000', 'consum', 0.0221, 'lps'),
	(435833, 125, '2015-03-01 00:46:14.000000', 'consum', 0.0214, 'lps'),
	(435834, 125, '2015-03-01 00:46:15.000000', 'consum', 0.0213, 'lps'),
	(435835, 125, '2015-03-01 00:46:16.000000', 'consum', 0.0214, 'lps'),
	(435836, 125, '2015-03-01 00:46:17.000000', 'consum', 0.0223, 'lps'),
	(435837, 125, '2015-03-01 00:46:18.000000', 'consum', 0.0211, 'lps'),
	(435838, 125, '2015-03-01 00:46:19.000000', 'consum', 0.0210, 'lps'),
	(435839, 125, '2015-03-01 00:46:20.000000', 'consum', 0.0223, 'lps'),
	(435840, 125, '2015-03-01 00:46:21.000000', 'consum', 0.0210, 'lps'),
	(435841, 125, '2015-03-01 00:46:22.000000', 'consum', 0.0221, 'lps'),
	(435842, 125, '2015-03-01 00:46:23.000000', 'consum', 0.0216, 'lps'),
	(435843, 125, '2015-03-01 00:46:24.000000', 'consum', 0.0224, 'lps'),
	(435844, 125, '2015-03-01 00:46:25.000000', 'consum', 0.0213, 'lps'),
	(435845, 125, '2015-03-01 00:46:26.000000', 'consum', 0.0216, 'lps'),
	(435846, 125, '2015-03-01 00:46:27.000000', 'consum', 0.0214, 'lps'),
	(435847, 125, '2015-03-01 00:46:28.000000', 'consum', 0.0215, 'lps'),
	(435848, 125, '2015-03-01 00:46:29.000000', 'consum', 0.0222, 'lps'),
	(435849, 125, '2015-03-01 00:46:30.000000', 'consum', 0.0221, 'lps'),
	(435850, 125, '2015-03-01 00:46:31.000000', 'consum', 0.0211, 'lps'),
	(435851, 125, '2015-03-01 00:46:32.000000', 'consum', 0.0218, 'lps'),
	(435852, 125, '2015-03-01 00:46:33.000000', 'consum', 0.0214, 'lps'),
	(435853, 125, '2015-03-01 00:46:34.000000', 'consum', 0.0225, 'lps'),
	(435854, 125, '2015-03-01 00:46:35.000000', 'consum', 0.0220, 'lps'),
	(435855, 125, '2015-03-01 00:46:36.000000', 'consum', 0.0218, 'lps'),
	(435856, 125, '2015-03-01 00:46:37.000000', 'consum', 0.0217, 'lps'),
	(435857, 125, '2015-03-01 00:46:38.000000', 'consum', 0.0225, 'lps'),
	(435858, 125, '2015-03-01 00:46:39.000000', 'consum', 0.0210, 'lps'),
	(435859, 125, '2015-03-01 00:46:40.000000', 'consum', 0.0219, 'lps'),
	(435860, 125, '2015-03-01 00:46:41.000000', 'consum', 0.0220, 'lps'),
	(435861, 125, '2015-03-01 00:46:42.000000', 'consum', 0.0219, 'lps'),
	(435862, 125, '2015-03-01 00:46:43.000000', 'consum', 0.0223, 'lps'),
	(435863, 125, '2015-03-01 00:46:44.000000', 'consum', 0.0214, 'lps'),
	(435864, 125, '2015-03-01 00:46:45.000000', 'consum', 0.0210, 'lps'),
	(435865, 125, '2015-03-01 00:46:46.000000', 'consum', 0.0214, 'lps'),
	(435866, 125, '2015-03-01 00:46:47.000000', 'consum', 0.0214, 'lps'),
	(435867, 125, '2015-03-01 00:46:48.000000', 'consum', 0.0218, 'lps'),
	(435868, 125, '2015-03-01 00:46:49.000000', 'consum', 0.0223, 'lps'),
	(435869, 125, '2015-03-01 00:46:50.000000', 'consum', 0.0216, 'lps'),
	(435870, 125, '2015-03-01 00:46:51.000000', 'consum', 0.0221, 'lps'),
	(435871, 125, '2015-03-01 00:46:52.000000', 'consum', 0.0211, 'lps'),
	(435872, 125, '2015-03-01 00:46:53.000000', 'consum', 0.0217, 'lps'),
	(435873, 125, '2015-03-01 00:46:54.000000', 'consum', 0.0224, 'lps'),
	(435874, 125, '2015-03-01 00:46:55.000000', 'consum', 0.0225, 'lps'),
	(435875, 125, '2015-03-01 00:46:56.000000', 'consum', 0.0212, 'lps'),
	(435876, 125, '2015-03-01 00:46:57.000000', 'consum', 0.0224, 'lps'),
	(435877, 125, '2015-03-01 00:46:58.000000', 'consum', 0.0225, 'lps'),
	(435878, 125, '2015-03-01 00:46:59.000000', 'consum', 0.0210, 'lps'),
	(435879, 125, '2015-03-01 00:47:00.000000', 'consum', 0.0214, 'lps'),
	(435880, 125, '2015-03-01 00:47:01.000000', 'consum', 0.0216, 'lps'),
	(435881, 125, '2015-03-01 00:47:02.000000', 'consum', 0.0226, 'lps'),
	(435882, 125, '2015-03-01 00:47:03.000000', 'consum', 0.0223, 'lps'),
	(435883, 125, '2015-03-01 00:47:04.000000', 'consum', 0.0225, 'lps'),
	(435884, 125, '2015-03-01 00:47:05.000000', 'consum', 0.0215, 'lps'),
	(435885, 125, '2015-03-01 00:47:06.000000', 'consum', 0.0224, 'lps'),
	(435886, 125, '2015-03-01 00:47:07.000000', 'consum', 0.0215, 'lps'),
	(435887, 125, '2015-03-01 00:47:08.000000', 'consum', 0.0211, 'lps'),
	(435888, 125, '2015-03-01 00:47:09.000000', 'consum', 0.0218, 'lps'),
	(435889, 125, '2015-03-01 00:47:10.000000', 'consum', 0.0213, 'lps'),
	(435890, 125, '2015-03-01 00:47:11.000000', 'consum', 0.0217, 'lps'),
	(435891, 125, '2015-03-01 00:47:12.000000', 'consum', 0.0221, 'lps'),
	(435892, 125, '2015-03-01 00:47:13.000000', 'consum', 0.0226, 'lps'),
	(435893, 125, '2015-03-01 00:47:14.000000', 'consum', 0.0223, 'lps'),
	(435894, 125, '2015-03-01 00:47:15.000000', 'consum', 0.0211, 'lps'),
	(435895, 125, '2015-03-01 00:47:16.000000', 'consum', 0.0213, 'lps'),
	(435896, 125, '2015-03-01 00:47:17.000000', 'consum', 0.0219, 'lps'),
	(435897, 125, '2015-03-01 00:47:18.000000', 'consum', 0.0215, 'lps'),
	(435898, 125, '2015-03-01 00:47:19.000000', 'consum', 0.0223, 'lps'),
	(435899, 125, '2015-03-01 00:47:20.000000', 'consum', 0.0210, 'lps'),
	(435900, 125, '2015-03-01 00:47:21.000000', 'consum', 0.0221, 'lps'),
	(435901, 125, '2015-03-01 00:47:22.000000', 'consum', 0.0217, 'lps'),
	(435902, 125, '2015-03-01 00:47:23.000000', 'consum', 0.0212, 'lps'),
	(435903, 125, '2015-03-01 00:47:24.000000', 'consum', 0.0217, 'lps'),
	(435904, 125, '2015-03-01 00:47:25.000000', 'consum', 0.0220, 'lps'),
	(435905, 125, '2015-03-01 00:47:26.000000', 'consum', 0.0226, 'lps'),
	(435906, 125, '2015-03-01 00:47:27.000000', 'consum', 0.0225, 'lps'),
	(435907, 125, '2015-03-01 00:47:28.000000', 'consum', 0.0219, 'lps'),
	(435908, 125, '2015-03-01 00:47:29.000000', 'consum', 0.0213, 'lps'),
	(435909, 125, '2015-03-01 00:47:30.000000', 'consum', 0.0214, 'lps'),
	(435910, 125, '2015-03-01 00:47:31.000000', 'consum', 0.0221, 'lps'),
	(435911, 125, '2015-03-01 00:47:32.000000', 'consum', 0.0222, 'lps'),
	(435912, 125, '2015-03-01 00:47:33.000000', 'consum', 0.0219, 'lps'),
	(435913, 125, '2015-03-01 00:47:34.000000', 'consum', 0.0221, 'lps'),
	(435914, 125, '2015-03-01 00:47:35.000000', 'consum', 0.0219, 'lps'),
	(435915, 125, '2015-03-01 00:47:36.000000', 'consum', 0.0223, 'lps'),
	(435916, 125, '2015-03-01 00:47:37.000000', 'consum', 0.0213, 'lps'),
	(435917, 125, '2015-03-01 00:47:38.000000', 'consum', 0.0221, 'lps'),
	(435918, 125, '2015-03-01 00:47:39.000000', 'consum', 0.0224, 'lps'),
	(435919, 125, '2015-03-01 00:47:40.000000', 'consum', 0.0214, 'lps'),
	(435920, 125, '2015-03-01 00:47:41.000000', 'consum', 0.0220, 'lps'),
	(435921, 125, '2015-03-01 00:47:42.000000', 'consum', 0.0215, 'lps'),
	(435922, 125, '2015-03-01 00:47:43.000000', 'consum', 0.0225, 'lps'),
	(435923, 125, '2015-03-01 00:47:44.000000', 'consum', 0.0216, 'lps'),
	(435924, 125, '2015-03-01 00:47:45.000000', 'consum', 0.0216, 'lps'),
	(435925, 125, '2015-03-01 00:47:46.000000', 'consum', 0.0220, 'lps'),
	(435926, 125, '2015-03-01 00:47:47.000000', 'consum', 0.0225, 'lps'),
	(435927, 125, '2015-03-01 00:47:48.000000', 'consum', 0.0224, 'lps'),
	(435928, 125, '2015-03-01 00:47:49.000000', 'consum', 0.0219, 'lps'),
	(435929, 125, '2015-03-01 00:47:50.000000', 'consum', 0.0211, 'lps'),
	(435930, 125, '2015-03-01 00:47:51.000000', 'consum', 0.0222, 'lps'),
	(435931, 125, '2015-03-01 00:47:52.000000', 'consum', 0.0217, 'lps'),
	(435932, 125, '2015-03-01 00:47:53.000000', 'consum', 0.0226, 'lps'),
	(435933, 125, '2015-03-01 00:47:54.000000', 'consum', 0.0221, 'lps'),
	(435934, 125, '2015-03-01 00:47:55.000000', 'consum', 0.0215, 'lps'),
	(435935, 125, '2015-03-01 00:47:56.000000', 'consum', 0.0220, 'lps'),
	(435936, 125, '2015-03-01 00:47:57.000000', 'consum', 0.0210, 'lps'),
	(435937, 125, '2015-03-01 00:47:58.000000', 'consum', 0.0215, 'lps'),
	(435938, 125, '2015-03-01 00:47:59.000000', 'consum', 0.0220, 'lps'),
	(435939, 125, '2015-03-01 00:48:00.000000', 'consum', 0.0212, 'lps'),
	(435940, 125, '2015-03-01 00:48:01.000000', 'consum', 0.0222, 'lps'),
	(435941, 125, '2015-03-01 00:48:02.000000', 'consum', 0.0214, 'lps'),
	(435942, 125, '2015-03-01 00:48:03.000000', 'consum', 0.0212, 'lps'),
	(435943, 125, '2015-03-01 00:48:04.000000', 'consum', 0.0225, 'lps'),
	(435944, 125, '2015-03-01 00:48:05.000000', 'consum', 0.0214, 'lps'),
	(435945, 125, '2015-03-01 00:48:06.000000', 'consum', 0.0216, 'lps'),
	(435946, 125, '2015-03-01 00:48:07.000000', 'consum', 0.0214, 'lps'),
	(435947, 125, '2015-03-01 00:48:08.000000', 'consum', 0.0211, 'lps'),
	(435948, 125, '2015-03-01 00:48:09.000000', 'consum', 0.0223, 'lps'),
	(435949, 125, '2015-03-01 00:48:10.000000', 'consum', 0.0219, 'lps'),
	(435950, 125, '2015-03-01 00:48:11.000000', 'consum', 0.0218, 'lps'),
	(435951, 125, '2015-03-01 00:48:12.000000', 'consum', 0.0225, 'lps'),
	(435952, 125, '2015-03-01 00:48:13.000000', 'consum', 0.0225, 'lps'),
	(435953, 125, '2015-03-01 00:48:14.000000', 'consum', 0.0224, 'lps'),
	(435954, 125, '2015-03-01 00:48:15.000000', 'consum', 0.0219, 'lps'),
	(435955, 125, '2015-03-01 00:48:16.000000', 'consum', 0.0212, 'lps'),
	(435956, 125, '2015-03-01 00:48:17.000000', 'consum', 0.0210, 'lps'),
	(435957, 125, '2015-03-01 00:48:18.000000', 'consum', 0.0222, 'lps'),
	(435958, 125, '2015-03-01 00:48:19.000000', 'consum', 0.0222, 'lps'),
	(435959, 125, '2015-03-01 00:48:20.000000', 'consum', 0.0215, 'lps'),
	(435960, 125, '2015-03-01 00:48:21.000000', 'consum', 0.0219, 'lps'),
	(435961, 125, '2015-03-01 00:48:22.000000', 'consum', 0.0220, 'lps'),
	(435962, 125, '2015-03-01 00:48:23.000000', 'consum', 0.0219, 'lps'),
	(435963, 125, '2015-03-01 00:48:24.000000', 'consum', 0.0226, 'lps'),
	(435964, 125, '2015-03-01 00:48:25.000000', 'consum', 0.0212, 'lps'),
	(435965, 125, '2015-03-01 00:48:26.000000', 'consum', 0.0222, 'lps'),
	(435966, 125, '2015-03-01 00:48:27.000000', 'consum', 0.0213, 'lps'),
	(435967, 125, '2015-03-01 00:48:28.000000', 'consum', 0.0226, 'lps'),
	(435968, 125, '2015-03-01 00:48:29.000000', 'consum', 0.0211, 'lps'),
	(435969, 125, '2015-03-01 00:48:30.000000', 'consum', 0.0221, 'lps'),
	(435970, 125, '2015-03-01 00:48:31.000000', 'consum', 0.0211, 'lps'),
	(435971, 125, '2015-03-01 00:48:32.000000', 'consum', 0.0214, 'lps'),
	(435972, 125, '2015-03-01 00:48:33.000000', 'consum', 0.0212, 'lps'),
	(435973, 125, '2015-03-01 00:48:34.000000', 'consum', 0.0226, 'lps'),
	(435974, 125, '2015-03-01 00:48:35.000000', 'consum', 0.0215, 'lps'),
	(435975, 125, '2015-03-01 00:48:36.000000', 'consum', 0.0223, 'lps'),
	(435976, 125, '2015-03-01 00:48:37.000000', 'consum', 0.0210, 'lps'),
	(435977, 125, '2015-03-01 00:48:38.000000', 'consum', 0.0221, 'lps'),
	(435978, 125, '2015-03-01 00:48:39.000000', 'consum', 0.0214, 'lps'),
	(435979, 125, '2015-03-01 00:48:40.000000', 'consum', 0.0214, 'lps'),
	(435980, 125, '2015-03-01 00:48:41.000000', 'consum', 0.0217, 'lps'),
	(435981, 125, '2015-03-01 00:48:42.000000', 'consum', 0.0220, 'lps'),
	(435982, 125, '2015-03-01 00:48:43.000000', 'consum', 0.0221, 'lps'),
	(435983, 125, '2015-03-01 00:48:44.000000', 'consum', 0.0219, 'lps'),
	(435984, 125, '2015-03-01 00:48:45.000000', 'consum', 0.0224, 'lps'),
	(435985, 125, '2015-03-01 00:48:46.000000', 'consum', 0.0219, 'lps'),
	(435986, 125, '2015-03-01 00:48:47.000000', 'consum', 0.0211, 'lps'),
	(435987, 125, '2015-03-01 00:48:48.000000', 'consum', 0.0224, 'lps'),
	(435988, 125, '2015-03-01 00:48:49.000000', 'consum', 0.0225, 'lps'),
	(435989, 125, '2015-03-01 00:48:50.000000', 'consum', 0.0211, 'lps'),
	(435990, 125, '2015-03-01 00:48:51.000000', 'consum', 0.0220, 'lps'),
	(435991, 125, '2015-03-01 00:48:52.000000', 'consum', 0.0225, 'lps'),
	(435992, 125, '2015-03-01 00:48:53.000000', 'consum', 0.0222, 'lps'),
	(435993, 125, '2015-03-01 00:48:54.000000', 'consum', 0.0223, 'lps'),
	(435994, 125, '2015-03-01 00:48:55.000000', 'consum', 0.0224, 'lps'),
	(435995, 125, '2015-03-01 00:48:56.000000', 'consum', 0.0223, 'lps'),
	(435996, 125, '2015-03-01 00:48:57.000000', 'consum', 0.0216, 'lps'),
	(435997, 125, '2015-03-01 00:48:58.000000', 'consum', 0.0220, 'lps'),
	(435998, 125, '2015-03-01 00:48:59.000000', 'consum', 0.0226, 'lps'),
	(435999, 125, '2015-03-01 00:49:00.000000', 'consum', 0.0210, 'lps'),
	(436000, 125, '2015-03-01 00:49:01.000000', 'consum', 0.0214, 'lps'),
	(436001, 125, '2015-03-01 00:49:02.000000', 'consum', 0.0214, 'lps'),
	(436002, 125, '2015-03-01 00:49:03.000000', 'consum', 0.0218, 'lps'),
	(436003, 125, '2015-03-01 00:49:04.000000', 'consum', 0.0223, 'lps'),
	(436004, 125, '2015-03-01 00:49:05.000000', 'consum', 0.0216, 'lps'),
	(436005, 125, '2015-03-01 00:49:06.000000', 'consum', 0.0220, 'lps'),
	(436006, 125, '2015-03-01 00:49:07.000000', 'consum', 0.0225, 'lps'),
	(436007, 125, '2015-03-01 00:49:08.000000', 'consum', 0.0220, 'lps'),
	(436008, 125, '2015-03-01 00:49:09.000000', 'consum', 0.0216, 'lps'),
	(436009, 125, '2015-03-01 00:49:10.000000', 'consum', 0.0226, 'lps'),
	(436010, 125, '2015-03-01 00:49:11.000000', 'consum', 0.0222, 'lps'),
	(436011, 125, '2015-03-01 00:49:12.000000', 'consum', 0.0223, 'lps'),
	(436012, 125, '2015-03-01 00:49:13.000000', 'consum', 0.0222, 'lps'),
	(436013, 125, '2015-03-01 00:49:14.000000', 'consum', 0.0215, 'lps'),
	(436014, 125, '2015-03-01 00:49:15.000000', 'consum', 0.0218, 'lps'),
	(436015, 125, '2015-03-01 00:49:16.000000', 'consum', 0.0219, 'lps'),
	(436016, 125, '2015-03-01 00:49:17.000000', 'consum', 0.0212, 'lps'),
	(436017, 125, '2015-03-01 00:49:18.000000', 'consum', 0.0226, 'lps'),
	(436018, 125, '2015-03-01 00:49:19.000000', 'consum', 0.0220, 'lps'),
	(436019, 125, '2015-03-01 00:49:20.000000', 'consum', 0.0213, 'lps'),
	(436020, 125, '2015-03-01 00:49:21.000000', 'consum', 0.0210, 'lps'),
	(436021, 125, '2015-03-01 00:49:22.000000', 'consum', 0.0220, 'lps'),
	(436022, 125, '2015-03-01 00:49:23.000000', 'consum', 0.0210, 'lps'),
	(436023, 125, '2015-03-01 00:49:24.000000', 'consum', 0.0216, 'lps'),
	(436024, 125, '2015-03-01 00:49:25.000000', 'consum', 0.0221, 'lps'),
	(436025, 125, '2015-03-01 00:49:26.000000', 'consum', 0.0214, 'lps'),
	(436026, 125, '2015-03-01 00:49:27.000000', 'consum', 0.0214, 'lps'),
	(436027, 125, '2015-03-01 00:49:28.000000', 'consum', 0.0219, 'lps'),
	(436028, 125, '2015-03-01 00:49:29.000000', 'consum', 0.0226, 'lps'),
	(436029, 125, '2015-03-01 00:49:30.000000', 'consum', 0.0211, 'lps'),
	(436030, 125, '2015-03-01 00:49:31.000000', 'consum', 0.0220, 'lps'),
	(436031, 125, '2015-03-01 00:49:32.000000', 'consum', 0.0223, 'lps'),
	(436032, 125, '2015-03-01 00:49:33.000000', 'consum', 0.0212, 'lps'),
	(436033, 125, '2015-03-01 00:49:34.000000', 'consum', 0.0214, 'lps'),
	(436034, 125, '2015-03-01 00:49:35.000000', 'consum', 0.0223, 'lps'),
	(436035, 125, '2015-03-01 00:49:36.000000', 'consum', 0.0216, 'lps'),
	(436036, 125, '2015-03-01 00:49:37.000000', 'consum', 0.0215, 'lps'),
	(436037, 125, '2015-03-01 00:49:38.000000', 'consum', 0.0220, 'lps'),
	(436038, 125, '2015-03-01 00:49:39.000000', 'consum', 0.0211, 'lps'),
	(436039, 125, '2015-03-01 00:49:40.000000', 'consum', 0.0218, 'lps'),
	(436040, 125, '2015-03-01 00:49:41.000000', 'consum', 0.0216, 'lps'),
	(436041, 125, '2015-03-01 00:49:42.000000', 'consum', 0.0217, 'lps'),
	(436042, 125, '2015-03-01 00:49:43.000000', 'consum', 0.0210, 'lps'),
	(436043, 125, '2015-03-01 00:49:44.000000', 'consum', 0.0225, 'lps'),
	(436044, 125, '2015-03-01 00:49:45.000000', 'consum', 0.0215, 'lps'),
	(436045, 125, '2015-03-01 00:49:46.000000', 'consum', 0.0224, 'lps'),
	(436046, 125, '2015-03-01 00:49:47.000000', 'consum', 0.0213, 'lps'),
	(436047, 125, '2015-03-01 00:49:48.000000', 'consum', 0.0221, 'lps'),
	(436048, 125, '2015-03-01 00:49:49.000000', 'consum', 0.0222, 'lps'),
	(436049, 125, '2015-03-01 00:49:50.000000', 'consum', 0.0221, 'lps'),
	(436050, 125, '2015-03-01 00:49:51.000000', 'consum', 0.0212, 'lps'),
	(436051, 125, '2015-03-01 00:49:52.000000', 'consum', 0.0220, 'lps'),
	(436052, 125, '2015-03-01 00:49:53.000000', 'consum', 0.0223, 'lps'),
	(436053, 125, '2015-03-01 00:49:54.000000', 'consum', 0.0226, 'lps'),
	(436054, 125, '2015-03-01 00:49:55.000000', 'consum', 0.0220, 'lps'),
	(436055, 125, '2015-03-01 00:49:56.000000', 'consum', 0.0212, 'lps'),
	(436056, 125, '2015-03-01 00:49:57.000000', 'consum', 0.0223, 'lps'),
	(436057, 125, '2015-03-01 00:49:58.000000', 'consum', 0.0220, 'lps'),
	(436058, 125, '2015-03-01 00:49:59.000000', 'consum', 0.0220, 'lps'),
	(436059, 125, '2015-03-01 00:50:00.000000', 'consum', 0.0212, 'lps'),
	(436060, 125, '2015-03-01 00:50:01.000000', 'consum', 0.0210, 'lps'),
	(436061, 125, '2015-03-01 00:50:02.000000', 'consum', 0.0219, 'lps'),
	(436062, 125, '2015-03-01 00:50:03.000000', 'consum', 0.0223, 'lps'),
	(436063, 125, '2015-03-01 00:50:04.000000', 'consum', 0.0215, 'lps'),
	(436064, 125, '2015-03-01 00:50:05.000000', 'consum', 0.0211, 'lps'),
	(436065, 125, '2015-03-01 00:50:06.000000', 'consum', 0.0219, 'lps'),
	(436066, 125, '2015-03-01 00:50:07.000000', 'consum', 0.0219, 'lps'),
	(436067, 125, '2015-03-01 00:50:08.000000', 'consum', 0.0210, 'lps'),
	(436068, 125, '2015-03-01 00:50:09.000000', 'consum', 0.0218, 'lps'),
	(436069, 125, '2015-03-01 00:50:10.000000', 'consum', 0.0218, 'lps'),
	(436070, 125, '2015-03-01 00:50:11.000000', 'consum', 0.0224, 'lps'),
	(436071, 125, '2015-03-01 00:50:12.000000', 'consum', 0.0222, 'lps'),
	(436072, 125, '2015-03-01 00:50:13.000000', 'consum', 0.0214, 'lps'),
	(436073, 125, '2015-03-01 00:50:14.000000', 'consum', 0.0210, 'lps'),
	(436074, 125, '2015-03-01 00:50:15.000000', 'consum', 0.0218, 'lps'),
	(436075, 125, '2015-03-01 00:50:16.000000', 'consum', 0.0214, 'lps'),
	(436076, 125, '2015-03-01 00:50:17.000000', 'consum', 0.0225, 'lps'),
	(436077, 125, '2015-03-01 00:50:18.000000', 'consum', 0.0223, 'lps'),
	(436078, 125, '2015-03-01 00:50:19.000000', 'consum', 0.0214, 'lps'),
	(436079, 125, '2015-03-01 00:50:20.000000', 'consum', 0.0225, 'lps'),
	(436080, 125, '2015-03-01 00:50:21.000000', 'consum', 0.0223, 'lps'),
	(436081, 125, '2015-03-01 00:50:22.000000', 'consum', 0.0211, 'lps'),
	(436082, 125, '2015-03-01 00:50:23.000000', 'consum', 0.0212, 'lps'),
	(436083, 125, '2015-03-01 00:50:24.000000', 'consum', 0.0216, 'lps'),
	(436084, 125, '2015-03-01 00:50:25.000000', 'consum', 0.0217, 'lps'),
	(436085, 125, '2015-03-01 00:50:26.000000', 'consum', 0.0211, 'lps'),
	(436086, 125, '2015-03-01 00:50:27.000000', 'consum', 0.0211, 'lps'),
	(436087, 125, '2015-03-01 00:50:28.000000', 'consum', 0.0212, 'lps'),
	(436088, 125, '2015-03-01 00:50:29.000000', 'consum', 0.0220, 'lps'),
	(436089, 125, '2015-03-01 00:50:30.000000', 'consum', 0.0219, 'lps'),
	(436090, 125, '2015-03-01 00:50:31.000000', 'consum', 0.0210, 'lps'),
	(436091, 125, '2015-03-01 00:50:32.000000', 'consum', 0.0217, 'lps'),
	(436092, 125, '2015-03-01 00:50:33.000000', 'consum', 0.0213, 'lps'),
	(436093, 125, '2015-03-01 00:50:34.000000', 'consum', 0.0221, 'lps'),
	(436094, 125, '2015-03-01 00:50:35.000000', 'consum', 0.0221, 'lps'),
	(436095, 125, '2015-03-01 00:50:36.000000', 'consum', 0.0218, 'lps'),
	(436096, 125, '2015-03-01 00:50:37.000000', 'consum', 0.0217, 'lps'),
	(436097, 125, '2015-03-01 00:50:38.000000', 'consum', 0.0222, 'lps'),
	(436098, 125, '2015-03-01 00:50:39.000000', 'consum', 0.0213, 'lps'),
	(436099, 125, '2015-03-01 00:50:40.000000', 'consum', 0.0225, 'lps'),
	(436100, 125, '2015-03-01 00:50:41.000000', 'consum', 0.0224, 'lps'),
	(436101, 125, '2015-03-01 00:50:42.000000', 'consum', 0.0221, 'lps'),
	(436102, 125, '2015-03-01 00:50:43.000000', 'consum', 0.0222, 'lps'),
	(436103, 125, '2015-03-01 00:50:44.000000', 'consum', 0.0219, 'lps'),
	(436104, 125, '2015-03-01 00:50:45.000000', 'consum', 0.0221, 'lps'),
	(436105, 125, '2015-03-01 00:50:46.000000', 'consum', 0.0221, 'lps'),
	(436106, 125, '2015-03-01 00:50:47.000000', 'consum', 0.0217, 'lps'),
	(436107, 125, '2015-03-01 00:50:48.000000', 'consum', 0.0211, 'lps'),
	(436108, 125, '2015-03-01 00:50:49.000000', 'consum', 0.0212, 'lps'),
	(436109, 125, '2015-03-01 00:50:50.000000', 'consum', 0.0218, 'lps'),
	(436110, 125, '2015-03-01 00:50:51.000000', 'consum', 0.0210, 'lps'),
	(436111, 125, '2015-03-01 00:50:52.000000', 'consum', 0.0222, 'lps'),
	(436112, 125, '2015-03-01 00:50:53.000000', 'consum', 0.0220, 'lps'),
	(436113, 125, '2015-03-01 00:50:54.000000', 'consum', 0.0223, 'lps'),
	(436114, 125, '2015-03-01 00:50:55.000000', 'consum', 0.0211, 'lps'),
	(436115, 125, '2015-03-01 00:50:56.000000', 'consum', 0.0211, 'lps'),
	(436116, 125, '2015-03-01 00:50:57.000000', 'consum', 0.0213, 'lps'),
	(436117, 125, '2015-03-01 00:50:58.000000', 'consum', 0.0220, 'lps'),
	(436118, 125, '2015-03-01 00:50:59.000000', 'consum', 0.0220, 'lps'),
	(436119, 125, '2015-03-01 00:51:00.000000', 'consum', 0.0213, 'lps'),
	(436120, 125, '2015-03-01 00:51:01.000000', 'consum', 0.0214, 'lps'),
	(436121, 125, '2015-03-01 00:51:02.000000', 'consum', 0.0220, 'lps'),
	(436122, 125, '2015-03-01 00:51:03.000000', 'consum', 0.0214, 'lps'),
	(436123, 125, '2015-03-01 00:51:04.000000', 'consum', 0.0218, 'lps'),
	(436124, 125, '2015-03-01 00:51:05.000000', 'consum', 0.0223, 'lps'),
	(436125, 125, '2015-03-01 00:51:06.000000', 'consum', 0.0218, 'lps'),
	(436126, 125, '2015-03-01 00:51:07.000000', 'consum', 0.0211, 'lps'),
	(436127, 125, '2015-03-01 00:51:08.000000', 'consum', 0.0224, 'lps'),
	(436128, 125, '2015-03-01 00:51:09.000000', 'consum', 0.0211, 'lps'),
	(436129, 125, '2015-03-01 00:51:10.000000', 'consum', 0.0224, 'lps'),
	(436130, 125, '2015-03-01 00:51:11.000000', 'consum', 0.0226, 'lps'),
	(436131, 125, '2015-03-01 00:51:12.000000', 'consum', 0.0215, 'lps'),
	(436132, 125, '2015-03-01 00:51:13.000000', 'consum', 0.0222, 'lps'),
	(436133, 125, '2015-03-01 00:51:14.000000', 'consum', 0.0222, 'lps'),
	(436134, 125, '2015-03-01 00:51:15.000000', 'consum', 0.0219, 'lps'),
	(436135, 125, '2015-03-01 00:51:16.000000', 'consum', 0.0217, 'lps'),
	(436136, 125, '2015-03-01 00:51:17.000000', 'consum', 0.0220, 'lps'),
	(436137, 125, '2015-03-01 00:51:18.000000', 'consum', 0.0224, 'lps'),
	(436138, 125, '2015-03-01 00:51:19.000000', 'consum', 0.0214, 'lps'),
	(436139, 125, '2015-03-01 00:51:20.000000', 'consum', 0.0222, 'lps'),
	(436140, 125, '2015-03-01 00:51:21.000000', 'consum', 0.0226, 'lps'),
	(436141, 125, '2015-03-01 00:51:22.000000', 'consum', 0.0221, 'lps'),
	(436142, 125, '2015-03-01 00:51:23.000000', 'consum', 0.0218, 'lps'),
	(436143, 125, '2015-03-01 00:51:24.000000', 'consum', 0.0219, 'lps'),
	(436144, 125, '2015-03-01 00:51:25.000000', 'consum', 0.0212, 'lps'),
	(436145, 125, '2015-03-01 00:51:26.000000', 'consum', 0.0210, 'lps'),
	(436146, 125, '2015-03-01 00:51:27.000000', 'consum', 0.0223, 'lps'),
	(436147, 125, '2015-03-01 00:51:28.000000', 'consum', 0.0224, 'lps'),
	(436148, 125, '2015-03-01 00:51:29.000000', 'consum', 0.0226, 'lps'),
	(436149, 125, '2015-03-01 00:51:30.000000', 'consum', 0.0212, 'lps'),
	(436150, 125, '2015-03-01 00:51:31.000000', 'consum', 0.0210, 'lps'),
	(436151, 125, '2015-03-01 00:51:32.000000', 'consum', 0.0218, 'lps'),
	(436152, 125, '2015-03-01 00:51:33.000000', 'consum', 0.0219, 'lps'),
	(436153, 125, '2015-03-01 00:51:34.000000', 'consum', 0.0212, 'lps'),
	(436154, 125, '2015-03-01 00:51:35.000000', 'consum', 0.0210, 'lps'),
	(436155, 125, '2015-03-01 00:51:36.000000', 'consum', 0.0224, 'lps'),
	(436156, 125, '2015-03-01 00:51:37.000000', 'consum', 0.0211, 'lps'),
	(436157, 125, '2015-03-01 00:51:38.000000', 'consum', 0.0226, 'lps'),
	(436158, 125, '2015-03-01 00:51:39.000000', 'consum', 0.0219, 'lps'),
	(436159, 125, '2015-03-01 00:51:40.000000', 'consum', 0.0225, 'lps'),
	(436160, 125, '2015-03-01 00:51:41.000000', 'consum', 0.0224, 'lps'),
	(436161, 125, '2015-03-01 00:51:42.000000', 'consum', 0.0220, 'lps'),
	(436162, 125, '2015-03-01 00:51:43.000000', 'consum', 0.0217, 'lps'),
	(436163, 125, '2015-03-01 00:51:44.000000', 'consum', 0.0217, 'lps'),
	(436164, 125, '2015-03-01 00:51:45.000000', 'consum', 0.0224, 'lps'),
	(436165, 125, '2015-03-01 00:51:46.000000', 'consum', 0.0223, 'lps'),
	(436166, 125, '2015-03-01 00:51:47.000000', 'consum', 0.0219, 'lps'),
	(436167, 125, '2015-03-01 00:51:48.000000', 'consum', 0.0215, 'lps'),
	(436168, 125, '2015-03-01 00:51:49.000000', 'consum', 0.0224, 'lps'),
	(436169, 125, '2015-03-01 00:51:50.000000', 'consum', 0.0216, 'lps'),
	(436170, 125, '2015-03-01 00:51:51.000000', 'consum', 0.0217, 'lps'),
	(436171, 125, '2015-03-01 00:51:52.000000', 'consum', 0.0226, 'lps'),
	(436172, 125, '2015-03-01 00:51:53.000000', 'consum', 0.0217, 'lps'),
	(436173, 125, '2015-03-01 00:51:54.000000', 'consum', 0.0217, 'lps'),
	(436174, 125, '2015-03-01 00:51:55.000000', 'consum', 0.0222, 'lps'),
	(436175, 125, '2015-03-01 00:51:56.000000', 'consum', 0.0218, 'lps'),
	(436176, 125, '2015-03-01 00:51:57.000000', 'consum', 0.0215, 'lps'),
	(436177, 125, '2015-03-01 00:51:58.000000', 'consum', 0.0212, 'lps'),
	(436178, 125, '2015-03-01 00:51:59.000000', 'consum', 0.0220, 'lps'),
	(436179, 125, '2015-03-01 00:52:00.000000', 'consum', 0.0223, 'lps'),
	(436180, 125, '2015-03-01 00:52:01.000000', 'consum', 0.0211, 'lps'),
	(436181, 125, '2015-03-01 00:52:02.000000', 'consum', 0.0226, 'lps'),
	(436182, 125, '2015-03-01 00:52:03.000000', 'consum', 0.0218, 'lps'),
	(436183, 125, '2015-03-01 00:52:04.000000', 'consum', 0.0222, 'lps'),
	(436184, 125, '2015-03-01 00:52:05.000000', 'consum', 0.0212, 'lps'),
	(436185, 125, '2015-03-01 00:52:06.000000', 'consum', 0.0220, 'lps'),
	(436186, 125, '2015-03-01 00:52:07.000000', 'consum', 0.0221, 'lps'),
	(436187, 125, '2015-03-01 00:52:08.000000', 'consum', 0.0216, 'lps'),
	(436188, 125, '2015-03-01 00:52:09.000000', 'consum', 0.0226, 'lps'),
	(436189, 125, '2015-03-01 00:52:10.000000', 'consum', 0.0222, 'lps'),
	(436190, 125, '2015-03-01 00:52:11.000000', 'consum', 0.0221, 'lps'),
	(436191, 125, '2015-03-01 00:52:12.000000', 'consum', 0.0215, 'lps'),
	(436192, 125, '2015-03-01 00:52:13.000000', 'consum', 0.0216, 'lps'),
	(436193, 125, '2015-03-01 00:52:14.000000', 'consum', 0.0212, 'lps'),
	(436194, 125, '2015-03-01 00:52:15.000000', 'consum', 0.0218, 'lps'),
	(436195, 125, '2015-03-01 00:52:16.000000', 'consum', 0.0213, 'lps'),
	(436196, 125, '2015-03-01 00:52:17.000000', 'consum', 0.0215, 'lps'),
	(436197, 125, '2015-03-01 00:52:18.000000', 'consum', 0.0210, 'lps'),
	(436198, 125, '2015-03-01 00:52:19.000000', 'consum', 0.0213, 'lps'),
	(436199, 125, '2015-03-01 00:52:20.000000', 'consum', 0.0225, 'lps'),
	(436200, 125, '2015-03-01 00:52:21.000000', 'consum', 0.0210, 'lps'),
	(436201, 125, '2015-03-01 00:52:22.000000', 'consum', 0.0215, 'lps'),
	(436202, 125, '2015-03-01 00:52:23.000000', 'consum', 0.0221, 'lps'),
	(436203, 125, '2015-03-01 00:52:24.000000', 'consum', 0.0215, 'lps'),
	(436204, 125, '2015-03-01 00:52:25.000000', 'consum', 0.0218, 'lps'),
	(436205, 125, '2015-03-01 00:52:26.000000', 'consum', 0.0219, 'lps'),
	(436206, 125, '2015-03-01 00:52:27.000000', 'consum', 0.0215, 'lps'),
	(436207, 125, '2015-03-01 00:52:28.000000', 'consum', 0.0210, 'lps'),
	(436208, 125, '2015-03-01 00:52:29.000000', 'consum', 0.0211, 'lps'),
	(436209, 125, '2015-03-01 00:52:30.000000', 'consum', 0.0218, 'lps'),
	(436210, 125, '2015-03-01 00:52:31.000000', 'consum', 0.0210, 'lps'),
	(436211, 125, '2015-03-01 00:52:32.000000', 'consum', 0.0222, 'lps'),
	(436212, 125, '2015-03-01 00:52:33.000000', 'consum', 0.0219, 'lps'),
	(436213, 125, '2015-03-01 00:52:34.000000', 'consum', 0.0218, 'lps'),
	(436214, 125, '2015-03-01 00:52:35.000000', 'consum', 0.0225, 'lps'),
	(436215, 125, '2015-03-01 00:52:36.000000', 'consum', 0.0211, 'lps'),
	(436216, 125, '2015-03-01 00:52:37.000000', 'consum', 0.0220, 'lps'),
	(436217, 125, '2015-03-01 00:52:38.000000', 'consum', 0.0222, 'lps'),
	(436218, 125, '2015-03-01 00:52:39.000000', 'consum', 0.0210, 'lps'),
	(436219, 125, '2015-03-01 00:52:40.000000', 'consum', 0.0223, 'lps'),
	(436220, 125, '2015-03-01 00:52:41.000000', 'consum', 0.0224, 'lps'),
	(436221, 125, '2015-03-01 00:52:42.000000', 'consum', 0.0210, 'lps'),
	(436222, 125, '2015-03-01 00:52:43.000000', 'consum', 0.0219, 'lps'),
	(436223, 125, '2015-03-01 00:52:44.000000', 'consum', 0.0221, 'lps'),
	(436224, 125, '2015-03-01 00:52:45.000000', 'consum', 0.0221, 'lps'),
	(436225, 125, '2015-03-01 00:52:46.000000', 'consum', 0.0214, 'lps'),
	(436226, 125, '2015-03-01 00:52:47.000000', 'consum', 0.0215, 'lps'),
	(436227, 125, '2015-03-01 00:52:48.000000', 'consum', 0.0223, 'lps'),
	(436228, 125, '2015-03-01 00:52:49.000000', 'consum', 0.0226, 'lps'),
	(436229, 125, '2015-03-01 00:52:50.000000', 'consum', 0.0220, 'lps'),
	(436230, 125, '2015-03-01 00:52:51.000000', 'consum', 0.0210, 'lps'),
	(436231, 125, '2015-03-01 00:52:52.000000', 'consum', 0.0217, 'lps'),
	(436232, 125, '2015-03-01 00:52:53.000000', 'consum', 0.0225, 'lps'),
	(436233, 125, '2015-03-01 00:52:54.000000', 'consum', 0.0217, 'lps'),
	(436234, 125, '2015-03-01 00:52:55.000000', 'consum', 0.0215, 'lps'),
	(436235, 125, '2015-03-01 00:52:56.000000', 'consum', 0.0215, 'lps'),
	(436236, 125, '2015-03-01 00:52:57.000000', 'consum', 0.0220, 'lps'),
	(436237, 125, '2015-03-01 00:52:58.000000', 'consum', 0.0213, 'lps'),
	(436238, 125, '2015-03-01 00:52:59.000000', 'consum', 0.0210, 'lps'),
	(436239, 125, '2015-03-01 00:53:00.000000', 'consum', 0.0220, 'lps'),
	(436240, 125, '2015-03-01 00:53:01.000000', 'consum', 0.0211, 'lps'),
	(436241, 125, '2015-03-01 00:53:02.000000', 'consum', 0.0217, 'lps'),
	(436242, 125, '2015-03-01 00:53:03.000000', 'consum', 0.0226, 'lps'),
	(436243, 125, '2015-03-01 00:53:04.000000', 'consum', 0.0219, 'lps'),
	(436244, 125, '2015-03-01 00:53:05.000000', 'consum', 0.0224, 'lps'),
	(436245, 125, '2015-03-01 00:53:06.000000', 'consum', 0.0220, 'lps'),
	(436246, 125, '2015-03-01 00:53:07.000000', 'consum', 0.0218, 'lps'),
	(436247, 125, '2015-03-01 00:53:08.000000', 'consum', 0.0220, 'lps'),
	(436248, 125, '2015-03-01 00:53:09.000000', 'consum', 0.0219, 'lps'),
	(436249, 125, '2015-03-01 00:53:10.000000', 'consum', 0.0225, 'lps'),
	(436250, 125, '2015-03-01 00:53:11.000000', 'consum', 0.0210, 'lps'),
	(436251, 125, '2015-03-01 00:53:12.000000', 'consum', 0.0216, 'lps'),
	(436252, 125, '2015-03-01 00:53:13.000000', 'consum', 0.0223, 'lps'),
	(436253, 125, '2015-03-01 00:53:14.000000', 'consum', 0.0223, 'lps'),
	(436254, 125, '2015-03-01 00:53:15.000000', 'consum', 0.0220, 'lps'),
	(436255, 125, '2015-03-01 00:53:16.000000', 'consum', 0.0220, 'lps'),
	(436256, 125, '2015-03-01 00:53:17.000000', 'consum', 0.0215, 'lps'),
	(436257, 125, '2015-03-01 00:53:18.000000', 'consum', 0.0224, 'lps'),
	(436258, 125, '2015-03-01 00:53:19.000000', 'consum', 0.0212, 'lps'),
	(436259, 125, '2015-03-01 00:53:20.000000', 'consum', 0.0214, 'lps'),
	(436260, 125, '2015-03-01 00:53:21.000000', 'consum', 0.0224, 'lps'),
	(436261, 125, '2015-03-01 00:53:22.000000', 'consum', 0.0219, 'lps'),
	(436262, 125, '2015-03-01 00:53:23.000000', 'consum', 0.0212, 'lps'),
	(436263, 125, '2015-03-01 00:53:24.000000', 'consum', 0.0211, 'lps'),
	(436264, 125, '2015-03-01 00:53:25.000000', 'consum', 0.0224, 'lps'),
	(436265, 125, '2015-03-01 00:53:26.000000', 'consum', 0.0212, 'lps'),
	(436266, 125, '2015-03-01 00:53:27.000000', 'consum', 0.0213, 'lps'),
	(436267, 125, '2015-03-01 00:53:28.000000', 'consum', 0.0221, 'lps'),
	(436268, 125, '2015-03-01 00:53:29.000000', 'consum', 0.0220, 'lps'),
	(436269, 125, '2015-03-01 00:53:30.000000', 'consum', 0.0211, 'lps'),
	(436270, 125, '2015-03-01 00:53:31.000000', 'consum', 0.0219, 'lps'),
	(436271, 125, '2015-03-01 00:53:32.000000', 'consum', 0.0221, 'lps'),
	(436272, 125, '2015-03-01 00:53:33.000000', 'consum', 0.0218, 'lps'),
	(436273, 125, '2015-03-01 00:53:34.000000', 'consum', 0.0220, 'lps'),
	(436274, 125, '2015-03-01 00:53:35.000000', 'consum', 0.0218, 'lps'),
	(436275, 125, '2015-03-01 00:53:36.000000', 'consum', 0.0220, 'lps'),
	(436276, 125, '2015-03-01 00:53:37.000000', 'consum', 0.0222, 'lps'),
	(436277, 125, '2015-03-01 00:53:38.000000', 'consum', 0.0222, 'lps'),
	(436278, 125, '2015-03-01 00:53:39.000000', 'consum', 0.0218, 'lps'),
	(436279, 125, '2015-03-01 00:53:40.000000', 'consum', 0.0214, 'lps'),
	(436280, 125, '2015-03-01 00:53:41.000000', 'consum', 0.0226, 'lps'),
	(436281, 125, '2015-03-01 00:53:42.000000', 'consum', 0.0224, 'lps'),
	(436282, 125, '2015-03-01 00:53:43.000000', 'consum', 0.0218, 'lps'),
	(436283, 125, '2015-03-01 00:53:44.000000', 'consum', 0.0223, 'lps'),
	(436284, 125, '2015-03-01 00:53:45.000000', 'consum', 0.0220, 'lps'),
	(436285, 125, '2015-03-01 00:53:46.000000', 'consum', 0.0219, 'lps'),
	(436286, 125, '2015-03-01 00:53:47.000000', 'consum', 0.0225, 'lps'),
	(436287, 125, '2015-03-01 00:53:48.000000', 'consum', 0.0210, 'lps'),
	(436288, 125, '2015-03-01 00:53:49.000000', 'consum', 0.0216, 'lps'),
	(436289, 125, '2015-03-01 00:53:50.000000', 'consum', 0.0223, 'lps'),
	(436290, 125, '2015-03-01 00:53:51.000000', 'consum', 0.0223, 'lps'),
	(436291, 125, '2015-03-01 00:53:52.000000', 'consum', 0.0221, 'lps'),
	(436292, 125, '2015-03-01 00:53:53.000000', 'consum', 0.0225, 'lps'),
	(436293, 125, '2015-03-01 00:53:54.000000', 'consum', 0.0221, 'lps'),
	(436294, 125, '2015-03-01 00:53:55.000000', 'consum', 0.0219, 'lps'),
	(436295, 125, '2015-03-01 00:53:56.000000', 'consum', 0.0221, 'lps'),
	(436296, 125, '2015-03-01 00:53:57.000000', 'consum', 0.0224, 'lps'),
	(436297, 125, '2015-03-01 00:53:58.000000', 'consum', 0.0211, 'lps'),
	(436298, 125, '2015-03-01 00:53:59.000000', 'consum', 0.0225, 'lps'),
	(436299, 125, '2015-03-01 00:54:00.000000', 'consum', 0.0217, 'lps'),
	(436300, 125, '2015-03-01 00:54:01.000000', 'consum', 0.0215, 'lps'),
	(436301, 125, '2015-03-01 00:54:02.000000', 'consum', 0.0216, 'lps'),
	(436302, 125, '2015-03-01 00:54:03.000000', 'consum', 0.0225, 'lps'),
	(436303, 125, '2015-03-01 00:54:04.000000', 'consum', 0.0215, 'lps'),
	(436304, 125, '2015-03-01 00:54:05.000000', 'consum', 0.0225, 'lps'),
	(436305, 125, '2015-03-01 00:54:06.000000', 'consum', 0.0218, 'lps'),
	(436306, 125, '2015-03-01 00:54:07.000000', 'consum', 0.0223, 'lps'),
	(436307, 125, '2015-03-01 00:54:08.000000', 'consum', 0.0219, 'lps'),
	(436308, 125, '2015-03-01 00:54:09.000000', 'consum', 0.0217, 'lps'),
	(436309, 125, '2015-03-01 00:54:10.000000', 'consum', 0.0217, 'lps'),
	(436310, 125, '2015-03-01 00:54:11.000000', 'consum', 0.0226, 'lps'),
	(436311, 125, '2015-03-01 00:54:12.000000', 'consum', 0.0217, 'lps'),
	(436312, 125, '2015-03-01 00:54:13.000000', 'consum', 0.0217, 'lps'),
	(436313, 125, '2015-03-01 00:54:14.000000', 'consum', 0.0224, 'lps'),
	(436314, 125, '2015-03-01 00:54:15.000000', 'consum', 0.0225, 'lps'),
	(436315, 125, '2015-03-01 00:54:16.000000', 'consum', 0.0226, 'lps'),
	(436316, 125, '2015-03-01 00:54:17.000000', 'consum', 0.0210, 'lps'),
	(436317, 125, '2015-03-01 00:54:18.000000', 'consum', 0.0217, 'lps'),
	(436318, 125, '2015-03-01 00:54:19.000000', 'consum', 0.0226, 'lps'),
	(436319, 125, '2015-03-01 00:54:20.000000', 'consum', 0.0220, 'lps'),
	(436320, 125, '2015-03-01 00:54:21.000000', 'consum', 0.0210, 'lps'),
	(436321, 125, '2015-03-01 00:54:22.000000', 'consum', 0.0216, 'lps'),
	(436322, 125, '2015-03-01 00:54:23.000000', 'consum', 0.0223, 'lps'),
	(436323, 125, '2015-03-01 00:54:24.000000', 'consum', 0.0225, 'lps'),
	(436324, 125, '2015-03-01 00:54:25.000000', 'consum', 0.0211, 'lps'),
	(436325, 125, '2015-03-01 00:54:26.000000', 'consum', 0.0223, 'lps'),
	(436326, 125, '2015-03-01 00:54:27.000000', 'consum', 0.0220, 'lps'),
	(436327, 125, '2015-03-01 00:54:28.000000', 'consum', 0.0220, 'lps'),
	(436328, 125, '2015-03-01 00:54:29.000000', 'consum', 0.0214, 'lps'),
	(436329, 125, '2015-03-01 00:54:30.000000', 'consum', 0.0220, 'lps'),
	(436330, 125, '2015-03-01 00:54:31.000000', 'consum', 0.0214, 'lps'),
	(436331, 125, '2015-03-01 00:54:32.000000', 'consum', 0.0217, 'lps'),
	(436332, 125, '2015-03-01 00:54:33.000000', 'consum', 0.0219, 'lps'),
	(436333, 125, '2015-03-01 00:54:34.000000', 'consum', 0.0214, 'lps'),
	(436334, 125, '2015-03-01 00:54:35.000000', 'consum', 0.0221, 'lps'),
	(436335, 125, '2015-03-01 00:54:36.000000', 'consum', 0.0218, 'lps'),
	(436336, 125, '2015-03-01 00:54:37.000000', 'consum', 0.0220, 'lps'),
	(436337, 125, '2015-03-01 00:54:38.000000', 'consum', 0.0217, 'lps'),
	(436338, 125, '2015-03-01 00:54:39.000000', 'consum', 0.0217, 'lps'),
	(436339, 125, '2015-03-01 00:54:40.000000', 'consum', 0.0225, 'lps'),
	(436340, 125, '2015-03-01 00:54:41.000000', 'consum', 0.0212, 'lps'),
	(436341, 125, '2015-03-01 00:54:42.000000', 'consum', 0.0211, 'lps'),
	(436342, 125, '2015-03-01 00:54:43.000000', 'consum', 0.0210, 'lps'),
	(436343, 125, '2015-03-01 00:54:44.000000', 'consum', 0.0223, 'lps'),
	(436344, 125, '2015-03-01 00:54:45.000000', 'consum', 0.0210, 'lps'),
	(436345, 125, '2015-03-01 00:54:46.000000', 'consum', 0.0222, 'lps'),
	(436346, 125, '2015-03-01 00:54:47.000000', 'consum', 0.0217, 'lps'),
	(436347, 125, '2015-03-01 00:54:48.000000', 'consum', 0.0213, 'lps'),
	(436348, 125, '2015-03-01 00:54:49.000000', 'consum', 0.0220, 'lps'),
	(436349, 125, '2015-03-01 00:54:50.000000', 'consum', 0.0216, 'lps'),
	(436350, 125, '2015-03-01 00:54:51.000000', 'consum', 0.0211, 'lps'),
	(436351, 125, '2015-03-01 00:54:52.000000', 'consum', 0.0213, 'lps'),
	(436352, 125, '2015-03-01 00:54:53.000000', 'consum', 0.0224, 'lps'),
	(436353, 125, '2015-03-01 00:54:54.000000', 'consum', 0.0219, 'lps'),
	(436354, 125, '2015-03-01 00:54:55.000000', 'consum', 0.0217, 'lps'),
	(436355, 125, '2015-03-01 00:54:56.000000', 'consum', 0.0215, 'lps'),
	(436356, 125, '2015-03-01 00:54:57.000000', 'consum', 0.0214, 'lps'),
	(436357, 125, '2015-03-01 00:54:58.000000', 'consum', 0.0216, 'lps'),
	(436358, 125, '2015-03-01 00:54:59.000000', 'consum', 0.0214, 'lps'),
	(436359, 125, '2015-03-01 00:55:00.000000', 'consum', 0.0211, 'lps'),
	(436360, 125, '2015-03-01 00:55:01.000000', 'consum', 0.0219, 'lps'),
	(436361, 125, '2015-03-01 00:55:02.000000', 'consum', 0.0218, 'lps'),
	(436362, 125, '2015-03-01 00:55:03.000000', 'consum', 0.0224, 'lps'),
	(436363, 125, '2015-03-01 00:55:04.000000', 'consum', 0.0222, 'lps'),
	(436364, 125, '2015-03-01 00:55:05.000000', 'consum', 0.0214, 'lps'),
	(436365, 125, '2015-03-01 00:55:06.000000', 'consum', 0.0226, 'lps'),
	(436366, 125, '2015-03-01 00:55:07.000000', 'consum', 0.0213, 'lps'),
	(436367, 125, '2015-03-01 00:55:08.000000', 'consum', 0.0211, 'lps'),
	(436368, 125, '2015-03-01 00:55:09.000000', 'consum', 0.0222, 'lps'),
	(436369, 125, '2015-03-01 00:55:10.000000', 'consum', 0.0219, 'lps'),
	(436370, 125, '2015-03-01 00:55:11.000000', 'consum', 0.0216, 'lps'),
	(436371, 125, '2015-03-01 00:55:12.000000', 'consum', 0.0216, 'lps'),
	(436372, 125, '2015-03-01 00:55:13.000000', 'consum', 0.0224, 'lps'),
	(436373, 125, '2015-03-01 00:55:14.000000', 'consum', 0.0226, 'lps'),
	(436374, 125, '2015-03-01 00:55:15.000000', 'consum', 0.0216, 'lps'),
	(436375, 125, '2015-03-01 00:55:16.000000', 'consum', 0.0225, 'lps'),
	(436376, 125, '2015-03-01 00:55:17.000000', 'consum', 0.0216, 'lps'),
	(436377, 125, '2015-03-01 00:55:18.000000', 'consum', 0.0215, 'lps'),
	(436378, 125, '2015-03-01 00:55:19.000000', 'consum', 0.0215, 'lps'),
	(436379, 125, '2015-03-01 00:55:20.000000', 'consum', 0.0220, 'lps'),
	(436380, 125, '2015-03-01 00:55:21.000000', 'consum', 0.0213, 'lps'),
	(436381, 125, '2015-03-01 00:55:22.000000', 'consum', 0.0214, 'lps'),
	(436382, 125, '2015-03-01 00:55:23.000000', 'consum', 0.0219, 'lps'),
	(436383, 125, '2015-03-01 00:55:24.000000', 'consum', 0.0226, 'lps'),
	(436384, 125, '2015-03-01 00:55:25.000000', 'consum', 0.0214, 'lps'),
	(436385, 125, '2015-03-01 00:55:26.000000', 'consum', 0.0216, 'lps'),
	(436386, 125, '2015-03-01 00:55:27.000000', 'consum', 0.0210, 'lps'),
	(436387, 125, '2015-03-01 00:55:28.000000', 'consum', 0.0226, 'lps'),
	(436388, 125, '2015-03-01 00:55:29.000000', 'consum', 0.0222, 'lps'),
	(436389, 125, '2015-03-01 00:55:30.000000', 'consum', 0.0222, 'lps'),
	(436390, 125, '2015-03-01 00:55:31.000000', 'consum', 0.0219, 'lps'),
	(436391, 125, '2015-03-01 00:55:32.000000', 'consum', 0.0217, 'lps'),
	(436392, 125, '2015-03-01 00:55:33.000000', 'consum', 0.0221, 'lps'),
	(436393, 125, '2015-03-01 00:55:34.000000', 'consum', 0.0211, 'lps'),
	(436394, 125, '2015-03-01 00:55:35.000000', 'consum', 0.0218, 'lps'),
	(436395, 125, '2015-03-01 00:55:36.000000', 'consum', 0.0211, 'lps'),
	(436396, 125, '2015-03-01 00:55:37.000000', 'consum', 0.0226, 'lps'),
	(436397, 125, '2015-03-01 00:55:38.000000', 'consum', 0.0221, 'lps'),
	(436398, 125, '2015-03-01 00:55:39.000000', 'consum', 0.0217, 'lps'),
	(436399, 125, '2015-03-01 00:55:40.000000', 'consum', 0.0214, 'lps'),
	(436400, 125, '2015-03-01 00:55:41.000000', 'consum', 0.0224, 'lps'),
	(436401, 125, '2015-03-01 00:55:42.000000', 'consum', 0.0218, 'lps'),
	(436402, 125, '2015-03-01 00:55:43.000000', 'consum', 0.0210, 'lps'),
	(436403, 125, '2015-03-01 00:55:44.000000', 'consum', 0.0221, 'lps'),
	(436404, 125, '2015-03-01 00:55:45.000000', 'consum', 0.0215, 'lps'),
	(436405, 125, '2015-03-01 00:55:46.000000', 'consum', 0.0220, 'lps'),
	(436406, 125, '2015-03-01 00:55:47.000000', 'consum', 0.0211, 'lps'),
	(436407, 125, '2015-03-01 00:55:48.000000', 'consum', 0.0220, 'lps'),
	(436408, 125, '2015-03-01 00:55:49.000000', 'consum', 0.0221, 'lps'),
	(436409, 125, '2015-03-01 00:55:50.000000', 'consum', 0.0219, 'lps'),
	(436410, 125, '2015-03-01 00:55:51.000000', 'consum', 0.0224, 'lps'),
	(436411, 125, '2015-03-01 00:55:52.000000', 'consum', 0.0218, 'lps'),
	(436412, 125, '2015-03-01 00:55:53.000000', 'consum', 0.0225, 'lps'),
	(436413, 125, '2015-03-01 00:55:54.000000', 'consum', 0.0210, 'lps'),
	(436414, 125, '2015-03-01 00:55:55.000000', 'consum', 0.0218, 'lps'),
	(436415, 125, '2015-03-01 00:55:56.000000', 'consum', 0.0215, 'lps'),
	(436416, 125, '2015-03-01 00:55:57.000000', 'consum', 0.0211, 'lps'),
	(436417, 125, '2015-03-01 00:55:58.000000', 'consum', 0.0219, 'lps'),
	(436418, 125, '2015-03-01 00:55:59.000000', 'consum', 0.0219, 'lps'),
	(436419, 125, '2015-03-01 00:56:00.000000', 'consum', 0.0211, 'lps'),
	(436420, 125, '2015-03-01 00:56:01.000000', 'consum', 0.0221, 'lps'),
	(436421, 125, '2015-03-01 00:56:02.000000', 'consum', 0.0210, 'lps'),
	(436422, 125, '2015-03-01 00:56:03.000000', 'consum', 0.0215, 'lps'),
	(436423, 125, '2015-03-01 00:56:04.000000', 'consum', 0.0216, 'lps'),
	(436424, 125, '2015-03-01 00:56:05.000000', 'consum', 0.0210, 'lps'),
	(436425, 125, '2015-03-01 00:56:06.000000', 'consum', 0.0225, 'lps'),
	(436426, 125, '2015-03-01 00:56:07.000000', 'consum', 0.0219, 'lps'),
	(436427, 125, '2015-03-01 00:56:08.000000', 'consum', 0.0211, 'lps'),
	(436428, 125, '2015-03-01 00:56:09.000000', 'consum', 0.0223, 'lps'),
	(436429, 125, '2015-03-01 00:56:10.000000', 'consum', 0.0222, 'lps'),
	(436430, 125, '2015-03-01 00:56:11.000000', 'consum', 0.0215, 'lps'),
	(436431, 125, '2015-03-01 00:56:12.000000', 'consum', 0.0214, 'lps'),
	(436432, 125, '2015-03-01 00:56:13.000000', 'consum', 0.0216, 'lps'),
	(436433, 125, '2015-03-01 00:56:14.000000', 'consum', 0.0212, 'lps'),
	(436434, 125, '2015-03-01 00:56:15.000000', 'consum', 0.0222, 'lps'),
	(436435, 125, '2015-03-01 00:56:16.000000', 'consum', 0.0210, 'lps'),
	(436436, 125, '2015-03-01 00:56:17.000000', 'consum', 0.0225, 'lps'),
	(436437, 125, '2015-03-01 00:56:18.000000', 'consum', 0.0220, 'lps'),
	(436438, 125, '2015-03-01 00:56:19.000000', 'consum', 0.0217, 'lps'),
	(436439, 125, '2015-03-01 00:56:20.000000', 'consum', 0.0212, 'lps'),
	(436440, 125, '2015-03-01 00:56:21.000000', 'consum', 0.0220, 'lps'),
	(436441, 125, '2015-03-01 00:56:22.000000', 'consum', 0.0217, 'lps'),
	(436442, 125, '2015-03-01 00:56:23.000000', 'consum', 0.0217, 'lps'),
	(436443, 125, '2015-03-01 00:56:24.000000', 'consum', 0.0226, 'lps'),
	(436444, 125, '2015-03-01 00:56:25.000000', 'consum', 0.0216, 'lps'),
	(436445, 125, '2015-03-01 00:56:26.000000', 'consum', 0.0212, 'lps'),
	(436446, 125, '2015-03-01 00:56:27.000000', 'consum', 0.0217, 'lps'),
	(436447, 125, '2015-03-01 00:56:28.000000', 'consum', 0.0225, 'lps'),
	(436448, 125, '2015-03-01 00:56:29.000000', 'consum', 0.0211, 'lps'),
	(436449, 125, '2015-03-01 00:56:30.000000', 'consum', 0.0222, 'lps'),
	(436450, 125, '2015-03-01 00:56:31.000000', 'consum', 0.0217, 'lps'),
	(436451, 125, '2015-03-01 00:56:32.000000', 'consum', 0.0225, 'lps'),
	(436452, 125, '2015-03-01 00:56:33.000000', 'consum', 0.0214, 'lps'),
	(436453, 125, '2015-03-01 00:56:34.000000', 'consum', 0.0218, 'lps'),
	(436454, 125, '2015-03-01 00:56:35.000000', 'consum', 0.0224, 'lps'),
	(436455, 125, '2015-03-01 00:56:36.000000', 'consum', 0.0220, 'lps'),
	(436456, 125, '2015-03-01 00:56:37.000000', 'consum', 0.0221, 'lps'),
	(436457, 125, '2015-03-01 00:56:38.000000', 'consum', 0.0217, 'lps'),
	(436458, 125, '2015-03-01 00:56:39.000000', 'consum', 0.0211, 'lps'),
	(436459, 125, '2015-03-01 00:56:40.000000', 'consum', 0.0212, 'lps'),
	(436460, 125, '2015-03-01 00:56:41.000000', 'consum', 0.0217, 'lps'),
	(436461, 125, '2015-03-01 00:56:42.000000', 'consum', 0.0224, 'lps'),
	(436462, 125, '2015-03-01 00:56:43.000000', 'consum', 0.0223, 'lps'),
	(436463, 125, '2015-03-01 00:56:44.000000', 'consum', 0.0220, 'lps'),
	(436464, 125, '2015-03-01 00:56:45.000000', 'consum', 0.0220, 'lps'),
	(436465, 125, '2015-03-01 00:56:46.000000', 'consum', 0.0212, 'lps'),
	(436466, 125, '2015-03-01 00:56:47.000000', 'consum', 0.0224, 'lps'),
	(436467, 125, '2015-03-01 00:56:48.000000', 'consum', 0.0225, 'lps'),
	(436468, 125, '2015-03-01 00:56:49.000000', 'consum', 0.0226, 'lps'),
	(436469, 125, '2015-03-01 00:56:50.000000', 'consum', 0.0214, 'lps'),
	(436470, 125, '2015-03-01 00:56:51.000000', 'consum', 0.0214, 'lps'),
	(436471, 125, '2015-03-01 00:56:52.000000', 'consum', 0.0219, 'lps'),
	(436472, 125, '2015-03-01 00:56:53.000000', 'consum', 0.0210, 'lps'),
	(436473, 125, '2015-03-01 00:56:54.000000', 'consum', 0.0215, 'lps'),
	(436474, 125, '2015-03-01 00:56:55.000000', 'consum', 0.0222, 'lps'),
	(436475, 125, '2015-03-01 00:56:56.000000', 'consum', 0.0221, 'lps'),
	(436476, 125, '2015-03-01 00:56:57.000000', 'consum', 0.0210, 'lps'),
	(436477, 125, '2015-03-01 00:56:58.000000', 'consum', 0.0212, 'lps'),
	(436478, 125, '2015-03-01 00:56:59.000000', 'consum', 0.0221, 'lps'),
	(436479, 125, '2015-03-01 00:57:00.000000', 'consum', 0.0210, 'lps'),
	(436480, 125, '2015-03-01 00:57:01.000000', 'consum', 0.0213, 'lps'),
	(436481, 125, '2015-03-01 00:57:02.000000', 'consum', 0.0222, 'lps'),
	(436482, 125, '2015-03-01 00:57:03.000000', 'consum', 0.0211, 'lps'),
	(436483, 125, '2015-03-01 00:57:04.000000', 'consum', 0.0216, 'lps'),
	(436484, 125, '2015-03-01 00:57:05.000000', 'consum', 0.0219, 'lps'),
	(436485, 125, '2015-03-01 00:57:06.000000', 'consum', 0.0222, 'lps'),
	(436486, 125, '2015-03-01 00:57:07.000000', 'consum', 0.0224, 'lps'),
	(436487, 125, '2015-03-01 00:57:08.000000', 'consum', 0.0210, 'lps'),
	(436488, 125, '2015-03-01 00:57:09.000000', 'consum', 0.0223, 'lps'),
	(436489, 125, '2015-03-01 00:57:10.000000', 'consum', 0.0221, 'lps'),
	(436490, 125, '2015-03-01 00:57:11.000000', 'consum', 0.0210, 'lps'),
	(436491, 125, '2015-03-01 00:57:12.000000', 'consum', 0.0211, 'lps'),
	(436492, 125, '2015-03-01 00:57:13.000000', 'consum', 0.0218, 'lps'),
	(436493, 125, '2015-03-01 00:57:14.000000', 'consum', 0.0213, 'lps'),
	(436494, 125, '2015-03-01 00:57:15.000000', 'consum', 0.0220, 'lps'),
	(436495, 125, '2015-03-01 00:57:16.000000', 'consum', 0.0214, 'lps'),
	(436496, 125, '2015-03-01 00:57:17.000000', 'consum', 0.0219, 'lps'),
	(436497, 125, '2015-03-01 00:57:18.000000', 'consum', 0.0226, 'lps'),
	(436498, 125, '2015-03-01 00:57:19.000000', 'consum', 0.0212, 'lps'),
	(436499, 125, '2015-03-01 00:57:20.000000', 'consum', 0.0225, 'lps'),
	(436500, 125, '2015-03-01 00:57:21.000000', 'consum', 0.0226, 'lps'),
	(436501, 125, '2015-03-01 00:57:22.000000', 'consum', 0.0213, 'lps'),
	(436502, 125, '2015-03-01 00:57:23.000000', 'consum', 0.0213, 'lps'),
	(436503, 125, '2015-03-01 00:57:24.000000', 'consum', 0.0216, 'lps'),
	(436504, 125, '2015-03-01 00:57:25.000000', 'consum', 0.0213, 'lps'),
	(436505, 125, '2015-03-01 00:57:26.000000', 'consum', 0.0226, 'lps'),
	(436506, 125, '2015-03-01 00:57:27.000000', 'consum', 0.0214, 'lps'),
	(436507, 125, '2015-03-01 00:57:28.000000', 'consum', 0.0214, 'lps'),
	(436508, 125, '2015-03-01 00:57:29.000000', 'consum', 0.0221, 'lps'),
	(436509, 125, '2015-03-01 00:57:30.000000', 'consum', 0.0219, 'lps'),
	(436510, 125, '2015-03-01 00:57:31.000000', 'consum', 0.0223, 'lps'),
	(436511, 125, '2015-03-01 00:57:32.000000', 'consum', 0.0215, 'lps'),
	(436512, 125, '2015-03-01 00:57:33.000000', 'consum', 0.0212, 'lps'),
	(436513, 125, '2015-03-01 00:57:34.000000', 'consum', 0.0224, 'lps'),
	(436514, 125, '2015-03-01 00:57:35.000000', 'consum', 0.0222, 'lps'),
	(436515, 125, '2015-03-01 00:57:36.000000', 'consum', 0.0213, 'lps'),
	(436516, 125, '2015-03-01 00:57:37.000000', 'consum', 0.0224, 'lps'),
	(436517, 125, '2015-03-01 00:57:38.000000', 'consum', 0.0219, 'lps'),
	(436518, 125, '2015-03-01 00:57:39.000000', 'consum', 0.0213, 'lps'),
	(436519, 125, '2015-03-01 00:57:40.000000', 'consum', 0.0218, 'lps'),
	(436520, 125, '2015-03-01 00:57:41.000000', 'consum', 0.0221, 'lps'),
	(436521, 125, '2015-03-01 00:57:42.000000', 'consum', 0.0211, 'lps'),
	(436522, 125, '2015-03-01 00:57:43.000000', 'consum', 0.0214, 'lps'),
	(436523, 125, '2015-03-01 00:57:44.000000', 'consum', 0.0226, 'lps'),
	(436524, 125, '2015-03-01 00:57:45.000000', 'consum', 0.0213, 'lps'),
	(436525, 125, '2015-03-01 00:57:46.000000', 'consum', 0.0210, 'lps'),
	(436526, 125, '2015-03-01 00:57:47.000000', 'consum', 0.0220, 'lps'),
	(436527, 125, '2015-03-01 00:57:48.000000', 'consum', 0.0226, 'lps'),
	(436528, 125, '2015-03-01 00:57:49.000000', 'consum', 0.0212, 'lps'),
	(436529, 125, '2015-03-01 00:57:50.000000', 'consum', 0.0220, 'lps'),
	(436530, 125, '2015-03-01 00:57:51.000000', 'consum', 0.0220, 'lps'),
	(436531, 125, '2015-03-01 00:57:52.000000', 'consum', 0.0214, 'lps'),
	(436532, 125, '2015-03-01 00:57:53.000000', 'consum', 0.0219, 'lps'),
	(436533, 125, '2015-03-01 00:57:54.000000', 'consum', 0.0225, 'lps'),
	(436534, 125, '2015-03-01 00:57:55.000000', 'consum', 0.0210, 'lps'),
	(436535, 125, '2015-03-01 00:57:56.000000', 'consum', 0.0215, 'lps'),
	(436536, 125, '2015-03-01 00:57:57.000000', 'consum', 0.0217, 'lps'),
	(436537, 125, '2015-03-01 00:57:58.000000', 'consum', 0.0214, 'lps'),
	(436538, 125, '2015-03-01 00:57:59.000000', 'consum', 0.0225, 'lps'),
	(436539, 125, '2015-03-01 00:58:00.000000', 'consum', 0.0224, 'lps'),
	(436540, 125, '2015-03-01 00:58:01.000000', 'consum', 0.0218, 'lps'),
	(436541, 125, '2015-03-01 00:58:02.000000', 'consum', 0.0224, 'lps'),
	(436542, 125, '2015-03-01 00:58:03.000000', 'consum', 0.0223, 'lps'),
	(436543, 125, '2015-03-01 00:58:04.000000', 'consum', 0.0217, 'lps'),
	(436544, 125, '2015-03-01 00:58:05.000000', 'consum', 0.0224, 'lps'),
	(436545, 125, '2015-03-01 00:58:06.000000', 'consum', 0.0226, 'lps'),
	(436546, 125, '2015-03-01 00:58:07.000000', 'consum', 0.0216, 'lps'),
	(436547, 125, '2015-03-01 00:58:08.000000', 'consum', 0.0225, 'lps'),
	(436548, 125, '2015-03-01 00:58:09.000000', 'consum', 0.0217, 'lps'),
	(436549, 125, '2015-03-01 00:58:10.000000', 'consum', 0.0217, 'lps'),
	(436550, 125, '2015-03-01 00:58:11.000000', 'consum', 0.0226, 'lps'),
	(436551, 125, '2015-03-01 00:58:12.000000', 'consum', 0.0219, 'lps'),
	(436552, 125, '2015-03-01 00:58:13.000000', 'consum', 0.0222, 'lps'),
	(436553, 125, '2015-03-01 00:58:14.000000', 'consum', 0.0212, 'lps'),
	(436554, 125, '2015-03-01 00:58:15.000000', 'consum', 0.0217, 'lps'),
	(436555, 125, '2015-03-01 00:58:16.000000', 'consum', 0.0221, 'lps'),
	(436556, 125, '2015-03-01 00:58:17.000000', 'consum', 0.0211, 'lps'),
	(436557, 125, '2015-03-01 00:58:18.000000', 'consum', 0.0216, 'lps'),
	(436558, 125, '2015-03-01 00:58:19.000000', 'consum', 0.0221, 'lps'),
	(436559, 125, '2015-03-01 00:58:20.000000', 'consum', 0.0215, 'lps'),
	(436560, 125, '2015-03-01 00:58:21.000000', 'consum', 0.0218, 'lps'),
	(436561, 125, '2015-03-01 00:58:22.000000', 'consum', 0.0219, 'lps'),
	(436562, 125, '2015-03-01 00:58:23.000000', 'consum', 0.0213, 'lps'),
	(436563, 125, '2015-03-01 00:58:24.000000', 'consum', 0.0216, 'lps'),
	(436564, 125, '2015-03-01 00:58:25.000000', 'consum', 0.0216, 'lps'),
	(436565, 125, '2015-03-01 00:58:26.000000', 'consum', 0.0220, 'lps'),
	(436566, 125, '2015-03-01 00:58:27.000000', 'consum', 0.0211, 'lps'),
	(436567, 125, '2015-03-01 00:58:28.000000', 'consum', 0.0220, 'lps'),
	(436568, 125, '2015-03-01 00:58:29.000000', 'consum', 0.0221, 'lps'),
	(436569, 125, '2015-03-01 00:58:30.000000', 'consum', 0.0219, 'lps'),
	(436570, 125, '2015-03-01 00:58:31.000000', 'consum', 0.0225, 'lps'),
	(436571, 125, '2015-03-01 00:58:32.000000', 'consum', 0.0223, 'lps'),
	(436572, 125, '2015-03-01 00:58:33.000000', 'consum', 0.0212, 'lps'),
	(436573, 125, '2015-03-01 00:58:34.000000', 'consum', 0.0215, 'lps'),
	(436574, 125, '2015-03-01 00:58:35.000000', 'consum', 0.0215, 'lps'),
	(436575, 125, '2015-03-01 00:58:36.000000', 'consum', 0.0220, 'lps'),
	(436576, 125, '2015-03-01 00:58:37.000000', 'consum', 0.0212, 'lps'),
	(436577, 125, '2015-03-01 00:58:38.000000', 'consum', 0.0222, 'lps'),
	(436578, 125, '2015-03-01 00:58:39.000000', 'consum', 0.0216, 'lps'),
	(436579, 125, '2015-03-01 00:58:40.000000', 'consum', 0.0221, 'lps'),
	(436580, 125, '2015-03-01 00:58:41.000000', 'consum', 0.0214, 'lps'),
	(436581, 125, '2015-03-01 00:58:42.000000', 'consum', 0.0212, 'lps'),
	(436582, 125, '2015-03-01 00:58:43.000000', 'consum', 0.0212, 'lps'),
	(436583, 125, '2015-03-01 00:58:44.000000', 'consum', 0.0212, 'lps'),
	(436584, 125, '2015-03-01 00:58:45.000000', 'consum', 0.0217, 'lps'),
	(436585, 125, '2015-03-01 00:58:46.000000', 'consum', 0.0221, 'lps'),
	(436586, 125, '2015-03-01 00:58:47.000000', 'consum', 0.0226, 'lps'),
	(436587, 125, '2015-03-01 00:58:48.000000', 'consum', 0.0226, 'lps'),
	(436588, 125, '2015-03-01 00:58:49.000000', 'consum', 0.0224, 'lps'),
	(436589, 125, '2015-03-01 00:58:50.000000', 'consum', 0.0216, 'lps'),
	(436590, 125, '2015-03-01 00:58:51.000000', 'consum', 0.0217, 'lps'),
	(436591, 125, '2015-03-01 00:58:52.000000', 'consum', 0.0224, 'lps'),
	(436592, 125, '2015-03-01 00:58:53.000000', 'consum', 0.0211, 'lps'),
	(436593, 125, '2015-03-01 00:58:54.000000', 'consum', 0.0226, 'lps'),
	(436594, 125, '2015-03-01 00:58:55.000000', 'consum', 0.0217, 'lps'),
	(436595, 125, '2015-03-01 00:58:56.000000', 'consum', 0.0217, 'lps'),
	(436596, 125, '2015-03-01 00:58:57.000000', 'consum', 0.0222, 'lps'),
	(436597, 125, '2015-03-01 00:58:58.000000', 'consum', 0.0215, 'lps'),
	(436598, 125, '2015-03-01 00:58:59.000000', 'consum', 0.0218, 'lps'),
	(436599, 125, '2015-03-01 00:59:00.000000', 'consum', 0.0218, 'lps'),
	(436600, 125, '2015-03-01 00:59:01.000000', 'consum', 0.0210, 'lps'),
	(436601, 125, '2015-03-01 00:59:02.000000', 'consum', 0.0219, 'lps'),
	(436602, 125, '2015-03-01 00:59:03.000000', 'consum', 0.0224, 'lps'),
	(436603, 125, '2015-03-01 00:59:04.000000', 'consum', 0.0219, 'lps'),
	(436604, 125, '2015-03-01 00:59:05.000000', 'consum', 0.0213, 'lps'),
	(436605, 125, '2015-03-01 00:59:06.000000', 'consum', 0.0215, 'lps'),
	(436606, 125, '2015-03-01 00:59:07.000000', 'consum', 0.0225, 'lps'),
	(436607, 125, '2015-03-01 00:59:08.000000', 'consum', 0.0221, 'lps'),
	(436608, 125, '2015-03-01 00:59:09.000000', 'consum', 0.0221, 'lps'),
	(436609, 125, '2015-03-01 00:59:10.000000', 'consum', 0.0214, 'lps'),
	(436610, 125, '2015-03-01 00:59:11.000000', 'consum', 0.0215, 'lps'),
	(436611, 125, '2015-03-01 00:59:12.000000', 'consum', 0.0225, 'lps'),
	(436612, 125, '2015-03-01 00:59:13.000000', 'consum', 0.0220, 'lps'),
	(436613, 125, '2015-03-01 00:59:14.000000', 'consum', 0.0213, 'lps'),
	(436614, 125, '2015-03-01 00:59:15.000000', 'consum', 0.0214, 'lps'),
	(436615, 125, '2015-03-01 00:59:16.000000', 'consum', 0.0223, 'lps'),
	(436616, 125, '2015-03-01 00:59:17.000000', 'consum', 0.0212, 'lps'),
	(436617, 125, '2015-03-01 00:59:18.000000', 'consum', 0.0216, 'lps'),
	(436618, 125, '2015-03-01 00:59:19.000000', 'consum', 0.0218, 'lps'),
	(436619, 125, '2015-03-01 00:59:20.000000', 'consum', 0.0217, 'lps'),
	(436620, 125, '2015-03-01 00:59:21.000000', 'consum', 0.0218, 'lps'),
	(436621, 125, '2015-03-01 00:59:22.000000', 'consum', 0.0215, 'lps'),
	(436622, 125, '2015-03-01 00:59:23.000000', 'consum', 0.0211, 'lps'),
	(436623, 125, '2015-03-01 00:59:24.000000', 'consum', 0.0219, 'lps'),
	(436624, 125, '2015-03-01 00:59:25.000000', 'consum', 0.0217, 'lps'),
	(436625, 125, '2015-03-01 00:59:26.000000', 'consum', 0.0219, 'lps'),
	(436626, 125, '2015-03-01 00:59:27.000000', 'consum', 0.0219, 'lps'),
	(436627, 125, '2015-03-01 00:59:28.000000', 'consum', 0.0226, 'lps'),
	(436628, 125, '2015-03-01 00:59:29.000000', 'consum', 0.0215, 'lps'),
	(436629, 125, '2015-03-01 00:59:30.000000', 'consum', 0.0219, 'lps'),
	(436630, 125, '2015-03-01 00:59:31.000000', 'consum', 0.0223, 'lps'),
	(436631, 125, '2015-03-01 00:59:32.000000', 'consum', 0.0216, 'lps'),
	(436632, 125, '2015-03-01 00:59:33.000000', 'consum', 0.0219, 'lps'),
	(436633, 125, '2015-03-01 00:59:34.000000', 'consum', 0.0218, 'lps'),
	(436634, 125, '2015-03-01 00:59:35.000000', 'consum', 0.0226, 'lps'),
	(436635, 125, '2015-03-01 00:59:36.000000', 'consum', 0.0217, 'lps'),
	(436636, 125, '2015-03-01 00:59:37.000000', 'consum', 0.0211, 'lps'),
	(436637, 125, '2015-03-01 00:59:38.000000', 'consum', 0.0215, 'lps'),
	(436638, 125, '2015-03-01 00:59:39.000000', 'consum', 0.0212, 'lps'),
	(436639, 125, '2015-03-01 00:59:40.000000', 'consum', 0.0224, 'lps'),
	(436640, 125, '2015-03-01 00:59:41.000000', 'consum', 0.0224, 'lps'),
	(436641, 125, '2015-03-01 00:59:42.000000', 'consum', 0.0219, 'lps'),
	(436642, 125, '2015-03-01 00:59:43.000000', 'consum', 0.0215, 'lps'),
	(436643, 125, '2015-03-01 00:59:44.000000', 'consum', 0.0226, 'lps'),
	(436644, 125, '2015-03-01 00:59:45.000000', 'consum', 0.0225, 'lps'),
	(436645, 125, '2015-03-01 00:59:46.000000', 'consum', 0.0219, 'lps'),
	(436646, 125, '2015-03-01 00:59:47.000000', 'consum', 0.0210, 'lps'),
	(436647, 125, '2015-03-01 00:59:48.000000', 'consum', 0.0218, 'lps'),
	(436648, 125, '2015-03-01 00:59:49.000000', 'consum', 0.0215, 'lps'),
	(436649, 125, '2015-03-01 00:59:50.000000', 'consum', 0.0212, 'lps'),
	(436650, 125, '2015-03-01 00:59:51.000000', 'consum', 0.0221, 'lps'),
	(436651, 125, '2015-03-01 00:59:52.000000', 'consum', 0.0210, 'lps'),
	(436652, 125, '2015-03-01 00:59:53.000000', 'consum', 0.0213, 'lps'),
	(436653, 125, '2015-03-01 00:59:54.000000', 'consum', 0.0225, 'lps'),
	(436654, 125, '2015-03-01 00:59:55.000000', 'consum', 0.0223, 'lps'),
	(436655, 125, '2015-03-01 00:59:56.000000', 'consum', 0.0216, 'lps'),
	(436656, 125, '2015-03-01 00:59:57.000000', 'consum', 0.0218, 'lps'),
	(436657, 125, '2015-03-01 00:59:58.000000', 'consum', 0.0214, 'lps'),
	(436658, 125, '2015-03-01 00:59:59.000000', 'consum', 0.0223, 'lps'),
	(436659, 125, '2015-03-01 01:00:00.000000', 'consum', 0.0215, 'lps'),
	(436660, 125, '2015-03-01 01:00:01.000000', 'consum', 0.0212, 'lps'),
	(436661, 125, '2015-03-01 01:00:02.000000', 'consum', 0.0224, 'lps'),
	(436662, 125, '2015-03-01 01:00:03.000000', 'consum', 0.0221, 'lps'),
	(436663, 125, '2015-03-01 01:00:04.000000', 'consum', 0.0223, 'lps'),
	(436664, 125, '2015-03-01 01:00:05.000000', 'consum', 0.0225, 'lps'),
	(436665, 125, '2015-03-01 01:00:06.000000', 'consum', 0.0214, 'lps'),
	(436666, 125, '2015-03-01 01:00:07.000000', 'consum', 0.0219, 'lps'),
	(436667, 125, '2015-03-01 01:00:08.000000', 'consum', 0.0225, 'lps'),
	(436668, 125, '2015-03-01 01:00:09.000000', 'consum', 0.0224, 'lps'),
	(436669, 125, '2015-03-01 01:00:10.000000', 'consum', 0.0221, 'lps'),
	(436670, 125, '2015-03-01 01:00:11.000000', 'consum', 0.0221, 'lps'),
	(436671, 125, '2015-03-01 01:00:12.000000', 'consum', 0.0216, 'lps'),
	(436672, 125, '2015-03-01 01:00:13.000000', 'consum', 0.0224, 'lps'),
	(436673, 125, '2015-03-01 01:00:14.000000', 'consum', 0.0212, 'lps'),
	(436674, 125, '2015-03-01 01:00:15.000000', 'consum', 0.0213, 'lps'),
	(436675, 125, '2015-03-01 01:00:16.000000', 'consum', 0.0221, 'lps'),
	(436676, 125, '2015-03-01 01:00:17.000000', 'consum', 0.0221, 'lps'),
	(436677, 125, '2015-03-01 01:00:18.000000', 'consum', 0.0217, 'lps'),
	(436678, 125, '2015-03-01 01:00:19.000000', 'consum', 0.0213, 'lps'),
	(436679, 125, '2015-03-01 01:00:20.000000', 'consum', 0.0222, 'lps'),
	(436680, 125, '2015-03-01 01:00:21.000000', 'consum', 0.0225, 'lps'),
	(436681, 125, '2015-03-01 01:00:22.000000', 'consum', 0.0216, 'lps'),
	(436682, 125, '2015-03-01 01:00:23.000000', 'consum', 0.0211, 'lps'),
	(436683, 125, '2015-03-01 01:00:24.000000', 'consum', 0.0217, 'lps'),
	(436684, 125, '2015-03-01 01:00:25.000000', 'consum', 0.0223, 'lps'),
	(436685, 125, '2015-03-01 01:00:26.000000', 'consum', 0.0222, 'lps'),
	(436686, 125, '2015-03-01 01:00:27.000000', 'consum', 0.0213, 'lps'),
	(436687, 125, '2015-03-01 01:00:28.000000', 'consum', 0.0222, 'lps'),
	(436688, 125, '2015-03-01 01:00:29.000000', 'consum', 0.0214, 'lps'),
	(436689, 125, '2015-03-01 01:00:30.000000', 'consum', 0.0210, 'lps'),
	(436690, 125, '2015-03-01 01:00:31.000000', 'consum', 0.0214, 'lps'),
	(436691, 125, '2015-03-01 01:00:32.000000', 'consum', 0.0215, 'lps'),
	(436692, 125, '2015-03-01 01:00:33.000000', 'consum', 0.0224, 'lps'),
	(436693, 125, '2015-03-01 01:00:34.000000', 'consum', 0.0214, 'lps'),
	(436694, 125, '2015-03-01 01:00:35.000000', 'consum', 0.0222, 'lps'),
	(436695, 125, '2015-03-01 01:00:36.000000', 'consum', 0.0226, 'lps'),
	(436696, 125, '2015-03-01 01:00:37.000000', 'consum', 0.0221, 'lps'),
	(436697, 125, '2015-03-01 01:00:38.000000', 'consum', 0.0216, 'lps'),
	(436698, 125, '2015-03-01 01:00:39.000000', 'consum', 0.0225, 'lps'),
	(436699, 125, '2015-03-01 01:00:40.000000', 'consum', 0.0216, 'lps'),
	(436700, 125, '2015-03-01 01:00:41.000000', 'consum', 0.0215, 'lps'),
	(436701, 125, '2015-03-01 01:00:42.000000', 'consum', 0.0214, 'lps'),
	(436702, 125, '2015-03-01 01:00:43.000000', 'consum', 0.0217, 'lps'),
	(436703, 125, '2015-03-01 01:00:44.000000', 'consum', 0.0215, 'lps'),
	(436704, 125, '2015-03-01 01:00:45.000000', 'consum', 0.0217, 'lps'),
	(436705, 125, '2015-03-01 01:00:46.000000', 'consum', 0.0213, 'lps'),
	(436706, 125, '2015-03-01 01:00:47.000000', 'consum', 0.0221, 'lps'),
	(436707, 125, '2015-03-01 01:00:48.000000', 'consum', 0.0221, 'lps'),
	(436708, 125, '2015-03-01 01:00:49.000000', 'consum', 0.0216, 'lps'),
	(436709, 125, '2015-03-01 01:00:50.000000', 'consum', 0.0224, 'lps'),
	(436710, 125, '2015-03-01 01:00:51.000000', 'consum', 0.0212, 'lps'),
	(436711, 125, '2015-03-01 01:00:52.000000', 'consum', 0.0212, 'lps'),
	(436712, 125, '2015-03-01 01:00:53.000000', 'consum', 0.0217, 'lps'),
	(436713, 125, '2015-03-01 01:00:54.000000', 'consum', 0.0219, 'lps'),
	(436714, 125, '2015-03-01 01:00:55.000000', 'consum', 0.0221, 'lps'),
	(436715, 125, '2015-03-01 01:00:56.000000', 'consum', 0.0220, 'lps'),
	(436716, 125, '2015-03-01 01:00:57.000000', 'consum', 0.0210, 'lps'),
	(436717, 125, '2015-03-01 01:00:58.000000', 'consum', 0.0217, 'lps'),
	(436718, 125, '2015-03-01 01:00:59.000000', 'consum', 0.0226, 'lps'),
	(436719, 125, '2015-03-01 01:01:00.000000', 'consum', 0.0219, 'lps'),
	(436720, 125, '2015-03-01 01:01:01.000000', 'consum', 0.0224, 'lps'),
	(436721, 125, '2015-03-01 01:01:02.000000', 'consum', 0.0220, 'lps'),
	(436722, 125, '2015-03-01 01:01:03.000000', 'consum', 0.0219, 'lps'),
	(436723, 125, '2015-03-01 01:01:04.000000', 'consum', 0.0225, 'lps'),
	(436724, 125, '2015-03-01 01:01:05.000000', 'consum', 0.0226, 'lps'),
	(436725, 125, '2015-03-01 01:01:06.000000', 'consum', 0.0212, 'lps'),
	(436726, 125, '2015-03-01 01:01:07.000000', 'consum', 0.0222, 'lps'),
	(436727, 125, '2015-03-01 01:01:08.000000', 'consum', 0.0216, 'lps'),
	(436728, 125, '2015-03-01 01:01:09.000000', 'consum', 0.0218, 'lps'),
	(436729, 125, '2015-03-01 01:01:10.000000', 'consum', 0.0218, 'lps'),
	(436730, 125, '2015-03-01 01:01:11.000000', 'consum', 0.0226, 'lps'),
	(436731, 125, '2015-03-01 01:01:12.000000', 'consum', 0.0216, 'lps'),
	(436732, 125, '2015-03-01 01:01:13.000000', 'consum', 0.0211, 'lps'),
	(436733, 125, '2015-03-01 01:01:14.000000', 'consum', 0.0212, 'lps'),
	(436734, 125, '2015-03-01 01:01:15.000000', 'consum', 0.0219, 'lps'),
	(436735, 125, '2015-03-01 01:01:16.000000', 'consum', 0.0216, 'lps'),
	(436736, 125, '2015-03-01 01:01:17.000000', 'consum', 0.0211, 'lps'),
	(436737, 125, '2015-03-01 01:01:18.000000', 'consum', 0.0215, 'lps'),
	(436738, 125, '2015-03-01 01:01:19.000000', 'consum', 0.0217, 'lps'),
	(436739, 125, '2015-03-01 01:01:20.000000', 'consum', 0.0213, 'lps'),
	(436740, 125, '2015-03-01 01:01:21.000000', 'consum', 0.0221, 'lps'),
	(436741, 125, '2015-03-01 01:01:22.000000', 'consum', 0.0221, 'lps'),
	(436742, 125, '2015-03-01 01:01:23.000000', 'consum', 0.0217, 'lps'),
	(436743, 125, '2015-03-01 01:01:24.000000', 'consum', 0.0213, 'lps'),
	(436744, 125, '2015-03-01 01:01:25.000000', 'consum', 0.0223, 'lps'),
	(436745, 125, '2015-03-01 01:01:26.000000', 'consum', 0.0215, 'lps'),
	(436746, 125, '2015-03-01 01:01:27.000000', 'consum', 0.0212, 'lps'),
	(436747, 125, '2015-03-01 01:01:28.000000', 'consum', 0.0222, 'lps'),
	(436748, 125, '2015-03-01 01:01:29.000000', 'consum', 0.0212, 'lps'),
	(436749, 125, '2015-03-01 01:01:30.000000', 'consum', 0.0221, 'lps'),
	(436750, 125, '2015-03-01 01:01:31.000000', 'consum', 0.0226, 'lps'),
	(436751, 125, '2015-03-01 01:01:32.000000', 'consum', 0.0224, 'lps'),
	(436752, 125, '2015-03-01 01:01:33.000000', 'consum', 0.0216, 'lps'),
	(436753, 125, '2015-03-01 01:01:34.000000', 'consum', 0.0216, 'lps'),
	(436754, 125, '2015-03-01 01:01:35.000000', 'consum', 0.0220, 'lps'),
	(436755, 125, '2015-03-01 01:01:36.000000', 'consum', 0.0210, 'lps'),
	(436756, 125, '2015-03-01 01:01:37.000000', 'consum', 0.0212, 'lps'),
	(436757, 125, '2015-03-01 01:01:38.000000', 'consum', 0.0224, 'lps'),
	(436758, 125, '2015-03-01 01:01:39.000000', 'consum', 0.0222, 'lps'),
	(436759, 125, '2015-03-01 01:01:40.000000', 'consum', 0.0210, 'lps'),
	(436760, 125, '2015-03-01 01:01:41.000000', 'consum', 0.0211, 'lps'),
	(436761, 125, '2015-03-01 01:01:42.000000', 'consum', 0.0216, 'lps'),
	(436762, 125, '2015-03-01 01:01:43.000000', 'consum', 0.0217, 'lps'),
	(436763, 125, '2015-03-01 01:01:44.000000', 'consum', 0.0214, 'lps'),
	(436764, 125, '2015-03-01 01:01:45.000000', 'consum', 0.0224, 'lps'),
	(436765, 125, '2015-03-01 01:01:46.000000', 'consum', 0.0217, 'lps'),
	(436766, 125, '2015-03-01 01:01:47.000000', 'consum', 0.0224, 'lps'),
	(436767, 125, '2015-03-01 01:01:48.000000', 'consum', 0.0222, 'lps'),
	(436768, 125, '2015-03-01 01:01:49.000000', 'consum', 0.0212, 'lps'),
	(436769, 125, '2015-03-01 01:01:50.000000', 'consum', 0.0218, 'lps'),
	(436770, 125, '2015-03-01 01:01:51.000000', 'consum', 0.0212, 'lps'),
	(436771, 125, '2015-03-01 01:01:52.000000', 'consum', 0.0214, 'lps'),
	(436772, 125, '2015-03-01 01:01:53.000000', 'consum', 0.0225, 'lps'),
	(436773, 125, '2015-03-01 01:01:54.000000', 'consum', 0.0222, 'lps'),
	(436774, 125, '2015-03-01 01:01:55.000000', 'consum', 0.0226, 'lps'),
	(436775, 125, '2015-03-01 01:01:56.000000', 'consum', 0.0219, 'lps'),
	(436776, 125, '2015-03-01 01:01:57.000000', 'consum', 0.0210, 'lps'),
	(436777, 125, '2015-03-01 01:01:58.000000', 'consum', 0.0215, 'lps'),
	(436778, 125, '2015-03-01 01:01:59.000000', 'consum', 0.0221, 'lps'),
	(436779, 125, '2015-03-01 01:02:00.000000', 'consum', 0.0215, 'lps'),
	(436780, 125, '2015-03-01 01:02:01.000000', 'consum', 0.0221, 'lps'),
	(436781, 125, '2015-03-01 01:02:02.000000', 'consum', 0.0217, 'lps'),
	(436782, 125, '2015-03-01 01:02:03.000000', 'consum', 0.0226, 'lps'),
	(436783, 125, '2015-03-01 01:02:04.000000', 'consum', 0.0222, 'lps'),
	(436784, 125, '2015-03-01 01:02:05.000000', 'consum', 0.0222, 'lps'),
	(436785, 125, '2015-03-01 01:02:06.000000', 'consum', 0.0218, 'lps'),
	(436786, 125, '2015-03-01 01:02:07.000000', 'consum', 0.0215, 'lps'),
	(436787, 125, '2015-03-01 01:02:08.000000', 'consum', 0.0210, 'lps'),
	(436788, 125, '2015-03-01 01:02:09.000000', 'consum', 0.0215, 'lps'),
	(436789, 125, '2015-03-01 01:02:10.000000', 'consum', 0.0216, 'lps'),
	(436790, 125, '2015-03-01 01:02:11.000000', 'consum', 0.0210, 'lps'),
	(436791, 125, '2015-03-01 01:02:12.000000', 'consum', 0.0211, 'lps'),
	(436792, 125, '2015-03-01 01:02:13.000000', 'consum', 0.0215, 'lps'),
	(436793, 125, '2015-03-01 01:02:14.000000', 'consum', 0.0213, 'lps'),
	(436794, 125, '2015-03-01 01:02:15.000000', 'consum', 0.0212, 'lps'),
	(436795, 125, '2015-03-01 01:02:16.000000', 'consum', 0.0210, 'lps'),
	(436796, 125, '2015-03-01 01:02:17.000000', 'consum', 0.0222, 'lps'),
	(436797, 125, '2015-03-01 01:02:18.000000', 'consum', 0.0219, 'lps'),
	(436798, 125, '2015-03-01 01:02:19.000000', 'consum', 0.0220, 'lps'),
	(436799, 125, '2015-03-01 01:02:20.000000', 'consum', 0.0219, 'lps'),
	(436800, 125, '2015-03-01 01:02:21.000000', 'consum', 0.0222, 'lps'),
	(436801, 125, '2015-03-01 01:02:22.000000', 'consum', 0.0212, 'lps'),
	(436802, 125, '2015-03-01 01:02:23.000000', 'consum', 0.0220, 'lps'),
	(436803, 125, '2015-03-01 01:02:24.000000', 'consum', 0.0217, 'lps'),
	(436804, 125, '2015-03-01 01:02:25.000000', 'consum', 0.0218, 'lps'),
	(436805, 125, '2015-03-01 01:02:26.000000', 'consum', 0.0211, 'lps'),
	(436806, 125, '2015-03-01 01:02:27.000000', 'consum', 0.0226, 'lps'),
	(436807, 125, '2015-03-01 01:02:28.000000', 'consum', 0.0220, 'lps'),
	(436808, 125, '2015-03-01 01:02:29.000000', 'consum', 0.0211, 'lps'),
	(436809, 125, '2015-03-01 01:02:30.000000', 'consum', 0.0222, 'lps'),
	(436810, 125, '2015-03-01 01:02:31.000000', 'consum', 0.0214, 'lps'),
	(436811, 125, '2015-03-01 01:02:32.000000', 'consum', 0.0214, 'lps'),
	(436812, 125, '2015-03-01 01:02:33.000000', 'consum', 0.0217, 'lps'),
	(436813, 125, '2015-03-01 01:02:34.000000', 'consum', 0.0217, 'lps'),
	(436814, 125, '2015-03-01 01:02:35.000000', 'consum', 0.0223, 'lps'),
	(436815, 125, '2015-03-01 01:02:36.000000', 'consum', 0.0220, 'lps'),
	(436816, 125, '2015-03-01 01:02:37.000000', 'consum', 0.0221, 'lps'),
	(436817, 125, '2015-03-01 01:02:38.000000', 'consum', 0.0221, 'lps'),
	(436818, 125, '2015-03-01 01:02:39.000000', 'consum', 0.0213, 'lps'),
	(436819, 125, '2015-03-01 01:02:40.000000', 'consum', 0.0212, 'lps'),
	(436820, 125, '2015-03-01 01:02:41.000000', 'consum', 0.0211, 'lps'),
	(436821, 125, '2015-03-01 01:02:42.000000', 'consum', 0.0226, 'lps'),
	(436822, 125, '2015-03-01 01:02:43.000000', 'consum', 0.0221, 'lps'),
	(436823, 125, '2015-03-01 01:02:44.000000', 'consum', 0.0217, 'lps'),
	(436824, 125, '2015-03-01 01:02:45.000000', 'consum', 0.0211, 'lps'),
	(436825, 125, '2015-03-01 01:02:46.000000', 'consum', 0.0212, 'lps'),
	(436826, 125, '2015-03-01 01:02:47.000000', 'consum', 0.0217, 'lps'),
	(436827, 125, '2015-03-01 01:02:48.000000', 'consum', 0.0225, 'lps'),
	(436828, 125, '2015-03-01 01:02:49.000000', 'consum', 0.0212, 'lps'),
	(436829, 125, '2015-03-01 01:02:50.000000', 'consum', 0.0225, 'lps'),
	(436830, 125, '2015-03-01 01:02:51.000000', 'consum', 0.0212, 'lps'),
	(436831, 125, '2015-03-01 01:02:52.000000', 'consum', 0.0210, 'lps'),
	(436832, 125, '2015-03-01 01:02:53.000000', 'consum', 0.0222, 'lps'),
	(436833, 125, '2015-03-01 01:02:54.000000', 'consum', 0.0221, 'lps'),
	(436834, 125, '2015-03-01 01:02:55.000000', 'consum', 0.0212, 'lps'),
	(436835, 125, '2015-03-01 01:02:56.000000', 'consum', 0.0221, 'lps'),
	(436836, 125, '2015-03-01 01:02:57.000000', 'consum', 0.0225, 'lps'),
	(436837, 125, '2015-03-01 01:02:58.000000', 'consum', 0.0220, 'lps'),
	(436838, 125, '2015-03-01 01:02:59.000000', 'consum', 0.0213, 'lps'),
	(436839, 125, '2015-03-01 01:03:00.000000', 'consum', 0.0213, 'lps'),
	(436840, 125, '2015-03-01 01:03:01.000000', 'consum', 0.0216, 'lps'),
	(436841, 125, '2015-03-01 01:03:02.000000', 'consum', 0.0217, 'lps'),
	(436842, 125, '2015-03-01 01:03:03.000000', 'consum', 0.0226, 'lps'),
	(436843, 125, '2015-03-01 01:03:04.000000', 'consum', 0.0220, 'lps'),
	(436844, 125, '2015-03-01 01:03:05.000000', 'consum', 0.0210, 'lps'),
	(436845, 125, '2015-03-01 01:03:06.000000', 'consum', 0.0215, 'lps'),
	(436846, 125, '2015-03-01 01:03:07.000000', 'consum', 0.0218, 'lps'),
	(436847, 125, '2015-03-01 01:03:08.000000', 'consum', 0.0217, 'lps'),
	(436848, 125, '2015-03-01 01:03:09.000000', 'consum', 0.0223, 'lps'),
	(436849, 125, '2015-03-01 01:03:10.000000', 'consum', 0.0222, 'lps'),
	(436850, 125, '2015-03-01 01:03:11.000000', 'consum', 0.0212, 'lps'),
	(436851, 125, '2015-03-01 01:03:12.000000', 'consum', 0.0219, 'lps'),
	(436852, 125, '2015-03-01 01:03:13.000000', 'consum', 0.0217, 'lps'),
	(436853, 125, '2015-03-01 01:03:14.000000', 'consum', 0.0220, 'lps'),
	(436854, 125, '2015-03-01 01:03:15.000000', 'consum', 0.0219, 'lps'),
	(436855, 125, '2015-03-01 01:03:16.000000', 'consum', 0.0211, 'lps'),
	(436856, 125, '2015-03-01 01:03:17.000000', 'consum', 0.0223, 'lps'),
	(436857, 125, '2015-03-01 01:03:18.000000', 'consum', 0.0221, 'lps'),
	(436858, 125, '2015-03-01 01:03:19.000000', 'consum', 0.0226, 'lps'),
	(436859, 125, '2015-03-01 01:03:20.000000', 'consum', 0.0222, 'lps'),
	(436860, 125, '2015-03-01 01:03:21.000000', 'consum', 0.0224, 'lps'),
	(436861, 125, '2015-03-01 01:03:22.000000', 'consum', 0.0210, 'lps'),
	(436862, 125, '2015-03-01 01:03:23.000000', 'consum', 0.0221, 'lps'),
	(436863, 125, '2015-03-01 01:03:24.000000', 'consum', 0.0215, 'lps'),
	(436864, 125, '2015-03-01 01:03:25.000000', 'consum', 0.0217, 'lps'),
	(436865, 125, '2015-03-01 01:03:26.000000', 'consum', 0.0216, 'lps'),
	(436866, 125, '2015-03-01 01:03:27.000000', 'consum', 0.0220, 'lps'),
	(436867, 125, '2015-03-01 01:03:28.000000', 'consum', 0.0223, 'lps'),
	(436868, 125, '2015-03-01 01:03:29.000000', 'consum', 0.0214, 'lps'),
	(436869, 125, '2015-03-01 01:03:30.000000', 'consum', 0.0226, 'lps'),
	(436870, 125, '2015-03-01 01:03:31.000000', 'consum', 0.0226, 'lps'),
	(436871, 125, '2015-03-01 01:03:32.000000', 'consum', 0.0224, 'lps'),
	(436872, 125, '2015-03-01 01:03:33.000000', 'consum', 0.0215, 'lps'),
	(436873, 125, '2015-03-01 01:03:34.000000', 'consum', 0.0213, 'lps'),
	(436874, 125, '2015-03-01 01:03:35.000000', 'consum', 0.0211, 'lps'),
	(436875, 125, '2015-03-01 01:03:36.000000', 'consum', 0.0222, 'lps'),
	(436876, 125, '2015-03-01 01:03:37.000000', 'consum', 0.0218, 'lps'),
	(436877, 125, '2015-03-01 01:03:38.000000', 'consum', 0.0212, 'lps'),
	(436878, 125, '2015-03-01 01:03:39.000000', 'consum', 0.0214, 'lps'),
	(436879, 125, '2015-03-01 01:03:40.000000', 'consum', 0.0223, 'lps'),
	(436880, 125, '2015-03-01 01:03:41.000000', 'consum', 0.0215, 'lps'),
	(436881, 125, '2015-03-01 01:03:42.000000', 'consum', 0.0214, 'lps'),
	(436882, 125, '2015-03-01 01:03:43.000000', 'consum', 0.0215, 'lps'),
	(436883, 125, '2015-03-01 01:03:44.000000', 'consum', 0.0222, 'lps'),
	(436884, 125, '2015-03-01 01:03:45.000000', 'consum', 0.0224, 'lps'),
	(436885, 125, '2015-03-01 01:03:46.000000', 'consum', 0.0226, 'lps'),
	(436886, 125, '2015-03-01 01:03:47.000000', 'consum', 0.0213, 'lps'),
	(436887, 125, '2015-03-01 01:03:48.000000', 'consum', 0.0213, 'lps'),
	(436888, 125, '2015-03-01 01:03:49.000000', 'consum', 0.0215, 'lps'),
	(436889, 125, '2015-03-01 01:03:50.000000', 'consum', 0.0212, 'lps'),
	(436890, 125, '2015-03-01 01:03:51.000000', 'consum', 0.0221, 'lps'),
	(436891, 125, '2015-03-01 01:03:52.000000', 'consum', 0.0226, 'lps'),
	(436892, 125, '2015-03-01 01:03:53.000000', 'consum', 0.0224, 'lps'),
	(436893, 125, '2015-03-01 01:03:54.000000', 'consum', 0.0215, 'lps'),
	(436894, 125, '2015-03-01 01:03:55.000000', 'consum', 0.0212, 'lps'),
	(436895, 125, '2015-03-01 01:03:56.000000', 'consum', 0.0222, 'lps'),
	(436896, 125, '2015-03-01 01:03:57.000000', 'consum', 0.0214, 'lps'),
	(436897, 125, '2015-03-01 01:03:58.000000', 'consum', 0.0210, 'lps'),
	(436898, 125, '2015-03-01 01:03:59.000000', 'consum', 0.0215, 'lps'),
	(436899, 125, '2015-03-01 01:04:00.000000', 'consum', 0.0218, 'lps'),
	(436900, 125, '2015-03-01 01:04:01.000000', 'consum', 0.0218, 'lps'),
	(436901, 125, '2015-03-01 01:04:02.000000', 'consum', 0.0210, 'lps'),
	(436902, 125, '2015-03-01 01:04:03.000000', 'consum', 0.0220, 'lps'),
	(436903, 125, '2015-03-01 01:04:04.000000', 'consum', 0.0212, 'lps'),
	(436904, 125, '2015-03-01 01:04:05.000000', 'consum', 0.0221, 'lps'),
	(436905, 125, '2015-03-01 01:04:06.000000', 'consum', 0.0211, 'lps'),
	(436906, 125, '2015-03-01 01:04:07.000000', 'consum', 0.0214, 'lps'),
	(436907, 125, '2015-03-01 01:04:08.000000', 'consum', 0.0211, 'lps'),
	(436908, 125, '2015-03-01 01:04:09.000000', 'consum', 0.0223, 'lps'),
	(436909, 125, '2015-03-01 01:04:10.000000', 'consum', 0.0219, 'lps'),
	(436910, 125, '2015-03-01 01:04:11.000000', 'consum', 0.0217, 'lps'),
	(436911, 125, '2015-03-01 01:04:12.000000', 'consum', 0.0219, 'lps'),
	(436912, 125, '2015-03-01 01:04:13.000000', 'consum', 0.0218, 'lps'),
	(436913, 125, '2015-03-01 01:04:14.000000', 'consum', 0.0221, 'lps'),
	(436914, 125, '2015-03-01 01:04:15.000000', 'consum', 0.0226, 'lps'),
	(436915, 125, '2015-03-01 01:04:16.000000', 'consum', 0.0225, 'lps'),
	(436916, 125, '2015-03-01 01:04:17.000000', 'consum', 0.0219, 'lps'),
	(436917, 125, '2015-03-01 01:04:18.000000', 'consum', 0.0212, 'lps'),
	(436918, 125, '2015-03-01 01:04:19.000000', 'consum', 0.0210, 'lps'),
	(436919, 125, '2015-03-01 01:04:20.000000', 'consum', 0.0221, 'lps'),
	(436920, 125, '2015-03-01 01:04:21.000000', 'consum', 0.0217, 'lps'),
	(436921, 125, '2015-03-01 01:04:22.000000', 'consum', 0.0210, 'lps'),
	(436922, 125, '2015-03-01 01:04:23.000000', 'consum', 0.0222, 'lps'),
	(436923, 125, '2015-03-01 01:04:24.000000', 'consum', 0.0221, 'lps'),
	(436924, 125, '2015-03-01 01:04:25.000000', 'consum', 0.0212, 'lps'),
	(436925, 125, '2015-03-01 01:04:26.000000', 'consum', 0.0222, 'lps'),
	(436926, 125, '2015-03-01 01:04:27.000000', 'consum', 0.0215, 'lps'),
	(436927, 125, '2015-03-01 01:04:28.000000', 'consum', 0.0216, 'lps'),
	(436928, 125, '2015-03-01 01:04:29.000000', 'consum', 0.0224, 'lps'),
	(436929, 125, '2015-03-01 01:04:30.000000', 'consum', 0.0210, 'lps'),
	(436930, 125, '2015-03-01 01:04:31.000000', 'consum', 0.0221, 'lps'),
	(436931, 125, '2015-03-01 01:04:32.000000', 'consum', 0.0217, 'lps'),
	(436932, 125, '2015-03-01 01:04:33.000000', 'consum', 0.0226, 'lps'),
	(436933, 125, '2015-03-01 01:04:34.000000', 'consum', 0.0220, 'lps'),
	(436934, 125, '2015-03-01 01:04:35.000000', 'consum', 0.0213, 'lps'),
	(436935, 125, '2015-03-01 01:04:36.000000', 'consum', 0.0212, 'lps'),
	(436936, 125, '2015-03-01 01:04:37.000000', 'consum', 0.0213, 'lps'),
	(436937, 125, '2015-03-01 01:04:38.000000', 'consum', 0.0219, 'lps'),
	(436938, 125, '2015-03-01 01:04:39.000000', 'consum', 0.0214, 'lps'),
	(436939, 125, '2015-03-01 01:04:40.000000', 'consum', 0.0218, 'lps'),
	(436940, 125, '2015-03-01 01:04:41.000000', 'consum', 0.0223, 'lps'),
	(436941, 125, '2015-03-01 01:04:42.000000', 'consum', 0.0218, 'lps'),
	(436942, 125, '2015-03-01 01:04:43.000000', 'consum', 0.0212, 'lps'),
	(436943, 125, '2015-03-01 01:04:44.000000', 'consum', 0.0212, 'lps'),
	(436944, 125, '2015-03-01 01:04:45.000000', 'consum', 0.0214, 'lps'),
	(436945, 125, '2015-03-01 01:04:46.000000', 'consum', 0.0225, 'lps'),
	(436946, 125, '2015-03-01 01:04:47.000000', 'consum', 0.0222, 'lps'),
	(436947, 125, '2015-03-01 01:04:48.000000', 'consum', 0.0210, 'lps'),
	(436948, 125, '2015-03-01 01:04:49.000000', 'consum', 0.0224, 'lps'),
	(436949, 125, '2015-03-01 01:04:50.000000', 'consum', 0.0213, 'lps'),
	(436950, 125, '2015-03-01 01:04:51.000000', 'consum', 0.0219, 'lps'),
	(436951, 125, '2015-03-01 01:04:52.000000', 'consum', 0.0211, 'lps'),
	(436952, 125, '2015-03-01 01:04:53.000000', 'consum', 0.0224, 'lps'),
	(436953, 125, '2015-03-01 01:04:54.000000', 'consum', 0.0226, 'lps'),
	(436954, 125, '2015-03-01 01:04:55.000000', 'consum', 0.0215, 'lps'),
	(436955, 125, '2015-03-01 01:04:56.000000', 'consum', 0.0219, 'lps'),
	(436956, 125, '2015-03-01 01:04:57.000000', 'consum', 0.0226, 'lps'),
	(436957, 125, '2015-03-01 01:04:58.000000', 'consum', 0.0214, 'lps'),
	(436958, 125, '2015-03-01 01:04:59.000000', 'consum', 0.0214, 'lps'),
	(436959, 125, '2015-03-01 01:05:00.000000', 'consum', 0.0219, 'lps'),
	(436960, 125, '2015-03-01 01:05:01.000000', 'consum', 0.0211, 'lps'),
	(436961, 125, '2015-03-01 01:05:02.000000', 'consum', 0.0224, 'lps'),
	(436962, 125, '2015-03-01 01:05:03.000000', 'consum', 0.0223, 'lps'),
	(436963, 125, '2015-03-01 01:05:04.000000', 'consum', 0.0216, 'lps'),
	(436964, 125, '2015-03-01 01:05:05.000000', 'consum', 0.0220, 'lps'),
	(436965, 125, '2015-03-01 01:05:06.000000', 'consum', 0.0210, 'lps'),
	(436966, 125, '2015-03-01 01:05:07.000000', 'consum', 0.0214, 'lps'),
	(436967, 125, '2015-03-01 01:05:08.000000', 'consum', 0.0214, 'lps'),
	(436968, 125, '2015-03-01 01:05:09.000000', 'consum', 0.0217, 'lps'),
	(436969, 125, '2015-03-01 01:05:10.000000', 'consum', 0.0219, 'lps'),
	(436970, 125, '2015-03-01 01:05:11.000000', 'consum', 0.0217, 'lps'),
	(436971, 125, '2015-03-01 01:05:12.000000', 'consum', 0.0217, 'lps'),
	(436972, 125, '2015-03-01 01:05:13.000000', 'consum', 0.0226, 'lps'),
	(436973, 125, '2015-03-01 01:05:14.000000', 'consum', 0.0219, 'lps'),
	(436974, 125, '2015-03-01 01:05:15.000000', 'consum', 0.0224, 'lps'),
	(436975, 125, '2015-03-01 01:05:16.000000', 'consum', 0.0219, 'lps'),
	(436976, 125, '2015-03-01 01:05:17.000000', 'consum', 0.0213, 'lps'),
	(436977, 125, '2015-03-01 01:05:18.000000', 'consum', 0.0217, 'lps'),
	(436978, 125, '2015-03-01 01:05:19.000000', 'consum', 0.0218, 'lps'),
	(436979, 125, '2015-03-01 01:05:20.000000', 'consum', 0.0214, 'lps'),
	(436980, 125, '2015-03-01 01:05:21.000000', 'consum', 0.0222, 'lps'),
	(436981, 125, '2015-03-01 01:05:22.000000', 'consum', 0.0210, 'lps'),
	(436982, 125, '2015-03-01 01:05:23.000000', 'consum', 0.0224, 'lps'),
	(436983, 125, '2015-03-01 01:05:24.000000', 'consum', 0.0213, 'lps'),
	(436984, 125, '2015-03-01 01:05:25.000000', 'consum', 0.0215, 'lps'),
	(436985, 125, '2015-03-01 01:05:26.000000', 'consum', 0.0212, 'lps'),
	(436986, 125, '2015-03-01 01:05:27.000000', 'consum', 0.0221, 'lps'),
	(436987, 125, '2015-03-01 01:05:28.000000', 'consum', 0.0226, 'lps'),
	(436988, 125, '2015-03-01 01:05:29.000000', 'consum', 0.0221, 'lps'),
	(436989, 125, '2015-03-01 01:05:30.000000', 'consum', 0.0221, 'lps'),
	(436990, 125, '2015-03-01 01:05:31.000000', 'consum', 0.0216, 'lps'),
	(436991, 125, '2015-03-01 01:05:32.000000', 'consum', 0.0222, 'lps'),
	(436992, 125, '2015-03-01 01:05:33.000000', 'consum', 0.0221, 'lps'),
	(436993, 125, '2015-03-01 01:05:34.000000', 'consum', 0.0212, 'lps'),
	(436994, 125, '2015-03-01 01:05:35.000000', 'consum', 0.0222, 'lps'),
	(436995, 125, '2015-03-01 01:05:36.000000', 'consum', 0.0214, 'lps'),
	(436996, 125, '2015-03-01 01:05:37.000000', 'consum', 0.0213, 'lps'),
	(436997, 125, '2015-03-01 01:05:38.000000', 'consum', 0.0211, 'lps'),
	(436998, 125, '2015-03-01 01:05:39.000000', 'consum', 0.0223, 'lps'),
	(436999, 125, '2015-03-01 01:05:40.000000', 'consum', 0.0224, 'lps'),
	(437000, 125, '2015-03-01 01:05:41.000000', 'consum', 0.0223, 'lps'),
	(437001, 125, '2015-03-01 01:05:42.000000', 'consum', 0.0216, 'lps'),
	(437002, 125, '2015-03-01 01:05:43.000000', 'consum', 0.0219, 'lps'),
	(437003, 125, '2015-03-01 01:05:44.000000', 'consum', 0.0220, 'lps'),
	(437004, 125, '2015-03-01 01:05:45.000000', 'consum', 0.0215, 'lps'),
	(437005, 125, '2015-03-01 01:05:46.000000', 'consum', 0.0225, 'lps'),
	(437006, 125, '2015-03-01 01:05:47.000000', 'consum', 0.0218, 'lps'),
	(437007, 125, '2015-03-01 01:05:48.000000', 'consum', 0.0222, 'lps'),
	(437008, 125, '2015-03-01 01:05:49.000000', 'consum', 0.0212, 'lps'),
	(437009, 125, '2015-03-01 01:05:50.000000', 'consum', 0.0221, 'lps'),
	(437010, 125, '2015-03-01 01:05:51.000000', 'consum', 0.0223, 'lps'),
	(437011, 125, '2015-03-01 01:05:52.000000', 'consum', 0.0211, 'lps'),
	(437012, 125, '2015-03-01 01:05:53.000000', 'consum', 0.0224, 'lps'),
	(437013, 125, '2015-03-01 01:05:54.000000', 'consum', 0.0212, 'lps'),
	(437014, 125, '2015-03-01 01:05:55.000000', 'consum', 0.0213, 'lps'),
	(437015, 125, '2015-03-01 01:05:56.000000', 'consum', 0.0220, 'lps'),
	(437016, 125, '2015-03-01 01:05:57.000000', 'consum', 0.0219, 'lps'),
	(437017, 125, '2015-03-01 01:05:58.000000', 'consum', 0.0222, 'lps'),
	(437018, 125, '2015-03-01 01:05:59.000000', 'consum', 0.0211, 'lps'),
	(437019, 125, '2015-03-01 01:06:00.000000', 'consum', 0.0212, 'lps'),
	(437020, 125, '2015-03-01 01:06:01.000000', 'consum', 0.0220, 'lps'),
	(437021, 125, '2015-03-01 01:06:02.000000', 'consum', 0.0219, 'lps'),
	(437022, 125, '2015-03-01 01:06:03.000000', 'consum', 0.0210, 'lps'),
	(437023, 125, '2015-03-01 01:06:04.000000', 'consum', 0.0218, 'lps'),
	(437024, 125, '2015-03-01 01:06:05.000000', 'consum', 0.0217, 'lps'),
	(437025, 125, '2015-03-01 01:06:06.000000', 'consum', 0.0219, 'lps'),
	(437026, 125, '2015-03-01 01:06:07.000000', 'consum', 0.0218, 'lps'),
	(437027, 125, '2015-03-01 01:06:08.000000', 'consum', 0.0223, 'lps'),
	(437028, 125, '2015-03-01 01:06:09.000000', 'consum', 0.0219, 'lps'),
	(437029, 125, '2015-03-01 01:06:10.000000', 'consum', 0.0217, 'lps'),
	(437030, 125, '2015-03-01 01:06:11.000000', 'consum', 0.0216, 'lps'),
	(437031, 125, '2015-03-01 01:06:12.000000', 'consum', 0.0222, 'lps'),
	(437032, 125, '2015-03-01 01:06:13.000000', 'consum', 0.0218, 'lps'),
	(437033, 125, '2015-03-01 01:06:14.000000', 'consum', 0.0215, 'lps'),
	(437034, 125, '2015-03-01 01:06:15.000000', 'consum', 0.0226, 'lps'),
	(437035, 125, '2015-03-01 01:06:16.000000', 'consum', 0.0210, 'lps'),
	(437036, 125, '2015-03-01 01:06:17.000000', 'consum', 0.0213, 'lps'),
	(437037, 125, '2015-03-01 01:06:18.000000', 'consum', 0.0226, 'lps'),
	(437038, 125, '2015-03-01 01:06:19.000000', 'consum', 0.0211, 'lps'),
	(437039, 125, '2015-03-01 01:06:20.000000', 'consum', 0.0220, 'lps'),
	(437040, 125, '2015-03-01 01:06:21.000000', 'consum', 0.0221, 'lps'),
	(437041, 125, '2015-03-01 01:06:22.000000', 'consum', 0.0222, 'lps'),
	(437042, 125, '2015-03-01 01:06:23.000000', 'consum', 0.0217, 'lps'),
	(437043, 125, '2015-03-01 01:06:24.000000', 'consum', 0.0213, 'lps'),
	(437044, 125, '2015-03-01 01:06:25.000000', 'consum', 0.0218, 'lps'),
	(437045, 125, '2015-03-01 01:06:26.000000', 'consum', 0.0211, 'lps'),
	(437046, 125, '2015-03-01 01:06:27.000000', 'consum', 0.0223, 'lps'),
	(437047, 125, '2015-03-01 01:06:28.000000', 'consum', 0.0223, 'lps'),
	(437048, 125, '2015-03-01 01:06:29.000000', 'consum', 0.0221, 'lps'),
	(437049, 125, '2015-03-01 01:06:30.000000', 'consum', 0.0223, 'lps'),
	(437050, 125, '2015-03-01 01:06:31.000000', 'consum', 0.0211, 'lps'),
	(437051, 125, '2015-03-01 01:06:32.000000', 'consum', 0.0225, 'lps'),
	(437052, 125, '2015-03-01 01:06:33.000000', 'consum', 0.0217, 'lps'),
	(437053, 125, '2015-03-01 01:06:34.000000', 'consum', 0.0217, 'lps'),
	(437054, 125, '2015-03-01 01:06:35.000000', 'consum', 0.0225, 'lps'),
	(437055, 125, '2015-03-01 01:06:36.000000', 'consum', 0.0211, 'lps'),
	(437056, 125, '2015-03-01 01:06:37.000000', 'consum', 0.0225, 'lps'),
	(437057, 125, '2015-03-01 01:06:38.000000', 'consum', 0.0212, 'lps'),
	(437058, 125, '2015-03-01 01:06:39.000000', 'consum', 0.0210, 'lps'),
	(437059, 125, '2015-03-01 01:06:40.000000', 'consum', 0.0221, 'lps'),
	(437060, 125, '2015-03-01 01:06:41.000000', 'consum', 0.0216, 'lps'),
	(437061, 125, '2015-03-01 01:06:42.000000', 'consum', 0.0226, 'lps'),
	(437062, 125, '2015-03-01 01:06:43.000000', 'consum', 0.0219, 'lps'),
	(437063, 125, '2015-03-01 01:06:44.000000', 'consum', 0.0210, 'lps'),
	(437064, 125, '2015-03-01 01:06:45.000000', 'consum', 0.0217, 'lps'),
	(437065, 125, '2015-03-01 01:06:46.000000', 'consum', 0.0213, 'lps'),
	(437066, 125, '2015-03-01 01:06:47.000000', 'consum', 0.0219, 'lps'),
	(437067, 125, '2015-03-01 01:06:48.000000', 'consum', 0.0212, 'lps'),
	(437068, 125, '2015-03-01 01:06:49.000000', 'consum', 0.0211, 'lps'),
	(437069, 125, '2015-03-01 01:06:50.000000', 'consum', 0.0211, 'lps'),
	(437070, 125, '2015-03-01 01:06:51.000000', 'consum', 0.0211, 'lps'),
	(437071, 125, '2015-03-01 01:06:52.000000', 'consum', 0.0212, 'lps'),
	(437072, 125, '2015-03-01 01:06:53.000000', 'consum', 0.0220, 'lps'),
	(437073, 125, '2015-03-01 01:06:54.000000', 'consum', 0.0218, 'lps'),
	(437074, 125, '2015-03-01 01:06:55.000000', 'consum', 0.0221, 'lps'),
	(437075, 125, '2015-03-01 01:06:56.000000', 'consum', 0.0225, 'lps'),
	(437076, 125, '2015-03-01 01:06:57.000000', 'consum', 0.0216, 'lps'),
	(437077, 125, '2015-03-01 01:06:58.000000', 'consum', 0.0215, 'lps'),
	(437078, 125, '2015-03-01 01:06:59.000000', 'consum', 0.0216, 'lps'),
	(437079, 125, '2015-03-01 01:07:00.000000', 'consum', 0.0210, 'lps'),
	(437080, 125, '2015-03-01 01:07:01.000000', 'consum', 0.0226, 'lps'),
	(437081, 125, '2015-03-01 01:07:02.000000', 'consum', 0.0223, 'lps'),
	(437082, 125, '2015-03-01 01:07:03.000000', 'consum', 0.0212, 'lps'),
	(437083, 125, '2015-03-01 01:07:04.000000', 'consum', 0.0214, 'lps'),
	(437084, 125, '2015-03-01 01:07:05.000000', 'consum', 0.0210, 'lps'),
	(437085, 125, '2015-03-01 01:07:06.000000', 'consum', 0.0213, 'lps'),
	(437086, 125, '2015-03-01 01:07:07.000000', 'consum', 0.0224, 'lps'),
	(437087, 125, '2015-03-01 01:07:08.000000', 'consum', 0.0222, 'lps'),
	(437088, 125, '2015-03-01 01:07:09.000000', 'consum', 0.0211, 'lps'),
	(437089, 125, '2015-03-01 01:07:10.000000', 'consum', 0.0215, 'lps'),
	(437090, 125, '2015-03-01 01:07:11.000000', 'consum', 0.0213, 'lps'),
	(437091, 125, '2015-03-01 01:07:12.000000', 'consum', 0.0213, 'lps'),
	(437092, 125, '2015-03-01 01:07:13.000000', 'consum', 0.0215, 'lps'),
	(437093, 125, '2015-03-01 01:07:14.000000', 'consum', 0.0210, 'lps'),
	(437094, 125, '2015-03-01 01:07:15.000000', 'consum', 0.0214, 'lps'),
	(437095, 125, '2015-03-01 01:07:16.000000', 'consum', 0.0212, 'lps'),
	(437096, 125, '2015-03-01 01:07:17.000000', 'consum', 0.0211, 'lps'),
	(437097, 125, '2015-03-01 01:07:18.000000', 'consum', 0.0224, 'lps'),
	(437098, 125, '2015-03-01 01:07:19.000000', 'consum', 0.0211, 'lps'),
	(437099, 125, '2015-03-01 01:07:20.000000', 'consum', 0.0226, 'lps'),
	(437100, 125, '2015-03-01 01:07:21.000000', 'consum', 0.0217, 'lps'),
	(437101, 125, '2015-03-01 01:07:22.000000', 'consum', 0.0216, 'lps'),
	(437102, 125, '2015-03-01 01:07:23.000000', 'consum', 0.0218, 'lps'),
	(437103, 125, '2015-03-01 01:07:24.000000', 'consum', 0.0215, 'lps'),
	(437104, 125, '2015-03-01 01:07:25.000000', 'consum', 0.0211, 'lps'),
	(437105, 125, '2015-03-01 01:07:26.000000', 'consum', 0.0218, 'lps'),
	(437106, 125, '2015-03-01 01:07:27.000000', 'consum', 0.0214, 'lps'),
	(437107, 125, '2015-03-01 01:07:28.000000', 'consum', 0.0224, 'lps'),
	(437108, 125, '2015-03-01 01:07:29.000000', 'consum', 0.0217, 'lps'),
	(437109, 125, '2015-03-01 01:07:30.000000', 'consum', 0.0220, 'lps'),
	(437110, 125, '2015-03-01 01:07:31.000000', 'consum', 0.0225, 'lps'),
	(437111, 125, '2015-03-01 01:07:32.000000', 'consum', 0.0219, 'lps'),
	(437112, 125, '2015-03-01 01:07:33.000000', 'consum', 0.0212, 'lps'),
	(437113, 125, '2015-03-01 01:07:34.000000', 'consum', 0.0226, 'lps'),
	(437114, 125, '2015-03-01 01:07:35.000000', 'consum', 0.0215, 'lps'),
	(437115, 125, '2015-03-01 01:07:36.000000', 'consum', 0.0224, 'lps'),
	(437116, 125, '2015-03-01 01:07:37.000000', 'consum', 0.0215, 'lps'),
	(437117, 125, '2015-03-01 01:07:38.000000', 'consum', 0.0225, 'lps'),
	(437118, 125, '2015-03-01 01:07:39.000000', 'consum', 0.0221, 'lps'),
	(437119, 125, '2015-03-01 01:07:40.000000', 'consum', 0.0220, 'lps'),
	(437120, 125, '2015-03-01 01:07:41.000000', 'consum', 0.0210, 'lps'),
	(437121, 125, '2015-03-01 01:07:42.000000', 'consum', 0.0214, 'lps'),
	(437122, 125, '2015-03-01 01:07:43.000000', 'consum', 0.0216, 'lps'),
	(437123, 125, '2015-03-01 01:07:44.000000', 'consum', 0.0211, 'lps'),
	(437124, 125, '2015-03-01 01:07:45.000000', 'consum', 0.0215, 'lps'),
	(437125, 125, '2015-03-01 01:07:46.000000', 'consum', 0.0216, 'lps'),
	(437126, 125, '2015-03-01 01:07:47.000000', 'consum', 0.0224, 'lps'),
	(437127, 125, '2015-03-01 01:07:48.000000', 'consum', 0.0211, 'lps'),
	(437128, 125, '2015-03-01 01:07:49.000000', 'consum', 0.0226, 'lps'),
	(437129, 125, '2015-03-01 01:07:50.000000', 'consum', 0.0221, 'lps'),
	(437130, 125, '2015-03-01 01:07:51.000000', 'consum', 0.0214, 'lps'),
	(437131, 125, '2015-03-01 01:07:52.000000', 'consum', 0.0216, 'lps'),
	(437132, 125, '2015-03-01 01:07:53.000000', 'consum', 0.0211, 'lps'),
	(437133, 125, '2015-03-01 01:07:54.000000', 'consum', 0.0216, 'lps'),
	(437134, 125, '2015-03-01 01:07:55.000000', 'consum', 0.0218, 'lps'),
	(437135, 125, '2015-03-01 01:07:56.000000', 'consum', 0.0218, 'lps'),
	(437136, 125, '2015-03-01 01:07:57.000000', 'consum', 0.0225, 'lps'),
	(437137, 125, '2015-03-01 01:07:58.000000', 'consum', 0.0212, 'lps'),
	(437138, 125, '2015-03-01 01:07:59.000000', 'consum', 0.0225, 'lps'),
	(437139, 125, '2015-03-01 01:08:00.000000', 'consum', 0.0212, 'lps'),
	(437140, 125, '2015-03-01 01:08:01.000000', 'consum', 0.0224, 'lps'),
	(437141, 125, '2015-03-01 01:08:02.000000', 'consum', 0.0210, 'lps'),
	(437142, 125, '2015-03-01 01:08:03.000000', 'consum', 0.0218, 'lps'),
	(437143, 125, '2015-03-01 01:08:04.000000', 'consum', 0.0218, 'lps'),
	(437144, 125, '2015-03-01 01:08:05.000000', 'consum', 0.0224, 'lps'),
	(437145, 125, '2015-03-01 01:08:06.000000', 'consum', 0.0222, 'lps'),
	(437146, 125, '2015-03-01 01:08:07.000000', 'consum', 0.0214, 'lps'),
	(437147, 125, '2015-03-01 01:08:08.000000', 'consum', 0.0212, 'lps'),
	(437148, 125, '2015-03-01 01:08:09.000000', 'consum', 0.0223, 'lps'),
	(437149, 125, '2015-03-01 01:08:10.000000', 'consum', 0.0220, 'lps'),
	(437150, 125, '2015-03-01 01:08:11.000000', 'consum', 0.0220, 'lps'),
	(437151, 125, '2015-03-01 01:08:12.000000', 'consum', 0.0214, 'lps'),
	(437152, 125, '2015-03-01 01:08:13.000000', 'consum', 0.0218, 'lps'),
	(437153, 125, '2015-03-01 01:08:14.000000', 'consum', 0.0220, 'lps'),
	(437154, 125, '2015-03-01 01:08:15.000000', 'consum', 0.0222, 'lps'),
	(437155, 125, '2015-03-01 01:08:16.000000', 'consum', 0.0222, 'lps'),
	(437156, 125, '2015-03-01 01:08:17.000000', 'consum', 0.0217, 'lps'),
	(437157, 125, '2015-03-01 01:08:18.000000', 'consum', 0.0212, 'lps'),
	(437158, 125, '2015-03-01 01:08:19.000000', 'consum', 0.0213, 'lps'),
	(437159, 125, '2015-03-01 01:08:20.000000', 'consum', 0.0222, 'lps'),
	(437160, 125, '2015-03-01 01:08:21.000000', 'consum', 0.0211, 'lps'),
	(437161, 125, '2015-03-01 01:08:22.000000', 'consum', 0.0215, 'lps'),
	(437162, 125, '2015-03-01 01:08:23.000000', 'consum', 0.0213, 'lps'),
	(437163, 125, '2015-03-01 01:08:24.000000', 'consum', 0.0211, 'lps'),
	(437164, 125, '2015-03-01 01:08:25.000000', 'consum', 0.0225, 'lps'),
	(437165, 125, '2015-03-01 01:08:26.000000', 'consum', 0.0213, 'lps'),
	(437166, 125, '2015-03-01 01:08:27.000000', 'consum', 0.0214, 'lps'),
	(437167, 125, '2015-03-01 01:08:28.000000', 'consum', 0.0222, 'lps'),
	(437168, 125, '2015-03-01 01:08:29.000000', 'consum', 0.0226, 'lps'),
	(437169, 125, '2015-03-01 01:08:30.000000', 'consum', 0.0221, 'lps'),
	(437170, 125, '2015-03-01 01:08:31.000000', 'consum', 0.0216, 'lps'),
	(437171, 125, '2015-03-01 01:08:32.000000', 'consum', 0.0223, 'lps'),
	(437172, 125, '2015-03-01 01:08:33.000000', 'consum', 0.0226, 'lps'),
	(437173, 125, '2015-03-01 01:08:34.000000', 'consum', 0.0215, 'lps'),
	(437174, 125, '2015-03-01 01:08:35.000000', 'consum', 0.0224, 'lps'),
	(437175, 125, '2015-03-01 01:08:36.000000', 'consum', 0.0215, 'lps'),
	(437176, 125, '2015-03-01 01:08:37.000000', 'consum', 0.0210, 'lps'),
	(437177, 125, '2015-03-01 01:08:38.000000', 'consum', 0.0210, 'lps'),
	(437178, 125, '2015-03-01 01:08:39.000000', 'consum', 0.0213, 'lps'),
	(437179, 125, '2015-03-01 01:08:40.000000', 'consum', 0.0225, 'lps'),
	(437180, 125, '2015-03-01 01:08:41.000000', 'consum', 0.0225, 'lps'),
	(437181, 125, '2015-03-01 01:08:42.000000', 'consum', 0.0225, 'lps'),
	(437182, 125, '2015-03-01 01:08:43.000000', 'consum', 0.0224, 'lps'),
	(437183, 125, '2015-03-01 01:08:44.000000', 'consum', 0.0216, 'lps'),
	(437184, 125, '2015-03-01 01:08:45.000000', 'consum', 0.0217, 'lps'),
	(437185, 125, '2015-03-01 01:08:46.000000', 'consum', 0.0211, 'lps'),
	(437186, 125, '2015-03-01 01:08:47.000000', 'consum', 0.0212, 'lps'),
	(437187, 125, '2015-03-01 01:08:48.000000', 'consum', 0.0215, 'lps'),
	(437188, 125, '2015-03-01 01:08:49.000000', 'consum', 0.0215, 'lps'),
	(437189, 125, '2015-03-01 01:08:50.000000', 'consum', 0.0221, 'lps'),
	(437190, 125, '2015-03-01 01:08:51.000000', 'consum', 0.0217, 'lps'),
	(437191, 125, '2015-03-01 01:08:52.000000', 'consum', 0.0212, 'lps'),
	(437192, 125, '2015-03-01 01:08:53.000000', 'consum', 0.0216, 'lps'),
	(437193, 125, '2015-03-01 01:08:54.000000', 'consum', 0.0218, 'lps'),
	(437194, 125, '2015-03-01 01:08:55.000000', 'consum', 0.0214, 'lps'),
	(437195, 125, '2015-03-01 01:08:56.000000', 'consum', 0.0224, 'lps'),
	(437196, 125, '2015-03-01 01:08:57.000000', 'consum', 0.0219, 'lps'),
	(437197, 125, '2015-03-01 01:08:58.000000', 'consum', 0.0212, 'lps'),
	(437198, 125, '2015-03-01 01:08:59.000000', 'consum', 0.0210, 'lps'),
	(437199, 125, '2015-03-01 01:09:00.000000', 'consum', 0.0224, 'lps'),
	(437200, 125, '2015-03-01 01:09:01.000000', 'consum', 0.0210, 'lps'),
	(437201, 125, '2015-03-01 01:09:02.000000', 'consum', 0.0219, 'lps'),
	(437202, 125, '2015-03-01 01:09:03.000000', 'consum', 0.0223, 'lps'),
	(437203, 125, '2015-03-01 01:09:04.000000', 'consum', 0.0214, 'lps'),
	(437204, 125, '2015-03-01 01:09:05.000000', 'consum', 0.0224, 'lps'),
	(437205, 126, '2015-03-01 00:00:00.000000', 'consum', 0.0225, 'lps'),
	(437206, 126, '2015-03-01 00:00:01.000000', 'consum', 0.0227, 'lps'),
	(437207, 126, '2015-03-01 00:00:02.000000', 'consum', 0.0228, 'lps'),
	(437208, 126, '2015-03-01 00:00:03.000000', 'consum', 0.0210, 'lps'),
	(437209, 126, '2015-03-01 00:00:04.000000', 'consum', 0.0216, 'lps'),
	(437210, 126, '2015-03-01 00:00:05.000000', 'consum', 0.0223, 'lps'),
	(437211, 126, '2015-03-01 00:00:06.000000', 'consum', 0.0215, 'lps'),
	(437212, 126, '2015-03-01 00:00:07.000000', 'consum', 0.0215, 'lps'),
	(437213, 126, '2015-03-01 00:00:08.000000', 'consum', 0.0221, 'lps'),
	(437214, 126, '2015-03-01 00:00:09.000000', 'consum', 0.0230, 'lps'),
	(437215, 126, '2015-03-01 00:00:10.000000', 'consum', 0.0216, 'lps'),
	(437216, 126, '2015-03-01 00:00:11.000000', 'consum', 0.0223, 'lps'),
	(437217, 126, '2015-03-01 00:00:12.000000', 'consum', 0.0216, 'lps'),
	(437218, 126, '2015-03-01 00:00:13.000000', 'consum', 0.0221, 'lps'),
	(437219, 126, '2015-03-01 00:00:14.000000', 'consum', 0.0226, 'lps'),
	(437220, 126, '2015-03-01 00:00:15.000000', 'consum', 0.0218, 'lps'),
	(437221, 126, '2015-03-01 00:00:16.000000', 'consum', 0.0222, 'lps'),
	(437222, 126, '2015-03-01 00:00:17.000000', 'consum', 0.0226, 'lps'),
	(437223, 126, '2015-03-01 00:00:18.000000', 'consum', 0.0214, 'lps'),
	(437224, 126, '2015-03-01 00:00:19.000000', 'consum', 0.0225, 'lps'),
	(437225, 126, '2015-03-01 00:00:20.000000', 'consum', 0.0229, 'lps'),
	(437226, 126, '2015-03-01 00:00:21.000000', 'consum', 0.0221, 'lps'),
	(437227, 126, '2015-03-01 00:00:22.000000', 'consum', 0.0229, 'lps'),
	(437228, 126, '2015-03-01 00:00:23.000000', 'consum', 0.0211, 'lps'),
	(437229, 126, '2015-03-01 00:00:24.000000', 'consum', 0.0219, 'lps'),
	(437230, 126, '2015-03-01 00:00:25.000000', 'consum', 0.0210, 'lps'),
	(437231, 126, '2015-03-01 00:00:26.000000', 'consum', 0.0228, 'lps'),
	(437232, 126, '2015-03-01 00:00:27.000000', 'consum', 0.0218, 'lps'),
	(437233, 126, '2015-03-01 00:00:28.000000', 'consum', 0.0214, 'lps'),
	(437234, 126, '2015-03-01 00:00:29.000000', 'consum', 0.0227, 'lps'),
	(437235, 126, '2015-03-01 00:00:30.000000', 'consum', 0.0223, 'lps'),
	(437236, 126, '2015-03-01 00:00:31.000000', 'consum', 0.0222, 'lps'),
	(437237, 126, '2015-03-01 00:00:32.000000', 'consum', 0.0211, 'lps'),
	(437238, 126, '2015-03-01 00:00:33.000000', 'consum', 0.0223, 'lps'),
	(437239, 126, '2015-03-01 00:00:34.000000', 'consum', 0.0211, 'lps'),
	(437240, 126, '2015-03-01 00:00:35.000000', 'consum', 0.0215, 'lps'),
	(437241, 126, '2015-03-01 00:00:36.000000', 'consum', 0.0212, 'lps'),
	(437242, 126, '2015-03-01 00:00:37.000000', 'consum', 0.0228, 'lps'),
	(437243, 126, '2015-03-01 00:00:38.000000', 'consum', 0.0229, 'lps'),
	(437244, 126, '2015-03-01 00:00:39.000000', 'consum', 0.0211, 'lps'),
	(437245, 126, '2015-03-01 00:00:40.000000', 'consum', 0.0220, 'lps'),
	(437246, 126, '2015-03-01 00:00:41.000000', 'consum', 0.0217, 'lps'),
	(437247, 126, '2015-03-01 00:00:42.000000', 'consum', 0.0216, 'lps'),
	(437248, 126, '2015-03-01 00:00:43.000000', 'consum', 0.0218, 'lps'),
	(437249, 126, '2015-03-01 00:00:44.000000', 'consum', 0.0213, 'lps'),
	(437250, 126, '2015-03-01 00:00:45.000000', 'consum', 0.0222, 'lps'),
	(437251, 126, '2015-03-01 00:00:46.000000', 'consum', 0.0219, 'lps'),
	(437252, 126, '2015-03-01 00:00:47.000000', 'consum', 0.0221, 'lps'),
	(437253, 126, '2015-03-01 00:00:48.000000', 'consum', 0.0219, 'lps'),
	(437254, 126, '2015-03-01 00:00:49.000000', 'consum', 0.0220, 'lps'),
	(437255, 126, '2015-03-01 00:00:50.000000', 'consum', 0.0211, 'lps'),
	(437256, 126, '2015-03-01 00:00:51.000000', 'consum', 0.0230, 'lps'),
	(437257, 126, '2015-03-01 00:00:52.000000', 'consum', 0.0225, 'lps'),
	(437258, 126, '2015-03-01 00:00:53.000000', 'consum', 0.0223, 'lps'),
	(437259, 126, '2015-03-01 00:00:54.000000', 'consum', 0.0230, 'lps'),
	(437260, 126, '2015-03-01 00:00:55.000000', 'consum', 0.0230, 'lps'),
	(437261, 126, '2015-03-01 00:00:56.000000', 'consum', 0.0230, 'lps'),
	(437262, 126, '2015-03-01 00:00:57.000000', 'consum', 0.0210, 'lps'),
	(437263, 126, '2015-03-01 00:00:58.000000', 'consum', 0.0211, 'lps'),
	(437264, 126, '2015-03-01 00:00:59.000000', 'consum', 0.0217, 'lps'),
	(437265, 126, '2015-03-01 00:01:00.000000', 'consum', 0.0219, 'lps'),
	(437266, 126, '2015-03-01 00:01:01.000000', 'consum', 0.0216, 'lps'),
	(437267, 126, '2015-03-01 00:01:02.000000', 'consum', 0.0214, 'lps'),
	(437268, 126, '2015-03-01 00:01:03.000000', 'consum', 0.0211, 'lps'),
	(437269, 126, '2015-03-01 00:01:04.000000', 'consum', 0.0223, 'lps'),
	(437270, 126, '2015-03-01 00:01:05.000000', 'consum', 0.0210, 'lps'),
	(437271, 126, '2015-03-01 00:01:06.000000', 'consum', 0.0216, 'lps'),
	(437272, 126, '2015-03-01 00:01:07.000000', 'consum', 0.0219, 'lps'),
	(437273, 126, '2015-03-01 00:01:08.000000', 'consum', 0.0217, 'lps'),
	(437274, 126, '2015-03-01 00:01:09.000000', 'consum', 0.0217, 'lps'),
	(437275, 126, '2015-03-01 00:01:10.000000', 'consum', 0.0225, 'lps'),
	(437276, 126, '2015-03-01 00:01:11.000000', 'consum', 0.0223, 'lps'),
	(437277, 126, '2015-03-01 00:01:12.000000', 'consum', 0.0229, 'lps'),
	(437278, 126, '2015-03-01 00:01:13.000000', 'consum', 0.0226, 'lps'),
	(437279, 126, '2015-03-01 00:01:14.000000', 'consum', 0.0212, 'lps'),
	(437280, 126, '2015-03-01 00:01:15.000000', 'consum', 0.0216, 'lps'),
	(437281, 126, '2015-03-01 00:01:16.000000', 'consum', 0.0213, 'lps'),
	(437282, 126, '2015-03-01 00:01:17.000000', 'consum', 0.0227, 'lps'),
	(437283, 126, '2015-03-01 00:01:18.000000', 'consum', 0.0226, 'lps'),
	(437284, 126, '2015-03-01 00:01:19.000000', 'consum', 0.0218, 'lps'),
	(437285, 126, '2015-03-01 00:01:20.000000', 'consum', 0.0224, 'lps'),
	(437286, 126, '2015-03-01 00:01:21.000000', 'consum', 0.0214, 'lps'),
	(437287, 126, '2015-03-01 00:01:22.000000', 'consum', 0.0211, 'lps'),
	(437288, 126, '2015-03-01 00:01:23.000000', 'consum', 0.0225, 'lps'),
	(437289, 126, '2015-03-01 00:01:24.000000', 'consum', 0.0219, 'lps'),
	(437290, 126, '2015-03-01 00:01:25.000000', 'consum', 0.0230, 'lps'),
	(437291, 126, '2015-03-01 00:01:26.000000', 'consum', 0.0220, 'lps'),
	(437292, 126, '2015-03-01 00:01:27.000000', 'consum', 0.0223, 'lps'),
	(437293, 126, '2015-03-01 00:01:28.000000', 'consum', 0.0226, 'lps'),
	(437294, 126, '2015-03-01 00:01:29.000000', 'consum', 0.0230, 'lps'),
	(437295, 126, '2015-03-01 00:01:30.000000', 'consum', 0.0218, 'lps'),
	(437296, 126, '2015-03-01 00:01:31.000000', 'consum', 0.0214, 'lps'),
	(437297, 126, '2015-03-01 00:01:32.000000', 'consum', 0.0229, 'lps'),
	(437298, 126, '2015-03-01 00:01:33.000000', 'consum', 0.0228, 'lps'),
	(437299, 126, '2015-03-01 00:01:34.000000', 'consum', 0.0221, 'lps'),
	(437300, 126, '2015-03-01 00:01:35.000000', 'consum', 0.0214, 'lps'),
	(437301, 126, '2015-03-01 00:01:36.000000', 'consum', 0.0216, 'lps'),
	(437302, 126, '2015-03-01 00:01:37.000000', 'consum', 0.0229, 'lps'),
	(437303, 126, '2015-03-01 00:01:38.000000', 'consum', 0.0225, 'lps'),
	(437304, 126, '2015-03-01 00:01:39.000000', 'consum', 0.0229, 'lps'),
	(437305, 126, '2015-03-01 00:01:40.000000', 'consum', 0.0220, 'lps'),
	(437306, 126, '2015-03-01 00:01:41.000000', 'consum', 0.0224, 'lps'),
	(437307, 126, '2015-03-01 00:01:42.000000', 'consum', 0.0230, 'lps'),
	(437308, 126, '2015-03-01 00:01:43.000000', 'consum', 0.0228, 'lps'),
	(437309, 126, '2015-03-01 00:01:44.000000', 'consum', 0.0217, 'lps'),
	(437310, 126, '2015-03-01 00:01:45.000000', 'consum', 0.0215, 'lps'),
	(437311, 126, '2015-03-01 00:01:46.000000', 'consum', 0.0213, 'lps'),
	(437312, 126, '2015-03-01 00:01:47.000000', 'consum', 0.0230, 'lps'),
	(437313, 126, '2015-03-01 00:01:48.000000', 'consum', 0.0219, 'lps'),
	(437314, 126, '2015-03-01 00:01:49.000000', 'consum', 0.0216, 'lps'),
	(437315, 126, '2015-03-01 00:01:50.000000', 'consum', 0.0215, 'lps'),
	(437316, 126, '2015-03-01 00:01:51.000000', 'consum', 0.0215, 'lps'),
	(437317, 126, '2015-03-01 00:01:52.000000', 'consum', 0.0221, 'lps'),
	(437318, 126, '2015-03-01 00:01:53.000000', 'consum', 0.0228, 'lps'),
	(437319, 126, '2015-03-01 00:01:54.000000', 'consum', 0.0226, 'lps'),
	(437320, 126, '2015-03-01 00:01:55.000000', 'consum', 0.0218, 'lps'),
	(437321, 126, '2015-03-01 00:01:56.000000', 'consum', 0.0222, 'lps'),
	(437322, 126, '2015-03-01 00:01:57.000000', 'consum', 0.0226, 'lps'),
	(437323, 126, '2015-03-01 00:01:58.000000', 'consum', 0.0211, 'lps'),
	(437324, 126, '2015-03-01 00:01:59.000000', 'consum', 0.0230, 'lps'),
	(437325, 126, '2015-03-01 00:02:00.000000', 'consum', 0.0223, 'lps'),
	(437326, 126, '2015-03-01 00:02:01.000000', 'consum', 0.0217, 'lps'),
	(437327, 126, '2015-03-01 00:02:02.000000', 'consum', 0.0227, 'lps'),
	(437328, 126, '2015-03-01 00:02:03.000000', 'consum', 0.0210, 'lps'),
	(437329, 126, '2015-03-01 00:02:04.000000', 'consum', 0.0224, 'lps'),
	(437330, 126, '2015-03-01 00:02:05.000000', 'consum', 0.0217, 'lps'),
	(437331, 126, '2015-03-01 00:02:06.000000', 'consum', 0.0224, 'lps'),
	(437332, 126, '2015-03-01 00:02:07.000000', 'consum', 0.0218, 'lps'),
	(437333, 126, '2015-03-01 00:02:08.000000', 'consum', 0.0228, 'lps'),
	(437334, 126, '2015-03-01 00:02:09.000000', 'consum', 0.0216, 'lps'),
	(437335, 126, '2015-03-01 00:02:10.000000', 'consum', 0.0227, 'lps'),
	(437336, 126, '2015-03-01 00:02:11.000000', 'consum', 0.0216, 'lps'),
	(437337, 126, '2015-03-01 00:02:12.000000', 'consum', 0.0211, 'lps'),
	(437338, 126, '2015-03-01 00:02:13.000000', 'consum', 0.0220, 'lps'),
	(437339, 126, '2015-03-01 00:02:14.000000', 'consum', 0.0212, 'lps'),
	(437340, 126, '2015-03-01 00:02:15.000000', 'consum', 0.0215, 'lps'),
	(437341, 126, '2015-03-01 00:02:16.000000', 'consum', 0.0227, 'lps'),
	(437342, 126, '2015-03-01 00:02:17.000000', 'consum', 0.0218, 'lps'),
	(437343, 126, '2015-03-01 00:02:18.000000', 'consum', 0.0222, 'lps'),
	(437344, 126, '2015-03-01 00:02:19.000000', 'consum', 0.0226, 'lps'),
	(437345, 126, '2015-03-01 00:02:20.000000', 'consum', 0.0212, 'lps'),
	(437346, 126, '2015-03-01 00:02:21.000000', 'consum', 0.0216, 'lps'),
	(437347, 126, '2015-03-01 00:02:22.000000', 'consum', 0.0212, 'lps'),
	(437348, 126, '2015-03-01 00:02:23.000000', 'consum', 0.0223, 'lps'),
	(437349, 126, '2015-03-01 00:02:24.000000', 'consum', 0.0229, 'lps'),
	(437350, 126, '2015-03-01 00:02:25.000000', 'consum', 0.0222, 'lps'),
	(437351, 126, '2015-03-01 00:02:26.000000', 'consum', 0.0215, 'lps'),
	(437352, 126, '2015-03-01 00:02:27.000000', 'consum', 0.0221, 'lps'),
	(437353, 126, '2015-03-01 00:02:28.000000', 'consum', 0.0229, 'lps'),
	(437354, 126, '2015-03-01 00:02:29.000000', 'consum', 0.0210, 'lps'),
	(437355, 126, '2015-03-01 00:02:30.000000', 'consum', 0.0218, 'lps'),
	(437356, 126, '2015-03-01 00:02:31.000000', 'consum', 0.0228, 'lps'),
	(437357, 126, '2015-03-01 00:02:32.000000', 'consum', 0.0214, 'lps'),
	(437358, 126, '2015-03-01 00:02:33.000000', 'consum', 0.0217, 'lps'),
	(437359, 126, '2015-03-01 00:02:34.000000', 'consum', 0.0215, 'lps'),
	(437360, 126, '2015-03-01 00:02:35.000000', 'consum', 0.0214, 'lps'),
	(437361, 126, '2015-03-01 00:02:36.000000', 'consum', 0.0217, 'lps'),
	(437362, 126, '2015-03-01 00:02:37.000000', 'consum', 0.0212, 'lps'),
	(437363, 126, '2015-03-01 00:02:38.000000', 'consum', 0.0218, 'lps'),
	(437364, 126, '2015-03-01 00:02:39.000000', 'consum', 0.0225, 'lps'),
	(437365, 126, '2015-03-01 00:02:40.000000', 'consum', 0.0219, 'lps'),
	(437366, 126, '2015-03-01 00:02:41.000000', 'consum', 0.0213, 'lps'),
	(437367, 126, '2015-03-01 00:02:42.000000', 'consum', 0.0217, 'lps'),
	(437368, 126, '2015-03-01 00:02:43.000000', 'consum', 0.0217, 'lps'),
	(437369, 126, '2015-03-01 00:02:44.000000', 'consum', 0.0224, 'lps'),
	(437370, 126, '2015-03-01 00:02:45.000000', 'consum', 0.0218, 'lps'),
	(437371, 126, '2015-03-01 00:02:46.000000', 'consum', 0.0230, 'lps'),
	(437372, 126, '2015-03-01 00:02:47.000000', 'consum', 0.0224, 'lps'),
	(437373, 126, '2015-03-01 00:02:48.000000', 'consum', 0.0220, 'lps'),
	(437374, 126, '2015-03-01 00:02:49.000000', 'consum', 0.0218, 'lps'),
	(437375, 126, '2015-03-01 00:02:50.000000', 'consum', 0.0222, 'lps'),
	(437376, 126, '2015-03-01 00:02:51.000000', 'consum', 0.0223, 'lps'),
	(437377, 126, '2015-03-01 00:02:52.000000', 'consum', 0.0220, 'lps'),
	(437378, 126, '2015-03-01 00:02:53.000000', 'consum', 0.0221, 'lps'),
	(437379, 126, '2015-03-01 00:02:54.000000', 'consum', 0.0216, 'lps'),
	(437380, 126, '2015-03-01 00:02:55.000000', 'consum', 0.0225, 'lps'),
	(437381, 126, '2015-03-01 00:02:56.000000', 'consum', 0.0229, 'lps'),
	(437382, 126, '2015-03-01 00:02:57.000000', 'consum', 0.0219, 'lps'),
	(437383, 126, '2015-03-01 00:02:58.000000', 'consum', 0.0217, 'lps'),
	(437384, 126, '2015-03-01 00:02:59.000000', 'consum', 0.0218, 'lps'),
	(437385, 126, '2015-03-01 00:03:00.000000', 'consum', 0.0229, 'lps'),
	(437386, 126, '2015-03-01 00:03:01.000000', 'consum', 0.0220, 'lps'),
	(437387, 126, '2015-03-01 00:03:02.000000', 'consum', 0.0224, 'lps'),
	(437388, 126, '2015-03-01 00:03:03.000000', 'consum', 0.0210, 'lps'),
	(437389, 126, '2015-03-01 00:03:04.000000', 'consum', 0.0211, 'lps'),
	(437390, 126, '2015-03-01 00:03:05.000000', 'consum', 0.0214, 'lps'),
	(437391, 126, '2015-03-01 00:03:06.000000', 'consum', 0.0226, 'lps'),
	(437392, 126, '2015-03-01 00:03:07.000000', 'consum', 0.0217, 'lps'),
	(437393, 126, '2015-03-01 00:03:08.000000', 'consum', 0.0218, 'lps'),
	(437394, 126, '2015-03-01 00:03:09.000000', 'consum', 0.0210, 'lps'),
	(437395, 126, '2015-03-01 00:03:10.000000', 'consum', 0.0227, 'lps'),
	(437396, 126, '2015-03-01 00:03:11.000000', 'consum', 0.0210, 'lps'),
	(437397, 126, '2015-03-01 00:03:12.000000', 'consum', 0.0224, 'lps'),
	(437398, 126, '2015-03-01 00:03:13.000000', 'consum', 0.0219, 'lps'),
	(437399, 126, '2015-03-01 00:03:14.000000', 'consum', 0.0214, 'lps'),
	(437400, 126, '2015-03-01 00:03:15.000000', 'consum', 0.0222, 'lps'),
	(437401, 126, '2015-03-01 00:03:16.000000', 'consum', 0.0219, 'lps'),
	(437402, 126, '2015-03-01 00:03:17.000000', 'consum', 0.0216, 'lps'),
	(437403, 126, '2015-03-01 00:03:18.000000', 'consum', 0.0217, 'lps'),
	(437404, 126, '2015-03-01 00:03:19.000000', 'consum', 0.0228, 'lps'),
	(437405, 126, '2015-03-01 00:03:20.000000', 'consum', 0.0214, 'lps'),
	(437406, 126, '2015-03-01 00:03:21.000000', 'consum', 0.0218, 'lps'),
	(437407, 126, '2015-03-01 00:03:22.000000', 'consum', 0.0219, 'lps'),
	(437408, 126, '2015-03-01 00:03:23.000000', 'consum', 0.0230, 'lps'),
	(437409, 126, '2015-03-01 00:03:24.000000', 'consum', 0.0221, 'lps'),
	(437410, 126, '2015-03-01 00:03:25.000000', 'consum', 0.0228, 'lps'),
	(437411, 126, '2015-03-01 00:03:26.000000', 'consum', 0.0225, 'lps'),
	(437412, 126, '2015-03-01 00:03:27.000000', 'consum', 0.0230, 'lps'),
	(437413, 126, '2015-03-01 00:03:28.000000', 'consum', 0.0222, 'lps'),
	(437414, 126, '2015-03-01 00:03:29.000000', 'consum', 0.0214, 'lps'),
	(437415, 126, '2015-03-01 00:03:30.000000', 'consum', 0.0212, 'lps'),
	(437416, 126, '2015-03-01 00:03:31.000000', 'consum', 0.0212, 'lps'),
	(437417, 126, '2015-03-01 00:03:32.000000', 'consum', 0.0212, 'lps'),
	(437418, 126, '2015-03-01 00:03:33.000000', 'consum', 0.0216, 'lps'),
	(437419, 126, '2015-03-01 00:03:34.000000', 'consum', 0.0212, 'lps'),
	(437420, 126, '2015-03-01 00:03:35.000000', 'consum', 0.0225, 'lps'),
	(437421, 126, '2015-03-01 00:03:36.000000', 'consum', 0.0214, 'lps'),
	(437422, 126, '2015-03-01 00:03:37.000000', 'consum', 0.0210, 'lps'),
	(437423, 126, '2015-03-01 00:03:38.000000', 'consum', 0.0217, 'lps'),
	(437424, 126, '2015-03-01 00:03:39.000000', 'consum', 0.0223, 'lps'),
	(437425, 126, '2015-03-01 00:03:40.000000', 'consum', 0.0216, 'lps'),
	(437426, 126, '2015-03-01 00:03:41.000000', 'consum', 0.0221, 'lps'),
	(437427, 126, '2015-03-01 00:03:42.000000', 'consum', 0.0229, 'lps'),
	(437428, 126, '2015-03-01 00:03:43.000000', 'consum', 0.0228, 'lps'),
	(437429, 126, '2015-03-01 00:03:44.000000', 'consum', 0.0221, 'lps'),
	(437430, 126, '2015-03-01 00:03:45.000000', 'consum', 0.0213, 'lps'),
	(437431, 126, '2015-03-01 00:03:46.000000', 'consum', 0.0215, 'lps'),
	(437432, 126, '2015-03-01 00:03:47.000000', 'consum', 0.0225, 'lps'),
	(437433, 126, '2015-03-01 00:03:48.000000', 'consum', 0.0210, 'lps'),
	(437434, 126, '2015-03-01 00:03:49.000000', 'consum', 0.0226, 'lps'),
	(437435, 126, '2015-03-01 00:03:50.000000', 'consum', 0.0230, 'lps'),
	(437436, 126, '2015-03-01 00:03:51.000000', 'consum', 0.0217, 'lps'),
	(437437, 126, '2015-03-01 00:03:52.000000', 'consum', 0.0210, 'lps'),
	(437438, 126, '2015-03-01 00:03:53.000000', 'consum', 0.0210, 'lps'),
	(437439, 126, '2015-03-01 00:03:54.000000', 'consum', 0.0229, 'lps'),
	(437440, 126, '2015-03-01 00:03:55.000000', 'consum', 0.0224, 'lps'),
	(437441, 126, '2015-03-01 00:03:56.000000', 'consum', 0.0223, 'lps'),
	(437442, 126, '2015-03-01 00:03:57.000000', 'consum', 0.0214, 'lps'),
	(437443, 126, '2015-03-01 00:03:58.000000', 'consum', 0.0210, 'lps'),
	(437444, 126, '2015-03-01 00:03:59.000000', 'consum', 0.0221, 'lps'),
	(437445, 126, '2015-03-01 00:04:00.000000', 'consum', 0.0221, 'lps'),
	(437446, 126, '2015-03-01 00:04:01.000000', 'consum', 0.0215, 'lps'),
	(437447, 126, '2015-03-01 00:04:02.000000', 'consum', 0.0222, 'lps'),
	(437448, 126, '2015-03-01 00:04:03.000000', 'consum', 0.0214, 'lps'),
	(437449, 126, '2015-03-01 00:04:04.000000', 'consum', 0.0217, 'lps'),
	(437450, 126, '2015-03-01 00:04:05.000000', 'consum', 0.0210, 'lps'),
	(437451, 126, '2015-03-01 00:04:06.000000', 'consum', 0.0213, 'lps'),
	(437452, 126, '2015-03-01 00:04:07.000000', 'consum', 0.0223, 'lps'),
	(437453, 126, '2015-03-01 00:04:08.000000', 'consum', 0.0224, 'lps'),
	(437454, 126, '2015-03-01 00:04:09.000000', 'consum', 0.0222, 'lps'),
	(437455, 126, '2015-03-01 00:04:10.000000', 'consum', 0.0228, 'lps'),
	(437456, 126, '2015-03-01 00:04:11.000000', 'consum', 0.0221, 'lps'),
	(437457, 126, '2015-03-01 00:04:12.000000', 'consum', 0.0211, 'lps'),
	(437458, 126, '2015-03-01 00:04:13.000000', 'consum', 0.0227, 'lps'),
	(437459, 126, '2015-03-01 00:04:14.000000', 'consum', 0.0230, 'lps'),
	(437460, 126, '2015-03-01 00:04:15.000000', 'consum', 0.0216, 'lps'),
	(437461, 126, '2015-03-01 00:04:16.000000', 'consum', 0.0221, 'lps'),
	(437462, 126, '2015-03-01 00:04:17.000000', 'consum', 0.0229, 'lps'),
	(437463, 126, '2015-03-01 00:04:18.000000', 'consum', 0.0230, 'lps'),
	(437464, 126, '2015-03-01 00:04:19.000000', 'consum', 0.0211, 'lps'),
	(437465, 126, '2015-03-01 00:04:20.000000', 'consum', 0.0217, 'lps'),
	(437466, 126, '2015-03-01 00:04:21.000000', 'consum', 0.0223, 'lps'),
	(437467, 126, '2015-03-01 00:04:22.000000', 'consum', 0.0213, 'lps'),
	(437468, 126, '2015-03-01 00:04:23.000000', 'consum', 0.0229, 'lps'),
	(437469, 126, '2015-03-01 00:04:24.000000', 'consum', 0.0212, 'lps'),
	(437470, 126, '2015-03-01 00:04:25.000000', 'consum', 0.0226, 'lps'),
	(437471, 126, '2015-03-01 00:04:26.000000', 'consum', 0.0222, 'lps'),
	(437472, 126, '2015-03-01 00:04:27.000000', 'consum', 0.0222, 'lps'),
	(437473, 126, '2015-03-01 00:04:28.000000', 'consum', 0.0214, 'lps'),
	(437474, 126, '2015-03-01 00:04:29.000000', 'consum', 0.0215, 'lps'),
	(437475, 126, '2015-03-01 00:04:30.000000', 'consum', 0.0225, 'lps'),
	(437476, 126, '2015-03-01 00:04:31.000000', 'consum', 0.0227, 'lps'),
	(437477, 126, '2015-03-01 00:04:32.000000', 'consum', 0.0229, 'lps'),
	(437478, 126, '2015-03-01 00:04:33.000000', 'consum', 0.0215, 'lps'),
	(437479, 126, '2015-03-01 00:04:34.000000', 'consum', 0.0218, 'lps'),
	(437480, 126, '2015-03-01 00:04:35.000000', 'consum', 0.0214, 'lps'),
	(437481, 126, '2015-03-01 00:04:36.000000', 'consum', 0.0227, 'lps'),
	(437482, 126, '2015-03-01 00:04:37.000000', 'consum', 0.0221, 'lps'),
	(437483, 126, '2015-03-01 00:04:38.000000', 'consum', 0.0216, 'lps'),
	(437484, 126, '2015-03-01 00:04:39.000000', 'consum', 0.0227, 'lps'),
	(437485, 126, '2015-03-01 00:04:40.000000', 'consum', 0.0216, 'lps'),
	(437486, 126, '2015-03-01 00:04:41.000000', 'consum', 0.0229, 'lps'),
	(437487, 126, '2015-03-01 00:04:42.000000', 'consum', 0.0228, 'lps'),
	(437488, 126, '2015-03-01 00:04:43.000000', 'consum', 0.0220, 'lps'),
	(437489, 126, '2015-03-01 00:04:44.000000', 'consum', 0.0228, 'lps'),
	(437490, 126, '2015-03-01 00:04:45.000000', 'consum', 0.0227, 'lps'),
	(437491, 126, '2015-03-01 00:04:46.000000', 'consum', 0.0223, 'lps'),
	(437492, 126, '2015-03-01 00:04:47.000000', 'consum', 0.0224, 'lps'),
	(437493, 126, '2015-03-01 00:04:48.000000', 'consum', 0.0220, 'lps'),
	(437494, 126, '2015-03-01 00:04:49.000000', 'consum', 0.0217, 'lps'),
	(437495, 126, '2015-03-01 00:04:50.000000', 'consum', 0.0217, 'lps'),
	(437496, 126, '2015-03-01 00:04:51.000000', 'consum', 0.0222, 'lps'),
	(437497, 126, '2015-03-01 00:04:52.000000', 'consum', 0.0210, 'lps'),
	(437498, 126, '2015-03-01 00:04:53.000000', 'consum', 0.0215, 'lps'),
	(437499, 126, '2015-03-01 00:04:54.000000', 'consum', 0.0216, 'lps'),
	(437500, 126, '2015-03-01 00:04:55.000000', 'consum', 0.0226, 'lps'),
	(437501, 126, '2015-03-01 00:04:56.000000', 'consum', 0.0229, 'lps'),
	(437502, 126, '2015-03-01 00:04:57.000000', 'consum', 0.0216, 'lps'),
	(437503, 126, '2015-03-01 00:04:58.000000', 'consum', 0.0227, 'lps'),
	(437504, 126, '2015-03-01 00:04:59.000000', 'consum', 0.0213, 'lps'),
	(437505, 126, '2015-03-01 00:05:00.000000', 'consum', 0.0215, 'lps'),
	(437506, 126, '2015-03-01 00:05:01.000000', 'consum', 0.0228, 'lps'),
	(437507, 126, '2015-03-01 00:05:02.000000', 'consum', 0.0222, 'lps'),
	(437508, 126, '2015-03-01 00:05:03.000000', 'consum', 0.0216, 'lps'),
	(437509, 126, '2015-03-01 00:05:04.000000', 'consum', 0.0226, 'lps'),
	(437510, 126, '2015-03-01 00:05:05.000000', 'consum', 0.0230, 'lps'),
	(437511, 126, '2015-03-01 00:05:06.000000', 'consum', 0.0220, 'lps'),
	(437512, 126, '2015-03-01 00:05:07.000000', 'consum', 0.0224, 'lps'),
	(437513, 126, '2015-03-01 00:05:08.000000', 'consum', 0.0229, 'lps'),
	(437514, 126, '2015-03-01 00:05:09.000000', 'consum', 0.0222, 'lps'),
	(437515, 126, '2015-03-01 00:05:10.000000', 'consum', 0.0211, 'lps'),
	(437516, 126, '2015-03-01 00:05:11.000000', 'consum', 0.0222, 'lps'),
	(437517, 126, '2015-03-01 00:05:12.000000', 'consum', 0.0228, 'lps'),
	(437518, 126, '2015-03-01 00:05:13.000000', 'consum', 0.0221, 'lps'),
	(437519, 126, '2015-03-01 00:05:14.000000', 'consum', 0.0211, 'lps'),
	(437520, 126, '2015-03-01 00:05:15.000000', 'consum', 0.0224, 'lps'),
	(437521, 126, '2015-03-01 00:05:16.000000', 'consum', 0.0213, 'lps'),
	(437522, 126, '2015-03-01 00:05:17.000000', 'consum', 0.0229, 'lps'),
	(437523, 126, '2015-03-01 00:05:18.000000', 'consum', 0.0211, 'lps'),
	(437524, 126, '2015-03-01 00:05:19.000000', 'consum', 0.0220, 'lps'),
	(437525, 126, '2015-03-01 00:05:20.000000', 'consum', 0.0218, 'lps'),
	(437526, 126, '2015-03-01 00:05:21.000000', 'consum', 0.0221, 'lps'),
	(437527, 126, '2015-03-01 00:05:22.000000', 'consum', 0.0219, 'lps'),
	(437528, 126, '2015-03-01 00:05:23.000000', 'consum', 0.0223, 'lps'),
	(437529, 126, '2015-03-01 00:05:24.000000', 'consum', 0.0228, 'lps'),
	(437530, 126, '2015-03-01 00:05:25.000000', 'consum', 0.0218, 'lps'),
	(437531, 126, '2015-03-01 00:05:26.000000', 'consum', 0.0218, 'lps'),
	(437532, 126, '2015-03-01 00:05:27.000000', 'consum', 0.0228, 'lps'),
	(437533, 126, '2015-03-01 00:05:28.000000', 'consum', 0.0214, 'lps'),
	(437534, 126, '2015-03-01 00:05:29.000000', 'consum', 0.0216, 'lps'),
	(437535, 126, '2015-03-01 00:05:30.000000', 'consum', 0.0228, 'lps'),
	(437536, 126, '2015-03-01 00:05:31.000000', 'consum', 0.0221, 'lps'),
	(437537, 126, '2015-03-01 00:05:32.000000', 'consum', 0.0213, 'lps'),
	(437538, 126, '2015-03-01 00:05:33.000000', 'consum', 0.0212, 'lps'),
	(437539, 126, '2015-03-01 00:05:34.000000', 'consum', 0.0210, 'lps'),
	(437540, 126, '2015-03-01 00:05:35.000000', 'consum', 0.0228, 'lps'),
	(437541, 126, '2015-03-01 00:05:36.000000', 'consum', 0.0214, 'lps'),
	(437542, 126, '2015-03-01 00:05:37.000000', 'consum', 0.0221, 'lps'),
	(437543, 126, '2015-03-01 00:05:38.000000', 'consum', 0.0212, 'lps'),
	(437544, 126, '2015-03-01 00:05:39.000000', 'consum', 0.0210, 'lps'),
	(437545, 126, '2015-03-01 00:05:40.000000', 'consum', 0.0222, 'lps'),
	(437546, 126, '2015-03-01 00:05:41.000000', 'consum', 0.0229, 'lps'),
	(437547, 126, '2015-03-01 00:05:42.000000', 'consum', 0.0229, 'lps'),
	(437548, 126, '2015-03-01 00:05:43.000000', 'consum', 0.0226, 'lps'),
	(437549, 126, '2015-03-01 00:05:44.000000', 'consum', 0.0212, 'lps'),
	(437550, 126, '2015-03-01 00:05:45.000000', 'consum', 0.0214, 'lps'),
	(437551, 126, '2015-03-01 00:05:46.000000', 'consum', 0.0227, 'lps'),
	(437552, 126, '2015-03-01 00:05:47.000000', 'consum', 0.0219, 'lps'),
	(437553, 126, '2015-03-01 00:05:48.000000', 'consum', 0.0225, 'lps'),
	(437554, 126, '2015-03-01 00:05:49.000000', 'consum', 0.0218, 'lps'),
	(437555, 126, '2015-03-01 00:05:50.000000', 'consum', 0.0227, 'lps'),
	(437556, 126, '2015-03-01 00:05:51.000000', 'consum', 0.0229, 'lps'),
	(437557, 126, '2015-03-01 00:05:52.000000', 'consum', 0.0212, 'lps'),
	(437558, 126, '2015-03-01 00:05:53.000000', 'consum', 0.0229, 'lps'),
	(437559, 126, '2015-03-01 00:05:54.000000', 'consum', 0.0213, 'lps'),
	(437560, 126, '2015-03-01 00:05:55.000000', 'consum', 0.0210, 'lps'),
	(437561, 126, '2015-03-01 00:05:56.000000', 'consum', 0.0223, 'lps'),
	(437562, 126, '2015-03-01 00:05:57.000000', 'consum', 0.0213, 'lps'),
	(437563, 126, '2015-03-01 00:05:58.000000', 'consum', 0.0229, 'lps'),
	(437564, 126, '2015-03-01 00:05:59.000000', 'consum', 0.0210, 'lps'),
	(437565, 126, '2015-03-01 00:06:00.000000', 'consum', 0.0217, 'lps'),
	(437566, 126, '2015-03-01 00:06:01.000000', 'consum', 0.0227, 'lps'),
	(437567, 126, '2015-03-01 00:06:02.000000', 'consum', 0.0210, 'lps'),
	(437568, 126, '2015-03-01 00:06:03.000000', 'consum', 0.0225, 'lps'),
	(437569, 126, '2015-03-01 00:06:04.000000', 'consum', 0.0219, 'lps'),
	(437570, 126, '2015-03-01 00:06:05.000000', 'consum', 0.0213, 'lps'),
	(437571, 126, '2015-03-01 00:06:06.000000', 'consum', 0.0221, 'lps'),
	(437572, 126, '2015-03-01 00:06:07.000000', 'consum', 0.0211, 'lps'),
	(437573, 126, '2015-03-01 00:06:08.000000', 'consum', 0.0228, 'lps'),
	(437574, 126, '2015-03-01 00:06:09.000000', 'consum', 0.0210, 'lps'),
	(437575, 126, '2015-03-01 00:06:10.000000', 'consum', 0.0222, 'lps'),
	(437576, 126, '2015-03-01 00:06:11.000000', 'consum', 0.0228, 'lps'),
	(437577, 126, '2015-03-01 00:06:12.000000', 'consum', 0.0222, 'lps'),
	(437578, 126, '2015-03-01 00:06:13.000000', 'consum', 0.0215, 'lps'),
	(437579, 126, '2015-03-01 00:06:14.000000', 'consum', 0.0221, 'lps'),
	(437580, 126, '2015-03-01 00:06:15.000000', 'consum', 0.0230, 'lps'),
	(437581, 126, '2015-03-01 00:06:16.000000', 'consum', 0.0212, 'lps'),
	(437582, 126, '2015-03-01 00:06:17.000000', 'consum', 0.0227, 'lps'),
	(437583, 126, '2015-03-01 00:06:18.000000', 'consum', 0.0225, 'lps'),
	(437584, 126, '2015-03-01 00:06:19.000000', 'consum', 0.0212, 'lps'),
	(437585, 126, '2015-03-01 00:06:20.000000', 'consum', 0.0220, 'lps'),
	(437586, 126, '2015-03-01 00:06:21.000000', 'consum', 0.0211, 'lps'),
	(437587, 126, '2015-03-01 00:06:22.000000', 'consum', 0.0226, 'lps'),
	(437588, 126, '2015-03-01 00:06:23.000000', 'consum', 0.0225, 'lps'),
	(437589, 126, '2015-03-01 00:06:24.000000', 'consum', 0.0217, 'lps'),
	(437590, 126, '2015-03-01 00:06:25.000000', 'consum', 0.0221, 'lps'),
	(437591, 126, '2015-03-01 00:06:26.000000', 'consum', 0.0225, 'lps'),
	(437592, 126, '2015-03-01 00:06:27.000000', 'consum', 0.0210, 'lps'),
	(437593, 126, '2015-03-01 00:06:28.000000', 'consum', 0.0226, 'lps'),
	(437594, 126, '2015-03-01 00:06:29.000000', 'consum', 0.0210, 'lps'),
	(437595, 126, '2015-03-01 00:06:30.000000', 'consum', 0.0223, 'lps'),
	(437596, 126, '2015-03-01 00:06:31.000000', 'consum', 0.0213, 'lps'),
	(437597, 126, '2015-03-01 00:06:32.000000', 'consum', 0.0229, 'lps'),
	(437598, 126, '2015-03-01 00:06:33.000000', 'consum', 0.0214, 'lps'),
	(437599, 126, '2015-03-01 00:06:34.000000', 'consum', 0.0213, 'lps'),
	(437600, 126, '2015-03-01 00:06:35.000000', 'consum', 0.0216, 'lps'),
	(437601, 126, '2015-03-01 00:06:36.000000', 'consum', 0.0230, 'lps'),
	(437602, 126, '2015-03-01 00:06:37.000000', 'consum', 0.0228, 'lps'),
	(437603, 126, '2015-03-01 00:06:38.000000', 'consum', 0.0222, 'lps'),
	(437604, 126, '2015-03-01 00:06:39.000000', 'consum', 0.0217, 'lps'),
	(437605, 126, '2015-03-01 00:06:40.000000', 'consum', 0.0230, 'lps'),
	(437606, 126, '2015-03-01 00:06:41.000000', 'consum', 0.0224, 'lps'),
	(437607, 126, '2015-03-01 00:06:42.000000', 'consum', 0.0223, 'lps'),
	(437608, 126, '2015-03-01 00:06:43.000000', 'consum', 0.0211, 'lps'),
	(437609, 126, '2015-03-01 00:06:44.000000', 'consum', 0.0218, 'lps'),
	(437610, 126, '2015-03-01 00:06:45.000000', 'consum', 0.0228, 'lps'),
	(437611, 126, '2015-03-01 00:06:46.000000', 'consum', 0.0212, 'lps'),
	(437612, 126, '2015-03-01 00:06:47.000000', 'consum', 0.0211, 'lps'),
	(437613, 126, '2015-03-01 00:06:48.000000', 'consum', 0.0227, 'lps'),
	(437614, 126, '2015-03-01 00:06:49.000000', 'consum', 0.0211, 'lps'),
	(437615, 126, '2015-03-01 00:06:50.000000', 'consum', 0.0227, 'lps'),
	(437616, 126, '2015-03-01 00:06:51.000000', 'consum', 0.0229, 'lps'),
	(437617, 126, '2015-03-01 00:06:52.000000', 'consum', 0.0211, 'lps'),
	(437618, 126, '2015-03-01 00:06:53.000000', 'consum', 0.0223, 'lps'),
	(437619, 126, '2015-03-01 00:06:54.000000', 'consum', 0.0230, 'lps'),
	(437620, 126, '2015-03-01 00:06:55.000000', 'consum', 0.0210, 'lps'),
	(437621, 126, '2015-03-01 00:06:56.000000', 'consum', 0.0213, 'lps'),
	(437622, 126, '2015-03-01 00:06:57.000000', 'consum', 0.0227, 'lps'),
	(437623, 126, '2015-03-01 00:06:58.000000', 'consum', 0.0220, 'lps'),
	(437624, 126, '2015-03-01 00:06:59.000000', 'consum', 0.0212, 'lps'),
	(437625, 126, '2015-03-01 00:07:00.000000', 'consum', 0.0212, 'lps'),
	(437626, 126, '2015-03-01 00:07:01.000000', 'consum', 0.0216, 'lps'),
	(437627, 126, '2015-03-01 00:07:02.000000', 'consum', 0.0210, 'lps'),
	(437628, 126, '2015-03-01 00:07:03.000000', 'consum', 0.0215, 'lps'),
	(437629, 126, '2015-03-01 00:07:04.000000', 'consum', 0.0214, 'lps'),
	(437630, 126, '2015-03-01 00:07:05.000000', 'consum', 0.0215, 'lps'),
	(437631, 126, '2015-03-01 00:07:06.000000', 'consum', 0.0223, 'lps'),
	(437632, 126, '2015-03-01 00:07:07.000000', 'consum', 0.0217, 'lps'),
	(437633, 126, '2015-03-01 00:07:08.000000', 'consum', 0.0230, 'lps'),
	(437634, 126, '2015-03-01 00:07:09.000000', 'consum', 0.0226, 'lps'),
	(437635, 126, '2015-03-01 00:07:10.000000', 'consum', 0.0230, 'lps'),
	(437636, 126, '2015-03-01 00:07:11.000000', 'consum', 0.0220, 'lps'),
	(437637, 126, '2015-03-01 00:07:12.000000', 'consum', 0.0222, 'lps'),
	(437638, 126, '2015-03-01 00:07:13.000000', 'consum', 0.0218, 'lps'),
	(437639, 126, '2015-03-01 00:07:14.000000', 'consum', 0.0214, 'lps'),
	(437640, 126, '2015-03-01 00:07:15.000000', 'consum', 0.0230, 'lps'),
	(437641, 126, '2015-03-01 00:07:16.000000', 'consum', 0.0214, 'lps'),
	(437642, 126, '2015-03-01 00:07:17.000000', 'consum', 0.0212, 'lps'),
	(437643, 126, '2015-03-01 00:07:18.000000', 'consum', 0.0228, 'lps'),
	(437644, 126, '2015-03-01 00:07:19.000000', 'consum', 0.0210, 'lps'),
	(437645, 126, '2015-03-01 00:07:20.000000', 'consum', 0.0220, 'lps'),
	(437646, 126, '2015-03-01 00:07:21.000000', 'consum', 0.0221, 'lps'),
	(437647, 126, '2015-03-01 00:07:22.000000', 'consum', 0.0212, 'lps'),
	(437648, 126, '2015-03-01 00:07:23.000000', 'consum', 0.0210, 'lps'),
	(437649, 126, '2015-03-01 00:07:24.000000', 'consum', 0.0224, 'lps'),
	(437650, 126, '2015-03-01 00:07:25.000000', 'consum', 0.0218, 'lps'),
	(437651, 126, '2015-03-01 00:07:26.000000', 'consum', 0.0229, 'lps'),
	(437652, 126, '2015-03-01 00:07:27.000000', 'consum', 0.0218, 'lps'),
	(437653, 126, '2015-03-01 00:07:28.000000', 'consum', 0.0214, 'lps'),
	(437654, 126, '2015-03-01 00:07:29.000000', 'consum', 0.0226, 'lps'),
	(437655, 126, '2015-03-01 00:07:30.000000', 'consum', 0.0219, 'lps'),
	(437656, 126, '2015-03-01 00:07:31.000000', 'consum', 0.0227, 'lps'),
	(437657, 126, '2015-03-01 00:07:32.000000', 'consum', 0.0227, 'lps'),
	(437658, 126, '2015-03-01 00:07:33.000000', 'consum', 0.0224, 'lps'),
	(437659, 126, '2015-03-01 00:07:34.000000', 'consum', 0.0229, 'lps'),
	(437660, 126, '2015-03-01 00:07:35.000000', 'consum', 0.0220, 'lps'),
	(437661, 126, '2015-03-01 00:07:36.000000', 'consum', 0.0225, 'lps'),
	(437662, 126, '2015-03-01 00:07:37.000000', 'consum', 0.0212, 'lps'),
	(437663, 126, '2015-03-01 00:07:38.000000', 'consum', 0.0220, 'lps'),
	(437664, 126, '2015-03-01 00:07:39.000000', 'consum', 0.0211, 'lps'),
	(437665, 126, '2015-03-01 00:07:40.000000', 'consum', 0.0229, 'lps'),
	(437666, 126, '2015-03-01 00:07:41.000000', 'consum', 0.0216, 'lps'),
	(437667, 126, '2015-03-01 00:07:42.000000', 'consum', 0.0229, 'lps'),
	(437668, 126, '2015-03-01 00:07:43.000000', 'consum', 0.0222, 'lps'),
	(437669, 126, '2015-03-01 00:07:44.000000', 'consum', 0.0213, 'lps'),
	(437670, 126, '2015-03-01 00:07:45.000000', 'consum', 0.0212, 'lps'),
	(437671, 126, '2015-03-01 00:07:46.000000', 'consum', 0.0230, 'lps'),
	(437672, 126, '2015-03-01 00:07:47.000000', 'consum', 0.0222, 'lps'),
	(437673, 126, '2015-03-01 00:07:48.000000', 'consum', 0.0230, 'lps'),
	(437674, 126, '2015-03-01 00:07:49.000000', 'consum', 0.0213, 'lps'),
	(437675, 126, '2015-03-01 00:07:50.000000', 'consum', 0.0229, 'lps'),
	(437676, 126, '2015-03-01 00:07:51.000000', 'consum', 0.0211, 'lps'),
	(437677, 126, '2015-03-01 00:07:52.000000', 'consum', 0.0223, 'lps'),
	(437678, 126, '2015-03-01 00:07:53.000000', 'consum', 0.0229, 'lps'),
	(437679, 126, '2015-03-01 00:07:54.000000', 'consum', 0.0226, 'lps'),
	(437680, 126, '2015-03-01 00:07:55.000000', 'consum', 0.0210, 'lps'),
	(437681, 126, '2015-03-01 00:07:56.000000', 'consum', 0.0227, 'lps'),
	(437682, 126, '2015-03-01 00:07:57.000000', 'consum', 0.0210, 'lps'),
	(437683, 126, '2015-03-01 00:07:58.000000', 'consum', 0.0224, 'lps'),
	(437684, 126, '2015-03-01 00:07:59.000000', 'consum', 0.0215, 'lps'),
	(437685, 126, '2015-03-01 00:08:00.000000', 'consum', 0.0218, 'lps'),
	(437686, 126, '2015-03-01 00:08:01.000000', 'consum', 0.0212, 'lps'),
	(437687, 126, '2015-03-01 00:08:02.000000', 'consum', 0.0217, 'lps'),
	(437688, 126, '2015-03-01 00:08:03.000000', 'consum', 0.0220, 'lps'),
	(437689, 126, '2015-03-01 00:08:04.000000', 'consum', 0.0219, 'lps'),
	(437690, 126, '2015-03-01 00:08:05.000000', 'consum', 0.0225, 'lps'),
	(437691, 126, '2015-03-01 00:08:06.000000', 'consum', 0.0217, 'lps'),
	(437692, 126, '2015-03-01 00:08:07.000000', 'consum', 0.0222, 'lps'),
	(437693, 126, '2015-03-01 00:08:08.000000', 'consum', 0.0230, 'lps'),
	(437694, 126, '2015-03-01 00:08:09.000000', 'consum', 0.0210, 'lps'),
	(437695, 126, '2015-03-01 00:08:10.000000', 'consum', 0.0212, 'lps'),
	(437696, 126, '2015-03-01 00:08:11.000000', 'consum', 0.0221, 'lps'),
	(437697, 126, '2015-03-01 00:08:12.000000', 'consum', 0.0219, 'lps'),
	(437698, 126, '2015-03-01 00:08:13.000000', 'consum', 0.0220, 'lps'),
	(437699, 126, '2015-03-01 00:08:14.000000', 'consum', 0.0214, 'lps'),
	(437700, 126, '2015-03-01 00:08:15.000000', 'consum', 0.0222, 'lps'),
	(437701, 126, '2015-03-01 00:08:16.000000', 'consum', 0.0216, 'lps'),
	(437702, 126, '2015-03-01 00:08:17.000000', 'consum', 0.0223, 'lps'),
	(437703, 126, '2015-03-01 00:08:18.000000', 'consum', 0.0219, 'lps'),
	(437704, 126, '2015-03-01 00:08:19.000000', 'consum', 0.0217, 'lps'),
	(437705, 126, '2015-03-01 00:08:20.000000', 'consum', 0.0217, 'lps'),
	(437706, 126, '2015-03-01 00:08:21.000000', 'consum', 0.0225, 'lps'),
	(437707, 126, '2015-03-01 00:08:22.000000', 'consum', 0.0224, 'lps'),
	(437708, 126, '2015-03-01 00:08:23.000000', 'consum', 0.0212, 'lps'),
	(437709, 126, '2015-03-01 00:08:24.000000', 'consum', 0.0221, 'lps'),
	(437710, 126, '2015-03-01 00:08:25.000000', 'consum', 0.0216, 'lps'),
	(437711, 126, '2015-03-01 00:08:26.000000', 'consum', 0.0210, 'lps'),
	(437712, 126, '2015-03-01 00:08:27.000000', 'consum', 0.0213, 'lps'),
	(437713, 126, '2015-03-01 00:08:28.000000', 'consum', 0.0227, 'lps'),
	(437714, 126, '2015-03-01 00:08:29.000000', 'consum', 0.0221, 'lps'),
	(437715, 126, '2015-03-01 00:08:30.000000', 'consum', 0.0214, 'lps'),
	(437716, 126, '2015-03-01 00:08:31.000000', 'consum', 0.0219, 'lps'),
	(437717, 126, '2015-03-01 00:08:32.000000', 'consum', 0.0222, 'lps'),
	(437718, 126, '2015-03-01 00:08:33.000000', 'consum', 0.0224, 'lps'),
	(437719, 126, '2015-03-01 00:08:34.000000', 'consum', 0.0222, 'lps'),
	(437720, 126, '2015-03-01 00:08:35.000000', 'consum', 0.0230, 'lps'),
	(437721, 126, '2015-03-01 00:08:36.000000', 'consum', 0.0212, 'lps'),
	(437722, 126, '2015-03-01 00:08:37.000000', 'consum', 0.0222, 'lps'),
	(437723, 126, '2015-03-01 00:08:38.000000', 'consum', 0.0222, 'lps'),
	(437724, 126, '2015-03-01 00:08:39.000000', 'consum', 0.0214, 'lps'),
	(437725, 126, '2015-03-01 00:08:40.000000', 'consum', 0.0214, 'lps'),
	(437726, 126, '2015-03-01 00:08:41.000000', 'consum', 0.0221, 'lps'),
	(437727, 126, '2015-03-01 00:08:42.000000', 'consum', 0.0212, 'lps'),
	(437728, 126, '2015-03-01 00:08:43.000000', 'consum', 0.0228, 'lps'),
	(437729, 126, '2015-03-01 00:08:44.000000', 'consum', 0.0212, 'lps'),
	(437730, 126, '2015-03-01 00:08:45.000000', 'consum', 0.0228, 'lps'),
	(437731, 126, '2015-03-01 00:08:46.000000', 'consum', 0.0210, 'lps'),
	(437732, 126, '2015-03-01 00:08:47.000000', 'consum', 0.0219, 'lps'),
	(437733, 126, '2015-03-01 00:08:48.000000', 'consum', 0.0215, 'lps'),
	(437734, 126, '2015-03-01 00:08:49.000000', 'consum', 0.0210, 'lps'),
	(437735, 126, '2015-03-01 00:08:50.000000', 'consum', 0.0216, 'lps'),
	(437736, 126, '2015-03-01 00:08:51.000000', 'consum', 0.0218, 'lps'),
	(437737, 126, '2015-03-01 00:08:52.000000', 'consum', 0.0210, 'lps'),
	(437738, 126, '2015-03-01 00:08:53.000000', 'consum', 0.0211, 'lps'),
	(437739, 126, '2015-03-01 00:08:54.000000', 'consum', 0.0214, 'lps'),
	(437740, 126, '2015-03-01 00:08:55.000000', 'consum', 0.0229, 'lps'),
	(437741, 126, '2015-03-01 00:08:56.000000', 'consum', 0.0230, 'lps'),
	(437742, 126, '2015-03-01 00:08:57.000000', 'consum', 0.0211, 'lps'),
	(437743, 126, '2015-03-01 00:08:58.000000', 'consum', 0.0218, 'lps'),
	(437744, 126, '2015-03-01 00:08:59.000000', 'consum', 0.0227, 'lps'),
	(437745, 126, '2015-03-01 00:09:00.000000', 'consum', 0.0210, 'lps'),
	(437746, 126, '2015-03-01 00:09:01.000000', 'consum', 0.0220, 'lps'),
	(437747, 126, '2015-03-01 00:09:02.000000', 'consum', 0.0218, 'lps'),
	(437748, 126, '2015-03-01 00:09:03.000000', 'consum', 0.0220, 'lps'),
	(437749, 126, '2015-03-01 00:09:04.000000', 'consum', 0.0216, 'lps'),
	(437750, 126, '2015-03-01 00:09:05.000000', 'consum', 0.0210, 'lps'),
	(437751, 126, '2015-03-01 00:09:06.000000', 'consum', 0.0214, 'lps'),
	(437752, 126, '2015-03-01 00:09:07.000000', 'consum', 0.0230, 'lps'),
	(437753, 126, '2015-03-01 00:09:08.000000', 'consum', 0.0216, 'lps'),
	(437754, 126, '2015-03-01 00:09:09.000000', 'consum', 0.0223, 'lps'),
	(437755, 126, '2015-03-01 00:09:10.000000', 'consum', 0.0213, 'lps'),
	(437756, 126, '2015-03-01 00:09:11.000000', 'consum', 0.0210, 'lps'),
	(437757, 126, '2015-03-01 00:09:12.000000', 'consum', 0.0222, 'lps'),
	(437758, 126, '2015-03-01 00:09:13.000000', 'consum', 0.0229, 'lps'),
	(437759, 126, '2015-03-01 00:09:14.000000', 'consum', 0.0228, 'lps'),
	(437760, 126, '2015-03-01 00:09:15.000000', 'consum', 0.0222, 'lps'),
	(437761, 126, '2015-03-01 00:09:16.000000', 'consum', 0.0218, 'lps'),
	(437762, 126, '2015-03-01 00:09:17.000000', 'consum', 0.0214, 'lps'),
	(437763, 126, '2015-03-01 00:09:18.000000', 'consum', 0.0226, 'lps'),
	(437764, 126, '2015-03-01 00:09:19.000000', 'consum', 0.0214, 'lps'),
	(437765, 126, '2015-03-01 00:09:20.000000', 'consum', 0.0227, 'lps'),
	(437766, 126, '2015-03-01 00:09:21.000000', 'consum', 0.0218, 'lps'),
	(437767, 126, '2015-03-01 00:09:22.000000', 'consum', 0.0224, 'lps'),
	(437768, 126, '2015-03-01 00:09:23.000000', 'consum', 0.0213, 'lps'),
	(437769, 126, '2015-03-01 00:09:24.000000', 'consum', 0.0223, 'lps'),
	(437770, 126, '2015-03-01 00:09:25.000000', 'consum', 0.0228, 'lps'),
	(437771, 126, '2015-03-01 00:09:26.000000', 'consum', 0.0218, 'lps'),
	(437772, 126, '2015-03-01 00:09:27.000000', 'consum', 0.0219, 'lps'),
	(437773, 126, '2015-03-01 00:09:28.000000', 'consum', 0.0229, 'lps'),
	(437774, 126, '2015-03-01 00:09:29.000000', 'consum', 0.0217, 'lps'),
	(437775, 126, '2015-03-01 00:09:30.000000', 'consum', 0.0210, 'lps'),
	(437776, 126, '2015-03-01 00:09:31.000000', 'consum', 0.0230, 'lps'),
	(437777, 126, '2015-03-01 00:09:32.000000', 'consum', 0.0229, 'lps'),
	(437778, 126, '2015-03-01 00:09:33.000000', 'consum', 0.0222, 'lps'),
	(437779, 126, '2015-03-01 00:09:34.000000', 'consum', 0.0212, 'lps'),
	(437780, 126, '2015-03-01 00:09:35.000000', 'consum', 0.0230, 'lps'),
	(437781, 126, '2015-03-01 00:09:36.000000', 'consum', 0.0220, 'lps'),
	(437782, 126, '2015-03-01 00:09:37.000000', 'consum', 0.0221, 'lps'),
	(437783, 126, '2015-03-01 00:09:38.000000', 'consum', 0.0214, 'lps'),
	(437784, 126, '2015-03-01 00:09:39.000000', 'consum', 0.0220, 'lps'),
	(437785, 126, '2015-03-01 00:09:40.000000', 'consum', 0.0226, 'lps'),
	(437786, 126, '2015-03-01 00:09:41.000000', 'consum', 0.0219, 'lps'),
	(437787, 126, '2015-03-01 00:09:42.000000', 'consum', 0.0227, 'lps'),
	(437788, 126, '2015-03-01 00:09:43.000000', 'consum', 0.0226, 'lps'),
	(437789, 126, '2015-03-01 00:09:44.000000', 'consum', 0.0219, 'lps'),
	(437790, 126, '2015-03-01 00:09:45.000000', 'consum', 0.0227, 'lps'),
	(437791, 126, '2015-03-01 00:09:46.000000', 'consum', 0.0227, 'lps'),
	(437792, 126, '2015-03-01 00:09:47.000000', 'consum', 0.0225, 'lps'),
	(437793, 126, '2015-03-01 00:09:48.000000', 'consum', 0.0211, 'lps'),
	(437794, 126, '2015-03-01 00:09:49.000000', 'consum', 0.0214, 'lps'),
	(437795, 126, '2015-03-01 00:09:50.000000', 'consum', 0.0229, 'lps'),
	(437796, 126, '2015-03-01 00:09:51.000000', 'consum', 0.0210, 'lps'),
	(437797, 126, '2015-03-01 00:09:52.000000', 'consum', 0.0217, 'lps'),
	(437798, 126, '2015-03-01 00:09:53.000000', 'consum', 0.0223, 'lps'),
	(437799, 126, '2015-03-01 00:09:54.000000', 'consum', 0.0212, 'lps'),
	(437800, 126, '2015-03-01 00:09:55.000000', 'consum', 0.0223, 'lps'),
	(437801, 126, '2015-03-01 00:09:56.000000', 'consum', 0.0228, 'lps'),
	(437802, 126, '2015-03-01 00:09:57.000000', 'consum', 0.0219, 'lps'),
	(437803, 126, '2015-03-01 00:09:58.000000', 'consum', 0.0223, 'lps'),
	(437804, 126, '2015-03-01 00:09:59.000000', 'consum', 0.0228, 'lps'),
	(437805, 126, '2015-03-01 00:10:00.000000', 'consum', 0.0220, 'lps'),
	(437806, 126, '2015-03-01 00:10:01.000000', 'consum', 0.0228, 'lps'),
	(437807, 126, '2015-03-01 00:10:02.000000', 'consum', 0.0229, 'lps'),
	(437808, 126, '2015-03-01 00:10:03.000000', 'consum', 0.0230, 'lps'),
	(437809, 126, '2015-03-01 00:10:04.000000', 'consum', 0.0213, 'lps'),
	(437810, 126, '2015-03-01 00:10:05.000000', 'consum', 0.0228, 'lps'),
	(437811, 126, '2015-03-01 00:10:06.000000', 'consum', 0.0229, 'lps'),
	(437812, 126, '2015-03-01 00:10:07.000000', 'consum', 0.0210, 'lps'),
	(437813, 126, '2015-03-01 00:10:08.000000', 'consum', 0.0215, 'lps'),
	(437814, 126, '2015-03-01 00:10:09.000000', 'consum', 0.0217, 'lps'),
	(437815, 126, '2015-03-01 00:10:10.000000', 'consum', 0.0229, 'lps'),
	(437816, 126, '2015-03-01 00:10:11.000000', 'consum', 0.0223, 'lps'),
	(437817, 126, '2015-03-01 00:10:12.000000', 'consum', 0.0218, 'lps'),
	(437818, 126, '2015-03-01 00:10:13.000000', 'consum', 0.0211, 'lps'),
	(437819, 126, '2015-03-01 00:10:14.000000', 'consum', 0.0212, 'lps'),
	(437820, 126, '2015-03-01 00:10:15.000000', 'consum', 0.0219, 'lps'),
	(437821, 126, '2015-03-01 00:10:16.000000', 'consum', 0.0228, 'lps'),
	(437822, 126, '2015-03-01 00:10:17.000000', 'consum', 0.0211, 'lps'),
	(437823, 126, '2015-03-01 00:10:18.000000', 'consum', 0.0222, 'lps'),
	(437824, 126, '2015-03-01 00:10:19.000000', 'consum', 0.0229, 'lps'),
	(437825, 126, '2015-03-01 00:10:20.000000', 'consum', 0.0225, 'lps'),
	(437826, 126, '2015-03-01 00:10:21.000000', 'consum', 0.0229, 'lps'),
	(437827, 126, '2015-03-01 00:10:22.000000', 'consum', 0.0218, 'lps'),
	(437828, 126, '2015-03-01 00:10:23.000000', 'consum', 0.0214, 'lps'),
	(437829, 126, '2015-03-01 00:10:24.000000', 'consum', 0.0227, 'lps'),
	(437830, 126, '2015-03-01 00:10:25.000000', 'consum', 0.0223, 'lps'),
	(437831, 126, '2015-03-01 00:10:26.000000', 'consum', 0.0223, 'lps'),
	(437832, 126, '2015-03-01 00:10:27.000000', 'consum', 0.0217, 'lps'),
	(437833, 126, '2015-03-01 00:10:28.000000', 'consum', 0.0226, 'lps'),
	(437834, 126, '2015-03-01 00:10:29.000000', 'consum', 0.0227, 'lps'),
	(437835, 126, '2015-03-01 00:10:30.000000', 'consum', 0.0226, 'lps'),
	(437836, 126, '2015-03-01 00:10:31.000000', 'consum', 0.0221, 'lps'),
	(437837, 126, '2015-03-01 00:10:32.000000', 'consum', 0.0216, 'lps'),
	(437838, 126, '2015-03-01 00:10:33.000000', 'consum', 0.0229, 'lps'),
	(437839, 126, '2015-03-01 00:10:34.000000', 'consum', 0.0226, 'lps'),
	(437840, 126, '2015-03-01 00:10:35.000000', 'consum', 0.0211, 'lps'),
	(437841, 126, '2015-03-01 00:10:36.000000', 'consum', 0.0210, 'lps'),
	(437842, 126, '2015-03-01 00:10:37.000000', 'consum', 0.0226, 'lps'),
	(437843, 126, '2015-03-01 00:10:38.000000', 'consum', 0.0230, 'lps'),
	(437844, 126, '2015-03-01 00:10:39.000000', 'consum', 0.0222, 'lps'),
	(437845, 126, '2015-03-01 00:10:40.000000', 'consum', 0.0229, 'lps'),
	(437846, 126, '2015-03-01 00:10:41.000000', 'consum', 0.0227, 'lps'),
	(437847, 126, '2015-03-01 00:10:42.000000', 'consum', 0.0220, 'lps'),
	(437848, 126, '2015-03-01 00:10:43.000000', 'consum', 0.0230, 'lps'),
	(437849, 126, '2015-03-01 00:10:44.000000', 'consum', 0.0218, 'lps'),
	(437850, 126, '2015-03-01 00:10:45.000000', 'consum', 0.0212, 'lps'),
	(437851, 126, '2015-03-01 00:10:46.000000', 'consum', 0.0216, 'lps'),
	(437852, 126, '2015-03-01 00:10:47.000000', 'consum', 0.0215, 'lps'),
	(437853, 126, '2015-03-01 00:10:48.000000', 'consum', 0.0216, 'lps'),
	(437854, 126, '2015-03-01 00:10:49.000000', 'consum', 0.0227, 'lps'),
	(437855, 126, '2015-03-01 00:10:50.000000', 'consum', 0.0213, 'lps'),
	(437856, 126, '2015-03-01 00:10:51.000000', 'consum', 0.0217, 'lps'),
	(437857, 126, '2015-03-01 00:10:52.000000', 'consum', 0.0214, 'lps'),
	(437858, 126, '2015-03-01 00:10:53.000000', 'consum', 0.0210, 'lps'),
	(437859, 126, '2015-03-01 00:10:54.000000', 'consum', 0.0220, 'lps'),
	(437860, 126, '2015-03-01 00:10:55.000000', 'consum', 0.0218, 'lps'),
	(437861, 126, '2015-03-01 00:10:56.000000', 'consum', 0.0219, 'lps'),
	(437862, 126, '2015-03-01 00:10:57.000000', 'consum', 0.0212, 'lps'),
	(437863, 126, '2015-03-01 00:10:58.000000', 'consum', 0.0213, 'lps'),
	(437864, 126, '2015-03-01 00:10:59.000000', 'consum', 0.0221, 'lps'),
	(437865, 126, '2015-03-01 00:11:00.000000', 'consum', 0.0215, 'lps'),
	(437866, 126, '2015-03-01 00:11:01.000000', 'consum', 0.0223, 'lps'),
	(437867, 126, '2015-03-01 00:11:02.000000', 'consum', 0.0217, 'lps'),
	(437868, 126, '2015-03-01 00:11:03.000000', 'consum', 0.0227, 'lps'),
	(437869, 126, '2015-03-01 00:11:04.000000', 'consum', 0.0214, 'lps'),
	(437870, 126, '2015-03-01 00:11:05.000000', 'consum', 0.0223, 'lps'),
	(437871, 126, '2015-03-01 00:11:06.000000', 'consum', 0.0218, 'lps'),
	(437872, 126, '2015-03-01 00:11:07.000000', 'consum', 0.0212, 'lps'),
	(437873, 126, '2015-03-01 00:11:08.000000', 'consum', 0.0220, 'lps'),
	(437874, 126, '2015-03-01 00:11:09.000000', 'consum', 0.0230, 'lps'),
	(437875, 126, '2015-03-01 00:11:10.000000', 'consum', 0.0219, 'lps'),
	(437876, 126, '2015-03-01 00:11:11.000000', 'consum', 0.0217, 'lps'),
	(437877, 126, '2015-03-01 00:11:12.000000', 'consum', 0.0219, 'lps'),
	(437878, 126, '2015-03-01 00:11:13.000000', 'consum', 0.0215, 'lps'),
	(437879, 126, '2015-03-01 00:11:14.000000', 'consum', 0.0227, 'lps'),
	(437880, 126, '2015-03-01 00:11:15.000000', 'consum', 0.0220, 'lps'),
	(437881, 126, '2015-03-01 00:11:16.000000', 'consum', 0.0210, 'lps'),
	(437882, 126, '2015-03-01 00:11:17.000000', 'consum', 0.0220, 'lps'),
	(437883, 126, '2015-03-01 00:11:18.000000', 'consum', 0.0217, 'lps'),
	(437884, 126, '2015-03-01 00:11:19.000000', 'consum', 0.0219, 'lps'),
	(437885, 126, '2015-03-01 00:11:20.000000', 'consum', 0.0214, 'lps'),
	(437886, 126, '2015-03-01 00:11:21.000000', 'consum', 0.0221, 'lps'),
	(437887, 126, '2015-03-01 00:11:22.000000', 'consum', 0.0214, 'lps'),
	(437888, 126, '2015-03-01 00:11:23.000000', 'consum', 0.0219, 'lps'),
	(437889, 126, '2015-03-01 00:11:24.000000', 'consum', 0.0223, 'lps'),
	(437890, 126, '2015-03-01 00:11:25.000000', 'consum', 0.0228, 'lps'),
	(437891, 126, '2015-03-01 00:11:26.000000', 'consum', 0.0218, 'lps'),
	(437892, 126, '2015-03-01 00:11:27.000000', 'consum', 0.0220, 'lps'),
	(437893, 126, '2015-03-01 00:11:28.000000', 'consum', 0.0213, 'lps'),
	(437894, 126, '2015-03-01 00:11:29.000000', 'consum', 0.0217, 'lps'),
	(437895, 126, '2015-03-01 00:11:30.000000', 'consum', 0.0214, 'lps'),
	(437896, 126, '2015-03-01 00:11:31.000000', 'consum', 0.0211, 'lps'),
	(437897, 126, '2015-03-01 00:11:32.000000', 'consum', 0.0223, 'lps'),
	(437898, 126, '2015-03-01 00:11:33.000000', 'consum', 0.0210, 'lps'),
	(437899, 126, '2015-03-01 00:11:34.000000', 'consum', 0.0215, 'lps'),
	(437900, 126, '2015-03-01 00:11:35.000000', 'consum', 0.0215, 'lps'),
	(437901, 126, '2015-03-01 00:11:36.000000', 'consum', 0.0219, 'lps'),
	(437902, 126, '2015-03-01 00:11:37.000000', 'consum', 0.0221, 'lps'),
	(437903, 126, '2015-03-01 00:11:38.000000', 'consum', 0.0215, 'lps'),
	(437904, 126, '2015-03-01 00:11:39.000000', 'consum', 0.0223, 'lps'),
	(437905, 126, '2015-03-01 00:11:40.000000', 'consum', 0.0219, 'lps'),
	(437906, 126, '2015-03-01 00:11:41.000000', 'consum', 0.0219, 'lps'),
	(437907, 126, '2015-03-01 00:11:42.000000', 'consum', 0.0225, 'lps'),
	(437908, 126, '2015-03-01 00:11:43.000000', 'consum', 0.0220, 'lps'),
	(437909, 126, '2015-03-01 00:11:44.000000', 'consum', 0.0214, 'lps'),
	(437910, 126, '2015-03-01 00:11:45.000000', 'consum', 0.0219, 'lps'),
	(437911, 126, '2015-03-01 00:11:46.000000', 'consum', 0.0226, 'lps'),
	(437912, 126, '2015-03-01 00:11:47.000000', 'consum', 0.0220, 'lps'),
	(437913, 126, '2015-03-01 00:11:48.000000', 'consum', 0.0215, 'lps'),
	(437914, 126, '2015-03-01 00:11:49.000000', 'consum', 0.0223, 'lps'),
	(437915, 126, '2015-03-01 00:11:50.000000', 'consum', 0.0220, 'lps'),
	(437916, 126, '2015-03-01 00:11:51.000000', 'consum', 0.0222, 'lps'),
	(437917, 126, '2015-03-01 00:11:52.000000', 'consum', 0.0218, 'lps'),
	(437918, 126, '2015-03-01 00:11:53.000000', 'consum', 0.0215, 'lps'),
	(437919, 126, '2015-03-01 00:11:54.000000', 'consum', 0.0213, 'lps'),
	(437920, 126, '2015-03-01 00:11:55.000000', 'consum', 0.0211, 'lps'),
	(437921, 126, '2015-03-01 00:11:56.000000', 'consum', 0.0225, 'lps'),
	(437922, 126, '2015-03-01 00:11:57.000000', 'consum', 0.0222, 'lps'),
	(437923, 126, '2015-03-01 00:11:58.000000', 'consum', 0.0226, 'lps'),
	(437924, 126, '2015-03-01 00:11:59.000000', 'consum', 0.0211, 'lps'),
	(437925, 126, '2015-03-01 00:12:00.000000', 'consum', 0.0229, 'lps'),
	(437926, 126, '2015-03-01 00:12:01.000000', 'consum', 0.0221, 'lps'),
	(437927, 126, '2015-03-01 00:12:02.000000', 'consum', 0.0227, 'lps'),
	(437928, 126, '2015-03-01 00:12:03.000000', 'consum', 0.0222, 'lps'),
	(437929, 126, '2015-03-01 00:12:04.000000', 'consum', 0.0217, 'lps'),
	(437930, 126, '2015-03-01 00:12:05.000000', 'consum', 0.0212, 'lps'),
	(437931, 126, '2015-03-01 00:12:06.000000', 'consum', 0.0218, 'lps'),
	(437932, 126, '2015-03-01 00:12:07.000000', 'consum', 0.0226, 'lps'),
	(437933, 126, '2015-03-01 00:12:08.000000', 'consum', 0.0223, 'lps'),
	(437934, 126, '2015-03-01 00:12:09.000000', 'consum', 0.0229, 'lps'),
	(437935, 126, '2015-03-01 00:12:10.000000', 'consum', 0.0222, 'lps'),
	(437936, 126, '2015-03-01 00:12:11.000000', 'consum', 0.0215, 'lps'),
	(437937, 126, '2015-03-01 00:12:12.000000', 'consum', 0.0219, 'lps'),
	(437938, 126, '2015-03-01 00:12:13.000000', 'consum', 0.0220, 'lps'),
	(437939, 126, '2015-03-01 00:12:14.000000', 'consum', 0.0214, 'lps'),
	(437940, 126, '2015-03-01 00:12:15.000000', 'consum', 0.0219, 'lps'),
	(437941, 126, '2015-03-01 00:12:16.000000', 'consum', 0.0222, 'lps'),
	(437942, 126, '2015-03-01 00:12:17.000000', 'consum', 0.0224, 'lps'),
	(437943, 126, '2015-03-01 00:12:18.000000', 'consum', 0.0224, 'lps'),
	(437944, 126, '2015-03-01 00:12:19.000000', 'consum', 0.0218, 'lps'),
	(437945, 126, '2015-03-01 00:12:20.000000', 'consum', 0.0227, 'lps'),
	(437946, 126, '2015-03-01 00:12:21.000000', 'consum', 0.0210, 'lps'),
	(437947, 126, '2015-03-01 00:12:22.000000', 'consum', 0.0222, 'lps'),
	(437948, 126, '2015-03-01 00:12:23.000000', 'consum', 0.0229, 'lps'),
	(437949, 126, '2015-03-01 00:12:24.000000', 'consum', 0.0226, 'lps'),
	(437950, 126, '2015-03-01 00:12:25.000000', 'consum', 0.0212, 'lps'),
	(437951, 126, '2015-03-01 00:12:26.000000', 'consum', 0.0214, 'lps'),
	(437952, 126, '2015-03-01 00:12:27.000000', 'consum', 0.0225, 'lps'),
	(437953, 126, '2015-03-01 00:12:28.000000', 'consum', 0.0213, 'lps'),
	(437954, 126, '2015-03-01 00:12:29.000000', 'consum', 0.0221, 'lps'),
	(437955, 126, '2015-03-01 00:12:30.000000', 'consum', 0.0213, 'lps'),
	(437956, 126, '2015-03-01 00:12:31.000000', 'consum', 0.0215, 'lps'),
	(437957, 126, '2015-03-01 00:12:32.000000', 'consum', 0.0227, 'lps'),
	(437958, 126, '2015-03-01 00:12:33.000000', 'consum', 0.0218, 'lps'),
	(437959, 126, '2015-03-01 00:12:34.000000', 'consum', 0.0221, 'lps'),
	(437960, 126, '2015-03-01 00:12:35.000000', 'consum', 0.0219, 'lps'),
	(437961, 126, '2015-03-01 00:12:36.000000', 'consum', 0.0223, 'lps'),
	(437962, 126, '2015-03-01 00:12:37.000000', 'consum', 0.0228, 'lps'),
	(437963, 126, '2015-03-01 00:12:38.000000', 'consum', 0.0219, 'lps'),
	(437964, 126, '2015-03-01 00:12:39.000000', 'consum', 0.0221, 'lps'),
	(437965, 126, '2015-03-01 00:12:40.000000', 'consum', 0.0220, 'lps'),
	(437966, 126, '2015-03-01 00:12:41.000000', 'consum', 0.0227, 'lps'),
	(437967, 126, '2015-03-01 00:12:42.000000', 'consum', 0.0223, 'lps'),
	(437968, 126, '2015-03-01 00:12:43.000000', 'consum', 0.0226, 'lps'),
	(437969, 126, '2015-03-01 00:12:44.000000', 'consum', 0.0230, 'lps'),
	(437970, 126, '2015-03-01 00:12:45.000000', 'consum', 0.0220, 'lps'),
	(437971, 126, '2015-03-01 00:12:46.000000', 'consum', 0.0221, 'lps'),
	(437972, 126, '2015-03-01 00:12:47.000000', 'consum', 0.0214, 'lps'),
	(437973, 126, '2015-03-01 00:12:48.000000', 'consum', 0.0219, 'lps'),
	(437974, 126, '2015-03-01 00:12:49.000000', 'consum', 0.0221, 'lps'),
	(437975, 126, '2015-03-01 00:12:50.000000', 'consum', 0.0219, 'lps'),
	(437976, 126, '2015-03-01 00:12:51.000000', 'consum', 0.0222, 'lps'),
	(437977, 126, '2015-03-01 00:12:52.000000', 'consum', 0.0221, 'lps'),
	(437978, 126, '2015-03-01 00:12:53.000000', 'consum', 0.0210, 'lps'),
	(437979, 126, '2015-03-01 00:12:54.000000', 'consum', 0.0217, 'lps'),
	(437980, 126, '2015-03-01 00:12:55.000000', 'consum', 0.0227, 'lps'),
	(437981, 126, '2015-03-01 00:12:56.000000', 'consum', 0.0210, 'lps'),
	(437982, 126, '2015-03-01 00:12:57.000000', 'consum', 0.0225, 'lps'),
	(437983, 126, '2015-03-01 00:12:58.000000', 'consum', 0.0220, 'lps'),
	(437984, 126, '2015-03-01 00:12:59.000000', 'consum', 0.0217, 'lps'),
	(437985, 126, '2015-03-01 00:13:00.000000', 'consum', 0.0214, 'lps'),
	(437986, 126, '2015-03-01 00:13:01.000000', 'consum', 0.0230, 'lps'),
	(437987, 126, '2015-03-01 00:13:02.000000', 'consum', 0.0214, 'lps'),
	(437988, 126, '2015-03-01 00:13:03.000000', 'consum', 0.0214, 'lps'),
	(437989, 126, '2015-03-01 00:13:04.000000', 'consum', 0.0219, 'lps'),
	(437990, 126, '2015-03-01 00:13:05.000000', 'consum', 0.0222, 'lps'),
	(437991, 126, '2015-03-01 00:13:06.000000', 'consum', 0.0224, 'lps'),
	(437992, 126, '2015-03-01 00:13:07.000000', 'consum', 0.0221, 'lps'),
	(437993, 126, '2015-03-01 00:13:08.000000', 'consum', 0.0226, 'lps'),
	(437994, 126, '2015-03-01 00:13:09.000000', 'consum', 0.0213, 'lps'),
	(437995, 126, '2015-03-01 00:13:10.000000', 'consum', 0.0219, 'lps'),
	(437996, 126, '2015-03-01 00:13:11.000000', 'consum', 0.0228, 'lps'),
	(437997, 126, '2015-03-01 00:13:12.000000', 'consum', 0.0211, 'lps'),
	(437998, 126, '2015-03-01 00:13:13.000000', 'consum', 0.0222, 'lps'),
	(437999, 126, '2015-03-01 00:13:14.000000', 'consum', 0.0227, 'lps'),
	(438000, 126, '2015-03-01 00:13:15.000000', 'consum', 0.0218, 'lps'),
	(438001, 126, '2015-03-01 00:13:16.000000', 'consum', 0.0218, 'lps'),
	(438002, 126, '2015-03-01 00:13:17.000000', 'consum', 0.0229, 'lps'),
	(438003, 126, '2015-03-01 00:13:18.000000', 'consum', 0.0220, 'lps'),
	(438004, 126, '2015-03-01 00:13:19.000000', 'consum', 0.0222, 'lps'),
	(438005, 126, '2015-03-01 00:13:20.000000', 'consum', 0.0220, 'lps'),
	(438006, 126, '2015-03-01 00:13:21.000000', 'consum', 0.0224, 'lps'),
	(438007, 126, '2015-03-01 00:13:22.000000', 'consum', 0.0230, 'lps'),
	(438008, 126, '2015-03-01 00:13:23.000000', 'consum', 0.0226, 'lps'),
	(438009, 126, '2015-03-01 00:13:24.000000', 'consum', 0.0230, 'lps'),
	(438010, 126, '2015-03-01 00:13:25.000000', 'consum', 0.0219, 'lps'),
	(438011, 126, '2015-03-01 00:13:26.000000', 'consum', 0.0219, 'lps'),
	(438012, 126, '2015-03-01 00:13:27.000000', 'consum', 0.0227, 'lps'),
	(438013, 126, '2015-03-01 00:13:28.000000', 'consum', 0.0228, 'lps'),
	(438014, 126, '2015-03-01 00:13:29.000000', 'consum', 0.0226, 'lps'),
	(438015, 126, '2015-03-01 00:13:30.000000', 'consum', 0.0217, 'lps'),
	(438016, 126, '2015-03-01 00:13:31.000000', 'consum', 0.0219, 'lps'),
	(438017, 126, '2015-03-01 00:13:32.000000', 'consum', 0.0212, 'lps'),
	(438018, 126, '2015-03-01 00:13:33.000000', 'consum', 0.0214, 'lps'),
	(438019, 126, '2015-03-01 00:13:34.000000', 'consum', 0.0224, 'lps'),
	(438020, 126, '2015-03-01 00:13:35.000000', 'consum', 0.0226, 'lps'),
	(438021, 126, '2015-03-01 00:13:36.000000', 'consum', 0.0229, 'lps'),
	(438022, 126, '2015-03-01 00:13:37.000000', 'consum', 0.0214, 'lps'),
	(438023, 126, '2015-03-01 00:13:38.000000', 'consum', 0.0214, 'lps'),
	(438024, 126, '2015-03-01 00:13:39.000000', 'consum', 0.0221, 'lps'),
	(438025, 126, '2015-03-01 00:13:40.000000', 'consum', 0.0212, 'lps'),
	(438026, 126, '2015-03-01 00:13:41.000000', 'consum', 0.0228, 'lps'),
	(438027, 126, '2015-03-01 00:13:42.000000', 'consum', 0.0230, 'lps'),
	(438028, 126, '2015-03-01 00:13:43.000000', 'consum', 0.0216, 'lps'),
	(438029, 126, '2015-03-01 00:13:44.000000', 'consum', 0.0221, 'lps'),
	(438030, 126, '2015-03-01 00:13:45.000000', 'consum', 0.0229, 'lps'),
	(438031, 126, '2015-03-01 00:13:46.000000', 'consum', 0.0230, 'lps'),
	(438032, 126, '2015-03-01 00:13:47.000000', 'consum', 0.0213, 'lps'),
	(438033, 126, '2015-03-01 00:13:48.000000', 'consum', 0.0228, 'lps'),
	(438034, 126, '2015-03-01 00:13:49.000000', 'consum', 0.0229, 'lps'),
	(438035, 126, '2015-03-01 00:13:50.000000', 'consum', 0.0228, 'lps'),
	(438036, 126, '2015-03-01 00:13:51.000000', 'consum', 0.0223, 'lps'),
	(438037, 126, '2015-03-01 00:13:52.000000', 'consum', 0.0220, 'lps'),
	(438038, 126, '2015-03-01 00:13:53.000000', 'consum', 0.0223, 'lps'),
	(438039, 126, '2015-03-01 00:13:54.000000', 'consum', 0.0226, 'lps'),
	(438040, 126, '2015-03-01 00:13:55.000000', 'consum', 0.0229, 'lps'),
	(438041, 126, '2015-03-01 00:13:56.000000', 'consum', 0.0214, 'lps'),
	(438042, 126, '2015-03-01 00:13:57.000000', 'consum', 0.0219, 'lps'),
	(438043, 126, '2015-03-01 00:13:58.000000', 'consum', 0.0219, 'lps'),
	(438044, 126, '2015-03-01 00:13:59.000000', 'consum', 0.0229, 'lps'),
	(438045, 126, '2015-03-01 00:14:00.000000', 'consum', 0.0216, 'lps'),
	(438046, 126, '2015-03-01 00:14:01.000000', 'consum', 0.0225, 'lps'),
	(438047, 126, '2015-03-01 00:14:02.000000', 'consum', 0.0227, 'lps'),
	(438048, 126, '2015-03-01 00:14:03.000000', 'consum', 0.0228, 'lps'),
	(438049, 126, '2015-03-01 00:14:04.000000', 'consum', 0.0230, 'lps'),
	(438050, 126, '2015-03-01 00:14:05.000000', 'consum', 0.0214, 'lps'),
	(438051, 126, '2015-03-01 00:14:06.000000', 'consum', 0.0211, 'lps'),
	(438052, 126, '2015-03-01 00:14:07.000000', 'consum', 0.0227, 'lps'),
	(438053, 126, '2015-03-01 00:14:08.000000', 'consum', 0.0227, 'lps'),
	(438054, 126, '2015-03-01 00:14:09.000000', 'consum', 0.0226, 'lps'),
	(438055, 126, '2015-03-01 00:14:10.000000', 'consum', 0.0218, 'lps'),
	(438056, 126, '2015-03-01 00:14:11.000000', 'consum', 0.0225, 'lps'),
	(438057, 126, '2015-03-01 00:14:12.000000', 'consum', 0.0217, 'lps'),
	(438058, 126, '2015-03-01 00:14:13.000000', 'consum', 0.0223, 'lps'),
	(438059, 126, '2015-03-01 00:14:14.000000', 'consum', 0.0210, 'lps'),
	(438060, 126, '2015-03-01 00:14:15.000000', 'consum', 0.0217, 'lps'),
	(438061, 126, '2015-03-01 00:14:16.000000', 'consum', 0.0223, 'lps'),
	(438062, 126, '2015-03-01 00:14:17.000000', 'consum', 0.0213, 'lps'),
	(438063, 126, '2015-03-01 00:14:18.000000', 'consum', 0.0228, 'lps'),
	(438064, 126, '2015-03-01 00:14:19.000000', 'consum', 0.0228, 'lps'),
	(438065, 126, '2015-03-01 00:14:20.000000', 'consum', 0.0225, 'lps'),
	(438066, 126, '2015-03-01 00:14:21.000000', 'consum', 0.0210, 'lps'),
	(438067, 126, '2015-03-01 00:14:22.000000', 'consum', 0.0230, 'lps'),
	(438068, 126, '2015-03-01 00:14:23.000000', 'consum', 0.0224, 'lps'),
	(438069, 126, '2015-03-01 00:14:24.000000', 'consum', 0.0223, 'lps'),
	(438070, 126, '2015-03-01 00:14:25.000000', 'consum', 0.0210, 'lps'),
	(438071, 126, '2015-03-01 00:14:26.000000', 'consum', 0.0217, 'lps'),
	(438072, 126, '2015-03-01 00:14:27.000000', 'consum', 0.0222, 'lps'),
	(438073, 126, '2015-03-01 00:14:28.000000', 'consum', 0.0229, 'lps'),
	(438074, 126, '2015-03-01 00:14:29.000000', 'consum', 0.0229, 'lps'),
	(438075, 126, '2015-03-01 00:14:30.000000', 'consum', 0.0228, 'lps'),
	(438076, 126, '2015-03-01 00:14:31.000000', 'consum', 0.0221, 'lps'),
	(438077, 126, '2015-03-01 00:14:32.000000', 'consum', 0.0210, 'lps'),
	(438078, 126, '2015-03-01 00:14:33.000000', 'consum', 0.0222, 'lps'),
	(438079, 126, '2015-03-01 00:14:34.000000', 'consum', 0.0229, 'lps'),
	(438080, 126, '2015-03-01 00:14:35.000000', 'consum', 0.0228, 'lps'),
	(438081, 126, '2015-03-01 00:14:36.000000', 'consum', 0.0223, 'lps'),
	(438082, 126, '2015-03-01 00:14:37.000000', 'consum', 0.0219, 'lps'),
	(438083, 126, '2015-03-01 00:14:38.000000', 'consum', 0.0217, 'lps'),
	(438084, 126, '2015-03-01 00:14:39.000000', 'consum', 0.0220, 'lps'),
	(438085, 126, '2015-03-01 00:14:40.000000', 'consum', 0.0219, 'lps'),
	(438086, 126, '2015-03-01 00:14:41.000000', 'consum', 0.0225, 'lps'),
	(438087, 126, '2015-03-01 00:14:42.000000', 'consum', 0.0217, 'lps'),
	(438088, 126, '2015-03-01 00:14:43.000000', 'consum', 0.0222, 'lps'),
	(438089, 126, '2015-03-01 00:14:44.000000', 'consum', 0.0227, 'lps'),
	(438090, 126, '2015-03-01 00:14:45.000000', 'consum', 0.0217, 'lps'),
	(438091, 126, '2015-03-01 00:14:46.000000', 'consum', 0.0218, 'lps'),
	(438092, 126, '2015-03-01 00:14:47.000000', 'consum', 0.0229, 'lps'),
	(438093, 126, '2015-03-01 00:14:48.000000', 'consum', 0.0218, 'lps'),
	(438094, 126, '2015-03-01 00:14:49.000000', 'consum', 0.0213, 'lps'),
	(438095, 126, '2015-03-01 00:14:50.000000', 'consum', 0.0222, 'lps'),
	(438096, 126, '2015-03-01 00:14:51.000000', 'consum', 0.0223, 'lps'),
	(438097, 126, '2015-03-01 00:14:52.000000', 'consum', 0.0215, 'lps'),
	(438098, 126, '2015-03-01 00:14:53.000000', 'consum', 0.0219, 'lps'),
	(438099, 126, '2015-03-01 00:14:54.000000', 'consum', 0.0219, 'lps'),
	(438100, 126, '2015-03-01 00:14:55.000000', 'consum', 0.0227, 'lps'),
	(438101, 126, '2015-03-01 00:14:56.000000', 'consum', 0.0229, 'lps'),
	(438102, 126, '2015-03-01 00:14:57.000000', 'consum', 0.0210, 'lps'),
	(438103, 126, '2015-03-01 00:14:58.000000', 'consum', 0.0218, 'lps'),
	(438104, 126, '2015-03-01 00:14:59.000000', 'consum', 0.0227, 'lps'),
	(438105, 126, '2015-03-01 00:15:00.000000', 'consum', 0.0211, 'lps'),
	(438106, 126, '2015-03-01 00:15:01.000000', 'consum', 0.0225, 'lps'),
	(438107, 126, '2015-03-01 00:15:02.000000', 'consum', 0.0223, 'lps'),
	(438108, 126, '2015-03-01 00:15:03.000000', 'consum', 0.0227, 'lps'),
	(438109, 126, '2015-03-01 00:15:04.000000', 'consum', 0.0216, 'lps'),
	(438110, 126, '2015-03-01 00:15:05.000000', 'consum', 0.0210, 'lps'),
	(438111, 126, '2015-03-01 00:15:06.000000', 'consum', 0.0214, 'lps'),
	(438112, 126, '2015-03-01 00:15:07.000000', 'consum', 0.0211, 'lps'),
	(438113, 126, '2015-03-01 00:15:08.000000', 'consum', 0.0223, 'lps'),
	(438114, 126, '2015-03-01 00:15:09.000000', 'consum', 0.0229, 'lps'),
	(438115, 126, '2015-03-01 00:15:10.000000', 'consum', 0.0227, 'lps'),
	(438116, 126, '2015-03-01 00:15:11.000000', 'consum', 0.0216, 'lps'),
	(438117, 126, '2015-03-01 00:15:12.000000', 'consum', 0.0211, 'lps'),
	(438118, 126, '2015-03-01 00:15:13.000000', 'consum', 0.0216, 'lps'),
	(438119, 126, '2015-03-01 00:15:14.000000', 'consum', 0.0220, 'lps'),
	(438120, 126, '2015-03-01 00:15:15.000000', 'consum', 0.0221, 'lps'),
	(438121, 126, '2015-03-01 00:15:16.000000', 'consum', 0.0214, 'lps'),
	(438122, 126, '2015-03-01 00:15:17.000000', 'consum', 0.0221, 'lps'),
	(438123, 126, '2015-03-01 00:15:18.000000', 'consum', 0.0229, 'lps'),
	(438124, 126, '2015-03-01 00:15:19.000000', 'consum', 0.0230, 'lps'),
	(438125, 126, '2015-03-01 00:15:20.000000', 'consum', 0.0215, 'lps'),
	(438126, 126, '2015-03-01 00:15:21.000000', 'consum', 0.0215, 'lps'),
	(438127, 126, '2015-03-01 00:15:22.000000', 'consum', 0.0220, 'lps'),
	(438128, 126, '2015-03-01 00:15:23.000000', 'consum', 0.0227, 'lps'),
	(438129, 126, '2015-03-01 00:15:24.000000', 'consum', 0.0221, 'lps'),
	(438130, 126, '2015-03-01 00:15:25.000000', 'consum', 0.0215, 'lps'),
	(438131, 126, '2015-03-01 00:15:26.000000', 'consum', 0.0223, 'lps'),
	(438132, 126, '2015-03-01 00:15:27.000000', 'consum', 0.0220, 'lps'),
	(438133, 126, '2015-03-01 00:15:28.000000', 'consum', 0.0222, 'lps'),
	(438134, 126, '2015-03-01 00:15:29.000000', 'consum', 0.0217, 'lps'),
	(438135, 126, '2015-03-01 00:15:30.000000', 'consum', 0.0211, 'lps'),
	(438136, 126, '2015-03-01 00:15:31.000000', 'consum', 0.0217, 'lps'),
	(438137, 126, '2015-03-01 00:15:32.000000', 'consum', 0.0219, 'lps'),
	(438138, 126, '2015-03-01 00:15:33.000000', 'consum', 0.0212, 'lps'),
	(438139, 126, '2015-03-01 00:15:34.000000', 'consum', 0.0218, 'lps'),
	(438140, 126, '2015-03-01 00:15:35.000000', 'consum', 0.0220, 'lps'),
	(438141, 126, '2015-03-01 00:15:36.000000', 'consum', 0.0218, 'lps'),
	(438142, 126, '2015-03-01 00:15:37.000000', 'consum', 0.0221, 'lps'),
	(438143, 126, '2015-03-01 00:15:38.000000', 'consum', 0.0219, 'lps'),
	(438144, 126, '2015-03-01 00:15:39.000000', 'consum', 0.0222, 'lps'),
	(438145, 126, '2015-03-01 00:15:40.000000', 'consum', 0.0224, 'lps'),
	(438146, 126, '2015-03-01 00:15:41.000000', 'consum', 0.0225, 'lps'),
	(438147, 126, '2015-03-01 00:15:42.000000', 'consum', 0.0219, 'lps'),
	(438148, 126, '2015-03-01 00:15:43.000000', 'consum', 0.0212, 'lps'),
	(438149, 126, '2015-03-01 00:15:44.000000', 'consum', 0.0216, 'lps'),
	(438150, 126, '2015-03-01 00:15:45.000000', 'consum', 0.0211, 'lps'),
	(438151, 126, '2015-03-01 00:15:46.000000', 'consum', 0.0221, 'lps'),
	(438152, 126, '2015-03-01 00:15:47.000000', 'consum', 0.0218, 'lps'),
	(438153, 126, '2015-03-01 00:15:48.000000', 'consum', 0.0216, 'lps'),
	(438154, 126, '2015-03-01 00:15:49.000000', 'consum', 0.0220, 'lps'),
	(438155, 126, '2015-03-01 00:15:50.000000', 'consum', 0.0221, 'lps'),
	(438156, 126, '2015-03-01 00:15:51.000000', 'consum', 0.0213, 'lps'),
	(438157, 126, '2015-03-01 00:15:52.000000', 'consum', 0.0216, 'lps'),
	(438158, 126, '2015-03-01 00:15:53.000000', 'consum', 0.0230, 'lps'),
	(438159, 126, '2015-03-01 00:15:54.000000', 'consum', 0.0229, 'lps'),
	(438160, 126, '2015-03-01 00:15:55.000000', 'consum', 0.0224, 'lps'),
	(438161, 126, '2015-03-01 00:15:56.000000', 'consum', 0.0223, 'lps'),
	(438162, 126, '2015-03-01 00:15:57.000000', 'consum', 0.0212, 'lps'),
	(438163, 126, '2015-03-01 00:15:58.000000', 'consum', 0.0222, 'lps'),
	(438164, 126, '2015-03-01 00:15:59.000000', 'consum', 0.0226, 'lps'),
	(438165, 126, '2015-03-01 00:16:00.000000', 'consum', 0.0212, 'lps'),
	(438166, 126, '2015-03-01 00:16:01.000000', 'consum', 0.0215, 'lps'),
	(438167, 126, '2015-03-01 00:16:02.000000', 'consum', 0.0227, 'lps'),
	(438168, 126, '2015-03-01 00:16:03.000000', 'consum', 0.0219, 'lps'),
	(438169, 126, '2015-03-01 00:16:04.000000', 'consum', 0.0226, 'lps'),
	(438170, 126, '2015-03-01 00:16:05.000000', 'consum', 0.0220, 'lps'),
	(438171, 126, '2015-03-01 00:16:06.000000', 'consum', 0.0213, 'lps'),
	(438172, 126, '2015-03-01 00:16:07.000000', 'consum', 0.0218, 'lps'),
	(438173, 126, '2015-03-01 00:16:08.000000', 'consum', 0.0219, 'lps'),
	(438174, 126, '2015-03-01 00:16:09.000000', 'consum', 0.0230, 'lps'),
	(438175, 126, '2015-03-01 00:16:10.000000', 'consum', 0.0224, 'lps'),
	(438176, 126, '2015-03-01 00:16:11.000000', 'consum', 0.0217, 'lps'),
	(438177, 126, '2015-03-01 00:16:12.000000', 'consum', 0.0227, 'lps'),
	(438178, 126, '2015-03-01 00:16:13.000000', 'consum', 0.0210, 'lps'),
	(438179, 126, '2015-03-01 00:16:14.000000', 'consum', 0.0222, 'lps'),
	(438180, 126, '2015-03-01 00:16:15.000000', 'consum', 0.0229, 'lps'),
	(438181, 126, '2015-03-01 00:16:16.000000', 'consum', 0.0230, 'lps'),
	(438182, 126, '2015-03-01 00:16:17.000000', 'consum', 0.0229, 'lps'),
	(438183, 126, '2015-03-01 00:16:18.000000', 'consum', 0.0227, 'lps'),
	(438184, 126, '2015-03-01 00:16:19.000000', 'consum', 0.0217, 'lps'),
	(438185, 126, '2015-03-01 00:16:20.000000', 'consum', 0.0214, 'lps'),
	(438186, 126, '2015-03-01 00:16:21.000000', 'consum', 0.0210, 'lps'),
	(438187, 126, '2015-03-01 00:16:22.000000', 'consum', 0.0222, 'lps'),
	(438188, 126, '2015-03-01 00:16:23.000000', 'consum', 0.0226, 'lps'),
	(438189, 126, '2015-03-01 00:16:24.000000', 'consum', 0.0212, 'lps'),
	(438190, 126, '2015-03-01 00:16:25.000000', 'consum', 0.0217, 'lps'),
	(438191, 126, '2015-03-01 00:16:26.000000', 'consum', 0.0218, 'lps'),
	(438192, 126, '2015-03-01 00:16:27.000000', 'consum', 0.0227, 'lps'),
	(438193, 126, '2015-03-01 00:16:28.000000', 'consum', 0.0212, 'lps'),
	(438194, 126, '2015-03-01 00:16:29.000000', 'consum', 0.0210, 'lps'),
	(438195, 126, '2015-03-01 00:16:30.000000', 'consum', 0.0225, 'lps'),
	(438196, 126, '2015-03-01 00:16:31.000000', 'consum', 0.0223, 'lps'),
	(438197, 126, '2015-03-01 00:16:32.000000', 'consum', 0.0230, 'lps'),
	(438198, 126, '2015-03-01 00:16:33.000000', 'consum', 0.0229, 'lps'),
	(438199, 126, '2015-03-01 00:16:34.000000', 'consum', 0.0225, 'lps'),
	(438200, 126, '2015-03-01 00:16:35.000000', 'consum', 0.0229, 'lps'),
	(438201, 126, '2015-03-01 00:16:36.000000', 'consum', 0.0220, 'lps'),
	(438202, 126, '2015-03-01 00:16:37.000000', 'consum', 0.0224, 'lps'),
	(438203, 126, '2015-03-01 00:16:38.000000', 'consum', 0.0228, 'lps'),
	(438204, 126, '2015-03-01 00:16:39.000000', 'consum', 0.0219, 'lps'),
	(438205, 126, '2015-03-01 00:16:40.000000', 'consum', 0.0219, 'lps'),
	(438206, 126, '2015-03-01 00:16:41.000000', 'consum', 0.0210, 'lps'),
	(438207, 126, '2015-03-01 00:16:42.000000', 'consum', 0.0226, 'lps'),
	(438208, 126, '2015-03-01 00:16:43.000000', 'consum', 0.0228, 'lps'),
	(438209, 126, '2015-03-01 00:16:44.000000', 'consum', 0.0212, 'lps'),
	(438210, 126, '2015-03-01 00:16:45.000000', 'consum', 0.0226, 'lps'),
	(438211, 126, '2015-03-01 00:16:46.000000', 'consum', 0.0224, 'lps'),
	(438212, 126, '2015-03-01 00:16:47.000000', 'consum', 0.0210, 'lps'),
	(438213, 126, '2015-03-01 00:16:48.000000', 'consum', 0.0210, 'lps'),
	(438214, 126, '2015-03-01 00:16:49.000000', 'consum', 0.0213, 'lps'),
	(438215, 126, '2015-03-01 00:16:50.000000', 'consum', 0.0223, 'lps'),
	(438216, 126, '2015-03-01 00:16:51.000000', 'consum', 0.0224, 'lps'),
	(438217, 126, '2015-03-01 00:16:52.000000', 'consum', 0.0220, 'lps'),
	(438218, 126, '2015-03-01 00:16:53.000000', 'consum', 0.0220, 'lps'),
	(438219, 126, '2015-03-01 00:16:54.000000', 'consum', 0.0230, 'lps'),
	(438220, 126, '2015-03-01 00:16:55.000000', 'consum', 0.0216, 'lps'),
	(438221, 126, '2015-03-01 00:16:56.000000', 'consum', 0.0222, 'lps'),
	(438222, 126, '2015-03-01 00:16:57.000000', 'consum', 0.0210, 'lps'),
	(438223, 126, '2015-03-01 00:16:58.000000', 'consum', 0.0216, 'lps'),
	(438224, 126, '2015-03-01 00:16:59.000000', 'consum', 0.0220, 'lps'),
	(438225, 126, '2015-03-01 00:17:00.000000', 'consum', 0.0224, 'lps'),
	(438226, 126, '2015-03-01 00:17:01.000000', 'consum', 0.0226, 'lps'),
	(438227, 126, '2015-03-01 00:17:02.000000', 'consum', 0.0229, 'lps'),
	(438228, 126, '2015-03-01 00:17:03.000000', 'consum', 0.0216, 'lps'),
	(438229, 126, '2015-03-01 00:17:04.000000', 'consum', 0.0226, 'lps'),
	(438230, 126, '2015-03-01 00:17:05.000000', 'consum', 0.0210, 'lps'),
	(438231, 126, '2015-03-01 00:17:06.000000', 'consum', 0.0224, 'lps'),
	(438232, 126, '2015-03-01 00:17:07.000000', 'consum', 0.0218, 'lps'),
	(438233, 126, '2015-03-01 00:17:08.000000', 'consum', 0.0211, 'lps'),
	(438234, 126, '2015-03-01 00:17:09.000000', 'consum', 0.0230, 'lps'),
	(438235, 126, '2015-03-01 00:17:10.000000', 'consum', 0.0224, 'lps'),
	(438236, 126, '2015-03-01 00:17:11.000000', 'consum', 0.0221, 'lps'),
	(438237, 126, '2015-03-01 00:17:12.000000', 'consum', 0.0223, 'lps'),
	(438238, 126, '2015-03-01 00:17:13.000000', 'consum', 0.0223, 'lps'),
	(438239, 126, '2015-03-01 00:17:14.000000', 'consum', 0.0216, 'lps'),
	(438240, 126, '2015-03-01 00:17:15.000000', 'consum', 0.0223, 'lps'),
	(438241, 126, '2015-03-01 00:17:16.000000', 'consum', 0.0213, 'lps'),
	(438242, 126, '2015-03-01 00:17:17.000000', 'consum', 0.0228, 'lps'),
	(438243, 126, '2015-03-01 00:17:18.000000', 'consum', 0.0230, 'lps'),
	(438244, 126, '2015-03-01 00:17:19.000000', 'consum', 0.0212, 'lps'),
	(438245, 126, '2015-03-01 00:17:20.000000', 'consum', 0.0226, 'lps'),
	(438246, 126, '2015-03-01 00:17:21.000000', 'consum', 0.0220, 'lps'),
	(438247, 126, '2015-03-01 00:17:22.000000', 'consum', 0.0214, 'lps'),
	(438248, 126, '2015-03-01 00:17:23.000000', 'consum', 0.0223, 'lps'),
	(438249, 126, '2015-03-01 00:17:24.000000', 'consum', 0.0219, 'lps'),
	(438250, 126, '2015-03-01 00:17:25.000000', 'consum', 0.0216, 'lps'),
	(438251, 126, '2015-03-01 00:17:26.000000', 'consum', 0.0212, 'lps'),
	(438252, 126, '2015-03-01 00:17:27.000000', 'consum', 0.0226, 'lps'),
	(438253, 126, '2015-03-01 00:17:28.000000', 'consum', 0.0221, 'lps'),
	(438254, 126, '2015-03-01 00:17:29.000000', 'consum', 0.0219, 'lps'),
	(438255, 126, '2015-03-01 00:17:30.000000', 'consum', 0.0220, 'lps'),
	(438256, 126, '2015-03-01 00:17:31.000000', 'consum', 0.0215, 'lps'),
	(438257, 126, '2015-03-01 00:17:32.000000', 'consum', 0.0225, 'lps'),
	(438258, 126, '2015-03-01 00:17:33.000000', 'consum', 0.0228, 'lps'),
	(438259, 126, '2015-03-01 00:17:34.000000', 'consum', 0.0214, 'lps'),
	(438260, 126, '2015-03-01 00:17:35.000000', 'consum', 0.0218, 'lps'),
	(438261, 126, '2015-03-01 00:17:36.000000', 'consum', 0.0217, 'lps'),
	(438262, 126, '2015-03-01 00:17:37.000000', 'consum', 0.0221, 'lps'),
	(438263, 126, '2015-03-01 00:17:38.000000', 'consum', 0.0225, 'lps'),
	(438264, 126, '2015-03-01 00:17:39.000000', 'consum', 0.0210, 'lps'),
	(438265, 126, '2015-03-01 00:17:40.000000', 'consum', 0.0227, 'lps'),
	(438266, 126, '2015-03-01 00:17:41.000000', 'consum', 0.0211, 'lps'),
	(438267, 126, '2015-03-01 00:17:42.000000', 'consum', 0.0227, 'lps'),
	(438268, 126, '2015-03-01 00:17:43.000000', 'consum', 0.0212, 'lps'),
	(438269, 126, '2015-03-01 00:17:44.000000', 'consum', 0.0229, 'lps'),
	(438270, 126, '2015-03-01 00:17:45.000000', 'consum', 0.0217, 'lps'),
	(438271, 126, '2015-03-01 00:17:46.000000', 'consum', 0.0211, 'lps'),
	(438272, 126, '2015-03-01 00:17:47.000000', 'consum', 0.0213, 'lps'),
	(438273, 126, '2015-03-01 00:17:48.000000', 'consum', 0.0223, 'lps'),
	(438274, 126, '2015-03-01 00:17:49.000000', 'consum', 0.0225, 'lps'),
	(438275, 126, '2015-03-01 00:17:50.000000', 'consum', 0.0225, 'lps'),
	(438276, 126, '2015-03-01 00:17:51.000000', 'consum', 0.0219, 'lps'),
	(438277, 126, '2015-03-01 00:17:52.000000', 'consum', 0.0210, 'lps'),
	(438278, 126, '2015-03-01 00:17:53.000000', 'consum', 0.0226, 'lps'),
	(438279, 126, '2015-03-01 00:17:54.000000', 'consum', 0.0227, 'lps'),
	(438280, 126, '2015-03-01 00:17:55.000000', 'consum', 0.0226, 'lps'),
	(438281, 126, '2015-03-01 00:17:56.000000', 'consum', 0.0219, 'lps'),
	(438282, 126, '2015-03-01 00:17:57.000000', 'consum', 0.0228, 'lps'),
	(438283, 126, '2015-03-01 00:17:58.000000', 'consum', 0.0212, 'lps'),
	(438284, 126, '2015-03-01 00:17:59.000000', 'consum', 0.0230, 'lps'),
	(438285, 126, '2015-03-01 00:18:00.000000', 'consum', 0.0220, 'lps'),
	(438286, 126, '2015-03-01 00:18:01.000000', 'consum', 0.0220, 'lps'),
	(438287, 126, '2015-03-01 00:18:02.000000', 'consum', 0.0212, 'lps'),
	(438288, 126, '2015-03-01 00:18:03.000000', 'consum', 0.0230, 'lps'),
	(438289, 126, '2015-03-01 00:18:04.000000', 'consum', 0.0222, 'lps'),
	(438290, 126, '2015-03-01 00:18:05.000000', 'consum', 0.0211, 'lps'),
	(438291, 126, '2015-03-01 00:18:06.000000', 'consum', 0.0221, 'lps'),
	(438292, 126, '2015-03-01 00:18:07.000000', 'consum', 0.0219, 'lps'),
	(438293, 126, '2015-03-01 00:18:08.000000', 'consum', 0.0225, 'lps'),
	(438294, 126, '2015-03-01 00:18:09.000000', 'consum', 0.0216, 'lps'),
	(438295, 126, '2015-03-01 00:18:10.000000', 'consum', 0.0218, 'lps'),
	(438296, 126, '2015-03-01 00:18:11.000000', 'consum', 0.0210, 'lps'),
	(438297, 126, '2015-03-01 00:18:12.000000', 'consum', 0.0229, 'lps'),
	(438298, 126, '2015-03-01 00:18:13.000000', 'consum', 0.0221, 'lps'),
	(438299, 126, '2015-03-01 00:18:14.000000', 'consum', 0.0229, 'lps'),
	(438300, 126, '2015-03-01 00:18:15.000000', 'consum', 0.0230, 'lps'),
	(438301, 126, '2015-03-01 00:18:16.000000', 'consum', 0.0211, 'lps'),
	(438302, 126, '2015-03-01 00:18:17.000000', 'consum', 0.0219, 'lps'),
	(438303, 126, '2015-03-01 00:18:18.000000', 'consum', 0.0212, 'lps'),
	(438304, 126, '2015-03-01 00:18:19.000000', 'consum', 0.0214, 'lps'),
	(438305, 126, '2015-03-01 00:18:20.000000', 'consum', 0.0225, 'lps'),
	(438306, 126, '2015-03-01 00:18:21.000000', 'consum', 0.0229, 'lps'),
	(438307, 126, '2015-03-01 00:18:22.000000', 'consum', 0.0220, 'lps'),
	(438308, 126, '2015-03-01 00:18:23.000000', 'consum', 0.0225, 'lps'),
	(438309, 126, '2015-03-01 00:18:24.000000', 'consum', 0.0214, 'lps'),
	(438310, 126, '2015-03-01 00:18:25.000000', 'consum', 0.0228, 'lps'),
	(438311, 126, '2015-03-01 00:18:26.000000', 'consum', 0.0226, 'lps'),
	(438312, 126, '2015-03-01 00:18:27.000000', 'consum', 0.0213, 'lps'),
	(438313, 126, '2015-03-01 00:18:28.000000', 'consum', 0.0220, 'lps'),
	(438314, 126, '2015-03-01 00:18:29.000000', 'consum', 0.0230, 'lps'),
	(438315, 126, '2015-03-01 00:18:30.000000', 'consum', 0.0220, 'lps'),
	(438316, 126, '2015-03-01 00:18:31.000000', 'consum', 0.0221, 'lps'),
	(438317, 126, '2015-03-01 00:18:32.000000', 'consum', 0.0215, 'lps'),
	(438318, 126, '2015-03-01 00:18:33.000000', 'consum', 0.0223, 'lps'),
	(438319, 126, '2015-03-01 00:18:34.000000', 'consum', 0.0219, 'lps'),
	(438320, 126, '2015-03-01 00:18:35.000000', 'consum', 0.0217, 'lps'),
	(438321, 126, '2015-03-01 00:18:36.000000', 'consum', 0.0216, 'lps'),
	(438322, 126, '2015-03-01 00:18:37.000000', 'consum', 0.0221, 'lps'),
	(438323, 126, '2015-03-01 00:18:38.000000', 'consum', 0.0225, 'lps'),
	(438324, 126, '2015-03-01 00:18:39.000000', 'consum', 0.0211, 'lps'),
	(438325, 126, '2015-03-01 00:18:40.000000', 'consum', 0.0212, 'lps'),
	(438326, 126, '2015-03-01 00:18:41.000000', 'consum', 0.0217, 'lps'),
	(438327, 126, '2015-03-01 00:18:42.000000', 'consum', 0.0221, 'lps'),
	(438328, 126, '2015-03-01 00:18:43.000000', 'consum', 0.0221, 'lps'),
	(438329, 126, '2015-03-01 00:18:44.000000', 'consum', 0.0212, 'lps'),
	(438330, 126, '2015-03-01 00:18:45.000000', 'consum', 0.0230, 'lps'),
	(438331, 126, '2015-03-01 00:18:46.000000', 'consum', 0.0219, 'lps'),
	(438332, 126, '2015-03-01 00:18:47.000000', 'consum', 0.0217, 'lps'),
	(438333, 126, '2015-03-01 00:18:48.000000', 'consum', 0.0217, 'lps'),
	(438334, 126, '2015-03-01 00:18:49.000000', 'consum', 0.0226, 'lps'),
	(438335, 126, '2015-03-01 00:18:50.000000', 'consum', 0.0228, 'lps'),
	(438336, 126, '2015-03-01 00:18:51.000000', 'consum', 0.0229, 'lps'),
	(438337, 126, '2015-03-01 00:18:52.000000', 'consum', 0.0213, 'lps'),
	(438338, 126, '2015-03-01 00:18:53.000000', 'consum', 0.0230, 'lps'),
	(438339, 126, '2015-03-01 00:18:54.000000', 'consum', 0.0216, 'lps'),
	(438340, 126, '2015-03-01 00:18:55.000000', 'consum', 0.0224, 'lps'),
	(438341, 126, '2015-03-01 00:18:56.000000', 'consum', 0.0221, 'lps'),
	(438342, 126, '2015-03-01 00:18:57.000000', 'consum', 0.0223, 'lps'),
	(438343, 126, '2015-03-01 00:18:58.000000', 'consum', 0.0222, 'lps'),
	(438344, 126, '2015-03-01 00:18:59.000000', 'consum', 0.0229, 'lps'),
	(438345, 126, '2015-03-01 00:19:00.000000', 'consum', 0.0229, 'lps'),
	(438346, 126, '2015-03-01 00:19:01.000000', 'consum', 0.0228, 'lps'),
	(438347, 126, '2015-03-01 00:19:02.000000', 'consum', 0.0224, 'lps'),
	(438348, 126, '2015-03-01 00:19:03.000000', 'consum', 0.0225, 'lps'),
	(438349, 126, '2015-03-01 00:19:04.000000', 'consum', 0.0222, 'lps'),
	(438350, 126, '2015-03-01 00:19:05.000000', 'consum', 0.0225, 'lps'),
	(438351, 126, '2015-03-01 00:19:06.000000', 'consum', 0.0229, 'lps'),
	(438352, 126, '2015-03-01 00:19:07.000000', 'consum', 0.0217, 'lps'),
	(438353, 126, '2015-03-01 00:19:08.000000', 'consum', 0.0211, 'lps'),
	(438354, 126, '2015-03-01 00:19:09.000000', 'consum', 0.0216, 'lps'),
	(438355, 126, '2015-03-01 00:19:10.000000', 'consum', 0.0217, 'lps'),
	(438356, 126, '2015-03-01 00:19:11.000000', 'consum', 0.0228, 'lps'),
	(438357, 126, '2015-03-01 00:19:12.000000', 'consum', 0.0217, 'lps'),
	(438358, 126, '2015-03-01 00:19:13.000000', 'consum', 0.0213, 'lps'),
	(438359, 126, '2015-03-01 00:19:14.000000', 'consum', 0.0223, 'lps'),
	(438360, 126, '2015-03-01 00:19:15.000000', 'consum', 0.0224, 'lps'),
	(438361, 126, '2015-03-01 00:19:16.000000', 'consum', 0.0220, 'lps'),
	(438362, 126, '2015-03-01 00:19:17.000000', 'consum', 0.0219, 'lps'),
	(438363, 126, '2015-03-01 00:19:18.000000', 'consum', 0.0227, 'lps'),
	(438364, 126, '2015-03-01 00:19:19.000000', 'consum', 0.0224, 'lps'),
	(438365, 126, '2015-03-01 00:19:20.000000', 'consum', 0.0210, 'lps'),
	(438366, 126, '2015-03-01 00:19:21.000000', 'consum', 0.0210, 'lps'),
	(438367, 126, '2015-03-01 00:19:22.000000', 'consum', 0.0212, 'lps'),
	(438368, 126, '2015-03-01 00:19:23.000000', 'consum', 0.0219, 'lps'),
	(438369, 126, '2015-03-01 00:19:24.000000', 'consum', 0.0227, 'lps'),
	(438370, 126, '2015-03-01 00:19:25.000000', 'consum', 0.0227, 'lps'),
	(438371, 126, '2015-03-01 00:19:26.000000', 'consum', 0.0225, 'lps'),
	(438372, 126, '2015-03-01 00:19:27.000000', 'consum', 0.0215, 'lps'),
	(438373, 126, '2015-03-01 00:19:28.000000', 'consum', 0.0210, 'lps'),
	(438374, 126, '2015-03-01 00:19:29.000000', 'consum', 0.0216, 'lps'),
	(438375, 126, '2015-03-01 00:19:30.000000', 'consum', 0.0219, 'lps'),
	(438376, 126, '2015-03-01 00:19:31.000000', 'consum', 0.0218, 'lps'),
	(438377, 126, '2015-03-01 00:19:32.000000', 'consum', 0.0221, 'lps'),
	(438378, 126, '2015-03-01 00:19:33.000000', 'consum', 0.0221, 'lps'),
	(438379, 126, '2015-03-01 00:19:34.000000', 'consum', 0.0214, 'lps'),
	(438380, 126, '2015-03-01 00:19:35.000000', 'consum', 0.0216, 'lps'),
	(438381, 126, '2015-03-01 00:19:36.000000', 'consum', 0.0228, 'lps'),
	(438382, 126, '2015-03-01 00:19:37.000000', 'consum', 0.0219, 'lps'),
	(438383, 126, '2015-03-01 00:19:38.000000', 'consum', 0.0224, 'lps'),
	(438384, 126, '2015-03-01 00:19:39.000000', 'consum', 0.0212, 'lps'),
	(438385, 126, '2015-03-01 00:19:40.000000', 'consum', 0.0220, 'lps'),
	(438386, 126, '2015-03-01 00:19:41.000000', 'consum', 0.0213, 'lps'),
	(438387, 126, '2015-03-01 00:19:42.000000', 'consum', 0.0218, 'lps'),
	(438388, 126, '2015-03-01 00:19:43.000000', 'consum', 0.0218, 'lps'),
	(438389, 126, '2015-03-01 00:19:44.000000', 'consum', 0.0228, 'lps'),
	(438390, 126, '2015-03-01 00:19:45.000000', 'consum', 0.0212, 'lps'),
	(438391, 126, '2015-03-01 00:19:46.000000', 'consum', 0.0211, 'lps'),
	(438392, 126, '2015-03-01 00:19:47.000000', 'consum', 0.0228, 'lps'),
	(438393, 126, '2015-03-01 00:19:48.000000', 'consum', 0.0215, 'lps'),
	(438394, 126, '2015-03-01 00:19:49.000000', 'consum', 0.0222, 'lps'),
	(438395, 126, '2015-03-01 00:19:50.000000', 'consum', 0.0214, 'lps'),
	(438396, 126, '2015-03-01 00:19:51.000000', 'consum', 0.0216, 'lps'),
	(438397, 126, '2015-03-01 00:19:52.000000', 'consum', 0.0229, 'lps'),
	(438398, 126, '2015-03-01 00:19:53.000000', 'consum', 0.0226, 'lps'),
	(438399, 126, '2015-03-01 00:19:54.000000', 'consum', 0.0211, 'lps'),
	(438400, 126, '2015-03-01 00:19:55.000000', 'consum', 0.0229, 'lps'),
	(438401, 126, '2015-03-01 00:19:56.000000', 'consum', 0.0219, 'lps'),
	(438402, 126, '2015-03-01 00:19:57.000000', 'consum', 0.0219, 'lps'),
	(438403, 126, '2015-03-01 00:19:58.000000', 'consum', 0.0228, 'lps'),
	(438404, 126, '2015-03-01 00:19:59.000000', 'consum', 0.0212, 'lps'),
	(438405, 126, '2015-03-01 00:20:00.000000', 'consum', 0.0227, 'lps'),
	(438406, 126, '2015-03-01 00:20:01.000000', 'consum', 0.0229, 'lps'),
	(438407, 126, '2015-03-01 00:20:02.000000', 'consum', 0.0212, 'lps'),
	(438408, 126, '2015-03-01 00:20:03.000000', 'consum', 0.0228, 'lps'),
	(438409, 126, '2015-03-01 00:20:04.000000', 'consum', 0.0230, 'lps'),
	(438410, 126, '2015-03-01 00:20:05.000000', 'consum', 0.0217, 'lps'),
	(438411, 126, '2015-03-01 00:20:06.000000', 'consum', 0.0224, 'lps'),
	(438412, 126, '2015-03-01 00:20:07.000000', 'consum', 0.0219, 'lps'),
	(438413, 126, '2015-03-01 00:20:08.000000', 'consum', 0.0214, 'lps'),
	(438414, 126, '2015-03-01 00:20:09.000000', 'consum', 0.0225, 'lps'),
	(438415, 126, '2015-03-01 00:20:10.000000', 'consum', 0.0212, 'lps'),
	(438416, 126, '2015-03-01 00:20:11.000000', 'consum', 0.0216, 'lps'),
	(438417, 126, '2015-03-01 00:20:12.000000', 'consum', 0.0213, 'lps'),
	(438418, 126, '2015-03-01 00:20:13.000000', 'consum', 0.0229, 'lps'),
	(438419, 126, '2015-03-01 00:20:14.000000', 'consum', 0.0214, 'lps'),
	(438420, 126, '2015-03-01 00:20:15.000000', 'consum', 0.0216, 'lps'),
	(438421, 126, '2015-03-01 00:20:16.000000', 'consum', 0.0228, 'lps'),
	(438422, 126, '2015-03-01 00:20:17.000000', 'consum', 0.0218, 'lps'),
	(438423, 126, '2015-03-01 00:20:18.000000', 'consum', 0.0217, 'lps'),
	(438424, 126, '2015-03-01 00:20:19.000000', 'consum', 0.0221, 'lps'),
	(438425, 126, '2015-03-01 00:20:20.000000', 'consum', 0.0226, 'lps'),
	(438426, 126, '2015-03-01 00:20:21.000000', 'consum', 0.0215, 'lps'),
	(438427, 126, '2015-03-01 00:20:22.000000', 'consum', 0.0210, 'lps'),
	(438428, 126, '2015-03-01 00:20:23.000000', 'consum', 0.0214, 'lps'),
	(438429, 126, '2015-03-01 00:20:24.000000', 'consum', 0.0230, 'lps'),
	(438430, 126, '2015-03-01 00:20:25.000000', 'consum', 0.0217, 'lps'),
	(438431, 126, '2015-03-01 00:20:26.000000', 'consum', 0.0226, 'lps'),
	(438432, 126, '2015-03-01 00:20:27.000000', 'consum', 0.0228, 'lps'),
	(438433, 126, '2015-03-01 00:20:28.000000', 'consum', 0.0210, 'lps'),
	(438434, 126, '2015-03-01 00:20:29.000000', 'consum', 0.0220, 'lps'),
	(438435, 126, '2015-03-01 00:20:30.000000', 'consum', 0.0218, 'lps'),
	(438436, 126, '2015-03-01 00:20:31.000000', 'consum', 0.0221, 'lps'),
	(438437, 126, '2015-03-01 00:20:32.000000', 'consum', 0.0218, 'lps'),
	(438438, 126, '2015-03-01 00:20:33.000000', 'consum', 0.0221, 'lps'),
	(438439, 126, '2015-03-01 00:20:34.000000', 'consum', 0.0219, 'lps'),
	(438440, 126, '2015-03-01 00:20:35.000000', 'consum', 0.0222, 'lps'),
	(438441, 126, '2015-03-01 00:20:36.000000', 'consum', 0.0224, 'lps'),
	(438442, 126, '2015-03-01 00:20:37.000000', 'consum', 0.0223, 'lps'),
	(438443, 126, '2015-03-01 00:20:38.000000', 'consum', 0.0213, 'lps'),
	(438444, 126, '2015-03-01 00:20:39.000000', 'consum', 0.0229, 'lps'),
	(438445, 126, '2015-03-01 00:20:40.000000', 'consum', 0.0211, 'lps'),
	(438446, 126, '2015-03-01 00:20:41.000000', 'consum', 0.0222, 'lps'),
	(438447, 126, '2015-03-01 00:20:42.000000', 'consum', 0.0226, 'lps'),
	(438448, 126, '2015-03-01 00:20:43.000000', 'consum', 0.0212, 'lps'),
	(438449, 126, '2015-03-01 00:20:44.000000', 'consum', 0.0213, 'lps'),
	(438450, 126, '2015-03-01 00:20:45.000000', 'consum', 0.0223, 'lps'),
	(438451, 126, '2015-03-01 00:20:46.000000', 'consum', 0.0222, 'lps'),
	(438452, 126, '2015-03-01 00:20:47.000000', 'consum', 0.0210, 'lps'),
	(438453, 126, '2015-03-01 00:20:48.000000', 'consum', 0.0217, 'lps'),
	(438454, 126, '2015-03-01 00:20:49.000000', 'consum', 0.0225, 'lps'),
	(438455, 126, '2015-03-01 00:20:50.000000', 'consum', 0.0224, 'lps'),
	(438456, 126, '2015-03-01 00:20:51.000000', 'consum', 0.0215, 'lps'),
	(438457, 126, '2015-03-01 00:20:52.000000', 'consum', 0.0212, 'lps'),
	(438458, 126, '2015-03-01 00:20:53.000000', 'consum', 0.0226, 'lps'),
	(438459, 126, '2015-03-01 00:20:54.000000', 'consum', 0.0223, 'lps'),
	(438460, 126, '2015-03-01 00:20:55.000000', 'consum', 0.0229, 'lps'),
	(438461, 126, '2015-03-01 00:20:56.000000', 'consum', 0.0224, 'lps'),
	(438462, 126, '2015-03-01 00:20:57.000000', 'consum', 0.0223, 'lps'),
	(438463, 126, '2015-03-01 00:20:58.000000', 'consum', 0.0213, 'lps'),
	(438464, 126, '2015-03-01 00:20:59.000000', 'consum', 0.0228, 'lps'),
	(438465, 126, '2015-03-01 00:21:00.000000', 'consum', 0.0229, 'lps'),
	(438466, 126, '2015-03-01 00:21:01.000000', 'consum', 0.0211, 'lps'),
	(438467, 126, '2015-03-01 00:21:02.000000', 'consum', 0.0219, 'lps'),
	(438468, 126, '2015-03-01 00:21:03.000000', 'consum', 0.0211, 'lps'),
	(438469, 126, '2015-03-01 00:21:04.000000', 'consum', 0.0210, 'lps'),
	(438470, 126, '2015-03-01 00:21:05.000000', 'consum', 0.0227, 'lps'),
	(438471, 126, '2015-03-01 00:21:06.000000', 'consum', 0.0215, 'lps'),
	(438472, 126, '2015-03-01 00:21:07.000000', 'consum', 0.0223, 'lps'),
	(438473, 126, '2015-03-01 00:21:08.000000', 'consum', 0.0218, 'lps'),
	(438474, 126, '2015-03-01 00:21:09.000000', 'consum', 0.0213, 'lps'),
	(438475, 126, '2015-03-01 00:21:10.000000', 'consum', 0.0224, 'lps'),
	(438476, 126, '2015-03-01 00:21:11.000000', 'consum', 0.0228, 'lps'),
	(438477, 126, '2015-03-01 00:21:12.000000', 'consum', 0.0215, 'lps'),
	(438478, 126, '2015-03-01 00:21:13.000000', 'consum', 0.0226, 'lps'),
	(438479, 126, '2015-03-01 00:21:14.000000', 'consum', 0.0211, 'lps'),
	(438480, 126, '2015-03-01 00:21:15.000000', 'consum', 0.0230, 'lps'),
	(438481, 126, '2015-03-01 00:21:16.000000', 'consum', 0.0224, 'lps'),
	(438482, 126, '2015-03-01 00:21:17.000000', 'consum', 0.0220, 'lps'),
	(438483, 126, '2015-03-01 00:21:18.000000', 'consum', 0.0218, 'lps'),
	(438484, 126, '2015-03-01 00:21:19.000000', 'consum', 0.0220, 'lps'),
	(438485, 126, '2015-03-01 00:21:20.000000', 'consum', 0.0214, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(438486, 126, '2015-03-01 00:21:21.000000', 'consum', 0.0224, 'lps'),
	(438487, 126, '2015-03-01 00:21:22.000000', 'consum', 0.0226, 'lps'),
	(438488, 126, '2015-03-01 00:21:23.000000', 'consum', 0.0229, 'lps'),
	(438489, 126, '2015-03-01 00:21:24.000000', 'consum', 0.0213, 'lps'),
	(438490, 126, '2015-03-01 00:21:25.000000', 'consum', 0.0212, 'lps'),
	(438491, 126, '2015-03-01 00:21:26.000000', 'consum', 0.0211, 'lps'),
	(438492, 126, '2015-03-01 00:21:27.000000', 'consum', 0.0210, 'lps'),
	(438493, 126, '2015-03-01 00:21:28.000000', 'consum', 0.0229, 'lps'),
	(438494, 126, '2015-03-01 00:21:29.000000', 'consum', 0.0220, 'lps'),
	(438495, 126, '2015-03-01 00:21:30.000000', 'consum', 0.0225, 'lps'),
	(438496, 126, '2015-03-01 00:21:31.000000', 'consum', 0.0213, 'lps'),
	(438497, 126, '2015-03-01 00:21:32.000000', 'consum', 0.0222, 'lps'),
	(438498, 126, '2015-03-01 00:21:33.000000', 'consum', 0.0221, 'lps'),
	(438499, 126, '2015-03-01 00:21:34.000000', 'consum', 0.0227, 'lps'),
	(438500, 126, '2015-03-01 00:21:35.000000', 'consum', 0.0222, 'lps'),
	(438501, 126, '2015-03-01 00:21:36.000000', 'consum', 0.0220, 'lps'),
	(438502, 126, '2015-03-01 00:21:37.000000', 'consum', 0.0224, 'lps'),
	(438503, 126, '2015-03-01 00:21:38.000000', 'consum', 0.0229, 'lps'),
	(438504, 126, '2015-03-01 00:21:39.000000', 'consum', 0.0223, 'lps'),
	(438505, 126, '2015-03-01 00:21:40.000000', 'consum', 0.0219, 'lps'),
	(438506, 126, '2015-03-01 00:21:41.000000', 'consum', 0.0216, 'lps'),
	(438507, 126, '2015-03-01 00:21:42.000000', 'consum', 0.0215, 'lps'),
	(438508, 126, '2015-03-01 00:21:43.000000', 'consum', 0.0217, 'lps'),
	(438509, 126, '2015-03-01 00:21:44.000000', 'consum', 0.0230, 'lps'),
	(438510, 126, '2015-03-01 00:21:45.000000', 'consum', 0.0228, 'lps'),
	(438511, 126, '2015-03-01 00:21:46.000000', 'consum', 0.0218, 'lps'),
	(438512, 126, '2015-03-01 00:21:47.000000', 'consum', 0.0216, 'lps'),
	(438513, 126, '2015-03-01 00:21:48.000000', 'consum', 0.0218, 'lps'),
	(438514, 126, '2015-03-01 00:21:49.000000', 'consum', 0.0212, 'lps'),
	(438515, 126, '2015-03-01 00:21:50.000000', 'consum', 0.0218, 'lps'),
	(438516, 126, '2015-03-01 00:21:51.000000', 'consum', 0.0225, 'lps'),
	(438517, 126, '2015-03-01 00:21:52.000000', 'consum', 0.0217, 'lps'),
	(438518, 126, '2015-03-01 00:21:53.000000', 'consum', 0.0223, 'lps'),
	(438519, 126, '2015-03-01 00:21:54.000000', 'consum', 0.0211, 'lps'),
	(438520, 126, '2015-03-01 00:21:55.000000', 'consum', 0.0220, 'lps'),
	(438521, 126, '2015-03-01 00:21:56.000000', 'consum', 0.0216, 'lps'),
	(438522, 126, '2015-03-01 00:21:57.000000', 'consum', 0.0229, 'lps'),
	(438523, 126, '2015-03-01 00:21:58.000000', 'consum', 0.0228, 'lps'),
	(438524, 126, '2015-03-01 00:21:59.000000', 'consum', 0.0220, 'lps'),
	(438525, 126, '2015-03-01 00:22:00.000000', 'consum', 0.0228, 'lps'),
	(438526, 126, '2015-03-01 00:22:01.000000', 'consum', 0.0229, 'lps'),
	(438527, 126, '2015-03-01 00:22:02.000000', 'consum', 0.0230, 'lps'),
	(438528, 126, '2015-03-01 00:22:03.000000', 'consum', 0.0210, 'lps'),
	(438529, 126, '2015-03-01 00:22:04.000000', 'consum', 0.0214, 'lps'),
	(438530, 126, '2015-03-01 00:22:05.000000', 'consum', 0.0229, 'lps'),
	(438531, 126, '2015-03-01 00:22:06.000000', 'consum', 0.0212, 'lps'),
	(438532, 126, '2015-03-01 00:22:07.000000', 'consum', 0.0228, 'lps'),
	(438533, 126, '2015-03-01 00:22:08.000000', 'consum', 0.0229, 'lps'),
	(438534, 126, '2015-03-01 00:22:09.000000', 'consum', 0.0210, 'lps'),
	(438535, 126, '2015-03-01 00:22:10.000000', 'consum', 0.0215, 'lps'),
	(438536, 126, '2015-03-01 00:22:11.000000', 'consum', 0.0217, 'lps'),
	(438537, 126, '2015-03-01 00:22:12.000000', 'consum', 0.0229, 'lps'),
	(438538, 126, '2015-03-01 00:22:13.000000', 'consum', 0.0224, 'lps'),
	(438539, 126, '2015-03-01 00:22:14.000000', 'consum', 0.0220, 'lps'),
	(438540, 126, '2015-03-01 00:22:15.000000', 'consum', 0.0221, 'lps'),
	(438541, 126, '2015-03-01 00:22:16.000000', 'consum', 0.0215, 'lps'),
	(438542, 126, '2015-03-01 00:22:17.000000', 'consum', 0.0224, 'lps'),
	(438543, 126, '2015-03-01 00:22:18.000000', 'consum', 0.0222, 'lps'),
	(438544, 126, '2015-03-01 00:22:19.000000', 'consum', 0.0229, 'lps'),
	(438545, 126, '2015-03-01 00:22:20.000000', 'consum', 0.0229, 'lps'),
	(438546, 126, '2015-03-01 00:22:21.000000', 'consum', 0.0225, 'lps'),
	(438547, 126, '2015-03-01 00:22:22.000000', 'consum', 0.0228, 'lps'),
	(438548, 126, '2015-03-01 00:22:23.000000', 'consum', 0.0215, 'lps'),
	(438549, 126, '2015-03-01 00:22:24.000000', 'consum', 0.0222, 'lps'),
	(438550, 126, '2015-03-01 00:22:25.000000', 'consum', 0.0213, 'lps'),
	(438551, 126, '2015-03-01 00:22:26.000000', 'consum', 0.0213, 'lps'),
	(438552, 126, '2015-03-01 00:22:27.000000', 'consum', 0.0217, 'lps'),
	(438553, 126, '2015-03-01 00:22:28.000000', 'consum', 0.0216, 'lps'),
	(438554, 126, '2015-03-01 00:22:29.000000', 'consum', 0.0219, 'lps'),
	(438555, 126, '2015-03-01 00:22:30.000000', 'consum', 0.0216, 'lps'),
	(438556, 126, '2015-03-01 00:22:31.000000', 'consum', 0.0212, 'lps'),
	(438557, 126, '2015-03-01 00:22:32.000000', 'consum', 0.0223, 'lps'),
	(438558, 126, '2015-03-01 00:22:33.000000', 'consum', 0.0227, 'lps'),
	(438559, 126, '2015-03-01 00:22:34.000000', 'consum', 0.0217, 'lps'),
	(438560, 126, '2015-03-01 00:22:35.000000', 'consum', 0.0216, 'lps'),
	(438561, 126, '2015-03-01 00:22:36.000000', 'consum', 0.0219, 'lps'),
	(438562, 126, '2015-03-01 00:22:37.000000', 'consum', 0.0217, 'lps'),
	(438563, 126, '2015-03-01 00:22:38.000000', 'consum', 0.0220, 'lps'),
	(438564, 126, '2015-03-01 00:22:39.000000', 'consum', 0.0215, 'lps'),
	(438565, 126, '2015-03-01 00:22:40.000000', 'consum', 0.0230, 'lps'),
	(438566, 126, '2015-03-01 00:22:41.000000', 'consum', 0.0210, 'lps'),
	(438567, 126, '2015-03-01 00:22:42.000000', 'consum', 0.0214, 'lps'),
	(438568, 126, '2015-03-01 00:22:43.000000', 'consum', 0.0211, 'lps'),
	(438569, 126, '2015-03-01 00:22:44.000000', 'consum', 0.0223, 'lps'),
	(438570, 126, '2015-03-01 00:22:45.000000', 'consum', 0.0230, 'lps'),
	(438571, 126, '2015-03-01 00:22:46.000000', 'consum', 0.0210, 'lps'),
	(438572, 126, '2015-03-01 00:22:47.000000', 'consum', 0.0213, 'lps'),
	(438573, 126, '2015-03-01 00:22:48.000000', 'consum', 0.0224, 'lps'),
	(438574, 126, '2015-03-01 00:22:49.000000', 'consum', 0.0210, 'lps'),
	(438575, 126, '2015-03-01 00:22:50.000000', 'consum', 0.0230, 'lps'),
	(438576, 126, '2015-03-01 00:22:51.000000', 'consum', 0.0229, 'lps'),
	(438577, 126, '2015-03-01 00:22:52.000000', 'consum', 0.0222, 'lps'),
	(438578, 126, '2015-03-01 00:22:53.000000', 'consum', 0.0215, 'lps'),
	(438579, 126, '2015-03-01 00:22:54.000000', 'consum', 0.0222, 'lps'),
	(438580, 126, '2015-03-01 00:22:55.000000', 'consum', 0.0210, 'lps'),
	(438581, 126, '2015-03-01 00:22:56.000000', 'consum', 0.0220, 'lps'),
	(438582, 126, '2015-03-01 00:22:57.000000', 'consum', 0.0217, 'lps'),
	(438583, 126, '2015-03-01 00:22:58.000000', 'consum', 0.0216, 'lps'),
	(438584, 126, '2015-03-01 00:22:59.000000', 'consum', 0.0217, 'lps'),
	(438585, 126, '2015-03-01 00:23:00.000000', 'consum', 0.0230, 'lps'),
	(438586, 126, '2015-03-01 00:23:01.000000', 'consum', 0.0225, 'lps'),
	(438587, 126, '2015-03-01 00:23:02.000000', 'consum', 0.0224, 'lps'),
	(438588, 126, '2015-03-01 00:23:03.000000', 'consum', 0.0217, 'lps'),
	(438589, 126, '2015-03-01 00:23:04.000000', 'consum', 0.0225, 'lps'),
	(438590, 126, '2015-03-01 00:23:05.000000', 'consum', 0.0221, 'lps'),
	(438591, 126, '2015-03-01 00:23:06.000000', 'consum', 0.0222, 'lps'),
	(438592, 126, '2015-03-01 00:23:07.000000', 'consum', 0.0214, 'lps'),
	(438593, 126, '2015-03-01 00:23:08.000000', 'consum', 0.0217, 'lps'),
	(438594, 126, '2015-03-01 00:23:09.000000', 'consum', 0.0210, 'lps'),
	(438595, 126, '2015-03-01 00:23:10.000000', 'consum', 0.0214, 'lps'),
	(438596, 126, '2015-03-01 00:23:11.000000', 'consum', 0.0228, 'lps'),
	(438597, 126, '2015-03-01 00:23:12.000000', 'consum', 0.0225, 'lps'),
	(438598, 126, '2015-03-01 00:23:13.000000', 'consum', 0.0211, 'lps'),
	(438599, 126, '2015-03-01 00:23:14.000000', 'consum', 0.0214, 'lps'),
	(438600, 126, '2015-03-01 00:23:15.000000', 'consum', 0.0226, 'lps'),
	(438601, 126, '2015-03-01 00:23:16.000000', 'consum', 0.0214, 'lps'),
	(438602, 126, '2015-03-01 00:23:17.000000', 'consum', 0.0228, 'lps'),
	(438603, 126, '2015-03-01 00:23:18.000000', 'consum', 0.0222, 'lps'),
	(438604, 126, '2015-03-01 00:23:19.000000', 'consum', 0.0220, 'lps'),
	(438605, 126, '2015-03-01 00:23:20.000000', 'consum', 0.0221, 'lps'),
	(438606, 126, '2015-03-01 00:23:21.000000', 'consum', 0.0218, 'lps'),
	(438607, 126, '2015-03-01 00:23:22.000000', 'consum', 0.0214, 'lps'),
	(438608, 126, '2015-03-01 00:23:23.000000', 'consum', 0.0229, 'lps'),
	(438609, 126, '2015-03-01 00:23:24.000000', 'consum', 0.0210, 'lps'),
	(438610, 126, '2015-03-01 00:23:25.000000', 'consum', 0.0215, 'lps'),
	(438611, 126, '2015-03-01 00:23:26.000000', 'consum', 0.0217, 'lps'),
	(438612, 126, '2015-03-01 00:23:27.000000', 'consum', 0.0228, 'lps'),
	(438613, 126, '2015-03-01 00:23:28.000000', 'consum', 0.0218, 'lps'),
	(438614, 126, '2015-03-01 00:23:29.000000', 'consum', 0.0219, 'lps'),
	(438615, 126, '2015-03-01 00:23:30.000000', 'consum', 0.0229, 'lps'),
	(438616, 126, '2015-03-01 00:23:31.000000', 'consum', 0.0218, 'lps'),
	(438617, 126, '2015-03-01 00:23:32.000000', 'consum', 0.0212, 'lps'),
	(438618, 126, '2015-03-01 00:23:33.000000', 'consum', 0.0219, 'lps'),
	(438619, 126, '2015-03-01 00:23:34.000000', 'consum', 0.0230, 'lps'),
	(438620, 126, '2015-03-01 00:23:35.000000', 'consum', 0.0220, 'lps'),
	(438621, 126, '2015-03-01 00:23:36.000000', 'consum', 0.0220, 'lps'),
	(438622, 126, '2015-03-01 00:23:37.000000', 'consum', 0.0212, 'lps'),
	(438623, 126, '2015-03-01 00:23:38.000000', 'consum', 0.0211, 'lps'),
	(438624, 126, '2015-03-01 00:23:39.000000', 'consum', 0.0230, 'lps'),
	(438625, 126, '2015-03-01 00:23:40.000000', 'consum', 0.0224, 'lps'),
	(438626, 126, '2015-03-01 00:23:41.000000', 'consum', 0.0219, 'lps'),
	(438627, 126, '2015-03-01 00:23:42.000000', 'consum', 0.0216, 'lps'),
	(438628, 126, '2015-03-01 00:23:43.000000', 'consum', 0.0212, 'lps'),
	(438629, 126, '2015-03-01 00:23:44.000000', 'consum', 0.0222, 'lps'),
	(438630, 126, '2015-03-01 00:23:45.000000', 'consum', 0.0223, 'lps'),
	(438631, 126, '2015-03-01 00:23:46.000000', 'consum', 0.0220, 'lps'),
	(438632, 126, '2015-03-01 00:23:47.000000', 'consum', 0.0219, 'lps'),
	(438633, 126, '2015-03-01 00:23:48.000000', 'consum', 0.0226, 'lps'),
	(438634, 126, '2015-03-01 00:23:49.000000', 'consum', 0.0224, 'lps'),
	(438635, 126, '2015-03-01 00:23:50.000000', 'consum', 0.0210, 'lps'),
	(438636, 126, '2015-03-01 00:23:51.000000', 'consum', 0.0213, 'lps'),
	(438637, 126, '2015-03-01 00:23:52.000000', 'consum', 0.0223, 'lps'),
	(438638, 126, '2015-03-01 00:23:53.000000', 'consum', 0.0223, 'lps'),
	(438639, 126, '2015-03-01 00:23:54.000000', 'consum', 0.0217, 'lps'),
	(438640, 126, '2015-03-01 00:23:55.000000', 'consum', 0.0229, 'lps'),
	(438641, 126, '2015-03-01 00:23:56.000000', 'consum', 0.0219, 'lps'),
	(438642, 126, '2015-03-01 00:23:57.000000', 'consum', 0.0219, 'lps'),
	(438643, 126, '2015-03-01 00:23:58.000000', 'consum', 0.0230, 'lps'),
	(438644, 126, '2015-03-01 00:23:59.000000', 'consum', 0.0221, 'lps'),
	(438645, 126, '2015-03-01 00:24:00.000000', 'consum', 0.0227, 'lps'),
	(438646, 126, '2015-03-01 00:24:01.000000', 'consum', 0.0219, 'lps'),
	(438647, 126, '2015-03-01 00:24:02.000000', 'consum', 0.0227, 'lps'),
	(438648, 126, '2015-03-01 00:24:03.000000', 'consum', 0.0226, 'lps'),
	(438649, 126, '2015-03-01 00:24:04.000000', 'consum', 0.0220, 'lps'),
	(438650, 126, '2015-03-01 00:24:05.000000', 'consum', 0.0211, 'lps'),
	(438651, 126, '2015-03-01 00:24:06.000000', 'consum', 0.0227, 'lps'),
	(438652, 126, '2015-03-01 00:24:07.000000', 'consum', 0.0210, 'lps'),
	(438653, 126, '2015-03-01 00:24:08.000000', 'consum', 0.0222, 'lps'),
	(438654, 126, '2015-03-01 00:24:09.000000', 'consum', 0.0230, 'lps'),
	(438655, 126, '2015-03-01 00:24:10.000000', 'consum', 0.0210, 'lps'),
	(438656, 126, '2015-03-01 00:24:11.000000', 'consum', 0.0214, 'lps'),
	(438657, 126, '2015-03-01 00:24:12.000000', 'consum', 0.0230, 'lps'),
	(438658, 126, '2015-03-01 00:24:13.000000', 'consum', 0.0217, 'lps'),
	(438659, 126, '2015-03-01 00:24:14.000000', 'consum', 0.0224, 'lps'),
	(438660, 126, '2015-03-01 00:24:15.000000', 'consum', 0.0221, 'lps'),
	(438661, 126, '2015-03-01 00:24:16.000000', 'consum', 0.0220, 'lps'),
	(438662, 126, '2015-03-01 00:24:17.000000', 'consum', 0.0230, 'lps'),
	(438663, 126, '2015-03-01 00:24:18.000000', 'consum', 0.0218, 'lps'),
	(438664, 126, '2015-03-01 00:24:19.000000', 'consum', 0.0230, 'lps'),
	(438665, 126, '2015-03-01 00:24:20.000000', 'consum', 0.0225, 'lps'),
	(438666, 126, '2015-03-01 00:24:21.000000', 'consum', 0.0227, 'lps'),
	(438667, 126, '2015-03-01 00:24:22.000000', 'consum', 0.0228, 'lps'),
	(438668, 126, '2015-03-01 00:24:23.000000', 'consum', 0.0228, 'lps'),
	(438669, 126, '2015-03-01 00:24:24.000000', 'consum', 0.0226, 'lps'),
	(438670, 126, '2015-03-01 00:24:25.000000', 'consum', 0.0216, 'lps'),
	(438671, 126, '2015-03-01 00:24:26.000000', 'consum', 0.0213, 'lps'),
	(438672, 126, '2015-03-01 00:24:27.000000', 'consum', 0.0230, 'lps'),
	(438673, 126, '2015-03-01 00:24:28.000000', 'consum', 0.0216, 'lps'),
	(438674, 126, '2015-03-01 00:24:29.000000', 'consum', 0.0224, 'lps'),
	(438675, 126, '2015-03-01 00:24:30.000000', 'consum', 0.0219, 'lps'),
	(438676, 126, '2015-03-01 00:24:31.000000', 'consum', 0.0215, 'lps'),
	(438677, 126, '2015-03-01 00:24:32.000000', 'consum', 0.0228, 'lps'),
	(438678, 126, '2015-03-01 00:24:33.000000', 'consum', 0.0221, 'lps'),
	(438679, 126, '2015-03-01 00:24:34.000000', 'consum', 0.0215, 'lps'),
	(438680, 126, '2015-03-01 00:24:35.000000', 'consum', 0.0221, 'lps'),
	(438681, 126, '2015-03-01 00:24:36.000000', 'consum', 0.0229, 'lps'),
	(438682, 126, '2015-03-01 00:24:37.000000', 'consum', 0.0211, 'lps'),
	(438683, 126, '2015-03-01 00:24:38.000000', 'consum', 0.0220, 'lps'),
	(438684, 126, '2015-03-01 00:24:39.000000', 'consum', 0.0216, 'lps'),
	(438685, 126, '2015-03-01 00:24:40.000000', 'consum', 0.0230, 'lps'),
	(438686, 126, '2015-03-01 00:24:41.000000', 'consum', 0.0210, 'lps'),
	(438687, 126, '2015-03-01 00:24:42.000000', 'consum', 0.0212, 'lps'),
	(438688, 126, '2015-03-01 00:24:43.000000', 'consum', 0.0222, 'lps'),
	(438689, 126, '2015-03-01 00:24:44.000000', 'consum', 0.0221, 'lps'),
	(438690, 126, '2015-03-01 00:24:45.000000', 'consum', 0.0211, 'lps'),
	(438691, 126, '2015-03-01 00:24:46.000000', 'consum', 0.0223, 'lps'),
	(438692, 126, '2015-03-01 00:24:47.000000', 'consum', 0.0212, 'lps'),
	(438693, 126, '2015-03-01 00:24:48.000000', 'consum', 0.0220, 'lps'),
	(438694, 126, '2015-03-01 00:24:49.000000', 'consum', 0.0213, 'lps'),
	(438695, 126, '2015-03-01 00:24:50.000000', 'consum', 0.0217, 'lps'),
	(438696, 126, '2015-03-01 00:24:51.000000', 'consum', 0.0216, 'lps'),
	(438697, 126, '2015-03-01 00:24:52.000000', 'consum', 0.0217, 'lps'),
	(438698, 126, '2015-03-01 00:24:53.000000', 'consum', 0.0230, 'lps'),
	(438699, 126, '2015-03-01 00:24:54.000000', 'consum', 0.0225, 'lps'),
	(438700, 126, '2015-03-01 00:24:55.000000', 'consum', 0.0225, 'lps'),
	(438701, 126, '2015-03-01 00:24:56.000000', 'consum', 0.0219, 'lps'),
	(438702, 126, '2015-03-01 00:24:57.000000', 'consum', 0.0211, 'lps'),
	(438703, 126, '2015-03-01 00:24:58.000000', 'consum', 0.0211, 'lps'),
	(438704, 126, '2015-03-01 00:24:59.000000', 'consum', 0.0213, 'lps'),
	(438705, 126, '2015-03-01 00:25:00.000000', 'consum', 0.0220, 'lps'),
	(438706, 126, '2015-03-01 00:25:01.000000', 'consum', 0.0213, 'lps'),
	(438707, 126, '2015-03-01 00:25:02.000000', 'consum', 0.0213, 'lps'),
	(438708, 126, '2015-03-01 00:25:03.000000', 'consum', 0.0219, 'lps'),
	(438709, 126, '2015-03-01 00:25:04.000000', 'consum', 0.0226, 'lps'),
	(438710, 126, '2015-03-01 00:25:05.000000', 'consum', 0.0221, 'lps'),
	(438711, 126, '2015-03-01 00:25:06.000000', 'consum', 0.0218, 'lps'),
	(438712, 126, '2015-03-01 00:25:07.000000', 'consum', 0.0216, 'lps'),
	(438713, 126, '2015-03-01 00:25:08.000000', 'consum', 0.0216, 'lps'),
	(438714, 126, '2015-03-01 00:25:09.000000', 'consum', 0.0224, 'lps'),
	(438715, 126, '2015-03-01 00:25:10.000000', 'consum', 0.0220, 'lps'),
	(438716, 126, '2015-03-01 00:25:11.000000', 'consum', 0.0220, 'lps'),
	(438717, 126, '2015-03-01 00:25:12.000000', 'consum', 0.0230, 'lps'),
	(438718, 126, '2015-03-01 00:25:13.000000', 'consum', 0.0216, 'lps'),
	(438719, 126, '2015-03-01 00:25:14.000000', 'consum', 0.0222, 'lps'),
	(438720, 126, '2015-03-01 00:25:15.000000', 'consum', 0.0211, 'lps'),
	(438721, 126, '2015-03-01 00:25:16.000000', 'consum', 0.0221, 'lps'),
	(438722, 126, '2015-03-01 00:25:17.000000', 'consum', 0.0221, 'lps'),
	(438723, 126, '2015-03-01 00:25:18.000000', 'consum', 0.0213, 'lps'),
	(438724, 126, '2015-03-01 00:25:19.000000', 'consum', 0.0212, 'lps'),
	(438725, 126, '2015-03-01 00:25:20.000000', 'consum', 0.0213, 'lps'),
	(438726, 126, '2015-03-01 00:25:21.000000', 'consum', 0.0218, 'lps'),
	(438727, 126, '2015-03-01 00:25:22.000000', 'consum', 0.0221, 'lps'),
	(438728, 126, '2015-03-01 00:25:23.000000', 'consum', 0.0222, 'lps'),
	(438729, 126, '2015-03-01 00:25:24.000000', 'consum', 0.0215, 'lps'),
	(438730, 126, '2015-03-01 00:25:25.000000', 'consum', 0.0222, 'lps'),
	(438731, 126, '2015-03-01 00:25:26.000000', 'consum', 0.0214, 'lps'),
	(438732, 126, '2015-03-01 00:25:27.000000', 'consum', 0.0213, 'lps'),
	(438733, 126, '2015-03-01 00:25:28.000000', 'consum', 0.0215, 'lps'),
	(438734, 126, '2015-03-01 00:25:29.000000', 'consum', 0.0227, 'lps'),
	(438735, 126, '2015-03-01 00:25:30.000000', 'consum', 0.0217, 'lps'),
	(438736, 126, '2015-03-01 00:25:31.000000', 'consum', 0.0215, 'lps'),
	(438737, 126, '2015-03-01 00:25:32.000000', 'consum', 0.0215, 'lps'),
	(438738, 126, '2015-03-01 00:25:33.000000', 'consum', 0.0221, 'lps'),
	(438739, 126, '2015-03-01 00:25:34.000000', 'consum', 0.0230, 'lps'),
	(438740, 126, '2015-03-01 00:25:35.000000', 'consum', 0.0212, 'lps'),
	(438741, 126, '2015-03-01 00:25:36.000000', 'consum', 0.0224, 'lps'),
	(438742, 126, '2015-03-01 00:25:37.000000', 'consum', 0.0214, 'lps'),
	(438743, 126, '2015-03-01 00:25:38.000000', 'consum', 0.0228, 'lps'),
	(438744, 126, '2015-03-01 00:25:39.000000', 'consum', 0.0225, 'lps'),
	(438745, 126, '2015-03-01 00:25:40.000000', 'consum', 0.0211, 'lps'),
	(438746, 126, '2015-03-01 00:25:41.000000', 'consum', 0.0212, 'lps'),
	(438747, 126, '2015-03-01 00:25:42.000000', 'consum', 0.0218, 'lps'),
	(438748, 126, '2015-03-01 00:25:43.000000', 'consum', 0.0225, 'lps'),
	(438749, 126, '2015-03-01 00:25:44.000000', 'consum', 0.0219, 'lps'),
	(438750, 126, '2015-03-01 00:25:45.000000', 'consum', 0.0210, 'lps'),
	(438751, 126, '2015-03-01 00:25:46.000000', 'consum', 0.0227, 'lps'),
	(438752, 126, '2015-03-01 00:25:47.000000', 'consum', 0.0212, 'lps'),
	(438753, 126, '2015-03-01 00:25:48.000000', 'consum', 0.0210, 'lps'),
	(438754, 126, '2015-03-01 00:25:49.000000', 'consum', 0.0228, 'lps'),
	(438755, 126, '2015-03-01 00:25:50.000000', 'consum', 0.0213, 'lps'),
	(438756, 126, '2015-03-01 00:25:51.000000', 'consum', 0.0216, 'lps'),
	(438757, 126, '2015-03-01 00:25:52.000000', 'consum', 0.0211, 'lps'),
	(438758, 126, '2015-03-01 00:25:53.000000', 'consum', 0.0217, 'lps'),
	(438759, 126, '2015-03-01 00:25:54.000000', 'consum', 0.0220, 'lps'),
	(438760, 126, '2015-03-01 00:25:55.000000', 'consum', 0.0220, 'lps'),
	(438761, 126, '2015-03-01 00:25:56.000000', 'consum', 0.0211, 'lps'),
	(438762, 126, '2015-03-01 00:25:57.000000', 'consum', 0.0224, 'lps'),
	(438763, 126, '2015-03-01 00:25:58.000000', 'consum', 0.0218, 'lps'),
	(438764, 126, '2015-03-01 00:25:59.000000', 'consum', 0.0227, 'lps'),
	(438765, 126, '2015-03-01 00:26:00.000000', 'consum', 0.0230, 'lps'),
	(438766, 126, '2015-03-01 00:26:01.000000', 'consum', 0.0216, 'lps'),
	(438767, 126, '2015-03-01 00:26:02.000000', 'consum', 0.0224, 'lps'),
	(438768, 126, '2015-03-01 00:26:03.000000', 'consum', 0.0222, 'lps'),
	(438769, 126, '2015-03-01 00:26:04.000000', 'consum', 0.0228, 'lps'),
	(438770, 126, '2015-03-01 00:26:05.000000', 'consum', 0.0224, 'lps'),
	(438771, 126, '2015-03-01 00:26:06.000000', 'consum', 0.0225, 'lps'),
	(438772, 126, '2015-03-01 00:26:07.000000', 'consum', 0.0223, 'lps'),
	(438773, 126, '2015-03-01 00:26:08.000000', 'consum', 0.0210, 'lps'),
	(438774, 126, '2015-03-01 00:26:09.000000', 'consum', 0.0213, 'lps'),
	(438775, 126, '2015-03-01 00:26:10.000000', 'consum', 0.0223, 'lps'),
	(438776, 126, '2015-03-01 00:26:11.000000', 'consum', 0.0228, 'lps'),
	(438777, 126, '2015-03-01 00:26:12.000000', 'consum', 0.0217, 'lps'),
	(438778, 126, '2015-03-01 00:26:13.000000', 'consum', 0.0214, 'lps'),
	(438779, 126, '2015-03-01 00:26:14.000000', 'consum', 0.0211, 'lps'),
	(438780, 126, '2015-03-01 00:26:15.000000', 'consum', 0.0221, 'lps'),
	(438781, 126, '2015-03-01 00:26:16.000000', 'consum', 0.0223, 'lps'),
	(438782, 126, '2015-03-01 00:26:17.000000', 'consum', 0.0222, 'lps'),
	(438783, 126, '2015-03-01 00:26:18.000000', 'consum', 0.0230, 'lps'),
	(438784, 126, '2015-03-01 00:26:19.000000', 'consum', 0.0212, 'lps'),
	(438785, 126, '2015-03-01 00:26:20.000000', 'consum', 0.0225, 'lps'),
	(438786, 126, '2015-03-01 00:26:21.000000', 'consum', 0.0216, 'lps'),
	(438787, 126, '2015-03-01 00:26:22.000000', 'consum', 0.0216, 'lps'),
	(438788, 126, '2015-03-01 00:26:23.000000', 'consum', 0.0221, 'lps'),
	(438789, 126, '2015-03-01 00:26:24.000000', 'consum', 0.0228, 'lps'),
	(438790, 126, '2015-03-01 00:26:25.000000', 'consum', 0.0224, 'lps'),
	(438791, 126, '2015-03-01 00:26:26.000000', 'consum', 0.0229, 'lps'),
	(438792, 126, '2015-03-01 00:26:27.000000', 'consum', 0.0222, 'lps'),
	(438793, 126, '2015-03-01 00:26:28.000000', 'consum', 0.0210, 'lps'),
	(438794, 126, '2015-03-01 00:26:29.000000', 'consum', 0.0220, 'lps'),
	(438795, 126, '2015-03-01 00:26:30.000000', 'consum', 0.0216, 'lps'),
	(438796, 126, '2015-03-01 00:26:31.000000', 'consum', 0.0212, 'lps'),
	(438797, 126, '2015-03-01 00:26:32.000000', 'consum', 0.0223, 'lps'),
	(438798, 126, '2015-03-01 00:26:33.000000', 'consum', 0.0230, 'lps'),
	(438799, 126, '2015-03-01 00:26:34.000000', 'consum', 0.0226, 'lps'),
	(438800, 126, '2015-03-01 00:26:35.000000', 'consum', 0.0212, 'lps'),
	(438801, 126, '2015-03-01 00:26:36.000000', 'consum', 0.0215, 'lps'),
	(438802, 126, '2015-03-01 00:26:37.000000', 'consum', 0.0229, 'lps'),
	(438803, 126, '2015-03-01 00:26:38.000000', 'consum', 0.0228, 'lps'),
	(438804, 126, '2015-03-01 00:26:39.000000', 'consum', 0.0224, 'lps'),
	(438805, 126, '2015-03-01 00:26:40.000000', 'consum', 0.0225, 'lps'),
	(438806, 126, '2015-03-01 00:26:41.000000', 'consum', 0.0224, 'lps'),
	(438807, 126, '2015-03-01 00:26:42.000000', 'consum', 0.0213, 'lps'),
	(438808, 126, '2015-03-01 00:26:43.000000', 'consum', 0.0227, 'lps'),
	(438809, 126, '2015-03-01 00:26:44.000000', 'consum', 0.0222, 'lps'),
	(438810, 126, '2015-03-01 00:26:45.000000', 'consum', 0.0218, 'lps'),
	(438811, 126, '2015-03-01 00:26:46.000000', 'consum', 0.0216, 'lps'),
	(438812, 126, '2015-03-01 00:26:47.000000', 'consum', 0.0216, 'lps'),
	(438813, 126, '2015-03-01 00:26:48.000000', 'consum', 0.0225, 'lps'),
	(438814, 126, '2015-03-01 00:26:49.000000', 'consum', 0.0222, 'lps'),
	(438815, 126, '2015-03-01 00:26:50.000000', 'consum', 0.0227, 'lps'),
	(438816, 126, '2015-03-01 00:26:51.000000', 'consum', 0.0216, 'lps'),
	(438817, 126, '2015-03-01 00:26:52.000000', 'consum', 0.0210, 'lps'),
	(438818, 126, '2015-03-01 00:26:53.000000', 'consum', 0.0217, 'lps'),
	(438819, 126, '2015-03-01 00:26:54.000000', 'consum', 0.0221, 'lps'),
	(438820, 126, '2015-03-01 00:26:55.000000', 'consum', 0.0226, 'lps'),
	(438821, 126, '2015-03-01 00:26:56.000000', 'consum', 0.0213, 'lps'),
	(438822, 126, '2015-03-01 00:26:57.000000', 'consum', 0.0221, 'lps'),
	(438823, 126, '2015-03-01 00:26:58.000000', 'consum', 0.0216, 'lps'),
	(438824, 126, '2015-03-01 00:26:59.000000', 'consum', 0.0228, 'lps'),
	(438825, 126, '2015-03-01 00:27:00.000000', 'consum', 0.0220, 'lps'),
	(438826, 126, '2015-03-01 00:27:01.000000', 'consum', 0.0226, 'lps'),
	(438827, 126, '2015-03-01 00:27:02.000000', 'consum', 0.0220, 'lps'),
	(438828, 126, '2015-03-01 00:27:03.000000', 'consum', 0.0213, 'lps'),
	(438829, 126, '2015-03-01 00:27:04.000000', 'consum', 0.0216, 'lps'),
	(438830, 126, '2015-03-01 00:27:05.000000', 'consum', 0.0230, 'lps'),
	(438831, 126, '2015-03-01 00:27:06.000000', 'consum', 0.0229, 'lps'),
	(438832, 126, '2015-03-01 00:27:07.000000', 'consum', 0.0226, 'lps'),
	(438833, 126, '2015-03-01 00:27:08.000000', 'consum', 0.0210, 'lps'),
	(438834, 126, '2015-03-01 00:27:09.000000', 'consum', 0.0229, 'lps'),
	(438835, 126, '2015-03-01 00:27:10.000000', 'consum', 0.0219, 'lps'),
	(438836, 126, '2015-03-01 00:27:11.000000', 'consum', 0.0221, 'lps'),
	(438837, 126, '2015-03-01 00:27:12.000000', 'consum', 0.0216, 'lps'),
	(438838, 126, '2015-03-01 00:27:13.000000', 'consum', 0.0230, 'lps'),
	(438839, 126, '2015-03-01 00:27:14.000000', 'consum', 0.0228, 'lps'),
	(438840, 126, '2015-03-01 00:27:15.000000', 'consum', 0.0221, 'lps'),
	(438841, 126, '2015-03-01 00:27:16.000000', 'consum', 0.0212, 'lps'),
	(438842, 126, '2015-03-01 00:27:17.000000', 'consum', 0.0229, 'lps'),
	(438843, 126, '2015-03-01 00:27:18.000000', 'consum', 0.0214, 'lps'),
	(438844, 126, '2015-03-01 00:27:19.000000', 'consum', 0.0217, 'lps'),
	(438845, 126, '2015-03-01 00:27:20.000000', 'consum', 0.0214, 'lps'),
	(438846, 126, '2015-03-01 00:27:21.000000', 'consum', 0.0230, 'lps'),
	(438847, 126, '2015-03-01 00:27:22.000000', 'consum', 0.0214, 'lps'),
	(438848, 126, '2015-03-01 00:27:23.000000', 'consum', 0.0212, 'lps'),
	(438849, 126, '2015-03-01 00:27:24.000000', 'consum', 0.0228, 'lps'),
	(438850, 126, '2015-03-01 00:27:25.000000', 'consum', 0.0211, 'lps'),
	(438851, 126, '2015-03-01 00:27:26.000000', 'consum', 0.0224, 'lps'),
	(438852, 126, '2015-03-01 00:27:27.000000', 'consum', 0.0215, 'lps'),
	(438853, 126, '2015-03-01 00:27:28.000000', 'consum', 0.0213, 'lps'),
	(438854, 126, '2015-03-01 00:27:29.000000', 'consum', 0.0210, 'lps'),
	(438855, 126, '2015-03-01 00:27:30.000000', 'consum', 0.0225, 'lps'),
	(438856, 126, '2015-03-01 00:27:31.000000', 'consum', 0.0224, 'lps'),
	(438857, 126, '2015-03-01 00:27:32.000000', 'consum', 0.0211, 'lps'),
	(438858, 126, '2015-03-01 00:27:33.000000', 'consum', 0.0217, 'lps'),
	(438859, 126, '2015-03-01 00:27:34.000000', 'consum', 0.0221, 'lps'),
	(438860, 126, '2015-03-01 00:27:35.000000', 'consum', 0.0222, 'lps'),
	(438861, 126, '2015-03-01 00:27:36.000000', 'consum', 0.0217, 'lps'),
	(438862, 126, '2015-03-01 00:27:37.000000', 'consum', 0.0210, 'lps'),
	(438863, 126, '2015-03-01 00:27:38.000000', 'consum', 0.0230, 'lps'),
	(438864, 126, '2015-03-01 00:27:39.000000', 'consum', 0.0226, 'lps'),
	(438865, 126, '2015-03-01 00:27:40.000000', 'consum', 0.0230, 'lps'),
	(438866, 126, '2015-03-01 00:27:41.000000', 'consum', 0.0220, 'lps'),
	(438867, 126, '2015-03-01 00:27:42.000000', 'consum', 0.0221, 'lps'),
	(438868, 126, '2015-03-01 00:27:43.000000', 'consum', 0.0215, 'lps'),
	(438869, 126, '2015-03-01 00:27:44.000000', 'consum', 0.0222, 'lps'),
	(438870, 126, '2015-03-01 00:27:45.000000', 'consum', 0.0215, 'lps'),
	(438871, 126, '2015-03-01 00:27:46.000000', 'consum', 0.0220, 'lps'),
	(438872, 126, '2015-03-01 00:27:47.000000', 'consum', 0.0225, 'lps'),
	(438873, 126, '2015-03-01 00:27:48.000000', 'consum', 0.0214, 'lps'),
	(438874, 126, '2015-03-01 00:27:49.000000', 'consum', 0.0225, 'lps'),
	(438875, 126, '2015-03-01 00:27:50.000000', 'consum', 0.0213, 'lps'),
	(438876, 126, '2015-03-01 00:27:51.000000', 'consum', 0.0223, 'lps'),
	(438877, 126, '2015-03-01 00:27:52.000000', 'consum', 0.0222, 'lps'),
	(438878, 126, '2015-03-01 00:27:53.000000', 'consum', 0.0212, 'lps'),
	(438879, 126, '2015-03-01 00:27:54.000000', 'consum', 0.0225, 'lps'),
	(438880, 126, '2015-03-01 00:27:55.000000', 'consum', 0.0219, 'lps'),
	(438881, 126, '2015-03-01 00:27:56.000000', 'consum', 0.0210, 'lps'),
	(438882, 126, '2015-03-01 00:27:57.000000', 'consum', 0.0224, 'lps'),
	(438883, 126, '2015-03-01 00:27:58.000000', 'consum', 0.0220, 'lps'),
	(438884, 126, '2015-03-01 00:27:59.000000', 'consum', 0.0218, 'lps'),
	(438885, 126, '2015-03-01 00:28:00.000000', 'consum', 0.0219, 'lps'),
	(438886, 126, '2015-03-01 00:28:01.000000', 'consum', 0.0211, 'lps'),
	(438887, 126, '2015-03-01 00:28:02.000000', 'consum', 0.0211, 'lps'),
	(438888, 126, '2015-03-01 00:28:03.000000', 'consum', 0.0210, 'lps'),
	(438889, 126, '2015-03-01 00:28:04.000000', 'consum', 0.0210, 'lps'),
	(438890, 126, '2015-03-01 00:28:05.000000', 'consum', 0.0229, 'lps'),
	(438891, 126, '2015-03-01 00:28:06.000000', 'consum', 0.0223, 'lps'),
	(438892, 126, '2015-03-01 00:28:07.000000', 'consum', 0.0217, 'lps'),
	(438893, 126, '2015-03-01 00:28:08.000000', 'consum', 0.0229, 'lps'),
	(438894, 126, '2015-03-01 00:28:09.000000', 'consum', 0.0222, 'lps'),
	(438895, 126, '2015-03-01 00:28:10.000000', 'consum', 0.0214, 'lps'),
	(438896, 126, '2015-03-01 00:28:11.000000', 'consum', 0.0214, 'lps'),
	(438897, 126, '2015-03-01 00:28:12.000000', 'consum', 0.0221, 'lps'),
	(438898, 126, '2015-03-01 00:28:13.000000', 'consum', 0.0210, 'lps'),
	(438899, 126, '2015-03-01 00:28:14.000000', 'consum', 0.0220, 'lps'),
	(438900, 126, '2015-03-01 00:28:15.000000', 'consum', 0.0218, 'lps'),
	(438901, 126, '2015-03-01 00:28:16.000000', 'consum', 0.0222, 'lps'),
	(438902, 126, '2015-03-01 00:28:17.000000', 'consum', 0.0226, 'lps'),
	(438903, 126, '2015-03-01 00:28:18.000000', 'consum', 0.0210, 'lps'),
	(438904, 126, '2015-03-01 00:28:19.000000', 'consum', 0.0224, 'lps'),
	(438905, 126, '2015-03-01 00:28:20.000000', 'consum', 0.0221, 'lps'),
	(438906, 126, '2015-03-01 00:28:21.000000', 'consum', 0.0222, 'lps'),
	(438907, 126, '2015-03-01 00:28:22.000000', 'consum', 0.0218, 'lps'),
	(438908, 126, '2015-03-01 00:28:23.000000', 'consum', 0.0213, 'lps'),
	(438909, 126, '2015-03-01 00:28:24.000000', 'consum', 0.0222, 'lps'),
	(438910, 126, '2015-03-01 00:28:25.000000', 'consum', 0.0220, 'lps'),
	(438911, 126, '2015-03-01 00:28:26.000000', 'consum', 0.0224, 'lps'),
	(438912, 126, '2015-03-01 00:28:27.000000', 'consum', 0.0230, 'lps'),
	(438913, 126, '2015-03-01 00:28:28.000000', 'consum', 0.0225, 'lps'),
	(438914, 126, '2015-03-01 00:28:29.000000', 'consum', 0.0227, 'lps'),
	(438915, 126, '2015-03-01 00:28:30.000000', 'consum', 0.0229, 'lps'),
	(438916, 126, '2015-03-01 00:28:31.000000', 'consum', 0.0214, 'lps'),
	(438917, 126, '2015-03-01 00:28:32.000000', 'consum', 0.0217, 'lps'),
	(438918, 126, '2015-03-01 00:28:33.000000', 'consum', 0.0230, 'lps'),
	(438919, 126, '2015-03-01 00:28:34.000000', 'consum', 0.0227, 'lps'),
	(438920, 126, '2015-03-01 00:28:35.000000', 'consum', 0.0216, 'lps'),
	(438921, 126, '2015-03-01 00:28:36.000000', 'consum', 0.0211, 'lps'),
	(438922, 126, '2015-03-01 00:28:37.000000', 'consum', 0.0220, 'lps'),
	(438923, 126, '2015-03-01 00:28:38.000000', 'consum', 0.0213, 'lps'),
	(438924, 126, '2015-03-01 00:28:39.000000', 'consum', 0.0216, 'lps'),
	(438925, 126, '2015-03-01 00:28:40.000000', 'consum', 0.0230, 'lps'),
	(438926, 126, '2015-03-01 00:28:41.000000', 'consum', 0.0212, 'lps'),
	(438927, 126, '2015-03-01 00:28:42.000000', 'consum', 0.0223, 'lps'),
	(438928, 126, '2015-03-01 00:28:43.000000', 'consum', 0.0228, 'lps'),
	(438929, 126, '2015-03-01 00:28:44.000000', 'consum', 0.0217, 'lps'),
	(438930, 126, '2015-03-01 00:28:45.000000', 'consum', 0.0214, 'lps'),
	(438931, 126, '2015-03-01 00:28:46.000000', 'consum', 0.0210, 'lps'),
	(438932, 126, '2015-03-01 00:28:47.000000', 'consum', 0.0218, 'lps'),
	(438933, 126, '2015-03-01 00:28:48.000000', 'consum', 0.0229, 'lps'),
	(438934, 126, '2015-03-01 00:28:49.000000', 'consum', 0.0218, 'lps'),
	(438935, 126, '2015-03-01 00:28:50.000000', 'consum', 0.0217, 'lps'),
	(438936, 126, '2015-03-01 00:28:51.000000', 'consum', 0.0222, 'lps'),
	(438937, 126, '2015-03-01 00:28:52.000000', 'consum', 0.0225, 'lps'),
	(438938, 126, '2015-03-01 00:28:53.000000', 'consum', 0.0211, 'lps'),
	(438939, 126, '2015-03-01 00:28:54.000000', 'consum', 0.0210, 'lps'),
	(438940, 126, '2015-03-01 00:28:55.000000', 'consum', 0.0228, 'lps'),
	(438941, 126, '2015-03-01 00:28:56.000000', 'consum', 0.0216, 'lps'),
	(438942, 126, '2015-03-01 00:28:57.000000', 'consum', 0.0228, 'lps'),
	(438943, 126, '2015-03-01 00:28:58.000000', 'consum', 0.0221, 'lps'),
	(438944, 126, '2015-03-01 00:28:59.000000', 'consum', 0.0212, 'lps'),
	(438945, 126, '2015-03-01 00:29:00.000000', 'consum', 0.0227, 'lps'),
	(438946, 126, '2015-03-01 00:29:01.000000', 'consum', 0.0229, 'lps'),
	(438947, 126, '2015-03-01 00:29:02.000000', 'consum', 0.0213, 'lps'),
	(438948, 126, '2015-03-01 00:29:03.000000', 'consum', 0.0229, 'lps'),
	(438949, 126, '2015-03-01 00:29:04.000000', 'consum', 0.0215, 'lps'),
	(438950, 126, '2015-03-01 00:29:05.000000', 'consum', 0.0218, 'lps'),
	(438951, 126, '2015-03-01 00:29:06.000000', 'consum', 0.0214, 'lps'),
	(438952, 126, '2015-03-01 00:29:07.000000', 'consum', 0.0228, 'lps'),
	(438953, 126, '2015-03-01 00:29:08.000000', 'consum', 0.0228, 'lps'),
	(438954, 126, '2015-03-01 00:29:09.000000', 'consum', 0.0222, 'lps'),
	(438955, 126, '2015-03-01 00:29:10.000000', 'consum', 0.0220, 'lps'),
	(438956, 126, '2015-03-01 00:29:11.000000', 'consum', 0.0222, 'lps'),
	(438957, 126, '2015-03-01 00:29:12.000000', 'consum', 0.0222, 'lps'),
	(438958, 126, '2015-03-01 00:29:13.000000', 'consum', 0.0210, 'lps'),
	(438959, 126, '2015-03-01 00:29:14.000000', 'consum', 0.0219, 'lps'),
	(438960, 126, '2015-03-01 00:29:15.000000', 'consum', 0.0214, 'lps'),
	(438961, 126, '2015-03-01 00:29:16.000000', 'consum', 0.0222, 'lps'),
	(438962, 126, '2015-03-01 00:29:17.000000', 'consum', 0.0217, 'lps'),
	(438963, 126, '2015-03-01 00:29:18.000000', 'consum', 0.0229, 'lps'),
	(438964, 126, '2015-03-01 00:29:19.000000', 'consum', 0.0224, 'lps'),
	(438965, 126, '2015-03-01 00:29:20.000000', 'consum', 0.0225, 'lps'),
	(438966, 126, '2015-03-01 00:29:21.000000', 'consum', 0.0220, 'lps'),
	(438967, 126, '2015-03-01 00:29:22.000000', 'consum', 0.0217, 'lps'),
	(438968, 126, '2015-03-01 00:29:23.000000', 'consum', 0.0215, 'lps'),
	(438969, 126, '2015-03-01 00:29:24.000000', 'consum', 0.0213, 'lps'),
	(438970, 126, '2015-03-01 00:29:25.000000', 'consum', 0.0213, 'lps'),
	(438971, 126, '2015-03-01 00:29:26.000000', 'consum', 0.0217, 'lps'),
	(438972, 126, '2015-03-01 00:29:27.000000', 'consum', 0.0215, 'lps'),
	(438973, 126, '2015-03-01 00:29:28.000000', 'consum', 0.0213, 'lps'),
	(438974, 126, '2015-03-01 00:29:29.000000', 'consum', 0.0211, 'lps'),
	(438975, 126, '2015-03-01 00:29:30.000000', 'consum', 0.0227, 'lps'),
	(438976, 126, '2015-03-01 00:29:31.000000', 'consum', 0.0210, 'lps'),
	(438977, 126, '2015-03-01 00:29:32.000000', 'consum', 0.0222, 'lps'),
	(438978, 126, '2015-03-01 00:29:33.000000', 'consum', 0.0230, 'lps'),
	(438979, 126, '2015-03-01 00:29:34.000000', 'consum', 0.0210, 'lps'),
	(438980, 126, '2015-03-01 00:29:35.000000', 'consum', 0.0215, 'lps'),
	(438981, 126, '2015-03-01 00:29:36.000000', 'consum', 0.0214, 'lps'),
	(438982, 126, '2015-03-01 00:29:37.000000', 'consum', 0.0217, 'lps'),
	(438983, 126, '2015-03-01 00:29:38.000000', 'consum', 0.0210, 'lps'),
	(438984, 126, '2015-03-01 00:29:39.000000', 'consum', 0.0211, 'lps'),
	(438985, 126, '2015-03-01 00:29:40.000000', 'consum', 0.0217, 'lps'),
	(438986, 126, '2015-03-01 00:29:41.000000', 'consum', 0.0220, 'lps'),
	(438987, 126, '2015-03-01 00:29:42.000000', 'consum', 0.0220, 'lps'),
	(438988, 126, '2015-03-01 00:29:43.000000', 'consum', 0.0228, 'lps'),
	(438989, 126, '2015-03-01 00:29:44.000000', 'consum', 0.0229, 'lps'),
	(438990, 126, '2015-03-01 00:29:45.000000', 'consum', 0.0210, 'lps'),
	(438991, 126, '2015-03-01 00:29:46.000000', 'consum', 0.0218, 'lps'),
	(438992, 126, '2015-03-01 00:29:47.000000', 'consum', 0.0227, 'lps'),
	(438993, 126, '2015-03-01 00:29:48.000000', 'consum', 0.0230, 'lps'),
	(438994, 126, '2015-03-01 00:29:49.000000', 'consum', 0.0218, 'lps'),
	(438995, 126, '2015-03-01 00:29:50.000000', 'consum', 0.0212, 'lps'),
	(438996, 126, '2015-03-01 00:29:51.000000', 'consum', 0.0219, 'lps'),
	(438997, 126, '2015-03-01 00:29:52.000000', 'consum', 0.0226, 'lps'),
	(438998, 126, '2015-03-01 00:29:53.000000', 'consum', 0.0224, 'lps'),
	(438999, 126, '2015-03-01 00:29:54.000000', 'consum', 0.0230, 'lps'),
	(439000, 126, '2015-03-01 00:29:55.000000', 'consum', 0.0229, 'lps'),
	(439001, 126, '2015-03-01 00:29:56.000000', 'consum', 0.0223, 'lps'),
	(439002, 126, '2015-03-01 00:29:57.000000', 'consum', 0.0219, 'lps'),
	(439003, 126, '2015-03-01 00:29:58.000000', 'consum', 0.0216, 'lps'),
	(439004, 126, '2015-03-01 00:29:59.000000', 'consum', 0.0213, 'lps'),
	(439005, 126, '2015-03-01 00:30:00.000000', 'consum', 0.0230, 'lps'),
	(439006, 126, '2015-03-01 00:30:01.000000', 'consum', 0.0215, 'lps'),
	(439007, 126, '2015-03-01 00:30:02.000000', 'consum', 0.0221, 'lps'),
	(439008, 126, '2015-03-01 00:30:03.000000', 'consum', 0.0227, 'lps'),
	(439009, 126, '2015-03-01 00:30:04.000000', 'consum', 0.0220, 'lps'),
	(439010, 126, '2015-03-01 00:30:05.000000', 'consum', 0.0210, 'lps'),
	(439011, 126, '2015-03-01 00:30:06.000000', 'consum', 0.0222, 'lps'),
	(439012, 126, '2015-03-01 00:30:07.000000', 'consum', 0.0227, 'lps'),
	(439013, 126, '2015-03-01 00:30:08.000000', 'consum', 0.0219, 'lps'),
	(439014, 126, '2015-03-01 00:30:09.000000', 'consum', 0.0227, 'lps'),
	(439015, 126, '2015-03-01 00:30:10.000000', 'consum', 0.0226, 'lps'),
	(439016, 126, '2015-03-01 00:30:11.000000', 'consum', 0.0217, 'lps'),
	(439017, 126, '2015-03-01 00:30:12.000000', 'consum', 0.0220, 'lps'),
	(439018, 126, '2015-03-01 00:30:13.000000', 'consum', 0.0217, 'lps'),
	(439019, 126, '2015-03-01 00:30:14.000000', 'consum', 0.0215, 'lps'),
	(439020, 126, '2015-03-01 00:30:15.000000', 'consum', 0.0217, 'lps'),
	(439021, 126, '2015-03-01 00:30:16.000000', 'consum', 0.0228, 'lps'),
	(439022, 126, '2015-03-01 00:30:17.000000', 'consum', 0.0217, 'lps'),
	(439023, 126, '2015-03-01 00:30:18.000000', 'consum', 0.0214, 'lps'),
	(439024, 126, '2015-03-01 00:30:19.000000', 'consum', 0.0229, 'lps'),
	(439025, 126, '2015-03-01 00:30:20.000000', 'consum', 0.0229, 'lps'),
	(439026, 126, '2015-03-01 00:30:21.000000', 'consum', 0.0210, 'lps'),
	(439027, 126, '2015-03-01 00:30:22.000000', 'consum', 0.0215, 'lps'),
	(439028, 126, '2015-03-01 00:30:23.000000', 'consum', 0.0214, 'lps'),
	(439029, 126, '2015-03-01 00:30:24.000000', 'consum', 0.0217, 'lps'),
	(439030, 126, '2015-03-01 00:30:25.000000', 'consum', 0.0212, 'lps'),
	(439031, 126, '2015-03-01 00:30:26.000000', 'consum', 0.0222, 'lps'),
	(439032, 126, '2015-03-01 00:30:27.000000', 'consum', 0.0222, 'lps'),
	(439033, 126, '2015-03-01 00:30:28.000000', 'consum', 0.0211, 'lps'),
	(439034, 126, '2015-03-01 00:30:29.000000', 'consum', 0.0223, 'lps'),
	(439035, 126, '2015-03-01 00:30:30.000000', 'consum', 0.0210, 'lps'),
	(439036, 126, '2015-03-01 00:30:31.000000', 'consum', 0.0212, 'lps'),
	(439037, 126, '2015-03-01 00:30:32.000000', 'consum', 0.0221, 'lps'),
	(439038, 126, '2015-03-01 00:30:33.000000', 'consum', 0.0217, 'lps'),
	(439039, 126, '2015-03-01 00:30:34.000000', 'consum', 0.0214, 'lps'),
	(439040, 126, '2015-03-01 00:30:35.000000', 'consum', 0.0228, 'lps'),
	(439041, 126, '2015-03-01 00:30:36.000000', 'consum', 0.0228, 'lps'),
	(439042, 126, '2015-03-01 00:30:37.000000', 'consum', 0.0224, 'lps'),
	(439043, 126, '2015-03-01 00:30:38.000000', 'consum', 0.0227, 'lps'),
	(439044, 126, '2015-03-01 00:30:39.000000', 'consum', 0.0211, 'lps'),
	(439045, 126, '2015-03-01 00:30:40.000000', 'consum', 0.0226, 'lps'),
	(439046, 126, '2015-03-01 00:30:41.000000', 'consum', 0.0225, 'lps'),
	(439047, 126, '2015-03-01 00:30:42.000000', 'consum', 0.0217, 'lps'),
	(439048, 126, '2015-03-01 00:30:43.000000', 'consum', 0.0222, 'lps'),
	(439049, 126, '2015-03-01 00:30:44.000000', 'consum', 0.0230, 'lps'),
	(439050, 126, '2015-03-01 00:30:45.000000', 'consum', 0.0230, 'lps'),
	(439051, 126, '2015-03-01 00:30:46.000000', 'consum', 0.0210, 'lps'),
	(439052, 126, '2015-03-01 00:30:47.000000', 'consum', 0.0213, 'lps'),
	(439053, 126, '2015-03-01 00:30:48.000000', 'consum', 0.0226, 'lps'),
	(439054, 126, '2015-03-01 00:30:49.000000', 'consum', 0.0218, 'lps'),
	(439055, 126, '2015-03-01 00:30:50.000000', 'consum', 0.0225, 'lps'),
	(439056, 126, '2015-03-01 00:30:51.000000', 'consum', 0.0218, 'lps'),
	(439057, 126, '2015-03-01 00:30:52.000000', 'consum', 0.0226, 'lps'),
	(439058, 126, '2015-03-01 00:30:53.000000', 'consum', 0.0223, 'lps'),
	(439059, 126, '2015-03-01 00:30:54.000000', 'consum', 0.0230, 'lps'),
	(439060, 126, '2015-03-01 00:30:55.000000', 'consum', 0.0228, 'lps'),
	(439061, 126, '2015-03-01 00:30:56.000000', 'consum', 0.0219, 'lps'),
	(439062, 126, '2015-03-01 00:30:57.000000', 'consum', 0.0223, 'lps'),
	(439063, 126, '2015-03-01 00:30:58.000000', 'consum', 0.0228, 'lps'),
	(439064, 126, '2015-03-01 00:30:59.000000', 'consum', 0.0221, 'lps'),
	(439065, 126, '2015-03-01 00:31:00.000000', 'consum', 0.0229, 'lps'),
	(439066, 126, '2015-03-01 00:31:01.000000', 'consum', 0.0213, 'lps'),
	(439067, 126, '2015-03-01 00:31:02.000000', 'consum', 0.0230, 'lps'),
	(439068, 126, '2015-03-01 00:31:03.000000', 'consum', 0.0220, 'lps'),
	(439069, 126, '2015-03-01 00:31:04.000000', 'consum', 0.0219, 'lps'),
	(439070, 126, '2015-03-01 00:31:05.000000', 'consum', 0.0225, 'lps'),
	(439071, 126, '2015-03-01 00:31:06.000000', 'consum', 0.0219, 'lps'),
	(439072, 126, '2015-03-01 00:31:07.000000', 'consum', 0.0210, 'lps'),
	(439073, 126, '2015-03-01 00:31:08.000000', 'consum', 0.0227, 'lps'),
	(439074, 126, '2015-03-01 00:31:09.000000', 'consum', 0.0229, 'lps'),
	(439075, 126, '2015-03-01 00:31:10.000000', 'consum', 0.0216, 'lps'),
	(439076, 126, '2015-03-01 00:31:11.000000', 'consum', 0.0222, 'lps'),
	(439077, 126, '2015-03-01 00:31:12.000000', 'consum', 0.0213, 'lps'),
	(439078, 126, '2015-03-01 00:31:13.000000', 'consum', 0.0229, 'lps'),
	(439079, 126, '2015-03-01 00:31:14.000000', 'consum', 0.0214, 'lps'),
	(439080, 126, '2015-03-01 00:31:15.000000', 'consum', 0.0217, 'lps'),
	(439081, 126, '2015-03-01 00:31:16.000000', 'consum', 0.0210, 'lps'),
	(439082, 126, '2015-03-01 00:31:17.000000', 'consum', 0.0213, 'lps'),
	(439083, 126, '2015-03-01 00:31:18.000000', 'consum', 0.0222, 'lps'),
	(439084, 126, '2015-03-01 00:31:19.000000', 'consum', 0.0223, 'lps'),
	(439085, 126, '2015-03-01 00:31:20.000000', 'consum', 0.0217, 'lps'),
	(439086, 126, '2015-03-01 00:31:21.000000', 'consum', 0.0227, 'lps'),
	(439087, 126, '2015-03-01 00:31:22.000000', 'consum', 0.0214, 'lps'),
	(439088, 126, '2015-03-01 00:31:23.000000', 'consum', 0.0220, 'lps'),
	(439089, 126, '2015-03-01 00:31:24.000000', 'consum', 0.0228, 'lps'),
	(439090, 126, '2015-03-01 00:31:25.000000', 'consum', 0.0229, 'lps'),
	(439091, 126, '2015-03-01 00:31:26.000000', 'consum', 0.0229, 'lps'),
	(439092, 126, '2015-03-01 00:31:27.000000', 'consum', 0.0229, 'lps'),
	(439093, 126, '2015-03-01 00:31:28.000000', 'consum', 0.0228, 'lps'),
	(439094, 126, '2015-03-01 00:31:29.000000', 'consum', 0.0223, 'lps'),
	(439095, 126, '2015-03-01 00:31:30.000000', 'consum', 0.0221, 'lps'),
	(439096, 126, '2015-03-01 00:31:31.000000', 'consum', 0.0228, 'lps'),
	(439097, 126, '2015-03-01 00:31:32.000000', 'consum', 0.0223, 'lps'),
	(439098, 126, '2015-03-01 00:31:33.000000', 'consum', 0.0222, 'lps'),
	(439099, 126, '2015-03-01 00:31:34.000000', 'consum', 0.0211, 'lps'),
	(439100, 126, '2015-03-01 00:31:35.000000', 'consum', 0.0220, 'lps'),
	(439101, 126, '2015-03-01 00:31:36.000000', 'consum', 0.0216, 'lps'),
	(439102, 126, '2015-03-01 00:31:37.000000', 'consum', 0.0213, 'lps'),
	(439103, 126, '2015-03-01 00:31:38.000000', 'consum', 0.0226, 'lps'),
	(439104, 126, '2015-03-01 00:31:39.000000', 'consum', 0.0219, 'lps'),
	(439105, 126, '2015-03-01 00:31:40.000000', 'consum', 0.0230, 'lps'),
	(439106, 126, '2015-03-01 00:31:41.000000', 'consum', 0.0219, 'lps'),
	(439107, 126, '2015-03-01 00:31:42.000000', 'consum', 0.0219, 'lps'),
	(439108, 126, '2015-03-01 00:31:43.000000', 'consum', 0.0227, 'lps'),
	(439109, 126, '2015-03-01 00:31:44.000000', 'consum', 0.0227, 'lps'),
	(439110, 126, '2015-03-01 00:31:45.000000', 'consum', 0.0223, 'lps'),
	(439111, 126, '2015-03-01 00:31:46.000000', 'consum', 0.0224, 'lps'),
	(439112, 126, '2015-03-01 00:31:47.000000', 'consum', 0.0219, 'lps'),
	(439113, 126, '2015-03-01 00:31:48.000000', 'consum', 0.0217, 'lps'),
	(439114, 126, '2015-03-01 00:31:49.000000', 'consum', 0.0216, 'lps'),
	(439115, 126, '2015-03-01 00:31:50.000000', 'consum', 0.0219, 'lps'),
	(439116, 126, '2015-03-01 00:31:51.000000', 'consum', 0.0218, 'lps'),
	(439117, 126, '2015-03-01 00:31:52.000000', 'consum', 0.0222, 'lps'),
	(439118, 126, '2015-03-01 00:31:53.000000', 'consum', 0.0228, 'lps'),
	(439119, 126, '2015-03-01 00:31:54.000000', 'consum', 0.0223, 'lps'),
	(439120, 126, '2015-03-01 00:31:55.000000', 'consum', 0.0220, 'lps'),
	(439121, 126, '2015-03-01 00:31:56.000000', 'consum', 0.0220, 'lps'),
	(439122, 126, '2015-03-01 00:31:57.000000', 'consum', 0.0211, 'lps'),
	(439123, 126, '2015-03-01 00:31:58.000000', 'consum', 0.0226, 'lps'),
	(439124, 126, '2015-03-01 00:31:59.000000', 'consum', 0.0225, 'lps'),
	(439125, 126, '2015-03-01 00:32:00.000000', 'consum', 0.0215, 'lps'),
	(439126, 126, '2015-03-01 00:32:01.000000', 'consum', 0.0213, 'lps'),
	(439127, 126, '2015-03-01 00:32:02.000000', 'consum', 0.0230, 'lps'),
	(439128, 126, '2015-03-01 00:32:03.000000', 'consum', 0.0220, 'lps'),
	(439129, 126, '2015-03-01 00:32:04.000000', 'consum', 0.0218, 'lps'),
	(439130, 126, '2015-03-01 00:32:05.000000', 'consum', 0.0224, 'lps'),
	(439131, 126, '2015-03-01 00:32:06.000000', 'consum', 0.0211, 'lps'),
	(439132, 126, '2015-03-01 00:32:07.000000', 'consum', 0.0218, 'lps'),
	(439133, 126, '2015-03-01 00:32:08.000000', 'consum', 0.0228, 'lps'),
	(439134, 126, '2015-03-01 00:32:09.000000', 'consum', 0.0210, 'lps'),
	(439135, 126, '2015-03-01 00:32:10.000000', 'consum', 0.0221, 'lps'),
	(439136, 126, '2015-03-01 00:32:11.000000', 'consum', 0.0222, 'lps'),
	(439137, 126, '2015-03-01 00:32:12.000000', 'consum', 0.0216, 'lps'),
	(439138, 126, '2015-03-01 00:32:13.000000', 'consum', 0.0225, 'lps'),
	(439139, 126, '2015-03-01 00:32:14.000000', 'consum', 0.0228, 'lps'),
	(439140, 126, '2015-03-01 00:32:15.000000', 'consum', 0.0214, 'lps'),
	(439141, 126, '2015-03-01 00:32:16.000000', 'consum', 0.0219, 'lps'),
	(439142, 126, '2015-03-01 00:32:17.000000', 'consum', 0.0222, 'lps'),
	(439143, 126, '2015-03-01 00:32:18.000000', 'consum', 0.0221, 'lps'),
	(439144, 126, '2015-03-01 00:32:19.000000', 'consum', 0.0211, 'lps'),
	(439145, 126, '2015-03-01 00:32:20.000000', 'consum', 0.0223, 'lps'),
	(439146, 126, '2015-03-01 00:32:21.000000', 'consum', 0.0210, 'lps'),
	(439147, 126, '2015-03-01 00:32:22.000000', 'consum', 0.0211, 'lps'),
	(439148, 126, '2015-03-01 00:32:23.000000', 'consum', 0.0219, 'lps'),
	(439149, 126, '2015-03-01 00:32:24.000000', 'consum', 0.0210, 'lps'),
	(439150, 126, '2015-03-01 00:32:25.000000', 'consum', 0.0224, 'lps'),
	(439151, 126, '2015-03-01 00:32:26.000000', 'consum', 0.0219, 'lps'),
	(439152, 126, '2015-03-01 00:32:27.000000', 'consum', 0.0212, 'lps'),
	(439153, 126, '2015-03-01 00:32:28.000000', 'consum', 0.0213, 'lps'),
	(439154, 126, '2015-03-01 00:32:29.000000', 'consum', 0.0222, 'lps'),
	(439155, 126, '2015-03-01 00:32:30.000000', 'consum', 0.0218, 'lps'),
	(439156, 126, '2015-03-01 00:32:31.000000', 'consum', 0.0215, 'lps'),
	(439157, 126, '2015-03-01 00:32:32.000000', 'consum', 0.0211, 'lps'),
	(439158, 126, '2015-03-01 00:32:33.000000', 'consum', 0.0224, 'lps'),
	(439159, 126, '2015-03-01 00:32:34.000000', 'consum', 0.0211, 'lps'),
	(439160, 126, '2015-03-01 00:32:35.000000', 'consum', 0.0219, 'lps'),
	(439161, 126, '2015-03-01 00:32:36.000000', 'consum', 0.0228, 'lps'),
	(439162, 126, '2015-03-01 00:32:37.000000', 'consum', 0.0213, 'lps'),
	(439163, 126, '2015-03-01 00:32:38.000000', 'consum', 0.0214, 'lps'),
	(439164, 126, '2015-03-01 00:32:39.000000', 'consum', 0.0219, 'lps'),
	(439165, 126, '2015-03-01 00:32:40.000000', 'consum', 0.0222, 'lps'),
	(439166, 126, '2015-03-01 00:32:41.000000', 'consum', 0.0224, 'lps'),
	(439167, 126, '2015-03-01 00:32:42.000000', 'consum', 0.0225, 'lps'),
	(439168, 126, '2015-03-01 00:32:43.000000', 'consum', 0.0220, 'lps'),
	(439169, 126, '2015-03-01 00:32:44.000000', 'consum', 0.0216, 'lps'),
	(439170, 126, '2015-03-01 00:32:45.000000', 'consum', 0.0211, 'lps'),
	(439171, 126, '2015-03-01 00:32:46.000000', 'consum', 0.0218, 'lps'),
	(439172, 126, '2015-03-01 00:32:47.000000', 'consum', 0.0227, 'lps'),
	(439173, 126, '2015-03-01 00:32:48.000000', 'consum', 0.0229, 'lps'),
	(439174, 126, '2015-03-01 00:32:49.000000', 'consum', 0.0214, 'lps'),
	(439175, 126, '2015-03-01 00:32:50.000000', 'consum', 0.0216, 'lps'),
	(439176, 126, '2015-03-01 00:32:51.000000', 'consum', 0.0228, 'lps'),
	(439177, 126, '2015-03-01 00:32:52.000000', 'consum', 0.0218, 'lps'),
	(439178, 126, '2015-03-01 00:32:53.000000', 'consum', 0.0220, 'lps'),
	(439179, 126, '2015-03-01 00:32:54.000000', 'consum', 0.0214, 'lps'),
	(439180, 126, '2015-03-01 00:32:55.000000', 'consum', 0.0223, 'lps'),
	(439181, 126, '2015-03-01 00:32:56.000000', 'consum', 0.0221, 'lps'),
	(439182, 126, '2015-03-01 00:32:57.000000', 'consum', 0.0227, 'lps'),
	(439183, 126, '2015-03-01 00:32:58.000000', 'consum', 0.0218, 'lps'),
	(439184, 126, '2015-03-01 00:32:59.000000', 'consum', 0.0222, 'lps'),
	(439185, 126, '2015-03-01 00:33:00.000000', 'consum', 0.0224, 'lps'),
	(439186, 126, '2015-03-01 00:33:01.000000', 'consum', 0.0227, 'lps'),
	(439187, 126, '2015-03-01 00:33:02.000000', 'consum', 0.0229, 'lps'),
	(439188, 126, '2015-03-01 00:33:03.000000', 'consum', 0.0212, 'lps'),
	(439189, 126, '2015-03-01 00:33:04.000000', 'consum', 0.0229, 'lps'),
	(439190, 126, '2015-03-01 00:33:05.000000', 'consum', 0.0213, 'lps'),
	(439191, 126, '2015-03-01 00:33:06.000000', 'consum', 0.0210, 'lps'),
	(439192, 126, '2015-03-01 00:33:07.000000', 'consum', 0.0222, 'lps'),
	(439193, 126, '2015-03-01 00:33:08.000000', 'consum', 0.0210, 'lps'),
	(439194, 126, '2015-03-01 00:33:09.000000', 'consum', 0.0216, 'lps'),
	(439195, 126, '2015-03-01 00:33:10.000000', 'consum', 0.0221, 'lps'),
	(439196, 126, '2015-03-01 00:33:11.000000', 'consum', 0.0225, 'lps'),
	(439197, 126, '2015-03-01 00:33:12.000000', 'consum', 0.0211, 'lps'),
	(439198, 126, '2015-03-01 00:33:13.000000', 'consum', 0.0213, 'lps'),
	(439199, 126, '2015-03-01 00:33:14.000000', 'consum', 0.0223, 'lps'),
	(439200, 126, '2015-03-01 00:33:15.000000', 'consum', 0.0224, 'lps'),
	(439201, 126, '2015-03-01 00:33:16.000000', 'consum', 0.0222, 'lps'),
	(439202, 126, '2015-03-01 00:33:17.000000', 'consum', 0.0228, 'lps'),
	(439203, 126, '2015-03-01 00:33:18.000000', 'consum', 0.0223, 'lps'),
	(439204, 126, '2015-03-01 00:33:19.000000', 'consum', 0.0220, 'lps'),
	(439205, 126, '2015-03-01 00:33:20.000000', 'consum', 0.0221, 'lps'),
	(439206, 126, '2015-03-01 00:33:21.000000', 'consum', 0.0216, 'lps'),
	(439207, 126, '2015-03-01 00:33:22.000000', 'consum', 0.0230, 'lps'),
	(439208, 126, '2015-03-01 00:33:23.000000', 'consum', 0.0228, 'lps'),
	(439209, 126, '2015-03-01 00:33:24.000000', 'consum', 0.0219, 'lps'),
	(439210, 126, '2015-03-01 00:33:25.000000', 'consum', 0.0221, 'lps'),
	(439211, 126, '2015-03-01 00:33:26.000000', 'consum', 0.0221, 'lps'),
	(439212, 126, '2015-03-01 00:33:27.000000', 'consum', 0.0210, 'lps'),
	(439213, 126, '2015-03-01 00:33:28.000000', 'consum', 0.0218, 'lps'),
	(439214, 126, '2015-03-01 00:33:29.000000', 'consum', 0.0212, 'lps'),
	(439215, 126, '2015-03-01 00:33:30.000000', 'consum', 0.0214, 'lps'),
	(439216, 126, '2015-03-01 00:33:31.000000', 'consum', 0.0224, 'lps'),
	(439217, 126, '2015-03-01 00:33:32.000000', 'consum', 0.0229, 'lps'),
	(439218, 126, '2015-03-01 00:33:33.000000', 'consum', 0.0221, 'lps'),
	(439219, 126, '2015-03-01 00:33:34.000000', 'consum', 0.0230, 'lps'),
	(439220, 126, '2015-03-01 00:33:35.000000', 'consum', 0.0216, 'lps'),
	(439221, 126, '2015-03-01 00:33:36.000000', 'consum', 0.0219, 'lps'),
	(439222, 126, '2015-03-01 00:33:37.000000', 'consum', 0.0218, 'lps'),
	(439223, 126, '2015-03-01 00:33:38.000000', 'consum', 0.0226, 'lps'),
	(439224, 126, '2015-03-01 00:33:39.000000', 'consum', 0.0221, 'lps'),
	(439225, 126, '2015-03-01 00:33:40.000000', 'consum', 0.0217, 'lps'),
	(439226, 126, '2015-03-01 00:33:41.000000', 'consum', 0.0216, 'lps'),
	(439227, 126, '2015-03-01 00:33:42.000000', 'consum', 0.0217, 'lps'),
	(439228, 126, '2015-03-01 00:33:43.000000', 'consum', 0.0226, 'lps'),
	(439229, 126, '2015-03-01 00:33:44.000000', 'consum', 0.0230, 'lps'),
	(439230, 126, '2015-03-01 00:33:45.000000', 'consum', 0.0221, 'lps'),
	(439231, 126, '2015-03-01 00:33:46.000000', 'consum', 0.0224, 'lps'),
	(439232, 126, '2015-03-01 00:33:47.000000', 'consum', 0.0226, 'lps'),
	(439233, 126, '2015-03-01 00:33:48.000000', 'consum', 0.0227, 'lps'),
	(439234, 126, '2015-03-01 00:33:49.000000', 'consum', 0.0227, 'lps'),
	(439235, 126, '2015-03-01 00:33:50.000000', 'consum', 0.0223, 'lps'),
	(439236, 126, '2015-03-01 00:33:51.000000', 'consum', 0.0225, 'lps'),
	(439237, 126, '2015-03-01 00:33:52.000000', 'consum', 0.0226, 'lps'),
	(439238, 126, '2015-03-01 00:33:53.000000', 'consum', 0.0225, 'lps'),
	(439239, 126, '2015-03-01 00:33:54.000000', 'consum', 0.0215, 'lps'),
	(439240, 126, '2015-03-01 00:33:55.000000', 'consum', 0.0211, 'lps'),
	(439241, 126, '2015-03-01 00:33:56.000000', 'consum', 0.0222, 'lps'),
	(439242, 126, '2015-03-01 00:33:57.000000', 'consum', 0.0225, 'lps'),
	(439243, 126, '2015-03-01 00:33:58.000000', 'consum', 0.0227, 'lps'),
	(439244, 126, '2015-03-01 00:33:59.000000', 'consum', 0.0210, 'lps'),
	(439245, 126, '2015-03-01 00:34:00.000000', 'consum', 0.0222, 'lps'),
	(439246, 126, '2015-03-01 00:34:01.000000', 'consum', 0.0210, 'lps'),
	(439247, 126, '2015-03-01 00:34:02.000000', 'consum', 0.0214, 'lps'),
	(439248, 126, '2015-03-01 00:34:03.000000', 'consum', 0.0211, 'lps'),
	(439249, 126, '2015-03-01 00:34:04.000000', 'consum', 0.0224, 'lps'),
	(439250, 126, '2015-03-01 00:34:05.000000', 'consum', 0.0216, 'lps'),
	(439251, 126, '2015-03-01 00:34:06.000000', 'consum', 0.0220, 'lps'),
	(439252, 126, '2015-03-01 00:34:07.000000', 'consum', 0.0221, 'lps'),
	(439253, 126, '2015-03-01 00:34:08.000000', 'consum', 0.0216, 'lps'),
	(439254, 126, '2015-03-01 00:34:09.000000', 'consum', 0.0227, 'lps'),
	(439255, 126, '2015-03-01 00:34:10.000000', 'consum', 0.0217, 'lps'),
	(439256, 126, '2015-03-01 00:34:11.000000', 'consum', 0.0212, 'lps'),
	(439257, 126, '2015-03-01 00:34:12.000000', 'consum', 0.0222, 'lps'),
	(439258, 126, '2015-03-01 00:34:13.000000', 'consum', 0.0223, 'lps'),
	(439259, 126, '2015-03-01 00:34:14.000000', 'consum', 0.0219, 'lps'),
	(439260, 126, '2015-03-01 00:34:15.000000', 'consum', 0.0216, 'lps'),
	(439261, 126, '2015-03-01 00:34:16.000000', 'consum', 0.0213, 'lps'),
	(439262, 126, '2015-03-01 00:34:17.000000', 'consum', 0.0227, 'lps'),
	(439263, 126, '2015-03-01 00:34:18.000000', 'consum', 0.0225, 'lps'),
	(439264, 126, '2015-03-01 00:34:19.000000', 'consum', 0.0211, 'lps'),
	(439265, 126, '2015-03-01 00:34:20.000000', 'consum', 0.0215, 'lps'),
	(439266, 126, '2015-03-01 00:34:21.000000', 'consum', 0.0212, 'lps'),
	(439267, 126, '2015-03-01 00:34:22.000000', 'consum', 0.0225, 'lps'),
	(439268, 126, '2015-03-01 00:34:23.000000', 'consum', 0.0218, 'lps'),
	(439269, 126, '2015-03-01 00:34:24.000000', 'consum', 0.0224, 'lps'),
	(439270, 126, '2015-03-01 00:34:25.000000', 'consum', 0.0217, 'lps'),
	(439271, 126, '2015-03-01 00:34:26.000000', 'consum', 0.0225, 'lps'),
	(439272, 126, '2015-03-01 00:34:27.000000', 'consum', 0.0222, 'lps'),
	(439273, 126, '2015-03-01 00:34:28.000000', 'consum', 0.0224, 'lps'),
	(439274, 126, '2015-03-01 00:34:29.000000', 'consum', 0.0225, 'lps'),
	(439275, 126, '2015-03-01 00:34:30.000000', 'consum', 0.0221, 'lps'),
	(439276, 126, '2015-03-01 00:34:31.000000', 'consum', 0.0222, 'lps'),
	(439277, 126, '2015-03-01 00:34:32.000000', 'consum', 0.0214, 'lps'),
	(439278, 126, '2015-03-01 00:34:33.000000', 'consum', 0.0217, 'lps'),
	(439279, 126, '2015-03-01 00:34:34.000000', 'consum', 0.0211, 'lps'),
	(439280, 126, '2015-03-01 00:34:35.000000', 'consum', 0.0216, 'lps'),
	(439281, 126, '2015-03-01 00:34:36.000000', 'consum', 0.0219, 'lps'),
	(439282, 126, '2015-03-01 00:34:37.000000', 'consum', 0.0215, 'lps'),
	(439283, 126, '2015-03-01 00:34:38.000000', 'consum', 0.0227, 'lps'),
	(439284, 126, '2015-03-01 00:34:39.000000', 'consum', 0.0221, 'lps'),
	(439285, 126, '2015-03-01 00:34:40.000000', 'consum', 0.0215, 'lps'),
	(439286, 126, '2015-03-01 00:34:41.000000', 'consum', 0.0221, 'lps'),
	(439287, 126, '2015-03-01 00:34:42.000000', 'consum', 0.0230, 'lps'),
	(439288, 126, '2015-03-01 00:34:43.000000', 'consum', 0.0216, 'lps'),
	(439289, 126, '2015-03-01 00:34:44.000000', 'consum', 0.0222, 'lps'),
	(439290, 126, '2015-03-01 00:34:45.000000', 'consum', 0.0230, 'lps'),
	(439291, 126, '2015-03-01 00:34:46.000000', 'consum', 0.0214, 'lps'),
	(439292, 126, '2015-03-01 00:34:47.000000', 'consum', 0.0212, 'lps'),
	(439293, 126, '2015-03-01 00:34:48.000000', 'consum', 0.0229, 'lps'),
	(439294, 126, '2015-03-01 00:34:49.000000', 'consum', 0.0215, 'lps'),
	(439295, 126, '2015-03-01 00:34:50.000000', 'consum', 0.0220, 'lps'),
	(439296, 126, '2015-03-01 00:34:51.000000', 'consum', 0.0227, 'lps'),
	(439297, 126, '2015-03-01 00:34:52.000000', 'consum', 0.0221, 'lps'),
	(439298, 126, '2015-03-01 00:34:53.000000', 'consum', 0.0217, 'lps'),
	(439299, 126, '2015-03-01 00:34:54.000000', 'consum', 0.0212, 'lps'),
	(439300, 126, '2015-03-01 00:34:55.000000', 'consum', 0.0221, 'lps'),
	(439301, 126, '2015-03-01 00:34:56.000000', 'consum', 0.0216, 'lps'),
	(439302, 126, '2015-03-01 00:34:57.000000', 'consum', 0.0230, 'lps'),
	(439303, 126, '2015-03-01 00:34:58.000000', 'consum', 0.0228, 'lps'),
	(439304, 126, '2015-03-01 00:34:59.000000', 'consum', 0.0218, 'lps'),
	(439305, 126, '2015-03-01 00:35:00.000000', 'consum', 0.0220, 'lps'),
	(439306, 126, '2015-03-01 00:35:01.000000', 'consum', 0.0215, 'lps'),
	(439307, 126, '2015-03-01 00:35:02.000000', 'consum', 0.0227, 'lps'),
	(439308, 126, '2015-03-01 00:35:03.000000', 'consum', 0.0217, 'lps'),
	(439309, 126, '2015-03-01 00:35:04.000000', 'consum', 0.0217, 'lps'),
	(439310, 126, '2015-03-01 00:35:05.000000', 'consum', 0.0225, 'lps'),
	(439311, 126, '2015-03-01 00:35:06.000000', 'consum', 0.0221, 'lps'),
	(439312, 126, '2015-03-01 00:35:07.000000', 'consum', 0.0219, 'lps'),
	(439313, 126, '2015-03-01 00:35:08.000000', 'consum', 0.0225, 'lps'),
	(439314, 126, '2015-03-01 00:35:09.000000', 'consum', 0.0214, 'lps'),
	(439315, 126, '2015-03-01 00:35:10.000000', 'consum', 0.0228, 'lps'),
	(439316, 126, '2015-03-01 00:35:11.000000', 'consum', 0.0227, 'lps'),
	(439317, 126, '2015-03-01 00:35:12.000000', 'consum', 0.0218, 'lps'),
	(439318, 126, '2015-03-01 00:35:13.000000', 'consum', 0.0223, 'lps'),
	(439319, 126, '2015-03-01 00:35:14.000000', 'consum', 0.0229, 'lps'),
	(439320, 126, '2015-03-01 00:35:15.000000', 'consum', 0.0224, 'lps'),
	(439321, 126, '2015-03-01 00:35:16.000000', 'consum', 0.0223, 'lps'),
	(439322, 126, '2015-03-01 00:35:17.000000', 'consum', 0.0213, 'lps'),
	(439323, 126, '2015-03-01 00:35:18.000000', 'consum', 0.0227, 'lps'),
	(439324, 126, '2015-03-01 00:35:19.000000', 'consum', 0.0224, 'lps'),
	(439325, 126, '2015-03-01 00:35:20.000000', 'consum', 0.0230, 'lps'),
	(439326, 126, '2015-03-01 00:35:21.000000', 'consum', 0.0228, 'lps'),
	(439327, 126, '2015-03-01 00:35:22.000000', 'consum', 0.0217, 'lps'),
	(439328, 126, '2015-03-01 00:35:23.000000', 'consum', 0.0215, 'lps'),
	(439329, 126, '2015-03-01 00:35:24.000000', 'consum', 0.0214, 'lps'),
	(439330, 126, '2015-03-01 00:35:25.000000', 'consum', 0.0214, 'lps'),
	(439331, 126, '2015-03-01 00:35:26.000000', 'consum', 0.0220, 'lps'),
	(439332, 126, '2015-03-01 00:35:27.000000', 'consum', 0.0225, 'lps'),
	(439333, 126, '2015-03-01 00:35:28.000000', 'consum', 0.0215, 'lps'),
	(439334, 126, '2015-03-01 00:35:29.000000', 'consum', 0.0213, 'lps'),
	(439335, 126, '2015-03-01 00:35:30.000000', 'consum', 0.0210, 'lps'),
	(439336, 126, '2015-03-01 00:35:31.000000', 'consum', 0.0221, 'lps'),
	(439337, 126, '2015-03-01 00:35:32.000000', 'consum', 0.0224, 'lps'),
	(439338, 126, '2015-03-01 00:35:33.000000', 'consum', 0.0228, 'lps'),
	(439339, 126, '2015-03-01 00:35:34.000000', 'consum', 0.0216, 'lps'),
	(439340, 126, '2015-03-01 00:35:35.000000', 'consum', 0.0230, 'lps'),
	(439341, 126, '2015-03-01 00:35:36.000000', 'consum', 0.0228, 'lps'),
	(439342, 126, '2015-03-01 00:35:37.000000', 'consum', 0.0220, 'lps'),
	(439343, 126, '2015-03-01 00:35:38.000000', 'consum', 0.0227, 'lps'),
	(439344, 126, '2015-03-01 00:35:39.000000', 'consum', 0.0226, 'lps'),
	(439345, 126, '2015-03-01 00:35:40.000000', 'consum', 0.0215, 'lps'),
	(439346, 126, '2015-03-01 00:35:41.000000', 'consum', 0.0211, 'lps'),
	(439347, 126, '2015-03-01 00:35:42.000000', 'consum', 0.0222, 'lps'),
	(439348, 126, '2015-03-01 00:35:43.000000', 'consum', 0.0226, 'lps'),
	(439349, 126, '2015-03-01 00:35:44.000000', 'consum', 0.0213, 'lps'),
	(439350, 126, '2015-03-01 00:35:45.000000', 'consum', 0.0219, 'lps'),
	(439351, 126, '2015-03-01 00:35:46.000000', 'consum', 0.0225, 'lps'),
	(439352, 126, '2015-03-01 00:35:47.000000', 'consum', 0.0217, 'lps'),
	(439353, 126, '2015-03-01 00:35:48.000000', 'consum', 0.0223, 'lps'),
	(439354, 126, '2015-03-01 00:35:49.000000', 'consum', 0.0213, 'lps'),
	(439355, 126, '2015-03-01 00:35:50.000000', 'consum', 0.0226, 'lps'),
	(439356, 126, '2015-03-01 00:35:51.000000', 'consum', 0.0221, 'lps'),
	(439357, 126, '2015-03-01 00:35:52.000000', 'consum', 0.0218, 'lps'),
	(439358, 126, '2015-03-01 00:35:53.000000', 'consum', 0.0215, 'lps'),
	(439359, 126, '2015-03-01 00:35:54.000000', 'consum', 0.0212, 'lps'),
	(439360, 126, '2015-03-01 00:35:55.000000', 'consum', 0.0228, 'lps'),
	(439361, 126, '2015-03-01 00:35:56.000000', 'consum', 0.0229, 'lps'),
	(439362, 126, '2015-03-01 00:35:57.000000', 'consum', 0.0212, 'lps'),
	(439363, 126, '2015-03-01 00:35:58.000000', 'consum', 0.0224, 'lps'),
	(439364, 126, '2015-03-01 00:35:59.000000', 'consum', 0.0212, 'lps'),
	(439365, 126, '2015-03-01 00:36:00.000000', 'consum', 0.0220, 'lps'),
	(439366, 126, '2015-03-01 00:36:01.000000', 'consum', 0.0212, 'lps'),
	(439367, 126, '2015-03-01 00:36:02.000000', 'consum', 0.0210, 'lps'),
	(439368, 126, '2015-03-01 00:36:03.000000', 'consum', 0.0229, 'lps'),
	(439369, 126, '2015-03-01 00:36:04.000000', 'consum', 0.0220, 'lps'),
	(439370, 126, '2015-03-01 00:36:05.000000', 'consum', 0.0223, 'lps'),
	(439371, 126, '2015-03-01 00:36:06.000000', 'consum', 0.0226, 'lps'),
	(439372, 126, '2015-03-01 00:36:07.000000', 'consum', 0.0230, 'lps'),
	(439373, 126, '2015-03-01 00:36:08.000000', 'consum', 0.0220, 'lps'),
	(439374, 126, '2015-03-01 00:36:09.000000', 'consum', 0.0223, 'lps'),
	(439375, 126, '2015-03-01 00:36:10.000000', 'consum', 0.0223, 'lps'),
	(439376, 126, '2015-03-01 00:36:11.000000', 'consum', 0.0214, 'lps'),
	(439377, 126, '2015-03-01 00:36:12.000000', 'consum', 0.0214, 'lps'),
	(439378, 126, '2015-03-01 00:36:13.000000', 'consum', 0.0217, 'lps'),
	(439379, 126, '2015-03-01 00:36:14.000000', 'consum', 0.0212, 'lps'),
	(439380, 126, '2015-03-01 00:36:15.000000', 'consum', 0.0222, 'lps'),
	(439381, 126, '2015-03-01 00:36:16.000000', 'consum', 0.0221, 'lps'),
	(439382, 126, '2015-03-01 00:36:17.000000', 'consum', 0.0230, 'lps'),
	(439383, 126, '2015-03-01 00:36:18.000000', 'consum', 0.0214, 'lps'),
	(439384, 126, '2015-03-01 00:36:19.000000', 'consum', 0.0214, 'lps'),
	(439385, 126, '2015-03-01 00:36:20.000000', 'consum', 0.0220, 'lps'),
	(439386, 126, '2015-03-01 00:36:21.000000', 'consum', 0.0226, 'lps'),
	(439387, 126, '2015-03-01 00:36:22.000000', 'consum', 0.0217, 'lps'),
	(439388, 126, '2015-03-01 00:36:23.000000', 'consum', 0.0220, 'lps'),
	(439389, 126, '2015-03-01 00:36:24.000000', 'consum', 0.0218, 'lps'),
	(439390, 126, '2015-03-01 00:36:25.000000', 'consum', 0.0221, 'lps'),
	(439391, 126, '2015-03-01 00:36:26.000000', 'consum', 0.0219, 'lps'),
	(439392, 126, '2015-03-01 00:36:27.000000', 'consum', 0.0222, 'lps'),
	(439393, 126, '2015-03-01 00:36:28.000000', 'consum', 0.0222, 'lps'),
	(439394, 126, '2015-03-01 00:36:29.000000', 'consum', 0.0216, 'lps'),
	(439395, 126, '2015-03-01 00:36:30.000000', 'consum', 0.0226, 'lps'),
	(439396, 126, '2015-03-01 00:36:31.000000', 'consum', 0.0229, 'lps'),
	(439397, 126, '2015-03-01 00:36:32.000000', 'consum', 0.0215, 'lps'),
	(439398, 126, '2015-03-01 00:36:33.000000', 'consum', 0.0221, 'lps'),
	(439399, 126, '2015-03-01 00:36:34.000000', 'consum', 0.0230, 'lps'),
	(439400, 126, '2015-03-01 00:36:35.000000', 'consum', 0.0213, 'lps'),
	(439401, 126, '2015-03-01 00:36:36.000000', 'consum', 0.0210, 'lps'),
	(439402, 126, '2015-03-01 00:36:37.000000', 'consum', 0.0223, 'lps'),
	(439403, 126, '2015-03-01 00:36:38.000000', 'consum', 0.0210, 'lps'),
	(439404, 126, '2015-03-01 00:36:39.000000', 'consum', 0.0215, 'lps'),
	(439405, 126, '2015-03-01 00:36:40.000000', 'consum', 0.0216, 'lps'),
	(439406, 126, '2015-03-01 00:36:41.000000', 'consum', 0.0224, 'lps'),
	(439407, 126, '2015-03-01 00:36:42.000000', 'consum', 0.0222, 'lps'),
	(439408, 126, '2015-03-01 00:36:43.000000', 'consum', 0.0225, 'lps'),
	(439409, 126, '2015-03-01 00:36:44.000000', 'consum', 0.0211, 'lps'),
	(439410, 126, '2015-03-01 00:36:45.000000', 'consum', 0.0212, 'lps'),
	(439411, 126, '2015-03-01 00:36:46.000000', 'consum', 0.0219, 'lps'),
	(439412, 126, '2015-03-01 00:36:47.000000', 'consum', 0.0225, 'lps'),
	(439413, 126, '2015-03-01 00:36:48.000000', 'consum', 0.0220, 'lps'),
	(439414, 126, '2015-03-01 00:36:49.000000', 'consum', 0.0213, 'lps'),
	(439415, 126, '2015-03-01 00:36:50.000000', 'consum', 0.0216, 'lps'),
	(439416, 126, '2015-03-01 00:36:51.000000', 'consum', 0.0212, 'lps'),
	(439417, 126, '2015-03-01 00:36:52.000000', 'consum', 0.0225, 'lps'),
	(439418, 126, '2015-03-01 00:36:53.000000', 'consum', 0.0215, 'lps'),
	(439419, 126, '2015-03-01 00:36:54.000000', 'consum', 0.0213, 'lps'),
	(439420, 126, '2015-03-01 00:36:55.000000', 'consum', 0.0229, 'lps'),
	(439421, 126, '2015-03-01 00:36:56.000000', 'consum', 0.0216, 'lps'),
	(439422, 126, '2015-03-01 00:36:57.000000', 'consum', 0.0222, 'lps'),
	(439423, 126, '2015-03-01 00:36:58.000000', 'consum', 0.0214, 'lps'),
	(439424, 126, '2015-03-01 00:36:59.000000', 'consum', 0.0213, 'lps'),
	(439425, 126, '2015-03-01 00:37:00.000000', 'consum', 0.0214, 'lps'),
	(439426, 126, '2015-03-01 00:37:01.000000', 'consum', 0.0223, 'lps'),
	(439427, 126, '2015-03-01 00:37:02.000000', 'consum', 0.0221, 'lps'),
	(439428, 126, '2015-03-01 00:37:03.000000', 'consum', 0.0228, 'lps'),
	(439429, 126, '2015-03-01 00:37:04.000000', 'consum', 0.0223, 'lps'),
	(439430, 126, '2015-03-01 00:37:05.000000', 'consum', 0.0220, 'lps'),
	(439431, 126, '2015-03-01 00:37:06.000000', 'consum', 0.0225, 'lps'),
	(439432, 126, '2015-03-01 00:37:07.000000', 'consum', 0.0213, 'lps'),
	(439433, 126, '2015-03-01 00:37:08.000000', 'consum', 0.0221, 'lps'),
	(439434, 126, '2015-03-01 00:37:09.000000', 'consum', 0.0213, 'lps'),
	(439435, 126, '2015-03-01 00:37:10.000000', 'consum', 0.0215, 'lps'),
	(439436, 126, '2015-03-01 00:37:11.000000', 'consum', 0.0228, 'lps'),
	(439437, 126, '2015-03-01 00:37:12.000000', 'consum', 0.0223, 'lps'),
	(439438, 126, '2015-03-01 00:37:13.000000', 'consum', 0.0218, 'lps'),
	(439439, 126, '2015-03-01 00:37:14.000000', 'consum', 0.0215, 'lps'),
	(439440, 126, '2015-03-01 00:37:15.000000', 'consum', 0.0230, 'lps'),
	(439441, 126, '2015-03-01 00:37:16.000000', 'consum', 0.0210, 'lps'),
	(439442, 126, '2015-03-01 00:37:17.000000', 'consum', 0.0217, 'lps'),
	(439443, 126, '2015-03-01 00:37:18.000000', 'consum', 0.0222, 'lps'),
	(439444, 126, '2015-03-01 00:37:19.000000', 'consum', 0.0227, 'lps'),
	(439445, 126, '2015-03-01 00:37:20.000000', 'consum', 0.0220, 'lps'),
	(439446, 126, '2015-03-01 00:37:21.000000', 'consum', 0.0230, 'lps'),
	(439447, 126, '2015-03-01 00:37:22.000000', 'consum', 0.0218, 'lps'),
	(439448, 126, '2015-03-01 00:37:23.000000', 'consum', 0.0211, 'lps'),
	(439449, 126, '2015-03-01 00:37:24.000000', 'consum', 0.0214, 'lps'),
	(439450, 126, '2015-03-01 00:37:25.000000', 'consum', 0.0225, 'lps'),
	(439451, 126, '2015-03-01 00:37:26.000000', 'consum', 0.0213, 'lps'),
	(439452, 126, '2015-03-01 00:37:27.000000', 'consum', 0.0223, 'lps'),
	(439453, 126, '2015-03-01 00:37:28.000000', 'consum', 0.0226, 'lps'),
	(439454, 126, '2015-03-01 00:37:29.000000', 'consum', 0.0227, 'lps'),
	(439455, 126, '2015-03-01 00:37:30.000000', 'consum', 0.0227, 'lps'),
	(439456, 126, '2015-03-01 00:37:31.000000', 'consum', 0.0224, 'lps'),
	(439457, 126, '2015-03-01 00:37:32.000000', 'consum', 0.0230, 'lps'),
	(439458, 126, '2015-03-01 00:37:33.000000', 'consum', 0.0228, 'lps'),
	(439459, 126, '2015-03-01 00:37:34.000000', 'consum', 0.0217, 'lps'),
	(439460, 126, '2015-03-01 00:37:35.000000', 'consum', 0.0215, 'lps'),
	(439461, 126, '2015-03-01 00:37:36.000000', 'consum', 0.0213, 'lps'),
	(439462, 126, '2015-03-01 00:37:37.000000', 'consum', 0.0213, 'lps'),
	(439463, 126, '2015-03-01 00:37:38.000000', 'consum', 0.0214, 'lps'),
	(439464, 126, '2015-03-01 00:37:39.000000', 'consum', 0.0224, 'lps'),
	(439465, 126, '2015-03-01 00:37:40.000000', 'consum', 0.0225, 'lps'),
	(439466, 126, '2015-03-01 00:37:41.000000', 'consum', 0.0224, 'lps'),
	(439467, 126, '2015-03-01 00:37:42.000000', 'consum', 0.0214, 'lps'),
	(439468, 126, '2015-03-01 00:37:43.000000', 'consum', 0.0210, 'lps'),
	(439469, 126, '2015-03-01 00:37:44.000000', 'consum', 0.0217, 'lps'),
	(439470, 126, '2015-03-01 00:37:45.000000', 'consum', 0.0225, 'lps'),
	(439471, 126, '2015-03-01 00:37:46.000000', 'consum', 0.0223, 'lps'),
	(439472, 126, '2015-03-01 00:37:47.000000', 'consum', 0.0230, 'lps'),
	(439473, 126, '2015-03-01 00:37:48.000000', 'consum', 0.0211, 'lps'),
	(439474, 126, '2015-03-01 00:37:49.000000', 'consum', 0.0215, 'lps'),
	(439475, 126, '2015-03-01 00:37:50.000000', 'consum', 0.0213, 'lps'),
	(439476, 126, '2015-03-01 00:37:51.000000', 'consum', 0.0210, 'lps'),
	(439477, 126, '2015-03-01 00:37:52.000000', 'consum', 0.0224, 'lps'),
	(439478, 126, '2015-03-01 00:37:53.000000', 'consum', 0.0218, 'lps'),
	(439479, 126, '2015-03-01 00:37:54.000000', 'consum', 0.0230, 'lps'),
	(439480, 126, '2015-03-01 00:37:55.000000', 'consum', 0.0224, 'lps'),
	(439481, 126, '2015-03-01 00:37:56.000000', 'consum', 0.0217, 'lps'),
	(439482, 126, '2015-03-01 00:37:57.000000', 'consum', 0.0228, 'lps'),
	(439483, 126, '2015-03-01 00:37:58.000000', 'consum', 0.0215, 'lps'),
	(439484, 126, '2015-03-01 00:37:59.000000', 'consum', 0.0222, 'lps'),
	(439485, 126, '2015-03-01 00:38:00.000000', 'consum', 0.0213, 'lps'),
	(439486, 126, '2015-03-01 00:38:01.000000', 'consum', 0.0211, 'lps'),
	(439487, 126, '2015-03-01 00:38:02.000000', 'consum', 0.0228, 'lps'),
	(439488, 126, '2015-03-01 00:38:03.000000', 'consum', 0.0213, 'lps'),
	(439489, 126, '2015-03-01 00:38:04.000000', 'consum', 0.0213, 'lps'),
	(439490, 126, '2015-03-01 00:38:05.000000', 'consum', 0.0217, 'lps'),
	(439491, 126, '2015-03-01 00:38:06.000000', 'consum', 0.0214, 'lps'),
	(439492, 126, '2015-03-01 00:38:07.000000', 'consum', 0.0210, 'lps'),
	(439493, 126, '2015-03-01 00:38:08.000000', 'consum', 0.0220, 'lps'),
	(439494, 126, '2015-03-01 00:38:09.000000', 'consum', 0.0217, 'lps'),
	(439495, 126, '2015-03-01 00:38:10.000000', 'consum', 0.0214, 'lps'),
	(439496, 126, '2015-03-01 00:38:11.000000', 'consum', 0.0213, 'lps'),
	(439497, 126, '2015-03-01 00:38:12.000000', 'consum', 0.0212, 'lps'),
	(439498, 126, '2015-03-01 00:38:13.000000', 'consum', 0.0210, 'lps'),
	(439499, 126, '2015-03-01 00:38:14.000000', 'consum', 0.0226, 'lps'),
	(439500, 126, '2015-03-01 00:38:15.000000', 'consum', 0.0226, 'lps'),
	(439501, 126, '2015-03-01 00:38:16.000000', 'consum', 0.0224, 'lps'),
	(439502, 126, '2015-03-01 00:38:17.000000', 'consum', 0.0230, 'lps'),
	(439503, 126, '2015-03-01 00:38:18.000000', 'consum', 0.0226, 'lps'),
	(439504, 126, '2015-03-01 00:38:19.000000', 'consum', 0.0210, 'lps'),
	(439505, 126, '2015-03-01 00:38:20.000000', 'consum', 0.0226, 'lps'),
	(439506, 126, '2015-03-01 00:38:21.000000', 'consum', 0.0226, 'lps'),
	(439507, 126, '2015-03-01 00:38:22.000000', 'consum', 0.0225, 'lps'),
	(439508, 126, '2015-03-01 00:38:23.000000', 'consum', 0.0213, 'lps'),
	(439509, 126, '2015-03-01 00:38:24.000000', 'consum', 0.0223, 'lps'),
	(439510, 126, '2015-03-01 00:38:25.000000', 'consum', 0.0224, 'lps'),
	(439511, 126, '2015-03-01 00:38:26.000000', 'consum', 0.0220, 'lps'),
	(439512, 126, '2015-03-01 00:38:27.000000', 'consum', 0.0221, 'lps'),
	(439513, 126, '2015-03-01 00:38:28.000000', 'consum', 0.0212, 'lps'),
	(439514, 126, '2015-03-01 00:38:29.000000', 'consum', 0.0210, 'lps'),
	(439515, 126, '2015-03-01 00:38:30.000000', 'consum', 0.0225, 'lps'),
	(439516, 126, '2015-03-01 00:38:31.000000', 'consum', 0.0221, 'lps'),
	(439517, 126, '2015-03-01 00:38:32.000000', 'consum', 0.0221, 'lps'),
	(439518, 126, '2015-03-01 00:38:33.000000', 'consum', 0.0211, 'lps'),
	(439519, 126, '2015-03-01 00:38:34.000000', 'consum', 0.0226, 'lps'),
	(439520, 126, '2015-03-01 00:38:35.000000', 'consum', 0.0222, 'lps'),
	(439521, 126, '2015-03-01 00:38:36.000000', 'consum', 0.0225, 'lps'),
	(439522, 126, '2015-03-01 00:38:37.000000', 'consum', 0.0229, 'lps'),
	(439523, 126, '2015-03-01 00:38:38.000000', 'consum', 0.0219, 'lps'),
	(439524, 126, '2015-03-01 00:38:39.000000', 'consum', 0.0217, 'lps'),
	(439525, 126, '2015-03-01 00:38:40.000000', 'consum', 0.0221, 'lps'),
	(439526, 126, '2015-03-01 00:38:41.000000', 'consum', 0.0222, 'lps'),
	(439527, 126, '2015-03-01 00:38:42.000000', 'consum', 0.0215, 'lps'),
	(439528, 126, '2015-03-01 00:38:43.000000', 'consum', 0.0222, 'lps'),
	(439529, 126, '2015-03-01 00:38:44.000000', 'consum', 0.0212, 'lps'),
	(439530, 126, '2015-03-01 00:38:45.000000', 'consum', 0.0226, 'lps'),
	(439531, 126, '2015-03-01 00:38:46.000000', 'consum', 0.0224, 'lps'),
	(439532, 126, '2015-03-01 00:38:47.000000', 'consum', 0.0230, 'lps'),
	(439533, 126, '2015-03-01 00:38:48.000000', 'consum', 0.0227, 'lps'),
	(439534, 126, '2015-03-01 00:38:49.000000', 'consum', 0.0217, 'lps'),
	(439535, 126, '2015-03-01 00:38:50.000000', 'consum', 0.0213, 'lps'),
	(439536, 126, '2015-03-01 00:38:51.000000', 'consum', 0.0226, 'lps'),
	(439537, 126, '2015-03-01 00:38:52.000000', 'consum', 0.0219, 'lps'),
	(439538, 126, '2015-03-01 00:38:53.000000', 'consum', 0.0227, 'lps'),
	(439539, 126, '2015-03-01 00:38:54.000000', 'consum', 0.0227, 'lps'),
	(439540, 126, '2015-03-01 00:38:55.000000', 'consum', 0.0225, 'lps'),
	(439541, 126, '2015-03-01 00:38:56.000000', 'consum', 0.0214, 'lps'),
	(439542, 126, '2015-03-01 00:38:57.000000', 'consum', 0.0228, 'lps'),
	(439543, 126, '2015-03-01 00:38:58.000000', 'consum', 0.0224, 'lps'),
	(439544, 126, '2015-03-01 00:38:59.000000', 'consum', 0.0229, 'lps'),
	(439545, 126, '2015-03-01 00:39:00.000000', 'consum', 0.0219, 'lps'),
	(439546, 126, '2015-03-01 00:39:01.000000', 'consum', 0.0221, 'lps'),
	(439547, 126, '2015-03-01 00:39:02.000000', 'consum', 0.0215, 'lps'),
	(439548, 126, '2015-03-01 00:39:03.000000', 'consum', 0.0225, 'lps'),
	(439549, 126, '2015-03-01 00:39:04.000000', 'consum', 0.0227, 'lps'),
	(439550, 126, '2015-03-01 00:39:05.000000', 'consum', 0.0229, 'lps'),
	(439551, 126, '2015-03-01 00:39:06.000000', 'consum', 0.0211, 'lps'),
	(439552, 126, '2015-03-01 00:39:07.000000', 'consum', 0.0225, 'lps'),
	(439553, 126, '2015-03-01 00:39:08.000000', 'consum', 0.0219, 'lps'),
	(439554, 126, '2015-03-01 00:39:09.000000', 'consum', 0.0210, 'lps'),
	(439555, 126, '2015-03-01 00:39:10.000000', 'consum', 0.0226, 'lps'),
	(439556, 126, '2015-03-01 00:39:11.000000', 'consum', 0.0225, 'lps'),
	(439557, 126, '2015-03-01 00:39:12.000000', 'consum', 0.0219, 'lps'),
	(439558, 126, '2015-03-01 00:39:13.000000', 'consum', 0.0211, 'lps'),
	(439559, 126, '2015-03-01 00:39:14.000000', 'consum', 0.0228, 'lps'),
	(439560, 126, '2015-03-01 00:39:15.000000', 'consum', 0.0213, 'lps'),
	(439561, 126, '2015-03-01 00:39:16.000000', 'consum', 0.0213, 'lps'),
	(439562, 126, '2015-03-01 00:39:17.000000', 'consum', 0.0218, 'lps'),
	(439563, 126, '2015-03-01 00:39:18.000000', 'consum', 0.0220, 'lps'),
	(439564, 126, '2015-03-01 00:39:19.000000', 'consum', 0.0217, 'lps'),
	(439565, 126, '2015-03-01 00:39:20.000000', 'consum', 0.0215, 'lps'),
	(439566, 126, '2015-03-01 00:39:21.000000', 'consum', 0.0215, 'lps'),
	(439567, 126, '2015-03-01 00:39:22.000000', 'consum', 0.0220, 'lps'),
	(439568, 126, '2015-03-01 00:39:23.000000', 'consum', 0.0226, 'lps'),
	(439569, 126, '2015-03-01 00:39:24.000000', 'consum', 0.0215, 'lps'),
	(439570, 126, '2015-03-01 00:39:25.000000', 'consum', 0.0212, 'lps'),
	(439571, 126, '2015-03-01 00:39:26.000000', 'consum', 0.0226, 'lps'),
	(439572, 126, '2015-03-01 00:39:27.000000', 'consum', 0.0222, 'lps'),
	(439573, 126, '2015-03-01 00:39:28.000000', 'consum', 0.0220, 'lps'),
	(439574, 126, '2015-03-01 00:39:29.000000', 'consum', 0.0227, 'lps'),
	(439575, 126, '2015-03-01 00:39:30.000000', 'consum', 0.0222, 'lps'),
	(439576, 126, '2015-03-01 00:39:31.000000', 'consum', 0.0219, 'lps'),
	(439577, 126, '2015-03-01 00:39:32.000000', 'consum', 0.0220, 'lps'),
	(439578, 126, '2015-03-01 00:39:33.000000', 'consum', 0.0213, 'lps'),
	(439579, 126, '2015-03-01 00:39:34.000000', 'consum', 0.0218, 'lps'),
	(439580, 126, '2015-03-01 00:39:35.000000', 'consum', 0.0218, 'lps'),
	(439581, 126, '2015-03-01 00:39:36.000000', 'consum', 0.0226, 'lps'),
	(439582, 126, '2015-03-01 00:39:37.000000', 'consum', 0.0225, 'lps'),
	(439583, 126, '2015-03-01 00:39:38.000000', 'consum', 0.0219, 'lps'),
	(439584, 126, '2015-03-01 00:39:39.000000', 'consum', 0.0230, 'lps'),
	(439585, 126, '2015-03-01 00:39:40.000000', 'consum', 0.0219, 'lps'),
	(439586, 126, '2015-03-01 00:39:41.000000', 'consum', 0.0219, 'lps'),
	(439587, 126, '2015-03-01 00:39:42.000000', 'consum', 0.0227, 'lps'),
	(439588, 126, '2015-03-01 00:39:43.000000', 'consum', 0.0225, 'lps'),
	(439589, 126, '2015-03-01 00:39:44.000000', 'consum', 0.0215, 'lps'),
	(439590, 126, '2015-03-01 00:39:45.000000', 'consum', 0.0211, 'lps'),
	(439591, 126, '2015-03-01 00:39:46.000000', 'consum', 0.0224, 'lps'),
	(439592, 126, '2015-03-01 00:39:47.000000', 'consum', 0.0211, 'lps'),
	(439593, 126, '2015-03-01 00:39:48.000000', 'consum', 0.0216, 'lps'),
	(439594, 126, '2015-03-01 00:39:49.000000', 'consum', 0.0218, 'lps'),
	(439595, 126, '2015-03-01 00:39:50.000000', 'consum', 0.0210, 'lps'),
	(439596, 126, '2015-03-01 00:39:51.000000', 'consum', 0.0210, 'lps'),
	(439597, 126, '2015-03-01 00:39:52.000000', 'consum', 0.0210, 'lps'),
	(439598, 126, '2015-03-01 00:39:53.000000', 'consum', 0.0229, 'lps'),
	(439599, 126, '2015-03-01 00:39:54.000000', 'consum', 0.0223, 'lps'),
	(439600, 126, '2015-03-01 00:39:55.000000', 'consum', 0.0218, 'lps'),
	(439601, 126, '2015-03-01 00:39:56.000000', 'consum', 0.0212, 'lps'),
	(439602, 126, '2015-03-01 00:39:57.000000', 'consum', 0.0219, 'lps'),
	(439603, 126, '2015-03-01 00:39:58.000000', 'consum', 0.0225, 'lps'),
	(439604, 126, '2015-03-01 00:39:59.000000', 'consum', 0.0219, 'lps'),
	(439605, 126, '2015-03-01 00:40:00.000000', 'consum', 0.0211, 'lps'),
	(439606, 126, '2015-03-01 00:40:01.000000', 'consum', 0.0210, 'lps'),
	(439607, 126, '2015-03-01 00:40:02.000000', 'consum', 0.0227, 'lps'),
	(439608, 126, '2015-03-01 00:40:03.000000', 'consum', 0.0213, 'lps'),
	(439609, 126, '2015-03-01 00:40:04.000000', 'consum', 0.0216, 'lps'),
	(439610, 126, '2015-03-01 00:40:05.000000', 'consum', 0.0230, 'lps'),
	(439611, 126, '2015-03-01 00:40:06.000000', 'consum', 0.0229, 'lps'),
	(439612, 126, '2015-03-01 00:40:07.000000', 'consum', 0.0227, 'lps'),
	(439613, 126, '2015-03-01 00:40:08.000000', 'consum', 0.0216, 'lps'),
	(439614, 126, '2015-03-01 00:40:09.000000', 'consum', 0.0230, 'lps'),
	(439615, 126, '2015-03-01 00:40:10.000000', 'consum', 0.0212, 'lps'),
	(439616, 126, '2015-03-01 00:40:11.000000', 'consum', 0.0221, 'lps'),
	(439617, 126, '2015-03-01 00:40:12.000000', 'consum', 0.0220, 'lps'),
	(439618, 126, '2015-03-01 00:40:13.000000', 'consum', 0.0225, 'lps'),
	(439619, 126, '2015-03-01 00:40:14.000000', 'consum', 0.0214, 'lps'),
	(439620, 126, '2015-03-01 00:40:15.000000', 'consum', 0.0228, 'lps'),
	(439621, 126, '2015-03-01 00:40:16.000000', 'consum', 0.0225, 'lps'),
	(439622, 126, '2015-03-01 00:40:17.000000', 'consum', 0.0230, 'lps'),
	(439623, 126, '2015-03-01 00:40:18.000000', 'consum', 0.0225, 'lps'),
	(439624, 126, '2015-03-01 00:40:19.000000', 'consum', 0.0227, 'lps'),
	(439625, 126, '2015-03-01 00:40:20.000000', 'consum', 0.0227, 'lps'),
	(439626, 126, '2015-03-01 00:40:21.000000', 'consum', 0.0226, 'lps'),
	(439627, 126, '2015-03-01 00:40:22.000000', 'consum', 0.0219, 'lps'),
	(439628, 126, '2015-03-01 00:40:23.000000', 'consum', 0.0229, 'lps'),
	(439629, 126, '2015-03-01 00:40:24.000000', 'consum', 0.0214, 'lps'),
	(439630, 126, '2015-03-01 00:40:25.000000', 'consum', 0.0215, 'lps'),
	(439631, 126, '2015-03-01 00:40:26.000000', 'consum', 0.0225, 'lps'),
	(439632, 126, '2015-03-01 00:40:27.000000', 'consum', 0.0227, 'lps'),
	(439633, 126, '2015-03-01 00:40:28.000000', 'consum', 0.0230, 'lps'),
	(439634, 126, '2015-03-01 00:40:29.000000', 'consum', 0.0218, 'lps'),
	(439635, 126, '2015-03-01 00:40:30.000000', 'consum', 0.0230, 'lps'),
	(439636, 126, '2015-03-01 00:40:31.000000', 'consum', 0.0225, 'lps'),
	(439637, 126, '2015-03-01 00:40:32.000000', 'consum', 0.0228, 'lps'),
	(439638, 126, '2015-03-01 00:40:33.000000', 'consum', 0.0210, 'lps'),
	(439639, 126, '2015-03-01 00:40:34.000000', 'consum', 0.0219, 'lps'),
	(439640, 126, '2015-03-01 00:40:35.000000', 'consum', 0.0216, 'lps'),
	(439641, 126, '2015-03-01 00:40:36.000000', 'consum', 0.0211, 'lps'),
	(439642, 126, '2015-03-01 00:40:37.000000', 'consum', 0.0221, 'lps'),
	(439643, 126, '2015-03-01 00:40:38.000000', 'consum', 0.0219, 'lps'),
	(439644, 126, '2015-03-01 00:40:39.000000', 'consum', 0.0224, 'lps'),
	(439645, 126, '2015-03-01 00:40:40.000000', 'consum', 0.0211, 'lps'),
	(439646, 126, '2015-03-01 00:40:41.000000', 'consum', 0.0214, 'lps'),
	(439647, 126, '2015-03-01 00:40:42.000000', 'consum', 0.0228, 'lps'),
	(439648, 126, '2015-03-01 00:40:43.000000', 'consum', 0.0224, 'lps'),
	(439649, 126, '2015-03-01 00:40:44.000000', 'consum', 0.0229, 'lps'),
	(439650, 126, '2015-03-01 00:40:45.000000', 'consum', 0.0221, 'lps'),
	(439651, 126, '2015-03-01 00:40:46.000000', 'consum', 0.0210, 'lps'),
	(439652, 126, '2015-03-01 00:40:47.000000', 'consum', 0.0219, 'lps'),
	(439653, 126, '2015-03-01 00:40:48.000000', 'consum', 0.0214, 'lps'),
	(439654, 126, '2015-03-01 00:40:49.000000', 'consum', 0.0222, 'lps'),
	(439655, 126, '2015-03-01 00:40:50.000000', 'consum', 0.0218, 'lps'),
	(439656, 126, '2015-03-01 00:40:51.000000', 'consum', 0.0213, 'lps'),
	(439657, 126, '2015-03-01 00:40:52.000000', 'consum', 0.0224, 'lps'),
	(439658, 126, '2015-03-01 00:40:53.000000', 'consum', 0.0230, 'lps'),
	(439659, 126, '2015-03-01 00:40:54.000000', 'consum', 0.0227, 'lps'),
	(439660, 126, '2015-03-01 00:40:55.000000', 'consum', 0.0213, 'lps'),
	(439661, 126, '2015-03-01 00:40:56.000000', 'consum', 0.0219, 'lps'),
	(439662, 126, '2015-03-01 00:40:57.000000', 'consum', 0.0222, 'lps'),
	(439663, 126, '2015-03-01 00:40:58.000000', 'consum', 0.0225, 'lps'),
	(439664, 126, '2015-03-01 00:40:59.000000', 'consum', 0.0227, 'lps'),
	(439665, 126, '2015-03-01 00:41:00.000000', 'consum', 0.0229, 'lps'),
	(439666, 126, '2015-03-01 00:41:01.000000', 'consum', 0.0214, 'lps'),
	(439667, 126, '2015-03-01 00:41:02.000000', 'consum', 0.0215, 'lps'),
	(439668, 126, '2015-03-01 00:41:03.000000', 'consum', 0.0224, 'lps'),
	(439669, 126, '2015-03-01 00:41:04.000000', 'consum', 0.0222, 'lps'),
	(439670, 126, '2015-03-01 00:41:05.000000', 'consum', 0.0210, 'lps'),
	(439671, 126, '2015-03-01 00:41:06.000000', 'consum', 0.0214, 'lps'),
	(439672, 126, '2015-03-01 00:41:07.000000', 'consum', 0.0230, 'lps'),
	(439673, 126, '2015-03-01 00:41:08.000000', 'consum', 0.0215, 'lps'),
	(439674, 126, '2015-03-01 00:41:09.000000', 'consum', 0.0217, 'lps'),
	(439675, 126, '2015-03-01 00:41:10.000000', 'consum', 0.0210, 'lps'),
	(439676, 126, '2015-03-01 00:41:11.000000', 'consum', 0.0210, 'lps'),
	(439677, 126, '2015-03-01 00:41:12.000000', 'consum', 0.0211, 'lps'),
	(439678, 126, '2015-03-01 00:41:13.000000', 'consum', 0.0218, 'lps'),
	(439679, 126, '2015-03-01 00:41:14.000000', 'consum', 0.0223, 'lps'),
	(439680, 126, '2015-03-01 00:41:15.000000', 'consum', 0.0230, 'lps'),
	(439681, 126, '2015-03-01 00:41:16.000000', 'consum', 0.0210, 'lps'),
	(439682, 126, '2015-03-01 00:41:17.000000', 'consum', 0.0215, 'lps'),
	(439683, 126, '2015-03-01 00:41:18.000000', 'consum', 0.0214, 'lps'),
	(439684, 126, '2015-03-01 00:41:19.000000', 'consum', 0.0216, 'lps'),
	(439685, 126, '2015-03-01 00:41:20.000000', 'consum', 0.0226, 'lps'),
	(439686, 126, '2015-03-01 00:41:21.000000', 'consum', 0.0210, 'lps'),
	(439687, 126, '2015-03-01 00:41:22.000000', 'consum', 0.0225, 'lps'),
	(439688, 126, '2015-03-01 00:41:23.000000', 'consum', 0.0223, 'lps'),
	(439689, 126, '2015-03-01 00:41:24.000000', 'consum', 0.0211, 'lps'),
	(439690, 126, '2015-03-01 00:41:25.000000', 'consum', 0.0217, 'lps'),
	(439691, 126, '2015-03-01 00:41:26.000000', 'consum', 0.0222, 'lps'),
	(439692, 126, '2015-03-01 00:41:27.000000', 'consum', 0.0229, 'lps'),
	(439693, 126, '2015-03-01 00:41:28.000000', 'consum', 0.0229, 'lps'),
	(439694, 126, '2015-03-01 00:41:29.000000', 'consum', 0.0227, 'lps'),
	(439695, 126, '2015-03-01 00:41:30.000000', 'consum', 0.0215, 'lps'),
	(439696, 126, '2015-03-01 00:41:31.000000', 'consum', 0.0229, 'lps'),
	(439697, 126, '2015-03-01 00:41:32.000000', 'consum', 0.0228, 'lps'),
	(439698, 126, '2015-03-01 00:41:33.000000', 'consum', 0.0221, 'lps'),
	(439699, 126, '2015-03-01 00:41:34.000000', 'consum', 0.0213, 'lps'),
	(439700, 126, '2015-03-01 00:41:35.000000', 'consum', 0.0214, 'lps'),
	(439701, 126, '2015-03-01 00:41:36.000000', 'consum', 0.0221, 'lps'),
	(439702, 126, '2015-03-01 00:41:37.000000', 'consum', 0.0210, 'lps'),
	(439703, 126, '2015-03-01 00:41:38.000000', 'consum', 0.0222, 'lps'),
	(439704, 126, '2015-03-01 00:41:39.000000', 'consum', 0.0226, 'lps'),
	(439705, 126, '2015-03-01 00:41:40.000000', 'consum', 0.0215, 'lps'),
	(439706, 126, '2015-03-01 00:41:41.000000', 'consum', 0.0227, 'lps'),
	(439707, 126, '2015-03-01 00:41:42.000000', 'consum', 0.0217, 'lps'),
	(439708, 126, '2015-03-01 00:41:43.000000', 'consum', 0.0217, 'lps'),
	(439709, 126, '2015-03-01 00:41:44.000000', 'consum', 0.0222, 'lps'),
	(439710, 126, '2015-03-01 00:41:45.000000', 'consum', 0.0230, 'lps'),
	(439711, 126, '2015-03-01 00:41:46.000000', 'consum', 0.0213, 'lps'),
	(439712, 126, '2015-03-01 00:41:47.000000', 'consum', 0.0226, 'lps'),
	(439713, 126, '2015-03-01 00:41:48.000000', 'consum', 0.0219, 'lps'),
	(439714, 126, '2015-03-01 00:41:49.000000', 'consum', 0.0228, 'lps'),
	(439715, 126, '2015-03-01 00:41:50.000000', 'consum', 0.0210, 'lps'),
	(439716, 126, '2015-03-01 00:41:51.000000', 'consum', 0.0221, 'lps'),
	(439717, 126, '2015-03-01 00:41:52.000000', 'consum', 0.0223, 'lps'),
	(439718, 126, '2015-03-01 00:41:53.000000', 'consum', 0.0223, 'lps'),
	(439719, 126, '2015-03-01 00:41:54.000000', 'consum', 0.0214, 'lps'),
	(439720, 126, '2015-03-01 00:41:55.000000', 'consum', 0.0213, 'lps'),
	(439721, 126, '2015-03-01 00:41:56.000000', 'consum', 0.0213, 'lps'),
	(439722, 126, '2015-03-01 00:41:57.000000', 'consum', 0.0215, 'lps'),
	(439723, 126, '2015-03-01 00:41:58.000000', 'consum', 0.0227, 'lps'),
	(439724, 126, '2015-03-01 00:41:59.000000', 'consum', 0.0219, 'lps'),
	(439725, 126, '2015-03-01 00:42:00.000000', 'consum', 0.0226, 'lps'),
	(439726, 126, '2015-03-01 00:42:01.000000', 'consum', 0.0221, 'lps'),
	(439727, 126, '2015-03-01 00:42:02.000000', 'consum', 0.0219, 'lps'),
	(439728, 126, '2015-03-01 00:42:03.000000', 'consum', 0.0221, 'lps'),
	(439729, 126, '2015-03-01 00:42:04.000000', 'consum', 0.0218, 'lps'),
	(439730, 126, '2015-03-01 00:42:05.000000', 'consum', 0.0216, 'lps'),
	(439731, 126, '2015-03-01 00:42:06.000000', 'consum', 0.0219, 'lps'),
	(439732, 126, '2015-03-01 00:42:07.000000', 'consum', 0.0215, 'lps'),
	(439733, 126, '2015-03-01 00:42:08.000000', 'consum', 0.0228, 'lps'),
	(439734, 126, '2015-03-01 00:42:09.000000', 'consum', 0.0223, 'lps'),
	(439735, 126, '2015-03-01 00:42:10.000000', 'consum', 0.0222, 'lps'),
	(439736, 126, '2015-03-01 00:42:11.000000', 'consum', 0.0210, 'lps'),
	(439737, 126, '2015-03-01 00:42:12.000000', 'consum', 0.0217, 'lps'),
	(439738, 126, '2015-03-01 00:42:13.000000', 'consum', 0.0225, 'lps'),
	(439739, 126, '2015-03-01 00:42:14.000000', 'consum', 0.0221, 'lps'),
	(439740, 126, '2015-03-01 00:42:15.000000', 'consum', 0.0222, 'lps'),
	(439741, 126, '2015-03-01 00:42:16.000000', 'consum', 0.0214, 'lps'),
	(439742, 126, '2015-03-01 00:42:17.000000', 'consum', 0.0218, 'lps'),
	(439743, 126, '2015-03-01 00:42:18.000000', 'consum', 0.0215, 'lps'),
	(439744, 126, '2015-03-01 00:42:19.000000', 'consum', 0.0213, 'lps'),
	(439745, 126, '2015-03-01 00:42:20.000000', 'consum', 0.0230, 'lps'),
	(439746, 126, '2015-03-01 00:42:21.000000', 'consum', 0.0217, 'lps'),
	(439747, 126, '2015-03-01 00:42:22.000000', 'consum', 0.0227, 'lps'),
	(439748, 126, '2015-03-01 00:42:23.000000', 'consum', 0.0211, 'lps'),
	(439749, 126, '2015-03-01 00:42:24.000000', 'consum', 0.0229, 'lps'),
	(439750, 126, '2015-03-01 00:42:25.000000', 'consum', 0.0217, 'lps'),
	(439751, 126, '2015-03-01 00:42:26.000000', 'consum', 0.0212, 'lps'),
	(439752, 126, '2015-03-01 00:42:27.000000', 'consum', 0.0218, 'lps'),
	(439753, 126, '2015-03-01 00:42:28.000000', 'consum', 0.0223, 'lps'),
	(439754, 126, '2015-03-01 00:42:29.000000', 'consum', 0.0230, 'lps'),
	(439755, 126, '2015-03-01 00:42:30.000000', 'consum', 0.0230, 'lps'),
	(439756, 126, '2015-03-01 00:42:31.000000', 'consum', 0.0228, 'lps'),
	(439757, 126, '2015-03-01 00:42:32.000000', 'consum', 0.0220, 'lps'),
	(439758, 126, '2015-03-01 00:42:33.000000', 'consum', 0.0228, 'lps'),
	(439759, 126, '2015-03-01 00:42:34.000000', 'consum', 0.0227, 'lps'),
	(439760, 126, '2015-03-01 00:42:35.000000', 'consum', 0.0220, 'lps'),
	(439761, 126, '2015-03-01 00:42:36.000000', 'consum', 0.0230, 'lps'),
	(439762, 126, '2015-03-01 00:42:37.000000', 'consum', 0.0218, 'lps'),
	(439763, 126, '2015-03-01 00:42:38.000000', 'consum', 0.0214, 'lps'),
	(439764, 126, '2015-03-01 00:42:39.000000', 'consum', 0.0224, 'lps'),
	(439765, 126, '2015-03-01 00:42:40.000000', 'consum', 0.0228, 'lps'),
	(439766, 126, '2015-03-01 00:42:41.000000', 'consum', 0.0217, 'lps'),
	(439767, 126, '2015-03-01 00:42:42.000000', 'consum', 0.0212, 'lps'),
	(439768, 126, '2015-03-01 00:42:43.000000', 'consum', 0.0218, 'lps'),
	(439769, 126, '2015-03-01 00:42:44.000000', 'consum', 0.0227, 'lps'),
	(439770, 126, '2015-03-01 00:42:45.000000', 'consum', 0.0230, 'lps'),
	(439771, 126, '2015-03-01 00:42:46.000000', 'consum', 0.0215, 'lps'),
	(439772, 126, '2015-03-01 00:42:47.000000', 'consum', 0.0218, 'lps'),
	(439773, 126, '2015-03-01 00:42:48.000000', 'consum', 0.0214, 'lps'),
	(439774, 126, '2015-03-01 00:42:49.000000', 'consum', 0.0227, 'lps'),
	(439775, 126, '2015-03-01 00:42:50.000000', 'consum', 0.0219, 'lps'),
	(439776, 126, '2015-03-01 00:42:51.000000', 'consum', 0.0229, 'lps'),
	(439777, 126, '2015-03-01 00:42:52.000000', 'consum', 0.0212, 'lps'),
	(439778, 126, '2015-03-01 00:42:53.000000', 'consum', 0.0229, 'lps'),
	(439779, 126, '2015-03-01 00:42:54.000000', 'consum', 0.0215, 'lps'),
	(439780, 126, '2015-03-01 00:42:55.000000', 'consum', 0.0221, 'lps'),
	(439781, 126, '2015-03-01 00:42:56.000000', 'consum', 0.0228, 'lps'),
	(439782, 126, '2015-03-01 00:42:57.000000', 'consum', 0.0225, 'lps'),
	(439783, 126, '2015-03-01 00:42:58.000000', 'consum', 0.0230, 'lps'),
	(439784, 126, '2015-03-01 00:42:59.000000', 'consum', 0.0227, 'lps'),
	(439785, 126, '2015-03-01 00:43:00.000000', 'consum', 0.0211, 'lps'),
	(439786, 126, '2015-03-01 00:43:01.000000', 'consum', 0.0210, 'lps'),
	(439787, 126, '2015-03-01 00:43:02.000000', 'consum', 0.0226, 'lps'),
	(439788, 126, '2015-03-01 00:43:03.000000', 'consum', 0.0230, 'lps'),
	(439789, 126, '2015-03-01 00:43:04.000000', 'consum', 0.0217, 'lps'),
	(439790, 126, '2015-03-01 00:43:05.000000', 'consum', 0.0230, 'lps'),
	(439791, 126, '2015-03-01 00:43:06.000000', 'consum', 0.0227, 'lps'),
	(439792, 126, '2015-03-01 00:43:07.000000', 'consum', 0.0214, 'lps'),
	(439793, 126, '2015-03-01 00:43:08.000000', 'consum', 0.0220, 'lps'),
	(439794, 126, '2015-03-01 00:43:09.000000', 'consum', 0.0227, 'lps'),
	(439795, 126, '2015-03-01 00:43:10.000000', 'consum', 0.0224, 'lps'),
	(439796, 126, '2015-03-01 00:43:11.000000', 'consum', 0.0230, 'lps'),
	(439797, 126, '2015-03-01 00:43:12.000000', 'consum', 0.0224, 'lps'),
	(439798, 126, '2015-03-01 00:43:13.000000', 'consum', 0.0224, 'lps'),
	(439799, 126, '2015-03-01 00:43:14.000000', 'consum', 0.0216, 'lps'),
	(439800, 126, '2015-03-01 00:43:15.000000', 'consum', 0.0221, 'lps'),
	(439801, 126, '2015-03-01 00:43:16.000000', 'consum', 0.0228, 'lps'),
	(439802, 126, '2015-03-01 00:43:17.000000', 'consum', 0.0222, 'lps'),
	(439803, 126, '2015-03-01 00:43:18.000000', 'consum', 0.0219, 'lps'),
	(439804, 126, '2015-03-01 00:43:19.000000', 'consum', 0.0219, 'lps'),
	(439805, 126, '2015-03-01 00:43:20.000000', 'consum', 0.0230, 'lps'),
	(439806, 126, '2015-03-01 00:43:21.000000', 'consum', 0.0219, 'lps'),
	(439807, 126, '2015-03-01 00:43:22.000000', 'consum', 0.0218, 'lps'),
	(439808, 126, '2015-03-01 00:43:23.000000', 'consum', 0.0224, 'lps'),
	(439809, 126, '2015-03-01 00:43:24.000000', 'consum', 0.0214, 'lps'),
	(439810, 126, '2015-03-01 00:43:25.000000', 'consum', 0.0230, 'lps'),
	(439811, 126, '2015-03-01 00:43:26.000000', 'consum', 0.0216, 'lps'),
	(439812, 126, '2015-03-01 00:43:27.000000', 'consum', 0.0222, 'lps'),
	(439813, 126, '2015-03-01 00:43:28.000000', 'consum', 0.0230, 'lps'),
	(439814, 126, '2015-03-01 00:43:29.000000', 'consum', 0.0210, 'lps'),
	(439815, 126, '2015-03-01 00:43:30.000000', 'consum', 0.0217, 'lps'),
	(439816, 126, '2015-03-01 00:43:31.000000', 'consum', 0.0221, 'lps'),
	(439817, 126, '2015-03-01 00:43:32.000000', 'consum', 0.0226, 'lps'),
	(439818, 126, '2015-03-01 00:43:33.000000', 'consum', 0.0213, 'lps'),
	(439819, 126, '2015-03-01 00:43:34.000000', 'consum', 0.0221, 'lps'),
	(439820, 126, '2015-03-01 00:43:35.000000', 'consum', 0.0213, 'lps'),
	(439821, 126, '2015-03-01 00:43:36.000000', 'consum', 0.0214, 'lps'),
	(439822, 126, '2015-03-01 00:43:37.000000', 'consum', 0.0222, 'lps'),
	(439823, 126, '2015-03-01 00:43:38.000000', 'consum', 0.0217, 'lps'),
	(439824, 126, '2015-03-01 00:43:39.000000', 'consum', 0.0211, 'lps'),
	(439825, 126, '2015-03-01 00:43:40.000000', 'consum', 0.0215, 'lps'),
	(439826, 126, '2015-03-01 00:43:41.000000', 'consum', 0.0211, 'lps'),
	(439827, 126, '2015-03-01 00:43:42.000000', 'consum', 0.0220, 'lps'),
	(439828, 126, '2015-03-01 00:43:43.000000', 'consum', 0.0218, 'lps'),
	(439829, 126, '2015-03-01 00:43:44.000000', 'consum', 0.0221, 'lps'),
	(439830, 126, '2015-03-01 00:43:45.000000', 'consum', 0.0218, 'lps'),
	(439831, 126, '2015-03-01 00:43:46.000000', 'consum', 0.0217, 'lps'),
	(439832, 126, '2015-03-01 00:43:47.000000', 'consum', 0.0223, 'lps'),
	(439833, 126, '2015-03-01 00:43:48.000000', 'consum', 0.0213, 'lps'),
	(439834, 126, '2015-03-01 00:43:49.000000', 'consum', 0.0227, 'lps'),
	(439835, 126, '2015-03-01 00:43:50.000000', 'consum', 0.0224, 'lps'),
	(439836, 126, '2015-03-01 00:43:51.000000', 'consum', 0.0228, 'lps'),
	(439837, 126, '2015-03-01 00:43:52.000000', 'consum', 0.0217, 'lps'),
	(439838, 126, '2015-03-01 00:43:53.000000', 'consum', 0.0212, 'lps'),
	(439839, 126, '2015-03-01 00:43:54.000000', 'consum', 0.0220, 'lps'),
	(439840, 126, '2015-03-01 00:43:55.000000', 'consum', 0.0214, 'lps'),
	(439841, 126, '2015-03-01 00:43:56.000000', 'consum', 0.0221, 'lps'),
	(439842, 126, '2015-03-01 00:43:57.000000', 'consum', 0.0212, 'lps'),
	(439843, 126, '2015-03-01 00:43:58.000000', 'consum', 0.0210, 'lps'),
	(439844, 126, '2015-03-01 00:43:59.000000', 'consum', 0.0224, 'lps'),
	(439845, 126, '2015-03-01 00:44:00.000000', 'consum', 0.0217, 'lps'),
	(439846, 126, '2015-03-01 00:44:01.000000', 'consum', 0.0227, 'lps'),
	(439847, 126, '2015-03-01 00:44:02.000000', 'consum', 0.0230, 'lps'),
	(439848, 126, '2015-03-01 00:44:03.000000', 'consum', 0.0217, 'lps'),
	(439849, 126, '2015-03-01 00:44:04.000000', 'consum', 0.0227, 'lps'),
	(439850, 126, '2015-03-01 00:44:05.000000', 'consum', 0.0213, 'lps'),
	(439851, 126, '2015-03-01 00:44:06.000000', 'consum', 0.0217, 'lps'),
	(439852, 126, '2015-03-01 00:44:07.000000', 'consum', 0.0213, 'lps'),
	(439853, 126, '2015-03-01 00:44:08.000000', 'consum', 0.0229, 'lps'),
	(439854, 126, '2015-03-01 00:44:09.000000', 'consum', 0.0210, 'lps'),
	(439855, 126, '2015-03-01 00:44:10.000000', 'consum', 0.0219, 'lps'),
	(439856, 126, '2015-03-01 00:44:11.000000', 'consum', 0.0212, 'lps'),
	(439857, 126, '2015-03-01 00:44:12.000000', 'consum', 0.0215, 'lps'),
	(439858, 126, '2015-03-01 00:44:13.000000', 'consum', 0.0229, 'lps'),
	(439859, 126, '2015-03-01 00:44:14.000000', 'consum', 0.0228, 'lps'),
	(439860, 126, '2015-03-01 00:44:15.000000', 'consum', 0.0222, 'lps'),
	(439861, 126, '2015-03-01 00:44:16.000000', 'consum', 0.0215, 'lps'),
	(439862, 126, '2015-03-01 00:44:17.000000', 'consum', 0.0220, 'lps'),
	(439863, 126, '2015-03-01 00:44:18.000000', 'consum', 0.0228, 'lps'),
	(439864, 126, '2015-03-01 00:44:19.000000', 'consum', 0.0225, 'lps'),
	(439865, 126, '2015-03-01 00:44:20.000000', 'consum', 0.0212, 'lps'),
	(439866, 126, '2015-03-01 00:44:21.000000', 'consum', 0.0217, 'lps'),
	(439867, 126, '2015-03-01 00:44:22.000000', 'consum', 0.0220, 'lps'),
	(439868, 126, '2015-03-01 00:44:23.000000', 'consum', 0.0218, 'lps'),
	(439869, 126, '2015-03-01 00:44:24.000000', 'consum', 0.0222, 'lps'),
	(439870, 126, '2015-03-01 00:44:25.000000', 'consum', 0.0223, 'lps'),
	(439871, 126, '2015-03-01 00:44:26.000000', 'consum', 0.0219, 'lps'),
	(439872, 126, '2015-03-01 00:44:27.000000', 'consum', 0.0217, 'lps'),
	(439873, 126, '2015-03-01 00:44:28.000000', 'consum', 0.0220, 'lps'),
	(439874, 126, '2015-03-01 00:44:29.000000', 'consum', 0.0219, 'lps'),
	(439875, 126, '2015-03-01 00:44:30.000000', 'consum', 0.0226, 'lps'),
	(439876, 126, '2015-03-01 00:44:31.000000', 'consum', 0.0219, 'lps'),
	(439877, 126, '2015-03-01 00:44:32.000000', 'consum', 0.0210, 'lps'),
	(439878, 126, '2015-03-01 00:44:33.000000', 'consum', 0.0224, 'lps'),
	(439879, 126, '2015-03-01 00:44:34.000000', 'consum', 0.0217, 'lps'),
	(439880, 126, '2015-03-01 00:44:35.000000', 'consum', 0.0223, 'lps'),
	(439881, 126, '2015-03-01 00:44:36.000000', 'consum', 0.0215, 'lps'),
	(439882, 126, '2015-03-01 00:44:37.000000', 'consum', 0.0218, 'lps'),
	(439883, 126, '2015-03-01 00:44:38.000000', 'consum', 0.0212, 'lps'),
	(439884, 126, '2015-03-01 00:44:39.000000', 'consum', 0.0219, 'lps'),
	(439885, 126, '2015-03-01 00:44:40.000000', 'consum', 0.0227, 'lps'),
	(439886, 126, '2015-03-01 00:44:41.000000', 'consum', 0.0226, 'lps'),
	(439887, 126, '2015-03-01 00:44:42.000000', 'consum', 0.0218, 'lps'),
	(439888, 126, '2015-03-01 00:44:43.000000', 'consum', 0.0225, 'lps'),
	(439889, 126, '2015-03-01 00:44:44.000000', 'consum', 0.0217, 'lps'),
	(439890, 126, '2015-03-01 00:44:45.000000', 'consum', 0.0224, 'lps'),
	(439891, 126, '2015-03-01 00:44:46.000000', 'consum', 0.0217, 'lps'),
	(439892, 126, '2015-03-01 00:44:47.000000', 'consum', 0.0224, 'lps'),
	(439893, 126, '2015-03-01 00:44:48.000000', 'consum', 0.0218, 'lps'),
	(439894, 126, '2015-03-01 00:44:49.000000', 'consum', 0.0228, 'lps'),
	(439895, 126, '2015-03-01 00:44:50.000000', 'consum', 0.0215, 'lps'),
	(439896, 126, '2015-03-01 00:44:51.000000', 'consum', 0.0223, 'lps'),
	(439897, 126, '2015-03-01 00:44:52.000000', 'consum', 0.0219, 'lps'),
	(439898, 126, '2015-03-01 00:44:53.000000', 'consum', 0.0215, 'lps'),
	(439899, 126, '2015-03-01 00:44:54.000000', 'consum', 0.0229, 'lps'),
	(439900, 126, '2015-03-01 00:44:55.000000', 'consum', 0.0228, 'lps'),
	(439901, 126, '2015-03-01 00:44:56.000000', 'consum', 0.0221, 'lps'),
	(439902, 126, '2015-03-01 00:44:57.000000', 'consum', 0.0212, 'lps'),
	(439903, 126, '2015-03-01 00:44:58.000000', 'consum', 0.0230, 'lps'),
	(439904, 126, '2015-03-01 00:44:59.000000', 'consum', 0.0219, 'lps'),
	(439905, 126, '2015-03-01 00:45:00.000000', 'consum', 0.0219, 'lps'),
	(439906, 126, '2015-03-01 00:45:01.000000', 'consum', 0.0226, 'lps'),
	(439907, 126, '2015-03-01 00:45:02.000000', 'consum', 0.0223, 'lps'),
	(439908, 126, '2015-03-01 00:45:03.000000', 'consum', 0.0227, 'lps'),
	(439909, 126, '2015-03-01 00:45:04.000000', 'consum', 0.0215, 'lps'),
	(439910, 126, '2015-03-01 00:45:05.000000', 'consum', 0.0227, 'lps'),
	(439911, 126, '2015-03-01 00:45:06.000000', 'consum', 0.0218, 'lps'),
	(439912, 126, '2015-03-01 00:45:07.000000', 'consum', 0.0220, 'lps'),
	(439913, 126, '2015-03-01 00:45:08.000000', 'consum', 0.0216, 'lps'),
	(439914, 126, '2015-03-01 00:45:09.000000', 'consum', 0.0230, 'lps'),
	(439915, 126, '2015-03-01 00:45:10.000000', 'consum', 0.0229, 'lps'),
	(439916, 126, '2015-03-01 00:45:11.000000', 'consum', 0.0227, 'lps'),
	(439917, 126, '2015-03-01 00:45:12.000000', 'consum', 0.0216, 'lps'),
	(439918, 126, '2015-03-01 00:45:13.000000', 'consum', 0.0211, 'lps'),
	(439919, 126, '2015-03-01 00:45:14.000000', 'consum', 0.0217, 'lps'),
	(439920, 126, '2015-03-01 00:45:15.000000', 'consum', 0.0224, 'lps'),
	(439921, 126, '2015-03-01 00:45:16.000000', 'consum', 0.0216, 'lps'),
	(439922, 126, '2015-03-01 00:45:17.000000', 'consum', 0.0221, 'lps'),
	(439923, 126, '2015-03-01 00:45:18.000000', 'consum', 0.0224, 'lps'),
	(439924, 126, '2015-03-01 00:45:19.000000', 'consum', 0.0229, 'lps'),
	(439925, 126, '2015-03-01 00:45:20.000000', 'consum', 0.0219, 'lps'),
	(439926, 126, '2015-03-01 00:45:21.000000', 'consum', 0.0222, 'lps'),
	(439927, 126, '2015-03-01 00:45:22.000000', 'consum', 0.0223, 'lps'),
	(439928, 126, '2015-03-01 00:45:23.000000', 'consum', 0.0218, 'lps'),
	(439929, 126, '2015-03-01 00:45:24.000000', 'consum', 0.0211, 'lps'),
	(439930, 126, '2015-03-01 00:45:25.000000', 'consum', 0.0214, 'lps'),
	(439931, 126, '2015-03-01 00:45:26.000000', 'consum', 0.0227, 'lps'),
	(439932, 126, '2015-03-01 00:45:27.000000', 'consum', 0.0220, 'lps'),
	(439933, 126, '2015-03-01 00:45:28.000000', 'consum', 0.0210, 'lps'),
	(439934, 126, '2015-03-01 00:45:29.000000', 'consum', 0.0223, 'lps'),
	(439935, 126, '2015-03-01 00:45:30.000000', 'consum', 0.0213, 'lps'),
	(439936, 126, '2015-03-01 00:45:31.000000', 'consum', 0.0226, 'lps'),
	(439937, 126, '2015-03-01 00:45:32.000000', 'consum', 0.0221, 'lps'),
	(439938, 126, '2015-03-01 00:45:33.000000', 'consum', 0.0216, 'lps'),
	(439939, 126, '2015-03-01 00:45:34.000000', 'consum', 0.0230, 'lps'),
	(439940, 126, '2015-03-01 00:45:35.000000', 'consum', 0.0227, 'lps'),
	(439941, 126, '2015-03-01 00:45:36.000000', 'consum', 0.0216, 'lps'),
	(439942, 126, '2015-03-01 00:45:37.000000', 'consum', 0.0210, 'lps'),
	(439943, 126, '2015-03-01 00:45:38.000000', 'consum', 0.0213, 'lps'),
	(439944, 126, '2015-03-01 00:45:39.000000', 'consum', 0.0226, 'lps'),
	(439945, 126, '2015-03-01 00:45:40.000000', 'consum', 0.0220, 'lps'),
	(439946, 126, '2015-03-01 00:45:41.000000', 'consum', 0.0211, 'lps'),
	(439947, 126, '2015-03-01 00:45:42.000000', 'consum', 0.0226, 'lps'),
	(439948, 126, '2015-03-01 00:45:43.000000', 'consum', 0.0228, 'lps'),
	(439949, 126, '2015-03-01 00:45:44.000000', 'consum', 0.0229, 'lps'),
	(439950, 126, '2015-03-01 00:45:45.000000', 'consum', 0.0212, 'lps'),
	(439951, 126, '2015-03-01 00:45:46.000000', 'consum', 0.0224, 'lps'),
	(439952, 126, '2015-03-01 00:45:47.000000', 'consum', 0.0212, 'lps'),
	(439953, 126, '2015-03-01 00:45:48.000000', 'consum', 0.0223, 'lps'),
	(439954, 126, '2015-03-01 00:45:49.000000', 'consum', 0.0224, 'lps'),
	(439955, 126, '2015-03-01 00:45:50.000000', 'consum', 0.0223, 'lps'),
	(439956, 126, '2015-03-01 00:45:51.000000', 'consum', 0.0212, 'lps'),
	(439957, 126, '2015-03-01 00:45:52.000000', 'consum', 0.0223, 'lps'),
	(439958, 126, '2015-03-01 00:45:53.000000', 'consum', 0.0230, 'lps'),
	(439959, 126, '2015-03-01 00:45:54.000000', 'consum', 0.0226, 'lps'),
	(439960, 126, '2015-03-01 00:45:55.000000', 'consum', 0.0210, 'lps'),
	(439961, 126, '2015-03-01 00:45:56.000000', 'consum', 0.0227, 'lps'),
	(439962, 126, '2015-03-01 00:45:57.000000', 'consum', 0.0210, 'lps'),
	(439963, 126, '2015-03-01 00:45:58.000000', 'consum', 0.0224, 'lps'),
	(439964, 126, '2015-03-01 00:45:59.000000', 'consum', 0.0217, 'lps'),
	(439965, 126, '2015-03-01 00:46:00.000000', 'consum', 0.0222, 'lps'),
	(439966, 126, '2015-03-01 00:46:01.000000', 'consum', 0.0211, 'lps'),
	(439967, 126, '2015-03-01 00:46:02.000000', 'consum', 0.0220, 'lps'),
	(439968, 126, '2015-03-01 00:46:03.000000', 'consum', 0.0216, 'lps'),
	(439969, 126, '2015-03-01 00:46:04.000000', 'consum', 0.0211, 'lps'),
	(439970, 126, '2015-03-01 00:46:05.000000', 'consum', 0.0219, 'lps'),
	(439971, 126, '2015-03-01 00:46:06.000000', 'consum', 0.0230, 'lps'),
	(439972, 126, '2015-03-01 00:46:07.000000', 'consum', 0.0221, 'lps'),
	(439973, 126, '2015-03-01 00:46:08.000000', 'consum', 0.0227, 'lps'),
	(439974, 126, '2015-03-01 00:46:09.000000', 'consum', 0.0222, 'lps'),
	(439975, 126, '2015-03-01 00:46:10.000000', 'consum', 0.0218, 'lps'),
	(439976, 126, '2015-03-01 00:46:11.000000', 'consum', 0.0213, 'lps'),
	(439977, 126, '2015-03-01 00:46:12.000000', 'consum', 0.0223, 'lps'),
	(439978, 126, '2015-03-01 00:46:13.000000', 'consum', 0.0225, 'lps'),
	(439979, 126, '2015-03-01 00:46:14.000000', 'consum', 0.0227, 'lps'),
	(439980, 126, '2015-03-01 00:46:15.000000', 'consum', 0.0210, 'lps'),
	(439981, 126, '2015-03-01 00:46:16.000000', 'consum', 0.0219, 'lps'),
	(439982, 126, '2015-03-01 00:46:17.000000', 'consum', 0.0214, 'lps'),
	(439983, 126, '2015-03-01 00:46:18.000000', 'consum', 0.0223, 'lps'),
	(439984, 126, '2015-03-01 00:46:19.000000', 'consum', 0.0224, 'lps'),
	(439985, 126, '2015-03-01 00:46:20.000000', 'consum', 0.0218, 'lps'),
	(439986, 126, '2015-03-01 00:46:21.000000', 'consum', 0.0212, 'lps'),
	(439987, 126, '2015-03-01 00:46:22.000000', 'consum', 0.0215, 'lps'),
	(439988, 126, '2015-03-01 00:46:23.000000', 'consum', 0.0229, 'lps'),
	(439989, 126, '2015-03-01 00:46:24.000000', 'consum', 0.0227, 'lps'),
	(439990, 126, '2015-03-01 00:46:25.000000', 'consum', 0.0219, 'lps'),
	(439991, 126, '2015-03-01 00:46:26.000000', 'consum', 0.0224, 'lps'),
	(439992, 126, '2015-03-01 00:46:27.000000', 'consum', 0.0211, 'lps'),
	(439993, 126, '2015-03-01 00:46:28.000000', 'consum', 0.0215, 'lps'),
	(439994, 126, '2015-03-01 00:46:29.000000', 'consum', 0.0211, 'lps'),
	(439995, 126, '2015-03-01 00:46:30.000000', 'consum', 0.0221, 'lps'),
	(439996, 126, '2015-03-01 00:46:31.000000', 'consum', 0.0222, 'lps'),
	(439997, 126, '2015-03-01 00:46:32.000000', 'consum', 0.0215, 'lps'),
	(439998, 126, '2015-03-01 00:46:33.000000', 'consum', 0.0222, 'lps'),
	(439999, 126, '2015-03-01 00:46:34.000000', 'consum', 0.0215, 'lps'),
	(440000, 126, '2015-03-01 00:46:35.000000', 'consum', 0.0220, 'lps'),
	(440001, 126, '2015-03-01 00:46:36.000000', 'consum', 0.0223, 'lps'),
	(440002, 126, '2015-03-01 00:46:37.000000', 'consum', 0.0225, 'lps'),
	(440003, 126, '2015-03-01 00:46:38.000000', 'consum', 0.0227, 'lps'),
	(440004, 126, '2015-03-01 00:46:39.000000', 'consum', 0.0228, 'lps'),
	(440005, 126, '2015-03-01 00:46:40.000000', 'consum', 0.0229, 'lps'),
	(440006, 126, '2015-03-01 00:46:41.000000', 'consum', 0.0229, 'lps'),
	(440007, 126, '2015-03-01 00:46:42.000000', 'consum', 0.0230, 'lps'),
	(440008, 126, '2015-03-01 00:46:43.000000', 'consum', 0.0211, 'lps'),
	(440009, 126, '2015-03-01 00:46:44.000000', 'consum', 0.0219, 'lps'),
	(440010, 126, '2015-03-01 00:46:45.000000', 'consum', 0.0211, 'lps'),
	(440011, 126, '2015-03-01 00:46:46.000000', 'consum', 0.0210, 'lps'),
	(440012, 126, '2015-03-01 00:46:47.000000', 'consum', 0.0226, 'lps'),
	(440013, 126, '2015-03-01 00:46:48.000000', 'consum', 0.0230, 'lps'),
	(440014, 126, '2015-03-01 00:46:49.000000', 'consum', 0.0220, 'lps'),
	(440015, 126, '2015-03-01 00:46:50.000000', 'consum', 0.0222, 'lps'),
	(440016, 126, '2015-03-01 00:46:51.000000', 'consum', 0.0221, 'lps'),
	(440017, 126, '2015-03-01 00:46:52.000000', 'consum', 0.0228, 'lps'),
	(440018, 126, '2015-03-01 00:46:53.000000', 'consum', 0.0226, 'lps'),
	(440019, 126, '2015-03-01 00:46:54.000000', 'consum', 0.0215, 'lps'),
	(440020, 126, '2015-03-01 00:46:55.000000', 'consum', 0.0210, 'lps'),
	(440021, 126, '2015-03-01 00:46:56.000000', 'consum', 0.0216, 'lps'),
	(440022, 126, '2015-03-01 00:46:57.000000', 'consum', 0.0217, 'lps'),
	(440023, 126, '2015-03-01 00:46:58.000000', 'consum', 0.0230, 'lps'),
	(440024, 126, '2015-03-01 00:46:59.000000', 'consum', 0.0225, 'lps'),
	(440025, 126, '2015-03-01 00:47:00.000000', 'consum', 0.0224, 'lps'),
	(440026, 126, '2015-03-01 00:47:01.000000', 'consum', 0.0216, 'lps'),
	(440027, 126, '2015-03-01 00:47:02.000000', 'consum', 0.0218, 'lps'),
	(440028, 126, '2015-03-01 00:47:03.000000', 'consum', 0.0214, 'lps'),
	(440029, 126, '2015-03-01 00:47:04.000000', 'consum', 0.0228, 'lps'),
	(440030, 126, '2015-03-01 00:47:05.000000', 'consum', 0.0223, 'lps'),
	(440031, 126, '2015-03-01 00:47:06.000000', 'consum', 0.0223, 'lps'),
	(440032, 126, '2015-03-01 00:47:07.000000', 'consum', 0.0214, 'lps'),
	(440033, 126, '2015-03-01 00:47:08.000000', 'consum', 0.0212, 'lps'),
	(440034, 126, '2015-03-01 00:47:09.000000', 'consum', 0.0210, 'lps'),
	(440035, 126, '2015-03-01 00:47:10.000000', 'consum', 0.0224, 'lps'),
	(440036, 126, '2015-03-01 00:47:11.000000', 'consum', 0.0219, 'lps'),
	(440037, 126, '2015-03-01 00:47:12.000000', 'consum', 0.0211, 'lps'),
	(440038, 126, '2015-03-01 00:47:13.000000', 'consum', 0.0211, 'lps'),
	(440039, 126, '2015-03-01 00:47:14.000000', 'consum', 0.0214, 'lps'),
	(440040, 126, '2015-03-01 00:47:15.000000', 'consum', 0.0224, 'lps'),
	(440041, 126, '2015-03-01 00:47:16.000000', 'consum', 0.0230, 'lps'),
	(440042, 126, '2015-03-01 00:47:17.000000', 'consum', 0.0224, 'lps'),
	(440043, 126, '2015-03-01 00:47:18.000000', 'consum', 0.0223, 'lps'),
	(440044, 126, '2015-03-01 00:47:19.000000', 'consum', 0.0211, 'lps'),
	(440045, 126, '2015-03-01 00:47:20.000000', 'consum', 0.0221, 'lps'),
	(440046, 126, '2015-03-01 00:47:21.000000', 'consum', 0.0218, 'lps'),
	(440047, 126, '2015-03-01 00:47:22.000000', 'consum', 0.0216, 'lps'),
	(440048, 126, '2015-03-01 00:47:23.000000', 'consum', 0.0219, 'lps'),
	(440049, 126, '2015-03-01 00:47:24.000000', 'consum', 0.0217, 'lps'),
	(440050, 126, '2015-03-01 00:47:25.000000', 'consum', 0.0219, 'lps'),
	(440051, 126, '2015-03-01 00:47:26.000000', 'consum', 0.0213, 'lps'),
	(440052, 126, '2015-03-01 00:47:27.000000', 'consum', 0.0218, 'lps'),
	(440053, 126, '2015-03-01 00:47:28.000000', 'consum', 0.0220, 'lps'),
	(440054, 126, '2015-03-01 00:47:29.000000', 'consum', 0.0216, 'lps'),
	(440055, 126, '2015-03-01 00:47:30.000000', 'consum', 0.0212, 'lps'),
	(440056, 126, '2015-03-01 00:47:31.000000', 'consum', 0.0224, 'lps'),
	(440057, 126, '2015-03-01 00:47:32.000000', 'consum', 0.0212, 'lps'),
	(440058, 126, '2015-03-01 00:47:33.000000', 'consum', 0.0219, 'lps'),
	(440059, 126, '2015-03-01 00:47:34.000000', 'consum', 0.0230, 'lps'),
	(440060, 126, '2015-03-01 00:47:35.000000', 'consum', 0.0220, 'lps'),
	(440061, 126, '2015-03-01 00:47:36.000000', 'consum', 0.0220, 'lps'),
	(440062, 126, '2015-03-01 00:47:37.000000', 'consum', 0.0211, 'lps'),
	(440063, 126, '2015-03-01 00:47:38.000000', 'consum', 0.0227, 'lps'),
	(440064, 126, '2015-03-01 00:47:39.000000', 'consum', 0.0230, 'lps'),
	(440065, 126, '2015-03-01 00:47:40.000000', 'consum', 0.0219, 'lps'),
	(440066, 126, '2015-03-01 00:47:41.000000', 'consum', 0.0216, 'lps'),
	(440067, 126, '2015-03-01 00:47:42.000000', 'consum', 0.0214, 'lps'),
	(440068, 126, '2015-03-01 00:47:43.000000', 'consum', 0.0212, 'lps'),
	(440069, 126, '2015-03-01 00:47:44.000000', 'consum', 0.0230, 'lps'),
	(440070, 126, '2015-03-01 00:47:45.000000', 'consum', 0.0219, 'lps'),
	(440071, 126, '2015-03-01 00:47:46.000000', 'consum', 0.0216, 'lps'),
	(440072, 126, '2015-03-01 00:47:47.000000', 'consum', 0.0214, 'lps'),
	(440073, 126, '2015-03-01 00:47:48.000000', 'consum', 0.0214, 'lps'),
	(440074, 126, '2015-03-01 00:47:49.000000', 'consum', 0.0216, 'lps'),
	(440075, 126, '2015-03-01 00:47:50.000000', 'consum', 0.0228, 'lps'),
	(440076, 126, '2015-03-01 00:47:51.000000', 'consum', 0.0220, 'lps'),
	(440077, 126, '2015-03-01 00:47:52.000000', 'consum', 0.0228, 'lps'),
	(440078, 126, '2015-03-01 00:47:53.000000', 'consum', 0.0230, 'lps'),
	(440079, 126, '2015-03-01 00:47:54.000000', 'consum', 0.0212, 'lps'),
	(440080, 126, '2015-03-01 00:47:55.000000', 'consum', 0.0223, 'lps'),
	(440081, 126, '2015-03-01 00:47:56.000000', 'consum', 0.0228, 'lps'),
	(440082, 126, '2015-03-01 00:47:57.000000', 'consum', 0.0222, 'lps'),
	(440083, 126, '2015-03-01 00:47:58.000000', 'consum', 0.0214, 'lps'),
	(440084, 126, '2015-03-01 00:47:59.000000', 'consum', 0.0218, 'lps'),
	(440085, 126, '2015-03-01 00:48:00.000000', 'consum', 0.0217, 'lps'),
	(440086, 126, '2015-03-01 00:48:01.000000', 'consum', 0.0222, 'lps'),
	(440087, 126, '2015-03-01 00:48:02.000000', 'consum', 0.0229, 'lps'),
	(440088, 126, '2015-03-01 00:48:03.000000', 'consum', 0.0227, 'lps'),
	(440089, 126, '2015-03-01 00:48:04.000000', 'consum', 0.0217, 'lps'),
	(440090, 126, '2015-03-01 00:48:05.000000', 'consum', 0.0218, 'lps'),
	(440091, 126, '2015-03-01 00:48:06.000000', 'consum', 0.0227, 'lps'),
	(440092, 126, '2015-03-01 00:48:07.000000', 'consum', 0.0228, 'lps'),
	(440093, 126, '2015-03-01 00:48:08.000000', 'consum', 0.0210, 'lps'),
	(440094, 126, '2015-03-01 00:48:09.000000', 'consum', 0.0218, 'lps'),
	(440095, 126, '2015-03-01 00:48:10.000000', 'consum', 0.0229, 'lps'),
	(440096, 126, '2015-03-01 00:48:11.000000', 'consum', 0.0221, 'lps'),
	(440097, 126, '2015-03-01 00:48:12.000000', 'consum', 0.0230, 'lps'),
	(440098, 126, '2015-03-01 00:48:13.000000', 'consum', 0.0213, 'lps'),
	(440099, 126, '2015-03-01 00:48:14.000000', 'consum', 0.0228, 'lps'),
	(440100, 126, '2015-03-01 00:48:15.000000', 'consum', 0.0229, 'lps'),
	(440101, 126, '2015-03-01 00:48:16.000000', 'consum', 0.0229, 'lps'),
	(440102, 126, '2015-03-01 00:48:17.000000', 'consum', 0.0229, 'lps'),
	(440103, 126, '2015-03-01 00:48:18.000000', 'consum', 0.0226, 'lps'),
	(440104, 126, '2015-03-01 00:48:19.000000', 'consum', 0.0211, 'lps'),
	(440105, 126, '2015-03-01 00:48:20.000000', 'consum', 0.0213, 'lps'),
	(440106, 126, '2015-03-01 00:48:21.000000', 'consum', 0.0221, 'lps'),
	(440107, 126, '2015-03-01 00:48:22.000000', 'consum', 0.0216, 'lps'),
	(440108, 126, '2015-03-01 00:48:23.000000', 'consum', 0.0226, 'lps'),
	(440109, 126, '2015-03-01 00:48:24.000000', 'consum', 0.0230, 'lps'),
	(440110, 126, '2015-03-01 00:48:25.000000', 'consum', 0.0220, 'lps'),
	(440111, 126, '2015-03-01 00:48:26.000000', 'consum', 0.0221, 'lps'),
	(440112, 126, '2015-03-01 00:48:27.000000', 'consum', 0.0217, 'lps'),
	(440113, 126, '2015-03-01 00:48:28.000000', 'consum', 0.0210, 'lps'),
	(440114, 126, '2015-03-01 00:48:29.000000', 'consum', 0.0213, 'lps'),
	(440115, 126, '2015-03-01 00:48:30.000000', 'consum', 0.0223, 'lps'),
	(440116, 126, '2015-03-01 00:48:31.000000', 'consum', 0.0226, 'lps'),
	(440117, 126, '2015-03-01 00:48:32.000000', 'consum', 0.0229, 'lps'),
	(440118, 126, '2015-03-01 00:48:33.000000', 'consum', 0.0218, 'lps'),
	(440119, 126, '2015-03-01 00:48:34.000000', 'consum', 0.0213, 'lps'),
	(440120, 126, '2015-03-01 00:48:35.000000', 'consum', 0.0224, 'lps'),
	(440121, 126, '2015-03-01 00:48:36.000000', 'consum', 0.0229, 'lps'),
	(440122, 126, '2015-03-01 00:48:37.000000', 'consum', 0.0222, 'lps'),
	(440123, 126, '2015-03-01 00:48:38.000000', 'consum', 0.0213, 'lps'),
	(440124, 126, '2015-03-01 00:48:39.000000', 'consum', 0.0210, 'lps'),
	(440125, 126, '2015-03-01 00:48:40.000000', 'consum', 0.0224, 'lps'),
	(440126, 126, '2015-03-01 00:48:41.000000', 'consum', 0.0216, 'lps'),
	(440127, 126, '2015-03-01 00:48:42.000000', 'consum', 0.0220, 'lps'),
	(440128, 126, '2015-03-01 00:48:43.000000', 'consum', 0.0221, 'lps'),
	(440129, 126, '2015-03-01 00:48:44.000000', 'consum', 0.0215, 'lps'),
	(440130, 126, '2015-03-01 00:48:45.000000', 'consum', 0.0225, 'lps'),
	(440131, 126, '2015-03-01 00:48:46.000000', 'consum', 0.0226, 'lps'),
	(440132, 126, '2015-03-01 00:48:47.000000', 'consum', 0.0226, 'lps'),
	(440133, 126, '2015-03-01 00:48:48.000000', 'consum', 0.0221, 'lps'),
	(440134, 126, '2015-03-01 00:48:49.000000', 'consum', 0.0216, 'lps'),
	(440135, 126, '2015-03-01 00:48:50.000000', 'consum', 0.0210, 'lps'),
	(440136, 126, '2015-03-01 00:48:51.000000', 'consum', 0.0213, 'lps'),
	(440137, 126, '2015-03-01 00:48:52.000000', 'consum', 0.0226, 'lps'),
	(440138, 126, '2015-03-01 00:48:53.000000', 'consum', 0.0217, 'lps'),
	(440139, 126, '2015-03-01 00:48:54.000000', 'consum', 0.0221, 'lps'),
	(440140, 126, '2015-03-01 00:48:55.000000', 'consum', 0.0220, 'lps'),
	(440141, 126, '2015-03-01 00:48:56.000000', 'consum', 0.0230, 'lps'),
	(440142, 126, '2015-03-01 00:48:57.000000', 'consum', 0.0216, 'lps'),
	(440143, 126, '2015-03-01 00:48:58.000000', 'consum', 0.0221, 'lps'),
	(440144, 126, '2015-03-01 00:48:59.000000', 'consum', 0.0228, 'lps'),
	(440145, 126, '2015-03-01 00:49:00.000000', 'consum', 0.0227, 'lps'),
	(440146, 126, '2015-03-01 00:49:01.000000', 'consum', 0.0217, 'lps'),
	(440147, 126, '2015-03-01 00:49:02.000000', 'consum', 0.0219, 'lps'),
	(440148, 126, '2015-03-01 00:49:03.000000', 'consum', 0.0213, 'lps'),
	(440149, 126, '2015-03-01 00:49:04.000000', 'consum', 0.0219, 'lps'),
	(440150, 126, '2015-03-01 00:49:05.000000', 'consum', 0.0226, 'lps'),
	(440151, 126, '2015-03-01 00:49:06.000000', 'consum', 0.0220, 'lps'),
	(440152, 126, '2015-03-01 00:49:07.000000', 'consum', 0.0214, 'lps'),
	(440153, 126, '2015-03-01 00:49:08.000000', 'consum', 0.0222, 'lps'),
	(440154, 126, '2015-03-01 00:49:09.000000', 'consum', 0.0215, 'lps'),
	(440155, 126, '2015-03-01 00:49:10.000000', 'consum', 0.0222, 'lps'),
	(440156, 126, '2015-03-01 00:49:11.000000', 'consum', 0.0213, 'lps'),
	(440157, 126, '2015-03-01 00:49:12.000000', 'consum', 0.0210, 'lps'),
	(440158, 126, '2015-03-01 00:49:13.000000', 'consum', 0.0222, 'lps'),
	(440159, 126, '2015-03-01 00:49:14.000000', 'consum', 0.0229, 'lps'),
	(440160, 126, '2015-03-01 00:49:15.000000', 'consum', 0.0228, 'lps'),
	(440161, 126, '2015-03-01 00:49:16.000000', 'consum', 0.0224, 'lps'),
	(440162, 126, '2015-03-01 00:49:17.000000', 'consum', 0.0226, 'lps'),
	(440163, 126, '2015-03-01 00:49:18.000000', 'consum', 0.0227, 'lps'),
	(440164, 126, '2015-03-01 00:49:19.000000', 'consum', 0.0227, 'lps'),
	(440165, 126, '2015-03-01 00:49:20.000000', 'consum', 0.0222, 'lps'),
	(440166, 126, '2015-03-01 00:49:21.000000', 'consum', 0.0219, 'lps'),
	(440167, 126, '2015-03-01 00:49:22.000000', 'consum', 0.0223, 'lps'),
	(440168, 126, '2015-03-01 00:49:23.000000', 'consum', 0.0224, 'lps'),
	(440169, 126, '2015-03-01 00:49:24.000000', 'consum', 0.0220, 'lps'),
	(440170, 126, '2015-03-01 00:49:25.000000', 'consum', 0.0221, 'lps'),
	(440171, 126, '2015-03-01 00:49:26.000000', 'consum', 0.0213, 'lps'),
	(440172, 126, '2015-03-01 00:49:27.000000', 'consum', 0.0213, 'lps'),
	(440173, 126, '2015-03-01 00:49:28.000000', 'consum', 0.0219, 'lps'),
	(440174, 126, '2015-03-01 00:49:29.000000', 'consum', 0.0225, 'lps'),
	(440175, 126, '2015-03-01 00:49:30.000000', 'consum', 0.0215, 'lps'),
	(440176, 126, '2015-03-01 00:49:31.000000', 'consum', 0.0213, 'lps'),
	(440177, 126, '2015-03-01 00:49:32.000000', 'consum', 0.0229, 'lps'),
	(440178, 126, '2015-03-01 00:49:33.000000', 'consum', 0.0216, 'lps'),
	(440179, 126, '2015-03-01 00:49:34.000000', 'consum', 0.0223, 'lps'),
	(440180, 126, '2015-03-01 00:49:35.000000', 'consum', 0.0217, 'lps'),
	(440181, 126, '2015-03-01 00:49:36.000000', 'consum', 0.0225, 'lps'),
	(440182, 126, '2015-03-01 00:49:37.000000', 'consum', 0.0225, 'lps'),
	(440183, 126, '2015-03-01 00:49:38.000000', 'consum', 0.0217, 'lps'),
	(440184, 126, '2015-03-01 00:49:39.000000', 'consum', 0.0221, 'lps'),
	(440185, 126, '2015-03-01 00:49:40.000000', 'consum', 0.0226, 'lps'),
	(440186, 126, '2015-03-01 00:49:41.000000', 'consum', 0.0214, 'lps'),
	(440187, 126, '2015-03-01 00:49:42.000000', 'consum', 0.0226, 'lps'),
	(440188, 126, '2015-03-01 00:49:43.000000', 'consum', 0.0217, 'lps'),
	(440189, 126, '2015-03-01 00:49:44.000000', 'consum', 0.0216, 'lps'),
	(440190, 126, '2015-03-01 00:49:45.000000', 'consum', 0.0218, 'lps'),
	(440191, 126, '2015-03-01 00:49:46.000000', 'consum', 0.0215, 'lps'),
	(440192, 126, '2015-03-01 00:49:47.000000', 'consum', 0.0210, 'lps'),
	(440193, 126, '2015-03-01 00:49:48.000000', 'consum', 0.0215, 'lps'),
	(440194, 126, '2015-03-01 00:49:49.000000', 'consum', 0.0215, 'lps'),
	(440195, 126, '2015-03-01 00:49:50.000000', 'consum', 0.0223, 'lps'),
	(440196, 126, '2015-03-01 00:49:51.000000', 'consum', 0.0215, 'lps'),
	(440197, 126, '2015-03-01 00:49:52.000000', 'consum', 0.0219, 'lps'),
	(440198, 126, '2015-03-01 00:49:53.000000', 'consum', 0.0221, 'lps'),
	(440199, 126, '2015-03-01 00:49:54.000000', 'consum', 0.0215, 'lps'),
	(440200, 126, '2015-03-01 00:49:55.000000', 'consum', 0.0224, 'lps'),
	(440201, 126, '2015-03-01 00:49:56.000000', 'consum', 0.0222, 'lps'),
	(440202, 126, '2015-03-01 00:49:57.000000', 'consum', 0.0210, 'lps'),
	(440203, 126, '2015-03-01 00:49:58.000000', 'consum', 0.0218, 'lps'),
	(440204, 126, '2015-03-01 00:49:59.000000', 'consum', 0.0227, 'lps'),
	(440205, 126, '2015-03-01 00:50:00.000000', 'consum', 0.0228, 'lps'),
	(440206, 126, '2015-03-01 00:50:01.000000', 'consum', 0.0230, 'lps'),
	(440207, 126, '2015-03-01 00:50:02.000000', 'consum', 0.0216, 'lps'),
	(440208, 126, '2015-03-01 00:50:03.000000', 'consum', 0.0220, 'lps'),
	(440209, 126, '2015-03-01 00:50:04.000000', 'consum', 0.0224, 'lps'),
	(440210, 126, '2015-03-01 00:50:05.000000', 'consum', 0.0227, 'lps'),
	(440211, 126, '2015-03-01 00:50:06.000000', 'consum', 0.0212, 'lps'),
	(440212, 126, '2015-03-01 00:50:07.000000', 'consum', 0.0211, 'lps'),
	(440213, 126, '2015-03-01 00:50:08.000000', 'consum', 0.0229, 'lps'),
	(440214, 126, '2015-03-01 00:50:09.000000', 'consum', 0.0222, 'lps'),
	(440215, 126, '2015-03-01 00:50:10.000000', 'consum', 0.0212, 'lps'),
	(440216, 126, '2015-03-01 00:50:11.000000', 'consum', 0.0227, 'lps'),
	(440217, 126, '2015-03-01 00:50:12.000000', 'consum', 0.0227, 'lps'),
	(440218, 126, '2015-03-01 00:50:13.000000', 'consum', 0.0223, 'lps'),
	(440219, 126, '2015-03-01 00:50:14.000000', 'consum', 0.0223, 'lps'),
	(440220, 126, '2015-03-01 00:50:15.000000', 'consum', 0.0216, 'lps'),
	(440221, 126, '2015-03-01 00:50:16.000000', 'consum', 0.0223, 'lps'),
	(440222, 126, '2015-03-01 00:50:17.000000', 'consum', 0.0214, 'lps'),
	(440223, 126, '2015-03-01 00:50:18.000000', 'consum', 0.0213, 'lps'),
	(440224, 126, '2015-03-01 00:50:19.000000', 'consum', 0.0212, 'lps'),
	(440225, 126, '2015-03-01 00:50:20.000000', 'consum', 0.0212, 'lps'),
	(440226, 126, '2015-03-01 00:50:21.000000', 'consum', 0.0216, 'lps'),
	(440227, 126, '2015-03-01 00:50:22.000000', 'consum', 0.0213, 'lps'),
	(440228, 126, '2015-03-01 00:50:23.000000', 'consum', 0.0227, 'lps'),
	(440229, 126, '2015-03-01 00:50:24.000000', 'consum', 0.0223, 'lps'),
	(440230, 126, '2015-03-01 00:50:25.000000', 'consum', 0.0227, 'lps'),
	(440231, 126, '2015-03-01 00:50:26.000000', 'consum', 0.0213, 'lps'),
	(440232, 126, '2015-03-01 00:50:27.000000', 'consum', 0.0217, 'lps'),
	(440233, 126, '2015-03-01 00:50:28.000000', 'consum', 0.0214, 'lps'),
	(440234, 126, '2015-03-01 00:50:29.000000', 'consum', 0.0211, 'lps'),
	(440235, 126, '2015-03-01 00:50:30.000000', 'consum', 0.0225, 'lps'),
	(440236, 126, '2015-03-01 00:50:31.000000', 'consum', 0.0219, 'lps'),
	(440237, 126, '2015-03-01 00:50:32.000000', 'consum', 0.0211, 'lps'),
	(440238, 126, '2015-03-01 00:50:33.000000', 'consum', 0.0230, 'lps'),
	(440239, 126, '2015-03-01 00:50:34.000000', 'consum', 0.0223, 'lps'),
	(440240, 126, '2015-03-01 00:50:35.000000', 'consum', 0.0218, 'lps'),
	(440241, 126, '2015-03-01 00:50:36.000000', 'consum', 0.0230, 'lps'),
	(440242, 126, '2015-03-01 00:50:37.000000', 'consum', 0.0224, 'lps'),
	(440243, 126, '2015-03-01 00:50:38.000000', 'consum', 0.0221, 'lps'),
	(440244, 126, '2015-03-01 00:50:39.000000', 'consum', 0.0224, 'lps'),
	(440245, 126, '2015-03-01 00:50:40.000000', 'consum', 0.0224, 'lps'),
	(440246, 126, '2015-03-01 00:50:41.000000', 'consum', 0.0218, 'lps'),
	(440247, 126, '2015-03-01 00:50:42.000000', 'consum', 0.0210, 'lps'),
	(440248, 126, '2015-03-01 00:50:43.000000', 'consum', 0.0229, 'lps'),
	(440249, 126, '2015-03-01 00:50:44.000000', 'consum', 0.0223, 'lps'),
	(440250, 126, '2015-03-01 00:50:45.000000', 'consum', 0.0216, 'lps'),
	(440251, 126, '2015-03-01 00:50:46.000000', 'consum', 0.0222, 'lps'),
	(440252, 126, '2015-03-01 00:50:47.000000', 'consum', 0.0213, 'lps'),
	(440253, 126, '2015-03-01 00:50:48.000000', 'consum', 0.0211, 'lps'),
	(440254, 126, '2015-03-01 00:50:49.000000', 'consum', 0.0227, 'lps'),
	(440255, 126, '2015-03-01 00:50:50.000000', 'consum', 0.0228, 'lps'),
	(440256, 126, '2015-03-01 00:50:51.000000', 'consum', 0.0229, 'lps'),
	(440257, 126, '2015-03-01 00:50:52.000000', 'consum', 0.0210, 'lps'),
	(440258, 126, '2015-03-01 00:50:53.000000', 'consum', 0.0217, 'lps'),
	(440259, 126, '2015-03-01 00:50:54.000000', 'consum', 0.0224, 'lps'),
	(440260, 126, '2015-03-01 00:50:55.000000', 'consum', 0.0219, 'lps'),
	(440261, 126, '2015-03-01 00:50:56.000000', 'consum', 0.0211, 'lps'),
	(440262, 126, '2015-03-01 00:50:57.000000', 'consum', 0.0212, 'lps'),
	(440263, 126, '2015-03-01 00:50:58.000000', 'consum', 0.0215, 'lps'),
	(440264, 126, '2015-03-01 00:50:59.000000', 'consum', 0.0211, 'lps'),
	(440265, 126, '2015-03-01 00:51:00.000000', 'consum', 0.0220, 'lps'),
	(440266, 126, '2015-03-01 00:51:01.000000', 'consum', 0.0218, 'lps'),
	(440267, 126, '2015-03-01 00:51:02.000000', 'consum', 0.0218, 'lps'),
	(440268, 126, '2015-03-01 00:51:03.000000', 'consum', 0.0229, 'lps'),
	(440269, 126, '2015-03-01 00:51:04.000000', 'consum', 0.0217, 'lps'),
	(440270, 126, '2015-03-01 00:51:05.000000', 'consum', 0.0210, 'lps'),
	(440271, 126, '2015-03-01 00:51:06.000000', 'consum', 0.0230, 'lps'),
	(440272, 126, '2015-03-01 00:51:07.000000', 'consum', 0.0228, 'lps'),
	(440273, 126, '2015-03-01 00:51:08.000000', 'consum', 0.0217, 'lps'),
	(440274, 126, '2015-03-01 00:51:09.000000', 'consum', 0.0215, 'lps'),
	(440275, 126, '2015-03-01 00:51:10.000000', 'consum', 0.0212, 'lps'),
	(440276, 126, '2015-03-01 00:51:11.000000', 'consum', 0.0228, 'lps'),
	(440277, 126, '2015-03-01 00:51:12.000000', 'consum', 0.0212, 'lps'),
	(440278, 126, '2015-03-01 00:51:13.000000', 'consum', 0.0229, 'lps'),
	(440279, 126, '2015-03-01 00:51:14.000000', 'consum', 0.0213, 'lps'),
	(440280, 126, '2015-03-01 00:51:15.000000', 'consum', 0.0212, 'lps'),
	(440281, 126, '2015-03-01 00:51:16.000000', 'consum', 0.0210, 'lps'),
	(440282, 126, '2015-03-01 00:51:17.000000', 'consum', 0.0226, 'lps'),
	(440283, 126, '2015-03-01 00:51:18.000000', 'consum', 0.0230, 'lps'),
	(440284, 126, '2015-03-01 00:51:19.000000', 'consum', 0.0217, 'lps'),
	(440285, 126, '2015-03-01 00:51:20.000000', 'consum', 0.0230, 'lps'),
	(440286, 126, '2015-03-01 00:51:21.000000', 'consum', 0.0226, 'lps'),
	(440287, 126, '2015-03-01 00:51:22.000000', 'consum', 0.0229, 'lps'),
	(440288, 126, '2015-03-01 00:51:23.000000', 'consum', 0.0217, 'lps'),
	(440289, 126, '2015-03-01 00:51:24.000000', 'consum', 0.0211, 'lps'),
	(440290, 126, '2015-03-01 00:51:25.000000', 'consum', 0.0214, 'lps'),
	(440291, 126, '2015-03-01 00:51:26.000000', 'consum', 0.0226, 'lps'),
	(440292, 126, '2015-03-01 00:51:27.000000', 'consum', 0.0215, 'lps'),
	(440293, 126, '2015-03-01 00:51:28.000000', 'consum', 0.0229, 'lps'),
	(440294, 126, '2015-03-01 00:51:29.000000', 'consum', 0.0230, 'lps'),
	(440295, 126, '2015-03-01 00:51:30.000000', 'consum', 0.0230, 'lps'),
	(440296, 126, '2015-03-01 00:51:31.000000', 'consum', 0.0229, 'lps'),
	(440297, 126, '2015-03-01 00:51:32.000000', 'consum', 0.0225, 'lps'),
	(440298, 126, '2015-03-01 00:51:33.000000', 'consum', 0.0230, 'lps'),
	(440299, 126, '2015-03-01 00:51:34.000000', 'consum', 0.0225, 'lps'),
	(440300, 126, '2015-03-01 00:51:35.000000', 'consum', 0.0223, 'lps'),
	(440301, 126, '2015-03-01 00:51:36.000000', 'consum', 0.0211, 'lps'),
	(440302, 126, '2015-03-01 00:51:37.000000', 'consum', 0.0217, 'lps'),
	(440303, 126, '2015-03-01 00:51:38.000000', 'consum', 0.0220, 'lps'),
	(440304, 126, '2015-03-01 00:51:39.000000', 'consum', 0.0221, 'lps'),
	(440305, 126, '2015-03-01 00:51:40.000000', 'consum', 0.0215, 'lps'),
	(440306, 126, '2015-03-01 00:51:41.000000', 'consum', 0.0225, 'lps'),
	(440307, 126, '2015-03-01 00:51:42.000000', 'consum', 0.0225, 'lps'),
	(440308, 126, '2015-03-01 00:51:43.000000', 'consum', 0.0222, 'lps'),
	(440309, 126, '2015-03-01 00:51:44.000000', 'consum', 0.0224, 'lps'),
	(440310, 126, '2015-03-01 00:51:45.000000', 'consum', 0.0225, 'lps'),
	(440311, 126, '2015-03-01 00:51:46.000000', 'consum', 0.0220, 'lps'),
	(440312, 126, '2015-03-01 00:51:47.000000', 'consum', 0.0217, 'lps'),
	(440313, 126, '2015-03-01 00:51:48.000000', 'consum', 0.0215, 'lps'),
	(440314, 126, '2015-03-01 00:51:49.000000', 'consum', 0.0213, 'lps'),
	(440315, 126, '2015-03-01 00:51:50.000000', 'consum', 0.0210, 'lps'),
	(440316, 126, '2015-03-01 00:51:51.000000', 'consum', 0.0223, 'lps'),
	(440317, 126, '2015-03-01 00:51:52.000000', 'consum', 0.0215, 'lps'),
	(440318, 126, '2015-03-01 00:51:53.000000', 'consum', 0.0215, 'lps'),
	(440319, 126, '2015-03-01 00:51:54.000000', 'consum', 0.0222, 'lps'),
	(440320, 126, '2015-03-01 00:51:55.000000', 'consum', 0.0212, 'lps'),
	(440321, 126, '2015-03-01 00:51:56.000000', 'consum', 0.0227, 'lps'),
	(440322, 126, '2015-03-01 00:51:57.000000', 'consum', 0.0229, 'lps'),
	(440323, 126, '2015-03-01 00:51:58.000000', 'consum', 0.0230, 'lps'),
	(440324, 126, '2015-03-01 00:51:59.000000', 'consum', 0.0215, 'lps'),
	(440325, 126, '2015-03-01 00:52:00.000000', 'consum', 0.0214, 'lps'),
	(440326, 126, '2015-03-01 00:52:01.000000', 'consum', 0.0217, 'lps'),
	(440327, 126, '2015-03-01 00:52:02.000000', 'consum', 0.0214, 'lps'),
	(440328, 126, '2015-03-01 00:52:03.000000', 'consum', 0.0210, 'lps'),
	(440329, 126, '2015-03-01 00:52:04.000000', 'consum', 0.0218, 'lps'),
	(440330, 126, '2015-03-01 00:52:05.000000', 'consum', 0.0210, 'lps'),
	(440331, 126, '2015-03-01 00:52:06.000000', 'consum', 0.0227, 'lps'),
	(440332, 126, '2015-03-01 00:52:07.000000', 'consum', 0.0212, 'lps'),
	(440333, 126, '2015-03-01 00:52:08.000000', 'consum', 0.0213, 'lps'),
	(440334, 126, '2015-03-01 00:52:09.000000', 'consum', 0.0220, 'lps'),
	(440335, 126, '2015-03-01 00:52:10.000000', 'consum', 0.0230, 'lps'),
	(440336, 126, '2015-03-01 00:52:11.000000', 'consum', 0.0218, 'lps'),
	(440337, 126, '2015-03-01 00:52:12.000000', 'consum', 0.0210, 'lps'),
	(440338, 126, '2015-03-01 00:52:13.000000', 'consum', 0.0227, 'lps'),
	(440339, 126, '2015-03-01 00:52:14.000000', 'consum', 0.0215, 'lps'),
	(440340, 126, '2015-03-01 00:52:15.000000', 'consum', 0.0223, 'lps'),
	(440341, 126, '2015-03-01 00:52:16.000000', 'consum', 0.0221, 'lps'),
	(440342, 126, '2015-03-01 00:52:17.000000', 'consum', 0.0228, 'lps'),
	(440343, 126, '2015-03-01 00:52:18.000000', 'consum', 0.0222, 'lps'),
	(440344, 126, '2015-03-01 00:52:19.000000', 'consum', 0.0220, 'lps'),
	(440345, 126, '2015-03-01 00:52:20.000000', 'consum', 0.0223, 'lps'),
	(440346, 126, '2015-03-01 00:52:21.000000', 'consum', 0.0222, 'lps'),
	(440347, 126, '2015-03-01 00:52:22.000000', 'consum', 0.0214, 'lps'),
	(440348, 126, '2015-03-01 00:52:23.000000', 'consum', 0.0215, 'lps'),
	(440349, 126, '2015-03-01 00:52:24.000000', 'consum', 0.0223, 'lps'),
	(440350, 126, '2015-03-01 00:52:25.000000', 'consum', 0.0219, 'lps'),
	(440351, 126, '2015-03-01 00:52:26.000000', 'consum', 0.0217, 'lps'),
	(440352, 126, '2015-03-01 00:52:27.000000', 'consum', 0.0220, 'lps'),
	(440353, 126, '2015-03-01 00:52:28.000000', 'consum', 0.0216, 'lps'),
	(440354, 126, '2015-03-01 00:52:29.000000', 'consum', 0.0212, 'lps'),
	(440355, 126, '2015-03-01 00:52:30.000000', 'consum', 0.0224, 'lps'),
	(440356, 126, '2015-03-01 00:52:31.000000', 'consum', 0.0211, 'lps'),
	(440357, 126, '2015-03-01 00:52:32.000000', 'consum', 0.0215, 'lps'),
	(440358, 126, '2015-03-01 00:52:33.000000', 'consum', 0.0213, 'lps'),
	(440359, 126, '2015-03-01 00:52:34.000000', 'consum', 0.0210, 'lps'),
	(440360, 126, '2015-03-01 00:52:35.000000', 'consum', 0.0223, 'lps'),
	(440361, 126, '2015-03-01 00:52:36.000000', 'consum', 0.0211, 'lps'),
	(440362, 126, '2015-03-01 00:52:37.000000', 'consum', 0.0218, 'lps'),
	(440363, 126, '2015-03-01 00:52:38.000000', 'consum', 0.0228, 'lps'),
	(440364, 126, '2015-03-01 00:52:39.000000', 'consum', 0.0215, 'lps'),
	(440365, 126, '2015-03-01 00:52:40.000000', 'consum', 0.0221, 'lps'),
	(440366, 126, '2015-03-01 00:52:41.000000', 'consum', 0.0210, 'lps'),
	(440367, 126, '2015-03-01 00:52:42.000000', 'consum', 0.0219, 'lps'),
	(440368, 126, '2015-03-01 00:52:43.000000', 'consum', 0.0212, 'lps'),
	(440369, 126, '2015-03-01 00:52:44.000000', 'consum', 0.0214, 'lps'),
	(440370, 126, '2015-03-01 00:52:45.000000', 'consum', 0.0225, 'lps'),
	(440371, 126, '2015-03-01 00:52:46.000000', 'consum', 0.0211, 'lps'),
	(440372, 126, '2015-03-01 00:52:47.000000', 'consum', 0.0213, 'lps'),
	(440373, 126, '2015-03-01 00:52:48.000000', 'consum', 0.0223, 'lps'),
	(440374, 126, '2015-03-01 00:52:49.000000', 'consum', 0.0224, 'lps'),
	(440375, 126, '2015-03-01 00:52:50.000000', 'consum', 0.0222, 'lps'),
	(440376, 126, '2015-03-01 00:52:51.000000', 'consum', 0.0228, 'lps'),
	(440377, 126, '2015-03-01 00:52:52.000000', 'consum', 0.0222, 'lps'),
	(440378, 126, '2015-03-01 00:52:53.000000', 'consum', 0.0215, 'lps'),
	(440379, 126, '2015-03-01 00:52:54.000000', 'consum', 0.0224, 'lps'),
	(440380, 126, '2015-03-01 00:52:55.000000', 'consum', 0.0220, 'lps'),
	(440381, 126, '2015-03-01 00:52:56.000000', 'consum', 0.0219, 'lps'),
	(440382, 126, '2015-03-01 00:52:57.000000', 'consum', 0.0227, 'lps'),
	(440383, 126, '2015-03-01 00:52:58.000000', 'consum', 0.0228, 'lps'),
	(440384, 126, '2015-03-01 00:52:59.000000', 'consum', 0.0227, 'lps'),
	(440385, 126, '2015-03-01 00:53:00.000000', 'consum', 0.0218, 'lps'),
	(440386, 126, '2015-03-01 00:53:01.000000', 'consum', 0.0224, 'lps'),
	(440387, 126, '2015-03-01 00:53:02.000000', 'consum', 0.0213, 'lps'),
	(440388, 126, '2015-03-01 00:53:03.000000', 'consum', 0.0226, 'lps'),
	(440389, 126, '2015-03-01 00:53:04.000000', 'consum', 0.0217, 'lps'),
	(440390, 126, '2015-03-01 00:53:05.000000', 'consum', 0.0217, 'lps'),
	(440391, 126, '2015-03-01 00:53:06.000000', 'consum', 0.0228, 'lps'),
	(440392, 126, '2015-03-01 00:53:07.000000', 'consum', 0.0213, 'lps'),
	(440393, 126, '2015-03-01 00:53:08.000000', 'consum', 0.0217, 'lps'),
	(440394, 126, '2015-03-01 00:53:09.000000', 'consum', 0.0213, 'lps'),
	(440395, 126, '2015-03-01 00:53:10.000000', 'consum', 0.0226, 'lps'),
	(440396, 126, '2015-03-01 00:53:11.000000', 'consum', 0.0217, 'lps'),
	(440397, 126, '2015-03-01 00:53:12.000000', 'consum', 0.0220, 'lps'),
	(440398, 126, '2015-03-01 00:53:13.000000', 'consum', 0.0218, 'lps'),
	(440399, 126, '2015-03-01 00:53:14.000000', 'consum', 0.0222, 'lps'),
	(440400, 126, '2015-03-01 00:53:15.000000', 'consum', 0.0225, 'lps'),
	(440401, 126, '2015-03-01 00:53:16.000000', 'consum', 0.0229, 'lps'),
	(440402, 126, '2015-03-01 00:53:17.000000', 'consum', 0.0219, 'lps'),
	(440403, 126, '2015-03-01 00:53:18.000000', 'consum', 0.0219, 'lps'),
	(440404, 126, '2015-03-01 00:53:19.000000', 'consum', 0.0227, 'lps'),
	(440405, 126, '2015-03-01 00:53:20.000000', 'consum', 0.0228, 'lps'),
	(440406, 126, '2015-03-01 00:53:21.000000', 'consum', 0.0229, 'lps'),
	(440407, 126, '2015-03-01 00:53:22.000000', 'consum', 0.0229, 'lps'),
	(440408, 126, '2015-03-01 00:53:23.000000', 'consum', 0.0229, 'lps'),
	(440409, 126, '2015-03-01 00:53:24.000000', 'consum', 0.0225, 'lps'),
	(440410, 126, '2015-03-01 00:53:25.000000', 'consum', 0.0230, 'lps'),
	(440411, 126, '2015-03-01 00:53:26.000000', 'consum', 0.0224, 'lps'),
	(440412, 126, '2015-03-01 00:53:27.000000', 'consum', 0.0219, 'lps'),
	(440413, 126, '2015-03-01 00:53:28.000000', 'consum', 0.0213, 'lps'),
	(440414, 126, '2015-03-01 00:53:29.000000', 'consum', 0.0221, 'lps'),
	(440415, 126, '2015-03-01 00:53:30.000000', 'consum', 0.0214, 'lps'),
	(440416, 126, '2015-03-01 00:53:31.000000', 'consum', 0.0219, 'lps'),
	(440417, 126, '2015-03-01 00:53:32.000000', 'consum', 0.0221, 'lps'),
	(440418, 126, '2015-03-01 00:53:33.000000', 'consum', 0.0217, 'lps'),
	(440419, 126, '2015-03-01 00:53:34.000000', 'consum', 0.0214, 'lps'),
	(440420, 126, '2015-03-01 00:53:35.000000', 'consum', 0.0211, 'lps'),
	(440421, 126, '2015-03-01 00:53:36.000000', 'consum', 0.0223, 'lps'),
	(440422, 126, '2015-03-01 00:53:37.000000', 'consum', 0.0212, 'lps'),
	(440423, 126, '2015-03-01 00:53:38.000000', 'consum', 0.0220, 'lps'),
	(440424, 126, '2015-03-01 00:53:39.000000', 'consum', 0.0214, 'lps'),
	(440425, 126, '2015-03-01 00:53:40.000000', 'consum', 0.0220, 'lps'),
	(440426, 126, '2015-03-01 00:53:41.000000', 'consum', 0.0228, 'lps'),
	(440427, 126, '2015-03-01 00:53:42.000000', 'consum', 0.0228, 'lps'),
	(440428, 126, '2015-03-01 00:53:43.000000', 'consum', 0.0226, 'lps'),
	(440429, 126, '2015-03-01 00:53:44.000000', 'consum', 0.0214, 'lps'),
	(440430, 126, '2015-03-01 00:53:45.000000', 'consum', 0.0226, 'lps'),
	(440431, 126, '2015-03-01 00:53:46.000000', 'consum', 0.0217, 'lps'),
	(440432, 126, '2015-03-01 00:53:47.000000', 'consum', 0.0216, 'lps'),
	(440433, 126, '2015-03-01 00:53:48.000000', 'consum', 0.0220, 'lps'),
	(440434, 126, '2015-03-01 00:53:49.000000', 'consum', 0.0222, 'lps'),
	(440435, 126, '2015-03-01 00:53:50.000000', 'consum', 0.0218, 'lps'),
	(440436, 126, '2015-03-01 00:53:51.000000', 'consum', 0.0217, 'lps'),
	(440437, 126, '2015-03-01 00:53:52.000000', 'consum', 0.0219, 'lps'),
	(440438, 126, '2015-03-01 00:53:53.000000', 'consum', 0.0214, 'lps'),
	(440439, 126, '2015-03-01 00:53:54.000000', 'consum', 0.0224, 'lps'),
	(440440, 126, '2015-03-01 00:53:55.000000', 'consum', 0.0227, 'lps'),
	(440441, 126, '2015-03-01 00:53:56.000000', 'consum', 0.0210, 'lps'),
	(440442, 126, '2015-03-01 00:53:57.000000', 'consum', 0.0224, 'lps'),
	(440443, 126, '2015-03-01 00:53:58.000000', 'consum', 0.0218, 'lps'),
	(440444, 126, '2015-03-01 00:53:59.000000', 'consum', 0.0227, 'lps'),
	(440445, 126, '2015-03-01 00:54:00.000000', 'consum', 0.0211, 'lps'),
	(440446, 126, '2015-03-01 00:54:01.000000', 'consum', 0.0227, 'lps'),
	(440447, 126, '2015-03-01 00:54:02.000000', 'consum', 0.0230, 'lps'),
	(440448, 126, '2015-03-01 00:54:03.000000', 'consum', 0.0218, 'lps'),
	(440449, 126, '2015-03-01 00:54:04.000000', 'consum', 0.0230, 'lps'),
	(440450, 126, '2015-03-01 00:54:05.000000', 'consum', 0.0226, 'lps'),
	(440451, 126, '2015-03-01 00:54:06.000000', 'consum', 0.0229, 'lps'),
	(440452, 126, '2015-03-01 00:54:07.000000', 'consum', 0.0216, 'lps'),
	(440453, 126, '2015-03-01 00:54:08.000000', 'consum', 0.0227, 'lps'),
	(440454, 126, '2015-03-01 00:54:09.000000', 'consum', 0.0214, 'lps'),
	(440455, 126, '2015-03-01 00:54:10.000000', 'consum', 0.0220, 'lps'),
	(440456, 126, '2015-03-01 00:54:11.000000', 'consum', 0.0228, 'lps'),
	(440457, 126, '2015-03-01 00:54:12.000000', 'consum', 0.0229, 'lps'),
	(440458, 126, '2015-03-01 00:54:13.000000', 'consum', 0.0229, 'lps'),
	(440459, 126, '2015-03-01 00:54:14.000000', 'consum', 0.0230, 'lps'),
	(440460, 126, '2015-03-01 00:54:15.000000', 'consum', 0.0212, 'lps'),
	(440461, 126, '2015-03-01 00:54:16.000000', 'consum', 0.0224, 'lps'),
	(440462, 126, '2015-03-01 00:54:17.000000', 'consum', 0.0210, 'lps'),
	(440463, 126, '2015-03-01 00:54:18.000000', 'consum', 0.0230, 'lps'),
	(440464, 126, '2015-03-01 00:54:19.000000', 'consum', 0.0227, 'lps'),
	(440465, 126, '2015-03-01 00:54:20.000000', 'consum', 0.0214, 'lps'),
	(440466, 126, '2015-03-01 00:54:21.000000', 'consum', 0.0223, 'lps'),
	(440467, 126, '2015-03-01 00:54:22.000000', 'consum', 0.0219, 'lps'),
	(440468, 126, '2015-03-01 00:54:23.000000', 'consum', 0.0220, 'lps'),
	(440469, 126, '2015-03-01 00:54:24.000000', 'consum', 0.0210, 'lps'),
	(440470, 126, '2015-03-01 00:54:25.000000', 'consum', 0.0222, 'lps'),
	(440471, 126, '2015-03-01 00:54:26.000000', 'consum', 0.0228, 'lps'),
	(440472, 126, '2015-03-01 00:54:27.000000', 'consum', 0.0224, 'lps'),
	(440473, 126, '2015-03-01 00:54:28.000000', 'consum', 0.0228, 'lps'),
	(440474, 126, '2015-03-01 00:54:29.000000', 'consum', 0.0214, 'lps'),
	(440475, 126, '2015-03-01 00:54:30.000000', 'consum', 0.0219, 'lps'),
	(440476, 126, '2015-03-01 00:54:31.000000', 'consum', 0.0221, 'lps'),
	(440477, 126, '2015-03-01 00:54:32.000000', 'consum', 0.0221, 'lps'),
	(440478, 126, '2015-03-01 00:54:33.000000', 'consum', 0.0229, 'lps'),
	(440479, 126, '2015-03-01 00:54:34.000000', 'consum', 0.0212, 'lps'),
	(440480, 126, '2015-03-01 00:54:35.000000', 'consum', 0.0226, 'lps'),
	(440481, 126, '2015-03-01 00:54:36.000000', 'consum', 0.0222, 'lps'),
	(440482, 126, '2015-03-01 00:54:37.000000', 'consum', 0.0223, 'lps'),
	(440483, 126, '2015-03-01 00:54:38.000000', 'consum', 0.0219, 'lps'),
	(440484, 126, '2015-03-01 00:54:39.000000', 'consum', 0.0217, 'lps'),
	(440485, 126, '2015-03-01 00:54:40.000000', 'consum', 0.0216, 'lps'),
	(440486, 126, '2015-03-01 00:54:41.000000', 'consum', 0.0219, 'lps'),
	(440487, 126, '2015-03-01 00:54:42.000000', 'consum', 0.0219, 'lps'),
	(440488, 126, '2015-03-01 00:54:43.000000', 'consum', 0.0228, 'lps'),
	(440489, 126, '2015-03-01 00:54:44.000000', 'consum', 0.0211, 'lps'),
	(440490, 126, '2015-03-01 00:54:45.000000', 'consum', 0.0224, 'lps'),
	(440491, 126, '2015-03-01 00:54:46.000000', 'consum', 0.0217, 'lps'),
	(440492, 126, '2015-03-01 00:54:47.000000', 'consum', 0.0221, 'lps'),
	(440493, 126, '2015-03-01 00:54:48.000000', 'consum', 0.0224, 'lps'),
	(440494, 126, '2015-03-01 00:54:49.000000', 'consum', 0.0227, 'lps'),
	(440495, 126, '2015-03-01 00:54:50.000000', 'consum', 0.0211, 'lps'),
	(440496, 126, '2015-03-01 00:54:51.000000', 'consum', 0.0228, 'lps'),
	(440497, 126, '2015-03-01 00:54:52.000000', 'consum', 0.0212, 'lps'),
	(440498, 126, '2015-03-01 00:54:53.000000', 'consum', 0.0229, 'lps'),
	(440499, 126, '2015-03-01 00:54:54.000000', 'consum', 0.0217, 'lps'),
	(440500, 126, '2015-03-01 00:54:55.000000', 'consum', 0.0210, 'lps'),
	(440501, 126, '2015-03-01 00:54:56.000000', 'consum', 0.0212, 'lps'),
	(440502, 126, '2015-03-01 00:54:57.000000', 'consum', 0.0217, 'lps'),
	(440503, 126, '2015-03-01 00:54:58.000000', 'consum', 0.0222, 'lps'),
	(440504, 126, '2015-03-01 00:54:59.000000', 'consum', 0.0226, 'lps'),
	(440505, 126, '2015-03-01 00:55:00.000000', 'consum', 0.0213, 'lps'),
	(440506, 126, '2015-03-01 00:55:01.000000', 'consum', 0.0218, 'lps'),
	(440507, 126, '2015-03-01 00:55:02.000000', 'consum', 0.0222, 'lps'),
	(440508, 126, '2015-03-01 00:55:03.000000', 'consum', 0.0227, 'lps'),
	(440509, 126, '2015-03-01 00:55:04.000000', 'consum', 0.0215, 'lps'),
	(440510, 126, '2015-03-01 00:55:05.000000', 'consum', 0.0227, 'lps'),
	(440511, 126, '2015-03-01 00:55:06.000000', 'consum', 0.0218, 'lps'),
	(440512, 126, '2015-03-01 00:55:07.000000', 'consum', 0.0221, 'lps'),
	(440513, 126, '2015-03-01 00:55:08.000000', 'consum', 0.0222, 'lps'),
	(440514, 126, '2015-03-01 00:55:09.000000', 'consum', 0.0216, 'lps'),
	(440515, 126, '2015-03-01 00:55:10.000000', 'consum', 0.0223, 'lps'),
	(440516, 126, '2015-03-01 00:55:11.000000', 'consum', 0.0216, 'lps'),
	(440517, 126, '2015-03-01 00:55:12.000000', 'consum', 0.0223, 'lps'),
	(440518, 126, '2015-03-01 00:55:13.000000', 'consum', 0.0214, 'lps'),
	(440519, 126, '2015-03-01 00:55:14.000000', 'consum', 0.0214, 'lps'),
	(440520, 126, '2015-03-01 00:55:15.000000', 'consum', 0.0217, 'lps'),
	(440521, 126, '2015-03-01 00:55:16.000000', 'consum', 0.0212, 'lps'),
	(440522, 126, '2015-03-01 00:55:17.000000', 'consum', 0.0222, 'lps'),
	(440523, 126, '2015-03-01 00:55:18.000000', 'consum', 0.0221, 'lps'),
	(440524, 126, '2015-03-01 00:55:19.000000', 'consum', 0.0211, 'lps'),
	(440525, 126, '2015-03-01 00:55:20.000000', 'consum', 0.0224, 'lps'),
	(440526, 126, '2015-03-01 00:55:21.000000', 'consum', 0.0214, 'lps'),
	(440527, 126, '2015-03-01 00:55:22.000000', 'consum', 0.0210, 'lps'),
	(440528, 126, '2015-03-01 00:55:23.000000', 'consum', 0.0219, 'lps'),
	(440529, 126, '2015-03-01 00:55:24.000000', 'consum', 0.0215, 'lps'),
	(440530, 126, '2015-03-01 00:55:25.000000', 'consum', 0.0227, 'lps'),
	(440531, 126, '2015-03-01 00:55:26.000000', 'consum', 0.0217, 'lps'),
	(440532, 126, '2015-03-01 00:55:27.000000', 'consum', 0.0217, 'lps'),
	(440533, 126, '2015-03-01 00:55:28.000000', 'consum', 0.0226, 'lps'),
	(440534, 126, '2015-03-01 00:55:29.000000', 'consum', 0.0225, 'lps'),
	(440535, 126, '2015-03-01 00:55:30.000000', 'consum', 0.0218, 'lps'),
	(440536, 126, '2015-03-01 00:55:31.000000', 'consum', 0.0225, 'lps'),
	(440537, 126, '2015-03-01 00:55:32.000000', 'consum', 0.0219, 'lps'),
	(440538, 126, '2015-03-01 00:55:33.000000', 'consum', 0.0212, 'lps'),
	(440539, 126, '2015-03-01 00:55:34.000000', 'consum', 0.0215, 'lps'),
	(440540, 126, '2015-03-01 00:55:35.000000', 'consum', 0.0227, 'lps'),
	(440541, 126, '2015-03-01 00:55:36.000000', 'consum', 0.0220, 'lps'),
	(440542, 126, '2015-03-01 00:55:37.000000', 'consum', 0.0230, 'lps'),
	(440543, 126, '2015-03-01 00:55:38.000000', 'consum', 0.0216, 'lps'),
	(440544, 126, '2015-03-01 00:55:39.000000', 'consum', 0.0223, 'lps'),
	(440545, 126, '2015-03-01 00:55:40.000000', 'consum', 0.0215, 'lps'),
	(440546, 126, '2015-03-01 00:55:41.000000', 'consum', 0.0217, 'lps'),
	(440547, 126, '2015-03-01 00:55:42.000000', 'consum', 0.0212, 'lps'),
	(440548, 126, '2015-03-01 00:55:43.000000', 'consum', 0.0220, 'lps'),
	(440549, 126, '2015-03-01 00:55:44.000000', 'consum', 0.0213, 'lps'),
	(440550, 126, '2015-03-01 00:55:45.000000', 'consum', 0.0218, 'lps'),
	(440551, 126, '2015-03-01 00:55:46.000000', 'consum', 0.0218, 'lps'),
	(440552, 126, '2015-03-01 00:55:47.000000', 'consum', 0.0228, 'lps'),
	(440553, 126, '2015-03-01 00:55:48.000000', 'consum', 0.0215, 'lps'),
	(440554, 126, '2015-03-01 00:55:49.000000', 'consum', 0.0222, 'lps'),
	(440555, 126, '2015-03-01 00:55:50.000000', 'consum', 0.0214, 'lps'),
	(440556, 126, '2015-03-01 00:55:51.000000', 'consum', 0.0217, 'lps'),
	(440557, 126, '2015-03-01 00:55:52.000000', 'consum', 0.0211, 'lps'),
	(440558, 126, '2015-03-01 00:55:53.000000', 'consum', 0.0218, 'lps'),
	(440559, 126, '2015-03-01 00:55:54.000000', 'consum', 0.0224, 'lps'),
	(440560, 126, '2015-03-01 00:55:55.000000', 'consum', 0.0214, 'lps'),
	(440561, 126, '2015-03-01 00:55:56.000000', 'consum', 0.0212, 'lps'),
	(440562, 126, '2015-03-01 00:55:57.000000', 'consum', 0.0229, 'lps'),
	(440563, 126, '2015-03-01 00:55:58.000000', 'consum', 0.0215, 'lps'),
	(440564, 126, '2015-03-01 00:55:59.000000', 'consum', 0.0223, 'lps'),
	(440565, 126, '2015-03-01 00:56:00.000000', 'consum', 0.0215, 'lps'),
	(440566, 126, '2015-03-01 00:56:01.000000', 'consum', 0.0219, 'lps'),
	(440567, 126, '2015-03-01 00:56:02.000000', 'consum', 0.0218, 'lps'),
	(440568, 126, '2015-03-01 00:56:03.000000', 'consum', 0.0225, 'lps'),
	(440569, 126, '2015-03-01 00:56:04.000000', 'consum', 0.0220, 'lps'),
	(440570, 126, '2015-03-01 00:56:05.000000', 'consum', 0.0215, 'lps'),
	(440571, 126, '2015-03-01 00:56:06.000000', 'consum', 0.0226, 'lps'),
	(440572, 126, '2015-03-01 00:56:07.000000', 'consum', 0.0214, 'lps'),
	(440573, 126, '2015-03-01 00:56:08.000000', 'consum', 0.0223, 'lps'),
	(440574, 126, '2015-03-01 00:56:09.000000', 'consum', 0.0224, 'lps'),
	(440575, 126, '2015-03-01 00:56:10.000000', 'consum', 0.0219, 'lps'),
	(440576, 126, '2015-03-01 00:56:11.000000', 'consum', 0.0214, 'lps'),
	(440577, 126, '2015-03-01 00:56:12.000000', 'consum', 0.0222, 'lps'),
	(440578, 126, '2015-03-01 00:56:13.000000', 'consum', 0.0219, 'lps'),
	(440579, 126, '2015-03-01 00:56:14.000000', 'consum', 0.0220, 'lps'),
	(440580, 126, '2015-03-01 00:56:15.000000', 'consum', 0.0214, 'lps'),
	(440581, 126, '2015-03-01 00:56:16.000000', 'consum', 0.0218, 'lps'),
	(440582, 126, '2015-03-01 00:56:17.000000', 'consum', 0.0220, 'lps'),
	(440583, 126, '2015-03-01 00:56:18.000000', 'consum', 0.0215, 'lps'),
	(440584, 126, '2015-03-01 00:56:19.000000', 'consum', 0.0227, 'lps'),
	(440585, 126, '2015-03-01 00:56:20.000000', 'consum', 0.0218, 'lps'),
	(440586, 126, '2015-03-01 00:56:21.000000', 'consum', 0.0221, 'lps'),
	(440587, 126, '2015-03-01 00:56:22.000000', 'consum', 0.0220, 'lps'),
	(440588, 126, '2015-03-01 00:56:23.000000', 'consum', 0.0229, 'lps'),
	(440589, 126, '2015-03-01 00:56:24.000000', 'consum', 0.0211, 'lps'),
	(440590, 126, '2015-03-01 00:56:25.000000', 'consum', 0.0222, 'lps'),
	(440591, 126, '2015-03-01 00:56:26.000000', 'consum', 0.0227, 'lps'),
	(440592, 126, '2015-03-01 00:56:27.000000', 'consum', 0.0215, 'lps'),
	(440593, 126, '2015-03-01 00:56:28.000000', 'consum', 0.0226, 'lps'),
	(440594, 126, '2015-03-01 00:56:29.000000', 'consum', 0.0213, 'lps'),
	(440595, 126, '2015-03-01 00:56:30.000000', 'consum', 0.0222, 'lps'),
	(440596, 126, '2015-03-01 00:56:31.000000', 'consum', 0.0216, 'lps'),
	(440597, 126, '2015-03-01 00:56:32.000000', 'consum', 0.0229, 'lps'),
	(440598, 126, '2015-03-01 00:56:33.000000', 'consum', 0.0223, 'lps'),
	(440599, 126, '2015-03-01 00:56:34.000000', 'consum', 0.0217, 'lps'),
	(440600, 126, '2015-03-01 00:56:35.000000', 'consum', 0.0230, 'lps'),
	(440601, 126, '2015-03-01 00:56:36.000000', 'consum', 0.0227, 'lps'),
	(440602, 126, '2015-03-01 00:56:37.000000', 'consum', 0.0212, 'lps'),
	(440603, 126, '2015-03-01 00:56:38.000000', 'consum', 0.0213, 'lps'),
	(440604, 126, '2015-03-01 00:56:39.000000', 'consum', 0.0219, 'lps'),
	(440605, 126, '2015-03-01 00:56:40.000000', 'consum', 0.0224, 'lps'),
	(440606, 126, '2015-03-01 00:56:41.000000', 'consum', 0.0212, 'lps'),
	(440607, 126, '2015-03-01 00:56:42.000000', 'consum', 0.0223, 'lps'),
	(440608, 126, '2015-03-01 00:56:43.000000', 'consum', 0.0225, 'lps'),
	(440609, 126, '2015-03-01 00:56:44.000000', 'consum', 0.0226, 'lps'),
	(440610, 126, '2015-03-01 00:56:45.000000', 'consum', 0.0226, 'lps'),
	(440611, 126, '2015-03-01 00:56:46.000000', 'consum', 0.0220, 'lps'),
	(440612, 126, '2015-03-01 00:56:47.000000', 'consum', 0.0215, 'lps'),
	(440613, 126, '2015-03-01 00:56:48.000000', 'consum', 0.0225, 'lps'),
	(440614, 126, '2015-03-01 00:56:49.000000', 'consum', 0.0227, 'lps'),
	(440615, 126, '2015-03-01 00:56:50.000000', 'consum', 0.0228, 'lps'),
	(440616, 126, '2015-03-01 00:56:51.000000', 'consum', 0.0211, 'lps'),
	(440617, 126, '2015-03-01 00:56:52.000000', 'consum', 0.0224, 'lps'),
	(440618, 126, '2015-03-01 00:56:53.000000', 'consum', 0.0216, 'lps'),
	(440619, 126, '2015-03-01 00:56:54.000000', 'consum', 0.0216, 'lps'),
	(440620, 126, '2015-03-01 00:56:55.000000', 'consum', 0.0226, 'lps'),
	(440621, 126, '2015-03-01 00:56:56.000000', 'consum', 0.0229, 'lps'),
	(440622, 126, '2015-03-01 00:56:57.000000', 'consum', 0.0217, 'lps'),
	(440623, 126, '2015-03-01 00:56:58.000000', 'consum', 0.0211, 'lps'),
	(440624, 126, '2015-03-01 00:56:59.000000', 'consum', 0.0212, 'lps'),
	(440625, 126, '2015-03-01 00:57:00.000000', 'consum', 0.0219, 'lps'),
	(440626, 126, '2015-03-01 00:57:01.000000', 'consum', 0.0227, 'lps'),
	(440627, 126, '2015-03-01 00:57:02.000000', 'consum', 0.0229, 'lps'),
	(440628, 126, '2015-03-01 00:57:03.000000', 'consum', 0.0212, 'lps'),
	(440629, 126, '2015-03-01 00:57:04.000000', 'consum', 0.0227, 'lps'),
	(440630, 126, '2015-03-01 00:57:05.000000', 'consum', 0.0226, 'lps'),
	(440631, 126, '2015-03-01 00:57:06.000000', 'consum', 0.0220, 'lps'),
	(440632, 126, '2015-03-01 00:57:07.000000', 'consum', 0.0214, 'lps'),
	(440633, 126, '2015-03-01 00:57:08.000000', 'consum', 0.0218, 'lps'),
	(440634, 126, '2015-03-01 00:57:09.000000', 'consum', 0.0217, 'lps'),
	(440635, 126, '2015-03-01 00:57:10.000000', 'consum', 0.0221, 'lps'),
	(440636, 126, '2015-03-01 00:57:11.000000', 'consum', 0.0227, 'lps'),
	(440637, 126, '2015-03-01 00:57:12.000000', 'consum', 0.0218, 'lps'),
	(440638, 126, '2015-03-01 00:57:13.000000', 'consum', 0.0219, 'lps'),
	(440639, 126, '2015-03-01 00:57:14.000000', 'consum', 0.0213, 'lps'),
	(440640, 126, '2015-03-01 00:57:15.000000', 'consum', 0.0221, 'lps'),
	(440641, 126, '2015-03-01 00:57:16.000000', 'consum', 0.0212, 'lps'),
	(440642, 126, '2015-03-01 00:57:17.000000', 'consum', 0.0211, 'lps'),
	(440643, 126, '2015-03-01 00:57:18.000000', 'consum', 0.0228, 'lps'),
	(440644, 126, '2015-03-01 00:57:19.000000', 'consum', 0.0213, 'lps'),
	(440645, 126, '2015-03-01 00:57:20.000000', 'consum', 0.0213, 'lps'),
	(440646, 126, '2015-03-01 00:57:21.000000', 'consum', 0.0217, 'lps'),
	(440647, 126, '2015-03-01 00:57:22.000000', 'consum', 0.0215, 'lps'),
	(440648, 126, '2015-03-01 00:57:23.000000', 'consum', 0.0214, 'lps'),
	(440649, 126, '2015-03-01 00:57:24.000000', 'consum', 0.0218, 'lps'),
	(440650, 126, '2015-03-01 00:57:25.000000', 'consum', 0.0218, 'lps'),
	(440651, 126, '2015-03-01 00:57:26.000000', 'consum', 0.0224, 'lps'),
	(440652, 126, '2015-03-01 00:57:27.000000', 'consum', 0.0217, 'lps'),
	(440653, 126, '2015-03-01 00:57:28.000000', 'consum', 0.0222, 'lps'),
	(440654, 126, '2015-03-01 00:57:29.000000', 'consum', 0.0210, 'lps'),
	(440655, 126, '2015-03-01 00:57:30.000000', 'consum', 0.0215, 'lps'),
	(440656, 126, '2015-03-01 00:57:31.000000', 'consum', 0.0217, 'lps'),
	(440657, 126, '2015-03-01 00:57:32.000000', 'consum', 0.0228, 'lps'),
	(440658, 126, '2015-03-01 00:57:33.000000', 'consum', 0.0217, 'lps'),
	(440659, 126, '2015-03-01 00:57:34.000000', 'consum', 0.0213, 'lps'),
	(440660, 126, '2015-03-01 00:57:35.000000', 'consum', 0.0227, 'lps'),
	(440661, 126, '2015-03-01 00:57:36.000000', 'consum', 0.0221, 'lps'),
	(440662, 126, '2015-03-01 00:57:37.000000', 'consum', 0.0216, 'lps'),
	(440663, 126, '2015-03-01 00:57:38.000000', 'consum', 0.0227, 'lps'),
	(440664, 126, '2015-03-01 00:57:39.000000', 'consum', 0.0217, 'lps'),
	(440665, 126, '2015-03-01 00:57:40.000000', 'consum', 0.0212, 'lps'),
	(440666, 126, '2015-03-01 00:57:41.000000', 'consum', 0.0223, 'lps'),
	(440667, 126, '2015-03-01 00:57:42.000000', 'consum', 0.0227, 'lps'),
	(440668, 126, '2015-03-01 00:57:43.000000', 'consum', 0.0215, 'lps'),
	(440669, 126, '2015-03-01 00:57:44.000000', 'consum', 0.0228, 'lps'),
	(440670, 126, '2015-03-01 00:57:45.000000', 'consum', 0.0222, 'lps'),
	(440671, 126, '2015-03-01 00:57:46.000000', 'consum', 0.0216, 'lps'),
	(440672, 126, '2015-03-01 00:57:47.000000', 'consum', 0.0224, 'lps'),
	(440673, 126, '2015-03-01 00:57:48.000000', 'consum', 0.0222, 'lps'),
	(440674, 126, '2015-03-01 00:57:49.000000', 'consum', 0.0230, 'lps'),
	(440675, 126, '2015-03-01 00:57:50.000000', 'consum', 0.0211, 'lps'),
	(440676, 126, '2015-03-01 00:57:51.000000', 'consum', 0.0216, 'lps'),
	(440677, 126, '2015-03-01 00:57:52.000000', 'consum', 0.0217, 'lps'),
	(440678, 126, '2015-03-01 00:57:53.000000', 'consum', 0.0229, 'lps'),
	(440679, 126, '2015-03-01 00:57:54.000000', 'consum', 0.0221, 'lps'),
	(440680, 126, '2015-03-01 00:57:55.000000', 'consum', 0.0227, 'lps'),
	(440681, 126, '2015-03-01 00:57:56.000000', 'consum', 0.0224, 'lps'),
	(440682, 126, '2015-03-01 00:57:57.000000', 'consum', 0.0228, 'lps'),
	(440683, 126, '2015-03-01 00:57:58.000000', 'consum', 0.0217, 'lps'),
	(440684, 126, '2015-03-01 00:57:59.000000', 'consum', 0.0211, 'lps'),
	(440685, 126, '2015-03-01 00:58:00.000000', 'consum', 0.0218, 'lps'),
	(440686, 126, '2015-03-01 00:58:01.000000', 'consum', 0.0226, 'lps'),
	(440687, 126, '2015-03-01 00:58:02.000000', 'consum', 0.0222, 'lps'),
	(440688, 126, '2015-03-01 00:58:03.000000', 'consum', 0.0225, 'lps'),
	(440689, 126, '2015-03-01 00:58:04.000000', 'consum', 0.0228, 'lps'),
	(440690, 126, '2015-03-01 00:58:05.000000', 'consum', 0.0215, 'lps'),
	(440691, 126, '2015-03-01 00:58:06.000000', 'consum', 0.0221, 'lps'),
	(440692, 126, '2015-03-01 00:58:07.000000', 'consum', 0.0210, 'lps'),
	(440693, 126, '2015-03-01 00:58:08.000000', 'consum', 0.0219, 'lps'),
	(440694, 126, '2015-03-01 00:58:09.000000', 'consum', 0.0213, 'lps'),
	(440695, 126, '2015-03-01 00:58:10.000000', 'consum', 0.0218, 'lps'),
	(440696, 126, '2015-03-01 00:58:11.000000', 'consum', 0.0222, 'lps'),
	(440697, 126, '2015-03-01 00:58:12.000000', 'consum', 0.0225, 'lps'),
	(440698, 126, '2015-03-01 00:58:13.000000', 'consum', 0.0227, 'lps'),
	(440699, 126, '2015-03-01 00:58:14.000000', 'consum', 0.0230, 'lps'),
	(440700, 126, '2015-03-01 00:58:15.000000', 'consum', 0.0219, 'lps'),
	(440701, 126, '2015-03-01 00:58:16.000000', 'consum', 0.0217, 'lps'),
	(440702, 126, '2015-03-01 00:58:17.000000', 'consum', 0.0217, 'lps'),
	(440703, 126, '2015-03-01 00:58:18.000000', 'consum', 0.0226, 'lps'),
	(440704, 126, '2015-03-01 00:58:19.000000', 'consum', 0.0228, 'lps'),
	(440705, 126, '2015-03-01 00:58:20.000000', 'consum', 0.0230, 'lps'),
	(440706, 126, '2015-03-01 00:58:21.000000', 'consum', 0.0215, 'lps'),
	(440707, 126, '2015-03-01 00:58:22.000000', 'consum', 0.0217, 'lps'),
	(440708, 126, '2015-03-01 00:58:23.000000', 'consum', 0.0210, 'lps'),
	(440709, 126, '2015-03-01 00:58:24.000000', 'consum', 0.0210, 'lps'),
	(440710, 126, '2015-03-01 00:58:25.000000', 'consum', 0.0210, 'lps'),
	(440711, 126, '2015-03-01 00:58:26.000000', 'consum', 0.0213, 'lps'),
	(440712, 126, '2015-03-01 00:58:27.000000', 'consum', 0.0222, 'lps'),
	(440713, 126, '2015-03-01 00:58:28.000000', 'consum', 0.0222, 'lps'),
	(440714, 126, '2015-03-01 00:58:29.000000', 'consum', 0.0212, 'lps'),
	(440715, 126, '2015-03-01 00:58:30.000000', 'consum', 0.0225, 'lps'),
	(440716, 126, '2015-03-01 00:58:31.000000', 'consum', 0.0218, 'lps'),
	(440717, 126, '2015-03-01 00:58:32.000000', 'consum', 0.0228, 'lps'),
	(440718, 126, '2015-03-01 00:58:33.000000', 'consum', 0.0210, 'lps'),
	(440719, 126, '2015-03-01 00:58:34.000000', 'consum', 0.0222, 'lps'),
	(440720, 126, '2015-03-01 00:58:35.000000', 'consum', 0.0230, 'lps'),
	(440721, 126, '2015-03-01 00:58:36.000000', 'consum', 0.0210, 'lps'),
	(440722, 126, '2015-03-01 00:58:37.000000', 'consum', 0.0213, 'lps'),
	(440723, 126, '2015-03-01 00:58:38.000000', 'consum', 0.0226, 'lps'),
	(440724, 126, '2015-03-01 00:58:39.000000', 'consum', 0.0218, 'lps'),
	(440725, 126, '2015-03-01 00:58:40.000000', 'consum', 0.0224, 'lps'),
	(440726, 126, '2015-03-01 00:58:41.000000', 'consum', 0.0216, 'lps'),
	(440727, 126, '2015-03-01 00:58:42.000000', 'consum', 0.0216, 'lps'),
	(440728, 126, '2015-03-01 00:58:43.000000', 'consum', 0.0226, 'lps'),
	(440729, 126, '2015-03-01 00:58:44.000000', 'consum', 0.0229, 'lps'),
	(440730, 126, '2015-03-01 00:58:45.000000', 'consum', 0.0216, 'lps'),
	(440731, 126, '2015-03-01 00:58:46.000000', 'consum', 0.0226, 'lps'),
	(440732, 126, '2015-03-01 00:58:47.000000', 'consum', 0.0230, 'lps'),
	(440733, 126, '2015-03-01 00:58:48.000000', 'consum', 0.0222, 'lps'),
	(440734, 126, '2015-03-01 00:58:49.000000', 'consum', 0.0230, 'lps'),
	(440735, 126, '2015-03-01 00:58:50.000000', 'consum', 0.0210, 'lps'),
	(440736, 126, '2015-03-01 00:58:51.000000', 'consum', 0.0217, 'lps'),
	(440737, 126, '2015-03-01 00:58:52.000000', 'consum', 0.0222, 'lps'),
	(440738, 126, '2015-03-01 00:58:53.000000', 'consum', 0.0228, 'lps'),
	(440739, 126, '2015-03-01 00:58:54.000000', 'consum', 0.0225, 'lps'),
	(440740, 126, '2015-03-01 00:58:55.000000', 'consum', 0.0210, 'lps'),
	(440741, 126, '2015-03-01 00:58:56.000000', 'consum', 0.0229, 'lps'),
	(440742, 126, '2015-03-01 00:58:57.000000', 'consum', 0.0219, 'lps'),
	(440743, 126, '2015-03-01 00:58:58.000000', 'consum', 0.0221, 'lps'),
	(440744, 126, '2015-03-01 00:58:59.000000', 'consum', 0.0215, 'lps'),
	(440745, 126, '2015-03-01 00:59:00.000000', 'consum', 0.0227, 'lps'),
	(440746, 126, '2015-03-01 00:59:01.000000', 'consum', 0.0216, 'lps'),
	(440747, 126, '2015-03-01 00:59:02.000000', 'consum', 0.0230, 'lps'),
	(440748, 126, '2015-03-01 00:59:03.000000', 'consum', 0.0230, 'lps'),
	(440749, 126, '2015-03-01 00:59:04.000000', 'consum', 0.0210, 'lps'),
	(440750, 126, '2015-03-01 00:59:05.000000', 'consum', 0.0214, 'lps'),
	(440751, 126, '2015-03-01 00:59:06.000000', 'consum', 0.0228, 'lps'),
	(440752, 126, '2015-03-01 00:59:07.000000', 'consum', 0.0226, 'lps'),
	(440753, 126, '2015-03-01 00:59:08.000000', 'consum', 0.0214, 'lps'),
	(440754, 126, '2015-03-01 00:59:09.000000', 'consum', 0.0227, 'lps'),
	(440755, 126, '2015-03-01 00:59:10.000000', 'consum', 0.0221, 'lps'),
	(440756, 126, '2015-03-01 00:59:11.000000', 'consum', 0.0212, 'lps'),
	(440757, 126, '2015-03-01 00:59:12.000000', 'consum', 0.0210, 'lps'),
	(440758, 126, '2015-03-01 00:59:13.000000', 'consum', 0.0224, 'lps'),
	(440759, 126, '2015-03-01 00:59:14.000000', 'consum', 0.0219, 'lps'),
	(440760, 126, '2015-03-01 00:59:15.000000', 'consum', 0.0214, 'lps'),
	(440761, 126, '2015-03-01 00:59:16.000000', 'consum', 0.0225, 'lps'),
	(440762, 126, '2015-03-01 00:59:17.000000', 'consum', 0.0230, 'lps'),
	(440763, 126, '2015-03-01 00:59:18.000000', 'consum', 0.0226, 'lps'),
	(440764, 126, '2015-03-01 00:59:19.000000', 'consum', 0.0230, 'lps'),
	(440765, 126, '2015-03-01 00:59:20.000000', 'consum', 0.0218, 'lps'),
	(440766, 126, '2015-03-01 00:59:21.000000', 'consum', 0.0213, 'lps'),
	(440767, 126, '2015-03-01 00:59:22.000000', 'consum', 0.0221, 'lps'),
	(440768, 126, '2015-03-01 00:59:23.000000', 'consum', 0.0214, 'lps'),
	(440769, 126, '2015-03-01 00:59:24.000000', 'consum', 0.0221, 'lps'),
	(440770, 126, '2015-03-01 00:59:25.000000', 'consum', 0.0212, 'lps'),
	(440771, 126, '2015-03-01 00:59:26.000000', 'consum', 0.0227, 'lps'),
	(440772, 126, '2015-03-01 00:59:27.000000', 'consum', 0.0227, 'lps'),
	(440773, 126, '2015-03-01 00:59:28.000000', 'consum', 0.0225, 'lps'),
	(440774, 126, '2015-03-01 00:59:29.000000', 'consum', 0.0211, 'lps'),
	(440775, 126, '2015-03-01 00:59:30.000000', 'consum', 0.0213, 'lps'),
	(440776, 126, '2015-03-01 00:59:31.000000', 'consum', 0.0225, 'lps'),
	(440777, 126, '2015-03-01 00:59:32.000000', 'consum', 0.0212, 'lps'),
	(440778, 126, '2015-03-01 00:59:33.000000', 'consum', 0.0217, 'lps'),
	(440779, 126, '2015-03-01 00:59:34.000000', 'consum', 0.0217, 'lps'),
	(440780, 126, '2015-03-01 00:59:35.000000', 'consum', 0.0227, 'lps'),
	(440781, 126, '2015-03-01 00:59:36.000000', 'consum', 0.0230, 'lps'),
	(440782, 126, '2015-03-01 00:59:37.000000', 'consum', 0.0217, 'lps'),
	(440783, 126, '2015-03-01 00:59:38.000000', 'consum', 0.0229, 'lps'),
	(440784, 126, '2015-03-01 00:59:39.000000', 'consum', 0.0222, 'lps'),
	(440785, 126, '2015-03-01 00:59:40.000000', 'consum', 0.0213, 'lps'),
	(440786, 126, '2015-03-01 00:59:41.000000', 'consum', 0.0212, 'lps'),
	(440787, 126, '2015-03-01 00:59:42.000000', 'consum', 0.0210, 'lps'),
	(440788, 126, '2015-03-01 00:59:43.000000', 'consum', 0.0226, 'lps'),
	(440789, 126, '2015-03-01 00:59:44.000000', 'consum', 0.0227, 'lps'),
	(440790, 126, '2015-03-01 00:59:45.000000', 'consum', 0.0226, 'lps'),
	(440791, 126, '2015-03-01 00:59:46.000000', 'consum', 0.0221, 'lps'),
	(440792, 126, '2015-03-01 00:59:47.000000', 'consum', 0.0215, 'lps'),
	(440793, 126, '2015-03-01 00:59:48.000000', 'consum', 0.0225, 'lps'),
	(440794, 126, '2015-03-01 00:59:49.000000', 'consum', 0.0229, 'lps'),
	(440795, 126, '2015-03-01 00:59:50.000000', 'consum', 0.0218, 'lps'),
	(440796, 126, '2015-03-01 00:59:51.000000', 'consum', 0.0213, 'lps'),
	(440797, 126, '2015-03-01 00:59:52.000000', 'consum', 0.0223, 'lps'),
	(440798, 126, '2015-03-01 00:59:53.000000', 'consum', 0.0223, 'lps'),
	(440799, 126, '2015-03-01 00:59:54.000000', 'consum', 0.0218, 'lps'),
	(440800, 126, '2015-03-01 00:59:55.000000', 'consum', 0.0210, 'lps'),
	(440801, 126, '2015-03-01 00:59:56.000000', 'consum', 0.0230, 'lps'),
	(440802, 126, '2015-03-01 00:59:57.000000', 'consum', 0.0228, 'lps'),
	(440803, 126, '2015-03-01 00:59:58.000000', 'consum', 0.0217, 'lps'),
	(440804, 126, '2015-03-01 00:59:59.000000', 'consum', 0.0211, 'lps'),
	(440805, 126, '2015-03-01 01:00:00.000000', 'consum', 0.0218, 'lps'),
	(440806, 126, '2015-03-01 01:00:01.000000', 'consum', 0.0224, 'lps'),
	(440807, 126, '2015-03-01 01:00:02.000000', 'consum', 0.0216, 'lps'),
	(440808, 126, '2015-03-01 01:00:03.000000', 'consum', 0.0218, 'lps'),
	(440809, 126, '2015-03-01 01:00:04.000000', 'consum', 0.0213, 'lps'),
	(440810, 126, '2015-03-01 01:00:05.000000', 'consum', 0.0223, 'lps'),
	(440811, 126, '2015-03-01 01:00:06.000000', 'consum', 0.0225, 'lps'),
	(440812, 126, '2015-03-01 01:00:07.000000', 'consum', 0.0223, 'lps'),
	(440813, 126, '2015-03-01 01:00:08.000000', 'consum', 0.0212, 'lps'),
	(440814, 126, '2015-03-01 01:00:09.000000', 'consum', 0.0223, 'lps'),
	(440815, 126, '2015-03-01 01:00:10.000000', 'consum', 0.0226, 'lps'),
	(440816, 126, '2015-03-01 01:00:11.000000', 'consum', 0.0212, 'lps'),
	(440817, 126, '2015-03-01 01:00:12.000000', 'consum', 0.0212, 'lps'),
	(440818, 126, '2015-03-01 01:00:13.000000', 'consum', 0.0214, 'lps'),
	(440819, 126, '2015-03-01 01:00:14.000000', 'consum', 0.0223, 'lps'),
	(440820, 126, '2015-03-01 01:00:15.000000', 'consum', 0.0225, 'lps'),
	(440821, 126, '2015-03-01 01:00:16.000000', 'consum', 0.0225, 'lps'),
	(440822, 126, '2015-03-01 01:00:17.000000', 'consum', 0.0220, 'lps'),
	(440823, 126, '2015-03-01 01:00:18.000000', 'consum', 0.0214, 'lps'),
	(440824, 126, '2015-03-01 01:00:19.000000', 'consum', 0.0220, 'lps'),
	(440825, 126, '2015-03-01 01:00:20.000000', 'consum', 0.0229, 'lps'),
	(440826, 126, '2015-03-01 01:00:21.000000', 'consum', 0.0212, 'lps'),
	(440827, 126, '2015-03-01 01:00:22.000000', 'consum', 0.0226, 'lps'),
	(440828, 126, '2015-03-01 01:00:23.000000', 'consum', 0.0222, 'lps'),
	(440829, 126, '2015-03-01 01:00:24.000000', 'consum', 0.0222, 'lps'),
	(440830, 126, '2015-03-01 01:00:25.000000', 'consum', 0.0214, 'lps'),
	(440831, 126, '2015-03-01 01:00:26.000000', 'consum', 0.0214, 'lps'),
	(440832, 126, '2015-03-01 01:00:27.000000', 'consum', 0.0219, 'lps'),
	(440833, 126, '2015-03-01 01:00:28.000000', 'consum', 0.0221, 'lps'),
	(440834, 126, '2015-03-01 01:00:29.000000', 'consum', 0.0218, 'lps'),
	(440835, 126, '2015-03-01 01:00:30.000000', 'consum', 0.0218, 'lps'),
	(440836, 126, '2015-03-01 01:00:31.000000', 'consum', 0.0225, 'lps'),
	(440837, 126, '2015-03-01 01:00:32.000000', 'consum', 0.0222, 'lps'),
	(440838, 126, '2015-03-01 01:00:33.000000', 'consum', 0.0224, 'lps'),
	(440839, 126, '2015-03-01 01:00:34.000000', 'consum', 0.0223, 'lps'),
	(440840, 126, '2015-03-01 01:00:35.000000', 'consum', 0.0213, 'lps'),
	(440841, 126, '2015-03-01 01:00:36.000000', 'consum', 0.0230, 'lps'),
	(440842, 126, '2015-03-01 01:00:37.000000', 'consum', 0.0217, 'lps'),
	(440843, 126, '2015-03-01 01:00:38.000000', 'consum', 0.0228, 'lps'),
	(440844, 126, '2015-03-01 01:00:39.000000', 'consum', 0.0215, 'lps'),
	(440845, 126, '2015-03-01 01:00:40.000000', 'consum', 0.0226, 'lps'),
	(440846, 126, '2015-03-01 01:00:41.000000', 'consum', 0.0230, 'lps'),
	(440847, 126, '2015-03-01 01:00:42.000000', 'consum', 0.0223, 'lps'),
	(440848, 126, '2015-03-01 01:00:43.000000', 'consum', 0.0217, 'lps'),
	(440849, 126, '2015-03-01 01:00:44.000000', 'consum', 0.0225, 'lps'),
	(440850, 126, '2015-03-01 01:00:45.000000', 'consum', 0.0223, 'lps'),
	(440851, 126, '2015-03-01 01:00:46.000000', 'consum', 0.0230, 'lps'),
	(440852, 126, '2015-03-01 01:00:47.000000', 'consum', 0.0228, 'lps'),
	(440853, 126, '2015-03-01 01:00:48.000000', 'consum', 0.0220, 'lps'),
	(440854, 126, '2015-03-01 01:00:49.000000', 'consum', 0.0229, 'lps'),
	(440855, 126, '2015-03-01 01:00:50.000000', 'consum', 0.0214, 'lps'),
	(440856, 126, '2015-03-01 01:00:51.000000', 'consum', 0.0213, 'lps'),
	(440857, 126, '2015-03-01 01:00:52.000000', 'consum', 0.0215, 'lps'),
	(440858, 126, '2015-03-01 01:00:53.000000', 'consum', 0.0228, 'lps'),
	(440859, 126, '2015-03-01 01:00:54.000000', 'consum', 0.0221, 'lps'),
	(440860, 126, '2015-03-01 01:00:55.000000', 'consum', 0.0213, 'lps'),
	(440861, 126, '2015-03-01 01:00:56.000000', 'consum', 0.0212, 'lps'),
	(440862, 126, '2015-03-01 01:00:57.000000', 'consum', 0.0212, 'lps'),
	(440863, 126, '2015-03-01 01:00:58.000000', 'consum', 0.0213, 'lps'),
	(440864, 126, '2015-03-01 01:00:59.000000', 'consum', 0.0223, 'lps'),
	(440865, 126, '2015-03-01 01:01:00.000000', 'consum', 0.0221, 'lps'),
	(440866, 126, '2015-03-01 01:01:01.000000', 'consum', 0.0226, 'lps'),
	(440867, 126, '2015-03-01 01:01:02.000000', 'consum', 0.0218, 'lps'),
	(440868, 126, '2015-03-01 01:01:03.000000', 'consum', 0.0221, 'lps'),
	(440869, 126, '2015-03-01 01:01:04.000000', 'consum', 0.0220, 'lps'),
	(440870, 126, '2015-03-01 01:01:05.000000', 'consum', 0.0228, 'lps'),
	(440871, 126, '2015-03-01 01:01:06.000000', 'consum', 0.0230, 'lps'),
	(440872, 126, '2015-03-01 01:01:07.000000', 'consum', 0.0214, 'lps'),
	(440873, 126, '2015-03-01 01:01:08.000000', 'consum', 0.0213, 'lps'),
	(440874, 126, '2015-03-01 01:01:09.000000', 'consum', 0.0212, 'lps'),
	(440875, 126, '2015-03-01 01:01:10.000000', 'consum', 0.0214, 'lps'),
	(440876, 126, '2015-03-01 01:01:11.000000', 'consum', 0.0224, 'lps'),
	(440877, 126, '2015-03-01 01:01:12.000000', 'consum', 0.0226, 'lps'),
	(440878, 126, '2015-03-01 01:01:13.000000', 'consum', 0.0226, 'lps'),
	(440879, 126, '2015-03-01 01:01:14.000000', 'consum', 0.0223, 'lps'),
	(440880, 126, '2015-03-01 01:01:15.000000', 'consum', 0.0228, 'lps'),
	(440881, 126, '2015-03-01 01:01:16.000000', 'consum', 0.0219, 'lps'),
	(440882, 126, '2015-03-01 01:01:17.000000', 'consum', 0.0221, 'lps'),
	(440883, 126, '2015-03-01 01:01:18.000000', 'consum', 0.0216, 'lps'),
	(440884, 126, '2015-03-01 01:01:19.000000', 'consum', 0.0211, 'lps'),
	(440885, 126, '2015-03-01 01:01:20.000000', 'consum', 0.0217, 'lps'),
	(440886, 126, '2015-03-01 01:01:21.000000', 'consum', 0.0223, 'lps'),
	(440887, 126, '2015-03-01 01:01:22.000000', 'consum', 0.0212, 'lps'),
	(440888, 126, '2015-03-01 01:01:23.000000', 'consum', 0.0225, 'lps'),
	(440889, 126, '2015-03-01 01:01:24.000000', 'consum', 0.0215, 'lps'),
	(440890, 126, '2015-03-01 01:01:25.000000', 'consum', 0.0211, 'lps'),
	(440891, 126, '2015-03-01 01:01:26.000000', 'consum', 0.0223, 'lps'),
	(440892, 126, '2015-03-01 01:01:27.000000', 'consum', 0.0211, 'lps'),
	(440893, 126, '2015-03-01 01:01:28.000000', 'consum', 0.0216, 'lps'),
	(440894, 126, '2015-03-01 01:01:29.000000', 'consum', 0.0218, 'lps'),
	(440895, 126, '2015-03-01 01:01:30.000000', 'consum', 0.0230, 'lps'),
	(440896, 126, '2015-03-01 01:01:31.000000', 'consum', 0.0224, 'lps'),
	(440897, 126, '2015-03-01 01:01:32.000000', 'consum', 0.0222, 'lps'),
	(440898, 126, '2015-03-01 01:01:33.000000', 'consum', 0.0229, 'lps'),
	(440899, 126, '2015-03-01 01:01:34.000000', 'consum', 0.0226, 'lps'),
	(440900, 126, '2015-03-01 01:01:35.000000', 'consum', 0.0211, 'lps'),
	(440901, 126, '2015-03-01 01:01:36.000000', 'consum', 0.0211, 'lps'),
	(440902, 126, '2015-03-01 01:01:37.000000', 'consum', 0.0211, 'lps'),
	(440903, 126, '2015-03-01 01:01:38.000000', 'consum', 0.0212, 'lps'),
	(440904, 126, '2015-03-01 01:01:39.000000', 'consum', 0.0217, 'lps'),
	(440905, 126, '2015-03-01 01:01:40.000000', 'consum', 0.0222, 'lps'),
	(440906, 126, '2015-03-01 01:01:41.000000', 'consum', 0.0225, 'lps'),
	(440907, 126, '2015-03-01 01:01:42.000000', 'consum', 0.0230, 'lps'),
	(440908, 126, '2015-03-01 01:01:43.000000', 'consum', 0.0224, 'lps'),
	(440909, 126, '2015-03-01 01:01:44.000000', 'consum', 0.0222, 'lps'),
	(440910, 126, '2015-03-01 01:01:45.000000', 'consum', 0.0226, 'lps'),
	(440911, 126, '2015-03-01 01:01:46.000000', 'consum', 0.0211, 'lps'),
	(440912, 126, '2015-03-01 01:01:47.000000', 'consum', 0.0213, 'lps'),
	(440913, 126, '2015-03-01 01:01:48.000000', 'consum', 0.0219, 'lps'),
	(440914, 126, '2015-03-01 01:01:49.000000', 'consum', 0.0227, 'lps'),
	(440915, 126, '2015-03-01 01:01:50.000000', 'consum', 0.0228, 'lps'),
	(440916, 126, '2015-03-01 01:01:51.000000', 'consum', 0.0227, 'lps'),
	(440917, 126, '2015-03-01 01:01:52.000000', 'consum', 0.0222, 'lps'),
	(440918, 126, '2015-03-01 01:01:53.000000', 'consum', 0.0217, 'lps'),
	(440919, 126, '2015-03-01 01:01:54.000000', 'consum', 0.0210, 'lps'),
	(440920, 126, '2015-03-01 01:01:55.000000', 'consum', 0.0230, 'lps'),
	(440921, 126, '2015-03-01 01:01:56.000000', 'consum', 0.0227, 'lps'),
	(440922, 126, '2015-03-01 01:01:57.000000', 'consum', 0.0217, 'lps'),
	(440923, 126, '2015-03-01 01:01:58.000000', 'consum', 0.0214, 'lps'),
	(440924, 126, '2015-03-01 01:01:59.000000', 'consum', 0.0210, 'lps'),
	(440925, 126, '2015-03-01 01:02:00.000000', 'consum', 0.0219, 'lps'),
	(440926, 126, '2015-03-01 01:02:01.000000', 'consum', 0.0213, 'lps'),
	(440927, 126, '2015-03-01 01:02:02.000000', 'consum', 0.0221, 'lps'),
	(440928, 126, '2015-03-01 01:02:03.000000', 'consum', 0.0212, 'lps'),
	(440929, 126, '2015-03-01 01:02:04.000000', 'consum', 0.0211, 'lps'),
	(440930, 126, '2015-03-01 01:02:05.000000', 'consum', 0.0228, 'lps'),
	(440931, 126, '2015-03-01 01:02:06.000000', 'consum', 0.0214, 'lps'),
	(440932, 126, '2015-03-01 01:02:07.000000', 'consum', 0.0220, 'lps'),
	(440933, 126, '2015-03-01 01:02:08.000000', 'consum', 0.0227, 'lps'),
	(440934, 126, '2015-03-01 01:02:09.000000', 'consum', 0.0222, 'lps'),
	(440935, 126, '2015-03-01 01:02:10.000000', 'consum', 0.0222, 'lps'),
	(440936, 126, '2015-03-01 01:02:11.000000', 'consum', 0.0213, 'lps'),
	(440937, 126, '2015-03-01 01:02:12.000000', 'consum', 0.0211, 'lps'),
	(440938, 126, '2015-03-01 01:02:13.000000', 'consum', 0.0229, 'lps'),
	(440939, 126, '2015-03-01 01:02:14.000000', 'consum', 0.0215, 'lps'),
	(440940, 126, '2015-03-01 01:02:15.000000', 'consum', 0.0224, 'lps'),
	(440941, 126, '2015-03-01 01:02:16.000000', 'consum', 0.0221, 'lps'),
	(440942, 126, '2015-03-01 01:02:17.000000', 'consum', 0.0223, 'lps'),
	(440943, 126, '2015-03-01 01:02:18.000000', 'consum', 0.0221, 'lps'),
	(440944, 126, '2015-03-01 01:02:19.000000', 'consum', 0.0227, 'lps'),
	(440945, 126, '2015-03-01 01:02:20.000000', 'consum', 0.0223, 'lps'),
	(440946, 126, '2015-03-01 01:02:21.000000', 'consum', 0.0223, 'lps'),
	(440947, 126, '2015-03-01 01:02:22.000000', 'consum', 0.0214, 'lps'),
	(440948, 126, '2015-03-01 01:02:23.000000', 'consum', 0.0215, 'lps'),
	(440949, 126, '2015-03-01 01:02:24.000000', 'consum', 0.0224, 'lps'),
	(440950, 126, '2015-03-01 01:02:25.000000', 'consum', 0.0223, 'lps'),
	(440951, 126, '2015-03-01 01:02:26.000000', 'consum', 0.0211, 'lps'),
	(440952, 126, '2015-03-01 01:02:27.000000', 'consum', 0.0217, 'lps'),
	(440953, 126, '2015-03-01 01:02:28.000000', 'consum', 0.0224, 'lps'),
	(440954, 126, '2015-03-01 01:02:29.000000', 'consum', 0.0219, 'lps'),
	(440955, 126, '2015-03-01 01:02:30.000000', 'consum', 0.0211, 'lps'),
	(440956, 126, '2015-03-01 01:02:31.000000', 'consum', 0.0211, 'lps'),
	(440957, 126, '2015-03-01 01:02:32.000000', 'consum', 0.0212, 'lps'),
	(440958, 126, '2015-03-01 01:02:33.000000', 'consum', 0.0219, 'lps'),
	(440959, 126, '2015-03-01 01:02:34.000000', 'consum', 0.0227, 'lps'),
	(440960, 126, '2015-03-01 01:02:35.000000', 'consum', 0.0226, 'lps'),
	(440961, 126, '2015-03-01 01:02:36.000000', 'consum', 0.0219, 'lps'),
	(440962, 126, '2015-03-01 01:02:37.000000', 'consum', 0.0226, 'lps'),
	(440963, 126, '2015-03-01 01:02:38.000000', 'consum', 0.0225, 'lps'),
	(440964, 126, '2015-03-01 01:02:39.000000', 'consum', 0.0216, 'lps'),
	(440965, 126, '2015-03-01 01:02:40.000000', 'consum', 0.0214, 'lps'),
	(440966, 126, '2015-03-01 01:02:41.000000', 'consum', 0.0214, 'lps'),
	(440967, 126, '2015-03-01 01:02:42.000000', 'consum', 0.0219, 'lps'),
	(440968, 126, '2015-03-01 01:02:43.000000', 'consum', 0.0224, 'lps'),
	(440969, 126, '2015-03-01 01:02:44.000000', 'consum', 0.0210, 'lps'),
	(440970, 126, '2015-03-01 01:02:45.000000', 'consum', 0.0211, 'lps'),
	(440971, 126, '2015-03-01 01:02:46.000000', 'consum', 0.0215, 'lps'),
	(440972, 126, '2015-03-01 01:02:47.000000', 'consum', 0.0213, 'lps'),
	(440973, 126, '2015-03-01 01:02:48.000000', 'consum', 0.0210, 'lps'),
	(440974, 126, '2015-03-01 01:02:49.000000', 'consum', 0.0220, 'lps'),
	(440975, 126, '2015-03-01 01:02:50.000000', 'consum', 0.0222, 'lps'),
	(440976, 126, '2015-03-01 01:02:51.000000', 'consum', 0.0216, 'lps'),
	(440977, 126, '2015-03-01 01:02:52.000000', 'consum', 0.0229, 'lps'),
	(440978, 126, '2015-03-01 01:02:53.000000', 'consum', 0.0223, 'lps'),
	(440979, 126, '2015-03-01 01:02:54.000000', 'consum', 0.0220, 'lps'),
	(440980, 126, '2015-03-01 01:02:55.000000', 'consum', 0.0222, 'lps'),
	(440981, 126, '2015-03-01 01:02:56.000000', 'consum', 0.0218, 'lps'),
	(440982, 126, '2015-03-01 01:02:57.000000', 'consum', 0.0214, 'lps'),
	(440983, 126, '2015-03-01 01:02:58.000000', 'consum', 0.0227, 'lps'),
	(440984, 126, '2015-03-01 01:02:59.000000', 'consum', 0.0219, 'lps'),
	(440985, 126, '2015-03-01 01:03:00.000000', 'consum', 0.0229, 'lps'),
	(440986, 126, '2015-03-01 01:03:01.000000', 'consum', 0.0215, 'lps'),
	(440987, 126, '2015-03-01 01:03:02.000000', 'consum', 0.0219, 'lps'),
	(440988, 126, '2015-03-01 01:03:03.000000', 'consum', 0.0221, 'lps'),
	(440989, 126, '2015-03-01 01:03:04.000000', 'consum', 0.0217, 'lps'),
	(440990, 126, '2015-03-01 01:03:05.000000', 'consum', 0.0211, 'lps'),
	(440991, 126, '2015-03-01 01:03:06.000000', 'consum', 0.0218, 'lps'),
	(440992, 126, '2015-03-01 01:03:07.000000', 'consum', 0.0224, 'lps'),
	(440993, 126, '2015-03-01 01:03:08.000000', 'consum', 0.0215, 'lps'),
	(440994, 126, '2015-03-01 01:03:09.000000', 'consum', 0.0217, 'lps'),
	(440995, 126, '2015-03-01 01:03:10.000000', 'consum', 0.0227, 'lps'),
	(440996, 126, '2015-03-01 01:03:11.000000', 'consum', 0.0213, 'lps'),
	(440997, 126, '2015-03-01 01:03:12.000000', 'consum', 0.0215, 'lps'),
	(440998, 126, '2015-03-01 01:03:13.000000', 'consum', 0.0228, 'lps'),
	(440999, 126, '2015-03-01 01:03:14.000000', 'consum', 0.0223, 'lps'),
	(441000, 126, '2015-03-01 01:03:15.000000', 'consum', 0.0219, 'lps'),
	(441001, 126, '2015-03-01 01:03:16.000000', 'consum', 0.0219, 'lps'),
	(441002, 126, '2015-03-01 01:03:17.000000', 'consum', 0.0227, 'lps'),
	(441003, 126, '2015-03-01 01:03:18.000000', 'consum', 0.0227, 'lps'),
	(441004, 126, '2015-03-01 01:03:19.000000', 'consum', 0.0224, 'lps'),
	(441005, 126, '2015-03-01 01:03:20.000000', 'consum', 0.0227, 'lps'),
	(441006, 126, '2015-03-01 01:03:21.000000', 'consum', 0.0215, 'lps'),
	(441007, 126, '2015-03-01 01:03:22.000000', 'consum', 0.0225, 'lps'),
	(441008, 126, '2015-03-01 01:03:23.000000', 'consum', 0.0228, 'lps'),
	(441009, 126, '2015-03-01 01:03:24.000000', 'consum', 0.0215, 'lps'),
	(441010, 126, '2015-03-01 01:03:25.000000', 'consum', 0.0223, 'lps'),
	(441011, 126, '2015-03-01 01:03:26.000000', 'consum', 0.0218, 'lps'),
	(441012, 126, '2015-03-01 01:03:27.000000', 'consum', 0.0211, 'lps'),
	(441013, 126, '2015-03-01 01:03:28.000000', 'consum', 0.0215, 'lps'),
	(441014, 126, '2015-03-01 01:03:29.000000', 'consum', 0.0230, 'lps'),
	(441015, 126, '2015-03-01 01:03:30.000000', 'consum', 0.0213, 'lps'),
	(441016, 126, '2015-03-01 01:03:31.000000', 'consum', 0.0228, 'lps'),
	(441017, 126, '2015-03-01 01:03:32.000000', 'consum', 0.0228, 'lps'),
	(441018, 126, '2015-03-01 01:03:33.000000', 'consum', 0.0227, 'lps'),
	(441019, 126, '2015-03-01 01:03:34.000000', 'consum', 0.0218, 'lps'),
	(441020, 126, '2015-03-01 01:03:35.000000', 'consum', 0.0224, 'lps'),
	(441021, 126, '2015-03-01 01:03:36.000000', 'consum', 0.0212, 'lps'),
	(441022, 126, '2015-03-01 01:03:37.000000', 'consum', 0.0220, 'lps'),
	(441023, 126, '2015-03-01 01:03:38.000000', 'consum', 0.0213, 'lps'),
	(441024, 126, '2015-03-01 01:03:39.000000', 'consum', 0.0217, 'lps'),
	(441025, 126, '2015-03-01 01:03:40.000000', 'consum', 0.0217, 'lps'),
	(441026, 126, '2015-03-01 01:03:41.000000', 'consum', 0.0221, 'lps'),
	(441027, 126, '2015-03-01 01:03:42.000000', 'consum', 0.0226, 'lps'),
	(441028, 126, '2015-03-01 01:03:43.000000', 'consum', 0.0217, 'lps'),
	(441029, 126, '2015-03-01 01:03:44.000000', 'consum', 0.0216, 'lps'),
	(441030, 126, '2015-03-01 01:03:45.000000', 'consum', 0.0220, 'lps'),
	(441031, 126, '2015-03-01 01:03:46.000000', 'consum', 0.0222, 'lps'),
	(441032, 126, '2015-03-01 01:03:47.000000', 'consum', 0.0219, 'lps'),
	(441033, 126, '2015-03-01 01:03:48.000000', 'consum', 0.0222, 'lps'),
	(441034, 126, '2015-03-01 01:03:49.000000', 'consum', 0.0219, 'lps'),
	(441035, 126, '2015-03-01 01:03:50.000000', 'consum', 0.0222, 'lps'),
	(441036, 126, '2015-03-01 01:03:51.000000', 'consum', 0.0222, 'lps'),
	(441037, 126, '2015-03-01 01:03:52.000000', 'consum', 0.0213, 'lps'),
	(441038, 126, '2015-03-01 01:03:53.000000', 'consum', 0.0230, 'lps'),
	(441039, 126, '2015-03-01 01:03:54.000000', 'consum', 0.0220, 'lps'),
	(441040, 126, '2015-03-01 01:03:55.000000', 'consum', 0.0219, 'lps'),
	(441041, 126, '2015-03-01 01:03:56.000000', 'consum', 0.0228, 'lps'),
	(441042, 126, '2015-03-01 01:03:57.000000', 'consum', 0.0210, 'lps'),
	(441043, 126, '2015-03-01 01:03:58.000000', 'consum', 0.0220, 'lps'),
	(441044, 126, '2015-03-01 01:03:59.000000', 'consum', 0.0216, 'lps'),
	(441045, 126, '2015-03-01 01:04:00.000000', 'consum', 0.0212, 'lps'),
	(441046, 126, '2015-03-01 01:04:01.000000', 'consum', 0.0223, 'lps'),
	(441047, 126, '2015-03-01 01:04:02.000000', 'consum', 0.0230, 'lps'),
	(441048, 126, '2015-03-01 01:04:03.000000', 'consum', 0.0226, 'lps'),
	(441049, 126, '2015-03-01 01:04:04.000000', 'consum', 0.0211, 'lps'),
	(441050, 126, '2015-03-01 01:04:05.000000', 'consum', 0.0229, 'lps'),
	(441051, 126, '2015-03-01 01:04:06.000000', 'consum', 0.0221, 'lps'),
	(441052, 126, '2015-03-01 01:04:07.000000', 'consum', 0.0227, 'lps'),
	(441053, 126, '2015-03-01 01:04:08.000000', 'consum', 0.0220, 'lps'),
	(441054, 126, '2015-03-01 01:04:09.000000', 'consum', 0.0211, 'lps'),
	(441055, 126, '2015-03-01 01:04:10.000000', 'consum', 0.0227, 'lps'),
	(441056, 126, '2015-03-01 01:04:11.000000', 'consum', 0.0230, 'lps'),
	(441057, 126, '2015-03-01 01:04:12.000000', 'consum', 0.0217, 'lps'),
	(441058, 126, '2015-03-01 01:04:13.000000', 'consum', 0.0227, 'lps'),
	(441059, 126, '2015-03-01 01:04:14.000000', 'consum', 0.0211, 'lps'),
	(441060, 126, '2015-03-01 01:04:15.000000', 'consum', 0.0227, 'lps'),
	(441061, 126, '2015-03-01 01:04:16.000000', 'consum', 0.0230, 'lps'),
	(441062, 126, '2015-03-01 01:04:17.000000', 'consum', 0.0217, 'lps'),
	(441063, 126, '2015-03-01 01:04:18.000000', 'consum', 0.0226, 'lps'),
	(441064, 126, '2015-03-01 01:04:19.000000', 'consum', 0.0230, 'lps'),
	(441065, 126, '2015-03-01 01:04:20.000000', 'consum', 0.0221, 'lps'),
	(441066, 126, '2015-03-01 01:04:21.000000', 'consum', 0.0225, 'lps'),
	(441067, 126, '2015-03-01 01:04:22.000000', 'consum', 0.0210, 'lps'),
	(441068, 126, '2015-03-01 01:04:23.000000', 'consum', 0.0210, 'lps'),
	(441069, 126, '2015-03-01 01:04:24.000000', 'consum', 0.0230, 'lps'),
	(441070, 126, '2015-03-01 01:04:25.000000', 'consum', 0.0227, 'lps'),
	(441071, 126, '2015-03-01 01:04:26.000000', 'consum', 0.0214, 'lps'),
	(441072, 126, '2015-03-01 01:04:27.000000', 'consum', 0.0222, 'lps'),
	(441073, 126, '2015-03-01 01:04:28.000000', 'consum', 0.0218, 'lps'),
	(441074, 126, '2015-03-01 01:04:29.000000', 'consum', 0.0215, 'lps'),
	(441075, 126, '2015-03-01 01:04:30.000000', 'consum', 0.0211, 'lps'),
	(441076, 126, '2015-03-01 01:04:31.000000', 'consum', 0.0220, 'lps'),
	(441077, 126, '2015-03-01 01:04:32.000000', 'consum', 0.0217, 'lps'),
	(441078, 126, '2015-03-01 01:04:33.000000', 'consum', 0.0216, 'lps'),
	(441079, 126, '2015-03-01 01:04:34.000000', 'consum', 0.0218, 'lps'),
	(441080, 126, '2015-03-01 01:04:35.000000', 'consum', 0.0211, 'lps'),
	(441081, 126, '2015-03-01 01:04:36.000000', 'consum', 0.0214, 'lps'),
	(441082, 126, '2015-03-01 01:04:37.000000', 'consum', 0.0228, 'lps'),
	(441083, 126, '2015-03-01 01:04:38.000000', 'consum', 0.0226, 'lps'),
	(441084, 126, '2015-03-01 01:04:39.000000', 'consum', 0.0216, 'lps'),
	(441085, 126, '2015-03-01 01:04:40.000000', 'consum', 0.0215, 'lps'),
	(441086, 126, '2015-03-01 01:04:41.000000', 'consum', 0.0214, 'lps'),
	(441087, 102, '2015-03-15 00:00:00.000000', 'consum', 0.0224, 'lps'),
	(441088, 102, '2015-03-15 00:00:01.000000', 'consum', 0.0224, 'lps'),
	(441089, 102, '2015-03-15 00:00:02.000000', 'consum', 0.0220, 'lps'),
	(441090, 102, '2015-03-15 00:00:03.000000', 'consum', 0.0218, 'lps'),
	(441091, 102, '2015-03-15 00:00:04.000000', 'consum', 0.0221, 'lps'),
	(441092, 102, '2015-03-15 00:00:05.000000', 'consum', 0.0225, 'lps'),
	(441093, 102, '2015-03-15 00:00:06.000000', 'consum', 0.0215, 'lps'),
	(441094, 102, '2015-03-15 00:00:07.000000', 'consum', 0.0227, 'lps'),
	(441095, 102, '2015-03-15 00:00:08.000000', 'consum', 0.0210, 'lps'),
	(441096, 102, '2015-03-15 00:00:09.000000', 'consum', 0.0210, 'lps'),
	(441097, 102, '2015-03-15 00:00:10.000000', 'consum', 0.0214, 'lps'),
	(441098, 102, '2015-03-15 00:00:11.000000', 'consum', 0.0210, 'lps'),
	(441099, 102, '2015-03-15 00:00:12.000000', 'consum', 0.0219, 'lps'),
	(441100, 102, '2015-03-15 00:00:13.000000', 'consum', 0.0218, 'lps'),
	(441101, 102, '2015-03-15 00:00:14.000000', 'consum', 0.0222, 'lps'),
	(441102, 102, '2015-03-15 00:00:15.000000', 'consum', 0.0213, 'lps'),
	(441103, 102, '2015-03-15 00:00:16.000000', 'consum', 0.0225, 'lps'),
	(441104, 102, '2015-03-15 00:00:17.000000', 'consum', 0.0221, 'lps'),
	(441105, 102, '2015-03-15 00:00:18.000000', 'consum', 0.0222, 'lps'),
	(441106, 102, '2015-03-15 00:00:19.000000', 'consum', 0.0219, 'lps'),
	(441107, 102, '2015-03-15 00:00:20.000000', 'consum', 0.0219, 'lps'),
	(441108, 102, '2015-03-15 00:00:21.000000', 'consum', 0.0210, 'lps'),
	(441109, 102, '2015-03-15 00:00:22.000000', 'consum', 0.0221, 'lps'),
	(441110, 102, '2015-03-15 00:00:23.000000', 'consum', 0.0227, 'lps'),
	(441111, 102, '2015-03-15 00:00:24.000000', 'consum', 0.0211, 'lps'),
	(441112, 102, '2015-03-15 00:00:25.000000', 'consum', 0.0218, 'lps'),
	(441113, 102, '2015-03-15 00:00:26.000000', 'consum', 0.0211, 'lps'),
	(441114, 102, '2015-03-15 00:00:27.000000', 'consum', 0.0226, 'lps'),
	(441115, 102, '2015-03-15 00:00:28.000000', 'consum', 0.0219, 'lps'),
	(441116, 102, '2015-03-15 00:00:29.000000', 'consum', 0.0222, 'lps'),
	(441117, 102, '2015-03-15 00:00:30.000000', 'consum', 0.0227, 'lps'),
	(441118, 102, '2015-03-15 00:00:31.000000', 'consum', 0.0222, 'lps'),
	(441119, 102, '2015-03-15 00:00:32.000000', 'consum', 0.0222, 'lps'),
	(441120, 102, '2015-03-15 00:00:33.000000', 'consum', 0.0213, 'lps'),
	(441121, 102, '2015-03-15 00:00:34.000000', 'consum', 0.0211, 'lps'),
	(441122, 102, '2015-03-15 00:00:35.000000', 'consum', 0.0223, 'lps'),
	(441123, 102, '2015-03-15 00:00:36.000000', 'consum', 0.0221, 'lps'),
	(441124, 102, '2015-03-15 00:00:37.000000', 'consum', 0.0223, 'lps'),
	(441125, 102, '2015-03-15 00:00:38.000000', 'consum', 0.0225, 'lps'),
	(441126, 102, '2015-03-15 00:00:39.000000', 'consum', 0.0212, 'lps'),
	(441127, 102, '2015-03-15 00:00:40.000000', 'consum', 0.0210, 'lps'),
	(441128, 102, '2015-03-15 00:00:41.000000', 'consum', 0.0224, 'lps'),
	(441129, 102, '2015-03-15 00:00:42.000000', 'consum', 0.0226, 'lps'),
	(441130, 102, '2015-03-15 00:00:43.000000', 'consum', 0.0212, 'lps'),
	(441131, 102, '2015-03-15 00:00:44.000000', 'consum', 0.0226, 'lps'),
	(441132, 102, '2015-03-15 00:00:45.000000', 'consum', 0.0212, 'lps'),
	(441133, 102, '2015-03-15 00:00:46.000000', 'consum', 0.0225, 'lps'),
	(441134, 102, '2015-03-15 00:00:47.000000', 'consum', 0.0210, 'lps'),
	(441135, 102, '2015-03-15 00:00:48.000000', 'consum', 0.0221, 'lps'),
	(441136, 102, '2015-03-15 00:00:49.000000', 'consum', 0.0226, 'lps'),
	(441137, 102, '2015-03-15 00:00:50.000000', 'consum', 0.0222, 'lps'),
	(441138, 102, '2015-03-15 00:00:51.000000', 'consum', 0.0225, 'lps'),
	(441139, 102, '2015-03-15 00:00:52.000000', 'consum', 0.0213, 'lps'),
	(441140, 102, '2015-03-15 00:00:53.000000', 'consum', 0.0214, 'lps'),
	(441141, 102, '2015-03-15 00:00:54.000000', 'consum', 0.0223, 'lps'),
	(441142, 102, '2015-03-15 00:00:55.000000', 'consum', 0.0227, 'lps'),
	(441143, 102, '2015-03-15 00:00:56.000000', 'consum', 0.0222, 'lps'),
	(441144, 102, '2015-03-15 00:00:57.000000', 'consum', 0.0220, 'lps'),
	(441145, 102, '2015-03-15 00:00:58.000000', 'consum', 0.0225, 'lps'),
	(441146, 102, '2015-03-15 00:00:59.000000', 'consum', 0.0221, 'lps'),
	(441147, 102, '2015-03-15 00:01:00.000000', 'consum', 0.0217, 'lps'),
	(441148, 102, '2015-03-15 00:01:01.000000', 'consum', 0.0212, 'lps'),
	(441149, 102, '2015-03-15 00:01:02.000000', 'consum', 0.0219, 'lps'),
	(441150, 102, '2015-03-15 00:01:03.000000', 'consum', 0.0214, 'lps'),
	(441151, 102, '2015-03-15 00:01:04.000000', 'consum', 0.0220, 'lps'),
	(441152, 102, '2015-03-15 00:01:05.000000', 'consum', 0.0211, 'lps'),
	(441153, 102, '2015-03-15 00:01:06.000000', 'consum', 0.0225, 'lps'),
	(441154, 102, '2015-03-15 00:01:07.000000', 'consum', 0.0227, 'lps'),
	(441155, 102, '2015-03-15 00:01:08.000000', 'consum', 0.0214, 'lps'),
	(441156, 102, '2015-03-15 00:01:09.000000', 'consum', 0.0217, 'lps'),
	(441157, 102, '2015-03-15 00:01:10.000000', 'consum', 0.0213, 'lps'),
	(441158, 102, '2015-03-15 00:01:11.000000', 'consum', 0.0222, 'lps'),
	(441159, 102, '2015-03-15 00:01:12.000000', 'consum', 0.0227, 'lps'),
	(441160, 102, '2015-03-15 00:01:13.000000', 'consum', 0.0222, 'lps'),
	(441161, 102, '2015-03-15 00:01:14.000000', 'consum', 0.0220, 'lps'),
	(441162, 102, '2015-03-15 00:01:15.000000', 'consum', 0.0224, 'lps'),
	(441163, 102, '2015-03-15 00:01:16.000000', 'consum', 0.0215, 'lps'),
	(441164, 102, '2015-03-15 00:01:17.000000', 'consum', 0.0212, 'lps'),
	(441165, 102, '2015-03-15 00:01:18.000000', 'consum', 0.0223, 'lps'),
	(441166, 102, '2015-03-15 00:01:19.000000', 'consum', 0.0215, 'lps'),
	(441167, 102, '2015-03-15 00:01:20.000000', 'consum', 0.0213, 'lps'),
	(441168, 102, '2015-03-15 00:01:21.000000', 'consum', 0.0211, 'lps'),
	(441169, 102, '2015-03-15 00:01:22.000000', 'consum', 0.0227, 'lps'),
	(441170, 102, '2015-03-15 00:01:23.000000', 'consum', 0.0217, 'lps'),
	(441171, 102, '2015-03-15 00:01:24.000000', 'consum', 0.0216, 'lps'),
	(441172, 102, '2015-03-15 00:01:25.000000', 'consum', 0.0218, 'lps'),
	(441173, 102, '2015-03-15 00:01:26.000000', 'consum', 0.0217, 'lps'),
	(441174, 102, '2015-03-15 00:01:27.000000', 'consum', 0.0218, 'lps'),
	(441175, 102, '2015-03-15 00:01:28.000000', 'consum', 0.0213, 'lps'),
	(441176, 102, '2015-03-15 00:01:29.000000', 'consum', 0.0218, 'lps'),
	(441177, 102, '2015-03-15 00:01:30.000000', 'consum', 0.0225, 'lps'),
	(441178, 102, '2015-03-15 00:01:31.000000', 'consum', 0.0224, 'lps'),
	(441179, 102, '2015-03-15 00:01:32.000000', 'consum', 0.0219, 'lps'),
	(441180, 102, '2015-03-15 00:01:33.000000', 'consum', 0.0215, 'lps'),
	(441181, 102, '2015-03-15 00:01:34.000000', 'consum', 0.0225, 'lps'),
	(441182, 102, '2015-03-15 00:01:35.000000', 'consum', 0.0217, 'lps'),
	(441183, 102, '2015-03-15 00:01:36.000000', 'consum', 0.0218, 'lps'),
	(441184, 102, '2015-03-15 00:01:37.000000', 'consum', 0.0212, 'lps'),
	(441185, 102, '2015-03-15 00:01:38.000000', 'consum', 0.0215, 'lps'),
	(441186, 102, '2015-03-15 00:01:39.000000', 'consum', 0.0212, 'lps'),
	(441187, 102, '2015-03-15 00:01:40.000000', 'consum', 0.0224, 'lps'),
	(441188, 102, '2015-03-15 00:01:41.000000', 'consum', 0.0220, 'lps'),
	(441189, 102, '2015-03-15 00:01:42.000000', 'consum', 0.0216, 'lps'),
	(441190, 102, '2015-03-15 00:01:43.000000', 'consum', 0.0214, 'lps'),
	(441191, 102, '2015-03-15 00:01:44.000000', 'consum', 0.0210, 'lps'),
	(441192, 102, '2015-03-15 00:01:45.000000', 'consum', 0.0216, 'lps'),
	(441193, 102, '2015-03-15 00:01:46.000000', 'consum', 0.0223, 'lps'),
	(441194, 102, '2015-03-15 00:01:47.000000', 'consum', 0.0221, 'lps'),
	(441195, 102, '2015-03-15 00:01:48.000000', 'consum', 0.0227, 'lps'),
	(441196, 102, '2015-03-15 00:01:49.000000', 'consum', 0.0227, 'lps'),
	(441197, 102, '2015-03-15 00:01:50.000000', 'consum', 0.0225, 'lps'),
	(441198, 102, '2015-03-15 00:01:51.000000', 'consum', 0.0217, 'lps'),
	(441199, 102, '2015-03-15 00:01:52.000000', 'consum', 0.0217, 'lps'),
	(441200, 102, '2015-03-15 00:01:53.000000', 'consum', 0.0225, 'lps'),
	(441201, 102, '2015-03-15 00:01:54.000000', 'consum', 0.0212, 'lps'),
	(441202, 102, '2015-03-15 00:01:55.000000', 'consum', 0.0212, 'lps'),
	(441203, 102, '2015-03-15 00:01:56.000000', 'consum', 0.0216, 'lps'),
	(441204, 102, '2015-03-15 00:01:57.000000', 'consum', 0.0214, 'lps'),
	(441205, 102, '2015-03-15 00:01:58.000000', 'consum', 0.0213, 'lps'),
	(441206, 102, '2015-03-15 00:01:59.000000', 'consum', 0.0215, 'lps'),
	(441207, 102, '2015-03-15 00:02:00.000000', 'consum', 0.0223, 'lps'),
	(441208, 102, '2015-03-15 00:02:01.000000', 'consum', 0.0210, 'lps'),
	(441209, 102, '2015-03-15 00:02:02.000000', 'consum', 0.0225, 'lps'),
	(441210, 102, '2015-03-15 00:02:03.000000', 'consum', 0.0214, 'lps'),
	(441211, 102, '2015-03-15 00:02:04.000000', 'consum', 0.0223, 'lps'),
	(441212, 102, '2015-03-15 00:02:05.000000', 'consum', 0.0225, 'lps'),
	(441213, 102, '2015-03-15 00:02:06.000000', 'consum', 0.0210, 'lps'),
	(441214, 102, '2015-03-15 00:02:07.000000', 'consum', 0.0222, 'lps'),
	(441215, 102, '2015-03-15 00:02:08.000000', 'consum', 0.0216, 'lps'),
	(441216, 102, '2015-03-15 00:02:09.000000', 'consum', 0.0221, 'lps'),
	(441217, 102, '2015-03-15 00:02:10.000000', 'consum', 0.0214, 'lps'),
	(441218, 102, '2015-03-15 00:02:11.000000', 'consum', 0.0214, 'lps'),
	(441219, 102, '2015-03-15 00:02:12.000000', 'consum', 0.0220, 'lps'),
	(441220, 102, '2015-03-15 00:02:13.000000', 'consum', 0.0210, 'lps'),
	(441221, 102, '2015-03-15 00:02:14.000000', 'consum', 0.0217, 'lps'),
	(441222, 102, '2015-03-15 00:02:15.000000', 'consum', 0.0211, 'lps'),
	(441223, 102, '2015-03-15 00:02:16.000000', 'consum', 0.0212, 'lps'),
	(441224, 102, '2015-03-15 00:02:17.000000', 'consum', 0.0216, 'lps'),
	(441225, 102, '2015-03-15 00:02:18.000000', 'consum', 0.0215, 'lps'),
	(441226, 102, '2015-03-15 00:02:19.000000', 'consum', 0.0221, 'lps'),
	(441227, 102, '2015-03-15 00:02:20.000000', 'consum', 0.0213, 'lps'),
	(441228, 102, '2015-03-15 00:02:21.000000', 'consum', 0.0210, 'lps'),
	(441229, 102, '2015-03-15 00:02:22.000000', 'consum', 0.0218, 'lps'),
	(441230, 102, '2015-03-15 00:02:23.000000', 'consum', 0.0217, 'lps'),
	(441231, 102, '2015-03-15 00:02:24.000000', 'consum', 0.0219, 'lps'),
	(441232, 102, '2015-03-15 00:02:25.000000', 'consum', 0.0217, 'lps'),
	(441233, 102, '2015-03-15 00:02:26.000000', 'consum', 0.0219, 'lps'),
	(441234, 102, '2015-03-15 00:02:27.000000', 'consum', 0.0216, 'lps'),
	(441235, 102, '2015-03-15 00:02:28.000000', 'consum', 0.0216, 'lps'),
	(441236, 102, '2015-03-15 00:02:29.000000', 'consum', 0.0220, 'lps'),
	(441237, 102, '2015-03-15 00:02:30.000000', 'consum', 0.0226, 'lps'),
	(441238, 102, '2015-03-15 00:02:31.000000', 'consum', 0.0222, 'lps'),
	(441239, 102, '2015-03-15 00:02:32.000000', 'consum', 0.0224, 'lps'),
	(441240, 102, '2015-03-15 00:02:33.000000', 'consum', 0.0226, 'lps'),
	(441241, 102, '2015-03-15 00:02:34.000000', 'consum', 0.0214, 'lps'),
	(441242, 102, '2015-03-15 00:02:35.000000', 'consum', 0.0220, 'lps'),
	(441243, 102, '2015-03-15 00:02:36.000000', 'consum', 0.0227, 'lps'),
	(441244, 102, '2015-03-15 00:02:37.000000', 'consum', 0.0215, 'lps'),
	(441245, 102, '2015-03-15 00:02:38.000000', 'consum', 0.0219, 'lps'),
	(441246, 102, '2015-03-15 00:02:39.000000', 'consum', 0.0221, 'lps'),
	(441247, 102, '2015-03-15 00:02:40.000000', 'consum', 0.0221, 'lps'),
	(441248, 102, '2015-03-15 00:02:41.000000', 'consum', 0.0215, 'lps'),
	(441249, 102, '2015-03-15 00:02:42.000000', 'consum', 0.0219, 'lps'),
	(441250, 102, '2015-03-15 00:02:43.000000', 'consum', 0.0225, 'lps'),
	(441251, 102, '2015-03-15 00:02:44.000000', 'consum', 0.0220, 'lps'),
	(441252, 102, '2015-03-15 00:02:45.000000', 'consum', 0.0217, 'lps'),
	(441253, 102, '2015-03-15 00:02:46.000000', 'consum', 0.0216, 'lps'),
	(441254, 102, '2015-03-15 00:02:47.000000', 'consum', 0.0219, 'lps'),
	(441255, 102, '2015-03-15 00:02:48.000000', 'consum', 0.0218, 'lps'),
	(441256, 102, '2015-03-15 00:02:49.000000', 'consum', 0.0225, 'lps'),
	(441257, 102, '2015-03-15 00:02:50.000000', 'consum', 0.0224, 'lps'),
	(441258, 102, '2015-03-15 00:02:51.000000', 'consum', 0.0218, 'lps'),
	(441259, 102, '2015-03-15 00:02:52.000000', 'consum', 0.0211, 'lps'),
	(441260, 102, '2015-03-15 00:02:53.000000', 'consum', 0.0225, 'lps'),
	(441261, 102, '2015-03-15 00:02:54.000000', 'consum', 0.0211, 'lps'),
	(441262, 102, '2015-03-15 00:02:55.000000', 'consum', 0.0225, 'lps'),
	(441263, 102, '2015-03-15 00:02:56.000000', 'consum', 0.0210, 'lps'),
	(441264, 102, '2015-03-15 00:02:57.000000', 'consum', 0.0220, 'lps'),
	(441265, 102, '2015-03-15 00:02:58.000000', 'consum', 0.0224, 'lps'),
	(441266, 102, '2015-03-15 00:02:59.000000', 'consum', 0.0215, 'lps'),
	(441267, 102, '2015-03-15 00:03:00.000000', 'consum', 0.0213, 'lps'),
	(441268, 102, '2015-03-15 00:03:01.000000', 'consum', 0.0227, 'lps'),
	(441269, 102, '2015-03-15 00:03:02.000000', 'consum', 0.0215, 'lps'),
	(441270, 102, '2015-03-15 00:03:03.000000', 'consum', 0.0219, 'lps'),
	(441271, 102, '2015-03-15 00:03:04.000000', 'consum', 0.0222, 'lps'),
	(441272, 102, '2015-03-15 00:03:05.000000', 'consum', 0.0210, 'lps'),
	(441273, 102, '2015-03-15 00:03:06.000000', 'consum', 0.0226, 'lps'),
	(441274, 102, '2015-03-15 00:03:07.000000', 'consum', 0.0218, 'lps'),
	(441275, 102, '2015-03-15 00:03:08.000000', 'consum', 0.0221, 'lps'),
	(441276, 102, '2015-03-15 00:03:09.000000', 'consum', 0.0223, 'lps'),
	(441277, 102, '2015-03-15 00:03:10.000000', 'consum', 0.0225, 'lps'),
	(441278, 102, '2015-03-15 00:03:11.000000', 'consum', 0.0210, 'lps'),
	(441279, 102, '2015-03-15 00:03:12.000000', 'consum', 0.0218, 'lps'),
	(441280, 102, '2015-03-15 00:03:13.000000', 'consum', 0.0216, 'lps'),
	(441281, 102, '2015-03-15 00:03:14.000000', 'consum', 0.0215, 'lps'),
	(441282, 102, '2015-03-15 00:03:15.000000', 'consum', 0.0220, 'lps'),
	(441283, 102, '2015-03-15 00:03:16.000000', 'consum', 0.0227, 'lps'),
	(441284, 102, '2015-03-15 00:03:17.000000', 'consum', 0.0212, 'lps'),
	(441285, 102, '2015-03-15 00:03:18.000000', 'consum', 0.0224, 'lps'),
	(441286, 102, '2015-03-15 00:03:19.000000', 'consum', 0.0222, 'lps'),
	(441287, 102, '2015-03-15 00:03:20.000000', 'consum', 0.0226, 'lps'),
	(441288, 102, '2015-03-15 00:03:21.000000', 'consum', 0.0218, 'lps'),
	(441289, 102, '2015-03-15 00:03:22.000000', 'consum', 0.0222, 'lps'),
	(441290, 102, '2015-03-15 00:03:23.000000', 'consum', 0.0227, 'lps'),
	(441291, 102, '2015-03-15 00:03:24.000000', 'consum', 0.0223, 'lps'),
	(441292, 102, '2015-03-15 00:03:25.000000', 'consum', 0.0227, 'lps'),
	(441293, 102, '2015-03-15 00:03:26.000000', 'consum', 0.0219, 'lps'),
	(441294, 102, '2015-03-15 00:03:27.000000', 'consum', 0.0222, 'lps'),
	(441295, 102, '2015-03-15 00:03:28.000000', 'consum', 0.0226, 'lps'),
	(441296, 102, '2015-03-15 00:03:29.000000', 'consum', 0.0219, 'lps'),
	(441297, 102, '2015-03-15 00:03:30.000000', 'consum', 0.0224, 'lps'),
	(441298, 102, '2015-03-15 00:03:31.000000', 'consum', 0.0218, 'lps'),
	(441299, 102, '2015-03-15 00:03:32.000000', 'consum', 0.0210, 'lps'),
	(441300, 102, '2015-03-15 00:03:33.000000', 'consum', 0.0221, 'lps'),
	(441301, 102, '2015-03-15 00:03:34.000000', 'consum', 0.0212, 'lps'),
	(441302, 102, '2015-03-15 00:03:35.000000', 'consum', 0.0222, 'lps'),
	(441303, 102, '2015-03-15 00:03:36.000000', 'consum', 0.0211, 'lps'),
	(441304, 102, '2015-03-15 00:03:37.000000', 'consum', 0.0217, 'lps'),
	(441305, 102, '2015-03-15 00:03:38.000000', 'consum', 0.0225, 'lps'),
	(441306, 102, '2015-03-15 00:03:39.000000', 'consum', 0.0225, 'lps'),
	(441307, 102, '2015-03-15 00:03:40.000000', 'consum', 0.0226, 'lps'),
	(441308, 102, '2015-03-15 00:03:41.000000', 'consum', 0.0210, 'lps'),
	(441309, 102, '2015-03-15 00:03:42.000000', 'consum', 0.0216, 'lps'),
	(441310, 102, '2015-03-15 00:03:43.000000', 'consum', 0.0223, 'lps'),
	(441311, 102, '2015-03-15 00:03:44.000000', 'consum', 0.0219, 'lps'),
	(441312, 102, '2015-03-15 00:03:45.000000', 'consum', 0.0219, 'lps'),
	(441313, 102, '2015-03-15 00:03:46.000000', 'consum', 0.0211, 'lps'),
	(441314, 102, '2015-03-15 00:03:47.000000', 'consum', 0.0226, 'lps'),
	(441315, 102, '2015-03-15 00:03:48.000000', 'consum', 0.0212, 'lps'),
	(441316, 102, '2015-03-15 00:03:49.000000', 'consum', 0.0211, 'lps'),
	(441317, 102, '2015-03-15 00:03:50.000000', 'consum', 0.0226, 'lps'),
	(441318, 102, '2015-03-15 00:03:51.000000', 'consum', 0.0215, 'lps'),
	(441319, 102, '2015-03-15 00:03:52.000000', 'consum', 0.0226, 'lps'),
	(441320, 102, '2015-03-15 00:03:53.000000', 'consum', 0.0219, 'lps'),
	(441321, 102, '2015-03-15 00:03:54.000000', 'consum', 0.0227, 'lps'),
	(441322, 102, '2015-03-15 00:03:55.000000', 'consum', 0.0212, 'lps'),
	(441323, 102, '2015-03-15 00:03:56.000000', 'consum', 0.0225, 'lps'),
	(441324, 102, '2015-03-15 00:03:57.000000', 'consum', 0.0225, 'lps'),
	(441325, 102, '2015-03-15 00:03:58.000000', 'consum', 0.0225, 'lps'),
	(441326, 102, '2015-03-15 00:03:59.000000', 'consum', 0.0220, 'lps'),
	(441327, 102, '2015-03-15 00:04:00.000000', 'consum', 0.0215, 'lps'),
	(441328, 102, '2015-03-15 00:04:01.000000', 'consum', 0.0222, 'lps'),
	(441329, 102, '2015-03-15 00:04:02.000000', 'consum', 0.0222, 'lps'),
	(441330, 102, '2015-03-15 00:04:03.000000', 'consum', 0.0215, 'lps'),
	(441331, 102, '2015-03-15 00:04:04.000000', 'consum', 0.0220, 'lps'),
	(441332, 102, '2015-03-15 00:04:05.000000', 'consum', 0.0226, 'lps'),
	(441333, 102, '2015-03-15 00:04:06.000000', 'consum', 0.0226, 'lps'),
	(441334, 102, '2015-03-15 00:04:07.000000', 'consum', 0.0225, 'lps'),
	(441335, 102, '2015-03-15 00:04:08.000000', 'consum', 0.0218, 'lps'),
	(441336, 102, '2015-03-15 00:04:09.000000', 'consum', 0.0225, 'lps'),
	(441337, 102, '2015-03-15 00:04:10.000000', 'consum', 0.0226, 'lps'),
	(441338, 102, '2015-03-15 00:04:11.000000', 'consum', 0.0226, 'lps'),
	(441339, 102, '2015-03-15 00:04:12.000000', 'consum', 0.0226, 'lps'),
	(441340, 102, '2015-03-15 00:04:13.000000', 'consum', 0.0225, 'lps'),
	(441341, 102, '2015-03-15 00:04:14.000000', 'consum', 0.0218, 'lps'),
	(441342, 102, '2015-03-15 00:04:15.000000', 'consum', 0.0225, 'lps'),
	(441343, 102, '2015-03-15 00:04:16.000000', 'consum', 0.0224, 'lps'),
	(441344, 102, '2015-03-15 00:04:17.000000', 'consum', 0.0219, 'lps'),
	(441345, 102, '2015-03-15 00:04:18.000000', 'consum', 0.0213, 'lps'),
	(441346, 102, '2015-03-15 00:04:19.000000', 'consum', 0.0217, 'lps'),
	(441347, 102, '2015-03-15 00:04:20.000000', 'consum', 0.0219, 'lps'),
	(441348, 102, '2015-03-15 00:04:21.000000', 'consum', 0.0216, 'lps'),
	(441349, 102, '2015-03-15 00:04:22.000000', 'consum', 0.0212, 'lps'),
	(441350, 102, '2015-03-15 00:04:23.000000', 'consum', 0.0220, 'lps'),
	(441351, 102, '2015-03-15 00:04:24.000000', 'consum', 0.0218, 'lps'),
	(441352, 102, '2015-03-15 00:04:25.000000', 'consum', 0.0219, 'lps'),
	(441353, 102, '2015-03-15 00:04:26.000000', 'consum', 0.0217, 'lps'),
	(441354, 102, '2015-03-15 00:04:27.000000', 'consum', 0.0219, 'lps'),
	(441355, 102, '2015-03-15 00:04:28.000000', 'consum', 0.0216, 'lps'),
	(441356, 102, '2015-03-15 00:04:29.000000', 'consum', 0.0211, 'lps'),
	(441357, 102, '2015-03-15 00:04:30.000000', 'consum', 0.0216, 'lps'),
	(441358, 102, '2015-03-15 00:04:31.000000', 'consum', 0.0222, 'lps'),
	(441359, 102, '2015-03-15 00:04:32.000000', 'consum', 0.0214, 'lps'),
	(441360, 102, '2015-03-15 00:04:33.000000', 'consum', 0.0215, 'lps'),
	(441361, 102, '2015-03-15 00:04:34.000000', 'consum', 0.0220, 'lps'),
	(441362, 102, '2015-03-15 00:04:35.000000', 'consum', 0.0212, 'lps'),
	(441363, 102, '2015-03-15 00:04:36.000000', 'consum', 0.0210, 'lps'),
	(441364, 102, '2015-03-15 00:04:37.000000', 'consum', 0.0220, 'lps'),
	(441365, 102, '2015-03-15 00:04:38.000000', 'consum', 0.0227, 'lps'),
	(441366, 102, '2015-03-15 00:04:39.000000', 'consum', 0.0211, 'lps'),
	(441367, 102, '2015-03-15 00:04:40.000000', 'consum', 0.0216, 'lps'),
	(441368, 102, '2015-03-15 00:04:41.000000', 'consum', 0.0221, 'lps'),
	(441369, 102, '2015-03-15 00:04:42.000000', 'consum', 0.0211, 'lps'),
	(441370, 102, '2015-03-15 00:04:43.000000', 'consum', 0.0218, 'lps'),
	(441371, 102, '2015-03-15 00:04:44.000000', 'consum', 0.0210, 'lps'),
	(441372, 102, '2015-03-15 00:04:45.000000', 'consum', 0.0224, 'lps'),
	(441373, 102, '2015-03-15 00:04:46.000000', 'consum', 0.0226, 'lps'),
	(441374, 102, '2015-03-15 00:04:47.000000', 'consum', 0.0212, 'lps'),
	(441375, 102, '2015-03-15 00:04:48.000000', 'consum', 0.0210, 'lps'),
	(441376, 102, '2015-03-15 00:04:49.000000', 'consum', 0.0223, 'lps'),
	(441377, 102, '2015-03-15 00:04:50.000000', 'consum', 0.0221, 'lps'),
	(441378, 102, '2015-03-15 00:04:51.000000', 'consum', 0.0226, 'lps'),
	(441379, 102, '2015-03-15 00:04:52.000000', 'consum', 0.0220, 'lps'),
	(441380, 102, '2015-03-15 00:04:53.000000', 'consum', 0.0216, 'lps'),
	(441381, 102, '2015-03-15 00:04:54.000000', 'consum', 0.0226, 'lps'),
	(441382, 102, '2015-03-15 00:04:55.000000', 'consum', 0.0218, 'lps'),
	(441383, 102, '2015-03-15 00:04:56.000000', 'consum', 0.0222, 'lps'),
	(441384, 102, '2015-03-15 00:04:57.000000', 'consum', 0.0211, 'lps'),
	(441385, 102, '2015-03-15 00:04:58.000000', 'consum', 0.0215, 'lps'),
	(441386, 102, '2015-03-15 00:04:59.000000', 'consum', 0.0214, 'lps'),
	(441387, 102, '2015-03-15 00:05:00.000000', 'consum', 0.0214, 'lps'),
	(441388, 102, '2015-03-15 00:05:01.000000', 'consum', 0.0221, 'lps'),
	(441389, 102, '2015-03-15 00:05:02.000000', 'consum', 0.0218, 'lps'),
	(441390, 102, '2015-03-15 00:05:03.000000', 'consum', 0.0215, 'lps'),
	(441391, 102, '2015-03-15 00:05:04.000000', 'consum', 0.0214, 'lps'),
	(441392, 102, '2015-03-15 00:05:05.000000', 'consum', 0.0216, 'lps'),
	(441393, 102, '2015-03-15 00:05:06.000000', 'consum', 0.0226, 'lps'),
	(441394, 102, '2015-03-15 00:05:07.000000', 'consum', 0.0220, 'lps'),
	(441395, 102, '2015-03-15 00:05:08.000000', 'consum', 0.0212, 'lps'),
	(441396, 102, '2015-03-15 00:05:09.000000', 'consum', 0.0210, 'lps'),
	(441397, 102, '2015-03-15 00:05:10.000000', 'consum', 0.0220, 'lps'),
	(441398, 102, '2015-03-15 00:05:11.000000', 'consum', 0.0225, 'lps'),
	(441399, 102, '2015-03-15 00:05:12.000000', 'consum', 0.0221, 'lps'),
	(441400, 102, '2015-03-15 00:05:13.000000', 'consum', 0.0219, 'lps'),
	(441401, 102, '2015-03-15 00:05:14.000000', 'consum', 0.0222, 'lps'),
	(441402, 102, '2015-03-15 00:05:15.000000', 'consum', 0.0210, 'lps'),
	(441403, 102, '2015-03-15 00:05:16.000000', 'consum', 0.0227, 'lps'),
	(441404, 102, '2015-03-15 00:05:17.000000', 'consum', 0.0222, 'lps'),
	(441405, 102, '2015-03-15 00:05:18.000000', 'consum', 0.0221, 'lps'),
	(441406, 102, '2015-03-15 00:05:19.000000', 'consum', 0.0213, 'lps'),
	(441407, 102, '2015-03-15 00:05:20.000000', 'consum', 0.0226, 'lps'),
	(441408, 102, '2015-03-15 00:05:21.000000', 'consum', 0.0211, 'lps'),
	(441409, 102, '2015-03-15 00:05:22.000000', 'consum', 0.0220, 'lps'),
	(441410, 102, '2015-03-15 00:05:23.000000', 'consum', 0.0223, 'lps'),
	(441411, 102, '2015-03-15 00:05:24.000000', 'consum', 0.0210, 'lps'),
	(441412, 102, '2015-03-15 00:05:25.000000', 'consum', 0.0224, 'lps'),
	(441413, 102, '2015-03-15 00:05:26.000000', 'consum', 0.0226, 'lps'),
	(441414, 102, '2015-03-15 00:05:27.000000', 'consum', 0.0213, 'lps'),
	(441415, 102, '2015-03-15 00:05:28.000000', 'consum', 0.0212, 'lps'),
	(441416, 102, '2015-03-15 00:05:29.000000', 'consum', 0.0211, 'lps'),
	(441417, 102, '2015-03-15 00:05:30.000000', 'consum', 0.0227, 'lps'),
	(441418, 102, '2015-03-15 00:05:31.000000', 'consum', 0.0223, 'lps'),
	(441419, 102, '2015-03-15 00:05:32.000000', 'consum', 0.0223, 'lps'),
	(441420, 102, '2015-03-15 00:05:33.000000', 'consum', 0.0221, 'lps'),
	(441421, 102, '2015-03-15 00:05:34.000000', 'consum', 0.0225, 'lps'),
	(441422, 102, '2015-03-15 00:05:35.000000', 'consum', 0.0216, 'lps'),
	(441423, 102, '2015-03-15 00:05:36.000000', 'consum', 0.0213, 'lps'),
	(441424, 102, '2015-03-15 00:05:37.000000', 'consum', 0.0225, 'lps'),
	(441425, 102, '2015-03-15 00:05:38.000000', 'consum', 0.0225, 'lps'),
	(441426, 102, '2015-03-15 00:05:39.000000', 'consum', 0.0222, 'lps'),
	(441427, 102, '2015-03-15 00:05:40.000000', 'consum', 0.0225, 'lps'),
	(441428, 102, '2015-03-15 00:05:41.000000', 'consum', 0.0215, 'lps'),
	(441429, 102, '2015-03-15 00:05:42.000000', 'consum', 0.0226, 'lps'),
	(441430, 102, '2015-03-15 00:05:43.000000', 'consum', 0.0222, 'lps'),
	(441431, 102, '2015-03-15 00:05:44.000000', 'consum', 0.0222, 'lps'),
	(441432, 102, '2015-03-15 00:05:45.000000', 'consum', 0.0215, 'lps'),
	(441433, 102, '2015-03-15 00:05:46.000000', 'consum', 0.0219, 'lps'),
	(441434, 102, '2015-03-15 00:05:47.000000', 'consum', 0.0221, 'lps'),
	(441435, 102, '2015-03-15 00:05:48.000000', 'consum', 0.0222, 'lps'),
	(441436, 102, '2015-03-15 00:05:49.000000', 'consum', 0.0220, 'lps'),
	(441437, 102, '2015-03-15 00:05:50.000000', 'consum', 0.0225, 'lps'),
	(441438, 102, '2015-03-15 00:05:51.000000', 'consum', 0.0217, 'lps'),
	(441439, 102, '2015-03-15 00:05:52.000000', 'consum', 0.0219, 'lps'),
	(441440, 102, '2015-03-15 00:05:53.000000', 'consum', 0.0216, 'lps'),
	(441441, 102, '2015-03-15 00:05:54.000000', 'consum', 0.0215, 'lps'),
	(441442, 102, '2015-03-15 00:05:55.000000', 'consum', 0.0218, 'lps'),
	(441443, 102, '2015-03-15 00:05:56.000000', 'consum', 0.0218, 'lps'),
	(441444, 102, '2015-03-15 00:05:57.000000', 'consum', 0.0226, 'lps'),
	(441445, 102, '2015-03-15 00:05:58.000000', 'consum', 0.0214, 'lps'),
	(441446, 102, '2015-03-15 00:05:59.000000', 'consum', 0.0218, 'lps'),
	(441447, 102, '2015-03-15 00:06:00.000000', 'consum', 0.0220, 'lps'),
	(441448, 102, '2015-03-15 00:06:01.000000', 'consum', 0.0218, 'lps'),
	(441449, 102, '2015-03-15 00:06:02.000000', 'consum', 0.0222, 'lps'),
	(441450, 102, '2015-03-15 00:06:03.000000', 'consum', 0.0227, 'lps'),
	(441451, 102, '2015-03-15 00:06:04.000000', 'consum', 0.0226, 'lps'),
	(441452, 102, '2015-03-15 00:06:05.000000', 'consum', 0.0219, 'lps'),
	(441453, 102, '2015-03-15 00:06:06.000000', 'consum', 0.0226, 'lps'),
	(441454, 102, '2015-03-15 00:06:07.000000', 'consum', 0.0210, 'lps'),
	(441455, 102, '2015-03-15 00:06:08.000000', 'consum', 0.0218, 'lps'),
	(441456, 102, '2015-03-15 00:06:09.000000', 'consum', 0.0212, 'lps'),
	(441457, 102, '2015-03-15 00:06:10.000000', 'consum', 0.0215, 'lps'),
	(441458, 102, '2015-03-15 00:06:11.000000', 'consum', 0.0214, 'lps'),
	(441459, 102, '2015-03-15 00:06:12.000000', 'consum', 0.0212, 'lps'),
	(441460, 102, '2015-03-15 00:06:13.000000', 'consum', 0.0210, 'lps'),
	(441461, 102, '2015-03-15 00:06:14.000000', 'consum', 0.0221, 'lps'),
	(441462, 102, '2015-03-15 00:06:15.000000', 'consum', 0.0214, 'lps'),
	(441463, 102, '2015-03-15 00:06:16.000000', 'consum', 0.0213, 'lps'),
	(441464, 102, '2015-03-15 00:06:17.000000', 'consum', 0.0215, 'lps'),
	(441465, 102, '2015-03-15 00:06:18.000000', 'consum', 0.0210, 'lps'),
	(441466, 102, '2015-03-15 00:06:19.000000', 'consum', 0.0212, 'lps'),
	(441467, 102, '2015-03-15 00:06:20.000000', 'consum', 0.0221, 'lps'),
	(441468, 102, '2015-03-15 00:06:21.000000', 'consum', 0.0223, 'lps'),
	(441469, 102, '2015-03-15 00:06:22.000000', 'consum', 0.0226, 'lps'),
	(441470, 102, '2015-03-15 00:06:23.000000', 'consum', 0.0216, 'lps'),
	(441471, 102, '2015-03-15 00:06:24.000000', 'consum', 0.0211, 'lps'),
	(441472, 102, '2015-03-15 00:06:25.000000', 'consum', 0.0215, 'lps'),
	(441473, 102, '2015-03-15 00:06:26.000000', 'consum', 0.0212, 'lps'),
	(441474, 102, '2015-03-15 00:06:27.000000', 'consum', 0.0225, 'lps'),
	(441475, 102, '2015-03-15 00:06:28.000000', 'consum', 0.0226, 'lps'),
	(441476, 102, '2015-03-15 00:06:29.000000', 'consum', 0.0210, 'lps'),
	(441477, 102, '2015-03-15 00:06:30.000000', 'consum', 0.0217, 'lps'),
	(441478, 102, '2015-03-15 00:06:31.000000', 'consum', 0.0210, 'lps'),
	(441479, 102, '2015-03-15 00:06:32.000000', 'consum', 0.0226, 'lps'),
	(441480, 102, '2015-03-15 00:06:33.000000', 'consum', 0.0217, 'lps'),
	(441481, 102, '2015-03-15 00:06:34.000000', 'consum', 0.0215, 'lps'),
	(441482, 102, '2015-03-15 00:06:35.000000', 'consum', 0.0217, 'lps'),
	(441483, 102, '2015-03-15 00:06:36.000000', 'consum', 0.0211, 'lps'),
	(441484, 102, '2015-03-15 00:06:37.000000', 'consum', 0.0214, 'lps'),
	(441485, 102, '2015-03-15 00:06:38.000000', 'consum', 0.0210, 'lps'),
	(441486, 102, '2015-03-15 00:06:39.000000', 'consum', 0.0215, 'lps'),
	(441487, 102, '2015-03-15 00:06:40.000000', 'consum', 0.0217, 'lps'),
	(441488, 102, '2015-03-15 00:06:41.000000', 'consum', 0.0215, 'lps'),
	(441489, 102, '2015-03-15 00:06:42.000000', 'consum', 0.0212, 'lps'),
	(441490, 102, '2015-03-15 00:06:43.000000', 'consum', 0.0226, 'lps'),
	(441491, 102, '2015-03-15 00:06:44.000000', 'consum', 0.0212, 'lps'),
	(441492, 102, '2015-03-15 00:06:45.000000', 'consum', 0.0227, 'lps'),
	(441493, 102, '2015-03-15 00:06:46.000000', 'consum', 0.0219, 'lps'),
	(441494, 102, '2015-03-15 00:06:47.000000', 'consum', 0.0219, 'lps'),
	(441495, 102, '2015-03-15 00:06:48.000000', 'consum', 0.0212, 'lps'),
	(441496, 102, '2015-03-15 00:06:49.000000', 'consum', 0.0213, 'lps'),
	(441497, 102, '2015-03-15 00:06:50.000000', 'consum', 0.0217, 'lps'),
	(441498, 102, '2015-03-15 00:06:51.000000', 'consum', 0.0220, 'lps'),
	(441499, 102, '2015-03-15 00:06:52.000000', 'consum', 0.0221, 'lps'),
	(441500, 102, '2015-03-15 00:06:53.000000', 'consum', 0.0218, 'lps'),
	(441501, 102, '2015-03-15 00:06:54.000000', 'consum', 0.0219, 'lps'),
	(441502, 102, '2015-03-15 00:06:55.000000', 'consum', 0.0213, 'lps'),
	(441503, 102, '2015-03-15 00:06:56.000000', 'consum', 0.0217, 'lps'),
	(441504, 102, '2015-03-15 00:06:57.000000', 'consum', 0.0217, 'lps'),
	(441505, 102, '2015-03-15 00:06:58.000000', 'consum', 0.0227, 'lps'),
	(441506, 102, '2015-03-15 00:06:59.000000', 'consum', 0.0220, 'lps'),
	(441507, 102, '2015-03-15 00:07:00.000000', 'consum', 0.0226, 'lps'),
	(441508, 102, '2015-03-15 00:07:01.000000', 'consum', 0.0223, 'lps'),
	(441509, 102, '2015-03-15 00:07:02.000000', 'consum', 0.0211, 'lps'),
	(441510, 102, '2015-03-15 00:07:03.000000', 'consum', 0.0214, 'lps'),
	(441511, 102, '2015-03-15 00:07:04.000000', 'consum', 0.0226, 'lps'),
	(441512, 102, '2015-03-15 00:07:05.000000', 'consum', 0.0224, 'lps'),
	(441513, 102, '2015-03-15 00:07:06.000000', 'consum', 0.0214, 'lps'),
	(441514, 102, '2015-03-15 00:07:07.000000', 'consum', 0.0227, 'lps'),
	(441515, 102, '2015-03-15 00:07:08.000000', 'consum', 0.0211, 'lps'),
	(441516, 102, '2015-03-15 00:07:09.000000', 'consum', 0.0217, 'lps'),
	(441517, 102, '2015-03-15 00:07:10.000000', 'consum', 0.0224, 'lps'),
	(441518, 102, '2015-03-15 00:07:11.000000', 'consum', 0.0226, 'lps'),
	(441519, 102, '2015-03-15 00:07:12.000000', 'consum', 0.0211, 'lps'),
	(441520, 102, '2015-03-15 00:07:13.000000', 'consum', 0.0224, 'lps'),
	(441521, 102, '2015-03-15 00:07:14.000000', 'consum', 0.0221, 'lps'),
	(441522, 102, '2015-03-15 00:07:15.000000', 'consum', 0.0225, 'lps'),
	(441523, 102, '2015-03-15 00:07:16.000000', 'consum', 0.0215, 'lps'),
	(441524, 102, '2015-03-15 00:07:17.000000', 'consum', 0.0211, 'lps'),
	(441525, 102, '2015-03-15 00:07:18.000000', 'consum', 0.0215, 'lps'),
	(441526, 102, '2015-03-15 00:07:19.000000', 'consum', 0.0216, 'lps'),
	(441527, 102, '2015-03-15 00:07:20.000000', 'consum', 0.0210, 'lps'),
	(441528, 102, '2015-03-15 00:07:21.000000', 'consum', 0.0225, 'lps'),
	(441529, 102, '2015-03-15 00:07:22.000000', 'consum', 0.0216, 'lps'),
	(441530, 102, '2015-03-15 00:07:23.000000', 'consum', 0.0212, 'lps'),
	(441531, 102, '2015-03-15 00:07:24.000000', 'consum', 0.0222, 'lps'),
	(441532, 102, '2015-03-15 00:07:25.000000', 'consum', 0.0210, 'lps'),
	(441533, 102, '2015-03-15 00:07:26.000000', 'consum', 0.0211, 'lps'),
	(441534, 102, '2015-03-15 00:07:27.000000', 'consum', 0.0213, 'lps'),
	(441535, 102, '2015-03-15 00:07:28.000000', 'consum', 0.0225, 'lps'),
	(441536, 102, '2015-03-15 00:07:29.000000', 'consum', 0.0220, 'lps'),
	(441537, 102, '2015-03-15 00:07:30.000000', 'consum', 0.0215, 'lps'),
	(441538, 102, '2015-03-15 00:07:31.000000', 'consum', 0.0226, 'lps'),
	(441539, 102, '2015-03-15 00:07:32.000000', 'consum', 0.0221, 'lps'),
	(441540, 102, '2015-03-15 00:07:33.000000', 'consum', 0.0215, 'lps'),
	(441541, 102, '2015-03-15 00:07:34.000000', 'consum', 0.0224, 'lps'),
	(441542, 102, '2015-03-15 00:07:35.000000', 'consum', 0.0227, 'lps'),
	(441543, 102, '2015-03-15 00:07:36.000000', 'consum', 0.0216, 'lps'),
	(441544, 102, '2015-03-15 00:07:37.000000', 'consum', 0.0211, 'lps'),
	(441545, 102, '2015-03-15 00:07:38.000000', 'consum', 0.0214, 'lps'),
	(441546, 102, '2015-03-15 00:07:39.000000', 'consum', 0.0226, 'lps'),
	(441547, 102, '2015-03-15 00:07:40.000000', 'consum', 0.0224, 'lps'),
	(441548, 102, '2015-03-15 00:07:41.000000', 'consum', 0.0216, 'lps'),
	(441549, 102, '2015-03-15 00:07:42.000000', 'consum', 0.0215, 'lps'),
	(441550, 102, '2015-03-15 00:07:43.000000', 'consum', 0.0219, 'lps'),
	(441551, 102, '2015-03-15 00:07:44.000000', 'consum', 0.0224, 'lps'),
	(441552, 102, '2015-03-15 00:07:45.000000', 'consum', 0.0215, 'lps'),
	(441553, 102, '2015-03-15 00:07:46.000000', 'consum', 0.0210, 'lps'),
	(441554, 102, '2015-03-15 00:07:47.000000', 'consum', 0.0217, 'lps'),
	(441555, 102, '2015-03-15 00:07:48.000000', 'consum', 0.0224, 'lps'),
	(441556, 102, '2015-03-15 00:07:49.000000', 'consum', 0.0227, 'lps'),
	(441557, 102, '2015-03-15 00:07:50.000000', 'consum', 0.0216, 'lps'),
	(441558, 102, '2015-03-15 00:07:51.000000', 'consum', 0.0225, 'lps'),
	(441559, 102, '2015-03-15 00:07:52.000000', 'consum', 0.0215, 'lps'),
	(441560, 102, '2015-03-15 00:07:53.000000', 'consum', 0.0226, 'lps'),
	(441561, 102, '2015-03-15 00:07:54.000000', 'consum', 0.0223, 'lps'),
	(441562, 102, '2015-03-15 00:07:55.000000', 'consum', 0.0225, 'lps'),
	(441563, 102, '2015-03-15 00:07:56.000000', 'consum', 0.0210, 'lps'),
	(441564, 102, '2015-03-15 00:07:57.000000', 'consum', 0.0222, 'lps'),
	(441565, 102, '2015-03-15 00:07:58.000000', 'consum', 0.0215, 'lps'),
	(441566, 102, '2015-03-15 00:07:59.000000', 'consum', 0.0216, 'lps'),
	(441567, 102, '2015-03-15 00:08:00.000000', 'consum', 0.0227, 'lps'),
	(441568, 102, '2015-03-15 00:08:01.000000', 'consum', 0.0225, 'lps'),
	(441569, 102, '2015-03-15 00:08:02.000000', 'consum', 0.0216, 'lps'),
	(441570, 102, '2015-03-15 00:08:03.000000', 'consum', 0.0212, 'lps'),
	(441571, 102, '2015-03-15 00:08:04.000000', 'consum', 0.0219, 'lps'),
	(441572, 102, '2015-03-15 00:08:05.000000', 'consum', 0.0217, 'lps'),
	(441573, 102, '2015-03-15 00:08:06.000000', 'consum', 0.0218, 'lps'),
	(441574, 102, '2015-03-15 00:08:07.000000', 'consum', 0.0227, 'lps'),
	(441575, 102, '2015-03-15 00:08:08.000000', 'consum', 0.0220, 'lps'),
	(441576, 102, '2015-03-15 00:08:09.000000', 'consum', 0.0225, 'lps'),
	(441577, 102, '2015-03-15 00:08:10.000000', 'consum', 0.0222, 'lps'),
	(441578, 102, '2015-03-15 00:08:11.000000', 'consum', 0.0225, 'lps'),
	(441579, 102, '2015-03-15 00:08:12.000000', 'consum', 0.0215, 'lps'),
	(441580, 102, '2015-03-15 00:08:13.000000', 'consum', 0.0224, 'lps'),
	(441581, 102, '2015-03-15 00:08:14.000000', 'consum', 0.0211, 'lps'),
	(441582, 102, '2015-03-15 00:08:15.000000', 'consum', 0.0210, 'lps'),
	(441583, 102, '2015-03-15 00:08:16.000000', 'consum', 0.0224, 'lps'),
	(441584, 102, '2015-03-15 00:08:17.000000', 'consum', 0.0211, 'lps'),
	(441585, 102, '2015-03-15 00:08:18.000000', 'consum', 0.0226, 'lps'),
	(441586, 102, '2015-03-15 00:08:19.000000', 'consum', 0.0217, 'lps'),
	(441587, 102, '2015-03-15 00:08:20.000000', 'consum', 0.0213, 'lps'),
	(441588, 102, '2015-03-15 00:08:21.000000', 'consum', 0.0226, 'lps'),
	(441589, 102, '2015-03-15 00:08:22.000000', 'consum', 0.0224, 'lps'),
	(441590, 102, '2015-03-15 00:08:23.000000', 'consum', 0.0217, 'lps'),
	(441591, 102, '2015-03-15 00:08:24.000000', 'consum', 0.0220, 'lps'),
	(441592, 102, '2015-03-15 00:08:25.000000', 'consum', 0.0223, 'lps'),
	(441593, 102, '2015-03-15 00:08:26.000000', 'consum', 0.0226, 'lps'),
	(441594, 102, '2015-03-15 00:08:27.000000', 'consum', 0.0215, 'lps'),
	(441595, 102, '2015-03-15 00:08:28.000000', 'consum', 0.0222, 'lps'),
	(441596, 102, '2015-03-15 00:08:29.000000', 'consum', 0.0223, 'lps'),
	(441597, 102, '2015-03-15 00:08:30.000000', 'consum', 0.0219, 'lps'),
	(441598, 102, '2015-03-15 00:08:31.000000', 'consum', 0.0218, 'lps'),
	(441599, 102, '2015-03-15 00:08:32.000000', 'consum', 0.0223, 'lps'),
	(441600, 102, '2015-03-15 00:08:33.000000', 'consum', 0.0214, 'lps'),
	(441601, 102, '2015-03-15 00:08:34.000000', 'consum', 0.0211, 'lps'),
	(441602, 102, '2015-03-15 00:08:35.000000', 'consum', 0.0223, 'lps'),
	(441603, 102, '2015-03-15 00:08:36.000000', 'consum', 0.0218, 'lps'),
	(441604, 102, '2015-03-15 00:08:37.000000', 'consum', 0.0212, 'lps'),
	(441605, 102, '2015-03-15 00:08:38.000000', 'consum', 0.0213, 'lps'),
	(441606, 102, '2015-03-15 00:08:39.000000', 'consum', 0.0220, 'lps'),
	(441607, 102, '2015-03-15 00:08:40.000000', 'consum', 0.0216, 'lps'),
	(441608, 102, '2015-03-15 00:08:41.000000', 'consum', 0.0210, 'lps'),
	(441609, 102, '2015-03-15 00:08:42.000000', 'consum', 0.0211, 'lps'),
	(441610, 102, '2015-03-15 00:08:43.000000', 'consum', 0.0217, 'lps'),
	(441611, 102, '2015-03-15 00:08:44.000000', 'consum', 0.0224, 'lps'),
	(441612, 102, '2015-03-15 00:08:45.000000', 'consum', 0.0225, 'lps'),
	(441613, 102, '2015-03-15 00:08:46.000000', 'consum', 0.0224, 'lps'),
	(441614, 102, '2015-03-15 00:08:47.000000', 'consum', 0.0216, 'lps'),
	(441615, 102, '2015-03-15 00:08:48.000000', 'consum', 0.0217, 'lps'),
	(441616, 102, '2015-03-15 00:08:49.000000', 'consum', 0.0227, 'lps'),
	(441617, 102, '2015-03-15 00:08:50.000000', 'consum', 0.0223, 'lps'),
	(441618, 102, '2015-03-15 00:08:51.000000', 'consum', 0.0222, 'lps'),
	(441619, 102, '2015-03-15 00:08:52.000000', 'consum', 0.0213, 'lps'),
	(441620, 102, '2015-03-15 00:08:53.000000', 'consum', 0.0227, 'lps'),
	(441621, 102, '2015-03-15 00:08:54.000000', 'consum', 0.0215, 'lps'),
	(441622, 102, '2015-03-15 00:08:55.000000', 'consum', 0.0218, 'lps'),
	(441623, 102, '2015-03-15 00:08:56.000000', 'consum', 0.0219, 'lps'),
	(441624, 102, '2015-03-15 00:08:57.000000', 'consum', 0.0213, 'lps'),
	(441625, 102, '2015-03-15 00:08:58.000000', 'consum', 0.0215, 'lps'),
	(441626, 102, '2015-03-15 00:08:59.000000', 'consum', 0.0210, 'lps'),
	(441627, 102, '2015-03-15 00:09:00.000000', 'consum', 0.0212, 'lps'),
	(441628, 102, '2015-03-15 00:09:01.000000', 'consum', 0.0222, 'lps'),
	(441629, 102, '2015-03-15 00:09:02.000000', 'consum', 0.0227, 'lps'),
	(441630, 102, '2015-03-15 00:09:03.000000', 'consum', 0.0225, 'lps'),
	(441631, 102, '2015-03-15 00:09:04.000000', 'consum', 0.0216, 'lps'),
	(441632, 102, '2015-03-15 00:09:05.000000', 'consum', 0.0215, 'lps'),
	(441633, 102, '2015-03-15 00:09:06.000000', 'consum', 0.0216, 'lps'),
	(441634, 102, '2015-03-15 00:09:07.000000', 'consum', 0.0225, 'lps'),
	(441635, 102, '2015-03-15 00:09:08.000000', 'consum', 0.0216, 'lps'),
	(441636, 102, '2015-03-15 00:09:09.000000', 'consum', 0.0210, 'lps'),
	(441637, 102, '2015-03-15 00:09:10.000000', 'consum', 0.0213, 'lps'),
	(441638, 102, '2015-03-15 00:09:11.000000', 'consum', 0.0226, 'lps'),
	(441639, 102, '2015-03-15 00:09:12.000000', 'consum', 0.0210, 'lps'),
	(441640, 102, '2015-03-15 00:09:13.000000', 'consum', 0.0215, 'lps'),
	(441641, 102, '2015-03-15 00:09:14.000000', 'consum', 0.0217, 'lps'),
	(441642, 102, '2015-03-15 00:09:15.000000', 'consum', 0.0215, 'lps'),
	(441643, 102, '2015-03-15 00:09:16.000000', 'consum', 0.0213, 'lps'),
	(441644, 102, '2015-03-15 00:09:17.000000', 'consum', 0.0210, 'lps'),
	(441645, 102, '2015-03-15 00:09:18.000000', 'consum', 0.0219, 'lps'),
	(441646, 102, '2015-03-15 00:09:19.000000', 'consum', 0.0222, 'lps'),
	(441647, 102, '2015-03-15 00:09:20.000000', 'consum', 0.0223, 'lps'),
	(441648, 102, '2015-03-15 00:09:21.000000', 'consum', 0.0224, 'lps'),
	(441649, 102, '2015-03-15 00:09:22.000000', 'consum', 0.0223, 'lps'),
	(441650, 102, '2015-03-15 00:09:23.000000', 'consum', 0.0217, 'lps'),
	(441651, 102, '2015-03-15 00:09:24.000000', 'consum', 0.0223, 'lps'),
	(441652, 102, '2015-03-15 00:09:25.000000', 'consum', 0.0220, 'lps'),
	(441653, 102, '2015-03-15 00:09:26.000000', 'consum', 0.0221, 'lps'),
	(441654, 102, '2015-03-15 00:09:27.000000', 'consum', 0.0218, 'lps'),
	(441655, 102, '2015-03-15 00:09:28.000000', 'consum', 0.0216, 'lps'),
	(441656, 102, '2015-03-15 00:09:29.000000', 'consum', 0.0219, 'lps'),
	(441657, 102, '2015-03-15 00:09:30.000000', 'consum', 0.0216, 'lps'),
	(441658, 102, '2015-03-15 00:09:31.000000', 'consum', 0.0215, 'lps'),
	(441659, 102, '2015-03-15 00:09:32.000000', 'consum', 0.0219, 'lps'),
	(441660, 102, '2015-03-15 00:09:33.000000', 'consum', 0.0221, 'lps'),
	(441661, 102, '2015-03-15 00:09:34.000000', 'consum', 0.0223, 'lps'),
	(441662, 102, '2015-03-15 00:09:35.000000', 'consum', 0.0222, 'lps'),
	(441663, 102, '2015-03-15 00:09:36.000000', 'consum', 0.0216, 'lps'),
	(441664, 102, '2015-03-15 00:09:37.000000', 'consum', 0.0220, 'lps'),
	(441665, 102, '2015-03-15 00:09:38.000000', 'consum', 0.0227, 'lps'),
	(441666, 102, '2015-03-15 00:09:39.000000', 'consum', 0.0211, 'lps'),
	(441667, 102, '2015-03-15 00:09:40.000000', 'consum', 0.0219, 'lps'),
	(441668, 102, '2015-03-15 00:09:41.000000', 'consum', 0.0214, 'lps'),
	(441669, 102, '2015-03-15 00:09:42.000000', 'consum', 0.0223, 'lps'),
	(441670, 102, '2015-03-15 00:09:43.000000', 'consum', 0.0227, 'lps'),
	(441671, 102, '2015-03-15 00:09:44.000000', 'consum', 0.0220, 'lps'),
	(441672, 102, '2015-03-15 00:09:45.000000', 'consum', 0.0211, 'lps'),
	(441673, 102, '2015-03-15 00:09:46.000000', 'consum', 0.0222, 'lps'),
	(441674, 102, '2015-03-15 00:09:47.000000', 'consum', 0.0214, 'lps'),
	(441675, 102, '2015-03-15 00:09:48.000000', 'consum', 0.0212, 'lps'),
	(441676, 102, '2015-03-15 00:09:49.000000', 'consum', 0.0227, 'lps'),
	(441677, 102, '2015-03-15 00:09:50.000000', 'consum', 0.0217, 'lps'),
	(441678, 102, '2015-03-15 00:09:51.000000', 'consum', 0.0214, 'lps'),
	(441679, 102, '2015-03-15 00:09:52.000000', 'consum', 0.0227, 'lps'),
	(441680, 102, '2015-03-15 00:09:53.000000', 'consum', 0.0211, 'lps'),
	(441681, 102, '2015-03-15 00:09:54.000000', 'consum', 0.0219, 'lps'),
	(441682, 102, '2015-03-15 00:09:55.000000', 'consum', 0.0216, 'lps'),
	(441683, 102, '2015-03-15 00:09:56.000000', 'consum', 0.0213, 'lps'),
	(441684, 102, '2015-03-15 00:09:57.000000', 'consum', 0.0225, 'lps'),
	(441685, 102, '2015-03-15 00:09:58.000000', 'consum', 0.0222, 'lps'),
	(441686, 102, '2015-03-15 00:09:59.000000', 'consum', 0.0224, 'lps'),
	(441687, 102, '2015-03-15 00:10:00.000000', 'consum', 0.0211, 'lps'),
	(441688, 102, '2015-03-15 00:10:01.000000', 'consum', 0.0211, 'lps'),
	(441689, 102, '2015-03-15 00:10:02.000000', 'consum', 0.0210, 'lps'),
	(441690, 102, '2015-03-15 00:10:03.000000', 'consum', 0.0227, 'lps'),
	(441691, 102, '2015-03-15 00:10:04.000000', 'consum', 0.0225, 'lps'),
	(441692, 102, '2015-03-15 00:10:05.000000', 'consum', 0.0214, 'lps'),
	(441693, 102, '2015-03-15 00:10:06.000000', 'consum', 0.0222, 'lps'),
	(441694, 102, '2015-03-15 00:10:07.000000', 'consum', 0.0224, 'lps'),
	(441695, 102, '2015-03-15 00:10:08.000000', 'consum', 0.0226, 'lps'),
	(441696, 102, '2015-03-15 00:10:09.000000', 'consum', 0.0214, 'lps'),
	(441697, 102, '2015-03-15 00:10:10.000000', 'consum', 0.0218, 'lps'),
	(441698, 102, '2015-03-15 00:10:11.000000', 'consum', 0.0218, 'lps'),
	(441699, 102, '2015-03-15 00:10:12.000000', 'consum', 0.0211, 'lps'),
	(441700, 102, '2015-03-15 00:10:13.000000', 'consum', 0.0226, 'lps'),
	(441701, 102, '2015-03-15 00:10:14.000000', 'consum', 0.0215, 'lps'),
	(441702, 102, '2015-03-15 00:10:15.000000', 'consum', 0.0224, 'lps'),
	(441703, 102, '2015-03-15 00:10:16.000000', 'consum', 0.0211, 'lps'),
	(441704, 102, '2015-03-15 00:10:17.000000', 'consum', 0.0211, 'lps'),
	(441705, 102, '2015-03-15 00:10:18.000000', 'consum', 0.0211, 'lps'),
	(441706, 102, '2015-03-15 00:10:19.000000', 'consum', 0.0214, 'lps'),
	(441707, 102, '2015-03-15 00:10:20.000000', 'consum', 0.0226, 'lps'),
	(441708, 102, '2015-03-15 00:10:21.000000', 'consum', 0.0226, 'lps'),
	(441709, 102, '2015-03-15 00:10:22.000000', 'consum', 0.0225, 'lps'),
	(441710, 102, '2015-03-15 00:10:23.000000', 'consum', 0.0219, 'lps'),
	(441711, 102, '2015-03-15 00:10:24.000000', 'consum', 0.0212, 'lps'),
	(441712, 102, '2015-03-15 00:10:25.000000', 'consum', 0.0211, 'lps'),
	(441713, 102, '2015-03-15 00:10:26.000000', 'consum', 0.0226, 'lps'),
	(441714, 102, '2015-03-15 00:10:27.000000', 'consum', 0.0217, 'lps'),
	(441715, 102, '2015-03-15 00:10:28.000000', 'consum', 0.0216, 'lps'),
	(441716, 102, '2015-03-15 00:10:29.000000', 'consum', 0.0217, 'lps'),
	(441717, 102, '2015-03-15 00:10:30.000000', 'consum', 0.0211, 'lps'),
	(441718, 102, '2015-03-15 00:10:31.000000', 'consum', 0.0212, 'lps'),
	(441719, 102, '2015-03-15 00:10:32.000000', 'consum', 0.0217, 'lps'),
	(441720, 102, '2015-03-15 00:10:33.000000', 'consum', 0.0221, 'lps'),
	(441721, 102, '2015-03-15 00:10:34.000000', 'consum', 0.0210, 'lps'),
	(441722, 102, '2015-03-15 00:10:35.000000', 'consum', 0.0214, 'lps'),
	(441723, 102, '2015-03-15 00:10:36.000000', 'consum', 0.0213, 'lps'),
	(441724, 102, '2015-03-15 00:10:37.000000', 'consum', 0.0211, 'lps'),
	(441725, 102, '2015-03-15 00:10:38.000000', 'consum', 0.0224, 'lps'),
	(441726, 102, '2015-03-15 00:10:39.000000', 'consum', 0.0226, 'lps'),
	(441727, 102, '2015-03-15 00:10:40.000000', 'consum', 0.0210, 'lps'),
	(441728, 102, '2015-03-15 00:10:41.000000', 'consum', 0.0219, 'lps'),
	(441729, 102, '2015-03-15 00:10:42.000000', 'consum', 0.0219, 'lps'),
	(441730, 102, '2015-03-15 00:10:43.000000', 'consum', 0.0227, 'lps'),
	(441731, 102, '2015-03-15 00:10:44.000000', 'consum', 0.0216, 'lps'),
	(441732, 102, '2015-03-15 00:10:45.000000', 'consum', 0.0225, 'lps'),
	(441733, 102, '2015-03-15 00:10:46.000000', 'consum', 0.0214, 'lps'),
	(441734, 102, '2015-03-15 00:10:47.000000', 'consum', 0.0219, 'lps'),
	(441735, 102, '2015-03-15 00:10:48.000000', 'consum', 0.0227, 'lps'),
	(441736, 102, '2015-03-15 00:10:49.000000', 'consum', 0.0216, 'lps'),
	(441737, 102, '2015-03-15 00:10:50.000000', 'consum', 0.0223, 'lps'),
	(441738, 102, '2015-03-15 00:10:51.000000', 'consum', 0.0223, 'lps'),
	(441739, 102, '2015-03-15 00:10:52.000000', 'consum', 0.0217, 'lps'),
	(441740, 102, '2015-03-15 00:10:53.000000', 'consum', 0.0225, 'lps'),
	(441741, 102, '2015-03-15 00:10:54.000000', 'consum', 0.0211, 'lps'),
	(441742, 102, '2015-03-15 00:10:55.000000', 'consum', 0.0226, 'lps'),
	(441743, 102, '2015-03-15 00:10:56.000000', 'consum', 0.0213, 'lps'),
	(441744, 102, '2015-03-15 00:10:57.000000', 'consum', 0.0216, 'lps'),
	(441745, 102, '2015-03-15 00:10:58.000000', 'consum', 0.0211, 'lps'),
	(441746, 102, '2015-03-15 00:10:59.000000', 'consum', 0.0216, 'lps'),
	(441747, 102, '2015-03-15 00:11:00.000000', 'consum', 0.0222, 'lps'),
	(441748, 102, '2015-03-15 00:11:01.000000', 'consum', 0.0213, 'lps'),
	(441749, 102, '2015-03-15 00:11:02.000000', 'consum', 0.0227, 'lps'),
	(441750, 102, '2015-03-15 00:11:03.000000', 'consum', 0.0214, 'lps'),
	(441751, 102, '2015-03-15 00:11:04.000000', 'consum', 0.0217, 'lps'),
	(441752, 102, '2015-03-15 00:11:05.000000', 'consum', 0.0213, 'lps'),
	(441753, 102, '2015-03-15 00:11:06.000000', 'consum', 0.0223, 'lps'),
	(441754, 102, '2015-03-15 00:11:07.000000', 'consum', 0.0211, 'lps'),
	(441755, 102, '2015-03-15 00:11:08.000000', 'consum', 0.0214, 'lps'),
	(441756, 102, '2015-03-15 00:11:09.000000', 'consum', 0.0211, 'lps'),
	(441757, 102, '2015-03-15 00:11:10.000000', 'consum', 0.0219, 'lps'),
	(441758, 102, '2015-03-15 00:11:11.000000', 'consum', 0.0219, 'lps'),
	(441759, 102, '2015-03-15 00:11:12.000000', 'consum', 0.0211, 'lps'),
	(441760, 102, '2015-03-15 00:11:13.000000', 'consum', 0.0222, 'lps'),
	(441761, 102, '2015-03-15 00:11:14.000000', 'consum', 0.0215, 'lps'),
	(441762, 102, '2015-03-15 00:11:15.000000', 'consum', 0.0216, 'lps'),
	(441763, 102, '2015-03-15 00:11:16.000000', 'consum', 0.0226, 'lps'),
	(441764, 102, '2015-03-15 00:11:17.000000', 'consum', 0.0220, 'lps'),
	(441765, 102, '2015-03-15 00:11:18.000000', 'consum', 0.0210, 'lps'),
	(441766, 102, '2015-03-15 00:11:19.000000', 'consum', 0.0219, 'lps'),
	(441767, 102, '2015-03-15 00:11:20.000000', 'consum', 0.0217, 'lps'),
	(441768, 102, '2015-03-15 00:11:21.000000', 'consum', 0.0218, 'lps'),
	(441769, 102, '2015-03-15 00:11:22.000000', 'consum', 0.0211, 'lps'),
	(441770, 102, '2015-03-15 00:11:23.000000', 'consum', 0.0212, 'lps'),
	(441771, 102, '2015-03-15 00:11:24.000000', 'consum', 0.0217, 'lps'),
	(441772, 102, '2015-03-15 00:11:25.000000', 'consum', 0.0222, 'lps'),
	(441773, 102, '2015-03-15 00:11:26.000000', 'consum', 0.0212, 'lps'),
	(441774, 102, '2015-03-15 00:11:27.000000', 'consum', 0.0220, 'lps'),
	(441775, 102, '2015-03-15 00:11:28.000000', 'consum', 0.0220, 'lps'),
	(441776, 102, '2015-03-15 00:11:29.000000', 'consum', 0.0211, 'lps'),
	(441777, 102, '2015-03-15 00:11:30.000000', 'consum', 0.0221, 'lps'),
	(441778, 102, '2015-03-15 00:11:31.000000', 'consum', 0.0226, 'lps'),
	(441779, 102, '2015-03-15 00:11:32.000000', 'consum', 0.0224, 'lps'),
	(441780, 102, '2015-03-15 00:11:33.000000', 'consum', 0.0212, 'lps'),
	(441781, 102, '2015-03-15 00:11:34.000000', 'consum', 0.0214, 'lps'),
	(441782, 102, '2015-03-15 00:11:35.000000', 'consum', 0.0226, 'lps'),
	(441783, 102, '2015-03-15 00:11:36.000000', 'consum', 0.0224, 'lps'),
	(441784, 102, '2015-03-15 00:11:37.000000', 'consum', 0.0214, 'lps'),
	(441785, 102, '2015-03-15 00:11:38.000000', 'consum', 0.0223, 'lps'),
	(441786, 102, '2015-03-15 00:11:39.000000', 'consum', 0.0211, 'lps'),
	(441787, 102, '2015-03-15 00:11:40.000000', 'consum', 0.0214, 'lps'),
	(441788, 102, '2015-03-15 00:11:41.000000', 'consum', 0.0225, 'lps'),
	(441789, 102, '2015-03-15 00:11:42.000000', 'consum', 0.0221, 'lps'),
	(441790, 102, '2015-03-15 00:11:43.000000', 'consum', 0.0220, 'lps'),
	(441791, 102, '2015-03-15 00:11:44.000000', 'consum', 0.0210, 'lps'),
	(441792, 102, '2015-03-15 00:11:45.000000', 'consum', 0.0217, 'lps'),
	(441793, 102, '2015-03-15 00:11:46.000000', 'consum', 0.0227, 'lps'),
	(441794, 102, '2015-03-15 00:11:47.000000', 'consum', 0.0220, 'lps'),
	(441795, 102, '2015-03-15 00:11:48.000000', 'consum', 0.0210, 'lps'),
	(441796, 102, '2015-03-15 00:11:49.000000', 'consum', 0.0217, 'lps'),
	(441797, 102, '2015-03-15 00:11:50.000000', 'consum', 0.0227, 'lps'),
	(441798, 102, '2015-03-15 00:11:51.000000', 'consum', 0.0219, 'lps'),
	(441799, 102, '2015-03-15 00:11:52.000000', 'consum', 0.0225, 'lps'),
	(441800, 102, '2015-03-15 00:11:53.000000', 'consum', 0.0223, 'lps'),
	(441801, 102, '2015-03-15 00:11:54.000000', 'consum', 0.0213, 'lps'),
	(441802, 102, '2015-03-15 00:11:55.000000', 'consum', 0.0221, 'lps'),
	(441803, 102, '2015-03-15 00:11:56.000000', 'consum', 0.0221, 'lps'),
	(441804, 102, '2015-03-15 00:11:57.000000', 'consum', 0.0215, 'lps'),
	(441805, 102, '2015-03-15 00:11:58.000000', 'consum', 0.0219, 'lps'),
	(441806, 102, '2015-03-15 00:11:59.000000', 'consum', 0.0222, 'lps'),
	(441807, 102, '2015-03-15 00:12:00.000000', 'consum', 0.0225, 'lps'),
	(441808, 102, '2015-03-15 00:12:01.000000', 'consum', 0.0216, 'lps'),
	(441809, 102, '2015-03-15 00:12:02.000000', 'consum', 0.0211, 'lps'),
	(441810, 102, '2015-03-15 00:12:03.000000', 'consum', 0.0217, 'lps'),
	(441811, 102, '2015-03-15 00:12:04.000000', 'consum', 0.0223, 'lps'),
	(441812, 102, '2015-03-15 00:12:05.000000', 'consum', 0.0221, 'lps'),
	(441813, 102, '2015-03-15 00:12:06.000000', 'consum', 0.0225, 'lps'),
	(441814, 102, '2015-03-15 00:12:07.000000', 'consum', 0.0216, 'lps'),
	(441815, 102, '2015-03-15 00:12:08.000000', 'consum', 0.0213, 'lps'),
	(441816, 102, '2015-03-15 00:12:09.000000', 'consum', 0.0210, 'lps'),
	(441817, 102, '2015-03-15 00:12:10.000000', 'consum', 0.0217, 'lps'),
	(441818, 102, '2015-03-15 00:12:11.000000', 'consum', 0.0210, 'lps'),
	(441819, 102, '2015-03-15 00:12:12.000000', 'consum', 0.0227, 'lps'),
	(441820, 102, '2015-03-15 00:12:13.000000', 'consum', 0.0225, 'lps'),
	(441821, 102, '2015-03-15 00:12:14.000000', 'consum', 0.0213, 'lps'),
	(441822, 102, '2015-03-15 00:12:15.000000', 'consum', 0.0217, 'lps'),
	(441823, 102, '2015-03-15 00:12:16.000000', 'consum', 0.0220, 'lps'),
	(441824, 102, '2015-03-15 00:12:17.000000', 'consum', 0.0220, 'lps'),
	(441825, 102, '2015-03-15 00:12:18.000000', 'consum', 0.0212, 'lps'),
	(441826, 102, '2015-03-15 00:12:19.000000', 'consum', 0.0211, 'lps'),
	(441827, 102, '2015-03-15 00:12:20.000000', 'consum', 0.0226, 'lps'),
	(441828, 102, '2015-03-15 00:12:21.000000', 'consum', 0.0214, 'lps'),
	(441829, 102, '2015-03-15 00:12:22.000000', 'consum', 0.0221, 'lps'),
	(441830, 102, '2015-03-15 00:12:23.000000', 'consum', 0.0215, 'lps'),
	(441831, 102, '2015-03-15 00:12:24.000000', 'consum', 0.0223, 'lps'),
	(441832, 102, '2015-03-15 00:12:25.000000', 'consum', 0.0224, 'lps'),
	(441833, 102, '2015-03-15 00:12:26.000000', 'consum', 0.0225, 'lps'),
	(441834, 102, '2015-03-15 00:12:27.000000', 'consum', 0.0225, 'lps'),
	(441835, 102, '2015-03-15 00:12:28.000000', 'consum', 0.0223, 'lps'),
	(441836, 102, '2015-03-15 00:12:29.000000', 'consum', 0.0211, 'lps'),
	(441837, 102, '2015-03-15 00:12:30.000000', 'consum', 0.0213, 'lps'),
	(441838, 102, '2015-03-15 00:12:31.000000', 'consum', 0.0221, 'lps'),
	(441839, 102, '2015-03-15 00:12:32.000000', 'consum', 0.0220, 'lps'),
	(441840, 102, '2015-03-15 00:12:33.000000', 'consum', 0.0227, 'lps'),
	(441841, 102, '2015-03-15 00:12:34.000000', 'consum', 0.0212, 'lps'),
	(441842, 102, '2015-03-15 00:12:35.000000', 'consum', 0.0222, 'lps'),
	(441843, 102, '2015-03-15 00:12:36.000000', 'consum', 0.0212, 'lps'),
	(441844, 102, '2015-03-15 00:12:37.000000', 'consum', 0.0221, 'lps'),
	(441845, 102, '2015-03-15 00:12:38.000000', 'consum', 0.0224, 'lps'),
	(441846, 102, '2015-03-15 00:12:39.000000', 'consum', 0.0211, 'lps'),
	(441847, 102, '2015-03-15 00:12:40.000000', 'consum', 0.0211, 'lps'),
	(441848, 102, '2015-03-15 00:12:41.000000', 'consum', 0.0210, 'lps'),
	(441849, 102, '2015-03-15 00:12:42.000000', 'consum', 0.0224, 'lps'),
	(441850, 102, '2015-03-15 00:12:43.000000', 'consum', 0.0212, 'lps'),
	(441851, 102, '2015-03-15 00:12:44.000000', 'consum', 0.0213, 'lps'),
	(441852, 102, '2015-03-15 00:12:45.000000', 'consum', 0.0218, 'lps'),
	(441853, 102, '2015-03-15 00:12:46.000000', 'consum', 0.0225, 'lps'),
	(441854, 102, '2015-03-15 00:12:47.000000', 'consum', 0.0226, 'lps'),
	(441855, 102, '2015-03-15 00:12:48.000000', 'consum', 0.0226, 'lps'),
	(441856, 102, '2015-03-15 00:12:49.000000', 'consum', 0.0225, 'lps'),
	(441857, 102, '2015-03-15 00:12:50.000000', 'consum', 0.0220, 'lps'),
	(441858, 102, '2015-03-15 00:12:51.000000', 'consum', 0.0215, 'lps'),
	(441859, 102, '2015-03-15 00:12:52.000000', 'consum', 0.0222, 'lps'),
	(441860, 102, '2015-03-15 00:12:53.000000', 'consum', 0.0222, 'lps'),
	(441861, 102, '2015-03-15 00:12:54.000000', 'consum', 0.0214, 'lps'),
	(441862, 102, '2015-03-15 00:12:55.000000', 'consum', 0.0212, 'lps'),
	(441863, 102, '2015-03-15 00:12:56.000000', 'consum', 0.0226, 'lps'),
	(441864, 102, '2015-03-15 00:12:57.000000', 'consum', 0.0213, 'lps'),
	(441865, 102, '2015-03-15 00:12:58.000000', 'consum', 0.0216, 'lps'),
	(441866, 102, '2015-03-15 00:12:59.000000', 'consum', 0.0211, 'lps'),
	(441867, 102, '2015-03-15 00:13:00.000000', 'consum', 0.0215, 'lps'),
	(441868, 102, '2015-03-15 00:13:01.000000', 'consum', 0.0215, 'lps'),
	(441869, 102, '2015-03-15 00:13:02.000000', 'consum', 0.0219, 'lps'),
	(441870, 102, '2015-03-15 00:13:03.000000', 'consum', 0.0225, 'lps'),
	(441871, 102, '2015-03-15 00:13:04.000000', 'consum', 0.0221, 'lps'),
	(441872, 102, '2015-03-15 00:13:05.000000', 'consum', 0.0220, 'lps'),
	(441873, 102, '2015-03-15 00:13:06.000000', 'consum', 0.0212, 'lps'),
	(441874, 102, '2015-03-15 00:13:07.000000', 'consum', 0.0225, 'lps'),
	(441875, 102, '2015-03-15 00:13:08.000000', 'consum', 0.0225, 'lps'),
	(441876, 102, '2015-03-15 00:13:09.000000', 'consum', 0.0224, 'lps'),
	(441877, 102, '2015-03-15 00:13:10.000000', 'consum', 0.0217, 'lps'),
	(441878, 102, '2015-03-15 00:13:11.000000', 'consum', 0.0222, 'lps'),
	(441879, 102, '2015-03-15 00:13:12.000000', 'consum', 0.0212, 'lps'),
	(441880, 102, '2015-03-15 00:13:13.000000', 'consum', 0.0221, 'lps'),
	(441881, 102, '2015-03-15 00:13:14.000000', 'consum', 0.0223, 'lps'),
	(441882, 102, '2015-03-15 00:13:15.000000', 'consum', 0.0225, 'lps'),
	(441883, 102, '2015-03-15 00:13:16.000000', 'consum', 0.0227, 'lps'),
	(441884, 102, '2015-03-15 00:13:17.000000', 'consum', 0.0217, 'lps'),
	(441885, 102, '2015-03-15 00:13:18.000000', 'consum', 0.0211, 'lps'),
	(441886, 102, '2015-03-15 00:13:19.000000', 'consum', 0.0212, 'lps'),
	(441887, 102, '2015-03-15 00:13:20.000000', 'consum', 0.0219, 'lps'),
	(441888, 102, '2015-03-15 00:13:21.000000', 'consum', 0.0212, 'lps'),
	(441889, 102, '2015-03-15 00:13:22.000000', 'consum', 0.0214, 'lps'),
	(441890, 102, '2015-03-15 00:13:23.000000', 'consum', 0.0224, 'lps'),
	(441891, 102, '2015-03-15 00:13:24.000000', 'consum', 0.0214, 'lps'),
	(441892, 102, '2015-03-15 00:13:25.000000', 'consum', 0.0226, 'lps'),
	(441893, 102, '2015-03-15 00:13:26.000000', 'consum', 0.0225, 'lps'),
	(441894, 102, '2015-03-15 00:13:27.000000', 'consum', 0.0217, 'lps'),
	(441895, 102, '2015-03-15 00:13:28.000000', 'consum', 0.0221, 'lps'),
	(441896, 102, '2015-03-15 00:13:29.000000', 'consum', 0.0226, 'lps'),
	(441897, 102, '2015-03-15 00:13:30.000000', 'consum', 0.0223, 'lps'),
	(441898, 102, '2015-03-15 00:13:31.000000', 'consum', 0.0224, 'lps'),
	(441899, 102, '2015-03-15 00:13:32.000000', 'consum', 0.0226, 'lps'),
	(441900, 102, '2015-03-15 00:13:33.000000', 'consum', 0.0210, 'lps'),
	(441901, 102, '2015-03-15 00:13:34.000000', 'consum', 0.0216, 'lps'),
	(441902, 102, '2015-03-15 00:13:35.000000', 'consum', 0.0225, 'lps'),
	(441903, 102, '2015-03-15 00:13:36.000000', 'consum', 0.0214, 'lps'),
	(441904, 102, '2015-03-15 00:13:37.000000', 'consum', 0.0219, 'lps'),
	(441905, 102, '2015-03-15 00:13:38.000000', 'consum', 0.0226, 'lps'),
	(441906, 102, '2015-03-15 00:13:39.000000', 'consum', 0.0210, 'lps'),
	(441907, 102, '2015-03-15 00:13:40.000000', 'consum', 0.0218, 'lps'),
	(441908, 102, '2015-03-15 00:13:41.000000', 'consum', 0.0215, 'lps'),
	(441909, 102, '2015-03-15 00:13:42.000000', 'consum', 0.0210, 'lps'),
	(441910, 102, '2015-03-15 00:13:43.000000', 'consum', 0.0214, 'lps'),
	(441911, 102, '2015-03-15 00:13:44.000000', 'consum', 0.0210, 'lps'),
	(441912, 102, '2015-03-15 00:13:45.000000', 'consum', 0.0220, 'lps'),
	(441913, 102, '2015-03-15 00:13:46.000000', 'consum', 0.0222, 'lps'),
	(441914, 102, '2015-03-15 00:13:47.000000', 'consum', 0.0223, 'lps'),
	(441915, 102, '2015-03-15 00:13:48.000000', 'consum', 0.0220, 'lps'),
	(441916, 102, '2015-03-15 00:13:49.000000', 'consum', 0.0224, 'lps'),
	(441917, 102, '2015-03-15 00:13:50.000000', 'consum', 0.0215, 'lps'),
	(441918, 102, '2015-03-15 00:13:51.000000', 'consum', 0.0211, 'lps'),
	(441919, 102, '2015-03-15 00:13:52.000000', 'consum', 0.0220, 'lps'),
	(441920, 102, '2015-03-15 00:13:53.000000', 'consum', 0.0221, 'lps'),
	(441921, 102, '2015-03-15 00:13:54.000000', 'consum', 0.0216, 'lps'),
	(441922, 102, '2015-03-15 00:13:55.000000', 'consum', 0.0226, 'lps'),
	(441923, 102, '2015-03-15 00:13:56.000000', 'consum', 0.0220, 'lps'),
	(441924, 102, '2015-03-15 00:13:57.000000', 'consum', 0.0211, 'lps'),
	(441925, 102, '2015-03-15 00:13:58.000000', 'consum', 0.0222, 'lps'),
	(441926, 102, '2015-03-15 00:13:59.000000', 'consum', 0.0212, 'lps'),
	(441927, 102, '2015-03-15 00:14:00.000000', 'consum', 0.0223, 'lps'),
	(441928, 102, '2015-03-15 00:14:01.000000', 'consum', 0.0214, 'lps'),
	(441929, 102, '2015-03-15 00:14:02.000000', 'consum', 0.0210, 'lps'),
	(441930, 102, '2015-03-15 00:14:03.000000', 'consum', 0.0215, 'lps'),
	(441931, 102, '2015-03-15 00:14:04.000000', 'consum', 0.0216, 'lps'),
	(441932, 102, '2015-03-15 00:14:05.000000', 'consum', 0.0211, 'lps'),
	(441933, 102, '2015-03-15 00:14:06.000000', 'consum', 0.0215, 'lps'),
	(441934, 102, '2015-03-15 00:14:07.000000', 'consum', 0.0215, 'lps'),
	(441935, 102, '2015-03-15 00:14:08.000000', 'consum', 0.0220, 'lps'),
	(441936, 102, '2015-03-15 00:14:09.000000', 'consum', 0.0211, 'lps'),
	(441937, 102, '2015-03-15 00:14:10.000000', 'consum', 0.0219, 'lps'),
	(441938, 102, '2015-03-15 00:14:11.000000', 'consum', 0.0219, 'lps'),
	(441939, 102, '2015-03-15 00:14:12.000000', 'consum', 0.0227, 'lps'),
	(441940, 102, '2015-03-15 00:14:13.000000', 'consum', 0.0215, 'lps'),
	(441941, 102, '2015-03-15 00:14:14.000000', 'consum', 0.0222, 'lps'),
	(441942, 102, '2015-03-15 00:14:15.000000', 'consum', 0.0220, 'lps'),
	(441943, 102, '2015-03-15 00:14:16.000000', 'consum', 0.0223, 'lps'),
	(441944, 102, '2015-03-15 00:14:17.000000', 'consum', 0.0211, 'lps'),
	(441945, 102, '2015-03-15 00:14:18.000000', 'consum', 0.0210, 'lps'),
	(441946, 102, '2015-03-15 00:14:19.000000', 'consum', 0.0227, 'lps'),
	(441947, 102, '2015-03-15 00:14:20.000000', 'consum', 0.0223, 'lps'),
	(441948, 102, '2015-03-15 00:14:21.000000', 'consum', 0.0226, 'lps'),
	(441949, 102, '2015-03-15 00:14:22.000000', 'consum', 0.0214, 'lps'),
	(441950, 102, '2015-03-15 00:14:23.000000', 'consum', 0.0217, 'lps'),
	(441951, 102, '2015-03-15 00:14:24.000000', 'consum', 0.0218, 'lps'),
	(441952, 102, '2015-03-15 00:14:25.000000', 'consum', 0.0213, 'lps'),
	(441953, 102, '2015-03-15 00:14:26.000000', 'consum', 0.0216, 'lps'),
	(441954, 102, '2015-03-15 00:14:27.000000', 'consum', 0.0216, 'lps'),
	(441955, 102, '2015-03-15 00:14:28.000000', 'consum', 0.0222, 'lps'),
	(441956, 102, '2015-03-15 00:14:29.000000', 'consum', 0.0217, 'lps'),
	(441957, 102, '2015-03-15 00:14:30.000000', 'consum', 0.0227, 'lps'),
	(441958, 102, '2015-03-15 00:14:31.000000', 'consum', 0.0219, 'lps'),
	(441959, 102, '2015-03-15 00:14:32.000000', 'consum', 0.0225, 'lps'),
	(441960, 102, '2015-03-15 00:14:33.000000', 'consum', 0.0223, 'lps'),
	(441961, 102, '2015-03-15 00:14:34.000000', 'consum', 0.0212, 'lps'),
	(441962, 102, '2015-03-15 00:14:35.000000', 'consum', 0.0218, 'lps'),
	(441963, 102, '2015-03-15 00:14:36.000000', 'consum', 0.0225, 'lps'),
	(441964, 102, '2015-03-15 00:14:37.000000', 'consum', 0.0225, 'lps'),
	(441965, 102, '2015-03-15 00:14:38.000000', 'consum', 0.0223, 'lps'),
	(441966, 102, '2015-03-15 00:14:39.000000', 'consum', 0.0211, 'lps'),
	(441967, 102, '2015-03-15 00:14:40.000000', 'consum', 0.0214, 'lps'),
	(441968, 102, '2015-03-15 00:14:41.000000', 'consum', 0.0227, 'lps'),
	(441969, 102, '2015-03-15 00:14:42.000000', 'consum', 0.0211, 'lps'),
	(441970, 102, '2015-03-15 00:14:43.000000', 'consum', 0.0218, 'lps'),
	(441971, 102, '2015-03-15 00:14:44.000000', 'consum', 0.0211, 'lps'),
	(441972, 102, '2015-03-15 00:14:45.000000', 'consum', 0.0211, 'lps'),
	(441973, 102, '2015-03-15 00:14:46.000000', 'consum', 0.0214, 'lps'),
	(441974, 102, '2015-03-15 00:14:47.000000', 'consum', 0.0226, 'lps'),
	(441975, 102, '2015-03-15 00:14:48.000000', 'consum', 0.0225, 'lps'),
	(441976, 102, '2015-03-15 00:14:49.000000', 'consum', 0.0221, 'lps'),
	(441977, 102, '2015-03-15 00:14:50.000000', 'consum', 0.0220, 'lps'),
	(441978, 102, '2015-03-15 00:14:51.000000', 'consum', 0.0225, 'lps'),
	(441979, 102, '2015-03-15 00:14:52.000000', 'consum', 0.0222, 'lps'),
	(441980, 102, '2015-03-15 00:14:53.000000', 'consum', 0.0225, 'lps'),
	(441981, 102, '2015-03-15 00:14:54.000000', 'consum', 0.0212, 'lps'),
	(441982, 102, '2015-03-15 00:14:55.000000', 'consum', 0.0214, 'lps'),
	(441983, 102, '2015-03-15 00:14:56.000000', 'consum', 0.0224, 'lps'),
	(441984, 102, '2015-03-15 00:14:57.000000', 'consum', 0.0212, 'lps'),
	(441985, 102, '2015-03-15 00:14:58.000000', 'consum', 0.0216, 'lps'),
	(441986, 102, '2015-03-15 00:14:59.000000', 'consum', 0.0216, 'lps'),
	(441987, 102, '2015-03-15 00:15:00.000000', 'consum', 0.0224, 'lps'),
	(441988, 102, '2015-03-15 00:15:01.000000', 'consum', 0.0224, 'lps'),
	(441989, 102, '2015-03-15 00:15:02.000000', 'consum', 0.0221, 'lps'),
	(441990, 102, '2015-03-15 00:15:03.000000', 'consum', 0.0224, 'lps'),
	(441991, 102, '2015-03-15 00:15:04.000000', 'consum', 0.0213, 'lps'),
	(441992, 102, '2015-03-15 00:15:05.000000', 'consum', 0.0217, 'lps'),
	(441993, 102, '2015-03-15 00:15:06.000000', 'consum', 0.0221, 'lps'),
	(441994, 102, '2015-03-15 00:15:07.000000', 'consum', 0.0227, 'lps'),
	(441995, 102, '2015-03-15 00:15:08.000000', 'consum', 0.0225, 'lps'),
	(441996, 102, '2015-03-15 00:15:09.000000', 'consum', 0.0215, 'lps'),
	(441997, 102, '2015-03-15 00:15:10.000000', 'consum', 0.0210, 'lps'),
	(441998, 102, '2015-03-15 00:15:11.000000', 'consum', 0.0213, 'lps'),
	(441999, 102, '2015-03-15 00:15:12.000000', 'consum', 0.0227, 'lps'),
	(442000, 102, '2015-03-15 00:15:13.000000', 'consum', 0.0215, 'lps'),
	(442001, 102, '2015-03-15 00:15:14.000000', 'consum', 0.0218, 'lps'),
	(442002, 102, '2015-03-15 00:15:15.000000', 'consum', 0.0218, 'lps'),
	(442003, 102, '2015-03-15 00:15:16.000000', 'consum', 0.0226, 'lps'),
	(442004, 102, '2015-03-15 00:15:17.000000', 'consum', 0.0213, 'lps'),
	(442005, 102, '2015-03-15 00:15:18.000000', 'consum', 0.0215, 'lps'),
	(442006, 102, '2015-03-15 00:15:19.000000', 'consum', 0.0225, 'lps'),
	(442007, 102, '2015-03-15 00:15:20.000000', 'consum', 0.0215, 'lps'),
	(442008, 102, '2015-03-15 00:15:21.000000', 'consum', 0.0211, 'lps'),
	(442009, 102, '2015-03-15 00:15:22.000000', 'consum', 0.0216, 'lps'),
	(442010, 102, '2015-03-15 00:15:23.000000', 'consum', 0.0220, 'lps'),
	(442011, 102, '2015-03-15 00:15:24.000000', 'consum', 0.0223, 'lps'),
	(442012, 102, '2015-03-15 00:15:25.000000', 'consum', 0.0212, 'lps'),
	(442013, 102, '2015-03-15 00:15:26.000000', 'consum', 0.0216, 'lps'),
	(442014, 102, '2015-03-15 00:15:27.000000', 'consum', 0.0219, 'lps'),
	(442015, 102, '2015-03-15 00:15:28.000000', 'consum', 0.0218, 'lps'),
	(442016, 102, '2015-03-15 00:15:29.000000', 'consum', 0.0224, 'lps'),
	(442017, 102, '2015-03-15 00:15:30.000000', 'consum', 0.0222, 'lps'),
	(442018, 102, '2015-03-15 00:15:31.000000', 'consum', 0.0226, 'lps'),
	(442019, 102, '2015-03-15 00:15:32.000000', 'consum', 0.0221, 'lps'),
	(442020, 102, '2015-03-15 00:15:33.000000', 'consum', 0.0215, 'lps'),
	(442021, 102, '2015-03-15 00:15:34.000000', 'consum', 0.0222, 'lps'),
	(442022, 102, '2015-03-15 00:15:35.000000', 'consum', 0.0221, 'lps'),
	(442023, 102, '2015-03-15 00:15:36.000000', 'consum', 0.0211, 'lps'),
	(442024, 102, '2015-03-15 00:15:37.000000', 'consum', 0.0218, 'lps'),
	(442025, 102, '2015-03-15 00:15:38.000000', 'consum', 0.0213, 'lps'),
	(442026, 102, '2015-03-15 00:15:39.000000', 'consum', 0.0220, 'lps'),
	(442027, 102, '2015-03-15 00:15:40.000000', 'consum', 0.0214, 'lps'),
	(442028, 102, '2015-03-15 00:15:41.000000', 'consum', 0.0221, 'lps'),
	(442029, 102, '2015-03-15 00:15:42.000000', 'consum', 0.0214, 'lps'),
	(442030, 102, '2015-03-15 00:15:43.000000', 'consum', 0.0216, 'lps'),
	(442031, 102, '2015-03-15 00:15:44.000000', 'consum', 0.0213, 'lps'),
	(442032, 102, '2015-03-15 00:15:45.000000', 'consum', 0.0224, 'lps'),
	(442033, 102, '2015-03-15 00:15:46.000000', 'consum', 0.0218, 'lps'),
	(442034, 102, '2015-03-15 00:15:47.000000', 'consum', 0.0224, 'lps'),
	(442035, 102, '2015-03-15 00:15:48.000000', 'consum', 0.0224, 'lps'),
	(442036, 102, '2015-03-15 00:15:49.000000', 'consum', 0.0219, 'lps'),
	(442037, 102, '2015-03-15 00:15:50.000000', 'consum', 0.0213, 'lps'),
	(442038, 102, '2015-03-15 00:15:51.000000', 'consum', 0.0216, 'lps'),
	(442039, 102, '2015-03-15 00:15:52.000000', 'consum', 0.0213, 'lps'),
	(442040, 102, '2015-03-15 00:15:53.000000', 'consum', 0.0226, 'lps'),
	(442041, 102, '2015-03-15 00:15:54.000000', 'consum', 0.0211, 'lps'),
	(442042, 102, '2015-03-15 00:15:55.000000', 'consum', 0.0221, 'lps'),
	(442043, 102, '2015-03-15 00:15:56.000000', 'consum', 0.0226, 'lps'),
	(442044, 102, '2015-03-15 00:15:57.000000', 'consum', 0.0220, 'lps'),
	(442045, 102, '2015-03-15 00:15:58.000000', 'consum', 0.0214, 'lps'),
	(442046, 102, '2015-03-15 00:15:59.000000', 'consum', 0.0216, 'lps'),
	(442047, 102, '2015-03-15 00:16:00.000000', 'consum', 0.0214, 'lps'),
	(442048, 102, '2015-03-15 00:16:01.000000', 'consum', 0.0212, 'lps'),
	(442049, 102, '2015-03-15 00:16:02.000000', 'consum', 0.0225, 'lps'),
	(442050, 102, '2015-03-15 00:16:03.000000', 'consum', 0.0226, 'lps'),
	(442051, 102, '2015-03-15 00:16:04.000000', 'consum', 0.0227, 'lps'),
	(442052, 102, '2015-03-15 00:16:05.000000', 'consum', 0.0214, 'lps'),
	(442053, 102, '2015-03-15 00:16:06.000000', 'consum', 0.0213, 'lps'),
	(442054, 102, '2015-03-15 00:16:07.000000', 'consum', 0.0213, 'lps'),
	(442055, 102, '2015-03-15 00:16:08.000000', 'consum', 0.0219, 'lps'),
	(442056, 102, '2015-03-15 00:16:09.000000', 'consum', 0.0227, 'lps'),
	(442057, 102, '2015-03-15 00:16:10.000000', 'consum', 0.0214, 'lps'),
	(442058, 102, '2015-03-15 00:16:11.000000', 'consum', 0.0214, 'lps'),
	(442059, 102, '2015-03-15 00:16:12.000000', 'consum', 0.0221, 'lps'),
	(442060, 102, '2015-03-15 00:16:13.000000', 'consum', 0.0218, 'lps'),
	(442061, 102, '2015-03-15 00:16:14.000000', 'consum', 0.0216, 'lps'),
	(442062, 102, '2015-03-15 00:16:15.000000', 'consum', 0.0216, 'lps'),
	(442063, 102, '2015-03-15 00:16:16.000000', 'consum', 0.0223, 'lps'),
	(442064, 102, '2015-03-15 00:16:17.000000', 'consum', 0.0223, 'lps'),
	(442065, 102, '2015-03-15 00:16:18.000000', 'consum', 0.0217, 'lps'),
	(442066, 102, '2015-03-15 00:16:19.000000', 'consum', 0.0225, 'lps'),
	(442067, 102, '2015-03-15 00:16:20.000000', 'consum', 0.0213, 'lps'),
	(442068, 102, '2015-03-15 00:16:21.000000', 'consum', 0.0213, 'lps'),
	(442069, 102, '2015-03-15 00:16:22.000000', 'consum', 0.0216, 'lps'),
	(442070, 102, '2015-03-15 00:16:23.000000', 'consum', 0.0215, 'lps'),
	(442071, 102, '2015-03-15 00:16:24.000000', 'consum', 0.0219, 'lps'),
	(442072, 102, '2015-03-15 00:16:25.000000', 'consum', 0.0222, 'lps'),
	(442073, 102, '2015-03-15 00:16:26.000000', 'consum', 0.0223, 'lps'),
	(442074, 102, '2015-03-15 00:16:27.000000', 'consum', 0.0224, 'lps'),
	(442075, 102, '2015-03-15 00:16:28.000000', 'consum', 0.0223, 'lps'),
	(442076, 102, '2015-03-15 00:16:29.000000', 'consum', 0.0217, 'lps'),
	(442077, 102, '2015-03-15 00:16:30.000000', 'consum', 0.0224, 'lps'),
	(442078, 102, '2015-03-15 00:16:31.000000', 'consum', 0.0223, 'lps'),
	(442079, 102, '2015-03-15 00:16:32.000000', 'consum', 0.0216, 'lps'),
	(442080, 102, '2015-03-15 00:16:33.000000', 'consum', 0.0219, 'lps'),
	(442081, 102, '2015-03-15 00:16:34.000000', 'consum', 0.0218, 'lps'),
	(442082, 102, '2015-03-15 00:16:35.000000', 'consum', 0.0223, 'lps'),
	(442083, 102, '2015-03-15 00:16:36.000000', 'consum', 0.0215, 'lps'),
	(442084, 102, '2015-03-15 00:16:37.000000', 'consum', 0.0216, 'lps'),
	(442085, 102, '2015-03-15 00:16:38.000000', 'consum', 0.0225, 'lps'),
	(442086, 102, '2015-03-15 00:16:39.000000', 'consum', 0.0216, 'lps'),
	(442087, 102, '2015-03-15 00:16:40.000000', 'consum', 0.0210, 'lps'),
	(442088, 102, '2015-03-15 00:16:41.000000', 'consum', 0.0214, 'lps'),
	(442089, 102, '2015-03-15 00:16:42.000000', 'consum', 0.0227, 'lps'),
	(442090, 102, '2015-03-15 00:16:43.000000', 'consum', 0.0214, 'lps'),
	(442091, 102, '2015-03-15 00:16:44.000000', 'consum', 0.0217, 'lps'),
	(442092, 102, '2015-03-15 00:16:45.000000', 'consum', 0.0213, 'lps'),
	(442093, 102, '2015-03-15 00:16:46.000000', 'consum', 0.0224, 'lps'),
	(442094, 102, '2015-03-15 00:16:47.000000', 'consum', 0.0217, 'lps'),
	(442095, 102, '2015-03-15 00:16:48.000000', 'consum', 0.0223, 'lps'),
	(442096, 102, '2015-03-15 00:16:49.000000', 'consum', 0.0218, 'lps'),
	(442097, 102, '2015-03-15 00:16:50.000000', 'consum', 0.0213, 'lps'),
	(442098, 102, '2015-03-15 00:16:51.000000', 'consum', 0.0216, 'lps'),
	(442099, 102, '2015-03-15 00:16:52.000000', 'consum', 0.0215, 'lps'),
	(442100, 102, '2015-03-15 00:16:53.000000', 'consum', 0.0218, 'lps'),
	(442101, 102, '2015-03-15 00:16:54.000000', 'consum', 0.0218, 'lps'),
	(442102, 102, '2015-03-15 00:16:55.000000', 'consum', 0.0227, 'lps'),
	(442103, 102, '2015-03-15 00:16:56.000000', 'consum', 0.0217, 'lps'),
	(442104, 102, '2015-03-15 00:16:57.000000', 'consum', 0.0213, 'lps'),
	(442105, 102, '2015-03-15 00:16:58.000000', 'consum', 0.0220, 'lps'),
	(442106, 102, '2015-03-15 00:16:59.000000', 'consum', 0.0218, 'lps'),
	(442107, 102, '2015-03-15 00:17:00.000000', 'consum', 0.0221, 'lps'),
	(442108, 102, '2015-03-15 00:17:01.000000', 'consum', 0.0221, 'lps'),
	(442109, 102, '2015-03-15 00:17:02.000000', 'consum', 0.0214, 'lps'),
	(442110, 102, '2015-03-15 00:17:03.000000', 'consum', 0.0219, 'lps'),
	(442111, 102, '2015-03-15 00:17:04.000000', 'consum', 0.0222, 'lps'),
	(442112, 102, '2015-03-15 00:17:05.000000', 'consum', 0.0227, 'lps'),
	(442113, 102, '2015-03-15 00:17:06.000000', 'consum', 0.0224, 'lps'),
	(442114, 102, '2015-03-15 00:17:07.000000', 'consum', 0.0211, 'lps'),
	(442115, 102, '2015-03-15 00:17:08.000000', 'consum', 0.0227, 'lps'),
	(442116, 102, '2015-03-15 00:17:09.000000', 'consum', 0.0221, 'lps'),
	(442117, 102, '2015-03-15 00:17:10.000000', 'consum', 0.0215, 'lps'),
	(442118, 102, '2015-03-15 00:17:11.000000', 'consum', 0.0220, 'lps'),
	(442119, 102, '2015-03-15 00:17:12.000000', 'consum', 0.0211, 'lps'),
	(442120, 102, '2015-03-15 00:17:13.000000', 'consum', 0.0220, 'lps'),
	(442121, 102, '2015-03-15 00:17:14.000000', 'consum', 0.0222, 'lps'),
	(442122, 102, '2015-03-15 00:17:15.000000', 'consum', 0.0222, 'lps'),
	(442123, 102, '2015-03-15 00:17:16.000000', 'consum', 0.0216, 'lps'),
	(442124, 102, '2015-03-15 00:17:17.000000', 'consum', 0.0224, 'lps'),
	(442125, 102, '2015-03-15 00:17:18.000000', 'consum', 0.0225, 'lps'),
	(442126, 102, '2015-03-15 00:17:19.000000', 'consum', 0.0210, 'lps'),
	(442127, 102, '2015-03-15 00:17:20.000000', 'consum', 0.0219, 'lps'),
	(442128, 102, '2015-03-15 00:17:21.000000', 'consum', 0.0218, 'lps'),
	(442129, 102, '2015-03-15 00:17:22.000000', 'consum', 0.0224, 'lps'),
	(442130, 102, '2015-03-15 00:17:23.000000', 'consum', 0.0222, 'lps'),
	(442131, 102, '2015-03-15 00:17:24.000000', 'consum', 0.0226, 'lps'),
	(442132, 102, '2015-03-15 00:17:25.000000', 'consum', 0.0221, 'lps'),
	(442133, 102, '2015-03-15 00:17:26.000000', 'consum', 0.0215, 'lps'),
	(442134, 102, '2015-03-15 00:17:27.000000', 'consum', 0.0221, 'lps'),
	(442135, 102, '2015-03-15 00:17:28.000000', 'consum', 0.0213, 'lps'),
	(442136, 102, '2015-03-15 00:17:29.000000', 'consum', 0.0211, 'lps'),
	(442137, 102, '2015-03-15 00:17:30.000000', 'consum', 0.0225, 'lps'),
	(442138, 102, '2015-03-15 00:17:31.000000', 'consum', 0.0227, 'lps'),
	(442139, 102, '2015-03-15 00:17:32.000000', 'consum', 0.0218, 'lps'),
	(442140, 102, '2015-03-15 00:17:33.000000', 'consum', 0.0215, 'lps'),
	(442141, 102, '2015-03-15 00:17:34.000000', 'consum', 0.0210, 'lps'),
	(442142, 102, '2015-03-15 00:17:35.000000', 'consum', 0.0215, 'lps'),
	(442143, 102, '2015-03-15 00:17:36.000000', 'consum', 0.0218, 'lps'),
	(442144, 102, '2015-03-15 00:17:37.000000', 'consum', 0.0218, 'lps'),
	(442145, 102, '2015-03-15 00:17:38.000000', 'consum', 0.0226, 'lps'),
	(442146, 102, '2015-03-15 00:17:39.000000', 'consum', 0.0213, 'lps'),
	(442147, 102, '2015-03-15 00:17:40.000000', 'consum', 0.0215, 'lps'),
	(442148, 102, '2015-03-15 00:17:41.000000', 'consum', 0.0223, 'lps'),
	(442149, 102, '2015-03-15 00:17:42.000000', 'consum', 0.0227, 'lps'),
	(442150, 102, '2015-03-15 00:17:43.000000', 'consum', 0.0218, 'lps'),
	(442151, 102, '2015-03-15 00:17:44.000000', 'consum', 0.0220, 'lps'),
	(442152, 102, '2015-03-15 00:17:45.000000', 'consum', 0.0217, 'lps'),
	(442153, 102, '2015-03-15 00:17:46.000000', 'consum', 0.0215, 'lps'),
	(442154, 102, '2015-03-15 00:17:47.000000', 'consum', 0.0214, 'lps'),
	(442155, 102, '2015-03-15 00:17:48.000000', 'consum', 0.0215, 'lps'),
	(442156, 102, '2015-03-15 00:17:49.000000', 'consum', 0.0225, 'lps'),
	(442157, 102, '2015-03-15 00:17:50.000000', 'consum', 0.0218, 'lps'),
	(442158, 102, '2015-03-15 00:17:51.000000', 'consum', 0.0221, 'lps'),
	(442159, 102, '2015-03-15 00:17:52.000000', 'consum', 0.0223, 'lps'),
	(442160, 102, '2015-03-15 00:17:53.000000', 'consum', 0.0225, 'lps'),
	(442161, 102, '2015-03-15 00:17:54.000000', 'consum', 0.0212, 'lps'),
	(442162, 102, '2015-03-15 00:17:55.000000', 'consum', 0.0213, 'lps'),
	(442163, 102, '2015-03-15 00:17:56.000000', 'consum', 0.0216, 'lps'),
	(442164, 102, '2015-03-15 00:17:57.000000', 'consum', 0.0214, 'lps'),
	(442165, 102, '2015-03-15 00:17:58.000000', 'consum', 0.0212, 'lps'),
	(442166, 102, '2015-03-15 00:17:59.000000', 'consum', 0.0211, 'lps'),
	(442167, 102, '2015-03-15 00:18:00.000000', 'consum', 0.0224, 'lps'),
	(442168, 102, '2015-03-15 00:18:01.000000', 'consum', 0.0227, 'lps'),
	(442169, 102, '2015-03-15 00:18:02.000000', 'consum', 0.0214, 'lps'),
	(442170, 102, '2015-03-15 00:18:03.000000', 'consum', 0.0218, 'lps'),
	(442171, 102, '2015-03-15 00:18:04.000000', 'consum', 0.0219, 'lps'),
	(442172, 102, '2015-03-15 00:18:05.000000', 'consum', 0.0215, 'lps'),
	(442173, 102, '2015-03-15 00:18:06.000000', 'consum', 0.0225, 'lps'),
	(442174, 102, '2015-03-15 00:18:07.000000', 'consum', 0.0219, 'lps'),
	(442175, 102, '2015-03-15 00:18:08.000000', 'consum', 0.0227, 'lps'),
	(442176, 102, '2015-03-15 00:18:09.000000', 'consum', 0.0216, 'lps'),
	(442177, 102, '2015-03-15 00:18:10.000000', 'consum', 0.0223, 'lps'),
	(442178, 102, '2015-03-15 00:18:11.000000', 'consum', 0.0224, 'lps'),
	(442179, 102, '2015-03-15 00:18:12.000000', 'consum', 0.0221, 'lps'),
	(442180, 102, '2015-03-15 00:18:13.000000', 'consum', 0.0226, 'lps'),
	(442181, 102, '2015-03-15 00:18:14.000000', 'consum', 0.0221, 'lps'),
	(442182, 102, '2015-03-15 00:18:15.000000', 'consum', 0.0219, 'lps'),
	(442183, 102, '2015-03-15 00:18:16.000000', 'consum', 0.0219, 'lps'),
	(442184, 102, '2015-03-15 00:18:17.000000', 'consum', 0.0212, 'lps'),
	(442185, 102, '2015-03-15 00:18:18.000000', 'consum', 0.0213, 'lps'),
	(442186, 102, '2015-03-15 00:18:19.000000', 'consum', 0.0219, 'lps'),
	(442187, 102, '2015-03-15 00:18:20.000000', 'consum', 0.0227, 'lps'),
	(442188, 102, '2015-03-15 00:18:21.000000', 'consum', 0.0217, 'lps'),
	(442189, 102, '2015-03-15 00:18:22.000000', 'consum', 0.0213, 'lps'),
	(442190, 102, '2015-03-15 00:18:23.000000', 'consum', 0.0220, 'lps'),
	(442191, 102, '2015-03-15 00:18:24.000000', 'consum', 0.0214, 'lps'),
	(442192, 102, '2015-03-15 00:18:25.000000', 'consum', 0.0222, 'lps'),
	(442193, 102, '2015-03-15 00:18:26.000000', 'consum', 0.0222, 'lps'),
	(442194, 102, '2015-03-15 00:18:27.000000', 'consum', 0.0217, 'lps'),
	(442195, 102, '2015-03-15 00:18:28.000000', 'consum', 0.0211, 'lps'),
	(442196, 102, '2015-03-15 00:18:29.000000', 'consum', 0.0227, 'lps'),
	(442197, 102, '2015-03-15 00:18:30.000000', 'consum', 0.0224, 'lps'),
	(442198, 102, '2015-03-15 00:18:31.000000', 'consum', 0.0227, 'lps'),
	(442199, 102, '2015-03-15 00:18:32.000000', 'consum', 0.0216, 'lps'),
	(442200, 102, '2015-03-15 00:18:33.000000', 'consum', 0.0210, 'lps'),
	(442201, 102, '2015-03-15 00:18:34.000000', 'consum', 0.0227, 'lps'),
	(442202, 102, '2015-03-15 00:18:35.000000', 'consum', 0.0226, 'lps'),
	(442203, 102, '2015-03-15 00:18:36.000000', 'consum', 0.0219, 'lps'),
	(442204, 102, '2015-03-15 00:18:37.000000', 'consum', 0.0224, 'lps'),
	(442205, 102, '2015-03-15 00:18:38.000000', 'consum', 0.0221, 'lps'),
	(442206, 102, '2015-03-15 00:18:39.000000', 'consum', 0.0220, 'lps'),
	(442207, 102, '2015-03-15 00:18:40.000000', 'consum', 0.0213, 'lps'),
	(442208, 102, '2015-03-15 00:18:41.000000', 'consum', 0.0212, 'lps'),
	(442209, 102, '2015-03-15 00:18:42.000000', 'consum', 0.0214, 'lps'),
	(442210, 102, '2015-03-15 00:18:43.000000', 'consum', 0.0221, 'lps'),
	(442211, 102, '2015-03-15 00:18:44.000000', 'consum', 0.0218, 'lps'),
	(442212, 102, '2015-03-15 00:18:45.000000', 'consum', 0.0217, 'lps'),
	(442213, 102, '2015-03-15 00:18:46.000000', 'consum', 0.0222, 'lps'),
	(442214, 102, '2015-03-15 00:18:47.000000', 'consum', 0.0214, 'lps'),
	(442215, 102, '2015-03-15 00:18:48.000000', 'consum', 0.0211, 'lps'),
	(442216, 102, '2015-03-15 00:18:49.000000', 'consum', 0.0222, 'lps'),
	(442217, 102, '2015-03-15 00:18:50.000000', 'consum', 0.0215, 'lps'),
	(442218, 102, '2015-03-15 00:18:51.000000', 'consum', 0.0219, 'lps'),
	(442219, 102, '2015-03-15 00:18:52.000000', 'consum', 0.0219, 'lps'),
	(442220, 102, '2015-03-15 00:18:53.000000', 'consum', 0.0211, 'lps'),
	(442221, 102, '2015-03-15 00:18:54.000000', 'consum', 0.0227, 'lps'),
	(442222, 102, '2015-03-15 00:18:55.000000', 'consum', 0.0219, 'lps'),
	(442223, 102, '2015-03-15 00:18:56.000000', 'consum', 0.0221, 'lps'),
	(442224, 102, '2015-03-15 00:18:57.000000', 'consum', 0.0220, 'lps'),
	(442225, 102, '2015-03-15 00:18:58.000000', 'consum', 0.0212, 'lps'),
	(442226, 102, '2015-03-15 00:18:59.000000', 'consum', 0.0227, 'lps'),
	(442227, 102, '2015-03-15 00:19:00.000000', 'consum', 0.0217, 'lps'),
	(442228, 102, '2015-03-15 00:19:01.000000', 'consum', 0.0213, 'lps'),
	(442229, 102, '2015-03-15 00:19:02.000000', 'consum', 0.0221, 'lps'),
	(442230, 102, '2015-03-15 00:19:03.000000', 'consum', 0.0221, 'lps'),
	(442231, 102, '2015-03-15 00:19:04.000000', 'consum', 0.0215, 'lps'),
	(442232, 102, '2015-03-15 00:19:05.000000', 'consum', 0.0218, 'lps'),
	(442233, 102, '2015-03-15 00:19:06.000000', 'consum', 0.0220, 'lps'),
	(442234, 102, '2015-03-15 00:19:07.000000', 'consum', 0.0218, 'lps'),
	(442235, 102, '2015-03-15 00:19:08.000000', 'consum', 0.0222, 'lps'),
	(442236, 102, '2015-03-15 00:19:09.000000', 'consum', 0.0210, 'lps'),
	(442237, 102, '2015-03-15 00:19:10.000000', 'consum', 0.0226, 'lps'),
	(442238, 102, '2015-03-15 00:19:11.000000', 'consum', 0.0220, 'lps'),
	(442239, 102, '2015-03-15 00:19:12.000000', 'consum', 0.0212, 'lps'),
	(442240, 102, '2015-03-15 00:19:13.000000', 'consum', 0.0226, 'lps'),
	(442241, 102, '2015-03-15 00:19:14.000000', 'consum', 0.0212, 'lps'),
	(442242, 102, '2015-03-15 00:19:15.000000', 'consum', 0.0211, 'lps'),
	(442243, 102, '2015-03-15 00:19:16.000000', 'consum', 0.0226, 'lps'),
	(442244, 102, '2015-03-15 00:19:17.000000', 'consum', 0.0215, 'lps'),
	(442245, 102, '2015-03-15 00:19:18.000000', 'consum', 0.0225, 'lps'),
	(442246, 102, '2015-03-15 00:19:19.000000', 'consum', 0.0215, 'lps'),
	(442247, 102, '2015-03-15 00:19:20.000000', 'consum', 0.0225, 'lps'),
	(442248, 102, '2015-03-15 00:19:21.000000', 'consum', 0.0218, 'lps'),
	(442249, 102, '2015-03-15 00:19:22.000000', 'consum', 0.0224, 'lps'),
	(442250, 102, '2015-03-15 00:19:23.000000', 'consum', 0.0221, 'lps'),
	(442251, 102, '2015-03-15 00:19:24.000000', 'consum', 0.0223, 'lps'),
	(442252, 102, '2015-03-15 00:19:25.000000', 'consum', 0.0226, 'lps'),
	(442253, 102, '2015-03-15 00:19:26.000000', 'consum', 0.0213, 'lps'),
	(442254, 102, '2015-03-15 00:19:27.000000', 'consum', 0.0213, 'lps'),
	(442255, 102, '2015-03-15 00:19:28.000000', 'consum', 0.0216, 'lps'),
	(442256, 102, '2015-03-15 00:19:29.000000', 'consum', 0.0216, 'lps'),
	(442257, 102, '2015-03-15 00:19:30.000000', 'consum', 0.0221, 'lps'),
	(442258, 102, '2015-03-15 00:19:31.000000', 'consum', 0.0211, 'lps'),
	(442259, 102, '2015-03-15 00:19:32.000000', 'consum', 0.0220, 'lps'),
	(442260, 102, '2015-03-15 00:19:33.000000', 'consum', 0.0223, 'lps'),
	(442261, 102, '2015-03-15 00:19:34.000000', 'consum', 0.0225, 'lps'),
	(442262, 102, '2015-03-15 00:19:35.000000', 'consum', 0.0213, 'lps'),
	(442263, 102, '2015-03-15 00:19:36.000000', 'consum', 0.0215, 'lps'),
	(442264, 102, '2015-03-15 00:19:37.000000', 'consum', 0.0211, 'lps'),
	(442265, 102, '2015-03-15 00:19:38.000000', 'consum', 0.0215, 'lps'),
	(442266, 102, '2015-03-15 00:19:39.000000', 'consum', 0.0218, 'lps'),
	(442267, 102, '2015-03-15 00:19:40.000000', 'consum', 0.0214, 'lps'),
	(442268, 102, '2015-03-15 00:19:41.000000', 'consum', 0.0227, 'lps'),
	(442269, 102, '2015-03-15 00:19:42.000000', 'consum', 0.0212, 'lps'),
	(442270, 102, '2015-03-15 00:19:43.000000', 'consum', 0.0221, 'lps'),
	(442271, 102, '2015-03-15 00:19:44.000000', 'consum', 0.0226, 'lps'),
	(442272, 102, '2015-03-15 00:19:45.000000', 'consum', 0.0220, 'lps'),
	(442273, 102, '2015-03-15 00:19:46.000000', 'consum', 0.0214, 'lps'),
	(442274, 102, '2015-03-15 00:19:47.000000', 'consum', 0.0217, 'lps'),
	(442275, 102, '2015-03-15 00:19:48.000000', 'consum', 0.0215, 'lps'),
	(442276, 102, '2015-03-15 00:19:49.000000', 'consum', 0.0216, 'lps'),
	(442277, 102, '2015-03-15 00:19:50.000000', 'consum', 0.0226, 'lps'),
	(442278, 102, '2015-03-15 00:19:51.000000', 'consum', 0.0216, 'lps'),
	(442279, 102, '2015-03-15 00:19:52.000000', 'consum', 0.0212, 'lps'),
	(442280, 102, '2015-03-15 00:19:53.000000', 'consum', 0.0219, 'lps'),
	(442281, 102, '2015-03-15 00:19:54.000000', 'consum', 0.0214, 'lps'),
	(442282, 102, '2015-03-15 00:19:55.000000', 'consum', 0.0224, 'lps'),
	(442283, 102, '2015-03-15 00:19:56.000000', 'consum', 0.0211, 'lps'),
	(442284, 102, '2015-03-15 00:19:57.000000', 'consum', 0.0212, 'lps'),
	(442285, 102, '2015-03-15 00:19:58.000000', 'consum', 0.0216, 'lps'),
	(442286, 102, '2015-03-15 00:19:59.000000', 'consum', 0.0216, 'lps'),
	(442287, 102, '2015-03-15 00:20:00.000000', 'consum', 0.0222, 'lps'),
	(442288, 102, '2015-03-15 00:20:01.000000', 'consum', 0.0217, 'lps'),
	(442289, 102, '2015-03-15 00:20:02.000000', 'consum', 0.0211, 'lps'),
	(442290, 102, '2015-03-15 00:20:03.000000', 'consum', 0.0212, 'lps'),
	(442291, 102, '2015-03-15 00:20:04.000000', 'consum', 0.0215, 'lps'),
	(442292, 102, '2015-03-15 00:20:05.000000', 'consum', 0.0213, 'lps'),
	(442293, 102, '2015-03-15 00:20:06.000000', 'consum', 0.0212, 'lps'),
	(442294, 102, '2015-03-15 00:20:07.000000', 'consum', 0.0212, 'lps'),
	(442295, 102, '2015-03-15 00:20:08.000000', 'consum', 0.0213, 'lps'),
	(442296, 102, '2015-03-15 00:20:09.000000', 'consum', 0.0218, 'lps'),
	(442297, 102, '2015-03-15 00:20:10.000000', 'consum', 0.0226, 'lps'),
	(442298, 102, '2015-03-15 00:20:11.000000', 'consum', 0.0212, 'lps'),
	(442299, 102, '2015-03-15 00:20:12.000000', 'consum', 0.0226, 'lps'),
	(442300, 102, '2015-03-15 00:20:13.000000', 'consum', 0.0214, 'lps'),
	(442301, 102, '2015-03-15 00:20:14.000000', 'consum', 0.0219, 'lps'),
	(442302, 102, '2015-03-15 00:20:15.000000', 'consum', 0.0223, 'lps'),
	(442303, 102, '2015-03-15 00:20:16.000000', 'consum', 0.0212, 'lps'),
	(442304, 102, '2015-03-15 00:20:17.000000', 'consum', 0.0219, 'lps'),
	(442305, 102, '2015-03-15 00:20:18.000000', 'consum', 0.0212, 'lps'),
	(442306, 102, '2015-03-15 00:20:19.000000', 'consum', 0.0212, 'lps'),
	(442307, 102, '2015-03-15 00:20:20.000000', 'consum', 0.0213, 'lps'),
	(442308, 102, '2015-03-15 00:20:21.000000', 'consum', 0.0220, 'lps'),
	(442309, 102, '2015-03-15 00:20:22.000000', 'consum', 0.0215, 'lps'),
	(442310, 102, '2015-03-15 00:20:23.000000', 'consum', 0.0226, 'lps'),
	(442311, 102, '2015-03-15 00:20:24.000000', 'consum', 0.0220, 'lps'),
	(442312, 102, '2015-03-15 00:20:25.000000', 'consum', 0.0215, 'lps'),
	(442313, 102, '2015-03-15 00:20:26.000000', 'consum', 0.0221, 'lps'),
	(442314, 102, '2015-03-15 00:20:27.000000', 'consum', 0.0213, 'lps'),
	(442315, 102, '2015-03-15 00:20:28.000000', 'consum', 0.0214, 'lps'),
	(442316, 102, '2015-03-15 00:20:29.000000', 'consum', 0.0219, 'lps'),
	(442317, 102, '2015-03-15 00:20:30.000000', 'consum', 0.0210, 'lps'),
	(442318, 102, '2015-03-15 00:20:31.000000', 'consum', 0.0217, 'lps'),
	(442319, 102, '2015-03-15 00:20:32.000000', 'consum', 0.0212, 'lps'),
	(442320, 102, '2015-03-15 00:20:33.000000', 'consum', 0.0215, 'lps'),
	(442321, 102, '2015-03-15 00:20:34.000000', 'consum', 0.0213, 'lps'),
	(442322, 102, '2015-03-15 00:20:35.000000', 'consum', 0.0212, 'lps'),
	(442323, 102, '2015-03-15 00:20:36.000000', 'consum', 0.0211, 'lps'),
	(442324, 102, '2015-03-15 00:20:37.000000', 'consum', 0.0227, 'lps'),
	(442325, 102, '2015-03-15 00:20:38.000000', 'consum', 0.0220, 'lps'),
	(442326, 102, '2015-03-15 00:20:39.000000', 'consum', 0.0210, 'lps'),
	(442327, 102, '2015-03-15 00:20:40.000000', 'consum', 0.0216, 'lps'),
	(442328, 102, '2015-03-15 00:20:41.000000', 'consum', 0.0221, 'lps'),
	(442329, 102, '2015-03-15 00:20:42.000000', 'consum', 0.0213, 'lps'),
	(442330, 102, '2015-03-15 00:20:43.000000', 'consum', 0.0227, 'lps'),
	(442331, 102, '2015-03-15 00:20:44.000000', 'consum', 0.0217, 'lps'),
	(442332, 102, '2015-03-15 00:20:45.000000', 'consum', 0.0211, 'lps'),
	(442333, 102, '2015-03-15 00:20:46.000000', 'consum', 0.0211, 'lps'),
	(442334, 102, '2015-03-15 00:20:47.000000', 'consum', 0.0214, 'lps'),
	(442335, 102, '2015-03-15 00:20:48.000000', 'consum', 0.0227, 'lps'),
	(442336, 102, '2015-03-15 00:20:49.000000', 'consum', 0.0210, 'lps'),
	(442337, 102, '2015-03-15 00:20:50.000000', 'consum', 0.0213, 'lps'),
	(442338, 102, '2015-03-15 00:20:51.000000', 'consum', 0.0226, 'lps'),
	(442339, 102, '2015-03-15 00:20:52.000000', 'consum', 0.0210, 'lps'),
	(442340, 102, '2015-03-15 00:20:53.000000', 'consum', 0.0218, 'lps'),
	(442341, 102, '2015-03-15 00:20:54.000000', 'consum', 0.0212, 'lps'),
	(442342, 102, '2015-03-15 00:20:55.000000', 'consum', 0.0214, 'lps'),
	(442343, 102, '2015-03-15 00:20:56.000000', 'consum', 0.0225, 'lps'),
	(442344, 102, '2015-03-15 00:20:57.000000', 'consum', 0.0221, 'lps'),
	(442345, 102, '2015-03-15 00:20:58.000000', 'consum', 0.0218, 'lps'),
	(442346, 102, '2015-03-15 00:20:59.000000', 'consum', 0.0217, 'lps'),
	(442347, 102, '2015-03-15 00:21:00.000000', 'consum', 0.0224, 'lps'),
	(442348, 102, '2015-03-15 00:21:01.000000', 'consum', 0.0221, 'lps'),
	(442349, 102, '2015-03-15 00:21:02.000000', 'consum', 0.0224, 'lps'),
	(442350, 102, '2015-03-15 00:21:03.000000', 'consum', 0.0213, 'lps'),
	(442351, 102, '2015-03-15 00:21:04.000000', 'consum', 0.0218, 'lps'),
	(442352, 102, '2015-03-15 00:21:05.000000', 'consum', 0.0225, 'lps'),
	(442353, 102, '2015-03-15 00:21:06.000000', 'consum', 0.0223, 'lps'),
	(442354, 102, '2015-03-15 00:21:07.000000', 'consum', 0.0213, 'lps'),
	(442355, 102, '2015-03-15 00:21:08.000000', 'consum', 0.0223, 'lps'),
	(442356, 102, '2015-03-15 00:21:09.000000', 'consum', 0.0210, 'lps'),
	(442357, 102, '2015-03-15 00:21:10.000000', 'consum', 0.0211, 'lps'),
	(442358, 102, '2015-03-15 00:21:11.000000', 'consum', 0.0216, 'lps'),
	(442359, 102, '2015-03-15 00:21:12.000000', 'consum', 0.0218, 'lps'),
	(442360, 102, '2015-03-15 00:21:13.000000', 'consum', 0.0215, 'lps'),
	(442361, 102, '2015-03-15 00:21:14.000000', 'consum', 0.0210, 'lps'),
	(442362, 102, '2015-03-15 00:21:15.000000', 'consum', 0.0215, 'lps'),
	(442363, 102, '2015-03-15 00:21:16.000000', 'consum', 0.0216, 'lps'),
	(442364, 102, '2015-03-15 00:21:17.000000', 'consum', 0.0224, 'lps'),
	(442365, 102, '2015-03-15 00:21:18.000000', 'consum', 0.0211, 'lps'),
	(442366, 102, '2015-03-15 00:21:19.000000', 'consum', 0.0225, 'lps'),
	(442367, 102, '2015-03-15 00:21:20.000000', 'consum', 0.0212, 'lps'),
	(442368, 102, '2015-03-15 00:21:21.000000', 'consum', 0.0213, 'lps'),
	(442369, 102, '2015-03-15 00:21:22.000000', 'consum', 0.0220, 'lps'),
	(442370, 102, '2015-03-15 00:21:23.000000', 'consum', 0.0216, 'lps'),
	(442371, 102, '2015-03-15 00:21:24.000000', 'consum', 0.0210, 'lps'),
	(442372, 102, '2015-03-15 00:21:25.000000', 'consum', 0.0210, 'lps'),
	(442373, 102, '2015-03-15 00:21:26.000000', 'consum', 0.0210, 'lps'),
	(442374, 102, '2015-03-15 00:21:27.000000', 'consum', 0.0213, 'lps'),
	(442375, 102, '2015-03-15 00:21:28.000000', 'consum', 0.0223, 'lps'),
	(442376, 102, '2015-03-15 00:21:29.000000', 'consum', 0.0215, 'lps'),
	(442377, 102, '2015-03-15 00:21:30.000000', 'consum', 0.0214, 'lps'),
	(442378, 102, '2015-03-15 00:21:31.000000', 'consum', 0.0215, 'lps'),
	(442379, 102, '2015-03-15 00:21:32.000000', 'consum', 0.0224, 'lps'),
	(442380, 102, '2015-03-15 00:21:33.000000', 'consum', 0.0210, 'lps'),
	(442381, 102, '2015-03-15 00:21:34.000000', 'consum', 0.0224, 'lps'),
	(442382, 102, '2015-03-15 00:21:35.000000', 'consum', 0.0224, 'lps'),
	(442383, 102, '2015-03-15 00:21:36.000000', 'consum', 0.0222, 'lps'),
	(442384, 102, '2015-03-15 00:21:37.000000', 'consum', 0.0210, 'lps'),
	(442385, 102, '2015-03-15 00:21:38.000000', 'consum', 0.0211, 'lps'),
	(442386, 102, '2015-03-15 00:21:39.000000', 'consum', 0.0215, 'lps'),
	(442387, 102, '2015-03-15 00:21:40.000000', 'consum', 0.0216, 'lps'),
	(442388, 102, '2015-03-15 00:21:41.000000', 'consum', 0.0224, 'lps'),
	(442389, 102, '2015-03-15 00:21:42.000000', 'consum', 0.0226, 'lps'),
	(442390, 102, '2015-03-15 00:21:43.000000', 'consum', 0.0211, 'lps'),
	(442391, 102, '2015-03-15 00:21:44.000000', 'consum', 0.0225, 'lps'),
	(442392, 102, '2015-03-15 00:21:45.000000', 'consum', 0.0226, 'lps'),
	(442393, 102, '2015-03-15 00:21:46.000000', 'consum', 0.0212, 'lps'),
	(442394, 102, '2015-03-15 00:21:47.000000', 'consum', 0.0226, 'lps'),
	(442395, 102, '2015-03-15 00:21:48.000000', 'consum', 0.0213, 'lps'),
	(442396, 102, '2015-03-15 00:21:49.000000', 'consum', 0.0214, 'lps'),
	(442397, 102, '2015-03-15 00:21:50.000000', 'consum', 0.0221, 'lps'),
	(442398, 102, '2015-03-15 00:21:51.000000', 'consum', 0.0217, 'lps'),
	(442399, 102, '2015-03-15 00:21:52.000000', 'consum', 0.0212, 'lps'),
	(442400, 102, '2015-03-15 00:21:53.000000', 'consum', 0.0216, 'lps'),
	(442401, 102, '2015-03-15 00:21:54.000000', 'consum', 0.0219, 'lps'),
	(442402, 102, '2015-03-15 00:21:55.000000', 'consum', 0.0220, 'lps'),
	(442403, 102, '2015-03-15 00:21:56.000000', 'consum', 0.0216, 'lps'),
	(442404, 102, '2015-03-15 00:21:57.000000', 'consum', 0.0227, 'lps'),
	(442405, 102, '2015-03-15 00:21:58.000000', 'consum', 0.0222, 'lps'),
	(442406, 102, '2015-03-15 00:21:59.000000', 'consum', 0.0223, 'lps'),
	(442407, 102, '2015-03-15 00:22:00.000000', 'consum', 0.0219, 'lps'),
	(442408, 102, '2015-03-15 00:22:01.000000', 'consum', 0.0218, 'lps'),
	(442409, 102, '2015-03-15 00:22:02.000000', 'consum', 0.0225, 'lps'),
	(442410, 102, '2015-03-15 00:22:03.000000', 'consum', 0.0223, 'lps'),
	(442411, 102, '2015-03-15 00:22:04.000000', 'consum', 0.0215, 'lps'),
	(442412, 102, '2015-03-15 00:22:05.000000', 'consum', 0.0212, 'lps'),
	(442413, 102, '2015-03-15 00:22:06.000000', 'consum', 0.0223, 'lps'),
	(442414, 102, '2015-03-15 00:22:07.000000', 'consum', 0.0217, 'lps'),
	(442415, 102, '2015-03-15 00:22:08.000000', 'consum', 0.0224, 'lps'),
	(442416, 102, '2015-03-15 00:22:09.000000', 'consum', 0.0222, 'lps'),
	(442417, 102, '2015-03-15 00:22:10.000000', 'consum', 0.0213, 'lps'),
	(442418, 102, '2015-03-15 00:22:11.000000', 'consum', 0.0223, 'lps'),
	(442419, 102, '2015-03-15 00:22:12.000000', 'consum', 0.0212, 'lps'),
	(442420, 102, '2015-03-15 00:22:13.000000', 'consum', 0.0218, 'lps'),
	(442421, 102, '2015-03-15 00:22:14.000000', 'consum', 0.0225, 'lps'),
	(442422, 102, '2015-03-15 00:22:15.000000', 'consum', 0.0210, 'lps'),
	(442423, 102, '2015-03-15 00:22:16.000000', 'consum', 0.0219, 'lps'),
	(442424, 102, '2015-03-15 00:22:17.000000', 'consum', 0.0219, 'lps'),
	(442425, 102, '2015-03-15 00:22:18.000000', 'consum', 0.0211, 'lps'),
	(442426, 102, '2015-03-15 00:22:19.000000', 'consum', 0.0226, 'lps'),
	(442427, 102, '2015-03-15 00:22:20.000000', 'consum', 0.0212, 'lps'),
	(442428, 102, '2015-03-15 00:22:21.000000', 'consum', 0.0212, 'lps'),
	(442429, 102, '2015-03-15 00:22:22.000000', 'consum', 0.0211, 'lps'),
	(442430, 102, '2015-03-15 00:22:23.000000', 'consum', 0.0212, 'lps'),
	(442431, 102, '2015-03-15 00:22:24.000000', 'consum', 0.0217, 'lps'),
	(442432, 102, '2015-03-15 00:22:25.000000', 'consum', 0.0220, 'lps'),
	(442433, 102, '2015-03-15 00:22:26.000000', 'consum', 0.0223, 'lps'),
	(442434, 102, '2015-03-15 00:22:27.000000', 'consum', 0.0210, 'lps'),
	(442435, 102, '2015-03-15 00:22:28.000000', 'consum', 0.0224, 'lps'),
	(442436, 102, '2015-03-15 00:22:29.000000', 'consum', 0.0226, 'lps'),
	(442437, 102, '2015-03-15 00:22:30.000000', 'consum', 0.0212, 'lps'),
	(442438, 102, '2015-03-15 00:22:31.000000', 'consum', 0.0211, 'lps'),
	(442439, 102, '2015-03-15 00:22:32.000000', 'consum', 0.0226, 'lps'),
	(442440, 102, '2015-03-15 00:22:33.000000', 'consum', 0.0215, 'lps'),
	(442441, 102, '2015-03-15 00:22:34.000000', 'consum', 0.0223, 'lps'),
	(442442, 102, '2015-03-15 00:22:35.000000', 'consum', 0.0224, 'lps'),
	(442443, 102, '2015-03-15 00:22:36.000000', 'consum', 0.0223, 'lps'),
	(442444, 102, '2015-03-15 00:22:37.000000', 'consum', 0.0217, 'lps'),
	(442445, 102, '2015-03-15 00:22:38.000000', 'consum', 0.0222, 'lps'),
	(442446, 102, '2015-03-15 00:22:39.000000', 'consum', 0.0216, 'lps'),
	(442447, 102, '2015-03-15 00:22:40.000000', 'consum', 0.0223, 'lps'),
	(442448, 102, '2015-03-15 00:22:41.000000', 'consum', 0.0220, 'lps'),
	(442449, 102, '2015-03-15 00:22:42.000000', 'consum', 0.0221, 'lps'),
	(442450, 102, '2015-03-15 00:22:43.000000', 'consum', 0.0219, 'lps'),
	(442451, 102, '2015-03-15 00:22:44.000000', 'consum', 0.0223, 'lps'),
	(442452, 102, '2015-03-15 00:22:45.000000', 'consum', 0.0210, 'lps'),
	(442453, 102, '2015-03-15 00:22:46.000000', 'consum', 0.0226, 'lps'),
	(442454, 102, '2015-03-15 00:22:47.000000', 'consum', 0.0218, 'lps'),
	(442455, 102, '2015-03-15 00:22:48.000000', 'consum', 0.0222, 'lps'),
	(442456, 102, '2015-03-15 00:22:49.000000', 'consum', 0.0227, 'lps'),
	(442457, 102, '2015-03-15 00:22:50.000000', 'consum', 0.0225, 'lps'),
	(442458, 102, '2015-03-15 00:22:51.000000', 'consum', 0.0218, 'lps'),
	(442459, 102, '2015-03-15 00:22:52.000000', 'consum', 0.0221, 'lps'),
	(442460, 102, '2015-03-15 00:22:53.000000', 'consum', 0.0226, 'lps'),
	(442461, 102, '2015-03-15 00:22:54.000000', 'consum', 0.0220, 'lps'),
	(442462, 102, '2015-03-15 00:22:55.000000', 'consum', 0.0213, 'lps'),
	(442463, 102, '2015-03-15 00:22:56.000000', 'consum', 0.0215, 'lps'),
	(442464, 102, '2015-03-15 00:22:57.000000', 'consum', 0.0225, 'lps'),
	(442465, 102, '2015-03-15 00:22:58.000000', 'consum', 0.0215, 'lps'),
	(442466, 102, '2015-03-15 00:22:59.000000', 'consum', 0.0212, 'lps'),
	(442467, 102, '2015-03-15 00:23:00.000000', 'consum', 0.0221, 'lps'),
	(442468, 102, '2015-03-15 00:23:01.000000', 'consum', 0.0224, 'lps'),
	(442469, 102, '2015-03-15 00:23:02.000000', 'consum', 0.0210, 'lps'),
	(442470, 102, '2015-03-15 00:23:03.000000', 'consum', 0.0224, 'lps'),
	(442471, 102, '2015-03-15 00:23:04.000000', 'consum', 0.0226, 'lps'),
	(442472, 102, '2015-03-15 00:23:05.000000', 'consum', 0.0213, 'lps'),
	(442473, 102, '2015-03-15 00:23:06.000000', 'consum', 0.0213, 'lps'),
	(442474, 102, '2015-03-15 00:23:07.000000', 'consum', 0.0218, 'lps'),
	(442475, 102, '2015-03-15 00:23:08.000000', 'consum', 0.0225, 'lps'),
	(442476, 102, '2015-03-15 00:23:09.000000', 'consum', 0.0222, 'lps'),
	(442477, 102, '2015-03-15 00:23:10.000000', 'consum', 0.0226, 'lps'),
	(442478, 102, '2015-03-15 00:23:11.000000', 'consum', 0.0221, 'lps'),
	(442479, 102, '2015-03-15 00:23:12.000000', 'consum', 0.0214, 'lps'),
	(442480, 102, '2015-03-15 00:23:13.000000', 'consum', 0.0219, 'lps'),
	(442481, 102, '2015-03-15 00:23:14.000000', 'consum', 0.0224, 'lps'),
	(442482, 102, '2015-03-15 00:23:15.000000', 'consum', 0.0219, 'lps'),
	(442483, 102, '2015-03-15 00:23:16.000000', 'consum', 0.0214, 'lps'),
	(442484, 102, '2015-03-15 00:23:17.000000', 'consum', 0.0222, 'lps'),
	(442485, 102, '2015-03-15 00:23:18.000000', 'consum', 0.0221, 'lps'),
	(442486, 102, '2015-03-15 00:23:19.000000', 'consum', 0.0211, 'lps'),
	(442487, 102, '2015-03-15 00:23:20.000000', 'consum', 0.0219, 'lps'),
	(442488, 102, '2015-03-15 00:23:21.000000', 'consum', 0.0218, 'lps'),
	(442489, 102, '2015-03-15 00:23:22.000000', 'consum', 0.0223, 'lps'),
	(442490, 102, '2015-03-15 00:23:23.000000', 'consum', 0.0217, 'lps'),
	(442491, 102, '2015-03-15 00:23:24.000000', 'consum', 0.0222, 'lps'),
	(442492, 102, '2015-03-15 00:23:25.000000', 'consum', 0.0215, 'lps'),
	(442493, 102, '2015-03-15 00:23:26.000000', 'consum', 0.0215, 'lps'),
	(442494, 102, '2015-03-15 00:23:27.000000', 'consum', 0.0224, 'lps'),
	(442495, 102, '2015-03-15 00:23:28.000000', 'consum', 0.0227, 'lps'),
	(442496, 102, '2015-03-15 00:23:29.000000', 'consum', 0.0219, 'lps'),
	(442497, 102, '2015-03-15 00:23:30.000000', 'consum', 0.0222, 'lps'),
	(442498, 102, '2015-03-15 00:23:31.000000', 'consum', 0.0224, 'lps'),
	(442499, 102, '2015-03-15 00:23:32.000000', 'consum', 0.0211, 'lps'),
	(442500, 102, '2015-03-15 00:23:33.000000', 'consum', 0.0226, 'lps'),
	(442501, 102, '2015-03-15 00:23:34.000000', 'consum', 0.0216, 'lps'),
	(442502, 102, '2015-03-15 00:23:35.000000', 'consum', 0.0212, 'lps'),
	(442503, 102, '2015-03-15 00:23:36.000000', 'consum', 0.0218, 'lps'),
	(442504, 102, '2015-03-15 00:23:37.000000', 'consum', 0.0211, 'lps'),
	(442505, 102, '2015-03-15 00:23:38.000000', 'consum', 0.0225, 'lps'),
	(442506, 102, '2015-03-15 00:23:39.000000', 'consum', 0.0214, 'lps'),
	(442507, 102, '2015-03-15 00:23:40.000000', 'consum', 0.0218, 'lps'),
	(442508, 102, '2015-03-15 00:23:41.000000', 'consum', 0.0221, 'lps'),
	(442509, 102, '2015-03-15 00:23:42.000000', 'consum', 0.0226, 'lps'),
	(442510, 102, '2015-03-15 00:23:43.000000', 'consum', 0.0219, 'lps'),
	(442511, 102, '2015-03-15 00:23:44.000000', 'consum', 0.0227, 'lps'),
	(442512, 102, '2015-03-15 00:23:45.000000', 'consum', 0.0215, 'lps'),
	(442513, 102, '2015-03-15 00:23:46.000000', 'consum', 0.0218, 'lps'),
	(442514, 102, '2015-03-15 00:23:47.000000', 'consum', 0.0219, 'lps'),
	(442515, 102, '2015-03-15 00:23:48.000000', 'consum', 0.0215, 'lps'),
	(442516, 102, '2015-03-15 00:23:49.000000', 'consum', 0.0226, 'lps'),
	(442517, 102, '2015-03-15 00:23:50.000000', 'consum', 0.0222, 'lps'),
	(442518, 102, '2015-03-15 00:23:51.000000', 'consum', 0.0223, 'lps'),
	(442519, 102, '2015-03-15 00:23:52.000000', 'consum', 0.0220, 'lps'),
	(442520, 102, '2015-03-15 00:23:53.000000', 'consum', 0.0222, 'lps'),
	(442521, 102, '2015-03-15 00:23:54.000000', 'consum', 0.0224, 'lps'),
	(442522, 102, '2015-03-15 00:23:55.000000', 'consum', 0.0224, 'lps'),
	(442523, 102, '2015-03-15 00:23:56.000000', 'consum', 0.0222, 'lps'),
	(442524, 102, '2015-03-15 00:23:57.000000', 'consum', 0.0227, 'lps'),
	(442525, 102, '2015-03-15 00:23:58.000000', 'consum', 0.0223, 'lps'),
	(442526, 102, '2015-03-15 00:23:59.000000', 'consum', 0.0226, 'lps'),
	(442527, 102, '2015-03-15 00:24:00.000000', 'consum', 0.0215, 'lps'),
	(442528, 102, '2015-03-15 00:24:01.000000', 'consum', 0.0222, 'lps'),
	(442529, 102, '2015-03-15 00:24:02.000000', 'consum', 0.0220, 'lps'),
	(442530, 102, '2015-03-15 00:24:03.000000', 'consum', 0.0224, 'lps'),
	(442531, 102, '2015-03-15 00:24:04.000000', 'consum', 0.0214, 'lps'),
	(442532, 102, '2015-03-15 00:24:05.000000', 'consum', 0.0226, 'lps'),
	(442533, 102, '2015-03-15 00:24:06.000000', 'consum', 0.0225, 'lps'),
	(442534, 102, '2015-03-15 00:24:07.000000', 'consum', 0.0217, 'lps'),
	(442535, 102, '2015-03-15 00:24:08.000000', 'consum', 0.0219, 'lps'),
	(442536, 102, '2015-03-15 00:24:09.000000', 'consum', 0.0218, 'lps'),
	(442537, 102, '2015-03-15 00:24:10.000000', 'consum', 0.0224, 'lps'),
	(442538, 102, '2015-03-15 00:24:11.000000', 'consum', 0.0221, 'lps'),
	(442539, 102, '2015-03-15 00:24:12.000000', 'consum', 0.0222, 'lps'),
	(442540, 102, '2015-03-15 00:24:13.000000', 'consum', 0.0221, 'lps'),
	(442541, 102, '2015-03-15 00:24:14.000000', 'consum', 0.0212, 'lps'),
	(442542, 102, '2015-03-15 00:24:15.000000', 'consum', 0.0221, 'lps'),
	(442543, 102, '2015-03-15 00:24:16.000000', 'consum', 0.0223, 'lps'),
	(442544, 102, '2015-03-15 00:24:17.000000', 'consum', 0.0225, 'lps'),
	(442545, 102, '2015-03-15 00:24:18.000000', 'consum', 0.0211, 'lps'),
	(442546, 102, '2015-03-15 00:24:19.000000', 'consum', 0.0226, 'lps'),
	(442547, 102, '2015-03-15 00:24:20.000000', 'consum', 0.0214, 'lps'),
	(442548, 102, '2015-03-15 00:24:21.000000', 'consum', 0.0220, 'lps'),
	(442549, 102, '2015-03-15 00:24:22.000000', 'consum', 0.0213, 'lps'),
	(442550, 102, '2015-03-15 00:24:23.000000', 'consum', 0.0211, 'lps'),
	(442551, 102, '2015-03-15 00:24:24.000000', 'consum', 0.0226, 'lps'),
	(442552, 102, '2015-03-15 00:24:25.000000', 'consum', 0.0214, 'lps'),
	(442553, 102, '2015-03-15 00:24:26.000000', 'consum', 0.0217, 'lps'),
	(442554, 102, '2015-03-15 00:24:27.000000', 'consum', 0.0218, 'lps'),
	(442555, 102, '2015-03-15 00:24:28.000000', 'consum', 0.0211, 'lps'),
	(442556, 102, '2015-03-15 00:24:29.000000', 'consum', 0.0227, 'lps'),
	(442557, 102, '2015-03-15 00:24:30.000000', 'consum', 0.0221, 'lps'),
	(442558, 102, '2015-03-15 00:24:31.000000', 'consum', 0.0216, 'lps'),
	(442559, 102, '2015-03-15 00:24:32.000000', 'consum', 0.0226, 'lps'),
	(442560, 102, '2015-03-15 00:24:33.000000', 'consum', 0.0216, 'lps'),
	(442561, 102, '2015-03-15 00:24:34.000000', 'consum', 0.0210, 'lps'),
	(442562, 102, '2015-03-15 00:24:35.000000', 'consum', 0.0210, 'lps'),
	(442563, 102, '2015-03-15 00:24:36.000000', 'consum', 0.0213, 'lps'),
	(442564, 102, '2015-03-15 00:24:37.000000', 'consum', 0.0224, 'lps'),
	(442565, 102, '2015-03-15 00:24:38.000000', 'consum', 0.0219, 'lps'),
	(442566, 102, '2015-03-15 00:24:39.000000', 'consum', 0.0213, 'lps'),
	(442567, 102, '2015-03-15 00:24:40.000000', 'consum', 0.0215, 'lps'),
	(442568, 102, '2015-03-15 00:24:41.000000', 'consum', 0.0226, 'lps'),
	(442569, 102, '2015-03-15 00:24:42.000000', 'consum', 0.0222, 'lps'),
	(442570, 102, '2015-03-15 00:24:43.000000', 'consum', 0.0223, 'lps'),
	(442571, 102, '2015-03-15 00:24:44.000000', 'consum', 0.0221, 'lps'),
	(442572, 102, '2015-03-15 00:24:45.000000', 'consum', 0.0210, 'lps'),
	(442573, 102, '2015-03-15 00:24:46.000000', 'consum', 0.0213, 'lps'),
	(442574, 102, '2015-03-15 00:24:47.000000', 'consum', 0.0224, 'lps'),
	(442575, 102, '2015-03-15 00:24:48.000000', 'consum', 0.0219, 'lps'),
	(442576, 102, '2015-03-15 00:24:49.000000', 'consum', 0.0214, 'lps'),
	(442577, 102, '2015-03-15 00:24:50.000000', 'consum', 0.0220, 'lps'),
	(442578, 102, '2015-03-15 00:24:51.000000', 'consum', 0.0213, 'lps'),
	(442579, 102, '2015-03-15 00:24:52.000000', 'consum', 0.0215, 'lps'),
	(442580, 102, '2015-03-15 00:24:53.000000', 'consum', 0.0224, 'lps'),
	(442581, 102, '2015-03-15 00:24:54.000000', 'consum', 0.0212, 'lps'),
	(442582, 102, '2015-03-15 00:24:55.000000', 'consum', 0.0215, 'lps'),
	(442583, 102, '2015-03-15 00:24:56.000000', 'consum', 0.0212, 'lps'),
	(442584, 102, '2015-03-15 00:24:57.000000', 'consum', 0.0224, 'lps'),
	(442585, 102, '2015-03-15 00:24:58.000000', 'consum', 0.0218, 'lps'),
	(442586, 102, '2015-03-15 00:24:59.000000', 'consum', 0.0210, 'lps'),
	(442587, 102, '2015-03-15 00:25:00.000000', 'consum', 0.0223, 'lps'),
	(442588, 102, '2015-03-15 00:25:01.000000', 'consum', 0.0222, 'lps'),
	(442589, 102, '2015-03-15 00:25:02.000000', 'consum', 0.0213, 'lps'),
	(442590, 102, '2015-03-15 00:25:03.000000', 'consum', 0.0227, 'lps'),
	(442591, 102, '2015-03-15 00:25:04.000000', 'consum', 0.0212, 'lps'),
	(442592, 102, '2015-03-15 00:25:05.000000', 'consum', 0.0226, 'lps'),
	(442593, 102, '2015-03-15 00:25:06.000000', 'consum', 0.0213, 'lps'),
	(442594, 102, '2015-03-15 00:25:07.000000', 'consum', 0.0210, 'lps'),
	(442595, 102, '2015-03-15 00:25:08.000000', 'consum', 0.0223, 'lps'),
	(442596, 102, '2015-03-15 00:25:09.000000', 'consum', 0.0218, 'lps'),
	(442597, 102, '2015-03-15 00:25:10.000000', 'consum', 0.0214, 'lps'),
	(442598, 102, '2015-03-15 00:25:11.000000', 'consum', 0.0225, 'lps'),
	(442599, 102, '2015-03-15 00:25:12.000000', 'consum', 0.0217, 'lps'),
	(442600, 102, '2015-03-15 00:25:13.000000', 'consum', 0.0221, 'lps'),
	(442601, 102, '2015-03-15 00:25:14.000000', 'consum', 0.0226, 'lps'),
	(442602, 102, '2015-03-15 00:25:15.000000', 'consum', 0.0223, 'lps'),
	(442603, 102, '2015-03-15 00:25:16.000000', 'consum', 0.0225, 'lps'),
	(442604, 102, '2015-03-15 00:25:17.000000', 'consum', 0.0212, 'lps'),
	(442605, 102, '2015-03-15 00:25:18.000000', 'consum', 0.0212, 'lps'),
	(442606, 102, '2015-03-15 00:25:19.000000', 'consum', 0.0212, 'lps'),
	(442607, 102, '2015-03-15 00:25:20.000000', 'consum', 0.0215, 'lps'),
	(442608, 102, '2015-03-15 00:25:21.000000', 'consum', 0.0212, 'lps'),
	(442609, 102, '2015-03-15 00:25:22.000000', 'consum', 0.0223, 'lps'),
	(442610, 102, '2015-03-15 00:25:23.000000', 'consum', 0.0216, 'lps'),
	(442611, 102, '2015-03-15 00:25:24.000000', 'consum', 0.0219, 'lps'),
	(442612, 102, '2015-03-15 00:25:25.000000', 'consum', 0.0218, 'lps'),
	(442613, 102, '2015-03-15 00:25:26.000000', 'consum', 0.0227, 'lps'),
	(442614, 102, '2015-03-15 00:25:27.000000', 'consum', 0.0215, 'lps'),
	(442615, 102, '2015-03-15 00:25:28.000000', 'consum', 0.0221, 'lps'),
	(442616, 102, '2015-03-15 00:25:29.000000', 'consum', 0.0216, 'lps'),
	(442617, 102, '2015-03-15 00:25:30.000000', 'consum', 0.0225, 'lps'),
	(442618, 102, '2015-03-15 00:25:31.000000', 'consum', 0.0211, 'lps'),
	(442619, 102, '2015-03-15 00:25:32.000000', 'consum', 0.0227, 'lps'),
	(442620, 102, '2015-03-15 00:25:33.000000', 'consum', 0.0219, 'lps'),
	(442621, 102, '2015-03-15 00:25:34.000000', 'consum', 0.0223, 'lps'),
	(442622, 102, '2015-03-15 00:25:35.000000', 'consum', 0.0212, 'lps'),
	(442623, 102, '2015-03-15 00:25:36.000000', 'consum', 0.0218, 'lps'),
	(442624, 102, '2015-03-15 00:25:37.000000', 'consum', 0.0225, 'lps'),
	(442625, 102, '2015-03-15 00:25:38.000000', 'consum', 0.0227, 'lps'),
	(442626, 102, '2015-03-15 00:25:39.000000', 'consum', 0.0216, 'lps'),
	(442627, 102, '2015-03-15 00:25:40.000000', 'consum', 0.0224, 'lps'),
	(442628, 102, '2015-03-15 00:25:41.000000', 'consum', 0.0210, 'lps'),
	(442629, 102, '2015-03-15 00:25:42.000000', 'consum', 0.0221, 'lps'),
	(442630, 102, '2015-03-15 00:25:43.000000', 'consum', 0.0212, 'lps'),
	(442631, 102, '2015-03-15 00:25:44.000000', 'consum', 0.0225, 'lps'),
	(442632, 102, '2015-03-15 00:25:45.000000', 'consum', 0.0223, 'lps'),
	(442633, 102, '2015-03-15 00:25:46.000000', 'consum', 0.0213, 'lps'),
	(442634, 102, '2015-03-15 00:25:47.000000', 'consum', 0.0222, 'lps'),
	(442635, 102, '2015-03-15 00:25:48.000000', 'consum', 0.0225, 'lps'),
	(442636, 102, '2015-03-15 00:25:49.000000', 'consum', 0.0216, 'lps'),
	(442637, 102, '2015-03-15 00:25:50.000000', 'consum', 0.0214, 'lps'),
	(442638, 102, '2015-03-15 00:25:51.000000', 'consum', 0.0210, 'lps'),
	(442639, 102, '2015-03-15 00:25:52.000000', 'consum', 0.0218, 'lps'),
	(442640, 102, '2015-03-15 00:25:53.000000', 'consum', 0.0215, 'lps'),
	(442641, 102, '2015-03-15 00:25:54.000000', 'consum', 0.0227, 'lps'),
	(442642, 102, '2015-03-15 00:25:55.000000', 'consum', 0.0212, 'lps'),
	(442643, 102, '2015-03-15 00:25:56.000000', 'consum', 0.0221, 'lps'),
	(442644, 102, '2015-03-15 00:25:57.000000', 'consum', 0.0223, 'lps'),
	(442645, 102, '2015-03-15 00:25:58.000000', 'consum', 0.0227, 'lps'),
	(442646, 102, '2015-03-15 00:25:59.000000', 'consum', 0.0221, 'lps'),
	(442647, 102, '2015-03-15 00:26:00.000000', 'consum', 0.0215, 'lps'),
	(442648, 102, '2015-03-15 00:26:01.000000', 'consum', 0.0218, 'lps'),
	(442649, 102, '2015-03-15 00:26:02.000000', 'consum', 0.0218, 'lps'),
	(442650, 102, '2015-03-15 00:26:03.000000', 'consum', 0.0227, 'lps'),
	(442651, 102, '2015-03-15 00:26:04.000000', 'consum', 0.0216, 'lps'),
	(442652, 102, '2015-03-15 00:26:05.000000', 'consum', 0.0210, 'lps'),
	(442653, 102, '2015-03-15 00:26:06.000000', 'consum', 0.0226, 'lps'),
	(442654, 102, '2015-03-15 00:26:07.000000', 'consum', 0.0220, 'lps'),
	(442655, 102, '2015-03-15 00:26:08.000000', 'consum', 0.0213, 'lps'),
	(442656, 102, '2015-03-15 00:26:09.000000', 'consum', 0.0215, 'lps'),
	(442657, 102, '2015-03-15 00:26:10.000000', 'consum', 0.0223, 'lps'),
	(442658, 102, '2015-03-15 00:26:11.000000', 'consum', 0.0226, 'lps'),
	(442659, 102, '2015-03-15 00:26:12.000000', 'consum', 0.0215, 'lps'),
	(442660, 102, '2015-03-15 00:26:13.000000', 'consum', 0.0223, 'lps'),
	(442661, 102, '2015-03-15 00:26:14.000000', 'consum', 0.0223, 'lps'),
	(442662, 102, '2015-03-15 00:26:15.000000', 'consum', 0.0221, 'lps'),
	(442663, 102, '2015-03-15 00:26:16.000000', 'consum', 0.0226, 'lps'),
	(442664, 102, '2015-03-15 00:26:17.000000', 'consum', 0.0223, 'lps'),
	(442665, 102, '2015-03-15 00:26:18.000000', 'consum', 0.0225, 'lps'),
	(442666, 102, '2015-03-15 00:26:19.000000', 'consum', 0.0213, 'lps'),
	(442667, 102, '2015-03-15 00:26:20.000000', 'consum', 0.0216, 'lps'),
	(442668, 102, '2015-03-15 00:26:21.000000', 'consum', 0.0212, 'lps'),
	(442669, 102, '2015-03-15 00:26:22.000000', 'consum', 0.0223, 'lps'),
	(442670, 102, '2015-03-15 00:26:23.000000', 'consum', 0.0214, 'lps'),
	(442671, 102, '2015-03-15 00:26:24.000000', 'consum', 0.0226, 'lps'),
	(442672, 102, '2015-03-15 00:26:25.000000', 'consum', 0.0225, 'lps'),
	(442673, 102, '2015-03-15 00:26:26.000000', 'consum', 0.0219, 'lps'),
	(442674, 102, '2015-03-15 00:26:27.000000', 'consum', 0.0211, 'lps'),
	(442675, 102, '2015-03-15 00:26:28.000000', 'consum', 0.0226, 'lps'),
	(442676, 102, '2015-03-15 00:26:29.000000', 'consum', 0.0213, 'lps'),
	(442677, 102, '2015-03-15 00:26:30.000000', 'consum', 0.0215, 'lps'),
	(442678, 102, '2015-03-15 00:26:31.000000', 'consum', 0.0225, 'lps'),
	(442679, 102, '2015-03-15 00:26:32.000000', 'consum', 0.0216, 'lps'),
	(442680, 102, '2015-03-15 00:26:33.000000', 'consum', 0.0216, 'lps'),
	(442681, 102, '2015-03-15 00:26:34.000000', 'consum', 0.0223, 'lps'),
	(442682, 102, '2015-03-15 00:26:35.000000', 'consum', 0.0221, 'lps'),
	(442683, 102, '2015-03-15 00:26:36.000000', 'consum', 0.0224, 'lps'),
	(442684, 102, '2015-03-15 00:26:37.000000', 'consum', 0.0215, 'lps'),
	(442685, 102, '2015-03-15 00:26:38.000000', 'consum', 0.0227, 'lps'),
	(442686, 102, '2015-03-15 00:26:39.000000', 'consum', 0.0210, 'lps'),
	(442687, 102, '2015-03-15 00:26:40.000000', 'consum', 0.0213, 'lps'),
	(442688, 102, '2015-03-15 00:26:41.000000', 'consum', 0.0224, 'lps'),
	(442689, 102, '2015-03-15 00:26:42.000000', 'consum', 0.0218, 'lps'),
	(442690, 102, '2015-03-15 00:26:43.000000', 'consum', 0.0226, 'lps'),
	(442691, 102, '2015-03-15 00:26:44.000000', 'consum', 0.0212, 'lps'),
	(442692, 102, '2015-03-15 00:26:45.000000', 'consum', 0.0226, 'lps'),
	(442693, 102, '2015-03-15 00:26:46.000000', 'consum', 0.0213, 'lps'),
	(442694, 102, '2015-03-15 00:26:47.000000', 'consum', 0.0212, 'lps'),
	(442695, 102, '2015-03-15 00:26:48.000000', 'consum', 0.0211, 'lps'),
	(442696, 102, '2015-03-15 00:26:49.000000', 'consum', 0.0212, 'lps'),
	(442697, 102, '2015-03-15 00:26:50.000000', 'consum', 0.0218, 'lps'),
	(442698, 102, '2015-03-15 00:26:51.000000', 'consum', 0.0225, 'lps'),
	(442699, 102, '2015-03-15 00:26:52.000000', 'consum', 0.0224, 'lps'),
	(442700, 102, '2015-03-15 00:26:53.000000', 'consum', 0.0220, 'lps'),
	(442701, 102, '2015-03-15 00:26:54.000000', 'consum', 0.0219, 'lps'),
	(442702, 102, '2015-03-15 00:26:55.000000', 'consum', 0.0222, 'lps'),
	(442703, 102, '2015-03-15 00:26:56.000000', 'consum', 0.0211, 'lps'),
	(442704, 102, '2015-03-15 00:26:57.000000', 'consum', 0.0215, 'lps'),
	(442705, 102, '2015-03-15 00:26:58.000000', 'consum', 0.0214, 'lps'),
	(442706, 102, '2015-03-15 00:26:59.000000', 'consum', 0.0213, 'lps'),
	(442707, 102, '2015-03-15 00:27:00.000000', 'consum', 0.0217, 'lps'),
	(442708, 102, '2015-03-15 00:27:01.000000', 'consum', 0.0218, 'lps'),
	(442709, 102, '2015-03-15 00:27:02.000000', 'consum', 0.0210, 'lps'),
	(442710, 102, '2015-03-15 00:27:03.000000', 'consum', 0.0224, 'lps'),
	(442711, 102, '2015-03-15 00:27:04.000000', 'consum', 0.0224, 'lps'),
	(442712, 102, '2015-03-15 00:27:05.000000', 'consum', 0.0222, 'lps'),
	(442713, 102, '2015-03-15 00:27:06.000000', 'consum', 0.0210, 'lps'),
	(442714, 102, '2015-03-15 00:27:07.000000', 'consum', 0.0213, 'lps'),
	(442715, 102, '2015-03-15 00:27:08.000000', 'consum', 0.0223, 'lps'),
	(442716, 102, '2015-03-15 00:27:09.000000', 'consum', 0.0214, 'lps'),
	(442717, 102, '2015-03-15 00:27:10.000000', 'consum', 0.0226, 'lps'),
	(442718, 102, '2015-03-15 00:27:11.000000', 'consum', 0.0225, 'lps'),
	(442719, 102, '2015-03-15 00:27:12.000000', 'consum', 0.0220, 'lps'),
	(442720, 102, '2015-03-15 00:27:13.000000', 'consum', 0.0217, 'lps'),
	(442721, 102, '2015-03-15 00:27:14.000000', 'consum', 0.0216, 'lps'),
	(442722, 102, '2015-03-15 00:27:15.000000', 'consum', 0.0217, 'lps'),
	(442723, 102, '2015-03-15 00:27:16.000000', 'consum', 0.0210, 'lps'),
	(442724, 102, '2015-03-15 00:27:17.000000', 'consum', 0.0227, 'lps'),
	(442725, 102, '2015-03-15 00:27:18.000000', 'consum', 0.0221, 'lps'),
	(442726, 102, '2015-03-15 00:27:19.000000', 'consum', 0.0216, 'lps'),
	(442727, 102, '2015-03-15 00:27:20.000000', 'consum', 0.0227, 'lps'),
	(442728, 102, '2015-03-15 00:27:21.000000', 'consum', 0.0224, 'lps'),
	(442729, 102, '2015-03-15 00:27:22.000000', 'consum', 0.0226, 'lps'),
	(442730, 102, '2015-03-15 00:27:23.000000', 'consum', 0.0215, 'lps'),
	(442731, 102, '2015-03-15 00:27:24.000000', 'consum', 0.0224, 'lps'),
	(442732, 102, '2015-03-15 00:27:25.000000', 'consum', 0.0212, 'lps'),
	(442733, 102, '2015-03-15 00:27:26.000000', 'consum', 0.0212, 'lps'),
	(442734, 102, '2015-03-15 00:27:27.000000', 'consum', 0.0215, 'lps'),
	(442735, 102, '2015-03-15 00:27:28.000000', 'consum', 0.0211, 'lps'),
	(442736, 102, '2015-03-15 00:27:29.000000', 'consum', 0.0220, 'lps'),
	(442737, 102, '2015-03-15 00:27:30.000000', 'consum', 0.0221, 'lps'),
	(442738, 102, '2015-03-15 00:27:31.000000', 'consum', 0.0218, 'lps'),
	(442739, 102, '2015-03-15 00:27:32.000000', 'consum', 0.0217, 'lps'),
	(442740, 102, '2015-03-15 00:27:33.000000', 'consum', 0.0221, 'lps'),
	(442741, 102, '2015-03-15 00:27:34.000000', 'consum', 0.0227, 'lps'),
	(442742, 102, '2015-03-15 00:27:35.000000', 'consum', 0.0227, 'lps'),
	(442743, 102, '2015-03-15 00:27:36.000000', 'consum', 0.0227, 'lps'),
	(442744, 102, '2015-03-15 00:27:37.000000', 'consum', 0.0227, 'lps'),
	(442745, 102, '2015-03-15 00:27:38.000000', 'consum', 0.0224, 'lps'),
	(442746, 102, '2015-03-15 00:27:39.000000', 'consum', 0.0212, 'lps'),
	(442747, 102, '2015-03-15 00:27:40.000000', 'consum', 0.0215, 'lps'),
	(442748, 102, '2015-03-15 00:27:41.000000', 'consum', 0.0212, 'lps'),
	(442749, 102, '2015-03-15 00:27:42.000000', 'consum', 0.0225, 'lps'),
	(442750, 102, '2015-03-15 00:27:43.000000', 'consum', 0.0223, 'lps'),
	(442751, 102, '2015-03-15 00:27:44.000000', 'consum', 0.0215, 'lps'),
	(442752, 102, '2015-03-15 00:27:45.000000', 'consum', 0.0214, 'lps'),
	(442753, 102, '2015-03-15 00:27:46.000000', 'consum', 0.0216, 'lps'),
	(442754, 102, '2015-03-15 00:27:47.000000', 'consum', 0.0227, 'lps'),
	(442755, 102, '2015-03-15 00:27:48.000000', 'consum', 0.0224, 'lps'),
	(442756, 102, '2015-03-15 00:27:49.000000', 'consum', 0.0210, 'lps'),
	(442757, 102, '2015-03-15 00:27:50.000000', 'consum', 0.0222, 'lps'),
	(442758, 102, '2015-03-15 00:27:51.000000', 'consum', 0.0219, 'lps'),
	(442759, 102, '2015-03-15 00:27:52.000000', 'consum', 0.0219, 'lps'),
	(442760, 102, '2015-03-15 00:27:53.000000', 'consum', 0.0211, 'lps'),
	(442761, 102, '2015-03-15 00:27:54.000000', 'consum', 0.0222, 'lps'),
	(442762, 102, '2015-03-15 00:27:55.000000', 'consum', 0.0217, 'lps'),
	(442763, 102, '2015-03-15 00:27:56.000000', 'consum', 0.0224, 'lps'),
	(442764, 102, '2015-03-15 00:27:57.000000', 'consum', 0.0227, 'lps'),
	(442765, 102, '2015-03-15 00:27:58.000000', 'consum', 0.0216, 'lps'),
	(442766, 102, '2015-03-15 00:27:59.000000', 'consum', 0.0225, 'lps'),
	(442767, 102, '2015-03-15 00:28:00.000000', 'consum', 0.0213, 'lps'),
	(442768, 102, '2015-03-15 00:28:01.000000', 'consum', 0.0216, 'lps'),
	(442769, 102, '2015-03-15 00:28:02.000000', 'consum', 0.0212, 'lps'),
	(442770, 102, '2015-03-15 00:28:03.000000', 'consum', 0.0223, 'lps'),
	(442771, 102, '2015-03-15 00:28:04.000000', 'consum', 0.0215, 'lps'),
	(442772, 102, '2015-03-15 00:28:05.000000', 'consum', 0.0215, 'lps'),
	(442773, 102, '2015-03-15 00:28:06.000000', 'consum', 0.0219, 'lps'),
	(442774, 102, '2015-03-15 00:28:07.000000', 'consum', 0.0222, 'lps'),
	(442775, 102, '2015-03-15 00:28:08.000000', 'consum', 0.0227, 'lps'),
	(442776, 102, '2015-03-15 00:28:09.000000', 'consum', 0.0222, 'lps'),
	(442777, 102, '2015-03-15 00:28:10.000000', 'consum', 0.0219, 'lps'),
	(442778, 102, '2015-03-15 00:28:11.000000', 'consum', 0.0221, 'lps'),
	(442779, 102, '2015-03-15 00:28:12.000000', 'consum', 0.0222, 'lps'),
	(442780, 102, '2015-03-15 00:28:13.000000', 'consum', 0.0218, 'lps'),
	(442781, 102, '2015-03-15 00:28:14.000000', 'consum', 0.0214, 'lps'),
	(442782, 102, '2015-03-15 00:28:15.000000', 'consum', 0.0227, 'lps'),
	(442783, 102, '2015-03-15 00:28:16.000000', 'consum', 0.0227, 'lps'),
	(442784, 102, '2015-03-15 00:28:17.000000', 'consum', 0.0226, 'lps'),
	(442785, 102, '2015-03-15 00:28:18.000000', 'consum', 0.0220, 'lps'),
	(442786, 102, '2015-03-15 00:28:19.000000', 'consum', 0.0215, 'lps'),
	(442787, 102, '2015-03-15 00:28:20.000000', 'consum', 0.0224, 'lps'),
	(442788, 102, '2015-03-15 00:28:21.000000', 'consum', 0.0211, 'lps'),
	(442789, 102, '2015-03-15 00:28:22.000000', 'consum', 0.0211, 'lps'),
	(442790, 102, '2015-03-15 00:28:23.000000', 'consum', 0.0212, 'lps'),
	(442791, 102, '2015-03-15 00:28:24.000000', 'consum', 0.0216, 'lps'),
	(442792, 102, '2015-03-15 00:28:25.000000', 'consum', 0.0219, 'lps'),
	(442793, 102, '2015-03-15 00:28:26.000000', 'consum', 0.0219, 'lps'),
	(442794, 102, '2015-03-15 00:28:27.000000', 'consum', 0.0227, 'lps'),
	(442795, 102, '2015-03-15 00:28:28.000000', 'consum', 0.0214, 'lps'),
	(442796, 102, '2015-03-15 00:28:29.000000', 'consum', 0.0218, 'lps'),
	(442797, 102, '2015-03-15 00:28:30.000000', 'consum', 0.0221, 'lps'),
	(442798, 102, '2015-03-15 00:28:31.000000', 'consum', 0.0220, 'lps'),
	(442799, 102, '2015-03-15 00:28:32.000000', 'consum', 0.0212, 'lps'),
	(442800, 102, '2015-03-15 00:28:33.000000', 'consum', 0.0227, 'lps'),
	(442801, 102, '2015-03-15 00:28:34.000000', 'consum', 0.0218, 'lps'),
	(442802, 102, '2015-03-15 00:28:35.000000', 'consum', 0.0219, 'lps'),
	(442803, 102, '2015-03-15 00:28:36.000000', 'consum', 0.0211, 'lps'),
	(442804, 102, '2015-03-15 00:28:37.000000', 'consum', 0.0223, 'lps'),
	(442805, 102, '2015-03-15 00:28:38.000000', 'consum', 0.0222, 'lps'),
	(442806, 102, '2015-03-15 00:28:39.000000', 'consum', 0.0212, 'lps'),
	(442807, 102, '2015-03-15 00:28:40.000000', 'consum', 0.0221, 'lps'),
	(442808, 102, '2015-03-15 00:28:41.000000', 'consum', 0.0222, 'lps'),
	(442809, 102, '2015-03-15 00:28:42.000000', 'consum', 0.0220, 'lps'),
	(442810, 102, '2015-03-15 00:28:43.000000', 'consum', 0.0225, 'lps'),
	(442811, 102, '2015-03-15 00:28:44.000000', 'consum', 0.0219, 'lps'),
	(442812, 102, '2015-03-15 00:28:45.000000', 'consum', 0.0211, 'lps'),
	(442813, 102, '2015-03-15 00:28:46.000000', 'consum', 0.0223, 'lps'),
	(442814, 102, '2015-03-15 00:28:47.000000', 'consum', 0.0221, 'lps'),
	(442815, 102, '2015-03-15 00:28:48.000000', 'consum', 0.0225, 'lps'),
	(442816, 102, '2015-03-15 00:28:49.000000', 'consum', 0.0216, 'lps'),
	(442817, 102, '2015-03-15 00:28:50.000000', 'consum', 0.0215, 'lps'),
	(442818, 102, '2015-03-15 00:28:51.000000', 'consum', 0.0218, 'lps'),
	(442819, 102, '2015-03-15 00:28:52.000000', 'consum', 0.0218, 'lps'),
	(442820, 102, '2015-03-15 00:28:53.000000', 'consum', 0.0226, 'lps'),
	(442821, 102, '2015-03-15 00:28:54.000000', 'consum', 0.0211, 'lps'),
	(442822, 102, '2015-03-15 00:28:55.000000', 'consum', 0.0222, 'lps'),
	(442823, 102, '2015-03-15 00:28:56.000000', 'consum', 0.0215, 'lps'),
	(442824, 102, '2015-03-15 00:28:57.000000', 'consum', 0.0217, 'lps'),
	(442825, 102, '2015-03-15 00:28:58.000000', 'consum', 0.0210, 'lps'),
	(442826, 102, '2015-03-15 00:28:59.000000', 'consum', 0.0210, 'lps'),
	(442827, 102, '2015-03-15 00:29:00.000000', 'consum', 0.0227, 'lps'),
	(442828, 102, '2015-03-15 00:29:01.000000', 'consum', 0.0223, 'lps'),
	(442829, 102, '2015-03-15 00:29:02.000000', 'consum', 0.0225, 'lps'),
	(442830, 102, '2015-03-15 00:29:03.000000', 'consum', 0.0227, 'lps'),
	(442831, 102, '2015-03-15 00:29:04.000000', 'consum', 0.0216, 'lps'),
	(442832, 102, '2015-03-15 00:29:05.000000', 'consum', 0.0223, 'lps'),
	(442833, 102, '2015-03-15 00:29:06.000000', 'consum', 0.0224, 'lps'),
	(442834, 102, '2015-03-15 00:29:07.000000', 'consum', 0.0223, 'lps'),
	(442835, 102, '2015-03-15 00:29:08.000000', 'consum', 0.0214, 'lps'),
	(442836, 102, '2015-03-15 00:29:09.000000', 'consum', 0.0211, 'lps'),
	(442837, 102, '2015-03-15 00:29:10.000000', 'consum', 0.0220, 'lps'),
	(442838, 102, '2015-03-15 00:29:11.000000', 'consum', 0.0220, 'lps'),
	(442839, 102, '2015-03-15 00:29:12.000000', 'consum', 0.0216, 'lps'),
	(442840, 102, '2015-03-15 00:29:13.000000', 'consum', 0.0226, 'lps'),
	(442841, 102, '2015-03-15 00:29:14.000000', 'consum', 0.0220, 'lps'),
	(442842, 102, '2015-03-15 00:29:15.000000', 'consum', 0.0213, 'lps'),
	(442843, 102, '2015-03-15 00:29:16.000000', 'consum', 0.0214, 'lps'),
	(442844, 102, '2015-03-15 00:29:17.000000', 'consum', 0.0221, 'lps'),
	(442845, 102, '2015-03-15 00:29:18.000000', 'consum', 0.0216, 'lps'),
	(442846, 102, '2015-03-15 00:29:19.000000', 'consum', 0.0210, 'lps'),
	(442847, 102, '2015-03-15 00:29:20.000000', 'consum', 0.0226, 'lps'),
	(442848, 102, '2015-03-15 00:29:21.000000', 'consum', 0.0219, 'lps'),
	(442849, 102, '2015-03-15 00:29:22.000000', 'consum', 0.0224, 'lps'),
	(442850, 102, '2015-03-15 00:29:23.000000', 'consum', 0.0219, 'lps'),
	(442851, 102, '2015-03-15 00:29:24.000000', 'consum', 0.0212, 'lps'),
	(442852, 102, '2015-03-15 00:29:25.000000', 'consum', 0.0211, 'lps'),
	(442853, 102, '2015-03-15 00:29:26.000000', 'consum', 0.0212, 'lps'),
	(442854, 102, '2015-03-15 00:29:27.000000', 'consum', 0.0215, 'lps'),
	(442855, 102, '2015-03-15 00:29:28.000000', 'consum', 0.0211, 'lps'),
	(442856, 102, '2015-03-15 00:29:29.000000', 'consum', 0.0218, 'lps'),
	(442857, 102, '2015-03-15 00:29:30.000000', 'consum', 0.0214, 'lps'),
	(442858, 102, '2015-03-15 00:29:31.000000', 'consum', 0.0223, 'lps'),
	(442859, 102, '2015-03-15 00:29:32.000000', 'consum', 0.0211, 'lps'),
	(442860, 102, '2015-03-15 00:29:33.000000', 'consum', 0.0210, 'lps'),
	(442861, 102, '2015-03-15 00:29:34.000000', 'consum', 0.0226, 'lps'),
	(442862, 102, '2015-03-15 00:29:35.000000', 'consum', 0.0217, 'lps'),
	(442863, 102, '2015-03-15 00:29:36.000000', 'consum', 0.0218, 'lps'),
	(442864, 102, '2015-03-15 00:29:37.000000', 'consum', 0.0210, 'lps'),
	(442865, 102, '2015-03-15 00:29:38.000000', 'consum', 0.0222, 'lps'),
	(442866, 102, '2015-03-15 00:29:39.000000', 'consum', 0.0219, 'lps'),
	(442867, 102, '2015-03-15 00:29:40.000000', 'consum', 0.0216, 'lps'),
	(442868, 102, '2015-03-15 00:29:41.000000', 'consum', 0.0216, 'lps'),
	(442869, 102, '2015-03-15 00:29:42.000000', 'consum', 0.0220, 'lps'),
	(442870, 102, '2015-03-15 00:29:43.000000', 'consum', 0.0226, 'lps'),
	(442871, 102, '2015-03-15 00:29:44.000000', 'consum', 0.0223, 'lps'),
	(442872, 102, '2015-03-15 00:29:45.000000', 'consum', 0.0211, 'lps'),
	(442873, 102, '2015-03-15 00:29:46.000000', 'consum', 0.0214, 'lps'),
	(442874, 102, '2015-03-15 00:29:47.000000', 'consum', 0.0227, 'lps'),
	(442875, 102, '2015-03-15 00:29:48.000000', 'consum', 0.0212, 'lps'),
	(442876, 102, '2015-03-15 00:29:49.000000', 'consum', 0.0221, 'lps'),
	(442877, 102, '2015-03-15 00:29:50.000000', 'consum', 0.0227, 'lps'),
	(442878, 102, '2015-03-15 00:29:51.000000', 'consum', 0.0223, 'lps'),
	(442879, 102, '2015-03-15 00:29:52.000000', 'consum', 0.0210, 'lps'),
	(442880, 102, '2015-03-15 00:29:53.000000', 'consum', 0.0223, 'lps'),
	(442881, 102, '2015-03-15 00:29:54.000000', 'consum', 0.0223, 'lps'),
	(442882, 102, '2015-03-15 00:29:55.000000', 'consum', 0.0219, 'lps'),
	(442883, 102, '2015-03-15 00:29:56.000000', 'consum', 0.0214, 'lps'),
	(442884, 102, '2015-03-15 00:29:57.000000', 'consum', 0.0224, 'lps'),
	(442885, 102, '2015-03-15 00:29:58.000000', 'consum', 0.0214, 'lps'),
	(442886, 102, '2015-03-15 00:29:59.000000', 'consum', 0.0225, 'lps'),
	(442887, 102, '2015-03-15 00:30:00.000000', 'consum', 0.0221, 'lps'),
	(442888, 102, '2015-03-15 00:30:01.000000', 'consum', 0.0217, 'lps'),
	(442889, 102, '2015-03-15 00:30:02.000000', 'consum', 0.0215, 'lps'),
	(442890, 102, '2015-03-15 00:30:03.000000', 'consum', 0.0213, 'lps'),
	(442891, 102, '2015-03-15 00:30:04.000000', 'consum', 0.0211, 'lps'),
	(442892, 102, '2015-03-15 00:30:05.000000', 'consum', 0.0224, 'lps'),
	(442893, 102, '2015-03-15 00:30:06.000000', 'consum', 0.0223, 'lps'),
	(442894, 102, '2015-03-15 00:30:07.000000', 'consum', 0.0217, 'lps'),
	(442895, 102, '2015-03-15 00:30:08.000000', 'consum', 0.0225, 'lps'),
	(442896, 102, '2015-03-15 00:30:09.000000', 'consum', 0.0227, 'lps'),
	(442897, 102, '2015-03-15 00:30:10.000000', 'consum', 0.0213, 'lps'),
	(442898, 102, '2015-03-15 00:30:11.000000', 'consum', 0.0212, 'lps'),
	(442899, 102, '2015-03-15 00:30:12.000000', 'consum', 0.0210, 'lps'),
	(442900, 102, '2015-03-15 00:30:13.000000', 'consum', 0.0222, 'lps'),
	(442901, 102, '2015-03-15 00:30:14.000000', 'consum', 0.0219, 'lps'),
	(442902, 102, '2015-03-15 00:30:15.000000', 'consum', 0.0220, 'lps'),
	(442903, 102, '2015-03-15 00:30:16.000000', 'consum', 0.0213, 'lps'),
	(442904, 102, '2015-03-15 00:30:17.000000', 'consum', 0.0213, 'lps'),
	(442905, 102, '2015-03-15 00:30:18.000000', 'consum', 0.0216, 'lps'),
	(442906, 102, '2015-03-15 00:30:19.000000', 'consum', 0.0215, 'lps'),
	(442907, 102, '2015-03-15 00:30:20.000000', 'consum', 0.0219, 'lps'),
	(442908, 102, '2015-03-15 00:30:21.000000', 'consum', 0.0220, 'lps'),
	(442909, 102, '2015-03-15 00:30:22.000000', 'consum', 0.0217, 'lps'),
	(442910, 102, '2015-03-15 00:30:23.000000', 'consum', 0.0214, 'lps'),
	(442911, 102, '2015-03-15 00:30:24.000000', 'consum', 0.0210, 'lps'),
	(442912, 102, '2015-03-15 00:30:25.000000', 'consum', 0.0218, 'lps'),
	(442913, 102, '2015-03-15 00:30:26.000000', 'consum', 0.0212, 'lps'),
	(442914, 102, '2015-03-15 00:30:27.000000', 'consum', 0.0216, 'lps'),
	(442915, 102, '2015-03-15 00:30:28.000000', 'consum', 0.0215, 'lps'),
	(442916, 102, '2015-03-15 00:30:29.000000', 'consum', 0.0218, 'lps'),
	(442917, 102, '2015-03-15 00:30:30.000000', 'consum', 0.0218, 'lps'),
	(442918, 102, '2015-03-15 00:30:31.000000', 'consum', 0.0225, 'lps'),
	(442919, 102, '2015-03-15 00:30:32.000000', 'consum', 0.0226, 'lps'),
	(442920, 102, '2015-03-15 00:30:33.000000', 'consum', 0.0211, 'lps'),
	(442921, 102, '2015-03-15 00:30:34.000000', 'consum', 0.0219, 'lps'),
	(442922, 102, '2015-03-15 00:30:35.000000', 'consum', 0.0218, 'lps'),
	(442923, 102, '2015-03-15 00:30:36.000000', 'consum', 0.0225, 'lps'),
	(442924, 102, '2015-03-15 00:30:37.000000', 'consum', 0.0224, 'lps'),
	(442925, 102, '2015-03-15 00:30:38.000000', 'consum', 0.0220, 'lps'),
	(442926, 102, '2015-03-15 00:30:39.000000', 'consum', 0.0215, 'lps'),
	(442927, 102, '2015-03-15 00:30:40.000000', 'consum', 0.0224, 'lps'),
	(442928, 102, '2015-03-15 00:30:41.000000', 'consum', 0.0212, 'lps'),
	(442929, 102, '2015-03-15 00:30:42.000000', 'consum', 0.0216, 'lps'),
	(442930, 102, '2015-03-15 00:30:43.000000', 'consum', 0.0216, 'lps'),
	(442931, 102, '2015-03-15 00:30:44.000000', 'consum', 0.0223, 'lps'),
	(442932, 102, '2015-03-15 00:30:45.000000', 'consum', 0.0220, 'lps'),
	(442933, 102, '2015-03-15 00:30:46.000000', 'consum', 0.0220, 'lps'),
	(442934, 102, '2015-03-15 00:30:47.000000', 'consum', 0.0216, 'lps'),
	(442935, 102, '2015-03-15 00:30:48.000000', 'consum', 0.0227, 'lps'),
	(442936, 102, '2015-03-15 00:30:49.000000', 'consum', 0.0223, 'lps'),
	(442937, 102, '2015-03-15 00:30:50.000000', 'consum', 0.0227, 'lps'),
	(442938, 102, '2015-03-15 00:30:51.000000', 'consum', 0.0217, 'lps'),
	(442939, 102, '2015-03-15 00:30:52.000000', 'consum', 0.0214, 'lps'),
	(442940, 102, '2015-03-15 00:30:53.000000', 'consum', 0.0210, 'lps'),
	(442941, 102, '2015-03-15 00:30:54.000000', 'consum', 0.0215, 'lps'),
	(442942, 102, '2015-03-15 00:30:55.000000', 'consum', 0.0219, 'lps'),
	(442943, 102, '2015-03-15 00:30:56.000000', 'consum', 0.0223, 'lps'),
	(442944, 102, '2015-03-15 00:30:57.000000', 'consum', 0.0213, 'lps'),
	(442945, 102, '2015-03-15 00:30:58.000000', 'consum', 0.0223, 'lps'),
	(442946, 102, '2015-03-15 00:30:59.000000', 'consum', 0.0211, 'lps'),
	(442947, 102, '2015-03-15 00:31:00.000000', 'consum', 0.0214, 'lps'),
	(442948, 102, '2015-03-15 00:31:01.000000', 'consum', 0.0227, 'lps'),
	(442949, 102, '2015-03-15 00:31:02.000000', 'consum', 0.0213, 'lps'),
	(442950, 102, '2015-03-15 00:31:03.000000', 'consum', 0.0210, 'lps'),
	(442951, 102, '2015-03-15 00:31:04.000000', 'consum', 0.0220, 'lps'),
	(442952, 102, '2015-03-15 00:31:05.000000', 'consum', 0.0225, 'lps'),
	(442953, 102, '2015-03-15 00:31:06.000000', 'consum', 0.0217, 'lps'),
	(442954, 102, '2015-03-15 00:31:07.000000', 'consum', 0.0220, 'lps'),
	(442955, 102, '2015-03-15 00:31:08.000000', 'consum', 0.0223, 'lps'),
	(442956, 102, '2015-03-15 00:31:09.000000', 'consum', 0.0226, 'lps'),
	(442957, 102, '2015-03-15 00:31:10.000000', 'consum', 0.0214, 'lps'),
	(442958, 102, '2015-03-15 00:31:11.000000', 'consum', 0.0218, 'lps'),
	(442959, 102, '2015-03-15 00:31:12.000000', 'consum', 0.0222, 'lps'),
	(442960, 102, '2015-03-15 00:31:13.000000', 'consum', 0.0212, 'lps'),
	(442961, 102, '2015-03-15 00:31:14.000000', 'consum', 0.0218, 'lps'),
	(442962, 102, '2015-03-15 00:31:15.000000', 'consum', 0.0226, 'lps'),
	(442963, 102, '2015-03-15 00:31:16.000000', 'consum', 0.0213, 'lps'),
	(442964, 102, '2015-03-15 00:31:17.000000', 'consum', 0.0214, 'lps'),
	(442965, 102, '2015-03-15 00:31:18.000000', 'consum', 0.0223, 'lps'),
	(442966, 102, '2015-03-15 00:31:19.000000', 'consum', 0.0210, 'lps'),
	(442967, 102, '2015-03-15 00:31:20.000000', 'consum', 0.0225, 'lps'),
	(442968, 102, '2015-03-15 00:31:21.000000', 'consum', 0.0212, 'lps'),
	(442969, 102, '2015-03-15 00:31:22.000000', 'consum', 0.0212, 'lps'),
	(442970, 102, '2015-03-15 00:31:23.000000', 'consum', 0.0213, 'lps'),
	(442971, 102, '2015-03-15 00:31:24.000000', 'consum', 0.0223, 'lps'),
	(442972, 102, '2015-03-15 00:31:25.000000', 'consum', 0.0227, 'lps'),
	(442973, 102, '2015-03-15 00:31:26.000000', 'consum', 0.0221, 'lps'),
	(442974, 102, '2015-03-15 00:31:27.000000', 'consum', 0.0217, 'lps'),
	(442975, 102, '2015-03-15 00:31:28.000000', 'consum', 0.0210, 'lps'),
	(442976, 102, '2015-03-15 00:31:29.000000', 'consum', 0.0225, 'lps'),
	(442977, 102, '2015-03-15 00:31:30.000000', 'consum', 0.0215, 'lps'),
	(442978, 102, '2015-03-15 00:31:31.000000', 'consum', 0.0227, 'lps'),
	(442979, 102, '2015-03-15 00:31:32.000000', 'consum', 0.0224, 'lps'),
	(442980, 102, '2015-03-15 00:31:33.000000', 'consum', 0.0214, 'lps'),
	(442981, 102, '2015-03-15 00:31:34.000000', 'consum', 0.0222, 'lps'),
	(442982, 102, '2015-03-15 00:31:35.000000', 'consum', 0.0223, 'lps'),
	(442983, 102, '2015-03-15 00:31:36.000000', 'consum', 0.0221, 'lps'),
	(442984, 102, '2015-03-15 00:31:37.000000', 'consum', 0.0225, 'lps'),
	(442985, 102, '2015-03-15 00:31:38.000000', 'consum', 0.0219, 'lps'),
	(442986, 102, '2015-03-15 00:31:39.000000', 'consum', 0.0227, 'lps'),
	(442987, 102, '2015-03-15 00:31:40.000000', 'consum', 0.0214, 'lps'),
	(442988, 102, '2015-03-15 00:31:41.000000', 'consum', 0.0218, 'lps'),
	(442989, 102, '2015-03-15 00:31:42.000000', 'consum', 0.0220, 'lps'),
	(442990, 102, '2015-03-15 00:31:43.000000', 'consum', 0.0218, 'lps'),
	(442991, 102, '2015-03-15 00:31:44.000000', 'consum', 0.0219, 'lps'),
	(442992, 102, '2015-03-15 00:31:45.000000', 'consum', 0.0216, 'lps'),
	(442993, 102, '2015-03-15 00:31:46.000000', 'consum', 0.0212, 'lps'),
	(442994, 102, '2015-03-15 00:31:47.000000', 'consum', 0.0219, 'lps'),
	(442995, 102, '2015-03-15 00:31:48.000000', 'consum', 0.0216, 'lps'),
	(442996, 102, '2015-03-15 00:31:49.000000', 'consum', 0.0212, 'lps'),
	(442997, 102, '2015-03-15 00:31:50.000000', 'consum', 0.0219, 'lps'),
	(442998, 102, '2015-03-15 00:31:51.000000', 'consum', 0.0216, 'lps'),
	(442999, 102, '2015-03-15 00:31:52.000000', 'consum', 0.0213, 'lps'),
	(443000, 102, '2015-03-15 00:31:53.000000', 'consum', 0.0227, 'lps'),
	(443001, 102, '2015-03-15 00:31:54.000000', 'consum', 0.0213, 'lps'),
	(443002, 102, '2015-03-15 00:31:55.000000', 'consum', 0.0227, 'lps'),
	(443003, 102, '2015-03-15 00:31:56.000000', 'consum', 0.0214, 'lps'),
	(443004, 102, '2015-03-15 00:31:57.000000', 'consum', 0.0217, 'lps'),
	(443005, 102, '2015-03-15 00:31:58.000000', 'consum', 0.0215, 'lps'),
	(443006, 102, '2015-03-15 00:31:59.000000', 'consum', 0.0215, 'lps'),
	(443007, 102, '2015-03-15 00:32:00.000000', 'consum', 0.0219, 'lps'),
	(443008, 102, '2015-03-15 00:32:01.000000', 'consum', 0.0221, 'lps'),
	(443009, 102, '2015-03-15 00:32:02.000000', 'consum', 0.0224, 'lps'),
	(443010, 102, '2015-03-15 00:32:03.000000', 'consum', 0.0210, 'lps'),
	(443011, 102, '2015-03-15 00:32:04.000000', 'consum', 0.0225, 'lps'),
	(443012, 102, '2015-03-15 00:32:05.000000', 'consum', 0.0211, 'lps'),
	(443013, 102, '2015-03-15 00:32:06.000000', 'consum', 0.0224, 'lps'),
	(443014, 102, '2015-03-15 00:32:07.000000', 'consum', 0.0225, 'lps'),
	(443015, 102, '2015-03-15 00:32:08.000000', 'consum', 0.0225, 'lps'),
	(443016, 102, '2015-03-15 00:32:09.000000', 'consum', 0.0221, 'lps'),
	(443017, 102, '2015-03-15 00:32:10.000000', 'consum', 0.0220, 'lps'),
	(443018, 102, '2015-03-15 00:32:11.000000', 'consum', 0.0212, 'lps'),
	(443019, 102, '2015-03-15 00:32:12.000000', 'consum', 0.0225, 'lps'),
	(443020, 102, '2015-03-15 00:32:13.000000', 'consum', 0.0225, 'lps'),
	(443021, 102, '2015-03-15 00:32:14.000000', 'consum', 0.0224, 'lps'),
	(443022, 102, '2015-03-15 00:32:15.000000', 'consum', 0.0216, 'lps'),
	(443023, 102, '2015-03-15 00:32:16.000000', 'consum', 0.0216, 'lps'),
	(443024, 102, '2015-03-15 00:32:17.000000', 'consum', 0.0223, 'lps'),
	(443025, 102, '2015-03-15 00:32:18.000000', 'consum', 0.0221, 'lps'),
	(443026, 102, '2015-03-15 00:32:19.000000', 'consum', 0.0226, 'lps'),
	(443027, 102, '2015-03-15 00:32:20.000000', 'consum', 0.0223, 'lps'),
	(443028, 102, '2015-03-15 00:32:21.000000', 'consum', 0.0210, 'lps'),
	(443029, 102, '2015-03-15 00:32:22.000000', 'consum', 0.0224, 'lps'),
	(443030, 102, '2015-03-15 00:32:23.000000', 'consum', 0.0210, 'lps'),
	(443031, 102, '2015-03-15 00:32:24.000000', 'consum', 0.0220, 'lps'),
	(443032, 102, '2015-03-15 00:32:25.000000', 'consum', 0.0227, 'lps'),
	(443033, 102, '2015-03-15 00:32:26.000000', 'consum', 0.0227, 'lps'),
	(443034, 102, '2015-03-15 00:32:27.000000', 'consum', 0.0226, 'lps'),
	(443035, 102, '2015-03-15 00:32:28.000000', 'consum', 0.0224, 'lps'),
	(443036, 102, '2015-03-15 00:32:29.000000', 'consum', 0.0211, 'lps'),
	(443037, 102, '2015-03-15 00:32:30.000000', 'consum', 0.0213, 'lps'),
	(443038, 102, '2015-03-15 00:32:31.000000', 'consum', 0.0222, 'lps'),
	(443039, 102, '2015-03-15 00:32:32.000000', 'consum', 0.0227, 'lps'),
	(443040, 102, '2015-03-15 00:32:33.000000', 'consum', 0.0221, 'lps'),
	(443041, 102, '2015-03-15 00:32:34.000000', 'consum', 0.0216, 'lps'),
	(443042, 102, '2015-03-15 00:32:35.000000', 'consum', 0.0225, 'lps'),
	(443043, 102, '2015-03-15 00:32:36.000000', 'consum', 0.0213, 'lps'),
	(443044, 102, '2015-03-15 00:32:37.000000', 'consum', 0.0215, 'lps'),
	(443045, 102, '2015-03-15 00:32:38.000000', 'consum', 0.0211, 'lps'),
	(443046, 102, '2015-03-15 00:32:39.000000', 'consum', 0.0217, 'lps'),
	(443047, 102, '2015-03-15 00:32:40.000000', 'consum', 0.0225, 'lps'),
	(443048, 102, '2015-03-15 00:32:41.000000', 'consum', 0.0212, 'lps'),
	(443049, 102, '2015-03-15 00:32:42.000000', 'consum', 0.0210, 'lps'),
	(443050, 102, '2015-03-15 00:32:43.000000', 'consum', 0.0224, 'lps'),
	(443051, 102, '2015-03-15 00:32:44.000000', 'consum', 0.0224, 'lps'),
	(443052, 102, '2015-03-15 00:32:45.000000', 'consum', 0.0223, 'lps'),
	(443053, 102, '2015-03-15 00:32:46.000000', 'consum', 0.0213, 'lps'),
	(443054, 102, '2015-03-15 00:32:47.000000', 'consum', 0.0222, 'lps'),
	(443055, 102, '2015-03-15 00:32:48.000000', 'consum', 0.0226, 'lps'),
	(443056, 102, '2015-03-15 00:32:49.000000', 'consum', 0.0217, 'lps'),
	(443057, 102, '2015-03-15 00:32:50.000000', 'consum', 0.0217, 'lps'),
	(443058, 102, '2015-03-15 00:32:51.000000', 'consum', 0.0226, 'lps'),
	(443059, 102, '2015-03-15 00:32:52.000000', 'consum', 0.0213, 'lps'),
	(443060, 102, '2015-03-15 00:32:53.000000', 'consum', 0.0214, 'lps'),
	(443061, 102, '2015-03-15 00:32:54.000000', 'consum', 0.0224, 'lps'),
	(443062, 102, '2015-03-15 00:32:55.000000', 'consum', 0.0213, 'lps'),
	(443063, 102, '2015-03-15 00:32:56.000000', 'consum', 0.0218, 'lps'),
	(443064, 102, '2015-03-15 00:32:57.000000', 'consum', 0.0226, 'lps'),
	(443065, 102, '2015-03-15 00:32:58.000000', 'consum', 0.0212, 'lps'),
	(443066, 102, '2015-03-15 00:32:59.000000', 'consum', 0.0227, 'lps'),
	(443067, 102, '2015-03-15 00:33:00.000000', 'consum', 0.0216, 'lps'),
	(443068, 102, '2015-03-15 00:33:01.000000', 'consum', 0.0225, 'lps'),
	(443069, 102, '2015-03-15 00:33:02.000000', 'consum', 0.0214, 'lps'),
	(443070, 102, '2015-03-15 00:33:03.000000', 'consum', 0.0224, 'lps'),
	(443071, 102, '2015-03-15 00:33:04.000000', 'consum', 0.0212, 'lps'),
	(443072, 102, '2015-03-15 00:33:05.000000', 'consum', 0.0215, 'lps'),
	(443073, 102, '2015-03-15 00:33:06.000000', 'consum', 0.0211, 'lps'),
	(443074, 102, '2015-03-15 00:33:07.000000', 'consum', 0.0220, 'lps'),
	(443075, 102, '2015-03-15 00:33:08.000000', 'consum', 0.0219, 'lps'),
	(443076, 102, '2015-03-15 00:33:09.000000', 'consum', 0.0210, 'lps'),
	(443077, 102, '2015-03-15 00:33:10.000000', 'consum', 0.0220, 'lps'),
	(443078, 102, '2015-03-15 00:33:11.000000', 'consum', 0.0225, 'lps'),
	(443079, 102, '2015-03-15 00:33:12.000000', 'consum', 0.0219, 'lps'),
	(443080, 102, '2015-03-15 00:33:13.000000', 'consum', 0.0211, 'lps'),
	(443081, 102, '2015-03-15 00:33:14.000000', 'consum', 0.0224, 'lps'),
	(443082, 102, '2015-03-15 00:33:15.000000', 'consum', 0.0223, 'lps'),
	(443083, 102, '2015-03-15 00:33:16.000000', 'consum', 0.0216, 'lps'),
	(443084, 102, '2015-03-15 00:33:17.000000', 'consum', 0.0219, 'lps'),
	(443085, 102, '2015-03-15 00:33:18.000000', 'consum', 0.0221, 'lps'),
	(443086, 102, '2015-03-15 00:33:19.000000', 'consum', 0.0219, 'lps'),
	(443087, 102, '2015-03-15 00:33:20.000000', 'consum', 0.0225, 'lps'),
	(443088, 102, '2015-03-15 00:33:21.000000', 'consum', 0.0219, 'lps'),
	(443089, 102, '2015-03-15 00:33:22.000000', 'consum', 0.0213, 'lps'),
	(443090, 102, '2015-03-15 00:33:23.000000', 'consum', 0.0214, 'lps'),
	(443091, 102, '2015-03-15 00:33:24.000000', 'consum', 0.0224, 'lps'),
	(443092, 102, '2015-03-15 00:33:25.000000', 'consum', 0.0213, 'lps'),
	(443093, 102, '2015-03-15 00:33:26.000000', 'consum', 0.0220, 'lps'),
	(443094, 102, '2015-03-15 00:33:27.000000', 'consum', 0.0216, 'lps'),
	(443095, 102, '2015-03-15 00:33:28.000000', 'consum', 0.0210, 'lps'),
	(443096, 102, '2015-03-15 00:33:29.000000', 'consum', 0.0213, 'lps'),
	(443097, 102, '2015-03-15 00:33:30.000000', 'consum', 0.0223, 'lps'),
	(443098, 102, '2015-03-15 00:33:31.000000', 'consum', 0.0211, 'lps'),
	(443099, 102, '2015-03-15 00:33:32.000000', 'consum', 0.0214, 'lps'),
	(443100, 102, '2015-03-15 00:33:33.000000', 'consum', 0.0211, 'lps'),
	(443101, 102, '2015-03-15 00:33:34.000000', 'consum', 0.0222, 'lps'),
	(443102, 102, '2015-03-15 00:33:35.000000', 'consum', 0.0211, 'lps'),
	(443103, 102, '2015-03-15 00:33:36.000000', 'consum', 0.0217, 'lps'),
	(443104, 102, '2015-03-15 00:33:37.000000', 'consum', 0.0226, 'lps'),
	(443105, 102, '2015-03-15 00:33:38.000000', 'consum', 0.0213, 'lps'),
	(443106, 102, '2015-03-15 00:33:39.000000', 'consum', 0.0216, 'lps'),
	(443107, 102, '2015-03-15 00:33:40.000000', 'consum', 0.0214, 'lps'),
	(443108, 102, '2015-03-15 00:33:41.000000', 'consum', 0.0212, 'lps'),
	(443109, 102, '2015-03-15 00:33:42.000000', 'consum', 0.0224, 'lps'),
	(443110, 102, '2015-03-15 00:33:43.000000', 'consum', 0.0222, 'lps'),
	(443111, 102, '2015-03-15 00:33:44.000000', 'consum', 0.0227, 'lps'),
	(443112, 102, '2015-03-15 00:33:45.000000', 'consum', 0.0225, 'lps'),
	(443113, 102, '2015-03-15 00:33:46.000000', 'consum', 0.0217, 'lps'),
	(443114, 102, '2015-03-15 00:33:47.000000', 'consum', 0.0218, 'lps'),
	(443115, 102, '2015-03-15 00:33:48.000000', 'consum', 0.0212, 'lps'),
	(443116, 102, '2015-03-15 00:33:49.000000', 'consum', 0.0215, 'lps'),
	(443117, 102, '2015-03-15 00:33:50.000000', 'consum', 0.0227, 'lps'),
	(443118, 102, '2015-03-15 00:33:51.000000', 'consum', 0.0211, 'lps'),
	(443119, 102, '2015-03-15 00:33:52.000000', 'consum', 0.0218, 'lps'),
	(443120, 102, '2015-03-15 00:33:53.000000', 'consum', 0.0210, 'lps'),
	(443121, 102, '2015-03-15 00:33:54.000000', 'consum', 0.0222, 'lps'),
	(443122, 102, '2015-03-15 00:33:55.000000', 'consum', 0.0219, 'lps'),
	(443123, 102, '2015-03-15 00:33:56.000000', 'consum', 0.0219, 'lps'),
	(443124, 102, '2015-03-15 00:33:57.000000', 'consum', 0.0210, 'lps'),
	(443125, 102, '2015-03-15 00:33:58.000000', 'consum', 0.0221, 'lps'),
	(443126, 102, '2015-03-15 00:33:59.000000', 'consum', 0.0227, 'lps'),
	(443127, 102, '2015-03-15 00:34:00.000000', 'consum', 0.0227, 'lps'),
	(443128, 102, '2015-03-15 00:34:01.000000', 'consum', 0.0225, 'lps'),
	(443129, 102, '2015-03-15 00:34:02.000000', 'consum', 0.0219, 'lps'),
	(443130, 102, '2015-03-15 00:34:03.000000', 'consum', 0.0227, 'lps'),
	(443131, 102, '2015-03-15 00:34:04.000000', 'consum', 0.0215, 'lps'),
	(443132, 102, '2015-03-15 00:34:05.000000', 'consum', 0.0220, 'lps'),
	(443133, 102, '2015-03-15 00:34:06.000000', 'consum', 0.0211, 'lps'),
	(443134, 102, '2015-03-15 00:34:07.000000', 'consum', 0.0219, 'lps'),
	(443135, 102, '2015-03-15 00:34:08.000000', 'consum', 0.0219, 'lps'),
	(443136, 102, '2015-03-15 00:34:09.000000', 'consum', 0.0227, 'lps'),
	(443137, 102, '2015-03-15 00:34:10.000000', 'consum', 0.0217, 'lps'),
	(443138, 102, '2015-03-15 00:34:11.000000', 'consum', 0.0210, 'lps'),
	(443139, 102, '2015-03-15 00:34:12.000000', 'consum', 0.0225, 'lps'),
	(443140, 102, '2015-03-15 00:34:13.000000', 'consum', 0.0216, 'lps'),
	(443141, 102, '2015-03-15 00:34:14.000000', 'consum', 0.0214, 'lps'),
	(443142, 102, '2015-03-15 00:34:15.000000', 'consum', 0.0211, 'lps'),
	(443143, 102, '2015-03-15 00:34:16.000000', 'consum', 0.0222, 'lps'),
	(443144, 102, '2015-03-15 00:34:17.000000', 'consum', 0.0212, 'lps'),
	(443145, 102, '2015-03-15 00:34:18.000000', 'consum', 0.0223, 'lps'),
	(443146, 102, '2015-03-15 00:34:19.000000', 'consum', 0.0214, 'lps'),
	(443147, 102, '2015-03-15 00:34:20.000000', 'consum', 0.0226, 'lps'),
	(443148, 102, '2015-03-15 00:34:21.000000', 'consum', 0.0224, 'lps'),
	(443149, 102, '2015-03-15 00:34:22.000000', 'consum', 0.0217, 'lps'),
	(443150, 102, '2015-03-15 00:34:23.000000', 'consum', 0.0221, 'lps'),
	(443151, 102, '2015-03-15 00:34:24.000000', 'consum', 0.0225, 'lps'),
	(443152, 102, '2015-03-15 00:34:25.000000', 'consum', 0.0218, 'lps'),
	(443153, 102, '2015-03-15 00:34:26.000000', 'consum', 0.0222, 'lps'),
	(443154, 102, '2015-03-15 00:34:27.000000', 'consum', 0.0212, 'lps'),
	(443155, 102, '2015-03-15 00:34:28.000000', 'consum', 0.0218, 'lps'),
	(443156, 102, '2015-03-15 00:34:29.000000', 'consum', 0.0210, 'lps'),
	(443157, 102, '2015-03-15 00:34:30.000000', 'consum', 0.0222, 'lps'),
	(443158, 102, '2015-03-15 00:34:31.000000', 'consum', 0.0217, 'lps'),
	(443159, 102, '2015-03-15 00:34:32.000000', 'consum', 0.0211, 'lps'),
	(443160, 102, '2015-03-15 00:34:33.000000', 'consum', 0.0210, 'lps'),
	(443161, 102, '2015-03-15 00:34:34.000000', 'consum', 0.0225, 'lps'),
	(443162, 102, '2015-03-15 00:34:35.000000', 'consum', 0.0213, 'lps'),
	(443163, 102, '2015-03-15 00:34:36.000000', 'consum', 0.0216, 'lps'),
	(443164, 102, '2015-03-15 00:34:37.000000', 'consum', 0.0214, 'lps'),
	(443165, 102, '2015-03-15 00:34:38.000000', 'consum', 0.0212, 'lps'),
	(443166, 102, '2015-03-15 00:34:39.000000', 'consum', 0.0227, 'lps'),
	(443167, 102, '2015-03-15 00:34:40.000000', 'consum', 0.0216, 'lps'),
	(443168, 102, '2015-03-15 00:34:41.000000', 'consum', 0.0225, 'lps'),
	(443169, 102, '2015-03-15 00:34:42.000000', 'consum', 0.0215, 'lps'),
	(443170, 102, '2015-03-15 00:34:43.000000', 'consum', 0.0226, 'lps'),
	(443171, 102, '2015-03-15 00:34:44.000000', 'consum', 0.0220, 'lps'),
	(443172, 102, '2015-03-15 00:34:45.000000', 'consum', 0.0212, 'lps'),
	(443173, 102, '2015-03-15 00:34:46.000000', 'consum', 0.0211, 'lps'),
	(443174, 102, '2015-03-15 00:34:47.000000', 'consum', 0.0210, 'lps'),
	(443175, 102, '2015-03-15 00:34:48.000000', 'consum', 0.0224, 'lps'),
	(443176, 102, '2015-03-15 00:34:49.000000', 'consum', 0.0227, 'lps'),
	(443177, 102, '2015-03-15 00:34:50.000000', 'consum', 0.0216, 'lps'),
	(443178, 102, '2015-03-15 00:34:51.000000', 'consum', 0.0226, 'lps'),
	(443179, 102, '2015-03-15 00:34:52.000000', 'consum', 0.0217, 'lps'),
	(443180, 102, '2015-03-15 00:34:53.000000', 'consum', 0.0216, 'lps'),
	(443181, 102, '2015-03-15 00:34:54.000000', 'consum', 0.0219, 'lps'),
	(443182, 102, '2015-03-15 00:34:55.000000', 'consum', 0.0221, 'lps'),
	(443183, 102, '2015-03-15 00:34:56.000000', 'consum', 0.0222, 'lps'),
	(443184, 102, '2015-03-15 00:34:57.000000', 'consum', 0.0217, 'lps'),
	(443185, 102, '2015-03-15 00:34:58.000000', 'consum', 0.0226, 'lps'),
	(443186, 102, '2015-03-15 00:34:59.000000', 'consum', 0.0219, 'lps'),
	(443187, 102, '2015-03-15 00:35:00.000000', 'consum', 0.0223, 'lps'),
	(443188, 102, '2015-03-15 00:35:01.000000', 'consum', 0.0215, 'lps'),
	(443189, 102, '2015-03-15 00:35:02.000000', 'consum', 0.0212, 'lps'),
	(443190, 102, '2015-03-15 00:35:03.000000', 'consum', 0.0225, 'lps'),
	(443191, 102, '2015-03-15 00:35:04.000000', 'consum', 0.0224, 'lps'),
	(443192, 102, '2015-03-15 00:35:05.000000', 'consum', 0.0219, 'lps'),
	(443193, 102, '2015-03-15 00:35:06.000000', 'consum', 0.0215, 'lps'),
	(443194, 102, '2015-03-15 00:35:07.000000', 'consum', 0.0224, 'lps'),
	(443195, 102, '2015-03-15 00:35:08.000000', 'consum', 0.0214, 'lps'),
	(443196, 102, '2015-03-15 00:35:09.000000', 'consum', 0.0223, 'lps'),
	(443197, 102, '2015-03-15 00:35:10.000000', 'consum', 0.0226, 'lps'),
	(443198, 102, '2015-03-15 00:35:11.000000', 'consum', 0.0215, 'lps'),
	(443199, 102, '2015-03-15 00:35:12.000000', 'consum', 0.0224, 'lps'),
	(443200, 102, '2015-03-15 00:35:13.000000', 'consum', 0.0214, 'lps'),
	(443201, 102, '2015-03-15 00:35:14.000000', 'consum', 0.0222, 'lps'),
	(443202, 102, '2015-03-15 00:35:15.000000', 'consum', 0.0222, 'lps'),
	(443203, 102, '2015-03-15 00:35:16.000000', 'consum', 0.0216, 'lps'),
	(443204, 102, '2015-03-15 00:35:17.000000', 'consum', 0.0225, 'lps'),
	(443205, 102, '2015-03-15 00:35:18.000000', 'consum', 0.0213, 'lps'),
	(443206, 102, '2015-03-15 00:35:19.000000', 'consum', 0.0214, 'lps'),
	(443207, 102, '2015-03-15 00:35:20.000000', 'consum', 0.0224, 'lps'),
	(443208, 102, '2015-03-15 00:35:21.000000', 'consum', 0.0215, 'lps'),
	(443209, 102, '2015-03-15 00:35:22.000000', 'consum', 0.0210, 'lps'),
	(443210, 102, '2015-03-15 00:35:23.000000', 'consum', 0.0215, 'lps'),
	(443211, 102, '2015-03-15 00:35:24.000000', 'consum', 0.0215, 'lps'),
	(443212, 102, '2015-03-15 00:35:25.000000', 'consum', 0.0223, 'lps'),
	(443213, 102, '2015-03-15 00:35:26.000000', 'consum', 0.0225, 'lps'),
	(443214, 102, '2015-03-15 00:35:27.000000', 'consum', 0.0226, 'lps'),
	(443215, 102, '2015-03-15 00:35:28.000000', 'consum', 0.0212, 'lps'),
	(443216, 102, '2015-03-15 00:35:29.000000', 'consum', 0.0225, 'lps'),
	(443217, 102, '2015-03-15 00:35:30.000000', 'consum', 0.0227, 'lps'),
	(443218, 102, '2015-03-15 00:35:31.000000', 'consum', 0.0215, 'lps'),
	(443219, 102, '2015-03-15 00:35:32.000000', 'consum', 0.0221, 'lps'),
	(443220, 102, '2015-03-15 00:35:33.000000', 'consum', 0.0215, 'lps'),
	(443221, 102, '2015-03-15 00:35:34.000000', 'consum', 0.0220, 'lps'),
	(443222, 102, '2015-03-15 00:35:35.000000', 'consum', 0.0227, 'lps'),
	(443223, 102, '2015-03-15 00:35:36.000000', 'consum', 0.0211, 'lps'),
	(443224, 102, '2015-03-15 00:35:37.000000', 'consum', 0.0217, 'lps'),
	(443225, 102, '2015-03-15 00:35:38.000000', 'consum', 0.0227, 'lps'),
	(443226, 102, '2015-03-15 00:35:39.000000', 'consum', 0.0220, 'lps'),
	(443227, 102, '2015-03-15 00:35:40.000000', 'consum', 0.0210, 'lps'),
	(443228, 102, '2015-03-15 00:35:41.000000', 'consum', 0.0215, 'lps'),
	(443229, 102, '2015-03-15 00:35:42.000000', 'consum', 0.0220, 'lps'),
	(443230, 102, '2015-03-15 00:35:43.000000', 'consum', 0.0225, 'lps'),
	(443231, 102, '2015-03-15 00:35:44.000000', 'consum', 0.0221, 'lps'),
	(443232, 102, '2015-03-15 00:35:45.000000', 'consum', 0.0221, 'lps'),
	(443233, 102, '2015-03-15 00:35:46.000000', 'consum', 0.0212, 'lps'),
	(443234, 102, '2015-03-15 00:35:47.000000', 'consum', 0.0226, 'lps'),
	(443235, 102, '2015-03-15 00:35:48.000000', 'consum', 0.0210, 'lps'),
	(443236, 102, '2015-03-15 00:35:49.000000', 'consum', 0.0216, 'lps'),
	(443237, 102, '2015-03-15 00:35:50.000000', 'consum', 0.0222, 'lps'),
	(443238, 102, '2015-03-15 00:35:51.000000', 'consum', 0.0219, 'lps'),
	(443239, 102, '2015-03-15 00:35:52.000000', 'consum', 0.0220, 'lps'),
	(443240, 102, '2015-03-15 00:35:53.000000', 'consum', 0.0216, 'lps'),
	(443241, 102, '2015-03-15 00:35:54.000000', 'consum', 0.0210, 'lps'),
	(443242, 102, '2015-03-15 00:35:55.000000', 'consum', 0.0212, 'lps'),
	(443243, 102, '2015-03-15 00:35:56.000000', 'consum', 0.0218, 'lps'),
	(443244, 102, '2015-03-15 00:35:57.000000', 'consum', 0.0210, 'lps'),
	(443245, 102, '2015-03-15 00:35:58.000000', 'consum', 0.0223, 'lps'),
	(443246, 102, '2015-03-15 00:35:59.000000', 'consum', 0.0223, 'lps'),
	(443247, 102, '2015-03-15 00:36:00.000000', 'consum', 0.0217, 'lps'),
	(443248, 102, '2015-03-15 00:36:01.000000', 'consum', 0.0223, 'lps'),
	(443249, 102, '2015-03-15 00:36:02.000000', 'consum', 0.0221, 'lps'),
	(443250, 102, '2015-03-15 00:36:03.000000', 'consum', 0.0224, 'lps'),
	(443251, 102, '2015-03-15 00:36:04.000000', 'consum', 0.0214, 'lps'),
	(443252, 102, '2015-03-15 00:36:05.000000', 'consum', 0.0222, 'lps'),
	(443253, 102, '2015-03-15 00:36:06.000000', 'consum', 0.0222, 'lps'),
	(443254, 102, '2015-03-15 00:36:07.000000', 'consum', 0.0218, 'lps'),
	(443255, 102, '2015-03-15 00:36:08.000000', 'consum', 0.0214, 'lps'),
	(443256, 102, '2015-03-15 00:36:09.000000', 'consum', 0.0224, 'lps'),
	(443257, 102, '2015-03-15 00:36:10.000000', 'consum', 0.0215, 'lps'),
	(443258, 102, '2015-03-15 00:36:11.000000', 'consum', 0.0213, 'lps'),
	(443259, 102, '2015-03-15 00:36:12.000000', 'consum', 0.0225, 'lps'),
	(443260, 102, '2015-03-15 00:36:13.000000', 'consum', 0.0226, 'lps'),
	(443261, 102, '2015-03-15 00:36:14.000000', 'consum', 0.0225, 'lps'),
	(443262, 102, '2015-03-15 00:36:15.000000', 'consum', 0.0219, 'lps'),
	(443263, 102, '2015-03-15 00:36:16.000000', 'consum', 0.0210, 'lps'),
	(443264, 102, '2015-03-15 00:36:17.000000', 'consum', 0.0220, 'lps'),
	(443265, 102, '2015-03-15 00:36:18.000000', 'consum', 0.0224, 'lps'),
	(443266, 102, '2015-03-15 00:36:19.000000', 'consum', 0.0217, 'lps'),
	(443267, 102, '2015-03-15 00:36:20.000000', 'consum', 0.0219, 'lps'),
	(443268, 102, '2015-03-15 00:36:21.000000', 'consum', 0.0215, 'lps'),
	(443269, 102, '2015-03-15 00:36:22.000000', 'consum', 0.0212, 'lps'),
	(443270, 102, '2015-03-15 00:36:23.000000', 'consum', 0.0222, 'lps'),
	(443271, 102, '2015-03-15 00:36:24.000000', 'consum', 0.0212, 'lps'),
	(443272, 102, '2015-03-15 00:36:25.000000', 'consum', 0.0220, 'lps'),
	(443273, 102, '2015-03-15 00:36:26.000000', 'consum', 0.0219, 'lps'),
	(443274, 102, '2015-03-15 00:36:27.000000', 'consum', 0.0227, 'lps'),
	(443275, 102, '2015-03-15 00:36:28.000000', 'consum', 0.0212, 'lps'),
	(443276, 102, '2015-03-15 00:36:29.000000', 'consum', 0.0225, 'lps'),
	(443277, 102, '2015-03-15 00:36:30.000000', 'consum', 0.0224, 'lps'),
	(443278, 102, '2015-03-15 00:36:31.000000', 'consum', 0.0219, 'lps'),
	(443279, 102, '2015-03-15 00:36:32.000000', 'consum', 0.0211, 'lps'),
	(443280, 102, '2015-03-15 00:36:33.000000', 'consum', 0.0210, 'lps'),
	(443281, 102, '2015-03-15 00:36:34.000000', 'consum', 0.0222, 'lps'),
	(443282, 102, '2015-03-15 00:36:35.000000', 'consum', 0.0218, 'lps'),
	(443283, 102, '2015-03-15 00:36:36.000000', 'consum', 0.0213, 'lps'),
	(443284, 102, '2015-03-15 00:36:37.000000', 'consum', 0.0223, 'lps'),
	(443285, 102, '2015-03-15 00:36:38.000000', 'consum', 0.0227, 'lps'),
	(443286, 102, '2015-03-15 00:36:39.000000', 'consum', 0.0222, 'lps'),
	(443287, 102, '2015-03-15 00:36:40.000000', 'consum', 0.0218, 'lps'),
	(443288, 102, '2015-03-15 00:36:41.000000', 'consum', 0.0213, 'lps'),
	(443289, 102, '2015-03-15 00:36:42.000000', 'consum', 0.0223, 'lps'),
	(443290, 102, '2015-03-15 00:36:43.000000', 'consum', 0.0211, 'lps'),
	(443291, 102, '2015-03-15 00:36:44.000000', 'consum', 0.0213, 'lps'),
	(443292, 102, '2015-03-15 00:36:45.000000', 'consum', 0.0222, 'lps'),
	(443293, 102, '2015-03-15 00:36:46.000000', 'consum', 0.0227, 'lps'),
	(443294, 102, '2015-03-15 00:36:47.000000', 'consum', 0.0224, 'lps'),
	(443295, 102, '2015-03-15 00:36:48.000000', 'consum', 0.0210, 'lps'),
	(443296, 102, '2015-03-15 00:36:49.000000', 'consum', 0.0225, 'lps'),
	(443297, 102, '2015-03-15 00:36:50.000000', 'consum', 0.0212, 'lps'),
	(443298, 102, '2015-03-15 00:36:51.000000', 'consum', 0.0210, 'lps'),
	(443299, 102, '2015-03-15 00:36:52.000000', 'consum', 0.0225, 'lps'),
	(443300, 102, '2015-03-15 00:36:53.000000', 'consum', 0.0213, 'lps'),
	(443301, 102, '2015-03-15 00:36:54.000000', 'consum', 0.0218, 'lps'),
	(443302, 102, '2015-03-15 00:36:55.000000', 'consum', 0.0220, 'lps'),
	(443303, 102, '2015-03-15 00:36:56.000000', 'consum', 0.0220, 'lps'),
	(443304, 102, '2015-03-15 00:36:57.000000', 'consum', 0.0214, 'lps'),
	(443305, 102, '2015-03-15 00:36:58.000000', 'consum', 0.0219, 'lps'),
	(443306, 102, '2015-03-15 00:36:59.000000', 'consum', 0.0222, 'lps'),
	(443307, 102, '2015-03-15 00:37:00.000000', 'consum', 0.0211, 'lps'),
	(443308, 102, '2015-03-15 00:37:01.000000', 'consum', 0.0215, 'lps'),
	(443309, 102, '2015-03-15 00:37:02.000000', 'consum', 0.0213, 'lps'),
	(443310, 102, '2015-03-15 00:37:03.000000', 'consum', 0.0212, 'lps'),
	(443311, 102, '2015-03-15 00:37:04.000000', 'consum', 0.0213, 'lps'),
	(443312, 102, '2015-03-15 00:37:05.000000', 'consum', 0.0217, 'lps'),
	(443313, 102, '2015-03-15 00:37:06.000000', 'consum', 0.0218, 'lps'),
	(443314, 102, '2015-03-15 00:37:07.000000', 'consum', 0.0213, 'lps'),
	(443315, 102, '2015-03-15 00:37:08.000000', 'consum', 0.0219, 'lps'),
	(443316, 102, '2015-03-15 00:37:09.000000', 'consum', 0.0210, 'lps'),
	(443317, 102, '2015-03-15 00:37:10.000000', 'consum', 0.0219, 'lps'),
	(443318, 102, '2015-03-15 00:37:11.000000', 'consum', 0.0221, 'lps'),
	(443319, 102, '2015-03-15 00:37:12.000000', 'consum', 0.0219, 'lps'),
	(443320, 102, '2015-03-15 00:37:13.000000', 'consum', 0.0222, 'lps'),
	(443321, 102, '2015-03-15 00:37:14.000000', 'consum', 0.0210, 'lps'),
	(443322, 102, '2015-03-15 00:37:15.000000', 'consum', 0.0227, 'lps'),
	(443323, 102, '2015-03-15 00:37:16.000000', 'consum', 0.0224, 'lps'),
	(443324, 102, '2015-03-15 00:37:17.000000', 'consum', 0.0227, 'lps'),
	(443325, 102, '2015-03-15 00:37:18.000000', 'consum', 0.0221, 'lps'),
	(443326, 102, '2015-03-15 00:37:19.000000', 'consum', 0.0211, 'lps'),
	(443327, 102, '2015-03-15 00:37:20.000000', 'consum', 0.0220, 'lps'),
	(443328, 102, '2015-03-15 00:37:21.000000', 'consum', 0.0223, 'lps'),
	(443329, 102, '2015-03-15 00:37:22.000000', 'consum', 0.0210, 'lps'),
	(443330, 102, '2015-03-15 00:37:23.000000', 'consum', 0.0225, 'lps'),
	(443331, 102, '2015-03-15 00:37:24.000000', 'consum', 0.0215, 'lps'),
	(443332, 102, '2015-03-15 00:37:25.000000', 'consum', 0.0224, 'lps'),
	(443333, 102, '2015-03-15 00:37:26.000000', 'consum', 0.0212, 'lps'),
	(443334, 102, '2015-03-15 00:37:27.000000', 'consum', 0.0216, 'lps'),
	(443335, 102, '2015-03-15 00:37:28.000000', 'consum', 0.0216, 'lps'),
	(443336, 102, '2015-03-15 00:37:29.000000', 'consum', 0.0222, 'lps'),
	(443337, 102, '2015-03-15 00:37:30.000000', 'consum', 0.0217, 'lps'),
	(443338, 102, '2015-03-15 00:37:31.000000', 'consum', 0.0210, 'lps'),
	(443339, 102, '2015-03-15 00:37:32.000000', 'consum', 0.0224, 'lps'),
	(443340, 102, '2015-03-15 00:37:33.000000', 'consum', 0.0227, 'lps'),
	(443341, 102, '2015-03-15 00:37:34.000000', 'consum', 0.0218, 'lps'),
	(443342, 102, '2015-03-15 00:37:35.000000', 'consum', 0.0216, 'lps'),
	(443343, 102, '2015-03-15 00:37:36.000000', 'consum', 0.0216, 'lps'),
	(443344, 102, '2015-03-15 00:37:37.000000', 'consum', 0.0222, 'lps'),
	(443345, 102, '2015-03-15 00:37:38.000000', 'consum', 0.0218, 'lps'),
	(443346, 102, '2015-03-15 00:37:39.000000', 'consum', 0.0214, 'lps'),
	(443347, 102, '2015-03-15 00:37:40.000000', 'consum', 0.0225, 'lps'),
	(443348, 102, '2015-03-15 00:37:41.000000', 'consum', 0.0218, 'lps'),
	(443349, 102, '2015-03-15 00:37:42.000000', 'consum', 0.0225, 'lps'),
	(443350, 102, '2015-03-15 00:37:43.000000', 'consum', 0.0225, 'lps'),
	(443351, 102, '2015-03-15 00:37:44.000000', 'consum', 0.0222, 'lps'),
	(443352, 102, '2015-03-15 00:37:45.000000', 'consum', 0.0224, 'lps'),
	(443353, 102, '2015-03-15 00:37:46.000000', 'consum', 0.0227, 'lps'),
	(443354, 102, '2015-03-15 00:37:47.000000', 'consum', 0.0220, 'lps'),
	(443355, 102, '2015-03-15 00:37:48.000000', 'consum', 0.0227, 'lps'),
	(443356, 102, '2015-03-15 00:37:49.000000', 'consum', 0.0227, 'lps'),
	(443357, 102, '2015-03-15 00:37:50.000000', 'consum', 0.0210, 'lps'),
	(443358, 102, '2015-03-15 00:37:51.000000', 'consum', 0.0214, 'lps'),
	(443359, 102, '2015-03-15 00:37:52.000000', 'consum', 0.0212, 'lps'),
	(443360, 102, '2015-03-15 00:37:53.000000', 'consum', 0.0224, 'lps'),
	(443361, 102, '2015-03-15 00:37:54.000000', 'consum', 0.0224, 'lps'),
	(443362, 102, '2015-03-15 00:37:55.000000', 'consum', 0.0220, 'lps'),
	(443363, 102, '2015-03-15 00:37:56.000000', 'consum', 0.0216, 'lps'),
	(443364, 102, '2015-03-15 00:37:57.000000', 'consum', 0.0213, 'lps'),
	(443365, 102, '2015-03-15 00:37:58.000000', 'consum', 0.0223, 'lps'),
	(443366, 102, '2015-03-15 00:37:59.000000', 'consum', 0.0212, 'lps'),
	(443367, 102, '2015-03-15 00:38:00.000000', 'consum', 0.0220, 'lps'),
	(443368, 102, '2015-03-15 00:38:01.000000', 'consum', 0.0219, 'lps'),
	(443369, 102, '2015-03-15 00:38:02.000000', 'consum', 0.0225, 'lps'),
	(443370, 102, '2015-03-15 00:38:03.000000', 'consum', 0.0224, 'lps'),
	(443371, 102, '2015-03-15 00:38:04.000000', 'consum', 0.0217, 'lps'),
	(443372, 102, '2015-03-15 00:38:05.000000', 'consum', 0.0221, 'lps'),
	(443373, 102, '2015-03-15 00:38:06.000000', 'consum', 0.0227, 'lps'),
	(443374, 102, '2015-03-15 00:38:07.000000', 'consum', 0.0225, 'lps'),
	(443375, 102, '2015-03-15 00:38:08.000000', 'consum', 0.0216, 'lps'),
	(443376, 102, '2015-03-15 00:38:09.000000', 'consum', 0.0216, 'lps'),
	(443377, 102, '2015-03-15 00:38:10.000000', 'consum', 0.0222, 'lps'),
	(443378, 102, '2015-03-15 00:38:11.000000', 'consum', 0.0216, 'lps'),
	(443379, 102, '2015-03-15 00:38:12.000000', 'consum', 0.0222, 'lps'),
	(443380, 102, '2015-03-15 00:38:13.000000', 'consum', 0.0215, 'lps'),
	(443381, 102, '2015-03-15 00:38:14.000000', 'consum', 0.0220, 'lps'),
	(443382, 102, '2015-03-15 00:38:15.000000', 'consum', 0.0225, 'lps'),
	(443383, 102, '2015-03-15 00:38:16.000000', 'consum', 0.0221, 'lps'),
	(443384, 102, '2015-03-15 00:38:17.000000', 'consum', 0.0222, 'lps'),
	(443385, 102, '2015-03-15 00:38:18.000000', 'consum', 0.0218, 'lps'),
	(443386, 102, '2015-03-15 00:38:19.000000', 'consum', 0.0214, 'lps'),
	(443387, 102, '2015-03-15 00:38:20.000000', 'consum', 0.0226, 'lps'),
	(443388, 102, '2015-03-15 00:38:21.000000', 'consum', 0.0224, 'lps'),
	(443389, 102, '2015-03-15 00:38:22.000000', 'consum', 0.0215, 'lps'),
	(443390, 102, '2015-03-15 00:38:23.000000', 'consum', 0.0212, 'lps'),
	(443391, 102, '2015-03-15 00:38:24.000000', 'consum', 0.0223, 'lps'),
	(443392, 102, '2015-03-15 00:38:25.000000', 'consum', 0.0216, 'lps'),
	(443393, 102, '2015-03-15 00:38:26.000000', 'consum', 0.0218, 'lps'),
	(443394, 102, '2015-03-15 00:38:27.000000', 'consum', 0.0216, 'lps'),
	(443395, 102, '2015-03-15 00:38:28.000000', 'consum', 0.0215, 'lps'),
	(443396, 102, '2015-03-15 00:38:29.000000', 'consum', 0.0217, 'lps'),
	(443397, 102, '2015-03-15 00:38:30.000000', 'consum', 0.0214, 'lps'),
	(443398, 102, '2015-03-15 00:38:31.000000', 'consum', 0.0226, 'lps'),
	(443399, 102, '2015-03-15 00:38:32.000000', 'consum', 0.0225, 'lps'),
	(443400, 102, '2015-03-15 00:38:33.000000', 'consum', 0.0218, 'lps'),
	(443401, 102, '2015-03-15 00:38:34.000000', 'consum', 0.0226, 'lps'),
	(443402, 102, '2015-03-15 00:38:35.000000', 'consum', 0.0210, 'lps'),
	(443403, 102, '2015-03-15 00:38:36.000000', 'consum', 0.0217, 'lps'),
	(443404, 102, '2015-03-15 00:38:37.000000', 'consum', 0.0227, 'lps'),
	(443405, 102, '2015-03-15 00:38:38.000000', 'consum', 0.0222, 'lps'),
	(443406, 102, '2015-03-15 00:38:39.000000', 'consum', 0.0219, 'lps'),
	(443407, 102, '2015-03-15 00:38:40.000000', 'consum', 0.0219, 'lps'),
	(443408, 102, '2015-03-15 00:38:41.000000', 'consum', 0.0227, 'lps'),
	(443409, 102, '2015-03-15 00:38:42.000000', 'consum', 0.0215, 'lps'),
	(443410, 102, '2015-03-15 00:38:43.000000', 'consum', 0.0219, 'lps'),
	(443411, 102, '2015-03-15 00:38:44.000000', 'consum', 0.0225, 'lps'),
	(443412, 102, '2015-03-15 00:38:45.000000', 'consum', 0.0221, 'lps'),
	(443413, 102, '2015-03-15 00:38:46.000000', 'consum', 0.0219, 'lps'),
	(443414, 102, '2015-03-15 00:38:47.000000', 'consum', 0.0225, 'lps'),
	(443415, 102, '2015-03-15 00:38:48.000000', 'consum', 0.0220, 'lps'),
	(443416, 102, '2015-03-15 00:38:49.000000', 'consum', 0.0216, 'lps'),
	(443417, 102, '2015-03-15 00:38:50.000000', 'consum', 0.0227, 'lps'),
	(443418, 102, '2015-03-15 00:38:51.000000', 'consum', 0.0227, 'lps'),
	(443419, 102, '2015-03-15 00:38:52.000000', 'consum', 0.0224, 'lps'),
	(443420, 102, '2015-03-15 00:38:53.000000', 'consum', 0.0213, 'lps'),
	(443421, 102, '2015-03-15 00:38:54.000000', 'consum', 0.0221, 'lps'),
	(443422, 102, '2015-03-15 00:38:55.000000', 'consum', 0.0218, 'lps'),
	(443423, 102, '2015-03-15 00:38:56.000000', 'consum', 0.0218, 'lps'),
	(443424, 102, '2015-03-15 00:38:57.000000', 'consum', 0.0210, 'lps'),
	(443425, 102, '2015-03-15 00:38:58.000000', 'consum', 0.0220, 'lps'),
	(443426, 102, '2015-03-15 00:38:59.000000', 'consum', 0.0227, 'lps'),
	(443427, 102, '2015-03-15 00:39:00.000000', 'consum', 0.0210, 'lps'),
	(443428, 102, '2015-03-15 00:39:01.000000', 'consum', 0.0216, 'lps'),
	(443429, 102, '2015-03-15 00:39:02.000000', 'consum', 0.0219, 'lps'),
	(443430, 102, '2015-03-15 00:39:03.000000', 'consum', 0.0223, 'lps'),
	(443431, 102, '2015-03-15 00:39:04.000000', 'consum', 0.0210, 'lps'),
	(443432, 102, '2015-03-15 00:39:05.000000', 'consum', 0.0226, 'lps'),
	(443433, 102, '2015-03-15 00:39:06.000000', 'consum', 0.0219, 'lps'),
	(443434, 102, '2015-03-15 00:39:07.000000', 'consum', 0.0224, 'lps'),
	(443435, 102, '2015-03-15 00:39:08.000000', 'consum', 0.0217, 'lps'),
	(443436, 102, '2015-03-15 00:39:09.000000', 'consum', 0.0221, 'lps'),
	(443437, 102, '2015-03-15 00:39:10.000000', 'consum', 0.0210, 'lps'),
	(443438, 102, '2015-03-15 00:39:11.000000', 'consum', 0.0215, 'lps'),
	(443439, 102, '2015-03-15 00:39:12.000000', 'consum', 0.0217, 'lps'),
	(443440, 102, '2015-03-15 00:39:13.000000', 'consum', 0.0211, 'lps'),
	(443441, 102, '2015-03-15 00:39:14.000000', 'consum', 0.0214, 'lps'),
	(443442, 102, '2015-03-15 00:39:15.000000', 'consum', 0.0210, 'lps'),
	(443443, 102, '2015-03-15 00:39:16.000000', 'consum', 0.0215, 'lps'),
	(443444, 102, '2015-03-15 00:39:17.000000', 'consum', 0.0220, 'lps'),
	(443445, 102, '2015-03-15 00:39:18.000000', 'consum', 0.0224, 'lps'),
	(443446, 102, '2015-03-15 00:39:19.000000', 'consum', 0.0218, 'lps'),
	(443447, 102, '2015-03-15 00:39:20.000000', 'consum', 0.0224, 'lps'),
	(443448, 102, '2015-03-15 00:39:21.000000', 'consum', 0.0221, 'lps'),
	(443449, 102, '2015-03-15 00:39:22.000000', 'consum', 0.0225, 'lps'),
	(443450, 102, '2015-03-15 00:39:23.000000', 'consum', 0.0217, 'lps'),
	(443451, 102, '2015-03-15 00:39:24.000000', 'consum', 0.0219, 'lps'),
	(443452, 102, '2015-03-15 00:39:25.000000', 'consum', 0.0215, 'lps'),
	(443453, 102, '2015-03-15 00:39:26.000000', 'consum', 0.0227, 'lps'),
	(443454, 102, '2015-03-15 00:39:27.000000', 'consum', 0.0210, 'lps'),
	(443455, 102, '2015-03-15 00:39:28.000000', 'consum', 0.0211, 'lps'),
	(443456, 102, '2015-03-15 00:39:29.000000', 'consum', 0.0217, 'lps'),
	(443457, 102, '2015-03-15 00:39:30.000000', 'consum', 0.0223, 'lps'),
	(443458, 102, '2015-03-15 00:39:31.000000', 'consum', 0.0220, 'lps'),
	(443459, 102, '2015-03-15 00:39:32.000000', 'consum', 0.0220, 'lps'),
	(443460, 102, '2015-03-15 00:39:33.000000', 'consum', 0.0215, 'lps'),
	(443461, 102, '2015-03-15 00:39:34.000000', 'consum', 0.0221, 'lps'),
	(443462, 102, '2015-03-15 00:39:35.000000', 'consum', 0.0217, 'lps'),
	(443463, 102, '2015-03-15 00:39:36.000000', 'consum', 0.0212, 'lps'),
	(443464, 102, '2015-03-15 00:39:37.000000', 'consum', 0.0218, 'lps'),
	(443465, 102, '2015-03-15 00:39:38.000000', 'consum', 0.0210, 'lps'),
	(443466, 102, '2015-03-15 00:39:39.000000', 'consum', 0.0220, 'lps'),
	(443467, 102, '2015-03-15 00:39:40.000000', 'consum', 0.0223, 'lps'),
	(443468, 102, '2015-03-15 00:39:41.000000', 'consum', 0.0212, 'lps'),
	(443469, 102, '2015-03-15 00:39:42.000000', 'consum', 0.0217, 'lps'),
	(443470, 102, '2015-03-15 00:39:43.000000', 'consum', 0.0220, 'lps'),
	(443471, 102, '2015-03-15 00:39:44.000000', 'consum', 0.0224, 'lps'),
	(443472, 102, '2015-03-15 00:39:45.000000', 'consum', 0.0211, 'lps'),
	(443473, 102, '2015-03-15 00:39:46.000000', 'consum', 0.0213, 'lps'),
	(443474, 102, '2015-03-15 00:39:47.000000', 'consum', 0.0222, 'lps'),
	(443475, 102, '2015-03-15 00:39:48.000000', 'consum', 0.0226, 'lps'),
	(443476, 102, '2015-03-15 00:39:49.000000', 'consum', 0.0219, 'lps'),
	(443477, 102, '2015-03-15 00:39:50.000000', 'consum', 0.0227, 'lps'),
	(443478, 102, '2015-03-15 00:39:51.000000', 'consum', 0.0211, 'lps'),
	(443479, 102, '2015-03-15 00:39:52.000000', 'consum', 0.0222, 'lps'),
	(443480, 102, '2015-03-15 00:39:53.000000', 'consum', 0.0212, 'lps'),
	(443481, 102, '2015-03-15 00:39:54.000000', 'consum', 0.0219, 'lps'),
	(443482, 102, '2015-03-15 00:39:55.000000', 'consum', 0.0216, 'lps'),
	(443483, 102, '2015-03-15 00:39:56.000000', 'consum', 0.0211, 'lps'),
	(443484, 102, '2015-03-15 00:39:57.000000', 'consum', 0.0215, 'lps'),
	(443485, 102, '2015-03-15 00:39:58.000000', 'consum', 0.0215, 'lps'),
	(443486, 102, '2015-03-15 00:39:59.000000', 'consum', 0.0220, 'lps'),
	(443487, 102, '2015-03-15 00:40:00.000000', 'consum', 0.0210, 'lps'),
	(443488, 102, '2015-03-15 00:40:01.000000', 'consum', 0.0218, 'lps'),
	(443489, 102, '2015-03-15 00:40:02.000000', 'consum', 0.0212, 'lps'),
	(443490, 102, '2015-03-15 00:40:03.000000', 'consum', 0.0215, 'lps'),
	(443491, 102, '2015-03-15 00:40:04.000000', 'consum', 0.0212, 'lps'),
	(443492, 102, '2015-03-15 00:40:05.000000', 'consum', 0.0225, 'lps'),
	(443493, 102, '2015-03-15 00:40:06.000000', 'consum', 0.0224, 'lps'),
	(443494, 102, '2015-03-15 00:40:07.000000', 'consum', 0.0220, 'lps'),
	(443495, 102, '2015-03-15 00:40:08.000000', 'consum', 0.0216, 'lps'),
	(443496, 102, '2015-03-15 00:40:09.000000', 'consum', 0.0213, 'lps'),
	(443497, 102, '2015-03-15 00:40:10.000000', 'consum', 0.0225, 'lps'),
	(443498, 102, '2015-03-15 00:40:11.000000', 'consum', 0.0221, 'lps'),
	(443499, 102, '2015-03-15 00:40:12.000000', 'consum', 0.0223, 'lps'),
	(443500, 102, '2015-03-15 00:40:13.000000', 'consum', 0.0225, 'lps'),
	(443501, 102, '2015-03-15 00:40:14.000000', 'consum', 0.0225, 'lps'),
	(443502, 102, '2015-03-15 00:40:15.000000', 'consum', 0.0225, 'lps'),
	(443503, 102, '2015-03-15 00:40:16.000000', 'consum', 0.0223, 'lps'),
	(443504, 102, '2015-03-15 00:40:17.000000', 'consum', 0.0210, 'lps'),
	(443505, 102, '2015-03-15 00:40:18.000000', 'consum', 0.0225, 'lps'),
	(443506, 102, '2015-03-15 00:40:19.000000', 'consum', 0.0217, 'lps'),
	(443507, 102, '2015-03-15 00:40:20.000000', 'consum', 0.0216, 'lps'),
	(443508, 102, '2015-03-15 00:40:21.000000', 'consum', 0.0219, 'lps'),
	(443509, 102, '2015-03-15 00:40:22.000000', 'consum', 0.0220, 'lps'),
	(443510, 102, '2015-03-15 00:40:23.000000', 'consum', 0.0217, 'lps'),
	(443511, 102, '2015-03-15 00:40:24.000000', 'consum', 0.0213, 'lps'),
	(443512, 102, '2015-03-15 00:40:25.000000', 'consum', 0.0222, 'lps'),
	(443513, 102, '2015-03-15 00:40:26.000000', 'consum', 0.0227, 'lps'),
	(443514, 102, '2015-03-15 00:40:27.000000', 'consum', 0.0223, 'lps'),
	(443515, 102, '2015-03-15 00:40:28.000000', 'consum', 0.0223, 'lps'),
	(443516, 102, '2015-03-15 00:40:29.000000', 'consum', 0.0219, 'lps'),
	(443517, 102, '2015-03-15 00:40:30.000000', 'consum', 0.0216, 'lps'),
	(443518, 102, '2015-03-15 00:40:31.000000', 'consum', 0.0214, 'lps'),
	(443519, 102, '2015-03-15 00:40:32.000000', 'consum', 0.0211, 'lps'),
	(443520, 102, '2015-03-15 00:40:33.000000', 'consum', 0.0221, 'lps'),
	(443521, 102, '2015-03-15 00:40:34.000000', 'consum', 0.0210, 'lps'),
	(443522, 102, '2015-03-15 00:40:35.000000', 'consum', 0.0212, 'lps'),
	(443523, 102, '2015-03-15 00:40:36.000000', 'consum', 0.0223, 'lps'),
	(443524, 102, '2015-03-15 00:40:37.000000', 'consum', 0.0214, 'lps'),
	(443525, 102, '2015-03-15 00:40:38.000000', 'consum', 0.0210, 'lps'),
	(443526, 102, '2015-03-15 00:40:39.000000', 'consum', 0.0217, 'lps'),
	(443527, 102, '2015-03-15 00:40:40.000000', 'consum', 0.0226, 'lps'),
	(443528, 102, '2015-03-15 00:40:41.000000', 'consum', 0.0218, 'lps'),
	(443529, 102, '2015-03-15 00:40:42.000000', 'consum', 0.0218, 'lps'),
	(443530, 102, '2015-03-15 00:40:43.000000', 'consum', 0.0211, 'lps'),
	(443531, 102, '2015-03-15 00:40:44.000000', 'consum', 0.0226, 'lps'),
	(443532, 102, '2015-03-15 00:40:45.000000', 'consum', 0.0217, 'lps'),
	(443533, 102, '2015-03-15 00:40:46.000000', 'consum', 0.0216, 'lps'),
	(443534, 102, '2015-03-15 00:40:47.000000', 'consum', 0.0220, 'lps'),
	(443535, 102, '2015-03-15 00:40:48.000000', 'consum', 0.0222, 'lps'),
	(443536, 102, '2015-03-15 00:40:49.000000', 'consum', 0.0222, 'lps'),
	(443537, 102, '2015-03-15 00:40:50.000000', 'consum', 0.0217, 'lps'),
	(443538, 102, '2015-03-15 00:40:51.000000', 'consum', 0.0212, 'lps'),
	(443539, 102, '2015-03-15 00:40:52.000000', 'consum', 0.0214, 'lps'),
	(443540, 102, '2015-03-15 00:40:53.000000', 'consum', 0.0227, 'lps'),
	(443541, 102, '2015-03-15 00:40:54.000000', 'consum', 0.0211, 'lps'),
	(443542, 102, '2015-03-15 00:40:55.000000', 'consum', 0.0217, 'lps'),
	(443543, 102, '2015-03-15 00:40:56.000000', 'consum', 0.0227, 'lps'),
	(443544, 102, '2015-03-15 00:40:57.000000', 'consum', 0.0219, 'lps'),
	(443545, 102, '2015-03-15 00:40:58.000000', 'consum', 0.0224, 'lps'),
	(443546, 102, '2015-03-15 00:40:59.000000', 'consum', 0.0218, 'lps'),
	(443547, 102, '2015-03-15 00:41:00.000000', 'consum', 0.0226, 'lps'),
	(443548, 102, '2015-03-15 00:41:01.000000', 'consum', 0.0211, 'lps'),
	(443549, 102, '2015-03-15 00:41:02.000000', 'consum', 0.0220, 'lps'),
	(443550, 102, '2015-03-15 00:41:03.000000', 'consum', 0.0225, 'lps'),
	(443551, 102, '2015-03-15 00:41:04.000000', 'consum', 0.0219, 'lps'),
	(443552, 102, '2015-03-15 00:41:05.000000', 'consum', 0.0211, 'lps'),
	(443553, 102, '2015-03-15 00:41:06.000000', 'consum', 0.0223, 'lps'),
	(443554, 102, '2015-03-15 00:41:07.000000', 'consum', 0.0217, 'lps'),
	(443555, 102, '2015-03-15 00:41:08.000000', 'consum', 0.0227, 'lps'),
	(443556, 102, '2015-03-15 00:41:09.000000', 'consum', 0.0218, 'lps'),
	(443557, 102, '2015-03-15 00:41:10.000000', 'consum', 0.0219, 'lps'),
	(443558, 102, '2015-03-15 00:41:11.000000', 'consum', 0.0215, 'lps'),
	(443559, 102, '2015-03-15 00:41:12.000000', 'consum', 0.0224, 'lps'),
	(443560, 102, '2015-03-15 00:41:13.000000', 'consum', 0.0213, 'lps'),
	(443561, 102, '2015-03-15 00:41:14.000000', 'consum', 0.0219, 'lps'),
	(443562, 102, '2015-03-15 00:41:15.000000', 'consum', 0.0227, 'lps'),
	(443563, 102, '2015-03-15 00:41:16.000000', 'consum', 0.0214, 'lps'),
	(443564, 102, '2015-03-15 00:41:17.000000', 'consum', 0.0219, 'lps'),
	(443565, 102, '2015-03-15 00:41:18.000000', 'consum', 0.0222, 'lps'),
	(443566, 102, '2015-03-15 00:41:19.000000', 'consum', 0.0210, 'lps'),
	(443567, 102, '2015-03-15 00:41:20.000000', 'consum', 0.0212, 'lps'),
	(443568, 102, '2015-03-15 00:41:21.000000', 'consum', 0.0217, 'lps'),
	(443569, 102, '2015-03-15 00:41:22.000000', 'consum', 0.0224, 'lps'),
	(443570, 102, '2015-03-15 00:41:23.000000', 'consum', 0.0224, 'lps'),
	(443571, 102, '2015-03-15 00:41:24.000000', 'consum', 0.0220, 'lps'),
	(443572, 102, '2015-03-15 00:41:25.000000', 'consum', 0.0216, 'lps'),
	(443573, 102, '2015-03-15 00:41:26.000000', 'consum', 0.0213, 'lps'),
	(443574, 102, '2015-03-15 00:41:27.000000', 'consum', 0.0224, 'lps'),
	(443575, 102, '2015-03-15 00:41:28.000000', 'consum', 0.0220, 'lps'),
	(443576, 102, '2015-03-15 00:41:29.000000', 'consum', 0.0217, 'lps'),
	(443577, 102, '2015-03-15 00:41:30.000000', 'consum', 0.0214, 'lps'),
	(443578, 102, '2015-03-15 00:41:31.000000', 'consum', 0.0210, 'lps'),
	(443579, 102, '2015-03-15 00:41:32.000000', 'consum', 0.0218, 'lps'),
	(443580, 102, '2015-03-15 00:41:33.000000', 'consum', 0.0215, 'lps'),
	(443581, 102, '2015-03-15 00:41:34.000000', 'consum', 0.0210, 'lps'),
	(443582, 102, '2015-03-15 00:41:35.000000', 'consum', 0.0214, 'lps'),
	(443583, 102, '2015-03-15 00:41:36.000000', 'consum', 0.0212, 'lps'),
	(443584, 102, '2015-03-15 00:41:37.000000', 'consum', 0.0210, 'lps'),
	(443585, 102, '2015-03-15 00:41:38.000000', 'consum', 0.0221, 'lps'),
	(443586, 102, '2015-03-15 00:41:39.000000', 'consum', 0.0213, 'lps'),
	(443587, 102, '2015-03-15 00:41:40.000000', 'consum', 0.0212, 'lps'),
	(443588, 102, '2015-03-15 00:41:41.000000', 'consum', 0.0227, 'lps'),
	(443589, 102, '2015-03-15 00:41:42.000000', 'consum', 0.0219, 'lps'),
	(443590, 102, '2015-03-15 00:41:43.000000', 'consum', 0.0224, 'lps'),
	(443591, 102, '2015-03-15 00:41:44.000000', 'consum', 0.0215, 'lps'),
	(443592, 102, '2015-03-15 00:41:45.000000', 'consum', 0.0212, 'lps'),
	(443593, 102, '2015-03-15 00:41:46.000000', 'consum', 0.0224, 'lps'),
	(443594, 102, '2015-03-15 00:41:47.000000', 'consum', 0.0222, 'lps'),
	(443595, 102, '2015-03-15 00:41:48.000000', 'consum', 0.0210, 'lps'),
	(443596, 102, '2015-03-15 00:41:49.000000', 'consum', 0.0227, 'lps'),
	(443597, 102, '2015-03-15 00:41:50.000000', 'consum', 0.0223, 'lps'),
	(443598, 102, '2015-03-15 00:41:51.000000', 'consum', 0.0224, 'lps'),
	(443599, 102, '2015-03-15 00:41:52.000000', 'consum', 0.0223, 'lps'),
	(443600, 102, '2015-03-15 00:41:53.000000', 'consum', 0.0218, 'lps'),
	(443601, 102, '2015-03-15 00:41:54.000000', 'consum', 0.0227, 'lps'),
	(443602, 102, '2015-03-15 00:41:55.000000', 'consum', 0.0218, 'lps'),
	(443603, 102, '2015-03-15 00:41:56.000000', 'consum', 0.0217, 'lps'),
	(443604, 102, '2015-03-15 00:41:57.000000', 'consum', 0.0220, 'lps'),
	(443605, 102, '2015-03-15 00:41:58.000000', 'consum', 0.0224, 'lps'),
	(443606, 102, '2015-03-15 00:41:59.000000', 'consum', 0.0213, 'lps'),
	(443607, 102, '2015-03-15 00:42:00.000000', 'consum', 0.0222, 'lps'),
	(443608, 102, '2015-03-15 00:42:01.000000', 'consum', 0.0224, 'lps'),
	(443609, 102, '2015-03-15 00:42:02.000000', 'consum', 0.0227, 'lps'),
	(443610, 102, '2015-03-15 00:42:03.000000', 'consum', 0.0215, 'lps'),
	(443611, 102, '2015-03-15 00:42:04.000000', 'consum', 0.0223, 'lps'),
	(443612, 102, '2015-03-15 00:42:05.000000', 'consum', 0.0224, 'lps'),
	(443613, 102, '2015-03-15 00:42:06.000000', 'consum', 0.0225, 'lps'),
	(443614, 102, '2015-03-15 00:42:07.000000', 'consum', 0.0225, 'lps'),
	(443615, 102, '2015-03-15 00:42:08.000000', 'consum', 0.0223, 'lps'),
	(443616, 102, '2015-03-15 00:42:09.000000', 'consum', 0.0213, 'lps'),
	(443617, 102, '2015-03-15 00:42:10.000000', 'consum', 0.0221, 'lps'),
	(443618, 102, '2015-03-15 00:42:11.000000', 'consum', 0.0223, 'lps'),
	(443619, 102, '2015-03-15 00:42:12.000000', 'consum', 0.0221, 'lps'),
	(443620, 102, '2015-03-15 00:42:13.000000', 'consum', 0.0210, 'lps'),
	(443621, 102, '2015-03-15 00:42:14.000000', 'consum', 0.0214, 'lps'),
	(443622, 102, '2015-03-15 00:42:15.000000', 'consum', 0.0211, 'lps'),
	(443623, 102, '2015-03-15 00:42:16.000000', 'consum', 0.0221, 'lps'),
	(443624, 102, '2015-03-15 00:42:17.000000', 'consum', 0.0211, 'lps'),
	(443625, 102, '2015-03-15 00:42:18.000000', 'consum', 0.0218, 'lps'),
	(443626, 102, '2015-03-15 00:42:19.000000', 'consum', 0.0212, 'lps'),
	(443627, 102, '2015-03-15 00:42:20.000000', 'consum', 0.0213, 'lps'),
	(443628, 102, '2015-03-15 00:42:21.000000', 'consum', 0.0220, 'lps'),
	(443629, 102, '2015-03-15 00:42:22.000000', 'consum', 0.0217, 'lps'),
	(443630, 102, '2015-03-15 00:42:23.000000', 'consum', 0.0216, 'lps'),
	(443631, 102, '2015-03-15 00:42:24.000000', 'consum', 0.0220, 'lps'),
	(443632, 102, '2015-03-15 00:42:25.000000', 'consum', 0.0225, 'lps'),
	(443633, 102, '2015-03-15 00:42:26.000000', 'consum', 0.0219, 'lps'),
	(443634, 102, '2015-03-15 00:42:27.000000', 'consum', 0.0212, 'lps'),
	(443635, 102, '2015-03-15 00:42:28.000000', 'consum', 0.0227, 'lps'),
	(443636, 102, '2015-03-15 00:42:29.000000', 'consum', 0.0217, 'lps'),
	(443637, 102, '2015-03-15 00:42:30.000000', 'consum', 0.0213, 'lps'),
	(443638, 102, '2015-03-15 00:42:31.000000', 'consum', 0.0222, 'lps'),
	(443639, 102, '2015-03-15 00:42:32.000000', 'consum', 0.0226, 'lps'),
	(443640, 102, '2015-03-15 00:42:33.000000', 'consum', 0.0217, 'lps'),
	(443641, 102, '2015-03-15 00:42:34.000000', 'consum', 0.0217, 'lps'),
	(443642, 102, '2015-03-15 00:42:35.000000', 'consum', 0.0223, 'lps'),
	(443643, 102, '2015-03-15 00:42:36.000000', 'consum', 0.0217, 'lps'),
	(443644, 102, '2015-03-15 00:42:37.000000', 'consum', 0.0227, 'lps'),
	(443645, 102, '2015-03-15 00:42:38.000000', 'consum', 0.0220, 'lps'),
	(443646, 102, '2015-03-15 00:42:39.000000', 'consum', 0.0210, 'lps'),
	(443647, 102, '2015-03-15 00:42:40.000000', 'consum', 0.0218, 'lps'),
	(443648, 102, '2015-03-15 00:42:41.000000', 'consum', 0.0212, 'lps'),
	(443649, 102, '2015-03-15 00:42:42.000000', 'consum', 0.0213, 'lps'),
	(443650, 102, '2015-03-15 00:42:43.000000', 'consum', 0.0223, 'lps'),
	(443651, 102, '2015-03-15 00:42:44.000000', 'consum', 0.0212, 'lps'),
	(443652, 102, '2015-03-15 00:42:45.000000', 'consum', 0.0217, 'lps'),
	(443653, 102, '2015-03-15 00:42:46.000000', 'consum', 0.0223, 'lps'),
	(443654, 102, '2015-03-15 00:42:47.000000', 'consum', 0.0219, 'lps'),
	(443655, 102, '2015-03-15 00:42:48.000000', 'consum', 0.0217, 'lps'),
	(443656, 102, '2015-03-15 00:42:49.000000', 'consum', 0.0217, 'lps'),
	(443657, 102, '2015-03-15 00:42:50.000000', 'consum', 0.0224, 'lps'),
	(443658, 102, '2015-03-15 00:42:51.000000', 'consum', 0.0225, 'lps'),
	(443659, 102, '2015-03-15 00:42:52.000000', 'consum', 0.0226, 'lps'),
	(443660, 102, '2015-03-15 00:42:53.000000', 'consum', 0.0226, 'lps'),
	(443661, 102, '2015-03-15 00:42:54.000000', 'consum', 0.0226, 'lps'),
	(443662, 102, '2015-03-15 00:42:55.000000', 'consum', 0.0222, 'lps'),
	(443663, 102, '2015-03-15 00:42:56.000000', 'consum', 0.0224, 'lps'),
	(443664, 102, '2015-03-15 00:42:57.000000', 'consum', 0.0225, 'lps'),
	(443665, 102, '2015-03-15 00:42:58.000000', 'consum', 0.0226, 'lps'),
	(443666, 102, '2015-03-15 00:42:59.000000', 'consum', 0.0211, 'lps'),
	(443667, 102, '2015-03-15 00:43:00.000000', 'consum', 0.0222, 'lps'),
	(443668, 102, '2015-03-15 00:43:01.000000', 'consum', 0.0212, 'lps'),
	(443669, 102, '2015-03-15 00:43:02.000000', 'consum', 0.0220, 'lps'),
	(443670, 102, '2015-03-15 00:43:03.000000', 'consum', 0.0221, 'lps'),
	(443671, 102, '2015-03-15 00:43:04.000000', 'consum', 0.0214, 'lps'),
	(443672, 102, '2015-03-15 00:43:05.000000', 'consum', 0.0218, 'lps'),
	(443673, 102, '2015-03-15 00:43:06.000000', 'consum', 0.0219, 'lps'),
	(443674, 102, '2015-03-15 00:43:07.000000', 'consum', 0.0213, 'lps'),
	(443675, 102, '2015-03-15 00:43:08.000000', 'consum', 0.0219, 'lps'),
	(443676, 102, '2015-03-15 00:43:09.000000', 'consum', 0.0227, 'lps'),
	(443677, 102, '2015-03-15 00:43:10.000000', 'consum', 0.0214, 'lps'),
	(443678, 102, '2015-03-15 00:43:11.000000', 'consum', 0.0216, 'lps'),
	(443679, 102, '2015-03-15 00:43:12.000000', 'consum', 0.0212, 'lps'),
	(443680, 102, '2015-03-15 00:43:13.000000', 'consum', 0.0221, 'lps'),
	(443681, 102, '2015-03-15 00:43:14.000000', 'consum', 0.0224, 'lps'),
	(443682, 102, '2015-03-15 00:43:15.000000', 'consum', 0.0211, 'lps'),
	(443683, 102, '2015-03-15 00:43:16.000000', 'consum', 0.0210, 'lps'),
	(443684, 102, '2015-03-15 00:43:17.000000', 'consum', 0.0225, 'lps'),
	(443685, 102, '2015-03-15 00:43:18.000000', 'consum', 0.0212, 'lps'),
	(443686, 102, '2015-03-15 00:43:19.000000', 'consum', 0.0212, 'lps'),
	(443687, 102, '2015-03-15 00:43:20.000000', 'consum', 0.0216, 'lps'),
	(443688, 102, '2015-03-15 00:43:21.000000', 'consum', 0.0216, 'lps'),
	(443689, 102, '2015-03-15 00:43:22.000000', 'consum', 0.0223, 'lps'),
	(443690, 102, '2015-03-15 00:43:23.000000', 'consum', 0.0222, 'lps'),
	(443691, 102, '2015-03-15 00:43:24.000000', 'consum', 0.0212, 'lps'),
	(443692, 102, '2015-03-15 00:43:25.000000', 'consum', 0.0221, 'lps'),
	(443693, 102, '2015-03-15 00:43:26.000000', 'consum', 0.0223, 'lps'),
	(443694, 102, '2015-03-15 00:43:27.000000', 'consum', 0.0223, 'lps'),
	(443695, 102, '2015-03-15 00:43:28.000000', 'consum', 0.0220, 'lps'),
	(443696, 102, '2015-03-15 00:43:29.000000', 'consum', 0.0222, 'lps'),
	(443697, 102, '2015-03-15 00:43:30.000000', 'consum', 0.0221, 'lps'),
	(443698, 102, '2015-03-15 00:43:31.000000', 'consum', 0.0214, 'lps'),
	(443699, 102, '2015-03-15 00:43:32.000000', 'consum', 0.0212, 'lps'),
	(443700, 102, '2015-03-15 00:43:33.000000', 'consum', 0.0211, 'lps'),
	(443701, 102, '2015-03-15 00:43:34.000000', 'consum', 0.0210, 'lps'),
	(443702, 102, '2015-03-15 00:43:35.000000', 'consum', 0.0224, 'lps'),
	(443703, 102, '2015-03-15 00:43:36.000000', 'consum', 0.0210, 'lps'),
	(443704, 102, '2015-03-15 00:43:37.000000', 'consum', 0.0224, 'lps'),
	(443705, 102, '2015-03-15 00:43:38.000000', 'consum', 0.0224, 'lps'),
	(443706, 102, '2015-03-15 00:43:39.000000', 'consum', 0.0223, 'lps'),
	(443707, 102, '2015-03-15 00:43:40.000000', 'consum', 0.0213, 'lps'),
	(443708, 102, '2015-03-15 00:43:41.000000', 'consum', 0.0224, 'lps'),
	(443709, 102, '2015-03-15 00:43:42.000000', 'consum', 0.0217, 'lps'),
	(443710, 102, '2015-03-15 00:43:43.000000', 'consum', 0.0222, 'lps'),
	(443711, 102, '2015-03-15 00:43:44.000000', 'consum', 0.0215, 'lps'),
	(443712, 102, '2015-03-15 00:43:45.000000', 'consum', 0.0217, 'lps'),
	(443713, 102, '2015-03-15 00:43:46.000000', 'consum', 0.0211, 'lps'),
	(443714, 102, '2015-03-15 00:43:47.000000', 'consum', 0.0213, 'lps'),
	(443715, 102, '2015-03-15 00:43:48.000000', 'consum', 0.0224, 'lps'),
	(443716, 102, '2015-03-15 00:43:49.000000', 'consum', 0.0216, 'lps'),
	(443717, 102, '2015-03-15 00:43:50.000000', 'consum', 0.0217, 'lps'),
	(443718, 102, '2015-03-15 00:43:51.000000', 'consum', 0.0211, 'lps'),
	(443719, 102, '2015-03-15 00:43:52.000000', 'consum', 0.0212, 'lps'),
	(443720, 102, '2015-03-15 00:43:53.000000', 'consum', 0.0215, 'lps'),
	(443721, 102, '2015-03-15 00:43:54.000000', 'consum', 0.0213, 'lps'),
	(443722, 102, '2015-03-15 00:43:55.000000', 'consum', 0.0210, 'lps'),
	(443723, 102, '2015-03-15 00:43:56.000000', 'consum', 0.0222, 'lps'),
	(443724, 102, '2015-03-15 00:43:57.000000', 'consum', 0.0214, 'lps'),
	(443725, 102, '2015-03-15 00:43:58.000000', 'consum', 0.0213, 'lps'),
	(443726, 102, '2015-03-15 00:43:59.000000', 'consum', 0.0215, 'lps'),
	(443727, 102, '2015-03-15 00:44:00.000000', 'consum', 0.0226, 'lps'),
	(443728, 102, '2015-03-15 00:44:01.000000', 'consum', 0.0222, 'lps'),
	(443729, 102, '2015-03-15 00:44:02.000000', 'consum', 0.0222, 'lps'),
	(443730, 102, '2015-03-15 00:44:03.000000', 'consum', 0.0219, 'lps'),
	(443731, 102, '2015-03-15 00:44:04.000000', 'consum', 0.0216, 'lps'),
	(443732, 102, '2015-03-15 00:44:05.000000', 'consum', 0.0213, 'lps'),
	(443733, 102, '2015-03-15 00:44:06.000000', 'consum', 0.0227, 'lps'),
	(443734, 102, '2015-03-15 00:44:07.000000', 'consum', 0.0216, 'lps'),
	(443735, 102, '2015-03-15 00:44:08.000000', 'consum', 0.0223, 'lps'),
	(443736, 102, '2015-03-15 00:44:09.000000', 'consum', 0.0223, 'lps'),
	(443737, 102, '2015-03-15 00:44:10.000000', 'consum', 0.0220, 'lps'),
	(443738, 102, '2015-03-15 00:44:11.000000', 'consum', 0.0221, 'lps'),
	(443739, 102, '2015-03-15 00:44:12.000000', 'consum', 0.0215, 'lps'),
	(443740, 102, '2015-03-15 00:44:13.000000', 'consum', 0.0221, 'lps'),
	(443741, 102, '2015-03-15 00:44:14.000000', 'consum', 0.0215, 'lps'),
	(443742, 102, '2015-03-15 00:44:15.000000', 'consum', 0.0221, 'lps'),
	(443743, 102, '2015-03-15 00:44:16.000000', 'consum', 0.0213, 'lps'),
	(443744, 102, '2015-03-15 00:44:17.000000', 'consum', 0.0213, 'lps'),
	(443745, 102, '2015-03-15 00:44:18.000000', 'consum', 0.0217, 'lps'),
	(443746, 102, '2015-03-15 00:44:19.000000', 'consum', 0.0217, 'lps'),
	(443747, 102, '2015-03-15 00:44:20.000000', 'consum', 0.0226, 'lps'),
	(443748, 102, '2015-03-15 00:44:21.000000', 'consum', 0.0214, 'lps'),
	(443749, 102, '2015-03-15 00:44:22.000000', 'consum', 0.0221, 'lps'),
	(443750, 102, '2015-03-15 00:44:23.000000', 'consum', 0.0216, 'lps'),
	(443751, 102, '2015-03-15 00:44:24.000000', 'consum', 0.0225, 'lps'),
	(443752, 102, '2015-03-15 00:44:25.000000', 'consum', 0.0212, 'lps'),
	(443753, 102, '2015-03-15 00:44:26.000000', 'consum', 0.0213, 'lps'),
	(443754, 102, '2015-03-15 00:44:27.000000', 'consum', 0.0220, 'lps'),
	(443755, 102, '2015-03-15 00:44:28.000000', 'consum', 0.0214, 'lps'),
	(443756, 102, '2015-03-15 00:44:29.000000', 'consum', 0.0221, 'lps'),
	(443757, 102, '2015-03-15 00:44:30.000000', 'consum', 0.0217, 'lps'),
	(443758, 102, '2015-03-15 00:44:31.000000', 'consum', 0.0212, 'lps'),
	(443759, 102, '2015-03-15 00:44:32.000000', 'consum', 0.0218, 'lps'),
	(443760, 102, '2015-03-15 00:44:33.000000', 'consum', 0.0227, 'lps'),
	(443761, 102, '2015-03-15 00:44:34.000000', 'consum', 0.0215, 'lps'),
	(443762, 102, '2015-03-15 00:44:35.000000', 'consum', 0.0223, 'lps'),
	(443763, 102, '2015-03-15 00:44:36.000000', 'consum', 0.0222, 'lps'),
	(443764, 102, '2015-03-15 00:44:37.000000', 'consum', 0.0214, 'lps'),
	(443765, 102, '2015-03-15 00:44:38.000000', 'consum', 0.0212, 'lps'),
	(443766, 102, '2015-03-15 00:44:39.000000', 'consum', 0.0210, 'lps'),
	(443767, 102, '2015-03-15 00:44:40.000000', 'consum', 0.0222, 'lps'),
	(443768, 102, '2015-03-15 00:44:41.000000', 'consum', 0.0218, 'lps'),
	(443769, 102, '2015-03-15 00:44:42.000000', 'consum', 0.0213, 'lps'),
	(443770, 102, '2015-03-15 00:44:43.000000', 'consum', 0.0219, 'lps'),
	(443771, 102, '2015-03-15 00:44:44.000000', 'consum', 0.0227, 'lps'),
	(443772, 102, '2015-03-15 00:44:45.000000', 'consum', 0.0218, 'lps'),
	(443773, 102, '2015-03-15 00:44:46.000000', 'consum', 0.0216, 'lps'),
	(443774, 102, '2015-03-15 00:44:47.000000', 'consum', 0.0217, 'lps'),
	(443775, 102, '2015-03-15 00:44:48.000000', 'consum', 0.0211, 'lps'),
	(443776, 102, '2015-03-15 00:44:49.000000', 'consum', 0.0213, 'lps'),
	(443777, 102, '2015-03-15 00:44:50.000000', 'consum', 0.0220, 'lps'),
	(443778, 102, '2015-03-15 00:44:51.000000', 'consum', 0.0215, 'lps'),
	(443779, 102, '2015-03-15 00:44:52.000000', 'consum', 0.0224, 'lps'),
	(443780, 102, '2015-03-15 00:44:53.000000', 'consum', 0.0211, 'lps'),
	(443781, 102, '2015-03-15 00:44:54.000000', 'consum', 0.0211, 'lps'),
	(443782, 102, '2015-03-15 00:44:55.000000', 'consum', 0.0212, 'lps'),
	(443783, 102, '2015-03-15 00:44:56.000000', 'consum', 0.0217, 'lps'),
	(443784, 102, '2015-03-15 00:44:57.000000', 'consum', 0.0222, 'lps'),
	(443785, 102, '2015-03-15 00:44:58.000000', 'consum', 0.0212, 'lps'),
	(443786, 102, '2015-03-15 00:44:59.000000', 'consum', 0.0221, 'lps'),
	(443787, 102, '2015-03-15 00:45:00.000000', 'consum', 0.0224, 'lps'),
	(443788, 102, '2015-03-15 00:45:01.000000', 'consum', 0.0212, 'lps'),
	(443789, 102, '2015-03-15 00:45:02.000000', 'consum', 0.0215, 'lps'),
	(443790, 102, '2015-03-15 00:45:03.000000', 'consum', 0.0212, 'lps'),
	(443791, 102, '2015-03-15 00:45:04.000000', 'consum', 0.0222, 'lps'),
	(443792, 102, '2015-03-15 00:45:05.000000', 'consum', 0.0210, 'lps'),
	(443793, 102, '2015-03-15 00:45:06.000000', 'consum', 0.0210, 'lps'),
	(443794, 102, '2015-03-15 00:45:07.000000', 'consum', 0.0213, 'lps'),
	(443795, 102, '2015-03-15 00:45:08.000000', 'consum', 0.0223, 'lps'),
	(443796, 102, '2015-03-15 00:45:09.000000', 'consum', 0.0214, 'lps'),
	(443797, 102, '2015-03-15 00:45:10.000000', 'consum', 0.0211, 'lps'),
	(443798, 102, '2015-03-15 00:45:11.000000', 'consum', 0.0221, 'lps'),
	(443799, 102, '2015-03-15 00:45:12.000000', 'consum', 0.0226, 'lps'),
	(443800, 102, '2015-03-15 00:45:13.000000', 'consum', 0.0221, 'lps'),
	(443801, 102, '2015-03-15 00:45:14.000000', 'consum', 0.0219, 'lps'),
	(443802, 102, '2015-03-15 00:45:15.000000', 'consum', 0.0220, 'lps'),
	(443803, 102, '2015-03-15 00:45:16.000000', 'consum', 0.0215, 'lps'),
	(443804, 102, '2015-03-15 00:45:17.000000', 'consum', 0.0225, 'lps'),
	(443805, 102, '2015-03-15 00:45:18.000000', 'consum', 0.0218, 'lps'),
	(443806, 102, '2015-03-15 00:45:19.000000', 'consum', 0.0220, 'lps'),
	(443807, 102, '2015-03-15 00:45:20.000000', 'consum', 0.0222, 'lps'),
	(443808, 102, '2015-03-15 00:45:21.000000', 'consum', 0.0219, 'lps'),
	(443809, 102, '2015-03-15 00:45:22.000000', 'consum', 0.0222, 'lps'),
	(443810, 102, '2015-03-15 00:45:23.000000', 'consum', 0.0223, 'lps'),
	(443811, 102, '2015-03-15 00:45:24.000000', 'consum', 0.0222, 'lps'),
	(443812, 102, '2015-03-15 00:45:25.000000', 'consum', 0.0216, 'lps'),
	(443813, 102, '2015-03-15 00:45:26.000000', 'consum', 0.0221, 'lps'),
	(443814, 102, '2015-03-15 00:45:27.000000', 'consum', 0.0213, 'lps'),
	(443815, 102, '2015-03-15 00:45:28.000000', 'consum', 0.0227, 'lps'),
	(443816, 102, '2015-03-15 00:45:29.000000', 'consum', 0.0213, 'lps'),
	(443817, 102, '2015-03-15 00:45:30.000000', 'consum', 0.0211, 'lps'),
	(443818, 102, '2015-03-15 00:45:31.000000', 'consum', 0.0224, 'lps'),
	(443819, 102, '2015-03-15 00:45:32.000000', 'consum', 0.0225, 'lps'),
	(443820, 102, '2015-03-15 00:45:33.000000', 'consum', 0.0225, 'lps'),
	(443821, 102, '2015-03-15 00:45:34.000000', 'consum', 0.0223, 'lps'),
	(443822, 102, '2015-03-15 00:45:35.000000', 'consum', 0.0212, 'lps'),
	(443823, 102, '2015-03-15 00:45:36.000000', 'consum', 0.0217, 'lps'),
	(443824, 102, '2015-03-15 00:45:37.000000', 'consum', 0.0221, 'lps'),
	(443825, 102, '2015-03-15 00:45:38.000000', 'consum', 0.0210, 'lps'),
	(443826, 102, '2015-03-15 00:45:39.000000', 'consum', 0.0215, 'lps'),
	(443827, 102, '2015-03-15 00:45:40.000000', 'consum', 0.0215, 'lps'),
	(443828, 102, '2015-03-15 00:45:41.000000', 'consum', 0.0221, 'lps'),
	(443829, 102, '2015-03-15 00:45:42.000000', 'consum', 0.0213, 'lps'),
	(443830, 102, '2015-03-15 00:45:43.000000', 'consum', 0.0212, 'lps'),
	(443831, 102, '2015-03-15 00:45:44.000000', 'consum', 0.0211, 'lps'),
	(443832, 102, '2015-03-15 00:45:45.000000', 'consum', 0.0212, 'lps'),
	(443833, 102, '2015-03-15 00:45:46.000000', 'consum', 0.0215, 'lps'),
	(443834, 102, '2015-03-15 00:45:47.000000', 'consum', 0.0212, 'lps'),
	(443835, 102, '2015-03-15 00:45:48.000000', 'consum', 0.0222, 'lps'),
	(443836, 102, '2015-03-15 00:45:49.000000', 'consum', 0.0210, 'lps'),
	(443837, 102, '2015-03-15 00:45:50.000000', 'consum', 0.0212, 'lps'),
	(443838, 102, '2015-03-15 00:45:51.000000', 'consum', 0.0221, 'lps'),
	(443839, 102, '2015-03-15 00:45:52.000000', 'consum', 0.0223, 'lps'),
	(443840, 102, '2015-03-15 00:45:53.000000', 'consum', 0.0224, 'lps'),
	(443841, 102, '2015-03-15 00:45:54.000000', 'consum', 0.0225, 'lps'),
	(443842, 102, '2015-03-15 00:45:55.000000', 'consum', 0.0227, 'lps'),
	(443843, 102, '2015-03-15 00:45:56.000000', 'consum', 0.0212, 'lps'),
	(443844, 102, '2015-03-15 00:45:57.000000', 'consum', 0.0223, 'lps'),
	(443845, 102, '2015-03-15 00:45:58.000000', 'consum', 0.0215, 'lps'),
	(443846, 102, '2015-03-15 00:45:59.000000', 'consum', 0.0216, 'lps'),
	(443847, 102, '2015-03-15 00:46:00.000000', 'consum', 0.0226, 'lps'),
	(443848, 102, '2015-03-15 00:46:01.000000', 'consum', 0.0217, 'lps'),
	(443849, 102, '2015-03-15 00:46:02.000000', 'consum', 0.0215, 'lps'),
	(443850, 102, '2015-03-15 00:46:03.000000', 'consum', 0.0214, 'lps'),
	(443851, 102, '2015-03-15 00:46:04.000000', 'consum', 0.0214, 'lps'),
	(443852, 102, '2015-03-15 00:46:05.000000', 'consum', 0.0222, 'lps'),
	(443853, 102, '2015-03-15 00:46:06.000000', 'consum', 0.0220, 'lps'),
	(443854, 102, '2015-03-15 00:46:07.000000', 'consum', 0.0225, 'lps'),
	(443855, 102, '2015-03-15 00:46:08.000000', 'consum', 0.0219, 'lps'),
	(443856, 102, '2015-03-15 00:46:09.000000', 'consum', 0.0212, 'lps'),
	(443857, 102, '2015-03-15 00:46:10.000000', 'consum', 0.0210, 'lps'),
	(443858, 102, '2015-03-15 00:46:11.000000', 'consum', 0.0221, 'lps'),
	(443859, 102, '2015-03-15 00:46:12.000000', 'consum', 0.0214, 'lps'),
	(443860, 102, '2015-03-15 00:46:13.000000', 'consum', 0.0216, 'lps'),
	(443861, 102, '2015-03-15 00:46:14.000000', 'consum', 0.0227, 'lps'),
	(443862, 102, '2015-03-15 00:46:15.000000', 'consum', 0.0224, 'lps'),
	(443863, 102, '2015-03-15 00:46:16.000000', 'consum', 0.0211, 'lps'),
	(443864, 102, '2015-03-15 00:46:17.000000', 'consum', 0.0210, 'lps'),
	(443865, 102, '2015-03-15 00:46:18.000000', 'consum', 0.0227, 'lps'),
	(443866, 102, '2015-03-15 00:46:19.000000', 'consum', 0.0223, 'lps'),
	(443867, 102, '2015-03-15 00:46:20.000000', 'consum', 0.0223, 'lps'),
	(443868, 102, '2015-03-15 00:46:21.000000', 'consum', 0.0221, 'lps'),
	(443869, 102, '2015-03-15 00:46:22.000000', 'consum', 0.0224, 'lps'),
	(443870, 102, '2015-03-15 00:46:23.000000', 'consum', 0.0214, 'lps'),
	(443871, 102, '2015-03-15 00:46:24.000000', 'consum', 0.0224, 'lps'),
	(443872, 102, '2015-03-15 00:46:25.000000', 'consum', 0.0216, 'lps'),
	(443873, 102, '2015-03-15 00:46:26.000000', 'consum', 0.0216, 'lps'),
	(443874, 102, '2015-03-15 00:46:27.000000', 'consum', 0.0221, 'lps'),
	(443875, 102, '2015-03-15 00:46:28.000000', 'consum', 0.0212, 'lps'),
	(443876, 102, '2015-03-15 00:46:29.000000', 'consum', 0.0224, 'lps'),
	(443877, 102, '2015-03-15 00:46:30.000000', 'consum', 0.0220, 'lps'),
	(443878, 102, '2015-03-15 00:46:31.000000', 'consum', 0.0220, 'lps'),
	(443879, 102, '2015-03-15 00:46:32.000000', 'consum', 0.0211, 'lps'),
	(443880, 102, '2015-03-15 00:46:33.000000', 'consum', 0.0220, 'lps'),
	(443881, 102, '2015-03-15 00:46:34.000000', 'consum', 0.0223, 'lps'),
	(443882, 102, '2015-03-15 00:46:35.000000', 'consum', 0.0227, 'lps'),
	(443883, 102, '2015-03-15 00:46:36.000000', 'consum', 0.0221, 'lps'),
	(443884, 102, '2015-03-15 00:46:37.000000', 'consum', 0.0213, 'lps'),
	(443885, 102, '2015-03-15 00:46:38.000000', 'consum', 0.0213, 'lps'),
	(443886, 102, '2015-03-15 00:46:39.000000', 'consum', 0.0215, 'lps'),
	(443887, 102, '2015-03-15 00:46:40.000000', 'consum', 0.0210, 'lps'),
	(443888, 102, '2015-03-15 00:46:41.000000', 'consum', 0.0212, 'lps'),
	(443889, 102, '2015-03-15 00:46:42.000000', 'consum', 0.0219, 'lps'),
	(443890, 102, '2015-03-15 00:46:43.000000', 'consum', 0.0214, 'lps'),
	(443891, 102, '2015-03-15 00:46:44.000000', 'consum', 0.0224, 'lps'),
	(443892, 102, '2015-03-15 00:46:45.000000', 'consum', 0.0214, 'lps'),
	(443893, 102, '2015-03-15 00:46:46.000000', 'consum', 0.0223, 'lps'),
	(443894, 102, '2015-03-15 00:46:47.000000', 'consum', 0.0210, 'lps'),
	(443895, 102, '2015-03-15 00:46:48.000000', 'consum', 0.0226, 'lps'),
	(443896, 102, '2015-03-15 00:46:49.000000', 'consum', 0.0218, 'lps'),
	(443897, 102, '2015-03-15 00:46:50.000000', 'consum', 0.0219, 'lps'),
	(443898, 102, '2015-03-15 00:46:51.000000', 'consum', 0.0216, 'lps'),
	(443899, 102, '2015-03-15 00:46:52.000000', 'consum', 0.0210, 'lps'),
	(443900, 102, '2015-03-15 00:46:53.000000', 'consum', 0.0214, 'lps'),
	(443901, 102, '2015-03-15 00:46:54.000000', 'consum', 0.0213, 'lps'),
	(443902, 102, '2015-03-15 00:46:55.000000', 'consum', 0.0211, 'lps'),
	(443903, 102, '2015-03-15 00:46:56.000000', 'consum', 0.0224, 'lps'),
	(443904, 102, '2015-03-15 00:46:57.000000', 'consum', 0.0226, 'lps'),
	(443905, 102, '2015-03-15 00:46:58.000000', 'consum', 0.0213, 'lps'),
	(443906, 102, '2015-03-15 00:46:59.000000', 'consum', 0.0213, 'lps'),
	(443907, 102, '2015-03-15 00:47:00.000000', 'consum', 0.0215, 'lps'),
	(443908, 102, '2015-03-15 00:47:01.000000', 'consum', 0.0211, 'lps'),
	(443909, 102, '2015-03-15 00:47:02.000000', 'consum', 0.0217, 'lps'),
	(443910, 102, '2015-03-15 00:47:03.000000', 'consum', 0.0226, 'lps'),
	(443911, 102, '2015-03-15 00:47:04.000000', 'consum', 0.0216, 'lps'),
	(443912, 102, '2015-03-15 00:47:05.000000', 'consum', 0.0210, 'lps'),
	(443913, 102, '2015-03-15 00:47:06.000000', 'consum', 0.0211, 'lps'),
	(443914, 102, '2015-03-15 00:47:07.000000', 'consum', 0.0213, 'lps'),
	(443915, 102, '2015-03-15 00:47:08.000000', 'consum', 0.0223, 'lps'),
	(443916, 102, '2015-03-15 00:47:09.000000', 'consum', 0.0214, 'lps'),
	(443917, 102, '2015-03-15 00:47:10.000000', 'consum', 0.0227, 'lps'),
	(443918, 102, '2015-03-15 00:47:11.000000', 'consum', 0.0212, 'lps'),
	(443919, 102, '2015-03-15 00:47:12.000000', 'consum', 0.0224, 'lps'),
	(443920, 102, '2015-03-15 00:47:13.000000', 'consum', 0.0222, 'lps'),
	(443921, 102, '2015-03-15 00:47:14.000000', 'consum', 0.0226, 'lps'),
	(443922, 102, '2015-03-15 00:47:15.000000', 'consum', 0.0219, 'lps'),
	(443923, 102, '2015-03-15 00:47:16.000000', 'consum', 0.0224, 'lps'),
	(443924, 102, '2015-03-15 00:47:17.000000', 'consum', 0.0221, 'lps'),
	(443925, 102, '2015-03-15 00:47:18.000000', 'consum', 0.0221, 'lps'),
	(443926, 102, '2015-03-15 00:47:19.000000', 'consum', 0.0214, 'lps'),
	(443927, 102, '2015-03-15 00:47:20.000000', 'consum', 0.0217, 'lps'),
	(443928, 102, '2015-03-15 00:47:21.000000', 'consum', 0.0216, 'lps'),
	(443929, 102, '2015-03-15 00:47:22.000000', 'consum', 0.0219, 'lps'),
	(443930, 102, '2015-03-15 00:47:23.000000', 'consum', 0.0220, 'lps'),
	(443931, 102, '2015-03-15 00:47:24.000000', 'consum', 0.0214, 'lps'),
	(443932, 102, '2015-03-15 00:47:25.000000', 'consum', 0.0218, 'lps'),
	(443933, 102, '2015-03-15 00:47:26.000000', 'consum', 0.0219, 'lps'),
	(443934, 102, '2015-03-15 00:47:27.000000', 'consum', 0.0216, 'lps'),
	(443935, 102, '2015-03-15 00:47:28.000000', 'consum', 0.0213, 'lps'),
	(443936, 102, '2015-03-15 00:47:29.000000', 'consum', 0.0226, 'lps'),
	(443937, 102, '2015-03-15 00:47:30.000000', 'consum', 0.0211, 'lps'),
	(443938, 102, '2015-03-15 00:47:31.000000', 'consum', 0.0220, 'lps'),
	(443939, 102, '2015-03-15 00:47:32.000000', 'consum', 0.0221, 'lps'),
	(443940, 102, '2015-03-15 00:47:33.000000', 'consum', 0.0220, 'lps'),
	(443941, 102, '2015-03-15 00:47:34.000000', 'consum', 0.0225, 'lps'),
	(443942, 102, '2015-03-15 00:47:35.000000', 'consum', 0.0219, 'lps'),
	(443943, 102, '2015-03-15 00:47:36.000000', 'consum', 0.0211, 'lps'),
	(443944, 102, '2015-03-15 00:47:37.000000', 'consum', 0.0223, 'lps'),
	(443945, 102, '2015-03-15 00:47:38.000000', 'consum', 0.0219, 'lps'),
	(443946, 102, '2015-03-15 00:47:39.000000', 'consum', 0.0217, 'lps'),
	(443947, 102, '2015-03-15 00:47:40.000000', 'consum', 0.0218, 'lps'),
	(443948, 102, '2015-03-15 00:47:41.000000', 'consum', 0.0210, 'lps'),
	(443949, 102, '2015-03-15 00:47:42.000000', 'consum', 0.0224, 'lps'),
	(443950, 102, '2015-03-15 00:47:43.000000', 'consum', 0.0210, 'lps'),
	(443951, 102, '2015-03-15 00:47:44.000000', 'consum', 0.0221, 'lps'),
	(443952, 102, '2015-03-15 00:47:45.000000', 'consum', 0.0212, 'lps'),
	(443953, 102, '2015-03-15 00:47:46.000000', 'consum', 0.0223, 'lps'),
	(443954, 102, '2015-03-15 00:47:47.000000', 'consum', 0.0216, 'lps'),
	(443955, 102, '2015-03-15 00:47:48.000000', 'consum', 0.0219, 'lps'),
	(443956, 102, '2015-03-15 00:47:49.000000', 'consum', 0.0219, 'lps'),
	(443957, 102, '2015-03-15 00:47:50.000000', 'consum', 0.0210, 'lps'),
	(443958, 102, '2015-03-15 00:47:51.000000', 'consum', 0.0218, 'lps'),
	(443959, 102, '2015-03-15 00:47:52.000000', 'consum', 0.0218, 'lps'),
	(443960, 102, '2015-03-15 00:47:53.000000', 'consum', 0.0224, 'lps'),
	(443961, 102, '2015-03-15 00:47:54.000000', 'consum', 0.0221, 'lps'),
	(443962, 102, '2015-03-15 00:47:55.000000', 'consum', 0.0224, 'lps'),
	(443963, 102, '2015-03-15 00:47:56.000000', 'consum', 0.0213, 'lps'),
	(443964, 102, '2015-03-15 00:47:57.000000', 'consum', 0.0220, 'lps'),
	(443965, 102, '2015-03-15 00:47:58.000000', 'consum', 0.0213, 'lps'),
	(443966, 102, '2015-03-15 00:47:59.000000', 'consum', 0.0215, 'lps'),
	(443967, 102, '2015-03-15 00:48:00.000000', 'consum', 0.0225, 'lps'),
	(443968, 102, '2015-03-15 00:48:01.000000', 'consum', 0.0215, 'lps'),
	(443969, 102, '2015-03-15 00:48:02.000000', 'consum', 0.0212, 'lps'),
	(443970, 102, '2015-03-15 00:48:03.000000', 'consum', 0.0222, 'lps'),
	(443971, 102, '2015-03-15 00:48:04.000000', 'consum', 0.0227, 'lps'),
	(443972, 102, '2015-03-15 00:48:05.000000', 'consum', 0.0224, 'lps'),
	(443973, 102, '2015-03-15 00:48:06.000000', 'consum', 0.0213, 'lps'),
	(443974, 102, '2015-03-15 00:48:07.000000', 'consum', 0.0220, 'lps'),
	(443975, 102, '2015-03-15 00:48:08.000000', 'consum', 0.0217, 'lps'),
	(443976, 102, '2015-03-15 00:48:09.000000', 'consum', 0.0212, 'lps'),
	(443977, 102, '2015-03-15 00:48:10.000000', 'consum', 0.0218, 'lps'),
	(443978, 102, '2015-03-15 00:48:11.000000', 'consum', 0.0211, 'lps'),
	(443979, 102, '2015-03-15 00:48:12.000000', 'consum', 0.0226, 'lps'),
	(443980, 102, '2015-03-15 00:48:13.000000', 'consum', 0.0214, 'lps'),
	(443981, 102, '2015-03-15 00:48:14.000000', 'consum', 0.0221, 'lps'),
	(443982, 102, '2015-03-15 00:48:15.000000', 'consum', 0.0216, 'lps'),
	(443983, 102, '2015-03-15 00:48:16.000000', 'consum', 0.0227, 'lps'),
	(443984, 102, '2015-03-15 00:48:17.000000', 'consum', 0.0222, 'lps'),
	(443985, 102, '2015-03-15 00:48:18.000000', 'consum', 0.0222, 'lps'),
	(443986, 102, '2015-03-15 00:48:19.000000', 'consum', 0.0215, 'lps'),
	(443987, 102, '2015-03-15 00:48:20.000000', 'consum', 0.0219, 'lps'),
	(443988, 102, '2015-03-15 00:48:21.000000', 'consum', 0.0220, 'lps'),
	(443989, 102, '2015-03-15 00:48:22.000000', 'consum', 0.0217, 'lps'),
	(443990, 102, '2015-03-15 00:48:23.000000', 'consum', 0.0215, 'lps'),
	(443991, 102, '2015-03-15 00:48:24.000000', 'consum', 0.0216, 'lps'),
	(443992, 102, '2015-03-15 00:48:25.000000', 'consum', 0.0223, 'lps'),
	(443993, 102, '2015-03-15 00:48:26.000000', 'consum', 0.0223, 'lps'),
	(443994, 102, '2015-03-15 00:48:27.000000', 'consum', 0.0217, 'lps'),
	(443995, 102, '2015-03-15 00:48:28.000000', 'consum', 0.0226, 'lps'),
	(443996, 102, '2015-03-15 00:48:29.000000', 'consum', 0.0215, 'lps'),
	(443997, 102, '2015-03-15 00:48:30.000000', 'consum', 0.0222, 'lps'),
	(443998, 102, '2015-03-15 00:48:31.000000', 'consum', 0.0219, 'lps'),
	(443999, 102, '2015-03-15 00:48:32.000000', 'consum', 0.0222, 'lps'),
	(444000, 102, '2015-03-15 00:48:33.000000', 'consum', 0.0223, 'lps'),
	(444001, 102, '2015-03-15 00:48:34.000000', 'consum', 0.0224, 'lps'),
	(444002, 102, '2015-03-15 00:48:35.000000', 'consum', 0.0224, 'lps'),
	(444003, 102, '2015-03-15 00:48:36.000000', 'consum', 0.0220, 'lps'),
	(444004, 102, '2015-03-15 00:48:37.000000', 'consum', 0.0219, 'lps'),
	(444005, 102, '2015-03-15 00:48:38.000000', 'consum', 0.0225, 'lps'),
	(444006, 102, '2015-03-15 00:48:39.000000', 'consum', 0.0223, 'lps'),
	(444007, 102, '2015-03-15 00:48:40.000000', 'consum', 0.0214, 'lps'),
	(444008, 102, '2015-03-15 00:48:41.000000', 'consum', 0.0226, 'lps'),
	(444009, 102, '2015-03-15 00:48:42.000000', 'consum', 0.0226, 'lps'),
	(444010, 102, '2015-03-15 00:48:43.000000', 'consum', 0.0224, 'lps'),
	(444011, 102, '2015-03-15 00:48:44.000000', 'consum', 0.0216, 'lps'),
	(444012, 102, '2015-03-15 00:48:45.000000', 'consum', 0.0216, 'lps'),
	(444013, 102, '2015-03-15 00:48:46.000000', 'consum', 0.0222, 'lps'),
	(444014, 102, '2015-03-15 00:48:47.000000', 'consum', 0.0217, 'lps'),
	(444015, 102, '2015-03-15 00:48:48.000000', 'consum', 0.0211, 'lps'),
	(444016, 102, '2015-03-15 00:48:49.000000', 'consum', 0.0210, 'lps'),
	(444017, 102, '2015-03-15 00:48:50.000000', 'consum', 0.0227, 'lps'),
	(444018, 102, '2015-03-15 00:48:51.000000', 'consum', 0.0223, 'lps'),
	(444019, 102, '2015-03-15 00:48:52.000000', 'consum', 0.0225, 'lps'),
	(444020, 102, '2015-03-15 00:48:53.000000', 'consum', 0.0211, 'lps'),
	(444021, 102, '2015-03-15 00:48:54.000000', 'consum', 0.0226, 'lps'),
	(444022, 102, '2015-03-15 00:48:55.000000', 'consum', 0.0212, 'lps'),
	(444023, 102, '2015-03-15 00:48:56.000000', 'consum', 0.0210, 'lps'),
	(444024, 102, '2015-03-15 00:48:57.000000', 'consum', 0.0221, 'lps'),
	(444025, 102, '2015-03-15 00:48:58.000000', 'consum', 0.0213, 'lps'),
	(444026, 102, '2015-03-15 00:48:59.000000', 'consum', 0.0212, 'lps'),
	(444027, 102, '2015-03-15 00:49:00.000000', 'consum', 0.0226, 'lps'),
	(444028, 102, '2015-03-15 00:49:01.000000', 'consum', 0.0215, 'lps'),
	(444029, 102, '2015-03-15 00:49:02.000000', 'consum', 0.0221, 'lps'),
	(444030, 102, '2015-03-15 00:49:03.000000', 'consum', 0.0215, 'lps'),
	(444031, 102, '2015-03-15 00:49:04.000000', 'consum', 0.0220, 'lps'),
	(444032, 102, '2015-03-15 00:49:05.000000', 'consum', 0.0227, 'lps'),
	(444033, 102, '2015-03-15 00:49:06.000000', 'consum', 0.0214, 'lps'),
	(444034, 102, '2015-03-15 00:49:07.000000', 'consum', 0.0215, 'lps'),
	(444035, 102, '2015-03-15 00:49:08.000000', 'consum', 0.0222, 'lps'),
	(444036, 102, '2015-03-15 00:49:09.000000', 'consum', 0.0219, 'lps'),
	(444037, 102, '2015-03-15 00:49:10.000000', 'consum', 0.0220, 'lps'),
	(444038, 102, '2015-03-15 00:49:11.000000', 'consum', 0.0215, 'lps'),
	(444039, 102, '2015-03-15 00:49:12.000000', 'consum', 0.0223, 'lps'),
	(444040, 102, '2015-03-15 00:49:13.000000', 'consum', 0.0227, 'lps'),
	(444041, 102, '2015-03-15 00:49:14.000000', 'consum', 0.0217, 'lps'),
	(444042, 102, '2015-03-15 00:49:15.000000', 'consum', 0.0215, 'lps'),
	(444043, 102, '2015-03-15 00:49:16.000000', 'consum', 0.0213, 'lps'),
	(444044, 102, '2015-03-15 00:49:17.000000', 'consum', 0.0212, 'lps'),
	(444045, 102, '2015-03-15 00:49:18.000000', 'consum', 0.0212, 'lps'),
	(444046, 102, '2015-03-15 00:49:19.000000', 'consum', 0.0215, 'lps'),
	(444047, 102, '2015-03-15 00:49:20.000000', 'consum', 0.0211, 'lps'),
	(444048, 102, '2015-03-15 00:49:21.000000', 'consum', 0.0216, 'lps'),
	(444049, 102, '2015-03-15 00:49:22.000000', 'consum', 0.0222, 'lps'),
	(444050, 102, '2015-03-15 00:49:23.000000', 'consum', 0.0215, 'lps'),
	(444051, 102, '2015-03-15 00:49:24.000000', 'consum', 0.0220, 'lps'),
	(444052, 102, '2015-03-15 00:49:25.000000', 'consum', 0.0226, 'lps'),
	(444053, 102, '2015-03-15 00:49:26.000000', 'consum', 0.0226, 'lps'),
	(444054, 102, '2015-03-15 00:49:27.000000', 'consum', 0.0224, 'lps'),
	(444055, 102, '2015-03-15 00:49:28.000000', 'consum', 0.0216, 'lps'),
	(444056, 102, '2015-03-15 00:49:29.000000', 'consum', 0.0216, 'lps'),
	(444057, 102, '2015-03-15 00:49:30.000000', 'consum', 0.0221, 'lps'),
	(444058, 102, '2015-03-15 00:49:31.000000', 'consum', 0.0211, 'lps'),
	(444059, 102, '2015-03-15 00:49:32.000000', 'consum', 0.0218, 'lps'),
	(444060, 102, '2015-03-15 00:49:33.000000', 'consum', 0.0212, 'lps'),
	(444061, 102, '2015-03-15 00:49:34.000000', 'consum', 0.0216, 'lps'),
	(444062, 102, '2015-03-15 00:49:35.000000', 'consum', 0.0218, 'lps'),
	(444063, 102, '2015-03-15 00:49:36.000000', 'consum', 0.0212, 'lps'),
	(444064, 102, '2015-03-15 00:49:37.000000', 'consum', 0.0214, 'lps'),
	(444065, 102, '2015-03-15 00:49:38.000000', 'consum', 0.0227, 'lps'),
	(444066, 102, '2015-03-15 00:49:39.000000', 'consum', 0.0211, 'lps'),
	(444067, 102, '2015-03-15 00:49:40.000000', 'consum', 0.0218, 'lps'),
	(444068, 102, '2015-03-15 00:49:41.000000', 'consum', 0.0212, 'lps'),
	(444069, 102, '2015-03-15 00:49:42.000000', 'consum', 0.0214, 'lps'),
	(444070, 102, '2015-03-15 00:49:43.000000', 'consum', 0.0224, 'lps'),
	(444071, 102, '2015-03-15 00:49:44.000000', 'consum', 0.0216, 'lps'),
	(444072, 102, '2015-03-15 00:49:45.000000', 'consum', 0.0216, 'lps'),
	(444073, 102, '2015-03-15 00:49:46.000000', 'consum', 0.0223, 'lps'),
	(444074, 102, '2015-03-15 00:49:47.000000', 'consum', 0.0220, 'lps'),
	(444075, 102, '2015-03-15 00:49:48.000000', 'consum', 0.0222, 'lps'),
	(444076, 102, '2015-03-15 00:49:49.000000', 'consum', 0.0221, 'lps'),
	(444077, 102, '2015-03-15 00:49:50.000000', 'consum', 0.0213, 'lps'),
	(444078, 102, '2015-03-15 00:49:51.000000', 'consum', 0.0227, 'lps'),
	(444079, 102, '2015-03-15 00:49:52.000000', 'consum', 0.0217, 'lps'),
	(444080, 102, '2015-03-15 00:49:53.000000', 'consum', 0.0211, 'lps'),
	(444081, 102, '2015-03-15 00:49:54.000000', 'consum', 0.0212, 'lps'),
	(444082, 102, '2015-03-15 00:49:55.000000', 'consum', 0.0218, 'lps'),
	(444083, 102, '2015-03-15 00:49:56.000000', 'consum', 0.0224, 'lps'),
	(444084, 102, '2015-03-15 00:49:57.000000', 'consum', 0.0224, 'lps'),
	(444085, 102, '2015-03-15 00:49:58.000000', 'consum', 0.0221, 'lps'),
	(444086, 102, '2015-03-15 00:49:59.000000', 'consum', 0.0222, 'lps'),
	(444087, 102, '2015-03-15 00:50:00.000000', 'consum', 0.0222, 'lps'),
	(444088, 102, '2015-03-15 00:50:01.000000', 'consum', 0.0213, 'lps'),
	(444089, 102, '2015-03-15 00:50:02.000000', 'consum', 0.0210, 'lps'),
	(444090, 102, '2015-03-15 00:50:03.000000', 'consum', 0.0217, 'lps'),
	(444091, 102, '2015-03-15 00:50:04.000000', 'consum', 0.0212, 'lps'),
	(444092, 102, '2015-03-15 00:50:05.000000', 'consum', 0.0217, 'lps'),
	(444093, 102, '2015-03-15 00:50:06.000000', 'consum', 0.0222, 'lps'),
	(444094, 102, '2015-03-15 00:50:07.000000', 'consum', 0.0215, 'lps'),
	(444095, 102, '2015-03-15 00:50:08.000000', 'consum', 0.0215, 'lps'),
	(444096, 102, '2015-03-15 00:50:09.000000', 'consum', 0.0221, 'lps'),
	(444097, 102, '2015-03-15 00:50:10.000000', 'consum', 0.0215, 'lps'),
	(444098, 102, '2015-03-15 00:50:11.000000', 'consum', 0.0219, 'lps'),
	(444099, 102, '2015-03-15 00:50:12.000000', 'consum', 0.0223, 'lps'),
	(444100, 102, '2015-03-15 00:50:13.000000', 'consum', 0.0212, 'lps'),
	(444101, 102, '2015-03-15 00:50:14.000000', 'consum', 0.0220, 'lps'),
	(444102, 102, '2015-03-15 00:50:15.000000', 'consum', 0.0217, 'lps'),
	(444103, 102, '2015-03-15 00:50:16.000000', 'consum', 0.0214, 'lps'),
	(444104, 102, '2015-03-15 00:50:17.000000', 'consum', 0.0227, 'lps'),
	(444105, 102, '2015-03-15 00:50:18.000000', 'consum', 0.0214, 'lps'),
	(444106, 102, '2015-03-15 00:50:19.000000', 'consum', 0.0214, 'lps'),
	(444107, 102, '2015-03-15 00:50:20.000000', 'consum', 0.0220, 'lps'),
	(444108, 102, '2015-03-15 00:50:21.000000', 'consum', 0.0213, 'lps'),
	(444109, 102, '2015-03-15 00:50:22.000000', 'consum', 0.0212, 'lps'),
	(444110, 102, '2015-03-15 00:50:23.000000', 'consum', 0.0211, 'lps'),
	(444111, 102, '2015-03-15 00:50:24.000000', 'consum', 0.0226, 'lps'),
	(444112, 102, '2015-03-15 00:50:25.000000', 'consum', 0.0219, 'lps'),
	(444113, 102, '2015-03-15 00:50:26.000000', 'consum', 0.0225, 'lps'),
	(444114, 102, '2015-03-15 00:50:27.000000', 'consum', 0.0220, 'lps'),
	(444115, 102, '2015-03-15 00:50:28.000000', 'consum', 0.0216, 'lps'),
	(444116, 102, '2015-03-15 00:50:29.000000', 'consum', 0.0212, 'lps'),
	(444117, 102, '2015-03-15 00:50:30.000000', 'consum', 0.0218, 'lps'),
	(444118, 102, '2015-03-15 00:50:31.000000', 'consum', 0.0212, 'lps'),
	(444119, 102, '2015-03-15 00:50:32.000000', 'consum', 0.0212, 'lps'),
	(444120, 102, '2015-03-15 00:50:33.000000', 'consum', 0.0215, 'lps'),
	(444121, 102, '2015-03-15 00:50:34.000000', 'consum', 0.0213, 'lps'),
	(444122, 102, '2015-03-15 00:50:35.000000', 'consum', 0.0226, 'lps'),
	(444123, 102, '2015-03-15 00:50:36.000000', 'consum', 0.0212, 'lps'),
	(444124, 102, '2015-03-15 00:50:37.000000', 'consum', 0.0227, 'lps'),
	(444125, 102, '2015-03-15 00:50:38.000000', 'consum', 0.0215, 'lps'),
	(444126, 102, '2015-03-15 00:50:39.000000', 'consum', 0.0220, 'lps'),
	(444127, 102, '2015-03-15 00:50:40.000000', 'consum', 0.0212, 'lps'),
	(444128, 102, '2015-03-15 00:50:41.000000', 'consum', 0.0226, 'lps'),
	(444129, 102, '2015-03-15 00:50:42.000000', 'consum', 0.0211, 'lps'),
	(444130, 102, '2015-03-15 00:50:43.000000', 'consum', 0.0221, 'lps'),
	(444131, 102, '2015-03-15 00:50:44.000000', 'consum', 0.0226, 'lps'),
	(444132, 102, '2015-03-15 00:50:45.000000', 'consum', 0.0221, 'lps'),
	(444133, 102, '2015-03-15 00:50:46.000000', 'consum', 0.0218, 'lps'),
	(444134, 102, '2015-03-15 00:50:47.000000', 'consum', 0.0217, 'lps'),
	(444135, 102, '2015-03-15 00:50:48.000000', 'consum', 0.0220, 'lps'),
	(444136, 102, '2015-03-15 00:50:49.000000', 'consum', 0.0224, 'lps'),
	(444137, 102, '2015-03-15 00:50:50.000000', 'consum', 0.0215, 'lps'),
	(444138, 102, '2015-03-15 00:50:51.000000', 'consum', 0.0210, 'lps'),
	(444139, 102, '2015-03-15 00:50:52.000000', 'consum', 0.0213, 'lps'),
	(444140, 102, '2015-03-15 00:50:53.000000', 'consum', 0.0225, 'lps'),
	(444141, 102, '2015-03-15 00:50:54.000000', 'consum', 0.0222, 'lps'),
	(444142, 102, '2015-03-15 00:50:55.000000', 'consum', 0.0210, 'lps'),
	(444143, 102, '2015-03-15 00:50:56.000000', 'consum', 0.0226, 'lps'),
	(444144, 102, '2015-03-15 00:50:57.000000', 'consum', 0.0221, 'lps'),
	(444145, 102, '2015-03-15 00:50:58.000000', 'consum', 0.0216, 'lps'),
	(444146, 102, '2015-03-15 00:50:59.000000', 'consum', 0.0226, 'lps'),
	(444147, 102, '2015-03-15 00:51:00.000000', 'consum', 0.0219, 'lps'),
	(444148, 102, '2015-03-15 00:51:01.000000', 'consum', 0.0225, 'lps'),
	(444149, 102, '2015-03-15 00:51:02.000000', 'consum', 0.0221, 'lps'),
	(444150, 102, '2015-03-15 00:51:03.000000', 'consum', 0.0220, 'lps'),
	(444151, 102, '2015-03-15 00:51:04.000000', 'consum', 0.0210, 'lps'),
	(444152, 102, '2015-03-15 00:51:05.000000', 'consum', 0.0218, 'lps'),
	(444153, 102, '2015-03-15 00:51:06.000000', 'consum', 0.0212, 'lps'),
	(444154, 102, '2015-03-15 00:51:07.000000', 'consum', 0.0216, 'lps'),
	(444155, 102, '2015-03-15 00:51:08.000000', 'consum', 0.0215, 'lps'),
	(444156, 102, '2015-03-15 00:51:09.000000', 'consum', 0.0217, 'lps'),
	(444157, 102, '2015-03-15 00:51:10.000000', 'consum', 0.0212, 'lps'),
	(444158, 102, '2015-03-15 00:51:11.000000', 'consum', 0.0218, 'lps'),
	(444159, 102, '2015-03-15 00:51:12.000000', 'consum', 0.0225, 'lps'),
	(444160, 102, '2015-03-15 00:51:13.000000', 'consum', 0.0226, 'lps'),
	(444161, 102, '2015-03-15 00:51:14.000000', 'consum', 0.0212, 'lps'),
	(444162, 102, '2015-03-15 00:51:15.000000', 'consum', 0.0226, 'lps'),
	(444163, 102, '2015-03-15 00:51:16.000000', 'consum', 0.0211, 'lps'),
	(444164, 102, '2015-03-15 00:51:17.000000', 'consum', 0.0224, 'lps'),
	(444165, 102, '2015-03-15 00:51:18.000000', 'consum', 0.0221, 'lps'),
	(444166, 102, '2015-03-15 00:51:19.000000', 'consum', 0.0224, 'lps'),
	(444167, 102, '2015-03-15 00:51:20.000000', 'consum', 0.0212, 'lps'),
	(444168, 102, '2015-03-15 00:51:21.000000', 'consum', 0.0214, 'lps'),
	(444169, 102, '2015-03-15 00:51:22.000000', 'consum', 0.0225, 'lps'),
	(444170, 102, '2015-03-15 00:51:23.000000', 'consum', 0.0219, 'lps'),
	(444171, 102, '2015-03-15 00:51:24.000000', 'consum', 0.0212, 'lps'),
	(444172, 102, '2015-03-15 00:51:25.000000', 'consum', 0.0211, 'lps'),
	(444173, 102, '2015-03-15 00:51:26.000000', 'consum', 0.0210, 'lps'),
	(444174, 102, '2015-03-15 00:51:27.000000', 'consum', 0.0226, 'lps'),
	(444175, 102, '2015-03-15 00:51:28.000000', 'consum', 0.0216, 'lps'),
	(444176, 102, '2015-03-15 00:51:29.000000', 'consum', 0.0214, 'lps'),
	(444177, 102, '2015-03-15 00:51:30.000000', 'consum', 0.0227, 'lps'),
	(444178, 102, '2015-03-15 00:51:31.000000', 'consum', 0.0212, 'lps'),
	(444179, 102, '2015-03-15 00:51:32.000000', 'consum', 0.0224, 'lps'),
	(444180, 102, '2015-03-15 00:51:33.000000', 'consum', 0.0220, 'lps'),
	(444181, 102, '2015-03-15 00:51:34.000000', 'consum', 0.0218, 'lps'),
	(444182, 102, '2015-03-15 00:51:35.000000', 'consum', 0.0223, 'lps'),
	(444183, 102, '2015-03-15 00:51:36.000000', 'consum', 0.0214, 'lps'),
	(444184, 102, '2015-03-15 00:51:37.000000', 'consum', 0.0211, 'lps'),
	(444185, 102, '2015-03-15 00:51:38.000000', 'consum', 0.0219, 'lps'),
	(444186, 102, '2015-03-15 00:51:39.000000', 'consum', 0.0218, 'lps'),
	(444187, 102, '2015-03-15 00:51:40.000000', 'consum', 0.0224, 'lps'),
	(444188, 102, '2015-03-15 00:51:41.000000', 'consum', 0.0221, 'lps'),
	(444189, 102, '2015-03-15 00:51:42.000000', 'consum', 0.0221, 'lps'),
	(444190, 102, '2015-03-15 00:51:43.000000', 'consum', 0.0217, 'lps'),
	(444191, 102, '2015-03-15 00:51:44.000000', 'consum', 0.0211, 'lps'),
	(444192, 102, '2015-03-15 00:51:45.000000', 'consum', 0.0215, 'lps'),
	(444193, 102, '2015-03-15 00:51:46.000000', 'consum', 0.0212, 'lps'),
	(444194, 102, '2015-03-15 00:51:47.000000', 'consum', 0.0223, 'lps'),
	(444195, 102, '2015-03-15 00:51:48.000000', 'consum', 0.0216, 'lps'),
	(444196, 102, '2015-03-15 00:51:49.000000', 'consum', 0.0219, 'lps'),
	(444197, 102, '2015-03-15 00:51:50.000000', 'consum', 0.0218, 'lps'),
	(444198, 102, '2015-03-15 00:51:51.000000', 'consum', 0.0225, 'lps'),
	(444199, 102, '2015-03-15 00:51:52.000000', 'consum', 0.0225, 'lps'),
	(444200, 102, '2015-03-15 00:51:53.000000', 'consum', 0.0224, 'lps'),
	(444201, 102, '2015-03-15 00:51:54.000000', 'consum', 0.0216, 'lps'),
	(444202, 102, '2015-03-15 00:51:55.000000', 'consum', 0.0217, 'lps'),
	(444203, 102, '2015-03-15 00:51:56.000000', 'consum', 0.0210, 'lps'),
	(444204, 102, '2015-03-15 00:51:57.000000', 'consum', 0.0225, 'lps'),
	(444205, 102, '2015-03-15 00:51:58.000000', 'consum', 0.0212, 'lps'),
	(444206, 102, '2015-03-15 00:51:59.000000', 'consum', 0.0212, 'lps'),
	(444207, 102, '2015-03-15 00:52:00.000000', 'consum', 0.0213, 'lps'),
	(444208, 102, '2015-03-15 00:52:01.000000', 'consum', 0.0223, 'lps'),
	(444209, 102, '2015-03-15 00:52:02.000000', 'consum', 0.0227, 'lps'),
	(444210, 102, '2015-03-15 00:52:03.000000', 'consum', 0.0221, 'lps'),
	(444211, 102, '2015-03-15 00:52:04.000000', 'consum', 0.0217, 'lps'),
	(444212, 102, '2015-03-15 00:52:05.000000', 'consum', 0.0212, 'lps'),
	(444213, 102, '2015-03-15 00:52:06.000000', 'consum', 0.0215, 'lps'),
	(444214, 102, '2015-03-15 00:52:07.000000', 'consum', 0.0214, 'lps'),
	(444215, 102, '2015-03-15 00:52:08.000000', 'consum', 0.0215, 'lps'),
	(444216, 102, '2015-03-15 00:52:09.000000', 'consum', 0.0224, 'lps'),
	(444217, 102, '2015-03-15 00:52:10.000000', 'consum', 0.0213, 'lps'),
	(444218, 102, '2015-03-15 00:52:11.000000', 'consum', 0.0218, 'lps'),
	(444219, 102, '2015-03-15 00:52:12.000000', 'consum', 0.0226, 'lps'),
	(444220, 102, '2015-03-15 00:52:13.000000', 'consum', 0.0227, 'lps'),
	(444221, 102, '2015-03-15 00:52:14.000000', 'consum', 0.0213, 'lps'),
	(444222, 102, '2015-03-15 00:52:15.000000', 'consum', 0.0212, 'lps'),
	(444223, 102, '2015-03-15 00:52:16.000000', 'consum', 0.0227, 'lps'),
	(444224, 102, '2015-03-15 00:52:17.000000', 'consum', 0.0220, 'lps'),
	(444225, 102, '2015-03-15 00:52:18.000000', 'consum', 0.0225, 'lps'),
	(444226, 102, '2015-03-15 00:52:19.000000', 'consum', 0.0220, 'lps'),
	(444227, 102, '2015-03-15 00:52:20.000000', 'consum', 0.0218, 'lps'),
	(444228, 102, '2015-03-15 00:52:21.000000', 'consum', 0.0219, 'lps'),
	(444229, 102, '2015-03-15 00:52:22.000000', 'consum', 0.0212, 'lps'),
	(444230, 102, '2015-03-15 00:52:23.000000', 'consum', 0.0213, 'lps'),
	(444231, 102, '2015-03-15 00:52:24.000000', 'consum', 0.0219, 'lps'),
	(444232, 102, '2015-03-15 00:52:25.000000', 'consum', 0.0210, 'lps'),
	(444233, 102, '2015-03-15 00:52:26.000000', 'consum', 0.0218, 'lps'),
	(444234, 102, '2015-03-15 00:52:27.000000', 'consum', 0.0215, 'lps'),
	(444235, 102, '2015-03-15 00:52:28.000000', 'consum', 0.0213, 'lps'),
	(444236, 102, '2015-03-15 00:52:29.000000', 'consum', 0.0226, 'lps'),
	(444237, 102, '2015-03-15 00:52:30.000000', 'consum', 0.0210, 'lps'),
	(444238, 102, '2015-03-15 00:52:31.000000', 'consum', 0.0219, 'lps'),
	(444239, 102, '2015-03-15 00:52:32.000000', 'consum', 0.0218, 'lps'),
	(444240, 102, '2015-03-15 00:52:33.000000', 'consum', 0.0224, 'lps'),
	(444241, 102, '2015-03-15 00:52:34.000000', 'consum', 0.0220, 'lps'),
	(444242, 102, '2015-03-15 00:52:35.000000', 'consum', 0.0220, 'lps'),
	(444243, 102, '2015-03-15 00:52:36.000000', 'consum', 0.0213, 'lps'),
	(444244, 102, '2015-03-15 00:52:37.000000', 'consum', 0.0213, 'lps'),
	(444245, 102, '2015-03-15 00:52:38.000000', 'consum', 0.0218, 'lps'),
	(444246, 102, '2015-03-15 00:52:39.000000', 'consum', 0.0223, 'lps'),
	(444247, 102, '2015-03-15 00:52:40.000000', 'consum', 0.0214, 'lps'),
	(444248, 102, '2015-03-15 00:52:41.000000', 'consum', 0.0211, 'lps'),
	(444249, 102, '2015-03-15 00:52:42.000000', 'consum', 0.0220, 'lps'),
	(444250, 102, '2015-03-15 00:52:43.000000', 'consum', 0.0220, 'lps'),
	(444251, 102, '2015-03-15 00:52:44.000000', 'consum', 0.0215, 'lps'),
	(444252, 102, '2015-03-15 00:52:45.000000', 'consum', 0.0224, 'lps'),
	(444253, 102, '2015-03-15 00:52:46.000000', 'consum', 0.0210, 'lps'),
	(444254, 102, '2015-03-15 00:52:47.000000', 'consum', 0.0222, 'lps'),
	(444255, 102, '2015-03-15 00:52:48.000000', 'consum', 0.0216, 'lps'),
	(444256, 102, '2015-03-15 00:52:49.000000', 'consum', 0.0223, 'lps'),
	(444257, 102, '2015-03-15 00:52:50.000000', 'consum', 0.0223, 'lps'),
	(444258, 102, '2015-03-15 00:52:51.000000', 'consum', 0.0220, 'lps'),
	(444259, 102, '2015-03-15 00:52:52.000000', 'consum', 0.0219, 'lps'),
	(444260, 102, '2015-03-15 00:52:53.000000', 'consum', 0.0224, 'lps'),
	(444261, 102, '2015-03-15 00:52:54.000000', 'consum', 0.0221, 'lps'),
	(444262, 102, '2015-03-15 00:52:55.000000', 'consum', 0.0221, 'lps'),
	(444263, 102, '2015-03-15 00:52:56.000000', 'consum', 0.0217, 'lps'),
	(444264, 102, '2015-03-15 00:52:57.000000', 'consum', 0.0213, 'lps'),
	(444265, 102, '2015-03-15 00:52:58.000000', 'consum', 0.0219, 'lps'),
	(444266, 102, '2015-03-15 00:52:59.000000', 'consum', 0.0213, 'lps'),
	(444267, 102, '2015-03-15 00:53:00.000000', 'consum', 0.0216, 'lps'),
	(444268, 102, '2015-03-15 00:53:01.000000', 'consum', 0.0214, 'lps'),
	(444269, 102, '2015-03-15 00:53:02.000000', 'consum', 0.0210, 'lps'),
	(444270, 102, '2015-03-15 00:53:03.000000', 'consum', 0.0218, 'lps'),
	(444271, 102, '2015-03-15 00:53:04.000000', 'consum', 0.0213, 'lps'),
	(444272, 102, '2015-03-15 00:53:05.000000', 'consum', 0.0221, 'lps'),
	(444273, 102, '2015-03-15 00:53:06.000000', 'consum', 0.0222, 'lps'),
	(444274, 102, '2015-03-15 00:53:07.000000', 'consum', 0.0217, 'lps'),
	(444275, 102, '2015-03-15 00:53:08.000000', 'consum', 0.0212, 'lps'),
	(444276, 102, '2015-03-15 00:53:09.000000', 'consum', 0.0218, 'lps'),
	(444277, 102, '2015-03-15 00:53:10.000000', 'consum', 0.0225, 'lps'),
	(444278, 102, '2015-03-15 00:53:11.000000', 'consum', 0.0225, 'lps'),
	(444279, 102, '2015-03-15 00:53:12.000000', 'consum', 0.0225, 'lps'),
	(444280, 102, '2015-03-15 00:53:13.000000', 'consum', 0.0219, 'lps'),
	(444281, 102, '2015-03-15 00:53:14.000000', 'consum', 0.0214, 'lps'),
	(444282, 102, '2015-03-15 00:53:15.000000', 'consum', 0.0219, 'lps'),
	(444283, 102, '2015-03-15 00:53:16.000000', 'consum', 0.0227, 'lps'),
	(444284, 102, '2015-03-15 00:53:17.000000', 'consum', 0.0215, 'lps'),
	(444285, 102, '2015-03-15 00:53:18.000000', 'consum', 0.0218, 'lps'),
	(444286, 102, '2015-03-15 00:53:19.000000', 'consum', 0.0218, 'lps'),
	(444287, 102, '2015-03-15 00:53:20.000000', 'consum', 0.0226, 'lps'),
	(444288, 102, '2015-03-15 00:53:21.000000', 'consum', 0.0215, 'lps'),
	(444289, 102, '2015-03-15 00:53:22.000000', 'consum', 0.0221, 'lps'),
	(444290, 102, '2015-03-15 00:53:23.000000', 'consum', 0.0214, 'lps'),
	(444291, 102, '2015-03-15 00:53:24.000000', 'consum', 0.0218, 'lps'),
	(444292, 102, '2015-03-15 00:53:25.000000', 'consum', 0.0219, 'lps'),
	(444293, 102, '2015-03-15 00:53:26.000000', 'consum', 0.0215, 'lps'),
	(444294, 102, '2015-03-15 00:53:27.000000', 'consum', 0.0226, 'lps'),
	(444295, 102, '2015-03-15 00:53:28.000000', 'consum', 0.0221, 'lps'),
	(444296, 102, '2015-03-15 00:53:29.000000', 'consum', 0.0218, 'lps'),
	(444297, 102, '2015-03-15 00:53:30.000000', 'consum', 0.0219, 'lps'),
	(444298, 102, '2015-03-15 00:53:31.000000', 'consum', 0.0212, 'lps'),
	(444299, 102, '2015-03-15 00:53:32.000000', 'consum', 0.0212, 'lps'),
	(444300, 102, '2015-03-15 00:53:33.000000', 'consum', 0.0216, 'lps'),
	(444301, 102, '2015-03-15 00:53:34.000000', 'consum', 0.0217, 'lps'),
	(444302, 102, '2015-03-15 00:53:35.000000', 'consum', 0.0225, 'lps'),
	(444303, 102, '2015-03-15 00:53:36.000000', 'consum', 0.0212, 'lps'),
	(444304, 102, '2015-03-15 00:53:37.000000', 'consum', 0.0227, 'lps'),
	(444305, 102, '2015-03-15 00:53:38.000000', 'consum', 0.0219, 'lps'),
	(444306, 102, '2015-03-15 00:53:39.000000', 'consum', 0.0223, 'lps'),
	(444307, 102, '2015-03-15 00:53:40.000000', 'consum', 0.0211, 'lps'),
	(444308, 102, '2015-03-15 00:53:41.000000', 'consum', 0.0215, 'lps'),
	(444309, 102, '2015-03-15 00:53:42.000000', 'consum', 0.0213, 'lps'),
	(444310, 102, '2015-03-15 00:53:43.000000', 'consum', 0.0210, 'lps'),
	(444311, 102, '2015-03-15 00:53:44.000000', 'consum', 0.0219, 'lps'),
	(444312, 102, '2015-03-15 00:53:45.000000', 'consum', 0.0220, 'lps'),
	(444313, 102, '2015-03-15 00:53:46.000000', 'consum', 0.0217, 'lps'),
	(444314, 102, '2015-03-15 00:53:47.000000', 'consum', 0.0213, 'lps'),
	(444315, 102, '2015-03-15 00:53:48.000000', 'consum', 0.0225, 'lps'),
	(444316, 102, '2015-03-15 00:53:49.000000', 'consum', 0.0220, 'lps'),
	(444317, 102, '2015-03-15 00:53:50.000000', 'consum', 0.0215, 'lps'),
	(444318, 102, '2015-03-15 00:53:51.000000', 'consum', 0.0225, 'lps'),
	(444319, 102, '2015-03-15 00:53:52.000000', 'consum', 0.0215, 'lps'),
	(444320, 102, '2015-03-15 00:53:53.000000', 'consum', 0.0211, 'lps'),
	(444321, 102, '2015-03-15 00:53:54.000000', 'consum', 0.0216, 'lps'),
	(444322, 102, '2015-03-15 00:53:55.000000', 'consum', 0.0219, 'lps'),
	(444323, 102, '2015-03-15 00:53:56.000000', 'consum', 0.0219, 'lps'),
	(444324, 102, '2015-03-15 00:53:57.000000', 'consum', 0.0210, 'lps'),
	(444325, 102, '2015-03-15 00:53:58.000000', 'consum', 0.0219, 'lps'),
	(444326, 102, '2015-03-15 00:53:59.000000', 'consum', 0.0219, 'lps'),
	(444327, 102, '2015-03-15 00:54:00.000000', 'consum', 0.0211, 'lps'),
	(444328, 102, '2015-03-15 00:54:01.000000', 'consum', 0.0224, 'lps'),
	(444329, 102, '2015-03-15 00:54:02.000000', 'consum', 0.0223, 'lps'),
	(444330, 102, '2015-03-15 00:54:03.000000', 'consum', 0.0215, 'lps'),
	(444331, 102, '2015-03-15 00:54:04.000000', 'consum', 0.0217, 'lps'),
	(444332, 102, '2015-03-15 00:54:05.000000', 'consum', 0.0211, 'lps'),
	(444333, 102, '2015-03-15 00:54:06.000000', 'consum', 0.0213, 'lps'),
	(444334, 102, '2015-03-15 00:54:07.000000', 'consum', 0.0224, 'lps'),
	(444335, 102, '2015-03-15 00:54:08.000000', 'consum', 0.0218, 'lps'),
	(444336, 102, '2015-03-15 00:54:09.000000', 'consum', 0.0227, 'lps'),
	(444337, 102, '2015-03-15 00:54:10.000000', 'consum', 0.0217, 'lps'),
	(444338, 102, '2015-03-15 00:54:11.000000', 'consum', 0.0214, 'lps'),
	(444339, 102, '2015-03-15 00:54:12.000000', 'consum', 0.0227, 'lps'),
	(444340, 102, '2015-03-15 00:54:13.000000', 'consum', 0.0210, 'lps'),
	(444341, 102, '2015-03-15 00:54:14.000000', 'consum', 0.0212, 'lps'),
	(444342, 102, '2015-03-15 00:54:15.000000', 'consum', 0.0224, 'lps'),
	(444343, 102, '2015-03-15 00:54:16.000000', 'consum', 0.0218, 'lps'),
	(444344, 102, '2015-03-15 00:54:17.000000', 'consum', 0.0226, 'lps'),
	(444345, 102, '2015-03-15 00:54:18.000000', 'consum', 0.0212, 'lps'),
	(444346, 102, '2015-03-15 00:54:19.000000', 'consum', 0.0226, 'lps'),
	(444347, 102, '2015-03-15 00:54:20.000000', 'consum', 0.0213, 'lps'),
	(444348, 102, '2015-03-15 00:54:21.000000', 'consum', 0.0214, 'lps'),
	(444349, 102, '2015-03-15 00:54:22.000000', 'consum', 0.0223, 'lps'),
	(444350, 102, '2015-03-15 00:54:23.000000', 'consum', 0.0226, 'lps'),
	(444351, 102, '2015-03-15 00:54:24.000000', 'consum', 0.0215, 'lps'),
	(444352, 102, '2015-03-15 00:54:25.000000', 'consum', 0.0223, 'lps'),
	(444353, 102, '2015-03-15 00:54:26.000000', 'consum', 0.0225, 'lps'),
	(444354, 102, '2015-03-15 00:54:27.000000', 'consum', 0.0227, 'lps'),
	(444355, 102, '2015-03-15 00:54:28.000000', 'consum', 0.0215, 'lps'),
	(444356, 102, '2015-03-15 00:54:29.000000', 'consum', 0.0222, 'lps'),
	(444357, 102, '2015-03-15 00:54:30.000000', 'consum', 0.0220, 'lps'),
	(444358, 102, '2015-03-15 00:54:31.000000', 'consum', 0.0225, 'lps'),
	(444359, 102, '2015-03-15 00:54:32.000000', 'consum', 0.0217, 'lps'),
	(444360, 102, '2015-03-15 00:54:33.000000', 'consum', 0.0220, 'lps'),
	(444361, 102, '2015-03-15 00:54:34.000000', 'consum', 0.0222, 'lps'),
	(444362, 102, '2015-03-15 00:54:35.000000', 'consum', 0.0221, 'lps'),
	(444363, 102, '2015-03-15 00:54:36.000000', 'consum', 0.0212, 'lps'),
	(444364, 102, '2015-03-15 00:54:37.000000', 'consum', 0.0222, 'lps'),
	(444365, 102, '2015-03-15 00:54:38.000000', 'consum', 0.0213, 'lps'),
	(444366, 102, '2015-03-15 00:54:39.000000', 'consum', 0.0223, 'lps'),
	(444367, 102, '2015-03-15 00:54:40.000000', 'consum', 0.0214, 'lps'),
	(444368, 102, '2015-03-15 00:54:41.000000', 'consum', 0.0227, 'lps'),
	(444369, 102, '2015-03-15 00:54:42.000000', 'consum', 0.0211, 'lps'),
	(444370, 102, '2015-03-15 00:54:43.000000', 'consum', 0.0220, 'lps'),
	(444371, 102, '2015-03-15 00:54:44.000000', 'consum', 0.0223, 'lps'),
	(444372, 102, '2015-03-15 00:54:45.000000', 'consum', 0.0225, 'lps'),
	(444373, 102, '2015-03-15 00:54:46.000000', 'consum', 0.0212, 'lps'),
	(444374, 102, '2015-03-15 00:54:47.000000', 'consum', 0.0212, 'lps'),
	(444375, 102, '2015-03-15 00:54:48.000000', 'consum', 0.0215, 'lps'),
	(444376, 102, '2015-03-15 00:54:49.000000', 'consum', 0.0211, 'lps'),
	(444377, 102, '2015-03-15 00:54:50.000000', 'consum', 0.0217, 'lps'),
	(444378, 102, '2015-03-15 00:54:51.000000', 'consum', 0.0224, 'lps'),
	(444379, 102, '2015-03-15 00:54:52.000000', 'consum', 0.0226, 'lps'),
	(444380, 102, '2015-03-15 00:54:53.000000', 'consum', 0.0212, 'lps'),
	(444381, 102, '2015-03-15 00:54:54.000000', 'consum', 0.0225, 'lps'),
	(444382, 102, '2015-03-15 00:54:55.000000', 'consum', 0.0225, 'lps'),
	(444383, 102, '2015-03-15 00:54:56.000000', 'consum', 0.0223, 'lps'),
	(444384, 102, '2015-03-15 00:54:57.000000', 'consum', 0.0213, 'lps'),
	(444385, 102, '2015-03-15 00:54:58.000000', 'consum', 0.0221, 'lps'),
	(444386, 102, '2015-03-15 00:54:59.000000', 'consum', 0.0222, 'lps'),
	(444387, 102, '2015-03-15 00:55:00.000000', 'consum', 0.0219, 'lps'),
	(444388, 102, '2015-03-15 00:55:01.000000', 'consum', 0.0218, 'lps'),
	(444389, 102, '2015-03-15 00:55:02.000000', 'consum', 0.0225, 'lps'),
	(444390, 102, '2015-03-15 00:55:03.000000', 'consum', 0.0227, 'lps'),
	(444391, 102, '2015-03-15 00:55:04.000000', 'consum', 0.0212, 'lps'),
	(444392, 102, '2015-03-15 00:55:05.000000', 'consum', 0.0223, 'lps'),
	(444393, 102, '2015-03-15 00:55:06.000000', 'consum', 0.0215, 'lps'),
	(444394, 102, '2015-03-15 00:55:07.000000', 'consum', 0.0214, 'lps'),
	(444395, 102, '2015-03-15 00:55:08.000000', 'consum', 0.0218, 'lps'),
	(444396, 102, '2015-03-15 00:55:09.000000', 'consum', 0.0219, 'lps'),
	(444397, 102, '2015-03-15 00:55:10.000000', 'consum', 0.0213, 'lps'),
	(444398, 102, '2015-03-15 00:55:11.000000', 'consum', 0.0216, 'lps'),
	(444399, 102, '2015-03-15 00:55:12.000000', 'consum', 0.0215, 'lps'),
	(444400, 102, '2015-03-15 00:55:13.000000', 'consum', 0.0217, 'lps'),
	(444401, 102, '2015-03-15 00:55:14.000000', 'consum', 0.0214, 'lps'),
	(444402, 102, '2015-03-15 00:55:15.000000', 'consum', 0.0226, 'lps'),
	(444403, 102, '2015-03-15 00:55:16.000000', 'consum', 0.0224, 'lps'),
	(444404, 102, '2015-03-15 00:55:17.000000', 'consum', 0.0213, 'lps'),
	(444405, 102, '2015-03-15 00:55:18.000000', 'consum', 0.0222, 'lps'),
	(444406, 102, '2015-03-15 00:55:19.000000', 'consum', 0.0227, 'lps'),
	(444407, 102, '2015-03-15 00:55:20.000000', 'consum', 0.0221, 'lps'),
	(444408, 102, '2015-03-15 00:55:21.000000', 'consum', 0.0215, 'lps'),
	(444409, 102, '2015-03-15 00:55:22.000000', 'consum', 0.0223, 'lps'),
	(444410, 102, '2015-03-15 00:55:23.000000', 'consum', 0.0221, 'lps'),
	(444411, 102, '2015-03-15 00:55:24.000000', 'consum', 0.0210, 'lps'),
	(444412, 102, '2015-03-15 00:55:25.000000', 'consum', 0.0214, 'lps'),
	(444413, 102, '2015-03-15 00:55:26.000000', 'consum', 0.0212, 'lps'),
	(444414, 102, '2015-03-15 00:55:27.000000', 'consum', 0.0225, 'lps'),
	(444415, 102, '2015-03-15 00:55:28.000000', 'consum', 0.0227, 'lps'),
	(444416, 102, '2015-03-15 00:55:29.000000', 'consum', 0.0213, 'lps'),
	(444417, 102, '2015-03-15 00:55:30.000000', 'consum', 0.0210, 'lps'),
	(444418, 102, '2015-03-15 00:55:31.000000', 'consum', 0.0220, 'lps'),
	(444419, 102, '2015-03-15 00:55:32.000000', 'consum', 0.0225, 'lps'),
	(444420, 102, '2015-03-15 00:55:33.000000', 'consum', 0.0217, 'lps'),
	(444421, 102, '2015-03-15 00:55:34.000000', 'consum', 0.0222, 'lps'),
	(444422, 102, '2015-03-15 00:55:35.000000', 'consum', 0.0210, 'lps'),
	(444423, 102, '2015-03-15 00:55:36.000000', 'consum', 0.0212, 'lps'),
	(444424, 102, '2015-03-15 00:55:37.000000', 'consum', 0.0223, 'lps'),
	(444425, 102, '2015-03-15 00:55:38.000000', 'consum', 0.0212, 'lps'),
	(444426, 102, '2015-03-15 00:55:39.000000', 'consum', 0.0218, 'lps'),
	(444427, 102, '2015-03-15 00:55:40.000000', 'consum', 0.0210, 'lps'),
	(444428, 102, '2015-03-15 00:55:41.000000', 'consum', 0.0220, 'lps'),
	(444429, 102, '2015-03-15 00:55:42.000000', 'consum', 0.0226, 'lps'),
	(444430, 102, '2015-03-15 00:55:43.000000', 'consum', 0.0226, 'lps'),
	(444431, 102, '2015-03-15 00:55:44.000000', 'consum', 0.0223, 'lps'),
	(444432, 102, '2015-03-15 00:55:45.000000', 'consum', 0.0227, 'lps'),
	(444433, 102, '2015-03-15 00:55:46.000000', 'consum', 0.0221, 'lps'),
	(444434, 102, '2015-03-15 00:55:47.000000', 'consum', 0.0214, 'lps'),
	(444435, 102, '2015-03-15 00:55:48.000000', 'consum', 0.0215, 'lps'),
	(444436, 102, '2015-03-15 00:55:49.000000', 'consum', 0.0225, 'lps'),
	(444437, 102, '2015-03-15 00:55:50.000000', 'consum', 0.0215, 'lps'),
	(444438, 102, '2015-03-15 00:55:51.000000', 'consum', 0.0210, 'lps'),
	(444439, 102, '2015-03-15 00:55:52.000000', 'consum', 0.0214, 'lps'),
	(444440, 102, '2015-03-15 00:55:53.000000', 'consum', 0.0213, 'lps'),
	(444441, 102, '2015-03-15 00:55:54.000000', 'consum', 0.0214, 'lps'),
	(444442, 102, '2015-03-15 00:55:55.000000', 'consum', 0.0222, 'lps'),
	(444443, 102, '2015-03-15 00:55:56.000000', 'consum', 0.0221, 'lps'),
	(444444, 102, '2015-03-15 00:55:57.000000', 'consum', 0.0212, 'lps'),
	(444445, 102, '2015-03-15 00:55:58.000000', 'consum', 0.0224, 'lps'),
	(444446, 102, '2015-03-15 00:55:59.000000', 'consum', 0.0222, 'lps'),
	(444447, 102, '2015-03-15 00:56:00.000000', 'consum', 0.0227, 'lps'),
	(444448, 102, '2015-03-15 00:56:01.000000', 'consum', 0.0223, 'lps'),
	(444449, 102, '2015-03-15 00:56:02.000000', 'consum', 0.0224, 'lps'),
	(444450, 102, '2015-03-15 00:56:03.000000', 'consum', 0.0223, 'lps'),
	(444451, 102, '2015-03-15 00:56:04.000000', 'consum', 0.0218, 'lps'),
	(444452, 102, '2015-03-15 00:56:05.000000', 'consum', 0.0210, 'lps'),
	(444453, 102, '2015-03-15 00:56:06.000000', 'consum', 0.0224, 'lps'),
	(444454, 102, '2015-03-15 00:56:07.000000', 'consum', 0.0225, 'lps'),
	(444455, 102, '2015-03-15 00:56:08.000000', 'consum', 0.0210, 'lps'),
	(444456, 102, '2015-03-15 00:56:09.000000', 'consum', 0.0216, 'lps'),
	(444457, 102, '2015-03-15 00:56:10.000000', 'consum', 0.0226, 'lps'),
	(444458, 102, '2015-03-15 00:56:11.000000', 'consum', 0.0215, 'lps'),
	(444459, 102, '2015-03-15 00:56:12.000000', 'consum', 0.0227, 'lps'),
	(444460, 102, '2015-03-15 00:56:13.000000', 'consum', 0.0224, 'lps'),
	(444461, 102, '2015-03-15 00:56:14.000000', 'consum', 0.0211, 'lps'),
	(444462, 102, '2015-03-15 00:56:15.000000', 'consum', 0.0210, 'lps'),
	(444463, 102, '2015-03-15 00:56:16.000000', 'consum', 0.0225, 'lps'),
	(444464, 102, '2015-03-15 00:56:17.000000', 'consum', 0.0214, 'lps'),
	(444465, 102, '2015-03-15 00:56:18.000000', 'consum', 0.0220, 'lps'),
	(444466, 102, '2015-03-15 00:56:19.000000', 'consum', 0.0211, 'lps'),
	(444467, 102, '2015-03-15 00:56:20.000000', 'consum', 0.0225, 'lps'),
	(444468, 102, '2015-03-15 00:56:21.000000', 'consum', 0.0210, 'lps'),
	(444469, 102, '2015-03-15 00:56:22.000000', 'consum', 0.0221, 'lps'),
	(444470, 102, '2015-03-15 00:56:23.000000', 'consum', 0.0211, 'lps'),
	(444471, 102, '2015-03-15 00:56:24.000000', 'consum', 0.0217, 'lps'),
	(444472, 102, '2015-03-15 00:56:25.000000', 'consum', 0.0223, 'lps'),
	(444473, 102, '2015-03-15 00:56:26.000000', 'consum', 0.0221, 'lps'),
	(444474, 102, '2015-03-15 00:56:27.000000', 'consum', 0.0224, 'lps'),
	(444475, 102, '2015-03-15 00:56:28.000000', 'consum', 0.0213, 'lps'),
	(444476, 102, '2015-03-15 00:56:29.000000', 'consum', 0.0218, 'lps'),
	(444477, 102, '2015-03-15 00:56:30.000000', 'consum', 0.0226, 'lps'),
	(444478, 102, '2015-03-15 00:56:31.000000', 'consum', 0.0210, 'lps'),
	(444479, 102, '2015-03-15 00:56:32.000000', 'consum', 0.0219, 'lps'),
	(444480, 102, '2015-03-15 00:56:33.000000', 'consum', 0.0218, 'lps'),
	(444481, 102, '2015-03-15 00:56:34.000000', 'consum', 0.0223, 'lps'),
	(444482, 102, '2015-03-15 00:56:35.000000', 'consum', 0.0217, 'lps'),
	(444483, 102, '2015-03-15 00:56:36.000000', 'consum', 0.0226, 'lps'),
	(444484, 102, '2015-03-15 00:56:37.000000', 'consum', 0.0212, 'lps'),
	(444485, 102, '2015-03-15 00:56:38.000000', 'consum', 0.0212, 'lps'),
	(444486, 102, '2015-03-15 00:56:39.000000', 'consum', 0.0213, 'lps'),
	(444487, 102, '2015-03-15 00:56:40.000000', 'consum', 0.0220, 'lps'),
	(444488, 102, '2015-03-15 00:56:41.000000', 'consum', 0.0217, 'lps'),
	(444489, 102, '2015-03-15 00:56:42.000000', 'consum', 0.0214, 'lps'),
	(444490, 102, '2015-03-15 00:56:43.000000', 'consum', 0.0211, 'lps'),
	(444491, 102, '2015-03-15 00:56:44.000000', 'consum', 0.0219, 'lps'),
	(444492, 102, '2015-03-15 00:56:45.000000', 'consum', 0.0217, 'lps'),
	(444493, 102, '2015-03-15 00:56:46.000000', 'consum', 0.0220, 'lps'),
	(444494, 102, '2015-03-15 00:56:47.000000', 'consum', 0.0220, 'lps'),
	(444495, 102, '2015-03-15 00:56:48.000000', 'consum', 0.0213, 'lps'),
	(444496, 102, '2015-03-15 00:56:49.000000', 'consum', 0.0215, 'lps'),
	(444497, 102, '2015-03-15 00:56:50.000000', 'consum', 0.0227, 'lps'),
	(444498, 102, '2015-03-15 00:56:51.000000', 'consum', 0.0225, 'lps'),
	(444499, 102, '2015-03-15 00:56:52.000000', 'consum', 0.0218, 'lps'),
	(444500, 102, '2015-03-15 00:56:53.000000', 'consum', 0.0221, 'lps'),
	(444501, 102, '2015-03-15 00:56:54.000000', 'consum', 0.0227, 'lps'),
	(444502, 102, '2015-03-15 00:56:55.000000', 'consum', 0.0223, 'lps'),
	(444503, 102, '2015-03-15 00:56:56.000000', 'consum', 0.0226, 'lps'),
	(444504, 102, '2015-03-15 00:56:57.000000', 'consum', 0.0215, 'lps'),
	(444505, 102, '2015-03-15 00:56:58.000000', 'consum', 0.0222, 'lps'),
	(444506, 102, '2015-03-15 00:56:59.000000', 'consum', 0.0221, 'lps'),
	(444507, 102, '2015-03-15 00:57:00.000000', 'consum', 0.0211, 'lps'),
	(444508, 102, '2015-03-15 00:57:01.000000', 'consum', 0.0217, 'lps'),
	(444509, 102, '2015-03-15 00:57:02.000000', 'consum', 0.0210, 'lps'),
	(444510, 102, '2015-03-15 00:57:03.000000', 'consum', 0.0222, 'lps'),
	(444511, 102, '2015-03-15 00:57:04.000000', 'consum', 0.0219, 'lps'),
	(444512, 102, '2015-03-15 00:57:05.000000', 'consum', 0.0218, 'lps'),
	(444513, 102, '2015-03-15 00:57:06.000000', 'consum', 0.0222, 'lps'),
	(444514, 102, '2015-03-15 00:57:07.000000', 'consum', 0.0213, 'lps'),
	(444515, 102, '2015-03-15 00:57:08.000000', 'consum', 0.0223, 'lps'),
	(444516, 102, '2015-03-15 00:57:09.000000', 'consum', 0.0215, 'lps'),
	(444517, 102, '2015-03-15 00:57:10.000000', 'consum', 0.0213, 'lps'),
	(444518, 102, '2015-03-15 00:57:11.000000', 'consum', 0.0213, 'lps'),
	(444519, 102, '2015-03-15 00:57:12.000000', 'consum', 0.0215, 'lps'),
	(444520, 102, '2015-03-15 00:57:13.000000', 'consum', 0.0225, 'lps'),
	(444521, 102, '2015-03-15 00:57:14.000000', 'consum', 0.0219, 'lps'),
	(444522, 102, '2015-03-15 00:57:15.000000', 'consum', 0.0227, 'lps'),
	(444523, 102, '2015-03-15 00:57:16.000000', 'consum', 0.0215, 'lps'),
	(444524, 102, '2015-03-15 00:57:17.000000', 'consum', 0.0219, 'lps'),
	(444525, 102, '2015-03-15 00:57:18.000000', 'consum', 0.0225, 'lps'),
	(444526, 102, '2015-03-15 00:57:19.000000', 'consum', 0.0221, 'lps'),
	(444527, 102, '2015-03-15 00:57:20.000000', 'consum', 0.0222, 'lps'),
	(444528, 102, '2015-03-15 00:57:21.000000', 'consum', 0.0219, 'lps'),
	(444529, 102, '2015-03-15 00:57:22.000000', 'consum', 0.0221, 'lps'),
	(444530, 102, '2015-03-15 00:57:23.000000', 'consum', 0.0219, 'lps'),
	(444531, 102, '2015-03-15 00:57:24.000000', 'consum', 0.0222, 'lps'),
	(444532, 102, '2015-03-15 00:57:25.000000', 'consum', 0.0225, 'lps'),
	(444533, 102, '2015-03-15 00:57:26.000000', 'consum', 0.0212, 'lps'),
	(444534, 102, '2015-03-15 00:57:27.000000', 'consum', 0.0214, 'lps'),
	(444535, 102, '2015-03-15 00:57:28.000000', 'consum', 0.0225, 'lps'),
	(444536, 102, '2015-03-15 00:57:29.000000', 'consum', 0.0220, 'lps'),
	(444537, 102, '2015-03-15 00:57:30.000000', 'consum', 0.0217, 'lps'),
	(444538, 102, '2015-03-15 00:57:31.000000', 'consum', 0.0212, 'lps'),
	(444539, 102, '2015-03-15 00:57:32.000000', 'consum', 0.0219, 'lps'),
	(444540, 102, '2015-03-15 00:57:33.000000', 'consum', 0.0211, 'lps'),
	(444541, 102, '2015-03-15 00:57:34.000000', 'consum', 0.0227, 'lps'),
	(444542, 102, '2015-03-15 00:57:35.000000', 'consum', 0.0221, 'lps'),
	(444543, 102, '2015-03-15 00:57:36.000000', 'consum', 0.0214, 'lps'),
	(444544, 102, '2015-03-15 00:57:37.000000', 'consum', 0.0214, 'lps'),
	(444545, 102, '2015-03-15 00:57:38.000000', 'consum', 0.0218, 'lps'),
	(444546, 102, '2015-03-15 00:57:39.000000', 'consum', 0.0223, 'lps'),
	(444547, 102, '2015-03-15 00:57:40.000000', 'consum', 0.0215, 'lps'),
	(444548, 102, '2015-03-15 00:57:41.000000', 'consum', 0.0216, 'lps'),
	(444549, 102, '2015-03-15 00:57:42.000000', 'consum', 0.0223, 'lps'),
	(444550, 102, '2015-03-15 00:57:43.000000', 'consum', 0.0221, 'lps'),
	(444551, 102, '2015-03-15 00:57:44.000000', 'consum', 0.0210, 'lps'),
	(444552, 102, '2015-03-15 00:57:45.000000', 'consum', 0.0213, 'lps'),
	(444553, 102, '2015-03-15 00:57:46.000000', 'consum', 0.0226, 'lps'),
	(444554, 102, '2015-03-15 00:57:47.000000', 'consum', 0.0226, 'lps'),
	(444555, 102, '2015-03-15 00:57:48.000000', 'consum', 0.0224, 'lps'),
	(444556, 102, '2015-03-15 00:57:49.000000', 'consum', 0.0217, 'lps'),
	(444557, 102, '2015-03-15 00:57:50.000000', 'consum', 0.0222, 'lps'),
	(444558, 102, '2015-03-15 00:57:51.000000', 'consum', 0.0211, 'lps'),
	(444559, 102, '2015-03-15 00:57:52.000000', 'consum', 0.0217, 'lps'),
	(444560, 102, '2015-03-15 00:57:53.000000', 'consum', 0.0224, 'lps'),
	(444561, 102, '2015-03-15 00:57:54.000000', 'consum', 0.0223, 'lps'),
	(444562, 102, '2015-03-15 00:57:55.000000', 'consum', 0.0215, 'lps'),
	(444563, 102, '2015-03-15 00:57:56.000000', 'consum', 0.0217, 'lps'),
	(444564, 102, '2015-03-15 00:57:57.000000', 'consum', 0.0211, 'lps'),
	(444565, 102, '2015-03-15 00:57:58.000000', 'consum', 0.0213, 'lps'),
	(444566, 102, '2015-03-15 00:57:59.000000', 'consum', 0.0221, 'lps'),
	(444567, 102, '2015-03-15 00:58:00.000000', 'consum', 0.0221, 'lps'),
	(444568, 102, '2015-03-15 00:58:01.000000', 'consum', 0.0214, 'lps'),
	(444569, 102, '2015-03-15 00:58:02.000000', 'consum', 0.0214, 'lps'),
	(444570, 102, '2015-03-15 00:58:03.000000', 'consum', 0.0220, 'lps'),
	(444571, 102, '2015-03-15 00:58:04.000000', 'consum', 0.0211, 'lps'),
	(444572, 102, '2015-03-15 00:58:05.000000', 'consum', 0.0222, 'lps'),
	(444573, 102, '2015-03-15 00:58:06.000000', 'consum', 0.0213, 'lps'),
	(444574, 102, '2015-03-15 00:58:07.000000', 'consum', 0.0227, 'lps'),
	(444575, 102, '2015-03-15 00:58:08.000000', 'consum', 0.0212, 'lps'),
	(444576, 102, '2015-03-15 00:58:09.000000', 'consum', 0.0224, 'lps'),
	(444577, 102, '2015-03-15 00:58:10.000000', 'consum', 0.0222, 'lps'),
	(444578, 102, '2015-03-15 00:58:11.000000', 'consum', 0.0227, 'lps'),
	(444579, 102, '2015-03-15 00:58:12.000000', 'consum', 0.0224, 'lps'),
	(444580, 102, '2015-03-15 00:58:13.000000', 'consum', 0.0212, 'lps'),
	(444581, 102, '2015-03-15 00:58:14.000000', 'consum', 0.0215, 'lps'),
	(444582, 102, '2015-03-15 00:58:15.000000', 'consum', 0.0210, 'lps'),
	(444583, 102, '2015-03-15 00:58:16.000000', 'consum', 0.0213, 'lps'),
	(444584, 102, '2015-03-15 00:58:17.000000', 'consum', 0.0225, 'lps'),
	(444585, 102, '2015-03-15 00:58:18.000000', 'consum', 0.0225, 'lps'),
	(444586, 102, '2015-03-15 00:58:19.000000', 'consum', 0.0220, 'lps'),
	(444587, 102, '2015-03-15 00:58:20.000000', 'consum', 0.0215, 'lps'),
	(444588, 102, '2015-03-15 00:58:21.000000', 'consum', 0.0223, 'lps'),
	(444589, 102, '2015-03-15 00:58:22.000000', 'consum', 0.0226, 'lps'),
	(444590, 102, '2015-03-15 00:58:23.000000', 'consum', 0.0216, 'lps'),
	(444591, 102, '2015-03-15 00:58:24.000000', 'consum', 0.0227, 'lps'),
	(444592, 102, '2015-03-15 00:58:25.000000', 'consum', 0.0223, 'lps'),
	(444593, 102, '2015-03-15 00:58:26.000000', 'consum', 0.0227, 'lps'),
	(444594, 102, '2015-03-15 00:58:27.000000', 'consum', 0.0218, 'lps'),
	(444595, 102, '2015-03-15 00:58:28.000000', 'consum', 0.0218, 'lps'),
	(444596, 102, '2015-03-15 00:58:29.000000', 'consum', 0.0210, 'lps'),
	(444597, 102, '2015-03-15 00:58:30.000000', 'consum', 0.0222, 'lps'),
	(444598, 102, '2015-03-15 00:58:31.000000', 'consum', 0.0215, 'lps'),
	(444599, 102, '2015-03-15 00:58:32.000000', 'consum', 0.0217, 'lps'),
	(444600, 102, '2015-03-15 00:58:33.000000', 'consum', 0.0213, 'lps'),
	(444601, 102, '2015-03-15 00:58:34.000000', 'consum', 0.0221, 'lps'),
	(444602, 102, '2015-03-15 00:58:35.000000', 'consum', 0.0223, 'lps'),
	(444603, 102, '2015-03-15 00:58:36.000000', 'consum', 0.0223, 'lps'),
	(444604, 102, '2015-03-15 00:58:37.000000', 'consum', 0.0218, 'lps'),
	(444605, 102, '2015-03-15 00:58:38.000000', 'consum', 0.0210, 'lps'),
	(444606, 102, '2015-03-15 00:58:39.000000', 'consum', 0.0224, 'lps'),
	(444607, 102, '2015-03-15 00:58:40.000000', 'consum', 0.0210, 'lps'),
	(444608, 102, '2015-03-15 00:58:41.000000', 'consum', 0.0220, 'lps'),
	(444609, 102, '2015-03-15 00:58:42.000000', 'consum', 0.0225, 'lps'),
	(444610, 102, '2015-03-15 00:58:43.000000', 'consum', 0.0221, 'lps'),
	(444611, 102, '2015-03-15 00:58:44.000000', 'consum', 0.0218, 'lps'),
	(444612, 102, '2015-03-15 00:58:45.000000', 'consum', 0.0219, 'lps'),
	(444613, 102, '2015-03-15 00:58:46.000000', 'consum', 0.0212, 'lps'),
	(444614, 102, '2015-03-15 00:58:47.000000', 'consum', 0.0213, 'lps'),
	(444615, 102, '2015-03-15 00:58:48.000000', 'consum', 0.0218, 'lps'),
	(444616, 102, '2015-03-15 00:58:49.000000', 'consum', 0.0222, 'lps'),
	(444617, 102, '2015-03-15 00:58:50.000000', 'consum', 0.0213, 'lps'),
	(444618, 102, '2015-03-15 00:58:51.000000', 'consum', 0.0223, 'lps'),
	(444619, 102, '2015-03-15 00:58:52.000000', 'consum', 0.0215, 'lps'),
	(444620, 102, '2015-03-15 00:58:53.000000', 'consum', 0.0214, 'lps'),
	(444621, 102, '2015-03-15 00:58:54.000000', 'consum', 0.0215, 'lps'),
	(444622, 102, '2015-03-15 00:58:55.000000', 'consum', 0.0224, 'lps'),
	(444623, 102, '2015-03-15 00:58:56.000000', 'consum', 0.0210, 'lps'),
	(444624, 102, '2015-03-15 00:58:57.000000', 'consum', 0.0224, 'lps'),
	(444625, 102, '2015-03-15 00:58:58.000000', 'consum', 0.0224, 'lps'),
	(444626, 102, '2015-03-15 00:58:59.000000', 'consum', 0.0224, 'lps'),
	(444627, 102, '2015-03-15 00:59:00.000000', 'consum', 0.0219, 'lps'),
	(444628, 102, '2015-03-15 00:59:01.000000', 'consum', 0.0214, 'lps'),
	(444629, 102, '2015-03-15 00:59:02.000000', 'consum', 0.0223, 'lps'),
	(444630, 102, '2015-03-15 00:59:03.000000', 'consum', 0.0224, 'lps'),
	(444631, 102, '2015-03-15 00:59:04.000000', 'consum', 0.0226, 'lps'),
	(444632, 102, '2015-03-15 00:59:05.000000', 'consum', 0.0214, 'lps'),
	(444633, 102, '2015-03-15 00:59:06.000000', 'consum', 0.0216, 'lps'),
	(444634, 102, '2015-03-15 00:59:07.000000', 'consum', 0.0211, 'lps'),
	(444635, 102, '2015-03-15 00:59:08.000000', 'consum', 0.0216, 'lps'),
	(444636, 102, '2015-03-15 00:59:09.000000', 'consum', 0.0217, 'lps'),
	(444637, 102, '2015-03-15 00:59:10.000000', 'consum', 0.0213, 'lps'),
	(444638, 102, '2015-03-15 00:59:11.000000', 'consum', 0.0221, 'lps'),
	(444639, 102, '2015-03-15 00:59:12.000000', 'consum', 0.0220, 'lps'),
	(444640, 102, '2015-03-15 00:59:13.000000', 'consum', 0.0226, 'lps'),
	(444641, 102, '2015-03-15 00:59:14.000000', 'consum', 0.0210, 'lps'),
	(444642, 102, '2015-03-15 00:59:15.000000', 'consum', 0.0214, 'lps'),
	(444643, 102, '2015-03-15 00:59:16.000000', 'consum', 0.0211, 'lps'),
	(444644, 102, '2015-03-15 00:59:17.000000', 'consum', 0.0224, 'lps'),
	(444645, 102, '2015-03-15 00:59:18.000000', 'consum', 0.0222, 'lps'),
	(444646, 102, '2015-03-15 00:59:19.000000', 'consum', 0.0210, 'lps'),
	(444647, 102, '2015-03-15 00:59:20.000000', 'consum', 0.0212, 'lps'),
	(444648, 102, '2015-03-15 00:59:21.000000', 'consum', 0.0222, 'lps'),
	(444649, 102, '2015-03-15 00:59:22.000000', 'consum', 0.0227, 'lps'),
	(444650, 102, '2015-03-15 00:59:23.000000', 'consum', 0.0226, 'lps'),
	(444651, 102, '2015-03-15 00:59:24.000000', 'consum', 0.0219, 'lps'),
	(444652, 102, '2015-03-15 00:59:25.000000', 'consum', 0.0224, 'lps'),
	(444653, 102, '2015-03-15 00:59:26.000000', 'consum', 0.0219, 'lps'),
	(444654, 102, '2015-03-15 00:59:27.000000', 'consum', 0.0213, 'lps'),
	(444655, 102, '2015-03-15 00:59:28.000000', 'consum', 0.0217, 'lps'),
	(444656, 102, '2015-03-15 00:59:29.000000', 'consum', 0.0217, 'lps'),
	(444657, 102, '2015-03-15 00:59:30.000000', 'consum', 0.0225, 'lps'),
	(444658, 102, '2015-03-15 00:59:31.000000', 'consum', 0.0211, 'lps'),
	(444659, 102, '2015-03-15 00:59:32.000000', 'consum', 0.0225, 'lps'),
	(444660, 102, '2015-03-15 00:59:33.000000', 'consum', 0.0226, 'lps'),
	(444661, 102, '2015-03-15 00:59:34.000000', 'consum', 0.0211, 'lps'),
	(444662, 102, '2015-03-15 00:59:35.000000', 'consum', 0.0220, 'lps'),
	(444663, 102, '2015-03-15 00:59:36.000000', 'consum', 0.0223, 'lps'),
	(444664, 102, '2015-03-15 00:59:37.000000', 'consum', 0.0226, 'lps'),
	(444665, 102, '2015-03-15 00:59:38.000000', 'consum', 0.0215, 'lps'),
	(444666, 102, '2015-03-15 00:59:39.000000', 'consum', 0.0224, 'lps'),
	(444667, 102, '2015-03-15 00:59:40.000000', 'consum', 0.0213, 'lps'),
	(444668, 102, '2015-03-15 00:59:41.000000', 'consum', 0.0218, 'lps'),
	(444669, 102, '2015-03-15 00:59:42.000000', 'consum', 0.0222, 'lps'),
	(444670, 102, '2015-03-15 00:59:43.000000', 'consum', 0.0211, 'lps'),
	(444671, 102, '2015-03-15 00:59:44.000000', 'consum', 0.0217, 'lps'),
	(444672, 102, '2015-03-15 00:59:45.000000', 'consum', 0.0226, 'lps'),
	(444673, 102, '2015-03-15 00:59:46.000000', 'consum', 0.0212, 'lps'),
	(444674, 102, '2015-03-15 00:59:47.000000', 'consum', 0.0212, 'lps'),
	(444675, 102, '2015-03-15 00:59:48.000000', 'consum', 0.0211, 'lps'),
	(444676, 102, '2015-03-15 00:59:49.000000', 'consum', 0.0211, 'lps'),
	(444677, 102, '2015-03-15 00:59:50.000000', 'consum', 0.0211, 'lps'),
	(444678, 102, '2015-03-15 00:59:51.000000', 'consum', 0.0212, 'lps'),
	(444679, 102, '2015-03-15 00:59:52.000000', 'consum', 0.0221, 'lps'),
	(444680, 102, '2015-03-15 00:59:53.000000', 'consum', 0.0220, 'lps'),
	(444681, 102, '2015-03-15 00:59:54.000000', 'consum', 0.0211, 'lps'),
	(444682, 102, '2015-03-15 00:59:55.000000', 'consum', 0.0222, 'lps'),
	(444683, 102, '2015-03-15 00:59:56.000000', 'consum', 0.0213, 'lps'),
	(444684, 102, '2015-03-15 00:59:57.000000', 'consum', 0.0210, 'lps'),
	(444685, 102, '2015-03-15 00:59:58.000000', 'consum', 0.0216, 'lps'),
	(444686, 102, '2015-03-15 00:59:59.000000', 'consum', 0.0225, 'lps'),
	(444687, 102, '2015-03-15 01:00:00.000000', 'consum', 0.0212, 'lps'),
	(444688, 102, '2015-03-15 01:00:01.000000', 'consum', 0.0211, 'lps'),
	(444689, 102, '2015-03-15 01:00:02.000000', 'consum', 0.0211, 'lps'),
	(444690, 102, '2015-03-15 01:00:03.000000', 'consum', 0.0213, 'lps'),
	(444691, 102, '2015-03-15 01:00:04.000000', 'consum', 0.0224, 'lps'),
	(444692, 102, '2015-03-15 01:00:05.000000', 'consum', 0.0215, 'lps'),
	(444693, 102, '2015-03-15 01:00:06.000000', 'consum', 0.0212, 'lps'),
	(444694, 102, '2015-03-15 01:00:07.000000', 'consum', 0.0223, 'lps'),
	(444695, 102, '2015-03-15 01:00:08.000000', 'consum', 0.0216, 'lps'),
	(444696, 102, '2015-03-15 01:00:09.000000', 'consum', 0.0221, 'lps'),
	(444697, 102, '2015-03-15 01:00:10.000000', 'consum', 0.0226, 'lps'),
	(444698, 102, '2015-03-15 01:00:11.000000', 'consum', 0.0225, 'lps'),
	(444699, 102, '2015-03-15 01:00:12.000000', 'consum', 0.0217, 'lps'),
	(444700, 102, '2015-03-15 01:00:13.000000', 'consum', 0.0219, 'lps'),
	(444701, 102, '2015-03-15 01:00:14.000000', 'consum', 0.0217, 'lps'),
	(444702, 102, '2015-03-15 01:00:15.000000', 'consum', 0.0217, 'lps'),
	(444703, 102, '2015-03-15 01:00:16.000000', 'consum', 0.0226, 'lps'),
	(444704, 102, '2015-03-15 01:00:17.000000', 'consum', 0.0216, 'lps'),
	(444705, 102, '2015-03-15 01:00:18.000000', 'consum', 0.0212, 'lps'),
	(444706, 102, '2015-03-15 01:00:19.000000', 'consum', 0.0218, 'lps'),
	(444707, 102, '2015-03-15 01:00:20.000000', 'consum', 0.0225, 'lps'),
	(444708, 102, '2015-03-15 01:00:21.000000', 'consum', 0.0227, 'lps'),
	(444709, 102, '2015-03-15 01:00:22.000000', 'consum', 0.0216, 'lps'),
	(444710, 102, '2015-03-15 01:00:23.000000', 'consum', 0.0226, 'lps'),
	(444711, 102, '2015-03-15 01:00:24.000000', 'consum', 0.0217, 'lps'),
	(444712, 102, '2015-03-15 01:00:25.000000', 'consum', 0.0214, 'lps'),
	(444713, 102, '2015-03-15 01:00:26.000000', 'consum', 0.0213, 'lps'),
	(444714, 102, '2015-03-15 01:00:27.000000', 'consum', 0.0211, 'lps'),
	(444715, 102, '2015-03-15 01:00:28.000000', 'consum', 0.0225, 'lps'),
	(444716, 102, '2015-03-15 01:00:29.000000', 'consum', 0.0210, 'lps'),
	(444717, 102, '2015-03-15 01:00:30.000000', 'consum', 0.0218, 'lps'),
	(444718, 102, '2015-03-15 01:00:31.000000', 'consum', 0.0216, 'lps'),
	(444719, 102, '2015-03-15 01:00:32.000000', 'consum', 0.0217, 'lps'),
	(444720, 102, '2015-03-15 01:00:33.000000', 'consum', 0.0211, 'lps'),
	(444721, 102, '2015-03-15 01:00:34.000000', 'consum', 0.0210, 'lps'),
	(444722, 102, '2015-03-15 01:00:35.000000', 'consum', 0.0226, 'lps'),
	(444723, 102, '2015-03-15 01:00:36.000000', 'consum', 0.0219, 'lps'),
	(444724, 102, '2015-03-15 01:00:37.000000', 'consum', 0.0227, 'lps'),
	(444725, 102, '2015-03-15 01:00:38.000000', 'consum', 0.0214, 'lps'),
	(444726, 102, '2015-03-15 01:00:39.000000', 'consum', 0.0216, 'lps'),
	(444727, 102, '2015-03-15 01:00:40.000000', 'consum', 0.0212, 'lps'),
	(444728, 102, '2015-03-15 01:00:41.000000', 'consum', 0.0218, 'lps'),
	(444729, 102, '2015-03-15 01:00:42.000000', 'consum', 0.0211, 'lps'),
	(444730, 102, '2015-03-15 01:00:43.000000', 'consum', 0.0224, 'lps'),
	(444731, 102, '2015-03-15 01:00:44.000000', 'consum', 0.0226, 'lps'),
	(444732, 102, '2015-03-15 01:00:45.000000', 'consum', 0.0213, 'lps'),
	(444733, 102, '2015-03-15 01:00:46.000000', 'consum', 0.0213, 'lps'),
	(444734, 102, '2015-03-15 01:00:47.000000', 'consum', 0.0215, 'lps'),
	(444735, 102, '2015-03-15 01:00:48.000000', 'consum', 0.0226, 'lps'),
	(444736, 102, '2015-03-15 01:00:49.000000', 'consum', 0.0224, 'lps'),
	(444737, 102, '2015-03-15 01:00:50.000000', 'consum', 0.0212, 'lps'),
	(444738, 102, '2015-03-15 01:00:51.000000', 'consum', 0.0214, 'lps'),
	(444739, 102, '2015-03-15 01:00:52.000000', 'consum', 0.0224, 'lps'),
	(444740, 102, '2015-03-15 01:00:53.000000', 'consum', 0.0215, 'lps'),
	(444741, 102, '2015-03-15 01:00:54.000000', 'consum', 0.0213, 'lps'),
	(444742, 102, '2015-03-15 01:00:55.000000', 'consum', 0.0227, 'lps'),
	(444743, 102, '2015-03-15 01:00:56.000000', 'consum', 0.0215, 'lps'),
	(444744, 102, '2015-03-15 01:00:57.000000', 'consum', 0.0220, 'lps'),
	(444745, 102, '2015-03-15 01:00:58.000000', 'consum', 0.0211, 'lps'),
	(444746, 102, '2015-03-15 01:00:59.000000', 'consum', 0.0219, 'lps'),
	(444747, 102, '2015-03-15 01:01:00.000000', 'consum', 0.0220, 'lps'),
	(444748, 102, '2015-03-15 01:01:01.000000', 'consum', 0.0213, 'lps'),
	(444749, 102, '2015-03-15 01:01:02.000000', 'consum', 0.0214, 'lps'),
	(444750, 102, '2015-03-15 01:01:03.000000', 'consum', 0.0221, 'lps'),
	(444751, 102, '2015-03-15 01:01:04.000000', 'consum', 0.0218, 'lps'),
	(444752, 102, '2015-03-15 01:01:05.000000', 'consum', 0.0216, 'lps'),
	(444753, 102, '2015-03-15 01:01:06.000000', 'consum', 0.0219, 'lps'),
	(444754, 102, '2015-03-15 01:01:07.000000', 'consum', 0.0217, 'lps'),
	(444755, 102, '2015-03-15 01:01:08.000000', 'consum', 0.0218, 'lps'),
	(444756, 102, '2015-03-15 01:01:09.000000', 'consum', 0.0210, 'lps'),
	(444757, 102, '2015-03-15 01:01:10.000000', 'consum', 0.0226, 'lps'),
	(444758, 102, '2015-03-15 01:01:11.000000', 'consum', 0.0218, 'lps'),
	(444759, 102, '2015-03-15 01:01:12.000000', 'consum', 0.0219, 'lps'),
	(444760, 102, '2015-03-15 01:01:13.000000', 'consum', 0.0216, 'lps'),
	(444761, 102, '2015-03-15 01:01:14.000000', 'consum', 0.0213, 'lps'),
	(444762, 102, '2015-03-15 01:01:15.000000', 'consum', 0.0223, 'lps'),
	(444763, 102, '2015-03-15 01:01:16.000000', 'consum', 0.0215, 'lps'),
	(444764, 102, '2015-03-15 01:01:17.000000', 'consum', 0.0212, 'lps'),
	(444765, 102, '2015-03-15 01:01:18.000000', 'consum', 0.0225, 'lps'),
	(444766, 102, '2015-03-15 01:01:19.000000', 'consum', 0.0227, 'lps'),
	(444767, 102, '2015-03-15 01:01:20.000000', 'consum', 0.0211, 'lps'),
	(444768, 102, '2015-03-15 01:01:21.000000', 'consum', 0.0222, 'lps'),
	(444769, 102, '2015-03-15 01:01:22.000000', 'consum', 0.0213, 'lps'),
	(444770, 102, '2015-03-15 01:01:23.000000', 'consum', 0.0225, 'lps'),
	(444771, 102, '2015-03-15 01:01:24.000000', 'consum', 0.0222, 'lps'),
	(444772, 102, '2015-03-15 01:01:25.000000', 'consum', 0.0227, 'lps'),
	(444773, 102, '2015-03-15 01:01:26.000000', 'consum', 0.0224, 'lps'),
	(444774, 102, '2015-03-15 01:01:27.000000', 'consum', 0.0210, 'lps'),
	(444775, 102, '2015-03-15 01:01:28.000000', 'consum', 0.0224, 'lps'),
	(444776, 102, '2015-03-15 01:01:29.000000', 'consum', 0.0225, 'lps'),
	(444777, 102, '2015-03-15 01:01:30.000000', 'consum', 0.0227, 'lps'),
	(444778, 102, '2015-03-15 01:01:31.000000', 'consum', 0.0215, 'lps'),
	(444779, 102, '2015-03-15 01:01:32.000000', 'consum', 0.0220, 'lps'),
	(444780, 102, '2015-03-15 01:01:33.000000', 'consum', 0.0227, 'lps'),
	(444781, 102, '2015-03-15 01:01:34.000000', 'consum', 0.0213, 'lps'),
	(444782, 102, '2015-03-15 01:01:35.000000', 'consum', 0.0226, 'lps'),
	(444783, 102, '2015-03-15 01:01:36.000000', 'consum', 0.0212, 'lps'),
	(444784, 102, '2015-03-15 01:01:37.000000', 'consum', 0.0225, 'lps'),
	(444785, 102, '2015-03-15 01:01:38.000000', 'consum', 0.0226, 'lps'),
	(444786, 102, '2015-03-15 01:01:39.000000', 'consum', 0.0211, 'lps'),
	(444787, 102, '2015-03-15 01:01:40.000000', 'consum', 0.0222, 'lps'),
	(444788, 102, '2015-03-15 01:01:41.000000', 'consum', 0.0212, 'lps'),
	(444789, 102, '2015-03-15 01:01:42.000000', 'consum', 0.0220, 'lps'),
	(444790, 102, '2015-03-15 01:01:43.000000', 'consum', 0.0218, 'lps'),
	(444791, 102, '2015-03-15 01:01:44.000000', 'consum', 0.0220, 'lps'),
	(444792, 102, '2015-03-15 01:01:45.000000', 'consum', 0.0218, 'lps'),
	(444793, 102, '2015-03-15 01:01:46.000000', 'consum', 0.0220, 'lps'),
	(444794, 102, '2015-03-15 01:01:47.000000', 'consum', 0.0217, 'lps'),
	(444795, 102, '2015-03-15 01:01:48.000000', 'consum', 0.0219, 'lps'),
	(444796, 102, '2015-03-15 01:01:49.000000', 'consum', 0.0216, 'lps'),
	(444797, 102, '2015-03-15 01:01:50.000000', 'consum', 0.0213, 'lps'),
	(444798, 102, '2015-03-15 01:01:51.000000', 'consum', 0.0225, 'lps'),
	(444799, 102, '2015-03-15 01:01:52.000000', 'consum', 0.0223, 'lps'),
	(444800, 102, '2015-03-15 01:01:53.000000', 'consum', 0.0211, 'lps'),
	(444801, 102, '2015-03-15 01:01:54.000000', 'consum', 0.0215, 'lps'),
	(444802, 102, '2015-03-15 01:01:55.000000', 'consum', 0.0213, 'lps'),
	(444803, 102, '2015-03-15 01:01:56.000000', 'consum', 0.0227, 'lps'),
	(444804, 102, '2015-03-15 01:01:57.000000', 'consum', 0.0216, 'lps'),
	(444805, 102, '2015-03-15 01:01:58.000000', 'consum', 0.0226, 'lps'),
	(444806, 102, '2015-03-15 01:01:59.000000', 'consum', 0.0217, 'lps'),
	(444807, 102, '2015-03-15 01:02:00.000000', 'consum', 0.0218, 'lps'),
	(444808, 102, '2015-03-15 01:02:01.000000', 'consum', 0.0210, 'lps'),
	(444809, 102, '2015-03-15 01:02:02.000000', 'consum', 0.0221, 'lps'),
	(444810, 102, '2015-03-15 01:02:03.000000', 'consum', 0.0211, 'lps'),
	(444811, 102, '2015-03-15 01:02:04.000000', 'consum', 0.0219, 'lps'),
	(444812, 102, '2015-03-15 01:02:05.000000', 'consum', 0.0216, 'lps'),
	(444813, 102, '2015-03-15 01:02:06.000000', 'consum', 0.0215, 'lps'),
	(444814, 102, '2015-03-15 01:02:07.000000', 'consum', 0.0217, 'lps'),
	(444815, 102, '2015-03-15 01:02:08.000000', 'consum', 0.0211, 'lps'),
	(444816, 102, '2015-03-15 01:02:09.000000', 'consum', 0.0211, 'lps'),
	(444817, 102, '2015-03-15 01:02:10.000000', 'consum', 0.0216, 'lps'),
	(444818, 102, '2015-03-15 01:02:11.000000', 'consum', 0.0218, 'lps'),
	(444819, 102, '2015-03-15 01:02:12.000000', 'consum', 0.0213, 'lps'),
	(444820, 102, '2015-03-15 01:02:13.000000', 'consum', 0.0220, 'lps'),
	(444821, 102, '2015-03-15 01:02:14.000000', 'consum', 0.0215, 'lps'),
	(444822, 102, '2015-03-15 01:02:15.000000', 'consum', 0.0222, 'lps'),
	(444823, 102, '2015-03-15 01:02:16.000000', 'consum', 0.0222, 'lps'),
	(444824, 102, '2015-03-15 01:02:17.000000', 'consum', 0.0215, 'lps'),
	(444825, 102, '2015-03-15 01:02:18.000000', 'consum', 0.0217, 'lps'),
	(444826, 102, '2015-03-15 01:02:19.000000', 'consum', 0.0215, 'lps'),
	(444827, 102, '2015-03-15 01:02:20.000000', 'consum', 0.0212, 'lps'),
	(444828, 102, '2015-03-15 01:02:21.000000', 'consum', 0.0223, 'lps'),
	(444829, 102, '2015-03-15 01:02:22.000000', 'consum', 0.0218, 'lps'),
	(444830, 102, '2015-03-15 01:02:23.000000', 'consum', 0.0227, 'lps'),
	(444831, 102, '2015-03-15 01:02:24.000000', 'consum', 0.0217, 'lps'),
	(444832, 102, '2015-03-15 01:02:25.000000', 'consum', 0.0214, 'lps'),
	(444833, 102, '2015-03-15 01:02:26.000000', 'consum', 0.0225, 'lps'),
	(444834, 102, '2015-03-15 01:02:27.000000', 'consum', 0.0222, 'lps'),
	(444835, 102, '2015-03-15 01:02:28.000000', 'consum', 0.0223, 'lps'),
	(444836, 102, '2015-03-15 01:02:29.000000', 'consum', 0.0223, 'lps'),
	(444837, 102, '2015-03-15 01:02:30.000000', 'consum', 0.0218, 'lps'),
	(444838, 102, '2015-03-15 01:02:31.000000', 'consum', 0.0210, 'lps'),
	(444839, 102, '2015-03-15 01:02:32.000000', 'consum', 0.0226, 'lps'),
	(444840, 102, '2015-03-15 01:02:33.000000', 'consum', 0.0215, 'lps'),
	(444841, 102, '2015-03-15 01:02:34.000000', 'consum', 0.0224, 'lps'),
	(444842, 102, '2015-03-15 01:02:35.000000', 'consum', 0.0214, 'lps'),
	(444843, 102, '2015-03-15 01:02:36.000000', 'consum', 0.0222, 'lps'),
	(444844, 102, '2015-03-15 01:02:37.000000', 'consum', 0.0222, 'lps'),
	(444845, 102, '2015-03-15 01:02:38.000000', 'consum', 0.0218, 'lps'),
	(444846, 102, '2015-03-15 01:02:39.000000', 'consum', 0.0214, 'lps'),
	(444847, 102, '2015-03-15 01:02:40.000000', 'consum', 0.0225, 'lps'),
	(444848, 102, '2015-03-15 01:02:41.000000', 'consum', 0.0220, 'lps'),
	(444849, 102, '2015-03-15 01:02:42.000000', 'consum', 0.0214, 'lps'),
	(444850, 102, '2015-03-15 01:02:43.000000', 'consum', 0.0219, 'lps'),
	(444851, 102, '2015-03-15 01:02:44.000000', 'consum', 0.0226, 'lps'),
	(444852, 102, '2015-03-15 01:02:45.000000', 'consum', 0.0225, 'lps'),
	(444853, 102, '2015-03-15 01:02:46.000000', 'consum', 0.0222, 'lps'),
	(444854, 102, '2015-03-15 01:02:47.000000', 'consum', 0.0224, 'lps'),
	(444855, 102, '2015-03-15 01:02:48.000000', 'consum', 0.0210, 'lps'),
	(444856, 102, '2015-03-15 01:02:49.000000', 'consum', 0.0222, 'lps'),
	(444857, 102, '2015-03-15 01:02:50.000000', 'consum', 0.0218, 'lps'),
	(444858, 102, '2015-03-15 01:02:51.000000', 'consum', 0.0215, 'lps'),
	(444859, 102, '2015-03-15 01:02:52.000000', 'consum', 0.0210, 'lps'),
	(444860, 102, '2015-03-15 01:02:53.000000', 'consum', 0.0214, 'lps'),
	(444861, 102, '2015-03-15 01:02:54.000000', 'consum', 0.0213, 'lps'),
	(444862, 102, '2015-03-15 01:02:55.000000', 'consum', 0.0211, 'lps'),
	(444863, 102, '2015-03-15 01:02:56.000000', 'consum', 0.0227, 'lps'),
	(444864, 102, '2015-03-15 01:02:57.000000', 'consum', 0.0220, 'lps'),
	(444865, 102, '2015-03-15 01:02:58.000000', 'consum', 0.0211, 'lps'),
	(444866, 102, '2015-03-15 01:02:59.000000', 'consum', 0.0220, 'lps'),
	(444867, 102, '2015-03-15 01:03:00.000000', 'consum', 0.0220, 'lps'),
	(444868, 102, '2015-03-15 01:03:01.000000', 'consum', 0.0215, 'lps'),
	(444869, 102, '2015-03-15 01:03:02.000000', 'consum', 0.0221, 'lps'),
	(444870, 102, '2015-03-15 01:03:03.000000', 'consum', 0.0217, 'lps'),
	(444871, 102, '2015-03-15 01:03:04.000000', 'consum', 0.0212, 'lps'),
	(444872, 102, '2015-03-15 01:03:05.000000', 'consum', 0.0219, 'lps'),
	(444873, 102, '2015-03-15 01:03:06.000000', 'consum', 0.0212, 'lps'),
	(444874, 102, '2015-03-15 01:03:07.000000', 'consum', 0.0210, 'lps'),
	(444875, 102, '2015-03-15 01:03:08.000000', 'consum', 0.0224, 'lps'),
	(444876, 102, '2015-03-15 01:03:09.000000', 'consum', 0.0224, 'lps'),
	(444877, 102, '2015-03-15 01:03:10.000000', 'consum', 0.0224, 'lps'),
	(444878, 102, '2015-03-15 01:03:11.000000', 'consum', 0.0219, 'lps'),
	(444879, 102, '2015-03-15 01:03:12.000000', 'consum', 0.0211, 'lps'),
	(444880, 102, '2015-03-15 01:03:13.000000', 'consum', 0.0210, 'lps'),
	(444881, 102, '2015-03-15 01:03:14.000000', 'consum', 0.0226, 'lps'),
	(444882, 102, '2015-03-15 01:03:15.000000', 'consum', 0.0218, 'lps'),
	(444883, 102, '2015-03-15 01:03:16.000000', 'consum', 0.0222, 'lps'),
	(444884, 102, '2015-03-15 01:03:17.000000', 'consum', 0.0226, 'lps'),
	(444885, 102, '2015-03-15 01:03:18.000000', 'consum', 0.0217, 'lps'),
	(444886, 102, '2015-03-15 01:03:19.000000', 'consum', 0.0219, 'lps'),
	(444887, 102, '2015-03-15 01:03:20.000000', 'consum', 0.0214, 'lps'),
	(444888, 102, '2015-03-15 01:03:21.000000', 'consum', 0.0223, 'lps'),
	(444889, 102, '2015-03-15 01:03:22.000000', 'consum', 0.0210, 'lps'),
	(444890, 102, '2015-03-15 01:03:23.000000', 'consum', 0.0223, 'lps'),
	(444891, 102, '2015-03-15 01:03:24.000000', 'consum', 0.0221, 'lps'),
	(444892, 102, '2015-03-15 01:03:25.000000', 'consum', 0.0212, 'lps'),
	(444893, 102, '2015-03-15 01:03:26.000000', 'consum', 0.0220, 'lps'),
	(444894, 102, '2015-03-15 01:03:27.000000', 'consum', 0.0221, 'lps'),
	(444895, 102, '2015-03-15 01:03:28.000000', 'consum', 0.0215, 'lps'),
	(444896, 102, '2015-03-15 01:03:29.000000', 'consum', 0.0223, 'lps'),
	(444897, 102, '2015-03-15 01:03:30.000000', 'consum', 0.0225, 'lps'),
	(444898, 102, '2015-03-15 01:03:31.000000', 'consum', 0.0225, 'lps'),
	(444899, 102, '2015-03-15 01:03:32.000000', 'consum', 0.0226, 'lps'),
	(444900, 102, '2015-03-15 01:03:33.000000', 'consum', 0.0227, 'lps'),
	(444901, 102, '2015-03-15 01:03:34.000000', 'consum', 0.0212, 'lps'),
	(444902, 102, '2015-03-15 01:03:35.000000', 'consum', 0.0223, 'lps'),
	(444903, 102, '2015-03-15 01:03:36.000000', 'consum', 0.0214, 'lps'),
	(444904, 102, '2015-03-15 01:03:37.000000', 'consum', 0.0212, 'lps'),
	(444905, 102, '2015-03-15 01:03:38.000000', 'consum', 0.0225, 'lps'),
	(444906, 102, '2015-03-15 01:03:39.000000', 'consum', 0.0224, 'lps'),
	(444907, 102, '2015-03-15 01:03:40.000000', 'consum', 0.0219, 'lps'),
	(444908, 102, '2015-03-15 01:03:41.000000', 'consum', 0.0213, 'lps'),
	(444909, 102, '2015-03-15 01:03:42.000000', 'consum', 0.0215, 'lps'),
	(444910, 102, '2015-03-15 01:03:43.000000', 'consum', 0.0227, 'lps'),
	(444911, 102, '2015-03-15 01:03:44.000000', 'consum', 0.0225, 'lps'),
	(444912, 102, '2015-03-15 01:03:45.000000', 'consum', 0.0219, 'lps'),
	(444913, 102, '2015-03-15 01:03:46.000000', 'consum', 0.0212, 'lps'),
	(444914, 102, '2015-03-15 01:03:47.000000', 'consum', 0.0226, 'lps'),
	(444915, 102, '2015-03-15 01:03:48.000000', 'consum', 0.0216, 'lps'),
	(444916, 102, '2015-03-15 01:03:49.000000', 'consum', 0.0226, 'lps'),
	(444917, 102, '2015-03-15 01:03:50.000000', 'consum', 0.0220, 'lps'),
	(444918, 102, '2015-03-15 01:03:51.000000', 'consum', 0.0211, 'lps'),
	(444919, 102, '2015-03-15 01:03:52.000000', 'consum', 0.0221, 'lps'),
	(444920, 102, '2015-03-15 01:03:53.000000', 'consum', 0.0211, 'lps'),
	(444921, 102, '2015-03-15 01:03:54.000000', 'consum', 0.0216, 'lps'),
	(444922, 102, '2015-03-15 01:03:55.000000', 'consum', 0.0221, 'lps'),
	(444923, 102, '2015-03-15 01:03:56.000000', 'consum', 0.0210, 'lps'),
	(444924, 102, '2015-03-15 01:03:57.000000', 'consum', 0.0215, 'lps'),
	(444925, 102, '2015-03-15 01:03:58.000000', 'consum', 0.0215, 'lps'),
	(444926, 102, '2015-03-15 01:03:59.000000', 'consum', 0.0223, 'lps'),
	(444927, 102, '2015-03-15 01:04:00.000000', 'consum', 0.0223, 'lps'),
	(444928, 102, '2015-03-15 01:04:01.000000', 'consum', 0.0220, 'lps'),
	(444929, 102, '2015-03-15 01:04:02.000000', 'consum', 0.0219, 'lps'),
	(444930, 102, '2015-03-15 01:04:03.000000', 'consum', 0.0227, 'lps'),
	(444931, 102, '2015-03-15 01:04:04.000000', 'consum', 0.0216, 'lps'),
	(444932, 102, '2015-03-15 01:04:05.000000', 'consum', 0.0226, 'lps'),
	(444933, 102, '2015-03-15 01:04:06.000000', 'consum', 0.0215, 'lps'),
	(444934, 102, '2015-03-15 01:04:07.000000', 'consum', 0.0226, 'lps'),
	(444935, 102, '2015-03-15 01:04:08.000000', 'consum', 0.0221, 'lps'),
	(444936, 102, '2015-03-15 01:04:09.000000', 'consum', 0.0219, 'lps'),
	(444937, 102, '2015-03-15 01:04:10.000000', 'consum', 0.0223, 'lps'),
	(444938, 102, '2015-03-15 01:04:11.000000', 'consum', 0.0211, 'lps'),
	(444939, 102, '2015-03-15 01:04:12.000000', 'consum', 0.0212, 'lps'),
	(444940, 102, '2015-03-15 01:04:13.000000', 'consum', 0.0220, 'lps'),
	(444941, 102, '2015-03-15 01:04:14.000000', 'consum', 0.0215, 'lps'),
	(444942, 102, '2015-03-15 01:04:15.000000', 'consum', 0.0226, 'lps'),
	(444943, 102, '2015-03-15 01:04:16.000000', 'consum', 0.0221, 'lps'),
	(444944, 102, '2015-03-15 01:04:17.000000', 'consum', 0.0215, 'lps'),
	(444945, 102, '2015-03-15 01:04:18.000000', 'consum', 0.0223, 'lps'),
	(444946, 102, '2015-03-15 01:04:19.000000', 'consum', 0.0225, 'lps'),
	(444947, 102, '2015-03-15 01:04:20.000000', 'consum', 0.0210, 'lps'),
	(444948, 102, '2015-03-15 01:04:21.000000', 'consum', 0.0219, 'lps'),
	(444949, 102, '2015-03-15 01:04:22.000000', 'consum', 0.0220, 'lps'),
	(444950, 102, '2015-03-15 01:04:23.000000', 'consum', 0.0215, 'lps'),
	(444951, 102, '2015-03-15 01:04:24.000000', 'consum', 0.0223, 'lps'),
	(444952, 102, '2015-03-15 01:04:25.000000', 'consum', 0.0224, 'lps'),
	(444953, 102, '2015-03-15 01:04:26.000000', 'consum', 0.0223, 'lps'),
	(444954, 102, '2015-03-15 01:04:27.000000', 'consum', 0.0215, 'lps'),
	(444955, 102, '2015-03-15 01:04:28.000000', 'consum', 0.0214, 'lps'),
	(444956, 102, '2015-03-15 01:04:29.000000', 'consum', 0.0217, 'lps'),
	(444957, 102, '2015-03-15 01:04:30.000000', 'consum', 0.0214, 'lps'),
	(444958, 102, '2015-03-15 01:04:31.000000', 'consum', 0.0212, 'lps'),
	(444959, 102, '2015-03-15 01:04:32.000000', 'consum', 0.0226, 'lps'),
	(444960, 102, '2015-03-15 01:04:33.000000', 'consum', 0.0213, 'lps'),
	(444961, 102, '2015-03-15 01:04:34.000000', 'consum', 0.0214, 'lps'),
	(444962, 102, '2015-03-15 01:04:35.000000', 'consum', 0.0220, 'lps'),
	(444963, 102, '2015-03-15 01:04:36.000000', 'consum', 0.0214, 'lps'),
	(444964, 102, '2015-03-15 01:04:37.000000', 'consum', 0.0219, 'lps'),
	(444965, 102, '2015-03-15 01:04:38.000000', 'consum', 0.0224, 'lps'),
	(444966, 102, '2015-03-15 01:04:39.000000', 'consum', 0.0218, 'lps'),
	(444967, 102, '2015-03-15 01:04:40.000000', 'consum', 0.0226, 'lps'),
	(444968, 102, '2015-03-15 01:04:41.000000', 'consum', 0.0211, 'lps'),
	(444969, 102, '2015-03-15 01:04:42.000000', 'consum', 0.0224, 'lps'),
	(444970, 102, '2015-03-15 01:04:43.000000', 'consum', 0.0223, 'lps'),
	(444971, 102, '2015-03-15 01:04:44.000000', 'consum', 0.0215, 'lps'),
	(444972, 102, '2015-03-15 01:04:45.000000', 'consum', 0.0214, 'lps'),
	(444973, 102, '2015-03-15 01:04:46.000000', 'consum', 0.0215, 'lps'),
	(444974, 102, '2015-03-15 01:04:47.000000', 'consum', 0.0223, 'lps'),
	(444975, 102, '2015-03-15 01:04:48.000000', 'consum', 0.0223, 'lps'),
	(444976, 102, '2015-03-15 01:04:49.000000', 'consum', 0.0222, 'lps'),
	(444977, 102, '2015-03-15 01:04:50.000000', 'consum', 0.0213, 'lps'),
	(444978, 102, '2015-03-15 01:04:51.000000', 'consum', 0.0224, 'lps'),
	(444979, 102, '2015-03-15 01:04:52.000000', 'consum', 0.0217, 'lps'),
	(444980, 102, '2015-03-15 01:04:53.000000', 'consum', 0.0224, 'lps'),
	(444981, 102, '2015-03-15 01:04:54.000000', 'consum', 0.0222, 'lps'),
	(444982, 102, '2015-03-15 01:04:55.000000', 'consum', 0.0210, 'lps'),
	(444983, 102, '2015-03-15 01:04:56.000000', 'consum', 0.0212, 'lps'),
	(444984, 102, '2015-03-15 01:04:57.000000', 'consum', 0.0219, 'lps'),
	(444985, 102, '2015-03-15 01:04:58.000000', 'consum', 0.0214, 'lps'),
	(444986, 102, '2015-03-15 01:04:59.000000', 'consum', 0.0222, 'lps'),
	(444987, 102, '2015-03-15 01:05:00.000000', 'consum', 0.0223, 'lps'),
	(444988, 102, '2015-03-15 01:05:01.000000', 'consum', 0.0221, 'lps'),
	(444989, 102, '2015-03-15 01:05:02.000000', 'consum', 0.0227, 'lps'),
	(444990, 102, '2015-03-15 01:05:03.000000', 'consum', 0.0226, 'lps'),
	(444991, 102, '2015-03-15 01:05:04.000000', 'consum', 0.0220, 'lps'),
	(444992, 102, '2015-03-15 01:05:05.000000', 'consum', 0.0212, 'lps'),
	(444993, 102, '2015-03-15 01:05:06.000000', 'consum', 0.0211, 'lps'),
	(444994, 102, '2015-03-15 01:05:07.000000', 'consum', 0.0225, 'lps'),
	(444995, 102, '2015-03-15 01:05:08.000000', 'consum', 0.0211, 'lps'),
	(444996, 102, '2015-03-15 01:05:09.000000', 'consum', 0.0225, 'lps'),
	(444997, 102, '2015-03-15 01:05:10.000000', 'consum', 0.0210, 'lps'),
	(444998, 102, '2015-03-15 01:05:11.000000', 'consum', 0.0220, 'lps'),
	(444999, 102, '2015-03-15 01:05:12.000000', 'consum', 0.0226, 'lps'),
	(445000, 102, '2015-03-15 01:05:13.000000', 'consum', 0.0224, 'lps'),
	(445001, 102, '2015-03-15 01:05:14.000000', 'consum', 0.0215, 'lps'),
	(445002, 102, '2015-03-15 01:05:15.000000', 'consum', 0.0211, 'lps'),
	(445003, 102, '2015-03-15 01:05:16.000000', 'consum', 0.0219, 'lps'),
	(445004, 102, '2015-03-15 01:05:17.000000', 'consum', 0.0215, 'lps'),
	(445005, 102, '2015-03-15 01:05:18.000000', 'consum', 0.0210, 'lps'),
	(445006, 102, '2015-03-15 01:05:19.000000', 'consum', 0.0214, 'lps'),
	(445007, 102, '2015-03-15 01:05:20.000000', 'consum', 0.0212, 'lps'),
	(445008, 102, '2015-03-15 01:05:21.000000', 'consum', 0.0226, 'lps'),
	(445009, 102, '2015-03-15 01:05:22.000000', 'consum', 0.0212, 'lps'),
	(445010, 102, '2015-03-15 01:05:23.000000', 'consum', 0.0210, 'lps'),
	(445011, 102, '2015-03-15 01:05:24.000000', 'consum', 0.0223, 'lps'),
	(445012, 102, '2015-03-15 01:05:25.000000', 'consum', 0.0223, 'lps'),
	(445013, 102, '2015-03-15 01:05:26.000000', 'consum', 0.0216, 'lps'),
	(445014, 102, '2015-03-15 01:05:27.000000', 'consum', 0.0218, 'lps'),
	(445015, 102, '2015-03-15 01:05:28.000000', 'consum', 0.0216, 'lps'),
	(445016, 102, '2015-03-15 01:05:29.000000', 'consum', 0.0217, 'lps'),
	(445017, 102, '2015-03-15 01:05:30.000000', 'consum', 0.0210, 'lps'),
	(445018, 102, '2015-03-15 01:05:31.000000', 'consum', 0.0225, 'lps'),
	(445019, 102, '2015-03-15 01:05:32.000000', 'consum', 0.0211, 'lps'),
	(445020, 102, '2015-03-15 01:05:33.000000', 'consum', 0.0210, 'lps'),
	(445021, 102, '2015-03-15 01:05:34.000000', 'consum', 0.0225, 'lps'),
	(445022, 102, '2015-03-15 01:05:35.000000', 'consum', 0.0214, 'lps'),
	(445023, 102, '2015-03-15 01:05:36.000000', 'consum', 0.0223, 'lps'),
	(445024, 102, '2015-03-15 01:05:37.000000', 'consum', 0.0224, 'lps'),
	(445025, 102, '2015-03-15 01:05:38.000000', 'consum', 0.0227, 'lps'),
	(445026, 102, '2015-03-15 01:05:39.000000', 'consum', 0.0215, 'lps'),
	(445027, 102, '2015-03-15 01:05:40.000000', 'consum', 0.0222, 'lps'),
	(445028, 102, '2015-03-15 01:05:41.000000', 'consum', 0.0218, 'lps'),
	(445029, 102, '2015-03-15 01:05:42.000000', 'consum', 0.0213, 'lps'),
	(445030, 102, '2015-03-15 01:05:43.000000', 'consum', 0.0222, 'lps'),
	(445031, 102, '2015-03-15 01:05:44.000000', 'consum', 0.0224, 'lps'),
	(445032, 102, '2015-03-15 01:05:45.000000', 'consum', 0.0227, 'lps'),
	(445033, 102, '2015-03-15 01:05:46.000000', 'consum', 0.0217, 'lps'),
	(445034, 102, '2015-03-15 01:05:47.000000', 'consum', 0.0214, 'lps'),
	(445035, 102, '2015-03-15 01:05:48.000000', 'consum', 0.0225, 'lps'),
	(445036, 102, '2015-03-15 01:05:49.000000', 'consum', 0.0219, 'lps'),
	(445037, 102, '2015-03-15 01:05:50.000000', 'consum', 0.0211, 'lps'),
	(445038, 102, '2015-03-15 01:05:51.000000', 'consum', 0.0226, 'lps'),
	(445039, 102, '2015-03-15 01:05:52.000000', 'consum', 0.0216, 'lps'),
	(445040, 102, '2015-03-15 01:05:53.000000', 'consum', 0.0211, 'lps'),
	(445041, 102, '2015-03-15 01:05:54.000000', 'consum', 0.0214, 'lps'),
	(445042, 102, '2015-03-15 01:05:55.000000', 'consum', 0.0226, 'lps'),
	(445043, 102, '2015-03-15 01:05:56.000000', 'consum', 0.0227, 'lps'),
	(445044, 102, '2015-03-15 01:05:57.000000', 'consum', 0.0212, 'lps'),
	(445045, 102, '2015-03-15 01:05:58.000000', 'consum', 0.0222, 'lps'),
	(445046, 102, '2015-03-15 01:05:59.000000', 'consum', 0.0212, 'lps'),
	(445047, 102, '2015-03-15 01:06:00.000000', 'consum', 0.0219, 'lps'),
	(445048, 102, '2015-03-15 01:06:01.000000', 'consum', 0.0216, 'lps'),
	(445049, 102, '2015-03-15 01:06:02.000000', 'consum', 0.0211, 'lps'),
	(445050, 102, '2015-03-15 01:06:03.000000', 'consum', 0.0216, 'lps'),
	(445051, 102, '2015-03-15 01:06:04.000000', 'consum', 0.0218, 'lps'),
	(445052, 102, '2015-03-15 01:06:05.000000', 'consum', 0.0215, 'lps'),
	(445053, 102, '2015-03-15 01:06:06.000000', 'consum', 0.0210, 'lps'),
	(445054, 102, '2015-03-15 01:06:07.000000', 'consum', 0.0216, 'lps'),
	(445055, 102, '2015-03-15 01:06:08.000000', 'consum', 0.0222, 'lps'),
	(445056, 102, '2015-03-15 01:06:09.000000', 'consum', 0.0216, 'lps'),
	(445057, 102, '2015-03-15 01:06:10.000000', 'consum', 0.0221, 'lps'),
	(445058, 102, '2015-03-15 01:06:11.000000', 'consum', 0.0212, 'lps'),
	(445059, 102, '2015-03-15 01:06:12.000000', 'consum', 0.0226, 'lps'),
	(445060, 102, '2015-03-15 01:06:13.000000', 'consum', 0.0210, 'lps'),
	(445061, 102, '2015-03-15 01:06:14.000000', 'consum', 0.0216, 'lps'),
	(445062, 102, '2015-03-15 01:06:15.000000', 'consum', 0.0225, 'lps'),
	(445063, 102, '2015-03-15 01:06:16.000000', 'consum', 0.0213, 'lps'),
	(445064, 102, '2015-03-15 01:06:17.000000', 'consum', 0.0216, 'lps'),
	(445065, 102, '2015-03-15 01:06:18.000000', 'consum', 0.0214, 'lps'),
	(445066, 102, '2015-03-15 01:06:19.000000', 'consum', 0.0212, 'lps'),
	(445067, 102, '2015-03-15 01:06:20.000000', 'consum', 0.0226, 'lps'),
	(445068, 102, '2015-03-15 01:06:21.000000', 'consum', 0.0213, 'lps'),
	(445069, 102, '2015-03-15 01:06:22.000000', 'consum', 0.0214, 'lps'),
	(445070, 102, '2015-03-15 01:06:23.000000', 'consum', 0.0222, 'lps'),
	(445071, 102, '2015-03-15 01:06:24.000000', 'consum', 0.0223, 'lps'),
	(445072, 102, '2015-03-15 01:06:25.000000', 'consum', 0.0221, 'lps'),
	(445073, 102, '2015-03-15 01:06:26.000000', 'consum', 0.0227, 'lps'),
	(445074, 102, '2015-03-15 01:06:27.000000', 'consum', 0.0224, 'lps'),
	(445075, 102, '2015-03-15 01:06:28.000000', 'consum', 0.0215, 'lps'),
	(445076, 102, '2015-03-15 01:06:29.000000', 'consum', 0.0227, 'lps'),
	(445077, 102, '2015-03-15 01:06:30.000000', 'consum', 0.0227, 'lps'),
	(445078, 102, '2015-03-15 01:06:31.000000', 'consum', 0.0211, 'lps'),
	(445079, 102, '2015-03-15 01:06:32.000000', 'consum', 0.0216, 'lps'),
	(445080, 102, '2015-03-15 01:06:33.000000', 'consum', 0.0220, 'lps'),
	(445081, 102, '2015-03-15 01:06:34.000000', 'consum', 0.0223, 'lps'),
	(445082, 102, '2015-03-15 01:06:35.000000', 'consum', 0.0211, 'lps'),
	(445083, 102, '2015-03-15 01:06:36.000000', 'consum', 0.0212, 'lps'),
	(445084, 102, '2015-03-15 01:06:37.000000', 'consum', 0.0217, 'lps'),
	(445085, 102, '2015-03-15 01:06:38.000000', 'consum', 0.0221, 'lps'),
	(445086, 102, '2015-03-15 01:06:39.000000', 'consum', 0.0210, 'lps'),
	(445087, 102, '2015-03-15 01:06:40.000000', 'consum', 0.0214, 'lps'),
	(445088, 102, '2015-03-15 01:06:41.000000', 'consum', 0.0214, 'lps'),
	(445089, 102, '2015-03-15 01:06:42.000000', 'consum', 0.0216, 'lps'),
	(445090, 102, '2015-03-15 01:06:43.000000', 'consum', 0.0212, 'lps'),
	(445091, 102, '2015-03-15 01:06:44.000000', 'consum', 0.0220, 'lps'),
	(445092, 102, '2015-03-15 01:06:45.000000', 'consum', 0.0218, 'lps'),
	(445093, 102, '2015-03-15 01:06:46.000000', 'consum', 0.0222, 'lps'),
	(445094, 102, '2015-03-15 01:06:47.000000', 'consum', 0.0226, 'lps'),
	(445095, 102, '2015-03-15 01:06:48.000000', 'consum', 0.0219, 'lps'),
	(445096, 102, '2015-03-15 01:06:49.000000', 'consum', 0.0224, 'lps'),
	(445097, 102, '2015-03-15 01:06:50.000000', 'consum', 0.0218, 'lps'),
	(445098, 102, '2015-03-15 01:06:51.000000', 'consum', 0.0210, 'lps'),
	(445099, 102, '2015-03-15 01:06:52.000000', 'consum', 0.0223, 'lps'),
	(445100, 102, '2015-03-15 01:06:53.000000', 'consum', 0.0220, 'lps'),
	(445101, 102, '2015-03-15 01:06:54.000000', 'consum', 0.0220, 'lps'),
	(445102, 102, '2015-03-15 01:06:55.000000', 'consum', 0.0214, 'lps'),
	(445103, 102, '2015-03-15 01:06:56.000000', 'consum', 0.0218, 'lps'),
	(445104, 102, '2015-03-15 01:06:57.000000', 'consum', 0.0222, 'lps'),
	(445105, 102, '2015-03-15 01:06:58.000000', 'consum', 0.0211, 'lps'),
	(445106, 102, '2015-03-15 01:06:59.000000', 'consum', 0.0214, 'lps'),
	(445107, 102, '2015-03-15 01:07:00.000000', 'consum', 0.0226, 'lps'),
	(445108, 102, '2015-03-15 01:07:01.000000', 'consum', 0.0227, 'lps'),
	(445109, 102, '2015-03-15 01:07:02.000000', 'consum', 0.0211, 'lps'),
	(445110, 102, '2015-03-15 01:07:03.000000', 'consum', 0.0219, 'lps'),
	(445111, 102, '2015-03-15 01:07:04.000000', 'consum', 0.0215, 'lps'),
	(445112, 102, '2015-03-15 01:07:05.000000', 'consum', 0.0225, 'lps'),
	(445113, 102, '2015-03-15 01:07:06.000000', 'consum', 0.0220, 'lps'),
	(445114, 102, '2015-03-15 01:07:07.000000', 'consum', 0.0213, 'lps'),
	(445115, 102, '2015-03-15 01:07:08.000000', 'consum', 0.0215, 'lps'),
	(445116, 102, '2015-03-15 01:07:09.000000', 'consum', 0.0210, 'lps'),
	(445117, 102, '2015-03-15 01:07:10.000000', 'consum', 0.0210, 'lps'),
	(445118, 102, '2015-03-15 01:07:11.000000', 'consum', 0.0212, 'lps'),
	(445119, 102, '2015-03-15 01:07:12.000000', 'consum', 0.0221, 'lps'),
	(445120, 102, '2015-03-15 01:07:13.000000', 'consum', 0.0222, 'lps'),
	(445121, 102, '2015-03-15 01:07:14.000000', 'consum', 0.0218, 'lps'),
	(445122, 102, '2015-03-15 01:07:15.000000', 'consum', 0.0217, 'lps'),
	(445123, 102, '2015-03-15 01:07:16.000000', 'consum', 0.0221, 'lps'),
	(445124, 102, '2015-03-15 01:07:17.000000', 'consum', 0.0225, 'lps'),
	(445125, 102, '2015-03-15 01:07:18.000000', 'consum', 0.0217, 'lps'),
	(445126, 102, '2015-03-15 01:07:19.000000', 'consum', 0.0218, 'lps'),
	(445127, 102, '2015-03-15 01:07:20.000000', 'consum', 0.0214, 'lps'),
	(445128, 102, '2015-03-15 01:07:21.000000', 'consum', 0.0222, 'lps'),
	(445129, 102, '2015-03-15 01:07:22.000000', 'consum', 0.0222, 'lps'),
	(445130, 102, '2015-03-15 01:07:23.000000', 'consum', 0.0215, 'lps'),
	(445131, 102, '2015-03-15 01:07:24.000000', 'consum', 0.0220, 'lps'),
	(445132, 102, '2015-03-15 01:07:25.000000', 'consum', 0.0211, 'lps'),
	(445133, 102, '2015-03-15 01:07:26.000000', 'consum', 0.0218, 'lps'),
	(445134, 102, '2015-03-15 01:07:27.000000', 'consum', 0.0215, 'lps'),
	(445135, 102, '2015-03-15 01:07:28.000000', 'consum', 0.0210, 'lps'),
	(445136, 102, '2015-03-15 01:07:29.000000', 'consum', 0.0212, 'lps'),
	(445137, 102, '2015-03-15 01:07:30.000000', 'consum', 0.0223, 'lps'),
	(445138, 102, '2015-03-15 01:07:31.000000', 'consum', 0.0213, 'lps'),
	(445139, 102, '2015-03-15 01:07:32.000000', 'consum', 0.0222, 'lps'),
	(445140, 102, '2015-03-15 01:07:33.000000', 'consum', 0.0226, 'lps'),
	(445141, 102, '2015-03-15 01:07:34.000000', 'consum', 0.0221, 'lps'),
	(445142, 102, '2015-03-15 01:07:35.000000', 'consum', 0.0216, 'lps'),
	(445143, 102, '2015-03-15 01:07:36.000000', 'consum', 0.0225, 'lps'),
	(445144, 102, '2015-03-15 01:07:37.000000', 'consum', 0.0214, 'lps'),
	(445145, 102, '2015-03-15 01:07:38.000000', 'consum', 0.0223, 'lps'),
	(445146, 102, '2015-03-15 01:07:39.000000', 'consum', 0.0227, 'lps'),
	(445147, 102, '2015-03-15 01:07:40.000000', 'consum', 0.0219, 'lps'),
	(445148, 102, '2015-03-15 01:07:41.000000', 'consum', 0.0221, 'lps'),
	(445149, 102, '2015-03-15 01:07:42.000000', 'consum', 0.0224, 'lps'),
	(445150, 102, '2015-03-15 01:07:43.000000', 'consum', 0.0227, 'lps'),
	(445151, 102, '2015-03-15 01:07:44.000000', 'consum', 0.0219, 'lps'),
	(445152, 102, '2015-03-15 01:07:45.000000', 'consum', 0.0224, 'lps'),
	(445153, 102, '2015-03-15 01:07:46.000000', 'consum', 0.0216, 'lps'),
	(445154, 102, '2015-03-15 01:07:47.000000', 'consum', 0.0217, 'lps'),
	(445155, 102, '2015-03-15 01:07:48.000000', 'consum', 0.0226, 'lps'),
	(445156, 102, '2015-03-15 01:07:49.000000', 'consum', 0.0215, 'lps'),
	(445157, 102, '2015-03-15 01:07:50.000000', 'consum', 0.0224, 'lps'),
	(445158, 102, '2015-03-15 01:07:51.000000', 'consum', 0.0214, 'lps'),
	(445159, 102, '2015-03-15 01:07:52.000000', 'consum', 0.0221, 'lps'),
	(445160, 102, '2015-03-15 01:07:53.000000', 'consum', 0.0220, 'lps'),
	(445161, 102, '2015-03-15 01:07:54.000000', 'consum', 0.0226, 'lps'),
	(445162, 102, '2015-03-15 01:07:55.000000', 'consum', 0.0226, 'lps'),
	(445163, 102, '2015-03-15 01:07:56.000000', 'consum', 0.0224, 'lps'),
	(445164, 102, '2015-03-15 01:07:57.000000', 'consum', 0.0214, 'lps'),
	(445165, 102, '2015-03-15 01:07:58.000000', 'consum', 0.0224, 'lps'),
	(445166, 102, '2015-03-15 01:07:59.000000', 'consum', 0.0215, 'lps'),
	(445167, 102, '2015-03-15 01:08:00.000000', 'consum', 0.0213, 'lps'),
	(445168, 102, '2015-03-15 01:08:01.000000', 'consum', 0.0227, 'lps'),
	(445169, 102, '2015-03-15 01:08:02.000000', 'consum', 0.0215, 'lps'),
	(445170, 102, '2015-03-15 01:08:03.000000', 'consum', 0.0220, 'lps'),
	(445171, 102, '2015-03-15 01:08:04.000000', 'consum', 0.0210, 'lps'),
	(445172, 102, '2015-03-15 01:08:05.000000', 'consum', 0.0215, 'lps'),
	(445173, 102, '2015-03-15 01:08:06.000000', 'consum', 0.0220, 'lps'),
	(445174, 102, '2015-03-15 01:08:07.000000', 'consum', 0.0210, 'lps'),
	(445175, 102, '2015-03-15 01:08:08.000000', 'consum', 0.0213, 'lps'),
	(445176, 102, '2015-03-15 01:08:09.000000', 'consum', 0.0211, 'lps'),
	(445177, 102, '2015-03-15 01:08:10.000000', 'consum', 0.0222, 'lps'),
	(445178, 102, '2015-03-15 01:08:11.000000', 'consum', 0.0216, 'lps'),
	(445179, 102, '2015-03-15 01:08:12.000000', 'consum', 0.0219, 'lps'),
	(445180, 102, '2015-03-15 01:08:13.000000', 'consum', 0.0223, 'lps'),
	(445181, 102, '2015-03-15 01:08:14.000000', 'consum', 0.0212, 'lps'),
	(445182, 102, '2015-03-15 01:08:15.000000', 'consum', 0.0216, 'lps'),
	(445183, 102, '2015-03-15 01:08:16.000000', 'consum', 0.0218, 'lps'),
	(445184, 102, '2015-03-15 01:08:17.000000', 'consum', 0.0214, 'lps'),
	(445185, 102, '2015-03-15 01:08:18.000000', 'consum', 0.0226, 'lps'),
	(445186, 102, '2015-03-15 01:08:19.000000', 'consum', 0.0223, 'lps'),
	(445187, 102, '2015-03-15 01:08:20.000000', 'consum', 0.0226, 'lps'),
	(445188, 102, '2015-03-15 01:08:21.000000', 'consum', 0.0217, 'lps'),
	(445189, 102, '2015-03-15 01:08:22.000000', 'consum', 0.0217, 'lps'),
	(445190, 102, '2015-03-15 01:08:23.000000', 'consum', 0.0224, 'lps'),
	(445191, 102, '2015-03-15 01:08:24.000000', 'consum', 0.0224, 'lps'),
	(445192, 102, '2015-03-15 01:08:25.000000', 'consum', 0.0218, 'lps'),
	(445193, 102, '2015-03-15 01:08:26.000000', 'consum', 0.0211, 'lps'),
	(445194, 102, '2015-03-15 01:08:27.000000', 'consum', 0.0225, 'lps'),
	(445195, 102, '2015-03-15 01:08:28.000000', 'consum', 0.0210, 'lps'),
	(445196, 102, '2015-03-15 01:08:29.000000', 'consum', 0.0221, 'lps'),
	(445197, 102, '2015-03-15 01:08:30.000000', 'consum', 0.0210, 'lps'),
	(445198, 102, '2015-03-15 01:08:31.000000', 'consum', 0.0216, 'lps'),
	(445199, 102, '2015-03-15 01:08:32.000000', 'consum', 0.0223, 'lps'),
	(445200, 102, '2015-03-15 01:08:33.000000', 'consum', 0.0221, 'lps'),
	(445201, 102, '2015-03-15 01:08:34.000000', 'consum', 0.0226, 'lps'),
	(445202, 102, '2015-03-15 01:08:35.000000', 'consum', 0.0223, 'lps'),
	(445203, 102, '2015-03-15 01:08:36.000000', 'consum', 0.0225, 'lps'),
	(445204, 102, '2015-03-15 01:08:37.000000', 'consum', 0.0213, 'lps'),
	(445205, 102, '2015-03-15 01:08:38.000000', 'consum', 0.0214, 'lps'),
	(445206, 102, '2015-03-15 01:08:39.000000', 'consum', 0.0222, 'lps'),
	(445207, 102, '2015-03-15 01:08:40.000000', 'consum', 0.0221, 'lps'),
	(445208, 102, '2015-03-15 01:08:41.000000', 'consum', 0.0213, 'lps'),
	(445209, 102, '2015-03-15 01:08:42.000000', 'consum', 0.0227, 'lps'),
	(445210, 102, '2015-03-15 01:08:43.000000', 'consum', 0.0216, 'lps'),
	(445211, 102, '2015-03-15 01:08:44.000000', 'consum', 0.0225, 'lps'),
	(445212, 102, '2015-03-15 01:08:45.000000', 'consum', 0.0214, 'lps'),
	(445213, 102, '2015-03-15 01:08:46.000000', 'consum', 0.0220, 'lps'),
	(445214, 102, '2015-03-15 01:08:47.000000', 'consum', 0.0214, 'lps'),
	(445215, 102, '2015-03-15 01:08:48.000000', 'consum', 0.0216, 'lps'),
	(445216, 102, '2015-03-15 01:08:49.000000', 'consum', 0.0214, 'lps'),
	(445217, 102, '2015-03-15 01:08:50.000000', 'consum', 0.0227, 'lps'),
	(445218, 102, '2015-03-15 01:08:51.000000', 'consum', 0.0215, 'lps'),
	(445219, 102, '2015-03-15 01:08:52.000000', 'consum', 0.0218, 'lps'),
	(445220, 102, '2015-03-15 01:08:53.000000', 'consum', 0.0220, 'lps'),
	(445221, 102, '2015-03-15 01:08:54.000000', 'consum', 0.0219, 'lps'),
	(445222, 102, '2015-03-15 01:08:55.000000', 'consum', 0.0223, 'lps'),
	(445223, 102, '2015-03-15 01:08:56.000000', 'consum', 0.0212, 'lps'),
	(445224, 102, '2015-03-15 01:08:57.000000', 'consum', 0.0219, 'lps'),
	(445225, 102, '2015-03-15 01:08:58.000000', 'consum', 0.0212, 'lps'),
	(445226, 102, '2015-03-15 01:08:59.000000', 'consum', 0.0213, 'lps'),
	(445227, 102, '2015-03-15 01:09:00.000000', 'consum', 0.0219, 'lps'),
	(445228, 102, '2015-03-15 01:09:01.000000', 'consum', 0.0227, 'lps'),
	(445229, 102, '2015-03-15 01:09:02.000000', 'consum', 0.0217, 'lps'),
	(445230, 102, '2015-03-15 01:09:03.000000', 'consum', 0.0210, 'lps'),
	(445231, 102, '2015-03-15 01:09:04.000000', 'consum', 0.0225, 'lps'),
	(445232, 102, '2015-03-15 01:09:05.000000', 'consum', 0.0215, 'lps'),
	(445233, 102, '2015-03-15 01:09:06.000000', 'consum', 0.0227, 'lps'),
	(445234, 102, '2015-03-15 01:09:07.000000', 'consum', 0.0226, 'lps'),
	(445235, 102, '2015-03-15 01:09:08.000000', 'consum', 0.0222, 'lps'),
	(445236, 102, '2015-03-15 01:09:09.000000', 'consum', 0.0224, 'lps'),
	(445237, 102, '2015-03-15 01:09:10.000000', 'consum', 0.0223, 'lps'),
	(445238, 102, '2015-03-15 01:09:11.000000', 'consum', 0.0219, 'lps'),
	(445239, 102, '2015-03-15 01:09:12.000000', 'consum', 0.0215, 'lps'),
	(445240, 102, '2015-03-15 01:09:13.000000', 'consum', 0.0210, 'lps'),
	(445241, 102, '2015-03-15 01:09:14.000000', 'consum', 0.0211, 'lps'),
	(445242, 102, '2015-03-15 01:09:15.000000', 'consum', 0.0218, 'lps'),
	(445243, 102, '2015-03-15 01:09:16.000000', 'consum', 0.0210, 'lps'),
	(445244, 102, '2015-03-15 01:09:17.000000', 'consum', 0.0221, 'lps'),
	(445245, 102, '2015-03-15 01:09:18.000000', 'consum', 0.0213, 'lps'),
	(445246, 102, '2015-03-15 01:09:19.000000', 'consum', 0.0227, 'lps'),
	(445247, 102, '2015-03-15 01:09:20.000000', 'consum', 0.0217, 'lps'),
	(445248, 102, '2015-03-15 01:09:21.000000', 'consum', 0.0210, 'lps'),
	(445249, 102, '2015-03-15 01:09:22.000000', 'consum', 0.0210, 'lps'),
	(445250, 102, '2015-03-15 01:09:23.000000', 'consum', 0.0227, 'lps'),
	(445251, 102, '2015-03-15 01:09:24.000000', 'consum', 0.0223, 'lps'),
	(445252, 102, '2015-03-15 01:09:25.000000', 'consum', 0.0226, 'lps'),
	(445253, 102, '2015-03-15 01:09:26.000000', 'consum', 0.0216, 'lps'),
	(445254, 102, '2015-03-15 01:09:27.000000', 'consum', 0.0227, 'lps'),
	(445255, 102, '2015-03-15 01:09:28.000000', 'consum', 0.0225, 'lps'),
	(445256, 102, '2015-03-15 01:09:29.000000', 'consum', 0.0214, 'lps'),
	(445257, 102, '2015-03-15 01:09:30.000000', 'consum', 0.0222, 'lps'),
	(445258, 102, '2015-03-15 01:09:31.000000', 'consum', 0.0222, 'lps'),
	(445259, 102, '2015-03-15 01:09:32.000000', 'consum', 0.0218, 'lps'),
	(445260, 102, '2015-03-15 01:09:33.000000', 'consum', 0.0214, 'lps'),
	(445261, 102, '2015-03-15 01:09:34.000000', 'consum', 0.0224, 'lps'),
	(445262, 102, '2015-03-15 01:09:35.000000', 'consum', 0.0213, 'lps'),
	(445263, 102, '2015-03-15 01:09:36.000000', 'consum', 0.0220, 'lps'),
	(445264, 102, '2015-03-15 01:09:37.000000', 'consum', 0.0217, 'lps'),
	(445265, 102, '2015-03-15 01:09:38.000000', 'consum', 0.0214, 'lps'),
	(445266, 102, '2015-03-15 01:09:39.000000', 'consum', 0.0211, 'lps'),
	(445267, 102, '2015-03-15 01:09:40.000000', 'consum', 0.0219, 'lps'),
	(445268, 102, '2015-03-15 01:09:41.000000', 'consum', 0.0217, 'lps'),
	(445269, 102, '2015-03-15 01:09:42.000000', 'consum', 0.0221, 'lps'),
	(445270, 102, '2015-03-15 01:09:43.000000', 'consum', 0.0224, 'lps'),
	(445271, 102, '2015-03-15 01:09:44.000000', 'consum', 0.0211, 'lps'),
	(445272, 102, '2015-03-15 01:09:45.000000', 'consum', 0.0211, 'lps'),
	(445273, 102, '2015-03-15 01:09:46.000000', 'consum', 0.0212, 'lps'),
	(445274, 102, '2015-03-15 01:09:47.000000', 'consum', 0.0219, 'lps'),
	(445275, 102, '2015-03-15 01:09:48.000000', 'consum', 0.0214, 'lps'),
	(445276, 102, '2015-03-15 01:09:49.000000', 'consum', 0.0221, 'lps'),
	(445277, 102, '2015-03-15 01:09:50.000000', 'consum', 0.0219, 'lps'),
	(445278, 102, '2015-03-15 01:09:51.000000', 'consum', 0.0220, 'lps'),
	(445279, 102, '2015-03-15 01:09:52.000000', 'consum', 0.0217, 'lps'),
	(445280, 102, '2015-03-15 01:09:53.000000', 'consum', 0.0213, 'lps'),
	(445281, 102, '2015-03-15 01:09:54.000000', 'consum', 0.0225, 'lps'),
	(445282, 102, '2015-03-15 01:09:55.000000', 'consum', 0.0223, 'lps'),
	(445283, 102, '2015-03-15 01:09:56.000000', 'consum', 0.0212, 'lps'),
	(445284, 102, '2015-03-15 01:09:57.000000', 'consum', 0.0219, 'lps'),
	(445285, 102, '2015-03-15 01:09:58.000000', 'consum', 0.0213, 'lps'),
	(445286, 102, '2015-03-15 01:09:59.000000', 'consum', 0.0216, 'lps'),
	(445287, 102, '2015-03-15 01:10:00.000000', 'consum', 0.0214, 'lps'),
	(445288, 102, '2015-03-15 01:10:01.000000', 'consum', 0.0214, 'lps'),
	(445289, 102, '2015-03-15 01:10:02.000000', 'consum', 0.0218, 'lps'),
	(445290, 102, '2015-03-15 01:10:03.000000', 'consum', 0.0221, 'lps'),
	(445291, 102, '2015-03-15 01:10:04.000000', 'consum', 0.0224, 'lps'),
	(445292, 102, '2015-03-15 01:10:05.000000', 'consum', 0.0211, 'lps'),
	(445293, 102, '2015-03-15 01:10:06.000000', 'consum', 0.0226, 'lps'),
	(445294, 102, '2015-03-15 01:10:07.000000', 'consum', 0.0216, 'lps'),
	(445295, 102, '2015-03-15 01:10:08.000000', 'consum', 0.0211, 'lps'),
	(445296, 102, '2015-03-15 01:10:09.000000', 'consum', 0.0215, 'lps'),
	(445297, 102, '2015-03-15 01:10:10.000000', 'consum', 0.0216, 'lps'),
	(445298, 102, '2015-03-15 01:10:11.000000', 'consum', 0.0225, 'lps'),
	(445299, 102, '2015-03-15 01:10:12.000000', 'consum', 0.0215, 'lps'),
	(445300, 102, '2015-03-15 01:10:13.000000', 'consum', 0.0224, 'lps'),
	(445301, 102, '2015-03-15 01:10:14.000000', 'consum', 0.0211, 'lps'),
	(445302, 102, '2015-03-15 01:10:15.000000', 'consum', 0.0212, 'lps'),
	(445303, 102, '2015-03-15 01:10:16.000000', 'consum', 0.0215, 'lps'),
	(445304, 102, '2015-03-15 01:10:17.000000', 'consum', 0.0212, 'lps'),
	(445305, 102, '2015-03-15 01:10:18.000000', 'consum', 0.0224, 'lps'),
	(445306, 102, '2015-03-15 01:10:19.000000', 'consum', 0.0221, 'lps'),
	(445307, 102, '2015-03-15 01:10:20.000000', 'consum', 0.0221, 'lps'),
	(445308, 102, '2015-03-15 01:10:21.000000', 'consum', 0.0218, 'lps'),
	(445309, 102, '2015-03-15 01:10:22.000000', 'consum', 0.0215, 'lps'),
	(445310, 102, '2015-03-15 01:10:23.000000', 'consum', 0.0213, 'lps'),
	(445311, 102, '2015-03-15 01:10:24.000000', 'consum', 0.0212, 'lps'),
	(445312, 102, '2015-03-15 01:10:25.000000', 'consum', 0.0226, 'lps'),
	(445313, 102, '2015-03-15 01:10:26.000000', 'consum', 0.0216, 'lps'),
	(445314, 102, '2015-03-15 01:10:27.000000', 'consum', 0.0227, 'lps'),
	(445315, 102, '2015-03-15 01:10:28.000000', 'consum', 0.0223, 'lps'),
	(445316, 102, '2015-03-15 01:10:29.000000', 'consum', 0.0225, 'lps'),
	(445317, 102, '2015-03-15 01:10:30.000000', 'consum', 0.0212, 'lps'),
	(445318, 102, '2015-03-15 01:10:31.000000', 'consum', 0.0226, 'lps'),
	(445319, 102, '2015-03-15 01:10:32.000000', 'consum', 0.0216, 'lps'),
	(445320, 102, '2015-03-15 01:10:33.000000', 'consum', 0.0210, 'lps'),
	(445321, 102, '2015-03-15 01:10:34.000000', 'consum', 0.0227, 'lps'),
	(445322, 102, '2015-03-15 01:10:35.000000', 'consum', 0.0225, 'lps'),
	(445323, 102, '2015-03-15 01:10:36.000000', 'consum', 0.0217, 'lps'),
	(445324, 102, '2015-03-15 01:10:37.000000', 'consum', 0.0216, 'lps'),
	(445325, 102, '2015-03-15 01:10:38.000000', 'consum', 0.0222, 'lps'),
	(445326, 102, '2015-03-15 01:10:39.000000', 'consum', 0.0216, 'lps'),
	(445327, 102, '2015-03-15 01:10:40.000000', 'consum', 0.0222, 'lps'),
	(445328, 102, '2015-03-15 01:10:41.000000', 'consum', 0.0215, 'lps'),
	(445329, 102, '2015-03-15 01:10:42.000000', 'consum', 0.0219, 'lps'),
	(445330, 102, '2015-03-15 01:10:43.000000', 'consum', 0.0220, 'lps'),
	(445331, 102, '2015-03-15 01:10:44.000000', 'consum', 0.0219, 'lps'),
	(445332, 123, '2015-03-15 00:00:00.000000', 'consum', 0.0210, 'lps'),
	(445333, 123, '2015-03-15 00:00:01.000000', 'consum', 0.0210, 'lps'),
	(445334, 123, '2015-03-15 00:00:02.000000', 'consum', 0.0232, 'lps'),
	(445335, 123, '2015-03-15 00:00:03.000000', 'consum', 0.0228, 'lps'),
	(445336, 123, '2015-03-15 00:00:04.000000', 'consum', 0.0232, 'lps'),
	(445337, 123, '2015-03-15 00:00:05.000000', 'consum', 0.0219, 'lps'),
	(445338, 123, '2015-03-15 00:00:06.000000', 'consum', 0.0213, 'lps'),
	(445339, 123, '2015-03-15 00:00:07.000000', 'consum', 0.0222, 'lps'),
	(445340, 123, '2015-03-15 00:00:08.000000', 'consum', 0.0214, 'lps'),
	(445341, 123, '2015-03-15 00:00:09.000000', 'consum', 0.0217, 'lps'),
	(445342, 123, '2015-03-15 00:00:10.000000', 'consum', 0.0213, 'lps'),
	(445343, 123, '2015-03-15 00:00:11.000000', 'consum', 0.0226, 'lps'),
	(445344, 123, '2015-03-15 00:00:12.000000', 'consum', 0.0232, 'lps'),
	(445345, 123, '2015-03-15 00:00:13.000000', 'consum', 0.0228, 'lps'),
	(445346, 123, '2015-03-15 00:00:14.000000', 'consum', 0.0231, 'lps'),
	(445347, 123, '2015-03-15 00:00:15.000000', 'consum', 0.0215, 'lps'),
	(445348, 123, '2015-03-15 00:00:16.000000', 'consum', 0.0220, 'lps'),
	(445349, 123, '2015-03-15 00:00:17.000000', 'consum', 0.0221, 'lps'),
	(445350, 123, '2015-03-15 00:00:18.000000', 'consum', 0.0210, 'lps'),
	(445351, 123, '2015-03-15 00:00:19.000000', 'consum', 0.0228, 'lps'),
	(445352, 123, '2015-03-15 00:00:20.000000', 'consum', 0.0226, 'lps'),
	(445353, 123, '2015-03-15 00:00:21.000000', 'consum', 0.0213, 'lps'),
	(445354, 123, '2015-03-15 00:00:22.000000', 'consum', 0.0225, 'lps'),
	(445355, 123, '2015-03-15 00:00:23.000000', 'consum', 0.0230, 'lps'),
	(445356, 123, '2015-03-15 00:00:24.000000', 'consum', 0.0216, 'lps'),
	(445357, 123, '2015-03-15 00:00:25.000000', 'consum', 0.0231, 'lps'),
	(445358, 123, '2015-03-15 00:00:26.000000', 'consum', 0.0222, 'lps'),
	(445359, 123, '2015-03-15 00:00:27.000000', 'consum', 0.0211, 'lps'),
	(445360, 123, '2015-03-15 00:00:28.000000', 'consum', 0.0226, 'lps'),
	(445361, 123, '2015-03-15 00:00:29.000000', 'consum', 0.0214, 'lps'),
	(445362, 123, '2015-03-15 00:00:30.000000', 'consum', 0.0233, 'lps'),
	(445363, 123, '2015-03-15 00:00:31.000000', 'consum', 0.0218, 'lps'),
	(445364, 123, '2015-03-15 00:00:32.000000', 'consum', 0.0227, 'lps'),
	(445365, 123, '2015-03-15 00:00:33.000000', 'consum', 0.0225, 'lps'),
	(445366, 123, '2015-03-15 00:00:34.000000', 'consum', 0.0232, 'lps'),
	(445367, 123, '2015-03-15 00:00:35.000000', 'consum', 0.0230, 'lps'),
	(445368, 123, '2015-03-15 00:00:36.000000', 'consum', 0.0219, 'lps'),
	(445369, 123, '2015-03-15 00:00:37.000000', 'consum', 0.0220, 'lps'),
	(445370, 123, '2015-03-15 00:00:38.000000', 'consum', 0.0210, 'lps'),
	(445371, 123, '2015-03-15 00:00:39.000000', 'consum', 0.0229, 'lps'),
	(445372, 123, '2015-03-15 00:00:40.000000', 'consum', 0.0210, 'lps'),
	(445373, 123, '2015-03-15 00:00:41.000000', 'consum', 0.0225, 'lps'),
	(445374, 123, '2015-03-15 00:00:42.000000', 'consum', 0.0212, 'lps'),
	(445375, 123, '2015-03-15 00:00:43.000000', 'consum', 0.0223, 'lps'),
	(445376, 123, '2015-03-15 00:00:44.000000', 'consum', 0.0222, 'lps'),
	(445377, 123, '2015-03-15 00:00:45.000000', 'consum', 0.0230, 'lps'),
	(445378, 123, '2015-03-15 00:00:46.000000', 'consum', 0.0227, 'lps'),
	(445379, 123, '2015-03-15 00:00:47.000000', 'consum', 0.0214, 'lps'),
	(445380, 123, '2015-03-15 00:00:48.000000', 'consum', 0.0225, 'lps'),
	(445381, 123, '2015-03-15 00:00:49.000000', 'consum', 0.0226, 'lps'),
	(445382, 123, '2015-03-15 00:00:50.000000', 'consum', 0.0221, 'lps'),
	(445383, 123, '2015-03-15 00:00:51.000000', 'consum', 0.0217, 'lps'),
	(445384, 123, '2015-03-15 00:00:52.000000', 'consum', 0.0214, 'lps'),
	(445385, 123, '2015-03-15 00:00:53.000000', 'consum', 0.0232, 'lps'),
	(445386, 123, '2015-03-15 00:00:54.000000', 'consum', 0.0213, 'lps'),
	(445387, 123, '2015-03-15 00:00:55.000000', 'consum', 0.0232, 'lps'),
	(445388, 123, '2015-03-15 00:00:56.000000', 'consum', 0.0213, 'lps'),
	(445389, 123, '2015-03-15 00:00:57.000000', 'consum', 0.0210, 'lps'),
	(445390, 123, '2015-03-15 00:00:58.000000', 'consum', 0.0227, 'lps'),
	(445391, 123, '2015-03-15 00:00:59.000000', 'consum', 0.0220, 'lps'),
	(445392, 123, '2015-03-15 00:01:00.000000', 'consum', 0.0212, 'lps'),
	(445393, 123, '2015-03-15 00:01:01.000000', 'consum', 0.0212, 'lps'),
	(445394, 123, '2015-03-15 00:01:02.000000', 'consum', 0.0217, 'lps'),
	(445395, 123, '2015-03-15 00:01:03.000000', 'consum', 0.0213, 'lps'),
	(445396, 123, '2015-03-15 00:01:04.000000', 'consum', 0.0232, 'lps'),
	(445397, 123, '2015-03-15 00:01:05.000000', 'consum', 0.0212, 'lps'),
	(445398, 123, '2015-03-15 00:01:06.000000', 'consum', 0.0229, 'lps'),
	(445399, 123, '2015-03-15 00:01:07.000000', 'consum', 0.0229, 'lps'),
	(445400, 123, '2015-03-15 00:01:08.000000', 'consum', 0.0222, 'lps'),
	(445401, 123, '2015-03-15 00:01:09.000000', 'consum', 0.0213, 'lps'),
	(445402, 123, '2015-03-15 00:01:10.000000', 'consum', 0.0216, 'lps'),
	(445403, 123, '2015-03-15 00:01:11.000000', 'consum', 0.0230, 'lps'),
	(445404, 123, '2015-03-15 00:01:12.000000', 'consum', 0.0222, 'lps'),
	(445405, 123, '2015-03-15 00:01:13.000000', 'consum', 0.0232, 'lps'),
	(445406, 123, '2015-03-15 00:01:14.000000', 'consum', 0.0212, 'lps'),
	(445407, 123, '2015-03-15 00:01:15.000000', 'consum', 0.0226, 'lps'),
	(445408, 123, '2015-03-15 00:01:16.000000', 'consum', 0.0213, 'lps'),
	(445409, 123, '2015-03-15 00:01:17.000000', 'consum', 0.0227, 'lps'),
	(445410, 123, '2015-03-15 00:01:18.000000', 'consum', 0.0216, 'lps'),
	(445411, 123, '2015-03-15 00:01:19.000000', 'consum', 0.0210, 'lps'),
	(445412, 123, '2015-03-15 00:01:20.000000', 'consum', 0.0218, 'lps'),
	(445413, 123, '2015-03-15 00:01:21.000000', 'consum', 0.0226, 'lps'),
	(445414, 123, '2015-03-15 00:01:22.000000', 'consum', 0.0221, 'lps'),
	(445415, 123, '2015-03-15 00:01:23.000000', 'consum', 0.0215, 'lps'),
	(445416, 123, '2015-03-15 00:01:24.000000', 'consum', 0.0228, 'lps'),
	(445417, 123, '2015-03-15 00:01:25.000000', 'consum', 0.0214, 'lps'),
	(445418, 123, '2015-03-15 00:01:26.000000', 'consum', 0.0222, 'lps'),
	(445419, 123, '2015-03-15 00:01:27.000000', 'consum', 0.0212, 'lps'),
	(445420, 123, '2015-03-15 00:01:28.000000', 'consum', 0.0231, 'lps'),
	(445421, 123, '2015-03-15 00:01:29.000000', 'consum', 0.0216, 'lps'),
	(445422, 123, '2015-03-15 00:01:30.000000', 'consum', 0.0225, 'lps'),
	(445423, 123, '2015-03-15 00:01:31.000000', 'consum', 0.0218, 'lps'),
	(445424, 123, '2015-03-15 00:01:32.000000', 'consum', 0.0229, 'lps'),
	(445425, 123, '2015-03-15 00:01:33.000000', 'consum', 0.0211, 'lps'),
	(445426, 123, '2015-03-15 00:01:34.000000', 'consum', 0.0231, 'lps'),
	(445427, 123, '2015-03-15 00:01:35.000000', 'consum', 0.0215, 'lps'),
	(445428, 123, '2015-03-15 00:01:36.000000', 'consum', 0.0221, 'lps'),
	(445429, 123, '2015-03-15 00:01:37.000000', 'consum', 0.0225, 'lps'),
	(445430, 123, '2015-03-15 00:01:38.000000', 'consum', 0.0231, 'lps'),
	(445431, 123, '2015-03-15 00:01:39.000000', 'consum', 0.0220, 'lps'),
	(445432, 123, '2015-03-15 00:01:40.000000', 'consum', 0.0222, 'lps'),
	(445433, 123, '2015-03-15 00:01:41.000000', 'consum', 0.0217, 'lps'),
	(445434, 123, '2015-03-15 00:01:42.000000', 'consum', 0.0210, 'lps'),
	(445435, 123, '2015-03-15 00:01:43.000000', 'consum', 0.0213, 'lps'),
	(445436, 123, '2015-03-15 00:01:44.000000', 'consum', 0.0228, 'lps'),
	(445437, 123, '2015-03-15 00:01:45.000000', 'consum', 0.0217, 'lps'),
	(445438, 123, '2015-03-15 00:01:46.000000', 'consum', 0.0214, 'lps'),
	(445439, 123, '2015-03-15 00:01:47.000000', 'consum', 0.0211, 'lps'),
	(445440, 123, '2015-03-15 00:01:48.000000', 'consum', 0.0227, 'lps'),
	(445441, 123, '2015-03-15 00:01:49.000000', 'consum', 0.0223, 'lps'),
	(445442, 123, '2015-03-15 00:01:50.000000', 'consum', 0.0221, 'lps'),
	(445443, 123, '2015-03-15 00:01:51.000000', 'consum', 0.0228, 'lps'),
	(445444, 123, '2015-03-15 00:01:52.000000', 'consum', 0.0218, 'lps'),
	(445445, 123, '2015-03-15 00:01:53.000000', 'consum', 0.0221, 'lps'),
	(445446, 123, '2015-03-15 00:01:54.000000', 'consum', 0.0218, 'lps'),
	(445447, 123, '2015-03-15 00:01:55.000000', 'consum', 0.0219, 'lps'),
	(445448, 123, '2015-03-15 00:01:56.000000', 'consum', 0.0229, 'lps'),
	(445449, 123, '2015-03-15 00:01:57.000000', 'consum', 0.0233, 'lps'),
	(445450, 123, '2015-03-15 00:01:58.000000', 'consum', 0.0221, 'lps'),
	(445451, 123, '2015-03-15 00:01:59.000000', 'consum', 0.0221, 'lps'),
	(445452, 123, '2015-03-15 00:02:00.000000', 'consum', 0.0231, 'lps'),
	(445453, 123, '2015-03-15 00:02:01.000000', 'consum', 0.0210, 'lps'),
	(445454, 123, '2015-03-15 00:02:02.000000', 'consum', 0.0220, 'lps'),
	(445455, 123, '2015-03-15 00:02:03.000000', 'consum', 0.0213, 'lps'),
	(445456, 123, '2015-03-15 00:02:04.000000', 'consum', 0.0220, 'lps'),
	(445457, 123, '2015-03-15 00:02:05.000000', 'consum', 0.0228, 'lps'),
	(445458, 123, '2015-03-15 00:02:06.000000', 'consum', 0.0222, 'lps'),
	(445459, 123, '2015-03-15 00:02:07.000000', 'consum', 0.0215, 'lps'),
	(445460, 123, '2015-03-15 00:02:08.000000', 'consum', 0.0226, 'lps'),
	(445461, 123, '2015-03-15 00:02:09.000000', 'consum', 0.0227, 'lps'),
	(445462, 123, '2015-03-15 00:02:10.000000', 'consum', 0.0222, 'lps'),
	(445463, 123, '2015-03-15 00:02:11.000000', 'consum', 0.0220, 'lps'),
	(445464, 123, '2015-03-15 00:02:12.000000', 'consum', 0.0227, 'lps'),
	(445465, 123, '2015-03-15 00:02:13.000000', 'consum', 0.0214, 'lps'),
	(445466, 123, '2015-03-15 00:02:14.000000', 'consum', 0.0229, 'lps'),
	(445467, 123, '2015-03-15 00:02:15.000000', 'consum', 0.0220, 'lps'),
	(445468, 123, '2015-03-15 00:02:16.000000', 'consum', 0.0228, 'lps'),
	(445469, 123, '2015-03-15 00:02:17.000000', 'consum', 0.0223, 'lps'),
	(445470, 123, '2015-03-15 00:02:18.000000', 'consum', 0.0222, 'lps'),
	(445471, 123, '2015-03-15 00:02:19.000000', 'consum', 0.0233, 'lps'),
	(445472, 123, '2015-03-15 00:02:20.000000', 'consum', 0.0216, 'lps'),
	(445473, 123, '2015-03-15 00:02:21.000000', 'consum', 0.0221, 'lps'),
	(445474, 123, '2015-03-15 00:02:22.000000', 'consum', 0.0222, 'lps'),
	(445475, 123, '2015-03-15 00:02:23.000000', 'consum', 0.0214, 'lps'),
	(445476, 123, '2015-03-15 00:02:24.000000', 'consum', 0.0217, 'lps'),
	(445477, 123, '2015-03-15 00:02:25.000000', 'consum', 0.0233, 'lps'),
	(445478, 123, '2015-03-15 00:02:26.000000', 'consum', 0.0233, 'lps'),
	(445479, 123, '2015-03-15 00:02:27.000000', 'consum', 0.0233, 'lps'),
	(445480, 123, '2015-03-15 00:02:28.000000', 'consum', 0.0230, 'lps'),
	(445481, 123, '2015-03-15 00:02:29.000000', 'consum', 0.0221, 'lps'),
	(445482, 123, '2015-03-15 00:02:30.000000', 'consum', 0.0227, 'lps'),
	(445483, 123, '2015-03-15 00:02:31.000000', 'consum', 0.0216, 'lps'),
	(445484, 123, '2015-03-15 00:02:32.000000', 'consum', 0.0212, 'lps'),
	(445485, 123, '2015-03-15 00:02:33.000000', 'consum', 0.0226, 'lps'),
	(445486, 123, '2015-03-15 00:02:34.000000', 'consum', 0.0214, 'lps'),
	(445487, 123, '2015-03-15 00:02:35.000000', 'consum', 0.0228, 'lps'),
	(445488, 123, '2015-03-15 00:02:36.000000', 'consum', 0.0219, 'lps'),
	(445489, 123, '2015-03-15 00:02:37.000000', 'consum', 0.0227, 'lps'),
	(445490, 123, '2015-03-15 00:02:38.000000', 'consum', 0.0218, 'lps'),
	(445491, 123, '2015-03-15 00:02:39.000000', 'consum', 0.0226, 'lps'),
	(445492, 123, '2015-03-15 00:02:40.000000', 'consum', 0.0216, 'lps'),
	(445493, 123, '2015-03-15 00:02:41.000000', 'consum', 0.0216, 'lps'),
	(445494, 123, '2015-03-15 00:02:42.000000', 'consum', 0.0222, 'lps'),
	(445495, 123, '2015-03-15 00:02:43.000000', 'consum', 0.0230, 'lps'),
	(445496, 123, '2015-03-15 00:02:44.000000', 'consum', 0.0227, 'lps'),
	(445497, 123, '2015-03-15 00:02:45.000000', 'consum', 0.0212, 'lps'),
	(445498, 123, '2015-03-15 00:02:46.000000', 'consum', 0.0218, 'lps'),
	(445499, 123, '2015-03-15 00:02:47.000000', 'consum', 0.0219, 'lps'),
	(445500, 123, '2015-03-15 00:02:48.000000', 'consum', 0.0231, 'lps'),
	(445501, 123, '2015-03-15 00:02:49.000000', 'consum', 0.0217, 'lps'),
	(445502, 123, '2015-03-15 00:02:50.000000', 'consum', 0.0230, 'lps'),
	(445503, 123, '2015-03-15 00:02:51.000000', 'consum', 0.0216, 'lps'),
	(445504, 123, '2015-03-15 00:02:52.000000', 'consum', 0.0231, 'lps'),
	(445505, 123, '2015-03-15 00:02:53.000000', 'consum', 0.0225, 'lps'),
	(445506, 123, '2015-03-15 00:02:54.000000', 'consum', 0.0221, 'lps'),
	(445507, 123, '2015-03-15 00:02:55.000000', 'consum', 0.0220, 'lps'),
	(445508, 123, '2015-03-15 00:02:56.000000', 'consum', 0.0230, 'lps'),
	(445509, 123, '2015-03-15 00:02:57.000000', 'consum', 0.0232, 'lps'),
	(445510, 123, '2015-03-15 00:02:58.000000', 'consum', 0.0211, 'lps'),
	(445511, 123, '2015-03-15 00:02:59.000000', 'consum', 0.0221, 'lps'),
	(445512, 123, '2015-03-15 00:03:00.000000', 'consum', 0.0214, 'lps'),
	(445513, 123, '2015-03-15 00:03:01.000000', 'consum', 0.0224, 'lps'),
	(445514, 123, '2015-03-15 00:03:02.000000', 'consum', 0.0221, 'lps'),
	(445515, 123, '2015-03-15 00:03:03.000000', 'consum', 0.0221, 'lps'),
	(445516, 123, '2015-03-15 00:03:04.000000', 'consum', 0.0232, 'lps'),
	(445517, 123, '2015-03-15 00:03:05.000000', 'consum', 0.0216, 'lps'),
	(445518, 123, '2015-03-15 00:03:06.000000', 'consum', 0.0221, 'lps'),
	(445519, 123, '2015-03-15 00:03:07.000000', 'consum', 0.0226, 'lps'),
	(445520, 123, '2015-03-15 00:03:08.000000', 'consum', 0.0233, 'lps'),
	(445521, 123, '2015-03-15 00:03:09.000000', 'consum', 0.0228, 'lps'),
	(445522, 123, '2015-03-15 00:03:10.000000', 'consum', 0.0231, 'lps'),
	(445523, 123, '2015-03-15 00:03:11.000000', 'consum', 0.0214, 'lps'),
	(445524, 123, '2015-03-15 00:03:12.000000', 'consum', 0.0216, 'lps'),
	(445525, 123, '2015-03-15 00:03:13.000000', 'consum', 0.0230, 'lps'),
	(445526, 123, '2015-03-15 00:03:14.000000', 'consum', 0.0218, 'lps'),
	(445527, 123, '2015-03-15 00:03:15.000000', 'consum', 0.0215, 'lps'),
	(445528, 123, '2015-03-15 00:03:16.000000', 'consum', 0.0213, 'lps'),
	(445529, 123, '2015-03-15 00:03:17.000000', 'consum', 0.0211, 'lps'),
	(445530, 123, '2015-03-15 00:03:18.000000', 'consum', 0.0230, 'lps'),
	(445531, 123, '2015-03-15 00:03:19.000000', 'consum', 0.0213, 'lps'),
	(445532, 123, '2015-03-15 00:03:20.000000', 'consum', 0.0211, 'lps'),
	(445533, 123, '2015-03-15 00:03:21.000000', 'consum', 0.0231, 'lps'),
	(445534, 123, '2015-03-15 00:03:22.000000', 'consum', 0.0215, 'lps'),
	(445535, 123, '2015-03-15 00:03:23.000000', 'consum', 0.0224, 'lps'),
	(445536, 123, '2015-03-15 00:03:24.000000', 'consum', 0.0215, 'lps'),
	(445537, 123, '2015-03-15 00:03:25.000000', 'consum', 0.0217, 'lps'),
	(445538, 123, '2015-03-15 00:03:26.000000', 'consum', 0.0230, 'lps'),
	(445539, 123, '2015-03-15 00:03:27.000000', 'consum', 0.0218, 'lps'),
	(445540, 123, '2015-03-15 00:03:28.000000', 'consum', 0.0216, 'lps'),
	(445541, 123, '2015-03-15 00:03:29.000000', 'consum', 0.0217, 'lps'),
	(445542, 123, '2015-03-15 00:03:30.000000', 'consum', 0.0227, 'lps'),
	(445543, 123, '2015-03-15 00:03:31.000000', 'consum', 0.0227, 'lps'),
	(445544, 123, '2015-03-15 00:03:32.000000', 'consum', 0.0221, 'lps'),
	(445545, 123, '2015-03-15 00:03:33.000000', 'consum', 0.0212, 'lps'),
	(445546, 123, '2015-03-15 00:03:34.000000', 'consum', 0.0211, 'lps'),
	(445547, 123, '2015-03-15 00:03:35.000000', 'consum', 0.0213, 'lps'),
	(445548, 123, '2015-03-15 00:03:36.000000', 'consum', 0.0219, 'lps'),
	(445549, 123, '2015-03-15 00:03:37.000000', 'consum', 0.0223, 'lps'),
	(445550, 123, '2015-03-15 00:03:38.000000', 'consum', 0.0227, 'lps'),
	(445551, 123, '2015-03-15 00:03:39.000000', 'consum', 0.0231, 'lps'),
	(445552, 123, '2015-03-15 00:03:40.000000', 'consum', 0.0217, 'lps'),
	(445553, 123, '2015-03-15 00:03:41.000000', 'consum', 0.0231, 'lps'),
	(445554, 123, '2015-03-15 00:03:42.000000', 'consum', 0.0220, 'lps'),
	(445555, 123, '2015-03-15 00:03:43.000000', 'consum', 0.0223, 'lps'),
	(445556, 123, '2015-03-15 00:03:44.000000', 'consum', 0.0219, 'lps'),
	(445557, 123, '2015-03-15 00:03:45.000000', 'consum', 0.0219, 'lps'),
	(445558, 123, '2015-03-15 00:03:46.000000', 'consum', 0.0229, 'lps'),
	(445559, 123, '2015-03-15 00:03:47.000000', 'consum', 0.0231, 'lps'),
	(445560, 123, '2015-03-15 00:03:48.000000', 'consum', 0.0211, 'lps'),
	(445561, 123, '2015-03-15 00:03:49.000000', 'consum', 0.0224, 'lps'),
	(445562, 123, '2015-03-15 00:03:50.000000', 'consum', 0.0230, 'lps'),
	(445563, 123, '2015-03-15 00:03:51.000000', 'consum', 0.0219, 'lps'),
	(445564, 123, '2015-03-15 00:03:52.000000', 'consum', 0.0220, 'lps'),
	(445565, 123, '2015-03-15 00:03:53.000000', 'consum', 0.0233, 'lps'),
	(445566, 123, '2015-03-15 00:03:54.000000', 'consum', 0.0226, 'lps'),
	(445567, 123, '2015-03-15 00:03:55.000000', 'consum', 0.0219, 'lps'),
	(445568, 123, '2015-03-15 00:03:56.000000', 'consum', 0.0231, 'lps'),
	(445569, 123, '2015-03-15 00:03:57.000000', 'consum', 0.0218, 'lps'),
	(445570, 123, '2015-03-15 00:03:58.000000', 'consum', 0.0233, 'lps'),
	(445571, 123, '2015-03-15 00:03:59.000000', 'consum', 0.0233, 'lps'),
	(445572, 123, '2015-03-15 00:04:00.000000', 'consum', 0.0231, 'lps'),
	(445573, 123, '2015-03-15 00:04:01.000000', 'consum', 0.0224, 'lps'),
	(445574, 123, '2015-03-15 00:04:02.000000', 'consum', 0.0217, 'lps'),
	(445575, 123, '2015-03-15 00:04:03.000000', 'consum', 0.0228, 'lps'),
	(445576, 123, '2015-03-15 00:04:04.000000', 'consum', 0.0231, 'lps'),
	(445577, 123, '2015-03-15 00:04:05.000000', 'consum', 0.0214, 'lps'),
	(445578, 123, '2015-03-15 00:04:06.000000', 'consum', 0.0214, 'lps'),
	(445579, 123, '2015-03-15 00:04:07.000000', 'consum', 0.0221, 'lps'),
	(445580, 123, '2015-03-15 00:04:08.000000', 'consum', 0.0229, 'lps'),
	(445581, 123, '2015-03-15 00:04:09.000000', 'consum', 0.0226, 'lps'),
	(445582, 123, '2015-03-15 00:04:10.000000', 'consum', 0.0232, 'lps'),
	(445583, 123, '2015-03-15 00:04:11.000000', 'consum', 0.0223, 'lps'),
	(445584, 123, '2015-03-15 00:04:12.000000', 'consum', 0.0210, 'lps'),
	(445585, 123, '2015-03-15 00:04:13.000000', 'consum', 0.0222, 'lps'),
	(445586, 123, '2015-03-15 00:04:14.000000', 'consum', 0.0220, 'lps'),
	(445587, 123, '2015-03-15 00:04:15.000000', 'consum', 0.0225, 'lps'),
	(445588, 123, '2015-03-15 00:04:16.000000', 'consum', 0.0230, 'lps'),
	(445589, 123, '2015-03-15 00:04:17.000000', 'consum', 0.0221, 'lps'),
	(445590, 123, '2015-03-15 00:04:18.000000', 'consum', 0.0226, 'lps'),
	(445591, 123, '2015-03-15 00:04:19.000000', 'consum', 0.0213, 'lps'),
	(445592, 123, '2015-03-15 00:04:20.000000', 'consum', 0.0224, 'lps'),
	(445593, 123, '2015-03-15 00:04:21.000000', 'consum', 0.0222, 'lps'),
	(445594, 123, '2015-03-15 00:04:22.000000', 'consum', 0.0228, 'lps'),
	(445595, 123, '2015-03-15 00:04:23.000000', 'consum', 0.0217, 'lps'),
	(445596, 123, '2015-03-15 00:04:24.000000', 'consum', 0.0214, 'lps'),
	(445597, 123, '2015-03-15 00:04:25.000000', 'consum', 0.0211, 'lps'),
	(445598, 123, '2015-03-15 00:04:26.000000', 'consum', 0.0228, 'lps'),
	(445599, 123, '2015-03-15 00:04:27.000000', 'consum', 0.0223, 'lps'),
	(445600, 123, '2015-03-15 00:04:28.000000', 'consum', 0.0224, 'lps'),
	(445601, 123, '2015-03-15 00:04:29.000000', 'consum', 0.0218, 'lps'),
	(445602, 123, '2015-03-15 00:04:30.000000', 'consum', 0.0232, 'lps'),
	(445603, 123, '2015-03-15 00:04:31.000000', 'consum', 0.0225, 'lps'),
	(445604, 123, '2015-03-15 00:04:32.000000', 'consum', 0.0220, 'lps'),
	(445605, 123, '2015-03-15 00:04:33.000000', 'consum', 0.0215, 'lps'),
	(445606, 123, '2015-03-15 00:04:34.000000', 'consum', 0.0228, 'lps'),
	(445607, 123, '2015-03-15 00:04:35.000000', 'consum', 0.0214, 'lps'),
	(445608, 123, '2015-03-15 00:04:36.000000', 'consum', 0.0226, 'lps'),
	(445609, 123, '2015-03-15 00:04:37.000000', 'consum', 0.0229, 'lps'),
	(445610, 123, '2015-03-15 00:04:38.000000', 'consum', 0.0211, 'lps'),
	(445611, 123, '2015-03-15 00:04:39.000000', 'consum', 0.0229, 'lps'),
	(445612, 123, '2015-03-15 00:04:40.000000', 'consum', 0.0229, 'lps'),
	(445613, 123, '2015-03-15 00:04:41.000000', 'consum', 0.0226, 'lps'),
	(445614, 123, '2015-03-15 00:04:42.000000', 'consum', 0.0210, 'lps'),
	(445615, 123, '2015-03-15 00:04:43.000000', 'consum', 0.0211, 'lps'),
	(445616, 123, '2015-03-15 00:04:44.000000', 'consum', 0.0216, 'lps'),
	(445617, 123, '2015-03-15 00:04:45.000000', 'consum', 0.0214, 'lps'),
	(445618, 123, '2015-03-15 00:04:46.000000', 'consum', 0.0211, 'lps'),
	(445619, 123, '2015-03-15 00:04:47.000000', 'consum', 0.0227, 'lps'),
	(445620, 123, '2015-03-15 00:04:48.000000', 'consum', 0.0220, 'lps'),
	(445621, 123, '2015-03-15 00:04:49.000000', 'consum', 0.0210, 'lps'),
	(445622, 123, '2015-03-15 00:04:50.000000', 'consum', 0.0229, 'lps'),
	(445623, 123, '2015-03-15 00:04:51.000000', 'consum', 0.0232, 'lps'),
	(445624, 123, '2015-03-15 00:04:52.000000', 'consum', 0.0216, 'lps'),
	(445625, 123, '2015-03-15 00:04:53.000000', 'consum', 0.0224, 'lps'),
	(445626, 123, '2015-03-15 00:04:54.000000', 'consum', 0.0215, 'lps'),
	(445627, 123, '2015-03-15 00:04:55.000000', 'consum', 0.0218, 'lps'),
	(445628, 123, '2015-03-15 00:04:56.000000', 'consum', 0.0211, 'lps'),
	(445629, 123, '2015-03-15 00:04:57.000000', 'consum', 0.0216, 'lps'),
	(445630, 123, '2015-03-15 00:04:58.000000', 'consum', 0.0214, 'lps'),
	(445631, 123, '2015-03-15 00:04:59.000000', 'consum', 0.0210, 'lps'),
	(445632, 123, '2015-03-15 00:05:00.000000', 'consum', 0.0225, 'lps'),
	(445633, 123, '2015-03-15 00:05:01.000000', 'consum', 0.0213, 'lps'),
	(445634, 123, '2015-03-15 00:05:02.000000', 'consum', 0.0227, 'lps'),
	(445635, 123, '2015-03-15 00:05:03.000000', 'consum', 0.0213, 'lps'),
	(445636, 123, '2015-03-15 00:05:04.000000', 'consum', 0.0226, 'lps'),
	(445637, 123, '2015-03-15 00:05:05.000000', 'consum', 0.0233, 'lps'),
	(445638, 123, '2015-03-15 00:05:06.000000', 'consum', 0.0229, 'lps'),
	(445639, 123, '2015-03-15 00:05:07.000000', 'consum', 0.0212, 'lps'),
	(445640, 123, '2015-03-15 00:05:08.000000', 'consum', 0.0210, 'lps'),
	(445641, 123, '2015-03-15 00:05:09.000000', 'consum', 0.0230, 'lps'),
	(445642, 123, '2015-03-15 00:05:10.000000', 'consum', 0.0214, 'lps'),
	(445643, 123, '2015-03-15 00:05:11.000000', 'consum', 0.0219, 'lps'),
	(445644, 123, '2015-03-15 00:05:12.000000', 'consum', 0.0218, 'lps'),
	(445645, 123, '2015-03-15 00:05:13.000000', 'consum', 0.0223, 'lps'),
	(445646, 123, '2015-03-15 00:05:14.000000', 'consum', 0.0227, 'lps'),
	(445647, 123, '2015-03-15 00:05:15.000000', 'consum', 0.0232, 'lps'),
	(445648, 123, '2015-03-15 00:05:16.000000', 'consum', 0.0221, 'lps'),
	(445649, 123, '2015-03-15 00:05:17.000000', 'consum', 0.0227, 'lps'),
	(445650, 123, '2015-03-15 00:05:18.000000', 'consum', 0.0211, 'lps'),
	(445651, 123, '2015-03-15 00:05:19.000000', 'consum', 0.0215, 'lps'),
	(445652, 123, '2015-03-15 00:05:20.000000', 'consum', 0.0233, 'lps'),
	(445653, 123, '2015-03-15 00:05:21.000000', 'consum', 0.0211, 'lps'),
	(445654, 123, '2015-03-15 00:05:22.000000', 'consum', 0.0222, 'lps'),
	(445655, 123, '2015-03-15 00:05:23.000000', 'consum', 0.0219, 'lps'),
	(445656, 123, '2015-03-15 00:05:24.000000', 'consum', 0.0218, 'lps'),
	(445657, 123, '2015-03-15 00:05:25.000000', 'consum', 0.0223, 'lps'),
	(445658, 123, '2015-03-15 00:05:26.000000', 'consum', 0.0228, 'lps'),
	(445659, 123, '2015-03-15 00:05:27.000000', 'consum', 0.0213, 'lps'),
	(445660, 123, '2015-03-15 00:05:28.000000', 'consum', 0.0221, 'lps'),
	(445661, 123, '2015-03-15 00:05:29.000000', 'consum', 0.0233, 'lps'),
	(445662, 123, '2015-03-15 00:05:30.000000', 'consum', 0.0220, 'lps'),
	(445663, 123, '2015-03-15 00:05:31.000000', 'consum', 0.0214, 'lps'),
	(445664, 123, '2015-03-15 00:05:32.000000', 'consum', 0.0226, 'lps'),
	(445665, 123, '2015-03-15 00:05:33.000000', 'consum', 0.0231, 'lps'),
	(445666, 123, '2015-03-15 00:05:34.000000', 'consum', 0.0220, 'lps'),
	(445667, 123, '2015-03-15 00:05:35.000000', 'consum', 0.0219, 'lps'),
	(445668, 123, '2015-03-15 00:05:36.000000', 'consum', 0.0226, 'lps'),
	(445669, 123, '2015-03-15 00:05:37.000000', 'consum', 0.0214, 'lps'),
	(445670, 123, '2015-03-15 00:05:38.000000', 'consum', 0.0210, 'lps'),
	(445671, 123, '2015-03-15 00:05:39.000000', 'consum', 0.0221, 'lps'),
	(445672, 123, '2015-03-15 00:05:40.000000', 'consum', 0.0217, 'lps'),
	(445673, 123, '2015-03-15 00:05:41.000000', 'consum', 0.0214, 'lps'),
	(445674, 123, '2015-03-15 00:05:42.000000', 'consum', 0.0233, 'lps'),
	(445675, 123, '2015-03-15 00:05:43.000000', 'consum', 0.0215, 'lps'),
	(445676, 123, '2015-03-15 00:05:44.000000', 'consum', 0.0218, 'lps'),
	(445677, 123, '2015-03-15 00:05:45.000000', 'consum', 0.0211, 'lps'),
	(445678, 123, '2015-03-15 00:05:46.000000', 'consum', 0.0215, 'lps'),
	(445679, 123, '2015-03-15 00:05:47.000000', 'consum', 0.0210, 'lps'),
	(445680, 123, '2015-03-15 00:05:48.000000', 'consum', 0.0220, 'lps'),
	(445681, 123, '2015-03-15 00:05:49.000000', 'consum', 0.0211, 'lps'),
	(445682, 123, '2015-03-15 00:05:50.000000', 'consum', 0.0232, 'lps'),
	(445683, 123, '2015-03-15 00:05:51.000000', 'consum', 0.0222, 'lps'),
	(445684, 123, '2015-03-15 00:05:52.000000', 'consum', 0.0228, 'lps'),
	(445685, 123, '2015-03-15 00:05:53.000000', 'consum', 0.0219, 'lps'),
	(445686, 123, '2015-03-15 00:05:54.000000', 'consum', 0.0225, 'lps'),
	(445687, 123, '2015-03-15 00:05:55.000000', 'consum', 0.0233, 'lps'),
	(445688, 123, '2015-03-15 00:05:56.000000', 'consum', 0.0231, 'lps'),
	(445689, 123, '2015-03-15 00:05:57.000000', 'consum', 0.0226, 'lps'),
	(445690, 123, '2015-03-15 00:05:58.000000', 'consum', 0.0224, 'lps'),
	(445691, 123, '2015-03-15 00:05:59.000000', 'consum', 0.0212, 'lps'),
	(445692, 123, '2015-03-15 00:06:00.000000', 'consum', 0.0224, 'lps'),
	(445693, 123, '2015-03-15 00:06:01.000000', 'consum', 0.0226, 'lps'),
	(445694, 123, '2015-03-15 00:06:02.000000', 'consum', 0.0227, 'lps'),
	(445695, 123, '2015-03-15 00:06:03.000000', 'consum', 0.0221, 'lps'),
	(445696, 123, '2015-03-15 00:06:04.000000', 'consum', 0.0216, 'lps'),
	(445697, 123, '2015-03-15 00:06:05.000000', 'consum', 0.0233, 'lps'),
	(445698, 123, '2015-03-15 00:06:06.000000', 'consum', 0.0210, 'lps'),
	(445699, 123, '2015-03-15 00:06:07.000000', 'consum', 0.0214, 'lps'),
	(445700, 123, '2015-03-15 00:06:08.000000', 'consum', 0.0229, 'lps'),
	(445701, 123, '2015-03-15 00:06:09.000000', 'consum', 0.0220, 'lps'),
	(445702, 123, '2015-03-15 00:06:10.000000', 'consum', 0.0231, 'lps'),
	(445703, 123, '2015-03-15 00:06:11.000000', 'consum', 0.0213, 'lps'),
	(445704, 123, '2015-03-15 00:06:12.000000', 'consum', 0.0232, 'lps'),
	(445705, 123, '2015-03-15 00:06:13.000000', 'consum', 0.0219, 'lps'),
	(445706, 123, '2015-03-15 00:06:14.000000', 'consum', 0.0210, 'lps'),
	(445707, 123, '2015-03-15 00:06:15.000000', 'consum', 0.0233, 'lps'),
	(445708, 123, '2015-03-15 00:06:16.000000', 'consum', 0.0229, 'lps'),
	(445709, 123, '2015-03-15 00:06:17.000000', 'consum', 0.0214, 'lps'),
	(445710, 123, '2015-03-15 00:06:18.000000', 'consum', 0.0219, 'lps'),
	(445711, 123, '2015-03-15 00:06:19.000000', 'consum', 0.0221, 'lps'),
	(445712, 123, '2015-03-15 00:06:20.000000', 'consum', 0.0215, 'lps'),
	(445713, 123, '2015-03-15 00:06:21.000000', 'consum', 0.0225, 'lps'),
	(445714, 123, '2015-03-15 00:06:22.000000', 'consum', 0.0223, 'lps'),
	(445715, 123, '2015-03-15 00:06:23.000000', 'consum', 0.0232, 'lps'),
	(445716, 123, '2015-03-15 00:06:24.000000', 'consum', 0.0210, 'lps'),
	(445717, 123, '2015-03-15 00:06:25.000000', 'consum', 0.0217, 'lps'),
	(445718, 123, '2015-03-15 00:06:26.000000', 'consum', 0.0221, 'lps'),
	(445719, 123, '2015-03-15 00:06:27.000000', 'consum', 0.0219, 'lps'),
	(445720, 123, '2015-03-15 00:06:28.000000', 'consum', 0.0222, 'lps'),
	(445721, 123, '2015-03-15 00:06:29.000000', 'consum', 0.0220, 'lps'),
	(445722, 123, '2015-03-15 00:06:30.000000', 'consum', 0.0226, 'lps'),
	(445723, 123, '2015-03-15 00:06:31.000000', 'consum', 0.0212, 'lps'),
	(445724, 123, '2015-03-15 00:06:32.000000', 'consum', 0.0219, 'lps'),
	(445725, 123, '2015-03-15 00:06:33.000000', 'consum', 0.0228, 'lps'),
	(445726, 123, '2015-03-15 00:06:34.000000', 'consum', 0.0226, 'lps'),
	(445727, 123, '2015-03-15 00:06:35.000000', 'consum', 0.0210, 'lps'),
	(445728, 123, '2015-03-15 00:06:36.000000', 'consum', 0.0213, 'lps'),
	(445729, 123, '2015-03-15 00:06:37.000000', 'consum', 0.0226, 'lps'),
	(445730, 123, '2015-03-15 00:06:38.000000', 'consum', 0.0231, 'lps'),
	(445731, 123, '2015-03-15 00:06:39.000000', 'consum', 0.0219, 'lps'),
	(445732, 123, '2015-03-15 00:06:40.000000', 'consum', 0.0218, 'lps'),
	(445733, 123, '2015-03-15 00:06:41.000000', 'consum', 0.0225, 'lps'),
	(445734, 123, '2015-03-15 00:06:42.000000', 'consum', 0.0214, 'lps'),
	(445735, 123, '2015-03-15 00:06:43.000000', 'consum', 0.0230, 'lps'),
	(445736, 123, '2015-03-15 00:06:44.000000', 'consum', 0.0230, 'lps'),
	(445737, 123, '2015-03-15 00:06:45.000000', 'consum', 0.0226, 'lps'),
	(445738, 123, '2015-03-15 00:06:46.000000', 'consum', 0.0230, 'lps'),
	(445739, 123, '2015-03-15 00:06:47.000000', 'consum', 0.0213, 'lps'),
	(445740, 123, '2015-03-15 00:06:48.000000', 'consum', 0.0216, 'lps'),
	(445741, 123, '2015-03-15 00:06:49.000000', 'consum', 0.0228, 'lps'),
	(445742, 123, '2015-03-15 00:06:50.000000', 'consum', 0.0214, 'lps'),
	(445743, 123, '2015-03-15 00:06:51.000000', 'consum', 0.0222, 'lps'),
	(445744, 123, '2015-03-15 00:06:52.000000', 'consum', 0.0212, 'lps'),
	(445745, 123, '2015-03-15 00:06:53.000000', 'consum', 0.0232, 'lps'),
	(445746, 123, '2015-03-15 00:06:54.000000', 'consum', 0.0220, 'lps'),
	(445747, 123, '2015-03-15 00:06:55.000000', 'consum', 0.0219, 'lps'),
	(445748, 123, '2015-03-15 00:06:56.000000', 'consum', 0.0225, 'lps'),
	(445749, 123, '2015-03-15 00:06:57.000000', 'consum', 0.0232, 'lps'),
	(445750, 123, '2015-03-15 00:06:58.000000', 'consum', 0.0230, 'lps'),
	(445751, 123, '2015-03-15 00:06:59.000000', 'consum', 0.0218, 'lps'),
	(445752, 123, '2015-03-15 00:07:00.000000', 'consum', 0.0217, 'lps'),
	(445753, 123, '2015-03-15 00:07:01.000000', 'consum', 0.0222, 'lps'),
	(445754, 123, '2015-03-15 00:07:02.000000', 'consum', 0.0225, 'lps'),
	(445755, 123, '2015-03-15 00:07:03.000000', 'consum', 0.0224, 'lps'),
	(445756, 123, '2015-03-15 00:07:04.000000', 'consum', 0.0212, 'lps'),
	(445757, 123, '2015-03-15 00:07:05.000000', 'consum', 0.0225, 'lps'),
	(445758, 123, '2015-03-15 00:07:06.000000', 'consum', 0.0232, 'lps'),
	(445759, 123, '2015-03-15 00:07:07.000000', 'consum', 0.0228, 'lps'),
	(445760, 123, '2015-03-15 00:07:08.000000', 'consum', 0.0211, 'lps'),
	(445761, 123, '2015-03-15 00:07:09.000000', 'consum', 0.0211, 'lps'),
	(445762, 123, '2015-03-15 00:07:10.000000', 'consum', 0.0212, 'lps'),
	(445763, 123, '2015-03-15 00:07:11.000000', 'consum', 0.0216, 'lps'),
	(445764, 123, '2015-03-15 00:07:12.000000', 'consum', 0.0213, 'lps'),
	(445765, 123, '2015-03-15 00:07:13.000000', 'consum', 0.0229, 'lps'),
	(445766, 123, '2015-03-15 00:07:14.000000', 'consum', 0.0225, 'lps'),
	(445767, 123, '2015-03-15 00:07:15.000000', 'consum', 0.0229, 'lps'),
	(445768, 123, '2015-03-15 00:07:16.000000', 'consum', 0.0211, 'lps'),
	(445769, 123, '2015-03-15 00:07:17.000000', 'consum', 0.0233, 'lps'),
	(445770, 123, '2015-03-15 00:07:18.000000', 'consum', 0.0225, 'lps'),
	(445771, 123, '2015-03-15 00:07:19.000000', 'consum', 0.0219, 'lps'),
	(445772, 123, '2015-03-15 00:07:20.000000', 'consum', 0.0231, 'lps'),
	(445773, 123, '2015-03-15 00:07:21.000000', 'consum', 0.0217, 'lps'),
	(445774, 123, '2015-03-15 00:07:22.000000', 'consum', 0.0233, 'lps'),
	(445775, 123, '2015-03-15 00:07:23.000000', 'consum', 0.0231, 'lps'),
	(445776, 123, '2015-03-15 00:07:24.000000', 'consum', 0.0222, 'lps'),
	(445777, 123, '2015-03-15 00:07:25.000000', 'consum', 0.0230, 'lps'),
	(445778, 123, '2015-03-15 00:07:26.000000', 'consum', 0.0228, 'lps'),
	(445779, 123, '2015-03-15 00:07:27.000000', 'consum', 0.0218, 'lps'),
	(445780, 123, '2015-03-15 00:07:28.000000', 'consum', 0.0217, 'lps'),
	(445781, 123, '2015-03-15 00:07:29.000000', 'consum', 0.0225, 'lps'),
	(445782, 123, '2015-03-15 00:07:30.000000', 'consum', 0.0216, 'lps'),
	(445783, 123, '2015-03-15 00:07:31.000000', 'consum', 0.0217, 'lps'),
	(445784, 123, '2015-03-15 00:07:32.000000', 'consum', 0.0229, 'lps'),
	(445785, 123, '2015-03-15 00:07:33.000000', 'consum', 0.0211, 'lps'),
	(445786, 123, '2015-03-15 00:07:34.000000', 'consum', 0.0230, 'lps'),
	(445787, 123, '2015-03-15 00:07:35.000000', 'consum', 0.0212, 'lps'),
	(445788, 123, '2015-03-15 00:07:36.000000', 'consum', 0.0231, 'lps'),
	(445789, 123, '2015-03-15 00:07:37.000000', 'consum', 0.0216, 'lps'),
	(445790, 123, '2015-03-15 00:07:38.000000', 'consum', 0.0226, 'lps'),
	(445791, 123, '2015-03-15 00:07:39.000000', 'consum', 0.0222, 'lps'),
	(445792, 123, '2015-03-15 00:07:40.000000', 'consum', 0.0225, 'lps'),
	(445793, 123, '2015-03-15 00:07:41.000000', 'consum', 0.0224, 'lps'),
	(445794, 123, '2015-03-15 00:07:42.000000', 'consum', 0.0214, 'lps'),
	(445795, 123, '2015-03-15 00:07:43.000000', 'consum', 0.0211, 'lps'),
	(445796, 123, '2015-03-15 00:07:44.000000', 'consum', 0.0228, 'lps'),
	(445797, 123, '2015-03-15 00:07:45.000000', 'consum', 0.0224, 'lps'),
	(445798, 123, '2015-03-15 00:07:46.000000', 'consum', 0.0227, 'lps'),
	(445799, 123, '2015-03-15 00:07:47.000000', 'consum', 0.0232, 'lps'),
	(445800, 123, '2015-03-15 00:07:48.000000', 'consum', 0.0219, 'lps'),
	(445801, 123, '2015-03-15 00:07:49.000000', 'consum', 0.0212, 'lps'),
	(445802, 123, '2015-03-15 00:07:50.000000', 'consum', 0.0220, 'lps'),
	(445803, 123, '2015-03-15 00:07:51.000000', 'consum', 0.0231, 'lps'),
	(445804, 123, '2015-03-15 00:07:52.000000', 'consum', 0.0211, 'lps'),
	(445805, 123, '2015-03-15 00:07:53.000000', 'consum', 0.0224, 'lps'),
	(445806, 123, '2015-03-15 00:07:54.000000', 'consum', 0.0231, 'lps'),
	(445807, 123, '2015-03-15 00:07:55.000000', 'consum', 0.0227, 'lps'),
	(445808, 123, '2015-03-15 00:07:56.000000', 'consum', 0.0232, 'lps'),
	(445809, 123, '2015-03-15 00:07:57.000000', 'consum', 0.0223, 'lps'),
	(445810, 123, '2015-03-15 00:07:58.000000', 'consum', 0.0230, 'lps'),
	(445811, 123, '2015-03-15 00:07:59.000000', 'consum', 0.0226, 'lps'),
	(445812, 123, '2015-03-15 00:08:00.000000', 'consum', 0.0228, 'lps'),
	(445813, 123, '2015-03-15 00:08:01.000000', 'consum', 0.0230, 'lps'),
	(445814, 123, '2015-03-15 00:08:02.000000', 'consum', 0.0232, 'lps'),
	(445815, 123, '2015-03-15 00:08:03.000000', 'consum', 0.0211, 'lps'),
	(445816, 123, '2015-03-15 00:08:04.000000', 'consum', 0.0224, 'lps'),
	(445817, 123, '2015-03-15 00:08:05.000000', 'consum', 0.0230, 'lps'),
	(445818, 123, '2015-03-15 00:08:06.000000', 'consum', 0.0219, 'lps'),
	(445819, 123, '2015-03-15 00:08:07.000000', 'consum', 0.0221, 'lps'),
	(445820, 123, '2015-03-15 00:08:08.000000', 'consum', 0.0213, 'lps'),
	(445821, 123, '2015-03-15 00:08:09.000000', 'consum', 0.0218, 'lps'),
	(445822, 123, '2015-03-15 00:08:10.000000', 'consum', 0.0217, 'lps'),
	(445823, 123, '2015-03-15 00:08:11.000000', 'consum', 0.0220, 'lps'),
	(445824, 123, '2015-03-15 00:08:12.000000', 'consum', 0.0218, 'lps'),
	(445825, 123, '2015-03-15 00:08:13.000000', 'consum', 0.0221, 'lps'),
	(445826, 123, '2015-03-15 00:08:14.000000', 'consum', 0.0217, 'lps'),
	(445827, 123, '2015-03-15 00:08:15.000000', 'consum', 0.0213, 'lps'),
	(445828, 123, '2015-03-15 00:08:16.000000', 'consum', 0.0230, 'lps'),
	(445829, 123, '2015-03-15 00:08:17.000000', 'consum', 0.0227, 'lps'),
	(445830, 123, '2015-03-15 00:08:18.000000', 'consum', 0.0212, 'lps'),
	(445831, 123, '2015-03-15 00:08:19.000000', 'consum', 0.0216, 'lps'),
	(445832, 123, '2015-03-15 00:08:20.000000', 'consum', 0.0210, 'lps'),
	(445833, 123, '2015-03-15 00:08:21.000000', 'consum', 0.0218, 'lps'),
	(445834, 123, '2015-03-15 00:08:22.000000', 'consum', 0.0228, 'lps'),
	(445835, 123, '2015-03-15 00:08:23.000000', 'consum', 0.0227, 'lps'),
	(445836, 123, '2015-03-15 00:08:24.000000', 'consum', 0.0219, 'lps'),
	(445837, 123, '2015-03-15 00:08:25.000000', 'consum', 0.0228, 'lps'),
	(445838, 123, '2015-03-15 00:08:26.000000', 'consum', 0.0224, 'lps'),
	(445839, 123, '2015-03-15 00:08:27.000000', 'consum', 0.0229, 'lps'),
	(445840, 123, '2015-03-15 00:08:28.000000', 'consum', 0.0214, 'lps'),
	(445841, 123, '2015-03-15 00:08:29.000000', 'consum', 0.0221, 'lps'),
	(445842, 123, '2015-03-15 00:08:30.000000', 'consum', 0.0228, 'lps'),
	(445843, 123, '2015-03-15 00:08:31.000000', 'consum', 0.0223, 'lps'),
	(445844, 123, '2015-03-15 00:08:32.000000', 'consum', 0.0218, 'lps'),
	(445845, 123, '2015-03-15 00:08:33.000000', 'consum', 0.0213, 'lps'),
	(445846, 123, '2015-03-15 00:08:34.000000', 'consum', 0.0226, 'lps'),
	(445847, 123, '2015-03-15 00:08:35.000000', 'consum', 0.0231, 'lps'),
	(445848, 123, '2015-03-15 00:08:36.000000', 'consum', 0.0222, 'lps'),
	(445849, 123, '2015-03-15 00:08:37.000000', 'consum', 0.0230, 'lps'),
	(445850, 123, '2015-03-15 00:08:38.000000', 'consum', 0.0228, 'lps'),
	(445851, 123, '2015-03-15 00:08:39.000000', 'consum', 0.0217, 'lps'),
	(445852, 123, '2015-03-15 00:08:40.000000', 'consum', 0.0215, 'lps'),
	(445853, 123, '2015-03-15 00:08:41.000000', 'consum', 0.0213, 'lps'),
	(445854, 123, '2015-03-15 00:08:42.000000', 'consum', 0.0210, 'lps'),
	(445855, 123, '2015-03-15 00:08:43.000000', 'consum', 0.0227, 'lps'),
	(445856, 123, '2015-03-15 00:08:44.000000', 'consum', 0.0225, 'lps'),
	(445857, 123, '2015-03-15 00:08:45.000000', 'consum', 0.0231, 'lps'),
	(445858, 123, '2015-03-15 00:08:46.000000', 'consum', 0.0225, 'lps'),
	(445859, 123, '2015-03-15 00:08:47.000000', 'consum', 0.0223, 'lps'),
	(445860, 123, '2015-03-15 00:08:48.000000', 'consum', 0.0228, 'lps'),
	(445861, 123, '2015-03-15 00:08:49.000000', 'consum', 0.0216, 'lps'),
	(445862, 123, '2015-03-15 00:08:50.000000', 'consum', 0.0232, 'lps'),
	(445863, 123, '2015-03-15 00:08:51.000000', 'consum', 0.0210, 'lps'),
	(445864, 123, '2015-03-15 00:08:52.000000', 'consum', 0.0213, 'lps'),
	(445865, 123, '2015-03-15 00:08:53.000000', 'consum', 0.0228, 'lps'),
	(445866, 123, '2015-03-15 00:08:54.000000', 'consum', 0.0218, 'lps'),
	(445867, 123, '2015-03-15 00:08:55.000000', 'consum', 0.0220, 'lps'),
	(445868, 123, '2015-03-15 00:08:56.000000', 'consum', 0.0212, 'lps'),
	(445869, 123, '2015-03-15 00:08:57.000000', 'consum', 0.0216, 'lps'),
	(445870, 123, '2015-03-15 00:08:58.000000', 'consum', 0.0233, 'lps'),
	(445871, 123, '2015-03-15 00:08:59.000000', 'consum', 0.0213, 'lps'),
	(445872, 123, '2015-03-15 00:09:00.000000', 'consum', 0.0229, 'lps'),
	(445873, 123, '2015-03-15 00:09:01.000000', 'consum', 0.0223, 'lps'),
	(445874, 123, '2015-03-15 00:09:02.000000', 'consum', 0.0221, 'lps'),
	(445875, 123, '2015-03-15 00:09:03.000000', 'consum', 0.0224, 'lps'),
	(445876, 123, '2015-03-15 00:09:04.000000', 'consum', 0.0222, 'lps'),
	(445877, 123, '2015-03-15 00:09:05.000000', 'consum', 0.0231, 'lps'),
	(445878, 123, '2015-03-15 00:09:06.000000', 'consum', 0.0232, 'lps'),
	(445879, 123, '2015-03-15 00:09:07.000000', 'consum', 0.0231, 'lps'),
	(445880, 123, '2015-03-15 00:09:08.000000', 'consum', 0.0228, 'lps'),
	(445881, 123, '2015-03-15 00:09:09.000000', 'consum', 0.0212, 'lps'),
	(445882, 123, '2015-03-15 00:09:10.000000', 'consum', 0.0217, 'lps'),
	(445883, 123, '2015-03-15 00:09:11.000000', 'consum', 0.0213, 'lps'),
	(445884, 123, '2015-03-15 00:09:12.000000', 'consum', 0.0230, 'lps'),
	(445885, 123, '2015-03-15 00:09:13.000000', 'consum', 0.0230, 'lps'),
	(445886, 123, '2015-03-15 00:09:14.000000', 'consum', 0.0224, 'lps'),
	(445887, 123, '2015-03-15 00:09:15.000000', 'consum', 0.0222, 'lps'),
	(445888, 123, '2015-03-15 00:09:16.000000', 'consum', 0.0227, 'lps'),
	(445889, 123, '2015-03-15 00:09:17.000000', 'consum', 0.0211, 'lps'),
	(445890, 123, '2015-03-15 00:09:18.000000', 'consum', 0.0216, 'lps'),
	(445891, 123, '2015-03-15 00:09:19.000000', 'consum', 0.0210, 'lps'),
	(445892, 123, '2015-03-15 00:09:20.000000', 'consum', 0.0218, 'lps'),
	(445893, 123, '2015-03-15 00:09:21.000000', 'consum', 0.0228, 'lps'),
	(445894, 123, '2015-03-15 00:09:22.000000', 'consum', 0.0229, 'lps'),
	(445895, 123, '2015-03-15 00:09:23.000000', 'consum', 0.0224, 'lps'),
	(445896, 123, '2015-03-15 00:09:24.000000', 'consum', 0.0226, 'lps'),
	(445897, 123, '2015-03-15 00:09:25.000000', 'consum', 0.0224, 'lps'),
	(445898, 123, '2015-03-15 00:09:26.000000', 'consum', 0.0210, 'lps'),
	(445899, 123, '2015-03-15 00:09:27.000000', 'consum', 0.0216, 'lps'),
	(445900, 123, '2015-03-15 00:09:28.000000', 'consum', 0.0215, 'lps'),
	(445901, 123, '2015-03-15 00:09:29.000000', 'consum', 0.0220, 'lps'),
	(445902, 123, '2015-03-15 00:09:30.000000', 'consum', 0.0218, 'lps'),
	(445903, 123, '2015-03-15 00:09:31.000000', 'consum', 0.0223, 'lps'),
	(445904, 123, '2015-03-15 00:09:32.000000', 'consum', 0.0226, 'lps'),
	(445905, 123, '2015-03-15 00:09:33.000000', 'consum', 0.0227, 'lps'),
	(445906, 123, '2015-03-15 00:09:34.000000', 'consum', 0.0222, 'lps'),
	(445907, 123, '2015-03-15 00:09:35.000000', 'consum', 0.0222, 'lps'),
	(445908, 123, '2015-03-15 00:09:36.000000', 'consum', 0.0233, 'lps'),
	(445909, 123, '2015-03-15 00:09:37.000000', 'consum', 0.0217, 'lps'),
	(445910, 123, '2015-03-15 00:09:38.000000', 'consum', 0.0226, 'lps'),
	(445911, 123, '2015-03-15 00:09:39.000000', 'consum', 0.0222, 'lps'),
	(445912, 123, '2015-03-15 00:09:40.000000', 'consum', 0.0222, 'lps'),
	(445913, 123, '2015-03-15 00:09:41.000000', 'consum', 0.0212, 'lps'),
	(445914, 123, '2015-03-15 00:09:42.000000', 'consum', 0.0231, 'lps'),
	(445915, 123, '2015-03-15 00:09:43.000000', 'consum', 0.0215, 'lps'),
	(445916, 123, '2015-03-15 00:09:44.000000', 'consum', 0.0221, 'lps'),
	(445917, 123, '2015-03-15 00:09:45.000000', 'consum', 0.0225, 'lps'),
	(445918, 123, '2015-03-15 00:09:46.000000', 'consum', 0.0229, 'lps'),
	(445919, 123, '2015-03-15 00:09:47.000000', 'consum', 0.0213, 'lps'),
	(445920, 123, '2015-03-15 00:09:48.000000', 'consum', 0.0218, 'lps'),
	(445921, 123, '2015-03-15 00:09:49.000000', 'consum', 0.0216, 'lps'),
	(445922, 123, '2015-03-15 00:09:50.000000', 'consum', 0.0217, 'lps'),
	(445923, 123, '2015-03-15 00:09:51.000000', 'consum', 0.0227, 'lps'),
	(445924, 123, '2015-03-15 00:09:52.000000', 'consum', 0.0227, 'lps'),
	(445925, 123, '2015-03-15 00:09:53.000000', 'consum', 0.0219, 'lps'),
	(445926, 123, '2015-03-15 00:09:54.000000', 'consum', 0.0231, 'lps'),
	(445927, 123, '2015-03-15 00:09:55.000000', 'consum', 0.0214, 'lps'),
	(445928, 123, '2015-03-15 00:09:56.000000', 'consum', 0.0217, 'lps'),
	(445929, 123, '2015-03-15 00:09:57.000000', 'consum', 0.0232, 'lps'),
	(445930, 123, '2015-03-15 00:09:58.000000', 'consum', 0.0228, 'lps'),
	(445931, 123, '2015-03-15 00:09:59.000000', 'consum', 0.0210, 'lps'),
	(445932, 123, '2015-03-15 00:10:00.000000', 'consum', 0.0230, 'lps'),
	(445933, 123, '2015-03-15 00:10:01.000000', 'consum', 0.0214, 'lps'),
	(445934, 123, '2015-03-15 00:10:02.000000', 'consum', 0.0220, 'lps'),
	(445935, 123, '2015-03-15 00:10:03.000000', 'consum', 0.0225, 'lps'),
	(445936, 123, '2015-03-15 00:10:04.000000', 'consum', 0.0229, 'lps'),
	(445937, 123, '2015-03-15 00:10:05.000000', 'consum', 0.0212, 'lps'),
	(445938, 123, '2015-03-15 00:10:06.000000', 'consum', 0.0214, 'lps'),
	(445939, 123, '2015-03-15 00:10:07.000000', 'consum', 0.0222, 'lps'),
	(445940, 123, '2015-03-15 00:10:08.000000', 'consum', 0.0211, 'lps'),
	(445941, 123, '2015-03-15 00:10:09.000000', 'consum', 0.0230, 'lps'),
	(445942, 123, '2015-03-15 00:10:10.000000', 'consum', 0.0233, 'lps'),
	(445943, 123, '2015-03-15 00:10:11.000000', 'consum', 0.0219, 'lps'),
	(445944, 123, '2015-03-15 00:10:12.000000', 'consum', 0.0210, 'lps'),
	(445945, 123, '2015-03-15 00:10:13.000000', 'consum', 0.0232, 'lps'),
	(445946, 123, '2015-03-15 00:10:14.000000', 'consum', 0.0226, 'lps'),
	(445947, 123, '2015-03-15 00:10:15.000000', 'consum', 0.0224, 'lps'),
	(445948, 123, '2015-03-15 00:10:16.000000', 'consum', 0.0231, 'lps'),
	(445949, 123, '2015-03-15 00:10:17.000000', 'consum', 0.0226, 'lps'),
	(445950, 123, '2015-03-15 00:10:18.000000', 'consum', 0.0226, 'lps'),
	(445951, 123, '2015-03-15 00:10:19.000000', 'consum', 0.0221, 'lps'),
	(445952, 123, '2015-03-15 00:10:20.000000', 'consum', 0.0215, 'lps'),
	(445953, 123, '2015-03-15 00:10:21.000000', 'consum', 0.0227, 'lps'),
	(445954, 123, '2015-03-15 00:10:22.000000', 'consum', 0.0233, 'lps'),
	(445955, 123, '2015-03-15 00:10:23.000000', 'consum', 0.0226, 'lps'),
	(445956, 123, '2015-03-15 00:10:24.000000', 'consum', 0.0220, 'lps'),
	(445957, 123, '2015-03-15 00:10:25.000000', 'consum', 0.0212, 'lps'),
	(445958, 123, '2015-03-15 00:10:26.000000', 'consum', 0.0217, 'lps'),
	(445959, 123, '2015-03-15 00:10:27.000000', 'consum', 0.0216, 'lps'),
	(445960, 123, '2015-03-15 00:10:28.000000', 'consum', 0.0217, 'lps'),
	(445961, 123, '2015-03-15 00:10:29.000000', 'consum', 0.0230, 'lps'),
	(445962, 123, '2015-03-15 00:10:30.000000', 'consum', 0.0215, 'lps'),
	(445963, 123, '2015-03-15 00:10:31.000000', 'consum', 0.0226, 'lps'),
	(445964, 123, '2015-03-15 00:10:32.000000', 'consum', 0.0225, 'lps'),
	(445965, 123, '2015-03-15 00:10:33.000000', 'consum', 0.0213, 'lps'),
	(445966, 123, '2015-03-15 00:10:34.000000', 'consum', 0.0229, 'lps'),
	(445967, 123, '2015-03-15 00:10:35.000000', 'consum', 0.0224, 'lps'),
	(445968, 123, '2015-03-15 00:10:36.000000', 'consum', 0.0225, 'lps'),
	(445969, 123, '2015-03-15 00:10:37.000000', 'consum', 0.0220, 'lps'),
	(445970, 123, '2015-03-15 00:10:38.000000', 'consum', 0.0215, 'lps'),
	(445971, 123, '2015-03-15 00:10:39.000000', 'consum', 0.0230, 'lps'),
	(445972, 123, '2015-03-15 00:10:40.000000', 'consum', 0.0221, 'lps'),
	(445973, 123, '2015-03-15 00:10:41.000000', 'consum', 0.0232, 'lps'),
	(445974, 123, '2015-03-15 00:10:42.000000', 'consum', 0.0216, 'lps'),
	(445975, 123, '2015-03-15 00:10:43.000000', 'consum', 0.0222, 'lps'),
	(445976, 123, '2015-03-15 00:10:44.000000', 'consum', 0.0230, 'lps'),
	(445977, 123, '2015-03-15 00:10:45.000000', 'consum', 0.0225, 'lps'),
	(445978, 123, '2015-03-15 00:10:46.000000', 'consum', 0.0227, 'lps'),
	(445979, 123, '2015-03-15 00:10:47.000000', 'consum', 0.0224, 'lps'),
	(445980, 123, '2015-03-15 00:10:48.000000', 'consum', 0.0231, 'lps'),
	(445981, 123, '2015-03-15 00:10:49.000000', 'consum', 0.0225, 'lps'),
	(445982, 123, '2015-03-15 00:10:50.000000', 'consum', 0.0224, 'lps'),
	(445983, 123, '2015-03-15 00:10:51.000000', 'consum', 0.0212, 'lps'),
	(445984, 123, '2015-03-15 00:10:52.000000', 'consum', 0.0225, 'lps'),
	(445985, 123, '2015-03-15 00:10:53.000000', 'consum', 0.0231, 'lps'),
	(445986, 123, '2015-03-15 00:10:54.000000', 'consum', 0.0224, 'lps'),
	(445987, 123, '2015-03-15 00:10:55.000000', 'consum', 0.0217, 'lps'),
	(445988, 123, '2015-03-15 00:10:56.000000', 'consum', 0.0225, 'lps'),
	(445989, 123, '2015-03-15 00:10:57.000000', 'consum', 0.0220, 'lps'),
	(445990, 123, '2015-03-15 00:10:58.000000', 'consum', 0.0215, 'lps'),
	(445991, 123, '2015-03-15 00:10:59.000000', 'consum', 0.0230, 'lps'),
	(445992, 123, '2015-03-15 00:11:00.000000', 'consum', 0.0223, 'lps'),
	(445993, 123, '2015-03-15 00:11:01.000000', 'consum', 0.0216, 'lps'),
	(445994, 123, '2015-03-15 00:11:02.000000', 'consum', 0.0225, 'lps'),
	(445995, 123, '2015-03-15 00:11:03.000000', 'consum', 0.0222, 'lps'),
	(445996, 123, '2015-03-15 00:11:04.000000', 'consum', 0.0222, 'lps'),
	(445997, 123, '2015-03-15 00:11:05.000000', 'consum', 0.0211, 'lps'),
	(445998, 123, '2015-03-15 00:11:06.000000', 'consum', 0.0229, 'lps'),
	(445999, 123, '2015-03-15 00:11:07.000000', 'consum', 0.0231, 'lps'),
	(446000, 123, '2015-03-15 00:11:08.000000', 'consum', 0.0210, 'lps'),
	(446001, 123, '2015-03-15 00:11:09.000000', 'consum', 0.0220, 'lps'),
	(446002, 123, '2015-03-15 00:11:10.000000', 'consum', 0.0212, 'lps'),
	(446003, 123, '2015-03-15 00:11:11.000000', 'consum', 0.0216, 'lps'),
	(446004, 123, '2015-03-15 00:11:12.000000', 'consum', 0.0232, 'lps'),
	(446005, 123, '2015-03-15 00:11:13.000000', 'consum', 0.0231, 'lps'),
	(446006, 123, '2015-03-15 00:11:14.000000', 'consum', 0.0227, 'lps'),
	(446007, 123, '2015-03-15 00:11:15.000000', 'consum', 0.0233, 'lps'),
	(446008, 123, '2015-03-15 00:11:16.000000', 'consum', 0.0225, 'lps'),
	(446009, 123, '2015-03-15 00:11:17.000000', 'consum', 0.0217, 'lps'),
	(446010, 123, '2015-03-15 00:11:18.000000', 'consum', 0.0225, 'lps'),
	(446011, 123, '2015-03-15 00:11:19.000000', 'consum', 0.0217, 'lps'),
	(446012, 123, '2015-03-15 00:11:20.000000', 'consum', 0.0225, 'lps'),
	(446013, 123, '2015-03-15 00:11:21.000000', 'consum', 0.0214, 'lps'),
	(446014, 123, '2015-03-15 00:11:22.000000', 'consum', 0.0210, 'lps'),
	(446015, 123, '2015-03-15 00:11:23.000000', 'consum', 0.0221, 'lps'),
	(446016, 123, '2015-03-15 00:11:24.000000', 'consum', 0.0220, 'lps'),
	(446017, 123, '2015-03-15 00:11:25.000000', 'consum', 0.0226, 'lps'),
	(446018, 123, '2015-03-15 00:11:26.000000', 'consum', 0.0211, 'lps'),
	(446019, 123, '2015-03-15 00:11:27.000000', 'consum', 0.0217, 'lps'),
	(446020, 123, '2015-03-15 00:11:28.000000', 'consum', 0.0220, 'lps'),
	(446021, 123, '2015-03-15 00:11:29.000000', 'consum', 0.0214, 'lps'),
	(446022, 123, '2015-03-15 00:11:30.000000', 'consum', 0.0223, 'lps'),
	(446023, 123, '2015-03-15 00:11:31.000000', 'consum', 0.0219, 'lps'),
	(446024, 123, '2015-03-15 00:11:32.000000', 'consum', 0.0213, 'lps'),
	(446025, 123, '2015-03-15 00:11:33.000000', 'consum', 0.0226, 'lps'),
	(446026, 123, '2015-03-15 00:11:34.000000', 'consum', 0.0231, 'lps'),
	(446027, 123, '2015-03-15 00:11:35.000000', 'consum', 0.0218, 'lps'),
	(446028, 123, '2015-03-15 00:11:36.000000', 'consum', 0.0214, 'lps'),
	(446029, 123, '2015-03-15 00:11:37.000000', 'consum', 0.0228, 'lps'),
	(446030, 123, '2015-03-15 00:11:38.000000', 'consum', 0.0219, 'lps'),
	(446031, 123, '2015-03-15 00:11:39.000000', 'consum', 0.0227, 'lps'),
	(446032, 123, '2015-03-15 00:11:40.000000', 'consum', 0.0217, 'lps'),
	(446033, 123, '2015-03-15 00:11:41.000000', 'consum', 0.0220, 'lps'),
	(446034, 123, '2015-03-15 00:11:42.000000', 'consum', 0.0217, 'lps'),
	(446035, 123, '2015-03-15 00:11:43.000000', 'consum', 0.0214, 'lps'),
	(446036, 123, '2015-03-15 00:11:44.000000', 'consum', 0.0210, 'lps'),
	(446037, 123, '2015-03-15 00:11:45.000000', 'consum', 0.0222, 'lps'),
	(446038, 123, '2015-03-15 00:11:46.000000', 'consum', 0.0222, 'lps'),
	(446039, 123, '2015-03-15 00:11:47.000000', 'consum', 0.0211, 'lps'),
	(446040, 123, '2015-03-15 00:11:48.000000', 'consum', 0.0226, 'lps'),
	(446041, 123, '2015-03-15 00:11:49.000000', 'consum', 0.0218, 'lps'),
	(446042, 123, '2015-03-15 00:11:50.000000', 'consum', 0.0226, 'lps'),
	(446043, 123, '2015-03-15 00:11:51.000000', 'consum', 0.0219, 'lps'),
	(446044, 123, '2015-03-15 00:11:52.000000', 'consum', 0.0231, 'lps'),
	(446045, 123, '2015-03-15 00:11:53.000000', 'consum', 0.0218, 'lps'),
	(446046, 123, '2015-03-15 00:11:54.000000', 'consum', 0.0233, 'lps'),
	(446047, 123, '2015-03-15 00:11:55.000000', 'consum', 0.0229, 'lps'),
	(446048, 123, '2015-03-15 00:11:56.000000', 'consum', 0.0213, 'lps'),
	(446049, 123, '2015-03-15 00:11:57.000000', 'consum', 0.0218, 'lps'),
	(446050, 123, '2015-03-15 00:11:58.000000', 'consum', 0.0217, 'lps'),
	(446051, 123, '2015-03-15 00:11:59.000000', 'consum', 0.0222, 'lps'),
	(446052, 123, '2015-03-15 00:12:00.000000', 'consum', 0.0225, 'lps'),
	(446053, 123, '2015-03-15 00:12:01.000000', 'consum', 0.0224, 'lps'),
	(446054, 123, '2015-03-15 00:12:02.000000', 'consum', 0.0213, 'lps'),
	(446055, 123, '2015-03-15 00:12:03.000000', 'consum', 0.0232, 'lps'),
	(446056, 123, '2015-03-15 00:12:04.000000', 'consum', 0.0215, 'lps'),
	(446057, 123, '2015-03-15 00:12:05.000000', 'consum', 0.0217, 'lps'),
	(446058, 123, '2015-03-15 00:12:06.000000', 'consum', 0.0231, 'lps'),
	(446059, 123, '2015-03-15 00:12:07.000000', 'consum', 0.0222, 'lps'),
	(446060, 123, '2015-03-15 00:12:08.000000', 'consum', 0.0233, 'lps'),
	(446061, 123, '2015-03-15 00:12:09.000000', 'consum', 0.0216, 'lps'),
	(446062, 123, '2015-03-15 00:12:10.000000', 'consum', 0.0221, 'lps'),
	(446063, 123, '2015-03-15 00:12:11.000000', 'consum', 0.0224, 'lps'),
	(446064, 123, '2015-03-15 00:12:12.000000', 'consum', 0.0224, 'lps'),
	(446065, 123, '2015-03-15 00:12:13.000000', 'consum', 0.0214, 'lps'),
	(446066, 123, '2015-03-15 00:12:14.000000', 'consum', 0.0213, 'lps'),
	(446067, 123, '2015-03-15 00:12:15.000000', 'consum', 0.0212, 'lps'),
	(446068, 123, '2015-03-15 00:12:16.000000', 'consum', 0.0211, 'lps'),
	(446069, 123, '2015-03-15 00:12:17.000000', 'consum', 0.0233, 'lps'),
	(446070, 123, '2015-03-15 00:12:18.000000', 'consum', 0.0229, 'lps'),
	(446071, 123, '2015-03-15 00:12:19.000000', 'consum', 0.0211, 'lps'),
	(446072, 123, '2015-03-15 00:12:20.000000', 'consum', 0.0233, 'lps'),
	(446073, 123, '2015-03-15 00:12:21.000000', 'consum', 0.0224, 'lps'),
	(446074, 123, '2015-03-15 00:12:22.000000', 'consum', 0.0211, 'lps'),
	(446075, 123, '2015-03-15 00:12:23.000000', 'consum', 0.0222, 'lps'),
	(446076, 123, '2015-03-15 00:12:24.000000', 'consum', 0.0219, 'lps'),
	(446077, 123, '2015-03-15 00:12:25.000000', 'consum', 0.0221, 'lps'),
	(446078, 123, '2015-03-15 00:12:26.000000', 'consum', 0.0212, 'lps'),
	(446079, 123, '2015-03-15 00:12:27.000000', 'consum', 0.0214, 'lps'),
	(446080, 123, '2015-03-15 00:12:28.000000', 'consum', 0.0223, 'lps'),
	(446081, 123, '2015-03-15 00:12:29.000000', 'consum', 0.0214, 'lps'),
	(446082, 123, '2015-03-15 00:12:30.000000', 'consum', 0.0217, 'lps'),
	(446083, 123, '2015-03-15 00:12:31.000000', 'consum', 0.0233, 'lps'),
	(446084, 123, '2015-03-15 00:12:32.000000', 'consum', 0.0210, 'lps'),
	(446085, 123, '2015-03-15 00:12:33.000000', 'consum', 0.0211, 'lps'),
	(446086, 123, '2015-03-15 00:12:34.000000', 'consum', 0.0218, 'lps'),
	(446087, 123, '2015-03-15 00:12:35.000000', 'consum', 0.0222, 'lps'),
	(446088, 123, '2015-03-15 00:12:36.000000', 'consum', 0.0221, 'lps'),
	(446089, 123, '2015-03-15 00:12:37.000000', 'consum', 0.0231, 'lps'),
	(446090, 123, '2015-03-15 00:12:38.000000', 'consum', 0.0211, 'lps'),
	(446091, 123, '2015-03-15 00:12:39.000000', 'consum', 0.0226, 'lps'),
	(446092, 123, '2015-03-15 00:12:40.000000', 'consum', 0.0212, 'lps'),
	(446093, 123, '2015-03-15 00:12:41.000000', 'consum', 0.0223, 'lps'),
	(446094, 123, '2015-03-15 00:12:42.000000', 'consum', 0.0222, 'lps'),
	(446095, 123, '2015-03-15 00:12:43.000000', 'consum', 0.0229, 'lps'),
	(446096, 123, '2015-03-15 00:12:44.000000', 'consum', 0.0225, 'lps'),
	(446097, 123, '2015-03-15 00:12:45.000000', 'consum', 0.0226, 'lps'),
	(446098, 123, '2015-03-15 00:12:46.000000', 'consum', 0.0220, 'lps'),
	(446099, 123, '2015-03-15 00:12:47.000000', 'consum', 0.0214, 'lps'),
	(446100, 123, '2015-03-15 00:12:48.000000', 'consum', 0.0224, 'lps'),
	(446101, 123, '2015-03-15 00:12:49.000000', 'consum', 0.0221, 'lps'),
	(446102, 123, '2015-03-15 00:12:50.000000', 'consum', 0.0223, 'lps'),
	(446103, 123, '2015-03-15 00:12:51.000000', 'consum', 0.0217, 'lps'),
	(446104, 123, '2015-03-15 00:12:52.000000', 'consum', 0.0231, 'lps'),
	(446105, 123, '2015-03-15 00:12:53.000000', 'consum', 0.0225, 'lps'),
	(446106, 123, '2015-03-15 00:12:54.000000', 'consum', 0.0222, 'lps'),
	(446107, 123, '2015-03-15 00:12:55.000000', 'consum', 0.0223, 'lps'),
	(446108, 123, '2015-03-15 00:12:56.000000', 'consum', 0.0219, 'lps'),
	(446109, 123, '2015-03-15 00:12:57.000000', 'consum', 0.0214, 'lps'),
	(446110, 123, '2015-03-15 00:12:58.000000', 'consum', 0.0228, 'lps'),
	(446111, 123, '2015-03-15 00:12:59.000000', 'consum', 0.0217, 'lps'),
	(446112, 123, '2015-03-15 00:13:00.000000', 'consum', 0.0215, 'lps'),
	(446113, 123, '2015-03-15 00:13:01.000000', 'consum', 0.0215, 'lps'),
	(446114, 123, '2015-03-15 00:13:02.000000', 'consum', 0.0220, 'lps'),
	(446115, 123, '2015-03-15 00:13:03.000000', 'consum', 0.0221, 'lps'),
	(446116, 123, '2015-03-15 00:13:04.000000', 'consum', 0.0211, 'lps'),
	(446117, 123, '2015-03-15 00:13:05.000000', 'consum', 0.0233, 'lps'),
	(446118, 123, '2015-03-15 00:13:06.000000', 'consum', 0.0225, 'lps'),
	(446119, 123, '2015-03-15 00:13:07.000000', 'consum', 0.0218, 'lps'),
	(446120, 123, '2015-03-15 00:13:08.000000', 'consum', 0.0230, 'lps'),
	(446121, 123, '2015-03-15 00:13:09.000000', 'consum', 0.0213, 'lps'),
	(446122, 123, '2015-03-15 00:13:10.000000', 'consum', 0.0213, 'lps'),
	(446123, 123, '2015-03-15 00:13:11.000000', 'consum', 0.0219, 'lps'),
	(446124, 123, '2015-03-15 00:13:12.000000', 'consum', 0.0219, 'lps'),
	(446125, 123, '2015-03-15 00:13:13.000000', 'consum', 0.0231, 'lps'),
	(446126, 123, '2015-03-15 00:13:14.000000', 'consum', 0.0216, 'lps'),
	(446127, 123, '2015-03-15 00:13:15.000000', 'consum', 0.0225, 'lps'),
	(446128, 123, '2015-03-15 00:13:16.000000', 'consum', 0.0219, 'lps'),
	(446129, 123, '2015-03-15 00:13:17.000000', 'consum', 0.0211, 'lps'),
	(446130, 123, '2015-03-15 00:13:18.000000', 'consum', 0.0214, 'lps'),
	(446131, 123, '2015-03-15 00:13:19.000000', 'consum', 0.0226, 'lps'),
	(446132, 123, '2015-03-15 00:13:20.000000', 'consum', 0.0229, 'lps'),
	(446133, 123, '2015-03-15 00:13:21.000000', 'consum', 0.0210, 'lps'),
	(446134, 123, '2015-03-15 00:13:22.000000', 'consum', 0.0226, 'lps'),
	(446135, 123, '2015-03-15 00:13:23.000000', 'consum', 0.0219, 'lps'),
	(446136, 123, '2015-03-15 00:13:24.000000', 'consum', 0.0230, 'lps'),
	(446137, 123, '2015-03-15 00:13:25.000000', 'consum', 0.0212, 'lps'),
	(446138, 123, '2015-03-15 00:13:26.000000', 'consum', 0.0211, 'lps'),
	(446139, 123, '2015-03-15 00:13:27.000000', 'consum', 0.0230, 'lps'),
	(446140, 123, '2015-03-15 00:13:28.000000', 'consum', 0.0212, 'lps'),
	(446141, 123, '2015-03-15 00:13:29.000000', 'consum', 0.0211, 'lps'),
	(446142, 123, '2015-03-15 00:13:30.000000', 'consum', 0.0231, 'lps'),
	(446143, 123, '2015-03-15 00:13:31.000000', 'consum', 0.0218, 'lps'),
	(446144, 123, '2015-03-15 00:13:32.000000', 'consum', 0.0211, 'lps'),
	(446145, 123, '2015-03-15 00:13:33.000000', 'consum', 0.0216, 'lps'),
	(446146, 123, '2015-03-15 00:13:34.000000', 'consum', 0.0212, 'lps'),
	(446147, 123, '2015-03-15 00:13:35.000000', 'consum', 0.0226, 'lps'),
	(446148, 123, '2015-03-15 00:13:36.000000', 'consum', 0.0215, 'lps'),
	(446149, 123, '2015-03-15 00:13:37.000000', 'consum', 0.0210, 'lps'),
	(446150, 123, '2015-03-15 00:13:38.000000', 'consum', 0.0219, 'lps'),
	(446151, 123, '2015-03-15 00:13:39.000000', 'consum', 0.0231, 'lps'),
	(446152, 123, '2015-03-15 00:13:40.000000', 'consum', 0.0219, 'lps'),
	(446153, 123, '2015-03-15 00:13:41.000000', 'consum', 0.0215, 'lps'),
	(446154, 123, '2015-03-15 00:13:42.000000', 'consum', 0.0233, 'lps'),
	(446155, 123, '2015-03-15 00:13:43.000000', 'consum', 0.0214, 'lps'),
	(446156, 123, '2015-03-15 00:13:44.000000', 'consum', 0.0210, 'lps'),
	(446157, 123, '2015-03-15 00:13:45.000000', 'consum', 0.0221, 'lps'),
	(446158, 123, '2015-03-15 00:13:46.000000', 'consum', 0.0217, 'lps'),
	(446159, 123, '2015-03-15 00:13:47.000000', 'consum', 0.0214, 'lps'),
	(446160, 123, '2015-03-15 00:13:48.000000', 'consum', 0.0210, 'lps'),
	(446161, 123, '2015-03-15 00:13:49.000000', 'consum', 0.0221, 'lps'),
	(446162, 123, '2015-03-15 00:13:50.000000', 'consum', 0.0218, 'lps'),
	(446163, 123, '2015-03-15 00:13:51.000000', 'consum', 0.0219, 'lps'),
	(446164, 123, '2015-03-15 00:13:52.000000', 'consum', 0.0232, 'lps'),
	(446165, 123, '2015-03-15 00:13:53.000000', 'consum', 0.0221, 'lps'),
	(446166, 123, '2015-03-15 00:13:54.000000', 'consum', 0.0222, 'lps'),
	(446167, 123, '2015-03-15 00:13:55.000000', 'consum', 0.0213, 'lps'),
	(446168, 123, '2015-03-15 00:13:56.000000', 'consum', 0.0215, 'lps'),
	(446169, 123, '2015-03-15 00:13:57.000000', 'consum', 0.0226, 'lps'),
	(446170, 123, '2015-03-15 00:13:58.000000', 'consum', 0.0229, 'lps'),
	(446171, 123, '2015-03-15 00:13:59.000000', 'consum', 0.0231, 'lps'),
	(446172, 123, '2015-03-15 00:14:00.000000', 'consum', 0.0213, 'lps'),
	(446173, 123, '2015-03-15 00:14:01.000000', 'consum', 0.0210, 'lps'),
	(446174, 123, '2015-03-15 00:14:02.000000', 'consum', 0.0227, 'lps'),
	(446175, 123, '2015-03-15 00:14:03.000000', 'consum', 0.0221, 'lps'),
	(446176, 123, '2015-03-15 00:14:04.000000', 'consum', 0.0214, 'lps'),
	(446177, 123, '2015-03-15 00:14:05.000000', 'consum', 0.0221, 'lps'),
	(446178, 123, '2015-03-15 00:14:06.000000', 'consum', 0.0232, 'lps'),
	(446179, 123, '2015-03-15 00:14:07.000000', 'consum', 0.0213, 'lps'),
	(446180, 123, '2015-03-15 00:14:08.000000', 'consum', 0.0232, 'lps'),
	(446181, 123, '2015-03-15 00:14:09.000000', 'consum', 0.0216, 'lps'),
	(446182, 123, '2015-03-15 00:14:10.000000', 'consum', 0.0221, 'lps'),
	(446183, 123, '2015-03-15 00:14:11.000000', 'consum', 0.0226, 'lps'),
	(446184, 123, '2015-03-15 00:14:12.000000', 'consum', 0.0210, 'lps'),
	(446185, 123, '2015-03-15 00:14:13.000000', 'consum', 0.0210, 'lps'),
	(446186, 123, '2015-03-15 00:14:14.000000', 'consum', 0.0210, 'lps'),
	(446187, 123, '2015-03-15 00:14:15.000000', 'consum', 0.0212, 'lps'),
	(446188, 123, '2015-03-15 00:14:16.000000', 'consum', 0.0221, 'lps'),
	(446189, 123, '2015-03-15 00:14:17.000000', 'consum', 0.0210, 'lps'),
	(446190, 123, '2015-03-15 00:14:18.000000', 'consum', 0.0227, 'lps'),
	(446191, 123, '2015-03-15 00:14:19.000000', 'consum', 0.0221, 'lps'),
	(446192, 123, '2015-03-15 00:14:20.000000', 'consum', 0.0216, 'lps'),
	(446193, 123, '2015-03-15 00:14:21.000000', 'consum', 0.0232, 'lps'),
	(446194, 123, '2015-03-15 00:14:22.000000', 'consum', 0.0231, 'lps'),
	(446195, 123, '2015-03-15 00:14:23.000000', 'consum', 0.0226, 'lps'),
	(446196, 123, '2015-03-15 00:14:24.000000', 'consum', 0.0226, 'lps'),
	(446197, 123, '2015-03-15 00:14:25.000000', 'consum', 0.0219, 'lps'),
	(446198, 123, '2015-03-15 00:14:26.000000', 'consum', 0.0232, 'lps'),
	(446199, 123, '2015-03-15 00:14:27.000000', 'consum', 0.0222, 'lps'),
	(446200, 123, '2015-03-15 00:14:28.000000', 'consum', 0.0230, 'lps'),
	(446201, 123, '2015-03-15 00:14:29.000000', 'consum', 0.0224, 'lps'),
	(446202, 123, '2015-03-15 00:14:30.000000', 'consum', 0.0223, 'lps'),
	(446203, 123, '2015-03-15 00:14:31.000000', 'consum', 0.0232, 'lps'),
	(446204, 123, '2015-03-15 00:14:32.000000', 'consum', 0.0232, 'lps'),
	(446205, 123, '2015-03-15 00:14:33.000000', 'consum', 0.0232, 'lps'),
	(446206, 123, '2015-03-15 00:14:34.000000', 'consum', 0.0230, 'lps'),
	(446207, 123, '2015-03-15 00:14:35.000000', 'consum', 0.0220, 'lps'),
	(446208, 123, '2015-03-15 00:14:36.000000', 'consum', 0.0226, 'lps'),
	(446209, 123, '2015-03-15 00:14:37.000000', 'consum', 0.0214, 'lps'),
	(446210, 123, '2015-03-15 00:14:38.000000', 'consum', 0.0228, 'lps'),
	(446211, 123, '2015-03-15 00:14:39.000000', 'consum', 0.0215, 'lps'),
	(446212, 123, '2015-03-15 00:14:40.000000', 'consum', 0.0231, 'lps'),
	(446213, 123, '2015-03-15 00:14:41.000000', 'consum', 0.0230, 'lps'),
	(446214, 123, '2015-03-15 00:14:42.000000', 'consum', 0.0224, 'lps'),
	(446215, 123, '2015-03-15 00:14:43.000000', 'consum', 0.0219, 'lps'),
	(446216, 123, '2015-03-15 00:14:44.000000', 'consum', 0.0214, 'lps'),
	(446217, 123, '2015-03-15 00:14:45.000000', 'consum', 0.0228, 'lps'),
	(446218, 123, '2015-03-15 00:14:46.000000', 'consum', 0.0214, 'lps'),
	(446219, 123, '2015-03-15 00:14:47.000000', 'consum', 0.0227, 'lps'),
	(446220, 123, '2015-03-15 00:14:48.000000', 'consum', 0.0210, 'lps'),
	(446221, 123, '2015-03-15 00:14:49.000000', 'consum', 0.0232, 'lps'),
	(446222, 123, '2015-03-15 00:14:50.000000', 'consum', 0.0223, 'lps'),
	(446223, 123, '2015-03-15 00:14:51.000000', 'consum', 0.0212, 'lps'),
	(446224, 123, '2015-03-15 00:14:52.000000', 'consum', 0.0229, 'lps'),
	(446225, 123, '2015-03-15 00:14:53.000000', 'consum', 0.0229, 'lps'),
	(446226, 123, '2015-03-15 00:14:54.000000', 'consum', 0.0223, 'lps'),
	(446227, 123, '2015-03-15 00:14:55.000000', 'consum', 0.0219, 'lps'),
	(446228, 123, '2015-03-15 00:14:56.000000', 'consum', 0.0218, 'lps'),
	(446229, 123, '2015-03-15 00:14:57.000000', 'consum', 0.0224, 'lps'),
	(446230, 123, '2015-03-15 00:14:58.000000', 'consum', 0.0231, 'lps'),
	(446231, 123, '2015-03-15 00:14:59.000000', 'consum', 0.0224, 'lps'),
	(446232, 123, '2015-03-15 00:15:00.000000', 'consum', 0.0218, 'lps'),
	(446233, 123, '2015-03-15 00:15:01.000000', 'consum', 0.0232, 'lps'),
	(446234, 123, '2015-03-15 00:15:02.000000', 'consum', 0.0224, 'lps'),
	(446235, 123, '2015-03-15 00:15:03.000000', 'consum', 0.0216, 'lps'),
	(446236, 123, '2015-03-15 00:15:04.000000', 'consum', 0.0224, 'lps'),
	(446237, 123, '2015-03-15 00:15:05.000000', 'consum', 0.0212, 'lps'),
	(446238, 123, '2015-03-15 00:15:06.000000', 'consum', 0.0228, 'lps'),
	(446239, 123, '2015-03-15 00:15:07.000000', 'consum', 0.0222, 'lps'),
	(446240, 123, '2015-03-15 00:15:08.000000', 'consum', 0.0215, 'lps'),
	(446241, 123, '2015-03-15 00:15:09.000000', 'consum', 0.0226, 'lps'),
	(446242, 123, '2015-03-15 00:15:10.000000', 'consum', 0.0228, 'lps'),
	(446243, 123, '2015-03-15 00:15:11.000000', 'consum', 0.0227, 'lps'),
	(446244, 123, '2015-03-15 00:15:12.000000', 'consum', 0.0219, 'lps'),
	(446245, 123, '2015-03-15 00:15:13.000000', 'consum', 0.0226, 'lps'),
	(446246, 123, '2015-03-15 00:15:14.000000', 'consum', 0.0216, 'lps'),
	(446247, 123, '2015-03-15 00:15:15.000000', 'consum', 0.0217, 'lps'),
	(446248, 123, '2015-03-15 00:15:16.000000', 'consum', 0.0227, 'lps'),
	(446249, 123, '2015-03-15 00:15:17.000000', 'consum', 0.0228, 'lps'),
	(446250, 123, '2015-03-15 00:15:18.000000', 'consum', 0.0223, 'lps'),
	(446251, 123, '2015-03-15 00:15:19.000000', 'consum', 0.0224, 'lps'),
	(446252, 123, '2015-03-15 00:15:20.000000', 'consum', 0.0217, 'lps'),
	(446253, 123, '2015-03-15 00:15:21.000000', 'consum', 0.0228, 'lps'),
	(446254, 123, '2015-03-15 00:15:22.000000', 'consum', 0.0231, 'lps'),
	(446255, 123, '2015-03-15 00:15:23.000000', 'consum', 0.0213, 'lps'),
	(446256, 123, '2015-03-15 00:15:24.000000', 'consum', 0.0211, 'lps'),
	(446257, 123, '2015-03-15 00:15:25.000000', 'consum', 0.0229, 'lps'),
	(446258, 123, '2015-03-15 00:15:26.000000', 'consum', 0.0230, 'lps'),
	(446259, 123, '2015-03-15 00:15:27.000000', 'consum', 0.0229, 'lps'),
	(446260, 123, '2015-03-15 00:15:28.000000', 'consum', 0.0221, 'lps'),
	(446261, 123, '2015-03-15 00:15:29.000000', 'consum', 0.0210, 'lps'),
	(446262, 123, '2015-03-15 00:15:30.000000', 'consum', 0.0226, 'lps'),
	(446263, 123, '2015-03-15 00:15:31.000000', 'consum', 0.0219, 'lps'),
	(446264, 123, '2015-03-15 00:15:32.000000', 'consum', 0.0231, 'lps'),
	(446265, 123, '2015-03-15 00:15:33.000000', 'consum', 0.0215, 'lps'),
	(446266, 123, '2015-03-15 00:15:34.000000', 'consum', 0.0221, 'lps'),
	(446267, 123, '2015-03-15 00:15:35.000000', 'consum', 0.0227, 'lps'),
	(446268, 123, '2015-03-15 00:15:36.000000', 'consum', 0.0214, 'lps'),
	(446269, 123, '2015-03-15 00:15:37.000000', 'consum', 0.0230, 'lps'),
	(446270, 123, '2015-03-15 00:15:38.000000', 'consum', 0.0224, 'lps'),
	(446271, 123, '2015-03-15 00:15:39.000000', 'consum', 0.0219, 'lps'),
	(446272, 123, '2015-03-15 00:15:40.000000', 'consum', 0.0216, 'lps'),
	(446273, 123, '2015-03-15 00:15:41.000000', 'consum', 0.0213, 'lps'),
	(446274, 123, '2015-03-15 00:15:42.000000', 'consum', 0.0232, 'lps'),
	(446275, 123, '2015-03-15 00:15:43.000000', 'consum', 0.0215, 'lps'),
	(446276, 123, '2015-03-15 00:15:44.000000', 'consum', 0.0219, 'lps'),
	(446277, 123, '2015-03-15 00:15:45.000000', 'consum', 0.0215, 'lps'),
	(446278, 123, '2015-03-15 00:15:46.000000', 'consum', 0.0210, 'lps'),
	(446279, 123, '2015-03-15 00:15:47.000000', 'consum', 0.0219, 'lps'),
	(446280, 123, '2015-03-15 00:15:48.000000', 'consum', 0.0232, 'lps'),
	(446281, 123, '2015-03-15 00:15:49.000000', 'consum', 0.0221, 'lps'),
	(446282, 123, '2015-03-15 00:15:50.000000', 'consum', 0.0222, 'lps'),
	(446283, 123, '2015-03-15 00:15:51.000000', 'consum', 0.0215, 'lps'),
	(446284, 123, '2015-03-15 00:15:52.000000', 'consum', 0.0223, 'lps'),
	(446285, 123, '2015-03-15 00:15:53.000000', 'consum', 0.0212, 'lps'),
	(446286, 123, '2015-03-15 00:15:54.000000', 'consum', 0.0229, 'lps'),
	(446287, 123, '2015-03-15 00:15:55.000000', 'consum', 0.0228, 'lps'),
	(446288, 123, '2015-03-15 00:15:56.000000', 'consum', 0.0221, 'lps'),
	(446289, 123, '2015-03-15 00:15:57.000000', 'consum', 0.0212, 'lps'),
	(446290, 123, '2015-03-15 00:15:58.000000', 'consum', 0.0233, 'lps'),
	(446291, 123, '2015-03-15 00:15:59.000000', 'consum', 0.0224, 'lps'),
	(446292, 123, '2015-03-15 00:16:00.000000', 'consum', 0.0213, 'lps'),
	(446293, 123, '2015-03-15 00:16:01.000000', 'consum', 0.0229, 'lps'),
	(446294, 123, '2015-03-15 00:16:02.000000', 'consum', 0.0227, 'lps'),
	(446295, 123, '2015-03-15 00:16:03.000000', 'consum', 0.0213, 'lps'),
	(446296, 123, '2015-03-15 00:16:04.000000', 'consum', 0.0221, 'lps'),
	(446297, 123, '2015-03-15 00:16:05.000000', 'consum', 0.0212, 'lps'),
	(446298, 123, '2015-03-15 00:16:06.000000', 'consum', 0.0232, 'lps'),
	(446299, 123, '2015-03-15 00:16:07.000000', 'consum', 0.0220, 'lps'),
	(446300, 123, '2015-03-15 00:16:08.000000', 'consum', 0.0219, 'lps'),
	(446301, 123, '2015-03-15 00:16:09.000000', 'consum', 0.0225, 'lps'),
	(446302, 123, '2015-03-15 00:16:10.000000', 'consum', 0.0233, 'lps'),
	(446303, 123, '2015-03-15 00:16:11.000000', 'consum', 0.0210, 'lps'),
	(446304, 123, '2015-03-15 00:16:12.000000', 'consum', 0.0213, 'lps'),
	(446305, 123, '2015-03-15 00:16:13.000000', 'consum', 0.0227, 'lps'),
	(446306, 123, '2015-03-15 00:16:14.000000', 'consum', 0.0214, 'lps'),
	(446307, 123, '2015-03-15 00:16:15.000000', 'consum', 0.0227, 'lps'),
	(446308, 123, '2015-03-15 00:16:16.000000', 'consum', 0.0211, 'lps'),
	(446309, 123, '2015-03-15 00:16:17.000000', 'consum', 0.0214, 'lps'),
	(446310, 123, '2015-03-15 00:16:18.000000', 'consum', 0.0228, 'lps'),
	(446311, 123, '2015-03-15 00:16:19.000000', 'consum', 0.0214, 'lps'),
	(446312, 123, '2015-03-15 00:16:20.000000', 'consum', 0.0225, 'lps'),
	(446313, 123, '2015-03-15 00:16:21.000000', 'consum', 0.0226, 'lps'),
	(446314, 123, '2015-03-15 00:16:22.000000', 'consum', 0.0222, 'lps'),
	(446315, 123, '2015-03-15 00:16:23.000000', 'consum', 0.0222, 'lps'),
	(446316, 123, '2015-03-15 00:16:24.000000', 'consum', 0.0211, 'lps'),
	(446317, 123, '2015-03-15 00:16:25.000000', 'consum', 0.0227, 'lps'),
	(446318, 123, '2015-03-15 00:16:26.000000', 'consum', 0.0222, 'lps'),
	(446319, 123, '2015-03-15 00:16:27.000000', 'consum', 0.0218, 'lps'),
	(446320, 123, '2015-03-15 00:16:28.000000', 'consum', 0.0213, 'lps'),
	(446321, 123, '2015-03-15 00:16:29.000000', 'consum', 0.0228, 'lps'),
	(446322, 123, '2015-03-15 00:16:30.000000', 'consum', 0.0219, 'lps'),
	(446323, 123, '2015-03-15 00:16:31.000000', 'consum', 0.0227, 'lps'),
	(446324, 123, '2015-03-15 00:16:32.000000', 'consum', 0.0219, 'lps'),
	(446325, 123, '2015-03-15 00:16:33.000000', 'consum', 0.0228, 'lps'),
	(446326, 123, '2015-03-15 00:16:34.000000', 'consum', 0.0228, 'lps'),
	(446327, 123, '2015-03-15 00:16:35.000000', 'consum', 0.0222, 'lps'),
	(446328, 123, '2015-03-15 00:16:36.000000', 'consum', 0.0215, 'lps'),
	(446329, 123, '2015-03-15 00:16:37.000000', 'consum', 0.0222, 'lps'),
	(446330, 123, '2015-03-15 00:16:38.000000', 'consum', 0.0210, 'lps'),
	(446331, 123, '2015-03-15 00:16:39.000000', 'consum', 0.0224, 'lps'),
	(446332, 123, '2015-03-15 00:16:40.000000', 'consum', 0.0230, 'lps'),
	(446333, 123, '2015-03-15 00:16:41.000000', 'consum', 0.0222, 'lps'),
	(446334, 123, '2015-03-15 00:16:42.000000', 'consum', 0.0233, 'lps'),
	(446335, 123, '2015-03-15 00:16:43.000000', 'consum', 0.0219, 'lps'),
	(446336, 123, '2015-03-15 00:16:44.000000', 'consum', 0.0212, 'lps'),
	(446337, 123, '2015-03-15 00:16:45.000000', 'consum', 0.0214, 'lps'),
	(446338, 123, '2015-03-15 00:16:46.000000', 'consum', 0.0226, 'lps'),
	(446339, 123, '2015-03-15 00:16:47.000000', 'consum', 0.0231, 'lps'),
	(446340, 123, '2015-03-15 00:16:48.000000', 'consum', 0.0217, 'lps'),
	(446341, 123, '2015-03-15 00:16:49.000000', 'consum', 0.0232, 'lps'),
	(446342, 123, '2015-03-15 00:16:50.000000', 'consum', 0.0228, 'lps'),
	(446343, 123, '2015-03-15 00:16:51.000000', 'consum', 0.0233, 'lps'),
	(446344, 123, '2015-03-15 00:16:52.000000', 'consum', 0.0225, 'lps'),
	(446345, 123, '2015-03-15 00:16:53.000000', 'consum', 0.0214, 'lps'),
	(446346, 123, '2015-03-15 00:16:54.000000', 'consum', 0.0211, 'lps'),
	(446347, 123, '2015-03-15 00:16:55.000000', 'consum', 0.0226, 'lps'),
	(446348, 123, '2015-03-15 00:16:56.000000', 'consum', 0.0217, 'lps'),
	(446349, 123, '2015-03-15 00:16:57.000000', 'consum', 0.0219, 'lps'),
	(446350, 123, '2015-03-15 00:16:58.000000', 'consum', 0.0212, 'lps'),
	(446351, 123, '2015-03-15 00:16:59.000000', 'consum', 0.0218, 'lps'),
	(446352, 123, '2015-03-15 00:17:00.000000', 'consum', 0.0222, 'lps'),
	(446353, 123, '2015-03-15 00:17:01.000000', 'consum', 0.0221, 'lps'),
	(446354, 123, '2015-03-15 00:17:02.000000', 'consum', 0.0228, 'lps'),
	(446355, 123, '2015-03-15 00:17:03.000000', 'consum', 0.0221, 'lps'),
	(446356, 123, '2015-03-15 00:17:04.000000', 'consum', 0.0211, 'lps'),
	(446357, 123, '2015-03-15 00:17:05.000000', 'consum', 0.0232, 'lps'),
	(446358, 123, '2015-03-15 00:17:06.000000', 'consum', 0.0219, 'lps'),
	(446359, 123, '2015-03-15 00:17:07.000000', 'consum', 0.0215, 'lps'),
	(446360, 123, '2015-03-15 00:17:08.000000', 'consum', 0.0233, 'lps'),
	(446361, 123, '2015-03-15 00:17:09.000000', 'consum', 0.0216, 'lps'),
	(446362, 123, '2015-03-15 00:17:10.000000', 'consum', 0.0218, 'lps'),
	(446363, 123, '2015-03-15 00:17:11.000000', 'consum', 0.0231, 'lps'),
	(446364, 123, '2015-03-15 00:17:12.000000', 'consum', 0.0221, 'lps'),
	(446365, 123, '2015-03-15 00:17:13.000000', 'consum', 0.0226, 'lps'),
	(446366, 123, '2015-03-15 00:17:14.000000', 'consum', 0.0233, 'lps'),
	(446367, 123, '2015-03-15 00:17:15.000000', 'consum', 0.0230, 'lps'),
	(446368, 123, '2015-03-15 00:17:16.000000', 'consum', 0.0219, 'lps'),
	(446369, 123, '2015-03-15 00:17:17.000000', 'consum', 0.0218, 'lps'),
	(446370, 123, '2015-03-15 00:17:18.000000', 'consum', 0.0224, 'lps'),
	(446371, 123, '2015-03-15 00:17:19.000000', 'consum', 0.0210, 'lps'),
	(446372, 123, '2015-03-15 00:17:20.000000', 'consum', 0.0215, 'lps'),
	(446373, 123, '2015-03-15 00:17:21.000000', 'consum', 0.0210, 'lps'),
	(446374, 123, '2015-03-15 00:17:22.000000', 'consum', 0.0223, 'lps'),
	(446375, 123, '2015-03-15 00:17:23.000000', 'consum', 0.0225, 'lps'),
	(446376, 123, '2015-03-15 00:17:24.000000', 'consum', 0.0225, 'lps'),
	(446377, 123, '2015-03-15 00:17:25.000000', 'consum', 0.0213, 'lps'),
	(446378, 123, '2015-03-15 00:17:26.000000', 'consum', 0.0231, 'lps'),
	(446379, 123, '2015-03-15 00:17:27.000000', 'consum', 0.0233, 'lps'),
	(446380, 123, '2015-03-15 00:17:28.000000', 'consum', 0.0214, 'lps'),
	(446381, 123, '2015-03-15 00:17:29.000000', 'consum', 0.0233, 'lps'),
	(446382, 123, '2015-03-15 00:17:30.000000', 'consum', 0.0217, 'lps'),
	(446383, 123, '2015-03-15 00:17:31.000000', 'consum', 0.0226, 'lps'),
	(446384, 123, '2015-03-15 00:17:32.000000', 'consum', 0.0220, 'lps'),
	(446385, 123, '2015-03-15 00:17:33.000000', 'consum', 0.0213, 'lps'),
	(446386, 123, '2015-03-15 00:17:34.000000', 'consum', 0.0220, 'lps'),
	(446387, 123, '2015-03-15 00:17:35.000000', 'consum', 0.0229, 'lps'),
	(446388, 123, '2015-03-15 00:17:36.000000', 'consum', 0.0228, 'lps'),
	(446389, 123, '2015-03-15 00:17:37.000000', 'consum', 0.0219, 'lps'),
	(446390, 123, '2015-03-15 00:17:38.000000', 'consum', 0.0223, 'lps'),
	(446391, 123, '2015-03-15 00:17:39.000000', 'consum', 0.0228, 'lps'),
	(446392, 123, '2015-03-15 00:17:40.000000', 'consum', 0.0211, 'lps'),
	(446393, 123, '2015-03-15 00:17:41.000000', 'consum', 0.0210, 'lps'),
	(446394, 123, '2015-03-15 00:17:42.000000', 'consum', 0.0230, 'lps'),
	(446395, 123, '2015-03-15 00:17:43.000000', 'consum', 0.0215, 'lps'),
	(446396, 123, '2015-03-15 00:17:44.000000', 'consum', 0.0226, 'lps'),
	(446397, 123, '2015-03-15 00:17:45.000000', 'consum', 0.0225, 'lps'),
	(446398, 123, '2015-03-15 00:17:46.000000', 'consum', 0.0213, 'lps'),
	(446399, 123, '2015-03-15 00:17:47.000000', 'consum', 0.0229, 'lps'),
	(446400, 123, '2015-03-15 00:17:48.000000', 'consum', 0.0227, 'lps'),
	(446401, 123, '2015-03-15 00:17:49.000000', 'consum', 0.0212, 'lps'),
	(446402, 123, '2015-03-15 00:17:50.000000', 'consum', 0.0216, 'lps'),
	(446403, 123, '2015-03-15 00:17:51.000000', 'consum', 0.0212, 'lps'),
	(446404, 123, '2015-03-15 00:17:52.000000', 'consum', 0.0227, 'lps'),
	(446405, 123, '2015-03-15 00:17:53.000000', 'consum', 0.0216, 'lps'),
	(446406, 123, '2015-03-15 00:17:54.000000', 'consum', 0.0212, 'lps'),
	(446407, 123, '2015-03-15 00:17:55.000000', 'consum', 0.0229, 'lps'),
	(446408, 123, '2015-03-15 00:17:56.000000', 'consum', 0.0228, 'lps'),
	(446409, 123, '2015-03-15 00:17:57.000000', 'consum', 0.0220, 'lps'),
	(446410, 123, '2015-03-15 00:17:58.000000', 'consum', 0.0232, 'lps'),
	(446411, 123, '2015-03-15 00:17:59.000000', 'consum', 0.0215, 'lps'),
	(446412, 123, '2015-03-15 00:18:00.000000', 'consum', 0.0218, 'lps'),
	(446413, 123, '2015-03-15 00:18:01.000000', 'consum', 0.0213, 'lps'),
	(446414, 123, '2015-03-15 00:18:02.000000', 'consum', 0.0226, 'lps'),
	(446415, 123, '2015-03-15 00:18:03.000000', 'consum', 0.0232, 'lps'),
	(446416, 123, '2015-03-15 00:18:04.000000', 'consum', 0.0223, 'lps'),
	(446417, 123, '2015-03-15 00:18:05.000000', 'consum', 0.0212, 'lps'),
	(446418, 123, '2015-03-15 00:18:06.000000', 'consum', 0.0230, 'lps'),
	(446419, 123, '2015-03-15 00:18:07.000000', 'consum', 0.0232, 'lps'),
	(446420, 123, '2015-03-15 00:18:08.000000', 'consum', 0.0212, 'lps'),
	(446421, 123, '2015-03-15 00:18:09.000000', 'consum', 0.0226, 'lps'),
	(446422, 123, '2015-03-15 00:18:10.000000', 'consum', 0.0213, 'lps'),
	(446423, 123, '2015-03-15 00:18:11.000000', 'consum', 0.0224, 'lps'),
	(446424, 123, '2015-03-15 00:18:12.000000', 'consum', 0.0226, 'lps'),
	(446425, 123, '2015-03-15 00:18:13.000000', 'consum', 0.0224, 'lps'),
	(446426, 123, '2015-03-15 00:18:14.000000', 'consum', 0.0232, 'lps'),
	(446427, 123, '2015-03-15 00:18:15.000000', 'consum', 0.0231, 'lps'),
	(446428, 123, '2015-03-15 00:18:16.000000', 'consum', 0.0223, 'lps'),
	(446429, 123, '2015-03-15 00:18:17.000000', 'consum', 0.0216, 'lps'),
	(446430, 123, '2015-03-15 00:18:18.000000', 'consum', 0.0224, 'lps'),
	(446431, 123, '2015-03-15 00:18:19.000000', 'consum', 0.0214, 'lps'),
	(446432, 123, '2015-03-15 00:18:20.000000', 'consum', 0.0215, 'lps'),
	(446433, 123, '2015-03-15 00:18:21.000000', 'consum', 0.0222, 'lps'),
	(446434, 123, '2015-03-15 00:18:22.000000', 'consum', 0.0230, 'lps'),
	(446435, 123, '2015-03-15 00:18:23.000000', 'consum', 0.0229, 'lps'),
	(446436, 123, '2015-03-15 00:18:24.000000', 'consum', 0.0221, 'lps'),
	(446437, 123, '2015-03-15 00:18:25.000000', 'consum', 0.0231, 'lps'),
	(446438, 123, '2015-03-15 00:18:26.000000', 'consum', 0.0210, 'lps'),
	(446439, 123, '2015-03-15 00:18:27.000000', 'consum', 0.0221, 'lps'),
	(446440, 123, '2015-03-15 00:18:28.000000', 'consum', 0.0219, 'lps'),
	(446441, 123, '2015-03-15 00:18:29.000000', 'consum', 0.0219, 'lps'),
	(446442, 123, '2015-03-15 00:18:30.000000', 'consum', 0.0231, 'lps'),
	(446443, 123, '2015-03-15 00:18:31.000000', 'consum', 0.0217, 'lps'),
	(446444, 123, '2015-03-15 00:18:32.000000', 'consum', 0.0229, 'lps'),
	(446445, 123, '2015-03-15 00:18:33.000000', 'consum', 0.0215, 'lps'),
	(446446, 123, '2015-03-15 00:18:34.000000', 'consum', 0.0223, 'lps'),
	(446447, 123, '2015-03-15 00:18:35.000000', 'consum', 0.0214, 'lps'),
	(446448, 123, '2015-03-15 00:18:36.000000', 'consum', 0.0216, 'lps'),
	(446449, 123, '2015-03-15 00:18:37.000000', 'consum', 0.0228, 'lps'),
	(446450, 123, '2015-03-15 00:18:38.000000', 'consum', 0.0233, 'lps'),
	(446451, 123, '2015-03-15 00:18:39.000000', 'consum', 0.0225, 'lps'),
	(446452, 123, '2015-03-15 00:18:40.000000', 'consum', 0.0215, 'lps'),
	(446453, 123, '2015-03-15 00:18:41.000000', 'consum', 0.0214, 'lps'),
	(446454, 123, '2015-03-15 00:18:42.000000', 'consum', 0.0218, 'lps'),
	(446455, 123, '2015-03-15 00:18:43.000000', 'consum', 0.0212, 'lps'),
	(446456, 123, '2015-03-15 00:18:44.000000', 'consum', 0.0220, 'lps'),
	(446457, 123, '2015-03-15 00:18:45.000000', 'consum', 0.0232, 'lps'),
	(446458, 123, '2015-03-15 00:18:46.000000', 'consum', 0.0220, 'lps'),
	(446459, 123, '2015-03-15 00:18:47.000000', 'consum', 0.0216, 'lps'),
	(446460, 123, '2015-03-15 00:18:48.000000', 'consum', 0.0212, 'lps'),
	(446461, 123, '2015-03-15 00:18:49.000000', 'consum', 0.0228, 'lps'),
	(446462, 123, '2015-03-15 00:18:50.000000', 'consum', 0.0222, 'lps'),
	(446463, 123, '2015-03-15 00:18:51.000000', 'consum', 0.0215, 'lps'),
	(446464, 123, '2015-03-15 00:18:52.000000', 'consum', 0.0224, 'lps'),
	(446465, 123, '2015-03-15 00:18:53.000000', 'consum', 0.0217, 'lps'),
	(446466, 123, '2015-03-15 00:18:54.000000', 'consum', 0.0230, 'lps'),
	(446467, 123, '2015-03-15 00:18:55.000000', 'consum', 0.0216, 'lps'),
	(446468, 123, '2015-03-15 00:18:56.000000', 'consum', 0.0229, 'lps'),
	(446469, 123, '2015-03-15 00:18:57.000000', 'consum', 0.0213, 'lps'),
	(446470, 123, '2015-03-15 00:18:58.000000', 'consum', 0.0220, 'lps'),
	(446471, 123, '2015-03-15 00:18:59.000000', 'consum', 0.0226, 'lps'),
	(446472, 123, '2015-03-15 00:19:00.000000', 'consum', 0.0211, 'lps'),
	(446473, 123, '2015-03-15 00:19:01.000000', 'consum', 0.0216, 'lps'),
	(446474, 123, '2015-03-15 00:19:02.000000', 'consum', 0.0214, 'lps'),
	(446475, 123, '2015-03-15 00:19:03.000000', 'consum', 0.0211, 'lps'),
	(446476, 123, '2015-03-15 00:19:04.000000', 'consum', 0.0229, 'lps'),
	(446477, 123, '2015-03-15 00:19:05.000000', 'consum', 0.0229, 'lps'),
	(446478, 123, '2015-03-15 00:19:06.000000', 'consum', 0.0225, 'lps'),
	(446479, 123, '2015-03-15 00:19:07.000000', 'consum', 0.0231, 'lps'),
	(446480, 123, '2015-03-15 00:19:08.000000', 'consum', 0.0219, 'lps'),
	(446481, 123, '2015-03-15 00:19:09.000000', 'consum', 0.0220, 'lps'),
	(446482, 123, '2015-03-15 00:19:10.000000', 'consum', 0.0230, 'lps'),
	(446483, 123, '2015-03-15 00:19:11.000000', 'consum', 0.0211, 'lps'),
	(446484, 123, '2015-03-15 00:19:12.000000', 'consum', 0.0225, 'lps'),
	(446485, 123, '2015-03-15 00:19:13.000000', 'consum', 0.0210, 'lps'),
	(446486, 123, '2015-03-15 00:19:14.000000', 'consum', 0.0216, 'lps'),
	(446487, 123, '2015-03-15 00:19:15.000000', 'consum', 0.0216, 'lps'),
	(446488, 123, '2015-03-15 00:19:16.000000', 'consum', 0.0223, 'lps'),
	(446489, 123, '2015-03-15 00:19:17.000000', 'consum', 0.0233, 'lps'),
	(446490, 123, '2015-03-15 00:19:18.000000', 'consum', 0.0213, 'lps'),
	(446491, 123, '2015-03-15 00:19:19.000000', 'consum', 0.0232, 'lps'),
	(446492, 123, '2015-03-15 00:19:20.000000', 'consum', 0.0212, 'lps'),
	(446493, 123, '2015-03-15 00:19:21.000000', 'consum', 0.0227, 'lps'),
	(446494, 123, '2015-03-15 00:19:22.000000', 'consum', 0.0218, 'lps'),
	(446495, 123, '2015-03-15 00:19:23.000000', 'consum', 0.0224, 'lps'),
	(446496, 123, '2015-03-15 00:19:24.000000', 'consum', 0.0233, 'lps'),
	(446497, 123, '2015-03-15 00:19:25.000000', 'consum', 0.0212, 'lps'),
	(446498, 123, '2015-03-15 00:19:26.000000', 'consum', 0.0223, 'lps'),
	(446499, 123, '2015-03-15 00:19:27.000000', 'consum', 0.0222, 'lps'),
	(446500, 123, '2015-03-15 00:19:28.000000', 'consum', 0.0231, 'lps'),
	(446501, 123, '2015-03-15 00:19:29.000000', 'consum', 0.0233, 'lps'),
	(446502, 123, '2015-03-15 00:19:30.000000', 'consum', 0.0214, 'lps'),
	(446503, 123, '2015-03-15 00:19:31.000000', 'consum', 0.0210, 'lps'),
	(446504, 123, '2015-03-15 00:19:32.000000', 'consum', 0.0221, 'lps'),
	(446505, 123, '2015-03-15 00:19:33.000000', 'consum', 0.0216, 'lps'),
	(446506, 123, '2015-03-15 00:19:34.000000', 'consum', 0.0210, 'lps'),
	(446507, 123, '2015-03-15 00:19:35.000000', 'consum', 0.0215, 'lps'),
	(446508, 123, '2015-03-15 00:19:36.000000', 'consum', 0.0214, 'lps'),
	(446509, 123, '2015-03-15 00:19:37.000000', 'consum', 0.0214, 'lps'),
	(446510, 123, '2015-03-15 00:19:38.000000', 'consum', 0.0218, 'lps'),
	(446511, 123, '2015-03-15 00:19:39.000000', 'consum', 0.0216, 'lps'),
	(446512, 123, '2015-03-15 00:19:40.000000', 'consum', 0.0214, 'lps'),
	(446513, 123, '2015-03-15 00:19:41.000000', 'consum', 0.0216, 'lps'),
	(446514, 123, '2015-03-15 00:19:42.000000', 'consum', 0.0225, 'lps'),
	(446515, 123, '2015-03-15 00:19:43.000000', 'consum', 0.0221, 'lps'),
	(446516, 123, '2015-03-15 00:19:44.000000', 'consum', 0.0220, 'lps'),
	(446517, 123, '2015-03-15 00:19:45.000000', 'consum', 0.0229, 'lps'),
	(446518, 123, '2015-03-15 00:19:46.000000', 'consum', 0.0226, 'lps'),
	(446519, 123, '2015-03-15 00:19:47.000000', 'consum', 0.0232, 'lps'),
	(446520, 123, '2015-03-15 00:19:48.000000', 'consum', 0.0225, 'lps'),
	(446521, 123, '2015-03-15 00:19:49.000000', 'consum', 0.0222, 'lps'),
	(446522, 123, '2015-03-15 00:19:50.000000', 'consum', 0.0223, 'lps'),
	(446523, 123, '2015-03-15 00:19:51.000000', 'consum', 0.0215, 'lps'),
	(446524, 123, '2015-03-15 00:19:52.000000', 'consum', 0.0220, 'lps'),
	(446525, 123, '2015-03-15 00:19:53.000000', 'consum', 0.0224, 'lps'),
	(446526, 123, '2015-03-15 00:19:54.000000', 'consum', 0.0226, 'lps'),
	(446527, 123, '2015-03-15 00:19:55.000000', 'consum', 0.0225, 'lps'),
	(446528, 123, '2015-03-15 00:19:56.000000', 'consum', 0.0214, 'lps'),
	(446529, 123, '2015-03-15 00:19:57.000000', 'consum', 0.0233, 'lps'),
	(446530, 123, '2015-03-15 00:19:58.000000', 'consum', 0.0219, 'lps'),
	(446531, 123, '2015-03-15 00:19:59.000000', 'consum', 0.0233, 'lps'),
	(446532, 123, '2015-03-15 00:20:00.000000', 'consum', 0.0226, 'lps'),
	(446533, 123, '2015-03-15 00:20:01.000000', 'consum', 0.0222, 'lps'),
	(446534, 123, '2015-03-15 00:20:02.000000', 'consum', 0.0224, 'lps'),
	(446535, 123, '2015-03-15 00:20:03.000000', 'consum', 0.0218, 'lps'),
	(446536, 123, '2015-03-15 00:20:04.000000', 'consum', 0.0210, 'lps'),
	(446537, 123, '2015-03-15 00:20:05.000000', 'consum', 0.0210, 'lps'),
	(446538, 123, '2015-03-15 00:20:06.000000', 'consum', 0.0213, 'lps'),
	(446539, 123, '2015-03-15 00:20:07.000000', 'consum', 0.0222, 'lps'),
	(446540, 123, '2015-03-15 00:20:08.000000', 'consum', 0.0217, 'lps'),
	(446541, 123, '2015-03-15 00:20:09.000000', 'consum', 0.0230, 'lps'),
	(446542, 123, '2015-03-15 00:20:10.000000', 'consum', 0.0220, 'lps'),
	(446543, 123, '2015-03-15 00:20:11.000000', 'consum', 0.0225, 'lps'),
	(446544, 123, '2015-03-15 00:20:12.000000', 'consum', 0.0231, 'lps'),
	(446545, 123, '2015-03-15 00:20:13.000000', 'consum', 0.0222, 'lps'),
	(446546, 123, '2015-03-15 00:20:14.000000', 'consum', 0.0232, 'lps'),
	(446547, 123, '2015-03-15 00:20:15.000000', 'consum', 0.0212, 'lps'),
	(446548, 123, '2015-03-15 00:20:16.000000', 'consum', 0.0225, 'lps'),
	(446549, 123, '2015-03-15 00:20:17.000000', 'consum', 0.0210, 'lps'),
	(446550, 123, '2015-03-15 00:20:18.000000', 'consum', 0.0211, 'lps'),
	(446551, 123, '2015-03-15 00:20:19.000000', 'consum', 0.0215, 'lps'),
	(446552, 123, '2015-03-15 00:20:20.000000', 'consum', 0.0212, 'lps'),
	(446553, 123, '2015-03-15 00:20:21.000000', 'consum', 0.0227, 'lps'),
	(446554, 123, '2015-03-15 00:20:22.000000', 'consum', 0.0217, 'lps'),
	(446555, 123, '2015-03-15 00:20:23.000000', 'consum', 0.0217, 'lps'),
	(446556, 123, '2015-03-15 00:20:24.000000', 'consum', 0.0228, 'lps'),
	(446557, 123, '2015-03-15 00:20:25.000000', 'consum', 0.0230, 'lps'),
	(446558, 123, '2015-03-15 00:20:26.000000', 'consum', 0.0231, 'lps'),
	(446559, 123, '2015-03-15 00:20:27.000000', 'consum', 0.0231, 'lps'),
	(446560, 123, '2015-03-15 00:20:28.000000', 'consum', 0.0230, 'lps'),
	(446561, 123, '2015-03-15 00:20:29.000000', 'consum', 0.0225, 'lps'),
	(446562, 123, '2015-03-15 00:20:30.000000', 'consum', 0.0223, 'lps'),
	(446563, 123, '2015-03-15 00:20:31.000000', 'consum', 0.0233, 'lps'),
	(446564, 123, '2015-03-15 00:20:32.000000', 'consum', 0.0211, 'lps'),
	(446565, 123, '2015-03-15 00:20:33.000000', 'consum', 0.0221, 'lps'),
	(446566, 123, '2015-03-15 00:20:34.000000', 'consum', 0.0215, 'lps'),
	(446567, 123, '2015-03-15 00:20:35.000000', 'consum', 0.0224, 'lps'),
	(446568, 123, '2015-03-15 00:20:36.000000', 'consum', 0.0220, 'lps'),
	(446569, 123, '2015-03-15 00:20:37.000000', 'consum', 0.0219, 'lps'),
	(446570, 123, '2015-03-15 00:20:38.000000', 'consum', 0.0226, 'lps'),
	(446571, 123, '2015-03-15 00:20:39.000000', 'consum', 0.0215, 'lps'),
	(446572, 123, '2015-03-15 00:20:40.000000', 'consum', 0.0210, 'lps'),
	(446573, 123, '2015-03-15 00:20:41.000000', 'consum', 0.0222, 'lps'),
	(446574, 123, '2015-03-15 00:20:42.000000', 'consum', 0.0220, 'lps'),
	(446575, 123, '2015-03-15 00:20:43.000000', 'consum', 0.0225, 'lps'),
	(446576, 123, '2015-03-15 00:20:44.000000', 'consum', 0.0231, 'lps'),
	(446577, 123, '2015-03-15 00:20:45.000000', 'consum', 0.0224, 'lps'),
	(446578, 123, '2015-03-15 00:20:46.000000', 'consum', 0.0216, 'lps'),
	(446579, 123, '2015-03-15 00:20:47.000000', 'consum', 0.0223, 'lps'),
	(446580, 123, '2015-03-15 00:20:48.000000', 'consum', 0.0233, 'lps'),
	(446581, 123, '2015-03-15 00:20:49.000000', 'consum', 0.0214, 'lps'),
	(446582, 123, '2015-03-15 00:20:50.000000', 'consum', 0.0211, 'lps'),
	(446583, 123, '2015-03-15 00:20:51.000000', 'consum', 0.0229, 'lps'),
	(446584, 123, '2015-03-15 00:20:52.000000', 'consum', 0.0228, 'lps'),
	(446585, 123, '2015-03-15 00:20:53.000000', 'consum', 0.0218, 'lps'),
	(446586, 123, '2015-03-15 00:20:54.000000', 'consum', 0.0222, 'lps'),
	(446587, 123, '2015-03-15 00:20:55.000000', 'consum', 0.0224, 'lps'),
	(446588, 123, '2015-03-15 00:20:56.000000', 'consum', 0.0219, 'lps'),
	(446589, 123, '2015-03-15 00:20:57.000000', 'consum', 0.0215, 'lps'),
	(446590, 123, '2015-03-15 00:20:58.000000', 'consum', 0.0230, 'lps'),
	(446591, 123, '2015-03-15 00:20:59.000000', 'consum', 0.0225, 'lps'),
	(446592, 123, '2015-03-15 00:21:00.000000', 'consum', 0.0226, 'lps'),
	(446593, 123, '2015-03-15 00:21:01.000000', 'consum', 0.0220, 'lps'),
	(446594, 123, '2015-03-15 00:21:02.000000', 'consum', 0.0214, 'lps'),
	(446595, 123, '2015-03-15 00:21:03.000000', 'consum', 0.0222, 'lps'),
	(446596, 123, '2015-03-15 00:21:04.000000', 'consum', 0.0214, 'lps'),
	(446597, 123, '2015-03-15 00:21:05.000000', 'consum', 0.0217, 'lps'),
	(446598, 123, '2015-03-15 00:21:06.000000', 'consum', 0.0232, 'lps'),
	(446599, 123, '2015-03-15 00:21:07.000000', 'consum', 0.0227, 'lps'),
	(446600, 123, '2015-03-15 00:21:08.000000', 'consum', 0.0230, 'lps'),
	(446601, 123, '2015-03-15 00:21:09.000000', 'consum', 0.0213, 'lps'),
	(446602, 123, '2015-03-15 00:21:10.000000', 'consum', 0.0214, 'lps'),
	(446603, 123, '2015-03-15 00:21:11.000000', 'consum', 0.0221, 'lps'),
	(446604, 123, '2015-03-15 00:21:12.000000', 'consum', 0.0228, 'lps'),
	(446605, 123, '2015-03-15 00:21:13.000000', 'consum', 0.0221, 'lps'),
	(446606, 123, '2015-03-15 00:21:14.000000', 'consum', 0.0211, 'lps'),
	(446607, 123, '2015-03-15 00:21:15.000000', 'consum', 0.0231, 'lps'),
	(446608, 123, '2015-03-15 00:21:16.000000', 'consum', 0.0215, 'lps'),
	(446609, 123, '2015-03-15 00:21:17.000000', 'consum', 0.0221, 'lps'),
	(446610, 123, '2015-03-15 00:21:18.000000', 'consum', 0.0227, 'lps'),
	(446611, 123, '2015-03-15 00:21:19.000000', 'consum', 0.0213, 'lps'),
	(446612, 123, '2015-03-15 00:21:20.000000', 'consum', 0.0222, 'lps'),
	(446613, 123, '2015-03-15 00:21:21.000000', 'consum', 0.0214, 'lps'),
	(446614, 123, '2015-03-15 00:21:22.000000', 'consum', 0.0218, 'lps'),
	(446615, 123, '2015-03-15 00:21:23.000000', 'consum', 0.0214, 'lps'),
	(446616, 123, '2015-03-15 00:21:24.000000', 'consum', 0.0230, 'lps'),
	(446617, 123, '2015-03-15 00:21:25.000000', 'consum', 0.0226, 'lps'),
	(446618, 123, '2015-03-15 00:21:26.000000', 'consum', 0.0231, 'lps'),
	(446619, 123, '2015-03-15 00:21:27.000000', 'consum', 0.0219, 'lps'),
	(446620, 123, '2015-03-15 00:21:28.000000', 'consum', 0.0217, 'lps'),
	(446621, 123, '2015-03-15 00:21:29.000000', 'consum', 0.0218, 'lps'),
	(446622, 123, '2015-03-15 00:21:30.000000', 'consum', 0.0229, 'lps'),
	(446623, 123, '2015-03-15 00:21:31.000000', 'consum', 0.0211, 'lps'),
	(446624, 123, '2015-03-15 00:21:32.000000', 'consum', 0.0230, 'lps'),
	(446625, 123, '2015-03-15 00:21:33.000000', 'consum', 0.0213, 'lps'),
	(446626, 123, '2015-03-15 00:21:34.000000', 'consum', 0.0213, 'lps'),
	(446627, 123, '2015-03-15 00:21:35.000000', 'consum', 0.0216, 'lps'),
	(446628, 123, '2015-03-15 00:21:36.000000', 'consum', 0.0233, 'lps'),
	(446629, 123, '2015-03-15 00:21:37.000000', 'consum', 0.0233, 'lps'),
	(446630, 123, '2015-03-15 00:21:38.000000', 'consum', 0.0211, 'lps'),
	(446631, 123, '2015-03-15 00:21:39.000000', 'consum', 0.0218, 'lps'),
	(446632, 123, '2015-03-15 00:21:40.000000', 'consum', 0.0225, 'lps'),
	(446633, 123, '2015-03-15 00:21:41.000000', 'consum', 0.0210, 'lps'),
	(446634, 123, '2015-03-15 00:21:42.000000', 'consum', 0.0215, 'lps'),
	(446635, 123, '2015-03-15 00:21:43.000000', 'consum', 0.0213, 'lps'),
	(446636, 123, '2015-03-15 00:21:44.000000', 'consum', 0.0211, 'lps'),
	(446637, 123, '2015-03-15 00:21:45.000000', 'consum', 0.0228, 'lps'),
	(446638, 123, '2015-03-15 00:21:46.000000', 'consum', 0.0228, 'lps'),
	(446639, 123, '2015-03-15 00:21:47.000000', 'consum', 0.0220, 'lps'),
	(446640, 123, '2015-03-15 00:21:48.000000', 'consum', 0.0233, 'lps'),
	(446641, 123, '2015-03-15 00:21:49.000000', 'consum', 0.0223, 'lps'),
	(446642, 123, '2015-03-15 00:21:50.000000', 'consum', 0.0231, 'lps'),
	(446643, 123, '2015-03-15 00:21:51.000000', 'consum', 0.0229, 'lps'),
	(446644, 123, '2015-03-15 00:21:52.000000', 'consum', 0.0217, 'lps'),
	(446645, 123, '2015-03-15 00:21:53.000000', 'consum', 0.0213, 'lps'),
	(446646, 123, '2015-03-15 00:21:54.000000', 'consum', 0.0228, 'lps'),
	(446647, 123, '2015-03-15 00:21:55.000000', 'consum', 0.0222, 'lps'),
	(446648, 123, '2015-03-15 00:21:56.000000', 'consum', 0.0213, 'lps'),
	(446649, 123, '2015-03-15 00:21:57.000000', 'consum', 0.0215, 'lps'),
	(446650, 123, '2015-03-15 00:21:58.000000', 'consum', 0.0226, 'lps'),
	(446651, 123, '2015-03-15 00:21:59.000000', 'consum', 0.0230, 'lps'),
	(446652, 123, '2015-03-15 00:22:00.000000', 'consum', 0.0212, 'lps'),
	(446653, 123, '2015-03-15 00:22:01.000000', 'consum', 0.0231, 'lps'),
	(446654, 123, '2015-03-15 00:22:02.000000', 'consum', 0.0215, 'lps'),
	(446655, 123, '2015-03-15 00:22:03.000000', 'consum', 0.0222, 'lps'),
	(446656, 123, '2015-03-15 00:22:04.000000', 'consum', 0.0232, 'lps'),
	(446657, 123, '2015-03-15 00:22:05.000000', 'consum', 0.0214, 'lps'),
	(446658, 123, '2015-03-15 00:22:06.000000', 'consum', 0.0233, 'lps'),
	(446659, 123, '2015-03-15 00:22:07.000000', 'consum', 0.0217, 'lps'),
	(446660, 123, '2015-03-15 00:22:08.000000', 'consum', 0.0227, 'lps'),
	(446661, 123, '2015-03-15 00:22:09.000000', 'consum', 0.0224, 'lps'),
	(446662, 123, '2015-03-15 00:22:10.000000', 'consum', 0.0232, 'lps'),
	(446663, 123, '2015-03-15 00:22:11.000000', 'consum', 0.0229, 'lps'),
	(446664, 123, '2015-03-15 00:22:12.000000', 'consum', 0.0217, 'lps'),
	(446665, 123, '2015-03-15 00:22:13.000000', 'consum', 0.0212, 'lps'),
	(446666, 123, '2015-03-15 00:22:14.000000', 'consum', 0.0222, 'lps'),
	(446667, 123, '2015-03-15 00:22:15.000000', 'consum', 0.0218, 'lps'),
	(446668, 123, '2015-03-15 00:22:16.000000', 'consum', 0.0213, 'lps'),
	(446669, 123, '2015-03-15 00:22:17.000000', 'consum', 0.0227, 'lps'),
	(446670, 123, '2015-03-15 00:22:18.000000', 'consum', 0.0216, 'lps'),
	(446671, 123, '2015-03-15 00:22:19.000000', 'consum', 0.0213, 'lps'),
	(446672, 123, '2015-03-15 00:22:20.000000', 'consum', 0.0229, 'lps'),
	(446673, 123, '2015-03-15 00:22:21.000000', 'consum', 0.0226, 'lps'),
	(446674, 123, '2015-03-15 00:22:22.000000', 'consum', 0.0233, 'lps'),
	(446675, 123, '2015-03-15 00:22:23.000000', 'consum', 0.0230, 'lps'),
	(446676, 123, '2015-03-15 00:22:24.000000', 'consum', 0.0216, 'lps'),
	(446677, 123, '2015-03-15 00:22:25.000000', 'consum', 0.0228, 'lps'),
	(446678, 123, '2015-03-15 00:22:26.000000', 'consum', 0.0213, 'lps'),
	(446679, 123, '2015-03-15 00:22:27.000000', 'consum', 0.0218, 'lps'),
	(446680, 123, '2015-03-15 00:22:28.000000', 'consum', 0.0218, 'lps'),
	(446681, 123, '2015-03-15 00:22:29.000000', 'consum', 0.0227, 'lps'),
	(446682, 123, '2015-03-15 00:22:30.000000', 'consum', 0.0224, 'lps'),
	(446683, 123, '2015-03-15 00:22:31.000000', 'consum', 0.0231, 'lps'),
	(446684, 123, '2015-03-15 00:22:32.000000', 'consum', 0.0222, 'lps'),
	(446685, 123, '2015-03-15 00:22:33.000000', 'consum', 0.0211, 'lps'),
	(446686, 123, '2015-03-15 00:22:34.000000', 'consum', 0.0225, 'lps'),
	(446687, 123, '2015-03-15 00:22:35.000000', 'consum', 0.0211, 'lps'),
	(446688, 123, '2015-03-15 00:22:36.000000', 'consum', 0.0220, 'lps'),
	(446689, 123, '2015-03-15 00:22:37.000000', 'consum', 0.0230, 'lps'),
	(446690, 123, '2015-03-15 00:22:38.000000', 'consum', 0.0212, 'lps'),
	(446691, 123, '2015-03-15 00:22:39.000000', 'consum', 0.0233, 'lps'),
	(446692, 123, '2015-03-15 00:22:40.000000', 'consum', 0.0223, 'lps'),
	(446693, 123, '2015-03-15 00:22:41.000000', 'consum', 0.0230, 'lps'),
	(446694, 123, '2015-03-15 00:22:42.000000', 'consum', 0.0223, 'lps'),
	(446695, 123, '2015-03-15 00:22:43.000000', 'consum', 0.0218, 'lps'),
	(446696, 123, '2015-03-15 00:22:44.000000', 'consum', 0.0232, 'lps'),
	(446697, 123, '2015-03-15 00:22:45.000000', 'consum', 0.0227, 'lps'),
	(446698, 123, '2015-03-15 00:22:46.000000', 'consum', 0.0228, 'lps'),
	(446699, 123, '2015-03-15 00:22:47.000000', 'consum', 0.0225, 'lps'),
	(446700, 123, '2015-03-15 00:22:48.000000', 'consum', 0.0232, 'lps'),
	(446701, 123, '2015-03-15 00:22:49.000000', 'consum', 0.0226, 'lps'),
	(446702, 123, '2015-03-15 00:22:50.000000', 'consum', 0.0226, 'lps'),
	(446703, 123, '2015-03-15 00:22:51.000000', 'consum', 0.0218, 'lps'),
	(446704, 123, '2015-03-15 00:22:52.000000', 'consum', 0.0227, 'lps'),
	(446705, 123, '2015-03-15 00:22:53.000000', 'consum', 0.0224, 'lps'),
	(446706, 123, '2015-03-15 00:22:54.000000', 'consum', 0.0228, 'lps'),
	(446707, 123, '2015-03-15 00:22:55.000000', 'consum', 0.0211, 'lps'),
	(446708, 123, '2015-03-15 00:22:56.000000', 'consum', 0.0232, 'lps'),
	(446709, 123, '2015-03-15 00:22:57.000000', 'consum', 0.0224, 'lps'),
	(446710, 123, '2015-03-15 00:22:58.000000', 'consum', 0.0212, 'lps'),
	(446711, 123, '2015-03-15 00:22:59.000000', 'consum', 0.0229, 'lps'),
	(446712, 123, '2015-03-15 00:23:00.000000', 'consum', 0.0225, 'lps'),
	(446713, 123, '2015-03-15 00:23:01.000000', 'consum', 0.0231, 'lps'),
	(446714, 123, '2015-03-15 00:23:02.000000', 'consum', 0.0220, 'lps'),
	(446715, 123, '2015-03-15 00:23:03.000000', 'consum', 0.0224, 'lps'),
	(446716, 123, '2015-03-15 00:23:04.000000', 'consum', 0.0227, 'lps'),
	(446717, 123, '2015-03-15 00:23:05.000000', 'consum', 0.0226, 'lps'),
	(446718, 123, '2015-03-15 00:23:06.000000', 'consum', 0.0219, 'lps'),
	(446719, 123, '2015-03-15 00:23:07.000000', 'consum', 0.0231, 'lps'),
	(446720, 123, '2015-03-15 00:23:08.000000', 'consum', 0.0215, 'lps'),
	(446721, 123, '2015-03-15 00:23:09.000000', 'consum', 0.0223, 'lps'),
	(446722, 123, '2015-03-15 00:23:10.000000', 'consum', 0.0212, 'lps'),
	(446723, 123, '2015-03-15 00:23:11.000000', 'consum', 0.0230, 'lps'),
	(446724, 123, '2015-03-15 00:23:12.000000', 'consum', 0.0210, 'lps'),
	(446725, 123, '2015-03-15 00:23:13.000000', 'consum', 0.0221, 'lps'),
	(446726, 123, '2015-03-15 00:23:14.000000', 'consum', 0.0216, 'lps'),
	(446727, 123, '2015-03-15 00:23:15.000000', 'consum', 0.0231, 'lps'),
	(446728, 123, '2015-03-15 00:23:16.000000', 'consum', 0.0225, 'lps'),
	(446729, 123, '2015-03-15 00:23:17.000000', 'consum', 0.0224, 'lps'),
	(446730, 123, '2015-03-15 00:23:18.000000', 'consum', 0.0213, 'lps'),
	(446731, 123, '2015-03-15 00:23:19.000000', 'consum', 0.0229, 'lps'),
	(446732, 123, '2015-03-15 00:23:20.000000', 'consum', 0.0226, 'lps'),
	(446733, 123, '2015-03-15 00:23:21.000000', 'consum', 0.0232, 'lps'),
	(446734, 123, '2015-03-15 00:23:22.000000', 'consum', 0.0224, 'lps'),
	(446735, 123, '2015-03-15 00:23:23.000000', 'consum', 0.0215, 'lps'),
	(446736, 123, '2015-03-15 00:23:24.000000', 'consum', 0.0219, 'lps'),
	(446737, 123, '2015-03-15 00:23:25.000000', 'consum', 0.0214, 'lps'),
	(446738, 123, '2015-03-15 00:23:26.000000', 'consum', 0.0229, 'lps'),
	(446739, 123, '2015-03-15 00:23:27.000000', 'consum', 0.0220, 'lps'),
	(446740, 123, '2015-03-15 00:23:28.000000', 'consum', 0.0226, 'lps'),
	(446741, 123, '2015-03-15 00:23:29.000000', 'consum', 0.0216, 'lps'),
	(446742, 123, '2015-03-15 00:23:30.000000', 'consum', 0.0214, 'lps'),
	(446743, 123, '2015-03-15 00:23:31.000000', 'consum', 0.0212, 'lps'),
	(446744, 123, '2015-03-15 00:23:32.000000', 'consum', 0.0210, 'lps'),
	(446745, 123, '2015-03-15 00:23:33.000000', 'consum', 0.0229, 'lps'),
	(446746, 123, '2015-03-15 00:23:34.000000', 'consum', 0.0232, 'lps'),
	(446747, 123, '2015-03-15 00:23:35.000000', 'consum', 0.0215, 'lps'),
	(446748, 123, '2015-03-15 00:23:36.000000', 'consum', 0.0219, 'lps'),
	(446749, 123, '2015-03-15 00:23:37.000000', 'consum', 0.0214, 'lps'),
	(446750, 123, '2015-03-15 00:23:38.000000', 'consum', 0.0231, 'lps'),
	(446751, 123, '2015-03-15 00:23:39.000000', 'consum', 0.0229, 'lps'),
	(446752, 123, '2015-03-15 00:23:40.000000', 'consum', 0.0221, 'lps'),
	(446753, 123, '2015-03-15 00:23:41.000000', 'consum', 0.0232, 'lps'),
	(446754, 123, '2015-03-15 00:23:42.000000', 'consum', 0.0215, 'lps'),
	(446755, 123, '2015-03-15 00:23:43.000000', 'consum', 0.0219, 'lps'),
	(446756, 123, '2015-03-15 00:23:44.000000', 'consum', 0.0216, 'lps'),
	(446757, 123, '2015-03-15 00:23:45.000000', 'consum', 0.0211, 'lps'),
	(446758, 123, '2015-03-15 00:23:46.000000', 'consum', 0.0225, 'lps'),
	(446759, 123, '2015-03-15 00:23:47.000000', 'consum', 0.0233, 'lps'),
	(446760, 123, '2015-03-15 00:23:48.000000', 'consum', 0.0231, 'lps'),
	(446761, 123, '2015-03-15 00:23:49.000000', 'consum', 0.0225, 'lps'),
	(446762, 123, '2015-03-15 00:23:50.000000', 'consum', 0.0221, 'lps'),
	(446763, 123, '2015-03-15 00:23:51.000000', 'consum', 0.0221, 'lps'),
	(446764, 123, '2015-03-15 00:23:52.000000', 'consum', 0.0233, 'lps'),
	(446765, 123, '2015-03-15 00:23:53.000000', 'consum', 0.0219, 'lps'),
	(446766, 123, '2015-03-15 00:23:54.000000', 'consum', 0.0212, 'lps'),
	(446767, 123, '2015-03-15 00:23:55.000000', 'consum', 0.0216, 'lps'),
	(446768, 123, '2015-03-15 00:23:56.000000', 'consum', 0.0213, 'lps'),
	(446769, 123, '2015-03-15 00:23:57.000000', 'consum', 0.0230, 'lps'),
	(446770, 123, '2015-03-15 00:23:58.000000', 'consum', 0.0228, 'lps'),
	(446771, 123, '2015-03-15 00:23:59.000000', 'consum', 0.0220, 'lps'),
	(446772, 123, '2015-03-15 00:24:00.000000', 'consum', 0.0228, 'lps'),
	(446773, 123, '2015-03-15 00:24:01.000000', 'consum', 0.0221, 'lps'),
	(446774, 123, '2015-03-15 00:24:02.000000', 'consum', 0.0215, 'lps'),
	(446775, 123, '2015-03-15 00:24:03.000000', 'consum', 0.0224, 'lps'),
	(446776, 123, '2015-03-15 00:24:04.000000', 'consum', 0.0217, 'lps'),
	(446777, 123, '2015-03-15 00:24:05.000000', 'consum', 0.0228, 'lps'),
	(446778, 123, '2015-03-15 00:24:06.000000', 'consum', 0.0230, 'lps'),
	(446779, 123, '2015-03-15 00:24:07.000000', 'consum', 0.0210, 'lps'),
	(446780, 123, '2015-03-15 00:24:08.000000', 'consum', 0.0222, 'lps'),
	(446781, 123, '2015-03-15 00:24:09.000000', 'consum', 0.0222, 'lps'),
	(446782, 123, '2015-03-15 00:24:10.000000', 'consum', 0.0211, 'lps'),
	(446783, 123, '2015-03-15 00:24:11.000000', 'consum', 0.0226, 'lps'),
	(446784, 123, '2015-03-15 00:24:12.000000', 'consum', 0.0215, 'lps'),
	(446785, 123, '2015-03-15 00:24:13.000000', 'consum', 0.0213, 'lps'),
	(446786, 123, '2015-03-15 00:24:14.000000', 'consum', 0.0233, 'lps'),
	(446787, 123, '2015-03-15 00:24:15.000000', 'consum', 0.0219, 'lps'),
	(446788, 123, '2015-03-15 00:24:16.000000', 'consum', 0.0213, 'lps'),
	(446789, 123, '2015-03-15 00:24:17.000000', 'consum', 0.0223, 'lps'),
	(446790, 123, '2015-03-15 00:24:18.000000', 'consum', 0.0216, 'lps'),
	(446791, 123, '2015-03-15 00:24:19.000000', 'consum', 0.0225, 'lps'),
	(446792, 123, '2015-03-15 00:24:20.000000', 'consum', 0.0223, 'lps'),
	(446793, 123, '2015-03-15 00:24:21.000000', 'consum', 0.0228, 'lps'),
	(446794, 123, '2015-03-15 00:24:22.000000', 'consum', 0.0214, 'lps'),
	(446795, 123, '2015-03-15 00:24:23.000000', 'consum', 0.0223, 'lps'),
	(446796, 123, '2015-03-15 00:24:24.000000', 'consum', 0.0218, 'lps'),
	(446797, 123, '2015-03-15 00:24:25.000000', 'consum', 0.0212, 'lps'),
	(446798, 123, '2015-03-15 00:24:26.000000', 'consum', 0.0220, 'lps'),
	(446799, 123, '2015-03-15 00:24:27.000000', 'consum', 0.0229, 'lps'),
	(446800, 123, '2015-03-15 00:24:28.000000', 'consum', 0.0226, 'lps'),
	(446801, 123, '2015-03-15 00:24:29.000000', 'consum', 0.0212, 'lps'),
	(446802, 123, '2015-03-15 00:24:30.000000', 'consum', 0.0220, 'lps'),
	(446803, 123, '2015-03-15 00:24:31.000000', 'consum', 0.0230, 'lps'),
	(446804, 123, '2015-03-15 00:24:32.000000', 'consum', 0.0210, 'lps'),
	(446805, 123, '2015-03-15 00:24:33.000000', 'consum', 0.0222, 'lps'),
	(446806, 123, '2015-03-15 00:24:34.000000', 'consum', 0.0224, 'lps'),
	(446807, 123, '2015-03-15 00:24:35.000000', 'consum', 0.0219, 'lps'),
	(446808, 123, '2015-03-15 00:24:36.000000', 'consum', 0.0213, 'lps'),
	(446809, 123, '2015-03-15 00:24:37.000000', 'consum', 0.0225, 'lps'),
	(446810, 123, '2015-03-15 00:24:38.000000', 'consum', 0.0225, 'lps'),
	(446811, 123, '2015-03-15 00:24:39.000000', 'consum', 0.0219, 'lps'),
	(446812, 123, '2015-03-15 00:24:40.000000', 'consum', 0.0233, 'lps'),
	(446813, 123, '2015-03-15 00:24:41.000000', 'consum', 0.0228, 'lps'),
	(446814, 123, '2015-03-15 00:24:42.000000', 'consum', 0.0232, 'lps'),
	(446815, 123, '2015-03-15 00:24:43.000000', 'consum', 0.0219, 'lps'),
	(446816, 123, '2015-03-15 00:24:44.000000', 'consum', 0.0214, 'lps'),
	(446817, 123, '2015-03-15 00:24:45.000000', 'consum', 0.0226, 'lps'),
	(446818, 123, '2015-03-15 00:24:46.000000', 'consum', 0.0229, 'lps'),
	(446819, 123, '2015-03-15 00:24:47.000000', 'consum', 0.0210, 'lps'),
	(446820, 123, '2015-03-15 00:24:48.000000', 'consum', 0.0228, 'lps'),
	(446821, 123, '2015-03-15 00:24:49.000000', 'consum', 0.0225, 'lps'),
	(446822, 123, '2015-03-15 00:24:50.000000', 'consum', 0.0233, 'lps'),
	(446823, 123, '2015-03-15 00:24:51.000000', 'consum', 0.0233, 'lps'),
	(446824, 123, '2015-03-15 00:24:52.000000', 'consum', 0.0210, 'lps'),
	(446825, 123, '2015-03-15 00:24:53.000000', 'consum', 0.0211, 'lps'),
	(446826, 123, '2015-03-15 00:24:54.000000', 'consum', 0.0216, 'lps'),
	(446827, 123, '2015-03-15 00:24:55.000000', 'consum', 0.0214, 'lps'),
	(446828, 123, '2015-03-15 00:24:56.000000', 'consum', 0.0211, 'lps'),
	(446829, 123, '2015-03-15 00:24:57.000000', 'consum', 0.0230, 'lps'),
	(446830, 123, '2015-03-15 00:24:58.000000', 'consum', 0.0210, 'lps'),
	(446831, 123, '2015-03-15 00:24:59.000000', 'consum', 0.0225, 'lps'),
	(446832, 123, '2015-03-15 00:25:00.000000', 'consum', 0.0210, 'lps'),
	(446833, 123, '2015-03-15 00:25:01.000000', 'consum', 0.0215, 'lps'),
	(446834, 123, '2015-03-15 00:25:02.000000', 'consum', 0.0210, 'lps'),
	(446835, 123, '2015-03-15 00:25:03.000000', 'consum', 0.0220, 'lps'),
	(446836, 123, '2015-03-15 00:25:04.000000', 'consum', 0.0211, 'lps'),
	(446837, 123, '2015-03-15 00:25:05.000000', 'consum', 0.0212, 'lps'),
	(446838, 123, '2015-03-15 00:25:06.000000', 'consum', 0.0219, 'lps'),
	(446839, 123, '2015-03-15 00:25:07.000000', 'consum', 0.0223, 'lps'),
	(446840, 123, '2015-03-15 00:25:08.000000', 'consum', 0.0224, 'lps'),
	(446841, 123, '2015-03-15 00:25:09.000000', 'consum', 0.0217, 'lps'),
	(446842, 123, '2015-03-15 00:25:10.000000', 'consum', 0.0229, 'lps'),
	(446843, 123, '2015-03-15 00:25:11.000000', 'consum', 0.0210, 'lps'),
	(446844, 123, '2015-03-15 00:25:12.000000', 'consum', 0.0227, 'lps'),
	(446845, 123, '2015-03-15 00:25:13.000000', 'consum', 0.0224, 'lps'),
	(446846, 123, '2015-03-15 00:25:14.000000', 'consum', 0.0230, 'lps'),
	(446847, 123, '2015-03-15 00:25:15.000000', 'consum', 0.0218, 'lps'),
	(446848, 123, '2015-03-15 00:25:16.000000', 'consum', 0.0217, 'lps'),
	(446849, 123, '2015-03-15 00:25:17.000000', 'consum', 0.0221, 'lps'),
	(446850, 123, '2015-03-15 00:25:18.000000', 'consum', 0.0221, 'lps'),
	(446851, 123, '2015-03-15 00:25:19.000000', 'consum', 0.0231, 'lps'),
	(446852, 123, '2015-03-15 00:25:20.000000', 'consum', 0.0211, 'lps'),
	(446853, 123, '2015-03-15 00:25:21.000000', 'consum', 0.0226, 'lps'),
	(446854, 123, '2015-03-15 00:25:22.000000', 'consum', 0.0213, 'lps'),
	(446855, 123, '2015-03-15 00:25:23.000000', 'consum', 0.0225, 'lps'),
	(446856, 123, '2015-03-15 00:25:24.000000', 'consum', 0.0230, 'lps'),
	(446857, 123, '2015-03-15 00:25:25.000000', 'consum', 0.0219, 'lps'),
	(446858, 123, '2015-03-15 00:25:26.000000', 'consum', 0.0216, 'lps'),
	(446859, 123, '2015-03-15 00:25:27.000000', 'consum', 0.0216, 'lps'),
	(446860, 123, '2015-03-15 00:25:28.000000', 'consum', 0.0220, 'lps'),
	(446861, 123, '2015-03-15 00:25:29.000000', 'consum', 0.0221, 'lps'),
	(446862, 123, '2015-03-15 00:25:30.000000', 'consum', 0.0212, 'lps'),
	(446863, 123, '2015-03-15 00:25:31.000000', 'consum', 0.0233, 'lps'),
	(446864, 123, '2015-03-15 00:25:32.000000', 'consum', 0.0225, 'lps'),
	(446865, 123, '2015-03-15 00:25:33.000000', 'consum', 0.0217, 'lps'),
	(446866, 123, '2015-03-15 00:25:34.000000', 'consum', 0.0225, 'lps'),
	(446867, 123, '2015-03-15 00:25:35.000000', 'consum', 0.0217, 'lps'),
	(446868, 123, '2015-03-15 00:25:36.000000', 'consum', 0.0226, 'lps'),
	(446869, 123, '2015-03-15 00:25:37.000000', 'consum', 0.0218, 'lps'),
	(446870, 123, '2015-03-15 00:25:38.000000', 'consum', 0.0227, 'lps'),
	(446871, 123, '2015-03-15 00:25:39.000000', 'consum', 0.0223, 'lps'),
	(446872, 123, '2015-03-15 00:25:40.000000', 'consum', 0.0226, 'lps'),
	(446873, 123, '2015-03-15 00:25:41.000000', 'consum', 0.0225, 'lps'),
	(446874, 123, '2015-03-15 00:25:42.000000', 'consum', 0.0216, 'lps'),
	(446875, 123, '2015-03-15 00:25:43.000000', 'consum', 0.0218, 'lps'),
	(446876, 123, '2015-03-15 00:25:44.000000', 'consum', 0.0231, 'lps'),
	(446877, 123, '2015-03-15 00:25:45.000000', 'consum', 0.0221, 'lps'),
	(446878, 123, '2015-03-15 00:25:46.000000', 'consum', 0.0226, 'lps'),
	(446879, 123, '2015-03-15 00:25:47.000000', 'consum', 0.0211, 'lps'),
	(446880, 123, '2015-03-15 00:25:48.000000', 'consum', 0.0214, 'lps'),
	(446881, 123, '2015-03-15 00:25:49.000000', 'consum', 0.0227, 'lps'),
	(446882, 123, '2015-03-15 00:25:50.000000', 'consum', 0.0213, 'lps'),
	(446883, 123, '2015-03-15 00:25:51.000000', 'consum', 0.0220, 'lps'),
	(446884, 123, '2015-03-15 00:25:52.000000', 'consum', 0.0230, 'lps'),
	(446885, 123, '2015-03-15 00:25:53.000000', 'consum', 0.0233, 'lps'),
	(446886, 123, '2015-03-15 00:25:54.000000', 'consum', 0.0215, 'lps'),
	(446887, 123, '2015-03-15 00:25:55.000000', 'consum', 0.0215, 'lps'),
	(446888, 123, '2015-03-15 00:25:56.000000', 'consum', 0.0219, 'lps'),
	(446889, 123, '2015-03-15 00:25:57.000000', 'consum', 0.0217, 'lps'),
	(446890, 123, '2015-03-15 00:25:58.000000', 'consum', 0.0220, 'lps'),
	(446891, 123, '2015-03-15 00:25:59.000000', 'consum', 0.0217, 'lps'),
	(446892, 123, '2015-03-15 00:26:00.000000', 'consum', 0.0212, 'lps'),
	(446893, 123, '2015-03-15 00:26:01.000000', 'consum', 0.0227, 'lps'),
	(446894, 123, '2015-03-15 00:26:02.000000', 'consum', 0.0216, 'lps'),
	(446895, 123, '2015-03-15 00:26:03.000000', 'consum', 0.0214, 'lps'),
	(446896, 123, '2015-03-15 00:26:04.000000', 'consum', 0.0212, 'lps'),
	(446897, 123, '2015-03-15 00:26:05.000000', 'consum', 0.0210, 'lps'),
	(446898, 123, '2015-03-15 00:26:06.000000', 'consum', 0.0226, 'lps'),
	(446899, 123, '2015-03-15 00:26:07.000000', 'consum', 0.0217, 'lps'),
	(446900, 123, '2015-03-15 00:26:08.000000', 'consum', 0.0225, 'lps'),
	(446901, 123, '2015-03-15 00:26:09.000000', 'consum', 0.0216, 'lps'),
	(446902, 123, '2015-03-15 00:26:10.000000', 'consum', 0.0220, 'lps'),
	(446903, 123, '2015-03-15 00:26:11.000000', 'consum', 0.0219, 'lps'),
	(446904, 123, '2015-03-15 00:26:12.000000', 'consum', 0.0223, 'lps'),
	(446905, 123, '2015-03-15 00:26:13.000000', 'consum', 0.0225, 'lps'),
	(446906, 123, '2015-03-15 00:26:14.000000', 'consum', 0.0223, 'lps'),
	(446907, 123, '2015-03-15 00:26:15.000000', 'consum', 0.0229, 'lps'),
	(446908, 123, '2015-03-15 00:26:16.000000', 'consum', 0.0219, 'lps'),
	(446909, 123, '2015-03-15 00:26:17.000000', 'consum', 0.0224, 'lps'),
	(446910, 123, '2015-03-15 00:26:18.000000', 'consum', 0.0228, 'lps'),
	(446911, 123, '2015-03-15 00:26:19.000000', 'consum', 0.0212, 'lps'),
	(446912, 123, '2015-03-15 00:26:20.000000', 'consum', 0.0214, 'lps'),
	(446913, 123, '2015-03-15 00:26:21.000000', 'consum', 0.0223, 'lps'),
	(446914, 123, '2015-03-15 00:26:22.000000', 'consum', 0.0218, 'lps'),
	(446915, 123, '2015-03-15 00:26:23.000000', 'consum', 0.0210, 'lps'),
	(446916, 123, '2015-03-15 00:26:24.000000', 'consum', 0.0212, 'lps'),
	(446917, 123, '2015-03-15 00:26:25.000000', 'consum', 0.0218, 'lps'),
	(446918, 123, '2015-03-15 00:26:26.000000', 'consum', 0.0224, 'lps'),
	(446919, 123, '2015-03-15 00:26:27.000000', 'consum', 0.0229, 'lps'),
	(446920, 123, '2015-03-15 00:26:28.000000', 'consum', 0.0218, 'lps'),
	(446921, 123, '2015-03-15 00:26:29.000000', 'consum', 0.0218, 'lps'),
	(446922, 123, '2015-03-15 00:26:30.000000', 'consum', 0.0224, 'lps'),
	(446923, 123, '2015-03-15 00:26:31.000000', 'consum', 0.0233, 'lps'),
	(446924, 123, '2015-03-15 00:26:32.000000', 'consum', 0.0212, 'lps'),
	(446925, 123, '2015-03-15 00:26:33.000000', 'consum', 0.0223, 'lps'),
	(446926, 123, '2015-03-15 00:26:34.000000', 'consum', 0.0221, 'lps'),
	(446927, 123, '2015-03-15 00:26:35.000000', 'consum', 0.0229, 'lps'),
	(446928, 123, '2015-03-15 00:26:36.000000', 'consum', 0.0223, 'lps'),
	(446929, 123, '2015-03-15 00:26:37.000000', 'consum', 0.0220, 'lps'),
	(446930, 123, '2015-03-15 00:26:38.000000', 'consum', 0.0219, 'lps'),
	(446931, 123, '2015-03-15 00:26:39.000000', 'consum', 0.0227, 'lps'),
	(446932, 123, '2015-03-15 00:26:40.000000', 'consum', 0.0220, 'lps'),
	(446933, 123, '2015-03-15 00:26:41.000000', 'consum', 0.0211, 'lps'),
	(446934, 123, '2015-03-15 00:26:42.000000', 'consum', 0.0210, 'lps'),
	(446935, 123, '2015-03-15 00:26:43.000000', 'consum', 0.0229, 'lps'),
	(446936, 123, '2015-03-15 00:26:44.000000', 'consum', 0.0211, 'lps'),
	(446937, 123, '2015-03-15 00:26:45.000000', 'consum', 0.0232, 'lps'),
	(446938, 123, '2015-03-15 00:26:46.000000', 'consum', 0.0219, 'lps'),
	(446939, 123, '2015-03-15 00:26:47.000000', 'consum', 0.0214, 'lps'),
	(446940, 123, '2015-03-15 00:26:48.000000', 'consum', 0.0226, 'lps'),
	(446941, 123, '2015-03-15 00:26:49.000000', 'consum', 0.0230, 'lps'),
	(446942, 123, '2015-03-15 00:26:50.000000', 'consum', 0.0217, 'lps'),
	(446943, 123, '2015-03-15 00:26:51.000000', 'consum', 0.0232, 'lps'),
	(446944, 123, '2015-03-15 00:26:52.000000', 'consum', 0.0228, 'lps'),
	(446945, 123, '2015-03-15 00:26:53.000000', 'consum', 0.0212, 'lps'),
	(446946, 123, '2015-03-15 00:26:54.000000', 'consum', 0.0214, 'lps'),
	(446947, 123, '2015-03-15 00:26:55.000000', 'consum', 0.0225, 'lps'),
	(446948, 123, '2015-03-15 00:26:56.000000', 'consum', 0.0226, 'lps'),
	(446949, 123, '2015-03-15 00:26:57.000000', 'consum', 0.0222, 'lps'),
	(446950, 123, '2015-03-15 00:26:58.000000', 'consum', 0.0223, 'lps'),
	(446951, 123, '2015-03-15 00:26:59.000000', 'consum', 0.0213, 'lps'),
	(446952, 123, '2015-03-15 00:27:00.000000', 'consum', 0.0212, 'lps'),
	(446953, 123, '2015-03-15 00:27:01.000000', 'consum', 0.0213, 'lps'),
	(446954, 123, '2015-03-15 00:27:02.000000', 'consum', 0.0218, 'lps'),
	(446955, 123, '2015-03-15 00:27:03.000000', 'consum', 0.0216, 'lps'),
	(446956, 123, '2015-03-15 00:27:04.000000', 'consum', 0.0219, 'lps'),
	(446957, 123, '2015-03-15 00:27:05.000000', 'consum', 0.0212, 'lps'),
	(446958, 123, '2015-03-15 00:27:06.000000', 'consum', 0.0219, 'lps'),
	(446959, 123, '2015-03-15 00:27:07.000000', 'consum', 0.0225, 'lps'),
	(446960, 123, '2015-03-15 00:27:08.000000', 'consum', 0.0233, 'lps'),
	(446961, 123, '2015-03-15 00:27:09.000000', 'consum', 0.0211, 'lps'),
	(446962, 123, '2015-03-15 00:27:10.000000', 'consum', 0.0217, 'lps'),
	(446963, 123, '2015-03-15 00:27:11.000000', 'consum', 0.0220, 'lps'),
	(446964, 123, '2015-03-15 00:27:12.000000', 'consum', 0.0213, 'lps'),
	(446965, 123, '2015-03-15 00:27:13.000000', 'consum', 0.0219, 'lps'),
	(446966, 123, '2015-03-15 00:27:14.000000', 'consum', 0.0225, 'lps'),
	(446967, 123, '2015-03-15 00:27:15.000000', 'consum', 0.0210, 'lps'),
	(446968, 123, '2015-03-15 00:27:16.000000', 'consum', 0.0215, 'lps'),
	(446969, 123, '2015-03-15 00:27:17.000000', 'consum', 0.0210, 'lps'),
	(446970, 123, '2015-03-15 00:27:18.000000', 'consum', 0.0218, 'lps'),
	(446971, 123, '2015-03-15 00:27:19.000000', 'consum', 0.0227, 'lps'),
	(446972, 123, '2015-03-15 00:27:20.000000', 'consum', 0.0224, 'lps'),
	(446973, 123, '2015-03-15 00:27:21.000000', 'consum', 0.0229, 'lps'),
	(446974, 123, '2015-03-15 00:27:22.000000', 'consum', 0.0218, 'lps'),
	(446975, 123, '2015-03-15 00:27:23.000000', 'consum', 0.0215, 'lps'),
	(446976, 123, '2015-03-15 00:27:24.000000', 'consum', 0.0214, 'lps'),
	(446977, 123, '2015-03-15 00:27:25.000000', 'consum', 0.0214, 'lps'),
	(446978, 123, '2015-03-15 00:27:26.000000', 'consum', 0.0217, 'lps'),
	(446979, 123, '2015-03-15 00:27:27.000000', 'consum', 0.0233, 'lps'),
	(446980, 123, '2015-03-15 00:27:28.000000', 'consum', 0.0211, 'lps'),
	(446981, 123, '2015-03-15 00:27:29.000000', 'consum', 0.0218, 'lps'),
	(446982, 123, '2015-03-15 00:27:30.000000', 'consum', 0.0222, 'lps'),
	(446983, 123, '2015-03-15 00:27:31.000000', 'consum', 0.0225, 'lps'),
	(446984, 123, '2015-03-15 00:27:32.000000', 'consum', 0.0224, 'lps'),
	(446985, 123, '2015-03-15 00:27:33.000000', 'consum', 0.0214, 'lps'),
	(446986, 123, '2015-03-15 00:27:34.000000', 'consum', 0.0210, 'lps'),
	(446987, 123, '2015-03-15 00:27:35.000000', 'consum', 0.0223, 'lps'),
	(446988, 123, '2015-03-15 00:27:36.000000', 'consum', 0.0229, 'lps'),
	(446989, 123, '2015-03-15 00:27:37.000000', 'consum', 0.0217, 'lps'),
	(446990, 123, '2015-03-15 00:27:38.000000', 'consum', 0.0214, 'lps'),
	(446991, 123, '2015-03-15 00:27:39.000000', 'consum', 0.0210, 'lps'),
	(446992, 123, '2015-03-15 00:27:40.000000', 'consum', 0.0220, 'lps'),
	(446993, 123, '2015-03-15 00:27:41.000000', 'consum', 0.0212, 'lps'),
	(446994, 123, '2015-03-15 00:27:42.000000', 'consum', 0.0214, 'lps'),
	(446995, 123, '2015-03-15 00:27:43.000000', 'consum', 0.0225, 'lps'),
	(446996, 123, '2015-03-15 00:27:44.000000', 'consum', 0.0227, 'lps'),
	(446997, 123, '2015-03-15 00:27:45.000000', 'consum', 0.0224, 'lps'),
	(446998, 123, '2015-03-15 00:27:46.000000', 'consum', 0.0229, 'lps'),
	(446999, 123, '2015-03-15 00:27:47.000000', 'consum', 0.0217, 'lps'),
	(447000, 123, '2015-03-15 00:27:48.000000', 'consum', 0.0213, 'lps'),
	(447001, 123, '2015-03-15 00:27:49.000000', 'consum', 0.0228, 'lps'),
	(447002, 123, '2015-03-15 00:27:50.000000', 'consum', 0.0219, 'lps'),
	(447003, 123, '2015-03-15 00:27:51.000000', 'consum', 0.0227, 'lps'),
	(447004, 123, '2015-03-15 00:27:52.000000', 'consum', 0.0220, 'lps'),
	(447005, 123, '2015-03-15 00:27:53.000000', 'consum', 0.0210, 'lps'),
	(447006, 123, '2015-03-15 00:27:54.000000', 'consum', 0.0230, 'lps'),
	(447007, 123, '2015-03-15 00:27:55.000000', 'consum', 0.0213, 'lps'),
	(447008, 123, '2015-03-15 00:27:56.000000', 'consum', 0.0214, 'lps'),
	(447009, 123, '2015-03-15 00:27:57.000000', 'consum', 0.0221, 'lps'),
	(447010, 123, '2015-03-15 00:27:58.000000', 'consum', 0.0231, 'lps'),
	(447011, 123, '2015-03-15 00:27:59.000000', 'consum', 0.0233, 'lps'),
	(447012, 123, '2015-03-15 00:28:00.000000', 'consum', 0.0213, 'lps'),
	(447013, 123, '2015-03-15 00:28:01.000000', 'consum', 0.0229, 'lps'),
	(447014, 123, '2015-03-15 00:28:02.000000', 'consum', 0.0224, 'lps'),
	(447015, 123, '2015-03-15 00:28:03.000000', 'consum', 0.0226, 'lps'),
	(447016, 123, '2015-03-15 00:28:04.000000', 'consum', 0.0223, 'lps'),
	(447017, 123, '2015-03-15 00:28:05.000000', 'consum', 0.0226, 'lps'),
	(447018, 123, '2015-03-15 00:28:06.000000', 'consum', 0.0228, 'lps'),
	(447019, 123, '2015-03-15 00:28:07.000000', 'consum', 0.0229, 'lps'),
	(447020, 123, '2015-03-15 00:28:08.000000', 'consum', 0.0227, 'lps'),
	(447021, 123, '2015-03-15 00:28:09.000000', 'consum', 0.0215, 'lps'),
	(447022, 123, '2015-03-15 00:28:10.000000', 'consum', 0.0232, 'lps'),
	(447023, 123, '2015-03-15 00:28:11.000000', 'consum', 0.0211, 'lps'),
	(447024, 123, '2015-03-15 00:28:12.000000', 'consum', 0.0219, 'lps'),
	(447025, 123, '2015-03-15 00:28:13.000000', 'consum', 0.0228, 'lps'),
	(447026, 123, '2015-03-15 00:28:14.000000', 'consum', 0.0225, 'lps'),
	(447027, 123, '2015-03-15 00:28:15.000000', 'consum', 0.0233, 'lps'),
	(447028, 123, '2015-03-15 00:28:16.000000', 'consum', 0.0230, 'lps'),
	(447029, 123, '2015-03-15 00:28:17.000000', 'consum', 0.0221, 'lps'),
	(447030, 123, '2015-03-15 00:28:18.000000', 'consum', 0.0226, 'lps'),
	(447031, 123, '2015-03-15 00:28:19.000000', 'consum', 0.0212, 'lps'),
	(447032, 123, '2015-03-15 00:28:20.000000', 'consum', 0.0220, 'lps'),
	(447033, 123, '2015-03-15 00:28:21.000000', 'consum', 0.0230, 'lps'),
	(447034, 123, '2015-03-15 00:28:22.000000', 'consum', 0.0232, 'lps'),
	(447035, 123, '2015-03-15 00:28:23.000000', 'consum', 0.0214, 'lps'),
	(447036, 123, '2015-03-15 00:28:24.000000', 'consum', 0.0213, 'lps'),
	(447037, 123, '2015-03-15 00:28:25.000000', 'consum', 0.0213, 'lps'),
	(447038, 123, '2015-03-15 00:28:26.000000', 'consum', 0.0216, 'lps'),
	(447039, 123, '2015-03-15 00:28:27.000000', 'consum', 0.0231, 'lps'),
	(447040, 123, '2015-03-15 00:28:28.000000', 'consum', 0.0224, 'lps'),
	(447041, 123, '2015-03-15 00:28:29.000000', 'consum', 0.0218, 'lps'),
	(447042, 123, '2015-03-15 00:28:30.000000', 'consum', 0.0211, 'lps'),
	(447043, 123, '2015-03-15 00:28:31.000000', 'consum', 0.0213, 'lps'),
	(447044, 123, '2015-03-15 00:28:32.000000', 'consum', 0.0222, 'lps'),
	(447045, 123, '2015-03-15 00:28:33.000000', 'consum', 0.0215, 'lps'),
	(447046, 123, '2015-03-15 00:28:34.000000', 'consum', 0.0225, 'lps'),
	(447047, 123, '2015-03-15 00:28:35.000000', 'consum', 0.0222, 'lps'),
	(447048, 123, '2015-03-15 00:28:36.000000', 'consum', 0.0223, 'lps'),
	(447049, 123, '2015-03-15 00:28:37.000000', 'consum', 0.0217, 'lps'),
	(447050, 123, '2015-03-15 00:28:38.000000', 'consum', 0.0232, 'lps'),
	(447051, 123, '2015-03-15 00:28:39.000000', 'consum', 0.0225, 'lps'),
	(447052, 123, '2015-03-15 00:28:40.000000', 'consum', 0.0219, 'lps'),
	(447053, 123, '2015-03-15 00:28:41.000000', 'consum', 0.0211, 'lps'),
	(447054, 123, '2015-03-15 00:28:42.000000', 'consum', 0.0214, 'lps'),
	(447055, 123, '2015-03-15 00:28:43.000000', 'consum', 0.0226, 'lps'),
	(447056, 123, '2015-03-15 00:28:44.000000', 'consum', 0.0231, 'lps'),
	(447057, 123, '2015-03-15 00:28:45.000000', 'consum', 0.0219, 'lps'),
	(447058, 123, '2015-03-15 00:28:46.000000', 'consum', 0.0215, 'lps'),
	(447059, 123, '2015-03-15 00:28:47.000000', 'consum', 0.0233, 'lps'),
	(447060, 123, '2015-03-15 00:28:48.000000', 'consum', 0.0216, 'lps'),
	(447061, 123, '2015-03-15 00:28:49.000000', 'consum', 0.0219, 'lps'),
	(447062, 123, '2015-03-15 00:28:50.000000', 'consum', 0.0216, 'lps'),
	(447063, 123, '2015-03-15 00:28:51.000000', 'consum', 0.0210, 'lps'),
	(447064, 123, '2015-03-15 00:28:52.000000', 'consum', 0.0216, 'lps'),
	(447065, 123, '2015-03-15 00:28:53.000000', 'consum', 0.0218, 'lps'),
	(447066, 123, '2015-03-15 00:28:54.000000', 'consum', 0.0210, 'lps'),
	(447067, 123, '2015-03-15 00:28:55.000000', 'consum', 0.0233, 'lps'),
	(447068, 123, '2015-03-15 00:28:56.000000', 'consum', 0.0230, 'lps'),
	(447069, 123, '2015-03-15 00:28:57.000000', 'consum', 0.0217, 'lps'),
	(447070, 123, '2015-03-15 00:28:58.000000', 'consum', 0.0210, 'lps'),
	(447071, 123, '2015-03-15 00:28:59.000000', 'consum', 0.0212, 'lps'),
	(447072, 123, '2015-03-15 00:29:00.000000', 'consum', 0.0221, 'lps'),
	(447073, 123, '2015-03-15 00:29:01.000000', 'consum', 0.0212, 'lps'),
	(447074, 123, '2015-03-15 00:29:02.000000', 'consum', 0.0212, 'lps'),
	(447075, 123, '2015-03-15 00:29:03.000000', 'consum', 0.0215, 'lps'),
	(447076, 123, '2015-03-15 00:29:04.000000', 'consum', 0.0231, 'lps'),
	(447077, 123, '2015-03-15 00:29:05.000000', 'consum', 0.0226, 'lps'),
	(447078, 123, '2015-03-15 00:29:06.000000', 'consum', 0.0229, 'lps'),
	(447079, 123, '2015-03-15 00:29:07.000000', 'consum', 0.0210, 'lps'),
	(447080, 123, '2015-03-15 00:29:08.000000', 'consum', 0.0224, 'lps'),
	(447081, 123, '2015-03-15 00:29:09.000000', 'consum', 0.0210, 'lps'),
	(447082, 123, '2015-03-15 00:29:10.000000', 'consum', 0.0215, 'lps'),
	(447083, 123, '2015-03-15 00:29:11.000000', 'consum', 0.0214, 'lps'),
	(447084, 123, '2015-03-15 00:29:12.000000', 'consum', 0.0214, 'lps'),
	(447085, 123, '2015-03-15 00:29:13.000000', 'consum', 0.0220, 'lps'),
	(447086, 123, '2015-03-15 00:29:14.000000', 'consum', 0.0224, 'lps'),
	(447087, 123, '2015-03-15 00:29:15.000000', 'consum', 0.0226, 'lps'),
	(447088, 123, '2015-03-15 00:29:16.000000', 'consum', 0.0224, 'lps'),
	(447089, 123, '2015-03-15 00:29:17.000000', 'consum', 0.0231, 'lps'),
	(447090, 123, '2015-03-15 00:29:18.000000', 'consum', 0.0226, 'lps'),
	(447091, 123, '2015-03-15 00:29:19.000000', 'consum', 0.0230, 'lps'),
	(447092, 123, '2015-03-15 00:29:20.000000', 'consum', 0.0214, 'lps'),
	(447093, 123, '2015-03-15 00:29:21.000000', 'consum', 0.0218, 'lps'),
	(447094, 123, '2015-03-15 00:29:22.000000', 'consum', 0.0213, 'lps'),
	(447095, 123, '2015-03-15 00:29:23.000000', 'consum', 0.0226, 'lps'),
	(447096, 123, '2015-03-15 00:29:24.000000', 'consum', 0.0211, 'lps'),
	(447097, 123, '2015-03-15 00:29:25.000000', 'consum', 0.0216, 'lps'),
	(447098, 123, '2015-03-15 00:29:26.000000', 'consum', 0.0211, 'lps'),
	(447099, 123, '2015-03-15 00:29:27.000000', 'consum', 0.0221, 'lps'),
	(447100, 123, '2015-03-15 00:29:28.000000', 'consum', 0.0217, 'lps'),
	(447101, 123, '2015-03-15 00:29:29.000000', 'consum', 0.0212, 'lps'),
	(447102, 123, '2015-03-15 00:29:30.000000', 'consum', 0.0222, 'lps'),
	(447103, 123, '2015-03-15 00:29:31.000000', 'consum', 0.0219, 'lps'),
	(447104, 123, '2015-03-15 00:29:32.000000', 'consum', 0.0217, 'lps'),
	(447105, 123, '2015-03-15 00:29:33.000000', 'consum', 0.0221, 'lps'),
	(447106, 123, '2015-03-15 00:29:34.000000', 'consum', 0.0220, 'lps'),
	(447107, 123, '2015-03-15 00:29:35.000000', 'consum', 0.0227, 'lps'),
	(447108, 123, '2015-03-15 00:29:36.000000', 'consum', 0.0218, 'lps'),
	(447109, 123, '2015-03-15 00:29:37.000000', 'consum', 0.0224, 'lps'),
	(447110, 123, '2015-03-15 00:29:38.000000', 'consum', 0.0231, 'lps'),
	(447111, 123, '2015-03-15 00:29:39.000000', 'consum', 0.0226, 'lps'),
	(447112, 123, '2015-03-15 00:29:40.000000', 'consum', 0.0226, 'lps'),
	(447113, 123, '2015-03-15 00:29:41.000000', 'consum', 0.0221, 'lps'),
	(447114, 123, '2015-03-15 00:29:42.000000', 'consum', 0.0218, 'lps'),
	(447115, 123, '2015-03-15 00:29:43.000000', 'consum', 0.0217, 'lps'),
	(447116, 123, '2015-03-15 00:29:44.000000', 'consum', 0.0220, 'lps'),
	(447117, 123, '2015-03-15 00:29:45.000000', 'consum', 0.0218, 'lps'),
	(447118, 123, '2015-03-15 00:29:46.000000', 'consum', 0.0219, 'lps'),
	(447119, 123, '2015-03-15 00:29:47.000000', 'consum', 0.0232, 'lps'),
	(447120, 123, '2015-03-15 00:29:48.000000', 'consum', 0.0221, 'lps'),
	(447121, 123, '2015-03-15 00:29:49.000000', 'consum', 0.0223, 'lps'),
	(447122, 123, '2015-03-15 00:29:50.000000', 'consum', 0.0218, 'lps'),
	(447123, 123, '2015-03-15 00:29:51.000000', 'consum', 0.0212, 'lps'),
	(447124, 123, '2015-03-15 00:29:52.000000', 'consum', 0.0220, 'lps'),
	(447125, 123, '2015-03-15 00:29:53.000000', 'consum', 0.0230, 'lps'),
	(447126, 123, '2015-03-15 00:29:54.000000', 'consum', 0.0233, 'lps'),
	(447127, 123, '2015-03-15 00:29:55.000000', 'consum', 0.0217, 'lps'),
	(447128, 123, '2015-03-15 00:29:56.000000', 'consum', 0.0226, 'lps'),
	(447129, 123, '2015-03-15 00:29:57.000000', 'consum', 0.0222, 'lps'),
	(447130, 123, '2015-03-15 00:29:58.000000', 'consum', 0.0222, 'lps'),
	(447131, 123, '2015-03-15 00:29:59.000000', 'consum', 0.0210, 'lps'),
	(447132, 123, '2015-03-15 00:30:00.000000', 'consum', 0.0221, 'lps'),
	(447133, 123, '2015-03-15 00:30:01.000000', 'consum', 0.0220, 'lps'),
	(447134, 123, '2015-03-15 00:30:02.000000', 'consum', 0.0228, 'lps'),
	(447135, 123, '2015-03-15 00:30:03.000000', 'consum', 0.0221, 'lps'),
	(447136, 123, '2015-03-15 00:30:04.000000', 'consum', 0.0214, 'lps'),
	(447137, 123, '2015-03-15 00:30:05.000000', 'consum', 0.0219, 'lps'),
	(447138, 123, '2015-03-15 00:30:06.000000', 'consum', 0.0219, 'lps'),
	(447139, 123, '2015-03-15 00:30:07.000000', 'consum', 0.0228, 'lps'),
	(447140, 123, '2015-03-15 00:30:08.000000', 'consum', 0.0228, 'lps'),
	(447141, 123, '2015-03-15 00:30:09.000000', 'consum', 0.0220, 'lps'),
	(447142, 123, '2015-03-15 00:30:10.000000', 'consum', 0.0232, 'lps'),
	(447143, 123, '2015-03-15 00:30:11.000000', 'consum', 0.0220, 'lps'),
	(447144, 123, '2015-03-15 00:30:12.000000', 'consum', 0.0218, 'lps'),
	(447145, 123, '2015-03-15 00:30:13.000000', 'consum', 0.0220, 'lps'),
	(447146, 123, '2015-03-15 00:30:14.000000', 'consum', 0.0212, 'lps'),
	(447147, 123, '2015-03-15 00:30:15.000000', 'consum', 0.0216, 'lps'),
	(447148, 123, '2015-03-15 00:30:16.000000', 'consum', 0.0233, 'lps'),
	(447149, 123, '2015-03-15 00:30:17.000000', 'consum', 0.0212, 'lps'),
	(447150, 123, '2015-03-15 00:30:18.000000', 'consum', 0.0222, 'lps'),
	(447151, 123, '2015-03-15 00:30:19.000000', 'consum', 0.0220, 'lps'),
	(447152, 123, '2015-03-15 00:30:20.000000', 'consum', 0.0221, 'lps'),
	(447153, 123, '2015-03-15 00:30:21.000000', 'consum', 0.0213, 'lps'),
	(447154, 123, '2015-03-15 00:30:22.000000', 'consum', 0.0216, 'lps'),
	(447155, 123, '2015-03-15 00:30:23.000000', 'consum', 0.0230, 'lps'),
	(447156, 123, '2015-03-15 00:30:24.000000', 'consum', 0.0222, 'lps'),
	(447157, 123, '2015-03-15 00:30:25.000000', 'consum', 0.0212, 'lps'),
	(447158, 123, '2015-03-15 00:30:26.000000', 'consum', 0.0229, 'lps'),
	(447159, 123, '2015-03-15 00:30:27.000000', 'consum', 0.0230, 'lps'),
	(447160, 123, '2015-03-15 00:30:28.000000', 'consum', 0.0229, 'lps'),
	(447161, 123, '2015-03-15 00:30:29.000000', 'consum', 0.0223, 'lps'),
	(447162, 123, '2015-03-15 00:30:30.000000', 'consum', 0.0217, 'lps'),
	(447163, 123, '2015-03-15 00:30:31.000000', 'consum', 0.0231, 'lps'),
	(447164, 123, '2015-03-15 00:30:32.000000', 'consum', 0.0221, 'lps'),
	(447165, 123, '2015-03-15 00:30:33.000000', 'consum', 0.0229, 'lps'),
	(447166, 123, '2015-03-15 00:30:34.000000', 'consum', 0.0222, 'lps'),
	(447167, 123, '2015-03-15 00:30:35.000000', 'consum', 0.0213, 'lps'),
	(447168, 123, '2015-03-15 00:30:36.000000', 'consum', 0.0214, 'lps'),
	(447169, 123, '2015-03-15 00:30:37.000000', 'consum', 0.0222, 'lps'),
	(447170, 123, '2015-03-15 00:30:38.000000', 'consum', 0.0211, 'lps'),
	(447171, 123, '2015-03-15 00:30:39.000000', 'consum', 0.0226, 'lps'),
	(447172, 123, '2015-03-15 00:30:40.000000', 'consum', 0.0217, 'lps'),
	(447173, 123, '2015-03-15 00:30:41.000000', 'consum', 0.0220, 'lps'),
	(447174, 123, '2015-03-15 00:30:42.000000', 'consum', 0.0216, 'lps'),
	(447175, 123, '2015-03-15 00:30:43.000000', 'consum', 0.0211, 'lps'),
	(447176, 123, '2015-03-15 00:30:44.000000', 'consum', 0.0220, 'lps'),
	(447177, 123, '2015-03-15 00:30:45.000000', 'consum', 0.0210, 'lps'),
	(447178, 123, '2015-03-15 00:30:46.000000', 'consum', 0.0228, 'lps'),
	(447179, 123, '2015-03-15 00:30:47.000000', 'consum', 0.0228, 'lps'),
	(447180, 123, '2015-03-15 00:30:48.000000', 'consum', 0.0221, 'lps'),
	(447181, 123, '2015-03-15 00:30:49.000000', 'consum', 0.0215, 'lps'),
	(447182, 123, '2015-03-15 00:30:50.000000', 'consum', 0.0224, 'lps'),
	(447183, 123, '2015-03-15 00:30:51.000000', 'consum', 0.0220, 'lps'),
	(447184, 123, '2015-03-15 00:30:52.000000', 'consum', 0.0216, 'lps'),
	(447185, 123, '2015-03-15 00:30:53.000000', 'consum', 0.0212, 'lps'),
	(447186, 123, '2015-03-15 00:30:54.000000', 'consum', 0.0226, 'lps'),
	(447187, 123, '2015-03-15 00:30:55.000000', 'consum', 0.0212, 'lps'),
	(447188, 123, '2015-03-15 00:30:56.000000', 'consum', 0.0221, 'lps'),
	(447189, 123, '2015-03-15 00:30:57.000000', 'consum', 0.0213, 'lps'),
	(447190, 123, '2015-03-15 00:30:58.000000', 'consum', 0.0215, 'lps'),
	(447191, 123, '2015-03-15 00:30:59.000000', 'consum', 0.0229, 'lps'),
	(447192, 123, '2015-03-15 00:31:00.000000', 'consum', 0.0216, 'lps'),
	(447193, 123, '2015-03-15 00:31:01.000000', 'consum', 0.0230, 'lps'),
	(447194, 123, '2015-03-15 00:31:02.000000', 'consum', 0.0223, 'lps'),
	(447195, 123, '2015-03-15 00:31:03.000000', 'consum', 0.0213, 'lps'),
	(447196, 123, '2015-03-15 00:31:04.000000', 'consum', 0.0213, 'lps'),
	(447197, 123, '2015-03-15 00:31:05.000000', 'consum', 0.0215, 'lps'),
	(447198, 123, '2015-03-15 00:31:06.000000', 'consum', 0.0226, 'lps'),
	(447199, 123, '2015-03-15 00:31:07.000000', 'consum', 0.0229, 'lps'),
	(447200, 123, '2015-03-15 00:31:08.000000', 'consum', 0.0233, 'lps'),
	(447201, 123, '2015-03-15 00:31:09.000000', 'consum', 0.0220, 'lps'),
	(447202, 123, '2015-03-15 00:31:10.000000', 'consum', 0.0214, 'lps'),
	(447203, 123, '2015-03-15 00:31:11.000000', 'consum', 0.0227, 'lps'),
	(447204, 123, '2015-03-15 00:31:12.000000', 'consum', 0.0212, 'lps'),
	(447205, 123, '2015-03-15 00:31:13.000000', 'consum', 0.0216, 'lps'),
	(447206, 123, '2015-03-15 00:31:14.000000', 'consum', 0.0213, 'lps'),
	(447207, 123, '2015-03-15 00:31:15.000000', 'consum', 0.0230, 'lps'),
	(447208, 123, '2015-03-15 00:31:16.000000', 'consum', 0.0229, 'lps'),
	(447209, 123, '2015-03-15 00:31:17.000000', 'consum', 0.0222, 'lps'),
	(447210, 123, '2015-03-15 00:31:18.000000', 'consum', 0.0212, 'lps'),
	(447211, 123, '2015-03-15 00:31:19.000000', 'consum', 0.0233, 'lps'),
	(447212, 123, '2015-03-15 00:31:20.000000', 'consum', 0.0225, 'lps'),
	(447213, 123, '2015-03-15 00:31:21.000000', 'consum', 0.0215, 'lps'),
	(447214, 123, '2015-03-15 00:31:22.000000', 'consum', 0.0215, 'lps'),
	(447215, 123, '2015-03-15 00:31:23.000000', 'consum', 0.0220, 'lps'),
	(447216, 123, '2015-03-15 00:31:24.000000', 'consum', 0.0222, 'lps'),
	(447217, 123, '2015-03-15 00:31:25.000000', 'consum', 0.0216, 'lps'),
	(447218, 123, '2015-03-15 00:31:26.000000', 'consum', 0.0227, 'lps'),
	(447219, 123, '2015-03-15 00:31:27.000000', 'consum', 0.0231, 'lps'),
	(447220, 123, '2015-03-15 00:31:28.000000', 'consum', 0.0216, 'lps'),
	(447221, 123, '2015-03-15 00:31:29.000000', 'consum', 0.0224, 'lps'),
	(447222, 123, '2015-03-15 00:31:30.000000', 'consum', 0.0218, 'lps'),
	(447223, 123, '2015-03-15 00:31:31.000000', 'consum', 0.0229, 'lps'),
	(447224, 123, '2015-03-15 00:31:32.000000', 'consum', 0.0212, 'lps'),
	(447225, 123, '2015-03-15 00:31:33.000000', 'consum', 0.0233, 'lps'),
	(447226, 123, '2015-03-15 00:31:34.000000', 'consum', 0.0226, 'lps'),
	(447227, 123, '2015-03-15 00:31:35.000000', 'consum', 0.0222, 'lps'),
	(447228, 123, '2015-03-15 00:31:36.000000', 'consum', 0.0221, 'lps'),
	(447229, 123, '2015-03-15 00:31:37.000000', 'consum', 0.0230, 'lps'),
	(447230, 123, '2015-03-15 00:31:38.000000', 'consum', 0.0229, 'lps'),
	(447231, 123, '2015-03-15 00:31:39.000000', 'consum', 0.0221, 'lps'),
	(447232, 123, '2015-03-15 00:31:40.000000', 'consum', 0.0211, 'lps'),
	(447233, 123, '2015-03-15 00:31:41.000000', 'consum', 0.0228, 'lps'),
	(447234, 123, '2015-03-15 00:31:42.000000', 'consum', 0.0225, 'lps'),
	(447235, 123, '2015-03-15 00:31:43.000000', 'consum', 0.0232, 'lps'),
	(447236, 123, '2015-03-15 00:31:44.000000', 'consum', 0.0228, 'lps'),
	(447237, 123, '2015-03-15 00:31:45.000000', 'consum', 0.0212, 'lps'),
	(447238, 123, '2015-03-15 00:31:46.000000', 'consum', 0.0212, 'lps'),
	(447239, 123, '2015-03-15 00:31:47.000000', 'consum', 0.0214, 'lps'),
	(447240, 123, '2015-03-15 00:31:48.000000', 'consum', 0.0224, 'lps'),
	(447241, 123, '2015-03-15 00:31:49.000000', 'consum', 0.0219, 'lps'),
	(447242, 123, '2015-03-15 00:31:50.000000', 'consum', 0.0217, 'lps'),
	(447243, 123, '2015-03-15 00:31:51.000000', 'consum', 0.0218, 'lps'),
	(447244, 123, '2015-03-15 00:31:52.000000', 'consum', 0.0228, 'lps'),
	(447245, 123, '2015-03-15 00:31:53.000000', 'consum', 0.0230, 'lps'),
	(447246, 123, '2015-03-15 00:31:54.000000', 'consum', 0.0233, 'lps'),
	(447247, 123, '2015-03-15 00:31:55.000000', 'consum', 0.0218, 'lps'),
	(447248, 123, '2015-03-15 00:31:56.000000', 'consum', 0.0230, 'lps'),
	(447249, 123, '2015-03-15 00:31:57.000000', 'consum', 0.0213, 'lps'),
	(447250, 123, '2015-03-15 00:31:58.000000', 'consum', 0.0213, 'lps'),
	(447251, 123, '2015-03-15 00:31:59.000000', 'consum', 0.0217, 'lps'),
	(447252, 123, '2015-03-15 00:32:00.000000', 'consum', 0.0213, 'lps'),
	(447253, 123, '2015-03-15 00:32:01.000000', 'consum', 0.0227, 'lps'),
	(447254, 123, '2015-03-15 00:32:02.000000', 'consum', 0.0217, 'lps'),
	(447255, 123, '2015-03-15 00:32:03.000000', 'consum', 0.0218, 'lps'),
	(447256, 123, '2015-03-15 00:32:04.000000', 'consum', 0.0230, 'lps'),
	(447257, 123, '2015-03-15 00:32:05.000000', 'consum', 0.0214, 'lps'),
	(447258, 123, '2015-03-15 00:32:06.000000', 'consum', 0.0220, 'lps'),
	(447259, 123, '2015-03-15 00:32:07.000000', 'consum', 0.0222, 'lps'),
	(447260, 123, '2015-03-15 00:32:08.000000', 'consum', 0.0218, 'lps'),
	(447261, 123, '2015-03-15 00:32:09.000000', 'consum', 0.0214, 'lps'),
	(447262, 123, '2015-03-15 00:32:10.000000', 'consum', 0.0232, 'lps'),
	(447263, 123, '2015-03-15 00:32:11.000000', 'consum', 0.0212, 'lps'),
	(447264, 123, '2015-03-15 00:32:12.000000', 'consum', 0.0228, 'lps'),
	(447265, 123, '2015-03-15 00:32:13.000000', 'consum', 0.0220, 'lps'),
	(447266, 123, '2015-03-15 00:32:14.000000', 'consum', 0.0230, 'lps'),
	(447267, 123, '2015-03-15 00:32:15.000000', 'consum', 0.0233, 'lps'),
	(447268, 123, '2015-03-15 00:32:16.000000', 'consum', 0.0218, 'lps'),
	(447269, 123, '2015-03-15 00:32:17.000000', 'consum', 0.0231, 'lps'),
	(447270, 123, '2015-03-15 00:32:18.000000', 'consum', 0.0217, 'lps'),
	(447271, 123, '2015-03-15 00:32:19.000000', 'consum', 0.0231, 'lps'),
	(447272, 123, '2015-03-15 00:32:20.000000', 'consum', 0.0223, 'lps'),
	(447273, 123, '2015-03-15 00:32:21.000000', 'consum', 0.0213, 'lps'),
	(447274, 123, '2015-03-15 00:32:22.000000', 'consum', 0.0233, 'lps'),
	(447275, 123, '2015-03-15 00:32:23.000000', 'consum', 0.0220, 'lps'),
	(447276, 123, '2015-03-15 00:32:24.000000', 'consum', 0.0215, 'lps'),
	(447277, 123, '2015-03-15 00:32:25.000000', 'consum', 0.0233, 'lps'),
	(447278, 123, '2015-03-15 00:32:26.000000', 'consum', 0.0211, 'lps'),
	(447279, 123, '2015-03-15 00:32:27.000000', 'consum', 0.0220, 'lps'),
	(447280, 123, '2015-03-15 00:32:28.000000', 'consum', 0.0232, 'lps'),
	(447281, 123, '2015-03-15 00:32:29.000000', 'consum', 0.0219, 'lps'),
	(447282, 123, '2015-03-15 00:32:30.000000', 'consum', 0.0216, 'lps'),
	(447283, 123, '2015-03-15 00:32:31.000000', 'consum', 0.0210, 'lps'),
	(447284, 123, '2015-03-15 00:32:32.000000', 'consum', 0.0219, 'lps'),
	(447285, 123, '2015-03-15 00:32:33.000000', 'consum', 0.0230, 'lps'),
	(447286, 123, '2015-03-15 00:32:34.000000', 'consum', 0.0212, 'lps'),
	(447287, 123, '2015-03-15 00:32:35.000000', 'consum', 0.0210, 'lps'),
	(447288, 123, '2015-03-15 00:32:36.000000', 'consum', 0.0228, 'lps'),
	(447289, 123, '2015-03-15 00:32:37.000000', 'consum', 0.0229, 'lps'),
	(447290, 123, '2015-03-15 00:32:38.000000', 'consum', 0.0228, 'lps'),
	(447291, 123, '2015-03-15 00:32:39.000000', 'consum', 0.0218, 'lps'),
	(447292, 123, '2015-03-15 00:32:40.000000', 'consum', 0.0220, 'lps'),
	(447293, 123, '2015-03-15 00:32:41.000000', 'consum', 0.0211, 'lps'),
	(447294, 123, '2015-03-15 00:32:42.000000', 'consum', 0.0213, 'lps'),
	(447295, 123, '2015-03-15 00:32:43.000000', 'consum', 0.0219, 'lps'),
	(447296, 123, '2015-03-15 00:32:44.000000', 'consum', 0.0225, 'lps'),
	(447297, 123, '2015-03-15 00:32:45.000000', 'consum', 0.0211, 'lps'),
	(447298, 123, '2015-03-15 00:32:46.000000', 'consum', 0.0218, 'lps'),
	(447299, 123, '2015-03-15 00:32:47.000000', 'consum', 0.0222, 'lps'),
	(447300, 123, '2015-03-15 00:32:48.000000', 'consum', 0.0223, 'lps'),
	(447301, 123, '2015-03-15 00:32:49.000000', 'consum', 0.0217, 'lps'),
	(447302, 123, '2015-03-15 00:32:50.000000', 'consum', 0.0232, 'lps'),
	(447303, 123, '2015-03-15 00:32:51.000000', 'consum', 0.0225, 'lps'),
	(447304, 123, '2015-03-15 00:32:52.000000', 'consum', 0.0220, 'lps'),
	(447305, 123, '2015-03-15 00:32:53.000000', 'consum', 0.0215, 'lps'),
	(447306, 123, '2015-03-15 00:32:54.000000', 'consum', 0.0230, 'lps'),
	(447307, 123, '2015-03-15 00:32:55.000000', 'consum', 0.0224, 'lps'),
	(447308, 123, '2015-03-15 00:32:56.000000', 'consum', 0.0219, 'lps'),
	(447309, 123, '2015-03-15 00:32:57.000000', 'consum', 0.0216, 'lps'),
	(447310, 123, '2015-03-15 00:32:58.000000', 'consum', 0.0211, 'lps'),
	(447311, 123, '2015-03-15 00:32:59.000000', 'consum', 0.0223, 'lps'),
	(447312, 123, '2015-03-15 00:33:00.000000', 'consum', 0.0225, 'lps'),
	(447313, 123, '2015-03-15 00:33:01.000000', 'consum', 0.0221, 'lps'),
	(447314, 123, '2015-03-15 00:33:02.000000', 'consum', 0.0221, 'lps'),
	(447315, 123, '2015-03-15 00:33:03.000000', 'consum', 0.0232, 'lps'),
	(447316, 123, '2015-03-15 00:33:04.000000', 'consum', 0.0215, 'lps'),
	(447317, 123, '2015-03-15 00:33:05.000000', 'consum', 0.0217, 'lps'),
	(447318, 123, '2015-03-15 00:33:06.000000', 'consum', 0.0230, 'lps'),
	(447319, 123, '2015-03-15 00:33:07.000000', 'consum', 0.0219, 'lps'),
	(447320, 123, '2015-03-15 00:33:08.000000', 'consum', 0.0220, 'lps'),
	(447321, 123, '2015-03-15 00:33:09.000000', 'consum', 0.0232, 'lps'),
	(447322, 123, '2015-03-15 00:33:10.000000', 'consum', 0.0220, 'lps'),
	(447323, 123, '2015-03-15 00:33:11.000000', 'consum', 0.0218, 'lps'),
	(447324, 123, '2015-03-15 00:33:12.000000', 'consum', 0.0222, 'lps'),
	(447325, 123, '2015-03-15 00:33:13.000000', 'consum', 0.0223, 'lps'),
	(447326, 123, '2015-03-15 00:33:14.000000', 'consum', 0.0215, 'lps'),
	(447327, 123, '2015-03-15 00:33:15.000000', 'consum', 0.0219, 'lps'),
	(447328, 123, '2015-03-15 00:33:16.000000', 'consum', 0.0217, 'lps'),
	(447329, 123, '2015-03-15 00:33:17.000000', 'consum', 0.0219, 'lps'),
	(447330, 123, '2015-03-15 00:33:18.000000', 'consum', 0.0211, 'lps'),
	(447331, 123, '2015-03-15 00:33:19.000000', 'consum', 0.0214, 'lps'),
	(447332, 123, '2015-03-15 00:33:20.000000', 'consum', 0.0224, 'lps'),
	(447333, 123, '2015-03-15 00:33:21.000000', 'consum', 0.0223, 'lps'),
	(447334, 123, '2015-03-15 00:33:22.000000', 'consum', 0.0231, 'lps'),
	(447335, 123, '2015-03-15 00:33:23.000000', 'consum', 0.0228, 'lps'),
	(447336, 123, '2015-03-15 00:33:24.000000', 'consum', 0.0217, 'lps'),
	(447337, 123, '2015-03-15 00:33:25.000000', 'consum', 0.0213, 'lps'),
	(447338, 123, '2015-03-15 00:33:26.000000', 'consum', 0.0229, 'lps'),
	(447339, 123, '2015-03-15 00:33:27.000000', 'consum', 0.0227, 'lps'),
	(447340, 123, '2015-03-15 00:33:28.000000', 'consum', 0.0211, 'lps'),
	(447341, 123, '2015-03-15 00:33:29.000000', 'consum', 0.0215, 'lps'),
	(447342, 123, '2015-03-15 00:33:30.000000', 'consum', 0.0230, 'lps'),
	(447343, 123, '2015-03-15 00:33:31.000000', 'consum', 0.0226, 'lps'),
	(447344, 123, '2015-03-15 00:33:32.000000', 'consum', 0.0228, 'lps'),
	(447345, 123, '2015-03-15 00:33:33.000000', 'consum', 0.0231, 'lps'),
	(447346, 123, '2015-03-15 00:33:34.000000', 'consum', 0.0211, 'lps'),
	(447347, 123, '2015-03-15 00:33:35.000000', 'consum', 0.0227, 'lps'),
	(447348, 123, '2015-03-15 00:33:36.000000', 'consum', 0.0222, 'lps'),
	(447349, 123, '2015-03-15 00:33:37.000000', 'consum', 0.0216, 'lps'),
	(447350, 123, '2015-03-15 00:33:38.000000', 'consum', 0.0228, 'lps'),
	(447351, 123, '2015-03-15 00:33:39.000000', 'consum', 0.0212, 'lps'),
	(447352, 123, '2015-03-15 00:33:40.000000', 'consum', 0.0215, 'lps'),
	(447353, 123, '2015-03-15 00:33:41.000000', 'consum', 0.0229, 'lps'),
	(447354, 123, '2015-03-15 00:33:42.000000', 'consum', 0.0217, 'lps'),
	(447355, 123, '2015-03-15 00:33:43.000000', 'consum', 0.0214, 'lps'),
	(447356, 123, '2015-03-15 00:33:44.000000', 'consum', 0.0232, 'lps'),
	(447357, 123, '2015-03-15 00:33:45.000000', 'consum', 0.0214, 'lps'),
	(447358, 123, '2015-03-15 00:33:46.000000', 'consum', 0.0213, 'lps'),
	(447359, 123, '2015-03-15 00:33:47.000000', 'consum', 0.0215, 'lps'),
	(447360, 123, '2015-03-15 00:33:48.000000', 'consum', 0.0224, 'lps'),
	(447361, 123, '2015-03-15 00:33:49.000000', 'consum', 0.0216, 'lps'),
	(447362, 123, '2015-03-15 00:33:50.000000', 'consum', 0.0225, 'lps'),
	(447363, 123, '2015-03-15 00:33:51.000000', 'consum', 0.0217, 'lps'),
	(447364, 123, '2015-03-15 00:33:52.000000', 'consum', 0.0225, 'lps'),
	(447365, 123, '2015-03-15 00:33:53.000000', 'consum', 0.0216, 'lps'),
	(447366, 123, '2015-03-15 00:33:54.000000', 'consum', 0.0219, 'lps'),
	(447367, 123, '2015-03-15 00:33:55.000000', 'consum', 0.0216, 'lps'),
	(447368, 123, '2015-03-15 00:33:56.000000', 'consum', 0.0213, 'lps'),
	(447369, 123, '2015-03-15 00:33:57.000000', 'consum', 0.0231, 'lps'),
	(447370, 123, '2015-03-15 00:33:58.000000', 'consum', 0.0210, 'lps'),
	(447371, 123, '2015-03-15 00:33:59.000000', 'consum', 0.0220, 'lps'),
	(447372, 123, '2015-03-15 00:34:00.000000', 'consum', 0.0210, 'lps'),
	(447373, 123, '2015-03-15 00:34:01.000000', 'consum', 0.0232, 'lps'),
	(447374, 123, '2015-03-15 00:34:02.000000', 'consum', 0.0224, 'lps'),
	(447375, 123, '2015-03-15 00:34:03.000000', 'consum', 0.0216, 'lps'),
	(447376, 123, '2015-03-15 00:34:04.000000', 'consum', 0.0219, 'lps'),
	(447377, 123, '2015-03-15 00:34:05.000000', 'consum', 0.0215, 'lps'),
	(447378, 123, '2015-03-15 00:34:06.000000', 'consum', 0.0233, 'lps'),
	(447379, 123, '2015-03-15 00:34:07.000000', 'consum', 0.0216, 'lps'),
	(447380, 123, '2015-03-15 00:34:08.000000', 'consum', 0.0218, 'lps'),
	(447381, 123, '2015-03-15 00:34:09.000000', 'consum', 0.0233, 'lps'),
	(447382, 123, '2015-03-15 00:34:10.000000', 'consum', 0.0231, 'lps'),
	(447383, 123, '2015-03-15 00:34:11.000000', 'consum', 0.0221, 'lps'),
	(447384, 123, '2015-03-15 00:34:12.000000', 'consum', 0.0226, 'lps'),
	(447385, 123, '2015-03-15 00:34:13.000000', 'consum', 0.0233, 'lps'),
	(447386, 123, '2015-03-15 00:34:14.000000', 'consum', 0.0232, 'lps'),
	(447387, 123, '2015-03-15 00:34:15.000000', 'consum', 0.0227, 'lps'),
	(447388, 123, '2015-03-15 00:34:16.000000', 'consum', 0.0228, 'lps'),
	(447389, 123, '2015-03-15 00:34:17.000000', 'consum', 0.0228, 'lps'),
	(447390, 123, '2015-03-15 00:34:18.000000', 'consum', 0.0220, 'lps'),
	(447391, 123, '2015-03-15 00:34:19.000000', 'consum', 0.0233, 'lps'),
	(447392, 123, '2015-03-15 00:34:20.000000', 'consum', 0.0223, 'lps'),
	(447393, 123, '2015-03-15 00:34:21.000000', 'consum', 0.0230, 'lps'),
	(447394, 123, '2015-03-15 00:34:22.000000', 'consum', 0.0224, 'lps'),
	(447395, 123, '2015-03-15 00:34:23.000000', 'consum', 0.0221, 'lps'),
	(447396, 123, '2015-03-15 00:34:24.000000', 'consum', 0.0225, 'lps'),
	(447397, 123, '2015-03-15 00:34:25.000000', 'consum', 0.0227, 'lps'),
	(447398, 123, '2015-03-15 00:34:26.000000', 'consum', 0.0225, 'lps'),
	(447399, 123, '2015-03-15 00:34:27.000000', 'consum', 0.0213, 'lps'),
	(447400, 123, '2015-03-15 00:34:28.000000', 'consum', 0.0229, 'lps'),
	(447401, 123, '2015-03-15 00:34:29.000000', 'consum', 0.0225, 'lps'),
	(447402, 123, '2015-03-15 00:34:30.000000', 'consum', 0.0227, 'lps'),
	(447403, 123, '2015-03-15 00:34:31.000000', 'consum', 0.0226, 'lps'),
	(447404, 123, '2015-03-15 00:34:32.000000', 'consum', 0.0215, 'lps'),
	(447405, 123, '2015-03-15 00:34:33.000000', 'consum', 0.0214, 'lps'),
	(447406, 123, '2015-03-15 00:34:34.000000', 'consum', 0.0214, 'lps'),
	(447407, 123, '2015-03-15 00:34:35.000000', 'consum', 0.0220, 'lps'),
	(447408, 123, '2015-03-15 00:34:36.000000', 'consum', 0.0223, 'lps'),
	(447409, 123, '2015-03-15 00:34:37.000000', 'consum', 0.0221, 'lps'),
	(447410, 123, '2015-03-15 00:34:38.000000', 'consum', 0.0226, 'lps'),
	(447411, 123, '2015-03-15 00:34:39.000000', 'consum', 0.0211, 'lps'),
	(447412, 123, '2015-03-15 00:34:40.000000', 'consum', 0.0214, 'lps'),
	(447413, 123, '2015-03-15 00:34:41.000000', 'consum', 0.0226, 'lps'),
	(447414, 123, '2015-03-15 00:34:42.000000', 'consum', 0.0233, 'lps'),
	(447415, 123, '2015-03-15 00:34:43.000000', 'consum', 0.0228, 'lps'),
	(447416, 123, '2015-03-15 00:34:44.000000', 'consum', 0.0233, 'lps'),
	(447417, 123, '2015-03-15 00:34:45.000000', 'consum', 0.0223, 'lps'),
	(447418, 123, '2015-03-15 00:34:46.000000', 'consum', 0.0230, 'lps'),
	(447419, 123, '2015-03-15 00:34:47.000000', 'consum', 0.0225, 'lps'),
	(447420, 123, '2015-03-15 00:34:48.000000', 'consum', 0.0223, 'lps'),
	(447421, 123, '2015-03-15 00:34:49.000000', 'consum', 0.0230, 'lps'),
	(447422, 123, '2015-03-15 00:34:50.000000', 'consum', 0.0227, 'lps'),
	(447423, 123, '2015-03-15 00:34:51.000000', 'consum', 0.0232, 'lps'),
	(447424, 123, '2015-03-15 00:34:52.000000', 'consum', 0.0222, 'lps'),
	(447425, 123, '2015-03-15 00:34:53.000000', 'consum', 0.0228, 'lps'),
	(447426, 123, '2015-03-15 00:34:54.000000', 'consum', 0.0217, 'lps'),
	(447427, 123, '2015-03-15 00:34:55.000000', 'consum', 0.0217, 'lps'),
	(447428, 123, '2015-03-15 00:34:56.000000', 'consum', 0.0226, 'lps'),
	(447429, 123, '2015-03-15 00:34:57.000000', 'consum', 0.0218, 'lps'),
	(447430, 123, '2015-03-15 00:34:58.000000', 'consum', 0.0227, 'lps'),
	(447431, 123, '2015-03-15 00:34:59.000000', 'consum', 0.0223, 'lps'),
	(447432, 123, '2015-03-15 00:35:00.000000', 'consum', 0.0225, 'lps'),
	(447433, 123, '2015-03-15 00:35:01.000000', 'consum', 0.0223, 'lps'),
	(447434, 123, '2015-03-15 00:35:02.000000', 'consum', 0.0229, 'lps'),
	(447435, 123, '2015-03-15 00:35:03.000000', 'consum', 0.0219, 'lps'),
	(447436, 123, '2015-03-15 00:35:04.000000', 'consum', 0.0225, 'lps'),
	(447437, 123, '2015-03-15 00:35:05.000000', 'consum', 0.0231, 'lps'),
	(447438, 123, '2015-03-15 00:35:06.000000', 'consum', 0.0225, 'lps'),
	(447439, 123, '2015-03-15 00:35:07.000000', 'consum', 0.0222, 'lps'),
	(447440, 123, '2015-03-15 00:35:08.000000', 'consum', 0.0225, 'lps'),
	(447441, 123, '2015-03-15 00:35:09.000000', 'consum', 0.0225, 'lps'),
	(447442, 123, '2015-03-15 00:35:10.000000', 'consum', 0.0219, 'lps'),
	(447443, 123, '2015-03-15 00:35:11.000000', 'consum', 0.0232, 'lps'),
	(447444, 123, '2015-03-15 00:35:12.000000', 'consum', 0.0223, 'lps'),
	(447445, 123, '2015-03-15 00:35:13.000000', 'consum', 0.0232, 'lps'),
	(447446, 123, '2015-03-15 00:35:14.000000', 'consum', 0.0233, 'lps'),
	(447447, 123, '2015-03-15 00:35:15.000000', 'consum', 0.0213, 'lps'),
	(447448, 123, '2015-03-15 00:35:16.000000', 'consum', 0.0230, 'lps'),
	(447449, 123, '2015-03-15 00:35:17.000000', 'consum', 0.0227, 'lps'),
	(447450, 123, '2015-03-15 00:35:18.000000', 'consum', 0.0213, 'lps'),
	(447451, 123, '2015-03-15 00:35:19.000000', 'consum', 0.0222, 'lps'),
	(447452, 123, '2015-03-15 00:35:20.000000', 'consum', 0.0212, 'lps'),
	(447453, 123, '2015-03-15 00:35:21.000000', 'consum', 0.0233, 'lps'),
	(447454, 123, '2015-03-15 00:35:22.000000', 'consum', 0.0223, 'lps'),
	(447455, 123, '2015-03-15 00:35:23.000000', 'consum', 0.0233, 'lps'),
	(447456, 123, '2015-03-15 00:35:24.000000', 'consum', 0.0211, 'lps'),
	(447457, 123, '2015-03-15 00:35:25.000000', 'consum', 0.0222, 'lps'),
	(447458, 123, '2015-03-15 00:35:26.000000', 'consum', 0.0217, 'lps'),
	(447459, 123, '2015-03-15 00:35:27.000000', 'consum', 0.0232, 'lps'),
	(447460, 123, '2015-03-15 00:35:28.000000', 'consum', 0.0231, 'lps'),
	(447461, 123, '2015-03-15 00:35:29.000000', 'consum', 0.0223, 'lps'),
	(447462, 123, '2015-03-15 00:35:30.000000', 'consum', 0.0212, 'lps'),
	(447463, 123, '2015-03-15 00:35:31.000000', 'consum', 0.0231, 'lps'),
	(447464, 123, '2015-03-15 00:35:32.000000', 'consum', 0.0213, 'lps'),
	(447465, 123, '2015-03-15 00:35:33.000000', 'consum', 0.0210, 'lps'),
	(447466, 123, '2015-03-15 00:35:34.000000', 'consum', 0.0226, 'lps'),
	(447467, 123, '2015-03-15 00:35:35.000000', 'consum', 0.0217, 'lps'),
	(447468, 123, '2015-03-15 00:35:36.000000', 'consum', 0.0221, 'lps'),
	(447469, 123, '2015-03-15 00:35:37.000000', 'consum', 0.0220, 'lps'),
	(447470, 123, '2015-03-15 00:35:38.000000', 'consum', 0.0229, 'lps'),
	(447471, 123, '2015-03-15 00:35:39.000000', 'consum', 0.0227, 'lps'),
	(447472, 123, '2015-03-15 00:35:40.000000', 'consum', 0.0215, 'lps'),
	(447473, 123, '2015-03-15 00:35:41.000000', 'consum', 0.0210, 'lps'),
	(447474, 123, '2015-03-15 00:35:42.000000', 'consum', 0.0217, 'lps'),
	(447475, 123, '2015-03-15 00:35:43.000000', 'consum', 0.0222, 'lps'),
	(447476, 123, '2015-03-15 00:35:44.000000', 'consum', 0.0227, 'lps'),
	(447477, 123, '2015-03-15 00:35:45.000000', 'consum', 0.0233, 'lps'),
	(447478, 123, '2015-03-15 00:35:46.000000', 'consum', 0.0227, 'lps'),
	(447479, 123, '2015-03-15 00:35:47.000000', 'consum', 0.0228, 'lps'),
	(447480, 123, '2015-03-15 00:35:48.000000', 'consum', 0.0226, 'lps'),
	(447481, 123, '2015-03-15 00:35:49.000000', 'consum', 0.0213, 'lps'),
	(447482, 123, '2015-03-15 00:35:50.000000', 'consum', 0.0227, 'lps'),
	(447483, 123, '2015-03-15 00:35:51.000000', 'consum', 0.0211, 'lps'),
	(447484, 123, '2015-03-15 00:35:52.000000', 'consum', 0.0216, 'lps'),
	(447485, 123, '2015-03-15 00:35:53.000000', 'consum', 0.0210, 'lps'),
	(447486, 123, '2015-03-15 00:35:54.000000', 'consum', 0.0217, 'lps'),
	(447487, 123, '2015-03-15 00:35:55.000000', 'consum', 0.0223, 'lps'),
	(447488, 123, '2015-03-15 00:35:56.000000', 'consum', 0.0231, 'lps'),
	(447489, 123, '2015-03-15 00:35:57.000000', 'consum', 0.0226, 'lps'),
	(447490, 123, '2015-03-15 00:35:58.000000', 'consum', 0.0230, 'lps'),
	(447491, 123, '2015-03-15 00:35:59.000000', 'consum', 0.0212, 'lps'),
	(447492, 123, '2015-03-15 00:36:00.000000', 'consum', 0.0211, 'lps'),
	(447493, 123, '2015-03-15 00:36:01.000000', 'consum', 0.0231, 'lps'),
	(447494, 123, '2015-03-15 00:36:02.000000', 'consum', 0.0219, 'lps'),
	(447495, 123, '2015-03-15 00:36:03.000000', 'consum', 0.0216, 'lps'),
	(447496, 123, '2015-03-15 00:36:04.000000', 'consum', 0.0214, 'lps'),
	(447497, 123, '2015-03-15 00:36:05.000000', 'consum', 0.0211, 'lps'),
	(447498, 123, '2015-03-15 00:36:06.000000', 'consum', 0.0228, 'lps'),
	(447499, 123, '2015-03-15 00:36:07.000000', 'consum', 0.0226, 'lps'),
	(447500, 123, '2015-03-15 00:36:08.000000', 'consum', 0.0211, 'lps'),
	(447501, 123, '2015-03-15 00:36:09.000000', 'consum', 0.0215, 'lps'),
	(447502, 123, '2015-03-15 00:36:10.000000', 'consum', 0.0211, 'lps'),
	(447503, 123, '2015-03-15 00:36:11.000000', 'consum', 0.0224, 'lps'),
	(447504, 123, '2015-03-15 00:36:12.000000', 'consum', 0.0228, 'lps'),
	(447505, 123, '2015-03-15 00:36:13.000000', 'consum', 0.0213, 'lps'),
	(447506, 123, '2015-03-15 00:36:14.000000', 'consum', 0.0216, 'lps'),
	(447507, 123, '2015-03-15 00:36:15.000000', 'consum', 0.0210, 'lps'),
	(447508, 123, '2015-03-15 00:36:16.000000', 'consum', 0.0217, 'lps'),
	(447509, 123, '2015-03-15 00:36:17.000000', 'consum', 0.0220, 'lps'),
	(447510, 123, '2015-03-15 00:36:18.000000', 'consum', 0.0214, 'lps'),
	(447511, 123, '2015-03-15 00:36:19.000000', 'consum', 0.0226, 'lps'),
	(447512, 123, '2015-03-15 00:36:20.000000', 'consum', 0.0229, 'lps'),
	(447513, 123, '2015-03-15 00:36:21.000000', 'consum', 0.0233, 'lps'),
	(447514, 123, '2015-03-15 00:36:22.000000', 'consum', 0.0222, 'lps'),
	(447515, 123, '2015-03-15 00:36:23.000000', 'consum', 0.0225, 'lps'),
	(447516, 123, '2015-03-15 00:36:24.000000', 'consum', 0.0226, 'lps'),
	(447517, 123, '2015-03-15 00:36:25.000000', 'consum', 0.0220, 'lps'),
	(447518, 123, '2015-03-15 00:36:26.000000', 'consum', 0.0212, 'lps'),
	(447519, 123, '2015-03-15 00:36:27.000000', 'consum', 0.0214, 'lps'),
	(447520, 123, '2015-03-15 00:36:28.000000', 'consum', 0.0224, 'lps'),
	(447521, 123, '2015-03-15 00:36:29.000000', 'consum', 0.0221, 'lps'),
	(447522, 123, '2015-03-15 00:36:30.000000', 'consum', 0.0226, 'lps'),
	(447523, 123, '2015-03-15 00:36:31.000000', 'consum', 0.0230, 'lps'),
	(447524, 123, '2015-03-15 00:36:32.000000', 'consum', 0.0217, 'lps'),
	(447525, 123, '2015-03-15 00:36:33.000000', 'consum', 0.0210, 'lps'),
	(447526, 123, '2015-03-15 00:36:34.000000', 'consum', 0.0214, 'lps'),
	(447527, 123, '2015-03-15 00:36:35.000000', 'consum', 0.0231, 'lps'),
	(447528, 123, '2015-03-15 00:36:36.000000', 'consum', 0.0230, 'lps'),
	(447529, 123, '2015-03-15 00:36:37.000000', 'consum', 0.0222, 'lps'),
	(447530, 123, '2015-03-15 00:36:38.000000', 'consum', 0.0213, 'lps'),
	(447531, 123, '2015-03-15 00:36:39.000000', 'consum', 0.0213, 'lps'),
	(447532, 123, '2015-03-15 00:36:40.000000', 'consum', 0.0215, 'lps'),
	(447533, 123, '2015-03-15 00:36:41.000000', 'consum', 0.0229, 'lps'),
	(447534, 123, '2015-03-15 00:36:42.000000', 'consum', 0.0219, 'lps'),
	(447535, 123, '2015-03-15 00:36:43.000000', 'consum', 0.0223, 'lps'),
	(447536, 123, '2015-03-15 00:36:44.000000', 'consum', 0.0223, 'lps'),
	(447537, 123, '2015-03-15 00:36:45.000000', 'consum', 0.0212, 'lps'),
	(447538, 123, '2015-03-15 00:36:46.000000', 'consum', 0.0230, 'lps'),
	(447539, 123, '2015-03-15 00:36:47.000000', 'consum', 0.0210, 'lps'),
	(447540, 123, '2015-03-15 00:36:48.000000', 'consum', 0.0222, 'lps'),
	(447541, 123, '2015-03-15 00:36:49.000000', 'consum', 0.0222, 'lps'),
	(447542, 123, '2015-03-15 00:36:50.000000', 'consum', 0.0213, 'lps'),
	(447543, 123, '2015-03-15 00:36:51.000000', 'consum', 0.0210, 'lps'),
	(447544, 123, '2015-03-15 00:36:52.000000', 'consum', 0.0225, 'lps'),
	(447545, 123, '2015-03-15 00:36:53.000000', 'consum', 0.0216, 'lps'),
	(447546, 123, '2015-03-15 00:36:54.000000', 'consum', 0.0220, 'lps'),
	(447547, 123, '2015-03-15 00:36:55.000000', 'consum', 0.0216, 'lps'),
	(447548, 123, '2015-03-15 00:36:56.000000', 'consum', 0.0212, 'lps'),
	(447549, 123, '2015-03-15 00:36:57.000000', 'consum', 0.0224, 'lps'),
	(447550, 123, '2015-03-15 00:36:58.000000', 'consum', 0.0230, 'lps'),
	(447551, 123, '2015-03-15 00:36:59.000000', 'consum', 0.0218, 'lps'),
	(447552, 123, '2015-03-15 00:37:00.000000', 'consum', 0.0213, 'lps'),
	(447553, 123, '2015-03-15 00:37:01.000000', 'consum', 0.0228, 'lps'),
	(447554, 123, '2015-03-15 00:37:02.000000', 'consum', 0.0220, 'lps'),
	(447555, 123, '2015-03-15 00:37:03.000000', 'consum', 0.0229, 'lps'),
	(447556, 123, '2015-03-15 00:37:04.000000', 'consum', 0.0229, 'lps'),
	(447557, 123, '2015-03-15 00:37:05.000000', 'consum', 0.0222, 'lps'),
	(447558, 123, '2015-03-15 00:37:06.000000', 'consum', 0.0216, 'lps'),
	(447559, 123, '2015-03-15 00:37:07.000000', 'consum', 0.0229, 'lps'),
	(447560, 123, '2015-03-15 00:37:08.000000', 'consum', 0.0216, 'lps'),
	(447561, 123, '2015-03-15 00:37:09.000000', 'consum', 0.0230, 'lps'),
	(447562, 123, '2015-03-15 00:37:10.000000', 'consum', 0.0223, 'lps'),
	(447563, 123, '2015-03-15 00:37:11.000000', 'consum', 0.0213, 'lps'),
	(447564, 123, '2015-03-15 00:37:12.000000', 'consum', 0.0211, 'lps'),
	(447565, 123, '2015-03-15 00:37:13.000000', 'consum', 0.0231, 'lps'),
	(447566, 123, '2015-03-15 00:37:14.000000', 'consum', 0.0216, 'lps'),
	(447567, 123, '2015-03-15 00:37:15.000000', 'consum', 0.0227, 'lps'),
	(447568, 123, '2015-03-15 00:37:16.000000', 'consum', 0.0229, 'lps'),
	(447569, 123, '2015-03-15 00:37:17.000000', 'consum', 0.0232, 'lps'),
	(447570, 123, '2015-03-15 00:37:18.000000', 'consum', 0.0214, 'lps'),
	(447571, 123, '2015-03-15 00:37:19.000000', 'consum', 0.0212, 'lps'),
	(447572, 123, '2015-03-15 00:37:20.000000', 'consum', 0.0211, 'lps'),
	(447573, 123, '2015-03-15 00:37:21.000000', 'consum', 0.0232, 'lps'),
	(447574, 123, '2015-03-15 00:37:22.000000', 'consum', 0.0223, 'lps'),
	(447575, 123, '2015-03-15 00:37:23.000000', 'consum', 0.0231, 'lps'),
	(447576, 123, '2015-03-15 00:37:24.000000', 'consum', 0.0229, 'lps'),
	(447577, 123, '2015-03-15 00:37:25.000000', 'consum', 0.0220, 'lps'),
	(447578, 123, '2015-03-15 00:37:26.000000', 'consum', 0.0228, 'lps'),
	(447579, 123, '2015-03-15 00:37:27.000000', 'consum', 0.0221, 'lps'),
	(447580, 123, '2015-03-15 00:37:28.000000', 'consum', 0.0211, 'lps'),
	(447581, 123, '2015-03-15 00:37:29.000000', 'consum', 0.0230, 'lps'),
	(447582, 123, '2015-03-15 00:37:30.000000', 'consum', 0.0213, 'lps'),
	(447583, 123, '2015-03-15 00:37:31.000000', 'consum', 0.0211, 'lps'),
	(447584, 123, '2015-03-15 00:37:32.000000', 'consum', 0.0231, 'lps'),
	(447585, 123, '2015-03-15 00:37:33.000000', 'consum', 0.0219, 'lps'),
	(447586, 123, '2015-03-15 00:37:34.000000', 'consum', 0.0214, 'lps'),
	(447587, 123, '2015-03-15 00:37:35.000000', 'consum', 0.0227, 'lps'),
	(447588, 123, '2015-03-15 00:37:36.000000', 'consum', 0.0213, 'lps'),
	(447589, 123, '2015-03-15 00:37:37.000000', 'consum', 0.0223, 'lps'),
	(447590, 123, '2015-03-15 00:37:38.000000', 'consum', 0.0219, 'lps'),
	(447591, 123, '2015-03-15 00:37:39.000000', 'consum', 0.0215, 'lps'),
	(447592, 123, '2015-03-15 00:37:40.000000', 'consum', 0.0233, 'lps'),
	(447593, 123, '2015-03-15 00:37:41.000000', 'consum', 0.0215, 'lps'),
	(447594, 123, '2015-03-15 00:37:42.000000', 'consum', 0.0214, 'lps'),
	(447595, 123, '2015-03-15 00:37:43.000000', 'consum', 0.0216, 'lps'),
	(447596, 123, '2015-03-15 00:37:44.000000', 'consum', 0.0229, 'lps'),
	(447597, 123, '2015-03-15 00:37:45.000000', 'consum', 0.0214, 'lps'),
	(447598, 123, '2015-03-15 00:37:46.000000', 'consum', 0.0221, 'lps'),
	(447599, 123, '2015-03-15 00:37:47.000000', 'consum', 0.0229, 'lps'),
	(447600, 123, '2015-03-15 00:37:48.000000', 'consum', 0.0226, 'lps'),
	(447601, 123, '2015-03-15 00:37:49.000000', 'consum', 0.0233, 'lps'),
	(447602, 123, '2015-03-15 00:37:50.000000', 'consum', 0.0229, 'lps'),
	(447603, 123, '2015-03-15 00:37:51.000000', 'consum', 0.0211, 'lps'),
	(447604, 123, '2015-03-15 00:37:52.000000', 'consum', 0.0232, 'lps'),
	(447605, 123, '2015-03-15 00:37:53.000000', 'consum', 0.0223, 'lps'),
	(447606, 123, '2015-03-15 00:37:54.000000', 'consum', 0.0232, 'lps'),
	(447607, 123, '2015-03-15 00:37:55.000000', 'consum', 0.0212, 'lps'),
	(447608, 123, '2015-03-15 00:37:56.000000', 'consum', 0.0223, 'lps'),
	(447609, 123, '2015-03-15 00:37:57.000000', 'consum', 0.0224, 'lps'),
	(447610, 123, '2015-03-15 00:37:58.000000', 'consum', 0.0217, 'lps'),
	(447611, 123, '2015-03-15 00:37:59.000000', 'consum', 0.0229, 'lps'),
	(447612, 123, '2015-03-15 00:38:00.000000', 'consum', 0.0212, 'lps'),
	(447613, 123, '2015-03-15 00:38:01.000000', 'consum', 0.0212, 'lps'),
	(447614, 123, '2015-03-15 00:38:02.000000', 'consum', 0.0212, 'lps'),
	(447615, 123, '2015-03-15 00:38:03.000000', 'consum', 0.0215, 'lps'),
	(447616, 123, '2015-03-15 00:38:04.000000', 'consum', 0.0231, 'lps'),
	(447617, 123, '2015-03-15 00:38:05.000000', 'consum', 0.0230, 'lps'),
	(447618, 123, '2015-03-15 00:38:06.000000', 'consum', 0.0220, 'lps'),
	(447619, 123, '2015-03-15 00:38:07.000000', 'consum', 0.0227, 'lps'),
	(447620, 123, '2015-03-15 00:38:08.000000', 'consum', 0.0216, 'lps'),
	(447621, 123, '2015-03-15 00:38:09.000000', 'consum', 0.0215, 'lps'),
	(447622, 123, '2015-03-15 00:38:10.000000', 'consum', 0.0216, 'lps'),
	(447623, 123, '2015-03-15 00:38:11.000000', 'consum', 0.0226, 'lps'),
	(447624, 123, '2015-03-15 00:38:12.000000', 'consum', 0.0226, 'lps'),
	(447625, 123, '2015-03-15 00:38:13.000000', 'consum', 0.0219, 'lps'),
	(447626, 123, '2015-03-15 00:38:14.000000', 'consum', 0.0228, 'lps'),
	(447627, 123, '2015-03-15 00:38:15.000000', 'consum', 0.0229, 'lps'),
	(447628, 123, '2015-03-15 00:38:16.000000', 'consum', 0.0227, 'lps'),
	(447629, 123, '2015-03-15 00:38:17.000000', 'consum', 0.0214, 'lps'),
	(447630, 123, '2015-03-15 00:38:18.000000', 'consum', 0.0228, 'lps'),
	(447631, 123, '2015-03-15 00:38:19.000000', 'consum', 0.0217, 'lps'),
	(447632, 123, '2015-03-15 00:38:20.000000', 'consum', 0.0215, 'lps'),
	(447633, 123, '2015-03-15 00:38:21.000000', 'consum', 0.0216, 'lps'),
	(447634, 123, '2015-03-15 00:38:22.000000', 'consum', 0.0223, 'lps'),
	(447635, 123, '2015-03-15 00:38:23.000000', 'consum', 0.0233, 'lps'),
	(447636, 123, '2015-03-15 00:38:24.000000', 'consum', 0.0216, 'lps'),
	(447637, 123, '2015-03-15 00:38:25.000000', 'consum', 0.0220, 'lps'),
	(447638, 123, '2015-03-15 00:38:26.000000', 'consum', 0.0217, 'lps'),
	(447639, 123, '2015-03-15 00:38:27.000000', 'consum', 0.0215, 'lps'),
	(447640, 123, '2015-03-15 00:38:28.000000', 'consum', 0.0214, 'lps'),
	(447641, 123, '2015-03-15 00:38:29.000000', 'consum', 0.0217, 'lps'),
	(447642, 123, '2015-03-15 00:38:30.000000', 'consum', 0.0233, 'lps'),
	(447643, 123, '2015-03-15 00:38:31.000000', 'consum', 0.0210, 'lps'),
	(447644, 123, '2015-03-15 00:38:32.000000', 'consum', 0.0214, 'lps'),
	(447645, 123, '2015-03-15 00:38:33.000000', 'consum', 0.0228, 'lps'),
	(447646, 123, '2015-03-15 00:38:34.000000', 'consum', 0.0218, 'lps'),
	(447647, 123, '2015-03-15 00:38:35.000000', 'consum', 0.0221, 'lps'),
	(447648, 123, '2015-03-15 00:38:36.000000', 'consum', 0.0218, 'lps'),
	(447649, 123, '2015-03-15 00:38:37.000000', 'consum', 0.0217, 'lps'),
	(447650, 123, '2015-03-15 00:38:38.000000', 'consum', 0.0222, 'lps'),
	(447651, 123, '2015-03-15 00:38:39.000000', 'consum', 0.0226, 'lps'),
	(447652, 123, '2015-03-15 00:38:40.000000', 'consum', 0.0228, 'lps'),
	(447653, 123, '2015-03-15 00:38:41.000000', 'consum', 0.0230, 'lps'),
	(447654, 123, '2015-03-15 00:38:42.000000', 'consum', 0.0210, 'lps'),
	(447655, 123, '2015-03-15 00:38:43.000000', 'consum', 0.0221, 'lps'),
	(447656, 123, '2015-03-15 00:38:44.000000', 'consum', 0.0217, 'lps'),
	(447657, 123, '2015-03-15 00:38:45.000000', 'consum', 0.0211, 'lps'),
	(447658, 123, '2015-03-15 00:38:46.000000', 'consum', 0.0221, 'lps'),
	(447659, 123, '2015-03-15 00:38:47.000000', 'consum', 0.0214, 'lps'),
	(447660, 123, '2015-03-15 00:38:48.000000', 'consum', 0.0221, 'lps'),
	(447661, 123, '2015-03-15 00:38:49.000000', 'consum', 0.0228, 'lps'),
	(447662, 123, '2015-03-15 00:38:50.000000', 'consum', 0.0219, 'lps'),
	(447663, 123, '2015-03-15 00:38:51.000000', 'consum', 0.0229, 'lps'),
	(447664, 123, '2015-03-15 00:38:52.000000', 'consum', 0.0227, 'lps'),
	(447665, 123, '2015-03-15 00:38:53.000000', 'consum', 0.0215, 'lps'),
	(447666, 123, '2015-03-15 00:38:54.000000', 'consum', 0.0211, 'lps'),
	(447667, 123, '2015-03-15 00:38:55.000000', 'consum', 0.0223, 'lps'),
	(447668, 123, '2015-03-15 00:38:56.000000', 'consum', 0.0226, 'lps'),
	(447669, 123, '2015-03-15 00:38:57.000000', 'consum', 0.0227, 'lps'),
	(447670, 123, '2015-03-15 00:38:58.000000', 'consum', 0.0223, 'lps'),
	(447671, 123, '2015-03-15 00:38:59.000000', 'consum', 0.0224, 'lps'),
	(447672, 123, '2015-03-15 00:39:00.000000', 'consum', 0.0220, 'lps'),
	(447673, 123, '2015-03-15 00:39:01.000000', 'consum', 0.0216, 'lps'),
	(447674, 123, '2015-03-15 00:39:02.000000', 'consum', 0.0211, 'lps'),
	(447675, 123, '2015-03-15 00:39:03.000000', 'consum', 0.0222, 'lps'),
	(447676, 123, '2015-03-15 00:39:04.000000', 'consum', 0.0218, 'lps'),
	(447677, 123, '2015-03-15 00:39:05.000000', 'consum', 0.0214, 'lps'),
	(447678, 123, '2015-03-15 00:39:06.000000', 'consum', 0.0229, 'lps'),
	(447679, 123, '2015-03-15 00:39:07.000000', 'consum', 0.0225, 'lps'),
	(447680, 123, '2015-03-15 00:39:08.000000', 'consum', 0.0226, 'lps'),
	(447681, 123, '2015-03-15 00:39:09.000000', 'consum', 0.0223, 'lps'),
	(447682, 123, '2015-03-15 00:39:10.000000', 'consum', 0.0227, 'lps'),
	(447683, 123, '2015-03-15 00:39:11.000000', 'consum', 0.0233, 'lps'),
	(447684, 123, '2015-03-15 00:39:12.000000', 'consum', 0.0225, 'lps'),
	(447685, 123, '2015-03-15 00:39:13.000000', 'consum', 0.0217, 'lps'),
	(447686, 123, '2015-03-15 00:39:14.000000', 'consum', 0.0226, 'lps'),
	(447687, 123, '2015-03-15 00:39:15.000000', 'consum', 0.0219, 'lps'),
	(447688, 123, '2015-03-15 00:39:16.000000', 'consum', 0.0231, 'lps'),
	(447689, 123, '2015-03-15 00:39:17.000000', 'consum', 0.0218, 'lps'),
	(447690, 123, '2015-03-15 00:39:18.000000', 'consum', 0.0213, 'lps'),
	(447691, 123, '2015-03-15 00:39:19.000000', 'consum', 0.0222, 'lps'),
	(447692, 123, '2015-03-15 00:39:20.000000', 'consum', 0.0216, 'lps'),
	(447693, 123, '2015-03-15 00:39:21.000000', 'consum', 0.0228, 'lps'),
	(447694, 123, '2015-03-15 00:39:22.000000', 'consum', 0.0211, 'lps'),
	(447695, 123, '2015-03-15 00:39:23.000000', 'consum', 0.0211, 'lps'),
	(447696, 123, '2015-03-15 00:39:24.000000', 'consum', 0.0210, 'lps'),
	(447697, 123, '2015-03-15 00:39:25.000000', 'consum', 0.0230, 'lps'),
	(447698, 123, '2015-03-15 00:39:26.000000', 'consum', 0.0218, 'lps'),
	(447699, 123, '2015-03-15 00:39:27.000000', 'consum', 0.0213, 'lps'),
	(447700, 123, '2015-03-15 00:39:28.000000', 'consum', 0.0224, 'lps'),
	(447701, 123, '2015-03-15 00:39:29.000000', 'consum', 0.0225, 'lps'),
	(447702, 123, '2015-03-15 00:39:30.000000', 'consum', 0.0218, 'lps'),
	(447703, 123, '2015-03-15 00:39:31.000000', 'consum', 0.0232, 'lps'),
	(447704, 123, '2015-03-15 00:39:32.000000', 'consum', 0.0222, 'lps'),
	(447705, 123, '2015-03-15 00:39:33.000000', 'consum', 0.0230, 'lps'),
	(447706, 123, '2015-03-15 00:39:34.000000', 'consum', 0.0228, 'lps'),
	(447707, 123, '2015-03-15 00:39:35.000000', 'consum', 0.0215, 'lps'),
	(447708, 123, '2015-03-15 00:39:36.000000', 'consum', 0.0229, 'lps'),
	(447709, 123, '2015-03-15 00:39:37.000000', 'consum', 0.0218, 'lps'),
	(447710, 123, '2015-03-15 00:39:38.000000', 'consum', 0.0220, 'lps'),
	(447711, 123, '2015-03-15 00:39:39.000000', 'consum', 0.0211, 'lps'),
	(447712, 123, '2015-03-15 00:39:40.000000', 'consum', 0.0210, 'lps'),
	(447713, 123, '2015-03-15 00:39:41.000000', 'consum', 0.0232, 'lps'),
	(447714, 123, '2015-03-15 00:39:42.000000', 'consum', 0.0224, 'lps'),
	(447715, 123, '2015-03-15 00:39:43.000000', 'consum', 0.0214, 'lps'),
	(447716, 123, '2015-03-15 00:39:44.000000', 'consum', 0.0213, 'lps'),
	(447717, 123, '2015-03-15 00:39:45.000000', 'consum', 0.0211, 'lps'),
	(447718, 123, '2015-03-15 00:39:46.000000', 'consum', 0.0233, 'lps'),
	(447719, 123, '2015-03-15 00:39:47.000000', 'consum', 0.0228, 'lps'),
	(447720, 123, '2015-03-15 00:39:48.000000', 'consum', 0.0230, 'lps'),
	(447721, 123, '2015-03-15 00:39:49.000000', 'consum', 0.0231, 'lps'),
	(447722, 123, '2015-03-15 00:39:50.000000', 'consum', 0.0231, 'lps'),
	(447723, 123, '2015-03-15 00:39:51.000000', 'consum', 0.0231, 'lps'),
	(447724, 123, '2015-03-15 00:39:52.000000', 'consum', 0.0228, 'lps'),
	(447725, 123, '2015-03-15 00:39:53.000000', 'consum', 0.0215, 'lps'),
	(447726, 123, '2015-03-15 00:39:54.000000', 'consum', 0.0229, 'lps'),
	(447727, 123, '2015-03-15 00:39:55.000000', 'consum', 0.0219, 'lps'),
	(447728, 123, '2015-03-15 00:39:56.000000', 'consum', 0.0224, 'lps'),
	(447729, 123, '2015-03-15 00:39:57.000000', 'consum', 0.0226, 'lps'),
	(447730, 123, '2015-03-15 00:39:58.000000', 'consum', 0.0226, 'lps'),
	(447731, 123, '2015-03-15 00:39:59.000000', 'consum', 0.0220, 'lps'),
	(447732, 123, '2015-03-15 00:40:00.000000', 'consum', 0.0213, 'lps'),
	(447733, 123, '2015-03-15 00:40:01.000000', 'consum', 0.0216, 'lps'),
	(447734, 123, '2015-03-15 00:40:02.000000', 'consum', 0.0210, 'lps'),
	(447735, 123, '2015-03-15 00:40:03.000000', 'consum', 0.0218, 'lps'),
	(447736, 123, '2015-03-15 00:40:04.000000', 'consum', 0.0224, 'lps'),
	(447737, 123, '2015-03-15 00:40:05.000000', 'consum', 0.0211, 'lps'),
	(447738, 123, '2015-03-15 00:40:06.000000', 'consum', 0.0220, 'lps'),
	(447739, 123, '2015-03-15 00:40:07.000000', 'consum', 0.0233, 'lps'),
	(447740, 123, '2015-03-15 00:40:08.000000', 'consum', 0.0226, 'lps'),
	(447741, 123, '2015-03-15 00:40:09.000000', 'consum', 0.0218, 'lps'),
	(447742, 123, '2015-03-15 00:40:10.000000', 'consum', 0.0228, 'lps'),
	(447743, 123, '2015-03-15 00:40:11.000000', 'consum', 0.0228, 'lps'),
	(447744, 123, '2015-03-15 00:40:12.000000', 'consum', 0.0221, 'lps'),
	(447745, 123, '2015-03-15 00:40:13.000000', 'consum', 0.0212, 'lps'),
	(447746, 123, '2015-03-15 00:40:14.000000', 'consum', 0.0211, 'lps'),
	(447747, 123, '2015-03-15 00:40:15.000000', 'consum', 0.0232, 'lps'),
	(447748, 123, '2015-03-15 00:40:16.000000', 'consum', 0.0225, 'lps'),
	(447749, 123, '2015-03-15 00:40:17.000000', 'consum', 0.0217, 'lps'),
	(447750, 123, '2015-03-15 00:40:18.000000', 'consum', 0.0226, 'lps'),
	(447751, 123, '2015-03-15 00:40:19.000000', 'consum', 0.0221, 'lps'),
	(447752, 123, '2015-03-15 00:40:20.000000', 'consum', 0.0217, 'lps'),
	(447753, 123, '2015-03-15 00:40:21.000000', 'consum', 0.0211, 'lps'),
	(447754, 123, '2015-03-15 00:40:22.000000', 'consum', 0.0220, 'lps'),
	(447755, 123, '2015-03-15 00:40:23.000000', 'consum', 0.0210, 'lps'),
	(447756, 123, '2015-03-15 00:40:24.000000', 'consum', 0.0228, 'lps'),
	(447757, 123, '2015-03-15 00:40:25.000000', 'consum', 0.0227, 'lps'),
	(447758, 123, '2015-03-15 00:40:26.000000', 'consum', 0.0218, 'lps'),
	(447759, 123, '2015-03-15 00:40:27.000000', 'consum', 0.0224, 'lps'),
	(447760, 123, '2015-03-15 00:40:28.000000', 'consum', 0.0231, 'lps'),
	(447761, 123, '2015-03-15 00:40:29.000000', 'consum', 0.0229, 'lps'),
	(447762, 123, '2015-03-15 00:40:30.000000', 'consum', 0.0215, 'lps'),
	(447763, 123, '2015-03-15 00:40:31.000000', 'consum', 0.0226, 'lps'),
	(447764, 123, '2015-03-15 00:40:32.000000', 'consum', 0.0230, 'lps'),
	(447765, 123, '2015-03-15 00:40:33.000000', 'consum', 0.0215, 'lps'),
	(447766, 123, '2015-03-15 00:40:34.000000', 'consum', 0.0221, 'lps'),
	(447767, 123, '2015-03-15 00:40:35.000000', 'consum', 0.0229, 'lps'),
	(447768, 123, '2015-03-15 00:40:36.000000', 'consum', 0.0223, 'lps'),
	(447769, 123, '2015-03-15 00:40:37.000000', 'consum', 0.0217, 'lps'),
	(447770, 123, '2015-03-15 00:40:38.000000', 'consum', 0.0232, 'lps'),
	(447771, 123, '2015-03-15 00:40:39.000000', 'consum', 0.0229, 'lps'),
	(447772, 123, '2015-03-15 00:40:40.000000', 'consum', 0.0215, 'lps'),
	(447773, 123, '2015-03-15 00:40:41.000000', 'consum', 0.0228, 'lps'),
	(447774, 123, '2015-03-15 00:40:42.000000', 'consum', 0.0211, 'lps'),
	(447775, 123, '2015-03-15 00:40:43.000000', 'consum', 0.0211, 'lps'),
	(447776, 123, '2015-03-15 00:40:44.000000', 'consum', 0.0211, 'lps'),
	(447777, 123, '2015-03-15 00:40:45.000000', 'consum', 0.0213, 'lps'),
	(447778, 123, '2015-03-15 00:40:46.000000', 'consum', 0.0222, 'lps'),
	(447779, 123, '2015-03-15 00:40:47.000000', 'consum', 0.0213, 'lps'),
	(447780, 123, '2015-03-15 00:40:48.000000', 'consum', 0.0213, 'lps'),
	(447781, 123, '2015-03-15 00:40:49.000000', 'consum', 0.0219, 'lps'),
	(447782, 123, '2015-03-15 00:40:50.000000', 'consum', 0.0223, 'lps'),
	(447783, 123, '2015-03-15 00:40:51.000000', 'consum', 0.0222, 'lps'),
	(447784, 123, '2015-03-15 00:40:52.000000', 'consum', 0.0231, 'lps'),
	(447785, 123, '2015-03-15 00:40:53.000000', 'consum', 0.0233, 'lps'),
	(447786, 123, '2015-03-15 00:40:54.000000', 'consum', 0.0212, 'lps'),
	(447787, 123, '2015-03-15 00:40:55.000000', 'consum', 0.0226, 'lps'),
	(447788, 123, '2015-03-15 00:40:56.000000', 'consum', 0.0213, 'lps'),
	(447789, 123, '2015-03-15 00:40:57.000000', 'consum', 0.0223, 'lps'),
	(447790, 123, '2015-03-15 00:40:58.000000', 'consum', 0.0219, 'lps'),
	(447791, 123, '2015-03-15 00:40:59.000000', 'consum', 0.0217, 'lps'),
	(447792, 123, '2015-03-15 00:41:00.000000', 'consum', 0.0218, 'lps'),
	(447793, 123, '2015-03-15 00:41:01.000000', 'consum', 0.0230, 'lps'),
	(447794, 123, '2015-03-15 00:41:02.000000', 'consum', 0.0216, 'lps'),
	(447795, 123, '2015-03-15 00:41:03.000000', 'consum', 0.0227, 'lps'),
	(447796, 123, '2015-03-15 00:41:04.000000', 'consum', 0.0232, 'lps'),
	(447797, 123, '2015-03-15 00:41:05.000000', 'consum', 0.0219, 'lps'),
	(447798, 123, '2015-03-15 00:41:06.000000', 'consum', 0.0215, 'lps'),
	(447799, 123, '2015-03-15 00:41:07.000000', 'consum', 0.0232, 'lps'),
	(447800, 123, '2015-03-15 00:41:08.000000', 'consum', 0.0233, 'lps'),
	(447801, 123, '2015-03-15 00:41:09.000000', 'consum', 0.0210, 'lps'),
	(447802, 123, '2015-03-15 00:41:10.000000', 'consum', 0.0215, 'lps'),
	(447803, 123, '2015-03-15 00:41:11.000000', 'consum', 0.0211, 'lps'),
	(447804, 123, '2015-03-15 00:41:12.000000', 'consum', 0.0224, 'lps'),
	(447805, 123, '2015-03-15 00:41:13.000000', 'consum', 0.0229, 'lps'),
	(447806, 123, '2015-03-15 00:41:14.000000', 'consum', 0.0214, 'lps'),
	(447807, 123, '2015-03-15 00:41:15.000000', 'consum', 0.0225, 'lps'),
	(447808, 123, '2015-03-15 00:41:16.000000', 'consum', 0.0224, 'lps'),
	(447809, 123, '2015-03-15 00:41:17.000000', 'consum', 0.0212, 'lps'),
	(447810, 123, '2015-03-15 00:41:18.000000', 'consum', 0.0227, 'lps'),
	(447811, 123, '2015-03-15 00:41:19.000000', 'consum', 0.0218, 'lps'),
	(447812, 123, '2015-03-15 00:41:20.000000', 'consum', 0.0221, 'lps'),
	(447813, 123, '2015-03-15 00:41:21.000000', 'consum', 0.0220, 'lps'),
	(447814, 123, '2015-03-15 00:41:22.000000', 'consum', 0.0226, 'lps'),
	(447815, 123, '2015-03-15 00:41:23.000000', 'consum', 0.0213, 'lps'),
	(447816, 123, '2015-03-15 00:41:24.000000', 'consum', 0.0226, 'lps'),
	(447817, 123, '2015-03-15 00:41:25.000000', 'consum', 0.0210, 'lps'),
	(447818, 123, '2015-03-15 00:41:26.000000', 'consum', 0.0212, 'lps'),
	(447819, 123, '2015-03-15 00:41:27.000000', 'consum', 0.0219, 'lps'),
	(447820, 123, '2015-03-15 00:41:28.000000', 'consum', 0.0225, 'lps'),
	(447821, 123, '2015-03-15 00:41:29.000000', 'consum', 0.0210, 'lps'),
	(447822, 123, '2015-03-15 00:41:30.000000', 'consum', 0.0215, 'lps'),
	(447823, 123, '2015-03-15 00:41:31.000000', 'consum', 0.0213, 'lps'),
	(447824, 123, '2015-03-15 00:41:32.000000', 'consum', 0.0233, 'lps'),
	(447825, 123, '2015-03-15 00:41:33.000000', 'consum', 0.0218, 'lps'),
	(447826, 123, '2015-03-15 00:41:34.000000', 'consum', 0.0233, 'lps'),
	(447827, 123, '2015-03-15 00:41:35.000000', 'consum', 0.0228, 'lps'),
	(447828, 123, '2015-03-15 00:41:36.000000', 'consum', 0.0231, 'lps'),
	(447829, 123, '2015-03-15 00:41:37.000000', 'consum', 0.0214, 'lps'),
	(447830, 123, '2015-03-15 00:41:38.000000', 'consum', 0.0217, 'lps'),
	(447831, 123, '2015-03-15 00:41:39.000000', 'consum', 0.0232, 'lps'),
	(447832, 123, '2015-03-15 00:41:40.000000', 'consum', 0.0227, 'lps'),
	(447833, 123, '2015-03-15 00:41:41.000000', 'consum', 0.0231, 'lps'),
	(447834, 123, '2015-03-15 00:41:42.000000', 'consum', 0.0214, 'lps'),
	(447835, 123, '2015-03-15 00:41:43.000000', 'consum', 0.0217, 'lps'),
	(447836, 123, '2015-03-15 00:41:44.000000', 'consum', 0.0232, 'lps'),
	(447837, 123, '2015-03-15 00:41:45.000000', 'consum', 0.0227, 'lps'),
	(447838, 123, '2015-03-15 00:41:46.000000', 'consum', 0.0229, 'lps'),
	(447839, 123, '2015-03-15 00:41:47.000000', 'consum', 0.0233, 'lps'),
	(447840, 123, '2015-03-15 00:41:48.000000', 'consum', 0.0219, 'lps'),
	(447841, 123, '2015-03-15 00:41:49.000000', 'consum', 0.0212, 'lps'),
	(447842, 123, '2015-03-15 00:41:50.000000', 'consum', 0.0218, 'lps'),
	(447843, 123, '2015-03-15 00:41:51.000000', 'consum', 0.0219, 'lps'),
	(447844, 123, '2015-03-15 00:41:52.000000', 'consum', 0.0233, 'lps'),
	(447845, 123, '2015-03-15 00:41:53.000000', 'consum', 0.0224, 'lps'),
	(447846, 123, '2015-03-15 00:41:54.000000', 'consum', 0.0212, 'lps'),
	(447847, 123, '2015-03-15 00:41:55.000000', 'consum', 0.0229, 'lps'),
	(447848, 123, '2015-03-15 00:41:56.000000', 'consum', 0.0226, 'lps'),
	(447849, 123, '2015-03-15 00:41:57.000000', 'consum', 0.0210, 'lps'),
	(447850, 123, '2015-03-15 00:41:58.000000', 'consum', 0.0211, 'lps'),
	(447851, 123, '2015-03-15 00:41:59.000000', 'consum', 0.0214, 'lps'),
	(447852, 123, '2015-03-15 00:42:00.000000', 'consum', 0.0229, 'lps'),
	(447853, 123, '2015-03-15 00:42:01.000000', 'consum', 0.0223, 'lps'),
	(447854, 123, '2015-03-15 00:42:02.000000', 'consum', 0.0216, 'lps'),
	(447855, 123, '2015-03-15 00:42:03.000000', 'consum', 0.0224, 'lps'),
	(447856, 123, '2015-03-15 00:42:04.000000', 'consum', 0.0217, 'lps'),
	(447857, 123, '2015-03-15 00:42:05.000000', 'consum', 0.0227, 'lps'),
	(447858, 123, '2015-03-15 00:42:06.000000', 'consum', 0.0225, 'lps'),
	(447859, 123, '2015-03-15 00:42:07.000000', 'consum', 0.0213, 'lps'),
	(447860, 123, '2015-03-15 00:42:08.000000', 'consum', 0.0226, 'lps'),
	(447861, 123, '2015-03-15 00:42:09.000000', 'consum', 0.0211, 'lps'),
	(447862, 123, '2015-03-15 00:42:10.000000', 'consum', 0.0214, 'lps'),
	(447863, 123, '2015-03-15 00:42:11.000000', 'consum', 0.0229, 'lps'),
	(447864, 123, '2015-03-15 00:42:12.000000', 'consum', 0.0220, 'lps'),
	(447865, 123, '2015-03-15 00:42:13.000000', 'consum', 0.0229, 'lps'),
	(447866, 123, '2015-03-15 00:42:14.000000', 'consum', 0.0227, 'lps'),
	(447867, 123, '2015-03-15 00:42:15.000000', 'consum', 0.0216, 'lps'),
	(447868, 123, '2015-03-15 00:42:16.000000', 'consum', 0.0211, 'lps'),
	(447869, 123, '2015-03-15 00:42:17.000000', 'consum', 0.0223, 'lps'),
	(447870, 123, '2015-03-15 00:42:18.000000', 'consum', 0.0224, 'lps'),
	(447871, 123, '2015-03-15 00:42:19.000000', 'consum', 0.0217, 'lps'),
	(447872, 123, '2015-03-15 00:42:20.000000', 'consum', 0.0228, 'lps'),
	(447873, 123, '2015-03-15 00:42:21.000000', 'consum', 0.0231, 'lps'),
	(447874, 123, '2015-03-15 00:42:22.000000', 'consum', 0.0212, 'lps'),
	(447875, 123, '2015-03-15 00:42:23.000000', 'consum', 0.0231, 'lps'),
	(447876, 123, '2015-03-15 00:42:24.000000', 'consum', 0.0215, 'lps'),
	(447877, 123, '2015-03-15 00:42:25.000000', 'consum', 0.0221, 'lps'),
	(447878, 123, '2015-03-15 00:42:26.000000', 'consum', 0.0226, 'lps'),
	(447879, 123, '2015-03-15 00:42:27.000000', 'consum', 0.0211, 'lps'),
	(447880, 123, '2015-03-15 00:42:28.000000', 'consum', 0.0213, 'lps'),
	(447881, 123, '2015-03-15 00:42:29.000000', 'consum', 0.0224, 'lps'),
	(447882, 123, '2015-03-15 00:42:30.000000', 'consum', 0.0223, 'lps'),
	(447883, 123, '2015-03-15 00:42:31.000000', 'consum', 0.0211, 'lps'),
	(447884, 123, '2015-03-15 00:42:32.000000', 'consum', 0.0224, 'lps'),
	(447885, 123, '2015-03-15 00:42:33.000000', 'consum', 0.0230, 'lps'),
	(447886, 123, '2015-03-15 00:42:34.000000', 'consum', 0.0220, 'lps'),
	(447887, 123, '2015-03-15 00:42:35.000000', 'consum', 0.0223, 'lps'),
	(447888, 123, '2015-03-15 00:42:36.000000', 'consum', 0.0224, 'lps'),
	(447889, 123, '2015-03-15 00:42:37.000000', 'consum', 0.0216, 'lps'),
	(447890, 123, '2015-03-15 00:42:38.000000', 'consum', 0.0222, 'lps'),
	(447891, 123, '2015-03-15 00:42:39.000000', 'consum', 0.0229, 'lps'),
	(447892, 123, '2015-03-15 00:42:40.000000', 'consum', 0.0223, 'lps'),
	(447893, 123, '2015-03-15 00:42:41.000000', 'consum', 0.0217, 'lps'),
	(447894, 123, '2015-03-15 00:42:42.000000', 'consum', 0.0230, 'lps'),
	(447895, 123, '2015-03-15 00:42:43.000000', 'consum', 0.0217, 'lps'),
	(447896, 123, '2015-03-15 00:42:44.000000', 'consum', 0.0212, 'lps'),
	(447897, 123, '2015-03-15 00:42:45.000000', 'consum', 0.0224, 'lps'),
	(447898, 123, '2015-03-15 00:42:46.000000', 'consum', 0.0224, 'lps'),
	(447899, 123, '2015-03-15 00:42:47.000000', 'consum', 0.0214, 'lps'),
	(447900, 123, '2015-03-15 00:42:48.000000', 'consum', 0.0213, 'lps'),
	(447901, 123, '2015-03-15 00:42:49.000000', 'consum', 0.0212, 'lps'),
	(447902, 123, '2015-03-15 00:42:50.000000', 'consum', 0.0212, 'lps'),
	(447903, 123, '2015-03-15 00:42:51.000000', 'consum', 0.0215, 'lps'),
	(447904, 123, '2015-03-15 00:42:52.000000', 'consum', 0.0229, 'lps'),
	(447905, 123, '2015-03-15 00:42:53.000000', 'consum', 0.0221, 'lps'),
	(447906, 123, '2015-03-15 00:42:54.000000', 'consum', 0.0230, 'lps'),
	(447907, 123, '2015-03-15 00:42:55.000000', 'consum', 0.0230, 'lps'),
	(447908, 123, '2015-03-15 00:42:56.000000', 'consum', 0.0225, 'lps'),
	(447909, 123, '2015-03-15 00:42:57.000000', 'consum', 0.0227, 'lps'),
	(447910, 123, '2015-03-15 00:42:58.000000', 'consum', 0.0226, 'lps'),
	(447911, 123, '2015-03-15 00:42:59.000000', 'consum', 0.0215, 'lps'),
	(447912, 123, '2015-03-15 00:43:00.000000', 'consum', 0.0214, 'lps'),
	(447913, 123, '2015-03-15 00:43:01.000000', 'consum', 0.0212, 'lps'),
	(447914, 123, '2015-03-15 00:43:02.000000', 'consum', 0.0210, 'lps'),
	(447915, 123, '2015-03-15 00:43:03.000000', 'consum', 0.0227, 'lps'),
	(447916, 123, '2015-03-15 00:43:04.000000', 'consum', 0.0227, 'lps'),
	(447917, 123, '2015-03-15 00:43:05.000000', 'consum', 0.0217, 'lps'),
	(447918, 123, '2015-03-15 00:43:06.000000', 'consum', 0.0219, 'lps'),
	(447919, 123, '2015-03-15 00:43:07.000000', 'consum', 0.0212, 'lps'),
	(447920, 123, '2015-03-15 00:43:08.000000', 'consum', 0.0216, 'lps'),
	(447921, 123, '2015-03-15 00:43:09.000000', 'consum', 0.0210, 'lps'),
	(447922, 123, '2015-03-15 00:43:10.000000', 'consum', 0.0217, 'lps'),
	(447923, 123, '2015-03-15 00:43:11.000000', 'consum', 0.0223, 'lps'),
	(447924, 123, '2015-03-15 00:43:12.000000', 'consum', 0.0231, 'lps'),
	(447925, 123, '2015-03-15 00:43:13.000000', 'consum', 0.0228, 'lps'),
	(447926, 123, '2015-03-15 00:43:14.000000', 'consum', 0.0212, 'lps'),
	(447927, 123, '2015-03-15 00:43:15.000000', 'consum', 0.0215, 'lps'),
	(447928, 123, '2015-03-15 00:43:16.000000', 'consum', 0.0230, 'lps'),
	(447929, 123, '2015-03-15 00:43:17.000000', 'consum', 0.0222, 'lps'),
	(447930, 123, '2015-03-15 00:43:18.000000', 'consum', 0.0213, 'lps'),
	(447931, 123, '2015-03-15 00:43:19.000000', 'consum', 0.0214, 'lps'),
	(447932, 123, '2015-03-15 00:43:20.000000', 'consum', 0.0219, 'lps'),
	(447933, 123, '2015-03-15 00:43:21.000000', 'consum', 0.0219, 'lps'),
	(447934, 123, '2015-03-15 00:43:22.000000', 'consum', 0.0231, 'lps'),
	(447935, 123, '2015-03-15 00:43:23.000000', 'consum', 0.0217, 'lps'),
	(447936, 123, '2015-03-15 00:43:24.000000', 'consum', 0.0228, 'lps'),
	(447937, 123, '2015-03-15 00:43:25.000000', 'consum', 0.0232, 'lps'),
	(447938, 123, '2015-03-15 00:43:26.000000', 'consum', 0.0219, 'lps'),
	(447939, 123, '2015-03-15 00:43:27.000000', 'consum', 0.0214, 'lps'),
	(447940, 123, '2015-03-15 00:43:28.000000', 'consum', 0.0227, 'lps'),
	(447941, 123, '2015-03-15 00:43:29.000000', 'consum', 0.0210, 'lps'),
	(447942, 123, '2015-03-15 00:43:30.000000', 'consum', 0.0233, 'lps'),
	(447943, 123, '2015-03-15 00:43:31.000000', 'consum', 0.0228, 'lps'),
	(447944, 123, '2015-03-15 00:43:32.000000', 'consum', 0.0233, 'lps'),
	(447945, 123, '2015-03-15 00:43:33.000000', 'consum', 0.0224, 'lps'),
	(447946, 123, '2015-03-15 00:43:34.000000', 'consum', 0.0212, 'lps'),
	(447947, 123, '2015-03-15 00:43:35.000000', 'consum', 0.0226, 'lps'),
	(447948, 123, '2015-03-15 00:43:36.000000', 'consum', 0.0212, 'lps'),
	(447949, 123, '2015-03-15 00:43:37.000000', 'consum', 0.0222, 'lps'),
	(447950, 123, '2015-03-15 00:43:38.000000', 'consum', 0.0217, 'lps'),
	(447951, 123, '2015-03-15 00:43:39.000000', 'consum', 0.0232, 'lps'),
	(447952, 123, '2015-03-15 00:43:40.000000', 'consum', 0.0226, 'lps'),
	(447953, 123, '2015-03-15 00:43:41.000000', 'consum', 0.0226, 'lps'),
	(447954, 123, '2015-03-15 00:43:42.000000', 'consum', 0.0220, 'lps'),
	(447955, 123, '2015-03-15 00:43:43.000000', 'consum', 0.0211, 'lps'),
	(447956, 123, '2015-03-15 00:43:44.000000', 'consum', 0.0212, 'lps'),
	(447957, 123, '2015-03-15 00:43:45.000000', 'consum', 0.0214, 'lps'),
	(447958, 123, '2015-03-15 00:43:46.000000', 'consum', 0.0227, 'lps'),
	(447959, 123, '2015-03-15 00:43:47.000000', 'consum', 0.0212, 'lps'),
	(447960, 123, '2015-03-15 00:43:48.000000', 'consum', 0.0218, 'lps'),
	(447961, 123, '2015-03-15 00:43:49.000000', 'consum', 0.0220, 'lps'),
	(447962, 123, '2015-03-15 00:43:50.000000', 'consum', 0.0210, 'lps'),
	(447963, 123, '2015-03-15 00:43:51.000000', 'consum', 0.0232, 'lps'),
	(447964, 123, '2015-03-15 00:43:52.000000', 'consum', 0.0224, 'lps'),
	(447965, 123, '2015-03-15 00:43:53.000000', 'consum', 0.0212, 'lps'),
	(447966, 123, '2015-03-15 00:43:54.000000', 'consum', 0.0227, 'lps'),
	(447967, 123, '2015-03-15 00:43:55.000000', 'consum', 0.0218, 'lps'),
	(447968, 123, '2015-03-15 00:43:56.000000', 'consum', 0.0223, 'lps'),
	(447969, 123, '2015-03-15 00:43:57.000000', 'consum', 0.0228, 'lps'),
	(447970, 123, '2015-03-15 00:43:58.000000', 'consum', 0.0215, 'lps'),
	(447971, 123, '2015-03-15 00:43:59.000000', 'consum', 0.0227, 'lps'),
	(447972, 123, '2015-03-15 00:44:00.000000', 'consum', 0.0210, 'lps'),
	(447973, 123, '2015-03-15 00:44:01.000000', 'consum', 0.0230, 'lps'),
	(447974, 123, '2015-03-15 00:44:02.000000', 'consum', 0.0213, 'lps'),
	(447975, 123, '2015-03-15 00:44:03.000000', 'consum', 0.0217, 'lps'),
	(447976, 123, '2015-03-15 00:44:04.000000', 'consum', 0.0212, 'lps'),
	(447977, 123, '2015-03-15 00:44:05.000000', 'consum', 0.0223, 'lps'),
	(447978, 123, '2015-03-15 00:44:06.000000', 'consum', 0.0223, 'lps'),
	(447979, 123, '2015-03-15 00:44:07.000000', 'consum', 0.0212, 'lps'),
	(447980, 123, '2015-03-15 00:44:08.000000', 'consum', 0.0230, 'lps'),
	(447981, 123, '2015-03-15 00:44:09.000000', 'consum', 0.0232, 'lps'),
	(447982, 123, '2015-03-15 00:44:10.000000', 'consum', 0.0213, 'lps'),
	(447983, 123, '2015-03-15 00:44:11.000000', 'consum', 0.0233, 'lps'),
	(447984, 123, '2015-03-15 00:44:12.000000', 'consum', 0.0219, 'lps'),
	(447985, 123, '2015-03-15 00:44:13.000000', 'consum', 0.0211, 'lps'),
	(447986, 123, '2015-03-15 00:44:14.000000', 'consum', 0.0214, 'lps'),
	(447987, 123, '2015-03-15 00:44:15.000000', 'consum', 0.0227, 'lps'),
	(447988, 123, '2015-03-15 00:44:16.000000', 'consum', 0.0233, 'lps'),
	(447989, 123, '2015-03-15 00:44:17.000000', 'consum', 0.0229, 'lps'),
	(447990, 123, '2015-03-15 00:44:18.000000', 'consum', 0.0212, 'lps'),
	(447991, 123, '2015-03-15 00:44:19.000000', 'consum', 0.0210, 'lps'),
	(447992, 123, '2015-03-15 00:44:20.000000', 'consum', 0.0232, 'lps'),
	(447993, 123, '2015-03-15 00:44:21.000000', 'consum', 0.0221, 'lps'),
	(447994, 123, '2015-03-15 00:44:22.000000', 'consum', 0.0224, 'lps'),
	(447995, 123, '2015-03-15 00:44:23.000000', 'consum', 0.0223, 'lps'),
	(447996, 123, '2015-03-15 00:44:24.000000', 'consum', 0.0211, 'lps'),
	(447997, 123, '2015-03-15 00:44:25.000000', 'consum', 0.0224, 'lps'),
	(447998, 123, '2015-03-15 00:44:26.000000', 'consum', 0.0230, 'lps'),
	(447999, 123, '2015-03-15 00:44:27.000000', 'consum', 0.0220, 'lps'),
	(448000, 123, '2015-03-15 00:44:28.000000', 'consum', 0.0223, 'lps'),
	(448001, 123, '2015-03-15 00:44:29.000000', 'consum', 0.0224, 'lps'),
	(448002, 123, '2015-03-15 00:44:30.000000', 'consum', 0.0218, 'lps'),
	(448003, 123, '2015-03-15 00:44:31.000000', 'consum', 0.0231, 'lps'),
	(448004, 123, '2015-03-15 00:44:32.000000', 'consum', 0.0218, 'lps'),
	(448005, 123, '2015-03-15 00:44:33.000000', 'consum', 0.0212, 'lps'),
	(448006, 123, '2015-03-15 00:44:34.000000', 'consum', 0.0222, 'lps'),
	(448007, 123, '2015-03-15 00:44:35.000000', 'consum', 0.0216, 'lps'),
	(448008, 123, '2015-03-15 00:44:36.000000', 'consum', 0.0227, 'lps'),
	(448009, 123, '2015-03-15 00:44:37.000000', 'consum', 0.0231, 'lps'),
	(448010, 123, '2015-03-15 00:44:38.000000', 'consum', 0.0217, 'lps'),
	(448011, 123, '2015-03-15 00:44:39.000000', 'consum', 0.0230, 'lps'),
	(448012, 123, '2015-03-15 00:44:40.000000', 'consum', 0.0218, 'lps'),
	(448013, 123, '2015-03-15 00:44:41.000000', 'consum', 0.0216, 'lps'),
	(448014, 123, '2015-03-15 00:44:42.000000', 'consum', 0.0213, 'lps'),
	(448015, 123, '2015-03-15 00:44:43.000000', 'consum', 0.0233, 'lps'),
	(448016, 123, '2015-03-15 00:44:44.000000', 'consum', 0.0222, 'lps'),
	(448017, 123, '2015-03-15 00:44:45.000000', 'consum', 0.0223, 'lps'),
	(448018, 123, '2015-03-15 00:44:46.000000', 'consum', 0.0215, 'lps'),
	(448019, 123, '2015-03-15 00:44:47.000000', 'consum', 0.0223, 'lps'),
	(448020, 123, '2015-03-15 00:44:48.000000', 'consum', 0.0213, 'lps'),
	(448021, 123, '2015-03-15 00:44:49.000000', 'consum', 0.0232, 'lps'),
	(448022, 123, '2015-03-15 00:44:50.000000', 'consum', 0.0216, 'lps'),
	(448023, 123, '2015-03-15 00:44:51.000000', 'consum', 0.0222, 'lps'),
	(448024, 123, '2015-03-15 00:44:52.000000', 'consum', 0.0231, 'lps'),
	(448025, 123, '2015-03-15 00:44:53.000000', 'consum', 0.0228, 'lps'),
	(448026, 123, '2015-03-15 00:44:54.000000', 'consum', 0.0217, 'lps'),
	(448027, 123, '2015-03-15 00:44:55.000000', 'consum', 0.0214, 'lps'),
	(448028, 123, '2015-03-15 00:44:56.000000', 'consum', 0.0233, 'lps'),
	(448029, 123, '2015-03-15 00:44:57.000000', 'consum', 0.0219, 'lps'),
	(448030, 123, '2015-03-15 00:44:58.000000', 'consum', 0.0210, 'lps'),
	(448031, 123, '2015-03-15 00:44:59.000000', 'consum', 0.0231, 'lps'),
	(448032, 123, '2015-03-15 00:45:00.000000', 'consum', 0.0220, 'lps'),
	(448033, 123, '2015-03-15 00:45:01.000000', 'consum', 0.0219, 'lps'),
	(448034, 123, '2015-03-15 00:45:02.000000', 'consum', 0.0229, 'lps'),
	(448035, 123, '2015-03-15 00:45:03.000000', 'consum', 0.0229, 'lps'),
	(448036, 123, '2015-03-15 00:45:04.000000', 'consum', 0.0225, 'lps'),
	(448037, 123, '2015-03-15 00:45:05.000000', 'consum', 0.0227, 'lps'),
	(448038, 123, '2015-03-15 00:45:06.000000', 'consum', 0.0229, 'lps'),
	(448039, 123, '2015-03-15 00:45:07.000000', 'consum', 0.0228, 'lps'),
	(448040, 123, '2015-03-15 00:45:08.000000', 'consum', 0.0220, 'lps'),
	(448041, 123, '2015-03-15 00:45:09.000000', 'consum', 0.0230, 'lps'),
	(448042, 123, '2015-03-15 00:45:10.000000', 'consum', 0.0233, 'lps'),
	(448043, 123, '2015-03-15 00:45:11.000000', 'consum', 0.0216, 'lps'),
	(448044, 123, '2015-03-15 00:45:12.000000', 'consum', 0.0222, 'lps'),
	(448045, 123, '2015-03-15 00:45:13.000000', 'consum', 0.0226, 'lps'),
	(448046, 123, '2015-03-15 00:45:14.000000', 'consum', 0.0231, 'lps'),
	(448047, 123, '2015-03-15 00:45:15.000000', 'consum', 0.0221, 'lps'),
	(448048, 123, '2015-03-15 00:45:16.000000', 'consum', 0.0227, 'lps'),
	(448049, 123, '2015-03-15 00:45:17.000000', 'consum', 0.0212, 'lps'),
	(448050, 123, '2015-03-15 00:45:18.000000', 'consum', 0.0219, 'lps'),
	(448051, 123, '2015-03-15 00:45:19.000000', 'consum', 0.0224, 'lps'),
	(448052, 123, '2015-03-15 00:45:20.000000', 'consum', 0.0231, 'lps'),
	(448053, 123, '2015-03-15 00:45:21.000000', 'consum', 0.0225, 'lps'),
	(448054, 123, '2015-03-15 00:45:22.000000', 'consum', 0.0223, 'lps'),
	(448055, 123, '2015-03-15 00:45:23.000000', 'consum', 0.0231, 'lps'),
	(448056, 123, '2015-03-15 00:45:24.000000', 'consum', 0.0226, 'lps'),
	(448057, 123, '2015-03-15 00:45:25.000000', 'consum', 0.0231, 'lps'),
	(448058, 123, '2015-03-15 00:45:26.000000', 'consum', 0.0217, 'lps'),
	(448059, 123, '2015-03-15 00:45:27.000000', 'consum', 0.0231, 'lps'),
	(448060, 123, '2015-03-15 00:45:28.000000', 'consum', 0.0224, 'lps'),
	(448061, 123, '2015-03-15 00:45:29.000000', 'consum', 0.0217, 'lps'),
	(448062, 123, '2015-03-15 00:45:30.000000', 'consum', 0.0229, 'lps'),
	(448063, 123, '2015-03-15 00:45:31.000000', 'consum', 0.0211, 'lps'),
	(448064, 123, '2015-03-15 00:45:32.000000', 'consum', 0.0230, 'lps'),
	(448065, 123, '2015-03-15 00:45:33.000000', 'consum', 0.0213, 'lps'),
	(448066, 123, '2015-03-15 00:45:34.000000', 'consum', 0.0214, 'lps'),
	(448067, 123, '2015-03-15 00:45:35.000000', 'consum', 0.0221, 'lps'),
	(448068, 123, '2015-03-15 00:45:36.000000', 'consum', 0.0231, 'lps'),
	(448069, 123, '2015-03-15 00:45:37.000000', 'consum', 0.0210, 'lps'),
	(448070, 123, '2015-03-15 00:45:38.000000', 'consum', 0.0219, 'lps'),
	(448071, 123, '2015-03-15 00:45:39.000000', 'consum', 0.0231, 'lps'),
	(448072, 123, '2015-03-15 00:45:40.000000', 'consum', 0.0216, 'lps'),
	(448073, 123, '2015-03-15 00:45:41.000000', 'consum', 0.0226, 'lps'),
	(448074, 123, '2015-03-15 00:45:42.000000', 'consum', 0.0226, 'lps'),
	(448075, 123, '2015-03-15 00:45:43.000000', 'consum', 0.0215, 'lps'),
	(448076, 123, '2015-03-15 00:45:44.000000', 'consum', 0.0215, 'lps'),
	(448077, 123, '2015-03-15 00:45:45.000000', 'consum', 0.0220, 'lps'),
	(448078, 123, '2015-03-15 00:45:46.000000', 'consum', 0.0221, 'lps'),
	(448079, 123, '2015-03-15 00:45:47.000000', 'consum', 0.0212, 'lps'),
	(448080, 123, '2015-03-15 00:45:48.000000', 'consum', 0.0211, 'lps'),
	(448081, 123, '2015-03-15 00:45:49.000000', 'consum', 0.0233, 'lps'),
	(448082, 123, '2015-03-15 00:45:50.000000', 'consum', 0.0226, 'lps'),
	(448083, 123, '2015-03-15 00:45:51.000000', 'consum', 0.0223, 'lps'),
	(448084, 123, '2015-03-15 00:45:52.000000', 'consum', 0.0227, 'lps'),
	(448085, 123, '2015-03-15 00:45:53.000000', 'consum', 0.0232, 'lps'),
	(448086, 123, '2015-03-15 00:45:54.000000', 'consum', 0.0220, 'lps'),
	(448087, 123, '2015-03-15 00:45:55.000000', 'consum', 0.0220, 'lps'),
	(448088, 123, '2015-03-15 00:45:56.000000', 'consum', 0.0230, 'lps'),
	(448089, 123, '2015-03-15 00:45:57.000000', 'consum', 0.0232, 'lps'),
	(448090, 123, '2015-03-15 00:45:58.000000', 'consum', 0.0212, 'lps'),
	(448091, 123, '2015-03-15 00:45:59.000000', 'consum', 0.0226, 'lps'),
	(448092, 123, '2015-03-15 00:46:00.000000', 'consum', 0.0215, 'lps'),
	(448093, 123, '2015-03-15 00:46:01.000000', 'consum', 0.0212, 'lps'),
	(448094, 123, '2015-03-15 00:46:02.000000', 'consum', 0.0228, 'lps'),
	(448095, 123, '2015-03-15 00:46:03.000000', 'consum', 0.0223, 'lps'),
	(448096, 123, '2015-03-15 00:46:04.000000', 'consum', 0.0223, 'lps'),
	(448097, 123, '2015-03-15 00:46:05.000000', 'consum', 0.0211, 'lps'),
	(448098, 123, '2015-03-15 00:46:06.000000', 'consum', 0.0225, 'lps'),
	(448099, 123, '2015-03-15 00:46:07.000000', 'consum', 0.0210, 'lps'),
	(448100, 123, '2015-03-15 00:46:08.000000', 'consum', 0.0215, 'lps'),
	(448101, 123, '2015-03-15 00:46:09.000000', 'consum', 0.0212, 'lps'),
	(448102, 123, '2015-03-15 00:46:10.000000', 'consum', 0.0230, 'lps'),
	(448103, 123, '2015-03-15 00:46:11.000000', 'consum', 0.0231, 'lps'),
	(448104, 123, '2015-03-15 00:46:12.000000', 'consum', 0.0231, 'lps'),
	(448105, 123, '2015-03-15 00:46:13.000000', 'consum', 0.0228, 'lps'),
	(448106, 123, '2015-03-15 00:46:14.000000', 'consum', 0.0214, 'lps'),
	(448107, 123, '2015-03-15 00:46:15.000000', 'consum', 0.0223, 'lps'),
	(448108, 123, '2015-03-15 00:46:16.000000', 'consum', 0.0217, 'lps'),
	(448109, 123, '2015-03-15 00:46:17.000000', 'consum', 0.0228, 'lps'),
	(448110, 123, '2015-03-15 00:46:18.000000', 'consum', 0.0211, 'lps'),
	(448111, 123, '2015-03-15 00:46:19.000000', 'consum', 0.0230, 'lps'),
	(448112, 123, '2015-03-15 00:46:20.000000', 'consum', 0.0214, 'lps'),
	(448113, 123, '2015-03-15 00:46:21.000000', 'consum', 0.0218, 'lps'),
	(448114, 123, '2015-03-15 00:46:22.000000', 'consum', 0.0216, 'lps'),
	(448115, 123, '2015-03-15 00:46:23.000000', 'consum', 0.0217, 'lps'),
	(448116, 123, '2015-03-15 00:46:24.000000', 'consum', 0.0228, 'lps'),
	(448117, 123, '2015-03-15 00:46:25.000000', 'consum', 0.0229, 'lps'),
	(448118, 123, '2015-03-15 00:46:26.000000', 'consum', 0.0229, 'lps'),
	(448119, 123, '2015-03-15 00:46:27.000000', 'consum', 0.0226, 'lps'),
	(448120, 123, '2015-03-15 00:46:28.000000', 'consum', 0.0233, 'lps'),
	(448121, 123, '2015-03-15 00:46:29.000000', 'consum', 0.0228, 'lps'),
	(448122, 123, '2015-03-15 00:46:30.000000', 'consum', 0.0233, 'lps'),
	(448123, 123, '2015-03-15 00:46:31.000000', 'consum', 0.0222, 'lps'),
	(448124, 123, '2015-03-15 00:46:32.000000', 'consum', 0.0225, 'lps'),
	(448125, 123, '2015-03-15 00:46:33.000000', 'consum', 0.0226, 'lps'),
	(448126, 123, '2015-03-15 00:46:34.000000', 'consum', 0.0223, 'lps'),
	(448127, 123, '2015-03-15 00:46:35.000000', 'consum', 0.0226, 'lps'),
	(448128, 123, '2015-03-15 00:46:36.000000', 'consum', 0.0227, 'lps'),
	(448129, 123, '2015-03-15 00:46:37.000000', 'consum', 0.0222, 'lps'),
	(448130, 123, '2015-03-15 00:46:38.000000', 'consum', 0.0222, 'lps'),
	(448131, 123, '2015-03-15 00:46:39.000000', 'consum', 0.0233, 'lps'),
	(448132, 123, '2015-03-15 00:46:40.000000', 'consum', 0.0217, 'lps'),
	(448133, 123, '2015-03-15 00:46:41.000000', 'consum', 0.0227, 'lps'),
	(448134, 123, '2015-03-15 00:46:42.000000', 'consum', 0.0223, 'lps'),
	(448135, 123, '2015-03-15 00:46:43.000000', 'consum', 0.0228, 'lps'),
	(448136, 123, '2015-03-15 00:46:44.000000', 'consum', 0.0213, 'lps'),
	(448137, 123, '2015-03-15 00:46:45.000000', 'consum', 0.0219, 'lps'),
	(448138, 123, '2015-03-15 00:46:46.000000', 'consum', 0.0223, 'lps'),
	(448139, 123, '2015-03-15 00:46:47.000000', 'consum', 0.0225, 'lps'),
	(448140, 123, '2015-03-15 00:46:48.000000', 'consum', 0.0224, 'lps'),
	(448141, 123, '2015-03-15 00:46:49.000000', 'consum', 0.0233, 'lps'),
	(448142, 123, '2015-03-15 00:46:50.000000', 'consum', 0.0213, 'lps'),
	(448143, 123, '2015-03-15 00:46:51.000000', 'consum', 0.0227, 'lps'),
	(448144, 123, '2015-03-15 00:46:52.000000', 'consum', 0.0213, 'lps'),
	(448145, 123, '2015-03-15 00:46:53.000000', 'consum', 0.0225, 'lps'),
	(448146, 123, '2015-03-15 00:46:54.000000', 'consum', 0.0227, 'lps'),
	(448147, 123, '2015-03-15 00:46:55.000000', 'consum', 0.0229, 'lps'),
	(448148, 123, '2015-03-15 00:46:56.000000', 'consum', 0.0229, 'lps'),
	(448149, 123, '2015-03-15 00:46:57.000000', 'consum', 0.0225, 'lps'),
	(448150, 123, '2015-03-15 00:46:58.000000', 'consum', 0.0229, 'lps'),
	(448151, 123, '2015-03-15 00:46:59.000000', 'consum', 0.0212, 'lps'),
	(448152, 123, '2015-03-15 00:47:00.000000', 'consum', 0.0211, 'lps'),
	(448153, 123, '2015-03-15 00:47:01.000000', 'consum', 0.0210, 'lps'),
	(448154, 123, '2015-03-15 00:47:02.000000', 'consum', 0.0231, 'lps'),
	(448155, 123, '2015-03-15 00:47:03.000000', 'consum', 0.0220, 'lps'),
	(448156, 123, '2015-03-15 00:47:04.000000', 'consum', 0.0223, 'lps'),
	(448157, 123, '2015-03-15 00:47:05.000000', 'consum', 0.0221, 'lps'),
	(448158, 123, '2015-03-15 00:47:06.000000', 'consum', 0.0228, 'lps'),
	(448159, 123, '2015-03-15 00:47:07.000000', 'consum', 0.0218, 'lps'),
	(448160, 123, '2015-03-15 00:47:08.000000', 'consum', 0.0222, 'lps'),
	(448161, 123, '2015-03-15 00:47:09.000000', 'consum', 0.0224, 'lps'),
	(448162, 123, '2015-03-15 00:47:10.000000', 'consum', 0.0217, 'lps'),
	(448163, 123, '2015-03-15 00:47:11.000000', 'consum', 0.0230, 'lps'),
	(448164, 123, '2015-03-15 00:47:12.000000', 'consum', 0.0215, 'lps'),
	(448165, 123, '2015-03-15 00:47:13.000000', 'consum', 0.0224, 'lps'),
	(448166, 123, '2015-03-15 00:47:14.000000', 'consum', 0.0217, 'lps'),
	(448167, 123, '2015-03-15 00:47:15.000000', 'consum', 0.0229, 'lps'),
	(448168, 123, '2015-03-15 00:47:16.000000', 'consum', 0.0212, 'lps'),
	(448169, 123, '2015-03-15 00:47:17.000000', 'consum', 0.0210, 'lps'),
	(448170, 123, '2015-03-15 00:47:18.000000', 'consum', 0.0229, 'lps'),
	(448171, 123, '2015-03-15 00:47:19.000000', 'consum', 0.0210, 'lps'),
	(448172, 123, '2015-03-15 00:47:20.000000', 'consum', 0.0225, 'lps'),
	(448173, 123, '2015-03-15 00:47:21.000000', 'consum', 0.0214, 'lps'),
	(448174, 123, '2015-03-15 00:47:22.000000', 'consum', 0.0210, 'lps'),
	(448175, 123, '2015-03-15 00:47:23.000000', 'consum', 0.0220, 'lps'),
	(448176, 123, '2015-03-15 00:47:24.000000', 'consum', 0.0215, 'lps'),
	(448177, 123, '2015-03-15 00:47:25.000000', 'consum', 0.0227, 'lps'),
	(448178, 123, '2015-03-15 00:47:26.000000', 'consum', 0.0211, 'lps'),
	(448179, 123, '2015-03-15 00:47:27.000000', 'consum', 0.0210, 'lps'),
	(448180, 123, '2015-03-15 00:47:28.000000', 'consum', 0.0233, 'lps'),
	(448181, 123, '2015-03-15 00:47:29.000000', 'consum', 0.0229, 'lps'),
	(448182, 123, '2015-03-15 00:47:30.000000', 'consum', 0.0214, 'lps'),
	(448183, 123, '2015-03-15 00:47:31.000000', 'consum', 0.0221, 'lps'),
	(448184, 123, '2015-03-15 00:47:32.000000', 'consum', 0.0231, 'lps'),
	(448185, 123, '2015-03-15 00:47:33.000000', 'consum', 0.0232, 'lps'),
	(448186, 123, '2015-03-15 00:47:34.000000', 'consum', 0.0233, 'lps'),
	(448187, 123, '2015-03-15 00:47:35.000000', 'consum', 0.0213, 'lps'),
	(448188, 123, '2015-03-15 00:47:36.000000', 'consum', 0.0228, 'lps'),
	(448189, 123, '2015-03-15 00:47:37.000000', 'consum', 0.0222, 'lps'),
	(448190, 123, '2015-03-15 00:47:38.000000', 'consum', 0.0213, 'lps'),
	(448191, 123, '2015-03-15 00:47:39.000000', 'consum', 0.0215, 'lps'),
	(448192, 123, '2015-03-15 00:47:40.000000', 'consum', 0.0228, 'lps'),
	(448193, 123, '2015-03-15 00:47:41.000000', 'consum', 0.0211, 'lps'),
	(448194, 123, '2015-03-15 00:47:42.000000', 'consum', 0.0212, 'lps'),
	(448195, 123, '2015-03-15 00:47:43.000000', 'consum', 0.0218, 'lps'),
	(448196, 123, '2015-03-15 00:47:44.000000', 'consum', 0.0222, 'lps'),
	(448197, 123, '2015-03-15 00:47:45.000000', 'consum', 0.0219, 'lps'),
	(448198, 123, '2015-03-15 00:47:46.000000', 'consum', 0.0219, 'lps'),
	(448199, 123, '2015-03-15 00:47:47.000000', 'consum', 0.0230, 'lps'),
	(448200, 123, '2015-03-15 00:47:48.000000', 'consum', 0.0212, 'lps'),
	(448201, 123, '2015-03-15 00:47:49.000000', 'consum', 0.0233, 'lps'),
	(448202, 123, '2015-03-15 00:47:50.000000', 'consum', 0.0224, 'lps'),
	(448203, 123, '2015-03-15 00:47:51.000000', 'consum', 0.0210, 'lps'),
	(448204, 123, '2015-03-15 00:47:52.000000', 'consum', 0.0217, 'lps'),
	(448205, 123, '2015-03-15 00:47:53.000000', 'consum', 0.0222, 'lps'),
	(448206, 123, '2015-03-15 00:47:54.000000', 'consum', 0.0226, 'lps'),
	(448207, 123, '2015-03-15 00:47:55.000000', 'consum', 0.0228, 'lps'),
	(448208, 123, '2015-03-15 00:47:56.000000', 'consum', 0.0229, 'lps'),
	(448209, 123, '2015-03-15 00:47:57.000000', 'consum', 0.0230, 'lps'),
	(448210, 123, '2015-03-15 00:47:58.000000', 'consum', 0.0227, 'lps'),
	(448211, 123, '2015-03-15 00:47:59.000000', 'consum', 0.0212, 'lps'),
	(448212, 123, '2015-03-15 00:48:00.000000', 'consum', 0.0219, 'lps'),
	(448213, 123, '2015-03-15 00:48:01.000000', 'consum', 0.0224, 'lps'),
	(448214, 123, '2015-03-15 00:48:02.000000', 'consum', 0.0230, 'lps'),
	(448215, 123, '2015-03-15 00:48:03.000000', 'consum', 0.0220, 'lps'),
	(448216, 123, '2015-03-15 00:48:04.000000', 'consum', 0.0226, 'lps'),
	(448217, 123, '2015-03-15 00:48:05.000000', 'consum', 0.0210, 'lps'),
	(448218, 123, '2015-03-15 00:48:06.000000', 'consum', 0.0211, 'lps'),
	(448219, 123, '2015-03-15 00:48:07.000000', 'consum', 0.0216, 'lps'),
	(448220, 123, '2015-03-15 00:48:08.000000', 'consum', 0.0215, 'lps'),
	(448221, 123, '2015-03-15 00:48:09.000000', 'consum', 0.0216, 'lps'),
	(448222, 123, '2015-03-15 00:48:10.000000', 'consum', 0.0224, 'lps'),
	(448223, 123, '2015-03-15 00:48:11.000000', 'consum', 0.0215, 'lps'),
	(448224, 123, '2015-03-15 00:48:12.000000', 'consum', 0.0219, 'lps'),
	(448225, 123, '2015-03-15 00:48:13.000000', 'consum', 0.0214, 'lps'),
	(448226, 123, '2015-03-15 00:48:14.000000', 'consum', 0.0230, 'lps'),
	(448227, 123, '2015-03-15 00:48:15.000000', 'consum', 0.0225, 'lps'),
	(448228, 123, '2015-03-15 00:48:16.000000', 'consum', 0.0226, 'lps'),
	(448229, 123, '2015-03-15 00:48:17.000000', 'consum', 0.0221, 'lps'),
	(448230, 123, '2015-03-15 00:48:18.000000', 'consum', 0.0219, 'lps'),
	(448231, 123, '2015-03-15 00:48:19.000000', 'consum', 0.0222, 'lps'),
	(448232, 123, '2015-03-15 00:48:20.000000', 'consum', 0.0217, 'lps'),
	(448233, 123, '2015-03-15 00:48:21.000000', 'consum', 0.0212, 'lps'),
	(448234, 123, '2015-03-15 00:48:22.000000', 'consum', 0.0223, 'lps'),
	(448235, 123, '2015-03-15 00:48:23.000000', 'consum', 0.0220, 'lps'),
	(448236, 123, '2015-03-15 00:48:24.000000', 'consum', 0.0223, 'lps'),
	(448237, 123, '2015-03-15 00:48:25.000000', 'consum', 0.0223, 'lps'),
	(448238, 123, '2015-03-15 00:48:26.000000', 'consum', 0.0233, 'lps'),
	(448239, 123, '2015-03-15 00:48:27.000000', 'consum', 0.0218, 'lps'),
	(448240, 123, '2015-03-15 00:48:28.000000', 'consum', 0.0227, 'lps'),
	(448241, 123, '2015-03-15 00:48:29.000000', 'consum', 0.0225, 'lps'),
	(448242, 123, '2015-03-15 00:48:30.000000', 'consum', 0.0210, 'lps'),
	(448243, 123, '2015-03-15 00:48:31.000000', 'consum', 0.0214, 'lps'),
	(448244, 123, '2015-03-15 00:48:32.000000', 'consum', 0.0229, 'lps'),
	(448245, 123, '2015-03-15 00:48:33.000000', 'consum', 0.0222, 'lps'),
	(448246, 123, '2015-03-15 00:48:34.000000', 'consum', 0.0213, 'lps'),
	(448247, 123, '2015-03-15 00:48:35.000000', 'consum', 0.0213, 'lps'),
	(448248, 123, '2015-03-15 00:48:36.000000', 'consum', 0.0218, 'lps'),
	(448249, 123, '2015-03-15 00:48:37.000000', 'consum', 0.0217, 'lps'),
	(448250, 123, '2015-03-15 00:48:38.000000', 'consum', 0.0223, 'lps'),
	(448251, 123, '2015-03-15 00:48:39.000000', 'consum', 0.0228, 'lps'),
	(448252, 123, '2015-03-15 00:48:40.000000', 'consum', 0.0215, 'lps'),
	(448253, 123, '2015-03-15 00:48:41.000000', 'consum', 0.0228, 'lps'),
	(448254, 123, '2015-03-15 00:48:42.000000', 'consum', 0.0212, 'lps'),
	(448255, 123, '2015-03-15 00:48:43.000000', 'consum', 0.0217, 'lps'),
	(448256, 123, '2015-03-15 00:48:44.000000', 'consum', 0.0216, 'lps'),
	(448257, 123, '2015-03-15 00:48:45.000000', 'consum', 0.0217, 'lps'),
	(448258, 123, '2015-03-15 00:48:46.000000', 'consum', 0.0229, 'lps'),
	(448259, 123, '2015-03-15 00:48:47.000000', 'consum', 0.0214, 'lps'),
	(448260, 123, '2015-03-15 00:48:48.000000', 'consum', 0.0221, 'lps'),
	(448261, 123, '2015-03-15 00:48:49.000000', 'consum', 0.0229, 'lps'),
	(448262, 123, '2015-03-15 00:48:50.000000', 'consum', 0.0223, 'lps'),
	(448263, 123, '2015-03-15 00:48:51.000000', 'consum', 0.0218, 'lps'),
	(448264, 123, '2015-03-15 00:48:52.000000', 'consum', 0.0214, 'lps'),
	(448265, 123, '2015-03-15 00:48:53.000000', 'consum', 0.0230, 'lps'),
	(448266, 123, '2015-03-15 00:48:54.000000', 'consum', 0.0224, 'lps'),
	(448267, 123, '2015-03-15 00:48:55.000000', 'consum', 0.0222, 'lps'),
	(448268, 123, '2015-03-15 00:48:56.000000', 'consum', 0.0230, 'lps'),
	(448269, 123, '2015-03-15 00:48:57.000000', 'consum', 0.0226, 'lps'),
	(448270, 123, '2015-03-15 00:48:58.000000', 'consum', 0.0229, 'lps'),
	(448271, 123, '2015-03-15 00:48:59.000000', 'consum', 0.0233, 'lps'),
	(448272, 123, '2015-03-15 00:49:00.000000', 'consum', 0.0223, 'lps'),
	(448273, 123, '2015-03-15 00:49:01.000000', 'consum', 0.0230, 'lps'),
	(448274, 123, '2015-03-15 00:49:02.000000', 'consum', 0.0222, 'lps'),
	(448275, 123, '2015-03-15 00:49:03.000000', 'consum', 0.0211, 'lps'),
	(448276, 123, '2015-03-15 00:49:04.000000', 'consum', 0.0227, 'lps'),
	(448277, 123, '2015-03-15 00:49:05.000000', 'consum', 0.0219, 'lps'),
	(448278, 123, '2015-03-15 00:49:06.000000', 'consum', 0.0232, 'lps'),
	(448279, 123, '2015-03-15 00:49:07.000000', 'consum', 0.0219, 'lps'),
	(448280, 123, '2015-03-15 00:49:08.000000', 'consum', 0.0216, 'lps'),
	(448281, 123, '2015-03-15 00:49:09.000000', 'consum', 0.0211, 'lps'),
	(448282, 123, '2015-03-15 00:49:10.000000', 'consum', 0.0223, 'lps'),
	(448283, 123, '2015-03-15 00:49:11.000000', 'consum', 0.0223, 'lps'),
	(448284, 123, '2015-03-15 00:49:12.000000', 'consum', 0.0212, 'lps'),
	(448285, 123, '2015-03-15 00:49:13.000000', 'consum', 0.0230, 'lps'),
	(448286, 123, '2015-03-15 00:49:14.000000', 'consum', 0.0211, 'lps'),
	(448287, 123, '2015-03-15 00:49:15.000000', 'consum', 0.0224, 'lps'),
	(448288, 123, '2015-03-15 00:49:16.000000', 'consum', 0.0231, 'lps'),
	(448289, 123, '2015-03-15 00:49:17.000000', 'consum', 0.0228, 'lps'),
	(448290, 123, '2015-03-15 00:49:18.000000', 'consum', 0.0210, 'lps'),
	(448291, 123, '2015-03-15 00:49:19.000000', 'consum', 0.0228, 'lps'),
	(448292, 123, '2015-03-15 00:49:20.000000', 'consum', 0.0231, 'lps'),
	(448293, 123, '2015-03-15 00:49:21.000000', 'consum', 0.0212, 'lps'),
	(448294, 123, '2015-03-15 00:49:22.000000', 'consum', 0.0232, 'lps'),
	(448295, 123, '2015-03-15 00:49:23.000000', 'consum', 0.0216, 'lps'),
	(448296, 123, '2015-03-15 00:49:24.000000', 'consum', 0.0223, 'lps'),
	(448297, 123, '2015-03-15 00:49:25.000000', 'consum', 0.0211, 'lps'),
	(448298, 123, '2015-03-15 00:49:26.000000', 'consum', 0.0224, 'lps'),
	(448299, 123, '2015-03-15 00:49:27.000000', 'consum', 0.0231, 'lps'),
	(448300, 123, '2015-03-15 00:49:28.000000', 'consum', 0.0226, 'lps'),
	(448301, 123, '2015-03-15 00:49:29.000000', 'consum', 0.0224, 'lps'),
	(448302, 123, '2015-03-15 00:49:30.000000', 'consum', 0.0212, 'lps'),
	(448303, 123, '2015-03-15 00:49:31.000000', 'consum', 0.0226, 'lps'),
	(448304, 123, '2015-03-15 00:49:32.000000', 'consum', 0.0213, 'lps'),
	(448305, 123, '2015-03-15 00:49:33.000000', 'consum', 0.0223, 'lps'),
	(448306, 123, '2015-03-15 00:49:34.000000', 'consum', 0.0218, 'lps'),
	(448307, 123, '2015-03-15 00:49:35.000000', 'consum', 0.0214, 'lps'),
	(448308, 123, '2015-03-15 00:49:36.000000', 'consum', 0.0228, 'lps'),
	(448309, 123, '2015-03-15 00:49:37.000000', 'consum', 0.0219, 'lps'),
	(448310, 123, '2015-03-15 00:49:38.000000', 'consum', 0.0224, 'lps'),
	(448311, 123, '2015-03-15 00:49:39.000000', 'consum', 0.0229, 'lps'),
	(448312, 123, '2015-03-15 00:49:40.000000', 'consum', 0.0215, 'lps'),
	(448313, 123, '2015-03-15 00:49:41.000000', 'consum', 0.0227, 'lps'),
	(448314, 123, '2015-03-15 00:49:42.000000', 'consum', 0.0211, 'lps'),
	(448315, 123, '2015-03-15 00:49:43.000000', 'consum', 0.0233, 'lps'),
	(448316, 123, '2015-03-15 00:49:44.000000', 'consum', 0.0229, 'lps'),
	(448317, 123, '2015-03-15 00:49:45.000000', 'consum', 0.0212, 'lps'),
	(448318, 123, '2015-03-15 00:49:46.000000', 'consum', 0.0233, 'lps'),
	(448319, 123, '2015-03-15 00:49:47.000000', 'consum', 0.0227, 'lps'),
	(448320, 123, '2015-03-15 00:49:48.000000', 'consum', 0.0223, 'lps'),
	(448321, 123, '2015-03-15 00:49:49.000000', 'consum', 0.0226, 'lps'),
	(448322, 123, '2015-03-15 00:49:50.000000', 'consum', 0.0229, 'lps'),
	(448323, 123, '2015-03-15 00:49:51.000000', 'consum', 0.0231, 'lps'),
	(448324, 123, '2015-03-15 00:49:52.000000', 'consum', 0.0211, 'lps'),
	(448325, 123, '2015-03-15 00:49:53.000000', 'consum', 0.0223, 'lps'),
	(448326, 123, '2015-03-15 00:49:54.000000', 'consum', 0.0227, 'lps'),
	(448327, 123, '2015-03-15 00:49:55.000000', 'consum', 0.0230, 'lps'),
	(448328, 123, '2015-03-15 00:49:56.000000', 'consum', 0.0212, 'lps'),
	(448329, 123, '2015-03-15 00:49:57.000000', 'consum', 0.0233, 'lps'),
	(448330, 123, '2015-03-15 00:49:58.000000', 'consum', 0.0224, 'lps'),
	(448331, 123, '2015-03-15 00:49:59.000000', 'consum', 0.0211, 'lps'),
	(448332, 123, '2015-03-15 00:50:00.000000', 'consum', 0.0220, 'lps'),
	(448333, 123, '2015-03-15 00:50:01.000000', 'consum', 0.0233, 'lps'),
	(448334, 123, '2015-03-15 00:50:02.000000', 'consum', 0.0226, 'lps'),
	(448335, 123, '2015-03-15 00:50:03.000000', 'consum', 0.0219, 'lps'),
	(448336, 123, '2015-03-15 00:50:04.000000', 'consum', 0.0231, 'lps'),
	(448337, 123, '2015-03-15 00:50:05.000000', 'consum', 0.0216, 'lps'),
	(448338, 123, '2015-03-15 00:50:06.000000', 'consum', 0.0226, 'lps'),
	(448339, 123, '2015-03-15 00:50:07.000000', 'consum', 0.0224, 'lps'),
	(448340, 123, '2015-03-15 00:50:08.000000', 'consum', 0.0210, 'lps'),
	(448341, 123, '2015-03-15 00:50:09.000000', 'consum', 0.0215, 'lps'),
	(448342, 123, '2015-03-15 00:50:10.000000', 'consum', 0.0214, 'lps'),
	(448343, 123, '2015-03-15 00:50:11.000000', 'consum', 0.0214, 'lps'),
	(448344, 123, '2015-03-15 00:50:12.000000', 'consum', 0.0220, 'lps'),
	(448345, 123, '2015-03-15 00:50:13.000000', 'consum', 0.0223, 'lps'),
	(448346, 123, '2015-03-15 00:50:14.000000', 'consum', 0.0223, 'lps'),
	(448347, 123, '2015-03-15 00:50:15.000000', 'consum', 0.0212, 'lps'),
	(448348, 123, '2015-03-15 00:50:16.000000', 'consum', 0.0228, 'lps'),
	(448349, 123, '2015-03-15 00:50:17.000000', 'consum', 0.0224, 'lps'),
	(448350, 123, '2015-03-15 00:50:18.000000', 'consum', 0.0227, 'lps'),
	(448351, 123, '2015-03-15 00:50:19.000000', 'consum', 0.0228, 'lps'),
	(448352, 123, '2015-03-15 00:50:20.000000', 'consum', 0.0228, 'lps'),
	(448353, 123, '2015-03-15 00:50:21.000000', 'consum', 0.0221, 'lps'),
	(448354, 123, '2015-03-15 00:50:22.000000', 'consum', 0.0213, 'lps'),
	(448355, 123, '2015-03-15 00:50:23.000000', 'consum', 0.0215, 'lps'),
	(448356, 123, '2015-03-15 00:50:24.000000', 'consum', 0.0228, 'lps'),
	(448357, 123, '2015-03-15 00:50:25.000000', 'consum', 0.0215, 'lps'),
	(448358, 123, '2015-03-15 00:50:26.000000', 'consum', 0.0227, 'lps'),
	(448359, 123, '2015-03-15 00:50:27.000000', 'consum', 0.0233, 'lps'),
	(448360, 123, '2015-03-15 00:50:28.000000', 'consum', 0.0229, 'lps'),
	(448361, 123, '2015-03-15 00:50:29.000000', 'consum', 0.0233, 'lps'),
	(448362, 123, '2015-03-15 00:50:30.000000', 'consum', 0.0221, 'lps'),
	(448363, 123, '2015-03-15 00:50:31.000000', 'consum', 0.0220, 'lps'),
	(448364, 123, '2015-03-15 00:50:32.000000', 'consum', 0.0226, 'lps'),
	(448365, 123, '2015-03-15 00:50:33.000000', 'consum', 0.0215, 'lps'),
	(448366, 123, '2015-03-15 00:50:34.000000', 'consum', 0.0211, 'lps'),
	(448367, 123, '2015-03-15 00:50:35.000000', 'consum', 0.0223, 'lps'),
	(448368, 123, '2015-03-15 00:50:36.000000', 'consum', 0.0224, 'lps'),
	(448369, 123, '2015-03-15 00:50:37.000000', 'consum', 0.0219, 'lps'),
	(448370, 123, '2015-03-15 00:50:38.000000', 'consum', 0.0214, 'lps'),
	(448371, 123, '2015-03-15 00:50:39.000000', 'consum', 0.0226, 'lps'),
	(448372, 123, '2015-03-15 00:50:40.000000', 'consum', 0.0233, 'lps'),
	(448373, 123, '2015-03-15 00:50:41.000000', 'consum', 0.0228, 'lps'),
	(448374, 123, '2015-03-15 00:50:42.000000', 'consum', 0.0233, 'lps'),
	(448375, 123, '2015-03-15 00:50:43.000000', 'consum', 0.0223, 'lps'),
	(448376, 123, '2015-03-15 00:50:44.000000', 'consum', 0.0230, 'lps'),
	(448377, 123, '2015-03-15 00:50:45.000000', 'consum', 0.0223, 'lps'),
	(448378, 123, '2015-03-15 00:50:46.000000', 'consum', 0.0215, 'lps'),
	(448379, 123, '2015-03-15 00:50:47.000000', 'consum', 0.0220, 'lps'),
	(448380, 123, '2015-03-15 00:50:48.000000', 'consum', 0.0222, 'lps'),
	(448381, 123, '2015-03-15 00:50:49.000000', 'consum', 0.0218, 'lps'),
	(448382, 123, '2015-03-15 00:50:50.000000', 'consum', 0.0214, 'lps'),
	(448383, 123, '2015-03-15 00:50:51.000000', 'consum', 0.0231, 'lps'),
	(448384, 123, '2015-03-15 00:50:52.000000', 'consum', 0.0230, 'lps'),
	(448385, 123, '2015-03-15 00:50:53.000000', 'consum', 0.0223, 'lps'),
	(448386, 123, '2015-03-15 00:50:54.000000', 'consum', 0.0214, 'lps'),
	(448387, 123, '2015-03-15 00:50:55.000000', 'consum', 0.0218, 'lps'),
	(448388, 123, '2015-03-15 00:50:56.000000', 'consum', 0.0214, 'lps'),
	(448389, 123, '2015-03-15 00:50:57.000000', 'consum', 0.0229, 'lps'),
	(448390, 123, '2015-03-15 00:50:58.000000', 'consum', 0.0221, 'lps'),
	(448391, 123, '2015-03-15 00:50:59.000000', 'consum', 0.0233, 'lps'),
	(448392, 123, '2015-03-15 00:51:00.000000', 'consum', 0.0220, 'lps'),
	(448393, 123, '2015-03-15 00:51:01.000000', 'consum', 0.0214, 'lps'),
	(448394, 123, '2015-03-15 00:51:02.000000', 'consum', 0.0227, 'lps'),
	(448395, 123, '2015-03-15 00:51:03.000000', 'consum', 0.0211, 'lps'),
	(448396, 123, '2015-03-15 00:51:04.000000', 'consum', 0.0211, 'lps'),
	(448397, 123, '2015-03-15 00:51:05.000000', 'consum', 0.0215, 'lps'),
	(448398, 123, '2015-03-15 00:51:06.000000', 'consum', 0.0232, 'lps'),
	(448399, 123, '2015-03-15 00:51:07.000000', 'consum', 0.0233, 'lps'),
	(448400, 123, '2015-03-15 00:51:08.000000', 'consum', 0.0213, 'lps'),
	(448401, 123, '2015-03-15 00:51:09.000000', 'consum', 0.0227, 'lps'),
	(448402, 123, '2015-03-15 00:51:10.000000', 'consum', 0.0214, 'lps'),
	(448403, 123, '2015-03-15 00:51:11.000000', 'consum', 0.0228, 'lps'),
	(448404, 123, '2015-03-15 00:51:12.000000', 'consum', 0.0215, 'lps'),
	(448405, 123, '2015-03-15 00:51:13.000000', 'consum', 0.0231, 'lps'),
	(448406, 123, '2015-03-15 00:51:14.000000', 'consum', 0.0229, 'lps'),
	(448407, 123, '2015-03-15 00:51:15.000000', 'consum', 0.0217, 'lps'),
	(448408, 123, '2015-03-15 00:51:16.000000', 'consum', 0.0212, 'lps'),
	(448409, 123, '2015-03-15 00:51:17.000000', 'consum', 0.0225, 'lps'),
	(448410, 123, '2015-03-15 00:51:18.000000', 'consum', 0.0230, 'lps'),
	(448411, 123, '2015-03-15 00:51:19.000000', 'consum', 0.0216, 'lps'),
	(448412, 123, '2015-03-15 00:51:20.000000', 'consum', 0.0232, 'lps'),
	(448413, 123, '2015-03-15 00:51:21.000000', 'consum', 0.0229, 'lps'),
	(448414, 123, '2015-03-15 00:51:22.000000', 'consum', 0.0214, 'lps'),
	(448415, 124, '2015-03-15 00:00:00.000000', 'consum', 0.0216, 'lps'),
	(448416, 124, '2015-03-15 00:00:01.000000', 'consum', 0.0228, 'lps'),
	(448417, 124, '2015-03-15 00:00:02.000000', 'consum', 0.0222, 'lps'),
	(448418, 124, '2015-03-15 00:00:03.000000', 'consum', 0.0217, 'lps'),
	(448419, 124, '2015-03-15 00:00:04.000000', 'consum', 0.0211, 'lps'),
	(448420, 124, '2015-03-15 00:00:05.000000', 'consum', 0.0213, 'lps'),
	(448421, 124, '2015-03-15 00:00:06.000000', 'consum', 0.0221, 'lps'),
	(448422, 124, '2015-03-15 00:00:07.000000', 'consum', 0.0216, 'lps'),
	(448423, 124, '2015-03-15 00:00:08.000000', 'consum', 0.0230, 'lps'),
	(448424, 124, '2015-03-15 00:00:09.000000', 'consum', 0.0229, 'lps'),
	(448425, 124, '2015-03-15 00:00:10.000000', 'consum', 0.0225, 'lps'),
	(448426, 124, '2015-03-15 00:00:11.000000', 'consum', 0.0227, 'lps'),
	(448427, 124, '2015-03-15 00:00:12.000000', 'consum', 0.0228, 'lps'),
	(448428, 124, '2015-03-15 00:00:13.000000', 'consum', 0.0210, 'lps'),
	(448429, 124, '2015-03-15 00:00:14.000000', 'consum', 0.0220, 'lps'),
	(448430, 124, '2015-03-15 00:00:15.000000', 'consum', 0.0218, 'lps'),
	(448431, 124, '2015-03-15 00:00:16.000000', 'consum', 0.0220, 'lps'),
	(448432, 124, '2015-03-15 00:00:17.000000', 'consum', 0.0216, 'lps'),
	(448433, 124, '2015-03-15 00:00:18.000000', 'consum', 0.0212, 'lps'),
	(448434, 124, '2015-03-15 00:00:19.000000', 'consum', 0.0221, 'lps'),
	(448435, 124, '2015-03-15 00:00:20.000000', 'consum', 0.0217, 'lps'),
	(448436, 124, '2015-03-15 00:00:21.000000', 'consum', 0.0211, 'lps'),
	(448437, 124, '2015-03-15 00:00:22.000000', 'consum', 0.0219, 'lps'),
	(448438, 124, '2015-03-15 00:00:23.000000', 'consum', 0.0210, 'lps'),
	(448439, 124, '2015-03-15 00:00:24.000000', 'consum', 0.0225, 'lps'),
	(448440, 124, '2015-03-15 00:00:25.000000', 'consum', 0.0223, 'lps'),
	(448441, 124, '2015-03-15 00:00:26.000000', 'consum', 0.0211, 'lps'),
	(448442, 124, '2015-03-15 00:00:27.000000', 'consum', 0.0217, 'lps'),
	(448443, 124, '2015-03-15 00:00:28.000000', 'consum', 0.0222, 'lps'),
	(448444, 124, '2015-03-15 00:00:29.000000', 'consum', 0.0228, 'lps'),
	(448445, 124, '2015-03-15 00:00:30.000000', 'consum', 0.0221, 'lps'),
	(448446, 124, '2015-03-15 00:00:31.000000', 'consum', 0.0213, 'lps'),
	(448447, 124, '2015-03-15 00:00:32.000000', 'consum', 0.0213, 'lps'),
	(448448, 124, '2015-03-15 00:00:33.000000', 'consum', 0.0218, 'lps'),
	(448449, 124, '2015-03-15 00:00:34.000000', 'consum', 0.0218, 'lps'),
	(448450, 124, '2015-03-15 00:00:35.000000', 'consum', 0.0228, 'lps'),
	(448451, 124, '2015-03-15 00:00:36.000000', 'consum', 0.0213, 'lps'),
	(448452, 124, '2015-03-15 00:00:37.000000', 'consum', 0.0213, 'lps'),
	(448453, 124, '2015-03-15 00:00:38.000000', 'consum', 0.0215, 'lps'),
	(448454, 124, '2015-03-15 00:00:39.000000', 'consum', 0.0227, 'lps'),
	(448455, 124, '2015-03-15 00:00:40.000000', 'consum', 0.0220, 'lps'),
	(448456, 124, '2015-03-15 00:00:41.000000', 'consum', 0.0227, 'lps'),
	(448457, 124, '2015-03-15 00:00:42.000000', 'consum', 0.0226, 'lps'),
	(448458, 124, '2015-03-15 00:00:43.000000', 'consum', 0.0218, 'lps'),
	(448459, 124, '2015-03-15 00:00:44.000000', 'consum', 0.0221, 'lps'),
	(448460, 124, '2015-03-15 00:00:45.000000', 'consum', 0.0224, 'lps'),
	(448461, 124, '2015-03-15 00:00:46.000000', 'consum', 0.0225, 'lps'),
	(448462, 124, '2015-03-15 00:00:47.000000', 'consum', 0.0225, 'lps'),
	(448463, 124, '2015-03-15 00:00:48.000000', 'consum', 0.0216, 'lps'),
	(448464, 124, '2015-03-15 00:00:49.000000', 'consum', 0.0219, 'lps'),
	(448465, 124, '2015-03-15 00:00:50.000000', 'consum', 0.0214, 'lps'),
	(448466, 124, '2015-03-15 00:00:51.000000', 'consum', 0.0226, 'lps'),
	(448467, 124, '2015-03-15 00:00:52.000000', 'consum', 0.0216, 'lps'),
	(448468, 124, '2015-03-15 00:00:53.000000', 'consum', 0.0214, 'lps'),
	(448469, 124, '2015-03-15 00:00:54.000000', 'consum', 0.0212, 'lps'),
	(448470, 124, '2015-03-15 00:00:55.000000', 'consum', 0.0229, 'lps'),
	(448471, 124, '2015-03-15 00:00:56.000000', 'consum', 0.0217, 'lps'),
	(448472, 124, '2015-03-15 00:00:57.000000', 'consum', 0.0230, 'lps'),
	(448473, 124, '2015-03-15 00:00:58.000000', 'consum', 0.0227, 'lps'),
	(448474, 124, '2015-03-15 00:00:59.000000', 'consum', 0.0213, 'lps'),
	(448475, 124, '2015-03-15 00:01:00.000000', 'consum', 0.0217, 'lps'),
	(448476, 124, '2015-03-15 00:01:01.000000', 'consum', 0.0217, 'lps'),
	(448477, 124, '2015-03-15 00:01:02.000000', 'consum', 0.0223, 'lps'),
	(448478, 124, '2015-03-15 00:01:03.000000', 'consum', 0.0214, 'lps'),
	(448479, 124, '2015-03-15 00:01:04.000000', 'consum', 0.0211, 'lps'),
	(448480, 124, '2015-03-15 00:01:05.000000', 'consum', 0.0226, 'lps'),
	(448481, 124, '2015-03-15 00:01:06.000000', 'consum', 0.0224, 'lps'),
	(448482, 124, '2015-03-15 00:01:07.000000', 'consum', 0.0212, 'lps'),
	(448483, 124, '2015-03-15 00:01:08.000000', 'consum', 0.0218, 'lps'),
	(448484, 124, '2015-03-15 00:01:09.000000', 'consum', 0.0225, 'lps'),
	(448485, 124, '2015-03-15 00:01:10.000000', 'consum', 0.0220, 'lps'),
	(448486, 124, '2015-03-15 00:01:11.000000', 'consum', 0.0214, 'lps'),
	(448487, 124, '2015-03-15 00:01:12.000000', 'consum', 0.0223, 'lps'),
	(448488, 124, '2015-03-15 00:01:13.000000', 'consum', 0.0222, 'lps'),
	(448489, 124, '2015-03-15 00:01:14.000000', 'consum', 0.0210, 'lps'),
	(448490, 124, '2015-03-15 00:01:15.000000', 'consum', 0.0218, 'lps'),
	(448491, 124, '2015-03-15 00:01:16.000000', 'consum', 0.0228, 'lps'),
	(448492, 124, '2015-03-15 00:01:17.000000', 'consum', 0.0212, 'lps'),
	(448493, 124, '2015-03-15 00:01:18.000000', 'consum', 0.0229, 'lps'),
	(448494, 124, '2015-03-15 00:01:19.000000', 'consum', 0.0218, 'lps'),
	(448495, 124, '2015-03-15 00:01:20.000000', 'consum', 0.0213, 'lps'),
	(448496, 124, '2015-03-15 00:01:21.000000', 'consum', 0.0221, 'lps'),
	(448497, 124, '2015-03-15 00:01:22.000000', 'consum', 0.0215, 'lps'),
	(448498, 124, '2015-03-15 00:01:23.000000', 'consum', 0.0226, 'lps'),
	(448499, 124, '2015-03-15 00:01:24.000000', 'consum', 0.0210, 'lps'),
	(448500, 124, '2015-03-15 00:01:25.000000', 'consum', 0.0228, 'lps'),
	(448501, 124, '2015-03-15 00:01:26.000000', 'consum', 0.0215, 'lps'),
	(448502, 124, '2015-03-15 00:01:27.000000', 'consum', 0.0223, 'lps'),
	(448503, 124, '2015-03-15 00:01:28.000000', 'consum', 0.0218, 'lps'),
	(448504, 124, '2015-03-15 00:01:29.000000', 'consum', 0.0214, 'lps'),
	(448505, 124, '2015-03-15 00:01:30.000000', 'consum', 0.0226, 'lps'),
	(448506, 124, '2015-03-15 00:01:31.000000', 'consum', 0.0214, 'lps'),
	(448507, 124, '2015-03-15 00:01:32.000000', 'consum', 0.0226, 'lps'),
	(448508, 124, '2015-03-15 00:01:33.000000', 'consum', 0.0217, 'lps'),
	(448509, 124, '2015-03-15 00:01:34.000000', 'consum', 0.0218, 'lps'),
	(448510, 124, '2015-03-15 00:01:35.000000', 'consum', 0.0230, 'lps'),
	(448511, 124, '2015-03-15 00:01:36.000000', 'consum', 0.0222, 'lps'),
	(448512, 124, '2015-03-15 00:01:37.000000', 'consum', 0.0213, 'lps'),
	(448513, 124, '2015-03-15 00:01:38.000000', 'consum', 0.0229, 'lps'),
	(448514, 124, '2015-03-15 00:01:39.000000', 'consum', 0.0211, 'lps'),
	(448515, 124, '2015-03-15 00:01:40.000000', 'consum', 0.0225, 'lps'),
	(448516, 124, '2015-03-15 00:01:41.000000', 'consum', 0.0219, 'lps'),
	(448517, 124, '2015-03-15 00:01:42.000000', 'consum', 0.0230, 'lps'),
	(448518, 124, '2015-03-15 00:01:43.000000', 'consum', 0.0223, 'lps'),
	(448519, 124, '2015-03-15 00:01:44.000000', 'consum', 0.0215, 'lps'),
	(448520, 124, '2015-03-15 00:01:45.000000', 'consum', 0.0215, 'lps'),
	(448521, 124, '2015-03-15 00:01:46.000000', 'consum', 0.0223, 'lps'),
	(448522, 124, '2015-03-15 00:01:47.000000', 'consum', 0.0216, 'lps'),
	(448523, 124, '2015-03-15 00:01:48.000000', 'consum', 0.0223, 'lps'),
	(448524, 124, '2015-03-15 00:01:49.000000', 'consum', 0.0216, 'lps'),
	(448525, 124, '2015-03-15 00:01:50.000000', 'consum', 0.0221, 'lps'),
	(448526, 124, '2015-03-15 00:01:51.000000', 'consum', 0.0227, 'lps'),
	(448527, 124, '2015-03-15 00:01:52.000000', 'consum', 0.0222, 'lps'),
	(448528, 124, '2015-03-15 00:01:53.000000', 'consum', 0.0218, 'lps'),
	(448529, 124, '2015-03-15 00:01:54.000000', 'consum', 0.0217, 'lps'),
	(448530, 124, '2015-03-15 00:01:55.000000', 'consum', 0.0219, 'lps'),
	(448531, 124, '2015-03-15 00:01:56.000000', 'consum', 0.0214, 'lps'),
	(448532, 124, '2015-03-15 00:01:57.000000', 'consum', 0.0225, 'lps'),
	(448533, 124, '2015-03-15 00:01:58.000000', 'consum', 0.0210, 'lps'),
	(448534, 124, '2015-03-15 00:01:59.000000', 'consum', 0.0210, 'lps'),
	(448535, 124, '2015-03-15 00:02:00.000000', 'consum', 0.0229, 'lps'),
	(448536, 124, '2015-03-15 00:02:01.000000', 'consum', 0.0222, 'lps'),
	(448537, 124, '2015-03-15 00:02:02.000000', 'consum', 0.0212, 'lps'),
	(448538, 124, '2015-03-15 00:02:03.000000', 'consum', 0.0226, 'lps'),
	(448539, 124, '2015-03-15 00:02:04.000000', 'consum', 0.0223, 'lps'),
	(448540, 124, '2015-03-15 00:02:05.000000', 'consum', 0.0225, 'lps'),
	(448541, 124, '2015-03-15 00:02:06.000000', 'consum', 0.0229, 'lps'),
	(448542, 124, '2015-03-15 00:02:07.000000', 'consum', 0.0216, 'lps'),
	(448543, 124, '2015-03-15 00:02:08.000000', 'consum', 0.0226, 'lps'),
	(448544, 124, '2015-03-15 00:02:09.000000', 'consum', 0.0210, 'lps'),
	(448545, 124, '2015-03-15 00:02:10.000000', 'consum', 0.0227, 'lps'),
	(448546, 124, '2015-03-15 00:02:11.000000', 'consum', 0.0211, 'lps'),
	(448547, 124, '2015-03-15 00:02:12.000000', 'consum', 0.0229, 'lps'),
	(448548, 124, '2015-03-15 00:02:13.000000', 'consum', 0.0217, 'lps'),
	(448549, 124, '2015-03-15 00:02:14.000000', 'consum', 0.0211, 'lps'),
	(448550, 124, '2015-03-15 00:02:15.000000', 'consum', 0.0213, 'lps'),
	(448551, 124, '2015-03-15 00:02:16.000000', 'consum', 0.0225, 'lps'),
	(448552, 124, '2015-03-15 00:02:17.000000', 'consum', 0.0211, 'lps'),
	(448553, 124, '2015-03-15 00:02:18.000000', 'consum', 0.0213, 'lps'),
	(448554, 124, '2015-03-15 00:02:19.000000', 'consum', 0.0222, 'lps'),
	(448555, 124, '2015-03-15 00:02:20.000000', 'consum', 0.0222, 'lps'),
	(448556, 124, '2015-03-15 00:02:21.000000', 'consum', 0.0212, 'lps'),
	(448557, 124, '2015-03-15 00:02:22.000000', 'consum', 0.0225, 'lps'),
	(448558, 124, '2015-03-15 00:02:23.000000', 'consum', 0.0218, 'lps'),
	(448559, 124, '2015-03-15 00:02:24.000000', 'consum', 0.0224, 'lps'),
	(448560, 124, '2015-03-15 00:02:25.000000', 'consum', 0.0217, 'lps'),
	(448561, 124, '2015-03-15 00:02:26.000000', 'consum', 0.0224, 'lps'),
	(448562, 124, '2015-03-15 00:02:27.000000', 'consum', 0.0219, 'lps'),
	(448563, 124, '2015-03-15 00:02:28.000000', 'consum', 0.0213, 'lps'),
	(448564, 124, '2015-03-15 00:02:29.000000', 'consum', 0.0219, 'lps'),
	(448565, 124, '2015-03-15 00:02:30.000000', 'consum', 0.0225, 'lps'),
	(448566, 124, '2015-03-15 00:02:31.000000', 'consum', 0.0215, 'lps'),
	(448567, 124, '2015-03-15 00:02:32.000000', 'consum', 0.0212, 'lps'),
	(448568, 124, '2015-03-15 00:02:33.000000', 'consum', 0.0226, 'lps'),
	(448569, 124, '2015-03-15 00:02:34.000000', 'consum', 0.0222, 'lps'),
	(448570, 124, '2015-03-15 00:02:35.000000', 'consum', 0.0224, 'lps'),
	(448571, 124, '2015-03-15 00:02:36.000000', 'consum', 0.0224, 'lps'),
	(448572, 124, '2015-03-15 00:02:37.000000', 'consum', 0.0215, 'lps'),
	(448573, 124, '2015-03-15 00:02:38.000000', 'consum', 0.0217, 'lps'),
	(448574, 124, '2015-03-15 00:02:39.000000', 'consum', 0.0230, 'lps'),
	(448575, 124, '2015-03-15 00:02:40.000000', 'consum', 0.0227, 'lps'),
	(448576, 124, '2015-03-15 00:02:41.000000', 'consum', 0.0214, 'lps'),
	(448577, 124, '2015-03-15 00:02:42.000000', 'consum', 0.0223, 'lps'),
	(448578, 124, '2015-03-15 00:02:43.000000', 'consum', 0.0222, 'lps'),
	(448579, 124, '2015-03-15 00:02:44.000000', 'consum', 0.0229, 'lps'),
	(448580, 124, '2015-03-15 00:02:45.000000', 'consum', 0.0230, 'lps'),
	(448581, 124, '2015-03-15 00:02:46.000000', 'consum', 0.0210, 'lps'),
	(448582, 124, '2015-03-15 00:02:47.000000', 'consum', 0.0213, 'lps'),
	(448583, 124, '2015-03-15 00:02:48.000000', 'consum', 0.0228, 'lps'),
	(448584, 124, '2015-03-15 00:02:49.000000', 'consum', 0.0226, 'lps'),
	(448585, 124, '2015-03-15 00:02:50.000000', 'consum', 0.0216, 'lps'),
	(448586, 124, '2015-03-15 00:02:51.000000', 'consum', 0.0214, 'lps'),
	(448587, 124, '2015-03-15 00:02:52.000000', 'consum', 0.0211, 'lps'),
	(448588, 124, '2015-03-15 00:02:53.000000', 'consum', 0.0226, 'lps'),
	(448589, 124, '2015-03-15 00:02:54.000000', 'consum', 0.0224, 'lps'),
	(448590, 124, '2015-03-15 00:02:55.000000', 'consum', 0.0210, 'lps'),
	(448591, 124, '2015-03-15 00:02:56.000000', 'consum', 0.0213, 'lps'),
	(448592, 124, '2015-03-15 00:02:57.000000', 'consum', 0.0225, 'lps'),
	(448593, 124, '2015-03-15 00:02:58.000000', 'consum', 0.0212, 'lps'),
	(448594, 124, '2015-03-15 00:02:59.000000', 'consum', 0.0219, 'lps'),
	(448595, 124, '2015-03-15 00:03:00.000000', 'consum', 0.0227, 'lps'),
	(448596, 124, '2015-03-15 00:03:01.000000', 'consum', 0.0228, 'lps'),
	(448597, 124, '2015-03-15 00:03:02.000000', 'consum', 0.0226, 'lps'),
	(448598, 124, '2015-03-15 00:03:03.000000', 'consum', 0.0217, 'lps'),
	(448599, 124, '2015-03-15 00:03:04.000000', 'consum', 0.0217, 'lps'),
	(448600, 124, '2015-03-15 00:03:05.000000', 'consum', 0.0225, 'lps'),
	(448601, 124, '2015-03-15 00:03:06.000000', 'consum', 0.0224, 'lps'),
	(448602, 124, '2015-03-15 00:03:07.000000', 'consum', 0.0212, 'lps'),
	(448603, 124, '2015-03-15 00:03:08.000000', 'consum', 0.0223, 'lps'),
	(448604, 124, '2015-03-15 00:03:09.000000', 'consum', 0.0227, 'lps'),
	(448605, 124, '2015-03-15 00:03:10.000000', 'consum', 0.0213, 'lps'),
	(448606, 124, '2015-03-15 00:03:11.000000', 'consum', 0.0219, 'lps'),
	(448607, 124, '2015-03-15 00:03:12.000000', 'consum', 0.0226, 'lps'),
	(448608, 124, '2015-03-15 00:03:13.000000', 'consum', 0.0220, 'lps'),
	(448609, 124, '2015-03-15 00:03:14.000000', 'consum', 0.0214, 'lps'),
	(448610, 124, '2015-03-15 00:03:15.000000', 'consum', 0.0221, 'lps'),
	(448611, 124, '2015-03-15 00:03:16.000000', 'consum', 0.0213, 'lps'),
	(448612, 124, '2015-03-15 00:03:17.000000', 'consum', 0.0211, 'lps'),
	(448613, 124, '2015-03-15 00:03:18.000000', 'consum', 0.0230, 'lps'),
	(448614, 124, '2015-03-15 00:03:19.000000', 'consum', 0.0222, 'lps'),
	(448615, 124, '2015-03-15 00:03:20.000000', 'consum', 0.0211, 'lps'),
	(448616, 124, '2015-03-15 00:03:21.000000', 'consum', 0.0222, 'lps'),
	(448617, 124, '2015-03-15 00:03:22.000000', 'consum', 0.0227, 'lps'),
	(448618, 124, '2015-03-15 00:03:23.000000', 'consum', 0.0216, 'lps'),
	(448619, 124, '2015-03-15 00:03:24.000000', 'consum', 0.0230, 'lps'),
	(448620, 124, '2015-03-15 00:03:25.000000', 'consum', 0.0229, 'lps'),
	(448621, 124, '2015-03-15 00:03:26.000000', 'consum', 0.0226, 'lps'),
	(448622, 124, '2015-03-15 00:03:27.000000', 'consum', 0.0212, 'lps'),
	(448623, 124, '2015-03-15 00:03:28.000000', 'consum', 0.0215, 'lps'),
	(448624, 124, '2015-03-15 00:03:29.000000', 'consum', 0.0230, 'lps'),
	(448625, 124, '2015-03-15 00:03:30.000000', 'consum', 0.0230, 'lps'),
	(448626, 124, '2015-03-15 00:03:31.000000', 'consum', 0.0211, 'lps'),
	(448627, 124, '2015-03-15 00:03:32.000000', 'consum', 0.0220, 'lps'),
	(448628, 124, '2015-03-15 00:03:33.000000', 'consum', 0.0213, 'lps'),
	(448629, 124, '2015-03-15 00:03:34.000000', 'consum', 0.0216, 'lps'),
	(448630, 124, '2015-03-15 00:03:35.000000', 'consum', 0.0212, 'lps'),
	(448631, 124, '2015-03-15 00:03:36.000000', 'consum', 0.0224, 'lps'),
	(448632, 124, '2015-03-15 00:03:37.000000', 'consum', 0.0211, 'lps'),
	(448633, 124, '2015-03-15 00:03:38.000000', 'consum', 0.0216, 'lps'),
	(448634, 124, '2015-03-15 00:03:39.000000', 'consum', 0.0217, 'lps'),
	(448635, 124, '2015-03-15 00:03:40.000000', 'consum', 0.0227, 'lps'),
	(448636, 124, '2015-03-15 00:03:41.000000', 'consum', 0.0212, 'lps'),
	(448637, 124, '2015-03-15 00:03:42.000000', 'consum', 0.0210, 'lps'),
	(448638, 124, '2015-03-15 00:03:43.000000', 'consum', 0.0226, 'lps'),
	(448639, 124, '2015-03-15 00:03:44.000000', 'consum', 0.0227, 'lps'),
	(448640, 124, '2015-03-15 00:03:45.000000', 'consum', 0.0227, 'lps'),
	(448641, 124, '2015-03-15 00:03:46.000000', 'consum', 0.0224, 'lps'),
	(448642, 124, '2015-03-15 00:03:47.000000', 'consum', 0.0230, 'lps'),
	(448643, 124, '2015-03-15 00:03:48.000000', 'consum', 0.0225, 'lps'),
	(448644, 124, '2015-03-15 00:03:49.000000', 'consum', 0.0228, 'lps'),
	(448645, 124, '2015-03-15 00:03:50.000000', 'consum', 0.0212, 'lps'),
	(448646, 124, '2015-03-15 00:03:51.000000', 'consum', 0.0229, 'lps'),
	(448647, 124, '2015-03-15 00:03:52.000000', 'consum', 0.0217, 'lps'),
	(448648, 124, '2015-03-15 00:03:53.000000', 'consum', 0.0211, 'lps'),
	(448649, 124, '2015-03-15 00:03:54.000000', 'consum', 0.0212, 'lps'),
	(448650, 124, '2015-03-15 00:03:55.000000', 'consum', 0.0219, 'lps'),
	(448651, 124, '2015-03-15 00:03:56.000000', 'consum', 0.0230, 'lps'),
	(448652, 124, '2015-03-15 00:03:57.000000', 'consum', 0.0219, 'lps'),
	(448653, 124, '2015-03-15 00:03:58.000000', 'consum', 0.0215, 'lps'),
	(448654, 124, '2015-03-15 00:03:59.000000', 'consum', 0.0211, 'lps'),
	(448655, 124, '2015-03-15 00:04:00.000000', 'consum', 0.0221, 'lps'),
	(448656, 124, '2015-03-15 00:04:01.000000', 'consum', 0.0222, 'lps'),
	(448657, 124, '2015-03-15 00:04:02.000000', 'consum', 0.0215, 'lps'),
	(448658, 124, '2015-03-15 00:04:03.000000', 'consum', 0.0222, 'lps'),
	(448659, 124, '2015-03-15 00:04:04.000000', 'consum', 0.0212, 'lps'),
	(448660, 124, '2015-03-15 00:04:05.000000', 'consum', 0.0227, 'lps'),
	(448661, 124, '2015-03-15 00:04:06.000000', 'consum', 0.0227, 'lps'),
	(448662, 124, '2015-03-15 00:04:07.000000', 'consum', 0.0223, 'lps'),
	(448663, 124, '2015-03-15 00:04:08.000000', 'consum', 0.0223, 'lps'),
	(448664, 124, '2015-03-15 00:04:09.000000', 'consum', 0.0217, 'lps'),
	(448665, 124, '2015-03-15 00:04:10.000000', 'consum', 0.0227, 'lps'),
	(448666, 124, '2015-03-15 00:04:11.000000', 'consum', 0.0210, 'lps'),
	(448667, 124, '2015-03-15 00:04:12.000000', 'consum', 0.0224, 'lps'),
	(448668, 124, '2015-03-15 00:04:13.000000', 'consum', 0.0218, 'lps'),
	(448669, 124, '2015-03-15 00:04:14.000000', 'consum', 0.0228, 'lps'),
	(448670, 124, '2015-03-15 00:04:15.000000', 'consum', 0.0216, 'lps'),
	(448671, 124, '2015-03-15 00:04:16.000000', 'consum', 0.0229, 'lps'),
	(448672, 124, '2015-03-15 00:04:17.000000', 'consum', 0.0221, 'lps'),
	(448673, 124, '2015-03-15 00:04:18.000000', 'consum', 0.0211, 'lps'),
	(448674, 124, '2015-03-15 00:04:19.000000', 'consum', 0.0223, 'lps'),
	(448675, 124, '2015-03-15 00:04:20.000000', 'consum', 0.0212, 'lps'),
	(448676, 124, '2015-03-15 00:04:21.000000', 'consum', 0.0221, 'lps'),
	(448677, 124, '2015-03-15 00:04:22.000000', 'consum', 0.0218, 'lps'),
	(448678, 124, '2015-03-15 00:04:23.000000', 'consum', 0.0218, 'lps'),
	(448679, 124, '2015-03-15 00:04:24.000000', 'consum', 0.0225, 'lps'),
	(448680, 124, '2015-03-15 00:04:25.000000', 'consum', 0.0222, 'lps'),
	(448681, 124, '2015-03-15 00:04:26.000000', 'consum', 0.0224, 'lps'),
	(448682, 124, '2015-03-15 00:04:27.000000', 'consum', 0.0226, 'lps'),
	(448683, 124, '2015-03-15 00:04:28.000000', 'consum', 0.0225, 'lps'),
	(448684, 124, '2015-03-15 00:04:29.000000', 'consum', 0.0219, 'lps'),
	(448685, 124, '2015-03-15 00:04:30.000000', 'consum', 0.0210, 'lps'),
	(448686, 124, '2015-03-15 00:04:31.000000', 'consum', 0.0225, 'lps'),
	(448687, 124, '2015-03-15 00:04:32.000000', 'consum', 0.0224, 'lps'),
	(448688, 124, '2015-03-15 00:04:33.000000', 'consum', 0.0215, 'lps'),
	(448689, 124, '2015-03-15 00:04:34.000000', 'consum', 0.0215, 'lps'),
	(448690, 124, '2015-03-15 00:04:35.000000', 'consum', 0.0218, 'lps'),
	(448691, 124, '2015-03-15 00:04:36.000000', 'consum', 0.0214, 'lps'),
	(448692, 124, '2015-03-15 00:04:37.000000', 'consum', 0.0229, 'lps'),
	(448693, 124, '2015-03-15 00:04:38.000000', 'consum', 0.0229, 'lps'),
	(448694, 124, '2015-03-15 00:04:39.000000', 'consum', 0.0228, 'lps'),
	(448695, 124, '2015-03-15 00:04:40.000000', 'consum', 0.0224, 'lps'),
	(448696, 124, '2015-03-15 00:04:41.000000', 'consum', 0.0227, 'lps'),
	(448697, 124, '2015-03-15 00:04:42.000000', 'consum', 0.0230, 'lps'),
	(448698, 124, '2015-03-15 00:04:43.000000', 'consum', 0.0217, 'lps'),
	(448699, 124, '2015-03-15 00:04:44.000000', 'consum', 0.0228, 'lps'),
	(448700, 124, '2015-03-15 00:04:45.000000', 'consum', 0.0218, 'lps'),
	(448701, 124, '2015-03-15 00:04:46.000000', 'consum', 0.0218, 'lps'),
	(448702, 124, '2015-03-15 00:04:47.000000', 'consum', 0.0224, 'lps'),
	(448703, 124, '2015-03-15 00:04:48.000000', 'consum', 0.0218, 'lps'),
	(448704, 124, '2015-03-15 00:04:49.000000', 'consum', 0.0227, 'lps'),
	(448705, 124, '2015-03-15 00:04:50.000000', 'consum', 0.0228, 'lps'),
	(448706, 124, '2015-03-15 00:04:51.000000', 'consum', 0.0211, 'lps'),
	(448707, 124, '2015-03-15 00:04:52.000000', 'consum', 0.0221, 'lps'),
	(448708, 124, '2015-03-15 00:04:53.000000', 'consum', 0.0224, 'lps'),
	(448709, 124, '2015-03-15 00:04:54.000000', 'consum', 0.0224, 'lps'),
	(448710, 124, '2015-03-15 00:04:55.000000', 'consum', 0.0219, 'lps'),
	(448711, 124, '2015-03-15 00:04:56.000000', 'consum', 0.0215, 'lps'),
	(448712, 124, '2015-03-15 00:04:57.000000', 'consum', 0.0227, 'lps'),
	(448713, 124, '2015-03-15 00:04:58.000000', 'consum', 0.0218, 'lps'),
	(448714, 124, '2015-03-15 00:04:59.000000', 'consum', 0.0219, 'lps'),
	(448715, 124, '2015-03-15 00:05:00.000000', 'consum', 0.0212, 'lps'),
	(448716, 124, '2015-03-15 00:05:01.000000', 'consum', 0.0212, 'lps'),
	(448717, 124, '2015-03-15 00:05:02.000000', 'consum', 0.0218, 'lps'),
	(448718, 124, '2015-03-15 00:05:03.000000', 'consum', 0.0220, 'lps'),
	(448719, 124, '2015-03-15 00:05:04.000000', 'consum', 0.0218, 'lps'),
	(448720, 124, '2015-03-15 00:05:05.000000', 'consum', 0.0219, 'lps'),
	(448721, 124, '2015-03-15 00:05:06.000000', 'consum', 0.0210, 'lps'),
	(448722, 124, '2015-03-15 00:05:07.000000', 'consum', 0.0226, 'lps'),
	(448723, 124, '2015-03-15 00:05:08.000000', 'consum', 0.0227, 'lps'),
	(448724, 124, '2015-03-15 00:05:09.000000', 'consum', 0.0228, 'lps'),
	(448725, 124, '2015-03-15 00:05:10.000000', 'consum', 0.0226, 'lps'),
	(448726, 124, '2015-03-15 00:05:11.000000', 'consum', 0.0217, 'lps'),
	(448727, 124, '2015-03-15 00:05:12.000000', 'consum', 0.0218, 'lps'),
	(448728, 124, '2015-03-15 00:05:13.000000', 'consum', 0.0210, 'lps'),
	(448729, 124, '2015-03-15 00:05:14.000000', 'consum', 0.0229, 'lps'),
	(448730, 124, '2015-03-15 00:05:15.000000', 'consum', 0.0219, 'lps'),
	(448731, 124, '2015-03-15 00:05:16.000000', 'consum', 0.0221, 'lps'),
	(448732, 124, '2015-03-15 00:05:17.000000', 'consum', 0.0219, 'lps'),
	(448733, 124, '2015-03-15 00:05:18.000000', 'consum', 0.0221, 'lps'),
	(448734, 124, '2015-03-15 00:05:19.000000', 'consum', 0.0218, 'lps'),
	(448735, 124, '2015-03-15 00:05:20.000000', 'consum', 0.0219, 'lps'),
	(448736, 124, '2015-03-15 00:05:21.000000', 'consum', 0.0210, 'lps'),
	(448737, 124, '2015-03-15 00:05:22.000000', 'consum', 0.0227, 'lps'),
	(448738, 124, '2015-03-15 00:05:23.000000', 'consum', 0.0230, 'lps'),
	(448739, 124, '2015-03-15 00:05:24.000000', 'consum', 0.0219, 'lps'),
	(448740, 124, '2015-03-15 00:05:25.000000', 'consum', 0.0215, 'lps'),
	(448741, 124, '2015-03-15 00:05:26.000000', 'consum', 0.0228, 'lps'),
	(448742, 124, '2015-03-15 00:05:27.000000', 'consum', 0.0225, 'lps'),
	(448743, 124, '2015-03-15 00:05:28.000000', 'consum', 0.0210, 'lps'),
	(448744, 124, '2015-03-15 00:05:29.000000', 'consum', 0.0228, 'lps'),
	(448745, 124, '2015-03-15 00:05:30.000000', 'consum', 0.0217, 'lps'),
	(448746, 124, '2015-03-15 00:05:31.000000', 'consum', 0.0213, 'lps'),
	(448747, 124, '2015-03-15 00:05:32.000000', 'consum', 0.0225, 'lps'),
	(448748, 124, '2015-03-15 00:05:33.000000', 'consum', 0.0213, 'lps'),
	(448749, 124, '2015-03-15 00:05:34.000000', 'consum', 0.0221, 'lps'),
	(448750, 124, '2015-03-15 00:05:35.000000', 'consum', 0.0215, 'lps'),
	(448751, 124, '2015-03-15 00:05:36.000000', 'consum', 0.0226, 'lps'),
	(448752, 124, '2015-03-15 00:05:37.000000', 'consum', 0.0210, 'lps'),
	(448753, 124, '2015-03-15 00:05:38.000000', 'consum', 0.0227, 'lps'),
	(448754, 124, '2015-03-15 00:05:39.000000', 'consum', 0.0210, 'lps'),
	(448755, 124, '2015-03-15 00:05:40.000000', 'consum', 0.0222, 'lps'),
	(448756, 124, '2015-03-15 00:05:41.000000', 'consum', 0.0230, 'lps'),
	(448757, 124, '2015-03-15 00:05:42.000000', 'consum', 0.0213, 'lps'),
	(448758, 124, '2015-03-15 00:05:43.000000', 'consum', 0.0227, 'lps'),
	(448759, 124, '2015-03-15 00:05:44.000000', 'consum', 0.0225, 'lps'),
	(448760, 124, '2015-03-15 00:05:45.000000', 'consum', 0.0215, 'lps'),
	(448761, 124, '2015-03-15 00:05:46.000000', 'consum', 0.0229, 'lps'),
	(448762, 124, '2015-03-15 00:05:47.000000', 'consum', 0.0230, 'lps'),
	(448763, 124, '2015-03-15 00:05:48.000000', 'consum', 0.0211, 'lps'),
	(448764, 124, '2015-03-15 00:05:49.000000', 'consum', 0.0220, 'lps'),
	(448765, 124, '2015-03-15 00:05:50.000000', 'consum', 0.0215, 'lps'),
	(448766, 124, '2015-03-15 00:05:51.000000', 'consum', 0.0228, 'lps'),
	(448767, 124, '2015-03-15 00:05:52.000000', 'consum', 0.0219, 'lps'),
	(448768, 124, '2015-03-15 00:05:53.000000', 'consum', 0.0225, 'lps'),
	(448769, 124, '2015-03-15 00:05:54.000000', 'consum', 0.0217, 'lps'),
	(448770, 124, '2015-03-15 00:05:55.000000', 'consum', 0.0221, 'lps'),
	(448771, 124, '2015-03-15 00:05:56.000000', 'consum', 0.0224, 'lps'),
	(448772, 124, '2015-03-15 00:05:57.000000', 'consum', 0.0225, 'lps'),
	(448773, 124, '2015-03-15 00:05:58.000000', 'consum', 0.0221, 'lps'),
	(448774, 124, '2015-03-15 00:05:59.000000', 'consum', 0.0223, 'lps'),
	(448775, 124, '2015-03-15 00:06:00.000000', 'consum', 0.0222, 'lps'),
	(448776, 124, '2015-03-15 00:06:01.000000', 'consum', 0.0210, 'lps'),
	(448777, 124, '2015-03-15 00:06:02.000000', 'consum', 0.0215, 'lps'),
	(448778, 124, '2015-03-15 00:06:03.000000', 'consum', 0.0215, 'lps'),
	(448779, 124, '2015-03-15 00:06:04.000000', 'consum', 0.0219, 'lps'),
	(448780, 124, '2015-03-15 00:06:05.000000', 'consum', 0.0221, 'lps'),
	(448781, 124, '2015-03-15 00:06:06.000000', 'consum', 0.0217, 'lps'),
	(448782, 124, '2015-03-15 00:06:07.000000', 'consum', 0.0213, 'lps'),
	(448783, 124, '2015-03-15 00:06:08.000000', 'consum', 0.0224, 'lps'),
	(448784, 124, '2015-03-15 00:06:09.000000', 'consum', 0.0210, 'lps'),
	(448785, 124, '2015-03-15 00:06:10.000000', 'consum', 0.0230, 'lps'),
	(448786, 124, '2015-03-15 00:06:11.000000', 'consum', 0.0228, 'lps'),
	(448787, 124, '2015-03-15 00:06:12.000000', 'consum', 0.0220, 'lps'),
	(448788, 124, '2015-03-15 00:06:13.000000', 'consum', 0.0227, 'lps'),
	(448789, 124, '2015-03-15 00:06:14.000000', 'consum', 0.0222, 'lps'),
	(448790, 124, '2015-03-15 00:06:15.000000', 'consum', 0.0219, 'lps'),
	(448791, 124, '2015-03-15 00:06:16.000000', 'consum', 0.0219, 'lps'),
	(448792, 124, '2015-03-15 00:06:17.000000', 'consum', 0.0210, 'lps'),
	(448793, 124, '2015-03-15 00:06:18.000000', 'consum', 0.0225, 'lps'),
	(448794, 124, '2015-03-15 00:06:19.000000', 'consum', 0.0223, 'lps'),
	(448795, 124, '2015-03-15 00:06:20.000000', 'consum', 0.0211, 'lps'),
	(448796, 124, '2015-03-15 00:06:21.000000', 'consum', 0.0216, 'lps'),
	(448797, 124, '2015-03-15 00:06:22.000000', 'consum', 0.0219, 'lps'),
	(448798, 124, '2015-03-15 00:06:23.000000', 'consum', 0.0215, 'lps'),
	(448799, 124, '2015-03-15 00:06:24.000000', 'consum', 0.0228, 'lps'),
	(448800, 124, '2015-03-15 00:06:25.000000', 'consum', 0.0225, 'lps'),
	(448801, 124, '2015-03-15 00:06:26.000000', 'consum', 0.0211, 'lps'),
	(448802, 124, '2015-03-15 00:06:27.000000', 'consum', 0.0213, 'lps'),
	(448803, 124, '2015-03-15 00:06:28.000000', 'consum', 0.0220, 'lps'),
	(448804, 124, '2015-03-15 00:06:29.000000', 'consum', 0.0211, 'lps'),
	(448805, 124, '2015-03-15 00:06:30.000000', 'consum', 0.0226, 'lps'),
	(448806, 124, '2015-03-15 00:06:31.000000', 'consum', 0.0224, 'lps'),
	(448807, 124, '2015-03-15 00:06:32.000000', 'consum', 0.0214, 'lps'),
	(448808, 124, '2015-03-15 00:06:33.000000', 'consum', 0.0229, 'lps'),
	(448809, 124, '2015-03-15 00:06:34.000000', 'consum', 0.0229, 'lps'),
	(448810, 124, '2015-03-15 00:06:35.000000', 'consum', 0.0229, 'lps'),
	(448811, 124, '2015-03-15 00:06:36.000000', 'consum', 0.0229, 'lps'),
	(448812, 124, '2015-03-15 00:06:37.000000', 'consum', 0.0226, 'lps'),
	(448813, 124, '2015-03-15 00:06:38.000000', 'consum', 0.0213, 'lps'),
	(448814, 124, '2015-03-15 00:06:39.000000', 'consum', 0.0219, 'lps'),
	(448815, 124, '2015-03-15 00:06:40.000000', 'consum', 0.0226, 'lps'),
	(448816, 124, '2015-03-15 00:06:41.000000', 'consum', 0.0222, 'lps'),
	(448817, 124, '2015-03-15 00:06:42.000000', 'consum', 0.0222, 'lps'),
	(448818, 124, '2015-03-15 00:06:43.000000', 'consum', 0.0214, 'lps'),
	(448819, 124, '2015-03-15 00:06:44.000000', 'consum', 0.0213, 'lps'),
	(448820, 124, '2015-03-15 00:06:45.000000', 'consum', 0.0216, 'lps'),
	(448821, 124, '2015-03-15 00:06:46.000000', 'consum', 0.0230, 'lps'),
	(448822, 124, '2015-03-15 00:06:47.000000', 'consum', 0.0228, 'lps'),
	(448823, 124, '2015-03-15 00:06:48.000000', 'consum', 0.0221, 'lps'),
	(448824, 124, '2015-03-15 00:06:49.000000', 'consum', 0.0210, 'lps'),
	(448825, 124, '2015-03-15 00:06:50.000000', 'consum', 0.0220, 'lps'),
	(448826, 124, '2015-03-15 00:06:51.000000', 'consum', 0.0218, 'lps'),
	(448827, 124, '2015-03-15 00:06:52.000000', 'consum', 0.0222, 'lps'),
	(448828, 124, '2015-03-15 00:06:53.000000', 'consum', 0.0224, 'lps'),
	(448829, 124, '2015-03-15 00:06:54.000000', 'consum', 0.0223, 'lps'),
	(448830, 124, '2015-03-15 00:06:55.000000', 'consum', 0.0215, 'lps'),
	(448831, 124, '2015-03-15 00:06:56.000000', 'consum', 0.0217, 'lps'),
	(448832, 124, '2015-03-15 00:06:57.000000', 'consum', 0.0230, 'lps'),
	(448833, 124, '2015-03-15 00:06:58.000000', 'consum', 0.0227, 'lps'),
	(448834, 124, '2015-03-15 00:06:59.000000', 'consum', 0.0215, 'lps'),
	(448835, 124, '2015-03-15 00:07:00.000000', 'consum', 0.0226, 'lps'),
	(448836, 124, '2015-03-15 00:07:01.000000', 'consum', 0.0214, 'lps'),
	(448837, 124, '2015-03-15 00:07:02.000000', 'consum', 0.0224, 'lps'),
	(448838, 124, '2015-03-15 00:07:03.000000', 'consum', 0.0225, 'lps'),
	(448839, 124, '2015-03-15 00:07:04.000000', 'consum', 0.0224, 'lps'),
	(448840, 124, '2015-03-15 00:07:05.000000', 'consum', 0.0215, 'lps'),
	(448841, 124, '2015-03-15 00:07:06.000000', 'consum', 0.0213, 'lps'),
	(448842, 124, '2015-03-15 00:07:07.000000', 'consum', 0.0213, 'lps'),
	(448843, 124, '2015-03-15 00:07:08.000000', 'consum', 0.0213, 'lps'),
	(448844, 124, '2015-03-15 00:07:09.000000', 'consum', 0.0220, 'lps'),
	(448845, 124, '2015-03-15 00:07:10.000000', 'consum', 0.0230, 'lps'),
	(448846, 124, '2015-03-15 00:07:11.000000', 'consum', 0.0215, 'lps'),
	(448847, 124, '2015-03-15 00:07:12.000000', 'consum', 0.0219, 'lps'),
	(448848, 124, '2015-03-15 00:07:13.000000', 'consum', 0.0220, 'lps'),
	(448849, 124, '2015-03-15 00:07:14.000000', 'consum', 0.0213, 'lps'),
	(448850, 124, '2015-03-15 00:07:15.000000', 'consum', 0.0214, 'lps'),
	(448851, 124, '2015-03-15 00:07:16.000000', 'consum', 0.0223, 'lps'),
	(448852, 124, '2015-03-15 00:07:17.000000', 'consum', 0.0221, 'lps'),
	(448853, 124, '2015-03-15 00:07:18.000000', 'consum', 0.0226, 'lps'),
	(448854, 124, '2015-03-15 00:07:19.000000', 'consum', 0.0215, 'lps'),
	(448855, 124, '2015-03-15 00:07:20.000000', 'consum', 0.0229, 'lps'),
	(448856, 124, '2015-03-15 00:07:21.000000', 'consum', 0.0227, 'lps'),
	(448857, 124, '2015-03-15 00:07:22.000000', 'consum', 0.0218, 'lps'),
	(448858, 124, '2015-03-15 00:07:23.000000', 'consum', 0.0223, 'lps'),
	(448859, 124, '2015-03-15 00:07:24.000000', 'consum', 0.0228, 'lps'),
	(448860, 124, '2015-03-15 00:07:25.000000', 'consum', 0.0222, 'lps'),
	(448861, 124, '2015-03-15 00:07:26.000000', 'consum', 0.0216, 'lps'),
	(448862, 124, '2015-03-15 00:07:27.000000', 'consum', 0.0223, 'lps'),
	(448863, 124, '2015-03-15 00:07:28.000000', 'consum', 0.0219, 'lps'),
	(448864, 124, '2015-03-15 00:07:29.000000', 'consum', 0.0214, 'lps'),
	(448865, 124, '2015-03-15 00:07:30.000000', 'consum', 0.0226, 'lps'),
	(448866, 124, '2015-03-15 00:07:31.000000', 'consum', 0.0217, 'lps'),
	(448867, 124, '2015-03-15 00:07:32.000000', 'consum', 0.0217, 'lps'),
	(448868, 124, '2015-03-15 00:07:33.000000', 'consum', 0.0224, 'lps'),
	(448869, 124, '2015-03-15 00:07:34.000000', 'consum', 0.0216, 'lps'),
	(448870, 124, '2015-03-15 00:07:35.000000', 'consum', 0.0223, 'lps'),
	(448871, 124, '2015-03-15 00:07:36.000000', 'consum', 0.0212, 'lps'),
	(448872, 124, '2015-03-15 00:07:37.000000', 'consum', 0.0226, 'lps'),
	(448873, 124, '2015-03-15 00:07:38.000000', 'consum', 0.0223, 'lps'),
	(448874, 124, '2015-03-15 00:07:39.000000', 'consum', 0.0224, 'lps'),
	(448875, 124, '2015-03-15 00:07:40.000000', 'consum', 0.0222, 'lps'),
	(448876, 124, '2015-03-15 00:07:41.000000', 'consum', 0.0228, 'lps'),
	(448877, 124, '2015-03-15 00:07:42.000000', 'consum', 0.0223, 'lps'),
	(448878, 124, '2015-03-15 00:07:43.000000', 'consum', 0.0219, 'lps'),
	(448879, 124, '2015-03-15 00:07:44.000000', 'consum', 0.0219, 'lps'),
	(448880, 124, '2015-03-15 00:07:45.000000', 'consum', 0.0228, 'lps'),
	(448881, 124, '2015-03-15 00:07:46.000000', 'consum', 0.0211, 'lps'),
	(448882, 124, '2015-03-15 00:07:47.000000', 'consum', 0.0224, 'lps'),
	(448883, 124, '2015-03-15 00:07:48.000000', 'consum', 0.0212, 'lps'),
	(448884, 124, '2015-03-15 00:07:49.000000', 'consum', 0.0224, 'lps'),
	(448885, 124, '2015-03-15 00:07:50.000000', 'consum', 0.0211, 'lps'),
	(448886, 124, '2015-03-15 00:07:51.000000', 'consum', 0.0215, 'lps'),
	(448887, 124, '2015-03-15 00:07:52.000000', 'consum', 0.0210, 'lps'),
	(448888, 124, '2015-03-15 00:07:53.000000', 'consum', 0.0217, 'lps'),
	(448889, 124, '2015-03-15 00:07:54.000000', 'consum', 0.0225, 'lps'),
	(448890, 124, '2015-03-15 00:07:55.000000', 'consum', 0.0221, 'lps'),
	(448891, 124, '2015-03-15 00:07:56.000000', 'consum', 0.0223, 'lps'),
	(448892, 124, '2015-03-15 00:07:57.000000', 'consum', 0.0219, 'lps'),
	(448893, 124, '2015-03-15 00:07:58.000000', 'consum', 0.0216, 'lps'),
	(448894, 124, '2015-03-15 00:07:59.000000', 'consum', 0.0216, 'lps'),
	(448895, 124, '2015-03-15 00:08:00.000000', 'consum', 0.0220, 'lps'),
	(448896, 124, '2015-03-15 00:08:01.000000', 'consum', 0.0223, 'lps'),
	(448897, 124, '2015-03-15 00:08:02.000000', 'consum', 0.0226, 'lps'),
	(448898, 124, '2015-03-15 00:08:03.000000', 'consum', 0.0227, 'lps'),
	(448899, 124, '2015-03-15 00:08:04.000000', 'consum', 0.0229, 'lps'),
	(448900, 124, '2015-03-15 00:08:05.000000', 'consum', 0.0212, 'lps'),
	(448901, 124, '2015-03-15 00:08:06.000000', 'consum', 0.0228, 'lps'),
	(448902, 124, '2015-03-15 00:08:07.000000', 'consum', 0.0210, 'lps'),
	(448903, 124, '2015-03-15 00:08:08.000000', 'consum', 0.0221, 'lps'),
	(448904, 124, '2015-03-15 00:08:09.000000', 'consum', 0.0222, 'lps'),
	(448905, 124, '2015-03-15 00:08:10.000000', 'consum', 0.0217, 'lps'),
	(448906, 124, '2015-03-15 00:08:11.000000', 'consum', 0.0228, 'lps'),
	(448907, 124, '2015-03-15 00:08:12.000000', 'consum', 0.0219, 'lps'),
	(448908, 124, '2015-03-15 00:08:13.000000', 'consum', 0.0222, 'lps'),
	(448909, 124, '2015-03-15 00:08:14.000000', 'consum', 0.0222, 'lps'),
	(448910, 124, '2015-03-15 00:08:15.000000', 'consum', 0.0213, 'lps'),
	(448911, 124, '2015-03-15 00:08:16.000000', 'consum', 0.0210, 'lps'),
	(448912, 124, '2015-03-15 00:08:17.000000', 'consum', 0.0221, 'lps'),
	(448913, 124, '2015-03-15 00:08:18.000000', 'consum', 0.0226, 'lps'),
	(448914, 124, '2015-03-15 00:08:19.000000', 'consum', 0.0216, 'lps'),
	(448915, 124, '2015-03-15 00:08:20.000000', 'consum', 0.0211, 'lps'),
	(448916, 124, '2015-03-15 00:08:21.000000', 'consum', 0.0220, 'lps'),
	(448917, 124, '2015-03-15 00:08:22.000000', 'consum', 0.0217, 'lps'),
	(448918, 124, '2015-03-15 00:08:23.000000', 'consum', 0.0213, 'lps'),
	(448919, 124, '2015-03-15 00:08:24.000000', 'consum', 0.0228, 'lps'),
	(448920, 124, '2015-03-15 00:08:25.000000', 'consum', 0.0229, 'lps'),
	(448921, 124, '2015-03-15 00:08:26.000000', 'consum', 0.0210, 'lps'),
	(448922, 124, '2015-03-15 00:08:27.000000', 'consum', 0.0215, 'lps'),
	(448923, 124, '2015-03-15 00:08:28.000000', 'consum', 0.0216, 'lps'),
	(448924, 124, '2015-03-15 00:08:29.000000', 'consum', 0.0227, 'lps'),
	(448925, 124, '2015-03-15 00:08:30.000000', 'consum', 0.0211, 'lps'),
	(448926, 124, '2015-03-15 00:08:31.000000', 'consum', 0.0229, 'lps'),
	(448927, 124, '2015-03-15 00:08:32.000000', 'consum', 0.0220, 'lps'),
	(448928, 124, '2015-03-15 00:08:33.000000', 'consum', 0.0225, 'lps'),
	(448929, 124, '2015-03-15 00:08:34.000000', 'consum', 0.0213, 'lps'),
	(448930, 124, '2015-03-15 00:08:35.000000', 'consum', 0.0224, 'lps'),
	(448931, 124, '2015-03-15 00:08:36.000000', 'consum', 0.0228, 'lps'),
	(448932, 124, '2015-03-15 00:08:37.000000', 'consum', 0.0218, 'lps'),
	(448933, 124, '2015-03-15 00:08:38.000000', 'consum', 0.0215, 'lps'),
	(448934, 124, '2015-03-15 00:08:39.000000', 'consum', 0.0213, 'lps'),
	(448935, 124, '2015-03-15 00:08:40.000000', 'consum', 0.0230, 'lps'),
	(448936, 124, '2015-03-15 00:08:41.000000', 'consum', 0.0218, 'lps'),
	(448937, 124, '2015-03-15 00:08:42.000000', 'consum', 0.0211, 'lps'),
	(448938, 124, '2015-03-15 00:08:43.000000', 'consum', 0.0212, 'lps'),
	(448939, 124, '2015-03-15 00:08:44.000000', 'consum', 0.0220, 'lps'),
	(448940, 124, '2015-03-15 00:08:45.000000', 'consum', 0.0210, 'lps'),
	(448941, 124, '2015-03-15 00:08:46.000000', 'consum', 0.0222, 'lps'),
	(448942, 124, '2015-03-15 00:08:47.000000', 'consum', 0.0229, 'lps'),
	(448943, 124, '2015-03-15 00:08:48.000000', 'consum', 0.0227, 'lps'),
	(448944, 124, '2015-03-15 00:08:49.000000', 'consum', 0.0216, 'lps'),
	(448945, 124, '2015-03-15 00:08:50.000000', 'consum', 0.0212, 'lps'),
	(448946, 124, '2015-03-15 00:08:51.000000', 'consum', 0.0224, 'lps'),
	(448947, 124, '2015-03-15 00:08:52.000000', 'consum', 0.0213, 'lps'),
	(448948, 124, '2015-03-15 00:08:53.000000', 'consum', 0.0223, 'lps'),
	(448949, 124, '2015-03-15 00:08:54.000000', 'consum', 0.0223, 'lps'),
	(448950, 124, '2015-03-15 00:08:55.000000', 'consum', 0.0219, 'lps'),
	(448951, 124, '2015-03-15 00:08:56.000000', 'consum', 0.0216, 'lps'),
	(448952, 124, '2015-03-15 00:08:57.000000', 'consum', 0.0211, 'lps'),
	(448953, 124, '2015-03-15 00:08:58.000000', 'consum', 0.0221, 'lps'),
	(448954, 124, '2015-03-15 00:08:59.000000', 'consum', 0.0220, 'lps'),
	(448955, 124, '2015-03-15 00:09:00.000000', 'consum', 0.0229, 'lps'),
	(448956, 124, '2015-03-15 00:09:01.000000', 'consum', 0.0213, 'lps'),
	(448957, 124, '2015-03-15 00:09:02.000000', 'consum', 0.0230, 'lps'),
	(448958, 124, '2015-03-15 00:09:03.000000', 'consum', 0.0217, 'lps'),
	(448959, 124, '2015-03-15 00:09:04.000000', 'consum', 0.0228, 'lps'),
	(448960, 124, '2015-03-15 00:09:05.000000', 'consum', 0.0216, 'lps'),
	(448961, 124, '2015-03-15 00:09:06.000000', 'consum', 0.0227, 'lps'),
	(448962, 124, '2015-03-15 00:09:07.000000', 'consum', 0.0217, 'lps'),
	(448963, 124, '2015-03-15 00:09:08.000000', 'consum', 0.0215, 'lps'),
	(448964, 124, '2015-03-15 00:09:09.000000', 'consum', 0.0212, 'lps'),
	(448965, 124, '2015-03-15 00:09:10.000000', 'consum', 0.0229, 'lps'),
	(448966, 124, '2015-03-15 00:09:11.000000', 'consum', 0.0216, 'lps'),
	(448967, 124, '2015-03-15 00:09:12.000000', 'consum', 0.0227, 'lps'),
	(448968, 124, '2015-03-15 00:09:13.000000', 'consum', 0.0211, 'lps'),
	(448969, 124, '2015-03-15 00:09:14.000000', 'consum', 0.0230, 'lps'),
	(448970, 124, '2015-03-15 00:09:15.000000', 'consum', 0.0223, 'lps'),
	(448971, 124, '2015-03-15 00:09:16.000000', 'consum', 0.0217, 'lps'),
	(448972, 124, '2015-03-15 00:09:17.000000', 'consum', 0.0224, 'lps'),
	(448973, 124, '2015-03-15 00:09:18.000000', 'consum', 0.0220, 'lps'),
	(448974, 124, '2015-03-15 00:09:19.000000', 'consum', 0.0219, 'lps'),
	(448975, 124, '2015-03-15 00:09:20.000000', 'consum', 0.0226, 'lps'),
	(448976, 124, '2015-03-15 00:09:21.000000', 'consum', 0.0219, 'lps'),
	(448977, 124, '2015-03-15 00:09:22.000000', 'consum', 0.0210, 'lps'),
	(448978, 124, '2015-03-15 00:09:23.000000', 'consum', 0.0225, 'lps'),
	(448979, 124, '2015-03-15 00:09:24.000000', 'consum', 0.0224, 'lps'),
	(448980, 124, '2015-03-15 00:09:25.000000', 'consum', 0.0215, 'lps'),
	(448981, 124, '2015-03-15 00:09:26.000000', 'consum', 0.0211, 'lps'),
	(448982, 124, '2015-03-15 00:09:27.000000', 'consum', 0.0224, 'lps'),
	(448983, 124, '2015-03-15 00:09:28.000000', 'consum', 0.0215, 'lps'),
	(448984, 124, '2015-03-15 00:09:29.000000', 'consum', 0.0215, 'lps'),
	(448985, 124, '2015-03-15 00:09:30.000000', 'consum', 0.0219, 'lps'),
	(448986, 124, '2015-03-15 00:09:31.000000', 'consum', 0.0220, 'lps'),
	(448987, 124, '2015-03-15 00:09:32.000000', 'consum', 0.0213, 'lps'),
	(448988, 124, '2015-03-15 00:09:33.000000', 'consum', 0.0214, 'lps'),
	(448989, 124, '2015-03-15 00:09:34.000000', 'consum', 0.0225, 'lps'),
	(448990, 124, '2015-03-15 00:09:35.000000', 'consum', 0.0229, 'lps'),
	(448991, 124, '2015-03-15 00:09:36.000000', 'consum', 0.0219, 'lps'),
	(448992, 124, '2015-03-15 00:09:37.000000', 'consum', 0.0220, 'lps'),
	(448993, 124, '2015-03-15 00:09:38.000000', 'consum', 0.0212, 'lps'),
	(448994, 124, '2015-03-15 00:09:39.000000', 'consum', 0.0214, 'lps'),
	(448995, 124, '2015-03-15 00:09:40.000000', 'consum', 0.0222, 'lps'),
	(448996, 124, '2015-03-15 00:09:41.000000', 'consum', 0.0216, 'lps'),
	(448997, 124, '2015-03-15 00:09:42.000000', 'consum', 0.0228, 'lps'),
	(448998, 124, '2015-03-15 00:09:43.000000', 'consum', 0.0219, 'lps'),
	(448999, 124, '2015-03-15 00:09:44.000000', 'consum', 0.0221, 'lps'),
	(449000, 124, '2015-03-15 00:09:45.000000', 'consum', 0.0217, 'lps'),
	(449001, 124, '2015-03-15 00:09:46.000000', 'consum', 0.0214, 'lps'),
	(449002, 124, '2015-03-15 00:09:47.000000', 'consum', 0.0230, 'lps'),
	(449003, 124, '2015-03-15 00:09:48.000000', 'consum', 0.0215, 'lps'),
	(449004, 124, '2015-03-15 00:09:49.000000', 'consum', 0.0218, 'lps'),
	(449005, 124, '2015-03-15 00:09:50.000000', 'consum', 0.0213, 'lps'),
	(449006, 124, '2015-03-15 00:09:51.000000', 'consum', 0.0222, 'lps'),
	(449007, 124, '2015-03-15 00:09:52.000000', 'consum', 0.0220, 'lps'),
	(449008, 124, '2015-03-15 00:09:53.000000', 'consum', 0.0224, 'lps'),
	(449009, 124, '2015-03-15 00:09:54.000000', 'consum', 0.0210, 'lps'),
	(449010, 124, '2015-03-15 00:09:55.000000', 'consum', 0.0230, 'lps'),
	(449011, 124, '2015-03-15 00:09:56.000000', 'consum', 0.0226, 'lps'),
	(449012, 124, '2015-03-15 00:09:57.000000', 'consum', 0.0230, 'lps'),
	(449013, 124, '2015-03-15 00:09:58.000000', 'consum', 0.0220, 'lps'),
	(449014, 124, '2015-03-15 00:09:59.000000', 'consum', 0.0224, 'lps'),
	(449015, 124, '2015-03-15 00:10:00.000000', 'consum', 0.0229, 'lps'),
	(449016, 124, '2015-03-15 00:10:01.000000', 'consum', 0.0223, 'lps'),
	(449017, 124, '2015-03-15 00:10:02.000000', 'consum', 0.0216, 'lps'),
	(449018, 124, '2015-03-15 00:10:03.000000', 'consum', 0.0221, 'lps'),
	(449019, 124, '2015-03-15 00:10:04.000000', 'consum', 0.0230, 'lps'),
	(449020, 124, '2015-03-15 00:10:05.000000', 'consum', 0.0213, 'lps'),
	(449021, 124, '2015-03-15 00:10:06.000000', 'consum', 0.0230, 'lps'),
	(449022, 124, '2015-03-15 00:10:07.000000', 'consum', 0.0219, 'lps'),
	(449023, 124, '2015-03-15 00:10:08.000000', 'consum', 0.0213, 'lps'),
	(449024, 124, '2015-03-15 00:10:09.000000', 'consum', 0.0221, 'lps'),
	(449025, 124, '2015-03-15 00:10:10.000000', 'consum', 0.0212, 'lps'),
	(449026, 124, '2015-03-15 00:10:11.000000', 'consum', 0.0212, 'lps'),
	(449027, 124, '2015-03-15 00:10:12.000000', 'consum', 0.0211, 'lps'),
	(449028, 124, '2015-03-15 00:10:13.000000', 'consum', 0.0212, 'lps'),
	(449029, 124, '2015-03-15 00:10:14.000000', 'consum', 0.0217, 'lps'),
	(449030, 124, '2015-03-15 00:10:15.000000', 'consum', 0.0220, 'lps'),
	(449031, 124, '2015-03-15 00:10:16.000000', 'consum', 0.0218, 'lps'),
	(449032, 124, '2015-03-15 00:10:17.000000', 'consum', 0.0220, 'lps'),
	(449033, 124, '2015-03-15 00:10:18.000000', 'consum', 0.0214, 'lps'),
	(449034, 124, '2015-03-15 00:10:19.000000', 'consum', 0.0221, 'lps'),
	(449035, 124, '2015-03-15 00:10:20.000000', 'consum', 0.0211, 'lps'),
	(449036, 124, '2015-03-15 00:10:21.000000', 'consum', 0.0225, 'lps'),
	(449037, 124, '2015-03-15 00:10:22.000000', 'consum', 0.0219, 'lps'),
	(449038, 124, '2015-03-15 00:10:23.000000', 'consum', 0.0213, 'lps'),
	(449039, 124, '2015-03-15 00:10:24.000000', 'consum', 0.0218, 'lps'),
	(449040, 124, '2015-03-15 00:10:25.000000', 'consum', 0.0222, 'lps'),
	(449041, 124, '2015-03-15 00:10:26.000000', 'consum', 0.0223, 'lps'),
	(449042, 124, '2015-03-15 00:10:27.000000', 'consum', 0.0220, 'lps'),
	(449043, 124, '2015-03-15 00:10:28.000000', 'consum', 0.0220, 'lps'),
	(449044, 124, '2015-03-15 00:10:29.000000', 'consum', 0.0211, 'lps'),
	(449045, 124, '2015-03-15 00:10:30.000000', 'consum', 0.0227, 'lps'),
	(449046, 124, '2015-03-15 00:10:31.000000', 'consum', 0.0230, 'lps'),
	(449047, 124, '2015-03-15 00:10:32.000000', 'consum', 0.0217, 'lps'),
	(449048, 124, '2015-03-15 00:10:33.000000', 'consum', 0.0227, 'lps'),
	(449049, 124, '2015-03-15 00:10:34.000000', 'consum', 0.0213, 'lps'),
	(449050, 124, '2015-03-15 00:10:35.000000', 'consum', 0.0217, 'lps'),
	(449051, 124, '2015-03-15 00:10:36.000000', 'consum', 0.0213, 'lps'),
	(449052, 124, '2015-03-15 00:10:37.000000', 'consum', 0.0227, 'lps'),
	(449053, 124, '2015-03-15 00:10:38.000000', 'consum', 0.0225, 'lps'),
	(449054, 124, '2015-03-15 00:10:39.000000', 'consum', 0.0212, 'lps'),
	(449055, 124, '2015-03-15 00:10:40.000000', 'consum', 0.0218, 'lps'),
	(449056, 124, '2015-03-15 00:10:41.000000', 'consum', 0.0222, 'lps'),
	(449057, 124, '2015-03-15 00:10:42.000000', 'consum', 0.0227, 'lps'),
	(449058, 124, '2015-03-15 00:10:43.000000', 'consum', 0.0216, 'lps'),
	(449059, 124, '2015-03-15 00:10:44.000000', 'consum', 0.0213, 'lps'),
	(449060, 124, '2015-03-15 00:10:45.000000', 'consum', 0.0227, 'lps'),
	(449061, 124, '2015-03-15 00:10:46.000000', 'consum', 0.0225, 'lps'),
	(449062, 124, '2015-03-15 00:10:47.000000', 'consum', 0.0213, 'lps'),
	(449063, 124, '2015-03-15 00:10:48.000000', 'consum', 0.0222, 'lps'),
	(449064, 124, '2015-03-15 00:10:49.000000', 'consum', 0.0218, 'lps'),
	(449065, 124, '2015-03-15 00:10:50.000000', 'consum', 0.0217, 'lps'),
	(449066, 124, '2015-03-15 00:10:51.000000', 'consum', 0.0223, 'lps'),
	(449067, 124, '2015-03-15 00:10:52.000000', 'consum', 0.0230, 'lps'),
	(449068, 124, '2015-03-15 00:10:53.000000', 'consum', 0.0210, 'lps'),
	(449069, 124, '2015-03-15 00:10:54.000000', 'consum', 0.0214, 'lps'),
	(449070, 124, '2015-03-15 00:10:55.000000', 'consum', 0.0229, 'lps'),
	(449071, 124, '2015-03-15 00:10:56.000000', 'consum', 0.0230, 'lps'),
	(449072, 124, '2015-03-15 00:10:57.000000', 'consum', 0.0211, 'lps'),
	(449073, 124, '2015-03-15 00:10:58.000000', 'consum', 0.0220, 'lps'),
	(449074, 124, '2015-03-15 00:10:59.000000', 'consum', 0.0213, 'lps'),
	(449075, 124, '2015-03-15 00:11:00.000000', 'consum', 0.0219, 'lps'),
	(449076, 124, '2015-03-15 00:11:01.000000', 'consum', 0.0227, 'lps'),
	(449077, 124, '2015-03-15 00:11:02.000000', 'consum', 0.0223, 'lps'),
	(449078, 124, '2015-03-15 00:11:03.000000', 'consum', 0.0225, 'lps'),
	(449079, 124, '2015-03-15 00:11:04.000000', 'consum', 0.0226, 'lps'),
	(449080, 124, '2015-03-15 00:11:05.000000', 'consum', 0.0226, 'lps'),
	(449081, 124, '2015-03-15 00:11:06.000000', 'consum', 0.0220, 'lps'),
	(449082, 124, '2015-03-15 00:11:07.000000', 'consum', 0.0213, 'lps'),
	(449083, 124, '2015-03-15 00:11:08.000000', 'consum', 0.0214, 'lps'),
	(449084, 124, '2015-03-15 00:11:09.000000', 'consum', 0.0225, 'lps'),
	(449085, 124, '2015-03-15 00:11:10.000000', 'consum', 0.0229, 'lps'),
	(449086, 124, '2015-03-15 00:11:11.000000', 'consum', 0.0219, 'lps'),
	(449087, 124, '2015-03-15 00:11:12.000000', 'consum', 0.0220, 'lps'),
	(449088, 124, '2015-03-15 00:11:13.000000', 'consum', 0.0213, 'lps'),
	(449089, 124, '2015-03-15 00:11:14.000000', 'consum', 0.0215, 'lps'),
	(449090, 124, '2015-03-15 00:11:15.000000', 'consum', 0.0227, 'lps'),
	(449091, 124, '2015-03-15 00:11:16.000000', 'consum', 0.0217, 'lps'),
	(449092, 124, '2015-03-15 00:11:17.000000', 'consum', 0.0215, 'lps'),
	(449093, 124, '2015-03-15 00:11:18.000000', 'consum', 0.0216, 'lps'),
	(449094, 124, '2015-03-15 00:11:19.000000', 'consum', 0.0226, 'lps'),
	(449095, 124, '2015-03-15 00:11:20.000000', 'consum', 0.0228, 'lps'),
	(449096, 124, '2015-03-15 00:11:21.000000', 'consum', 0.0214, 'lps'),
	(449097, 124, '2015-03-15 00:11:22.000000', 'consum', 0.0215, 'lps'),
	(449098, 124, '2015-03-15 00:11:23.000000', 'consum', 0.0225, 'lps'),
	(449099, 124, '2015-03-15 00:11:24.000000', 'consum', 0.0230, 'lps'),
	(449100, 124, '2015-03-15 00:11:25.000000', 'consum', 0.0221, 'lps'),
	(449101, 124, '2015-03-15 00:11:26.000000', 'consum', 0.0227, 'lps'),
	(449102, 124, '2015-03-15 00:11:27.000000', 'consum', 0.0220, 'lps'),
	(449103, 124, '2015-03-15 00:11:28.000000', 'consum', 0.0210, 'lps'),
	(449104, 124, '2015-03-15 00:11:29.000000', 'consum', 0.0223, 'lps'),
	(449105, 124, '2015-03-15 00:11:30.000000', 'consum', 0.0211, 'lps'),
	(449106, 124, '2015-03-15 00:11:31.000000', 'consum', 0.0220, 'lps'),
	(449107, 124, '2015-03-15 00:11:32.000000', 'consum', 0.0213, 'lps'),
	(449108, 124, '2015-03-15 00:11:33.000000', 'consum', 0.0218, 'lps'),
	(449109, 124, '2015-03-15 00:11:34.000000', 'consum', 0.0221, 'lps'),
	(449110, 124, '2015-03-15 00:11:35.000000', 'consum', 0.0222, 'lps'),
	(449111, 124, '2015-03-15 00:11:36.000000', 'consum', 0.0214, 'lps'),
	(449112, 124, '2015-03-15 00:11:37.000000', 'consum', 0.0215, 'lps'),
	(449113, 124, '2015-03-15 00:11:38.000000', 'consum', 0.0225, 'lps'),
	(449114, 124, '2015-03-15 00:11:39.000000', 'consum', 0.0227, 'lps'),
	(449115, 124, '2015-03-15 00:11:40.000000', 'consum', 0.0210, 'lps'),
	(449116, 124, '2015-03-15 00:11:41.000000', 'consum', 0.0221, 'lps'),
	(449117, 124, '2015-03-15 00:11:42.000000', 'consum', 0.0225, 'lps'),
	(449118, 124, '2015-03-15 00:11:43.000000', 'consum', 0.0211, 'lps'),
	(449119, 124, '2015-03-15 00:11:44.000000', 'consum', 0.0213, 'lps'),
	(449120, 124, '2015-03-15 00:11:45.000000', 'consum', 0.0223, 'lps'),
	(449121, 124, '2015-03-15 00:11:46.000000', 'consum', 0.0224, 'lps'),
	(449122, 124, '2015-03-15 00:11:47.000000', 'consum', 0.0219, 'lps'),
	(449123, 124, '2015-03-15 00:11:48.000000', 'consum', 0.0213, 'lps'),
	(449124, 124, '2015-03-15 00:11:49.000000', 'consum', 0.0221, 'lps'),
	(449125, 124, '2015-03-15 00:11:50.000000', 'consum', 0.0213, 'lps'),
	(449126, 124, '2015-03-15 00:11:51.000000', 'consum', 0.0215, 'lps'),
	(449127, 124, '2015-03-15 00:11:52.000000', 'consum', 0.0226, 'lps'),
	(449128, 124, '2015-03-15 00:11:53.000000', 'consum', 0.0212, 'lps'),
	(449129, 124, '2015-03-15 00:11:54.000000', 'consum', 0.0214, 'lps'),
	(449130, 124, '2015-03-15 00:11:55.000000', 'consum', 0.0224, 'lps'),
	(449131, 124, '2015-03-15 00:11:56.000000', 'consum', 0.0226, 'lps'),
	(449132, 124, '2015-03-15 00:11:57.000000', 'consum', 0.0227, 'lps'),
	(449133, 124, '2015-03-15 00:11:58.000000', 'consum', 0.0226, 'lps'),
	(449134, 124, '2015-03-15 00:11:59.000000', 'consum', 0.0220, 'lps'),
	(449135, 124, '2015-03-15 00:12:00.000000', 'consum', 0.0214, 'lps'),
	(449136, 124, '2015-03-15 00:12:01.000000', 'consum', 0.0219, 'lps'),
	(449137, 124, '2015-03-15 00:12:02.000000', 'consum', 0.0223, 'lps'),
	(449138, 124, '2015-03-15 00:12:03.000000', 'consum', 0.0227, 'lps'),
	(449139, 124, '2015-03-15 00:12:04.000000', 'consum', 0.0217, 'lps'),
	(449140, 124, '2015-03-15 00:12:05.000000', 'consum', 0.0213, 'lps'),
	(449141, 124, '2015-03-15 00:12:06.000000', 'consum', 0.0228, 'lps'),
	(449142, 124, '2015-03-15 00:12:07.000000', 'consum', 0.0228, 'lps'),
	(449143, 124, '2015-03-15 00:12:08.000000', 'consum', 0.0227, 'lps'),
	(449144, 124, '2015-03-15 00:12:09.000000', 'consum', 0.0219, 'lps'),
	(449145, 124, '2015-03-15 00:12:10.000000', 'consum', 0.0224, 'lps'),
	(449146, 124, '2015-03-15 00:12:11.000000', 'consum', 0.0211, 'lps'),
	(449147, 124, '2015-03-15 00:12:12.000000', 'consum', 0.0216, 'lps'),
	(449148, 124, '2015-03-15 00:12:13.000000', 'consum', 0.0216, 'lps'),
	(449149, 124, '2015-03-15 00:12:14.000000', 'consum', 0.0223, 'lps'),
	(449150, 124, '2015-03-15 00:12:15.000000', 'consum', 0.0216, 'lps'),
	(449151, 124, '2015-03-15 00:12:16.000000', 'consum', 0.0222, 'lps'),
	(449152, 124, '2015-03-15 00:12:17.000000', 'consum', 0.0230, 'lps'),
	(449153, 124, '2015-03-15 00:12:18.000000', 'consum', 0.0211, 'lps'),
	(449154, 124, '2015-03-15 00:12:19.000000', 'consum', 0.0221, 'lps'),
	(449155, 124, '2015-03-15 00:12:20.000000', 'consum', 0.0221, 'lps'),
	(449156, 124, '2015-03-15 00:12:21.000000', 'consum', 0.0211, 'lps'),
	(449157, 124, '2015-03-15 00:12:22.000000', 'consum', 0.0223, 'lps'),
	(449158, 124, '2015-03-15 00:12:23.000000', 'consum', 0.0230, 'lps'),
	(449159, 124, '2015-03-15 00:12:24.000000', 'consum', 0.0230, 'lps'),
	(449160, 124, '2015-03-15 00:12:25.000000', 'consum', 0.0228, 'lps'),
	(449161, 124, '2015-03-15 00:12:26.000000', 'consum', 0.0221, 'lps'),
	(449162, 124, '2015-03-15 00:12:27.000000', 'consum', 0.0210, 'lps'),
	(449163, 124, '2015-03-15 00:12:28.000000', 'consum', 0.0219, 'lps'),
	(449164, 124, '2015-03-15 00:12:29.000000', 'consum', 0.0216, 'lps'),
	(449165, 124, '2015-03-15 00:12:30.000000', 'consum', 0.0213, 'lps'),
	(449166, 124, '2015-03-15 00:12:31.000000', 'consum', 0.0230, 'lps'),
	(449167, 124, '2015-03-15 00:12:32.000000', 'consum', 0.0215, 'lps'),
	(449168, 124, '2015-03-15 00:12:33.000000', 'consum', 0.0220, 'lps'),
	(449169, 124, '2015-03-15 00:12:34.000000', 'consum', 0.0222, 'lps'),
	(449170, 124, '2015-03-15 00:12:35.000000', 'consum', 0.0220, 'lps'),
	(449171, 124, '2015-03-15 00:12:36.000000', 'consum', 0.0224, 'lps'),
	(449172, 124, '2015-03-15 00:12:37.000000', 'consum', 0.0228, 'lps'),
	(449173, 124, '2015-03-15 00:12:38.000000', 'consum', 0.0219, 'lps'),
	(449174, 124, '2015-03-15 00:12:39.000000', 'consum', 0.0222, 'lps'),
	(449175, 124, '2015-03-15 00:12:40.000000', 'consum', 0.0223, 'lps'),
	(449176, 124, '2015-03-15 00:12:41.000000', 'consum', 0.0218, 'lps'),
	(449177, 124, '2015-03-15 00:12:42.000000', 'consum', 0.0212, 'lps'),
	(449178, 124, '2015-03-15 00:12:43.000000', 'consum', 0.0216, 'lps'),
	(449179, 124, '2015-03-15 00:12:44.000000', 'consum', 0.0215, 'lps'),
	(449180, 124, '2015-03-15 00:12:45.000000', 'consum', 0.0217, 'lps'),
	(449181, 124, '2015-03-15 00:12:46.000000', 'consum', 0.0230, 'lps'),
	(449182, 124, '2015-03-15 00:12:47.000000', 'consum', 0.0228, 'lps'),
	(449183, 124, '2015-03-15 00:12:48.000000', 'consum', 0.0218, 'lps'),
	(449184, 124, '2015-03-15 00:12:49.000000', 'consum', 0.0219, 'lps'),
	(449185, 124, '2015-03-15 00:12:50.000000', 'consum', 0.0210, 'lps'),
	(449186, 124, '2015-03-15 00:12:51.000000', 'consum', 0.0225, 'lps'),
	(449187, 124, '2015-03-15 00:12:52.000000', 'consum', 0.0223, 'lps'),
	(449188, 124, '2015-03-15 00:12:53.000000', 'consum', 0.0229, 'lps'),
	(449189, 124, '2015-03-15 00:12:54.000000', 'consum', 0.0228, 'lps'),
	(449190, 124, '2015-03-15 00:12:55.000000', 'consum', 0.0219, 'lps'),
	(449191, 124, '2015-03-15 00:12:56.000000', 'consum', 0.0222, 'lps'),
	(449192, 124, '2015-03-15 00:12:57.000000', 'consum', 0.0225, 'lps'),
	(449193, 124, '2015-03-15 00:12:58.000000', 'consum', 0.0226, 'lps'),
	(449194, 124, '2015-03-15 00:12:59.000000', 'consum', 0.0226, 'lps'),
	(449195, 124, '2015-03-15 00:13:00.000000', 'consum', 0.0222, 'lps'),
	(449196, 124, '2015-03-15 00:13:01.000000', 'consum', 0.0222, 'lps'),
	(449197, 124, '2015-03-15 00:13:02.000000', 'consum', 0.0213, 'lps'),
	(449198, 124, '2015-03-15 00:13:03.000000', 'consum', 0.0230, 'lps'),
	(449199, 124, '2015-03-15 00:13:04.000000', 'consum', 0.0218, 'lps'),
	(449200, 124, '2015-03-15 00:13:05.000000', 'consum', 0.0214, 'lps'),
	(449201, 124, '2015-03-15 00:13:06.000000', 'consum', 0.0225, 'lps'),
	(449202, 124, '2015-03-15 00:13:07.000000', 'consum', 0.0212, 'lps'),
	(449203, 124, '2015-03-15 00:13:08.000000', 'consum', 0.0218, 'lps'),
	(449204, 124, '2015-03-15 00:13:09.000000', 'consum', 0.0225, 'lps'),
	(449205, 124, '2015-03-15 00:13:10.000000', 'consum', 0.0218, 'lps'),
	(449206, 124, '2015-03-15 00:13:11.000000', 'consum', 0.0225, 'lps'),
	(449207, 124, '2015-03-15 00:13:12.000000', 'consum', 0.0221, 'lps'),
	(449208, 124, '2015-03-15 00:13:13.000000', 'consum', 0.0220, 'lps'),
	(449209, 124, '2015-03-15 00:13:14.000000', 'consum', 0.0227, 'lps'),
	(449210, 124, '2015-03-15 00:13:15.000000', 'consum', 0.0226, 'lps'),
	(449211, 124, '2015-03-15 00:13:16.000000', 'consum', 0.0215, 'lps'),
	(449212, 124, '2015-03-15 00:13:17.000000', 'consum', 0.0211, 'lps'),
	(449213, 124, '2015-03-15 00:13:18.000000', 'consum', 0.0221, 'lps'),
	(449214, 124, '2015-03-15 00:13:19.000000', 'consum', 0.0219, 'lps'),
	(449215, 124, '2015-03-15 00:13:20.000000', 'consum', 0.0223, 'lps'),
	(449216, 124, '2015-03-15 00:13:21.000000', 'consum', 0.0229, 'lps'),
	(449217, 124, '2015-03-15 00:13:22.000000', 'consum', 0.0222, 'lps'),
	(449218, 124, '2015-03-15 00:13:23.000000', 'consum', 0.0217, 'lps'),
	(449219, 124, '2015-03-15 00:13:24.000000', 'consum', 0.0228, 'lps'),
	(449220, 124, '2015-03-15 00:13:25.000000', 'consum', 0.0216, 'lps'),
	(449221, 124, '2015-03-15 00:13:26.000000', 'consum', 0.0228, 'lps'),
	(449222, 124, '2015-03-15 00:13:27.000000', 'consum', 0.0221, 'lps'),
	(449223, 124, '2015-03-15 00:13:28.000000', 'consum', 0.0230, 'lps'),
	(449224, 124, '2015-03-15 00:13:29.000000', 'consum', 0.0216, 'lps'),
	(449225, 124, '2015-03-15 00:13:30.000000', 'consum', 0.0222, 'lps'),
	(449226, 124, '2015-03-15 00:13:31.000000', 'consum', 0.0212, 'lps'),
	(449227, 124, '2015-03-15 00:13:32.000000', 'consum', 0.0226, 'lps'),
	(449228, 124, '2015-03-15 00:13:33.000000', 'consum', 0.0222, 'lps'),
	(449229, 124, '2015-03-15 00:13:34.000000', 'consum', 0.0221, 'lps'),
	(449230, 124, '2015-03-15 00:13:35.000000', 'consum', 0.0229, 'lps'),
	(449231, 124, '2015-03-15 00:13:36.000000', 'consum', 0.0212, 'lps'),
	(449232, 124, '2015-03-15 00:13:37.000000', 'consum', 0.0225, 'lps'),
	(449233, 124, '2015-03-15 00:13:38.000000', 'consum', 0.0215, 'lps'),
	(449234, 124, '2015-03-15 00:13:39.000000', 'consum', 0.0211, 'lps'),
	(449235, 124, '2015-03-15 00:13:40.000000', 'consum', 0.0224, 'lps'),
	(449236, 124, '2015-03-15 00:13:41.000000', 'consum', 0.0211, 'lps'),
	(449237, 124, '2015-03-15 00:13:42.000000', 'consum', 0.0219, 'lps'),
	(449238, 124, '2015-03-15 00:13:43.000000', 'consum', 0.0211, 'lps'),
	(449239, 124, '2015-03-15 00:13:44.000000', 'consum', 0.0229, 'lps'),
	(449240, 124, '2015-03-15 00:13:45.000000', 'consum', 0.0218, 'lps'),
	(449241, 124, '2015-03-15 00:13:46.000000', 'consum', 0.0214, 'lps'),
	(449242, 124, '2015-03-15 00:13:47.000000', 'consum', 0.0229, 'lps'),
	(449243, 124, '2015-03-15 00:13:48.000000', 'consum', 0.0210, 'lps'),
	(449244, 124, '2015-03-15 00:13:49.000000', 'consum', 0.0215, 'lps'),
	(449245, 124, '2015-03-15 00:13:50.000000', 'consum', 0.0217, 'lps'),
	(449246, 124, '2015-03-15 00:13:51.000000', 'consum', 0.0227, 'lps'),
	(449247, 124, '2015-03-15 00:13:52.000000', 'consum', 0.0213, 'lps'),
	(449248, 124, '2015-03-15 00:13:53.000000', 'consum', 0.0219, 'lps'),
	(449249, 124, '2015-03-15 00:13:54.000000', 'consum', 0.0222, 'lps'),
	(449250, 124, '2015-03-15 00:13:55.000000', 'consum', 0.0222, 'lps'),
	(449251, 124, '2015-03-15 00:13:56.000000', 'consum', 0.0216, 'lps'),
	(449252, 124, '2015-03-15 00:13:57.000000', 'consum', 0.0225, 'lps'),
	(449253, 124, '2015-03-15 00:13:58.000000', 'consum', 0.0223, 'lps'),
	(449254, 124, '2015-03-15 00:13:59.000000', 'consum', 0.0213, 'lps'),
	(449255, 124, '2015-03-15 00:14:00.000000', 'consum', 0.0225, 'lps'),
	(449256, 124, '2015-03-15 00:14:01.000000', 'consum', 0.0216, 'lps'),
	(449257, 124, '2015-03-15 00:14:02.000000', 'consum', 0.0214, 'lps'),
	(449258, 124, '2015-03-15 00:14:03.000000', 'consum', 0.0214, 'lps'),
	(449259, 124, '2015-03-15 00:14:04.000000', 'consum', 0.0218, 'lps'),
	(449260, 124, '2015-03-15 00:14:05.000000', 'consum', 0.0217, 'lps'),
	(449261, 124, '2015-03-15 00:14:06.000000', 'consum', 0.0224, 'lps'),
	(449262, 124, '2015-03-15 00:14:07.000000', 'consum', 0.0216, 'lps'),
	(449263, 124, '2015-03-15 00:14:08.000000', 'consum', 0.0220, 'lps'),
	(449264, 124, '2015-03-15 00:14:09.000000', 'consum', 0.0219, 'lps'),
	(449265, 124, '2015-03-15 00:14:10.000000', 'consum', 0.0228, 'lps'),
	(449266, 124, '2015-03-15 00:14:11.000000', 'consum', 0.0230, 'lps'),
	(449267, 124, '2015-03-15 00:14:12.000000', 'consum', 0.0213, 'lps'),
	(449268, 124, '2015-03-15 00:14:13.000000', 'consum', 0.0211, 'lps'),
	(449269, 124, '2015-03-15 00:14:14.000000', 'consum', 0.0226, 'lps'),
	(449270, 124, '2015-03-15 00:14:15.000000', 'consum', 0.0226, 'lps'),
	(449271, 124, '2015-03-15 00:14:16.000000', 'consum', 0.0219, 'lps'),
	(449272, 124, '2015-03-15 00:14:17.000000', 'consum', 0.0230, 'lps'),
	(449273, 124, '2015-03-15 00:14:18.000000', 'consum', 0.0220, 'lps'),
	(449274, 124, '2015-03-15 00:14:19.000000', 'consum', 0.0223, 'lps'),
	(449275, 124, '2015-03-15 00:14:20.000000', 'consum', 0.0223, 'lps'),
	(449276, 124, '2015-03-15 00:14:21.000000', 'consum', 0.0218, 'lps'),
	(449277, 124, '2015-03-15 00:14:22.000000', 'consum', 0.0229, 'lps'),
	(449278, 124, '2015-03-15 00:14:23.000000', 'consum', 0.0221, 'lps'),
	(449279, 124, '2015-03-15 00:14:24.000000', 'consum', 0.0228, 'lps'),
	(449280, 124, '2015-03-15 00:14:25.000000', 'consum', 0.0225, 'lps'),
	(449281, 124, '2015-03-15 00:14:26.000000', 'consum', 0.0211, 'lps'),
	(449282, 124, '2015-03-15 00:14:27.000000', 'consum', 0.0213, 'lps'),
	(449283, 124, '2015-03-15 00:14:28.000000', 'consum', 0.0224, 'lps'),
	(449284, 124, '2015-03-15 00:14:29.000000', 'consum', 0.0230, 'lps'),
	(449285, 124, '2015-03-15 00:14:30.000000', 'consum', 0.0225, 'lps'),
	(449286, 124, '2015-03-15 00:14:31.000000', 'consum', 0.0224, 'lps'),
	(449287, 124, '2015-03-15 00:14:32.000000', 'consum', 0.0215, 'lps'),
	(449288, 124, '2015-03-15 00:14:33.000000', 'consum', 0.0217, 'lps'),
	(449289, 124, '2015-03-15 00:14:34.000000', 'consum', 0.0227, 'lps'),
	(449290, 124, '2015-03-15 00:14:35.000000', 'consum', 0.0215, 'lps'),
	(449291, 124, '2015-03-15 00:14:36.000000', 'consum', 0.0224, 'lps'),
	(449292, 124, '2015-03-15 00:14:37.000000', 'consum', 0.0226, 'lps'),
	(449293, 124, '2015-03-15 00:14:38.000000', 'consum', 0.0228, 'lps'),
	(449294, 124, '2015-03-15 00:14:39.000000', 'consum', 0.0229, 'lps'),
	(449295, 124, '2015-03-15 00:14:40.000000', 'consum', 0.0229, 'lps'),
	(449296, 124, '2015-03-15 00:14:41.000000', 'consum', 0.0210, 'lps'),
	(449297, 124, '2015-03-15 00:14:42.000000', 'consum', 0.0215, 'lps'),
	(449298, 124, '2015-03-15 00:14:43.000000', 'consum', 0.0216, 'lps'),
	(449299, 124, '2015-03-15 00:14:44.000000', 'consum', 0.0224, 'lps'),
	(449300, 124, '2015-03-15 00:14:45.000000', 'consum', 0.0221, 'lps'),
	(449301, 124, '2015-03-15 00:14:46.000000', 'consum', 0.0222, 'lps'),
	(449302, 124, '2015-03-15 00:14:47.000000', 'consum', 0.0218, 'lps'),
	(449303, 124, '2015-03-15 00:14:48.000000', 'consum', 0.0214, 'lps'),
	(449304, 124, '2015-03-15 00:14:49.000000', 'consum', 0.0227, 'lps'),
	(449305, 124, '2015-03-15 00:14:50.000000', 'consum', 0.0220, 'lps'),
	(449306, 124, '2015-03-15 00:14:51.000000', 'consum', 0.0230, 'lps'),
	(449307, 124, '2015-03-15 00:14:52.000000', 'consum', 0.0217, 'lps'),
	(449308, 124, '2015-03-15 00:14:53.000000', 'consum', 0.0228, 'lps'),
	(449309, 124, '2015-03-15 00:14:54.000000', 'consum', 0.0217, 'lps'),
	(449310, 124, '2015-03-15 00:14:55.000000', 'consum', 0.0212, 'lps'),
	(449311, 124, '2015-03-15 00:14:56.000000', 'consum', 0.0220, 'lps'),
	(449312, 124, '2015-03-15 00:14:57.000000', 'consum', 0.0213, 'lps'),
	(449313, 124, '2015-03-15 00:14:58.000000', 'consum', 0.0215, 'lps'),
	(449314, 124, '2015-03-15 00:14:59.000000', 'consum', 0.0226, 'lps'),
	(449315, 124, '2015-03-15 00:15:00.000000', 'consum', 0.0214, 'lps'),
	(449316, 124, '2015-03-15 00:15:01.000000', 'consum', 0.0223, 'lps'),
	(449317, 124, '2015-03-15 00:15:02.000000', 'consum', 0.0224, 'lps'),
	(449318, 124, '2015-03-15 00:15:03.000000', 'consum', 0.0221, 'lps'),
	(449319, 124, '2015-03-15 00:15:04.000000', 'consum', 0.0224, 'lps'),
	(449320, 124, '2015-03-15 00:15:05.000000', 'consum', 0.0225, 'lps'),
	(449321, 124, '2015-03-15 00:15:06.000000', 'consum', 0.0224, 'lps'),
	(449322, 124, '2015-03-15 00:15:07.000000', 'consum', 0.0213, 'lps'),
	(449323, 124, '2015-03-15 00:15:08.000000', 'consum', 0.0225, 'lps'),
	(449324, 124, '2015-03-15 00:15:09.000000', 'consum', 0.0212, 'lps'),
	(449325, 124, '2015-03-15 00:15:10.000000', 'consum', 0.0221, 'lps'),
	(449326, 124, '2015-03-15 00:15:11.000000', 'consum', 0.0215, 'lps'),
	(449327, 124, '2015-03-15 00:15:12.000000', 'consum', 0.0226, 'lps'),
	(449328, 124, '2015-03-15 00:15:13.000000', 'consum', 0.0212, 'lps'),
	(449329, 124, '2015-03-15 00:15:14.000000', 'consum', 0.0212, 'lps'),
	(449330, 124, '2015-03-15 00:15:15.000000', 'consum', 0.0216, 'lps'),
	(449331, 124, '2015-03-15 00:15:16.000000', 'consum', 0.0211, 'lps'),
	(449332, 124, '2015-03-15 00:15:17.000000', 'consum', 0.0222, 'lps'),
	(449333, 124, '2015-03-15 00:15:18.000000', 'consum', 0.0225, 'lps'),
	(449334, 124, '2015-03-15 00:15:19.000000', 'consum', 0.0227, 'lps'),
	(449335, 124, '2015-03-15 00:15:20.000000', 'consum', 0.0230, 'lps'),
	(449336, 124, '2015-03-15 00:15:21.000000', 'consum', 0.0216, 'lps'),
	(449337, 124, '2015-03-15 00:15:22.000000', 'consum', 0.0222, 'lps'),
	(449338, 124, '2015-03-15 00:15:23.000000', 'consum', 0.0213, 'lps'),
	(449339, 124, '2015-03-15 00:15:24.000000', 'consum', 0.0210, 'lps'),
	(449340, 124, '2015-03-15 00:15:25.000000', 'consum', 0.0222, 'lps'),
	(449341, 124, '2015-03-15 00:15:26.000000', 'consum', 0.0229, 'lps'),
	(449342, 124, '2015-03-15 00:15:27.000000', 'consum', 0.0226, 'lps'),
	(449343, 124, '2015-03-15 00:15:28.000000', 'consum', 0.0213, 'lps'),
	(449344, 124, '2015-03-15 00:15:29.000000', 'consum', 0.0219, 'lps'),
	(449345, 124, '2015-03-15 00:15:30.000000', 'consum', 0.0225, 'lps'),
	(449346, 124, '2015-03-15 00:15:31.000000', 'consum', 0.0216, 'lps'),
	(449347, 124, '2015-03-15 00:15:32.000000', 'consum', 0.0216, 'lps'),
	(449348, 124, '2015-03-15 00:15:33.000000', 'consum', 0.0225, 'lps'),
	(449349, 124, '2015-03-15 00:15:34.000000', 'consum', 0.0226, 'lps'),
	(449350, 124, '2015-03-15 00:15:35.000000', 'consum', 0.0223, 'lps'),
	(449351, 124, '2015-03-15 00:15:36.000000', 'consum', 0.0228, 'lps'),
	(449352, 124, '2015-03-15 00:15:37.000000', 'consum', 0.0220, 'lps'),
	(449353, 124, '2015-03-15 00:15:38.000000', 'consum', 0.0227, 'lps'),
	(449354, 124, '2015-03-15 00:15:39.000000', 'consum', 0.0223, 'lps'),
	(449355, 124, '2015-03-15 00:15:40.000000', 'consum', 0.0224, 'lps'),
	(449356, 124, '2015-03-15 00:15:41.000000', 'consum', 0.0221, 'lps'),
	(449357, 124, '2015-03-15 00:15:42.000000', 'consum', 0.0225, 'lps'),
	(449358, 124, '2015-03-15 00:15:43.000000', 'consum', 0.0211, 'lps'),
	(449359, 124, '2015-03-15 00:15:44.000000', 'consum', 0.0210, 'lps'),
	(449360, 124, '2015-03-15 00:15:45.000000', 'consum', 0.0230, 'lps'),
	(449361, 124, '2015-03-15 00:15:46.000000', 'consum', 0.0225, 'lps'),
	(449362, 124, '2015-03-15 00:15:47.000000', 'consum', 0.0226, 'lps'),
	(449363, 124, '2015-03-15 00:15:48.000000', 'consum', 0.0224, 'lps'),
	(449364, 124, '2015-03-15 00:15:49.000000', 'consum', 0.0211, 'lps'),
	(449365, 124, '2015-03-15 00:15:50.000000', 'consum', 0.0217, 'lps'),
	(449366, 124, '2015-03-15 00:15:51.000000', 'consum', 0.0223, 'lps'),
	(449367, 124, '2015-03-15 00:15:52.000000', 'consum', 0.0211, 'lps'),
	(449368, 124, '2015-03-15 00:15:53.000000', 'consum', 0.0220, 'lps'),
	(449369, 124, '2015-03-15 00:15:54.000000', 'consum', 0.0213, 'lps'),
	(449370, 124, '2015-03-15 00:15:55.000000', 'consum', 0.0216, 'lps'),
	(449371, 124, '2015-03-15 00:15:56.000000', 'consum', 0.0210, 'lps'),
	(449372, 124, '2015-03-15 00:15:57.000000', 'consum', 0.0216, 'lps'),
	(449373, 124, '2015-03-15 00:15:58.000000', 'consum', 0.0217, 'lps'),
	(449374, 124, '2015-03-15 00:15:59.000000', 'consum', 0.0229, 'lps'),
	(449375, 124, '2015-03-15 00:16:00.000000', 'consum', 0.0222, 'lps'),
	(449376, 124, '2015-03-15 00:16:01.000000', 'consum', 0.0212, 'lps'),
	(449377, 124, '2015-03-15 00:16:02.000000', 'consum', 0.0227, 'lps'),
	(449378, 124, '2015-03-15 00:16:03.000000', 'consum', 0.0227, 'lps'),
	(449379, 124, '2015-03-15 00:16:04.000000', 'consum', 0.0222, 'lps'),
	(449380, 124, '2015-03-15 00:16:05.000000', 'consum', 0.0218, 'lps'),
	(449381, 124, '2015-03-15 00:16:06.000000', 'consum', 0.0217, 'lps'),
	(449382, 124, '2015-03-15 00:16:07.000000', 'consum', 0.0222, 'lps'),
	(449383, 124, '2015-03-15 00:16:08.000000', 'consum', 0.0226, 'lps'),
	(449384, 124, '2015-03-15 00:16:09.000000', 'consum', 0.0214, 'lps'),
	(449385, 124, '2015-03-15 00:16:10.000000', 'consum', 0.0225, 'lps'),
	(449386, 124, '2015-03-15 00:16:11.000000', 'consum', 0.0212, 'lps'),
	(449387, 124, '2015-03-15 00:16:12.000000', 'consum', 0.0215, 'lps'),
	(449388, 124, '2015-03-15 00:16:13.000000', 'consum', 0.0210, 'lps'),
	(449389, 124, '2015-03-15 00:16:14.000000', 'consum', 0.0214, 'lps'),
	(449390, 124, '2015-03-15 00:16:15.000000', 'consum', 0.0212, 'lps'),
	(449391, 124, '2015-03-15 00:16:16.000000', 'consum', 0.0229, 'lps'),
	(449392, 124, '2015-03-15 00:16:17.000000', 'consum', 0.0216, 'lps'),
	(449393, 124, '2015-03-15 00:16:18.000000', 'consum', 0.0225, 'lps'),
	(449394, 124, '2015-03-15 00:16:19.000000', 'consum', 0.0225, 'lps'),
	(449395, 124, '2015-03-15 00:16:20.000000', 'consum', 0.0221, 'lps'),
	(449396, 124, '2015-03-15 00:16:21.000000', 'consum', 0.0219, 'lps'),
	(449397, 124, '2015-03-15 00:16:22.000000', 'consum', 0.0223, 'lps'),
	(449398, 124, '2015-03-15 00:16:23.000000', 'consum', 0.0229, 'lps'),
	(449399, 124, '2015-03-15 00:16:24.000000', 'consum', 0.0225, 'lps'),
	(449400, 124, '2015-03-15 00:16:25.000000', 'consum', 0.0229, 'lps'),
	(449401, 124, '2015-03-15 00:16:26.000000', 'consum', 0.0218, 'lps'),
	(449402, 124, '2015-03-15 00:16:27.000000', 'consum', 0.0213, 'lps'),
	(449403, 124, '2015-03-15 00:16:28.000000', 'consum', 0.0222, 'lps'),
	(449404, 124, '2015-03-15 00:16:29.000000', 'consum', 0.0219, 'lps'),
	(449405, 124, '2015-03-15 00:16:30.000000', 'consum', 0.0219, 'lps'),
	(449406, 124, '2015-03-15 00:16:31.000000', 'consum', 0.0228, 'lps'),
	(449407, 124, '2015-03-15 00:16:32.000000', 'consum', 0.0210, 'lps'),
	(449408, 124, '2015-03-15 00:16:33.000000', 'consum', 0.0221, 'lps'),
	(449409, 124, '2015-03-15 00:16:34.000000', 'consum', 0.0222, 'lps'),
	(449410, 124, '2015-03-15 00:16:35.000000', 'consum', 0.0217, 'lps'),
	(449411, 124, '2015-03-15 00:16:36.000000', 'consum', 0.0229, 'lps'),
	(449412, 124, '2015-03-15 00:16:37.000000', 'consum', 0.0221, 'lps'),
	(449413, 124, '2015-03-15 00:16:38.000000', 'consum', 0.0211, 'lps'),
	(449414, 124, '2015-03-15 00:16:39.000000', 'consum', 0.0225, 'lps'),
	(449415, 124, '2015-03-15 00:16:40.000000', 'consum', 0.0217, 'lps'),
	(449416, 124, '2015-03-15 00:16:41.000000', 'consum', 0.0223, 'lps'),
	(449417, 124, '2015-03-15 00:16:42.000000', 'consum', 0.0212, 'lps'),
	(449418, 124, '2015-03-15 00:16:43.000000', 'consum', 0.0225, 'lps'),
	(449419, 124, '2015-03-15 00:16:44.000000', 'consum', 0.0218, 'lps'),
	(449420, 124, '2015-03-15 00:16:45.000000', 'consum', 0.0223, 'lps'),
	(449421, 124, '2015-03-15 00:16:46.000000', 'consum', 0.0211, 'lps'),
	(449422, 124, '2015-03-15 00:16:47.000000', 'consum', 0.0217, 'lps'),
	(449423, 124, '2015-03-15 00:16:48.000000', 'consum', 0.0221, 'lps'),
	(449424, 124, '2015-03-15 00:16:49.000000', 'consum', 0.0225, 'lps'),
	(449425, 124, '2015-03-15 00:16:50.000000', 'consum', 0.0229, 'lps'),
	(449426, 124, '2015-03-15 00:16:51.000000', 'consum', 0.0221, 'lps'),
	(449427, 124, '2015-03-15 00:16:52.000000', 'consum', 0.0230, 'lps'),
	(449428, 124, '2015-03-15 00:16:53.000000', 'consum', 0.0213, 'lps'),
	(449429, 124, '2015-03-15 00:16:54.000000', 'consum', 0.0228, 'lps'),
	(449430, 124, '2015-03-15 00:16:55.000000', 'consum', 0.0228, 'lps'),
	(449431, 124, '2015-03-15 00:16:56.000000', 'consum', 0.0226, 'lps'),
	(449432, 124, '2015-03-15 00:16:57.000000', 'consum', 0.0216, 'lps'),
	(449433, 124, '2015-03-15 00:16:58.000000', 'consum', 0.0212, 'lps'),
	(449434, 124, '2015-03-15 00:16:59.000000', 'consum', 0.0226, 'lps'),
	(449435, 124, '2015-03-15 00:17:00.000000', 'consum', 0.0221, 'lps'),
	(449436, 124, '2015-03-15 00:17:01.000000', 'consum', 0.0217, 'lps'),
	(449437, 124, '2015-03-15 00:17:02.000000', 'consum', 0.0213, 'lps'),
	(449438, 124, '2015-03-15 00:17:03.000000', 'consum', 0.0226, 'lps'),
	(449439, 124, '2015-03-15 00:17:04.000000', 'consum', 0.0220, 'lps'),
	(449440, 124, '2015-03-15 00:17:05.000000', 'consum', 0.0210, 'lps'),
	(449441, 124, '2015-03-15 00:17:06.000000', 'consum', 0.0223, 'lps'),
	(449442, 124, '2015-03-15 00:17:07.000000', 'consum', 0.0213, 'lps'),
	(449443, 124, '2015-03-15 00:17:08.000000', 'consum', 0.0227, 'lps'),
	(449444, 124, '2015-03-15 00:17:09.000000', 'consum', 0.0224, 'lps'),
	(449445, 124, '2015-03-15 00:17:10.000000', 'consum', 0.0210, 'lps'),
	(449446, 124, '2015-03-15 00:17:11.000000', 'consum', 0.0210, 'lps'),
	(449447, 124, '2015-03-15 00:17:12.000000', 'consum', 0.0212, 'lps'),
	(449448, 124, '2015-03-15 00:17:13.000000', 'consum', 0.0219, 'lps'),
	(449449, 124, '2015-03-15 00:17:14.000000', 'consum', 0.0230, 'lps'),
	(449450, 124, '2015-03-15 00:17:15.000000', 'consum', 0.0221, 'lps'),
	(449451, 124, '2015-03-15 00:17:16.000000', 'consum', 0.0226, 'lps'),
	(449452, 124, '2015-03-15 00:17:17.000000', 'consum', 0.0213, 'lps'),
	(449453, 124, '2015-03-15 00:17:18.000000', 'consum', 0.0222, 'lps'),
	(449454, 124, '2015-03-15 00:17:19.000000', 'consum', 0.0217, 'lps'),
	(449455, 124, '2015-03-15 00:17:20.000000', 'consum', 0.0230, 'lps'),
	(449456, 124, '2015-03-15 00:17:21.000000', 'consum', 0.0230, 'lps'),
	(449457, 124, '2015-03-15 00:17:22.000000', 'consum', 0.0227, 'lps'),
	(449458, 124, '2015-03-15 00:17:23.000000', 'consum', 0.0214, 'lps'),
	(449459, 124, '2015-03-15 00:17:24.000000', 'consum', 0.0221, 'lps'),
	(449460, 124, '2015-03-15 00:17:25.000000', 'consum', 0.0214, 'lps'),
	(449461, 124, '2015-03-15 00:17:26.000000', 'consum', 0.0216, 'lps'),
	(449462, 124, '2015-03-15 00:17:27.000000', 'consum', 0.0210, 'lps'),
	(449463, 124, '2015-03-15 00:17:28.000000', 'consum', 0.0214, 'lps'),
	(449464, 124, '2015-03-15 00:17:29.000000', 'consum', 0.0228, 'lps'),
	(449465, 124, '2015-03-15 00:17:30.000000', 'consum', 0.0228, 'lps'),
	(449466, 124, '2015-03-15 00:17:31.000000', 'consum', 0.0224, 'lps'),
	(449467, 124, '2015-03-15 00:17:32.000000', 'consum', 0.0226, 'lps'),
	(449468, 124, '2015-03-15 00:17:33.000000', 'consum', 0.0228, 'lps'),
	(449469, 124, '2015-03-15 00:17:34.000000', 'consum', 0.0230, 'lps'),
	(449470, 124, '2015-03-15 00:17:35.000000', 'consum', 0.0216, 'lps'),
	(449471, 124, '2015-03-15 00:17:36.000000', 'consum', 0.0222, 'lps'),
	(449472, 124, '2015-03-15 00:17:37.000000', 'consum', 0.0210, 'lps'),
	(449473, 124, '2015-03-15 00:17:38.000000', 'consum', 0.0218, 'lps'),
	(449474, 124, '2015-03-15 00:17:39.000000', 'consum', 0.0230, 'lps'),
	(449475, 124, '2015-03-15 00:17:40.000000', 'consum', 0.0221, 'lps'),
	(449476, 124, '2015-03-15 00:17:41.000000', 'consum', 0.0227, 'lps'),
	(449477, 124, '2015-03-15 00:17:42.000000', 'consum', 0.0222, 'lps'),
	(449478, 124, '2015-03-15 00:17:43.000000', 'consum', 0.0218, 'lps'),
	(449479, 124, '2015-03-15 00:17:44.000000', 'consum', 0.0213, 'lps'),
	(449480, 124, '2015-03-15 00:17:45.000000', 'consum', 0.0224, 'lps'),
	(449481, 124, '2015-03-15 00:17:46.000000', 'consum', 0.0230, 'lps'),
	(449482, 124, '2015-03-15 00:17:47.000000', 'consum', 0.0225, 'lps'),
	(449483, 124, '2015-03-15 00:17:48.000000', 'consum', 0.0228, 'lps'),
	(449484, 124, '2015-03-15 00:17:49.000000', 'consum', 0.0211, 'lps'),
	(449485, 124, '2015-03-15 00:17:50.000000', 'consum', 0.0226, 'lps'),
	(449486, 124, '2015-03-15 00:17:51.000000', 'consum', 0.0224, 'lps'),
	(449487, 124, '2015-03-15 00:17:52.000000', 'consum', 0.0211, 'lps'),
	(449488, 124, '2015-03-15 00:17:53.000000', 'consum', 0.0215, 'lps'),
	(449489, 124, '2015-03-15 00:17:54.000000', 'consum', 0.0213, 'lps'),
	(449490, 124, '2015-03-15 00:17:55.000000', 'consum', 0.0210, 'lps'),
	(449491, 124, '2015-03-15 00:17:56.000000', 'consum', 0.0222, 'lps'),
	(449492, 124, '2015-03-15 00:17:57.000000', 'consum', 0.0230, 'lps'),
	(449493, 124, '2015-03-15 00:17:58.000000', 'consum', 0.0211, 'lps'),
	(449494, 124, '2015-03-15 00:17:59.000000', 'consum', 0.0217, 'lps'),
	(449495, 124, '2015-03-15 00:18:00.000000', 'consum', 0.0221, 'lps'),
	(449496, 124, '2015-03-15 00:18:01.000000', 'consum', 0.0224, 'lps'),
	(449497, 124, '2015-03-15 00:18:02.000000', 'consum', 0.0225, 'lps'),
	(449498, 124, '2015-03-15 00:18:03.000000', 'consum', 0.0223, 'lps'),
	(449499, 124, '2015-03-15 00:18:04.000000', 'consum', 0.0230, 'lps'),
	(449500, 124, '2015-03-15 00:18:05.000000', 'consum', 0.0211, 'lps'),
	(449501, 124, '2015-03-15 00:18:06.000000', 'consum', 0.0217, 'lps'),
	(449502, 124, '2015-03-15 00:18:07.000000', 'consum', 0.0224, 'lps'),
	(449503, 124, '2015-03-15 00:18:08.000000', 'consum', 0.0214, 'lps'),
	(449504, 124, '2015-03-15 00:18:09.000000', 'consum', 0.0211, 'lps'),
	(449505, 124, '2015-03-15 00:18:10.000000', 'consum', 0.0225, 'lps'),
	(449506, 124, '2015-03-15 00:18:11.000000', 'consum', 0.0219, 'lps'),
	(449507, 124, '2015-03-15 00:18:12.000000', 'consum', 0.0213, 'lps'),
	(449508, 124, '2015-03-15 00:18:13.000000', 'consum', 0.0216, 'lps'),
	(449509, 124, '2015-03-15 00:18:14.000000', 'consum', 0.0211, 'lps'),
	(449510, 124, '2015-03-15 00:18:15.000000', 'consum', 0.0219, 'lps'),
	(449511, 124, '2015-03-15 00:18:16.000000', 'consum', 0.0211, 'lps'),
	(449512, 124, '2015-03-15 00:18:17.000000', 'consum', 0.0210, 'lps'),
	(449513, 124, '2015-03-15 00:18:18.000000', 'consum', 0.0229, 'lps'),
	(449514, 124, '2015-03-15 00:18:19.000000', 'consum', 0.0223, 'lps'),
	(449515, 124, '2015-03-15 00:18:20.000000', 'consum', 0.0215, 'lps'),
	(449516, 124, '2015-03-15 00:18:21.000000', 'consum', 0.0220, 'lps'),
	(449517, 124, '2015-03-15 00:18:22.000000', 'consum', 0.0222, 'lps'),
	(449518, 124, '2015-03-15 00:18:23.000000', 'consum', 0.0221, 'lps'),
	(449519, 124, '2015-03-15 00:18:24.000000', 'consum', 0.0228, 'lps'),
	(449520, 124, '2015-03-15 00:18:25.000000', 'consum', 0.0225, 'lps'),
	(449521, 124, '2015-03-15 00:18:26.000000', 'consum', 0.0210, 'lps'),
	(449522, 124, '2015-03-15 00:18:27.000000', 'consum', 0.0228, 'lps'),
	(449523, 124, '2015-03-15 00:18:28.000000', 'consum', 0.0218, 'lps'),
	(449524, 124, '2015-03-15 00:18:29.000000', 'consum', 0.0216, 'lps'),
	(449525, 124, '2015-03-15 00:18:30.000000', 'consum', 0.0219, 'lps'),
	(449526, 124, '2015-03-15 00:18:31.000000', 'consum', 0.0214, 'lps'),
	(449527, 124, '2015-03-15 00:18:32.000000', 'consum', 0.0227, 'lps'),
	(449528, 124, '2015-03-15 00:18:33.000000', 'consum', 0.0220, 'lps'),
	(449529, 124, '2015-03-15 00:18:34.000000', 'consum', 0.0210, 'lps'),
	(449530, 124, '2015-03-15 00:18:35.000000', 'consum', 0.0221, 'lps'),
	(449531, 124, '2015-03-15 00:18:36.000000', 'consum', 0.0224, 'lps'),
	(449532, 124, '2015-03-15 00:18:37.000000', 'consum', 0.0228, 'lps'),
	(449533, 124, '2015-03-15 00:18:38.000000', 'consum', 0.0216, 'lps'),
	(449534, 124, '2015-03-15 00:18:39.000000', 'consum', 0.0227, 'lps'),
	(449535, 124, '2015-03-15 00:18:40.000000', 'consum', 0.0217, 'lps'),
	(449536, 124, '2015-03-15 00:18:41.000000', 'consum', 0.0214, 'lps'),
	(449537, 124, '2015-03-15 00:18:42.000000', 'consum', 0.0211, 'lps'),
	(449538, 124, '2015-03-15 00:18:43.000000', 'consum', 0.0222, 'lps'),
	(449539, 124, '2015-03-15 00:18:44.000000', 'consum', 0.0226, 'lps'),
	(449540, 124, '2015-03-15 00:18:45.000000', 'consum', 0.0212, 'lps'),
	(449541, 124, '2015-03-15 00:18:46.000000', 'consum', 0.0216, 'lps'),
	(449542, 124, '2015-03-15 00:18:47.000000', 'consum', 0.0215, 'lps'),
	(449543, 124, '2015-03-15 00:18:48.000000', 'consum', 0.0215, 'lps'),
	(449544, 124, '2015-03-15 00:18:49.000000', 'consum', 0.0222, 'lps'),
	(449545, 124, '2015-03-15 00:18:50.000000', 'consum', 0.0213, 'lps'),
	(449546, 124, '2015-03-15 00:18:51.000000', 'consum', 0.0230, 'lps'),
	(449547, 124, '2015-03-15 00:18:52.000000', 'consum', 0.0217, 'lps'),
	(449548, 124, '2015-03-15 00:18:53.000000', 'consum', 0.0227, 'lps'),
	(449549, 124, '2015-03-15 00:18:54.000000', 'consum', 0.0214, 'lps'),
	(449550, 124, '2015-03-15 00:18:55.000000', 'consum', 0.0219, 'lps'),
	(449551, 124, '2015-03-15 00:18:56.000000', 'consum', 0.0223, 'lps'),
	(449552, 124, '2015-03-15 00:18:57.000000', 'consum', 0.0229, 'lps'),
	(449553, 124, '2015-03-15 00:18:58.000000', 'consum', 0.0223, 'lps'),
	(449554, 124, '2015-03-15 00:18:59.000000', 'consum', 0.0217, 'lps'),
	(449555, 124, '2015-03-15 00:19:00.000000', 'consum', 0.0229, 'lps'),
	(449556, 124, '2015-03-15 00:19:01.000000', 'consum', 0.0222, 'lps'),
	(449557, 124, '2015-03-15 00:19:02.000000', 'consum', 0.0215, 'lps'),
	(449558, 124, '2015-03-15 00:19:03.000000', 'consum', 0.0219, 'lps'),
	(449559, 124, '2015-03-15 00:19:04.000000', 'consum', 0.0218, 'lps'),
	(449560, 124, '2015-03-15 00:19:05.000000', 'consum', 0.0225, 'lps'),
	(449561, 124, '2015-03-15 00:19:06.000000', 'consum', 0.0217, 'lps'),
	(449562, 124, '2015-03-15 00:19:07.000000', 'consum', 0.0225, 'lps'),
	(449563, 124, '2015-03-15 00:19:08.000000', 'consum', 0.0220, 'lps'),
	(449564, 124, '2015-03-15 00:19:09.000000', 'consum', 0.0218, 'lps'),
	(449565, 124, '2015-03-15 00:19:10.000000', 'consum', 0.0217, 'lps'),
	(449566, 124, '2015-03-15 00:19:11.000000', 'consum', 0.0224, 'lps'),
	(449567, 124, '2015-03-15 00:19:12.000000', 'consum', 0.0218, 'lps'),
	(449568, 124, '2015-03-15 00:19:13.000000', 'consum', 0.0228, 'lps'),
	(449569, 124, '2015-03-15 00:19:14.000000', 'consum', 0.0214, 'lps'),
	(449570, 124, '2015-03-15 00:19:15.000000', 'consum', 0.0218, 'lps'),
	(449571, 124, '2015-03-15 00:19:16.000000', 'consum', 0.0217, 'lps'),
	(449572, 124, '2015-03-15 00:19:17.000000', 'consum', 0.0224, 'lps'),
	(449573, 124, '2015-03-15 00:19:18.000000', 'consum', 0.0216, 'lps'),
	(449574, 124, '2015-03-15 00:19:19.000000', 'consum', 0.0220, 'lps'),
	(449575, 124, '2015-03-15 00:19:20.000000', 'consum', 0.0220, 'lps'),
	(449576, 124, '2015-03-15 00:19:21.000000', 'consum', 0.0229, 'lps'),
	(449577, 124, '2015-03-15 00:19:22.000000', 'consum', 0.0216, 'lps'),
	(449578, 124, '2015-03-15 00:19:23.000000', 'consum', 0.0225, 'lps'),
	(449579, 124, '2015-03-15 00:19:24.000000', 'consum', 0.0225, 'lps'),
	(449580, 124, '2015-03-15 00:19:25.000000', 'consum', 0.0219, 'lps'),
	(449581, 124, '2015-03-15 00:19:26.000000', 'consum', 0.0230, 'lps'),
	(449582, 124, '2015-03-15 00:19:27.000000', 'consum', 0.0223, 'lps'),
	(449583, 124, '2015-03-15 00:19:28.000000', 'consum', 0.0216, 'lps'),
	(449584, 124, '2015-03-15 00:19:29.000000', 'consum', 0.0222, 'lps'),
	(449585, 124, '2015-03-15 00:19:30.000000', 'consum', 0.0211, 'lps'),
	(449586, 124, '2015-03-15 00:19:31.000000', 'consum', 0.0221, 'lps'),
	(449587, 124, '2015-03-15 00:19:32.000000', 'consum', 0.0222, 'lps'),
	(449588, 124, '2015-03-15 00:19:33.000000', 'consum', 0.0215, 'lps'),
	(449589, 124, '2015-03-15 00:19:34.000000', 'consum', 0.0219, 'lps'),
	(449590, 124, '2015-03-15 00:19:35.000000', 'consum', 0.0222, 'lps'),
	(449591, 124, '2015-03-15 00:19:36.000000', 'consum', 0.0222, 'lps'),
	(449592, 124, '2015-03-15 00:19:37.000000', 'consum', 0.0213, 'lps'),
	(449593, 124, '2015-03-15 00:19:38.000000', 'consum', 0.0230, 'lps'),
	(449594, 124, '2015-03-15 00:19:39.000000', 'consum', 0.0219, 'lps'),
	(449595, 124, '2015-03-15 00:19:40.000000', 'consum', 0.0215, 'lps'),
	(449596, 124, '2015-03-15 00:19:41.000000', 'consum', 0.0210, 'lps'),
	(449597, 124, '2015-03-15 00:19:42.000000', 'consum', 0.0215, 'lps'),
	(449598, 124, '2015-03-15 00:19:43.000000', 'consum', 0.0217, 'lps'),
	(449599, 124, '2015-03-15 00:19:44.000000', 'consum', 0.0230, 'lps'),
	(449600, 124, '2015-03-15 00:19:45.000000', 'consum', 0.0227, 'lps'),
	(449601, 124, '2015-03-15 00:19:46.000000', 'consum', 0.0212, 'lps'),
	(449602, 124, '2015-03-15 00:19:47.000000', 'consum', 0.0212, 'lps'),
	(449603, 124, '2015-03-15 00:19:48.000000', 'consum', 0.0215, 'lps'),
	(449604, 124, '2015-03-15 00:19:49.000000', 'consum', 0.0230, 'lps'),
	(449605, 124, '2015-03-15 00:19:50.000000', 'consum', 0.0210, 'lps'),
	(449606, 124, '2015-03-15 00:19:51.000000', 'consum', 0.0216, 'lps'),
	(449607, 124, '2015-03-15 00:19:52.000000', 'consum', 0.0220, 'lps'),
	(449608, 124, '2015-03-15 00:19:53.000000', 'consum', 0.0221, 'lps'),
	(449609, 124, '2015-03-15 00:19:54.000000', 'consum', 0.0213, 'lps'),
	(449610, 124, '2015-03-15 00:19:55.000000', 'consum', 0.0212, 'lps'),
	(449611, 124, '2015-03-15 00:19:56.000000', 'consum', 0.0214, 'lps'),
	(449612, 124, '2015-03-15 00:19:57.000000', 'consum', 0.0222, 'lps'),
	(449613, 124, '2015-03-15 00:19:58.000000', 'consum', 0.0219, 'lps'),
	(449614, 124, '2015-03-15 00:19:59.000000', 'consum', 0.0220, 'lps'),
	(449615, 124, '2015-03-15 00:20:00.000000', 'consum', 0.0212, 'lps'),
	(449616, 124, '2015-03-15 00:20:01.000000', 'consum', 0.0211, 'lps'),
	(449617, 124, '2015-03-15 00:20:02.000000', 'consum', 0.0210, 'lps'),
	(449618, 124, '2015-03-15 00:20:03.000000', 'consum', 0.0230, 'lps'),
	(449619, 124, '2015-03-15 00:20:04.000000', 'consum', 0.0226, 'lps'),
	(449620, 124, '2015-03-15 00:20:05.000000', 'consum', 0.0230, 'lps'),
	(449621, 124, '2015-03-15 00:20:06.000000', 'consum', 0.0218, 'lps'),
	(449622, 124, '2015-03-15 00:20:07.000000', 'consum', 0.0215, 'lps'),
	(449623, 124, '2015-03-15 00:20:08.000000', 'consum', 0.0211, 'lps'),
	(449624, 124, '2015-03-15 00:20:09.000000', 'consum', 0.0219, 'lps'),
	(449625, 124, '2015-03-15 00:20:10.000000', 'consum', 0.0213, 'lps'),
	(449626, 124, '2015-03-15 00:20:11.000000', 'consum', 0.0220, 'lps'),
	(449627, 124, '2015-03-15 00:20:12.000000', 'consum', 0.0210, 'lps'),
	(449628, 124, '2015-03-15 00:20:13.000000', 'consum', 0.0222, 'lps'),
	(449629, 124, '2015-03-15 00:20:14.000000', 'consum', 0.0230, 'lps'),
	(449630, 124, '2015-03-15 00:20:15.000000', 'consum', 0.0229, 'lps'),
	(449631, 124, '2015-03-15 00:20:16.000000', 'consum', 0.0227, 'lps'),
	(449632, 124, '2015-03-15 00:20:17.000000', 'consum', 0.0219, 'lps'),
	(449633, 124, '2015-03-15 00:20:18.000000', 'consum', 0.0224, 'lps'),
	(449634, 124, '2015-03-15 00:20:19.000000', 'consum', 0.0211, 'lps'),
	(449635, 124, '2015-03-15 00:20:20.000000', 'consum', 0.0215, 'lps'),
	(449636, 124, '2015-03-15 00:20:21.000000', 'consum', 0.0212, 'lps'),
	(449637, 124, '2015-03-15 00:20:22.000000', 'consum', 0.0227, 'lps'),
	(449638, 124, '2015-03-15 00:20:23.000000', 'consum', 0.0228, 'lps'),
	(449639, 124, '2015-03-15 00:20:24.000000', 'consum', 0.0228, 'lps'),
	(449640, 124, '2015-03-15 00:20:25.000000', 'consum', 0.0225, 'lps'),
	(449641, 124, '2015-03-15 00:20:26.000000', 'consum', 0.0210, 'lps'),
	(449642, 124, '2015-03-15 00:20:27.000000', 'consum', 0.0227, 'lps'),
	(449643, 124, '2015-03-15 00:20:28.000000', 'consum', 0.0215, 'lps'),
	(449644, 124, '2015-03-15 00:20:29.000000', 'consum', 0.0223, 'lps'),
	(449645, 124, '2015-03-15 00:20:30.000000', 'consum', 0.0220, 'lps'),
	(449646, 124, '2015-03-15 00:20:31.000000', 'consum', 0.0220, 'lps'),
	(449647, 124, '2015-03-15 00:20:32.000000', 'consum', 0.0230, 'lps'),
	(449648, 124, '2015-03-15 00:20:33.000000', 'consum', 0.0220, 'lps'),
	(449649, 124, '2015-03-15 00:20:34.000000', 'consum', 0.0220, 'lps'),
	(449650, 124, '2015-03-15 00:20:35.000000', 'consum', 0.0210, 'lps'),
	(449651, 124, '2015-03-15 00:20:36.000000', 'consum', 0.0222, 'lps'),
	(449652, 124, '2015-03-15 00:20:37.000000', 'consum', 0.0229, 'lps'),
	(449653, 124, '2015-03-15 00:20:38.000000', 'consum', 0.0227, 'lps'),
	(449654, 124, '2015-03-15 00:20:39.000000', 'consum', 0.0220, 'lps'),
	(449655, 124, '2015-03-15 00:20:40.000000', 'consum', 0.0227, 'lps'),
	(449656, 124, '2015-03-15 00:20:41.000000', 'consum', 0.0227, 'lps'),
	(449657, 124, '2015-03-15 00:20:42.000000', 'consum', 0.0220, 'lps'),
	(449658, 124, '2015-03-15 00:20:43.000000', 'consum', 0.0212, 'lps'),
	(449659, 124, '2015-03-15 00:20:44.000000', 'consum', 0.0210, 'lps'),
	(449660, 124, '2015-03-15 00:20:45.000000', 'consum', 0.0228, 'lps'),
	(449661, 124, '2015-03-15 00:20:46.000000', 'consum', 0.0215, 'lps'),
	(449662, 124, '2015-03-15 00:20:47.000000', 'consum', 0.0222, 'lps'),
	(449663, 124, '2015-03-15 00:20:48.000000', 'consum', 0.0216, 'lps'),
	(449664, 124, '2015-03-15 00:20:49.000000', 'consum', 0.0226, 'lps'),
	(449665, 124, '2015-03-15 00:20:50.000000', 'consum', 0.0230, 'lps'),
	(449666, 124, '2015-03-15 00:20:51.000000', 'consum', 0.0221, 'lps'),
	(449667, 124, '2015-03-15 00:20:52.000000', 'consum', 0.0228, 'lps'),
	(449668, 124, '2015-03-15 00:20:53.000000', 'consum', 0.0222, 'lps'),
	(449669, 124, '2015-03-15 00:20:54.000000', 'consum', 0.0219, 'lps'),
	(449670, 124, '2015-03-15 00:20:55.000000', 'consum', 0.0217, 'lps'),
	(449671, 124, '2015-03-15 00:20:56.000000', 'consum', 0.0218, 'lps'),
	(449672, 124, '2015-03-15 00:20:57.000000', 'consum', 0.0211, 'lps'),
	(449673, 124, '2015-03-15 00:20:58.000000', 'consum', 0.0213, 'lps'),
	(449674, 124, '2015-03-15 00:20:59.000000', 'consum', 0.0220, 'lps'),
	(449675, 124, '2015-03-15 00:21:00.000000', 'consum', 0.0212, 'lps'),
	(449676, 124, '2015-03-15 00:21:01.000000', 'consum', 0.0230, 'lps'),
	(449677, 124, '2015-03-15 00:21:02.000000', 'consum', 0.0221, 'lps'),
	(449678, 124, '2015-03-15 00:21:03.000000', 'consum', 0.0228, 'lps'),
	(449679, 124, '2015-03-15 00:21:04.000000', 'consum', 0.0226, 'lps'),
	(449680, 124, '2015-03-15 00:21:05.000000', 'consum', 0.0213, 'lps'),
	(449681, 124, '2015-03-15 00:21:06.000000', 'consum', 0.0219, 'lps'),
	(449682, 124, '2015-03-15 00:21:07.000000', 'consum', 0.0228, 'lps'),
	(449683, 124, '2015-03-15 00:21:08.000000', 'consum', 0.0230, 'lps'),
	(449684, 124, '2015-03-15 00:21:09.000000', 'consum', 0.0217, 'lps'),
	(449685, 124, '2015-03-15 00:21:10.000000', 'consum', 0.0225, 'lps'),
	(449686, 124, '2015-03-15 00:21:11.000000', 'consum', 0.0223, 'lps'),
	(449687, 124, '2015-03-15 00:21:12.000000', 'consum', 0.0212, 'lps'),
	(449688, 124, '2015-03-15 00:21:13.000000', 'consum', 0.0220, 'lps'),
	(449689, 124, '2015-03-15 00:21:14.000000', 'consum', 0.0215, 'lps'),
	(449690, 124, '2015-03-15 00:21:15.000000', 'consum', 0.0225, 'lps'),
	(449691, 124, '2015-03-15 00:21:16.000000', 'consum', 0.0210, 'lps'),
	(449692, 124, '2015-03-15 00:21:17.000000', 'consum', 0.0225, 'lps'),
	(449693, 124, '2015-03-15 00:21:18.000000', 'consum', 0.0224, 'lps'),
	(449694, 124, '2015-03-15 00:21:19.000000', 'consum', 0.0215, 'lps'),
	(449695, 124, '2015-03-15 00:21:20.000000', 'consum', 0.0216, 'lps'),
	(449696, 124, '2015-03-15 00:21:21.000000', 'consum', 0.0225, 'lps'),
	(449697, 124, '2015-03-15 00:21:22.000000', 'consum', 0.0223, 'lps'),
	(449698, 124, '2015-03-15 00:21:23.000000', 'consum', 0.0212, 'lps'),
	(449699, 124, '2015-03-15 00:21:24.000000', 'consum', 0.0222, 'lps'),
	(449700, 124, '2015-03-15 00:21:25.000000', 'consum', 0.0222, 'lps'),
	(449701, 124, '2015-03-15 00:21:26.000000', 'consum', 0.0214, 'lps'),
	(449702, 124, '2015-03-15 00:21:27.000000', 'consum', 0.0214, 'lps'),
	(449703, 124, '2015-03-15 00:21:28.000000', 'consum', 0.0221, 'lps'),
	(449704, 124, '2015-03-15 00:21:29.000000', 'consum', 0.0211, 'lps'),
	(449705, 124, '2015-03-15 00:21:30.000000', 'consum', 0.0223, 'lps'),
	(449706, 124, '2015-03-15 00:21:31.000000', 'consum', 0.0212, 'lps'),
	(449707, 124, '2015-03-15 00:21:32.000000', 'consum', 0.0223, 'lps'),
	(449708, 124, '2015-03-15 00:21:33.000000', 'consum', 0.0226, 'lps'),
	(449709, 124, '2015-03-15 00:21:34.000000', 'consum', 0.0229, 'lps'),
	(449710, 124, '2015-03-15 00:21:35.000000', 'consum', 0.0219, 'lps'),
	(449711, 124, '2015-03-15 00:21:36.000000', 'consum', 0.0218, 'lps'),
	(449712, 124, '2015-03-15 00:21:37.000000', 'consum', 0.0225, 'lps'),
	(449713, 124, '2015-03-15 00:21:38.000000', 'consum', 0.0219, 'lps'),
	(449714, 124, '2015-03-15 00:21:39.000000', 'consum', 0.0212, 'lps'),
	(449715, 124, '2015-03-15 00:21:40.000000', 'consum', 0.0214, 'lps'),
	(449716, 124, '2015-03-15 00:21:41.000000', 'consum', 0.0225, 'lps'),
	(449717, 124, '2015-03-15 00:21:42.000000', 'consum', 0.0211, 'lps'),
	(449718, 124, '2015-03-15 00:21:43.000000', 'consum', 0.0212, 'lps'),
	(449719, 124, '2015-03-15 00:21:44.000000', 'consum', 0.0219, 'lps'),
	(449720, 124, '2015-03-15 00:21:45.000000', 'consum', 0.0226, 'lps'),
	(449721, 124, '2015-03-15 00:21:46.000000', 'consum', 0.0221, 'lps'),
	(449722, 124, '2015-03-15 00:21:47.000000', 'consum', 0.0218, 'lps'),
	(449723, 124, '2015-03-15 00:21:48.000000', 'consum', 0.0217, 'lps'),
	(449724, 124, '2015-03-15 00:21:49.000000', 'consum', 0.0223, 'lps'),
	(449725, 124, '2015-03-15 00:21:50.000000', 'consum', 0.0212, 'lps'),
	(449726, 124, '2015-03-15 00:21:51.000000', 'consum', 0.0223, 'lps'),
	(449727, 124, '2015-03-15 00:21:52.000000', 'consum', 0.0229, 'lps'),
	(449728, 124, '2015-03-15 00:21:53.000000', 'consum', 0.0225, 'lps'),
	(449729, 124, '2015-03-15 00:21:54.000000', 'consum', 0.0229, 'lps'),
	(449730, 124, '2015-03-15 00:21:55.000000', 'consum', 0.0217, 'lps'),
	(449731, 124, '2015-03-15 00:21:56.000000', 'consum', 0.0211, 'lps'),
	(449732, 124, '2015-03-15 00:21:57.000000', 'consum', 0.0214, 'lps'),
	(449733, 124, '2015-03-15 00:21:58.000000', 'consum', 0.0230, 'lps'),
	(449734, 124, '2015-03-15 00:21:59.000000', 'consum', 0.0214, 'lps'),
	(449735, 124, '2015-03-15 00:22:00.000000', 'consum', 0.0210, 'lps'),
	(449736, 124, '2015-03-15 00:22:01.000000', 'consum', 0.0221, 'lps'),
	(449737, 124, '2015-03-15 00:22:02.000000', 'consum', 0.0223, 'lps'),
	(449738, 124, '2015-03-15 00:22:03.000000', 'consum', 0.0223, 'lps'),
	(449739, 124, '2015-03-15 00:22:04.000000', 'consum', 0.0214, 'lps'),
	(449740, 124, '2015-03-15 00:22:05.000000', 'consum', 0.0215, 'lps'),
	(449741, 124, '2015-03-15 00:22:06.000000', 'consum', 0.0221, 'lps'),
	(449742, 124, '2015-03-15 00:22:07.000000', 'consum', 0.0211, 'lps'),
	(449743, 124, '2015-03-15 00:22:08.000000', 'consum', 0.0223, 'lps'),
	(449744, 124, '2015-03-15 00:22:09.000000', 'consum', 0.0211, 'lps'),
	(449745, 124, '2015-03-15 00:22:10.000000', 'consum', 0.0219, 'lps'),
	(449746, 124, '2015-03-15 00:22:11.000000', 'consum', 0.0212, 'lps'),
	(449747, 124, '2015-03-15 00:22:12.000000', 'consum', 0.0211, 'lps'),
	(449748, 124, '2015-03-15 00:22:13.000000', 'consum', 0.0211, 'lps'),
	(449749, 124, '2015-03-15 00:22:14.000000', 'consum', 0.0214, 'lps'),
	(449750, 124, '2015-03-15 00:22:15.000000', 'consum', 0.0225, 'lps'),
	(449751, 124, '2015-03-15 00:22:16.000000', 'consum', 0.0213, 'lps'),
	(449752, 124, '2015-03-15 00:22:17.000000', 'consum', 0.0219, 'lps'),
	(449753, 124, '2015-03-15 00:22:18.000000', 'consum', 0.0228, 'lps'),
	(449754, 124, '2015-03-15 00:22:19.000000', 'consum', 0.0212, 'lps'),
	(449755, 124, '2015-03-15 00:22:20.000000', 'consum', 0.0228, 'lps'),
	(449756, 124, '2015-03-15 00:22:21.000000', 'consum', 0.0211, 'lps'),
	(449757, 124, '2015-03-15 00:22:22.000000', 'consum', 0.0224, 'lps'),
	(449758, 124, '2015-03-15 00:22:23.000000', 'consum', 0.0214, 'lps'),
	(449759, 124, '2015-03-15 00:22:24.000000', 'consum', 0.0210, 'lps'),
	(449760, 124, '2015-03-15 00:22:25.000000', 'consum', 0.0220, 'lps'),
	(449761, 124, '2015-03-15 00:22:26.000000', 'consum', 0.0216, 'lps'),
	(449762, 124, '2015-03-15 00:22:27.000000', 'consum', 0.0213, 'lps'),
	(449763, 124, '2015-03-15 00:22:28.000000', 'consum', 0.0229, 'lps'),
	(449764, 124, '2015-03-15 00:22:29.000000', 'consum', 0.0211, 'lps'),
	(449765, 124, '2015-03-15 00:22:30.000000', 'consum', 0.0221, 'lps'),
	(449766, 124, '2015-03-15 00:22:31.000000', 'consum', 0.0221, 'lps'),
	(449767, 124, '2015-03-15 00:22:32.000000', 'consum', 0.0213, 'lps'),
	(449768, 124, '2015-03-15 00:22:33.000000', 'consum', 0.0211, 'lps'),
	(449769, 124, '2015-03-15 00:22:34.000000', 'consum', 0.0230, 'lps'),
	(449770, 124, '2015-03-15 00:22:35.000000', 'consum', 0.0224, 'lps'),
	(449771, 124, '2015-03-15 00:22:36.000000', 'consum', 0.0219, 'lps'),
	(449772, 124, '2015-03-15 00:22:37.000000', 'consum', 0.0213, 'lps'),
	(449773, 124, '2015-03-15 00:22:38.000000', 'consum', 0.0220, 'lps'),
	(449774, 124, '2015-03-15 00:22:39.000000', 'consum', 0.0211, 'lps'),
	(449775, 124, '2015-03-15 00:22:40.000000', 'consum', 0.0226, 'lps'),
	(449776, 124, '2015-03-15 00:22:41.000000', 'consum', 0.0223, 'lps'),
	(449777, 124, '2015-03-15 00:22:42.000000', 'consum', 0.0230, 'lps'),
	(449778, 124, '2015-03-15 00:22:43.000000', 'consum', 0.0228, 'lps'),
	(449779, 124, '2015-03-15 00:22:44.000000', 'consum', 0.0218, 'lps'),
	(449780, 124, '2015-03-15 00:22:45.000000', 'consum', 0.0219, 'lps'),
	(449781, 124, '2015-03-15 00:22:46.000000', 'consum', 0.0230, 'lps'),
	(449782, 124, '2015-03-15 00:22:47.000000', 'consum', 0.0223, 'lps'),
	(449783, 124, '2015-03-15 00:22:48.000000', 'consum', 0.0212, 'lps'),
	(449784, 124, '2015-03-15 00:22:49.000000', 'consum', 0.0226, 'lps'),
	(449785, 124, '2015-03-15 00:22:50.000000', 'consum', 0.0223, 'lps'),
	(449786, 124, '2015-03-15 00:22:51.000000', 'consum', 0.0226, 'lps'),
	(449787, 124, '2015-03-15 00:22:52.000000', 'consum', 0.0229, 'lps'),
	(449788, 124, '2015-03-15 00:22:53.000000', 'consum', 0.0218, 'lps'),
	(449789, 124, '2015-03-15 00:22:54.000000', 'consum', 0.0212, 'lps'),
	(449790, 124, '2015-03-15 00:22:55.000000', 'consum', 0.0218, 'lps'),
	(449791, 124, '2015-03-15 00:22:56.000000', 'consum', 0.0223, 'lps'),
	(449792, 124, '2015-03-15 00:22:57.000000', 'consum', 0.0230, 'lps'),
	(449793, 124, '2015-03-15 00:22:58.000000', 'consum', 0.0228, 'lps'),
	(449794, 124, '2015-03-15 00:22:59.000000', 'consum', 0.0223, 'lps'),
	(449795, 124, '2015-03-15 00:23:00.000000', 'consum', 0.0221, 'lps'),
	(449796, 124, '2015-03-15 00:23:01.000000', 'consum', 0.0226, 'lps'),
	(449797, 124, '2015-03-15 00:23:02.000000', 'consum', 0.0217, 'lps'),
	(449798, 124, '2015-03-15 00:23:03.000000', 'consum', 0.0216, 'lps'),
	(449799, 124, '2015-03-15 00:23:04.000000', 'consum', 0.0222, 'lps'),
	(449800, 124, '2015-03-15 00:23:05.000000', 'consum', 0.0210, 'lps'),
	(449801, 124, '2015-03-15 00:23:06.000000', 'consum', 0.0214, 'lps'),
	(449802, 124, '2015-03-15 00:23:07.000000', 'consum', 0.0211, 'lps'),
	(449803, 124, '2015-03-15 00:23:08.000000', 'consum', 0.0226, 'lps'),
	(449804, 124, '2015-03-15 00:23:09.000000', 'consum', 0.0223, 'lps'),
	(449805, 124, '2015-03-15 00:23:10.000000', 'consum', 0.0228, 'lps'),
	(449806, 124, '2015-03-15 00:23:11.000000', 'consum', 0.0220, 'lps'),
	(449807, 124, '2015-03-15 00:23:12.000000', 'consum', 0.0228, 'lps'),
	(449808, 124, '2015-03-15 00:23:13.000000', 'consum', 0.0227, 'lps'),
	(449809, 124, '2015-03-15 00:23:14.000000', 'consum', 0.0223, 'lps'),
	(449810, 124, '2015-03-15 00:23:15.000000', 'consum', 0.0224, 'lps'),
	(449811, 124, '2015-03-15 00:23:16.000000', 'consum', 0.0218, 'lps'),
	(449812, 124, '2015-03-15 00:23:17.000000', 'consum', 0.0230, 'lps'),
	(449813, 124, '2015-03-15 00:23:18.000000', 'consum', 0.0224, 'lps'),
	(449814, 124, '2015-03-15 00:23:19.000000', 'consum', 0.0221, 'lps'),
	(449815, 124, '2015-03-15 00:23:20.000000', 'consum', 0.0223, 'lps'),
	(449816, 124, '2015-03-15 00:23:21.000000', 'consum', 0.0221, 'lps'),
	(449817, 124, '2015-03-15 00:23:22.000000', 'consum', 0.0229, 'lps'),
	(449818, 124, '2015-03-15 00:23:23.000000', 'consum', 0.0228, 'lps'),
	(449819, 124, '2015-03-15 00:23:24.000000', 'consum', 0.0221, 'lps'),
	(449820, 124, '2015-03-15 00:23:25.000000', 'consum', 0.0214, 'lps'),
	(449821, 124, '2015-03-15 00:23:26.000000', 'consum', 0.0217, 'lps'),
	(449822, 124, '2015-03-15 00:23:27.000000', 'consum', 0.0215, 'lps'),
	(449823, 124, '2015-03-15 00:23:28.000000', 'consum', 0.0213, 'lps'),
	(449824, 124, '2015-03-15 00:23:29.000000', 'consum', 0.0211, 'lps'),
	(449825, 124, '2015-03-15 00:23:30.000000', 'consum', 0.0227, 'lps'),
	(449826, 124, '2015-03-15 00:23:31.000000', 'consum', 0.0211, 'lps'),
	(449827, 124, '2015-03-15 00:23:32.000000', 'consum', 0.0224, 'lps'),
	(449828, 124, '2015-03-15 00:23:33.000000', 'consum', 0.0216, 'lps'),
	(449829, 124, '2015-03-15 00:23:34.000000', 'consum', 0.0218, 'lps'),
	(449830, 124, '2015-03-15 00:23:35.000000', 'consum', 0.0213, 'lps'),
	(449831, 124, '2015-03-15 00:23:36.000000', 'consum', 0.0221, 'lps'),
	(449832, 124, '2015-03-15 00:23:37.000000', 'consum', 0.0217, 'lps'),
	(449833, 124, '2015-03-15 00:23:38.000000', 'consum', 0.0210, 'lps'),
	(449834, 124, '2015-03-15 00:23:39.000000', 'consum', 0.0210, 'lps'),
	(449835, 124, '2015-03-15 00:23:40.000000', 'consum', 0.0212, 'lps'),
	(449836, 124, '2015-03-15 00:23:41.000000', 'consum', 0.0220, 'lps'),
	(449837, 124, '2015-03-15 00:23:42.000000', 'consum', 0.0214, 'lps'),
	(449838, 124, '2015-03-15 00:23:43.000000', 'consum', 0.0221, 'lps'),
	(449839, 124, '2015-03-15 00:23:44.000000', 'consum', 0.0210, 'lps'),
	(449840, 124, '2015-03-15 00:23:45.000000', 'consum', 0.0219, 'lps'),
	(449841, 124, '2015-03-15 00:23:46.000000', 'consum', 0.0216, 'lps'),
	(449842, 124, '2015-03-15 00:23:47.000000', 'consum', 0.0213, 'lps'),
	(449843, 124, '2015-03-15 00:23:48.000000', 'consum', 0.0226, 'lps'),
	(449844, 124, '2015-03-15 00:23:49.000000', 'consum', 0.0220, 'lps'),
	(449845, 124, '2015-03-15 00:23:50.000000', 'consum', 0.0211, 'lps'),
	(449846, 124, '2015-03-15 00:23:51.000000', 'consum', 0.0230, 'lps'),
	(449847, 124, '2015-03-15 00:23:52.000000', 'consum', 0.0221, 'lps'),
	(449848, 124, '2015-03-15 00:23:53.000000', 'consum', 0.0230, 'lps'),
	(449849, 124, '2015-03-15 00:23:54.000000', 'consum', 0.0211, 'lps'),
	(449850, 124, '2015-03-15 00:23:55.000000', 'consum', 0.0221, 'lps'),
	(449851, 124, '2015-03-15 00:23:56.000000', 'consum', 0.0220, 'lps'),
	(449852, 124, '2015-03-15 00:23:57.000000', 'consum', 0.0226, 'lps'),
	(449853, 124, '2015-03-15 00:23:58.000000', 'consum', 0.0218, 'lps'),
	(449854, 124, '2015-03-15 00:23:59.000000', 'consum', 0.0226, 'lps'),
	(449855, 124, '2015-03-15 00:24:00.000000', 'consum', 0.0223, 'lps'),
	(449856, 124, '2015-03-15 00:24:01.000000', 'consum', 0.0228, 'lps'),
	(449857, 124, '2015-03-15 00:24:02.000000', 'consum', 0.0221, 'lps'),
	(449858, 124, '2015-03-15 00:24:03.000000', 'consum', 0.0230, 'lps'),
	(449859, 124, '2015-03-15 00:24:04.000000', 'consum', 0.0214, 'lps'),
	(449860, 124, '2015-03-15 00:24:05.000000', 'consum', 0.0214, 'lps'),
	(449861, 124, '2015-03-15 00:24:06.000000', 'consum', 0.0217, 'lps'),
	(449862, 124, '2015-03-15 00:24:07.000000', 'consum', 0.0214, 'lps'),
	(449863, 124, '2015-03-15 00:24:08.000000', 'consum', 0.0229, 'lps'),
	(449864, 124, '2015-03-15 00:24:09.000000', 'consum', 0.0212, 'lps'),
	(449865, 124, '2015-03-15 00:24:10.000000', 'consum', 0.0226, 'lps'),
	(449866, 124, '2015-03-15 00:24:11.000000', 'consum', 0.0222, 'lps'),
	(449867, 124, '2015-03-15 00:24:12.000000', 'consum', 0.0222, 'lps'),
	(449868, 124, '2015-03-15 00:24:13.000000', 'consum', 0.0214, 'lps'),
	(449869, 124, '2015-03-15 00:24:14.000000', 'consum', 0.0213, 'lps'),
	(449870, 124, '2015-03-15 00:24:15.000000', 'consum', 0.0217, 'lps'),
	(449871, 124, '2015-03-15 00:24:16.000000', 'consum', 0.0214, 'lps'),
	(449872, 124, '2015-03-15 00:24:17.000000', 'consum', 0.0229, 'lps'),
	(449873, 124, '2015-03-15 00:24:18.000000', 'consum', 0.0230, 'lps'),
	(449874, 124, '2015-03-15 00:24:19.000000', 'consum', 0.0215, 'lps'),
	(449875, 124, '2015-03-15 00:24:20.000000', 'consum', 0.0215, 'lps'),
	(449876, 124, '2015-03-15 00:24:21.000000', 'consum', 0.0220, 'lps'),
	(449877, 124, '2015-03-15 00:24:22.000000', 'consum', 0.0223, 'lps'),
	(449878, 124, '2015-03-15 00:24:23.000000', 'consum', 0.0227, 'lps'),
	(449879, 124, '2015-03-15 00:24:24.000000', 'consum', 0.0215, 'lps'),
	(449880, 124, '2015-03-15 00:24:25.000000', 'consum', 0.0228, 'lps'),
	(449881, 124, '2015-03-15 00:24:26.000000', 'consum', 0.0219, 'lps'),
	(449882, 124, '2015-03-15 00:24:27.000000', 'consum', 0.0223, 'lps'),
	(449883, 124, '2015-03-15 00:24:28.000000', 'consum', 0.0228, 'lps'),
	(449884, 124, '2015-03-15 00:24:29.000000', 'consum', 0.0221, 'lps'),
	(449885, 124, '2015-03-15 00:24:30.000000', 'consum', 0.0230, 'lps'),
	(449886, 124, '2015-03-15 00:24:31.000000', 'consum', 0.0214, 'lps'),
	(449887, 124, '2015-03-15 00:24:32.000000', 'consum', 0.0215, 'lps'),
	(449888, 124, '2015-03-15 00:24:33.000000', 'consum', 0.0220, 'lps'),
	(449889, 124, '2015-03-15 00:24:34.000000', 'consum', 0.0228, 'lps'),
	(449890, 124, '2015-03-15 00:24:35.000000', 'consum', 0.0228, 'lps'),
	(449891, 124, '2015-03-15 00:24:36.000000', 'consum', 0.0225, 'lps'),
	(449892, 124, '2015-03-15 00:24:37.000000', 'consum', 0.0212, 'lps'),
	(449893, 124, '2015-03-15 00:24:38.000000', 'consum', 0.0218, 'lps'),
	(449894, 124, '2015-03-15 00:24:39.000000', 'consum', 0.0221, 'lps'),
	(449895, 124, '2015-03-15 00:24:40.000000', 'consum', 0.0223, 'lps'),
	(449896, 124, '2015-03-15 00:24:41.000000', 'consum', 0.0220, 'lps'),
	(449897, 124, '2015-03-15 00:24:42.000000', 'consum', 0.0223, 'lps'),
	(449898, 124, '2015-03-15 00:24:43.000000', 'consum', 0.0222, 'lps'),
	(449899, 124, '2015-03-15 00:24:44.000000', 'consum', 0.0212, 'lps'),
	(449900, 124, '2015-03-15 00:24:45.000000', 'consum', 0.0224, 'lps'),
	(449901, 124, '2015-03-15 00:24:46.000000', 'consum', 0.0214, 'lps'),
	(449902, 124, '2015-03-15 00:24:47.000000', 'consum', 0.0230, 'lps'),
	(449903, 124, '2015-03-15 00:24:48.000000', 'consum', 0.0213, 'lps'),
	(449904, 124, '2015-03-15 00:24:49.000000', 'consum', 0.0228, 'lps'),
	(449905, 124, '2015-03-15 00:24:50.000000', 'consum', 0.0229, 'lps'),
	(449906, 124, '2015-03-15 00:24:51.000000', 'consum', 0.0212, 'lps'),
	(449907, 124, '2015-03-15 00:24:52.000000', 'consum', 0.0225, 'lps'),
	(449908, 124, '2015-03-15 00:24:53.000000', 'consum', 0.0216, 'lps'),
	(449909, 124, '2015-03-15 00:24:54.000000', 'consum', 0.0217, 'lps'),
	(449910, 124, '2015-03-15 00:24:55.000000', 'consum', 0.0227, 'lps'),
	(449911, 124, '2015-03-15 00:24:56.000000', 'consum', 0.0213, 'lps'),
	(449912, 124, '2015-03-15 00:24:57.000000', 'consum', 0.0217, 'lps'),
	(449913, 124, '2015-03-15 00:24:58.000000', 'consum', 0.0213, 'lps'),
	(449914, 124, '2015-03-15 00:24:59.000000', 'consum', 0.0226, 'lps'),
	(449915, 124, '2015-03-15 00:25:00.000000', 'consum', 0.0221, 'lps'),
	(449916, 124, '2015-03-15 00:25:01.000000', 'consum', 0.0215, 'lps'),
	(449917, 124, '2015-03-15 00:25:02.000000', 'consum', 0.0224, 'lps'),
	(449918, 124, '2015-03-15 00:25:03.000000', 'consum', 0.0224, 'lps'),
	(449919, 124, '2015-03-15 00:25:04.000000', 'consum', 0.0218, 'lps'),
	(449920, 124, '2015-03-15 00:25:05.000000', 'consum', 0.0230, 'lps'),
	(449921, 124, '2015-03-15 00:25:06.000000', 'consum', 0.0225, 'lps'),
	(449922, 124, '2015-03-15 00:25:07.000000', 'consum', 0.0222, 'lps'),
	(449923, 124, '2015-03-15 00:25:08.000000', 'consum', 0.0227, 'lps'),
	(449924, 124, '2015-03-15 00:25:09.000000', 'consum', 0.0218, 'lps'),
	(449925, 124, '2015-03-15 00:25:10.000000', 'consum', 0.0218, 'lps'),
	(449926, 124, '2015-03-15 00:25:11.000000', 'consum', 0.0228, 'lps'),
	(449927, 124, '2015-03-15 00:25:12.000000', 'consum', 0.0214, 'lps'),
	(449928, 124, '2015-03-15 00:25:13.000000', 'consum', 0.0216, 'lps'),
	(449929, 124, '2015-03-15 00:25:14.000000', 'consum', 0.0210, 'lps'),
	(449930, 124, '2015-03-15 00:25:15.000000', 'consum', 0.0211, 'lps'),
	(449931, 124, '2015-03-15 00:25:16.000000', 'consum', 0.0215, 'lps'),
	(449932, 124, '2015-03-15 00:25:17.000000', 'consum', 0.0214, 'lps'),
	(449933, 124, '2015-03-15 00:25:18.000000', 'consum', 0.0216, 'lps'),
	(449934, 124, '2015-03-15 00:25:19.000000', 'consum', 0.0226, 'lps'),
	(449935, 124, '2015-03-15 00:25:20.000000', 'consum', 0.0230, 'lps'),
	(449936, 124, '2015-03-15 00:25:21.000000', 'consum', 0.0220, 'lps'),
	(449937, 124, '2015-03-15 00:25:22.000000', 'consum', 0.0222, 'lps'),
	(449938, 124, '2015-03-15 00:25:23.000000', 'consum', 0.0219, 'lps'),
	(449939, 124, '2015-03-15 00:25:24.000000', 'consum', 0.0219, 'lps'),
	(449940, 124, '2015-03-15 00:25:25.000000', 'consum', 0.0210, 'lps'),
	(449941, 124, '2015-03-15 00:25:26.000000', 'consum', 0.0223, 'lps'),
	(449942, 124, '2015-03-15 00:25:27.000000', 'consum', 0.0214, 'lps'),
	(449943, 124, '2015-03-15 00:25:28.000000', 'consum', 0.0211, 'lps'),
	(449944, 124, '2015-03-15 00:25:29.000000', 'consum', 0.0225, 'lps'),
	(449945, 124, '2015-03-15 00:25:30.000000', 'consum', 0.0220, 'lps'),
	(449946, 124, '2015-03-15 00:25:31.000000', 'consum', 0.0216, 'lps'),
	(449947, 124, '2015-03-15 00:25:32.000000', 'consum', 0.0210, 'lps'),
	(449948, 124, '2015-03-15 00:25:33.000000', 'consum', 0.0215, 'lps'),
	(449949, 124, '2015-03-15 00:25:34.000000', 'consum', 0.0211, 'lps'),
	(449950, 124, '2015-03-15 00:25:35.000000', 'consum', 0.0225, 'lps'),
	(449951, 124, '2015-03-15 00:25:36.000000', 'consum', 0.0217, 'lps'),
	(449952, 124, '2015-03-15 00:25:37.000000', 'consum', 0.0222, 'lps'),
	(449953, 124, '2015-03-15 00:25:38.000000', 'consum', 0.0229, 'lps'),
	(449954, 124, '2015-03-15 00:25:39.000000', 'consum', 0.0229, 'lps'),
	(449955, 124, '2015-03-15 00:25:40.000000', 'consum', 0.0226, 'lps'),
	(449956, 124, '2015-03-15 00:25:41.000000', 'consum', 0.0212, 'lps'),
	(449957, 124, '2015-03-15 00:25:42.000000', 'consum', 0.0215, 'lps'),
	(449958, 124, '2015-03-15 00:25:43.000000', 'consum', 0.0228, 'lps'),
	(449959, 124, '2015-03-15 00:25:44.000000', 'consum', 0.0223, 'lps'),
	(449960, 124, '2015-03-15 00:25:45.000000', 'consum', 0.0220, 'lps'),
	(449961, 124, '2015-03-15 00:25:46.000000', 'consum', 0.0222, 'lps'),
	(449962, 124, '2015-03-15 00:25:47.000000', 'consum', 0.0222, 'lps'),
	(449963, 124, '2015-03-15 00:25:48.000000', 'consum', 0.0211, 'lps'),
	(449964, 124, '2015-03-15 00:25:49.000000', 'consum', 0.0221, 'lps'),
	(449965, 124, '2015-03-15 00:25:50.000000', 'consum', 0.0223, 'lps'),
	(449966, 124, '2015-03-15 00:25:51.000000', 'consum', 0.0222, 'lps'),
	(449967, 124, '2015-03-15 00:25:52.000000', 'consum', 0.0211, 'lps'),
	(449968, 124, '2015-03-15 00:25:53.000000', 'consum', 0.0222, 'lps'),
	(449969, 124, '2015-03-15 00:25:54.000000', 'consum', 0.0223, 'lps'),
	(449970, 124, '2015-03-15 00:25:55.000000', 'consum', 0.0221, 'lps'),
	(449971, 124, '2015-03-15 00:25:56.000000', 'consum', 0.0227, 'lps'),
	(449972, 124, '2015-03-15 00:25:57.000000', 'consum', 0.0221, 'lps'),
	(449973, 124, '2015-03-15 00:25:58.000000', 'consum', 0.0215, 'lps'),
	(449974, 124, '2015-03-15 00:25:59.000000', 'consum', 0.0221, 'lps'),
	(449975, 124, '2015-03-15 00:26:00.000000', 'consum', 0.0211, 'lps'),
	(449976, 124, '2015-03-15 00:26:01.000000', 'consum', 0.0222, 'lps'),
	(449977, 124, '2015-03-15 00:26:02.000000', 'consum', 0.0225, 'lps'),
	(449978, 124, '2015-03-15 00:26:03.000000', 'consum', 0.0228, 'lps'),
	(449979, 124, '2015-03-15 00:26:04.000000', 'consum', 0.0216, 'lps'),
	(449980, 124, '2015-03-15 00:26:05.000000', 'consum', 0.0228, 'lps'),
	(449981, 124, '2015-03-15 00:26:06.000000', 'consum', 0.0217, 'lps'),
	(449982, 124, '2015-03-15 00:26:07.000000', 'consum', 0.0215, 'lps'),
	(449983, 124, '2015-03-15 00:26:08.000000', 'consum', 0.0214, 'lps'),
	(449984, 124, '2015-03-15 00:26:09.000000', 'consum', 0.0216, 'lps'),
	(449985, 124, '2015-03-15 00:26:10.000000', 'consum', 0.0229, 'lps'),
	(449986, 124, '2015-03-15 00:26:11.000000', 'consum', 0.0222, 'lps'),
	(449987, 124, '2015-03-15 00:26:12.000000', 'consum', 0.0216, 'lps'),
	(449988, 124, '2015-03-15 00:26:13.000000', 'consum', 0.0225, 'lps'),
	(449989, 124, '2015-03-15 00:26:14.000000', 'consum', 0.0225, 'lps'),
	(449990, 124, '2015-03-15 00:26:15.000000', 'consum', 0.0222, 'lps'),
	(449991, 124, '2015-03-15 00:26:16.000000', 'consum', 0.0222, 'lps'),
	(449992, 124, '2015-03-15 00:26:17.000000', 'consum', 0.0214, 'lps'),
	(449993, 124, '2015-03-15 00:26:18.000000', 'consum', 0.0217, 'lps'),
	(449994, 124, '2015-03-15 00:26:19.000000', 'consum', 0.0212, 'lps'),
	(449995, 124, '2015-03-15 00:26:20.000000', 'consum', 0.0220, 'lps'),
	(449996, 124, '2015-03-15 00:26:21.000000', 'consum', 0.0215, 'lps'),
	(449997, 124, '2015-03-15 00:26:22.000000', 'consum', 0.0224, 'lps'),
	(449998, 124, '2015-03-15 00:26:23.000000', 'consum', 0.0226, 'lps'),
	(449999, 124, '2015-03-15 00:26:24.000000', 'consum', 0.0227, 'lps'),
	(450000, 124, '2015-03-15 00:26:25.000000', 'consum', 0.0225, 'lps'),
	(450001, 124, '2015-03-15 00:26:26.000000', 'consum', 0.0213, 'lps'),
	(450002, 124, '2015-03-15 00:26:27.000000', 'consum', 0.0225, 'lps'),
	(450003, 124, '2015-03-15 00:26:28.000000', 'consum', 0.0213, 'lps'),
	(450004, 124, '2015-03-15 00:26:29.000000', 'consum', 0.0223, 'lps'),
	(450005, 124, '2015-03-15 00:26:30.000000', 'consum', 0.0225, 'lps'),
	(450006, 124, '2015-03-15 00:26:31.000000', 'consum', 0.0226, 'lps'),
	(450007, 124, '2015-03-15 00:26:32.000000', 'consum', 0.0224, 'lps'),
	(450008, 124, '2015-03-15 00:26:33.000000', 'consum', 0.0212, 'lps'),
	(450009, 124, '2015-03-15 00:26:34.000000', 'consum', 0.0219, 'lps'),
	(450010, 124, '2015-03-15 00:26:35.000000', 'consum', 0.0230, 'lps'),
	(450011, 124, '2015-03-15 00:26:36.000000', 'consum', 0.0221, 'lps'),
	(450012, 124, '2015-03-15 00:26:37.000000', 'consum', 0.0224, 'lps'),
	(450013, 124, '2015-03-15 00:26:38.000000', 'consum', 0.0228, 'lps'),
	(450014, 124, '2015-03-15 00:26:39.000000', 'consum', 0.0216, 'lps'),
	(450015, 124, '2015-03-15 00:26:40.000000', 'consum', 0.0227, 'lps'),
	(450016, 124, '2015-03-15 00:26:41.000000', 'consum', 0.0214, 'lps'),
	(450017, 124, '2015-03-15 00:26:42.000000', 'consum', 0.0223, 'lps'),
	(450018, 124, '2015-03-15 00:26:43.000000', 'consum', 0.0222, 'lps'),
	(450019, 124, '2015-03-15 00:26:44.000000', 'consum', 0.0230, 'lps'),
	(450020, 124, '2015-03-15 00:26:45.000000', 'consum', 0.0214, 'lps'),
	(450021, 124, '2015-03-15 00:26:46.000000', 'consum', 0.0210, 'lps'),
	(450022, 124, '2015-03-15 00:26:47.000000', 'consum', 0.0222, 'lps'),
	(450023, 124, '2015-03-15 00:26:48.000000', 'consum', 0.0229, 'lps'),
	(450024, 124, '2015-03-15 00:26:49.000000', 'consum', 0.0228, 'lps'),
	(450025, 124, '2015-03-15 00:26:50.000000', 'consum', 0.0223, 'lps'),
	(450026, 124, '2015-03-15 00:26:51.000000', 'consum', 0.0219, 'lps'),
	(450027, 124, '2015-03-15 00:26:52.000000', 'consum', 0.0218, 'lps'),
	(450028, 124, '2015-03-15 00:26:53.000000', 'consum', 0.0223, 'lps'),
	(450029, 124, '2015-03-15 00:26:54.000000', 'consum', 0.0212, 'lps'),
	(450030, 124, '2015-03-15 00:26:55.000000', 'consum', 0.0220, 'lps'),
	(450031, 124, '2015-03-15 00:26:56.000000', 'consum', 0.0213, 'lps'),
	(450032, 124, '2015-03-15 00:26:57.000000', 'consum', 0.0216, 'lps'),
	(450033, 124, '2015-03-15 00:26:58.000000', 'consum', 0.0230, 'lps'),
	(450034, 124, '2015-03-15 00:26:59.000000', 'consum', 0.0211, 'lps'),
	(450035, 124, '2015-03-15 00:27:00.000000', 'consum', 0.0218, 'lps'),
	(450036, 124, '2015-03-15 00:27:01.000000', 'consum', 0.0226, 'lps'),
	(450037, 124, '2015-03-15 00:27:02.000000', 'consum', 0.0224, 'lps'),
	(450038, 124, '2015-03-15 00:27:03.000000', 'consum', 0.0213, 'lps'),
	(450039, 124, '2015-03-15 00:27:04.000000', 'consum', 0.0225, 'lps'),
	(450040, 124, '2015-03-15 00:27:05.000000', 'consum', 0.0213, 'lps'),
	(450041, 124, '2015-03-15 00:27:06.000000', 'consum', 0.0222, 'lps'),
	(450042, 124, '2015-03-15 00:27:07.000000', 'consum', 0.0218, 'lps'),
	(450043, 124, '2015-03-15 00:27:08.000000', 'consum', 0.0216, 'lps'),
	(450044, 124, '2015-03-15 00:27:09.000000', 'consum', 0.0218, 'lps'),
	(450045, 124, '2015-03-15 00:27:10.000000', 'consum', 0.0230, 'lps'),
	(450046, 124, '2015-03-15 00:27:11.000000', 'consum', 0.0224, 'lps'),
	(450047, 124, '2015-03-15 00:27:12.000000', 'consum', 0.0221, 'lps'),
	(450048, 124, '2015-03-15 00:27:13.000000', 'consum', 0.0225, 'lps'),
	(450049, 124, '2015-03-15 00:27:14.000000', 'consum', 0.0210, 'lps'),
	(450050, 124, '2015-03-15 00:27:15.000000', 'consum', 0.0230, 'lps'),
	(450051, 124, '2015-03-15 00:27:16.000000', 'consum', 0.0224, 'lps'),
	(450052, 124, '2015-03-15 00:27:17.000000', 'consum', 0.0223, 'lps'),
	(450053, 124, '2015-03-15 00:27:18.000000', 'consum', 0.0212, 'lps'),
	(450054, 124, '2015-03-15 00:27:19.000000', 'consum', 0.0222, 'lps'),
	(450055, 124, '2015-03-15 00:27:20.000000', 'consum', 0.0225, 'lps'),
	(450056, 124, '2015-03-15 00:27:21.000000', 'consum', 0.0228, 'lps'),
	(450057, 124, '2015-03-15 00:27:22.000000', 'consum', 0.0214, 'lps'),
	(450058, 124, '2015-03-15 00:27:23.000000', 'consum', 0.0219, 'lps'),
	(450059, 124, '2015-03-15 00:27:24.000000', 'consum', 0.0222, 'lps'),
	(450060, 124, '2015-03-15 00:27:25.000000', 'consum', 0.0222, 'lps'),
	(450061, 124, '2015-03-15 00:27:26.000000', 'consum', 0.0213, 'lps'),
	(450062, 124, '2015-03-15 00:27:27.000000', 'consum', 0.0211, 'lps'),
	(450063, 124, '2015-03-15 00:27:28.000000', 'consum', 0.0229, 'lps'),
	(450064, 124, '2015-03-15 00:27:29.000000', 'consum', 0.0218, 'lps'),
	(450065, 124, '2015-03-15 00:27:30.000000', 'consum', 0.0215, 'lps'),
	(450066, 124, '2015-03-15 00:27:31.000000', 'consum', 0.0212, 'lps'),
	(450067, 124, '2015-03-15 00:27:32.000000', 'consum', 0.0226, 'lps'),
	(450068, 124, '2015-03-15 00:27:33.000000', 'consum', 0.0220, 'lps'),
	(450069, 124, '2015-03-15 00:27:34.000000', 'consum', 0.0214, 'lps'),
	(450070, 124, '2015-03-15 00:27:35.000000', 'consum', 0.0222, 'lps'),
	(450071, 124, '2015-03-15 00:27:36.000000', 'consum', 0.0216, 'lps'),
	(450072, 124, '2015-03-15 00:27:37.000000', 'consum', 0.0224, 'lps'),
	(450073, 124, '2015-03-15 00:27:38.000000', 'consum', 0.0223, 'lps'),
	(450074, 124, '2015-03-15 00:27:39.000000', 'consum', 0.0212, 'lps'),
	(450075, 124, '2015-03-15 00:27:40.000000', 'consum', 0.0223, 'lps'),
	(450076, 124, '2015-03-15 00:27:41.000000', 'consum', 0.0229, 'lps'),
	(450077, 124, '2015-03-15 00:27:42.000000', 'consum', 0.0224, 'lps'),
	(450078, 124, '2015-03-15 00:27:43.000000', 'consum', 0.0223, 'lps'),
	(450079, 124, '2015-03-15 00:27:44.000000', 'consum', 0.0213, 'lps'),
	(450080, 124, '2015-03-15 00:27:45.000000', 'consum', 0.0230, 'lps'),
	(450081, 124, '2015-03-15 00:27:46.000000', 'consum', 0.0214, 'lps'),
	(450082, 124, '2015-03-15 00:27:47.000000', 'consum', 0.0215, 'lps'),
	(450083, 124, '2015-03-15 00:27:48.000000', 'consum', 0.0224, 'lps'),
	(450084, 124, '2015-03-15 00:27:49.000000', 'consum', 0.0224, 'lps'),
	(450085, 124, '2015-03-15 00:27:50.000000', 'consum', 0.0214, 'lps'),
	(450086, 124, '2015-03-15 00:27:51.000000', 'consum', 0.0213, 'lps'),
	(450087, 124, '2015-03-15 00:27:52.000000', 'consum', 0.0214, 'lps'),
	(450088, 124, '2015-03-15 00:27:53.000000', 'consum', 0.0222, 'lps'),
	(450089, 124, '2015-03-15 00:27:54.000000', 'consum', 0.0213, 'lps'),
	(450090, 124, '2015-03-15 00:27:55.000000', 'consum', 0.0213, 'lps'),
	(450091, 124, '2015-03-15 00:27:56.000000', 'consum', 0.0216, 'lps'),
	(450092, 124, '2015-03-15 00:27:57.000000', 'consum', 0.0230, 'lps'),
	(450093, 124, '2015-03-15 00:27:58.000000', 'consum', 0.0210, 'lps'),
	(450094, 124, '2015-03-15 00:27:59.000000', 'consum', 0.0213, 'lps'),
	(450095, 124, '2015-03-15 00:28:00.000000', 'consum', 0.0226, 'lps'),
	(450096, 124, '2015-03-15 00:28:01.000000', 'consum', 0.0217, 'lps'),
	(450097, 124, '2015-03-15 00:28:02.000000', 'consum', 0.0218, 'lps'),
	(450098, 124, '2015-03-15 00:28:03.000000', 'consum', 0.0210, 'lps'),
	(450099, 124, '2015-03-15 00:28:04.000000', 'consum', 0.0228, 'lps'),
	(450100, 124, '2015-03-15 00:28:05.000000', 'consum', 0.0217, 'lps'),
	(450101, 124, '2015-03-15 00:28:06.000000', 'consum', 0.0214, 'lps'),
	(450102, 124, '2015-03-15 00:28:07.000000', 'consum', 0.0230, 'lps'),
	(450103, 124, '2015-03-15 00:28:08.000000', 'consum', 0.0213, 'lps'),
	(450104, 124, '2015-03-15 00:28:09.000000', 'consum', 0.0227, 'lps'),
	(450105, 124, '2015-03-15 00:28:10.000000', 'consum', 0.0225, 'lps'),
	(450106, 124, '2015-03-15 00:28:11.000000', 'consum', 0.0215, 'lps'),
	(450107, 124, '2015-03-15 00:28:12.000000', 'consum', 0.0212, 'lps'),
	(450108, 124, '2015-03-15 00:28:13.000000', 'consum', 0.0226, 'lps'),
	(450109, 124, '2015-03-15 00:28:14.000000', 'consum', 0.0220, 'lps'),
	(450110, 124, '2015-03-15 00:28:15.000000', 'consum', 0.0214, 'lps'),
	(450111, 124, '2015-03-15 00:28:16.000000', 'consum', 0.0220, 'lps'),
	(450112, 124, '2015-03-15 00:28:17.000000', 'consum', 0.0228, 'lps'),
	(450113, 124, '2015-03-15 00:28:18.000000', 'consum', 0.0229, 'lps'),
	(450114, 124, '2015-03-15 00:28:19.000000', 'consum', 0.0230, 'lps'),
	(450115, 124, '2015-03-15 00:28:20.000000', 'consum', 0.0213, 'lps'),
	(450116, 124, '2015-03-15 00:28:21.000000', 'consum', 0.0229, 'lps'),
	(450117, 124, '2015-03-15 00:28:22.000000', 'consum', 0.0211, 'lps'),
	(450118, 124, '2015-03-15 00:28:23.000000', 'consum', 0.0220, 'lps'),
	(450119, 124, '2015-03-15 00:28:24.000000', 'consum', 0.0218, 'lps'),
	(450120, 124, '2015-03-15 00:28:25.000000', 'consum', 0.0218, 'lps'),
	(450121, 124, '2015-03-15 00:28:26.000000', 'consum', 0.0226, 'lps'),
	(450122, 124, '2015-03-15 00:28:27.000000', 'consum', 0.0225, 'lps'),
	(450123, 124, '2015-03-15 00:28:28.000000', 'consum', 0.0218, 'lps'),
	(450124, 124, '2015-03-15 00:28:29.000000', 'consum', 0.0227, 'lps'),
	(450125, 124, '2015-03-15 00:28:30.000000', 'consum', 0.0229, 'lps'),
	(450126, 124, '2015-03-15 00:28:31.000000', 'consum', 0.0211, 'lps'),
	(450127, 124, '2015-03-15 00:28:32.000000', 'consum', 0.0221, 'lps'),
	(450128, 124, '2015-03-15 00:28:33.000000', 'consum', 0.0220, 'lps'),
	(450129, 124, '2015-03-15 00:28:34.000000', 'consum', 0.0227, 'lps'),
	(450130, 124, '2015-03-15 00:28:35.000000', 'consum', 0.0223, 'lps'),
	(450131, 124, '2015-03-15 00:28:36.000000', 'consum', 0.0227, 'lps'),
	(450132, 124, '2015-03-15 00:28:37.000000', 'consum', 0.0213, 'lps'),
	(450133, 124, '2015-03-15 00:28:38.000000', 'consum', 0.0217, 'lps'),
	(450134, 124, '2015-03-15 00:28:39.000000', 'consum', 0.0215, 'lps'),
	(450135, 124, '2015-03-15 00:28:40.000000', 'consum', 0.0213, 'lps'),
	(450136, 124, '2015-03-15 00:28:41.000000', 'consum', 0.0211, 'lps'),
	(450137, 124, '2015-03-15 00:28:42.000000', 'consum', 0.0229, 'lps'),
	(450138, 124, '2015-03-15 00:28:43.000000', 'consum', 0.0216, 'lps'),
	(450139, 124, '2015-03-15 00:28:44.000000', 'consum', 0.0227, 'lps'),
	(450140, 124, '2015-03-15 00:28:45.000000', 'consum', 0.0214, 'lps'),
	(450141, 124, '2015-03-15 00:28:46.000000', 'consum', 0.0223, 'lps'),
	(450142, 124, '2015-03-15 00:28:47.000000', 'consum', 0.0222, 'lps'),
	(450143, 124, '2015-03-15 00:28:48.000000', 'consum', 0.0229, 'lps'),
	(450144, 124, '2015-03-15 00:28:49.000000', 'consum', 0.0228, 'lps'),
	(450145, 124, '2015-03-15 00:28:50.000000', 'consum', 0.0222, 'lps'),
	(450146, 124, '2015-03-15 00:28:51.000000', 'consum', 0.0216, 'lps'),
	(450147, 124, '2015-03-15 00:28:52.000000', 'consum', 0.0225, 'lps'),
	(450148, 124, '2015-03-15 00:28:53.000000', 'consum', 0.0228, 'lps'),
	(450149, 124, '2015-03-15 00:28:54.000000', 'consum', 0.0214, 'lps'),
	(450150, 124, '2015-03-15 00:28:55.000000', 'consum', 0.0217, 'lps'),
	(450151, 124, '2015-03-15 00:28:56.000000', 'consum', 0.0213, 'lps'),
	(450152, 124, '2015-03-15 00:28:57.000000', 'consum', 0.0225, 'lps'),
	(450153, 124, '2015-03-15 00:28:58.000000', 'consum', 0.0212, 'lps'),
	(450154, 124, '2015-03-15 00:28:59.000000', 'consum', 0.0221, 'lps'),
	(450155, 124, '2015-03-15 00:29:00.000000', 'consum', 0.0214, 'lps'),
	(450156, 124, '2015-03-15 00:29:01.000000', 'consum', 0.0221, 'lps'),
	(450157, 124, '2015-03-15 00:29:02.000000', 'consum', 0.0212, 'lps'),
	(450158, 124, '2015-03-15 00:29:03.000000', 'consum', 0.0230, 'lps'),
	(450159, 124, '2015-03-15 00:29:04.000000', 'consum', 0.0219, 'lps'),
	(450160, 124, '2015-03-15 00:29:05.000000', 'consum', 0.0216, 'lps'),
	(450161, 124, '2015-03-15 00:29:06.000000', 'consum', 0.0214, 'lps'),
	(450162, 124, '2015-03-15 00:29:07.000000', 'consum', 0.0214, 'lps'),
	(450163, 124, '2015-03-15 00:29:08.000000', 'consum', 0.0218, 'lps'),
	(450164, 124, '2015-03-15 00:29:09.000000', 'consum', 0.0219, 'lps'),
	(450165, 124, '2015-03-15 00:29:10.000000', 'consum', 0.0229, 'lps'),
	(450166, 124, '2015-03-15 00:29:11.000000', 'consum', 0.0217, 'lps'),
	(450167, 124, '2015-03-15 00:29:12.000000', 'consum', 0.0230, 'lps'),
	(450168, 124, '2015-03-15 00:29:13.000000', 'consum', 0.0229, 'lps'),
	(450169, 124, '2015-03-15 00:29:14.000000', 'consum', 0.0221, 'lps'),
	(450170, 124, '2015-03-15 00:29:15.000000', 'consum', 0.0230, 'lps'),
	(450171, 124, '2015-03-15 00:29:16.000000', 'consum', 0.0216, 'lps'),
	(450172, 124, '2015-03-15 00:29:17.000000', 'consum', 0.0222, 'lps'),
	(450173, 124, '2015-03-15 00:29:18.000000', 'consum', 0.0211, 'lps'),
	(450174, 124, '2015-03-15 00:29:19.000000', 'consum', 0.0222, 'lps'),
	(450175, 124, '2015-03-15 00:29:20.000000', 'consum', 0.0226, 'lps'),
	(450176, 124, '2015-03-15 00:29:21.000000', 'consum', 0.0211, 'lps'),
	(450177, 124, '2015-03-15 00:29:22.000000', 'consum', 0.0212, 'lps'),
	(450178, 124, '2015-03-15 00:29:23.000000', 'consum', 0.0216, 'lps'),
	(450179, 124, '2015-03-15 00:29:24.000000', 'consum', 0.0213, 'lps'),
	(450180, 124, '2015-03-15 00:29:25.000000', 'consum', 0.0229, 'lps'),
	(450181, 124, '2015-03-15 00:29:26.000000', 'consum', 0.0213, 'lps'),
	(450182, 124, '2015-03-15 00:29:27.000000', 'consum', 0.0211, 'lps'),
	(450183, 124, '2015-03-15 00:29:28.000000', 'consum', 0.0226, 'lps'),
	(450184, 124, '2015-03-15 00:29:29.000000', 'consum', 0.0227, 'lps'),
	(450185, 124, '2015-03-15 00:29:30.000000', 'consum', 0.0223, 'lps'),
	(450186, 124, '2015-03-15 00:29:31.000000', 'consum', 0.0227, 'lps'),
	(450187, 124, '2015-03-15 00:29:32.000000', 'consum', 0.0214, 'lps'),
	(450188, 124, '2015-03-15 00:29:33.000000', 'consum', 0.0222, 'lps'),
	(450189, 124, '2015-03-15 00:29:34.000000', 'consum', 0.0217, 'lps'),
	(450190, 124, '2015-03-15 00:29:35.000000', 'consum', 0.0229, 'lps'),
	(450191, 124, '2015-03-15 00:29:36.000000', 'consum', 0.0223, 'lps'),
	(450192, 124, '2015-03-15 00:29:37.000000', 'consum', 0.0219, 'lps'),
	(450193, 124, '2015-03-15 00:29:38.000000', 'consum', 0.0214, 'lps'),
	(450194, 124, '2015-03-15 00:29:39.000000', 'consum', 0.0226, 'lps'),
	(450195, 124, '2015-03-15 00:29:40.000000', 'consum', 0.0216, 'lps'),
	(450196, 124, '2015-03-15 00:29:41.000000', 'consum', 0.0214, 'lps'),
	(450197, 124, '2015-03-15 00:29:42.000000', 'consum', 0.0212, 'lps'),
	(450198, 124, '2015-03-15 00:29:43.000000', 'consum', 0.0227, 'lps'),
	(450199, 124, '2015-03-15 00:29:44.000000', 'consum', 0.0229, 'lps'),
	(450200, 124, '2015-03-15 00:29:45.000000', 'consum', 0.0214, 'lps'),
	(450201, 124, '2015-03-15 00:29:46.000000', 'consum', 0.0214, 'lps'),
	(450202, 124, '2015-03-15 00:29:47.000000', 'consum', 0.0219, 'lps'),
	(450203, 124, '2015-03-15 00:29:48.000000', 'consum', 0.0223, 'lps'),
	(450204, 124, '2015-03-15 00:29:49.000000', 'consum', 0.0226, 'lps'),
	(450205, 124, '2015-03-15 00:29:50.000000', 'consum', 0.0230, 'lps'),
	(450206, 124, '2015-03-15 00:29:51.000000', 'consum', 0.0221, 'lps'),
	(450207, 124, '2015-03-15 00:29:52.000000', 'consum', 0.0226, 'lps'),
	(450208, 124, '2015-03-15 00:29:53.000000', 'consum', 0.0214, 'lps'),
	(450209, 124, '2015-03-15 00:29:54.000000', 'consum', 0.0227, 'lps'),
	(450210, 124, '2015-03-15 00:29:55.000000', 'consum', 0.0220, 'lps'),
	(450211, 124, '2015-03-15 00:29:56.000000', 'consum', 0.0210, 'lps'),
	(450212, 124, '2015-03-15 00:29:57.000000', 'consum', 0.0222, 'lps'),
	(450213, 124, '2015-03-15 00:29:58.000000', 'consum', 0.0228, 'lps'),
	(450214, 124, '2015-03-15 00:29:59.000000', 'consum', 0.0223, 'lps'),
	(450215, 124, '2015-03-15 00:30:00.000000', 'consum', 0.0222, 'lps'),
	(450216, 124, '2015-03-15 00:30:01.000000', 'consum', 0.0212, 'lps'),
	(450217, 124, '2015-03-15 00:30:02.000000', 'consum', 0.0224, 'lps'),
	(450218, 124, '2015-03-15 00:30:03.000000', 'consum', 0.0212, 'lps'),
	(450219, 124, '2015-03-15 00:30:04.000000', 'consum', 0.0220, 'lps'),
	(450220, 124, '2015-03-15 00:30:05.000000', 'consum', 0.0212, 'lps'),
	(450221, 124, '2015-03-15 00:30:06.000000', 'consum', 0.0213, 'lps'),
	(450222, 124, '2015-03-15 00:30:07.000000', 'consum', 0.0217, 'lps'),
	(450223, 124, '2015-03-15 00:30:08.000000', 'consum', 0.0217, 'lps'),
	(450224, 124, '2015-03-15 00:30:09.000000', 'consum', 0.0223, 'lps'),
	(450225, 124, '2015-03-15 00:30:10.000000', 'consum', 0.0212, 'lps'),
	(450226, 124, '2015-03-15 00:30:11.000000', 'consum', 0.0226, 'lps'),
	(450227, 124, '2015-03-15 00:30:12.000000', 'consum', 0.0218, 'lps'),
	(450228, 124, '2015-03-15 00:30:13.000000', 'consum', 0.0227, 'lps'),
	(450229, 124, '2015-03-15 00:30:14.000000', 'consum', 0.0228, 'lps'),
	(450230, 124, '2015-03-15 00:30:15.000000', 'consum', 0.0229, 'lps'),
	(450231, 124, '2015-03-15 00:30:16.000000', 'consum', 0.0211, 'lps'),
	(450232, 124, '2015-03-15 00:30:17.000000', 'consum', 0.0221, 'lps'),
	(450233, 124, '2015-03-15 00:30:18.000000', 'consum', 0.0218, 'lps'),
	(450234, 124, '2015-03-15 00:30:19.000000', 'consum', 0.0220, 'lps'),
	(450235, 124, '2015-03-15 00:30:20.000000', 'consum', 0.0214, 'lps'),
	(450236, 124, '2015-03-15 00:30:21.000000', 'consum', 0.0222, 'lps'),
	(450237, 124, '2015-03-15 00:30:22.000000', 'consum', 0.0214, 'lps'),
	(450238, 124, '2015-03-15 00:30:23.000000', 'consum', 0.0219, 'lps'),
	(450239, 124, '2015-03-15 00:30:24.000000', 'consum', 0.0222, 'lps'),
	(450240, 124, '2015-03-15 00:30:25.000000', 'consum', 0.0221, 'lps'),
	(450241, 124, '2015-03-15 00:30:26.000000', 'consum', 0.0229, 'lps'),
	(450242, 124, '2015-03-15 00:30:27.000000', 'consum', 0.0212, 'lps'),
	(450243, 124, '2015-03-15 00:30:28.000000', 'consum', 0.0227, 'lps'),
	(450244, 124, '2015-03-15 00:30:29.000000', 'consum', 0.0224, 'lps'),
	(450245, 124, '2015-03-15 00:30:30.000000', 'consum', 0.0211, 'lps'),
	(450246, 124, '2015-03-15 00:30:31.000000', 'consum', 0.0215, 'lps'),
	(450247, 124, '2015-03-15 00:30:32.000000', 'consum', 0.0210, 'lps'),
	(450248, 124, '2015-03-15 00:30:33.000000', 'consum', 0.0215, 'lps'),
	(450249, 124, '2015-03-15 00:30:34.000000', 'consum', 0.0218, 'lps'),
	(450250, 124, '2015-03-15 00:30:35.000000', 'consum', 0.0212, 'lps'),
	(450251, 124, '2015-03-15 00:30:36.000000', 'consum', 0.0219, 'lps'),
	(450252, 124, '2015-03-15 00:30:37.000000', 'consum', 0.0228, 'lps'),
	(450253, 124, '2015-03-15 00:30:38.000000', 'consum', 0.0229, 'lps'),
	(450254, 124, '2015-03-15 00:30:39.000000', 'consum', 0.0213, 'lps'),
	(450255, 124, '2015-03-15 00:30:40.000000', 'consum', 0.0210, 'lps'),
	(450256, 124, '2015-03-15 00:30:41.000000', 'consum', 0.0221, 'lps'),
	(450257, 124, '2015-03-15 00:30:42.000000', 'consum', 0.0226, 'lps'),
	(450258, 124, '2015-03-15 00:30:43.000000', 'consum', 0.0213, 'lps'),
	(450259, 124, '2015-03-15 00:30:44.000000', 'consum', 0.0220, 'lps'),
	(450260, 124, '2015-03-15 00:30:45.000000', 'consum', 0.0211, 'lps'),
	(450261, 124, '2015-03-15 00:30:46.000000', 'consum', 0.0229, 'lps'),
	(450262, 124, '2015-03-15 00:30:47.000000', 'consum', 0.0216, 'lps'),
	(450263, 124, '2015-03-15 00:30:48.000000', 'consum', 0.0225, 'lps'),
	(450264, 124, '2015-03-15 00:30:49.000000', 'consum', 0.0227, 'lps'),
	(450265, 124, '2015-03-15 00:30:50.000000', 'consum', 0.0210, 'lps'),
	(450266, 124, '2015-03-15 00:30:51.000000', 'consum', 0.0220, 'lps'),
	(450267, 124, '2015-03-15 00:30:52.000000', 'consum', 0.0217, 'lps'),
	(450268, 124, '2015-03-15 00:30:53.000000', 'consum', 0.0218, 'lps'),
	(450269, 124, '2015-03-15 00:30:54.000000', 'consum', 0.0230, 'lps'),
	(450270, 124, '2015-03-15 00:30:55.000000', 'consum', 0.0221, 'lps'),
	(450271, 124, '2015-03-15 00:30:56.000000', 'consum', 0.0227, 'lps'),
	(450272, 124, '2015-03-15 00:30:57.000000', 'consum', 0.0223, 'lps'),
	(450273, 124, '2015-03-15 00:30:58.000000', 'consum', 0.0224, 'lps'),
	(450274, 124, '2015-03-15 00:30:59.000000', 'consum', 0.0218, 'lps'),
	(450275, 124, '2015-03-15 00:31:00.000000', 'consum', 0.0210, 'lps'),
	(450276, 124, '2015-03-15 00:31:01.000000', 'consum', 0.0229, 'lps'),
	(450277, 124, '2015-03-15 00:31:02.000000', 'consum', 0.0220, 'lps'),
	(450278, 124, '2015-03-15 00:31:03.000000', 'consum', 0.0226, 'lps'),
	(450279, 124, '2015-03-15 00:31:04.000000', 'consum', 0.0217, 'lps'),
	(450280, 124, '2015-03-15 00:31:05.000000', 'consum', 0.0220, 'lps'),
	(450281, 124, '2015-03-15 00:31:06.000000', 'consum', 0.0220, 'lps'),
	(450282, 124, '2015-03-15 00:31:07.000000', 'consum', 0.0227, 'lps'),
	(450283, 124, '2015-03-15 00:31:08.000000', 'consum', 0.0227, 'lps'),
	(450284, 124, '2015-03-15 00:31:09.000000', 'consum', 0.0221, 'lps'),
	(450285, 124, '2015-03-15 00:31:10.000000', 'consum', 0.0216, 'lps'),
	(450286, 124, '2015-03-15 00:31:11.000000', 'consum', 0.0229, 'lps'),
	(450287, 124, '2015-03-15 00:31:12.000000', 'consum', 0.0222, 'lps'),
	(450288, 124, '2015-03-15 00:31:13.000000', 'consum', 0.0213, 'lps'),
	(450289, 124, '2015-03-15 00:31:14.000000', 'consum', 0.0213, 'lps'),
	(450290, 124, '2015-03-15 00:31:15.000000', 'consum', 0.0217, 'lps'),
	(450291, 124, '2015-03-15 00:31:16.000000', 'consum', 0.0216, 'lps'),
	(450292, 124, '2015-03-15 00:31:17.000000', 'consum', 0.0219, 'lps'),
	(450293, 124, '2015-03-15 00:31:18.000000', 'consum', 0.0218, 'lps'),
	(450294, 124, '2015-03-15 00:31:19.000000', 'consum', 0.0223, 'lps'),
	(450295, 124, '2015-03-15 00:31:20.000000', 'consum', 0.0210, 'lps'),
	(450296, 124, '2015-03-15 00:31:21.000000', 'consum', 0.0212, 'lps'),
	(450297, 124, '2015-03-15 00:31:22.000000', 'consum', 0.0220, 'lps'),
	(450298, 124, '2015-03-15 00:31:23.000000', 'consum', 0.0214, 'lps'),
	(450299, 124, '2015-03-15 00:31:24.000000', 'consum', 0.0223, 'lps'),
	(450300, 124, '2015-03-15 00:31:25.000000', 'consum', 0.0220, 'lps'),
	(450301, 124, '2015-03-15 00:31:26.000000', 'consum', 0.0222, 'lps'),
	(450302, 124, '2015-03-15 00:31:27.000000', 'consum', 0.0218, 'lps'),
	(450303, 124, '2015-03-15 00:31:28.000000', 'consum', 0.0213, 'lps'),
	(450304, 124, '2015-03-15 00:31:29.000000', 'consum', 0.0225, 'lps'),
	(450305, 124, '2015-03-15 00:31:30.000000', 'consum', 0.0214, 'lps'),
	(450306, 124, '2015-03-15 00:31:31.000000', 'consum', 0.0225, 'lps'),
	(450307, 124, '2015-03-15 00:31:32.000000', 'consum', 0.0210, 'lps'),
	(450308, 124, '2015-03-15 00:31:33.000000', 'consum', 0.0229, 'lps'),
	(450309, 124, '2015-03-15 00:31:34.000000', 'consum', 0.0223, 'lps'),
	(450310, 124, '2015-03-15 00:31:35.000000', 'consum', 0.0217, 'lps'),
	(450311, 124, '2015-03-15 00:31:36.000000', 'consum', 0.0228, 'lps'),
	(450312, 124, '2015-03-15 00:31:37.000000', 'consum', 0.0215, 'lps'),
	(450313, 124, '2015-03-15 00:31:38.000000', 'consum', 0.0224, 'lps'),
	(450314, 124, '2015-03-15 00:31:39.000000', 'consum', 0.0222, 'lps'),
	(450315, 124, '2015-03-15 00:31:40.000000', 'consum', 0.0210, 'lps'),
	(450316, 124, '2015-03-15 00:31:41.000000', 'consum', 0.0215, 'lps'),
	(450317, 124, '2015-03-15 00:31:42.000000', 'consum', 0.0214, 'lps'),
	(450318, 124, '2015-03-15 00:31:43.000000', 'consum', 0.0218, 'lps'),
	(450319, 124, '2015-03-15 00:31:44.000000', 'consum', 0.0216, 'lps'),
	(450320, 124, '2015-03-15 00:31:45.000000', 'consum', 0.0216, 'lps'),
	(450321, 124, '2015-03-15 00:31:46.000000', 'consum', 0.0222, 'lps'),
	(450322, 124, '2015-03-15 00:31:47.000000', 'consum', 0.0210, 'lps'),
	(450323, 124, '2015-03-15 00:31:48.000000', 'consum', 0.0217, 'lps'),
	(450324, 124, '2015-03-15 00:31:49.000000', 'consum', 0.0224, 'lps'),
	(450325, 124, '2015-03-15 00:31:50.000000', 'consum', 0.0216, 'lps'),
	(450326, 124, '2015-03-15 00:31:51.000000', 'consum', 0.0222, 'lps'),
	(450327, 124, '2015-03-15 00:31:52.000000', 'consum', 0.0211, 'lps'),
	(450328, 124, '2015-03-15 00:31:53.000000', 'consum', 0.0219, 'lps'),
	(450329, 124, '2015-03-15 00:31:54.000000', 'consum', 0.0214, 'lps'),
	(450330, 124, '2015-03-15 00:31:55.000000', 'consum', 0.0221, 'lps'),
	(450331, 124, '2015-03-15 00:31:56.000000', 'consum', 0.0213, 'lps'),
	(450332, 124, '2015-03-15 00:31:57.000000', 'consum', 0.0214, 'lps'),
	(450333, 124, '2015-03-15 00:31:58.000000', 'consum', 0.0223, 'lps'),
	(450334, 124, '2015-03-15 00:31:59.000000', 'consum', 0.0219, 'lps'),
	(450335, 124, '2015-03-15 00:32:00.000000', 'consum', 0.0217, 'lps'),
	(450336, 124, '2015-03-15 00:32:01.000000', 'consum', 0.0217, 'lps'),
	(450337, 124, '2015-03-15 00:32:02.000000', 'consum', 0.0227, 'lps'),
	(450338, 124, '2015-03-15 00:32:03.000000', 'consum', 0.0210, 'lps'),
	(450339, 124, '2015-03-15 00:32:04.000000', 'consum', 0.0223, 'lps'),
	(450340, 124, '2015-03-15 00:32:05.000000', 'consum', 0.0212, 'lps'),
	(450341, 124, '2015-03-15 00:32:06.000000', 'consum', 0.0226, 'lps'),
	(450342, 124, '2015-03-15 00:32:07.000000', 'consum', 0.0219, 'lps'),
	(450343, 124, '2015-03-15 00:32:08.000000', 'consum', 0.0229, 'lps'),
	(450344, 124, '2015-03-15 00:32:09.000000', 'consum', 0.0217, 'lps'),
	(450345, 124, '2015-03-15 00:32:10.000000', 'consum', 0.0228, 'lps'),
	(450346, 124, '2015-03-15 00:32:11.000000', 'consum', 0.0215, 'lps'),
	(450347, 124, '2015-03-15 00:32:12.000000', 'consum', 0.0227, 'lps'),
	(450348, 124, '2015-03-15 00:32:13.000000', 'consum', 0.0218, 'lps'),
	(450349, 124, '2015-03-15 00:32:14.000000', 'consum', 0.0218, 'lps'),
	(450350, 124, '2015-03-15 00:32:15.000000', 'consum', 0.0228, 'lps'),
	(450351, 124, '2015-03-15 00:32:16.000000', 'consum', 0.0214, 'lps'),
	(450352, 124, '2015-03-15 00:32:17.000000', 'consum', 0.0217, 'lps'),
	(450353, 124, '2015-03-15 00:32:18.000000', 'consum', 0.0213, 'lps'),
	(450354, 124, '2015-03-15 00:32:19.000000', 'consum', 0.0228, 'lps'),
	(450355, 124, '2015-03-15 00:32:20.000000', 'consum', 0.0225, 'lps'),
	(450356, 124, '2015-03-15 00:32:21.000000', 'consum', 0.0212, 'lps'),
	(450357, 124, '2015-03-15 00:32:22.000000', 'consum', 0.0219, 'lps'),
	(450358, 124, '2015-03-15 00:32:23.000000', 'consum', 0.0229, 'lps'),
	(450359, 124, '2015-03-15 00:32:24.000000', 'consum', 0.0215, 'lps'),
	(450360, 124, '2015-03-15 00:32:25.000000', 'consum', 0.0222, 'lps'),
	(450361, 124, '2015-03-15 00:32:26.000000', 'consum', 0.0211, 'lps'),
	(450362, 124, '2015-03-15 00:32:27.000000', 'consum', 0.0222, 'lps'),
	(450363, 124, '2015-03-15 00:32:28.000000', 'consum', 0.0228, 'lps'),
	(450364, 124, '2015-03-15 00:32:29.000000', 'consum', 0.0220, 'lps'),
	(450365, 124, '2015-03-15 00:32:30.000000', 'consum', 0.0227, 'lps'),
	(450366, 124, '2015-03-15 00:32:31.000000', 'consum', 0.0226, 'lps'),
	(450367, 124, '2015-03-15 00:32:32.000000', 'consum', 0.0217, 'lps'),
	(450368, 124, '2015-03-15 00:32:33.000000', 'consum', 0.0219, 'lps'),
	(450369, 124, '2015-03-15 00:32:34.000000', 'consum', 0.0215, 'lps'),
	(450370, 124, '2015-03-15 00:32:35.000000', 'consum', 0.0227, 'lps'),
	(450371, 124, '2015-03-15 00:32:36.000000', 'consum', 0.0220, 'lps'),
	(450372, 124, '2015-03-15 00:32:37.000000', 'consum', 0.0230, 'lps'),
	(450373, 124, '2015-03-15 00:32:38.000000', 'consum', 0.0217, 'lps'),
	(450374, 124, '2015-03-15 00:32:39.000000', 'consum', 0.0229, 'lps'),
	(450375, 124, '2015-03-15 00:32:40.000000', 'consum', 0.0219, 'lps'),
	(450376, 124, '2015-03-15 00:32:41.000000', 'consum', 0.0219, 'lps'),
	(450377, 124, '2015-03-15 00:32:42.000000', 'consum', 0.0228, 'lps'),
	(450378, 124, '2015-03-15 00:32:43.000000', 'consum', 0.0214, 'lps'),
	(450379, 124, '2015-03-15 00:32:44.000000', 'consum', 0.0215, 'lps'),
	(450380, 124, '2015-03-15 00:32:45.000000', 'consum', 0.0224, 'lps'),
	(450381, 124, '2015-03-15 00:32:46.000000', 'consum', 0.0223, 'lps'),
	(450382, 124, '2015-03-15 00:32:47.000000', 'consum', 0.0213, 'lps'),
	(450383, 124, '2015-03-15 00:32:48.000000', 'consum', 0.0230, 'lps'),
	(450384, 124, '2015-03-15 00:32:49.000000', 'consum', 0.0215, 'lps'),
	(450385, 124, '2015-03-15 00:32:50.000000', 'consum', 0.0218, 'lps'),
	(450386, 124, '2015-03-15 00:32:51.000000', 'consum', 0.0215, 'lps'),
	(450387, 124, '2015-03-15 00:32:52.000000', 'consum', 0.0212, 'lps'),
	(450388, 124, '2015-03-15 00:32:53.000000', 'consum', 0.0224, 'lps'),
	(450389, 124, '2015-03-15 00:32:54.000000', 'consum', 0.0214, 'lps'),
	(450390, 124, '2015-03-15 00:32:55.000000', 'consum', 0.0211, 'lps'),
	(450391, 124, '2015-03-15 00:32:56.000000', 'consum', 0.0221, 'lps'),
	(450392, 124, '2015-03-15 00:32:57.000000', 'consum', 0.0223, 'lps'),
	(450393, 124, '2015-03-15 00:32:58.000000', 'consum', 0.0221, 'lps'),
	(450394, 124, '2015-03-15 00:32:59.000000', 'consum', 0.0228, 'lps'),
	(450395, 124, '2015-03-15 00:33:00.000000', 'consum', 0.0223, 'lps'),
	(450396, 124, '2015-03-15 00:33:01.000000', 'consum', 0.0224, 'lps'),
	(450397, 124, '2015-03-15 00:33:02.000000', 'consum', 0.0217, 'lps'),
	(450398, 124, '2015-03-15 00:33:03.000000', 'consum', 0.0227, 'lps'),
	(450399, 124, '2015-03-15 00:33:04.000000', 'consum', 0.0213, 'lps'),
	(450400, 124, '2015-03-15 00:33:05.000000', 'consum', 0.0214, 'lps'),
	(450401, 124, '2015-03-15 00:33:06.000000', 'consum', 0.0224, 'lps'),
	(450402, 124, '2015-03-15 00:33:07.000000', 'consum', 0.0224, 'lps'),
	(450403, 124, '2015-03-15 00:33:08.000000', 'consum', 0.0218, 'lps'),
	(450404, 124, '2015-03-15 00:33:09.000000', 'consum', 0.0228, 'lps'),
	(450405, 124, '2015-03-15 00:33:10.000000', 'consum', 0.0214, 'lps'),
	(450406, 124, '2015-03-15 00:33:11.000000', 'consum', 0.0220, 'lps'),
	(450407, 124, '2015-03-15 00:33:12.000000', 'consum', 0.0229, 'lps'),
	(450408, 124, '2015-03-15 00:33:13.000000', 'consum', 0.0230, 'lps'),
	(450409, 124, '2015-03-15 00:33:14.000000', 'consum', 0.0213, 'lps'),
	(450410, 124, '2015-03-15 00:33:15.000000', 'consum', 0.0228, 'lps'),
	(450411, 124, '2015-03-15 00:33:16.000000', 'consum', 0.0228, 'lps'),
	(450412, 124, '2015-03-15 00:33:17.000000', 'consum', 0.0225, 'lps'),
	(450413, 124, '2015-03-15 00:33:18.000000', 'consum', 0.0210, 'lps'),
	(450414, 124, '2015-03-15 00:33:19.000000', 'consum', 0.0230, 'lps'),
	(450415, 124, '2015-03-15 00:33:20.000000', 'consum', 0.0225, 'lps'),
	(450416, 124, '2015-03-15 00:33:21.000000', 'consum', 0.0226, 'lps'),
	(450417, 124, '2015-03-15 00:33:22.000000', 'consum', 0.0223, 'lps'),
	(450418, 124, '2015-03-15 00:33:23.000000', 'consum', 0.0227, 'lps'),
	(450419, 124, '2015-03-15 00:33:24.000000', 'consum', 0.0216, 'lps'),
	(450420, 124, '2015-03-15 00:33:25.000000', 'consum', 0.0210, 'lps'),
	(450421, 124, '2015-03-15 00:33:26.000000', 'consum', 0.0213, 'lps'),
	(450422, 124, '2015-03-15 00:33:27.000000', 'consum', 0.0224, 'lps'),
	(450423, 124, '2015-03-15 00:33:28.000000', 'consum', 0.0210, 'lps'),
	(450424, 124, '2015-03-15 00:33:29.000000', 'consum', 0.0230, 'lps'),
	(450425, 124, '2015-03-15 00:33:30.000000', 'consum', 0.0226, 'lps'),
	(450426, 124, '2015-03-15 00:33:31.000000', 'consum', 0.0210, 'lps'),
	(450427, 124, '2015-03-15 00:33:32.000000', 'consum', 0.0226, 'lps'),
	(450428, 124, '2015-03-15 00:33:33.000000', 'consum', 0.0229, 'lps'),
	(450429, 124, '2015-03-15 00:33:34.000000', 'consum', 0.0213, 'lps'),
	(450430, 124, '2015-03-15 00:33:35.000000', 'consum', 0.0213, 'lps'),
	(450431, 124, '2015-03-15 00:33:36.000000', 'consum', 0.0215, 'lps'),
	(450432, 124, '2015-03-15 00:33:37.000000', 'consum', 0.0228, 'lps'),
	(450433, 124, '2015-03-15 00:33:38.000000', 'consum', 0.0221, 'lps'),
	(450434, 124, '2015-03-15 00:33:39.000000', 'consum', 0.0211, 'lps'),
	(450435, 124, '2015-03-15 00:33:40.000000', 'consum', 0.0225, 'lps'),
	(450436, 124, '2015-03-15 00:33:41.000000', 'consum', 0.0218, 'lps'),
	(450437, 124, '2015-03-15 00:33:42.000000', 'consum', 0.0229, 'lps'),
	(450438, 124, '2015-03-15 00:33:43.000000', 'consum', 0.0218, 'lps'),
	(450439, 124, '2015-03-15 00:33:44.000000', 'consum', 0.0216, 'lps'),
	(450440, 124, '2015-03-15 00:33:45.000000', 'consum', 0.0216, 'lps'),
	(450441, 124, '2015-03-15 00:33:46.000000', 'consum', 0.0221, 'lps'),
	(450442, 124, '2015-03-15 00:33:47.000000', 'consum', 0.0227, 'lps'),
	(450443, 124, '2015-03-15 00:33:48.000000', 'consum', 0.0221, 'lps'),
	(450444, 124, '2015-03-15 00:33:49.000000', 'consum', 0.0216, 'lps'),
	(450445, 124, '2015-03-15 00:33:50.000000', 'consum', 0.0226, 'lps'),
	(450446, 124, '2015-03-15 00:33:51.000000', 'consum', 0.0211, 'lps'),
	(450447, 124, '2015-03-15 00:33:52.000000', 'consum', 0.0230, 'lps'),
	(450448, 124, '2015-03-15 00:33:53.000000', 'consum', 0.0224, 'lps'),
	(450449, 124, '2015-03-15 00:33:54.000000', 'consum', 0.0221, 'lps'),
	(450450, 124, '2015-03-15 00:33:55.000000', 'consum', 0.0222, 'lps'),
	(450451, 124, '2015-03-15 00:33:56.000000', 'consum', 0.0218, 'lps'),
	(450452, 124, '2015-03-15 00:33:57.000000', 'consum', 0.0214, 'lps'),
	(450453, 124, '2015-03-15 00:33:58.000000', 'consum', 0.0229, 'lps'),
	(450454, 124, '2015-03-15 00:33:59.000000', 'consum', 0.0228, 'lps'),
	(450455, 124, '2015-03-15 00:34:00.000000', 'consum', 0.0224, 'lps'),
	(450456, 124, '2015-03-15 00:34:01.000000', 'consum', 0.0225, 'lps'),
	(450457, 124, '2015-03-15 00:34:02.000000', 'consum', 0.0225, 'lps'),
	(450458, 124, '2015-03-15 00:34:03.000000', 'consum', 0.0218, 'lps'),
	(450459, 124, '2015-03-15 00:34:04.000000', 'consum', 0.0228, 'lps'),
	(450460, 124, '2015-03-15 00:34:05.000000', 'consum', 0.0211, 'lps'),
	(450461, 124, '2015-03-15 00:34:06.000000', 'consum', 0.0224, 'lps'),
	(450462, 124, '2015-03-15 00:34:07.000000', 'consum', 0.0217, 'lps'),
	(450463, 124, '2015-03-15 00:34:08.000000', 'consum', 0.0223, 'lps'),
	(450464, 124, '2015-03-15 00:34:09.000000', 'consum', 0.0212, 'lps'),
	(450465, 124, '2015-03-15 00:34:10.000000', 'consum', 0.0223, 'lps'),
	(450466, 124, '2015-03-15 00:34:11.000000', 'consum', 0.0226, 'lps'),
	(450467, 124, '2015-03-15 00:34:12.000000', 'consum', 0.0212, 'lps'),
	(450468, 124, '2015-03-15 00:34:13.000000', 'consum', 0.0215, 'lps'),
	(450469, 124, '2015-03-15 00:34:14.000000', 'consum', 0.0229, 'lps'),
	(450470, 124, '2015-03-15 00:34:15.000000', 'consum', 0.0228, 'lps'),
	(450471, 124, '2015-03-15 00:34:16.000000', 'consum', 0.0221, 'lps'),
	(450472, 124, '2015-03-15 00:34:17.000000', 'consum', 0.0212, 'lps'),
	(450473, 124, '2015-03-15 00:34:18.000000', 'consum', 0.0211, 'lps'),
	(450474, 124, '2015-03-15 00:34:19.000000', 'consum', 0.0227, 'lps'),
	(450475, 124, '2015-03-15 00:34:20.000000', 'consum', 0.0211, 'lps'),
	(450476, 124, '2015-03-15 00:34:21.000000', 'consum', 0.0225, 'lps'),
	(450477, 124, '2015-03-15 00:34:22.000000', 'consum', 0.0222, 'lps'),
	(450478, 124, '2015-03-15 00:34:23.000000', 'consum', 0.0226, 'lps'),
	(450479, 124, '2015-03-15 00:34:24.000000', 'consum', 0.0210, 'lps'),
	(450480, 124, '2015-03-15 00:34:25.000000', 'consum', 0.0227, 'lps'),
	(450481, 124, '2015-03-15 00:34:26.000000', 'consum', 0.0211, 'lps'),
	(450482, 124, '2015-03-15 00:34:27.000000', 'consum', 0.0226, 'lps'),
	(450483, 124, '2015-03-15 00:34:28.000000', 'consum', 0.0227, 'lps'),
	(450484, 124, '2015-03-15 00:34:29.000000', 'consum', 0.0226, 'lps'),
	(450485, 124, '2015-03-15 00:34:30.000000', 'consum', 0.0218, 'lps'),
	(450486, 124, '2015-03-15 00:34:31.000000', 'consum', 0.0223, 'lps'),
	(450487, 124, '2015-03-15 00:34:32.000000', 'consum', 0.0230, 'lps'),
	(450488, 124, '2015-03-15 00:34:33.000000', 'consum', 0.0229, 'lps'),
	(450489, 124, '2015-03-15 00:34:34.000000', 'consum', 0.0224, 'lps'),
	(450490, 124, '2015-03-15 00:34:35.000000', 'consum', 0.0226, 'lps'),
	(450491, 124, '2015-03-15 00:34:36.000000', 'consum', 0.0228, 'lps'),
	(450492, 124, '2015-03-15 00:34:37.000000', 'consum', 0.0210, 'lps'),
	(450493, 124, '2015-03-15 00:34:38.000000', 'consum', 0.0218, 'lps'),
	(450494, 124, '2015-03-15 00:34:39.000000', 'consum', 0.0230, 'lps'),
	(450495, 124, '2015-03-15 00:34:40.000000', 'consum', 0.0222, 'lps'),
	(450496, 124, '2015-03-15 00:34:41.000000', 'consum', 0.0212, 'lps'),
	(450497, 124, '2015-03-15 00:34:42.000000', 'consum', 0.0225, 'lps'),
	(450498, 124, '2015-03-15 00:34:43.000000', 'consum', 0.0219, 'lps'),
	(450499, 124, '2015-03-15 00:34:44.000000', 'consum', 0.0211, 'lps'),
	(450500, 124, '2015-03-15 00:34:45.000000', 'consum', 0.0230, 'lps'),
	(450501, 124, '2015-03-15 00:34:46.000000', 'consum', 0.0221, 'lps'),
	(450502, 124, '2015-03-15 00:34:47.000000', 'consum', 0.0228, 'lps'),
	(450503, 124, '2015-03-15 00:34:48.000000', 'consum', 0.0225, 'lps'),
	(450504, 124, '2015-03-15 00:34:49.000000', 'consum', 0.0212, 'lps'),
	(450505, 124, '2015-03-15 00:34:50.000000', 'consum', 0.0218, 'lps'),
	(450506, 124, '2015-03-15 00:34:51.000000', 'consum', 0.0223, 'lps'),
	(450507, 124, '2015-03-15 00:34:52.000000', 'consum', 0.0210, 'lps'),
	(450508, 124, '2015-03-15 00:34:53.000000', 'consum', 0.0214, 'lps'),
	(450509, 124, '2015-03-15 00:34:54.000000', 'consum', 0.0228, 'lps'),
	(450510, 124, '2015-03-15 00:34:55.000000', 'consum', 0.0226, 'lps'),
	(450511, 124, '2015-03-15 00:34:56.000000', 'consum', 0.0215, 'lps'),
	(450512, 124, '2015-03-15 00:34:57.000000', 'consum', 0.0211, 'lps'),
	(450513, 124, '2015-03-15 00:34:58.000000', 'consum', 0.0220, 'lps'),
	(450514, 124, '2015-03-15 00:34:59.000000', 'consum', 0.0214, 'lps'),
	(450515, 124, '2015-03-15 00:35:00.000000', 'consum', 0.0222, 'lps'),
	(450516, 124, '2015-03-15 00:35:01.000000', 'consum', 0.0217, 'lps'),
	(450517, 124, '2015-03-15 00:35:02.000000', 'consum', 0.0211, 'lps'),
	(450518, 124, '2015-03-15 00:35:03.000000', 'consum', 0.0216, 'lps'),
	(450519, 124, '2015-03-15 00:35:04.000000', 'consum', 0.0217, 'lps'),
	(450520, 124, '2015-03-15 00:35:05.000000', 'consum', 0.0228, 'lps'),
	(450521, 124, '2015-03-15 00:35:06.000000', 'consum', 0.0214, 'lps'),
	(450522, 124, '2015-03-15 00:35:07.000000', 'consum', 0.0219, 'lps'),
	(450523, 124, '2015-03-15 00:35:08.000000', 'consum', 0.0221, 'lps'),
	(450524, 124, '2015-03-15 00:35:09.000000', 'consum', 0.0218, 'lps'),
	(450525, 124, '2015-03-15 00:35:10.000000', 'consum', 0.0219, 'lps'),
	(450526, 124, '2015-03-15 00:35:11.000000', 'consum', 0.0210, 'lps'),
	(450527, 124, '2015-03-15 00:35:12.000000', 'consum', 0.0225, 'lps'),
	(450528, 124, '2015-03-15 00:35:13.000000', 'consum', 0.0223, 'lps'),
	(450529, 124, '2015-03-15 00:35:14.000000', 'consum', 0.0230, 'lps'),
	(450530, 124, '2015-03-15 00:35:15.000000', 'consum', 0.0228, 'lps'),
	(450531, 124, '2015-03-15 00:35:16.000000', 'consum', 0.0220, 'lps'),
	(450532, 124, '2015-03-15 00:35:17.000000', 'consum', 0.0228, 'lps'),
	(450533, 124, '2015-03-15 00:35:18.000000', 'consum', 0.0230, 'lps'),
	(450534, 124, '2015-03-15 00:35:19.000000', 'consum', 0.0215, 'lps'),
	(450535, 124, '2015-03-15 00:35:20.000000', 'consum', 0.0215, 'lps'),
	(450536, 124, '2015-03-15 00:35:21.000000', 'consum', 0.0223, 'lps'),
	(450537, 124, '2015-03-15 00:35:22.000000', 'consum', 0.0219, 'lps'),
	(450538, 124, '2015-03-15 00:35:23.000000', 'consum', 0.0216, 'lps'),
	(450539, 124, '2015-03-15 00:35:24.000000', 'consum', 0.0214, 'lps'),
	(450540, 124, '2015-03-15 00:35:25.000000', 'consum', 0.0213, 'lps'),
	(450541, 124, '2015-03-15 00:35:26.000000', 'consum', 0.0214, 'lps'),
	(450542, 124, '2015-03-15 00:35:27.000000', 'consum', 0.0221, 'lps'),
	(450543, 124, '2015-03-15 00:35:28.000000', 'consum', 0.0212, 'lps'),
	(450544, 124, '2015-03-15 00:35:29.000000', 'consum', 0.0227, 'lps'),
	(450545, 124, '2015-03-15 00:35:30.000000', 'consum', 0.0229, 'lps'),
	(450546, 124, '2015-03-15 00:35:31.000000', 'consum', 0.0210, 'lps'),
	(450547, 124, '2015-03-15 00:35:32.000000', 'consum', 0.0216, 'lps'),
	(450548, 124, '2015-03-15 00:35:33.000000', 'consum', 0.0220, 'lps'),
	(450549, 124, '2015-03-15 00:35:34.000000', 'consum', 0.0223, 'lps'),
	(450550, 124, '2015-03-15 00:35:35.000000', 'consum', 0.0224, 'lps'),
	(450551, 124, '2015-03-15 00:35:36.000000', 'consum', 0.0219, 'lps'),
	(450552, 124, '2015-03-15 00:35:37.000000', 'consum', 0.0213, 'lps'),
	(450553, 124, '2015-03-15 00:35:38.000000', 'consum', 0.0220, 'lps'),
	(450554, 124, '2015-03-15 00:35:39.000000', 'consum', 0.0210, 'lps'),
	(450555, 124, '2015-03-15 00:35:40.000000', 'consum', 0.0223, 'lps'),
	(450556, 124, '2015-03-15 00:35:41.000000', 'consum', 0.0210, 'lps'),
	(450557, 124, '2015-03-15 00:35:42.000000', 'consum', 0.0217, 'lps'),
	(450558, 124, '2015-03-15 00:35:43.000000', 'consum', 0.0224, 'lps'),
	(450559, 124, '2015-03-15 00:35:44.000000', 'consum', 0.0215, 'lps'),
	(450560, 124, '2015-03-15 00:35:45.000000', 'consum', 0.0215, 'lps'),
	(450561, 124, '2015-03-15 00:35:46.000000', 'consum', 0.0219, 'lps'),
	(450562, 124, '2015-03-15 00:35:47.000000', 'consum', 0.0221, 'lps'),
	(450563, 124, '2015-03-15 00:35:48.000000', 'consum', 0.0219, 'lps'),
	(450564, 124, '2015-03-15 00:35:49.000000', 'consum', 0.0220, 'lps'),
	(450565, 124, '2015-03-15 00:35:50.000000', 'consum', 0.0212, 'lps'),
	(450566, 124, '2015-03-15 00:35:51.000000', 'consum', 0.0214, 'lps'),
	(450567, 124, '2015-03-15 00:35:52.000000', 'consum', 0.0222, 'lps'),
	(450568, 124, '2015-03-15 00:35:53.000000', 'consum', 0.0216, 'lps'),
	(450569, 124, '2015-03-15 00:35:54.000000', 'consum', 0.0228, 'lps'),
	(450570, 124, '2015-03-15 00:35:55.000000', 'consum', 0.0219, 'lps'),
	(450571, 124, '2015-03-15 00:35:56.000000', 'consum', 0.0220, 'lps'),
	(450572, 124, '2015-03-15 00:35:57.000000', 'consum', 0.0215, 'lps'),
	(450573, 124, '2015-03-15 00:35:58.000000', 'consum', 0.0225, 'lps'),
	(450574, 124, '2015-03-15 00:35:59.000000', 'consum', 0.0227, 'lps'),
	(450575, 124, '2015-03-15 00:36:00.000000', 'consum', 0.0212, 'lps'),
	(450576, 124, '2015-03-15 00:36:01.000000', 'consum', 0.0210, 'lps'),
	(450577, 124, '2015-03-15 00:36:02.000000', 'consum', 0.0226, 'lps'),
	(450578, 124, '2015-03-15 00:36:03.000000', 'consum', 0.0227, 'lps'),
	(450579, 124, '2015-03-15 00:36:04.000000', 'consum', 0.0228, 'lps'),
	(450580, 124, '2015-03-15 00:36:05.000000', 'consum', 0.0228, 'lps'),
	(450581, 124, '2015-03-15 00:36:06.000000', 'consum', 0.0224, 'lps'),
	(450582, 124, '2015-03-15 00:36:07.000000', 'consum', 0.0229, 'lps'),
	(450583, 124, '2015-03-15 00:36:08.000000', 'consum', 0.0219, 'lps'),
	(450584, 124, '2015-03-15 00:36:09.000000', 'consum', 0.0219, 'lps'),
	(450585, 124, '2015-03-15 00:36:10.000000', 'consum', 0.0228, 'lps'),
	(450586, 124, '2015-03-15 00:36:11.000000', 'consum', 0.0212, 'lps'),
	(450587, 124, '2015-03-15 00:36:12.000000', 'consum', 0.0229, 'lps'),
	(450588, 124, '2015-03-15 00:36:13.000000', 'consum', 0.0216, 'lps'),
	(450589, 124, '2015-03-15 00:36:14.000000', 'consum', 0.0225, 'lps'),
	(450590, 124, '2015-03-15 00:36:15.000000', 'consum', 0.0224, 'lps'),
	(450591, 124, '2015-03-15 00:36:16.000000', 'consum', 0.0217, 'lps'),
	(450592, 124, '2015-03-15 00:36:17.000000', 'consum', 0.0225, 'lps'),
	(450593, 124, '2015-03-15 00:36:18.000000', 'consum', 0.0223, 'lps'),
	(450594, 124, '2015-03-15 00:36:19.000000', 'consum', 0.0229, 'lps'),
	(450595, 124, '2015-03-15 00:36:20.000000', 'consum', 0.0223, 'lps'),
	(450596, 124, '2015-03-15 00:36:21.000000', 'consum', 0.0222, 'lps'),
	(450597, 124, '2015-03-15 00:36:22.000000', 'consum', 0.0228, 'lps'),
	(450598, 124, '2015-03-15 00:36:23.000000', 'consum', 0.0225, 'lps'),
	(450599, 124, '2015-03-15 00:36:24.000000', 'consum', 0.0210, 'lps'),
	(450600, 124, '2015-03-15 00:36:25.000000', 'consum', 0.0227, 'lps'),
	(450601, 124, '2015-03-15 00:36:26.000000', 'consum', 0.0212, 'lps'),
	(450602, 124, '2015-03-15 00:36:27.000000', 'consum', 0.0210, 'lps'),
	(450603, 124, '2015-03-15 00:36:28.000000', 'consum', 0.0228, 'lps'),
	(450604, 124, '2015-03-15 00:36:29.000000', 'consum', 0.0217, 'lps'),
	(450605, 124, '2015-03-15 00:36:30.000000', 'consum', 0.0211, 'lps'),
	(450606, 124, '2015-03-15 00:36:31.000000', 'consum', 0.0216, 'lps'),
	(450607, 124, '2015-03-15 00:36:32.000000', 'consum', 0.0217, 'lps'),
	(450608, 124, '2015-03-15 00:36:33.000000', 'consum', 0.0228, 'lps'),
	(450609, 124, '2015-03-15 00:36:34.000000', 'consum', 0.0218, 'lps'),
	(450610, 124, '2015-03-15 00:36:35.000000', 'consum', 0.0214, 'lps'),
	(450611, 124, '2015-03-15 00:36:36.000000', 'consum', 0.0230, 'lps'),
	(450612, 124, '2015-03-15 00:36:37.000000', 'consum', 0.0214, 'lps'),
	(450613, 124, '2015-03-15 00:36:38.000000', 'consum', 0.0213, 'lps'),
	(450614, 124, '2015-03-15 00:36:39.000000', 'consum', 0.0211, 'lps'),
	(450615, 124, '2015-03-15 00:36:40.000000', 'consum', 0.0230, 'lps'),
	(450616, 124, '2015-03-15 00:36:41.000000', 'consum', 0.0224, 'lps'),
	(450617, 124, '2015-03-15 00:36:42.000000', 'consum', 0.0219, 'lps'),
	(450618, 124, '2015-03-15 00:36:43.000000', 'consum', 0.0214, 'lps'),
	(450619, 124, '2015-03-15 00:36:44.000000', 'consum', 0.0225, 'lps'),
	(450620, 124, '2015-03-15 00:36:45.000000', 'consum', 0.0210, 'lps'),
	(450621, 124, '2015-03-15 00:36:46.000000', 'consum', 0.0227, 'lps'),
	(450622, 124, '2015-03-15 00:36:47.000000', 'consum', 0.0213, 'lps'),
	(450623, 124, '2015-03-15 00:36:48.000000', 'consum', 0.0215, 'lps'),
	(450624, 124, '2015-03-15 00:36:49.000000', 'consum', 0.0227, 'lps'),
	(450625, 124, '2015-03-15 00:36:50.000000', 'consum', 0.0217, 'lps'),
	(450626, 124, '2015-03-15 00:36:51.000000', 'consum', 0.0218, 'lps'),
	(450627, 124, '2015-03-15 00:36:52.000000', 'consum', 0.0228, 'lps'),
	(450628, 124, '2015-03-15 00:36:53.000000', 'consum', 0.0213, 'lps'),
	(450629, 124, '2015-03-15 00:36:54.000000', 'consum', 0.0212, 'lps'),
	(450630, 124, '2015-03-15 00:36:55.000000', 'consum', 0.0214, 'lps'),
	(450631, 124, '2015-03-15 00:36:56.000000', 'consum', 0.0223, 'lps'),
	(450632, 124, '2015-03-15 00:36:57.000000', 'consum', 0.0222, 'lps'),
	(450633, 124, '2015-03-15 00:36:58.000000', 'consum', 0.0212, 'lps'),
	(450634, 124, '2015-03-15 00:36:59.000000', 'consum', 0.0226, 'lps'),
	(450635, 124, '2015-03-15 00:37:00.000000', 'consum', 0.0220, 'lps'),
	(450636, 124, '2015-03-15 00:37:01.000000', 'consum', 0.0215, 'lps'),
	(450637, 124, '2015-03-15 00:37:02.000000', 'consum', 0.0224, 'lps'),
	(450638, 124, '2015-03-15 00:37:03.000000', 'consum', 0.0224, 'lps'),
	(450639, 124, '2015-03-15 00:37:04.000000', 'consum', 0.0219, 'lps'),
	(450640, 124, '2015-03-15 00:37:05.000000', 'consum', 0.0212, 'lps'),
	(450641, 124, '2015-03-15 00:37:06.000000', 'consum', 0.0214, 'lps'),
	(450642, 124, '2015-03-15 00:37:07.000000', 'consum', 0.0226, 'lps'),
	(450643, 124, '2015-03-15 00:37:08.000000', 'consum', 0.0215, 'lps'),
	(450644, 124, '2015-03-15 00:37:09.000000', 'consum', 0.0210, 'lps'),
	(450645, 124, '2015-03-15 00:37:10.000000', 'consum', 0.0214, 'lps'),
	(450646, 124, '2015-03-15 00:37:11.000000', 'consum', 0.0212, 'lps'),
	(450647, 124, '2015-03-15 00:37:12.000000', 'consum', 0.0227, 'lps'),
	(450648, 124, '2015-03-15 00:37:13.000000', 'consum', 0.0228, 'lps'),
	(450649, 124, '2015-03-15 00:37:14.000000', 'consum', 0.0228, 'lps'),
	(450650, 124, '2015-03-15 00:37:15.000000', 'consum', 0.0228, 'lps'),
	(450651, 124, '2015-03-15 00:37:16.000000', 'consum', 0.0223, 'lps'),
	(450652, 124, '2015-03-15 00:37:17.000000', 'consum', 0.0220, 'lps'),
	(450653, 124, '2015-03-15 00:37:18.000000', 'consum', 0.0224, 'lps'),
	(450654, 124, '2015-03-15 00:37:19.000000', 'consum', 0.0228, 'lps'),
	(450655, 124, '2015-03-15 00:37:20.000000', 'consum', 0.0218, 'lps'),
	(450656, 124, '2015-03-15 00:37:21.000000', 'consum', 0.0216, 'lps'),
	(450657, 124, '2015-03-15 00:37:22.000000', 'consum', 0.0216, 'lps'),
	(450658, 124, '2015-03-15 00:37:23.000000', 'consum', 0.0224, 'lps'),
	(450659, 124, '2015-03-15 00:37:24.000000', 'consum', 0.0218, 'lps'),
	(450660, 124, '2015-03-15 00:37:25.000000', 'consum', 0.0210, 'lps'),
	(450661, 124, '2015-03-15 00:37:26.000000', 'consum', 0.0228, 'lps'),
	(450662, 124, '2015-03-15 00:37:27.000000', 'consum', 0.0217, 'lps'),
	(450663, 124, '2015-03-15 00:37:28.000000', 'consum', 0.0212, 'lps'),
	(450664, 124, '2015-03-15 00:37:29.000000', 'consum', 0.0221, 'lps'),
	(450665, 124, '2015-03-15 00:37:30.000000', 'consum', 0.0218, 'lps'),
	(450666, 124, '2015-03-15 00:37:31.000000', 'consum', 0.0216, 'lps'),
	(450667, 124, '2015-03-15 00:37:32.000000', 'consum', 0.0219, 'lps'),
	(450668, 124, '2015-03-15 00:37:33.000000', 'consum', 0.0215, 'lps'),
	(450669, 124, '2015-03-15 00:37:34.000000', 'consum', 0.0210, 'lps'),
	(450670, 124, '2015-03-15 00:37:35.000000', 'consum', 0.0217, 'lps'),
	(450671, 124, '2015-03-15 00:37:36.000000', 'consum', 0.0223, 'lps'),
	(450672, 124, '2015-03-15 00:37:37.000000', 'consum', 0.0213, 'lps'),
	(450673, 124, '2015-03-15 00:37:38.000000', 'consum', 0.0228, 'lps'),
	(450674, 124, '2015-03-15 00:37:39.000000', 'consum', 0.0228, 'lps'),
	(450675, 124, '2015-03-15 00:37:40.000000', 'consum', 0.0228, 'lps'),
	(450676, 124, '2015-03-15 00:37:41.000000', 'consum', 0.0224, 'lps'),
	(450677, 124, '2015-03-15 00:37:42.000000', 'consum', 0.0227, 'lps'),
	(450678, 124, '2015-03-15 00:37:43.000000', 'consum', 0.0213, 'lps'),
	(450679, 124, '2015-03-15 00:37:44.000000', 'consum', 0.0217, 'lps'),
	(450680, 124, '2015-03-15 00:37:45.000000', 'consum', 0.0212, 'lps'),
	(450681, 124, '2015-03-15 00:37:46.000000', 'consum', 0.0224, 'lps'),
	(450682, 124, '2015-03-15 00:37:47.000000', 'consum', 0.0211, 'lps'),
	(450683, 124, '2015-03-15 00:37:48.000000', 'consum', 0.0215, 'lps'),
	(450684, 124, '2015-03-15 00:37:49.000000', 'consum', 0.0211, 'lps'),
	(450685, 124, '2015-03-15 00:37:50.000000', 'consum', 0.0221, 'lps'),
	(450686, 124, '2015-03-15 00:37:51.000000', 'consum', 0.0223, 'lps'),
	(450687, 124, '2015-03-15 00:37:52.000000', 'consum', 0.0220, 'lps'),
	(450688, 124, '2015-03-15 00:37:53.000000', 'consum', 0.0220, 'lps'),
	(450689, 124, '2015-03-15 00:37:54.000000', 'consum', 0.0211, 'lps'),
	(450690, 124, '2015-03-15 00:37:55.000000', 'consum', 0.0227, 'lps'),
	(450691, 124, '2015-03-15 00:37:56.000000', 'consum', 0.0229, 'lps'),
	(450692, 124, '2015-03-15 00:37:57.000000', 'consum', 0.0215, 'lps'),
	(450693, 124, '2015-03-15 00:37:58.000000', 'consum', 0.0218, 'lps'),
	(450694, 124, '2015-03-15 00:37:59.000000', 'consum', 0.0214, 'lps'),
	(450695, 124, '2015-03-15 00:38:00.000000', 'consum', 0.0227, 'lps'),
	(450696, 124, '2015-03-15 00:38:01.000000', 'consum', 0.0222, 'lps'),
	(450697, 124, '2015-03-15 00:38:02.000000', 'consum', 0.0217, 'lps'),
	(450698, 124, '2015-03-15 00:38:03.000000', 'consum', 0.0212, 'lps'),
	(450699, 124, '2015-03-15 00:38:04.000000', 'consum', 0.0222, 'lps'),
	(450700, 124, '2015-03-15 00:38:05.000000', 'consum', 0.0221, 'lps'),
	(450701, 124, '2015-03-15 00:38:06.000000', 'consum', 0.0228, 'lps'),
	(450702, 124, '2015-03-15 00:38:07.000000', 'consum', 0.0225, 'lps'),
	(450703, 124, '2015-03-15 00:38:08.000000', 'consum', 0.0214, 'lps'),
	(450704, 124, '2015-03-15 00:38:09.000000', 'consum', 0.0224, 'lps'),
	(450705, 124, '2015-03-15 00:38:10.000000', 'consum', 0.0226, 'lps'),
	(450706, 124, '2015-03-15 00:38:11.000000', 'consum', 0.0210, 'lps'),
	(450707, 124, '2015-03-15 00:38:12.000000', 'consum', 0.0222, 'lps'),
	(450708, 124, '2015-03-15 00:38:13.000000', 'consum', 0.0210, 'lps'),
	(450709, 124, '2015-03-15 00:38:14.000000', 'consum', 0.0217, 'lps'),
	(450710, 124, '2015-03-15 00:38:15.000000', 'consum', 0.0224, 'lps'),
	(450711, 124, '2015-03-15 00:38:16.000000', 'consum', 0.0219, 'lps'),
	(450712, 124, '2015-03-15 00:38:17.000000', 'consum', 0.0210, 'lps'),
	(450713, 124, '2015-03-15 00:38:18.000000', 'consum', 0.0228, 'lps'),
	(450714, 124, '2015-03-15 00:38:19.000000', 'consum', 0.0217, 'lps'),
	(450715, 124, '2015-03-15 00:38:20.000000', 'consum', 0.0211, 'lps'),
	(450716, 124, '2015-03-15 00:38:21.000000', 'consum', 0.0215, 'lps'),
	(450717, 124, '2015-03-15 00:38:22.000000', 'consum', 0.0214, 'lps'),
	(450718, 124, '2015-03-15 00:38:23.000000', 'consum', 0.0215, 'lps'),
	(450719, 124, '2015-03-15 00:38:24.000000', 'consum', 0.0225, 'lps'),
	(450720, 124, '2015-03-15 00:38:25.000000', 'consum', 0.0227, 'lps'),
	(450721, 124, '2015-03-15 00:38:26.000000', 'consum', 0.0230, 'lps'),
	(450722, 124, '2015-03-15 00:38:27.000000', 'consum', 0.0217, 'lps'),
	(450723, 124, '2015-03-15 00:38:28.000000', 'consum', 0.0225, 'lps'),
	(450724, 124, '2015-03-15 00:38:29.000000', 'consum', 0.0226, 'lps'),
	(450725, 124, '2015-03-15 00:38:30.000000', 'consum', 0.0225, 'lps'),
	(450726, 124, '2015-03-15 00:38:31.000000', 'consum', 0.0217, 'lps'),
	(450727, 124, '2015-03-15 00:38:32.000000', 'consum', 0.0219, 'lps'),
	(450728, 124, '2015-03-15 00:38:33.000000', 'consum', 0.0213, 'lps'),
	(450729, 124, '2015-03-15 00:38:34.000000', 'consum', 0.0222, 'lps'),
	(450730, 124, '2015-03-15 00:38:35.000000', 'consum', 0.0218, 'lps'),
	(450731, 124, '2015-03-15 00:38:36.000000', 'consum', 0.0215, 'lps'),
	(450732, 124, '2015-03-15 00:38:37.000000', 'consum', 0.0211, 'lps'),
	(450733, 124, '2015-03-15 00:38:38.000000', 'consum', 0.0222, 'lps'),
	(450734, 124, '2015-03-15 00:38:39.000000', 'consum', 0.0225, 'lps'),
	(450735, 124, '2015-03-15 00:38:40.000000', 'consum', 0.0230, 'lps'),
	(450736, 124, '2015-03-15 00:38:41.000000', 'consum', 0.0221, 'lps'),
	(450737, 124, '2015-03-15 00:38:42.000000', 'consum', 0.0228, 'lps'),
	(450738, 124, '2015-03-15 00:38:43.000000', 'consum', 0.0224, 'lps'),
	(450739, 124, '2015-03-15 00:38:44.000000', 'consum', 0.0227, 'lps'),
	(450740, 124, '2015-03-15 00:38:45.000000', 'consum', 0.0213, 'lps'),
	(450741, 124, '2015-03-15 00:38:46.000000', 'consum', 0.0216, 'lps'),
	(450742, 124, '2015-03-15 00:38:47.000000', 'consum', 0.0212, 'lps'),
	(450743, 124, '2015-03-15 00:38:48.000000', 'consum', 0.0220, 'lps'),
	(450744, 124, '2015-03-15 00:38:49.000000', 'consum', 0.0216, 'lps'),
	(450745, 124, '2015-03-15 00:38:50.000000', 'consum', 0.0210, 'lps'),
	(450746, 124, '2015-03-15 00:38:51.000000', 'consum', 0.0211, 'lps'),
	(450747, 124, '2015-03-15 00:38:52.000000', 'consum', 0.0218, 'lps'),
	(450748, 124, '2015-03-15 00:38:53.000000', 'consum', 0.0227, 'lps'),
	(450749, 124, '2015-03-15 00:38:54.000000', 'consum', 0.0229, 'lps'),
	(450750, 124, '2015-03-15 00:38:55.000000', 'consum', 0.0213, 'lps'),
	(450751, 124, '2015-03-15 00:38:56.000000', 'consum', 0.0211, 'lps'),
	(450752, 124, '2015-03-15 00:38:57.000000', 'consum', 0.0228, 'lps'),
	(450753, 124, '2015-03-15 00:38:58.000000', 'consum', 0.0213, 'lps'),
	(450754, 124, '2015-03-15 00:38:59.000000', 'consum', 0.0215, 'lps'),
	(450755, 124, '2015-03-15 00:39:00.000000', 'consum', 0.0223, 'lps'),
	(450756, 124, '2015-03-15 00:39:01.000000', 'consum', 0.0222, 'lps'),
	(450757, 124, '2015-03-15 00:39:02.000000', 'consum', 0.0210, 'lps'),
	(450758, 124, '2015-03-15 00:39:03.000000', 'consum', 0.0216, 'lps'),
	(450759, 124, '2015-03-15 00:39:04.000000', 'consum', 0.0218, 'lps'),
	(450760, 124, '2015-03-15 00:39:05.000000', 'consum', 0.0212, 'lps'),
	(450761, 124, '2015-03-15 00:39:06.000000', 'consum', 0.0217, 'lps'),
	(450762, 124, '2015-03-15 00:39:07.000000', 'consum', 0.0217, 'lps'),
	(450763, 124, '2015-03-15 00:39:08.000000', 'consum', 0.0227, 'lps'),
	(450764, 124, '2015-03-15 00:39:09.000000', 'consum', 0.0211, 'lps'),
	(450765, 124, '2015-03-15 00:39:10.000000', 'consum', 0.0229, 'lps'),
	(450766, 124, '2015-03-15 00:39:11.000000', 'consum', 0.0216, 'lps'),
	(450767, 124, '2015-03-15 00:39:12.000000', 'consum', 0.0228, 'lps'),
	(450768, 124, '2015-03-15 00:39:13.000000', 'consum', 0.0219, 'lps'),
	(450769, 124, '2015-03-15 00:39:14.000000', 'consum', 0.0221, 'lps'),
	(450770, 124, '2015-03-15 00:39:15.000000', 'consum', 0.0220, 'lps'),
	(450771, 124, '2015-03-15 00:39:16.000000', 'consum', 0.0226, 'lps'),
	(450772, 124, '2015-03-15 00:39:17.000000', 'consum', 0.0217, 'lps'),
	(450773, 124, '2015-03-15 00:39:18.000000', 'consum', 0.0221, 'lps'),
	(450774, 124, '2015-03-15 00:39:19.000000', 'consum', 0.0223, 'lps'),
	(450775, 124, '2015-03-15 00:39:20.000000', 'consum', 0.0219, 'lps'),
	(450776, 124, '2015-03-15 00:39:21.000000', 'consum', 0.0219, 'lps'),
	(450777, 124, '2015-03-15 00:39:22.000000', 'consum', 0.0228, 'lps'),
	(450778, 124, '2015-03-15 00:39:23.000000', 'consum', 0.0212, 'lps'),
	(450779, 124, '2015-03-15 00:39:24.000000', 'consum', 0.0227, 'lps'),
	(450780, 124, '2015-03-15 00:39:25.000000', 'consum', 0.0226, 'lps'),
	(450781, 124, '2015-03-15 00:39:26.000000', 'consum', 0.0219, 'lps'),
	(450782, 124, '2015-03-15 00:39:27.000000', 'consum', 0.0210, 'lps'),
	(450783, 124, '2015-03-15 00:39:28.000000', 'consum', 0.0223, 'lps'),
	(450784, 124, '2015-03-15 00:39:29.000000', 'consum', 0.0215, 'lps'),
	(450785, 124, '2015-03-15 00:39:30.000000', 'consum', 0.0217, 'lps'),
	(450786, 124, '2015-03-15 00:39:31.000000', 'consum', 0.0211, 'lps'),
	(450787, 124, '2015-03-15 00:39:32.000000', 'consum', 0.0213, 'lps'),
	(450788, 124, '2015-03-15 00:39:33.000000', 'consum', 0.0222, 'lps'),
	(450789, 124, '2015-03-15 00:39:34.000000', 'consum', 0.0222, 'lps'),
	(450790, 124, '2015-03-15 00:39:35.000000', 'consum', 0.0213, 'lps'),
	(450791, 124, '2015-03-15 00:39:36.000000', 'consum', 0.0210, 'lps'),
	(450792, 124, '2015-03-15 00:39:37.000000', 'consum', 0.0220, 'lps'),
	(450793, 124, '2015-03-15 00:39:38.000000', 'consum', 0.0222, 'lps'),
	(450794, 124, '2015-03-15 00:39:39.000000', 'consum', 0.0219, 'lps'),
	(450795, 124, '2015-03-15 00:39:40.000000', 'consum', 0.0218, 'lps'),
	(450796, 124, '2015-03-15 00:39:41.000000', 'consum', 0.0226, 'lps'),
	(450797, 124, '2015-03-15 00:39:42.000000', 'consum', 0.0224, 'lps'),
	(450798, 124, '2015-03-15 00:39:43.000000', 'consum', 0.0211, 'lps'),
	(450799, 124, '2015-03-15 00:39:44.000000', 'consum', 0.0216, 'lps'),
	(450800, 124, '2015-03-15 00:39:45.000000', 'consum', 0.0215, 'lps'),
	(450801, 124, '2015-03-15 00:39:46.000000', 'consum', 0.0220, 'lps'),
	(450802, 124, '2015-03-15 00:39:47.000000', 'consum', 0.0222, 'lps'),
	(450803, 124, '2015-03-15 00:39:48.000000', 'consum', 0.0222, 'lps'),
	(450804, 124, '2015-03-15 00:39:49.000000', 'consum', 0.0211, 'lps'),
	(450805, 124, '2015-03-15 00:39:50.000000', 'consum', 0.0224, 'lps'),
	(450806, 124, '2015-03-15 00:39:51.000000', 'consum', 0.0215, 'lps'),
	(450807, 124, '2015-03-15 00:39:52.000000', 'consum', 0.0214, 'lps'),
	(450808, 124, '2015-03-15 00:39:53.000000', 'consum', 0.0215, 'lps'),
	(450809, 124, '2015-03-15 00:39:54.000000', 'consum', 0.0222, 'lps'),
	(450810, 124, '2015-03-15 00:39:55.000000', 'consum', 0.0216, 'lps'),
	(450811, 124, '2015-03-15 00:39:56.000000', 'consum', 0.0223, 'lps'),
	(450812, 124, '2015-03-15 00:39:57.000000', 'consum', 0.0219, 'lps'),
	(450813, 124, '2015-03-15 00:39:58.000000', 'consum', 0.0213, 'lps'),
	(450814, 124, '2015-03-15 00:39:59.000000', 'consum', 0.0222, 'lps'),
	(450815, 124, '2015-03-15 00:40:00.000000', 'consum', 0.0218, 'lps'),
	(450816, 124, '2015-03-15 00:40:01.000000', 'consum', 0.0216, 'lps'),
	(450817, 124, '2015-03-15 00:40:02.000000', 'consum', 0.0214, 'lps'),
	(450818, 124, '2015-03-15 00:40:03.000000', 'consum', 0.0213, 'lps'),
	(450819, 124, '2015-03-15 00:40:04.000000', 'consum', 0.0215, 'lps'),
	(450820, 124, '2015-03-15 00:40:05.000000', 'consum', 0.0224, 'lps'),
	(450821, 124, '2015-03-15 00:40:06.000000', 'consum', 0.0226, 'lps'),
	(450822, 124, '2015-03-15 00:40:07.000000', 'consum', 0.0226, 'lps'),
	(450823, 124, '2015-03-15 00:40:08.000000', 'consum', 0.0220, 'lps'),
	(450824, 124, '2015-03-15 00:40:09.000000', 'consum', 0.0214, 'lps'),
	(450825, 124, '2015-03-15 00:40:10.000000', 'consum', 0.0222, 'lps'),
	(450826, 124, '2015-03-15 00:40:11.000000', 'consum', 0.0217, 'lps'),
	(450827, 124, '2015-03-15 00:40:12.000000', 'consum', 0.0230, 'lps'),
	(450828, 124, '2015-03-15 00:40:13.000000', 'consum', 0.0225, 'lps'),
	(450829, 124, '2015-03-15 00:40:14.000000', 'consum', 0.0225, 'lps'),
	(450830, 124, '2015-03-15 00:40:15.000000', 'consum', 0.0221, 'lps'),
	(450831, 124, '2015-03-15 00:40:16.000000', 'consum', 0.0221, 'lps'),
	(450832, 124, '2015-03-15 00:40:17.000000', 'consum', 0.0210, 'lps'),
	(450833, 124, '2015-03-15 00:40:18.000000', 'consum', 0.0219, 'lps'),
	(450834, 124, '2015-03-15 00:40:19.000000', 'consum', 0.0215, 'lps'),
	(450835, 124, '2015-03-15 00:40:20.000000', 'consum', 0.0229, 'lps'),
	(450836, 124, '2015-03-15 00:40:21.000000', 'consum', 0.0229, 'lps'),
	(450837, 124, '2015-03-15 00:40:22.000000', 'consum', 0.0224, 'lps'),
	(450838, 124, '2015-03-15 00:40:23.000000', 'consum', 0.0227, 'lps'),
	(450839, 124, '2015-03-15 00:40:24.000000', 'consum', 0.0212, 'lps'),
	(450840, 124, '2015-03-15 00:40:25.000000', 'consum', 0.0230, 'lps'),
	(450841, 124, '2015-03-15 00:40:26.000000', 'consum', 0.0222, 'lps'),
	(450842, 124, '2015-03-15 00:40:27.000000', 'consum', 0.0212, 'lps'),
	(450843, 124, '2015-03-15 00:40:28.000000', 'consum', 0.0224, 'lps'),
	(450844, 124, '2015-03-15 00:40:29.000000', 'consum', 0.0212, 'lps'),
	(450845, 124, '2015-03-15 00:40:30.000000', 'consum', 0.0222, 'lps'),
	(450846, 124, '2015-03-15 00:40:31.000000', 'consum', 0.0221, 'lps'),
	(450847, 124, '2015-03-15 00:40:32.000000', 'consum', 0.0210, 'lps'),
	(450848, 124, '2015-03-15 00:40:33.000000', 'consum', 0.0217, 'lps'),
	(450849, 124, '2015-03-15 00:40:34.000000', 'consum', 0.0226, 'lps'),
	(450850, 124, '2015-03-15 00:40:35.000000', 'consum', 0.0226, 'lps'),
	(450851, 124, '2015-03-15 00:40:36.000000', 'consum', 0.0224, 'lps'),
	(450852, 124, '2015-03-15 00:40:37.000000', 'consum', 0.0230, 'lps'),
	(450853, 124, '2015-03-15 00:40:38.000000', 'consum', 0.0226, 'lps'),
	(450854, 124, '2015-03-15 00:40:39.000000', 'consum', 0.0211, 'lps'),
	(450855, 124, '2015-03-15 00:40:40.000000', 'consum', 0.0230, 'lps'),
	(450856, 124, '2015-03-15 00:40:41.000000', 'consum', 0.0223, 'lps'),
	(450857, 124, '2015-03-15 00:40:42.000000', 'consum', 0.0216, 'lps'),
	(450858, 124, '2015-03-15 00:40:43.000000', 'consum', 0.0222, 'lps'),
	(450859, 124, '2015-03-15 00:40:44.000000', 'consum', 0.0212, 'lps'),
	(450860, 124, '2015-03-15 00:40:45.000000', 'consum', 0.0224, 'lps'),
	(450861, 124, '2015-03-15 00:40:46.000000', 'consum', 0.0211, 'lps'),
	(450862, 124, '2015-03-15 00:40:47.000000', 'consum', 0.0217, 'lps'),
	(450863, 124, '2015-03-15 00:40:48.000000', 'consum', 0.0222, 'lps'),
	(450864, 124, '2015-03-15 00:40:49.000000', 'consum', 0.0228, 'lps'),
	(450865, 124, '2015-03-15 00:40:50.000000', 'consum', 0.0223, 'lps'),
	(450866, 124, '2015-03-15 00:40:51.000000', 'consum', 0.0222, 'lps'),
	(450867, 124, '2015-03-15 00:40:52.000000', 'consum', 0.0210, 'lps'),
	(450868, 124, '2015-03-15 00:40:53.000000', 'consum', 0.0215, 'lps'),
	(450869, 124, '2015-03-15 00:40:54.000000', 'consum', 0.0215, 'lps'),
	(450870, 124, '2015-03-15 00:40:55.000000', 'consum', 0.0219, 'lps'),
	(450871, 124, '2015-03-15 00:40:56.000000', 'consum', 0.0222, 'lps'),
	(450872, 124, '2015-03-15 00:40:57.000000', 'consum', 0.0223, 'lps'),
	(450873, 124, '2015-03-15 00:40:58.000000', 'consum', 0.0219, 'lps'),
	(450874, 124, '2015-03-15 00:40:59.000000', 'consum', 0.0217, 'lps'),
	(450875, 124, '2015-03-15 00:41:00.000000', 'consum', 0.0219, 'lps'),
	(450876, 124, '2015-03-15 00:41:01.000000', 'consum', 0.0211, 'lps'),
	(450877, 124, '2015-03-15 00:41:02.000000', 'consum', 0.0230, 'lps'),
	(450878, 124, '2015-03-15 00:41:03.000000', 'consum', 0.0224, 'lps'),
	(450879, 124, '2015-03-15 00:41:04.000000', 'consum', 0.0219, 'lps'),
	(450880, 124, '2015-03-15 00:41:05.000000', 'consum', 0.0217, 'lps'),
	(450881, 124, '2015-03-15 00:41:06.000000', 'consum', 0.0216, 'lps'),
	(450882, 124, '2015-03-15 00:41:07.000000', 'consum', 0.0221, 'lps'),
	(450883, 124, '2015-03-15 00:41:08.000000', 'consum', 0.0226, 'lps'),
	(450884, 124, '2015-03-15 00:41:09.000000', 'consum', 0.0215, 'lps'),
	(450885, 124, '2015-03-15 00:41:10.000000', 'consum', 0.0229, 'lps'),
	(450886, 124, '2015-03-15 00:41:11.000000', 'consum', 0.0229, 'lps'),
	(450887, 124, '2015-03-15 00:41:12.000000', 'consum', 0.0228, 'lps'),
	(450888, 124, '2015-03-15 00:41:13.000000', 'consum', 0.0221, 'lps'),
	(450889, 124, '2015-03-15 00:41:14.000000', 'consum', 0.0213, 'lps'),
	(450890, 124, '2015-03-15 00:41:15.000000', 'consum', 0.0213, 'lps'),
	(450891, 124, '2015-03-15 00:41:16.000000', 'consum', 0.0217, 'lps'),
	(450892, 124, '2015-03-15 00:41:17.000000', 'consum', 0.0213, 'lps'),
	(450893, 124, '2015-03-15 00:41:18.000000', 'consum', 0.0227, 'lps'),
	(450894, 124, '2015-03-15 00:41:19.000000', 'consum', 0.0223, 'lps'),
	(450895, 124, '2015-03-15 00:41:20.000000', 'consum', 0.0224, 'lps'),
	(450896, 124, '2015-03-15 00:41:21.000000', 'consum', 0.0222, 'lps'),
	(450897, 124, '2015-03-15 00:41:22.000000', 'consum', 0.0227, 'lps'),
	(450898, 124, '2015-03-15 00:41:23.000000', 'consum', 0.0218, 'lps'),
	(450899, 124, '2015-03-15 00:41:24.000000', 'consum', 0.0221, 'lps'),
	(450900, 124, '2015-03-15 00:41:25.000000', 'consum', 0.0221, 'lps'),
	(450901, 124, '2015-03-15 00:41:26.000000', 'consum', 0.0211, 'lps'),
	(450902, 124, '2015-03-15 00:41:27.000000', 'consum', 0.0226, 'lps'),
	(450903, 124, '2015-03-15 00:41:28.000000', 'consum', 0.0225, 'lps'),
	(450904, 124, '2015-03-15 00:41:29.000000', 'consum', 0.0213, 'lps'),
	(450905, 124, '2015-03-15 00:41:30.000000', 'consum', 0.0226, 'lps'),
	(450906, 124, '2015-03-15 00:41:31.000000', 'consum', 0.0216, 'lps'),
	(450907, 124, '2015-03-15 00:41:32.000000', 'consum', 0.0213, 'lps'),
	(450908, 124, '2015-03-15 00:41:33.000000', 'consum', 0.0229, 'lps'),
	(450909, 124, '2015-03-15 00:41:34.000000', 'consum', 0.0213, 'lps'),
	(450910, 124, '2015-03-15 00:41:35.000000', 'consum', 0.0211, 'lps'),
	(450911, 124, '2015-03-15 00:41:36.000000', 'consum', 0.0228, 'lps'),
	(450912, 124, '2015-03-15 00:41:37.000000', 'consum', 0.0214, 'lps'),
	(450913, 124, '2015-03-15 00:41:38.000000', 'consum', 0.0216, 'lps'),
	(450914, 124, '2015-03-15 00:41:39.000000', 'consum', 0.0230, 'lps'),
	(450915, 124, '2015-03-15 00:41:40.000000', 'consum', 0.0230, 'lps'),
	(450916, 124, '2015-03-15 00:41:41.000000', 'consum', 0.0227, 'lps'),
	(450917, 124, '2015-03-15 00:41:42.000000', 'consum', 0.0216, 'lps'),
	(450918, 124, '2015-03-15 00:41:43.000000', 'consum', 0.0212, 'lps'),
	(450919, 124, '2015-03-15 00:41:44.000000', 'consum', 0.0224, 'lps'),
	(450920, 124, '2015-03-15 00:41:45.000000', 'consum', 0.0212, 'lps'),
	(450921, 124, '2015-03-15 00:41:46.000000', 'consum', 0.0219, 'lps'),
	(450922, 124, '2015-03-15 00:41:47.000000', 'consum', 0.0230, 'lps'),
	(450923, 124, '2015-03-15 00:41:48.000000', 'consum', 0.0218, 'lps'),
	(450924, 124, '2015-03-15 00:41:49.000000', 'consum', 0.0214, 'lps'),
	(450925, 124, '2015-03-15 00:41:50.000000', 'consum', 0.0228, 'lps'),
	(450926, 124, '2015-03-15 00:41:51.000000', 'consum', 0.0222, 'lps'),
	(450927, 124, '2015-03-15 00:41:52.000000', 'consum', 0.0220, 'lps'),
	(450928, 124, '2015-03-15 00:41:53.000000', 'consum', 0.0223, 'lps'),
	(450929, 124, '2015-03-15 00:41:54.000000', 'consum', 0.0223, 'lps'),
	(450930, 124, '2015-03-15 00:41:55.000000', 'consum', 0.0217, 'lps'),
	(450931, 124, '2015-03-15 00:41:56.000000', 'consum', 0.0225, 'lps'),
	(450932, 124, '2015-03-15 00:41:57.000000', 'consum', 0.0225, 'lps'),
	(450933, 124, '2015-03-15 00:41:58.000000', 'consum', 0.0219, 'lps'),
	(450934, 124, '2015-03-15 00:41:59.000000', 'consum', 0.0213, 'lps'),
	(450935, 124, '2015-03-15 00:42:00.000000', 'consum', 0.0216, 'lps'),
	(450936, 124, '2015-03-15 00:42:01.000000', 'consum', 0.0210, 'lps'),
	(450937, 124, '2015-03-15 00:42:02.000000', 'consum', 0.0216, 'lps'),
	(450938, 124, '2015-03-15 00:42:03.000000', 'consum', 0.0220, 'lps'),
	(450939, 124, '2015-03-15 00:42:04.000000', 'consum', 0.0221, 'lps'),
	(450940, 124, '2015-03-15 00:42:05.000000', 'consum', 0.0214, 'lps'),
	(450941, 124, '2015-03-15 00:42:06.000000', 'consum', 0.0220, 'lps'),
	(450942, 124, '2015-03-15 00:42:07.000000', 'consum', 0.0228, 'lps'),
	(450943, 124, '2015-03-15 00:42:08.000000', 'consum', 0.0229, 'lps'),
	(450944, 124, '2015-03-15 00:42:09.000000', 'consum', 0.0228, 'lps'),
	(450945, 124, '2015-03-15 00:42:10.000000', 'consum', 0.0223, 'lps'),
	(450946, 124, '2015-03-15 00:42:11.000000', 'consum', 0.0221, 'lps'),
	(450947, 124, '2015-03-15 00:42:12.000000', 'consum', 0.0229, 'lps'),
	(450948, 124, '2015-03-15 00:42:13.000000', 'consum', 0.0230, 'lps'),
	(450949, 124, '2015-03-15 00:42:14.000000', 'consum', 0.0212, 'lps'),
	(450950, 124, '2015-03-15 00:42:15.000000', 'consum', 0.0222, 'lps'),
	(450951, 124, '2015-03-15 00:42:16.000000', 'consum', 0.0223, 'lps'),
	(450952, 124, '2015-03-15 00:42:17.000000', 'consum', 0.0217, 'lps'),
	(450953, 124, '2015-03-15 00:42:18.000000', 'consum', 0.0228, 'lps'),
	(450954, 124, '2015-03-15 00:42:19.000000', 'consum', 0.0219, 'lps'),
	(450955, 124, '2015-03-15 00:42:20.000000', 'consum', 0.0220, 'lps'),
	(450956, 124, '2015-03-15 00:42:21.000000', 'consum', 0.0215, 'lps'),
	(450957, 124, '2015-03-15 00:42:22.000000', 'consum', 0.0227, 'lps'),
	(450958, 124, '2015-03-15 00:42:23.000000', 'consum', 0.0214, 'lps'),
	(450959, 124, '2015-03-15 00:42:24.000000', 'consum', 0.0224, 'lps'),
	(450960, 124, '2015-03-15 00:42:25.000000', 'consum', 0.0225, 'lps'),
	(450961, 124, '2015-03-15 00:42:26.000000', 'consum', 0.0225, 'lps'),
	(450962, 124, '2015-03-15 00:42:27.000000', 'consum', 0.0218, 'lps'),
	(450963, 124, '2015-03-15 00:42:28.000000', 'consum', 0.0228, 'lps'),
	(450964, 124, '2015-03-15 00:42:29.000000', 'consum', 0.0215, 'lps'),
	(450965, 124, '2015-03-15 00:42:30.000000', 'consum', 0.0220, 'lps'),
	(450966, 124, '2015-03-15 00:42:31.000000', 'consum', 0.0225, 'lps'),
	(450967, 124, '2015-03-15 00:42:32.000000', 'consum', 0.0215, 'lps'),
	(450968, 124, '2015-03-15 00:42:33.000000', 'consum', 0.0210, 'lps'),
	(450969, 124, '2015-03-15 00:42:34.000000', 'consum', 0.0216, 'lps'),
	(450970, 124, '2015-03-15 00:42:35.000000', 'consum', 0.0220, 'lps'),
	(450971, 124, '2015-03-15 00:42:36.000000', 'consum', 0.0221, 'lps'),
	(450972, 124, '2015-03-15 00:42:37.000000', 'consum', 0.0217, 'lps'),
	(450973, 124, '2015-03-15 00:42:38.000000', 'consum', 0.0212, 'lps'),
	(450974, 124, '2015-03-15 00:42:39.000000', 'consum', 0.0218, 'lps'),
	(450975, 124, '2015-03-15 00:42:40.000000', 'consum', 0.0224, 'lps'),
	(450976, 124, '2015-03-15 00:42:41.000000', 'consum', 0.0217, 'lps'),
	(450977, 124, '2015-03-15 00:42:42.000000', 'consum', 0.0223, 'lps'),
	(450978, 124, '2015-03-15 00:42:43.000000', 'consum', 0.0214, 'lps'),
	(450979, 124, '2015-03-15 00:42:44.000000', 'consum', 0.0212, 'lps'),
	(450980, 124, '2015-03-15 00:42:45.000000', 'consum', 0.0229, 'lps'),
	(450981, 124, '2015-03-15 00:42:46.000000', 'consum', 0.0215, 'lps'),
	(450982, 124, '2015-03-15 00:42:47.000000', 'consum', 0.0222, 'lps'),
	(450983, 124, '2015-03-15 00:42:48.000000', 'consum', 0.0213, 'lps'),
	(450984, 124, '2015-03-15 00:42:49.000000', 'consum', 0.0212, 'lps'),
	(450985, 124, '2015-03-15 00:42:50.000000', 'consum', 0.0210, 'lps'),
	(450986, 124, '2015-03-15 00:42:51.000000', 'consum', 0.0224, 'lps'),
	(450987, 124, '2015-03-15 00:42:52.000000', 'consum', 0.0217, 'lps'),
	(450988, 124, '2015-03-15 00:42:53.000000', 'consum', 0.0226, 'lps'),
	(450989, 124, '2015-03-15 00:42:54.000000', 'consum', 0.0227, 'lps'),
	(450990, 124, '2015-03-15 00:42:55.000000', 'consum', 0.0228, 'lps'),
	(450991, 124, '2015-03-15 00:42:56.000000', 'consum', 0.0228, 'lps'),
	(450992, 124, '2015-03-15 00:42:57.000000', 'consum', 0.0227, 'lps'),
	(450993, 124, '2015-03-15 00:42:58.000000', 'consum', 0.0219, 'lps'),
	(450994, 124, '2015-03-15 00:42:59.000000', 'consum', 0.0227, 'lps'),
	(450995, 124, '2015-03-15 00:43:00.000000', 'consum', 0.0228, 'lps'),
	(450996, 124, '2015-03-15 00:43:01.000000', 'consum', 0.0225, 'lps'),
	(450997, 124, '2015-03-15 00:43:02.000000', 'consum', 0.0211, 'lps'),
	(450998, 124, '2015-03-15 00:43:03.000000', 'consum', 0.0213, 'lps'),
	(450999, 124, '2015-03-15 00:43:04.000000', 'consum', 0.0221, 'lps'),
	(451000, 124, '2015-03-15 00:43:05.000000', 'consum', 0.0216, 'lps'),
	(451001, 124, '2015-03-15 00:43:06.000000', 'consum', 0.0229, 'lps'),
	(451002, 124, '2015-03-15 00:43:07.000000', 'consum', 0.0226, 'lps'),
	(451003, 124, '2015-03-15 00:43:08.000000', 'consum', 0.0210, 'lps'),
	(451004, 124, '2015-03-15 00:43:09.000000', 'consum', 0.0226, 'lps'),
	(451005, 124, '2015-03-15 00:43:10.000000', 'consum', 0.0229, 'lps'),
	(451006, 124, '2015-03-15 00:43:11.000000', 'consum', 0.0214, 'lps'),
	(451007, 124, '2015-03-15 00:43:12.000000', 'consum', 0.0215, 'lps'),
	(451008, 124, '2015-03-15 00:43:13.000000', 'consum', 0.0224, 'lps'),
	(451009, 124, '2015-03-15 00:43:14.000000', 'consum', 0.0224, 'lps'),
	(451010, 124, '2015-03-15 00:43:15.000000', 'consum', 0.0215, 'lps'),
	(451011, 124, '2015-03-15 00:43:16.000000', 'consum', 0.0217, 'lps'),
	(451012, 124, '2015-03-15 00:43:17.000000', 'consum', 0.0228, 'lps'),
	(451013, 124, '2015-03-15 00:43:18.000000', 'consum', 0.0219, 'lps'),
	(451014, 124, '2015-03-15 00:43:19.000000', 'consum', 0.0222, 'lps'),
	(451015, 124, '2015-03-15 00:43:20.000000', 'consum', 0.0222, 'lps'),
	(451016, 124, '2015-03-15 00:43:21.000000', 'consum', 0.0215, 'lps'),
	(451017, 124, '2015-03-15 00:43:22.000000', 'consum', 0.0221, 'lps'),
	(451018, 124, '2015-03-15 00:43:23.000000', 'consum', 0.0228, 'lps'),
	(451019, 124, '2015-03-15 00:43:24.000000', 'consum', 0.0226, 'lps'),
	(451020, 124, '2015-03-15 00:43:25.000000', 'consum', 0.0215, 'lps'),
	(451021, 124, '2015-03-15 00:43:26.000000', 'consum', 0.0230, 'lps'),
	(451022, 124, '2015-03-15 00:43:27.000000', 'consum', 0.0211, 'lps'),
	(451023, 124, '2015-03-15 00:43:28.000000', 'consum', 0.0217, 'lps'),
	(451024, 124, '2015-03-15 00:43:29.000000', 'consum', 0.0224, 'lps'),
	(451025, 124, '2015-03-15 00:43:30.000000', 'consum', 0.0217, 'lps'),
	(451026, 124, '2015-03-15 00:43:31.000000', 'consum', 0.0226, 'lps'),
	(451027, 124, '2015-03-15 00:43:32.000000', 'consum', 0.0227, 'lps'),
	(451028, 124, '2015-03-15 00:43:33.000000', 'consum', 0.0227, 'lps'),
	(451029, 124, '2015-03-15 00:43:34.000000', 'consum', 0.0225, 'lps'),
	(451030, 124, '2015-03-15 00:43:35.000000', 'consum', 0.0210, 'lps'),
	(451031, 124, '2015-03-15 00:43:36.000000', 'consum', 0.0211, 'lps'),
	(451032, 124, '2015-03-15 00:43:37.000000', 'consum', 0.0214, 'lps'),
	(451033, 124, '2015-03-15 00:43:38.000000', 'consum', 0.0226, 'lps'),
	(451034, 124, '2015-03-15 00:43:39.000000', 'consum', 0.0217, 'lps'),
	(451035, 124, '2015-03-15 00:43:40.000000', 'consum', 0.0219, 'lps'),
	(451036, 124, '2015-03-15 00:43:41.000000', 'consum', 0.0213, 'lps'),
	(451037, 124, '2015-03-15 00:43:42.000000', 'consum', 0.0221, 'lps'),
	(451038, 124, '2015-03-15 00:43:43.000000', 'consum', 0.0215, 'lps'),
	(451039, 124, '2015-03-15 00:43:44.000000', 'consum', 0.0222, 'lps'),
	(451040, 124, '2015-03-15 00:43:45.000000', 'consum', 0.0215, 'lps'),
	(451041, 124, '2015-03-15 00:43:46.000000', 'consum', 0.0220, 'lps'),
	(451042, 124, '2015-03-15 00:43:47.000000', 'consum', 0.0226, 'lps'),
	(451043, 124, '2015-03-15 00:43:48.000000', 'consum', 0.0217, 'lps'),
	(451044, 124, '2015-03-15 00:43:49.000000', 'consum', 0.0217, 'lps'),
	(451045, 124, '2015-03-15 00:43:50.000000', 'consum', 0.0224, 'lps'),
	(451046, 124, '2015-03-15 00:43:51.000000', 'consum', 0.0220, 'lps'),
	(451047, 124, '2015-03-15 00:43:52.000000', 'consum', 0.0220, 'lps'),
	(451048, 124, '2015-03-15 00:43:53.000000', 'consum', 0.0227, 'lps'),
	(451049, 124, '2015-03-15 00:43:54.000000', 'consum', 0.0226, 'lps'),
	(451050, 124, '2015-03-15 00:43:55.000000', 'consum', 0.0220, 'lps'),
	(451051, 124, '2015-03-15 00:43:56.000000', 'consum', 0.0230, 'lps'),
	(451052, 124, '2015-03-15 00:43:57.000000', 'consum', 0.0221, 'lps'),
	(451053, 124, '2015-03-15 00:43:58.000000', 'consum', 0.0223, 'lps'),
	(451054, 124, '2015-03-15 00:43:59.000000', 'consum', 0.0224, 'lps'),
	(451055, 124, '2015-03-15 00:44:00.000000', 'consum', 0.0219, 'lps'),
	(451056, 124, '2015-03-15 00:44:01.000000', 'consum', 0.0213, 'lps'),
	(451057, 124, '2015-03-15 00:44:02.000000', 'consum', 0.0221, 'lps'),
	(451058, 124, '2015-03-15 00:44:03.000000', 'consum', 0.0213, 'lps'),
	(451059, 124, '2015-03-15 00:44:04.000000', 'consum', 0.0212, 'lps'),
	(451060, 124, '2015-03-15 00:44:05.000000', 'consum', 0.0214, 'lps'),
	(451061, 124, '2015-03-15 00:44:06.000000', 'consum', 0.0222, 'lps'),
	(451062, 124, '2015-03-15 00:44:07.000000', 'consum', 0.0218, 'lps'),
	(451063, 124, '2015-03-15 00:44:08.000000', 'consum', 0.0215, 'lps'),
	(451064, 124, '2015-03-15 00:44:09.000000', 'consum', 0.0211, 'lps'),
	(451065, 124, '2015-03-15 00:44:10.000000', 'consum', 0.0222, 'lps'),
	(451066, 124, '2015-03-15 00:44:11.000000', 'consum', 0.0225, 'lps'),
	(451067, 124, '2015-03-15 00:44:12.000000', 'consum', 0.0227, 'lps'),
	(451068, 124, '2015-03-15 00:44:13.000000', 'consum', 0.0229, 'lps'),
	(451069, 124, '2015-03-15 00:44:14.000000', 'consum', 0.0213, 'lps'),
	(451070, 124, '2015-03-15 00:44:15.000000', 'consum', 0.0212, 'lps'),
	(451071, 124, '2015-03-15 00:44:16.000000', 'consum', 0.0210, 'lps'),
	(451072, 124, '2015-03-15 00:44:17.000000', 'consum', 0.0225, 'lps'),
	(451073, 124, '2015-03-15 00:44:18.000000', 'consum', 0.0221, 'lps'),
	(451074, 124, '2015-03-15 00:44:19.000000', 'consum', 0.0224, 'lps'),
	(451075, 124, '2015-03-15 00:44:20.000000', 'consum', 0.0225, 'lps'),
	(451076, 124, '2015-03-15 00:44:21.000000', 'consum', 0.0224, 'lps'),
	(451077, 124, '2015-03-15 00:44:22.000000', 'consum', 0.0213, 'lps'),
	(451078, 124, '2015-03-15 00:44:23.000000', 'consum', 0.0226, 'lps'),
	(451079, 124, '2015-03-15 00:44:24.000000', 'consum', 0.0219, 'lps'),
	(451080, 124, '2015-03-15 00:44:25.000000', 'consum', 0.0227, 'lps'),
	(451081, 124, '2015-03-15 00:44:26.000000', 'consum', 0.0228, 'lps'),
	(451082, 124, '2015-03-15 00:44:27.000000', 'consum', 0.0226, 'lps'),
	(451083, 124, '2015-03-15 00:44:28.000000', 'consum', 0.0216, 'lps'),
	(451084, 124, '2015-03-15 00:44:29.000000', 'consum', 0.0216, 'lps'),
	(451085, 124, '2015-03-15 00:44:30.000000', 'consum', 0.0221, 'lps'),
	(451086, 124, '2015-03-15 00:44:31.000000', 'consum', 0.0228, 'lps'),
	(451087, 124, '2015-03-15 00:44:32.000000', 'consum', 0.0224, 'lps'),
	(451088, 124, '2015-03-15 00:44:33.000000', 'consum', 0.0228, 'lps'),
	(451089, 124, '2015-03-15 00:44:34.000000', 'consum', 0.0216, 'lps'),
	(451090, 124, '2015-03-15 00:44:35.000000', 'consum', 0.0228, 'lps'),
	(451091, 124, '2015-03-15 00:44:36.000000', 'consum', 0.0221, 'lps'),
	(451092, 124, '2015-03-15 00:44:37.000000', 'consum', 0.0230, 'lps'),
	(451093, 124, '2015-03-15 00:44:38.000000', 'consum', 0.0214, 'lps'),
	(451094, 124, '2015-03-15 00:44:39.000000', 'consum', 0.0212, 'lps'),
	(451095, 124, '2015-03-15 00:44:40.000000', 'consum', 0.0230, 'lps'),
	(451096, 124, '2015-03-15 00:44:41.000000', 'consum', 0.0220, 'lps'),
	(451097, 124, '2015-03-15 00:44:42.000000', 'consum', 0.0221, 'lps'),
	(451098, 124, '2015-03-15 00:44:43.000000', 'consum', 0.0214, 'lps'),
	(451099, 124, '2015-03-15 00:44:44.000000', 'consum', 0.0220, 'lps'),
	(451100, 124, '2015-03-15 00:44:45.000000', 'consum', 0.0229, 'lps'),
	(451101, 124, '2015-03-15 00:44:46.000000', 'consum', 0.0230, 'lps'),
	(451102, 124, '2015-03-15 00:44:47.000000', 'consum', 0.0213, 'lps'),
	(451103, 124, '2015-03-15 00:44:48.000000', 'consum', 0.0230, 'lps'),
	(451104, 124, '2015-03-15 00:44:49.000000', 'consum', 0.0215, 'lps'),
	(451105, 124, '2015-03-15 00:44:50.000000', 'consum', 0.0220, 'lps'),
	(451106, 124, '2015-03-15 00:44:51.000000', 'consum', 0.0224, 'lps'),
	(451107, 124, '2015-03-15 00:44:52.000000', 'consum', 0.0228, 'lps'),
	(451108, 124, '2015-03-15 00:44:53.000000', 'consum', 0.0216, 'lps'),
	(451109, 124, '2015-03-15 00:44:54.000000', 'consum', 0.0230, 'lps'),
	(451110, 124, '2015-03-15 00:44:55.000000', 'consum', 0.0228, 'lps'),
	(451111, 124, '2015-03-15 00:44:56.000000', 'consum', 0.0219, 'lps'),
	(451112, 124, '2015-03-15 00:44:57.000000', 'consum', 0.0223, 'lps'),
	(451113, 124, '2015-03-15 00:44:58.000000', 'consum', 0.0226, 'lps'),
	(451114, 124, '2015-03-15 00:44:59.000000', 'consum', 0.0210, 'lps'),
	(451115, 124, '2015-03-15 00:45:00.000000', 'consum', 0.0227, 'lps'),
	(451116, 124, '2015-03-15 00:45:01.000000', 'consum', 0.0213, 'lps'),
	(451117, 124, '2015-03-15 00:45:02.000000', 'consum', 0.0213, 'lps'),
	(451118, 124, '2015-03-15 00:45:03.000000', 'consum', 0.0219, 'lps'),
	(451119, 124, '2015-03-15 00:45:04.000000', 'consum', 0.0226, 'lps'),
	(451120, 124, '2015-03-15 00:45:05.000000', 'consum', 0.0220, 'lps'),
	(451121, 124, '2015-03-15 00:45:06.000000', 'consum', 0.0214, 'lps'),
	(451122, 124, '2015-03-15 00:45:07.000000', 'consum', 0.0219, 'lps'),
	(451123, 124, '2015-03-15 00:45:08.000000', 'consum', 0.0225, 'lps'),
	(451124, 124, '2015-03-15 00:45:09.000000', 'consum', 0.0217, 'lps'),
	(451125, 124, '2015-03-15 00:45:10.000000', 'consum', 0.0222, 'lps'),
	(451126, 124, '2015-03-15 00:45:11.000000', 'consum', 0.0226, 'lps'),
	(451127, 124, '2015-03-15 00:45:12.000000', 'consum', 0.0211, 'lps'),
	(451128, 124, '2015-03-15 00:45:13.000000', 'consum', 0.0213, 'lps'),
	(451129, 124, '2015-03-15 00:45:14.000000', 'consum', 0.0222, 'lps'),
	(451130, 124, '2015-03-15 00:45:15.000000', 'consum', 0.0221, 'lps'),
	(451131, 124, '2015-03-15 00:45:16.000000', 'consum', 0.0228, 'lps'),
	(451132, 124, '2015-03-15 00:45:17.000000', 'consum', 0.0227, 'lps'),
	(451133, 124, '2015-03-15 00:45:18.000000', 'consum', 0.0220, 'lps'),
	(451134, 124, '2015-03-15 00:45:19.000000', 'consum', 0.0230, 'lps'),
	(451135, 124, '2015-03-15 00:45:20.000000', 'consum', 0.0216, 'lps'),
	(451136, 124, '2015-03-15 00:45:21.000000', 'consum', 0.0223, 'lps'),
	(451137, 124, '2015-03-15 00:45:22.000000', 'consum', 0.0215, 'lps'),
	(451138, 124, '2015-03-15 00:45:23.000000', 'consum', 0.0218, 'lps'),
	(451139, 124, '2015-03-15 00:45:24.000000', 'consum', 0.0214, 'lps'),
	(451140, 124, '2015-03-15 00:45:25.000000', 'consum', 0.0230, 'lps'),
	(451141, 124, '2015-03-15 00:45:26.000000', 'consum', 0.0211, 'lps'),
	(451142, 124, '2015-03-15 00:45:27.000000', 'consum', 0.0220, 'lps'),
	(451143, 124, '2015-03-15 00:45:28.000000', 'consum', 0.0214, 'lps'),
	(451144, 124, '2015-03-15 00:45:29.000000', 'consum', 0.0221, 'lps'),
	(451145, 124, '2015-03-15 00:45:30.000000', 'consum', 0.0215, 'lps'),
	(451146, 124, '2015-03-15 00:45:31.000000', 'consum', 0.0220, 'lps'),
	(451147, 124, '2015-03-15 00:45:32.000000', 'consum', 0.0225, 'lps'),
	(451148, 124, '2015-03-15 00:45:33.000000', 'consum', 0.0214, 'lps'),
	(451149, 124, '2015-03-15 00:45:34.000000', 'consum', 0.0228, 'lps'),
	(451150, 124, '2015-03-15 00:45:35.000000', 'consum', 0.0224, 'lps'),
	(451151, 124, '2015-03-15 00:45:36.000000', 'consum', 0.0226, 'lps'),
	(451152, 124, '2015-03-15 00:45:37.000000', 'consum', 0.0227, 'lps'),
	(451153, 124, '2015-03-15 00:45:38.000000', 'consum', 0.0226, 'lps'),
	(451154, 124, '2015-03-15 00:45:39.000000', 'consum', 0.0220, 'lps'),
	(451155, 124, '2015-03-15 00:45:40.000000', 'consum', 0.0212, 'lps'),
	(451156, 124, '2015-03-15 00:45:41.000000', 'consum', 0.0210, 'lps'),
	(451157, 124, '2015-03-15 00:45:42.000000', 'consum', 0.0225, 'lps'),
	(451158, 124, '2015-03-15 00:45:43.000000', 'consum', 0.0224, 'lps'),
	(451159, 124, '2015-03-15 00:45:44.000000', 'consum', 0.0214, 'lps'),
	(451160, 124, '2015-03-15 00:45:45.000000', 'consum', 0.0211, 'lps'),
	(451161, 124, '2015-03-15 00:45:46.000000', 'consum', 0.0226, 'lps'),
	(451162, 124, '2015-03-15 00:45:47.000000', 'consum', 0.0221, 'lps'),
	(451163, 124, '2015-03-15 00:45:48.000000', 'consum', 0.0218, 'lps'),
	(451164, 124, '2015-03-15 00:45:49.000000', 'consum', 0.0219, 'lps'),
	(451165, 124, '2015-03-15 00:45:50.000000', 'consum', 0.0230, 'lps'),
	(451166, 124, '2015-03-15 00:45:51.000000', 'consum', 0.0219, 'lps'),
	(451167, 124, '2015-03-15 00:45:52.000000', 'consum', 0.0219, 'lps'),
	(451168, 124, '2015-03-15 00:45:53.000000', 'consum', 0.0227, 'lps'),
	(451169, 124, '2015-03-15 00:45:54.000000', 'consum', 0.0229, 'lps'),
	(451170, 124, '2015-03-15 00:45:55.000000', 'consum', 0.0230, 'lps'),
	(451171, 124, '2015-03-15 00:45:56.000000', 'consum', 0.0215, 'lps'),
	(451172, 124, '2015-03-15 00:45:57.000000', 'consum', 0.0215, 'lps'),
	(451173, 124, '2015-03-15 00:45:58.000000', 'consum', 0.0220, 'lps'),
	(451174, 124, '2015-03-15 00:45:59.000000', 'consum', 0.0226, 'lps'),
	(451175, 124, '2015-03-15 00:46:00.000000', 'consum', 0.0218, 'lps'),
	(451176, 124, '2015-03-15 00:46:01.000000', 'consum', 0.0224, 'lps'),
	(451177, 124, '2015-03-15 00:46:02.000000', 'consum', 0.0214, 'lps'),
	(451178, 124, '2015-03-15 00:46:03.000000', 'consum', 0.0211, 'lps'),
	(451179, 124, '2015-03-15 00:46:04.000000', 'consum', 0.0225, 'lps'),
	(451180, 124, '2015-03-15 00:46:05.000000', 'consum', 0.0218, 'lps'),
	(451181, 124, '2015-03-15 00:46:06.000000', 'consum', 0.0227, 'lps'),
	(451182, 124, '2015-03-15 00:46:07.000000', 'consum', 0.0229, 'lps'),
	(451183, 124, '2015-03-15 00:46:08.000000', 'consum', 0.0213, 'lps'),
	(451184, 124, '2015-03-15 00:46:09.000000', 'consum', 0.0212, 'lps'),
	(451185, 124, '2015-03-15 00:46:10.000000', 'consum', 0.0210, 'lps'),
	(451186, 124, '2015-03-15 00:46:11.000000', 'consum', 0.0227, 'lps'),
	(451187, 124, '2015-03-15 00:46:12.000000', 'consum', 0.0211, 'lps'),
	(451188, 124, '2015-03-15 00:46:13.000000', 'consum', 0.0225, 'lps'),
	(451189, 124, '2015-03-15 00:46:14.000000', 'consum', 0.0222, 'lps'),
	(451190, 124, '2015-03-15 00:46:15.000000', 'consum', 0.0223, 'lps'),
	(451191, 124, '2015-03-15 00:46:16.000000', 'consum', 0.0221, 'lps'),
	(451192, 124, '2015-03-15 00:46:17.000000', 'consum', 0.0227, 'lps'),
	(451193, 124, '2015-03-15 00:46:18.000000', 'consum', 0.0218, 'lps'),
	(451194, 124, '2015-03-15 00:46:19.000000', 'consum', 0.0223, 'lps'),
	(451195, 124, '2015-03-15 00:46:20.000000', 'consum', 0.0228, 'lps'),
	(451196, 124, '2015-03-15 00:46:21.000000', 'consum', 0.0220, 'lps'),
	(451197, 124, '2015-03-15 00:46:22.000000', 'consum', 0.0228, 'lps'),
	(451198, 124, '2015-03-15 00:46:23.000000', 'consum', 0.0227, 'lps'),
	(451199, 124, '2015-03-15 00:46:24.000000', 'consum', 0.0221, 'lps'),
	(451200, 124, '2015-03-15 00:46:25.000000', 'consum', 0.0215, 'lps'),
	(451201, 124, '2015-03-15 00:46:26.000000', 'consum', 0.0222, 'lps'),
	(451202, 124, '2015-03-15 00:46:27.000000', 'consum', 0.0217, 'lps'),
	(451203, 124, '2015-03-15 00:46:28.000000', 'consum', 0.0227, 'lps'),
	(451204, 124, '2015-03-15 00:46:29.000000', 'consum', 0.0212, 'lps'),
	(451205, 124, '2015-03-15 00:46:30.000000', 'consum', 0.0211, 'lps'),
	(451206, 124, '2015-03-15 00:46:31.000000', 'consum', 0.0211, 'lps'),
	(451207, 124, '2015-03-15 00:46:32.000000', 'consum', 0.0212, 'lps'),
	(451208, 124, '2015-03-15 00:46:33.000000', 'consum', 0.0218, 'lps'),
	(451209, 124, '2015-03-15 00:46:34.000000', 'consum', 0.0225, 'lps'),
	(451210, 124, '2015-03-15 00:46:35.000000', 'consum', 0.0218, 'lps'),
	(451211, 124, '2015-03-15 00:46:36.000000', 'consum', 0.0225, 'lps'),
	(451212, 124, '2015-03-15 00:46:37.000000', 'consum', 0.0221, 'lps'),
	(451213, 124, '2015-03-15 00:46:38.000000', 'consum', 0.0220, 'lps'),
	(451214, 124, '2015-03-15 00:46:39.000000', 'consum', 0.0228, 'lps'),
	(451215, 124, '2015-03-15 00:46:40.000000', 'consum', 0.0228, 'lps'),
	(451216, 124, '2015-03-15 00:46:41.000000', 'consum', 0.0225, 'lps'),
	(451217, 124, '2015-03-15 00:46:42.000000', 'consum', 0.0213, 'lps'),
	(451218, 124, '2015-03-15 00:46:43.000000', 'consum', 0.0219, 'lps'),
	(451219, 124, '2015-03-15 00:46:44.000000', 'consum', 0.0229, 'lps'),
	(451220, 124, '2015-03-15 00:46:45.000000', 'consum', 0.0214, 'lps'),
	(451221, 124, '2015-03-15 00:46:46.000000', 'consum', 0.0216, 'lps'),
	(451222, 124, '2015-03-15 00:46:47.000000', 'consum', 0.0228, 'lps'),
	(451223, 124, '2015-03-15 00:46:48.000000', 'consum', 0.0219, 'lps'),
	(451224, 124, '2015-03-15 00:46:49.000000', 'consum', 0.0221, 'lps'),
	(451225, 124, '2015-03-15 00:46:50.000000', 'consum', 0.0220, 'lps'),
	(451226, 124, '2015-03-15 00:46:51.000000', 'consum', 0.0228, 'lps'),
	(451227, 124, '2015-03-15 00:46:52.000000', 'consum', 0.0226, 'lps'),
	(451228, 124, '2015-03-15 00:46:53.000000', 'consum', 0.0219, 'lps'),
	(451229, 124, '2015-03-15 00:46:54.000000', 'consum', 0.0225, 'lps'),
	(451230, 124, '2015-03-15 00:46:55.000000', 'consum', 0.0219, 'lps'),
	(451231, 124, '2015-03-15 00:46:56.000000', 'consum', 0.0230, 'lps'),
	(451232, 124, '2015-03-15 00:46:57.000000', 'consum', 0.0221, 'lps'),
	(451233, 124, '2015-03-15 00:46:58.000000', 'consum', 0.0225, 'lps'),
	(451234, 124, '2015-03-15 00:46:59.000000', 'consum', 0.0213, 'lps'),
	(451235, 124, '2015-03-15 00:47:00.000000', 'consum', 0.0221, 'lps'),
	(451236, 124, '2015-03-15 00:47:01.000000', 'consum', 0.0215, 'lps'),
	(451237, 124, '2015-03-15 00:47:02.000000', 'consum', 0.0225, 'lps'),
	(451238, 124, '2015-03-15 00:47:03.000000', 'consum', 0.0228, 'lps'),
	(451239, 124, '2015-03-15 00:47:04.000000', 'consum', 0.0215, 'lps'),
	(451240, 124, '2015-03-15 00:47:05.000000', 'consum', 0.0222, 'lps'),
	(451241, 124, '2015-03-15 00:47:06.000000', 'consum', 0.0212, 'lps'),
	(451242, 124, '2015-03-15 00:47:07.000000', 'consum', 0.0229, 'lps'),
	(451243, 124, '2015-03-15 00:47:08.000000', 'consum', 0.0216, 'lps'),
	(451244, 124, '2015-03-15 00:47:09.000000', 'consum', 0.0226, 'lps'),
	(451245, 124, '2015-03-15 00:47:10.000000', 'consum', 0.0228, 'lps'),
	(451246, 124, '2015-03-15 00:47:11.000000', 'consum', 0.0212, 'lps'),
	(451247, 124, '2015-03-15 00:47:12.000000', 'consum', 0.0210, 'lps'),
	(451248, 124, '2015-03-15 00:47:13.000000', 'consum', 0.0223, 'lps'),
	(451249, 124, '2015-03-15 00:47:14.000000', 'consum', 0.0211, 'lps'),
	(451250, 124, '2015-03-15 00:47:15.000000', 'consum', 0.0221, 'lps'),
	(451251, 124, '2015-03-15 00:47:16.000000', 'consum', 0.0221, 'lps'),
	(451252, 124, '2015-03-15 00:47:17.000000', 'consum', 0.0211, 'lps'),
	(451253, 124, '2015-03-15 00:47:18.000000', 'consum', 0.0224, 'lps'),
	(451254, 124, '2015-03-15 00:47:19.000000', 'consum', 0.0213, 'lps'),
	(451255, 124, '2015-03-15 00:47:20.000000', 'consum', 0.0227, 'lps'),
	(451256, 124, '2015-03-15 00:47:21.000000', 'consum', 0.0225, 'lps'),
	(451257, 124, '2015-03-15 00:47:22.000000', 'consum', 0.0213, 'lps'),
	(451258, 124, '2015-03-15 00:47:23.000000', 'consum', 0.0223, 'lps'),
	(451259, 124, '2015-03-15 00:47:24.000000', 'consum', 0.0226, 'lps'),
	(451260, 124, '2015-03-15 00:47:25.000000', 'consum', 0.0227, 'lps'),
	(451261, 124, '2015-03-15 00:47:26.000000', 'consum', 0.0229, 'lps'),
	(451262, 124, '2015-03-15 00:47:27.000000', 'consum', 0.0210, 'lps'),
	(451263, 124, '2015-03-15 00:47:28.000000', 'consum', 0.0217, 'lps'),
	(451264, 124, '2015-03-15 00:47:29.000000', 'consum', 0.0226, 'lps'),
	(451265, 124, '2015-03-15 00:47:30.000000', 'consum', 0.0229, 'lps'),
	(451266, 124, '2015-03-15 00:47:31.000000', 'consum', 0.0213, 'lps'),
	(451267, 124, '2015-03-15 00:47:32.000000', 'consum', 0.0213, 'lps'),
	(451268, 124, '2015-03-15 00:47:33.000000', 'consum', 0.0215, 'lps'),
	(451269, 124, '2015-03-15 00:47:34.000000', 'consum', 0.0228, 'lps'),
	(451270, 124, '2015-03-15 00:47:35.000000', 'consum', 0.0222, 'lps'),
	(451271, 124, '2015-03-15 00:47:36.000000', 'consum', 0.0218, 'lps'),
	(451272, 124, '2015-03-15 00:47:37.000000', 'consum', 0.0211, 'lps'),
	(451273, 124, '2015-03-15 00:47:38.000000', 'consum', 0.0216, 'lps'),
	(451274, 124, '2015-03-15 00:47:39.000000', 'consum', 0.0214, 'lps'),
	(451275, 124, '2015-03-15 00:47:40.000000', 'consum', 0.0212, 'lps'),
	(451276, 124, '2015-03-15 00:47:41.000000', 'consum', 0.0211, 'lps'),
	(451277, 124, '2015-03-15 00:47:42.000000', 'consum', 0.0230, 'lps'),
	(451278, 124, '2015-03-15 00:47:43.000000', 'consum', 0.0225, 'lps'),
	(451279, 124, '2015-03-15 00:47:44.000000', 'consum', 0.0224, 'lps'),
	(451280, 124, '2015-03-15 00:47:45.000000', 'consum', 0.0217, 'lps'),
	(451281, 124, '2015-03-15 00:47:46.000000', 'consum', 0.0222, 'lps'),
	(451282, 124, '2015-03-15 00:47:47.000000', 'consum', 0.0228, 'lps'),
	(451283, 124, '2015-03-15 00:47:48.000000', 'consum', 0.0223, 'lps'),
	(451284, 124, '2015-03-15 00:47:49.000000', 'consum', 0.0220, 'lps'),
	(451285, 124, '2015-03-15 00:47:50.000000', 'consum', 0.0222, 'lps'),
	(451286, 124, '2015-03-15 00:47:51.000000', 'consum', 0.0218, 'lps'),
	(451287, 124, '2015-03-15 00:47:52.000000', 'consum', 0.0218, 'lps'),
	(451288, 124, '2015-03-15 00:47:53.000000', 'consum', 0.0224, 'lps'),
	(451289, 124, '2015-03-15 00:47:54.000000', 'consum', 0.0216, 'lps'),
	(451290, 124, '2015-03-15 00:47:55.000000', 'consum', 0.0218, 'lps'),
	(451291, 124, '2015-03-15 00:47:56.000000', 'consum', 0.0214, 'lps'),
	(451292, 124, '2015-03-15 00:47:57.000000', 'consum', 0.0226, 'lps'),
	(451293, 124, '2015-03-15 00:47:58.000000', 'consum', 0.0215, 'lps'),
	(451294, 124, '2015-03-15 00:47:59.000000', 'consum', 0.0230, 'lps'),
	(451295, 124, '2015-03-15 00:48:00.000000', 'consum', 0.0211, 'lps'),
	(451296, 124, '2015-03-15 00:48:01.000000', 'consum', 0.0219, 'lps'),
	(451297, 124, '2015-03-15 00:48:02.000000', 'consum', 0.0230, 'lps'),
	(451298, 124, '2015-03-15 00:48:03.000000', 'consum', 0.0222, 'lps'),
	(451299, 124, '2015-03-15 00:48:04.000000', 'consum', 0.0230, 'lps'),
	(451300, 124, '2015-03-15 00:48:05.000000', 'consum', 0.0212, 'lps'),
	(451301, 124, '2015-03-15 00:48:06.000000', 'consum', 0.0225, 'lps'),
	(451302, 124, '2015-03-15 00:48:07.000000', 'consum', 0.0215, 'lps'),
	(451303, 124, '2015-03-15 00:48:08.000000', 'consum', 0.0213, 'lps'),
	(451304, 124, '2015-03-15 00:48:09.000000', 'consum', 0.0210, 'lps'),
	(451305, 124, '2015-03-15 00:48:10.000000', 'consum', 0.0221, 'lps'),
	(451306, 124, '2015-03-15 00:48:11.000000', 'consum', 0.0224, 'lps'),
	(451307, 124, '2015-03-15 00:48:12.000000', 'consum', 0.0228, 'lps'),
	(451308, 124, '2015-03-15 00:48:13.000000', 'consum', 0.0217, 'lps'),
	(451309, 124, '2015-03-15 00:48:14.000000', 'consum', 0.0212, 'lps'),
	(451310, 124, '2015-03-15 00:48:15.000000', 'consum', 0.0220, 'lps'),
	(451311, 124, '2015-03-15 00:48:16.000000', 'consum', 0.0213, 'lps'),
	(451312, 124, '2015-03-15 00:48:17.000000', 'consum', 0.0218, 'lps'),
	(451313, 124, '2015-03-15 00:48:18.000000', 'consum', 0.0220, 'lps'),
	(451314, 124, '2015-03-15 00:48:19.000000', 'consum', 0.0215, 'lps'),
	(451315, 124, '2015-03-15 00:48:20.000000', 'consum', 0.0225, 'lps'),
	(451316, 124, '2015-03-15 00:48:21.000000', 'consum', 0.0229, 'lps'),
	(451317, 124, '2015-03-15 00:48:22.000000', 'consum', 0.0218, 'lps'),
	(451318, 124, '2015-03-15 00:48:23.000000', 'consum', 0.0214, 'lps'),
	(451319, 124, '2015-03-15 00:48:24.000000', 'consum', 0.0229, 'lps'),
	(451320, 124, '2015-03-15 00:48:25.000000', 'consum', 0.0230, 'lps'),
	(451321, 124, '2015-03-15 00:48:26.000000', 'consum', 0.0210, 'lps'),
	(451322, 124, '2015-03-15 00:48:27.000000', 'consum', 0.0216, 'lps'),
	(451323, 124, '2015-03-15 00:48:28.000000', 'consum', 0.0217, 'lps'),
	(451324, 124, '2015-03-15 00:48:29.000000', 'consum', 0.0229, 'lps'),
	(451325, 124, '2015-03-15 00:48:30.000000', 'consum', 0.0223, 'lps'),
	(451326, 124, '2015-03-15 00:48:31.000000', 'consum', 0.0217, 'lps'),
	(451327, 124, '2015-03-15 00:48:32.000000', 'consum', 0.0230, 'lps'),
	(451328, 124, '2015-03-15 00:48:33.000000', 'consum', 0.0223, 'lps'),
	(451329, 124, '2015-03-15 00:48:34.000000', 'consum', 0.0217, 'lps'),
	(451330, 124, '2015-03-15 00:48:35.000000', 'consum', 0.0226, 'lps'),
	(451331, 124, '2015-03-15 00:48:36.000000', 'consum', 0.0227, 'lps'),
	(451332, 124, '2015-03-15 00:48:37.000000', 'consum', 0.0227, 'lps'),
	(451333, 124, '2015-03-15 00:48:38.000000', 'consum', 0.0222, 'lps'),
	(451334, 124, '2015-03-15 00:48:39.000000', 'consum', 0.0221, 'lps'),
	(451335, 124, '2015-03-15 00:48:40.000000', 'consum', 0.0227, 'lps'),
	(451336, 124, '2015-03-15 00:48:41.000000', 'consum', 0.0224, 'lps'),
	(451337, 124, '2015-03-15 00:48:42.000000', 'consum', 0.0228, 'lps'),
	(451338, 124, '2015-03-15 00:48:43.000000', 'consum', 0.0218, 'lps'),
	(451339, 124, '2015-03-15 00:48:44.000000', 'consum', 0.0214, 'lps'),
	(451340, 124, '2015-03-15 00:48:45.000000', 'consum', 0.0210, 'lps'),
	(451341, 124, '2015-03-15 00:48:46.000000', 'consum', 0.0219, 'lps'),
	(451342, 124, '2015-03-15 00:48:47.000000', 'consum', 0.0212, 'lps'),
	(451343, 124, '2015-03-15 00:48:48.000000', 'consum', 0.0216, 'lps'),
	(451344, 124, '2015-03-15 00:48:49.000000', 'consum', 0.0212, 'lps'),
	(451345, 124, '2015-03-15 00:48:50.000000', 'consum', 0.0223, 'lps'),
	(451346, 124, '2015-03-15 00:48:51.000000', 'consum', 0.0229, 'lps'),
	(451347, 124, '2015-03-15 00:48:52.000000', 'consum', 0.0223, 'lps'),
	(451348, 124, '2015-03-15 00:48:53.000000', 'consum', 0.0221, 'lps'),
	(451349, 124, '2015-03-15 00:48:54.000000', 'consum', 0.0226, 'lps'),
	(451350, 124, '2015-03-15 00:48:55.000000', 'consum', 0.0213, 'lps'),
	(451351, 124, '2015-03-15 00:48:56.000000', 'consum', 0.0221, 'lps'),
	(451352, 124, '2015-03-15 00:48:57.000000', 'consum', 0.0217, 'lps'),
	(451353, 124, '2015-03-15 00:48:58.000000', 'consum', 0.0230, 'lps'),
	(451354, 124, '2015-03-15 00:48:59.000000', 'consum', 0.0226, 'lps'),
	(451355, 124, '2015-03-15 00:49:00.000000', 'consum', 0.0210, 'lps'),
	(451356, 124, '2015-03-15 00:49:01.000000', 'consum', 0.0226, 'lps'),
	(451357, 124, '2015-03-15 00:49:02.000000', 'consum', 0.0229, 'lps'),
	(451358, 124, '2015-03-15 00:49:03.000000', 'consum', 0.0216, 'lps'),
	(451359, 124, '2015-03-15 00:49:04.000000', 'consum', 0.0224, 'lps'),
	(451360, 124, '2015-03-15 00:49:05.000000', 'consum', 0.0221, 'lps'),
	(451361, 124, '2015-03-15 00:49:06.000000', 'consum', 0.0225, 'lps'),
	(451362, 124, '2015-03-15 00:49:07.000000', 'consum', 0.0211, 'lps'),
	(451363, 124, '2015-03-15 00:49:08.000000', 'consum', 0.0211, 'lps'),
	(451364, 124, '2015-03-15 00:49:09.000000', 'consum', 0.0214, 'lps'),
	(451365, 124, '2015-03-15 00:49:10.000000', 'consum', 0.0229, 'lps'),
	(451366, 124, '2015-03-15 00:49:11.000000', 'consum', 0.0227, 'lps'),
	(451367, 124, '2015-03-15 00:49:12.000000', 'consum', 0.0217, 'lps'),
	(451368, 124, '2015-03-15 00:49:13.000000', 'consum', 0.0219, 'lps'),
	(451369, 124, '2015-03-15 00:49:14.000000', 'consum', 0.0211, 'lps'),
	(451370, 124, '2015-03-15 00:49:15.000000', 'consum', 0.0212, 'lps'),
	(451371, 124, '2015-03-15 00:49:16.000000', 'consum', 0.0214, 'lps'),
	(451372, 124, '2015-03-15 00:49:17.000000', 'consum', 0.0227, 'lps'),
	(451373, 124, '2015-03-15 00:49:18.000000', 'consum', 0.0221, 'lps'),
	(451374, 124, '2015-03-15 00:49:19.000000', 'consum', 0.0213, 'lps'),
	(451375, 124, '2015-03-15 00:49:20.000000', 'consum', 0.0213, 'lps'),
	(451376, 124, '2015-03-15 00:49:21.000000', 'consum', 0.0219, 'lps'),
	(451377, 124, '2015-03-15 00:49:22.000000', 'consum', 0.0224, 'lps'),
	(451378, 124, '2015-03-15 00:49:23.000000', 'consum', 0.0213, 'lps'),
	(451379, 124, '2015-03-15 00:49:24.000000', 'consum', 0.0224, 'lps'),
	(451380, 124, '2015-03-15 00:49:25.000000', 'consum', 0.0211, 'lps'),
	(451381, 124, '2015-03-15 00:49:26.000000', 'consum', 0.0213, 'lps'),
	(451382, 124, '2015-03-15 00:49:27.000000', 'consum', 0.0223, 'lps'),
	(451383, 124, '2015-03-15 00:49:28.000000', 'consum', 0.0223, 'lps'),
	(451384, 124, '2015-03-15 00:49:29.000000', 'consum', 0.0217, 'lps'),
	(451385, 124, '2015-03-15 00:49:30.000000', 'consum', 0.0229, 'lps'),
	(451386, 124, '2015-03-15 00:49:31.000000', 'consum', 0.0219, 'lps'),
	(451387, 124, '2015-03-15 00:49:32.000000', 'consum', 0.0222, 'lps'),
	(451388, 124, '2015-03-15 00:49:33.000000', 'consum', 0.0221, 'lps'),
	(451389, 124, '2015-03-15 00:49:34.000000', 'consum', 0.0229, 'lps'),
	(451390, 124, '2015-03-15 00:49:35.000000', 'consum', 0.0211, 'lps'),
	(451391, 124, '2015-03-15 00:49:36.000000', 'consum', 0.0220, 'lps'),
	(451392, 124, '2015-03-15 00:49:37.000000', 'consum', 0.0215, 'lps'),
	(451393, 124, '2015-03-15 00:49:38.000000', 'consum', 0.0227, 'lps'),
	(451394, 124, '2015-03-15 00:49:39.000000', 'consum', 0.0219, 'lps'),
	(451395, 124, '2015-03-15 00:49:40.000000', 'consum', 0.0226, 'lps'),
	(451396, 124, '2015-03-15 00:49:41.000000', 'consum', 0.0218, 'lps'),
	(451397, 124, '2015-03-15 00:49:42.000000', 'consum', 0.0227, 'lps'),
	(451398, 124, '2015-03-15 00:49:43.000000', 'consum', 0.0229, 'lps'),
	(451399, 124, '2015-03-15 00:49:44.000000', 'consum', 0.0211, 'lps'),
	(451400, 124, '2015-03-15 00:49:45.000000', 'consum', 0.0220, 'lps'),
	(451401, 124, '2015-03-15 00:49:46.000000', 'consum', 0.0219, 'lps'),
	(451402, 124, '2015-03-15 00:49:47.000000', 'consum', 0.0223, 'lps'),
	(451403, 124, '2015-03-15 00:49:48.000000', 'consum', 0.0230, 'lps'),
	(451404, 124, '2015-03-15 00:49:49.000000', 'consum', 0.0230, 'lps'),
	(451405, 124, '2015-03-15 00:49:50.000000', 'consum', 0.0227, 'lps'),
	(451406, 124, '2015-03-15 00:49:51.000000', 'consum', 0.0216, 'lps'),
	(451407, 124, '2015-03-15 00:49:52.000000', 'consum', 0.0230, 'lps'),
	(451408, 124, '2015-03-15 00:49:53.000000', 'consum', 0.0210, 'lps'),
	(451409, 124, '2015-03-15 00:49:54.000000', 'consum', 0.0213, 'lps'),
	(451410, 124, '2015-03-15 00:49:55.000000', 'consum', 0.0225, 'lps'),
	(451411, 124, '2015-03-15 00:49:56.000000', 'consum', 0.0216, 'lps'),
	(451412, 124, '2015-03-15 00:49:57.000000', 'consum', 0.0215, 'lps'),
	(451413, 124, '2015-03-15 00:49:58.000000', 'consum', 0.0217, 'lps'),
	(451414, 124, '2015-03-15 00:49:59.000000', 'consum', 0.0210, 'lps'),
	(451415, 124, '2015-03-15 00:50:00.000000', 'consum', 0.0229, 'lps'),
	(451416, 124, '2015-03-15 00:50:01.000000', 'consum', 0.0225, 'lps'),
	(451417, 124, '2015-03-15 00:50:02.000000', 'consum', 0.0227, 'lps'),
	(451418, 124, '2015-03-15 00:50:03.000000', 'consum', 0.0210, 'lps'),
	(451419, 124, '2015-03-15 00:50:04.000000', 'consum', 0.0223, 'lps'),
	(451420, 124, '2015-03-15 00:50:05.000000', 'consum', 0.0211, 'lps'),
	(451421, 124, '2015-03-15 00:50:06.000000', 'consum', 0.0220, 'lps'),
	(451422, 124, '2015-03-15 00:50:07.000000', 'consum', 0.0217, 'lps'),
	(451423, 124, '2015-03-15 00:50:08.000000', 'consum', 0.0212, 'lps'),
	(451424, 124, '2015-03-15 00:50:09.000000', 'consum', 0.0222, 'lps'),
	(451425, 124, '2015-03-15 00:50:10.000000', 'consum', 0.0224, 'lps'),
	(451426, 124, '2015-03-15 00:50:11.000000', 'consum', 0.0221, 'lps'),
	(451427, 124, '2015-03-15 00:50:12.000000', 'consum', 0.0225, 'lps'),
	(451428, 124, '2015-03-15 00:50:13.000000', 'consum', 0.0229, 'lps'),
	(451429, 124, '2015-03-15 00:50:14.000000', 'consum', 0.0221, 'lps'),
	(451430, 124, '2015-03-15 00:50:15.000000', 'consum', 0.0230, 'lps'),
	(451431, 124, '2015-03-15 00:50:16.000000', 'consum', 0.0214, 'lps'),
	(451432, 124, '2015-03-15 00:50:17.000000', 'consum', 0.0212, 'lps'),
	(451433, 124, '2015-03-15 00:50:18.000000', 'consum', 0.0228, 'lps'),
	(451434, 124, '2015-03-15 00:50:19.000000', 'consum', 0.0211, 'lps'),
	(451435, 124, '2015-03-15 00:50:20.000000', 'consum', 0.0224, 'lps'),
	(451436, 124, '2015-03-15 00:50:21.000000', 'consum', 0.0215, 'lps'),
	(451437, 124, '2015-03-15 00:50:22.000000', 'consum', 0.0215, 'lps'),
	(451438, 124, '2015-03-15 00:50:23.000000', 'consum', 0.0218, 'lps'),
	(451439, 124, '2015-03-15 00:50:24.000000', 'consum', 0.0217, 'lps'),
	(451440, 124, '2015-03-15 00:50:25.000000', 'consum', 0.0221, 'lps'),
	(451441, 124, '2015-03-15 00:50:26.000000', 'consum', 0.0225, 'lps'),
	(451442, 124, '2015-03-15 00:50:27.000000', 'consum', 0.0211, 'lps'),
	(451443, 124, '2015-03-15 00:50:28.000000', 'consum', 0.0230, 'lps'),
	(451444, 124, '2015-03-15 00:50:29.000000', 'consum', 0.0227, 'lps'),
	(451445, 124, '2015-03-15 00:50:30.000000', 'consum', 0.0214, 'lps'),
	(451446, 124, '2015-03-15 00:50:31.000000', 'consum', 0.0223, 'lps'),
	(451447, 124, '2015-03-15 00:50:32.000000', 'consum', 0.0220, 'lps'),
	(451448, 124, '2015-03-15 00:50:33.000000', 'consum', 0.0223, 'lps'),
	(451449, 124, '2015-03-15 00:50:34.000000', 'consum', 0.0223, 'lps'),
	(451450, 124, '2015-03-15 00:50:35.000000', 'consum', 0.0218, 'lps'),
	(451451, 124, '2015-03-15 00:50:36.000000', 'consum', 0.0229, 'lps'),
	(451452, 124, '2015-03-15 00:50:37.000000', 'consum', 0.0219, 'lps'),
	(451453, 124, '2015-03-15 00:50:38.000000', 'consum', 0.0222, 'lps'),
	(451454, 124, '2015-03-15 00:50:39.000000', 'consum', 0.0221, 'lps'),
	(451455, 124, '2015-03-15 00:50:40.000000', 'consum', 0.0228, 'lps'),
	(451456, 124, '2015-03-15 00:50:41.000000', 'consum', 0.0228, 'lps'),
	(451457, 124, '2015-03-15 00:50:42.000000', 'consum', 0.0224, 'lps'),
	(451458, 124, '2015-03-15 00:50:43.000000', 'consum', 0.0229, 'lps'),
	(451459, 124, '2015-03-15 00:50:44.000000', 'consum', 0.0219, 'lps'),
	(451460, 124, '2015-03-15 00:50:45.000000', 'consum', 0.0218, 'lps'),
	(451461, 124, '2015-03-15 00:50:46.000000', 'consum', 0.0226, 'lps'),
	(451462, 124, '2015-03-15 00:50:47.000000', 'consum', 0.0225, 'lps'),
	(451463, 124, '2015-03-15 00:50:48.000000', 'consum', 0.0217, 'lps'),
	(451464, 124, '2015-03-15 00:50:49.000000', 'consum', 0.0220, 'lps'),
	(451465, 124, '2015-03-15 00:50:50.000000', 'consum', 0.0220, 'lps'),
	(451466, 124, '2015-03-15 00:50:51.000000', 'consum', 0.0230, 'lps'),
	(451467, 124, '2015-03-15 00:50:52.000000', 'consum', 0.0219, 'lps'),
	(451468, 124, '2015-03-15 00:50:53.000000', 'consum', 0.0214, 'lps'),
	(451469, 124, '2015-03-15 00:50:54.000000', 'consum', 0.0225, 'lps'),
	(451470, 124, '2015-03-15 00:50:55.000000', 'consum', 0.0210, 'lps'),
	(451471, 124, '2015-03-15 00:50:56.000000', 'consum', 0.0227, 'lps'),
	(451472, 124, '2015-03-15 00:50:57.000000', 'consum', 0.0213, 'lps'),
	(451473, 124, '2015-03-15 00:50:58.000000', 'consum', 0.0215, 'lps'),
	(451474, 124, '2015-03-15 00:50:59.000000', 'consum', 0.0228, 'lps'),
	(451475, 124, '2015-03-15 00:51:00.000000', 'consum', 0.0221, 'lps'),
	(451476, 124, '2015-03-15 00:51:01.000000', 'consum', 0.0212, 'lps'),
	(451477, 124, '2015-03-15 00:51:02.000000', 'consum', 0.0228, 'lps'),
	(451478, 124, '2015-03-15 00:51:03.000000', 'consum', 0.0210, 'lps'),
	(451479, 124, '2015-03-15 00:51:04.000000', 'consum', 0.0221, 'lps'),
	(451480, 124, '2015-03-15 00:51:05.000000', 'consum', 0.0224, 'lps'),
	(451481, 124, '2015-03-15 00:51:06.000000', 'consum', 0.0224, 'lps'),
	(451482, 124, '2015-03-15 00:51:07.000000', 'consum', 0.0220, 'lps'),
	(451483, 124, '2015-03-15 00:51:08.000000', 'consum', 0.0218, 'lps'),
	(451484, 124, '2015-03-15 00:51:09.000000', 'consum', 0.0221, 'lps'),
	(451485, 124, '2015-03-15 00:51:10.000000', 'consum', 0.0219, 'lps'),
	(451486, 124, '2015-03-15 00:51:11.000000', 'consum', 0.0224, 'lps'),
	(451487, 124, '2015-03-15 00:51:12.000000', 'consum', 0.0210, 'lps'),
	(451488, 124, '2015-03-15 00:51:13.000000', 'consum', 0.0211, 'lps'),
	(451489, 124, '2015-03-15 00:51:14.000000', 'consum', 0.0216, 'lps'),
	(451490, 124, '2015-03-15 00:51:15.000000', 'consum', 0.0218, 'lps'),
	(451491, 124, '2015-03-15 00:51:16.000000', 'consum', 0.0211, 'lps'),
	(451492, 124, '2015-03-15 00:51:17.000000', 'consum', 0.0212, 'lps'),
	(451493, 124, '2015-03-15 00:51:18.000000', 'consum', 0.0218, 'lps'),
	(451494, 124, '2015-03-15 00:51:19.000000', 'consum', 0.0223, 'lps'),
	(451495, 124, '2015-03-15 00:51:20.000000', 'consum', 0.0230, 'lps'),
	(451496, 124, '2015-03-15 00:51:21.000000', 'consum', 0.0210, 'lps'),
	(451497, 124, '2015-03-15 00:51:22.000000', 'consum', 0.0211, 'lps'),
	(451498, 124, '2015-03-15 00:51:23.000000', 'consum', 0.0215, 'lps'),
	(451499, 124, '2015-03-15 00:51:24.000000', 'consum', 0.0214, 'lps'),
	(451500, 124, '2015-03-15 00:51:25.000000', 'consum', 0.0213, 'lps'),
	(451501, 124, '2015-03-15 00:51:26.000000', 'consum', 0.0214, 'lps'),
	(451502, 124, '2015-03-15 00:51:27.000000', 'consum', 0.0221, 'lps'),
	(451503, 124, '2015-03-15 00:51:28.000000', 'consum', 0.0211, 'lps'),
	(451504, 124, '2015-03-15 00:51:29.000000', 'consum', 0.0226, 'lps'),
	(451505, 124, '2015-03-15 00:51:30.000000', 'consum', 0.0226, 'lps'),
	(451506, 124, '2015-03-15 00:51:31.000000', 'consum', 0.0219, 'lps'),
	(451507, 124, '2015-03-15 00:51:32.000000', 'consum', 0.0228, 'lps'),
	(451508, 124, '2015-03-15 00:51:33.000000', 'consum', 0.0213, 'lps'),
	(451509, 124, '2015-03-15 00:51:34.000000', 'consum', 0.0211, 'lps'),
	(451510, 124, '2015-03-15 00:51:35.000000', 'consum', 0.0227, 'lps'),
	(451511, 124, '2015-03-15 00:51:36.000000', 'consum', 0.0212, 'lps'),
	(451512, 124, '2015-03-15 00:51:37.000000', 'consum', 0.0229, 'lps'),
	(451513, 124, '2015-03-15 00:51:38.000000', 'consum', 0.0216, 'lps'),
	(451514, 124, '2015-03-15 00:51:39.000000', 'consum', 0.0228, 'lps'),
	(451515, 124, '2015-03-15 00:51:40.000000', 'consum', 0.0217, 'lps'),
	(451516, 124, '2015-03-15 00:51:41.000000', 'consum', 0.0213, 'lps'),
	(451517, 124, '2015-03-15 00:51:42.000000', 'consum', 0.0227, 'lps'),
	(451518, 124, '2015-03-15 00:51:43.000000', 'consum', 0.0221, 'lps'),
	(451519, 124, '2015-03-15 00:51:44.000000', 'consum', 0.0217, 'lps'),
	(451520, 124, '2015-03-15 00:51:45.000000', 'consum', 0.0212, 'lps'),
	(451521, 124, '2015-03-15 00:51:46.000000', 'consum', 0.0219, 'lps'),
	(451522, 124, '2015-03-15 00:51:47.000000', 'consum', 0.0228, 'lps'),
	(451523, 124, '2015-03-15 00:51:48.000000', 'consum', 0.0212, 'lps'),
	(451524, 124, '2015-03-15 00:51:49.000000', 'consum', 0.0228, 'lps'),
	(451525, 124, '2015-03-15 00:51:50.000000', 'consum', 0.0211, 'lps'),
	(451526, 124, '2015-03-15 00:51:51.000000', 'consum', 0.0224, 'lps'),
	(451527, 124, '2015-03-15 00:51:52.000000', 'consum', 0.0214, 'lps'),
	(451528, 124, '2015-03-15 00:51:53.000000', 'consum', 0.0211, 'lps'),
	(451529, 124, '2015-03-15 00:51:54.000000', 'consum', 0.0225, 'lps'),
	(451530, 124, '2015-03-15 00:51:55.000000', 'consum', 0.0220, 'lps'),
	(451531, 124, '2015-03-15 00:51:56.000000', 'consum', 0.0216, 'lps'),
	(451532, 124, '2015-03-15 00:51:57.000000', 'consum', 0.0210, 'lps'),
	(451533, 124, '2015-03-15 00:51:58.000000', 'consum', 0.0211, 'lps'),
	(451534, 124, '2015-03-15 00:51:59.000000', 'consum', 0.0218, 'lps'),
	(451535, 124, '2015-03-15 00:52:00.000000', 'consum', 0.0225, 'lps'),
	(451536, 124, '2015-03-15 00:52:01.000000', 'consum', 0.0221, 'lps'),
	(451537, 124, '2015-03-15 00:52:02.000000', 'consum', 0.0221, 'lps'),
	(451538, 124, '2015-03-15 00:52:03.000000', 'consum', 0.0210, 'lps'),
	(451539, 124, '2015-03-15 00:52:04.000000', 'consum', 0.0221, 'lps'),
	(451540, 124, '2015-03-15 00:52:05.000000', 'consum', 0.0225, 'lps'),
	(451541, 124, '2015-03-15 00:52:06.000000', 'consum', 0.0228, 'lps'),
	(451542, 124, '2015-03-15 00:52:07.000000', 'consum', 0.0216, 'lps'),
	(451543, 124, '2015-03-15 00:52:08.000000', 'consum', 0.0227, 'lps'),
	(451544, 124, '2015-03-15 00:52:09.000000', 'consum', 0.0216, 'lps'),
	(451545, 124, '2015-03-15 00:52:10.000000', 'consum', 0.0211, 'lps'),
	(451546, 124, '2015-03-15 00:52:11.000000', 'consum', 0.0217, 'lps'),
	(451547, 124, '2015-03-15 00:52:12.000000', 'consum', 0.0221, 'lps'),
	(451548, 124, '2015-03-15 00:52:13.000000', 'consum', 0.0225, 'lps'),
	(451549, 124, '2015-03-15 00:52:14.000000', 'consum', 0.0211, 'lps'),
	(451550, 124, '2015-03-15 00:52:15.000000', 'consum', 0.0213, 'lps'),
	(451551, 124, '2015-03-15 00:52:16.000000', 'consum', 0.0222, 'lps'),
	(451552, 124, '2015-03-15 00:52:17.000000', 'consum', 0.0219, 'lps'),
	(451553, 124, '2015-03-15 00:52:18.000000', 'consum', 0.0219, 'lps'),
	(451554, 124, '2015-03-15 00:52:19.000000', 'consum', 0.0230, 'lps'),
	(451555, 124, '2015-03-15 00:52:20.000000', 'consum', 0.0218, 'lps'),
	(451556, 124, '2015-03-15 00:52:21.000000', 'consum', 0.0214, 'lps'),
	(451557, 124, '2015-03-15 00:52:22.000000', 'consum', 0.0226, 'lps'),
	(451558, 124, '2015-03-15 00:52:23.000000', 'consum', 0.0216, 'lps'),
	(451559, 124, '2015-03-15 00:52:24.000000', 'consum', 0.0213, 'lps'),
	(451560, 124, '2015-03-15 00:52:25.000000', 'consum', 0.0230, 'lps'),
	(451561, 124, '2015-03-15 00:52:26.000000', 'consum', 0.0216, 'lps'),
	(451562, 124, '2015-03-15 00:52:27.000000', 'consum', 0.0224, 'lps'),
	(451563, 124, '2015-03-15 00:52:28.000000', 'consum', 0.0218, 'lps'),
	(451564, 124, '2015-03-15 00:52:29.000000', 'consum', 0.0210, 'lps'),
	(451565, 124, '2015-03-15 00:52:30.000000', 'consum', 0.0230, 'lps'),
	(451566, 124, '2015-03-15 00:52:31.000000', 'consum', 0.0224, 'lps'),
	(451567, 124, '2015-03-15 00:52:32.000000', 'consum', 0.0221, 'lps'),
	(451568, 124, '2015-03-15 00:52:33.000000', 'consum', 0.0223, 'lps'),
	(451569, 124, '2015-03-15 00:52:34.000000', 'consum', 0.0222, 'lps'),
	(451570, 124, '2015-03-15 00:52:35.000000', 'consum', 0.0210, 'lps'),
	(451571, 124, '2015-03-15 00:52:36.000000', 'consum', 0.0218, 'lps'),
	(451572, 124, '2015-03-15 00:52:37.000000', 'consum', 0.0228, 'lps'),
	(451573, 124, '2015-03-15 00:52:38.000000', 'consum', 0.0213, 'lps'),
	(451574, 124, '2015-03-15 00:52:39.000000', 'consum', 0.0215, 'lps'),
	(451575, 124, '2015-03-15 00:52:40.000000', 'consum', 0.0224, 'lps'),
	(451576, 124, '2015-03-15 00:52:41.000000', 'consum', 0.0226, 'lps'),
	(451577, 124, '2015-03-15 00:52:42.000000', 'consum', 0.0225, 'lps'),
	(451578, 124, '2015-03-15 00:52:43.000000', 'consum', 0.0217, 'lps'),
	(451579, 124, '2015-03-15 00:52:44.000000', 'consum', 0.0221, 'lps'),
	(451580, 124, '2015-03-15 00:52:45.000000', 'consum', 0.0224, 'lps'),
	(451581, 124, '2015-03-15 00:52:46.000000', 'consum', 0.0226, 'lps'),
	(451582, 124, '2015-03-15 00:52:47.000000', 'consum', 0.0227, 'lps'),
	(451583, 124, '2015-03-15 00:52:48.000000', 'consum', 0.0226, 'lps'),
	(451584, 124, '2015-03-15 00:52:49.000000', 'consum', 0.0218, 'lps'),
	(451585, 124, '2015-03-15 00:52:50.000000', 'consum', 0.0224, 'lps'),
	(451586, 124, '2015-03-15 00:52:51.000000', 'consum', 0.0213, 'lps'),
	(451587, 124, '2015-03-15 00:52:52.000000', 'consum', 0.0228, 'lps'),
	(451588, 124, '2015-03-15 00:52:53.000000', 'consum', 0.0228, 'lps'),
	(451589, 124, '2015-03-15 00:52:54.000000', 'consum', 0.0225, 'lps'),
	(451590, 124, '2015-03-15 00:52:55.000000', 'consum', 0.0211, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(451591, 124, '2015-03-15 00:52:56.000000', 'consum', 0.0211, 'lps'),
	(451592, 124, '2015-03-15 00:52:57.000000', 'consum', 0.0212, 'lps'),
	(451593, 124, '2015-03-15 00:52:58.000000', 'consum', 0.0219, 'lps'),
	(451594, 124, '2015-03-15 00:52:59.000000', 'consum', 0.0228, 'lps'),
	(451595, 124, '2015-03-15 00:53:00.000000', 'consum', 0.0210, 'lps'),
	(451596, 124, '2015-03-15 00:53:01.000000', 'consum', 0.0221, 'lps'),
	(451597, 124, '2015-03-15 00:53:02.000000', 'consum', 0.0223, 'lps'),
	(451598, 124, '2015-03-15 00:53:03.000000', 'consum', 0.0222, 'lps'),
	(451599, 124, '2015-03-15 00:53:04.000000', 'consum', 0.0230, 'lps'),
	(451600, 124, '2015-03-15 00:53:05.000000', 'consum', 0.0211, 'lps'),
	(451601, 124, '2015-03-15 00:53:06.000000', 'consum', 0.0218, 'lps'),
	(451602, 124, '2015-03-15 00:53:07.000000', 'consum', 0.0227, 'lps'),
	(451603, 124, '2015-03-15 00:53:08.000000', 'consum', 0.0229, 'lps'),
	(451604, 124, '2015-03-15 00:53:09.000000', 'consum', 0.0213, 'lps'),
	(451605, 124, '2015-03-15 00:53:10.000000', 'consum', 0.0230, 'lps'),
	(451606, 124, '2015-03-15 00:53:11.000000', 'consum', 0.0218, 'lps'),
	(451607, 124, '2015-03-15 00:53:12.000000', 'consum', 0.0212, 'lps'),
	(451608, 124, '2015-03-15 00:53:13.000000', 'consum', 0.0216, 'lps'),
	(451609, 124, '2015-03-15 00:53:14.000000', 'consum', 0.0216, 'lps'),
	(451610, 124, '2015-03-15 00:53:15.000000', 'consum', 0.0222, 'lps'),
	(451611, 124, '2015-03-15 00:53:16.000000', 'consum', 0.0211, 'lps'),
	(451612, 124, '2015-03-15 00:53:17.000000', 'consum', 0.0222, 'lps'),
	(451613, 124, '2015-03-15 00:53:18.000000', 'consum', 0.0226, 'lps'),
	(451614, 124, '2015-03-15 00:53:19.000000', 'consum', 0.0210, 'lps'),
	(451615, 124, '2015-03-15 00:53:20.000000', 'consum', 0.0226, 'lps'),
	(451616, 124, '2015-03-15 00:53:21.000000', 'consum', 0.0226, 'lps'),
	(451617, 124, '2015-03-15 00:53:22.000000', 'consum', 0.0224, 'lps'),
	(451618, 124, '2015-03-15 00:53:23.000000', 'consum', 0.0210, 'lps'),
	(451619, 124, '2015-03-15 00:53:24.000000', 'consum', 0.0230, 'lps'),
	(451620, 124, '2015-03-15 00:53:25.000000', 'consum', 0.0228, 'lps'),
	(451621, 124, '2015-03-15 00:53:26.000000', 'consum', 0.0220, 'lps'),
	(451622, 124, '2015-03-15 00:53:27.000000', 'consum', 0.0225, 'lps'),
	(451623, 124, '2015-03-15 00:53:28.000000', 'consum', 0.0216, 'lps'),
	(451624, 124, '2015-03-15 00:53:29.000000', 'consum', 0.0216, 'lps'),
	(451625, 124, '2015-03-15 00:53:30.000000', 'consum', 0.0222, 'lps'),
	(451626, 124, '2015-03-15 00:53:31.000000', 'consum', 0.0212, 'lps'),
	(451627, 124, '2015-03-15 00:53:32.000000', 'consum', 0.0227, 'lps'),
	(451628, 124, '2015-03-15 00:53:33.000000', 'consum', 0.0227, 'lps'),
	(451629, 124, '2015-03-15 00:53:34.000000', 'consum', 0.0221, 'lps'),
	(451630, 124, '2015-03-15 00:53:35.000000', 'consum', 0.0214, 'lps'),
	(451631, 124, '2015-03-15 00:53:36.000000', 'consum', 0.0221, 'lps'),
	(451632, 124, '2015-03-15 00:53:37.000000', 'consum', 0.0211, 'lps'),
	(451633, 124, '2015-03-15 00:53:38.000000', 'consum', 0.0223, 'lps'),
	(451634, 124, '2015-03-15 00:53:39.000000', 'consum', 0.0210, 'lps'),
	(451635, 124, '2015-03-15 00:53:40.000000', 'consum', 0.0212, 'lps'),
	(451636, 124, '2015-03-15 00:53:41.000000', 'consum', 0.0223, 'lps'),
	(451637, 124, '2015-03-15 00:53:42.000000', 'consum', 0.0227, 'lps'),
	(451638, 124, '2015-03-15 00:53:43.000000', 'consum', 0.0213, 'lps'),
	(451639, 124, '2015-03-15 00:53:44.000000', 'consum', 0.0217, 'lps'),
	(451640, 124, '2015-03-15 00:53:45.000000', 'consum', 0.0214, 'lps'),
	(451641, 124, '2015-03-15 00:53:46.000000', 'consum', 0.0212, 'lps'),
	(451642, 124, '2015-03-15 00:53:47.000000', 'consum', 0.0229, 'lps'),
	(451643, 124, '2015-03-15 00:53:48.000000', 'consum', 0.0217, 'lps'),
	(451644, 124, '2015-03-15 00:53:49.000000', 'consum', 0.0230, 'lps'),
	(451645, 124, '2015-03-15 00:53:50.000000', 'consum', 0.0227, 'lps'),
	(451646, 124, '2015-03-15 00:53:51.000000', 'consum', 0.0214, 'lps'),
	(451647, 124, '2015-03-15 00:53:52.000000', 'consum', 0.0220, 'lps'),
	(451648, 124, '2015-03-15 00:53:53.000000', 'consum', 0.0227, 'lps'),
	(451649, 124, '2015-03-15 00:53:54.000000', 'consum', 0.0225, 'lps'),
	(451650, 124, '2015-03-15 00:53:55.000000', 'consum', 0.0213, 'lps'),
	(451651, 124, '2015-03-15 00:53:56.000000', 'consum', 0.0223, 'lps'),
	(451652, 124, '2015-03-15 00:53:57.000000', 'consum', 0.0224, 'lps'),
	(451653, 124, '2015-03-15 00:53:58.000000', 'consum', 0.0222, 'lps'),
	(451654, 124, '2015-03-15 00:53:59.000000', 'consum', 0.0226, 'lps'),
	(451655, 124, '2015-03-15 00:54:00.000000', 'consum', 0.0215, 'lps'),
	(451656, 124, '2015-03-15 00:54:01.000000', 'consum', 0.0229, 'lps'),
	(451657, 124, '2015-03-15 00:54:02.000000', 'consum', 0.0225, 'lps'),
	(451658, 124, '2015-03-15 00:54:03.000000', 'consum', 0.0210, 'lps'),
	(451659, 124, '2015-03-15 00:54:04.000000', 'consum', 0.0230, 'lps'),
	(451660, 124, '2015-03-15 00:54:05.000000', 'consum', 0.0223, 'lps'),
	(451661, 124, '2015-03-15 00:54:06.000000', 'consum', 0.0219, 'lps'),
	(451662, 124, '2015-03-15 00:54:07.000000', 'consum', 0.0215, 'lps'),
	(451663, 124, '2015-03-15 00:54:08.000000', 'consum', 0.0229, 'lps'),
	(451664, 124, '2015-03-15 00:54:09.000000', 'consum', 0.0229, 'lps'),
	(451665, 124, '2015-03-15 00:54:10.000000', 'consum', 0.0226, 'lps'),
	(451666, 124, '2015-03-15 00:54:11.000000', 'consum', 0.0213, 'lps'),
	(451667, 124, '2015-03-15 00:54:12.000000', 'consum', 0.0219, 'lps'),
	(451668, 124, '2015-03-15 00:54:13.000000', 'consum', 0.0226, 'lps'),
	(451669, 124, '2015-03-15 00:54:14.000000', 'consum', 0.0221, 'lps'),
	(451670, 124, '2015-03-15 00:54:15.000000', 'consum', 0.0217, 'lps'),
	(451671, 124, '2015-03-15 00:54:16.000000', 'consum', 0.0212, 'lps'),
	(451672, 124, '2015-03-15 00:54:17.000000', 'consum', 0.0219, 'lps'),
	(451673, 124, '2015-03-15 00:54:18.000000', 'consum', 0.0210, 'lps'),
	(451674, 124, '2015-03-15 00:54:19.000000', 'consum', 0.0226, 'lps'),
	(451675, 124, '2015-03-15 00:54:20.000000', 'consum', 0.0225, 'lps'),
	(451676, 124, '2015-03-15 00:54:21.000000', 'consum', 0.0218, 'lps'),
	(451677, 124, '2015-03-15 00:54:22.000000', 'consum', 0.0225, 'lps'),
	(451678, 124, '2015-03-15 00:54:23.000000', 'consum', 0.0220, 'lps'),
	(451679, 124, '2015-03-15 00:54:24.000000', 'consum', 0.0217, 'lps'),
	(451680, 124, '2015-03-15 00:54:25.000000', 'consum', 0.0216, 'lps'),
	(451681, 124, '2015-03-15 00:54:26.000000', 'consum', 0.0220, 'lps'),
	(451682, 124, '2015-03-15 00:54:27.000000', 'consum', 0.0222, 'lps'),
	(451683, 124, '2015-03-15 00:54:28.000000', 'consum', 0.0220, 'lps'),
	(451684, 124, '2015-03-15 00:54:29.000000', 'consum', 0.0224, 'lps'),
	(451685, 124, '2015-03-15 00:54:30.000000', 'consum', 0.0210, 'lps'),
	(451686, 124, '2015-03-15 00:54:31.000000', 'consum', 0.0228, 'lps'),
	(451687, 124, '2015-03-15 00:54:32.000000', 'consum', 0.0219, 'lps'),
	(451688, 124, '2015-03-15 00:54:33.000000', 'consum', 0.0222, 'lps'),
	(451689, 124, '2015-03-15 00:54:34.000000', 'consum', 0.0220, 'lps'),
	(451690, 124, '2015-03-15 00:54:35.000000', 'consum', 0.0228, 'lps'),
	(451691, 124, '2015-03-15 00:54:36.000000', 'consum', 0.0226, 'lps'),
	(451692, 124, '2015-03-15 00:54:37.000000', 'consum', 0.0217, 'lps'),
	(451693, 124, '2015-03-15 00:54:38.000000', 'consum', 0.0217, 'lps'),
	(451694, 124, '2015-03-15 00:54:39.000000', 'consum', 0.0225, 'lps'),
	(451695, 124, '2015-03-15 00:54:40.000000', 'consum', 0.0223, 'lps'),
	(451696, 124, '2015-03-15 00:54:41.000000', 'consum', 0.0211, 'lps'),
	(451697, 124, '2015-03-15 00:54:42.000000', 'consum', 0.0219, 'lps'),
	(451698, 124, '2015-03-15 00:54:43.000000', 'consum', 0.0229, 'lps'),
	(451699, 124, '2015-03-15 00:54:44.000000', 'consum', 0.0218, 'lps'),
	(451700, 124, '2015-03-15 00:54:45.000000', 'consum', 0.0214, 'lps'),
	(451701, 124, '2015-03-15 00:54:46.000000', 'consum', 0.0226, 'lps'),
	(451702, 124, '2015-03-15 00:54:47.000000', 'consum', 0.0218, 'lps'),
	(451703, 124, '2015-03-15 00:54:48.000000', 'consum', 0.0221, 'lps'),
	(451704, 124, '2015-03-15 00:54:49.000000', 'consum', 0.0223, 'lps'),
	(451705, 124, '2015-03-15 00:54:50.000000', 'consum', 0.0221, 'lps'),
	(451706, 124, '2015-03-15 00:54:51.000000', 'consum', 0.0224, 'lps'),
	(451707, 124, '2015-03-15 00:54:52.000000', 'consum', 0.0228, 'lps'),
	(451708, 124, '2015-03-15 00:54:53.000000', 'consum', 0.0218, 'lps'),
	(451709, 124, '2015-03-15 00:54:54.000000', 'consum', 0.0216, 'lps'),
	(451710, 124, '2015-03-15 00:54:55.000000', 'consum', 0.0217, 'lps'),
	(451711, 124, '2015-03-15 00:54:56.000000', 'consum', 0.0228, 'lps'),
	(451712, 124, '2015-03-15 00:54:57.000000', 'consum', 0.0215, 'lps'),
	(451713, 124, '2015-03-15 00:54:58.000000', 'consum', 0.0225, 'lps'),
	(451714, 124, '2015-03-15 00:54:59.000000', 'consum', 0.0228, 'lps'),
	(451715, 124, '2015-03-15 00:55:00.000000', 'consum', 0.0212, 'lps'),
	(451716, 124, '2015-03-15 00:55:01.000000', 'consum', 0.0229, 'lps'),
	(451717, 124, '2015-03-15 00:55:02.000000', 'consum', 0.0217, 'lps'),
	(451718, 124, '2015-03-15 00:55:03.000000', 'consum', 0.0229, 'lps'),
	(451719, 124, '2015-03-15 00:55:04.000000', 'consum', 0.0221, 'lps'),
	(451720, 124, '2015-03-15 00:55:05.000000', 'consum', 0.0229, 'lps'),
	(451721, 124, '2015-03-15 00:55:06.000000', 'consum', 0.0210, 'lps'),
	(451722, 124, '2015-03-15 00:55:07.000000', 'consum', 0.0217, 'lps'),
	(451723, 124, '2015-03-15 00:55:08.000000', 'consum', 0.0225, 'lps'),
	(451724, 124, '2015-03-15 00:55:09.000000', 'consum', 0.0223, 'lps'),
	(451725, 124, '2015-03-15 00:55:10.000000', 'consum', 0.0210, 'lps'),
	(451726, 124, '2015-03-15 00:55:11.000000', 'consum', 0.0212, 'lps'),
	(451727, 124, '2015-03-15 00:55:12.000000', 'consum', 0.0223, 'lps'),
	(451728, 124, '2015-03-15 00:55:13.000000', 'consum', 0.0226, 'lps'),
	(451729, 124, '2015-03-15 00:55:14.000000', 'consum', 0.0229, 'lps'),
	(451730, 124, '2015-03-15 00:55:15.000000', 'consum', 0.0215, 'lps'),
	(451731, 124, '2015-03-15 00:55:16.000000', 'consum', 0.0222, 'lps'),
	(451732, 124, '2015-03-15 00:55:17.000000', 'consum', 0.0213, 'lps'),
	(451733, 124, '2015-03-15 00:55:18.000000', 'consum', 0.0230, 'lps'),
	(451734, 124, '2015-03-15 00:55:19.000000', 'consum', 0.0219, 'lps'),
	(451735, 124, '2015-03-15 00:55:20.000000', 'consum', 0.0214, 'lps'),
	(451736, 124, '2015-03-15 00:55:21.000000', 'consum', 0.0228, 'lps'),
	(451737, 124, '2015-03-15 00:55:22.000000', 'consum', 0.0222, 'lps'),
	(451738, 124, '2015-03-15 00:55:23.000000', 'consum', 0.0218, 'lps'),
	(451739, 124, '2015-03-15 00:55:24.000000', 'consum', 0.0216, 'lps'),
	(451740, 124, '2015-03-15 00:55:25.000000', 'consum', 0.0214, 'lps'),
	(451741, 124, '2015-03-15 00:55:26.000000', 'consum', 0.0213, 'lps'),
	(451742, 124, '2015-03-15 00:55:27.000000', 'consum', 0.0214, 'lps'),
	(451743, 124, '2015-03-15 00:55:28.000000', 'consum', 0.0220, 'lps'),
	(451744, 124, '2015-03-15 00:55:29.000000', 'consum', 0.0227, 'lps'),
	(451745, 124, '2015-03-15 00:55:30.000000', 'consum', 0.0224, 'lps'),
	(451746, 124, '2015-03-15 00:55:31.000000', 'consum', 0.0230, 'lps'),
	(451747, 124, '2015-03-15 00:55:32.000000', 'consum', 0.0225, 'lps'),
	(451748, 124, '2015-03-15 00:55:33.000000', 'consum', 0.0228, 'lps'),
	(451749, 124, '2015-03-15 00:55:34.000000', 'consum', 0.0214, 'lps'),
	(451750, 124, '2015-03-15 00:55:35.000000', 'consum', 0.0219, 'lps'),
	(451751, 124, '2015-03-15 00:55:36.000000', 'consum', 0.0221, 'lps'),
	(451752, 124, '2015-03-15 00:55:37.000000', 'consum', 0.0217, 'lps'),
	(451753, 124, '2015-03-15 00:55:38.000000', 'consum', 0.0215, 'lps'),
	(451754, 124, '2015-03-15 00:55:39.000000', 'consum', 0.0213, 'lps'),
	(451755, 124, '2015-03-15 00:55:40.000000', 'consum', 0.0213, 'lps'),
	(451756, 124, '2015-03-15 00:55:41.000000', 'consum', 0.0213, 'lps'),
	(451757, 124, '2015-03-15 00:55:42.000000', 'consum', 0.0220, 'lps'),
	(451758, 124, '2015-03-15 00:55:43.000000', 'consum', 0.0227, 'lps'),
	(451759, 124, '2015-03-15 00:55:44.000000', 'consum', 0.0225, 'lps'),
	(451760, 124, '2015-03-15 00:55:45.000000', 'consum', 0.0213, 'lps'),
	(451761, 124, '2015-03-15 00:55:46.000000', 'consum', 0.0225, 'lps'),
	(451762, 124, '2015-03-15 00:55:47.000000', 'consum', 0.0211, 'lps'),
	(451763, 124, '2015-03-15 00:55:48.000000', 'consum', 0.0214, 'lps'),
	(451764, 124, '2015-03-15 00:55:49.000000', 'consum', 0.0226, 'lps'),
	(451765, 124, '2015-03-15 00:55:50.000000', 'consum', 0.0218, 'lps'),
	(451766, 124, '2015-03-15 00:55:51.000000', 'consum', 0.0222, 'lps'),
	(451767, 124, '2015-03-15 00:55:52.000000', 'consum', 0.0225, 'lps'),
	(451768, 124, '2015-03-15 00:55:53.000000', 'consum', 0.0228, 'lps'),
	(451769, 124, '2015-03-15 00:55:54.000000', 'consum', 0.0216, 'lps'),
	(451770, 124, '2015-03-15 00:55:55.000000', 'consum', 0.0228, 'lps'),
	(451771, 124, '2015-03-15 00:55:56.000000', 'consum', 0.0217, 'lps'),
	(451772, 124, '2015-03-15 00:55:57.000000', 'consum', 0.0214, 'lps'),
	(451773, 124, '2015-03-15 00:55:58.000000', 'consum', 0.0211, 'lps'),
	(451774, 124, '2015-03-15 00:55:59.000000', 'consum', 0.0224, 'lps'),
	(451775, 124, '2015-03-15 00:56:00.000000', 'consum', 0.0213, 'lps'),
	(451776, 124, '2015-03-15 00:56:01.000000', 'consum', 0.0227, 'lps'),
	(451777, 124, '2015-03-15 00:56:02.000000', 'consum', 0.0224, 'lps'),
	(451778, 124, '2015-03-15 00:56:03.000000', 'consum', 0.0229, 'lps'),
	(451779, 124, '2015-03-15 00:56:04.000000', 'consum', 0.0221, 'lps'),
	(451780, 124, '2015-03-15 00:56:05.000000', 'consum', 0.0228, 'lps'),
	(451781, 124, '2015-03-15 00:56:06.000000', 'consum', 0.0225, 'lps'),
	(451782, 124, '2015-03-15 00:56:07.000000', 'consum', 0.0212, 'lps'),
	(451783, 124, '2015-03-15 00:56:08.000000', 'consum', 0.0217, 'lps'),
	(451784, 124, '2015-03-15 00:56:09.000000', 'consum', 0.0217, 'lps'),
	(451785, 124, '2015-03-15 00:56:10.000000', 'consum', 0.0227, 'lps'),
	(451786, 124, '2015-03-15 00:56:11.000000', 'consum', 0.0210, 'lps'),
	(451787, 124, '2015-03-15 00:56:12.000000', 'consum', 0.0221, 'lps'),
	(451788, 124, '2015-03-15 00:56:13.000000', 'consum', 0.0226, 'lps'),
	(451789, 124, '2015-03-15 00:56:14.000000', 'consum', 0.0215, 'lps'),
	(451790, 124, '2015-03-15 00:56:15.000000', 'consum', 0.0210, 'lps'),
	(451791, 124, '2015-03-15 00:56:16.000000', 'consum', 0.0214, 'lps'),
	(451792, 124, '2015-03-15 00:56:17.000000', 'consum', 0.0229, 'lps'),
	(451793, 124, '2015-03-15 00:56:18.000000', 'consum', 0.0213, 'lps'),
	(451794, 124, '2015-03-15 00:56:19.000000', 'consum', 0.0229, 'lps'),
	(451795, 124, '2015-03-15 00:56:20.000000', 'consum', 0.0214, 'lps'),
	(451796, 124, '2015-03-15 00:56:21.000000', 'consum', 0.0217, 'lps'),
	(451797, 124, '2015-03-15 00:56:22.000000', 'consum', 0.0210, 'lps'),
	(451798, 124, '2015-03-15 00:56:23.000000', 'consum', 0.0212, 'lps'),
	(451799, 124, '2015-03-15 00:56:24.000000', 'consum', 0.0220, 'lps'),
	(451800, 124, '2015-03-15 00:56:25.000000', 'consum', 0.0211, 'lps'),
	(451801, 124, '2015-03-15 00:56:26.000000', 'consum', 0.0228, 'lps'),
	(451802, 124, '2015-03-15 00:56:27.000000', 'consum', 0.0215, 'lps'),
	(451803, 124, '2015-03-15 00:56:28.000000', 'consum', 0.0223, 'lps'),
	(451804, 124, '2015-03-15 00:56:29.000000', 'consum', 0.0217, 'lps'),
	(451805, 124, '2015-03-15 00:56:30.000000', 'consum', 0.0227, 'lps'),
	(451806, 124, '2015-03-15 00:56:31.000000', 'consum', 0.0214, 'lps'),
	(451807, 124, '2015-03-15 00:56:32.000000', 'consum', 0.0223, 'lps'),
	(451808, 124, '2015-03-15 00:56:33.000000', 'consum', 0.0218, 'lps'),
	(451809, 124, '2015-03-15 00:56:34.000000', 'consum', 0.0211, 'lps'),
	(451810, 124, '2015-03-15 00:56:35.000000', 'consum', 0.0215, 'lps'),
	(451811, 124, '2015-03-15 00:56:36.000000', 'consum', 0.0210, 'lps'),
	(451812, 124, '2015-03-15 00:56:37.000000', 'consum', 0.0215, 'lps'),
	(451813, 124, '2015-03-15 00:56:38.000000', 'consum', 0.0215, 'lps'),
	(451814, 124, '2015-03-15 00:56:39.000000', 'consum', 0.0221, 'lps'),
	(451815, 124, '2015-03-15 00:56:40.000000', 'consum', 0.0230, 'lps'),
	(451816, 124, '2015-03-15 00:56:41.000000', 'consum', 0.0214, 'lps'),
	(451817, 124, '2015-03-15 00:56:42.000000', 'consum', 0.0214, 'lps'),
	(451818, 124, '2015-03-15 00:56:43.000000', 'consum', 0.0220, 'lps'),
	(451819, 124, '2015-03-15 00:56:44.000000', 'consum', 0.0224, 'lps'),
	(451820, 124, '2015-03-15 00:56:45.000000', 'consum', 0.0230, 'lps'),
	(451821, 124, '2015-03-15 00:56:46.000000', 'consum', 0.0227, 'lps'),
	(451822, 124, '2015-03-15 00:56:47.000000', 'consum', 0.0213, 'lps'),
	(451823, 124, '2015-03-15 00:56:48.000000', 'consum', 0.0219, 'lps'),
	(451824, 124, '2015-03-15 00:56:49.000000', 'consum', 0.0224, 'lps'),
	(451825, 124, '2015-03-15 00:56:50.000000', 'consum', 0.0212, 'lps'),
	(451826, 124, '2015-03-15 00:56:51.000000', 'consum', 0.0220, 'lps'),
	(451827, 124, '2015-03-15 00:56:52.000000', 'consum', 0.0211, 'lps'),
	(451828, 124, '2015-03-15 00:56:53.000000', 'consum', 0.0229, 'lps'),
	(451829, 124, '2015-03-15 00:56:54.000000', 'consum', 0.0217, 'lps'),
	(451830, 124, '2015-03-15 00:56:55.000000', 'consum', 0.0211, 'lps'),
	(451831, 124, '2015-03-15 00:56:56.000000', 'consum', 0.0217, 'lps'),
	(451832, 124, '2015-03-15 00:56:57.000000', 'consum', 0.0219, 'lps'),
	(451833, 124, '2015-03-15 00:56:58.000000', 'consum', 0.0216, 'lps'),
	(451834, 124, '2015-03-15 00:56:59.000000', 'consum', 0.0211, 'lps'),
	(451835, 124, '2015-03-15 00:57:00.000000', 'consum', 0.0221, 'lps'),
	(451836, 124, '2015-03-15 00:57:01.000000', 'consum', 0.0220, 'lps'),
	(451837, 124, '2015-03-15 00:57:02.000000', 'consum', 0.0226, 'lps'),
	(451838, 124, '2015-03-15 00:57:03.000000', 'consum', 0.0219, 'lps'),
	(451839, 124, '2015-03-15 00:57:04.000000', 'consum', 0.0229, 'lps'),
	(451840, 124, '2015-03-15 00:57:05.000000', 'consum', 0.0213, 'lps'),
	(451841, 124, '2015-03-15 00:57:06.000000', 'consum', 0.0214, 'lps'),
	(451842, 124, '2015-03-15 00:57:07.000000', 'consum', 0.0218, 'lps'),
	(451843, 124, '2015-03-15 00:57:08.000000', 'consum', 0.0220, 'lps'),
	(451844, 124, '2015-03-15 00:57:09.000000', 'consum', 0.0216, 'lps'),
	(451845, 124, '2015-03-15 00:57:10.000000', 'consum', 0.0230, 'lps'),
	(451846, 124, '2015-03-15 00:57:11.000000', 'consum', 0.0229, 'lps'),
	(451847, 124, '2015-03-15 00:57:12.000000', 'consum', 0.0227, 'lps'),
	(451848, 124, '2015-03-15 00:57:13.000000', 'consum', 0.0217, 'lps'),
	(451849, 124, '2015-03-15 00:57:14.000000', 'consum', 0.0214, 'lps'),
	(451850, 124, '2015-03-15 00:57:15.000000', 'consum', 0.0229, 'lps'),
	(451851, 124, '2015-03-15 00:57:16.000000', 'consum', 0.0211, 'lps'),
	(451852, 124, '2015-03-15 00:57:17.000000', 'consum', 0.0223, 'lps'),
	(451853, 124, '2015-03-15 00:57:18.000000', 'consum', 0.0228, 'lps'),
	(451854, 124, '2015-03-15 00:57:19.000000', 'consum', 0.0219, 'lps'),
	(451855, 124, '2015-03-15 00:57:20.000000', 'consum', 0.0222, 'lps'),
	(451856, 124, '2015-03-15 00:57:21.000000', 'consum', 0.0224, 'lps'),
	(451857, 124, '2015-03-15 00:57:22.000000', 'consum', 0.0222, 'lps'),
	(451858, 124, '2015-03-15 00:57:23.000000', 'consum', 0.0229, 'lps'),
	(451859, 124, '2015-03-15 00:57:24.000000', 'consum', 0.0227, 'lps'),
	(451860, 124, '2015-03-15 00:57:25.000000', 'consum', 0.0216, 'lps'),
	(451861, 124, '2015-03-15 00:57:26.000000', 'consum', 0.0212, 'lps'),
	(451862, 124, '2015-03-15 00:57:27.000000', 'consum', 0.0223, 'lps'),
	(451863, 124, '2015-03-15 00:57:28.000000', 'consum', 0.0226, 'lps'),
	(451864, 124, '2015-03-15 00:57:29.000000', 'consum', 0.0213, 'lps'),
	(451865, 124, '2015-03-15 00:57:30.000000', 'consum', 0.0217, 'lps'),
	(451866, 124, '2015-03-15 00:57:31.000000', 'consum', 0.0216, 'lps'),
	(451867, 124, '2015-03-15 00:57:32.000000', 'consum', 0.0221, 'lps'),
	(451868, 124, '2015-03-15 00:57:33.000000', 'consum', 0.0225, 'lps'),
	(451869, 124, '2015-03-15 00:57:34.000000', 'consum', 0.0213, 'lps'),
	(451870, 124, '2015-03-15 00:57:35.000000', 'consum', 0.0221, 'lps'),
	(451871, 124, '2015-03-15 00:57:36.000000', 'consum', 0.0215, 'lps'),
	(451872, 124, '2015-03-15 00:57:37.000000', 'consum', 0.0222, 'lps'),
	(451873, 124, '2015-03-15 00:57:38.000000', 'consum', 0.0213, 'lps'),
	(451874, 124, '2015-03-15 00:57:39.000000', 'consum', 0.0212, 'lps'),
	(451875, 124, '2015-03-15 00:57:40.000000', 'consum', 0.0230, 'lps'),
	(451876, 124, '2015-03-15 00:57:41.000000', 'consum', 0.0223, 'lps'),
	(451877, 124, '2015-03-15 00:57:42.000000', 'consum', 0.0217, 'lps'),
	(451878, 124, '2015-03-15 00:57:43.000000', 'consum', 0.0224, 'lps'),
	(451879, 124, '2015-03-15 00:57:44.000000', 'consum', 0.0220, 'lps'),
	(451880, 124, '2015-03-15 00:57:45.000000', 'consum', 0.0218, 'lps'),
	(451881, 124, '2015-03-15 00:57:46.000000', 'consum', 0.0220, 'lps'),
	(451882, 124, '2015-03-15 00:57:47.000000', 'consum', 0.0215, 'lps'),
	(451883, 124, '2015-03-15 00:57:48.000000', 'consum', 0.0228, 'lps'),
	(451884, 124, '2015-03-15 00:57:49.000000', 'consum', 0.0223, 'lps'),
	(451885, 124, '2015-03-15 00:57:50.000000', 'consum', 0.0221, 'lps'),
	(451886, 124, '2015-03-15 00:57:51.000000', 'consum', 0.0226, 'lps'),
	(451887, 124, '2015-03-15 00:57:52.000000', 'consum', 0.0214, 'lps'),
	(451888, 124, '2015-03-15 00:57:53.000000', 'consum', 0.0225, 'lps'),
	(451889, 124, '2015-03-15 00:57:54.000000', 'consum', 0.0210, 'lps'),
	(451890, 124, '2015-03-15 00:57:55.000000', 'consum', 0.0229, 'lps'),
	(451891, 124, '2015-03-15 00:57:56.000000', 'consum', 0.0224, 'lps'),
	(451892, 124, '2015-03-15 00:57:57.000000', 'consum', 0.0220, 'lps'),
	(451893, 124, '2015-03-15 00:57:58.000000', 'consum', 0.0221, 'lps'),
	(451894, 124, '2015-03-15 00:57:59.000000', 'consum', 0.0213, 'lps'),
	(451895, 124, '2015-03-15 00:58:00.000000', 'consum', 0.0214, 'lps'),
	(451896, 124, '2015-03-15 00:58:01.000000', 'consum', 0.0220, 'lps'),
	(451897, 124, '2015-03-15 00:58:02.000000', 'consum', 0.0230, 'lps'),
	(451898, 124, '2015-03-15 00:58:03.000000', 'consum', 0.0215, 'lps'),
	(451899, 124, '2015-03-15 00:58:04.000000', 'consum', 0.0219, 'lps'),
	(451900, 124, '2015-03-15 00:58:05.000000', 'consum', 0.0219, 'lps'),
	(451901, 124, '2015-03-15 00:58:06.000000', 'consum', 0.0230, 'lps'),
	(451902, 124, '2015-03-15 00:58:07.000000', 'consum', 0.0221, 'lps'),
	(451903, 124, '2015-03-15 00:58:08.000000', 'consum', 0.0225, 'lps'),
	(451904, 124, '2015-03-15 00:58:09.000000', 'consum', 0.0212, 'lps'),
	(451905, 124, '2015-03-15 00:58:10.000000', 'consum', 0.0217, 'lps'),
	(451906, 124, '2015-03-15 00:58:11.000000', 'consum', 0.0217, 'lps'),
	(451907, 124, '2015-03-15 00:58:12.000000', 'consum', 0.0226, 'lps'),
	(451908, 124, '2015-03-15 00:58:13.000000', 'consum', 0.0227, 'lps'),
	(451909, 124, '2015-03-15 00:58:14.000000', 'consum', 0.0226, 'lps'),
	(451910, 124, '2015-03-15 00:58:15.000000', 'consum', 0.0220, 'lps'),
	(451911, 124, '2015-03-15 00:58:16.000000', 'consum', 0.0212, 'lps'),
	(451912, 124, '2015-03-15 00:58:17.000000', 'consum', 0.0210, 'lps'),
	(451913, 124, '2015-03-15 00:58:18.000000', 'consum', 0.0226, 'lps'),
	(451914, 124, '2015-03-15 00:58:19.000000', 'consum', 0.0228, 'lps'),
	(451915, 124, '2015-03-15 00:58:20.000000', 'consum', 0.0210, 'lps'),
	(451916, 124, '2015-03-15 00:58:21.000000', 'consum', 0.0220, 'lps'),
	(451917, 124, '2015-03-15 00:58:22.000000', 'consum', 0.0218, 'lps'),
	(451918, 124, '2015-03-15 00:58:23.000000', 'consum', 0.0221, 'lps'),
	(451919, 124, '2015-03-15 00:58:24.000000', 'consum', 0.0222, 'lps'),
	(451920, 124, '2015-03-15 00:58:25.000000', 'consum', 0.0217, 'lps'),
	(451921, 124, '2015-03-15 00:58:26.000000', 'consum', 0.0230, 'lps'),
	(451922, 124, '2015-03-15 00:58:27.000000', 'consum', 0.0227, 'lps'),
	(451923, 124, '2015-03-15 00:58:28.000000', 'consum', 0.0214, 'lps'),
	(451924, 124, '2015-03-15 00:58:29.000000', 'consum', 0.0220, 'lps'),
	(451925, 124, '2015-03-15 00:58:30.000000', 'consum', 0.0229, 'lps'),
	(451926, 124, '2015-03-15 00:58:31.000000', 'consum', 0.0211, 'lps'),
	(451927, 124, '2015-03-15 00:58:32.000000', 'consum', 0.0223, 'lps'),
	(451928, 124, '2015-03-15 00:58:33.000000', 'consum', 0.0230, 'lps'),
	(451929, 124, '2015-03-15 00:58:34.000000', 'consum', 0.0210, 'lps'),
	(451930, 124, '2015-03-15 00:58:35.000000', 'consum', 0.0214, 'lps'),
	(451931, 124, '2015-03-15 00:58:36.000000', 'consum', 0.0230, 'lps'),
	(451932, 124, '2015-03-15 00:58:37.000000', 'consum', 0.0213, 'lps'),
	(451933, 124, '2015-03-15 00:58:38.000000', 'consum', 0.0230, 'lps'),
	(451934, 124, '2015-03-15 00:58:39.000000', 'consum', 0.0217, 'lps'),
	(451935, 124, '2015-03-15 00:58:40.000000', 'consum', 0.0227, 'lps'),
	(451936, 124, '2015-03-15 00:58:41.000000', 'consum', 0.0211, 'lps'),
	(451937, 124, '2015-03-15 00:58:42.000000', 'consum', 0.0227, 'lps'),
	(451938, 124, '2015-03-15 00:58:43.000000', 'consum', 0.0228, 'lps'),
	(451939, 124, '2015-03-15 00:58:44.000000', 'consum', 0.0210, 'lps'),
	(451940, 124, '2015-03-15 00:58:45.000000', 'consum', 0.0221, 'lps'),
	(451941, 124, '2015-03-15 00:58:46.000000', 'consum', 0.0221, 'lps'),
	(451942, 124, '2015-03-15 00:58:47.000000', 'consum', 0.0214, 'lps'),
	(451943, 124, '2015-03-15 00:58:48.000000', 'consum', 0.0216, 'lps'),
	(451944, 124, '2015-03-15 00:58:49.000000', 'consum', 0.0210, 'lps'),
	(451945, 124, '2015-03-15 00:58:50.000000', 'consum', 0.0210, 'lps'),
	(451946, 124, '2015-03-15 00:58:51.000000', 'consum', 0.0214, 'lps'),
	(451947, 124, '2015-03-15 00:58:52.000000', 'consum', 0.0230, 'lps'),
	(451948, 124, '2015-03-15 00:58:53.000000', 'consum', 0.0214, 'lps'),
	(451949, 124, '2015-03-15 00:58:54.000000', 'consum', 0.0210, 'lps'),
	(451950, 124, '2015-03-15 00:58:55.000000', 'consum', 0.0223, 'lps'),
	(451951, 124, '2015-03-15 00:58:56.000000', 'consum', 0.0212, 'lps'),
	(451952, 124, '2015-03-15 00:58:57.000000', 'consum', 0.0221, 'lps'),
	(451953, 124, '2015-03-15 00:58:58.000000', 'consum', 0.0219, 'lps'),
	(451954, 124, '2015-03-15 00:58:59.000000', 'consum', 0.0220, 'lps'),
	(451955, 124, '2015-03-15 00:59:00.000000', 'consum', 0.0215, 'lps'),
	(451956, 124, '2015-03-15 00:59:01.000000', 'consum', 0.0228, 'lps'),
	(451957, 124, '2015-03-15 00:59:02.000000', 'consum', 0.0219, 'lps'),
	(451958, 124, '2015-03-15 00:59:03.000000', 'consum', 0.0224, 'lps'),
	(451959, 124, '2015-03-15 00:59:04.000000', 'consum', 0.0212, 'lps'),
	(451960, 124, '2015-03-15 00:59:05.000000', 'consum', 0.0221, 'lps'),
	(451961, 124, '2015-03-15 00:59:06.000000', 'consum', 0.0219, 'lps'),
	(451962, 124, '2015-03-15 00:59:07.000000', 'consum', 0.0220, 'lps'),
	(451963, 124, '2015-03-15 00:59:08.000000', 'consum', 0.0212, 'lps'),
	(451964, 124, '2015-03-15 00:59:09.000000', 'consum', 0.0211, 'lps'),
	(451965, 124, '2015-03-15 00:59:10.000000', 'consum', 0.0212, 'lps'),
	(451966, 124, '2015-03-15 00:59:11.000000', 'consum', 0.0216, 'lps'),
	(451967, 124, '2015-03-15 00:59:12.000000', 'consum', 0.0214, 'lps'),
	(451968, 124, '2015-03-15 00:59:13.000000', 'consum', 0.0214, 'lps'),
	(451969, 124, '2015-03-15 00:59:14.000000', 'consum', 0.0216, 'lps'),
	(451970, 124, '2015-03-15 00:59:15.000000', 'consum', 0.0228, 'lps'),
	(451971, 124, '2015-03-15 00:59:16.000000', 'consum', 0.0221, 'lps'),
	(451972, 124, '2015-03-15 00:59:17.000000', 'consum', 0.0210, 'lps'),
	(451973, 124, '2015-03-15 00:59:18.000000', 'consum', 0.0222, 'lps'),
	(451974, 124, '2015-03-15 00:59:19.000000', 'consum', 0.0227, 'lps'),
	(451975, 124, '2015-03-15 00:59:20.000000', 'consum', 0.0218, 'lps'),
	(451976, 124, '2015-03-15 00:59:21.000000', 'consum', 0.0219, 'lps'),
	(451977, 124, '2015-03-15 00:59:22.000000', 'consum', 0.0210, 'lps'),
	(451978, 124, '2015-03-15 00:59:23.000000', 'consum', 0.0225, 'lps'),
	(451979, 124, '2015-03-15 00:59:24.000000', 'consum', 0.0224, 'lps'),
	(451980, 124, '2015-03-15 00:59:25.000000', 'consum', 0.0214, 'lps'),
	(451981, 124, '2015-03-15 00:59:26.000000', 'consum', 0.0210, 'lps'),
	(451982, 125, '2015-03-15 00:00:00.000000', 'consum', 0.0222, 'lps'),
	(451983, 125, '2015-03-15 00:00:01.000000', 'consum', 0.0220, 'lps'),
	(451984, 125, '2015-03-15 00:00:02.000000', 'consum', 0.0225, 'lps'),
	(451985, 125, '2015-03-15 00:00:03.000000', 'consum', 0.0221, 'lps'),
	(451986, 125, '2015-03-15 00:00:04.000000', 'consum', 0.0218, 'lps'),
	(451987, 125, '2015-03-15 00:00:05.000000', 'consum', 0.0219, 'lps'),
	(451988, 125, '2015-03-15 00:00:06.000000', 'consum', 0.0212, 'lps'),
	(451989, 125, '2015-03-15 00:00:07.000000', 'consum', 0.0212, 'lps'),
	(451990, 125, '2015-03-15 00:00:08.000000', 'consum', 0.0216, 'lps'),
	(451991, 125, '2015-03-15 00:00:09.000000', 'consum', 0.0216, 'lps'),
	(451992, 125, '2015-03-15 00:00:10.000000', 'consum', 0.0224, 'lps'),
	(451993, 125, '2015-03-15 00:00:11.000000', 'consum', 0.0226, 'lps'),
	(451994, 125, '2015-03-15 00:00:12.000000', 'consum', 0.0213, 'lps'),
	(451995, 125, '2015-03-15 00:00:13.000000', 'consum', 0.0212, 'lps'),
	(451996, 125, '2015-03-15 00:00:14.000000', 'consum', 0.0213, 'lps'),
	(451997, 125, '2015-03-15 00:00:15.000000', 'consum', 0.0217, 'lps'),
	(451998, 125, '2015-03-15 00:00:16.000000', 'consum', 0.0221, 'lps'),
	(451999, 125, '2015-03-15 00:00:17.000000', 'consum', 0.0227, 'lps'),
	(452000, 125, '2015-03-15 00:00:18.000000', 'consum', 0.0226, 'lps'),
	(452001, 125, '2015-03-15 00:00:19.000000', 'consum', 0.0220, 'lps'),
	(452002, 125, '2015-03-15 00:00:20.000000', 'consum', 0.0214, 'lps'),
	(452003, 125, '2015-03-15 00:00:21.000000', 'consum', 0.0217, 'lps'),
	(452004, 125, '2015-03-15 00:00:22.000000', 'consum', 0.0214, 'lps'),
	(452005, 125, '2015-03-15 00:00:23.000000', 'consum', 0.0212, 'lps'),
	(452006, 125, '2015-03-15 00:00:24.000000', 'consum', 0.0226, 'lps'),
	(452007, 125, '2015-03-15 00:00:25.000000', 'consum', 0.0213, 'lps'),
	(452008, 125, '2015-03-15 00:00:26.000000', 'consum', 0.0215, 'lps'),
	(452009, 125, '2015-03-15 00:00:27.000000', 'consum', 0.0225, 'lps'),
	(452010, 125, '2015-03-15 00:00:28.000000', 'consum', 0.0217, 'lps'),
	(452011, 125, '2015-03-15 00:00:29.000000', 'consum', 0.0219, 'lps'),
	(452012, 125, '2015-03-15 00:00:30.000000', 'consum', 0.0214, 'lps'),
	(452013, 125, '2015-03-15 00:00:31.000000', 'consum', 0.0223, 'lps'),
	(452014, 125, '2015-03-15 00:00:32.000000', 'consum', 0.0210, 'lps'),
	(452015, 125, '2015-03-15 00:00:33.000000', 'consum', 0.0224, 'lps'),
	(452016, 125, '2015-03-15 00:00:34.000000', 'consum', 0.0210, 'lps'),
	(452017, 125, '2015-03-15 00:00:35.000000', 'consum', 0.0221, 'lps'),
	(452018, 125, '2015-03-15 00:00:36.000000', 'consum', 0.0211, 'lps'),
	(452019, 125, '2015-03-15 00:00:37.000000', 'consum', 0.0219, 'lps'),
	(452020, 125, '2015-03-15 00:00:38.000000', 'consum', 0.0218, 'lps'),
	(452021, 125, '2015-03-15 00:00:39.000000', 'consum', 0.0223, 'lps'),
	(452022, 125, '2015-03-15 00:00:40.000000', 'consum', 0.0217, 'lps'),
	(452023, 125, '2015-03-15 00:00:41.000000', 'consum', 0.0223, 'lps'),
	(452024, 125, '2015-03-15 00:00:42.000000', 'consum', 0.0219, 'lps'),
	(452025, 125, '2015-03-15 00:00:43.000000', 'consum', 0.0215, 'lps'),
	(452026, 125, '2015-03-15 00:00:44.000000', 'consum', 0.0211, 'lps'),
	(452027, 125, '2015-03-15 00:00:45.000000', 'consum', 0.0215, 'lps'),
	(452028, 125, '2015-03-15 00:00:46.000000', 'consum', 0.0218, 'lps'),
	(452029, 125, '2015-03-15 00:00:47.000000', 'consum', 0.0217, 'lps'),
	(452030, 125, '2015-03-15 00:00:48.000000', 'consum', 0.0221, 'lps'),
	(452031, 125, '2015-03-15 00:00:49.000000', 'consum', 0.0225, 'lps'),
	(452032, 125, '2015-03-15 00:00:50.000000', 'consum', 0.0216, 'lps'),
	(452033, 125, '2015-03-15 00:00:51.000000', 'consum', 0.0216, 'lps'),
	(452034, 125, '2015-03-15 00:00:52.000000', 'consum', 0.0222, 'lps'),
	(452035, 125, '2015-03-15 00:00:53.000000', 'consum', 0.0216, 'lps'),
	(452036, 125, '2015-03-15 00:00:54.000000', 'consum', 0.0221, 'lps'),
	(452037, 125, '2015-03-15 00:00:55.000000', 'consum', 0.0213, 'lps'),
	(452038, 125, '2015-03-15 00:00:56.000000', 'consum', 0.0212, 'lps'),
	(452039, 125, '2015-03-15 00:00:57.000000', 'consum', 0.0211, 'lps'),
	(452040, 125, '2015-03-15 00:00:58.000000', 'consum', 0.0210, 'lps'),
	(452041, 125, '2015-03-15 00:00:59.000000', 'consum', 0.0226, 'lps'),
	(452042, 125, '2015-03-15 00:01:00.000000', 'consum', 0.0218, 'lps'),
	(452043, 125, '2015-03-15 00:01:01.000000', 'consum', 0.0218, 'lps'),
	(452044, 125, '2015-03-15 00:01:02.000000', 'consum', 0.0212, 'lps'),
	(452045, 125, '2015-03-15 00:01:03.000000', 'consum', 0.0211, 'lps'),
	(452046, 125, '2015-03-15 00:01:04.000000', 'consum', 0.0211, 'lps'),
	(452047, 125, '2015-03-15 00:01:05.000000', 'consum', 0.0213, 'lps'),
	(452048, 125, '2015-03-15 00:01:06.000000', 'consum', 0.0223, 'lps'),
	(452049, 125, '2015-03-15 00:01:07.000000', 'consum', 0.0212, 'lps'),
	(452050, 125, '2015-03-15 00:01:08.000000', 'consum', 0.0218, 'lps'),
	(452051, 125, '2015-03-15 00:01:09.000000', 'consum', 0.0224, 'lps'),
	(452052, 125, '2015-03-15 00:01:10.000000', 'consum', 0.0224, 'lps'),
	(452053, 125, '2015-03-15 00:01:11.000000', 'consum', 0.0218, 'lps'),
	(452054, 125, '2015-03-15 00:01:12.000000', 'consum', 0.0210, 'lps'),
	(452055, 125, '2015-03-15 00:01:13.000000', 'consum', 0.0223, 'lps'),
	(452056, 125, '2015-03-15 00:01:14.000000', 'consum', 0.0221, 'lps'),
	(452057, 125, '2015-03-15 00:01:15.000000', 'consum', 0.0226, 'lps'),
	(452058, 125, '2015-03-15 00:01:16.000000', 'consum', 0.0222, 'lps'),
	(452059, 125, '2015-03-15 00:01:17.000000', 'consum', 0.0221, 'lps'),
	(452060, 125, '2015-03-15 00:01:18.000000', 'consum', 0.0211, 'lps'),
	(452061, 125, '2015-03-15 00:01:19.000000', 'consum', 0.0220, 'lps'),
	(452062, 125, '2015-03-15 00:01:20.000000', 'consum', 0.0219, 'lps'),
	(452063, 125, '2015-03-15 00:01:21.000000', 'consum', 0.0210, 'lps'),
	(452064, 125, '2015-03-15 00:01:22.000000', 'consum', 0.0217, 'lps'),
	(452065, 125, '2015-03-15 00:01:23.000000', 'consum', 0.0211, 'lps'),
	(452066, 125, '2015-03-15 00:01:24.000000', 'consum', 0.0211, 'lps'),
	(452067, 125, '2015-03-15 00:01:25.000000', 'consum', 0.0213, 'lps'),
	(452068, 125, '2015-03-15 00:01:26.000000', 'consum', 0.0225, 'lps'),
	(452069, 125, '2015-03-15 00:01:27.000000', 'consum', 0.0219, 'lps'),
	(452070, 125, '2015-03-15 00:01:28.000000', 'consum', 0.0212, 'lps'),
	(452071, 125, '2015-03-15 00:01:29.000000', 'consum', 0.0212, 'lps'),
	(452072, 125, '2015-03-15 00:01:30.000000', 'consum', 0.0213, 'lps'),
	(452073, 125, '2015-03-15 00:01:31.000000', 'consum', 0.0219, 'lps'),
	(452074, 125, '2015-03-15 00:01:32.000000', 'consum', 0.0227, 'lps'),
	(452075, 125, '2015-03-15 00:01:33.000000', 'consum', 0.0218, 'lps'),
	(452076, 125, '2015-03-15 00:01:34.000000', 'consum', 0.0215, 'lps'),
	(452077, 125, '2015-03-15 00:01:35.000000', 'consum', 0.0211, 'lps'),
	(452078, 125, '2015-03-15 00:01:36.000000', 'consum', 0.0220, 'lps'),
	(452079, 125, '2015-03-15 00:01:37.000000', 'consum', 0.0222, 'lps'),
	(452080, 125, '2015-03-15 00:01:38.000000', 'consum', 0.0220, 'lps'),
	(452081, 125, '2015-03-15 00:01:39.000000', 'consum', 0.0226, 'lps'),
	(452082, 125, '2015-03-15 00:01:40.000000', 'consum', 0.0225, 'lps'),
	(452083, 125, '2015-03-15 00:01:41.000000', 'consum', 0.0221, 'lps'),
	(452084, 125, '2015-03-15 00:01:42.000000', 'consum', 0.0219, 'lps'),
	(452085, 125, '2015-03-15 00:01:43.000000', 'consum', 0.0223, 'lps'),
	(452086, 125, '2015-03-15 00:01:44.000000', 'consum', 0.0213, 'lps'),
	(452087, 125, '2015-03-15 00:01:45.000000', 'consum', 0.0223, 'lps'),
	(452088, 125, '2015-03-15 00:01:46.000000', 'consum', 0.0213, 'lps'),
	(452089, 125, '2015-03-15 00:01:47.000000', 'consum', 0.0220, 'lps'),
	(452090, 125, '2015-03-15 00:01:48.000000', 'consum', 0.0217, 'lps'),
	(452091, 125, '2015-03-15 00:01:49.000000', 'consum', 0.0216, 'lps'),
	(452092, 125, '2015-03-15 00:01:50.000000', 'consum', 0.0218, 'lps'),
	(452093, 125, '2015-03-15 00:01:51.000000', 'consum', 0.0217, 'lps'),
	(452094, 125, '2015-03-15 00:01:52.000000', 'consum', 0.0220, 'lps'),
	(452095, 125, '2015-03-15 00:01:53.000000', 'consum', 0.0223, 'lps'),
	(452096, 125, '2015-03-15 00:01:54.000000', 'consum', 0.0226, 'lps'),
	(452097, 125, '2015-03-15 00:01:55.000000', 'consum', 0.0214, 'lps'),
	(452098, 125, '2015-03-15 00:01:56.000000', 'consum', 0.0221, 'lps'),
	(452099, 125, '2015-03-15 00:01:57.000000', 'consum', 0.0218, 'lps'),
	(452100, 125, '2015-03-15 00:01:58.000000', 'consum', 0.0217, 'lps'),
	(452101, 125, '2015-03-15 00:01:59.000000', 'consum', 0.0223, 'lps'),
	(452102, 125, '2015-03-15 00:02:00.000000', 'consum', 0.0215, 'lps'),
	(452103, 125, '2015-03-15 00:02:01.000000', 'consum', 0.0217, 'lps'),
	(452104, 125, '2015-03-15 00:02:02.000000', 'consum', 0.0213, 'lps'),
	(452105, 125, '2015-03-15 00:02:03.000000', 'consum', 0.0220, 'lps'),
	(452106, 125, '2015-03-15 00:02:04.000000', 'consum', 0.0218, 'lps'),
	(452107, 125, '2015-03-15 00:02:05.000000', 'consum', 0.0219, 'lps'),
	(452108, 125, '2015-03-15 00:02:06.000000', 'consum', 0.0215, 'lps'),
	(452109, 125, '2015-03-15 00:02:07.000000', 'consum', 0.0224, 'lps'),
	(452110, 125, '2015-03-15 00:02:08.000000', 'consum', 0.0214, 'lps'),
	(452111, 125, '2015-03-15 00:02:09.000000', 'consum', 0.0222, 'lps'),
	(452112, 125, '2015-03-15 00:02:10.000000', 'consum', 0.0223, 'lps'),
	(452113, 125, '2015-03-15 00:02:11.000000', 'consum', 0.0222, 'lps'),
	(452114, 125, '2015-03-15 00:02:12.000000', 'consum', 0.0214, 'lps'),
	(452115, 125, '2015-03-15 00:02:13.000000', 'consum', 0.0212, 'lps'),
	(452116, 125, '2015-03-15 00:02:14.000000', 'consum', 0.0210, 'lps'),
	(452117, 125, '2015-03-15 00:02:15.000000', 'consum', 0.0222, 'lps'),
	(452118, 125, '2015-03-15 00:02:16.000000', 'consum', 0.0215, 'lps'),
	(452119, 125, '2015-03-15 00:02:17.000000', 'consum', 0.0220, 'lps'),
	(452120, 125, '2015-03-15 00:02:18.000000', 'consum', 0.0226, 'lps'),
	(452121, 125, '2015-03-15 00:02:19.000000', 'consum', 0.0226, 'lps'),
	(452122, 125, '2015-03-15 00:02:20.000000', 'consum', 0.0225, 'lps'),
	(452123, 125, '2015-03-15 00:02:21.000000', 'consum', 0.0220, 'lps'),
	(452124, 125, '2015-03-15 00:02:22.000000', 'consum', 0.0215, 'lps'),
	(452125, 125, '2015-03-15 00:02:23.000000', 'consum', 0.0221, 'lps'),
	(452126, 125, '2015-03-15 00:02:24.000000', 'consum', 0.0216, 'lps'),
	(452127, 125, '2015-03-15 00:02:25.000000', 'consum', 0.0225, 'lps'),
	(452128, 125, '2015-03-15 00:02:26.000000', 'consum', 0.0216, 'lps'),
	(452129, 125, '2015-03-15 00:02:27.000000', 'consum', 0.0211, 'lps'),
	(452130, 125, '2015-03-15 00:02:28.000000', 'consum', 0.0216, 'lps'),
	(452131, 125, '2015-03-15 00:02:29.000000', 'consum', 0.0218, 'lps'),
	(452132, 125, '2015-03-15 00:02:30.000000', 'consum', 0.0214, 'lps'),
	(452133, 125, '2015-03-15 00:02:31.000000', 'consum', 0.0224, 'lps'),
	(452134, 125, '2015-03-15 00:02:32.000000', 'consum', 0.0214, 'lps'),
	(452135, 125, '2015-03-15 00:02:33.000000', 'consum', 0.0227, 'lps'),
	(452136, 125, '2015-03-15 00:02:34.000000', 'consum', 0.0227, 'lps'),
	(452137, 125, '2015-03-15 00:02:35.000000', 'consum', 0.0211, 'lps'),
	(452138, 125, '2015-03-15 00:02:36.000000', 'consum', 0.0216, 'lps'),
	(452139, 125, '2015-03-15 00:02:37.000000', 'consum', 0.0223, 'lps'),
	(452140, 125, '2015-03-15 00:02:38.000000', 'consum', 0.0218, 'lps'),
	(452141, 125, '2015-03-15 00:02:39.000000', 'consum', 0.0212, 'lps'),
	(452142, 125, '2015-03-15 00:02:40.000000', 'consum', 0.0215, 'lps'),
	(452143, 125, '2015-03-15 00:02:41.000000', 'consum', 0.0227, 'lps'),
	(452144, 125, '2015-03-15 00:02:42.000000', 'consum', 0.0212, 'lps'),
	(452145, 125, '2015-03-15 00:02:43.000000', 'consum', 0.0223, 'lps'),
	(452146, 125, '2015-03-15 00:02:44.000000', 'consum', 0.0215, 'lps'),
	(452147, 125, '2015-03-15 00:02:45.000000', 'consum', 0.0215, 'lps'),
	(452148, 125, '2015-03-15 00:02:46.000000', 'consum', 0.0221, 'lps'),
	(452149, 125, '2015-03-15 00:02:47.000000', 'consum', 0.0214, 'lps'),
	(452150, 125, '2015-03-15 00:02:48.000000', 'consum', 0.0214, 'lps'),
	(452151, 125, '2015-03-15 00:02:49.000000', 'consum', 0.0218, 'lps'),
	(452152, 125, '2015-03-15 00:02:50.000000', 'consum', 0.0223, 'lps'),
	(452153, 125, '2015-03-15 00:02:51.000000', 'consum', 0.0213, 'lps'),
	(452154, 125, '2015-03-15 00:02:52.000000', 'consum', 0.0222, 'lps'),
	(452155, 125, '2015-03-15 00:02:53.000000', 'consum', 0.0210, 'lps'),
	(452156, 125, '2015-03-15 00:02:54.000000', 'consum', 0.0226, 'lps'),
	(452157, 125, '2015-03-15 00:02:55.000000', 'consum', 0.0222, 'lps'),
	(452158, 125, '2015-03-15 00:02:56.000000', 'consum', 0.0219, 'lps'),
	(452159, 125, '2015-03-15 00:02:57.000000', 'consum', 0.0221, 'lps'),
	(452160, 125, '2015-03-15 00:02:58.000000', 'consum', 0.0219, 'lps'),
	(452161, 125, '2015-03-15 00:02:59.000000', 'consum', 0.0225, 'lps'),
	(452162, 125, '2015-03-15 00:03:00.000000', 'consum', 0.0223, 'lps'),
	(452163, 125, '2015-03-15 00:03:01.000000', 'consum', 0.0212, 'lps'),
	(452164, 125, '2015-03-15 00:03:02.000000', 'consum', 0.0217, 'lps'),
	(452165, 125, '2015-03-15 00:03:03.000000', 'consum', 0.0222, 'lps'),
	(452166, 125, '2015-03-15 00:03:04.000000', 'consum', 0.0212, 'lps'),
	(452167, 125, '2015-03-15 00:03:05.000000', 'consum', 0.0223, 'lps'),
	(452168, 125, '2015-03-15 00:03:06.000000', 'consum', 0.0216, 'lps'),
	(452169, 125, '2015-03-15 00:03:07.000000', 'consum', 0.0218, 'lps'),
	(452170, 125, '2015-03-15 00:03:08.000000', 'consum', 0.0213, 'lps'),
	(452171, 125, '2015-03-15 00:03:09.000000', 'consum', 0.0221, 'lps'),
	(452172, 125, '2015-03-15 00:03:10.000000', 'consum', 0.0219, 'lps'),
	(452173, 125, '2015-03-15 00:03:11.000000', 'consum', 0.0224, 'lps'),
	(452174, 125, '2015-03-15 00:03:12.000000', 'consum', 0.0218, 'lps'),
	(452175, 125, '2015-03-15 00:03:13.000000', 'consum', 0.0225, 'lps'),
	(452176, 125, '2015-03-15 00:03:14.000000', 'consum', 0.0226, 'lps'),
	(452177, 125, '2015-03-15 00:03:15.000000', 'consum', 0.0227, 'lps'),
	(452178, 125, '2015-03-15 00:03:16.000000', 'consum', 0.0212, 'lps'),
	(452179, 125, '2015-03-15 00:03:17.000000', 'consum', 0.0221, 'lps'),
	(452180, 125, '2015-03-15 00:03:18.000000', 'consum', 0.0227, 'lps'),
	(452181, 125, '2015-03-15 00:03:19.000000', 'consum', 0.0225, 'lps'),
	(452182, 125, '2015-03-15 00:03:20.000000', 'consum', 0.0216, 'lps'),
	(452183, 125, '2015-03-15 00:03:21.000000', 'consum', 0.0212, 'lps'),
	(452184, 125, '2015-03-15 00:03:22.000000', 'consum', 0.0222, 'lps'),
	(452185, 125, '2015-03-15 00:03:23.000000', 'consum', 0.0227, 'lps'),
	(452186, 125, '2015-03-15 00:03:24.000000', 'consum', 0.0223, 'lps'),
	(452187, 125, '2015-03-15 00:03:25.000000', 'consum', 0.0225, 'lps'),
	(452188, 125, '2015-03-15 00:03:26.000000', 'consum', 0.0211, 'lps'),
	(452189, 125, '2015-03-15 00:03:27.000000', 'consum', 0.0224, 'lps'),
	(452190, 125, '2015-03-15 00:03:28.000000', 'consum', 0.0222, 'lps'),
	(452191, 125, '2015-03-15 00:03:29.000000', 'consum', 0.0213, 'lps'),
	(452192, 125, '2015-03-15 00:03:30.000000', 'consum', 0.0224, 'lps'),
	(452193, 125, '2015-03-15 00:03:31.000000', 'consum', 0.0219, 'lps'),
	(452194, 125, '2015-03-15 00:03:32.000000', 'consum', 0.0213, 'lps'),
	(452195, 125, '2015-03-15 00:03:33.000000', 'consum', 0.0216, 'lps'),
	(452196, 125, '2015-03-15 00:03:34.000000', 'consum', 0.0212, 'lps'),
	(452197, 125, '2015-03-15 00:03:35.000000', 'consum', 0.0221, 'lps'),
	(452198, 125, '2015-03-15 00:03:36.000000', 'consum', 0.0223, 'lps'),
	(452199, 125, '2015-03-15 00:03:37.000000', 'consum', 0.0226, 'lps'),
	(452200, 125, '2015-03-15 00:03:38.000000', 'consum', 0.0216, 'lps'),
	(452201, 125, '2015-03-15 00:03:39.000000', 'consum', 0.0210, 'lps'),
	(452202, 125, '2015-03-15 00:03:40.000000', 'consum', 0.0210, 'lps'),
	(452203, 125, '2015-03-15 00:03:41.000000', 'consum', 0.0212, 'lps'),
	(452204, 125, '2015-03-15 00:03:42.000000', 'consum', 0.0220, 'lps'),
	(452205, 125, '2015-03-15 00:03:43.000000', 'consum', 0.0218, 'lps'),
	(452206, 125, '2015-03-15 00:03:44.000000', 'consum', 0.0221, 'lps'),
	(452207, 125, '2015-03-15 00:03:45.000000', 'consum', 0.0224, 'lps'),
	(452208, 125, '2015-03-15 00:03:46.000000', 'consum', 0.0213, 'lps'),
	(452209, 125, '2015-03-15 00:03:47.000000', 'consum', 0.0216, 'lps'),
	(452210, 125, '2015-03-15 00:03:48.000000', 'consum', 0.0216, 'lps'),
	(452211, 125, '2015-03-15 00:03:49.000000', 'consum', 0.0220, 'lps'),
	(452212, 125, '2015-03-15 00:03:50.000000', 'consum', 0.0225, 'lps'),
	(452213, 125, '2015-03-15 00:03:51.000000', 'consum', 0.0222, 'lps'),
	(452214, 125, '2015-03-15 00:03:52.000000', 'consum', 0.0224, 'lps'),
	(452215, 125, '2015-03-15 00:03:53.000000', 'consum', 0.0225, 'lps'),
	(452216, 125, '2015-03-15 00:03:54.000000', 'consum', 0.0210, 'lps'),
	(452217, 125, '2015-03-15 00:03:55.000000', 'consum', 0.0220, 'lps'),
	(452218, 125, '2015-03-15 00:03:56.000000', 'consum', 0.0225, 'lps'),
	(452219, 125, '2015-03-15 00:03:57.000000', 'consum', 0.0219, 'lps'),
	(452220, 125, '2015-03-15 00:03:58.000000', 'consum', 0.0226, 'lps'),
	(452221, 125, '2015-03-15 00:03:59.000000', 'consum', 0.0212, 'lps'),
	(452222, 125, '2015-03-15 00:04:00.000000', 'consum', 0.0225, 'lps'),
	(452223, 125, '2015-03-15 00:04:01.000000', 'consum', 0.0226, 'lps'),
	(452224, 125, '2015-03-15 00:04:02.000000', 'consum', 0.0210, 'lps'),
	(452225, 125, '2015-03-15 00:04:03.000000', 'consum', 0.0218, 'lps'),
	(452226, 125, '2015-03-15 00:04:04.000000', 'consum', 0.0214, 'lps'),
	(452227, 125, '2015-03-15 00:04:05.000000', 'consum', 0.0224, 'lps'),
	(452228, 125, '2015-03-15 00:04:06.000000', 'consum', 0.0213, 'lps'),
	(452229, 125, '2015-03-15 00:04:07.000000', 'consum', 0.0220, 'lps'),
	(452230, 125, '2015-03-15 00:04:08.000000', 'consum', 0.0218, 'lps'),
	(452231, 125, '2015-03-15 00:04:09.000000', 'consum', 0.0218, 'lps'),
	(452232, 125, '2015-03-15 00:04:10.000000', 'consum', 0.0226, 'lps'),
	(452233, 125, '2015-03-15 00:04:11.000000', 'consum', 0.0215, 'lps'),
	(452234, 125, '2015-03-15 00:04:12.000000', 'consum', 0.0221, 'lps'),
	(452235, 125, '2015-03-15 00:04:13.000000', 'consum', 0.0215, 'lps'),
	(452236, 125, '2015-03-15 00:04:14.000000', 'consum', 0.0223, 'lps'),
	(452237, 125, '2015-03-15 00:04:15.000000', 'consum', 0.0223, 'lps'),
	(452238, 125, '2015-03-15 00:04:16.000000', 'consum', 0.0217, 'lps'),
	(452239, 125, '2015-03-15 00:04:17.000000', 'consum', 0.0227, 'lps'),
	(452240, 125, '2015-03-15 00:04:18.000000', 'consum', 0.0221, 'lps'),
	(452241, 125, '2015-03-15 00:04:19.000000', 'consum', 0.0213, 'lps'),
	(452242, 125, '2015-03-15 00:04:20.000000', 'consum', 0.0210, 'lps'),
	(452243, 125, '2015-03-15 00:04:21.000000', 'consum', 0.0221, 'lps'),
	(452244, 125, '2015-03-15 00:04:22.000000', 'consum', 0.0212, 'lps'),
	(452245, 125, '2015-03-15 00:04:23.000000', 'consum', 0.0221, 'lps'),
	(452246, 125, '2015-03-15 00:04:24.000000', 'consum', 0.0225, 'lps'),
	(452247, 125, '2015-03-15 00:04:25.000000', 'consum', 0.0215, 'lps'),
	(452248, 125, '2015-03-15 00:04:26.000000', 'consum', 0.0211, 'lps'),
	(452249, 125, '2015-03-15 00:04:27.000000', 'consum', 0.0217, 'lps'),
	(452250, 125, '2015-03-15 00:04:28.000000', 'consum', 0.0224, 'lps'),
	(452251, 125, '2015-03-15 00:04:29.000000', 'consum', 0.0226, 'lps'),
	(452252, 125, '2015-03-15 00:04:30.000000', 'consum', 0.0227, 'lps'),
	(452253, 125, '2015-03-15 00:04:31.000000', 'consum', 0.0214, 'lps'),
	(452254, 125, '2015-03-15 00:04:32.000000', 'consum', 0.0215, 'lps'),
	(452255, 125, '2015-03-15 00:04:33.000000', 'consum', 0.0223, 'lps'),
	(452256, 125, '2015-03-15 00:04:34.000000', 'consum', 0.0224, 'lps'),
	(452257, 125, '2015-03-15 00:04:35.000000', 'consum', 0.0225, 'lps'),
	(452258, 125, '2015-03-15 00:04:36.000000', 'consum', 0.0225, 'lps'),
	(452259, 125, '2015-03-15 00:04:37.000000', 'consum', 0.0221, 'lps'),
	(452260, 125, '2015-03-15 00:04:38.000000', 'consum', 0.0220, 'lps'),
	(452261, 125, '2015-03-15 00:04:39.000000', 'consum', 0.0227, 'lps'),
	(452262, 125, '2015-03-15 00:04:40.000000', 'consum', 0.0214, 'lps'),
	(452263, 125, '2015-03-15 00:04:41.000000', 'consum', 0.0213, 'lps'),
	(452264, 125, '2015-03-15 00:04:42.000000', 'consum', 0.0213, 'lps'),
	(452265, 125, '2015-03-15 00:04:43.000000', 'consum', 0.0218, 'lps'),
	(452266, 125, '2015-03-15 00:04:44.000000', 'consum', 0.0225, 'lps'),
	(452267, 125, '2015-03-15 00:04:45.000000', 'consum', 0.0225, 'lps'),
	(452268, 125, '2015-03-15 00:04:46.000000', 'consum', 0.0222, 'lps'),
	(452269, 125, '2015-03-15 00:04:47.000000', 'consum', 0.0225, 'lps'),
	(452270, 125, '2015-03-15 00:04:48.000000', 'consum', 0.0216, 'lps'),
	(452271, 125, '2015-03-15 00:04:49.000000', 'consum', 0.0210, 'lps'),
	(452272, 125, '2015-03-15 00:04:50.000000', 'consum', 0.0213, 'lps'),
	(452273, 125, '2015-03-15 00:04:51.000000', 'consum', 0.0224, 'lps'),
	(452274, 125, '2015-03-15 00:04:52.000000', 'consum', 0.0219, 'lps'),
	(452275, 125, '2015-03-15 00:04:53.000000', 'consum', 0.0212, 'lps'),
	(452276, 125, '2015-03-15 00:04:54.000000', 'consum', 0.0214, 'lps'),
	(452277, 125, '2015-03-15 00:04:55.000000', 'consum', 0.0222, 'lps'),
	(452278, 125, '2015-03-15 00:04:56.000000', 'consum', 0.0223, 'lps'),
	(452279, 125, '2015-03-15 00:04:57.000000', 'consum', 0.0222, 'lps'),
	(452280, 125, '2015-03-15 00:04:58.000000', 'consum', 0.0214, 'lps'),
	(452281, 125, '2015-03-15 00:04:59.000000', 'consum', 0.0211, 'lps'),
	(452282, 125, '2015-03-15 00:05:00.000000', 'consum', 0.0220, 'lps'),
	(452283, 125, '2015-03-15 00:05:01.000000', 'consum', 0.0224, 'lps'),
	(452284, 125, '2015-03-15 00:05:02.000000', 'consum', 0.0214, 'lps'),
	(452285, 125, '2015-03-15 00:05:03.000000', 'consum', 0.0226, 'lps'),
	(452286, 125, '2015-03-15 00:05:04.000000', 'consum', 0.0224, 'lps'),
	(452287, 125, '2015-03-15 00:05:05.000000', 'consum', 0.0215, 'lps'),
	(452288, 125, '2015-03-15 00:05:06.000000', 'consum', 0.0227, 'lps'),
	(452289, 125, '2015-03-15 00:05:07.000000', 'consum', 0.0210, 'lps'),
	(452290, 125, '2015-03-15 00:05:08.000000', 'consum', 0.0213, 'lps'),
	(452291, 125, '2015-03-15 00:05:09.000000', 'consum', 0.0227, 'lps'),
	(452292, 125, '2015-03-15 00:05:10.000000', 'consum', 0.0213, 'lps'),
	(452293, 125, '2015-03-15 00:05:11.000000', 'consum', 0.0227, 'lps'),
	(452294, 125, '2015-03-15 00:05:12.000000', 'consum', 0.0217, 'lps'),
	(452295, 125, '2015-03-15 00:05:13.000000', 'consum', 0.0211, 'lps'),
	(452296, 125, '2015-03-15 00:05:14.000000', 'consum', 0.0215, 'lps'),
	(452297, 125, '2015-03-15 00:05:15.000000', 'consum', 0.0212, 'lps'),
	(452298, 125, '2015-03-15 00:05:16.000000', 'consum', 0.0226, 'lps'),
	(452299, 125, '2015-03-15 00:05:17.000000', 'consum', 0.0212, 'lps'),
	(452300, 125, '2015-03-15 00:05:18.000000', 'consum', 0.0210, 'lps'),
	(452301, 125, '2015-03-15 00:05:19.000000', 'consum', 0.0221, 'lps'),
	(452302, 125, '2015-03-15 00:05:20.000000', 'consum', 0.0211, 'lps'),
	(452303, 125, '2015-03-15 00:05:21.000000', 'consum', 0.0220, 'lps'),
	(452304, 125, '2015-03-15 00:05:22.000000', 'consum', 0.0220, 'lps'),
	(452305, 125, '2015-03-15 00:05:23.000000', 'consum', 0.0214, 'lps'),
	(452306, 125, '2015-03-15 00:05:24.000000', 'consum', 0.0218, 'lps'),
	(452307, 125, '2015-03-15 00:05:25.000000', 'consum', 0.0218, 'lps'),
	(452308, 125, '2015-03-15 00:05:26.000000', 'consum', 0.0211, 'lps'),
	(452309, 125, '2015-03-15 00:05:27.000000', 'consum', 0.0211, 'lps'),
	(452310, 125, '2015-03-15 00:05:28.000000', 'consum', 0.0210, 'lps'),
	(452311, 125, '2015-03-15 00:05:29.000000', 'consum', 0.0210, 'lps'),
	(452312, 125, '2015-03-15 00:05:30.000000', 'consum', 0.0226, 'lps'),
	(452313, 125, '2015-03-15 00:05:31.000000', 'consum', 0.0217, 'lps'),
	(452314, 125, '2015-03-15 00:05:32.000000', 'consum', 0.0219, 'lps'),
	(452315, 125, '2015-03-15 00:05:33.000000', 'consum', 0.0216, 'lps'),
	(452316, 125, '2015-03-15 00:05:34.000000', 'consum', 0.0212, 'lps'),
	(452317, 125, '2015-03-15 00:05:35.000000', 'consum', 0.0221, 'lps'),
	(452318, 125, '2015-03-15 00:05:36.000000', 'consum', 0.0223, 'lps'),
	(452319, 125, '2015-03-15 00:05:37.000000', 'consum', 0.0226, 'lps'),
	(452320, 125, '2015-03-15 00:05:38.000000', 'consum', 0.0214, 'lps'),
	(452321, 125, '2015-03-15 00:05:39.000000', 'consum', 0.0220, 'lps'),
	(452322, 125, '2015-03-15 00:05:40.000000', 'consum', 0.0213, 'lps'),
	(452323, 125, '2015-03-15 00:05:41.000000', 'consum', 0.0213, 'lps'),
	(452324, 125, '2015-03-15 00:05:42.000000', 'consum', 0.0215, 'lps'),
	(452325, 125, '2015-03-15 00:05:43.000000', 'consum', 0.0210, 'lps'),
	(452326, 125, '2015-03-15 00:05:44.000000', 'consum', 0.0212, 'lps'),
	(452327, 125, '2015-03-15 00:05:45.000000', 'consum', 0.0222, 'lps'),
	(452328, 125, '2015-03-15 00:05:46.000000', 'consum', 0.0210, 'lps'),
	(452329, 125, '2015-03-15 00:05:47.000000', 'consum', 0.0212, 'lps'),
	(452330, 125, '2015-03-15 00:05:48.000000', 'consum', 0.0221, 'lps'),
	(452331, 125, '2015-03-15 00:05:49.000000', 'consum', 0.0224, 'lps'),
	(452332, 125, '2015-03-15 00:05:50.000000', 'consum', 0.0227, 'lps'),
	(452333, 125, '2015-03-15 00:05:51.000000', 'consum', 0.0217, 'lps'),
	(452334, 125, '2015-03-15 00:05:52.000000', 'consum', 0.0215, 'lps'),
	(452335, 125, '2015-03-15 00:05:53.000000', 'consum', 0.0215, 'lps'),
	(452336, 125, '2015-03-15 00:05:54.000000', 'consum', 0.0220, 'lps'),
	(452337, 125, '2015-03-15 00:05:55.000000', 'consum', 0.0210, 'lps'),
	(452338, 125, '2015-03-15 00:05:56.000000', 'consum', 0.0217, 'lps'),
	(452339, 125, '2015-03-15 00:05:57.000000', 'consum', 0.0226, 'lps'),
	(452340, 125, '2015-03-15 00:05:58.000000', 'consum', 0.0218, 'lps'),
	(452341, 125, '2015-03-15 00:05:59.000000', 'consum', 0.0217, 'lps'),
	(452342, 125, '2015-03-15 00:06:00.000000', 'consum', 0.0223, 'lps'),
	(452343, 125, '2015-03-15 00:06:01.000000', 'consum', 0.0220, 'lps'),
	(452344, 125, '2015-03-15 00:06:02.000000', 'consum', 0.0222, 'lps'),
	(452345, 125, '2015-03-15 00:06:03.000000', 'consum', 0.0221, 'lps'),
	(452346, 125, '2015-03-15 00:06:04.000000', 'consum', 0.0210, 'lps'),
	(452347, 125, '2015-03-15 00:06:05.000000', 'consum', 0.0213, 'lps'),
	(452348, 125, '2015-03-15 00:06:06.000000', 'consum', 0.0211, 'lps'),
	(452349, 125, '2015-03-15 00:06:07.000000', 'consum', 0.0221, 'lps'),
	(452350, 125, '2015-03-15 00:06:08.000000', 'consum', 0.0210, 'lps'),
	(452351, 125, '2015-03-15 00:06:09.000000', 'consum', 0.0212, 'lps'),
	(452352, 125, '2015-03-15 00:06:10.000000', 'consum', 0.0223, 'lps'),
	(452353, 125, '2015-03-15 00:06:11.000000', 'consum', 0.0213, 'lps'),
	(452354, 125, '2015-03-15 00:06:12.000000', 'consum', 0.0224, 'lps'),
	(452355, 125, '2015-03-15 00:06:13.000000', 'consum', 0.0217, 'lps'),
	(452356, 125, '2015-03-15 00:06:14.000000', 'consum', 0.0220, 'lps'),
	(452357, 125, '2015-03-15 00:06:15.000000', 'consum', 0.0221, 'lps'),
	(452358, 125, '2015-03-15 00:06:16.000000', 'consum', 0.0221, 'lps'),
	(452359, 125, '2015-03-15 00:06:17.000000', 'consum', 0.0211, 'lps'),
	(452360, 125, '2015-03-15 00:06:18.000000', 'consum', 0.0219, 'lps'),
	(452361, 125, '2015-03-15 00:06:19.000000', 'consum', 0.0219, 'lps'),
	(452362, 125, '2015-03-15 00:06:20.000000', 'consum', 0.0226, 'lps'),
	(452363, 125, '2015-03-15 00:06:21.000000', 'consum', 0.0211, 'lps'),
	(452364, 125, '2015-03-15 00:06:22.000000', 'consum', 0.0222, 'lps'),
	(452365, 125, '2015-03-15 00:06:23.000000', 'consum', 0.0211, 'lps'),
	(452366, 125, '2015-03-15 00:06:24.000000', 'consum', 0.0216, 'lps'),
	(452367, 125, '2015-03-15 00:06:25.000000', 'consum', 0.0221, 'lps'),
	(452368, 125, '2015-03-15 00:06:26.000000', 'consum', 0.0212, 'lps'),
	(452369, 125, '2015-03-15 00:06:27.000000', 'consum', 0.0223, 'lps'),
	(452370, 125, '2015-03-15 00:06:28.000000', 'consum', 0.0215, 'lps'),
	(452371, 125, '2015-03-15 00:06:29.000000', 'consum', 0.0217, 'lps'),
	(452372, 125, '2015-03-15 00:06:30.000000', 'consum', 0.0227, 'lps'),
	(452373, 125, '2015-03-15 00:06:31.000000', 'consum', 0.0221, 'lps'),
	(452374, 125, '2015-03-15 00:06:32.000000', 'consum', 0.0217, 'lps'),
	(452375, 125, '2015-03-15 00:06:33.000000', 'consum', 0.0211, 'lps'),
	(452376, 125, '2015-03-15 00:06:34.000000', 'consum', 0.0212, 'lps'),
	(452377, 125, '2015-03-15 00:06:35.000000', 'consum', 0.0220, 'lps'),
	(452378, 125, '2015-03-15 00:06:36.000000', 'consum', 0.0216, 'lps'),
	(452379, 125, '2015-03-15 00:06:37.000000', 'consum', 0.0213, 'lps'),
	(452380, 125, '2015-03-15 00:06:38.000000', 'consum', 0.0224, 'lps'),
	(452381, 125, '2015-03-15 00:06:39.000000', 'consum', 0.0219, 'lps'),
	(452382, 125, '2015-03-15 00:06:40.000000', 'consum', 0.0211, 'lps'),
	(452383, 125, '2015-03-15 00:06:41.000000', 'consum', 0.0224, 'lps'),
	(452384, 125, '2015-03-15 00:06:42.000000', 'consum', 0.0226, 'lps'),
	(452385, 125, '2015-03-15 00:06:43.000000', 'consum', 0.0213, 'lps'),
	(452386, 125, '2015-03-15 00:06:44.000000', 'consum', 0.0211, 'lps'),
	(452387, 125, '2015-03-15 00:06:45.000000', 'consum', 0.0225, 'lps'),
	(452388, 125, '2015-03-15 00:06:46.000000', 'consum', 0.0211, 'lps'),
	(452389, 125, '2015-03-15 00:06:47.000000', 'consum', 0.0225, 'lps'),
	(452390, 125, '2015-03-15 00:06:48.000000', 'consum', 0.0211, 'lps'),
	(452391, 125, '2015-03-15 00:06:49.000000', 'consum', 0.0224, 'lps'),
	(452392, 125, '2015-03-15 00:06:50.000000', 'consum', 0.0225, 'lps'),
	(452393, 125, '2015-03-15 00:06:51.000000', 'consum', 0.0225, 'lps'),
	(452394, 125, '2015-03-15 00:06:52.000000', 'consum', 0.0222, 'lps'),
	(452395, 125, '2015-03-15 00:06:53.000000', 'consum', 0.0227, 'lps'),
	(452396, 125, '2015-03-15 00:06:54.000000', 'consum', 0.0224, 'lps'),
	(452397, 125, '2015-03-15 00:06:55.000000', 'consum', 0.0212, 'lps'),
	(452398, 125, '2015-03-15 00:06:56.000000', 'consum', 0.0215, 'lps'),
	(452399, 125, '2015-03-15 00:06:57.000000', 'consum', 0.0212, 'lps'),
	(452400, 125, '2015-03-15 00:06:58.000000', 'consum', 0.0224, 'lps'),
	(452401, 125, '2015-03-15 00:06:59.000000', 'consum', 0.0218, 'lps'),
	(452402, 125, '2015-03-15 00:07:00.000000', 'consum', 0.0211, 'lps'),
	(452403, 125, '2015-03-15 00:07:01.000000', 'consum', 0.0226, 'lps'),
	(452404, 125, '2015-03-15 00:07:02.000000', 'consum', 0.0217, 'lps'),
	(452405, 125, '2015-03-15 00:07:03.000000', 'consum', 0.0216, 'lps'),
	(452406, 125, '2015-03-15 00:07:04.000000', 'consum', 0.0217, 'lps'),
	(452407, 125, '2015-03-15 00:07:05.000000', 'consum', 0.0226, 'lps'),
	(452408, 125, '2015-03-15 00:07:06.000000', 'consum', 0.0219, 'lps'),
	(452409, 125, '2015-03-15 00:07:07.000000', 'consum', 0.0226, 'lps'),
	(452410, 125, '2015-03-15 00:07:08.000000', 'consum', 0.0227, 'lps'),
	(452411, 125, '2015-03-15 00:07:09.000000', 'consum', 0.0210, 'lps'),
	(452412, 125, '2015-03-15 00:07:10.000000', 'consum', 0.0215, 'lps'),
	(452413, 125, '2015-03-15 00:07:11.000000', 'consum', 0.0215, 'lps'),
	(452414, 125, '2015-03-15 00:07:12.000000', 'consum', 0.0223, 'lps'),
	(452415, 125, '2015-03-15 00:07:13.000000', 'consum', 0.0226, 'lps'),
	(452416, 125, '2015-03-15 00:07:14.000000', 'consum', 0.0213, 'lps'),
	(452417, 125, '2015-03-15 00:07:15.000000', 'consum', 0.0214, 'lps'),
	(452418, 125, '2015-03-15 00:07:16.000000', 'consum', 0.0224, 'lps'),
	(452419, 125, '2015-03-15 00:07:17.000000', 'consum', 0.0211, 'lps'),
	(452420, 125, '2015-03-15 00:07:18.000000', 'consum', 0.0211, 'lps'),
	(452421, 125, '2015-03-15 00:07:19.000000', 'consum', 0.0212, 'lps'),
	(452422, 125, '2015-03-15 00:07:20.000000', 'consum', 0.0219, 'lps'),
	(452423, 125, '2015-03-15 00:07:21.000000', 'consum', 0.0212, 'lps'),
	(452424, 125, '2015-03-15 00:07:22.000000', 'consum', 0.0210, 'lps'),
	(452425, 125, '2015-03-15 00:07:23.000000', 'consum', 0.0224, 'lps'),
	(452426, 125, '2015-03-15 00:07:24.000000', 'consum', 0.0225, 'lps'),
	(452427, 125, '2015-03-15 00:07:25.000000', 'consum', 0.0210, 'lps'),
	(452428, 125, '2015-03-15 00:07:26.000000', 'consum', 0.0220, 'lps'),
	(452429, 125, '2015-03-15 00:07:27.000000', 'consum', 0.0223, 'lps'),
	(452430, 125, '2015-03-15 00:07:28.000000', 'consum', 0.0227, 'lps'),
	(452431, 125, '2015-03-15 00:07:29.000000', 'consum', 0.0223, 'lps'),
	(452432, 125, '2015-03-15 00:07:30.000000', 'consum', 0.0223, 'lps'),
	(452433, 125, '2015-03-15 00:07:31.000000', 'consum', 0.0217, 'lps'),
	(452434, 125, '2015-03-15 00:07:32.000000', 'consum', 0.0226, 'lps'),
	(452435, 125, '2015-03-15 00:07:33.000000', 'consum', 0.0215, 'lps'),
	(452436, 125, '2015-03-15 00:07:34.000000', 'consum', 0.0225, 'lps'),
	(452437, 125, '2015-03-15 00:07:35.000000', 'consum', 0.0214, 'lps'),
	(452438, 125, '2015-03-15 00:07:36.000000', 'consum', 0.0223, 'lps'),
	(452439, 125, '2015-03-15 00:07:37.000000', 'consum', 0.0211, 'lps'),
	(452440, 125, '2015-03-15 00:07:38.000000', 'consum', 0.0210, 'lps'),
	(452441, 125, '2015-03-15 00:07:39.000000', 'consum', 0.0227, 'lps'),
	(452442, 125, '2015-03-15 00:07:40.000000', 'consum', 0.0223, 'lps'),
	(452443, 125, '2015-03-15 00:07:41.000000', 'consum', 0.0225, 'lps'),
	(452444, 125, '2015-03-15 00:07:42.000000', 'consum', 0.0210, 'lps'),
	(452445, 125, '2015-03-15 00:07:43.000000', 'consum', 0.0218, 'lps'),
	(452446, 125, '2015-03-15 00:07:44.000000', 'consum', 0.0216, 'lps'),
	(452447, 125, '2015-03-15 00:07:45.000000', 'consum', 0.0218, 'lps'),
	(452448, 125, '2015-03-15 00:07:46.000000', 'consum', 0.0213, 'lps'),
	(452449, 125, '2015-03-15 00:07:47.000000', 'consum', 0.0219, 'lps'),
	(452450, 125, '2015-03-15 00:07:48.000000', 'consum', 0.0227, 'lps'),
	(452451, 125, '2015-03-15 00:07:49.000000', 'consum', 0.0216, 'lps'),
	(452452, 125, '2015-03-15 00:07:50.000000', 'consum', 0.0227, 'lps'),
	(452453, 125, '2015-03-15 00:07:51.000000', 'consum', 0.0224, 'lps'),
	(452454, 125, '2015-03-15 00:07:52.000000', 'consum', 0.0227, 'lps'),
	(452455, 125, '2015-03-15 00:07:53.000000', 'consum', 0.0219, 'lps'),
	(452456, 125, '2015-03-15 00:07:54.000000', 'consum', 0.0221, 'lps'),
	(452457, 125, '2015-03-15 00:07:55.000000', 'consum', 0.0220, 'lps'),
	(452458, 125, '2015-03-15 00:07:56.000000', 'consum', 0.0227, 'lps'),
	(452459, 125, '2015-03-15 00:07:57.000000', 'consum', 0.0211, 'lps'),
	(452460, 125, '2015-03-15 00:07:58.000000', 'consum', 0.0221, 'lps'),
	(452461, 125, '2015-03-15 00:07:59.000000', 'consum', 0.0226, 'lps'),
	(452462, 125, '2015-03-15 00:08:00.000000', 'consum', 0.0221, 'lps'),
	(452463, 125, '2015-03-15 00:08:01.000000', 'consum', 0.0216, 'lps'),
	(452464, 125, '2015-03-15 00:08:02.000000', 'consum', 0.0227, 'lps'),
	(452465, 125, '2015-03-15 00:08:03.000000', 'consum', 0.0223, 'lps'),
	(452466, 125, '2015-03-15 00:08:04.000000', 'consum', 0.0227, 'lps'),
	(452467, 125, '2015-03-15 00:08:05.000000', 'consum', 0.0217, 'lps'),
	(452468, 125, '2015-03-15 00:08:06.000000', 'consum', 0.0214, 'lps'),
	(452469, 125, '2015-03-15 00:08:07.000000', 'consum', 0.0226, 'lps'),
	(452470, 125, '2015-03-15 00:08:08.000000', 'consum', 0.0224, 'lps'),
	(452471, 125, '2015-03-15 00:08:09.000000', 'consum', 0.0215, 'lps'),
	(452472, 125, '2015-03-15 00:08:10.000000', 'consum', 0.0213, 'lps'),
	(452473, 125, '2015-03-15 00:08:11.000000', 'consum', 0.0226, 'lps'),
	(452474, 125, '2015-03-15 00:08:12.000000', 'consum', 0.0227, 'lps'),
	(452475, 125, '2015-03-15 00:08:13.000000', 'consum', 0.0213, 'lps'),
	(452476, 125, '2015-03-15 00:08:14.000000', 'consum', 0.0226, 'lps'),
	(452477, 125, '2015-03-15 00:08:15.000000', 'consum', 0.0212, 'lps'),
	(452478, 125, '2015-03-15 00:08:16.000000', 'consum', 0.0226, 'lps'),
	(452479, 125, '2015-03-15 00:08:17.000000', 'consum', 0.0214, 'lps'),
	(452480, 125, '2015-03-15 00:08:18.000000', 'consum', 0.0218, 'lps'),
	(452481, 125, '2015-03-15 00:08:19.000000', 'consum', 0.0218, 'lps'),
	(452482, 125, '2015-03-15 00:08:20.000000', 'consum', 0.0211, 'lps'),
	(452483, 125, '2015-03-15 00:08:21.000000', 'consum', 0.0226, 'lps'),
	(452484, 125, '2015-03-15 00:08:22.000000', 'consum', 0.0214, 'lps'),
	(452485, 125, '2015-03-15 00:08:23.000000', 'consum', 0.0221, 'lps'),
	(452486, 125, '2015-03-15 00:08:24.000000', 'consum', 0.0216, 'lps'),
	(452487, 125, '2015-03-15 00:08:25.000000', 'consum', 0.0226, 'lps'),
	(452488, 125, '2015-03-15 00:08:26.000000', 'consum', 0.0218, 'lps'),
	(452489, 125, '2015-03-15 00:08:27.000000', 'consum', 0.0223, 'lps'),
	(452490, 125, '2015-03-15 00:08:28.000000', 'consum', 0.0213, 'lps'),
	(452491, 125, '2015-03-15 00:08:29.000000', 'consum', 0.0223, 'lps'),
	(452492, 125, '2015-03-15 00:08:30.000000', 'consum', 0.0212, 'lps'),
	(452493, 125, '2015-03-15 00:08:31.000000', 'consum', 0.0217, 'lps'),
	(452494, 125, '2015-03-15 00:08:32.000000', 'consum', 0.0222, 'lps'),
	(452495, 125, '2015-03-15 00:08:33.000000', 'consum', 0.0212, 'lps'),
	(452496, 125, '2015-03-15 00:08:34.000000', 'consum', 0.0220, 'lps'),
	(452497, 125, '2015-03-15 00:08:35.000000', 'consum', 0.0218, 'lps'),
	(452498, 125, '2015-03-15 00:08:36.000000', 'consum', 0.0223, 'lps'),
	(452499, 125, '2015-03-15 00:08:37.000000', 'consum', 0.0216, 'lps'),
	(452500, 125, '2015-03-15 00:08:38.000000', 'consum', 0.0217, 'lps'),
	(452501, 125, '2015-03-15 00:08:39.000000', 'consum', 0.0226, 'lps'),
	(452502, 125, '2015-03-15 00:08:40.000000', 'consum', 0.0219, 'lps'),
	(452503, 125, '2015-03-15 00:08:41.000000', 'consum', 0.0224, 'lps'),
	(452504, 125, '2015-03-15 00:08:42.000000', 'consum', 0.0219, 'lps'),
	(452505, 125, '2015-03-15 00:08:43.000000', 'consum', 0.0211, 'lps'),
	(452506, 125, '2015-03-15 00:08:44.000000', 'consum', 0.0226, 'lps'),
	(452507, 125, '2015-03-15 00:08:45.000000', 'consum', 0.0217, 'lps'),
	(452508, 125, '2015-03-15 00:08:46.000000', 'consum', 0.0214, 'lps'),
	(452509, 125, '2015-03-15 00:08:47.000000', 'consum', 0.0227, 'lps'),
	(452510, 125, '2015-03-15 00:08:48.000000', 'consum', 0.0213, 'lps'),
	(452511, 125, '2015-03-15 00:08:49.000000', 'consum', 0.0210, 'lps'),
	(452512, 125, '2015-03-15 00:08:50.000000', 'consum', 0.0219, 'lps'),
	(452513, 125, '2015-03-15 00:08:51.000000', 'consum', 0.0220, 'lps'),
	(452514, 125, '2015-03-15 00:08:52.000000', 'consum', 0.0216, 'lps'),
	(452515, 125, '2015-03-15 00:08:53.000000', 'consum', 0.0226, 'lps'),
	(452516, 125, '2015-03-15 00:08:54.000000', 'consum', 0.0221, 'lps'),
	(452517, 125, '2015-03-15 00:08:55.000000', 'consum', 0.0216, 'lps'),
	(452518, 125, '2015-03-15 00:08:56.000000', 'consum', 0.0226, 'lps'),
	(452519, 125, '2015-03-15 00:08:57.000000', 'consum', 0.0219, 'lps'),
	(452520, 125, '2015-03-15 00:08:58.000000', 'consum', 0.0227, 'lps'),
	(452521, 125, '2015-03-15 00:08:59.000000', 'consum', 0.0212, 'lps'),
	(452522, 125, '2015-03-15 00:09:00.000000', 'consum', 0.0226, 'lps'),
	(452523, 125, '2015-03-15 00:09:01.000000', 'consum', 0.0213, 'lps'),
	(452524, 125, '2015-03-15 00:09:02.000000', 'consum', 0.0213, 'lps'),
	(452525, 125, '2015-03-15 00:09:03.000000', 'consum', 0.0216, 'lps'),
	(452526, 125, '2015-03-15 00:09:04.000000', 'consum', 0.0212, 'lps'),
	(452527, 125, '2015-03-15 00:09:05.000000', 'consum', 0.0222, 'lps'),
	(452528, 125, '2015-03-15 00:09:06.000000', 'consum', 0.0227, 'lps'),
	(452529, 125, '2015-03-15 00:09:07.000000', 'consum', 0.0225, 'lps'),
	(452530, 125, '2015-03-15 00:09:08.000000', 'consum', 0.0217, 'lps'),
	(452531, 125, '2015-03-15 00:09:09.000000', 'consum', 0.0218, 'lps'),
	(452532, 125, '2015-03-15 00:09:10.000000', 'consum', 0.0213, 'lps'),
	(452533, 125, '2015-03-15 00:09:11.000000', 'consum', 0.0217, 'lps'),
	(452534, 125, '2015-03-15 00:09:12.000000', 'consum', 0.0218, 'lps'),
	(452535, 125, '2015-03-15 00:09:13.000000', 'consum', 0.0214, 'lps'),
	(452536, 125, '2015-03-15 00:09:14.000000', 'consum', 0.0221, 'lps'),
	(452537, 125, '2015-03-15 00:09:15.000000', 'consum', 0.0221, 'lps'),
	(452538, 125, '2015-03-15 00:09:16.000000', 'consum', 0.0213, 'lps'),
	(452539, 125, '2015-03-15 00:09:17.000000', 'consum', 0.0227, 'lps'),
	(452540, 125, '2015-03-15 00:09:18.000000', 'consum', 0.0215, 'lps'),
	(452541, 125, '2015-03-15 00:09:19.000000', 'consum', 0.0221, 'lps'),
	(452542, 125, '2015-03-15 00:09:20.000000', 'consum', 0.0215, 'lps'),
	(452543, 125, '2015-03-15 00:09:21.000000', 'consum', 0.0218, 'lps'),
	(452544, 125, '2015-03-15 00:09:22.000000', 'consum', 0.0220, 'lps'),
	(452545, 125, '2015-03-15 00:09:23.000000', 'consum', 0.0220, 'lps'),
	(452546, 125, '2015-03-15 00:09:24.000000', 'consum', 0.0211, 'lps'),
	(452547, 125, '2015-03-15 00:09:25.000000', 'consum', 0.0220, 'lps'),
	(452548, 125, '2015-03-15 00:09:26.000000', 'consum', 0.0224, 'lps'),
	(452549, 125, '2015-03-15 00:09:27.000000', 'consum', 0.0213, 'lps'),
	(452550, 125, '2015-03-15 00:09:28.000000', 'consum', 0.0219, 'lps'),
	(452551, 125, '2015-03-15 00:09:29.000000', 'consum', 0.0212, 'lps'),
	(452552, 125, '2015-03-15 00:09:30.000000', 'consum', 0.0211, 'lps'),
	(452553, 125, '2015-03-15 00:09:31.000000', 'consum', 0.0227, 'lps'),
	(452554, 125, '2015-03-15 00:09:32.000000', 'consum', 0.0223, 'lps'),
	(452555, 125, '2015-03-15 00:09:33.000000', 'consum', 0.0222, 'lps'),
	(452556, 125, '2015-03-15 00:09:34.000000', 'consum', 0.0215, 'lps'),
	(452557, 125, '2015-03-15 00:09:35.000000', 'consum', 0.0219, 'lps'),
	(452558, 125, '2015-03-15 00:09:36.000000', 'consum', 0.0221, 'lps'),
	(452559, 125, '2015-03-15 00:09:37.000000', 'consum', 0.0218, 'lps'),
	(452560, 125, '2015-03-15 00:09:38.000000', 'consum', 0.0221, 'lps'),
	(452561, 125, '2015-03-15 00:09:39.000000', 'consum', 0.0224, 'lps'),
	(452562, 125, '2015-03-15 00:09:40.000000', 'consum', 0.0227, 'lps'),
	(452563, 125, '2015-03-15 00:09:41.000000', 'consum', 0.0219, 'lps'),
	(452564, 125, '2015-03-15 00:09:42.000000', 'consum', 0.0224, 'lps'),
	(452565, 125, '2015-03-15 00:09:43.000000', 'consum', 0.0214, 'lps'),
	(452566, 125, '2015-03-15 00:09:44.000000', 'consum', 0.0210, 'lps'),
	(452567, 125, '2015-03-15 00:09:45.000000', 'consum', 0.0215, 'lps'),
	(452568, 125, '2015-03-15 00:09:46.000000', 'consum', 0.0219, 'lps'),
	(452569, 125, '2015-03-15 00:09:47.000000', 'consum', 0.0221, 'lps'),
	(452570, 125, '2015-03-15 00:09:48.000000', 'consum', 0.0222, 'lps'),
	(452571, 125, '2015-03-15 00:09:49.000000', 'consum', 0.0219, 'lps'),
	(452572, 125, '2015-03-15 00:09:50.000000', 'consum', 0.0221, 'lps'),
	(452573, 125, '2015-03-15 00:09:51.000000', 'consum', 0.0221, 'lps'),
	(452574, 125, '2015-03-15 00:09:52.000000', 'consum', 0.0213, 'lps'),
	(452575, 125, '2015-03-15 00:09:53.000000', 'consum', 0.0227, 'lps'),
	(452576, 125, '2015-03-15 00:09:54.000000', 'consum', 0.0215, 'lps'),
	(452577, 125, '2015-03-15 00:09:55.000000', 'consum', 0.0223, 'lps'),
	(452578, 125, '2015-03-15 00:09:56.000000', 'consum', 0.0222, 'lps'),
	(452579, 125, '2015-03-15 00:09:57.000000', 'consum', 0.0213, 'lps'),
	(452580, 125, '2015-03-15 00:09:58.000000', 'consum', 0.0227, 'lps'),
	(452581, 125, '2015-03-15 00:09:59.000000', 'consum', 0.0215, 'lps'),
	(452582, 125, '2015-03-15 00:10:00.000000', 'consum', 0.0221, 'lps'),
	(452583, 125, '2015-03-15 00:10:01.000000', 'consum', 0.0213, 'lps'),
	(452584, 125, '2015-03-15 00:10:02.000000', 'consum', 0.0213, 'lps'),
	(452585, 125, '2015-03-15 00:10:03.000000', 'consum', 0.0216, 'lps'),
	(452586, 125, '2015-03-15 00:10:04.000000', 'consum', 0.0211, 'lps'),
	(452587, 125, '2015-03-15 00:10:05.000000', 'consum', 0.0219, 'lps'),
	(452588, 125, '2015-03-15 00:10:06.000000', 'consum', 0.0213, 'lps'),
	(452589, 125, '2015-03-15 00:10:07.000000', 'consum', 0.0220, 'lps'),
	(452590, 125, '2015-03-15 00:10:08.000000', 'consum', 0.0213, 'lps'),
	(452591, 125, '2015-03-15 00:10:09.000000', 'consum', 0.0215, 'lps'),
	(452592, 125, '2015-03-15 00:10:10.000000', 'consum', 0.0227, 'lps'),
	(452593, 125, '2015-03-15 00:10:11.000000', 'consum', 0.0224, 'lps'),
	(452594, 125, '2015-03-15 00:10:12.000000', 'consum', 0.0214, 'lps'),
	(452595, 125, '2015-03-15 00:10:13.000000', 'consum', 0.0224, 'lps'),
	(452596, 125, '2015-03-15 00:10:14.000000', 'consum', 0.0215, 'lps'),
	(452597, 125, '2015-03-15 00:10:15.000000', 'consum', 0.0211, 'lps'),
	(452598, 125, '2015-03-15 00:10:16.000000', 'consum', 0.0218, 'lps'),
	(452599, 125, '2015-03-15 00:10:17.000000', 'consum', 0.0210, 'lps'),
	(452600, 125, '2015-03-15 00:10:18.000000', 'consum', 0.0223, 'lps'),
	(452601, 125, '2015-03-15 00:10:19.000000', 'consum', 0.0222, 'lps'),
	(452602, 125, '2015-03-15 00:10:20.000000', 'consum', 0.0214, 'lps'),
	(452603, 125, '2015-03-15 00:10:21.000000', 'consum', 0.0210, 'lps'),
	(452604, 125, '2015-03-15 00:10:22.000000', 'consum', 0.0219, 'lps'),
	(452605, 125, '2015-03-15 00:10:23.000000', 'consum', 0.0217, 'lps'),
	(452606, 125, '2015-03-15 00:10:24.000000', 'consum', 0.0220, 'lps'),
	(452607, 125, '2015-03-15 00:10:25.000000', 'consum', 0.0223, 'lps'),
	(452608, 125, '2015-03-15 00:10:26.000000', 'consum', 0.0226, 'lps'),
	(452609, 125, '2015-03-15 00:10:27.000000', 'consum', 0.0215, 'lps'),
	(452610, 125, '2015-03-15 00:10:28.000000', 'consum', 0.0226, 'lps'),
	(452611, 125, '2015-03-15 00:10:29.000000', 'consum', 0.0218, 'lps'),
	(452612, 125, '2015-03-15 00:10:30.000000', 'consum', 0.0223, 'lps'),
	(452613, 125, '2015-03-15 00:10:31.000000', 'consum', 0.0216, 'lps'),
	(452614, 125, '2015-03-15 00:10:32.000000', 'consum', 0.0219, 'lps'),
	(452615, 125, '2015-03-15 00:10:33.000000', 'consum', 0.0220, 'lps'),
	(452616, 125, '2015-03-15 00:10:34.000000', 'consum', 0.0216, 'lps'),
	(452617, 125, '2015-03-15 00:10:35.000000', 'consum', 0.0212, 'lps'),
	(452618, 125, '2015-03-15 00:10:36.000000', 'consum', 0.0217, 'lps'),
	(452619, 125, '2015-03-15 00:10:37.000000', 'consum', 0.0225, 'lps'),
	(452620, 125, '2015-03-15 00:10:38.000000', 'consum', 0.0225, 'lps'),
	(452621, 125, '2015-03-15 00:10:39.000000', 'consum', 0.0226, 'lps'),
	(452622, 125, '2015-03-15 00:10:40.000000', 'consum', 0.0226, 'lps'),
	(452623, 125, '2015-03-15 00:10:41.000000', 'consum', 0.0224, 'lps'),
	(452624, 125, '2015-03-15 00:10:42.000000', 'consum', 0.0214, 'lps'),
	(452625, 125, '2015-03-15 00:10:43.000000', 'consum', 0.0226, 'lps'),
	(452626, 125, '2015-03-15 00:10:44.000000', 'consum', 0.0225, 'lps'),
	(452627, 125, '2015-03-15 00:10:45.000000', 'consum', 0.0220, 'lps'),
	(452628, 125, '2015-03-15 00:10:46.000000', 'consum', 0.0216, 'lps'),
	(452629, 125, '2015-03-15 00:10:47.000000', 'consum', 0.0226, 'lps'),
	(452630, 125, '2015-03-15 00:10:48.000000', 'consum', 0.0219, 'lps'),
	(452631, 125, '2015-03-15 00:10:49.000000', 'consum', 0.0210, 'lps'),
	(452632, 125, '2015-03-15 00:10:50.000000', 'consum', 0.0216, 'lps'),
	(452633, 125, '2015-03-15 00:10:51.000000', 'consum', 0.0225, 'lps'),
	(452634, 125, '2015-03-15 00:10:52.000000', 'consum', 0.0213, 'lps'),
	(452635, 125, '2015-03-15 00:10:53.000000', 'consum', 0.0216, 'lps'),
	(452636, 125, '2015-03-15 00:10:54.000000', 'consum', 0.0216, 'lps'),
	(452637, 125, '2015-03-15 00:10:55.000000', 'consum', 0.0220, 'lps'),
	(452638, 125, '2015-03-15 00:10:56.000000', 'consum', 0.0226, 'lps'),
	(452639, 125, '2015-03-15 00:10:57.000000', 'consum', 0.0224, 'lps'),
	(452640, 125, '2015-03-15 00:10:58.000000', 'consum', 0.0215, 'lps'),
	(452641, 125, '2015-03-15 00:10:59.000000', 'consum', 0.0213, 'lps'),
	(452642, 125, '2015-03-15 00:11:00.000000', 'consum', 0.0226, 'lps'),
	(452643, 125, '2015-03-15 00:11:01.000000', 'consum', 0.0210, 'lps'),
	(452644, 125, '2015-03-15 00:11:02.000000', 'consum', 0.0218, 'lps'),
	(452645, 125, '2015-03-15 00:11:03.000000', 'consum', 0.0212, 'lps'),
	(452646, 125, '2015-03-15 00:11:04.000000', 'consum', 0.0214, 'lps'),
	(452647, 125, '2015-03-15 00:11:05.000000', 'consum', 0.0226, 'lps'),
	(452648, 125, '2015-03-15 00:11:06.000000', 'consum', 0.0224, 'lps'),
	(452649, 125, '2015-03-15 00:11:07.000000', 'consum', 0.0216, 'lps'),
	(452650, 125, '2015-03-15 00:11:08.000000', 'consum', 0.0216, 'lps'),
	(452651, 125, '2015-03-15 00:11:09.000000', 'consum', 0.0224, 'lps'),
	(452652, 125, '2015-03-15 00:11:10.000000', 'consum', 0.0226, 'lps'),
	(452653, 125, '2015-03-15 00:11:11.000000', 'consum', 0.0211, 'lps'),
	(452654, 125, '2015-03-15 00:11:12.000000', 'consum', 0.0223, 'lps'),
	(452655, 125, '2015-03-15 00:11:13.000000', 'consum', 0.0217, 'lps'),
	(452656, 125, '2015-03-15 00:11:14.000000', 'consum', 0.0227, 'lps'),
	(452657, 125, '2015-03-15 00:11:15.000000', 'consum', 0.0218, 'lps'),
	(452658, 125, '2015-03-15 00:11:16.000000', 'consum', 0.0219, 'lps'),
	(452659, 125, '2015-03-15 00:11:17.000000', 'consum', 0.0214, 'lps'),
	(452660, 125, '2015-03-15 00:11:18.000000', 'consum', 0.0220, 'lps'),
	(452661, 125, '2015-03-15 00:11:19.000000', 'consum', 0.0213, 'lps'),
	(452662, 125, '2015-03-15 00:11:20.000000', 'consum', 0.0214, 'lps'),
	(452663, 125, '2015-03-15 00:11:21.000000', 'consum', 0.0223, 'lps'),
	(452664, 125, '2015-03-15 00:11:22.000000', 'consum', 0.0226, 'lps'),
	(452665, 125, '2015-03-15 00:11:23.000000', 'consum', 0.0218, 'lps'),
	(452666, 125, '2015-03-15 00:11:24.000000', 'consum', 0.0218, 'lps'),
	(452667, 125, '2015-03-15 00:11:25.000000', 'consum', 0.0227, 'lps'),
	(452668, 125, '2015-03-15 00:11:26.000000', 'consum', 0.0217, 'lps'),
	(452669, 125, '2015-03-15 00:11:27.000000', 'consum', 0.0212, 'lps'),
	(452670, 125, '2015-03-15 00:11:28.000000', 'consum', 0.0217, 'lps'),
	(452671, 125, '2015-03-15 00:11:29.000000', 'consum', 0.0223, 'lps'),
	(452672, 125, '2015-03-15 00:11:30.000000', 'consum', 0.0219, 'lps'),
	(452673, 125, '2015-03-15 00:11:31.000000', 'consum', 0.0216, 'lps'),
	(452674, 125, '2015-03-15 00:11:32.000000', 'consum', 0.0214, 'lps'),
	(452675, 125, '2015-03-15 00:11:33.000000', 'consum', 0.0213, 'lps'),
	(452676, 125, '2015-03-15 00:11:34.000000', 'consum', 0.0212, 'lps'),
	(452677, 125, '2015-03-15 00:11:35.000000', 'consum', 0.0214, 'lps'),
	(452678, 125, '2015-03-15 00:11:36.000000', 'consum', 0.0222, 'lps'),
	(452679, 125, '2015-03-15 00:11:37.000000', 'consum', 0.0225, 'lps'),
	(452680, 125, '2015-03-15 00:11:38.000000', 'consum', 0.0213, 'lps'),
	(452681, 125, '2015-03-15 00:11:39.000000', 'consum', 0.0215, 'lps'),
	(452682, 125, '2015-03-15 00:11:40.000000', 'consum', 0.0226, 'lps'),
	(452683, 125, '2015-03-15 00:11:41.000000', 'consum', 0.0223, 'lps'),
	(452684, 125, '2015-03-15 00:11:42.000000', 'consum', 0.0227, 'lps'),
	(452685, 125, '2015-03-15 00:11:43.000000', 'consum', 0.0222, 'lps'),
	(452686, 125, '2015-03-15 00:11:44.000000', 'consum', 0.0220, 'lps'),
	(452687, 125, '2015-03-15 00:11:45.000000', 'consum', 0.0224, 'lps'),
	(452688, 125, '2015-03-15 00:11:46.000000', 'consum', 0.0212, 'lps'),
	(452689, 125, '2015-03-15 00:11:47.000000', 'consum', 0.0217, 'lps'),
	(452690, 125, '2015-03-15 00:11:48.000000', 'consum', 0.0220, 'lps'),
	(452691, 125, '2015-03-15 00:11:49.000000', 'consum', 0.0223, 'lps'),
	(452692, 125, '2015-03-15 00:11:50.000000', 'consum', 0.0211, 'lps'),
	(452693, 125, '2015-03-15 00:11:51.000000', 'consum', 0.0210, 'lps'),
	(452694, 125, '2015-03-15 00:11:52.000000', 'consum', 0.0227, 'lps'),
	(452695, 125, '2015-03-15 00:11:53.000000', 'consum', 0.0221, 'lps'),
	(452696, 125, '2015-03-15 00:11:54.000000', 'consum', 0.0217, 'lps'),
	(452697, 125, '2015-03-15 00:11:55.000000', 'consum', 0.0212, 'lps'),
	(452698, 125, '2015-03-15 00:11:56.000000', 'consum', 0.0218, 'lps'),
	(452699, 125, '2015-03-15 00:11:57.000000', 'consum', 0.0226, 'lps'),
	(452700, 125, '2015-03-15 00:11:58.000000', 'consum', 0.0211, 'lps'),
	(452701, 125, '2015-03-15 00:11:59.000000', 'consum', 0.0221, 'lps'),
	(452702, 125, '2015-03-15 00:12:00.000000', 'consum', 0.0211, 'lps'),
	(452703, 125, '2015-03-15 00:12:01.000000', 'consum', 0.0219, 'lps'),
	(452704, 125, '2015-03-15 00:12:02.000000', 'consum', 0.0215, 'lps'),
	(452705, 125, '2015-03-15 00:12:03.000000', 'consum', 0.0227, 'lps'),
	(452706, 125, '2015-03-15 00:12:04.000000', 'consum', 0.0210, 'lps'),
	(452707, 125, '2015-03-15 00:12:05.000000', 'consum', 0.0211, 'lps'),
	(452708, 125, '2015-03-15 00:12:06.000000', 'consum', 0.0214, 'lps'),
	(452709, 125, '2015-03-15 00:12:07.000000', 'consum', 0.0213, 'lps'),
	(452710, 125, '2015-03-15 00:12:08.000000', 'consum', 0.0214, 'lps'),
	(452711, 125, '2015-03-15 00:12:09.000000', 'consum', 0.0219, 'lps'),
	(452712, 125, '2015-03-15 00:12:10.000000', 'consum', 0.0225, 'lps'),
	(452713, 125, '2015-03-15 00:12:11.000000', 'consum', 0.0225, 'lps'),
	(452714, 125, '2015-03-15 00:12:12.000000', 'consum', 0.0223, 'lps'),
	(452715, 125, '2015-03-15 00:12:13.000000', 'consum', 0.0213, 'lps'),
	(452716, 125, '2015-03-15 00:12:14.000000', 'consum', 0.0220, 'lps'),
	(452717, 125, '2015-03-15 00:12:15.000000', 'consum', 0.0214, 'lps'),
	(452718, 125, '2015-03-15 00:12:16.000000', 'consum', 0.0222, 'lps'),
	(452719, 125, '2015-03-15 00:12:17.000000', 'consum', 0.0221, 'lps'),
	(452720, 125, '2015-03-15 00:12:18.000000', 'consum', 0.0212, 'lps'),
	(452721, 125, '2015-03-15 00:12:19.000000', 'consum', 0.0223, 'lps'),
	(452722, 125, '2015-03-15 00:12:20.000000', 'consum', 0.0214, 'lps'),
	(452723, 125, '2015-03-15 00:12:21.000000', 'consum', 0.0227, 'lps'),
	(452724, 125, '2015-03-15 00:12:22.000000', 'consum', 0.0212, 'lps'),
	(452725, 125, '2015-03-15 00:12:23.000000', 'consum', 0.0223, 'lps'),
	(452726, 125, '2015-03-15 00:12:24.000000', 'consum', 0.0217, 'lps'),
	(452727, 125, '2015-03-15 00:12:25.000000', 'consum', 0.0224, 'lps'),
	(452728, 125, '2015-03-15 00:12:26.000000', 'consum', 0.0225, 'lps'),
	(452729, 125, '2015-03-15 00:12:27.000000', 'consum', 0.0224, 'lps'),
	(452730, 125, '2015-03-15 00:12:28.000000', 'consum', 0.0219, 'lps'),
	(452731, 125, '2015-03-15 00:12:29.000000', 'consum', 0.0215, 'lps'),
	(452732, 125, '2015-03-15 00:12:30.000000', 'consum', 0.0223, 'lps'),
	(452733, 125, '2015-03-15 00:12:31.000000', 'consum', 0.0225, 'lps'),
	(452734, 125, '2015-03-15 00:12:32.000000', 'consum', 0.0211, 'lps'),
	(452735, 125, '2015-03-15 00:12:33.000000', 'consum', 0.0226, 'lps'),
	(452736, 125, '2015-03-15 00:12:34.000000', 'consum', 0.0215, 'lps'),
	(452737, 125, '2015-03-15 00:12:35.000000', 'consum', 0.0225, 'lps'),
	(452738, 125, '2015-03-15 00:12:36.000000', 'consum', 0.0214, 'lps'),
	(452739, 125, '2015-03-15 00:12:37.000000', 'consum', 0.0221, 'lps'),
	(452740, 125, '2015-03-15 00:12:38.000000', 'consum', 0.0218, 'lps'),
	(452741, 125, '2015-03-15 00:12:39.000000', 'consum', 0.0218, 'lps'),
	(452742, 125, '2015-03-15 00:12:40.000000', 'consum', 0.0226, 'lps'),
	(452743, 125, '2015-03-15 00:12:41.000000', 'consum', 0.0214, 'lps'),
	(452744, 125, '2015-03-15 00:12:42.000000', 'consum', 0.0218, 'lps'),
	(452745, 125, '2015-03-15 00:12:43.000000', 'consum', 0.0219, 'lps'),
	(452746, 125, '2015-03-15 00:12:44.000000', 'consum', 0.0216, 'lps'),
	(452747, 125, '2015-03-15 00:12:45.000000', 'consum', 0.0213, 'lps'),
	(452748, 125, '2015-03-15 00:12:46.000000', 'consum', 0.0224, 'lps'),
	(452749, 125, '2015-03-15 00:12:47.000000', 'consum', 0.0219, 'lps'),
	(452750, 125, '2015-03-15 00:12:48.000000', 'consum', 0.0211, 'lps'),
	(452751, 125, '2015-03-15 00:12:49.000000', 'consum', 0.0227, 'lps'),
	(452752, 125, '2015-03-15 00:12:50.000000', 'consum', 0.0221, 'lps'),
	(452753, 125, '2015-03-15 00:12:51.000000', 'consum', 0.0216, 'lps'),
	(452754, 125, '2015-03-15 00:12:52.000000', 'consum', 0.0222, 'lps'),
	(452755, 125, '2015-03-15 00:12:53.000000', 'consum', 0.0220, 'lps'),
	(452756, 125, '2015-03-15 00:12:54.000000', 'consum', 0.0221, 'lps'),
	(452757, 125, '2015-03-15 00:12:55.000000', 'consum', 0.0220, 'lps'),
	(452758, 125, '2015-03-15 00:12:56.000000', 'consum', 0.0227, 'lps'),
	(452759, 125, '2015-03-15 00:12:57.000000', 'consum', 0.0227, 'lps'),
	(452760, 125, '2015-03-15 00:12:58.000000', 'consum', 0.0211, 'lps'),
	(452761, 125, '2015-03-15 00:12:59.000000', 'consum', 0.0219, 'lps'),
	(452762, 125, '2015-03-15 00:13:00.000000', 'consum', 0.0215, 'lps'),
	(452763, 125, '2015-03-15 00:13:01.000000', 'consum', 0.0211, 'lps'),
	(452764, 125, '2015-03-15 00:13:02.000000', 'consum', 0.0215, 'lps'),
	(452765, 125, '2015-03-15 00:13:03.000000', 'consum', 0.0216, 'lps'),
	(452766, 125, '2015-03-15 00:13:04.000000', 'consum', 0.0226, 'lps'),
	(452767, 125, '2015-03-15 00:13:05.000000', 'consum', 0.0218, 'lps'),
	(452768, 125, '2015-03-15 00:13:06.000000', 'consum', 0.0221, 'lps'),
	(452769, 125, '2015-03-15 00:13:07.000000', 'consum', 0.0225, 'lps'),
	(452770, 125, '2015-03-15 00:13:08.000000', 'consum', 0.0215, 'lps'),
	(452771, 125, '2015-03-15 00:13:09.000000', 'consum', 0.0210, 'lps'),
	(452772, 125, '2015-03-15 00:13:10.000000', 'consum', 0.0213, 'lps'),
	(452773, 125, '2015-03-15 00:13:11.000000', 'consum', 0.0223, 'lps'),
	(452774, 125, '2015-03-15 00:13:12.000000', 'consum', 0.0215, 'lps'),
	(452775, 125, '2015-03-15 00:13:13.000000', 'consum', 0.0212, 'lps'),
	(452776, 125, '2015-03-15 00:13:14.000000', 'consum', 0.0227, 'lps'),
	(452777, 125, '2015-03-15 00:13:15.000000', 'consum', 0.0215, 'lps'),
	(452778, 125, '2015-03-15 00:13:16.000000', 'consum', 0.0222, 'lps'),
	(452779, 125, '2015-03-15 00:13:17.000000', 'consum', 0.0218, 'lps'),
	(452780, 125, '2015-03-15 00:13:18.000000', 'consum', 0.0214, 'lps'),
	(452781, 125, '2015-03-15 00:13:19.000000', 'consum', 0.0224, 'lps'),
	(452782, 125, '2015-03-15 00:13:20.000000', 'consum', 0.0216, 'lps'),
	(452783, 125, '2015-03-15 00:13:21.000000', 'consum', 0.0218, 'lps'),
	(452784, 125, '2015-03-15 00:13:22.000000', 'consum', 0.0214, 'lps'),
	(452785, 125, '2015-03-15 00:13:23.000000', 'consum', 0.0224, 'lps'),
	(452786, 125, '2015-03-15 00:13:24.000000', 'consum', 0.0216, 'lps'),
	(452787, 125, '2015-03-15 00:13:25.000000', 'consum', 0.0215, 'lps'),
	(452788, 125, '2015-03-15 00:13:26.000000', 'consum', 0.0220, 'lps'),
	(452789, 125, '2015-03-15 00:13:27.000000', 'consum', 0.0225, 'lps'),
	(452790, 125, '2015-03-15 00:13:28.000000', 'consum', 0.0220, 'lps'),
	(452791, 125, '2015-03-15 00:13:29.000000', 'consum', 0.0216, 'lps'),
	(452792, 125, '2015-03-15 00:13:30.000000', 'consum', 0.0212, 'lps'),
	(452793, 125, '2015-03-15 00:13:31.000000', 'consum', 0.0219, 'lps'),
	(452794, 125, '2015-03-15 00:13:32.000000', 'consum', 0.0212, 'lps'),
	(452795, 125, '2015-03-15 00:13:33.000000', 'consum', 0.0214, 'lps'),
	(452796, 125, '2015-03-15 00:13:34.000000', 'consum', 0.0222, 'lps'),
	(452797, 125, '2015-03-15 00:13:35.000000', 'consum', 0.0225, 'lps'),
	(452798, 125, '2015-03-15 00:13:36.000000', 'consum', 0.0211, 'lps'),
	(452799, 125, '2015-03-15 00:13:37.000000', 'consum', 0.0224, 'lps'),
	(452800, 125, '2015-03-15 00:13:38.000000', 'consum', 0.0226, 'lps'),
	(452801, 125, '2015-03-15 00:13:39.000000', 'consum', 0.0214, 'lps'),
	(452802, 125, '2015-03-15 00:13:40.000000', 'consum', 0.0215, 'lps'),
	(452803, 125, '2015-03-15 00:13:41.000000', 'consum', 0.0226, 'lps'),
	(452804, 125, '2015-03-15 00:13:42.000000', 'consum', 0.0220, 'lps'),
	(452805, 125, '2015-03-15 00:13:43.000000', 'consum', 0.0212, 'lps'),
	(452806, 125, '2015-03-15 00:13:44.000000', 'consum', 0.0210, 'lps'),
	(452807, 125, '2015-03-15 00:13:45.000000', 'consum', 0.0223, 'lps'),
	(452808, 125, '2015-03-15 00:13:46.000000', 'consum', 0.0221, 'lps'),
	(452809, 125, '2015-03-15 00:13:47.000000', 'consum', 0.0226, 'lps'),
	(452810, 125, '2015-03-15 00:13:48.000000', 'consum', 0.0224, 'lps'),
	(452811, 125, '2015-03-15 00:13:49.000000', 'consum', 0.0211, 'lps'),
	(452812, 125, '2015-03-15 00:13:50.000000', 'consum', 0.0211, 'lps'),
	(452813, 125, '2015-03-15 00:13:51.000000', 'consum', 0.0214, 'lps'),
	(452814, 125, '2015-03-15 00:13:52.000000', 'consum', 0.0225, 'lps'),
	(452815, 125, '2015-03-15 00:13:53.000000', 'consum', 0.0219, 'lps'),
	(452816, 125, '2015-03-15 00:13:54.000000', 'consum', 0.0213, 'lps'),
	(452817, 125, '2015-03-15 00:13:55.000000', 'consum', 0.0217, 'lps'),
	(452818, 125, '2015-03-15 00:13:56.000000', 'consum', 0.0218, 'lps'),
	(452819, 125, '2015-03-15 00:13:57.000000', 'consum', 0.0210, 'lps'),
	(452820, 125, '2015-03-15 00:13:58.000000', 'consum', 0.0224, 'lps'),
	(452821, 125, '2015-03-15 00:13:59.000000', 'consum', 0.0225, 'lps'),
	(452822, 125, '2015-03-15 00:14:00.000000', 'consum', 0.0210, 'lps'),
	(452823, 125, '2015-03-15 00:14:01.000000', 'consum', 0.0217, 'lps'),
	(452824, 125, '2015-03-15 00:14:02.000000', 'consum', 0.0212, 'lps'),
	(452825, 125, '2015-03-15 00:14:03.000000', 'consum', 0.0216, 'lps'),
	(452826, 125, '2015-03-15 00:14:04.000000', 'consum', 0.0218, 'lps'),
	(452827, 125, '2015-03-15 00:14:05.000000', 'consum', 0.0215, 'lps'),
	(452828, 125, '2015-03-15 00:14:06.000000', 'consum', 0.0227, 'lps'),
	(452829, 125, '2015-03-15 00:14:07.000000', 'consum', 0.0227, 'lps'),
	(452830, 125, '2015-03-15 00:14:08.000000', 'consum', 0.0225, 'lps'),
	(452831, 125, '2015-03-15 00:14:09.000000', 'consum', 0.0218, 'lps'),
	(452832, 125, '2015-03-15 00:14:10.000000', 'consum', 0.0224, 'lps'),
	(452833, 125, '2015-03-15 00:14:11.000000', 'consum', 0.0219, 'lps'),
	(452834, 125, '2015-03-15 00:14:12.000000', 'consum', 0.0216, 'lps'),
	(452835, 125, '2015-03-15 00:14:13.000000', 'consum', 0.0211, 'lps'),
	(452836, 125, '2015-03-15 00:14:14.000000', 'consum', 0.0215, 'lps'),
	(452837, 125, '2015-03-15 00:14:15.000000', 'consum', 0.0217, 'lps'),
	(452838, 125, '2015-03-15 00:14:16.000000', 'consum', 0.0211, 'lps'),
	(452839, 125, '2015-03-15 00:14:17.000000', 'consum', 0.0211, 'lps'),
	(452840, 125, '2015-03-15 00:14:18.000000', 'consum', 0.0214, 'lps'),
	(452841, 125, '2015-03-15 00:14:19.000000', 'consum', 0.0210, 'lps'),
	(452842, 125, '2015-03-15 00:14:20.000000', 'consum', 0.0217, 'lps'),
	(452843, 125, '2015-03-15 00:14:21.000000', 'consum', 0.0226, 'lps'),
	(452844, 125, '2015-03-15 00:14:22.000000', 'consum', 0.0217, 'lps'),
	(452845, 125, '2015-03-15 00:14:23.000000', 'consum', 0.0217, 'lps'),
	(452846, 125, '2015-03-15 00:14:24.000000', 'consum', 0.0222, 'lps'),
	(452847, 125, '2015-03-15 00:14:25.000000', 'consum', 0.0216, 'lps'),
	(452848, 125, '2015-03-15 00:14:26.000000', 'consum', 0.0220, 'lps'),
	(452849, 125, '2015-03-15 00:14:27.000000', 'consum', 0.0227, 'lps'),
	(452850, 125, '2015-03-15 00:14:28.000000', 'consum', 0.0227, 'lps'),
	(452851, 125, '2015-03-15 00:14:29.000000', 'consum', 0.0210, 'lps'),
	(452852, 125, '2015-03-15 00:14:30.000000', 'consum', 0.0213, 'lps'),
	(452853, 125, '2015-03-15 00:14:31.000000', 'consum', 0.0210, 'lps'),
	(452854, 125, '2015-03-15 00:14:32.000000', 'consum', 0.0216, 'lps'),
	(452855, 125, '2015-03-15 00:14:33.000000', 'consum', 0.0225, 'lps'),
	(452856, 125, '2015-03-15 00:14:34.000000', 'consum', 0.0212, 'lps'),
	(452857, 125, '2015-03-15 00:14:35.000000', 'consum', 0.0212, 'lps'),
	(452858, 125, '2015-03-15 00:14:36.000000', 'consum', 0.0213, 'lps'),
	(452859, 125, '2015-03-15 00:14:37.000000', 'consum', 0.0222, 'lps'),
	(452860, 125, '2015-03-15 00:14:38.000000', 'consum', 0.0223, 'lps'),
	(452861, 125, '2015-03-15 00:14:39.000000', 'consum', 0.0224, 'lps'),
	(452862, 125, '2015-03-15 00:14:40.000000', 'consum', 0.0222, 'lps'),
	(452863, 125, '2015-03-15 00:14:41.000000', 'consum', 0.0227, 'lps'),
	(452864, 125, '2015-03-15 00:14:42.000000', 'consum', 0.0226, 'lps'),
	(452865, 125, '2015-03-15 00:14:43.000000', 'consum', 0.0222, 'lps'),
	(452866, 125, '2015-03-15 00:14:44.000000', 'consum', 0.0220, 'lps'),
	(452867, 125, '2015-03-15 00:14:45.000000', 'consum', 0.0227, 'lps'),
	(452868, 125, '2015-03-15 00:14:46.000000', 'consum', 0.0213, 'lps'),
	(452869, 125, '2015-03-15 00:14:47.000000', 'consum', 0.0225, 'lps'),
	(452870, 125, '2015-03-15 00:14:48.000000', 'consum', 0.0224, 'lps'),
	(452871, 125, '2015-03-15 00:14:49.000000', 'consum', 0.0216, 'lps'),
	(452872, 125, '2015-03-15 00:14:50.000000', 'consum', 0.0218, 'lps'),
	(452873, 125, '2015-03-15 00:14:51.000000', 'consum', 0.0213, 'lps'),
	(452874, 125, '2015-03-15 00:14:52.000000', 'consum', 0.0218, 'lps'),
	(452875, 125, '2015-03-15 00:14:53.000000', 'consum', 0.0226, 'lps'),
	(452876, 125, '2015-03-15 00:14:54.000000', 'consum', 0.0213, 'lps'),
	(452877, 125, '2015-03-15 00:14:55.000000', 'consum', 0.0213, 'lps'),
	(452878, 125, '2015-03-15 00:14:56.000000', 'consum', 0.0216, 'lps'),
	(452879, 125, '2015-03-15 00:14:57.000000', 'consum', 0.0215, 'lps'),
	(452880, 125, '2015-03-15 00:14:58.000000', 'consum', 0.0215, 'lps'),
	(452881, 125, '2015-03-15 00:14:59.000000', 'consum', 0.0223, 'lps'),
	(452882, 125, '2015-03-15 00:15:00.000000', 'consum', 0.0225, 'lps'),
	(452883, 125, '2015-03-15 00:15:01.000000', 'consum', 0.0227, 'lps'),
	(452884, 125, '2015-03-15 00:15:02.000000', 'consum', 0.0213, 'lps'),
	(452885, 125, '2015-03-15 00:15:03.000000', 'consum', 0.0213, 'lps'),
	(452886, 125, '2015-03-15 00:15:04.000000', 'consum', 0.0214, 'lps'),
	(452887, 125, '2015-03-15 00:15:05.000000', 'consum', 0.0222, 'lps'),
	(452888, 125, '2015-03-15 00:15:06.000000', 'consum', 0.0221, 'lps'),
	(452889, 125, '2015-03-15 00:15:07.000000', 'consum', 0.0214, 'lps'),
	(452890, 125, '2015-03-15 00:15:08.000000', 'consum', 0.0214, 'lps'),
	(452891, 125, '2015-03-15 00:15:09.000000', 'consum', 0.0217, 'lps'),
	(452892, 125, '2015-03-15 00:15:10.000000', 'consum', 0.0217, 'lps'),
	(452893, 125, '2015-03-15 00:15:11.000000', 'consum', 0.0224, 'lps'),
	(452894, 125, '2015-03-15 00:15:12.000000', 'consum', 0.0225, 'lps'),
	(452895, 125, '2015-03-15 00:15:13.000000', 'consum', 0.0225, 'lps'),
	(452896, 125, '2015-03-15 00:15:14.000000', 'consum', 0.0221, 'lps'),
	(452897, 125, '2015-03-15 00:15:15.000000', 'consum', 0.0221, 'lps'),
	(452898, 125, '2015-03-15 00:15:16.000000', 'consum', 0.0215, 'lps'),
	(452899, 125, '2015-03-15 00:15:17.000000', 'consum', 0.0219, 'lps'),
	(452900, 125, '2015-03-15 00:15:18.000000', 'consum', 0.0224, 'lps'),
	(452901, 125, '2015-03-15 00:15:19.000000', 'consum', 0.0216, 'lps'),
	(452902, 125, '2015-03-15 00:15:20.000000', 'consum', 0.0219, 'lps'),
	(452903, 125, '2015-03-15 00:15:21.000000', 'consum', 0.0216, 'lps'),
	(452904, 125, '2015-03-15 00:15:22.000000', 'consum', 0.0216, 'lps'),
	(452905, 125, '2015-03-15 00:15:23.000000', 'consum', 0.0222, 'lps'),
	(452906, 125, '2015-03-15 00:15:24.000000', 'consum', 0.0217, 'lps'),
	(452907, 125, '2015-03-15 00:15:25.000000', 'consum', 0.0210, 'lps'),
	(452908, 125, '2015-03-15 00:15:26.000000', 'consum', 0.0226, 'lps'),
	(452909, 125, '2015-03-15 00:15:27.000000', 'consum', 0.0217, 'lps'),
	(452910, 125, '2015-03-15 00:15:28.000000', 'consum', 0.0218, 'lps'),
	(452911, 125, '2015-03-15 00:15:29.000000', 'consum', 0.0227, 'lps'),
	(452912, 125, '2015-03-15 00:15:30.000000', 'consum', 0.0219, 'lps'),
	(452913, 125, '2015-03-15 00:15:31.000000', 'consum', 0.0223, 'lps'),
	(452914, 125, '2015-03-15 00:15:32.000000', 'consum', 0.0213, 'lps'),
	(452915, 125, '2015-03-15 00:15:33.000000', 'consum', 0.0220, 'lps'),
	(452916, 125, '2015-03-15 00:15:34.000000', 'consum', 0.0215, 'lps'),
	(452917, 125, '2015-03-15 00:15:35.000000', 'consum', 0.0226, 'lps'),
	(452918, 125, '2015-03-15 00:15:36.000000', 'consum', 0.0221, 'lps'),
	(452919, 125, '2015-03-15 00:15:37.000000', 'consum', 0.0218, 'lps'),
	(452920, 125, '2015-03-15 00:15:38.000000', 'consum', 0.0216, 'lps'),
	(452921, 125, '2015-03-15 00:15:39.000000', 'consum', 0.0216, 'lps'),
	(452922, 125, '2015-03-15 00:15:40.000000', 'consum', 0.0225, 'lps'),
	(452923, 125, '2015-03-15 00:15:41.000000', 'consum', 0.0212, 'lps'),
	(452924, 125, '2015-03-15 00:15:42.000000', 'consum', 0.0213, 'lps'),
	(452925, 125, '2015-03-15 00:15:43.000000', 'consum', 0.0220, 'lps'),
	(452926, 125, '2015-03-15 00:15:44.000000', 'consum', 0.0214, 'lps'),
	(452927, 125, '2015-03-15 00:15:45.000000', 'consum', 0.0219, 'lps'),
	(452928, 125, '2015-03-15 00:15:46.000000', 'consum', 0.0224, 'lps'),
	(452929, 125, '2015-03-15 00:15:47.000000', 'consum', 0.0219, 'lps'),
	(452930, 125, '2015-03-15 00:15:48.000000', 'consum', 0.0211, 'lps'),
	(452931, 125, '2015-03-15 00:15:49.000000', 'consum', 0.0227, 'lps'),
	(452932, 125, '2015-03-15 00:15:50.000000', 'consum', 0.0218, 'lps'),
	(452933, 125, '2015-03-15 00:15:51.000000', 'consum', 0.0220, 'lps'),
	(452934, 125, '2015-03-15 00:15:52.000000', 'consum', 0.0219, 'lps'),
	(452935, 125, '2015-03-15 00:15:53.000000', 'consum', 0.0226, 'lps'),
	(452936, 125, '2015-03-15 00:15:54.000000', 'consum', 0.0225, 'lps'),
	(452937, 125, '2015-03-15 00:15:55.000000', 'consum', 0.0219, 'lps'),
	(452938, 125, '2015-03-15 00:15:56.000000', 'consum', 0.0211, 'lps'),
	(452939, 125, '2015-03-15 00:15:57.000000', 'consum', 0.0225, 'lps'),
	(452940, 125, '2015-03-15 00:15:58.000000', 'consum', 0.0227, 'lps'),
	(452941, 125, '2015-03-15 00:15:59.000000', 'consum', 0.0214, 'lps'),
	(452942, 125, '2015-03-15 00:16:00.000000', 'consum', 0.0218, 'lps'),
	(452943, 125, '2015-03-15 00:16:01.000000', 'consum', 0.0218, 'lps'),
	(452944, 125, '2015-03-15 00:16:02.000000', 'consum', 0.0227, 'lps'),
	(452945, 125, '2015-03-15 00:16:03.000000', 'consum', 0.0216, 'lps'),
	(452946, 125, '2015-03-15 00:16:04.000000', 'consum', 0.0210, 'lps'),
	(452947, 125, '2015-03-15 00:16:05.000000', 'consum', 0.0210, 'lps'),
	(452948, 125, '2015-03-15 00:16:06.000000', 'consum', 0.0212, 'lps'),
	(452949, 125, '2015-03-15 00:16:07.000000', 'consum', 0.0219, 'lps'),
	(452950, 125, '2015-03-15 00:16:08.000000', 'consum', 0.0212, 'lps'),
	(452951, 125, '2015-03-15 00:16:09.000000', 'consum', 0.0215, 'lps'),
	(452952, 125, '2015-03-15 00:16:10.000000', 'consum', 0.0226, 'lps'),
	(452953, 125, '2015-03-15 00:16:11.000000', 'consum', 0.0224, 'lps'),
	(452954, 125, '2015-03-15 00:16:12.000000', 'consum', 0.0215, 'lps'),
	(452955, 125, '2015-03-15 00:16:13.000000', 'consum', 0.0212, 'lps'),
	(452956, 125, '2015-03-15 00:16:14.000000', 'consum', 0.0222, 'lps'),
	(452957, 125, '2015-03-15 00:16:15.000000', 'consum', 0.0227, 'lps'),
	(452958, 125, '2015-03-15 00:16:16.000000', 'consum', 0.0226, 'lps'),
	(452959, 125, '2015-03-15 00:16:17.000000', 'consum', 0.0222, 'lps'),
	(452960, 125, '2015-03-15 00:16:18.000000', 'consum', 0.0223, 'lps'),
	(452961, 125, '2015-03-15 00:16:19.000000', 'consum', 0.0219, 'lps'),
	(452962, 125, '2015-03-15 00:16:20.000000', 'consum', 0.0218, 'lps'),
	(452963, 125, '2015-03-15 00:16:21.000000', 'consum', 0.0222, 'lps'),
	(452964, 125, '2015-03-15 00:16:22.000000', 'consum', 0.0210, 'lps'),
	(452965, 125, '2015-03-15 00:16:23.000000', 'consum', 0.0210, 'lps'),
	(452966, 125, '2015-03-15 00:16:24.000000', 'consum', 0.0212, 'lps'),
	(452967, 125, '2015-03-15 00:16:25.000000', 'consum', 0.0220, 'lps'),
	(452968, 125, '2015-03-15 00:16:26.000000', 'consum', 0.0218, 'lps'),
	(452969, 125, '2015-03-15 00:16:27.000000', 'consum', 0.0223, 'lps'),
	(452970, 125, '2015-03-15 00:16:28.000000', 'consum', 0.0213, 'lps'),
	(452971, 125, '2015-03-15 00:16:29.000000', 'consum', 0.0223, 'lps'),
	(452972, 125, '2015-03-15 00:16:30.000000', 'consum', 0.0211, 'lps'),
	(452973, 125, '2015-03-15 00:16:31.000000', 'consum', 0.0212, 'lps'),
	(452974, 125, '2015-03-15 00:16:32.000000', 'consum', 0.0219, 'lps'),
	(452975, 125, '2015-03-15 00:16:33.000000', 'consum', 0.0214, 'lps'),
	(452976, 125, '2015-03-15 00:16:34.000000', 'consum', 0.0220, 'lps'),
	(452977, 125, '2015-03-15 00:16:35.000000', 'consum', 0.0213, 'lps'),
	(452978, 125, '2015-03-15 00:16:36.000000', 'consum', 0.0215, 'lps'),
	(452979, 125, '2015-03-15 00:16:37.000000', 'consum', 0.0227, 'lps'),
	(452980, 125, '2015-03-15 00:16:38.000000', 'consum', 0.0225, 'lps'),
	(452981, 125, '2015-03-15 00:16:39.000000', 'consum', 0.0215, 'lps'),
	(452982, 125, '2015-03-15 00:16:40.000000', 'consum', 0.0227, 'lps'),
	(452983, 125, '2015-03-15 00:16:41.000000', 'consum', 0.0211, 'lps'),
	(452984, 125, '2015-03-15 00:16:42.000000', 'consum', 0.0215, 'lps'),
	(452985, 125, '2015-03-15 00:16:43.000000', 'consum', 0.0217, 'lps'),
	(452986, 125, '2015-03-15 00:16:44.000000', 'consum', 0.0213, 'lps'),
	(452987, 125, '2015-03-15 00:16:45.000000', 'consum', 0.0222, 'lps'),
	(452988, 125, '2015-03-15 00:16:46.000000', 'consum', 0.0226, 'lps'),
	(452989, 125, '2015-03-15 00:16:47.000000', 'consum', 0.0219, 'lps'),
	(452990, 125, '2015-03-15 00:16:48.000000', 'consum', 0.0226, 'lps'),
	(452991, 125, '2015-03-15 00:16:49.000000', 'consum', 0.0210, 'lps'),
	(452992, 125, '2015-03-15 00:16:50.000000', 'consum', 0.0214, 'lps'),
	(452993, 125, '2015-03-15 00:16:51.000000', 'consum', 0.0213, 'lps'),
	(452994, 125, '2015-03-15 00:16:52.000000', 'consum', 0.0212, 'lps'),
	(452995, 125, '2015-03-15 00:16:53.000000', 'consum', 0.0212, 'lps'),
	(452996, 125, '2015-03-15 00:16:54.000000', 'consum', 0.0215, 'lps'),
	(452997, 125, '2015-03-15 00:16:55.000000', 'consum', 0.0227, 'lps'),
	(452998, 125, '2015-03-15 00:16:56.000000', 'consum', 0.0212, 'lps'),
	(452999, 125, '2015-03-15 00:16:57.000000', 'consum', 0.0223, 'lps'),
	(453000, 125, '2015-03-15 00:16:58.000000', 'consum', 0.0213, 'lps'),
	(453001, 125, '2015-03-15 00:16:59.000000', 'consum', 0.0225, 'lps'),
	(453002, 125, '2015-03-15 00:17:00.000000', 'consum', 0.0222, 'lps'),
	(453003, 125, '2015-03-15 00:17:01.000000', 'consum', 0.0227, 'lps'),
	(453004, 125, '2015-03-15 00:17:02.000000', 'consum', 0.0222, 'lps'),
	(453005, 125, '2015-03-15 00:17:03.000000', 'consum', 0.0219, 'lps'),
	(453006, 125, '2015-03-15 00:17:04.000000', 'consum', 0.0220, 'lps'),
	(453007, 125, '2015-03-15 00:17:05.000000', 'consum', 0.0214, 'lps'),
	(453008, 125, '2015-03-15 00:17:06.000000', 'consum', 0.0220, 'lps'),
	(453009, 125, '2015-03-15 00:17:07.000000', 'consum', 0.0210, 'lps'),
	(453010, 125, '2015-03-15 00:17:08.000000', 'consum', 0.0219, 'lps'),
	(453011, 125, '2015-03-15 00:17:09.000000', 'consum', 0.0220, 'lps'),
	(453012, 125, '2015-03-15 00:17:10.000000', 'consum', 0.0216, 'lps'),
	(453013, 125, '2015-03-15 00:17:11.000000', 'consum', 0.0226, 'lps'),
	(453014, 125, '2015-03-15 00:17:12.000000', 'consum', 0.0220, 'lps'),
	(453015, 125, '2015-03-15 00:17:13.000000', 'consum', 0.0210, 'lps'),
	(453016, 125, '2015-03-15 00:17:14.000000', 'consum', 0.0219, 'lps'),
	(453017, 125, '2015-03-15 00:17:15.000000', 'consum', 0.0219, 'lps'),
	(453018, 125, '2015-03-15 00:17:16.000000', 'consum', 0.0227, 'lps'),
	(453019, 125, '2015-03-15 00:17:17.000000', 'consum', 0.0216, 'lps'),
	(453020, 125, '2015-03-15 00:17:18.000000', 'consum', 0.0226, 'lps'),
	(453021, 125, '2015-03-15 00:17:19.000000', 'consum', 0.0219, 'lps'),
	(453022, 125, '2015-03-15 00:17:20.000000', 'consum', 0.0224, 'lps'),
	(453023, 125, '2015-03-15 00:17:21.000000', 'consum', 0.0217, 'lps'),
	(453024, 125, '2015-03-15 00:17:22.000000', 'consum', 0.0221, 'lps'),
	(453025, 125, '2015-03-15 00:17:23.000000', 'consum', 0.0211, 'lps'),
	(453026, 125, '2015-03-15 00:17:24.000000', 'consum', 0.0216, 'lps'),
	(453027, 125, '2015-03-15 00:17:25.000000', 'consum', 0.0220, 'lps'),
	(453028, 125, '2015-03-15 00:17:26.000000', 'consum', 0.0225, 'lps'),
	(453029, 125, '2015-03-15 00:17:27.000000', 'consum', 0.0220, 'lps'),
	(453030, 125, '2015-03-15 00:17:28.000000', 'consum', 0.0214, 'lps'),
	(453031, 125, '2015-03-15 00:17:29.000000', 'consum', 0.0218, 'lps'),
	(453032, 125, '2015-03-15 00:17:30.000000', 'consum', 0.0220, 'lps'),
	(453033, 125, '2015-03-15 00:17:31.000000', 'consum', 0.0220, 'lps'),
	(453034, 125, '2015-03-15 00:17:32.000000', 'consum', 0.0212, 'lps'),
	(453035, 125, '2015-03-15 00:17:33.000000', 'consum', 0.0225, 'lps'),
	(453036, 125, '2015-03-15 00:17:34.000000', 'consum', 0.0225, 'lps'),
	(453037, 125, '2015-03-15 00:17:35.000000', 'consum', 0.0222, 'lps'),
	(453038, 125, '2015-03-15 00:17:36.000000', 'consum', 0.0226, 'lps'),
	(453039, 125, '2015-03-15 00:17:37.000000', 'consum', 0.0218, 'lps'),
	(453040, 125, '2015-03-15 00:17:38.000000', 'consum', 0.0221, 'lps'),
	(453041, 125, '2015-03-15 00:17:39.000000', 'consum', 0.0222, 'lps'),
	(453042, 125, '2015-03-15 00:17:40.000000', 'consum', 0.0220, 'lps'),
	(453043, 125, '2015-03-15 00:17:41.000000', 'consum', 0.0224, 'lps'),
	(453044, 125, '2015-03-15 00:17:42.000000', 'consum', 0.0215, 'lps'),
	(453045, 125, '2015-03-15 00:17:43.000000', 'consum', 0.0212, 'lps'),
	(453046, 125, '2015-03-15 00:17:44.000000', 'consum', 0.0225, 'lps'),
	(453047, 125, '2015-03-15 00:17:45.000000', 'consum', 0.0223, 'lps'),
	(453048, 125, '2015-03-15 00:17:46.000000', 'consum', 0.0212, 'lps'),
	(453049, 125, '2015-03-15 00:17:47.000000', 'consum', 0.0218, 'lps'),
	(453050, 125, '2015-03-15 00:17:48.000000', 'consum', 0.0225, 'lps'),
	(453051, 125, '2015-03-15 00:17:49.000000', 'consum', 0.0227, 'lps'),
	(453052, 125, '2015-03-15 00:17:50.000000', 'consum', 0.0213, 'lps'),
	(453053, 125, '2015-03-15 00:17:51.000000', 'consum', 0.0227, 'lps'),
	(453054, 125, '2015-03-15 00:17:52.000000', 'consum', 0.0218, 'lps'),
	(453055, 125, '2015-03-15 00:17:53.000000', 'consum', 0.0215, 'lps'),
	(453056, 125, '2015-03-15 00:17:54.000000', 'consum', 0.0212, 'lps'),
	(453057, 125, '2015-03-15 00:17:55.000000', 'consum', 0.0224, 'lps'),
	(453058, 125, '2015-03-15 00:17:56.000000', 'consum', 0.0220, 'lps'),
	(453059, 125, '2015-03-15 00:17:57.000000', 'consum', 0.0217, 'lps'),
	(453060, 125, '2015-03-15 00:17:58.000000', 'consum', 0.0215, 'lps'),
	(453061, 125, '2015-03-15 00:17:59.000000', 'consum', 0.0216, 'lps'),
	(453062, 125, '2015-03-15 00:18:00.000000', 'consum', 0.0225, 'lps'),
	(453063, 125, '2015-03-15 00:18:01.000000', 'consum', 0.0213, 'lps'),
	(453064, 125, '2015-03-15 00:18:02.000000', 'consum', 0.0215, 'lps'),
	(453065, 125, '2015-03-15 00:18:03.000000', 'consum', 0.0210, 'lps'),
	(453066, 125, '2015-03-15 00:18:04.000000', 'consum', 0.0214, 'lps'),
	(453067, 125, '2015-03-15 00:18:05.000000', 'consum', 0.0211, 'lps'),
	(453068, 125, '2015-03-15 00:18:06.000000', 'consum', 0.0224, 'lps'),
	(453069, 125, '2015-03-15 00:18:07.000000', 'consum', 0.0221, 'lps'),
	(453070, 125, '2015-03-15 00:18:08.000000', 'consum', 0.0226, 'lps'),
	(453071, 125, '2015-03-15 00:18:09.000000', 'consum', 0.0222, 'lps'),
	(453072, 125, '2015-03-15 00:18:10.000000', 'consum', 0.0219, 'lps'),
	(453073, 125, '2015-03-15 00:18:11.000000', 'consum', 0.0222, 'lps'),
	(453074, 125, '2015-03-15 00:18:12.000000', 'consum', 0.0226, 'lps'),
	(453075, 125, '2015-03-15 00:18:13.000000', 'consum', 0.0218, 'lps'),
	(453076, 125, '2015-03-15 00:18:14.000000', 'consum', 0.0220, 'lps'),
	(453077, 125, '2015-03-15 00:18:15.000000', 'consum', 0.0218, 'lps'),
	(453078, 125, '2015-03-15 00:18:16.000000', 'consum', 0.0222, 'lps'),
	(453079, 125, '2015-03-15 00:18:17.000000', 'consum', 0.0227, 'lps'),
	(453080, 125, '2015-03-15 00:18:18.000000', 'consum', 0.0224, 'lps'),
	(453081, 125, '2015-03-15 00:18:19.000000', 'consum', 0.0213, 'lps'),
	(453082, 125, '2015-03-15 00:18:20.000000', 'consum', 0.0220, 'lps'),
	(453083, 125, '2015-03-15 00:18:21.000000', 'consum', 0.0213, 'lps'),
	(453084, 125, '2015-03-15 00:18:22.000000', 'consum', 0.0214, 'lps'),
	(453085, 125, '2015-03-15 00:18:23.000000', 'consum', 0.0222, 'lps'),
	(453086, 125, '2015-03-15 00:18:24.000000', 'consum', 0.0222, 'lps'),
	(453087, 125, '2015-03-15 00:18:25.000000', 'consum', 0.0215, 'lps'),
	(453088, 125, '2015-03-15 00:18:26.000000', 'consum', 0.0218, 'lps'),
	(453089, 125, '2015-03-15 00:18:27.000000', 'consum', 0.0217, 'lps'),
	(453090, 125, '2015-03-15 00:18:28.000000', 'consum', 0.0222, 'lps'),
	(453091, 125, '2015-03-15 00:18:29.000000', 'consum', 0.0212, 'lps'),
	(453092, 125, '2015-03-15 00:18:30.000000', 'consum', 0.0223, 'lps'),
	(453093, 125, '2015-03-15 00:18:31.000000', 'consum', 0.0213, 'lps'),
	(453094, 125, '2015-03-15 00:18:32.000000', 'consum', 0.0222, 'lps'),
	(453095, 125, '2015-03-15 00:18:33.000000', 'consum', 0.0227, 'lps'),
	(453096, 125, '2015-03-15 00:18:34.000000', 'consum', 0.0222, 'lps'),
	(453097, 125, '2015-03-15 00:18:35.000000', 'consum', 0.0220, 'lps'),
	(453098, 125, '2015-03-15 00:18:36.000000', 'consum', 0.0226, 'lps'),
	(453099, 125, '2015-03-15 00:18:37.000000', 'consum', 0.0225, 'lps'),
	(453100, 125, '2015-03-15 00:18:38.000000', 'consum', 0.0220, 'lps'),
	(453101, 125, '2015-03-15 00:18:39.000000', 'consum', 0.0216, 'lps'),
	(453102, 125, '2015-03-15 00:18:40.000000', 'consum', 0.0226, 'lps'),
	(453103, 125, '2015-03-15 00:18:41.000000', 'consum', 0.0218, 'lps'),
	(453104, 125, '2015-03-15 00:18:42.000000', 'consum', 0.0222, 'lps'),
	(453105, 125, '2015-03-15 00:18:43.000000', 'consum', 0.0210, 'lps'),
	(453106, 125, '2015-03-15 00:18:44.000000', 'consum', 0.0227, 'lps'),
	(453107, 125, '2015-03-15 00:18:45.000000', 'consum', 0.0226, 'lps'),
	(453108, 125, '2015-03-15 00:18:46.000000', 'consum', 0.0221, 'lps'),
	(453109, 125, '2015-03-15 00:18:47.000000', 'consum', 0.0217, 'lps'),
	(453110, 125, '2015-03-15 00:18:48.000000', 'consum', 0.0214, 'lps'),
	(453111, 125, '2015-03-15 00:18:49.000000', 'consum', 0.0210, 'lps'),
	(453112, 125, '2015-03-15 00:18:50.000000', 'consum', 0.0216, 'lps'),
	(453113, 125, '2015-03-15 00:18:51.000000', 'consum', 0.0223, 'lps'),
	(453114, 125, '2015-03-15 00:18:52.000000', 'consum', 0.0222, 'lps'),
	(453115, 125, '2015-03-15 00:18:53.000000', 'consum', 0.0214, 'lps'),
	(453116, 125, '2015-03-15 00:18:54.000000', 'consum', 0.0210, 'lps'),
	(453117, 125, '2015-03-15 00:18:55.000000', 'consum', 0.0218, 'lps'),
	(453118, 125, '2015-03-15 00:18:56.000000', 'consum', 0.0214, 'lps'),
	(453119, 125, '2015-03-15 00:18:57.000000', 'consum', 0.0223, 'lps'),
	(453120, 125, '2015-03-15 00:18:58.000000', 'consum', 0.0211, 'lps'),
	(453121, 125, '2015-03-15 00:18:59.000000', 'consum', 0.0211, 'lps'),
	(453122, 125, '2015-03-15 00:19:00.000000', 'consum', 0.0212, 'lps'),
	(453123, 125, '2015-03-15 00:19:01.000000', 'consum', 0.0216, 'lps'),
	(453124, 125, '2015-03-15 00:19:02.000000', 'consum', 0.0220, 'lps'),
	(453125, 125, '2015-03-15 00:19:03.000000', 'consum', 0.0222, 'lps'),
	(453126, 125, '2015-03-15 00:19:04.000000', 'consum', 0.0225, 'lps'),
	(453127, 125, '2015-03-15 00:19:05.000000', 'consum', 0.0211, 'lps'),
	(453128, 125, '2015-03-15 00:19:06.000000', 'consum', 0.0225, 'lps'),
	(453129, 125, '2015-03-15 00:19:07.000000', 'consum', 0.0227, 'lps'),
	(453130, 125, '2015-03-15 00:19:08.000000', 'consum', 0.0217, 'lps'),
	(453131, 125, '2015-03-15 00:19:09.000000', 'consum', 0.0213, 'lps'),
	(453132, 125, '2015-03-15 00:19:10.000000', 'consum', 0.0220, 'lps'),
	(453133, 125, '2015-03-15 00:19:11.000000', 'consum', 0.0215, 'lps'),
	(453134, 125, '2015-03-15 00:19:12.000000', 'consum', 0.0225, 'lps'),
	(453135, 125, '2015-03-15 00:19:13.000000', 'consum', 0.0218, 'lps'),
	(453136, 125, '2015-03-15 00:19:14.000000', 'consum', 0.0223, 'lps'),
	(453137, 125, '2015-03-15 00:19:15.000000', 'consum', 0.0217, 'lps'),
	(453138, 125, '2015-03-15 00:19:16.000000', 'consum', 0.0223, 'lps'),
	(453139, 125, '2015-03-15 00:19:17.000000', 'consum', 0.0219, 'lps'),
	(453140, 125, '2015-03-15 00:19:18.000000', 'consum', 0.0216, 'lps'),
	(453141, 125, '2015-03-15 00:19:19.000000', 'consum', 0.0212, 'lps'),
	(453142, 125, '2015-03-15 00:19:20.000000', 'consum', 0.0223, 'lps'),
	(453143, 125, '2015-03-15 00:19:21.000000', 'consum', 0.0216, 'lps'),
	(453144, 125, '2015-03-15 00:19:22.000000', 'consum', 0.0219, 'lps'),
	(453145, 125, '2015-03-15 00:19:23.000000', 'consum', 0.0218, 'lps'),
	(453146, 125, '2015-03-15 00:19:24.000000', 'consum', 0.0226, 'lps'),
	(453147, 125, '2015-03-15 00:19:25.000000', 'consum', 0.0211, 'lps'),
	(453148, 125, '2015-03-15 00:19:26.000000', 'consum', 0.0221, 'lps'),
	(453149, 125, '2015-03-15 00:19:27.000000', 'consum', 0.0225, 'lps'),
	(453150, 125, '2015-03-15 00:19:28.000000', 'consum', 0.0219, 'lps'),
	(453151, 125, '2015-03-15 00:19:29.000000', 'consum', 0.0210, 'lps'),
	(453152, 125, '2015-03-15 00:19:30.000000', 'consum', 0.0218, 'lps'),
	(453153, 125, '2015-03-15 00:19:31.000000', 'consum', 0.0215, 'lps'),
	(453154, 125, '2015-03-15 00:19:32.000000', 'consum', 0.0212, 'lps'),
	(453155, 125, '2015-03-15 00:19:33.000000', 'consum', 0.0223, 'lps'),
	(453156, 125, '2015-03-15 00:19:34.000000', 'consum', 0.0214, 'lps'),
	(453157, 125, '2015-03-15 00:19:35.000000', 'consum', 0.0210, 'lps'),
	(453158, 125, '2015-03-15 00:19:36.000000', 'consum', 0.0216, 'lps'),
	(453159, 125, '2015-03-15 00:19:37.000000', 'consum', 0.0223, 'lps'),
	(453160, 125, '2015-03-15 00:19:38.000000', 'consum', 0.0223, 'lps'),
	(453161, 125, '2015-03-15 00:19:39.000000', 'consum', 0.0218, 'lps'),
	(453162, 125, '2015-03-15 00:19:40.000000', 'consum', 0.0210, 'lps'),
	(453163, 125, '2015-03-15 00:19:41.000000', 'consum', 0.0224, 'lps'),
	(453164, 125, '2015-03-15 00:19:42.000000', 'consum', 0.0210, 'lps'),
	(453165, 125, '2015-03-15 00:19:43.000000', 'consum', 0.0220, 'lps'),
	(453166, 125, '2015-03-15 00:19:44.000000', 'consum', 0.0224, 'lps'),
	(453167, 125, '2015-03-15 00:19:45.000000', 'consum', 0.0214, 'lps'),
	(453168, 125, '2015-03-15 00:19:46.000000', 'consum', 0.0210, 'lps'),
	(453169, 125, '2015-03-15 00:19:47.000000', 'consum', 0.0213, 'lps'),
	(453170, 125, '2015-03-15 00:19:48.000000', 'consum', 0.0225, 'lps'),
	(453171, 125, '2015-03-15 00:19:49.000000', 'consum', 0.0224, 'lps'),
	(453172, 125, '2015-03-15 00:19:50.000000', 'consum', 0.0217, 'lps'),
	(453173, 125, '2015-03-15 00:19:51.000000', 'consum', 0.0220, 'lps'),
	(453174, 125, '2015-03-15 00:19:52.000000', 'consum', 0.0223, 'lps'),
	(453175, 125, '2015-03-15 00:19:53.000000', 'consum', 0.0211, 'lps'),
	(453176, 125, '2015-03-15 00:19:54.000000', 'consum', 0.0210, 'lps'),
	(453177, 125, '2015-03-15 00:19:55.000000', 'consum', 0.0227, 'lps'),
	(453178, 125, '2015-03-15 00:19:56.000000', 'consum', 0.0224, 'lps'),
	(453179, 125, '2015-03-15 00:19:57.000000', 'consum', 0.0211, 'lps'),
	(453180, 125, '2015-03-15 00:19:58.000000', 'consum', 0.0226, 'lps'),
	(453181, 125, '2015-03-15 00:19:59.000000', 'consum', 0.0217, 'lps'),
	(453182, 125, '2015-03-15 00:20:00.000000', 'consum', 0.0213, 'lps'),
	(453183, 125, '2015-03-15 00:20:01.000000', 'consum', 0.0225, 'lps'),
	(453184, 125, '2015-03-15 00:20:02.000000', 'consum', 0.0220, 'lps'),
	(453185, 125, '2015-03-15 00:20:03.000000', 'consum', 0.0219, 'lps'),
	(453186, 125, '2015-03-15 00:20:04.000000', 'consum', 0.0223, 'lps'),
	(453187, 125, '2015-03-15 00:20:05.000000', 'consum', 0.0211, 'lps'),
	(453188, 125, '2015-03-15 00:20:06.000000', 'consum', 0.0215, 'lps'),
	(453189, 125, '2015-03-15 00:20:07.000000', 'consum', 0.0216, 'lps'),
	(453190, 125, '2015-03-15 00:20:08.000000', 'consum', 0.0222, 'lps'),
	(453191, 125, '2015-03-15 00:20:09.000000', 'consum', 0.0218, 'lps'),
	(453192, 125, '2015-03-15 00:20:10.000000', 'consum', 0.0213, 'lps'),
	(453193, 125, '2015-03-15 00:20:11.000000', 'consum', 0.0221, 'lps'),
	(453194, 125, '2015-03-15 00:20:12.000000', 'consum', 0.0222, 'lps'),
	(453195, 125, '2015-03-15 00:20:13.000000', 'consum', 0.0219, 'lps'),
	(453196, 125, '2015-03-15 00:20:14.000000', 'consum', 0.0219, 'lps'),
	(453197, 125, '2015-03-15 00:20:15.000000', 'consum', 0.0210, 'lps'),
	(453198, 125, '2015-03-15 00:20:16.000000', 'consum', 0.0218, 'lps'),
	(453199, 125, '2015-03-15 00:20:17.000000', 'consum', 0.0214, 'lps'),
	(453200, 125, '2015-03-15 00:20:18.000000', 'consum', 0.0210, 'lps'),
	(453201, 125, '2015-03-15 00:20:19.000000', 'consum', 0.0214, 'lps'),
	(453202, 125, '2015-03-15 00:20:20.000000', 'consum', 0.0212, 'lps'),
	(453203, 125, '2015-03-15 00:20:21.000000', 'consum', 0.0227, 'lps'),
	(453204, 125, '2015-03-15 00:20:22.000000', 'consum', 0.0217, 'lps'),
	(453205, 125, '2015-03-15 00:20:23.000000', 'consum', 0.0213, 'lps'),
	(453206, 125, '2015-03-15 00:20:24.000000', 'consum', 0.0220, 'lps'),
	(453207, 125, '2015-03-15 00:20:25.000000', 'consum', 0.0219, 'lps'),
	(453208, 125, '2015-03-15 00:20:26.000000', 'consum', 0.0224, 'lps'),
	(453209, 125, '2015-03-15 00:20:27.000000', 'consum', 0.0218, 'lps'),
	(453210, 125, '2015-03-15 00:20:28.000000', 'consum', 0.0225, 'lps'),
	(453211, 125, '2015-03-15 00:20:29.000000', 'consum', 0.0226, 'lps'),
	(453212, 125, '2015-03-15 00:20:30.000000', 'consum', 0.0211, 'lps'),
	(453213, 125, '2015-03-15 00:20:31.000000', 'consum', 0.0221, 'lps'),
	(453214, 125, '2015-03-15 00:20:32.000000', 'consum', 0.0210, 'lps'),
	(453215, 125, '2015-03-15 00:20:33.000000', 'consum', 0.0214, 'lps'),
	(453216, 125, '2015-03-15 00:20:34.000000', 'consum', 0.0210, 'lps'),
	(453217, 125, '2015-03-15 00:20:35.000000', 'consum', 0.0219, 'lps'),
	(453218, 125, '2015-03-15 00:20:36.000000', 'consum', 0.0219, 'lps'),
	(453219, 125, '2015-03-15 00:20:37.000000', 'consum', 0.0211, 'lps'),
	(453220, 125, '2015-03-15 00:20:38.000000', 'consum', 0.0223, 'lps'),
	(453221, 125, '2015-03-15 00:20:39.000000', 'consum', 0.0218, 'lps'),
	(453222, 125, '2015-03-15 00:20:40.000000', 'consum', 0.0212, 'lps'),
	(453223, 125, '2015-03-15 00:20:41.000000', 'consum', 0.0217, 'lps'),
	(453224, 125, '2015-03-15 00:20:42.000000', 'consum', 0.0219, 'lps'),
	(453225, 125, '2015-03-15 00:20:43.000000', 'consum', 0.0216, 'lps'),
	(453226, 125, '2015-03-15 00:20:44.000000', 'consum', 0.0213, 'lps'),
	(453227, 125, '2015-03-15 00:20:45.000000', 'consum', 0.0210, 'lps'),
	(453228, 125, '2015-03-15 00:20:46.000000', 'consum', 0.0217, 'lps'),
	(453229, 125, '2015-03-15 00:20:47.000000', 'consum', 0.0212, 'lps'),
	(453230, 125, '2015-03-15 00:20:48.000000', 'consum', 0.0218, 'lps'),
	(453231, 125, '2015-03-15 00:20:49.000000', 'consum', 0.0227, 'lps'),
	(453232, 125, '2015-03-15 00:20:50.000000', 'consum', 0.0216, 'lps'),
	(453233, 125, '2015-03-15 00:20:51.000000', 'consum', 0.0227, 'lps'),
	(453234, 125, '2015-03-15 00:20:52.000000', 'consum', 0.0221, 'lps'),
	(453235, 125, '2015-03-15 00:20:53.000000', 'consum', 0.0217, 'lps'),
	(453236, 125, '2015-03-15 00:20:54.000000', 'consum', 0.0210, 'lps'),
	(453237, 125, '2015-03-15 00:20:55.000000', 'consum', 0.0210, 'lps'),
	(453238, 125, '2015-03-15 00:20:56.000000', 'consum', 0.0210, 'lps'),
	(453239, 125, '2015-03-15 00:20:57.000000', 'consum', 0.0212, 'lps'),
	(453240, 125, '2015-03-15 00:20:58.000000', 'consum', 0.0219, 'lps'),
	(453241, 125, '2015-03-15 00:20:59.000000', 'consum', 0.0213, 'lps'),
	(453242, 125, '2015-03-15 00:21:00.000000', 'consum', 0.0218, 'lps'),
	(453243, 125, '2015-03-15 00:21:01.000000', 'consum', 0.0223, 'lps'),
	(453244, 125, '2015-03-15 00:21:02.000000', 'consum', 0.0216, 'lps'),
	(453245, 125, '2015-03-15 00:21:03.000000', 'consum', 0.0218, 'lps'),
	(453246, 125, '2015-03-15 00:21:04.000000', 'consum', 0.0214, 'lps'),
	(453247, 125, '2015-03-15 00:21:05.000000', 'consum', 0.0224, 'lps'),
	(453248, 125, '2015-03-15 00:21:06.000000', 'consum', 0.0216, 'lps'),
	(453249, 125, '2015-03-15 00:21:07.000000', 'consum', 0.0214, 'lps'),
	(453250, 125, '2015-03-15 00:21:08.000000', 'consum', 0.0216, 'lps'),
	(453251, 125, '2015-03-15 00:21:09.000000', 'consum', 0.0226, 'lps'),
	(453252, 125, '2015-03-15 00:21:10.000000', 'consum', 0.0218, 'lps'),
	(453253, 125, '2015-03-15 00:21:11.000000', 'consum', 0.0222, 'lps'),
	(453254, 125, '2015-03-15 00:21:12.000000', 'consum', 0.0227, 'lps'),
	(453255, 125, '2015-03-15 00:21:13.000000', 'consum', 0.0224, 'lps'),
	(453256, 125, '2015-03-15 00:21:14.000000', 'consum', 0.0211, 'lps'),
	(453257, 125, '2015-03-15 00:21:15.000000', 'consum', 0.0227, 'lps'),
	(453258, 125, '2015-03-15 00:21:16.000000', 'consum', 0.0221, 'lps'),
	(453259, 125, '2015-03-15 00:21:17.000000', 'consum', 0.0214, 'lps'),
	(453260, 125, '2015-03-15 00:21:18.000000', 'consum', 0.0218, 'lps'),
	(453261, 125, '2015-03-15 00:21:19.000000', 'consum', 0.0218, 'lps'),
	(453262, 125, '2015-03-15 00:21:20.000000', 'consum', 0.0210, 'lps'),
	(453263, 125, '2015-03-15 00:21:21.000000', 'consum', 0.0220, 'lps'),
	(453264, 125, '2015-03-15 00:21:22.000000', 'consum', 0.0210, 'lps'),
	(453265, 125, '2015-03-15 00:21:23.000000', 'consum', 0.0215, 'lps'),
	(453266, 125, '2015-03-15 00:21:24.000000', 'consum', 0.0218, 'lps'),
	(453267, 125, '2015-03-15 00:21:25.000000', 'consum', 0.0217, 'lps'),
	(453268, 125, '2015-03-15 00:21:26.000000', 'consum', 0.0222, 'lps'),
	(453269, 125, '2015-03-15 00:21:27.000000', 'consum', 0.0212, 'lps'),
	(453270, 125, '2015-03-15 00:21:28.000000', 'consum', 0.0223, 'lps'),
	(453271, 125, '2015-03-15 00:21:29.000000', 'consum', 0.0213, 'lps'),
	(453272, 125, '2015-03-15 00:21:30.000000', 'consum', 0.0223, 'lps'),
	(453273, 125, '2015-03-15 00:21:31.000000', 'consum', 0.0213, 'lps'),
	(453274, 125, '2015-03-15 00:21:32.000000', 'consum', 0.0222, 'lps'),
	(453275, 125, '2015-03-15 00:21:33.000000', 'consum', 0.0226, 'lps'),
	(453276, 125, '2015-03-15 00:21:34.000000', 'consum', 0.0217, 'lps'),
	(453277, 125, '2015-03-15 00:21:35.000000', 'consum', 0.0216, 'lps'),
	(453278, 125, '2015-03-15 00:21:36.000000', 'consum', 0.0218, 'lps'),
	(453279, 125, '2015-03-15 00:21:37.000000', 'consum', 0.0216, 'lps'),
	(453280, 125, '2015-03-15 00:21:38.000000', 'consum', 0.0217, 'lps'),
	(453281, 125, '2015-03-15 00:21:39.000000', 'consum', 0.0226, 'lps'),
	(453282, 125, '2015-03-15 00:21:40.000000', 'consum', 0.0215, 'lps'),
	(453283, 125, '2015-03-15 00:21:41.000000', 'consum', 0.0224, 'lps'),
	(453284, 125, '2015-03-15 00:21:42.000000', 'consum', 0.0210, 'lps'),
	(453285, 125, '2015-03-15 00:21:43.000000', 'consum', 0.0223, 'lps'),
	(453286, 125, '2015-03-15 00:21:44.000000', 'consum', 0.0222, 'lps'),
	(453287, 125, '2015-03-15 00:21:45.000000', 'consum', 0.0211, 'lps'),
	(453288, 125, '2015-03-15 00:21:46.000000', 'consum', 0.0219, 'lps'),
	(453289, 125, '2015-03-15 00:21:47.000000', 'consum', 0.0216, 'lps'),
	(453290, 125, '2015-03-15 00:21:48.000000', 'consum', 0.0211, 'lps'),
	(453291, 125, '2015-03-15 00:21:49.000000', 'consum', 0.0219, 'lps'),
	(453292, 125, '2015-03-15 00:21:50.000000', 'consum', 0.0213, 'lps'),
	(453293, 125, '2015-03-15 00:21:51.000000', 'consum', 0.0218, 'lps'),
	(453294, 125, '2015-03-15 00:21:52.000000', 'consum', 0.0225, 'lps'),
	(453295, 125, '2015-03-15 00:21:53.000000', 'consum', 0.0224, 'lps'),
	(453296, 125, '2015-03-15 00:21:54.000000', 'consum', 0.0217, 'lps'),
	(453297, 125, '2015-03-15 00:21:55.000000', 'consum', 0.0221, 'lps'),
	(453298, 125, '2015-03-15 00:21:56.000000', 'consum', 0.0227, 'lps'),
	(453299, 125, '2015-03-15 00:21:57.000000', 'consum', 0.0227, 'lps'),
	(453300, 125, '2015-03-15 00:21:58.000000', 'consum', 0.0227, 'lps'),
	(453301, 125, '2015-03-15 00:21:59.000000', 'consum', 0.0224, 'lps'),
	(453302, 125, '2015-03-15 00:22:00.000000', 'consum', 0.0212, 'lps'),
	(453303, 125, '2015-03-15 00:22:01.000000', 'consum', 0.0217, 'lps'),
	(453304, 125, '2015-03-15 00:22:02.000000', 'consum', 0.0219, 'lps'),
	(453305, 125, '2015-03-15 00:22:03.000000', 'consum', 0.0218, 'lps'),
	(453306, 125, '2015-03-15 00:22:04.000000', 'consum', 0.0221, 'lps'),
	(453307, 125, '2015-03-15 00:22:05.000000', 'consum', 0.0227, 'lps'),
	(453308, 125, '2015-03-15 00:22:06.000000', 'consum', 0.0224, 'lps'),
	(453309, 125, '2015-03-15 00:22:07.000000', 'consum', 0.0211, 'lps'),
	(453310, 125, '2015-03-15 00:22:08.000000', 'consum', 0.0210, 'lps'),
	(453311, 125, '2015-03-15 00:22:09.000000', 'consum', 0.0225, 'lps'),
	(453312, 125, '2015-03-15 00:22:10.000000', 'consum', 0.0214, 'lps'),
	(453313, 125, '2015-03-15 00:22:11.000000', 'consum', 0.0223, 'lps'),
	(453314, 125, '2015-03-15 00:22:12.000000', 'consum', 0.0227, 'lps'),
	(453315, 125, '2015-03-15 00:22:13.000000', 'consum', 0.0220, 'lps'),
	(453316, 125, '2015-03-15 00:22:14.000000', 'consum', 0.0210, 'lps'),
	(453317, 125, '2015-03-15 00:22:15.000000', 'consum', 0.0214, 'lps'),
	(453318, 125, '2015-03-15 00:22:16.000000', 'consum', 0.0216, 'lps'),
	(453319, 125, '2015-03-15 00:22:17.000000', 'consum', 0.0227, 'lps'),
	(453320, 125, '2015-03-15 00:22:18.000000', 'consum', 0.0224, 'lps'),
	(453321, 125, '2015-03-15 00:22:19.000000', 'consum', 0.0213, 'lps'),
	(453322, 125, '2015-03-15 00:22:20.000000', 'consum', 0.0218, 'lps'),
	(453323, 125, '2015-03-15 00:22:21.000000', 'consum', 0.0225, 'lps'),
	(453324, 125, '2015-03-15 00:22:22.000000', 'consum', 0.0226, 'lps'),
	(453325, 125, '2015-03-15 00:22:23.000000', 'consum', 0.0226, 'lps'),
	(453326, 125, '2015-03-15 00:22:24.000000', 'consum', 0.0223, 'lps'),
	(453327, 125, '2015-03-15 00:22:25.000000', 'consum', 0.0210, 'lps'),
	(453328, 125, '2015-03-15 00:22:26.000000', 'consum', 0.0225, 'lps'),
	(453329, 125, '2015-03-15 00:22:27.000000', 'consum', 0.0216, 'lps'),
	(453330, 125, '2015-03-15 00:22:28.000000', 'consum', 0.0214, 'lps'),
	(453331, 125, '2015-03-15 00:22:29.000000', 'consum', 0.0211, 'lps'),
	(453332, 125, '2015-03-15 00:22:30.000000', 'consum', 0.0220, 'lps'),
	(453333, 125, '2015-03-15 00:22:31.000000', 'consum', 0.0223, 'lps'),
	(453334, 125, '2015-03-15 00:22:32.000000', 'consum', 0.0210, 'lps'),
	(453335, 125, '2015-03-15 00:22:33.000000', 'consum', 0.0224, 'lps'),
	(453336, 125, '2015-03-15 00:22:34.000000', 'consum', 0.0210, 'lps'),
	(453337, 125, '2015-03-15 00:22:35.000000', 'consum', 0.0222, 'lps'),
	(453338, 125, '2015-03-15 00:22:36.000000', 'consum', 0.0218, 'lps'),
	(453339, 125, '2015-03-15 00:22:37.000000', 'consum', 0.0214, 'lps'),
	(453340, 125, '2015-03-15 00:22:38.000000', 'consum', 0.0224, 'lps'),
	(453341, 125, '2015-03-15 00:22:39.000000', 'consum', 0.0216, 'lps'),
	(453342, 125, '2015-03-15 00:22:40.000000', 'consum', 0.0217, 'lps'),
	(453343, 125, '2015-03-15 00:22:41.000000', 'consum', 0.0226, 'lps'),
	(453344, 125, '2015-03-15 00:22:42.000000', 'consum', 0.0217, 'lps'),
	(453345, 125, '2015-03-15 00:22:43.000000', 'consum', 0.0213, 'lps'),
	(453346, 125, '2015-03-15 00:22:44.000000', 'consum', 0.0224, 'lps'),
	(453347, 125, '2015-03-15 00:22:45.000000', 'consum', 0.0218, 'lps'),
	(453348, 125, '2015-03-15 00:22:46.000000', 'consum', 0.0227, 'lps'),
	(453349, 125, '2015-03-15 00:22:47.000000', 'consum', 0.0217, 'lps'),
	(453350, 125, '2015-03-15 00:22:48.000000', 'consum', 0.0211, 'lps'),
	(453351, 125, '2015-03-15 00:22:49.000000', 'consum', 0.0212, 'lps'),
	(453352, 125, '2015-03-15 00:22:50.000000', 'consum', 0.0218, 'lps'),
	(453353, 125, '2015-03-15 00:22:51.000000', 'consum', 0.0211, 'lps'),
	(453354, 125, '2015-03-15 00:22:52.000000', 'consum', 0.0224, 'lps'),
	(453355, 125, '2015-03-15 00:22:53.000000', 'consum', 0.0227, 'lps'),
	(453356, 125, '2015-03-15 00:22:54.000000', 'consum', 0.0214, 'lps'),
	(453357, 125, '2015-03-15 00:22:55.000000', 'consum', 0.0218, 'lps'),
	(453358, 125, '2015-03-15 00:22:56.000000', 'consum', 0.0219, 'lps'),
	(453359, 125, '2015-03-15 00:22:57.000000', 'consum', 0.0213, 'lps'),
	(453360, 125, '2015-03-15 00:22:58.000000', 'consum', 0.0217, 'lps'),
	(453361, 125, '2015-03-15 00:22:59.000000', 'consum', 0.0219, 'lps'),
	(453362, 125, '2015-03-15 00:23:00.000000', 'consum', 0.0216, 'lps'),
	(453363, 125, '2015-03-15 00:23:01.000000', 'consum', 0.0216, 'lps'),
	(453364, 125, '2015-03-15 00:23:02.000000', 'consum', 0.0219, 'lps'),
	(453365, 125, '2015-03-15 00:23:03.000000', 'consum', 0.0222, 'lps'),
	(453366, 125, '2015-03-15 00:23:04.000000', 'consum', 0.0225, 'lps'),
	(453367, 125, '2015-03-15 00:23:05.000000', 'consum', 0.0215, 'lps'),
	(453368, 125, '2015-03-15 00:23:06.000000', 'consum', 0.0223, 'lps'),
	(453369, 125, '2015-03-15 00:23:07.000000', 'consum', 0.0210, 'lps'),
	(453370, 125, '2015-03-15 00:23:08.000000', 'consum', 0.0225, 'lps'),
	(453371, 125, '2015-03-15 00:23:09.000000', 'consum', 0.0211, 'lps'),
	(453372, 125, '2015-03-15 00:23:10.000000', 'consum', 0.0227, 'lps'),
	(453373, 125, '2015-03-15 00:23:11.000000', 'consum', 0.0221, 'lps'),
	(453374, 125, '2015-03-15 00:23:12.000000', 'consum', 0.0213, 'lps'),
	(453375, 125, '2015-03-15 00:23:13.000000', 'consum', 0.0211, 'lps'),
	(453376, 125, '2015-03-15 00:23:14.000000', 'consum', 0.0225, 'lps'),
	(453377, 125, '2015-03-15 00:23:15.000000', 'consum', 0.0227, 'lps'),
	(453378, 125, '2015-03-15 00:23:16.000000', 'consum', 0.0217, 'lps'),
	(453379, 125, '2015-03-15 00:23:17.000000', 'consum', 0.0213, 'lps'),
	(453380, 125, '2015-03-15 00:23:18.000000', 'consum', 0.0219, 'lps'),
	(453381, 125, '2015-03-15 00:23:19.000000', 'consum', 0.0214, 'lps'),
	(453382, 125, '2015-03-15 00:23:20.000000', 'consum', 0.0219, 'lps'),
	(453383, 125, '2015-03-15 00:23:21.000000', 'consum', 0.0227, 'lps'),
	(453384, 125, '2015-03-15 00:23:22.000000', 'consum', 0.0214, 'lps'),
	(453385, 125, '2015-03-15 00:23:23.000000', 'consum', 0.0217, 'lps'),
	(453386, 125, '2015-03-15 00:23:24.000000', 'consum', 0.0216, 'lps'),
	(453387, 125, '2015-03-15 00:23:25.000000', 'consum', 0.0219, 'lps'),
	(453388, 125, '2015-03-15 00:23:26.000000', 'consum', 0.0218, 'lps'),
	(453389, 125, '2015-03-15 00:23:27.000000', 'consum', 0.0223, 'lps'),
	(453390, 125, '2015-03-15 00:23:28.000000', 'consum', 0.0217, 'lps'),
	(453391, 125, '2015-03-15 00:23:29.000000', 'consum', 0.0224, 'lps'),
	(453392, 125, '2015-03-15 00:23:30.000000', 'consum', 0.0224, 'lps'),
	(453393, 125, '2015-03-15 00:23:31.000000', 'consum', 0.0222, 'lps'),
	(453394, 125, '2015-03-15 00:23:32.000000', 'consum', 0.0225, 'lps'),
	(453395, 125, '2015-03-15 00:23:33.000000', 'consum', 0.0216, 'lps'),
	(453396, 125, '2015-03-15 00:23:34.000000', 'consum', 0.0213, 'lps'),
	(453397, 125, '2015-03-15 00:23:35.000000', 'consum', 0.0224, 'lps'),
	(453398, 125, '2015-03-15 00:23:36.000000', 'consum', 0.0220, 'lps'),
	(453399, 125, '2015-03-15 00:23:37.000000', 'consum', 0.0216, 'lps'),
	(453400, 125, '2015-03-15 00:23:38.000000', 'consum', 0.0210, 'lps'),
	(453401, 125, '2015-03-15 00:23:39.000000', 'consum', 0.0212, 'lps'),
	(453402, 125, '2015-03-15 00:23:40.000000', 'consum', 0.0220, 'lps'),
	(453403, 125, '2015-03-15 00:23:41.000000', 'consum', 0.0217, 'lps'),
	(453404, 125, '2015-03-15 00:23:42.000000', 'consum', 0.0218, 'lps'),
	(453405, 125, '2015-03-15 00:23:43.000000', 'consum', 0.0211, 'lps'),
	(453406, 125, '2015-03-15 00:23:44.000000', 'consum', 0.0211, 'lps'),
	(453407, 125, '2015-03-15 00:23:45.000000', 'consum', 0.0211, 'lps'),
	(453408, 125, '2015-03-15 00:23:46.000000', 'consum', 0.0211, 'lps'),
	(453409, 125, '2015-03-15 00:23:47.000000', 'consum', 0.0213, 'lps'),
	(453410, 125, '2015-03-15 00:23:48.000000', 'consum', 0.0222, 'lps'),
	(453411, 125, '2015-03-15 00:23:49.000000', 'consum', 0.0227, 'lps'),
	(453412, 125, '2015-03-15 00:23:50.000000', 'consum', 0.0221, 'lps'),
	(453413, 125, '2015-03-15 00:23:51.000000', 'consum', 0.0218, 'lps'),
	(453414, 125, '2015-03-15 00:23:52.000000', 'consum', 0.0215, 'lps'),
	(453415, 125, '2015-03-15 00:23:53.000000', 'consum', 0.0212, 'lps'),
	(453416, 125, '2015-03-15 00:23:54.000000', 'consum', 0.0225, 'lps'),
	(453417, 125, '2015-03-15 00:23:55.000000', 'consum', 0.0226, 'lps'),
	(453418, 125, '2015-03-15 00:23:56.000000', 'consum', 0.0227, 'lps'),
	(453419, 125, '2015-03-15 00:23:57.000000', 'consum', 0.0212, 'lps'),
	(453420, 125, '2015-03-15 00:23:58.000000', 'consum', 0.0224, 'lps'),
	(453421, 125, '2015-03-15 00:23:59.000000', 'consum', 0.0222, 'lps'),
	(453422, 125, '2015-03-15 00:24:00.000000', 'consum', 0.0226, 'lps'),
	(453423, 125, '2015-03-15 00:24:01.000000', 'consum', 0.0220, 'lps'),
	(453424, 125, '2015-03-15 00:24:02.000000', 'consum', 0.0211, 'lps'),
	(453425, 125, '2015-03-15 00:24:03.000000', 'consum', 0.0221, 'lps'),
	(453426, 125, '2015-03-15 00:24:04.000000', 'consum', 0.0211, 'lps'),
	(453427, 125, '2015-03-15 00:24:05.000000', 'consum', 0.0216, 'lps'),
	(453428, 125, '2015-03-15 00:24:06.000000', 'consum', 0.0220, 'lps'),
	(453429, 125, '2015-03-15 00:24:07.000000', 'consum', 0.0225, 'lps'),
	(453430, 125, '2015-03-15 00:24:08.000000', 'consum', 0.0220, 'lps'),
	(453431, 125, '2015-03-15 00:24:09.000000', 'consum', 0.0216, 'lps'),
	(453432, 125, '2015-03-15 00:24:10.000000', 'consum', 0.0211, 'lps'),
	(453433, 125, '2015-03-15 00:24:11.000000', 'consum', 0.0214, 'lps'),
	(453434, 125, '2015-03-15 00:24:12.000000', 'consum', 0.0210, 'lps'),
	(453435, 125, '2015-03-15 00:24:13.000000', 'consum', 0.0215, 'lps'),
	(453436, 125, '2015-03-15 00:24:14.000000', 'consum', 0.0220, 'lps'),
	(453437, 125, '2015-03-15 00:24:15.000000', 'consum', 0.0210, 'lps'),
	(453438, 125, '2015-03-15 00:24:16.000000', 'consum', 0.0215, 'lps'),
	(453439, 125, '2015-03-15 00:24:17.000000', 'consum', 0.0218, 'lps'),
	(453440, 125, '2015-03-15 00:24:18.000000', 'consum', 0.0217, 'lps'),
	(453441, 125, '2015-03-15 00:24:19.000000', 'consum', 0.0221, 'lps'),
	(453442, 125, '2015-03-15 00:24:20.000000', 'consum', 0.0210, 'lps'),
	(453443, 125, '2015-03-15 00:24:21.000000', 'consum', 0.0211, 'lps'),
	(453444, 125, '2015-03-15 00:24:22.000000', 'consum', 0.0218, 'lps'),
	(453445, 125, '2015-03-15 00:24:23.000000', 'consum', 0.0211, 'lps'),
	(453446, 125, '2015-03-15 00:24:24.000000', 'consum', 0.0226, 'lps'),
	(453447, 125, '2015-03-15 00:24:25.000000', 'consum', 0.0218, 'lps'),
	(453448, 125, '2015-03-15 00:24:26.000000', 'consum', 0.0218, 'lps'),
	(453449, 125, '2015-03-15 00:24:27.000000', 'consum', 0.0226, 'lps'),
	(453450, 125, '2015-03-15 00:24:28.000000', 'consum', 0.0212, 'lps'),
	(453451, 125, '2015-03-15 00:24:29.000000', 'consum', 0.0227, 'lps'),
	(453452, 125, '2015-03-15 00:24:30.000000', 'consum', 0.0217, 'lps'),
	(453453, 125, '2015-03-15 00:24:31.000000', 'consum', 0.0214, 'lps'),
	(453454, 125, '2015-03-15 00:24:32.000000', 'consum', 0.0210, 'lps'),
	(453455, 125, '2015-03-15 00:24:33.000000', 'consum', 0.0214, 'lps'),
	(453456, 125, '2015-03-15 00:24:34.000000', 'consum', 0.0214, 'lps'),
	(453457, 125, '2015-03-15 00:24:35.000000', 'consum', 0.0220, 'lps'),
	(453458, 125, '2015-03-15 00:24:36.000000', 'consum', 0.0211, 'lps'),
	(453459, 125, '2015-03-15 00:24:37.000000', 'consum', 0.0221, 'lps'),
	(453460, 125, '2015-03-15 00:24:38.000000', 'consum', 0.0225, 'lps'),
	(453461, 125, '2015-03-15 00:24:39.000000', 'consum', 0.0219, 'lps'),
	(453462, 125, '2015-03-15 00:24:40.000000', 'consum', 0.0211, 'lps'),
	(453463, 125, '2015-03-15 00:24:41.000000', 'consum', 0.0225, 'lps'),
	(453464, 125, '2015-03-15 00:24:42.000000', 'consum', 0.0210, 'lps'),
	(453465, 125, '2015-03-15 00:24:43.000000', 'consum', 0.0219, 'lps'),
	(453466, 125, '2015-03-15 00:24:44.000000', 'consum', 0.0219, 'lps'),
	(453467, 125, '2015-03-15 00:24:45.000000', 'consum', 0.0211, 'lps'),
	(453468, 125, '2015-03-15 00:24:46.000000', 'consum', 0.0225, 'lps'),
	(453469, 125, '2015-03-15 00:24:47.000000', 'consum', 0.0212, 'lps'),
	(453470, 125, '2015-03-15 00:24:48.000000', 'consum', 0.0211, 'lps'),
	(453471, 125, '2015-03-15 00:24:49.000000', 'consum', 0.0226, 'lps'),
	(453472, 125, '2015-03-15 00:24:50.000000', 'consum', 0.0217, 'lps'),
	(453473, 125, '2015-03-15 00:24:51.000000', 'consum', 0.0216, 'lps'),
	(453474, 125, '2015-03-15 00:24:52.000000', 'consum', 0.0219, 'lps'),
	(453475, 125, '2015-03-15 00:24:53.000000', 'consum', 0.0219, 'lps'),
	(453476, 125, '2015-03-15 00:24:54.000000', 'consum', 0.0213, 'lps'),
	(453477, 125, '2015-03-15 00:24:55.000000', 'consum', 0.0213, 'lps'),
	(453478, 125, '2015-03-15 00:24:56.000000', 'consum', 0.0220, 'lps'),
	(453479, 125, '2015-03-15 00:24:57.000000', 'consum', 0.0213, 'lps'),
	(453480, 125, '2015-03-15 00:24:58.000000', 'consum', 0.0213, 'lps'),
	(453481, 125, '2015-03-15 00:24:59.000000', 'consum', 0.0216, 'lps'),
	(453482, 125, '2015-03-15 00:25:00.000000', 'consum', 0.0213, 'lps'),
	(453483, 125, '2015-03-15 00:25:01.000000', 'consum', 0.0210, 'lps'),
	(453484, 125, '2015-03-15 00:25:02.000000', 'consum', 0.0218, 'lps'),
	(453485, 125, '2015-03-15 00:25:03.000000', 'consum', 0.0216, 'lps'),
	(453486, 125, '2015-03-15 00:25:04.000000', 'consum', 0.0216, 'lps'),
	(453487, 125, '2015-03-15 00:25:05.000000', 'consum', 0.0224, 'lps'),
	(453488, 125, '2015-03-15 00:25:06.000000', 'consum', 0.0223, 'lps'),
	(453489, 125, '2015-03-15 00:25:07.000000', 'consum', 0.0219, 'lps'),
	(453490, 125, '2015-03-15 00:25:08.000000', 'consum', 0.0214, 'lps'),
	(453491, 125, '2015-03-15 00:25:09.000000', 'consum', 0.0224, 'lps'),
	(453492, 125, '2015-03-15 00:25:10.000000', 'consum', 0.0211, 'lps'),
	(453493, 125, '2015-03-15 00:25:11.000000', 'consum', 0.0213, 'lps'),
	(453494, 125, '2015-03-15 00:25:12.000000', 'consum', 0.0221, 'lps'),
	(453495, 125, '2015-03-15 00:25:13.000000', 'consum', 0.0222, 'lps'),
	(453496, 125, '2015-03-15 00:25:14.000000', 'consum', 0.0217, 'lps'),
	(453497, 125, '2015-03-15 00:25:15.000000', 'consum', 0.0211, 'lps'),
	(453498, 125, '2015-03-15 00:25:16.000000', 'consum', 0.0213, 'lps'),
	(453499, 125, '2015-03-15 00:25:17.000000', 'consum', 0.0220, 'lps'),
	(453500, 125, '2015-03-15 00:25:18.000000', 'consum', 0.0217, 'lps'),
	(453501, 125, '2015-03-15 00:25:19.000000', 'consum', 0.0214, 'lps'),
	(453502, 125, '2015-03-15 00:25:20.000000', 'consum', 0.0227, 'lps'),
	(453503, 125, '2015-03-15 00:25:21.000000', 'consum', 0.0215, 'lps'),
	(453504, 125, '2015-03-15 00:25:22.000000', 'consum', 0.0217, 'lps'),
	(453505, 125, '2015-03-15 00:25:23.000000', 'consum', 0.0214, 'lps'),
	(453506, 125, '2015-03-15 00:25:24.000000', 'consum', 0.0210, 'lps'),
	(453507, 125, '2015-03-15 00:25:25.000000', 'consum', 0.0217, 'lps'),
	(453508, 125, '2015-03-15 00:25:26.000000', 'consum', 0.0225, 'lps'),
	(453509, 125, '2015-03-15 00:25:27.000000', 'consum', 0.0213, 'lps'),
	(453510, 125, '2015-03-15 00:25:28.000000', 'consum', 0.0218, 'lps'),
	(453511, 125, '2015-03-15 00:25:29.000000', 'consum', 0.0220, 'lps'),
	(453512, 125, '2015-03-15 00:25:30.000000', 'consum', 0.0222, 'lps'),
	(453513, 125, '2015-03-15 00:25:31.000000', 'consum', 0.0220, 'lps'),
	(453514, 125, '2015-03-15 00:25:32.000000', 'consum', 0.0225, 'lps'),
	(453515, 125, '2015-03-15 00:25:33.000000', 'consum', 0.0221, 'lps'),
	(453516, 125, '2015-03-15 00:25:34.000000', 'consum', 0.0220, 'lps'),
	(453517, 125, '2015-03-15 00:25:35.000000', 'consum', 0.0210, 'lps'),
	(453518, 125, '2015-03-15 00:25:36.000000', 'consum', 0.0217, 'lps'),
	(453519, 125, '2015-03-15 00:25:37.000000', 'consum', 0.0210, 'lps'),
	(453520, 125, '2015-03-15 00:25:38.000000', 'consum', 0.0224, 'lps'),
	(453521, 125, '2015-03-15 00:25:39.000000', 'consum', 0.0227, 'lps'),
	(453522, 125, '2015-03-15 00:25:40.000000', 'consum', 0.0219, 'lps'),
	(453523, 125, '2015-03-15 00:25:41.000000', 'consum', 0.0220, 'lps'),
	(453524, 125, '2015-03-15 00:25:42.000000', 'consum', 0.0218, 'lps'),
	(453525, 125, '2015-03-15 00:25:43.000000', 'consum', 0.0219, 'lps'),
	(453526, 125, '2015-03-15 00:25:44.000000', 'consum', 0.0215, 'lps'),
	(453527, 125, '2015-03-15 00:25:45.000000', 'consum', 0.0227, 'lps'),
	(453528, 125, '2015-03-15 00:25:46.000000', 'consum', 0.0224, 'lps'),
	(453529, 125, '2015-03-15 00:25:47.000000', 'consum', 0.0211, 'lps'),
	(453530, 125, '2015-03-15 00:25:48.000000', 'consum', 0.0210, 'lps'),
	(453531, 125, '2015-03-15 00:25:49.000000', 'consum', 0.0227, 'lps'),
	(453532, 125, '2015-03-15 00:25:50.000000', 'consum', 0.0221, 'lps'),
	(453533, 125, '2015-03-15 00:25:51.000000', 'consum', 0.0215, 'lps'),
	(453534, 125, '2015-03-15 00:25:52.000000', 'consum', 0.0220, 'lps'),
	(453535, 125, '2015-03-15 00:25:53.000000', 'consum', 0.0212, 'lps'),
	(453536, 125, '2015-03-15 00:25:54.000000', 'consum', 0.0226, 'lps'),
	(453537, 125, '2015-03-15 00:25:55.000000', 'consum', 0.0211, 'lps'),
	(453538, 125, '2015-03-15 00:25:56.000000', 'consum', 0.0222, 'lps'),
	(453539, 125, '2015-03-15 00:25:57.000000', 'consum', 0.0212, 'lps'),
	(453540, 125, '2015-03-15 00:25:58.000000', 'consum', 0.0221, 'lps'),
	(453541, 125, '2015-03-15 00:25:59.000000', 'consum', 0.0223, 'lps'),
	(453542, 125, '2015-03-15 00:26:00.000000', 'consum', 0.0226, 'lps'),
	(453543, 125, '2015-03-15 00:26:01.000000', 'consum', 0.0216, 'lps'),
	(453544, 125, '2015-03-15 00:26:02.000000', 'consum', 0.0226, 'lps'),
	(453545, 125, '2015-03-15 00:26:03.000000', 'consum', 0.0221, 'lps'),
	(453546, 125, '2015-03-15 00:26:04.000000', 'consum', 0.0218, 'lps'),
	(453547, 125, '2015-03-15 00:26:05.000000', 'consum', 0.0217, 'lps'),
	(453548, 125, '2015-03-15 00:26:06.000000', 'consum', 0.0223, 'lps'),
	(453549, 125, '2015-03-15 00:26:07.000000', 'consum', 0.0216, 'lps'),
	(453550, 125, '2015-03-15 00:26:08.000000', 'consum', 0.0222, 'lps'),
	(453551, 125, '2015-03-15 00:26:09.000000', 'consum', 0.0217, 'lps'),
	(453552, 125, '2015-03-15 00:26:10.000000', 'consum', 0.0225, 'lps'),
	(453553, 125, '2015-03-15 00:26:11.000000', 'consum', 0.0212, 'lps'),
	(453554, 125, '2015-03-15 00:26:12.000000', 'consum', 0.0213, 'lps'),
	(453555, 125, '2015-03-15 00:26:13.000000', 'consum', 0.0217, 'lps'),
	(453556, 125, '2015-03-15 00:26:14.000000', 'consum', 0.0219, 'lps'),
	(453557, 125, '2015-03-15 00:26:15.000000', 'consum', 0.0217, 'lps'),
	(453558, 125, '2015-03-15 00:26:16.000000', 'consum', 0.0220, 'lps'),
	(453559, 125, '2015-03-15 00:26:17.000000', 'consum', 0.0218, 'lps'),
	(453560, 125, '2015-03-15 00:26:18.000000', 'consum', 0.0223, 'lps'),
	(453561, 125, '2015-03-15 00:26:19.000000', 'consum', 0.0217, 'lps'),
	(453562, 125, '2015-03-15 00:26:20.000000', 'consum', 0.0221, 'lps'),
	(453563, 125, '2015-03-15 00:26:21.000000', 'consum', 0.0227, 'lps'),
	(453564, 125, '2015-03-15 00:26:22.000000', 'consum', 0.0211, 'lps'),
	(453565, 125, '2015-03-15 00:26:23.000000', 'consum', 0.0217, 'lps'),
	(453566, 125, '2015-03-15 00:26:24.000000', 'consum', 0.0225, 'lps'),
	(453567, 125, '2015-03-15 00:26:25.000000', 'consum', 0.0227, 'lps'),
	(453568, 125, '2015-03-15 00:26:26.000000', 'consum', 0.0217, 'lps'),
	(453569, 125, '2015-03-15 00:26:27.000000', 'consum', 0.0211, 'lps'),
	(453570, 125, '2015-03-15 00:26:28.000000', 'consum', 0.0211, 'lps'),
	(453571, 125, '2015-03-15 00:26:29.000000', 'consum', 0.0215, 'lps'),
	(453572, 125, '2015-03-15 00:26:30.000000', 'consum', 0.0213, 'lps'),
	(453573, 125, '2015-03-15 00:26:31.000000', 'consum', 0.0212, 'lps'),
	(453574, 125, '2015-03-15 00:26:32.000000', 'consum', 0.0210, 'lps'),
	(453575, 125, '2015-03-15 00:26:33.000000', 'consum', 0.0222, 'lps'),
	(453576, 125, '2015-03-15 00:26:34.000000', 'consum', 0.0216, 'lps'),
	(453577, 125, '2015-03-15 00:26:35.000000', 'consum', 0.0225, 'lps'),
	(453578, 125, '2015-03-15 00:26:36.000000', 'consum', 0.0212, 'lps'),
	(453579, 125, '2015-03-15 00:26:37.000000', 'consum', 0.0214, 'lps'),
	(453580, 125, '2015-03-15 00:26:38.000000', 'consum', 0.0222, 'lps'),
	(453581, 125, '2015-03-15 00:26:39.000000', 'consum', 0.0223, 'lps'),
	(453582, 125, '2015-03-15 00:26:40.000000', 'consum', 0.0223, 'lps'),
	(453583, 125, '2015-03-15 00:26:41.000000', 'consum', 0.0216, 'lps'),
	(453584, 125, '2015-03-15 00:26:42.000000', 'consum', 0.0222, 'lps'),
	(453585, 125, '2015-03-15 00:26:43.000000', 'consum', 0.0213, 'lps'),
	(453586, 125, '2015-03-15 00:26:44.000000', 'consum', 0.0211, 'lps'),
	(453587, 125, '2015-03-15 00:26:45.000000', 'consum', 0.0224, 'lps'),
	(453588, 125, '2015-03-15 00:26:46.000000', 'consum', 0.0224, 'lps'),
	(453589, 125, '2015-03-15 00:26:47.000000', 'consum', 0.0221, 'lps'),
	(453590, 125, '2015-03-15 00:26:48.000000', 'consum', 0.0222, 'lps'),
	(453591, 125, '2015-03-15 00:26:49.000000', 'consum', 0.0219, 'lps'),
	(453592, 125, '2015-03-15 00:26:50.000000', 'consum', 0.0219, 'lps'),
	(453593, 125, '2015-03-15 00:26:51.000000', 'consum', 0.0227, 'lps'),
	(453594, 125, '2015-03-15 00:26:52.000000', 'consum', 0.0217, 'lps'),
	(453595, 125, '2015-03-15 00:26:53.000000', 'consum', 0.0212, 'lps'),
	(453596, 125, '2015-03-15 00:26:54.000000', 'consum', 0.0218, 'lps'),
	(453597, 125, '2015-03-15 00:26:55.000000', 'consum', 0.0224, 'lps'),
	(453598, 125, '2015-03-15 00:26:56.000000', 'consum', 0.0223, 'lps'),
	(453599, 125, '2015-03-15 00:26:57.000000', 'consum', 0.0214, 'lps'),
	(453600, 125, '2015-03-15 00:26:58.000000', 'consum', 0.0212, 'lps'),
	(453601, 125, '2015-03-15 00:26:59.000000', 'consum', 0.0223, 'lps'),
	(453602, 125, '2015-03-15 00:27:00.000000', 'consum', 0.0218, 'lps'),
	(453603, 125, '2015-03-15 00:27:01.000000', 'consum', 0.0213, 'lps'),
	(453604, 125, '2015-03-15 00:27:02.000000', 'consum', 0.0216, 'lps'),
	(453605, 125, '2015-03-15 00:27:03.000000', 'consum', 0.0216, 'lps'),
	(453606, 125, '2015-03-15 00:27:04.000000', 'consum', 0.0220, 'lps'),
	(453607, 125, '2015-03-15 00:27:05.000000', 'consum', 0.0224, 'lps'),
	(453608, 125, '2015-03-15 00:27:06.000000', 'consum', 0.0217, 'lps'),
	(453609, 125, '2015-03-15 00:27:07.000000', 'consum', 0.0219, 'lps'),
	(453610, 125, '2015-03-15 00:27:08.000000', 'consum', 0.0216, 'lps'),
	(453611, 125, '2015-03-15 00:27:09.000000', 'consum', 0.0215, 'lps'),
	(453612, 125, '2015-03-15 00:27:10.000000', 'consum', 0.0216, 'lps'),
	(453613, 125, '2015-03-15 00:27:11.000000', 'consum', 0.0227, 'lps'),
	(453614, 125, '2015-03-15 00:27:12.000000', 'consum', 0.0221, 'lps'),
	(453615, 125, '2015-03-15 00:27:13.000000', 'consum', 0.0218, 'lps'),
	(453616, 125, '2015-03-15 00:27:14.000000', 'consum', 0.0216, 'lps'),
	(453617, 125, '2015-03-15 00:27:15.000000', 'consum', 0.0217, 'lps'),
	(453618, 125, '2015-03-15 00:27:16.000000', 'consum', 0.0210, 'lps'),
	(453619, 125, '2015-03-15 00:27:17.000000', 'consum', 0.0225, 'lps'),
	(453620, 125, '2015-03-15 00:27:18.000000', 'consum', 0.0212, 'lps'),
	(453621, 125, '2015-03-15 00:27:19.000000', 'consum', 0.0213, 'lps'),
	(453622, 125, '2015-03-15 00:27:20.000000', 'consum', 0.0218, 'lps'),
	(453623, 125, '2015-03-15 00:27:21.000000', 'consum', 0.0225, 'lps'),
	(453624, 125, '2015-03-15 00:27:22.000000', 'consum', 0.0227, 'lps'),
	(453625, 125, '2015-03-15 00:27:23.000000', 'consum', 0.0212, 'lps'),
	(453626, 125, '2015-03-15 00:27:24.000000', 'consum', 0.0222, 'lps'),
	(453627, 125, '2015-03-15 00:27:25.000000', 'consum', 0.0213, 'lps'),
	(453628, 125, '2015-03-15 00:27:26.000000', 'consum', 0.0225, 'lps'),
	(453629, 125, '2015-03-15 00:27:27.000000', 'consum', 0.0220, 'lps'),
	(453630, 125, '2015-03-15 00:27:28.000000', 'consum', 0.0219, 'lps'),
	(453631, 125, '2015-03-15 00:27:29.000000', 'consum', 0.0225, 'lps'),
	(453632, 125, '2015-03-15 00:27:30.000000', 'consum', 0.0223, 'lps'),
	(453633, 125, '2015-03-15 00:27:31.000000', 'consum', 0.0214, 'lps'),
	(453634, 125, '2015-03-15 00:27:32.000000', 'consum', 0.0225, 'lps'),
	(453635, 125, '2015-03-15 00:27:33.000000', 'consum', 0.0222, 'lps'),
	(453636, 125, '2015-03-15 00:27:34.000000', 'consum', 0.0224, 'lps'),
	(453637, 125, '2015-03-15 00:27:35.000000', 'consum', 0.0225, 'lps'),
	(453638, 125, '2015-03-15 00:27:36.000000', 'consum', 0.0225, 'lps'),
	(453639, 125, '2015-03-15 00:27:37.000000', 'consum', 0.0225, 'lps'),
	(453640, 125, '2015-03-15 00:27:38.000000', 'consum', 0.0223, 'lps'),
	(453641, 125, '2015-03-15 00:27:39.000000', 'consum', 0.0211, 'lps'),
	(453642, 125, '2015-03-15 00:27:40.000000', 'consum', 0.0211, 'lps'),
	(453643, 125, '2015-03-15 00:27:41.000000', 'consum', 0.0214, 'lps'),
	(453644, 125, '2015-03-15 00:27:42.000000', 'consum', 0.0226, 'lps'),
	(453645, 125, '2015-03-15 00:27:43.000000', 'consum', 0.0225, 'lps'),
	(453646, 125, '2015-03-15 00:27:44.000000', 'consum', 0.0221, 'lps'),
	(453647, 125, '2015-03-15 00:27:45.000000', 'consum', 0.0220, 'lps'),
	(453648, 125, '2015-03-15 00:27:46.000000', 'consum', 0.0226, 'lps'),
	(453649, 125, '2015-03-15 00:27:47.000000', 'consum', 0.0225, 'lps'),
	(453650, 125, '2015-03-15 00:27:48.000000', 'consum', 0.0220, 'lps'),
	(453651, 125, '2015-03-15 00:27:49.000000', 'consum', 0.0215, 'lps'),
	(453652, 125, '2015-03-15 00:27:50.000000', 'consum', 0.0222, 'lps'),
	(453653, 125, '2015-03-15 00:27:51.000000', 'consum', 0.0221, 'lps'),
	(453654, 125, '2015-03-15 00:27:52.000000', 'consum', 0.0211, 'lps'),
	(453655, 125, '2015-03-15 00:27:53.000000', 'consum', 0.0217, 'lps'),
	(453656, 125, '2015-03-15 00:27:54.000000', 'consum', 0.0227, 'lps'),
	(453657, 125, '2015-03-15 00:27:55.000000', 'consum', 0.0219, 'lps'),
	(453658, 125, '2015-03-15 00:27:56.000000', 'consum', 0.0221, 'lps'),
	(453659, 125, '2015-03-15 00:27:57.000000', 'consum', 0.0223, 'lps'),
	(453660, 125, '2015-03-15 00:27:58.000000', 'consum', 0.0222, 'lps'),
	(453661, 125, '2015-03-15 00:27:59.000000', 'consum', 0.0214, 'lps'),
	(453662, 125, '2015-03-15 00:28:00.000000', 'consum', 0.0212, 'lps'),
	(453663, 125, '2015-03-15 00:28:01.000000', 'consum', 0.0225, 'lps'),
	(453664, 125, '2015-03-15 00:28:02.000000', 'consum', 0.0211, 'lps'),
	(453665, 125, '2015-03-15 00:28:03.000000', 'consum', 0.0222, 'lps'),
	(453666, 125, '2015-03-15 00:28:04.000000', 'consum', 0.0213, 'lps'),
	(453667, 125, '2015-03-15 00:28:05.000000', 'consum', 0.0225, 'lps'),
	(453668, 125, '2015-03-15 00:28:06.000000', 'consum', 0.0222, 'lps'),
	(453669, 125, '2015-03-15 00:28:07.000000', 'consum', 0.0227, 'lps'),
	(453670, 125, '2015-03-15 00:28:08.000000', 'consum', 0.0221, 'lps'),
	(453671, 125, '2015-03-15 00:28:09.000000', 'consum', 0.0217, 'lps'),
	(453672, 125, '2015-03-15 00:28:10.000000', 'consum', 0.0212, 'lps'),
	(453673, 125, '2015-03-15 00:28:11.000000', 'consum', 0.0219, 'lps'),
	(453674, 125, '2015-03-15 00:28:12.000000', 'consum', 0.0214, 'lps'),
	(453675, 125, '2015-03-15 00:28:13.000000', 'consum', 0.0222, 'lps'),
	(453676, 125, '2015-03-15 00:28:14.000000', 'consum', 0.0220, 'lps'),
	(453677, 125, '2015-03-15 00:28:15.000000', 'consum', 0.0223, 'lps'),
	(453678, 125, '2015-03-15 00:28:16.000000', 'consum', 0.0213, 'lps'),
	(453679, 125, '2015-03-15 00:28:17.000000', 'consum', 0.0221, 'lps'),
	(453680, 125, '2015-03-15 00:28:18.000000', 'consum', 0.0221, 'lps'),
	(453681, 125, '2015-03-15 00:28:19.000000', 'consum', 0.0213, 'lps'),
	(453682, 125, '2015-03-15 00:28:20.000000', 'consum', 0.0210, 'lps'),
	(453683, 125, '2015-03-15 00:28:21.000000', 'consum', 0.0218, 'lps'),
	(453684, 125, '2015-03-15 00:28:22.000000', 'consum', 0.0218, 'lps'),
	(453685, 125, '2015-03-15 00:28:23.000000', 'consum', 0.0226, 'lps'),
	(453686, 125, '2015-03-15 00:28:24.000000', 'consum', 0.0214, 'lps'),
	(453687, 125, '2015-03-15 00:28:25.000000', 'consum', 0.0217, 'lps'),
	(453688, 125, '2015-03-15 00:28:26.000000', 'consum', 0.0214, 'lps'),
	(453689, 125, '2015-03-15 00:28:27.000000', 'consum', 0.0227, 'lps'),
	(453690, 125, '2015-03-15 00:28:28.000000', 'consum', 0.0214, 'lps'),
	(453691, 125, '2015-03-15 00:28:29.000000', 'consum', 0.0216, 'lps'),
	(453692, 125, '2015-03-15 00:28:30.000000', 'consum', 0.0227, 'lps'),
	(453693, 125, '2015-03-15 00:28:31.000000', 'consum', 0.0226, 'lps'),
	(453694, 125, '2015-03-15 00:28:32.000000', 'consum', 0.0220, 'lps'),
	(453695, 125, '2015-03-15 00:28:33.000000', 'consum', 0.0212, 'lps'),
	(453696, 125, '2015-03-15 00:28:34.000000', 'consum', 0.0226, 'lps'),
	(453697, 125, '2015-03-15 00:28:35.000000', 'consum', 0.0212, 'lps'),
	(453698, 125, '2015-03-15 00:28:36.000000', 'consum', 0.0211, 'lps'),
	(453699, 125, '2015-03-15 00:28:37.000000', 'consum', 0.0227, 'lps'),
	(453700, 125, '2015-03-15 00:28:38.000000', 'consum', 0.0221, 'lps'),
	(453701, 125, '2015-03-15 00:28:39.000000', 'consum', 0.0212, 'lps'),
	(453702, 125, '2015-03-15 00:28:40.000000', 'consum', 0.0224, 'lps'),
	(453703, 125, '2015-03-15 00:28:41.000000', 'consum', 0.0221, 'lps'),
	(453704, 125, '2015-03-15 00:28:42.000000', 'consum', 0.0224, 'lps'),
	(453705, 125, '2015-03-15 00:28:43.000000', 'consum', 0.0211, 'lps'),
	(453706, 125, '2015-03-15 00:28:44.000000', 'consum', 0.0226, 'lps'),
	(453707, 125, '2015-03-15 00:28:45.000000', 'consum', 0.0219, 'lps'),
	(453708, 125, '2015-03-15 00:28:46.000000', 'consum', 0.0223, 'lps'),
	(453709, 125, '2015-03-15 00:28:47.000000', 'consum', 0.0211, 'lps'),
	(453710, 125, '2015-03-15 00:28:48.000000', 'consum', 0.0215, 'lps'),
	(453711, 125, '2015-03-15 00:28:49.000000', 'consum', 0.0214, 'lps'),
	(453712, 125, '2015-03-15 00:28:50.000000', 'consum', 0.0217, 'lps'),
	(453713, 125, '2015-03-15 00:28:51.000000', 'consum', 0.0212, 'lps'),
	(453714, 125, '2015-03-15 00:28:52.000000', 'consum', 0.0221, 'lps'),
	(453715, 125, '2015-03-15 00:28:53.000000', 'consum', 0.0222, 'lps'),
	(453716, 125, '2015-03-15 00:28:54.000000', 'consum', 0.0218, 'lps'),
	(453717, 125, '2015-03-15 00:28:55.000000', 'consum', 0.0214, 'lps'),
	(453718, 125, '2015-03-15 00:28:56.000000', 'consum', 0.0227, 'lps'),
	(453719, 125, '2015-03-15 00:28:57.000000', 'consum', 0.0227, 'lps'),
	(453720, 125, '2015-03-15 00:28:58.000000', 'consum', 0.0226, 'lps'),
	(453721, 125, '2015-03-15 00:28:59.000000', 'consum', 0.0221, 'lps'),
	(453722, 125, '2015-03-15 00:29:00.000000', 'consum', 0.0219, 'lps'),
	(453723, 125, '2015-03-15 00:29:01.000000', 'consum', 0.0224, 'lps'),
	(453724, 125, '2015-03-15 00:29:02.000000', 'consum', 0.0214, 'lps'),
	(453725, 125, '2015-03-15 00:29:03.000000', 'consum', 0.0210, 'lps'),
	(453726, 125, '2015-03-15 00:29:04.000000', 'consum', 0.0215, 'lps'),
	(453727, 125, '2015-03-15 00:29:05.000000', 'consum', 0.0216, 'lps'),
	(453728, 125, '2015-03-15 00:29:06.000000', 'consum', 0.0210, 'lps'),
	(453729, 125, '2015-03-15 00:29:07.000000', 'consum', 0.0210, 'lps'),
	(453730, 125, '2015-03-15 00:29:08.000000', 'consum', 0.0211, 'lps'),
	(453731, 125, '2015-03-15 00:29:09.000000', 'consum', 0.0215, 'lps'),
	(453732, 125, '2015-03-15 00:29:10.000000', 'consum', 0.0215, 'lps'),
	(453733, 125, '2015-03-15 00:29:11.000000', 'consum', 0.0220, 'lps'),
	(453734, 125, '2015-03-15 00:29:12.000000', 'consum', 0.0227, 'lps'),
	(453735, 125, '2015-03-15 00:29:13.000000', 'consum', 0.0212, 'lps'),
	(453736, 125, '2015-03-15 00:29:14.000000', 'consum', 0.0225, 'lps'),
	(453737, 125, '2015-03-15 00:29:15.000000', 'consum', 0.0224, 'lps'),
	(453738, 125, '2015-03-15 00:29:16.000000', 'consum', 0.0217, 'lps'),
	(453739, 125, '2015-03-15 00:29:17.000000', 'consum', 0.0223, 'lps'),
	(453740, 125, '2015-03-15 00:29:18.000000', 'consum', 0.0217, 'lps'),
	(453741, 125, '2015-03-15 00:29:19.000000', 'consum', 0.0223, 'lps'),
	(453742, 125, '2015-03-15 00:29:20.000000', 'consum', 0.0220, 'lps'),
	(453743, 125, '2015-03-15 00:29:21.000000', 'consum', 0.0222, 'lps'),
	(453744, 125, '2015-03-15 00:29:22.000000', 'consum', 0.0223, 'lps'),
	(453745, 125, '2015-03-15 00:29:23.000000', 'consum', 0.0220, 'lps'),
	(453746, 125, '2015-03-15 00:29:24.000000', 'consum', 0.0224, 'lps'),
	(453747, 125, '2015-03-15 00:29:25.000000', 'consum', 0.0214, 'lps'),
	(453748, 125, '2015-03-15 00:29:26.000000', 'consum', 0.0223, 'lps'),
	(453749, 125, '2015-03-15 00:29:27.000000', 'consum', 0.0210, 'lps'),
	(453750, 125, '2015-03-15 00:29:28.000000', 'consum', 0.0226, 'lps'),
	(453751, 125, '2015-03-15 00:29:29.000000', 'consum', 0.0219, 'lps'),
	(453752, 125, '2015-03-15 00:29:30.000000', 'consum', 0.0226, 'lps'),
	(453753, 125, '2015-03-15 00:29:31.000000', 'consum', 0.0225, 'lps'),
	(453754, 125, '2015-03-15 00:29:32.000000', 'consum', 0.0221, 'lps'),
	(453755, 125, '2015-03-15 00:29:33.000000', 'consum', 0.0220, 'lps'),
	(453756, 125, '2015-03-15 00:29:34.000000', 'consum', 0.0210, 'lps'),
	(453757, 125, '2015-03-15 00:29:35.000000', 'consum', 0.0217, 'lps'),
	(453758, 125, '2015-03-15 00:29:36.000000', 'consum', 0.0226, 'lps'),
	(453759, 125, '2015-03-15 00:29:37.000000', 'consum', 0.0217, 'lps'),
	(453760, 125, '2015-03-15 00:29:38.000000', 'consum', 0.0215, 'lps'),
	(453761, 125, '2015-03-15 00:29:39.000000', 'consum', 0.0213, 'lps'),
	(453762, 125, '2015-03-15 00:29:40.000000', 'consum', 0.0213, 'lps'),
	(453763, 125, '2015-03-15 00:29:41.000000', 'consum', 0.0217, 'lps'),
	(453764, 125, '2015-03-15 00:29:42.000000', 'consum', 0.0218, 'lps'),
	(453765, 125, '2015-03-15 00:29:43.000000', 'consum', 0.0211, 'lps'),
	(453766, 125, '2015-03-15 00:29:44.000000', 'consum', 0.0210, 'lps'),
	(453767, 125, '2015-03-15 00:29:45.000000', 'consum', 0.0226, 'lps'),
	(453768, 125, '2015-03-15 00:29:46.000000', 'consum', 0.0219, 'lps'),
	(453769, 125, '2015-03-15 00:29:47.000000', 'consum', 0.0225, 'lps'),
	(453770, 125, '2015-03-15 00:29:48.000000', 'consum', 0.0222, 'lps'),
	(453771, 125, '2015-03-15 00:29:49.000000', 'consum', 0.0225, 'lps'),
	(453772, 125, '2015-03-15 00:29:50.000000', 'consum', 0.0216, 'lps'),
	(453773, 125, '2015-03-15 00:29:51.000000', 'consum', 0.0210, 'lps'),
	(453774, 125, '2015-03-15 00:29:52.000000', 'consum', 0.0214, 'lps'),
	(453775, 125, '2015-03-15 00:29:53.000000', 'consum', 0.0211, 'lps'),
	(453776, 125, '2015-03-15 00:29:54.000000', 'consum', 0.0222, 'lps'),
	(453777, 125, '2015-03-15 00:29:55.000000', 'consum', 0.0214, 'lps'),
	(453778, 125, '2015-03-15 00:29:56.000000', 'consum', 0.0212, 'lps'),
	(453779, 125, '2015-03-15 00:29:57.000000', 'consum', 0.0210, 'lps'),
	(453780, 125, '2015-03-15 00:29:58.000000', 'consum', 0.0222, 'lps'),
	(453781, 125, '2015-03-15 00:29:59.000000', 'consum', 0.0218, 'lps'),
	(453782, 125, '2015-03-15 00:30:00.000000', 'consum', 0.0211, 'lps'),
	(453783, 125, '2015-03-15 00:30:01.000000', 'consum', 0.0212, 'lps'),
	(453784, 125, '2015-03-15 00:30:02.000000', 'consum', 0.0215, 'lps'),
	(453785, 125, '2015-03-15 00:30:03.000000', 'consum', 0.0212, 'lps'),
	(453786, 125, '2015-03-15 00:30:04.000000', 'consum', 0.0226, 'lps'),
	(453787, 125, '2015-03-15 00:30:05.000000', 'consum', 0.0227, 'lps'),
	(453788, 125, '2015-03-15 00:30:06.000000', 'consum', 0.0215, 'lps'),
	(453789, 125, '2015-03-15 00:30:07.000000', 'consum', 0.0218, 'lps'),
	(453790, 125, '2015-03-15 00:30:08.000000', 'consum', 0.0217, 'lps'),
	(453791, 125, '2015-03-15 00:30:09.000000', 'consum', 0.0223, 'lps'),
	(453792, 125, '2015-03-15 00:30:10.000000', 'consum', 0.0216, 'lps'),
	(453793, 125, '2015-03-15 00:30:11.000000', 'consum', 0.0223, 'lps'),
	(453794, 125, '2015-03-15 00:30:12.000000', 'consum', 0.0218, 'lps'),
	(453795, 125, '2015-03-15 00:30:13.000000', 'consum', 0.0214, 'lps'),
	(453796, 125, '2015-03-15 00:30:14.000000', 'consum', 0.0224, 'lps'),
	(453797, 125, '2015-03-15 00:30:15.000000', 'consum', 0.0212, 'lps'),
	(453798, 125, '2015-03-15 00:30:16.000000', 'consum', 0.0218, 'lps'),
	(453799, 125, '2015-03-15 00:30:17.000000', 'consum', 0.0224, 'lps'),
	(453800, 125, '2015-03-15 00:30:18.000000', 'consum', 0.0219, 'lps'),
	(453801, 125, '2015-03-15 00:30:19.000000', 'consum', 0.0216, 'lps'),
	(453802, 125, '2015-03-15 00:30:20.000000', 'consum', 0.0214, 'lps'),
	(453803, 125, '2015-03-15 00:30:21.000000', 'consum', 0.0210, 'lps'),
	(453804, 125, '2015-03-15 00:30:22.000000', 'consum', 0.0219, 'lps'),
	(453805, 125, '2015-03-15 00:30:23.000000', 'consum', 0.0217, 'lps'),
	(453806, 125, '2015-03-15 00:30:24.000000', 'consum', 0.0219, 'lps'),
	(453807, 125, '2015-03-15 00:30:25.000000', 'consum', 0.0218, 'lps'),
	(453808, 125, '2015-03-15 00:30:26.000000', 'consum', 0.0223, 'lps'),
	(453809, 125, '2015-03-15 00:30:27.000000', 'consum', 0.0215, 'lps'),
	(453810, 125, '2015-03-15 00:30:28.000000', 'consum', 0.0213, 'lps'),
	(453811, 125, '2015-03-15 00:30:29.000000', 'consum', 0.0212, 'lps'),
	(453812, 125, '2015-03-15 00:30:30.000000', 'consum', 0.0227, 'lps'),
	(453813, 125, '2015-03-15 00:30:31.000000', 'consum', 0.0220, 'lps'),
	(453814, 125, '2015-03-15 00:30:32.000000', 'consum', 0.0210, 'lps'),
	(453815, 125, '2015-03-15 00:30:33.000000', 'consum', 0.0216, 'lps'),
	(453816, 125, '2015-03-15 00:30:34.000000', 'consum', 0.0222, 'lps'),
	(453817, 125, '2015-03-15 00:30:35.000000', 'consum', 0.0217, 'lps'),
	(453818, 125, '2015-03-15 00:30:36.000000', 'consum', 0.0227, 'lps'),
	(453819, 125, '2015-03-15 00:30:37.000000', 'consum', 0.0222, 'lps'),
	(453820, 125, '2015-03-15 00:30:38.000000', 'consum', 0.0219, 'lps'),
	(453821, 125, '2015-03-15 00:30:39.000000', 'consum', 0.0221, 'lps'),
	(453822, 125, '2015-03-15 00:30:40.000000', 'consum', 0.0220, 'lps'),
	(453823, 125, '2015-03-15 00:30:41.000000', 'consum', 0.0211, 'lps'),
	(453824, 125, '2015-03-15 00:30:42.000000', 'consum', 0.0218, 'lps'),
	(453825, 125, '2015-03-15 00:30:43.000000', 'consum', 0.0213, 'lps'),
	(453826, 125, '2015-03-15 00:30:44.000000', 'consum', 0.0218, 'lps'),
	(453827, 125, '2015-03-15 00:30:45.000000', 'consum', 0.0227, 'lps'),
	(453828, 125, '2015-03-15 00:30:46.000000', 'consum', 0.0214, 'lps'),
	(453829, 125, '2015-03-15 00:30:47.000000', 'consum', 0.0218, 'lps'),
	(453830, 125, '2015-03-15 00:30:48.000000', 'consum', 0.0221, 'lps'),
	(453831, 125, '2015-03-15 00:30:49.000000', 'consum', 0.0221, 'lps'),
	(453832, 125, '2015-03-15 00:30:50.000000', 'consum', 0.0215, 'lps'),
	(453833, 125, '2015-03-15 00:30:51.000000', 'consum', 0.0221, 'lps'),
	(453834, 125, '2015-03-15 00:30:52.000000', 'consum', 0.0213, 'lps'),
	(453835, 125, '2015-03-15 00:30:53.000000', 'consum', 0.0212, 'lps'),
	(453836, 125, '2015-03-15 00:30:54.000000', 'consum', 0.0211, 'lps'),
	(453837, 125, '2015-03-15 00:30:55.000000', 'consum', 0.0210, 'lps'),
	(453838, 125, '2015-03-15 00:30:56.000000', 'consum', 0.0223, 'lps'),
	(453839, 125, '2015-03-15 00:30:57.000000', 'consum', 0.0224, 'lps'),
	(453840, 125, '2015-03-15 00:30:58.000000', 'consum', 0.0225, 'lps'),
	(453841, 125, '2015-03-15 00:30:59.000000', 'consum', 0.0223, 'lps'),
	(453842, 125, '2015-03-15 00:31:00.000000', 'consum', 0.0211, 'lps'),
	(453843, 125, '2015-03-15 00:31:01.000000', 'consum', 0.0214, 'lps'),
	(453844, 125, '2015-03-15 00:31:02.000000', 'consum', 0.0212, 'lps'),
	(453845, 125, '2015-03-15 00:31:03.000000', 'consum', 0.0223, 'lps'),
	(453846, 125, '2015-03-15 00:31:04.000000', 'consum', 0.0215, 'lps'),
	(453847, 125, '2015-03-15 00:31:05.000000', 'consum', 0.0217, 'lps'),
	(453848, 125, '2015-03-15 00:31:06.000000', 'consum', 0.0212, 'lps'),
	(453849, 125, '2015-03-15 00:31:07.000000', 'consum', 0.0218, 'lps'),
	(453850, 125, '2015-03-15 00:31:08.000000', 'consum', 0.0225, 'lps'),
	(453851, 125, '2015-03-15 00:31:09.000000', 'consum', 0.0227, 'lps'),
	(453852, 125, '2015-03-15 00:31:10.000000', 'consum', 0.0214, 'lps'),
	(453853, 125, '2015-03-15 00:31:11.000000', 'consum', 0.0216, 'lps'),
	(453854, 125, '2015-03-15 00:31:12.000000', 'consum', 0.0212, 'lps'),
	(453855, 125, '2015-03-15 00:31:13.000000', 'consum', 0.0220, 'lps'),
	(453856, 125, '2015-03-15 00:31:14.000000', 'consum', 0.0217, 'lps'),
	(453857, 125, '2015-03-15 00:31:15.000000', 'consum', 0.0214, 'lps'),
	(453858, 125, '2015-03-15 00:31:16.000000', 'consum', 0.0211, 'lps'),
	(453859, 125, '2015-03-15 00:31:17.000000', 'consum', 0.0223, 'lps'),
	(453860, 125, '2015-03-15 00:31:18.000000', 'consum', 0.0217, 'lps'),
	(453861, 125, '2015-03-15 00:31:19.000000', 'consum', 0.0226, 'lps'),
	(453862, 125, '2015-03-15 00:31:20.000000', 'consum', 0.0214, 'lps'),
	(453863, 125, '2015-03-15 00:31:21.000000', 'consum', 0.0221, 'lps'),
	(453864, 125, '2015-03-15 00:31:22.000000', 'consum', 0.0214, 'lps'),
	(453865, 125, '2015-03-15 00:31:23.000000', 'consum', 0.0217, 'lps'),
	(453866, 125, '2015-03-15 00:31:24.000000', 'consum', 0.0214, 'lps'),
	(453867, 125, '2015-03-15 00:31:25.000000', 'consum', 0.0212, 'lps'),
	(453868, 125, '2015-03-15 00:31:26.000000', 'consum', 0.0224, 'lps'),
	(453869, 125, '2015-03-15 00:31:27.000000', 'consum', 0.0222, 'lps'),
	(453870, 125, '2015-03-15 00:31:28.000000', 'consum', 0.0212, 'lps'),
	(453871, 125, '2015-03-15 00:31:29.000000', 'consum', 0.0218, 'lps'),
	(453872, 125, '2015-03-15 00:31:30.000000', 'consum', 0.0227, 'lps'),
	(453873, 125, '2015-03-15 00:31:31.000000', 'consum', 0.0216, 'lps'),
	(453874, 125, '2015-03-15 00:31:32.000000', 'consum', 0.0226, 'lps'),
	(453875, 125, '2015-03-15 00:31:33.000000', 'consum', 0.0218, 'lps'),
	(453876, 125, '2015-03-15 00:31:34.000000', 'consum', 0.0220, 'lps'),
	(453877, 125, '2015-03-15 00:31:35.000000', 'consum', 0.0221, 'lps'),
	(453878, 125, '2015-03-15 00:31:36.000000', 'consum', 0.0215, 'lps'),
	(453879, 125, '2015-03-15 00:31:37.000000', 'consum', 0.0220, 'lps'),
	(453880, 125, '2015-03-15 00:31:38.000000', 'consum', 0.0210, 'lps'),
	(453881, 125, '2015-03-15 00:31:39.000000', 'consum', 0.0215, 'lps'),
	(453882, 125, '2015-03-15 00:31:40.000000', 'consum', 0.0219, 'lps'),
	(453883, 125, '2015-03-15 00:31:41.000000', 'consum', 0.0224, 'lps'),
	(453884, 125, '2015-03-15 00:31:42.000000', 'consum', 0.0217, 'lps'),
	(453885, 125, '2015-03-15 00:31:43.000000', 'consum', 0.0220, 'lps'),
	(453886, 125, '2015-03-15 00:31:44.000000', 'consum', 0.0223, 'lps'),
	(453887, 125, '2015-03-15 00:31:45.000000', 'consum', 0.0210, 'lps'),
	(453888, 125, '2015-03-15 00:31:46.000000', 'consum', 0.0226, 'lps'),
	(453889, 125, '2015-03-15 00:31:47.000000', 'consum', 0.0217, 'lps'),
	(453890, 125, '2015-03-15 00:31:48.000000', 'consum', 0.0217, 'lps'),
	(453891, 125, '2015-03-15 00:31:49.000000', 'consum', 0.0225, 'lps'),
	(453892, 125, '2015-03-15 00:31:50.000000', 'consum', 0.0227, 'lps'),
	(453893, 125, '2015-03-15 00:31:51.000000', 'consum', 0.0216, 'lps'),
	(453894, 125, '2015-03-15 00:31:52.000000', 'consum', 0.0225, 'lps'),
	(453895, 125, '2015-03-15 00:31:53.000000', 'consum', 0.0215, 'lps'),
	(453896, 125, '2015-03-15 00:31:54.000000', 'consum', 0.0227, 'lps'),
	(453897, 125, '2015-03-15 00:31:55.000000', 'consum', 0.0224, 'lps'),
	(453898, 125, '2015-03-15 00:31:56.000000', 'consum', 0.0213, 'lps'),
	(453899, 125, '2015-03-15 00:31:57.000000', 'consum', 0.0217, 'lps'),
	(453900, 125, '2015-03-15 00:31:58.000000', 'consum', 0.0220, 'lps'),
	(453901, 125, '2015-03-15 00:31:59.000000', 'consum', 0.0222, 'lps'),
	(453902, 125, '2015-03-15 00:32:00.000000', 'consum', 0.0224, 'lps'),
	(453903, 125, '2015-03-15 00:32:01.000000', 'consum', 0.0225, 'lps'),
	(453904, 125, '2015-03-15 00:32:02.000000', 'consum', 0.0225, 'lps'),
	(453905, 125, '2015-03-15 00:32:03.000000', 'consum', 0.0223, 'lps'),
	(453906, 125, '2015-03-15 00:32:04.000000', 'consum', 0.0212, 'lps'),
	(453907, 125, '2015-03-15 00:32:05.000000', 'consum', 0.0219, 'lps'),
	(453908, 125, '2015-03-15 00:32:06.000000', 'consum', 0.0214, 'lps'),
	(453909, 125, '2015-03-15 00:32:07.000000', 'consum', 0.0219, 'lps'),
	(453910, 125, '2015-03-15 00:32:08.000000', 'consum', 0.0225, 'lps'),
	(453911, 125, '2015-03-15 00:32:09.000000', 'consum', 0.0223, 'lps'),
	(453912, 125, '2015-03-15 00:32:10.000000', 'consum', 0.0212, 'lps'),
	(453913, 125, '2015-03-15 00:32:11.000000', 'consum', 0.0219, 'lps'),
	(453914, 125, '2015-03-15 00:32:12.000000', 'consum', 0.0215, 'lps'),
	(453915, 125, '2015-03-15 00:32:13.000000', 'consum', 0.0225, 'lps'),
	(453916, 125, '2015-03-15 00:32:14.000000', 'consum', 0.0217, 'lps'),
	(453917, 125, '2015-03-15 00:32:15.000000', 'consum', 0.0218, 'lps'),
	(453918, 125, '2015-03-15 00:32:16.000000', 'consum', 0.0213, 'lps'),
	(453919, 125, '2015-03-15 00:32:17.000000', 'consum', 0.0218, 'lps'),
	(453920, 125, '2015-03-15 00:32:18.000000', 'consum', 0.0224, 'lps'),
	(453921, 125, '2015-03-15 00:32:19.000000', 'consum', 0.0219, 'lps'),
	(453922, 125, '2015-03-15 00:32:20.000000', 'consum', 0.0214, 'lps'),
	(453923, 125, '2015-03-15 00:32:21.000000', 'consum', 0.0221, 'lps'),
	(453924, 125, '2015-03-15 00:32:22.000000', 'consum', 0.0218, 'lps'),
	(453925, 125, '2015-03-15 00:32:23.000000', 'consum', 0.0216, 'lps'),
	(453926, 125, '2015-03-15 00:32:24.000000', 'consum', 0.0219, 'lps'),
	(453927, 125, '2015-03-15 00:32:25.000000', 'consum', 0.0220, 'lps'),
	(453928, 125, '2015-03-15 00:32:26.000000', 'consum', 0.0216, 'lps'),
	(453929, 125, '2015-03-15 00:32:27.000000', 'consum', 0.0226, 'lps'),
	(453930, 125, '2015-03-15 00:32:28.000000', 'consum', 0.0221, 'lps'),
	(453931, 125, '2015-03-15 00:32:29.000000', 'consum', 0.0215, 'lps'),
	(453932, 125, '2015-03-15 00:32:30.000000', 'consum', 0.0220, 'lps'),
	(453933, 125, '2015-03-15 00:32:31.000000', 'consum', 0.0213, 'lps'),
	(453934, 125, '2015-03-15 00:32:32.000000', 'consum', 0.0210, 'lps'),
	(453935, 125, '2015-03-15 00:32:33.000000', 'consum', 0.0221, 'lps'),
	(453936, 125, '2015-03-15 00:32:34.000000', 'consum', 0.0211, 'lps'),
	(453937, 125, '2015-03-15 00:32:35.000000', 'consum', 0.0219, 'lps'),
	(453938, 125, '2015-03-15 00:32:36.000000', 'consum', 0.0217, 'lps'),
	(453939, 125, '2015-03-15 00:32:37.000000', 'consum', 0.0218, 'lps'),
	(453940, 125, '2015-03-15 00:32:38.000000', 'consum', 0.0213, 'lps'),
	(453941, 125, '2015-03-15 00:32:39.000000', 'consum', 0.0218, 'lps'),
	(453942, 125, '2015-03-15 00:32:40.000000', 'consum', 0.0224, 'lps'),
	(453943, 125, '2015-03-15 00:32:41.000000', 'consum', 0.0222, 'lps'),
	(453944, 125, '2015-03-15 00:32:42.000000', 'consum', 0.0210, 'lps'),
	(453945, 125, '2015-03-15 00:32:43.000000', 'consum', 0.0211, 'lps'),
	(453946, 125, '2015-03-15 00:32:44.000000', 'consum', 0.0214, 'lps'),
	(453947, 125, '2015-03-15 00:32:45.000000', 'consum', 0.0226, 'lps'),
	(453948, 125, '2015-03-15 00:32:46.000000', 'consum', 0.0226, 'lps'),
	(453949, 125, '2015-03-15 00:32:47.000000', 'consum', 0.0224, 'lps'),
	(453950, 125, '2015-03-15 00:32:48.000000', 'consum', 0.0213, 'lps'),
	(453951, 125, '2015-03-15 00:32:49.000000', 'consum', 0.0223, 'lps'),
	(453952, 125, '2015-03-15 00:32:50.000000', 'consum', 0.0227, 'lps'),
	(453953, 125, '2015-03-15 00:32:51.000000', 'consum', 0.0221, 'lps'),
	(453954, 125, '2015-03-15 00:32:52.000000', 'consum', 0.0215, 'lps'),
	(453955, 125, '2015-03-15 00:32:53.000000', 'consum', 0.0222, 'lps'),
	(453956, 125, '2015-03-15 00:32:54.000000', 'consum', 0.0217, 'lps'),
	(453957, 125, '2015-03-15 00:32:55.000000', 'consum', 0.0227, 'lps'),
	(453958, 125, '2015-03-15 00:32:56.000000', 'consum', 0.0220, 'lps'),
	(453959, 125, '2015-03-15 00:32:57.000000', 'consum', 0.0213, 'lps'),
	(453960, 125, '2015-03-15 00:32:58.000000', 'consum', 0.0210, 'lps'),
	(453961, 125, '2015-03-15 00:32:59.000000', 'consum', 0.0220, 'lps'),
	(453962, 125, '2015-03-15 00:33:00.000000', 'consum', 0.0227, 'lps'),
	(453963, 125, '2015-03-15 00:33:01.000000', 'consum', 0.0226, 'lps'),
	(453964, 125, '2015-03-15 00:33:02.000000', 'consum', 0.0224, 'lps'),
	(453965, 125, '2015-03-15 00:33:03.000000', 'consum', 0.0214, 'lps'),
	(453966, 125, '2015-03-15 00:33:04.000000', 'consum', 0.0226, 'lps'),
	(453967, 125, '2015-03-15 00:33:05.000000', 'consum', 0.0225, 'lps'),
	(453968, 125, '2015-03-15 00:33:06.000000', 'consum', 0.0217, 'lps'),
	(453969, 125, '2015-03-15 00:33:07.000000', 'consum', 0.0218, 'lps'),
	(453970, 125, '2015-03-15 00:33:08.000000', 'consum', 0.0214, 'lps'),
	(453971, 125, '2015-03-15 00:33:09.000000', 'consum', 0.0224, 'lps'),
	(453972, 125, '2015-03-15 00:33:10.000000', 'consum', 0.0215, 'lps'),
	(453973, 125, '2015-03-15 00:33:11.000000', 'consum', 0.0210, 'lps'),
	(453974, 125, '2015-03-15 00:33:12.000000', 'consum', 0.0213, 'lps'),
	(453975, 125, '2015-03-15 00:33:13.000000', 'consum', 0.0210, 'lps'),
	(453976, 125, '2015-03-15 00:33:14.000000', 'consum', 0.0218, 'lps'),
	(453977, 125, '2015-03-15 00:33:15.000000', 'consum', 0.0216, 'lps'),
	(453978, 125, '2015-03-15 00:33:16.000000', 'consum', 0.0215, 'lps'),
	(453979, 125, '2015-03-15 00:33:17.000000', 'consum', 0.0219, 'lps'),
	(453980, 125, '2015-03-15 00:33:18.000000', 'consum', 0.0221, 'lps'),
	(453981, 125, '2015-03-15 00:33:19.000000', 'consum', 0.0221, 'lps'),
	(453982, 125, '2015-03-15 00:33:20.000000', 'consum', 0.0213, 'lps'),
	(453983, 125, '2015-03-15 00:33:21.000000', 'consum', 0.0213, 'lps'),
	(453984, 125, '2015-03-15 00:33:22.000000', 'consum', 0.0214, 'lps'),
	(453985, 125, '2015-03-15 00:33:23.000000', 'consum', 0.0225, 'lps'),
	(453986, 125, '2015-03-15 00:33:24.000000', 'consum', 0.0216, 'lps'),
	(453987, 125, '2015-03-15 00:33:25.000000', 'consum', 0.0217, 'lps'),
	(453988, 125, '2015-03-15 00:33:26.000000', 'consum', 0.0224, 'lps'),
	(453989, 125, '2015-03-15 00:33:27.000000', 'consum', 0.0227, 'lps'),
	(453990, 125, '2015-03-15 00:33:28.000000', 'consum', 0.0214, 'lps'),
	(453991, 125, '2015-03-15 00:33:29.000000', 'consum', 0.0216, 'lps'),
	(453992, 125, '2015-03-15 00:33:30.000000', 'consum', 0.0213, 'lps'),
	(453993, 125, '2015-03-15 00:33:31.000000', 'consum', 0.0225, 'lps'),
	(453994, 125, '2015-03-15 00:33:32.000000', 'consum', 0.0221, 'lps'),
	(453995, 125, '2015-03-15 00:33:33.000000', 'consum', 0.0222, 'lps'),
	(453996, 125, '2015-03-15 00:33:34.000000', 'consum', 0.0217, 'lps'),
	(453997, 125, '2015-03-15 00:33:35.000000', 'consum', 0.0212, 'lps'),
	(453998, 125, '2015-03-15 00:33:36.000000', 'consum', 0.0217, 'lps'),
	(453999, 125, '2015-03-15 00:33:37.000000', 'consum', 0.0221, 'lps'),
	(454000, 125, '2015-03-15 00:33:38.000000', 'consum', 0.0227, 'lps'),
	(454001, 125, '2015-03-15 00:33:39.000000', 'consum', 0.0225, 'lps'),
	(454002, 125, '2015-03-15 00:33:40.000000', 'consum', 0.0217, 'lps'),
	(454003, 125, '2015-03-15 00:33:41.000000', 'consum', 0.0219, 'lps'),
	(454004, 125, '2015-03-15 00:33:42.000000', 'consum', 0.0215, 'lps'),
	(454005, 125, '2015-03-15 00:33:43.000000', 'consum', 0.0211, 'lps'),
	(454006, 125, '2015-03-15 00:33:44.000000', 'consum', 0.0217, 'lps'),
	(454007, 125, '2015-03-15 00:33:45.000000', 'consum', 0.0226, 'lps'),
	(454008, 125, '2015-03-15 00:33:46.000000', 'consum', 0.0213, 'lps'),
	(454009, 125, '2015-03-15 00:33:47.000000', 'consum', 0.0216, 'lps'),
	(454010, 125, '2015-03-15 00:33:48.000000', 'consum', 0.0213, 'lps'),
	(454011, 125, '2015-03-15 00:33:49.000000', 'consum', 0.0227, 'lps'),
	(454012, 125, '2015-03-15 00:33:50.000000', 'consum', 0.0213, 'lps'),
	(454013, 125, '2015-03-15 00:33:51.000000', 'consum', 0.0212, 'lps'),
	(454014, 125, '2015-03-15 00:33:52.000000', 'consum', 0.0211, 'lps'),
	(454015, 125, '2015-03-15 00:33:53.000000', 'consum', 0.0211, 'lps'),
	(454016, 125, '2015-03-15 00:33:54.000000', 'consum', 0.0212, 'lps'),
	(454017, 125, '2015-03-15 00:33:55.000000', 'consum', 0.0217, 'lps'),
	(454018, 125, '2015-03-15 00:33:56.000000', 'consum', 0.0220, 'lps'),
	(454019, 125, '2015-03-15 00:33:57.000000', 'consum', 0.0223, 'lps'),
	(454020, 125, '2015-03-15 00:33:58.000000', 'consum', 0.0227, 'lps'),
	(454021, 125, '2015-03-15 00:33:59.000000', 'consum', 0.0220, 'lps'),
	(454022, 125, '2015-03-15 00:34:00.000000', 'consum', 0.0211, 'lps'),
	(454023, 125, '2015-03-15 00:34:01.000000', 'consum', 0.0219, 'lps'),
	(454024, 125, '2015-03-15 00:34:02.000000', 'consum', 0.0219, 'lps'),
	(454025, 125, '2015-03-15 00:34:03.000000', 'consum', 0.0227, 'lps'),
	(454026, 125, '2015-03-15 00:34:04.000000', 'consum', 0.0214, 'lps'),
	(454027, 125, '2015-03-15 00:34:05.000000', 'consum', 0.0215, 'lps'),
	(454028, 125, '2015-03-15 00:34:06.000000', 'consum', 0.0223, 'lps'),
	(454029, 125, '2015-03-15 00:34:07.000000', 'consum', 0.0225, 'lps'),
	(454030, 125, '2015-03-15 00:34:08.000000', 'consum', 0.0210, 'lps'),
	(454031, 125, '2015-03-15 00:34:09.000000', 'consum', 0.0222, 'lps'),
	(454032, 125, '2015-03-15 00:34:10.000000', 'consum', 0.0214, 'lps'),
	(454033, 125, '2015-03-15 00:34:11.000000', 'consum', 0.0212, 'lps'),
	(454034, 125, '2015-03-15 00:34:12.000000', 'consum', 0.0210, 'lps'),
	(454035, 125, '2015-03-15 00:34:13.000000', 'consum', 0.0224, 'lps'),
	(454036, 125, '2015-03-15 00:34:14.000000', 'consum', 0.0226, 'lps'),
	(454037, 125, '2015-03-15 00:34:15.000000', 'consum', 0.0211, 'lps'),
	(454038, 125, '2015-03-15 00:34:16.000000', 'consum', 0.0222, 'lps'),
	(454039, 125, '2015-03-15 00:34:17.000000', 'consum', 0.0213, 'lps'),
	(454040, 125, '2015-03-15 00:34:18.000000', 'consum', 0.0224, 'lps'),
	(454041, 125, '2015-03-15 00:34:19.000000', 'consum', 0.0219, 'lps'),
	(454042, 125, '2015-03-15 00:34:20.000000', 'consum', 0.0213, 'lps'),
	(454043, 125, '2015-03-15 00:34:21.000000', 'consum', 0.0218, 'lps'),
	(454044, 125, '2015-03-15 00:34:22.000000', 'consum', 0.0222, 'lps'),
	(454045, 125, '2015-03-15 00:34:23.000000', 'consum', 0.0213, 'lps'),
	(454046, 125, '2015-03-15 00:34:24.000000', 'consum', 0.0223, 'lps'),
	(454047, 125, '2015-03-15 00:34:25.000000', 'consum', 0.0214, 'lps'),
	(454048, 125, '2015-03-15 00:34:26.000000', 'consum', 0.0210, 'lps'),
	(454049, 125, '2015-03-15 00:34:27.000000', 'consum', 0.0216, 'lps'),
	(454050, 125, '2015-03-15 00:34:28.000000', 'consum', 0.0223, 'lps'),
	(454051, 125, '2015-03-15 00:34:29.000000', 'consum', 0.0219, 'lps'),
	(454052, 125, '2015-03-15 00:34:30.000000', 'consum', 0.0220, 'lps'),
	(454053, 125, '2015-03-15 00:34:31.000000', 'consum', 0.0214, 'lps'),
	(454054, 125, '2015-03-15 00:34:32.000000', 'consum', 0.0220, 'lps'),
	(454055, 125, '2015-03-15 00:34:33.000000', 'consum', 0.0210, 'lps'),
	(454056, 125, '2015-03-15 00:34:34.000000', 'consum', 0.0216, 'lps'),
	(454057, 125, '2015-03-15 00:34:35.000000', 'consum', 0.0225, 'lps'),
	(454058, 125, '2015-03-15 00:34:36.000000', 'consum', 0.0213, 'lps'),
	(454059, 125, '2015-03-15 00:34:37.000000', 'consum', 0.0215, 'lps'),
	(454060, 125, '2015-03-15 00:34:38.000000', 'consum', 0.0210, 'lps'),
	(454061, 125, '2015-03-15 00:34:39.000000', 'consum', 0.0212, 'lps'),
	(454062, 125, '2015-03-15 00:34:40.000000', 'consum', 0.0222, 'lps'),
	(454063, 125, '2015-03-15 00:34:41.000000', 'consum', 0.0212, 'lps'),
	(454064, 125, '2015-03-15 00:34:42.000000', 'consum', 0.0218, 'lps'),
	(454065, 125, '2015-03-15 00:34:43.000000', 'consum', 0.0210, 'lps'),
	(454066, 125, '2015-03-15 00:34:44.000000', 'consum', 0.0220, 'lps'),
	(454067, 125, '2015-03-15 00:34:45.000000', 'consum', 0.0226, 'lps'),
	(454068, 125, '2015-03-15 00:34:46.000000', 'consum', 0.0226, 'lps'),
	(454069, 125, '2015-03-15 00:34:47.000000', 'consum', 0.0224, 'lps'),
	(454070, 125, '2015-03-15 00:34:48.000000', 'consum', 0.0215, 'lps'),
	(454071, 125, '2015-03-15 00:34:49.000000', 'consum', 0.0212, 'lps'),
	(454072, 125, '2015-03-15 00:34:50.000000', 'consum', 0.0222, 'lps'),
	(454073, 125, '2015-03-15 00:34:51.000000', 'consum', 0.0212, 'lps'),
	(454074, 125, '2015-03-15 00:34:52.000000', 'consum', 0.0219, 'lps'),
	(454075, 125, '2015-03-15 00:34:53.000000', 'consum', 0.0214, 'lps'),
	(454076, 125, '2015-03-15 00:34:54.000000', 'consum', 0.0222, 'lps'),
	(454077, 125, '2015-03-15 00:34:55.000000', 'consum', 0.0224, 'lps'),
	(454078, 125, '2015-03-15 00:34:56.000000', 'consum', 0.0224, 'lps'),
	(454079, 125, '2015-03-15 00:34:57.000000', 'consum', 0.0223, 'lps'),
	(454080, 125, '2015-03-15 00:34:58.000000', 'consum', 0.0215, 'lps'),
	(454081, 125, '2015-03-15 00:34:59.000000', 'consum', 0.0213, 'lps'),
	(454082, 125, '2015-03-15 00:35:00.000000', 'consum', 0.0227, 'lps'),
	(454083, 125, '2015-03-15 00:35:01.000000', 'consum', 0.0218, 'lps'),
	(454084, 125, '2015-03-15 00:35:02.000000', 'consum', 0.0217, 'lps'),
	(454085, 125, '2015-03-15 00:35:03.000000', 'consum', 0.0219, 'lps'),
	(454086, 125, '2015-03-15 00:35:04.000000', 'consum', 0.0220, 'lps'),
	(454087, 125, '2015-03-15 00:35:05.000000', 'consum', 0.0212, 'lps'),
	(454088, 125, '2015-03-15 00:35:06.000000', 'consum', 0.0210, 'lps'),
	(454089, 125, '2015-03-15 00:35:07.000000', 'consum', 0.0222, 'lps'),
	(454090, 125, '2015-03-15 00:35:08.000000', 'consum', 0.0219, 'lps'),
	(454091, 125, '2015-03-15 00:35:09.000000', 'consum', 0.0217, 'lps'),
	(454092, 125, '2015-03-15 00:35:10.000000', 'consum', 0.0220, 'lps'),
	(454093, 125, '2015-03-15 00:35:11.000000', 'consum', 0.0220, 'lps'),
	(454094, 125, '2015-03-15 00:35:12.000000', 'consum', 0.0215, 'lps'),
	(454095, 125, '2015-03-15 00:35:13.000000', 'consum', 0.0222, 'lps'),
	(454096, 125, '2015-03-15 00:35:14.000000', 'consum', 0.0218, 'lps'),
	(454097, 125, '2015-03-15 00:35:15.000000', 'consum', 0.0217, 'lps'),
	(454098, 125, '2015-03-15 00:35:16.000000', 'consum', 0.0219, 'lps'),
	(454099, 125, '2015-03-15 00:35:17.000000', 'consum', 0.0216, 'lps'),
	(454100, 125, '2015-03-15 00:35:18.000000', 'consum', 0.0214, 'lps'),
	(454101, 125, '2015-03-15 00:35:19.000000', 'consum', 0.0212, 'lps'),
	(454102, 125, '2015-03-15 00:35:20.000000', 'consum', 0.0227, 'lps'),
	(454103, 125, '2015-03-15 00:35:21.000000', 'consum', 0.0218, 'lps'),
	(454104, 125, '2015-03-15 00:35:22.000000', 'consum', 0.0217, 'lps'),
	(454105, 125, '2015-03-15 00:35:23.000000', 'consum', 0.0220, 'lps'),
	(454106, 125, '2015-03-15 00:35:24.000000', 'consum', 0.0224, 'lps'),
	(454107, 125, '2015-03-15 00:35:25.000000', 'consum', 0.0212, 'lps'),
	(454108, 125, '2015-03-15 00:35:26.000000', 'consum', 0.0216, 'lps'),
	(454109, 125, '2015-03-15 00:35:27.000000', 'consum', 0.0217, 'lps'),
	(454110, 125, '2015-03-15 00:35:28.000000', 'consum', 0.0226, 'lps'),
	(454111, 125, '2015-03-15 00:35:29.000000', 'consum', 0.0215, 'lps'),
	(454112, 125, '2015-03-15 00:35:30.000000', 'consum', 0.0223, 'lps'),
	(454113, 125, '2015-03-15 00:35:31.000000', 'consum', 0.0225, 'lps'),
	(454114, 125, '2015-03-15 00:35:32.000000', 'consum', 0.0210, 'lps'),
	(454115, 125, '2015-03-15 00:35:33.000000', 'consum', 0.0220, 'lps'),
	(454116, 125, '2015-03-15 00:35:34.000000', 'consum', 0.0226, 'lps'),
	(454117, 125, '2015-03-15 00:35:35.000000', 'consum', 0.0223, 'lps'),
	(454118, 125, '2015-03-15 00:35:36.000000', 'consum', 0.0211, 'lps'),
	(454119, 125, '2015-03-15 00:35:37.000000', 'consum', 0.0213, 'lps'),
	(454120, 125, '2015-03-15 00:35:38.000000', 'consum', 0.0222, 'lps'),
	(454121, 125, '2015-03-15 00:35:39.000000', 'consum', 0.0226, 'lps'),
	(454122, 125, '2015-03-15 00:35:40.000000', 'consum', 0.0216, 'lps'),
	(454123, 125, '2015-03-15 00:35:41.000000', 'consum', 0.0212, 'lps'),
	(454124, 125, '2015-03-15 00:35:42.000000', 'consum', 0.0220, 'lps'),
	(454125, 125, '2015-03-15 00:35:43.000000', 'consum', 0.0219, 'lps'),
	(454126, 125, '2015-03-15 00:35:44.000000', 'consum', 0.0224, 'lps'),
	(454127, 125, '2015-03-15 00:35:45.000000', 'consum', 0.0218, 'lps'),
	(454128, 125, '2015-03-15 00:35:46.000000', 'consum', 0.0227, 'lps'),
	(454129, 125, '2015-03-15 00:35:47.000000', 'consum', 0.0219, 'lps'),
	(454130, 125, '2015-03-15 00:35:48.000000', 'consum', 0.0219, 'lps'),
	(454131, 125, '2015-03-15 00:35:49.000000', 'consum', 0.0214, 'lps'),
	(454132, 125, '2015-03-15 00:35:50.000000', 'consum', 0.0219, 'lps'),
	(454133, 125, '2015-03-15 00:35:51.000000', 'consum', 0.0225, 'lps'),
	(454134, 125, '2015-03-15 00:35:52.000000', 'consum', 0.0223, 'lps'),
	(454135, 125, '2015-03-15 00:35:53.000000', 'consum', 0.0212, 'lps'),
	(454136, 125, '2015-03-15 00:35:54.000000', 'consum', 0.0218, 'lps'),
	(454137, 125, '2015-03-15 00:35:55.000000', 'consum', 0.0227, 'lps'),
	(454138, 125, '2015-03-15 00:35:56.000000', 'consum', 0.0216, 'lps'),
	(454139, 125, '2015-03-15 00:35:57.000000', 'consum', 0.0225, 'lps'),
	(454140, 125, '2015-03-15 00:35:58.000000', 'consum', 0.0217, 'lps'),
	(454141, 125, '2015-03-15 00:35:59.000000', 'consum', 0.0215, 'lps'),
	(454142, 125, '2015-03-15 00:36:00.000000', 'consum', 0.0214, 'lps'),
	(454143, 125, '2015-03-15 00:36:01.000000', 'consum', 0.0217, 'lps'),
	(454144, 125, '2015-03-15 00:36:02.000000', 'consum', 0.0214, 'lps'),
	(454145, 125, '2015-03-15 00:36:03.000000', 'consum', 0.0227, 'lps'),
	(454146, 125, '2015-03-15 00:36:04.000000', 'consum', 0.0212, 'lps'),
	(454147, 125, '2015-03-15 00:36:05.000000', 'consum', 0.0226, 'lps'),
	(454148, 125, '2015-03-15 00:36:06.000000', 'consum', 0.0210, 'lps'),
	(454149, 125, '2015-03-15 00:36:07.000000', 'consum', 0.0217, 'lps'),
	(454150, 125, '2015-03-15 00:36:08.000000', 'consum', 0.0211, 'lps'),
	(454151, 125, '2015-03-15 00:36:09.000000', 'consum', 0.0227, 'lps'),
	(454152, 125, '2015-03-15 00:36:10.000000', 'consum', 0.0224, 'lps'),
	(454153, 125, '2015-03-15 00:36:11.000000', 'consum', 0.0212, 'lps'),
	(454154, 125, '2015-03-15 00:36:12.000000', 'consum', 0.0213, 'lps'),
	(454155, 125, '2015-03-15 00:36:13.000000', 'consum', 0.0221, 'lps'),
	(454156, 125, '2015-03-15 00:36:14.000000', 'consum', 0.0221, 'lps'),
	(454157, 125, '2015-03-15 00:36:15.000000', 'consum', 0.0214, 'lps'),
	(454158, 125, '2015-03-15 00:36:16.000000', 'consum', 0.0217, 'lps'),
	(454159, 125, '2015-03-15 00:36:17.000000', 'consum', 0.0212, 'lps'),
	(454160, 125, '2015-03-15 00:36:18.000000', 'consum', 0.0220, 'lps'),
	(454161, 125, '2015-03-15 00:36:19.000000', 'consum', 0.0216, 'lps'),
	(454162, 125, '2015-03-15 00:36:20.000000', 'consum', 0.0213, 'lps'),
	(454163, 125, '2015-03-15 00:36:21.000000', 'consum', 0.0225, 'lps'),
	(454164, 125, '2015-03-15 00:36:22.000000', 'consum', 0.0222, 'lps'),
	(454165, 125, '2015-03-15 00:36:23.000000', 'consum', 0.0227, 'lps'),
	(454166, 125, '2015-03-15 00:36:24.000000', 'consum', 0.0222, 'lps'),
	(454167, 125, '2015-03-15 00:36:25.000000', 'consum', 0.0222, 'lps'),
	(454168, 125, '2015-03-15 00:36:26.000000', 'consum', 0.0213, 'lps'),
	(454169, 125, '2015-03-15 00:36:27.000000', 'consum', 0.0211, 'lps'),
	(454170, 125, '2015-03-15 00:36:28.000000', 'consum', 0.0223, 'lps'),
	(454171, 125, '2015-03-15 00:36:29.000000', 'consum', 0.0218, 'lps'),
	(454172, 125, '2015-03-15 00:36:30.000000', 'consum', 0.0214, 'lps'),
	(454173, 125, '2015-03-15 00:36:31.000000', 'consum', 0.0223, 'lps'),
	(454174, 125, '2015-03-15 00:36:32.000000', 'consum', 0.0227, 'lps'),
	(454175, 125, '2015-03-15 00:36:33.000000', 'consum', 0.0220, 'lps'),
	(454176, 125, '2015-03-15 00:36:34.000000', 'consum', 0.0211, 'lps'),
	(454177, 125, '2015-03-15 00:36:35.000000', 'consum', 0.0219, 'lps'),
	(454178, 125, '2015-03-15 00:36:36.000000', 'consum', 0.0219, 'lps'),
	(454179, 125, '2015-03-15 00:36:37.000000', 'consum', 0.0211, 'lps'),
	(454180, 125, '2015-03-15 00:36:38.000000', 'consum', 0.0224, 'lps'),
	(454181, 125, '2015-03-15 00:36:39.000000', 'consum', 0.0224, 'lps'),
	(454182, 125, '2015-03-15 00:36:40.000000', 'consum', 0.0222, 'lps'),
	(454183, 125, '2015-03-15 00:36:41.000000', 'consum', 0.0227, 'lps'),
	(454184, 125, '2015-03-15 00:36:42.000000', 'consum', 0.0226, 'lps'),
	(454185, 125, '2015-03-15 00:36:43.000000', 'consum', 0.0218, 'lps'),
	(454186, 125, '2015-03-15 00:36:44.000000', 'consum', 0.0221, 'lps'),
	(454187, 125, '2015-03-15 00:36:45.000000', 'consum', 0.0222, 'lps'),
	(454188, 125, '2015-03-15 00:36:46.000000', 'consum', 0.0221, 'lps'),
	(454189, 125, '2015-03-15 00:36:47.000000', 'consum', 0.0212, 'lps'),
	(454190, 125, '2015-03-15 00:36:48.000000', 'consum', 0.0223, 'lps'),
	(454191, 125, '2015-03-15 00:36:49.000000', 'consum', 0.0214, 'lps'),
	(454192, 125, '2015-03-15 00:36:50.000000', 'consum', 0.0227, 'lps'),
	(454193, 125, '2015-03-15 00:36:51.000000', 'consum', 0.0213, 'lps'),
	(454194, 125, '2015-03-15 00:36:52.000000', 'consum', 0.0210, 'lps'),
	(454195, 125, '2015-03-15 00:36:53.000000', 'consum', 0.0219, 'lps'),
	(454196, 125, '2015-03-15 00:36:54.000000', 'consum', 0.0220, 'lps'),
	(454197, 125, '2015-03-15 00:36:55.000000', 'consum', 0.0214, 'lps'),
	(454198, 125, '2015-03-15 00:36:56.000000', 'consum', 0.0221, 'lps'),
	(454199, 125, '2015-03-15 00:36:57.000000', 'consum', 0.0215, 'lps'),
	(454200, 125, '2015-03-15 00:36:58.000000', 'consum', 0.0223, 'lps'),
	(454201, 125, '2015-03-15 00:36:59.000000', 'consum', 0.0223, 'lps'),
	(454202, 125, '2015-03-15 00:37:00.000000', 'consum', 0.0221, 'lps'),
	(454203, 125, '2015-03-15 00:37:01.000000', 'consum', 0.0223, 'lps'),
	(454204, 125, '2015-03-15 00:37:02.000000', 'consum', 0.0226, 'lps'),
	(454205, 125, '2015-03-15 00:37:03.000000', 'consum', 0.0216, 'lps'),
	(454206, 125, '2015-03-15 00:37:04.000000', 'consum', 0.0210, 'lps'),
	(454207, 125, '2015-03-15 00:37:05.000000', 'consum', 0.0212, 'lps'),
	(454208, 125, '2015-03-15 00:37:06.000000', 'consum', 0.0219, 'lps'),
	(454209, 125, '2015-03-15 00:37:07.000000', 'consum', 0.0214, 'lps'),
	(454210, 125, '2015-03-15 00:37:08.000000', 'consum', 0.0221, 'lps'),
	(454211, 125, '2015-03-15 00:37:09.000000', 'consum', 0.0218, 'lps'),
	(454212, 125, '2015-03-15 00:37:10.000000', 'consum', 0.0216, 'lps'),
	(454213, 125, '2015-03-15 00:37:11.000000', 'consum', 0.0215, 'lps'),
	(454214, 125, '2015-03-15 00:37:12.000000', 'consum', 0.0221, 'lps'),
	(454215, 125, '2015-03-15 00:37:13.000000', 'consum', 0.0212, 'lps'),
	(454216, 125, '2015-03-15 00:37:14.000000', 'consum', 0.0224, 'lps'),
	(454217, 125, '2015-03-15 00:37:15.000000', 'consum', 0.0221, 'lps'),
	(454218, 125, '2015-03-15 00:37:16.000000', 'consum', 0.0224, 'lps'),
	(454219, 125, '2015-03-15 00:37:17.000000', 'consum', 0.0227, 'lps'),
	(454220, 125, '2015-03-15 00:37:18.000000', 'consum', 0.0220, 'lps'),
	(454221, 125, '2015-03-15 00:37:19.000000', 'consum', 0.0210, 'lps'),
	(454222, 125, '2015-03-15 00:37:20.000000', 'consum', 0.0218, 'lps'),
	(454223, 125, '2015-03-15 00:37:21.000000', 'consum', 0.0211, 'lps'),
	(454224, 125, '2015-03-15 00:37:22.000000', 'consum', 0.0212, 'lps'),
	(454225, 125, '2015-03-15 00:37:23.000000', 'consum', 0.0215, 'lps'),
	(454226, 125, '2015-03-15 00:37:24.000000', 'consum', 0.0212, 'lps'),
	(454227, 125, '2015-03-15 00:37:25.000000', 'consum', 0.0224, 'lps'),
	(454228, 125, '2015-03-15 00:37:26.000000', 'consum', 0.0222, 'lps'),
	(454229, 125, '2015-03-15 00:37:27.000000', 'consum', 0.0227, 'lps'),
	(454230, 125, '2015-03-15 00:37:28.000000', 'consum', 0.0223, 'lps'),
	(454231, 125, '2015-03-15 00:37:29.000000', 'consum', 0.0224, 'lps'),
	(454232, 125, '2015-03-15 00:37:30.000000', 'consum', 0.0223, 'lps'),
	(454233, 125, '2015-03-15 00:37:31.000000', 'consum', 0.0215, 'lps'),
	(454234, 125, '2015-03-15 00:37:32.000000', 'consum', 0.0216, 'lps'),
	(454235, 125, '2015-03-15 00:37:33.000000', 'consum', 0.0227, 'lps'),
	(454236, 125, '2015-03-15 00:37:34.000000', 'consum', 0.0223, 'lps'),
	(454237, 125, '2015-03-15 00:37:35.000000', 'consum', 0.0223, 'lps'),
	(454238, 125, '2015-03-15 00:37:36.000000', 'consum', 0.0221, 'lps'),
	(454239, 125, '2015-03-15 00:37:37.000000', 'consum', 0.0225, 'lps'),
	(454240, 125, '2015-03-15 00:37:38.000000', 'consum', 0.0215, 'lps'),
	(454241, 125, '2015-03-15 00:37:39.000000', 'consum', 0.0227, 'lps'),
	(454242, 125, '2015-03-15 00:37:40.000000', 'consum', 0.0226, 'lps'),
	(454243, 125, '2015-03-15 00:37:41.000000', 'consum', 0.0221, 'lps'),
	(454244, 125, '2015-03-15 00:37:42.000000', 'consum', 0.0220, 'lps'),
	(454245, 125, '2015-03-15 00:37:43.000000', 'consum', 0.0226, 'lps'),
	(454246, 125, '2015-03-15 00:37:44.000000', 'consum', 0.0224, 'lps'),
	(454247, 125, '2015-03-15 00:37:45.000000', 'consum', 0.0214, 'lps'),
	(454248, 125, '2015-03-15 00:37:46.000000', 'consum', 0.0224, 'lps'),
	(454249, 125, '2015-03-15 00:37:47.000000', 'consum', 0.0215, 'lps'),
	(454250, 125, '2015-03-15 00:37:48.000000', 'consum', 0.0212, 'lps'),
	(454251, 125, '2015-03-15 00:37:49.000000', 'consum', 0.0222, 'lps'),
	(454252, 125, '2015-03-15 00:37:50.000000', 'consum', 0.0210, 'lps'),
	(454253, 125, '2015-03-15 00:37:51.000000', 'consum', 0.0212, 'lps'),
	(454254, 125, '2015-03-15 00:37:52.000000', 'consum', 0.0221, 'lps'),
	(454255, 125, '2015-03-15 00:37:53.000000', 'consum', 0.0225, 'lps'),
	(454256, 125, '2015-03-15 00:37:54.000000', 'consum', 0.0213, 'lps'),
	(454257, 125, '2015-03-15 00:37:55.000000', 'consum', 0.0220, 'lps'),
	(454258, 125, '2015-03-15 00:37:56.000000', 'consum', 0.0214, 'lps'),
	(454259, 125, '2015-03-15 00:37:57.000000', 'consum', 0.0217, 'lps'),
	(454260, 125, '2015-03-15 00:37:58.000000', 'consum', 0.0215, 'lps'),
	(454261, 125, '2015-03-15 00:37:59.000000', 'consum', 0.0218, 'lps'),
	(454262, 125, '2015-03-15 00:38:00.000000', 'consum', 0.0214, 'lps'),
	(454263, 125, '2015-03-15 00:38:01.000000', 'consum', 0.0226, 'lps'),
	(454264, 125, '2015-03-15 00:38:02.000000', 'consum', 0.0223, 'lps'),
	(454265, 125, '2015-03-15 00:38:03.000000', 'consum', 0.0211, 'lps'),
	(454266, 125, '2015-03-15 00:38:04.000000', 'consum', 0.0213, 'lps'),
	(454267, 125, '2015-03-15 00:38:05.000000', 'consum', 0.0222, 'lps'),
	(454268, 125, '2015-03-15 00:38:06.000000', 'consum', 0.0225, 'lps'),
	(454269, 125, '2015-03-15 00:38:07.000000', 'consum', 0.0215, 'lps'),
	(454270, 125, '2015-03-15 00:38:08.000000', 'consum', 0.0225, 'lps'),
	(454271, 125, '2015-03-15 00:38:09.000000', 'consum', 0.0216, 'lps'),
	(454272, 125, '2015-03-15 00:38:10.000000', 'consum', 0.0213, 'lps'),
	(454273, 125, '2015-03-15 00:38:11.000000', 'consum', 0.0210, 'lps'),
	(454274, 125, '2015-03-15 00:38:12.000000', 'consum', 0.0218, 'lps'),
	(454275, 125, '2015-03-15 00:38:13.000000', 'consum', 0.0213, 'lps'),
	(454276, 125, '2015-03-15 00:38:14.000000', 'consum', 0.0220, 'lps'),
	(454277, 125, '2015-03-15 00:38:15.000000', 'consum', 0.0216, 'lps'),
	(454278, 125, '2015-03-15 00:38:16.000000', 'consum', 0.0212, 'lps'),
	(454279, 125, '2015-03-15 00:38:17.000000', 'consum', 0.0220, 'lps'),
	(454280, 125, '2015-03-15 00:38:18.000000', 'consum', 0.0220, 'lps'),
	(454281, 125, '2015-03-15 00:38:19.000000', 'consum', 0.0212, 'lps'),
	(454282, 125, '2015-03-15 00:38:20.000000', 'consum', 0.0226, 'lps'),
	(454283, 125, '2015-03-15 00:38:21.000000', 'consum', 0.0212, 'lps'),
	(454284, 125, '2015-03-15 00:38:22.000000', 'consum', 0.0226, 'lps'),
	(454285, 125, '2015-03-15 00:38:23.000000', 'consum', 0.0211, 'lps'),
	(454286, 125, '2015-03-15 00:38:24.000000', 'consum', 0.0225, 'lps'),
	(454287, 125, '2015-03-15 00:38:25.000000', 'consum', 0.0226, 'lps'),
	(454288, 125, '2015-03-15 00:38:26.000000', 'consum', 0.0227, 'lps'),
	(454289, 125, '2015-03-15 00:38:27.000000', 'consum', 0.0212, 'lps'),
	(454290, 125, '2015-03-15 00:38:28.000000', 'consum', 0.0225, 'lps'),
	(454291, 125, '2015-03-15 00:38:29.000000', 'consum', 0.0223, 'lps'),
	(454292, 125, '2015-03-15 00:38:30.000000', 'consum', 0.0213, 'lps'),
	(454293, 125, '2015-03-15 00:38:31.000000', 'consum', 0.0222, 'lps'),
	(454294, 125, '2015-03-15 00:38:32.000000', 'consum', 0.0227, 'lps'),
	(454295, 125, '2015-03-15 00:38:33.000000', 'consum', 0.0221, 'lps'),
	(454296, 125, '2015-03-15 00:38:34.000000', 'consum', 0.0217, 'lps'),
	(454297, 125, '2015-03-15 00:38:35.000000', 'consum', 0.0210, 'lps'),
	(454298, 125, '2015-03-15 00:38:36.000000', 'consum', 0.0227, 'lps'),
	(454299, 125, '2015-03-15 00:38:37.000000', 'consum', 0.0225, 'lps'),
	(454300, 125, '2015-03-15 00:38:38.000000', 'consum', 0.0217, 'lps'),
	(454301, 125, '2015-03-15 00:38:39.000000', 'consum', 0.0216, 'lps'),
	(454302, 125, '2015-03-15 00:38:40.000000', 'consum', 0.0221, 'lps'),
	(454303, 125, '2015-03-15 00:38:41.000000', 'consum', 0.0227, 'lps'),
	(454304, 125, '2015-03-15 00:38:42.000000', 'consum', 0.0210, 'lps'),
	(454305, 125, '2015-03-15 00:38:43.000000', 'consum', 0.0213, 'lps'),
	(454306, 125, '2015-03-15 00:38:44.000000', 'consum', 0.0227, 'lps'),
	(454307, 125, '2015-03-15 00:38:45.000000', 'consum', 0.0214, 'lps'),
	(454308, 125, '2015-03-15 00:38:46.000000', 'consum', 0.0217, 'lps'),
	(454309, 125, '2015-03-15 00:38:47.000000', 'consum', 0.0213, 'lps'),
	(454310, 125, '2015-03-15 00:38:48.000000', 'consum', 0.0225, 'lps'),
	(454311, 125, '2015-03-15 00:38:49.000000', 'consum', 0.0220, 'lps'),
	(454312, 125, '2015-03-15 00:38:50.000000', 'consum', 0.0217, 'lps'),
	(454313, 125, '2015-03-15 00:38:51.000000', 'consum', 0.0213, 'lps'),
	(454314, 125, '2015-03-15 00:38:52.000000', 'consum', 0.0225, 'lps'),
	(454315, 125, '2015-03-15 00:38:53.000000', 'consum', 0.0220, 'lps'),
	(454316, 125, '2015-03-15 00:38:54.000000', 'consum', 0.0216, 'lps'),
	(454317, 125, '2015-03-15 00:38:55.000000', 'consum', 0.0212, 'lps'),
	(454318, 125, '2015-03-15 00:38:56.000000', 'consum', 0.0219, 'lps'),
	(454319, 125, '2015-03-15 00:38:57.000000', 'consum', 0.0214, 'lps'),
	(454320, 125, '2015-03-15 00:38:58.000000', 'consum', 0.0220, 'lps'),
	(454321, 125, '2015-03-15 00:38:59.000000', 'consum', 0.0214, 'lps'),
	(454322, 125, '2015-03-15 00:39:00.000000', 'consum', 0.0219, 'lps'),
	(454323, 125, '2015-03-15 00:39:01.000000', 'consum', 0.0227, 'lps'),
	(454324, 125, '2015-03-15 00:39:02.000000', 'consum', 0.0213, 'lps'),
	(454325, 125, '2015-03-15 00:39:03.000000', 'consum', 0.0212, 'lps'),
	(454326, 125, '2015-03-15 00:39:04.000000', 'consum', 0.0211, 'lps'),
	(454327, 125, '2015-03-15 00:39:05.000000', 'consum', 0.0226, 'lps'),
	(454328, 125, '2015-03-15 00:39:06.000000', 'consum', 0.0217, 'lps'),
	(454329, 125, '2015-03-15 00:39:07.000000', 'consum', 0.0216, 'lps'),
	(454330, 125, '2015-03-15 00:39:08.000000', 'consum', 0.0221, 'lps'),
	(454331, 125, '2015-03-15 00:39:09.000000', 'consum', 0.0226, 'lps'),
	(454332, 125, '2015-03-15 00:39:10.000000', 'consum', 0.0224, 'lps'),
	(454333, 125, '2015-03-15 00:39:11.000000', 'consum', 0.0213, 'lps'),
	(454334, 125, '2015-03-15 00:39:12.000000', 'consum', 0.0219, 'lps'),
	(454335, 125, '2015-03-15 00:39:13.000000', 'consum', 0.0227, 'lps'),
	(454336, 125, '2015-03-15 00:39:14.000000', 'consum', 0.0216, 'lps'),
	(454337, 125, '2015-03-15 00:39:15.000000', 'consum', 0.0210, 'lps'),
	(454338, 125, '2015-03-15 00:39:16.000000', 'consum', 0.0225, 'lps'),
	(454339, 125, '2015-03-15 00:39:17.000000', 'consum', 0.0214, 'lps'),
	(454340, 125, '2015-03-15 00:39:18.000000', 'consum', 0.0221, 'lps'),
	(454341, 125, '2015-03-15 00:39:19.000000', 'consum', 0.0216, 'lps'),
	(454342, 125, '2015-03-15 00:39:20.000000', 'consum', 0.0210, 'lps'),
	(454343, 125, '2015-03-15 00:39:21.000000', 'consum', 0.0226, 'lps'),
	(454344, 125, '2015-03-15 00:39:22.000000', 'consum', 0.0219, 'lps'),
	(454345, 125, '2015-03-15 00:39:23.000000', 'consum', 0.0224, 'lps'),
	(454346, 125, '2015-03-15 00:39:24.000000', 'consum', 0.0219, 'lps'),
	(454347, 125, '2015-03-15 00:39:25.000000', 'consum', 0.0212, 'lps'),
	(454348, 125, '2015-03-15 00:39:26.000000', 'consum', 0.0211, 'lps'),
	(454349, 125, '2015-03-15 00:39:27.000000', 'consum', 0.0227, 'lps'),
	(454350, 125, '2015-03-15 00:39:28.000000', 'consum', 0.0223, 'lps'),
	(454351, 125, '2015-03-15 00:39:29.000000', 'consum', 0.0222, 'lps'),
	(454352, 125, '2015-03-15 00:39:30.000000', 'consum', 0.0216, 'lps'),
	(454353, 125, '2015-03-15 00:39:31.000000', 'consum', 0.0220, 'lps'),
	(454354, 125, '2015-03-15 00:39:32.000000', 'consum', 0.0210, 'lps'),
	(454355, 125, '2015-03-15 00:39:33.000000', 'consum', 0.0213, 'lps'),
	(454356, 125, '2015-03-15 00:39:34.000000', 'consum', 0.0226, 'lps'),
	(454357, 125, '2015-03-15 00:39:35.000000', 'consum', 0.0210, 'lps'),
	(454358, 125, '2015-03-15 00:39:36.000000', 'consum', 0.0216, 'lps'),
	(454359, 125, '2015-03-15 00:39:37.000000', 'consum', 0.0224, 'lps'),
	(454360, 125, '2015-03-15 00:39:38.000000', 'consum', 0.0227, 'lps'),
	(454361, 125, '2015-03-15 00:39:39.000000', 'consum', 0.0217, 'lps'),
	(454362, 125, '2015-03-15 00:39:40.000000', 'consum', 0.0210, 'lps'),
	(454363, 125, '2015-03-15 00:39:41.000000', 'consum', 0.0211, 'lps'),
	(454364, 125, '2015-03-15 00:39:42.000000', 'consum', 0.0214, 'lps'),
	(454365, 125, '2015-03-15 00:39:43.000000', 'consum', 0.0227, 'lps'),
	(454366, 125, '2015-03-15 00:39:44.000000', 'consum', 0.0214, 'lps'),
	(454367, 125, '2015-03-15 00:39:45.000000', 'consum', 0.0214, 'lps'),
	(454368, 125, '2015-03-15 00:39:46.000000', 'consum', 0.0219, 'lps'),
	(454369, 125, '2015-03-15 00:39:47.000000', 'consum', 0.0224, 'lps'),
	(454370, 125, '2015-03-15 00:39:48.000000', 'consum', 0.0218, 'lps'),
	(454371, 125, '2015-03-15 00:39:49.000000', 'consum', 0.0226, 'lps'),
	(454372, 125, '2015-03-15 00:39:50.000000', 'consum', 0.0211, 'lps'),
	(454373, 125, '2015-03-15 00:39:51.000000', 'consum', 0.0223, 'lps'),
	(454374, 125, '2015-03-15 00:39:52.000000', 'consum', 0.0219, 'lps'),
	(454375, 125, '2015-03-15 00:39:53.000000', 'consum', 0.0215, 'lps'),
	(454376, 125, '2015-03-15 00:39:54.000000', 'consum', 0.0211, 'lps'),
	(454377, 125, '2015-03-15 00:39:55.000000', 'consum', 0.0218, 'lps'),
	(454378, 125, '2015-03-15 00:39:56.000000', 'consum', 0.0213, 'lps'),
	(454379, 125, '2015-03-15 00:39:57.000000', 'consum', 0.0217, 'lps'),
	(454380, 125, '2015-03-15 00:39:58.000000', 'consum', 0.0219, 'lps'),
	(454381, 125, '2015-03-15 00:39:59.000000', 'consum', 0.0216, 'lps'),
	(454382, 125, '2015-03-15 00:40:00.000000', 'consum', 0.0215, 'lps'),
	(454383, 125, '2015-03-15 00:40:01.000000', 'consum', 0.0216, 'lps'),
	(454384, 125, '2015-03-15 00:40:02.000000', 'consum', 0.0225, 'lps'),
	(454385, 125, '2015-03-15 00:40:03.000000', 'consum', 0.0214, 'lps'),
	(454386, 125, '2015-03-15 00:40:04.000000', 'consum', 0.0220, 'lps'),
	(454387, 125, '2015-03-15 00:40:05.000000', 'consum', 0.0214, 'lps'),
	(454388, 125, '2015-03-15 00:40:06.000000', 'consum', 0.0218, 'lps'),
	(454389, 125, '2015-03-15 00:40:07.000000', 'consum', 0.0221, 'lps'),
	(454390, 125, '2015-03-15 00:40:08.000000', 'consum', 0.0222, 'lps'),
	(454391, 125, '2015-03-15 00:40:09.000000', 'consum', 0.0221, 'lps'),
	(454392, 125, '2015-03-15 00:40:10.000000', 'consum', 0.0213, 'lps'),
	(454393, 125, '2015-03-15 00:40:11.000000', 'consum', 0.0226, 'lps'),
	(454394, 125, '2015-03-15 00:40:12.000000', 'consum', 0.0212, 'lps'),
	(454395, 125, '2015-03-15 00:40:13.000000', 'consum', 0.0224, 'lps'),
	(454396, 125, '2015-03-15 00:40:14.000000', 'consum', 0.0222, 'lps'),
	(454397, 125, '2015-03-15 00:40:15.000000', 'consum', 0.0226, 'lps'),
	(454398, 125, '2015-03-15 00:40:16.000000', 'consum', 0.0220, 'lps'),
	(454399, 125, '2015-03-15 00:40:17.000000', 'consum', 0.0214, 'lps'),
	(454400, 125, '2015-03-15 00:40:18.000000', 'consum', 0.0216, 'lps'),
	(454401, 125, '2015-03-15 00:40:19.000000', 'consum', 0.0213, 'lps'),
	(454402, 125, '2015-03-15 00:40:20.000000', 'consum', 0.0227, 'lps'),
	(454403, 125, '2015-03-15 00:40:21.000000', 'consum', 0.0211, 'lps'),
	(454404, 125, '2015-03-15 00:40:22.000000', 'consum', 0.0218, 'lps'),
	(454405, 125, '2015-03-15 00:40:23.000000', 'consum', 0.0214, 'lps'),
	(454406, 125, '2015-03-15 00:40:24.000000', 'consum', 0.0223, 'lps'),
	(454407, 125, '2015-03-15 00:40:25.000000', 'consum', 0.0210, 'lps'),
	(454408, 125, '2015-03-15 00:40:26.000000', 'consum', 0.0226, 'lps'),
	(454409, 125, '2015-03-15 00:40:27.000000', 'consum', 0.0219, 'lps'),
	(454410, 125, '2015-03-15 00:40:28.000000', 'consum', 0.0227, 'lps'),
	(454411, 125, '2015-03-15 00:40:29.000000', 'consum', 0.0211, 'lps'),
	(454412, 125, '2015-03-15 00:40:30.000000', 'consum', 0.0220, 'lps'),
	(454413, 125, '2015-03-15 00:40:31.000000', 'consum', 0.0223, 'lps'),
	(454414, 125, '2015-03-15 00:40:32.000000', 'consum', 0.0210, 'lps'),
	(454415, 125, '2015-03-15 00:40:33.000000', 'consum', 0.0226, 'lps'),
	(454416, 125, '2015-03-15 00:40:34.000000', 'consum', 0.0219, 'lps'),
	(454417, 125, '2015-03-15 00:40:35.000000', 'consum', 0.0224, 'lps'),
	(454418, 125, '2015-03-15 00:40:36.000000', 'consum', 0.0216, 'lps'),
	(454419, 125, '2015-03-15 00:40:37.000000', 'consum', 0.0218, 'lps'),
	(454420, 125, '2015-03-15 00:40:38.000000', 'consum', 0.0213, 'lps'),
	(454421, 125, '2015-03-15 00:40:39.000000', 'consum', 0.0218, 'lps'),
	(454422, 125, '2015-03-15 00:40:40.000000', 'consum', 0.0227, 'lps'),
	(454423, 125, '2015-03-15 00:40:41.000000', 'consum', 0.0215, 'lps'),
	(454424, 125, '2015-03-15 00:40:42.000000', 'consum', 0.0222, 'lps'),
	(454425, 125, '2015-03-15 00:40:43.000000', 'consum', 0.0219, 'lps'),
	(454426, 125, '2015-03-15 00:40:44.000000', 'consum', 0.0221, 'lps'),
	(454427, 125, '2015-03-15 00:40:45.000000', 'consum', 0.0222, 'lps'),
	(454428, 125, '2015-03-15 00:40:46.000000', 'consum', 0.0216, 'lps'),
	(454429, 125, '2015-03-15 00:40:47.000000', 'consum', 0.0222, 'lps'),
	(454430, 125, '2015-03-15 00:40:48.000000', 'consum', 0.0219, 'lps'),
	(454431, 125, '2015-03-15 00:40:49.000000', 'consum', 0.0217, 'lps'),
	(454432, 125, '2015-03-15 00:40:50.000000', 'consum', 0.0221, 'lps'),
	(454433, 125, '2015-03-15 00:40:51.000000', 'consum', 0.0227, 'lps'),
	(454434, 125, '2015-03-15 00:40:52.000000', 'consum', 0.0224, 'lps'),
	(454435, 125, '2015-03-15 00:40:53.000000', 'consum', 0.0212, 'lps'),
	(454436, 125, '2015-03-15 00:40:54.000000', 'consum', 0.0214, 'lps'),
	(454437, 125, '2015-03-15 00:40:55.000000', 'consum', 0.0226, 'lps'),
	(454438, 125, '2015-03-15 00:40:56.000000', 'consum', 0.0224, 'lps'),
	(454439, 125, '2015-03-15 00:40:57.000000', 'consum', 0.0213, 'lps'),
	(454440, 125, '2015-03-15 00:40:58.000000', 'consum', 0.0221, 'lps'),
	(454441, 125, '2015-03-15 00:40:59.000000', 'consum', 0.0220, 'lps'),
	(454442, 125, '2015-03-15 00:41:00.000000', 'consum', 0.0226, 'lps'),
	(454443, 125, '2015-03-15 00:41:01.000000', 'consum', 0.0226, 'lps'),
	(454444, 125, '2015-03-15 00:41:02.000000', 'consum', 0.0224, 'lps'),
	(454445, 125, '2015-03-15 00:41:03.000000', 'consum', 0.0214, 'lps'),
	(454446, 125, '2015-03-15 00:41:04.000000', 'consum', 0.0224, 'lps'),
	(454447, 125, '2015-03-15 00:41:05.000000', 'consum', 0.0213, 'lps'),
	(454448, 125, '2015-03-15 00:41:06.000000', 'consum', 0.0223, 'lps'),
	(454449, 125, '2015-03-15 00:41:07.000000', 'consum', 0.0227, 'lps'),
	(454450, 125, '2015-03-15 00:41:08.000000', 'consum', 0.0222, 'lps'),
	(454451, 125, '2015-03-15 00:41:09.000000', 'consum', 0.0221, 'lps'),
	(454452, 125, '2015-03-15 00:41:10.000000', 'consum', 0.0211, 'lps'),
	(454453, 125, '2015-03-15 00:41:11.000000', 'consum', 0.0217, 'lps'),
	(454454, 125, '2015-03-15 00:41:12.000000', 'consum', 0.0224, 'lps'),
	(454455, 125, '2015-03-15 00:41:13.000000', 'consum', 0.0223, 'lps'),
	(454456, 125, '2015-03-15 00:41:14.000000', 'consum', 0.0218, 'lps'),
	(454457, 125, '2015-03-15 00:41:15.000000', 'consum', 0.0210, 'lps'),
	(454458, 125, '2015-03-15 00:41:16.000000', 'consum', 0.0223, 'lps'),
	(454459, 125, '2015-03-15 00:41:17.000000', 'consum', 0.0221, 'lps'),
	(454460, 125, '2015-03-15 00:41:18.000000', 'consum', 0.0210, 'lps'),
	(454461, 125, '2015-03-15 00:41:19.000000', 'consum', 0.0211, 'lps'),
	(454462, 125, '2015-03-15 00:41:20.000000', 'consum', 0.0216, 'lps'),
	(454463, 125, '2015-03-15 00:41:21.000000', 'consum', 0.0221, 'lps'),
	(454464, 125, '2015-03-15 00:41:22.000000', 'consum', 0.0211, 'lps'),
	(454465, 125, '2015-03-15 00:41:23.000000', 'consum', 0.0218, 'lps'),
	(454466, 125, '2015-03-15 00:41:24.000000', 'consum', 0.0213, 'lps'),
	(454467, 125, '2015-03-15 00:41:25.000000', 'consum', 0.0219, 'lps'),
	(454468, 125, '2015-03-15 00:41:26.000000', 'consum', 0.0226, 'lps'),
	(454469, 125, '2015-03-15 00:41:27.000000', 'consum', 0.0212, 'lps'),
	(454470, 125, '2015-03-15 00:41:28.000000', 'consum', 0.0225, 'lps'),
	(454471, 125, '2015-03-15 00:41:29.000000', 'consum', 0.0226, 'lps'),
	(454472, 125, '2015-03-15 00:41:30.000000', 'consum', 0.0227, 'lps'),
	(454473, 125, '2015-03-15 00:41:31.000000', 'consum', 0.0210, 'lps'),
	(454474, 125, '2015-03-15 00:41:32.000000', 'consum', 0.0217, 'lps'),
	(454475, 125, '2015-03-15 00:41:33.000000', 'consum', 0.0224, 'lps'),
	(454476, 125, '2015-03-15 00:41:34.000000', 'consum', 0.0227, 'lps'),
	(454477, 125, '2015-03-15 00:41:35.000000', 'consum', 0.0215, 'lps'),
	(454478, 125, '2015-03-15 00:41:36.000000', 'consum', 0.0219, 'lps'),
	(454479, 125, '2015-03-15 00:41:37.000000', 'consum', 0.0224, 'lps'),
	(454480, 125, '2015-03-15 00:41:38.000000', 'consum', 0.0219, 'lps'),
	(454481, 125, '2015-03-15 00:41:39.000000', 'consum', 0.0213, 'lps'),
	(454482, 125, '2015-03-15 00:41:40.000000', 'consum', 0.0216, 'lps'),
	(454483, 125, '2015-03-15 00:41:41.000000', 'consum', 0.0212, 'lps'),
	(454484, 125, '2015-03-15 00:41:42.000000', 'consum', 0.0222, 'lps'),
	(454485, 125, '2015-03-15 00:41:43.000000', 'consum', 0.0210, 'lps'),
	(454486, 125, '2015-03-15 00:41:44.000000', 'consum', 0.0212, 'lps'),
	(454487, 125, '2015-03-15 00:41:45.000000', 'consum', 0.0221, 'lps'),
	(454488, 125, '2015-03-15 00:41:46.000000', 'consum', 0.0222, 'lps'),
	(454489, 125, '2015-03-15 00:41:47.000000', 'consum', 0.0220, 'lps'),
	(454490, 125, '2015-03-15 00:41:48.000000', 'consum', 0.0224, 'lps'),
	(454491, 125, '2015-03-15 00:41:49.000000', 'consum', 0.0213, 'lps'),
	(454492, 125, '2015-03-15 00:41:50.000000', 'consum', 0.0222, 'lps'),
	(454493, 125, '2015-03-15 00:41:51.000000', 'consum', 0.0224, 'lps'),
	(454494, 125, '2015-03-15 00:41:52.000000', 'consum', 0.0227, 'lps'),
	(454495, 125, '2015-03-15 00:41:53.000000', 'consum', 0.0216, 'lps'),
	(454496, 125, '2015-03-15 00:41:54.000000', 'consum', 0.0211, 'lps'),
	(454497, 125, '2015-03-15 00:41:55.000000', 'consum', 0.0212, 'lps'),
	(454498, 125, '2015-03-15 00:41:56.000000', 'consum', 0.0219, 'lps'),
	(454499, 125, '2015-03-15 00:41:57.000000', 'consum', 0.0214, 'lps'),
	(454500, 125, '2015-03-15 00:41:58.000000', 'consum', 0.0223, 'lps'),
	(454501, 125, '2015-03-15 00:41:59.000000', 'consum', 0.0226, 'lps'),
	(454502, 125, '2015-03-15 00:42:00.000000', 'consum', 0.0214, 'lps'),
	(454503, 125, '2015-03-15 00:42:01.000000', 'consum', 0.0220, 'lps'),
	(454504, 125, '2015-03-15 00:42:02.000000', 'consum', 0.0210, 'lps'),
	(454505, 125, '2015-03-15 00:42:03.000000', 'consum', 0.0220, 'lps'),
	(454506, 125, '2015-03-15 00:42:04.000000', 'consum', 0.0221, 'lps'),
	(454507, 125, '2015-03-15 00:42:05.000000', 'consum', 0.0221, 'lps'),
	(454508, 125, '2015-03-15 00:42:06.000000', 'consum', 0.0212, 'lps'),
	(454509, 125, '2015-03-15 00:42:07.000000', 'consum', 0.0223, 'lps'),
	(454510, 125, '2015-03-15 00:42:08.000000', 'consum', 0.0215, 'lps'),
	(454511, 125, '2015-03-15 00:42:09.000000', 'consum', 0.0214, 'lps'),
	(454512, 125, '2015-03-15 00:42:10.000000', 'consum', 0.0217, 'lps'),
	(454513, 125, '2015-03-15 00:42:11.000000', 'consum', 0.0215, 'lps'),
	(454514, 125, '2015-03-15 00:42:12.000000', 'consum', 0.0213, 'lps'),
	(454515, 125, '2015-03-15 00:42:13.000000', 'consum', 0.0210, 'lps'),
	(454516, 125, '2015-03-15 00:42:14.000000', 'consum', 0.0222, 'lps'),
	(454517, 125, '2015-03-15 00:42:15.000000', 'consum', 0.0218, 'lps'),
	(454518, 125, '2015-03-15 00:42:16.000000', 'consum', 0.0211, 'lps'),
	(454519, 125, '2015-03-15 00:42:17.000000', 'consum', 0.0227, 'lps'),
	(454520, 125, '2015-03-15 00:42:18.000000', 'consum', 0.0223, 'lps'),
	(454521, 125, '2015-03-15 00:42:19.000000', 'consum', 0.0223, 'lps'),
	(454522, 125, '2015-03-15 00:42:20.000000', 'consum', 0.0221, 'lps'),
	(454523, 125, '2015-03-15 00:42:21.000000', 'consum', 0.0225, 'lps'),
	(454524, 125, '2015-03-15 00:42:22.000000', 'consum', 0.0216, 'lps'),
	(454525, 125, '2015-03-15 00:42:23.000000', 'consum', 0.0212, 'lps'),
	(454526, 125, '2015-03-15 00:42:24.000000', 'consum', 0.0223, 'lps'),
	(454527, 125, '2015-03-15 00:42:25.000000', 'consum', 0.0216, 'lps'),
	(454528, 125, '2015-03-15 00:42:26.000000', 'consum', 0.0217, 'lps'),
	(454529, 125, '2015-03-15 00:42:27.000000', 'consum', 0.0226, 'lps'),
	(454530, 125, '2015-03-15 00:42:28.000000', 'consum', 0.0219, 'lps'),
	(454531, 125, '2015-03-15 00:42:29.000000', 'consum', 0.0225, 'lps'),
	(454532, 125, '2015-03-15 00:42:30.000000', 'consum', 0.0224, 'lps'),
	(454533, 125, '2015-03-15 00:42:31.000000', 'consum', 0.0215, 'lps'),
	(454534, 125, '2015-03-15 00:42:32.000000', 'consum', 0.0210, 'lps'),
	(454535, 125, '2015-03-15 00:42:33.000000', 'consum', 0.0216, 'lps'),
	(454536, 125, '2015-03-15 00:42:34.000000', 'consum', 0.0223, 'lps'),
	(454537, 125, '2015-03-15 00:42:35.000000', 'consum', 0.0219, 'lps'),
	(454538, 125, '2015-03-15 00:42:36.000000', 'consum', 0.0216, 'lps'),
	(454539, 125, '2015-03-15 00:42:37.000000', 'consum', 0.0216, 'lps'),
	(454540, 125, '2015-03-15 00:42:38.000000', 'consum', 0.0223, 'lps'),
	(454541, 125, '2015-03-15 00:42:39.000000', 'consum', 0.0220, 'lps'),
	(454542, 125, '2015-03-15 00:42:40.000000', 'consum', 0.0223, 'lps'),
	(454543, 125, '2015-03-15 00:42:41.000000', 'consum', 0.0210, 'lps'),
	(454544, 125, '2015-03-15 00:42:42.000000', 'consum', 0.0224, 'lps'),
	(454545, 125, '2015-03-15 00:42:43.000000', 'consum', 0.0225, 'lps'),
	(454546, 125, '2015-03-15 00:42:44.000000', 'consum', 0.0210, 'lps'),
	(454547, 125, '2015-03-15 00:42:45.000000', 'consum', 0.0217, 'lps'),
	(454548, 125, '2015-03-15 00:42:46.000000', 'consum', 0.0212, 'lps'),
	(454549, 125, '2015-03-15 00:42:47.000000', 'consum', 0.0217, 'lps'),
	(454550, 125, '2015-03-15 00:42:48.000000', 'consum', 0.0220, 'lps'),
	(454551, 125, '2015-03-15 00:42:49.000000', 'consum', 0.0224, 'lps'),
	(454552, 125, '2015-03-15 00:42:50.000000', 'consum', 0.0215, 'lps'),
	(454553, 125, '2015-03-15 00:42:51.000000', 'consum', 0.0210, 'lps'),
	(454554, 125, '2015-03-15 00:42:52.000000', 'consum', 0.0212, 'lps'),
	(454555, 125, '2015-03-15 00:42:53.000000', 'consum', 0.0221, 'lps'),
	(454556, 125, '2015-03-15 00:42:54.000000', 'consum', 0.0224, 'lps'),
	(454557, 125, '2015-03-15 00:42:55.000000', 'consum', 0.0210, 'lps'),
	(454558, 125, '2015-03-15 00:42:56.000000', 'consum', 0.0224, 'lps'),
	(454559, 125, '2015-03-15 00:42:57.000000', 'consum', 0.0227, 'lps'),
	(454560, 125, '2015-03-15 00:42:58.000000', 'consum', 0.0217, 'lps'),
	(454561, 125, '2015-03-15 00:42:59.000000', 'consum', 0.0212, 'lps'),
	(454562, 125, '2015-03-15 00:43:00.000000', 'consum', 0.0220, 'lps'),
	(454563, 125, '2015-03-15 00:43:01.000000', 'consum', 0.0215, 'lps'),
	(454564, 125, '2015-03-15 00:43:02.000000', 'consum', 0.0224, 'lps'),
	(454565, 125, '2015-03-15 00:43:03.000000', 'consum', 0.0214, 'lps'),
	(454566, 125, '2015-03-15 00:43:04.000000', 'consum', 0.0224, 'lps'),
	(454567, 125, '2015-03-15 00:43:05.000000', 'consum', 0.0213, 'lps'),
	(454568, 125, '2015-03-15 00:43:06.000000', 'consum', 0.0222, 'lps'),
	(454569, 125, '2015-03-15 00:43:07.000000', 'consum', 0.0225, 'lps'),
	(454570, 125, '2015-03-15 00:43:08.000000', 'consum', 0.0214, 'lps'),
	(454571, 125, '2015-03-15 00:43:09.000000', 'consum', 0.0220, 'lps'),
	(454572, 125, '2015-03-15 00:43:10.000000', 'consum', 0.0214, 'lps'),
	(454573, 125, '2015-03-15 00:43:11.000000', 'consum', 0.0217, 'lps'),
	(454574, 125, '2015-03-15 00:43:12.000000', 'consum', 0.0214, 'lps'),
	(454575, 125, '2015-03-15 00:43:13.000000', 'consum', 0.0212, 'lps'),
	(454576, 125, '2015-03-15 00:43:14.000000', 'consum', 0.0227, 'lps'),
	(454577, 125, '2015-03-15 00:43:15.000000', 'consum', 0.0217, 'lps'),
	(454578, 125, '2015-03-15 00:43:16.000000', 'consum', 0.0211, 'lps'),
	(454579, 125, '2015-03-15 00:43:17.000000', 'consum', 0.0214, 'lps'),
	(454580, 125, '2015-03-15 00:43:18.000000', 'consum', 0.0226, 'lps'),
	(454581, 125, '2015-03-15 00:43:19.000000', 'consum', 0.0227, 'lps'),
	(454582, 125, '2015-03-15 00:43:20.000000', 'consum', 0.0211, 'lps'),
	(454583, 125, '2015-03-15 00:43:21.000000', 'consum', 0.0218, 'lps'),
	(454584, 125, '2015-03-15 00:43:22.000000', 'consum', 0.0211, 'lps'),
	(454585, 125, '2015-03-15 00:43:23.000000', 'consum', 0.0211, 'lps'),
	(454586, 125, '2015-03-15 00:43:24.000000', 'consum', 0.0211, 'lps'),
	(454587, 125, '2015-03-15 00:43:25.000000', 'consum', 0.0213, 'lps'),
	(454588, 125, '2015-03-15 00:43:26.000000', 'consum', 0.0221, 'lps'),
	(454589, 125, '2015-03-15 00:43:27.000000', 'consum', 0.0220, 'lps'),
	(454590, 125, '2015-03-15 00:43:28.000000', 'consum', 0.0211, 'lps'),
	(454591, 125, '2015-03-15 00:43:29.000000', 'consum', 0.0219, 'lps'),
	(454592, 125, '2015-03-15 00:43:30.000000', 'consum', 0.0219, 'lps'),
	(454593, 125, '2015-03-15 00:43:31.000000', 'consum', 0.0212, 'lps'),
	(454594, 125, '2015-03-15 00:43:32.000000', 'consum', 0.0226, 'lps'),
	(454595, 125, '2015-03-15 00:43:33.000000', 'consum', 0.0216, 'lps'),
	(454596, 125, '2015-03-15 00:43:34.000000', 'consum', 0.0226, 'lps'),
	(454597, 125, '2015-03-15 00:43:35.000000', 'consum', 0.0218, 'lps'),
	(454598, 125, '2015-03-15 00:43:36.000000', 'consum', 0.0220, 'lps'),
	(454599, 125, '2015-03-15 00:43:37.000000', 'consum', 0.0218, 'lps'),
	(454600, 125, '2015-03-15 00:43:38.000000', 'consum', 0.0223, 'lps'),
	(454601, 125, '2015-03-15 00:43:39.000000', 'consum', 0.0215, 'lps'),
	(454602, 125, '2015-03-15 00:43:40.000000', 'consum', 0.0214, 'lps'),
	(454603, 125, '2015-03-15 00:43:41.000000', 'consum', 0.0216, 'lps'),
	(454604, 125, '2015-03-15 00:43:42.000000', 'consum', 0.0211, 'lps'),
	(454605, 125, '2015-03-15 00:43:43.000000', 'consum', 0.0216, 'lps'),
	(454606, 125, '2015-03-15 00:43:44.000000', 'consum', 0.0220, 'lps'),
	(454607, 125, '2015-03-15 00:43:45.000000', 'consum', 0.0226, 'lps'),
	(454608, 125, '2015-03-15 00:43:46.000000', 'consum', 0.0221, 'lps'),
	(454609, 125, '2015-03-15 00:43:47.000000', 'consum', 0.0219, 'lps'),
	(454610, 125, '2015-03-15 00:43:48.000000', 'consum', 0.0221, 'lps'),
	(454611, 125, '2015-03-15 00:43:49.000000', 'consum', 0.0220, 'lps'),
	(454612, 125, '2015-03-15 00:43:50.000000', 'consum', 0.0226, 'lps'),
	(454613, 125, '2015-03-15 00:43:51.000000', 'consum', 0.0210, 'lps'),
	(454614, 125, '2015-03-15 00:43:52.000000', 'consum', 0.0215, 'lps'),
	(454615, 125, '2015-03-15 00:43:53.000000', 'consum', 0.0216, 'lps'),
	(454616, 125, '2015-03-15 00:43:54.000000', 'consum', 0.0226, 'lps'),
	(454617, 125, '2015-03-15 00:43:55.000000', 'consum', 0.0218, 'lps'),
	(454618, 125, '2015-03-15 00:43:56.000000', 'consum', 0.0222, 'lps'),
	(454619, 125, '2015-03-15 00:43:57.000000', 'consum', 0.0210, 'lps'),
	(454620, 125, '2015-03-15 00:43:58.000000', 'consum', 0.0212, 'lps'),
	(454621, 125, '2015-03-15 00:43:59.000000', 'consum', 0.0219, 'lps'),
	(454622, 125, '2015-03-15 00:44:00.000000', 'consum', 0.0213, 'lps'),
	(454623, 125, '2015-03-15 00:44:01.000000', 'consum', 0.0217, 'lps'),
	(454624, 125, '2015-03-15 00:44:02.000000', 'consum', 0.0217, 'lps'),
	(454625, 125, '2015-03-15 00:44:03.000000', 'consum', 0.0225, 'lps'),
	(454626, 125, '2015-03-15 00:44:04.000000', 'consum', 0.0211, 'lps'),
	(454627, 125, '2015-03-15 00:44:05.000000', 'consum', 0.0226, 'lps'),
	(454628, 125, '2015-03-15 00:44:06.000000', 'consum', 0.0214, 'lps'),
	(454629, 125, '2015-03-15 00:44:07.000000', 'consum', 0.0218, 'lps'),
	(454630, 125, '2015-03-15 00:44:08.000000', 'consum', 0.0220, 'lps'),
	(454631, 125, '2015-03-15 00:44:09.000000', 'consum', 0.0218, 'lps'),
	(454632, 125, '2015-03-15 00:44:10.000000', 'consum', 0.0223, 'lps'),
	(454633, 125, '2015-03-15 00:44:11.000000', 'consum', 0.0214, 'lps'),
	(454634, 125, '2015-03-15 00:44:12.000000', 'consum', 0.0211, 'lps'),
	(454635, 125, '2015-03-15 00:44:13.000000', 'consum', 0.0219, 'lps'),
	(454636, 125, '2015-03-15 00:44:14.000000', 'consum', 0.0219, 'lps'),
	(454637, 125, '2015-03-15 00:44:15.000000', 'consum', 0.0210, 'lps'),
	(454638, 125, '2015-03-15 00:44:16.000000', 'consum', 0.0220, 'lps'),
	(454639, 125, '2015-03-15 00:44:17.000000', 'consum', 0.0225, 'lps'),
	(454640, 125, '2015-03-15 00:44:18.000000', 'consum', 0.0218, 'lps'),
	(454641, 125, '2015-03-15 00:44:19.000000', 'consum', 0.0222, 'lps'),
	(454642, 125, '2015-03-15 00:44:20.000000', 'consum', 0.0213, 'lps'),
	(454643, 125, '2015-03-15 00:44:21.000000', 'consum', 0.0224, 'lps'),
	(454644, 125, '2015-03-15 00:44:22.000000', 'consum', 0.0216, 'lps'),
	(454645, 125, '2015-03-15 00:44:23.000000', 'consum', 0.0220, 'lps'),
	(454646, 125, '2015-03-15 00:44:24.000000', 'consum', 0.0223, 'lps'),
	(454647, 125, '2015-03-15 00:44:25.000000', 'consum', 0.0226, 'lps'),
	(454648, 125, '2015-03-15 00:44:26.000000', 'consum', 0.0216, 'lps'),
	(454649, 125, '2015-03-15 00:44:27.000000', 'consum', 0.0227, 'lps'),
	(454650, 125, '2015-03-15 00:44:28.000000', 'consum', 0.0226, 'lps'),
	(454651, 125, '2015-03-15 00:44:29.000000', 'consum', 0.0220, 'lps'),
	(454652, 125, '2015-03-15 00:44:30.000000', 'consum', 0.0212, 'lps'),
	(454653, 125, '2015-03-15 00:44:31.000000', 'consum', 0.0225, 'lps'),
	(454654, 125, '2015-03-15 00:44:32.000000', 'consum', 0.0210, 'lps'),
	(454655, 125, '2015-03-15 00:44:33.000000', 'consum', 0.0220, 'lps'),
	(454656, 125, '2015-03-15 00:44:34.000000', 'consum', 0.0225, 'lps'),
	(454657, 125, '2015-03-15 00:44:35.000000', 'consum', 0.0219, 'lps'),
	(454658, 125, '2015-03-15 00:44:36.000000', 'consum', 0.0227, 'lps'),
	(454659, 125, '2015-03-15 00:44:37.000000', 'consum', 0.0215, 'lps'),
	(454660, 125, '2015-03-15 00:44:38.000000', 'consum', 0.0220, 'lps'),
	(454661, 125, '2015-03-15 00:44:39.000000', 'consum', 0.0212, 'lps'),
	(454662, 125, '2015-03-15 00:44:40.000000', 'consum', 0.0223, 'lps'),
	(454663, 125, '2015-03-15 00:44:41.000000', 'consum', 0.0218, 'lps'),
	(454664, 125, '2015-03-15 00:44:42.000000', 'consum', 0.0210, 'lps'),
	(454665, 125, '2015-03-15 00:44:43.000000', 'consum', 0.0225, 'lps'),
	(454666, 125, '2015-03-15 00:44:44.000000', 'consum', 0.0210, 'lps'),
	(454667, 125, '2015-03-15 00:44:45.000000', 'consum', 0.0222, 'lps'),
	(454668, 125, '2015-03-15 00:44:46.000000', 'consum', 0.0218, 'lps'),
	(454669, 125, '2015-03-15 00:44:47.000000', 'consum', 0.0213, 'lps'),
	(454670, 125, '2015-03-15 00:44:48.000000', 'consum', 0.0218, 'lps'),
	(454671, 125, '2015-03-15 00:44:49.000000', 'consum', 0.0224, 'lps'),
	(454672, 125, '2015-03-15 00:44:50.000000', 'consum', 0.0222, 'lps'),
	(454673, 125, '2015-03-15 00:44:51.000000', 'consum', 0.0210, 'lps'),
	(454674, 125, '2015-03-15 00:44:52.000000', 'consum', 0.0226, 'lps'),
	(454675, 125, '2015-03-15 00:44:53.000000', 'consum', 0.0221, 'lps'),
	(454676, 125, '2015-03-15 00:44:54.000000', 'consum', 0.0218, 'lps'),
	(454677, 125, '2015-03-15 00:44:55.000000', 'consum', 0.0218, 'lps'),
	(454678, 125, '2015-03-15 00:44:56.000000', 'consum', 0.0224, 'lps'),
	(454679, 125, '2015-03-15 00:44:57.000000', 'consum', 0.0222, 'lps'),
	(454680, 125, '2015-03-15 00:44:58.000000', 'consum', 0.0227, 'lps'),
	(454681, 125, '2015-03-15 00:44:59.000000', 'consum', 0.0226, 'lps'),
	(454682, 125, '2015-03-15 00:45:00.000000', 'consum', 0.0221, 'lps'),
	(454683, 125, '2015-03-15 00:45:01.000000', 'consum', 0.0219, 'lps'),
	(454684, 125, '2015-03-15 00:45:02.000000', 'consum', 0.0219, 'lps'),
	(454685, 125, '2015-03-15 00:45:03.000000', 'consum', 0.0214, 'lps'),
	(454686, 125, '2015-03-15 00:45:04.000000', 'consum', 0.0219, 'lps'),
	(454687, 125, '2015-03-15 00:45:05.000000', 'consum', 0.0226, 'lps'),
	(454688, 125, '2015-03-15 00:45:06.000000', 'consum', 0.0210, 'lps'),
	(454689, 125, '2015-03-15 00:45:07.000000', 'consum', 0.0217, 'lps'),
	(454690, 125, '2015-03-15 00:45:08.000000', 'consum', 0.0225, 'lps'),
	(454691, 125, '2015-03-15 00:45:09.000000', 'consum', 0.0214, 'lps'),
	(454692, 125, '2015-03-15 00:45:10.000000', 'consum', 0.0220, 'lps'),
	(454693, 125, '2015-03-15 00:45:11.000000', 'consum', 0.0212, 'lps'),
	(454694, 125, '2015-03-15 00:45:12.000000', 'consum', 0.0226, 'lps'),
	(454695, 125, '2015-03-15 00:45:13.000000', 'consum', 0.0211, 'lps'),
	(454696, 125, '2015-03-15 00:45:14.000000', 'consum', 0.0224, 'lps'),
	(454697, 125, '2015-03-15 00:45:15.000000', 'consum', 0.0221, 'lps'),
	(454698, 125, '2015-03-15 00:45:16.000000', 'consum', 0.0224, 'lps'),
	(454699, 125, '2015-03-15 00:45:17.000000', 'consum', 0.0211, 'lps'),
	(454700, 125, '2015-03-15 00:45:18.000000', 'consum', 0.0210, 'lps'),
	(454701, 125, '2015-03-15 00:45:19.000000', 'consum', 0.0225, 'lps'),
	(454702, 125, '2015-03-15 00:45:20.000000', 'consum', 0.0215, 'lps'),
	(454703, 125, '2015-03-15 00:45:21.000000', 'consum', 0.0210, 'lps'),
	(454704, 125, '2015-03-15 00:45:22.000000', 'consum', 0.0211, 'lps'),
	(454705, 125, '2015-03-15 00:45:23.000000', 'consum', 0.0216, 'lps'),
	(454706, 125, '2015-03-15 00:45:24.000000', 'consum', 0.0220, 'lps'),
	(454707, 125, '2015-03-15 00:45:25.000000', 'consum', 0.0225, 'lps'),
	(454708, 125, '2015-03-15 00:45:26.000000', 'consum', 0.0221, 'lps'),
	(454709, 125, '2015-03-15 00:45:27.000000', 'consum', 0.0219, 'lps'),
	(454710, 125, '2015-03-15 00:45:28.000000', 'consum', 0.0221, 'lps'),
	(454711, 125, '2015-03-15 00:45:29.000000', 'consum', 0.0223, 'lps'),
	(454712, 125, '2015-03-15 00:45:30.000000', 'consum', 0.0225, 'lps'),
	(454713, 125, '2015-03-15 00:45:31.000000', 'consum', 0.0225, 'lps'),
	(454714, 125, '2015-03-15 00:45:32.000000', 'consum', 0.0226, 'lps'),
	(454715, 125, '2015-03-15 00:45:33.000000', 'consum', 0.0226, 'lps'),
	(454716, 125, '2015-03-15 00:45:34.000000', 'consum', 0.0226, 'lps'),
	(454717, 125, '2015-03-15 00:45:35.000000', 'consum', 0.0223, 'lps'),
	(454718, 125, '2015-03-15 00:45:36.000000', 'consum', 0.0227, 'lps'),
	(454719, 125, '2015-03-15 00:45:37.000000', 'consum', 0.0219, 'lps'),
	(454720, 125, '2015-03-15 00:45:38.000000', 'consum', 0.0225, 'lps'),
	(454721, 125, '2015-03-15 00:45:39.000000', 'consum', 0.0222, 'lps'),
	(454722, 125, '2015-03-15 00:45:40.000000', 'consum', 0.0224, 'lps'),
	(454723, 125, '2015-03-15 00:45:41.000000', 'consum', 0.0227, 'lps'),
	(454724, 125, '2015-03-15 00:45:42.000000', 'consum', 0.0216, 'lps'),
	(454725, 125, '2015-03-15 00:45:43.000000', 'consum', 0.0227, 'lps'),
	(454726, 125, '2015-03-15 00:45:44.000000', 'consum', 0.0222, 'lps'),
	(454727, 125, '2015-03-15 00:45:45.000000', 'consum', 0.0219, 'lps'),
	(454728, 125, '2015-03-15 00:45:46.000000', 'consum', 0.0219, 'lps'),
	(454729, 125, '2015-03-15 00:45:47.000000', 'consum', 0.0210, 'lps'),
	(454730, 125, '2015-03-15 00:45:48.000000', 'consum', 0.0222, 'lps'),
	(454731, 125, '2015-03-15 00:45:49.000000', 'consum', 0.0214, 'lps'),
	(454732, 125, '2015-03-15 00:45:50.000000', 'consum', 0.0214, 'lps'),
	(454733, 125, '2015-03-15 00:45:51.000000', 'consum', 0.0218, 'lps'),
	(454734, 125, '2015-03-15 00:45:52.000000', 'consum', 0.0223, 'lps'),
	(454735, 125, '2015-03-15 00:45:53.000000', 'consum', 0.0212, 'lps'),
	(454736, 125, '2015-03-15 00:45:54.000000', 'consum', 0.0221, 'lps'),
	(454737, 125, '2015-03-15 00:45:55.000000', 'consum', 0.0222, 'lps'),
	(454738, 125, '2015-03-15 00:45:56.000000', 'consum', 0.0218, 'lps'),
	(454739, 125, '2015-03-15 00:45:57.000000', 'consum', 0.0215, 'lps'),
	(454740, 125, '2015-03-15 00:45:58.000000', 'consum', 0.0212, 'lps'),
	(454741, 125, '2015-03-15 00:45:59.000000', 'consum', 0.0225, 'lps'),
	(454742, 125, '2015-03-15 00:46:00.000000', 'consum', 0.0225, 'lps'),
	(454743, 125, '2015-03-15 00:46:01.000000', 'consum', 0.0221, 'lps'),
	(454744, 125, '2015-03-15 00:46:02.000000', 'consum', 0.0222, 'lps'),
	(454745, 125, '2015-03-15 00:46:03.000000', 'consum', 0.0218, 'lps'),
	(454746, 125, '2015-03-15 00:46:04.000000', 'consum', 0.0217, 'lps'),
	(454747, 125, '2015-03-15 00:46:05.000000', 'consum', 0.0219, 'lps'),
	(454748, 125, '2015-03-15 00:46:06.000000', 'consum', 0.0215, 'lps'),
	(454749, 125, '2015-03-15 00:46:07.000000', 'consum', 0.0211, 'lps'),
	(454750, 125, '2015-03-15 00:46:08.000000', 'consum', 0.0219, 'lps'),
	(454751, 125, '2015-03-15 00:46:09.000000', 'consum', 0.0217, 'lps'),
	(454752, 125, '2015-03-15 00:46:10.000000', 'consum', 0.0219, 'lps'),
	(454753, 125, '2015-03-15 00:46:11.000000', 'consum', 0.0216, 'lps'),
	(454754, 125, '2015-03-15 00:46:12.000000', 'consum', 0.0212, 'lps'),
	(454755, 125, '2015-03-15 00:46:13.000000', 'consum', 0.0221, 'lps'),
	(454756, 125, '2015-03-15 00:46:14.000000', 'consum', 0.0225, 'lps'),
	(454757, 125, '2015-03-15 00:46:15.000000', 'consum', 0.0217, 'lps'),
	(454758, 125, '2015-03-15 00:46:16.000000', 'consum', 0.0218, 'lps'),
	(454759, 125, '2015-03-15 00:46:17.000000', 'consum', 0.0210, 'lps'),
	(454760, 125, '2015-03-15 00:46:18.000000', 'consum', 0.0224, 'lps'),
	(454761, 125, '2015-03-15 00:46:19.000000', 'consum', 0.0210, 'lps'),
	(454762, 125, '2015-03-15 00:46:20.000000', 'consum', 0.0219, 'lps'),
	(454763, 125, '2015-03-15 00:46:21.000000', 'consum', 0.0223, 'lps'),
	(454764, 125, '2015-03-15 00:46:22.000000', 'consum', 0.0210, 'lps'),
	(454765, 125, '2015-03-15 00:46:23.000000', 'consum', 0.0225, 'lps'),
	(454766, 125, '2015-03-15 00:46:24.000000', 'consum', 0.0214, 'lps'),
	(454767, 125, '2015-03-15 00:46:25.000000', 'consum', 0.0223, 'lps'),
	(454768, 125, '2015-03-15 00:46:26.000000', 'consum', 0.0226, 'lps'),
	(454769, 125, '2015-03-15 00:46:27.000000', 'consum', 0.0216, 'lps'),
	(454770, 125, '2015-03-15 00:46:28.000000', 'consum', 0.0211, 'lps'),
	(454771, 125, '2015-03-15 00:46:29.000000', 'consum', 0.0214, 'lps'),
	(454772, 125, '2015-03-15 00:46:30.000000', 'consum', 0.0227, 'lps'),
	(454773, 125, '2015-03-15 00:46:31.000000', 'consum', 0.0213, 'lps'),
	(454774, 125, '2015-03-15 00:46:32.000000', 'consum', 0.0210, 'lps'),
	(454775, 125, '2015-03-15 00:46:33.000000', 'consum', 0.0218, 'lps'),
	(454776, 125, '2015-03-15 00:46:34.000000', 'consum', 0.0215, 'lps'),
	(454777, 125, '2015-03-15 00:46:35.000000', 'consum', 0.0211, 'lps'),
	(454778, 125, '2015-03-15 00:46:36.000000', 'consum', 0.0220, 'lps'),
	(454779, 125, '2015-03-15 00:46:37.000000', 'consum', 0.0222, 'lps'),
	(454780, 125, '2015-03-15 00:46:38.000000', 'consum', 0.0223, 'lps'),
	(454781, 125, '2015-03-15 00:46:39.000000', 'consum', 0.0221, 'lps'),
	(454782, 125, '2015-03-15 00:46:40.000000', 'consum', 0.0210, 'lps'),
	(454783, 125, '2015-03-15 00:46:41.000000', 'consum', 0.0213, 'lps'),
	(454784, 125, '2015-03-15 00:46:42.000000', 'consum', 0.0226, 'lps'),
	(454785, 125, '2015-03-15 00:46:43.000000', 'consum', 0.0211, 'lps'),
	(454786, 125, '2015-03-15 00:46:44.000000', 'consum', 0.0219, 'lps'),
	(454787, 125, '2015-03-15 00:46:45.000000', 'consum', 0.0218, 'lps'),
	(454788, 125, '2015-03-15 00:46:46.000000', 'consum', 0.0222, 'lps'),
	(454789, 125, '2015-03-15 00:46:47.000000', 'consum', 0.0210, 'lps'),
	(454790, 125, '2015-03-15 00:46:48.000000', 'consum', 0.0211, 'lps'),
	(454791, 125, '2015-03-15 00:46:49.000000', 'consum', 0.0217, 'lps'),
	(454792, 125, '2015-03-15 00:46:50.000000', 'consum', 0.0223, 'lps'),
	(454793, 125, '2015-03-15 00:46:51.000000', 'consum', 0.0217, 'lps'),
	(454794, 125, '2015-03-15 00:46:52.000000', 'consum', 0.0225, 'lps'),
	(454795, 125, '2015-03-15 00:46:53.000000', 'consum', 0.0210, 'lps'),
	(454796, 125, '2015-03-15 00:46:54.000000', 'consum', 0.0222, 'lps'),
	(454797, 125, '2015-03-15 00:46:55.000000', 'consum', 0.0216, 'lps'),
	(454798, 125, '2015-03-15 00:46:56.000000', 'consum', 0.0220, 'lps'),
	(454799, 125, '2015-03-15 00:46:57.000000', 'consum', 0.0210, 'lps'),
	(454800, 125, '2015-03-15 00:46:58.000000', 'consum', 0.0215, 'lps'),
	(454801, 125, '2015-03-15 00:46:59.000000', 'consum', 0.0217, 'lps'),
	(454802, 125, '2015-03-15 00:47:00.000000', 'consum', 0.0212, 'lps'),
	(454803, 125, '2015-03-15 00:47:01.000000', 'consum', 0.0217, 'lps'),
	(454804, 125, '2015-03-15 00:47:02.000000', 'consum', 0.0223, 'lps'),
	(454805, 125, '2015-03-15 00:47:03.000000', 'consum', 0.0217, 'lps'),
	(454806, 125, '2015-03-15 00:47:04.000000', 'consum', 0.0223, 'lps'),
	(454807, 125, '2015-03-15 00:47:05.000000', 'consum', 0.0222, 'lps'),
	(454808, 125, '2015-03-15 00:47:06.000000', 'consum', 0.0210, 'lps'),
	(454809, 125, '2015-03-15 00:47:07.000000', 'consum', 0.0214, 'lps'),
	(454810, 125, '2015-03-15 00:47:08.000000', 'consum', 0.0210, 'lps'),
	(454811, 125, '2015-03-15 00:47:09.000000', 'consum', 0.0219, 'lps'),
	(454812, 125, '2015-03-15 00:47:10.000000', 'consum', 0.0218, 'lps'),
	(454813, 125, '2015-03-15 00:47:11.000000', 'consum', 0.0224, 'lps'),
	(454814, 125, '2015-03-15 00:47:12.000000', 'consum', 0.0219, 'lps'),
	(454815, 125, '2015-03-15 00:47:13.000000', 'consum', 0.0214, 'lps'),
	(454816, 125, '2015-03-15 00:47:14.000000', 'consum', 0.0220, 'lps'),
	(454817, 125, '2015-03-15 00:47:15.000000', 'consum', 0.0213, 'lps'),
	(454818, 125, '2015-03-15 00:47:16.000000', 'consum', 0.0213, 'lps'),
	(454819, 125, '2015-03-15 00:47:17.000000', 'consum', 0.0217, 'lps'),
	(454820, 125, '2015-03-15 00:47:18.000000', 'consum', 0.0220, 'lps'),
	(454821, 125, '2015-03-15 00:47:19.000000', 'consum', 0.0220, 'lps'),
	(454822, 125, '2015-03-15 00:47:20.000000', 'consum', 0.0214, 'lps'),
	(454823, 125, '2015-03-15 00:47:21.000000', 'consum', 0.0219, 'lps'),
	(454824, 125, '2015-03-15 00:47:22.000000', 'consum', 0.0223, 'lps'),
	(454825, 125, '2015-03-15 00:47:23.000000', 'consum', 0.0214, 'lps'),
	(454826, 125, '2015-03-15 00:47:24.000000', 'consum', 0.0211, 'lps'),
	(454827, 125, '2015-03-15 00:47:25.000000', 'consum', 0.0219, 'lps'),
	(454828, 125, '2015-03-15 00:47:26.000000', 'consum', 0.0216, 'lps'),
	(454829, 125, '2015-03-15 00:47:27.000000', 'consum', 0.0214, 'lps'),
	(454830, 125, '2015-03-15 00:47:28.000000', 'consum', 0.0211, 'lps'),
	(454831, 125, '2015-03-15 00:47:29.000000', 'consum', 0.0221, 'lps'),
	(454832, 125, '2015-03-15 00:47:30.000000', 'consum', 0.0211, 'lps'),
	(454833, 125, '2015-03-15 00:47:31.000000', 'consum', 0.0219, 'lps'),
	(454834, 125, '2015-03-15 00:47:32.000000', 'consum', 0.0216, 'lps'),
	(454835, 125, '2015-03-15 00:47:33.000000', 'consum', 0.0214, 'lps'),
	(454836, 125, '2015-03-15 00:47:34.000000', 'consum', 0.0210, 'lps'),
	(454837, 125, '2015-03-15 00:47:35.000000', 'consum', 0.0218, 'lps'),
	(454838, 125, '2015-03-15 00:47:36.000000', 'consum', 0.0216, 'lps'),
	(454839, 125, '2015-03-15 00:47:37.000000', 'consum', 0.0215, 'lps'),
	(454840, 125, '2015-03-15 00:47:38.000000', 'consum', 0.0219, 'lps'),
	(454841, 125, '2015-03-15 00:47:39.000000', 'consum', 0.0220, 'lps'),
	(454842, 125, '2015-03-15 00:47:40.000000', 'consum', 0.0215, 'lps'),
	(454843, 125, '2015-03-15 00:47:41.000000', 'consum', 0.0225, 'lps'),
	(454844, 125, '2015-03-15 00:47:42.000000', 'consum', 0.0216, 'lps'),
	(454845, 125, '2015-03-15 00:47:43.000000', 'consum', 0.0214, 'lps'),
	(454846, 125, '2015-03-15 00:47:44.000000', 'consum', 0.0212, 'lps'),
	(454847, 125, '2015-03-15 00:47:45.000000', 'consum', 0.0227, 'lps'),
	(454848, 125, '2015-03-15 00:47:46.000000', 'consum', 0.0216, 'lps'),
	(454849, 125, '2015-03-15 00:47:47.000000', 'consum', 0.0226, 'lps'),
	(454850, 125, '2015-03-15 00:47:48.000000', 'consum', 0.0218, 'lps'),
	(454851, 125, '2015-03-15 00:47:49.000000', 'consum', 0.0221, 'lps'),
	(454852, 125, '2015-03-15 00:47:50.000000', 'consum', 0.0225, 'lps'),
	(454853, 125, '2015-03-15 00:47:51.000000', 'consum', 0.0216, 'lps'),
	(454854, 125, '2015-03-15 00:47:52.000000', 'consum', 0.0215, 'lps'),
	(454855, 125, '2015-03-15 00:47:53.000000', 'consum', 0.0216, 'lps'),
	(454856, 125, '2015-03-15 00:47:54.000000', 'consum', 0.0227, 'lps'),
	(454857, 125, '2015-03-15 00:47:55.000000', 'consum', 0.0221, 'lps'),
	(454858, 125, '2015-03-15 00:47:56.000000', 'consum', 0.0216, 'lps'),
	(454859, 125, '2015-03-15 00:47:57.000000', 'consum', 0.0225, 'lps'),
	(454860, 125, '2015-03-15 00:47:58.000000', 'consum', 0.0214, 'lps'),
	(454861, 125, '2015-03-15 00:47:59.000000', 'consum', 0.0222, 'lps'),
	(454862, 125, '2015-03-15 00:48:00.000000', 'consum', 0.0220, 'lps'),
	(454863, 125, '2015-03-15 00:48:01.000000', 'consum', 0.0210, 'lps'),
	(454864, 125, '2015-03-15 00:48:02.000000', 'consum', 0.0214, 'lps'),
	(454865, 125, '2015-03-15 00:48:03.000000', 'consum', 0.0211, 'lps'),
	(454866, 125, '2015-03-15 00:48:04.000000', 'consum', 0.0224, 'lps'),
	(454867, 125, '2015-03-15 00:48:05.000000', 'consum', 0.0221, 'lps'),
	(454868, 125, '2015-03-15 00:48:06.000000', 'consum', 0.0225, 'lps'),
	(454869, 125, '2015-03-15 00:48:07.000000', 'consum', 0.0214, 'lps'),
	(454870, 125, '2015-03-15 00:48:08.000000', 'consum', 0.0225, 'lps'),
	(454871, 125, '2015-03-15 00:48:09.000000', 'consum', 0.0219, 'lps'),
	(454872, 125, '2015-03-15 00:48:10.000000', 'consum', 0.0210, 'lps'),
	(454873, 125, '2015-03-15 00:48:11.000000', 'consum', 0.0221, 'lps'),
	(454874, 125, '2015-03-15 00:48:12.000000', 'consum', 0.0212, 'lps'),
	(454875, 125, '2015-03-15 00:48:13.000000', 'consum', 0.0224, 'lps'),
	(454876, 125, '2015-03-15 00:48:14.000000', 'consum', 0.0217, 'lps'),
	(454877, 125, '2015-03-15 00:48:15.000000', 'consum', 0.0224, 'lps'),
	(454878, 125, '2015-03-15 00:48:16.000000', 'consum', 0.0225, 'lps'),
	(454879, 125, '2015-03-15 00:48:17.000000', 'consum', 0.0223, 'lps'),
	(454880, 125, '2015-03-15 00:48:18.000000', 'consum', 0.0211, 'lps'),
	(454881, 125, '2015-03-15 00:48:19.000000', 'consum', 0.0215, 'lps'),
	(454882, 125, '2015-03-15 00:48:20.000000', 'consum', 0.0216, 'lps'),
	(454883, 125, '2015-03-15 00:48:21.000000', 'consum', 0.0223, 'lps'),
	(454884, 125, '2015-03-15 00:48:22.000000', 'consum', 0.0224, 'lps'),
	(454885, 125, '2015-03-15 00:48:23.000000', 'consum', 0.0220, 'lps'),
	(454886, 125, '2015-03-15 00:48:24.000000', 'consum', 0.0222, 'lps'),
	(454887, 125, '2015-03-15 00:48:25.000000', 'consum', 0.0221, 'lps'),
	(454888, 125, '2015-03-15 00:48:26.000000', 'consum', 0.0210, 'lps'),
	(454889, 125, '2015-03-15 00:48:27.000000', 'consum', 0.0215, 'lps'),
	(454890, 125, '2015-03-15 00:48:28.000000', 'consum', 0.0216, 'lps'),
	(454891, 125, '2015-03-15 00:48:29.000000', 'consum', 0.0226, 'lps'),
	(454892, 125, '2015-03-15 00:48:30.000000', 'consum', 0.0218, 'lps'),
	(454893, 125, '2015-03-15 00:48:31.000000', 'consum', 0.0222, 'lps'),
	(454894, 125, '2015-03-15 00:48:32.000000', 'consum', 0.0212, 'lps'),
	(454895, 125, '2015-03-15 00:48:33.000000', 'consum', 0.0218, 'lps'),
	(454896, 125, '2015-03-15 00:48:34.000000', 'consum', 0.0210, 'lps'),
	(454897, 125, '2015-03-15 00:48:35.000000', 'consum', 0.0221, 'lps'),
	(454898, 125, '2015-03-15 00:48:36.000000', 'consum', 0.0213, 'lps'),
	(454899, 125, '2015-03-15 00:48:37.000000', 'consum', 0.0212, 'lps'),
	(454900, 125, '2015-03-15 00:48:38.000000', 'consum', 0.0210, 'lps'),
	(454901, 125, '2015-03-15 00:48:39.000000', 'consum', 0.0221, 'lps'),
	(454902, 125, '2015-03-15 00:48:40.000000', 'consum', 0.0214, 'lps'),
	(454903, 125, '2015-03-15 00:48:41.000000', 'consum', 0.0214, 'lps'),
	(454904, 125, '2015-03-15 00:48:42.000000', 'consum', 0.0218, 'lps'),
	(454905, 125, '2015-03-15 00:48:43.000000', 'consum', 0.0223, 'lps'),
	(454906, 125, '2015-03-15 00:48:44.000000', 'consum', 0.0215, 'lps'),
	(454907, 125, '2015-03-15 00:48:45.000000', 'consum', 0.0212, 'lps'),
	(454908, 125, '2015-03-15 00:48:46.000000', 'consum', 0.0226, 'lps'),
	(454909, 125, '2015-03-15 00:48:47.000000', 'consum', 0.0213, 'lps'),
	(454910, 125, '2015-03-15 00:48:48.000000', 'consum', 0.0214, 'lps'),
	(454911, 125, '2015-03-15 00:48:49.000000', 'consum', 0.0220, 'lps'),
	(454912, 125, '2015-03-15 00:48:50.000000', 'consum', 0.0212, 'lps'),
	(454913, 125, '2015-03-15 00:48:51.000000', 'consum', 0.0226, 'lps'),
	(454914, 125, '2015-03-15 00:48:52.000000', 'consum', 0.0212, 'lps'),
	(454915, 125, '2015-03-15 00:48:53.000000', 'consum', 0.0227, 'lps'),
	(454916, 125, '2015-03-15 00:48:54.000000', 'consum', 0.0216, 'lps'),
	(454917, 125, '2015-03-15 00:48:55.000000', 'consum', 0.0226, 'lps'),
	(454918, 125, '2015-03-15 00:48:56.000000', 'consum', 0.0218, 'lps'),
	(454919, 125, '2015-03-15 00:48:57.000000', 'consum', 0.0222, 'lps'),
	(454920, 125, '2015-03-15 00:48:58.000000', 'consum', 0.0212, 'lps'),
	(454921, 125, '2015-03-15 00:48:59.000000', 'consum', 0.0219, 'lps'),
	(454922, 125, '2015-03-15 00:49:00.000000', 'consum', 0.0212, 'lps'),
	(454923, 125, '2015-03-15 00:49:01.000000', 'consum', 0.0211, 'lps'),
	(454924, 125, '2015-03-15 00:49:02.000000', 'consum', 0.0227, 'lps'),
	(454925, 125, '2015-03-15 00:49:03.000000', 'consum', 0.0223, 'lps'),
	(454926, 125, '2015-03-15 00:49:04.000000', 'consum', 0.0222, 'lps'),
	(454927, 125, '2015-03-15 00:49:05.000000', 'consum', 0.0212, 'lps'),
	(454928, 125, '2015-03-15 00:49:06.000000', 'consum', 0.0224, 'lps'),
	(454929, 125, '2015-03-15 00:49:07.000000', 'consum', 0.0220, 'lps'),
	(454930, 125, '2015-03-15 00:49:08.000000', 'consum', 0.0219, 'lps'),
	(454931, 125, '2015-03-15 00:49:09.000000', 'consum', 0.0224, 'lps'),
	(454932, 125, '2015-03-15 00:49:10.000000', 'consum', 0.0217, 'lps'),
	(454933, 125, '2015-03-15 00:49:11.000000', 'consum', 0.0221, 'lps'),
	(454934, 125, '2015-03-15 00:49:12.000000', 'consum', 0.0210, 'lps'),
	(454935, 125, '2015-03-15 00:49:13.000000', 'consum', 0.0213, 'lps'),
	(454936, 125, '2015-03-15 00:49:14.000000', 'consum', 0.0225, 'lps'),
	(454937, 125, '2015-03-15 00:49:15.000000', 'consum', 0.0223, 'lps'),
	(454938, 125, '2015-03-15 00:49:16.000000', 'consum', 0.0211, 'lps'),
	(454939, 125, '2015-03-15 00:49:17.000000', 'consum', 0.0213, 'lps'),
	(454940, 125, '2015-03-15 00:49:18.000000', 'consum', 0.0221, 'lps'),
	(454941, 125, '2015-03-15 00:49:19.000000', 'consum', 0.0222, 'lps'),
	(454942, 125, '2015-03-15 00:49:20.000000', 'consum', 0.0219, 'lps'),
	(454943, 125, '2015-03-15 00:49:21.000000', 'consum', 0.0222, 'lps'),
	(454944, 125, '2015-03-15 00:49:22.000000', 'consum', 0.0223, 'lps'),
	(454945, 125, '2015-03-15 00:49:23.000000', 'consum', 0.0224, 'lps'),
	(454946, 125, '2015-03-15 00:49:24.000000', 'consum', 0.0220, 'lps'),
	(454947, 125, '2015-03-15 00:49:25.000000', 'consum', 0.0222, 'lps'),
	(454948, 125, '2015-03-15 00:49:26.000000', 'consum', 0.0220, 'lps'),
	(454949, 125, '2015-03-15 00:49:27.000000', 'consum', 0.0225, 'lps'),
	(454950, 125, '2015-03-15 00:49:28.000000', 'consum', 0.0219, 'lps'),
	(454951, 125, '2015-03-15 00:49:29.000000', 'consum', 0.0210, 'lps'),
	(454952, 125, '2015-03-15 00:49:30.000000', 'consum', 0.0219, 'lps'),
	(454953, 125, '2015-03-15 00:49:31.000000', 'consum', 0.0220, 'lps'),
	(454954, 125, '2015-03-15 00:49:32.000000', 'consum', 0.0216, 'lps'),
	(454955, 125, '2015-03-15 00:49:33.000000', 'consum', 0.0227, 'lps'),
	(454956, 125, '2015-03-15 00:49:34.000000', 'consum', 0.0226, 'lps'),
	(454957, 125, '2015-03-15 00:49:35.000000', 'consum', 0.0219, 'lps'),
	(454958, 125, '2015-03-15 00:49:36.000000', 'consum', 0.0226, 'lps'),
	(454959, 125, '2015-03-15 00:49:37.000000', 'consum', 0.0227, 'lps'),
	(454960, 125, '2015-03-15 00:49:38.000000', 'consum', 0.0211, 'lps'),
	(454961, 125, '2015-03-15 00:49:39.000000', 'consum', 0.0221, 'lps'),
	(454962, 125, '2015-03-15 00:49:40.000000', 'consum', 0.0224, 'lps'),
	(454963, 125, '2015-03-15 00:49:41.000000', 'consum', 0.0212, 'lps'),
	(454964, 125, '2015-03-15 00:49:42.000000', 'consum', 0.0213, 'lps'),
	(454965, 125, '2015-03-15 00:49:43.000000', 'consum', 0.0221, 'lps'),
	(454966, 125, '2015-03-15 00:49:44.000000', 'consum', 0.0218, 'lps'),
	(454967, 125, '2015-03-15 00:49:45.000000', 'consum', 0.0221, 'lps'),
	(454968, 125, '2015-03-15 00:49:46.000000', 'consum', 0.0221, 'lps'),
	(454969, 125, '2015-03-15 00:49:47.000000', 'consum', 0.0217, 'lps'),
	(454970, 125, '2015-03-15 00:49:48.000000', 'consum', 0.0212, 'lps'),
	(454971, 125, '2015-03-15 00:49:49.000000', 'consum', 0.0218, 'lps'),
	(454972, 125, '2015-03-15 00:49:50.000000', 'consum', 0.0227, 'lps'),
	(454973, 125, '2015-03-15 00:49:51.000000', 'consum', 0.0216, 'lps'),
	(454974, 125, '2015-03-15 00:49:52.000000', 'consum', 0.0225, 'lps'),
	(454975, 125, '2015-03-15 00:49:53.000000', 'consum', 0.0215, 'lps'),
	(454976, 125, '2015-03-15 00:49:54.000000', 'consum', 0.0225, 'lps'),
	(454977, 125, '2015-03-15 00:49:55.000000', 'consum', 0.0216, 'lps'),
	(454978, 125, '2015-03-15 00:49:56.000000', 'consum', 0.0214, 'lps'),
	(454979, 125, '2015-03-15 00:49:57.000000', 'consum', 0.0214, 'lps'),
	(454980, 125, '2015-03-15 00:49:58.000000', 'consum', 0.0217, 'lps'),
	(454981, 125, '2015-03-15 00:49:59.000000', 'consum', 0.0218, 'lps'),
	(454982, 125, '2015-03-15 00:50:00.000000', 'consum', 0.0227, 'lps'),
	(454983, 125, '2015-03-15 00:50:01.000000', 'consum', 0.0217, 'lps'),
	(454984, 125, '2015-03-15 00:50:02.000000', 'consum', 0.0215, 'lps'),
	(454985, 125, '2015-03-15 00:50:03.000000', 'consum', 0.0213, 'lps'),
	(454986, 125, '2015-03-15 00:50:04.000000', 'consum', 0.0212, 'lps'),
	(454987, 125, '2015-03-15 00:50:05.000000', 'consum', 0.0211, 'lps'),
	(454988, 125, '2015-03-15 00:50:06.000000', 'consum', 0.0226, 'lps'),
	(454989, 125, '2015-03-15 00:50:07.000000', 'consum', 0.0217, 'lps'),
	(454990, 125, '2015-03-15 00:50:08.000000', 'consum', 0.0215, 'lps'),
	(454991, 125, '2015-03-15 00:50:09.000000', 'consum', 0.0214, 'lps'),
	(454992, 125, '2015-03-15 00:50:10.000000', 'consum', 0.0215, 'lps'),
	(454993, 125, '2015-03-15 00:50:11.000000', 'consum', 0.0224, 'lps'),
	(454994, 125, '2015-03-15 00:50:12.000000', 'consum', 0.0210, 'lps'),
	(454995, 125, '2015-03-15 00:50:13.000000', 'consum', 0.0223, 'lps'),
	(454996, 125, '2015-03-15 00:50:14.000000', 'consum', 0.0222, 'lps'),
	(454997, 125, '2015-03-15 00:50:15.000000', 'consum', 0.0214, 'lps'),
	(454998, 125, '2015-03-15 00:50:16.000000', 'consum', 0.0211, 'lps'),
	(454999, 125, '2015-03-15 00:50:17.000000', 'consum', 0.0224, 'lps'),
	(455000, 125, '2015-03-15 00:50:18.000000', 'consum', 0.0222, 'lps'),
	(455001, 125, '2015-03-15 00:50:19.000000', 'consum', 0.0211, 'lps'),
	(455002, 125, '2015-03-15 00:50:20.000000', 'consum', 0.0214, 'lps'),
	(455003, 125, '2015-03-15 00:50:21.000000', 'consum', 0.0210, 'lps'),
	(455004, 125, '2015-03-15 00:50:22.000000', 'consum', 0.0218, 'lps'),
	(455005, 125, '2015-03-15 00:50:23.000000', 'consum', 0.0214, 'lps'),
	(455006, 125, '2015-03-15 00:50:24.000000', 'consum', 0.0226, 'lps'),
	(455007, 125, '2015-03-15 00:50:25.000000', 'consum', 0.0222, 'lps'),
	(455008, 125, '2015-03-15 00:50:26.000000', 'consum', 0.0224, 'lps'),
	(455009, 125, '2015-03-15 00:50:27.000000', 'consum', 0.0224, 'lps'),
	(455010, 125, '2015-03-15 00:50:28.000000', 'consum', 0.0222, 'lps'),
	(455011, 125, '2015-03-15 00:50:29.000000', 'consum', 0.0210, 'lps'),
	(455012, 125, '2015-03-15 00:50:30.000000', 'consum', 0.0210, 'lps'),
	(455013, 125, '2015-03-15 00:50:31.000000', 'consum', 0.0211, 'lps'),
	(455014, 125, '2015-03-15 00:50:32.000000', 'consum', 0.0215, 'lps'),
	(455015, 125, '2015-03-15 00:50:33.000000', 'consum', 0.0217, 'lps'),
	(455016, 125, '2015-03-15 00:50:34.000000', 'consum', 0.0211, 'lps'),
	(455017, 125, '2015-03-15 00:50:35.000000', 'consum', 0.0212, 'lps'),
	(455018, 125, '2015-03-15 00:50:36.000000', 'consum', 0.0218, 'lps'),
	(455019, 125, '2015-03-15 00:50:37.000000', 'consum', 0.0210, 'lps'),
	(455020, 125, '2015-03-15 00:50:38.000000', 'consum', 0.0223, 'lps'),
	(455021, 125, '2015-03-15 00:50:39.000000', 'consum', 0.0222, 'lps'),
	(455022, 125, '2015-03-15 00:50:40.000000', 'consum', 0.0214, 'lps'),
	(455023, 125, '2015-03-15 00:50:41.000000', 'consum', 0.0210, 'lps'),
	(455024, 125, '2015-03-15 00:50:42.000000', 'consum', 0.0219, 'lps'),
	(455025, 125, '2015-03-15 00:50:43.000000', 'consum', 0.0217, 'lps'),
	(455026, 125, '2015-03-15 00:50:44.000000', 'consum', 0.0220, 'lps'),
	(455027, 125, '2015-03-15 00:50:45.000000', 'consum', 0.0222, 'lps'),
	(455028, 125, '2015-03-15 00:50:46.000000', 'consum', 0.0222, 'lps'),
	(455029, 125, '2015-03-15 00:50:47.000000', 'consum', 0.0218, 'lps'),
	(455030, 125, '2015-03-15 00:50:48.000000', 'consum', 0.0212, 'lps'),
	(455031, 125, '2015-03-15 00:50:49.000000', 'consum', 0.0217, 'lps'),
	(455032, 125, '2015-03-15 00:50:50.000000', 'consum', 0.0221, 'lps'),
	(455033, 125, '2015-03-15 00:50:51.000000', 'consum', 0.0226, 'lps'),
	(455034, 125, '2015-03-15 00:50:52.000000', 'consum', 0.0222, 'lps'),
	(455035, 125, '2015-03-15 00:50:53.000000', 'consum', 0.0223, 'lps'),
	(455036, 125, '2015-03-15 00:50:54.000000', 'consum', 0.0219, 'lps'),
	(455037, 125, '2015-03-15 00:50:55.000000', 'consum', 0.0220, 'lps'),
	(455038, 125, '2015-03-15 00:50:56.000000', 'consum', 0.0213, 'lps'),
	(455039, 125, '2015-03-15 00:50:57.000000', 'consum', 0.0215, 'lps'),
	(455040, 125, '2015-03-15 00:50:58.000000', 'consum', 0.0226, 'lps'),
	(455041, 125, '2015-03-15 00:50:59.000000', 'consum', 0.0222, 'lps'),
	(455042, 125, '2015-03-15 00:51:00.000000', 'consum', 0.0223, 'lps'),
	(455043, 125, '2015-03-15 00:51:01.000000', 'consum', 0.0222, 'lps'),
	(455044, 125, '2015-03-15 00:51:02.000000', 'consum', 0.0212, 'lps'),
	(455045, 125, '2015-03-15 00:51:03.000000', 'consum', 0.0223, 'lps'),
	(455046, 125, '2015-03-15 00:51:04.000000', 'consum', 0.0212, 'lps'),
	(455047, 125, '2015-03-15 00:51:05.000000', 'consum', 0.0219, 'lps'),
	(455048, 125, '2015-03-15 00:51:06.000000', 'consum', 0.0214, 'lps'),
	(455049, 125, '2015-03-15 00:51:07.000000', 'consum', 0.0223, 'lps'),
	(455050, 125, '2015-03-15 00:51:08.000000', 'consum', 0.0225, 'lps'),
	(455051, 125, '2015-03-15 00:51:09.000000', 'consum', 0.0211, 'lps'),
	(455052, 125, '2015-03-15 00:51:10.000000', 'consum', 0.0226, 'lps'),
	(455053, 125, '2015-03-15 00:51:11.000000', 'consum', 0.0213, 'lps'),
	(455054, 125, '2015-03-15 00:51:12.000000', 'consum', 0.0216, 'lps'),
	(455055, 125, '2015-03-15 00:51:13.000000', 'consum', 0.0212, 'lps'),
	(455056, 125, '2015-03-15 00:51:14.000000', 'consum', 0.0222, 'lps'),
	(455057, 125, '2015-03-15 00:51:15.000000', 'consum', 0.0211, 'lps'),
	(455058, 125, '2015-03-15 00:51:16.000000', 'consum', 0.0213, 'lps'),
	(455059, 125, '2015-03-15 00:51:17.000000', 'consum', 0.0222, 'lps'),
	(455060, 125, '2015-03-15 00:51:18.000000', 'consum', 0.0225, 'lps'),
	(455061, 125, '2015-03-15 00:51:19.000000', 'consum', 0.0213, 'lps'),
	(455062, 125, '2015-03-15 00:51:20.000000', 'consum', 0.0217, 'lps'),
	(455063, 125, '2015-03-15 00:51:21.000000', 'consum', 0.0219, 'lps'),
	(455064, 125, '2015-03-15 00:51:22.000000', 'consum', 0.0217, 'lps'),
	(455065, 125, '2015-03-15 00:51:23.000000', 'consum', 0.0219, 'lps'),
	(455066, 125, '2015-03-15 00:51:24.000000', 'consum', 0.0215, 'lps'),
	(455067, 125, '2015-03-15 00:51:25.000000', 'consum', 0.0226, 'lps'),
	(455068, 125, '2015-03-15 00:51:26.000000', 'consum', 0.0223, 'lps'),
	(455069, 125, '2015-03-15 00:51:27.000000', 'consum', 0.0225, 'lps'),
	(455070, 125, '2015-03-15 00:51:28.000000', 'consum', 0.0211, 'lps'),
	(455071, 125, '2015-03-15 00:51:29.000000', 'consum', 0.0226, 'lps'),
	(455072, 125, '2015-03-15 00:51:30.000000', 'consum', 0.0216, 'lps'),
	(455073, 125, '2015-03-15 00:51:31.000000', 'consum', 0.0210, 'lps'),
	(455074, 125, '2015-03-15 00:51:32.000000', 'consum', 0.0212, 'lps'),
	(455075, 125, '2015-03-15 00:51:33.000000', 'consum', 0.0221, 'lps'),
	(455076, 125, '2015-03-15 00:51:34.000000', 'consum', 0.0221, 'lps'),
	(455077, 125, '2015-03-15 00:51:35.000000', 'consum', 0.0214, 'lps'),
	(455078, 125, '2015-03-15 00:51:36.000000', 'consum', 0.0215, 'lps'),
	(455079, 125, '2015-03-15 00:51:37.000000', 'consum', 0.0223, 'lps'),
	(455080, 125, '2015-03-15 00:51:38.000000', 'consum', 0.0227, 'lps'),
	(455081, 125, '2015-03-15 00:51:39.000000', 'consum', 0.0221, 'lps'),
	(455082, 125, '2015-03-15 00:51:40.000000', 'consum', 0.0215, 'lps'),
	(455083, 125, '2015-03-15 00:51:41.000000', 'consum', 0.0221, 'lps'),
	(455084, 125, '2015-03-15 00:51:42.000000', 'consum', 0.0213, 'lps'),
	(455085, 125, '2015-03-15 00:51:43.000000', 'consum', 0.0210, 'lps'),
	(455086, 125, '2015-03-15 00:51:44.000000', 'consum', 0.0220, 'lps'),
	(455087, 125, '2015-03-15 00:51:45.000000', 'consum', 0.0226, 'lps'),
	(455088, 125, '2015-03-15 00:51:46.000000', 'consum', 0.0222, 'lps'),
	(455089, 125, '2015-03-15 00:51:47.000000', 'consum', 0.0225, 'lps'),
	(455090, 125, '2015-03-15 00:51:48.000000', 'consum', 0.0212, 'lps'),
	(455091, 125, '2015-03-15 00:51:49.000000', 'consum', 0.0210, 'lps'),
	(455092, 125, '2015-03-15 00:51:50.000000', 'consum', 0.0225, 'lps'),
	(455093, 125, '2015-03-15 00:51:51.000000', 'consum', 0.0213, 'lps'),
	(455094, 125, '2015-03-15 00:51:52.000000', 'consum', 0.0216, 'lps'),
	(455095, 125, '2015-03-15 00:51:53.000000', 'consum', 0.0215, 'lps'),
	(455096, 125, '2015-03-15 00:51:54.000000', 'consum', 0.0215, 'lps'),
	(455097, 125, '2015-03-15 00:51:55.000000', 'consum', 0.0221, 'lps'),
	(455098, 125, '2015-03-15 00:51:56.000000', 'consum', 0.0214, 'lps'),
	(455099, 125, '2015-03-15 00:51:57.000000', 'consum', 0.0214, 'lps'),
	(455100, 125, '2015-03-15 00:51:58.000000', 'consum', 0.0221, 'lps'),
	(455101, 125, '2015-03-15 00:51:59.000000', 'consum', 0.0217, 'lps'),
	(455102, 125, '2015-03-15 00:52:00.000000', 'consum', 0.0213, 'lps'),
	(455103, 125, '2015-03-15 00:52:01.000000', 'consum', 0.0223, 'lps'),
	(455104, 125, '2015-03-15 00:52:02.000000', 'consum', 0.0212, 'lps'),
	(455105, 125, '2015-03-15 00:52:03.000000', 'consum', 0.0216, 'lps'),
	(455106, 125, '2015-03-15 00:52:04.000000', 'consum', 0.0219, 'lps'),
	(455107, 125, '2015-03-15 00:52:05.000000', 'consum', 0.0219, 'lps'),
	(455108, 125, '2015-03-15 00:52:06.000000', 'consum', 0.0211, 'lps'),
	(455109, 125, '2015-03-15 00:52:07.000000', 'consum', 0.0225, 'lps'),
	(455110, 125, '2015-03-15 00:52:08.000000', 'consum', 0.0227, 'lps'),
	(455111, 125, '2015-03-15 00:52:09.000000', 'consum', 0.0217, 'lps'),
	(455112, 125, '2015-03-15 00:52:10.000000', 'consum', 0.0210, 'lps'),
	(455113, 125, '2015-03-15 00:52:11.000000', 'consum', 0.0226, 'lps'),
	(455114, 125, '2015-03-15 00:52:12.000000', 'consum', 0.0217, 'lps'),
	(455115, 125, '2015-03-15 00:52:13.000000', 'consum', 0.0215, 'lps'),
	(455116, 125, '2015-03-15 00:52:14.000000', 'consum', 0.0217, 'lps'),
	(455117, 125, '2015-03-15 00:52:15.000000', 'consum', 0.0212, 'lps'),
	(455118, 125, '2015-03-15 00:52:16.000000', 'consum', 0.0218, 'lps'),
	(455119, 125, '2015-03-15 00:52:17.000000', 'consum', 0.0227, 'lps'),
	(455120, 125, '2015-03-15 00:52:18.000000', 'consum', 0.0215, 'lps'),
	(455121, 125, '2015-03-15 00:52:19.000000', 'consum', 0.0223, 'lps'),
	(455122, 125, '2015-03-15 00:52:20.000000', 'consum', 0.0224, 'lps'),
	(455123, 125, '2015-03-15 00:52:21.000000', 'consum', 0.0225, 'lps'),
	(455124, 125, '2015-03-15 00:52:22.000000', 'consum', 0.0223, 'lps'),
	(455125, 125, '2015-03-15 00:52:23.000000', 'consum', 0.0211, 'lps'),
	(455126, 125, '2015-03-15 00:52:24.000000', 'consum', 0.0216, 'lps'),
	(455127, 125, '2015-03-15 00:52:25.000000', 'consum', 0.0217, 'lps'),
	(455128, 125, '2015-03-15 00:52:26.000000', 'consum', 0.0211, 'lps'),
	(455129, 125, '2015-03-15 00:52:27.000000', 'consum', 0.0214, 'lps'),
	(455130, 125, '2015-03-15 00:52:28.000000', 'consum', 0.0227, 'lps'),
	(455131, 125, '2015-03-15 00:52:29.000000', 'consum', 0.0227, 'lps'),
	(455132, 125, '2015-03-15 00:52:30.000000', 'consum', 0.0211, 'lps'),
	(455133, 125, '2015-03-15 00:52:31.000000', 'consum', 0.0218, 'lps'),
	(455134, 125, '2015-03-15 00:52:32.000000', 'consum', 0.0210, 'lps'),
	(455135, 125, '2015-03-15 00:52:33.000000', 'consum', 0.0225, 'lps'),
	(455136, 125, '2015-03-15 00:52:34.000000', 'consum', 0.0214, 'lps'),
	(455137, 125, '2015-03-15 00:52:35.000000', 'consum', 0.0221, 'lps'),
	(455138, 125, '2015-03-15 00:52:36.000000', 'consum', 0.0216, 'lps'),
	(455139, 125, '2015-03-15 00:52:37.000000', 'consum', 0.0226, 'lps'),
	(455140, 125, '2015-03-15 00:52:38.000000', 'consum', 0.0218, 'lps'),
	(455141, 125, '2015-03-15 00:52:39.000000', 'consum', 0.0222, 'lps'),
	(455142, 125, '2015-03-15 00:52:40.000000', 'consum', 0.0212, 'lps'),
	(455143, 125, '2015-03-15 00:52:41.000000', 'consum', 0.0217, 'lps'),
	(455144, 125, '2015-03-15 00:52:42.000000', 'consum', 0.0224, 'lps'),
	(455145, 125, '2015-03-15 00:52:43.000000', 'consum', 0.0222, 'lps'),
	(455146, 125, '2015-03-15 00:52:44.000000', 'consum', 0.0210, 'lps'),
	(455147, 125, '2015-03-15 00:52:45.000000', 'consum', 0.0211, 'lps'),
	(455148, 125, '2015-03-15 00:52:46.000000', 'consum', 0.0216, 'lps'),
	(455149, 125, '2015-03-15 00:52:47.000000', 'consum', 0.0218, 'lps'),
	(455150, 125, '2015-03-15 00:52:48.000000', 'consum', 0.0216, 'lps'),
	(455151, 125, '2015-03-15 00:52:49.000000', 'consum', 0.0215, 'lps'),
	(455152, 125, '2015-03-15 00:52:50.000000', 'consum', 0.0217, 'lps'),
	(455153, 125, '2015-03-15 00:52:51.000000', 'consum', 0.0213, 'lps'),
	(455154, 125, '2015-03-15 00:52:52.000000', 'consum', 0.0222, 'lps'),
	(455155, 125, '2015-03-15 00:52:53.000000', 'consum', 0.0227, 'lps'),
	(455156, 125, '2015-03-15 00:52:54.000000', 'consum', 0.0222, 'lps'),
	(455157, 125, '2015-03-15 00:52:55.000000', 'consum', 0.0219, 'lps'),
	(455158, 125, '2015-03-15 00:52:56.000000', 'consum', 0.0222, 'lps'),
	(455159, 125, '2015-03-15 00:52:57.000000', 'consum', 0.0225, 'lps'),
	(455160, 125, '2015-03-15 00:52:58.000000', 'consum', 0.0215, 'lps'),
	(455161, 125, '2015-03-15 00:52:59.000000', 'consum', 0.0226, 'lps'),
	(455162, 125, '2015-03-15 00:53:00.000000', 'consum', 0.0220, 'lps'),
	(455163, 125, '2015-03-15 00:53:01.000000', 'consum', 0.0211, 'lps'),
	(455164, 125, '2015-03-15 00:53:02.000000', 'consum', 0.0224, 'lps'),
	(455165, 125, '2015-03-15 00:53:03.000000', 'consum', 0.0225, 'lps'),
	(455166, 125, '2015-03-15 00:53:04.000000', 'consum', 0.0223, 'lps'),
	(455167, 125, '2015-03-15 00:53:05.000000', 'consum', 0.0212, 'lps'),
	(455168, 125, '2015-03-15 00:53:06.000000', 'consum', 0.0217, 'lps'),
	(455169, 125, '2015-03-15 00:53:07.000000', 'consum', 0.0224, 'lps'),
	(455170, 125, '2015-03-15 00:53:08.000000', 'consum', 0.0222, 'lps'),
	(455171, 125, '2015-03-15 00:53:09.000000', 'consum', 0.0210, 'lps'),
	(455172, 125, '2015-03-15 00:53:10.000000', 'consum', 0.0212, 'lps'),
	(455173, 125, '2015-03-15 00:53:11.000000', 'consum', 0.0219, 'lps'),
	(455174, 125, '2015-03-15 00:53:12.000000', 'consum', 0.0214, 'lps'),
	(455175, 125, '2015-03-15 00:53:13.000000', 'consum', 0.0221, 'lps'),
	(455176, 125, '2015-03-15 00:53:14.000000', 'consum', 0.0216, 'lps'),
	(455177, 125, '2015-03-15 00:53:15.000000', 'consum', 0.0227, 'lps'),
	(455178, 125, '2015-03-15 00:53:16.000000', 'consum', 0.0222, 'lps'),
	(455179, 125, '2015-03-15 00:53:17.000000', 'consum', 0.0220, 'lps'),
	(455180, 125, '2015-03-15 00:53:18.000000', 'consum', 0.0227, 'lps'),
	(455181, 125, '2015-03-15 00:53:19.000000', 'consum', 0.0226, 'lps'),
	(455182, 125, '2015-03-15 00:53:20.000000', 'consum', 0.0224, 'lps'),
	(455183, 125, '2015-03-15 00:53:21.000000', 'consum', 0.0214, 'lps'),
	(455184, 125, '2015-03-15 00:53:22.000000', 'consum', 0.0225, 'lps'),
	(455185, 125, '2015-03-15 00:53:23.000000', 'consum', 0.0220, 'lps'),
	(455186, 125, '2015-03-15 00:53:24.000000', 'consum', 0.0214, 'lps'),
	(455187, 125, '2015-03-15 00:53:25.000000', 'consum', 0.0220, 'lps'),
	(455188, 125, '2015-03-15 00:53:26.000000', 'consum', 0.0212, 'lps'),
	(455189, 125, '2015-03-15 00:53:27.000000', 'consum', 0.0227, 'lps'),
	(455190, 125, '2015-03-15 00:53:28.000000', 'consum', 0.0216, 'lps'),
	(455191, 125, '2015-03-15 00:53:29.000000', 'consum', 0.0227, 'lps'),
	(455192, 125, '2015-03-15 00:53:30.000000', 'consum', 0.0222, 'lps'),
	(455193, 125, '2015-03-15 00:53:31.000000', 'consum', 0.0219, 'lps'),
	(455194, 125, '2015-03-15 00:53:32.000000', 'consum', 0.0219, 'lps'),
	(455195, 125, '2015-03-15 00:53:33.000000', 'consum', 0.0210, 'lps'),
	(455196, 125, '2015-03-15 00:53:34.000000', 'consum', 0.0221, 'lps'),
	(455197, 125, '2015-03-15 00:53:35.000000', 'consum', 0.0212, 'lps'),
	(455198, 125, '2015-03-15 00:53:36.000000', 'consum', 0.0223, 'lps'),
	(455199, 125, '2015-03-15 00:53:37.000000', 'consum', 0.0214, 'lps'),
	(455200, 125, '2015-03-15 00:53:38.000000', 'consum', 0.0210, 'lps'),
	(455201, 125, '2015-03-15 00:53:39.000000', 'consum', 0.0216, 'lps'),
	(455202, 125, '2015-03-15 00:53:40.000000', 'consum', 0.0224, 'lps'),
	(455203, 125, '2015-03-15 00:53:41.000000', 'consum', 0.0226, 'lps'),
	(455204, 125, '2015-03-15 00:53:42.000000', 'consum', 0.0212, 'lps'),
	(455205, 125, '2015-03-15 00:53:43.000000', 'consum', 0.0226, 'lps'),
	(455206, 125, '2015-03-15 00:53:44.000000', 'consum', 0.0215, 'lps'),
	(455207, 125, '2015-03-15 00:53:45.000000', 'consum', 0.0222, 'lps'),
	(455208, 125, '2015-03-15 00:53:46.000000', 'consum', 0.0219, 'lps'),
	(455209, 125, '2015-03-15 00:53:47.000000', 'consum', 0.0220, 'lps'),
	(455210, 125, '2015-03-15 00:53:48.000000', 'consum', 0.0217, 'lps'),
	(455211, 125, '2015-03-15 00:53:49.000000', 'consum', 0.0214, 'lps'),
	(455212, 125, '2015-03-15 00:53:50.000000', 'consum', 0.0227, 'lps'),
	(455213, 125, '2015-03-15 00:53:51.000000', 'consum', 0.0211, 'lps'),
	(455214, 125, '2015-03-15 00:53:52.000000', 'consum', 0.0218, 'lps'),
	(455215, 125, '2015-03-15 00:53:53.000000', 'consum', 0.0211, 'lps'),
	(455216, 125, '2015-03-15 00:53:54.000000', 'consum', 0.0210, 'lps'),
	(455217, 125, '2015-03-15 00:53:55.000000', 'consum', 0.0227, 'lps'),
	(455218, 125, '2015-03-15 00:53:56.000000', 'consum', 0.0224, 'lps'),
	(455219, 125, '2015-03-15 00:53:57.000000', 'consum', 0.0211, 'lps'),
	(455220, 125, '2015-03-15 00:53:58.000000', 'consum', 0.0211, 'lps'),
	(455221, 125, '2015-03-15 00:53:59.000000', 'consum', 0.0212, 'lps'),
	(455222, 125, '2015-03-15 00:54:00.000000', 'consum', 0.0215, 'lps'),
	(455223, 125, '2015-03-15 00:54:01.000000', 'consum', 0.0214, 'lps'),
	(455224, 125, '2015-03-15 00:54:02.000000', 'consum', 0.0214, 'lps'),
	(455225, 125, '2015-03-15 00:54:03.000000', 'consum', 0.0220, 'lps'),
	(455226, 125, '2015-03-15 00:54:04.000000', 'consum', 0.0210, 'lps'),
	(455227, 125, '2015-03-15 00:54:05.000000', 'consum', 0.0218, 'lps'),
	(455228, 125, '2015-03-15 00:54:06.000000', 'consum', 0.0215, 'lps'),
	(455229, 125, '2015-03-15 00:54:07.000000', 'consum', 0.0210, 'lps'),
	(455230, 125, '2015-03-15 00:54:08.000000', 'consum', 0.0215, 'lps'),
	(455231, 125, '2015-03-15 00:54:09.000000', 'consum', 0.0217, 'lps'),
	(455232, 125, '2015-03-15 00:54:10.000000', 'consum', 0.0214, 'lps'),
	(455233, 125, '2015-03-15 00:54:11.000000', 'consum', 0.0210, 'lps'),
	(455234, 125, '2015-03-15 00:54:12.000000', 'consum', 0.0217, 'lps'),
	(455235, 125, '2015-03-15 00:54:13.000000', 'consum', 0.0226, 'lps'),
	(455236, 125, '2015-03-15 00:54:14.000000', 'consum', 0.0218, 'lps'),
	(455237, 125, '2015-03-15 00:54:15.000000', 'consum', 0.0217, 'lps'),
	(455238, 125, '2015-03-15 00:54:16.000000', 'consum', 0.0225, 'lps'),
	(455239, 125, '2015-03-15 00:54:17.000000', 'consum', 0.0226, 'lps'),
	(455240, 125, '2015-03-15 00:54:18.000000', 'consum', 0.0227, 'lps'),
	(455241, 125, '2015-03-15 00:54:19.000000', 'consum', 0.0211, 'lps'),
	(455242, 125, '2015-03-15 00:54:20.000000', 'consum', 0.0220, 'lps'),
	(455243, 125, '2015-03-15 00:54:21.000000', 'consum', 0.0223, 'lps'),
	(455244, 125, '2015-03-15 00:54:22.000000', 'consum', 0.0225, 'lps'),
	(455245, 125, '2015-03-15 00:54:23.000000', 'consum', 0.0213, 'lps'),
	(455246, 125, '2015-03-15 00:54:24.000000', 'consum', 0.0215, 'lps'),
	(455247, 125, '2015-03-15 00:54:25.000000', 'consum', 0.0226, 'lps'),
	(455248, 125, '2015-03-15 00:54:26.000000', 'consum', 0.0223, 'lps'),
	(455249, 125, '2015-03-15 00:54:27.000000', 'consum', 0.0227, 'lps'),
	(455250, 125, '2015-03-15 00:54:28.000000', 'consum', 0.0220, 'lps'),
	(455251, 125, '2015-03-15 00:54:29.000000', 'consum', 0.0211, 'lps'),
	(455252, 125, '2015-03-15 00:54:30.000000', 'consum', 0.0222, 'lps'),
	(455253, 125, '2015-03-15 00:54:31.000000', 'consum', 0.0211, 'lps'),
	(455254, 125, '2015-03-15 00:54:32.000000', 'consum', 0.0218, 'lps'),
	(455255, 125, '2015-03-15 00:54:33.000000', 'consum', 0.0210, 'lps'),
	(455256, 125, '2015-03-15 00:54:34.000000', 'consum', 0.0222, 'lps'),
	(455257, 125, '2015-03-15 00:54:35.000000', 'consum', 0.0215, 'lps'),
	(455258, 125, '2015-03-15 00:54:36.000000', 'consum', 0.0219, 'lps'),
	(455259, 125, '2015-03-15 00:54:37.000000', 'consum', 0.0224, 'lps'),
	(455260, 125, '2015-03-15 00:54:38.000000', 'consum', 0.0218, 'lps'),
	(455261, 125, '2015-03-15 00:54:39.000000', 'consum', 0.0224, 'lps'),
	(455262, 125, '2015-03-15 00:54:40.000000', 'consum', 0.0222, 'lps'),
	(455263, 125, '2015-03-15 00:54:41.000000', 'consum', 0.0210, 'lps'),
	(455264, 125, '2015-03-15 00:54:42.000000', 'consum', 0.0211, 'lps'),
	(455265, 125, '2015-03-15 00:54:43.000000', 'consum', 0.0214, 'lps'),
	(455266, 125, '2015-03-15 00:54:44.000000', 'consum', 0.0210, 'lps'),
	(455267, 125, '2015-03-15 00:54:45.000000', 'consum', 0.0215, 'lps'),
	(455268, 125, '2015-03-15 00:54:46.000000', 'consum', 0.0220, 'lps'),
	(455269, 125, '2015-03-15 00:54:47.000000', 'consum', 0.0227, 'lps'),
	(455270, 125, '2015-03-15 00:54:48.000000', 'consum', 0.0211, 'lps'),
	(455271, 125, '2015-03-15 00:54:49.000000', 'consum', 0.0217, 'lps'),
	(455272, 125, '2015-03-15 00:54:50.000000', 'consum', 0.0210, 'lps'),
	(455273, 125, '2015-03-15 00:54:51.000000', 'consum', 0.0222, 'lps'),
	(455274, 125, '2015-03-15 00:54:52.000000', 'consum', 0.0217, 'lps'),
	(455275, 125, '2015-03-15 00:54:53.000000', 'consum', 0.0211, 'lps'),
	(455276, 125, '2015-03-15 00:54:54.000000', 'consum', 0.0211, 'lps'),
	(455277, 125, '2015-03-15 00:54:55.000000', 'consum', 0.0215, 'lps'),
	(455278, 125, '2015-03-15 00:54:56.000000', 'consum', 0.0213, 'lps'),
	(455279, 125, '2015-03-15 00:54:57.000000', 'consum', 0.0212, 'lps'),
	(455280, 125, '2015-03-15 00:54:58.000000', 'consum', 0.0227, 'lps'),
	(455281, 125, '2015-03-15 00:54:59.000000', 'consum', 0.0218, 'lps'),
	(455282, 125, '2015-03-15 00:55:00.000000', 'consum', 0.0216, 'lps'),
	(455283, 125, '2015-03-15 00:55:01.000000', 'consum', 0.0219, 'lps'),
	(455284, 125, '2015-03-15 00:55:02.000000', 'consum', 0.0220, 'lps'),
	(455285, 125, '2015-03-15 00:55:03.000000', 'consum', 0.0217, 'lps'),
	(455286, 125, '2015-03-15 00:55:04.000000', 'consum', 0.0212, 'lps'),
	(455287, 125, '2015-03-15 00:55:05.000000', 'consum', 0.0217, 'lps'),
	(455288, 125, '2015-03-15 00:55:06.000000', 'consum', 0.0224, 'lps'),
	(455289, 125, '2015-03-15 00:55:07.000000', 'consum', 0.0224, 'lps'),
	(455290, 125, '2015-03-15 00:55:08.000000', 'consum', 0.0218, 'lps'),
	(455291, 125, '2015-03-15 00:55:09.000000', 'consum', 0.0212, 'lps'),
	(455292, 125, '2015-03-15 00:55:10.000000', 'consum', 0.0211, 'lps'),
	(455293, 125, '2015-03-15 00:55:11.000000', 'consum', 0.0212, 'lps'),
	(455294, 125, '2015-03-15 00:55:12.000000', 'consum', 0.0215, 'lps'),
	(455295, 125, '2015-03-15 00:55:13.000000', 'consum', 0.0212, 'lps'),
	(455296, 125, '2015-03-15 00:55:14.000000', 'consum', 0.0224, 'lps'),
	(455297, 125, '2015-03-15 00:55:15.000000', 'consum', 0.0222, 'lps'),
	(455298, 125, '2015-03-15 00:55:16.000000', 'consum', 0.0226, 'lps'),
	(455299, 125, '2015-03-15 00:55:17.000000', 'consum', 0.0221, 'lps'),
	(455300, 125, '2015-03-15 00:55:18.000000', 'consum', 0.0217, 'lps'),
	(455301, 125, '2015-03-15 00:55:19.000000', 'consum', 0.0214, 'lps'),
	(455302, 125, '2015-03-15 00:55:20.000000', 'consum', 0.0224, 'lps'),
	(455303, 125, '2015-03-15 00:55:21.000000', 'consum', 0.0217, 'lps'),
	(455304, 125, '2015-03-15 00:55:22.000000', 'consum', 0.0222, 'lps'),
	(455305, 125, '2015-03-15 00:55:23.000000', 'consum', 0.0213, 'lps'),
	(455306, 125, '2015-03-15 00:55:24.000000', 'consum', 0.0226, 'lps'),
	(455307, 125, '2015-03-15 00:55:25.000000', 'consum', 0.0226, 'lps'),
	(455308, 125, '2015-03-15 00:55:26.000000', 'consum', 0.0227, 'lps'),
	(455309, 125, '2015-03-15 00:55:27.000000', 'consum', 0.0226, 'lps'),
	(455310, 125, '2015-03-15 00:55:28.000000', 'consum', 0.0225, 'lps'),
	(455311, 125, '2015-03-15 00:55:29.000000', 'consum', 0.0218, 'lps'),
	(455312, 125, '2015-03-15 00:55:30.000000', 'consum', 0.0222, 'lps'),
	(455313, 125, '2015-03-15 00:55:31.000000', 'consum', 0.0210, 'lps'),
	(455314, 125, '2015-03-15 00:55:32.000000', 'consum', 0.0210, 'lps'),
	(455315, 125, '2015-03-15 00:55:33.000000', 'consum', 0.0212, 'lps'),
	(455316, 125, '2015-03-15 00:55:34.000000', 'consum', 0.0220, 'lps'),
	(455317, 125, '2015-03-15 00:55:35.000000', 'consum', 0.0219, 'lps'),
	(455318, 125, '2015-03-15 00:55:36.000000', 'consum', 0.0227, 'lps'),
	(455319, 125, '2015-03-15 00:55:37.000000', 'consum', 0.0214, 'lps'),
	(455320, 125, '2015-03-15 00:55:38.000000', 'consum', 0.0215, 'lps'),
	(455321, 125, '2015-03-15 00:55:39.000000', 'consum', 0.0225, 'lps'),
	(455322, 125, '2015-03-15 00:55:40.000000', 'consum', 0.0214, 'lps'),
	(455323, 125, '2015-03-15 00:55:41.000000', 'consum', 0.0225, 'lps'),
	(455324, 125, '2015-03-15 00:55:42.000000', 'consum', 0.0216, 'lps'),
	(455325, 125, '2015-03-15 00:55:43.000000', 'consum', 0.0214, 'lps'),
	(455326, 125, '2015-03-15 00:55:44.000000', 'consum', 0.0212, 'lps'),
	(455327, 125, '2015-03-15 00:55:45.000000', 'consum', 0.0211, 'lps'),
	(455328, 125, '2015-03-15 00:55:46.000000', 'consum', 0.0226, 'lps'),
	(455329, 125, '2015-03-15 00:55:47.000000', 'consum', 0.0216, 'lps'),
	(455330, 125, '2015-03-15 00:55:48.000000', 'consum', 0.0212, 'lps'),
	(455331, 125, '2015-03-15 00:55:49.000000', 'consum', 0.0217, 'lps'),
	(455332, 125, '2015-03-15 00:55:50.000000', 'consum', 0.0224, 'lps'),
	(455333, 125, '2015-03-15 00:55:51.000000', 'consum', 0.0223, 'lps'),
	(455334, 125, '2015-03-15 00:55:52.000000', 'consum', 0.0215, 'lps'),
	(455335, 125, '2015-03-15 00:55:53.000000', 'consum', 0.0215, 'lps'),
	(455336, 125, '2015-03-15 00:55:54.000000', 'consum', 0.0222, 'lps'),
	(455337, 125, '2015-03-15 00:55:55.000000', 'consum', 0.0218, 'lps'),
	(455338, 125, '2015-03-15 00:55:56.000000', 'consum', 0.0213, 'lps'),
	(455339, 125, '2015-03-15 00:55:57.000000', 'consum', 0.0219, 'lps'),
	(455340, 125, '2015-03-15 00:55:58.000000', 'consum', 0.0212, 'lps'),
	(455341, 125, '2015-03-15 00:55:59.000000', 'consum', 0.0212, 'lps'),
	(455342, 125, '2015-03-15 00:56:00.000000', 'consum', 0.0216, 'lps'),
	(455343, 125, '2015-03-15 00:56:01.000000', 'consum', 0.0213, 'lps'),
	(455344, 125, '2015-03-15 00:56:02.000000', 'consum', 0.0211, 'lps'),
	(455345, 125, '2015-03-15 00:56:03.000000', 'consum', 0.0221, 'lps'),
	(455346, 125, '2015-03-15 00:56:04.000000', 'consum', 0.0210, 'lps'),
	(455347, 125, '2015-03-15 00:56:05.000000', 'consum', 0.0214, 'lps'),
	(455348, 125, '2015-03-15 00:56:06.000000', 'consum', 0.0210, 'lps'),
	(455349, 125, '2015-03-15 00:56:07.000000', 'consum', 0.0218, 'lps'),
	(455350, 125, '2015-03-15 00:56:08.000000', 'consum', 0.0216, 'lps'),
	(455351, 125, '2015-03-15 00:56:09.000000', 'consum', 0.0214, 'lps'),
	(455352, 125, '2015-03-15 00:56:10.000000', 'consum', 0.0212, 'lps'),
	(455353, 125, '2015-03-15 00:56:11.000000', 'consum', 0.0226, 'lps'),
	(455354, 125, '2015-03-15 00:56:12.000000', 'consum', 0.0213, 'lps'),
	(455355, 125, '2015-03-15 00:56:13.000000', 'consum', 0.0213, 'lps'),
	(455356, 125, '2015-03-15 00:56:14.000000', 'consum', 0.0216, 'lps'),
	(455357, 125, '2015-03-15 00:56:15.000000', 'consum', 0.0216, 'lps'),
	(455358, 125, '2015-03-15 00:56:16.000000', 'consum', 0.0219, 'lps'),
	(455359, 125, '2015-03-15 00:56:17.000000', 'consum', 0.0222, 'lps'),
	(455360, 125, '2015-03-15 00:56:18.000000', 'consum', 0.0224, 'lps'),
	(455361, 125, '2015-03-15 00:56:19.000000', 'consum', 0.0227, 'lps'),
	(455362, 125, '2015-03-15 00:56:20.000000', 'consum', 0.0217, 'lps'),
	(455363, 125, '2015-03-15 00:56:21.000000', 'consum', 0.0215, 'lps'),
	(455364, 125, '2015-03-15 00:56:22.000000', 'consum', 0.0213, 'lps'),
	(455365, 125, '2015-03-15 00:56:23.000000', 'consum', 0.0210, 'lps'),
	(455366, 125, '2015-03-15 00:56:24.000000', 'consum', 0.0221, 'lps'),
	(455367, 125, '2015-03-15 00:56:25.000000', 'consum', 0.0227, 'lps'),
	(455368, 125, '2015-03-15 00:56:26.000000', 'consum', 0.0210, 'lps'),
	(455369, 125, '2015-03-15 00:56:27.000000', 'consum', 0.0212, 'lps'),
	(455370, 125, '2015-03-15 00:56:28.000000', 'consum', 0.0221, 'lps'),
	(455371, 125, '2015-03-15 00:56:29.000000', 'consum', 0.0222, 'lps'),
	(455372, 125, '2015-03-15 00:56:30.000000', 'consum', 0.0221, 'lps'),
	(455373, 125, '2015-03-15 00:56:31.000000', 'consum', 0.0213, 'lps'),
	(455374, 125, '2015-03-15 00:56:32.000000', 'consum', 0.0226, 'lps'),
	(455375, 125, '2015-03-15 00:56:33.000000', 'consum', 0.0210, 'lps'),
	(455376, 125, '2015-03-15 00:56:34.000000', 'consum', 0.0216, 'lps'),
	(455377, 125, '2015-03-15 00:56:35.000000', 'consum', 0.0223, 'lps'),
	(455378, 125, '2015-03-15 00:56:36.000000', 'consum', 0.0223, 'lps'),
	(455379, 125, '2015-03-15 00:56:37.000000', 'consum', 0.0217, 'lps'),
	(455380, 125, '2015-03-15 00:56:38.000000', 'consum', 0.0224, 'lps'),
	(455381, 125, '2015-03-15 00:56:39.000000', 'consum', 0.0222, 'lps'),
	(455382, 125, '2015-03-15 00:56:40.000000', 'consum', 0.0213, 'lps'),
	(455383, 125, '2015-03-15 00:56:41.000000', 'consum', 0.0224, 'lps'),
	(455384, 125, '2015-03-15 00:56:42.000000', 'consum', 0.0218, 'lps'),
	(455385, 125, '2015-03-15 00:56:43.000000', 'consum', 0.0225, 'lps'),
	(455386, 125, '2015-03-15 00:56:44.000000', 'consum', 0.0210, 'lps'),
	(455387, 125, '2015-03-15 00:56:45.000000', 'consum', 0.0219, 'lps'),
	(455388, 125, '2015-03-15 00:56:46.000000', 'consum', 0.0217, 'lps'),
	(455389, 125, '2015-03-15 00:56:47.000000', 'consum', 0.0221, 'lps'),
	(455390, 125, '2015-03-15 00:56:48.000000', 'consum', 0.0210, 'lps'),
	(455391, 125, '2015-03-15 00:56:49.000000', 'consum', 0.0211, 'lps'),
	(455392, 125, '2015-03-15 00:56:50.000000', 'consum', 0.0214, 'lps'),
	(455393, 125, '2015-03-15 00:56:51.000000', 'consum', 0.0212, 'lps'),
	(455394, 125, '2015-03-15 00:56:52.000000', 'consum', 0.0210, 'lps'),
	(455395, 125, '2015-03-15 00:56:53.000000', 'consum', 0.0220, 'lps'),
	(455396, 125, '2015-03-15 00:56:54.000000', 'consum', 0.0225, 'lps'),
	(455397, 125, '2015-03-15 00:56:55.000000', 'consum', 0.0220, 'lps'),
	(455398, 125, '2015-03-15 00:56:56.000000', 'consum', 0.0216, 'lps'),
	(455399, 125, '2015-03-15 00:56:57.000000', 'consum', 0.0212, 'lps'),
	(455400, 125, '2015-03-15 00:56:58.000000', 'consum', 0.0217, 'lps'),
	(455401, 125, '2015-03-15 00:56:59.000000', 'consum', 0.0225, 'lps'),
	(455402, 125, '2015-03-15 00:57:00.000000', 'consum', 0.0226, 'lps'),
	(455403, 125, '2015-03-15 00:57:01.000000', 'consum', 0.0227, 'lps'),
	(455404, 125, '2015-03-15 00:57:02.000000', 'consum', 0.0213, 'lps'),
	(455405, 125, '2015-03-15 00:57:03.000000', 'consum', 0.0226, 'lps'),
	(455406, 125, '2015-03-15 00:57:04.000000', 'consum', 0.0213, 'lps'),
	(455407, 125, '2015-03-15 00:57:05.000000', 'consum', 0.0212, 'lps'),
	(455408, 125, '2015-03-15 00:57:06.000000', 'consum', 0.0211, 'lps'),
	(455409, 125, '2015-03-15 00:57:07.000000', 'consum', 0.0212, 'lps'),
	(455410, 125, '2015-03-15 00:57:08.000000', 'consum', 0.0216, 'lps'),
	(455411, 125, '2015-03-15 00:57:09.000000', 'consum', 0.0215, 'lps'),
	(455412, 125, '2015-03-15 00:57:10.000000', 'consum', 0.0217, 'lps'),
	(455413, 125, '2015-03-15 00:57:11.000000', 'consum', 0.0213, 'lps'),
	(455414, 125, '2015-03-15 00:57:12.000000', 'consum', 0.0221, 'lps'),
	(455415, 125, '2015-03-15 00:57:13.000000', 'consum', 0.0221, 'lps'),
	(455416, 125, '2015-03-15 00:57:14.000000', 'consum', 0.0217, 'lps'),
	(455417, 125, '2015-03-15 00:57:15.000000', 'consum', 0.0210, 'lps'),
	(455418, 125, '2015-03-15 00:57:16.000000', 'consum', 0.0227, 'lps'),
	(455419, 125, '2015-03-15 00:57:17.000000', 'consum', 0.0221, 'lps'),
	(455420, 125, '2015-03-15 00:57:18.000000', 'consum', 0.0217, 'lps'),
	(455421, 125, '2015-03-15 00:57:19.000000', 'consum', 0.0210, 'lps'),
	(455422, 125, '2015-03-15 00:57:20.000000', 'consum', 0.0227, 'lps'),
	(455423, 125, '2015-03-15 00:57:21.000000', 'consum', 0.0223, 'lps'),
	(455424, 125, '2015-03-15 00:57:22.000000', 'consum', 0.0226, 'lps'),
	(455425, 125, '2015-03-15 00:57:23.000000', 'consum', 0.0215, 'lps'),
	(455426, 125, '2015-03-15 00:57:24.000000', 'consum', 0.0223, 'lps'),
	(455427, 125, '2015-03-15 00:57:25.000000', 'consum', 0.0226, 'lps'),
	(455428, 125, '2015-03-15 00:57:26.000000', 'consum', 0.0213, 'lps'),
	(455429, 125, '2015-03-15 00:57:27.000000', 'consum', 0.0213, 'lps'),
	(455430, 125, '2015-03-15 00:57:28.000000', 'consum', 0.0220, 'lps'),
	(455431, 125, '2015-03-15 00:57:29.000000', 'consum', 0.0212, 'lps'),
	(455432, 125, '2015-03-15 00:57:30.000000', 'consum', 0.0211, 'lps'),
	(455433, 125, '2015-03-15 00:57:31.000000', 'consum', 0.0226, 'lps'),
	(455434, 125, '2015-03-15 00:57:32.000000', 'consum', 0.0216, 'lps'),
	(455435, 125, '2015-03-15 00:57:33.000000', 'consum', 0.0227, 'lps'),
	(455436, 125, '2015-03-15 00:57:34.000000', 'consum', 0.0226, 'lps'),
	(455437, 125, '2015-03-15 00:57:35.000000', 'consum', 0.0221, 'lps'),
	(455438, 125, '2015-03-15 00:57:36.000000', 'consum', 0.0218, 'lps'),
	(455439, 125, '2015-03-15 00:57:37.000000', 'consum', 0.0217, 'lps'),
	(455440, 125, '2015-03-15 00:57:38.000000', 'consum', 0.0222, 'lps'),
	(455441, 125, '2015-03-15 00:57:39.000000', 'consum', 0.0215, 'lps'),
	(455442, 125, '2015-03-15 00:57:40.000000', 'consum', 0.0216, 'lps'),
	(455443, 125, '2015-03-15 00:57:41.000000', 'consum', 0.0210, 'lps'),
	(455444, 125, '2015-03-15 00:57:42.000000', 'consum', 0.0225, 'lps'),
	(455445, 125, '2015-03-15 00:57:43.000000', 'consum', 0.0214, 'lps'),
	(455446, 125, '2015-03-15 00:57:44.000000', 'consum', 0.0222, 'lps'),
	(455447, 125, '2015-03-15 00:57:45.000000', 'consum', 0.0222, 'lps'),
	(455448, 125, '2015-03-15 00:57:46.000000', 'consum', 0.0219, 'lps'),
	(455449, 125, '2015-03-15 00:57:47.000000', 'consum', 0.0218, 'lps'),
	(455450, 125, '2015-03-15 00:57:48.000000', 'consum', 0.0223, 'lps'),
	(455451, 125, '2015-03-15 00:57:49.000000', 'consum', 0.0215, 'lps'),
	(455452, 125, '2015-03-15 00:57:50.000000', 'consum', 0.0217, 'lps'),
	(455453, 125, '2015-03-15 00:57:51.000000', 'consum', 0.0210, 'lps'),
	(455454, 125, '2015-03-15 00:57:52.000000', 'consum', 0.0225, 'lps'),
	(455455, 125, '2015-03-15 00:57:53.000000', 'consum', 0.0215, 'lps'),
	(455456, 125, '2015-03-15 00:57:54.000000', 'consum', 0.0227, 'lps'),
	(455457, 125, '2015-03-15 00:57:55.000000', 'consum', 0.0227, 'lps'),
	(455458, 125, '2015-03-15 00:57:56.000000', 'consum', 0.0224, 'lps'),
	(455459, 125, '2015-03-15 00:57:57.000000', 'consum', 0.0213, 'lps'),
	(455460, 125, '2015-03-15 00:57:58.000000', 'consum', 0.0221, 'lps'),
	(455461, 125, '2015-03-15 00:57:59.000000', 'consum', 0.0221, 'lps'),
	(455462, 125, '2015-03-15 00:58:00.000000', 'consum', 0.0212, 'lps'),
	(455463, 125, '2015-03-15 00:58:01.000000', 'consum', 0.0222, 'lps'),
	(455464, 125, '2015-03-15 00:58:02.000000', 'consum', 0.0214, 'lps'),
	(455465, 125, '2015-03-15 00:58:03.000000', 'consum', 0.0212, 'lps'),
	(455466, 125, '2015-03-15 00:58:04.000000', 'consum', 0.0227, 'lps'),
	(455467, 125, '2015-03-15 00:58:05.000000', 'consum', 0.0215, 'lps'),
	(455468, 125, '2015-03-15 00:58:06.000000', 'consum', 0.0221, 'lps'),
	(455469, 125, '2015-03-15 00:58:07.000000', 'consum', 0.0214, 'lps'),
	(455470, 125, '2015-03-15 00:58:08.000000', 'consum', 0.0216, 'lps'),
	(455471, 125, '2015-03-15 00:58:09.000000', 'consum', 0.0227, 'lps'),
	(455472, 125, '2015-03-15 00:58:10.000000', 'consum', 0.0225, 'lps'),
	(455473, 125, '2015-03-15 00:58:11.000000', 'consum', 0.0215, 'lps'),
	(455474, 125, '2015-03-15 00:58:12.000000', 'consum', 0.0225, 'lps'),
	(455475, 125, '2015-03-15 00:58:13.000000', 'consum', 0.0220, 'lps'),
	(455476, 125, '2015-03-15 00:58:14.000000', 'consum', 0.0213, 'lps'),
	(455477, 125, '2015-03-15 00:58:15.000000', 'consum', 0.0213, 'lps'),
	(455478, 125, '2015-03-15 00:58:16.000000', 'consum', 0.0216, 'lps'),
	(455479, 125, '2015-03-15 00:58:17.000000', 'consum', 0.0213, 'lps'),
	(455480, 125, '2015-03-15 00:58:18.000000', 'consum', 0.0226, 'lps'),
	(455481, 125, '2015-03-15 00:58:19.000000', 'consum', 0.0211, 'lps'),
	(455482, 125, '2015-03-15 00:58:20.000000', 'consum', 0.0221, 'lps'),
	(455483, 125, '2015-03-15 00:58:21.000000', 'consum', 0.0227, 'lps'),
	(455484, 125, '2015-03-15 00:58:22.000000', 'consum', 0.0224, 'lps'),
	(455485, 125, '2015-03-15 00:58:23.000000', 'consum', 0.0214, 'lps'),
	(455486, 125, '2015-03-15 00:58:24.000000', 'consum', 0.0225, 'lps'),
	(455487, 125, '2015-03-15 00:58:25.000000', 'consum', 0.0217, 'lps'),
	(455488, 125, '2015-03-15 00:58:26.000000', 'consum', 0.0221, 'lps'),
	(455489, 125, '2015-03-15 00:58:27.000000', 'consum', 0.0226, 'lps'),
	(455490, 125, '2015-03-15 00:58:28.000000', 'consum', 0.0219, 'lps'),
	(455491, 125, '2015-03-15 00:58:29.000000', 'consum', 0.0211, 'lps'),
	(455492, 125, '2015-03-15 00:58:30.000000', 'consum', 0.0221, 'lps'),
	(455493, 125, '2015-03-15 00:58:31.000000', 'consum', 0.0211, 'lps'),
	(455494, 125, '2015-03-15 00:58:32.000000', 'consum', 0.0217, 'lps'),
	(455495, 125, '2015-03-15 00:58:33.000000', 'consum', 0.0225, 'lps'),
	(455496, 125, '2015-03-15 00:58:34.000000', 'consum', 0.0211, 'lps'),
	(455497, 125, '2015-03-15 00:58:35.000000', 'consum', 0.0224, 'lps'),
	(455498, 125, '2015-03-15 00:58:36.000000', 'consum', 0.0224, 'lps'),
	(455499, 125, '2015-03-15 00:58:37.000000', 'consum', 0.0221, 'lps'),
	(455500, 125, '2015-03-15 00:58:38.000000', 'consum', 0.0225, 'lps'),
	(455501, 125, '2015-03-15 00:58:39.000000', 'consum', 0.0215, 'lps'),
	(455502, 125, '2015-03-15 00:58:40.000000', 'consum', 0.0226, 'lps'),
	(455503, 125, '2015-03-15 00:58:41.000000', 'consum', 0.0224, 'lps'),
	(455504, 125, '2015-03-15 00:58:42.000000', 'consum', 0.0212, 'lps'),
	(455505, 125, '2015-03-15 00:58:43.000000', 'consum', 0.0216, 'lps'),
	(455506, 125, '2015-03-15 00:58:44.000000', 'consum', 0.0216, 'lps'),
	(455507, 125, '2015-03-15 00:58:45.000000', 'consum', 0.0223, 'lps'),
	(455508, 125, '2015-03-15 00:58:46.000000', 'consum', 0.0220, 'lps'),
	(455509, 125, '2015-03-15 00:58:47.000000', 'consum', 0.0224, 'lps'),
	(455510, 125, '2015-03-15 00:58:48.000000', 'consum', 0.0211, 'lps'),
	(455511, 125, '2015-03-15 00:58:49.000000', 'consum', 0.0212, 'lps'),
	(455512, 125, '2015-03-15 00:58:50.000000', 'consum', 0.0219, 'lps'),
	(455513, 125, '2015-03-15 00:58:51.000000', 'consum', 0.0212, 'lps'),
	(455514, 125, '2015-03-15 00:58:52.000000', 'consum', 0.0212, 'lps'),
	(455515, 125, '2015-03-15 00:58:53.000000', 'consum', 0.0214, 'lps'),
	(455516, 125, '2015-03-15 00:58:54.000000', 'consum', 0.0223, 'lps'),
	(455517, 125, '2015-03-15 00:58:55.000000', 'consum', 0.0211, 'lps'),
	(455518, 125, '2015-03-15 00:58:56.000000', 'consum', 0.0214, 'lps'),
	(455519, 125, '2015-03-15 00:58:57.000000', 'consum', 0.0224, 'lps'),
	(455520, 125, '2015-03-15 00:58:58.000000', 'consum', 0.0218, 'lps'),
	(455521, 125, '2015-03-15 00:58:59.000000', 'consum', 0.0226, 'lps'),
	(455522, 125, '2015-03-15 00:59:00.000000', 'consum', 0.0211, 'lps'),
	(455523, 125, '2015-03-15 00:59:01.000000', 'consum', 0.0221, 'lps'),
	(455524, 125, '2015-03-15 00:59:02.000000', 'consum', 0.0210, 'lps'),
	(455525, 125, '2015-03-15 00:59:03.000000', 'consum', 0.0213, 'lps'),
	(455526, 125, '2015-03-15 00:59:04.000000', 'consum', 0.0225, 'lps'),
	(455527, 125, '2015-03-15 00:59:05.000000', 'consum', 0.0223, 'lps'),
	(455528, 125, '2015-03-15 00:59:06.000000', 'consum', 0.0212, 'lps'),
	(455529, 125, '2015-03-15 00:59:07.000000', 'consum', 0.0216, 'lps'),
	(455530, 125, '2015-03-15 00:59:08.000000', 'consum', 0.0217, 'lps'),
	(455531, 125, '2015-03-15 00:59:09.000000', 'consum', 0.0211, 'lps'),
	(455532, 125, '2015-03-15 00:59:10.000000', 'consum', 0.0211, 'lps'),
	(455533, 125, '2015-03-15 00:59:11.000000', 'consum', 0.0212, 'lps'),
	(455534, 125, '2015-03-15 00:59:12.000000', 'consum', 0.0220, 'lps'),
	(455535, 125, '2015-03-15 00:59:13.000000', 'consum', 0.0216, 'lps'),
	(455536, 125, '2015-03-15 00:59:14.000000', 'consum', 0.0210, 'lps'),
	(455537, 125, '2015-03-15 00:59:15.000000', 'consum', 0.0210, 'lps'),
	(455538, 125, '2015-03-15 00:59:16.000000', 'consum', 0.0213, 'lps'),
	(455539, 125, '2015-03-15 00:59:17.000000', 'consum', 0.0224, 'lps'),
	(455540, 125, '2015-03-15 00:59:18.000000', 'consum', 0.0217, 'lps'),
	(455541, 125, '2015-03-15 00:59:19.000000', 'consum', 0.0223, 'lps'),
	(455542, 125, '2015-03-15 00:59:20.000000', 'consum', 0.0218, 'lps'),
	(455543, 125, '2015-03-15 00:59:21.000000', 'consum', 0.0212, 'lps'),
	(455544, 125, '2015-03-15 00:59:22.000000', 'consum', 0.0215, 'lps'),
	(455545, 125, '2015-03-15 00:59:23.000000', 'consum', 0.0227, 'lps'),
	(455546, 125, '2015-03-15 00:59:24.000000', 'consum', 0.0212, 'lps'),
	(455547, 125, '2015-03-15 00:59:25.000000', 'consum', 0.0220, 'lps'),
	(455548, 125, '2015-03-15 00:59:26.000000', 'consum', 0.0222, 'lps'),
	(455549, 125, '2015-03-15 00:59:27.000000', 'consum', 0.0221, 'lps'),
	(455550, 125, '2015-03-15 00:59:28.000000', 'consum', 0.0211, 'lps'),
	(455551, 125, '2015-03-15 00:59:29.000000', 'consum', 0.0218, 'lps'),
	(455552, 125, '2015-03-15 00:59:30.000000', 'consum', 0.0210, 'lps'),
	(455553, 125, '2015-03-15 00:59:31.000000', 'consum', 0.0225, 'lps'),
	(455554, 125, '2015-03-15 00:59:32.000000', 'consum', 0.0215, 'lps'),
	(455555, 125, '2015-03-15 00:59:33.000000', 'consum', 0.0223, 'lps'),
	(455556, 125, '2015-03-15 00:59:34.000000', 'consum', 0.0225, 'lps'),
	(455557, 125, '2015-03-15 00:59:35.000000', 'consum', 0.0213, 'lps'),
	(455558, 125, '2015-03-15 00:59:36.000000', 'consum', 0.0213, 'lps'),
	(455559, 125, '2015-03-15 00:59:37.000000', 'consum', 0.0218, 'lps'),
	(455560, 125, '2015-03-15 00:59:38.000000', 'consum', 0.0225, 'lps'),
	(455561, 125, '2015-03-15 00:59:39.000000', 'consum', 0.0225, 'lps'),
	(455562, 125, '2015-03-15 00:59:40.000000', 'consum', 0.0224, 'lps'),
	(455563, 125, '2015-03-15 00:59:41.000000', 'consum', 0.0217, 'lps'),
	(455564, 125, '2015-03-15 00:59:42.000000', 'consum', 0.0221, 'lps'),
	(455565, 125, '2015-03-15 00:59:43.000000', 'consum', 0.0225, 'lps'),
	(455566, 125, '2015-03-15 00:59:44.000000', 'consum', 0.0216, 'lps'),
	(455567, 125, '2015-03-15 00:59:45.000000', 'consum', 0.0216, 'lps'),
	(455568, 125, '2015-03-15 00:59:46.000000', 'consum', 0.0220, 'lps'),
	(455569, 125, '2015-03-15 00:59:47.000000', 'consum', 0.0227, 'lps'),
	(455570, 125, '2015-03-15 00:59:48.000000', 'consum', 0.0212, 'lps'),
	(455571, 125, '2015-03-15 00:59:49.000000', 'consum', 0.0220, 'lps'),
	(455572, 125, '2015-03-15 00:59:50.000000', 'consum', 0.0222, 'lps'),
	(455573, 125, '2015-03-15 00:59:51.000000', 'consum', 0.0221, 'lps'),
	(455574, 125, '2015-03-15 00:59:52.000000', 'consum', 0.0210, 'lps'),
	(455575, 125, '2015-03-15 00:59:53.000000', 'consum', 0.0214, 'lps'),
	(455576, 125, '2015-03-15 00:59:54.000000', 'consum', 0.0213, 'lps'),
	(455577, 125, '2015-03-15 00:59:55.000000', 'consum', 0.0212, 'lps'),
	(455578, 125, '2015-03-15 00:59:56.000000', 'consum', 0.0211, 'lps'),
	(455579, 125, '2015-03-15 00:59:57.000000', 'consum', 0.0210, 'lps'),
	(455580, 125, '2015-03-15 00:59:58.000000', 'consum', 0.0225, 'lps'),
	(455581, 125, '2015-03-15 00:59:59.000000', 'consum', 0.0214, 'lps'),
	(455582, 125, '2015-03-15 01:00:00.000000', 'consum', 0.0223, 'lps'),
	(455583, 125, '2015-03-15 01:00:01.000000', 'consum', 0.0224, 'lps'),
	(455584, 125, '2015-03-15 01:00:02.000000', 'consum', 0.0227, 'lps'),
	(455585, 125, '2015-03-15 01:00:03.000000', 'consum', 0.0216, 'lps'),
	(455586, 125, '2015-03-15 01:00:04.000000', 'consum', 0.0225, 'lps'),
	(455587, 125, '2015-03-15 01:00:05.000000', 'consum', 0.0215, 'lps'),
	(455588, 125, '2015-03-15 01:00:06.000000', 'consum', 0.0226, 'lps'),
	(455589, 125, '2015-03-15 01:00:07.000000', 'consum', 0.0222, 'lps'),
	(455590, 125, '2015-03-15 01:00:08.000000', 'consum', 0.0222, 'lps'),
	(455591, 125, '2015-03-15 01:00:09.000000', 'consum', 0.0216, 'lps'),
	(455592, 125, '2015-03-15 01:00:10.000000', 'consum', 0.0225, 'lps'),
	(455593, 125, '2015-03-15 01:00:11.000000', 'consum', 0.0212, 'lps'),
	(455594, 125, '2015-03-15 01:00:12.000000', 'consum', 0.0210, 'lps'),
	(455595, 125, '2015-03-15 01:00:13.000000', 'consum', 0.0222, 'lps'),
	(455596, 125, '2015-03-15 01:00:14.000000', 'consum', 0.0217, 'lps'),
	(455597, 125, '2015-03-15 01:00:15.000000', 'consum', 0.0227, 'lps'),
	(455598, 125, '2015-03-15 01:00:16.000000', 'consum', 0.0221, 'lps'),
	(455599, 125, '2015-03-15 01:00:17.000000', 'consum', 0.0215, 'lps'),
	(455600, 125, '2015-03-15 01:00:18.000000', 'consum', 0.0219, 'lps'),
	(455601, 125, '2015-03-15 01:00:19.000000', 'consum', 0.0222, 'lps'),
	(455602, 125, '2015-03-15 01:00:20.000000', 'consum', 0.0226, 'lps'),
	(455603, 125, '2015-03-15 01:00:21.000000', 'consum', 0.0217, 'lps'),
	(455604, 125, '2015-03-15 01:00:22.000000', 'consum', 0.0219, 'lps'),
	(455605, 125, '2015-03-15 01:00:23.000000', 'consum', 0.0214, 'lps'),
	(455606, 125, '2015-03-15 01:00:24.000000', 'consum', 0.0221, 'lps'),
	(455607, 125, '2015-03-15 01:00:25.000000', 'consum', 0.0217, 'lps'),
	(455608, 125, '2015-03-15 01:00:26.000000', 'consum', 0.0213, 'lps'),
	(455609, 125, '2015-03-15 01:00:27.000000', 'consum', 0.0223, 'lps'),
	(455610, 125, '2015-03-15 01:00:28.000000', 'consum', 0.0211, 'lps'),
	(455611, 125, '2015-03-15 01:00:29.000000', 'consum', 0.0214, 'lps'),
	(455612, 125, '2015-03-15 01:00:30.000000', 'consum', 0.0227, 'lps'),
	(455613, 125, '2015-03-15 01:00:31.000000', 'consum', 0.0210, 'lps'),
	(455614, 125, '2015-03-15 01:00:32.000000', 'consum', 0.0215, 'lps'),
	(455615, 125, '2015-03-15 01:00:33.000000', 'consum', 0.0217, 'lps'),
	(455616, 125, '2015-03-15 01:00:34.000000', 'consum', 0.0212, 'lps'),
	(455617, 125, '2015-03-15 01:00:35.000000', 'consum', 0.0219, 'lps'),
	(455618, 125, '2015-03-15 01:00:36.000000', 'consum', 0.0212, 'lps'),
	(455619, 125, '2015-03-15 01:00:37.000000', 'consum', 0.0213, 'lps'),
	(455620, 125, '2015-03-15 01:00:38.000000', 'consum', 0.0220, 'lps'),
	(455621, 125, '2015-03-15 01:00:39.000000', 'consum', 0.0213, 'lps'),
	(455622, 125, '2015-03-15 01:00:40.000000', 'consum', 0.0214, 'lps'),
	(455623, 125, '2015-03-15 01:00:41.000000', 'consum', 0.0224, 'lps'),
	(455624, 125, '2015-03-15 01:00:42.000000', 'consum', 0.0214, 'lps'),
	(455625, 125, '2015-03-15 01:00:43.000000', 'consum', 0.0222, 'lps'),
	(455626, 125, '2015-03-15 01:00:44.000000', 'consum', 0.0224, 'lps'),
	(455627, 125, '2015-03-15 01:00:45.000000', 'consum', 0.0225, 'lps'),
	(455628, 125, '2015-03-15 01:00:46.000000', 'consum', 0.0227, 'lps'),
	(455629, 125, '2015-03-15 01:00:47.000000', 'consum', 0.0216, 'lps'),
	(455630, 125, '2015-03-15 01:00:48.000000', 'consum', 0.0225, 'lps'),
	(455631, 125, '2015-03-15 01:00:49.000000', 'consum', 0.0213, 'lps'),
	(455632, 125, '2015-03-15 01:00:50.000000', 'consum', 0.0217, 'lps'),
	(455633, 125, '2015-03-15 01:00:51.000000', 'consum', 0.0217, 'lps'),
	(455634, 125, '2015-03-15 01:00:52.000000', 'consum', 0.0225, 'lps'),
	(455635, 125, '2015-03-15 01:00:53.000000', 'consum', 0.0210, 'lps'),
	(455636, 125, '2015-03-15 01:00:54.000000', 'consum', 0.0221, 'lps'),
	(455637, 125, '2015-03-15 01:00:55.000000', 'consum', 0.0227, 'lps'),
	(455638, 125, '2015-03-15 01:00:56.000000', 'consum', 0.0211, 'lps'),
	(455639, 125, '2015-03-15 01:00:57.000000', 'consum', 0.0219, 'lps'),
	(455640, 125, '2015-03-15 01:00:58.000000', 'consum', 0.0215, 'lps'),
	(455641, 125, '2015-03-15 01:00:59.000000', 'consum', 0.0210, 'lps'),
	(455642, 125, '2015-03-15 01:01:00.000000', 'consum', 0.0214, 'lps'),
	(455643, 125, '2015-03-15 01:01:01.000000', 'consum', 0.0212, 'lps'),
	(455644, 125, '2015-03-15 01:01:02.000000', 'consum', 0.0210, 'lps'),
	(455645, 125, '2015-03-15 01:01:03.000000', 'consum', 0.0221, 'lps'),
	(455646, 125, '2015-03-15 01:01:04.000000', 'consum', 0.0214, 'lps'),
	(455647, 125, '2015-03-15 01:01:05.000000', 'consum', 0.0212, 'lps'),
	(455648, 125, '2015-03-15 01:01:06.000000', 'consum', 0.0227, 'lps'),
	(455649, 125, '2015-03-15 01:01:07.000000', 'consum', 0.0220, 'lps'),
	(455650, 125, '2015-03-15 01:01:08.000000', 'consum', 0.0224, 'lps'),
	(455651, 125, '2015-03-15 01:01:09.000000', 'consum', 0.0218, 'lps'),
	(455652, 125, '2015-03-15 01:01:10.000000', 'consum', 0.0224, 'lps'),
	(455653, 125, '2015-03-15 01:01:11.000000', 'consum', 0.0220, 'lps'),
	(455654, 125, '2015-03-15 01:01:12.000000', 'consum', 0.0221, 'lps'),
	(455655, 125, '2015-03-15 01:01:13.000000', 'consum', 0.0217, 'lps'),
	(455656, 125, '2015-03-15 01:01:14.000000', 'consum', 0.0210, 'lps'),
	(455657, 125, '2015-03-15 01:01:15.000000', 'consum', 0.0210, 'lps'),
	(455658, 125, '2015-03-15 01:01:16.000000', 'consum', 0.0211, 'lps'),
	(455659, 125, '2015-03-15 01:01:17.000000', 'consum', 0.0213, 'lps'),
	(455660, 125, '2015-03-15 01:01:18.000000', 'consum', 0.0222, 'lps'),
	(455661, 125, '2015-03-15 01:01:19.000000', 'consum', 0.0226, 'lps'),
	(455662, 125, '2015-03-15 01:01:20.000000', 'consum', 0.0220, 'lps'),
	(455663, 125, '2015-03-15 01:01:21.000000', 'consum', 0.0212, 'lps'),
	(455664, 125, '2015-03-15 01:01:22.000000', 'consum', 0.0225, 'lps'),
	(455665, 125, '2015-03-15 01:01:23.000000', 'consum', 0.0225, 'lps'),
	(455666, 125, '2015-03-15 01:01:24.000000', 'consum', 0.0223, 'lps'),
	(455667, 125, '2015-03-15 01:01:25.000000', 'consum', 0.0212, 'lps'),
	(455668, 125, '2015-03-15 01:01:26.000000', 'consum', 0.0218, 'lps'),
	(455669, 125, '2015-03-15 01:01:27.000000', 'consum', 0.0211, 'lps'),
	(455670, 125, '2015-03-15 01:01:28.000000', 'consum', 0.0224, 'lps'),
	(455671, 125, '2015-03-15 01:01:29.000000', 'consum', 0.0225, 'lps'),
	(455672, 125, '2015-03-15 01:01:30.000000', 'consum', 0.0224, 'lps'),
	(455673, 125, '2015-03-15 01:01:31.000000', 'consum', 0.0218, 'lps'),
	(455674, 125, '2015-03-15 01:01:32.000000', 'consum', 0.0225, 'lps'),
	(455675, 125, '2015-03-15 01:01:33.000000', 'consum', 0.0211, 'lps'),
	(455676, 125, '2015-03-15 01:01:34.000000', 'consum', 0.0221, 'lps'),
	(455677, 125, '2015-03-15 01:01:35.000000', 'consum', 0.0211, 'lps'),
	(455678, 125, '2015-03-15 01:01:36.000000', 'consum', 0.0216, 'lps'),
	(455679, 125, '2015-03-15 01:01:37.000000', 'consum', 0.0219, 'lps'),
	(455680, 125, '2015-03-15 01:01:38.000000', 'consum', 0.0220, 'lps'),
	(455681, 125, '2015-03-15 01:01:39.000000', 'consum', 0.0217, 'lps'),
	(455682, 125, '2015-03-15 01:01:40.000000', 'consum', 0.0216, 'lps'),
	(455683, 125, '2015-03-15 01:01:41.000000', 'consum', 0.0217, 'lps'),
	(455684, 125, '2015-03-15 01:01:42.000000', 'consum', 0.0212, 'lps'),
	(455685, 125, '2015-03-15 01:01:43.000000', 'consum', 0.0217, 'lps'),
	(455686, 125, '2015-03-15 01:01:44.000000', 'consum', 0.0221, 'lps'),
	(455687, 125, '2015-03-15 01:01:45.000000', 'consum', 0.0226, 'lps'),
	(455688, 125, '2015-03-15 01:01:46.000000', 'consum', 0.0223, 'lps'),
	(455689, 125, '2015-03-15 01:01:47.000000', 'consum', 0.0225, 'lps'),
	(455690, 125, '2015-03-15 01:01:48.000000', 'consum', 0.0212, 'lps'),
	(455691, 125, '2015-03-15 01:01:49.000000', 'consum', 0.0213, 'lps'),
	(455692, 125, '2015-03-15 01:01:50.000000', 'consum', 0.0216, 'lps'),
	(455693, 125, '2015-03-15 01:01:51.000000', 'consum', 0.0217, 'lps'),
	(455694, 125, '2015-03-15 01:01:52.000000', 'consum', 0.0224, 'lps'),
	(455695, 125, '2015-03-15 01:01:53.000000', 'consum', 0.0226, 'lps'),
	(455696, 125, '2015-03-15 01:01:54.000000', 'consum', 0.0211, 'lps'),
	(455697, 125, '2015-03-15 01:01:55.000000', 'consum', 0.0221, 'lps'),
	(455698, 125, '2015-03-15 01:01:56.000000', 'consum', 0.0210, 'lps'),
	(455699, 125, '2015-03-15 01:01:57.000000', 'consum', 0.0214, 'lps'),
	(455700, 125, '2015-03-15 01:01:58.000000', 'consum', 0.0212, 'lps'),
	(455701, 125, '2015-03-15 01:01:59.000000', 'consum', 0.0210, 'lps'),
	(455702, 125, '2015-03-15 01:02:00.000000', 'consum', 0.0220, 'lps'),
	(455703, 125, '2015-03-15 01:02:01.000000', 'consum', 0.0225, 'lps'),
	(455704, 125, '2015-03-15 01:02:02.000000', 'consum', 0.0219, 'lps'),
	(455705, 125, '2015-03-15 01:02:03.000000', 'consum', 0.0227, 'lps'),
	(455706, 125, '2015-03-15 01:02:04.000000', 'consum', 0.0216, 'lps'),
	(455707, 125, '2015-03-15 01:02:05.000000', 'consum', 0.0225, 'lps'),
	(455708, 125, '2015-03-15 01:02:06.000000', 'consum', 0.0215, 'lps'),
	(455709, 125, '2015-03-15 01:02:07.000000', 'consum', 0.0210, 'lps'),
	(455710, 125, '2015-03-15 01:02:08.000000', 'consum', 0.0210, 'lps'),
	(455711, 125, '2015-03-15 01:02:09.000000', 'consum', 0.0213, 'lps'),
	(455712, 125, '2015-03-15 01:02:10.000000', 'consum', 0.0226, 'lps'),
	(455713, 125, '2015-03-15 01:02:11.000000', 'consum', 0.0210, 'lps'),
	(455714, 125, '2015-03-15 01:02:12.000000', 'consum', 0.0215, 'lps'),
	(455715, 125, '2015-03-15 01:02:13.000000', 'consum', 0.0217, 'lps'),
	(455716, 125, '2015-03-15 01:02:14.000000', 'consum', 0.0212, 'lps'),
	(455717, 125, '2015-03-15 01:02:15.000000', 'consum', 0.0219, 'lps'),
	(455718, 125, '2015-03-15 01:02:16.000000', 'consum', 0.0212, 'lps'),
	(455719, 125, '2015-03-15 01:02:17.000000', 'consum', 0.0212, 'lps'),
	(455720, 125, '2015-03-15 01:02:18.000000', 'consum', 0.0214, 'lps'),
	(455721, 125, '2015-03-15 01:02:19.000000', 'consum', 0.0224, 'lps'),
	(455722, 125, '2015-03-15 01:02:20.000000', 'consum', 0.0215, 'lps'),
	(455723, 125, '2015-03-15 01:02:21.000000', 'consum', 0.0212, 'lps'),
	(455724, 125, '2015-03-15 01:02:22.000000', 'consum', 0.0224, 'lps'),
	(455725, 125, '2015-03-15 01:02:23.000000', 'consum', 0.0221, 'lps'),
	(455726, 125, '2015-03-15 01:02:24.000000', 'consum', 0.0225, 'lps'),
	(455727, 125, '2015-03-15 01:02:25.000000', 'consum', 0.0214, 'lps'),
	(455728, 125, '2015-03-15 01:02:26.000000', 'consum', 0.0221, 'lps'),
	(455729, 125, '2015-03-15 01:02:27.000000', 'consum', 0.0220, 'lps'),
	(455730, 125, '2015-03-15 01:02:28.000000', 'consum', 0.0225, 'lps'),
	(455731, 125, '2015-03-15 01:02:29.000000', 'consum', 0.0221, 'lps'),
	(455732, 125, '2015-03-15 01:02:30.000000', 'consum', 0.0219, 'lps'),
	(455733, 125, '2015-03-15 01:02:31.000000', 'consum', 0.0225, 'lps'),
	(455734, 125, '2015-03-15 01:02:32.000000', 'consum', 0.0221, 'lps'),
	(455735, 125, '2015-03-15 01:02:33.000000', 'consum', 0.0223, 'lps'),
	(455736, 125, '2015-03-15 01:02:34.000000', 'consum', 0.0221, 'lps'),
	(455737, 125, '2015-03-15 01:02:35.000000', 'consum', 0.0211, 'lps'),
	(455738, 125, '2015-03-15 01:02:36.000000', 'consum', 0.0219, 'lps'),
	(455739, 125, '2015-03-15 01:02:37.000000', 'consum', 0.0217, 'lps'),
	(455740, 125, '2015-03-15 01:02:38.000000', 'consum', 0.0219, 'lps'),
	(455741, 125, '2015-03-15 01:02:39.000000', 'consum', 0.0216, 'lps'),
	(455742, 125, '2015-03-15 01:02:40.000000', 'consum', 0.0215, 'lps'),
	(455743, 125, '2015-03-15 01:02:41.000000', 'consum', 0.0216, 'lps'),
	(455744, 125, '2015-03-15 01:02:42.000000', 'consum', 0.0224, 'lps'),
	(455745, 125, '2015-03-15 01:02:43.000000', 'consum', 0.0226, 'lps'),
	(455746, 125, '2015-03-15 01:02:44.000000', 'consum', 0.0212, 'lps'),
	(455747, 125, '2015-03-15 01:02:45.000000', 'consum', 0.0210, 'lps'),
	(455748, 125, '2015-03-15 01:02:46.000000', 'consum', 0.0223, 'lps'),
	(455749, 125, '2015-03-15 01:02:47.000000', 'consum', 0.0219, 'lps'),
	(455750, 125, '2015-03-15 01:02:48.000000', 'consum', 0.0220, 'lps'),
	(455751, 125, '2015-03-15 01:02:49.000000', 'consum', 0.0214, 'lps'),
	(455752, 125, '2015-03-15 01:02:50.000000', 'consum', 0.0217, 'lps'),
	(455753, 125, '2015-03-15 01:02:51.000000', 'consum', 0.0217, 'lps'),
	(455754, 125, '2015-03-15 01:02:52.000000', 'consum', 0.0224, 'lps'),
	(455755, 125, '2015-03-15 01:02:53.000000', 'consum', 0.0222, 'lps'),
	(455756, 125, '2015-03-15 01:02:54.000000', 'consum', 0.0211, 'lps'),
	(455757, 125, '2015-03-15 01:02:55.000000', 'consum', 0.0217, 'lps'),
	(455758, 125, '2015-03-15 01:02:56.000000', 'consum', 0.0222, 'lps'),
	(455759, 125, '2015-03-15 01:02:57.000000', 'consum', 0.0213, 'lps'),
	(455760, 125, '2015-03-15 01:02:58.000000', 'consum', 0.0227, 'lps'),
	(455761, 125, '2015-03-15 01:02:59.000000', 'consum', 0.0215, 'lps'),
	(455762, 125, '2015-03-15 01:03:00.000000', 'consum', 0.0221, 'lps'),
	(455763, 125, '2015-03-15 01:03:01.000000', 'consum', 0.0214, 'lps'),
	(455764, 125, '2015-03-15 01:03:02.000000', 'consum', 0.0215, 'lps'),
	(455765, 125, '2015-03-15 01:03:03.000000', 'consum', 0.0223, 'lps'),
	(455766, 125, '2015-03-15 01:03:04.000000', 'consum', 0.0227, 'lps'),
	(455767, 125, '2015-03-15 01:03:05.000000', 'consum', 0.0217, 'lps'),
	(455768, 125, '2015-03-15 01:03:06.000000', 'consum', 0.0215, 'lps'),
	(455769, 125, '2015-03-15 01:03:07.000000', 'consum', 0.0213, 'lps'),
	(455770, 125, '2015-03-15 01:03:08.000000', 'consum', 0.0210, 'lps'),
	(455771, 125, '2015-03-15 01:03:09.000000', 'consum', 0.0218, 'lps'),
	(455772, 125, '2015-03-15 01:03:10.000000', 'consum', 0.0217, 'lps'),
	(455773, 125, '2015-03-15 01:03:11.000000', 'consum', 0.0222, 'lps'),
	(455774, 125, '2015-03-15 01:03:12.000000', 'consum', 0.0214, 'lps'),
	(455775, 125, '2015-03-15 01:03:13.000000', 'consum', 0.0212, 'lps'),
	(455776, 125, '2015-03-15 01:03:14.000000', 'consum', 0.0225, 'lps'),
	(455777, 125, '2015-03-15 01:03:15.000000', 'consum', 0.0225, 'lps'),
	(455778, 125, '2015-03-15 01:03:16.000000', 'consum', 0.0225, 'lps'),
	(455779, 125, '2015-03-15 01:03:17.000000', 'consum', 0.0222, 'lps'),
	(455780, 125, '2015-03-15 01:03:18.000000', 'consum', 0.0223, 'lps'),
	(455781, 125, '2015-03-15 01:03:19.000000', 'consum', 0.0223, 'lps'),
	(455782, 125, '2015-03-15 01:03:20.000000', 'consum', 0.0218, 'lps'),
	(455783, 125, '2015-03-15 01:03:21.000000', 'consum', 0.0213, 'lps'),
	(455784, 125, '2015-03-15 01:03:22.000000', 'consum', 0.0220, 'lps'),
	(455785, 125, '2015-03-15 01:03:23.000000', 'consum', 0.0217, 'lps'),
	(455786, 125, '2015-03-15 01:03:24.000000', 'consum', 0.0213, 'lps'),
	(455787, 125, '2015-03-15 01:03:25.000000', 'consum', 0.0221, 'lps'),
	(455788, 125, '2015-03-15 01:03:26.000000', 'consum', 0.0222, 'lps'),
	(455789, 125, '2015-03-15 01:03:27.000000', 'consum', 0.0221, 'lps'),
	(455790, 125, '2015-03-15 01:03:28.000000', 'consum', 0.0212, 'lps'),
	(455791, 125, '2015-03-15 01:03:29.000000', 'consum', 0.0221, 'lps'),
	(455792, 125, '2015-03-15 01:03:30.000000', 'consum', 0.0225, 'lps'),
	(455793, 125, '2015-03-15 01:03:31.000000', 'consum', 0.0218, 'lps'),
	(455794, 125, '2015-03-15 01:03:32.000000', 'consum', 0.0222, 'lps'),
	(455795, 125, '2015-03-15 01:03:33.000000', 'consum', 0.0211, 'lps'),
	(455796, 125, '2015-03-15 01:03:34.000000', 'consum', 0.0214, 'lps'),
	(455797, 125, '2015-03-15 01:03:35.000000', 'consum', 0.0226, 'lps'),
	(455798, 125, '2015-03-15 01:03:36.000000', 'consum', 0.0210, 'lps'),
	(455799, 125, '2015-03-15 01:03:37.000000', 'consum', 0.0216, 'lps'),
	(455800, 125, '2015-03-15 01:03:38.000000', 'consum', 0.0224, 'lps'),
	(455801, 125, '2015-03-15 01:03:39.000000', 'consum', 0.0225, 'lps'),
	(455802, 125, '2015-03-15 01:03:40.000000', 'consum', 0.0225, 'lps'),
	(455803, 125, '2015-03-15 01:03:41.000000', 'consum', 0.0223, 'lps'),
	(455804, 125, '2015-03-15 01:03:42.000000', 'consum', 0.0213, 'lps'),
	(455805, 125, '2015-03-15 01:03:43.000000', 'consum', 0.0220, 'lps'),
	(455806, 125, '2015-03-15 01:03:44.000000', 'consum', 0.0218, 'lps'),
	(455807, 125, '2015-03-15 01:03:45.000000', 'consum', 0.0220, 'lps'),
	(455808, 125, '2015-03-15 01:03:46.000000', 'consum', 0.0220, 'lps'),
	(455809, 125, '2015-03-15 01:03:47.000000', 'consum', 0.0212, 'lps'),
	(455810, 125, '2015-03-15 01:03:48.000000', 'consum', 0.0226, 'lps'),
	(455811, 125, '2015-03-15 01:03:49.000000', 'consum', 0.0211, 'lps'),
	(455812, 125, '2015-03-15 01:03:50.000000', 'consum', 0.0222, 'lps'),
	(455813, 125, '2015-03-15 01:03:51.000000', 'consum', 0.0214, 'lps'),
	(455814, 125, '2015-03-15 01:03:52.000000', 'consum', 0.0213, 'lps'),
	(455815, 125, '2015-03-15 01:03:53.000000', 'consum', 0.0212, 'lps'),
	(455816, 125, '2015-03-15 01:03:54.000000', 'consum', 0.0213, 'lps'),
	(455817, 125, '2015-03-15 01:03:55.000000', 'consum', 0.0218, 'lps'),
	(455818, 125, '2015-03-15 01:03:56.000000', 'consum', 0.0226, 'lps'),
	(455819, 125, '2015-03-15 01:03:57.000000', 'consum', 0.0210, 'lps'),
	(455820, 125, '2015-03-15 01:03:58.000000', 'consum', 0.0215, 'lps'),
	(455821, 125, '2015-03-15 01:03:59.000000', 'consum', 0.0221, 'lps'),
	(455822, 125, '2015-03-15 01:04:00.000000', 'consum', 0.0211, 'lps'),
	(455823, 125, '2015-03-15 01:04:01.000000', 'consum', 0.0221, 'lps'),
	(455824, 125, '2015-03-15 01:04:02.000000', 'consum', 0.0210, 'lps'),
	(455825, 125, '2015-03-15 01:04:03.000000', 'consum', 0.0211, 'lps'),
	(455826, 125, '2015-03-15 01:04:04.000000', 'consum', 0.0217, 'lps'),
	(455827, 125, '2015-03-15 01:04:05.000000', 'consum', 0.0222, 'lps'),
	(455828, 125, '2015-03-15 01:04:06.000000', 'consum', 0.0215, 'lps'),
	(455829, 125, '2015-03-15 01:04:07.000000', 'consum', 0.0218, 'lps'),
	(455830, 125, '2015-03-15 01:04:08.000000', 'consum', 0.0217, 'lps'),
	(455831, 125, '2015-03-15 01:04:09.000000', 'consum', 0.0219, 'lps'),
	(455832, 125, '2015-03-15 01:04:10.000000', 'consum', 0.0220, 'lps'),
	(455833, 125, '2015-03-15 01:04:11.000000', 'consum', 0.0215, 'lps'),
	(455834, 125, '2015-03-15 01:04:12.000000', 'consum', 0.0222, 'lps'),
	(455835, 125, '2015-03-15 01:04:13.000000', 'consum', 0.0219, 'lps'),
	(455836, 125, '2015-03-15 01:04:14.000000', 'consum', 0.0218, 'lps'),
	(455837, 125, '2015-03-15 01:04:15.000000', 'consum', 0.0227, 'lps'),
	(455838, 125, '2015-03-15 01:04:16.000000', 'consum', 0.0214, 'lps'),
	(455839, 125, '2015-03-15 01:04:17.000000', 'consum', 0.0219, 'lps'),
	(455840, 125, '2015-03-15 01:04:18.000000', 'consum', 0.0223, 'lps'),
	(455841, 125, '2015-03-15 01:04:19.000000', 'consum', 0.0213, 'lps'),
	(455842, 125, '2015-03-15 01:04:20.000000', 'consum', 0.0225, 'lps'),
	(455843, 125, '2015-03-15 01:04:21.000000', 'consum', 0.0219, 'lps'),
	(455844, 125, '2015-03-15 01:04:22.000000', 'consum', 0.0211, 'lps'),
	(455845, 125, '2015-03-15 01:04:23.000000', 'consum', 0.0227, 'lps'),
	(455846, 125, '2015-03-15 01:04:24.000000', 'consum', 0.0218, 'lps'),
	(455847, 125, '2015-03-15 01:04:25.000000', 'consum', 0.0218, 'lps'),
	(455848, 125, '2015-03-15 01:04:26.000000', 'consum', 0.0226, 'lps'),
	(455849, 125, '2015-03-15 01:04:27.000000', 'consum', 0.0214, 'lps'),
	(455850, 125, '2015-03-15 01:04:28.000000', 'consum', 0.0219, 'lps'),
	(455851, 125, '2015-03-15 01:04:29.000000', 'consum', 0.0226, 'lps'),
	(455852, 125, '2015-03-15 01:04:30.000000', 'consum', 0.0227, 'lps'),
	(455853, 125, '2015-03-15 01:04:31.000000', 'consum', 0.0212, 'lps'),
	(455854, 125, '2015-03-15 01:04:32.000000', 'consum', 0.0224, 'lps'),
	(455855, 125, '2015-03-15 01:04:33.000000', 'consum', 0.0221, 'lps'),
	(455856, 125, '2015-03-15 01:04:34.000000', 'consum', 0.0221, 'lps'),
	(455857, 125, '2015-03-15 01:04:35.000000', 'consum', 0.0215, 'lps'),
	(455858, 125, '2015-03-15 01:04:36.000000', 'consum', 0.0220, 'lps'),
	(455859, 125, '2015-03-15 01:04:37.000000', 'consum', 0.0211, 'lps'),
	(455860, 125, '2015-03-15 01:04:38.000000', 'consum', 0.0221, 'lps'),
	(455861, 125, '2015-03-15 01:04:39.000000', 'consum', 0.0227, 'lps'),
	(455862, 125, '2015-03-15 01:04:40.000000', 'consum', 0.0225, 'lps'),
	(455863, 125, '2015-03-15 01:04:41.000000', 'consum', 0.0218, 'lps'),
	(455864, 125, '2015-03-15 01:04:42.000000', 'consum', 0.0222, 'lps'),
	(455865, 125, '2015-03-15 01:04:43.000000', 'consum', 0.0212, 'lps'),
	(455866, 125, '2015-03-15 01:04:44.000000', 'consum', 0.0220, 'lps'),
	(455867, 125, '2015-03-15 01:04:45.000000', 'consum', 0.0220, 'lps'),
	(455868, 125, '2015-03-15 01:04:46.000000', 'consum', 0.0210, 'lps'),
	(455869, 125, '2015-03-15 01:04:47.000000', 'consum', 0.0218, 'lps'),
	(455870, 125, '2015-03-15 01:04:48.000000', 'consum', 0.0215, 'lps'),
	(455871, 125, '2015-03-15 01:04:49.000000', 'consum', 0.0227, 'lps'),
	(455872, 125, '2015-03-15 01:04:50.000000', 'consum', 0.0227, 'lps'),
	(455873, 125, '2015-03-15 01:04:51.000000', 'consum', 0.0210, 'lps'),
	(455874, 125, '2015-03-15 01:04:52.000000', 'consum', 0.0212, 'lps'),
	(455875, 125, '2015-03-15 01:04:53.000000', 'consum', 0.0221, 'lps'),
	(455876, 125, '2015-03-15 01:04:54.000000', 'consum', 0.0224, 'lps'),
	(455877, 125, '2015-03-15 01:04:55.000000', 'consum', 0.0213, 'lps'),
	(455878, 125, '2015-03-15 01:04:56.000000', 'consum', 0.0217, 'lps'),
	(455879, 125, '2015-03-15 01:04:57.000000', 'consum', 0.0218, 'lps'),
	(455880, 125, '2015-03-15 01:04:58.000000', 'consum', 0.0211, 'lps'),
	(455881, 125, '2015-03-15 01:04:59.000000', 'consum', 0.0211, 'lps'),
	(455882, 125, '2015-03-15 01:05:00.000000', 'consum', 0.0213, 'lps'),
	(455883, 125, '2015-03-15 01:05:01.000000', 'consum', 0.0222, 'lps'),
	(455884, 125, '2015-03-15 01:05:02.000000', 'consum', 0.0226, 'lps'),
	(455885, 125, '2015-03-15 01:05:03.000000', 'consum', 0.0219, 'lps'),
	(455886, 125, '2015-03-15 01:05:04.000000', 'consum', 0.0224, 'lps'),
	(455887, 125, '2015-03-15 01:05:05.000000', 'consum', 0.0220, 'lps'),
	(455888, 125, '2015-03-15 01:05:06.000000', 'consum', 0.0217, 'lps'),
	(455889, 125, '2015-03-15 01:05:07.000000', 'consum', 0.0216, 'lps'),
	(455890, 125, '2015-03-15 01:05:08.000000', 'consum', 0.0219, 'lps'),
	(455891, 125, '2015-03-15 01:05:09.000000', 'consum', 0.0221, 'lps'),
	(455892, 125, '2015-03-15 01:05:10.000000', 'consum', 0.0221, 'lps'),
	(455893, 125, '2015-03-15 01:05:11.000000', 'consum', 0.0212, 'lps'),
	(455894, 125, '2015-03-15 01:05:12.000000', 'consum', 0.0225, 'lps'),
	(455895, 125, '2015-03-15 01:05:13.000000', 'consum', 0.0226, 'lps'),
	(455896, 125, '2015-03-15 01:05:14.000000', 'consum', 0.0225, 'lps'),
	(455897, 125, '2015-03-15 01:05:15.000000', 'consum', 0.0221, 'lps'),
	(455898, 125, '2015-03-15 01:05:16.000000', 'consum', 0.0221, 'lps'),
	(455899, 125, '2015-03-15 01:05:17.000000', 'consum', 0.0214, 'lps'),
	(455900, 125, '2015-03-15 01:05:18.000000', 'consum', 0.0215, 'lps'),
	(455901, 125, '2015-03-15 01:05:19.000000', 'consum', 0.0222, 'lps'),
	(455902, 125, '2015-03-15 01:05:20.000000', 'consum', 0.0222, 'lps'),
	(455903, 125, '2015-03-15 01:05:21.000000', 'consum', 0.0216, 'lps'),
	(455904, 125, '2015-03-15 01:05:22.000000', 'consum', 0.0220, 'lps'),
	(455905, 125, '2015-03-15 01:05:23.000000', 'consum', 0.0210, 'lps'),
	(455906, 125, '2015-03-15 01:05:24.000000', 'consum', 0.0214, 'lps'),
	(455907, 125, '2015-03-15 01:05:25.000000', 'consum', 0.0212, 'lps'),
	(455908, 125, '2015-03-15 01:05:26.000000', 'consum', 0.0227, 'lps'),
	(455909, 125, '2015-03-15 01:05:27.000000', 'consum', 0.0219, 'lps'),
	(455910, 125, '2015-03-15 01:05:28.000000', 'consum', 0.0222, 'lps'),
	(455911, 125, '2015-03-15 01:05:29.000000', 'consum', 0.0226, 'lps'),
	(455912, 125, '2015-03-15 01:05:30.000000', 'consum', 0.0218, 'lps'),
	(455913, 125, '2015-03-15 01:05:31.000000', 'consum', 0.0223, 'lps'),
	(455914, 125, '2015-03-15 01:05:32.000000', 'consum', 0.0212, 'lps'),
	(455915, 125, '2015-03-15 01:05:33.000000', 'consum', 0.0219, 'lps'),
	(455916, 125, '2015-03-15 01:05:34.000000', 'consum', 0.0213, 'lps'),
	(455917, 125, '2015-03-15 01:05:35.000000', 'consum', 0.0216, 'lps'),
	(455918, 125, '2015-03-15 01:05:36.000000', 'consum', 0.0213, 'lps'),
	(455919, 125, '2015-03-15 01:05:37.000000', 'consum', 0.0226, 'lps'),
	(455920, 125, '2015-03-15 01:05:38.000000', 'consum', 0.0212, 'lps'),
	(455921, 125, '2015-03-15 01:05:39.000000', 'consum', 0.0223, 'lps'),
	(455922, 125, '2015-03-15 01:05:40.000000', 'consum', 0.0219, 'lps'),
	(455923, 125, '2015-03-15 01:05:41.000000', 'consum', 0.0214, 'lps'),
	(455924, 125, '2015-03-15 01:05:42.000000', 'consum', 0.0223, 'lps'),
	(455925, 125, '2015-03-15 01:05:43.000000', 'consum', 0.0225, 'lps'),
	(455926, 125, '2015-03-15 01:05:44.000000', 'consum', 0.0212, 'lps'),
	(455927, 125, '2015-03-15 01:05:45.000000', 'consum', 0.0210, 'lps'),
	(455928, 125, '2015-03-15 01:05:46.000000', 'consum', 0.0222, 'lps'),
	(455929, 125, '2015-03-15 01:05:47.000000', 'consum', 0.0219, 'lps'),
	(455930, 125, '2015-03-15 01:05:48.000000', 'consum', 0.0218, 'lps'),
	(455931, 125, '2015-03-15 01:05:49.000000', 'consum', 0.0222, 'lps'),
	(455932, 125, '2015-03-15 01:05:50.000000', 'consum', 0.0212, 'lps'),
	(455933, 125, '2015-03-15 01:05:51.000000', 'consum', 0.0222, 'lps'),
	(455934, 125, '2015-03-15 01:05:52.000000', 'consum', 0.0211, 'lps'),
	(455935, 125, '2015-03-15 01:05:53.000000', 'consum', 0.0215, 'lps'),
	(455936, 125, '2015-03-15 01:05:54.000000', 'consum', 0.0216, 'lps'),
	(455937, 125, '2015-03-15 01:05:55.000000', 'consum', 0.0224, 'lps'),
	(455938, 125, '2015-03-15 01:05:56.000000', 'consum', 0.0211, 'lps'),
	(455939, 125, '2015-03-15 01:05:57.000000', 'consum', 0.0224, 'lps'),
	(455940, 125, '2015-03-15 01:05:58.000000', 'consum', 0.0224, 'lps'),
	(455941, 125, '2015-03-15 01:05:59.000000', 'consum', 0.0223, 'lps'),
	(455942, 125, '2015-03-15 01:06:00.000000', 'consum', 0.0214, 'lps'),
	(455943, 125, '2015-03-15 01:06:01.000000', 'consum', 0.0226, 'lps'),
	(455944, 125, '2015-03-15 01:06:02.000000', 'consum', 0.0227, 'lps'),
	(455945, 125, '2015-03-15 01:06:03.000000', 'consum', 0.0227, 'lps'),
	(455946, 125, '2015-03-15 01:06:04.000000', 'consum', 0.0211, 'lps'),
	(455947, 125, '2015-03-15 01:06:05.000000', 'consum', 0.0219, 'lps'),
	(455948, 125, '2015-03-15 01:06:06.000000', 'consum', 0.0217, 'lps'),
	(455949, 125, '2015-03-15 01:06:07.000000', 'consum', 0.0219, 'lps'),
	(455950, 125, '2015-03-15 01:06:08.000000', 'consum', 0.0216, 'lps'),
	(455951, 125, '2015-03-15 01:06:09.000000', 'consum', 0.0211, 'lps'),
	(455952, 125, '2015-03-15 01:06:10.000000', 'consum', 0.0219, 'lps'),
	(455953, 125, '2015-03-15 01:06:11.000000', 'consum', 0.0214, 'lps'),
	(455954, 125, '2015-03-15 01:06:12.000000', 'consum', 0.0223, 'lps'),
	(455955, 125, '2015-03-15 01:06:13.000000', 'consum', 0.0210, 'lps'),
	(455956, 125, '2015-03-15 01:06:14.000000', 'consum', 0.0224, 'lps'),
	(455957, 125, '2015-03-15 01:06:15.000000', 'consum', 0.0225, 'lps'),
	(455958, 125, '2015-03-15 01:06:16.000000', 'consum', 0.0210, 'lps'),
	(455959, 125, '2015-03-15 01:06:17.000000', 'consum', 0.0221, 'lps'),
	(455960, 125, '2015-03-15 01:06:18.000000', 'consum', 0.0226, 'lps'),
	(455961, 125, '2015-03-15 01:06:19.000000', 'consum', 0.0224, 'lps'),
	(455962, 125, '2015-03-15 01:06:20.000000', 'consum', 0.0213, 'lps'),
	(455963, 125, '2015-03-15 01:06:21.000000', 'consum', 0.0220, 'lps'),
	(455964, 125, '2015-03-15 01:06:22.000000', 'consum', 0.0217, 'lps'),
	(455965, 125, '2015-03-15 01:06:23.000000', 'consum', 0.0215, 'lps'),
	(455966, 125, '2015-03-15 01:06:24.000000', 'consum', 0.0214, 'lps'),
	(455967, 125, '2015-03-15 01:06:25.000000', 'consum', 0.0214, 'lps'),
	(455968, 125, '2015-03-15 01:06:26.000000', 'consum', 0.0219, 'lps'),
	(455969, 125, '2015-03-15 01:06:27.000000', 'consum', 0.0210, 'lps'),
	(455970, 125, '2015-03-15 01:06:28.000000', 'consum', 0.0217, 'lps'),
	(455971, 125, '2015-03-15 01:06:29.000000', 'consum', 0.0210, 'lps'),
	(455972, 125, '2015-03-15 01:06:30.000000', 'consum', 0.0227, 'lps'),
	(455973, 125, '2015-03-15 01:06:31.000000', 'consum', 0.0222, 'lps'),
	(455974, 125, '2015-03-15 01:06:32.000000', 'consum', 0.0220, 'lps'),
	(455975, 125, '2015-03-15 01:06:33.000000', 'consum', 0.0223, 'lps'),
	(455976, 125, '2015-03-15 01:06:34.000000', 'consum', 0.0212, 'lps'),
	(455977, 125, '2015-03-15 01:06:35.000000', 'consum', 0.0214, 'lps'),
	(455978, 125, '2015-03-15 01:06:36.000000', 'consum', 0.0210, 'lps'),
	(455979, 125, '2015-03-15 01:06:37.000000', 'consum', 0.0217, 'lps'),
	(455980, 125, '2015-03-15 01:06:38.000000', 'consum', 0.0225, 'lps'),
	(455981, 125, '2015-03-15 01:06:39.000000', 'consum', 0.0210, 'lps'),
	(455982, 125, '2015-03-15 01:06:40.000000', 'consum', 0.0221, 'lps'),
	(455983, 125, '2015-03-15 01:06:41.000000', 'consum', 0.0212, 'lps'),
	(455984, 125, '2015-03-15 01:06:42.000000', 'consum', 0.0223, 'lps'),
	(455985, 125, '2015-03-15 01:06:43.000000', 'consum', 0.0217, 'lps'),
	(455986, 125, '2015-03-15 01:06:44.000000', 'consum', 0.0224, 'lps'),
	(455987, 125, '2015-03-15 01:06:45.000000', 'consum', 0.0223, 'lps'),
	(455988, 125, '2015-03-15 01:06:46.000000', 'consum', 0.0216, 'lps'),
	(455989, 125, '2015-03-15 01:06:47.000000', 'consum', 0.0221, 'lps'),
	(455990, 125, '2015-03-15 01:06:48.000000', 'consum', 0.0210, 'lps'),
	(455991, 125, '2015-03-15 01:06:49.000000', 'consum', 0.0215, 'lps'),
	(455992, 125, '2015-03-15 01:06:50.000000', 'consum', 0.0218, 'lps'),
	(455993, 125, '2015-03-15 01:06:51.000000', 'consum', 0.0216, 'lps'),
	(455994, 125, '2015-03-15 01:06:52.000000', 'consum', 0.0218, 'lps'),
	(455995, 125, '2015-03-15 01:06:53.000000', 'consum', 0.0213, 'lps'),
	(455996, 125, '2015-03-15 01:06:54.000000', 'consum', 0.0222, 'lps'),
	(455997, 125, '2015-03-15 01:06:55.000000', 'consum', 0.0224, 'lps'),
	(455998, 125, '2015-03-15 01:06:56.000000', 'consum', 0.0226, 'lps'),
	(455999, 125, '2015-03-15 01:06:57.000000', 'consum', 0.0214, 'lps'),
	(456000, 125, '2015-03-15 01:06:58.000000', 'consum', 0.0218, 'lps'),
	(456001, 125, '2015-03-15 01:06:59.000000', 'consum', 0.0222, 'lps'),
	(456002, 125, '2015-03-15 01:07:00.000000', 'consum', 0.0211, 'lps'),
	(456003, 125, '2015-03-15 01:07:01.000000', 'consum', 0.0214, 'lps'),
	(456004, 125, '2015-03-15 01:07:02.000000', 'consum', 0.0227, 'lps'),
	(456005, 125, '2015-03-15 01:07:03.000000', 'consum', 0.0211, 'lps'),
	(456006, 125, '2015-03-15 01:07:04.000000', 'consum', 0.0218, 'lps'),
	(456007, 125, '2015-03-15 01:07:05.000000', 'consum', 0.0213, 'lps'),
	(456008, 125, '2015-03-15 01:07:06.000000', 'consum', 0.0220, 'lps'),
	(456009, 125, '2015-03-15 01:07:07.000000', 'consum', 0.0214, 'lps'),
	(456010, 125, '2015-03-15 01:07:08.000000', 'consum', 0.0220, 'lps'),
	(456011, 125, '2015-03-15 01:07:09.000000', 'consum', 0.0214, 'lps'),
	(456012, 125, '2015-03-15 01:07:10.000000', 'consum', 0.0216, 'lps'),
	(456013, 125, '2015-03-15 01:07:11.000000', 'consum', 0.0211, 'lps'),
	(456014, 125, '2015-03-15 01:07:12.000000', 'consum', 0.0214, 'lps'),
	(456015, 125, '2015-03-15 01:07:13.000000', 'consum', 0.0227, 'lps'),
	(456016, 125, '2015-03-15 01:07:14.000000', 'consum', 0.0212, 'lps'),
	(456017, 125, '2015-03-15 01:07:15.000000', 'consum', 0.0223, 'lps'),
	(456018, 125, '2015-03-15 01:07:16.000000', 'consum', 0.0216, 'lps'),
	(456019, 125, '2015-03-15 01:07:17.000000', 'consum', 0.0218, 'lps'),
	(456020, 125, '2015-03-15 01:07:18.000000', 'consum', 0.0217, 'lps'),
	(456021, 125, '2015-03-15 01:07:19.000000', 'consum', 0.0222, 'lps'),
	(456022, 125, '2015-03-15 01:07:20.000000', 'consum', 0.0211, 'lps'),
	(456023, 125, '2015-03-15 01:07:21.000000', 'consum', 0.0218, 'lps'),
	(456024, 125, '2015-03-15 01:07:22.000000', 'consum', 0.0227, 'lps'),
	(456025, 125, '2015-03-15 01:07:23.000000', 'consum', 0.0220, 'lps'),
	(456026, 125, '2015-03-15 01:07:24.000000', 'consum', 0.0227, 'lps'),
	(456027, 125, '2015-03-15 01:07:25.000000', 'consum', 0.0212, 'lps'),
	(456028, 125, '2015-03-15 01:07:26.000000', 'consum', 0.0223, 'lps'),
	(456029, 125, '2015-03-15 01:07:27.000000', 'consum', 0.0214, 'lps'),
	(456030, 125, '2015-03-15 01:07:28.000000', 'consum', 0.0213, 'lps'),
	(456031, 125, '2015-03-15 01:07:29.000000', 'consum', 0.0210, 'lps'),
	(456032, 125, '2015-03-15 01:07:30.000000', 'consum', 0.0220, 'lps'),
	(456033, 125, '2015-03-15 01:07:31.000000', 'consum', 0.0225, 'lps'),
	(456034, 125, '2015-03-15 01:07:32.000000', 'consum', 0.0219, 'lps'),
	(456035, 125, '2015-03-15 01:07:33.000000', 'consum', 0.0227, 'lps'),
	(456036, 125, '2015-03-15 01:07:34.000000', 'consum', 0.0217, 'lps'),
	(456037, 125, '2015-03-15 01:07:35.000000', 'consum', 0.0213, 'lps'),
	(456038, 125, '2015-03-15 01:07:36.000000', 'consum', 0.0221, 'lps'),
	(456039, 125, '2015-03-15 01:07:37.000000', 'consum', 0.0220, 'lps'),
	(456040, 125, '2015-03-15 01:07:38.000000', 'consum', 0.0227, 'lps'),
	(456041, 125, '2015-03-15 01:07:39.000000', 'consum', 0.0214, 'lps'),
	(456042, 125, '2015-03-15 01:07:40.000000', 'consum', 0.0214, 'lps'),
	(456043, 125, '2015-03-15 01:07:41.000000', 'consum', 0.0219, 'lps'),
	(456044, 125, '2015-03-15 01:07:42.000000', 'consum', 0.0227, 'lps'),
	(456045, 125, '2015-03-15 01:07:43.000000', 'consum', 0.0215, 'lps'),
	(456046, 125, '2015-03-15 01:07:44.000000', 'consum', 0.0220, 'lps'),
	(456047, 125, '2015-03-15 01:07:45.000000', 'consum', 0.0226, 'lps'),
	(456048, 125, '2015-03-15 01:07:46.000000', 'consum', 0.0226, 'lps'),
	(456049, 125, '2015-03-15 01:07:47.000000', 'consum', 0.0222, 'lps'),
	(456050, 125, '2015-03-15 01:07:48.000000', 'consum', 0.0226, 'lps'),
	(456051, 125, '2015-03-15 01:07:49.000000', 'consum', 0.0217, 'lps'),
	(456052, 125, '2015-03-15 01:07:50.000000', 'consum', 0.0215, 'lps'),
	(456053, 125, '2015-03-15 01:07:51.000000', 'consum', 0.0215, 'lps'),
	(456054, 125, '2015-03-15 01:07:52.000000', 'consum', 0.0220, 'lps'),
	(456055, 125, '2015-03-15 01:07:53.000000', 'consum', 0.0211, 'lps'),
	(456056, 125, '2015-03-15 01:07:54.000000', 'consum', 0.0219, 'lps'),
	(456057, 125, '2015-03-15 01:07:55.000000', 'consum', 0.0216, 'lps'),
	(456058, 125, '2015-03-15 01:07:56.000000', 'consum', 0.0214, 'lps'),
	(456059, 125, '2015-03-15 01:07:57.000000', 'consum', 0.0211, 'lps'),
	(456060, 125, '2015-03-15 01:07:58.000000', 'consum', 0.0223, 'lps'),
	(456061, 125, '2015-03-15 01:07:59.000000', 'consum', 0.0217, 'lps'),
	(456062, 125, '2015-03-15 01:08:00.000000', 'consum', 0.0224, 'lps'),
	(456063, 125, '2015-03-15 01:08:01.000000', 'consum', 0.0226, 'lps'),
	(456064, 125, '2015-03-15 01:08:02.000000', 'consum', 0.0213, 'lps'),
	(456065, 125, '2015-03-15 01:08:03.000000', 'consum', 0.0212, 'lps'),
	(456066, 125, '2015-03-15 01:08:04.000000', 'consum', 0.0211, 'lps'),
	(456067, 125, '2015-03-15 01:08:05.000000', 'consum', 0.0211, 'lps'),
	(456068, 125, '2015-03-15 01:08:06.000000', 'consum', 0.0210, 'lps'),
	(456069, 125, '2015-03-15 01:08:07.000000', 'consum', 0.0227, 'lps'),
	(456070, 125, '2015-03-15 01:08:08.000000', 'consum', 0.0223, 'lps'),
	(456071, 125, '2015-03-15 01:08:09.000000', 'consum', 0.0226, 'lps'),
	(456072, 125, '2015-03-15 01:08:10.000000', 'consum', 0.0213, 'lps'),
	(456073, 125, '2015-03-15 01:08:11.000000', 'consum', 0.0216, 'lps'),
	(456074, 125, '2015-03-15 01:08:12.000000', 'consum', 0.0214, 'lps'),
	(456075, 125, '2015-03-15 01:08:13.000000', 'consum', 0.0211, 'lps'),
	(456076, 125, '2015-03-15 01:08:14.000000', 'consum', 0.0220, 'lps'),
	(456077, 125, '2015-03-15 01:08:15.000000', 'consum', 0.0222, 'lps'),
	(456078, 125, '2015-03-15 01:08:16.000000', 'consum', 0.0223, 'lps'),
	(456079, 125, '2015-03-15 01:08:17.000000', 'consum', 0.0220, 'lps'),
	(456080, 125, '2015-03-15 01:08:18.000000', 'consum', 0.0224, 'lps'),
	(456081, 125, '2015-03-15 01:08:19.000000', 'consum', 0.0214, 'lps'),
	(456082, 125, '2015-03-15 01:08:20.000000', 'consum', 0.0223, 'lps'),
	(456083, 125, '2015-03-15 01:08:21.000000', 'consum', 0.0210, 'lps'),
	(456084, 125, '2015-03-15 01:08:22.000000', 'consum', 0.0226, 'lps'),
	(456085, 125, '2015-03-15 01:08:23.000000', 'consum', 0.0217, 'lps'),
	(456086, 125, '2015-03-15 01:08:24.000000', 'consum', 0.0216, 'lps'),
	(456087, 125, '2015-03-15 01:08:25.000000', 'consum', 0.0220, 'lps'),
	(456088, 125, '2015-03-15 01:08:26.000000', 'consum', 0.0222, 'lps'),
	(456089, 125, '2015-03-15 01:08:27.000000', 'consum', 0.0226, 'lps'),
	(456090, 125, '2015-03-15 01:08:28.000000', 'consum', 0.0218, 'lps'),
	(456091, 125, '2015-03-15 01:08:29.000000', 'consum', 0.0221, 'lps'),
	(456092, 125, '2015-03-15 01:08:30.000000', 'consum', 0.0221, 'lps'),
	(456093, 125, '2015-03-15 01:08:31.000000', 'consum', 0.0215, 'lps'),
	(456094, 125, '2015-03-15 01:08:32.000000', 'consum', 0.0223, 'lps'),
	(456095, 125, '2015-03-15 01:08:33.000000', 'consum', 0.0222, 'lps'),
	(456096, 125, '2015-03-15 01:08:34.000000', 'consum', 0.0216, 'lps'),
	(456097, 125, '2015-03-15 01:08:35.000000', 'consum', 0.0223, 'lps'),
	(456098, 125, '2015-03-15 01:08:36.000000', 'consum', 0.0219, 'lps'),
	(456099, 125, '2015-03-15 01:08:37.000000', 'consum', 0.0215, 'lps'),
	(456100, 125, '2015-03-15 01:08:38.000000', 'consum', 0.0212, 'lps'),
	(456101, 125, '2015-03-15 01:08:39.000000', 'consum', 0.0224, 'lps'),
	(456102, 125, '2015-03-15 01:08:40.000000', 'consum', 0.0217, 'lps'),
	(456103, 125, '2015-03-15 01:08:41.000000', 'consum', 0.0224, 'lps'),
	(456104, 125, '2015-03-15 01:08:42.000000', 'consum', 0.0222, 'lps'),
	(456105, 125, '2015-03-15 01:08:43.000000', 'consum', 0.0213, 'lps'),
	(456106, 125, '2015-03-15 01:08:44.000000', 'consum', 0.0224, 'lps'),
	(456107, 125, '2015-03-15 01:08:45.000000', 'consum', 0.0218, 'lps'),
	(456108, 125, '2015-03-15 01:08:46.000000', 'consum', 0.0224, 'lps'),
	(456109, 125, '2015-03-15 01:08:47.000000', 'consum', 0.0224, 'lps'),
	(456110, 125, '2015-03-15 01:08:48.000000', 'consum', 0.0218, 'lps'),
	(456111, 125, '2015-03-15 01:08:49.000000', 'consum', 0.0211, 'lps'),
	(456112, 125, '2015-03-15 01:08:50.000000', 'consum', 0.0225, 'lps'),
	(456113, 125, '2015-03-15 01:08:51.000000', 'consum', 0.0210, 'lps'),
	(456114, 125, '2015-03-15 01:08:52.000000', 'consum', 0.0222, 'lps'),
	(456115, 125, '2015-03-15 01:08:53.000000', 'consum', 0.0216, 'lps'),
	(456116, 125, '2015-03-15 01:08:54.000000', 'consum', 0.0222, 'lps'),
	(456117, 125, '2015-03-15 01:08:55.000000', 'consum', 0.0216, 'lps'),
	(456118, 125, '2015-03-15 01:08:56.000000', 'consum', 0.0222, 'lps'),
	(456119, 125, '2015-03-15 01:08:57.000000', 'consum', 0.0219, 'lps'),
	(456120, 125, '2015-03-15 01:08:58.000000', 'consum', 0.0219, 'lps'),
	(456121, 125, '2015-03-15 01:08:59.000000', 'consum', 0.0227, 'lps'),
	(456122, 125, '2015-03-15 01:09:00.000000', 'consum', 0.0215, 'lps'),
	(456123, 125, '2015-03-15 01:09:01.000000', 'consum', 0.0220, 'lps'),
	(456124, 125, '2015-03-15 01:09:02.000000', 'consum', 0.0210, 'lps'),
	(456125, 125, '2015-03-15 01:09:03.000000', 'consum', 0.0217, 'lps'),
	(456126, 125, '2015-03-15 01:09:04.000000', 'consum', 0.0210, 'lps'),
	(456127, 125, '2015-03-15 01:09:05.000000', 'consum', 0.0223, 'lps'),
	(456128, 125, '2015-03-15 01:09:06.000000', 'consum', 0.0224, 'lps'),
	(456129, 125, '2015-03-15 01:09:07.000000', 'consum', 0.0222, 'lps'),
	(456130, 125, '2015-03-15 01:09:08.000000', 'consum', 0.0211, 'lps'),
	(456131, 125, '2015-03-15 01:09:09.000000', 'consum', 0.0216, 'lps'),
	(456132, 125, '2015-03-15 01:09:10.000000', 'consum', 0.0220, 'lps'),
	(456133, 125, '2015-03-15 01:09:11.000000', 'consum', 0.0226, 'lps'),
	(456134, 125, '2015-03-15 01:09:12.000000', 'consum', 0.0222, 'lps'),
	(456135, 125, '2015-03-15 01:09:13.000000', 'consum', 0.0223, 'lps'),
	(456136, 125, '2015-03-15 01:09:14.000000', 'consum', 0.0220, 'lps'),
	(456137, 125, '2015-03-15 01:09:15.000000', 'consum', 0.0221, 'lps'),
	(456138, 125, '2015-03-15 01:09:16.000000', 'consum', 0.0220, 'lps'),
	(456139, 125, '2015-03-15 01:09:17.000000', 'consum', 0.0210, 'lps'),
	(456140, 125, '2015-03-15 01:09:18.000000', 'consum', 0.0215, 'lps'),
	(456141, 125, '2015-03-15 01:09:19.000000', 'consum', 0.0218, 'lps'),
	(456142, 125, '2015-03-15 01:09:20.000000', 'consum', 0.0216, 'lps'),
	(456143, 125, '2015-03-15 01:09:21.000000', 'consum', 0.0216, 'lps'),
	(456144, 125, '2015-03-15 01:09:22.000000', 'consum', 0.0225, 'lps'),
	(456145, 125, '2015-03-15 01:09:23.000000', 'consum', 0.0211, 'lps'),
	(456146, 125, '2015-03-15 01:09:24.000000', 'consum', 0.0227, 'lps'),
	(456147, 125, '2015-03-15 01:09:25.000000', 'consum', 0.0218, 'lps'),
	(456148, 125, '2015-03-15 01:09:26.000000', 'consum', 0.0217, 'lps'),
	(456149, 125, '2015-03-15 01:09:27.000000', 'consum', 0.0225, 'lps'),
	(456150, 125, '2015-03-15 01:09:28.000000', 'consum', 0.0225, 'lps'),
	(456151, 125, '2015-03-15 01:09:29.000000', 'consum', 0.0226, 'lps'),
	(456152, 125, '2015-03-15 01:09:30.000000', 'consum', 0.0224, 'lps'),
	(456153, 125, '2015-03-15 01:09:31.000000', 'consum', 0.0217, 'lps'),
	(456154, 125, '2015-03-15 01:09:32.000000', 'consum', 0.0221, 'lps'),
	(456155, 125, '2015-03-15 01:09:33.000000', 'consum', 0.0226, 'lps'),
	(456156, 125, '2015-03-15 01:09:34.000000', 'consum', 0.0223, 'lps'),
	(456157, 125, '2015-03-15 01:09:35.000000', 'consum', 0.0210, 'lps'),
	(456158, 125, '2015-03-15 01:09:36.000000', 'consum', 0.0225, 'lps'),
	(456159, 125, '2015-03-15 01:09:37.000000', 'consum', 0.0214, 'lps'),
	(456160, 125, '2015-03-15 01:09:38.000000', 'consum', 0.0222, 'lps'),
	(456161, 125, '2015-03-15 01:09:39.000000', 'consum', 0.0221, 'lps'),
	(456162, 125, '2015-03-15 01:09:40.000000', 'consum', 0.0211, 'lps'),
	(456163, 125, '2015-03-15 01:09:41.000000', 'consum', 0.0219, 'lps'),
	(456164, 125, '2015-03-15 01:09:42.000000', 'consum', 0.0217, 'lps'),
	(456165, 125, '2015-03-15 01:09:43.000000', 'consum', 0.0220, 'lps'),
	(456166, 125, '2015-03-15 01:09:44.000000', 'consum', 0.0219, 'lps'),
	(456167, 125, '2015-03-15 01:09:45.000000', 'consum', 0.0226, 'lps'),
	(456168, 125, '2015-03-15 01:09:46.000000', 'consum', 0.0226, 'lps'),
	(456169, 125, '2015-03-15 01:09:47.000000', 'consum', 0.0225, 'lps'),
	(456170, 125, '2015-03-15 01:09:48.000000', 'consum', 0.0220, 'lps'),
	(456171, 125, '2015-03-15 01:09:49.000000', 'consum', 0.0215, 'lps'),
	(456172, 125, '2015-03-15 01:09:50.000000', 'consum', 0.0223, 'lps'),
	(456173, 125, '2015-03-15 01:09:51.000000', 'consum', 0.0223, 'lps'),
	(456174, 125, '2015-03-15 01:09:52.000000', 'consum', 0.0221, 'lps'),
	(456175, 125, '2015-03-15 01:09:53.000000', 'consum', 0.0226, 'lps'),
	(456176, 125, '2015-03-15 01:09:54.000000', 'consum', 0.0220, 'lps'),
	(456177, 125, '2015-03-15 01:09:55.000000', 'consum', 0.0214, 'lps'),
	(456178, 125, '2015-03-15 01:09:56.000000', 'consum', 0.0218, 'lps'),
	(456179, 125, '2015-03-15 01:09:57.000000', 'consum', 0.0222, 'lps'),
	(456180, 125, '2015-03-15 01:09:58.000000', 'consum', 0.0226, 'lps'),
	(456181, 125, '2015-03-15 01:09:59.000000', 'consum', 0.0219, 'lps'),
	(456182, 125, '2015-03-15 01:10:00.000000', 'consum', 0.0226, 'lps'),
	(456183, 125, '2015-03-15 01:10:01.000000', 'consum', 0.0210, 'lps'),
	(456184, 125, '2015-03-15 01:10:02.000000', 'consum', 0.0217, 'lps'),
	(456185, 125, '2015-03-15 01:10:03.000000', 'consum', 0.0227, 'lps'),
	(456186, 125, '2015-03-15 01:10:04.000000', 'consum', 0.0221, 'lps'),
	(456187, 125, '2015-03-15 01:10:05.000000', 'consum', 0.0214, 'lps'),
	(456188, 125, '2015-03-15 01:10:06.000000', 'consum', 0.0214, 'lps'),
	(456189, 125, '2015-03-15 01:10:07.000000', 'consum', 0.0218, 'lps'),
	(456190, 125, '2015-03-15 01:10:08.000000', 'consum', 0.0223, 'lps'),
	(456191, 125, '2015-03-15 01:10:09.000000', 'consum', 0.0214, 'lps'),
	(456192, 125, '2015-03-15 01:10:10.000000', 'consum', 0.0211, 'lps'),
	(456193, 125, '2015-03-15 01:10:11.000000', 'consum', 0.0220, 'lps'),
	(456194, 125, '2015-03-15 01:10:12.000000', 'consum', 0.0220, 'lps'),
	(456195, 125, '2015-03-15 01:10:13.000000', 'consum', 0.0216, 'lps'),
	(456196, 125, '2015-03-15 01:10:14.000000', 'consum', 0.0225, 'lps'),
	(456197, 125, '2015-03-15 01:10:15.000000', 'consum', 0.0217, 'lps'),
	(456198, 125, '2015-03-15 01:10:16.000000', 'consum', 0.0216, 'lps'),
	(456199, 125, '2015-03-15 01:10:17.000000', 'consum', 0.0218, 'lps'),
	(456200, 125, '2015-03-15 01:10:18.000000', 'consum', 0.0217, 'lps'),
	(456201, 125, '2015-03-15 01:10:19.000000', 'consum', 0.0221, 'lps'),
	(456202, 125, '2015-03-15 01:10:20.000000', 'consum', 0.0210, 'lps'),
	(456203, 125, '2015-03-15 01:10:21.000000', 'consum', 0.0214, 'lps'),
	(456204, 125, '2015-03-15 01:10:22.000000', 'consum', 0.0211, 'lps'),
	(456205, 125, '2015-03-15 01:10:23.000000', 'consum', 0.0222, 'lps'),
	(456206, 125, '2015-03-15 01:10:24.000000', 'consum', 0.0212, 'lps'),
	(456207, 125, '2015-03-15 01:10:25.000000', 'consum', 0.0220, 'lps'),
	(456208, 125, '2015-03-15 01:10:26.000000', 'consum', 0.0218, 'lps'),
	(456209, 125, '2015-03-15 01:10:27.000000', 'consum', 0.0222, 'lps'),
	(456210, 125, '2015-03-15 01:10:28.000000', 'consum', 0.0211, 'lps'),
	(456211, 125, '2015-03-15 01:10:29.000000', 'consum', 0.0215, 'lps'),
	(456212, 125, '2015-03-15 01:10:30.000000', 'consum', 0.0212, 'lps'),
	(456213, 125, '2015-03-15 01:10:31.000000', 'consum', 0.0227, 'lps'),
	(456214, 125, '2015-03-15 01:10:32.000000', 'consum', 0.0216, 'lps'),
	(456215, 125, '2015-03-15 01:10:33.000000', 'consum', 0.0226, 'lps'),
	(456216, 125, '2015-03-15 01:10:34.000000', 'consum', 0.0219, 'lps'),
	(456217, 125, '2015-03-15 01:10:35.000000', 'consum', 0.0225, 'lps'),
	(456218, 125, '2015-03-15 01:10:36.000000', 'consum', 0.0223, 'lps'),
	(456219, 125, '2015-03-15 01:10:37.000000', 'consum', 0.0214, 'lps'),
	(456220, 125, '2015-03-15 01:10:38.000000', 'consum', 0.0224, 'lps'),
	(456221, 125, '2015-03-15 01:10:39.000000', 'consum', 0.0217, 'lps'),
	(456222, 125, '2015-03-15 01:10:40.000000', 'consum', 0.0220, 'lps'),
	(456223, 125, '2015-03-15 01:10:41.000000', 'consum', 0.0220, 'lps'),
	(456224, 125, '2015-03-15 01:10:42.000000', 'consum', 0.0215, 'lps'),
	(456225, 125, '2015-03-15 01:10:43.000000', 'consum', 0.0223, 'lps'),
	(456226, 125, '2015-03-15 01:10:44.000000', 'consum', 0.0223, 'lps'),
	(456227, 125, '2015-03-15 01:10:45.000000', 'consum', 0.0219, 'lps'),
	(456228, 125, '2015-03-15 01:10:46.000000', 'consum', 0.0219, 'lps'),
	(456229, 125, '2015-03-15 01:10:47.000000', 'consum', 0.0226, 'lps'),
	(456230, 125, '2015-03-15 01:10:48.000000', 'consum', 0.0210, 'lps'),
	(456231, 125, '2015-03-15 01:10:49.000000', 'consum', 0.0217, 'lps'),
	(456232, 125, '2015-03-15 01:10:50.000000', 'consum', 0.0226, 'lps'),
	(456233, 125, '2015-03-15 01:10:51.000000', 'consum', 0.0217, 'lps'),
	(456234, 125, '2015-03-15 01:10:52.000000', 'consum', 0.0214, 'lps'),
	(456235, 125, '2015-03-15 01:10:53.000000', 'consum', 0.0212, 'lps'),
	(456236, 125, '2015-03-15 01:10:54.000000', 'consum', 0.0225, 'lps'),
	(456237, 125, '2015-03-15 01:10:55.000000', 'consum', 0.0225, 'lps'),
	(456238, 125, '2015-03-15 01:10:56.000000', 'consum', 0.0223, 'lps'),
	(456239, 125, '2015-03-15 01:10:57.000000', 'consum', 0.0212, 'lps'),
	(456240, 125, '2015-03-15 01:10:58.000000', 'consum', 0.0219, 'lps'),
	(456241, 125, '2015-03-15 01:10:59.000000', 'consum', 0.0211, 'lps'),
	(456242, 125, '2015-03-15 01:11:00.000000', 'consum', 0.0227, 'lps'),
	(456243, 125, '2015-03-15 01:11:01.000000', 'consum', 0.0220, 'lps'),
	(456244, 125, '2015-03-15 01:11:02.000000', 'consum', 0.0227, 'lps'),
	(456245, 125, '2015-03-15 01:11:03.000000', 'consum', 0.0213, 'lps'),
	(456246, 125, '2015-03-15 01:11:04.000000', 'consum', 0.0226, 'lps'),
	(456247, 125, '2015-03-15 01:11:05.000000', 'consum', 0.0212, 'lps'),
	(456248, 125, '2015-03-15 01:11:06.000000', 'consum', 0.0226, 'lps'),
	(456249, 125, '2015-03-15 01:11:07.000000', 'consum', 0.0213, 'lps'),
	(456250, 125, '2015-03-15 01:11:08.000000', 'consum', 0.0214, 'lps'),
	(456251, 125, '2015-03-15 01:11:09.000000', 'consum', 0.0219, 'lps'),
	(456252, 125, '2015-03-15 01:11:10.000000', 'consum', 0.0227, 'lps'),
	(456253, 125, '2015-03-15 01:11:11.000000', 'consum', 0.0216, 'lps'),
	(456254, 125, '2015-03-15 01:11:12.000000', 'consum', 0.0224, 'lps'),
	(456255, 125, '2015-03-15 01:11:13.000000', 'consum', 0.0227, 'lps'),
	(456256, 125, '2015-03-15 01:11:14.000000', 'consum', 0.0219, 'lps'),
	(456257, 125, '2015-03-15 01:11:15.000000', 'consum', 0.0221, 'lps'),
	(456258, 125, '2015-03-15 01:11:16.000000', 'consum', 0.0219, 'lps'),
	(456259, 125, '2015-03-15 01:11:17.000000', 'consum', 0.0224, 'lps'),
	(456260, 125, '2015-03-15 01:11:18.000000', 'consum', 0.0219, 'lps'),
	(456261, 125, '2015-03-15 01:11:19.000000', 'consum', 0.0212, 'lps'),
	(456262, 125, '2015-03-15 01:11:20.000000', 'consum', 0.0212, 'lps'),
	(456263, 125, '2015-03-15 01:11:21.000000', 'consum', 0.0215, 'lps'),
	(456264, 125, '2015-03-15 01:11:22.000000', 'consum', 0.0211, 'lps'),
	(456265, 125, '2015-03-15 01:11:23.000000', 'consum', 0.0220, 'lps'),
	(456266, 125, '2015-03-15 01:11:24.000000', 'consum', 0.0219, 'lps'),
	(456267, 125, '2015-03-15 01:11:25.000000', 'consum', 0.0225, 'lps'),
	(456268, 125, '2015-03-15 01:11:26.000000', 'consum', 0.0225, 'lps'),
	(456269, 125, '2015-03-15 01:11:27.000000', 'consum', 0.0220, 'lps'),
	(456270, 125, '2015-03-15 01:11:28.000000', 'consum', 0.0215, 'lps'),
	(456271, 125, '2015-03-15 01:11:29.000000', 'consum', 0.0224, 'lps'),
	(456272, 125, '2015-03-15 01:11:30.000000', 'consum', 0.0212, 'lps'),
	(456273, 125, '2015-03-15 01:11:31.000000', 'consum', 0.0213, 'lps'),
	(456274, 125, '2015-03-15 01:11:32.000000', 'consum', 0.0219, 'lps'),
	(456275, 125, '2015-03-15 01:11:33.000000', 'consum', 0.0212, 'lps'),
	(456276, 125, '2015-03-15 01:11:34.000000', 'consum', 0.0212, 'lps'),
	(456277, 125, '2015-03-15 01:11:35.000000', 'consum', 0.0214, 'lps'),
	(456278, 125, '2015-03-15 01:11:36.000000', 'consum', 0.0223, 'lps'),
	(456279, 125, '2015-03-15 01:11:37.000000', 'consum', 0.0211, 'lps'),
	(456280, 125, '2015-03-15 01:11:38.000000', 'consum', 0.0214, 'lps'),
	(456281, 125, '2015-03-15 01:11:39.000000', 'consum', 0.0224, 'lps'),
	(456282, 125, '2015-03-15 01:11:40.000000', 'consum', 0.0218, 'lps'),
	(456283, 125, '2015-03-15 01:11:41.000000', 'consum', 0.0224, 'lps'),
	(456284, 125, '2015-03-15 01:11:42.000000', 'consum', 0.0223, 'lps'),
	(456285, 125, '2015-03-15 01:11:43.000000', 'consum', 0.0213, 'lps'),
	(456286, 125, '2015-03-15 01:11:44.000000', 'consum', 0.0223, 'lps'),
	(456287, 125, '2015-03-15 01:11:45.000000', 'consum', 0.0212, 'lps'),
	(456288, 125, '2015-03-15 01:11:46.000000', 'consum', 0.0219, 'lps'),
	(456289, 125, '2015-03-15 01:11:47.000000', 'consum', 0.0214, 'lps'),
	(456290, 125, '2015-03-15 01:11:48.000000', 'consum', 0.0220, 'lps'),
	(456291, 125, '2015-03-15 01:11:49.000000', 'consum', 0.0214, 'lps'),
	(456292, 125, '2015-03-15 01:11:50.000000', 'consum', 0.0217, 'lps'),
	(456293, 125, '2015-03-15 01:11:51.000000', 'consum', 0.0218, 'lps'),
	(456294, 125, '2015-03-15 01:11:52.000000', 'consum', 0.0227, 'lps'),
	(456295, 125, '2015-03-15 01:11:53.000000', 'consum', 0.0220, 'lps'),
	(456296, 125, '2015-03-15 01:11:54.000000', 'consum', 0.0210, 'lps'),
	(456297, 125, '2015-03-15 01:11:55.000000', 'consum', 0.0215, 'lps'),
	(456298, 125, '2015-03-15 01:11:56.000000', 'consum', 0.0216, 'lps'),
	(456299, 125, '2015-03-15 01:11:57.000000', 'consum', 0.0225, 'lps'),
	(456300, 125, '2015-03-15 01:11:58.000000', 'consum', 0.0215, 'lps'),
	(456301, 125, '2015-03-15 01:11:59.000000', 'consum', 0.0224, 'lps'),
	(456302, 125, '2015-03-15 01:12:00.000000', 'consum', 0.0214, 'lps'),
	(456303, 125, '2015-03-15 01:12:01.000000', 'consum', 0.0226, 'lps'),
	(456304, 125, '2015-03-15 01:12:02.000000', 'consum', 0.0222, 'lps'),
	(456305, 125, '2015-03-15 01:12:03.000000', 'consum', 0.0223, 'lps'),
	(456306, 125, '2015-03-15 01:12:04.000000', 'consum', 0.0221, 'lps'),
	(456307, 125, '2015-03-15 01:12:05.000000', 'consum', 0.0211, 'lps'),
	(456308, 125, '2015-03-15 01:12:06.000000', 'consum', 0.0216, 'lps'),
	(456309, 125, '2015-03-15 01:12:07.000000', 'consum', 0.0220, 'lps'),
	(456310, 125, '2015-03-15 01:12:08.000000', 'consum', 0.0226, 'lps'),
	(456311, 125, '2015-03-15 01:12:09.000000', 'consum', 0.0223, 'lps'),
	(456312, 125, '2015-03-15 01:12:10.000000', 'consum', 0.0210, 'lps'),
	(456313, 125, '2015-03-15 01:12:11.000000', 'consum', 0.0227, 'lps'),
	(456314, 125, '2015-03-15 01:12:12.000000', 'consum', 0.0221, 'lps'),
	(456315, 125, '2015-03-15 01:12:13.000000', 'consum', 0.0213, 'lps'),
	(456316, 125, '2015-03-15 01:12:14.000000', 'consum', 0.0214, 'lps'),
	(456317, 125, '2015-03-15 01:12:15.000000', 'consum', 0.0220, 'lps'),
	(456318, 125, '2015-03-15 01:12:16.000000', 'consum', 0.0212, 'lps'),
	(456319, 125, '2015-03-15 01:12:17.000000', 'consum', 0.0227, 'lps'),
	(456320, 125, '2015-03-15 01:12:18.000000', 'consum', 0.0217, 'lps'),
	(456321, 125, '2015-03-15 01:12:19.000000', 'consum', 0.0213, 'lps'),
	(456322, 125, '2015-03-15 01:12:20.000000', 'consum', 0.0223, 'lps'),
	(456323, 125, '2015-03-15 01:12:21.000000', 'consum', 0.0211, 'lps'),
	(456324, 125, '2015-03-15 01:12:22.000000', 'consum', 0.0212, 'lps'),
	(456325, 125, '2015-03-15 01:12:23.000000', 'consum', 0.0219, 'lps'),
	(456326, 125, '2015-03-15 01:12:24.000000', 'consum', 0.0212, 'lps'),
	(456327, 125, '2015-03-15 01:12:25.000000', 'consum', 0.0211, 'lps'),
	(456328, 125, '2015-03-15 01:12:26.000000', 'consum', 0.0212, 'lps'),
	(456329, 125, '2015-03-15 01:12:27.000000', 'consum', 0.0218, 'lps'),
	(456330, 125, '2015-03-15 01:12:28.000000', 'consum', 0.0224, 'lps'),
	(456331, 125, '2015-03-15 01:12:29.000000', 'consum', 0.0221, 'lps'),
	(456332, 125, '2015-03-15 01:12:30.000000', 'consum', 0.0222, 'lps'),
	(456333, 125, '2015-03-15 01:12:31.000000', 'consum', 0.0220, 'lps'),
	(456334, 125, '2015-03-15 01:12:32.000000', 'consum', 0.0227, 'lps'),
	(456335, 125, '2015-03-15 01:12:33.000000', 'consum', 0.0226, 'lps'),
	(456336, 125, '2015-03-15 01:12:34.000000', 'consum', 0.0224, 'lps'),
	(456337, 125, '2015-03-15 01:12:35.000000', 'consum', 0.0212, 'lps'),
	(456338, 125, '2015-03-15 01:12:36.000000', 'consum', 0.0216, 'lps'),
	(456339, 125, '2015-03-15 01:12:37.000000', 'consum', 0.0217, 'lps'),
	(456340, 125, '2015-03-15 01:12:38.000000', 'consum', 0.0210, 'lps'),
	(456341, 125, '2015-03-15 01:12:39.000000', 'consum', 0.0226, 'lps'),
	(456342, 125, '2015-03-15 01:12:40.000000', 'consum', 0.0216, 'lps'),
	(456343, 125, '2015-03-15 01:12:41.000000', 'consum', 0.0212, 'lps'),
	(456344, 125, '2015-03-15 01:12:42.000000', 'consum', 0.0219, 'lps'),
	(456345, 125, '2015-03-15 01:12:43.000000', 'consum', 0.0214, 'lps'),
	(456346, 125, '2015-03-15 01:12:44.000000', 'consum', 0.0220, 'lps'),
	(456347, 125, '2015-03-15 01:12:45.000000', 'consum', 0.0212, 'lps'),
	(456348, 125, '2015-03-15 01:12:46.000000', 'consum', 0.0212, 'lps'),
	(456349, 125, '2015-03-15 01:12:47.000000', 'consum', 0.0211, 'lps'),
	(456350, 125, '2015-03-15 01:12:48.000000', 'consum', 0.0213, 'lps'),
	(456351, 125, '2015-03-15 01:12:49.000000', 'consum', 0.0221, 'lps'),
	(456352, 125, '2015-03-15 01:12:50.000000', 'consum', 0.0220, 'lps'),
	(456353, 125, '2015-03-15 01:12:51.000000', 'consum', 0.0227, 'lps'),
	(456354, 125, '2015-03-15 01:12:52.000000', 'consum', 0.0210, 'lps'),
	(456355, 125, '2015-03-15 01:12:53.000000', 'consum', 0.0215, 'lps'),
	(456356, 125, '2015-03-15 01:12:54.000000', 'consum', 0.0217, 'lps'),
	(456357, 125, '2015-03-15 01:12:55.000000', 'consum', 0.0213, 'lps'),
	(456358, 125, '2015-03-15 01:12:56.000000', 'consum', 0.0224, 'lps'),
	(456359, 125, '2015-03-15 01:12:57.000000', 'consum', 0.0216, 'lps'),
	(456360, 125, '2015-03-15 01:12:58.000000', 'consum', 0.0217, 'lps'),
	(456361, 125, '2015-03-15 01:12:59.000000', 'consum', 0.0226, 'lps'),
	(456362, 125, '2015-03-15 01:13:00.000000', 'consum', 0.0216, 'lps'),
	(456363, 125, '2015-03-15 01:13:01.000000', 'consum', 0.0212, 'lps'),
	(456364, 125, '2015-03-15 01:13:02.000000', 'consum', 0.0221, 'lps'),
	(456365, 125, '2015-03-15 01:13:03.000000', 'consum', 0.0221, 'lps'),
	(456366, 125, '2015-03-15 01:13:04.000000', 'consum', 0.0213, 'lps'),
	(456367, 125, '2015-03-15 01:13:05.000000', 'consum', 0.0214, 'lps'),
	(456368, 125, '2015-03-15 01:13:06.000000', 'consum', 0.0221, 'lps'),
	(456369, 125, '2015-03-15 01:13:07.000000', 'consum', 0.0218, 'lps'),
	(456370, 125, '2015-03-15 01:13:08.000000', 'consum', 0.0219, 'lps'),
	(456371, 125, '2015-03-15 01:13:09.000000', 'consum', 0.0212, 'lps'),
	(456372, 125, '2015-03-15 01:13:10.000000', 'consum', 0.0210, 'lps'),
	(456373, 125, '2015-03-15 01:13:11.000000', 'consum', 0.0223, 'lps'),
	(456374, 125, '2015-03-15 01:13:12.000000', 'consum', 0.0223, 'lps'),
	(456375, 125, '2015-03-15 01:13:13.000000', 'consum', 0.0216, 'lps'),
	(456376, 125, '2015-03-15 01:13:14.000000', 'consum', 0.0220, 'lps'),
	(456377, 125, '2015-03-15 01:13:15.000000', 'consum', 0.0225, 'lps'),
	(456378, 125, '2015-03-15 01:13:16.000000', 'consum', 0.0219, 'lps'),
	(456379, 125, '2015-03-15 01:13:17.000000', 'consum', 0.0210, 'lps'),
	(456380, 125, '2015-03-15 01:13:18.000000', 'consum', 0.0222, 'lps'),
	(456381, 125, '2015-03-15 01:13:19.000000', 'consum', 0.0214, 'lps'),
	(456382, 125, '2015-03-15 01:13:20.000000', 'consum', 0.0213, 'lps'),
	(456383, 125, '2015-03-15 01:13:21.000000', 'consum', 0.0212, 'lps'),
	(456384, 125, '2015-03-15 01:13:22.000000', 'consum', 0.0214, 'lps'),
	(456385, 125, '2015-03-15 01:13:23.000000', 'consum', 0.0222, 'lps'),
	(456386, 125, '2015-03-15 01:13:24.000000', 'consum', 0.0222, 'lps'),
	(456387, 125, '2015-03-15 01:13:25.000000', 'consum', 0.0219, 'lps'),
	(456388, 125, '2015-03-15 01:13:26.000000', 'consum', 0.0219, 'lps'),
	(456389, 125, '2015-03-15 01:13:27.000000', 'consum', 0.0210, 'lps'),
	(456390, 125, '2015-03-15 01:13:28.000000', 'consum', 0.0219, 'lps'),
	(456391, 125, '2015-03-15 01:13:29.000000', 'consum', 0.0220, 'lps'),
	(456392, 125, '2015-03-15 01:13:30.000000', 'consum', 0.0214, 'lps'),
	(456393, 125, '2015-03-15 01:13:31.000000', 'consum', 0.0220, 'lps'),
	(456394, 125, '2015-03-15 01:13:32.000000', 'consum', 0.0214, 'lps'),
	(456395, 125, '2015-03-15 01:13:33.000000', 'consum', 0.0217, 'lps'),
	(456396, 125, '2015-03-15 01:13:34.000000', 'consum', 0.0218, 'lps'),
	(456397, 125, '2015-03-15 01:13:35.000000', 'consum', 0.0227, 'lps'),
	(456398, 125, '2015-03-15 01:13:36.000000', 'consum', 0.0217, 'lps'),
	(456399, 125, '2015-03-15 01:13:37.000000', 'consum', 0.0215, 'lps'),
	(456400, 125, '2015-03-15 01:13:38.000000', 'consum', 0.0214, 'lps'),
	(456401, 125, '2015-03-15 01:13:39.000000', 'consum', 0.0217, 'lps'),
	(456402, 125, '2015-03-15 01:13:40.000000', 'consum', 0.0214, 'lps'),
	(456403, 125, '2015-03-15 01:13:41.000000', 'consum', 0.0226, 'lps'),
	(456404, 125, '2015-03-15 01:13:42.000000', 'consum', 0.0227, 'lps'),
	(456405, 125, '2015-03-15 01:13:43.000000', 'consum', 0.0210, 'lps'),
	(456406, 125, '2015-03-15 01:13:44.000000', 'consum', 0.0214, 'lps'),
	(456407, 125, '2015-03-15 01:13:45.000000', 'consum', 0.0213, 'lps'),
	(456408, 125, '2015-03-15 01:13:46.000000', 'consum', 0.0214, 'lps'),
	(456409, 125, '2015-03-15 01:13:47.000000', 'consum', 0.0222, 'lps'),
	(456410, 125, '2015-03-15 01:13:48.000000', 'consum', 0.0222, 'lps'),
	(456411, 125, '2015-03-15 01:13:49.000000', 'consum', 0.0216, 'lps'),
	(456412, 125, '2015-03-15 01:13:50.000000', 'consum', 0.0222, 'lps'),
	(456413, 125, '2015-03-15 01:13:51.000000', 'consum', 0.0217, 'lps'),
	(456414, 125, '2015-03-15 01:13:52.000000', 'consum', 0.0227, 'lps'),
	(456415, 125, '2015-03-15 01:13:53.000000', 'consum', 0.0219, 'lps'),
	(456416, 125, '2015-03-15 01:13:54.000000', 'consum', 0.0225, 'lps'),
	(456417, 125, '2015-03-15 01:13:55.000000', 'consum', 0.0221, 'lps'),
	(456418, 125, '2015-03-15 01:13:56.000000', 'consum', 0.0220, 'lps'),
	(456419, 125, '2015-03-15 01:13:57.000000', 'consum', 0.0210, 'lps'),
	(456420, 125, '2015-03-15 01:13:58.000000', 'consum', 0.0218, 'lps'),
	(456421, 125, '2015-03-15 01:13:59.000000', 'consum', 0.0214, 'lps'),
	(456422, 125, '2015-03-15 01:14:00.000000', 'consum', 0.0226, 'lps'),
	(456423, 125, '2015-03-15 01:14:01.000000', 'consum', 0.0222, 'lps'),
	(456424, 125, '2015-03-15 01:14:02.000000', 'consum', 0.0223, 'lps'),
	(456425, 125, '2015-03-15 01:14:03.000000', 'consum', 0.0221, 'lps'),
	(456426, 125, '2015-03-15 01:14:04.000000', 'consum', 0.0211, 'lps'),
	(456427, 125, '2015-03-15 01:14:05.000000', 'consum', 0.0217, 'lps'),
	(456428, 125, '2015-03-15 01:14:06.000000', 'consum', 0.0223, 'lps'),
	(456429, 125, '2015-03-15 01:14:07.000000', 'consum', 0.0219, 'lps'),
	(456430, 125, '2015-03-15 01:14:08.000000', 'consum', 0.0217, 'lps'),
	(456431, 125, '2015-03-15 01:14:09.000000', 'consum', 0.0217, 'lps'),
	(456432, 125, '2015-03-15 01:14:10.000000', 'consum', 0.0226, 'lps'),
	(456433, 125, '2015-03-15 01:14:11.000000', 'consum', 0.0216, 'lps'),
	(456434, 125, '2015-03-15 01:14:12.000000', 'consum', 0.0227, 'lps'),
	(456435, 125, '2015-03-15 01:14:13.000000', 'consum', 0.0224, 'lps'),
	(456436, 125, '2015-03-15 01:14:14.000000', 'consum', 0.0212, 'lps'),
	(456437, 125, '2015-03-15 01:14:15.000000', 'consum', 0.0214, 'lps'),
	(456438, 125, '2015-03-15 01:14:16.000000', 'consum', 0.0223, 'lps'),
	(456439, 125, '2015-03-15 01:14:17.000000', 'consum', 0.0212, 'lps'),
	(456440, 125, '2015-03-15 01:14:18.000000', 'consum', 0.0218, 'lps'),
	(456441, 125, '2015-03-15 01:14:19.000000', 'consum', 0.0225, 'lps'),
	(456442, 125, '2015-03-15 01:14:20.000000', 'consum', 0.0210, 'lps'),
	(456443, 125, '2015-03-15 01:14:21.000000', 'consum', 0.0216, 'lps'),
	(456444, 125, '2015-03-15 01:14:22.000000', 'consum', 0.0226, 'lps'),
	(456445, 125, '2015-03-15 01:14:23.000000', 'consum', 0.0217, 'lps'),
	(456446, 125, '2015-03-15 01:14:24.000000', 'consum', 0.0216, 'lps'),
	(456447, 125, '2015-03-15 01:14:25.000000', 'consum', 0.0217, 'lps'),
	(456448, 125, '2015-03-15 01:14:26.000000', 'consum', 0.0212, 'lps'),
	(456449, 125, '2015-03-15 01:14:27.000000', 'consum', 0.0219, 'lps'),
	(456450, 125, '2015-03-15 01:14:28.000000', 'consum', 0.0212, 'lps'),
	(456451, 125, '2015-03-15 01:14:29.000000', 'consum', 0.0210, 'lps'),
	(456452, 125, '2015-03-15 01:14:30.000000', 'consum', 0.0222, 'lps'),
	(456453, 125, '2015-03-15 01:14:31.000000', 'consum', 0.0216, 'lps'),
	(456454, 125, '2015-03-15 01:14:32.000000', 'consum', 0.0225, 'lps'),
	(456455, 125, '2015-03-15 01:14:33.000000', 'consum', 0.0212, 'lps'),
	(456456, 125, '2015-03-15 01:14:34.000000', 'consum', 0.0212, 'lps'),
	(456457, 125, '2015-03-15 01:14:35.000000', 'consum', 0.0216, 'lps'),
	(456458, 125, '2015-03-15 01:14:36.000000', 'consum', 0.0217, 'lps'),
	(456459, 125, '2015-03-15 01:14:37.000000', 'consum', 0.0227, 'lps'),
	(456460, 125, '2015-03-15 01:14:38.000000', 'consum', 0.0221, 'lps'),
	(456461, 125, '2015-03-15 01:14:39.000000', 'consum', 0.0212, 'lps'),
	(456462, 125, '2015-03-15 01:14:40.000000', 'consum', 0.0227, 'lps'),
	(456463, 125, '2015-03-15 01:14:41.000000', 'consum', 0.0215, 'lps'),
	(456464, 125, '2015-03-15 01:14:42.000000', 'consum', 0.0223, 'lps'),
	(456465, 125, '2015-03-15 01:14:43.000000', 'consum', 0.0222, 'lps'),
	(456466, 125, '2015-03-15 01:14:44.000000', 'consum', 0.0214, 'lps'),
	(456467, 125, '2015-03-15 01:14:45.000000', 'consum', 0.0214, 'lps'),
	(456468, 125, '2015-03-15 01:14:46.000000', 'consum', 0.0218, 'lps'),
	(456469, 125, '2015-03-15 01:14:47.000000', 'consum', 0.0221, 'lps'),
	(456470, 125, '2015-03-15 01:14:48.000000', 'consum', 0.0222, 'lps'),
	(456471, 125, '2015-03-15 01:14:49.000000', 'consum', 0.0222, 'lps'),
	(456472, 125, '2015-03-15 01:14:50.000000', 'consum', 0.0216, 'lps'),
	(456473, 125, '2015-03-15 01:14:51.000000', 'consum', 0.0223, 'lps'),
	(456474, 125, '2015-03-15 01:14:52.000000', 'consum', 0.0220, 'lps'),
	(456475, 125, '2015-03-15 01:14:53.000000', 'consum', 0.0223, 'lps'),
	(456476, 125, '2015-03-15 01:14:54.000000', 'consum', 0.0211, 'lps'),
	(456477, 125, '2015-03-15 01:14:55.000000', 'consum', 0.0210, 'lps'),
	(456478, 125, '2015-03-15 01:14:56.000000', 'consum', 0.0226, 'lps'),
	(456479, 125, '2015-03-15 01:14:57.000000', 'consum', 0.0218, 'lps'),
	(456480, 125, '2015-03-15 01:14:58.000000', 'consum', 0.0220, 'lps'),
	(456481, 125, '2015-03-15 01:14:59.000000', 'consum', 0.0218, 'lps'),
	(456482, 125, '2015-03-15 01:15:00.000000', 'consum', 0.0220, 'lps'),
	(456483, 125, '2015-03-15 01:15:01.000000', 'consum', 0.0221, 'lps'),
	(456484, 125, '2015-03-15 01:15:02.000000', 'consum', 0.0217, 'lps'),
	(456485, 125, '2015-03-15 01:15:03.000000', 'consum', 0.0212, 'lps'),
	(456486, 125, '2015-03-15 01:15:04.000000', 'consum', 0.0219, 'lps'),
	(456487, 125, '2015-03-15 01:15:05.000000', 'consum', 0.0214, 'lps'),
	(456488, 125, '2015-03-15 01:15:06.000000', 'consum', 0.0220, 'lps'),
	(456489, 125, '2015-03-15 01:15:07.000000', 'consum', 0.0211, 'lps'),
	(456490, 125, '2015-03-15 01:15:08.000000', 'consum', 0.0222, 'lps'),
	(456491, 125, '2015-03-15 01:15:09.000000', 'consum', 0.0214, 'lps'),
	(456492, 125, '2015-03-15 01:15:10.000000', 'consum', 0.0211, 'lps'),
	(456493, 125, '2015-03-15 01:15:11.000000', 'consum', 0.0222, 'lps'),
	(456494, 125, '2015-03-15 01:15:12.000000', 'consum', 0.0213, 'lps'),
	(456495, 125, '2015-03-15 01:15:13.000000', 'consum', 0.0226, 'lps'),
	(456496, 125, '2015-03-15 01:15:14.000000', 'consum', 0.0210, 'lps'),
	(456497, 125, '2015-03-15 01:15:15.000000', 'consum', 0.0216, 'lps'),
	(456498, 125, '2015-03-15 01:15:16.000000', 'consum', 0.0221, 'lps'),
	(456499, 125, '2015-03-15 01:15:17.000000', 'consum', 0.0212, 'lps'),
	(456500, 125, '2015-03-15 01:15:18.000000', 'consum', 0.0224, 'lps'),
	(456501, 125, '2015-03-15 01:15:19.000000', 'consum', 0.0222, 'lps'),
	(456502, 125, '2015-03-15 01:15:20.000000', 'consum', 0.0226, 'lps'),
	(456503, 125, '2015-03-15 01:15:21.000000', 'consum', 0.0220, 'lps'),
	(456504, 125, '2015-03-15 01:15:22.000000', 'consum', 0.0212, 'lps'),
	(456505, 125, '2015-03-15 01:15:23.000000', 'consum', 0.0210, 'lps'),
	(456506, 125, '2015-03-15 01:15:24.000000', 'consum', 0.0220, 'lps'),
	(456507, 125, '2015-03-15 01:15:25.000000', 'consum', 0.0226, 'lps'),
	(456508, 125, '2015-03-15 01:15:26.000000', 'consum', 0.0225, 'lps'),
	(456509, 125, '2015-03-15 01:15:27.000000', 'consum', 0.0219, 'lps'),
	(456510, 125, '2015-03-15 01:15:28.000000', 'consum', 0.0211, 'lps'),
	(456511, 125, '2015-03-15 01:15:29.000000', 'consum', 0.0226, 'lps'),
	(456512, 125, '2015-03-15 01:15:30.000000', 'consum', 0.0214, 'lps'),
	(456513, 125, '2015-03-15 01:15:31.000000', 'consum', 0.0219, 'lps'),
	(456514, 125, '2015-03-15 01:15:32.000000', 'consum', 0.0226, 'lps'),
	(456515, 125, '2015-03-15 01:15:33.000000', 'consum', 0.0226, 'lps'),
	(456516, 125, '2015-03-15 01:15:34.000000', 'consum', 0.0224, 'lps'),
	(456517, 125, '2015-03-15 01:15:35.000000', 'consum', 0.0214, 'lps'),
	(456518, 125, '2015-03-15 01:15:36.000000', 'consum', 0.0226, 'lps'),
	(456519, 125, '2015-03-15 01:15:37.000000', 'consum', 0.0223, 'lps'),
	(456520, 125, '2015-03-15 01:15:38.000000', 'consum', 0.0227, 'lps'),
	(456521, 125, '2015-03-15 01:15:39.000000', 'consum', 0.0223, 'lps'),
	(456522, 125, '2015-03-15 01:15:40.000000', 'consum', 0.0222, 'lps'),
	(456523, 125, '2015-03-15 01:15:41.000000', 'consum', 0.0213, 'lps'),
	(456524, 125, '2015-03-15 01:15:42.000000', 'consum', 0.0225, 'lps'),
	(456525, 125, '2015-03-15 01:15:43.000000', 'consum', 0.0226, 'lps'),
	(456526, 125, '2015-03-15 01:15:44.000000', 'consum', 0.0224, 'lps'),
	(456527, 125, '2015-03-15 01:15:45.000000', 'consum', 0.0215, 'lps'),
	(456528, 125, '2015-03-15 01:15:46.000000', 'consum', 0.0212, 'lps'),
	(456529, 125, '2015-03-15 01:15:47.000000', 'consum', 0.0224, 'lps'),
	(456530, 125, '2015-03-15 01:15:48.000000', 'consum', 0.0219, 'lps'),
	(456531, 125, '2015-03-15 01:15:49.000000', 'consum', 0.0216, 'lps'),
	(456532, 125, '2015-03-15 01:15:50.000000', 'consum', 0.0214, 'lps'),
	(456533, 125, '2015-03-15 01:15:51.000000', 'consum', 0.0211, 'lps'),
	(456534, 125, '2015-03-15 01:15:52.000000', 'consum', 0.0224, 'lps'),
	(456535, 125, '2015-03-15 01:15:53.000000', 'consum', 0.0221, 'lps'),
	(456536, 125, '2015-03-15 01:15:54.000000', 'consum', 0.0222, 'lps'),
	(456537, 125, '2015-03-15 01:15:55.000000', 'consum', 0.0222, 'lps'),
	(456538, 125, '2015-03-15 01:15:56.000000', 'consum', 0.0217, 'lps'),
	(456539, 125, '2015-03-15 01:15:57.000000', 'consum', 0.0225, 'lps'),
	(456540, 125, '2015-03-15 01:15:58.000000', 'consum', 0.0213, 'lps'),
	(456541, 125, '2015-03-15 01:15:59.000000', 'consum', 0.0215, 'lps'),
	(456542, 125, '2015-03-15 01:16:00.000000', 'consum', 0.0210, 'lps'),
	(456543, 125, '2015-03-15 01:16:01.000000', 'consum', 0.0214, 'lps'),
	(456544, 125, '2015-03-15 01:16:02.000000', 'consum', 0.0213, 'lps'),
	(456545, 125, '2015-03-15 01:16:03.000000', 'consum', 0.0214, 'lps'),
	(456546, 125, '2015-03-15 01:16:04.000000', 'consum', 0.0222, 'lps'),
	(456547, 125, '2015-03-15 01:16:05.000000', 'consum', 0.0223, 'lps'),
	(456548, 125, '2015-03-15 01:16:06.000000', 'consum', 0.0220, 'lps'),
	(456549, 125, '2015-03-15 01:16:07.000000', 'consum', 0.0220, 'lps'),
	(456550, 125, '2015-03-15 01:16:08.000000', 'consum', 0.0214, 'lps'),
	(456551, 125, '2015-03-15 01:16:09.000000', 'consum', 0.0220, 'lps'),
	(456552, 125, '2015-03-15 01:16:10.000000', 'consum', 0.0213, 'lps'),
	(456553, 125, '2015-03-15 01:16:11.000000', 'consum', 0.0212, 'lps'),
	(456554, 125, '2015-03-15 01:16:12.000000', 'consum', 0.0214, 'lps'),
	(456555, 125, '2015-03-15 01:16:13.000000', 'consum', 0.0222, 'lps'),
	(456556, 125, '2015-03-15 01:16:14.000000', 'consum', 0.0222, 'lps'),
	(456557, 125, '2015-03-15 01:16:15.000000', 'consum', 0.0217, 'lps'),
	(456558, 125, '2015-03-15 01:16:16.000000', 'consum', 0.0210, 'lps'),
	(456559, 125, '2015-03-15 01:16:17.000000', 'consum', 0.0225, 'lps'),
	(456560, 125, '2015-03-15 01:16:18.000000', 'consum', 0.0213, 'lps'),
	(456561, 125, '2015-03-15 01:16:19.000000', 'consum', 0.0216, 'lps'),
	(456562, 125, '2015-03-15 01:16:20.000000', 'consum', 0.0216, 'lps'),
	(456563, 125, '2015-03-15 01:16:21.000000', 'consum', 0.0220, 'lps'),
	(456564, 125, '2015-03-15 01:16:22.000000', 'consum', 0.0224, 'lps'),
	(456565, 125, '2015-03-15 01:16:23.000000', 'consum', 0.0215, 'lps'),
	(456566, 125, '2015-03-15 01:16:24.000000', 'consum', 0.0211, 'lps'),
	(456567, 125, '2015-03-15 01:16:25.000000', 'consum', 0.0219, 'lps'),
	(456568, 125, '2015-03-15 01:16:26.000000', 'consum', 0.0218, 'lps'),
	(456569, 125, '2015-03-15 01:16:27.000000', 'consum', 0.0221, 'lps'),
	(456570, 125, '2015-03-15 01:16:28.000000', 'consum', 0.0226, 'lps'),
	(456571, 125, '2015-03-15 01:16:29.000000', 'consum', 0.0222, 'lps'),
	(456572, 125, '2015-03-15 01:16:30.000000', 'consum', 0.0220, 'lps'),
	(456573, 125, '2015-03-15 01:16:31.000000', 'consum', 0.0225, 'lps'),
	(456574, 125, '2015-03-15 01:16:32.000000', 'consum', 0.0222, 'lps'),
	(456575, 125, '2015-03-15 01:16:33.000000', 'consum', 0.0223, 'lps'),
	(456576, 125, '2015-03-15 01:16:34.000000', 'consum', 0.0224, 'lps'),
	(456577, 125, '2015-03-15 01:16:35.000000', 'consum', 0.0221, 'lps'),
	(456578, 125, '2015-03-15 01:16:36.000000', 'consum', 0.0224, 'lps'),
	(456579, 125, '2015-03-15 01:16:37.000000', 'consum', 0.0211, 'lps'),
	(456580, 125, '2015-03-15 01:16:38.000000', 'consum', 0.0212, 'lps'),
	(456581, 125, '2015-03-15 01:16:39.000000', 'consum', 0.0216, 'lps'),
	(456582, 125, '2015-03-15 01:16:40.000000', 'consum', 0.0216, 'lps'),
	(456583, 125, '2015-03-15 01:16:41.000000', 'consum', 0.0221, 'lps'),
	(456584, 125, '2015-03-15 01:16:42.000000', 'consum', 0.0213, 'lps'),
	(456585, 125, '2015-03-15 01:16:43.000000', 'consum', 0.0211, 'lps'),
	(456586, 125, '2015-03-15 01:16:44.000000', 'consum', 0.0224, 'lps'),
	(456587, 125, '2015-03-15 01:16:45.000000', 'consum', 0.0224, 'lps'),
	(456588, 125, '2015-03-15 01:16:46.000000', 'consum', 0.0221, 'lps'),
	(456589, 125, '2015-03-15 01:16:47.000000', 'consum', 0.0223, 'lps'),
	(456590, 125, '2015-03-15 01:16:48.000000', 'consum', 0.0226, 'lps'),
	(456591, 125, '2015-03-15 01:16:49.000000', 'consum', 0.0216, 'lps'),
	(456592, 125, '2015-03-15 01:16:50.000000', 'consum', 0.0227, 'lps'),
	(456593, 125, '2015-03-15 01:16:51.000000', 'consum', 0.0222, 'lps'),
	(456594, 125, '2015-03-15 01:16:52.000000', 'consum', 0.0221, 'lps'),
	(456595, 125, '2015-03-15 01:16:53.000000', 'consum', 0.0210, 'lps'),
	(456596, 125, '2015-03-15 01:16:54.000000', 'consum', 0.0212, 'lps'),
	(456597, 125, '2015-03-15 01:16:55.000000', 'consum', 0.0223, 'lps'),
	(456598, 125, '2015-03-15 01:16:56.000000', 'consum', 0.0217, 'lps'),
	(456599, 125, '2015-03-15 01:16:57.000000', 'consum', 0.0223, 'lps'),
	(456600, 125, '2015-03-15 01:16:58.000000', 'consum', 0.0220, 'lps'),
	(456601, 125, '2015-03-15 01:16:59.000000', 'consum', 0.0220, 'lps'),
	(456602, 125, '2015-03-15 01:17:00.000000', 'consum', 0.0213, 'lps'),
	(456603, 125, '2015-03-15 01:17:01.000000', 'consum', 0.0214, 'lps'),
	(456604, 125, '2015-03-15 01:17:02.000000', 'consum', 0.0221, 'lps'),
	(456605, 125, '2015-03-15 01:17:03.000000', 'consum', 0.0218, 'lps'),
	(456606, 125, '2015-03-15 01:17:04.000000', 'consum', 0.0217, 'lps'),
	(456607, 125, '2015-03-15 01:17:05.000000', 'consum', 0.0221, 'lps'),
	(456608, 125, '2015-03-15 01:17:06.000000', 'consum', 0.0210, 'lps'),
	(456609, 125, '2015-03-15 01:17:07.000000', 'consum', 0.0211, 'lps'),
	(456610, 125, '2015-03-15 01:17:08.000000', 'consum', 0.0219, 'lps'),
	(456611, 125, '2015-03-15 01:17:09.000000', 'consum', 0.0213, 'lps'),
	(456612, 125, '2015-03-15 01:17:10.000000', 'consum', 0.0219, 'lps'),
	(456613, 125, '2015-03-15 01:17:11.000000', 'consum', 0.0210, 'lps'),
	(456614, 125, '2015-03-15 01:17:12.000000', 'consum', 0.0220, 'lps'),
	(456615, 125, '2015-03-15 01:17:13.000000', 'consum', 0.0225, 'lps'),
	(456616, 125, '2015-03-15 01:17:14.000000', 'consum', 0.0221, 'lps'),
	(456617, 125, '2015-03-15 01:17:15.000000', 'consum', 0.0218, 'lps'),
	(456618, 125, '2015-03-15 01:17:16.000000', 'consum', 0.0218, 'lps'),
	(456619, 125, '2015-03-15 01:17:17.000000', 'consum', 0.0227, 'lps'),
	(456620, 125, '2015-03-15 01:17:18.000000', 'consum', 0.0215, 'lps'),
	(456621, 125, '2015-03-15 01:17:19.000000', 'consum', 0.0223, 'lps'),
	(456622, 125, '2015-03-15 01:17:20.000000', 'consum', 0.0223, 'lps'),
	(456623, 125, '2015-03-15 01:17:21.000000', 'consum', 0.0218, 'lps'),
	(456624, 125, '2015-03-15 01:17:22.000000', 'consum', 0.0211, 'lps'),
	(456625, 125, '2015-03-15 01:17:23.000000', 'consum', 0.0212, 'lps'),
	(456626, 125, '2015-03-15 01:17:24.000000', 'consum', 0.0217, 'lps'),
	(456627, 125, '2015-03-15 01:17:25.000000', 'consum', 0.0220, 'lps'),
	(456628, 125, '2015-03-15 01:17:26.000000', 'consum', 0.0222, 'lps'),
	(456629, 125, '2015-03-15 01:17:27.000000', 'consum', 0.0221, 'lps'),
	(456630, 125, '2015-03-15 01:17:28.000000', 'consum', 0.0212, 'lps'),
	(456631, 125, '2015-03-15 01:17:29.000000', 'consum', 0.0225, 'lps'),
	(456632, 125, '2015-03-15 01:17:30.000000', 'consum', 0.0223, 'lps'),
	(456633, 125, '2015-03-15 01:17:31.000000', 'consum', 0.0213, 'lps'),
	(456634, 125, '2015-03-15 01:17:32.000000', 'consum', 0.0221, 'lps'),
	(456635, 125, '2015-03-15 01:17:33.000000', 'consum', 0.0221, 'lps'),
	(456636, 125, '2015-03-15 01:17:34.000000', 'consum', 0.0217, 'lps'),
	(456637, 125, '2015-03-15 01:17:35.000000', 'consum', 0.0211, 'lps'),
	(456638, 125, '2015-03-15 01:17:36.000000', 'consum', 0.0212, 'lps'),
	(456639, 125, '2015-03-15 01:17:37.000000', 'consum', 0.0218, 'lps'),
	(456640, 125, '2015-03-15 01:17:38.000000', 'consum', 0.0224, 'lps'),
	(456641, 125, '2015-03-15 01:17:39.000000', 'consum', 0.0224, 'lps'),
	(456642, 125, '2015-03-15 01:17:40.000000', 'consum', 0.0219, 'lps'),
	(456643, 125, '2015-03-15 01:17:41.000000', 'consum', 0.0215, 'lps'),
	(456644, 125, '2015-03-15 01:17:42.000000', 'consum', 0.0227, 'lps'),
	(456645, 125, '2015-03-15 01:17:43.000000', 'consum', 0.0225, 'lps'),
	(456646, 125, '2015-03-15 01:17:44.000000', 'consum', 0.0215, 'lps'),
	(456647, 125, '2015-03-15 01:17:45.000000', 'consum', 0.0212, 'lps'),
	(456648, 125, '2015-03-15 01:17:46.000000', 'consum', 0.0221, 'lps'),
	(456649, 125, '2015-03-15 01:17:47.000000', 'consum', 0.0225, 'lps'),
	(456650, 125, '2015-03-15 01:17:48.000000', 'consum', 0.0216, 'lps'),
	(456651, 125, '2015-03-15 01:17:49.000000', 'consum', 0.0214, 'lps'),
	(456652, 125, '2015-03-15 01:17:50.000000', 'consum', 0.0210, 'lps'),
	(456653, 125, '2015-03-15 01:17:51.000000', 'consum', 0.0219, 'lps'),
	(456654, 125, '2015-03-15 01:17:52.000000', 'consum', 0.0219, 'lps'),
	(456655, 125, '2015-03-15 01:17:53.000000', 'consum', 0.0210, 'lps'),
	(456656, 125, '2015-03-15 01:17:54.000000', 'consum', 0.0220, 'lps'),
	(456657, 125, '2015-03-15 01:17:55.000000', 'consum', 0.0224, 'lps'),
	(456658, 125, '2015-03-15 01:17:56.000000', 'consum', 0.0216, 'lps'),
	(456659, 125, '2015-03-15 01:17:57.000000', 'consum', 0.0214, 'lps'),
	(456660, 125, '2015-03-15 01:17:58.000000', 'consum', 0.0214, 'lps'),
	(456661, 125, '2015-03-15 01:17:59.000000', 'consum', 0.0216, 'lps'),
	(456662, 125, '2015-03-15 01:18:00.000000', 'consum', 0.0213, 'lps'),
	(456663, 125, '2015-03-15 01:18:01.000000', 'consum', 0.0225, 'lps'),
	(456664, 125, '2015-03-15 01:18:02.000000', 'consum', 0.0224, 'lps'),
	(456665, 125, '2015-03-15 01:18:03.000000', 'consum', 0.0218, 'lps'),
	(456666, 125, '2015-03-15 01:18:04.000000', 'consum', 0.0225, 'lps'),
	(456667, 125, '2015-03-15 01:18:05.000000', 'consum', 0.0225, 'lps'),
	(456668, 125, '2015-03-15 01:18:06.000000', 'consum', 0.0225, 'lps'),
	(456669, 125, '2015-03-15 01:18:07.000000', 'consum', 0.0221, 'lps'),
	(456670, 125, '2015-03-15 01:18:08.000000', 'consum', 0.0221, 'lps'),
	(456671, 125, '2015-03-15 01:18:09.000000', 'consum', 0.0215, 'lps'),
	(456672, 125, '2015-03-15 01:18:10.000000', 'consum', 0.0220, 'lps'),
	(456673, 125, '2015-03-15 01:18:11.000000', 'consum', 0.0211, 'lps'),
	(456674, 125, '2015-03-15 01:18:12.000000', 'consum', 0.0218, 'lps'),
	(456675, 125, '2015-03-15 01:18:13.000000', 'consum', 0.0215, 'lps'),
	(456676, 125, '2015-03-15 01:18:14.000000', 'consum', 0.0227, 'lps'),
	(456677, 125, '2015-03-15 01:18:15.000000', 'consum', 0.0210, 'lps'),
	(456678, 125, '2015-03-15 01:18:16.000000', 'consum', 0.0215, 'lps'),
	(456679, 125, '2015-03-15 01:18:17.000000', 'consum', 0.0217, 'lps'),
	(456680, 125, '2015-03-15 01:18:18.000000', 'consum', 0.0210, 'lps'),
	(456681, 125, '2015-03-15 01:18:19.000000', 'consum', 0.0227, 'lps'),
	(456682, 125, '2015-03-15 01:18:20.000000', 'consum', 0.0223, 'lps'),
	(456683, 125, '2015-03-15 01:18:21.000000', 'consum', 0.0226, 'lps'),
	(456684, 125, '2015-03-15 01:18:22.000000', 'consum', 0.0213, 'lps'),
	(456685, 125, '2015-03-15 01:18:23.000000', 'consum', 0.0216, 'lps'),
	(456686, 125, '2015-03-15 01:18:24.000000', 'consum', 0.0213, 'lps'),
	(456687, 125, '2015-03-15 01:18:25.000000', 'consum', 0.0227, 'lps'),
	(456688, 125, '2015-03-15 01:18:26.000000', 'consum', 0.0212, 'lps'),
	(456689, 125, '2015-03-15 01:18:27.000000', 'consum', 0.0224, 'lps'),
	(456690, 125, '2015-03-15 01:18:28.000000', 'consum', 0.0223, 'lps'),
	(456691, 125, '2015-03-15 01:18:29.000000', 'consum', 0.0213, 'lps'),
	(456692, 125, '2015-03-15 01:18:30.000000', 'consum', 0.0225, 'lps'),
	(456693, 125, '2015-03-15 01:18:31.000000', 'consum', 0.0222, 'lps'),
	(456694, 125, '2015-03-15 01:18:32.000000', 'consum', 0.0224, 'lps'),
	(456695, 125, '2015-03-15 01:18:33.000000', 'consum', 0.0227, 'lps'),
	(456696, 125, '2015-03-15 01:18:34.000000', 'consum', 0.0216, 'lps'),
	(456697, 125, '2015-03-15 01:18:35.000000', 'consum', 0.0210, 'lps'),
	(456698, 125, '2015-03-15 01:18:36.000000', 'consum', 0.0227, 'lps'),
	(456699, 125, '2015-03-15 01:18:37.000000', 'consum', 0.0225, 'lps'),
	(456700, 125, '2015-03-15 01:18:38.000000', 'consum', 0.0216, 'lps'),
	(456701, 125, '2015-03-15 01:18:39.000000', 'consum', 0.0212, 'lps'),
	(456702, 125, '2015-03-15 01:18:40.000000', 'consum', 0.0221, 'lps'),
	(456703, 125, '2015-03-15 01:18:41.000000', 'consum', 0.0225, 'lps'),
	(456704, 125, '2015-03-15 01:18:42.000000', 'consum', 0.0217, 'lps'),
	(456705, 125, '2015-03-15 01:18:43.000000', 'consum', 0.0219, 'lps'),
	(456706, 125, '2015-03-15 01:18:44.000000', 'consum', 0.0215, 'lps'),
	(456707, 125, '2015-03-15 01:18:45.000000', 'consum', 0.0227, 'lps'),
	(456708, 125, '2015-03-15 01:18:46.000000', 'consum', 0.0227, 'lps'),
	(456709, 125, '2015-03-15 01:18:47.000000', 'consum', 0.0226, 'lps'),
	(456710, 125, '2015-03-15 01:18:48.000000', 'consum', 0.0223, 'lps'),
	(456711, 125, '2015-03-15 01:18:49.000000', 'consum', 0.0210, 'lps'),
	(456712, 125, '2015-03-15 01:18:50.000000', 'consum', 0.0227, 'lps'),
	(456713, 125, '2015-03-15 01:18:51.000000', 'consum', 0.0220, 'lps'),
	(456714, 125, '2015-03-15 01:18:52.000000', 'consum', 0.0211, 'lps'),
	(456715, 125, '2015-03-15 01:18:53.000000', 'consum', 0.0219, 'lps'),
	(456716, 125, '2015-03-15 01:18:54.000000', 'consum', 0.0220, 'lps'),
	(456717, 125, '2015-03-15 01:18:55.000000', 'consum', 0.0213, 'lps'),
	(456718, 125, '2015-03-15 01:18:56.000000', 'consum', 0.0215, 'lps'),
	(456719, 125, '2015-03-15 01:18:57.000000', 'consum', 0.0210, 'lps'),
	(456720, 125, '2015-03-15 01:18:58.000000', 'consum', 0.0212, 'lps'),
	(456721, 125, '2015-03-15 01:18:59.000000', 'consum', 0.0219, 'lps'),
	(456722, 125, '2015-03-15 01:19:00.000000', 'consum', 0.0213, 'lps'),
	(456723, 125, '2015-03-15 01:19:01.000000', 'consum', 0.0218, 'lps'),
	(456724, 125, '2015-03-15 01:19:02.000000', 'consum', 0.0224, 'lps'),
	(456725, 125, '2015-03-15 01:19:03.000000', 'consum', 0.0220, 'lps'),
	(456726, 125, '2015-03-15 01:19:04.000000', 'consum', 0.0218, 'lps'),
	(456727, 125, '2015-03-15 01:19:05.000000', 'consum', 0.0219, 'lps'),
	(456728, 125, '2015-03-15 01:19:06.000000', 'consum', 0.0217, 'lps'),
	(456729, 125, '2015-03-15 01:19:07.000000', 'consum', 0.0216, 'lps'),
	(456730, 125, '2015-03-15 01:19:08.000000', 'consum', 0.0218, 'lps'),
	(456731, 125, '2015-03-15 01:19:09.000000', 'consum', 0.0218, 'lps'),
	(456732, 125, '2015-03-15 01:19:10.000000', 'consum', 0.0225, 'lps'),
	(456733, 125, '2015-03-15 01:19:11.000000', 'consum', 0.0224, 'lps'),
	(456734, 125, '2015-03-15 01:19:12.000000', 'consum', 0.0217, 'lps'),
	(456735, 125, '2015-03-15 01:19:13.000000', 'consum', 0.0221, 'lps'),
	(456736, 125, '2015-03-15 01:19:14.000000', 'consum', 0.0210, 'lps'),
	(456737, 125, '2015-03-15 01:19:15.000000', 'consum', 0.0213, 'lps'),
	(456738, 125, '2015-03-15 01:19:16.000000', 'consum', 0.0227, 'lps'),
	(456739, 125, '2015-03-15 01:19:17.000000', 'consum', 0.0215, 'lps'),
	(456740, 125, '2015-03-15 01:19:18.000000', 'consum', 0.0221, 'lps'),
	(456741, 125, '2015-03-15 01:19:19.000000', 'consum', 0.0213, 'lps'),
	(456742, 125, '2015-03-15 01:19:20.000000', 'consum', 0.0212, 'lps'),
	(456743, 125, '2015-03-15 01:19:21.000000', 'consum', 0.0212, 'lps'),
	(456744, 125, '2015-03-15 01:19:22.000000', 'consum', 0.0215, 'lps'),
	(456745, 125, '2015-03-15 01:19:23.000000', 'consum', 0.0212, 'lps'),
	(456746, 125, '2015-03-15 01:19:24.000000', 'consum', 0.0223, 'lps'),
	(456747, 125, '2015-03-15 01:19:25.000000', 'consum', 0.0215, 'lps'),
	(456748, 125, '2015-03-15 01:19:26.000000', 'consum', 0.0216, 'lps'),
	(456749, 125, '2015-03-15 01:19:27.000000', 'consum', 0.0224, 'lps'),
	(456750, 125, '2015-03-15 01:19:28.000000', 'consum', 0.0227, 'lps'),
	(456751, 125, '2015-03-15 01:19:29.000000', 'consum', 0.0217, 'lps'),
	(456752, 125, '2015-03-15 01:19:30.000000', 'consum', 0.0212, 'lps'),
	(456753, 125, '2015-03-15 01:19:31.000000', 'consum', 0.0218, 'lps'),
	(456754, 125, '2015-03-15 01:19:32.000000', 'consum', 0.0225, 'lps'),
	(456755, 125, '2015-03-15 01:19:33.000000', 'consum', 0.0210, 'lps'),
	(456756, 125, '2015-03-15 01:19:34.000000', 'consum', 0.0218, 'lps'),
	(456757, 125, '2015-03-15 01:19:35.000000', 'consum', 0.0216, 'lps'),
	(456758, 125, '2015-03-15 01:19:36.000000', 'consum', 0.0218, 'lps'),
	(456759, 125, '2015-03-15 01:19:37.000000', 'consum', 0.0212, 'lps'),
	(456760, 125, '2015-03-15 01:19:38.000000', 'consum', 0.0215, 'lps'),
	(456761, 125, '2015-03-15 01:19:39.000000', 'consum', 0.0213, 'lps'),
	(456762, 125, '2015-03-15 01:19:40.000000', 'consum', 0.0211, 'lps'),
	(456763, 125, '2015-03-15 01:19:41.000000', 'consum', 0.0223, 'lps'),
	(456764, 125, '2015-03-15 01:19:42.000000', 'consum', 0.0219, 'lps'),
	(456765, 125, '2015-03-15 01:19:43.000000', 'consum', 0.0215, 'lps'),
	(456766, 125, '2015-03-15 01:19:44.000000', 'consum', 0.0227, 'lps'),
	(456767, 125, '2015-03-15 01:19:45.000000', 'consum', 0.0226, 'lps'),
	(456768, 125, '2015-03-15 01:19:46.000000', 'consum', 0.0224, 'lps'),
	(456769, 125, '2015-03-15 01:19:47.000000', 'consum', 0.0211, 'lps'),
	(456770, 125, '2015-03-15 01:19:48.000000', 'consum', 0.0213, 'lps'),
	(456771, 125, '2015-03-15 01:19:49.000000', 'consum', 0.0221, 'lps'),
	(456772, 125, '2015-03-15 01:19:50.000000', 'consum', 0.0221, 'lps'),
	(456773, 125, '2015-03-15 01:19:51.000000', 'consum', 0.0214, 'lps'),
	(456774, 125, '2015-03-15 01:19:52.000000', 'consum', 0.0216, 'lps'),
	(456775, 125, '2015-03-15 01:19:53.000000', 'consum', 0.0212, 'lps'),
	(456776, 125, '2015-03-15 01:19:54.000000', 'consum', 0.0220, 'lps'),
	(456777, 125, '2015-03-15 01:19:55.000000', 'consum', 0.0216, 'lps'),
	(456778, 125, '2015-03-15 01:19:56.000000', 'consum', 0.0213, 'lps'),
	(456779, 125, '2015-03-15 01:19:57.000000', 'consum', 0.0224, 'lps'),
	(456780, 125, '2015-03-15 01:19:58.000000', 'consum', 0.0217, 'lps'),
	(456781, 125, '2015-03-15 01:19:59.000000', 'consum', 0.0222, 'lps'),
	(456782, 125, '2015-03-15 01:20:00.000000', 'consum', 0.0216, 'lps'),
	(456783, 125, '2015-03-15 01:20:01.000000', 'consum', 0.0220, 'lps'),
	(456784, 125, '2015-03-15 01:20:02.000000', 'consum', 0.0223, 'lps'),
	(456785, 125, '2015-03-15 01:20:03.000000', 'consum', 0.0213, 'lps'),
	(456786, 125, '2015-03-15 01:20:04.000000', 'consum', 0.0219, 'lps'),
	(456787, 125, '2015-03-15 01:20:05.000000', 'consum', 0.0212, 'lps'),
	(456788, 125, '2015-03-15 01:20:06.000000', 'consum', 0.0212, 'lps'),
	(456789, 125, '2015-03-15 01:20:07.000000', 'consum', 0.0214, 'lps'),
	(456790, 125, '2015-03-15 01:20:08.000000', 'consum', 0.0225, 'lps'),
	(456791, 125, '2015-03-15 01:20:09.000000', 'consum', 0.0221, 'lps'),
	(456792, 125, '2015-03-15 01:20:10.000000', 'consum', 0.0220, 'lps'),
	(456793, 125, '2015-03-15 01:20:11.000000', 'consum', 0.0227, 'lps'),
	(456794, 125, '2015-03-15 01:20:12.000000', 'consum', 0.0213, 'lps'),
	(456795, 125, '2015-03-15 01:20:13.000000', 'consum', 0.0227, 'lps'),
	(456796, 125, '2015-03-15 01:20:14.000000', 'consum', 0.0216, 'lps'),
	(456797, 125, '2015-03-15 01:20:15.000000', 'consum', 0.0225, 'lps'),
	(456798, 125, '2015-03-15 01:20:16.000000', 'consum', 0.0213, 'lps'),
	(456799, 125, '2015-03-15 01:20:17.000000', 'consum', 0.0216, 'lps'),
	(456800, 125, '2015-03-15 01:20:18.000000', 'consum', 0.0216, 'lps'),
	(456801, 125, '2015-03-15 01:20:19.000000', 'consum', 0.0220, 'lps'),
	(456802, 125, '2015-03-15 01:20:20.000000', 'consum', 0.0226, 'lps'),
	(456803, 125, '2015-03-15 01:20:21.000000', 'consum', 0.0223, 'lps'),
	(456804, 125, '2015-03-15 01:20:22.000000', 'consum', 0.0211, 'lps'),
	(456805, 125, '2015-03-15 01:20:23.000000', 'consum', 0.0212, 'lps'),
	(456806, 125, '2015-03-15 01:20:24.000000', 'consum', 0.0217, 'lps'),
	(456807, 125, '2015-03-15 01:20:25.000000', 'consum', 0.0220, 'lps'),
	(456808, 125, '2015-03-15 01:20:26.000000', 'consum', 0.0224, 'lps'),
	(456809, 125, '2015-03-15 01:20:27.000000', 'consum', 0.0214, 'lps'),
	(456810, 125, '2015-03-15 01:20:28.000000', 'consum', 0.0225, 'lps'),
	(456811, 125, '2015-03-15 01:20:29.000000', 'consum', 0.0219, 'lps'),
	(456812, 125, '2015-03-15 01:20:30.000000', 'consum', 0.0212, 'lps'),
	(456813, 125, '2015-03-15 01:20:31.000000', 'consum', 0.0210, 'lps'),
	(456814, 125, '2015-03-15 01:20:32.000000', 'consum', 0.0222, 'lps'),
	(456815, 125, '2015-03-15 01:20:33.000000', 'consum', 0.0219, 'lps'),
	(456816, 125, '2015-03-15 01:20:34.000000', 'consum', 0.0218, 'lps'),
	(456817, 125, '2015-03-15 01:20:35.000000', 'consum', 0.0225, 'lps'),
	(456818, 125, '2015-03-15 01:20:36.000000', 'consum', 0.0224, 'lps'),
	(456819, 125, '2015-03-15 01:20:37.000000', 'consum', 0.0217, 'lps'),
	(456820, 125, '2015-03-15 01:20:38.000000', 'consum', 0.0224, 'lps'),
	(456821, 125, '2015-03-15 01:20:39.000000', 'consum', 0.0221, 'lps'),
	(456822, 125, '2015-03-15 01:20:40.000000', 'consum', 0.0223, 'lps'),
	(456823, 125, '2015-03-15 01:20:41.000000', 'consum', 0.0226, 'lps'),
	(456824, 125, '2015-03-15 01:20:42.000000', 'consum', 0.0216, 'lps'),
	(456825, 125, '2015-03-15 01:20:43.000000', 'consum', 0.0212, 'lps'),
	(456826, 125, '2015-03-15 01:20:44.000000', 'consum', 0.0219, 'lps'),
	(456827, 125, '2015-03-15 01:20:45.000000', 'consum', 0.0211, 'lps'),
	(456828, 125, '2015-03-15 01:20:46.000000', 'consum', 0.0210, 'lps'),
	(456829, 125, '2015-03-15 01:20:47.000000', 'consum', 0.0225, 'lps'),
	(456830, 125, '2015-03-15 01:20:48.000000', 'consum', 0.0215, 'lps'),
	(456831, 125, '2015-03-15 01:20:49.000000', 'consum', 0.0225, 'lps'),
	(456832, 125, '2015-03-15 01:20:50.000000', 'consum', 0.0216, 'lps'),
	(456833, 125, '2015-03-15 01:20:51.000000', 'consum', 0.0214, 'lps'),
	(456834, 125, '2015-03-15 01:20:52.000000', 'consum', 0.0213, 'lps'),
	(456835, 125, '2015-03-15 01:20:53.000000', 'consum', 0.0211, 'lps'),
	(456836, 125, '2015-03-15 01:20:54.000000', 'consum', 0.0226, 'lps'),
	(456837, 125, '2015-03-15 01:20:55.000000', 'consum', 0.0215, 'lps'),
	(456838, 125, '2015-03-15 01:20:56.000000', 'consum', 0.0224, 'lps'),
	(456839, 125, '2015-03-15 01:20:57.000000', 'consum', 0.0211, 'lps'),
	(456840, 125, '2015-03-15 01:20:58.000000', 'consum', 0.0211, 'lps'),
	(456841, 125, '2015-03-15 01:20:59.000000', 'consum', 0.0211, 'lps'),
	(456842, 125, '2015-03-15 01:21:00.000000', 'consum', 0.0213, 'lps'),
	(456843, 125, '2015-03-15 01:21:01.000000', 'consum', 0.0222, 'lps'),
	(456844, 125, '2015-03-15 01:21:02.000000', 'consum', 0.0225, 'lps'),
	(456845, 125, '2015-03-15 01:21:03.000000', 'consum', 0.0215, 'lps'),
	(456846, 125, '2015-03-15 01:21:04.000000', 'consum', 0.0224, 'lps'),
	(456847, 125, '2015-03-15 01:21:05.000000', 'consum', 0.0212, 'lps'),
	(456848, 125, '2015-03-15 01:21:06.000000', 'consum', 0.0216, 'lps'),
	(456849, 125, '2015-03-15 01:21:07.000000', 'consum', 0.0216, 'lps'),
	(456850, 125, '2015-03-15 01:21:08.000000', 'consum', 0.0222, 'lps'),
	(456851, 125, '2015-03-15 01:21:09.000000', 'consum', 0.0219, 'lps'),
	(456852, 125, '2015-03-15 01:21:10.000000', 'consum', 0.0217, 'lps'),
	(456853, 125, '2015-03-15 01:21:11.000000', 'consum', 0.0221, 'lps'),
	(456854, 125, '2015-03-15 01:21:12.000000', 'consum', 0.0225, 'lps'),
	(456855, 125, '2015-03-15 01:21:13.000000', 'consum', 0.0215, 'lps'),
	(456856, 125, '2015-03-15 01:21:14.000000', 'consum', 0.0211, 'lps'),
	(456857, 125, '2015-03-15 01:21:15.000000', 'consum', 0.0216, 'lps'),
	(456858, 125, '2015-03-15 01:21:16.000000', 'consum', 0.0220, 'lps'),
	(456859, 125, '2015-03-15 01:21:17.000000', 'consum', 0.0223, 'lps'),
	(456860, 125, '2015-03-15 01:21:18.000000', 'consum', 0.0210, 'lps'),
	(456861, 125, '2015-03-15 01:21:19.000000', 'consum', 0.0226, 'lps'),
	(456862, 125, '2015-03-15 01:21:20.000000', 'consum', 0.0218, 'lps'),
	(456863, 125, '2015-03-15 01:21:21.000000', 'consum', 0.0219, 'lps'),
	(456864, 125, '2015-03-15 01:21:22.000000', 'consum', 0.0216, 'lps'),
	(456865, 125, '2015-03-15 01:21:23.000000', 'consum', 0.0212, 'lps'),
	(456866, 125, '2015-03-15 01:21:24.000000', 'consum', 0.0219, 'lps'),
	(456867, 125, '2015-03-15 01:21:25.000000', 'consum', 0.0217, 'lps'),
	(456868, 125, '2015-03-15 01:21:26.000000', 'consum', 0.0215, 'lps'),
	(456869, 125, '2015-03-15 01:21:27.000000', 'consum', 0.0217, 'lps'),
	(456870, 125, '2015-03-15 01:21:28.000000', 'consum', 0.0211, 'lps'),
	(456871, 125, '2015-03-15 01:21:29.000000', 'consum', 0.0213, 'lps'),
	(456872, 125, '2015-03-15 01:21:30.000000', 'consum', 0.0224, 'lps'),
	(456873, 125, '2015-03-15 01:21:31.000000', 'consum', 0.0215, 'lps'),
	(456874, 125, '2015-03-15 01:21:32.000000', 'consum', 0.0212, 'lps'),
	(456875, 125, '2015-03-15 01:21:33.000000', 'consum', 0.0225, 'lps'),
	(456876, 125, '2015-03-15 01:21:34.000000', 'consum', 0.0223, 'lps'),
	(456877, 125, '2015-03-15 01:21:35.000000', 'consum', 0.0214, 'lps'),
	(456878, 125, '2015-03-15 01:21:36.000000', 'consum', 0.0211, 'lps'),
	(456879, 125, '2015-03-15 01:21:37.000000', 'consum', 0.0220, 'lps'),
	(456880, 125, '2015-03-15 01:21:38.000000', 'consum', 0.0220, 'lps'),
	(456881, 125, '2015-03-15 01:21:39.000000', 'consum', 0.0212, 'lps'),
	(456882, 125, '2015-03-15 01:21:40.000000', 'consum', 0.0210, 'lps'),
	(456883, 125, '2015-03-15 01:21:41.000000', 'consum', 0.0224, 'lps'),
	(456884, 125, '2015-03-15 01:21:42.000000', 'consum', 0.0227, 'lps'),
	(456885, 125, '2015-03-15 01:21:43.000000', 'consum', 0.0215, 'lps'),
	(456886, 125, '2015-03-15 01:21:44.000000', 'consum', 0.0221, 'lps'),
	(456887, 125, '2015-03-15 01:21:45.000000', 'consum', 0.0213, 'lps'),
	(456888, 125, '2015-03-15 01:21:46.000000', 'consum', 0.0211, 'lps'),
	(456889, 125, '2015-03-15 01:21:47.000000', 'consum', 0.0224, 'lps'),
	(456890, 125, '2015-03-15 01:21:48.000000', 'consum', 0.0225, 'lps'),
	(456891, 125, '2015-03-15 01:21:49.000000', 'consum', 0.0227, 'lps'),
	(456892, 125, '2015-03-15 01:21:50.000000', 'consum', 0.0213, 'lps'),
	(456893, 125, '2015-03-15 01:21:51.000000', 'consum', 0.0211, 'lps'),
	(456894, 125, '2015-03-15 01:21:52.000000', 'consum', 0.0226, 'lps'),
	(456895, 125, '2015-03-15 01:21:53.000000', 'consum', 0.0215, 'lps'),
	(456896, 125, '2015-03-15 01:21:54.000000', 'consum', 0.0223, 'lps'),
	(456897, 125, '2015-03-15 01:21:55.000000', 'consum', 0.0223, 'lps'),
	(456898, 125, '2015-03-15 01:21:56.000000', 'consum', 0.0218, 'lps'),
	(456899, 125, '2015-03-15 01:21:57.000000', 'consum', 0.0214, 'lps'),
	(456900, 125, '2015-03-15 01:21:58.000000', 'consum', 0.0223, 'lps'),
	(456901, 125, '2015-03-15 01:21:59.000000', 'consum', 0.0226, 'lps'),
	(456902, 125, '2015-03-15 01:22:00.000000', 'consum', 0.0216, 'lps'),
	(456903, 125, '2015-03-15 01:22:01.000000', 'consum', 0.0210, 'lps'),
	(456904, 125, '2015-03-15 01:22:02.000000', 'consum', 0.0212, 'lps'),
	(456905, 125, '2015-03-15 01:22:03.000000', 'consum', 0.0221, 'lps'),
	(456906, 125, '2015-03-15 01:22:04.000000', 'consum', 0.0223, 'lps'),
	(456907, 125, '2015-03-15 01:22:05.000000', 'consum', 0.0224, 'lps'),
	(456908, 125, '2015-03-15 01:22:06.000000', 'consum', 0.0224, 'lps'),
	(456909, 125, '2015-03-15 01:22:07.000000', 'consum', 0.0219, 'lps'),
	(456910, 125, '2015-03-15 01:22:08.000000', 'consum', 0.0216, 'lps'),
	(456911, 125, '2015-03-15 01:22:09.000000', 'consum', 0.0213, 'lps'),
	(456912, 125, '2015-03-15 01:22:10.000000', 'consum', 0.0223, 'lps'),
	(456913, 125, '2015-03-15 01:22:11.000000', 'consum', 0.0214, 'lps'),
	(456914, 125, '2015-03-15 01:22:12.000000', 'consum', 0.0210, 'lps'),
	(456915, 125, '2015-03-15 01:22:13.000000', 'consum', 0.0217, 'lps'),
	(456916, 125, '2015-03-15 01:22:14.000000', 'consum', 0.0227, 'lps'),
	(456917, 125, '2015-03-15 01:22:15.000000', 'consum', 0.0219, 'lps'),
	(456918, 125, '2015-03-15 01:22:16.000000', 'consum', 0.0223, 'lps'),
	(456919, 125, '2015-03-15 01:22:17.000000', 'consum', 0.0213, 'lps'),
	(456920, 125, '2015-03-15 01:22:18.000000', 'consum', 0.0224, 'lps'),
	(456921, 125, '2015-03-15 01:22:19.000000', 'consum', 0.0216, 'lps'),
	(456922, 125, '2015-03-15 01:22:20.000000', 'consum', 0.0217, 'lps'),
	(456923, 125, '2015-03-15 01:22:21.000000', 'consum', 0.0211, 'lps'),
	(456924, 125, '2015-03-15 01:22:22.000000', 'consum', 0.0210, 'lps'),
	(456925, 125, '2015-03-15 01:22:23.000000', 'consum', 0.0227, 'lps'),
	(456926, 125, '2015-03-15 01:22:24.000000', 'consum', 0.0224, 'lps'),
	(456927, 125, '2015-03-15 01:22:25.000000', 'consum', 0.0213, 'lps'),
	(456928, 125, '2015-03-15 01:22:26.000000', 'consum', 0.0217, 'lps'),
	(456929, 125, '2015-03-15 01:22:27.000000', 'consum', 0.0221, 'lps'),
	(456930, 125, '2015-03-15 01:22:28.000000', 'consum', 0.0224, 'lps'),
	(456931, 125, '2015-03-15 01:22:29.000000', 'consum', 0.0212, 'lps'),
	(456932, 125, '2015-03-15 01:22:30.000000', 'consum', 0.0214, 'lps'),
	(456933, 125, '2015-03-15 01:22:31.000000', 'consum', 0.0227, 'lps'),
	(456934, 125, '2015-03-15 01:22:32.000000', 'consum', 0.0210, 'lps'),
	(456935, 125, '2015-03-15 01:22:33.000000', 'consum', 0.0213, 'lps'),
	(456936, 125, '2015-03-15 01:22:34.000000', 'consum', 0.0227, 'lps'),
	(456937, 125, '2015-03-15 01:22:35.000000', 'consum', 0.0213, 'lps'),
	(456938, 125, '2015-03-15 01:22:36.000000', 'consum', 0.0211, 'lps'),
	(456939, 125, '2015-03-15 01:22:37.000000', 'consum', 0.0223, 'lps'),
	(456940, 125, '2015-03-15 01:22:38.000000', 'consum', 0.0221, 'lps'),
	(456941, 125, '2015-03-15 01:22:39.000000', 'consum', 0.0226, 'lps'),
	(456942, 125, '2015-03-15 01:22:40.000000', 'consum', 0.0223, 'lps'),
	(456943, 125, '2015-03-15 01:22:41.000000', 'consum', 0.0225, 'lps'),
	(456944, 125, '2015-03-15 01:22:42.000000', 'consum', 0.0212, 'lps'),
	(456945, 125, '2015-03-15 01:22:43.000000', 'consum', 0.0211, 'lps'),
	(456946, 125, '2015-03-15 01:22:44.000000', 'consum', 0.0210, 'lps'),
	(456947, 125, '2015-03-15 01:22:45.000000', 'consum', 0.0226, 'lps'),
	(456948, 125, '2015-03-15 01:22:46.000000', 'consum', 0.0218, 'lps'),
	(456949, 125, '2015-03-15 01:22:47.000000', 'consum', 0.0222, 'lps'),
	(456950, 125, '2015-03-15 01:22:48.000000', 'consum', 0.0226, 'lps'),
	(456951, 125, '2015-03-15 01:22:49.000000', 'consum', 0.0220, 'lps'),
	(456952, 125, '2015-03-15 01:22:50.000000', 'consum', 0.0213, 'lps'),
	(456953, 125, '2015-03-15 01:22:51.000000', 'consum', 0.0214, 'lps'),
	(456954, 125, '2015-03-15 01:22:52.000000', 'consum', 0.0220, 'lps'),
	(456955, 125, '2015-03-15 01:22:53.000000', 'consum', 0.0211, 'lps'),
	(456956, 125, '2015-03-15 01:22:54.000000', 'consum', 0.0224, 'lps'),
	(456957, 125, '2015-03-15 01:22:55.000000', 'consum', 0.0224, 'lps'),
	(456958, 125, '2015-03-15 01:22:56.000000', 'consum', 0.0218, 'lps'),
	(456959, 125, '2015-03-15 01:22:57.000000', 'consum', 0.0211, 'lps'),
	(456960, 125, '2015-03-15 01:22:58.000000', 'consum', 0.0225, 'lps'),
	(456961, 125, '2015-03-15 01:22:59.000000', 'consum', 0.0211, 'lps'),
	(456962, 125, '2015-03-15 01:23:00.000000', 'consum', 0.0227, 'lps'),
	(456963, 125, '2015-03-15 01:23:01.000000', 'consum', 0.0218, 'lps'),
	(456964, 125, '2015-03-15 01:23:02.000000', 'consum', 0.0217, 'lps'),
	(456965, 125, '2015-03-15 01:23:03.000000', 'consum', 0.0224, 'lps'),
	(456966, 125, '2015-03-15 01:23:04.000000', 'consum', 0.0221, 'lps'),
	(456967, 125, '2015-03-15 01:23:05.000000', 'consum', 0.0223, 'lps'),
	(456968, 125, '2015-03-15 01:23:06.000000', 'consum', 0.0226, 'lps'),
	(456969, 125, '2015-03-15 01:23:07.000000', 'consum', 0.0214, 'lps'),
	(456970, 125, '2015-03-15 01:23:08.000000', 'consum', 0.0218, 'lps'),
	(456971, 125, '2015-03-15 01:23:09.000000', 'consum', 0.0220, 'lps'),
	(456972, 125, '2015-03-15 01:23:10.000000', 'consum', 0.0218, 'lps'),
	(456973, 125, '2015-03-15 01:23:11.000000', 'consum', 0.0223, 'lps'),
	(456974, 125, '2015-03-15 01:23:12.000000', 'consum', 0.0212, 'lps'),
	(456975, 125, '2015-03-15 01:23:13.000000', 'consum', 0.0221, 'lps'),
	(456976, 125, '2015-03-15 01:23:14.000000', 'consum', 0.0221, 'lps'),
	(456977, 125, '2015-03-15 01:23:15.000000', 'consum', 0.0214, 'lps'),
	(456978, 125, '2015-03-15 01:23:16.000000', 'consum', 0.0218, 'lps'),
	(456979, 125, '2015-03-15 01:23:17.000000', 'consum', 0.0219, 'lps'),
	(456980, 125, '2015-03-15 01:23:18.000000', 'consum', 0.0212, 'lps'),
	(456981, 125, '2015-03-15 01:23:19.000000', 'consum', 0.0214, 'lps'),
	(456982, 125, '2015-03-15 01:23:20.000000', 'consum', 0.0224, 'lps'),
	(456983, 125, '2015-03-15 01:23:21.000000', 'consum', 0.0213, 'lps'),
	(456984, 125, '2015-03-15 01:23:22.000000', 'consum', 0.0220, 'lps'),
	(456985, 125, '2015-03-15 01:23:23.000000', 'consum', 0.0217, 'lps'),
	(456986, 125, '2015-03-15 01:23:24.000000', 'consum', 0.0213, 'lps'),
	(456987, 125, '2015-03-15 01:23:25.000000', 'consum', 0.0225, 'lps'),
	(456988, 125, '2015-03-15 01:23:26.000000', 'consum', 0.0223, 'lps'),
	(456989, 125, '2015-03-15 01:23:27.000000', 'consum', 0.0210, 'lps'),
	(456990, 125, '2015-03-15 01:23:28.000000', 'consum', 0.0210, 'lps'),
	(456991, 125, '2015-03-15 01:23:29.000000', 'consum', 0.0211, 'lps'),
	(456992, 125, '2015-03-15 01:23:30.000000', 'consum', 0.0213, 'lps'),
	(456993, 125, '2015-03-15 01:23:31.000000', 'consum', 0.0222, 'lps'),
	(456994, 125, '2015-03-15 01:23:32.000000', 'consum', 0.0227, 'lps'),
	(456995, 125, '2015-03-15 01:23:33.000000', 'consum', 0.0225, 'lps'),
	(456996, 125, '2015-03-15 01:23:34.000000', 'consum', 0.0216, 'lps'),
	(456997, 125, '2015-03-15 01:23:35.000000', 'consum', 0.0211, 'lps'),
	(456998, 125, '2015-03-15 01:23:36.000000', 'consum', 0.0217, 'lps'),
	(456999, 125, '2015-03-15 01:23:37.000000', 'consum', 0.0226, 'lps'),
	(457000, 125, '2015-03-15 01:23:38.000000', 'consum', 0.0213, 'lps'),
	(457001, 125, '2015-03-15 01:23:39.000000', 'consum', 0.0217, 'lps'),
	(457002, 125, '2015-03-15 01:23:40.000000', 'consum', 0.0215, 'lps'),
	(457003, 125, '2015-03-15 01:23:41.000000', 'consum', 0.0214, 'lps'),
	(457004, 125, '2015-03-15 01:23:42.000000', 'consum', 0.0217, 'lps'),
	(457005, 125, '2015-03-15 01:23:43.000000', 'consum', 0.0215, 'lps'),
	(457006, 125, '2015-03-15 01:23:44.000000', 'consum', 0.0216, 'lps'),
	(457007, 125, '2015-03-15 01:23:45.000000', 'consum', 0.0227, 'lps'),
	(457008, 125, '2015-03-15 01:23:46.000000', 'consum', 0.0220, 'lps'),
	(457009, 125, '2015-03-15 01:23:47.000000', 'consum', 0.0210, 'lps'),
	(457010, 125, '2015-03-15 01:23:48.000000', 'consum', 0.0217, 'lps'),
	(457011, 125, '2015-03-15 01:23:49.000000', 'consum', 0.0211, 'lps'),
	(457012, 125, '2015-03-15 01:23:50.000000', 'consum', 0.0211, 'lps'),
	(457013, 125, '2015-03-15 01:23:51.000000', 'consum', 0.0211, 'lps'),
	(457014, 125, '2015-03-15 01:23:52.000000', 'consum', 0.0214, 'lps'),
	(457015, 125, '2015-03-15 01:23:53.000000', 'consum', 0.0226, 'lps'),
	(457016, 125, '2015-03-15 01:23:54.000000', 'consum', 0.0224, 'lps'),
	(457017, 125, '2015-03-15 01:23:55.000000', 'consum', 0.0216, 'lps'),
	(457018, 125, '2015-03-15 01:23:56.000000', 'consum', 0.0216, 'lps'),
	(457019, 125, '2015-03-15 01:23:57.000000', 'consum', 0.0222, 'lps'),
	(457020, 125, '2015-03-15 01:23:58.000000', 'consum', 0.0215, 'lps'),
	(457021, 125, '2015-03-15 01:23:59.000000', 'consum', 0.0219, 'lps'),
	(457022, 125, '2015-03-15 01:24:00.000000', 'consum', 0.0222, 'lps'),
	(457023, 125, '2015-03-15 01:24:01.000000', 'consum', 0.0224, 'lps'),
	(457024, 125, '2015-03-15 01:24:02.000000', 'consum', 0.0210, 'lps'),
	(457025, 125, '2015-03-15 01:24:03.000000', 'consum', 0.0223, 'lps'),
	(457026, 125, '2015-03-15 01:24:04.000000', 'consum', 0.0220, 'lps'),
	(457027, 125, '2015-03-15 01:24:05.000000', 'consum', 0.0222, 'lps'),
	(457028, 125, '2015-03-15 01:24:06.000000', 'consum', 0.0221, 'lps'),
	(457029, 125, '2015-03-15 01:24:07.000000', 'consum', 0.0213, 'lps'),
	(457030, 125, '2015-03-15 01:24:08.000000', 'consum', 0.0212, 'lps'),
	(457031, 125, '2015-03-15 01:24:09.000000', 'consum', 0.0212, 'lps'),
	(457032, 125, '2015-03-15 01:24:10.000000', 'consum', 0.0213, 'lps'),
	(457033, 125, '2015-03-15 01:24:11.000000', 'consum', 0.0222, 'lps'),
	(457034, 125, '2015-03-15 01:24:12.000000', 'consum', 0.0222, 'lps'),
	(457035, 125, '2015-03-15 01:24:13.000000', 'consum', 0.0217, 'lps'),
	(457036, 125, '2015-03-15 01:24:14.000000', 'consum', 0.0212, 'lps'),
	(457037, 125, '2015-03-15 01:24:15.000000', 'consum', 0.0217, 'lps'),
	(457038, 125, '2015-03-15 01:24:16.000000', 'consum', 0.0221, 'lps'),
	(457039, 125, '2015-03-15 01:24:17.000000', 'consum', 0.0210, 'lps'),
	(457040, 125, '2015-03-15 01:24:18.000000', 'consum', 0.0211, 'lps'),
	(457041, 125, '2015-03-15 01:24:19.000000', 'consum', 0.0214, 'lps'),
	(457042, 125, '2015-03-15 01:24:20.000000', 'consum', 0.0213, 'lps'),
	(457043, 125, '2015-03-15 01:24:21.000000', 'consum', 0.0214, 'lps'),
	(457044, 125, '2015-03-15 01:24:22.000000', 'consum', 0.0219, 'lps'),
	(457045, 125, '2015-03-15 01:24:23.000000', 'consum', 0.0225, 'lps'),
	(457046, 125, '2015-03-15 01:24:24.000000', 'consum', 0.0222, 'lps'),
	(457047, 125, '2015-03-15 01:24:25.000000', 'consum', 0.0227, 'lps'),
	(457048, 125, '2015-03-15 01:24:26.000000', 'consum', 0.0222, 'lps'),
	(457049, 125, '2015-03-15 01:24:27.000000', 'consum', 0.0219, 'lps'),
	(457050, 125, '2015-03-15 01:24:28.000000', 'consum', 0.0219, 'lps'),
	(457051, 125, '2015-03-15 01:24:29.000000', 'consum', 0.0213, 'lps'),
	(457052, 125, '2015-03-15 01:24:30.000000', 'consum', 0.0215, 'lps'),
	(457053, 125, '2015-03-15 01:24:31.000000', 'consum', 0.0210, 'lps'),
	(457054, 125, '2015-03-15 01:24:32.000000', 'consum', 0.0213, 'lps'),
	(457055, 125, '2015-03-15 01:24:33.000000', 'consum', 0.0225, 'lps'),
	(457056, 125, '2015-03-15 01:24:34.000000', 'consum', 0.0224, 'lps'),
	(457057, 125, '2015-03-15 01:24:35.000000', 'consum', 0.0216, 'lps'),
	(457058, 125, '2015-03-15 01:24:36.000000', 'consum', 0.0218, 'lps'),
	(457059, 125, '2015-03-15 01:24:37.000000', 'consum', 0.0214, 'lps'),
	(457060, 125, '2015-03-15 01:24:38.000000', 'consum', 0.0224, 'lps'),
	(457061, 125, '2015-03-15 01:24:39.000000', 'consum', 0.0215, 'lps'),
	(457062, 125, '2015-03-15 01:24:40.000000', 'consum', 0.0212, 'lps'),
	(457063, 125, '2015-03-15 01:24:41.000000', 'consum', 0.0224, 'lps'),
	(457064, 125, '2015-03-15 01:24:42.000000', 'consum', 0.0218, 'lps'),
	(457065, 125, '2015-03-15 01:24:43.000000', 'consum', 0.0227, 'lps'),
	(457066, 125, '2015-03-15 01:24:44.000000', 'consum', 0.0219, 'lps'),
	(457067, 125, '2015-03-15 01:24:45.000000', 'consum', 0.0223, 'lps'),
	(457068, 125, '2015-03-15 01:24:46.000000', 'consum', 0.0211, 'lps'),
	(457069, 125, '2015-03-15 01:24:47.000000', 'consum', 0.0213, 'lps'),
	(457070, 125, '2015-03-15 01:24:48.000000', 'consum', 0.0224, 'lps'),
	(457071, 125, '2015-03-15 01:24:49.000000', 'consum', 0.0216, 'lps'),
	(457072, 125, '2015-03-15 01:24:50.000000', 'consum', 0.0215, 'lps'),
	(457073, 125, '2015-03-15 01:24:51.000000', 'consum', 0.0219, 'lps'),
	(457074, 125, '2015-03-15 01:24:52.000000', 'consum', 0.0223, 'lps'),
	(457075, 125, '2015-03-15 01:24:53.000000', 'consum', 0.0213, 'lps'),
	(457076, 125, '2015-03-15 01:24:54.000000', 'consum', 0.0223, 'lps'),
	(457077, 125, '2015-03-15 01:24:55.000000', 'consum', 0.0212, 'lps'),
	(457078, 125, '2015-03-15 01:24:56.000000', 'consum', 0.0217, 'lps'),
	(457079, 125, '2015-03-15 01:24:57.000000', 'consum', 0.0222, 'lps'),
	(457080, 125, '2015-03-15 01:24:58.000000', 'consum', 0.0214, 'lps'),
	(457081, 125, '2015-03-15 01:24:59.000000', 'consum', 0.0213, 'lps'),
	(457082, 125, '2015-03-15 01:25:00.000000', 'consum', 0.0211, 'lps'),
	(457083, 125, '2015-03-15 01:25:01.000000', 'consum', 0.0226, 'lps'),
	(457084, 125, '2015-03-15 01:25:02.000000', 'consum', 0.0217, 'lps'),
	(457085, 125, '2015-03-15 01:25:03.000000', 'consum', 0.0216, 'lps'),
	(457086, 125, '2015-03-15 01:25:04.000000', 'consum', 0.0218, 'lps'),
	(457087, 125, '2015-03-15 01:25:05.000000', 'consum', 0.0213, 'lps'),
	(457088, 125, '2015-03-15 01:25:06.000000', 'consum', 0.0221, 'lps'),
	(457089, 125, '2015-03-15 01:25:07.000000', 'consum', 0.0219, 'lps'),
	(457090, 125, '2015-03-15 01:25:08.000000', 'consum', 0.0223, 'lps'),
	(457091, 125, '2015-03-15 01:25:09.000000', 'consum', 0.0212, 'lps'),
	(457092, 125, '2015-03-15 01:25:10.000000', 'consum', 0.0217, 'lps'),
	(457093, 125, '2015-03-15 01:25:11.000000', 'consum', 0.0223, 'lps'),
	(457094, 125, '2015-03-15 01:25:12.000000', 'consum', 0.0218, 'lps'),
	(457095, 125, '2015-03-15 01:25:13.000000', 'consum', 0.0211, 'lps'),
	(457096, 125, '2015-03-15 01:25:14.000000', 'consum', 0.0210, 'lps'),
	(457097, 125, '2015-03-15 01:25:15.000000', 'consum', 0.0224, 'lps'),
	(457098, 125, '2015-03-15 01:25:16.000000', 'consum', 0.0211, 'lps'),
	(457099, 125, '2015-03-15 01:25:17.000000', 'consum', 0.0211, 'lps'),
	(457100, 125, '2015-03-15 01:25:18.000000', 'consum', 0.0227, 'lps'),
	(457101, 125, '2015-03-15 01:25:19.000000', 'consum', 0.0220, 'lps'),
	(457102, 125, '2015-03-15 01:25:20.000000', 'consum', 0.0212, 'lps'),
	(457103, 125, '2015-03-15 01:25:21.000000', 'consum', 0.0226, 'lps'),
	(457104, 125, '2015-03-15 01:25:22.000000', 'consum', 0.0214, 'lps'),
	(457105, 125, '2015-03-15 01:25:23.000000', 'consum', 0.0218, 'lps'),
	(457106, 125, '2015-03-15 01:25:24.000000', 'consum', 0.0218, 'lps'),
	(457107, 125, '2015-03-15 01:25:25.000000', 'consum', 0.0227, 'lps'),
	(457108, 125, '2015-03-15 01:25:26.000000', 'consum', 0.0220, 'lps'),
	(457109, 125, '2015-03-15 01:25:27.000000', 'consum', 0.0224, 'lps'),
	(457110, 125, '2015-03-15 01:25:28.000000', 'consum', 0.0218, 'lps'),
	(457111, 125, '2015-03-15 01:25:29.000000', 'consum', 0.0224, 'lps'),
	(457112, 125, '2015-03-15 01:25:30.000000', 'consum', 0.0221, 'lps'),
	(457113, 125, '2015-03-15 01:25:31.000000', 'consum', 0.0223, 'lps'),
	(457114, 125, '2015-03-15 01:25:32.000000', 'consum', 0.0226, 'lps'),
	(457115, 125, '2015-03-15 01:25:33.000000', 'consum', 0.0216, 'lps'),
	(457116, 125, '2015-03-15 01:25:34.000000', 'consum', 0.0210, 'lps'),
	(457117, 125, '2015-03-15 01:25:35.000000', 'consum', 0.0210, 'lps'),
	(457118, 125, '2015-03-15 01:25:36.000000', 'consum', 0.0227, 'lps'),
	(457119, 125, '2015-03-15 01:25:37.000000', 'consum', 0.0224, 'lps'),
	(457120, 125, '2015-03-15 01:25:38.000000', 'consum', 0.0214, 'lps'),
	(457121, 125, '2015-03-15 01:25:39.000000', 'consum', 0.0223, 'lps'),
	(457122, 125, '2015-03-15 01:25:40.000000', 'consum', 0.0227, 'lps'),
	(457123, 125, '2015-03-15 01:25:41.000000', 'consum', 0.0219, 'lps'),
	(457124, 125, '2015-03-15 01:25:42.000000', 'consum', 0.0223, 'lps'),
	(457125, 125, '2015-03-15 01:25:43.000000', 'consum', 0.0214, 'lps'),
	(457126, 125, '2015-03-15 01:25:44.000000', 'consum', 0.0210, 'lps'),
	(457127, 125, '2015-03-15 01:25:45.000000', 'consum', 0.0216, 'lps'),
	(457128, 125, '2015-03-15 01:25:46.000000', 'consum', 0.0221, 'lps'),
	(457129, 125, '2015-03-15 01:25:47.000000', 'consum', 0.0214, 'lps'),
	(457130, 125, '2015-03-15 01:25:48.000000', 'consum', 0.0217, 'lps'),
	(457131, 125, '2015-03-15 01:25:49.000000', 'consum', 0.0212, 'lps'),
	(457132, 125, '2015-03-15 01:25:50.000000', 'consum', 0.0217, 'lps'),
	(457133, 125, '2015-03-15 01:25:51.000000', 'consum', 0.0221, 'lps'),
	(457134, 125, '2015-03-15 01:25:52.000000', 'consum', 0.0210, 'lps'),
	(457135, 125, '2015-03-15 01:25:53.000000', 'consum', 0.0215, 'lps'),
	(457136, 125, '2015-03-15 01:25:54.000000', 'consum', 0.0216, 'lps'),
	(457137, 125, '2015-03-15 01:25:55.000000', 'consum', 0.0226, 'lps'),
	(457138, 125, '2015-03-15 01:25:56.000000', 'consum', 0.0220, 'lps'),
	(457139, 125, '2015-03-15 01:25:57.000000', 'consum', 0.0212, 'lps'),
	(457140, 125, '2015-03-15 01:25:58.000000', 'consum', 0.0227, 'lps'),
	(457141, 125, '2015-03-15 01:25:59.000000', 'consum', 0.0216, 'lps'),
	(457142, 125, '2015-03-15 01:26:00.000000', 'consum', 0.0224, 'lps'),
	(457143, 125, '2015-03-15 01:26:01.000000', 'consum', 0.0211, 'lps'),
	(457144, 125, '2015-03-15 01:26:02.000000', 'consum', 0.0210, 'lps'),
	(457145, 125, '2015-03-15 01:26:03.000000', 'consum', 0.0225, 'lps'),
	(457146, 125, '2015-03-15 01:26:04.000000', 'consum', 0.0212, 'lps'),
	(457147, 125, '2015-03-15 01:26:05.000000', 'consum', 0.0213, 'lps'),
	(457148, 125, '2015-03-15 01:26:06.000000', 'consum', 0.0221, 'lps'),
	(457149, 125, '2015-03-15 01:26:07.000000', 'consum', 0.0217, 'lps'),
	(457150, 125, '2015-03-15 01:26:08.000000', 'consum', 0.0215, 'lps'),
	(457151, 125, '2015-03-15 01:26:09.000000', 'consum', 0.0214, 'lps'),
	(457152, 125, '2015-03-15 01:26:10.000000', 'consum', 0.0217, 'lps'),
	(457153, 125, '2015-03-15 01:26:11.000000', 'consum', 0.0214, 'lps'),
	(457154, 125, '2015-03-15 01:26:12.000000', 'consum', 0.0226, 'lps'),
	(457155, 125, '2015-03-15 01:26:13.000000', 'consum', 0.0210, 'lps'),
	(457156, 125, '2015-03-15 01:26:14.000000', 'consum', 0.0213, 'lps'),
	(457157, 125, '2015-03-15 01:26:15.000000', 'consum', 0.0211, 'lps'),
	(457158, 125, '2015-03-15 01:26:16.000000', 'consum', 0.0222, 'lps'),
	(457159, 125, '2015-03-15 01:26:17.000000', 'consum', 0.0213, 'lps'),
	(457160, 125, '2015-03-15 01:26:18.000000', 'consum', 0.0226, 'lps'),
	(457161, 125, '2015-03-15 01:26:19.000000', 'consum', 0.0227, 'lps'),
	(457162, 125, '2015-03-15 01:26:20.000000', 'consum', 0.0211, 'lps'),
	(457163, 125, '2015-03-15 01:26:21.000000', 'consum', 0.0219, 'lps'),
	(457164, 125, '2015-03-15 01:26:22.000000', 'consum', 0.0216, 'lps'),
	(457165, 125, '2015-03-15 01:26:23.000000', 'consum', 0.0214, 'lps'),
	(457166, 125, '2015-03-15 01:26:24.000000', 'consum', 0.0211, 'lps'),
	(457167, 125, '2015-03-15 01:26:25.000000', 'consum', 0.0222, 'lps'),
	(457168, 125, '2015-03-15 01:26:26.000000', 'consum', 0.0212, 'lps'),
	(457169, 125, '2015-03-15 01:26:27.000000', 'consum', 0.0223, 'lps'),
	(457170, 125, '2015-03-15 01:26:28.000000', 'consum', 0.0216, 'lps'),
	(457171, 125, '2015-03-15 01:26:29.000000', 'consum', 0.0219, 'lps'),
	(457172, 125, '2015-03-15 01:26:30.000000', 'consum', 0.0218, 'lps'),
	(457173, 125, '2015-03-15 01:26:31.000000', 'consum', 0.0225, 'lps'),
	(457174, 125, '2015-03-15 01:26:32.000000', 'consum', 0.0227, 'lps'),
	(457175, 125, '2015-03-15 01:26:33.000000', 'consum', 0.0213, 'lps'),
	(457176, 125, '2015-03-15 01:26:34.000000', 'consum', 0.0210, 'lps'),
	(457177, 125, '2015-03-15 01:26:35.000000', 'consum', 0.0220, 'lps'),
	(457178, 125, '2015-03-15 01:26:36.000000', 'consum', 0.0226, 'lps'),
	(457179, 125, '2015-03-15 01:26:37.000000', 'consum', 0.0223, 'lps'),
	(457180, 125, '2015-03-15 01:26:38.000000', 'consum', 0.0210, 'lps'),
	(457181, 125, '2015-03-15 01:26:39.000000', 'consum', 0.0226, 'lps'),
	(457182, 125, '2015-03-15 01:26:40.000000', 'consum', 0.0216, 'lps'),
	(457183, 125, '2015-03-15 01:26:41.000000', 'consum', 0.0212, 'lps'),
	(457184, 125, '2015-03-15 01:26:42.000000', 'consum', 0.0219, 'lps'),
	(457185, 125, '2015-03-15 01:26:43.000000', 'consum', 0.0214, 'lps'),
	(457186, 125, '2015-03-15 01:26:44.000000', 'consum', 0.0223, 'lps'),
	(457187, 125, '2015-03-15 01:26:45.000000', 'consum', 0.0210, 'lps'),
	(457188, 125, '2015-03-15 01:26:46.000000', 'consum', 0.0227, 'lps'),
	(457189, 125, '2015-03-15 01:26:47.000000', 'consum', 0.0220, 'lps'),
	(457190, 125, '2015-03-15 01:26:48.000000', 'consum', 0.0211, 'lps'),
	(457191, 125, '2015-03-15 01:26:49.000000', 'consum', 0.0220, 'lps'),
	(457192, 125, '2015-03-15 01:26:50.000000', 'consum', 0.0222, 'lps'),
	(457193, 125, '2015-03-15 01:26:51.000000', 'consum', 0.0221, 'lps'),
	(457194, 125, '2015-03-15 01:26:52.000000', 'consum', 0.0213, 'lps'),
	(457195, 125, '2015-03-15 01:26:53.000000', 'consum', 0.0226, 'lps'),
	(457196, 125, '2015-03-15 01:26:54.000000', 'consum', 0.0212, 'lps'),
	(457197, 125, '2015-03-15 01:26:55.000000', 'consum', 0.0226, 'lps'),
	(457198, 125, '2015-03-15 01:26:56.000000', 'consum', 0.0214, 'lps'),
	(457199, 125, '2015-03-15 01:26:57.000000', 'consum', 0.0216, 'lps'),
	(457200, 125, '2015-03-15 01:26:58.000000', 'consum', 0.0210, 'lps'),
	(457201, 125, '2015-03-15 01:26:59.000000', 'consum', 0.0211, 'lps'),
	(457202, 125, '2015-03-15 01:27:00.000000', 'consum', 0.0217, 'lps'),
	(457203, 125, '2015-03-15 01:27:01.000000', 'consum', 0.0224, 'lps'),
	(457204, 125, '2015-03-15 01:27:02.000000', 'consum', 0.0223, 'lps'),
	(457205, 125, '2015-03-15 01:27:03.000000', 'consum', 0.0215, 'lps'),
	(457206, 125, '2015-03-15 01:27:04.000000', 'consum', 0.0214, 'lps'),
	(457207, 125, '2015-03-15 01:27:05.000000', 'consum', 0.0217, 'lps'),
	(457208, 125, '2015-03-15 01:27:06.000000', 'consum', 0.0217, 'lps'),
	(457209, 125, '2015-03-15 01:27:07.000000', 'consum', 0.0222, 'lps'),
	(457210, 125, '2015-03-15 01:27:08.000000', 'consum', 0.0213, 'lps'),
	(457211, 125, '2015-03-15 01:27:09.000000', 'consum', 0.0227, 'lps'),
	(457212, 125, '2015-03-15 01:27:10.000000', 'consum', 0.0215, 'lps'),
	(457213, 125, '2015-03-15 01:27:11.000000', 'consum', 0.0221, 'lps'),
	(457214, 125, '2015-03-15 01:27:12.000000', 'consum', 0.0212, 'lps'),
	(457215, 125, '2015-03-15 01:27:13.000000', 'consum', 0.0225, 'lps'),
	(457216, 125, '2015-03-15 01:27:14.000000', 'consum', 0.0225, 'lps'),
	(457217, 125, '2015-03-15 01:27:15.000000', 'consum', 0.0222, 'lps'),
	(457218, 125, '2015-03-15 01:27:16.000000', 'consum', 0.0226, 'lps'),
	(457219, 125, '2015-03-15 01:27:17.000000', 'consum', 0.0219, 'lps'),
	(457220, 125, '2015-03-15 01:27:18.000000', 'consum', 0.0223, 'lps'),
	(457221, 125, '2015-03-15 01:27:19.000000', 'consum', 0.0215, 'lps'),
	(457222, 125, '2015-03-15 01:27:20.000000', 'consum', 0.0213, 'lps'),
	(457223, 125, '2015-03-15 01:27:21.000000', 'consum', 0.0210, 'lps'),
	(457224, 125, '2015-03-15 01:27:22.000000', 'consum', 0.0221, 'lps'),
	(457225, 125, '2015-03-15 01:27:23.000000', 'consum', 0.0210, 'lps'),
	(457226, 125, '2015-03-15 01:27:24.000000', 'consum', 0.0213, 'lps'),
	(457227, 125, '2015-03-15 01:27:25.000000', 'consum', 0.0225, 'lps'),
	(457228, 125, '2015-03-15 01:27:26.000000', 'consum', 0.0222, 'lps'),
	(457229, 125, '2015-03-15 01:27:27.000000', 'consum', 0.0226, 'lps'),
	(457230, 125, '2015-03-15 01:27:28.000000', 'consum', 0.0218, 'lps'),
	(457231, 125, '2015-03-15 01:27:29.000000', 'consum', 0.0219, 'lps'),
	(457232, 125, '2015-03-15 01:27:30.000000', 'consum', 0.0215, 'lps'),
	(457233, 125, '2015-03-15 01:27:31.000000', 'consum', 0.0226, 'lps'),
	(457234, 125, '2015-03-15 01:27:32.000000', 'consum', 0.0222, 'lps'),
	(457235, 125, '2015-03-15 01:27:33.000000', 'consum', 0.0223, 'lps'),
	(457236, 125, '2015-03-15 01:27:34.000000', 'consum', 0.0222, 'lps'),
	(457237, 125, '2015-03-15 01:27:35.000000', 'consum', 0.0211, 'lps'),
	(457238, 125, '2015-03-15 01:27:36.000000', 'consum', 0.0216, 'lps'),
	(457239, 125, '2015-03-15 01:27:37.000000', 'consum', 0.0218, 'lps'),
	(457240, 125, '2015-03-15 01:27:38.000000', 'consum', 0.0216, 'lps'),
	(457241, 125, '2015-03-15 01:27:39.000000', 'consum', 0.0216, 'lps'),
	(457242, 125, '2015-03-15 01:27:40.000000', 'consum', 0.0222, 'lps'),
	(457243, 125, '2015-03-15 01:27:41.000000', 'consum', 0.0218, 'lps'),
	(457244, 125, '2015-03-15 01:27:42.000000', 'consum', 0.0213, 'lps'),
	(457245, 125, '2015-03-15 01:27:43.000000', 'consum', 0.0219, 'lps'),
	(457246, 125, '2015-03-15 01:27:44.000000', 'consum', 0.0227, 'lps'),
	(457247, 125, '2015-03-15 01:27:45.000000', 'consum', 0.0218, 'lps'),
	(457248, 125, '2015-03-15 01:27:46.000000', 'consum', 0.0216, 'lps'),
	(457249, 125, '2015-03-15 01:27:47.000000', 'consum', 0.0217, 'lps'),
	(457250, 125, '2015-03-15 01:27:48.000000', 'consum', 0.0225, 'lps'),
	(457251, 125, '2015-03-15 01:27:49.000000', 'consum', 0.0213, 'lps'),
	(457252, 125, '2015-03-15 01:27:50.000000', 'consum', 0.0214, 'lps'),
	(457253, 125, '2015-03-15 01:27:51.000000', 'consum', 0.0225, 'lps'),
	(457254, 125, '2015-03-15 01:27:52.000000', 'consum', 0.0217, 'lps'),
	(457255, 125, '2015-03-15 01:27:53.000000', 'consum', 0.0220, 'lps'),
	(457256, 125, '2015-03-15 01:27:54.000000', 'consum', 0.0221, 'lps'),
	(457257, 125, '2015-03-15 01:27:55.000000', 'consum', 0.0216, 'lps'),
	(457258, 125, '2015-03-15 01:27:56.000000', 'consum', 0.0225, 'lps'),
	(457259, 125, '2015-03-15 01:27:57.000000', 'consum', 0.0215, 'lps'),
	(457260, 125, '2015-03-15 01:27:58.000000', 'consum', 0.0226, 'lps'),
	(457261, 125, '2015-03-15 01:27:59.000000', 'consum', 0.0221, 'lps'),
	(457262, 125, '2015-03-15 01:28:00.000000', 'consum', 0.0219, 'lps'),
	(457263, 125, '2015-03-15 01:28:01.000000', 'consum', 0.0223, 'lps'),
	(457264, 125, '2015-03-15 01:28:02.000000', 'consum', 0.0213, 'lps'),
	(457265, 125, '2015-03-15 01:28:03.000000', 'consum', 0.0221, 'lps'),
	(457266, 125, '2015-03-15 01:28:04.000000', 'consum', 0.0222, 'lps'),
	(457267, 125, '2015-03-15 01:28:05.000000', 'consum', 0.0220, 'lps'),
	(457268, 125, '2015-03-15 01:28:06.000000', 'consum', 0.0225, 'lps'),
	(457269, 125, '2015-03-15 01:28:07.000000', 'consum', 0.0219, 'lps'),
	(457270, 125, '2015-03-15 01:28:08.000000', 'consum', 0.0210, 'lps'),
	(457271, 125, '2015-03-15 01:28:09.000000', 'consum', 0.0219, 'lps'),
	(457272, 125, '2015-03-15 01:28:10.000000', 'consum', 0.0222, 'lps'),
	(457273, 125, '2015-03-15 01:28:11.000000', 'consum', 0.0224, 'lps'),
	(457274, 125, '2015-03-15 01:28:12.000000', 'consum', 0.0227, 'lps'),
	(457275, 125, '2015-03-15 01:28:13.000000', 'consum', 0.0218, 'lps'),
	(457276, 125, '2015-03-15 01:28:14.000000', 'consum', 0.0216, 'lps'),
	(457277, 125, '2015-03-15 01:28:15.000000', 'consum', 0.0216, 'lps'),
	(457278, 125, '2015-03-15 01:28:16.000000', 'consum', 0.0222, 'lps'),
	(457279, 125, '2015-03-15 01:28:17.000000', 'consum', 0.0218, 'lps'),
	(457280, 125, '2015-03-15 01:28:18.000000', 'consum', 0.0212, 'lps'),
	(457281, 125, '2015-03-15 01:28:19.000000', 'consum', 0.0217, 'lps'),
	(457282, 125, '2015-03-15 01:28:20.000000', 'consum', 0.0219, 'lps'),
	(457283, 125, '2015-03-15 01:28:21.000000', 'consum', 0.0219, 'lps'),
	(457284, 125, '2015-03-15 01:28:22.000000', 'consum', 0.0227, 'lps'),
	(457285, 125, '2015-03-15 01:28:23.000000', 'consum', 0.0217, 'lps'),
	(457286, 125, '2015-03-15 01:28:24.000000', 'consum', 0.0210, 'lps'),
	(457287, 125, '2015-03-15 01:28:25.000000', 'consum', 0.0224, 'lps'),
	(457288, 125, '2015-03-15 01:28:26.000000', 'consum', 0.0211, 'lps'),
	(457289, 125, '2015-03-15 01:28:27.000000', 'consum', 0.0226, 'lps'),
	(457290, 125, '2015-03-15 01:28:28.000000', 'consum', 0.0217, 'lps'),
	(457291, 125, '2015-03-15 01:28:29.000000', 'consum', 0.0214, 'lps'),
	(457292, 125, '2015-03-15 01:28:30.000000', 'consum', 0.0210, 'lps'),
	(457293, 125, '2015-03-15 01:28:31.000000', 'consum', 0.0215, 'lps'),
	(457294, 125, '2015-03-15 01:28:32.000000', 'consum', 0.0217, 'lps'),
	(457295, 125, '2015-03-15 01:28:33.000000', 'consum', 0.0213, 'lps'),
	(457296, 125, '2015-03-15 01:28:34.000000', 'consum', 0.0223, 'lps'),
	(457297, 125, '2015-03-15 01:28:35.000000', 'consum', 0.0211, 'lps'),
	(457298, 125, '2015-03-15 01:28:36.000000', 'consum', 0.0213, 'lps'),
	(457299, 125, '2015-03-15 01:28:37.000000', 'consum', 0.0224, 'lps'),
	(457300, 125, '2015-03-15 01:28:38.000000', 'consum', 0.0217, 'lps'),
	(457301, 125, '2015-03-15 01:28:39.000000', 'consum', 0.0220, 'lps'),
	(457302, 125, '2015-03-15 01:28:40.000000', 'consum', 0.0223, 'lps'),
	(457303, 125, '2015-03-15 01:28:41.000000', 'consum', 0.0227, 'lps'),
	(457304, 125, '2015-03-15 01:28:42.000000', 'consum', 0.0221, 'lps'),
	(457305, 125, '2015-03-15 01:28:43.000000', 'consum', 0.0214, 'lps'),
	(457306, 125, '2015-03-15 01:28:44.000000', 'consum', 0.0215, 'lps'),
	(457307, 125, '2015-03-15 01:28:45.000000', 'consum', 0.0226, 'lps'),
	(457308, 125, '2015-03-15 01:28:46.000000', 'consum', 0.0218, 'lps'),
	(457309, 125, '2015-03-15 01:28:47.000000', 'consum', 0.0224, 'lps'),
	(457310, 125, '2015-03-15 01:28:48.000000', 'consum', 0.0218, 'lps'),
	(457311, 125, '2015-03-15 01:28:49.000000', 'consum', 0.0226, 'lps'),
	(457312, 125, '2015-03-15 01:28:50.000000', 'consum', 0.0211, 'lps'),
	(457313, 125, '2015-03-15 01:28:51.000000', 'consum', 0.0225, 'lps'),
	(457314, 125, '2015-03-15 01:28:52.000000', 'consum', 0.0227, 'lps'),
	(457315, 125, '2015-03-15 01:28:53.000000', 'consum', 0.0215, 'lps'),
	(457316, 125, '2015-03-15 01:28:54.000000', 'consum', 0.0221, 'lps'),
	(457317, 125, '2015-03-15 01:28:55.000000', 'consum', 0.0213, 'lps'),
	(457318, 125, '2015-03-15 01:28:56.000000', 'consum', 0.0212, 'lps'),
	(457319, 125, '2015-03-15 01:28:57.000000', 'consum', 0.0210, 'lps'),
	(457320, 125, '2015-03-15 01:28:58.000000', 'consum', 0.0221, 'lps'),
	(457321, 125, '2015-03-15 01:28:59.000000', 'consum', 0.0214, 'lps'),
	(457322, 125, '2015-03-15 01:29:00.000000', 'consum', 0.0213, 'lps'),
	(457323, 125, '2015-03-15 01:29:01.000000', 'consum', 0.0213, 'lps'),
	(457324, 125, '2015-03-15 01:29:02.000000', 'consum', 0.0219, 'lps'),
	(457325, 125, '2015-03-15 01:29:03.000000', 'consum', 0.0210, 'lps'),
	(457326, 125, '2015-03-15 01:29:04.000000', 'consum', 0.0220, 'lps'),
	(457327, 125, '2015-03-15 01:29:05.000000', 'consum', 0.0225, 'lps'),
	(457328, 125, '2015-03-15 01:29:06.000000', 'consum', 0.0217, 'lps'),
	(457329, 125, '2015-03-15 01:29:07.000000', 'consum', 0.0220, 'lps'),
	(457330, 125, '2015-03-15 01:29:08.000000', 'consum', 0.0221, 'lps'),
	(457331, 125, '2015-03-15 01:29:09.000000', 'consum', 0.0220, 'lps'),
	(457332, 125, '2015-03-15 01:29:10.000000', 'consum', 0.0225, 'lps'),
	(457333, 125, '2015-03-15 01:29:11.000000', 'consum', 0.0221, 'lps'),
	(457334, 125, '2015-03-15 01:29:12.000000', 'consum', 0.0221, 'lps'),
	(457335, 125, '2015-03-15 01:29:13.000000', 'consum', 0.0213, 'lps'),
	(457336, 125, '2015-03-15 01:29:14.000000', 'consum', 0.0212, 'lps'),
	(457337, 125, '2015-03-15 01:29:15.000000', 'consum', 0.0212, 'lps'),
	(457338, 125, '2015-03-15 01:29:16.000000', 'consum', 0.0214, 'lps'),
	(457339, 125, '2015-03-15 01:29:17.000000', 'consum', 0.0224, 'lps'),
	(457340, 125, '2015-03-15 01:29:18.000000', 'consum', 0.0214, 'lps'),
	(457341, 125, '2015-03-15 01:29:19.000000', 'consum', 0.0225, 'lps'),
	(457342, 125, '2015-03-15 01:29:20.000000', 'consum', 0.0219, 'lps'),
	(457343, 125, '2015-03-15 01:29:21.000000', 'consum', 0.0212, 'lps'),
	(457344, 125, '2015-03-15 01:29:22.000000', 'consum', 0.0211, 'lps'),
	(457345, 125, '2015-03-15 01:29:23.000000', 'consum', 0.0226, 'lps'),
	(457346, 125, '2015-03-15 01:29:24.000000', 'consum', 0.0218, 'lps'),
	(457347, 125, '2015-03-15 01:29:25.000000', 'consum', 0.0221, 'lps'),
	(457348, 125, '2015-03-15 01:29:26.000000', 'consum', 0.0221, 'lps'),
	(457349, 125, '2015-03-15 01:29:27.000000', 'consum', 0.0214, 'lps'),
	(457350, 125, '2015-03-15 01:29:28.000000', 'consum', 0.0218, 'lps'),
	(457351, 125, '2015-03-15 01:29:29.000000', 'consum', 0.0220, 'lps'),
	(457352, 125, '2015-03-15 01:29:30.000000', 'consum', 0.0220, 'lps'),
	(457353, 125, '2015-03-15 01:29:31.000000', 'consum', 0.0211, 'lps'),
	(457354, 125, '2015-03-15 01:29:32.000000', 'consum', 0.0222, 'lps'),
	(457355, 125, '2015-03-15 01:29:33.000000', 'consum', 0.0212, 'lps'),
	(457356, 125, '2015-03-15 01:29:34.000000', 'consum', 0.0222, 'lps'),
	(457357, 125, '2015-03-15 01:29:35.000000', 'consum', 0.0227, 'lps'),
	(457358, 125, '2015-03-15 01:29:36.000000', 'consum', 0.0224, 'lps'),
	(457359, 125, '2015-03-15 01:29:37.000000', 'consum', 0.0212, 'lps'),
	(457360, 125, '2015-03-15 01:29:38.000000', 'consum', 0.0216, 'lps'),
	(457361, 125, '2015-03-15 01:29:39.000000', 'consum', 0.0215, 'lps'),
	(457362, 125, '2015-03-15 01:29:40.000000', 'consum', 0.0218, 'lps'),
	(457363, 125, '2015-03-15 01:29:41.000000', 'consum', 0.0218, 'lps'),
	(457364, 125, '2015-03-15 01:29:42.000000', 'consum', 0.0227, 'lps'),
	(457365, 125, '2015-03-15 01:29:43.000000', 'consum', 0.0215, 'lps'),
	(457366, 125, '2015-03-15 01:29:44.000000', 'consum', 0.0223, 'lps'),
	(457367, 125, '2015-03-15 01:29:45.000000', 'consum', 0.0225, 'lps'),
	(457368, 125, '2015-03-15 01:29:46.000000', 'consum', 0.0227, 'lps'),
	(457369, 125, '2015-03-15 01:29:47.000000', 'consum', 0.0213, 'lps'),
	(457370, 125, '2015-03-15 01:29:48.000000', 'consum', 0.0212, 'lps'),
	(457371, 125, '2015-03-15 01:29:49.000000', 'consum', 0.0210, 'lps'),
	(457372, 125, '2015-03-15 01:29:50.000000', 'consum', 0.0225, 'lps'),
	(457373, 125, '2015-03-15 01:29:51.000000', 'consum', 0.0214, 'lps'),
	(457374, 125, '2015-03-15 01:29:52.000000', 'consum', 0.0219, 'lps'),
	(457375, 125, '2015-03-15 01:29:53.000000', 'consum', 0.0225, 'lps'),
	(457376, 125, '2015-03-15 01:29:54.000000', 'consum', 0.0225, 'lps'),
	(457377, 125, '2015-03-15 01:29:55.000000', 'consum', 0.0223, 'lps'),
	(457378, 125, '2015-03-15 01:29:56.000000', 'consum', 0.0212, 'lps'),
	(457379, 125, '2015-03-15 01:29:57.000000', 'consum', 0.0217, 'lps'),
	(457380, 125, '2015-03-15 01:29:58.000000', 'consum', 0.0221, 'lps'),
	(457381, 125, '2015-03-15 01:29:59.000000', 'consum', 0.0226, 'lps'),
	(457382, 125, '2015-03-15 01:30:00.000000', 'consum', 0.0222, 'lps'),
	(457383, 125, '2015-03-15 01:30:01.000000', 'consum', 0.0222, 'lps'),
	(457384, 125, '2015-03-15 01:30:02.000000', 'consum', 0.0215, 'lps'),
	(457385, 125, '2015-03-15 01:30:03.000000', 'consum', 0.0220, 'lps'),
	(457386, 125, '2015-03-15 01:30:04.000000', 'consum', 0.0225, 'lps'),
	(457387, 125, '2015-03-15 01:30:05.000000', 'consum', 0.0222, 'lps'),
	(457388, 125, '2015-03-15 01:30:06.000000', 'consum', 0.0225, 'lps'),
	(457389, 125, '2015-03-15 01:30:07.000000', 'consum', 0.0213, 'lps'),
	(457390, 125, '2015-03-15 01:30:08.000000', 'consum', 0.0215, 'lps'),
	(457391, 125, '2015-03-15 01:30:09.000000', 'consum', 0.0227, 'lps'),
	(457392, 125, '2015-03-15 01:30:10.000000', 'consum', 0.0211, 'lps'),
	(457393, 125, '2015-03-15 01:30:11.000000', 'consum', 0.0216, 'lps'),
	(457394, 125, '2015-03-15 01:30:12.000000', 'consum', 0.0221, 'lps'),
	(457395, 125, '2015-03-15 01:30:13.000000', 'consum', 0.0211, 'lps'),
	(457396, 125, '2015-03-15 01:30:14.000000', 'consum', 0.0220, 'lps'),
	(457397, 125, '2015-03-15 01:30:15.000000', 'consum', 0.0220, 'lps'),
	(457398, 125, '2015-03-15 01:30:16.000000', 'consum', 0.0214, 'lps'),
	(457399, 125, '2015-03-15 01:30:17.000000', 'consum', 0.0216, 'lps'),
	(457400, 125, '2015-03-15 01:30:18.000000', 'consum', 0.0213, 'lps'),
	(457401, 125, '2015-03-15 01:30:19.000000', 'consum', 0.0224, 'lps'),
	(457402, 125, '2015-03-15 01:30:20.000000', 'consum', 0.0217, 'lps'),
	(457403, 125, '2015-03-15 01:30:21.000000', 'consum', 0.0221, 'lps'),
	(457404, 125, '2015-03-15 01:30:22.000000', 'consum', 0.0227, 'lps'),
	(457405, 125, '2015-03-15 01:30:23.000000', 'consum', 0.0226, 'lps'),
	(457406, 125, '2015-03-15 01:30:24.000000', 'consum', 0.0222, 'lps'),
	(457407, 125, '2015-03-15 01:30:25.000000', 'consum', 0.0223, 'lps'),
	(457408, 125, '2015-03-15 01:30:26.000000', 'consum', 0.0221, 'lps'),
	(457409, 125, '2015-03-15 01:30:27.000000', 'consum', 0.0225, 'lps'),
	(457410, 125, '2015-03-15 01:30:28.000000', 'consum', 0.0216, 'lps'),
	(457411, 125, '2015-03-15 01:30:29.000000', 'consum', 0.0217, 'lps'),
	(457412, 125, '2015-03-15 01:30:30.000000', 'consum', 0.0225, 'lps'),
	(457413, 125, '2015-03-15 01:30:31.000000', 'consum', 0.0210, 'lps'),
	(457414, 125, '2015-03-15 01:30:32.000000', 'consum', 0.0221, 'lps'),
	(457415, 125, '2015-03-15 01:30:33.000000', 'consum', 0.0227, 'lps'),
	(457416, 125, '2015-03-15 01:30:34.000000', 'consum', 0.0211, 'lps'),
	(457417, 125, '2015-03-15 01:30:35.000000', 'consum', 0.0217, 'lps'),
	(457418, 125, '2015-03-15 01:30:36.000000', 'consum', 0.0224, 'lps'),
	(457419, 125, '2015-03-15 01:30:37.000000', 'consum', 0.0225, 'lps'),
	(457420, 125, '2015-03-15 01:30:38.000000', 'consum', 0.0227, 'lps'),
	(457421, 125, '2015-03-15 01:30:39.000000', 'consum', 0.0213, 'lps'),
	(457422, 125, '2015-03-15 01:30:40.000000', 'consum', 0.0210, 'lps'),
	(457423, 125, '2015-03-15 01:30:41.000000', 'consum', 0.0220, 'lps'),
	(457424, 125, '2015-03-15 01:30:42.000000', 'consum', 0.0226, 'lps'),
	(457425, 125, '2015-03-15 01:30:43.000000', 'consum', 0.0223, 'lps'),
	(457426, 125, '2015-03-15 01:30:44.000000', 'consum', 0.0227, 'lps'),
	(457427, 125, '2015-03-15 01:30:45.000000', 'consum', 0.0219, 'lps'),
	(457428, 125, '2015-03-15 01:30:46.000000', 'consum', 0.0224, 'lps'),
	(457429, 125, '2015-03-15 01:30:47.000000', 'consum', 0.0218, 'lps'),
	(457430, 125, '2015-03-15 01:30:48.000000', 'consum', 0.0225, 'lps'),
	(457431, 125, '2015-03-15 01:30:49.000000', 'consum', 0.0224, 'lps'),
	(457432, 125, '2015-03-15 01:30:50.000000', 'consum', 0.0220, 'lps'),
	(457433, 125, '2015-03-15 01:30:51.000000', 'consum', 0.0218, 'lps'),
	(457434, 125, '2015-03-15 01:30:52.000000', 'consum', 0.0219, 'lps'),
	(457435, 125, '2015-03-15 01:30:53.000000', 'consum', 0.0216, 'lps'),
	(457436, 125, '2015-03-15 01:30:54.000000', 'consum', 0.0213, 'lps'),
	(457437, 125, '2015-03-15 01:30:55.000000', 'consum', 0.0227, 'lps'),
	(457438, 125, '2015-03-15 01:30:56.000000', 'consum', 0.0214, 'lps'),
	(457439, 125, '2015-03-15 01:30:57.000000', 'consum', 0.0214, 'lps'),
	(457440, 125, '2015-03-15 01:30:58.000000', 'consum', 0.0219, 'lps'),
	(457441, 125, '2015-03-15 01:30:59.000000', 'consum', 0.0227, 'lps'),
	(457442, 125, '2015-03-15 01:31:00.000000', 'consum', 0.0213, 'lps'),
	(457443, 125, '2015-03-15 01:31:01.000000', 'consum', 0.0210, 'lps'),
	(457444, 125, '2015-03-15 01:31:02.000000', 'consum', 0.0219, 'lps'),
	(457445, 125, '2015-03-15 01:31:03.000000', 'consum', 0.0222, 'lps'),
	(457446, 125, '2015-03-15 01:31:04.000000', 'consum', 0.0225, 'lps'),
	(457447, 125, '2015-03-15 01:31:05.000000', 'consum', 0.0215, 'lps'),
	(457448, 125, '2015-03-15 01:31:06.000000', 'consum', 0.0225, 'lps'),
	(457449, 125, '2015-03-15 01:31:07.000000', 'consum', 0.0216, 'lps'),
	(457450, 125, '2015-03-15 01:31:08.000000', 'consum', 0.0214, 'lps'),
	(457451, 125, '2015-03-15 01:31:09.000000', 'consum', 0.0212, 'lps'),
	(457452, 125, '2015-03-15 01:31:10.000000', 'consum', 0.0227, 'lps'),
	(457453, 125, '2015-03-15 01:31:11.000000', 'consum', 0.0218, 'lps'),
	(457454, 125, '2015-03-15 01:31:12.000000', 'consum', 0.0216, 'lps'),
	(457455, 125, '2015-03-15 01:31:13.000000', 'consum', 0.0218, 'lps'),
	(457456, 125, '2015-03-15 01:31:14.000000', 'consum', 0.0213, 'lps'),
	(457457, 125, '2015-03-15 01:31:15.000000', 'consum', 0.0219, 'lps'),
	(457458, 125, '2015-03-15 01:31:16.000000', 'consum', 0.0211, 'lps'),
	(457459, 125, '2015-03-15 01:31:17.000000', 'consum', 0.0224, 'lps'),
	(457460, 125, '2015-03-15 01:31:18.000000', 'consum', 0.0222, 'lps'),
	(457461, 125, '2015-03-15 01:31:19.000000', 'consum', 0.0214, 'lps'),
	(457462, 125, '2015-03-15 01:31:20.000000', 'consum', 0.0211, 'lps'),
	(457463, 125, '2015-03-15 01:31:21.000000', 'consum', 0.0222, 'lps'),
	(457464, 125, '2015-03-15 01:31:22.000000', 'consum', 0.0215, 'lps'),
	(457465, 125, '2015-03-15 01:31:23.000000', 'consum', 0.0214, 'lps'),
	(457466, 125, '2015-03-15 01:31:24.000000', 'consum', 0.0218, 'lps'),
	(457467, 125, '2015-03-15 01:31:25.000000', 'consum', 0.0220, 'lps'),
	(457468, 125, '2015-03-15 01:31:26.000000', 'consum', 0.0217, 'lps'),
	(457469, 125, '2015-03-15 01:31:27.000000', 'consum', 0.0215, 'lps'),
	(457470, 125, '2015-03-15 01:31:28.000000', 'consum', 0.0215, 'lps'),
	(457471, 125, '2015-03-15 01:31:29.000000', 'consum', 0.0220, 'lps'),
	(457472, 125, '2015-03-15 01:31:30.000000', 'consum', 0.0212, 'lps'),
	(457473, 125, '2015-03-15 01:31:31.000000', 'consum', 0.0226, 'lps'),
	(457474, 125, '2015-03-15 01:31:32.000000', 'consum', 0.0212, 'lps'),
	(457475, 125, '2015-03-15 01:31:33.000000', 'consum', 0.0225, 'lps'),
	(457476, 125, '2015-03-15 01:31:34.000000', 'consum', 0.0210, 'lps'),
	(457477, 125, '2015-03-15 01:31:35.000000', 'consum', 0.0218, 'lps'),
	(457478, 125, '2015-03-15 01:31:36.000000', 'consum', 0.0213, 'lps'),
	(457479, 125, '2015-03-15 01:31:37.000000', 'consum', 0.0220, 'lps'),
	(457480, 125, '2015-03-15 01:31:38.000000', 'consum', 0.0214, 'lps'),
	(457481, 125, '2015-03-15 01:31:39.000000', 'consum', 0.0221, 'lps'),
	(457482, 125, '2015-03-15 01:31:40.000000', 'consum', 0.0219, 'lps'),
	(457483, 125, '2015-03-15 01:31:41.000000', 'consum', 0.0220, 'lps'),
	(457484, 125, '2015-03-15 01:31:42.000000', 'consum', 0.0217, 'lps'),
	(457485, 125, '2015-03-15 01:31:43.000000', 'consum', 0.0215, 'lps'),
	(457486, 125, '2015-03-15 01:31:44.000000', 'consum', 0.0215, 'lps'),
	(457487, 125, '2015-03-15 01:31:45.000000', 'consum', 0.0220, 'lps'),
	(457488, 125, '2015-03-15 01:31:46.000000', 'consum', 0.0211, 'lps'),
	(457489, 125, '2015-03-15 01:31:47.000000', 'consum', 0.0219, 'lps'),
	(457490, 125, '2015-03-15 01:31:48.000000', 'consum', 0.0217, 'lps'),
	(457491, 125, '2015-03-15 01:31:49.000000', 'consum', 0.0219, 'lps'),
	(457492, 125, '2015-03-15 01:31:50.000000', 'consum', 0.0215, 'lps'),
	(457493, 125, '2015-03-15 01:31:51.000000', 'consum', 0.0211, 'lps'),
	(457494, 125, '2015-03-15 01:31:52.000000', 'consum', 0.0215, 'lps'),
	(457495, 125, '2015-03-15 01:31:53.000000', 'consum', 0.0218, 'lps'),
	(457496, 125, '2015-03-15 01:31:54.000000', 'consum', 0.0215, 'lps'),
	(457497, 125, '2015-03-15 01:31:55.000000', 'consum', 0.0212, 'lps'),
	(457498, 125, '2015-03-15 01:31:56.000000', 'consum', 0.0225, 'lps'),
	(457499, 125, '2015-03-15 01:31:57.000000', 'consum', 0.0225, 'lps'),
	(457500, 125, '2015-03-15 01:31:58.000000', 'consum', 0.0223, 'lps'),
	(457501, 125, '2015-03-15 01:31:59.000000', 'consum', 0.0213, 'lps'),
	(457502, 125, '2015-03-15 01:32:00.000000', 'consum', 0.0222, 'lps'),
	(457503, 125, '2015-03-15 01:32:01.000000', 'consum', 0.0224, 'lps'),
	(457504, 125, '2015-03-15 01:32:02.000000', 'consum', 0.0227, 'lps'),
	(457505, 125, '2015-03-15 01:32:03.000000', 'consum', 0.0217, 'lps'),
	(457506, 125, '2015-03-15 01:32:04.000000', 'consum', 0.0213, 'lps'),
	(457507, 125, '2015-03-15 01:32:05.000000', 'consum', 0.0223, 'lps'),
	(457508, 125, '2015-03-15 01:32:06.000000', 'consum', 0.0212, 'lps'),
	(457509, 125, '2015-03-15 01:32:07.000000', 'consum', 0.0216, 'lps'),
	(457510, 125, '2015-03-15 01:32:08.000000', 'consum', 0.0218, 'lps'),
	(457511, 125, '2015-03-15 01:32:09.000000', 'consum', 0.0213, 'lps'),
	(457512, 125, '2015-03-15 01:32:10.000000', 'consum', 0.0219, 'lps'),
	(457513, 125, '2015-03-15 01:32:11.000000', 'consum', 0.0211, 'lps'),
	(457514, 125, '2015-03-15 01:32:12.000000', 'consum', 0.0224, 'lps'),
	(457515, 125, '2015-03-15 01:32:13.000000', 'consum', 0.0223, 'lps'),
	(457516, 125, '2015-03-15 01:32:14.000000', 'consum', 0.0215, 'lps'),
	(457517, 125, '2015-03-15 01:32:15.000000', 'consum', 0.0215, 'lps'),
	(457518, 125, '2015-03-15 01:32:16.000000', 'consum', 0.0219, 'lps'),
	(457519, 125, '2015-03-15 01:32:17.000000', 'consum', 0.0224, 'lps'),
	(457520, 125, '2015-03-15 01:32:18.000000', 'consum', 0.0215, 'lps'),
	(457521, 125, '2015-03-15 01:32:19.000000', 'consum', 0.0215, 'lps'),
	(457522, 125, '2015-03-15 01:32:20.000000', 'consum', 0.0218, 'lps'),
	(457523, 125, '2015-03-15 01:32:21.000000', 'consum', 0.0220, 'lps'),
	(457524, 125, '2015-03-15 01:32:22.000000', 'consum', 0.0216, 'lps'),
	(457525, 125, '2015-03-15 01:32:23.000000', 'consum', 0.0211, 'lps'),
	(457526, 125, '2015-03-15 01:32:24.000000', 'consum', 0.0214, 'lps'),
	(457527, 125, '2015-03-15 01:32:25.000000', 'consum', 0.0212, 'lps'),
	(457528, 125, '2015-03-15 01:32:26.000000', 'consum', 0.0227, 'lps'),
	(457529, 125, '2015-03-15 01:32:27.000000', 'consum', 0.0216, 'lps'),
	(457530, 125, '2015-03-15 01:32:28.000000', 'consum', 0.0227, 'lps'),
	(457531, 125, '2015-03-15 01:32:29.000000', 'consum', 0.0224, 'lps'),
	(457532, 125, '2015-03-15 01:32:30.000000', 'consum', 0.0227, 'lps'),
	(457533, 125, '2015-03-15 01:32:31.000000', 'consum', 0.0219, 'lps'),
	(457534, 125, '2015-03-15 01:32:32.000000', 'consum', 0.0223, 'lps'),
	(457535, 125, '2015-03-15 01:32:33.000000', 'consum', 0.0213, 'lps'),
	(457536, 125, '2015-03-15 01:32:34.000000', 'consum', 0.0220, 'lps'),
	(457537, 125, '2015-03-15 01:32:35.000000', 'consum', 0.0216, 'lps'),
	(457538, 125, '2015-03-15 01:32:36.000000', 'consum', 0.0212, 'lps'),
	(457539, 125, '2015-03-15 01:32:37.000000', 'consum', 0.0218, 'lps'),
	(457540, 125, '2015-03-15 01:32:38.000000', 'consum', 0.0211, 'lps'),
	(457541, 125, '2015-03-15 01:32:39.000000', 'consum', 0.0225, 'lps'),
	(457542, 125, '2015-03-15 01:32:40.000000', 'consum', 0.0214, 'lps'),
	(457543, 125, '2015-03-15 01:32:41.000000', 'consum', 0.0218, 'lps'),
	(457544, 125, '2015-03-15 01:32:42.000000', 'consum', 0.0222, 'lps'),
	(457545, 125, '2015-03-15 01:32:43.000000', 'consum', 0.0211, 'lps'),
	(457546, 125, '2015-03-15 01:32:44.000000', 'consum', 0.0216, 'lps'),
	(457547, 125, '2015-03-15 01:32:45.000000', 'consum', 0.0218, 'lps'),
	(457548, 125, '2015-03-15 01:32:46.000000', 'consum', 0.0214, 'lps'),
	(457549, 125, '2015-03-15 01:32:47.000000', 'consum', 0.0226, 'lps'),
	(457550, 125, '2015-03-15 01:32:48.000000', 'consum', 0.0224, 'lps'),
	(457551, 125, '2015-03-15 01:32:49.000000', 'consum', 0.0217, 'lps'),
	(457552, 125, '2015-03-15 01:32:50.000000', 'consum', 0.0218, 'lps'),
	(457553, 125, '2015-03-15 01:32:51.000000', 'consum', 0.0211, 'lps'),
	(457554, 125, '2015-03-15 01:32:52.000000', 'consum', 0.0212, 'lps'),
	(457555, 125, '2015-03-15 01:32:53.000000', 'consum', 0.0217, 'lps'),
	(457556, 125, '2015-03-15 01:32:54.000000', 'consum', 0.0222, 'lps'),
	(457557, 125, '2015-03-15 01:32:55.000000', 'consum', 0.0213, 'lps'),
	(457558, 125, '2015-03-15 01:32:56.000000', 'consum', 0.0226, 'lps'),
	(457559, 125, '2015-03-15 01:32:57.000000', 'consum', 0.0226, 'lps'),
	(457560, 125, '2015-03-15 01:32:58.000000', 'consum', 0.0225, 'lps'),
	(457561, 125, '2015-03-15 01:32:59.000000', 'consum', 0.0219, 'lps'),
	(457562, 125, '2015-03-15 01:33:00.000000', 'consum', 0.0212, 'lps'),
	(457563, 125, '2015-03-15 01:33:01.000000', 'consum', 0.0211, 'lps'),
	(457564, 125, '2015-03-15 01:33:02.000000', 'consum', 0.0210, 'lps'),
	(457565, 125, '2015-03-15 01:33:03.000000', 'consum', 0.0224, 'lps'),
	(457566, 125, '2015-03-15 01:33:04.000000', 'consum', 0.0210, 'lps'),
	(457567, 125, '2015-03-15 01:33:05.000000', 'consum', 0.0223, 'lps'),
	(457568, 125, '2015-03-15 01:33:06.000000', 'consum', 0.0223, 'lps'),
	(457569, 125, '2015-03-15 01:33:07.000000', 'consum', 0.0215, 'lps'),
	(457570, 125, '2015-03-15 01:33:08.000000', 'consum', 0.0217, 'lps'),
	(457571, 125, '2015-03-15 01:33:09.000000', 'consum', 0.0213, 'lps'),
	(457572, 125, '2015-03-15 01:33:10.000000', 'consum', 0.0220, 'lps'),
	(457573, 125, '2015-03-15 01:33:11.000000', 'consum', 0.0215, 'lps'),
	(457574, 125, '2015-03-15 01:33:12.000000', 'consum', 0.0223, 'lps'),
	(457575, 125, '2015-03-15 01:33:13.000000', 'consum', 0.0225, 'lps'),
	(457576, 125, '2015-03-15 01:33:14.000000', 'consum', 0.0211, 'lps'),
	(457577, 125, '2015-03-15 01:33:15.000000', 'consum', 0.0226, 'lps'),
	(457578, 125, '2015-03-15 01:33:16.000000', 'consum', 0.0214, 'lps'),
	(457579, 125, '2015-03-15 01:33:17.000000', 'consum', 0.0218, 'lps'),
	(457580, 125, '2015-03-15 01:33:18.000000', 'consum', 0.0222, 'lps'),
	(457581, 125, '2015-03-15 01:33:19.000000', 'consum', 0.0211, 'lps'),
	(457582, 125, '2015-03-15 01:33:20.000000', 'consum', 0.0215, 'lps'),
	(457583, 125, '2015-03-15 01:33:21.000000', 'consum', 0.0214, 'lps'),
	(457584, 125, '2015-03-15 01:33:22.000000', 'consum', 0.0216, 'lps'),
	(457585, 125, '2015-03-15 01:33:23.000000', 'consum', 0.0211, 'lps'),
	(457586, 125, '2015-03-15 01:33:24.000000', 'consum', 0.0215, 'lps'),
	(457587, 125, '2015-03-15 01:33:25.000000', 'consum', 0.0214, 'lps'),
	(457588, 125, '2015-03-15 01:33:26.000000', 'consum', 0.0214, 'lps'),
	(457589, 125, '2015-03-15 01:33:27.000000', 'consum', 0.0220, 'lps'),
	(457590, 125, '2015-03-15 01:33:28.000000', 'consum', 0.0211, 'lps'),
	(457591, 125, '2015-03-15 01:33:29.000000', 'consum', 0.0223, 'lps'),
	(457592, 125, '2015-03-15 01:33:30.000000', 'consum', 0.0219, 'lps'),
	(457593, 125, '2015-03-15 01:33:31.000000', 'consum', 0.0215, 'lps'),
	(457594, 125, '2015-03-15 01:33:32.000000', 'consum', 0.0210, 'lps'),
	(457595, 125, '2015-03-15 01:33:33.000000', 'consum', 0.0213, 'lps'),
	(457596, 125, '2015-03-15 01:33:34.000000', 'consum', 0.0210, 'lps'),
	(457597, 125, '2015-03-15 01:33:35.000000', 'consum', 0.0216, 'lps'),
	(457598, 125, '2015-03-15 01:33:36.000000', 'consum', 0.0222, 'lps'),
	(457599, 125, '2015-03-15 01:33:37.000000', 'consum', 0.0217, 'lps'),
	(457600, 125, '2015-03-15 01:33:38.000000', 'consum', 0.0227, 'lps'),
	(457601, 125, '2015-03-15 01:33:39.000000', 'consum', 0.0223, 'lps'),
	(457602, 125, '2015-03-15 01:33:40.000000', 'consum', 0.0222, 'lps'),
	(457603, 125, '2015-03-15 01:33:41.000000', 'consum', 0.0216, 'lps'),
	(457604, 125, '2015-03-15 01:33:42.000000', 'consum', 0.0220, 'lps'),
	(457605, 125, '2015-03-15 01:33:43.000000', 'consum', 0.0223, 'lps'),
	(457606, 125, '2015-03-15 01:33:44.000000', 'consum', 0.0213, 'lps'),
	(457607, 125, '2015-03-15 01:33:45.000000', 'consum', 0.0220, 'lps'),
	(457608, 125, '2015-03-15 01:33:46.000000', 'consum', 0.0217, 'lps'),
	(457609, 125, '2015-03-15 01:33:47.000000', 'consum', 0.0217, 'lps'),
	(457610, 125, '2015-03-15 01:33:48.000000', 'consum', 0.0223, 'lps'),
	(457611, 125, '2015-03-15 01:33:49.000000', 'consum', 0.0218, 'lps'),
	(457612, 125, '2015-03-15 01:33:50.000000', 'consum', 0.0211, 'lps'),
	(457613, 125, '2015-03-15 01:33:51.000000', 'consum', 0.0211, 'lps'),
	(457614, 125, '2015-03-15 01:33:52.000000', 'consum', 0.0212, 'lps'),
	(457615, 125, '2015-03-15 01:33:53.000000', 'consum', 0.0216, 'lps'),
	(457616, 125, '2015-03-15 01:33:54.000000', 'consum', 0.0218, 'lps'),
	(457617, 125, '2015-03-15 01:33:55.000000', 'consum', 0.0214, 'lps'),
	(457618, 125, '2015-03-15 01:33:56.000000', 'consum', 0.0225, 'lps'),
	(457619, 125, '2015-03-15 01:33:57.000000', 'consum', 0.0221, 'lps'),
	(457620, 125, '2015-03-15 01:33:58.000000', 'consum', 0.0220, 'lps'),
	(457621, 125, '2015-03-15 01:33:59.000000', 'consum', 0.0225, 'lps'),
	(457622, 125, '2015-03-15 01:34:00.000000', 'consum', 0.0221, 'lps'),
	(457623, 125, '2015-03-15 01:34:01.000000', 'consum', 0.0220, 'lps'),
	(457624, 125, '2015-03-15 01:34:02.000000', 'consum', 0.0210, 'lps'),
	(457625, 125, '2015-03-15 01:34:03.000000', 'consum', 0.0216, 'lps'),
	(457626, 125, '2015-03-15 01:34:04.000000', 'consum', 0.0225, 'lps'),
	(457627, 125, '2015-03-15 01:34:05.000000', 'consum', 0.0211, 'lps'),
	(457628, 125, '2015-03-15 01:34:06.000000', 'consum', 0.0226, 'lps'),
	(457629, 125, '2015-03-15 01:34:07.000000', 'consum', 0.0213, 'lps'),
	(457630, 125, '2015-03-15 01:34:08.000000', 'consum', 0.0215, 'lps'),
	(457631, 125, '2015-03-15 01:34:09.000000', 'consum', 0.0210, 'lps'),
	(457632, 125, '2015-03-15 01:34:10.000000', 'consum', 0.0211, 'lps'),
	(457633, 125, '2015-03-15 01:34:11.000000', 'consum', 0.0218, 'lps'),
	(457634, 125, '2015-03-15 01:34:12.000000', 'consum', 0.0211, 'lps'),
	(457635, 125, '2015-03-15 01:34:13.000000', 'consum', 0.0210, 'lps'),
	(457636, 125, '2015-03-15 01:34:14.000000', 'consum', 0.0226, 'lps'),
	(457637, 125, '2015-03-15 01:34:15.000000', 'consum', 0.0216, 'lps'),
	(457638, 125, '2015-03-15 01:34:16.000000', 'consum', 0.0211, 'lps'),
	(457639, 125, '2015-03-15 01:34:17.000000', 'consum', 0.0217, 'lps'),
	(457640, 125, '2015-03-15 01:34:18.000000', 'consum', 0.0226, 'lps'),
	(457641, 125, '2015-03-15 01:34:19.000000', 'consum', 0.0212, 'lps'),
	(457642, 125, '2015-03-15 01:34:20.000000', 'consum', 0.0210, 'lps'),
	(457643, 125, '2015-03-15 01:34:21.000000', 'consum', 0.0223, 'lps'),
	(457644, 125, '2015-03-15 01:34:22.000000', 'consum', 0.0223, 'lps'),
	(457645, 125, '2015-03-15 01:34:23.000000', 'consum', 0.0215, 'lps'),
	(457646, 125, '2015-03-15 01:34:24.000000', 'consum', 0.0217, 'lps'),
	(457647, 125, '2015-03-15 01:34:25.000000', 'consum', 0.0210, 'lps'),
	(457648, 125, '2015-03-15 01:34:26.000000', 'consum', 0.0211, 'lps'),
	(457649, 125, '2015-03-15 01:34:27.000000', 'consum', 0.0212, 'lps'),
	(457650, 125, '2015-03-15 01:34:28.000000', 'consum', 0.0219, 'lps'),
	(457651, 125, '2015-03-15 01:34:29.000000', 'consum', 0.0212, 'lps'),
	(457652, 125, '2015-03-15 01:34:30.000000', 'consum', 0.0213, 'lps'),
	(457653, 125, '2015-03-15 01:34:31.000000', 'consum', 0.0221, 'lps'),
	(457654, 125, '2015-03-15 01:34:32.000000', 'consum', 0.0218, 'lps'),
	(457655, 125, '2015-03-15 01:34:33.000000', 'consum', 0.0220, 'lps'),
	(457656, 125, '2015-03-15 01:34:34.000000', 'consum', 0.0218, 'lps'),
	(457657, 125, '2015-03-15 01:34:35.000000', 'consum', 0.0219, 'lps'),
	(457658, 125, '2015-03-15 01:34:36.000000', 'consum', 0.0212, 'lps'),
	(457659, 125, '2015-03-15 01:34:37.000000', 'consum', 0.0214, 'lps'),
	(457660, 125, '2015-03-15 01:34:38.000000', 'consum', 0.0223, 'lps'),
	(457661, 125, '2015-03-15 01:34:39.000000', 'consum', 0.0212, 'lps'),
	(457662, 125, '2015-03-15 01:34:40.000000', 'consum', 0.0215, 'lps'),
	(457663, 125, '2015-03-15 01:34:41.000000', 'consum', 0.0213, 'lps'),
	(457664, 125, '2015-03-15 01:34:42.000000', 'consum', 0.0210, 'lps'),
	(457665, 125, '2015-03-15 01:34:43.000000', 'consum', 0.0219, 'lps'),
	(457666, 125, '2015-03-15 01:34:44.000000', 'consum', 0.0219, 'lps'),
	(457667, 125, '2015-03-15 01:34:45.000000', 'consum', 0.0210, 'lps'),
	(457668, 125, '2015-03-15 01:34:46.000000', 'consum', 0.0219, 'lps'),
	(457669, 125, '2015-03-15 01:34:47.000000', 'consum', 0.0220, 'lps'),
	(457670, 125, '2015-03-15 01:34:48.000000', 'consum', 0.0214, 'lps'),
	(457671, 125, '2015-03-15 01:34:49.000000', 'consum', 0.0220, 'lps'),
	(457672, 125, '2015-03-15 01:34:50.000000', 'consum', 0.0213, 'lps'),
	(457673, 125, '2015-03-15 01:34:51.000000', 'consum', 0.0213, 'lps'),
	(457674, 125, '2015-03-15 01:34:52.000000', 'consum', 0.0215, 'lps'),
	(457675, 125, '2015-03-15 01:34:53.000000', 'consum', 0.0227, 'lps'),
	(457676, 125, '2015-03-15 01:34:54.000000', 'consum', 0.0210, 'lps'),
	(457677, 125, '2015-03-15 01:34:55.000000', 'consum', 0.0214, 'lps'),
	(457678, 125, '2015-03-15 01:34:56.000000', 'consum', 0.0212, 'lps'),
	(457679, 125, '2015-03-15 01:34:57.000000', 'consum', 0.0227, 'lps'),
	(457680, 125, '2015-03-15 01:34:58.000000', 'consum', 0.0215, 'lps'),
	(457681, 125, '2015-03-15 01:34:59.000000', 'consum', 0.0223, 'lps'),
	(457682, 125, '2015-03-15 01:35:00.000000', 'consum', 0.0226, 'lps'),
	(457683, 125, '2015-03-15 01:35:01.000000', 'consum', 0.0213, 'lps'),
	(457684, 125, '2015-03-15 01:35:02.000000', 'consum', 0.0215, 'lps'),
	(457685, 125, '2015-03-15 01:35:03.000000', 'consum', 0.0227, 'lps'),
	(457686, 125, '2015-03-15 01:35:04.000000', 'consum', 0.0227, 'lps'),
	(457687, 125, '2015-03-15 01:35:05.000000', 'consum', 0.0226, 'lps'),
	(457688, 125, '2015-03-15 01:35:06.000000', 'consum', 0.0221, 'lps'),
	(457689, 125, '2015-03-15 01:35:07.000000', 'consum', 0.0219, 'lps'),
	(457690, 125, '2015-03-15 01:35:08.000000', 'consum', 0.0220, 'lps'),
	(457691, 125, '2015-03-15 01:35:09.000000', 'consum', 0.0218, 'lps'),
	(457692, 125, '2015-03-15 01:35:10.000000', 'consum', 0.0221, 'lps'),
	(457693, 125, '2015-03-15 01:35:11.000000', 'consum', 0.0224, 'lps'),
	(457694, 125, '2015-03-15 01:35:12.000000', 'consum', 0.0210, 'lps'),
	(457695, 125, '2015-03-15 01:35:13.000000', 'consum', 0.0223, 'lps'),
	(457696, 125, '2015-03-15 01:35:14.000000', 'consum', 0.0220, 'lps'),
	(457697, 125, '2015-03-15 01:35:15.000000', 'consum', 0.0224, 'lps'),
	(457698, 125, '2015-03-15 01:35:16.000000', 'consum', 0.0212, 'lps'),
	(457699, 125, '2015-03-15 01:35:17.000000', 'consum', 0.0217, 'lps'),
	(457700, 125, '2015-03-15 01:35:18.000000', 'consum', 0.0219, 'lps'),
	(457701, 125, '2015-03-15 01:35:19.000000', 'consum', 0.0218, 'lps'),
	(457702, 125, '2015-03-15 01:35:20.000000', 'consum', 0.0223, 'lps'),
	(457703, 125, '2015-03-15 01:35:21.000000', 'consum', 0.0215, 'lps'),
	(457704, 125, '2015-03-15 01:35:22.000000', 'consum', 0.0215, 'lps'),
	(457705, 125, '2015-03-15 01:35:23.000000', 'consum', 0.0219, 'lps'),
	(457706, 125, '2015-03-15 01:35:24.000000', 'consum', 0.0223, 'lps'),
	(457707, 125, '2015-03-15 01:35:25.000000', 'consum', 0.0211, 'lps'),
	(457708, 125, '2015-03-15 01:35:26.000000', 'consum', 0.0216, 'lps'),
	(457709, 125, '2015-03-15 01:35:27.000000', 'consum', 0.0217, 'lps'),
	(457710, 125, '2015-03-15 01:35:28.000000', 'consum', 0.0211, 'lps'),
	(457711, 125, '2015-03-15 01:35:29.000000', 'consum', 0.0213, 'lps'),
	(457712, 125, '2015-03-15 01:35:30.000000', 'consum', 0.0223, 'lps'),
	(457713, 125, '2015-03-15 01:35:31.000000', 'consum', 0.0213, 'lps'),
	(457714, 125, '2015-03-15 01:35:32.000000', 'consum', 0.0222, 'lps'),
	(457715, 125, '2015-03-15 01:35:33.000000', 'consum', 0.0227, 'lps'),
	(457716, 125, '2015-03-15 01:35:34.000000', 'consum', 0.0222, 'lps'),
	(457717, 125, '2015-03-15 01:35:35.000000', 'consum', 0.0218, 'lps'),
	(457718, 125, '2015-03-15 01:35:36.000000', 'consum', 0.0214, 'lps'),
	(457719, 125, '2015-03-15 01:35:37.000000', 'consum', 0.0227, 'lps'),
	(457720, 125, '2015-03-15 01:35:38.000000', 'consum', 0.0210, 'lps'),
	(457721, 125, '2015-03-15 01:35:39.000000', 'consum', 0.0215, 'lps'),
	(457722, 125, '2015-03-15 01:35:40.000000', 'consum', 0.0216, 'lps'),
	(457723, 125, '2015-03-15 01:35:41.000000', 'consum', 0.0210, 'lps'),
	(457724, 125, '2015-03-15 01:35:42.000000', 'consum', 0.0225, 'lps'),
	(457725, 125, '2015-03-15 01:35:43.000000', 'consum', 0.0216, 'lps'),
	(457726, 125, '2015-03-15 01:35:44.000000', 'consum', 0.0214, 'lps'),
	(457727, 125, '2015-03-15 01:35:45.000000', 'consum', 0.0210, 'lps'),
	(457728, 125, '2015-03-15 01:35:46.000000', 'consum', 0.0220, 'lps'),
	(457729, 125, '2015-03-15 01:35:47.000000', 'consum', 0.0221, 'lps'),
	(457730, 125, '2015-03-15 01:35:48.000000', 'consum', 0.0221, 'lps'),
	(457731, 125, '2015-03-15 01:35:49.000000', 'consum', 0.0211, 'lps'),
	(457732, 125, '2015-03-15 01:35:50.000000', 'consum', 0.0220, 'lps'),
	(457733, 125, '2015-03-15 01:35:51.000000', 'consum', 0.0222, 'lps'),
	(457734, 125, '2015-03-15 01:35:52.000000', 'consum', 0.0224, 'lps'),
	(457735, 125, '2015-03-15 01:35:53.000000', 'consum', 0.0225, 'lps'),
	(457736, 125, '2015-03-15 01:35:54.000000', 'consum', 0.0227, 'lps'),
	(457737, 125, '2015-03-15 01:35:55.000000', 'consum', 0.0213, 'lps'),
	(457738, 125, '2015-03-15 01:35:56.000000', 'consum', 0.0211, 'lps'),
	(457739, 125, '2015-03-15 01:35:57.000000', 'consum', 0.0225, 'lps'),
	(457740, 125, '2015-03-15 01:35:58.000000', 'consum', 0.0212, 'lps'),
	(457741, 125, '2015-03-15 01:35:59.000000', 'consum', 0.0226, 'lps'),
	(457742, 125, '2015-03-15 01:36:00.000000', 'consum', 0.0214, 'lps'),
	(457743, 125, '2015-03-15 01:36:01.000000', 'consum', 0.0219, 'lps'),
	(457744, 125, '2015-03-15 01:36:02.000000', 'consum', 0.0226, 'lps'),
	(457745, 125, '2015-03-15 01:36:03.000000', 'consum', 0.0211, 'lps'),
	(457746, 125, '2015-03-15 01:36:04.000000', 'consum', 0.0220, 'lps'),
	(457747, 125, '2015-03-15 01:36:05.000000', 'consum', 0.0220, 'lps'),
	(457748, 125, '2015-03-15 01:36:06.000000', 'consum', 0.0212, 'lps'),
	(457749, 125, '2015-03-15 01:36:07.000000', 'consum', 0.0226, 'lps'),
	(457750, 125, '2015-03-15 01:36:08.000000', 'consum', 0.0214, 'lps'),
	(457751, 125, '2015-03-15 01:36:09.000000', 'consum', 0.0218, 'lps'),
	(457752, 125, '2015-03-15 01:36:10.000000', 'consum', 0.0220, 'lps'),
	(457753, 125, '2015-03-15 01:36:11.000000', 'consum', 0.0219, 'lps'),
	(457754, 125, '2015-03-15 01:36:12.000000', 'consum', 0.0225, 'lps'),
	(457755, 125, '2015-03-15 01:36:13.000000', 'consum', 0.0221, 'lps'),
	(457756, 125, '2015-03-15 01:36:14.000000', 'consum', 0.0224, 'lps'),
	(457757, 125, '2015-03-15 01:36:15.000000', 'consum', 0.0227, 'lps'),
	(457758, 125, '2015-03-15 01:36:16.000000', 'consum', 0.0218, 'lps'),
	(457759, 125, '2015-03-15 01:36:17.000000', 'consum', 0.0218, 'lps'),
	(457760, 125, '2015-03-15 01:36:18.000000', 'consum', 0.0224, 'lps'),
	(457761, 125, '2015-03-15 01:36:19.000000', 'consum', 0.0223, 'lps'),
	(457762, 125, '2015-03-15 01:36:20.000000', 'consum', 0.0216, 'lps'),
	(457763, 125, '2015-03-15 01:36:21.000000', 'consum', 0.0218, 'lps'),
	(457764, 125, '2015-03-15 01:36:22.000000', 'consum', 0.0215, 'lps'),
	(457765, 125, '2015-03-15 01:36:23.000000', 'consum', 0.0212, 'lps'),
	(457766, 125, '2015-03-15 01:36:24.000000', 'consum', 0.0223, 'lps'),
	(457767, 125, '2015-03-15 01:36:25.000000', 'consum', 0.0215, 'lps'),
	(457768, 125, '2015-03-15 01:36:26.000000', 'consum', 0.0215, 'lps'),
	(457769, 125, '2015-03-15 01:36:27.000000', 'consum', 0.0218, 'lps'),
	(457770, 125, '2015-03-15 01:36:28.000000', 'consum', 0.0221, 'lps'),
	(457771, 125, '2015-03-15 01:36:29.000000', 'consum', 0.0223, 'lps'),
	(457772, 125, '2015-03-15 01:36:30.000000', 'consum', 0.0224, 'lps'),
	(457773, 125, '2015-03-15 01:36:31.000000', 'consum', 0.0223, 'lps'),
	(457774, 125, '2015-03-15 01:36:32.000000', 'consum', 0.0214, 'lps'),
	(457775, 125, '2015-03-15 01:36:33.000000', 'consum', 0.0211, 'lps'),
	(457776, 125, '2015-03-15 01:36:34.000000', 'consum', 0.0222, 'lps'),
	(457777, 125, '2015-03-15 01:36:35.000000', 'consum', 0.0212, 'lps'),
	(457778, 125, '2015-03-15 01:36:36.000000', 'consum', 0.0221, 'lps'),
	(457779, 125, '2015-03-15 01:36:37.000000', 'consum', 0.0225, 'lps'),
	(457780, 125, '2015-03-15 01:36:38.000000', 'consum', 0.0214, 'lps'),
	(457781, 125, '2015-03-15 01:36:39.000000', 'consum', 0.0223, 'lps'),
	(457782, 125, '2015-03-15 01:36:40.000000', 'consum', 0.0226, 'lps'),
	(457783, 125, '2015-03-15 01:36:41.000000', 'consum', 0.0217, 'lps'),
	(457784, 125, '2015-03-15 01:36:42.000000', 'consum', 0.0216, 'lps'),
	(457785, 125, '2015-03-15 01:36:43.000000', 'consum', 0.0218, 'lps'),
	(457786, 125, '2015-03-15 01:36:44.000000', 'consum', 0.0215, 'lps'),
	(457787, 125, '2015-03-15 01:36:45.000000', 'consum', 0.0214, 'lps'),
	(457788, 125, '2015-03-15 01:36:46.000000', 'consum', 0.0212, 'lps'),
	(457789, 125, '2015-03-15 01:36:47.000000', 'consum', 0.0212, 'lps'),
	(457790, 125, '2015-03-15 01:36:48.000000', 'consum', 0.0212, 'lps'),
	(457791, 125, '2015-03-15 01:36:49.000000', 'consum', 0.0216, 'lps'),
	(457792, 125, '2015-03-15 01:36:50.000000', 'consum', 0.0215, 'lps'),
	(457793, 125, '2015-03-15 01:36:51.000000', 'consum', 0.0217, 'lps'),
	(457794, 125, '2015-03-15 01:36:52.000000', 'consum', 0.0213, 'lps'),
	(457795, 125, '2015-03-15 01:36:53.000000', 'consum', 0.0222, 'lps'),
	(457796, 125, '2015-03-15 01:36:54.000000', 'consum', 0.0227, 'lps'),
	(457797, 125, '2015-03-15 01:36:55.000000', 'consum', 0.0221, 'lps'),
	(457798, 125, '2015-03-15 01:36:56.000000', 'consum', 0.0217, 'lps'),
	(457799, 125, '2015-03-15 01:36:57.000000', 'consum', 0.0213, 'lps'),
	(457800, 125, '2015-03-15 01:36:58.000000', 'consum', 0.0220, 'lps'),
	(457801, 125, '2015-03-15 01:36:59.000000', 'consum', 0.0216, 'lps'),
	(457802, 125, '2015-03-15 01:37:00.000000', 'consum', 0.0213, 'lps'),
	(457803, 125, '2015-03-15 01:37:01.000000', 'consum', 0.0224, 'lps'),
	(457804, 125, '2015-03-15 01:37:02.000000', 'consum', 0.0216, 'lps'),
	(457805, 125, '2015-03-15 01:37:03.000000', 'consum', 0.0219, 'lps'),
	(457806, 125, '2015-03-15 01:37:04.000000', 'consum', 0.0216, 'lps'),
	(457807, 125, '2015-03-15 01:37:05.000000', 'consum', 0.0217, 'lps'),
	(457808, 125, '2015-03-15 01:37:06.000000', 'consum', 0.0227, 'lps'),
	(457809, 125, '2015-03-15 01:37:07.000000', 'consum', 0.0219, 'lps'),
	(457810, 125, '2015-03-15 01:37:08.000000', 'consum', 0.0222, 'lps'),
	(457811, 125, '2015-03-15 01:37:09.000000', 'consum', 0.0227, 'lps'),
	(457812, 125, '2015-03-15 01:37:10.000000', 'consum', 0.0222, 'lps'),
	(457813, 125, '2015-03-15 01:37:11.000000', 'consum', 0.0221, 'lps'),
	(457814, 125, '2015-03-15 01:37:12.000000', 'consum', 0.0211, 'lps'),
	(457815, 125, '2015-03-15 01:37:13.000000', 'consum', 0.0216, 'lps'),
	(457816, 125, '2015-03-15 01:37:14.000000', 'consum', 0.0223, 'lps'),
	(457817, 125, '2015-03-15 01:37:15.000000', 'consum', 0.0219, 'lps'),
	(457818, 125, '2015-03-15 01:37:16.000000', 'consum', 0.0219, 'lps'),
	(457819, 125, '2015-03-15 01:37:17.000000', 'consum', 0.0227, 'lps'),
	(457820, 125, '2015-03-15 01:37:18.000000', 'consum', 0.0214, 'lps'),
	(457821, 125, '2015-03-15 01:37:19.000000', 'consum', 0.0216, 'lps'),
	(457822, 125, '2015-03-15 01:37:20.000000', 'consum', 0.0227, 'lps'),
	(457823, 125, '2015-03-15 01:37:21.000000', 'consum', 0.0224, 'lps'),
	(457824, 125, '2015-03-15 01:37:22.000000', 'consum', 0.0212, 'lps'),
	(457825, 125, '2015-03-15 01:37:23.000000', 'consum', 0.0213, 'lps'),
	(457826, 125, '2015-03-15 01:37:24.000000', 'consum', 0.0220, 'lps'),
	(457827, 125, '2015-03-15 01:37:25.000000', 'consum', 0.0215, 'lps'),
	(457828, 125, '2015-03-15 01:37:26.000000', 'consum', 0.0226, 'lps'),
	(457829, 125, '2015-03-15 01:37:27.000000', 'consum', 0.0219, 'lps'),
	(457830, 125, '2015-03-15 01:37:28.000000', 'consum', 0.0227, 'lps'),
	(457831, 125, '2015-03-15 01:37:29.000000', 'consum', 0.0214, 'lps'),
	(457832, 125, '2015-03-15 01:37:30.000000', 'consum', 0.0213, 'lps'),
	(457833, 125, '2015-03-15 01:37:31.000000', 'consum', 0.0217, 'lps'),
	(457834, 125, '2015-03-15 01:37:32.000000', 'consum', 0.0219, 'lps'),
	(457835, 125, '2015-03-15 01:37:33.000000', 'consum', 0.0214, 'lps'),
	(457836, 125, '2015-03-15 01:37:34.000000', 'consum', 0.0222, 'lps'),
	(457837, 125, '2015-03-15 01:37:35.000000', 'consum', 0.0221, 'lps'),
	(457838, 125, '2015-03-15 01:37:36.000000', 'consum', 0.0214, 'lps'),
	(457839, 125, '2015-03-15 01:37:37.000000', 'consum', 0.0216, 'lps'),
	(457840, 125, '2015-03-15 01:37:38.000000', 'consum', 0.0227, 'lps'),
	(457841, 125, '2015-03-15 01:37:39.000000', 'consum', 0.0226, 'lps'),
	(457842, 125, '2015-03-15 01:37:40.000000', 'consum', 0.0220, 'lps'),
	(457843, 125, '2015-03-15 01:37:41.000000', 'consum', 0.0211, 'lps'),
	(457844, 125, '2015-03-15 01:37:42.000000', 'consum', 0.0221, 'lps'),
	(457845, 125, '2015-03-15 01:37:43.000000', 'consum', 0.0227, 'lps'),
	(457846, 125, '2015-03-15 01:37:44.000000', 'consum', 0.0226, 'lps'),
	(457847, 125, '2015-03-15 01:37:45.000000', 'consum', 0.0222, 'lps'),
	(457848, 125, '2015-03-15 01:37:46.000000', 'consum', 0.0222, 'lps'),
	(457849, 125, '2015-03-15 01:37:47.000000', 'consum', 0.0218, 'lps'),
	(457850, 125, '2015-03-15 01:37:48.000000', 'consum', 0.0216, 'lps'),
	(457851, 125, '2015-03-15 01:37:49.000000', 'consum', 0.0214, 'lps'),
	(457852, 125, '2015-03-15 01:37:50.000000', 'consum', 0.0213, 'lps'),
	(457853, 125, '2015-03-15 01:37:51.000000', 'consum', 0.0212, 'lps'),
	(457854, 125, '2015-03-15 01:37:52.000000', 'consum', 0.0212, 'lps'),
	(457855, 125, '2015-03-15 01:37:53.000000', 'consum', 0.0217, 'lps'),
	(457856, 125, '2015-03-15 01:37:54.000000', 'consum', 0.0220, 'lps'),
	(457857, 125, '2015-03-15 01:37:55.000000', 'consum', 0.0223, 'lps'),
	(457858, 125, '2015-03-15 01:37:56.000000', 'consum', 0.0226, 'lps'),
	(457859, 125, '2015-03-15 01:37:57.000000', 'consum', 0.0216, 'lps'),
	(457860, 125, '2015-03-15 01:37:58.000000', 'consum', 0.0227, 'lps'),
	(457861, 125, '2015-03-15 01:37:59.000000', 'consum', 0.0223, 'lps'),
	(457862, 125, '2015-03-15 01:38:00.000000', 'consum', 0.0227, 'lps'),
	(457863, 125, '2015-03-15 01:38:01.000000', 'consum', 0.0220, 'lps'),
	(457864, 125, '2015-03-15 01:38:02.000000', 'consum', 0.0227, 'lps'),
	(457865, 125, '2015-03-15 01:38:03.000000', 'consum', 0.0211, 'lps'),
	(457866, 125, '2015-03-15 01:38:04.000000', 'consum', 0.0217, 'lps'),
	(457867, 125, '2015-03-15 01:38:05.000000', 'consum', 0.0227, 'lps'),
	(457868, 125, '2015-03-15 01:38:06.000000', 'consum', 0.0219, 'lps'),
	(457869, 125, '2015-03-15 01:38:07.000000', 'consum', 0.0224, 'lps'),
	(457870, 125, '2015-03-15 01:38:08.000000', 'consum', 0.0219, 'lps'),
	(457871, 125, '2015-03-15 01:38:09.000000', 'consum', 0.0210, 'lps'),
	(457872, 125, '2015-03-15 01:38:10.000000', 'consum', 0.0222, 'lps'),
	(457873, 125, '2015-03-15 01:38:11.000000', 'consum', 0.0215, 'lps'),
	(457874, 125, '2015-03-15 01:38:12.000000', 'consum', 0.0218, 'lps'),
	(457875, 125, '2015-03-15 01:38:13.000000', 'consum', 0.0219, 'lps'),
	(457876, 125, '2015-03-15 01:38:14.000000', 'consum', 0.0214, 'lps'),
	(457877, 125, '2015-03-15 01:38:15.000000', 'consum', 0.0220, 'lps'),
	(457878, 125, '2015-03-15 01:38:16.000000', 'consum', 0.0212, 'lps'),
	(457879, 125, '2015-03-15 01:38:17.000000', 'consum', 0.0225, 'lps'),
	(457880, 125, '2015-03-15 01:38:18.000000', 'consum', 0.0227, 'lps'),
	(457881, 125, '2015-03-15 01:38:19.000000', 'consum', 0.0214, 'lps'),
	(457882, 125, '2015-03-15 01:38:20.000000', 'consum', 0.0214, 'lps'),
	(457883, 125, '2015-03-15 01:38:21.000000', 'consum', 0.0219, 'lps'),
	(457884, 125, '2015-03-15 01:38:22.000000', 'consum', 0.0210, 'lps'),
	(457885, 125, '2015-03-15 01:38:23.000000', 'consum', 0.0217, 'lps'),
	(457886, 125, '2015-03-15 01:38:24.000000', 'consum', 0.0212, 'lps'),
	(457887, 125, '2015-03-15 01:38:25.000000', 'consum', 0.0218, 'lps'),
	(457888, 125, '2015-03-15 01:38:26.000000', 'consum', 0.0225, 'lps'),
	(457889, 125, '2015-03-15 01:38:27.000000', 'consum', 0.0225, 'lps'),
	(457890, 125, '2015-03-15 01:38:28.000000', 'consum', 0.0223, 'lps'),
	(457891, 125, '2015-03-15 01:38:29.000000', 'consum', 0.0211, 'lps'),
	(457892, 125, '2015-03-15 01:38:30.000000', 'consum', 0.0212, 'lps'),
	(457893, 125, '2015-03-15 01:38:31.000000', 'consum', 0.0219, 'lps'),
	(457894, 125, '2015-03-15 01:38:32.000000', 'consum', 0.0212, 'lps'),
	(457895, 125, '2015-03-15 01:38:33.000000', 'consum', 0.0211, 'lps'),
	(457896, 125, '2015-03-15 01:38:34.000000', 'consum', 0.0211, 'lps'),
	(457897, 125, '2015-03-15 01:38:35.000000', 'consum', 0.0211, 'lps'),
	(457898, 125, '2015-03-15 01:38:36.000000', 'consum', 0.0213, 'lps'),
	(457899, 125, '2015-03-15 01:38:37.000000', 'consum', 0.0225, 'lps'),
	(457900, 125, '2015-03-15 01:38:38.000000', 'consum', 0.0220, 'lps'),
	(457901, 125, '2015-03-15 01:38:39.000000', 'consum', 0.0216, 'lps'),
	(457902, 125, '2015-03-15 01:38:40.000000', 'consum', 0.0210, 'lps'),
	(457903, 125, '2015-03-15 01:38:41.000000', 'consum', 0.0210, 'lps'),
	(457904, 125, '2015-03-15 01:38:42.000000', 'consum', 0.0210, 'lps'),
	(457905, 125, '2015-03-15 01:38:43.000000', 'consum', 0.0213, 'lps'),
	(457906, 125, '2015-03-15 01:38:44.000000', 'consum', 0.0224, 'lps'),
	(457907, 125, '2015-03-15 01:38:45.000000', 'consum', 0.0217, 'lps'),
	(457908, 125, '2015-03-15 01:38:46.000000', 'consum', 0.0221, 'lps'),
	(457909, 125, '2015-03-15 01:38:47.000000', 'consum', 0.0227, 'lps'),
	(457910, 125, '2015-03-15 01:38:48.000000', 'consum', 0.0227, 'lps'),
	(457911, 125, '2015-03-15 01:38:49.000000', 'consum', 0.0227, 'lps'),
	(457912, 125, '2015-03-15 01:38:50.000000', 'consum', 0.0225, 'lps'),
	(457913, 125, '2015-03-15 01:38:51.000000', 'consum', 0.0217, 'lps'),
	(457914, 125, '2015-03-15 01:38:52.000000', 'consum', 0.0220, 'lps'),
	(457915, 125, '2015-03-15 01:38:53.000000', 'consum', 0.0221, 'lps'),
	(457916, 125, '2015-03-15 01:38:54.000000', 'consum', 0.0217, 'lps'),
	(457917, 125, '2015-03-15 01:38:55.000000', 'consum', 0.0213, 'lps'),
	(457918, 125, '2015-03-15 01:38:56.000000', 'consum', 0.0221, 'lps'),
	(457919, 125, '2015-03-15 01:38:57.000000', 'consum', 0.0222, 'lps'),
	(457920, 125, '2015-03-15 01:38:58.000000', 'consum', 0.0221, 'lps'),
	(457921, 125, '2015-03-15 01:38:59.000000', 'consum', 0.0210, 'lps'),
	(457922, 125, '2015-03-15 01:39:00.000000', 'consum', 0.0212, 'lps'),
	(457923, 125, '2015-03-15 01:39:01.000000', 'consum', 0.0222, 'lps'),
	(457924, 125, '2015-03-15 01:39:02.000000', 'consum', 0.0227, 'lps'),
	(457925, 125, '2015-03-15 01:39:03.000000', 'consum', 0.0225, 'lps'),
	(457926, 125, '2015-03-15 01:39:04.000000', 'consum', 0.0214, 'lps'),
	(457927, 125, '2015-03-15 01:39:05.000000', 'consum', 0.0223, 'lps'),
	(457928, 125, '2015-03-15 01:39:06.000000', 'consum', 0.0210, 'lps'),
	(457929, 125, '2015-03-15 01:39:07.000000', 'consum', 0.0226, 'lps'),
	(457930, 125, '2015-03-15 01:39:08.000000', 'consum', 0.0220, 'lps'),
	(457931, 125, '2015-03-15 01:39:09.000000', 'consum', 0.0211, 'lps'),
	(457932, 125, '2015-03-15 01:39:10.000000', 'consum', 0.0222, 'lps'),
	(457933, 126, '2015-03-15 00:00:00.000000', 'consum', 0.0222, 'lps'),
	(457934, 126, '2015-03-15 00:00:01.000000', 'consum', 0.0212, 'lps'),
	(457935, 126, '2015-03-15 00:00:02.000000', 'consum', 0.0211, 'lps'),
	(457936, 126, '2015-03-15 00:00:03.000000', 'consum', 0.0223, 'lps'),
	(457937, 126, '2015-03-15 00:00:04.000000', 'consum', 0.0216, 'lps'),
	(457938, 126, '2015-03-15 00:00:05.000000', 'consum', 0.0216, 'lps'),
	(457939, 126, '2015-03-15 00:00:06.000000', 'consum', 0.0223, 'lps'),
	(457940, 126, '2015-03-15 00:00:07.000000', 'consum', 0.0217, 'lps'),
	(457941, 126, '2015-03-15 00:00:08.000000', 'consum', 0.0218, 'lps'),
	(457942, 126, '2015-03-15 00:00:09.000000', 'consum', 0.0215, 'lps'),
	(457943, 126, '2015-03-15 00:00:10.000000', 'consum', 0.0215, 'lps'),
	(457944, 126, '2015-03-15 00:00:11.000000', 'consum', 0.0217, 'lps'),
	(457945, 126, '2015-03-15 00:00:12.000000', 'consum', 0.0218, 'lps'),
	(457946, 126, '2015-03-15 00:00:13.000000', 'consum', 0.0215, 'lps'),
	(457947, 126, '2015-03-15 00:00:14.000000', 'consum', 0.0212, 'lps'),
	(457948, 126, '2015-03-15 00:00:15.000000', 'consum', 0.0219, 'lps'),
	(457949, 126, '2015-03-15 00:00:16.000000', 'consum', 0.0220, 'lps'),
	(457950, 126, '2015-03-15 00:00:17.000000', 'consum', 0.0222, 'lps'),
	(457951, 126, '2015-03-15 00:00:18.000000', 'consum', 0.0213, 'lps'),
	(457952, 126, '2015-03-15 00:00:19.000000', 'consum', 0.0217, 'lps'),
	(457953, 126, '2015-03-15 00:00:20.000000', 'consum', 0.0210, 'lps'),
	(457954, 126, '2015-03-15 00:00:21.000000', 'consum', 0.0216, 'lps'),
	(457955, 126, '2015-03-15 00:00:22.000000', 'consum', 0.0211, 'lps'),
	(457956, 126, '2015-03-15 00:00:23.000000', 'consum', 0.0212, 'lps'),
	(457957, 126, '2015-03-15 00:00:24.000000', 'consum', 0.0217, 'lps'),
	(457958, 126, '2015-03-15 00:00:25.000000', 'consum', 0.0210, 'lps'),
	(457959, 126, '2015-03-15 00:00:26.000000', 'consum', 0.0220, 'lps'),
	(457960, 126, '2015-03-15 00:00:27.000000', 'consum', 0.0220, 'lps'),
	(457961, 126, '2015-03-15 00:00:28.000000', 'consum', 0.0213, 'lps'),
	(457962, 126, '2015-03-15 00:00:29.000000', 'consum', 0.0212, 'lps'),
	(457963, 126, '2015-03-15 00:00:30.000000', 'consum', 0.0212, 'lps'),
	(457964, 126, '2015-03-15 00:00:31.000000', 'consum', 0.0213, 'lps'),
	(457965, 126, '2015-03-15 00:00:32.000000', 'consum', 0.0218, 'lps'),
	(457966, 126, '2015-03-15 00:00:33.000000', 'consum', 0.0217, 'lps'),
	(457967, 126, '2015-03-15 00:00:34.000000', 'consum', 0.0220, 'lps'),
	(457968, 126, '2015-03-15 00:00:35.000000', 'consum', 0.0211, 'lps'),
	(457969, 126, '2015-03-15 00:00:36.000000', 'consum', 0.0213, 'lps'),
	(457970, 126, '2015-03-15 00:00:37.000000', 'consum', 0.0210, 'lps'),
	(457971, 126, '2015-03-15 00:00:38.000000', 'consum', 0.0215, 'lps'),
	(457972, 126, '2015-03-15 00:00:39.000000', 'consum', 0.0222, 'lps'),
	(457973, 126, '2015-03-15 00:00:40.000000', 'consum', 0.0211, 'lps'),
	(457974, 126, '2015-03-15 00:00:41.000000', 'consum', 0.0210, 'lps'),
	(457975, 126, '2015-03-15 00:00:42.000000', 'consum', 0.0222, 'lps'),
	(457976, 126, '2015-03-15 00:00:43.000000', 'consum', 0.0212, 'lps'),
	(457977, 126, '2015-03-15 00:00:44.000000', 'consum', 0.0212, 'lps'),
	(457978, 126, '2015-03-15 00:00:45.000000', 'consum', 0.0216, 'lps'),
	(457979, 126, '2015-03-15 00:00:46.000000', 'consum', 0.0220, 'lps'),
	(457980, 126, '2015-03-15 00:00:47.000000', 'consum', 0.0215, 'lps'),
	(457981, 126, '2015-03-15 00:00:48.000000', 'consum', 0.0219, 'lps'),
	(457982, 126, '2015-03-15 00:00:49.000000', 'consum', 0.0213, 'lps'),
	(457983, 126, '2015-03-15 00:00:50.000000', 'consum', 0.0212, 'lps'),
	(457984, 126, '2015-03-15 00:00:51.000000', 'consum', 0.0211, 'lps'),
	(457985, 126, '2015-03-15 00:00:52.000000', 'consum', 0.0210, 'lps'),
	(457986, 126, '2015-03-15 00:00:53.000000', 'consum', 0.0223, 'lps'),
	(457987, 126, '2015-03-15 00:00:54.000000', 'consum', 0.0217, 'lps'),
	(457988, 126, '2015-03-15 00:00:55.000000', 'consum', 0.0221, 'lps'),
	(457989, 126, '2015-03-15 00:00:56.000000', 'consum', 0.0219, 'lps'),
	(457990, 126, '2015-03-15 00:00:57.000000', 'consum', 0.0221, 'lps'),
	(457991, 126, '2015-03-15 00:00:58.000000', 'consum', 0.0210, 'lps'),
	(457992, 126, '2015-03-15 00:00:59.000000', 'consum', 0.0218, 'lps'),
	(457993, 126, '2015-03-15 00:01:00.000000', 'consum', 0.0223, 'lps'),
	(457994, 126, '2015-03-15 00:01:01.000000', 'consum', 0.0210, 'lps'),
	(457995, 126, '2015-03-15 00:01:02.000000', 'consum', 0.0213, 'lps'),
	(457996, 126, '2015-03-15 00:01:03.000000', 'consum', 0.0212, 'lps'),
	(457997, 126, '2015-03-15 00:01:04.000000', 'consum', 0.0211, 'lps'),
	(457998, 126, '2015-03-15 00:01:05.000000', 'consum', 0.0212, 'lps'),
	(457999, 126, '2015-03-15 00:01:06.000000', 'consum', 0.0215, 'lps'),
	(458000, 126, '2015-03-15 00:01:07.000000', 'consum', 0.0216, 'lps'),
	(458001, 126, '2015-03-15 00:01:08.000000', 'consum', 0.0213, 'lps'),
	(458002, 126, '2015-03-15 00:01:09.000000', 'consum', 0.0221, 'lps'),
	(458003, 126, '2015-03-15 00:01:10.000000', 'consum', 0.0216, 'lps'),
	(458004, 126, '2015-03-15 00:01:11.000000', 'consum', 0.0221, 'lps'),
	(458005, 126, '2015-03-15 00:01:12.000000', 'consum', 0.0218, 'lps'),
	(458006, 126, '2015-03-15 00:01:13.000000', 'consum', 0.0220, 'lps'),
	(458007, 126, '2015-03-15 00:01:14.000000', 'consum', 0.0220, 'lps'),
	(458008, 126, '2015-03-15 00:01:15.000000', 'consum', 0.0218, 'lps'),
	(458009, 126, '2015-03-15 00:01:16.000000', 'consum', 0.0220, 'lps'),
	(458010, 126, '2015-03-15 00:01:17.000000', 'consum', 0.0210, 'lps'),
	(458011, 126, '2015-03-15 00:01:18.000000', 'consum', 0.0223, 'lps'),
	(458012, 126, '2015-03-15 00:01:19.000000', 'consum', 0.0220, 'lps'),
	(458013, 126, '2015-03-15 00:01:20.000000', 'consum', 0.0219, 'lps'),
	(458014, 126, '2015-03-15 00:01:21.000000', 'consum', 0.0212, 'lps'),
	(458015, 126, '2015-03-15 00:01:22.000000', 'consum', 0.0210, 'lps'),
	(458016, 126, '2015-03-15 00:01:23.000000', 'consum', 0.0216, 'lps'),
	(458017, 126, '2015-03-15 00:01:24.000000', 'consum', 0.0213, 'lps'),
	(458018, 126, '2015-03-15 00:01:25.000000', 'consum', 0.0220, 'lps'),
	(458019, 126, '2015-03-15 00:01:26.000000', 'consum', 0.0210, 'lps'),
	(458020, 126, '2015-03-15 00:01:27.000000', 'consum', 0.0210, 'lps'),
	(458021, 126, '2015-03-15 00:01:28.000000', 'consum', 0.0211, 'lps'),
	(458022, 126, '2015-03-15 00:01:29.000000', 'consum', 0.0214, 'lps'),
	(458023, 126, '2015-03-15 00:01:30.000000', 'consum', 0.0215, 'lps'),
	(458024, 126, '2015-03-15 00:01:31.000000', 'consum', 0.0221, 'lps'),
	(458025, 126, '2015-03-15 00:01:32.000000', 'consum', 0.0222, 'lps'),
	(458026, 126, '2015-03-15 00:01:33.000000', 'consum', 0.0211, 'lps'),
	(458027, 126, '2015-03-15 00:01:34.000000', 'consum', 0.0223, 'lps'),
	(458028, 126, '2015-03-15 00:01:35.000000', 'consum', 0.0217, 'lps'),
	(458029, 126, '2015-03-15 00:01:36.000000', 'consum', 0.0219, 'lps'),
	(458030, 126, '2015-03-15 00:01:37.000000', 'consum', 0.0223, 'lps'),
	(458031, 126, '2015-03-15 00:01:38.000000', 'consum', 0.0217, 'lps'),
	(458032, 126, '2015-03-15 00:01:39.000000', 'consum', 0.0222, 'lps'),
	(458033, 126, '2015-03-15 00:01:40.000000', 'consum', 0.0220, 'lps'),
	(458034, 126, '2015-03-15 00:01:41.000000', 'consum', 0.0210, 'lps'),
	(458035, 126, '2015-03-15 00:01:42.000000', 'consum', 0.0222, 'lps'),
	(458036, 126, '2015-03-15 00:01:43.000000', 'consum', 0.0217, 'lps'),
	(458037, 126, '2015-03-15 00:01:44.000000', 'consum', 0.0210, 'lps'),
	(458038, 126, '2015-03-15 00:01:45.000000', 'consum', 0.0218, 'lps'),
	(458039, 126, '2015-03-15 00:01:46.000000', 'consum', 0.0223, 'lps'),
	(458040, 126, '2015-03-15 00:01:47.000000', 'consum', 0.0223, 'lps'),
	(458041, 126, '2015-03-15 00:01:48.000000', 'consum', 0.0222, 'lps'),
	(458042, 126, '2015-03-15 00:01:49.000000', 'consum', 0.0216, 'lps'),
	(458043, 126, '2015-03-15 00:01:50.000000', 'consum', 0.0218, 'lps'),
	(458044, 126, '2015-03-15 00:01:51.000000', 'consum', 0.0221, 'lps'),
	(458045, 126, '2015-03-15 00:01:52.000000', 'consum', 0.0211, 'lps'),
	(458046, 126, '2015-03-15 00:01:53.000000', 'consum', 0.0211, 'lps'),
	(458047, 126, '2015-03-15 00:01:54.000000', 'consum', 0.0213, 'lps'),
	(458048, 126, '2015-03-15 00:01:55.000000', 'consum', 0.0222, 'lps'),
	(458049, 126, '2015-03-15 00:01:56.000000', 'consum', 0.0219, 'lps'),
	(458050, 126, '2015-03-15 00:01:57.000000', 'consum', 0.0222, 'lps'),
	(458051, 126, '2015-03-15 00:01:58.000000', 'consum', 0.0214, 'lps'),
	(458052, 126, '2015-03-15 00:01:59.000000', 'consum', 0.0223, 'lps'),
	(458053, 126, '2015-03-15 00:02:00.000000', 'consum', 0.0219, 'lps'),
	(458054, 126, '2015-03-15 00:02:01.000000', 'consum', 0.0219, 'lps'),
	(458055, 126, '2015-03-15 00:02:02.000000', 'consum', 0.0212, 'lps'),
	(458056, 126, '2015-03-15 00:02:03.000000', 'consum', 0.0222, 'lps'),
	(458057, 126, '2015-03-15 00:02:04.000000', 'consum', 0.0210, 'lps'),
	(458058, 126, '2015-03-15 00:02:05.000000', 'consum', 0.0216, 'lps'),
	(458059, 126, '2015-03-15 00:02:06.000000', 'consum', 0.0212, 'lps'),
	(458060, 126, '2015-03-15 00:02:07.000000', 'consum', 0.0218, 'lps'),
	(458061, 126, '2015-03-15 00:02:08.000000', 'consum', 0.0216, 'lps'),
	(458062, 126, '2015-03-15 00:02:09.000000', 'consum', 0.0217, 'lps'),
	(458063, 126, '2015-03-15 00:02:10.000000', 'consum', 0.0213, 'lps'),
	(458064, 126, '2015-03-15 00:02:11.000000', 'consum', 0.0219, 'lps'),
	(458065, 126, '2015-03-15 00:02:12.000000', 'consum', 0.0219, 'lps'),
	(458066, 126, '2015-03-15 00:02:13.000000', 'consum', 0.0212, 'lps'),
	(458067, 126, '2015-03-15 00:02:14.000000', 'consum', 0.0210, 'lps'),
	(458068, 126, '2015-03-15 00:02:15.000000', 'consum', 0.0219, 'lps'),
	(458069, 126, '2015-03-15 00:02:16.000000', 'consum', 0.0212, 'lps'),
	(458070, 126, '2015-03-15 00:02:17.000000', 'consum', 0.0221, 'lps'),
	(458071, 126, '2015-03-15 00:02:18.000000', 'consum', 0.0218, 'lps'),
	(458072, 126, '2015-03-15 00:02:19.000000', 'consum', 0.0219, 'lps'),
	(458073, 126, '2015-03-15 00:02:20.000000', 'consum', 0.0219, 'lps'),
	(458074, 126, '2015-03-15 00:02:21.000000', 'consum', 0.0211, 'lps'),
	(458075, 126, '2015-03-15 00:02:22.000000', 'consum', 0.0217, 'lps'),
	(458076, 126, '2015-03-15 00:02:23.000000', 'consum', 0.0214, 'lps'),
	(458077, 126, '2015-03-15 00:02:24.000000', 'consum', 0.0210, 'lps'),
	(458078, 126, '2015-03-15 00:02:25.000000', 'consum', 0.0214, 'lps'),
	(458079, 126, '2015-03-15 00:02:26.000000', 'consum', 0.0216, 'lps'),
	(458080, 126, '2015-03-15 00:02:27.000000', 'consum', 0.0216, 'lps'),
	(458081, 126, '2015-03-15 00:02:28.000000', 'consum', 0.0222, 'lps'),
	(458082, 126, '2015-03-15 00:02:29.000000', 'consum', 0.0223, 'lps'),
	(458083, 126, '2015-03-15 00:02:30.000000', 'consum', 0.0210, 'lps'),
	(458084, 126, '2015-03-15 00:02:31.000000', 'consum', 0.0216, 'lps'),
	(458085, 126, '2015-03-15 00:02:32.000000', 'consum', 0.0211, 'lps'),
	(458086, 126, '2015-03-15 00:02:33.000000', 'consum', 0.0213, 'lps'),
	(458087, 126, '2015-03-15 00:02:34.000000', 'consum', 0.0220, 'lps'),
	(458088, 126, '2015-03-15 00:02:35.000000', 'consum', 0.0210, 'lps'),
	(458089, 126, '2015-03-15 00:02:36.000000', 'consum', 0.0223, 'lps'),
	(458090, 126, '2015-03-15 00:02:37.000000', 'consum', 0.0219, 'lps'),
	(458091, 126, '2015-03-15 00:02:38.000000', 'consum', 0.0215, 'lps'),
	(458092, 126, '2015-03-15 00:02:39.000000', 'consum', 0.0212, 'lps'),
	(458093, 126, '2015-03-15 00:02:40.000000', 'consum', 0.0217, 'lps'),
	(458094, 126, '2015-03-15 00:02:41.000000', 'consum', 0.0211, 'lps'),
	(458095, 126, '2015-03-15 00:02:42.000000', 'consum', 0.0222, 'lps'),
	(458096, 126, '2015-03-15 00:02:43.000000', 'consum', 0.0213, 'lps'),
	(458097, 126, '2015-03-15 00:02:44.000000', 'consum', 0.0215, 'lps'),
	(458098, 126, '2015-03-15 00:02:45.000000', 'consum', 0.0214, 'lps'),
	(458099, 126, '2015-03-15 00:02:46.000000', 'consum', 0.0215, 'lps'),
	(458100, 126, '2015-03-15 00:02:47.000000', 'consum', 0.0211, 'lps'),
	(458101, 126, '2015-03-15 00:02:48.000000', 'consum', 0.0214, 'lps'),
	(458102, 126, '2015-03-15 00:02:49.000000', 'consum', 0.0213, 'lps'),
	(458103, 126, '2015-03-15 00:02:50.000000', 'consum', 0.0213, 'lps'),
	(458104, 126, '2015-03-15 00:02:51.000000', 'consum', 0.0217, 'lps'),
	(458105, 126, '2015-03-15 00:02:52.000000', 'consum', 0.0210, 'lps'),
	(458106, 126, '2015-03-15 00:02:53.000000', 'consum', 0.0218, 'lps'),
	(458107, 126, '2015-03-15 00:02:54.000000', 'consum', 0.0210, 'lps'),
	(458108, 126, '2015-03-15 00:02:55.000000', 'consum', 0.0211, 'lps'),
	(458109, 126, '2015-03-15 00:02:56.000000', 'consum', 0.0216, 'lps'),
	(458110, 126, '2015-03-15 00:02:57.000000', 'consum', 0.0210, 'lps'),
	(458111, 126, '2015-03-15 00:02:58.000000', 'consum', 0.0220, 'lps'),
	(458112, 126, '2015-03-15 00:02:59.000000', 'consum', 0.0219, 'lps'),
	(458113, 126, '2015-03-15 00:03:00.000000', 'consum', 0.0212, 'lps'),
	(458114, 126, '2015-03-15 00:03:01.000000', 'consum', 0.0222, 'lps'),
	(458115, 126, '2015-03-15 00:03:02.000000', 'consum', 0.0220, 'lps'),
	(458116, 126, '2015-03-15 00:03:03.000000', 'consum', 0.0213, 'lps'),
	(458117, 126, '2015-03-15 00:03:04.000000', 'consum', 0.0223, 'lps'),
	(458118, 126, '2015-03-15 00:03:05.000000', 'consum', 0.0223, 'lps'),
	(458119, 126, '2015-03-15 00:03:06.000000', 'consum', 0.0211, 'lps'),
	(458120, 126, '2015-03-15 00:03:07.000000', 'consum', 0.0216, 'lps'),
	(458121, 126, '2015-03-15 00:03:08.000000', 'consum', 0.0212, 'lps'),
	(458122, 126, '2015-03-15 00:03:09.000000', 'consum', 0.0214, 'lps'),
	(458123, 126, '2015-03-15 00:03:10.000000', 'consum', 0.0211, 'lps'),
	(458124, 126, '2015-03-15 00:03:11.000000', 'consum', 0.0217, 'lps'),
	(458125, 126, '2015-03-15 00:03:12.000000', 'consum', 0.0215, 'lps'),
	(458126, 126, '2015-03-15 00:03:13.000000', 'consum', 0.0215, 'lps'),
	(458127, 126, '2015-03-15 00:03:14.000000', 'consum', 0.0221, 'lps'),
	(458128, 126, '2015-03-15 00:03:15.000000', 'consum', 0.0223, 'lps'),
	(458129, 126, '2015-03-15 00:03:16.000000', 'consum', 0.0216, 'lps'),
	(458130, 126, '2015-03-15 00:03:17.000000', 'consum', 0.0213, 'lps'),
	(458131, 126, '2015-03-15 00:03:18.000000', 'consum', 0.0220, 'lps'),
	(458132, 126, '2015-03-15 00:03:19.000000', 'consum', 0.0212, 'lps'),
	(458133, 126, '2015-03-15 00:03:20.000000', 'consum', 0.0220, 'lps'),
	(458134, 126, '2015-03-15 00:03:21.000000', 'consum', 0.0210, 'lps'),
	(458135, 126, '2015-03-15 00:03:22.000000', 'consum', 0.0210, 'lps'),
	(458136, 126, '2015-03-15 00:03:23.000000', 'consum', 0.0210, 'lps'),
	(458137, 126, '2015-03-15 00:03:24.000000', 'consum', 0.0210, 'lps'),
	(458138, 126, '2015-03-15 00:03:25.000000', 'consum', 0.0210, 'lps'),
	(458139, 126, '2015-03-15 00:03:26.000000', 'consum', 0.0223, 'lps'),
	(458140, 126, '2015-03-15 00:03:27.000000', 'consum', 0.0222, 'lps'),
	(458141, 126, '2015-03-15 00:03:28.000000', 'consum', 0.0218, 'lps'),
	(458142, 126, '2015-03-15 00:03:29.000000', 'consum', 0.0213, 'lps'),
	(458143, 126, '2015-03-15 00:03:30.000000', 'consum', 0.0215, 'lps'),
	(458144, 126, '2015-03-15 00:03:31.000000', 'consum', 0.0213, 'lps'),
	(458145, 126, '2015-03-15 00:03:32.000000', 'consum', 0.0210, 'lps'),
	(458146, 126, '2015-03-15 00:03:33.000000', 'consum', 0.0215, 'lps'),
	(458147, 126, '2015-03-15 00:03:34.000000', 'consum', 0.0220, 'lps'),
	(458148, 126, '2015-03-15 00:03:35.000000', 'consum', 0.0220, 'lps'),
	(458149, 126, '2015-03-15 00:03:36.000000', 'consum', 0.0215, 'lps'),
	(458150, 126, '2015-03-15 00:03:37.000000', 'consum', 0.0220, 'lps'),
	(458151, 126, '2015-03-15 00:03:38.000000', 'consum', 0.0220, 'lps'),
	(458152, 126, '2015-03-15 00:03:39.000000', 'consum', 0.0213, 'lps'),
	(458153, 126, '2015-03-15 00:03:40.000000', 'consum', 0.0210, 'lps'),
	(458154, 126, '2015-03-15 00:03:41.000000', 'consum', 0.0214, 'lps'),
	(458155, 126, '2015-03-15 00:03:42.000000', 'consum', 0.0219, 'lps'),
	(458156, 126, '2015-03-15 00:03:43.000000', 'consum', 0.0216, 'lps'),
	(458157, 126, '2015-03-15 00:03:44.000000', 'consum', 0.0213, 'lps'),
	(458158, 126, '2015-03-15 00:03:45.000000', 'consum', 0.0219, 'lps'),
	(458159, 126, '2015-03-15 00:03:46.000000', 'consum', 0.0221, 'lps'),
	(458160, 126, '2015-03-15 00:03:47.000000', 'consum', 0.0222, 'lps'),
	(458161, 126, '2015-03-15 00:03:48.000000', 'consum', 0.0213, 'lps'),
	(458162, 126, '2015-03-15 00:03:49.000000', 'consum', 0.0215, 'lps'),
	(458163, 126, '2015-03-15 00:03:50.000000', 'consum', 0.0211, 'lps'),
	(458164, 126, '2015-03-15 00:03:51.000000', 'consum', 0.0218, 'lps'),
	(458165, 126, '2015-03-15 00:03:52.000000', 'consum', 0.0216, 'lps'),
	(458166, 126, '2015-03-15 00:03:53.000000', 'consum', 0.0219, 'lps'),
	(458167, 126, '2015-03-15 00:03:54.000000', 'consum', 0.0210, 'lps'),
	(458168, 126, '2015-03-15 00:03:55.000000', 'consum', 0.0210, 'lps'),
	(458169, 126, '2015-03-15 00:03:56.000000', 'consum', 0.0210, 'lps'),
	(458170, 126, '2015-03-15 00:03:57.000000', 'consum', 0.0211, 'lps'),
	(458171, 126, '2015-03-15 00:03:58.000000', 'consum', 0.0217, 'lps'),
	(458172, 126, '2015-03-15 00:03:59.000000', 'consum', 0.0215, 'lps'),
	(458173, 126, '2015-03-15 00:04:00.000000', 'consum', 0.0213, 'lps'),
	(458174, 126, '2015-03-15 00:04:01.000000', 'consum', 0.0211, 'lps'),
	(458175, 126, '2015-03-15 00:04:02.000000', 'consum', 0.0218, 'lps'),
	(458176, 126, '2015-03-15 00:04:03.000000', 'consum', 0.0222, 'lps'),
	(458177, 126, '2015-03-15 00:04:04.000000', 'consum', 0.0219, 'lps'),
	(458178, 126, '2015-03-15 00:04:05.000000', 'consum', 0.0220, 'lps'),
	(458179, 126, '2015-03-15 00:04:06.000000', 'consum', 0.0216, 'lps'),
	(458180, 126, '2015-03-15 00:04:07.000000', 'consum', 0.0214, 'lps'),
	(458181, 126, '2015-03-15 00:04:08.000000', 'consum', 0.0213, 'lps'),
	(458182, 126, '2015-03-15 00:04:09.000000', 'consum', 0.0214, 'lps'),
	(458183, 126, '2015-03-15 00:04:10.000000', 'consum', 0.0221, 'lps'),
	(458184, 126, '2015-03-15 00:04:11.000000', 'consum', 0.0223, 'lps'),
	(458185, 126, '2015-03-15 00:04:12.000000', 'consum', 0.0216, 'lps'),
	(458186, 126, '2015-03-15 00:04:13.000000', 'consum', 0.0216, 'lps'),
	(458187, 126, '2015-03-15 00:04:14.000000', 'consum', 0.0223, 'lps'),
	(458188, 126, '2015-03-15 00:04:15.000000', 'consum', 0.0214, 'lps'),
	(458189, 126, '2015-03-15 00:04:16.000000', 'consum', 0.0221, 'lps'),
	(458190, 126, '2015-03-15 00:04:17.000000', 'consum', 0.0212, 'lps'),
	(458191, 126, '2015-03-15 00:04:18.000000', 'consum', 0.0213, 'lps'),
	(458192, 126, '2015-03-15 00:04:19.000000', 'consum', 0.0223, 'lps'),
	(458193, 126, '2015-03-15 00:04:20.000000', 'consum', 0.0221, 'lps'),
	(458194, 126, '2015-03-15 00:04:21.000000', 'consum', 0.0215, 'lps'),
	(458195, 126, '2015-03-15 00:04:22.000000', 'consum', 0.0215, 'lps'),
	(458196, 126, '2015-03-15 00:04:23.000000', 'consum', 0.0222, 'lps'),
	(458197, 126, '2015-03-15 00:04:24.000000', 'consum', 0.0213, 'lps'),
	(458198, 126, '2015-03-15 00:04:25.000000', 'consum', 0.0216, 'lps'),
	(458199, 126, '2015-03-15 00:04:26.000000', 'consum', 0.0220, 'lps'),
	(458200, 126, '2015-03-15 00:04:27.000000', 'consum', 0.0214, 'lps'),
	(458201, 126, '2015-03-15 00:04:28.000000', 'consum', 0.0215, 'lps'),
	(458202, 126, '2015-03-15 00:04:29.000000', 'consum', 0.0223, 'lps'),
	(458203, 126, '2015-03-15 00:04:30.000000', 'consum', 0.0218, 'lps'),
	(458204, 126, '2015-03-15 00:04:31.000000', 'consum', 0.0210, 'lps'),
	(458205, 126, '2015-03-15 00:04:32.000000', 'consum', 0.0215, 'lps'),
	(458206, 126, '2015-03-15 00:04:33.000000', 'consum', 0.0221, 'lps'),
	(458207, 126, '2015-03-15 00:04:34.000000', 'consum', 0.0222, 'lps'),
	(458208, 126, '2015-03-15 00:04:35.000000', 'consum', 0.0222, 'lps'),
	(458209, 126, '2015-03-15 00:04:36.000000', 'consum', 0.0223, 'lps'),
	(458210, 126, '2015-03-15 00:04:37.000000', 'consum', 0.0213, 'lps'),
	(458211, 126, '2015-03-15 00:04:38.000000', 'consum', 0.0213, 'lps'),
	(458212, 126, '2015-03-15 00:04:39.000000', 'consum', 0.0216, 'lps'),
	(458213, 126, '2015-03-15 00:04:40.000000', 'consum', 0.0218, 'lps'),
	(458214, 126, '2015-03-15 00:04:41.000000', 'consum', 0.0221, 'lps'),
	(458215, 126, '2015-03-15 00:04:42.000000', 'consum', 0.0210, 'lps'),
	(458216, 126, '2015-03-15 00:04:43.000000', 'consum', 0.0219, 'lps'),
	(458217, 126, '2015-03-15 00:04:44.000000', 'consum', 0.0217, 'lps'),
	(458218, 126, '2015-03-15 00:04:45.000000', 'consum', 0.0216, 'lps'),
	(458219, 126, '2015-03-15 00:04:46.000000', 'consum', 0.0218, 'lps'),
	(458220, 126, '2015-03-15 00:04:47.000000', 'consum', 0.0220, 'lps'),
	(458221, 126, '2015-03-15 00:04:48.000000', 'consum', 0.0222, 'lps'),
	(458222, 126, '2015-03-15 00:04:49.000000', 'consum', 0.0212, 'lps'),
	(458223, 126, '2015-03-15 00:04:50.000000', 'consum', 0.0211, 'lps'),
	(458224, 126, '2015-03-15 00:04:51.000000', 'consum', 0.0211, 'lps'),
	(458225, 126, '2015-03-15 00:04:52.000000', 'consum', 0.0213, 'lps'),
	(458226, 126, '2015-03-15 00:04:53.000000', 'consum', 0.0222, 'lps'),
	(458227, 126, '2015-03-15 00:04:54.000000', 'consum', 0.0218, 'lps'),
	(458228, 126, '2015-03-15 00:04:55.000000', 'consum', 0.0214, 'lps'),
	(458229, 126, '2015-03-15 00:04:56.000000', 'consum', 0.0220, 'lps'),
	(458230, 126, '2015-03-15 00:04:57.000000', 'consum', 0.0223, 'lps'),
	(458231, 126, '2015-03-15 00:04:58.000000', 'consum', 0.0215, 'lps'),
	(458232, 126, '2015-03-15 00:04:59.000000', 'consum', 0.0212, 'lps'),
	(458233, 126, '2015-03-15 00:05:00.000000', 'consum', 0.0218, 'lps'),
	(458234, 126, '2015-03-15 00:05:01.000000', 'consum', 0.0218, 'lps'),
	(458235, 126, '2015-03-15 00:05:02.000000', 'consum', 0.0213, 'lps'),
	(458236, 126, '2015-03-15 00:05:03.000000', 'consum', 0.0215, 'lps'),
	(458237, 126, '2015-03-15 00:05:04.000000', 'consum', 0.0211, 'lps'),
	(458238, 126, '2015-03-15 00:05:05.000000', 'consum', 0.0215, 'lps'),
	(458239, 126, '2015-03-15 00:05:06.000000', 'consum', 0.0219, 'lps'),
	(458240, 126, '2015-03-15 00:05:07.000000', 'consum', 0.0211, 'lps'),
	(458241, 126, '2015-03-15 00:05:08.000000', 'consum', 0.0217, 'lps'),
	(458242, 126, '2015-03-15 00:05:09.000000', 'consum', 0.0216, 'lps'),
	(458243, 126, '2015-03-15 00:05:10.000000', 'consum', 0.0220, 'lps'),
	(458244, 126, '2015-03-15 00:05:11.000000', 'consum', 0.0215, 'lps'),
	(458245, 126, '2015-03-15 00:05:12.000000', 'consum', 0.0218, 'lps'),
	(458246, 126, '2015-03-15 00:05:13.000000', 'consum', 0.0223, 'lps'),
	(458247, 126, '2015-03-15 00:05:14.000000', 'consum', 0.0222, 'lps'),
	(458248, 126, '2015-03-15 00:05:15.000000', 'consum', 0.0219, 'lps'),
	(458249, 126, '2015-03-15 00:05:16.000000', 'consum', 0.0219, 'lps'),
	(458250, 126, '2015-03-15 00:05:17.000000', 'consum', 0.0212, 'lps'),
	(458251, 126, '2015-03-15 00:05:18.000000', 'consum', 0.0211, 'lps'),
	(458252, 126, '2015-03-15 00:05:19.000000', 'consum', 0.0220, 'lps'),
	(458253, 126, '2015-03-15 00:05:20.000000', 'consum', 0.0219, 'lps'),
	(458254, 126, '2015-03-15 00:05:21.000000', 'consum', 0.0210, 'lps'),
	(458255, 126, '2015-03-15 00:05:22.000000', 'consum', 0.0211, 'lps'),
	(458256, 126, '2015-03-15 00:05:23.000000', 'consum', 0.0217, 'lps'),
	(458257, 126, '2015-03-15 00:05:24.000000', 'consum', 0.0215, 'lps'),
	(458258, 126, '2015-03-15 00:05:25.000000', 'consum', 0.0212, 'lps'),
	(458259, 126, '2015-03-15 00:05:26.000000', 'consum', 0.0222, 'lps'),
	(458260, 126, '2015-03-15 00:05:27.000000', 'consum', 0.0221, 'lps'),
	(458261, 126, '2015-03-15 00:05:28.000000', 'consum', 0.0216, 'lps'),
	(458262, 126, '2015-03-15 00:05:29.000000', 'consum', 0.0223, 'lps'),
	(458263, 126, '2015-03-15 00:05:30.000000', 'consum', 0.0215, 'lps'),
	(458264, 126, '2015-03-15 00:05:31.000000', 'consum', 0.0210, 'lps'),
	(458265, 126, '2015-03-15 00:05:32.000000', 'consum', 0.0222, 'lps'),
	(458266, 126, '2015-03-15 00:05:33.000000', 'consum', 0.0215, 'lps'),
	(458267, 126, '2015-03-15 00:05:34.000000', 'consum', 0.0213, 'lps'),
	(458268, 126, '2015-03-15 00:05:35.000000', 'consum', 0.0211, 'lps'),
	(458269, 126, '2015-03-15 00:05:36.000000', 'consum', 0.0222, 'lps'),
	(458270, 126, '2015-03-15 00:05:37.000000', 'consum', 0.0212, 'lps'),
	(458271, 126, '2015-03-15 00:05:38.000000', 'consum', 0.0213, 'lps'),
	(458272, 126, '2015-03-15 00:05:39.000000', 'consum', 0.0220, 'lps'),
	(458273, 126, '2015-03-15 00:05:40.000000', 'consum', 0.0223, 'lps'),
	(458274, 126, '2015-03-15 00:05:41.000000', 'consum', 0.0218, 'lps'),
	(458275, 126, '2015-03-15 00:05:42.000000', 'consum', 0.0213, 'lps'),
	(458276, 126, '2015-03-15 00:05:43.000000', 'consum', 0.0214, 'lps'),
	(458277, 126, '2015-03-15 00:05:44.000000', 'consum', 0.0220, 'lps'),
	(458278, 126, '2015-03-15 00:05:45.000000', 'consum', 0.0210, 'lps'),
	(458279, 126, '2015-03-15 00:05:46.000000', 'consum', 0.0219, 'lps'),
	(458280, 126, '2015-03-15 00:05:47.000000', 'consum', 0.0213, 'lps'),
	(458281, 126, '2015-03-15 00:05:48.000000', 'consum', 0.0216, 'lps'),
	(458282, 126, '2015-03-15 00:05:49.000000', 'consum', 0.0215, 'lps'),
	(458283, 126, '2015-03-15 00:05:50.000000', 'consum', 0.0218, 'lps'),
	(458284, 126, '2015-03-15 00:05:51.000000', 'consum', 0.0223, 'lps'),
	(458285, 126, '2015-03-15 00:05:52.000000', 'consum', 0.0210, 'lps'),
	(458286, 126, '2015-03-15 00:05:53.000000', 'consum', 0.0212, 'lps'),
	(458287, 126, '2015-03-15 00:05:54.000000', 'consum', 0.0222, 'lps'),
	(458288, 126, '2015-03-15 00:05:55.000000', 'consum', 0.0222, 'lps'),
	(458289, 126, '2015-03-15 00:05:56.000000', 'consum', 0.0220, 'lps'),
	(458290, 126, '2015-03-15 00:05:57.000000', 'consum', 0.0223, 'lps'),
	(458291, 126, '2015-03-15 00:05:58.000000', 'consum', 0.0220, 'lps'),
	(458292, 126, '2015-03-15 00:05:59.000000', 'consum', 0.0221, 'lps'),
	(458293, 126, '2015-03-15 00:06:00.000000', 'consum', 0.0220, 'lps'),
	(458294, 126, '2015-03-15 00:06:01.000000', 'consum', 0.0213, 'lps'),
	(458295, 126, '2015-03-15 00:06:02.000000', 'consum', 0.0223, 'lps'),
	(458296, 126, '2015-03-15 00:06:03.000000', 'consum', 0.0213, 'lps'),
	(458297, 126, '2015-03-15 00:06:04.000000', 'consum', 0.0212, 'lps'),
	(458298, 126, '2015-03-15 00:06:05.000000', 'consum', 0.0213, 'lps'),
	(458299, 126, '2015-03-15 00:06:06.000000', 'consum', 0.0220, 'lps'),
	(458300, 126, '2015-03-15 00:06:07.000000', 'consum', 0.0222, 'lps'),
	(458301, 126, '2015-03-15 00:06:08.000000', 'consum', 0.0212, 'lps'),
	(458302, 126, '2015-03-15 00:06:09.000000', 'consum', 0.0215, 'lps'),
	(458303, 126, '2015-03-15 00:06:10.000000', 'consum', 0.0212, 'lps'),
	(458304, 126, '2015-03-15 00:06:11.000000', 'consum', 0.0223, 'lps'),
	(458305, 126, '2015-03-15 00:06:12.000000', 'consum', 0.0212, 'lps'),
	(458306, 126, '2015-03-15 00:06:13.000000', 'consum', 0.0210, 'lps'),
	(458307, 126, '2015-03-15 00:06:14.000000', 'consum', 0.0216, 'lps'),
	(458308, 126, '2015-03-15 00:06:15.000000', 'consum', 0.0214, 'lps'),
	(458309, 126, '2015-03-15 00:06:16.000000', 'consum', 0.0215, 'lps'),
	(458310, 126, '2015-03-15 00:06:17.000000', 'consum', 0.0220, 'lps'),
	(458311, 126, '2015-03-15 00:06:18.000000', 'consum', 0.0220, 'lps'),
	(458312, 126, '2015-03-15 00:06:19.000000', 'consum', 0.0216, 'lps'),
	(458313, 126, '2015-03-15 00:06:20.000000', 'consum', 0.0222, 'lps'),
	(458314, 126, '2015-03-15 00:06:21.000000', 'consum', 0.0213, 'lps'),
	(458315, 126, '2015-03-15 00:06:22.000000', 'consum', 0.0218, 'lps'),
	(458316, 126, '2015-03-15 00:06:23.000000', 'consum', 0.0211, 'lps'),
	(458317, 126, '2015-03-15 00:06:24.000000', 'consum', 0.0221, 'lps'),
	(458318, 126, '2015-03-15 00:06:25.000000', 'consum', 0.0222, 'lps'),
	(458319, 126, '2015-03-15 00:06:26.000000', 'consum', 0.0220, 'lps'),
	(458320, 126, '2015-03-15 00:06:27.000000', 'consum', 0.0213, 'lps'),
	(458321, 126, '2015-03-15 00:06:28.000000', 'consum', 0.0210, 'lps'),
	(458322, 126, '2015-03-15 00:06:29.000000', 'consum', 0.0213, 'lps'),
	(458323, 126, '2015-03-15 00:06:30.000000', 'consum', 0.0214, 'lps'),
	(458324, 126, '2015-03-15 00:06:31.000000', 'consum', 0.0219, 'lps'),
	(458325, 126, '2015-03-15 00:06:32.000000', 'consum', 0.0215, 'lps'),
	(458326, 126, '2015-03-15 00:06:33.000000', 'consum', 0.0212, 'lps'),
	(458327, 126, '2015-03-15 00:06:34.000000', 'consum', 0.0216, 'lps'),
	(458328, 126, '2015-03-15 00:06:35.000000', 'consum', 0.0223, 'lps'),
	(458329, 126, '2015-03-15 00:06:36.000000', 'consum', 0.0216, 'lps'),
	(458330, 126, '2015-03-15 00:06:37.000000', 'consum', 0.0214, 'lps'),
	(458331, 126, '2015-03-15 00:06:38.000000', 'consum', 0.0211, 'lps'),
	(458332, 126, '2015-03-15 00:06:39.000000', 'consum', 0.0220, 'lps'),
	(458333, 126, '2015-03-15 00:06:40.000000', 'consum', 0.0214, 'lps'),
	(458334, 126, '2015-03-15 00:06:41.000000', 'consum', 0.0214, 'lps'),
	(458335, 126, '2015-03-15 00:06:42.000000', 'consum', 0.0220, 'lps'),
	(458336, 126, '2015-03-15 00:06:43.000000', 'consum', 0.0219, 'lps'),
	(458337, 126, '2015-03-15 00:06:44.000000', 'consum', 0.0213, 'lps'),
	(458338, 126, '2015-03-15 00:06:45.000000', 'consum', 0.0214, 'lps'),
	(458339, 126, '2015-03-15 00:06:46.000000', 'consum', 0.0220, 'lps'),
	(458340, 126, '2015-03-15 00:06:47.000000', 'consum', 0.0220, 'lps'),
	(458341, 126, '2015-03-15 00:06:48.000000', 'consum', 0.0216, 'lps'),
	(458342, 126, '2015-03-15 00:06:49.000000', 'consum', 0.0210, 'lps'),
	(458343, 126, '2015-03-15 00:06:50.000000', 'consum', 0.0219, 'lps'),
	(458344, 126, '2015-03-15 00:06:51.000000', 'consum', 0.0217, 'lps'),
	(458345, 126, '2015-03-15 00:06:52.000000', 'consum', 0.0217, 'lps'),
	(458346, 126, '2015-03-15 00:06:53.000000', 'consum', 0.0223, 'lps'),
	(458347, 126, '2015-03-15 00:06:54.000000', 'consum', 0.0214, 'lps'),
	(458348, 126, '2015-03-15 00:06:55.000000', 'consum', 0.0220, 'lps'),
	(458349, 126, '2015-03-15 00:06:56.000000', 'consum', 0.0220, 'lps'),
	(458350, 126, '2015-03-15 00:06:57.000000', 'consum', 0.0217, 'lps'),
	(458351, 126, '2015-03-15 00:06:58.000000', 'consum', 0.0214, 'lps'),
	(458352, 126, '2015-03-15 00:06:59.000000', 'consum', 0.0223, 'lps'),
	(458353, 126, '2015-03-15 00:07:00.000000', 'consum', 0.0210, 'lps'),
	(458354, 126, '2015-03-15 00:07:01.000000', 'consum', 0.0211, 'lps'),
	(458355, 126, '2015-03-15 00:07:02.000000', 'consum', 0.0216, 'lps'),
	(458356, 126, '2015-03-15 00:07:03.000000', 'consum', 0.0223, 'lps'),
	(458357, 126, '2015-03-15 00:07:04.000000', 'consum', 0.0215, 'lps'),
	(458358, 126, '2015-03-15 00:07:05.000000', 'consum', 0.0210, 'lps'),
	(458359, 126, '2015-03-15 00:07:06.000000', 'consum', 0.0212, 'lps'),
	(458360, 126, '2015-03-15 00:07:07.000000', 'consum', 0.0217, 'lps'),
	(458361, 126, '2015-03-15 00:07:08.000000', 'consum', 0.0215, 'lps'),
	(458362, 126, '2015-03-15 00:07:09.000000', 'consum', 0.0214, 'lps'),
	(458363, 126, '2015-03-15 00:07:10.000000', 'consum', 0.0214, 'lps'),
	(458364, 126, '2015-03-15 00:07:11.000000', 'consum', 0.0221, 'lps'),
	(458365, 126, '2015-03-15 00:07:12.000000', 'consum', 0.0211, 'lps'),
	(458366, 126, '2015-03-15 00:07:13.000000', 'consum', 0.0211, 'lps'),
	(458367, 126, '2015-03-15 00:07:14.000000', 'consum', 0.0211, 'lps'),
	(458368, 126, '2015-03-15 00:07:15.000000', 'consum', 0.0215, 'lps'),
	(458369, 126, '2015-03-15 00:07:16.000000', 'consum', 0.0218, 'lps'),
	(458370, 126, '2015-03-15 00:07:17.000000', 'consum', 0.0221, 'lps'),
	(458371, 126, '2015-03-15 00:07:18.000000', 'consum', 0.0212, 'lps'),
	(458372, 126, '2015-03-15 00:07:19.000000', 'consum', 0.0216, 'lps'),
	(458373, 126, '2015-03-15 00:07:20.000000', 'consum', 0.0219, 'lps'),
	(458374, 126, '2015-03-15 00:07:21.000000', 'consum', 0.0212, 'lps'),
	(458375, 126, '2015-03-15 00:07:22.000000', 'consum', 0.0220, 'lps'),
	(458376, 126, '2015-03-15 00:07:23.000000', 'consum', 0.0212, 'lps'),
	(458377, 126, '2015-03-15 00:07:24.000000', 'consum', 0.0218, 'lps'),
	(458378, 126, '2015-03-15 00:07:25.000000', 'consum', 0.0216, 'lps'),
	(458379, 126, '2015-03-15 00:07:26.000000', 'consum', 0.0216, 'lps'),
	(458380, 126, '2015-03-15 00:07:27.000000', 'consum', 0.0222, 'lps'),
	(458381, 126, '2015-03-15 00:07:28.000000', 'consum', 0.0214, 'lps'),
	(458382, 126, '2015-03-15 00:07:29.000000', 'consum', 0.0219, 'lps'),
	(458383, 126, '2015-03-15 00:07:30.000000', 'consum', 0.0216, 'lps'),
	(458384, 126, '2015-03-15 00:07:31.000000', 'consum', 0.0215, 'lps'),
	(458385, 126, '2015-03-15 00:07:32.000000', 'consum', 0.0217, 'lps'),
	(458386, 126, '2015-03-15 00:07:33.000000', 'consum', 0.0215, 'lps'),
	(458387, 126, '2015-03-15 00:07:34.000000', 'consum', 0.0214, 'lps'),
	(458388, 126, '2015-03-15 00:07:35.000000', 'consum', 0.0216, 'lps'),
	(458389, 126, '2015-03-15 00:07:36.000000', 'consum', 0.0215, 'lps'),
	(458390, 126, '2015-03-15 00:07:37.000000', 'consum', 0.0216, 'lps'),
	(458391, 126, '2015-03-15 00:07:38.000000', 'consum', 0.0214, 'lps'),
	(458392, 126, '2015-03-15 00:07:39.000000', 'consum', 0.0212, 'lps'),
	(458393, 126, '2015-03-15 00:07:40.000000', 'consum', 0.0221, 'lps'),
	(458394, 126, '2015-03-15 00:07:41.000000', 'consum', 0.0219, 'lps'),
	(458395, 126, '2015-03-15 00:07:42.000000', 'consum', 0.0220, 'lps'),
	(458396, 126, '2015-03-15 00:07:43.000000', 'consum', 0.0221, 'lps'),
	(458397, 126, '2015-03-15 00:07:44.000000', 'consum', 0.0221, 'lps'),
	(458398, 126, '2015-03-15 00:07:45.000000', 'consum', 0.0219, 'lps'),
	(458399, 126, '2015-03-15 00:07:46.000000', 'consum', 0.0210, 'lps'),
	(458400, 126, '2015-03-15 00:07:47.000000', 'consum', 0.0211, 'lps'),
	(458401, 126, '2015-03-15 00:07:48.000000', 'consum', 0.0215, 'lps'),
	(458402, 126, '2015-03-15 00:07:49.000000', 'consum', 0.0220, 'lps'),
	(458403, 126, '2015-03-15 00:07:50.000000', 'consum', 0.0218, 'lps'),
	(458404, 126, '2015-03-15 00:07:51.000000', 'consum', 0.0219, 'lps'),
	(458405, 126, '2015-03-15 00:07:52.000000', 'consum', 0.0218, 'lps'),
	(458406, 126, '2015-03-15 00:07:53.000000', 'consum', 0.0211, 'lps'),
	(458407, 126, '2015-03-15 00:07:54.000000', 'consum', 0.0218, 'lps'),
	(458408, 126, '2015-03-15 00:07:55.000000', 'consum', 0.0218, 'lps'),
	(458409, 126, '2015-03-15 00:07:56.000000', 'consum', 0.0216, 'lps'),
	(458410, 126, '2015-03-15 00:07:57.000000', 'consum', 0.0214, 'lps'),
	(458411, 126, '2015-03-15 00:07:58.000000', 'consum', 0.0212, 'lps'),
	(458412, 126, '2015-03-15 00:07:59.000000', 'consum', 0.0223, 'lps'),
	(458413, 126, '2015-03-15 00:08:00.000000', 'consum', 0.0214, 'lps'),
	(458414, 126, '2015-03-15 00:08:01.000000', 'consum', 0.0219, 'lps'),
	(458415, 126, '2015-03-15 00:08:02.000000', 'consum', 0.0217, 'lps'),
	(458416, 126, '2015-03-15 00:08:03.000000', 'consum', 0.0218, 'lps'),
	(458417, 126, '2015-03-15 00:08:04.000000', 'consum', 0.0215, 'lps'),
	(458418, 126, '2015-03-15 00:08:05.000000', 'consum', 0.0212, 'lps'),
	(458419, 126, '2015-03-15 00:08:06.000000', 'consum', 0.0219, 'lps'),
	(458420, 126, '2015-03-15 00:08:07.000000', 'consum', 0.0220, 'lps'),
	(458421, 126, '2015-03-15 00:08:08.000000', 'consum', 0.0220, 'lps'),
	(458422, 126, '2015-03-15 00:08:09.000000', 'consum', 0.0216, 'lps'),
	(458423, 126, '2015-03-15 00:08:10.000000', 'consum', 0.0213, 'lps'),
	(458424, 126, '2015-03-15 00:08:11.000000', 'consum', 0.0219, 'lps'),
	(458425, 126, '2015-03-15 00:08:12.000000', 'consum', 0.0218, 'lps'),
	(458426, 126, '2015-03-15 00:08:13.000000', 'consum', 0.0211, 'lps'),
	(458427, 126, '2015-03-15 00:08:14.000000', 'consum', 0.0218, 'lps'),
	(458428, 126, '2015-03-15 00:08:15.000000', 'consum', 0.0221, 'lps'),
	(458429, 126, '2015-03-15 00:08:16.000000', 'consum', 0.0212, 'lps'),
	(458430, 126, '2015-03-15 00:08:17.000000', 'consum', 0.0215, 'lps'),
	(458431, 126, '2015-03-15 00:08:18.000000', 'consum', 0.0215, 'lps'),
	(458432, 126, '2015-03-15 00:08:19.000000', 'consum', 0.0220, 'lps'),
	(458433, 126, '2015-03-15 00:08:20.000000', 'consum', 0.0220, 'lps'),
	(458434, 126, '2015-03-15 00:08:21.000000', 'consum', 0.0217, 'lps'),
	(458435, 126, '2015-03-15 00:08:22.000000', 'consum', 0.0216, 'lps'),
	(458436, 126, '2015-03-15 00:08:23.000000', 'consum', 0.0217, 'lps'),
	(458437, 126, '2015-03-15 00:08:24.000000', 'consum', 0.0213, 'lps'),
	(458438, 126, '2015-03-15 00:08:25.000000', 'consum', 0.0221, 'lps'),
	(458439, 126, '2015-03-15 00:08:26.000000', 'consum', 0.0214, 'lps'),
	(458440, 126, '2015-03-15 00:08:27.000000', 'consum', 0.0210, 'lps'),
	(458441, 126, '2015-03-15 00:08:28.000000', 'consum', 0.0213, 'lps'),
	(458442, 126, '2015-03-15 00:08:29.000000', 'consum', 0.0210, 'lps'),
	(458443, 126, '2015-03-15 00:08:30.000000', 'consum', 0.0219, 'lps'),
	(458444, 126, '2015-03-15 00:08:31.000000', 'consum', 0.0211, 'lps'),
	(458445, 126, '2015-03-15 00:08:32.000000', 'consum', 0.0217, 'lps'),
	(458446, 126, '2015-03-15 00:08:33.000000', 'consum', 0.0213, 'lps'),
	(458447, 126, '2015-03-15 00:08:34.000000', 'consum', 0.0219, 'lps'),
	(458448, 126, '2015-03-15 00:08:35.000000', 'consum', 0.0217, 'lps'),
	(458449, 126, '2015-03-15 00:08:36.000000', 'consum', 0.0219, 'lps'),
	(458450, 126, '2015-03-15 00:08:37.000000', 'consum', 0.0223, 'lps'),
	(458451, 126, '2015-03-15 00:08:38.000000', 'consum', 0.0219, 'lps'),
	(458452, 126, '2015-03-15 00:08:39.000000', 'consum', 0.0218, 'lps'),
	(458453, 126, '2015-03-15 00:08:40.000000', 'consum', 0.0221, 'lps'),
	(458454, 126, '2015-03-15 00:08:41.000000', 'consum', 0.0213, 'lps'),
	(458455, 126, '2015-03-15 00:08:42.000000', 'consum', 0.0220, 'lps'),
	(458456, 126, '2015-03-15 00:08:43.000000', 'consum', 0.0223, 'lps'),
	(458457, 126, '2015-03-15 00:08:44.000000', 'consum', 0.0219, 'lps'),
	(458458, 126, '2015-03-15 00:08:45.000000', 'consum', 0.0217, 'lps'),
	(458459, 126, '2015-03-15 00:08:46.000000', 'consum', 0.0216, 'lps'),
	(458460, 126, '2015-03-15 00:08:47.000000', 'consum', 0.0223, 'lps'),
	(458461, 126, '2015-03-15 00:08:48.000000', 'consum', 0.0213, 'lps'),
	(458462, 126, '2015-03-15 00:08:49.000000', 'consum', 0.0214, 'lps'),
	(458463, 126, '2015-03-15 00:08:50.000000', 'consum', 0.0223, 'lps'),
	(458464, 126, '2015-03-15 00:08:51.000000', 'consum', 0.0220, 'lps'),
	(458465, 126, '2015-03-15 00:08:52.000000', 'consum', 0.0221, 'lps'),
	(458466, 126, '2015-03-15 00:08:53.000000', 'consum', 0.0210, 'lps'),
	(458467, 126, '2015-03-15 00:08:54.000000', 'consum', 0.0218, 'lps'),
	(458468, 126, '2015-03-15 00:08:55.000000', 'consum', 0.0222, 'lps'),
	(458469, 126, '2015-03-15 00:08:56.000000', 'consum', 0.0218, 'lps'),
	(458470, 126, '2015-03-15 00:08:57.000000', 'consum', 0.0214, 'lps'),
	(458471, 126, '2015-03-15 00:08:58.000000', 'consum', 0.0222, 'lps'),
	(458472, 126, '2015-03-15 00:08:59.000000', 'consum', 0.0217, 'lps'),
	(458473, 126, '2015-03-15 00:09:00.000000', 'consum', 0.0223, 'lps'),
	(458474, 126, '2015-03-15 00:09:01.000000', 'consum', 0.0210, 'lps'),
	(458475, 126, '2015-03-15 00:09:02.000000', 'consum', 0.0217, 'lps'),
	(458476, 126, '2015-03-15 00:09:03.000000', 'consum', 0.0216, 'lps'),
	(458477, 126, '2015-03-15 00:09:04.000000', 'consum', 0.0220, 'lps'),
	(458478, 126, '2015-03-15 00:09:05.000000', 'consum', 0.0214, 'lps'),
	(458479, 126, '2015-03-15 00:09:06.000000', 'consum', 0.0213, 'lps'),
	(458480, 126, '2015-03-15 00:09:07.000000', 'consum', 0.0214, 'lps'),
	(458481, 126, '2015-03-15 00:09:08.000000', 'consum', 0.0210, 'lps'),
	(458482, 126, '2015-03-15 00:09:09.000000', 'consum', 0.0223, 'lps'),
	(458483, 126, '2015-03-15 00:09:10.000000', 'consum', 0.0222, 'lps'),
	(458484, 126, '2015-03-15 00:09:11.000000', 'consum', 0.0218, 'lps'),
	(458485, 126, '2015-03-15 00:09:12.000000', 'consum', 0.0214, 'lps'),
	(458486, 126, '2015-03-15 00:09:13.000000', 'consum', 0.0220, 'lps'),
	(458487, 126, '2015-03-15 00:09:14.000000', 'consum', 0.0223, 'lps'),
	(458488, 126, '2015-03-15 00:09:15.000000', 'consum', 0.0214, 'lps'),
	(458489, 126, '2015-03-15 00:09:16.000000', 'consum', 0.0222, 'lps'),
	(458490, 126, '2015-03-15 00:09:17.000000', 'consum', 0.0217, 'lps'),
	(458491, 126, '2015-03-15 00:09:18.000000', 'consum', 0.0222, 'lps'),
	(458492, 126, '2015-03-15 00:09:19.000000', 'consum', 0.0221, 'lps'),
	(458493, 126, '2015-03-15 00:09:20.000000', 'consum', 0.0216, 'lps'),
	(458494, 126, '2015-03-15 00:09:21.000000', 'consum', 0.0221, 'lps'),
	(458495, 126, '2015-03-15 00:09:22.000000', 'consum', 0.0220, 'lps'),
	(458496, 126, '2015-03-15 00:09:23.000000', 'consum', 0.0212, 'lps'),
	(458497, 126, '2015-03-15 00:09:24.000000', 'consum', 0.0221, 'lps'),
	(458498, 126, '2015-03-15 00:09:25.000000', 'consum', 0.0218, 'lps'),
	(458499, 126, '2015-03-15 00:09:26.000000', 'consum', 0.0218, 'lps'),
	(458500, 126, '2015-03-15 00:09:27.000000', 'consum', 0.0212, 'lps'),
	(458501, 126, '2015-03-15 00:09:28.000000', 'consum', 0.0211, 'lps'),
	(458502, 126, '2015-03-15 00:09:29.000000', 'consum', 0.0211, 'lps'),
	(458503, 126, '2015-03-15 00:09:30.000000', 'consum', 0.0210, 'lps'),
	(458504, 126, '2015-03-15 00:09:31.000000', 'consum', 0.0222, 'lps'),
	(458505, 126, '2015-03-15 00:09:32.000000', 'consum', 0.0216, 'lps'),
	(458506, 126, '2015-03-15 00:09:33.000000', 'consum', 0.0219, 'lps'),
	(458507, 126, '2015-03-15 00:09:34.000000', 'consum', 0.0223, 'lps'),
	(458508, 126, '2015-03-15 00:09:35.000000', 'consum', 0.0219, 'lps'),
	(458509, 126, '2015-03-15 00:09:36.000000', 'consum', 0.0216, 'lps'),
	(458510, 126, '2015-03-15 00:09:37.000000', 'consum', 0.0216, 'lps'),
	(458511, 126, '2015-03-15 00:09:38.000000', 'consum', 0.0220, 'lps'),
	(458512, 126, '2015-03-15 00:09:39.000000', 'consum', 0.0216, 'lps'),
	(458513, 126, '2015-03-15 00:09:40.000000', 'consum', 0.0212, 'lps'),
	(458514, 126, '2015-03-15 00:09:41.000000', 'consum', 0.0213, 'lps'),
	(458515, 126, '2015-03-15 00:09:42.000000', 'consum', 0.0223, 'lps'),
	(458516, 126, '2015-03-15 00:09:43.000000', 'consum', 0.0221, 'lps'),
	(458517, 126, '2015-03-15 00:09:44.000000', 'consum', 0.0215, 'lps'),
	(458518, 126, '2015-03-15 00:09:45.000000', 'consum', 0.0214, 'lps'),
	(458519, 126, '2015-03-15 00:09:46.000000', 'consum', 0.0217, 'lps'),
	(458520, 126, '2015-03-15 00:09:47.000000', 'consum', 0.0218, 'lps'),
	(458521, 126, '2015-03-15 00:09:48.000000', 'consum', 0.0214, 'lps'),
	(458522, 126, '2015-03-15 00:09:49.000000', 'consum', 0.0210, 'lps'),
	(458523, 126, '2015-03-15 00:09:50.000000', 'consum', 0.0211, 'lps'),
	(458524, 126, '2015-03-15 00:09:51.000000', 'consum', 0.0216, 'lps'),
	(458525, 126, '2015-03-15 00:09:52.000000', 'consum', 0.0222, 'lps'),
	(458526, 126, '2015-03-15 00:09:53.000000', 'consum', 0.0211, 'lps'),
	(458527, 126, '2015-03-15 00:09:54.000000', 'consum', 0.0222, 'lps'),
	(458528, 126, '2015-03-15 00:09:55.000000', 'consum', 0.0223, 'lps'),
	(458529, 126, '2015-03-15 00:09:56.000000', 'consum', 0.0215, 'lps'),
	(458530, 126, '2015-03-15 00:09:57.000000', 'consum', 0.0223, 'lps'),
	(458531, 126, '2015-03-15 00:09:58.000000', 'consum', 0.0221, 'lps'),
	(458532, 126, '2015-03-15 00:09:59.000000', 'consum', 0.0223, 'lps'),
	(458533, 126, '2015-03-15 00:10:00.000000', 'consum', 0.0216, 'lps'),
	(458534, 126, '2015-03-15 00:10:01.000000', 'consum', 0.0217, 'lps'),
	(458535, 126, '2015-03-15 00:10:02.000000', 'consum', 0.0213, 'lps'),
	(458536, 126, '2015-03-15 00:10:03.000000', 'consum', 0.0216, 'lps'),
	(458537, 126, '2015-03-15 00:10:04.000000', 'consum', 0.0219, 'lps'),
	(458538, 126, '2015-03-15 00:10:05.000000', 'consum', 0.0210, 'lps'),
	(458539, 126, '2015-03-15 00:10:06.000000', 'consum', 0.0210, 'lps'),
	(458540, 126, '2015-03-15 00:10:07.000000', 'consum', 0.0211, 'lps'),
	(458541, 126, '2015-03-15 00:10:08.000000', 'consum', 0.0217, 'lps'),
	(458542, 126, '2015-03-15 00:10:09.000000', 'consum', 0.0216, 'lps'),
	(458543, 126, '2015-03-15 00:10:10.000000', 'consum', 0.0216, 'lps'),
	(458544, 126, '2015-03-15 00:10:11.000000', 'consum', 0.0211, 'lps'),
	(458545, 126, '2015-03-15 00:10:12.000000', 'consum', 0.0223, 'lps'),
	(458546, 126, '2015-03-15 00:10:13.000000', 'consum', 0.0216, 'lps'),
	(458547, 126, '2015-03-15 00:10:14.000000', 'consum', 0.0217, 'lps'),
	(458548, 126, '2015-03-15 00:10:15.000000', 'consum', 0.0215, 'lps'),
	(458549, 126, '2015-03-15 00:10:16.000000', 'consum', 0.0212, 'lps'),
	(458550, 126, '2015-03-15 00:10:17.000000', 'consum', 0.0220, 'lps'),
	(458551, 126, '2015-03-15 00:10:18.000000', 'consum', 0.0215, 'lps'),
	(458552, 126, '2015-03-15 00:10:19.000000', 'consum', 0.0217, 'lps'),
	(458553, 126, '2015-03-15 00:10:20.000000', 'consum', 0.0216, 'lps'),
	(458554, 126, '2015-03-15 00:10:21.000000', 'consum', 0.0220, 'lps'),
	(458555, 126, '2015-03-15 00:10:22.000000', 'consum', 0.0217, 'lps'),
	(458556, 126, '2015-03-15 00:10:23.000000', 'consum', 0.0213, 'lps'),
	(458557, 126, '2015-03-15 00:10:24.000000', 'consum', 0.0220, 'lps'),
	(458558, 126, '2015-03-15 00:10:25.000000', 'consum', 0.0210, 'lps'),
	(458559, 126, '2015-03-15 00:10:26.000000', 'consum', 0.0223, 'lps'),
	(458560, 126, '2015-03-15 00:10:27.000000', 'consum', 0.0217, 'lps'),
	(458561, 126, '2015-03-15 00:10:28.000000', 'consum', 0.0221, 'lps'),
	(458562, 126, '2015-03-15 00:10:29.000000', 'consum', 0.0216, 'lps'),
	(458563, 126, '2015-03-15 00:10:30.000000', 'consum', 0.0221, 'lps'),
	(458564, 126, '2015-03-15 00:10:31.000000', 'consum', 0.0221, 'lps'),
	(458565, 126, '2015-03-15 00:10:32.000000', 'consum', 0.0217, 'lps'),
	(458566, 126, '2015-03-15 00:10:33.000000', 'consum', 0.0215, 'lps'),
	(458567, 126, '2015-03-15 00:10:34.000000', 'consum', 0.0211, 'lps'),
	(458568, 126, '2015-03-15 00:10:35.000000', 'consum', 0.0217, 'lps'),
	(458569, 126, '2015-03-15 00:10:36.000000', 'consum', 0.0215, 'lps'),
	(458570, 126, '2015-03-15 00:10:37.000000', 'consum', 0.0212, 'lps'),
	(458571, 126, '2015-03-15 00:10:38.000000', 'consum', 0.0222, 'lps'),
	(458572, 126, '2015-03-15 00:10:39.000000', 'consum', 0.0223, 'lps'),
	(458573, 126, '2015-03-15 00:10:40.000000', 'consum', 0.0210, 'lps'),
	(458574, 126, '2015-03-15 00:10:41.000000', 'consum', 0.0213, 'lps'),
	(458575, 126, '2015-03-15 00:10:42.000000', 'consum', 0.0214, 'lps'),
	(458576, 126, '2015-03-15 00:10:43.000000', 'consum', 0.0219, 'lps'),
	(458577, 126, '2015-03-15 00:10:44.000000', 'consum', 0.0215, 'lps'),
	(458578, 126, '2015-03-15 00:10:45.000000', 'consum', 0.0221, 'lps'),
	(458579, 126, '2015-03-15 00:10:46.000000', 'consum', 0.0212, 'lps'),
	(458580, 126, '2015-03-15 00:10:47.000000', 'consum', 0.0214, 'lps'),
	(458581, 126, '2015-03-15 00:10:48.000000', 'consum', 0.0213, 'lps'),
	(458582, 126, '2015-03-15 00:10:49.000000', 'consum', 0.0210, 'lps'),
	(458583, 126, '2015-03-15 00:10:50.000000', 'consum', 0.0216, 'lps'),
	(458584, 126, '2015-03-15 00:10:51.000000', 'consum', 0.0214, 'lps'),
	(458585, 126, '2015-03-15 00:10:52.000000', 'consum', 0.0214, 'lps'),
	(458586, 126, '2015-03-15 00:10:53.000000', 'consum', 0.0217, 'lps'),
	(458587, 126, '2015-03-15 00:10:54.000000', 'consum', 0.0218, 'lps'),
	(458588, 126, '2015-03-15 00:10:55.000000', 'consum', 0.0218, 'lps'),
	(458589, 126, '2015-03-15 00:10:56.000000', 'consum', 0.0212, 'lps'),
	(458590, 126, '2015-03-15 00:10:57.000000', 'consum', 0.0222, 'lps'),
	(458591, 126, '2015-03-15 00:10:58.000000', 'consum', 0.0211, 'lps'),
	(458592, 126, '2015-03-15 00:10:59.000000', 'consum', 0.0221, 'lps'),
	(458593, 126, '2015-03-15 00:11:00.000000', 'consum', 0.0220, 'lps'),
	(458594, 126, '2015-03-15 00:11:01.000000', 'consum', 0.0213, 'lps'),
	(458595, 126, '2015-03-15 00:11:02.000000', 'consum', 0.0211, 'lps'),
	(458596, 126, '2015-03-15 00:11:03.000000', 'consum', 0.0220, 'lps'),
	(458597, 126, '2015-03-15 00:11:04.000000', 'consum', 0.0217, 'lps'),
	(458598, 126, '2015-03-15 00:11:05.000000', 'consum', 0.0213, 'lps'),
	(458599, 126, '2015-03-15 00:11:06.000000', 'consum', 0.0218, 'lps'),
	(458600, 126, '2015-03-15 00:11:07.000000', 'consum', 0.0213, 'lps'),
	(458601, 126, '2015-03-15 00:11:08.000000', 'consum', 0.0218, 'lps'),
	(458602, 126, '2015-03-15 00:11:09.000000', 'consum', 0.0213, 'lps'),
	(458603, 126, '2015-03-15 00:11:10.000000', 'consum', 0.0214, 'lps'),
	(458604, 126, '2015-03-15 00:11:11.000000', 'consum', 0.0222, 'lps'),
	(458605, 126, '2015-03-15 00:11:12.000000', 'consum', 0.0215, 'lps'),
	(458606, 126, '2015-03-15 00:11:13.000000', 'consum', 0.0213, 'lps'),
	(458607, 126, '2015-03-15 00:11:14.000000', 'consum', 0.0212, 'lps'),
	(458608, 126, '2015-03-15 00:11:15.000000', 'consum', 0.0212, 'lps'),
	(458609, 126, '2015-03-15 00:11:16.000000', 'consum', 0.0215, 'lps'),
	(458610, 126, '2015-03-15 00:11:17.000000', 'consum', 0.0213, 'lps'),
	(458611, 126, '2015-03-15 00:11:18.000000', 'consum', 0.0211, 'lps'),
	(458612, 126, '2015-03-15 00:11:19.000000', 'consum', 0.0223, 'lps'),
	(458613, 126, '2015-03-15 00:11:20.000000', 'consum', 0.0213, 'lps'),
	(458614, 126, '2015-03-15 00:11:21.000000', 'consum', 0.0217, 'lps'),
	(458615, 126, '2015-03-15 00:11:22.000000', 'consum', 0.0222, 'lps'),
	(458616, 126, '2015-03-15 00:11:23.000000', 'consum', 0.0220, 'lps'),
	(458617, 126, '2015-03-15 00:11:24.000000', 'consum', 0.0212, 'lps'),
	(458618, 126, '2015-03-15 00:11:25.000000', 'consum', 0.0219, 'lps'),
	(458619, 126, '2015-03-15 00:11:26.000000', 'consum', 0.0222, 'lps'),
	(458620, 126, '2015-03-15 00:11:27.000000', 'consum', 0.0213, 'lps'),
	(458621, 126, '2015-03-15 00:11:28.000000', 'consum', 0.0217, 'lps'),
	(458622, 126, '2015-03-15 00:11:29.000000', 'consum', 0.0210, 'lps'),
	(458623, 126, '2015-03-15 00:11:30.000000', 'consum', 0.0216, 'lps'),
	(458624, 126, '2015-03-15 00:11:31.000000', 'consum', 0.0213, 'lps'),
	(458625, 126, '2015-03-15 00:11:32.000000', 'consum', 0.0222, 'lps'),
	(458626, 126, '2015-03-15 00:11:33.000000', 'consum', 0.0219, 'lps'),
	(458627, 126, '2015-03-15 00:11:34.000000', 'consum', 0.0221, 'lps'),
	(458628, 126, '2015-03-15 00:11:35.000000', 'consum', 0.0222, 'lps'),
	(458629, 126, '2015-03-15 00:11:36.000000', 'consum', 0.0210, 'lps'),
	(458630, 126, '2015-03-15 00:11:37.000000', 'consum', 0.0215, 'lps'),
	(458631, 126, '2015-03-15 00:11:38.000000', 'consum', 0.0210, 'lps'),
	(458632, 126, '2015-03-15 00:11:39.000000', 'consum', 0.0221, 'lps'),
	(458633, 126, '2015-03-15 00:11:40.000000', 'consum', 0.0210, 'lps'),
	(458634, 126, '2015-03-15 00:11:41.000000', 'consum', 0.0221, 'lps'),
	(458635, 126, '2015-03-15 00:11:42.000000', 'consum', 0.0222, 'lps'),
	(458636, 126, '2015-03-15 00:11:43.000000', 'consum', 0.0210, 'lps'),
	(458637, 126, '2015-03-15 00:11:44.000000', 'consum', 0.0216, 'lps'),
	(458638, 126, '2015-03-15 00:11:45.000000', 'consum', 0.0211, 'lps'),
	(458639, 126, '2015-03-15 00:11:46.000000', 'consum', 0.0212, 'lps'),
	(458640, 126, '2015-03-15 00:11:47.000000', 'consum', 0.0216, 'lps'),
	(458641, 126, '2015-03-15 00:11:48.000000', 'consum', 0.0210, 'lps'),
	(458642, 126, '2015-03-15 00:11:49.000000', 'consum', 0.0217, 'lps'),
	(458643, 126, '2015-03-15 00:11:50.000000', 'consum', 0.0219, 'lps'),
	(458644, 126, '2015-03-15 00:11:51.000000', 'consum', 0.0222, 'lps'),
	(458645, 126, '2015-03-15 00:11:52.000000', 'consum', 0.0213, 'lps'),
	(458646, 126, '2015-03-15 00:11:53.000000', 'consum', 0.0217, 'lps'),
	(458647, 126, '2015-03-15 00:11:54.000000', 'consum', 0.0222, 'lps'),
	(458648, 126, '2015-03-15 00:11:55.000000', 'consum', 0.0223, 'lps'),
	(458649, 126, '2015-03-15 00:11:56.000000', 'consum', 0.0213, 'lps'),
	(458650, 126, '2015-03-15 00:11:57.000000', 'consum', 0.0212, 'lps'),
	(458651, 126, '2015-03-15 00:11:58.000000', 'consum', 0.0214, 'lps'),
	(458652, 126, '2015-03-15 00:11:59.000000', 'consum', 0.0223, 'lps'),
	(458653, 126, '2015-03-15 00:12:00.000000', 'consum', 0.0221, 'lps'),
	(458654, 126, '2015-03-15 00:12:01.000000', 'consum', 0.0214, 'lps'),
	(458655, 126, '2015-03-15 00:12:02.000000', 'consum', 0.0210, 'lps'),
	(458656, 126, '2015-03-15 00:12:03.000000', 'consum', 0.0215, 'lps'),
	(458657, 126, '2015-03-15 00:12:04.000000', 'consum', 0.0220, 'lps'),
	(458658, 126, '2015-03-15 00:12:05.000000', 'consum', 0.0216, 'lps'),
	(458659, 126, '2015-03-15 00:12:06.000000', 'consum', 0.0210, 'lps'),
	(458660, 126, '2015-03-15 00:12:07.000000', 'consum', 0.0221, 'lps'),
	(458661, 126, '2015-03-15 00:12:08.000000', 'consum', 0.0211, 'lps'),
	(458662, 126, '2015-03-15 00:12:09.000000', 'consum', 0.0222, 'lps'),
	(458663, 126, '2015-03-15 00:12:10.000000', 'consum', 0.0214, 'lps'),
	(458664, 126, '2015-03-15 00:12:11.000000', 'consum', 0.0222, 'lps'),
	(458665, 126, '2015-03-15 00:12:12.000000', 'consum', 0.0214, 'lps'),
	(458666, 126, '2015-03-15 00:12:13.000000', 'consum', 0.0211, 'lps'),
	(458667, 126, '2015-03-15 00:12:14.000000', 'consum', 0.0217, 'lps'),
	(458668, 126, '2015-03-15 00:12:15.000000', 'consum', 0.0215, 'lps'),
	(458669, 126, '2015-03-15 00:12:16.000000', 'consum', 0.0216, 'lps'),
	(458670, 126, '2015-03-15 00:12:17.000000', 'consum', 0.0211, 'lps'),
	(458671, 126, '2015-03-15 00:12:18.000000', 'consum', 0.0211, 'lps'),
	(458672, 126, '2015-03-15 00:12:19.000000', 'consum', 0.0211, 'lps'),
	(458673, 126, '2015-03-15 00:12:20.000000', 'consum', 0.0213, 'lps'),
	(458674, 126, '2015-03-15 00:12:21.000000', 'consum', 0.0210, 'lps'),
	(458675, 126, '2015-03-15 00:12:22.000000', 'consum', 0.0216, 'lps'),
	(458676, 126, '2015-03-15 00:12:23.000000', 'consum', 0.0214, 'lps'),
	(458677, 126, '2015-03-15 00:12:24.000000', 'consum', 0.0223, 'lps'),
	(458678, 126, '2015-03-15 00:12:25.000000', 'consum', 0.0210, 'lps'),
	(458679, 126, '2015-03-15 00:12:26.000000', 'consum', 0.0214, 'lps'),
	(458680, 126, '2015-03-15 00:12:27.000000', 'consum', 0.0215, 'lps'),
	(458681, 126, '2015-03-15 00:12:28.000000', 'consum', 0.0211, 'lps'),
	(458682, 126, '2015-03-15 00:12:29.000000', 'consum', 0.0213, 'lps'),
	(458683, 126, '2015-03-15 00:12:30.000000', 'consum', 0.0210, 'lps'),
	(458684, 126, '2015-03-15 00:12:31.000000', 'consum', 0.0213, 'lps'),
	(458685, 126, '2015-03-15 00:12:32.000000', 'consum', 0.0213, 'lps'),
	(458686, 126, '2015-03-15 00:12:33.000000', 'consum', 0.0216, 'lps'),
	(458687, 126, '2015-03-15 00:12:34.000000', 'consum', 0.0217, 'lps'),
	(458688, 126, '2015-03-15 00:12:35.000000', 'consum', 0.0213, 'lps'),
	(458689, 126, '2015-03-15 00:12:36.000000', 'consum', 0.0218, 'lps'),
	(458690, 126, '2015-03-15 00:12:37.000000', 'consum', 0.0213, 'lps'),
	(458691, 126, '2015-03-15 00:12:38.000000', 'consum', 0.0215, 'lps'),
	(458692, 126, '2015-03-15 00:12:39.000000', 'consum', 0.0215, 'lps'),
	(458693, 126, '2015-03-15 00:12:40.000000', 'consum', 0.0220, 'lps'),
	(458694, 126, '2015-03-15 00:12:41.000000', 'consum', 0.0216, 'lps'),
	(458695, 126, '2015-03-15 00:12:42.000000', 'consum', 0.0212, 'lps'),
	(458696, 126, '2015-03-15 00:12:43.000000', 'consum', 0.0215, 'lps'),
	(458697, 126, '2015-03-15 00:12:44.000000', 'consum', 0.0218, 'lps'),
	(458698, 126, '2015-03-15 00:12:45.000000', 'consum', 0.0219, 'lps'),
	(458699, 126, '2015-03-15 00:12:46.000000', 'consum', 0.0220, 'lps'),
	(458700, 126, '2015-03-15 00:12:47.000000', 'consum', 0.0217, 'lps'),
	(458701, 126, '2015-03-15 00:12:48.000000', 'consum', 0.0217, 'lps'),
	(458702, 126, '2015-03-15 00:12:49.000000', 'consum', 0.0222, 'lps'),
	(458703, 126, '2015-03-15 00:12:50.000000', 'consum', 0.0211, 'lps'),
	(458704, 126, '2015-03-15 00:12:51.000000', 'consum', 0.0220, 'lps'),
	(458705, 126, '2015-03-15 00:12:52.000000', 'consum', 0.0216, 'lps'),
	(458706, 126, '2015-03-15 00:12:53.000000', 'consum', 0.0212, 'lps'),
	(458707, 126, '2015-03-15 00:12:54.000000', 'consum', 0.0215, 'lps'),
	(458708, 126, '2015-03-15 00:12:55.000000', 'consum', 0.0215, 'lps'),
	(458709, 126, '2015-03-15 00:12:56.000000', 'consum', 0.0222, 'lps'),
	(458710, 126, '2015-03-15 00:12:57.000000', 'consum', 0.0213, 'lps'),
	(458711, 126, '2015-03-15 00:12:58.000000', 'consum', 0.0216, 'lps'),
	(458712, 126, '2015-03-15 00:12:59.000000', 'consum', 0.0217, 'lps'),
	(458713, 126, '2015-03-15 00:13:00.000000', 'consum', 0.0212, 'lps'),
	(458714, 126, '2015-03-15 00:13:01.000000', 'consum', 0.0217, 'lps'),
	(458715, 126, '2015-03-15 00:13:02.000000', 'consum', 0.0211, 'lps'),
	(458716, 126, '2015-03-15 00:13:03.000000', 'consum', 0.0210, 'lps'),
	(458717, 126, '2015-03-15 00:13:04.000000', 'consum', 0.0220, 'lps'),
	(458718, 126, '2015-03-15 00:13:05.000000', 'consum', 0.0220, 'lps'),
	(458719, 126, '2015-03-15 00:13:06.000000', 'consum', 0.0215, 'lps'),
	(458720, 126, '2015-03-15 00:13:07.000000', 'consum', 0.0218, 'lps'),
	(458721, 126, '2015-03-15 00:13:08.000000', 'consum', 0.0210, 'lps'),
	(458722, 126, '2015-03-15 00:13:09.000000', 'consum', 0.0212, 'lps'),
	(458723, 126, '2015-03-15 00:13:10.000000', 'consum', 0.0222, 'lps'),
	(458724, 126, '2015-03-15 00:13:11.000000', 'consum', 0.0210, 'lps'),
	(458725, 126, '2015-03-15 00:13:12.000000', 'consum', 0.0214, 'lps'),
	(458726, 126, '2015-03-15 00:13:13.000000', 'consum', 0.0216, 'lps'),
	(458727, 126, '2015-03-15 00:13:14.000000', 'consum', 0.0217, 'lps'),
	(458728, 126, '2015-03-15 00:13:15.000000', 'consum', 0.0212, 'lps'),
	(458729, 126, '2015-03-15 00:13:16.000000', 'consum', 0.0215, 'lps'),
	(458730, 126, '2015-03-15 00:13:17.000000', 'consum', 0.0213, 'lps'),
	(458731, 126, '2015-03-15 00:13:18.000000', 'consum', 0.0211, 'lps'),
	(458732, 126, '2015-03-15 00:13:19.000000', 'consum', 0.0220, 'lps'),
	(458733, 126, '2015-03-15 00:13:20.000000', 'consum', 0.0217, 'lps'),
	(458734, 126, '2015-03-15 00:13:21.000000', 'consum', 0.0217, 'lps'),
	(458735, 126, '2015-03-15 00:13:22.000000', 'consum', 0.0223, 'lps'),
	(458736, 126, '2015-03-15 00:13:23.000000', 'consum', 0.0212, 'lps'),
	(458737, 126, '2015-03-15 00:13:24.000000', 'consum', 0.0212, 'lps'),
	(458738, 126, '2015-03-15 00:13:25.000000', 'consum', 0.0212, 'lps'),
	(458739, 126, '2015-03-15 00:13:26.000000', 'consum', 0.0213, 'lps'),
	(458740, 126, '2015-03-15 00:13:27.000000', 'consum', 0.0222, 'lps'),
	(458741, 126, '2015-03-15 00:13:28.000000', 'consum', 0.0219, 'lps'),
	(458742, 126, '2015-03-15 00:13:29.000000', 'consum', 0.0217, 'lps'),
	(458743, 126, '2015-03-15 00:13:30.000000', 'consum', 0.0221, 'lps'),
	(458744, 126, '2015-03-15 00:13:31.000000', 'consum', 0.0217, 'lps'),
	(458745, 126, '2015-03-15 00:13:32.000000', 'consum', 0.0214, 'lps'),
	(458746, 126, '2015-03-15 00:13:33.000000', 'consum', 0.0221, 'lps'),
	(458747, 126, '2015-03-15 00:13:34.000000', 'consum', 0.0213, 'lps'),
	(458748, 126, '2015-03-15 00:13:35.000000', 'consum', 0.0218, 'lps'),
	(458749, 126, '2015-03-15 00:13:36.000000', 'consum', 0.0217, 'lps'),
	(458750, 126, '2015-03-15 00:13:37.000000', 'consum', 0.0219, 'lps'),
	(458751, 126, '2015-03-15 00:13:38.000000', 'consum', 0.0220, 'lps'),
	(458752, 126, '2015-03-15 00:13:39.000000', 'consum', 0.0218, 'lps'),
	(458753, 126, '2015-03-15 00:13:40.000000', 'consum', 0.0210, 'lps'),
	(458754, 126, '2015-03-15 00:13:41.000000', 'consum', 0.0212, 'lps'),
	(458755, 126, '2015-03-15 00:13:42.000000', 'consum', 0.0220, 'lps'),
	(458756, 126, '2015-03-15 00:13:43.000000', 'consum', 0.0214, 'lps'),
	(458757, 126, '2015-03-15 00:13:44.000000', 'consum', 0.0212, 'lps'),
	(458758, 126, '2015-03-15 00:13:45.000000', 'consum', 0.0211, 'lps'),
	(458759, 126, '2015-03-15 00:13:46.000000', 'consum', 0.0211, 'lps'),
	(458760, 126, '2015-03-15 00:13:47.000000', 'consum', 0.0210, 'lps'),
	(458761, 126, '2015-03-15 00:13:48.000000', 'consum', 0.0210, 'lps'),
	(458762, 126, '2015-03-15 00:13:49.000000', 'consum', 0.0222, 'lps'),
	(458763, 126, '2015-03-15 00:13:50.000000', 'consum', 0.0216, 'lps'),
	(458764, 126, '2015-03-15 00:13:51.000000', 'consum', 0.0219, 'lps'),
	(458765, 126, '2015-03-15 00:13:52.000000', 'consum', 0.0210, 'lps'),
	(458766, 126, '2015-03-15 00:13:53.000000', 'consum', 0.0210, 'lps'),
	(458767, 126, '2015-03-15 00:13:54.000000', 'consum', 0.0213, 'lps'),
	(458768, 126, '2015-03-15 00:13:55.000000', 'consum', 0.0223, 'lps'),
	(458769, 126, '2015-03-15 00:13:56.000000', 'consum', 0.0212, 'lps'),
	(458770, 126, '2015-03-15 00:13:57.000000', 'consum', 0.0211, 'lps'),
	(458771, 126, '2015-03-15 00:13:58.000000', 'consum', 0.0223, 'lps'),
	(458772, 126, '2015-03-15 00:13:59.000000', 'consum', 0.0214, 'lps'),
	(458773, 126, '2015-03-15 00:14:00.000000', 'consum', 0.0223, 'lps'),
	(458774, 126, '2015-03-15 00:14:01.000000', 'consum', 0.0219, 'lps'),
	(458775, 126, '2015-03-15 00:14:02.000000', 'consum', 0.0217, 'lps'),
	(458776, 126, '2015-03-15 00:14:03.000000', 'consum', 0.0219, 'lps'),
	(458777, 126, '2015-03-15 00:14:04.000000', 'consum', 0.0220, 'lps'),
	(458778, 126, '2015-03-15 00:14:05.000000', 'consum', 0.0218, 'lps'),
	(458779, 126, '2015-03-15 00:14:06.000000', 'consum', 0.0221, 'lps'),
	(458780, 126, '2015-03-15 00:14:07.000000', 'consum', 0.0214, 'lps'),
	(458781, 126, '2015-03-15 00:14:08.000000', 'consum', 0.0211, 'lps'),
	(458782, 126, '2015-03-15 00:14:09.000000', 'consum', 0.0218, 'lps'),
	(458783, 126, '2015-03-15 00:14:10.000000', 'consum', 0.0220, 'lps'),
	(458784, 126, '2015-03-15 00:14:11.000000', 'consum', 0.0221, 'lps'),
	(458785, 126, '2015-03-15 00:14:12.000000', 'consum', 0.0223, 'lps'),
	(458786, 126, '2015-03-15 00:14:13.000000', 'consum', 0.0214, 'lps'),
	(458787, 126, '2015-03-15 00:14:14.000000', 'consum', 0.0220, 'lps'),
	(458788, 126, '2015-03-15 00:14:15.000000', 'consum', 0.0219, 'lps'),
	(458789, 126, '2015-03-15 00:14:16.000000', 'consum', 0.0210, 'lps'),
	(458790, 126, '2015-03-15 00:14:17.000000', 'consum', 0.0215, 'lps'),
	(458791, 126, '2015-03-15 00:14:18.000000', 'consum', 0.0219, 'lps'),
	(458792, 126, '2015-03-15 00:14:19.000000', 'consum', 0.0212, 'lps'),
	(458793, 126, '2015-03-15 00:14:20.000000', 'consum', 0.0211, 'lps'),
	(458794, 126, '2015-03-15 00:14:21.000000', 'consum', 0.0220, 'lps'),
	(458795, 126, '2015-03-15 00:14:22.000000', 'consum', 0.0215, 'lps'),
	(458796, 126, '2015-03-15 00:14:23.000000', 'consum', 0.0220, 'lps'),
	(458797, 126, '2015-03-15 00:14:24.000000', 'consum', 0.0219, 'lps'),
	(458798, 126, '2015-03-15 00:14:25.000000', 'consum', 0.0210, 'lps'),
	(458799, 126, '2015-03-15 00:14:26.000000', 'consum', 0.0214, 'lps'),
	(458800, 126, '2015-03-15 00:14:27.000000', 'consum', 0.0213, 'lps'),
	(458801, 126, '2015-03-15 00:14:28.000000', 'consum', 0.0215, 'lps'),
	(458802, 126, '2015-03-15 00:14:29.000000', 'consum', 0.0213, 'lps'),
	(458803, 126, '2015-03-15 00:14:30.000000', 'consum', 0.0222, 'lps'),
	(458804, 126, '2015-03-15 00:14:31.000000', 'consum', 0.0222, 'lps'),
	(458805, 126, '2015-03-15 00:14:32.000000', 'consum', 0.0221, 'lps'),
	(458806, 126, '2015-03-15 00:14:33.000000', 'consum', 0.0215, 'lps'),
	(458807, 126, '2015-03-15 00:14:34.000000', 'consum', 0.0215, 'lps'),
	(458808, 126, '2015-03-15 00:14:35.000000', 'consum', 0.0221, 'lps'),
	(458809, 126, '2015-03-15 00:14:36.000000', 'consum', 0.0222, 'lps'),
	(458810, 126, '2015-03-15 00:14:37.000000', 'consum', 0.0222, 'lps'),
	(458811, 126, '2015-03-15 00:14:38.000000', 'consum', 0.0210, 'lps'),
	(458812, 126, '2015-03-15 00:14:39.000000', 'consum', 0.0214, 'lps'),
	(458813, 126, '2015-03-15 00:14:40.000000', 'consum', 0.0217, 'lps'),
	(458814, 126, '2015-03-15 00:14:41.000000', 'consum', 0.0218, 'lps'),
	(458815, 126, '2015-03-15 00:14:42.000000', 'consum', 0.0219, 'lps'),
	(458816, 126, '2015-03-15 00:14:43.000000', 'consum', 0.0214, 'lps'),
	(458817, 126, '2015-03-15 00:14:44.000000', 'consum', 0.0220, 'lps'),
	(458818, 126, '2015-03-15 00:14:45.000000', 'consum', 0.0218, 'lps'),
	(458819, 126, '2015-03-15 00:14:46.000000', 'consum', 0.0223, 'lps'),
	(458820, 126, '2015-03-15 00:14:47.000000', 'consum', 0.0223, 'lps'),
	(458821, 126, '2015-03-15 00:14:48.000000', 'consum', 0.0221, 'lps'),
	(458822, 126, '2015-03-15 00:14:49.000000', 'consum', 0.0215, 'lps'),
	(458823, 126, '2015-03-15 00:14:50.000000', 'consum', 0.0214, 'lps'),
	(458824, 126, '2015-03-15 00:14:51.000000', 'consum', 0.0214, 'lps'),
	(458825, 126, '2015-03-15 00:14:52.000000', 'consum', 0.0222, 'lps'),
	(458826, 126, '2015-03-15 00:14:53.000000', 'consum', 0.0213, 'lps'),
	(458827, 126, '2015-03-15 00:14:54.000000', 'consum', 0.0220, 'lps'),
	(458828, 126, '2015-03-15 00:14:55.000000', 'consum', 0.0210, 'lps'),
	(458829, 126, '2015-03-15 00:14:56.000000', 'consum', 0.0222, 'lps'),
	(458830, 126, '2015-03-15 00:14:57.000000', 'consum', 0.0215, 'lps'),
	(458831, 126, '2015-03-15 00:14:58.000000', 'consum', 0.0211, 'lps'),
	(458832, 126, '2015-03-15 00:14:59.000000', 'consum', 0.0216, 'lps'),
	(458833, 126, '2015-03-15 00:15:00.000000', 'consum', 0.0223, 'lps'),
	(458834, 126, '2015-03-15 00:15:01.000000', 'consum', 0.0218, 'lps'),
	(458835, 126, '2015-03-15 00:15:02.000000', 'consum', 0.0222, 'lps'),
	(458836, 126, '2015-03-15 00:15:03.000000', 'consum', 0.0221, 'lps'),
	(458837, 126, '2015-03-15 00:15:04.000000', 'consum', 0.0214, 'lps'),
	(458838, 126, '2015-03-15 00:15:05.000000', 'consum', 0.0213, 'lps'),
	(458839, 126, '2015-03-15 00:15:06.000000', 'consum', 0.0212, 'lps'),
	(458840, 126, '2015-03-15 00:15:07.000000', 'consum', 0.0212, 'lps'),
	(458841, 126, '2015-03-15 00:15:08.000000', 'consum', 0.0214, 'lps'),
	(458842, 126, '2015-03-15 00:15:09.000000', 'consum', 0.0210, 'lps'),
	(458843, 126, '2015-03-15 00:15:10.000000', 'consum', 0.0214, 'lps'),
	(458844, 126, '2015-03-15 00:15:11.000000', 'consum', 0.0216, 'lps'),
	(458845, 126, '2015-03-15 00:15:12.000000', 'consum', 0.0213, 'lps'),
	(458846, 126, '2015-03-15 00:15:13.000000', 'consum', 0.0223, 'lps'),
	(458847, 126, '2015-03-15 00:15:14.000000', 'consum', 0.0210, 'lps'),
	(458848, 126, '2015-03-15 00:15:15.000000', 'consum', 0.0213, 'lps'),
	(458849, 126, '2015-03-15 00:15:16.000000', 'consum', 0.0211, 'lps'),
	(458850, 126, '2015-03-15 00:15:17.000000', 'consum', 0.0222, 'lps'),
	(458851, 126, '2015-03-15 00:15:18.000000', 'consum', 0.0212, 'lps'),
	(458852, 126, '2015-03-15 00:15:19.000000', 'consum', 0.0211, 'lps'),
	(458853, 126, '2015-03-15 00:15:20.000000', 'consum', 0.0223, 'lps'),
	(458854, 126, '2015-03-15 00:15:21.000000', 'consum', 0.0217, 'lps'),
	(458855, 126, '2015-03-15 00:15:22.000000', 'consum', 0.0221, 'lps'),
	(458856, 126, '2015-03-15 00:15:23.000000', 'consum', 0.0218, 'lps'),
	(458857, 126, '2015-03-15 00:15:24.000000', 'consum', 0.0218, 'lps'),
	(458858, 126, '2015-03-15 00:15:25.000000', 'consum', 0.0210, 'lps'),
	(458859, 126, '2015-03-15 00:15:26.000000', 'consum', 0.0216, 'lps'),
	(458860, 126, '2015-03-15 00:15:27.000000', 'consum', 0.0213, 'lps'),
	(458861, 126, '2015-03-15 00:15:28.000000', 'consum', 0.0220, 'lps'),
	(458862, 126, '2015-03-15 00:15:29.000000', 'consum', 0.0211, 'lps'),
	(458863, 126, '2015-03-15 00:15:30.000000', 'consum', 0.0211, 'lps'),
	(458864, 126, '2015-03-15 00:15:31.000000', 'consum', 0.0215, 'lps'),
	(458865, 126, '2015-03-15 00:15:32.000000', 'consum', 0.0220, 'lps'),
	(458866, 126, '2015-03-15 00:15:33.000000', 'consum', 0.0215, 'lps'),
	(458867, 126, '2015-03-15 00:15:34.000000', 'consum', 0.0219, 'lps'),
	(458868, 126, '2015-03-15 00:15:35.000000', 'consum', 0.0215, 'lps'),
	(458869, 126, '2015-03-15 00:15:36.000000', 'consum', 0.0220, 'lps'),
	(458870, 126, '2015-03-15 00:15:37.000000', 'consum', 0.0217, 'lps'),
	(458871, 126, '2015-03-15 00:15:38.000000', 'consum', 0.0214, 'lps'),
	(458872, 126, '2015-03-15 00:15:39.000000', 'consum', 0.0213, 'lps'),
	(458873, 126, '2015-03-15 00:15:40.000000', 'consum', 0.0212, 'lps'),
	(458874, 126, '2015-03-15 00:15:41.000000', 'consum', 0.0211, 'lps'),
	(458875, 126, '2015-03-15 00:15:42.000000', 'consum', 0.0222, 'lps'),
	(458876, 126, '2015-03-15 00:15:43.000000', 'consum', 0.0214, 'lps'),
	(458877, 126, '2015-03-15 00:15:44.000000', 'consum', 0.0221, 'lps'),
	(458878, 126, '2015-03-15 00:15:45.000000', 'consum', 0.0211, 'lps'),
	(458879, 126, '2015-03-15 00:15:46.000000', 'consum', 0.0212, 'lps'),
	(458880, 126, '2015-03-15 00:15:47.000000', 'consum', 0.0215, 'lps'),
	(458881, 126, '2015-03-15 00:15:48.000000', 'consum', 0.0217, 'lps'),
	(458882, 126, '2015-03-15 00:15:49.000000', 'consum', 0.0218, 'lps'),
	(458883, 126, '2015-03-15 00:15:50.000000', 'consum', 0.0214, 'lps'),
	(458884, 126, '2015-03-15 00:15:51.000000', 'consum', 0.0222, 'lps'),
	(458885, 126, '2015-03-15 00:15:52.000000', 'consum', 0.0214, 'lps'),
	(458886, 126, '2015-03-15 00:15:53.000000', 'consum', 0.0223, 'lps'),
	(458887, 126, '2015-03-15 00:15:54.000000', 'consum', 0.0223, 'lps'),
	(458888, 126, '2015-03-15 00:15:55.000000', 'consum', 0.0221, 'lps'),
	(458889, 126, '2015-03-15 00:15:56.000000', 'consum', 0.0212, 'lps'),
	(458890, 126, '2015-03-15 00:15:57.000000', 'consum', 0.0215, 'lps'),
	(458891, 126, '2015-03-15 00:15:58.000000', 'consum', 0.0215, 'lps'),
	(458892, 126, '2015-03-15 00:15:59.000000', 'consum', 0.0222, 'lps'),
	(458893, 126, '2015-03-15 00:16:00.000000', 'consum', 0.0213, 'lps'),
	(458894, 126, '2015-03-15 00:16:01.000000', 'consum', 0.0217, 'lps'),
	(458895, 126, '2015-03-15 00:16:02.000000', 'consum', 0.0223, 'lps'),
	(458896, 126, '2015-03-15 00:16:03.000000', 'consum', 0.0211, 'lps'),
	(458897, 126, '2015-03-15 00:16:04.000000', 'consum', 0.0220, 'lps'),
	(458898, 126, '2015-03-15 00:16:05.000000', 'consum', 0.0217, 'lps'),
	(458899, 126, '2015-03-15 00:16:06.000000', 'consum', 0.0213, 'lps'),
	(458900, 126, '2015-03-15 00:16:07.000000', 'consum', 0.0218, 'lps'),
	(458901, 126, '2015-03-15 00:16:08.000000', 'consum', 0.0214, 'lps'),
	(458902, 126, '2015-03-15 00:16:09.000000', 'consum', 0.0221, 'lps'),
	(458903, 126, '2015-03-15 00:16:10.000000', 'consum', 0.0213, 'lps'),
	(458904, 126, '2015-03-15 00:16:11.000000', 'consum', 0.0218, 'lps'),
	(458905, 126, '2015-03-15 00:16:12.000000', 'consum', 0.0213, 'lps'),
	(458906, 126, '2015-03-15 00:16:13.000000', 'consum', 0.0217, 'lps'),
	(458907, 126, '2015-03-15 00:16:14.000000', 'consum', 0.0222, 'lps'),
	(458908, 126, '2015-03-15 00:16:15.000000', 'consum', 0.0221, 'lps'),
	(458909, 126, '2015-03-15 00:16:16.000000', 'consum', 0.0217, 'lps'),
	(458910, 126, '2015-03-15 00:16:17.000000', 'consum', 0.0213, 'lps'),
	(458911, 126, '2015-03-15 00:16:18.000000', 'consum', 0.0217, 'lps'),
	(458912, 126, '2015-03-15 00:16:19.000000', 'consum', 0.0221, 'lps'),
	(458913, 126, '2015-03-15 00:16:20.000000', 'consum', 0.0220, 'lps'),
	(458914, 126, '2015-03-15 00:16:21.000000', 'consum', 0.0210, 'lps'),
	(458915, 126, '2015-03-15 00:16:22.000000', 'consum', 0.0212, 'lps'),
	(458916, 126, '2015-03-15 00:16:23.000000', 'consum', 0.0219, 'lps'),
	(458917, 126, '2015-03-15 00:16:24.000000', 'consum', 0.0222, 'lps'),
	(458918, 126, '2015-03-15 00:16:25.000000', 'consum', 0.0215, 'lps'),
	(458919, 126, '2015-03-15 00:16:26.000000', 'consum', 0.0214, 'lps'),
	(458920, 126, '2015-03-15 00:16:27.000000', 'consum', 0.0215, 'lps'),
	(458921, 126, '2015-03-15 00:16:28.000000', 'consum', 0.0210, 'lps'),
	(458922, 126, '2015-03-15 00:16:29.000000', 'consum', 0.0221, 'lps'),
	(458923, 126, '2015-03-15 00:16:30.000000', 'consum', 0.0213, 'lps'),
	(458924, 126, '2015-03-15 00:16:31.000000', 'consum', 0.0219, 'lps'),
	(458925, 126, '2015-03-15 00:16:32.000000', 'consum', 0.0220, 'lps'),
	(458926, 126, '2015-03-15 00:16:33.000000', 'consum', 0.0218, 'lps'),
	(458927, 126, '2015-03-15 00:16:34.000000', 'consum', 0.0221, 'lps'),
	(458928, 126, '2015-03-15 00:16:35.000000', 'consum', 0.0215, 'lps'),
	(458929, 126, '2015-03-15 00:16:36.000000', 'consum', 0.0217, 'lps'),
	(458930, 126, '2015-03-15 00:16:37.000000', 'consum', 0.0217, 'lps'),
	(458931, 126, '2015-03-15 00:16:38.000000', 'consum', 0.0210, 'lps'),
	(458932, 126, '2015-03-15 00:16:39.000000', 'consum', 0.0218, 'lps'),
	(458933, 126, '2015-03-15 00:16:40.000000', 'consum', 0.0221, 'lps'),
	(458934, 126, '2015-03-15 00:16:41.000000', 'consum', 0.0213, 'lps'),
	(458935, 126, '2015-03-15 00:16:42.000000', 'consum', 0.0220, 'lps'),
	(458936, 126, '2015-03-15 00:16:43.000000', 'consum', 0.0210, 'lps'),
	(458937, 126, '2015-03-15 00:16:44.000000', 'consum', 0.0210, 'lps'),
	(458938, 126, '2015-03-15 00:16:45.000000', 'consum', 0.0211, 'lps'),
	(458939, 126, '2015-03-15 00:16:46.000000', 'consum', 0.0215, 'lps'),
	(458940, 126, '2015-03-15 00:16:47.000000', 'consum', 0.0217, 'lps'),
	(458941, 126, '2015-03-15 00:16:48.000000', 'consum', 0.0217, 'lps'),
	(458942, 126, '2015-03-15 00:16:49.000000', 'consum', 0.0210, 'lps'),
	(458943, 126, '2015-03-15 00:16:50.000000', 'consum', 0.0219, 'lps'),
	(458944, 126, '2015-03-15 00:16:51.000000', 'consum', 0.0211, 'lps'),
	(458945, 126, '2015-03-15 00:16:52.000000', 'consum', 0.0219, 'lps'),
	(458946, 126, '2015-03-15 00:16:53.000000', 'consum', 0.0210, 'lps'),
	(458947, 126, '2015-03-15 00:16:54.000000', 'consum', 0.0211, 'lps'),
	(458948, 126, '2015-03-15 00:16:55.000000', 'consum', 0.0215, 'lps'),
	(458949, 126, '2015-03-15 00:16:56.000000', 'consum', 0.0217, 'lps'),
	(458950, 126, '2015-03-15 00:16:57.000000', 'consum', 0.0217, 'lps'),
	(458951, 126, '2015-03-15 00:16:58.000000', 'consum', 0.0213, 'lps'),
	(458952, 126, '2015-03-15 00:16:59.000000', 'consum', 0.0218, 'lps'),
	(458953, 126, '2015-03-15 00:17:00.000000', 'consum', 0.0213, 'lps'),
	(458954, 126, '2015-03-15 00:17:01.000000', 'consum', 0.0216, 'lps'),
	(458955, 126, '2015-03-15 00:17:02.000000', 'consum', 0.0215, 'lps'),
	(458956, 126, '2015-03-15 00:17:03.000000', 'consum', 0.0220, 'lps'),
	(458957, 126, '2015-03-15 00:17:04.000000', 'consum', 0.0215, 'lps'),
	(458958, 126, '2015-03-15 00:17:05.000000', 'consum', 0.0220, 'lps'),
	(458959, 126, '2015-03-15 00:17:06.000000', 'consum', 0.0216, 'lps'),
	(458960, 126, '2015-03-15 00:17:07.000000', 'consum', 0.0213, 'lps'),
	(458961, 126, '2015-03-15 00:17:08.000000', 'consum', 0.0220, 'lps'),
	(458962, 126, '2015-03-15 00:17:09.000000', 'consum', 0.0210, 'lps'),
	(458963, 126, '2015-03-15 00:17:10.000000', 'consum', 0.0210, 'lps'),
	(458964, 126, '2015-03-15 00:17:11.000000', 'consum', 0.0210, 'lps'),
	(458965, 126, '2015-03-15 00:17:12.000000', 'consum', 0.0211, 'lps'),
	(458966, 126, '2015-03-15 00:17:13.000000', 'consum', 0.0215, 'lps'),
	(458967, 126, '2015-03-15 00:17:14.000000', 'consum', 0.0220, 'lps'),
	(458968, 126, '2015-03-15 00:17:15.000000', 'consum', 0.0215, 'lps'),
	(458969, 126, '2015-03-15 00:17:16.000000', 'consum', 0.0221, 'lps'),
	(458970, 126, '2015-03-15 00:17:17.000000', 'consum', 0.0210, 'lps'),
	(458971, 126, '2015-03-15 00:17:18.000000', 'consum', 0.0219, 'lps'),
	(458972, 126, '2015-03-15 00:17:19.000000', 'consum', 0.0211, 'lps'),
	(458973, 126, '2015-03-15 00:17:20.000000', 'consum', 0.0220, 'lps'),
	(458974, 126, '2015-03-15 00:17:21.000000', 'consum', 0.0212, 'lps'),
	(458975, 126, '2015-03-15 00:17:22.000000', 'consum', 0.0220, 'lps'),
	(458976, 126, '2015-03-15 00:17:23.000000', 'consum', 0.0214, 'lps'),
	(458977, 126, '2015-03-15 00:17:24.000000', 'consum', 0.0213, 'lps'),
	(458978, 126, '2015-03-15 00:17:25.000000', 'consum', 0.0214, 'lps'),
	(458979, 126, '2015-03-15 00:17:26.000000', 'consum', 0.0220, 'lps'),
	(458980, 126, '2015-03-15 00:17:27.000000', 'consum', 0.0223, 'lps'),
	(458981, 126, '2015-03-15 00:17:28.000000', 'consum', 0.0217, 'lps'),
	(458982, 126, '2015-03-15 00:17:29.000000', 'consum', 0.0222, 'lps'),
	(458983, 126, '2015-03-15 00:17:30.000000', 'consum', 0.0219, 'lps'),
	(458984, 126, '2015-03-15 00:17:31.000000', 'consum', 0.0220, 'lps'),
	(458985, 126, '2015-03-15 00:17:32.000000', 'consum', 0.0218, 'lps'),
	(458986, 126, '2015-03-15 00:17:33.000000', 'consum', 0.0221, 'lps'),
	(458987, 126, '2015-03-15 00:17:34.000000', 'consum', 0.0214, 'lps'),
	(458988, 126, '2015-03-15 00:17:35.000000', 'consum', 0.0212, 'lps'),
	(458989, 126, '2015-03-15 00:17:36.000000', 'consum', 0.0221, 'lps'),
	(458990, 126, '2015-03-15 00:17:37.000000', 'consum', 0.0219, 'lps'),
	(458991, 126, '2015-03-15 00:17:38.000000', 'consum', 0.0222, 'lps'),
	(458992, 126, '2015-03-15 00:17:39.000000', 'consum', 0.0216, 'lps'),
	(458993, 126, '2015-03-15 00:17:40.000000', 'consum', 0.0216, 'lps'),
	(458994, 126, '2015-03-15 00:17:41.000000', 'consum', 0.0211, 'lps'),
	(458995, 126, '2015-03-15 00:17:42.000000', 'consum', 0.0223, 'lps'),
	(458996, 126, '2015-03-15 00:17:43.000000', 'consum', 0.0220, 'lps'),
	(458997, 126, '2015-03-15 00:17:44.000000', 'consum', 0.0218, 'lps'),
	(458998, 126, '2015-03-15 00:17:45.000000', 'consum', 0.0210, 'lps'),
	(458999, 126, '2015-03-15 00:17:46.000000', 'consum', 0.0213, 'lps'),
	(459000, 126, '2015-03-15 00:17:47.000000', 'consum', 0.0211, 'lps'),
	(459001, 126, '2015-03-15 00:17:48.000000', 'consum', 0.0220, 'lps'),
	(459002, 126, '2015-03-15 00:17:49.000000', 'consum', 0.0218, 'lps'),
	(459003, 126, '2015-03-15 00:17:50.000000', 'consum', 0.0217, 'lps'),
	(459004, 126, '2015-03-15 00:17:51.000000', 'consum', 0.0223, 'lps'),
	(459005, 126, '2015-03-15 00:17:52.000000', 'consum', 0.0214, 'lps'),
	(459006, 126, '2015-03-15 00:17:53.000000', 'consum', 0.0218, 'lps'),
	(459007, 126, '2015-03-15 00:17:54.000000', 'consum', 0.0211, 'lps'),
	(459008, 126, '2015-03-15 00:17:55.000000', 'consum', 0.0219, 'lps'),
	(459009, 126, '2015-03-15 00:17:56.000000', 'consum', 0.0223, 'lps'),
	(459010, 126, '2015-03-15 00:17:57.000000', 'consum', 0.0223, 'lps'),
	(459011, 126, '2015-03-15 00:17:58.000000', 'consum', 0.0222, 'lps'),
	(459012, 126, '2015-03-15 00:17:59.000000', 'consum', 0.0217, 'lps'),
	(459013, 126, '2015-03-15 00:18:00.000000', 'consum', 0.0211, 'lps'),
	(459014, 126, '2015-03-15 00:18:01.000000', 'consum', 0.0223, 'lps'),
	(459015, 126, '2015-03-15 00:18:02.000000', 'consum', 0.0214, 'lps'),
	(459016, 126, '2015-03-15 00:18:03.000000', 'consum', 0.0220, 'lps'),
	(459017, 126, '2015-03-15 00:18:04.000000', 'consum', 0.0223, 'lps'),
	(459018, 126, '2015-03-15 00:18:05.000000', 'consum', 0.0215, 'lps'),
	(459019, 126, '2015-03-15 00:18:06.000000', 'consum', 0.0212, 'lps'),
	(459020, 126, '2015-03-15 00:18:07.000000', 'consum', 0.0218, 'lps'),
	(459021, 126, '2015-03-15 00:18:08.000000', 'consum', 0.0216, 'lps'),
	(459022, 126, '2015-03-15 00:18:09.000000', 'consum', 0.0218, 'lps'),
	(459023, 126, '2015-03-15 00:18:10.000000', 'consum', 0.0217, 'lps'),
	(459024, 126, '2015-03-15 00:18:11.000000', 'consum', 0.0222, 'lps'),
	(459025, 126, '2015-03-15 00:18:12.000000', 'consum', 0.0223, 'lps'),
	(459026, 126, '2015-03-15 00:18:13.000000', 'consum', 0.0211, 'lps'),
	(459027, 126, '2015-03-15 00:18:14.000000', 'consum', 0.0218, 'lps'),
	(459028, 126, '2015-03-15 00:18:15.000000', 'consum', 0.0218, 'lps'),
	(459029, 126, '2015-03-15 00:18:16.000000', 'consum', 0.0211, 'lps'),
	(459030, 126, '2015-03-15 00:18:17.000000', 'consum', 0.0223, 'lps'),
	(459031, 126, '2015-03-15 00:18:18.000000', 'consum', 0.0217, 'lps'),
	(459032, 126, '2015-03-15 00:18:19.000000', 'consum', 0.0221, 'lps'),
	(459033, 126, '2015-03-15 00:18:20.000000', 'consum', 0.0215, 'lps'),
	(459034, 126, '2015-03-15 00:18:21.000000', 'consum', 0.0217, 'lps'),
	(459035, 126, '2015-03-15 00:18:22.000000', 'consum', 0.0218, 'lps'),
	(459036, 126, '2015-03-15 00:18:23.000000', 'consum', 0.0216, 'lps'),
	(459037, 126, '2015-03-15 00:18:24.000000', 'consum', 0.0214, 'lps'),
	(459038, 126, '2015-03-15 00:18:25.000000', 'consum', 0.0213, 'lps'),
	(459039, 126, '2015-03-15 00:18:26.000000', 'consum', 0.0212, 'lps'),
	(459040, 126, '2015-03-15 00:18:27.000000', 'consum', 0.0214, 'lps'),
	(459041, 126, '2015-03-15 00:18:28.000000', 'consum', 0.0210, 'lps'),
	(459042, 126, '2015-03-15 00:18:29.000000', 'consum', 0.0214, 'lps'),
	(459043, 126, '2015-03-15 00:18:30.000000', 'consum', 0.0216, 'lps'),
	(459044, 126, '2015-03-15 00:18:31.000000', 'consum', 0.0215, 'lps'),
	(459045, 126, '2015-03-15 00:18:32.000000', 'consum', 0.0217, 'lps'),
	(459046, 126, '2015-03-15 00:18:33.000000', 'consum', 0.0218, 'lps'),
	(459047, 126, '2015-03-15 00:18:34.000000', 'consum', 0.0213, 'lps'),
	(459048, 126, '2015-03-15 00:18:35.000000', 'consum', 0.0218, 'lps'),
	(459049, 126, '2015-03-15 00:18:36.000000', 'consum', 0.0212, 'lps'),
	(459050, 126, '2015-03-15 00:18:37.000000', 'consum', 0.0213, 'lps'),
	(459051, 126, '2015-03-15 00:18:38.000000', 'consum', 0.0217, 'lps'),
	(459052, 126, '2015-03-15 00:18:39.000000', 'consum', 0.0223, 'lps'),
	(459053, 126, '2015-03-15 00:18:40.000000', 'consum', 0.0212, 'lps'),
	(459054, 126, '2015-03-15 00:18:41.000000', 'consum', 0.0223, 'lps'),
	(459055, 126, '2015-03-15 00:18:42.000000', 'consum', 0.0214, 'lps'),
	(459056, 126, '2015-03-15 00:18:43.000000', 'consum', 0.0219, 'lps'),
	(459057, 126, '2015-03-15 00:18:44.000000', 'consum', 0.0216, 'lps'),
	(459058, 126, '2015-03-15 00:18:45.000000', 'consum', 0.0211, 'lps'),
	(459059, 126, '2015-03-15 00:18:46.000000', 'consum', 0.0215, 'lps'),
	(459060, 126, '2015-03-15 00:18:47.000000', 'consum', 0.0215, 'lps'),
	(459061, 126, '2015-03-15 00:18:48.000000', 'consum', 0.0210, 'lps'),
	(459062, 126, '2015-03-15 00:18:49.000000', 'consum', 0.0222, 'lps'),
	(459063, 126, '2015-03-15 00:18:50.000000', 'consum', 0.0213, 'lps'),
	(459064, 126, '2015-03-15 00:18:51.000000', 'consum', 0.0217, 'lps'),
	(459065, 126, '2015-03-15 00:18:52.000000', 'consum', 0.0223, 'lps'),
	(459066, 126, '2015-03-15 00:18:53.000000', 'consum', 0.0211, 'lps'),
	(459067, 126, '2015-03-15 00:18:54.000000', 'consum', 0.0221, 'lps'),
	(459068, 126, '2015-03-15 00:18:55.000000', 'consum', 0.0221, 'lps'),
	(459069, 126, '2015-03-15 00:18:56.000000', 'consum', 0.0217, 'lps'),
	(459070, 126, '2015-03-15 00:18:57.000000', 'consum', 0.0211, 'lps'),
	(459071, 126, '2015-03-15 00:18:58.000000', 'consum', 0.0211, 'lps'),
	(459072, 126, '2015-03-15 00:18:59.000000', 'consum', 0.0210, 'lps'),
	(459073, 126, '2015-03-15 00:19:00.000000', 'consum', 0.0221, 'lps'),
	(459074, 126, '2015-03-15 00:19:01.000000', 'consum', 0.0212, 'lps'),
	(459075, 126, '2015-03-15 00:19:02.000000', 'consum', 0.0217, 'lps'),
	(459076, 126, '2015-03-15 00:19:03.000000', 'consum', 0.0223, 'lps'),
	(459077, 126, '2015-03-15 00:19:04.000000', 'consum', 0.0211, 'lps'),
	(459078, 126, '2015-03-15 00:19:05.000000', 'consum', 0.0222, 'lps'),
	(459079, 126, '2015-03-15 00:19:06.000000', 'consum', 0.0222, 'lps'),
	(459080, 126, '2015-03-15 00:19:07.000000', 'consum', 0.0223, 'lps'),
	(459081, 126, '2015-03-15 00:19:08.000000', 'consum', 0.0223, 'lps'),
	(459082, 126, '2015-03-15 00:19:09.000000', 'consum', 0.0223, 'lps'),
	(459083, 126, '2015-03-15 00:19:10.000000', 'consum', 0.0223, 'lps'),
	(459084, 126, '2015-03-15 00:19:11.000000', 'consum', 0.0223, 'lps'),
	(459085, 126, '2015-03-15 00:19:12.000000', 'consum', 0.0220, 'lps'),
	(459086, 126, '2015-03-15 00:19:13.000000', 'consum', 0.0210, 'lps'),
	(459087, 126, '2015-03-15 00:19:14.000000', 'consum', 0.0221, 'lps'),
	(459088, 126, '2015-03-15 00:19:15.000000', 'consum', 0.0212, 'lps'),
	(459089, 126, '2015-03-15 00:19:16.000000', 'consum', 0.0214, 'lps'),
	(459090, 126, '2015-03-15 00:19:17.000000', 'consum', 0.0210, 'lps'),
	(459091, 126, '2015-03-15 00:19:18.000000', 'consum', 0.0213, 'lps'),
	(459092, 126, '2015-03-15 00:19:19.000000', 'consum', 0.0212, 'lps'),
	(459093, 126, '2015-03-15 00:19:20.000000', 'consum', 0.0210, 'lps'),
	(459094, 126, '2015-03-15 00:19:21.000000', 'consum', 0.0221, 'lps'),
	(459095, 126, '2015-03-15 00:19:22.000000', 'consum', 0.0222, 'lps'),
	(459096, 126, '2015-03-15 00:19:23.000000', 'consum', 0.0210, 'lps'),
	(459097, 126, '2015-03-15 00:19:24.000000', 'consum', 0.0218, 'lps'),
	(459098, 126, '2015-03-15 00:19:25.000000', 'consum', 0.0222, 'lps'),
	(459099, 126, '2015-03-15 00:19:26.000000', 'consum', 0.0216, 'lps'),
	(459100, 126, '2015-03-15 00:19:27.000000', 'consum', 0.0220, 'lps'),
	(459101, 126, '2015-03-15 00:19:28.000000', 'consum', 0.0214, 'lps'),
	(459102, 126, '2015-03-15 00:19:29.000000', 'consum', 0.0217, 'lps'),
	(459103, 126, '2015-03-15 00:19:30.000000', 'consum', 0.0217, 'lps'),
	(459104, 126, '2015-03-15 00:19:31.000000', 'consum', 0.0210, 'lps'),
	(459105, 126, '2015-03-15 00:19:32.000000', 'consum', 0.0216, 'lps'),
	(459106, 126, '2015-03-15 00:19:33.000000', 'consum', 0.0215, 'lps'),
	(459107, 126, '2015-03-15 00:19:34.000000', 'consum', 0.0219, 'lps'),
	(459108, 126, '2015-03-15 00:19:35.000000', 'consum', 0.0211, 'lps'),
	(459109, 126, '2015-03-15 00:19:36.000000', 'consum', 0.0216, 'lps'),
	(459110, 126, '2015-03-15 00:19:37.000000', 'consum', 0.0223, 'lps'),
	(459111, 126, '2015-03-15 00:19:38.000000', 'consum', 0.0214, 'lps'),
	(459112, 126, '2015-03-15 00:19:39.000000', 'consum', 0.0223, 'lps'),
	(459113, 126, '2015-03-15 00:19:40.000000', 'consum', 0.0219, 'lps'),
	(459114, 126, '2015-03-15 00:19:41.000000', 'consum', 0.0217, 'lps'),
	(459115, 126, '2015-03-15 00:19:42.000000', 'consum', 0.0218, 'lps'),
	(459116, 126, '2015-03-15 00:19:43.000000', 'consum', 0.0215, 'lps'),
	(459117, 126, '2015-03-15 00:19:44.000000', 'consum', 0.0210, 'lps'),
	(459118, 126, '2015-03-15 00:19:45.000000', 'consum', 0.0211, 'lps'),
	(459119, 126, '2015-03-15 00:19:46.000000', 'consum', 0.0218, 'lps'),
	(459120, 126, '2015-03-15 00:19:47.000000', 'consum', 0.0216, 'lps'),
	(459121, 126, '2015-03-15 00:19:48.000000', 'consum', 0.0219, 'lps'),
	(459122, 126, '2015-03-15 00:19:49.000000', 'consum', 0.0222, 'lps'),
	(459123, 126, '2015-03-15 00:19:50.000000', 'consum', 0.0216, 'lps'),
	(459124, 126, '2015-03-15 00:19:51.000000', 'consum', 0.0219, 'lps'),
	(459125, 126, '2015-03-15 00:19:52.000000', 'consum', 0.0223, 'lps'),
	(459126, 126, '2015-03-15 00:19:53.000000', 'consum', 0.0221, 'lps'),
	(459127, 126, '2015-03-15 00:19:54.000000', 'consum', 0.0211, 'lps'),
	(459128, 126, '2015-03-15 00:19:55.000000', 'consum', 0.0211, 'lps'),
	(459129, 126, '2015-03-15 00:19:56.000000', 'consum', 0.0214, 'lps'),
	(459130, 126, '2015-03-15 00:19:57.000000', 'consum', 0.0213, 'lps'),
	(459131, 126, '2015-03-15 00:19:58.000000', 'consum', 0.0214, 'lps'),
	(459132, 126, '2015-03-15 00:19:59.000000', 'consum', 0.0220, 'lps'),
	(459133, 126, '2015-03-15 00:20:00.000000', 'consum', 0.0223, 'lps'),
	(459134, 126, '2015-03-15 00:20:01.000000', 'consum', 0.0217, 'lps'),
	(459135, 126, '2015-03-15 00:20:02.000000', 'consum', 0.0221, 'lps'),
	(459136, 126, '2015-03-15 00:20:03.000000', 'consum', 0.0214, 'lps'),
	(459137, 126, '2015-03-15 00:20:04.000000', 'consum', 0.0213, 'lps'),
	(459138, 126, '2015-03-15 00:20:05.000000', 'consum', 0.0214, 'lps'),
	(459139, 126, '2015-03-15 00:20:06.000000', 'consum', 0.0219, 'lps'),
	(459140, 126, '2015-03-15 00:20:07.000000', 'consum', 0.0217, 'lps'),
	(459141, 126, '2015-03-15 00:20:08.000000', 'consum', 0.0219, 'lps'),
	(459142, 126, '2015-03-15 00:20:09.000000', 'consum', 0.0219, 'lps'),
	(459143, 126, '2015-03-15 00:20:10.000000', 'consum', 0.0216, 'lps'),
	(459144, 126, '2015-03-15 00:20:11.000000', 'consum', 0.0213, 'lps'),
	(459145, 126, '2015-03-15 00:20:12.000000', 'consum', 0.0223, 'lps'),
	(459146, 126, '2015-03-15 00:20:13.000000', 'consum', 0.0211, 'lps'),
	(459147, 126, '2015-03-15 00:20:14.000000', 'consum', 0.0219, 'lps'),
	(459148, 126, '2015-03-15 00:20:15.000000', 'consum', 0.0223, 'lps'),
	(459149, 126, '2015-03-15 00:20:16.000000', 'consum', 0.0219, 'lps'),
	(459150, 126, '2015-03-15 00:20:17.000000', 'consum', 0.0217, 'lps'),
	(459151, 126, '2015-03-15 00:20:18.000000', 'consum', 0.0218, 'lps'),
	(459152, 126, '2015-03-15 00:20:19.000000', 'consum', 0.0214, 'lps'),
	(459153, 126, '2015-03-15 00:20:20.000000', 'consum', 0.0210, 'lps'),
	(459154, 126, '2015-03-15 00:20:21.000000', 'consum', 0.0223, 'lps'),
	(459155, 126, '2015-03-15 00:20:22.000000', 'consum', 0.0223, 'lps'),
	(459156, 126, '2015-03-15 00:20:23.000000', 'consum', 0.0219, 'lps'),
	(459157, 126, '2015-03-15 00:20:24.000000', 'consum', 0.0220, 'lps'),
	(459158, 126, '2015-03-15 00:20:25.000000', 'consum', 0.0218, 'lps'),
	(459159, 126, '2015-03-15 00:20:26.000000', 'consum', 0.0220, 'lps'),
	(459160, 126, '2015-03-15 00:20:27.000000', 'consum', 0.0223, 'lps'),
	(459161, 126, '2015-03-15 00:20:28.000000', 'consum', 0.0218, 'lps'),
	(459162, 126, '2015-03-15 00:20:29.000000', 'consum', 0.0210, 'lps'),
	(459163, 126, '2015-03-15 00:20:30.000000', 'consum', 0.0217, 'lps'),
	(459164, 126, '2015-03-15 00:20:31.000000', 'consum', 0.0218, 'lps'),
	(459165, 126, '2015-03-15 00:20:32.000000', 'consum', 0.0212, 'lps'),
	(459166, 126, '2015-03-15 00:20:33.000000', 'consum', 0.0213, 'lps'),
	(459167, 126, '2015-03-15 00:20:34.000000', 'consum', 0.0218, 'lps'),
	(459168, 126, '2015-03-15 00:20:35.000000', 'consum', 0.0216, 'lps'),
	(459169, 126, '2015-03-15 00:20:36.000000', 'consum', 0.0216, 'lps'),
	(459170, 126, '2015-03-15 00:20:37.000000', 'consum', 0.0223, 'lps'),
	(459171, 126, '2015-03-15 00:20:38.000000', 'consum', 0.0214, 'lps'),
	(459172, 126, '2015-03-15 00:20:39.000000', 'consum', 0.0219, 'lps'),
	(459173, 126, '2015-03-15 00:20:40.000000', 'consum', 0.0216, 'lps'),
	(459174, 126, '2015-03-15 00:20:41.000000', 'consum', 0.0214, 'lps'),
	(459175, 126, '2015-03-15 00:20:42.000000', 'consum', 0.0212, 'lps'),
	(459176, 126, '2015-03-15 00:20:43.000000', 'consum', 0.0223, 'lps'),
	(459177, 126, '2015-03-15 00:20:44.000000', 'consum', 0.0211, 'lps'),
	(459178, 126, '2015-03-15 00:20:45.000000', 'consum', 0.0222, 'lps'),
	(459179, 126, '2015-03-15 00:20:46.000000', 'consum', 0.0223, 'lps'),
	(459180, 126, '2015-03-15 00:20:47.000000', 'consum', 0.0211, 'lps'),
	(459181, 126, '2015-03-15 00:20:48.000000', 'consum', 0.0218, 'lps'),
	(459182, 126, '2015-03-15 00:20:49.000000', 'consum', 0.0219, 'lps'),
	(459183, 126, '2015-03-15 00:20:50.000000', 'consum', 0.0217, 'lps'),
	(459184, 126, '2015-03-15 00:20:51.000000', 'consum', 0.0221, 'lps'),
	(459185, 126, '2015-03-15 00:20:52.000000', 'consum', 0.0216, 'lps'),
	(459186, 126, '2015-03-15 00:20:53.000000', 'consum', 0.0222, 'lps'),
	(459187, 126, '2015-03-15 00:20:54.000000', 'consum', 0.0222, 'lps'),
	(459188, 126, '2015-03-15 00:20:55.000000', 'consum', 0.0210, 'lps'),
	(459189, 126, '2015-03-15 00:20:56.000000', 'consum', 0.0214, 'lps'),
	(459190, 126, '2015-03-15 00:20:57.000000', 'consum', 0.0217, 'lps'),
	(459191, 126, '2015-03-15 00:20:58.000000', 'consum', 0.0219, 'lps'),
	(459192, 126, '2015-03-15 00:20:59.000000', 'consum', 0.0223, 'lps'),
	(459193, 126, '2015-03-15 00:21:00.000000', 'consum', 0.0218, 'lps'),
	(459194, 126, '2015-03-15 00:21:01.000000', 'consum', 0.0212, 'lps'),
	(459195, 126, '2015-03-15 00:21:02.000000', 'consum', 0.0212, 'lps'),
	(459196, 126, '2015-03-15 00:21:03.000000', 'consum', 0.0212, 'lps'),
	(459197, 126, '2015-03-15 00:21:04.000000', 'consum', 0.0216, 'lps'),
	(459198, 126, '2015-03-15 00:21:05.000000', 'consum', 0.0222, 'lps'),
	(459199, 126, '2015-03-15 00:21:06.000000', 'consum', 0.0222, 'lps'),
	(459200, 126, '2015-03-15 00:21:07.000000', 'consum', 0.0222, 'lps'),
	(459201, 126, '2015-03-15 00:21:08.000000', 'consum', 0.0219, 'lps'),
	(459202, 126, '2015-03-15 00:21:09.000000', 'consum', 0.0222, 'lps'),
	(459203, 126, '2015-03-15 00:21:10.000000', 'consum', 0.0215, 'lps'),
	(459204, 126, '2015-03-15 00:21:11.000000', 'consum', 0.0214, 'lps'),
	(459205, 126, '2015-03-15 00:21:12.000000', 'consum', 0.0214, 'lps'),
	(459206, 126, '2015-03-15 00:21:13.000000', 'consum', 0.0219, 'lps'),
	(459207, 126, '2015-03-15 00:21:14.000000', 'consum', 0.0214, 'lps'),
	(459208, 126, '2015-03-15 00:21:15.000000', 'consum', 0.0218, 'lps'),
	(459209, 126, '2015-03-15 00:21:16.000000', 'consum', 0.0223, 'lps'),
	(459210, 126, '2015-03-15 00:21:17.000000', 'consum', 0.0212, 'lps'),
	(459211, 126, '2015-03-15 00:21:18.000000', 'consum', 0.0210, 'lps'),
	(459212, 126, '2015-03-15 00:21:19.000000', 'consum', 0.0218, 'lps'),
	(459213, 126, '2015-03-15 00:21:20.000000', 'consum', 0.0222, 'lps'),
	(459214, 126, '2015-03-15 00:21:21.000000', 'consum', 0.0221, 'lps'),
	(459215, 126, '2015-03-15 00:21:22.000000', 'consum', 0.0212, 'lps'),
	(459216, 126, '2015-03-15 00:21:23.000000', 'consum', 0.0218, 'lps'),
	(459217, 126, '2015-03-15 00:21:24.000000', 'consum', 0.0214, 'lps'),
	(459218, 126, '2015-03-15 00:21:25.000000', 'consum', 0.0220, 'lps'),
	(459219, 126, '2015-03-15 00:21:26.000000', 'consum', 0.0223, 'lps'),
	(459220, 126, '2015-03-15 00:21:27.000000', 'consum', 0.0218, 'lps'),
	(459221, 126, '2015-03-15 00:21:28.000000', 'consum', 0.0223, 'lps'),
	(459222, 126, '2015-03-15 00:21:29.000000', 'consum', 0.0212, 'lps'),
	(459223, 126, '2015-03-15 00:21:30.000000', 'consum', 0.0210, 'lps'),
	(459224, 126, '2015-03-15 00:21:31.000000', 'consum', 0.0218, 'lps'),
	(459225, 126, '2015-03-15 00:21:32.000000', 'consum', 0.0222, 'lps'),
	(459226, 126, '2015-03-15 00:21:33.000000', 'consum', 0.0219, 'lps'),
	(459227, 126, '2015-03-15 00:21:34.000000', 'consum', 0.0220, 'lps'),
	(459228, 126, '2015-03-15 00:21:35.000000', 'consum', 0.0218, 'lps'),
	(459229, 126, '2015-03-15 00:21:36.000000', 'consum', 0.0220, 'lps'),
	(459230, 126, '2015-03-15 00:21:37.000000', 'consum', 0.0223, 'lps'),
	(459231, 126, '2015-03-15 00:21:38.000000', 'consum', 0.0217, 'lps'),
	(459232, 126, '2015-03-15 00:21:39.000000', 'consum', 0.0223, 'lps'),
	(459233, 126, '2015-03-15 00:21:40.000000', 'consum', 0.0211, 'lps'),
	(459234, 126, '2015-03-15 00:21:41.000000', 'consum', 0.0218, 'lps'),
	(459235, 126, '2015-03-15 00:21:42.000000', 'consum', 0.0219, 'lps'),
	(459236, 126, '2015-03-15 00:21:43.000000', 'consum', 0.0218, 'lps'),
	(459237, 126, '2015-03-15 00:21:44.000000', 'consum', 0.0210, 'lps'),
	(459238, 126, '2015-03-15 00:21:45.000000', 'consum', 0.0216, 'lps'),
	(459239, 126, '2015-03-15 00:21:46.000000', 'consum', 0.0223, 'lps'),
	(459240, 126, '2015-03-15 00:21:47.000000', 'consum', 0.0218, 'lps'),
	(459241, 126, '2015-03-15 00:21:48.000000', 'consum', 0.0211, 'lps'),
	(459242, 126, '2015-03-15 00:21:49.000000', 'consum', 0.0220, 'lps'),
	(459243, 126, '2015-03-15 00:21:50.000000', 'consum', 0.0215, 'lps'),
	(459244, 126, '2015-03-15 00:21:51.000000', 'consum', 0.0222, 'lps'),
	(459245, 126, '2015-03-15 00:21:52.000000', 'consum', 0.0210, 'lps'),
	(459246, 126, '2015-03-15 00:21:53.000000', 'consum', 0.0218, 'lps'),
	(459247, 126, '2015-03-15 00:21:54.000000', 'consum', 0.0222, 'lps'),
	(459248, 126, '2015-03-15 00:21:55.000000', 'consum', 0.0221, 'lps'),
	(459249, 126, '2015-03-15 00:21:56.000000', 'consum', 0.0212, 'lps'),
	(459250, 126, '2015-03-15 00:21:57.000000', 'consum', 0.0218, 'lps'),
	(459251, 126, '2015-03-15 00:21:58.000000', 'consum', 0.0214, 'lps'),
	(459252, 126, '2015-03-15 00:21:59.000000', 'consum', 0.0220, 'lps'),
	(459253, 126, '2015-03-15 00:22:00.000000', 'consum', 0.0222, 'lps'),
	(459254, 126, '2015-03-15 00:22:01.000000', 'consum', 0.0214, 'lps'),
	(459255, 126, '2015-03-15 00:22:02.000000', 'consum', 0.0221, 'lps'),
	(459256, 126, '2015-03-15 00:22:03.000000', 'consum', 0.0213, 'lps'),
	(459257, 126, '2015-03-15 00:22:04.000000', 'consum', 0.0221, 'lps'),
	(459258, 126, '2015-03-15 00:22:05.000000', 'consum', 0.0213, 'lps'),
	(459259, 126, '2015-03-15 00:22:06.000000', 'consum', 0.0222, 'lps'),
	(459260, 126, '2015-03-15 00:22:07.000000', 'consum', 0.0218, 'lps'),
	(459261, 126, '2015-03-15 00:22:08.000000', 'consum', 0.0215, 'lps'),
	(459262, 126, '2015-03-15 00:22:09.000000', 'consum', 0.0212, 'lps'),
	(459263, 126, '2015-03-15 00:22:10.000000', 'consum', 0.0220, 'lps'),
	(459264, 126, '2015-03-15 00:22:11.000000', 'consum', 0.0211, 'lps'),
	(459265, 126, '2015-03-15 00:22:12.000000', 'consum', 0.0215, 'lps'),
	(459266, 126, '2015-03-15 00:22:13.000000', 'consum', 0.0218, 'lps'),
	(459267, 126, '2015-03-15 00:22:14.000000', 'consum', 0.0222, 'lps'),
	(459268, 126, '2015-03-15 00:22:15.000000', 'consum', 0.0216, 'lps'),
	(459269, 126, '2015-03-15 00:22:16.000000', 'consum', 0.0220, 'lps'),
	(459270, 126, '2015-03-15 00:22:17.000000', 'consum', 0.0214, 'lps'),
	(459271, 126, '2015-03-15 00:22:18.000000', 'consum', 0.0213, 'lps'),
	(459272, 126, '2015-03-15 00:22:19.000000', 'consum', 0.0215, 'lps'),
	(459273, 126, '2015-03-15 00:22:20.000000', 'consum', 0.0213, 'lps'),
	(459274, 126, '2015-03-15 00:22:21.000000', 'consum', 0.0223, 'lps'),
	(459275, 126, '2015-03-15 00:22:22.000000', 'consum', 0.0223, 'lps'),
	(459276, 126, '2015-03-15 00:22:23.000000', 'consum', 0.0211, 'lps'),
	(459277, 126, '2015-03-15 00:22:24.000000', 'consum', 0.0219, 'lps'),
	(459278, 126, '2015-03-15 00:22:25.000000', 'consum', 0.0210, 'lps'),
	(459279, 126, '2015-03-15 00:22:26.000000', 'consum', 0.0212, 'lps'),
	(459280, 126, '2015-03-15 00:22:27.000000', 'consum', 0.0218, 'lps'),
	(459281, 126, '2015-03-15 00:22:28.000000', 'consum', 0.0219, 'lps'),
	(459282, 126, '2015-03-15 00:22:29.000000', 'consum', 0.0215, 'lps'),
	(459283, 126, '2015-03-15 00:22:30.000000', 'consum', 0.0223, 'lps'),
	(459284, 126, '2015-03-15 00:22:31.000000', 'consum', 0.0219, 'lps'),
	(459285, 126, '2015-03-15 00:22:32.000000', 'consum', 0.0217, 'lps'),
	(459286, 126, '2015-03-15 00:22:33.000000', 'consum', 0.0216, 'lps'),
	(459287, 126, '2015-03-15 00:22:34.000000', 'consum', 0.0221, 'lps'),
	(459288, 126, '2015-03-15 00:22:35.000000', 'consum', 0.0221, 'lps'),
	(459289, 126, '2015-03-15 00:22:36.000000', 'consum', 0.0219, 'lps'),
	(459290, 126, '2015-03-15 00:22:37.000000', 'consum', 0.0221, 'lps'),
	(459291, 126, '2015-03-15 00:22:38.000000', 'consum', 0.0223, 'lps'),
	(459292, 126, '2015-03-15 00:22:39.000000', 'consum', 0.0216, 'lps'),
	(459293, 126, '2015-03-15 00:22:40.000000', 'consum', 0.0214, 'lps'),
	(459294, 126, '2015-03-15 00:22:41.000000', 'consum', 0.0214, 'lps'),
	(459295, 126, '2015-03-15 00:22:42.000000', 'consum', 0.0218, 'lps'),
	(459296, 126, '2015-03-15 00:22:43.000000', 'consum', 0.0210, 'lps'),
	(459297, 126, '2015-03-15 00:22:44.000000', 'consum', 0.0215, 'lps'),
	(459298, 126, '2015-03-15 00:22:45.000000', 'consum', 0.0223, 'lps'),
	(459299, 126, '2015-03-15 00:22:46.000000', 'consum', 0.0218, 'lps'),
	(459300, 126, '2015-03-15 00:22:47.000000', 'consum', 0.0211, 'lps'),
	(459301, 126, '2015-03-15 00:22:48.000000', 'consum', 0.0219, 'lps'),
	(459302, 126, '2015-03-15 00:22:49.000000', 'consum', 0.0223, 'lps'),
	(459303, 126, '2015-03-15 00:22:50.000000', 'consum', 0.0221, 'lps'),
	(459304, 126, '2015-03-15 00:22:51.000000', 'consum', 0.0213, 'lps'),
	(459305, 126, '2015-03-15 00:22:52.000000', 'consum', 0.0220, 'lps'),
	(459306, 126, '2015-03-15 00:22:53.000000', 'consum', 0.0211, 'lps'),
	(459307, 126, '2015-03-15 00:22:54.000000', 'consum', 0.0212, 'lps'),
	(459308, 126, '2015-03-15 00:22:55.000000', 'consum', 0.0217, 'lps'),
	(459309, 126, '2015-03-15 00:22:56.000000', 'consum', 0.0214, 'lps'),
	(459310, 126, '2015-03-15 00:22:57.000000', 'consum', 0.0223, 'lps'),
	(459311, 126, '2015-03-15 00:22:58.000000', 'consum', 0.0223, 'lps'),
	(459312, 126, '2015-03-15 00:22:59.000000', 'consum', 0.0221, 'lps'),
	(459313, 126, '2015-03-15 00:23:00.000000', 'consum', 0.0214, 'lps'),
	(459314, 126, '2015-03-15 00:23:01.000000', 'consum', 0.0210, 'lps'),
	(459315, 126, '2015-03-15 00:23:02.000000', 'consum', 0.0211, 'lps'),
	(459316, 126, '2015-03-15 00:23:03.000000', 'consum', 0.0219, 'lps'),
	(459317, 126, '2015-03-15 00:23:04.000000', 'consum', 0.0222, 'lps'),
	(459318, 126, '2015-03-15 00:23:05.000000', 'consum', 0.0215, 'lps'),
	(459319, 126, '2015-03-15 00:23:06.000000', 'consum', 0.0215, 'lps'),
	(459320, 126, '2015-03-15 00:23:07.000000', 'consum', 0.0221, 'lps'),
	(459321, 126, '2015-03-15 00:23:08.000000', 'consum', 0.0223, 'lps'),
	(459322, 126, '2015-03-15 00:23:09.000000', 'consum', 0.0212, 'lps'),
	(459323, 126, '2015-03-15 00:23:10.000000', 'consum', 0.0211, 'lps'),
	(459324, 126, '2015-03-15 00:23:11.000000', 'consum', 0.0221, 'lps'),
	(459325, 126, '2015-03-15 00:23:12.000000', 'consum', 0.0210, 'lps'),
	(459326, 126, '2015-03-15 00:23:13.000000', 'consum', 0.0218, 'lps'),
	(459327, 126, '2015-03-15 00:23:14.000000', 'consum', 0.0223, 'lps'),
	(459328, 126, '2015-03-15 00:23:15.000000', 'consum', 0.0223, 'lps'),
	(459329, 126, '2015-03-15 00:23:16.000000', 'consum', 0.0210, 'lps'),
	(459330, 126, '2015-03-15 00:23:17.000000', 'consum', 0.0214, 'lps'),
	(459331, 126, '2015-03-15 00:23:18.000000', 'consum', 0.0216, 'lps'),
	(459332, 126, '2015-03-15 00:23:19.000000', 'consum', 0.0213, 'lps'),
	(459333, 126, '2015-03-15 00:23:20.000000', 'consum', 0.0223, 'lps'),
	(459334, 126, '2015-03-15 00:23:21.000000', 'consum', 0.0212, 'lps'),
	(459335, 126, '2015-03-15 00:23:22.000000', 'consum', 0.0223, 'lps'),
	(459336, 126, '2015-03-15 00:23:23.000000', 'consum', 0.0212, 'lps'),
	(459337, 126, '2015-03-15 00:23:24.000000', 'consum', 0.0210, 'lps'),
	(459338, 126, '2015-03-15 00:23:25.000000', 'consum', 0.0219, 'lps'),
	(459339, 126, '2015-03-15 00:23:26.000000', 'consum', 0.0211, 'lps'),
	(459340, 126, '2015-03-15 00:23:27.000000', 'consum', 0.0219, 'lps'),
	(459341, 126, '2015-03-15 00:23:28.000000', 'consum', 0.0211, 'lps'),
	(459342, 126, '2015-03-15 00:23:29.000000', 'consum', 0.0216, 'lps'),
	(459343, 126, '2015-03-15 00:23:30.000000', 'consum', 0.0210, 'lps'),
	(459344, 126, '2015-03-15 00:23:31.000000', 'consum', 0.0218, 'lps'),
	(459345, 126, '2015-03-15 00:23:32.000000', 'consum', 0.0211, 'lps'),
	(459346, 126, '2015-03-15 00:23:33.000000', 'consum', 0.0219, 'lps'),
	(459347, 126, '2015-03-15 00:23:34.000000', 'consum', 0.0223, 'lps'),
	(459348, 126, '2015-03-15 00:23:35.000000', 'consum', 0.0221, 'lps'),
	(459349, 126, '2015-03-15 00:23:36.000000', 'consum', 0.0214, 'lps'),
	(459350, 126, '2015-03-15 00:23:37.000000', 'consum', 0.0211, 'lps'),
	(459351, 126, '2015-03-15 00:23:38.000000', 'consum', 0.0216, 'lps'),
	(459352, 126, '2015-03-15 00:23:39.000000', 'consum', 0.0223, 'lps'),
	(459353, 126, '2015-03-15 00:23:40.000000', 'consum', 0.0216, 'lps'),
	(459354, 126, '2015-03-15 00:23:41.000000', 'consum', 0.0214, 'lps'),
	(459355, 126, '2015-03-15 00:23:42.000000', 'consum', 0.0213, 'lps'),
	(459356, 126, '2015-03-15 00:23:43.000000', 'consum', 0.0215, 'lps'),
	(459357, 126, '2015-03-15 00:23:44.000000', 'consum', 0.0211, 'lps'),
	(459358, 126, '2015-03-15 00:23:45.000000', 'consum', 0.0217, 'lps'),
	(459359, 126, '2015-03-15 00:23:46.000000', 'consum', 0.0213, 'lps'),
	(459360, 126, '2015-03-15 00:23:47.000000', 'consum', 0.0219, 'lps'),
	(459361, 126, '2015-03-15 00:23:48.000000', 'consum', 0.0218, 'lps'),
	(459362, 126, '2015-03-15 00:23:49.000000', 'consum', 0.0223, 'lps'),
	(459363, 126, '2015-03-15 00:23:50.000000', 'consum', 0.0210, 'lps'),
	(459364, 126, '2015-03-15 00:23:51.000000', 'consum', 0.0212, 'lps'),
	(459365, 126, '2015-03-15 00:23:52.000000', 'consum', 0.0220, 'lps'),
	(459366, 126, '2015-03-15 00:23:53.000000', 'consum', 0.0212, 'lps'),
	(459367, 126, '2015-03-15 00:23:54.000000', 'consum', 0.0218, 'lps'),
	(459368, 126, '2015-03-15 00:23:55.000000', 'consum', 0.0217, 'lps'),
	(459369, 126, '2015-03-15 00:23:56.000000', 'consum', 0.0210, 'lps'),
	(459370, 126, '2015-03-15 00:23:57.000000', 'consum', 0.0214, 'lps'),
	(459371, 126, '2015-03-15 00:23:58.000000', 'consum', 0.0218, 'lps'),
	(459372, 126, '2015-03-15 00:23:59.000000', 'consum', 0.0222, 'lps'),
	(459373, 126, '2015-03-15 00:24:00.000000', 'consum', 0.0222, 'lps'),
	(459374, 126, '2015-03-15 00:24:01.000000', 'consum', 0.0218, 'lps'),
	(459375, 126, '2015-03-15 00:24:02.000000', 'consum', 0.0216, 'lps'),
	(459376, 126, '2015-03-15 00:24:03.000000', 'consum', 0.0216, 'lps'),
	(459377, 126, '2015-03-15 00:24:04.000000', 'consum', 0.0221, 'lps'),
	(459378, 126, '2015-03-15 00:24:05.000000', 'consum', 0.0222, 'lps'),
	(459379, 126, '2015-03-15 00:24:06.000000', 'consum', 0.0223, 'lps'),
	(459380, 126, '2015-03-15 00:24:07.000000', 'consum', 0.0213, 'lps'),
	(459381, 126, '2015-03-15 00:24:08.000000', 'consum', 0.0212, 'lps'),
	(459382, 126, '2015-03-15 00:24:09.000000', 'consum', 0.0212, 'lps'),
	(459383, 126, '2015-03-15 00:24:10.000000', 'consum', 0.0213, 'lps'),
	(459384, 126, '2015-03-15 00:24:11.000000', 'consum', 0.0221, 'lps'),
	(459385, 126, '2015-03-15 00:24:12.000000', 'consum', 0.0213, 'lps'),
	(459386, 126, '2015-03-15 00:24:13.000000', 'consum', 0.0221, 'lps'),
	(459387, 126, '2015-03-15 00:24:14.000000', 'consum', 0.0216, 'lps'),
	(459388, 126, '2015-03-15 00:24:15.000000', 'consum', 0.0219, 'lps'),
	(459389, 126, '2015-03-15 00:24:16.000000', 'consum', 0.0212, 'lps'),
	(459390, 126, '2015-03-15 00:24:17.000000', 'consum', 0.0222, 'lps'),
	(459391, 126, '2015-03-15 00:24:18.000000', 'consum', 0.0220, 'lps'),
	(459392, 126, '2015-03-15 00:24:19.000000', 'consum', 0.0210, 'lps'),
	(459393, 126, '2015-03-15 00:24:20.000000', 'consum', 0.0223, 'lps'),
	(459394, 126, '2015-03-15 00:24:21.000000', 'consum', 0.0219, 'lps'),
	(459395, 126, '2015-03-15 00:24:22.000000', 'consum', 0.0216, 'lps'),
	(459396, 126, '2015-03-15 00:24:23.000000', 'consum', 0.0215, 'lps'),
	(459397, 126, '2015-03-15 00:24:24.000000', 'consum', 0.0218, 'lps'),
	(459398, 126, '2015-03-15 00:24:25.000000', 'consum', 0.0220, 'lps'),
	(459399, 126, '2015-03-15 00:24:26.000000', 'consum', 0.0211, 'lps'),
	(459400, 126, '2015-03-15 00:24:27.000000', 'consum', 0.0211, 'lps'),
	(459401, 126, '2015-03-15 00:24:28.000000', 'consum', 0.0213, 'lps'),
	(459402, 126, '2015-03-15 00:24:29.000000', 'consum', 0.0210, 'lps'),
	(459403, 126, '2015-03-15 00:24:30.000000', 'consum', 0.0215, 'lps'),
	(459404, 126, '2015-03-15 00:24:31.000000', 'consum', 0.0223, 'lps'),
	(459405, 126, '2015-03-15 00:24:32.000000', 'consum', 0.0216, 'lps'),
	(459406, 126, '2015-03-15 00:24:33.000000', 'consum', 0.0218, 'lps'),
	(459407, 126, '2015-03-15 00:24:34.000000', 'consum', 0.0219, 'lps'),
	(459408, 126, '2015-03-15 00:24:35.000000', 'consum', 0.0216, 'lps'),
	(459409, 126, '2015-03-15 00:24:36.000000', 'consum', 0.0213, 'lps'),
	(459410, 126, '2015-03-15 00:24:37.000000', 'consum', 0.0221, 'lps'),
	(459411, 126, '2015-03-15 00:24:38.000000', 'consum', 0.0217, 'lps'),
	(459412, 126, '2015-03-15 00:24:39.000000', 'consum', 0.0212, 'lps'),
	(459413, 126, '2015-03-15 00:24:40.000000', 'consum', 0.0211, 'lps'),
	(459414, 126, '2015-03-15 00:24:41.000000', 'consum', 0.0211, 'lps'),
	(459415, 126, '2015-03-15 00:24:42.000000', 'consum', 0.0210, 'lps'),
	(459416, 126, '2015-03-15 00:24:43.000000', 'consum', 0.0211, 'lps'),
	(459417, 126, '2015-03-15 00:24:44.000000', 'consum', 0.0215, 'lps'),
	(459418, 126, '2015-03-15 00:24:45.000000', 'consum', 0.0217, 'lps'),
	(459419, 126, '2015-03-15 00:24:46.000000', 'consum', 0.0219, 'lps'),
	(459420, 126, '2015-03-15 00:24:47.000000', 'consum', 0.0218, 'lps'),
	(459421, 126, '2015-03-15 00:24:48.000000', 'consum', 0.0210, 'lps'),
	(459422, 126, '2015-03-15 00:24:49.000000', 'consum', 0.0217, 'lps'),
	(459423, 126, '2015-03-15 00:24:50.000000', 'consum', 0.0214, 'lps'),
	(459424, 126, '2015-03-15 00:24:51.000000', 'consum', 0.0213, 'lps'),
	(459425, 126, '2015-03-15 00:24:52.000000', 'consum', 0.0212, 'lps'),
	(459426, 126, '2015-03-15 00:24:53.000000', 'consum', 0.0211, 'lps'),
	(459427, 126, '2015-03-15 00:24:54.000000', 'consum', 0.0210, 'lps'),
	(459428, 126, '2015-03-15 00:24:55.000000', 'consum', 0.0222, 'lps'),
	(459429, 126, '2015-03-15 00:24:56.000000', 'consum', 0.0213, 'lps'),
	(459430, 126, '2015-03-15 00:24:57.000000', 'consum', 0.0219, 'lps'),
	(459431, 126, '2015-03-15 00:24:58.000000', 'consum', 0.0217, 'lps'),
	(459432, 126, '2015-03-15 00:24:59.000000', 'consum', 0.0218, 'lps'),
	(459433, 126, '2015-03-15 00:25:00.000000', 'consum', 0.0216, 'lps'),
	(459434, 126, '2015-03-15 00:25:01.000000', 'consum', 0.0215, 'lps'),
	(459435, 126, '2015-03-15 00:25:02.000000', 'consum', 0.0217, 'lps'),
	(459436, 126, '2015-03-15 00:25:03.000000', 'consum', 0.0219, 'lps'),
	(459437, 126, '2015-03-15 00:25:04.000000', 'consum', 0.0220, 'lps'),
	(459438, 126, '2015-03-15 00:25:05.000000', 'consum', 0.0221, 'lps'),
	(459439, 126, '2015-03-15 00:25:06.000000', 'consum', 0.0220, 'lps'),
	(459440, 126, '2015-03-15 00:25:07.000000', 'consum', 0.0212, 'lps'),
	(459441, 126, '2015-03-15 00:25:08.000000', 'consum', 0.0219, 'lps'),
	(459442, 126, '2015-03-15 00:25:09.000000', 'consum', 0.0223, 'lps'),
	(459443, 126, '2015-03-15 00:25:10.000000', 'consum', 0.0218, 'lps'),
	(459444, 126, '2015-03-15 00:25:11.000000', 'consum', 0.0212, 'lps'),
	(459445, 126, '2015-03-15 00:25:12.000000', 'consum', 0.0223, 'lps'),
	(459446, 126, '2015-03-15 00:25:13.000000', 'consum', 0.0215, 'lps'),
	(459447, 126, '2015-03-15 00:25:14.000000', 'consum', 0.0210, 'lps'),
	(459448, 126, '2015-03-15 00:25:15.000000', 'consum', 0.0222, 'lps'),
	(459449, 126, '2015-03-15 00:25:16.000000', 'consum', 0.0216, 'lps'),
	(459450, 126, '2015-03-15 00:25:17.000000', 'consum', 0.0219, 'lps'),
	(459451, 126, '2015-03-15 00:25:18.000000', 'consum', 0.0211, 'lps'),
	(459452, 126, '2015-03-15 00:25:19.000000', 'consum', 0.0215, 'lps'),
	(459453, 126, '2015-03-15 00:25:20.000000', 'consum', 0.0220, 'lps'),
	(459454, 126, '2015-03-15 00:25:21.000000', 'consum', 0.0216, 'lps'),
	(459455, 126, '2015-03-15 00:25:22.000000', 'consum', 0.0210, 'lps'),
	(459456, 126, '2015-03-15 00:25:23.000000', 'consum', 0.0223, 'lps'),
	(459457, 126, '2015-03-15 00:25:24.000000', 'consum', 0.0219, 'lps'),
	(459458, 126, '2015-03-15 00:25:25.000000', 'consum', 0.0217, 'lps'),
	(459459, 126, '2015-03-15 00:25:26.000000', 'consum', 0.0217, 'lps'),
	(459460, 126, '2015-03-15 00:25:27.000000', 'consum', 0.0213, 'lps'),
	(459461, 126, '2015-03-15 00:25:28.000000', 'consum', 0.0217, 'lps'),
	(459462, 126, '2015-03-15 00:25:29.000000', 'consum', 0.0222, 'lps'),
	(459463, 126, '2015-03-15 00:25:30.000000', 'consum', 0.0221, 'lps'),
	(459464, 126, '2015-03-15 00:25:31.000000', 'consum', 0.0215, 'lps'),
	(459465, 126, '2015-03-15 00:25:32.000000', 'consum', 0.0215, 'lps'),
	(459466, 126, '2015-03-15 00:25:33.000000', 'consum', 0.0223, 'lps'),
	(459467, 126, '2015-03-15 00:25:34.000000', 'consum', 0.0220, 'lps'),
	(459468, 126, '2015-03-15 00:25:35.000000', 'consum', 0.0220, 'lps'),
	(459469, 126, '2015-03-15 00:25:36.000000', 'consum', 0.0216, 'lps'),
	(459470, 126, '2015-03-15 00:25:37.000000', 'consum', 0.0211, 'lps'),
	(459471, 126, '2015-03-15 00:25:38.000000', 'consum', 0.0211, 'lps'),
	(459472, 126, '2015-03-15 00:25:39.000000', 'consum', 0.0213, 'lps'),
	(459473, 126, '2015-03-15 00:25:40.000000', 'consum', 0.0220, 'lps'),
	(459474, 126, '2015-03-15 00:25:41.000000', 'consum', 0.0213, 'lps'),
	(459475, 126, '2015-03-15 00:25:42.000000', 'consum', 0.0222, 'lps'),
	(459476, 126, '2015-03-15 00:25:43.000000', 'consum', 0.0219, 'lps'),
	(459477, 126, '2015-03-15 00:25:44.000000', 'consum', 0.0222, 'lps'),
	(459478, 126, '2015-03-15 00:25:45.000000', 'consum', 0.0212, 'lps'),
	(459479, 126, '2015-03-15 00:25:46.000000', 'consum', 0.0216, 'lps'),
	(459480, 126, '2015-03-15 00:25:47.000000', 'consum', 0.0219, 'lps'),
	(459481, 126, '2015-03-15 00:25:48.000000', 'consum', 0.0210, 'lps'),
	(459482, 126, '2015-03-15 00:25:49.000000', 'consum', 0.0211, 'lps'),
	(459483, 126, '2015-03-15 00:25:50.000000', 'consum', 0.0216, 'lps'),
	(459484, 126, '2015-03-15 00:25:51.000000', 'consum', 0.0222, 'lps'),
	(459485, 126, '2015-03-15 00:25:52.000000', 'consum', 0.0211, 'lps'),
	(459486, 126, '2015-03-15 00:25:53.000000', 'consum', 0.0221, 'lps'),
	(459487, 126, '2015-03-15 00:25:54.000000', 'consum', 0.0221, 'lps'),
	(459488, 126, '2015-03-15 00:25:55.000000', 'consum', 0.0220, 'lps'),
	(459489, 126, '2015-03-15 00:25:56.000000', 'consum', 0.0215, 'lps'),
	(459490, 126, '2015-03-15 00:25:57.000000', 'consum', 0.0216, 'lps'),
	(459491, 126, '2015-03-15 00:25:58.000000', 'consum', 0.0211, 'lps'),
	(459492, 126, '2015-03-15 00:25:59.000000', 'consum', 0.0214, 'lps'),
	(459493, 126, '2015-03-15 00:26:00.000000', 'consum', 0.0211, 'lps'),
	(459494, 126, '2015-03-15 00:26:01.000000', 'consum', 0.0217, 'lps'),
	(459495, 126, '2015-03-15 00:26:02.000000', 'consum', 0.0217, 'lps'),
	(459496, 126, '2015-03-15 00:26:03.000000', 'consum', 0.0211, 'lps'),
	(459497, 126, '2015-03-15 00:26:04.000000', 'consum', 0.0210, 'lps'),
	(459498, 126, '2015-03-15 00:26:05.000000', 'consum', 0.0218, 'lps'),
	(459499, 126, '2015-03-15 00:26:06.000000', 'consum', 0.0223, 'lps'),
	(459500, 126, '2015-03-15 00:26:07.000000', 'consum', 0.0211, 'lps'),
	(459501, 126, '2015-03-15 00:26:08.000000', 'consum', 0.0219, 'lps'),
	(459502, 126, '2015-03-15 00:26:09.000000', 'consum', 0.0222, 'lps'),
	(459503, 126, '2015-03-15 00:26:10.000000', 'consum', 0.0215, 'lps'),
	(459504, 126, '2015-03-15 00:26:11.000000', 'consum', 0.0213, 'lps'),
	(459505, 126, '2015-03-15 00:26:12.000000', 'consum', 0.0214, 'lps'),
	(459506, 126, '2015-03-15 00:26:13.000000', 'consum', 0.0218, 'lps'),
	(459507, 126, '2015-03-15 00:26:14.000000', 'consum', 0.0211, 'lps'),
	(459508, 126, '2015-03-15 00:26:15.000000', 'consum', 0.0219, 'lps'),
	(459509, 126, '2015-03-15 00:26:16.000000', 'consum', 0.0211, 'lps'),
	(459510, 126, '2015-03-15 00:26:17.000000', 'consum', 0.0217, 'lps'),
	(459511, 126, '2015-03-15 00:26:18.000000', 'consum', 0.0214, 'lps'),
	(459512, 126, '2015-03-15 00:26:19.000000', 'consum', 0.0210, 'lps'),
	(459513, 126, '2015-03-15 00:26:20.000000', 'consum', 0.0214, 'lps'),
	(459514, 126, '2015-03-15 00:26:21.000000', 'consum', 0.0214, 'lps'),
	(459515, 126, '2015-03-15 00:26:22.000000', 'consum', 0.0220, 'lps'),
	(459516, 126, '2015-03-15 00:26:23.000000', 'consum', 0.0221, 'lps'),
	(459517, 126, '2015-03-15 00:26:24.000000', 'consum', 0.0222, 'lps'),
	(459518, 126, '2015-03-15 00:26:25.000000', 'consum', 0.0223, 'lps'),
	(459519, 126, '2015-03-15 00:26:26.000000', 'consum', 0.0210, 'lps'),
	(459520, 126, '2015-03-15 00:26:27.000000', 'consum', 0.0215, 'lps'),
	(459521, 126, '2015-03-15 00:26:28.000000', 'consum', 0.0222, 'lps'),
	(459522, 126, '2015-03-15 00:26:29.000000', 'consum', 0.0213, 'lps'),
	(459523, 126, '2015-03-15 00:26:30.000000', 'consum', 0.0218, 'lps'),
	(459524, 126, '2015-03-15 00:26:31.000000', 'consum', 0.0213, 'lps'),
	(459525, 126, '2015-03-15 00:26:32.000000', 'consum', 0.0215, 'lps'),
	(459526, 126, '2015-03-15 00:26:33.000000', 'consum', 0.0212, 'lps'),
	(459527, 126, '2015-03-15 00:26:34.000000', 'consum', 0.0219, 'lps'),
	(459528, 126, '2015-03-15 00:26:35.000000', 'consum', 0.0223, 'lps'),
	(459529, 126, '2015-03-15 00:26:36.000000', 'consum', 0.0222, 'lps'),
	(459530, 126, '2015-03-15 00:26:37.000000', 'consum', 0.0217, 'lps'),
	(459531, 126, '2015-03-15 00:26:38.000000', 'consum', 0.0221, 'lps'),
	(459532, 126, '2015-03-15 00:26:39.000000', 'consum', 0.0217, 'lps'),
	(459533, 126, '2015-03-15 00:26:40.000000', 'consum', 0.0215, 'lps'),
	(459534, 126, '2015-03-15 00:26:41.000000', 'consum', 0.0214, 'lps'),
	(459535, 126, '2015-03-15 00:26:42.000000', 'consum', 0.0214, 'lps'),
	(459536, 126, '2015-03-15 00:26:43.000000', 'consum', 0.0219, 'lps'),
	(459537, 126, '2015-03-15 00:26:44.000000', 'consum', 0.0216, 'lps'),
	(459538, 126, '2015-03-15 00:26:45.000000', 'consum', 0.0214, 'lps'),
	(459539, 126, '2015-03-15 00:26:46.000000', 'consum', 0.0211, 'lps'),
	(459540, 126, '2015-03-15 00:26:47.000000', 'consum', 0.0219, 'lps'),
	(459541, 126, '2015-03-15 00:26:48.000000', 'consum', 0.0210, 'lps'),
	(459542, 126, '2015-03-15 00:26:49.000000', 'consum', 0.0212, 'lps'),
	(459543, 126, '2015-03-15 00:26:50.000000', 'consum', 0.0222, 'lps'),
	(459544, 126, '2015-03-15 00:26:51.000000', 'consum', 0.0220, 'lps'),
	(459545, 126, '2015-03-15 00:26:52.000000', 'consum', 0.0212, 'lps'),
	(459546, 126, '2015-03-15 00:26:53.000000', 'consum', 0.0217, 'lps'),
	(459547, 126, '2015-03-15 00:26:54.000000', 'consum', 0.0214, 'lps'),
	(459548, 126, '2015-03-15 00:26:55.000000', 'consum', 0.0221, 'lps'),
	(459549, 126, '2015-03-15 00:26:56.000000', 'consum', 0.0211, 'lps'),
	(459550, 126, '2015-03-15 00:26:57.000000', 'consum', 0.0211, 'lps'),
	(459551, 126, '2015-03-15 00:26:58.000000', 'consum', 0.0213, 'lps'),
	(459552, 126, '2015-03-15 00:26:59.000000', 'consum', 0.0223, 'lps'),
	(459553, 126, '2015-03-15 00:27:00.000000', 'consum', 0.0223, 'lps'),
	(459554, 126, '2015-03-15 00:27:01.000000', 'consum', 0.0211, 'lps'),
	(459555, 126, '2015-03-15 00:27:02.000000', 'consum', 0.0216, 'lps'),
	(459556, 126, '2015-03-15 00:27:03.000000', 'consum', 0.0212, 'lps'),
	(459557, 126, '2015-03-15 00:27:04.000000', 'consum', 0.0218, 'lps'),
	(459558, 126, '2015-03-15 00:27:05.000000', 'consum', 0.0213, 'lps'),
	(459559, 126, '2015-03-15 00:27:06.000000', 'consum', 0.0215, 'lps'),
	(459560, 126, '2015-03-15 00:27:07.000000', 'consum', 0.0213, 'lps'),
	(459561, 126, '2015-03-15 00:27:08.000000', 'consum', 0.0223, 'lps'),
	(459562, 126, '2015-03-15 00:27:09.000000', 'consum', 0.0213, 'lps'),
	(459563, 126, '2015-03-15 00:27:10.000000', 'consum', 0.0215, 'lps'),
	(459564, 126, '2015-03-15 00:27:11.000000', 'consum', 0.0211, 'lps'),
	(459565, 126, '2015-03-15 00:27:12.000000', 'consum', 0.0216, 'lps'),
	(459566, 126, '2015-03-15 00:27:13.000000', 'consum', 0.0221, 'lps'),
	(459567, 126, '2015-03-15 00:27:14.000000', 'consum', 0.0219, 'lps'),
	(459568, 126, '2015-03-15 00:27:15.000000', 'consum', 0.0210, 'lps'),
	(459569, 126, '2015-03-15 00:27:16.000000', 'consum', 0.0210, 'lps'),
	(459570, 126, '2015-03-15 00:27:17.000000', 'consum', 0.0211, 'lps'),
	(459571, 126, '2015-03-15 00:27:18.000000', 'consum', 0.0217, 'lps'),
	(459572, 126, '2015-03-15 00:27:19.000000', 'consum', 0.0214, 'lps'),
	(459573, 126, '2015-03-15 00:27:20.000000', 'consum', 0.0223, 'lps'),
	(459574, 126, '2015-03-15 00:27:21.000000', 'consum', 0.0221, 'lps'),
	(459575, 126, '2015-03-15 00:27:22.000000', 'consum', 0.0212, 'lps'),
	(459576, 126, '2015-03-15 00:27:23.000000', 'consum', 0.0214, 'lps'),
	(459577, 126, '2015-03-15 00:27:24.000000', 'consum', 0.0213, 'lps'),
	(459578, 126, '2015-03-15 00:27:25.000000', 'consum', 0.0213, 'lps'),
	(459579, 126, '2015-03-15 00:27:26.000000', 'consum', 0.0216, 'lps'),
	(459580, 126, '2015-03-15 00:27:27.000000', 'consum', 0.0218, 'lps'),
	(459581, 126, '2015-03-15 00:27:28.000000', 'consum', 0.0217, 'lps'),
	(459582, 126, '2015-03-15 00:27:29.000000', 'consum', 0.0210, 'lps'),
	(459583, 126, '2015-03-15 00:27:30.000000', 'consum', 0.0218, 'lps'),
	(459584, 126, '2015-03-15 00:27:31.000000', 'consum', 0.0220, 'lps'),
	(459585, 126, '2015-03-15 00:27:32.000000', 'consum', 0.0211, 'lps'),
	(459586, 126, '2015-03-15 00:27:33.000000', 'consum', 0.0215, 'lps'),
	(459587, 126, '2015-03-15 00:27:34.000000', 'consum', 0.0215, 'lps'),
	(459588, 126, '2015-03-15 00:27:35.000000', 'consum', 0.0220, 'lps'),
	(459589, 126, '2015-03-15 00:27:36.000000', 'consum', 0.0220, 'lps'),
	(459590, 126, '2015-03-15 00:27:37.000000', 'consum', 0.0215, 'lps'),
	(459591, 126, '2015-03-15 00:27:38.000000', 'consum', 0.0219, 'lps'),
	(459592, 126, '2015-03-15 00:27:39.000000', 'consum', 0.0213, 'lps'),
	(459593, 126, '2015-03-15 00:27:40.000000', 'consum', 0.0214, 'lps'),
	(459594, 126, '2015-03-15 00:27:41.000000', 'consum', 0.0220, 'lps'),
	(459595, 126, '2015-03-15 00:27:42.000000', 'consum', 0.0220, 'lps'),
	(459596, 126, '2015-03-15 00:27:43.000000', 'consum', 0.0219, 'lps'),
	(459597, 126, '2015-03-15 00:27:44.000000', 'consum', 0.0210, 'lps'),
	(459598, 126, '2015-03-15 00:27:45.000000', 'consum', 0.0211, 'lps'),
	(459599, 126, '2015-03-15 00:27:46.000000', 'consum', 0.0217, 'lps'),
	(459600, 126, '2015-03-15 00:27:47.000000', 'consum', 0.0215, 'lps'),
	(459601, 126, '2015-03-15 00:27:48.000000', 'consum', 0.0215, 'lps'),
	(459602, 126, '2015-03-15 00:27:49.000000', 'consum', 0.0218, 'lps'),
	(459603, 126, '2015-03-15 00:27:50.000000', 'consum', 0.0222, 'lps'),
	(459604, 126, '2015-03-15 00:27:51.000000', 'consum', 0.0217, 'lps'),
	(459605, 126, '2015-03-15 00:27:52.000000', 'consum', 0.0210, 'lps'),
	(459606, 126, '2015-03-15 00:27:53.000000', 'consum', 0.0218, 'lps'),
	(459607, 126, '2015-03-15 00:27:54.000000', 'consum', 0.0210, 'lps'),
	(459608, 126, '2015-03-15 00:27:55.000000', 'consum', 0.0216, 'lps'),
	(459609, 126, '2015-03-15 00:27:56.000000', 'consum', 0.0223, 'lps'),
	(459610, 126, '2015-03-15 00:27:57.000000', 'consum', 0.0216, 'lps'),
	(459611, 126, '2015-03-15 00:27:58.000000', 'consum', 0.0217, 'lps'),
	(459612, 126, '2015-03-15 00:27:59.000000', 'consum', 0.0212, 'lps'),
	(459613, 126, '2015-03-15 00:28:00.000000', 'consum', 0.0213, 'lps'),
	(459614, 126, '2015-03-15 00:28:01.000000', 'consum', 0.0222, 'lps'),
	(459615, 126, '2015-03-15 00:28:02.000000', 'consum', 0.0217, 'lps'),
	(459616, 126, '2015-03-15 00:28:03.000000', 'consum', 0.0212, 'lps'),
	(459617, 126, '2015-03-15 00:28:04.000000', 'consum', 0.0211, 'lps'),
	(459618, 126, '2015-03-15 00:28:05.000000', 'consum', 0.0210, 'lps'),
	(459619, 126, '2015-03-15 00:28:06.000000', 'consum', 0.0210, 'lps'),
	(459620, 126, '2015-03-15 00:28:07.000000', 'consum', 0.0223, 'lps'),
	(459621, 126, '2015-03-15 00:28:08.000000', 'consum', 0.0218, 'lps'),
	(459622, 126, '2015-03-15 00:28:09.000000', 'consum', 0.0212, 'lps'),
	(459623, 126, '2015-03-15 00:28:10.000000', 'consum', 0.0213, 'lps'),
	(459624, 126, '2015-03-15 00:28:11.000000', 'consum', 0.0217, 'lps'),
	(459625, 126, '2015-03-15 00:28:12.000000', 'consum', 0.0221, 'lps'),
	(459626, 126, '2015-03-15 00:28:13.000000', 'consum', 0.0219, 'lps'),
	(459627, 126, '2015-03-15 00:28:14.000000', 'consum', 0.0221, 'lps'),
	(459628, 126, '2015-03-15 00:28:15.000000', 'consum', 0.0213, 'lps'),
	(459629, 126, '2015-03-15 00:28:16.000000', 'consum', 0.0220, 'lps'),
	(459630, 126, '2015-03-15 00:28:17.000000', 'consum', 0.0222, 'lps'),
	(459631, 126, '2015-03-15 00:28:18.000000', 'consum', 0.0212, 'lps'),
	(459632, 126, '2015-03-15 00:28:19.000000', 'consum', 0.0212, 'lps'),
	(459633, 126, '2015-03-15 00:28:20.000000', 'consum', 0.0217, 'lps'),
	(459634, 126, '2015-03-15 00:28:21.000000', 'consum', 0.0223, 'lps'),
	(459635, 126, '2015-03-15 00:28:22.000000', 'consum', 0.0212, 'lps'),
	(459636, 126, '2015-03-15 00:28:23.000000', 'consum', 0.0211, 'lps'),
	(459637, 126, '2015-03-15 00:28:24.000000', 'consum', 0.0222, 'lps'),
	(459638, 126, '2015-03-15 00:28:25.000000', 'consum', 0.0211, 'lps'),
	(459639, 126, '2015-03-15 00:28:26.000000', 'consum', 0.0210, 'lps'),
	(459640, 126, '2015-03-15 00:28:27.000000', 'consum', 0.0222, 'lps'),
	(459641, 126, '2015-03-15 00:28:28.000000', 'consum', 0.0211, 'lps'),
	(459642, 126, '2015-03-15 00:28:29.000000', 'consum', 0.0211, 'lps'),
	(459643, 126, '2015-03-15 00:28:30.000000', 'consum', 0.0210, 'lps'),
	(459644, 126, '2015-03-15 00:28:31.000000', 'consum', 0.0210, 'lps'),
	(459645, 126, '2015-03-15 00:28:32.000000', 'consum', 0.0211, 'lps'),
	(459646, 126, '2015-03-15 00:28:33.000000', 'consum', 0.0212, 'lps'),
	(459647, 126, '2015-03-15 00:28:34.000000', 'consum', 0.0221, 'lps'),
	(459648, 126, '2015-03-15 00:28:35.000000', 'consum', 0.0215, 'lps'),
	(459649, 126, '2015-03-15 00:28:36.000000', 'consum', 0.0219, 'lps'),
	(459650, 126, '2015-03-15 00:28:37.000000', 'consum', 0.0223, 'lps'),
	(459651, 126, '2015-03-15 00:28:38.000000', 'consum', 0.0210, 'lps'),
	(459652, 126, '2015-03-15 00:28:39.000000', 'consum', 0.0210, 'lps'),
	(459653, 126, '2015-03-15 00:28:40.000000', 'consum', 0.0213, 'lps'),
	(459654, 126, '2015-03-15 00:28:41.000000', 'consum', 0.0210, 'lps'),
	(459655, 126, '2015-03-15 00:28:42.000000', 'consum', 0.0216, 'lps'),
	(459656, 126, '2015-03-15 00:28:43.000000', 'consum', 0.0213, 'lps'),
	(459657, 126, '2015-03-15 00:28:44.000000', 'consum', 0.0222, 'lps'),
	(459658, 126, '2015-03-15 00:28:45.000000', 'consum', 0.0221, 'lps'),
	(459659, 126, '2015-03-15 00:28:46.000000', 'consum', 0.0214, 'lps'),
	(459660, 126, '2015-03-15 00:28:47.000000', 'consum', 0.0213, 'lps'),
	(459661, 126, '2015-03-15 00:28:48.000000', 'consum', 0.0211, 'lps'),
	(459662, 126, '2015-03-15 00:28:49.000000', 'consum', 0.0221, 'lps'),
	(459663, 126, '2015-03-15 00:28:50.000000', 'consum', 0.0222, 'lps'),
	(459664, 126, '2015-03-15 00:28:51.000000', 'consum', 0.0221, 'lps'),
	(459665, 126, '2015-03-15 00:28:52.000000', 'consum', 0.0217, 'lps'),
	(459666, 126, '2015-03-15 00:28:53.000000', 'consum', 0.0213, 'lps'),
	(459667, 126, '2015-03-15 00:28:54.000000', 'consum', 0.0219, 'lps'),
	(459668, 126, '2015-03-15 00:28:55.000000', 'consum', 0.0220, 'lps'),
	(459669, 126, '2015-03-15 00:28:56.000000', 'consum', 0.0217, 'lps'),
	(459670, 126, '2015-03-15 00:28:57.000000', 'consum', 0.0216, 'lps'),
	(459671, 126, '2015-03-15 00:28:58.000000', 'consum', 0.0219, 'lps'),
	(459672, 126, '2015-03-15 00:28:59.000000', 'consum', 0.0210, 'lps'),
	(459673, 126, '2015-03-15 00:29:00.000000', 'consum', 0.0210, 'lps'),
	(459674, 126, '2015-03-15 00:29:01.000000', 'consum', 0.0210, 'lps'),
	(459675, 126, '2015-03-15 00:29:02.000000', 'consum', 0.0213, 'lps'),
	(459676, 126, '2015-03-15 00:29:03.000000', 'consum', 0.0223, 'lps'),
	(459677, 126, '2015-03-15 00:29:04.000000', 'consum', 0.0212, 'lps'),
	(459678, 126, '2015-03-15 00:29:05.000000', 'consum', 0.0222, 'lps'),
	(459679, 126, '2015-03-15 00:29:06.000000', 'consum', 0.0222, 'lps'),
	(459680, 126, '2015-03-15 00:29:07.000000', 'consum', 0.0219, 'lps'),
	(459681, 126, '2015-03-15 00:29:08.000000', 'consum', 0.0222, 'lps'),
	(459682, 126, '2015-03-15 00:29:09.000000', 'consum', 0.0217, 'lps'),
	(459683, 126, '2015-03-15 00:29:10.000000', 'consum', 0.0220, 'lps'),
	(459684, 126, '2015-03-15 00:29:11.000000', 'consum', 0.0213, 'lps'),
	(459685, 126, '2015-03-15 00:29:12.000000', 'consum', 0.0222, 'lps'),
	(459686, 126, '2015-03-15 00:29:13.000000', 'consum', 0.0221, 'lps'),
	(459687, 126, '2015-03-15 00:29:14.000000', 'consum', 0.0216, 'lps'),
	(459688, 126, '2015-03-15 00:29:15.000000', 'consum', 0.0220, 'lps'),
	(459689, 126, '2015-03-15 00:29:16.000000', 'consum', 0.0215, 'lps'),
	(459690, 126, '2015-03-15 00:29:17.000000', 'consum', 0.0221, 'lps'),
	(459691, 126, '2015-03-15 00:29:18.000000', 'consum', 0.0223, 'lps'),
	(459692, 126, '2015-03-15 00:29:19.000000', 'consum', 0.0213, 'lps'),
	(459693, 126, '2015-03-15 00:29:20.000000', 'consum', 0.0216, 'lps'),
	(459694, 126, '2015-03-15 00:29:21.000000', 'consum', 0.0218, 'lps'),
	(459695, 126, '2015-03-15 00:29:22.000000', 'consum', 0.0218, 'lps'),
	(459696, 126, '2015-03-15 00:29:23.000000', 'consum', 0.0214, 'lps'),
	(459697, 126, '2015-03-15 00:29:24.000000', 'consum', 0.0219, 'lps'),
	(459698, 126, '2015-03-15 00:29:25.000000', 'consum', 0.0218, 'lps'),
	(459699, 126, '2015-03-15 00:29:26.000000', 'consum', 0.0220, 'lps'),
	(459700, 126, '2015-03-15 00:29:27.000000', 'consum', 0.0210, 'lps'),
	(459701, 126, '2015-03-15 00:29:28.000000', 'consum', 0.0221, 'lps'),
	(459702, 126, '2015-03-15 00:29:29.000000', 'consum', 0.0210, 'lps'),
	(459703, 126, '2015-03-15 00:29:30.000000', 'consum', 0.0218, 'lps'),
	(459704, 126, '2015-03-15 00:29:31.000000', 'consum', 0.0223, 'lps'),
	(459705, 126, '2015-03-15 00:29:32.000000', 'consum', 0.0212, 'lps'),
	(459706, 126, '2015-03-15 00:29:33.000000', 'consum', 0.0223, 'lps'),
	(459707, 126, '2015-03-15 00:29:34.000000', 'consum', 0.0212, 'lps'),
	(459708, 126, '2015-03-15 00:29:35.000000', 'consum', 0.0211, 'lps'),
	(459709, 126, '2015-03-15 00:29:36.000000', 'consum', 0.0222, 'lps'),
	(459710, 126, '2015-03-15 00:29:37.000000', 'consum', 0.0211, 'lps'),
	(459711, 126, '2015-03-15 00:29:38.000000', 'consum', 0.0221, 'lps'),
	(459712, 126, '2015-03-15 00:29:39.000000', 'consum', 0.0222, 'lps'),
	(459713, 126, '2015-03-15 00:29:40.000000', 'consum', 0.0210, 'lps'),
	(459714, 126, '2015-03-15 00:29:41.000000', 'consum', 0.0217, 'lps'),
	(459715, 126, '2015-03-15 00:29:42.000000', 'consum', 0.0216, 'lps'),
	(459716, 126, '2015-03-15 00:29:43.000000', 'consum', 0.0220, 'lps'),
	(459717, 126, '2015-03-15 00:29:44.000000', 'consum', 0.0214, 'lps'),
	(459718, 126, '2015-03-15 00:29:45.000000', 'consum', 0.0215, 'lps'),
	(459719, 126, '2015-03-15 00:29:46.000000', 'consum', 0.0211, 'lps'),
	(459720, 126, '2015-03-15 00:29:47.000000', 'consum', 0.0215, 'lps'),
	(459721, 126, '2015-03-15 00:29:48.000000', 'consum', 0.0219, 'lps'),
	(459722, 126, '2015-03-15 00:29:49.000000', 'consum', 0.0212, 'lps'),
	(459723, 126, '2015-03-15 00:29:50.000000', 'consum', 0.0221, 'lps'),
	(459724, 126, '2015-03-15 00:29:51.000000', 'consum', 0.0218, 'lps'),
	(459725, 126, '2015-03-15 00:29:52.000000', 'consum', 0.0217, 'lps'),
	(459726, 126, '2015-03-15 00:29:53.000000', 'consum', 0.0223, 'lps'),
	(459727, 126, '2015-03-15 00:29:54.000000', 'consum', 0.0210, 'lps'),
	(459728, 126, '2015-03-15 00:29:55.000000', 'consum', 0.0216, 'lps'),
	(459729, 126, '2015-03-15 00:29:56.000000', 'consum', 0.0214, 'lps'),
	(459730, 126, '2015-03-15 00:29:57.000000', 'consum', 0.0223, 'lps'),
	(459731, 126, '2015-03-15 00:29:58.000000', 'consum', 0.0222, 'lps'),
	(459732, 126, '2015-03-15 00:29:59.000000', 'consum', 0.0217, 'lps'),
	(459733, 126, '2015-03-15 00:30:00.000000', 'consum', 0.0210, 'lps'),
	(459734, 126, '2015-03-15 00:30:01.000000', 'consum', 0.0216, 'lps'),
	(459735, 126, '2015-03-15 00:30:02.000000', 'consum', 0.0214, 'lps'),
	(459736, 126, '2015-03-15 00:30:03.000000', 'consum', 0.0211, 'lps'),
	(459737, 126, '2015-03-15 00:30:04.000000', 'consum', 0.0219, 'lps'),
	(459738, 126, '2015-03-15 00:30:05.000000', 'consum', 0.0223, 'lps'),
	(459739, 126, '2015-03-15 00:30:06.000000', 'consum', 0.0221, 'lps'),
	(459740, 126, '2015-03-15 00:30:07.000000', 'consum', 0.0215, 'lps'),
	(459741, 126, '2015-03-15 00:30:08.000000', 'consum', 0.0213, 'lps'),
	(459742, 126, '2015-03-15 00:30:09.000000', 'consum', 0.0211, 'lps'),
	(459743, 126, '2015-03-15 00:30:10.000000', 'consum', 0.0223, 'lps'),
	(459744, 126, '2015-03-15 00:30:11.000000', 'consum', 0.0214, 'lps'),
	(459745, 126, '2015-03-15 00:30:12.000000', 'consum', 0.0221, 'lps'),
	(459746, 126, '2015-03-15 00:30:13.000000', 'consum', 0.0213, 'lps'),
	(459747, 126, '2015-03-15 00:30:14.000000', 'consum', 0.0219, 'lps'),
	(459748, 126, '2015-03-15 00:30:15.000000', 'consum', 0.0218, 'lps'),
	(459749, 126, '2015-03-15 00:30:16.000000', 'consum', 0.0223, 'lps'),
	(459750, 126, '2015-03-15 00:30:17.000000', 'consum', 0.0212, 'lps'),
	(459751, 126, '2015-03-15 00:30:18.000000', 'consum', 0.0222, 'lps'),
	(459752, 126, '2015-03-15 00:30:19.000000', 'consum', 0.0210, 'lps'),
	(459753, 126, '2015-03-15 00:30:20.000000', 'consum', 0.0214, 'lps'),
	(459754, 126, '2015-03-15 00:30:21.000000', 'consum', 0.0220, 'lps'),
	(459755, 126, '2015-03-15 00:30:22.000000', 'consum', 0.0217, 'lps'),
	(459756, 126, '2015-03-15 00:30:23.000000', 'consum', 0.0218, 'lps'),
	(459757, 126, '2015-03-15 00:30:24.000000', 'consum', 0.0214, 'lps'),
	(459758, 126, '2015-03-15 00:30:25.000000', 'consum', 0.0219, 'lps'),
	(459759, 126, '2015-03-15 00:30:26.000000', 'consum', 0.0217, 'lps'),
	(459760, 126, '2015-03-15 00:30:27.000000', 'consum', 0.0216, 'lps'),
	(459761, 126, '2015-03-15 00:30:28.000000', 'consum', 0.0223, 'lps'),
	(459762, 126, '2015-03-15 00:30:29.000000', 'consum', 0.0215, 'lps'),
	(459763, 126, '2015-03-15 00:30:30.000000', 'consum', 0.0223, 'lps'),
	(459764, 126, '2015-03-15 00:30:31.000000', 'consum', 0.0217, 'lps'),
	(459765, 126, '2015-03-15 00:30:32.000000', 'consum', 0.0222, 'lps'),
	(459766, 126, '2015-03-15 00:30:33.000000', 'consum', 0.0222, 'lps'),
	(459767, 126, '2015-03-15 00:30:34.000000', 'consum', 0.0222, 'lps'),
	(459768, 126, '2015-03-15 00:30:35.000000', 'consum', 0.0218, 'lps'),
	(459769, 126, '2015-03-15 00:30:36.000000', 'consum', 0.0216, 'lps'),
	(459770, 126, '2015-03-15 00:30:37.000000', 'consum', 0.0217, 'lps'),
	(459771, 126, '2015-03-15 00:30:38.000000', 'consum', 0.0212, 'lps'),
	(459772, 126, '2015-03-15 00:30:39.000000', 'consum', 0.0214, 'lps'),
	(459773, 126, '2015-03-15 00:30:40.000000', 'consum', 0.0212, 'lps'),
	(459774, 126, '2015-03-15 00:30:41.000000', 'consum', 0.0222, 'lps'),
	(459775, 126, '2015-03-15 00:30:42.000000', 'consum', 0.0221, 'lps'),
	(459776, 126, '2015-03-15 00:30:43.000000', 'consum', 0.0216, 'lps'),
	(459777, 126, '2015-03-15 00:30:44.000000', 'consum', 0.0223, 'lps'),
	(459778, 126, '2015-03-15 00:30:45.000000', 'consum', 0.0213, 'lps'),
	(459779, 126, '2015-03-15 00:30:46.000000', 'consum', 0.0214, 'lps'),
	(459780, 126, '2015-03-15 00:30:47.000000', 'consum', 0.0210, 'lps'),
	(459781, 126, '2015-03-15 00:30:48.000000', 'consum', 0.0211, 'lps'),
	(459782, 126, '2015-03-15 00:30:49.000000', 'consum', 0.0214, 'lps'),
	(459783, 126, '2015-03-15 00:30:50.000000', 'consum', 0.0216, 'lps'),
	(459784, 126, '2015-03-15 00:30:51.000000', 'consum', 0.0212, 'lps'),
	(459785, 126, '2015-03-15 00:30:52.000000', 'consum', 0.0217, 'lps'),
	(459786, 126, '2015-03-15 00:30:53.000000', 'consum', 0.0214, 'lps'),
	(459787, 126, '2015-03-15 00:30:54.000000', 'consum', 0.0221, 'lps'),
	(459788, 126, '2015-03-15 00:30:55.000000', 'consum', 0.0213, 'lps'),
	(459789, 126, '2015-03-15 00:30:56.000000', 'consum', 0.0221, 'lps'),
	(459790, 126, '2015-03-15 00:30:57.000000', 'consum', 0.0212, 'lps'),
	(459791, 126, '2015-03-15 00:30:58.000000', 'consum', 0.0218, 'lps'),
	(459792, 126, '2015-03-15 00:30:59.000000', 'consum', 0.0218, 'lps'),
	(459793, 126, '2015-03-15 00:31:00.000000', 'consum', 0.0223, 'lps'),
	(459794, 126, '2015-03-15 00:31:01.000000', 'consum', 0.0210, 'lps'),
	(459795, 126, '2015-03-15 00:31:02.000000', 'consum', 0.0215, 'lps'),
	(459796, 126, '2015-03-15 00:31:03.000000', 'consum', 0.0221, 'lps'),
	(459797, 126, '2015-03-15 00:31:04.000000', 'consum', 0.0223, 'lps'),
	(459798, 126, '2015-03-15 00:31:05.000000', 'consum', 0.0212, 'lps'),
	(459799, 126, '2015-03-15 00:31:06.000000', 'consum', 0.0213, 'lps'),
	(459800, 126, '2015-03-15 00:31:07.000000', 'consum', 0.0217, 'lps'),
	(459801, 126, '2015-03-15 00:31:08.000000', 'consum', 0.0223, 'lps'),
	(459802, 126, '2015-03-15 00:31:09.000000', 'consum', 0.0211, 'lps'),
	(459803, 126, '2015-03-15 00:31:10.000000', 'consum', 0.0219, 'lps'),
	(459804, 126, '2015-03-15 00:31:11.000000', 'consum', 0.0212, 'lps'),
	(459805, 126, '2015-03-15 00:31:12.000000', 'consum', 0.0222, 'lps'),
	(459806, 126, '2015-03-15 00:31:13.000000', 'consum', 0.0221, 'lps'),
	(459807, 126, '2015-03-15 00:31:14.000000', 'consum', 0.0214, 'lps'),
	(459808, 126, '2015-03-15 00:31:15.000000', 'consum', 0.0214, 'lps'),
	(459809, 126, '2015-03-15 00:31:16.000000', 'consum', 0.0216, 'lps'),
	(459810, 126, '2015-03-15 00:31:17.000000', 'consum', 0.0215, 'lps'),
	(459811, 126, '2015-03-15 00:31:18.000000', 'consum', 0.0216, 'lps'),
	(459812, 126, '2015-03-15 00:31:19.000000', 'consum', 0.0212, 'lps'),
	(459813, 126, '2015-03-15 00:31:20.000000', 'consum', 0.0219, 'lps'),
	(459814, 126, '2015-03-15 00:31:21.000000', 'consum', 0.0219, 'lps'),
	(459815, 126, '2015-03-15 00:31:22.000000', 'consum', 0.0217, 'lps'),
	(459816, 126, '2015-03-15 00:31:23.000000', 'consum', 0.0219, 'lps'),
	(459817, 126, '2015-03-15 00:31:24.000000', 'consum', 0.0219, 'lps'),
	(459818, 126, '2015-03-15 00:31:25.000000', 'consum', 0.0213, 'lps'),
	(459819, 126, '2015-03-15 00:31:26.000000', 'consum', 0.0216, 'lps'),
	(459820, 126, '2015-03-15 00:31:27.000000', 'consum', 0.0214, 'lps'),
	(459821, 126, '2015-03-15 00:31:28.000000', 'consum', 0.0216, 'lps'),
	(459822, 126, '2015-03-15 00:31:29.000000', 'consum', 0.0213, 'lps'),
	(459823, 126, '2015-03-15 00:31:30.000000', 'consum', 0.0220, 'lps'),
	(459824, 126, '2015-03-15 00:31:31.000000', 'consum', 0.0223, 'lps'),
	(459825, 126, '2015-03-15 00:31:32.000000', 'consum', 0.0217, 'lps'),
	(459826, 126, '2015-03-15 00:31:33.000000', 'consum', 0.0220, 'lps'),
	(459827, 126, '2015-03-15 00:31:34.000000', 'consum', 0.0213, 'lps'),
	(459828, 126, '2015-03-15 00:31:35.000000', 'consum', 0.0210, 'lps'),
	(459829, 126, '2015-03-15 00:31:36.000000', 'consum', 0.0216, 'lps'),
	(459830, 126, '2015-03-15 00:31:37.000000', 'consum', 0.0210, 'lps'),
	(459831, 126, '2015-03-15 00:31:38.000000', 'consum', 0.0221, 'lps'),
	(459832, 126, '2015-03-15 00:31:39.000000', 'consum', 0.0210, 'lps'),
	(459833, 126, '2015-03-15 00:31:40.000000', 'consum', 0.0218, 'lps'),
	(459834, 126, '2015-03-15 00:31:41.000000', 'consum', 0.0223, 'lps'),
	(459835, 126, '2015-03-15 00:31:42.000000', 'consum', 0.0211, 'lps'),
	(459836, 126, '2015-03-15 00:31:43.000000', 'consum', 0.0216, 'lps'),
	(459837, 126, '2015-03-15 00:31:44.000000', 'consum', 0.0212, 'lps'),
	(459838, 126, '2015-03-15 00:31:45.000000', 'consum', 0.0216, 'lps'),
	(459839, 126, '2015-03-15 00:31:46.000000', 'consum', 0.0222, 'lps'),
	(459840, 126, '2015-03-15 00:31:47.000000', 'consum', 0.0222, 'lps'),
	(459841, 126, '2015-03-15 00:31:48.000000', 'consum', 0.0220, 'lps'),
	(459842, 126, '2015-03-15 00:31:49.000000', 'consum', 0.0213, 'lps'),
	(459843, 126, '2015-03-15 00:31:50.000000', 'consum', 0.0223, 'lps'),
	(459844, 126, '2015-03-15 00:31:51.000000', 'consum', 0.0223, 'lps'),
	(459845, 126, '2015-03-15 00:31:52.000000', 'consum', 0.0210, 'lps'),
	(459846, 126, '2015-03-15 00:31:53.000000', 'consum', 0.0213, 'lps'),
	(459847, 126, '2015-03-15 00:31:54.000000', 'consum', 0.0211, 'lps'),
	(459848, 126, '2015-03-15 00:31:55.000000', 'consum', 0.0220, 'lps'),
	(459849, 126, '2015-03-15 00:31:56.000000', 'consum', 0.0215, 'lps'),
	(459850, 126, '2015-03-15 00:31:57.000000', 'consum', 0.0221, 'lps'),
	(459851, 126, '2015-03-15 00:31:58.000000', 'consum', 0.0210, 'lps'),
	(459852, 126, '2015-03-15 00:31:59.000000', 'consum', 0.0218, 'lps'),
	(459853, 126, '2015-03-15 00:32:00.000000', 'consum', 0.0210, 'lps'),
	(459854, 126, '2015-03-15 00:32:01.000000', 'consum', 0.0212, 'lps'),
	(459855, 126, '2015-03-15 00:32:02.000000', 'consum', 0.0223, 'lps'),
	(459856, 126, '2015-03-15 00:32:03.000000', 'consum', 0.0212, 'lps'),
	(459857, 126, '2015-03-15 00:32:04.000000', 'consum', 0.0222, 'lps'),
	(459858, 126, '2015-03-15 00:32:05.000000', 'consum', 0.0210, 'lps'),
	(459859, 126, '2015-03-15 00:32:06.000000', 'consum', 0.0218, 'lps'),
	(459860, 126, '2015-03-15 00:32:07.000000', 'consum', 0.0220, 'lps'),
	(459861, 126, '2015-03-15 00:32:08.000000', 'consum', 0.0222, 'lps'),
	(459862, 126, '2015-03-15 00:32:09.000000', 'consum', 0.0215, 'lps'),
	(459863, 126, '2015-03-15 00:32:10.000000', 'consum', 0.0212, 'lps'),
	(459864, 126, '2015-03-15 00:32:11.000000', 'consum', 0.0222, 'lps'),
	(459865, 126, '2015-03-15 00:32:12.000000', 'consum', 0.0219, 'lps'),
	(459866, 126, '2015-03-15 00:32:13.000000', 'consum', 0.0220, 'lps'),
	(459867, 126, '2015-03-15 00:32:14.000000', 'consum', 0.0222, 'lps'),
	(459868, 126, '2015-03-15 00:32:15.000000', 'consum', 0.0210, 'lps'),
	(459869, 126, '2015-03-15 00:32:16.000000', 'consum', 0.0218, 'lps'),
	(459870, 126, '2015-03-15 00:32:17.000000', 'consum', 0.0220, 'lps'),
	(459871, 126, '2015-03-15 00:32:18.000000', 'consum', 0.0210, 'lps'),
	(459872, 126, '2015-03-15 00:32:19.000000', 'consum', 0.0220, 'lps'),
	(459873, 126, '2015-03-15 00:32:20.000000', 'consum', 0.0221, 'lps'),
	(459874, 126, '2015-03-15 00:32:21.000000', 'consum', 0.0223, 'lps'),
	(459875, 126, '2015-03-15 00:32:22.000000', 'consum', 0.0213, 'lps'),
	(459876, 126, '2015-03-15 00:32:23.000000', 'consum', 0.0216, 'lps'),
	(459877, 126, '2015-03-15 00:32:24.000000', 'consum', 0.0217, 'lps'),
	(459878, 126, '2015-03-15 00:32:25.000000', 'consum', 0.0212, 'lps'),
	(459879, 126, '2015-03-15 00:32:26.000000', 'consum', 0.0215, 'lps'),
	(459880, 126, '2015-03-15 00:32:27.000000', 'consum', 0.0216, 'lps'),
	(459881, 126, '2015-03-15 00:32:28.000000', 'consum', 0.0212, 'lps'),
	(459882, 126, '2015-03-15 00:32:29.000000', 'consum', 0.0215, 'lps'),
	(459883, 126, '2015-03-15 00:32:30.000000', 'consum', 0.0215, 'lps'),
	(459884, 126, '2015-03-15 00:32:31.000000', 'consum', 0.0222, 'lps'),
	(459885, 126, '2015-03-15 00:32:32.000000', 'consum', 0.0213, 'lps'),
	(459886, 126, '2015-03-15 00:32:33.000000', 'consum', 0.0219, 'lps'),
	(459887, 126, '2015-03-15 00:32:34.000000', 'consum', 0.0216, 'lps'),
	(459888, 126, '2015-03-15 00:32:35.000000', 'consum', 0.0215, 'lps'),
	(459889, 126, '2015-03-15 00:32:36.000000', 'consum', 0.0219, 'lps'),
	(459890, 126, '2015-03-15 00:32:37.000000', 'consum', 0.0210, 'lps'),
	(459891, 126, '2015-03-15 00:32:38.000000', 'consum', 0.0214, 'lps'),
	(459892, 126, '2015-03-15 00:32:39.000000', 'consum', 0.0214, 'lps'),
	(459893, 126, '2015-03-15 00:32:40.000000', 'consum', 0.0217, 'lps'),
	(459894, 126, '2015-03-15 00:32:41.000000', 'consum', 0.0223, 'lps'),
	(459895, 126, '2015-03-15 00:32:42.000000', 'consum', 0.0210, 'lps'),
	(459896, 126, '2015-03-15 00:32:43.000000', 'consum', 0.0213, 'lps'),
	(459897, 126, '2015-03-15 00:32:44.000000', 'consum', 0.0211, 'lps'),
	(459898, 126, '2015-03-15 00:32:45.000000', 'consum', 0.0220, 'lps'),
	(459899, 126, '2015-03-15 00:32:46.000000', 'consum', 0.0217, 'lps'),
	(459900, 126, '2015-03-15 00:32:47.000000', 'consum', 0.0217, 'lps'),
	(459901, 126, '2015-03-15 00:32:48.000000', 'consum', 0.0210, 'lps'),
	(459902, 126, '2015-03-15 00:32:49.000000', 'consum', 0.0219, 'lps'),
	(459903, 126, '2015-03-15 00:32:50.000000', 'consum', 0.0211, 'lps'),
	(459904, 126, '2015-03-15 00:32:51.000000', 'consum', 0.0219, 'lps'),
	(459905, 126, '2015-03-15 00:32:52.000000', 'consum', 0.0210, 'lps'),
	(459906, 126, '2015-03-15 00:32:53.000000', 'consum', 0.0212, 'lps'),
	(459907, 126, '2015-03-15 00:32:54.000000', 'consum', 0.0219, 'lps'),
	(459908, 126, '2015-03-15 00:32:55.000000', 'consum', 0.0223, 'lps'),
	(459909, 126, '2015-03-15 00:32:56.000000', 'consum', 0.0218, 'lps'),
	(459910, 126, '2015-03-15 00:32:57.000000', 'consum', 0.0214, 'lps'),
	(459911, 126, '2015-03-15 00:32:58.000000', 'consum', 0.0219, 'lps'),
	(459912, 126, '2015-03-15 00:32:59.000000', 'consum', 0.0215, 'lps'),
	(459913, 126, '2015-03-15 00:33:00.000000', 'consum', 0.0211, 'lps'),
	(459914, 126, '2015-03-15 00:33:01.000000', 'consum', 0.0211, 'lps'),
	(459915, 126, '2015-03-15 00:33:02.000000', 'consum', 0.0215, 'lps'),
	(459916, 126, '2015-03-15 00:33:03.000000', 'consum', 0.0218, 'lps'),
	(459917, 126, '2015-03-15 00:33:04.000000', 'consum', 0.0222, 'lps'),
	(459918, 126, '2015-03-15 00:33:05.000000', 'consum', 0.0218, 'lps'),
	(459919, 126, '2015-03-15 00:33:06.000000', 'consum', 0.0216, 'lps'),
	(459920, 126, '2015-03-15 00:33:07.000000', 'consum', 0.0214, 'lps'),
	(459921, 126, '2015-03-15 00:33:08.000000', 'consum', 0.0216, 'lps'),
	(459922, 126, '2015-03-15 00:33:09.000000', 'consum', 0.0211, 'lps'),
	(459923, 126, '2015-03-15 00:33:10.000000', 'consum', 0.0214, 'lps'),
	(459924, 126, '2015-03-15 00:33:11.000000', 'consum', 0.0211, 'lps'),
	(459925, 126, '2015-03-15 00:33:12.000000', 'consum', 0.0220, 'lps'),
	(459926, 126, '2015-03-15 00:33:13.000000', 'consum', 0.0216, 'lps'),
	(459927, 126, '2015-03-15 00:33:14.000000', 'consum', 0.0222, 'lps'),
	(459928, 126, '2015-03-15 00:33:15.000000', 'consum', 0.0210, 'lps'),
	(459929, 126, '2015-03-15 00:33:16.000000', 'consum', 0.0217, 'lps'),
	(459930, 126, '2015-03-15 00:33:17.000000', 'consum', 0.0218, 'lps'),
	(459931, 126, '2015-03-15 00:33:18.000000', 'consum', 0.0215, 'lps'),
	(459932, 126, '2015-03-15 00:33:19.000000', 'consum', 0.0211, 'lps'),
	(459933, 126, '2015-03-15 00:33:20.000000', 'consum', 0.0215, 'lps'),
	(459934, 126, '2015-03-15 00:33:21.000000', 'consum', 0.0217, 'lps'),
	(459935, 126, '2015-03-15 00:33:22.000000', 'consum', 0.0218, 'lps'),
	(459936, 126, '2015-03-15 00:33:23.000000', 'consum', 0.0215, 'lps'),
	(459937, 126, '2015-03-15 00:33:24.000000', 'consum', 0.0213, 'lps'),
	(459938, 126, '2015-03-15 00:33:25.000000', 'consum', 0.0210, 'lps'),
	(459939, 126, '2015-03-15 00:33:26.000000', 'consum', 0.0216, 'lps'),
	(459940, 126, '2015-03-15 00:33:27.000000', 'consum', 0.0210, 'lps'),
	(459941, 126, '2015-03-15 00:33:28.000000', 'consum', 0.0221, 'lps'),
	(459942, 126, '2015-03-15 00:33:29.000000', 'consum', 0.0212, 'lps'),
	(459943, 126, '2015-03-15 00:33:30.000000', 'consum', 0.0215, 'lps'),
	(459944, 126, '2015-03-15 00:33:31.000000', 'consum', 0.0214, 'lps'),
	(459945, 126, '2015-03-15 00:33:32.000000', 'consum', 0.0215, 'lps'),
	(459946, 126, '2015-03-15 00:33:33.000000', 'consum', 0.0222, 'lps'),
	(459947, 126, '2015-03-15 00:33:34.000000', 'consum', 0.0216, 'lps'),
	(459948, 126, '2015-03-15 00:33:35.000000', 'consum', 0.0217, 'lps'),
	(459949, 126, '2015-03-15 00:33:36.000000', 'consum', 0.0216, 'lps'),
	(459950, 126, '2015-03-15 00:33:37.000000', 'consum', 0.0219, 'lps'),
	(459951, 126, '2015-03-15 00:33:38.000000', 'consum', 0.0221, 'lps'),
	(459952, 126, '2015-03-15 00:33:39.000000', 'consum', 0.0211, 'lps'),
	(459953, 126, '2015-03-15 00:33:40.000000', 'consum', 0.0211, 'lps'),
	(459954, 126, '2015-03-15 00:33:41.000000', 'consum', 0.0213, 'lps'),
	(459955, 126, '2015-03-15 00:33:42.000000', 'consum', 0.0221, 'lps'),
	(459956, 126, '2015-03-15 00:33:43.000000', 'consum', 0.0214, 'lps'),
	(459957, 126, '2015-03-15 00:33:44.000000', 'consum', 0.0214, 'lps'),
	(459958, 126, '2015-03-15 00:33:45.000000', 'consum', 0.0216, 'lps'),
	(459959, 126, '2015-03-15 00:33:46.000000', 'consum', 0.0216, 'lps'),
	(459960, 126, '2015-03-15 00:33:47.000000', 'consum', 0.0222, 'lps'),
	(459961, 126, '2015-03-15 00:33:48.000000', 'consum', 0.0223, 'lps'),
	(459962, 126, '2015-03-15 00:33:49.000000', 'consum', 0.0212, 'lps'),
	(459963, 126, '2015-03-15 00:33:50.000000', 'consum', 0.0210, 'lps'),
	(459964, 126, '2015-03-15 00:33:51.000000', 'consum', 0.0218, 'lps'),
	(459965, 126, '2015-03-15 00:33:52.000000', 'consum', 0.0223, 'lps'),
	(459966, 126, '2015-03-15 00:33:53.000000', 'consum', 0.0210, 'lps'),
	(459967, 126, '2015-03-15 00:33:54.000000', 'consum', 0.0213, 'lps'),
	(459968, 126, '2015-03-15 00:33:55.000000', 'consum', 0.0211, 'lps'),
	(459969, 126, '2015-03-15 00:33:56.000000', 'consum', 0.0223, 'lps'),
	(459970, 126, '2015-03-15 00:33:57.000000', 'consum', 0.0215, 'lps'),
	(459971, 126, '2015-03-15 00:33:58.000000', 'consum', 0.0210, 'lps'),
	(459972, 126, '2015-03-15 00:33:59.000000', 'consum', 0.0212, 'lps'),
	(459973, 126, '2015-03-15 00:34:00.000000', 'consum', 0.0219, 'lps'),
	(459974, 126, '2015-03-15 00:34:01.000000', 'consum', 0.0222, 'lps'),
	(459975, 126, '2015-03-15 00:34:02.000000', 'consum', 0.0214, 'lps'),
	(459976, 126, '2015-03-15 00:34:03.000000', 'consum', 0.0222, 'lps'),
	(459977, 126, '2015-03-15 00:34:04.000000', 'consum', 0.0216, 'lps'),
	(459978, 126, '2015-03-15 00:34:05.000000', 'consum', 0.0218, 'lps'),
	(459979, 126, '2015-03-15 00:34:06.000000', 'consum', 0.0217, 'lps'),
	(459980, 126, '2015-03-15 00:34:07.000000', 'consum', 0.0211, 'lps'),
	(459981, 126, '2015-03-15 00:34:08.000000', 'consum', 0.0222, 'lps'),
	(459982, 126, '2015-03-15 00:34:09.000000', 'consum', 0.0212, 'lps'),
	(459983, 126, '2015-03-15 00:34:10.000000', 'consum', 0.0212, 'lps'),
	(459984, 126, '2015-03-15 00:34:11.000000', 'consum', 0.0214, 'lps'),
	(459985, 126, '2015-03-15 00:34:12.000000', 'consum', 0.0211, 'lps'),
	(459986, 126, '2015-03-15 00:34:13.000000', 'consum', 0.0219, 'lps'),
	(459987, 126, '2015-03-15 00:34:14.000000', 'consum', 0.0223, 'lps'),
	(459988, 126, '2015-03-15 00:34:15.000000', 'consum', 0.0221, 'lps'),
	(459989, 126, '2015-03-15 00:34:16.000000', 'consum', 0.0212, 'lps'),
	(459990, 126, '2015-03-15 00:34:17.000000', 'consum', 0.0216, 'lps'),
	(459991, 126, '2015-03-15 00:34:18.000000', 'consum', 0.0221, 'lps'),
	(459992, 126, '2015-03-15 00:34:19.000000', 'consum', 0.0217, 'lps'),
	(459993, 126, '2015-03-15 00:34:20.000000', 'consum', 0.0216, 'lps'),
	(459994, 126, '2015-03-15 00:34:21.000000', 'consum', 0.0216, 'lps'),
	(459995, 126, '2015-03-15 00:34:22.000000', 'consum', 0.0211, 'lps'),
	(459996, 126, '2015-03-15 00:34:23.000000', 'consum', 0.0211, 'lps'),
	(459997, 126, '2015-03-15 00:34:24.000000', 'consum', 0.0211, 'lps'),
	(459998, 126, '2015-03-15 00:34:25.000000', 'consum', 0.0214, 'lps'),
	(459999, 126, '2015-03-15 00:34:26.000000', 'consum', 0.0215, 'lps'),
	(460000, 126, '2015-03-15 00:34:27.000000', 'consum', 0.0223, 'lps'),
	(460001, 126, '2015-03-15 00:34:28.000000', 'consum', 0.0219, 'lps'),
	(460002, 126, '2015-03-15 00:34:29.000000', 'consum', 0.0215, 'lps'),
	(460003, 126, '2015-03-15 00:34:30.000000', 'consum', 0.0211, 'lps'),
	(460004, 126, '2015-03-15 00:34:31.000000', 'consum', 0.0211, 'lps'),
	(460005, 126, '2015-03-15 00:34:32.000000', 'consum', 0.0216, 'lps'),
	(460006, 126, '2015-03-15 00:34:33.000000', 'consum', 0.0220, 'lps'),
	(460007, 126, '2015-03-15 00:34:34.000000', 'consum', 0.0218, 'lps'),
	(460008, 126, '2015-03-15 00:34:35.000000', 'consum', 0.0218, 'lps'),
	(460009, 126, '2015-03-15 00:34:36.000000', 'consum', 0.0215, 'lps'),
	(460010, 126, '2015-03-15 00:34:37.000000', 'consum', 0.0210, 'lps'),
	(460011, 126, '2015-03-15 00:34:38.000000', 'consum', 0.0222, 'lps'),
	(460012, 126, '2015-03-15 00:34:39.000000', 'consum', 0.0217, 'lps'),
	(460013, 126, '2015-03-15 00:34:40.000000', 'consum', 0.0222, 'lps'),
	(460014, 126, '2015-03-15 00:34:41.000000', 'consum', 0.0222, 'lps'),
	(460015, 126, '2015-03-15 00:34:42.000000', 'consum', 0.0218, 'lps'),
	(460016, 126, '2015-03-15 00:34:43.000000', 'consum', 0.0218, 'lps'),
	(460017, 126, '2015-03-15 00:34:44.000000', 'consum', 0.0211, 'lps'),
	(460018, 126, '2015-03-15 00:34:45.000000', 'consum', 0.0218, 'lps'),
	(460019, 126, '2015-03-15 00:34:46.000000', 'consum', 0.0221, 'lps'),
	(460020, 126, '2015-03-15 00:34:47.000000', 'consum', 0.0214, 'lps'),
	(460021, 126, '2015-03-15 00:34:48.000000', 'consum', 0.0213, 'lps'),
	(460022, 126, '2015-03-15 00:34:49.000000', 'consum', 0.0211, 'lps'),
	(460023, 126, '2015-03-15 00:34:50.000000', 'consum', 0.0221, 'lps'),
	(460024, 126, '2015-03-15 00:34:51.000000', 'consum', 0.0221, 'lps'),
	(460025, 126, '2015-03-15 00:34:52.000000', 'consum', 0.0218, 'lps'),
	(460026, 126, '2015-03-15 00:34:53.000000', 'consum', 0.0216, 'lps'),
	(460027, 126, '2015-03-15 00:34:54.000000', 'consum', 0.0219, 'lps'),
	(460028, 126, '2015-03-15 00:34:55.000000', 'consum', 0.0222, 'lps'),
	(460029, 126, '2015-03-15 00:34:56.000000', 'consum', 0.0215, 'lps'),
	(460030, 126, '2015-03-15 00:34:57.000000', 'consum', 0.0215, 'lps'),
	(460031, 126, '2015-03-15 00:34:58.000000', 'consum', 0.0221, 'lps'),
	(460032, 126, '2015-03-15 00:34:59.000000', 'consum', 0.0223, 'lps'),
	(460033, 126, '2015-03-15 00:35:00.000000', 'consum', 0.0213, 'lps'),
	(460034, 126, '2015-03-15 00:35:01.000000', 'consum', 0.0214, 'lps'),
	(460035, 126, '2015-03-15 00:35:02.000000', 'consum', 0.0222, 'lps'),
	(460036, 126, '2015-03-15 00:35:03.000000', 'consum', 0.0217, 'lps'),
	(460037, 126, '2015-03-15 00:35:04.000000', 'consum', 0.0211, 'lps'),
	(460038, 126, '2015-03-15 00:35:05.000000', 'consum', 0.0222, 'lps'),
	(460039, 126, '2015-03-15 00:35:06.000000', 'consum', 0.0212, 'lps'),
	(460040, 126, '2015-03-15 00:35:07.000000', 'consum', 0.0213, 'lps'),
	(460041, 126, '2015-03-15 00:35:08.000000', 'consum', 0.0220, 'lps'),
	(460042, 126, '2015-03-15 00:35:09.000000', 'consum', 0.0221, 'lps'),
	(460043, 126, '2015-03-15 00:35:10.000000', 'consum', 0.0223, 'lps'),
	(460044, 126, '2015-03-15 00:35:11.000000', 'consum', 0.0214, 'lps'),
	(460045, 126, '2015-03-15 00:35:12.000000', 'consum', 0.0220, 'lps'),
	(460046, 126, '2015-03-15 00:35:13.000000', 'consum', 0.0222, 'lps'),
	(460047, 126, '2015-03-15 00:35:14.000000', 'consum', 0.0210, 'lps'),
	(460048, 126, '2015-03-15 00:35:15.000000', 'consum', 0.0219, 'lps'),
	(460049, 126, '2015-03-15 00:35:16.000000', 'consum', 0.0213, 'lps'),
	(460050, 126, '2015-03-15 00:35:17.000000', 'consum', 0.0210, 'lps'),
	(460051, 126, '2015-03-15 00:35:18.000000', 'consum', 0.0218, 'lps'),
	(460052, 126, '2015-03-15 00:35:19.000000', 'consum', 0.0222, 'lps'),
	(460053, 126, '2015-03-15 00:35:20.000000', 'consum', 0.0219, 'lps'),
	(460054, 126, '2015-03-15 00:35:21.000000', 'consum', 0.0217, 'lps'),
	(460055, 126, '2015-03-15 00:35:22.000000', 'consum', 0.0220, 'lps'),
	(460056, 126, '2015-03-15 00:35:23.000000', 'consum', 0.0210, 'lps'),
	(460057, 126, '2015-03-15 00:35:24.000000', 'consum', 0.0212, 'lps'),
	(460058, 126, '2015-03-15 00:35:25.000000', 'consum', 0.0217, 'lps'),
	(460059, 126, '2015-03-15 00:35:26.000000', 'consum', 0.0214, 'lps'),
	(460060, 126, '2015-03-15 00:35:27.000000', 'consum', 0.0221, 'lps'),
	(460061, 126, '2015-03-15 00:35:28.000000', 'consum', 0.0214, 'lps'),
	(460062, 126, '2015-03-15 00:35:29.000000', 'consum', 0.0213, 'lps'),
	(460063, 126, '2015-03-15 00:35:30.000000', 'consum', 0.0210, 'lps'),
	(460064, 126, '2015-03-15 00:35:31.000000', 'consum', 0.0218, 'lps'),
	(460065, 126, '2015-03-15 00:35:32.000000', 'consum', 0.0221, 'lps'),
	(460066, 126, '2015-03-15 00:35:33.000000', 'consum', 0.0216, 'lps'),
	(460067, 126, '2015-03-15 00:35:34.000000', 'consum', 0.0220, 'lps'),
	(460068, 126, '2015-03-15 00:35:35.000000', 'consum', 0.0215, 'lps'),
	(460069, 126, '2015-03-15 00:35:36.000000', 'consum', 0.0218, 'lps'),
	(460070, 126, '2015-03-15 00:35:37.000000', 'consum', 0.0220, 'lps'),
	(460071, 126, '2015-03-15 00:35:38.000000', 'consum', 0.0211, 'lps'),
	(460072, 126, '2015-03-15 00:35:39.000000', 'consum', 0.0215, 'lps'),
	(460073, 126, '2015-03-15 00:35:40.000000', 'consum', 0.0217, 'lps'),
	(460074, 126, '2015-03-15 00:35:41.000000', 'consum', 0.0217, 'lps'),
	(460075, 126, '2015-03-15 00:35:42.000000', 'consum', 0.0222, 'lps'),
	(460076, 126, '2015-03-15 00:35:43.000000', 'consum', 0.0210, 'lps'),
	(460077, 126, '2015-03-15 00:35:44.000000', 'consum', 0.0214, 'lps'),
	(460078, 126, '2015-03-15 00:35:45.000000', 'consum', 0.0217, 'lps'),
	(460079, 126, '2015-03-15 00:35:46.000000', 'consum', 0.0220, 'lps'),
	(460080, 126, '2015-03-15 00:35:47.000000', 'consum', 0.0214, 'lps'),
	(460081, 126, '2015-03-15 00:35:48.000000', 'consum', 0.0211, 'lps'),
	(460082, 126, '2015-03-15 00:35:49.000000', 'consum', 0.0218, 'lps'),
	(460083, 126, '2015-03-15 00:35:50.000000', 'consum', 0.0219, 'lps'),
	(460084, 126, '2015-03-15 00:35:51.000000', 'consum', 0.0220, 'lps'),
	(460085, 126, '2015-03-15 00:35:52.000000', 'consum', 0.0217, 'lps'),
	(460086, 126, '2015-03-15 00:35:53.000000', 'consum', 0.0216, 'lps'),
	(460087, 126, '2015-03-15 00:35:54.000000', 'consum', 0.0219, 'lps'),
	(460088, 126, '2015-03-15 00:35:55.000000', 'consum', 0.0223, 'lps'),
	(460089, 126, '2015-03-15 00:35:56.000000', 'consum', 0.0221, 'lps'),
	(460090, 126, '2015-03-15 00:35:57.000000', 'consum', 0.0212, 'lps'),
	(460091, 126, '2015-03-15 00:35:58.000000', 'consum', 0.0216, 'lps'),
	(460092, 126, '2015-03-15 00:35:59.000000', 'consum', 0.0219, 'lps'),
	(460093, 126, '2015-03-15 00:36:00.000000', 'consum', 0.0211, 'lps'),
	(460094, 126, '2015-03-15 00:36:01.000000', 'consum', 0.0216, 'lps'),
	(460095, 126, '2015-03-15 00:36:02.000000', 'consum', 0.0211, 'lps'),
	(460096, 126, '2015-03-15 00:36:03.000000', 'consum', 0.0210, 'lps'),
	(460097, 126, '2015-03-15 00:36:04.000000', 'consum', 0.0221, 'lps'),
	(460098, 126, '2015-03-15 00:36:05.000000', 'consum', 0.0211, 'lps'),
	(460099, 126, '2015-03-15 00:36:06.000000', 'consum', 0.0211, 'lps'),
	(460100, 126, '2015-03-15 00:36:07.000000', 'consum', 0.0213, 'lps'),
	(460101, 126, '2015-03-15 00:36:08.000000', 'consum', 0.0222, 'lps'),
	(460102, 126, '2015-03-15 00:36:09.000000', 'consum', 0.0219, 'lps'),
	(460103, 126, '2015-03-15 00:36:10.000000', 'consum', 0.0219, 'lps'),
	(460104, 126, '2015-03-15 00:36:11.000000', 'consum', 0.0216, 'lps'),
	(460105, 126, '2015-03-15 00:36:12.000000', 'consum', 0.0212, 'lps'),
	(460106, 126, '2015-03-15 00:36:13.000000', 'consum', 0.0218, 'lps'),
	(460107, 126, '2015-03-15 00:36:14.000000', 'consum', 0.0216, 'lps'),
	(460108, 126, '2015-03-15 00:36:15.000000', 'consum', 0.0215, 'lps'),
	(460109, 126, '2015-03-15 00:36:16.000000', 'consum', 0.0220, 'lps'),
	(460110, 126, '2015-03-15 00:36:17.000000', 'consum', 0.0218, 'lps'),
	(460111, 126, '2015-03-15 00:36:18.000000', 'consum', 0.0218, 'lps'),
	(460112, 126, '2015-03-15 00:36:19.000000', 'consum', 0.0215, 'lps'),
	(460113, 126, '2015-03-15 00:36:20.000000', 'consum', 0.0223, 'lps'),
	(460114, 126, '2015-03-15 00:36:21.000000', 'consum', 0.0221, 'lps'),
	(460115, 126, '2015-03-15 00:36:22.000000', 'consum', 0.0211, 'lps'),
	(460116, 126, '2015-03-15 00:36:23.000000', 'consum', 0.0213, 'lps'),
	(460117, 126, '2015-03-15 00:36:24.000000', 'consum', 0.0220, 'lps'),
	(460118, 126, '2015-03-15 00:36:25.000000', 'consum', 0.0211, 'lps'),
	(460119, 126, '2015-03-15 00:36:26.000000', 'consum', 0.0213, 'lps'),
	(460120, 126, '2015-03-15 00:36:27.000000', 'consum', 0.0210, 'lps'),
	(460121, 126, '2015-03-15 00:36:28.000000', 'consum', 0.0213, 'lps'),
	(460122, 126, '2015-03-15 00:36:29.000000', 'consum', 0.0212, 'lps'),
	(460123, 126, '2015-03-15 00:36:30.000000', 'consum', 0.0210, 'lps'),
	(460124, 126, '2015-03-15 00:36:31.000000', 'consum', 0.0219, 'lps'),
	(460125, 126, '2015-03-15 00:36:32.000000', 'consum', 0.0215, 'lps'),
	(460126, 126, '2015-03-15 00:36:33.000000', 'consum', 0.0223, 'lps'),
	(460127, 126, '2015-03-15 00:36:34.000000', 'consum', 0.0216, 'lps'),
	(460128, 126, '2015-03-15 00:36:35.000000', 'consum', 0.0217, 'lps'),
	(460129, 126, '2015-03-15 00:36:36.000000', 'consum', 0.0213, 'lps'),
	(460130, 126, '2015-03-15 00:36:37.000000', 'consum', 0.0217, 'lps'),
	(460131, 126, '2015-03-15 00:36:38.000000', 'consum', 0.0210, 'lps'),
	(460132, 126, '2015-03-15 00:36:39.000000', 'consum', 0.0219, 'lps'),
	(460133, 126, '2015-03-15 00:36:40.000000', 'consum', 0.0211, 'lps'),
	(460134, 126, '2015-03-15 00:36:41.000000', 'consum', 0.0216, 'lps'),
	(460135, 126, '2015-03-15 00:36:42.000000', 'consum', 0.0223, 'lps'),
	(460136, 126, '2015-03-15 00:36:43.000000', 'consum', 0.0218, 'lps'),
	(460137, 126, '2015-03-15 00:36:44.000000', 'consum', 0.0223, 'lps'),
	(460138, 126, '2015-03-15 00:36:45.000000', 'consum', 0.0210, 'lps'),
	(460139, 126, '2015-03-15 00:36:46.000000', 'consum', 0.0213, 'lps'),
	(460140, 126, '2015-03-15 00:36:47.000000', 'consum', 0.0214, 'lps'),
	(460141, 126, '2015-03-15 00:36:48.000000', 'consum', 0.0218, 'lps'),
	(460142, 126, '2015-03-15 00:36:49.000000', 'consum', 0.0214, 'lps'),
	(460143, 126, '2015-03-15 00:36:50.000000', 'consum', 0.0218, 'lps'),
	(460144, 126, '2015-03-15 00:36:51.000000', 'consum', 0.0213, 'lps'),
	(460145, 126, '2015-03-15 00:36:52.000000', 'consum', 0.0214, 'lps'),
	(460146, 126, '2015-03-15 00:36:53.000000', 'consum', 0.0223, 'lps'),
	(460147, 126, '2015-03-15 00:36:54.000000', 'consum', 0.0219, 'lps'),
	(460148, 126, '2015-03-15 00:36:55.000000', 'consum', 0.0216, 'lps'),
	(460149, 126, '2015-03-15 00:36:56.000000', 'consum', 0.0216, 'lps'),
	(460150, 126, '2015-03-15 00:36:57.000000', 'consum', 0.0220, 'lps'),
	(460151, 126, '2015-03-15 00:36:58.000000', 'consum', 0.0214, 'lps'),
	(460152, 126, '2015-03-15 00:36:59.000000', 'consum', 0.0214, 'lps'),
	(460153, 126, '2015-03-15 00:37:00.000000', 'consum', 0.0220, 'lps'),
	(460154, 126, '2015-03-15 00:37:01.000000', 'consum', 0.0220, 'lps'),
	(460155, 126, '2015-03-15 00:37:02.000000', 'consum', 0.0217, 'lps'),
	(460156, 126, '2015-03-15 00:37:03.000000', 'consum', 0.0215, 'lps'),
	(460157, 126, '2015-03-15 00:37:04.000000', 'consum', 0.0213, 'lps'),
	(460158, 126, '2015-03-15 00:37:05.000000', 'consum', 0.0211, 'lps'),
	(460159, 126, '2015-03-15 00:37:06.000000', 'consum', 0.0221, 'lps'),
	(460160, 126, '2015-03-15 00:37:07.000000', 'consum', 0.0219, 'lps'),
	(460161, 126, '2015-03-15 00:37:08.000000', 'consum', 0.0223, 'lps'),
	(460162, 126, '2015-03-15 00:37:09.000000', 'consum', 0.0219, 'lps'),
	(460163, 126, '2015-03-15 00:37:10.000000', 'consum', 0.0217, 'lps'),
	(460164, 126, '2015-03-15 00:37:11.000000', 'consum', 0.0219, 'lps'),
	(460165, 126, '2015-03-15 00:37:12.000000', 'consum', 0.0218, 'lps'),
	(460166, 126, '2015-03-15 00:37:13.000000', 'consum', 0.0213, 'lps'),
	(460167, 126, '2015-03-15 00:37:14.000000', 'consum', 0.0214, 'lps'),
	(460168, 126, '2015-03-15 00:37:15.000000', 'consum', 0.0223, 'lps'),
	(460169, 126, '2015-03-15 00:37:16.000000', 'consum', 0.0219, 'lps'),
	(460170, 126, '2015-03-15 00:37:17.000000', 'consum', 0.0219, 'lps'),
	(460171, 126, '2015-03-15 00:37:18.000000', 'consum', 0.0215, 'lps'),
	(460172, 126, '2015-03-15 00:37:19.000000', 'consum', 0.0220, 'lps'),
	(460173, 126, '2015-03-15 00:37:20.000000', 'consum', 0.0219, 'lps'),
	(460174, 126, '2015-03-15 00:37:21.000000', 'consum', 0.0210, 'lps'),
	(460175, 126, '2015-03-15 00:37:22.000000', 'consum', 0.0210, 'lps'),
	(460176, 126, '2015-03-15 00:37:23.000000', 'consum', 0.0213, 'lps'),
	(460177, 126, '2015-03-15 00:37:24.000000', 'consum', 0.0211, 'lps'),
	(460178, 126, '2015-03-15 00:37:25.000000', 'consum', 0.0221, 'lps'),
	(460179, 126, '2015-03-15 00:37:26.000000', 'consum', 0.0221, 'lps'),
	(460180, 126, '2015-03-15 00:37:27.000000', 'consum', 0.0218, 'lps'),
	(460181, 126, '2015-03-15 00:37:28.000000', 'consum', 0.0216, 'lps'),
	(460182, 126, '2015-03-15 00:37:29.000000', 'consum', 0.0219, 'lps'),
	(460183, 126, '2015-03-15 00:37:30.000000', 'consum', 0.0222, 'lps'),
	(460184, 126, '2015-03-15 00:37:31.000000', 'consum', 0.0217, 'lps'),
	(460185, 126, '2015-03-15 00:37:32.000000', 'consum', 0.0222, 'lps'),
	(460186, 126, '2015-03-15 00:37:33.000000', 'consum', 0.0223, 'lps'),
	(460187, 126, '2015-03-15 00:37:34.000000', 'consum', 0.0211, 'lps'),
	(460188, 126, '2015-03-15 00:37:35.000000', 'consum', 0.0219, 'lps'),
	(460189, 126, '2015-03-15 00:37:36.000000', 'consum', 0.0212, 'lps'),
	(460190, 126, '2015-03-15 00:37:37.000000', 'consum', 0.0219, 'lps'),
	(460191, 126, '2015-03-15 00:37:38.000000', 'consum', 0.0222, 'lps'),
	(460192, 126, '2015-03-15 00:37:39.000000', 'consum', 0.0214, 'lps'),
	(460193, 126, '2015-03-15 00:37:40.000000', 'consum', 0.0223, 'lps'),
	(460194, 126, '2015-03-15 00:37:41.000000', 'consum', 0.0222, 'lps'),
	(460195, 126, '2015-03-15 00:37:42.000000', 'consum', 0.0217, 'lps'),
	(460196, 126, '2015-03-15 00:37:43.000000', 'consum', 0.0211, 'lps'),
	(460197, 126, '2015-03-15 00:37:44.000000', 'consum', 0.0223, 'lps'),
	(460198, 126, '2015-03-15 00:37:45.000000', 'consum', 0.0215, 'lps'),
	(460199, 126, '2015-03-15 00:37:46.000000', 'consum', 0.0212, 'lps'),
	(460200, 126, '2015-03-15 00:37:47.000000', 'consum', 0.0219, 'lps'),
	(460201, 126, '2015-03-15 00:37:48.000000', 'consum', 0.0220, 'lps'),
	(460202, 126, '2015-03-15 00:37:49.000000', 'consum', 0.0220, 'lps'),
	(460203, 126, '2015-03-15 00:37:50.000000', 'consum', 0.0217, 'lps'),
	(460204, 126, '2015-03-15 00:37:51.000000', 'consum', 0.0218, 'lps'),
	(460205, 126, '2015-03-15 00:37:52.000000', 'consum', 0.0212, 'lps'),
	(460206, 126, '2015-03-15 00:37:53.000000', 'consum', 0.0210, 'lps'),
	(460207, 126, '2015-03-15 00:37:54.000000', 'consum', 0.0218, 'lps'),
	(460208, 126, '2015-03-15 00:37:55.000000', 'consum', 0.0223, 'lps'),
	(460209, 126, '2015-03-15 00:37:56.000000', 'consum', 0.0223, 'lps'),
	(460210, 126, '2015-03-15 00:37:57.000000', 'consum', 0.0211, 'lps'),
	(460211, 126, '2015-03-15 00:37:58.000000', 'consum', 0.0218, 'lps'),
	(460212, 126, '2015-03-15 00:37:59.000000', 'consum', 0.0220, 'lps'),
	(460213, 126, '2015-03-15 00:38:00.000000', 'consum', 0.0220, 'lps'),
	(460214, 126, '2015-03-15 00:38:01.000000', 'consum', 0.0217, 'lps'),
	(460215, 126, '2015-03-15 00:38:02.000000', 'consum', 0.0217, 'lps'),
	(460216, 126, '2015-03-15 00:38:03.000000', 'consum', 0.0211, 'lps'),
	(460217, 126, '2015-03-15 00:38:04.000000', 'consum', 0.0223, 'lps'),
	(460218, 126, '2015-03-15 00:38:05.000000', 'consum', 0.0215, 'lps'),
	(460219, 126, '2015-03-15 00:38:06.000000', 'consum', 0.0211, 'lps'),
	(460220, 126, '2015-03-15 00:38:07.000000', 'consum', 0.0215, 'lps'),
	(460221, 126, '2015-03-15 00:38:08.000000', 'consum', 0.0218, 'lps'),
	(460222, 126, '2015-03-15 00:38:09.000000', 'consum', 0.0222, 'lps'),
	(460223, 126, '2015-03-15 00:38:10.000000', 'consum', 0.0217, 'lps'),
	(460224, 126, '2015-03-15 00:38:11.000000', 'consum', 0.0212, 'lps'),
	(460225, 126, '2015-03-15 00:38:12.000000', 'consum', 0.0211, 'lps'),
	(460226, 126, '2015-03-15 00:38:13.000000', 'consum', 0.0223, 'lps'),
	(460227, 126, '2015-03-15 00:38:14.000000', 'consum', 0.0219, 'lps'),
	(460228, 126, '2015-03-15 00:38:15.000000', 'consum', 0.0214, 'lps'),
	(460229, 126, '2015-03-15 00:38:16.000000', 'consum', 0.0218, 'lps'),
	(460230, 126, '2015-03-15 00:38:17.000000', 'consum', 0.0212, 'lps'),
	(460231, 126, '2015-03-15 00:38:18.000000', 'consum', 0.0223, 'lps'),
	(460232, 126, '2015-03-15 00:38:19.000000', 'consum', 0.0214, 'lps'),
	(460233, 126, '2015-03-15 00:38:20.000000', 'consum', 0.0220, 'lps'),
	(460234, 126, '2015-03-15 00:38:21.000000', 'consum', 0.0218, 'lps'),
	(460235, 126, '2015-03-15 00:38:22.000000', 'consum', 0.0222, 'lps'),
	(460236, 126, '2015-03-15 00:38:23.000000', 'consum', 0.0220, 'lps'),
	(460237, 126, '2015-03-15 00:38:24.000000', 'consum', 0.0222, 'lps'),
	(460238, 126, '2015-03-15 00:38:25.000000', 'consum', 0.0215, 'lps'),
	(460239, 126, '2015-03-15 00:38:26.000000', 'consum', 0.0211, 'lps'),
	(460240, 126, '2015-03-15 00:38:27.000000', 'consum', 0.0215, 'lps'),
	(460241, 126, '2015-03-15 00:38:28.000000', 'consum', 0.0221, 'lps'),
	(460242, 126, '2015-03-15 00:38:29.000000', 'consum', 0.0221, 'lps'),
	(460243, 126, '2015-03-15 00:38:30.000000', 'consum', 0.0218, 'lps'),
	(460244, 126, '2015-03-15 00:38:31.000000', 'consum', 0.0218, 'lps'),
	(460245, 126, '2015-03-15 00:38:32.000000', 'consum', 0.0212, 'lps'),
	(460246, 126, '2015-03-15 00:38:33.000000', 'consum', 0.0210, 'lps'),
	(460247, 126, '2015-03-15 00:38:34.000000', 'consum', 0.0218, 'lps'),
	(460248, 126, '2015-03-15 00:38:35.000000', 'consum', 0.0210, 'lps'),
	(460249, 126, '2015-03-15 00:38:36.000000', 'consum', 0.0213, 'lps'),
	(460250, 126, '2015-03-15 00:38:37.000000', 'consum', 0.0211, 'lps'),
	(460251, 126, '2015-03-15 00:38:38.000000', 'consum', 0.0220, 'lps'),
	(460252, 126, '2015-03-15 00:38:39.000000', 'consum', 0.0217, 'lps'),
	(460253, 126, '2015-03-15 00:38:40.000000', 'consum', 0.0217, 'lps'),
	(460254, 126, '2015-03-15 00:38:41.000000', 'consum', 0.0210, 'lps'),
	(460255, 126, '2015-03-15 00:38:42.000000', 'consum', 0.0217, 'lps'),
	(460256, 126, '2015-03-15 00:38:43.000000', 'consum', 0.0217, 'lps'),
	(460257, 126, '2015-03-15 00:38:44.000000', 'consum', 0.0223, 'lps'),
	(460258, 126, '2015-03-15 00:38:45.000000', 'consum', 0.0214, 'lps'),
	(460259, 126, '2015-03-15 00:38:46.000000', 'consum', 0.0221, 'lps'),
	(460260, 126, '2015-03-15 00:38:47.000000', 'consum', 0.0211, 'lps'),
	(460261, 126, '2015-03-15 00:38:48.000000', 'consum', 0.0212, 'lps'),
	(460262, 126, '2015-03-15 00:38:49.000000', 'consum', 0.0216, 'lps'),
	(460263, 126, '2015-03-15 00:38:50.000000', 'consum', 0.0221, 'lps'),
	(460264, 126, '2015-03-15 00:38:51.000000', 'consum', 0.0218, 'lps'),
	(460265, 126, '2015-03-15 00:38:52.000000', 'consum', 0.0217, 'lps'),
	(460266, 126, '2015-03-15 00:38:53.000000', 'consum', 0.0222, 'lps'),
	(460267, 126, '2015-03-15 00:38:54.000000', 'consum', 0.0223, 'lps'),
	(460268, 126, '2015-03-15 00:38:55.000000', 'consum', 0.0223, 'lps'),
	(460269, 126, '2015-03-15 00:38:56.000000', 'consum', 0.0210, 'lps'),
	(460270, 126, '2015-03-15 00:38:57.000000', 'consum', 0.0215, 'lps'),
	(460271, 126, '2015-03-15 00:38:58.000000', 'consum', 0.0222, 'lps'),
	(460272, 126, '2015-03-15 00:38:59.000000', 'consum', 0.0211, 'lps'),
	(460273, 126, '2015-03-15 00:39:00.000000', 'consum', 0.0223, 'lps'),
	(460274, 126, '2015-03-15 00:39:01.000000', 'consum', 0.0218, 'lps'),
	(460275, 126, '2015-03-15 00:39:02.000000', 'consum', 0.0222, 'lps'),
	(460276, 126, '2015-03-15 00:39:03.000000', 'consum', 0.0220, 'lps'),
	(460277, 126, '2015-03-15 00:39:04.000000', 'consum', 0.0212, 'lps'),
	(460278, 126, '2015-03-15 00:39:05.000000', 'consum', 0.0216, 'lps'),
	(460279, 126, '2015-03-15 00:39:06.000000', 'consum', 0.0222, 'lps'),
	(460280, 126, '2015-03-15 00:39:07.000000', 'consum', 0.0211, 'lps'),
	(460281, 126, '2015-03-15 00:39:08.000000', 'consum', 0.0219, 'lps'),
	(460282, 126, '2015-03-15 00:39:09.000000', 'consum', 0.0211, 'lps'),
	(460283, 126, '2015-03-15 00:39:10.000000', 'consum', 0.0218, 'lps'),
	(460284, 126, '2015-03-15 00:39:11.000000', 'consum', 0.0218, 'lps'),
	(460285, 126, '2015-03-15 00:39:12.000000', 'consum', 0.0211, 'lps'),
	(460286, 126, '2015-03-15 00:39:13.000000', 'consum', 0.0223, 'lps'),
	(460287, 126, '2015-03-15 00:39:14.000000', 'consum', 0.0215, 'lps'),
	(460288, 126, '2015-03-15 00:39:15.000000', 'consum', 0.0210, 'lps'),
	(460289, 126, '2015-03-15 00:39:16.000000', 'consum', 0.0223, 'lps'),
	(460290, 126, '2015-03-15 00:39:17.000000', 'consum', 0.0218, 'lps'),
	(460291, 126, '2015-03-15 00:39:18.000000', 'consum', 0.0214, 'lps'),
	(460292, 126, '2015-03-15 00:39:19.000000', 'consum', 0.0220, 'lps'),
	(460293, 126, '2015-03-15 00:39:20.000000', 'consum', 0.0221, 'lps'),
	(460294, 126, '2015-03-15 00:39:21.000000', 'consum', 0.0222, 'lps'),
	(460295, 126, '2015-03-15 00:39:22.000000', 'consum', 0.0223, 'lps'),
	(460296, 126, '2015-03-15 00:39:23.000000', 'consum', 0.0213, 'lps'),
	(460297, 126, '2015-03-15 00:39:24.000000', 'consum', 0.0213, 'lps'),
	(460298, 126, '2015-03-15 00:39:25.000000', 'consum', 0.0219, 'lps'),
	(460299, 126, '2015-03-15 00:39:26.000000', 'consum', 0.0216, 'lps'),
	(460300, 126, '2015-03-15 00:39:27.000000', 'consum', 0.0213, 'lps'),
	(460301, 126, '2015-03-15 00:39:28.000000', 'consum', 0.0220, 'lps'),
	(460302, 126, '2015-03-15 00:39:29.000000', 'consum', 0.0212, 'lps'),
	(460303, 126, '2015-03-15 00:39:30.000000', 'consum', 0.0218, 'lps'),
	(460304, 126, '2015-03-15 00:39:31.000000', 'consum', 0.0217, 'lps'),
	(460305, 126, '2015-03-15 00:39:32.000000', 'consum', 0.0222, 'lps'),
	(460306, 126, '2015-03-15 00:39:33.000000', 'consum', 0.0222, 'lps'),
	(460307, 126, '2015-03-15 00:39:34.000000', 'consum', 0.0220, 'lps'),
	(460308, 126, '2015-03-15 00:39:35.000000', 'consum', 0.0210, 'lps'),
	(460309, 126, '2015-03-15 00:39:36.000000', 'consum', 0.0223, 'lps'),
	(460310, 126, '2015-03-15 00:39:37.000000', 'consum', 0.0221, 'lps'),
	(460311, 126, '2015-03-15 00:39:38.000000', 'consum', 0.0213, 'lps'),
	(460312, 126, '2015-03-15 00:39:39.000000', 'consum', 0.0220, 'lps'),
	(460313, 126, '2015-03-15 00:39:40.000000', 'consum', 0.0223, 'lps'),
	(460314, 126, '2015-03-15 00:39:41.000000', 'consum', 0.0219, 'lps'),
	(460315, 126, '2015-03-15 00:39:42.000000', 'consum', 0.0214, 'lps'),
	(460316, 126, '2015-03-15 00:39:43.000000', 'consum', 0.0220, 'lps'),
	(460317, 126, '2015-03-15 00:39:44.000000', 'consum', 0.0218, 'lps'),
	(460318, 126, '2015-03-15 00:39:45.000000', 'consum', 0.0223, 'lps'),
	(460319, 126, '2015-03-15 00:39:46.000000', 'consum', 0.0223, 'lps'),
	(460320, 126, '2015-03-15 00:39:47.000000', 'consum', 0.0221, 'lps'),
	(460321, 126, '2015-03-15 00:39:48.000000', 'consum', 0.0215, 'lps'),
	(460322, 126, '2015-03-15 00:39:49.000000', 'consum', 0.0216, 'lps'),
	(460323, 126, '2015-03-15 00:39:50.000000', 'consum', 0.0212, 'lps'),
	(460324, 126, '2015-03-15 00:39:51.000000', 'consum', 0.0217, 'lps'),
	(460325, 126, '2015-03-15 00:39:52.000000', 'consum', 0.0210, 'lps'),
	(460326, 126, '2015-03-15 00:39:53.000000', 'consum', 0.0219, 'lps'),
	(460327, 126, '2015-03-15 00:39:54.000000', 'consum', 0.0211, 'lps'),
	(460328, 126, '2015-03-15 00:39:55.000000', 'consum', 0.0217, 'lps'),
	(460329, 126, '2015-03-15 00:39:56.000000', 'consum', 0.0216, 'lps'),
	(460330, 126, '2015-03-15 00:39:57.000000', 'consum', 0.0217, 'lps'),
	(460331, 126, '2015-03-15 00:39:58.000000', 'consum', 0.0215, 'lps'),
	(460332, 126, '2015-03-15 00:39:59.000000', 'consum', 0.0215, 'lps'),
	(460333, 126, '2015-03-15 00:40:00.000000', 'consum', 0.0221, 'lps'),
	(460334, 126, '2015-03-15 00:40:01.000000', 'consum', 0.0222, 'lps'),
	(460335, 126, '2015-03-15 00:40:02.000000', 'consum', 0.0211, 'lps'),
	(460336, 126, '2015-03-15 00:40:03.000000', 'consum', 0.0220, 'lps'),
	(460337, 126, '2015-03-15 00:40:04.000000', 'consum', 0.0217, 'lps'),
	(460338, 126, '2015-03-15 00:40:05.000000', 'consum', 0.0214, 'lps'),
	(460339, 126, '2015-03-15 00:40:06.000000', 'consum', 0.0211, 'lps'),
	(460340, 126, '2015-03-15 00:40:07.000000', 'consum', 0.0215, 'lps'),
	(460341, 126, '2015-03-15 00:40:08.000000', 'consum', 0.0220, 'lps'),
	(460342, 126, '2015-03-15 00:40:09.000000', 'consum', 0.0219, 'lps'),
	(460343, 126, '2015-03-15 00:40:10.000000', 'consum', 0.0211, 'lps'),
	(460344, 126, '2015-03-15 00:40:11.000000', 'consum', 0.0215, 'lps'),
	(460345, 126, '2015-03-15 00:40:12.000000', 'consum', 0.0220, 'lps'),
	(460346, 126, '2015-03-15 00:40:13.000000', 'consum', 0.0216, 'lps'),
	(460347, 126, '2015-03-15 00:40:14.000000', 'consum', 0.0212, 'lps'),
	(460348, 126, '2015-03-15 00:40:15.000000', 'consum', 0.0217, 'lps'),
	(460349, 126, '2015-03-15 00:40:16.000000', 'consum', 0.0211, 'lps'),
	(460350, 126, '2015-03-15 00:40:17.000000', 'consum', 0.0210, 'lps'),
	(460351, 126, '2015-03-15 00:40:18.000000', 'consum', 0.0222, 'lps'),
	(460352, 126, '2015-03-15 00:40:19.000000', 'consum', 0.0212, 'lps'),
	(460353, 126, '2015-03-15 00:40:20.000000', 'consum', 0.0213, 'lps'),
	(460354, 126, '2015-03-15 00:40:21.000000', 'consum', 0.0221, 'lps'),
	(460355, 126, '2015-03-15 00:40:22.000000', 'consum', 0.0214, 'lps'),
	(460356, 126, '2015-03-15 00:40:23.000000', 'consum', 0.0211, 'lps'),
	(460357, 126, '2015-03-15 00:40:24.000000', 'consum', 0.0219, 'lps'),
	(460358, 126, '2015-03-15 00:40:25.000000', 'consum', 0.0223, 'lps'),
	(460359, 126, '2015-03-15 00:40:26.000000', 'consum', 0.0220, 'lps'),
	(460360, 126, '2015-03-15 00:40:27.000000', 'consum', 0.0220, 'lps'),
	(460361, 126, '2015-03-15 00:40:28.000000', 'consum', 0.0220, 'lps'),
	(460362, 126, '2015-03-15 00:40:29.000000', 'consum', 0.0215, 'lps'),
	(460363, 126, '2015-03-15 00:40:30.000000', 'consum', 0.0221, 'lps'),
	(460364, 126, '2015-03-15 00:40:31.000000', 'consum', 0.0221, 'lps'),
	(460365, 126, '2015-03-15 00:40:32.000000', 'consum', 0.0219, 'lps'),
	(460366, 126, '2015-03-15 00:40:33.000000', 'consum', 0.0222, 'lps'),
	(460367, 126, '2015-03-15 00:40:34.000000', 'consum', 0.0218, 'lps'),
	(460368, 126, '2015-03-15 00:40:35.000000', 'consum', 0.0211, 'lps'),
	(460369, 126, '2015-03-15 00:40:36.000000', 'consum', 0.0222, 'lps'),
	(460370, 126, '2015-03-15 00:40:37.000000', 'consum', 0.0210, 'lps'),
	(460371, 126, '2015-03-15 00:40:38.000000', 'consum', 0.0217, 'lps'),
	(460372, 126, '2015-03-15 00:40:39.000000', 'consum', 0.0217, 'lps'),
	(460373, 126, '2015-03-15 00:40:40.000000', 'consum', 0.0212, 'lps'),
	(460374, 126, '2015-03-15 00:40:41.000000', 'consum', 0.0212, 'lps'),
	(460375, 126, '2015-03-15 00:40:42.000000', 'consum', 0.0214, 'lps'),
	(460376, 126, '2015-03-15 00:40:43.000000', 'consum', 0.0211, 'lps'),
	(460377, 126, '2015-03-15 00:40:44.000000', 'consum', 0.0219, 'lps'),
	(460378, 126, '2015-03-15 00:40:45.000000', 'consum', 0.0222, 'lps'),
	(460379, 126, '2015-03-15 00:40:46.000000', 'consum', 0.0215, 'lps'),
	(460380, 126, '2015-03-15 00:40:47.000000', 'consum', 0.0213, 'lps'),
	(460381, 126, '2015-03-15 00:40:48.000000', 'consum', 0.0213, 'lps'),
	(460382, 126, '2015-03-15 00:40:49.000000', 'consum', 0.0213, 'lps'),
	(460383, 126, '2015-03-15 00:40:50.000000', 'consum', 0.0220, 'lps'),
	(460384, 126, '2015-03-15 00:40:51.000000', 'consum', 0.0223, 'lps'),
	(460385, 126, '2015-03-15 00:40:52.000000', 'consum', 0.0217, 'lps'),
	(460386, 126, '2015-03-15 00:40:53.000000', 'consum', 0.0219, 'lps'),
	(460387, 126, '2015-03-15 00:40:54.000000', 'consum', 0.0223, 'lps'),
	(460388, 126, '2015-03-15 00:40:55.000000', 'consum', 0.0218, 'lps'),
	(460389, 126, '2015-03-15 00:40:56.000000', 'consum', 0.0213, 'lps'),
	(460390, 126, '2015-03-15 00:40:57.000000', 'consum', 0.0216, 'lps'),
	(460391, 126, '2015-03-15 00:40:58.000000', 'consum', 0.0216, 'lps'),
	(460392, 126, '2015-03-15 00:40:59.000000', 'consum', 0.0211, 'lps'),
	(460393, 126, '2015-03-15 00:41:00.000000', 'consum', 0.0211, 'lps'),
	(460394, 126, '2015-03-15 00:41:01.000000', 'consum', 0.0212, 'lps'),
	(460395, 126, '2015-03-15 00:41:02.000000', 'consum', 0.0216, 'lps'),
	(460396, 126, '2015-03-15 00:41:03.000000', 'consum', 0.0223, 'lps'),
	(460397, 126, '2015-03-15 00:41:04.000000', 'consum', 0.0216, 'lps'),
	(460398, 126, '2015-03-15 00:41:05.000000', 'consum', 0.0214, 'lps'),
	(460399, 126, '2015-03-15 00:41:06.000000', 'consum', 0.0213, 'lps'),
	(460400, 126, '2015-03-15 00:41:07.000000', 'consum', 0.0215, 'lps'),
	(460401, 126, '2015-03-15 00:41:08.000000', 'consum', 0.0210, 'lps'),
	(460402, 126, '2015-03-15 00:41:09.000000', 'consum', 0.0212, 'lps'),
	(460403, 126, '2015-03-15 00:41:10.000000', 'consum', 0.0219, 'lps'),
	(460404, 126, '2015-03-15 00:41:11.000000', 'consum', 0.0221, 'lps'),
	(460405, 126, '2015-03-15 00:41:12.000000', 'consum', 0.0211, 'lps'),
	(460406, 126, '2015-03-15 00:41:13.000000', 'consum', 0.0223, 'lps'),
	(460407, 126, '2015-03-15 00:41:14.000000', 'consum', 0.0216, 'lps'),
	(460408, 126, '2015-03-15 00:41:15.000000', 'consum', 0.0216, 'lps'),
	(460409, 126, '2015-03-15 00:41:16.000000', 'consum', 0.0211, 'lps'),
	(460410, 126, '2015-03-15 00:41:17.000000', 'consum', 0.0222, 'lps'),
	(460411, 126, '2015-03-15 00:41:18.000000', 'consum', 0.0213, 'lps'),
	(460412, 126, '2015-03-15 00:41:19.000000', 'consum', 0.0215, 'lps'),
	(460413, 126, '2015-03-15 00:41:20.000000', 'consum', 0.0216, 'lps'),
	(460414, 126, '2015-03-15 00:41:21.000000', 'consum', 0.0211, 'lps'),
	(460415, 126, '2015-03-15 00:41:22.000000', 'consum', 0.0212, 'lps'),
	(460416, 126, '2015-03-15 00:41:23.000000', 'consum', 0.0216, 'lps'),
	(460417, 126, '2015-03-15 00:41:24.000000', 'consum', 0.0221, 'lps'),
	(460418, 126, '2015-03-15 00:41:25.000000', 'consum', 0.0219, 'lps'),
	(460419, 126, '2015-03-15 00:41:26.000000', 'consum', 0.0210, 'lps'),
	(460420, 126, '2015-03-15 00:41:27.000000', 'consum', 0.0210, 'lps'),
	(460421, 126, '2015-03-15 00:41:28.000000', 'consum', 0.0210, 'lps'),
	(460422, 126, '2015-03-15 00:41:29.000000', 'consum', 0.0213, 'lps'),
	(460423, 126, '2015-03-15 00:41:30.000000', 'consum', 0.0210, 'lps'),
	(460424, 126, '2015-03-15 00:41:31.000000', 'consum', 0.0216, 'lps'),
	(460425, 126, '2015-03-15 00:41:32.000000', 'consum', 0.0212, 'lps'),
	(460426, 126, '2015-03-15 00:41:33.000000', 'consum', 0.0218, 'lps'),
	(460427, 126, '2015-03-15 00:41:34.000000', 'consum', 0.0218, 'lps'),
	(460428, 126, '2015-03-15 00:41:35.000000', 'consum', 0.0223, 'lps'),
	(460429, 126, '2015-03-15 00:41:36.000000', 'consum', 0.0212, 'lps'),
	(460430, 126, '2015-03-15 00:41:37.000000', 'consum', 0.0210, 'lps'),
	(460431, 126, '2015-03-15 00:41:38.000000', 'consum', 0.0220, 'lps'),
	(460432, 126, '2015-03-15 00:41:39.000000', 'consum', 0.0215, 'lps'),
	(460433, 126, '2015-03-15 00:41:40.000000', 'consum', 0.0222, 'lps'),
	(460434, 126, '2015-03-15 00:41:41.000000', 'consum', 0.0214, 'lps'),
	(460435, 126, '2015-03-15 00:41:42.000000', 'consum', 0.0222, 'lps'),
	(460436, 126, '2015-03-15 00:41:43.000000', 'consum', 0.0214, 'lps'),
	(460437, 126, '2015-03-15 00:41:44.000000', 'consum', 0.0211, 'lps'),
	(460438, 126, '2015-03-15 00:41:45.000000', 'consum', 0.0215, 'lps'),
	(460439, 126, '2015-03-15 00:41:46.000000', 'consum', 0.0220, 'lps'),
	(460440, 126, '2015-03-15 00:41:47.000000', 'consum', 0.0219, 'lps'),
	(460441, 126, '2015-03-15 00:41:48.000000', 'consum', 0.0210, 'lps'),
	(460442, 126, '2015-03-15 00:41:49.000000', 'consum', 0.0214, 'lps'),
	(460443, 126, '2015-03-15 00:41:50.000000', 'consum', 0.0214, 'lps'),
	(460444, 126, '2015-03-15 00:41:51.000000', 'consum', 0.0217, 'lps'),
	(460445, 126, '2015-03-15 00:41:52.000000', 'consum', 0.0223, 'lps'),
	(460446, 126, '2015-03-15 00:41:53.000000', 'consum', 0.0210, 'lps'),
	(460447, 126, '2015-03-15 00:41:54.000000', 'consum', 0.0212, 'lps'),
	(460448, 126, '2015-03-15 00:41:55.000000', 'consum', 0.0223, 'lps'),
	(460449, 126, '2015-03-15 00:41:56.000000', 'consum', 0.0212, 'lps'),
	(460450, 126, '2015-03-15 00:41:57.000000', 'consum', 0.0212, 'lps'),
	(460451, 126, '2015-03-15 00:41:58.000000', 'consum', 0.0212, 'lps'),
	(460452, 126, '2015-03-15 00:41:59.000000', 'consum', 0.0217, 'lps'),
	(460453, 126, '2015-03-15 00:42:00.000000', 'consum', 0.0212, 'lps'),
	(460454, 126, '2015-03-15 00:42:01.000000', 'consum', 0.0212, 'lps'),
	(460455, 126, '2015-03-15 00:42:02.000000', 'consum', 0.0213, 'lps'),
	(460456, 126, '2015-03-15 00:42:03.000000', 'consum', 0.0220, 'lps'),
	(460457, 126, '2015-03-15 00:42:04.000000', 'consum', 0.0210, 'lps'),
	(460458, 126, '2015-03-15 00:42:05.000000', 'consum', 0.0210, 'lps'),
	(460459, 126, '2015-03-15 00:42:06.000000', 'consum', 0.0210, 'lps'),
	(460460, 126, '2015-03-15 00:42:07.000000', 'consum', 0.0212, 'lps'),
	(460461, 126, '2015-03-15 00:42:08.000000', 'consum', 0.0218, 'lps'),
	(460462, 126, '2015-03-15 00:42:09.000000', 'consum', 0.0216, 'lps'),
	(460463, 126, '2015-03-15 00:42:10.000000', 'consum', 0.0215, 'lps'),
	(460464, 126, '2015-03-15 00:42:11.000000', 'consum', 0.0221, 'lps'),
	(460465, 126, '2015-03-15 00:42:12.000000', 'consum', 0.0221, 'lps'),
	(460466, 126, '2015-03-15 00:42:13.000000', 'consum', 0.0219, 'lps'),
	(460467, 126, '2015-03-15 00:42:14.000000', 'consum', 0.0210, 'lps'),
	(460468, 126, '2015-03-15 00:42:15.000000', 'consum', 0.0222, 'lps'),
	(460469, 126, '2015-03-15 00:42:16.000000', 'consum', 0.0218, 'lps'),
	(460470, 126, '2015-03-15 00:42:17.000000', 'consum', 0.0211, 'lps'),
	(460471, 126, '2015-03-15 00:42:18.000000', 'consum', 0.0222, 'lps'),
	(460472, 126, '2015-03-15 00:42:19.000000', 'consum', 0.0210, 'lps'),
	(460473, 126, '2015-03-15 00:42:20.000000', 'consum', 0.0217, 'lps'),
	(460474, 126, '2015-03-15 00:42:21.000000', 'consum', 0.0218, 'lps'),
	(460475, 126, '2015-03-15 00:42:22.000000', 'consum', 0.0216, 'lps'),
	(460476, 126, '2015-03-15 00:42:23.000000', 'consum', 0.0217, 'lps'),
	(460477, 126, '2015-03-15 00:42:24.000000', 'consum', 0.0212, 'lps'),
	(460478, 126, '2015-03-15 00:42:25.000000', 'consum', 0.0215, 'lps'),
	(460479, 126, '2015-03-15 00:42:26.000000', 'consum', 0.0215, 'lps'),
	(460480, 126, '2015-03-15 00:42:27.000000', 'consum', 0.0222, 'lps'),
	(460481, 126, '2015-03-15 00:42:28.000000', 'consum', 0.0212, 'lps'),
	(460482, 126, '2015-03-15 00:42:29.000000', 'consum', 0.0214, 'lps'),
	(460483, 126, '2015-03-15 00:42:30.000000', 'consum', 0.0210, 'lps'),
	(460484, 126, '2015-03-15 00:42:31.000000', 'consum', 0.0210, 'lps'),
	(460485, 126, '2015-03-15 00:42:32.000000', 'consum', 0.0213, 'lps'),
	(460486, 126, '2015-03-15 00:42:33.000000', 'consum', 0.0210, 'lps'),
	(460487, 126, '2015-03-15 00:42:34.000000', 'consum', 0.0215, 'lps'),
	(460488, 126, '2015-03-15 00:42:35.000000', 'consum', 0.0222, 'lps'),
	(460489, 126, '2015-03-15 00:42:36.000000', 'consum', 0.0213, 'lps'),
	(460490, 126, '2015-03-15 00:42:37.000000', 'consum', 0.0220, 'lps'),
	(460491, 126, '2015-03-15 00:42:38.000000', 'consum', 0.0222, 'lps'),
	(460492, 126, '2015-03-15 00:42:39.000000', 'consum', 0.0212, 'lps'),
	(460493, 126, '2015-03-15 00:42:40.000000', 'consum', 0.0214, 'lps'),
	(460494, 126, '2015-03-15 00:42:41.000000', 'consum', 0.0212, 'lps'),
	(460495, 126, '2015-03-15 00:42:42.000000', 'consum', 0.0220, 'lps'),
	(460496, 126, '2015-03-15 00:42:43.000000', 'consum', 0.0214, 'lps'),
	(460497, 126, '2015-03-15 00:42:44.000000', 'consum', 0.0215, 'lps'),
	(460498, 126, '2015-03-15 00:42:45.000000', 'consum', 0.0223, 'lps'),
	(460499, 126, '2015-03-15 00:42:46.000000', 'consum', 0.0217, 'lps'),
	(460500, 126, '2015-03-15 00:42:47.000000', 'consum', 0.0223, 'lps'),
	(460501, 126, '2015-03-15 00:42:48.000000', 'consum', 0.0212, 'lps'),
	(460502, 126, '2015-03-15 00:42:49.000000', 'consum', 0.0222, 'lps'),
	(460503, 126, '2015-03-15 00:42:50.000000', 'consum', 0.0223, 'lps'),
	(460504, 126, '2015-03-15 00:42:51.000000', 'consum', 0.0214, 'lps'),
	(460505, 126, '2015-03-15 00:42:52.000000', 'consum', 0.0216, 'lps'),
	(460506, 126, '2015-03-15 00:42:53.000000', 'consum', 0.0216, 'lps'),
	(460507, 126, '2015-03-15 00:42:54.000000', 'consum', 0.0223, 'lps'),
	(460508, 126, '2015-03-15 00:42:55.000000', 'consum', 0.0215, 'lps'),
	(460509, 126, '2015-03-15 00:42:56.000000', 'consum', 0.0223, 'lps'),
	(460510, 126, '2015-03-15 00:42:57.000000', 'consum', 0.0218, 'lps'),
	(460511, 126, '2015-03-15 00:42:58.000000', 'consum', 0.0213, 'lps'),
	(460512, 126, '2015-03-15 00:42:59.000000', 'consum', 0.0213, 'lps'),
	(460513, 126, '2015-03-15 00:43:00.000000', 'consum', 0.0220, 'lps'),
	(460514, 126, '2015-03-15 00:43:01.000000', 'consum', 0.0223, 'lps'),
	(460515, 126, '2015-03-15 00:43:02.000000', 'consum', 0.0215, 'lps'),
	(460516, 126, '2015-03-15 00:43:03.000000', 'consum', 0.0212, 'lps'),
	(460517, 126, '2015-03-15 00:43:04.000000', 'consum', 0.0219, 'lps'),
	(460518, 126, '2015-03-15 00:43:05.000000', 'consum', 0.0223, 'lps'),
	(460519, 126, '2015-03-15 00:43:06.000000', 'consum', 0.0220, 'lps'),
	(460520, 126, '2015-03-15 00:43:07.000000', 'consum', 0.0222, 'lps'),
	(460521, 126, '2015-03-15 00:43:08.000000', 'consum', 0.0213, 'lps'),
	(460522, 126, '2015-03-15 00:43:09.000000', 'consum', 0.0216, 'lps'),
	(460523, 126, '2015-03-15 00:43:10.000000', 'consum', 0.0217, 'lps'),
	(460524, 126, '2015-03-15 00:43:11.000000', 'consum', 0.0215, 'lps'),
	(460525, 126, '2015-03-15 00:43:12.000000', 'consum', 0.0213, 'lps'),
	(460526, 126, '2015-03-15 00:43:13.000000', 'consum', 0.0212, 'lps'),
	(460527, 126, '2015-03-15 00:43:14.000000', 'consum', 0.0211, 'lps'),
	(460528, 126, '2015-03-15 00:43:15.000000', 'consum', 0.0223, 'lps'),
	(460529, 126, '2015-03-15 00:43:16.000000', 'consum', 0.0216, 'lps'),
	(460530, 126, '2015-03-15 00:43:17.000000', 'consum', 0.0214, 'lps'),
	(460531, 126, '2015-03-15 00:43:18.000000', 'consum', 0.0215, 'lps'),
	(460532, 126, '2015-03-15 00:43:19.000000', 'consum', 0.0221, 'lps'),
	(460533, 126, '2015-03-15 00:43:20.000000', 'consum', 0.0211, 'lps'),
	(460534, 126, '2015-03-15 00:43:21.000000', 'consum', 0.0223, 'lps'),
	(460535, 126, '2015-03-15 00:43:22.000000', 'consum', 0.0218, 'lps'),
	(460536, 126, '2015-03-15 00:43:23.000000', 'consum', 0.0210, 'lps'),
	(460537, 126, '2015-03-15 00:43:24.000000', 'consum', 0.0215, 'lps'),
	(460538, 126, '2015-03-15 00:43:25.000000', 'consum', 0.0220, 'lps'),
	(460539, 126, '2015-03-15 00:43:26.000000', 'consum', 0.0219, 'lps'),
	(460540, 126, '2015-03-15 00:43:27.000000', 'consum', 0.0213, 'lps'),
	(460541, 126, '2015-03-15 00:43:28.000000', 'consum', 0.0211, 'lps'),
	(460542, 126, '2015-03-15 00:43:29.000000', 'consum', 0.0222, 'lps'),
	(460543, 126, '2015-03-15 00:43:30.000000', 'consum', 0.0223, 'lps'),
	(460544, 126, '2015-03-15 00:43:31.000000', 'consum', 0.0214, 'lps'),
	(460545, 126, '2015-03-15 00:43:32.000000', 'consum', 0.0218, 'lps'),
	(460546, 126, '2015-03-15 00:43:33.000000', 'consum', 0.0210, 'lps'),
	(460547, 126, '2015-03-15 00:43:34.000000', 'consum', 0.0215, 'lps'),
	(460548, 126, '2015-03-15 00:43:35.000000', 'consum', 0.0221, 'lps'),
	(460549, 126, '2015-03-15 00:43:36.000000', 'consum', 0.0222, 'lps'),
	(460550, 126, '2015-03-15 00:43:37.000000', 'consum', 0.0210, 'lps'),
	(460551, 126, '2015-03-15 00:43:38.000000', 'consum', 0.0215, 'lps'),
	(460552, 126, '2015-03-15 00:43:39.000000', 'consum', 0.0221, 'lps'),
	(460553, 126, '2015-03-15 00:43:40.000000', 'consum', 0.0222, 'lps'),
	(460554, 126, '2015-03-15 00:43:41.000000', 'consum', 0.0223, 'lps'),
	(460555, 126, '2015-03-15 00:43:42.000000', 'consum', 0.0214, 'lps'),
	(460556, 126, '2015-03-15 00:43:43.000000', 'consum', 0.0220, 'lps'),
	(460557, 126, '2015-03-15 00:43:44.000000', 'consum', 0.0219, 'lps'),
	(460558, 126, '2015-03-15 00:43:45.000000', 'consum', 0.0211, 'lps'),
	(460559, 126, '2015-03-15 00:43:46.000000', 'consum', 0.0216, 'lps'),
	(460560, 126, '2015-03-15 00:43:47.000000', 'consum', 0.0223, 'lps'),
	(460561, 126, '2015-03-15 00:43:48.000000', 'consum', 0.0215, 'lps'),
	(460562, 126, '2015-03-15 00:43:49.000000', 'consum', 0.0211, 'lps'),
	(460563, 126, '2015-03-15 00:43:50.000000', 'consum', 0.0216, 'lps'),
	(460564, 126, '2015-03-15 00:43:51.000000', 'consum', 0.0211, 'lps'),
	(460565, 126, '2015-03-15 00:43:52.000000', 'consum', 0.0222, 'lps'),
	(460566, 126, '2015-03-15 00:43:53.000000', 'consum', 0.0215, 'lps'),
	(460567, 126, '2015-03-15 00:43:54.000000', 'consum', 0.0210, 'lps'),
	(460568, 126, '2015-03-15 00:43:55.000000', 'consum', 0.0213, 'lps'),
	(460569, 126, '2015-03-15 00:43:56.000000', 'consum', 0.0223, 'lps'),
	(460570, 126, '2015-03-15 00:43:57.000000', 'consum', 0.0211, 'lps'),
	(460571, 126, '2015-03-15 00:43:58.000000', 'consum', 0.0220, 'lps'),
	(460572, 126, '2015-03-15 00:43:59.000000', 'consum', 0.0216, 'lps'),
	(460573, 126, '2015-03-15 00:44:00.000000', 'consum', 0.0211, 'lps'),
	(460574, 126, '2015-03-15 00:44:01.000000', 'consum', 0.0211, 'lps'),
	(460575, 126, '2015-03-15 00:44:02.000000', 'consum', 0.0210, 'lps'),
	(460576, 126, '2015-03-15 00:44:03.000000', 'consum', 0.0211, 'lps'),
	(460577, 126, '2015-03-15 00:44:04.000000', 'consum', 0.0214, 'lps'),
	(460578, 126, '2015-03-15 00:44:05.000000', 'consum', 0.0212, 'lps'),
	(460579, 126, '2015-03-15 00:44:06.000000', 'consum', 0.0211, 'lps'),
	(460580, 126, '2015-03-15 00:44:07.000000', 'consum', 0.0222, 'lps'),
	(460581, 126, '2015-03-15 00:44:08.000000', 'consum', 0.0213, 'lps'),
	(460582, 126, '2015-03-15 00:44:09.000000', 'consum', 0.0216, 'lps'),
	(460583, 126, '2015-03-15 00:44:10.000000', 'consum', 0.0216, 'lps'),
	(460584, 126, '2015-03-15 00:44:11.000000', 'consum', 0.0210, 'lps'),
	(460585, 126, '2015-03-15 00:44:12.000000', 'consum', 0.0222, 'lps'),
	(460586, 126, '2015-03-15 00:44:13.000000', 'consum', 0.0213, 'lps'),
	(460587, 126, '2015-03-15 00:44:14.000000', 'consum', 0.0217, 'lps'),
	(460588, 126, '2015-03-15 00:44:15.000000', 'consum', 0.0223, 'lps'),
	(460589, 126, '2015-03-15 00:44:16.000000', 'consum', 0.0213, 'lps'),
	(460590, 126, '2015-03-15 00:44:17.000000', 'consum', 0.0214, 'lps'),
	(460591, 126, '2015-03-15 00:44:18.000000', 'consum', 0.0220, 'lps'),
	(460592, 126, '2015-03-15 00:44:19.000000', 'consum', 0.0222, 'lps'),
	(460593, 126, '2015-03-15 00:44:20.000000', 'consum', 0.0212, 'lps'),
	(460594, 126, '2015-03-15 00:44:21.000000', 'consum', 0.0215, 'lps'),
	(460595, 126, '2015-03-15 00:44:22.000000', 'consum', 0.0212, 'lps'),
	(460596, 126, '2015-03-15 00:44:23.000000', 'consum', 0.0222, 'lps'),
	(460597, 126, '2015-03-15 00:44:24.000000', 'consum', 0.0222, 'lps'),
	(460598, 126, '2015-03-15 00:44:25.000000', 'consum', 0.0218, 'lps'),
	(460599, 126, '2015-03-15 00:44:26.000000', 'consum', 0.0217, 'lps'),
	(460600, 126, '2015-03-15 00:44:27.000000', 'consum', 0.0222, 'lps'),
	(460601, 126, '2015-03-15 00:44:28.000000', 'consum', 0.0219, 'lps'),
	(460602, 126, '2015-03-15 00:44:29.000000', 'consum', 0.0222, 'lps'),
	(460603, 126, '2015-03-15 00:44:30.000000', 'consum', 0.0215, 'lps'),
	(460604, 126, '2015-03-15 00:44:31.000000', 'consum', 0.0215, 'lps'),
	(460605, 126, '2015-03-15 00:44:32.000000', 'consum', 0.0218, 'lps'),
	(460606, 126, '2015-03-15 00:44:33.000000', 'consum', 0.0223, 'lps'),
	(460607, 126, '2015-03-15 00:44:34.000000', 'consum', 0.0221, 'lps'),
	(460608, 126, '2015-03-15 00:44:35.000000', 'consum', 0.0216, 'lps'),
	(460609, 126, '2015-03-15 00:44:36.000000', 'consum', 0.0220, 'lps'),
	(460610, 126, '2015-03-15 00:44:37.000000', 'consum', 0.0214, 'lps'),
	(460611, 126, '2015-03-15 00:44:38.000000', 'consum', 0.0213, 'lps'),
	(460612, 126, '2015-03-15 00:44:39.000000', 'consum', 0.0216, 'lps'),
	(460613, 126, '2015-03-15 00:44:40.000000', 'consum', 0.0217, 'lps'),
	(460614, 126, '2015-03-15 00:44:41.000000', 'consum', 0.0212, 'lps'),
	(460615, 126, '2015-03-15 00:44:42.000000', 'consum', 0.0215, 'lps'),
	(460616, 126, '2015-03-15 00:44:43.000000', 'consum', 0.0214, 'lps'),
	(460617, 126, '2015-03-15 00:44:44.000000', 'consum', 0.0215, 'lps'),
	(460618, 126, '2015-03-15 00:44:45.000000', 'consum', 0.0210, 'lps'),
	(460619, 126, '2015-03-15 00:44:46.000000', 'consum', 0.0210, 'lps'),
	(460620, 126, '2015-03-15 00:44:47.000000', 'consum', 0.0212, 'lps'),
	(460621, 126, '2015-03-15 00:44:48.000000', 'consum', 0.0220, 'lps'),
	(460622, 126, '2015-03-15 00:44:49.000000', 'consum', 0.0210, 'lps'),
	(460623, 126, '2015-03-15 00:44:50.000000', 'consum', 0.0211, 'lps'),
	(460624, 126, '2015-03-15 00:44:51.000000', 'consum', 0.0214, 'lps'),
	(460625, 126, '2015-03-15 00:44:52.000000', 'consum', 0.0213, 'lps'),
	(460626, 126, '2015-03-15 00:44:53.000000', 'consum', 0.0215, 'lps'),
	(460627, 126, '2015-03-15 00:44:54.000000', 'consum', 0.0214, 'lps'),
	(460628, 126, '2015-03-15 00:44:55.000000', 'consum', 0.0213, 'lps'),
	(460629, 126, '2015-03-15 00:44:56.000000', 'consum', 0.0215, 'lps'),
	(460630, 126, '2015-03-15 00:44:57.000000', 'consum', 0.0213, 'lps'),
	(460631, 126, '2015-03-15 00:44:58.000000', 'consum', 0.0211, 'lps'),
	(460632, 126, '2015-03-15 00:44:59.000000', 'consum', 0.0221, 'lps'),
	(460633, 126, '2015-03-15 00:45:00.000000', 'consum', 0.0221, 'lps'),
	(460634, 126, '2015-03-15 00:45:01.000000', 'consum', 0.0219, 'lps'),
	(460635, 126, '2015-03-15 00:45:02.000000', 'consum', 0.0223, 'lps'),
	(460636, 126, '2015-03-15 00:45:03.000000', 'consum', 0.0220, 'lps'),
	(460637, 126, '2015-03-15 00:45:04.000000', 'consum', 0.0222, 'lps'),
	(460638, 126, '2015-03-15 00:45:05.000000', 'consum', 0.0211, 'lps'),
	(460639, 126, '2015-03-15 00:45:06.000000', 'consum', 0.0223, 'lps'),
	(460640, 126, '2015-03-15 00:45:07.000000', 'consum', 0.0216, 'lps'),
	(460641, 126, '2015-03-15 00:45:08.000000', 'consum', 0.0215, 'lps'),
	(460642, 126, '2015-03-15 00:45:09.000000', 'consum', 0.0217, 'lps'),
	(460643, 126, '2015-03-15 00:45:10.000000', 'consum', 0.0215, 'lps'),
	(460644, 126, '2015-03-15 00:45:11.000000', 'consum', 0.0217, 'lps'),
	(460645, 126, '2015-03-15 00:45:12.000000', 'consum', 0.0216, 'lps'),
	(460646, 126, '2015-03-15 00:45:13.000000', 'consum', 0.0219, 'lps'),
	(460647, 126, '2015-03-15 00:45:14.000000', 'consum', 0.0223, 'lps'),
	(460648, 126, '2015-03-15 00:45:15.000000', 'consum', 0.0220, 'lps'),
	(460649, 126, '2015-03-15 00:45:16.000000', 'consum', 0.0220, 'lps'),
	(460650, 126, '2015-03-15 00:45:17.000000', 'consum', 0.0219, 'lps'),
	(460651, 126, '2015-03-15 00:45:18.000000', 'consum', 0.0211, 'lps'),
	(460652, 126, '2015-03-15 00:45:19.000000', 'consum', 0.0215, 'lps'),
	(460653, 126, '2015-03-15 00:45:20.000000', 'consum', 0.0221, 'lps'),
	(460654, 126, '2015-03-15 00:45:21.000000', 'consum', 0.0221, 'lps'),
	(460655, 126, '2015-03-15 00:45:22.000000', 'consum', 0.0219, 'lps'),
	(460656, 126, '2015-03-15 00:45:23.000000', 'consum', 0.0221, 'lps'),
	(460657, 126, '2015-03-15 00:45:24.000000', 'consum', 0.0210, 'lps'),
	(460658, 126, '2015-03-15 00:45:25.000000', 'consum', 0.0223, 'lps'),
	(460659, 126, '2015-03-15 00:45:26.000000', 'consum', 0.0216, 'lps'),
	(460660, 126, '2015-03-15 00:45:27.000000', 'consum', 0.0217, 'lps'),
	(460661, 126, '2015-03-15 00:45:28.000000', 'consum', 0.0213, 'lps'),
	(460662, 126, '2015-03-15 00:45:29.000000', 'consum', 0.0219, 'lps'),
	(460663, 126, '2015-03-15 00:45:30.000000', 'consum', 0.0216, 'lps'),
	(460664, 126, '2015-03-15 00:45:31.000000', 'consum', 0.0216, 'lps'),
	(460665, 126, '2015-03-15 00:45:32.000000', 'consum', 0.0222, 'lps'),
	(460666, 126, '2015-03-15 00:45:33.000000', 'consum', 0.0212, 'lps'),
	(460667, 126, '2015-03-15 00:45:34.000000', 'consum', 0.0210, 'lps'),
	(460668, 126, '2015-03-15 00:45:35.000000', 'consum', 0.0219, 'lps'),
	(460669, 126, '2015-03-15 00:45:36.000000', 'consum', 0.0212, 'lps'),
	(460670, 126, '2015-03-15 00:45:37.000000', 'consum', 0.0210, 'lps'),
	(460671, 126, '2015-03-15 00:45:38.000000', 'consum', 0.0220, 'lps'),
	(460672, 126, '2015-03-15 00:45:39.000000', 'consum', 0.0215, 'lps'),
	(460673, 126, '2015-03-15 00:45:40.000000', 'consum', 0.0222, 'lps'),
	(460674, 126, '2015-03-15 00:45:41.000000', 'consum', 0.0214, 'lps'),
	(460675, 126, '2015-03-15 00:45:42.000000', 'consum', 0.0221, 'lps'),
	(460676, 126, '2015-03-15 00:45:43.000000', 'consum', 0.0212, 'lps'),
	(460677, 126, '2015-03-15 00:45:44.000000', 'consum', 0.0216, 'lps'),
	(460678, 126, '2015-03-15 00:45:45.000000', 'consum', 0.0221, 'lps'),
	(460679, 126, '2015-03-15 00:45:46.000000', 'consum', 0.0220, 'lps'),
	(460680, 126, '2015-03-15 00:45:47.000000', 'consum', 0.0212, 'lps'),
	(460681, 126, '2015-03-15 00:45:48.000000', 'consum', 0.0218, 'lps'),
	(460682, 126, '2015-03-15 00:45:49.000000', 'consum', 0.0217, 'lps'),
	(460683, 126, '2015-03-15 00:45:50.000000', 'consum', 0.0223, 'lps'),
	(460684, 126, '2015-03-15 00:45:51.000000', 'consum', 0.0213, 'lps'),
	(460685, 126, '2015-03-15 00:45:52.000000', 'consum', 0.0214, 'lps'),
	(460686, 126, '2015-03-15 00:45:53.000000', 'consum', 0.0223, 'lps'),
	(460687, 126, '2015-03-15 00:45:54.000000', 'consum', 0.0218, 'lps'),
	(460688, 126, '2015-03-15 00:45:55.000000', 'consum', 0.0215, 'lps'),
	(460689, 126, '2015-03-15 00:45:56.000000', 'consum', 0.0222, 'lps'),
	(460690, 126, '2015-03-15 00:45:57.000000', 'consum', 0.0216, 'lps'),
	(460691, 126, '2015-03-15 00:45:58.000000', 'consum', 0.0216, 'lps'),
	(460692, 126, '2015-03-15 00:45:59.000000', 'consum', 0.0210, 'lps'),
	(460693, 126, '2015-03-15 00:46:00.000000', 'consum', 0.0221, 'lps'),
	(460694, 126, '2015-03-15 00:46:01.000000', 'consum', 0.0210, 'lps'),
	(460695, 126, '2015-03-15 00:46:02.000000', 'consum', 0.0220, 'lps'),
	(460696, 126, '2015-03-15 00:46:03.000000', 'consum', 0.0219, 'lps'),
	(460697, 126, '2015-03-15 00:46:04.000000', 'consum', 0.0212, 'lps'),
	(460698, 126, '2015-03-15 00:46:05.000000', 'consum', 0.0220, 'lps'),
	(460699, 126, '2015-03-15 00:46:06.000000', 'consum', 0.0212, 'lps'),
	(460700, 126, '2015-03-15 00:46:07.000000', 'consum', 0.0221, 'lps'),
	(460701, 126, '2015-03-15 00:46:08.000000', 'consum', 0.0214, 'lps'),
	(460702, 126, '2015-03-15 00:46:09.000000', 'consum', 0.0215, 'lps'),
	(460703, 126, '2015-03-15 00:46:10.000000', 'consum', 0.0221, 'lps'),
	(460704, 126, '2015-03-15 00:46:11.000000', 'consum', 0.0211, 'lps'),
	(460705, 126, '2015-03-15 00:46:12.000000', 'consum', 0.0222, 'lps'),
	(460706, 126, '2015-03-15 00:46:13.000000', 'consum', 0.0210, 'lps'),
	(460707, 126, '2015-03-15 00:46:14.000000', 'consum', 0.0220, 'lps'),
	(460708, 126, '2015-03-15 00:46:15.000000', 'consum', 0.0217, 'lps'),
	(460709, 126, '2015-03-15 00:46:16.000000', 'consum', 0.0216, 'lps'),
	(460710, 126, '2015-03-15 00:46:17.000000', 'consum', 0.0217, 'lps'),
	(460711, 126, '2015-03-15 00:46:18.000000', 'consum', 0.0217, 'lps'),
	(460712, 126, '2015-03-15 00:46:19.000000', 'consum', 0.0222, 'lps'),
	(460713, 126, '2015-03-15 00:46:20.000000', 'consum', 0.0222, 'lps'),
	(460714, 126, '2015-03-15 00:46:21.000000', 'consum', 0.0221, 'lps'),
	(460715, 126, '2015-03-15 00:46:22.000000', 'consum', 0.0214, 'lps'),
	(460716, 126, '2015-03-15 00:46:23.000000', 'consum', 0.0211, 'lps'),
	(460717, 126, '2015-03-15 00:46:24.000000', 'consum', 0.0217, 'lps'),
	(460718, 126, '2015-03-15 00:46:25.000000', 'consum', 0.0216, 'lps'),
	(460719, 126, '2015-03-15 00:46:26.000000', 'consum', 0.0221, 'lps'),
	(460720, 126, '2015-03-15 00:46:27.000000', 'consum', 0.0219, 'lps'),
	(460721, 126, '2015-03-15 00:46:28.000000', 'consum', 0.0223, 'lps'),
	(460722, 126, '2015-03-15 00:46:29.000000', 'consum', 0.0221, 'lps'),
	(460723, 126, '2015-03-15 00:46:30.000000', 'consum', 0.0210, 'lps'),
	(460724, 126, '2015-03-15 00:46:31.000000', 'consum', 0.0221, 'lps'),
	(460725, 126, '2015-03-15 00:46:32.000000', 'consum', 0.0222, 'lps'),
	(460726, 126, '2015-03-15 00:46:33.000000', 'consum', 0.0210, 'lps'),
	(460727, 126, '2015-03-15 00:46:34.000000', 'consum', 0.0215, 'lps'),
	(460728, 126, '2015-03-15 00:46:35.000000', 'consum', 0.0211, 'lps'),
	(460729, 126, '2015-03-15 00:46:36.000000', 'consum', 0.0212, 'lps'),
	(460730, 126, '2015-03-15 00:46:37.000000', 'consum', 0.0217, 'lps'),
	(460731, 126, '2015-03-15 00:46:38.000000', 'consum', 0.0212, 'lps'),
	(460732, 126, '2015-03-15 00:46:39.000000', 'consum', 0.0214, 'lps'),
	(460733, 126, '2015-03-15 00:46:40.000000', 'consum', 0.0211, 'lps'),
	(460734, 126, '2015-03-15 00:46:41.000000', 'consum', 0.0218, 'lps'),
	(460735, 126, '2015-03-15 00:46:42.000000', 'consum', 0.0217, 'lps'),
	(460736, 126, '2015-03-15 00:46:43.000000', 'consum', 0.0210, 'lps'),
	(460737, 126, '2015-03-15 00:46:44.000000', 'consum', 0.0216, 'lps'),
	(460738, 126, '2015-03-15 00:46:45.000000', 'consum', 0.0212, 'lps'),
	(460739, 126, '2015-03-15 00:46:46.000000', 'consum', 0.0216, 'lps'),
	(460740, 126, '2015-03-15 00:46:47.000000', 'consum', 0.0220, 'lps'),
	(460741, 126, '2015-03-15 00:46:48.000000', 'consum', 0.0215, 'lps'),
	(460742, 126, '2015-03-15 00:46:49.000000', 'consum', 0.0219, 'lps'),
	(460743, 126, '2015-03-15 00:46:50.000000', 'consum', 0.0215, 'lps'),
	(460744, 126, '2015-03-15 00:46:51.000000', 'consum', 0.0222, 'lps'),
	(460745, 126, '2015-03-15 00:46:52.000000', 'consum', 0.0211, 'lps'),
	(460746, 126, '2015-03-15 00:46:53.000000', 'consum', 0.0223, 'lps'),
	(460747, 126, '2015-03-15 00:46:54.000000', 'consum', 0.0215, 'lps'),
	(460748, 126, '2015-03-15 00:46:55.000000', 'consum', 0.0210, 'lps'),
	(460749, 126, '2015-03-15 00:46:56.000000', 'consum', 0.0212, 'lps'),
	(460750, 126, '2015-03-15 00:46:57.000000', 'consum', 0.0221, 'lps'),
	(460751, 126, '2015-03-15 00:46:58.000000', 'consum', 0.0217, 'lps'),
	(460752, 126, '2015-03-15 00:46:59.000000', 'consum', 0.0213, 'lps'),
	(460753, 126, '2015-03-15 00:47:00.000000', 'consum', 0.0220, 'lps'),
	(460754, 126, '2015-03-15 00:47:01.000000', 'consum', 0.0221, 'lps'),
	(460755, 126, '2015-03-15 00:47:02.000000', 'consum', 0.0210, 'lps'),
	(460756, 126, '2015-03-15 00:47:03.000000', 'consum', 0.0218, 'lps'),
	(460757, 126, '2015-03-15 00:47:04.000000', 'consum', 0.0221, 'lps'),
	(460758, 126, '2015-03-15 00:47:05.000000', 'consum', 0.0214, 'lps'),
	(460759, 126, '2015-03-15 00:47:06.000000', 'consum', 0.0210, 'lps'),
	(460760, 126, '2015-03-15 00:47:07.000000', 'consum', 0.0215, 'lps'),
	(460761, 126, '2015-03-15 00:47:08.000000', 'consum', 0.0222, 'lps'),
	(460762, 126, '2015-03-15 00:47:09.000000', 'consum', 0.0214, 'lps'),
	(460763, 126, '2015-03-15 00:47:10.000000', 'consum', 0.0223, 'lps'),
	(460764, 126, '2015-03-15 00:47:11.000000', 'consum', 0.0222, 'lps'),
	(460765, 126, '2015-03-15 00:47:12.000000', 'consum', 0.0217, 'lps'),
	(460766, 126, '2015-03-15 00:47:13.000000', 'consum', 0.0223, 'lps'),
	(460767, 126, '2015-03-15 00:47:14.000000', 'consum', 0.0214, 'lps'),
	(460768, 126, '2015-03-15 00:47:15.000000', 'consum', 0.0219, 'lps'),
	(460769, 126, '2015-03-15 00:47:16.000000', 'consum', 0.0217, 'lps'),
	(460770, 126, '2015-03-15 00:47:17.000000', 'consum', 0.0216, 'lps'),
	(460771, 126, '2015-03-15 00:47:18.000000', 'consum', 0.0222, 'lps'),
	(460772, 126, '2015-03-15 00:47:19.000000', 'consum', 0.0222, 'lps'),
	(460773, 126, '2015-03-15 00:47:20.000000', 'consum', 0.0220, 'lps'),
	(460774, 126, '2015-03-15 00:47:21.000000', 'consum', 0.0213, 'lps'),
	(460775, 126, '2015-03-15 00:47:22.000000', 'consum', 0.0222, 'lps'),
	(460776, 126, '2015-03-15 00:47:23.000000', 'consum', 0.0219, 'lps'),
	(460777, 126, '2015-03-15 00:47:24.000000', 'consum', 0.0220, 'lps'),
	(460778, 126, '2015-03-15 00:47:25.000000', 'consum', 0.0221, 'lps'),
	(460779, 126, '2015-03-15 00:47:26.000000', 'consum', 0.0222, 'lps'),
	(460780, 126, '2015-03-15 00:47:27.000000', 'consum', 0.0221, 'lps'),
	(460781, 126, '2015-03-15 00:47:28.000000', 'consum', 0.0216, 'lps'),
	(460782, 126, '2015-03-15 00:47:29.000000', 'consum', 0.0220, 'lps'),
	(460783, 126, '2015-03-15 00:47:30.000000', 'consum', 0.0218, 'lps'),
	(460784, 126, '2015-03-15 00:47:31.000000', 'consum', 0.0218, 'lps'),
	(460785, 126, '2015-03-15 00:47:32.000000', 'consum', 0.0215, 'lps'),
	(460786, 126, '2015-03-15 00:47:33.000000', 'consum', 0.0210, 'lps'),
	(460787, 126, '2015-03-15 00:47:34.000000', 'consum', 0.0210, 'lps'),
	(460788, 126, '2015-03-15 00:47:35.000000', 'consum', 0.0222, 'lps'),
	(460789, 126, '2015-03-15 00:47:36.000000', 'consum', 0.0217, 'lps'),
	(460790, 126, '2015-03-15 00:47:37.000000', 'consum', 0.0223, 'lps'),
	(460791, 126, '2015-03-15 00:47:38.000000', 'consum', 0.0214, 'lps'),
	(460792, 126, '2015-03-15 00:47:39.000000', 'consum', 0.0217, 'lps'),
	(460793, 126, '2015-03-15 00:47:40.000000', 'consum', 0.0219, 'lps'),
	(460794, 126, '2015-03-15 00:47:41.000000', 'consum', 0.0220, 'lps'),
	(460795, 126, '2015-03-15 00:47:42.000000', 'consum', 0.0221, 'lps'),
	(460796, 126, '2015-03-15 00:47:43.000000', 'consum', 0.0221, 'lps'),
	(460797, 126, '2015-03-15 00:47:44.000000', 'consum', 0.0217, 'lps'),
	(460798, 126, '2015-03-15 00:47:45.000000', 'consum', 0.0212, 'lps'),
	(460799, 126, '2015-03-15 00:47:46.000000', 'consum', 0.0215, 'lps'),
	(460800, 126, '2015-03-15 00:47:47.000000', 'consum', 0.0215, 'lps'),
	(460801, 126, '2015-03-15 00:47:48.000000', 'consum', 0.0220, 'lps'),
	(460802, 126, '2015-03-15 00:47:49.000000', 'consum', 0.0218, 'lps'),
	(460803, 126, '2015-03-15 00:47:50.000000', 'consum', 0.0219, 'lps'),
	(460804, 126, '2015-03-15 00:47:51.000000', 'consum', 0.0219, 'lps'),
	(460805, 126, '2015-03-15 00:47:52.000000', 'consum', 0.0215, 'lps'),
	(460806, 126, '2015-03-15 00:47:53.000000', 'consum', 0.0223, 'lps'),
	(460807, 126, '2015-03-15 00:47:54.000000', 'consum', 0.0217, 'lps'),
	(460808, 126, '2015-03-15 00:47:55.000000', 'consum', 0.0221, 'lps'),
	(460809, 126, '2015-03-15 00:47:56.000000', 'consum', 0.0216, 'lps'),
	(460810, 126, '2015-03-15 00:47:57.000000', 'consum', 0.0221, 'lps'),
	(460811, 126, '2015-03-15 00:47:58.000000', 'consum', 0.0222, 'lps'),
	(460812, 126, '2015-03-15 00:47:59.000000', 'consum', 0.0220, 'lps'),
	(460813, 126, '2015-03-15 00:48:00.000000', 'consum', 0.0214, 'lps'),
	(460814, 126, '2015-03-15 00:48:01.000000', 'consum', 0.0213, 'lps'),
	(460815, 126, '2015-03-15 00:48:02.000000', 'consum', 0.0213, 'lps'),
	(460816, 126, '2015-03-15 00:48:03.000000', 'consum', 0.0217, 'lps'),
	(460817, 126, '2015-03-15 00:48:04.000000', 'consum', 0.0210, 'lps'),
	(460818, 126, '2015-03-15 00:48:05.000000', 'consum', 0.0216, 'lps'),
	(460819, 126, '2015-03-15 00:48:06.000000', 'consum', 0.0214, 'lps'),
	(460820, 126, '2015-03-15 00:48:07.000000', 'consum', 0.0212, 'lps'),
	(460821, 126, '2015-03-15 00:48:08.000000', 'consum', 0.0223, 'lps'),
	(460822, 126, '2015-03-15 00:48:09.000000', 'consum', 0.0213, 'lps'),
	(460823, 126, '2015-03-15 00:48:10.000000', 'consum', 0.0213, 'lps'),
	(460824, 126, '2015-03-15 00:48:11.000000', 'consum', 0.0219, 'lps'),
	(460825, 126, '2015-03-15 00:48:12.000000', 'consum', 0.0218, 'lps'),
	(460826, 126, '2015-03-15 00:48:13.000000', 'consum', 0.0222, 'lps'),
	(460827, 126, '2015-03-15 00:48:14.000000', 'consum', 0.0220, 'lps'),
	(460828, 126, '2015-03-15 00:48:15.000000', 'consum', 0.0222, 'lps'),
	(460829, 126, '2015-03-15 00:48:16.000000', 'consum', 0.0214, 'lps'),
	(460830, 126, '2015-03-15 00:48:17.000000', 'consum', 0.0211, 'lps'),
	(460831, 126, '2015-03-15 00:48:18.000000', 'consum', 0.0214, 'lps'),
	(460832, 126, '2015-03-15 00:48:19.000000', 'consum', 0.0213, 'lps'),
	(460833, 126, '2015-03-15 00:48:20.000000', 'consum', 0.0216, 'lps'),
	(460834, 126, '2015-03-15 00:48:21.000000', 'consum', 0.0215, 'lps'),
	(460835, 126, '2015-03-15 00:48:22.000000', 'consum', 0.0220, 'lps'),
	(460836, 126, '2015-03-15 00:48:23.000000', 'consum', 0.0219, 'lps'),
	(460837, 126, '2015-03-15 00:48:24.000000', 'consum', 0.0222, 'lps'),
	(460838, 126, '2015-03-15 00:48:25.000000', 'consum', 0.0215, 'lps'),
	(460839, 126, '2015-03-15 00:48:26.000000', 'consum', 0.0217, 'lps'),
	(460840, 126, '2015-03-15 00:48:27.000000', 'consum', 0.0214, 'lps'),
	(460841, 126, '2015-03-15 00:48:28.000000', 'consum', 0.0223, 'lps'),
	(460842, 126, '2015-03-15 00:48:29.000000', 'consum', 0.0221, 'lps'),
	(460843, 126, '2015-03-15 00:48:30.000000', 'consum', 0.0215, 'lps'),
	(460844, 126, '2015-03-15 00:48:31.000000', 'consum', 0.0215, 'lps'),
	(460845, 126, '2015-03-15 00:48:32.000000', 'consum', 0.0220, 'lps'),
	(460846, 126, '2015-03-15 00:48:33.000000', 'consum', 0.0219, 'lps'),
	(460847, 126, '2015-03-15 00:48:34.000000', 'consum', 0.0210, 'lps'),
	(460848, 126, '2015-03-15 00:48:35.000000', 'consum', 0.0212, 'lps'),
	(460849, 126, '2015-03-15 00:48:36.000000', 'consum', 0.0223, 'lps'),
	(460850, 126, '2015-03-15 00:48:37.000000', 'consum', 0.0210, 'lps'),
	(460851, 126, '2015-03-15 00:48:38.000000', 'consum', 0.0214, 'lps'),
	(460852, 126, '2015-03-15 00:48:39.000000', 'consum', 0.0217, 'lps'),
	(460853, 126, '2015-03-15 00:48:40.000000', 'consum', 0.0221, 'lps'),
	(460854, 126, '2015-03-15 00:48:41.000000', 'consum', 0.0217, 'lps'),
	(460855, 126, '2015-03-15 00:48:42.000000', 'consum', 0.0213, 'lps'),
	(460856, 126, '2015-03-15 00:48:43.000000', 'consum', 0.0217, 'lps'),
	(460857, 126, '2015-03-15 00:48:44.000000', 'consum', 0.0210, 'lps'),
	(460858, 126, '2015-03-15 00:48:45.000000', 'consum', 0.0218, 'lps'),
	(460859, 126, '2015-03-15 00:48:46.000000', 'consum', 0.0220, 'lps'),
	(460860, 126, '2015-03-15 00:48:47.000000', 'consum', 0.0211, 'lps'),
	(460861, 126, '2015-03-15 00:48:48.000000', 'consum', 0.0212, 'lps'),
	(460862, 126, '2015-03-15 00:48:49.000000', 'consum', 0.0220, 'lps'),
	(460863, 126, '2015-03-15 00:48:50.000000', 'consum', 0.0210, 'lps'),
	(460864, 126, '2015-03-15 00:48:51.000000', 'consum', 0.0223, 'lps'),
	(460865, 126, '2015-03-15 00:48:52.000000', 'consum', 0.0221, 'lps'),
	(460866, 126, '2015-03-15 00:48:53.000000', 'consum', 0.0223, 'lps'),
	(460867, 126, '2015-03-15 00:48:54.000000', 'consum', 0.0218, 'lps'),
	(460868, 126, '2015-03-15 00:48:55.000000', 'consum', 0.0211, 'lps'),
	(460869, 126, '2015-03-15 00:48:56.000000', 'consum', 0.0219, 'lps'),
	(460870, 126, '2015-03-15 00:48:57.000000', 'consum', 0.0210, 'lps'),
	(460871, 126, '2015-03-15 00:48:58.000000', 'consum', 0.0214, 'lps'),
	(460872, 126, '2015-03-15 00:48:59.000000', 'consum', 0.0214, 'lps'),
	(460873, 126, '2015-03-15 00:49:00.000000', 'consum', 0.0220, 'lps'),
	(460874, 126, '2015-03-15 00:49:01.000000', 'consum', 0.0218, 'lps'),
	(460875, 126, '2015-03-15 00:49:02.000000', 'consum', 0.0210, 'lps'),
	(460876, 126, '2015-03-15 00:49:03.000000', 'consum', 0.0213, 'lps'),
	(460877, 126, '2015-03-15 00:49:04.000000', 'consum', 0.0211, 'lps'),
	(460878, 126, '2015-03-15 00:49:05.000000', 'consum', 0.0221, 'lps'),
	(460879, 126, '2015-03-15 00:49:06.000000', 'consum', 0.0220, 'lps'),
	(460880, 126, '2015-03-15 00:49:07.000000', 'consum', 0.0212, 'lps'),
	(460881, 126, '2015-03-15 00:49:08.000000', 'consum', 0.0220, 'lps'),
	(460882, 126, '2015-03-15 00:49:09.000000', 'consum', 0.0214, 'lps'),
	(460883, 126, '2015-03-15 00:49:10.000000', 'consum', 0.0215, 'lps'),
	(460884, 126, '2015-03-15 00:49:11.000000', 'consum', 0.0221, 'lps'),
	(460885, 126, '2015-03-15 00:49:12.000000', 'consum', 0.0222, 'lps'),
	(460886, 126, '2015-03-15 00:49:13.000000', 'consum', 0.0212, 'lps'),
	(460887, 126, '2015-03-15 00:49:14.000000', 'consum', 0.0210, 'lps'),
	(460888, 126, '2015-03-15 00:49:15.000000', 'consum', 0.0221, 'lps'),
	(460889, 126, '2015-03-15 00:49:16.000000', 'consum', 0.0223, 'lps'),
	(460890, 126, '2015-03-15 00:49:17.000000', 'consum', 0.0212, 'lps'),
	(460891, 126, '2015-03-15 00:49:18.000000', 'consum', 0.0213, 'lps'),
	(460892, 126, '2015-03-15 00:49:19.000000', 'consum', 0.0217, 'lps'),
	(460893, 126, '2015-03-15 00:49:20.000000', 'consum', 0.0211, 'lps'),
	(460894, 126, '2015-03-15 00:49:21.000000', 'consum', 0.0220, 'lps'),
	(460895, 126, '2015-03-15 00:49:22.000000', 'consum', 0.0216, 'lps'),
	(460896, 126, '2015-03-15 00:49:23.000000', 'consum', 0.0210, 'lps'),
	(460897, 126, '2015-03-15 00:49:24.000000', 'consum', 0.0221, 'lps'),
	(460898, 126, '2015-03-15 00:49:25.000000', 'consum', 0.0212, 'lps'),
	(460899, 126, '2015-03-15 00:49:26.000000', 'consum', 0.0212, 'lps'),
	(460900, 126, '2015-03-15 00:49:27.000000', 'consum', 0.0217, 'lps'),
	(460901, 126, '2015-03-15 00:49:28.000000', 'consum', 0.0210, 'lps'),
	(460902, 126, '2015-03-15 00:49:29.000000', 'consum', 0.0218, 'lps'),
	(460903, 126, '2015-03-15 00:49:30.000000', 'consum', 0.0221, 'lps'),
	(460904, 126, '2015-03-15 00:49:31.000000', 'consum', 0.0214, 'lps'),
	(460905, 126, '2015-03-15 00:49:32.000000', 'consum', 0.0214, 'lps'),
	(460906, 126, '2015-03-15 00:49:33.000000', 'consum', 0.0217, 'lps'),
	(460907, 126, '2015-03-15 00:49:34.000000', 'consum', 0.0219, 'lps'),
	(460908, 126, '2015-03-15 00:49:35.000000', 'consum', 0.0219, 'lps'),
	(460909, 126, '2015-03-15 00:49:36.000000', 'consum', 0.0217, 'lps'),
	(460910, 126, '2015-03-15 00:49:37.000000', 'consum', 0.0217, 'lps'),
	(460911, 126, '2015-03-15 00:49:38.000000', 'consum', 0.0223, 'lps'),
	(460912, 126, '2015-03-15 00:49:39.000000', 'consum', 0.0216, 'lps'),
	(460913, 126, '2015-03-15 00:49:40.000000', 'consum', 0.0213, 'lps'),
	(460914, 126, '2015-03-15 00:49:41.000000', 'consum', 0.0222, 'lps'),
	(460915, 126, '2015-03-15 00:49:42.000000', 'consum', 0.0221, 'lps'),
	(460916, 126, '2015-03-15 00:49:43.000000', 'consum', 0.0214, 'lps'),
	(460917, 126, '2015-03-15 00:49:44.000000', 'consum', 0.0213, 'lps'),
	(460918, 126, '2015-03-15 00:49:45.000000', 'consum', 0.0211, 'lps'),
	(460919, 126, '2015-03-15 00:49:46.000000', 'consum', 0.0220, 'lps'),
	(460920, 126, '2015-03-15 00:49:47.000000', 'consum', 0.0218, 'lps'),
	(460921, 126, '2015-03-15 00:49:48.000000', 'consum', 0.0221, 'lps'),
	(460922, 126, '2015-03-15 00:49:49.000000', 'consum', 0.0211, 'lps'),
	(460923, 126, '2015-03-15 00:49:50.000000', 'consum', 0.0213, 'lps'),
	(460924, 126, '2015-03-15 00:49:51.000000', 'consum', 0.0220, 'lps'),
	(460925, 126, '2015-03-15 00:49:52.000000', 'consum', 0.0211, 'lps'),
	(460926, 126, '2015-03-15 00:49:53.000000', 'consum', 0.0212, 'lps'),
	(460927, 126, '2015-03-15 00:49:54.000000', 'consum', 0.0218, 'lps'),
	(460928, 126, '2015-03-15 00:49:55.000000', 'consum', 0.0217, 'lps'),
	(460929, 126, '2015-03-15 00:49:56.000000', 'consum', 0.0219, 'lps'),
	(460930, 126, '2015-03-15 00:49:57.000000', 'consum', 0.0223, 'lps'),
	(460931, 126, '2015-03-15 00:49:58.000000', 'consum', 0.0221, 'lps'),
	(460932, 126, '2015-03-15 00:49:59.000000', 'consum', 0.0210, 'lps'),
	(460933, 126, '2015-03-15 00:50:00.000000', 'consum', 0.0219, 'lps'),
	(460934, 126, '2015-03-15 00:50:01.000000', 'consum', 0.0216, 'lps'),
	(460935, 126, '2015-03-15 00:50:02.000000', 'consum', 0.0212, 'lps'),
	(460936, 126, '2015-03-15 00:50:03.000000', 'consum', 0.0216, 'lps'),
	(460937, 126, '2015-03-15 00:50:04.000000', 'consum', 0.0223, 'lps'),
	(460938, 126, '2015-03-15 00:50:05.000000', 'consum', 0.0215, 'lps'),
	(460939, 126, '2015-03-15 00:50:06.000000', 'consum', 0.0222, 'lps'),
	(460940, 126, '2015-03-15 00:50:07.000000', 'consum', 0.0214, 'lps'),
	(460941, 126, '2015-03-15 00:50:08.000000', 'consum', 0.0223, 'lps'),
	(460942, 126, '2015-03-15 00:50:09.000000', 'consum', 0.0223, 'lps'),
	(460943, 126, '2015-03-15 00:50:10.000000', 'consum', 0.0219, 'lps'),
	(460944, 126, '2015-03-15 00:50:11.000000', 'consum', 0.0220, 'lps'),
	(460945, 126, '2015-03-15 00:50:12.000000', 'consum', 0.0220, 'lps'),
	(460946, 126, '2015-03-15 00:50:13.000000', 'consum', 0.0214, 'lps'),
	(460947, 126, '2015-03-15 00:50:14.000000', 'consum', 0.0215, 'lps'),
	(460948, 126, '2015-03-15 00:50:15.000000', 'consum', 0.0223, 'lps'),
	(460949, 126, '2015-03-15 00:50:16.000000', 'consum', 0.0218, 'lps'),
	(460950, 126, '2015-03-15 00:50:17.000000', 'consum', 0.0213, 'lps'),
	(460951, 126, '2015-03-15 00:50:18.000000', 'consum', 0.0214, 'lps'),
	(460952, 126, '2015-03-15 00:50:19.000000', 'consum', 0.0220, 'lps'),
	(460953, 126, '2015-03-15 00:50:20.000000', 'consum', 0.0210, 'lps'),
	(460954, 126, '2015-03-15 00:50:21.000000', 'consum', 0.0221, 'lps'),
	(460955, 126, '2015-03-15 00:50:22.000000', 'consum', 0.0211, 'lps'),
	(460956, 126, '2015-03-15 00:50:23.000000', 'consum', 0.0222, 'lps'),
	(460957, 126, '2015-03-15 00:50:24.000000', 'consum', 0.0212, 'lps'),
	(460958, 126, '2015-03-15 00:50:25.000000', 'consum', 0.0214, 'lps'),
	(460959, 126, '2015-03-15 00:50:26.000000', 'consum', 0.0211, 'lps'),
	(460960, 126, '2015-03-15 00:50:27.000000', 'consum', 0.0218, 'lps'),
	(460961, 126, '2015-03-15 00:50:28.000000', 'consum', 0.0220, 'lps'),
	(460962, 126, '2015-03-15 00:50:29.000000', 'consum', 0.0220, 'lps'),
	(460963, 126, '2015-03-15 00:50:30.000000', 'consum', 0.0218, 'lps'),
	(460964, 126, '2015-03-15 00:50:31.000000', 'consum', 0.0221, 'lps'),
	(460965, 126, '2015-03-15 00:50:32.000000', 'consum', 0.0212, 'lps'),
	(460966, 126, '2015-03-15 00:50:33.000000', 'consum', 0.0214, 'lps'),
	(460967, 126, '2015-03-15 00:50:34.000000', 'consum', 0.0212, 'lps'),
	(460968, 126, '2015-03-15 00:50:35.000000', 'consum', 0.0223, 'lps'),
	(460969, 126, '2015-03-15 00:50:36.000000', 'consum', 0.0213, 'lps'),
	(460970, 126, '2015-03-15 00:50:37.000000', 'consum', 0.0215, 'lps'),
	(460971, 126, '2015-03-15 00:50:38.000000', 'consum', 0.0213, 'lps'),
	(460972, 126, '2015-03-15 00:50:39.000000', 'consum', 0.0212, 'lps'),
	(460973, 126, '2015-03-15 00:50:40.000000', 'consum', 0.0223, 'lps'),
	(460974, 126, '2015-03-15 00:50:41.000000', 'consum', 0.0212, 'lps'),
	(460975, 126, '2015-03-15 00:50:42.000000', 'consum', 0.0212, 'lps'),
	(460976, 126, '2015-03-15 00:50:43.000000', 'consum', 0.0214, 'lps'),
	(460977, 126, '2015-03-15 00:50:44.000000', 'consum', 0.0222, 'lps'),
	(460978, 126, '2015-03-15 00:50:45.000000', 'consum', 0.0219, 'lps'),
	(460979, 126, '2015-03-15 00:50:46.000000', 'consum', 0.0221, 'lps'),
	(460980, 126, '2015-03-15 00:50:47.000000', 'consum', 0.0223, 'lps'),
	(460981, 126, '2015-03-15 00:50:48.000000', 'consum', 0.0214, 'lps'),
	(460982, 126, '2015-03-15 00:50:49.000000', 'consum', 0.0221, 'lps'),
	(460983, 126, '2015-03-15 00:50:50.000000', 'consum', 0.0211, 'lps'),
	(460984, 126, '2015-03-15 00:50:51.000000', 'consum', 0.0211, 'lps'),
	(460985, 126, '2015-03-15 00:50:52.000000', 'consum', 0.0214, 'lps'),
	(460986, 126, '2015-03-15 00:50:53.000000', 'consum', 0.0213, 'lps'),
	(460987, 126, '2015-03-15 00:50:54.000000', 'consum', 0.0212, 'lps'),
	(460988, 126, '2015-03-15 00:50:55.000000', 'consum', 0.0210, 'lps'),
	(460989, 126, '2015-03-15 00:50:56.000000', 'consum', 0.0221, 'lps'),
	(460990, 126, '2015-03-15 00:50:57.000000', 'consum', 0.0223, 'lps'),
	(460991, 126, '2015-03-15 00:50:58.000000', 'consum', 0.0215, 'lps'),
	(460992, 126, '2015-03-15 00:50:59.000000', 'consum', 0.0222, 'lps'),
	(460993, 126, '2015-03-15 00:51:00.000000', 'consum', 0.0215, 'lps'),
	(460994, 126, '2015-03-15 00:51:01.000000', 'consum', 0.0212, 'lps'),
	(460995, 126, '2015-03-15 00:51:02.000000', 'consum', 0.0221, 'lps'),
	(460996, 126, '2015-03-15 00:51:03.000000', 'consum', 0.0216, 'lps'),
	(460997, 126, '2015-03-15 00:51:04.000000', 'consum', 0.0222, 'lps'),
	(460998, 126, '2015-03-15 00:51:05.000000', 'consum', 0.0223, 'lps'),
	(460999, 126, '2015-03-15 00:51:06.000000', 'consum', 0.0214, 'lps'),
	(461000, 126, '2015-03-15 00:51:07.000000', 'consum', 0.0219, 'lps'),
	(461001, 126, '2015-03-15 00:51:08.000000', 'consum', 0.0215, 'lps'),
	(461002, 126, '2015-03-15 00:51:09.000000', 'consum', 0.0222, 'lps'),
	(461003, 126, '2015-03-15 00:51:10.000000', 'consum', 0.0213, 'lps'),
	(461004, 126, '2015-03-15 00:51:11.000000', 'consum', 0.0217, 'lps'),
	(461005, 126, '2015-03-15 00:51:12.000000', 'consum', 0.0210, 'lps'),
	(461006, 126, '2015-03-15 00:51:13.000000', 'consum', 0.0217, 'lps'),
	(461007, 126, '2015-03-15 00:51:14.000000', 'consum', 0.0216, 'lps'),
	(461008, 126, '2015-03-15 00:51:15.000000', 'consum', 0.0219, 'lps'),
	(461009, 126, '2015-03-15 00:51:16.000000', 'consum', 0.0210, 'lps'),
	(461010, 126, '2015-03-15 00:51:17.000000', 'consum', 0.0214, 'lps'),
	(461011, 126, '2015-03-15 00:51:18.000000', 'consum', 0.0213, 'lps'),
	(461012, 126, '2015-03-15 00:51:19.000000', 'consum', 0.0215, 'lps'),
	(461013, 126, '2015-03-15 00:51:20.000000', 'consum', 0.0213, 'lps'),
	(461014, 126, '2015-03-15 00:51:21.000000', 'consum', 0.0210, 'lps'),
	(461015, 126, '2015-03-15 00:51:22.000000', 'consum', 0.0216, 'lps'),
	(461016, 126, '2015-03-15 00:51:23.000000', 'consum', 0.0212, 'lps'),
	(461017, 126, '2015-03-15 00:51:24.000000', 'consum', 0.0215, 'lps'),
	(461018, 126, '2015-03-15 00:51:25.000000', 'consum', 0.0215, 'lps'),
	(461019, 126, '2015-03-15 00:51:26.000000', 'consum', 0.0220, 'lps'),
	(461020, 126, '2015-03-15 00:51:27.000000', 'consum', 0.0220, 'lps'),
	(461021, 126, '2015-03-15 00:51:28.000000', 'consum', 0.0214, 'lps'),
	(461022, 126, '2015-03-15 00:51:29.000000', 'consum', 0.0214, 'lps'),
	(461023, 126, '2015-03-15 00:51:30.000000', 'consum', 0.0218, 'lps'),
	(461024, 126, '2015-03-15 00:51:31.000000', 'consum', 0.0210, 'lps'),
	(461025, 126, '2015-03-15 00:51:32.000000', 'consum', 0.0214, 'lps'),
	(461026, 126, '2015-03-15 00:51:33.000000', 'consum', 0.0216, 'lps'),
	(461027, 126, '2015-03-15 00:51:34.000000', 'consum', 0.0217, 'lps'),
	(461028, 126, '2015-03-15 00:51:35.000000', 'consum', 0.0213, 'lps'),
	(461029, 126, '2015-03-15 00:51:36.000000', 'consum', 0.0219, 'lps'),
	(461030, 126, '2015-03-15 00:51:37.000000', 'consum', 0.0218, 'lps'),
	(461031, 126, '2015-03-15 00:51:38.000000', 'consum', 0.0223, 'lps'),
	(461032, 126, '2015-03-15 00:51:39.000000', 'consum', 0.0222, 'lps'),
	(461033, 126, '2015-03-15 00:51:40.000000', 'consum', 0.0218, 'lps'),
	(461034, 126, '2015-03-15 00:51:41.000000', 'consum', 0.0213, 'lps'),
	(461035, 126, '2015-03-15 00:51:42.000000', 'consum', 0.0219, 'lps'),
	(461036, 126, '2015-03-15 00:51:43.000000', 'consum', 0.0217, 'lps'),
	(461037, 126, '2015-03-15 00:51:44.000000', 'consum', 0.0220, 'lps'),
	(461038, 126, '2015-03-15 00:51:45.000000', 'consum', 0.0223, 'lps'),
	(461039, 126, '2015-03-15 00:51:46.000000', 'consum', 0.0217, 'lps'),
	(461040, 126, '2015-03-15 00:51:47.000000', 'consum', 0.0222, 'lps'),
	(461041, 126, '2015-03-15 00:51:48.000000', 'consum', 0.0223, 'lps'),
	(461042, 126, '2015-03-15 00:51:49.000000', 'consum', 0.0210, 'lps'),
	(461043, 126, '2015-03-15 00:51:50.000000', 'consum', 0.0212, 'lps'),
	(461044, 126, '2015-03-15 00:51:51.000000', 'consum', 0.0222, 'lps'),
	(461045, 126, '2015-03-15 00:51:52.000000', 'consum', 0.0210, 'lps'),
	(461046, 126, '2015-03-15 00:51:53.000000', 'consum', 0.0214, 'lps'),
	(461047, 126, '2015-03-15 00:51:54.000000', 'consum', 0.0219, 'lps'),
	(461048, 126, '2015-03-15 00:51:55.000000', 'consum', 0.0214, 'lps'),
	(461049, 126, '2015-03-15 00:51:56.000000', 'consum', 0.0216, 'lps'),
	(461050, 126, '2015-03-15 00:51:57.000000', 'consum', 0.0216, 'lps'),
	(461051, 126, '2015-03-15 00:51:58.000000', 'consum', 0.0220, 'lps'),
	(461052, 126, '2015-03-15 00:51:59.000000', 'consum', 0.0218, 'lps'),
	(461053, 126, '2015-03-15 00:52:00.000000', 'consum', 0.0217, 'lps'),
	(461054, 126, '2015-03-15 00:52:01.000000', 'consum', 0.0210, 'lps'),
	(461055, 126, '2015-03-15 00:52:02.000000', 'consum', 0.0215, 'lps'),
	(461056, 126, '2015-03-15 00:52:03.000000', 'consum', 0.0211, 'lps'),
	(461057, 126, '2015-03-15 00:52:04.000000', 'consum', 0.0211, 'lps'),
	(461058, 126, '2015-03-15 00:52:05.000000', 'consum', 0.0216, 'lps'),
	(461059, 126, '2015-03-15 00:52:06.000000', 'consum', 0.0220, 'lps'),
	(461060, 126, '2015-03-15 00:52:07.000000', 'consum', 0.0217, 'lps'),
	(461061, 126, '2015-03-15 00:52:08.000000', 'consum', 0.0214, 'lps'),
	(461062, 126, '2015-03-15 00:52:09.000000', 'consum', 0.0211, 'lps'),
	(461063, 126, '2015-03-15 00:52:10.000000', 'consum', 0.0218, 'lps'),
	(461064, 126, '2015-03-15 00:52:11.000000', 'consum', 0.0220, 'lps'),
	(461065, 126, '2015-03-15 00:52:12.000000', 'consum', 0.0221, 'lps'),
	(461066, 126, '2015-03-15 00:52:13.000000', 'consum', 0.0220, 'lps'),
	(461067, 126, '2015-03-15 00:52:14.000000', 'consum', 0.0216, 'lps'),
	(461068, 126, '2015-03-15 00:52:15.000000', 'consum', 0.0210, 'lps'),
	(461069, 126, '2015-03-15 00:52:16.000000', 'consum', 0.0218, 'lps'),
	(461070, 126, '2015-03-15 00:52:17.000000', 'consum', 0.0211, 'lps'),
	(461071, 126, '2015-03-15 00:52:18.000000', 'consum', 0.0220, 'lps'),
	(461072, 126, '2015-03-15 00:52:19.000000', 'consum', 0.0215, 'lps'),
	(461073, 126, '2015-03-15 00:52:20.000000', 'consum', 0.0221, 'lps'),
	(461074, 126, '2015-03-15 00:52:21.000000', 'consum', 0.0223, 'lps'),
	(461075, 126, '2015-03-15 00:52:22.000000', 'consum', 0.0213, 'lps'),
	(461076, 126, '2015-03-15 00:52:23.000000', 'consum', 0.0216, 'lps'),
	(461077, 126, '2015-03-15 00:52:24.000000', 'consum', 0.0215, 'lps'),
	(461078, 126, '2015-03-15 00:52:25.000000', 'consum', 0.0218, 'lps'),
	(461079, 126, '2015-03-15 00:52:26.000000', 'consum', 0.0221, 'lps'),
	(461080, 126, '2015-03-15 00:52:27.000000', 'consum', 0.0213, 'lps'),
	(461081, 126, '2015-03-15 00:52:28.000000', 'consum', 0.0221, 'lps'),
	(461082, 126, '2015-03-15 00:52:29.000000', 'consum', 0.0215, 'lps'),
	(461083, 126, '2015-03-15 00:52:30.000000', 'consum', 0.0216, 'lps'),
	(461084, 126, '2015-03-15 00:52:31.000000', 'consum', 0.0213, 'lps'),
	(461085, 126, '2015-03-15 00:52:32.000000', 'consum', 0.0219, 'lps'),
	(461086, 126, '2015-03-15 00:52:33.000000', 'consum', 0.0220, 'lps'),
	(461087, 126, '2015-03-15 00:52:34.000000', 'consum', 0.0221, 'lps'),
	(461088, 126, '2015-03-15 00:52:35.000000', 'consum', 0.0221, 'lps'),
	(461089, 126, '2015-03-15 00:52:36.000000', 'consum', 0.0218, 'lps'),
	(461090, 126, '2015-03-15 00:52:37.000000', 'consum', 0.0218, 'lps'),
	(461091, 126, '2015-03-15 00:52:38.000000', 'consum', 0.0210, 'lps'),
	(461092, 126, '2015-03-15 00:52:39.000000', 'consum', 0.0217, 'lps'),
	(461093, 126, '2015-03-15 00:52:40.000000', 'consum', 0.0216, 'lps'),
	(461094, 126, '2015-03-15 00:52:41.000000', 'consum', 0.0219, 'lps'),
	(461095, 126, '2015-03-15 00:52:42.000000', 'consum', 0.0210, 'lps'),
	(461096, 126, '2015-03-15 00:52:43.000000', 'consum', 0.0213, 'lps'),
	(461097, 126, '2015-03-15 00:52:44.000000', 'consum', 0.0212, 'lps'),
	(461098, 126, '2015-03-15 00:52:45.000000', 'consum', 0.0213, 'lps'),
	(461099, 126, '2015-03-15 00:52:46.000000', 'consum', 0.0216, 'lps'),
	(461100, 126, '2015-03-15 00:52:47.000000', 'consum', 0.0219, 'lps'),
	(461101, 126, '2015-03-15 00:52:48.000000', 'consum', 0.0210, 'lps'),
	(461102, 126, '2015-03-15 00:52:49.000000', 'consum', 0.0223, 'lps'),
	(461103, 126, '2015-03-15 00:52:50.000000', 'consum', 0.0221, 'lps'),
	(461104, 126, '2015-03-15 00:52:51.000000', 'consum', 0.0213, 'lps'),
	(461105, 126, '2015-03-15 00:52:52.000000', 'consum', 0.0222, 'lps'),
	(461106, 126, '2015-03-15 00:52:53.000000', 'consum', 0.0218, 'lps'),
	(461107, 126, '2015-03-15 00:52:54.000000', 'consum', 0.0217, 'lps'),
	(461108, 126, '2015-03-15 00:52:55.000000', 'consum', 0.0218, 'lps'),
	(461109, 126, '2015-03-15 00:52:56.000000', 'consum', 0.0218, 'lps'),
	(461110, 126, '2015-03-15 00:52:57.000000', 'consum', 0.0210, 'lps'),
	(461111, 126, '2015-03-15 00:52:58.000000', 'consum', 0.0215, 'lps'),
	(461112, 126, '2015-03-15 00:52:59.000000', 'consum', 0.0221, 'lps'),
	(461113, 126, '2015-03-15 00:53:00.000000', 'consum', 0.0222, 'lps'),
	(461114, 126, '2015-03-15 00:53:01.000000', 'consum', 0.0210, 'lps'),
	(461115, 126, '2015-03-15 00:53:02.000000', 'consum', 0.0218, 'lps'),
	(461116, 126, '2015-03-15 00:53:03.000000', 'consum', 0.0221, 'lps'),
	(461117, 126, '2015-03-15 00:53:04.000000', 'consum', 0.0216, 'lps'),
	(461118, 126, '2015-03-15 00:53:05.000000', 'consum', 0.0219, 'lps'),
	(461119, 126, '2015-03-15 00:53:06.000000', 'consum', 0.0210, 'lps'),
	(461120, 126, '2015-03-15 00:53:07.000000', 'consum', 0.0211, 'lps'),
	(461121, 126, '2015-03-15 00:53:08.000000', 'consum', 0.0214, 'lps'),
	(461122, 126, '2015-03-15 00:53:09.000000', 'consum', 0.0215, 'lps'),
	(461123, 126, '2015-03-15 00:53:10.000000', 'consum', 0.0211, 'lps'),
	(461124, 126, '2015-03-15 00:53:11.000000', 'consum', 0.0213, 'lps'),
	(461125, 126, '2015-03-15 00:53:12.000000', 'consum', 0.0221, 'lps'),
	(461126, 126, '2015-03-15 00:53:13.000000', 'consum', 0.0217, 'lps'),
	(461127, 126, '2015-03-15 00:53:14.000000', 'consum', 0.0212, 'lps'),
	(461128, 126, '2015-03-15 00:53:15.000000', 'consum', 0.0211, 'lps'),
	(461129, 126, '2015-03-15 00:53:16.000000', 'consum', 0.0212, 'lps'),
	(461130, 126, '2015-03-15 00:53:17.000000', 'consum', 0.0218, 'lps'),
	(461131, 126, '2015-03-15 00:53:18.000000', 'consum', 0.0216, 'lps'),
	(461132, 126, '2015-03-15 00:53:19.000000', 'consum', 0.0216, 'lps'),
	(461133, 126, '2015-03-15 00:53:20.000000', 'consum', 0.0221, 'lps'),
	(461134, 126, '2015-03-15 00:53:21.000000', 'consum', 0.0219, 'lps'),
	(461135, 126, '2015-03-15 00:53:22.000000', 'consum', 0.0210, 'lps'),
	(461136, 126, '2015-03-15 00:53:23.000000', 'consum', 0.0211, 'lps'),
	(461137, 126, '2015-03-15 00:53:24.000000', 'consum', 0.0217, 'lps'),
	(461138, 126, '2015-03-15 00:53:25.000000', 'consum', 0.0216, 'lps'),
	(461139, 126, '2015-03-15 00:53:26.000000', 'consum', 0.0216, 'lps'),
	(461140, 126, '2015-03-15 00:53:27.000000', 'consum', 0.0223, 'lps'),
	(461141, 126, '2015-03-15 00:53:28.000000', 'consum', 0.0218, 'lps'),
	(461142, 126, '2015-03-15 00:53:29.000000', 'consum', 0.0210, 'lps'),
	(461143, 126, '2015-03-15 00:53:30.000000', 'consum', 0.0216, 'lps'),
	(461144, 126, '2015-03-15 00:53:31.000000', 'consum', 0.0211, 'lps'),
	(461145, 126, '2015-03-15 00:53:32.000000', 'consum', 0.0213, 'lps'),
	(461146, 126, '2015-03-15 00:53:33.000000', 'consum', 0.0222, 'lps'),
	(461147, 126, '2015-03-15 00:53:34.000000', 'consum', 0.0221, 'lps'),
	(461148, 126, '2015-03-15 00:53:35.000000', 'consum', 0.0214, 'lps'),
	(461149, 126, '2015-03-15 00:53:36.000000', 'consum', 0.0213, 'lps'),
	(461150, 126, '2015-03-15 00:53:37.000000', 'consum', 0.0215, 'lps'),
	(461151, 126, '2015-03-15 00:53:38.000000', 'consum', 0.0223, 'lps'),
	(461152, 126, '2015-03-15 00:53:39.000000', 'consum', 0.0221, 'lps'),
	(461153, 126, '2015-03-15 00:53:40.000000', 'consum', 0.0210, 'lps'),
	(461154, 126, '2015-03-15 00:53:41.000000', 'consum', 0.0220, 'lps'),
	(461155, 126, '2015-03-15 00:53:42.000000', 'consum', 0.0218, 'lps'),
	(461156, 126, '2015-03-15 00:53:43.000000', 'consum', 0.0219, 'lps'),
	(461157, 126, '2015-03-15 00:53:44.000000', 'consum', 0.0220, 'lps'),
	(461158, 126, '2015-03-15 00:53:45.000000', 'consum', 0.0217, 'lps'),
	(461159, 126, '2015-03-15 00:53:46.000000', 'consum', 0.0217, 'lps'),
	(461160, 126, '2015-03-15 00:53:47.000000', 'consum', 0.0212, 'lps'),
	(461161, 126, '2015-03-15 00:53:48.000000', 'consum', 0.0213, 'lps'),
	(461162, 126, '2015-03-15 00:53:49.000000', 'consum', 0.0220, 'lps'),
	(461163, 126, '2015-03-15 00:53:50.000000', 'consum', 0.0210, 'lps'),
	(461164, 126, '2015-03-15 00:53:51.000000', 'consum', 0.0222, 'lps'),
	(461165, 126, '2015-03-15 00:53:52.000000', 'consum', 0.0216, 'lps'),
	(461166, 126, '2015-03-15 00:53:53.000000', 'consum', 0.0215, 'lps'),
	(461167, 126, '2015-03-15 00:53:54.000000', 'consum', 0.0221, 'lps'),
	(461168, 126, '2015-03-15 00:53:55.000000', 'consum', 0.0221, 'lps'),
	(461169, 126, '2015-03-15 00:53:56.000000', 'consum', 0.0217, 'lps'),
	(461170, 126, '2015-03-15 00:53:57.000000', 'consum', 0.0215, 'lps'),
	(461171, 126, '2015-03-15 00:53:58.000000', 'consum', 0.0213, 'lps'),
	(461172, 126, '2015-03-15 00:53:59.000000', 'consum', 0.0210, 'lps'),
	(461173, 126, '2015-03-15 00:54:00.000000', 'consum', 0.0214, 'lps'),
	(461174, 126, '2015-03-15 00:54:01.000000', 'consum', 0.0220, 'lps'),
	(461175, 126, '2015-03-15 00:54:02.000000', 'consum', 0.0219, 'lps'),
	(461176, 126, '2015-03-15 00:54:03.000000', 'consum', 0.0210, 'lps'),
	(461177, 126, '2015-03-15 00:54:04.000000', 'consum', 0.0213, 'lps'),
	(461178, 126, '2015-03-15 00:54:05.000000', 'consum', 0.0211, 'lps'),
	(461179, 126, '2015-03-15 00:54:06.000000', 'consum', 0.0222, 'lps'),
	(461180, 126, '2015-03-15 00:54:07.000000', 'consum', 0.0212, 'lps'),
	(461181, 126, '2015-03-15 00:54:08.000000', 'consum', 0.0212, 'lps'),
	(461182, 126, '2015-03-15 00:54:09.000000', 'consum', 0.0213, 'lps'),
	(461183, 126, '2015-03-15 00:54:10.000000', 'consum', 0.0222, 'lps'),
	(461184, 126, '2015-03-15 00:54:11.000000', 'consum', 0.0217, 'lps'),
	(461185, 126, '2015-03-15 00:54:12.000000', 'consum', 0.0211, 'lps'),
	(461186, 126, '2015-03-15 00:54:13.000000', 'consum', 0.0210, 'lps'),
	(461187, 126, '2015-03-15 00:54:14.000000', 'consum', 0.0219, 'lps'),
	(461188, 126, '2015-03-15 00:54:15.000000', 'consum', 0.0214, 'lps'),
	(461189, 126, '2015-03-15 00:54:16.000000', 'consum', 0.0219, 'lps'),
	(461190, 126, '2015-03-15 00:54:17.000000', 'consum', 0.0216, 'lps'),
	(461191, 126, '2015-03-15 00:54:18.000000', 'consum', 0.0212, 'lps'),
	(461192, 126, '2015-03-15 00:54:19.000000', 'consum', 0.0216, 'lps'),
	(461193, 126, '2015-03-15 00:54:20.000000', 'consum', 0.0221, 'lps'),
	(461194, 126, '2015-03-15 00:54:21.000000', 'consum', 0.0218, 'lps'),
	(461195, 126, '2015-03-15 00:54:22.000000', 'consum', 0.0218, 'lps'),
	(461196, 126, '2015-03-15 00:54:23.000000', 'consum', 0.0214, 'lps'),
	(461197, 126, '2015-03-15 00:54:24.000000', 'consum', 0.0220, 'lps'),
	(461198, 126, '2015-03-15 00:54:25.000000', 'consum', 0.0222, 'lps'),
	(461199, 126, '2015-03-15 00:54:26.000000', 'consum', 0.0213, 'lps'),
	(461200, 126, '2015-03-15 00:54:27.000000', 'consum', 0.0216, 'lps'),
	(461201, 126, '2015-03-15 00:54:28.000000', 'consum', 0.0217, 'lps'),
	(461202, 126, '2015-03-15 00:54:29.000000', 'consum', 0.0216, 'lps'),
	(461203, 126, '2015-03-15 00:54:30.000000', 'consum', 0.0216, 'lps'),
	(461204, 126, '2015-03-15 00:54:31.000000', 'consum', 0.0212, 'lps'),
	(461205, 126, '2015-03-15 00:54:32.000000', 'consum', 0.0215, 'lps'),
	(461206, 126, '2015-03-15 00:54:33.000000', 'consum', 0.0214, 'lps'),
	(461207, 126, '2015-03-15 00:54:34.000000', 'consum', 0.0217, 'lps'),
	(461208, 126, '2015-03-15 00:54:35.000000', 'consum', 0.0220, 'lps'),
	(461209, 126, '2015-03-15 00:54:36.000000', 'consum', 0.0223, 'lps'),
	(461210, 126, '2015-03-15 00:54:37.000000', 'consum', 0.0219, 'lps'),
	(461211, 126, '2015-03-15 00:54:38.000000', 'consum', 0.0217, 'lps'),
	(461212, 126, '2015-03-15 00:54:39.000000', 'consum', 0.0219, 'lps'),
	(461213, 126, '2015-03-15 00:54:40.000000', 'consum', 0.0221, 'lps'),
	(461214, 126, '2015-03-15 00:54:41.000000', 'consum', 0.0223, 'lps'),
	(461215, 126, '2015-03-15 00:54:42.000000', 'consum', 0.0216, 'lps'),
	(461216, 126, '2015-03-15 00:54:43.000000', 'consum', 0.0216, 'lps'),
	(461217, 126, '2015-03-15 00:54:44.000000', 'consum', 0.0221, 'lps'),
	(461218, 126, '2015-03-15 00:54:45.000000', 'consum', 0.0219, 'lps'),
	(461219, 126, '2015-03-15 00:54:46.000000', 'consum', 0.0222, 'lps'),
	(461220, 126, '2015-03-15 00:54:47.000000', 'consum', 0.0215, 'lps'),
	(461221, 126, '2015-03-15 00:54:48.000000', 'consum', 0.0214, 'lps'),
	(461222, 126, '2015-03-15 00:54:49.000000', 'consum', 0.0218, 'lps'),
	(461223, 126, '2015-03-15 00:54:50.000000', 'consum', 0.0222, 'lps'),
	(461224, 126, '2015-03-15 00:54:51.000000', 'consum', 0.0218, 'lps'),
	(461225, 126, '2015-03-15 00:54:52.000000', 'consum', 0.0216, 'lps'),
	(461226, 126, '2015-03-15 00:54:53.000000', 'consum', 0.0217, 'lps'),
	(461227, 126, '2015-03-15 00:54:54.000000', 'consum', 0.0212, 'lps'),
	(461228, 126, '2015-03-15 00:54:55.000000', 'consum', 0.0213, 'lps'),
	(461229, 126, '2015-03-15 00:54:56.000000', 'consum', 0.0222, 'lps'),
	(461230, 126, '2015-03-15 00:54:57.000000', 'consum', 0.0217, 'lps'),
	(461231, 126, '2015-03-15 00:54:58.000000', 'consum', 0.0222, 'lps'),
	(461232, 126, '2015-03-15 00:54:59.000000', 'consum', 0.0210, 'lps'),
	(461233, 126, '2015-03-15 00:55:00.000000', 'consum', 0.0218, 'lps'),
	(461234, 126, '2015-03-15 00:55:01.000000', 'consum', 0.0221, 'lps'),
	(461235, 126, '2015-03-15 00:55:02.000000', 'consum', 0.0214, 'lps'),
	(461236, 126, '2015-03-15 00:55:03.000000', 'consum', 0.0212, 'lps'),
	(461237, 126, '2015-03-15 00:55:04.000000', 'consum', 0.0221, 'lps'),
	(461238, 126, '2015-03-15 00:55:05.000000', 'consum', 0.0219, 'lps'),
	(461239, 126, '2015-03-15 00:55:06.000000', 'consum', 0.0223, 'lps'),
	(461240, 126, '2015-03-15 00:55:07.000000', 'consum', 0.0218, 'lps'),
	(461241, 126, '2015-03-15 00:55:08.000000', 'consum', 0.0212, 'lps'),
	(461242, 126, '2015-03-15 00:55:09.000000', 'consum', 0.0210, 'lps'),
	(461243, 126, '2015-03-15 00:55:10.000000', 'consum', 0.0218, 'lps'),
	(461244, 126, '2015-03-15 00:55:11.000000', 'consum', 0.0211, 'lps'),
	(461245, 126, '2015-03-15 00:55:12.000000', 'consum', 0.0220, 'lps'),
	(461246, 126, '2015-03-15 00:55:13.000000', 'consum', 0.0216, 'lps'),
	(461247, 126, '2015-03-15 00:55:14.000000', 'consum', 0.0210, 'lps'),
	(461248, 126, '2015-03-15 00:55:15.000000', 'consum', 0.0219, 'lps'),
	(461249, 126, '2015-03-15 00:55:16.000000', 'consum', 0.0216, 'lps'),
	(461250, 126, '2015-03-15 00:55:17.000000', 'consum', 0.0213, 'lps'),
	(461251, 126, '2015-03-15 00:55:18.000000', 'consum', 0.0221, 'lps'),
	(461252, 126, '2015-03-15 00:55:19.000000', 'consum', 0.0216, 'lps'),
	(461253, 126, '2015-03-15 00:55:20.000000', 'consum', 0.0221, 'lps'),
	(461254, 126, '2015-03-15 00:55:21.000000', 'consum', 0.0218, 'lps'),
	(461255, 126, '2015-03-15 00:55:22.000000', 'consum', 0.0217, 'lps'),
	(461256, 126, '2015-03-15 00:55:23.000000', 'consum', 0.0220, 'lps'),
	(461257, 126, '2015-03-15 00:55:24.000000', 'consum', 0.0214, 'lps'),
	(461258, 126, '2015-03-15 00:55:25.000000', 'consum', 0.0216, 'lps'),
	(461259, 126, '2015-03-15 00:55:26.000000', 'consum', 0.0212, 'lps'),
	(461260, 126, '2015-03-15 00:55:27.000000', 'consum', 0.0217, 'lps'),
	(461261, 126, '2015-03-15 00:55:28.000000', 'consum', 0.0214, 'lps'),
	(461262, 126, '2015-03-15 00:55:29.000000', 'consum', 0.0221, 'lps'),
	(461263, 126, '2015-03-15 00:55:30.000000', 'consum', 0.0212, 'lps'),
	(461264, 126, '2015-03-15 00:55:31.000000', 'consum', 0.0215, 'lps'),
	(461265, 126, '2015-03-15 00:55:32.000000', 'consum', 0.0217, 'lps'),
	(461266, 126, '2015-03-15 00:55:33.000000', 'consum', 0.0216, 'lps'),
	(461267, 126, '2015-03-15 00:55:34.000000', 'consum', 0.0219, 'lps'),
	(461268, 126, '2015-03-15 00:55:35.000000', 'consum', 0.0211, 'lps'),
	(461269, 126, '2015-03-15 00:55:36.000000', 'consum', 0.0214, 'lps'),
	(461270, 126, '2015-03-15 00:55:37.000000', 'consum', 0.0216, 'lps'),
	(461271, 126, '2015-03-15 00:55:38.000000', 'consum', 0.0213, 'lps'),
	(461272, 126, '2015-03-15 00:55:39.000000', 'consum', 0.0221, 'lps'),
	(461273, 126, '2015-03-15 00:55:40.000000', 'consum', 0.0215, 'lps'),
	(461274, 126, '2015-03-15 00:55:41.000000', 'consum', 0.0217, 'lps'),
	(461275, 126, '2015-03-15 00:55:42.000000', 'consum', 0.0215, 'lps'),
	(461276, 126, '2015-03-15 00:55:43.000000', 'consum', 0.0214, 'lps'),
	(461277, 126, '2015-03-15 00:55:44.000000', 'consum', 0.0217, 'lps'),
	(461278, 126, '2015-03-15 00:55:45.000000', 'consum', 0.0220, 'lps'),
	(461279, 126, '2015-03-15 00:55:46.000000', 'consum', 0.0210, 'lps'),
	(461280, 126, '2015-03-15 00:55:47.000000', 'consum', 0.0211, 'lps'),
	(461281, 126, '2015-03-15 00:55:48.000000', 'consum', 0.0214, 'lps'),
	(461282, 126, '2015-03-15 00:55:49.000000', 'consum', 0.0213, 'lps'),
	(461283, 126, '2015-03-15 00:55:50.000000', 'consum', 0.0213, 'lps'),
	(461284, 126, '2015-03-15 00:55:51.000000', 'consum', 0.0219, 'lps'),
	(461285, 126, '2015-03-15 00:55:52.000000', 'consum', 0.0217, 'lps'),
	(461286, 126, '2015-03-15 00:55:53.000000', 'consum', 0.0221, 'lps'),
	(461287, 126, '2015-03-15 00:55:54.000000', 'consum', 0.0214, 'lps'),
	(461288, 126, '2015-03-15 00:55:55.000000', 'consum', 0.0211, 'lps'),
	(461289, 126, '2015-03-15 00:55:56.000000', 'consum', 0.0219, 'lps'),
	(461290, 126, '2015-03-15 00:55:57.000000', 'consum', 0.0222, 'lps'),
	(461291, 126, '2015-03-15 00:55:58.000000', 'consum', 0.0217, 'lps'),
	(461292, 126, '2015-03-15 00:55:59.000000', 'consum', 0.0222, 'lps'),
	(461293, 126, '2015-03-15 00:56:00.000000', 'consum', 0.0223, 'lps'),
	(461294, 126, '2015-03-15 00:56:01.000000', 'consum', 0.0212, 'lps'),
	(461295, 126, '2015-03-15 00:56:02.000000', 'consum', 0.0223, 'lps'),
	(461296, 126, '2015-03-15 00:56:03.000000', 'consum', 0.0212, 'lps'),
	(461297, 126, '2015-03-15 00:56:04.000000', 'consum', 0.0223, 'lps'),
	(461298, 126, '2015-03-15 00:56:05.000000', 'consum', 0.0215, 'lps'),
	(461299, 126, '2015-03-15 00:56:06.000000', 'consum', 0.0212, 'lps'),
	(461300, 126, '2015-03-15 00:56:07.000000', 'consum', 0.0218, 'lps'),
	(461301, 126, '2015-03-15 00:56:08.000000', 'consum', 0.0218, 'lps'),
	(461302, 126, '2015-03-15 00:56:09.000000', 'consum', 0.0211, 'lps'),
	(461303, 126, '2015-03-15 00:56:10.000000', 'consum', 0.0221, 'lps'),
	(461304, 126, '2015-03-15 00:56:11.000000', 'consum', 0.0218, 'lps'),
	(461305, 126, '2015-03-15 00:56:12.000000', 'consum', 0.0219, 'lps'),
	(461306, 126, '2015-03-15 00:56:13.000000', 'consum', 0.0216, 'lps'),
	(461307, 126, '2015-03-15 00:56:14.000000', 'consum', 0.0213, 'lps'),
	(461308, 126, '2015-03-15 00:56:15.000000', 'consum', 0.0222, 'lps'),
	(461309, 126, '2015-03-15 00:56:16.000000', 'consum', 0.0219, 'lps'),
	(461310, 126, '2015-03-15 00:56:17.000000', 'consum', 0.0219, 'lps'),
	(461311, 126, '2015-03-15 00:56:18.000000', 'consum', 0.0215, 'lps'),
	(461312, 126, '2015-03-15 00:56:19.000000', 'consum', 0.0221, 'lps'),
	(461313, 126, '2015-03-15 00:56:20.000000', 'consum', 0.0211, 'lps'),
	(461314, 126, '2015-03-15 00:56:21.000000', 'consum', 0.0210, 'lps'),
	(461315, 126, '2015-03-15 00:56:22.000000', 'consum', 0.0223, 'lps'),
	(461316, 126, '2015-03-15 00:56:23.000000', 'consum', 0.0219, 'lps'),
	(461317, 126, '2015-03-15 00:56:24.000000', 'consum', 0.0216, 'lps'),
	(461318, 126, '2015-03-15 00:56:25.000000', 'consum', 0.0214, 'lps'),
	(461319, 126, '2015-03-15 00:56:26.000000', 'consum', 0.0213, 'lps'),
	(461320, 126, '2015-03-15 00:56:27.000000', 'consum', 0.0213, 'lps'),
	(461321, 126, '2015-03-15 00:56:28.000000', 'consum', 0.0217, 'lps'),
	(461322, 126, '2015-03-15 00:56:29.000000', 'consum', 0.0220, 'lps'),
	(461323, 126, '2015-03-15 00:56:30.000000', 'consum', 0.0213, 'lps'),
	(461324, 126, '2015-03-15 00:56:31.000000', 'consum', 0.0211, 'lps'),
	(461325, 126, '2015-03-15 00:56:32.000000', 'consum', 0.0222, 'lps'),
	(461326, 126, '2015-03-15 00:56:33.000000', 'consum', 0.0222, 'lps'),
	(461327, 126, '2015-03-15 00:56:34.000000', 'consum', 0.0220, 'lps'),
	(461328, 126, '2015-03-15 00:56:35.000000', 'consum', 0.0212, 'lps'),
	(461329, 102, '2015-04-01 00:00:00.000000', 'consum', 0.0215, 'lps'),
	(461330, 102, '2015-04-01 00:00:01.000000', 'consum', 0.0210, 'lps'),
	(461331, 102, '2015-04-01 00:00:02.000000', 'consum', 0.0217, 'lps'),
	(461332, 102, '2015-04-01 00:00:03.000000', 'consum', 0.0226, 'lps'),
	(461333, 102, '2015-04-01 00:00:04.000000', 'consum', 0.0225, 'lps'),
	(461334, 102, '2015-04-01 00:00:05.000000', 'consum', 0.0218, 'lps'),
	(461335, 102, '2015-04-01 00:00:06.000000', 'consum', 0.0228, 'lps'),
	(461336, 102, '2015-04-01 00:00:07.000000', 'consum', 0.0214, 'lps'),
	(461337, 102, '2015-04-01 00:00:08.000000', 'consum', 0.0218, 'lps'),
	(461338, 102, '2015-04-01 00:00:09.000000', 'consum', 0.0215, 'lps'),
	(461339, 102, '2015-04-01 00:00:10.000000', 'consum', 0.0215, 'lps'),
	(461340, 102, '2015-04-01 00:00:11.000000', 'consum', 0.0219, 'lps'),
	(461341, 102, '2015-04-01 00:00:12.000000', 'consum', 0.0219, 'lps'),
	(461342, 102, '2015-04-01 00:00:13.000000', 'consum', 0.0229, 'lps'),
	(461343, 102, '2015-04-01 00:00:14.000000', 'consum', 0.0215, 'lps'),
	(461344, 102, '2015-04-01 00:00:15.000000', 'consum', 0.0222, 'lps'),
	(461345, 102, '2015-04-01 00:00:16.000000', 'consum', 0.0213, 'lps'),
	(461346, 102, '2015-04-01 00:00:17.000000', 'consum', 0.0211, 'lps'),
	(461347, 102, '2015-04-01 00:00:18.000000', 'consum', 0.0228, 'lps'),
	(461348, 102, '2015-04-01 00:00:19.000000', 'consum', 0.0212, 'lps'),
	(461349, 102, '2015-04-01 00:00:20.000000', 'consum', 0.0229, 'lps'),
	(461350, 102, '2015-04-01 00:00:21.000000', 'consum', 0.0215, 'lps'),
	(461351, 102, '2015-04-01 00:00:22.000000', 'consum', 0.0223, 'lps'),
	(461352, 102, '2015-04-01 00:00:23.000000', 'consum', 0.0217, 'lps'),
	(461353, 102, '2015-04-01 00:00:24.000000', 'consum', 0.0230, 'lps'),
	(461354, 102, '2015-04-01 00:00:25.000000', 'consum', 0.0224, 'lps'),
	(461355, 102, '2015-04-01 00:00:26.000000', 'consum', 0.0221, 'lps'),
	(461356, 102, '2015-04-01 00:00:27.000000', 'consum', 0.0224, 'lps'),
	(461357, 102, '2015-04-01 00:00:28.000000', 'consum', 0.0225, 'lps'),
	(461358, 102, '2015-04-01 00:00:29.000000', 'consum', 0.0221, 'lps'),
	(461359, 102, '2015-04-01 00:00:30.000000', 'consum', 0.0224, 'lps'),
	(461360, 102, '2015-04-01 00:00:31.000000', 'consum', 0.0226, 'lps'),
	(461361, 102, '2015-04-01 00:00:32.000000', 'consum', 0.0229, 'lps'),
	(461362, 102, '2015-04-01 00:00:33.000000', 'consum', 0.0212, 'lps'),
	(461363, 102, '2015-04-01 00:00:34.000000', 'consum', 0.0229, 'lps'),
	(461364, 102, '2015-04-01 00:00:35.000000', 'consum', 0.0213, 'lps'),
	(461365, 102, '2015-04-01 00:00:36.000000', 'consum', 0.0211, 'lps'),
	(461366, 102, '2015-04-01 00:00:37.000000', 'consum', 0.0229, 'lps'),
	(461367, 102, '2015-04-01 00:00:38.000000', 'consum', 0.0219, 'lps'),
	(461368, 102, '2015-04-01 00:00:39.000000', 'consum', 0.0219, 'lps'),
	(461369, 102, '2015-04-01 00:00:40.000000', 'consum', 0.0227, 'lps'),
	(461370, 102, '2015-04-01 00:00:41.000000', 'consum', 0.0228, 'lps'),
	(461371, 102, '2015-04-01 00:00:42.000000', 'consum', 0.0230, 'lps'),
	(461372, 102, '2015-04-01 00:00:43.000000', 'consum', 0.0214, 'lps'),
	(461373, 102, '2015-04-01 00:00:44.000000', 'consum', 0.0212, 'lps'),
	(461374, 102, '2015-04-01 00:00:45.000000', 'consum', 0.0210, 'lps'),
	(461375, 102, '2015-04-01 00:00:46.000000', 'consum', 0.0224, 'lps'),
	(461376, 102, '2015-04-01 00:00:47.000000', 'consum', 0.0219, 'lps'),
	(461377, 102, '2015-04-01 00:00:48.000000', 'consum', 0.0212, 'lps'),
	(461378, 102, '2015-04-01 00:00:49.000000', 'consum', 0.0215, 'lps'),
	(461379, 102, '2015-04-01 00:00:50.000000', 'consum', 0.0210, 'lps'),
	(461380, 102, '2015-04-01 00:00:51.000000', 'consum', 0.0215, 'lps'),
	(461381, 102, '2015-04-01 00:00:52.000000', 'consum', 0.0215, 'lps'),
	(461382, 102, '2015-04-01 00:00:53.000000', 'consum', 0.0220, 'lps'),
	(461383, 102, '2015-04-01 00:00:54.000000', 'consum', 0.0226, 'lps'),
	(461384, 102, '2015-04-01 00:00:55.000000', 'consum', 0.0219, 'lps'),
	(461385, 102, '2015-04-01 00:00:56.000000', 'consum', 0.0227, 'lps'),
	(461386, 102, '2015-04-01 00:00:57.000000', 'consum', 0.0226, 'lps'),
	(461387, 102, '2015-04-01 00:00:58.000000', 'consum', 0.0220, 'lps'),
	(461388, 102, '2015-04-01 00:00:59.000000', 'consum', 0.0211, 'lps'),
	(461389, 102, '2015-04-01 00:01:00.000000', 'consum', 0.0230, 'lps'),
	(461390, 102, '2015-04-01 00:01:01.000000', 'consum', 0.0223, 'lps'),
	(461391, 102, '2015-04-01 00:01:02.000000', 'consum', 0.0216, 'lps'),
	(461392, 102, '2015-04-01 00:01:03.000000', 'consum', 0.0222, 'lps'),
	(461393, 102, '2015-04-01 00:01:04.000000', 'consum', 0.0212, 'lps'),
	(461394, 102, '2015-04-01 00:01:05.000000', 'consum', 0.0226, 'lps'),
	(461395, 102, '2015-04-01 00:01:06.000000', 'consum', 0.0220, 'lps'),
	(461396, 102, '2015-04-01 00:01:07.000000', 'consum', 0.0215, 'lps'),
	(461397, 102, '2015-04-01 00:01:08.000000', 'consum', 0.0223, 'lps'),
	(461398, 102, '2015-04-01 00:01:09.000000', 'consum', 0.0222, 'lps'),
	(461399, 102, '2015-04-01 00:01:10.000000', 'consum', 0.0210, 'lps'),
	(461400, 102, '2015-04-01 00:01:11.000000', 'consum', 0.0215, 'lps'),
	(461401, 102, '2015-04-01 00:01:12.000000', 'consum', 0.0217, 'lps'),
	(461402, 102, '2015-04-01 00:01:13.000000', 'consum', 0.0230, 'lps'),
	(461403, 102, '2015-04-01 00:01:14.000000', 'consum', 0.0226, 'lps'),
	(461404, 102, '2015-04-01 00:01:15.000000', 'consum', 0.0229, 'lps'),
	(461405, 102, '2015-04-01 00:01:16.000000', 'consum', 0.0216, 'lps'),
	(461406, 102, '2015-04-01 00:01:17.000000', 'consum', 0.0227, 'lps'),
	(461407, 102, '2015-04-01 00:01:18.000000', 'consum', 0.0215, 'lps'),
	(461408, 102, '2015-04-01 00:01:19.000000', 'consum', 0.0225, 'lps'),
	(461409, 102, '2015-04-01 00:01:20.000000', 'consum', 0.0227, 'lps'),
	(461410, 102, '2015-04-01 00:01:21.000000', 'consum', 0.0212, 'lps'),
	(461411, 102, '2015-04-01 00:01:22.000000', 'consum', 0.0230, 'lps'),
	(461412, 102, '2015-04-01 00:01:23.000000', 'consum', 0.0221, 'lps'),
	(461413, 102, '2015-04-01 00:01:24.000000', 'consum', 0.0227, 'lps'),
	(461414, 102, '2015-04-01 00:01:25.000000', 'consum', 0.0218, 'lps'),
	(461415, 102, '2015-04-01 00:01:26.000000', 'consum', 0.0223, 'lps'),
	(461416, 102, '2015-04-01 00:01:27.000000', 'consum', 0.0210, 'lps'),
	(461417, 102, '2015-04-01 00:01:28.000000', 'consum', 0.0211, 'lps'),
	(461418, 102, '2015-04-01 00:01:29.000000', 'consum', 0.0219, 'lps'),
	(461419, 102, '2015-04-01 00:01:30.000000', 'consum', 0.0229, 'lps'),
	(461420, 102, '2015-04-01 00:01:31.000000', 'consum', 0.0215, 'lps'),
	(461421, 102, '2015-04-01 00:01:32.000000', 'consum', 0.0220, 'lps'),
	(461422, 102, '2015-04-01 00:01:33.000000', 'consum', 0.0227, 'lps'),
	(461423, 102, '2015-04-01 00:01:34.000000', 'consum', 0.0221, 'lps'),
	(461424, 102, '2015-04-01 00:01:35.000000', 'consum', 0.0214, 'lps'),
	(461425, 102, '2015-04-01 00:01:36.000000', 'consum', 0.0220, 'lps'),
	(461426, 102, '2015-04-01 00:01:37.000000', 'consum', 0.0227, 'lps'),
	(461427, 102, '2015-04-01 00:01:38.000000', 'consum', 0.0226, 'lps'),
	(461428, 102, '2015-04-01 00:01:39.000000', 'consum', 0.0216, 'lps'),
	(461429, 102, '2015-04-01 00:01:40.000000', 'consum', 0.0212, 'lps'),
	(461430, 102, '2015-04-01 00:01:41.000000', 'consum', 0.0226, 'lps'),
	(461431, 102, '2015-04-01 00:01:42.000000', 'consum', 0.0219, 'lps'),
	(461432, 102, '2015-04-01 00:01:43.000000', 'consum', 0.0211, 'lps'),
	(461433, 102, '2015-04-01 00:01:44.000000', 'consum', 0.0228, 'lps'),
	(461434, 102, '2015-04-01 00:01:45.000000', 'consum', 0.0212, 'lps'),
	(461435, 102, '2015-04-01 00:01:46.000000', 'consum', 0.0210, 'lps'),
	(461436, 102, '2015-04-01 00:01:47.000000', 'consum', 0.0226, 'lps'),
	(461437, 102, '2015-04-01 00:01:48.000000', 'consum', 0.0227, 'lps'),
	(461438, 102, '2015-04-01 00:01:49.000000', 'consum', 0.0227, 'lps'),
	(461439, 102, '2015-04-01 00:01:50.000000', 'consum', 0.0221, 'lps'),
	(461440, 102, '2015-04-01 00:01:51.000000', 'consum', 0.0217, 'lps'),
	(461441, 102, '2015-04-01 00:01:52.000000', 'consum', 0.0210, 'lps'),
	(461442, 102, '2015-04-01 00:01:53.000000', 'consum', 0.0212, 'lps'),
	(461443, 102, '2015-04-01 00:01:54.000000', 'consum', 0.0222, 'lps'),
	(461444, 102, '2015-04-01 00:01:55.000000', 'consum', 0.0223, 'lps'),
	(461445, 102, '2015-04-01 00:01:56.000000', 'consum', 0.0215, 'lps'),
	(461446, 102, '2015-04-01 00:01:57.000000', 'consum', 0.0221, 'lps'),
	(461447, 102, '2015-04-01 00:01:58.000000', 'consum', 0.0228, 'lps'),
	(461448, 102, '2015-04-01 00:01:59.000000', 'consum', 0.0227, 'lps'),
	(461449, 102, '2015-04-01 00:02:00.000000', 'consum', 0.0221, 'lps'),
	(461450, 102, '2015-04-01 00:02:01.000000', 'consum', 0.0213, 'lps'),
	(461451, 102, '2015-04-01 00:02:02.000000', 'consum', 0.0212, 'lps'),
	(461452, 102, '2015-04-01 00:02:03.000000', 'consum', 0.0212, 'lps'),
	(461453, 102, '2015-04-01 00:02:04.000000', 'consum', 0.0215, 'lps'),
	(461454, 102, '2015-04-01 00:02:05.000000', 'consum', 0.0210, 'lps'),
	(461455, 102, '2015-04-01 00:02:06.000000', 'consum', 0.0217, 'lps'),
	(461456, 102, '2015-04-01 00:02:07.000000', 'consum', 0.0223, 'lps'),
	(461457, 102, '2015-04-01 00:02:08.000000', 'consum', 0.0215, 'lps'),
	(461458, 102, '2015-04-01 00:02:09.000000', 'consum', 0.0216, 'lps'),
	(461459, 102, '2015-04-01 00:02:10.000000', 'consum', 0.0224, 'lps'),
	(461460, 102, '2015-04-01 00:02:11.000000', 'consum', 0.0222, 'lps'),
	(461461, 102, '2015-04-01 00:02:12.000000', 'consum', 0.0229, 'lps'),
	(461462, 102, '2015-04-01 00:02:13.000000', 'consum', 0.0227, 'lps'),
	(461463, 102, '2015-04-01 00:02:14.000000', 'consum', 0.0219, 'lps'),
	(461464, 102, '2015-04-01 00:02:15.000000', 'consum', 0.0224, 'lps'),
	(461465, 102, '2015-04-01 00:02:16.000000', 'consum', 0.0213, 'lps'),
	(461466, 102, '2015-04-01 00:02:17.000000', 'consum', 0.0224, 'lps'),
	(461467, 102, '2015-04-01 00:02:18.000000', 'consum', 0.0230, 'lps'),
	(461468, 102, '2015-04-01 00:02:19.000000', 'consum', 0.0228, 'lps'),
	(461469, 102, '2015-04-01 00:02:20.000000', 'consum', 0.0218, 'lps'),
	(461470, 102, '2015-04-01 00:02:21.000000', 'consum', 0.0217, 'lps'),
	(461471, 102, '2015-04-01 00:02:22.000000', 'consum', 0.0223, 'lps'),
	(461472, 102, '2015-04-01 00:02:23.000000', 'consum', 0.0213, 'lps'),
	(461473, 102, '2015-04-01 00:02:24.000000', 'consum', 0.0226, 'lps'),
	(461474, 102, '2015-04-01 00:02:25.000000', 'consum', 0.0220, 'lps'),
	(461475, 102, '2015-04-01 00:02:26.000000', 'consum', 0.0211, 'lps'),
	(461476, 102, '2015-04-01 00:02:27.000000', 'consum', 0.0229, 'lps'),
	(461477, 102, '2015-04-01 00:02:28.000000', 'consum', 0.0217, 'lps'),
	(461478, 102, '2015-04-01 00:02:29.000000', 'consum', 0.0210, 'lps'),
	(461479, 102, '2015-04-01 00:02:30.000000', 'consum', 0.0210, 'lps'),
	(461480, 102, '2015-04-01 00:02:31.000000', 'consum', 0.0230, 'lps'),
	(461481, 102, '2015-04-01 00:02:32.000000', 'consum', 0.0229, 'lps'),
	(461482, 102, '2015-04-01 00:02:33.000000', 'consum', 0.0222, 'lps'),
	(461483, 102, '2015-04-01 00:02:34.000000', 'consum', 0.0213, 'lps'),
	(461484, 102, '2015-04-01 00:02:35.000000', 'consum', 0.0212, 'lps'),
	(461485, 102, '2015-04-01 00:02:36.000000', 'consum', 0.0230, 'lps'),
	(461486, 102, '2015-04-01 00:02:37.000000', 'consum', 0.0223, 'lps'),
	(461487, 102, '2015-04-01 00:02:38.000000', 'consum', 0.0214, 'lps'),
	(461488, 102, '2015-04-01 00:02:39.000000', 'consum', 0.0213, 'lps'),
	(461489, 102, '2015-04-01 00:02:40.000000', 'consum', 0.0214, 'lps'),
	(461490, 102, '2015-04-01 00:02:41.000000', 'consum', 0.0222, 'lps'),
	(461491, 102, '2015-04-01 00:02:42.000000', 'consum', 0.0214, 'lps'),
	(461492, 102, '2015-04-01 00:02:43.000000', 'consum', 0.0218, 'lps'),
	(461493, 102, '2015-04-01 00:02:44.000000', 'consum', 0.0216, 'lps'),
	(461494, 102, '2015-04-01 00:02:45.000000', 'consum', 0.0218, 'lps'),
	(461495, 102, '2015-04-01 00:02:46.000000', 'consum', 0.0211, 'lps'),
	(461496, 102, '2015-04-01 00:02:47.000000', 'consum', 0.0213, 'lps'),
	(461497, 102, '2015-04-01 00:02:48.000000', 'consum', 0.0222, 'lps'),
	(461498, 102, '2015-04-01 00:02:49.000000', 'consum', 0.0220, 'lps'),
	(461499, 102, '2015-04-01 00:02:50.000000', 'consum', 0.0225, 'lps'),
	(461500, 102, '2015-04-01 00:02:51.000000', 'consum', 0.0214, 'lps'),
	(461501, 102, '2015-04-01 00:02:52.000000', 'consum', 0.0229, 'lps'),
	(461502, 102, '2015-04-01 00:02:53.000000', 'consum', 0.0228, 'lps'),
	(461503, 102, '2015-04-01 00:02:54.000000', 'consum', 0.0224, 'lps'),
	(461504, 102, '2015-04-01 00:02:55.000000', 'consum', 0.0224, 'lps'),
	(461505, 102, '2015-04-01 00:02:56.000000', 'consum', 0.0218, 'lps'),
	(461506, 102, '2015-04-01 00:02:57.000000', 'consum', 0.0211, 'lps'),
	(461507, 102, '2015-04-01 00:02:58.000000', 'consum', 0.0210, 'lps'),
	(461508, 102, '2015-04-01 00:02:59.000000', 'consum', 0.0210, 'lps'),
	(461509, 102, '2015-04-01 00:03:00.000000', 'consum', 0.0229, 'lps'),
	(461510, 102, '2015-04-01 00:03:01.000000', 'consum', 0.0224, 'lps'),
	(461511, 102, '2015-04-01 00:03:02.000000', 'consum', 0.0221, 'lps'),
	(461512, 102, '2015-04-01 00:03:03.000000', 'consum', 0.0225, 'lps'),
	(461513, 102, '2015-04-01 00:03:04.000000', 'consum', 0.0229, 'lps'),
	(461514, 102, '2015-04-01 00:03:05.000000', 'consum', 0.0221, 'lps'),
	(461515, 102, '2015-04-01 00:03:06.000000', 'consum', 0.0228, 'lps'),
	(461516, 102, '2015-04-01 00:03:07.000000', 'consum', 0.0226, 'lps'),
	(461517, 102, '2015-04-01 00:03:08.000000', 'consum', 0.0217, 'lps'),
	(461518, 102, '2015-04-01 00:03:09.000000', 'consum', 0.0219, 'lps'),
	(461519, 102, '2015-04-01 00:03:10.000000', 'consum', 0.0211, 'lps'),
	(461520, 102, '2015-04-01 00:03:11.000000', 'consum', 0.0211, 'lps'),
	(461521, 102, '2015-04-01 00:03:12.000000', 'consum', 0.0211, 'lps'),
	(461522, 102, '2015-04-01 00:03:13.000000', 'consum', 0.0214, 'lps'),
	(461523, 102, '2015-04-01 00:03:14.000000', 'consum', 0.0229, 'lps'),
	(461524, 102, '2015-04-01 00:03:15.000000', 'consum', 0.0228, 'lps'),
	(461525, 102, '2015-04-01 00:03:16.000000', 'consum', 0.0225, 'lps'),
	(461526, 102, '2015-04-01 00:03:17.000000', 'consum', 0.0210, 'lps'),
	(461527, 102, '2015-04-01 00:03:18.000000', 'consum', 0.0226, 'lps'),
	(461528, 102, '2015-04-01 00:03:19.000000', 'consum', 0.0230, 'lps'),
	(461529, 102, '2015-04-01 00:03:20.000000', 'consum', 0.0219, 'lps'),
	(461530, 102, '2015-04-01 00:03:21.000000', 'consum', 0.0217, 'lps'),
	(461531, 102, '2015-04-01 00:03:22.000000', 'consum', 0.0217, 'lps'),
	(461532, 102, '2015-04-01 00:03:23.000000', 'consum', 0.0224, 'lps'),
	(461533, 102, '2015-04-01 00:03:24.000000', 'consum', 0.0218, 'lps'),
	(461534, 102, '2015-04-01 00:03:25.000000', 'consum', 0.0230, 'lps'),
	(461535, 102, '2015-04-01 00:03:26.000000', 'consum', 0.0225, 'lps'),
	(461536, 102, '2015-04-01 00:03:27.000000', 'consum', 0.0226, 'lps'),
	(461537, 102, '2015-04-01 00:03:28.000000', 'consum', 0.0223, 'lps'),
	(461538, 102, '2015-04-01 00:03:29.000000', 'consum', 0.0229, 'lps'),
	(461539, 102, '2015-04-01 00:03:30.000000', 'consum', 0.0224, 'lps'),
	(461540, 102, '2015-04-01 00:03:31.000000', 'consum', 0.0222, 'lps'),
	(461541, 102, '2015-04-01 00:03:32.000000', 'consum', 0.0228, 'lps'),
	(461542, 102, '2015-04-01 00:03:33.000000', 'consum', 0.0224, 'lps'),
	(461543, 102, '2015-04-01 00:03:34.000000', 'consum', 0.0226, 'lps'),
	(461544, 102, '2015-04-01 00:03:35.000000', 'consum', 0.0227, 'lps'),
	(461545, 102, '2015-04-01 00:03:36.000000', 'consum', 0.0227, 'lps'),
	(461546, 102, '2015-04-01 00:03:37.000000', 'consum', 0.0222, 'lps'),
	(461547, 102, '2015-04-01 00:03:38.000000', 'consum', 0.0223, 'lps'),
	(461548, 102, '2015-04-01 00:03:39.000000', 'consum', 0.0215, 'lps'),
	(461549, 102, '2015-04-01 00:03:40.000000', 'consum', 0.0218, 'lps'),
	(461550, 102, '2015-04-01 00:03:41.000000', 'consum', 0.0214, 'lps'),
	(461551, 102, '2015-04-01 00:03:42.000000', 'consum', 0.0228, 'lps'),
	(461552, 102, '2015-04-01 00:03:43.000000', 'consum', 0.0227, 'lps'),
	(461553, 102, '2015-04-01 00:03:44.000000', 'consum', 0.0219, 'lps'),
	(461554, 102, '2015-04-01 00:03:45.000000', 'consum', 0.0225, 'lps'),
	(461555, 102, '2015-04-01 00:03:46.000000', 'consum', 0.0219, 'lps'),
	(461556, 102, '2015-04-01 00:03:47.000000', 'consum', 0.0230, 'lps'),
	(461557, 102, '2015-04-01 00:03:48.000000', 'consum', 0.0220, 'lps'),
	(461558, 102, '2015-04-01 00:03:49.000000', 'consum', 0.0223, 'lps'),
	(461559, 102, '2015-04-01 00:03:50.000000', 'consum', 0.0224, 'lps'),
	(461560, 102, '2015-04-01 00:03:51.000000', 'consum', 0.0221, 'lps'),
	(461561, 102, '2015-04-01 00:03:52.000000', 'consum', 0.0224, 'lps'),
	(461562, 102, '2015-04-01 00:03:53.000000', 'consum', 0.0225, 'lps'),
	(461563, 102, '2015-04-01 00:03:54.000000', 'consum', 0.0222, 'lps'),
	(461564, 102, '2015-04-01 00:03:55.000000', 'consum', 0.0224, 'lps'),
	(461565, 102, '2015-04-01 00:03:56.000000', 'consum', 0.0226, 'lps'),
	(461566, 102, '2015-04-01 00:03:57.000000', 'consum', 0.0228, 'lps'),
	(461567, 102, '2015-04-01 00:03:58.000000', 'consum', 0.0230, 'lps'),
	(461568, 102, '2015-04-01 00:03:59.000000', 'consum', 0.0214, 'lps'),
	(461569, 102, '2015-04-01 00:04:00.000000', 'consum', 0.0213, 'lps'),
	(461570, 102, '2015-04-01 00:04:01.000000', 'consum', 0.0214, 'lps'),
	(461571, 102, '2015-04-01 00:04:02.000000', 'consum', 0.0221, 'lps'),
	(461572, 102, '2015-04-01 00:04:03.000000', 'consum', 0.0212, 'lps'),
	(461573, 102, '2015-04-01 00:04:04.000000', 'consum', 0.0228, 'lps'),
	(461574, 102, '2015-04-01 00:04:05.000000', 'consum', 0.0213, 'lps'),
	(461575, 102, '2015-04-01 00:04:06.000000', 'consum', 0.0212, 'lps'),
	(461576, 102, '2015-04-01 00:04:07.000000', 'consum', 0.0210, 'lps'),
	(461577, 102, '2015-04-01 00:04:08.000000', 'consum', 0.0225, 'lps'),
	(461578, 102, '2015-04-01 00:04:09.000000', 'consum', 0.0226, 'lps'),
	(461579, 102, '2015-04-01 00:04:10.000000', 'consum', 0.0222, 'lps'),
	(461580, 102, '2015-04-01 00:04:11.000000', 'consum', 0.0224, 'lps'),
	(461581, 102, '2015-04-01 00:04:12.000000', 'consum', 0.0223, 'lps'),
	(461582, 102, '2015-04-01 00:04:13.000000', 'consum', 0.0212, 'lps'),
	(461583, 102, '2015-04-01 00:04:14.000000', 'consum', 0.0223, 'lps'),
	(461584, 102, '2015-04-01 00:04:15.000000', 'consum', 0.0226, 'lps'),
	(461585, 102, '2015-04-01 00:04:16.000000', 'consum', 0.0212, 'lps'),
	(461586, 102, '2015-04-01 00:04:17.000000', 'consum', 0.0216, 'lps'),
	(461587, 102, '2015-04-01 00:04:18.000000', 'consum', 0.0211, 'lps'),
	(461588, 102, '2015-04-01 00:04:19.000000', 'consum', 0.0218, 'lps'),
	(461589, 102, '2015-04-01 00:04:20.000000', 'consum', 0.0229, 'lps'),
	(461590, 102, '2015-04-01 00:04:21.000000', 'consum', 0.0218, 'lps'),
	(461591, 102, '2015-04-01 00:04:22.000000', 'consum', 0.0214, 'lps'),
	(461592, 102, '2015-04-01 00:04:23.000000', 'consum', 0.0229, 'lps'),
	(461593, 102, '2015-04-01 00:04:24.000000', 'consum', 0.0210, 'lps'),
	(461594, 102, '2015-04-01 00:04:25.000000', 'consum', 0.0217, 'lps'),
	(461595, 102, '2015-04-01 00:04:26.000000', 'consum', 0.0222, 'lps'),
	(461596, 102, '2015-04-01 00:04:27.000000', 'consum', 0.0228, 'lps'),
	(461597, 102, '2015-04-01 00:04:28.000000', 'consum', 0.0226, 'lps'),
	(461598, 102, '2015-04-01 00:04:29.000000', 'consum', 0.0212, 'lps'),
	(461599, 102, '2015-04-01 00:04:30.000000', 'consum', 0.0217, 'lps'),
	(461600, 102, '2015-04-01 00:04:31.000000', 'consum', 0.0220, 'lps'),
	(461601, 102, '2015-04-01 00:04:32.000000', 'consum', 0.0215, 'lps'),
	(461602, 102, '2015-04-01 00:04:33.000000', 'consum', 0.0227, 'lps'),
	(461603, 102, '2015-04-01 00:04:34.000000', 'consum', 0.0217, 'lps'),
	(461604, 102, '2015-04-01 00:04:35.000000', 'consum', 0.0216, 'lps'),
	(461605, 102, '2015-04-01 00:04:36.000000', 'consum', 0.0219, 'lps'),
	(461606, 102, '2015-04-01 00:04:37.000000', 'consum', 0.0218, 'lps'),
	(461607, 102, '2015-04-01 00:04:38.000000', 'consum', 0.0221, 'lps'),
	(461608, 102, '2015-04-01 00:04:39.000000', 'consum', 0.0222, 'lps'),
	(461609, 102, '2015-04-01 00:04:40.000000', 'consum', 0.0215, 'lps'),
	(461610, 102, '2015-04-01 00:04:41.000000', 'consum', 0.0220, 'lps'),
	(461611, 102, '2015-04-01 00:04:42.000000', 'consum', 0.0224, 'lps'),
	(461612, 102, '2015-04-01 00:04:43.000000', 'consum', 0.0210, 'lps'),
	(461613, 102, '2015-04-01 00:04:44.000000', 'consum', 0.0230, 'lps'),
	(461614, 102, '2015-04-01 00:04:45.000000', 'consum', 0.0227, 'lps'),
	(461615, 102, '2015-04-01 00:04:46.000000', 'consum', 0.0216, 'lps'),
	(461616, 102, '2015-04-01 00:04:47.000000', 'consum', 0.0229, 'lps'),
	(461617, 102, '2015-04-01 00:04:48.000000', 'consum', 0.0227, 'lps'),
	(461618, 102, '2015-04-01 00:04:49.000000', 'consum', 0.0216, 'lps'),
	(461619, 102, '2015-04-01 00:04:50.000000', 'consum', 0.0230, 'lps'),
	(461620, 102, '2015-04-01 00:04:51.000000', 'consum', 0.0212, 'lps'),
	(461621, 102, '2015-04-01 00:04:52.000000', 'consum', 0.0222, 'lps'),
	(461622, 102, '2015-04-01 00:04:53.000000', 'consum', 0.0221, 'lps'),
	(461623, 102, '2015-04-01 00:04:54.000000', 'consum', 0.0229, 'lps'),
	(461624, 102, '2015-04-01 00:04:55.000000', 'consum', 0.0212, 'lps'),
	(461625, 102, '2015-04-01 00:04:56.000000', 'consum', 0.0225, 'lps'),
	(461626, 102, '2015-04-01 00:04:57.000000', 'consum', 0.0217, 'lps'),
	(461627, 102, '2015-04-01 00:04:58.000000', 'consum', 0.0221, 'lps'),
	(461628, 102, '2015-04-01 00:04:59.000000', 'consum', 0.0222, 'lps'),
	(461629, 102, '2015-04-01 00:05:00.000000', 'consum', 0.0220, 'lps'),
	(461630, 102, '2015-04-01 00:05:01.000000', 'consum', 0.0222, 'lps'),
	(461631, 102, '2015-04-01 00:05:02.000000', 'consum', 0.0221, 'lps'),
	(461632, 102, '2015-04-01 00:05:03.000000', 'consum', 0.0229, 'lps'),
	(461633, 102, '2015-04-01 00:05:04.000000', 'consum', 0.0230, 'lps'),
	(461634, 102, '2015-04-01 00:05:05.000000', 'consum', 0.0211, 'lps'),
	(461635, 102, '2015-04-01 00:05:06.000000', 'consum', 0.0218, 'lps'),
	(461636, 102, '2015-04-01 00:05:07.000000', 'consum', 0.0229, 'lps'),
	(461637, 102, '2015-04-01 00:05:08.000000', 'consum', 0.0218, 'lps'),
	(461638, 102, '2015-04-01 00:05:09.000000', 'consum', 0.0213, 'lps'),
	(461639, 102, '2015-04-01 00:05:10.000000', 'consum', 0.0223, 'lps'),
	(461640, 102, '2015-04-01 00:05:11.000000', 'consum', 0.0224, 'lps'),
	(461641, 102, '2015-04-01 00:05:12.000000', 'consum', 0.0221, 'lps'),
	(461642, 102, '2015-04-01 00:05:13.000000', 'consum', 0.0223, 'lps'),
	(461643, 102, '2015-04-01 00:05:14.000000', 'consum', 0.0221, 'lps'),
	(461644, 102, '2015-04-01 00:05:15.000000', 'consum', 0.0227, 'lps'),
	(461645, 102, '2015-04-01 00:05:16.000000', 'consum', 0.0220, 'lps'),
	(461646, 102, '2015-04-01 00:05:17.000000', 'consum', 0.0211, 'lps'),
	(461647, 102, '2015-04-01 00:05:18.000000', 'consum', 0.0228, 'lps'),
	(461648, 102, '2015-04-01 00:05:19.000000', 'consum', 0.0211, 'lps'),
	(461649, 102, '2015-04-01 00:05:20.000000', 'consum', 0.0226, 'lps'),
	(461650, 102, '2015-04-01 00:05:21.000000', 'consum', 0.0223, 'lps'),
	(461651, 102, '2015-04-01 00:05:22.000000', 'consum', 0.0230, 'lps'),
	(461652, 102, '2015-04-01 00:05:23.000000', 'consum', 0.0228, 'lps'),
	(461653, 102, '2015-04-01 00:05:24.000000', 'consum', 0.0220, 'lps'),
	(461654, 102, '2015-04-01 00:05:25.000000', 'consum', 0.0226, 'lps'),
	(461655, 102, '2015-04-01 00:05:26.000000', 'consum', 0.0219, 'lps'),
	(461656, 102, '2015-04-01 00:05:27.000000', 'consum', 0.0228, 'lps'),
	(461657, 102, '2015-04-01 00:05:28.000000', 'consum', 0.0210, 'lps'),
	(461658, 102, '2015-04-01 00:05:29.000000', 'consum', 0.0219, 'lps'),
	(461659, 102, '2015-04-01 00:05:30.000000', 'consum', 0.0215, 'lps'),
	(461660, 102, '2015-04-01 00:05:31.000000', 'consum', 0.0227, 'lps'),
	(461661, 102, '2015-04-01 00:05:32.000000', 'consum', 0.0220, 'lps'),
	(461662, 102, '2015-04-01 00:05:33.000000', 'consum', 0.0210, 'lps'),
	(461663, 102, '2015-04-01 00:05:34.000000', 'consum', 0.0220, 'lps'),
	(461664, 102, '2015-04-01 00:05:35.000000', 'consum', 0.0220, 'lps'),
	(461665, 102, '2015-04-01 00:05:36.000000', 'consum', 0.0229, 'lps'),
	(461666, 102, '2015-04-01 00:05:37.000000', 'consum', 0.0215, 'lps'),
	(461667, 102, '2015-04-01 00:05:38.000000', 'consum', 0.0219, 'lps'),
	(461668, 102, '2015-04-01 00:05:39.000000', 'consum', 0.0220, 'lps'),
	(461669, 102, '2015-04-01 00:05:40.000000', 'consum', 0.0212, 'lps'),
	(461670, 102, '2015-04-01 00:05:41.000000', 'consum', 0.0213, 'lps'),
	(461671, 102, '2015-04-01 00:05:42.000000', 'consum', 0.0218, 'lps'),
	(461672, 102, '2015-04-01 00:05:43.000000', 'consum', 0.0220, 'lps'),
	(461673, 102, '2015-04-01 00:05:44.000000', 'consum', 0.0217, 'lps'),
	(461674, 102, '2015-04-01 00:05:45.000000', 'consum', 0.0214, 'lps'),
	(461675, 102, '2015-04-01 00:05:46.000000', 'consum', 0.0212, 'lps'),
	(461676, 102, '2015-04-01 00:05:47.000000', 'consum', 0.0228, 'lps'),
	(461677, 102, '2015-04-01 00:05:48.000000', 'consum', 0.0212, 'lps'),
	(461678, 102, '2015-04-01 00:05:49.000000', 'consum', 0.0230, 'lps'),
	(461679, 102, '2015-04-01 00:05:50.000000', 'consum', 0.0219, 'lps'),
	(461680, 102, '2015-04-01 00:05:51.000000', 'consum', 0.0215, 'lps'),
	(461681, 102, '2015-04-01 00:05:52.000000', 'consum', 0.0211, 'lps'),
	(461682, 102, '2015-04-01 00:05:53.000000', 'consum', 0.0221, 'lps'),
	(461683, 102, '2015-04-01 00:05:54.000000', 'consum', 0.0220, 'lps'),
	(461684, 102, '2015-04-01 00:05:55.000000', 'consum', 0.0228, 'lps'),
	(461685, 102, '2015-04-01 00:05:56.000000', 'consum', 0.0228, 'lps'),
	(461686, 102, '2015-04-01 00:05:57.000000', 'consum', 0.0224, 'lps'),
	(461687, 102, '2015-04-01 00:05:58.000000', 'consum', 0.0229, 'lps'),
	(461688, 102, '2015-04-01 00:05:59.000000', 'consum', 0.0221, 'lps'),
	(461689, 102, '2015-04-01 00:06:00.000000', 'consum', 0.0227, 'lps'),
	(461690, 102, '2015-04-01 00:06:01.000000', 'consum', 0.0223, 'lps'),
	(461691, 102, '2015-04-01 00:06:02.000000', 'consum', 0.0224, 'lps'),
	(461692, 102, '2015-04-01 00:06:03.000000', 'consum', 0.0220, 'lps'),
	(461693, 102, '2015-04-01 00:06:04.000000', 'consum', 0.0219, 'lps'),
	(461694, 102, '2015-04-01 00:06:05.000000', 'consum', 0.0224, 'lps'),
	(461695, 102, '2015-04-01 00:06:06.000000', 'consum', 0.0215, 'lps'),
	(461696, 102, '2015-04-01 00:06:07.000000', 'consum', 0.0211, 'lps'),
	(461697, 102, '2015-04-01 00:06:08.000000', 'consum', 0.0221, 'lps'),
	(461698, 102, '2015-04-01 00:06:09.000000', 'consum', 0.0222, 'lps'),
	(461699, 102, '2015-04-01 00:06:10.000000', 'consum', 0.0215, 'lps'),
	(461700, 102, '2015-04-01 00:06:11.000000', 'consum', 0.0221, 'lps'),
	(461701, 102, '2015-04-01 00:06:12.000000', 'consum', 0.0229, 'lps'),
	(461702, 102, '2015-04-01 00:06:13.000000', 'consum', 0.0230, 'lps'),
	(461703, 102, '2015-04-01 00:06:14.000000', 'consum', 0.0211, 'lps'),
	(461704, 102, '2015-04-01 00:06:15.000000', 'consum', 0.0220, 'lps'),
	(461705, 102, '2015-04-01 00:06:16.000000', 'consum', 0.0216, 'lps'),
	(461706, 102, '2015-04-01 00:06:17.000000', 'consum', 0.0210, 'lps'),
	(461707, 102, '2015-04-01 00:06:18.000000', 'consum', 0.0212, 'lps'),
	(461708, 102, '2015-04-01 00:06:19.000000', 'consum', 0.0223, 'lps'),
	(461709, 102, '2015-04-01 00:06:20.000000', 'consum', 0.0225, 'lps'),
	(461710, 102, '2015-04-01 00:06:21.000000', 'consum', 0.0225, 'lps'),
	(461711, 102, '2015-04-01 00:06:22.000000', 'consum', 0.0219, 'lps'),
	(461712, 102, '2015-04-01 00:06:23.000000', 'consum', 0.0211, 'lps'),
	(461713, 102, '2015-04-01 00:06:24.000000', 'consum', 0.0212, 'lps'),
	(461714, 102, '2015-04-01 00:06:25.000000', 'consum', 0.0214, 'lps'),
	(461715, 102, '2015-04-01 00:06:26.000000', 'consum', 0.0228, 'lps'),
	(461716, 102, '2015-04-01 00:06:27.000000', 'consum', 0.0223, 'lps'),
	(461717, 102, '2015-04-01 00:06:28.000000', 'consum', 0.0224, 'lps'),
	(461718, 102, '2015-04-01 00:06:29.000000', 'consum', 0.0220, 'lps'),
	(461719, 102, '2015-04-01 00:06:30.000000', 'consum', 0.0217, 'lps'),
	(461720, 102, '2015-04-01 00:06:31.000000', 'consum', 0.0215, 'lps'),
	(461721, 102, '2015-04-01 00:06:32.000000', 'consum', 0.0213, 'lps'),
	(461722, 102, '2015-04-01 00:06:33.000000', 'consum', 0.0214, 'lps'),
	(461723, 102, '2015-04-01 00:06:34.000000', 'consum', 0.0218, 'lps'),
	(461724, 102, '2015-04-01 00:06:35.000000', 'consum', 0.0220, 'lps'),
	(461725, 102, '2015-04-01 00:06:36.000000', 'consum', 0.0214, 'lps'),
	(461726, 102, '2015-04-01 00:06:37.000000', 'consum', 0.0221, 'lps'),
	(461727, 102, '2015-04-01 00:06:38.000000', 'consum', 0.0214, 'lps'),
	(461728, 102, '2015-04-01 00:06:39.000000', 'consum', 0.0215, 'lps'),
	(461729, 102, '2015-04-01 00:06:40.000000', 'consum', 0.0226, 'lps'),
	(461730, 102, '2015-04-01 00:06:41.000000', 'consum', 0.0213, 'lps'),
	(461731, 102, '2015-04-01 00:06:42.000000', 'consum', 0.0217, 'lps'),
	(461732, 102, '2015-04-01 00:06:43.000000', 'consum', 0.0219, 'lps'),
	(461733, 102, '2015-04-01 00:06:44.000000', 'consum', 0.0211, 'lps'),
	(461734, 102, '2015-04-01 00:06:45.000000', 'consum', 0.0230, 'lps'),
	(461735, 102, '2015-04-01 00:06:46.000000', 'consum', 0.0225, 'lps'),
	(461736, 102, '2015-04-01 00:06:47.000000', 'consum', 0.0224, 'lps'),
	(461737, 102, '2015-04-01 00:06:48.000000', 'consum', 0.0213, 'lps'),
	(461738, 102, '2015-04-01 00:06:49.000000', 'consum', 0.0228, 'lps'),
	(461739, 102, '2015-04-01 00:06:50.000000', 'consum', 0.0228, 'lps'),
	(461740, 102, '2015-04-01 00:06:51.000000', 'consum', 0.0226, 'lps'),
	(461741, 102, '2015-04-01 00:06:52.000000', 'consum', 0.0214, 'lps'),
	(461742, 102, '2015-04-01 00:06:53.000000', 'consum', 0.0225, 'lps'),
	(461743, 102, '2015-04-01 00:06:54.000000', 'consum', 0.0212, 'lps'),
	(461744, 102, '2015-04-01 00:06:55.000000', 'consum', 0.0215, 'lps'),
	(461745, 102, '2015-04-01 00:06:56.000000', 'consum', 0.0229, 'lps'),
	(461746, 102, '2015-04-01 00:06:57.000000', 'consum', 0.0229, 'lps'),
	(461747, 102, '2015-04-01 00:06:58.000000', 'consum', 0.0226, 'lps'),
	(461748, 102, '2015-04-01 00:06:59.000000', 'consum', 0.0212, 'lps'),
	(461749, 102, '2015-04-01 00:07:00.000000', 'consum', 0.0216, 'lps'),
	(461750, 102, '2015-04-01 00:07:01.000000', 'consum', 0.0212, 'lps'),
	(461751, 102, '2015-04-01 00:07:02.000000', 'consum', 0.0222, 'lps'),
	(461752, 102, '2015-04-01 00:07:03.000000', 'consum', 0.0225, 'lps'),
	(461753, 102, '2015-04-01 00:07:04.000000', 'consum', 0.0227, 'lps'),
	(461754, 102, '2015-04-01 00:07:05.000000', 'consum', 0.0210, 'lps'),
	(461755, 102, '2015-04-01 00:07:06.000000', 'consum', 0.0223, 'lps'),
	(461756, 102, '2015-04-01 00:07:07.000000', 'consum', 0.0210, 'lps'),
	(461757, 102, '2015-04-01 00:07:08.000000', 'consum', 0.0213, 'lps'),
	(461758, 102, '2015-04-01 00:07:09.000000', 'consum', 0.0226, 'lps'),
	(461759, 102, '2015-04-01 00:07:10.000000', 'consum', 0.0219, 'lps'),
	(461760, 102, '2015-04-01 00:07:11.000000', 'consum', 0.0227, 'lps'),
	(461761, 102, '2015-04-01 00:07:12.000000', 'consum', 0.0228, 'lps'),
	(461762, 102, '2015-04-01 00:07:13.000000', 'consum', 0.0228, 'lps'),
	(461763, 102, '2015-04-01 00:07:14.000000', 'consum', 0.0225, 'lps'),
	(461764, 102, '2015-04-01 00:07:15.000000', 'consum', 0.0210, 'lps'),
	(461765, 102, '2015-04-01 00:07:16.000000', 'consum', 0.0228, 'lps'),
	(461766, 102, '2015-04-01 00:07:17.000000', 'consum', 0.0216, 'lps'),
	(461767, 102, '2015-04-01 00:07:18.000000', 'consum', 0.0228, 'lps'),
	(461768, 102, '2015-04-01 00:07:19.000000', 'consum', 0.0222, 'lps'),
	(461769, 102, '2015-04-01 00:07:20.000000', 'consum', 0.0216, 'lps'),
	(461770, 102, '2015-04-01 00:07:21.000000', 'consum', 0.0225, 'lps'),
	(461771, 102, '2015-04-01 00:07:22.000000', 'consum', 0.0225, 'lps'),
	(461772, 102, '2015-04-01 00:07:23.000000', 'consum', 0.0222, 'lps'),
	(461773, 102, '2015-04-01 00:07:24.000000', 'consum', 0.0224, 'lps'),
	(461774, 102, '2015-04-01 00:07:25.000000', 'consum', 0.0222, 'lps'),
	(461775, 102, '2015-04-01 00:07:26.000000', 'consum', 0.0229, 'lps'),
	(461776, 102, '2015-04-01 00:07:27.000000', 'consum', 0.0228, 'lps'),
	(461777, 102, '2015-04-01 00:07:28.000000', 'consum', 0.0224, 'lps'),
	(461778, 102, '2015-04-01 00:07:29.000000', 'consum', 0.0225, 'lps'),
	(461779, 102, '2015-04-01 00:07:30.000000', 'consum', 0.0225, 'lps'),
	(461780, 102, '2015-04-01 00:07:31.000000', 'consum', 0.0217, 'lps'),
	(461781, 102, '2015-04-01 00:07:32.000000', 'consum', 0.0223, 'lps'),
	(461782, 102, '2015-04-01 00:07:33.000000', 'consum', 0.0211, 'lps'),
	(461783, 102, '2015-04-01 00:07:34.000000', 'consum', 0.0217, 'lps'),
	(461784, 102, '2015-04-01 00:07:35.000000', 'consum', 0.0224, 'lps'),
	(461785, 102, '2015-04-01 00:07:36.000000', 'consum', 0.0217, 'lps'),
	(461786, 102, '2015-04-01 00:07:37.000000', 'consum', 0.0226, 'lps'),
	(461787, 102, '2015-04-01 00:07:38.000000', 'consum', 0.0228, 'lps'),
	(461788, 102, '2015-04-01 00:07:39.000000', 'consum', 0.0229, 'lps'),
	(461789, 102, '2015-04-01 00:07:40.000000', 'consum', 0.0210, 'lps'),
	(461790, 102, '2015-04-01 00:07:41.000000', 'consum', 0.0216, 'lps'),
	(461791, 102, '2015-04-01 00:07:42.000000', 'consum', 0.0219, 'lps'),
	(461792, 102, '2015-04-01 00:07:43.000000', 'consum', 0.0218, 'lps'),
	(461793, 102, '2015-04-01 00:07:44.000000', 'consum', 0.0225, 'lps'),
	(461794, 102, '2015-04-01 00:07:45.000000', 'consum', 0.0218, 'lps'),
	(461795, 102, '2015-04-01 00:07:46.000000', 'consum', 0.0226, 'lps'),
	(461796, 102, '2015-04-01 00:07:47.000000', 'consum', 0.0223, 'lps'),
	(461797, 102, '2015-04-01 00:07:48.000000', 'consum', 0.0228, 'lps'),
	(461798, 102, '2015-04-01 00:07:49.000000', 'consum', 0.0219, 'lps'),
	(461799, 102, '2015-04-01 00:07:50.000000', 'consum', 0.0224, 'lps'),
	(461800, 102, '2015-04-01 00:07:51.000000', 'consum', 0.0210, 'lps'),
	(461801, 102, '2015-04-01 00:07:52.000000', 'consum', 0.0211, 'lps'),
	(461802, 102, '2015-04-01 00:07:53.000000', 'consum', 0.0215, 'lps'),
	(461803, 102, '2015-04-01 00:07:54.000000', 'consum', 0.0211, 'lps'),
	(461804, 102, '2015-04-01 00:07:55.000000', 'consum', 0.0224, 'lps'),
	(461805, 102, '2015-04-01 00:07:56.000000', 'consum', 0.0212, 'lps'),
	(461806, 102, '2015-04-01 00:07:57.000000', 'consum', 0.0220, 'lps'),
	(461807, 102, '2015-04-01 00:07:58.000000', 'consum', 0.0215, 'lps'),
	(461808, 102, '2015-04-01 00:07:59.000000', 'consum', 0.0225, 'lps'),
	(461809, 102, '2015-04-01 00:08:00.000000', 'consum', 0.0229, 'lps'),
	(461810, 102, '2015-04-01 00:08:01.000000', 'consum', 0.0219, 'lps'),
	(461811, 102, '2015-04-01 00:08:02.000000', 'consum', 0.0221, 'lps'),
	(461812, 102, '2015-04-01 00:08:03.000000', 'consum', 0.0216, 'lps'),
	(461813, 102, '2015-04-01 00:08:04.000000', 'consum', 0.0229, 'lps'),
	(461814, 102, '2015-04-01 00:08:05.000000', 'consum', 0.0225, 'lps'),
	(461815, 102, '2015-04-01 00:08:06.000000', 'consum', 0.0228, 'lps'),
	(461816, 102, '2015-04-01 00:08:07.000000', 'consum', 0.0213, 'lps'),
	(461817, 102, '2015-04-01 00:08:08.000000', 'consum', 0.0214, 'lps'),
	(461818, 102, '2015-04-01 00:08:09.000000', 'consum', 0.0222, 'lps'),
	(461819, 102, '2015-04-01 00:08:10.000000', 'consum', 0.0216, 'lps'),
	(461820, 102, '2015-04-01 00:08:11.000000', 'consum', 0.0227, 'lps'),
	(461821, 102, '2015-04-01 00:08:12.000000', 'consum', 0.0215, 'lps'),
	(461822, 102, '2015-04-01 00:08:13.000000', 'consum', 0.0227, 'lps'),
	(461823, 102, '2015-04-01 00:08:14.000000', 'consum', 0.0215, 'lps'),
	(461824, 102, '2015-04-01 00:08:15.000000', 'consum', 0.0229, 'lps'),
	(461825, 102, '2015-04-01 00:08:16.000000', 'consum', 0.0225, 'lps'),
	(461826, 102, '2015-04-01 00:08:17.000000', 'consum', 0.0230, 'lps'),
	(461827, 102, '2015-04-01 00:08:18.000000', 'consum', 0.0223, 'lps'),
	(461828, 102, '2015-04-01 00:08:19.000000', 'consum', 0.0217, 'lps'),
	(461829, 102, '2015-04-01 00:08:20.000000', 'consum', 0.0225, 'lps'),
	(461830, 102, '2015-04-01 00:08:21.000000', 'consum', 0.0225, 'lps'),
	(461831, 102, '2015-04-01 00:08:22.000000', 'consum', 0.0221, 'lps'),
	(461832, 102, '2015-04-01 00:08:23.000000', 'consum', 0.0217, 'lps'),
	(461833, 102, '2015-04-01 00:08:24.000000', 'consum', 0.0213, 'lps'),
	(461834, 102, '2015-04-01 00:08:25.000000', 'consum', 0.0226, 'lps'),
	(461835, 102, '2015-04-01 00:08:26.000000', 'consum', 0.0217, 'lps'),
	(461836, 102, '2015-04-01 00:08:27.000000', 'consum', 0.0218, 'lps'),
	(461837, 102, '2015-04-01 00:08:28.000000', 'consum', 0.0229, 'lps'),
	(461838, 102, '2015-04-01 00:08:29.000000', 'consum', 0.0220, 'lps'),
	(461839, 102, '2015-04-01 00:08:30.000000', 'consum', 0.0226, 'lps'),
	(461840, 102, '2015-04-01 00:08:31.000000', 'consum', 0.0215, 'lps'),
	(461841, 102, '2015-04-01 00:08:32.000000', 'consum', 0.0211, 'lps'),
	(461842, 102, '2015-04-01 00:08:33.000000', 'consum', 0.0223, 'lps'),
	(461843, 102, '2015-04-01 00:08:34.000000', 'consum', 0.0227, 'lps'),
	(461844, 102, '2015-04-01 00:08:35.000000', 'consum', 0.0217, 'lps'),
	(461845, 102, '2015-04-01 00:08:36.000000', 'consum', 0.0216, 'lps'),
	(461846, 102, '2015-04-01 00:08:37.000000', 'consum', 0.0220, 'lps'),
	(461847, 102, '2015-04-01 00:08:38.000000', 'consum', 0.0220, 'lps'),
	(461848, 102, '2015-04-01 00:08:39.000000', 'consum', 0.0211, 'lps'),
	(461849, 102, '2015-04-01 00:08:40.000000', 'consum', 0.0225, 'lps'),
	(461850, 102, '2015-04-01 00:08:41.000000', 'consum', 0.0220, 'lps'),
	(461851, 102, '2015-04-01 00:08:42.000000', 'consum', 0.0216, 'lps'),
	(461852, 102, '2015-04-01 00:08:43.000000', 'consum', 0.0230, 'lps'),
	(461853, 102, '2015-04-01 00:08:44.000000', 'consum', 0.0212, 'lps'),
	(461854, 102, '2015-04-01 00:08:45.000000', 'consum', 0.0220, 'lps'),
	(461855, 102, '2015-04-01 00:08:46.000000', 'consum', 0.0214, 'lps'),
	(461856, 102, '2015-04-01 00:08:47.000000', 'consum', 0.0222, 'lps'),
	(461857, 102, '2015-04-01 00:08:48.000000', 'consum', 0.0215, 'lps'),
	(461858, 102, '2015-04-01 00:08:49.000000', 'consum', 0.0223, 'lps'),
	(461859, 102, '2015-04-01 00:08:50.000000', 'consum', 0.0216, 'lps'),
	(461860, 102, '2015-04-01 00:08:51.000000', 'consum', 0.0223, 'lps'),
	(461861, 102, '2015-04-01 00:08:52.000000', 'consum', 0.0218, 'lps'),
	(461862, 102, '2015-04-01 00:08:53.000000', 'consum', 0.0229, 'lps'),
	(461863, 102, '2015-04-01 00:08:54.000000', 'consum', 0.0221, 'lps'),
	(461864, 102, '2015-04-01 00:08:55.000000', 'consum', 0.0229, 'lps'),
	(461865, 102, '2015-04-01 00:08:56.000000', 'consum', 0.0229, 'lps'),
	(461866, 102, '2015-04-01 00:08:57.000000', 'consum', 0.0229, 'lps'),
	(461867, 102, '2015-04-01 00:08:58.000000', 'consum', 0.0226, 'lps'),
	(461868, 102, '2015-04-01 00:08:59.000000', 'consum', 0.0212, 'lps'),
	(461869, 102, '2015-04-01 00:09:00.000000', 'consum', 0.0218, 'lps'),
	(461870, 102, '2015-04-01 00:09:01.000000', 'consum', 0.0220, 'lps'),
	(461871, 102, '2015-04-01 00:09:02.000000', 'consum', 0.0215, 'lps'),
	(461872, 102, '2015-04-01 00:09:03.000000', 'consum', 0.0226, 'lps'),
	(461873, 102, '2015-04-01 00:09:04.000000', 'consum', 0.0215, 'lps'),
	(461874, 102, '2015-04-01 00:09:05.000000', 'consum', 0.0229, 'lps'),
	(461875, 102, '2015-04-01 00:09:06.000000', 'consum', 0.0229, 'lps'),
	(461876, 102, '2015-04-01 00:09:07.000000', 'consum', 0.0225, 'lps'),
	(461877, 102, '2015-04-01 00:09:08.000000', 'consum', 0.0227, 'lps'),
	(461878, 102, '2015-04-01 00:09:09.000000', 'consum', 0.0212, 'lps'),
	(461879, 102, '2015-04-01 00:09:10.000000', 'consum', 0.0210, 'lps'),
	(461880, 102, '2015-04-01 00:09:11.000000', 'consum', 0.0226, 'lps'),
	(461881, 102, '2015-04-01 00:09:12.000000', 'consum', 0.0229, 'lps'),
	(461882, 102, '2015-04-01 00:09:13.000000', 'consum', 0.0215, 'lps'),
	(461883, 102, '2015-04-01 00:09:14.000000', 'consum', 0.0218, 'lps'),
	(461884, 102, '2015-04-01 00:09:15.000000', 'consum', 0.0216, 'lps'),
	(461885, 102, '2015-04-01 00:09:16.000000', 'consum', 0.0214, 'lps'),
	(461886, 102, '2015-04-01 00:09:17.000000', 'consum', 0.0216, 'lps'),
	(461887, 102, '2015-04-01 00:09:18.000000', 'consum', 0.0227, 'lps'),
	(461888, 102, '2015-04-01 00:09:19.000000', 'consum', 0.0213, 'lps'),
	(461889, 102, '2015-04-01 00:09:20.000000', 'consum', 0.0218, 'lps'),
	(461890, 102, '2015-04-01 00:09:21.000000', 'consum', 0.0222, 'lps'),
	(461891, 102, '2015-04-01 00:09:22.000000', 'consum', 0.0223, 'lps'),
	(461892, 102, '2015-04-01 00:09:23.000000', 'consum', 0.0217, 'lps'),
	(461893, 102, '2015-04-01 00:09:24.000000', 'consum', 0.0210, 'lps'),
	(461894, 102, '2015-04-01 00:09:25.000000', 'consum', 0.0229, 'lps'),
	(461895, 102, '2015-04-01 00:09:26.000000', 'consum', 0.0224, 'lps'),
	(461896, 102, '2015-04-01 00:09:27.000000', 'consum', 0.0224, 'lps'),
	(461897, 102, '2015-04-01 00:09:28.000000', 'consum', 0.0217, 'lps'),
	(461898, 102, '2015-04-01 00:09:29.000000', 'consum', 0.0222, 'lps'),
	(461899, 102, '2015-04-01 00:09:30.000000', 'consum', 0.0211, 'lps'),
	(461900, 102, '2015-04-01 00:09:31.000000', 'consum', 0.0219, 'lps'),
	(461901, 102, '2015-04-01 00:09:32.000000', 'consum', 0.0212, 'lps'),
	(461902, 102, '2015-04-01 00:09:33.000000', 'consum', 0.0214, 'lps'),
	(461903, 102, '2015-04-01 00:09:34.000000', 'consum', 0.0223, 'lps'),
	(461904, 102, '2015-04-01 00:09:35.000000', 'consum', 0.0223, 'lps'),
	(461905, 102, '2015-04-01 00:09:36.000000', 'consum', 0.0215, 'lps'),
	(461906, 102, '2015-04-01 00:09:37.000000', 'consum', 0.0216, 'lps'),
	(461907, 102, '2015-04-01 00:09:38.000000', 'consum', 0.0225, 'lps'),
	(461908, 102, '2015-04-01 00:09:39.000000', 'consum', 0.0228, 'lps'),
	(461909, 102, '2015-04-01 00:09:40.000000', 'consum', 0.0214, 'lps'),
	(461910, 102, '2015-04-01 00:09:41.000000', 'consum', 0.0216, 'lps'),
	(461911, 102, '2015-04-01 00:09:42.000000', 'consum', 0.0230, 'lps'),
	(461912, 102, '2015-04-01 00:09:43.000000', 'consum', 0.0210, 'lps'),
	(461913, 102, '2015-04-01 00:09:44.000000', 'consum', 0.0210, 'lps'),
	(461914, 102, '2015-04-01 00:09:45.000000', 'consum', 0.0214, 'lps'),
	(461915, 102, '2015-04-01 00:09:46.000000', 'consum', 0.0228, 'lps'),
	(461916, 102, '2015-04-01 00:09:47.000000', 'consum', 0.0226, 'lps'),
	(461917, 102, '2015-04-01 00:09:48.000000', 'consum', 0.0214, 'lps'),
	(461918, 102, '2015-04-01 00:09:49.000000', 'consum', 0.0227, 'lps'),
	(461919, 102, '2015-04-01 00:09:50.000000', 'consum', 0.0220, 'lps'),
	(461920, 102, '2015-04-01 00:09:51.000000', 'consum', 0.0210, 'lps'),
	(461921, 102, '2015-04-01 00:09:52.000000', 'consum', 0.0223, 'lps'),
	(461922, 102, '2015-04-01 00:09:53.000000', 'consum', 0.0211, 'lps'),
	(461923, 102, '2015-04-01 00:09:54.000000', 'consum', 0.0218, 'lps'),
	(461924, 102, '2015-04-01 00:09:55.000000', 'consum', 0.0229, 'lps'),
	(461925, 102, '2015-04-01 00:09:56.000000', 'consum', 0.0217, 'lps'),
	(461926, 102, '2015-04-01 00:09:57.000000', 'consum', 0.0229, 'lps'),
	(461927, 102, '2015-04-01 00:09:58.000000', 'consum', 0.0224, 'lps'),
	(461928, 102, '2015-04-01 00:09:59.000000', 'consum', 0.0221, 'lps'),
	(461929, 102, '2015-04-01 00:10:00.000000', 'consum', 0.0225, 'lps'),
	(461930, 102, '2015-04-01 00:10:01.000000', 'consum', 0.0230, 'lps'),
	(461931, 102, '2015-04-01 00:10:02.000000', 'consum', 0.0224, 'lps'),
	(461932, 102, '2015-04-01 00:10:03.000000', 'consum', 0.0222, 'lps'),
	(461933, 102, '2015-04-01 00:10:04.000000', 'consum', 0.0229, 'lps'),
	(461934, 102, '2015-04-01 00:10:05.000000', 'consum', 0.0226, 'lps'),
	(461935, 102, '2015-04-01 00:10:06.000000', 'consum', 0.0213, 'lps'),
	(461936, 102, '2015-04-01 00:10:07.000000', 'consum', 0.0219, 'lps'),
	(461937, 102, '2015-04-01 00:10:08.000000', 'consum', 0.0225, 'lps'),
	(461938, 102, '2015-04-01 00:10:09.000000', 'consum', 0.0217, 'lps'),
	(461939, 102, '2015-04-01 00:10:10.000000', 'consum', 0.0221, 'lps'),
	(461940, 102, '2015-04-01 00:10:11.000000', 'consum', 0.0222, 'lps'),
	(461941, 102, '2015-04-01 00:10:12.000000', 'consum', 0.0219, 'lps'),
	(461942, 102, '2015-04-01 00:10:13.000000', 'consum', 0.0220, 'lps'),
	(461943, 102, '2015-04-01 00:10:14.000000', 'consum', 0.0214, 'lps'),
	(461944, 102, '2015-04-01 00:10:15.000000', 'consum', 0.0218, 'lps'),
	(461945, 102, '2015-04-01 00:10:16.000000', 'consum', 0.0221, 'lps'),
	(461946, 102, '2015-04-01 00:10:17.000000', 'consum', 0.0218, 'lps'),
	(461947, 102, '2015-04-01 00:10:18.000000', 'consum', 0.0217, 'lps'),
	(461948, 102, '2015-04-01 00:10:19.000000', 'consum', 0.0221, 'lps'),
	(461949, 102, '2015-04-01 00:10:20.000000', 'consum', 0.0223, 'lps'),
	(461950, 102, '2015-04-01 00:10:21.000000', 'consum', 0.0223, 'lps'),
	(461951, 102, '2015-04-01 00:10:22.000000', 'consum', 0.0217, 'lps'),
	(461952, 102, '2015-04-01 00:10:23.000000', 'consum', 0.0224, 'lps'),
	(461953, 102, '2015-04-01 00:10:24.000000', 'consum', 0.0220, 'lps'),
	(461954, 102, '2015-04-01 00:10:25.000000', 'consum', 0.0220, 'lps'),
	(461955, 102, '2015-04-01 00:10:26.000000', 'consum', 0.0228, 'lps'),
	(461956, 102, '2015-04-01 00:10:27.000000', 'consum', 0.0230, 'lps'),
	(461957, 102, '2015-04-01 00:10:28.000000', 'consum', 0.0213, 'lps'),
	(461958, 102, '2015-04-01 00:10:29.000000', 'consum', 0.0228, 'lps'),
	(461959, 102, '2015-04-01 00:10:30.000000', 'consum', 0.0230, 'lps'),
	(461960, 102, '2015-04-01 00:10:31.000000', 'consum', 0.0214, 'lps'),
	(461961, 102, '2015-04-01 00:10:32.000000', 'consum', 0.0212, 'lps'),
	(461962, 102, '2015-04-01 00:10:33.000000', 'consum', 0.0228, 'lps'),
	(461963, 102, '2015-04-01 00:10:34.000000', 'consum', 0.0211, 'lps'),
	(461964, 102, '2015-04-01 00:10:35.000000', 'consum', 0.0226, 'lps'),
	(461965, 102, '2015-04-01 00:10:36.000000', 'consum', 0.0224, 'lps'),
	(461966, 102, '2015-04-01 00:10:37.000000', 'consum', 0.0211, 'lps'),
	(461967, 102, '2015-04-01 00:10:38.000000', 'consum', 0.0215, 'lps'),
	(461968, 102, '2015-04-01 00:10:39.000000', 'consum', 0.0211, 'lps'),
	(461969, 102, '2015-04-01 00:10:40.000000', 'consum', 0.0222, 'lps'),
	(461970, 102, '2015-04-01 00:10:41.000000', 'consum', 0.0224, 'lps'),
	(461971, 102, '2015-04-01 00:10:42.000000', 'consum', 0.0223, 'lps'),
	(461972, 102, '2015-04-01 00:10:43.000000', 'consum', 0.0214, 'lps'),
	(461973, 102, '2015-04-01 00:10:44.000000', 'consum', 0.0213, 'lps'),
	(461974, 102, '2015-04-01 00:10:45.000000', 'consum', 0.0213, 'lps'),
	(461975, 102, '2015-04-01 00:10:46.000000', 'consum', 0.0216, 'lps'),
	(461976, 102, '2015-04-01 00:10:47.000000', 'consum', 0.0210, 'lps'),
	(461977, 102, '2015-04-01 00:10:48.000000', 'consum', 0.0214, 'lps'),
	(461978, 102, '2015-04-01 00:10:49.000000', 'consum', 0.0211, 'lps'),
	(461979, 102, '2015-04-01 00:10:50.000000', 'consum', 0.0225, 'lps'),
	(461980, 102, '2015-04-01 00:10:51.000000', 'consum', 0.0218, 'lps'),
	(461981, 102, '2015-04-01 00:10:52.000000', 'consum', 0.0226, 'lps'),
	(461982, 102, '2015-04-01 00:10:53.000000', 'consum', 0.0225, 'lps'),
	(461983, 102, '2015-04-01 00:10:54.000000', 'consum', 0.0218, 'lps'),
	(461984, 102, '2015-04-01 00:10:55.000000', 'consum', 0.0226, 'lps'),
	(461985, 102, '2015-04-01 00:10:56.000000', 'consum', 0.0223, 'lps'),
	(461986, 102, '2015-04-01 00:10:57.000000', 'consum', 0.0228, 'lps'),
	(461987, 102, '2015-04-01 00:10:58.000000', 'consum', 0.0220, 'lps'),
	(461988, 102, '2015-04-01 00:10:59.000000', 'consum', 0.0227, 'lps'),
	(461989, 102, '2015-04-01 00:11:00.000000', 'consum', 0.0222, 'lps'),
	(461990, 102, '2015-04-01 00:11:01.000000', 'consum', 0.0220, 'lps'),
	(461991, 102, '2015-04-01 00:11:02.000000', 'consum', 0.0226, 'lps'),
	(461992, 102, '2015-04-01 00:11:03.000000', 'consum', 0.0218, 'lps'),
	(461993, 102, '2015-04-01 00:11:04.000000', 'consum', 0.0222, 'lps'),
	(461994, 102, '2015-04-01 00:11:05.000000', 'consum', 0.0227, 'lps'),
	(461995, 102, '2015-04-01 00:11:06.000000', 'consum', 0.0217, 'lps'),
	(461996, 102, '2015-04-01 00:11:07.000000', 'consum', 0.0217, 'lps'),
	(461997, 102, '2015-04-01 00:11:08.000000', 'consum', 0.0222, 'lps'),
	(461998, 102, '2015-04-01 00:11:09.000000', 'consum', 0.0228, 'lps'),
	(461999, 102, '2015-04-01 00:11:10.000000', 'consum', 0.0224, 'lps'),
	(462000, 102, '2015-04-01 00:11:11.000000', 'consum', 0.0227, 'lps'),
	(462001, 102, '2015-04-01 00:11:12.000000', 'consum', 0.0212, 'lps'),
	(462002, 102, '2015-04-01 00:11:13.000000', 'consum', 0.0211, 'lps'),
	(462003, 102, '2015-04-01 00:11:14.000000', 'consum', 0.0210, 'lps'),
	(462004, 102, '2015-04-01 00:11:15.000000', 'consum', 0.0229, 'lps'),
	(462005, 102, '2015-04-01 00:11:16.000000', 'consum', 0.0220, 'lps'),
	(462006, 102, '2015-04-01 00:11:17.000000', 'consum', 0.0225, 'lps'),
	(462007, 102, '2015-04-01 00:11:18.000000', 'consum', 0.0215, 'lps'),
	(462008, 102, '2015-04-01 00:11:19.000000', 'consum', 0.0212, 'lps'),
	(462009, 102, '2015-04-01 00:11:20.000000', 'consum', 0.0227, 'lps'),
	(462010, 102, '2015-04-01 00:11:21.000000', 'consum', 0.0225, 'lps'),
	(462011, 102, '2015-04-01 00:11:22.000000', 'consum', 0.0216, 'lps'),
	(462012, 102, '2015-04-01 00:11:23.000000', 'consum', 0.0214, 'lps'),
	(462013, 102, '2015-04-01 00:11:24.000000', 'consum', 0.0214, 'lps'),
	(462014, 102, '2015-04-01 00:11:25.000000', 'consum', 0.0219, 'lps'),
	(462015, 102, '2015-04-01 00:11:26.000000', 'consum', 0.0223, 'lps'),
	(462016, 102, '2015-04-01 00:11:27.000000', 'consum', 0.0225, 'lps'),
	(462017, 102, '2015-04-01 00:11:28.000000', 'consum', 0.0227, 'lps'),
	(462018, 102, '2015-04-01 00:11:29.000000', 'consum', 0.0230, 'lps'),
	(462019, 102, '2015-04-01 00:11:30.000000', 'consum', 0.0216, 'lps'),
	(462020, 102, '2015-04-01 00:11:31.000000', 'consum', 0.0225, 'lps'),
	(462021, 102, '2015-04-01 00:11:32.000000', 'consum', 0.0226, 'lps'),
	(462022, 102, '2015-04-01 00:11:33.000000', 'consum', 0.0221, 'lps'),
	(462023, 102, '2015-04-01 00:11:34.000000', 'consum', 0.0220, 'lps'),
	(462024, 102, '2015-04-01 00:11:35.000000', 'consum', 0.0228, 'lps'),
	(462025, 102, '2015-04-01 00:11:36.000000', 'consum', 0.0226, 'lps'),
	(462026, 102, '2015-04-01 00:11:37.000000', 'consum', 0.0215, 'lps'),
	(462027, 102, '2015-04-01 00:11:38.000000', 'consum', 0.0210, 'lps'),
	(462028, 102, '2015-04-01 00:11:39.000000', 'consum', 0.0217, 'lps'),
	(462029, 102, '2015-04-01 00:11:40.000000', 'consum', 0.0225, 'lps'),
	(462030, 102, '2015-04-01 00:11:41.000000', 'consum', 0.0222, 'lps'),
	(462031, 102, '2015-04-01 00:11:42.000000', 'consum', 0.0225, 'lps'),
	(462032, 102, '2015-04-01 00:11:43.000000', 'consum', 0.0228, 'lps'),
	(462033, 102, '2015-04-01 00:11:44.000000', 'consum', 0.0214, 'lps'),
	(462034, 102, '2015-04-01 00:11:45.000000', 'consum', 0.0217, 'lps'),
	(462035, 102, '2015-04-01 00:11:46.000000', 'consum', 0.0212, 'lps'),
	(462036, 102, '2015-04-01 00:11:47.000000', 'consum', 0.0220, 'lps'),
	(462037, 102, '2015-04-01 00:11:48.000000', 'consum', 0.0215, 'lps'),
	(462038, 102, '2015-04-01 00:11:49.000000', 'consum', 0.0224, 'lps'),
	(462039, 102, '2015-04-01 00:11:50.000000', 'consum', 0.0223, 'lps'),
	(462040, 102, '2015-04-01 00:11:51.000000', 'consum', 0.0214, 'lps'),
	(462041, 102, '2015-04-01 00:11:52.000000', 'consum', 0.0213, 'lps'),
	(462042, 102, '2015-04-01 00:11:53.000000', 'consum', 0.0214, 'lps'),
	(462043, 102, '2015-04-01 00:11:54.000000', 'consum', 0.0223, 'lps'),
	(462044, 102, '2015-04-01 00:11:55.000000', 'consum', 0.0219, 'lps'),
	(462045, 102, '2015-04-01 00:11:56.000000', 'consum', 0.0215, 'lps'),
	(462046, 102, '2015-04-01 00:11:57.000000', 'consum', 0.0210, 'lps'),
	(462047, 102, '2015-04-01 00:11:58.000000', 'consum', 0.0217, 'lps'),
	(462048, 102, '2015-04-01 00:11:59.000000', 'consum', 0.0226, 'lps'),
	(462049, 102, '2015-04-01 00:12:00.000000', 'consum', 0.0228, 'lps'),
	(462050, 102, '2015-04-01 00:12:01.000000', 'consum', 0.0228, 'lps'),
	(462051, 102, '2015-04-01 00:12:02.000000', 'consum', 0.0228, 'lps'),
	(462052, 102, '2015-04-01 00:12:03.000000', 'consum', 0.0224, 'lps'),
	(462053, 102, '2015-04-01 00:12:04.000000', 'consum', 0.0225, 'lps'),
	(462054, 102, '2015-04-01 00:12:05.000000', 'consum', 0.0224, 'lps'),
	(462055, 102, '2015-04-01 00:12:06.000000', 'consum', 0.0216, 'lps'),
	(462056, 102, '2015-04-01 00:12:07.000000', 'consum', 0.0217, 'lps'),
	(462057, 102, '2015-04-01 00:12:08.000000', 'consum', 0.0229, 'lps'),
	(462058, 102, '2015-04-01 00:12:09.000000', 'consum', 0.0222, 'lps'),
	(462059, 102, '2015-04-01 00:12:10.000000', 'consum', 0.0211, 'lps'),
	(462060, 102, '2015-04-01 00:12:11.000000', 'consum', 0.0223, 'lps'),
	(462061, 102, '2015-04-01 00:12:12.000000', 'consum', 0.0211, 'lps'),
	(462062, 102, '2015-04-01 00:12:13.000000', 'consum', 0.0217, 'lps'),
	(462063, 102, '2015-04-01 00:12:14.000000', 'consum', 0.0222, 'lps'),
	(462064, 102, '2015-04-01 00:12:15.000000', 'consum', 0.0230, 'lps'),
	(462065, 102, '2015-04-01 00:12:16.000000', 'consum', 0.0210, 'lps'),
	(462066, 102, '2015-04-01 00:12:17.000000', 'consum', 0.0215, 'lps'),
	(462067, 102, '2015-04-01 00:12:18.000000', 'consum', 0.0214, 'lps'),
	(462068, 102, '2015-04-01 00:12:19.000000', 'consum', 0.0217, 'lps'),
	(462069, 102, '2015-04-01 00:12:20.000000', 'consum', 0.0212, 'lps'),
	(462070, 102, '2015-04-01 00:12:21.000000', 'consum', 0.0218, 'lps'),
	(462071, 102, '2015-04-01 00:12:22.000000', 'consum', 0.0225, 'lps'),
	(462072, 102, '2015-04-01 00:12:23.000000', 'consum', 0.0220, 'lps'),
	(462073, 102, '2015-04-01 00:12:24.000000', 'consum', 0.0216, 'lps'),
	(462074, 102, '2015-04-01 00:12:25.000000', 'consum', 0.0230, 'lps'),
	(462075, 102, '2015-04-01 00:12:26.000000', 'consum', 0.0230, 'lps'),
	(462076, 102, '2015-04-01 00:12:27.000000', 'consum', 0.0229, 'lps'),
	(462077, 102, '2015-04-01 00:12:28.000000', 'consum', 0.0225, 'lps'),
	(462078, 102, '2015-04-01 00:12:29.000000', 'consum', 0.0227, 'lps'),
	(462079, 102, '2015-04-01 00:12:30.000000', 'consum', 0.0229, 'lps'),
	(462080, 102, '2015-04-01 00:12:31.000000', 'consum', 0.0214, 'lps'),
	(462081, 102, '2015-04-01 00:12:32.000000', 'consum', 0.0213, 'lps'),
	(462082, 102, '2015-04-01 00:12:33.000000', 'consum', 0.0216, 'lps'),
	(462083, 102, '2015-04-01 00:12:34.000000', 'consum', 0.0230, 'lps'),
	(462084, 102, '2015-04-01 00:12:35.000000', 'consum', 0.0230, 'lps'),
	(462085, 102, '2015-04-01 00:12:36.000000', 'consum', 0.0229, 'lps'),
	(462086, 102, '2015-04-01 00:12:37.000000', 'consum', 0.0226, 'lps'),
	(462087, 102, '2015-04-01 00:12:38.000000', 'consum', 0.0213, 'lps'),
	(462088, 102, '2015-04-01 00:12:39.000000', 'consum', 0.0219, 'lps'),
	(462089, 102, '2015-04-01 00:12:40.000000', 'consum', 0.0227, 'lps'),
	(462090, 102, '2015-04-01 00:12:41.000000', 'consum', 0.0226, 'lps'),
	(462091, 102, '2015-04-01 00:12:42.000000', 'consum', 0.0218, 'lps'),
	(462092, 102, '2015-04-01 00:12:43.000000', 'consum', 0.0224, 'lps'),
	(462093, 102, '2015-04-01 00:12:44.000000', 'consum', 0.0215, 'lps'),
	(462094, 102, '2015-04-01 00:12:45.000000', 'consum', 0.0214, 'lps'),
	(462095, 102, '2015-04-01 00:12:46.000000', 'consum', 0.0214, 'lps'),
	(462096, 102, '2015-04-01 00:12:47.000000', 'consum', 0.0219, 'lps'),
	(462097, 102, '2015-04-01 00:12:48.000000', 'consum', 0.0224, 'lps'),
	(462098, 102, '2015-04-01 00:12:49.000000', 'consum', 0.0212, 'lps'),
	(462099, 102, '2015-04-01 00:12:50.000000', 'consum', 0.0219, 'lps'),
	(462100, 102, '2015-04-01 00:12:51.000000', 'consum', 0.0230, 'lps'),
	(462101, 102, '2015-04-01 00:12:52.000000', 'consum', 0.0219, 'lps'),
	(462102, 102, '2015-04-01 00:12:53.000000', 'consum', 0.0218, 'lps'),
	(462103, 102, '2015-04-01 00:12:54.000000', 'consum', 0.0225, 'lps'),
	(462104, 102, '2015-04-01 00:12:55.000000', 'consum', 0.0216, 'lps'),
	(462105, 102, '2015-04-01 00:12:56.000000', 'consum', 0.0217, 'lps'),
	(462106, 102, '2015-04-01 00:12:57.000000', 'consum', 0.0230, 'lps'),
	(462107, 102, '2015-04-01 00:12:58.000000', 'consum', 0.0226, 'lps'),
	(462108, 102, '2015-04-01 00:12:59.000000', 'consum', 0.0228, 'lps'),
	(462109, 102, '2015-04-01 00:13:00.000000', 'consum', 0.0212, 'lps'),
	(462110, 102, '2015-04-01 00:13:01.000000', 'consum', 0.0228, 'lps'),
	(462111, 102, '2015-04-01 00:13:02.000000', 'consum', 0.0213, 'lps'),
	(462112, 102, '2015-04-01 00:13:03.000000', 'consum', 0.0213, 'lps'),
	(462113, 102, '2015-04-01 00:13:04.000000', 'consum', 0.0216, 'lps'),
	(462114, 102, '2015-04-01 00:13:05.000000', 'consum', 0.0212, 'lps'),
	(462115, 102, '2015-04-01 00:13:06.000000', 'consum', 0.0220, 'lps'),
	(462116, 102, '2015-04-01 00:13:07.000000', 'consum', 0.0216, 'lps'),
	(462117, 102, '2015-04-01 00:13:08.000000', 'consum', 0.0210, 'lps'),
	(462118, 102, '2015-04-01 00:13:09.000000', 'consum', 0.0214, 'lps'),
	(462119, 102, '2015-04-01 00:13:10.000000', 'consum', 0.0228, 'lps'),
	(462120, 102, '2015-04-01 00:13:11.000000', 'consum', 0.0226, 'lps'),
	(462121, 102, '2015-04-01 00:13:12.000000', 'consum', 0.0214, 'lps'),
	(462122, 102, '2015-04-01 00:13:13.000000', 'consum', 0.0227, 'lps'),
	(462123, 102, '2015-04-01 00:13:14.000000', 'consum', 0.0219, 'lps'),
	(462124, 102, '2015-04-01 00:13:15.000000', 'consum', 0.0227, 'lps'),
	(462125, 102, '2015-04-01 00:13:16.000000', 'consum', 0.0228, 'lps'),
	(462126, 102, '2015-04-01 00:13:17.000000', 'consum', 0.0226, 'lps'),
	(462127, 102, '2015-04-01 00:13:18.000000', 'consum', 0.0215, 'lps'),
	(462128, 102, '2015-04-01 00:13:19.000000', 'consum', 0.0228, 'lps'),
	(462129, 102, '2015-04-01 00:13:20.000000', 'consum', 0.0225, 'lps'),
	(462130, 102, '2015-04-01 00:13:21.000000', 'consum', 0.0212, 'lps'),
	(462131, 102, '2015-04-01 00:13:22.000000', 'consum', 0.0214, 'lps'),
	(462132, 102, '2015-04-01 00:13:23.000000', 'consum', 0.0228, 'lps'),
	(462133, 102, '2015-04-01 00:13:24.000000', 'consum', 0.0222, 'lps'),
	(462134, 102, '2015-04-01 00:13:25.000000', 'consum', 0.0219, 'lps'),
	(462135, 102, '2015-04-01 00:13:26.000000', 'consum', 0.0218, 'lps'),
	(462136, 102, '2015-04-01 00:13:27.000000', 'consum', 0.0223, 'lps'),
	(462137, 102, '2015-04-01 00:13:28.000000', 'consum', 0.0210, 'lps'),
	(462138, 102, '2015-04-01 00:13:29.000000', 'consum', 0.0215, 'lps'),
	(462139, 102, '2015-04-01 00:13:30.000000', 'consum', 0.0213, 'lps'),
	(462140, 102, '2015-04-01 00:13:31.000000', 'consum', 0.0230, 'lps'),
	(462141, 102, '2015-04-01 00:13:32.000000', 'consum', 0.0218, 'lps'),
	(462142, 102, '2015-04-01 00:13:33.000000', 'consum', 0.0214, 'lps'),
	(462143, 102, '2015-04-01 00:13:34.000000', 'consum', 0.0226, 'lps'),
	(462144, 102, '2015-04-01 00:13:35.000000', 'consum', 0.0218, 'lps'),
	(462145, 102, '2015-04-01 00:13:36.000000', 'consum', 0.0220, 'lps'),
	(462146, 102, '2015-04-01 00:13:37.000000', 'consum', 0.0217, 'lps'),
	(462147, 102, '2015-04-01 00:13:38.000000', 'consum', 0.0217, 'lps'),
	(462148, 102, '2015-04-01 00:13:39.000000', 'consum', 0.0221, 'lps'),
	(462149, 102, '2015-04-01 00:13:40.000000', 'consum', 0.0226, 'lps'),
	(462150, 102, '2015-04-01 00:13:41.000000', 'consum', 0.0216, 'lps'),
	(462151, 102, '2015-04-01 00:13:42.000000', 'consum', 0.0214, 'lps'),
	(462152, 102, '2015-04-01 00:13:43.000000', 'consum', 0.0210, 'lps'),
	(462153, 102, '2015-04-01 00:13:44.000000', 'consum', 0.0222, 'lps'),
	(462154, 102, '2015-04-01 00:13:45.000000', 'consum', 0.0229, 'lps'),
	(462155, 102, '2015-04-01 00:13:46.000000', 'consum', 0.0225, 'lps'),
	(462156, 102, '2015-04-01 00:13:47.000000', 'consum', 0.0230, 'lps'),
	(462157, 102, '2015-04-01 00:13:48.000000', 'consum', 0.0222, 'lps'),
	(462158, 102, '2015-04-01 00:13:49.000000', 'consum', 0.0212, 'lps'),
	(462159, 102, '2015-04-01 00:13:50.000000', 'consum', 0.0227, 'lps'),
	(462160, 102, '2015-04-01 00:13:51.000000', 'consum', 0.0226, 'lps'),
	(462161, 102, '2015-04-01 00:13:52.000000', 'consum', 0.0218, 'lps'),
	(462162, 102, '2015-04-01 00:13:53.000000', 'consum', 0.0222, 'lps'),
	(462163, 102, '2015-04-01 00:13:54.000000', 'consum', 0.0229, 'lps'),
	(462164, 102, '2015-04-01 00:13:55.000000', 'consum', 0.0225, 'lps'),
	(462165, 102, '2015-04-01 00:13:56.000000', 'consum', 0.0230, 'lps'),
	(462166, 102, '2015-04-01 00:13:57.000000', 'consum', 0.0224, 'lps'),
	(462167, 102, '2015-04-01 00:13:58.000000', 'consum', 0.0221, 'lps'),
	(462168, 102, '2015-04-01 00:13:59.000000', 'consum', 0.0223, 'lps'),
	(462169, 102, '2015-04-01 00:14:00.000000', 'consum', 0.0219, 'lps'),
	(462170, 102, '2015-04-01 00:14:01.000000', 'consum', 0.0219, 'lps'),
	(462171, 102, '2015-04-01 00:14:02.000000', 'consum', 0.0226, 'lps'),
	(462172, 102, '2015-04-01 00:14:03.000000', 'consum', 0.0224, 'lps'),
	(462173, 102, '2015-04-01 00:14:04.000000', 'consum', 0.0213, 'lps'),
	(462174, 102, '2015-04-01 00:14:05.000000', 'consum', 0.0222, 'lps'),
	(462175, 102, '2015-04-01 00:14:06.000000', 'consum', 0.0223, 'lps'),
	(462176, 102, '2015-04-01 00:14:07.000000', 'consum', 0.0216, 'lps'),
	(462177, 102, '2015-04-01 00:14:08.000000', 'consum', 0.0221, 'lps'),
	(462178, 102, '2015-04-01 00:14:09.000000', 'consum', 0.0230, 'lps'),
	(462179, 102, '2015-04-01 00:14:10.000000', 'consum', 0.0212, 'lps'),
	(462180, 102, '2015-04-01 00:14:11.000000', 'consum', 0.0225, 'lps'),
	(462181, 102, '2015-04-01 00:14:12.000000', 'consum', 0.0216, 'lps'),
	(462182, 102, '2015-04-01 00:14:13.000000', 'consum', 0.0218, 'lps'),
	(462183, 102, '2015-04-01 00:14:14.000000', 'consum', 0.0230, 'lps'),
	(462184, 102, '2015-04-01 00:14:15.000000', 'consum', 0.0223, 'lps'),
	(462185, 102, '2015-04-01 00:14:16.000000', 'consum', 0.0215, 'lps'),
	(462186, 102, '2015-04-01 00:14:17.000000', 'consum', 0.0218, 'lps'),
	(462187, 102, '2015-04-01 00:14:18.000000', 'consum', 0.0217, 'lps'),
	(462188, 102, '2015-04-01 00:14:19.000000', 'consum', 0.0218, 'lps'),
	(462189, 102, '2015-04-01 00:14:20.000000', 'consum', 0.0211, 'lps'),
	(462190, 102, '2015-04-01 00:14:21.000000', 'consum', 0.0213, 'lps'),
	(462191, 102, '2015-04-01 00:14:22.000000', 'consum', 0.0222, 'lps'),
	(462192, 102, '2015-04-01 00:14:23.000000', 'consum', 0.0220, 'lps'),
	(462193, 102, '2015-04-01 00:14:24.000000', 'consum', 0.0224, 'lps'),
	(462194, 102, '2015-04-01 00:14:25.000000', 'consum', 0.0210, 'lps'),
	(462195, 102, '2015-04-01 00:14:26.000000', 'consum', 0.0229, 'lps'),
	(462196, 102, '2015-04-01 00:14:27.000000', 'consum', 0.0223, 'lps'),
	(462197, 102, '2015-04-01 00:14:28.000000', 'consum', 0.0217, 'lps'),
	(462198, 102, '2015-04-01 00:14:29.000000', 'consum', 0.0229, 'lps'),
	(462199, 102, '2015-04-01 00:14:30.000000', 'consum', 0.0223, 'lps'),
	(462200, 102, '2015-04-01 00:14:31.000000', 'consum', 0.0215, 'lps'),
	(462201, 102, '2015-04-01 00:14:32.000000', 'consum', 0.0220, 'lps'),
	(462202, 102, '2015-04-01 00:14:33.000000', 'consum', 0.0226, 'lps'),
	(462203, 102, '2015-04-01 00:14:34.000000', 'consum', 0.0215, 'lps'),
	(462204, 102, '2015-04-01 00:14:35.000000', 'consum', 0.0212, 'lps'),
	(462205, 102, '2015-04-01 00:14:36.000000', 'consum', 0.0224, 'lps'),
	(462206, 102, '2015-04-01 00:14:37.000000', 'consum', 0.0214, 'lps'),
	(462207, 102, '2015-04-01 00:14:38.000000', 'consum', 0.0229, 'lps'),
	(462208, 102, '2015-04-01 00:14:39.000000', 'consum', 0.0212, 'lps'),
	(462209, 102, '2015-04-01 00:14:40.000000', 'consum', 0.0223, 'lps'),
	(462210, 102, '2015-04-01 00:14:41.000000', 'consum', 0.0229, 'lps'),
	(462211, 102, '2015-04-01 00:14:42.000000', 'consum', 0.0224, 'lps'),
	(462212, 102, '2015-04-01 00:14:43.000000', 'consum', 0.0222, 'lps'),
	(462213, 102, '2015-04-01 00:14:44.000000', 'consum', 0.0229, 'lps'),
	(462214, 102, '2015-04-01 00:14:45.000000', 'consum', 0.0230, 'lps'),
	(462215, 102, '2015-04-01 00:14:46.000000', 'consum', 0.0230, 'lps'),
	(462216, 102, '2015-04-01 00:14:47.000000', 'consum', 0.0230, 'lps'),
	(462217, 102, '2015-04-01 00:14:48.000000', 'consum', 0.0211, 'lps'),
	(462218, 102, '2015-04-01 00:14:49.000000', 'consum', 0.0215, 'lps'),
	(462219, 102, '2015-04-01 00:14:50.000000', 'consum', 0.0213, 'lps'),
	(462220, 102, '2015-04-01 00:14:51.000000', 'consum', 0.0230, 'lps'),
	(462221, 102, '2015-04-01 00:14:52.000000', 'consum', 0.0219, 'lps'),
	(462222, 102, '2015-04-01 00:14:53.000000', 'consum', 0.0214, 'lps'),
	(462223, 102, '2015-04-01 00:14:54.000000', 'consum', 0.0228, 'lps'),
	(462224, 102, '2015-04-01 00:14:55.000000', 'consum', 0.0224, 'lps'),
	(462225, 102, '2015-04-01 00:14:56.000000', 'consum', 0.0226, 'lps'),
	(462226, 102, '2015-04-01 00:14:57.000000', 'consum', 0.0227, 'lps'),
	(462227, 102, '2015-04-01 00:14:58.000000', 'consum', 0.0225, 'lps'),
	(462228, 102, '2015-04-01 00:14:59.000000', 'consum', 0.0216, 'lps'),
	(462229, 102, '2015-04-01 00:15:00.000000', 'consum', 0.0217, 'lps'),
	(462230, 102, '2015-04-01 00:15:01.000000', 'consum', 0.0228, 'lps'),
	(462231, 102, '2015-04-01 00:15:02.000000', 'consum', 0.0217, 'lps'),
	(462232, 102, '2015-04-01 00:15:03.000000', 'consum', 0.0214, 'lps'),
	(462233, 102, '2015-04-01 00:15:04.000000', 'consum', 0.0227, 'lps'),
	(462234, 102, '2015-04-01 00:15:05.000000', 'consum', 0.0221, 'lps'),
	(462235, 102, '2015-04-01 00:15:06.000000', 'consum', 0.0213, 'lps'),
	(462236, 102, '2015-04-01 00:15:07.000000', 'consum', 0.0215, 'lps'),
	(462237, 102, '2015-04-01 00:15:08.000000', 'consum', 0.0225, 'lps'),
	(462238, 102, '2015-04-01 00:15:09.000000', 'consum', 0.0230, 'lps'),
	(462239, 102, '2015-04-01 00:15:10.000000', 'consum', 0.0224, 'lps'),
	(462240, 102, '2015-04-01 00:15:11.000000', 'consum', 0.0219, 'lps'),
	(462241, 102, '2015-04-01 00:15:12.000000', 'consum', 0.0214, 'lps'),
	(462242, 102, '2015-04-01 00:15:13.000000', 'consum', 0.0225, 'lps'),
	(462243, 102, '2015-04-01 00:15:14.000000', 'consum', 0.0211, 'lps'),
	(462244, 102, '2015-04-01 00:15:15.000000', 'consum', 0.0211, 'lps'),
	(462245, 102, '2015-04-01 00:15:16.000000', 'consum', 0.0213, 'lps'),
	(462246, 102, '2015-04-01 00:15:17.000000', 'consum', 0.0223, 'lps'),
	(462247, 102, '2015-04-01 00:15:18.000000', 'consum', 0.0225, 'lps'),
	(462248, 102, '2015-04-01 00:15:19.000000', 'consum', 0.0225, 'lps'),
	(462249, 102, '2015-04-01 00:15:20.000000', 'consum', 0.0221, 'lps'),
	(462250, 102, '2015-04-01 00:15:21.000000', 'consum', 0.0220, 'lps'),
	(462251, 102, '2015-04-01 00:15:22.000000', 'consum', 0.0228, 'lps'),
	(462252, 102, '2015-04-01 00:15:23.000000', 'consum', 0.0229, 'lps'),
	(462253, 102, '2015-04-01 00:15:24.000000', 'consum', 0.0210, 'lps'),
	(462254, 102, '2015-04-01 00:15:25.000000', 'consum', 0.0215, 'lps'),
	(462255, 102, '2015-04-01 00:15:26.000000', 'consum', 0.0214, 'lps'),
	(462256, 102, '2015-04-01 00:15:27.000000', 'consum', 0.0214, 'lps'),
	(462257, 102, '2015-04-01 00:15:28.000000', 'consum', 0.0222, 'lps'),
	(462258, 102, '2015-04-01 00:15:29.000000', 'consum', 0.0213, 'lps'),
	(462259, 102, '2015-04-01 00:15:30.000000', 'consum', 0.0213, 'lps'),
	(462260, 102, '2015-04-01 00:15:31.000000', 'consum', 0.0217, 'lps'),
	(462261, 102, '2015-04-01 00:15:32.000000', 'consum', 0.0215, 'lps'),
	(462262, 102, '2015-04-01 00:15:33.000000', 'consum', 0.0215, 'lps'),
	(462263, 102, '2015-04-01 00:15:34.000000', 'consum', 0.0221, 'lps'),
	(462264, 102, '2015-04-01 00:15:35.000000', 'consum', 0.0227, 'lps'),
	(462265, 102, '2015-04-01 00:15:36.000000', 'consum', 0.0221, 'lps'),
	(462266, 102, '2015-04-01 00:15:37.000000', 'consum', 0.0215, 'lps'),
	(462267, 102, '2015-04-01 00:15:38.000000', 'consum', 0.0226, 'lps'),
	(462268, 102, '2015-04-01 00:15:39.000000', 'consum', 0.0230, 'lps'),
	(462269, 102, '2015-04-01 00:15:40.000000', 'consum', 0.0221, 'lps'),
	(462270, 102, '2015-04-01 00:15:41.000000', 'consum', 0.0229, 'lps'),
	(462271, 102, '2015-04-01 00:15:42.000000', 'consum', 0.0229, 'lps'),
	(462272, 102, '2015-04-01 00:15:43.000000', 'consum', 0.0226, 'lps'),
	(462273, 102, '2015-04-01 00:15:44.000000', 'consum', 0.0212, 'lps'),
	(462274, 102, '2015-04-01 00:15:45.000000', 'consum', 0.0215, 'lps'),
	(462275, 102, '2015-04-01 00:15:46.000000', 'consum', 0.0210, 'lps'),
	(462276, 102, '2015-04-01 00:15:47.000000', 'consum', 0.0214, 'lps'),
	(462277, 102, '2015-04-01 00:15:48.000000', 'consum', 0.0210, 'lps'),
	(462278, 102, '2015-04-01 00:15:49.000000', 'consum', 0.0218, 'lps'),
	(462279, 102, '2015-04-01 00:15:50.000000', 'consum', 0.0211, 'lps'),
	(462280, 102, '2015-04-01 00:15:51.000000', 'consum', 0.0213, 'lps'),
	(462281, 102, '2015-04-01 00:15:52.000000', 'consum', 0.0221, 'lps'),
	(462282, 102, '2015-04-01 00:15:53.000000', 'consum', 0.0216, 'lps'),
	(462283, 102, '2015-04-01 00:15:54.000000', 'consum', 0.0227, 'lps'),
	(462284, 102, '2015-04-01 00:15:55.000000', 'consum', 0.0214, 'lps'),
	(462285, 102, '2015-04-01 00:15:56.000000', 'consum', 0.0223, 'lps'),
	(462286, 102, '2015-04-01 00:15:57.000000', 'consum', 0.0223, 'lps'),
	(462287, 102, '2015-04-01 00:15:58.000000', 'consum', 0.0212, 'lps'),
	(462288, 102, '2015-04-01 00:15:59.000000', 'consum', 0.0226, 'lps'),
	(462289, 102, '2015-04-01 00:16:00.000000', 'consum', 0.0220, 'lps'),
	(462290, 102, '2015-04-01 00:16:01.000000', 'consum', 0.0212, 'lps'),
	(462291, 102, '2015-04-01 00:16:02.000000', 'consum', 0.0213, 'lps'),
	(462292, 102, '2015-04-01 00:16:03.000000', 'consum', 0.0218, 'lps'),
	(462293, 102, '2015-04-01 00:16:04.000000', 'consum', 0.0220, 'lps'),
	(462294, 102, '2015-04-01 00:16:05.000000', 'consum', 0.0215, 'lps'),
	(462295, 102, '2015-04-01 00:16:06.000000', 'consum', 0.0227, 'lps'),
	(462296, 102, '2015-04-01 00:16:07.000000', 'consum', 0.0217, 'lps'),
	(462297, 102, '2015-04-01 00:16:08.000000', 'consum', 0.0218, 'lps'),
	(462298, 102, '2015-04-01 00:16:09.000000', 'consum', 0.0229, 'lps'),
	(462299, 102, '2015-04-01 00:16:10.000000', 'consum', 0.0216, 'lps'),
	(462300, 102, '2015-04-01 00:16:11.000000', 'consum', 0.0227, 'lps'),
	(462301, 102, '2015-04-01 00:16:12.000000', 'consum', 0.0216, 'lps'),
	(462302, 102, '2015-04-01 00:16:13.000000', 'consum', 0.0228, 'lps'),
	(462303, 102, '2015-04-01 00:16:14.000000', 'consum', 0.0222, 'lps'),
	(462304, 102, '2015-04-01 00:16:15.000000', 'consum', 0.0218, 'lps'),
	(462305, 102, '2015-04-01 00:16:16.000000', 'consum', 0.0211, 'lps'),
	(462306, 102, '2015-04-01 00:16:17.000000', 'consum', 0.0216, 'lps'),
	(462307, 102, '2015-04-01 00:16:18.000000', 'consum', 0.0213, 'lps'),
	(462308, 102, '2015-04-01 00:16:19.000000', 'consum', 0.0230, 'lps'),
	(462309, 102, '2015-04-01 00:16:20.000000', 'consum', 0.0216, 'lps'),
	(462310, 102, '2015-04-01 00:16:21.000000', 'consum', 0.0221, 'lps'),
	(462311, 102, '2015-04-01 00:16:22.000000', 'consum', 0.0230, 'lps'),
	(462312, 102, '2015-04-01 00:16:23.000000', 'consum', 0.0215, 'lps'),
	(462313, 102, '2015-04-01 00:16:24.000000', 'consum', 0.0214, 'lps'),
	(462314, 102, '2015-04-01 00:16:25.000000', 'consum', 0.0218, 'lps'),
	(462315, 102, '2015-04-01 00:16:26.000000', 'consum', 0.0216, 'lps'),
	(462316, 102, '2015-04-01 00:16:27.000000', 'consum', 0.0219, 'lps'),
	(462317, 102, '2015-04-01 00:16:28.000000', 'consum', 0.0214, 'lps'),
	(462318, 102, '2015-04-01 00:16:29.000000', 'consum', 0.0224, 'lps'),
	(462319, 102, '2015-04-01 00:16:30.000000', 'consum', 0.0227, 'lps'),
	(462320, 102, '2015-04-01 00:16:31.000000', 'consum', 0.0210, 'lps'),
	(462321, 102, '2015-04-01 00:16:32.000000', 'consum', 0.0224, 'lps'),
	(462322, 102, '2015-04-01 00:16:33.000000', 'consum', 0.0217, 'lps'),
	(462323, 102, '2015-04-01 00:16:34.000000', 'consum', 0.0223, 'lps'),
	(462324, 102, '2015-04-01 00:16:35.000000', 'consum', 0.0215, 'lps'),
	(462325, 102, '2015-04-01 00:16:36.000000', 'consum', 0.0217, 'lps'),
	(462326, 102, '2015-04-01 00:16:37.000000', 'consum', 0.0228, 'lps'),
	(462327, 102, '2015-04-01 00:16:38.000000', 'consum', 0.0219, 'lps'),
	(462328, 102, '2015-04-01 00:16:39.000000', 'consum', 0.0222, 'lps'),
	(462329, 102, '2015-04-01 00:16:40.000000', 'consum', 0.0223, 'lps'),
	(462330, 102, '2015-04-01 00:16:41.000000', 'consum', 0.0220, 'lps'),
	(462331, 102, '2015-04-01 00:16:42.000000', 'consum', 0.0218, 'lps'),
	(462332, 102, '2015-04-01 00:16:43.000000', 'consum', 0.0222, 'lps'),
	(462333, 102, '2015-04-01 00:16:44.000000', 'consum', 0.0227, 'lps'),
	(462334, 102, '2015-04-01 00:16:45.000000', 'consum', 0.0217, 'lps'),
	(462335, 102, '2015-04-01 00:16:46.000000', 'consum', 0.0215, 'lps'),
	(462336, 102, '2015-04-01 00:16:47.000000', 'consum', 0.0213, 'lps'),
	(462337, 102, '2015-04-01 00:16:48.000000', 'consum', 0.0212, 'lps'),
	(462338, 102, '2015-04-01 00:16:49.000000', 'consum', 0.0230, 'lps'),
	(462339, 102, '2015-04-01 00:16:50.000000', 'consum', 0.0223, 'lps'),
	(462340, 102, '2015-04-01 00:16:51.000000', 'consum', 0.0214, 'lps'),
	(462341, 102, '2015-04-01 00:16:52.000000', 'consum', 0.0214, 'lps'),
	(462342, 102, '2015-04-01 00:16:53.000000', 'consum', 0.0219, 'lps'),
	(462343, 102, '2015-04-01 00:16:54.000000', 'consum', 0.0221, 'lps'),
	(462344, 102, '2015-04-01 00:16:55.000000', 'consum', 0.0217, 'lps'),
	(462345, 102, '2015-04-01 00:16:56.000000', 'consum', 0.0215, 'lps'),
	(462346, 102, '2015-04-01 00:16:57.000000', 'consum', 0.0214, 'lps'),
	(462347, 102, '2015-04-01 00:16:58.000000', 'consum', 0.0213, 'lps'),
	(462348, 102, '2015-04-01 00:16:59.000000', 'consum', 0.0216, 'lps'),
	(462349, 102, '2015-04-01 00:17:00.000000', 'consum', 0.0230, 'lps'),
	(462350, 102, '2015-04-01 00:17:01.000000', 'consum', 0.0211, 'lps'),
	(462351, 102, '2015-04-01 00:17:02.000000', 'consum', 0.0217, 'lps'),
	(462352, 102, '2015-04-01 00:17:03.000000', 'consum', 0.0221, 'lps'),
	(462353, 102, '2015-04-01 00:17:04.000000', 'consum', 0.0224, 'lps'),
	(462354, 102, '2015-04-01 00:17:05.000000', 'consum', 0.0228, 'lps'),
	(462355, 102, '2015-04-01 00:17:06.000000', 'consum', 0.0214, 'lps'),
	(462356, 102, '2015-04-01 00:17:07.000000', 'consum', 0.0219, 'lps'),
	(462357, 102, '2015-04-01 00:17:08.000000', 'consum', 0.0221, 'lps'),
	(462358, 102, '2015-04-01 00:17:09.000000', 'consum', 0.0218, 'lps'),
	(462359, 102, '2015-04-01 00:17:10.000000', 'consum', 0.0218, 'lps'),
	(462360, 102, '2015-04-01 00:17:11.000000', 'consum', 0.0227, 'lps'),
	(462361, 102, '2015-04-01 00:17:12.000000', 'consum', 0.0230, 'lps'),
	(462362, 102, '2015-04-01 00:17:13.000000', 'consum', 0.0217, 'lps'),
	(462363, 102, '2015-04-01 00:17:14.000000', 'consum', 0.0229, 'lps'),
	(462364, 102, '2015-04-01 00:17:15.000000', 'consum', 0.0222, 'lps'),
	(462365, 102, '2015-04-01 00:17:16.000000', 'consum', 0.0212, 'lps'),
	(462366, 102, '2015-04-01 00:17:17.000000', 'consum', 0.0225, 'lps'),
	(462367, 102, '2015-04-01 00:17:18.000000', 'consum', 0.0220, 'lps'),
	(462368, 102, '2015-04-01 00:17:19.000000', 'consum', 0.0212, 'lps'),
	(462369, 102, '2015-04-01 00:17:20.000000', 'consum', 0.0212, 'lps'),
	(462370, 102, '2015-04-01 00:17:21.000000', 'consum', 0.0215, 'lps'),
	(462371, 102, '2015-04-01 00:17:22.000000', 'consum', 0.0228, 'lps'),
	(462372, 102, '2015-04-01 00:17:23.000000', 'consum', 0.0225, 'lps'),
	(462373, 102, '2015-04-01 00:17:24.000000', 'consum', 0.0210, 'lps'),
	(462374, 102, '2015-04-01 00:17:25.000000', 'consum', 0.0227, 'lps'),
	(462375, 102, '2015-04-01 00:17:26.000000', 'consum', 0.0213, 'lps'),
	(462376, 102, '2015-04-01 00:17:27.000000', 'consum', 0.0216, 'lps'),
	(462377, 102, '2015-04-01 00:17:28.000000', 'consum', 0.0210, 'lps'),
	(462378, 102, '2015-04-01 00:17:29.000000', 'consum', 0.0213, 'lps'),
	(462379, 102, '2015-04-01 00:17:30.000000', 'consum', 0.0226, 'lps'),
	(462380, 102, '2015-04-01 00:17:31.000000', 'consum', 0.0221, 'lps'),
	(462381, 102, '2015-04-01 00:17:32.000000', 'consum', 0.0214, 'lps'),
	(462382, 102, '2015-04-01 00:17:33.000000', 'consum', 0.0221, 'lps'),
	(462383, 102, '2015-04-01 00:17:34.000000', 'consum', 0.0210, 'lps'),
	(462384, 102, '2015-04-01 00:17:35.000000', 'consum', 0.0219, 'lps'),
	(462385, 102, '2015-04-01 00:17:36.000000', 'consum', 0.0215, 'lps'),
	(462386, 102, '2015-04-01 00:17:37.000000', 'consum', 0.0228, 'lps'),
	(462387, 102, '2015-04-01 00:17:38.000000', 'consum', 0.0222, 'lps'),
	(462388, 102, '2015-04-01 00:17:39.000000', 'consum', 0.0216, 'lps'),
	(462389, 102, '2015-04-01 00:17:40.000000', 'consum', 0.0226, 'lps'),
	(462390, 102, '2015-04-01 00:17:41.000000', 'consum', 0.0230, 'lps'),
	(462391, 102, '2015-04-01 00:17:42.000000', 'consum', 0.0221, 'lps'),
	(462392, 102, '2015-04-01 00:17:43.000000', 'consum', 0.0226, 'lps'),
	(462393, 102, '2015-04-01 00:17:44.000000', 'consum', 0.0214, 'lps'),
	(462394, 102, '2015-04-01 00:17:45.000000', 'consum', 0.0225, 'lps'),
	(462395, 102, '2015-04-01 00:17:46.000000', 'consum', 0.0211, 'lps'),
	(462396, 102, '2015-04-01 00:17:47.000000', 'consum', 0.0212, 'lps'),
	(462397, 102, '2015-04-01 00:17:48.000000', 'consum', 0.0218, 'lps'),
	(462398, 102, '2015-04-01 00:17:49.000000', 'consum', 0.0222, 'lps'),
	(462399, 102, '2015-04-01 00:17:50.000000', 'consum', 0.0226, 'lps'),
	(462400, 102, '2015-04-01 00:17:51.000000', 'consum', 0.0213, 'lps'),
	(462401, 102, '2015-04-01 00:17:52.000000', 'consum', 0.0219, 'lps'),
	(462402, 102, '2015-04-01 00:17:53.000000', 'consum', 0.0228, 'lps'),
	(462403, 102, '2015-04-01 00:17:54.000000', 'consum', 0.0228, 'lps'),
	(462404, 102, '2015-04-01 00:17:55.000000', 'consum', 0.0227, 'lps'),
	(462405, 102, '2015-04-01 00:17:56.000000', 'consum', 0.0219, 'lps'),
	(462406, 102, '2015-04-01 00:17:57.000000', 'consum', 0.0226, 'lps'),
	(462407, 102, '2015-04-01 00:17:58.000000', 'consum', 0.0222, 'lps'),
	(462408, 102, '2015-04-01 00:17:59.000000', 'consum', 0.0223, 'lps'),
	(462409, 102, '2015-04-01 00:18:00.000000', 'consum', 0.0219, 'lps'),
	(462410, 102, '2015-04-01 00:18:01.000000', 'consum', 0.0215, 'lps'),
	(462411, 102, '2015-04-01 00:18:02.000000', 'consum', 0.0229, 'lps'),
	(462412, 102, '2015-04-01 00:18:03.000000', 'consum', 0.0230, 'lps'),
	(462413, 102, '2015-04-01 00:18:04.000000', 'consum', 0.0229, 'lps'),
	(462414, 102, '2015-04-01 00:18:05.000000', 'consum', 0.0227, 'lps'),
	(462415, 102, '2015-04-01 00:18:06.000000', 'consum', 0.0218, 'lps'),
	(462416, 102, '2015-04-01 00:18:07.000000', 'consum', 0.0218, 'lps'),
	(462417, 102, '2015-04-01 00:18:08.000000', 'consum', 0.0227, 'lps'),
	(462418, 102, '2015-04-01 00:18:09.000000', 'consum', 0.0211, 'lps'),
	(462419, 102, '2015-04-01 00:18:10.000000', 'consum', 0.0225, 'lps'),
	(462420, 102, '2015-04-01 00:18:11.000000', 'consum', 0.0221, 'lps'),
	(462421, 102, '2015-04-01 00:18:12.000000', 'consum', 0.0219, 'lps'),
	(462422, 102, '2015-04-01 00:18:13.000000', 'consum', 0.0223, 'lps'),
	(462423, 102, '2015-04-01 00:18:14.000000', 'consum', 0.0230, 'lps'),
	(462424, 102, '2015-04-01 00:18:15.000000', 'consum', 0.0226, 'lps'),
	(462425, 102, '2015-04-01 00:18:16.000000', 'consum', 0.0212, 'lps'),
	(462426, 102, '2015-04-01 00:18:17.000000', 'consum', 0.0214, 'lps'),
	(462427, 102, '2015-04-01 00:18:18.000000', 'consum', 0.0224, 'lps'),
	(462428, 102, '2015-04-01 00:18:19.000000', 'consum', 0.0226, 'lps'),
	(462429, 102, '2015-04-01 00:18:20.000000', 'consum', 0.0229, 'lps'),
	(462430, 102, '2015-04-01 00:18:21.000000', 'consum', 0.0214, 'lps'),
	(462431, 102, '2015-04-01 00:18:22.000000', 'consum', 0.0216, 'lps'),
	(462432, 102, '2015-04-01 00:18:23.000000', 'consum', 0.0230, 'lps'),
	(462433, 102, '2015-04-01 00:18:24.000000', 'consum', 0.0230, 'lps'),
	(462434, 102, '2015-04-01 00:18:25.000000', 'consum', 0.0229, 'lps'),
	(462435, 102, '2015-04-01 00:18:26.000000', 'consum', 0.0223, 'lps'),
	(462436, 102, '2015-04-01 00:18:27.000000', 'consum', 0.0219, 'lps'),
	(462437, 102, '2015-04-01 00:18:28.000000', 'consum', 0.0215, 'lps'),
	(462438, 102, '2015-04-01 00:18:29.000000', 'consum', 0.0229, 'lps'),
	(462439, 102, '2015-04-01 00:18:30.000000', 'consum', 0.0229, 'lps'),
	(462440, 102, '2015-04-01 00:18:31.000000', 'consum', 0.0228, 'lps'),
	(462441, 102, '2015-04-01 00:18:32.000000', 'consum', 0.0222, 'lps'),
	(462442, 102, '2015-04-01 00:18:33.000000', 'consum', 0.0215, 'lps'),
	(462443, 102, '2015-04-01 00:18:34.000000', 'consum', 0.0223, 'lps'),
	(462444, 102, '2015-04-01 00:18:35.000000', 'consum', 0.0216, 'lps'),
	(462445, 102, '2015-04-01 00:18:36.000000', 'consum', 0.0223, 'lps'),
	(462446, 102, '2015-04-01 00:18:37.000000', 'consum', 0.0217, 'lps'),
	(462447, 102, '2015-04-01 00:18:38.000000', 'consum', 0.0229, 'lps'),
	(462448, 102, '2015-04-01 00:18:39.000000', 'consum', 0.0219, 'lps'),
	(462449, 102, '2015-04-01 00:18:40.000000', 'consum', 0.0219, 'lps'),
	(462450, 102, '2015-04-01 00:18:41.000000', 'consum', 0.0230, 'lps'),
	(462451, 102, '2015-04-01 00:18:42.000000', 'consum', 0.0220, 'lps'),
	(462452, 102, '2015-04-01 00:18:43.000000', 'consum', 0.0222, 'lps'),
	(462453, 102, '2015-04-01 00:18:44.000000', 'consum', 0.0220, 'lps'),
	(462454, 102, '2015-04-01 00:18:45.000000', 'consum', 0.0222, 'lps'),
	(462455, 102, '2015-04-01 00:18:46.000000', 'consum', 0.0222, 'lps'),
	(462456, 102, '2015-04-01 00:18:47.000000', 'consum', 0.0213, 'lps'),
	(462457, 102, '2015-04-01 00:18:48.000000', 'consum', 0.0211, 'lps'),
	(462458, 102, '2015-04-01 00:18:49.000000', 'consum', 0.0228, 'lps'),
	(462459, 102, '2015-04-01 00:18:50.000000', 'consum', 0.0214, 'lps'),
	(462460, 102, '2015-04-01 00:18:51.000000', 'consum', 0.0218, 'lps'),
	(462461, 102, '2015-04-01 00:18:52.000000', 'consum', 0.0218, 'lps'),
	(462462, 102, '2015-04-01 00:18:53.000000', 'consum', 0.0224, 'lps'),
	(462463, 102, '2015-04-01 00:18:54.000000', 'consum', 0.0217, 'lps'),
	(462464, 102, '2015-04-01 00:18:55.000000', 'consum', 0.0223, 'lps'),
	(462465, 102, '2015-04-01 00:18:56.000000', 'consum', 0.0212, 'lps'),
	(462466, 102, '2015-04-01 00:18:57.000000', 'consum', 0.0223, 'lps'),
	(462467, 102, '2015-04-01 00:18:58.000000', 'consum', 0.0227, 'lps'),
	(462468, 102, '2015-04-01 00:18:59.000000', 'consum', 0.0215, 'lps'),
	(462469, 102, '2015-04-01 00:19:00.000000', 'consum', 0.0228, 'lps'),
	(462470, 102, '2015-04-01 00:19:01.000000', 'consum', 0.0223, 'lps'),
	(462471, 102, '2015-04-01 00:19:02.000000', 'consum', 0.0219, 'lps'),
	(462472, 102, '2015-04-01 00:19:03.000000', 'consum', 0.0220, 'lps'),
	(462473, 102, '2015-04-01 00:19:04.000000', 'consum', 0.0230, 'lps'),
	(462474, 102, '2015-04-01 00:19:05.000000', 'consum', 0.0219, 'lps'),
	(462475, 102, '2015-04-01 00:19:06.000000', 'consum', 0.0216, 'lps'),
	(462476, 102, '2015-04-01 00:19:07.000000', 'consum', 0.0215, 'lps'),
	(462477, 102, '2015-04-01 00:19:08.000000', 'consum', 0.0216, 'lps'),
	(462478, 102, '2015-04-01 00:19:09.000000', 'consum', 0.0227, 'lps'),
	(462479, 102, '2015-04-01 00:19:10.000000', 'consum', 0.0213, 'lps'),
	(462480, 102, '2015-04-01 00:19:11.000000', 'consum', 0.0216, 'lps'),
	(462481, 102, '2015-04-01 00:19:12.000000', 'consum', 0.0213, 'lps'),
	(462482, 102, '2015-04-01 00:19:13.000000', 'consum', 0.0227, 'lps'),
	(462483, 102, '2015-04-01 00:19:14.000000', 'consum', 0.0224, 'lps'),
	(462484, 102, '2015-04-01 00:19:15.000000', 'consum', 0.0228, 'lps'),
	(462485, 102, '2015-04-01 00:19:16.000000', 'consum', 0.0218, 'lps'),
	(462486, 102, '2015-04-01 00:19:17.000000', 'consum', 0.0215, 'lps'),
	(462487, 102, '2015-04-01 00:19:18.000000', 'consum', 0.0213, 'lps'),
	(462488, 102, '2015-04-01 00:19:19.000000', 'consum', 0.0211, 'lps'),
	(462489, 102, '2015-04-01 00:19:20.000000', 'consum', 0.0229, 'lps'),
	(462490, 102, '2015-04-01 00:19:21.000000', 'consum', 0.0215, 'lps'),
	(462491, 102, '2015-04-01 00:19:22.000000', 'consum', 0.0222, 'lps'),
	(462492, 102, '2015-04-01 00:19:23.000000', 'consum', 0.0215, 'lps'),
	(462493, 102, '2015-04-01 00:19:24.000000', 'consum', 0.0219, 'lps'),
	(462494, 102, '2015-04-01 00:19:25.000000', 'consum', 0.0219, 'lps'),
	(462495, 102, '2015-04-01 00:19:26.000000', 'consum', 0.0227, 'lps'),
	(462496, 102, '2015-04-01 00:19:27.000000', 'consum', 0.0229, 'lps'),
	(462497, 102, '2015-04-01 00:19:28.000000', 'consum', 0.0211, 'lps'),
	(462498, 102, '2015-04-01 00:19:29.000000', 'consum', 0.0223, 'lps'),
	(462499, 102, '2015-04-01 00:19:30.000000', 'consum', 0.0210, 'lps'),
	(462500, 102, '2015-04-01 00:19:31.000000', 'consum', 0.0214, 'lps'),
	(462501, 102, '2015-04-01 00:19:32.000000', 'consum', 0.0230, 'lps'),
	(462502, 102, '2015-04-01 00:19:33.000000', 'consum', 0.0213, 'lps'),
	(462503, 102, '2015-04-01 00:19:34.000000', 'consum', 0.0229, 'lps'),
	(462504, 102, '2015-04-01 00:19:35.000000', 'consum', 0.0214, 'lps'),
	(462505, 102, '2015-04-01 00:19:36.000000', 'consum', 0.0216, 'lps'),
	(462506, 102, '2015-04-01 00:19:37.000000', 'consum', 0.0229, 'lps'),
	(462507, 102, '2015-04-01 00:19:38.000000', 'consum', 0.0225, 'lps'),
	(462508, 102, '2015-04-01 00:19:39.000000', 'consum', 0.0229, 'lps'),
	(462509, 102, '2015-04-01 00:19:40.000000', 'consum', 0.0217, 'lps'),
	(462510, 102, '2015-04-01 00:19:41.000000', 'consum', 0.0230, 'lps'),
	(462511, 102, '2015-04-01 00:19:42.000000', 'consum', 0.0225, 'lps'),
	(462512, 102, '2015-04-01 00:19:43.000000', 'consum', 0.0226, 'lps'),
	(462513, 102, '2015-04-01 00:19:44.000000', 'consum', 0.0227, 'lps'),
	(462514, 102, '2015-04-01 00:19:45.000000', 'consum', 0.0226, 'lps'),
	(462515, 102, '2015-04-01 00:19:46.000000', 'consum', 0.0220, 'lps'),
	(462516, 102, '2015-04-01 00:19:47.000000', 'consum', 0.0211, 'lps'),
	(462517, 102, '2015-04-01 00:19:48.000000', 'consum', 0.0226, 'lps'),
	(462518, 102, '2015-04-01 00:19:49.000000', 'consum', 0.0225, 'lps'),
	(462519, 102, '2015-04-01 00:19:50.000000', 'consum', 0.0215, 'lps'),
	(462520, 102, '2015-04-01 00:19:51.000000', 'consum', 0.0213, 'lps'),
	(462521, 102, '2015-04-01 00:19:52.000000', 'consum', 0.0210, 'lps'),
	(462522, 102, '2015-04-01 00:19:53.000000', 'consum', 0.0222, 'lps'),
	(462523, 102, '2015-04-01 00:19:54.000000', 'consum', 0.0229, 'lps'),
	(462524, 102, '2015-04-01 00:19:55.000000', 'consum', 0.0226, 'lps'),
	(462525, 102, '2015-04-01 00:19:56.000000', 'consum', 0.0213, 'lps'),
	(462526, 102, '2015-04-01 00:19:57.000000', 'consum', 0.0222, 'lps'),
	(462527, 102, '2015-04-01 00:19:58.000000', 'consum', 0.0217, 'lps'),
	(462528, 102, '2015-04-01 00:19:59.000000', 'consum', 0.0212, 'lps'),
	(462529, 102, '2015-04-01 00:20:00.000000', 'consum', 0.0217, 'lps'),
	(462530, 102, '2015-04-01 00:20:01.000000', 'consum', 0.0221, 'lps'),
	(462531, 102, '2015-04-01 00:20:02.000000', 'consum', 0.0224, 'lps'),
	(462532, 102, '2015-04-01 00:20:03.000000', 'consum', 0.0224, 'lps'),
	(462533, 102, '2015-04-01 00:20:04.000000', 'consum', 0.0218, 'lps'),
	(462534, 102, '2015-04-01 00:20:05.000000', 'consum', 0.0228, 'lps'),
	(462535, 102, '2015-04-01 00:20:06.000000', 'consum', 0.0215, 'lps'),
	(462536, 102, '2015-04-01 00:20:07.000000', 'consum', 0.0226, 'lps'),
	(462537, 102, '2015-04-01 00:20:08.000000', 'consum', 0.0230, 'lps'),
	(462538, 102, '2015-04-01 00:20:09.000000', 'consum', 0.0220, 'lps'),
	(462539, 102, '2015-04-01 00:20:10.000000', 'consum', 0.0224, 'lps'),
	(462540, 102, '2015-04-01 00:20:11.000000', 'consum', 0.0230, 'lps'),
	(462541, 102, '2015-04-01 00:20:12.000000', 'consum', 0.0226, 'lps'),
	(462542, 102, '2015-04-01 00:20:13.000000', 'consum', 0.0210, 'lps'),
	(462543, 102, '2015-04-01 00:20:14.000000', 'consum', 0.0226, 'lps'),
	(462544, 102, '2015-04-01 00:20:15.000000', 'consum', 0.0225, 'lps'),
	(462545, 102, '2015-04-01 00:20:16.000000', 'consum', 0.0219, 'lps'),
	(462546, 102, '2015-04-01 00:20:17.000000', 'consum', 0.0230, 'lps'),
	(462547, 102, '2015-04-01 00:20:18.000000', 'consum', 0.0222, 'lps'),
	(462548, 102, '2015-04-01 00:20:19.000000', 'consum', 0.0210, 'lps'),
	(462549, 102, '2015-04-01 00:20:20.000000', 'consum', 0.0218, 'lps'),
	(462550, 102, '2015-04-01 00:20:21.000000', 'consum', 0.0230, 'lps'),
	(462551, 102, '2015-04-01 00:20:22.000000', 'consum', 0.0221, 'lps'),
	(462552, 102, '2015-04-01 00:20:23.000000', 'consum', 0.0227, 'lps'),
	(462553, 102, '2015-04-01 00:20:24.000000', 'consum', 0.0222, 'lps'),
	(462554, 102, '2015-04-01 00:20:25.000000', 'consum', 0.0220, 'lps'),
	(462555, 102, '2015-04-01 00:20:26.000000', 'consum', 0.0225, 'lps'),
	(462556, 102, '2015-04-01 00:20:27.000000', 'consum', 0.0211, 'lps'),
	(462557, 102, '2015-04-01 00:20:28.000000', 'consum', 0.0215, 'lps'),
	(462558, 102, '2015-04-01 00:20:29.000000', 'consum', 0.0229, 'lps'),
	(462559, 102, '2015-04-01 00:20:30.000000', 'consum', 0.0210, 'lps'),
	(462560, 102, '2015-04-01 00:20:31.000000', 'consum', 0.0214, 'lps'),
	(462561, 102, '2015-04-01 00:20:32.000000', 'consum', 0.0211, 'lps'),
	(462562, 102, '2015-04-01 00:20:33.000000', 'consum', 0.0225, 'lps'),
	(462563, 102, '2015-04-01 00:20:34.000000', 'consum', 0.0218, 'lps'),
	(462564, 102, '2015-04-01 00:20:35.000000', 'consum', 0.0227, 'lps'),
	(462565, 102, '2015-04-01 00:20:36.000000', 'consum', 0.0211, 'lps'),
	(462566, 102, '2015-04-01 00:20:37.000000', 'consum', 0.0224, 'lps'),
	(462567, 102, '2015-04-01 00:20:38.000000', 'consum', 0.0215, 'lps'),
	(462568, 102, '2015-04-01 00:20:39.000000', 'consum', 0.0217, 'lps'),
	(462569, 102, '2015-04-01 00:20:40.000000', 'consum', 0.0228, 'lps'),
	(462570, 102, '2015-04-01 00:20:41.000000', 'consum', 0.0217, 'lps'),
	(462571, 102, '2015-04-01 00:20:42.000000', 'consum', 0.0213, 'lps'),
	(462572, 102, '2015-04-01 00:20:43.000000', 'consum', 0.0223, 'lps'),
	(462573, 102, '2015-04-01 00:20:44.000000', 'consum', 0.0227, 'lps'),
	(462574, 102, '2015-04-01 00:20:45.000000', 'consum', 0.0215, 'lps'),
	(462575, 102, '2015-04-01 00:20:46.000000', 'consum', 0.0225, 'lps'),
	(462576, 102, '2015-04-01 00:20:47.000000', 'consum', 0.0228, 'lps'),
	(462577, 102, '2015-04-01 00:20:48.000000', 'consum', 0.0216, 'lps'),
	(462578, 102, '2015-04-01 00:20:49.000000', 'consum', 0.0229, 'lps'),
	(462579, 102, '2015-04-01 00:20:50.000000', 'consum', 0.0222, 'lps'),
	(462580, 102, '2015-04-01 00:20:51.000000', 'consum', 0.0213, 'lps'),
	(462581, 102, '2015-04-01 00:20:52.000000', 'consum', 0.0211, 'lps'),
	(462582, 102, '2015-04-01 00:20:53.000000', 'consum', 0.0227, 'lps'),
	(462583, 102, '2015-04-01 00:20:54.000000', 'consum', 0.0211, 'lps'),
	(462584, 102, '2015-04-01 00:20:55.000000', 'consum', 0.0225, 'lps'),
	(462585, 102, '2015-04-01 00:20:56.000000', 'consum', 0.0220, 'lps'),
	(462586, 102, '2015-04-01 00:20:57.000000', 'consum', 0.0215, 'lps'),
	(462587, 102, '2015-04-01 00:20:58.000000', 'consum', 0.0226, 'lps'),
	(462588, 102, '2015-04-01 00:20:59.000000', 'consum', 0.0212, 'lps'),
	(462589, 102, '2015-04-01 00:21:00.000000', 'consum', 0.0217, 'lps'),
	(462590, 102, '2015-04-01 00:21:01.000000', 'consum', 0.0217, 'lps'),
	(462591, 102, '2015-04-01 00:21:02.000000', 'consum', 0.0225, 'lps'),
	(462592, 102, '2015-04-01 00:21:03.000000', 'consum', 0.0224, 'lps'),
	(462593, 102, '2015-04-01 00:21:04.000000', 'consum', 0.0215, 'lps'),
	(462594, 102, '2015-04-01 00:21:05.000000', 'consum', 0.0213, 'lps'),
	(462595, 102, '2015-04-01 00:21:06.000000', 'consum', 0.0211, 'lps'),
	(462596, 102, '2015-04-01 00:21:07.000000', 'consum', 0.0225, 'lps'),
	(462597, 102, '2015-04-01 00:21:08.000000', 'consum', 0.0223, 'lps'),
	(462598, 102, '2015-04-01 00:21:09.000000', 'consum', 0.0230, 'lps'),
	(462599, 102, '2015-04-01 00:21:10.000000', 'consum', 0.0228, 'lps'),
	(462600, 102, '2015-04-01 00:21:11.000000', 'consum', 0.0219, 'lps'),
	(462601, 102, '2015-04-01 00:21:12.000000', 'consum', 0.0224, 'lps'),
	(462602, 102, '2015-04-01 00:21:13.000000', 'consum', 0.0211, 'lps'),
	(462603, 102, '2015-04-01 00:21:14.000000', 'consum', 0.0217, 'lps'),
	(462604, 102, '2015-04-01 00:21:15.000000', 'consum', 0.0222, 'lps'),
	(462605, 102, '2015-04-01 00:21:16.000000', 'consum', 0.0226, 'lps'),
	(462606, 102, '2015-04-01 00:21:17.000000', 'consum', 0.0214, 'lps'),
	(462607, 102, '2015-04-01 00:21:18.000000', 'consum', 0.0224, 'lps'),
	(462608, 102, '2015-04-01 00:21:19.000000', 'consum', 0.0227, 'lps'),
	(462609, 102, '2015-04-01 00:21:20.000000', 'consum', 0.0210, 'lps'),
	(462610, 102, '2015-04-01 00:21:21.000000', 'consum', 0.0222, 'lps'),
	(462611, 102, '2015-04-01 00:21:22.000000', 'consum', 0.0229, 'lps'),
	(462612, 102, '2015-04-01 00:21:23.000000', 'consum', 0.0230, 'lps'),
	(462613, 102, '2015-04-01 00:21:24.000000', 'consum', 0.0229, 'lps'),
	(462614, 102, '2015-04-01 00:21:25.000000', 'consum', 0.0228, 'lps'),
	(462615, 102, '2015-04-01 00:21:26.000000', 'consum', 0.0219, 'lps'),
	(462616, 102, '2015-04-01 00:21:27.000000', 'consum', 0.0225, 'lps'),
	(462617, 102, '2015-04-01 00:21:28.000000', 'consum', 0.0214, 'lps'),
	(462618, 102, '2015-04-01 00:21:29.000000', 'consum', 0.0229, 'lps'),
	(462619, 102, '2015-04-01 00:21:30.000000', 'consum', 0.0210, 'lps'),
	(462620, 102, '2015-04-01 00:21:31.000000', 'consum', 0.0214, 'lps'),
	(462621, 102, '2015-04-01 00:21:32.000000', 'consum', 0.0210, 'lps'),
	(462622, 102, '2015-04-01 00:21:33.000000', 'consum', 0.0222, 'lps'),
	(462623, 102, '2015-04-01 00:21:34.000000', 'consum', 0.0227, 'lps'),
	(462624, 102, '2015-04-01 00:21:35.000000', 'consum', 0.0217, 'lps'),
	(462625, 102, '2015-04-01 00:21:36.000000', 'consum', 0.0216, 'lps'),
	(462626, 102, '2015-04-01 00:21:37.000000', 'consum', 0.0220, 'lps'),
	(462627, 102, '2015-04-01 00:21:38.000000', 'consum', 0.0220, 'lps'),
	(462628, 102, '2015-04-01 00:21:39.000000', 'consum', 0.0210, 'lps'),
	(462629, 102, '2015-04-01 00:21:40.000000', 'consum', 0.0222, 'lps'),
	(462630, 102, '2015-04-01 00:21:41.000000', 'consum', 0.0230, 'lps'),
	(462631, 102, '2015-04-01 00:21:42.000000', 'consum', 0.0212, 'lps'),
	(462632, 102, '2015-04-01 00:21:43.000000', 'consum', 0.0221, 'lps'),
	(462633, 102, '2015-04-01 00:21:44.000000', 'consum', 0.0217, 'lps'),
	(462634, 102, '2015-04-01 00:21:45.000000', 'consum', 0.0213, 'lps'),
	(462635, 102, '2015-04-01 00:21:46.000000', 'consum', 0.0225, 'lps'),
	(462636, 102, '2015-04-01 00:21:47.000000', 'consum', 0.0215, 'lps'),
	(462637, 102, '2015-04-01 00:21:48.000000', 'consum', 0.0230, 'lps'),
	(462638, 102, '2015-04-01 00:21:49.000000', 'consum', 0.0213, 'lps'),
	(462639, 102, '2015-04-01 00:21:50.000000', 'consum', 0.0227, 'lps'),
	(462640, 102, '2015-04-01 00:21:51.000000', 'consum', 0.0226, 'lps'),
	(462641, 102, '2015-04-01 00:21:52.000000', 'consum', 0.0216, 'lps'),
	(462642, 102, '2015-04-01 00:21:53.000000', 'consum', 0.0213, 'lps'),
	(462643, 102, '2015-04-01 00:21:54.000000', 'consum', 0.0229, 'lps'),
	(462644, 102, '2015-04-01 00:21:55.000000', 'consum', 0.0211, 'lps'),
	(462645, 102, '2015-04-01 00:21:56.000000', 'consum', 0.0224, 'lps'),
	(462646, 102, '2015-04-01 00:21:57.000000', 'consum', 0.0212, 'lps'),
	(462647, 102, '2015-04-01 00:21:58.000000', 'consum', 0.0221, 'lps'),
	(462648, 102, '2015-04-01 00:21:59.000000', 'consum', 0.0219, 'lps'),
	(462649, 102, '2015-04-01 00:22:00.000000', 'consum', 0.0220, 'lps'),
	(462650, 102, '2015-04-01 00:22:01.000000', 'consum', 0.0216, 'lps'),
	(462651, 102, '2015-04-01 00:22:02.000000', 'consum', 0.0229, 'lps'),
	(462652, 102, '2015-04-01 00:22:03.000000', 'consum', 0.0225, 'lps'),
	(462653, 102, '2015-04-01 00:22:04.000000', 'consum', 0.0228, 'lps'),
	(462654, 102, '2015-04-01 00:22:05.000000', 'consum', 0.0212, 'lps'),
	(462655, 102, '2015-04-01 00:22:06.000000', 'consum', 0.0211, 'lps'),
	(462656, 102, '2015-04-01 00:22:07.000000', 'consum', 0.0210, 'lps'),
	(462657, 102, '2015-04-01 00:22:08.000000', 'consum', 0.0226, 'lps'),
	(462658, 102, '2015-04-01 00:22:09.000000', 'consum', 0.0229, 'lps'),
	(462659, 102, '2015-04-01 00:22:10.000000', 'consum', 0.0214, 'lps'),
	(462660, 102, '2015-04-01 00:22:11.000000', 'consum', 0.0216, 'lps'),
	(462661, 102, '2015-04-01 00:22:12.000000', 'consum', 0.0229, 'lps'),
	(462662, 102, '2015-04-01 00:22:13.000000', 'consum', 0.0225, 'lps'),
	(462663, 102, '2015-04-01 00:22:14.000000', 'consum', 0.0228, 'lps'),
	(462664, 102, '2015-04-01 00:22:15.000000', 'consum', 0.0215, 'lps'),
	(462665, 102, '2015-04-01 00:22:16.000000', 'consum', 0.0222, 'lps'),
	(462666, 102, '2015-04-01 00:22:17.000000', 'consum', 0.0215, 'lps'),
	(462667, 102, '2015-04-01 00:22:18.000000', 'consum', 0.0222, 'lps'),
	(462668, 102, '2015-04-01 00:22:19.000000', 'consum', 0.0211, 'lps'),
	(462669, 102, '2015-04-01 00:22:20.000000', 'consum', 0.0222, 'lps'),
	(462670, 102, '2015-04-01 00:22:21.000000', 'consum', 0.0224, 'lps'),
	(462671, 102, '2015-04-01 00:22:22.000000', 'consum', 0.0225, 'lps'),
	(462672, 102, '2015-04-01 00:22:23.000000', 'consum', 0.0220, 'lps'),
	(462673, 102, '2015-04-01 00:22:24.000000', 'consum', 0.0219, 'lps'),
	(462674, 102, '2015-04-01 00:22:25.000000', 'consum', 0.0224, 'lps'),
	(462675, 102, '2015-04-01 00:22:26.000000', 'consum', 0.0213, 'lps'),
	(462676, 102, '2015-04-01 00:22:27.000000', 'consum', 0.0223, 'lps'),
	(462677, 102, '2015-04-01 00:22:28.000000', 'consum', 0.0227, 'lps'),
	(462678, 102, '2015-04-01 00:22:29.000000', 'consum', 0.0215, 'lps'),
	(462679, 102, '2015-04-01 00:22:30.000000', 'consum', 0.0226, 'lps'),
	(462680, 102, '2015-04-01 00:22:31.000000', 'consum', 0.0210, 'lps'),
	(462681, 102, '2015-04-01 00:22:32.000000', 'consum', 0.0228, 'lps'),
	(462682, 102, '2015-04-01 00:22:33.000000', 'consum', 0.0215, 'lps'),
	(462683, 102, '2015-04-01 00:22:34.000000', 'consum', 0.0224, 'lps'),
	(462684, 102, '2015-04-01 00:22:35.000000', 'consum', 0.0225, 'lps'),
	(462685, 102, '2015-04-01 00:22:36.000000', 'consum', 0.0220, 'lps'),
	(462686, 102, '2015-04-01 00:22:37.000000', 'consum', 0.0217, 'lps'),
	(462687, 102, '2015-04-01 00:22:38.000000', 'consum', 0.0215, 'lps'),
	(462688, 102, '2015-04-01 00:22:39.000000', 'consum', 0.0217, 'lps'),
	(462689, 102, '2015-04-01 00:22:40.000000', 'consum', 0.0227, 'lps'),
	(462690, 102, '2015-04-01 00:22:41.000000', 'consum', 0.0214, 'lps'),
	(462691, 102, '2015-04-01 00:22:42.000000', 'consum', 0.0223, 'lps'),
	(462692, 102, '2015-04-01 00:22:43.000000', 'consum', 0.0218, 'lps'),
	(462693, 102, '2015-04-01 00:22:44.000000', 'consum', 0.0214, 'lps'),
	(462694, 102, '2015-04-01 00:22:45.000000', 'consum', 0.0228, 'lps'),
	(462695, 102, '2015-04-01 00:22:46.000000', 'consum', 0.0227, 'lps'),
	(462696, 102, '2015-04-01 00:22:47.000000', 'consum', 0.0217, 'lps'),
	(462697, 102, '2015-04-01 00:22:48.000000', 'consum', 0.0218, 'lps'),
	(462698, 102, '2015-04-01 00:22:49.000000', 'consum', 0.0230, 'lps'),
	(462699, 102, '2015-04-01 00:22:50.000000', 'consum', 0.0221, 'lps'),
	(462700, 102, '2015-04-01 00:22:51.000000', 'consum', 0.0227, 'lps'),
	(462701, 102, '2015-04-01 00:22:52.000000', 'consum', 0.0223, 'lps'),
	(462702, 102, '2015-04-01 00:22:53.000000', 'consum', 0.0223, 'lps'),
	(462703, 102, '2015-04-01 00:22:54.000000', 'consum', 0.0214, 'lps'),
	(462704, 102, '2015-04-01 00:22:55.000000', 'consum', 0.0212, 'lps'),
	(462705, 102, '2015-04-01 00:22:56.000000', 'consum', 0.0229, 'lps'),
	(462706, 102, '2015-04-01 00:22:57.000000', 'consum', 0.0216, 'lps'),
	(462707, 102, '2015-04-01 00:22:58.000000', 'consum', 0.0224, 'lps'),
	(462708, 102, '2015-04-01 00:22:59.000000', 'consum', 0.0221, 'lps'),
	(462709, 102, '2015-04-01 00:23:00.000000', 'consum', 0.0226, 'lps'),
	(462710, 102, '2015-04-01 00:23:01.000000', 'consum', 0.0213, 'lps'),
	(462711, 102, '2015-04-01 00:23:02.000000', 'consum', 0.0220, 'lps'),
	(462712, 102, '2015-04-01 00:23:03.000000', 'consum', 0.0229, 'lps'),
	(462713, 102, '2015-04-01 00:23:04.000000', 'consum', 0.0214, 'lps'),
	(462714, 102, '2015-04-01 00:23:05.000000', 'consum', 0.0213, 'lps'),
	(462715, 102, '2015-04-01 00:23:06.000000', 'consum', 0.0217, 'lps'),
	(462716, 102, '2015-04-01 00:23:07.000000', 'consum', 0.0215, 'lps'),
	(462717, 102, '2015-04-01 00:23:08.000000', 'consum', 0.0213, 'lps'),
	(462718, 102, '2015-04-01 00:23:09.000000', 'consum', 0.0230, 'lps'),
	(462719, 102, '2015-04-01 00:23:10.000000', 'consum', 0.0220, 'lps'),
	(462720, 102, '2015-04-01 00:23:11.000000', 'consum', 0.0223, 'lps'),
	(462721, 102, '2015-04-01 00:23:12.000000', 'consum', 0.0222, 'lps'),
	(462722, 102, '2015-04-01 00:23:13.000000', 'consum', 0.0213, 'lps'),
	(462723, 102, '2015-04-01 00:23:14.000000', 'consum', 0.0229, 'lps'),
	(462724, 102, '2015-04-01 00:23:15.000000', 'consum', 0.0213, 'lps'),
	(462725, 102, '2015-04-01 00:23:16.000000', 'consum', 0.0211, 'lps'),
	(462726, 102, '2015-04-01 00:23:17.000000', 'consum', 0.0227, 'lps'),
	(462727, 102, '2015-04-01 00:23:18.000000', 'consum', 0.0229, 'lps'),
	(462728, 102, '2015-04-01 00:23:19.000000', 'consum', 0.0211, 'lps'),
	(462729, 102, '2015-04-01 00:23:20.000000', 'consum', 0.0223, 'lps'),
	(462730, 102, '2015-04-01 00:23:21.000000', 'consum', 0.0211, 'lps'),
	(462731, 102, '2015-04-01 00:23:22.000000', 'consum', 0.0216, 'lps'),
	(462732, 102, '2015-04-01 00:23:23.000000', 'consum', 0.0218, 'lps'),
	(462733, 102, '2015-04-01 00:23:24.000000', 'consum', 0.0211, 'lps'),
	(462734, 102, '2015-04-01 00:23:25.000000', 'consum', 0.0214, 'lps'),
	(462735, 102, '2015-04-01 00:23:26.000000', 'consum', 0.0227, 'lps'),
	(462736, 102, '2015-04-01 00:23:27.000000', 'consum', 0.0219, 'lps'),
	(462737, 102, '2015-04-01 00:23:28.000000', 'consum', 0.0225, 'lps'),
	(462738, 102, '2015-04-01 00:23:29.000000', 'consum', 0.0217, 'lps'),
	(462739, 102, '2015-04-01 00:23:30.000000', 'consum', 0.0223, 'lps'),
	(462740, 102, '2015-04-01 00:23:31.000000', 'consum', 0.0211, 'lps'),
	(462741, 102, '2015-04-01 00:23:32.000000', 'consum', 0.0217, 'lps'),
	(462742, 102, '2015-04-01 00:23:33.000000', 'consum', 0.0224, 'lps'),
	(462743, 102, '2015-04-01 00:23:34.000000', 'consum', 0.0215, 'lps'),
	(462744, 102, '2015-04-01 00:23:35.000000', 'consum', 0.0217, 'lps'),
	(462745, 102, '2015-04-01 00:23:36.000000', 'consum', 0.0229, 'lps'),
	(462746, 102, '2015-04-01 00:23:37.000000', 'consum', 0.0221, 'lps'),
	(462747, 102, '2015-04-01 00:23:38.000000', 'consum', 0.0229, 'lps'),
	(462748, 102, '2015-04-01 00:23:39.000000', 'consum', 0.0212, 'lps'),
	(462749, 102, '2015-04-01 00:23:40.000000', 'consum', 0.0225, 'lps'),
	(462750, 102, '2015-04-01 00:23:41.000000', 'consum', 0.0216, 'lps'),
	(462751, 102, '2015-04-01 00:23:42.000000', 'consum', 0.0217, 'lps'),
	(462752, 102, '2015-04-01 00:23:43.000000', 'consum', 0.0226, 'lps'),
	(462753, 102, '2015-04-01 00:23:44.000000', 'consum', 0.0230, 'lps'),
	(462754, 102, '2015-04-01 00:23:45.000000', 'consum', 0.0221, 'lps'),
	(462755, 102, '2015-04-01 00:23:46.000000', 'consum', 0.0224, 'lps'),
	(462756, 102, '2015-04-01 00:23:47.000000', 'consum', 0.0228, 'lps'),
	(462757, 102, '2015-04-01 00:23:48.000000', 'consum', 0.0217, 'lps'),
	(462758, 102, '2015-04-01 00:23:49.000000', 'consum', 0.0212, 'lps'),
	(462759, 102, '2015-04-01 00:23:50.000000', 'consum', 0.0220, 'lps'),
	(462760, 102, '2015-04-01 00:23:51.000000', 'consum', 0.0214, 'lps'),
	(462761, 102, '2015-04-01 00:23:52.000000', 'consum', 0.0221, 'lps'),
	(462762, 102, '2015-04-01 00:23:53.000000', 'consum', 0.0211, 'lps'),
	(462763, 102, '2015-04-01 00:23:54.000000', 'consum', 0.0227, 'lps'),
	(462764, 102, '2015-04-01 00:23:55.000000', 'consum', 0.0227, 'lps'),
	(462765, 102, '2015-04-01 00:23:56.000000', 'consum', 0.0222, 'lps'),
	(462766, 102, '2015-04-01 00:23:57.000000', 'consum', 0.0223, 'lps'),
	(462767, 102, '2015-04-01 00:23:58.000000', 'consum', 0.0216, 'lps'),
	(462768, 102, '2015-04-01 00:23:59.000000', 'consum', 0.0222, 'lps'),
	(462769, 102, '2015-04-01 00:24:00.000000', 'consum', 0.0211, 'lps'),
	(462770, 102, '2015-04-01 00:24:01.000000', 'consum', 0.0222, 'lps'),
	(462771, 102, '2015-04-01 00:24:02.000000', 'consum', 0.0224, 'lps'),
	(462772, 102, '2015-04-01 00:24:03.000000', 'consum', 0.0224, 'lps'),
	(462773, 102, '2015-04-01 00:24:04.000000', 'consum', 0.0216, 'lps'),
	(462774, 102, '2015-04-01 00:24:05.000000', 'consum', 0.0223, 'lps'),
	(462775, 102, '2015-04-01 00:24:06.000000', 'consum', 0.0212, 'lps'),
	(462776, 102, '2015-04-01 00:24:07.000000', 'consum', 0.0227, 'lps'),
	(462777, 102, '2015-04-01 00:24:08.000000', 'consum', 0.0224, 'lps'),
	(462778, 102, '2015-04-01 00:24:09.000000', 'consum', 0.0211, 'lps'),
	(462779, 102, '2015-04-01 00:24:10.000000', 'consum', 0.0213, 'lps'),
	(462780, 102, '2015-04-01 00:24:11.000000', 'consum', 0.0225, 'lps'),
	(462781, 102, '2015-04-01 00:24:12.000000', 'consum', 0.0214, 'lps'),
	(462782, 102, '2015-04-01 00:24:13.000000', 'consum', 0.0228, 'lps'),
	(462783, 102, '2015-04-01 00:24:14.000000', 'consum', 0.0225, 'lps'),
	(462784, 102, '2015-04-01 00:24:15.000000', 'consum', 0.0230, 'lps'),
	(462785, 102, '2015-04-01 00:24:16.000000', 'consum', 0.0225, 'lps'),
	(462786, 102, '2015-04-01 00:24:17.000000', 'consum', 0.0223, 'lps'),
	(462787, 102, '2015-04-01 00:24:18.000000', 'consum', 0.0211, 'lps'),
	(462788, 102, '2015-04-01 00:24:19.000000', 'consum', 0.0217, 'lps'),
	(462789, 102, '2015-04-01 00:24:20.000000', 'consum', 0.0221, 'lps'),
	(462790, 102, '2015-04-01 00:24:21.000000', 'consum', 0.0222, 'lps'),
	(462791, 102, '2015-04-01 00:24:22.000000', 'consum', 0.0220, 'lps'),
	(462792, 102, '2015-04-01 00:24:23.000000', 'consum', 0.0224, 'lps'),
	(462793, 102, '2015-04-01 00:24:24.000000', 'consum', 0.0228, 'lps'),
	(462794, 102, '2015-04-01 00:24:25.000000', 'consum', 0.0219, 'lps'),
	(462795, 102, '2015-04-01 00:24:26.000000', 'consum', 0.0220, 'lps'),
	(462796, 102, '2015-04-01 00:24:27.000000', 'consum', 0.0212, 'lps'),
	(462797, 102, '2015-04-01 00:24:28.000000', 'consum', 0.0211, 'lps'),
	(462798, 102, '2015-04-01 00:24:29.000000', 'consum', 0.0210, 'lps'),
	(462799, 102, '2015-04-01 00:24:30.000000', 'consum', 0.0210, 'lps'),
	(462800, 102, '2015-04-01 00:24:31.000000', 'consum', 0.0229, 'lps'),
	(462801, 102, '2015-04-01 00:24:32.000000', 'consum', 0.0223, 'lps'),
	(462802, 102, '2015-04-01 00:24:33.000000', 'consum', 0.0219, 'lps'),
	(462803, 102, '2015-04-01 00:24:34.000000', 'consum', 0.0217, 'lps'),
	(462804, 102, '2015-04-01 00:24:35.000000', 'consum', 0.0217, 'lps'),
	(462805, 102, '2015-04-01 00:24:36.000000', 'consum', 0.0225, 'lps'),
	(462806, 102, '2015-04-01 00:24:37.000000', 'consum', 0.0221, 'lps'),
	(462807, 102, '2015-04-01 00:24:38.000000', 'consum', 0.0222, 'lps'),
	(462808, 102, '2015-04-01 00:24:39.000000', 'consum', 0.0217, 'lps'),
	(462809, 102, '2015-04-01 00:24:40.000000', 'consum', 0.0210, 'lps'),
	(462810, 102, '2015-04-01 00:24:41.000000', 'consum', 0.0212, 'lps'),
	(462811, 102, '2015-04-01 00:24:42.000000', 'consum', 0.0218, 'lps'),
	(462812, 102, '2015-04-01 00:24:43.000000', 'consum', 0.0223, 'lps'),
	(462813, 102, '2015-04-01 00:24:44.000000', 'consum', 0.0211, 'lps'),
	(462814, 102, '2015-04-01 00:24:45.000000', 'consum', 0.0220, 'lps'),
	(462815, 102, '2015-04-01 00:24:46.000000', 'consum', 0.0212, 'lps'),
	(462816, 102, '2015-04-01 00:24:47.000000', 'consum', 0.0215, 'lps'),
	(462817, 102, '2015-04-01 00:24:48.000000', 'consum', 0.0226, 'lps'),
	(462818, 102, '2015-04-01 00:24:49.000000', 'consum', 0.0215, 'lps'),
	(462819, 102, '2015-04-01 00:24:50.000000', 'consum', 0.0229, 'lps'),
	(462820, 102, '2015-04-01 00:24:51.000000', 'consum', 0.0228, 'lps'),
	(462821, 102, '2015-04-01 00:24:52.000000', 'consum', 0.0222, 'lps'),
	(462822, 102, '2015-04-01 00:24:53.000000', 'consum', 0.0215, 'lps'),
	(462823, 102, '2015-04-01 00:24:54.000000', 'consum', 0.0222, 'lps'),
	(462824, 102, '2015-04-01 00:24:55.000000', 'consum', 0.0215, 'lps'),
	(462825, 102, '2015-04-01 00:24:56.000000', 'consum', 0.0218, 'lps'),
	(462826, 102, '2015-04-01 00:24:57.000000', 'consum', 0.0215, 'lps'),
	(462827, 102, '2015-04-01 00:24:58.000000', 'consum', 0.0214, 'lps'),
	(462828, 102, '2015-04-01 00:24:59.000000', 'consum', 0.0213, 'lps'),
	(462829, 102, '2015-04-01 00:25:00.000000', 'consum', 0.0213, 'lps'),
	(462830, 102, '2015-04-01 00:25:01.000000', 'consum', 0.0218, 'lps'),
	(462831, 102, '2015-04-01 00:25:02.000000', 'consum', 0.0219, 'lps'),
	(462832, 102, '2015-04-01 00:25:03.000000', 'consum', 0.0213, 'lps'),
	(462833, 102, '2015-04-01 00:25:04.000000', 'consum', 0.0220, 'lps'),
	(462834, 102, '2015-04-01 00:25:05.000000', 'consum', 0.0228, 'lps'),
	(462835, 102, '2015-04-01 00:25:06.000000', 'consum', 0.0230, 'lps'),
	(462836, 102, '2015-04-01 00:25:07.000000', 'consum', 0.0214, 'lps'),
	(462837, 102, '2015-04-01 00:25:08.000000', 'consum', 0.0211, 'lps'),
	(462838, 102, '2015-04-01 00:25:09.000000', 'consum', 0.0225, 'lps'),
	(462839, 102, '2015-04-01 00:25:10.000000', 'consum', 0.0220, 'lps'),
	(462840, 102, '2015-04-01 00:25:11.000000', 'consum', 0.0216, 'lps'),
	(462841, 102, '2015-04-01 00:25:12.000000', 'consum', 0.0211, 'lps'),
	(462842, 102, '2015-04-01 00:25:13.000000', 'consum', 0.0220, 'lps'),
	(462843, 102, '2015-04-01 00:25:14.000000', 'consum', 0.0212, 'lps'),
	(462844, 102, '2015-04-01 00:25:15.000000', 'consum', 0.0213, 'lps'),
	(462845, 102, '2015-04-01 00:25:16.000000', 'consum', 0.0218, 'lps'),
	(462846, 102, '2015-04-01 00:25:17.000000', 'consum', 0.0222, 'lps'),
	(462847, 102, '2015-04-01 00:25:18.000000', 'consum', 0.0223, 'lps'),
	(462848, 102, '2015-04-01 00:25:19.000000', 'consum', 0.0222, 'lps'),
	(462849, 102, '2015-04-01 00:25:20.000000', 'consum', 0.0229, 'lps'),
	(462850, 102, '2015-04-01 00:25:21.000000', 'consum', 0.0226, 'lps'),
	(462851, 102, '2015-04-01 00:25:22.000000', 'consum', 0.0215, 'lps'),
	(462852, 102, '2015-04-01 00:25:23.000000', 'consum', 0.0229, 'lps'),
	(462853, 102, '2015-04-01 00:25:24.000000', 'consum', 0.0230, 'lps'),
	(462854, 102, '2015-04-01 00:25:25.000000', 'consum', 0.0229, 'lps'),
	(462855, 102, '2015-04-01 00:25:26.000000', 'consum', 0.0224, 'lps'),
	(462856, 102, '2015-04-01 00:25:27.000000', 'consum', 0.0225, 'lps'),
	(462857, 102, '2015-04-01 00:25:28.000000', 'consum', 0.0224, 'lps'),
	(462858, 102, '2015-04-01 00:25:29.000000', 'consum', 0.0211, 'lps'),
	(462859, 102, '2015-04-01 00:25:30.000000', 'consum', 0.0218, 'lps'),
	(462860, 102, '2015-04-01 00:25:31.000000', 'consum', 0.0227, 'lps'),
	(462861, 102, '2015-04-01 00:25:32.000000', 'consum', 0.0228, 'lps'),
	(462862, 102, '2015-04-01 00:25:33.000000', 'consum', 0.0227, 'lps'),
	(462863, 102, '2015-04-01 00:25:34.000000', 'consum', 0.0222, 'lps'),
	(462864, 102, '2015-04-01 00:25:35.000000', 'consum', 0.0218, 'lps'),
	(462865, 102, '2015-04-01 00:25:36.000000', 'consum', 0.0217, 'lps'),
	(462866, 102, '2015-04-01 00:25:37.000000', 'consum', 0.0219, 'lps'),
	(462867, 102, '2015-04-01 00:25:38.000000', 'consum', 0.0214, 'lps'),
	(462868, 102, '2015-04-01 00:25:39.000000', 'consum', 0.0225, 'lps'),
	(462869, 102, '2015-04-01 00:25:40.000000', 'consum', 0.0211, 'lps'),
	(462870, 102, '2015-04-01 00:25:41.000000', 'consum', 0.0212, 'lps'),
	(462871, 102, '2015-04-01 00:25:42.000000', 'consum', 0.0216, 'lps'),
	(462872, 102, '2015-04-01 00:25:43.000000', 'consum', 0.0213, 'lps'),
	(462873, 102, '2015-04-01 00:25:44.000000', 'consum', 0.0228, 'lps'),
	(462874, 102, '2015-04-01 00:25:45.000000', 'consum', 0.0210, 'lps'),
	(462875, 102, '2015-04-01 00:25:46.000000', 'consum', 0.0217, 'lps'),
	(462876, 102, '2015-04-01 00:25:47.000000', 'consum', 0.0225, 'lps'),
	(462877, 102, '2015-04-01 00:25:48.000000', 'consum', 0.0223, 'lps'),
	(462878, 102, '2015-04-01 00:25:49.000000', 'consum', 0.0229, 'lps'),
	(462879, 102, '2015-04-01 00:25:50.000000', 'consum', 0.0227, 'lps'),
	(462880, 102, '2015-04-01 00:25:51.000000', 'consum', 0.0216, 'lps'),
	(462881, 102, '2015-04-01 00:25:52.000000', 'consum', 0.0212, 'lps'),
	(462882, 102, '2015-04-01 00:25:53.000000', 'consum', 0.0223, 'lps'),
	(462883, 102, '2015-04-01 00:25:54.000000', 'consum', 0.0229, 'lps'),
	(462884, 102, '2015-04-01 00:25:55.000000', 'consum', 0.0223, 'lps'),
	(462885, 102, '2015-04-01 00:25:56.000000', 'consum', 0.0217, 'lps'),
	(462886, 102, '2015-04-01 00:25:57.000000', 'consum', 0.0228, 'lps'),
	(462887, 102, '2015-04-01 00:25:58.000000', 'consum', 0.0216, 'lps'),
	(462888, 102, '2015-04-01 00:25:59.000000', 'consum', 0.0229, 'lps'),
	(462889, 102, '2015-04-01 00:26:00.000000', 'consum', 0.0226, 'lps'),
	(462890, 102, '2015-04-01 00:26:01.000000', 'consum', 0.0211, 'lps'),
	(462891, 102, '2015-04-01 00:26:02.000000', 'consum', 0.0230, 'lps'),
	(462892, 102, '2015-04-01 00:26:03.000000', 'consum', 0.0224, 'lps'),
	(462893, 102, '2015-04-01 00:26:04.000000', 'consum', 0.0220, 'lps'),
	(462894, 102, '2015-04-01 00:26:05.000000', 'consum', 0.0218, 'lps'),
	(462895, 102, '2015-04-01 00:26:06.000000', 'consum', 0.0221, 'lps'),
	(462896, 102, '2015-04-01 00:26:07.000000', 'consum', 0.0222, 'lps'),
	(462897, 102, '2015-04-01 00:26:08.000000', 'consum', 0.0214, 'lps'),
	(462898, 102, '2015-04-01 00:26:09.000000', 'consum', 0.0215, 'lps'),
	(462899, 102, '2015-04-01 00:26:10.000000', 'consum', 0.0225, 'lps'),
	(462900, 102, '2015-04-01 00:26:11.000000', 'consum', 0.0228, 'lps'),
	(462901, 102, '2015-04-01 00:26:12.000000', 'consum', 0.0213, 'lps'),
	(462902, 102, '2015-04-01 00:26:13.000000', 'consum', 0.0215, 'lps'),
	(462903, 102, '2015-04-01 00:26:14.000000', 'consum', 0.0226, 'lps'),
	(462904, 102, '2015-04-01 00:26:15.000000', 'consum', 0.0212, 'lps'),
	(462905, 102, '2015-04-01 00:26:16.000000', 'consum', 0.0214, 'lps'),
	(462906, 102, '2015-04-01 00:26:17.000000', 'consum', 0.0224, 'lps'),
	(462907, 102, '2015-04-01 00:26:18.000000', 'consum', 0.0228, 'lps'),
	(462908, 102, '2015-04-01 00:26:19.000000', 'consum', 0.0216, 'lps'),
	(462909, 102, '2015-04-01 00:26:20.000000', 'consum', 0.0230, 'lps'),
	(462910, 102, '2015-04-01 00:26:21.000000', 'consum', 0.0227, 'lps'),
	(462911, 102, '2015-04-01 00:26:22.000000', 'consum', 0.0217, 'lps'),
	(462912, 102, '2015-04-01 00:26:23.000000', 'consum', 0.0213, 'lps'),
	(462913, 102, '2015-04-01 00:26:24.000000', 'consum', 0.0225, 'lps'),
	(462914, 102, '2015-04-01 00:26:25.000000', 'consum', 0.0216, 'lps'),
	(462915, 102, '2015-04-01 00:26:26.000000', 'consum', 0.0216, 'lps'),
	(462916, 102, '2015-04-01 00:26:27.000000', 'consum', 0.0223, 'lps'),
	(462917, 102, '2015-04-01 00:26:28.000000', 'consum', 0.0213, 'lps'),
	(462918, 102, '2015-04-01 00:26:29.000000', 'consum', 0.0211, 'lps'),
	(462919, 102, '2015-04-01 00:26:30.000000', 'consum', 0.0226, 'lps'),
	(462920, 102, '2015-04-01 00:26:31.000000', 'consum', 0.0224, 'lps'),
	(462921, 102, '2015-04-01 00:26:32.000000', 'consum', 0.0210, 'lps'),
	(462922, 102, '2015-04-01 00:26:33.000000', 'consum', 0.0213, 'lps'),
	(462923, 102, '2015-04-01 00:26:34.000000', 'consum', 0.0225, 'lps'),
	(462924, 102, '2015-04-01 00:26:35.000000', 'consum', 0.0213, 'lps'),
	(462925, 102, '2015-04-01 00:26:36.000000', 'consum', 0.0223, 'lps'),
	(462926, 102, '2015-04-01 00:26:37.000000', 'consum', 0.0225, 'lps'),
	(462927, 102, '2015-04-01 00:26:38.000000', 'consum', 0.0226, 'lps'),
	(462928, 102, '2015-04-01 00:26:39.000000', 'consum', 0.0222, 'lps'),
	(462929, 102, '2015-04-01 00:26:40.000000', 'consum', 0.0224, 'lps'),
	(462930, 102, '2015-04-01 00:26:41.000000', 'consum', 0.0225, 'lps'),
	(462931, 102, '2015-04-01 00:26:42.000000', 'consum', 0.0222, 'lps'),
	(462932, 102, '2015-04-01 00:26:43.000000', 'consum', 0.0227, 'lps'),
	(462933, 102, '2015-04-01 00:26:44.000000', 'consum', 0.0216, 'lps'),
	(462934, 102, '2015-04-01 00:26:45.000000', 'consum', 0.0212, 'lps'),
	(462935, 102, '2015-04-01 00:26:46.000000', 'consum', 0.0222, 'lps'),
	(462936, 102, '2015-04-01 00:26:47.000000', 'consum', 0.0224, 'lps'),
	(462937, 102, '2015-04-01 00:26:48.000000', 'consum', 0.0221, 'lps'),
	(462938, 102, '2015-04-01 00:26:49.000000', 'consum', 0.0223, 'lps'),
	(462939, 102, '2015-04-01 00:26:50.000000', 'consum', 0.0224, 'lps'),
	(462940, 102, '2015-04-01 00:26:51.000000', 'consum', 0.0220, 'lps'),
	(462941, 102, '2015-04-01 00:26:52.000000', 'consum', 0.0219, 'lps'),
	(462942, 102, '2015-04-01 00:26:53.000000', 'consum', 0.0224, 'lps'),
	(462943, 102, '2015-04-01 00:26:54.000000', 'consum', 0.0212, 'lps'),
	(462944, 102, '2015-04-01 00:26:55.000000', 'consum', 0.0219, 'lps'),
	(462945, 102, '2015-04-01 00:26:56.000000', 'consum', 0.0210, 'lps'),
	(462946, 102, '2015-04-01 00:26:57.000000', 'consum', 0.0226, 'lps'),
	(462947, 102, '2015-04-01 00:26:58.000000', 'consum', 0.0228, 'lps'),
	(462948, 102, '2015-04-01 00:26:59.000000', 'consum', 0.0210, 'lps'),
	(462949, 102, '2015-04-01 00:27:00.000000', 'consum', 0.0220, 'lps'),
	(462950, 102, '2015-04-01 00:27:01.000000', 'consum', 0.0219, 'lps'),
	(462951, 102, '2015-04-01 00:27:02.000000', 'consum', 0.0224, 'lps'),
	(462952, 102, '2015-04-01 00:27:03.000000', 'consum', 0.0211, 'lps'),
	(462953, 102, '2015-04-01 00:27:04.000000', 'consum', 0.0217, 'lps'),
	(462954, 102, '2015-04-01 00:27:05.000000', 'consum', 0.0220, 'lps'),
	(462955, 102, '2015-04-01 00:27:06.000000', 'consum', 0.0220, 'lps'),
	(462956, 102, '2015-04-01 00:27:07.000000', 'consum', 0.0210, 'lps'),
	(462957, 102, '2015-04-01 00:27:08.000000', 'consum', 0.0220, 'lps'),
	(462958, 102, '2015-04-01 00:27:09.000000', 'consum', 0.0221, 'lps'),
	(462959, 102, '2015-04-01 00:27:10.000000', 'consum', 0.0213, 'lps'),
	(462960, 102, '2015-04-01 00:27:11.000000', 'consum', 0.0216, 'lps'),
	(462961, 102, '2015-04-01 00:27:12.000000', 'consum', 0.0230, 'lps'),
	(462962, 102, '2015-04-01 00:27:13.000000', 'consum', 0.0229, 'lps'),
	(462963, 102, '2015-04-01 00:27:14.000000', 'consum', 0.0223, 'lps'),
	(462964, 102, '2015-04-01 00:27:15.000000', 'consum', 0.0221, 'lps'),
	(462965, 102, '2015-04-01 00:27:16.000000', 'consum', 0.0225, 'lps'),
	(462966, 102, '2015-04-01 00:27:17.000000', 'consum', 0.0211, 'lps'),
	(462967, 102, '2015-04-01 00:27:18.000000', 'consum', 0.0211, 'lps'),
	(462968, 102, '2015-04-01 00:27:19.000000', 'consum', 0.0215, 'lps'),
	(462969, 102, '2015-04-01 00:27:20.000000', 'consum', 0.0213, 'lps'),
	(462970, 102, '2015-04-01 00:27:21.000000', 'consum', 0.0228, 'lps'),
	(462971, 102, '2015-04-01 00:27:22.000000', 'consum', 0.0230, 'lps'),
	(462972, 102, '2015-04-01 00:27:23.000000', 'consum', 0.0215, 'lps'),
	(462973, 102, '2015-04-01 00:27:24.000000', 'consum', 0.0217, 'lps'),
	(462974, 102, '2015-04-01 00:27:25.000000', 'consum', 0.0229, 'lps'),
	(462975, 102, '2015-04-01 00:27:26.000000', 'consum', 0.0222, 'lps'),
	(462976, 102, '2015-04-01 00:27:27.000000', 'consum', 0.0215, 'lps'),
	(462977, 102, '2015-04-01 00:27:28.000000', 'consum', 0.0218, 'lps'),
	(462978, 102, '2015-04-01 00:27:29.000000', 'consum', 0.0218, 'lps'),
	(462979, 102, '2015-04-01 00:27:30.000000', 'consum', 0.0224, 'lps'),
	(462980, 102, '2015-04-01 00:27:31.000000', 'consum', 0.0215, 'lps'),
	(462981, 102, '2015-04-01 00:27:32.000000', 'consum', 0.0216, 'lps'),
	(462982, 102, '2015-04-01 00:27:33.000000', 'consum', 0.0224, 'lps'),
	(462983, 102, '2015-04-01 00:27:34.000000', 'consum', 0.0223, 'lps'),
	(462984, 102, '2015-04-01 00:27:35.000000', 'consum', 0.0230, 'lps'),
	(462985, 102, '2015-04-01 00:27:36.000000', 'consum', 0.0230, 'lps'),
	(462986, 102, '2015-04-01 00:27:37.000000', 'consum', 0.0210, 'lps'),
	(462987, 102, '2015-04-01 00:27:38.000000', 'consum', 0.0214, 'lps'),
	(462988, 102, '2015-04-01 00:27:39.000000', 'consum', 0.0210, 'lps'),
	(462989, 102, '2015-04-01 00:27:40.000000', 'consum', 0.0220, 'lps'),
	(462990, 102, '2015-04-01 00:27:41.000000', 'consum', 0.0220, 'lps'),
	(462991, 102, '2015-04-01 00:27:42.000000', 'consum', 0.0227, 'lps'),
	(462992, 102, '2015-04-01 00:27:43.000000', 'consum', 0.0225, 'lps'),
	(462993, 102, '2015-04-01 00:27:44.000000', 'consum', 0.0214, 'lps'),
	(462994, 102, '2015-04-01 00:27:45.000000', 'consum', 0.0225, 'lps'),
	(462995, 102, '2015-04-01 00:27:46.000000', 'consum', 0.0213, 'lps'),
	(462996, 102, '2015-04-01 00:27:47.000000', 'consum', 0.0220, 'lps'),
	(462997, 102, '2015-04-01 00:27:48.000000', 'consum', 0.0211, 'lps'),
	(462998, 102, '2015-04-01 00:27:49.000000', 'consum', 0.0228, 'lps'),
	(462999, 102, '2015-04-01 00:27:50.000000', 'consum', 0.0212, 'lps'),
	(463000, 102, '2015-04-01 00:27:51.000000', 'consum', 0.0211, 'lps'),
	(463001, 102, '2015-04-01 00:27:52.000000', 'consum', 0.0228, 'lps'),
	(463002, 102, '2015-04-01 00:27:53.000000', 'consum', 0.0213, 'lps'),
	(463003, 102, '2015-04-01 00:27:54.000000', 'consum', 0.0216, 'lps'),
	(463004, 102, '2015-04-01 00:27:55.000000', 'consum', 0.0210, 'lps'),
	(463005, 102, '2015-04-01 00:27:56.000000', 'consum', 0.0212, 'lps'),
	(463006, 102, '2015-04-01 00:27:57.000000', 'consum', 0.0220, 'lps'),
	(463007, 102, '2015-04-01 00:27:58.000000', 'consum', 0.0212, 'lps'),
	(463008, 102, '2015-04-01 00:27:59.000000', 'consum', 0.0215, 'lps'),
	(463009, 102, '2015-04-01 00:28:00.000000', 'consum', 0.0226, 'lps'),
	(463010, 102, '2015-04-01 00:28:01.000000', 'consum', 0.0213, 'lps'),
	(463011, 102, '2015-04-01 00:28:02.000000', 'consum', 0.0221, 'lps'),
	(463012, 102, '2015-04-01 00:28:03.000000', 'consum', 0.0213, 'lps'),
	(463013, 102, '2015-04-01 00:28:04.000000', 'consum', 0.0215, 'lps'),
	(463014, 102, '2015-04-01 00:28:05.000000', 'consum', 0.0225, 'lps'),
	(463015, 102, '2015-04-01 00:28:06.000000', 'consum', 0.0228, 'lps'),
	(463016, 102, '2015-04-01 00:28:07.000000', 'consum', 0.0215, 'lps'),
	(463017, 102, '2015-04-01 00:28:08.000000', 'consum', 0.0225, 'lps'),
	(463018, 102, '2015-04-01 00:28:09.000000', 'consum', 0.0227, 'lps'),
	(463019, 102, '2015-04-01 00:28:10.000000', 'consum', 0.0210, 'lps'),
	(463020, 102, '2015-04-01 00:28:11.000000', 'consum', 0.0223, 'lps'),
	(463021, 102, '2015-04-01 00:28:12.000000', 'consum', 0.0210, 'lps'),
	(463022, 102, '2015-04-01 00:28:13.000000', 'consum', 0.0215, 'lps'),
	(463023, 102, '2015-04-01 00:28:14.000000', 'consum', 0.0216, 'lps'),
	(463024, 102, '2015-04-01 00:28:15.000000', 'consum', 0.0225, 'lps'),
	(463025, 102, '2015-04-01 00:28:16.000000', 'consum', 0.0223, 'lps'),
	(463026, 102, '2015-04-01 00:28:17.000000', 'consum', 0.0212, 'lps'),
	(463027, 102, '2015-04-01 00:28:18.000000', 'consum', 0.0223, 'lps'),
	(463028, 102, '2015-04-01 00:28:19.000000', 'consum', 0.0227, 'lps'),
	(463029, 102, '2015-04-01 00:28:20.000000', 'consum', 0.0215, 'lps'),
	(463030, 102, '2015-04-01 00:28:21.000000', 'consum', 0.0224, 'lps'),
	(463031, 102, '2015-04-01 00:28:22.000000', 'consum', 0.0227, 'lps'),
	(463032, 102, '2015-04-01 00:28:23.000000', 'consum', 0.0210, 'lps'),
	(463033, 102, '2015-04-01 00:28:24.000000', 'consum', 0.0224, 'lps'),
	(463034, 102, '2015-04-01 00:28:25.000000', 'consum', 0.0218, 'lps'),
	(463035, 102, '2015-04-01 00:28:26.000000', 'consum', 0.0229, 'lps'),
	(463036, 102, '2015-04-01 00:28:27.000000', 'consum', 0.0219, 'lps'),
	(463037, 102, '2015-04-01 00:28:28.000000', 'consum', 0.0220, 'lps'),
	(463038, 102, '2015-04-01 00:28:29.000000', 'consum', 0.0213, 'lps'),
	(463039, 102, '2015-04-01 00:28:30.000000', 'consum', 0.0216, 'lps'),
	(463040, 102, '2015-04-01 00:28:31.000000', 'consum', 0.0212, 'lps'),
	(463041, 102, '2015-04-01 00:28:32.000000', 'consum', 0.0221, 'lps'),
	(463042, 102, '2015-04-01 00:28:33.000000', 'consum', 0.0219, 'lps'),
	(463043, 102, '2015-04-01 00:28:34.000000', 'consum', 0.0224, 'lps'),
	(463044, 102, '2015-04-01 00:28:35.000000', 'consum', 0.0211, 'lps'),
	(463045, 102, '2015-04-01 00:28:36.000000', 'consum', 0.0214, 'lps'),
	(463046, 102, '2015-04-01 00:28:37.000000', 'consum', 0.0230, 'lps'),
	(463047, 102, '2015-04-01 00:28:38.000000', 'consum', 0.0212, 'lps'),
	(463048, 102, '2015-04-01 00:28:39.000000', 'consum', 0.0223, 'lps'),
	(463049, 102, '2015-04-01 00:28:40.000000', 'consum', 0.0228, 'lps'),
	(463050, 102, '2015-04-01 00:28:41.000000', 'consum', 0.0219, 'lps'),
	(463051, 102, '2015-04-01 00:28:42.000000', 'consum', 0.0224, 'lps'),
	(463052, 102, '2015-04-01 00:28:43.000000', 'consum', 0.0230, 'lps'),
	(463053, 102, '2015-04-01 00:28:44.000000', 'consum', 0.0228, 'lps'),
	(463054, 102, '2015-04-01 00:28:45.000000', 'consum', 0.0218, 'lps'),
	(463055, 102, '2015-04-01 00:28:46.000000', 'consum', 0.0220, 'lps'),
	(463056, 102, '2015-04-01 00:28:47.000000', 'consum', 0.0214, 'lps'),
	(463057, 102, '2015-04-01 00:28:48.000000', 'consum', 0.0220, 'lps'),
	(463058, 102, '2015-04-01 00:28:49.000000', 'consum', 0.0229, 'lps'),
	(463059, 102, '2015-04-01 00:28:50.000000', 'consum', 0.0213, 'lps'),
	(463060, 102, '2015-04-01 00:28:51.000000', 'consum', 0.0212, 'lps'),
	(463061, 102, '2015-04-01 00:28:52.000000', 'consum', 0.0229, 'lps'),
	(463062, 102, '2015-04-01 00:28:53.000000', 'consum', 0.0218, 'lps'),
	(463063, 102, '2015-04-01 00:28:54.000000', 'consum', 0.0213, 'lps'),
	(463064, 102, '2015-04-01 00:28:55.000000', 'consum', 0.0224, 'lps'),
	(463065, 102, '2015-04-01 00:28:56.000000', 'consum', 0.0229, 'lps'),
	(463066, 102, '2015-04-01 00:28:57.000000', 'consum', 0.0220, 'lps'),
	(463067, 102, '2015-04-01 00:28:58.000000', 'consum', 0.0224, 'lps'),
	(463068, 102, '2015-04-01 00:28:59.000000', 'consum', 0.0229, 'lps'),
	(463069, 102, '2015-04-01 00:29:00.000000', 'consum', 0.0222, 'lps'),
	(463070, 102, '2015-04-01 00:29:01.000000', 'consum', 0.0213, 'lps'),
	(463071, 102, '2015-04-01 00:29:02.000000', 'consum', 0.0212, 'lps'),
	(463072, 102, '2015-04-01 00:29:03.000000', 'consum', 0.0230, 'lps'),
	(463073, 102, '2015-04-01 00:29:04.000000', 'consum', 0.0222, 'lps'),
	(463074, 102, '2015-04-01 00:29:05.000000', 'consum', 0.0210, 'lps'),
	(463075, 102, '2015-04-01 00:29:06.000000', 'consum', 0.0215, 'lps'),
	(463076, 102, '2015-04-01 00:29:07.000000', 'consum', 0.0217, 'lps'),
	(463077, 102, '2015-04-01 00:29:08.000000', 'consum', 0.0229, 'lps'),
	(463078, 102, '2015-04-01 00:29:09.000000', 'consum', 0.0221, 'lps'),
	(463079, 102, '2015-04-01 00:29:10.000000', 'consum', 0.0210, 'lps'),
	(463080, 102, '2015-04-01 00:29:11.000000', 'consum', 0.0220, 'lps'),
	(463081, 102, '2015-04-01 00:29:12.000000', 'consum', 0.0220, 'lps'),
	(463082, 102, '2015-04-01 00:29:13.000000', 'consum', 0.0228, 'lps'),
	(463083, 102, '2015-04-01 00:29:14.000000', 'consum', 0.0228, 'lps'),
	(463084, 102, '2015-04-01 00:29:15.000000', 'consum', 0.0228, 'lps'),
	(463085, 102, '2015-04-01 00:29:16.000000', 'consum', 0.0225, 'lps'),
	(463086, 102, '2015-04-01 00:29:17.000000', 'consum', 0.0229, 'lps'),
	(463087, 102, '2015-04-01 00:29:18.000000', 'consum', 0.0221, 'lps'),
	(463088, 102, '2015-04-01 00:29:19.000000', 'consum', 0.0227, 'lps'),
	(463089, 102, '2015-04-01 00:29:20.000000', 'consum', 0.0223, 'lps'),
	(463090, 102, '2015-04-01 00:29:21.000000', 'consum', 0.0222, 'lps'),
	(463091, 102, '2015-04-01 00:29:22.000000', 'consum', 0.0213, 'lps'),
	(463092, 102, '2015-04-01 00:29:23.000000', 'consum', 0.0212, 'lps'),
	(463093, 102, '2015-04-01 00:29:24.000000', 'consum', 0.0229, 'lps'),
	(463094, 102, '2015-04-01 00:29:25.000000', 'consum', 0.0217, 'lps'),
	(463095, 102, '2015-04-01 00:29:26.000000', 'consum', 0.0228, 'lps'),
	(463096, 102, '2015-04-01 00:29:27.000000', 'consum', 0.0219, 'lps'),
	(463097, 102, '2015-04-01 00:29:28.000000', 'consum', 0.0222, 'lps'),
	(463098, 102, '2015-04-01 00:29:29.000000', 'consum', 0.0222, 'lps'),
	(463099, 102, '2015-04-01 00:29:30.000000', 'consum', 0.0215, 'lps'),
	(463100, 102, '2015-04-01 00:29:31.000000', 'consum', 0.0220, 'lps'),
	(463101, 102, '2015-04-01 00:29:32.000000', 'consum', 0.0224, 'lps'),
	(463102, 102, '2015-04-01 00:29:33.000000', 'consum', 0.0210, 'lps'),
	(463103, 102, '2015-04-01 00:29:34.000000', 'consum', 0.0211, 'lps'),
	(463104, 102, '2015-04-01 00:29:35.000000', 'consum', 0.0215, 'lps'),
	(463105, 102, '2015-04-01 00:29:36.000000', 'consum', 0.0212, 'lps'),
	(463106, 102, '2015-04-01 00:29:37.000000', 'consum', 0.0226, 'lps'),
	(463107, 102, '2015-04-01 00:29:38.000000', 'consum', 0.0223, 'lps'),
	(463108, 102, '2015-04-01 00:29:39.000000', 'consum', 0.0225, 'lps'),
	(463109, 102, '2015-04-01 00:29:40.000000', 'consum', 0.0226, 'lps'),
	(463110, 102, '2015-04-01 00:29:41.000000', 'consum', 0.0223, 'lps'),
	(463111, 102, '2015-04-01 00:29:42.000000', 'consum', 0.0228, 'lps'),
	(463112, 102, '2015-04-01 00:29:43.000000', 'consum', 0.0219, 'lps'),
	(463113, 102, '2015-04-01 00:29:44.000000', 'consum', 0.0224, 'lps'),
	(463114, 102, '2015-04-01 00:29:45.000000', 'consum', 0.0213, 'lps'),
	(463115, 102, '2015-04-01 00:29:46.000000', 'consum', 0.0223, 'lps'),
	(463116, 102, '2015-04-01 00:29:47.000000', 'consum', 0.0227, 'lps'),
	(463117, 102, '2015-04-01 00:29:48.000000', 'consum', 0.0215, 'lps'),
	(463118, 102, '2015-04-01 00:29:49.000000', 'consum', 0.0225, 'lps'),
	(463119, 102, '2015-04-01 00:29:50.000000', 'consum', 0.0228, 'lps'),
	(463120, 102, '2015-04-01 00:29:51.000000', 'consum', 0.0212, 'lps'),
	(463121, 102, '2015-04-01 00:29:52.000000', 'consum', 0.0211, 'lps'),
	(463122, 102, '2015-04-01 00:29:53.000000', 'consum', 0.0228, 'lps'),
	(463123, 102, '2015-04-01 00:29:54.000000', 'consum', 0.0214, 'lps'),
	(463124, 102, '2015-04-01 00:29:55.000000', 'consum', 0.0219, 'lps'),
	(463125, 102, '2015-04-01 00:29:56.000000', 'consum', 0.0222, 'lps'),
	(463126, 102, '2015-04-01 00:29:57.000000', 'consum', 0.0222, 'lps'),
	(463127, 102, '2015-04-01 00:29:58.000000', 'consum', 0.0215, 'lps'),
	(463128, 102, '2015-04-01 00:29:59.000000', 'consum', 0.0218, 'lps'),
	(463129, 102, '2015-04-01 00:30:00.000000', 'consum', 0.0217, 'lps'),
	(463130, 102, '2015-04-01 00:30:01.000000', 'consum', 0.0223, 'lps'),
	(463131, 102, '2015-04-01 00:30:02.000000', 'consum', 0.0230, 'lps'),
	(463132, 102, '2015-04-01 00:30:03.000000', 'consum', 0.0211, 'lps'),
	(463133, 102, '2015-04-01 00:30:04.000000', 'consum', 0.0217, 'lps'),
	(463134, 102, '2015-04-01 00:30:05.000000', 'consum', 0.0224, 'lps'),
	(463135, 102, '2015-04-01 00:30:06.000000', 'consum', 0.0216, 'lps'),
	(463136, 102, '2015-04-01 00:30:07.000000', 'consum', 0.0220, 'lps'),
	(463137, 102, '2015-04-01 00:30:08.000000', 'consum', 0.0223, 'lps'),
	(463138, 102, '2015-04-01 00:30:09.000000', 'consum', 0.0224, 'lps'),
	(463139, 102, '2015-04-01 00:30:10.000000', 'consum', 0.0219, 'lps'),
	(463140, 102, '2015-04-01 00:30:11.000000', 'consum', 0.0213, 'lps'),
	(463141, 102, '2015-04-01 00:30:12.000000', 'consum', 0.0219, 'lps'),
	(463142, 102, '2015-04-01 00:30:13.000000', 'consum', 0.0228, 'lps'),
	(463143, 102, '2015-04-01 00:30:14.000000', 'consum', 0.0230, 'lps'),
	(463144, 102, '2015-04-01 00:30:15.000000', 'consum', 0.0213, 'lps'),
	(463145, 102, '2015-04-01 00:30:16.000000', 'consum', 0.0210, 'lps'),
	(463146, 102, '2015-04-01 00:30:17.000000', 'consum', 0.0222, 'lps'),
	(463147, 102, '2015-04-01 00:30:18.000000', 'consum', 0.0228, 'lps'),
	(463148, 102, '2015-04-01 00:30:19.000000', 'consum', 0.0222, 'lps'),
	(463149, 102, '2015-04-01 00:30:20.000000', 'consum', 0.0218, 'lps'),
	(463150, 102, '2015-04-01 00:30:21.000000', 'consum', 0.0214, 'lps'),
	(463151, 102, '2015-04-01 00:30:22.000000', 'consum', 0.0227, 'lps'),
	(463152, 102, '2015-04-01 00:30:23.000000', 'consum', 0.0223, 'lps'),
	(463153, 102, '2015-04-01 00:30:24.000000', 'consum', 0.0222, 'lps'),
	(463154, 102, '2015-04-01 00:30:25.000000', 'consum', 0.0212, 'lps'),
	(463155, 102, '2015-04-01 00:30:26.000000', 'consum', 0.0226, 'lps'),
	(463156, 102, '2015-04-01 00:30:27.000000', 'consum', 0.0220, 'lps'),
	(463157, 102, '2015-04-01 00:30:28.000000', 'consum', 0.0212, 'lps'),
	(463158, 102, '2015-04-01 00:30:29.000000', 'consum', 0.0214, 'lps'),
	(463159, 102, '2015-04-01 00:30:30.000000', 'consum', 0.0223, 'lps'),
	(463160, 102, '2015-04-01 00:30:31.000000', 'consum', 0.0223, 'lps'),
	(463161, 102, '2015-04-01 00:30:32.000000', 'consum', 0.0215, 'lps'),
	(463162, 102, '2015-04-01 00:30:33.000000', 'consum', 0.0218, 'lps'),
	(463163, 102, '2015-04-01 00:30:34.000000', 'consum', 0.0213, 'lps'),
	(463164, 102, '2015-04-01 00:30:35.000000', 'consum', 0.0223, 'lps'),
	(463165, 102, '2015-04-01 00:30:36.000000', 'consum', 0.0224, 'lps'),
	(463166, 102, '2015-04-01 00:30:37.000000', 'consum', 0.0219, 'lps'),
	(463167, 102, '2015-04-01 00:30:38.000000', 'consum', 0.0216, 'lps'),
	(463168, 102, '2015-04-01 00:30:39.000000', 'consum', 0.0214, 'lps'),
	(463169, 102, '2015-04-01 00:30:40.000000', 'consum', 0.0210, 'lps'),
	(463170, 102, '2015-04-01 00:30:41.000000', 'consum', 0.0219, 'lps'),
	(463171, 102, '2015-04-01 00:30:42.000000', 'consum', 0.0213, 'lps'),
	(463172, 102, '2015-04-01 00:30:43.000000', 'consum', 0.0219, 'lps'),
	(463173, 102, '2015-04-01 00:30:44.000000', 'consum', 0.0226, 'lps'),
	(463174, 102, '2015-04-01 00:30:45.000000', 'consum', 0.0224, 'lps'),
	(463175, 102, '2015-04-01 00:30:46.000000', 'consum', 0.0210, 'lps'),
	(463176, 102, '2015-04-01 00:30:47.000000', 'consum', 0.0230, 'lps'),
	(463177, 102, '2015-04-01 00:30:48.000000', 'consum', 0.0227, 'lps'),
	(463178, 102, '2015-04-01 00:30:49.000000', 'consum', 0.0216, 'lps'),
	(463179, 102, '2015-04-01 00:30:50.000000', 'consum', 0.0210, 'lps'),
	(463180, 102, '2015-04-01 00:30:51.000000', 'consum', 0.0215, 'lps'),
	(463181, 102, '2015-04-01 00:30:52.000000', 'consum', 0.0213, 'lps'),
	(463182, 102, '2015-04-01 00:30:53.000000', 'consum', 0.0212, 'lps'),
	(463183, 102, '2015-04-01 00:30:54.000000', 'consum', 0.0212, 'lps'),
	(463184, 102, '2015-04-01 00:30:55.000000', 'consum', 0.0215, 'lps'),
	(463185, 102, '2015-04-01 00:30:56.000000', 'consum', 0.0210, 'lps'),
	(463186, 102, '2015-04-01 00:30:57.000000', 'consum', 0.0213, 'lps'),
	(463187, 102, '2015-04-01 00:30:58.000000', 'consum', 0.0226, 'lps'),
	(463188, 102, '2015-04-01 00:30:59.000000', 'consum', 0.0219, 'lps'),
	(463189, 102, '2015-04-01 00:31:00.000000', 'consum', 0.0228, 'lps'),
	(463190, 102, '2015-04-01 00:31:01.000000', 'consum', 0.0210, 'lps'),
	(463191, 102, '2015-04-01 00:31:02.000000', 'consum', 0.0218, 'lps'),
	(463192, 102, '2015-04-01 00:31:03.000000', 'consum', 0.0210, 'lps'),
	(463193, 102, '2015-04-01 00:31:04.000000', 'consum', 0.0228, 'lps'),
	(463194, 102, '2015-04-01 00:31:05.000000', 'consum', 0.0218, 'lps'),
	(463195, 102, '2015-04-01 00:31:06.000000', 'consum', 0.0215, 'lps'),
	(463196, 102, '2015-04-01 00:31:07.000000', 'consum', 0.0212, 'lps'),
	(463197, 102, '2015-04-01 00:31:08.000000', 'consum', 0.0225, 'lps'),
	(463198, 102, '2015-04-01 00:31:09.000000', 'consum', 0.0220, 'lps'),
	(463199, 102, '2015-04-01 00:31:10.000000', 'consum', 0.0213, 'lps'),
	(463200, 102, '2015-04-01 00:31:11.000000', 'consum', 0.0216, 'lps'),
	(463201, 102, '2015-04-01 00:31:12.000000', 'consum', 0.0210, 'lps'),
	(463202, 102, '2015-04-01 00:31:13.000000', 'consum', 0.0214, 'lps'),
	(463203, 102, '2015-04-01 00:31:14.000000', 'consum', 0.0229, 'lps'),
	(463204, 102, '2015-04-01 00:31:15.000000', 'consum', 0.0213, 'lps'),
	(463205, 102, '2015-04-01 00:31:16.000000', 'consum', 0.0229, 'lps'),
	(463206, 102, '2015-04-01 00:31:17.000000', 'consum', 0.0214, 'lps'),
	(463207, 102, '2015-04-01 00:31:18.000000', 'consum', 0.0214, 'lps'),
	(463208, 102, '2015-04-01 00:31:19.000000', 'consum', 0.0218, 'lps'),
	(463209, 102, '2015-04-01 00:31:20.000000', 'consum', 0.0217, 'lps'),
	(463210, 102, '2015-04-01 00:31:21.000000', 'consum', 0.0222, 'lps'),
	(463211, 102, '2015-04-01 00:31:22.000000', 'consum', 0.0229, 'lps'),
	(463212, 102, '2015-04-01 00:31:23.000000', 'consum', 0.0229, 'lps'),
	(463213, 102, '2015-04-01 00:31:24.000000', 'consum', 0.0226, 'lps'),
	(463214, 102, '2015-04-01 00:31:25.000000', 'consum', 0.0211, 'lps'),
	(463215, 102, '2015-04-01 00:31:26.000000', 'consum', 0.0211, 'lps'),
	(463216, 102, '2015-04-01 00:31:27.000000', 'consum', 0.0212, 'lps'),
	(463217, 102, '2015-04-01 00:31:28.000000', 'consum', 0.0219, 'lps'),
	(463218, 102, '2015-04-01 00:31:29.000000', 'consum', 0.0227, 'lps'),
	(463219, 102, '2015-04-01 00:31:30.000000', 'consum', 0.0228, 'lps'),
	(463220, 102, '2015-04-01 00:31:31.000000', 'consum', 0.0227, 'lps'),
	(463221, 102, '2015-04-01 00:31:32.000000', 'consum', 0.0219, 'lps'),
	(463222, 102, '2015-04-01 00:31:33.000000', 'consum', 0.0228, 'lps'),
	(463223, 102, '2015-04-01 00:31:34.000000', 'consum', 0.0230, 'lps'),
	(463224, 102, '2015-04-01 00:31:35.000000', 'consum', 0.0215, 'lps'),
	(463225, 102, '2015-04-01 00:31:36.000000', 'consum', 0.0218, 'lps'),
	(463226, 102, '2015-04-01 00:31:37.000000', 'consum', 0.0215, 'lps'),
	(463227, 102, '2015-04-01 00:31:38.000000', 'consum', 0.0211, 'lps'),
	(463228, 102, '2015-04-01 00:31:39.000000', 'consum', 0.0222, 'lps'),
	(463229, 102, '2015-04-01 00:31:40.000000', 'consum', 0.0226, 'lps'),
	(463230, 102, '2015-04-01 00:31:41.000000', 'consum', 0.0212, 'lps'),
	(463231, 102, '2015-04-01 00:31:42.000000', 'consum', 0.0216, 'lps'),
	(463232, 102, '2015-04-01 00:31:43.000000', 'consum', 0.0211, 'lps'),
	(463233, 102, '2015-04-01 00:31:44.000000', 'consum', 0.0221, 'lps'),
	(463234, 102, '2015-04-01 00:31:45.000000', 'consum', 0.0221, 'lps'),
	(463235, 102, '2015-04-01 00:31:46.000000', 'consum', 0.0212, 'lps'),
	(463236, 102, '2015-04-01 00:31:47.000000', 'consum', 0.0229, 'lps'),
	(463237, 102, '2015-04-01 00:31:48.000000', 'consum', 0.0215, 'lps'),
	(463238, 102, '2015-04-01 00:31:49.000000', 'consum', 0.0222, 'lps'),
	(463239, 102, '2015-04-01 00:31:50.000000', 'consum', 0.0213, 'lps'),
	(463240, 102, '2015-04-01 00:31:51.000000', 'consum', 0.0210, 'lps'),
	(463241, 102, '2015-04-01 00:31:52.000000', 'consum', 0.0225, 'lps'),
	(463242, 102, '2015-04-01 00:31:53.000000', 'consum', 0.0219, 'lps'),
	(463243, 102, '2015-04-01 00:31:54.000000', 'consum', 0.0213, 'lps'),
	(463244, 102, '2015-04-01 00:31:55.000000', 'consum', 0.0220, 'lps'),
	(463245, 102, '2015-04-01 00:31:56.000000', 'consum', 0.0229, 'lps'),
	(463246, 102, '2015-04-01 00:31:57.000000', 'consum', 0.0214, 'lps'),
	(463247, 102, '2015-04-01 00:31:58.000000', 'consum', 0.0216, 'lps'),
	(463248, 102, '2015-04-01 00:31:59.000000', 'consum', 0.0229, 'lps'),
	(463249, 102, '2015-04-01 00:32:00.000000', 'consum', 0.0224, 'lps'),
	(463250, 102, '2015-04-01 00:32:01.000000', 'consum', 0.0225, 'lps'),
	(463251, 102, '2015-04-01 00:32:02.000000', 'consum', 0.0222, 'lps'),
	(463252, 102, '2015-04-01 00:32:03.000000', 'consum', 0.0225, 'lps'),
	(463253, 102, '2015-04-01 00:32:04.000000', 'consum', 0.0230, 'lps'),
	(463254, 102, '2015-04-01 00:32:05.000000', 'consum', 0.0224, 'lps'),
	(463255, 102, '2015-04-01 00:32:06.000000', 'consum', 0.0218, 'lps'),
	(463256, 102, '2015-04-01 00:32:07.000000', 'consum', 0.0230, 'lps'),
	(463257, 102, '2015-04-01 00:32:08.000000', 'consum', 0.0223, 'lps'),
	(463258, 102, '2015-04-01 00:32:09.000000', 'consum', 0.0215, 'lps'),
	(463259, 102, '2015-04-01 00:32:10.000000', 'consum', 0.0217, 'lps'),
	(463260, 102, '2015-04-01 00:32:11.000000', 'consum', 0.0211, 'lps'),
	(463261, 102, '2015-04-01 00:32:12.000000', 'consum', 0.0214, 'lps'),
	(463262, 102, '2015-04-01 00:32:13.000000', 'consum', 0.0228, 'lps'),
	(463263, 102, '2015-04-01 00:32:14.000000', 'consum', 0.0226, 'lps'),
	(463264, 102, '2015-04-01 00:32:15.000000', 'consum', 0.0216, 'lps'),
	(463265, 102, '2015-04-01 00:32:16.000000', 'consum', 0.0215, 'lps'),
	(463266, 102, '2015-04-01 00:32:17.000000', 'consum', 0.0216, 'lps'),
	(463267, 102, '2015-04-01 00:32:18.000000', 'consum', 0.0226, 'lps'),
	(463268, 102, '2015-04-01 00:32:19.000000', 'consum', 0.0229, 'lps'),
	(463269, 102, '2015-04-01 00:32:20.000000', 'consum', 0.0218, 'lps'),
	(463270, 102, '2015-04-01 00:32:21.000000', 'consum', 0.0212, 'lps'),
	(463271, 102, '2015-04-01 00:32:22.000000', 'consum', 0.0218, 'lps'),
	(463272, 102, '2015-04-01 00:32:23.000000', 'consum', 0.0224, 'lps'),
	(463273, 102, '2015-04-01 00:32:24.000000', 'consum', 0.0215, 'lps'),
	(463274, 102, '2015-04-01 00:32:25.000000', 'consum', 0.0215, 'lps'),
	(463275, 102, '2015-04-01 00:32:26.000000', 'consum', 0.0219, 'lps'),
	(463276, 102, '2015-04-01 00:32:27.000000', 'consum', 0.0222, 'lps'),
	(463277, 102, '2015-04-01 00:32:28.000000', 'consum', 0.0222, 'lps'),
	(463278, 102, '2015-04-01 00:32:29.000000', 'consum', 0.0212, 'lps'),
	(463279, 102, '2015-04-01 00:32:30.000000', 'consum', 0.0226, 'lps'),
	(463280, 102, '2015-04-01 00:32:31.000000', 'consum', 0.0224, 'lps'),
	(463281, 102, '2015-04-01 00:32:32.000000', 'consum', 0.0230, 'lps'),
	(463282, 102, '2015-04-01 00:32:33.000000', 'consum', 0.0229, 'lps'),
	(463283, 102, '2015-04-01 00:32:34.000000', 'consum', 0.0223, 'lps'),
	(463284, 102, '2015-04-01 00:32:35.000000', 'consum', 0.0218, 'lps'),
	(463285, 102, '2015-04-01 00:32:36.000000', 'consum', 0.0213, 'lps'),
	(463286, 102, '2015-04-01 00:32:37.000000', 'consum', 0.0222, 'lps'),
	(463287, 102, '2015-04-01 00:32:38.000000', 'consum', 0.0219, 'lps'),
	(463288, 102, '2015-04-01 00:32:39.000000', 'consum', 0.0220, 'lps'),
	(463289, 102, '2015-04-01 00:32:40.000000', 'consum', 0.0212, 'lps'),
	(463290, 102, '2015-04-01 00:32:41.000000', 'consum', 0.0210, 'lps'),
	(463291, 102, '2015-04-01 00:32:42.000000', 'consum', 0.0228, 'lps'),
	(463292, 102, '2015-04-01 00:32:43.000000', 'consum', 0.0216, 'lps'),
	(463293, 102, '2015-04-01 00:32:44.000000', 'consum', 0.0230, 'lps'),
	(463294, 102, '2015-04-01 00:32:45.000000', 'consum', 0.0227, 'lps'),
	(463295, 102, '2015-04-01 00:32:46.000000', 'consum', 0.0215, 'lps'),
	(463296, 102, '2015-04-01 00:32:47.000000', 'consum', 0.0226, 'lps'),
	(463297, 102, '2015-04-01 00:32:48.000000', 'consum', 0.0214, 'lps'),
	(463298, 102, '2015-04-01 00:32:49.000000', 'consum', 0.0222, 'lps'),
	(463299, 102, '2015-04-01 00:32:50.000000', 'consum', 0.0219, 'lps'),
	(463300, 102, '2015-04-01 00:32:51.000000', 'consum', 0.0217, 'lps'),
	(463301, 102, '2015-04-01 00:32:52.000000', 'consum', 0.0219, 'lps'),
	(463302, 102, '2015-04-01 00:32:53.000000', 'consum', 0.0214, 'lps'),
	(463303, 102, '2015-04-01 00:32:54.000000', 'consum', 0.0225, 'lps'),
	(463304, 102, '2015-04-01 00:32:55.000000', 'consum', 0.0229, 'lps'),
	(463305, 102, '2015-04-01 00:32:56.000000', 'consum', 0.0221, 'lps'),
	(463306, 102, '2015-04-01 00:32:57.000000', 'consum', 0.0229, 'lps'),
	(463307, 102, '2015-04-01 00:32:58.000000', 'consum', 0.0210, 'lps'),
	(463308, 102, '2015-04-01 00:32:59.000000', 'consum', 0.0218, 'lps'),
	(463309, 102, '2015-04-01 00:33:00.000000', 'consum', 0.0226, 'lps'),
	(463310, 102, '2015-04-01 00:33:01.000000', 'consum', 0.0227, 'lps'),
	(463311, 102, '2015-04-01 00:33:02.000000', 'consum', 0.0225, 'lps'),
	(463312, 102, '2015-04-01 00:33:03.000000', 'consum', 0.0212, 'lps'),
	(463313, 102, '2015-04-01 00:33:04.000000', 'consum', 0.0219, 'lps'),
	(463314, 102, '2015-04-01 00:33:05.000000', 'consum', 0.0228, 'lps'),
	(463315, 102, '2015-04-01 00:33:06.000000', 'consum', 0.0212, 'lps'),
	(463316, 102, '2015-04-01 00:33:07.000000', 'consum', 0.0228, 'lps'),
	(463317, 102, '2015-04-01 00:33:08.000000', 'consum', 0.0212, 'lps'),
	(463318, 102, '2015-04-01 00:33:09.000000', 'consum', 0.0230, 'lps'),
	(463319, 102, '2015-04-01 00:33:10.000000', 'consum', 0.0221, 'lps'),
	(463320, 102, '2015-04-01 00:33:11.000000', 'consum', 0.0227, 'lps'),
	(463321, 102, '2015-04-01 00:33:12.000000', 'consum', 0.0220, 'lps'),
	(463322, 102, '2015-04-01 00:33:13.000000', 'consum', 0.0230, 'lps'),
	(463323, 102, '2015-04-01 00:33:14.000000', 'consum', 0.0218, 'lps'),
	(463324, 102, '2015-04-01 00:33:15.000000', 'consum', 0.0212, 'lps'),
	(463325, 102, '2015-04-01 00:33:16.000000', 'consum', 0.0215, 'lps'),
	(463326, 102, '2015-04-01 00:33:17.000000', 'consum', 0.0210, 'lps'),
	(463327, 102, '2015-04-01 00:33:18.000000', 'consum', 0.0215, 'lps'),
	(463328, 102, '2015-04-01 00:33:19.000000', 'consum', 0.0215, 'lps'),
	(463329, 102, '2015-04-01 00:33:20.000000', 'consum', 0.0219, 'lps'),
	(463330, 102, '2015-04-01 00:33:21.000000', 'consum', 0.0221, 'lps'),
	(463331, 102, '2015-04-01 00:33:22.000000', 'consum', 0.0218, 'lps'),
	(463332, 102, '2015-04-01 00:33:23.000000', 'consum', 0.0219, 'lps'),
	(463333, 102, '2015-04-01 00:33:24.000000', 'consum', 0.0229, 'lps'),
	(463334, 102, '2015-04-01 00:33:25.000000', 'consum', 0.0218, 'lps'),
	(463335, 102, '2015-04-01 00:33:26.000000', 'consum', 0.0213, 'lps'),
	(463336, 102, '2015-04-01 00:33:27.000000', 'consum', 0.0223, 'lps'),
	(463337, 102, '2015-04-01 00:33:28.000000', 'consum', 0.0226, 'lps'),
	(463338, 102, '2015-04-01 00:33:29.000000', 'consum', 0.0229, 'lps'),
	(463339, 102, '2015-04-01 00:33:30.000000', 'consum', 0.0216, 'lps'),
	(463340, 102, '2015-04-01 00:33:31.000000', 'consum', 0.0224, 'lps'),
	(463341, 102, '2015-04-01 00:33:32.000000', 'consum', 0.0220, 'lps'),
	(463342, 102, '2015-04-01 00:33:33.000000', 'consum', 0.0220, 'lps'),
	(463343, 102, '2015-04-01 00:33:34.000000', 'consum', 0.0229, 'lps'),
	(463344, 102, '2015-04-01 00:33:35.000000', 'consum', 0.0214, 'lps'),
	(463345, 102, '2015-04-01 00:33:36.000000', 'consum', 0.0216, 'lps'),
	(463346, 102, '2015-04-01 00:33:37.000000', 'consum', 0.0227, 'lps'),
	(463347, 102, '2015-04-01 00:33:38.000000', 'consum', 0.0214, 'lps'),
	(463348, 102, '2015-04-01 00:33:39.000000', 'consum', 0.0222, 'lps'),
	(463349, 102, '2015-04-01 00:33:40.000000', 'consum', 0.0217, 'lps'),
	(463350, 102, '2015-04-01 00:33:41.000000', 'consum', 0.0229, 'lps'),
	(463351, 102, '2015-04-01 00:33:42.000000', 'consum', 0.0224, 'lps'),
	(463352, 102, '2015-04-01 00:33:43.000000', 'consum', 0.0221, 'lps'),
	(463353, 102, '2015-04-01 00:33:44.000000', 'consum', 0.0224, 'lps'),
	(463354, 102, '2015-04-01 00:33:45.000000', 'consum', 0.0227, 'lps'),
	(463355, 102, '2015-04-01 00:33:46.000000', 'consum', 0.0213, 'lps'),
	(463356, 102, '2015-04-01 00:33:47.000000', 'consum', 0.0215, 'lps'),
	(463357, 102, '2015-04-01 00:33:48.000000', 'consum', 0.0228, 'lps'),
	(463358, 102, '2015-04-01 00:33:49.000000', 'consum', 0.0221, 'lps'),
	(463359, 102, '2015-04-01 00:33:50.000000', 'consum', 0.0211, 'lps'),
	(463360, 102, '2015-04-01 00:33:51.000000', 'consum', 0.0226, 'lps'),
	(463361, 102, '2015-04-01 00:33:52.000000', 'consum', 0.0224, 'lps'),
	(463362, 102, '2015-04-01 00:33:53.000000', 'consum', 0.0212, 'lps'),
	(463363, 102, '2015-04-01 00:33:54.000000', 'consum', 0.0218, 'lps'),
	(463364, 102, '2015-04-01 00:33:55.000000', 'consum', 0.0225, 'lps'),
	(463365, 102, '2015-04-01 00:33:56.000000', 'consum', 0.0220, 'lps'),
	(463366, 102, '2015-04-01 00:33:57.000000', 'consum', 0.0214, 'lps'),
	(463367, 102, '2015-04-01 00:33:58.000000', 'consum', 0.0224, 'lps'),
	(463368, 102, '2015-04-01 00:33:59.000000', 'consum', 0.0224, 'lps'),
	(463369, 102, '2015-04-01 00:34:00.000000', 'consum', 0.0218, 'lps'),
	(463370, 102, '2015-04-01 00:34:01.000000', 'consum', 0.0229, 'lps'),
	(463371, 102, '2015-04-01 00:34:02.000000', 'consum', 0.0219, 'lps'),
	(463372, 102, '2015-04-01 00:34:03.000000', 'consum', 0.0220, 'lps'),
	(463373, 102, '2015-04-01 00:34:04.000000', 'consum', 0.0214, 'lps'),
	(463374, 102, '2015-04-01 00:34:05.000000', 'consum', 0.0218, 'lps'),
	(463375, 102, '2015-04-01 00:34:06.000000', 'consum', 0.0220, 'lps'),
	(463376, 102, '2015-04-01 00:34:07.000000', 'consum', 0.0217, 'lps'),
	(463377, 102, '2015-04-01 00:34:08.000000', 'consum', 0.0213, 'lps'),
	(463378, 102, '2015-04-01 00:34:09.000000', 'consum', 0.0228, 'lps'),
	(463379, 102, '2015-04-01 00:34:10.000000', 'consum', 0.0228, 'lps'),
	(463380, 102, '2015-04-01 00:34:11.000000', 'consum', 0.0225, 'lps'),
	(463381, 102, '2015-04-01 00:34:12.000000', 'consum', 0.0211, 'lps'),
	(463382, 102, '2015-04-01 00:34:13.000000', 'consum', 0.0210, 'lps'),
	(463383, 102, '2015-04-01 00:34:14.000000', 'consum', 0.0211, 'lps'),
	(463384, 102, '2015-04-01 00:34:15.000000', 'consum', 0.0215, 'lps'),
	(463385, 102, '2015-04-01 00:34:16.000000', 'consum', 0.0230, 'lps'),
	(463386, 102, '2015-04-01 00:34:17.000000', 'consum', 0.0212, 'lps'),
	(463387, 102, '2015-04-01 00:34:18.000000', 'consum', 0.0224, 'lps'),
	(463388, 102, '2015-04-01 00:34:19.000000', 'consum', 0.0210, 'lps'),
	(463389, 102, '2015-04-01 00:34:20.000000', 'consum', 0.0212, 'lps'),
	(463390, 102, '2015-04-01 00:34:21.000000', 'consum', 0.0218, 'lps'),
	(463391, 102, '2015-04-01 00:34:22.000000', 'consum', 0.0227, 'lps'),
	(463392, 102, '2015-04-01 00:34:23.000000', 'consum', 0.0229, 'lps'),
	(463393, 102, '2015-04-01 00:34:24.000000', 'consum', 0.0211, 'lps'),
	(463394, 102, '2015-04-01 00:34:25.000000', 'consum', 0.0223, 'lps'),
	(463395, 102, '2015-04-01 00:34:26.000000', 'consum', 0.0211, 'lps'),
	(463396, 102, '2015-04-01 00:34:27.000000', 'consum', 0.0217, 'lps'),
	(463397, 102, '2015-04-01 00:34:28.000000', 'consum', 0.0222, 'lps'),
	(463398, 102, '2015-04-01 00:34:29.000000', 'consum', 0.0227, 'lps'),
	(463399, 102, '2015-04-01 00:34:30.000000', 'consum', 0.0218, 'lps'),
	(463400, 102, '2015-04-01 00:34:31.000000', 'consum', 0.0220, 'lps'),
	(463401, 102, '2015-04-01 00:34:32.000000', 'consum', 0.0217, 'lps'),
	(463402, 102, '2015-04-01 00:34:33.000000', 'consum', 0.0216, 'lps'),
	(463403, 102, '2015-04-01 00:34:34.000000', 'consum', 0.0220, 'lps'),
	(463404, 102, '2015-04-01 00:34:35.000000', 'consum', 0.0222, 'lps'),
	(463405, 102, '2015-04-01 00:34:36.000000', 'consum', 0.0220, 'lps'),
	(463406, 102, '2015-04-01 00:34:37.000000', 'consum', 0.0224, 'lps'),
	(463407, 102, '2015-04-01 00:34:38.000000', 'consum', 0.0230, 'lps'),
	(463408, 102, '2015-04-01 00:34:39.000000', 'consum', 0.0226, 'lps'),
	(463409, 102, '2015-04-01 00:34:40.000000', 'consum', 0.0211, 'lps'),
	(463410, 102, '2015-04-01 00:34:41.000000', 'consum', 0.0229, 'lps'),
	(463411, 102, '2015-04-01 00:34:42.000000', 'consum', 0.0220, 'lps'),
	(463412, 102, '2015-04-01 00:34:43.000000', 'consum', 0.0223, 'lps'),
	(463413, 102, '2015-04-01 00:34:44.000000', 'consum', 0.0226, 'lps'),
	(463414, 102, '2015-04-01 00:34:45.000000', 'consum', 0.0210, 'lps'),
	(463415, 102, '2015-04-01 00:34:46.000000', 'consum', 0.0225, 'lps'),
	(463416, 102, '2015-04-01 00:34:47.000000', 'consum', 0.0222, 'lps'),
	(463417, 102, '2015-04-01 00:34:48.000000', 'consum', 0.0225, 'lps'),
	(463418, 102, '2015-04-01 00:34:49.000000', 'consum', 0.0228, 'lps'),
	(463419, 102, '2015-04-01 00:34:50.000000', 'consum', 0.0214, 'lps'),
	(463420, 102, '2015-04-01 00:34:51.000000', 'consum', 0.0219, 'lps'),
	(463421, 102, '2015-04-01 00:34:52.000000', 'consum', 0.0222, 'lps'),
	(463422, 102, '2015-04-01 00:34:53.000000', 'consum', 0.0225, 'lps'),
	(463423, 102, '2015-04-01 00:34:54.000000', 'consum', 0.0226, 'lps'),
	(463424, 102, '2015-04-01 00:34:55.000000', 'consum', 0.0225, 'lps'),
	(463425, 102, '2015-04-01 00:34:56.000000', 'consum', 0.0217, 'lps'),
	(463426, 102, '2015-04-01 00:34:57.000000', 'consum', 0.0220, 'lps'),
	(463427, 102, '2015-04-01 00:34:58.000000', 'consum', 0.0220, 'lps'),
	(463428, 102, '2015-04-01 00:34:59.000000', 'consum', 0.0229, 'lps'),
	(463429, 102, '2015-04-01 00:35:00.000000', 'consum', 0.0211, 'lps'),
	(463430, 102, '2015-04-01 00:35:01.000000', 'consum', 0.0224, 'lps'),
	(463431, 102, '2015-04-01 00:35:02.000000', 'consum', 0.0214, 'lps'),
	(463432, 102, '2015-04-01 00:35:03.000000', 'consum', 0.0210, 'lps'),
	(463433, 102, '2015-04-01 00:35:04.000000', 'consum', 0.0219, 'lps'),
	(463434, 102, '2015-04-01 00:35:05.000000', 'consum', 0.0216, 'lps'),
	(463435, 102, '2015-04-01 00:35:06.000000', 'consum', 0.0210, 'lps'),
	(463436, 102, '2015-04-01 00:35:07.000000', 'consum', 0.0214, 'lps'),
	(463437, 102, '2015-04-01 00:35:08.000000', 'consum', 0.0229, 'lps'),
	(463438, 102, '2015-04-01 00:35:09.000000', 'consum', 0.0212, 'lps'),
	(463439, 102, '2015-04-01 00:35:10.000000', 'consum', 0.0225, 'lps'),
	(463440, 102, '2015-04-01 00:35:11.000000', 'consum', 0.0219, 'lps'),
	(463441, 102, '2015-04-01 00:35:12.000000', 'consum', 0.0230, 'lps'),
	(463442, 102, '2015-04-01 00:35:13.000000', 'consum', 0.0221, 'lps'),
	(463443, 102, '2015-04-01 00:35:14.000000', 'consum', 0.0225, 'lps'),
	(463444, 102, '2015-04-01 00:35:15.000000', 'consum', 0.0213, 'lps'),
	(463445, 102, '2015-04-01 00:35:16.000000', 'consum', 0.0220, 'lps'),
	(463446, 102, '2015-04-01 00:35:17.000000', 'consum', 0.0230, 'lps'),
	(463447, 102, '2015-04-01 00:35:18.000000', 'consum', 0.0218, 'lps'),
	(463448, 102, '2015-04-01 00:35:19.000000', 'consum', 0.0210, 'lps'),
	(463449, 102, '2015-04-01 00:35:20.000000', 'consum', 0.0211, 'lps'),
	(463450, 102, '2015-04-01 00:35:21.000000', 'consum', 0.0214, 'lps'),
	(463451, 102, '2015-04-01 00:35:22.000000', 'consum', 0.0226, 'lps'),
	(463452, 102, '2015-04-01 00:35:23.000000', 'consum', 0.0216, 'lps'),
	(463453, 102, '2015-04-01 00:35:24.000000', 'consum', 0.0215, 'lps'),
	(463454, 102, '2015-04-01 00:35:25.000000', 'consum', 0.0218, 'lps'),
	(463455, 102, '2015-04-01 00:35:26.000000', 'consum', 0.0212, 'lps'),
	(463456, 102, '2015-04-01 00:35:27.000000', 'consum', 0.0218, 'lps'),
	(463457, 102, '2015-04-01 00:35:28.000000', 'consum', 0.0225, 'lps'),
	(463458, 102, '2015-04-01 00:35:29.000000', 'consum', 0.0218, 'lps'),
	(463459, 102, '2015-04-01 00:35:30.000000', 'consum', 0.0229, 'lps'),
	(463460, 102, '2015-04-01 00:35:31.000000', 'consum', 0.0216, 'lps'),
	(463461, 102, '2015-04-01 00:35:32.000000', 'consum', 0.0227, 'lps'),
	(463462, 102, '2015-04-01 00:35:33.000000', 'consum', 0.0213, 'lps'),
	(463463, 102, '2015-04-01 00:35:34.000000', 'consum', 0.0217, 'lps'),
	(463464, 102, '2015-04-01 00:35:35.000000', 'consum', 0.0215, 'lps'),
	(463465, 102, '2015-04-01 00:35:36.000000', 'consum', 0.0217, 'lps'),
	(463466, 102, '2015-04-01 00:35:37.000000', 'consum', 0.0229, 'lps'),
	(463467, 102, '2015-04-01 00:35:38.000000', 'consum', 0.0221, 'lps'),
	(463468, 102, '2015-04-01 00:35:39.000000', 'consum', 0.0210, 'lps'),
	(463469, 102, '2015-04-01 00:35:40.000000', 'consum', 0.0218, 'lps'),
	(463470, 102, '2015-04-01 00:35:41.000000', 'consum', 0.0228, 'lps'),
	(463471, 102, '2015-04-01 00:35:42.000000', 'consum', 0.0216, 'lps'),
	(463472, 102, '2015-04-01 00:35:43.000000', 'consum', 0.0230, 'lps'),
	(463473, 102, '2015-04-01 00:35:44.000000', 'consum', 0.0226, 'lps'),
	(463474, 102, '2015-04-01 00:35:45.000000', 'consum', 0.0211, 'lps'),
	(463475, 102, '2015-04-01 00:35:46.000000', 'consum', 0.0229, 'lps'),
	(463476, 102, '2015-04-01 00:35:47.000000', 'consum', 0.0219, 'lps'),
	(463477, 102, '2015-04-01 00:35:48.000000', 'consum', 0.0221, 'lps'),
	(463478, 102, '2015-04-01 00:35:49.000000', 'consum', 0.0215, 'lps'),
	(463479, 102, '2015-04-01 00:35:50.000000', 'consum', 0.0226, 'lps'),
	(463480, 102, '2015-04-01 00:35:51.000000', 'consum', 0.0213, 'lps'),
	(463481, 102, '2015-04-01 00:35:52.000000', 'consum', 0.0220, 'lps'),
	(463482, 102, '2015-04-01 00:35:53.000000', 'consum', 0.0228, 'lps'),
	(463483, 102, '2015-04-01 00:35:54.000000', 'consum', 0.0228, 'lps'),
	(463484, 102, '2015-04-01 00:35:55.000000', 'consum', 0.0227, 'lps'),
	(463485, 102, '2015-04-01 00:35:56.000000', 'consum', 0.0220, 'lps'),
	(463486, 102, '2015-04-01 00:35:57.000000', 'consum', 0.0211, 'lps'),
	(463487, 102, '2015-04-01 00:35:58.000000', 'consum', 0.0225, 'lps'),
	(463488, 102, '2015-04-01 00:35:59.000000', 'consum', 0.0221, 'lps'),
	(463489, 102, '2015-04-01 00:36:00.000000', 'consum', 0.0218, 'lps'),
	(463490, 102, '2015-04-01 00:36:01.000000', 'consum', 0.0221, 'lps'),
	(463491, 102, '2015-04-01 00:36:02.000000', 'consum', 0.0217, 'lps'),
	(463492, 102, '2015-04-01 00:36:03.000000', 'consum', 0.0215, 'lps'),
	(463493, 102, '2015-04-01 00:36:04.000000', 'consum', 0.0213, 'lps'),
	(463494, 102, '2015-04-01 00:36:05.000000', 'consum', 0.0210, 'lps'),
	(463495, 102, '2015-04-01 00:36:06.000000', 'consum', 0.0223, 'lps'),
	(463496, 102, '2015-04-01 00:36:07.000000', 'consum', 0.0211, 'lps'),
	(463497, 102, '2015-04-01 00:36:08.000000', 'consum', 0.0218, 'lps'),
	(463498, 102, '2015-04-01 00:36:09.000000', 'consum', 0.0229, 'lps'),
	(463499, 102, '2015-04-01 00:36:10.000000', 'consum', 0.0216, 'lps'),
	(463500, 102, '2015-04-01 00:36:11.000000', 'consum', 0.0227, 'lps'),
	(463501, 102, '2015-04-01 00:36:12.000000', 'consum', 0.0216, 'lps'),
	(463502, 102, '2015-04-01 00:36:13.000000', 'consum', 0.0230, 'lps'),
	(463503, 102, '2015-04-01 00:36:14.000000', 'consum', 0.0230, 'lps'),
	(463504, 102, '2015-04-01 00:36:15.000000', 'consum', 0.0229, 'lps'),
	(463505, 102, '2015-04-01 00:36:16.000000', 'consum', 0.0227, 'lps'),
	(463506, 102, '2015-04-01 00:36:17.000000', 'consum', 0.0214, 'lps'),
	(463507, 102, '2015-04-01 00:36:18.000000', 'consum', 0.0224, 'lps'),
	(463508, 102, '2015-04-01 00:36:19.000000', 'consum', 0.0225, 'lps'),
	(463509, 102, '2015-04-01 00:36:20.000000', 'consum', 0.0225, 'lps'),
	(463510, 102, '2015-04-01 00:36:21.000000', 'consum', 0.0216, 'lps'),
	(463511, 102, '2015-04-01 00:36:22.000000', 'consum', 0.0219, 'lps'),
	(463512, 102, '2015-04-01 00:36:23.000000', 'consum', 0.0216, 'lps'),
	(463513, 102, '2015-04-01 00:36:24.000000', 'consum', 0.0214, 'lps'),
	(463514, 102, '2015-04-01 00:36:25.000000', 'consum', 0.0214, 'lps'),
	(463515, 102, '2015-04-01 00:36:26.000000', 'consum', 0.0216, 'lps'),
	(463516, 102, '2015-04-01 00:36:27.000000', 'consum', 0.0227, 'lps'),
	(463517, 102, '2015-04-01 00:36:28.000000', 'consum', 0.0217, 'lps'),
	(463518, 102, '2015-04-01 00:36:29.000000', 'consum', 0.0217, 'lps'),
	(463519, 102, '2015-04-01 00:36:30.000000', 'consum', 0.0221, 'lps'),
	(463520, 102, '2015-04-01 00:36:31.000000', 'consum', 0.0226, 'lps'),
	(463521, 102, '2015-04-01 00:36:32.000000', 'consum', 0.0214, 'lps'),
	(463522, 102, '2015-04-01 00:36:33.000000', 'consum', 0.0227, 'lps'),
	(463523, 102, '2015-04-01 00:36:34.000000', 'consum', 0.0219, 'lps'),
	(463524, 102, '2015-04-01 00:36:35.000000', 'consum', 0.0226, 'lps'),
	(463525, 102, '2015-04-01 00:36:36.000000', 'consum', 0.0221, 'lps'),
	(463526, 102, '2015-04-01 00:36:37.000000', 'consum', 0.0218, 'lps'),
	(463527, 102, '2015-04-01 00:36:38.000000', 'consum', 0.0219, 'lps'),
	(463528, 102, '2015-04-01 00:36:39.000000', 'consum', 0.0229, 'lps'),
	(463529, 102, '2015-04-01 00:36:40.000000', 'consum', 0.0217, 'lps'),
	(463530, 102, '2015-04-01 00:36:41.000000', 'consum', 0.0229, 'lps'),
	(463531, 102, '2015-04-01 00:36:42.000000', 'consum', 0.0223, 'lps'),
	(463532, 102, '2015-04-01 00:36:43.000000', 'consum', 0.0216, 'lps'),
	(463533, 102, '2015-04-01 00:36:44.000000', 'consum', 0.0225, 'lps'),
	(463534, 102, '2015-04-01 00:36:45.000000', 'consum', 0.0225, 'lps'),
	(463535, 102, '2015-04-01 00:36:46.000000', 'consum', 0.0219, 'lps'),
	(463536, 102, '2015-04-01 00:36:47.000000', 'consum', 0.0230, 'lps'),
	(463537, 102, '2015-04-01 00:36:48.000000', 'consum', 0.0223, 'lps'),
	(463538, 102, '2015-04-01 00:36:49.000000', 'consum', 0.0215, 'lps'),
	(463539, 102, '2015-04-01 00:36:50.000000', 'consum', 0.0218, 'lps'),
	(463540, 102, '2015-04-01 00:36:51.000000', 'consum', 0.0214, 'lps'),
	(463541, 102, '2015-04-01 00:36:52.000000', 'consum', 0.0226, 'lps'),
	(463542, 102, '2015-04-01 00:36:53.000000', 'consum', 0.0216, 'lps'),
	(463543, 102, '2015-04-01 00:36:54.000000', 'consum', 0.0215, 'lps'),
	(463544, 102, '2015-04-01 00:36:55.000000', 'consum', 0.0216, 'lps'),
	(463545, 102, '2015-04-01 00:36:56.000000', 'consum', 0.0227, 'lps'),
	(463546, 102, '2015-04-01 00:36:57.000000', 'consum', 0.0214, 'lps'),
	(463547, 102, '2015-04-01 00:36:58.000000', 'consum', 0.0221, 'lps'),
	(463548, 102, '2015-04-01 00:36:59.000000', 'consum', 0.0213, 'lps'),
	(463549, 102, '2015-04-01 00:37:00.000000', 'consum', 0.0214, 'lps'),
	(463550, 102, '2015-04-01 00:37:01.000000', 'consum', 0.0221, 'lps'),
	(463551, 102, '2015-04-01 00:37:02.000000', 'consum', 0.0210, 'lps'),
	(463552, 102, '2015-04-01 00:37:03.000000', 'consum', 0.0222, 'lps'),
	(463553, 102, '2015-04-01 00:37:04.000000', 'consum', 0.0228, 'lps'),
	(463554, 102, '2015-04-01 00:37:05.000000', 'consum', 0.0224, 'lps'),
	(463555, 102, '2015-04-01 00:37:06.000000', 'consum', 0.0226, 'lps'),
	(463556, 102, '2015-04-01 00:37:07.000000', 'consum', 0.0225, 'lps'),
	(463557, 102, '2015-04-01 00:37:08.000000', 'consum', 0.0217, 'lps'),
	(463558, 102, '2015-04-01 00:37:09.000000', 'consum', 0.0224, 'lps'),
	(463559, 102, '2015-04-01 00:37:10.000000', 'consum', 0.0215, 'lps'),
	(463560, 102, '2015-04-01 00:37:11.000000', 'consum', 0.0213, 'lps'),
	(463561, 102, '2015-04-01 00:37:12.000000', 'consum', 0.0213, 'lps'),
	(463562, 102, '2015-04-01 00:37:13.000000', 'consum', 0.0216, 'lps'),
	(463563, 102, '2015-04-01 00:37:14.000000', 'consum', 0.0230, 'lps'),
	(463564, 102, '2015-04-01 00:37:15.000000', 'consum', 0.0229, 'lps'),
	(463565, 102, '2015-04-01 00:37:16.000000', 'consum', 0.0225, 'lps'),
	(463566, 102, '2015-04-01 00:37:17.000000', 'consum', 0.0230, 'lps'),
	(463567, 102, '2015-04-01 00:37:18.000000', 'consum', 0.0221, 'lps'),
	(463568, 102, '2015-04-01 00:37:19.000000', 'consum', 0.0230, 'lps'),
	(463569, 102, '2015-04-01 00:37:20.000000', 'consum', 0.0211, 'lps'),
	(463570, 102, '2015-04-01 00:37:21.000000', 'consum', 0.0221, 'lps'),
	(463571, 102, '2015-04-01 00:37:22.000000', 'consum', 0.0222, 'lps'),
	(463572, 102, '2015-04-01 00:37:23.000000', 'consum', 0.0214, 'lps'),
	(463573, 102, '2015-04-01 00:37:24.000000', 'consum', 0.0216, 'lps'),
	(463574, 102, '2015-04-01 00:37:25.000000', 'consum', 0.0227, 'lps'),
	(463575, 102, '2015-04-01 00:37:26.000000', 'consum', 0.0214, 'lps'),
	(463576, 102, '2015-04-01 00:37:27.000000', 'consum', 0.0225, 'lps'),
	(463577, 102, '2015-04-01 00:37:28.000000', 'consum', 0.0229, 'lps'),
	(463578, 102, '2015-04-01 00:37:29.000000', 'consum', 0.0217, 'lps'),
	(463579, 102, '2015-04-01 00:37:30.000000', 'consum', 0.0211, 'lps'),
	(463580, 102, '2015-04-01 00:37:31.000000', 'consum', 0.0216, 'lps'),
	(463581, 102, '2015-04-01 00:37:32.000000', 'consum', 0.0215, 'lps'),
	(463582, 102, '2015-04-01 00:37:33.000000', 'consum', 0.0218, 'lps'),
	(463583, 102, '2015-04-01 00:37:34.000000', 'consum', 0.0216, 'lps'),
	(463584, 102, '2015-04-01 00:37:35.000000', 'consum', 0.0217, 'lps'),
	(463585, 102, '2015-04-01 00:37:36.000000', 'consum', 0.0226, 'lps'),
	(463586, 102, '2015-04-01 00:37:37.000000', 'consum', 0.0227, 'lps'),
	(463587, 102, '2015-04-01 00:37:38.000000', 'consum', 0.0227, 'lps'),
	(463588, 102, '2015-04-01 00:37:39.000000', 'consum', 0.0222, 'lps'),
	(463589, 102, '2015-04-01 00:37:40.000000', 'consum', 0.0221, 'lps'),
	(463590, 102, '2015-04-01 00:37:41.000000', 'consum', 0.0210, 'lps'),
	(463591, 102, '2015-04-01 00:37:42.000000', 'consum', 0.0218, 'lps'),
	(463592, 102, '2015-04-01 00:37:43.000000', 'consum', 0.0210, 'lps'),
	(463593, 102, '2015-04-01 00:37:44.000000', 'consum', 0.0229, 'lps'),
	(463594, 102, '2015-04-01 00:37:45.000000', 'consum', 0.0219, 'lps'),
	(463595, 102, '2015-04-01 00:37:46.000000', 'consum', 0.0219, 'lps'),
	(463596, 102, '2015-04-01 00:37:47.000000', 'consum', 0.0211, 'lps'),
	(463597, 102, '2015-04-01 00:37:48.000000', 'consum', 0.0227, 'lps'),
	(463598, 102, '2015-04-01 00:37:49.000000', 'consum', 0.0212, 'lps'),
	(463599, 102, '2015-04-01 00:37:50.000000', 'consum', 0.0230, 'lps'),
	(463600, 102, '2015-04-01 00:37:51.000000', 'consum', 0.0223, 'lps'),
	(463601, 102, '2015-04-01 00:37:52.000000', 'consum', 0.0214, 'lps'),
	(463602, 102, '2015-04-01 00:37:53.000000', 'consum', 0.0214, 'lps'),
	(463603, 102, '2015-04-01 00:37:54.000000', 'consum', 0.0219, 'lps'),
	(463604, 102, '2015-04-01 00:37:55.000000', 'consum', 0.0221, 'lps'),
	(463605, 102, '2015-04-01 00:37:56.000000', 'consum', 0.0217, 'lps'),
	(463606, 102, '2015-04-01 00:37:57.000000', 'consum', 0.0215, 'lps'),
	(463607, 102, '2015-04-01 00:37:58.000000', 'consum', 0.0214, 'lps'),
	(463608, 102, '2015-04-01 00:37:59.000000', 'consum', 0.0213, 'lps'),
	(463609, 102, '2015-04-01 00:38:00.000000', 'consum', 0.0215, 'lps'),
	(463610, 102, '2015-04-01 00:38:01.000000', 'consum', 0.0226, 'lps'),
	(463611, 102, '2015-04-01 00:38:02.000000', 'consum', 0.0214, 'lps'),
	(463612, 102, '2015-04-01 00:38:03.000000', 'consum', 0.0225, 'lps'),
	(463613, 102, '2015-04-01 00:38:04.000000', 'consum', 0.0211, 'lps'),
	(463614, 102, '2015-04-01 00:38:05.000000', 'consum', 0.0213, 'lps'),
	(463615, 102, '2015-04-01 00:38:06.000000', 'consum', 0.0222, 'lps'),
	(463616, 102, '2015-04-01 00:38:07.000000', 'consum', 0.0218, 'lps'),
	(463617, 102, '2015-04-01 00:38:08.000000', 'consum', 0.0216, 'lps'),
	(463618, 102, '2015-04-01 00:38:09.000000', 'consum', 0.0215, 'lps'),
	(463619, 102, '2015-04-01 00:38:10.000000', 'consum', 0.0218, 'lps'),
	(463620, 102, '2015-04-01 00:38:11.000000', 'consum', 0.0213, 'lps'),
	(463621, 102, '2015-04-01 00:38:12.000000', 'consum', 0.0224, 'lps'),
	(463622, 102, '2015-04-01 00:38:13.000000', 'consum', 0.0228, 'lps'),
	(463623, 102, '2015-04-01 00:38:14.000000', 'consum', 0.0217, 'lps'),
	(463624, 102, '2015-04-01 00:38:15.000000', 'consum', 0.0212, 'lps'),
	(463625, 102, '2015-04-01 00:38:16.000000', 'consum', 0.0219, 'lps'),
	(463626, 102, '2015-04-01 00:38:17.000000', 'consum', 0.0211, 'lps'),
	(463627, 102, '2015-04-01 00:38:18.000000', 'consum', 0.0228, 'lps'),
	(463628, 102, '2015-04-01 00:38:19.000000', 'consum', 0.0213, 'lps'),
	(463629, 102, '2015-04-01 00:38:20.000000', 'consum', 0.0215, 'lps'),
	(463630, 102, '2015-04-01 00:38:21.000000', 'consum', 0.0225, 'lps'),
	(463631, 102, '2015-04-01 00:38:22.000000', 'consum', 0.0228, 'lps'),
	(463632, 102, '2015-04-01 00:38:23.000000', 'consum', 0.0215, 'lps'),
	(463633, 102, '2015-04-01 00:38:24.000000', 'consum', 0.0223, 'lps'),
	(463634, 102, '2015-04-01 00:38:25.000000', 'consum', 0.0219, 'lps'),
	(463635, 102, '2015-04-01 00:38:26.000000', 'consum', 0.0217, 'lps'),
	(463636, 102, '2015-04-01 00:38:27.000000', 'consum', 0.0216, 'lps'),
	(463637, 102, '2015-04-01 00:38:28.000000', 'consum', 0.0222, 'lps'),
	(463638, 102, '2015-04-01 00:38:29.000000', 'consum', 0.0229, 'lps'),
	(463639, 102, '2015-04-01 00:38:30.000000', 'consum', 0.0229, 'lps'),
	(463640, 102, '2015-04-01 00:38:31.000000', 'consum', 0.0228, 'lps'),
	(463641, 102, '2015-04-01 00:38:32.000000', 'consum', 0.0221, 'lps'),
	(463642, 102, '2015-04-01 00:38:33.000000', 'consum', 0.0210, 'lps'),
	(463643, 102, '2015-04-01 00:38:34.000000', 'consum', 0.0222, 'lps'),
	(463644, 102, '2015-04-01 00:38:35.000000', 'consum', 0.0227, 'lps'),
	(463645, 102, '2015-04-01 00:38:36.000000', 'consum', 0.0217, 'lps'),
	(463646, 102, '2015-04-01 00:38:37.000000', 'consum', 0.0214, 'lps'),
	(463647, 102, '2015-04-01 00:38:38.000000', 'consum', 0.0212, 'lps'),
	(463648, 102, '2015-04-01 00:38:39.000000', 'consum', 0.0229, 'lps'),
	(463649, 102, '2015-04-01 00:38:40.000000', 'consum', 0.0217, 'lps'),
	(463650, 102, '2015-04-01 00:38:41.000000', 'consum', 0.0229, 'lps'),
	(463651, 102, '2015-04-01 00:38:42.000000', 'consum', 0.0222, 'lps'),
	(463652, 102, '2015-04-01 00:38:43.000000', 'consum', 0.0213, 'lps'),
	(463653, 102, '2015-04-01 00:38:44.000000', 'consum', 0.0212, 'lps'),
	(463654, 102, '2015-04-01 00:38:45.000000', 'consum', 0.0230, 'lps'),
	(463655, 102, '2015-04-01 00:38:46.000000', 'consum', 0.0221, 'lps'),
	(463656, 102, '2015-04-01 00:38:47.000000', 'consum', 0.0226, 'lps'),
	(463657, 102, '2015-04-01 00:38:48.000000', 'consum', 0.0215, 'lps'),
	(463658, 102, '2015-04-01 00:38:49.000000', 'consum', 0.0229, 'lps'),
	(463659, 102, '2015-04-01 00:38:50.000000', 'consum', 0.0228, 'lps'),
	(463660, 102, '2015-04-01 00:38:51.000000', 'consum', 0.0222, 'lps'),
	(463661, 102, '2015-04-01 00:38:52.000000', 'consum', 0.0218, 'lps'),
	(463662, 102, '2015-04-01 00:38:53.000000', 'consum', 0.0212, 'lps'),
	(463663, 102, '2015-04-01 00:38:54.000000', 'consum', 0.0220, 'lps'),
	(463664, 102, '2015-04-01 00:38:55.000000', 'consum', 0.0211, 'lps'),
	(463665, 102, '2015-04-01 00:38:56.000000', 'consum', 0.0227, 'lps'),
	(463666, 102, '2015-04-01 00:38:57.000000', 'consum', 0.0228, 'lps'),
	(463667, 102, '2015-04-01 00:38:58.000000', 'consum', 0.0210, 'lps'),
	(463668, 102, '2015-04-01 00:38:59.000000', 'consum', 0.0220, 'lps'),
	(463669, 102, '2015-04-01 00:39:00.000000', 'consum', 0.0218, 'lps'),
	(463670, 102, '2015-04-01 00:39:01.000000', 'consum', 0.0220, 'lps'),
	(463671, 102, '2015-04-01 00:39:02.000000', 'consum', 0.0216, 'lps'),
	(463672, 102, '2015-04-01 00:39:03.000000', 'consum', 0.0230, 'lps'),
	(463673, 102, '2015-04-01 00:39:04.000000', 'consum', 0.0211, 'lps'),
	(463674, 102, '2015-04-01 00:39:05.000000', 'consum', 0.0219, 'lps'),
	(463675, 102, '2015-04-01 00:39:06.000000', 'consum', 0.0211, 'lps'),
	(463676, 102, '2015-04-01 00:39:07.000000', 'consum', 0.0228, 'lps'),
	(463677, 102, '2015-04-01 00:39:08.000000', 'consum', 0.0213, 'lps'),
	(463678, 102, '2015-04-01 00:39:09.000000', 'consum', 0.0217, 'lps'),
	(463679, 102, '2015-04-01 00:39:10.000000', 'consum', 0.0212, 'lps'),
	(463680, 102, '2015-04-01 00:39:11.000000', 'consum', 0.0222, 'lps'),
	(463681, 102, '2015-04-01 00:39:12.000000', 'consum', 0.0222, 'lps'),
	(463682, 102, '2015-04-01 00:39:13.000000', 'consum', 0.0215, 'lps'),
	(463683, 102, '2015-04-01 00:39:14.000000', 'consum', 0.0221, 'lps'),
	(463684, 102, '2015-04-01 00:39:15.000000', 'consum', 0.0229, 'lps'),
	(463685, 102, '2015-04-01 00:39:16.000000', 'consum', 0.0211, 'lps'),
	(463686, 102, '2015-04-01 00:39:17.000000', 'consum', 0.0220, 'lps'),
	(463687, 102, '2015-04-01 00:39:18.000000', 'consum', 0.0216, 'lps'),
	(463688, 102, '2015-04-01 00:39:19.000000', 'consum', 0.0210, 'lps'),
	(463689, 102, '2015-04-01 00:39:20.000000', 'consum', 0.0214, 'lps'),
	(463690, 102, '2015-04-01 00:39:21.000000', 'consum', 0.0211, 'lps'),
	(463691, 102, '2015-04-01 00:39:22.000000', 'consum', 0.0221, 'lps'),
	(463692, 102, '2015-04-01 00:39:23.000000', 'consum', 0.0224, 'lps'),
	(463693, 102, '2015-04-01 00:39:24.000000', 'consum', 0.0225, 'lps'),
	(463694, 102, '2015-04-01 00:39:25.000000', 'consum', 0.0221, 'lps'),
	(463695, 102, '2015-04-01 00:39:26.000000', 'consum', 0.0221, 'lps'),
	(463696, 102, '2015-04-01 00:39:27.000000', 'consum', 0.0213, 'lps'),
	(463697, 102, '2015-04-01 00:39:28.000000', 'consum', 0.0212, 'lps'),
	(463698, 102, '2015-04-01 00:39:29.000000', 'consum', 0.0212, 'lps'),
	(463699, 102, '2015-04-01 00:39:30.000000', 'consum', 0.0216, 'lps'),
	(463700, 102, '2015-04-01 00:39:31.000000', 'consum', 0.0213, 'lps'),
	(463701, 102, '2015-04-01 00:39:32.000000', 'consum', 0.0230, 'lps'),
	(463702, 102, '2015-04-01 00:39:33.000000', 'consum', 0.0215, 'lps'),
	(463703, 102, '2015-04-01 00:39:34.000000', 'consum', 0.0220, 'lps'),
	(463704, 102, '2015-04-01 00:39:35.000000', 'consum', 0.0224, 'lps'),
	(463705, 102, '2015-04-01 00:39:36.000000', 'consum', 0.0228, 'lps'),
	(463706, 102, '2015-04-01 00:39:37.000000', 'consum', 0.0218, 'lps'),
	(463707, 102, '2015-04-01 00:39:38.000000', 'consum', 0.0219, 'lps'),
	(463708, 102, '2015-04-01 00:39:39.000000', 'consum', 0.0228, 'lps'),
	(463709, 102, '2015-04-01 00:39:40.000000', 'consum', 0.0213, 'lps'),
	(463710, 102, '2015-04-01 00:39:41.000000', 'consum', 0.0212, 'lps'),
	(463711, 102, '2015-04-01 00:39:42.000000', 'consum', 0.0210, 'lps'),
	(463712, 102, '2015-04-01 00:39:43.000000', 'consum', 0.0227, 'lps'),
	(463713, 102, '2015-04-01 00:39:44.000000', 'consum', 0.0213, 'lps'),
	(463714, 102, '2015-04-01 00:39:45.000000', 'consum', 0.0217, 'lps'),
	(463715, 102, '2015-04-01 00:39:46.000000', 'consum', 0.0215, 'lps'),
	(463716, 102, '2015-04-01 00:39:47.000000', 'consum', 0.0216, 'lps'),
	(463717, 102, '2015-04-01 00:39:48.000000', 'consum', 0.0223, 'lps'),
	(463718, 102, '2015-04-01 00:39:49.000000', 'consum', 0.0218, 'lps'),
	(463719, 102, '2015-04-01 00:39:50.000000', 'consum', 0.0230, 'lps'),
	(463720, 102, '2015-04-01 00:39:51.000000', 'consum', 0.0226, 'lps'),
	(463721, 102, '2015-04-01 00:39:52.000000', 'consum', 0.0228, 'lps'),
	(463722, 102, '2015-04-01 00:39:53.000000', 'consum', 0.0210, 'lps'),
	(463723, 102, '2015-04-01 00:39:54.000000', 'consum', 0.0220, 'lps'),
	(463724, 102, '2015-04-01 00:39:55.000000', 'consum', 0.0218, 'lps'),
	(463725, 102, '2015-04-01 00:39:56.000000', 'consum', 0.0220, 'lps'),
	(463726, 102, '2015-04-01 00:39:57.000000', 'consum', 0.0214, 'lps'),
	(463727, 102, '2015-04-01 00:39:58.000000', 'consum', 0.0225, 'lps'),
	(463728, 102, '2015-04-01 00:39:59.000000', 'consum', 0.0230, 'lps'),
	(463729, 102, '2015-04-01 00:40:00.000000', 'consum', 0.0222, 'lps'),
	(463730, 102, '2015-04-01 00:40:01.000000', 'consum', 0.0211, 'lps'),
	(463731, 102, '2015-04-01 00:40:02.000000', 'consum', 0.0220, 'lps'),
	(463732, 102, '2015-04-01 00:40:03.000000', 'consum', 0.0217, 'lps'),
	(463733, 102, '2015-04-01 00:40:04.000000', 'consum', 0.0217, 'lps'),
	(463734, 102, '2015-04-01 00:40:05.000000', 'consum', 0.0224, 'lps'),
	(463735, 102, '2015-04-01 00:40:06.000000', 'consum', 0.0215, 'lps'),
	(463736, 102, '2015-04-01 00:40:07.000000', 'consum', 0.0218, 'lps'),
	(463737, 102, '2015-04-01 00:40:08.000000', 'consum', 0.0211, 'lps'),
	(463738, 102, '2015-04-01 00:40:09.000000', 'consum', 0.0216, 'lps'),
	(463739, 102, '2015-04-01 00:40:10.000000', 'consum', 0.0215, 'lps'),
	(463740, 102, '2015-04-01 00:40:11.000000', 'consum', 0.0217, 'lps'),
	(463741, 102, '2015-04-01 00:40:12.000000', 'consum', 0.0230, 'lps'),
	(463742, 102, '2015-04-01 00:40:13.000000', 'consum', 0.0227, 'lps'),
	(463743, 102, '2015-04-01 00:40:14.000000', 'consum', 0.0215, 'lps'),
	(463744, 102, '2015-04-01 00:40:15.000000', 'consum', 0.0225, 'lps'),
	(463745, 102, '2015-04-01 00:40:16.000000', 'consum', 0.0210, 'lps'),
	(463746, 102, '2015-04-01 00:40:17.000000', 'consum', 0.0226, 'lps'),
	(463747, 102, '2015-04-01 00:40:18.000000', 'consum', 0.0230, 'lps'),
	(463748, 102, '2015-04-01 00:40:19.000000', 'consum', 0.0220, 'lps'),
	(463749, 102, '2015-04-01 00:40:20.000000', 'consum', 0.0221, 'lps'),
	(463750, 102, '2015-04-01 00:40:21.000000', 'consum', 0.0214, 'lps'),
	(463751, 102, '2015-04-01 00:40:22.000000', 'consum', 0.0219, 'lps'),
	(463752, 102, '2015-04-01 00:40:23.000000', 'consum', 0.0221, 'lps'),
	(463753, 102, '2015-04-01 00:40:24.000000', 'consum', 0.0220, 'lps'),
	(463754, 102, '2015-04-01 00:40:25.000000', 'consum', 0.0227, 'lps'),
	(463755, 102, '2015-04-01 00:40:26.000000', 'consum', 0.0223, 'lps'),
	(463756, 102, '2015-04-01 00:40:27.000000', 'consum', 0.0224, 'lps'),
	(463757, 102, '2015-04-01 00:40:28.000000', 'consum', 0.0220, 'lps'),
	(463758, 102, '2015-04-01 00:40:29.000000', 'consum', 0.0218, 'lps'),
	(463759, 102, '2015-04-01 00:40:30.000000', 'consum', 0.0221, 'lps'),
	(463760, 102, '2015-04-01 00:40:31.000000', 'consum', 0.0220, 'lps'),
	(463761, 102, '2015-04-01 00:40:32.000000', 'consum', 0.0230, 'lps'),
	(463762, 102, '2015-04-01 00:40:33.000000', 'consum', 0.0216, 'lps'),
	(463763, 102, '2015-04-01 00:40:34.000000', 'consum', 0.0223, 'lps'),
	(463764, 102, '2015-04-01 00:40:35.000000', 'consum', 0.0214, 'lps'),
	(463765, 102, '2015-04-01 00:40:36.000000', 'consum', 0.0212, 'lps'),
	(463766, 102, '2015-04-01 00:40:37.000000', 'consum', 0.0229, 'lps'),
	(463767, 102, '2015-04-01 00:40:38.000000', 'consum', 0.0217, 'lps'),
	(463768, 102, '2015-04-01 00:40:39.000000', 'consum', 0.0210, 'lps'),
	(463769, 102, '2015-04-01 00:40:40.000000', 'consum', 0.0229, 'lps'),
	(463770, 102, '2015-04-01 00:40:41.000000', 'consum', 0.0225, 'lps'),
	(463771, 102, '2015-04-01 00:40:42.000000', 'consum', 0.0225, 'lps'),
	(463772, 102, '2015-04-01 00:40:43.000000', 'consum', 0.0222, 'lps'),
	(463773, 102, '2015-04-01 00:40:44.000000', 'consum', 0.0225, 'lps'),
	(463774, 102, '2015-04-01 00:40:45.000000', 'consum', 0.0229, 'lps'),
	(463775, 102, '2015-04-01 00:40:46.000000', 'consum', 0.0218, 'lps'),
	(463776, 102, '2015-04-01 00:40:47.000000', 'consum', 0.0213, 'lps'),
	(463777, 102, '2015-04-01 00:40:48.000000', 'consum', 0.0221, 'lps'),
	(463778, 102, '2015-04-01 00:40:49.000000', 'consum', 0.0218, 'lps'),
	(463779, 102, '2015-04-01 00:40:50.000000', 'consum', 0.0216, 'lps'),
	(463780, 102, '2015-04-01 00:40:51.000000', 'consum', 0.0219, 'lps'),
	(463781, 102, '2015-04-01 00:40:52.000000', 'consum', 0.0213, 'lps'),
	(463782, 102, '2015-04-01 00:40:53.000000', 'consum', 0.0222, 'lps'),
	(463783, 102, '2015-04-01 00:40:54.000000', 'consum', 0.0220, 'lps'),
	(463784, 102, '2015-04-01 00:40:55.000000', 'consum', 0.0222, 'lps'),
	(463785, 102, '2015-04-01 00:40:56.000000', 'consum', 0.0219, 'lps'),
	(463786, 102, '2015-04-01 00:40:57.000000', 'consum', 0.0219, 'lps'),
	(463787, 102, '2015-04-01 00:40:58.000000', 'consum', 0.0230, 'lps'),
	(463788, 102, '2015-04-01 00:40:59.000000', 'consum', 0.0221, 'lps'),
	(463789, 102, '2015-04-01 00:41:00.000000', 'consum', 0.0225, 'lps'),
	(463790, 102, '2015-04-01 00:41:01.000000', 'consum', 0.0210, 'lps'),
	(463791, 102, '2015-04-01 00:41:02.000000', 'consum', 0.0228, 'lps'),
	(463792, 102, '2015-04-01 00:41:03.000000', 'consum', 0.0216, 'lps'),
	(463793, 102, '2015-04-01 00:41:04.000000', 'consum', 0.0228, 'lps'),
	(463794, 102, '2015-04-01 00:41:05.000000', 'consum', 0.0218, 'lps'),
	(463795, 102, '2015-04-01 00:41:06.000000', 'consum', 0.0221, 'lps'),
	(463796, 102, '2015-04-01 00:41:07.000000', 'consum', 0.0220, 'lps'),
	(463797, 102, '2015-04-01 00:41:08.000000', 'consum', 0.0229, 'lps'),
	(463798, 102, '2015-04-01 00:41:09.000000', 'consum', 0.0230, 'lps'),
	(463799, 102, '2015-04-01 00:41:10.000000', 'consum', 0.0215, 'lps'),
	(463800, 102, '2015-04-01 00:41:11.000000', 'consum', 0.0214, 'lps'),
	(463801, 102, '2015-04-01 00:41:12.000000', 'consum', 0.0217, 'lps'),
	(463802, 102, '2015-04-01 00:41:13.000000', 'consum', 0.0211, 'lps'),
	(463803, 102, '2015-04-01 00:41:14.000000', 'consum', 0.0219, 'lps'),
	(463804, 102, '2015-04-01 00:41:15.000000', 'consum', 0.0228, 'lps'),
	(463805, 102, '2015-04-01 00:41:16.000000', 'consum', 0.0213, 'lps'),
	(463806, 102, '2015-04-01 00:41:17.000000', 'consum', 0.0211, 'lps'),
	(463807, 102, '2015-04-01 00:41:18.000000', 'consum', 0.0229, 'lps'),
	(463808, 102, '2015-04-01 00:41:19.000000', 'consum', 0.0218, 'lps'),
	(463809, 102, '2015-04-01 00:41:20.000000', 'consum', 0.0215, 'lps'),
	(463810, 102, '2015-04-01 00:41:21.000000', 'consum', 0.0213, 'lps'),
	(463811, 102, '2015-04-01 00:41:22.000000', 'consum', 0.0228, 'lps'),
	(463812, 102, '2015-04-01 00:41:23.000000', 'consum', 0.0210, 'lps'),
	(463813, 102, '2015-04-01 00:41:24.000000', 'consum', 0.0220, 'lps'),
	(463814, 102, '2015-04-01 00:41:25.000000', 'consum', 0.0219, 'lps'),
	(463815, 102, '2015-04-01 00:41:26.000000', 'consum', 0.0226, 'lps'),
	(463816, 102, '2015-04-01 00:41:27.000000', 'consum', 0.0219, 'lps'),
	(463817, 102, '2015-04-01 00:41:28.000000', 'consum', 0.0229, 'lps'),
	(463818, 102, '2015-04-01 00:41:29.000000', 'consum', 0.0215, 'lps'),
	(463819, 102, '2015-04-01 00:41:30.000000', 'consum', 0.0220, 'lps'),
	(463820, 102, '2015-04-01 00:41:31.000000', 'consum', 0.0224, 'lps'),
	(463821, 102, '2015-04-01 00:41:32.000000', 'consum', 0.0210, 'lps'),
	(463822, 102, '2015-04-01 00:41:33.000000', 'consum', 0.0230, 'lps'),
	(463823, 102, '2015-04-01 00:41:34.000000', 'consum', 0.0226, 'lps'),
	(463824, 102, '2015-04-01 00:41:35.000000', 'consum', 0.0210, 'lps'),
	(463825, 102, '2015-04-01 00:41:36.000000', 'consum', 0.0227, 'lps'),
	(463826, 102, '2015-04-01 00:41:37.000000', 'consum', 0.0212, 'lps'),
	(463827, 102, '2015-04-01 00:41:38.000000', 'consum', 0.0230, 'lps'),
	(463828, 102, '2015-04-01 00:41:39.000000', 'consum', 0.0222, 'lps'),
	(463829, 102, '2015-04-01 00:41:40.000000', 'consum', 0.0212, 'lps'),
	(463830, 102, '2015-04-01 00:41:41.000000', 'consum', 0.0224, 'lps'),
	(463831, 102, '2015-04-01 00:41:42.000000', 'consum', 0.0214, 'lps'),
	(463832, 102, '2015-04-01 00:41:43.000000', 'consum', 0.0230, 'lps'),
	(463833, 102, '2015-04-01 00:41:44.000000', 'consum', 0.0216, 'lps'),
	(463834, 102, '2015-04-01 00:41:45.000000', 'consum', 0.0220, 'lps'),
	(463835, 102, '2015-04-01 00:41:46.000000', 'consum', 0.0223, 'lps'),
	(463836, 102, '2015-04-01 00:41:47.000000', 'consum', 0.0223, 'lps'),
	(463837, 102, '2015-04-01 00:41:48.000000', 'consum', 0.0216, 'lps'),
	(463838, 102, '2015-04-01 00:41:49.000000', 'consum', 0.0224, 'lps'),
	(463839, 102, '2015-04-01 00:41:50.000000', 'consum', 0.0218, 'lps'),
	(463840, 102, '2015-04-01 00:41:51.000000', 'consum', 0.0229, 'lps'),
	(463841, 102, '2015-04-01 00:41:52.000000', 'consum', 0.0217, 'lps'),
	(463842, 102, '2015-04-01 00:41:53.000000', 'consum', 0.0213, 'lps'),
	(463843, 102, '2015-04-01 00:41:54.000000', 'consum', 0.0226, 'lps'),
	(463844, 102, '2015-04-01 00:41:55.000000', 'consum', 0.0215, 'lps'),
	(463845, 102, '2015-04-01 00:41:56.000000', 'consum', 0.0212, 'lps'),
	(463846, 102, '2015-04-01 00:41:57.000000', 'consum', 0.0226, 'lps'),
	(463847, 102, '2015-04-01 00:41:58.000000', 'consum', 0.0220, 'lps'),
	(463848, 102, '2015-04-01 00:41:59.000000', 'consum', 0.0211, 'lps'),
	(463849, 102, '2015-04-01 00:42:00.000000', 'consum', 0.0230, 'lps'),
	(463850, 102, '2015-04-01 00:42:01.000000', 'consum', 0.0222, 'lps'),
	(463851, 102, '2015-04-01 00:42:02.000000', 'consum', 0.0210, 'lps'),
	(463852, 102, '2015-04-01 00:42:03.000000', 'consum', 0.0219, 'lps'),
	(463853, 102, '2015-04-01 00:42:04.000000', 'consum', 0.0213, 'lps'),
	(463854, 102, '2015-04-01 00:42:05.000000', 'consum', 0.0219, 'lps'),
	(463855, 102, '2015-04-01 00:42:06.000000', 'consum', 0.0225, 'lps'),
	(463856, 102, '2015-04-01 00:42:07.000000', 'consum', 0.0216, 'lps'),
	(463857, 102, '2015-04-01 00:42:08.000000', 'consum', 0.0217, 'lps'),
	(463858, 102, '2015-04-01 00:42:09.000000', 'consum', 0.0229, 'lps'),
	(463859, 102, '2015-04-01 00:42:10.000000', 'consum', 0.0219, 'lps'),
	(463860, 102, '2015-04-01 00:42:11.000000', 'consum', 0.0218, 'lps'),
	(463861, 102, '2015-04-01 00:42:12.000000', 'consum', 0.0227, 'lps'),
	(463862, 102, '2015-04-01 00:42:13.000000', 'consum', 0.0229, 'lps'),
	(463863, 102, '2015-04-01 00:42:14.000000', 'consum', 0.0210, 'lps'),
	(463864, 102, '2015-04-01 00:42:15.000000', 'consum', 0.0219, 'lps'),
	(463865, 102, '2015-04-01 00:42:16.000000', 'consum', 0.0212, 'lps'),
	(463866, 102, '2015-04-01 00:42:17.000000', 'consum', 0.0214, 'lps'),
	(463867, 102, '2015-04-01 00:42:18.000000', 'consum', 0.0224, 'lps'),
	(463868, 102, '2015-04-01 00:42:19.000000', 'consum', 0.0228, 'lps'),
	(463869, 102, '2015-04-01 00:42:20.000000', 'consum', 0.0215, 'lps'),
	(463870, 102, '2015-04-01 00:42:21.000000', 'consum', 0.0222, 'lps'),
	(463871, 102, '2015-04-01 00:42:22.000000', 'consum', 0.0217, 'lps'),
	(463872, 102, '2015-04-01 00:42:23.000000', 'consum', 0.0227, 'lps'),
	(463873, 102, '2015-04-01 00:42:24.000000', 'consum', 0.0214, 'lps'),
	(463874, 102, '2015-04-01 00:42:25.000000', 'consum', 0.0222, 'lps'),
	(463875, 102, '2015-04-01 00:42:26.000000', 'consum', 0.0216, 'lps'),
	(463876, 102, '2015-04-01 00:42:27.000000', 'consum', 0.0225, 'lps'),
	(463877, 102, '2015-04-01 00:42:28.000000', 'consum', 0.0228, 'lps'),
	(463878, 102, '2015-04-01 00:42:29.000000', 'consum', 0.0210, 'lps'),
	(463879, 102, '2015-04-01 00:42:30.000000', 'consum', 0.0220, 'lps'),
	(463880, 102, '2015-04-01 00:42:31.000000', 'consum', 0.0221, 'lps'),
	(463881, 102, '2015-04-01 00:42:32.000000', 'consum', 0.0212, 'lps'),
	(463882, 102, '2015-04-01 00:42:33.000000', 'consum', 0.0211, 'lps'),
	(463883, 102, '2015-04-01 00:42:34.000000', 'consum', 0.0228, 'lps'),
	(463884, 102, '2015-04-01 00:42:35.000000', 'consum', 0.0214, 'lps'),
	(463885, 102, '2015-04-01 00:42:36.000000', 'consum', 0.0221, 'lps'),
	(463886, 102, '2015-04-01 00:42:37.000000', 'consum', 0.0230, 'lps'),
	(463887, 102, '2015-04-01 00:42:38.000000', 'consum', 0.0215, 'lps'),
	(463888, 102, '2015-04-01 00:42:39.000000', 'consum', 0.0219, 'lps'),
	(463889, 102, '2015-04-01 00:42:40.000000', 'consum', 0.0218, 'lps'),
	(463890, 102, '2015-04-01 00:42:41.000000', 'consum', 0.0224, 'lps'),
	(463891, 102, '2015-04-01 00:42:42.000000', 'consum', 0.0216, 'lps'),
	(463892, 102, '2015-04-01 00:42:43.000000', 'consum', 0.0220, 'lps'),
	(463893, 102, '2015-04-01 00:42:44.000000', 'consum', 0.0219, 'lps'),
	(463894, 102, '2015-04-01 00:42:45.000000', 'consum', 0.0228, 'lps'),
	(463895, 102, '2015-04-01 00:42:46.000000', 'consum', 0.0210, 'lps'),
	(463896, 102, '2015-04-01 00:42:47.000000', 'consum', 0.0220, 'lps'),
	(463897, 102, '2015-04-01 00:42:48.000000', 'consum', 0.0219, 'lps'),
	(463898, 102, '2015-04-01 00:42:49.000000', 'consum', 0.0223, 'lps'),
	(463899, 102, '2015-04-01 00:42:50.000000', 'consum', 0.0229, 'lps'),
	(463900, 102, '2015-04-01 00:42:51.000000', 'consum', 0.0225, 'lps'),
	(463901, 102, '2015-04-01 00:42:52.000000', 'consum', 0.0230, 'lps'),
	(463902, 102, '2015-04-01 00:42:53.000000', 'consum', 0.0221, 'lps'),
	(463903, 102, '2015-04-01 00:42:54.000000', 'consum', 0.0227, 'lps'),
	(463904, 102, '2015-04-01 00:42:55.000000', 'consum', 0.0219, 'lps'),
	(463905, 102, '2015-04-01 00:42:56.000000', 'consum', 0.0226, 'lps'),
	(463906, 102, '2015-04-01 00:42:57.000000', 'consum', 0.0223, 'lps'),
	(463907, 102, '2015-04-01 00:42:58.000000', 'consum', 0.0225, 'lps'),
	(463908, 102, '2015-04-01 00:42:59.000000', 'consum', 0.0226, 'lps'),
	(463909, 102, '2015-04-01 00:43:00.000000', 'consum', 0.0223, 'lps'),
	(463910, 102, '2015-04-01 00:43:01.000000', 'consum', 0.0229, 'lps'),
	(463911, 102, '2015-04-01 00:43:02.000000', 'consum', 0.0223, 'lps'),
	(463912, 102, '2015-04-01 00:43:03.000000', 'consum', 0.0219, 'lps'),
	(463913, 102, '2015-04-01 00:43:04.000000', 'consum', 0.0215, 'lps'),
	(463914, 102, '2015-04-01 00:43:05.000000', 'consum', 0.0230, 'lps'),
	(463915, 102, '2015-04-01 00:43:06.000000', 'consum', 0.0212, 'lps'),
	(463916, 102, '2015-04-01 00:43:07.000000', 'consum', 0.0222, 'lps'),
	(463917, 102, '2015-04-01 00:43:08.000000', 'consum', 0.0222, 'lps'),
	(463918, 102, '2015-04-01 00:43:09.000000', 'consum', 0.0214, 'lps'),
	(463919, 102, '2015-04-01 00:43:10.000000', 'consum', 0.0214, 'lps'),
	(463920, 102, '2015-04-01 00:43:11.000000', 'consum', 0.0221, 'lps'),
	(463921, 102, '2015-04-01 00:43:12.000000', 'consum', 0.0230, 'lps'),
	(463922, 102, '2015-04-01 00:43:13.000000', 'consum', 0.0215, 'lps'),
	(463923, 102, '2015-04-01 00:43:14.000000', 'consum', 0.0216, 'lps'),
	(463924, 102, '2015-04-01 00:43:15.000000', 'consum', 0.0226, 'lps'),
	(463925, 102, '2015-04-01 00:43:16.000000', 'consum', 0.0211, 'lps'),
	(463926, 102, '2015-04-01 00:43:17.000000', 'consum', 0.0228, 'lps'),
	(463927, 102, '2015-04-01 00:43:18.000000', 'consum', 0.0217, 'lps'),
	(463928, 102, '2015-04-01 00:43:19.000000', 'consum', 0.0211, 'lps'),
	(463929, 102, '2015-04-01 00:43:20.000000', 'consum', 0.0214, 'lps'),
	(463930, 102, '2015-04-01 00:43:21.000000', 'consum', 0.0228, 'lps'),
	(463931, 102, '2015-04-01 00:43:22.000000', 'consum', 0.0224, 'lps'),
	(463932, 102, '2015-04-01 00:43:23.000000', 'consum', 0.0229, 'lps'),
	(463933, 102, '2015-04-01 00:43:24.000000', 'consum', 0.0220, 'lps'),
	(463934, 102, '2015-04-01 00:43:25.000000', 'consum', 0.0225, 'lps'),
	(463935, 102, '2015-04-01 00:43:26.000000', 'consum', 0.0215, 'lps'),
	(463936, 102, '2015-04-01 00:43:27.000000', 'consum', 0.0230, 'lps'),
	(463937, 102, '2015-04-01 00:43:28.000000', 'consum', 0.0213, 'lps'),
	(463938, 102, '2015-04-01 00:43:29.000000', 'consum', 0.0226, 'lps'),
	(463939, 102, '2015-04-01 00:43:30.000000', 'consum', 0.0220, 'lps'),
	(463940, 102, '2015-04-01 00:43:31.000000', 'consum', 0.0213, 'lps'),
	(463941, 102, '2015-04-01 00:43:32.000000', 'consum', 0.0217, 'lps'),
	(463942, 102, '2015-04-01 00:43:33.000000', 'consum', 0.0213, 'lps'),
	(463943, 102, '2015-04-01 00:43:34.000000', 'consum', 0.0226, 'lps'),
	(463944, 102, '2015-04-01 00:43:35.000000', 'consum', 0.0220, 'lps'),
	(463945, 102, '2015-04-01 00:43:36.000000', 'consum', 0.0211, 'lps'),
	(463946, 102, '2015-04-01 00:43:37.000000', 'consum', 0.0226, 'lps'),
	(463947, 102, '2015-04-01 00:43:38.000000', 'consum', 0.0227, 'lps'),
	(463948, 102, '2015-04-01 00:43:39.000000', 'consum', 0.0226, 'lps'),
	(463949, 102, '2015-04-01 00:43:40.000000', 'consum', 0.0217, 'lps'),
	(463950, 102, '2015-04-01 00:43:41.000000', 'consum', 0.0220, 'lps'),
	(463951, 102, '2015-04-01 00:43:42.000000', 'consum', 0.0216, 'lps'),
	(463952, 102, '2015-04-01 00:43:43.000000', 'consum', 0.0213, 'lps'),
	(463953, 102, '2015-04-01 00:43:44.000000', 'consum', 0.0226, 'lps'),
	(463954, 102, '2015-04-01 00:43:45.000000', 'consum', 0.0220, 'lps'),
	(463955, 102, '2015-04-01 00:43:46.000000', 'consum', 0.0211, 'lps'),
	(463956, 102, '2015-04-01 00:43:47.000000', 'consum', 0.0229, 'lps'),
	(463957, 102, '2015-04-01 00:43:48.000000', 'consum', 0.0219, 'lps'),
	(463958, 102, '2015-04-01 00:43:49.000000', 'consum', 0.0219, 'lps'),
	(463959, 102, '2015-04-01 00:43:50.000000', 'consum', 0.0229, 'lps'),
	(463960, 102, '2015-04-01 00:43:51.000000', 'consum', 0.0213, 'lps'),
	(463961, 102, '2015-04-01 00:43:52.000000', 'consum', 0.0213, 'lps'),
	(463962, 102, '2015-04-01 00:43:53.000000', 'consum', 0.0215, 'lps'),
	(463963, 102, '2015-04-01 00:43:54.000000', 'consum', 0.0227, 'lps'),
	(463964, 102, '2015-04-01 00:43:55.000000', 'consum', 0.0216, 'lps'),
	(463965, 102, '2015-04-01 00:43:56.000000', 'consum', 0.0213, 'lps'),
	(463966, 102, '2015-04-01 00:43:57.000000', 'consum', 0.0229, 'lps'),
	(463967, 102, '2015-04-01 00:43:58.000000', 'consum', 0.0212, 'lps'),
	(463968, 102, '2015-04-01 00:43:59.000000', 'consum', 0.0227, 'lps'),
	(463969, 102, '2015-04-01 00:44:00.000000', 'consum', 0.0226, 'lps'),
	(463970, 102, '2015-04-01 00:44:01.000000', 'consum', 0.0219, 'lps'),
	(463971, 102, '2015-04-01 00:44:02.000000', 'consum', 0.0230, 'lps'),
	(463972, 102, '2015-04-01 00:44:03.000000', 'consum', 0.0218, 'lps'),
	(463973, 102, '2015-04-01 00:44:04.000000', 'consum', 0.0213, 'lps'),
	(463974, 102, '2015-04-01 00:44:05.000000', 'consum', 0.0224, 'lps'),
	(463975, 102, '2015-04-01 00:44:06.000000', 'consum', 0.0228, 'lps'),
	(463976, 102, '2015-04-01 00:44:07.000000', 'consum', 0.0216, 'lps'),
	(463977, 102, '2015-04-01 00:44:08.000000', 'consum', 0.0227, 'lps'),
	(463978, 102, '2015-04-01 00:44:09.000000', 'consum', 0.0215, 'lps'),
	(463979, 102, '2015-04-01 00:44:10.000000', 'consum', 0.0227, 'lps'),
	(463980, 102, '2015-04-01 00:44:11.000000', 'consum', 0.0218, 'lps'),
	(463981, 102, '2015-04-01 00:44:12.000000', 'consum', 0.0222, 'lps'),
	(463982, 102, '2015-04-01 00:44:13.000000', 'consum', 0.0223, 'lps'),
	(463983, 102, '2015-04-01 00:44:14.000000', 'consum', 0.0221, 'lps'),
	(463984, 102, '2015-04-01 00:44:15.000000', 'consum', 0.0224, 'lps'),
	(463985, 102, '2015-04-01 00:44:16.000000', 'consum', 0.0228, 'lps'),
	(463986, 102, '2015-04-01 00:44:17.000000', 'consum', 0.0215, 'lps'),
	(463987, 102, '2015-04-01 00:44:18.000000', 'consum', 0.0225, 'lps'),
	(463988, 102, '2015-04-01 00:44:19.000000', 'consum', 0.0230, 'lps'),
	(463989, 102, '2015-04-01 00:44:20.000000', 'consum', 0.0220, 'lps'),
	(463990, 102, '2015-04-01 00:44:21.000000', 'consum', 0.0223, 'lps'),
	(463991, 102, '2015-04-01 00:44:22.000000', 'consum', 0.0224, 'lps'),
	(463992, 102, '2015-04-01 00:44:23.000000', 'consum', 0.0223, 'lps'),
	(463993, 102, '2015-04-01 00:44:24.000000', 'consum', 0.0210, 'lps'),
	(463994, 102, '2015-04-01 00:44:25.000000', 'consum', 0.0215, 'lps'),
	(463995, 102, '2015-04-01 00:44:26.000000', 'consum', 0.0213, 'lps'),
	(463996, 102, '2015-04-01 00:44:27.000000', 'consum', 0.0212, 'lps'),
	(463997, 102, '2015-04-01 00:44:28.000000', 'consum', 0.0230, 'lps'),
	(463998, 102, '2015-04-01 00:44:29.000000', 'consum', 0.0221, 'lps'),
	(463999, 102, '2015-04-01 00:44:30.000000', 'consum', 0.0227, 'lps'),
	(464000, 102, '2015-04-01 00:44:31.000000', 'consum', 0.0219, 'lps'),
	(464001, 102, '2015-04-01 00:44:32.000000', 'consum', 0.0226, 'lps'),
	(464002, 102, '2015-04-01 00:44:33.000000', 'consum', 0.0221, 'lps'),
	(464003, 102, '2015-04-01 00:44:34.000000', 'consum', 0.0219, 'lps'),
	(464004, 102, '2015-04-01 00:44:35.000000', 'consum', 0.0222, 'lps'),
	(464005, 102, '2015-04-01 00:44:36.000000', 'consum', 0.0221, 'lps'),
	(464006, 102, '2015-04-01 00:44:37.000000', 'consum', 0.0230, 'lps'),
	(464007, 102, '2015-04-01 00:44:38.000000', 'consum', 0.0215, 'lps'),
	(464008, 102, '2015-04-01 00:44:39.000000', 'consum', 0.0217, 'lps'),
	(464009, 102, '2015-04-01 00:44:40.000000', 'consum', 0.0230, 'lps'),
	(464010, 102, '2015-04-01 00:44:41.000000', 'consum', 0.0226, 'lps'),
	(464011, 102, '2015-04-01 00:44:42.000000', 'consum', 0.0212, 'lps'),
	(464012, 102, '2015-04-01 00:44:43.000000', 'consum', 0.0214, 'lps'),
	(464013, 102, '2015-04-01 00:44:44.000000', 'consum', 0.0223, 'lps'),
	(464014, 102, '2015-04-01 00:44:45.000000', 'consum', 0.0221, 'lps'),
	(464015, 102, '2015-04-01 00:44:46.000000', 'consum', 0.0227, 'lps'),
	(464016, 102, '2015-04-01 00:44:47.000000', 'consum', 0.0221, 'lps'),
	(464017, 102, '2015-04-01 00:44:48.000000', 'consum', 0.0213, 'lps'),
	(464018, 102, '2015-04-01 00:44:49.000000', 'consum', 0.0213, 'lps'),
	(464019, 102, '2015-04-01 00:44:50.000000', 'consum', 0.0219, 'lps'),
	(464020, 102, '2015-04-01 00:44:51.000000', 'consum', 0.0226, 'lps'),
	(464021, 102, '2015-04-01 00:44:52.000000', 'consum', 0.0221, 'lps'),
	(464022, 102, '2015-04-01 00:44:53.000000', 'consum', 0.0219, 'lps'),
	(464023, 102, '2015-04-01 00:44:54.000000', 'consum', 0.0220, 'lps'),
	(464024, 102, '2015-04-01 00:44:55.000000', 'consum', 0.0215, 'lps'),
	(464025, 102, '2015-04-01 00:44:56.000000', 'consum', 0.0226, 'lps'),
	(464026, 102, '2015-04-01 00:44:57.000000', 'consum', 0.0211, 'lps'),
	(464027, 102, '2015-04-01 00:44:58.000000', 'consum', 0.0211, 'lps'),
	(464028, 102, '2015-04-01 00:44:59.000000', 'consum', 0.0213, 'lps'),
	(464029, 102, '2015-04-01 00:45:00.000000', 'consum', 0.0223, 'lps'),
	(464030, 102, '2015-04-01 00:45:01.000000', 'consum', 0.0223, 'lps'),
	(464031, 102, '2015-04-01 00:45:02.000000', 'consum', 0.0216, 'lps'),
	(464032, 102, '2015-04-01 00:45:03.000000', 'consum', 0.0221, 'lps'),
	(464033, 102, '2015-04-01 00:45:04.000000', 'consum', 0.0229, 'lps'),
	(464034, 102, '2015-04-01 00:45:05.000000', 'consum', 0.0229, 'lps'),
	(464035, 102, '2015-04-01 00:45:06.000000', 'consum', 0.0227, 'lps'),
	(464036, 102, '2015-04-01 00:45:07.000000', 'consum', 0.0219, 'lps'),
	(464037, 102, '2015-04-01 00:45:08.000000', 'consum', 0.0224, 'lps'),
	(464038, 102, '2015-04-01 00:45:09.000000', 'consum', 0.0212, 'lps'),
	(464039, 102, '2015-04-01 00:45:10.000000', 'consum', 0.0222, 'lps'),
	(464040, 102, '2015-04-01 00:45:11.000000', 'consum', 0.0223, 'lps'),
	(464041, 102, '2015-04-01 00:45:12.000000', 'consum', 0.0216, 'lps'),
	(464042, 102, '2015-04-01 00:45:13.000000', 'consum', 0.0225, 'lps'),
	(464043, 102, '2015-04-01 00:45:14.000000', 'consum', 0.0226, 'lps'),
	(464044, 102, '2015-04-01 00:45:15.000000', 'consum', 0.0221, 'lps'),
	(464045, 102, '2015-04-01 00:45:16.000000', 'consum', 0.0221, 'lps'),
	(464046, 102, '2015-04-01 00:45:17.000000', 'consum', 0.0230, 'lps'),
	(464047, 102, '2015-04-01 00:45:18.000000', 'consum', 0.0216, 'lps'),
	(464048, 102, '2015-04-01 00:45:19.000000', 'consum', 0.0220, 'lps'),
	(464049, 102, '2015-04-01 00:45:20.000000', 'consum', 0.0223, 'lps'),
	(464050, 102, '2015-04-01 00:45:21.000000', 'consum', 0.0224, 'lps'),
	(464051, 102, '2015-04-01 00:45:22.000000', 'consum', 0.0219, 'lps'),
	(464052, 102, '2015-04-01 00:45:23.000000', 'consum', 0.0214, 'lps'),
	(464053, 102, '2015-04-01 00:45:24.000000', 'consum', 0.0224, 'lps'),
	(464054, 102, '2015-04-01 00:45:25.000000', 'consum', 0.0228, 'lps'),
	(464055, 102, '2015-04-01 00:45:26.000000', 'consum', 0.0216, 'lps'),
	(464056, 102, '2015-04-01 00:45:27.000000', 'consum', 0.0227, 'lps'),
	(464057, 102, '2015-04-01 00:45:28.000000', 'consum', 0.0217, 'lps'),
	(464058, 102, '2015-04-01 00:45:29.000000', 'consum', 0.0214, 'lps'),
	(464059, 102, '2015-04-01 00:45:30.000000', 'consum', 0.0211, 'lps'),
	(464060, 102, '2015-04-01 00:45:31.000000', 'consum', 0.0225, 'lps'),
	(464061, 102, '2015-04-01 00:45:32.000000', 'consum', 0.0219, 'lps'),
	(464062, 102, '2015-04-01 00:45:33.000000', 'consum', 0.0210, 'lps'),
	(464063, 102, '2015-04-01 00:45:34.000000', 'consum', 0.0225, 'lps'),
	(464064, 102, '2015-04-01 00:45:35.000000', 'consum', 0.0223, 'lps'),
	(464065, 102, '2015-04-01 00:45:36.000000', 'consum', 0.0229, 'lps'),
	(464066, 102, '2015-04-01 00:45:37.000000', 'consum', 0.0227, 'lps'),
	(464067, 102, '2015-04-01 00:45:38.000000', 'consum', 0.0217, 'lps'),
	(464068, 102, '2015-04-01 00:45:39.000000', 'consum', 0.0214, 'lps'),
	(464069, 102, '2015-04-01 00:45:40.000000', 'consum', 0.0230, 'lps'),
	(464070, 102, '2015-04-01 00:45:41.000000', 'consum', 0.0214, 'lps'),
	(464071, 102, '2015-04-01 00:45:42.000000', 'consum', 0.0215, 'lps'),
	(464072, 102, '2015-04-01 00:45:43.000000', 'consum', 0.0222, 'lps'),
	(464073, 102, '2015-04-01 00:45:44.000000', 'consum', 0.0216, 'lps'),
	(464074, 102, '2015-04-01 00:45:45.000000', 'consum', 0.0223, 'lps'),
	(464075, 102, '2015-04-01 00:45:46.000000', 'consum', 0.0215, 'lps'),
	(464076, 102, '2015-04-01 00:45:47.000000', 'consum', 0.0217, 'lps'),
	(464077, 102, '2015-04-01 00:45:48.000000', 'consum', 0.0211, 'lps'),
	(464078, 102, '2015-04-01 00:45:49.000000', 'consum', 0.0214, 'lps'),
	(464079, 102, '2015-04-01 00:45:50.000000', 'consum', 0.0227, 'lps'),
	(464080, 102, '2015-04-01 00:45:51.000000', 'consum', 0.0221, 'lps'),
	(464081, 102, '2015-04-01 00:45:52.000000', 'consum', 0.0216, 'lps'),
	(464082, 102, '2015-04-01 00:45:53.000000', 'consum', 0.0230, 'lps'),
	(464083, 102, '2015-04-01 00:45:54.000000', 'consum', 0.0227, 'lps'),
	(464084, 102, '2015-04-01 00:45:55.000000', 'consum', 0.0213, 'lps'),
	(464085, 102, '2015-04-01 00:45:56.000000', 'consum', 0.0218, 'lps'),
	(464086, 102, '2015-04-01 00:45:57.000000', 'consum', 0.0222, 'lps'),
	(464087, 102, '2015-04-01 00:45:58.000000', 'consum', 0.0226, 'lps'),
	(464088, 102, '2015-04-01 00:45:59.000000', 'consum', 0.0213, 'lps'),
	(464089, 102, '2015-04-01 00:46:00.000000', 'consum', 0.0218, 'lps'),
	(464090, 102, '2015-04-01 00:46:01.000000', 'consum', 0.0220, 'lps'),
	(464091, 102, '2015-04-01 00:46:02.000000', 'consum', 0.0215, 'lps'),
	(464092, 102, '2015-04-01 00:46:03.000000', 'consum', 0.0229, 'lps'),
	(464093, 102, '2015-04-01 00:46:04.000000', 'consum', 0.0225, 'lps'),
	(464094, 102, '2015-04-01 00:46:05.000000', 'consum', 0.0210, 'lps'),
	(464095, 102, '2015-04-01 00:46:06.000000', 'consum', 0.0228, 'lps'),
	(464096, 102, '2015-04-01 00:46:07.000000', 'consum', 0.0216, 'lps'),
	(464097, 102, '2015-04-01 00:46:08.000000', 'consum', 0.0229, 'lps'),
	(464098, 102, '2015-04-01 00:46:09.000000', 'consum', 0.0225, 'lps'),
	(464099, 102, '2015-04-01 00:46:10.000000', 'consum', 0.0230, 'lps'),
	(464100, 102, '2015-04-01 00:46:11.000000', 'consum', 0.0222, 'lps'),
	(464101, 102, '2015-04-01 00:46:12.000000', 'consum', 0.0211, 'lps'),
	(464102, 102, '2015-04-01 00:46:13.000000', 'consum', 0.0223, 'lps'),
	(464103, 102, '2015-04-01 00:46:14.000000', 'consum', 0.0228, 'lps'),
	(464104, 102, '2015-04-01 00:46:15.000000', 'consum', 0.0221, 'lps'),
	(464105, 102, '2015-04-01 00:46:16.000000', 'consum', 0.0212, 'lps'),
	(464106, 102, '2015-04-01 00:46:17.000000', 'consum', 0.0229, 'lps'),
	(464107, 102, '2015-04-01 00:46:18.000000', 'consum', 0.0218, 'lps'),
	(464108, 102, '2015-04-01 00:46:19.000000', 'consum', 0.0211, 'lps'),
	(464109, 102, '2015-04-01 00:46:20.000000', 'consum', 0.0212, 'lps'),
	(464110, 102, '2015-04-01 00:46:21.000000', 'consum', 0.0219, 'lps'),
	(464111, 102, '2015-04-01 00:46:22.000000', 'consum', 0.0226, 'lps'),
	(464112, 102, '2015-04-01 00:46:23.000000', 'consum', 0.0225, 'lps'),
	(464113, 102, '2015-04-01 00:46:24.000000', 'consum', 0.0215, 'lps'),
	(464114, 102, '2015-04-01 00:46:25.000000', 'consum', 0.0210, 'lps'),
	(464115, 102, '2015-04-01 00:46:26.000000', 'consum', 0.0217, 'lps'),
	(464116, 102, '2015-04-01 00:46:27.000000', 'consum', 0.0225, 'lps'),
	(464117, 102, '2015-04-01 00:46:28.000000', 'consum', 0.0225, 'lps'),
	(464118, 102, '2015-04-01 00:46:29.000000', 'consum', 0.0216, 'lps'),
	(464119, 102, '2015-04-01 00:46:30.000000', 'consum', 0.0216, 'lps'),
	(464120, 102, '2015-04-01 00:46:31.000000', 'consum', 0.0224, 'lps'),
	(464121, 102, '2015-04-01 00:46:32.000000', 'consum', 0.0218, 'lps'),
	(464122, 102, '2015-04-01 00:46:33.000000', 'consum', 0.0211, 'lps'),
	(464123, 102, '2015-04-01 00:46:34.000000', 'consum', 0.0211, 'lps'),
	(464124, 102, '2015-04-01 00:46:35.000000', 'consum', 0.0214, 'lps'),
	(464125, 102, '2015-04-01 00:46:36.000000', 'consum', 0.0225, 'lps'),
	(464126, 102, '2015-04-01 00:46:37.000000', 'consum', 0.0211, 'lps'),
	(464127, 102, '2015-04-01 00:46:38.000000', 'consum', 0.0212, 'lps'),
	(464128, 102, '2015-04-01 00:46:39.000000', 'consum', 0.0216, 'lps'),
	(464129, 102, '2015-04-01 00:46:40.000000', 'consum', 0.0216, 'lps'),
	(464130, 102, '2015-04-01 00:46:41.000000', 'consum', 0.0223, 'lps'),
	(464131, 102, '2015-04-01 00:46:42.000000', 'consum', 0.0213, 'lps'),
	(464132, 102, '2015-04-01 00:46:43.000000', 'consum', 0.0211, 'lps'),
	(464133, 102, '2015-04-01 00:46:44.000000', 'consum', 0.0225, 'lps'),
	(464134, 102, '2015-04-01 00:46:45.000000', 'consum', 0.0218, 'lps'),
	(464135, 102, '2015-04-01 00:46:46.000000', 'consum', 0.0229, 'lps'),
	(464136, 102, '2015-04-01 00:46:47.000000', 'consum', 0.0217, 'lps'),
	(464137, 102, '2015-04-01 00:46:48.000000', 'consum', 0.0229, 'lps'),
	(464138, 102, '2015-04-01 00:46:49.000000', 'consum', 0.0225, 'lps'),
	(464139, 102, '2015-04-01 00:46:50.000000', 'consum', 0.0225, 'lps'),
	(464140, 102, '2015-04-01 00:46:51.000000', 'consum', 0.0221, 'lps'),
	(464141, 102, '2015-04-01 00:46:52.000000', 'consum', 0.0222, 'lps'),
	(464142, 102, '2015-04-01 00:46:53.000000', 'consum', 0.0216, 'lps'),
	(464143, 102, '2015-04-01 00:46:54.000000', 'consum', 0.0224, 'lps'),
	(464144, 102, '2015-04-01 00:46:55.000000', 'consum', 0.0222, 'lps'),
	(464145, 102, '2015-04-01 00:46:56.000000', 'consum', 0.0229, 'lps'),
	(464146, 102, '2015-04-01 00:46:57.000000', 'consum', 0.0225, 'lps'),
	(464147, 102, '2015-04-01 00:46:58.000000', 'consum', 0.0210, 'lps'),
	(464148, 102, '2015-04-01 00:46:59.000000', 'consum', 0.0226, 'lps'),
	(464149, 102, '2015-04-01 00:47:00.000000', 'consum', 0.0228, 'lps'),
	(464150, 102, '2015-04-01 00:47:01.000000', 'consum', 0.0212, 'lps'),
	(464151, 102, '2015-04-01 00:47:02.000000', 'consum', 0.0229, 'lps'),
	(464152, 102, '2015-04-01 00:47:03.000000', 'consum', 0.0214, 'lps'),
	(464153, 102, '2015-04-01 00:47:04.000000', 'consum', 0.0216, 'lps'),
	(464154, 102, '2015-04-01 00:47:05.000000', 'consum', 0.0229, 'lps'),
	(464155, 102, '2015-04-01 00:47:06.000000', 'consum', 0.0225, 'lps'),
	(464156, 102, '2015-04-01 00:47:07.000000', 'consum', 0.0228, 'lps'),
	(464157, 102, '2015-04-01 00:47:08.000000', 'consum', 0.0212, 'lps'),
	(464158, 102, '2015-04-01 00:47:09.000000', 'consum', 0.0210, 'lps'),
	(464159, 102, '2015-04-01 00:47:10.000000', 'consum', 0.0224, 'lps'),
	(464160, 102, '2015-04-01 00:47:11.000000', 'consum', 0.0218, 'lps'),
	(464161, 102, '2015-04-01 00:47:12.000000', 'consum', 0.0211, 'lps'),
	(464162, 102, '2015-04-01 00:47:13.000000', 'consum', 0.0230, 'lps'),
	(464163, 102, '2015-04-01 00:47:14.000000', 'consum', 0.0225, 'lps'),
	(464164, 102, '2015-04-01 00:47:15.000000', 'consum', 0.0225, 'lps'),
	(464165, 102, '2015-04-01 00:47:16.000000', 'consum', 0.0218, 'lps'),
	(464166, 102, '2015-04-01 00:47:17.000000', 'consum', 0.0229, 'lps'),
	(464167, 102, '2015-04-01 00:47:18.000000', 'consum', 0.0217, 'lps'),
	(464168, 102, '2015-04-01 00:47:19.000000', 'consum', 0.0211, 'lps'),
	(464169, 102, '2015-04-01 00:47:20.000000', 'consum', 0.0216, 'lps'),
	(464170, 102, '2015-04-01 00:47:21.000000', 'consum', 0.0217, 'lps'),
	(464171, 102, '2015-04-01 00:47:22.000000', 'consum', 0.0227, 'lps'),
	(464172, 102, '2015-04-01 00:47:23.000000', 'consum', 0.0213, 'lps'),
	(464173, 102, '2015-04-01 00:47:24.000000', 'consum', 0.0215, 'lps'),
	(464174, 102, '2015-04-01 00:47:25.000000', 'consum', 0.0227, 'lps'),
	(464175, 102, '2015-04-01 00:47:26.000000', 'consum', 0.0217, 'lps'),
	(464176, 102, '2015-04-01 00:47:27.000000', 'consum', 0.0217, 'lps'),
	(464177, 102, '2015-04-01 00:47:28.000000', 'consum', 0.0224, 'lps'),
	(464178, 102, '2015-04-01 00:47:29.000000', 'consum', 0.0218, 'lps'),
	(464179, 102, '2015-04-01 00:47:30.000000', 'consum', 0.0229, 'lps'),
	(464180, 102, '2015-04-01 00:47:31.000000', 'consum', 0.0220, 'lps'),
	(464181, 102, '2015-04-01 00:47:32.000000', 'consum', 0.0224, 'lps'),
	(464182, 102, '2015-04-01 00:47:33.000000', 'consum', 0.0229, 'lps'),
	(464183, 102, '2015-04-01 00:47:34.000000', 'consum', 0.0222, 'lps'),
	(464184, 102, '2015-04-01 00:47:35.000000', 'consum', 0.0213, 'lps'),
	(464185, 102, '2015-04-01 00:47:36.000000', 'consum', 0.0210, 'lps'),
	(464186, 102, '2015-04-01 00:47:37.000000', 'consum', 0.0223, 'lps'),
	(464187, 102, '2015-04-01 00:47:38.000000', 'consum', 0.0214, 'lps'),
	(464188, 102, '2015-04-01 00:47:39.000000', 'consum', 0.0211, 'lps'),
	(464189, 102, '2015-04-01 00:47:40.000000', 'consum', 0.0227, 'lps'),
	(464190, 102, '2015-04-01 00:47:41.000000', 'consum', 0.0227, 'lps'),
	(464191, 102, '2015-04-01 00:47:42.000000', 'consum', 0.0225, 'lps'),
	(464192, 102, '2015-04-01 00:47:43.000000', 'consum', 0.0211, 'lps'),
	(464193, 102, '2015-04-01 00:47:44.000000', 'consum', 0.0215, 'lps'),
	(464194, 102, '2015-04-01 00:47:45.000000', 'consum', 0.0210, 'lps'),
	(464195, 102, '2015-04-01 00:47:46.000000', 'consum', 0.0216, 'lps'),
	(464196, 102, '2015-04-01 00:47:47.000000', 'consum', 0.0220, 'lps'),
	(464197, 102, '2015-04-01 00:47:48.000000', 'consum', 0.0223, 'lps'),
	(464198, 102, '2015-04-01 00:47:49.000000', 'consum', 0.0225, 'lps'),
	(464199, 102, '2015-04-01 00:47:50.000000', 'consum', 0.0222, 'lps'),
	(464200, 102, '2015-04-01 00:47:51.000000', 'consum', 0.0229, 'lps'),
	(464201, 102, '2015-04-01 00:47:52.000000', 'consum', 0.0227, 'lps'),
	(464202, 102, '2015-04-01 00:47:53.000000', 'consum', 0.0219, 'lps'),
	(464203, 102, '2015-04-01 00:47:54.000000', 'consum', 0.0223, 'lps'),
	(464204, 102, '2015-04-01 00:47:55.000000', 'consum', 0.0230, 'lps'),
	(464205, 102, '2015-04-01 00:47:56.000000', 'consum', 0.0228, 'lps'),
	(464206, 102, '2015-04-01 00:47:57.000000', 'consum', 0.0218, 'lps'),
	(464207, 102, '2015-04-01 00:47:58.000000', 'consum', 0.0221, 'lps'),
	(464208, 102, '2015-04-01 00:47:59.000000', 'consum', 0.0217, 'lps'),
	(464209, 102, '2015-04-01 00:48:00.000000', 'consum', 0.0214, 'lps'),
	(464210, 102, '2015-04-01 00:48:01.000000', 'consum', 0.0210, 'lps'),
	(464211, 102, '2015-04-01 00:48:02.000000', 'consum', 0.0217, 'lps'),
	(464212, 102, '2015-04-01 00:48:03.000000', 'consum', 0.0226, 'lps'),
	(464213, 102, '2015-04-01 00:48:04.000000', 'consum', 0.0228, 'lps'),
	(464214, 102, '2015-04-01 00:48:05.000000', 'consum', 0.0210, 'lps'),
	(464215, 102, '2015-04-01 00:48:06.000000', 'consum', 0.0218, 'lps'),
	(464216, 102, '2015-04-01 00:48:07.000000', 'consum', 0.0229, 'lps'),
	(464217, 102, '2015-04-01 00:48:08.000000', 'consum', 0.0220, 'lps'),
	(464218, 102, '2015-04-01 00:48:09.000000', 'consum', 0.0223, 'lps'),
	(464219, 102, '2015-04-01 00:48:10.000000', 'consum', 0.0226, 'lps'),
	(464220, 102, '2015-04-01 00:48:11.000000', 'consum', 0.0230, 'lps'),
	(464221, 102, '2015-04-01 00:48:12.000000', 'consum', 0.0219, 'lps'),
	(464222, 102, '2015-04-01 00:48:13.000000', 'consum', 0.0217, 'lps'),
	(464223, 102, '2015-04-01 00:48:14.000000', 'consum', 0.0220, 'lps'),
	(464224, 102, '2015-04-01 00:48:15.000000', 'consum', 0.0219, 'lps'),
	(464225, 102, '2015-04-01 00:48:16.000000', 'consum', 0.0226, 'lps'),
	(464226, 102, '2015-04-01 00:48:17.000000', 'consum', 0.0220, 'lps'),
	(464227, 102, '2015-04-01 00:48:18.000000', 'consum', 0.0211, 'lps'),
	(464228, 102, '2015-04-01 00:48:19.000000', 'consum', 0.0210, 'lps'),
	(464229, 102, '2015-04-01 00:48:20.000000', 'consum', 0.0227, 'lps'),
	(464230, 102, '2015-04-01 00:48:21.000000', 'consum', 0.0210, 'lps'),
	(464231, 102, '2015-04-01 00:48:22.000000', 'consum', 0.0224, 'lps'),
	(464232, 102, '2015-04-01 00:48:23.000000', 'consum', 0.0216, 'lps'),
	(464233, 102, '2015-04-01 00:48:24.000000', 'consum', 0.0221, 'lps'),
	(464234, 102, '2015-04-01 00:48:25.000000', 'consum', 0.0225, 'lps'),
	(464235, 102, '2015-04-01 00:48:26.000000', 'consum', 0.0230, 'lps'),
	(464236, 102, '2015-04-01 00:48:27.000000', 'consum', 0.0225, 'lps'),
	(464237, 102, '2015-04-01 00:48:28.000000', 'consum', 0.0228, 'lps'),
	(464238, 102, '2015-04-01 00:48:29.000000', 'consum', 0.0210, 'lps'),
	(464239, 102, '2015-04-01 00:48:30.000000', 'consum', 0.0222, 'lps'),
	(464240, 102, '2015-04-01 00:48:31.000000', 'consum', 0.0228, 'lps'),
	(464241, 102, '2015-04-01 00:48:32.000000', 'consum', 0.0224, 'lps'),
	(464242, 102, '2015-04-01 00:48:33.000000', 'consum', 0.0225, 'lps'),
	(464243, 102, '2015-04-01 00:48:34.000000', 'consum', 0.0222, 'lps'),
	(464244, 102, '2015-04-01 00:48:35.000000', 'consum', 0.0226, 'lps'),
	(464245, 102, '2015-04-01 00:48:36.000000', 'consum', 0.0213, 'lps'),
	(464246, 102, '2015-04-01 00:48:37.000000', 'consum', 0.0217, 'lps'),
	(464247, 102, '2015-04-01 00:48:38.000000', 'consum', 0.0218, 'lps'),
	(464248, 102, '2015-04-01 00:48:39.000000', 'consum', 0.0210, 'lps'),
	(464249, 102, '2015-04-01 00:48:40.000000', 'consum', 0.0226, 'lps'),
	(464250, 102, '2015-04-01 00:48:41.000000', 'consum', 0.0227, 'lps'),
	(464251, 102, '2015-04-01 00:48:42.000000', 'consum', 0.0227, 'lps'),
	(464252, 102, '2015-04-01 00:48:43.000000', 'consum', 0.0223, 'lps'),
	(464253, 102, '2015-04-01 00:48:44.000000', 'consum', 0.0224, 'lps'),
	(464254, 102, '2015-04-01 00:48:45.000000', 'consum', 0.0222, 'lps'),
	(464255, 102, '2015-04-01 00:48:46.000000', 'consum', 0.0226, 'lps'),
	(464256, 102, '2015-04-01 00:48:47.000000', 'consum', 0.0213, 'lps'),
	(464257, 102, '2015-04-01 00:48:48.000000', 'consum', 0.0221, 'lps'),
	(464258, 102, '2015-04-01 00:48:49.000000', 'consum', 0.0214, 'lps'),
	(464259, 102, '2015-04-01 00:48:50.000000', 'consum', 0.0220, 'lps'),
	(464260, 102, '2015-04-01 00:48:51.000000', 'consum', 0.0228, 'lps'),
	(464261, 102, '2015-04-01 00:48:52.000000', 'consum', 0.0227, 'lps'),
	(464262, 102, '2015-04-01 00:48:53.000000', 'consum', 0.0221, 'lps'),
	(464263, 102, '2015-04-01 00:48:54.000000', 'consum', 0.0213, 'lps'),
	(464264, 102, '2015-04-01 00:48:55.000000', 'consum', 0.0214, 'lps'),
	(464265, 102, '2015-04-01 00:48:56.000000', 'consum', 0.0221, 'lps'),
	(464266, 102, '2015-04-01 00:48:57.000000', 'consum', 0.0212, 'lps'),
	(464267, 102, '2015-04-01 00:48:58.000000', 'consum', 0.0230, 'lps'),
	(464268, 102, '2015-04-01 00:48:59.000000', 'consum', 0.0219, 'lps'),
	(464269, 102, '2015-04-01 00:49:00.000000', 'consum', 0.0218, 'lps'),
	(464270, 102, '2015-04-01 00:49:01.000000', 'consum', 0.0223, 'lps'),
	(464271, 102, '2015-04-01 00:49:02.000000', 'consum', 0.0211, 'lps'),
	(464272, 102, '2015-04-01 00:49:03.000000', 'consum', 0.0219, 'lps'),
	(464273, 102, '2015-04-01 00:49:04.000000', 'consum', 0.0210, 'lps'),
	(464274, 102, '2015-04-01 00:49:05.000000', 'consum', 0.0226, 'lps'),
	(464275, 102, '2015-04-01 00:49:06.000000', 'consum', 0.0229, 'lps'),
	(464276, 102, '2015-04-01 00:49:07.000000', 'consum', 0.0213, 'lps'),
	(464277, 102, '2015-04-01 00:49:08.000000', 'consum', 0.0212, 'lps'),
	(464278, 102, '2015-04-01 00:49:09.000000', 'consum', 0.0213, 'lps'),
	(464279, 102, '2015-04-01 00:49:10.000000', 'consum', 0.0218, 'lps'),
	(464280, 102, '2015-04-01 00:49:11.000000', 'consum', 0.0220, 'lps'),
	(464281, 102, '2015-04-01 00:49:12.000000', 'consum', 0.0217, 'lps'),
	(464282, 102, '2015-04-01 00:49:13.000000', 'consum', 0.0216, 'lps'),
	(464283, 102, '2015-04-01 00:49:14.000000', 'consum', 0.0218, 'lps'),
	(464284, 102, '2015-04-01 00:49:15.000000', 'consum', 0.0212, 'lps'),
	(464285, 102, '2015-04-01 00:49:16.000000', 'consum', 0.0219, 'lps'),
	(464286, 102, '2015-04-01 00:49:17.000000', 'consum', 0.0227, 'lps'),
	(464287, 102, '2015-04-01 00:49:18.000000', 'consum', 0.0229, 'lps'),
	(464288, 102, '2015-04-01 00:49:19.000000', 'consum', 0.0230, 'lps'),
	(464289, 102, '2015-04-01 00:49:20.000000', 'consum', 0.0214, 'lps'),
	(464290, 102, '2015-04-01 00:49:21.000000', 'consum', 0.0210, 'lps'),
	(464291, 102, '2015-04-01 00:49:22.000000', 'consum', 0.0219, 'lps'),
	(464292, 102, '2015-04-01 00:49:23.000000', 'consum', 0.0214, 'lps'),
	(464293, 102, '2015-04-01 00:49:24.000000', 'consum', 0.0225, 'lps'),
	(464294, 102, '2015-04-01 00:49:25.000000', 'consum', 0.0230, 'lps'),
	(464295, 102, '2015-04-01 00:49:26.000000', 'consum', 0.0225, 'lps'),
	(464296, 102, '2015-04-01 00:49:27.000000', 'consum', 0.0226, 'lps'),
	(464297, 102, '2015-04-01 00:49:28.000000', 'consum', 0.0224, 'lps'),
	(464298, 102, '2015-04-01 00:49:29.000000', 'consum', 0.0211, 'lps'),
	(464299, 102, '2015-04-01 00:49:30.000000', 'consum', 0.0216, 'lps'),
	(464300, 102, '2015-04-01 00:49:31.000000', 'consum', 0.0215, 'lps'),
	(464301, 102, '2015-04-01 00:49:32.000000', 'consum', 0.0218, 'lps'),
	(464302, 102, '2015-04-01 00:49:33.000000', 'consum', 0.0215, 'lps'),
	(464303, 102, '2015-04-01 00:49:34.000000', 'consum', 0.0211, 'lps'),
	(464304, 102, '2015-04-01 00:49:35.000000', 'consum', 0.0223, 'lps'),
	(464305, 102, '2015-04-01 00:49:36.000000', 'consum', 0.0210, 'lps'),
	(464306, 102, '2015-04-01 00:49:37.000000', 'consum', 0.0213, 'lps'),
	(464307, 102, '2015-04-01 00:49:38.000000', 'consum', 0.0225, 'lps'),
	(464308, 102, '2015-04-01 00:49:39.000000', 'consum', 0.0215, 'lps'),
	(464309, 102, '2015-04-01 00:49:40.000000', 'consum', 0.0212, 'lps'),
	(464310, 102, '2015-04-01 00:49:41.000000', 'consum', 0.0227, 'lps'),
	(464311, 102, '2015-04-01 00:49:42.000000', 'consum', 0.0226, 'lps'),
	(464312, 102, '2015-04-01 00:49:43.000000', 'consum', 0.0220, 'lps'),
	(464313, 102, '2015-04-01 00:49:44.000000', 'consum', 0.0211, 'lps'),
	(464314, 102, '2015-04-01 00:49:45.000000', 'consum', 0.0226, 'lps'),
	(464315, 102, '2015-04-01 00:49:46.000000', 'consum', 0.0225, 'lps'),
	(464316, 102, '2015-04-01 00:49:47.000000', 'consum', 0.0216, 'lps'),
	(464317, 102, '2015-04-01 00:49:48.000000', 'consum', 0.0216, 'lps'),
	(464318, 102, '2015-04-01 00:49:49.000000', 'consum', 0.0224, 'lps'),
	(464319, 102, '2015-04-01 00:49:50.000000', 'consum', 0.0218, 'lps'),
	(464320, 102, '2015-04-01 00:49:51.000000', 'consum', 0.0211, 'lps'),
	(464321, 102, '2015-04-01 00:49:52.000000', 'consum', 0.0213, 'lps'),
	(464322, 102, '2015-04-01 00:49:53.000000', 'consum', 0.0224, 'lps'),
	(464323, 102, '2015-04-01 00:49:54.000000', 'consum', 0.0227, 'lps'),
	(464324, 102, '2015-04-01 00:49:55.000000', 'consum', 0.0210, 'lps'),
	(464325, 102, '2015-04-01 00:49:56.000000', 'consum', 0.0224, 'lps'),
	(464326, 102, '2015-04-01 00:49:57.000000', 'consum', 0.0217, 'lps'),
	(464327, 102, '2015-04-01 00:49:58.000000', 'consum', 0.0223, 'lps'),
	(464328, 102, '2015-04-01 00:49:59.000000', 'consum', 0.0216, 'lps'),
	(464329, 102, '2015-04-01 00:50:00.000000', 'consum', 0.0220, 'lps'),
	(464330, 102, '2015-04-01 00:50:01.000000', 'consum', 0.0223, 'lps'),
	(464331, 102, '2015-04-01 00:50:02.000000', 'consum', 0.0223, 'lps'),
	(464332, 102, '2015-04-01 00:50:03.000000', 'consum', 0.0217, 'lps'),
	(464333, 102, '2015-04-01 00:50:04.000000', 'consum', 0.0227, 'lps'),
	(464334, 102, '2015-04-01 00:50:05.000000', 'consum', 0.0211, 'lps'),
	(464335, 102, '2015-04-01 00:50:06.000000', 'consum', 0.0230, 'lps'),
	(464336, 102, '2015-04-01 00:50:07.000000', 'consum', 0.0221, 'lps'),
	(464337, 102, '2015-04-01 00:50:08.000000', 'consum', 0.0228, 'lps'),
	(464338, 102, '2015-04-01 00:50:09.000000', 'consum', 0.0226, 'lps'),
	(464339, 102, '2015-04-01 00:50:10.000000', 'consum', 0.0214, 'lps'),
	(464340, 102, '2015-04-01 00:50:11.000000', 'consum', 0.0224, 'lps'),
	(464341, 102, '2015-04-01 00:50:12.000000', 'consum', 0.0229, 'lps'),
	(464342, 102, '2015-04-01 00:50:13.000000', 'consum', 0.0219, 'lps'),
	(464343, 102, '2015-04-01 00:50:14.000000', 'consum', 0.0219, 'lps'),
	(464344, 102, '2015-04-01 00:50:15.000000', 'consum', 0.0229, 'lps'),
	(464345, 102, '2015-04-01 00:50:16.000000', 'consum', 0.0217, 'lps'),
	(464346, 102, '2015-04-01 00:50:17.000000', 'consum', 0.0210, 'lps'),
	(464347, 102, '2015-04-01 00:50:18.000000', 'consum', 0.0230, 'lps'),
	(464348, 102, '2015-04-01 00:50:19.000000', 'consum', 0.0226, 'lps'),
	(464349, 102, '2015-04-01 00:50:20.000000', 'consum', 0.0211, 'lps'),
	(464350, 102, '2015-04-01 00:50:21.000000', 'consum', 0.0210, 'lps'),
	(464351, 102, '2015-04-01 00:50:22.000000', 'consum', 0.0226, 'lps'),
	(464352, 102, '2015-04-01 00:50:23.000000', 'consum', 0.0227, 'lps'),
	(464353, 102, '2015-04-01 00:50:24.000000', 'consum', 0.0228, 'lps'),
	(464354, 102, '2015-04-01 00:50:25.000000', 'consum', 0.0227, 'lps'),
	(464355, 102, '2015-04-01 00:50:26.000000', 'consum', 0.0221, 'lps'),
	(464356, 102, '2015-04-01 00:50:27.000000', 'consum', 0.0215, 'lps'),
	(464357, 102, '2015-04-01 00:50:28.000000', 'consum', 0.0224, 'lps'),
	(464358, 102, '2015-04-01 00:50:29.000000', 'consum', 0.0224, 'lps'),
	(464359, 102, '2015-04-01 00:50:30.000000', 'consum', 0.0215, 'lps'),
	(464360, 102, '2015-04-01 00:50:31.000000', 'consum', 0.0217, 'lps'),
	(464361, 102, '2015-04-01 00:50:32.000000', 'consum', 0.0210, 'lps'),
	(464362, 102, '2015-04-01 00:50:33.000000', 'consum', 0.0229, 'lps'),
	(464363, 102, '2015-04-01 00:50:34.000000', 'consum', 0.0224, 'lps'),
	(464364, 102, '2015-04-01 00:50:35.000000', 'consum', 0.0224, 'lps'),
	(464365, 102, '2015-04-01 00:50:36.000000', 'consum', 0.0216, 'lps'),
	(464366, 102, '2015-04-01 00:50:37.000000', 'consum', 0.0219, 'lps'),
	(464367, 102, '2015-04-01 00:50:38.000000', 'consum', 0.0217, 'lps'),
	(464368, 102, '2015-04-01 00:50:39.000000', 'consum', 0.0218, 'lps'),
	(464369, 102, '2015-04-01 00:50:40.000000', 'consum', 0.0210, 'lps'),
	(464370, 102, '2015-04-01 00:50:41.000000', 'consum', 0.0226, 'lps'),
	(464371, 102, '2015-04-01 00:50:42.000000', 'consum', 0.0228, 'lps'),
	(464372, 102, '2015-04-01 00:50:43.000000', 'consum', 0.0211, 'lps'),
	(464373, 102, '2015-04-01 00:50:44.000000', 'consum', 0.0225, 'lps'),
	(464374, 102, '2015-04-01 00:50:45.000000', 'consum', 0.0219, 'lps'),
	(464375, 102, '2015-04-01 00:50:46.000000', 'consum', 0.0212, 'lps'),
	(464376, 102, '2015-04-01 00:50:47.000000', 'consum', 0.0213, 'lps'),
	(464377, 102, '2015-04-01 00:50:48.000000', 'consum', 0.0218, 'lps'),
	(464378, 102, '2015-04-01 00:50:49.000000', 'consum', 0.0221, 'lps'),
	(464379, 102, '2015-04-01 00:50:50.000000', 'consum', 0.0221, 'lps'),
	(464380, 102, '2015-04-01 00:50:51.000000', 'consum', 0.0211, 'lps'),
	(464381, 102, '2015-04-01 00:50:52.000000', 'consum', 0.0226, 'lps'),
	(464382, 102, '2015-04-01 00:50:53.000000', 'consum', 0.0224, 'lps'),
	(464383, 102, '2015-04-01 00:50:54.000000', 'consum', 0.0213, 'lps'),
	(464384, 102, '2015-04-01 00:50:55.000000', 'consum', 0.0223, 'lps'),
	(464385, 102, '2015-04-01 00:50:56.000000', 'consum', 0.0225, 'lps'),
	(464386, 102, '2015-04-01 00:50:57.000000', 'consum', 0.0227, 'lps'),
	(464387, 102, '2015-04-01 00:50:58.000000', 'consum', 0.0227, 'lps'),
	(464388, 102, '2015-04-01 00:50:59.000000', 'consum', 0.0227, 'lps'),
	(464389, 102, '2015-04-01 00:51:00.000000', 'consum', 0.0220, 'lps'),
	(464390, 102, '2015-04-01 00:51:01.000000', 'consum', 0.0210, 'lps'),
	(464391, 102, '2015-04-01 00:51:02.000000', 'consum', 0.0222, 'lps'),
	(464392, 102, '2015-04-01 00:51:03.000000', 'consum', 0.0228, 'lps'),
	(464393, 102, '2015-04-01 00:51:04.000000', 'consum', 0.0222, 'lps'),
	(464394, 102, '2015-04-01 00:51:05.000000', 'consum', 0.0218, 'lps'),
	(464395, 102, '2015-04-01 00:51:06.000000', 'consum', 0.0216, 'lps'),
	(464396, 102, '2015-04-01 00:51:07.000000', 'consum', 0.0214, 'lps'),
	(464397, 102, '2015-04-01 00:51:08.000000', 'consum', 0.0214, 'lps'),
	(464398, 102, '2015-04-01 00:51:09.000000', 'consum', 0.0219, 'lps'),
	(464399, 102, '2015-04-01 00:51:10.000000', 'consum', 0.0220, 'lps'),
	(464400, 102, '2015-04-01 00:51:11.000000', 'consum', 0.0216, 'lps'),
	(464401, 102, '2015-04-01 00:51:12.000000', 'consum', 0.0230, 'lps'),
	(464402, 102, '2015-04-01 00:51:13.000000', 'consum', 0.0228, 'lps'),
	(464403, 102, '2015-04-01 00:51:14.000000', 'consum', 0.0218, 'lps'),
	(464404, 102, '2015-04-01 00:51:15.000000', 'consum', 0.0221, 'lps'),
	(464405, 102, '2015-04-01 00:51:16.000000', 'consum', 0.0219, 'lps'),
	(464406, 102, '2015-04-01 00:51:17.000000', 'consum', 0.0223, 'lps'),
	(464407, 102, '2015-04-01 00:51:18.000000', 'consum', 0.0228, 'lps'),
	(464408, 102, '2015-04-01 00:51:19.000000', 'consum', 0.0219, 'lps'),
	(464409, 102, '2015-04-01 00:51:20.000000', 'consum', 0.0223, 'lps'),
	(464410, 102, '2015-04-01 00:51:21.000000', 'consum', 0.0229, 'lps'),
	(464411, 102, '2015-04-01 00:51:22.000000', 'consum', 0.0222, 'lps'),
	(464412, 102, '2015-04-01 00:51:23.000000', 'consum', 0.0216, 'lps'),
	(464413, 102, '2015-04-01 00:51:24.000000', 'consum', 0.0225, 'lps'),
	(464414, 102, '2015-04-01 00:51:25.000000', 'consum', 0.0226, 'lps'),
	(464415, 102, '2015-04-01 00:51:26.000000', 'consum', 0.0226, 'lps'),
	(464416, 102, '2015-04-01 00:51:27.000000', 'consum', 0.0218, 'lps'),
	(464417, 102, '2015-04-01 00:51:28.000000', 'consum', 0.0225, 'lps'),
	(464418, 102, '2015-04-01 00:51:29.000000', 'consum', 0.0222, 'lps'),
	(464419, 102, '2015-04-01 00:51:30.000000', 'consum', 0.0222, 'lps'),
	(464420, 102, '2015-04-01 00:51:31.000000', 'consum', 0.0214, 'lps'),
	(464421, 102, '2015-04-01 00:51:32.000000', 'consum', 0.0215, 'lps'),
	(464422, 102, '2015-04-01 00:51:33.000000', 'consum', 0.0226, 'lps'),
	(464423, 102, '2015-04-01 00:51:34.000000', 'consum', 0.0210, 'lps'),
	(464424, 102, '2015-04-01 00:51:35.000000', 'consum', 0.0227, 'lps'),
	(464425, 102, '2015-04-01 00:51:36.000000', 'consum', 0.0210, 'lps'),
	(464426, 102, '2015-04-01 00:51:37.000000', 'consum', 0.0223, 'lps'),
	(464427, 102, '2015-04-01 00:51:38.000000', 'consum', 0.0212, 'lps'),
	(464428, 102, '2015-04-01 00:51:39.000000', 'consum', 0.0222, 'lps'),
	(464429, 102, '2015-04-01 00:51:40.000000', 'consum', 0.0225, 'lps'),
	(464430, 102, '2015-04-01 00:51:41.000000', 'consum', 0.0227, 'lps'),
	(464431, 102, '2015-04-01 00:51:42.000000', 'consum', 0.0211, 'lps'),
	(464432, 102, '2015-04-01 00:51:43.000000', 'consum', 0.0226, 'lps'),
	(464433, 102, '2015-04-01 00:51:44.000000', 'consum', 0.0225, 'lps'),
	(464434, 102, '2015-04-01 00:51:45.000000', 'consum', 0.0216, 'lps'),
	(464435, 102, '2015-04-01 00:51:46.000000', 'consum', 0.0218, 'lps'),
	(464436, 102, '2015-04-01 00:51:47.000000', 'consum', 0.0211, 'lps'),
	(464437, 102, '2015-04-01 00:51:48.000000', 'consum', 0.0211, 'lps'),
	(464438, 102, '2015-04-01 00:51:49.000000', 'consum', 0.0214, 'lps'),
	(464439, 102, '2015-04-01 00:51:50.000000', 'consum', 0.0228, 'lps'),
	(464440, 102, '2015-04-01 00:51:51.000000', 'consum', 0.0227, 'lps'),
	(464441, 102, '2015-04-01 00:51:52.000000', 'consum', 0.0218, 'lps'),
	(464442, 102, '2015-04-01 00:51:53.000000', 'consum', 0.0223, 'lps'),
	(464443, 102, '2015-04-01 00:51:54.000000', 'consum', 0.0227, 'lps'),
	(464444, 102, '2015-04-01 00:51:55.000000', 'consum', 0.0217, 'lps'),
	(464445, 102, '2015-04-01 00:51:56.000000', 'consum', 0.0213, 'lps'),
	(464446, 102, '2015-04-01 00:51:57.000000', 'consum', 0.0227, 'lps'),
	(464447, 102, '2015-04-01 00:51:58.000000', 'consum', 0.0223, 'lps'),
	(464448, 102, '2015-04-01 00:51:59.000000', 'consum', 0.0227, 'lps'),
	(464449, 102, '2015-04-01 00:52:00.000000', 'consum', 0.0212, 'lps'),
	(464450, 102, '2015-04-01 00:52:01.000000', 'consum', 0.0213, 'lps'),
	(464451, 102, '2015-04-01 00:52:02.000000', 'consum', 0.0219, 'lps'),
	(464452, 102, '2015-04-01 00:52:03.000000', 'consum', 0.0224, 'lps'),
	(464453, 102, '2015-04-01 00:52:04.000000', 'consum', 0.0213, 'lps'),
	(464454, 102, '2015-04-01 00:52:05.000000', 'consum', 0.0224, 'lps'),
	(464455, 102, '2015-04-01 00:52:06.000000', 'consum', 0.0230, 'lps'),
	(464456, 102, '2015-04-01 00:52:07.000000', 'consum', 0.0228, 'lps'),
	(464457, 102, '2015-04-01 00:52:08.000000', 'consum', 0.0217, 'lps'),
	(464458, 102, '2015-04-01 00:52:09.000000', 'consum', 0.0212, 'lps'),
	(464459, 102, '2015-04-01 00:52:10.000000', 'consum', 0.0220, 'lps'),
	(464460, 102, '2015-04-01 00:52:11.000000', 'consum', 0.0216, 'lps'),
	(464461, 102, '2015-04-01 00:52:12.000000', 'consum', 0.0228, 'lps'),
	(464462, 102, '2015-04-01 00:52:13.000000', 'consum', 0.0222, 'lps'),
	(464463, 102, '2015-04-01 00:52:14.000000', 'consum', 0.0215, 'lps'),
	(464464, 102, '2015-04-01 00:52:15.000000', 'consum', 0.0220, 'lps'),
	(464465, 102, '2015-04-01 00:52:16.000000', 'consum', 0.0223, 'lps'),
	(464466, 102, '2015-04-01 00:52:17.000000', 'consum', 0.0227, 'lps'),
	(464467, 102, '2015-04-01 00:52:18.000000', 'consum', 0.0212, 'lps'),
	(464468, 102, '2015-04-01 00:52:19.000000', 'consum', 0.0213, 'lps'),
	(464469, 102, '2015-04-01 00:52:20.000000', 'consum', 0.0218, 'lps'),
	(464470, 102, '2015-04-01 00:52:21.000000', 'consum', 0.0221, 'lps'),
	(464471, 102, '2015-04-01 00:52:22.000000', 'consum', 0.0221, 'lps'),
	(464472, 102, '2015-04-01 00:52:23.000000', 'consum', 0.0211, 'lps'),
	(464473, 102, '2015-04-01 00:52:24.000000', 'consum', 0.0223, 'lps'),
	(464474, 102, '2015-04-01 00:52:25.000000', 'consum', 0.0210, 'lps'),
	(464475, 102, '2015-04-01 00:52:26.000000', 'consum', 0.0216, 'lps'),
	(464476, 102, '2015-04-01 00:52:27.000000', 'consum', 0.0216, 'lps'),
	(464477, 102, '2015-04-01 00:52:28.000000', 'consum', 0.0226, 'lps'),
	(464478, 102, '2015-04-01 00:52:29.000000', 'consum', 0.0228, 'lps'),
	(464479, 102, '2015-04-01 00:52:30.000000', 'consum', 0.0212, 'lps'),
	(464480, 102, '2015-04-01 00:52:31.000000', 'consum', 0.0210, 'lps'),
	(464481, 102, '2015-04-01 00:52:32.000000', 'consum', 0.0222, 'lps'),
	(464482, 102, '2015-04-01 00:52:33.000000', 'consum', 0.0230, 'lps'),
	(464483, 102, '2015-04-01 00:52:34.000000', 'consum', 0.0213, 'lps'),
	(464484, 102, '2015-04-01 00:52:35.000000', 'consum', 0.0228, 'lps'),
	(464485, 102, '2015-04-01 00:52:36.000000', 'consum', 0.0226, 'lps'),
	(464486, 102, '2015-04-01 00:52:37.000000', 'consum', 0.0217, 'lps'),
	(464487, 102, '2015-04-01 00:52:38.000000', 'consum', 0.0219, 'lps'),
	(464488, 102, '2015-04-01 00:52:39.000000', 'consum', 0.0214, 'lps'),
	(464489, 102, '2015-04-01 00:52:40.000000', 'consum', 0.0225, 'lps'),
	(464490, 102, '2015-04-01 00:52:41.000000', 'consum', 0.0210, 'lps'),
	(464491, 102, '2015-04-01 00:52:42.000000', 'consum', 0.0227, 'lps'),
	(464492, 102, '2015-04-01 00:52:43.000000', 'consum', 0.0214, 'lps'),
	(464493, 102, '2015-04-01 00:52:44.000000', 'consum', 0.0221, 'lps'),
	(464494, 102, '2015-04-01 00:52:45.000000', 'consum', 0.0211, 'lps'),
	(464495, 102, '2015-04-01 00:52:46.000000', 'consum', 0.0227, 'lps'),
	(464496, 102, '2015-04-01 00:52:47.000000', 'consum', 0.0226, 'lps'),
	(464497, 102, '2015-04-01 00:52:48.000000', 'consum', 0.0220, 'lps'),
	(464498, 102, '2015-04-01 00:52:49.000000', 'consum', 0.0210, 'lps'),
	(464499, 102, '2015-04-01 00:52:50.000000', 'consum', 0.0225, 'lps'),
	(464500, 102, '2015-04-01 00:52:51.000000', 'consum', 0.0222, 'lps'),
	(464501, 102, '2015-04-01 00:52:52.000000', 'consum', 0.0226, 'lps'),
	(464502, 102, '2015-04-01 00:52:53.000000', 'consum', 0.0212, 'lps'),
	(464503, 102, '2015-04-01 00:52:54.000000', 'consum', 0.0213, 'lps'),
	(464504, 102, '2015-04-01 00:52:55.000000', 'consum', 0.0220, 'lps'),
	(464505, 102, '2015-04-01 00:52:56.000000', 'consum', 0.0210, 'lps'),
	(464506, 102, '2015-04-01 00:52:57.000000', 'consum', 0.0222, 'lps'),
	(464507, 102, '2015-04-01 00:52:58.000000', 'consum', 0.0227, 'lps'),
	(464508, 102, '2015-04-01 00:52:59.000000', 'consum', 0.0218, 'lps'),
	(464509, 102, '2015-04-01 00:53:00.000000', 'consum', 0.0220, 'lps'),
	(464510, 102, '2015-04-01 00:53:01.000000', 'consum', 0.0217, 'lps'),
	(464511, 102, '2015-04-01 00:53:02.000000', 'consum', 0.0213, 'lps'),
	(464512, 102, '2015-04-01 00:53:03.000000', 'consum', 0.0229, 'lps'),
	(464513, 102, '2015-04-01 00:53:04.000000', 'consum', 0.0211, 'lps'),
	(464514, 102, '2015-04-01 00:53:05.000000', 'consum', 0.0220, 'lps'),
	(464515, 102, '2015-04-01 00:53:06.000000', 'consum', 0.0217, 'lps'),
	(464516, 102, '2015-04-01 00:53:07.000000', 'consum', 0.0217, 'lps'),
	(464517, 102, '2015-04-01 00:53:08.000000', 'consum', 0.0222, 'lps'),
	(464518, 102, '2015-04-01 00:53:09.000000', 'consum', 0.0228, 'lps'),
	(464519, 102, '2015-04-01 00:53:10.000000', 'consum', 0.0223, 'lps'),
	(464520, 102, '2015-04-01 00:53:11.000000', 'consum', 0.0222, 'lps'),
	(464521, 102, '2015-04-01 00:53:12.000000', 'consum', 0.0212, 'lps'),
	(464522, 102, '2015-04-01 00:53:13.000000', 'consum', 0.0225, 'lps'),
	(464523, 102, '2015-04-01 00:53:14.000000', 'consum', 0.0215, 'lps'),
	(464524, 102, '2015-04-01 00:53:15.000000', 'consum', 0.0213, 'lps'),
	(464525, 102, '2015-04-01 00:53:16.000000', 'consum', 0.0210, 'lps'),
	(464526, 102, '2015-04-01 00:53:17.000000', 'consum', 0.0225, 'lps'),
	(464527, 102, '2015-04-01 00:53:18.000000', 'consum', 0.0220, 'lps'),
	(464528, 102, '2015-04-01 00:53:19.000000', 'consum', 0.0215, 'lps'),
	(464529, 102, '2015-04-01 00:53:20.000000', 'consum', 0.0228, 'lps'),
	(464530, 102, '2015-04-01 00:53:21.000000', 'consum', 0.0221, 'lps'),
	(464531, 102, '2015-04-01 00:53:22.000000', 'consum', 0.0212, 'lps'),
	(464532, 102, '2015-04-01 00:53:23.000000', 'consum', 0.0228, 'lps'),
	(464533, 102, '2015-04-01 00:53:24.000000', 'consum', 0.0213, 'lps'),
	(464534, 102, '2015-04-01 00:53:25.000000', 'consum', 0.0214, 'lps'),
	(464535, 102, '2015-04-01 00:53:26.000000', 'consum', 0.0220, 'lps'),
	(464536, 102, '2015-04-01 00:53:27.000000', 'consum', 0.0228, 'lps'),
	(464537, 102, '2015-04-01 00:53:28.000000', 'consum', 0.0229, 'lps'),
	(464538, 102, '2015-04-01 00:53:29.000000', 'consum', 0.0230, 'lps'),
	(464539, 102, '2015-04-01 00:53:30.000000', 'consum', 0.0212, 'lps'),
	(464540, 102, '2015-04-01 00:53:31.000000', 'consum', 0.0224, 'lps'),
	(464541, 102, '2015-04-01 00:53:32.000000', 'consum', 0.0212, 'lps'),
	(464542, 102, '2015-04-01 00:53:33.000000', 'consum', 0.0221, 'lps'),
	(464543, 102, '2015-04-01 00:53:34.000000', 'consum', 0.0215, 'lps'),
	(464544, 102, '2015-04-01 00:53:35.000000', 'consum', 0.0226, 'lps'),
	(464545, 102, '2015-04-01 00:53:36.000000', 'consum', 0.0213, 'lps'),
	(464546, 102, '2015-04-01 00:53:37.000000', 'consum', 0.0219, 'lps'),
	(464547, 102, '2015-04-01 00:53:38.000000', 'consum', 0.0225, 'lps'),
	(464548, 102, '2015-04-01 00:53:39.000000', 'consum', 0.0217, 'lps'),
	(464549, 102, '2015-04-01 00:53:40.000000', 'consum', 0.0222, 'lps'),
	(464550, 102, '2015-04-01 00:53:41.000000', 'consum', 0.0228, 'lps'),
	(464551, 102, '2015-04-01 00:53:42.000000', 'consum', 0.0221, 'lps'),
	(464552, 102, '2015-04-01 00:53:43.000000', 'consum', 0.0211, 'lps'),
	(464553, 102, '2015-04-01 00:53:44.000000', 'consum', 0.0225, 'lps'),
	(464554, 102, '2015-04-01 00:53:45.000000', 'consum', 0.0219, 'lps'),
	(464555, 102, '2015-04-01 00:53:46.000000', 'consum', 0.0212, 'lps'),
	(464556, 102, '2015-04-01 00:53:47.000000', 'consum', 0.0216, 'lps'),
	(464557, 102, '2015-04-01 00:53:48.000000', 'consum', 0.0211, 'lps'),
	(464558, 102, '2015-04-01 00:53:49.000000', 'consum', 0.0220, 'lps'),
	(464559, 102, '2015-04-01 00:53:50.000000', 'consum', 0.0214, 'lps'),
	(464560, 102, '2015-04-01 00:53:51.000000', 'consum', 0.0221, 'lps'),
	(464561, 102, '2015-04-01 00:53:52.000000', 'consum', 0.0211, 'lps'),
	(464562, 102, '2015-04-01 00:53:53.000000', 'consum', 0.0227, 'lps'),
	(464563, 102, '2015-04-01 00:53:54.000000', 'consum', 0.0230, 'lps'),
	(464564, 102, '2015-04-01 00:53:55.000000', 'consum', 0.0218, 'lps'),
	(464565, 102, '2015-04-01 00:53:56.000000', 'consum', 0.0211, 'lps'),
	(464566, 102, '2015-04-01 00:53:57.000000', 'consum', 0.0211, 'lps'),
	(464567, 102, '2015-04-01 00:53:58.000000', 'consum', 0.0215, 'lps'),
	(464568, 102, '2015-04-01 00:53:59.000000', 'consum', 0.0211, 'lps'),
	(464569, 102, '2015-04-01 00:54:00.000000', 'consum', 0.0223, 'lps'),
	(464570, 102, '2015-04-01 00:54:01.000000', 'consum', 0.0229, 'lps'),
	(464571, 102, '2015-04-01 00:54:02.000000', 'consum', 0.0223, 'lps'),
	(464572, 102, '2015-04-01 00:54:03.000000', 'consum', 0.0219, 'lps'),
	(464573, 102, '2015-04-01 00:54:04.000000', 'consum', 0.0218, 'lps'),
	(464574, 102, '2015-04-01 00:54:05.000000', 'consum', 0.0222, 'lps'),
	(464575, 102, '2015-04-01 00:54:06.000000', 'consum', 0.0228, 'lps'),
	(464576, 102, '2015-04-01 00:54:07.000000', 'consum', 0.0220, 'lps'),
	(464577, 102, '2015-04-01 00:54:08.000000', 'consum', 0.0227, 'lps'),
	(464578, 102, '2015-04-01 00:54:09.000000', 'consum', 0.0224, 'lps'),
	(464579, 102, '2015-04-01 00:54:10.000000', 'consum', 0.0228, 'lps'),
	(464580, 102, '2015-04-01 00:54:11.000000', 'consum', 0.0217, 'lps'),
	(464581, 102, '2015-04-01 00:54:12.000000', 'consum', 0.0211, 'lps'),
	(464582, 102, '2015-04-01 00:54:13.000000', 'consum', 0.0217, 'lps'),
	(464583, 102, '2015-04-01 00:54:14.000000', 'consum', 0.0220, 'lps'),
	(464584, 102, '2015-04-01 00:54:15.000000', 'consum', 0.0220, 'lps'),
	(464585, 102, '2015-04-01 00:54:16.000000', 'consum', 0.0229, 'lps'),
	(464586, 102, '2015-04-01 00:54:17.000000', 'consum', 0.0215, 'lps'),
	(464587, 102, '2015-04-01 00:54:18.000000', 'consum', 0.0220, 'lps'),
	(464588, 102, '2015-04-01 00:54:19.000000', 'consum', 0.0225, 'lps'),
	(464589, 102, '2015-04-01 00:54:20.000000', 'consum', 0.0211, 'lps'),
	(464590, 102, '2015-04-01 00:54:21.000000', 'consum', 0.0214, 'lps'),
	(464591, 102, '2015-04-01 00:54:22.000000', 'consum', 0.0228, 'lps'),
	(464592, 102, '2015-04-01 00:54:23.000000', 'consum', 0.0226, 'lps'),
	(464593, 102, '2015-04-01 00:54:24.000000', 'consum', 0.0214, 'lps'),
	(464594, 102, '2015-04-01 00:54:25.000000', 'consum', 0.0225, 'lps'),
	(464595, 102, '2015-04-01 00:54:26.000000', 'consum', 0.0230, 'lps'),
	(464596, 102, '2015-04-01 00:54:27.000000', 'consum', 0.0225, 'lps'),
	(464597, 102, '2015-04-01 00:54:28.000000', 'consum', 0.0226, 'lps'),
	(464598, 102, '2015-04-01 00:54:29.000000', 'consum', 0.0224, 'lps'),
	(464599, 102, '2015-04-01 00:54:30.000000', 'consum', 0.0212, 'lps'),
	(464600, 102, '2015-04-01 00:54:31.000000', 'consum', 0.0221, 'lps'),
	(464601, 102, '2015-04-01 00:54:32.000000', 'consum', 0.0215, 'lps'),
	(464602, 102, '2015-04-01 00:54:33.000000', 'consum', 0.0226, 'lps'),
	(464603, 102, '2015-04-01 00:54:34.000000', 'consum', 0.0211, 'lps'),
	(464604, 102, '2015-04-01 00:54:35.000000', 'consum', 0.0230, 'lps'),
	(464605, 102, '2015-04-01 00:54:36.000000', 'consum', 0.0226, 'lps'),
	(464606, 102, '2015-04-01 00:54:37.000000', 'consum', 0.0230, 'lps'),
	(464607, 102, '2015-04-01 00:54:38.000000', 'consum', 0.0218, 'lps'),
	(464608, 102, '2015-04-01 00:54:39.000000', 'consum', 0.0213, 'lps'),
	(464609, 102, '2015-04-01 00:54:40.000000', 'consum', 0.0223, 'lps'),
	(464610, 102, '2015-04-01 00:54:41.000000', 'consum', 0.0225, 'lps'),
	(464611, 102, '2015-04-01 00:54:42.000000', 'consum', 0.0224, 'lps'),
	(464612, 102, '2015-04-01 00:54:43.000000', 'consum', 0.0217, 'lps'),
	(464613, 102, '2015-04-01 00:54:44.000000', 'consum', 0.0222, 'lps'),
	(464614, 102, '2015-04-01 00:54:45.000000', 'consum', 0.0230, 'lps'),
	(464615, 102, '2015-04-01 00:54:46.000000', 'consum', 0.0230, 'lps'),
	(464616, 102, '2015-04-01 00:54:47.000000', 'consum', 0.0210, 'lps'),
	(464617, 102, '2015-04-01 00:54:48.000000', 'consum', 0.0213, 'lps'),
	(464618, 102, '2015-04-01 00:54:49.000000', 'consum', 0.0224, 'lps'),
	(464619, 102, '2015-04-01 00:54:50.000000', 'consum', 0.0229, 'lps'),
	(464620, 102, '2015-04-01 00:54:51.000000', 'consum', 0.0225, 'lps'),
	(464621, 102, '2015-04-01 00:54:52.000000', 'consum', 0.0225, 'lps'),
	(464622, 102, '2015-04-01 00:54:53.000000', 'consum', 0.0221, 'lps'),
	(464623, 102, '2015-04-01 00:54:54.000000', 'consum', 0.0220, 'lps'),
	(464624, 102, '2015-04-01 00:54:55.000000', 'consum', 0.0227, 'lps'),
	(464625, 102, '2015-04-01 00:54:56.000000', 'consum', 0.0223, 'lps'),
	(464626, 102, '2015-04-01 00:54:57.000000', 'consum', 0.0225, 'lps'),
	(464627, 102, '2015-04-01 00:54:58.000000', 'consum', 0.0225, 'lps'),
	(464628, 102, '2015-04-01 00:54:59.000000', 'consum', 0.0219, 'lps'),
	(464629, 102, '2015-04-01 00:55:00.000000', 'consum', 0.0212, 'lps'),
	(464630, 102, '2015-04-01 00:55:01.000000', 'consum', 0.0216, 'lps'),
	(464631, 102, '2015-04-01 00:55:02.000000', 'consum', 0.0210, 'lps'),
	(464632, 102, '2015-04-01 00:55:03.000000', 'consum', 0.0217, 'lps'),
	(464633, 102, '2015-04-01 00:55:04.000000', 'consum', 0.0223, 'lps'),
	(464634, 102, '2015-04-01 00:55:05.000000', 'consum', 0.0214, 'lps'),
	(464635, 102, '2015-04-01 00:55:06.000000', 'consum', 0.0211, 'lps'),
	(464636, 102, '2015-04-01 00:55:07.000000', 'consum', 0.0224, 'lps'),
	(464637, 102, '2015-04-01 00:55:08.000000', 'consum', 0.0215, 'lps'),
	(464638, 102, '2015-04-01 00:55:09.000000', 'consum', 0.0215, 'lps'),
	(464639, 102, '2015-04-01 00:55:10.000000', 'consum', 0.0220, 'lps'),
	(464640, 102, '2015-04-01 00:55:11.000000', 'consum', 0.0224, 'lps'),
	(464641, 102, '2015-04-01 00:55:12.000000', 'consum', 0.0228, 'lps'),
	(464642, 102, '2015-04-01 00:55:13.000000', 'consum', 0.0220, 'lps'),
	(464643, 102, '2015-04-01 00:55:14.000000', 'consum', 0.0225, 'lps'),
	(464644, 102, '2015-04-01 00:55:15.000000', 'consum', 0.0216, 'lps'),
	(464645, 102, '2015-04-01 00:55:16.000000', 'consum', 0.0215, 'lps'),
	(464646, 102, '2015-04-01 00:55:17.000000', 'consum', 0.0217, 'lps'),
	(464647, 102, '2015-04-01 00:55:18.000000', 'consum', 0.0212, 'lps'),
	(464648, 102, '2015-04-01 00:55:19.000000', 'consum', 0.0218, 'lps'),
	(464649, 102, '2015-04-01 00:55:20.000000', 'consum', 0.0224, 'lps'),
	(464650, 102, '2015-04-01 00:55:21.000000', 'consum', 0.0214, 'lps'),
	(464651, 102, '2015-04-01 00:55:22.000000', 'consum', 0.0210, 'lps'),
	(464652, 102, '2015-04-01 00:55:23.000000', 'consum', 0.0220, 'lps'),
	(464653, 102, '2015-04-01 00:55:24.000000', 'consum', 0.0219, 'lps'),
	(464654, 102, '2015-04-01 00:55:25.000000', 'consum', 0.0225, 'lps'),
	(464655, 102, '2015-04-01 00:55:26.000000', 'consum', 0.0216, 'lps'),
	(464656, 102, '2015-04-01 00:55:27.000000', 'consum', 0.0216, 'lps'),
	(464657, 102, '2015-04-01 00:55:28.000000', 'consum', 0.0225, 'lps'),
	(464658, 102, '2015-04-01 00:55:29.000000', 'consum', 0.0225, 'lps'),
	(464659, 102, '2015-04-01 00:55:30.000000', 'consum', 0.0217, 'lps'),
	(464660, 102, '2015-04-01 00:55:31.000000', 'consum', 0.0222, 'lps'),
	(464661, 102, '2015-04-01 00:55:32.000000', 'consum', 0.0228, 'lps'),
	(464662, 102, '2015-04-01 00:55:33.000000', 'consum', 0.0224, 'lps'),
	(464663, 102, '2015-04-01 00:55:34.000000', 'consum', 0.0226, 'lps'),
	(464664, 102, '2015-04-01 00:55:35.000000', 'consum', 0.0229, 'lps'),
	(464665, 102, '2015-04-01 00:55:36.000000', 'consum', 0.0214, 'lps'),
	(464666, 102, '2015-04-01 00:55:37.000000', 'consum', 0.0217, 'lps'),
	(464667, 102, '2015-04-01 00:55:38.000000', 'consum', 0.0211, 'lps'),
	(464668, 102, '2015-04-01 00:55:39.000000', 'consum', 0.0216, 'lps'),
	(464669, 102, '2015-04-01 00:55:40.000000', 'consum', 0.0217, 'lps'),
	(464670, 102, '2015-04-01 00:55:41.000000', 'consum', 0.0227, 'lps'),
	(464671, 102, '2015-04-01 00:55:42.000000', 'consum', 0.0210, 'lps'),
	(464672, 102, '2015-04-01 00:55:43.000000', 'consum', 0.0224, 'lps'),
	(464673, 102, '2015-04-01 00:55:44.000000', 'consum', 0.0216, 'lps'),
	(464674, 102, '2015-04-01 00:55:45.000000', 'consum', 0.0220, 'lps'),
	(464675, 102, '2015-04-01 00:55:46.000000', 'consum', 0.0221, 'lps'),
	(464676, 102, '2015-04-01 00:55:47.000000', 'consum', 0.0215, 'lps'),
	(464677, 102, '2015-04-01 00:55:48.000000', 'consum', 0.0223, 'lps'),
	(464678, 102, '2015-04-01 00:55:49.000000', 'consum', 0.0217, 'lps'),
	(464679, 102, '2015-04-01 00:55:50.000000', 'consum', 0.0230, 'lps'),
	(464680, 102, '2015-04-01 00:55:51.000000', 'consum', 0.0225, 'lps'),
	(464681, 102, '2015-04-01 00:55:52.000000', 'consum', 0.0226, 'lps'),
	(464682, 102, '2015-04-01 00:55:53.000000', 'consum', 0.0222, 'lps'),
	(464683, 102, '2015-04-01 00:55:54.000000', 'consum', 0.0226, 'lps'),
	(464684, 102, '2015-04-01 00:55:55.000000', 'consum', 0.0212, 'lps'),
	(464685, 102, '2015-04-01 00:55:56.000000', 'consum', 0.0216, 'lps'),
	(464686, 102, '2015-04-01 00:55:57.000000', 'consum', 0.0212, 'lps'),
	(464687, 102, '2015-04-01 00:55:58.000000', 'consum', 0.0223, 'lps'),
	(464688, 102, '2015-04-01 00:55:59.000000', 'consum', 0.0229, 'lps'),
	(464689, 102, '2015-04-01 00:56:00.000000', 'consum', 0.0224, 'lps'),
	(464690, 102, '2015-04-01 00:56:01.000000', 'consum', 0.0225, 'lps'),
	(464691, 102, '2015-04-01 00:56:02.000000', 'consum', 0.0220, 'lps'),
	(464692, 102, '2015-04-01 00:56:03.000000', 'consum', 0.0217, 'lps'),
	(464693, 102, '2015-04-01 00:56:04.000000', 'consum', 0.0217, 'lps'),
	(464694, 102, '2015-04-01 00:56:05.000000', 'consum', 0.0222, 'lps'),
	(464695, 102, '2015-04-01 00:56:06.000000', 'consum', 0.0228, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(464696, 102, '2015-04-01 00:56:07.000000', 'consum', 0.0224, 'lps'),
	(464697, 102, '2015-04-01 00:56:08.000000', 'consum', 0.0224, 'lps'),
	(464698, 102, '2015-04-01 00:56:09.000000', 'consum', 0.0219, 'lps'),
	(464699, 102, '2015-04-01 00:56:10.000000', 'consum', 0.0214, 'lps'),
	(464700, 102, '2015-04-01 00:56:11.000000', 'consum', 0.0225, 'lps'),
	(464701, 102, '2015-04-01 00:56:12.000000', 'consum', 0.0212, 'lps'),
	(464702, 102, '2015-04-01 00:56:13.000000', 'consum', 0.0215, 'lps'),
	(464703, 102, '2015-04-01 00:56:14.000000', 'consum', 0.0230, 'lps'),
	(464704, 102, '2015-04-01 00:56:15.000000', 'consum', 0.0210, 'lps'),
	(464705, 102, '2015-04-01 00:56:16.000000', 'consum', 0.0213, 'lps'),
	(464706, 102, '2015-04-01 00:56:17.000000', 'consum', 0.0227, 'lps'),
	(464707, 102, '2015-04-01 00:56:18.000000', 'consum', 0.0223, 'lps'),
	(464708, 102, '2015-04-01 00:56:19.000000', 'consum', 0.0224, 'lps'),
	(464709, 102, '2015-04-01 00:56:20.000000', 'consum', 0.0222, 'lps'),
	(464710, 102, '2015-04-01 00:56:21.000000', 'consum', 0.0226, 'lps'),
	(464711, 102, '2015-04-01 00:56:22.000000', 'consum', 0.0213, 'lps'),
	(464712, 102, '2015-04-01 00:56:23.000000', 'consum', 0.0219, 'lps'),
	(464713, 102, '2015-04-01 00:56:24.000000', 'consum', 0.0225, 'lps'),
	(464714, 102, '2015-04-01 00:56:25.000000', 'consum', 0.0219, 'lps'),
	(464715, 102, '2015-04-01 00:56:26.000000', 'consum', 0.0230, 'lps'),
	(464716, 102, '2015-04-01 00:56:27.000000', 'consum', 0.0219, 'lps'),
	(464717, 102, '2015-04-01 00:56:28.000000', 'consum', 0.0218, 'lps'),
	(464718, 102, '2015-04-01 00:56:29.000000', 'consum', 0.0225, 'lps'),
	(464719, 102, '2015-04-01 00:56:30.000000', 'consum', 0.0217, 'lps'),
	(464720, 102, '2015-04-01 00:56:31.000000', 'consum', 0.0221, 'lps'),
	(464721, 102, '2015-04-01 00:56:32.000000', 'consum', 0.0226, 'lps'),
	(464722, 102, '2015-04-01 00:56:33.000000', 'consum', 0.0214, 'lps'),
	(464723, 102, '2015-04-01 00:56:34.000000', 'consum', 0.0224, 'lps'),
	(464724, 102, '2015-04-01 00:56:35.000000', 'consum', 0.0227, 'lps'),
	(464725, 102, '2015-04-01 00:56:36.000000', 'consum', 0.0214, 'lps'),
	(464726, 102, '2015-04-01 00:56:37.000000', 'consum', 0.0218, 'lps'),
	(464727, 102, '2015-04-01 00:56:38.000000', 'consum', 0.0219, 'lps'),
	(464728, 102, '2015-04-01 00:56:39.000000', 'consum', 0.0230, 'lps'),
	(464729, 102, '2015-04-01 00:56:40.000000', 'consum', 0.0221, 'lps'),
	(464730, 102, '2015-04-01 00:56:41.000000', 'consum', 0.0228, 'lps'),
	(464731, 102, '2015-04-01 00:56:42.000000', 'consum', 0.0225, 'lps'),
	(464732, 102, '2015-04-01 00:56:43.000000', 'consum', 0.0210, 'lps'),
	(464733, 102, '2015-04-01 00:56:44.000000', 'consum', 0.0227, 'lps'),
	(464734, 102, '2015-04-01 00:56:45.000000', 'consum', 0.0214, 'lps'),
	(464735, 102, '2015-04-01 00:56:46.000000', 'consum', 0.0219, 'lps'),
	(464736, 102, '2015-04-01 00:56:47.000000', 'consum', 0.0225, 'lps'),
	(464737, 102, '2015-04-01 00:56:48.000000', 'consum', 0.0216, 'lps'),
	(464738, 102, '2015-04-01 00:56:49.000000', 'consum', 0.0218, 'lps'),
	(464739, 102, '2015-04-01 00:56:50.000000', 'consum', 0.0210, 'lps'),
	(464740, 102, '2015-04-01 00:56:51.000000', 'consum', 0.0227, 'lps'),
	(464741, 102, '2015-04-01 00:56:52.000000', 'consum', 0.0214, 'lps'),
	(464742, 102, '2015-04-01 00:56:53.000000', 'consum', 0.0222, 'lps'),
	(464743, 102, '2015-04-01 00:56:54.000000', 'consum', 0.0214, 'lps'),
	(464744, 102, '2015-04-01 00:56:55.000000', 'consum', 0.0217, 'lps'),
	(464745, 102, '2015-04-01 00:56:56.000000', 'consum', 0.0213, 'lps'),
	(464746, 102, '2015-04-01 00:56:57.000000', 'consum', 0.0224, 'lps'),
	(464747, 102, '2015-04-01 00:56:58.000000', 'consum', 0.0228, 'lps'),
	(464748, 102, '2015-04-01 00:56:59.000000', 'consum', 0.0218, 'lps'),
	(464749, 102, '2015-04-01 00:57:00.000000', 'consum', 0.0220, 'lps'),
	(464750, 102, '2015-04-01 00:57:01.000000', 'consum', 0.0212, 'lps'),
	(464751, 102, '2015-04-01 00:57:02.000000', 'consum', 0.0212, 'lps'),
	(464752, 102, '2015-04-01 00:57:03.000000', 'consum', 0.0215, 'lps'),
	(464753, 102, '2015-04-01 00:57:04.000000', 'consum', 0.0229, 'lps'),
	(464754, 102, '2015-04-01 00:57:05.000000', 'consum', 0.0228, 'lps'),
	(464755, 102, '2015-04-01 00:57:06.000000', 'consum', 0.0223, 'lps'),
	(464756, 102, '2015-04-01 00:57:07.000000', 'consum', 0.0222, 'lps'),
	(464757, 102, '2015-04-01 00:57:08.000000', 'consum', 0.0230, 'lps'),
	(464758, 102, '2015-04-01 00:57:09.000000', 'consum', 0.0211, 'lps'),
	(464759, 102, '2015-04-01 00:57:10.000000', 'consum', 0.0219, 'lps'),
	(464760, 102, '2015-04-01 00:57:11.000000', 'consum', 0.0212, 'lps'),
	(464761, 102, '2015-04-01 00:57:12.000000', 'consum', 0.0215, 'lps'),
	(464762, 102, '2015-04-01 00:57:13.000000', 'consum', 0.0227, 'lps'),
	(464763, 102, '2015-04-01 00:57:14.000000', 'consum', 0.0219, 'lps'),
	(464764, 102, '2015-04-01 00:57:15.000000', 'consum', 0.0227, 'lps'),
	(464765, 102, '2015-04-01 00:57:16.000000', 'consum', 0.0224, 'lps'),
	(464766, 102, '2015-04-01 00:57:17.000000', 'consum', 0.0229, 'lps'),
	(464767, 102, '2015-04-01 00:57:18.000000', 'consum', 0.0224, 'lps'),
	(464768, 102, '2015-04-01 00:57:19.000000', 'consum', 0.0222, 'lps'),
	(464769, 102, '2015-04-01 00:57:20.000000', 'consum', 0.0228, 'lps'),
	(464770, 102, '2015-04-01 00:57:21.000000', 'consum', 0.0223, 'lps'),
	(464771, 102, '2015-04-01 00:57:22.000000', 'consum', 0.0220, 'lps'),
	(464772, 102, '2015-04-01 00:57:23.000000', 'consum', 0.0223, 'lps'),
	(464773, 102, '2015-04-01 00:57:24.000000', 'consum', 0.0226, 'lps'),
	(464774, 102, '2015-04-01 00:57:25.000000', 'consum', 0.0230, 'lps'),
	(464775, 102, '2015-04-01 00:57:26.000000', 'consum', 0.0219, 'lps'),
	(464776, 102, '2015-04-01 00:57:27.000000', 'consum', 0.0217, 'lps'),
	(464777, 102, '2015-04-01 00:57:28.000000', 'consum', 0.0217, 'lps'),
	(464778, 102, '2015-04-01 00:57:29.000000', 'consum', 0.0228, 'lps'),
	(464779, 102, '2015-04-01 00:57:30.000000', 'consum', 0.0214, 'lps'),
	(464780, 102, '2015-04-01 00:57:31.000000', 'consum', 0.0217, 'lps'),
	(464781, 102, '2015-04-01 00:57:32.000000', 'consum', 0.0214, 'lps'),
	(464782, 102, '2015-04-01 00:57:33.000000', 'consum', 0.0230, 'lps'),
	(464783, 102, '2015-04-01 00:57:34.000000', 'consum', 0.0214, 'lps'),
	(464784, 102, '2015-04-01 00:57:35.000000', 'consum', 0.0214, 'lps'),
	(464785, 102, '2015-04-01 00:57:36.000000', 'consum', 0.0218, 'lps'),
	(464786, 102, '2015-04-01 00:57:37.000000', 'consum', 0.0218, 'lps'),
	(464787, 102, '2015-04-01 00:57:38.000000', 'consum', 0.0225, 'lps'),
	(464788, 102, '2015-04-01 00:57:39.000000', 'consum', 0.0221, 'lps'),
	(464789, 102, '2015-04-01 00:57:40.000000', 'consum', 0.0220, 'lps'),
	(464790, 102, '2015-04-01 00:57:41.000000', 'consum', 0.0229, 'lps'),
	(464791, 102, '2015-04-01 00:57:42.000000', 'consum', 0.0210, 'lps'),
	(464792, 102, '2015-04-01 00:57:43.000000', 'consum', 0.0217, 'lps'),
	(464793, 102, '2015-04-01 00:57:44.000000', 'consum', 0.0226, 'lps'),
	(464794, 102, '2015-04-01 00:57:45.000000', 'consum', 0.0227, 'lps'),
	(464795, 102, '2015-04-01 00:57:46.000000', 'consum', 0.0228, 'lps'),
	(464796, 102, '2015-04-01 00:57:47.000000', 'consum', 0.0225, 'lps'),
	(464797, 102, '2015-04-01 00:57:48.000000', 'consum', 0.0214, 'lps'),
	(464798, 102, '2015-04-01 00:57:49.000000', 'consum', 0.0225, 'lps'),
	(464799, 102, '2015-04-01 00:57:50.000000', 'consum', 0.0210, 'lps'),
	(464800, 102, '2015-04-01 00:57:51.000000', 'consum', 0.0230, 'lps'),
	(464801, 102, '2015-04-01 00:57:52.000000', 'consum', 0.0227, 'lps'),
	(464802, 102, '2015-04-01 00:57:53.000000', 'consum', 0.0213, 'lps'),
	(464803, 102, '2015-04-01 00:57:54.000000', 'consum', 0.0217, 'lps'),
	(464804, 102, '2015-04-01 00:57:55.000000', 'consum', 0.0214, 'lps'),
	(464805, 102, '2015-04-01 00:57:56.000000', 'consum', 0.0211, 'lps'),
	(464806, 102, '2015-04-01 00:57:57.000000', 'consum', 0.0223, 'lps'),
	(464807, 102, '2015-04-01 00:57:58.000000', 'consum', 0.0212, 'lps'),
	(464808, 102, '2015-04-01 00:57:59.000000', 'consum', 0.0220, 'lps'),
	(464809, 102, '2015-04-01 00:58:00.000000', 'consum', 0.0216, 'lps'),
	(464810, 102, '2015-04-01 00:58:01.000000', 'consum', 0.0230, 'lps'),
	(464811, 102, '2015-04-01 00:58:02.000000', 'consum', 0.0229, 'lps'),
	(464812, 102, '2015-04-01 00:58:03.000000', 'consum', 0.0226, 'lps'),
	(464813, 102, '2015-04-01 00:58:04.000000', 'consum', 0.0210, 'lps'),
	(464814, 102, '2015-04-01 00:58:05.000000', 'consum', 0.0227, 'lps'),
	(464815, 102, '2015-04-01 00:58:06.000000', 'consum', 0.0210, 'lps'),
	(464816, 102, '2015-04-01 00:58:07.000000', 'consum', 0.0224, 'lps'),
	(464817, 102, '2015-04-01 00:58:08.000000', 'consum', 0.0216, 'lps'),
	(464818, 102, '2015-04-01 00:58:09.000000', 'consum', 0.0219, 'lps'),
	(464819, 102, '2015-04-01 00:58:10.000000', 'consum', 0.0218, 'lps'),
	(464820, 102, '2015-04-01 00:58:11.000000', 'consum', 0.0224, 'lps'),
	(464821, 102, '2015-04-01 00:58:12.000000', 'consum', 0.0216, 'lps'),
	(464822, 102, '2015-04-01 00:58:13.000000', 'consum', 0.0216, 'lps'),
	(464823, 102, '2015-04-01 00:58:14.000000', 'consum', 0.0226, 'lps'),
	(464824, 102, '2015-04-01 00:58:15.000000', 'consum', 0.0228, 'lps'),
	(464825, 102, '2015-04-01 00:58:16.000000', 'consum', 0.0213, 'lps'),
	(464826, 102, '2015-04-01 00:58:17.000000', 'consum', 0.0213, 'lps'),
	(464827, 102, '2015-04-01 00:58:18.000000', 'consum', 0.0215, 'lps'),
	(464828, 102, '2015-04-01 00:58:19.000000', 'consum', 0.0225, 'lps'),
	(464829, 102, '2015-04-01 00:58:20.000000', 'consum', 0.0230, 'lps'),
	(464830, 102, '2015-04-01 00:58:21.000000', 'consum', 0.0225, 'lps'),
	(464831, 102, '2015-04-01 00:58:22.000000', 'consum', 0.0223, 'lps'),
	(464832, 102, '2015-04-01 00:58:23.000000', 'consum', 0.0210, 'lps'),
	(464833, 102, '2015-04-01 00:58:24.000000', 'consum', 0.0212, 'lps'),
	(464834, 102, '2015-04-01 00:58:25.000000', 'consum', 0.0222, 'lps'),
	(464835, 102, '2015-04-01 00:58:26.000000', 'consum', 0.0223, 'lps'),
	(464836, 102, '2015-04-01 00:58:27.000000', 'consum', 0.0217, 'lps'),
	(464837, 102, '2015-04-01 00:58:28.000000', 'consum', 0.0228, 'lps'),
	(464838, 102, '2015-04-01 00:58:29.000000', 'consum', 0.0215, 'lps'),
	(464839, 102, '2015-04-01 00:58:30.000000', 'consum', 0.0225, 'lps'),
	(464840, 102, '2015-04-01 00:58:31.000000', 'consum', 0.0229, 'lps'),
	(464841, 102, '2015-04-01 00:58:32.000000', 'consum', 0.0216, 'lps'),
	(464842, 102, '2015-04-01 00:58:33.000000', 'consum', 0.0228, 'lps'),
	(464843, 102, '2015-04-01 00:58:34.000000', 'consum', 0.0218, 'lps'),
	(464844, 102, '2015-04-01 00:58:35.000000', 'consum', 0.0220, 'lps'),
	(464845, 102, '2015-04-01 00:58:36.000000', 'consum', 0.0214, 'lps'),
	(464846, 102, '2015-04-01 00:58:37.000000', 'consum', 0.0222, 'lps'),
	(464847, 102, '2015-04-01 00:58:38.000000', 'consum', 0.0215, 'lps'),
	(464848, 102, '2015-04-01 00:58:39.000000', 'consum', 0.0220, 'lps'),
	(464849, 102, '2015-04-01 00:58:40.000000', 'consum', 0.0224, 'lps'),
	(464850, 102, '2015-04-01 00:58:41.000000', 'consum', 0.0211, 'lps'),
	(464851, 102, '2015-04-01 00:58:42.000000', 'consum', 0.0212, 'lps'),
	(464852, 102, '2015-04-01 00:58:43.000000', 'consum', 0.0221, 'lps'),
	(464853, 102, '2015-04-01 00:58:44.000000', 'consum', 0.0216, 'lps'),
	(464854, 102, '2015-04-01 00:58:45.000000', 'consum', 0.0228, 'lps'),
	(464855, 102, '2015-04-01 00:58:46.000000', 'consum', 0.0222, 'lps'),
	(464856, 102, '2015-04-01 00:58:47.000000', 'consum', 0.0214, 'lps'),
	(464857, 102, '2015-04-01 00:58:48.000000', 'consum', 0.0217, 'lps'),
	(464858, 102, '2015-04-01 00:58:49.000000', 'consum', 0.0211, 'lps'),
	(464859, 102, '2015-04-01 00:58:50.000000', 'consum', 0.0216, 'lps'),
	(464860, 102, '2015-04-01 00:58:51.000000', 'consum', 0.0215, 'lps'),
	(464861, 102, '2015-04-01 00:58:52.000000', 'consum', 0.0217, 'lps'),
	(464862, 102, '2015-04-01 00:58:53.000000', 'consum', 0.0213, 'lps'),
	(464863, 102, '2015-04-01 00:58:54.000000', 'consum', 0.0222, 'lps'),
	(464864, 102, '2015-04-01 00:58:55.000000', 'consum', 0.0220, 'lps'),
	(464865, 102, '2015-04-01 00:58:56.000000', 'consum', 0.0223, 'lps'),
	(464866, 102, '2015-04-01 00:58:57.000000', 'consum', 0.0227, 'lps'),
	(464867, 102, '2015-04-01 00:58:58.000000', 'consum', 0.0214, 'lps'),
	(464868, 102, '2015-04-01 00:58:59.000000', 'consum', 0.0220, 'lps'),
	(464869, 102, '2015-04-01 00:59:00.000000', 'consum', 0.0228, 'lps'),
	(464870, 102, '2015-04-01 00:59:01.000000', 'consum', 0.0228, 'lps'),
	(464871, 102, '2015-04-01 00:59:02.000000', 'consum', 0.0228, 'lps'),
	(464872, 102, '2015-04-01 00:59:03.000000', 'consum', 0.0223, 'lps'),
	(464873, 102, '2015-04-01 00:59:04.000000', 'consum', 0.0223, 'lps'),
	(464874, 102, '2015-04-01 00:59:05.000000', 'consum', 0.0213, 'lps'),
	(464875, 102, '2015-04-01 00:59:06.000000', 'consum', 0.0230, 'lps'),
	(464876, 102, '2015-04-01 00:59:07.000000', 'consum', 0.0217, 'lps'),
	(464877, 102, '2015-04-01 00:59:08.000000', 'consum', 0.0228, 'lps'),
	(464878, 102, '2015-04-01 00:59:09.000000', 'consum', 0.0215, 'lps'),
	(464879, 102, '2015-04-01 00:59:10.000000', 'consum', 0.0223, 'lps'),
	(464880, 102, '2015-04-01 00:59:11.000000', 'consum', 0.0219, 'lps'),
	(464881, 102, '2015-04-01 00:59:12.000000', 'consum', 0.0217, 'lps'),
	(464882, 102, '2015-04-01 00:59:13.000000', 'consum', 0.0217, 'lps'),
	(464883, 102, '2015-04-01 00:59:14.000000', 'consum', 0.0224, 'lps'),
	(464884, 102, '2015-04-01 00:59:15.000000', 'consum', 0.0218, 'lps'),
	(464885, 102, '2015-04-01 00:59:16.000000', 'consum', 0.0210, 'lps'),
	(464886, 102, '2015-04-01 00:59:17.000000', 'consum', 0.0229, 'lps'),
	(464887, 102, '2015-04-01 00:59:18.000000', 'consum', 0.0221, 'lps'),
	(464888, 102, '2015-04-01 00:59:19.000000', 'consum', 0.0210, 'lps'),
	(464889, 102, '2015-04-01 00:59:20.000000', 'consum', 0.0217, 'lps'),
	(464890, 102, '2015-04-01 00:59:21.000000', 'consum', 0.0226, 'lps'),
	(464891, 102, '2015-04-01 00:59:22.000000', 'consum', 0.0229, 'lps'),
	(464892, 102, '2015-04-01 00:59:23.000000', 'consum', 0.0212, 'lps'),
	(464893, 102, '2015-04-01 00:59:24.000000', 'consum', 0.0228, 'lps'),
	(464894, 102, '2015-04-01 00:59:25.000000', 'consum', 0.0211, 'lps'),
	(464895, 102, '2015-04-01 00:59:26.000000', 'consum', 0.0223, 'lps'),
	(464896, 102, '2015-04-01 00:59:27.000000', 'consum', 0.0230, 'lps'),
	(464897, 102, '2015-04-01 00:59:28.000000', 'consum', 0.0210, 'lps'),
	(464898, 102, '2015-04-01 00:59:29.000000', 'consum', 0.0212, 'lps'),
	(464899, 102, '2015-04-01 00:59:30.000000', 'consum', 0.0222, 'lps'),
	(464900, 102, '2015-04-01 00:59:31.000000', 'consum', 0.0223, 'lps'),
	(464901, 102, '2015-04-01 00:59:32.000000', 'consum', 0.0220, 'lps'),
	(464902, 102, '2015-04-01 00:59:33.000000', 'consum', 0.0219, 'lps'),
	(464903, 102, '2015-04-01 00:59:34.000000', 'consum', 0.0226, 'lps'),
	(464904, 102, '2015-04-01 00:59:35.000000', 'consum', 0.0219, 'lps'),
	(464905, 102, '2015-04-01 00:59:36.000000', 'consum', 0.0211, 'lps'),
	(464906, 102, '2015-04-01 00:59:37.000000', 'consum', 0.0210, 'lps'),
	(464907, 102, '2015-04-01 00:59:38.000000', 'consum', 0.0228, 'lps'),
	(464908, 102, '2015-04-01 00:59:39.000000', 'consum', 0.0217, 'lps'),
	(464909, 102, '2015-04-01 00:59:40.000000', 'consum', 0.0212, 'lps'),
	(464910, 102, '2015-04-01 00:59:41.000000', 'consum', 0.0222, 'lps'),
	(464911, 102, '2015-04-01 00:59:42.000000', 'consum', 0.0221, 'lps'),
	(464912, 102, '2015-04-01 00:59:43.000000', 'consum', 0.0210, 'lps'),
	(464913, 102, '2015-04-01 00:59:44.000000', 'consum', 0.0221, 'lps'),
	(464914, 102, '2015-04-01 00:59:45.000000', 'consum', 0.0220, 'lps'),
	(464915, 102, '2015-04-01 00:59:46.000000', 'consum', 0.0230, 'lps'),
	(464916, 102, '2015-04-01 00:59:47.000000', 'consum', 0.0217, 'lps'),
	(464917, 102, '2015-04-01 00:59:48.000000', 'consum', 0.0228, 'lps'),
	(464918, 102, '2015-04-01 00:59:49.000000', 'consum', 0.0215, 'lps'),
	(464919, 102, '2015-04-01 00:59:50.000000', 'consum', 0.0225, 'lps'),
	(464920, 102, '2015-04-01 00:59:51.000000', 'consum', 0.0230, 'lps'),
	(464921, 102, '2015-04-01 00:59:52.000000', 'consum', 0.0220, 'lps'),
	(464922, 102, '2015-04-01 00:59:53.000000', 'consum', 0.0223, 'lps'),
	(464923, 102, '2015-04-01 00:59:54.000000', 'consum', 0.0226, 'lps'),
	(464924, 102, '2015-04-01 00:59:55.000000', 'consum', 0.0229, 'lps'),
	(464925, 102, '2015-04-01 00:59:56.000000', 'consum', 0.0215, 'lps'),
	(464926, 102, '2015-04-01 00:59:57.000000', 'consum', 0.0219, 'lps'),
	(464927, 102, '2015-04-01 00:59:58.000000', 'consum', 0.0221, 'lps'),
	(464928, 102, '2015-04-01 00:59:59.000000', 'consum', 0.0216, 'lps'),
	(464929, 102, '2015-04-01 01:00:00.000000', 'consum', 0.0228, 'lps'),
	(464930, 102, '2015-04-01 01:00:01.000000', 'consum', 0.0222, 'lps'),
	(464931, 102, '2015-04-01 01:00:02.000000', 'consum', 0.0216, 'lps'),
	(464932, 102, '2015-04-01 01:00:03.000000', 'consum', 0.0225, 'lps'),
	(464933, 102, '2015-04-01 01:00:04.000000', 'consum', 0.0224, 'lps'),
	(464934, 102, '2015-04-01 01:00:05.000000', 'consum', 0.0214, 'lps'),
	(464935, 102, '2015-04-01 01:00:06.000000', 'consum', 0.0230, 'lps'),
	(464936, 102, '2015-04-01 01:00:07.000000', 'consum', 0.0217, 'lps'),
	(464937, 102, '2015-04-01 01:00:08.000000', 'consum', 0.0228, 'lps'),
	(464938, 102, '2015-04-01 01:00:09.000000', 'consum', 0.0215, 'lps'),
	(464939, 102, '2015-04-01 01:00:10.000000', 'consum', 0.0224, 'lps'),
	(464940, 102, '2015-04-01 01:00:11.000000', 'consum', 0.0224, 'lps'),
	(464941, 102, '2015-04-01 01:00:12.000000', 'consum', 0.0218, 'lps'),
	(464942, 102, '2015-04-01 01:00:13.000000', 'consum', 0.0229, 'lps'),
	(464943, 102, '2015-04-01 01:00:14.000000', 'consum', 0.0219, 'lps'),
	(464944, 102, '2015-04-01 01:00:15.000000', 'consum', 0.0217, 'lps'),
	(464945, 102, '2015-04-01 01:00:16.000000', 'consum', 0.0222, 'lps'),
	(464946, 102, '2015-04-01 01:00:17.000000', 'consum', 0.0227, 'lps'),
	(464947, 102, '2015-04-01 01:00:18.000000', 'consum', 0.0217, 'lps'),
	(464948, 102, '2015-04-01 01:00:19.000000', 'consum', 0.0215, 'lps'),
	(464949, 102, '2015-04-01 01:00:20.000000', 'consum', 0.0216, 'lps'),
	(464950, 102, '2015-04-01 01:00:21.000000', 'consum', 0.0226, 'lps'),
	(464951, 102, '2015-04-01 01:00:22.000000', 'consum', 0.0210, 'lps'),
	(464952, 102, '2015-04-01 01:00:23.000000', 'consum', 0.0223, 'lps'),
	(464953, 102, '2015-04-01 01:00:24.000000', 'consum', 0.0215, 'lps'),
	(464954, 102, '2015-04-01 01:00:25.000000', 'consum', 0.0218, 'lps'),
	(464955, 102, '2015-04-01 01:00:26.000000', 'consum', 0.0213, 'lps'),
	(464956, 102, '2015-04-01 01:00:27.000000', 'consum', 0.0222, 'lps'),
	(464957, 102, '2015-04-01 01:00:28.000000', 'consum', 0.0222, 'lps'),
	(464958, 102, '2015-04-01 01:00:29.000000', 'consum', 0.0212, 'lps'),
	(464959, 102, '2015-04-01 01:00:30.000000', 'consum', 0.0225, 'lps'),
	(464960, 102, '2015-04-01 01:00:31.000000', 'consum', 0.0216, 'lps'),
	(464961, 102, '2015-04-01 01:00:32.000000', 'consum', 0.0218, 'lps'),
	(464962, 102, '2015-04-01 01:00:33.000000', 'consum', 0.0211, 'lps'),
	(464963, 102, '2015-04-01 01:00:34.000000', 'consum', 0.0213, 'lps'),
	(464964, 102, '2015-04-01 01:00:35.000000', 'consum', 0.0222, 'lps'),
	(464965, 102, '2015-04-01 01:00:36.000000', 'consum', 0.0221, 'lps'),
	(464966, 102, '2015-04-01 01:00:37.000000', 'consum', 0.0228, 'lps'),
	(464967, 102, '2015-04-01 01:00:38.000000', 'consum', 0.0226, 'lps'),
	(464968, 102, '2015-04-01 01:00:39.000000', 'consum', 0.0215, 'lps'),
	(464969, 102, '2015-04-01 01:00:40.000000', 'consum', 0.0228, 'lps'),
	(464970, 102, '2015-04-01 01:00:41.000000', 'consum', 0.0225, 'lps'),
	(464971, 102, '2015-04-01 01:00:42.000000', 'consum', 0.0230, 'lps'),
	(464972, 102, '2015-04-01 01:00:43.000000', 'consum', 0.0223, 'lps'),
	(464973, 102, '2015-04-01 01:00:44.000000', 'consum', 0.0216, 'lps'),
	(464974, 102, '2015-04-01 01:00:45.000000', 'consum', 0.0225, 'lps'),
	(464975, 102, '2015-04-01 01:00:46.000000', 'consum', 0.0222, 'lps'),
	(464976, 102, '2015-04-01 01:00:47.000000', 'consum', 0.0228, 'lps'),
	(464977, 102, '2015-04-01 01:00:48.000000', 'consum', 0.0222, 'lps'),
	(464978, 102, '2015-04-01 01:00:49.000000', 'consum', 0.0218, 'lps'),
	(464979, 102, '2015-04-01 01:00:50.000000', 'consum', 0.0212, 'lps'),
	(464980, 102, '2015-04-01 01:00:51.000000', 'consum', 0.0218, 'lps'),
	(464981, 102, '2015-04-01 01:00:52.000000', 'consum', 0.0225, 'lps'),
	(464982, 102, '2015-04-01 01:00:53.000000', 'consum', 0.0218, 'lps'),
	(464983, 102, '2015-04-01 01:00:54.000000', 'consum', 0.0225, 'lps'),
	(464984, 102, '2015-04-01 01:00:55.000000', 'consum', 0.0222, 'lps'),
	(464985, 102, '2015-04-01 01:00:56.000000', 'consum', 0.0224, 'lps'),
	(464986, 102, '2015-04-01 01:00:57.000000', 'consum', 0.0223, 'lps'),
	(464987, 102, '2015-04-01 01:00:58.000000', 'consum', 0.0213, 'lps'),
	(464988, 102, '2015-04-01 01:00:59.000000', 'consum', 0.0228, 'lps'),
	(464989, 102, '2015-04-01 01:01:00.000000', 'consum', 0.0228, 'lps'),
	(464990, 102, '2015-04-01 01:01:01.000000', 'consum', 0.0228, 'lps'),
	(464991, 102, '2015-04-01 01:01:02.000000', 'consum', 0.0225, 'lps'),
	(464992, 102, '2015-04-01 01:01:03.000000', 'consum', 0.0230, 'lps'),
	(464993, 102, '2015-04-01 01:01:04.000000', 'consum', 0.0223, 'lps'),
	(464994, 102, '2015-04-01 01:01:05.000000', 'consum', 0.0218, 'lps'),
	(464995, 102, '2015-04-01 01:01:06.000000', 'consum', 0.0211, 'lps'),
	(464996, 102, '2015-04-01 01:01:07.000000', 'consum', 0.0212, 'lps'),
	(464997, 102, '2015-04-01 01:01:08.000000', 'consum', 0.0217, 'lps'),
	(464998, 102, '2015-04-01 01:01:09.000000', 'consum', 0.0218, 'lps'),
	(464999, 102, '2015-04-01 01:01:10.000000', 'consum', 0.0229, 'lps'),
	(465000, 102, '2015-04-01 01:01:11.000000', 'consum', 0.0221, 'lps'),
	(465001, 102, '2015-04-01 01:01:12.000000', 'consum', 0.0229, 'lps'),
	(465002, 102, '2015-04-01 01:01:13.000000', 'consum', 0.0211, 'lps'),
	(465003, 102, '2015-04-01 01:01:14.000000', 'consum', 0.0220, 'lps'),
	(465004, 102, '2015-04-01 01:01:15.000000', 'consum', 0.0215, 'lps'),
	(465005, 102, '2015-04-01 01:01:16.000000', 'consum', 0.0228, 'lps'),
	(465006, 102, '2015-04-01 01:01:17.000000', 'consum', 0.0220, 'lps'),
	(465007, 102, '2015-04-01 01:01:18.000000', 'consum', 0.0230, 'lps'),
	(465008, 102, '2015-04-01 01:01:19.000000', 'consum', 0.0216, 'lps'),
	(465009, 102, '2015-04-01 01:01:20.000000', 'consum', 0.0221, 'lps'),
	(465010, 102, '2015-04-01 01:01:21.000000', 'consum', 0.0230, 'lps'),
	(465011, 102, '2015-04-01 01:01:22.000000', 'consum', 0.0213, 'lps'),
	(465012, 102, '2015-04-01 01:01:23.000000', 'consum', 0.0227, 'lps'),
	(465013, 102, '2015-04-01 01:01:24.000000', 'consum', 0.0223, 'lps'),
	(465014, 102, '2015-04-01 01:01:25.000000', 'consum', 0.0225, 'lps'),
	(465015, 102, '2015-04-01 01:01:26.000000', 'consum', 0.0227, 'lps'),
	(465016, 102, '2015-04-01 01:01:27.000000', 'consum', 0.0230, 'lps'),
	(465017, 102, '2015-04-01 01:01:28.000000', 'consum', 0.0218, 'lps'),
	(465018, 102, '2015-04-01 01:01:29.000000', 'consum', 0.0210, 'lps'),
	(465019, 102, '2015-04-01 01:01:30.000000', 'consum', 0.0228, 'lps'),
	(465020, 102, '2015-04-01 01:01:31.000000', 'consum', 0.0218, 'lps'),
	(465021, 102, '2015-04-01 01:01:32.000000', 'consum', 0.0216, 'lps'),
	(465022, 102, '2015-04-01 01:01:33.000000', 'consum', 0.0217, 'lps'),
	(465023, 102, '2015-04-01 01:01:34.000000', 'consum', 0.0229, 'lps'),
	(465024, 102, '2015-04-01 01:01:35.000000', 'consum', 0.0222, 'lps'),
	(465025, 102, '2015-04-01 01:01:36.000000', 'consum', 0.0214, 'lps'),
	(465026, 102, '2015-04-01 01:01:37.000000', 'consum', 0.0213, 'lps'),
	(465027, 102, '2015-04-01 01:01:38.000000', 'consum', 0.0213, 'lps'),
	(465028, 102, '2015-04-01 01:01:39.000000', 'consum', 0.0216, 'lps'),
	(465029, 102, '2015-04-01 01:01:40.000000', 'consum', 0.0210, 'lps'),
	(465030, 102, '2015-04-01 01:01:41.000000', 'consum', 0.0214, 'lps'),
	(465031, 102, '2015-04-01 01:01:42.000000', 'consum', 0.0211, 'lps'),
	(465032, 102, '2015-04-01 01:01:43.000000', 'consum', 0.0226, 'lps'),
	(465033, 102, '2015-04-01 01:01:44.000000', 'consum', 0.0222, 'lps'),
	(465034, 102, '2015-04-01 01:01:45.000000', 'consum', 0.0224, 'lps'),
	(465035, 102, '2015-04-01 01:01:46.000000', 'consum', 0.0221, 'lps'),
	(465036, 102, '2015-04-01 01:01:47.000000', 'consum', 0.0225, 'lps'),
	(465037, 102, '2015-04-01 01:01:48.000000', 'consum', 0.0211, 'lps'),
	(465038, 102, '2015-04-01 01:01:49.000000', 'consum', 0.0212, 'lps'),
	(465039, 102, '2015-04-01 01:01:50.000000', 'consum', 0.0219, 'lps'),
	(465040, 102, '2015-04-01 01:01:51.000000', 'consum', 0.0228, 'lps'),
	(465041, 102, '2015-04-01 01:01:52.000000', 'consum', 0.0229, 'lps'),
	(465042, 102, '2015-04-01 01:01:53.000000', 'consum', 0.0212, 'lps'),
	(465043, 102, '2015-04-01 01:01:54.000000', 'consum', 0.0225, 'lps'),
	(465044, 102, '2015-04-01 01:01:55.000000', 'consum', 0.0217, 'lps'),
	(465045, 102, '2015-04-01 01:01:56.000000', 'consum', 0.0221, 'lps'),
	(465046, 102, '2015-04-01 01:01:57.000000', 'consum', 0.0225, 'lps'),
	(465047, 102, '2015-04-01 01:01:58.000000', 'consum', 0.0230, 'lps'),
	(465048, 102, '2015-04-01 01:01:59.000000', 'consum', 0.0225, 'lps'),
	(465049, 102, '2015-04-01 01:02:00.000000', 'consum', 0.0223, 'lps'),
	(465050, 102, '2015-04-01 01:02:01.000000', 'consum', 0.0210, 'lps'),
	(465051, 102, '2015-04-01 01:02:02.000000', 'consum', 0.0215, 'lps'),
	(465052, 102, '2015-04-01 01:02:03.000000', 'consum', 0.0214, 'lps'),
	(465053, 102, '2015-04-01 01:02:04.000000', 'consum', 0.0215, 'lps'),
	(465054, 102, '2015-04-01 01:02:05.000000', 'consum', 0.0223, 'lps'),
	(465055, 102, '2015-04-01 01:02:06.000000', 'consum', 0.0217, 'lps'),
	(465056, 102, '2015-04-01 01:02:07.000000', 'consum', 0.0229, 'lps'),
	(465057, 102, '2015-04-01 01:02:08.000000', 'consum', 0.0221, 'lps'),
	(465058, 102, '2015-04-01 01:02:09.000000', 'consum', 0.0228, 'lps'),
	(465059, 102, '2015-04-01 01:02:10.000000', 'consum', 0.0228, 'lps'),
	(465060, 102, '2015-04-01 01:02:11.000000', 'consum', 0.0223, 'lps'),
	(465061, 102, '2015-04-01 01:02:12.000000', 'consum', 0.0221, 'lps'),
	(465062, 102, '2015-04-01 01:02:13.000000', 'consum', 0.0226, 'lps'),
	(465063, 102, '2015-04-01 01:02:14.000000', 'consum', 0.0215, 'lps'),
	(465064, 102, '2015-04-01 01:02:15.000000', 'consum', 0.0230, 'lps'),
	(465065, 102, '2015-04-01 01:02:16.000000', 'consum', 0.0212, 'lps'),
	(465066, 102, '2015-04-01 01:02:17.000000', 'consum', 0.0223, 'lps'),
	(465067, 102, '2015-04-01 01:02:18.000000', 'consum', 0.0229, 'lps'),
	(465068, 102, '2015-04-01 01:02:19.000000', 'consum', 0.0223, 'lps'),
	(465069, 102, '2015-04-01 01:02:20.000000', 'consum', 0.0217, 'lps'),
	(465070, 102, '2015-04-01 01:02:21.000000', 'consum', 0.0229, 'lps'),
	(465071, 102, '2015-04-01 01:02:22.000000', 'consum', 0.0223, 'lps'),
	(465072, 102, '2015-04-01 01:02:23.000000', 'consum', 0.0217, 'lps'),
	(465073, 102, '2015-04-01 01:02:24.000000', 'consum', 0.0230, 'lps'),
	(465074, 102, '2015-04-01 01:02:25.000000', 'consum', 0.0224, 'lps'),
	(465075, 102, '2015-04-01 01:02:26.000000', 'consum', 0.0219, 'lps'),
	(465076, 102, '2015-04-01 01:02:27.000000', 'consum', 0.0215, 'lps'),
	(465077, 102, '2015-04-01 01:02:28.000000', 'consum', 0.0230, 'lps'),
	(465078, 102, '2015-04-01 01:02:29.000000', 'consum', 0.0211, 'lps'),
	(465079, 102, '2015-04-01 01:02:30.000000', 'consum', 0.0218, 'lps'),
	(465080, 102, '2015-04-01 01:02:31.000000', 'consum', 0.0228, 'lps'),
	(465081, 102, '2015-04-01 01:02:32.000000', 'consum', 0.0212, 'lps'),
	(465082, 102, '2015-04-01 01:02:33.000000', 'consum', 0.0228, 'lps'),
	(465083, 102, '2015-04-01 01:02:34.000000', 'consum', 0.0212, 'lps'),
	(465084, 102, '2015-04-01 01:02:35.000000', 'consum', 0.0210, 'lps'),
	(465085, 102, '2015-04-01 01:02:36.000000', 'consum', 0.0223, 'lps'),
	(465086, 102, '2015-04-01 01:02:37.000000', 'consum', 0.0215, 'lps'),
	(465087, 102, '2015-04-01 01:02:38.000000', 'consum', 0.0218, 'lps'),
	(465088, 102, '2015-04-01 01:02:39.000000', 'consum', 0.0213, 'lps'),
	(465089, 102, '2015-04-01 01:02:40.000000', 'consum', 0.0221, 'lps'),
	(465090, 102, '2015-04-01 01:02:41.000000', 'consum', 0.0216, 'lps'),
	(465091, 102, '2015-04-01 01:02:42.000000', 'consum', 0.0228, 'lps'),
	(465092, 102, '2015-04-01 01:02:43.000000', 'consum', 0.0222, 'lps'),
	(465093, 102, '2015-04-01 01:02:44.000000', 'consum', 0.0214, 'lps'),
	(465094, 102, '2015-04-01 01:02:45.000000', 'consum', 0.0215, 'lps'),
	(465095, 102, '2015-04-01 01:02:46.000000', 'consum', 0.0224, 'lps'),
	(465096, 102, '2015-04-01 01:02:47.000000', 'consum', 0.0223, 'lps'),
	(465097, 102, '2015-04-01 01:02:48.000000', 'consum', 0.0214, 'lps'),
	(465098, 102, '2015-04-01 01:02:49.000000', 'consum', 0.0211, 'lps'),
	(465099, 102, '2015-04-01 01:02:50.000000', 'consum', 0.0227, 'lps'),
	(465100, 102, '2015-04-01 01:02:51.000000', 'consum', 0.0227, 'lps'),
	(465101, 102, '2015-04-01 01:02:52.000000', 'consum', 0.0226, 'lps'),
	(465102, 102, '2015-04-01 01:02:53.000000', 'consum', 0.0219, 'lps'),
	(465103, 102, '2015-04-01 01:02:54.000000', 'consum', 0.0226, 'lps'),
	(465104, 102, '2015-04-01 01:02:55.000000', 'consum', 0.0220, 'lps'),
	(465105, 102, '2015-04-01 01:02:56.000000', 'consum', 0.0216, 'lps'),
	(465106, 102, '2015-04-01 01:02:57.000000', 'consum', 0.0230, 'lps'),
	(465107, 102, '2015-04-01 01:02:58.000000', 'consum', 0.0210, 'lps'),
	(465108, 102, '2015-04-01 01:02:59.000000', 'consum', 0.0213, 'lps'),
	(465109, 102, '2015-04-01 01:03:00.000000', 'consum', 0.0225, 'lps'),
	(465110, 102, '2015-04-01 01:03:01.000000', 'consum', 0.0212, 'lps'),
	(465111, 102, '2015-04-01 01:03:02.000000', 'consum', 0.0220, 'lps'),
	(465112, 102, '2015-04-01 01:03:03.000000', 'consum', 0.0212, 'lps'),
	(465113, 102, '2015-04-01 01:03:04.000000', 'consum', 0.0213, 'lps'),
	(465114, 102, '2015-04-01 01:03:05.000000', 'consum', 0.0218, 'lps'),
	(465115, 102, '2015-04-01 01:03:06.000000', 'consum', 0.0220, 'lps'),
	(465116, 102, '2015-04-01 01:03:07.000000', 'consum', 0.0214, 'lps'),
	(465117, 102, '2015-04-01 01:03:08.000000', 'consum', 0.0225, 'lps'),
	(465118, 102, '2015-04-01 01:03:09.000000', 'consum', 0.0229, 'lps'),
	(465119, 102, '2015-04-01 01:03:10.000000', 'consum', 0.0219, 'lps'),
	(465120, 102, '2015-04-01 01:03:11.000000', 'consum', 0.0221, 'lps'),
	(465121, 102, '2015-04-01 01:03:12.000000', 'consum', 0.0217, 'lps'),
	(465122, 102, '2015-04-01 01:03:13.000000', 'consum', 0.0211, 'lps'),
	(465123, 102, '2015-04-01 01:03:14.000000', 'consum', 0.0217, 'lps'),
	(465124, 102, '2015-04-01 01:03:15.000000', 'consum', 0.0220, 'lps'),
	(465125, 102, '2015-04-01 01:03:16.000000', 'consum', 0.0218, 'lps'),
	(465126, 102, '2015-04-01 01:03:17.000000', 'consum', 0.0221, 'lps'),
	(465127, 102, '2015-04-01 01:03:18.000000', 'consum', 0.0222, 'lps'),
	(465128, 102, '2015-04-01 01:03:19.000000', 'consum', 0.0215, 'lps'),
	(465129, 102, '2015-04-01 01:03:20.000000', 'consum', 0.0223, 'lps'),
	(465130, 102, '2015-04-01 01:03:21.000000', 'consum', 0.0216, 'lps'),
	(465131, 102, '2015-04-01 01:03:22.000000', 'consum', 0.0221, 'lps'),
	(465132, 102, '2015-04-01 01:03:23.000000', 'consum', 0.0229, 'lps'),
	(465133, 102, '2015-04-01 01:03:24.000000', 'consum', 0.0230, 'lps'),
	(465134, 102, '2015-04-01 01:03:25.000000', 'consum', 0.0212, 'lps'),
	(465135, 102, '2015-04-01 01:03:26.000000', 'consum', 0.0222, 'lps'),
	(465136, 102, '2015-04-01 01:03:27.000000', 'consum', 0.0224, 'lps'),
	(465137, 102, '2015-04-01 01:03:28.000000', 'consum', 0.0222, 'lps'),
	(465138, 102, '2015-04-01 01:03:29.000000', 'consum', 0.0210, 'lps'),
	(465139, 102, '2015-04-01 01:03:30.000000', 'consum', 0.0216, 'lps'),
	(465140, 102, '2015-04-01 01:03:31.000000', 'consum', 0.0217, 'lps'),
	(465141, 102, '2015-04-01 01:03:32.000000', 'consum', 0.0229, 'lps'),
	(465142, 102, '2015-04-01 01:03:33.000000', 'consum', 0.0223, 'lps'),
	(465143, 102, '2015-04-01 01:03:34.000000', 'consum', 0.0216, 'lps'),
	(465144, 102, '2015-04-01 01:03:35.000000', 'consum', 0.0224, 'lps'),
	(465145, 102, '2015-04-01 01:03:36.000000', 'consum', 0.0221, 'lps'),
	(465146, 102, '2015-04-01 01:03:37.000000', 'consum', 0.0221, 'lps'),
	(465147, 102, '2015-04-01 01:03:38.000000', 'consum', 0.0212, 'lps'),
	(465148, 102, '2015-04-01 01:03:39.000000', 'consum', 0.0230, 'lps'),
	(465149, 102, '2015-04-01 01:03:40.000000', 'consum', 0.0222, 'lps'),
	(465150, 102, '2015-04-01 01:03:41.000000', 'consum', 0.0229, 'lps'),
	(465151, 102, '2015-04-01 01:03:42.000000', 'consum', 0.0229, 'lps'),
	(465152, 102, '2015-04-01 01:03:43.000000', 'consum', 0.0229, 'lps'),
	(465153, 102, '2015-04-01 01:03:44.000000', 'consum', 0.0224, 'lps'),
	(465154, 102, '2015-04-01 01:03:45.000000', 'consum', 0.0226, 'lps'),
	(465155, 102, '2015-04-01 01:03:46.000000', 'consum', 0.0226, 'lps'),
	(465156, 102, '2015-04-01 01:03:47.000000', 'consum', 0.0223, 'lps'),
	(465157, 102, '2015-04-01 01:03:48.000000', 'consum', 0.0226, 'lps'),
	(465158, 102, '2015-04-01 01:03:49.000000', 'consum', 0.0211, 'lps'),
	(465159, 102, '2015-04-01 01:03:50.000000', 'consum', 0.0229, 'lps'),
	(465160, 102, '2015-04-01 01:03:51.000000', 'consum', 0.0218, 'lps'),
	(465161, 102, '2015-04-01 01:03:52.000000', 'consum', 0.0214, 'lps'),
	(465162, 102, '2015-04-01 01:03:53.000000', 'consum', 0.0228, 'lps'),
	(465163, 102, '2015-04-01 01:03:54.000000', 'consum', 0.0227, 'lps'),
	(465164, 102, '2015-04-01 01:03:55.000000', 'consum', 0.0221, 'lps'),
	(465165, 102, '2015-04-01 01:03:56.000000', 'consum', 0.0215, 'lps'),
	(465166, 102, '2015-04-01 01:03:57.000000', 'consum', 0.0223, 'lps'),
	(465167, 102, '2015-04-01 01:03:58.000000', 'consum', 0.0216, 'lps'),
	(465168, 102, '2015-04-01 01:03:59.000000', 'consum', 0.0226, 'lps'),
	(465169, 102, '2015-04-01 01:04:00.000000', 'consum', 0.0228, 'lps'),
	(465170, 102, '2015-04-01 01:04:01.000000', 'consum', 0.0213, 'lps'),
	(465171, 102, '2015-04-01 01:04:02.000000', 'consum', 0.0212, 'lps'),
	(465172, 102, '2015-04-01 01:04:03.000000', 'consum', 0.0211, 'lps'),
	(465173, 102, '2015-04-01 01:04:04.000000', 'consum', 0.0229, 'lps'),
	(465174, 102, '2015-04-01 01:04:05.000000', 'consum', 0.0220, 'lps'),
	(465175, 102, '2015-04-01 01:04:06.000000', 'consum', 0.0222, 'lps'),
	(465176, 102, '2015-04-01 01:04:07.000000', 'consum', 0.0223, 'lps'),
	(465177, 102, '2015-04-01 01:04:08.000000', 'consum', 0.0219, 'lps'),
	(465178, 102, '2015-04-01 01:04:09.000000', 'consum', 0.0214, 'lps'),
	(465179, 102, '2015-04-01 01:04:10.000000', 'consum', 0.0224, 'lps'),
	(465180, 102, '2015-04-01 01:04:11.000000', 'consum', 0.0227, 'lps'),
	(465181, 102, '2015-04-01 01:04:12.000000', 'consum', 0.0212, 'lps'),
	(465182, 102, '2015-04-01 01:04:13.000000', 'consum', 0.0230, 'lps'),
	(465183, 102, '2015-04-01 01:04:14.000000', 'consum', 0.0224, 'lps'),
	(465184, 102, '2015-04-01 01:04:15.000000', 'consum', 0.0218, 'lps'),
	(465185, 102, '2015-04-01 01:04:16.000000', 'consum', 0.0210, 'lps'),
	(465186, 102, '2015-04-01 01:04:17.000000', 'consum', 0.0228, 'lps'),
	(465187, 102, '2015-04-01 01:04:18.000000', 'consum', 0.0217, 'lps'),
	(465188, 102, '2015-04-01 01:04:19.000000', 'consum', 0.0210, 'lps'),
	(465189, 102, '2015-04-01 01:04:20.000000', 'consum', 0.0214, 'lps'),
	(465190, 102, '2015-04-01 01:04:21.000000', 'consum', 0.0227, 'lps'),
	(465191, 102, '2015-04-01 01:04:22.000000', 'consum', 0.0224, 'lps'),
	(465192, 102, '2015-04-01 01:04:23.000000', 'consum', 0.0228, 'lps'),
	(465193, 102, '2015-04-01 01:04:24.000000', 'consum', 0.0216, 'lps'),
	(465194, 102, '2015-04-01 01:04:25.000000', 'consum', 0.0229, 'lps'),
	(465195, 102, '2015-04-01 01:04:26.000000', 'consum', 0.0223, 'lps'),
	(465196, 102, '2015-04-01 01:04:27.000000', 'consum', 0.0220, 'lps'),
	(465197, 102, '2015-04-01 01:04:28.000000', 'consum', 0.0222, 'lps'),
	(465198, 102, '2015-04-01 01:04:29.000000', 'consum', 0.0220, 'lps'),
	(465199, 102, '2015-04-01 01:04:30.000000', 'consum', 0.0223, 'lps'),
	(465200, 102, '2015-04-01 01:04:31.000000', 'consum', 0.0225, 'lps'),
	(465201, 102, '2015-04-01 01:04:32.000000', 'consum', 0.0225, 'lps'),
	(465202, 102, '2015-04-01 01:04:33.000000', 'consum', 0.0219, 'lps'),
	(465203, 102, '2015-04-01 01:04:34.000000', 'consum', 0.0211, 'lps'),
	(465204, 102, '2015-04-01 01:04:35.000000', 'consum', 0.0229, 'lps'),
	(465205, 102, '2015-04-01 01:04:36.000000', 'consum', 0.0220, 'lps'),
	(465206, 102, '2015-04-01 01:04:37.000000', 'consum', 0.0223, 'lps'),
	(465207, 102, '2015-04-01 01:04:38.000000', 'consum', 0.0227, 'lps'),
	(465208, 102, '2015-04-01 01:04:39.000000', 'consum', 0.0214, 'lps'),
	(465209, 102, '2015-04-01 01:04:40.000000', 'consum', 0.0221, 'lps'),
	(465210, 102, '2015-04-01 01:04:41.000000', 'consum', 0.0212, 'lps'),
	(465211, 102, '2015-04-01 01:04:42.000000', 'consum', 0.0210, 'lps'),
	(465212, 102, '2015-04-01 01:04:43.000000', 'consum', 0.0225, 'lps'),
	(465213, 102, '2015-04-01 01:04:44.000000', 'consum', 0.0222, 'lps'),
	(465214, 102, '2015-04-01 01:04:45.000000', 'consum', 0.0226, 'lps'),
	(465215, 102, '2015-04-01 01:04:46.000000', 'consum', 0.0214, 'lps'),
	(465216, 102, '2015-04-01 01:04:47.000000', 'consum', 0.0223, 'lps'),
	(465217, 102, '2015-04-01 01:04:48.000000', 'consum', 0.0222, 'lps'),
	(465218, 102, '2015-04-01 01:04:49.000000', 'consum', 0.0229, 'lps'),
	(465219, 102, '2015-04-01 01:04:50.000000', 'consum', 0.0230, 'lps'),
	(465220, 102, '2015-04-01 01:04:51.000000', 'consum', 0.0210, 'lps'),
	(465221, 102, '2015-04-01 01:04:52.000000', 'consum', 0.0214, 'lps'),
	(465222, 102, '2015-04-01 01:04:53.000000', 'consum', 0.0230, 'lps'),
	(465223, 102, '2015-04-01 01:04:54.000000', 'consum', 0.0213, 'lps'),
	(465224, 102, '2015-04-01 01:04:55.000000', 'consum', 0.0230, 'lps'),
	(465225, 102, '2015-04-01 01:04:56.000000', 'consum', 0.0219, 'lps'),
	(465226, 102, '2015-04-01 01:04:57.000000', 'consum', 0.0214, 'lps'),
	(465227, 102, '2015-04-01 01:04:58.000000', 'consum', 0.0224, 'lps'),
	(465228, 102, '2015-04-01 01:04:59.000000', 'consum', 0.0228, 'lps'),
	(465229, 102, '2015-04-01 01:05:00.000000', 'consum', 0.0217, 'lps'),
	(465230, 102, '2015-04-01 01:05:01.000000', 'consum', 0.0212, 'lps'),
	(465231, 102, '2015-04-01 01:05:02.000000', 'consum', 0.0222, 'lps'),
	(465232, 102, '2015-04-01 01:05:03.000000', 'consum', 0.0220, 'lps'),
	(465233, 102, '2015-04-01 01:05:04.000000', 'consum', 0.0225, 'lps'),
	(465234, 102, '2015-04-01 01:05:05.000000', 'consum', 0.0213, 'lps'),
	(465235, 102, '2015-04-01 01:05:06.000000', 'consum', 0.0224, 'lps'),
	(465236, 102, '2015-04-01 01:05:07.000000', 'consum', 0.0228, 'lps'),
	(465237, 102, '2015-04-01 01:05:08.000000', 'consum', 0.0218, 'lps'),
	(465238, 102, '2015-04-01 01:05:09.000000', 'consum', 0.0217, 'lps'),
	(465239, 102, '2015-04-01 01:05:10.000000', 'consum', 0.0223, 'lps'),
	(465240, 102, '2015-04-01 01:05:11.000000', 'consum', 0.0213, 'lps'),
	(465241, 102, '2015-04-01 01:05:12.000000', 'consum', 0.0229, 'lps'),
	(465242, 102, '2015-04-01 01:05:13.000000', 'consum', 0.0230, 'lps'),
	(465243, 102, '2015-04-01 01:05:14.000000', 'consum', 0.0214, 'lps'),
	(465244, 102, '2015-04-01 01:05:15.000000', 'consum', 0.0212, 'lps'),
	(465245, 102, '2015-04-01 01:05:16.000000', 'consum', 0.0210, 'lps'),
	(465246, 102, '2015-04-01 01:05:17.000000', 'consum', 0.0225, 'lps'),
	(465247, 102, '2015-04-01 01:05:18.000000', 'consum', 0.0222, 'lps'),
	(465248, 102, '2015-04-01 01:05:19.000000', 'consum', 0.0228, 'lps'),
	(465249, 102, '2015-04-01 01:05:20.000000', 'consum', 0.0219, 'lps'),
	(465250, 102, '2015-04-01 01:05:21.000000', 'consum', 0.0226, 'lps'),
	(465251, 102, '2015-04-01 01:05:22.000000', 'consum', 0.0219, 'lps'),
	(465252, 102, '2015-04-01 01:05:23.000000', 'consum', 0.0227, 'lps'),
	(465253, 102, '2015-04-01 01:05:24.000000', 'consum', 0.0230, 'lps'),
	(465254, 102, '2015-04-01 01:05:25.000000', 'consum', 0.0214, 'lps'),
	(465255, 102, '2015-04-01 01:05:26.000000', 'consum', 0.0215, 'lps'),
	(465256, 102, '2015-04-01 01:05:27.000000', 'consum', 0.0224, 'lps'),
	(465257, 102, '2015-04-01 01:05:28.000000', 'consum', 0.0222, 'lps'),
	(465258, 102, '2015-04-01 01:05:29.000000', 'consum', 0.0227, 'lps'),
	(465259, 102, '2015-04-01 01:05:30.000000', 'consum', 0.0219, 'lps'),
	(465260, 102, '2015-04-01 01:05:31.000000', 'consum', 0.0223, 'lps'),
	(465261, 102, '2015-04-01 01:05:32.000000', 'consum', 0.0210, 'lps'),
	(465262, 102, '2015-04-01 01:05:33.000000', 'consum', 0.0212, 'lps'),
	(465263, 102, '2015-04-01 01:05:34.000000', 'consum', 0.0221, 'lps'),
	(465264, 102, '2015-04-01 01:05:35.000000', 'consum', 0.0217, 'lps'),
	(465265, 102, '2015-04-01 01:05:36.000000', 'consum', 0.0214, 'lps'),
	(465266, 102, '2015-04-01 01:05:37.000000', 'consum', 0.0210, 'lps'),
	(465267, 102, '2015-04-01 01:05:38.000000', 'consum', 0.0218, 'lps'),
	(465268, 102, '2015-04-01 01:05:39.000000', 'consum', 0.0211, 'lps'),
	(465269, 102, '2015-04-01 01:05:40.000000', 'consum', 0.0210, 'lps'),
	(465270, 102, '2015-04-01 01:05:41.000000', 'consum', 0.0230, 'lps'),
	(465271, 102, '2015-04-01 01:05:42.000000', 'consum', 0.0227, 'lps'),
	(465272, 102, '2015-04-01 01:05:43.000000', 'consum', 0.0215, 'lps'),
	(465273, 102, '2015-04-01 01:05:44.000000', 'consum', 0.0226, 'lps'),
	(465274, 102, '2015-04-01 01:05:45.000000', 'consum', 0.0211, 'lps'),
	(465275, 102, '2015-04-01 01:05:46.000000', 'consum', 0.0212, 'lps'),
	(465276, 102, '2015-04-01 01:05:47.000000', 'consum', 0.0215, 'lps'),
	(465277, 102, '2015-04-01 01:05:48.000000', 'consum', 0.0230, 'lps'),
	(465278, 102, '2015-04-01 01:05:49.000000', 'consum', 0.0213, 'lps'),
	(465279, 102, '2015-04-01 01:05:50.000000', 'consum', 0.0227, 'lps'),
	(465280, 102, '2015-04-01 01:05:51.000000', 'consum', 0.0223, 'lps'),
	(465281, 102, '2015-04-01 01:05:52.000000', 'consum', 0.0223, 'lps'),
	(465282, 102, '2015-04-01 01:05:53.000000', 'consum', 0.0218, 'lps'),
	(465283, 102, '2015-04-01 01:05:54.000000', 'consum', 0.0230, 'lps'),
	(465284, 102, '2015-04-01 01:05:55.000000', 'consum', 0.0224, 'lps'),
	(465285, 102, '2015-04-01 01:05:56.000000', 'consum', 0.0222, 'lps'),
	(465286, 102, '2015-04-01 01:05:57.000000', 'consum', 0.0226, 'lps'),
	(465287, 102, '2015-04-01 01:05:58.000000', 'consum', 0.0213, 'lps'),
	(465288, 102, '2015-04-01 01:05:59.000000', 'consum', 0.0218, 'lps'),
	(465289, 102, '2015-04-01 01:06:00.000000', 'consum', 0.0224, 'lps'),
	(465290, 102, '2015-04-01 01:06:01.000000', 'consum', 0.0213, 'lps'),
	(465291, 102, '2015-04-01 01:06:02.000000', 'consum', 0.0227, 'lps'),
	(465292, 102, '2015-04-01 01:06:03.000000', 'consum', 0.0222, 'lps'),
	(465293, 102, '2015-04-01 01:06:04.000000', 'consum', 0.0218, 'lps'),
	(465294, 102, '2015-04-01 01:06:05.000000', 'consum', 0.0216, 'lps'),
	(465295, 102, '2015-04-01 01:06:06.000000', 'consum', 0.0215, 'lps'),
	(465296, 102, '2015-04-01 01:06:07.000000', 'consum', 0.0220, 'lps'),
	(465297, 102, '2015-04-01 01:06:08.000000', 'consum', 0.0223, 'lps'),
	(465298, 102, '2015-04-01 01:06:09.000000', 'consum', 0.0225, 'lps'),
	(465299, 102, '2015-04-01 01:06:10.000000', 'consum', 0.0227, 'lps'),
	(465300, 102, '2015-04-01 01:06:11.000000', 'consum', 0.0226, 'lps'),
	(465301, 102, '2015-04-01 01:06:12.000000', 'consum', 0.0222, 'lps'),
	(465302, 102, '2015-04-01 01:06:13.000000', 'consum', 0.0220, 'lps'),
	(465303, 102, '2015-04-01 01:06:14.000000', 'consum', 0.0225, 'lps'),
	(465304, 102, '2015-04-01 01:06:15.000000', 'consum', 0.0213, 'lps'),
	(465305, 102, '2015-04-01 01:06:16.000000', 'consum', 0.0225, 'lps'),
	(465306, 102, '2015-04-01 01:06:17.000000', 'consum', 0.0210, 'lps'),
	(465307, 102, '2015-04-01 01:06:18.000000', 'consum', 0.0210, 'lps'),
	(465308, 102, '2015-04-01 01:06:19.000000', 'consum', 0.0211, 'lps'),
	(465309, 102, '2015-04-01 01:06:20.000000', 'consum', 0.0215, 'lps'),
	(465310, 102, '2015-04-01 01:06:21.000000', 'consum', 0.0212, 'lps'),
	(465311, 102, '2015-04-01 01:06:22.000000', 'consum', 0.0224, 'lps'),
	(465312, 102, '2015-04-01 01:06:23.000000', 'consum', 0.0213, 'lps'),
	(465313, 102, '2015-04-01 01:06:24.000000', 'consum', 0.0224, 'lps'),
	(465314, 102, '2015-04-01 01:06:25.000000', 'consum', 0.0211, 'lps'),
	(465315, 102, '2015-04-01 01:06:26.000000', 'consum', 0.0213, 'lps'),
	(465316, 102, '2015-04-01 01:06:27.000000', 'consum', 0.0222, 'lps'),
	(465317, 102, '2015-04-01 01:06:28.000000', 'consum', 0.0221, 'lps'),
	(465318, 102, '2015-04-01 01:06:29.000000', 'consum', 0.0229, 'lps'),
	(465319, 102, '2015-04-01 01:06:30.000000', 'consum', 0.0210, 'lps'),
	(465320, 102, '2015-04-01 01:06:31.000000', 'consum', 0.0218, 'lps'),
	(465321, 102, '2015-04-01 01:06:32.000000', 'consum', 0.0227, 'lps'),
	(465322, 102, '2015-04-01 01:06:33.000000', 'consum', 0.0229, 'lps'),
	(465323, 102, '2015-04-01 01:06:34.000000', 'consum', 0.0214, 'lps'),
	(465324, 102, '2015-04-01 01:06:35.000000', 'consum', 0.0217, 'lps'),
	(465325, 102, '2015-04-01 01:06:36.000000', 'consum', 0.0230, 'lps'),
	(465326, 102, '2015-04-01 01:06:37.000000', 'consum', 0.0230, 'lps'),
	(465327, 102, '2015-04-01 01:06:38.000000', 'consum', 0.0227, 'lps'),
	(465328, 102, '2015-04-01 01:06:39.000000', 'consum', 0.0214, 'lps'),
	(465329, 102, '2015-04-01 01:06:40.000000', 'consum', 0.0224, 'lps'),
	(465330, 102, '2015-04-01 01:06:41.000000', 'consum', 0.0226, 'lps'),
	(465331, 102, '2015-04-01 01:06:42.000000', 'consum', 0.0229, 'lps'),
	(465332, 102, '2015-04-01 01:06:43.000000', 'consum', 0.0212, 'lps'),
	(465333, 102, '2015-04-01 01:06:44.000000', 'consum', 0.0229, 'lps'),
	(465334, 102, '2015-04-01 01:06:45.000000', 'consum', 0.0215, 'lps'),
	(465335, 102, '2015-04-01 01:06:46.000000', 'consum', 0.0219, 'lps'),
	(465336, 102, '2015-04-01 01:06:47.000000', 'consum', 0.0222, 'lps'),
	(465337, 102, '2015-04-01 01:06:48.000000', 'consum', 0.0222, 'lps'),
	(465338, 102, '2015-04-01 01:06:49.000000', 'consum', 0.0215, 'lps'),
	(465339, 102, '2015-04-01 01:06:50.000000', 'consum', 0.0217, 'lps'),
	(465340, 102, '2015-04-01 01:06:51.000000', 'consum', 0.0212, 'lps'),
	(465341, 102, '2015-04-01 01:06:52.000000', 'consum', 0.0221, 'lps'),
	(465342, 102, '2015-04-01 01:06:53.000000', 'consum', 0.0217, 'lps'),
	(465343, 102, '2015-04-01 01:06:54.000000', 'consum', 0.0213, 'lps'),
	(465344, 102, '2015-04-01 01:06:55.000000', 'consum', 0.0225, 'lps'),
	(465345, 102, '2015-04-01 01:06:56.000000', 'consum', 0.0213, 'lps'),
	(465346, 102, '2015-04-01 01:06:57.000000', 'consum', 0.0223, 'lps'),
	(465347, 102, '2015-04-01 01:06:58.000000', 'consum', 0.0222, 'lps'),
	(465348, 102, '2015-04-01 01:06:59.000000', 'consum', 0.0213, 'lps'),
	(465349, 102, '2015-04-01 01:07:00.000000', 'consum', 0.0211, 'lps'),
	(465350, 102, '2015-04-01 01:07:01.000000', 'consum', 0.0226, 'lps'),
	(465351, 102, '2015-04-01 01:07:02.000000', 'consum', 0.0227, 'lps'),
	(465352, 102, '2015-04-01 01:07:03.000000', 'consum', 0.0225, 'lps'),
	(465353, 102, '2015-04-01 01:07:04.000000', 'consum', 0.0214, 'lps'),
	(465354, 102, '2015-04-01 01:07:05.000000', 'consum', 0.0225, 'lps'),
	(465355, 102, '2015-04-01 01:07:06.000000', 'consum', 0.0213, 'lps'),
	(465356, 102, '2015-04-01 01:07:07.000000', 'consum', 0.0223, 'lps'),
	(465357, 102, '2015-04-01 01:07:08.000000', 'consum', 0.0224, 'lps'),
	(465358, 102, '2015-04-01 01:07:09.000000', 'consum', 0.0219, 'lps'),
	(465359, 102, '2015-04-01 01:07:10.000000', 'consum', 0.0216, 'lps'),
	(465360, 102, '2015-04-01 01:07:11.000000', 'consum', 0.0213, 'lps'),
	(465361, 102, '2015-04-01 01:07:12.000000', 'consum', 0.0230, 'lps'),
	(465362, 102, '2015-04-01 01:07:13.000000', 'consum', 0.0217, 'lps'),
	(465363, 102, '2015-04-01 01:07:14.000000', 'consum', 0.0227, 'lps'),
	(465364, 102, '2015-04-01 01:07:15.000000', 'consum', 0.0210, 'lps'),
	(465365, 102, '2015-04-01 01:07:16.000000', 'consum', 0.0225, 'lps'),
	(465366, 102, '2015-04-01 01:07:17.000000', 'consum', 0.0221, 'lps'),
	(465367, 102, '2015-04-01 01:07:18.000000', 'consum', 0.0222, 'lps'),
	(465368, 102, '2015-04-01 01:07:19.000000', 'consum', 0.0217, 'lps'),
	(465369, 102, '2015-04-01 01:07:20.000000', 'consum', 0.0229, 'lps'),
	(465370, 102, '2015-04-01 01:07:21.000000', 'consum', 0.0221, 'lps'),
	(465371, 102, '2015-04-01 01:07:22.000000', 'consum', 0.0229, 'lps'),
	(465372, 102, '2015-04-01 01:07:23.000000', 'consum', 0.0230, 'lps'),
	(465373, 102, '2015-04-01 01:07:24.000000', 'consum', 0.0214, 'lps'),
	(465374, 102, '2015-04-01 01:07:25.000000', 'consum', 0.0211, 'lps'),
	(465375, 102, '2015-04-01 01:07:26.000000', 'consum', 0.0225, 'lps'),
	(465376, 102, '2015-04-01 01:07:27.000000', 'consum', 0.0221, 'lps'),
	(465377, 102, '2015-04-01 01:07:28.000000', 'consum', 0.0218, 'lps'),
	(465378, 102, '2015-04-01 01:07:29.000000', 'consum', 0.0218, 'lps'),
	(465379, 102, '2015-04-01 01:07:30.000000', 'consum', 0.0228, 'lps'),
	(465380, 102, '2015-04-01 01:07:31.000000', 'consum', 0.0212, 'lps'),
	(465381, 102, '2015-04-01 01:07:32.000000', 'consum', 0.0210, 'lps'),
	(465382, 102, '2015-04-01 01:07:33.000000', 'consum', 0.0224, 'lps'),
	(465383, 102, '2015-04-01 01:07:34.000000', 'consum', 0.0220, 'lps'),
	(465384, 102, '2015-04-01 01:07:35.000000', 'consum', 0.0216, 'lps'),
	(465385, 102, '2015-04-01 01:07:36.000000', 'consum', 0.0213, 'lps'),
	(465386, 102, '2015-04-01 01:07:37.000000', 'consum', 0.0229, 'lps'),
	(465387, 102, '2015-04-01 01:07:38.000000', 'consum', 0.0211, 'lps'),
	(465388, 102, '2015-04-01 01:07:39.000000', 'consum', 0.0223, 'lps'),
	(465389, 102, '2015-04-01 01:07:40.000000', 'consum', 0.0229, 'lps'),
	(465390, 102, '2015-04-01 01:07:41.000000', 'consum', 0.0225, 'lps'),
	(465391, 102, '2015-04-01 01:07:42.000000', 'consum', 0.0229, 'lps'),
	(465392, 102, '2015-04-01 01:07:43.000000', 'consum', 0.0220, 'lps'),
	(465393, 102, '2015-04-01 01:07:44.000000', 'consum', 0.0223, 'lps'),
	(465394, 102, '2015-04-01 01:07:45.000000', 'consum', 0.0225, 'lps'),
	(465395, 102, '2015-04-01 01:07:46.000000', 'consum', 0.0224, 'lps'),
	(465396, 102, '2015-04-01 01:07:47.000000', 'consum', 0.0214, 'lps'),
	(465397, 102, '2015-04-01 01:07:48.000000', 'consum', 0.0211, 'lps'),
	(465398, 102, '2015-04-01 01:07:49.000000', 'consum', 0.0225, 'lps'),
	(465399, 102, '2015-04-01 01:07:50.000000', 'consum', 0.0221, 'lps'),
	(465400, 102, '2015-04-01 01:07:51.000000', 'consum', 0.0217, 'lps'),
	(465401, 102, '2015-04-01 01:07:52.000000', 'consum', 0.0214, 'lps'),
	(465402, 102, '2015-04-01 01:07:53.000000', 'consum', 0.0211, 'lps'),
	(465403, 102, '2015-04-01 01:07:54.000000', 'consum', 0.0224, 'lps'),
	(465404, 102, '2015-04-01 01:07:55.000000', 'consum', 0.0213, 'lps'),
	(465405, 102, '2015-04-01 01:07:56.000000', 'consum', 0.0228, 'lps'),
	(465406, 102, '2015-04-01 01:07:57.000000', 'consum', 0.0229, 'lps'),
	(465407, 102, '2015-04-01 01:07:58.000000', 'consum', 0.0228, 'lps'),
	(465408, 102, '2015-04-01 01:07:59.000000', 'consum', 0.0225, 'lps'),
	(465409, 102, '2015-04-01 01:08:00.000000', 'consum', 0.0211, 'lps'),
	(465410, 102, '2015-04-01 01:08:01.000000', 'consum', 0.0213, 'lps'),
	(465411, 102, '2015-04-01 01:08:02.000000', 'consum', 0.0222, 'lps'),
	(465412, 102, '2015-04-01 01:08:03.000000', 'consum', 0.0217, 'lps'),
	(465413, 102, '2015-04-01 01:08:04.000000', 'consum', 0.0212, 'lps'),
	(465414, 102, '2015-04-01 01:08:05.000000', 'consum', 0.0222, 'lps'),
	(465415, 102, '2015-04-01 01:08:06.000000', 'consum', 0.0220, 'lps'),
	(465416, 102, '2015-04-01 01:08:07.000000', 'consum', 0.0226, 'lps'),
	(465417, 102, '2015-04-01 01:08:08.000000', 'consum', 0.0218, 'lps'),
	(465418, 102, '2015-04-01 01:08:09.000000', 'consum', 0.0224, 'lps'),
	(465419, 102, '2015-04-01 01:08:10.000000', 'consum', 0.0216, 'lps'),
	(465420, 102, '2015-04-01 01:08:11.000000', 'consum', 0.0217, 'lps'),
	(465421, 102, '2015-04-01 01:08:12.000000', 'consum', 0.0227, 'lps'),
	(465422, 102, '2015-04-01 01:08:13.000000', 'consum', 0.0210, 'lps'),
	(465423, 102, '2015-04-01 01:08:14.000000', 'consum', 0.0226, 'lps'),
	(465424, 102, '2015-04-01 01:08:15.000000', 'consum', 0.0227, 'lps'),
	(465425, 102, '2015-04-01 01:08:16.000000', 'consum', 0.0228, 'lps'),
	(465426, 102, '2015-04-01 01:08:17.000000', 'consum', 0.0227, 'lps'),
	(465427, 102, '2015-04-01 01:08:18.000000', 'consum', 0.0219, 'lps'),
	(465428, 102, '2015-04-01 01:08:19.000000', 'consum', 0.0227, 'lps'),
	(465429, 102, '2015-04-01 01:08:20.000000', 'consum', 0.0225, 'lps'),
	(465430, 102, '2015-04-01 01:08:21.000000', 'consum', 0.0213, 'lps'),
	(465431, 102, '2015-04-01 01:08:22.000000', 'consum', 0.0222, 'lps'),
	(465432, 102, '2015-04-01 01:08:23.000000', 'consum', 0.0222, 'lps'),
	(465433, 102, '2015-04-01 01:08:24.000000', 'consum', 0.0214, 'lps'),
	(465434, 102, '2015-04-01 01:08:25.000000', 'consum', 0.0213, 'lps'),
	(465435, 102, '2015-04-01 01:08:26.000000', 'consum', 0.0215, 'lps'),
	(465436, 102, '2015-04-01 01:08:27.000000', 'consum', 0.0227, 'lps'),
	(465437, 102, '2015-04-01 01:08:28.000000', 'consum', 0.0219, 'lps'),
	(465438, 102, '2015-04-01 01:08:29.000000', 'consum', 0.0222, 'lps'),
	(465439, 102, '2015-04-01 01:08:30.000000', 'consum', 0.0225, 'lps'),
	(465440, 102, '2015-04-01 01:08:31.000000', 'consum', 0.0227, 'lps'),
	(465441, 102, '2015-04-01 01:08:32.000000', 'consum', 0.0211, 'lps'),
	(465442, 102, '2015-04-01 01:08:33.000000', 'consum', 0.0224, 'lps'),
	(465443, 102, '2015-04-01 01:08:34.000000', 'consum', 0.0216, 'lps'),
	(465444, 102, '2015-04-01 01:08:35.000000', 'consum', 0.0219, 'lps'),
	(465445, 102, '2015-04-01 01:08:36.000000', 'consum', 0.0218, 'lps'),
	(465446, 102, '2015-04-01 01:08:37.000000', 'consum', 0.0224, 'lps'),
	(465447, 102, '2015-04-01 01:08:38.000000', 'consum', 0.0213, 'lps'),
	(465448, 102, '2015-04-01 01:08:39.000000', 'consum', 0.0228, 'lps'),
	(465449, 102, '2015-04-01 01:08:40.000000', 'consum', 0.0227, 'lps'),
	(465450, 102, '2015-04-01 01:08:41.000000', 'consum', 0.0221, 'lps'),
	(465451, 102, '2015-04-01 01:08:42.000000', 'consum', 0.0216, 'lps'),
	(465452, 102, '2015-04-01 01:08:43.000000', 'consum', 0.0226, 'lps'),
	(465453, 102, '2015-04-01 01:08:44.000000', 'consum', 0.0212, 'lps'),
	(465454, 102, '2015-04-01 01:08:45.000000', 'consum', 0.0215, 'lps'),
	(465455, 102, '2015-04-01 01:08:46.000000', 'consum', 0.0229, 'lps'),
	(465456, 102, '2015-04-01 01:08:47.000000', 'consum', 0.0226, 'lps'),
	(465457, 102, '2015-04-01 01:08:48.000000', 'consum', 0.0213, 'lps'),
	(465458, 102, '2015-04-01 01:08:49.000000', 'consum', 0.0218, 'lps'),
	(465459, 102, '2015-04-01 01:08:50.000000', 'consum', 0.0222, 'lps'),
	(465460, 102, '2015-04-01 01:08:51.000000', 'consum', 0.0226, 'lps'),
	(465461, 102, '2015-04-01 01:08:52.000000', 'consum', 0.0212, 'lps'),
	(465462, 102, '2015-04-01 01:08:53.000000', 'consum', 0.0216, 'lps'),
	(465463, 102, '2015-04-01 01:08:54.000000', 'consum', 0.0214, 'lps'),
	(465464, 102, '2015-04-01 01:08:55.000000', 'consum', 0.0213, 'lps'),
	(465465, 102, '2015-04-01 01:08:56.000000', 'consum', 0.0214, 'lps'),
	(465466, 102, '2015-04-01 01:08:57.000000', 'consum', 0.0222, 'lps'),
	(465467, 102, '2015-04-01 01:08:58.000000', 'consum', 0.0215, 'lps'),
	(465468, 102, '2015-04-01 01:08:59.000000', 'consum', 0.0220, 'lps'),
	(465469, 102, '2015-04-01 01:09:00.000000', 'consum', 0.0224, 'lps'),
	(465470, 102, '2015-04-01 01:09:01.000000', 'consum', 0.0230, 'lps'),
	(465471, 102, '2015-04-01 01:09:02.000000', 'consum', 0.0227, 'lps'),
	(465472, 102, '2015-04-01 01:09:03.000000', 'consum', 0.0215, 'lps'),
	(465473, 102, '2015-04-01 01:09:04.000000', 'consum', 0.0227, 'lps'),
	(465474, 102, '2015-04-01 01:09:05.000000', 'consum', 0.0217, 'lps'),
	(465475, 102, '2015-04-01 01:09:06.000000', 'consum', 0.0215, 'lps'),
	(465476, 102, '2015-04-01 01:09:07.000000', 'consum', 0.0215, 'lps'),
	(465477, 102, '2015-04-01 01:09:08.000000', 'consum', 0.0220, 'lps'),
	(465478, 102, '2015-04-01 01:09:09.000000', 'consum', 0.0223, 'lps'),
	(465479, 102, '2015-04-01 01:09:10.000000', 'consum', 0.0225, 'lps'),
	(465480, 102, '2015-04-01 01:09:11.000000', 'consum', 0.0225, 'lps'),
	(465481, 102, '2015-04-01 01:09:12.000000', 'consum', 0.0222, 'lps'),
	(465482, 102, '2015-04-01 01:09:13.000000', 'consum', 0.0225, 'lps'),
	(465483, 102, '2015-04-01 01:09:14.000000', 'consum', 0.0229, 'lps'),
	(465484, 102, '2015-04-01 01:09:15.000000', 'consum', 0.0219, 'lps'),
	(465485, 102, '2015-04-01 01:09:16.000000', 'consum', 0.0217, 'lps'),
	(465486, 102, '2015-04-01 01:09:17.000000', 'consum', 0.0220, 'lps'),
	(465487, 102, '2015-04-01 01:09:18.000000', 'consum', 0.0219, 'lps'),
	(465488, 102, '2015-04-01 01:09:19.000000', 'consum', 0.0223, 'lps'),
	(465489, 102, '2015-04-01 01:09:20.000000', 'consum', 0.0230, 'lps'),
	(465490, 102, '2015-04-01 01:09:21.000000', 'consum', 0.0227, 'lps'),
	(465491, 102, '2015-04-01 01:09:22.000000', 'consum', 0.0217, 'lps'),
	(465492, 102, '2015-04-01 01:09:23.000000', 'consum', 0.0214, 'lps'),
	(465493, 102, '2015-04-01 01:09:24.000000', 'consum', 0.0212, 'lps'),
	(465494, 102, '2015-04-01 01:09:25.000000', 'consum', 0.0227, 'lps'),
	(465495, 102, '2015-04-01 01:09:26.000000', 'consum', 0.0226, 'lps'),
	(465496, 102, '2015-04-01 01:09:27.000000', 'consum', 0.0219, 'lps'),
	(465497, 102, '2015-04-01 01:09:28.000000', 'consum', 0.0228, 'lps'),
	(465498, 102, '2015-04-01 01:09:29.000000', 'consum', 0.0211, 'lps'),
	(465499, 102, '2015-04-01 01:09:30.000000', 'consum', 0.0227, 'lps'),
	(465500, 102, '2015-04-01 01:09:31.000000', 'consum', 0.0226, 'lps'),
	(465501, 102, '2015-04-01 01:09:32.000000', 'consum', 0.0221, 'lps'),
	(465502, 102, '2015-04-01 01:09:33.000000', 'consum', 0.0217, 'lps'),
	(465503, 102, '2015-04-01 01:09:34.000000', 'consum', 0.0211, 'lps'),
	(465504, 102, '2015-04-01 01:09:35.000000', 'consum', 0.0216, 'lps'),
	(465505, 102, '2015-04-01 01:09:36.000000', 'consum', 0.0216, 'lps'),
	(465506, 102, '2015-04-01 01:09:37.000000', 'consum', 0.0222, 'lps'),
	(465507, 102, '2015-04-01 01:09:38.000000', 'consum', 0.0213, 'lps'),
	(465508, 102, '2015-04-01 01:09:39.000000', 'consum', 0.0210, 'lps'),
	(465509, 102, '2015-04-01 01:09:40.000000', 'consum', 0.0222, 'lps'),
	(465510, 102, '2015-04-01 01:09:41.000000', 'consum', 0.0227, 'lps'),
	(465511, 102, '2015-04-01 01:09:42.000000', 'consum', 0.0218, 'lps'),
	(465512, 102, '2015-04-01 01:09:43.000000', 'consum', 0.0220, 'lps'),
	(465513, 102, '2015-04-01 01:09:44.000000', 'consum', 0.0215, 'lps'),
	(465514, 102, '2015-04-01 01:09:45.000000', 'consum', 0.0227, 'lps'),
	(465515, 102, '2015-04-01 01:09:46.000000', 'consum', 0.0216, 'lps'),
	(465516, 102, '2015-04-01 01:09:47.000000', 'consum', 0.0213, 'lps'),
	(465517, 123, '2015-04-01 00:00:00.000000', 'consum', 0.0220, 'lps'),
	(465518, 123, '2015-04-01 00:00:01.000000', 'consum', 0.0232, 'lps'),
	(465519, 123, '2015-04-01 00:00:02.000000', 'consum', 0.0233, 'lps'),
	(465520, 123, '2015-04-01 00:00:03.000000', 'consum', 0.0231, 'lps'),
	(465521, 123, '2015-04-01 00:00:04.000000', 'consum', 0.0219, 'lps'),
	(465522, 123, '2015-04-01 00:00:05.000000', 'consum', 0.0223, 'lps'),
	(465523, 123, '2015-04-01 00:00:06.000000', 'consum', 0.0219, 'lps'),
	(465524, 123, '2015-04-01 00:00:07.000000', 'consum', 0.0214, 'lps'),
	(465525, 123, '2015-04-01 00:00:08.000000', 'consum', 0.0235, 'lps'),
	(465526, 123, '2015-04-01 00:00:09.000000', 'consum', 0.0211, 'lps'),
	(465527, 123, '2015-04-01 00:00:10.000000', 'consum', 0.0226, 'lps'),
	(465528, 123, '2015-04-01 00:00:11.000000', 'consum', 0.0231, 'lps'),
	(465529, 123, '2015-04-01 00:00:12.000000', 'consum', 0.0237, 'lps'),
	(465530, 123, '2015-04-01 00:00:13.000000', 'consum', 0.0229, 'lps'),
	(465531, 123, '2015-04-01 00:00:14.000000', 'consum', 0.0225, 'lps'),
	(465532, 123, '2015-04-01 00:00:15.000000', 'consum', 0.0229, 'lps'),
	(465533, 123, '2015-04-01 00:00:16.000000', 'consum', 0.0232, 'lps'),
	(465534, 123, '2015-04-01 00:00:17.000000', 'consum', 0.0234, 'lps'),
	(465535, 123, '2015-04-01 00:00:18.000000', 'consum', 0.0236, 'lps'),
	(465536, 123, '2015-04-01 00:00:19.000000', 'consum', 0.0213, 'lps'),
	(465537, 123, '2015-04-01 00:00:20.000000', 'consum', 0.0232, 'lps'),
	(465538, 123, '2015-04-01 00:00:21.000000', 'consum', 0.0227, 'lps'),
	(465539, 123, '2015-04-01 00:00:22.000000', 'consum', 0.0230, 'lps'),
	(465540, 123, '2015-04-01 00:00:23.000000', 'consum', 0.0232, 'lps'),
	(465541, 123, '2015-04-01 00:00:24.000000', 'consum', 0.0233, 'lps'),
	(465542, 123, '2015-04-01 00:00:25.000000', 'consum', 0.0232, 'lps'),
	(465543, 123, '2015-04-01 00:00:26.000000', 'consum', 0.0223, 'lps'),
	(465544, 123, '2015-04-01 00:00:27.000000', 'consum', 0.0236, 'lps'),
	(465545, 123, '2015-04-01 00:00:28.000000', 'consum', 0.0219, 'lps'),
	(465546, 123, '2015-04-01 00:00:29.000000', 'consum', 0.0233, 'lps'),
	(465547, 123, '2015-04-01 00:00:30.000000', 'consum', 0.0216, 'lps'),
	(465548, 123, '2015-04-01 00:00:31.000000', 'consum', 0.0226, 'lps'),
	(465549, 123, '2015-04-01 00:00:32.000000', 'consum', 0.0218, 'lps'),
	(465550, 123, '2015-04-01 00:00:33.000000', 'consum', 0.0229, 'lps'),
	(465551, 123, '2015-04-01 00:00:34.000000', 'consum', 0.0225, 'lps'),
	(465552, 123, '2015-04-01 00:00:35.000000', 'consum', 0.0230, 'lps'),
	(465553, 123, '2015-04-01 00:00:36.000000', 'consum', 0.0210, 'lps'),
	(465554, 123, '2015-04-01 00:00:37.000000', 'consum', 0.0233, 'lps'),
	(465555, 123, '2015-04-01 00:00:38.000000', 'consum', 0.0214, 'lps'),
	(465556, 123, '2015-04-01 00:00:39.000000', 'consum', 0.0219, 'lps'),
	(465557, 123, '2015-04-01 00:00:40.000000', 'consum', 0.0216, 'lps'),
	(465558, 123, '2015-04-01 00:00:41.000000', 'consum', 0.0212, 'lps'),
	(465559, 123, '2015-04-01 00:00:42.000000', 'consum', 0.0229, 'lps'),
	(465560, 123, '2015-04-01 00:00:43.000000', 'consum', 0.0215, 'lps'),
	(465561, 123, '2015-04-01 00:00:44.000000', 'consum', 0.0237, 'lps'),
	(465562, 123, '2015-04-01 00:00:45.000000', 'consum', 0.0219, 'lps'),
	(465563, 123, '2015-04-01 00:00:46.000000', 'consum', 0.0228, 'lps'),
	(465564, 123, '2015-04-01 00:00:47.000000', 'consum', 0.0219, 'lps'),
	(465565, 123, '2015-04-01 00:00:48.000000', 'consum', 0.0231, 'lps'),
	(465566, 123, '2015-04-01 00:00:49.000000', 'consum', 0.0229, 'lps'),
	(465567, 123, '2015-04-01 00:00:50.000000', 'consum', 0.0217, 'lps'),
	(465568, 123, '2015-04-01 00:00:51.000000', 'consum', 0.0214, 'lps'),
	(465569, 123, '2015-04-01 00:00:52.000000', 'consum', 0.0213, 'lps'),
	(465570, 123, '2015-04-01 00:00:53.000000', 'consum', 0.0211, 'lps'),
	(465571, 123, '2015-04-01 00:00:54.000000', 'consum', 0.0234, 'lps'),
	(465572, 123, '2015-04-01 00:00:55.000000', 'consum', 0.0217, 'lps'),
	(465573, 123, '2015-04-01 00:00:56.000000', 'consum', 0.0227, 'lps'),
	(465574, 123, '2015-04-01 00:00:57.000000', 'consum', 0.0221, 'lps'),
	(465575, 123, '2015-04-01 00:00:58.000000', 'consum', 0.0215, 'lps'),
	(465576, 123, '2015-04-01 00:00:59.000000', 'consum', 0.0231, 'lps'),
	(465577, 123, '2015-04-01 00:01:00.000000', 'consum', 0.0214, 'lps'),
	(465578, 123, '2015-04-01 00:01:01.000000', 'consum', 0.0224, 'lps'),
	(465579, 123, '2015-04-01 00:01:02.000000', 'consum', 0.0214, 'lps'),
	(465580, 123, '2015-04-01 00:01:03.000000', 'consum', 0.0218, 'lps'),
	(465581, 123, '2015-04-01 00:01:04.000000', 'consum', 0.0236, 'lps'),
	(465582, 123, '2015-04-01 00:01:05.000000', 'consum', 0.0232, 'lps'),
	(465583, 123, '2015-04-01 00:01:06.000000', 'consum', 0.0216, 'lps'),
	(465584, 123, '2015-04-01 00:01:07.000000', 'consum', 0.0228, 'lps'),
	(465585, 123, '2015-04-01 00:01:08.000000', 'consum', 0.0229, 'lps'),
	(465586, 123, '2015-04-01 00:01:09.000000', 'consum', 0.0222, 'lps'),
	(465587, 123, '2015-04-01 00:01:10.000000', 'consum', 0.0214, 'lps'),
	(465588, 123, '2015-04-01 00:01:11.000000', 'consum', 0.0224, 'lps'),
	(465589, 123, '2015-04-01 00:01:12.000000', 'consum', 0.0211, 'lps'),
	(465590, 123, '2015-04-01 00:01:13.000000', 'consum', 0.0229, 'lps'),
	(465591, 123, '2015-04-01 00:01:14.000000', 'consum', 0.0220, 'lps'),
	(465592, 123, '2015-04-01 00:01:15.000000', 'consum', 0.0230, 'lps'),
	(465593, 123, '2015-04-01 00:01:16.000000', 'consum', 0.0223, 'lps'),
	(465594, 123, '2015-04-01 00:01:17.000000', 'consum', 0.0219, 'lps'),
	(465595, 123, '2015-04-01 00:01:18.000000', 'consum', 0.0213, 'lps'),
	(465596, 123, '2015-04-01 00:01:19.000000', 'consum', 0.0228, 'lps'),
	(465597, 123, '2015-04-01 00:01:20.000000', 'consum', 0.0235, 'lps'),
	(465598, 123, '2015-04-01 00:01:21.000000', 'consum', 0.0228, 'lps'),
	(465599, 123, '2015-04-01 00:01:22.000000', 'consum', 0.0222, 'lps'),
	(465600, 123, '2015-04-01 00:01:23.000000', 'consum', 0.0218, 'lps'),
	(465601, 123, '2015-04-01 00:01:24.000000', 'consum', 0.0216, 'lps'),
	(465602, 123, '2015-04-01 00:01:25.000000', 'consum', 0.0217, 'lps'),
	(465603, 123, '2015-04-01 00:01:26.000000', 'consum', 0.0225, 'lps'),
	(465604, 123, '2015-04-01 00:01:27.000000', 'consum', 0.0236, 'lps'),
	(465605, 123, '2015-04-01 00:01:28.000000', 'consum', 0.0211, 'lps'),
	(465606, 123, '2015-04-01 00:01:29.000000', 'consum', 0.0220, 'lps'),
	(465607, 123, '2015-04-01 00:01:30.000000', 'consum', 0.0233, 'lps'),
	(465608, 123, '2015-04-01 00:01:31.000000', 'consum', 0.0212, 'lps'),
	(465609, 123, '2015-04-01 00:01:32.000000', 'consum', 0.0233, 'lps'),
	(465610, 123, '2015-04-01 00:01:33.000000', 'consum', 0.0236, 'lps'),
	(465611, 123, '2015-04-01 00:01:34.000000', 'consum', 0.0216, 'lps'),
	(465612, 123, '2015-04-01 00:01:35.000000', 'consum', 0.0217, 'lps'),
	(465613, 123, '2015-04-01 00:01:36.000000', 'consum', 0.0228, 'lps'),
	(465614, 123, '2015-04-01 00:01:37.000000', 'consum', 0.0224, 'lps'),
	(465615, 123, '2015-04-01 00:01:38.000000', 'consum', 0.0227, 'lps'),
	(465616, 123, '2015-04-01 00:01:39.000000', 'consum', 0.0226, 'lps'),
	(465617, 123, '2015-04-01 00:01:40.000000', 'consum', 0.0210, 'lps'),
	(465618, 123, '2015-04-01 00:01:41.000000', 'consum', 0.0220, 'lps'),
	(465619, 123, '2015-04-01 00:01:42.000000', 'consum', 0.0231, 'lps'),
	(465620, 123, '2015-04-01 00:01:43.000000', 'consum', 0.0229, 'lps'),
	(465621, 123, '2015-04-01 00:01:44.000000', 'consum', 0.0215, 'lps'),
	(465622, 123, '2015-04-01 00:01:45.000000', 'consum', 0.0235, 'lps'),
	(465623, 123, '2015-04-01 00:01:46.000000', 'consum', 0.0237, 'lps'),
	(465624, 123, '2015-04-01 00:01:47.000000', 'consum', 0.0216, 'lps'),
	(465625, 123, '2015-04-01 00:01:48.000000', 'consum', 0.0214, 'lps'),
	(465626, 123, '2015-04-01 00:01:49.000000', 'consum', 0.0211, 'lps'),
	(465627, 123, '2015-04-01 00:01:50.000000', 'consum', 0.0233, 'lps'),
	(465628, 123, '2015-04-01 00:01:51.000000', 'consum', 0.0212, 'lps'),
	(465629, 123, '2015-04-01 00:01:52.000000', 'consum', 0.0236, 'lps'),
	(465630, 123, '2015-04-01 00:01:53.000000', 'consum', 0.0219, 'lps'),
	(465631, 123, '2015-04-01 00:01:54.000000', 'consum', 0.0237, 'lps'),
	(465632, 123, '2015-04-01 00:01:55.000000', 'consum', 0.0234, 'lps'),
	(465633, 123, '2015-04-01 00:01:56.000000', 'consum', 0.0221, 'lps'),
	(465634, 123, '2015-04-01 00:01:57.000000', 'consum', 0.0219, 'lps'),
	(465635, 123, '2015-04-01 00:01:58.000000', 'consum', 0.0226, 'lps'),
	(465636, 123, '2015-04-01 00:01:59.000000', 'consum', 0.0234, 'lps'),
	(465637, 123, '2015-04-01 00:02:00.000000', 'consum', 0.0228, 'lps'),
	(465638, 123, '2015-04-01 00:02:01.000000', 'consum', 0.0228, 'lps'),
	(465639, 123, '2015-04-01 00:02:02.000000', 'consum', 0.0219, 'lps'),
	(465640, 123, '2015-04-01 00:02:03.000000', 'consum', 0.0230, 'lps'),
	(465641, 123, '2015-04-01 00:02:04.000000', 'consum', 0.0228, 'lps'),
	(465642, 123, '2015-04-01 00:02:05.000000', 'consum', 0.0211, 'lps'),
	(465643, 123, '2015-04-01 00:02:06.000000', 'consum', 0.0219, 'lps'),
	(465644, 123, '2015-04-01 00:02:07.000000', 'consum', 0.0224, 'lps'),
	(465645, 123, '2015-04-01 00:02:08.000000', 'consum', 0.0225, 'lps'),
	(465646, 123, '2015-04-01 00:02:09.000000', 'consum', 0.0216, 'lps'),
	(465647, 123, '2015-04-01 00:02:10.000000', 'consum', 0.0225, 'lps'),
	(465648, 123, '2015-04-01 00:02:11.000000', 'consum', 0.0211, 'lps'),
	(465649, 123, '2015-04-01 00:02:12.000000', 'consum', 0.0227, 'lps'),
	(465650, 123, '2015-04-01 00:02:13.000000', 'consum', 0.0236, 'lps'),
	(465651, 123, '2015-04-01 00:02:14.000000', 'consum', 0.0234, 'lps'),
	(465652, 123, '2015-04-01 00:02:15.000000', 'consum', 0.0225, 'lps'),
	(465653, 123, '2015-04-01 00:02:16.000000', 'consum', 0.0212, 'lps'),
	(465654, 123, '2015-04-01 00:02:17.000000', 'consum', 0.0232, 'lps'),
	(465655, 123, '2015-04-01 00:02:18.000000', 'consum', 0.0230, 'lps'),
	(465656, 123, '2015-04-01 00:02:19.000000', 'consum', 0.0215, 'lps'),
	(465657, 123, '2015-04-01 00:02:20.000000', 'consum', 0.0233, 'lps'),
	(465658, 123, '2015-04-01 00:02:21.000000', 'consum', 0.0227, 'lps'),
	(465659, 123, '2015-04-01 00:02:22.000000', 'consum', 0.0227, 'lps'),
	(465660, 123, '2015-04-01 00:02:23.000000', 'consum', 0.0217, 'lps'),
	(465661, 123, '2015-04-01 00:02:24.000000', 'consum', 0.0223, 'lps'),
	(465662, 123, '2015-04-01 00:02:25.000000', 'consum', 0.0226, 'lps'),
	(465663, 123, '2015-04-01 00:02:26.000000', 'consum', 0.0223, 'lps'),
	(465664, 123, '2015-04-01 00:02:27.000000', 'consum', 0.0228, 'lps'),
	(465665, 123, '2015-04-01 00:02:28.000000', 'consum', 0.0233, 'lps'),
	(465666, 123, '2015-04-01 00:02:29.000000', 'consum', 0.0215, 'lps'),
	(465667, 123, '2015-04-01 00:02:30.000000', 'consum', 0.0223, 'lps'),
	(465668, 123, '2015-04-01 00:02:31.000000', 'consum', 0.0234, 'lps'),
	(465669, 123, '2015-04-01 00:02:32.000000', 'consum', 0.0236, 'lps'),
	(465670, 123, '2015-04-01 00:02:33.000000', 'consum', 0.0214, 'lps'),
	(465671, 123, '2015-04-01 00:02:34.000000', 'consum', 0.0233, 'lps'),
	(465672, 123, '2015-04-01 00:02:35.000000', 'consum', 0.0229, 'lps'),
	(465673, 123, '2015-04-01 00:02:36.000000', 'consum', 0.0237, 'lps'),
	(465674, 123, '2015-04-01 00:02:37.000000', 'consum', 0.0234, 'lps'),
	(465675, 123, '2015-04-01 00:02:38.000000', 'consum', 0.0222, 'lps'),
	(465676, 123, '2015-04-01 00:02:39.000000', 'consum', 0.0225, 'lps'),
	(465677, 123, '2015-04-01 00:02:40.000000', 'consum', 0.0224, 'lps'),
	(465678, 123, '2015-04-01 00:02:41.000000', 'consum', 0.0233, 'lps'),
	(465679, 123, '2015-04-01 00:02:42.000000', 'consum', 0.0230, 'lps'),
	(465680, 123, '2015-04-01 00:02:43.000000', 'consum', 0.0212, 'lps'),
	(465681, 123, '2015-04-01 00:02:44.000000', 'consum', 0.0215, 'lps'),
	(465682, 123, '2015-04-01 00:02:45.000000', 'consum', 0.0230, 'lps'),
	(465683, 123, '2015-04-01 00:02:46.000000', 'consum', 0.0212, 'lps'),
	(465684, 123, '2015-04-01 00:02:47.000000', 'consum', 0.0215, 'lps'),
	(465685, 123, '2015-04-01 00:02:48.000000', 'consum', 0.0230, 'lps'),
	(465686, 123, '2015-04-01 00:02:49.000000', 'consum', 0.0212, 'lps'),
	(465687, 123, '2015-04-01 00:02:50.000000', 'consum', 0.0215, 'lps'),
	(465688, 123, '2015-04-01 00:02:51.000000', 'consum', 0.0231, 'lps'),
	(465689, 123, '2015-04-01 00:02:52.000000', 'consum', 0.0215, 'lps'),
	(465690, 123, '2015-04-01 00:02:53.000000', 'consum', 0.0229, 'lps'),
	(465691, 123, '2015-04-01 00:02:54.000000', 'consum', 0.0234, 'lps'),
	(465692, 123, '2015-04-01 00:02:55.000000', 'consum', 0.0217, 'lps'),
	(465693, 123, '2015-04-01 00:02:56.000000', 'consum', 0.0232, 'lps'),
	(465694, 123, '2015-04-01 00:02:57.000000', 'consum', 0.0215, 'lps'),
	(465695, 123, '2015-04-01 00:02:58.000000', 'consum', 0.0224, 'lps'),
	(465696, 123, '2015-04-01 00:02:59.000000', 'consum', 0.0212, 'lps'),
	(465697, 123, '2015-04-01 00:03:00.000000', 'consum', 0.0232, 'lps'),
	(465698, 123, '2015-04-01 00:03:01.000000', 'consum', 0.0230, 'lps'),
	(465699, 123, '2015-04-01 00:03:02.000000', 'consum', 0.0218, 'lps'),
	(465700, 123, '2015-04-01 00:03:03.000000', 'consum', 0.0216, 'lps'),
	(465701, 123, '2015-04-01 00:03:04.000000', 'consum', 0.0218, 'lps'),
	(465702, 123, '2015-04-01 00:03:05.000000', 'consum', 0.0233, 'lps'),
	(465703, 123, '2015-04-01 00:03:06.000000', 'consum', 0.0216, 'lps'),
	(465704, 123, '2015-04-01 00:03:07.000000', 'consum', 0.0229, 'lps'),
	(465705, 123, '2015-04-01 00:03:08.000000', 'consum', 0.0233, 'lps'),
	(465706, 123, '2015-04-01 00:03:09.000000', 'consum', 0.0210, 'lps'),
	(465707, 123, '2015-04-01 00:03:10.000000', 'consum', 0.0226, 'lps'),
	(465708, 123, '2015-04-01 00:03:11.000000', 'consum', 0.0234, 'lps'),
	(465709, 123, '2015-04-01 00:03:12.000000', 'consum', 0.0229, 'lps'),
	(465710, 123, '2015-04-01 00:03:13.000000', 'consum', 0.0231, 'lps'),
	(465711, 123, '2015-04-01 00:03:14.000000', 'consum', 0.0233, 'lps'),
	(465712, 123, '2015-04-01 00:03:15.000000', 'consum', 0.0231, 'lps'),
	(465713, 123, '2015-04-01 00:03:16.000000', 'consum', 0.0222, 'lps'),
	(465714, 123, '2015-04-01 00:03:17.000000', 'consum', 0.0233, 'lps'),
	(465715, 123, '2015-04-01 00:03:18.000000', 'consum', 0.0234, 'lps'),
	(465716, 123, '2015-04-01 00:03:19.000000', 'consum', 0.0233, 'lps'),
	(465717, 123, '2015-04-01 00:03:20.000000', 'consum', 0.0226, 'lps'),
	(465718, 123, '2015-04-01 00:03:21.000000', 'consum', 0.0220, 'lps'),
	(465719, 123, '2015-04-01 00:03:22.000000', 'consum', 0.0216, 'lps'),
	(465720, 123, '2015-04-01 00:03:23.000000', 'consum', 0.0235, 'lps'),
	(465721, 123, '2015-04-01 00:03:24.000000', 'consum', 0.0237, 'lps'),
	(465722, 123, '2015-04-01 00:03:25.000000', 'consum', 0.0211, 'lps'),
	(465723, 123, '2015-04-01 00:03:26.000000', 'consum', 0.0221, 'lps'),
	(465724, 123, '2015-04-01 00:03:27.000000', 'consum', 0.0234, 'lps'),
	(465725, 123, '2015-04-01 00:03:28.000000', 'consum', 0.0215, 'lps'),
	(465726, 123, '2015-04-01 00:03:29.000000', 'consum', 0.0217, 'lps'),
	(465727, 123, '2015-04-01 00:03:30.000000', 'consum', 0.0234, 'lps'),
	(465728, 123, '2015-04-01 00:03:31.000000', 'consum', 0.0222, 'lps'),
	(465729, 123, '2015-04-01 00:03:32.000000', 'consum', 0.0227, 'lps'),
	(465730, 123, '2015-04-01 00:03:33.000000', 'consum', 0.0231, 'lps'),
	(465731, 123, '2015-04-01 00:03:34.000000', 'consum', 0.0237, 'lps'),
	(465732, 123, '2015-04-01 00:03:35.000000', 'consum', 0.0229, 'lps'),
	(465733, 123, '2015-04-01 00:03:36.000000', 'consum', 0.0222, 'lps'),
	(465734, 123, '2015-04-01 00:03:37.000000', 'consum', 0.0212, 'lps'),
	(465735, 123, '2015-04-01 00:03:38.000000', 'consum', 0.0215, 'lps'),
	(465736, 123, '2015-04-01 00:03:39.000000', 'consum', 0.0230, 'lps'),
	(465737, 123, '2015-04-01 00:03:40.000000', 'consum', 0.0211, 'lps'),
	(465738, 123, '2015-04-01 00:03:41.000000', 'consum', 0.0212, 'lps'),
	(465739, 123, '2015-04-01 00:03:42.000000', 'consum', 0.0215, 'lps'),
	(465740, 123, '2015-04-01 00:03:43.000000', 'consum', 0.0232, 'lps'),
	(465741, 123, '2015-04-01 00:03:44.000000', 'consum', 0.0221, 'lps'),
	(465742, 123, '2015-04-01 00:03:45.000000', 'consum', 0.0227, 'lps'),
	(465743, 123, '2015-04-01 00:03:46.000000', 'consum', 0.0236, 'lps'),
	(465744, 123, '2015-04-01 00:03:47.000000', 'consum', 0.0234, 'lps'),
	(465745, 123, '2015-04-01 00:03:48.000000', 'consum', 0.0223, 'lps'),
	(465746, 123, '2015-04-01 00:03:49.000000', 'consum', 0.0232, 'lps'),
	(465747, 123, '2015-04-01 00:03:50.000000', 'consum', 0.0224, 'lps'),
	(465748, 123, '2015-04-01 00:03:51.000000', 'consum', 0.0216, 'lps'),
	(465749, 123, '2015-04-01 00:03:52.000000', 'consum', 0.0227, 'lps'),
	(465750, 123, '2015-04-01 00:03:53.000000', 'consum', 0.0221, 'lps'),
	(465751, 123, '2015-04-01 00:03:54.000000', 'consum', 0.0213, 'lps'),
	(465752, 123, '2015-04-01 00:03:55.000000', 'consum', 0.0220, 'lps'),
	(465753, 123, '2015-04-01 00:03:56.000000', 'consum', 0.0226, 'lps'),
	(465754, 123, '2015-04-01 00:03:57.000000', 'consum', 0.0232, 'lps'),
	(465755, 123, '2015-04-01 00:03:58.000000', 'consum', 0.0215, 'lps'),
	(465756, 123, '2015-04-01 00:03:59.000000', 'consum', 0.0226, 'lps'),
	(465757, 123, '2015-04-01 00:04:00.000000', 'consum', 0.0221, 'lps'),
	(465758, 123, '2015-04-01 00:04:01.000000', 'consum', 0.0218, 'lps'),
	(465759, 123, '2015-04-01 00:04:02.000000', 'consum', 0.0216, 'lps'),
	(465760, 123, '2015-04-01 00:04:03.000000', 'consum', 0.0216, 'lps'),
	(465761, 123, '2015-04-01 00:04:04.000000', 'consum', 0.0221, 'lps'),
	(465762, 123, '2015-04-01 00:04:05.000000', 'consum', 0.0222, 'lps'),
	(465763, 123, '2015-04-01 00:04:06.000000', 'consum', 0.0235, 'lps'),
	(465764, 123, '2015-04-01 00:04:07.000000', 'consum', 0.0218, 'lps'),
	(465765, 123, '2015-04-01 00:04:08.000000', 'consum', 0.0229, 'lps'),
	(465766, 123, '2015-04-01 00:04:09.000000', 'consum', 0.0226, 'lps'),
	(465767, 123, '2015-04-01 00:04:10.000000', 'consum', 0.0236, 'lps'),
	(465768, 123, '2015-04-01 00:04:11.000000', 'consum', 0.0233, 'lps'),
	(465769, 123, '2015-04-01 00:04:12.000000', 'consum', 0.0221, 'lps'),
	(465770, 123, '2015-04-01 00:04:13.000000', 'consum', 0.0224, 'lps'),
	(465771, 123, '2015-04-01 00:04:14.000000', 'consum', 0.0218, 'lps'),
	(465772, 123, '2015-04-01 00:04:15.000000', 'consum', 0.0210, 'lps'),
	(465773, 123, '2015-04-01 00:04:16.000000', 'consum', 0.0213, 'lps'),
	(465774, 123, '2015-04-01 00:04:17.000000', 'consum', 0.0225, 'lps'),
	(465775, 123, '2015-04-01 00:04:18.000000', 'consum', 0.0220, 'lps'),
	(465776, 123, '2015-04-01 00:04:19.000000', 'consum', 0.0216, 'lps'),
	(465777, 123, '2015-04-01 00:04:20.000000', 'consum', 0.0210, 'lps'),
	(465778, 123, '2015-04-01 00:04:21.000000', 'consum', 0.0223, 'lps'),
	(465779, 123, '2015-04-01 00:04:22.000000', 'consum', 0.0218, 'lps'),
	(465780, 123, '2015-04-01 00:04:23.000000', 'consum', 0.0211, 'lps'),
	(465781, 123, '2015-04-01 00:04:24.000000', 'consum', 0.0221, 'lps'),
	(465782, 123, '2015-04-01 00:04:25.000000', 'consum', 0.0233, 'lps'),
	(465783, 123, '2015-04-01 00:04:26.000000', 'consum', 0.0236, 'lps'),
	(465784, 123, '2015-04-01 00:04:27.000000', 'consum', 0.0217, 'lps'),
	(465785, 123, '2015-04-01 00:04:28.000000', 'consum', 0.0225, 'lps'),
	(465786, 123, '2015-04-01 00:04:29.000000', 'consum', 0.0234, 'lps'),
	(465787, 123, '2015-04-01 00:04:30.000000', 'consum', 0.0231, 'lps'),
	(465788, 123, '2015-04-01 00:04:31.000000', 'consum', 0.0215, 'lps'),
	(465789, 123, '2015-04-01 00:04:32.000000', 'consum', 0.0229, 'lps'),
	(465790, 123, '2015-04-01 00:04:33.000000', 'consum', 0.0234, 'lps'),
	(465791, 123, '2015-04-01 00:04:34.000000', 'consum', 0.0217, 'lps'),
	(465792, 123, '2015-04-01 00:04:35.000000', 'consum', 0.0232, 'lps'),
	(465793, 123, '2015-04-01 00:04:36.000000', 'consum', 0.0213, 'lps'),
	(465794, 123, '2015-04-01 00:04:37.000000', 'consum', 0.0218, 'lps'),
	(465795, 123, '2015-04-01 00:04:38.000000', 'consum', 0.0212, 'lps'),
	(465796, 123, '2015-04-01 00:04:39.000000', 'consum', 0.0224, 'lps'),
	(465797, 123, '2015-04-01 00:04:40.000000', 'consum', 0.0219, 'lps'),
	(465798, 123, '2015-04-01 00:04:41.000000', 'consum', 0.0214, 'lps'),
	(465799, 123, '2015-04-01 00:04:42.000000', 'consum', 0.0232, 'lps'),
	(465800, 123, '2015-04-01 00:04:43.000000', 'consum', 0.0222, 'lps'),
	(465801, 123, '2015-04-01 00:04:44.000000', 'consum', 0.0235, 'lps'),
	(465802, 123, '2015-04-01 00:04:45.000000', 'consum', 0.0213, 'lps'),
	(465803, 123, '2015-04-01 00:04:46.000000', 'consum', 0.0234, 'lps'),
	(465804, 123, '2015-04-01 00:04:47.000000', 'consum', 0.0212, 'lps'),
	(465805, 123, '2015-04-01 00:04:48.000000', 'consum', 0.0232, 'lps'),
	(465806, 123, '2015-04-01 00:04:49.000000', 'consum', 0.0230, 'lps'),
	(465807, 123, '2015-04-01 00:04:50.000000', 'consum', 0.0216, 'lps'),
	(465808, 123, '2015-04-01 00:04:51.000000', 'consum', 0.0236, 'lps'),
	(465809, 123, '2015-04-01 00:04:52.000000', 'consum', 0.0210, 'lps'),
	(465810, 123, '2015-04-01 00:04:53.000000', 'consum', 0.0216, 'lps'),
	(465811, 123, '2015-04-01 00:04:54.000000', 'consum', 0.0212, 'lps'),
	(465812, 123, '2015-04-01 00:04:55.000000', 'consum', 0.0234, 'lps'),
	(465813, 123, '2015-04-01 00:04:56.000000', 'consum', 0.0237, 'lps'),
	(465814, 123, '2015-04-01 00:04:57.000000', 'consum', 0.0218, 'lps'),
	(465815, 123, '2015-04-01 00:04:58.000000', 'consum', 0.0225, 'lps'),
	(465816, 123, '2015-04-01 00:04:59.000000', 'consum', 0.0232, 'lps'),
	(465817, 123, '2015-04-01 00:05:00.000000', 'consum', 0.0222, 'lps'),
	(465818, 123, '2015-04-01 00:05:01.000000', 'consum', 0.0231, 'lps'),
	(465819, 123, '2015-04-01 00:05:02.000000', 'consum', 0.0223, 'lps'),
	(465820, 123, '2015-04-01 00:05:03.000000', 'consum', 0.0214, 'lps'),
	(465821, 123, '2015-04-01 00:05:04.000000', 'consum', 0.0219, 'lps'),
	(465822, 123, '2015-04-01 00:05:05.000000', 'consum', 0.0214, 'lps'),
	(465823, 123, '2015-04-01 00:05:06.000000', 'consum', 0.0232, 'lps'),
	(465824, 123, '2015-04-01 00:05:07.000000', 'consum', 0.0223, 'lps'),
	(465825, 123, '2015-04-01 00:05:08.000000', 'consum', 0.0210, 'lps'),
	(465826, 123, '2015-04-01 00:05:09.000000', 'consum', 0.0227, 'lps'),
	(465827, 123, '2015-04-01 00:05:10.000000', 'consum', 0.0212, 'lps'),
	(465828, 123, '2015-04-01 00:05:11.000000', 'consum', 0.0226, 'lps'),
	(465829, 123, '2015-04-01 00:05:12.000000', 'consum', 0.0228, 'lps'),
	(465830, 123, '2015-04-01 00:05:13.000000', 'consum', 0.0223, 'lps'),
	(465831, 123, '2015-04-01 00:05:14.000000', 'consum', 0.0223, 'lps'),
	(465832, 123, '2015-04-01 00:05:15.000000', 'consum', 0.0210, 'lps'),
	(465833, 123, '2015-04-01 00:05:16.000000', 'consum', 0.0224, 'lps'),
	(465834, 123, '2015-04-01 00:05:17.000000', 'consum', 0.0227, 'lps'),
	(465835, 123, '2015-04-01 00:05:18.000000', 'consum', 0.0227, 'lps'),
	(465836, 123, '2015-04-01 00:05:19.000000', 'consum', 0.0213, 'lps'),
	(465837, 123, '2015-04-01 00:05:20.000000', 'consum', 0.0234, 'lps'),
	(465838, 123, '2015-04-01 00:05:21.000000', 'consum', 0.0236, 'lps'),
	(465839, 123, '2015-04-01 00:05:22.000000', 'consum', 0.0211, 'lps'),
	(465840, 123, '2015-04-01 00:05:23.000000', 'consum', 0.0225, 'lps'),
	(465841, 123, '2015-04-01 00:05:24.000000', 'consum', 0.0223, 'lps'),
	(465842, 123, '2015-04-01 00:05:25.000000', 'consum', 0.0231, 'lps'),
	(465843, 123, '2015-04-01 00:05:26.000000', 'consum', 0.0221, 'lps'),
	(465844, 123, '2015-04-01 00:05:27.000000', 'consum', 0.0231, 'lps'),
	(465845, 123, '2015-04-01 00:05:28.000000', 'consum', 0.0225, 'lps'),
	(465846, 123, '2015-04-01 00:05:29.000000', 'consum', 0.0224, 'lps'),
	(465847, 123, '2015-04-01 00:05:30.000000', 'consum', 0.0236, 'lps'),
	(465848, 123, '2015-04-01 00:05:31.000000', 'consum', 0.0216, 'lps'),
	(465849, 123, '2015-04-01 00:05:32.000000', 'consum', 0.0216, 'lps'),
	(465850, 123, '2015-04-01 00:05:33.000000', 'consum', 0.0225, 'lps'),
	(465851, 123, '2015-04-01 00:05:34.000000', 'consum', 0.0237, 'lps'),
	(465852, 123, '2015-04-01 00:05:35.000000', 'consum', 0.0216, 'lps'),
	(465853, 123, '2015-04-01 00:05:36.000000', 'consum', 0.0216, 'lps'),
	(465854, 123, '2015-04-01 00:05:37.000000', 'consum', 0.0224, 'lps'),
	(465855, 123, '2015-04-01 00:05:38.000000', 'consum', 0.0236, 'lps'),
	(465856, 123, '2015-04-01 00:05:39.000000', 'consum', 0.0211, 'lps'),
	(465857, 123, '2015-04-01 00:05:40.000000', 'consum', 0.0223, 'lps'),
	(465858, 123, '2015-04-01 00:05:41.000000', 'consum', 0.0217, 'lps'),
	(465859, 123, '2015-04-01 00:05:42.000000', 'consum', 0.0235, 'lps'),
	(465860, 123, '2015-04-01 00:05:43.000000', 'consum', 0.0230, 'lps'),
	(465861, 123, '2015-04-01 00:05:44.000000', 'consum', 0.0236, 'lps'),
	(465862, 123, '2015-04-01 00:05:45.000000', 'consum', 0.0223, 'lps'),
	(465863, 123, '2015-04-01 00:05:46.000000', 'consum', 0.0226, 'lps'),
	(465864, 123, '2015-04-01 00:05:47.000000', 'consum', 0.0224, 'lps'),
	(465865, 123, '2015-04-01 00:05:48.000000', 'consum', 0.0233, 'lps'),
	(465866, 123, '2015-04-01 00:05:49.000000', 'consum', 0.0228, 'lps'),
	(465867, 123, '2015-04-01 00:05:50.000000', 'consum', 0.0229, 'lps'),
	(465868, 123, '2015-04-01 00:05:51.000000', 'consum', 0.0226, 'lps'),
	(465869, 123, '2015-04-01 00:05:52.000000', 'consum', 0.0233, 'lps'),
	(465870, 123, '2015-04-01 00:05:53.000000', 'consum', 0.0222, 'lps'),
	(465871, 123, '2015-04-01 00:05:54.000000', 'consum', 0.0229, 'lps'),
	(465872, 123, '2015-04-01 00:05:55.000000', 'consum', 0.0213, 'lps'),
	(465873, 123, '2015-04-01 00:05:56.000000', 'consum', 0.0227, 'lps'),
	(465874, 123, '2015-04-01 00:05:57.000000', 'consum', 0.0228, 'lps'),
	(465875, 123, '2015-04-01 00:05:58.000000', 'consum', 0.0224, 'lps'),
	(465876, 123, '2015-04-01 00:05:59.000000', 'consum', 0.0226, 'lps'),
	(465877, 123, '2015-04-01 00:06:00.000000', 'consum', 0.0219, 'lps'),
	(465878, 123, '2015-04-01 00:06:01.000000', 'consum', 0.0237, 'lps'),
	(465879, 123, '2015-04-01 00:06:02.000000', 'consum', 0.0234, 'lps'),
	(465880, 123, '2015-04-01 00:06:03.000000', 'consum', 0.0223, 'lps'),
	(465881, 123, '2015-04-01 00:06:04.000000', 'consum', 0.0230, 'lps'),
	(465882, 123, '2015-04-01 00:06:05.000000', 'consum', 0.0214, 'lps'),
	(465883, 123, '2015-04-01 00:06:06.000000', 'consum', 0.0226, 'lps'),
	(465884, 123, '2015-04-01 00:06:07.000000', 'consum', 0.0225, 'lps'),
	(465885, 123, '2015-04-01 00:06:08.000000', 'consum', 0.0237, 'lps'),
	(465886, 123, '2015-04-01 00:06:09.000000', 'consum', 0.0214, 'lps'),
	(465887, 123, '2015-04-01 00:06:10.000000', 'consum', 0.0237, 'lps'),
	(465888, 123, '2015-04-01 00:06:11.000000', 'consum', 0.0221, 'lps'),
	(465889, 123, '2015-04-01 00:06:12.000000', 'consum', 0.0211, 'lps'),
	(465890, 123, '2015-04-01 00:06:13.000000', 'consum', 0.0212, 'lps'),
	(465891, 123, '2015-04-01 00:06:14.000000', 'consum', 0.0216, 'lps'),
	(465892, 123, '2015-04-01 00:06:15.000000', 'consum', 0.0236, 'lps'),
	(465893, 123, '2015-04-01 00:06:16.000000', 'consum', 0.0212, 'lps'),
	(465894, 123, '2015-04-01 00:06:17.000000', 'consum', 0.0223, 'lps'),
	(465895, 123, '2015-04-01 00:06:18.000000', 'consum', 0.0217, 'lps'),
	(465896, 123, '2015-04-01 00:06:19.000000', 'consum', 0.0232, 'lps'),
	(465897, 123, '2015-04-01 00:06:20.000000', 'consum', 0.0215, 'lps'),
	(465898, 123, '2015-04-01 00:06:21.000000', 'consum', 0.0227, 'lps'),
	(465899, 123, '2015-04-01 00:06:22.000000', 'consum', 0.0225, 'lps'),
	(465900, 123, '2015-04-01 00:06:23.000000', 'consum', 0.0233, 'lps'),
	(465901, 123, '2015-04-01 00:06:24.000000', 'consum', 0.0224, 'lps'),
	(465902, 123, '2015-04-01 00:06:25.000000', 'consum', 0.0213, 'lps'),
	(465903, 123, '2015-04-01 00:06:26.000000', 'consum', 0.0213, 'lps'),
	(465904, 123, '2015-04-01 00:06:27.000000', 'consum', 0.0215, 'lps'),
	(465905, 123, '2015-04-01 00:06:28.000000', 'consum', 0.0225, 'lps'),
	(465906, 123, '2015-04-01 00:06:29.000000', 'consum', 0.0216, 'lps'),
	(465907, 123, '2015-04-01 00:06:30.000000', 'consum', 0.0222, 'lps'),
	(465908, 123, '2015-04-01 00:06:31.000000', 'consum', 0.0227, 'lps'),
	(465909, 123, '2015-04-01 00:06:32.000000', 'consum', 0.0232, 'lps'),
	(465910, 123, '2015-04-01 00:06:33.000000', 'consum', 0.0211, 'lps'),
	(465911, 123, '2015-04-01 00:06:34.000000', 'consum', 0.0235, 'lps'),
	(465912, 123, '2015-04-01 00:06:35.000000', 'consum', 0.0219, 'lps'),
	(465913, 123, '2015-04-01 00:06:36.000000', 'consum', 0.0211, 'lps'),
	(465914, 123, '2015-04-01 00:06:37.000000', 'consum', 0.0215, 'lps'),
	(465915, 123, '2015-04-01 00:06:38.000000', 'consum', 0.0233, 'lps'),
	(465916, 123, '2015-04-01 00:06:39.000000', 'consum', 0.0227, 'lps'),
	(465917, 123, '2015-04-01 00:06:40.000000', 'consum', 0.0224, 'lps'),
	(465918, 123, '2015-04-01 00:06:41.000000', 'consum', 0.0232, 'lps'),
	(465919, 123, '2015-04-01 00:06:42.000000', 'consum', 0.0223, 'lps'),
	(465920, 123, '2015-04-01 00:06:43.000000', 'consum', 0.0235, 'lps'),
	(465921, 123, '2015-04-01 00:06:44.000000', 'consum', 0.0215, 'lps'),
	(465922, 123, '2015-04-01 00:06:45.000000', 'consum', 0.0215, 'lps'),
	(465923, 123, '2015-04-01 00:06:46.000000', 'consum', 0.0222, 'lps'),
	(465924, 123, '2015-04-01 00:06:47.000000', 'consum', 0.0229, 'lps'),
	(465925, 123, '2015-04-01 00:06:48.000000', 'consum', 0.0211, 'lps'),
	(465926, 123, '2015-04-01 00:06:49.000000', 'consum', 0.0216, 'lps'),
	(465927, 123, '2015-04-01 00:06:50.000000', 'consum', 0.0210, 'lps'),
	(465928, 123, '2015-04-01 00:06:51.000000', 'consum', 0.0219, 'lps'),
	(465929, 123, '2015-04-01 00:06:52.000000', 'consum', 0.0226, 'lps'),
	(465930, 123, '2015-04-01 00:06:53.000000', 'consum', 0.0236, 'lps'),
	(465931, 123, '2015-04-01 00:06:54.000000', 'consum', 0.0211, 'lps'),
	(465932, 123, '2015-04-01 00:06:55.000000', 'consum', 0.0221, 'lps'),
	(465933, 123, '2015-04-01 00:06:56.000000', 'consum', 0.0235, 'lps'),
	(465934, 123, '2015-04-01 00:06:57.000000', 'consum', 0.0216, 'lps'),
	(465935, 123, '2015-04-01 00:06:58.000000', 'consum', 0.0224, 'lps'),
	(465936, 123, '2015-04-01 00:06:59.000000', 'consum', 0.0235, 'lps'),
	(465937, 123, '2015-04-01 00:07:00.000000', 'consum', 0.0235, 'lps'),
	(465938, 123, '2015-04-01 00:07:01.000000', 'consum', 0.0233, 'lps'),
	(465939, 123, '2015-04-01 00:07:02.000000', 'consum', 0.0224, 'lps'),
	(465940, 123, '2015-04-01 00:07:03.000000', 'consum', 0.0210, 'lps'),
	(465941, 123, '2015-04-01 00:07:04.000000', 'consum', 0.0225, 'lps'),
	(465942, 123, '2015-04-01 00:07:05.000000', 'consum', 0.0232, 'lps'),
	(465943, 123, '2015-04-01 00:07:06.000000', 'consum', 0.0216, 'lps'),
	(465944, 123, '2015-04-01 00:07:07.000000', 'consum', 0.0230, 'lps'),
	(465945, 123, '2015-04-01 00:07:08.000000', 'consum', 0.0211, 'lps'),
	(465946, 123, '2015-04-01 00:07:09.000000', 'consum', 0.0212, 'lps'),
	(465947, 123, '2015-04-01 00:07:10.000000', 'consum', 0.0217, 'lps'),
	(465948, 123, '2015-04-01 00:07:11.000000', 'consum', 0.0213, 'lps'),
	(465949, 123, '2015-04-01 00:07:12.000000', 'consum', 0.0229, 'lps'),
	(465950, 123, '2015-04-01 00:07:13.000000', 'consum', 0.0216, 'lps'),
	(465951, 123, '2015-04-01 00:07:14.000000', 'consum', 0.0210, 'lps'),
	(465952, 123, '2015-04-01 00:07:15.000000', 'consum', 0.0220, 'lps'),
	(465953, 123, '2015-04-01 00:07:16.000000', 'consum', 0.0231, 'lps'),
	(465954, 123, '2015-04-01 00:07:17.000000', 'consum', 0.0232, 'lps'),
	(465955, 123, '2015-04-01 00:07:18.000000', 'consum', 0.0228, 'lps'),
	(465956, 123, '2015-04-01 00:07:19.000000', 'consum', 0.0237, 'lps'),
	(465957, 123, '2015-04-01 00:07:20.000000', 'consum', 0.0233, 'lps'),
	(465958, 123, '2015-04-01 00:07:21.000000', 'consum', 0.0218, 'lps'),
	(465959, 123, '2015-04-01 00:07:22.000000', 'consum', 0.0236, 'lps'),
	(465960, 123, '2015-04-01 00:07:23.000000', 'consum', 0.0231, 'lps'),
	(465961, 123, '2015-04-01 00:07:24.000000', 'consum', 0.0211, 'lps'),
	(465962, 123, '2015-04-01 00:07:25.000000', 'consum', 0.0210, 'lps'),
	(465963, 123, '2015-04-01 00:07:26.000000', 'consum', 0.0233, 'lps'),
	(465964, 123, '2015-04-01 00:07:27.000000', 'consum', 0.0216, 'lps'),
	(465965, 123, '2015-04-01 00:07:28.000000', 'consum', 0.0227, 'lps'),
	(465966, 123, '2015-04-01 00:07:29.000000', 'consum', 0.0221, 'lps'),
	(465967, 123, '2015-04-01 00:07:30.000000', 'consum', 0.0215, 'lps'),
	(465968, 123, '2015-04-01 00:07:31.000000', 'consum', 0.0231, 'lps'),
	(465969, 123, '2015-04-01 00:07:32.000000', 'consum', 0.0215, 'lps'),
	(465970, 123, '2015-04-01 00:07:33.000000', 'consum', 0.0229, 'lps'),
	(465971, 123, '2015-04-01 00:07:34.000000', 'consum', 0.0235, 'lps'),
	(465972, 123, '2015-04-01 00:07:35.000000', 'consum', 0.0221, 'lps'),
	(465973, 123, '2015-04-01 00:07:36.000000', 'consum', 0.0221, 'lps'),
	(465974, 123, '2015-04-01 00:07:37.000000', 'consum', 0.0231, 'lps'),
	(465975, 123, '2015-04-01 00:07:38.000000', 'consum', 0.0226, 'lps'),
	(465976, 123, '2015-04-01 00:07:39.000000', 'consum', 0.0228, 'lps'),
	(465977, 123, '2015-04-01 00:07:40.000000', 'consum', 0.0225, 'lps'),
	(465978, 123, '2015-04-01 00:07:41.000000', 'consum', 0.0229, 'lps'),
	(465979, 123, '2015-04-01 00:07:42.000000', 'consum', 0.0235, 'lps'),
	(465980, 123, '2015-04-01 00:07:43.000000', 'consum', 0.0222, 'lps'),
	(465981, 123, '2015-04-01 00:07:44.000000', 'consum', 0.0223, 'lps'),
	(465982, 123, '2015-04-01 00:07:45.000000', 'consum', 0.0210, 'lps'),
	(465983, 123, '2015-04-01 00:07:46.000000', 'consum', 0.0228, 'lps'),
	(465984, 123, '2015-04-01 00:07:47.000000', 'consum', 0.0217, 'lps'),
	(465985, 123, '2015-04-01 00:07:48.000000', 'consum', 0.0220, 'lps'),
	(465986, 123, '2015-04-01 00:07:49.000000', 'consum', 0.0211, 'lps'),
	(465987, 123, '2015-04-01 00:07:50.000000', 'consum', 0.0214, 'lps'),
	(465988, 123, '2015-04-01 00:07:51.000000', 'consum', 0.0228, 'lps'),
	(465989, 123, '2015-04-01 00:07:52.000000', 'consum', 0.0232, 'lps'),
	(465990, 123, '2015-04-01 00:07:53.000000', 'consum', 0.0237, 'lps'),
	(465991, 123, '2015-04-01 00:07:54.000000', 'consum', 0.0224, 'lps'),
	(465992, 123, '2015-04-01 00:07:55.000000', 'consum', 0.0228, 'lps'),
	(465993, 123, '2015-04-01 00:07:56.000000', 'consum', 0.0230, 'lps'),
	(465994, 123, '2015-04-01 00:07:57.000000', 'consum', 0.0230, 'lps'),
	(465995, 123, '2015-04-01 00:07:58.000000', 'consum', 0.0221, 'lps'),
	(465996, 123, '2015-04-01 00:07:59.000000', 'consum', 0.0235, 'lps'),
	(465997, 123, '2015-04-01 00:08:00.000000', 'consum', 0.0220, 'lps'),
	(465998, 123, '2015-04-01 00:08:01.000000', 'consum', 0.0210, 'lps'),
	(465999, 123, '2015-04-01 00:08:02.000000', 'consum', 0.0237, 'lps'),
	(466000, 123, '2015-04-01 00:08:03.000000', 'consum', 0.0235, 'lps'),
	(466001, 123, '2015-04-01 00:08:04.000000', 'consum', 0.0228, 'lps'),
	(466002, 123, '2015-04-01 00:08:05.000000', 'consum', 0.0223, 'lps'),
	(466003, 123, '2015-04-01 00:08:06.000000', 'consum', 0.0222, 'lps'),
	(466004, 123, '2015-04-01 00:08:07.000000', 'consum', 0.0232, 'lps'),
	(466005, 123, '2015-04-01 00:08:08.000000', 'consum', 0.0229, 'lps'),
	(466006, 123, '2015-04-01 00:08:09.000000', 'consum', 0.0211, 'lps'),
	(466007, 123, '2015-04-01 00:08:10.000000', 'consum', 0.0214, 'lps'),
	(466008, 123, '2015-04-01 00:08:11.000000', 'consum', 0.0226, 'lps'),
	(466009, 123, '2015-04-01 00:08:12.000000', 'consum', 0.0226, 'lps'),
	(466010, 123, '2015-04-01 00:08:13.000000', 'consum', 0.0212, 'lps'),
	(466011, 123, '2015-04-01 00:08:14.000000', 'consum', 0.0231, 'lps'),
	(466012, 123, '2015-04-01 00:08:15.000000', 'consum', 0.0223, 'lps'),
	(466013, 123, '2015-04-01 00:08:16.000000', 'consum', 0.0214, 'lps'),
	(466014, 123, '2015-04-01 00:08:17.000000', 'consum', 0.0219, 'lps'),
	(466015, 123, '2015-04-01 00:08:18.000000', 'consum', 0.0215, 'lps'),
	(466016, 123, '2015-04-01 00:08:19.000000', 'consum', 0.0237, 'lps'),
	(466017, 123, '2015-04-01 00:08:20.000000', 'consum', 0.0217, 'lps'),
	(466018, 123, '2015-04-01 00:08:21.000000', 'consum', 0.0220, 'lps'),
	(466019, 123, '2015-04-01 00:08:22.000000', 'consum', 0.0211, 'lps'),
	(466020, 123, '2015-04-01 00:08:23.000000', 'consum', 0.0217, 'lps'),
	(466021, 123, '2015-04-01 00:08:24.000000', 'consum', 0.0211, 'lps'),
	(466022, 123, '2015-04-01 00:08:25.000000', 'consum', 0.0225, 'lps'),
	(466023, 123, '2015-04-01 00:08:26.000000', 'consum', 0.0228, 'lps'),
	(466024, 123, '2015-04-01 00:08:27.000000', 'consum', 0.0225, 'lps'),
	(466025, 123, '2015-04-01 00:08:28.000000', 'consum', 0.0230, 'lps'),
	(466026, 123, '2015-04-01 00:08:29.000000', 'consum', 0.0212, 'lps'),
	(466027, 123, '2015-04-01 00:08:30.000000', 'consum', 0.0215, 'lps'),
	(466028, 123, '2015-04-01 00:08:31.000000', 'consum', 0.0231, 'lps'),
	(466029, 123, '2015-04-01 00:08:32.000000', 'consum', 0.0217, 'lps'),
	(466030, 123, '2015-04-01 00:08:33.000000', 'consum', 0.0236, 'lps'),
	(466031, 123, '2015-04-01 00:08:34.000000', 'consum', 0.0235, 'lps'),
	(466032, 123, '2015-04-01 00:08:35.000000', 'consum', 0.0229, 'lps'),
	(466033, 123, '2015-04-01 00:08:36.000000', 'consum', 0.0233, 'lps'),
	(466034, 123, '2015-04-01 00:08:37.000000', 'consum', 0.0214, 'lps'),
	(466035, 123, '2015-04-01 00:08:38.000000', 'consum', 0.0214, 'lps'),
	(466036, 123, '2015-04-01 00:08:39.000000', 'consum', 0.0219, 'lps'),
	(466037, 123, '2015-04-01 00:08:40.000000', 'consum', 0.0218, 'lps'),
	(466038, 123, '2015-04-01 00:08:41.000000', 'consum', 0.0221, 'lps'),
	(466039, 123, '2015-04-01 00:08:42.000000', 'consum', 0.0215, 'lps'),
	(466040, 123, '2015-04-01 00:08:43.000000', 'consum', 0.0231, 'lps'),
	(466041, 123, '2015-04-01 00:08:44.000000', 'consum', 0.0216, 'lps'),
	(466042, 123, '2015-04-01 00:08:45.000000', 'consum', 0.0232, 'lps'),
	(466043, 123, '2015-04-01 00:08:46.000000', 'consum', 0.0219, 'lps'),
	(466044, 123, '2015-04-01 00:08:47.000000', 'consum', 0.0219, 'lps'),
	(466045, 123, '2015-04-01 00:08:48.000000', 'consum', 0.0228, 'lps'),
	(466046, 123, '2015-04-01 00:08:49.000000', 'consum', 0.0218, 'lps'),
	(466047, 123, '2015-04-01 00:08:50.000000', 'consum', 0.0224, 'lps'),
	(466048, 123, '2015-04-01 00:08:51.000000', 'consum', 0.0227, 'lps'),
	(466049, 123, '2015-04-01 00:08:52.000000', 'consum', 0.0228, 'lps'),
	(466050, 123, '2015-04-01 00:08:53.000000', 'consum', 0.0221, 'lps'),
	(466051, 123, '2015-04-01 00:08:54.000000', 'consum', 0.0212, 'lps'),
	(466052, 123, '2015-04-01 00:08:55.000000', 'consum', 0.0216, 'lps'),
	(466053, 123, '2015-04-01 00:08:56.000000', 'consum', 0.0232, 'lps'),
	(466054, 123, '2015-04-01 00:08:57.000000', 'consum', 0.0220, 'lps'),
	(466055, 123, '2015-04-01 00:08:58.000000', 'consum', 0.0223, 'lps'),
	(466056, 123, '2015-04-01 00:08:59.000000', 'consum', 0.0218, 'lps'),
	(466057, 123, '2015-04-01 00:09:00.000000', 'consum', 0.0237, 'lps'),
	(466058, 123, '2015-04-01 00:09:01.000000', 'consum', 0.0213, 'lps'),
	(466059, 123, '2015-04-01 00:09:02.000000', 'consum', 0.0227, 'lps'),
	(466060, 123, '2015-04-01 00:09:03.000000', 'consum', 0.0228, 'lps'),
	(466061, 123, '2015-04-01 00:09:04.000000', 'consum', 0.0225, 'lps'),
	(466062, 123, '2015-04-01 00:09:05.000000', 'consum', 0.0229, 'lps'),
	(466063, 123, '2015-04-01 00:09:06.000000', 'consum', 0.0234, 'lps'),
	(466064, 123, '2015-04-01 00:09:07.000000', 'consum', 0.0216, 'lps'),
	(466065, 123, '2015-04-01 00:09:08.000000', 'consum', 0.0227, 'lps'),
	(466066, 123, '2015-04-01 00:09:09.000000', 'consum', 0.0218, 'lps'),
	(466067, 123, '2015-04-01 00:09:10.000000', 'consum', 0.0231, 'lps'),
	(466068, 123, '2015-04-01 00:09:11.000000', 'consum', 0.0233, 'lps'),
	(466069, 123, '2015-04-01 00:09:12.000000', 'consum', 0.0234, 'lps'),
	(466070, 123, '2015-04-01 00:09:13.000000', 'consum', 0.0236, 'lps'),
	(466071, 123, '2015-04-01 00:09:14.000000', 'consum', 0.0211, 'lps'),
	(466072, 123, '2015-04-01 00:09:15.000000', 'consum', 0.0222, 'lps'),
	(466073, 123, '2015-04-01 00:09:16.000000', 'consum', 0.0213, 'lps'),
	(466074, 123, '2015-04-01 00:09:17.000000', 'consum', 0.0216, 'lps'),
	(466075, 123, '2015-04-01 00:09:18.000000', 'consum', 0.0231, 'lps'),
	(466076, 123, '2015-04-01 00:09:19.000000', 'consum', 0.0215, 'lps'),
	(466077, 123, '2015-04-01 00:09:20.000000', 'consum', 0.0227, 'lps'),
	(466078, 123, '2015-04-01 00:09:21.000000', 'consum', 0.0226, 'lps'),
	(466079, 123, '2015-04-01 00:09:22.000000', 'consum', 0.0237, 'lps'),
	(466080, 123, '2015-04-01 00:09:23.000000', 'consum', 0.0215, 'lps'),
	(466081, 123, '2015-04-01 00:09:24.000000', 'consum', 0.0212, 'lps'),
	(466082, 123, '2015-04-01 00:09:25.000000', 'consum', 0.0231, 'lps'),
	(466083, 123, '2015-04-01 00:09:26.000000', 'consum', 0.0227, 'lps'),
	(466084, 123, '2015-04-01 00:09:27.000000', 'consum', 0.0233, 'lps'),
	(466085, 123, '2015-04-01 00:09:28.000000', 'consum', 0.0218, 'lps'),
	(466086, 123, '2015-04-01 00:09:29.000000', 'consum', 0.0236, 'lps'),
	(466087, 123, '2015-04-01 00:09:30.000000', 'consum', 0.0234, 'lps'),
	(466088, 123, '2015-04-01 00:09:31.000000', 'consum', 0.0222, 'lps'),
	(466089, 123, '2015-04-01 00:09:32.000000', 'consum', 0.0230, 'lps'),
	(466090, 123, '2015-04-01 00:09:33.000000', 'consum', 0.0216, 'lps'),
	(466091, 123, '2015-04-01 00:09:34.000000', 'consum', 0.0210, 'lps'),
	(466092, 123, '2015-04-01 00:09:35.000000', 'consum', 0.0222, 'lps'),
	(466093, 123, '2015-04-01 00:09:36.000000', 'consum', 0.0211, 'lps'),
	(466094, 123, '2015-04-01 00:09:37.000000', 'consum', 0.0210, 'lps'),
	(466095, 123, '2015-04-01 00:09:38.000000', 'consum', 0.0235, 'lps'),
	(466096, 123, '2015-04-01 00:09:39.000000', 'consum', 0.0222, 'lps'),
	(466097, 123, '2015-04-01 00:09:40.000000', 'consum', 0.0226, 'lps'),
	(466098, 123, '2015-04-01 00:09:41.000000', 'consum', 0.0225, 'lps'),
	(466099, 123, '2015-04-01 00:09:42.000000', 'consum', 0.0236, 'lps'),
	(466100, 123, '2015-04-01 00:09:43.000000', 'consum', 0.0212, 'lps'),
	(466101, 123, '2015-04-01 00:09:44.000000', 'consum', 0.0226, 'lps'),
	(466102, 123, '2015-04-01 00:09:45.000000', 'consum', 0.0228, 'lps'),
	(466103, 123, '2015-04-01 00:09:46.000000', 'consum', 0.0226, 'lps'),
	(466104, 123, '2015-04-01 00:09:47.000000', 'consum', 0.0236, 'lps'),
	(466105, 123, '2015-04-01 00:09:48.000000', 'consum', 0.0235, 'lps'),
	(466106, 123, '2015-04-01 00:09:49.000000', 'consum', 0.0229, 'lps'),
	(466107, 123, '2015-04-01 00:09:50.000000', 'consum', 0.0233, 'lps'),
	(466108, 123, '2015-04-01 00:09:51.000000', 'consum', 0.0211, 'lps'),
	(466109, 123, '2015-04-01 00:09:52.000000', 'consum', 0.0231, 'lps'),
	(466110, 123, '2015-04-01 00:09:53.000000', 'consum', 0.0229, 'lps'),
	(466111, 123, '2015-04-01 00:09:54.000000', 'consum', 0.0213, 'lps'),
	(466112, 123, '2015-04-01 00:09:55.000000', 'consum', 0.0224, 'lps'),
	(466113, 123, '2015-04-01 00:09:56.000000', 'consum', 0.0215, 'lps'),
	(466114, 123, '2015-04-01 00:09:57.000000', 'consum', 0.0224, 'lps'),
	(466115, 123, '2015-04-01 00:09:58.000000', 'consum', 0.0236, 'lps'),
	(466116, 123, '2015-04-01 00:09:59.000000', 'consum', 0.0215, 'lps'),
	(466117, 123, '2015-04-01 00:10:00.000000', 'consum', 0.0214, 'lps'),
	(466118, 123, '2015-04-01 00:10:01.000000', 'consum', 0.0217, 'lps'),
	(466119, 123, '2015-04-01 00:10:02.000000', 'consum', 0.0231, 'lps'),
	(466120, 123, '2015-04-01 00:10:03.000000', 'consum', 0.0211, 'lps'),
	(466121, 123, '2015-04-01 00:10:04.000000', 'consum', 0.0235, 'lps'),
	(466122, 123, '2015-04-01 00:10:05.000000', 'consum', 0.0220, 'lps'),
	(466123, 123, '2015-04-01 00:10:06.000000', 'consum', 0.0217, 'lps'),
	(466124, 123, '2015-04-01 00:10:07.000000', 'consum', 0.0213, 'lps'),
	(466125, 123, '2015-04-01 00:10:08.000000', 'consum', 0.0232, 'lps'),
	(466126, 123, '2015-04-01 00:10:09.000000', 'consum', 0.0228, 'lps'),
	(466127, 123, '2015-04-01 00:10:10.000000', 'consum', 0.0233, 'lps'),
	(466128, 123, '2015-04-01 00:10:11.000000', 'consum', 0.0216, 'lps'),
	(466129, 123, '2015-04-01 00:10:12.000000', 'consum', 0.0230, 'lps'),
	(466130, 123, '2015-04-01 00:10:13.000000', 'consum', 0.0235, 'lps'),
	(466131, 123, '2015-04-01 00:10:14.000000', 'consum', 0.0221, 'lps'),
	(466132, 123, '2015-04-01 00:10:15.000000', 'consum', 0.0220, 'lps'),
	(466133, 123, '2015-04-01 00:10:16.000000', 'consum', 0.0224, 'lps'),
	(466134, 123, '2015-04-01 00:10:17.000000', 'consum', 0.0224, 'lps'),
	(466135, 123, '2015-04-01 00:10:18.000000', 'consum', 0.0237, 'lps'),
	(466136, 123, '2015-04-01 00:10:19.000000', 'consum', 0.0222, 'lps'),
	(466137, 123, '2015-04-01 00:10:20.000000', 'consum', 0.0215, 'lps'),
	(466138, 123, '2015-04-01 00:10:21.000000', 'consum', 0.0229, 'lps'),
	(466139, 123, '2015-04-01 00:10:22.000000', 'consum', 0.0234, 'lps'),
	(466140, 123, '2015-04-01 00:10:23.000000', 'consum', 0.0217, 'lps'),
	(466141, 123, '2015-04-01 00:10:24.000000', 'consum', 0.0232, 'lps'),
	(466142, 123, '2015-04-01 00:10:25.000000', 'consum', 0.0214, 'lps'),
	(466143, 123, '2015-04-01 00:10:26.000000', 'consum', 0.0221, 'lps'),
	(466144, 123, '2015-04-01 00:10:27.000000', 'consum', 0.0223, 'lps'),
	(466145, 123, '2015-04-01 00:10:28.000000', 'consum', 0.0218, 'lps'),
	(466146, 123, '2015-04-01 00:10:29.000000', 'consum', 0.0237, 'lps'),
	(466147, 123, '2015-04-01 00:10:30.000000', 'consum', 0.0237, 'lps'),
	(466148, 123, '2015-04-01 00:10:31.000000', 'consum', 0.0210, 'lps'),
	(466149, 123, '2015-04-01 00:10:32.000000', 'consum', 0.0211, 'lps'),
	(466150, 123, '2015-04-01 00:10:33.000000', 'consum', 0.0219, 'lps'),
	(466151, 123, '2015-04-01 00:10:34.000000', 'consum', 0.0223, 'lps'),
	(466152, 123, '2015-04-01 00:10:35.000000', 'consum', 0.0219, 'lps'),
	(466153, 123, '2015-04-01 00:10:36.000000', 'consum', 0.0219, 'lps'),
	(466154, 123, '2015-04-01 00:10:37.000000', 'consum', 0.0227, 'lps'),
	(466155, 123, '2015-04-01 00:10:38.000000', 'consum', 0.0211, 'lps'),
	(466156, 123, '2015-04-01 00:10:39.000000', 'consum', 0.0221, 'lps'),
	(466157, 123, '2015-04-01 00:10:40.000000', 'consum', 0.0235, 'lps'),
	(466158, 123, '2015-04-01 00:10:41.000000', 'consum', 0.0217, 'lps'),
	(466159, 123, '2015-04-01 00:10:42.000000', 'consum', 0.0229, 'lps'),
	(466160, 123, '2015-04-01 00:10:43.000000', 'consum', 0.0226, 'lps'),
	(466161, 123, '2015-04-01 00:10:44.000000', 'consum', 0.0233, 'lps'),
	(466162, 123, '2015-04-01 00:10:45.000000', 'consum', 0.0225, 'lps'),
	(466163, 123, '2015-04-01 00:10:46.000000', 'consum', 0.0213, 'lps'),
	(466164, 123, '2015-04-01 00:10:47.000000', 'consum', 0.0236, 'lps'),
	(466165, 123, '2015-04-01 00:10:48.000000', 'consum', 0.0223, 'lps'),
	(466166, 123, '2015-04-01 00:10:49.000000', 'consum', 0.0222, 'lps'),
	(466167, 123, '2015-04-01 00:10:50.000000', 'consum', 0.0234, 'lps'),
	(466168, 123, '2015-04-01 00:10:51.000000', 'consum', 0.0237, 'lps'),
	(466169, 123, '2015-04-01 00:10:52.000000', 'consum', 0.0218, 'lps'),
	(466170, 123, '2015-04-01 00:10:53.000000', 'consum', 0.0224, 'lps'),
	(466171, 123, '2015-04-01 00:10:54.000000', 'consum', 0.0229, 'lps'),
	(466172, 123, '2015-04-01 00:10:55.000000', 'consum', 0.0237, 'lps'),
	(466173, 123, '2015-04-01 00:10:56.000000', 'consum', 0.0234, 'lps'),
	(466174, 123, '2015-04-01 00:10:57.000000', 'consum', 0.0219, 'lps'),
	(466175, 123, '2015-04-01 00:10:58.000000', 'consum', 0.0211, 'lps'),
	(466176, 123, '2015-04-01 00:10:59.000000', 'consum', 0.0218, 'lps'),
	(466177, 123, '2015-04-01 00:11:00.000000', 'consum', 0.0220, 'lps'),
	(466178, 123, '2015-04-01 00:11:01.000000', 'consum', 0.0237, 'lps'),
	(466179, 123, '2015-04-01 00:11:02.000000', 'consum', 0.0229, 'lps'),
	(466180, 123, '2015-04-01 00:11:03.000000', 'consum', 0.0227, 'lps'),
	(466181, 123, '2015-04-01 00:11:04.000000', 'consum', 0.0237, 'lps'),
	(466182, 123, '2015-04-01 00:11:05.000000', 'consum', 0.0237, 'lps'),
	(466183, 123, '2015-04-01 00:11:06.000000', 'consum', 0.0237, 'lps'),
	(466184, 123, '2015-04-01 00:11:07.000000', 'consum', 0.0237, 'lps'),
	(466185, 123, '2015-04-01 00:11:08.000000', 'consum', 0.0237, 'lps'),
	(466186, 123, '2015-04-01 00:11:09.000000', 'consum', 0.0236, 'lps'),
	(466187, 123, '2015-04-01 00:11:10.000000', 'consum', 0.0233, 'lps'),
	(466188, 123, '2015-04-01 00:11:11.000000', 'consum', 0.0220, 'lps'),
	(466189, 123, '2015-04-01 00:11:12.000000', 'consum', 0.0220, 'lps'),
	(466190, 123, '2015-04-01 00:11:13.000000', 'consum', 0.0229, 'lps'),
	(466191, 123, '2015-04-01 00:11:14.000000', 'consum', 0.0219, 'lps'),
	(466192, 123, '2015-04-01 00:11:15.000000', 'consum', 0.0228, 'lps'),
	(466193, 123, '2015-04-01 00:11:16.000000', 'consum', 0.0219, 'lps'),
	(466194, 123, '2015-04-01 00:11:17.000000', 'consum', 0.0226, 'lps'),
	(466195, 123, '2015-04-01 00:11:18.000000', 'consum', 0.0236, 'lps'),
	(466196, 123, '2015-04-01 00:11:19.000000', 'consum', 0.0210, 'lps'),
	(466197, 123, '2015-04-01 00:11:20.000000', 'consum', 0.0217, 'lps'),
	(466198, 123, '2015-04-01 00:11:21.000000', 'consum', 0.0216, 'lps'),
	(466199, 123, '2015-04-01 00:11:22.000000', 'consum', 0.0219, 'lps'),
	(466200, 123, '2015-04-01 00:11:23.000000', 'consum', 0.0212, 'lps'),
	(466201, 123, '2015-04-01 00:11:24.000000', 'consum', 0.0219, 'lps'),
	(466202, 123, '2015-04-01 00:11:25.000000', 'consum', 0.0223, 'lps'),
	(466203, 123, '2015-04-01 00:11:26.000000', 'consum', 0.0222, 'lps'),
	(466204, 123, '2015-04-01 00:11:27.000000', 'consum', 0.0231, 'lps'),
	(466205, 123, '2015-04-01 00:11:28.000000', 'consum', 0.0221, 'lps'),
	(466206, 123, '2015-04-01 00:11:29.000000', 'consum', 0.0231, 'lps'),
	(466207, 123, '2015-04-01 00:11:30.000000', 'consum', 0.0227, 'lps'),
	(466208, 123, '2015-04-01 00:11:31.000000', 'consum', 0.0232, 'lps'),
	(466209, 123, '2015-04-01 00:11:32.000000', 'consum', 0.0214, 'lps'),
	(466210, 123, '2015-04-01 00:11:33.000000', 'consum', 0.0222, 'lps'),
	(466211, 123, '2015-04-01 00:11:34.000000', 'consum', 0.0229, 'lps'),
	(466212, 123, '2015-04-01 00:11:35.000000', 'consum', 0.0212, 'lps'),
	(466213, 123, '2015-04-01 00:11:36.000000', 'consum', 0.0222, 'lps'),
	(466214, 123, '2015-04-01 00:11:37.000000', 'consum', 0.0236, 'lps'),
	(466215, 123, '2015-04-01 00:11:38.000000', 'consum', 0.0222, 'lps'),
	(466216, 123, '2015-04-01 00:11:39.000000', 'consum', 0.0221, 'lps'),
	(466217, 123, '2015-04-01 00:11:40.000000', 'consum', 0.0227, 'lps'),
	(466218, 123, '2015-04-01 00:11:41.000000', 'consum', 0.0237, 'lps'),
	(466219, 123, '2015-04-01 00:11:42.000000', 'consum', 0.0236, 'lps'),
	(466220, 123, '2015-04-01 00:11:43.000000', 'consum', 0.0232, 'lps'),
	(466221, 123, '2015-04-01 00:11:44.000000', 'consum', 0.0214, 'lps'),
	(466222, 123, '2015-04-01 00:11:45.000000', 'consum', 0.0222, 'lps'),
	(466223, 123, '2015-04-01 00:11:46.000000', 'consum', 0.0228, 'lps'),
	(466224, 123, '2015-04-01 00:11:47.000000', 'consum', 0.0237, 'lps'),
	(466225, 123, '2015-04-01 00:11:48.000000', 'consum', 0.0235, 'lps'),
	(466226, 123, '2015-04-01 00:11:49.000000', 'consum', 0.0227, 'lps'),
	(466227, 123, '2015-04-01 00:11:50.000000', 'consum', 0.0220, 'lps'),
	(466228, 123, '2015-04-01 00:11:51.000000', 'consum', 0.0212, 'lps'),
	(466229, 123, '2015-04-01 00:11:52.000000', 'consum', 0.0216, 'lps'),
	(466230, 123, '2015-04-01 00:11:53.000000', 'consum', 0.0236, 'lps'),
	(466231, 123, '2015-04-01 00:11:54.000000', 'consum', 0.0210, 'lps'),
	(466232, 123, '2015-04-01 00:11:55.000000', 'consum', 0.0216, 'lps'),
	(466233, 123, '2015-04-01 00:11:56.000000', 'consum', 0.0215, 'lps'),
	(466234, 123, '2015-04-01 00:11:57.000000', 'consum', 0.0215, 'lps'),
	(466235, 123, '2015-04-01 00:11:58.000000', 'consum', 0.0219, 'lps'),
	(466236, 123, '2015-04-01 00:11:59.000000', 'consum', 0.0215, 'lps'),
	(466237, 123, '2015-04-01 00:12:00.000000', 'consum', 0.0236, 'lps'),
	(466238, 123, '2015-04-01 00:12:01.000000', 'consum', 0.0213, 'lps'),
	(466239, 123, '2015-04-01 00:12:02.000000', 'consum', 0.0231, 'lps'),
	(466240, 123, '2015-04-01 00:12:03.000000', 'consum', 0.0224, 'lps'),
	(466241, 123, '2015-04-01 00:12:04.000000', 'consum', 0.0218, 'lps'),
	(466242, 123, '2015-04-01 00:12:05.000000', 'consum', 0.0237, 'lps'),
	(466243, 123, '2015-04-01 00:12:06.000000', 'consum', 0.0210, 'lps'),
	(466244, 123, '2015-04-01 00:12:07.000000', 'consum', 0.0213, 'lps'),
	(466245, 123, '2015-04-01 00:12:08.000000', 'consum', 0.0224, 'lps'),
	(466246, 123, '2015-04-01 00:12:09.000000', 'consum', 0.0216, 'lps'),
	(466247, 123, '2015-04-01 00:12:10.000000', 'consum', 0.0226, 'lps'),
	(466248, 123, '2015-04-01 00:12:11.000000', 'consum', 0.0218, 'lps'),
	(466249, 123, '2015-04-01 00:12:12.000000', 'consum', 0.0231, 'lps'),
	(466250, 123, '2015-04-01 00:12:13.000000', 'consum', 0.0233, 'lps'),
	(466251, 123, '2015-04-01 00:12:14.000000', 'consum', 0.0237, 'lps'),
	(466252, 123, '2015-04-01 00:12:15.000000', 'consum', 0.0220, 'lps'),
	(466253, 123, '2015-04-01 00:12:16.000000', 'consum', 0.0236, 'lps'),
	(466254, 123, '2015-04-01 00:12:17.000000', 'consum', 0.0226, 'lps'),
	(466255, 123, '2015-04-01 00:12:18.000000', 'consum', 0.0212, 'lps'),
	(466256, 123, '2015-04-01 00:12:19.000000', 'consum', 0.0229, 'lps'),
	(466257, 123, '2015-04-01 00:12:20.000000', 'consum', 0.0217, 'lps'),
	(466258, 123, '2015-04-01 00:12:21.000000', 'consum', 0.0214, 'lps'),
	(466259, 123, '2015-04-01 00:12:22.000000', 'consum', 0.0211, 'lps'),
	(466260, 123, '2015-04-01 00:12:23.000000', 'consum', 0.0230, 'lps'),
	(466261, 123, '2015-04-01 00:12:24.000000', 'consum', 0.0225, 'lps'),
	(466262, 123, '2015-04-01 00:12:25.000000', 'consum', 0.0225, 'lps'),
	(466263, 123, '2015-04-01 00:12:26.000000', 'consum', 0.0212, 'lps'),
	(466264, 123, '2015-04-01 00:12:27.000000', 'consum', 0.0231, 'lps'),
	(466265, 123, '2015-04-01 00:12:28.000000', 'consum', 0.0224, 'lps'),
	(466266, 123, '2015-04-01 00:12:29.000000', 'consum', 0.0221, 'lps'),
	(466267, 123, '2015-04-01 00:12:30.000000', 'consum', 0.0221, 'lps'),
	(466268, 123, '2015-04-01 00:12:31.000000', 'consum', 0.0234, 'lps'),
	(466269, 123, '2015-04-01 00:12:32.000000', 'consum', 0.0212, 'lps'),
	(466270, 123, '2015-04-01 00:12:33.000000', 'consum', 0.0231, 'lps'),
	(466271, 123, '2015-04-01 00:12:34.000000', 'consum', 0.0228, 'lps'),
	(466272, 123, '2015-04-01 00:12:35.000000', 'consum', 0.0211, 'lps'),
	(466273, 123, '2015-04-01 00:12:36.000000', 'consum', 0.0215, 'lps'),
	(466274, 123, '2015-04-01 00:12:37.000000', 'consum', 0.0234, 'lps'),
	(466275, 123, '2015-04-01 00:12:38.000000', 'consum', 0.0229, 'lps'),
	(466276, 123, '2015-04-01 00:12:39.000000', 'consum', 0.0236, 'lps'),
	(466277, 123, '2015-04-01 00:12:40.000000', 'consum', 0.0226, 'lps'),
	(466278, 123, '2015-04-01 00:12:41.000000', 'consum', 0.0213, 'lps'),
	(466279, 123, '2015-04-01 00:12:42.000000', 'consum', 0.0231, 'lps'),
	(466280, 123, '2015-04-01 00:12:43.000000', 'consum', 0.0226, 'lps'),
	(466281, 123, '2015-04-01 00:12:44.000000', 'consum', 0.0228, 'lps'),
	(466282, 123, '2015-04-01 00:12:45.000000', 'consum', 0.0222, 'lps'),
	(466283, 123, '2015-04-01 00:12:46.000000', 'consum', 0.0219, 'lps'),
	(466284, 123, '2015-04-01 00:12:47.000000', 'consum', 0.0218, 'lps'),
	(466285, 123, '2015-04-01 00:12:48.000000', 'consum', 0.0222, 'lps'),
	(466286, 123, '2015-04-01 00:12:49.000000', 'consum', 0.0219, 'lps'),
	(466287, 123, '2015-04-01 00:12:50.000000', 'consum', 0.0218, 'lps'),
	(466288, 123, '2015-04-01 00:12:51.000000', 'consum', 0.0227, 'lps'),
	(466289, 123, '2015-04-01 00:12:52.000000', 'consum', 0.0213, 'lps'),
	(466290, 123, '2015-04-01 00:12:53.000000', 'consum', 0.0231, 'lps'),
	(466291, 123, '2015-04-01 00:12:54.000000', 'consum', 0.0224, 'lps'),
	(466292, 123, '2015-04-01 00:12:55.000000', 'consum', 0.0217, 'lps'),
	(466293, 123, '2015-04-01 00:12:56.000000', 'consum', 0.0230, 'lps'),
	(466294, 123, '2015-04-01 00:12:57.000000', 'consum', 0.0236, 'lps'),
	(466295, 123, '2015-04-01 00:12:58.000000', 'consum', 0.0223, 'lps'),
	(466296, 123, '2015-04-01 00:12:59.000000', 'consum', 0.0227, 'lps'),
	(466297, 123, '2015-04-01 00:13:00.000000', 'consum', 0.0229, 'lps'),
	(466298, 123, '2015-04-01 00:13:01.000000', 'consum', 0.0228, 'lps'),
	(466299, 123, '2015-04-01 00:13:02.000000', 'consum', 0.0212, 'lps'),
	(466300, 123, '2015-04-01 00:13:03.000000', 'consum', 0.0223, 'lps'),
	(466301, 123, '2015-04-01 00:13:04.000000', 'consum', 0.0213, 'lps'),
	(466302, 123, '2015-04-01 00:13:05.000000', 'consum', 0.0214, 'lps'),
	(466303, 123, '2015-04-01 00:13:06.000000', 'consum', 0.0222, 'lps'),
	(466304, 123, '2015-04-01 00:13:07.000000', 'consum', 0.0232, 'lps'),
	(466305, 123, '2015-04-01 00:13:08.000000', 'consum', 0.0227, 'lps'),
	(466306, 123, '2015-04-01 00:13:09.000000', 'consum', 0.0230, 'lps'),
	(466307, 123, '2015-04-01 00:13:10.000000', 'consum', 0.0231, 'lps'),
	(466308, 123, '2015-04-01 00:13:11.000000', 'consum', 0.0230, 'lps'),
	(466309, 123, '2015-04-01 00:13:12.000000', 'consum', 0.0217, 'lps'),
	(466310, 123, '2015-04-01 00:13:13.000000', 'consum', 0.0213, 'lps'),
	(466311, 123, '2015-04-01 00:13:14.000000', 'consum', 0.0235, 'lps'),
	(466312, 123, '2015-04-01 00:13:15.000000', 'consum', 0.0214, 'lps'),
	(466313, 123, '2015-04-01 00:13:16.000000', 'consum', 0.0213, 'lps'),
	(466314, 123, '2015-04-01 00:13:17.000000', 'consum', 0.0212, 'lps'),
	(466315, 123, '2015-04-01 00:13:18.000000', 'consum', 0.0212, 'lps'),
	(466316, 123, '2015-04-01 00:13:19.000000', 'consum', 0.0216, 'lps'),
	(466317, 123, '2015-04-01 00:13:20.000000', 'consum', 0.0234, 'lps'),
	(466318, 123, '2015-04-01 00:13:21.000000', 'consum', 0.0227, 'lps'),
	(466319, 123, '2015-04-01 00:13:22.000000', 'consum', 0.0226, 'lps'),
	(466320, 123, '2015-04-01 00:13:23.000000', 'consum', 0.0212, 'lps'),
	(466321, 123, '2015-04-01 00:13:24.000000', 'consum', 0.0225, 'lps'),
	(466322, 123, '2015-04-01 00:13:25.000000', 'consum', 0.0226, 'lps'),
	(466323, 123, '2015-04-01 00:13:26.000000', 'consum', 0.0216, 'lps'),
	(466324, 123, '2015-04-01 00:13:27.000000', 'consum', 0.0219, 'lps'),
	(466325, 123, '2015-04-01 00:13:28.000000', 'consum', 0.0211, 'lps'),
	(466326, 123, '2015-04-01 00:13:29.000000', 'consum', 0.0216, 'lps'),
	(466327, 123, '2015-04-01 00:13:30.000000', 'consum', 0.0212, 'lps'),
	(466328, 123, '2015-04-01 00:13:31.000000', 'consum', 0.0227, 'lps'),
	(466329, 123, '2015-04-01 00:13:32.000000', 'consum', 0.0235, 'lps'),
	(466330, 123, '2015-04-01 00:13:33.000000', 'consum', 0.0228, 'lps'),
	(466331, 123, '2015-04-01 00:13:34.000000', 'consum', 0.0224, 'lps'),
	(466332, 123, '2015-04-01 00:13:35.000000', 'consum', 0.0229, 'lps'),
	(466333, 123, '2015-04-01 00:13:36.000000', 'consum', 0.0233, 'lps'),
	(466334, 123, '2015-04-01 00:13:37.000000', 'consum', 0.0212, 'lps'),
	(466335, 123, '2015-04-01 00:13:38.000000', 'consum', 0.0236, 'lps'),
	(466336, 123, '2015-04-01 00:13:39.000000', 'consum', 0.0221, 'lps'),
	(466337, 123, '2015-04-01 00:13:40.000000', 'consum', 0.0219, 'lps'),
	(466338, 123, '2015-04-01 00:13:41.000000', 'consum', 0.0219, 'lps'),
	(466339, 123, '2015-04-01 00:13:42.000000', 'consum', 0.0231, 'lps'),
	(466340, 123, '2015-04-01 00:13:43.000000', 'consum', 0.0233, 'lps'),
	(466341, 123, '2015-04-01 00:13:44.000000', 'consum', 0.0236, 'lps'),
	(466342, 123, '2015-04-01 00:13:45.000000', 'consum', 0.0213, 'lps'),
	(466343, 123, '2015-04-01 00:13:46.000000', 'consum', 0.0231, 'lps'),
	(466344, 123, '2015-04-01 00:13:47.000000', 'consum', 0.0221, 'lps'),
	(466345, 123, '2015-04-01 00:13:48.000000', 'consum', 0.0233, 'lps'),
	(466346, 123, '2015-04-01 00:13:49.000000', 'consum', 0.0235, 'lps'),
	(466347, 123, '2015-04-01 00:13:50.000000', 'consum', 0.0211, 'lps'),
	(466348, 123, '2015-04-01 00:13:51.000000', 'consum', 0.0223, 'lps'),
	(466349, 123, '2015-04-01 00:13:52.000000', 'consum', 0.0220, 'lps'),
	(466350, 123, '2015-04-01 00:13:53.000000', 'consum', 0.0218, 'lps'),
	(466351, 123, '2015-04-01 00:13:54.000000', 'consum', 0.0223, 'lps'),
	(466352, 123, '2015-04-01 00:13:55.000000', 'consum', 0.0223, 'lps'),
	(466353, 123, '2015-04-01 00:13:56.000000', 'consum', 0.0237, 'lps'),
	(466354, 123, '2015-04-01 00:13:57.000000', 'consum', 0.0223, 'lps'),
	(466355, 123, '2015-04-01 00:13:58.000000', 'consum', 0.0222, 'lps'),
	(466356, 123, '2015-04-01 00:13:59.000000', 'consum', 0.0232, 'lps'),
	(466357, 123, '2015-04-01 00:14:00.000000', 'consum', 0.0226, 'lps'),
	(466358, 123, '2015-04-01 00:14:01.000000', 'consum', 0.0227, 'lps'),
	(466359, 123, '2015-04-01 00:14:02.000000', 'consum', 0.0220, 'lps'),
	(466360, 123, '2015-04-01 00:14:03.000000', 'consum', 0.0235, 'lps'),
	(466361, 123, '2015-04-01 00:14:04.000000', 'consum', 0.0221, 'lps'),
	(466362, 123, '2015-04-01 00:14:05.000000', 'consum', 0.0219, 'lps'),
	(466363, 123, '2015-04-01 00:14:06.000000', 'consum', 0.0223, 'lps'),
	(466364, 123, '2015-04-01 00:14:07.000000', 'consum', 0.0219, 'lps'),
	(466365, 123, '2015-04-01 00:14:08.000000', 'consum', 0.0216, 'lps'),
	(466366, 123, '2015-04-01 00:14:09.000000', 'consum', 0.0214, 'lps'),
	(466367, 123, '2015-04-01 00:14:10.000000', 'consum', 0.0211, 'lps'),
	(466368, 123, '2015-04-01 00:14:11.000000', 'consum', 0.0232, 'lps'),
	(466369, 123, '2015-04-01 00:14:12.000000', 'consum', 0.0234, 'lps'),
	(466370, 123, '2015-04-01 00:14:13.000000', 'consum', 0.0210, 'lps'),
	(466371, 123, '2015-04-01 00:14:14.000000', 'consum', 0.0221, 'lps'),
	(466372, 123, '2015-04-01 00:14:15.000000', 'consum', 0.0210, 'lps'),
	(466373, 123, '2015-04-01 00:14:16.000000', 'consum', 0.0232, 'lps'),
	(466374, 123, '2015-04-01 00:14:17.000000', 'consum', 0.0237, 'lps'),
	(466375, 123, '2015-04-01 00:14:18.000000', 'consum', 0.0226, 'lps'),
	(466376, 123, '2015-04-01 00:14:19.000000', 'consum', 0.0235, 'lps'),
	(466377, 123, '2015-04-01 00:14:20.000000', 'consum', 0.0232, 'lps'),
	(466378, 123, '2015-04-01 00:14:21.000000', 'consum', 0.0219, 'lps'),
	(466379, 123, '2015-04-01 00:14:22.000000', 'consum', 0.0218, 'lps'),
	(466380, 123, '2015-04-01 00:14:23.000000', 'consum', 0.0225, 'lps'),
	(466381, 123, '2015-04-01 00:14:24.000000', 'consum', 0.0230, 'lps'),
	(466382, 123, '2015-04-01 00:14:25.000000', 'consum', 0.0211, 'lps'),
	(466383, 123, '2015-04-01 00:14:26.000000', 'consum', 0.0211, 'lps'),
	(466384, 123, '2015-04-01 00:14:27.000000', 'consum', 0.0211, 'lps'),
	(466385, 123, '2015-04-01 00:14:28.000000', 'consum', 0.0216, 'lps'),
	(466386, 123, '2015-04-01 00:14:29.000000', 'consum', 0.0235, 'lps'),
	(466387, 123, '2015-04-01 00:14:30.000000', 'consum', 0.0234, 'lps'),
	(466388, 123, '2015-04-01 00:14:31.000000', 'consum', 0.0228, 'lps'),
	(466389, 123, '2015-04-01 00:14:32.000000', 'consum', 0.0228, 'lps'),
	(466390, 123, '2015-04-01 00:14:33.000000', 'consum', 0.0219, 'lps'),
	(466391, 123, '2015-04-01 00:14:34.000000', 'consum', 0.0231, 'lps'),
	(466392, 123, '2015-04-01 00:14:35.000000', 'consum', 0.0231, 'lps'),
	(466393, 123, '2015-04-01 00:14:36.000000', 'consum', 0.0227, 'lps'),
	(466394, 123, '2015-04-01 00:14:37.000000', 'consum', 0.0230, 'lps'),
	(466395, 123, '2015-04-01 00:14:38.000000', 'consum', 0.0232, 'lps'),
	(466396, 123, '2015-04-01 00:14:39.000000', 'consum', 0.0232, 'lps'),
	(466397, 123, '2015-04-01 00:14:40.000000', 'consum', 0.0225, 'lps'),
	(466398, 123, '2015-04-01 00:14:41.000000', 'consum', 0.0222, 'lps'),
	(466399, 123, '2015-04-01 00:14:42.000000', 'consum', 0.0226, 'lps'),
	(466400, 123, '2015-04-01 00:14:43.000000', 'consum', 0.0225, 'lps'),
	(466401, 123, '2015-04-01 00:14:44.000000', 'consum', 0.0237, 'lps'),
	(466402, 123, '2015-04-01 00:14:45.000000', 'consum', 0.0216, 'lps'),
	(466403, 123, '2015-04-01 00:14:46.000000', 'consum', 0.0216, 'lps'),
	(466404, 123, '2015-04-01 00:14:47.000000', 'consum', 0.0224, 'lps'),
	(466405, 123, '2015-04-01 00:14:48.000000', 'consum', 0.0233, 'lps'),
	(466406, 123, '2015-04-01 00:14:49.000000', 'consum', 0.0229, 'lps'),
	(466407, 123, '2015-04-01 00:14:50.000000', 'consum', 0.0210, 'lps'),
	(466408, 123, '2015-04-01 00:14:51.000000', 'consum', 0.0235, 'lps'),
	(466409, 123, '2015-04-01 00:14:52.000000', 'consum', 0.0225, 'lps'),
	(466410, 123, '2015-04-01 00:14:53.000000', 'consum', 0.0210, 'lps'),
	(466411, 123, '2015-04-01 00:14:54.000000', 'consum', 0.0221, 'lps'),
	(466412, 123, '2015-04-01 00:14:55.000000', 'consum', 0.0211, 'lps'),
	(466413, 123, '2015-04-01 00:14:56.000000', 'consum', 0.0210, 'lps'),
	(466414, 123, '2015-04-01 00:14:57.000000', 'consum', 0.0234, 'lps'),
	(466415, 123, '2015-04-01 00:14:58.000000', 'consum', 0.0219, 'lps'),
	(466416, 123, '2015-04-01 00:14:59.000000', 'consum', 0.0213, 'lps'),
	(466417, 123, '2015-04-01 00:15:00.000000', 'consum', 0.0226, 'lps'),
	(466418, 123, '2015-04-01 00:15:01.000000', 'consum', 0.0225, 'lps'),
	(466419, 123, '2015-04-01 00:15:02.000000', 'consum', 0.0211, 'lps'),
	(466420, 123, '2015-04-01 00:15:03.000000', 'consum', 0.0226, 'lps'),
	(466421, 123, '2015-04-01 00:15:04.000000', 'consum', 0.0231, 'lps'),
	(466422, 123, '2015-04-01 00:15:05.000000', 'consum', 0.0213, 'lps'),
	(466423, 123, '2015-04-01 00:15:06.000000', 'consum', 0.0216, 'lps'),
	(466424, 123, '2015-04-01 00:15:07.000000', 'consum', 0.0232, 'lps'),
	(466425, 123, '2015-04-01 00:15:08.000000', 'consum', 0.0220, 'lps'),
	(466426, 123, '2015-04-01 00:15:09.000000', 'consum', 0.0222, 'lps'),
	(466427, 123, '2015-04-01 00:15:10.000000', 'consum', 0.0213, 'lps'),
	(466428, 123, '2015-04-01 00:15:11.000000', 'consum', 0.0218, 'lps'),
	(466429, 123, '2015-04-01 00:15:12.000000', 'consum', 0.0215, 'lps'),
	(466430, 123, '2015-04-01 00:15:13.000000', 'consum', 0.0237, 'lps'),
	(466431, 123, '2015-04-01 00:15:14.000000', 'consum', 0.0219, 'lps'),
	(466432, 123, '2015-04-01 00:15:15.000000', 'consum', 0.0229, 'lps'),
	(466433, 123, '2015-04-01 00:15:16.000000', 'consum', 0.0222, 'lps'),
	(466434, 123, '2015-04-01 00:15:17.000000', 'consum', 0.0214, 'lps'),
	(466435, 123, '2015-04-01 00:15:18.000000', 'consum', 0.0225, 'lps'),
	(466436, 123, '2015-04-01 00:15:19.000000', 'consum', 0.0216, 'lps'),
	(466437, 123, '2015-04-01 00:15:20.000000', 'consum', 0.0225, 'lps'),
	(466438, 123, '2015-04-01 00:15:21.000000', 'consum', 0.0237, 'lps'),
	(466439, 123, '2015-04-01 00:15:22.000000', 'consum', 0.0217, 'lps'),
	(466440, 123, '2015-04-01 00:15:23.000000', 'consum', 0.0220, 'lps'),
	(466441, 123, '2015-04-01 00:15:24.000000', 'consum', 0.0211, 'lps'),
	(466442, 123, '2015-04-01 00:15:25.000000', 'consum', 0.0213, 'lps'),
	(466443, 123, '2015-04-01 00:15:26.000000', 'consum', 0.0225, 'lps'),
	(466444, 123, '2015-04-01 00:15:27.000000', 'consum', 0.0221, 'lps'),
	(466445, 123, '2015-04-01 00:15:28.000000', 'consum', 0.0220, 'lps'),
	(466446, 123, '2015-04-01 00:15:29.000000', 'consum', 0.0228, 'lps'),
	(466447, 123, '2015-04-01 00:15:30.000000', 'consum', 0.0215, 'lps'),
	(466448, 123, '2015-04-01 00:15:31.000000', 'consum', 0.0236, 'lps'),
	(466449, 123, '2015-04-01 00:15:32.000000', 'consum', 0.0216, 'lps'),
	(466450, 123, '2015-04-01 00:15:33.000000', 'consum', 0.0217, 'lps'),
	(466451, 123, '2015-04-01 00:15:34.000000', 'consum', 0.0228, 'lps'),
	(466452, 123, '2015-04-01 00:15:35.000000', 'consum', 0.0222, 'lps'),
	(466453, 123, '2015-04-01 00:15:36.000000', 'consum', 0.0219, 'lps'),
	(466454, 123, '2015-04-01 00:15:37.000000', 'consum', 0.0217, 'lps'),
	(466455, 123, '2015-04-01 00:15:38.000000', 'consum', 0.0220, 'lps'),
	(466456, 123, '2015-04-01 00:15:39.000000', 'consum', 0.0212, 'lps'),
	(466457, 123, '2015-04-01 00:15:40.000000', 'consum', 0.0217, 'lps'),
	(466458, 123, '2015-04-01 00:15:41.000000', 'consum', 0.0213, 'lps'),
	(466459, 123, '2015-04-01 00:15:42.000000', 'consum', 0.0231, 'lps'),
	(466460, 123, '2015-04-01 00:15:43.000000', 'consum', 0.0225, 'lps'),
	(466461, 123, '2015-04-01 00:15:44.000000', 'consum', 0.0221, 'lps'),
	(466462, 123, '2015-04-01 00:15:45.000000', 'consum', 0.0220, 'lps'),
	(466463, 123, '2015-04-01 00:15:46.000000', 'consum', 0.0227, 'lps'),
	(466464, 123, '2015-04-01 00:15:47.000000', 'consum', 0.0237, 'lps'),
	(466465, 123, '2015-04-01 00:15:48.000000', 'consum', 0.0211, 'lps'),
	(466466, 123, '2015-04-01 00:15:49.000000', 'consum', 0.0218, 'lps'),
	(466467, 123, '2015-04-01 00:15:50.000000', 'consum', 0.0218, 'lps'),
	(466468, 123, '2015-04-01 00:15:51.000000', 'consum', 0.0229, 'lps'),
	(466469, 123, '2015-04-01 00:15:52.000000', 'consum', 0.0224, 'lps'),
	(466470, 123, '2015-04-01 00:15:53.000000', 'consum', 0.0225, 'lps'),
	(466471, 123, '2015-04-01 00:15:54.000000', 'consum', 0.0213, 'lps'),
	(466472, 123, '2015-04-01 00:15:55.000000', 'consum', 0.0210, 'lps'),
	(466473, 123, '2015-04-01 00:15:56.000000', 'consum', 0.0228, 'lps'),
	(466474, 123, '2015-04-01 00:15:57.000000', 'consum', 0.0216, 'lps'),
	(466475, 123, '2015-04-01 00:15:58.000000', 'consum', 0.0215, 'lps'),
	(466476, 123, '2015-04-01 00:15:59.000000', 'consum', 0.0218, 'lps'),
	(466477, 123, '2015-04-01 00:16:00.000000', 'consum', 0.0233, 'lps'),
	(466478, 123, '2015-04-01 00:16:01.000000', 'consum', 0.0221, 'lps'),
	(466479, 123, '2015-04-01 00:16:02.000000', 'consum', 0.0224, 'lps'),
	(466480, 123, '2015-04-01 00:16:03.000000', 'consum', 0.0220, 'lps'),
	(466481, 123, '2015-04-01 00:16:04.000000', 'consum', 0.0218, 'lps'),
	(466482, 123, '2015-04-01 00:16:05.000000', 'consum', 0.0222, 'lps'),
	(466483, 123, '2015-04-01 00:16:06.000000', 'consum', 0.0217, 'lps'),
	(466484, 123, '2015-04-01 00:16:07.000000', 'consum', 0.0236, 'lps'),
	(466485, 123, '2015-04-01 00:16:08.000000', 'consum', 0.0236, 'lps'),
	(466486, 123, '2015-04-01 00:16:09.000000', 'consum', 0.0233, 'lps'),
	(466487, 123, '2015-04-01 00:16:10.000000', 'consum', 0.0223, 'lps'),
	(466488, 123, '2015-04-01 00:16:11.000000', 'consum', 0.0233, 'lps'),
	(466489, 123, '2015-04-01 00:16:12.000000', 'consum', 0.0229, 'lps'),
	(466490, 123, '2015-04-01 00:16:13.000000', 'consum', 0.0211, 'lps'),
	(466491, 123, '2015-04-01 00:16:14.000000', 'consum', 0.0212, 'lps'),
	(466492, 123, '2015-04-01 00:16:15.000000', 'consum', 0.0220, 'lps'),
	(466493, 123, '2015-04-01 00:16:16.000000', 'consum', 0.0227, 'lps'),
	(466494, 123, '2015-04-01 00:16:17.000000', 'consum', 0.0236, 'lps'),
	(466495, 123, '2015-04-01 00:16:18.000000', 'consum', 0.0235, 'lps'),
	(466496, 123, '2015-04-01 00:16:19.000000', 'consum', 0.0229, 'lps'),
	(466497, 123, '2015-04-01 00:16:20.000000', 'consum', 0.0229, 'lps'),
	(466498, 123, '2015-04-01 00:16:21.000000', 'consum', 0.0221, 'lps'),
	(466499, 123, '2015-04-01 00:16:22.000000', 'consum', 0.0210, 'lps'),
	(466500, 123, '2015-04-01 00:16:23.000000', 'consum', 0.0234, 'lps'),
	(466501, 123, '2015-04-01 00:16:24.000000', 'consum', 0.0218, 'lps'),
	(466502, 123, '2015-04-01 00:16:25.000000', 'consum', 0.0234, 'lps'),
	(466503, 123, '2015-04-01 00:16:26.000000', 'consum', 0.0221, 'lps'),
	(466504, 123, '2015-04-01 00:16:27.000000', 'consum', 0.0221, 'lps'),
	(466505, 123, '2015-04-01 00:16:28.000000', 'consum', 0.0235, 'lps'),
	(466506, 123, '2015-04-01 00:16:29.000000', 'consum', 0.0219, 'lps'),
	(466507, 123, '2015-04-01 00:16:30.000000', 'consum', 0.0237, 'lps'),
	(466508, 123, '2015-04-01 00:16:31.000000', 'consum', 0.0234, 'lps'),
	(466509, 123, '2015-04-01 00:16:32.000000', 'consum', 0.0219, 'lps'),
	(466510, 123, '2015-04-01 00:16:33.000000', 'consum', 0.0215, 'lps'),
	(466511, 123, '2015-04-01 00:16:34.000000', 'consum', 0.0233, 'lps'),
	(466512, 123, '2015-04-01 00:16:35.000000', 'consum', 0.0230, 'lps'),
	(466513, 123, '2015-04-01 00:16:36.000000', 'consum', 0.0212, 'lps'),
	(466514, 123, '2015-04-01 00:16:37.000000', 'consum', 0.0217, 'lps'),
	(466515, 123, '2015-04-01 00:16:38.000000', 'consum', 0.0211, 'lps'),
	(466516, 123, '2015-04-01 00:16:39.000000', 'consum', 0.0224, 'lps'),
	(466517, 123, '2015-04-01 00:16:40.000000', 'consum', 0.0221, 'lps'),
	(466518, 123, '2015-04-01 00:16:41.000000', 'consum', 0.0224, 'lps'),
	(466519, 123, '2015-04-01 00:16:42.000000', 'consum', 0.0220, 'lps'),
	(466520, 123, '2015-04-01 00:16:43.000000', 'consum', 0.0218, 'lps'),
	(466521, 123, '2015-04-01 00:16:44.000000', 'consum', 0.0219, 'lps'),
	(466522, 123, '2015-04-01 00:16:45.000000', 'consum', 0.0234, 'lps'),
	(466523, 123, '2015-04-01 00:16:46.000000', 'consum', 0.0220, 'lps'),
	(466524, 123, '2015-04-01 00:16:47.000000', 'consum', 0.0214, 'lps'),
	(466525, 123, '2015-04-01 00:16:48.000000', 'consum', 0.0231, 'lps'),
	(466526, 123, '2015-04-01 00:16:49.000000', 'consum', 0.0218, 'lps'),
	(466527, 123, '2015-04-01 00:16:50.000000', 'consum', 0.0215, 'lps'),
	(466528, 123, '2015-04-01 00:16:51.000000', 'consum', 0.0213, 'lps'),
	(466529, 123, '2015-04-01 00:16:52.000000', 'consum', 0.0211, 'lps'),
	(466530, 123, '2015-04-01 00:16:53.000000', 'consum', 0.0233, 'lps'),
	(466531, 123, '2015-04-01 00:16:54.000000', 'consum', 0.0213, 'lps'),
	(466532, 123, '2015-04-01 00:16:55.000000', 'consum', 0.0211, 'lps'),
	(466533, 123, '2015-04-01 00:16:56.000000', 'consum', 0.0236, 'lps'),
	(466534, 123, '2015-04-01 00:16:57.000000', 'consum', 0.0225, 'lps'),
	(466535, 123, '2015-04-01 00:16:58.000000', 'consum', 0.0235, 'lps'),
	(466536, 123, '2015-04-01 00:16:59.000000', 'consum', 0.0234, 'lps'),
	(466537, 123, '2015-04-01 00:17:00.000000', 'consum', 0.0230, 'lps'),
	(466538, 123, '2015-04-01 00:17:01.000000', 'consum', 0.0236, 'lps'),
	(466539, 123, '2015-04-01 00:17:02.000000', 'consum', 0.0226, 'lps'),
	(466540, 123, '2015-04-01 00:17:03.000000', 'consum', 0.0212, 'lps'),
	(466541, 123, '2015-04-01 00:17:04.000000', 'consum', 0.0230, 'lps'),
	(466542, 123, '2015-04-01 00:17:05.000000', 'consum', 0.0221, 'lps'),
	(466543, 123, '2015-04-01 00:17:06.000000', 'consum', 0.0233, 'lps'),
	(466544, 123, '2015-04-01 00:17:07.000000', 'consum', 0.0236, 'lps'),
	(466545, 123, '2015-04-01 00:17:08.000000', 'consum', 0.0216, 'lps'),
	(466546, 123, '2015-04-01 00:17:09.000000', 'consum', 0.0218, 'lps'),
	(466547, 123, '2015-04-01 00:17:10.000000', 'consum', 0.0235, 'lps'),
	(466548, 123, '2015-04-01 00:17:11.000000', 'consum', 0.0224, 'lps'),
	(466549, 123, '2015-04-01 00:17:12.000000', 'consum', 0.0235, 'lps'),
	(466550, 123, '2015-04-01 00:17:13.000000', 'consum', 0.0211, 'lps'),
	(466551, 123, '2015-04-01 00:17:14.000000', 'consum', 0.0222, 'lps'),
	(466552, 123, '2015-04-01 00:17:15.000000', 'consum', 0.0211, 'lps'),
	(466553, 123, '2015-04-01 00:17:16.000000', 'consum', 0.0236, 'lps'),
	(466554, 123, '2015-04-01 00:17:17.000000', 'consum', 0.0224, 'lps'),
	(466555, 123, '2015-04-01 00:17:18.000000', 'consum', 0.0232, 'lps'),
	(466556, 123, '2015-04-01 00:17:19.000000', 'consum', 0.0221, 'lps'),
	(466557, 123, '2015-04-01 00:17:20.000000', 'consum', 0.0227, 'lps'),
	(466558, 123, '2015-04-01 00:17:21.000000', 'consum', 0.0234, 'lps'),
	(466559, 123, '2015-04-01 00:17:22.000000', 'consum', 0.0226, 'lps'),
	(466560, 123, '2015-04-01 00:17:23.000000', 'consum', 0.0218, 'lps'),
	(466561, 123, '2015-04-01 00:17:24.000000', 'consum', 0.0230, 'lps'),
	(466562, 123, '2015-04-01 00:17:25.000000', 'consum', 0.0229, 'lps'),
	(466563, 123, '2015-04-01 00:17:26.000000', 'consum', 0.0219, 'lps'),
	(466564, 123, '2015-04-01 00:17:27.000000', 'consum', 0.0226, 'lps'),
	(466565, 123, '2015-04-01 00:17:28.000000', 'consum', 0.0235, 'lps'),
	(466566, 123, '2015-04-01 00:17:29.000000', 'consum', 0.0233, 'lps'),
	(466567, 123, '2015-04-01 00:17:30.000000', 'consum', 0.0223, 'lps'),
	(466568, 123, '2015-04-01 00:17:31.000000', 'consum', 0.0234, 'lps'),
	(466569, 123, '2015-04-01 00:17:32.000000', 'consum', 0.0234, 'lps'),
	(466570, 123, '2015-04-01 00:17:33.000000', 'consum', 0.0231, 'lps'),
	(466571, 123, '2015-04-01 00:17:34.000000', 'consum', 0.0216, 'lps'),
	(466572, 123, '2015-04-01 00:17:35.000000', 'consum', 0.0235, 'lps'),
	(466573, 123, '2015-04-01 00:17:36.000000', 'consum', 0.0233, 'lps'),
	(466574, 123, '2015-04-01 00:17:37.000000', 'consum', 0.0221, 'lps'),
	(466575, 123, '2015-04-01 00:17:38.000000', 'consum', 0.0224, 'lps'),
	(466576, 123, '2015-04-01 00:17:39.000000', 'consum', 0.0220, 'lps'),
	(466577, 123, '2015-04-01 00:17:40.000000', 'consum', 0.0220, 'lps'),
	(466578, 123, '2015-04-01 00:17:41.000000', 'consum', 0.0228, 'lps'),
	(466579, 123, '2015-04-01 00:17:42.000000', 'consum', 0.0216, 'lps'),
	(466580, 123, '2015-04-01 00:17:43.000000', 'consum', 0.0216, 'lps'),
	(466581, 123, '2015-04-01 00:17:44.000000', 'consum', 0.0220, 'lps'),
	(466582, 123, '2015-04-01 00:17:45.000000', 'consum', 0.0218, 'lps'),
	(466583, 123, '2015-04-01 00:17:46.000000', 'consum', 0.0217, 'lps'),
	(466584, 123, '2015-04-01 00:17:47.000000', 'consum', 0.0221, 'lps'),
	(466585, 123, '2015-04-01 00:17:48.000000', 'consum', 0.0219, 'lps'),
	(466586, 123, '2015-04-01 00:17:49.000000', 'consum', 0.0220, 'lps'),
	(466587, 123, '2015-04-01 00:17:50.000000', 'consum', 0.0234, 'lps'),
	(466588, 123, '2015-04-01 00:17:51.000000', 'consum', 0.0217, 'lps'),
	(466589, 123, '2015-04-01 00:17:52.000000', 'consum', 0.0229, 'lps'),
	(466590, 123, '2015-04-01 00:17:53.000000', 'consum', 0.0227, 'lps'),
	(466591, 123, '2015-04-01 00:17:54.000000', 'consum', 0.0211, 'lps'),
	(466592, 123, '2015-04-01 00:17:55.000000', 'consum', 0.0220, 'lps'),
	(466593, 123, '2015-04-01 00:17:56.000000', 'consum', 0.0230, 'lps'),
	(466594, 123, '2015-04-01 00:17:57.000000', 'consum', 0.0225, 'lps'),
	(466595, 123, '2015-04-01 00:17:58.000000', 'consum', 0.0226, 'lps'),
	(466596, 123, '2015-04-01 00:17:59.000000', 'consum', 0.0215, 'lps'),
	(466597, 123, '2015-04-01 00:18:00.000000', 'consum', 0.0217, 'lps'),
	(466598, 123, '2015-04-01 00:18:01.000000', 'consum', 0.0231, 'lps'),
	(466599, 123, '2015-04-01 00:18:02.000000', 'consum', 0.0212, 'lps'),
	(466600, 123, '2015-04-01 00:18:03.000000', 'consum', 0.0211, 'lps'),
	(466601, 123, '2015-04-01 00:18:04.000000', 'consum', 0.0212, 'lps'),
	(466602, 123, '2015-04-01 00:18:05.000000', 'consum', 0.0217, 'lps'),
	(466603, 123, '2015-04-01 00:18:06.000000', 'consum', 0.0237, 'lps'),
	(466604, 123, '2015-04-01 00:18:07.000000', 'consum', 0.0214, 'lps'),
	(466605, 123, '2015-04-01 00:18:08.000000', 'consum', 0.0235, 'lps'),
	(466606, 123, '2015-04-01 00:18:09.000000', 'consum', 0.0211, 'lps'),
	(466607, 123, '2015-04-01 00:18:10.000000', 'consum', 0.0225, 'lps'),
	(466608, 123, '2015-04-01 00:18:11.000000', 'consum', 0.0227, 'lps'),
	(466609, 123, '2015-04-01 00:18:12.000000', 'consum', 0.0221, 'lps'),
	(466610, 123, '2015-04-01 00:18:13.000000', 'consum', 0.0217, 'lps'),
	(466611, 123, '2015-04-01 00:18:14.000000', 'consum', 0.0210, 'lps'),
	(466612, 123, '2015-04-01 00:18:15.000000', 'consum', 0.0220, 'lps'),
	(466613, 123, '2015-04-01 00:18:16.000000', 'consum', 0.0229, 'lps'),
	(466614, 123, '2015-04-01 00:18:17.000000', 'consum', 0.0222, 'lps'),
	(466615, 123, '2015-04-01 00:18:18.000000', 'consum', 0.0213, 'lps'),
	(466616, 123, '2015-04-01 00:18:19.000000', 'consum', 0.0218, 'lps'),
	(466617, 123, '2015-04-01 00:18:20.000000', 'consum', 0.0215, 'lps'),
	(466618, 123, '2015-04-01 00:18:21.000000', 'consum', 0.0211, 'lps'),
	(466619, 123, '2015-04-01 00:18:22.000000', 'consum', 0.0228, 'lps'),
	(466620, 123, '2015-04-01 00:18:23.000000', 'consum', 0.0215, 'lps'),
	(466621, 123, '2015-04-01 00:18:24.000000', 'consum', 0.0234, 'lps'),
	(466622, 123, '2015-04-01 00:18:25.000000', 'consum', 0.0235, 'lps'),
	(466623, 123, '2015-04-01 00:18:26.000000', 'consum', 0.0234, 'lps'),
	(466624, 123, '2015-04-01 00:18:27.000000', 'consum', 0.0227, 'lps'),
	(466625, 123, '2015-04-01 00:18:28.000000', 'consum', 0.0223, 'lps'),
	(466626, 123, '2015-04-01 00:18:29.000000', 'consum', 0.0227, 'lps'),
	(466627, 123, '2015-04-01 00:18:30.000000', 'consum', 0.0228, 'lps'),
	(466628, 123, '2015-04-01 00:18:31.000000', 'consum', 0.0220, 'lps'),
	(466629, 123, '2015-04-01 00:18:32.000000', 'consum', 0.0233, 'lps'),
	(466630, 123, '2015-04-01 00:18:33.000000', 'consum', 0.0215, 'lps'),
	(466631, 123, '2015-04-01 00:18:34.000000', 'consum', 0.0221, 'lps'),
	(466632, 123, '2015-04-01 00:18:35.000000', 'consum', 0.0224, 'lps'),
	(466633, 123, '2015-04-01 00:18:36.000000', 'consum', 0.0217, 'lps'),
	(466634, 123, '2015-04-01 00:18:37.000000', 'consum', 0.0235, 'lps'),
	(466635, 123, '2015-04-01 00:18:38.000000', 'consum', 0.0227, 'lps'),
	(466636, 123, '2015-04-01 00:18:39.000000', 'consum', 0.0223, 'lps'),
	(466637, 123, '2015-04-01 00:18:40.000000', 'consum', 0.0223, 'lps'),
	(466638, 123, '2015-04-01 00:18:41.000000', 'consum', 0.0210, 'lps'),
	(466639, 123, '2015-04-01 00:18:42.000000', 'consum', 0.0225, 'lps'),
	(466640, 123, '2015-04-01 00:18:43.000000', 'consum', 0.0232, 'lps'),
	(466641, 123, '2015-04-01 00:18:44.000000', 'consum', 0.0217, 'lps'),
	(466642, 123, '2015-04-01 00:18:45.000000', 'consum', 0.0210, 'lps'),
	(466643, 123, '2015-04-01 00:18:46.000000', 'consum', 0.0217, 'lps'),
	(466644, 123, '2015-04-01 00:18:47.000000', 'consum', 0.0219, 'lps'),
	(466645, 123, '2015-04-01 00:18:48.000000', 'consum', 0.0234, 'lps'),
	(466646, 123, '2015-04-01 00:18:49.000000', 'consum', 0.0217, 'lps'),
	(466647, 123, '2015-04-01 00:18:50.000000', 'consum', 0.0231, 'lps'),
	(466648, 123, '2015-04-01 00:18:51.000000', 'consum', 0.0211, 'lps'),
	(466649, 123, '2015-04-01 00:18:52.000000', 'consum', 0.0234, 'lps'),
	(466650, 123, '2015-04-01 00:18:53.000000', 'consum', 0.0217, 'lps'),
	(466651, 123, '2015-04-01 00:18:54.000000', 'consum', 0.0232, 'lps'),
	(466652, 123, '2015-04-01 00:18:55.000000', 'consum', 0.0212, 'lps'),
	(466653, 123, '2015-04-01 00:18:56.000000', 'consum', 0.0211, 'lps'),
	(466654, 123, '2015-04-01 00:18:57.000000', 'consum', 0.0237, 'lps'),
	(466655, 123, '2015-04-01 00:18:58.000000', 'consum', 0.0232, 'lps'),
	(466656, 123, '2015-04-01 00:18:59.000000', 'consum', 0.0212, 'lps'),
	(466657, 123, '2015-04-01 00:19:00.000000', 'consum', 0.0237, 'lps'),
	(466658, 123, '2015-04-01 00:19:01.000000', 'consum', 0.0230, 'lps'),
	(466659, 123, '2015-04-01 00:19:02.000000', 'consum', 0.0227, 'lps'),
	(466660, 123, '2015-04-01 00:19:03.000000', 'consum', 0.0235, 'lps'),
	(466661, 123, '2015-04-01 00:19:04.000000', 'consum', 0.0229, 'lps'),
	(466662, 123, '2015-04-01 00:19:05.000000', 'consum', 0.0230, 'lps'),
	(466663, 123, '2015-04-01 00:19:06.000000', 'consum', 0.0225, 'lps'),
	(466664, 123, '2015-04-01 00:19:07.000000', 'consum', 0.0225, 'lps'),
	(466665, 123, '2015-04-01 00:19:08.000000', 'consum', 0.0214, 'lps'),
	(466666, 123, '2015-04-01 00:19:09.000000', 'consum', 0.0212, 'lps'),
	(466667, 123, '2015-04-01 00:19:10.000000', 'consum', 0.0235, 'lps'),
	(466668, 123, '2015-04-01 00:19:11.000000', 'consum', 0.0220, 'lps'),
	(466669, 123, '2015-04-01 00:19:12.000000', 'consum', 0.0211, 'lps'),
	(466670, 123, '2015-04-01 00:19:13.000000', 'consum', 0.0215, 'lps'),
	(466671, 123, '2015-04-01 00:19:14.000000', 'consum', 0.0230, 'lps'),
	(466672, 123, '2015-04-01 00:19:15.000000', 'consum', 0.0215, 'lps'),
	(466673, 123, '2015-04-01 00:19:16.000000', 'consum', 0.0230, 'lps'),
	(466674, 123, '2015-04-01 00:19:17.000000', 'consum', 0.0211, 'lps'),
	(466675, 123, '2015-04-01 00:19:18.000000', 'consum', 0.0212, 'lps'),
	(466676, 123, '2015-04-01 00:19:19.000000', 'consum', 0.0217, 'lps'),
	(466677, 123, '2015-04-01 00:19:20.000000', 'consum', 0.0213, 'lps'),
	(466678, 123, '2015-04-01 00:19:21.000000', 'consum', 0.0231, 'lps'),
	(466679, 123, '2015-04-01 00:19:22.000000', 'consum', 0.0224, 'lps'),
	(466680, 123, '2015-04-01 00:19:23.000000', 'consum', 0.0216, 'lps'),
	(466681, 123, '2015-04-01 00:19:24.000000', 'consum', 0.0228, 'lps'),
	(466682, 123, '2015-04-01 00:19:25.000000', 'consum', 0.0224, 'lps'),
	(466683, 123, '2015-04-01 00:19:26.000000', 'consum', 0.0228, 'lps'),
	(466684, 123, '2015-04-01 00:19:27.000000', 'consum', 0.0231, 'lps'),
	(466685, 123, '2015-04-01 00:19:28.000000', 'consum', 0.0235, 'lps'),
	(466686, 123, '2015-04-01 00:19:29.000000', 'consum', 0.0215, 'lps'),
	(466687, 123, '2015-04-01 00:19:30.000000', 'consum', 0.0218, 'lps'),
	(466688, 123, '2015-04-01 00:19:31.000000', 'consum', 0.0234, 'lps'),
	(466689, 123, '2015-04-01 00:19:32.000000', 'consum', 0.0223, 'lps'),
	(466690, 123, '2015-04-01 00:19:33.000000', 'consum', 0.0230, 'lps'),
	(466691, 123, '2015-04-01 00:19:34.000000', 'consum', 0.0218, 'lps'),
	(466692, 123, '2015-04-01 00:19:35.000000', 'consum', 0.0216, 'lps'),
	(466693, 123, '2015-04-01 00:19:36.000000', 'consum', 0.0220, 'lps'),
	(466694, 123, '2015-04-01 00:19:37.000000', 'consum', 0.0211, 'lps'),
	(466695, 123, '2015-04-01 00:19:38.000000', 'consum', 0.0216, 'lps'),
	(466696, 123, '2015-04-01 00:19:39.000000', 'consum', 0.0236, 'lps'),
	(466697, 123, '2015-04-01 00:19:40.000000', 'consum', 0.0210, 'lps'),
	(466698, 123, '2015-04-01 00:19:41.000000', 'consum', 0.0217, 'lps'),
	(466699, 123, '2015-04-01 00:19:42.000000', 'consum', 0.0217, 'lps'),
	(466700, 123, '2015-04-01 00:19:43.000000', 'consum', 0.0226, 'lps'),
	(466701, 123, '2015-04-01 00:19:44.000000', 'consum', 0.0213, 'lps'),
	(466702, 123, '2015-04-01 00:19:45.000000', 'consum', 0.0232, 'lps'),
	(466703, 123, '2015-04-01 00:19:46.000000', 'consum', 0.0229, 'lps'),
	(466704, 123, '2015-04-01 00:19:47.000000', 'consum', 0.0211, 'lps'),
	(466705, 123, '2015-04-01 00:19:48.000000', 'consum', 0.0213, 'lps'),
	(466706, 123, '2015-04-01 00:19:49.000000', 'consum', 0.0224, 'lps'),
	(466707, 123, '2015-04-01 00:19:50.000000', 'consum', 0.0216, 'lps'),
	(466708, 123, '2015-04-01 00:19:51.000000', 'consum', 0.0224, 'lps'),
	(466709, 123, '2015-04-01 00:19:52.000000', 'consum', 0.0236, 'lps'),
	(466710, 123, '2015-04-01 00:19:53.000000', 'consum', 0.0213, 'lps'),
	(466711, 123, '2015-04-01 00:19:54.000000', 'consum', 0.0234, 'lps'),
	(466712, 123, '2015-04-01 00:19:55.000000', 'consum', 0.0237, 'lps'),
	(466713, 123, '2015-04-01 00:19:56.000000', 'consum', 0.0218, 'lps'),
	(466714, 123, '2015-04-01 00:19:57.000000', 'consum', 0.0225, 'lps'),
	(466715, 123, '2015-04-01 00:19:58.000000', 'consum', 0.0235, 'lps'),
	(466716, 123, '2015-04-01 00:19:59.000000', 'consum', 0.0234, 'lps'),
	(466717, 123, '2015-04-01 00:20:00.000000', 'consum', 0.0228, 'lps'),
	(466718, 123, '2015-04-01 00:20:01.000000', 'consum', 0.0228, 'lps'),
	(466719, 123, '2015-04-01 00:20:02.000000', 'consum', 0.0219, 'lps'),
	(466720, 123, '2015-04-01 00:20:03.000000', 'consum', 0.0230, 'lps'),
	(466721, 123, '2015-04-01 00:20:04.000000', 'consum', 0.0225, 'lps'),
	(466722, 123, '2015-04-01 00:20:05.000000', 'consum', 0.0227, 'lps'),
	(466723, 123, '2015-04-01 00:20:06.000000', 'consum', 0.0224, 'lps'),
	(466724, 123, '2015-04-01 00:20:07.000000', 'consum', 0.0230, 'lps'),
	(466725, 123, '2015-04-01 00:20:08.000000', 'consum', 0.0212, 'lps'),
	(466726, 123, '2015-04-01 00:20:09.000000', 'consum', 0.0214, 'lps'),
	(466727, 123, '2015-04-01 00:20:10.000000', 'consum', 0.0228, 'lps'),
	(466728, 123, '2015-04-01 00:20:11.000000', 'consum', 0.0230, 'lps'),
	(466729, 123, '2015-04-01 00:20:12.000000', 'consum', 0.0227, 'lps'),
	(466730, 123, '2015-04-01 00:20:13.000000', 'consum', 0.0210, 'lps'),
	(466731, 123, '2015-04-01 00:20:14.000000', 'consum', 0.0215, 'lps'),
	(466732, 123, '2015-04-01 00:20:15.000000', 'consum', 0.0237, 'lps'),
	(466733, 123, '2015-04-01 00:20:16.000000', 'consum', 0.0217, 'lps'),
	(466734, 123, '2015-04-01 00:20:17.000000', 'consum', 0.0222, 'lps'),
	(466735, 123, '2015-04-01 00:20:18.000000', 'consum', 0.0220, 'lps'),
	(466736, 123, '2015-04-01 00:20:19.000000', 'consum', 0.0224, 'lps'),
	(466737, 123, '2015-04-01 00:20:20.000000', 'consum', 0.0225, 'lps'),
	(466738, 123, '2015-04-01 00:20:21.000000', 'consum', 0.0212, 'lps'),
	(466739, 123, '2015-04-01 00:20:22.000000', 'consum', 0.0233, 'lps'),
	(466740, 123, '2015-04-01 00:20:23.000000', 'consum', 0.0237, 'lps'),
	(466741, 123, '2015-04-01 00:20:24.000000', 'consum', 0.0221, 'lps'),
	(466742, 123, '2015-04-01 00:20:25.000000', 'consum', 0.0237, 'lps'),
	(466743, 123, '2015-04-01 00:20:26.000000', 'consum', 0.0232, 'lps'),
	(466744, 123, '2015-04-01 00:20:27.000000', 'consum', 0.0237, 'lps'),
	(466745, 123, '2015-04-01 00:20:28.000000', 'consum', 0.0223, 'lps'),
	(466746, 123, '2015-04-01 00:20:29.000000', 'consum', 0.0224, 'lps'),
	(466747, 123, '2015-04-01 00:20:30.000000', 'consum', 0.0212, 'lps'),
	(466748, 123, '2015-04-01 00:20:31.000000', 'consum', 0.0233, 'lps'),
	(466749, 123, '2015-04-01 00:20:32.000000', 'consum', 0.0210, 'lps'),
	(466750, 123, '2015-04-01 00:20:33.000000', 'consum', 0.0226, 'lps'),
	(466751, 123, '2015-04-01 00:20:34.000000', 'consum', 0.0234, 'lps'),
	(466752, 123, '2015-04-01 00:20:35.000000', 'consum', 0.0228, 'lps'),
	(466753, 123, '2015-04-01 00:20:36.000000', 'consum', 0.0226, 'lps'),
	(466754, 123, '2015-04-01 00:20:37.000000', 'consum', 0.0210, 'lps'),
	(466755, 123, '2015-04-01 00:20:38.000000', 'consum', 0.0216, 'lps'),
	(466756, 123, '2015-04-01 00:20:39.000000', 'consum', 0.0216, 'lps'),
	(466757, 123, '2015-04-01 00:20:40.000000', 'consum', 0.0220, 'lps'),
	(466758, 123, '2015-04-01 00:20:41.000000', 'consum', 0.0214, 'lps'),
	(466759, 123, '2015-04-01 00:20:42.000000', 'consum', 0.0230, 'lps'),
	(466760, 123, '2015-04-01 00:20:43.000000', 'consum', 0.0213, 'lps'),
	(466761, 123, '2015-04-01 00:20:44.000000', 'consum', 0.0221, 'lps'),
	(466762, 123, '2015-04-01 00:20:45.000000', 'consum', 0.0228, 'lps'),
	(466763, 123, '2015-04-01 00:20:46.000000', 'consum', 0.0212, 'lps'),
	(466764, 123, '2015-04-01 00:20:47.000000', 'consum', 0.0225, 'lps'),
	(466765, 123, '2015-04-01 00:20:48.000000', 'consum', 0.0221, 'lps'),
	(466766, 123, '2015-04-01 00:20:49.000000', 'consum', 0.0220, 'lps'),
	(466767, 123, '2015-04-01 00:20:50.000000', 'consum', 0.0228, 'lps'),
	(466768, 123, '2015-04-01 00:20:51.000000', 'consum', 0.0215, 'lps'),
	(466769, 123, '2015-04-01 00:20:52.000000', 'consum', 0.0237, 'lps'),
	(466770, 123, '2015-04-01 00:20:53.000000', 'consum', 0.0218, 'lps'),
	(466771, 123, '2015-04-01 00:20:54.000000', 'consum', 0.0226, 'lps'),
	(466772, 123, '2015-04-01 00:20:55.000000', 'consum', 0.0211, 'lps'),
	(466773, 123, '2015-04-01 00:20:56.000000', 'consum', 0.0225, 'lps'),
	(466774, 123, '2015-04-01 00:20:57.000000', 'consum', 0.0224, 'lps'),
	(466775, 123, '2015-04-01 00:20:58.000000', 'consum', 0.0237, 'lps'),
	(466776, 123, '2015-04-01 00:20:59.000000', 'consum', 0.0219, 'lps'),
	(466777, 123, '2015-04-01 00:21:00.000000', 'consum', 0.0232, 'lps'),
	(466778, 123, '2015-04-01 00:21:01.000000', 'consum', 0.0210, 'lps'),
	(466779, 123, '2015-04-01 00:21:02.000000', 'consum', 0.0229, 'lps'),
	(466780, 123, '2015-04-01 00:21:03.000000', 'consum', 0.0218, 'lps'),
	(466781, 123, '2015-04-01 00:21:04.000000', 'consum', 0.0225, 'lps'),
	(466782, 123, '2015-04-01 00:21:05.000000', 'consum', 0.0233, 'lps'),
	(466783, 123, '2015-04-01 00:21:06.000000', 'consum', 0.0223, 'lps'),
	(466784, 123, '2015-04-01 00:21:07.000000', 'consum', 0.0234, 'lps'),
	(466785, 123, '2015-04-01 00:21:08.000000', 'consum', 0.0237, 'lps'),
	(466786, 123, '2015-04-01 00:21:09.000000', 'consum', 0.0218, 'lps'),
	(466787, 123, '2015-04-01 00:21:10.000000', 'consum', 0.0224, 'lps'),
	(466788, 123, '2015-04-01 00:21:11.000000', 'consum', 0.0228, 'lps'),
	(466789, 123, '2015-04-01 00:21:12.000000', 'consum', 0.0231, 'lps'),
	(466790, 123, '2015-04-01 00:21:13.000000', 'consum', 0.0235, 'lps'),
	(466791, 123, '2015-04-01 00:21:14.000000', 'consum', 0.0217, 'lps'),
	(466792, 123, '2015-04-01 00:21:15.000000', 'consum', 0.0225, 'lps'),
	(466793, 123, '2015-04-01 00:21:16.000000', 'consum', 0.0236, 'lps'),
	(466794, 123, '2015-04-01 00:21:17.000000', 'consum', 0.0212, 'lps'),
	(466795, 123, '2015-04-01 00:21:18.000000', 'consum', 0.0227, 'lps'),
	(466796, 123, '2015-04-01 00:21:19.000000', 'consum', 0.0233, 'lps'),
	(466797, 123, '2015-04-01 00:21:20.000000', 'consum', 0.0220, 'lps'),
	(466798, 123, '2015-04-01 00:21:21.000000', 'consum', 0.0216, 'lps'),
	(466799, 123, '2015-04-01 00:21:22.000000', 'consum', 0.0214, 'lps'),
	(466800, 123, '2015-04-01 00:21:23.000000', 'consum', 0.0212, 'lps'),
	(466801, 123, '2015-04-01 00:21:24.000000', 'consum', 0.0237, 'lps'),
	(466802, 123, '2015-04-01 00:21:25.000000', 'consum', 0.0227, 'lps'),
	(466803, 123, '2015-04-01 00:21:26.000000', 'consum', 0.0216, 'lps'),
	(466804, 123, '2015-04-01 00:21:27.000000', 'consum', 0.0217, 'lps'),
	(466805, 123, '2015-04-01 00:21:28.000000', 'consum', 0.0226, 'lps'),
	(466806, 123, '2015-04-01 00:21:29.000000', 'consum', 0.0216, 'lps'),
	(466807, 123, '2015-04-01 00:21:30.000000', 'consum', 0.0219, 'lps'),
	(466808, 123, '2015-04-01 00:21:31.000000', 'consum', 0.0212, 'lps'),
	(466809, 123, '2015-04-01 00:21:32.000000', 'consum', 0.0218, 'lps'),
	(466810, 123, '2015-04-01 00:21:33.000000', 'consum', 0.0218, 'lps'),
	(466811, 123, '2015-04-01 00:21:34.000000', 'consum', 0.0227, 'lps'),
	(466812, 123, '2015-04-01 00:21:35.000000', 'consum', 0.0217, 'lps'),
	(466813, 123, '2015-04-01 00:21:36.000000', 'consum', 0.0221, 'lps'),
	(466814, 123, '2015-04-01 00:21:37.000000', 'consum', 0.0215, 'lps'),
	(466815, 123, '2015-04-01 00:21:38.000000', 'consum', 0.0232, 'lps'),
	(466816, 123, '2015-04-01 00:21:39.000000', 'consum', 0.0222, 'lps'),
	(466817, 123, '2015-04-01 00:21:40.000000', 'consum', 0.0233, 'lps'),
	(466818, 123, '2015-04-01 00:21:41.000000', 'consum', 0.0234, 'lps'),
	(466819, 123, '2015-04-01 00:21:42.000000', 'consum', 0.0231, 'lps'),
	(466820, 123, '2015-04-01 00:21:43.000000', 'consum', 0.0218, 'lps'),
	(466821, 123, '2015-04-01 00:21:44.000000', 'consum', 0.0213, 'lps'),
	(466822, 123, '2015-04-01 00:21:45.000000', 'consum', 0.0229, 'lps'),
	(466823, 123, '2015-04-01 00:21:46.000000', 'consum', 0.0213, 'lps'),
	(466824, 123, '2015-04-01 00:21:47.000000', 'consum', 0.0224, 'lps'),
	(466825, 123, '2015-04-01 00:21:48.000000', 'consum', 0.0216, 'lps'),
	(466826, 123, '2015-04-01 00:21:49.000000', 'consum', 0.0225, 'lps'),
	(466827, 123, '2015-04-01 00:21:50.000000', 'consum', 0.0215, 'lps'),
	(466828, 123, '2015-04-01 00:21:51.000000', 'consum', 0.0215, 'lps'),
	(466829, 123, '2015-04-01 00:21:52.000000', 'consum', 0.0221, 'lps'),
	(466830, 123, '2015-04-01 00:21:53.000000', 'consum', 0.0225, 'lps'),
	(466831, 123, '2015-04-01 00:21:54.000000', 'consum', 0.0221, 'lps'),
	(466832, 123, '2015-04-01 00:21:55.000000', 'consum', 0.0224, 'lps'),
	(466833, 123, '2015-04-01 00:21:56.000000', 'consum', 0.0217, 'lps'),
	(466834, 123, '2015-04-01 00:21:57.000000', 'consum', 0.0234, 'lps'),
	(466835, 123, '2015-04-01 00:21:58.000000', 'consum', 0.0223, 'lps'),
	(466836, 123, '2015-04-01 00:21:59.000000', 'consum', 0.0231, 'lps'),
	(466837, 123, '2015-04-01 00:22:00.000000', 'consum', 0.0222, 'lps'),
	(466838, 123, '2015-04-01 00:22:01.000000', 'consum', 0.0235, 'lps'),
	(466839, 123, '2015-04-01 00:22:02.000000', 'consum', 0.0215, 'lps'),
	(466840, 123, '2015-04-01 00:22:03.000000', 'consum', 0.0217, 'lps'),
	(466841, 123, '2015-04-01 00:22:04.000000', 'consum', 0.0232, 'lps'),
	(466842, 123, '2015-04-01 00:22:05.000000', 'consum', 0.0213, 'lps'),
	(466843, 123, '2015-04-01 00:22:06.000000', 'consum', 0.0216, 'lps'),
	(466844, 123, '2015-04-01 00:22:07.000000', 'consum', 0.0233, 'lps'),
	(466845, 123, '2015-04-01 00:22:08.000000', 'consum', 0.0224, 'lps'),
	(466846, 123, '2015-04-01 00:22:09.000000', 'consum', 0.0210, 'lps'),
	(466847, 123, '2015-04-01 00:22:10.000000', 'consum', 0.0226, 'lps'),
	(466848, 123, '2015-04-01 00:22:11.000000', 'consum', 0.0234, 'lps'),
	(466849, 123, '2015-04-01 00:22:12.000000', 'consum', 0.0228, 'lps'),
	(466850, 123, '2015-04-01 00:22:13.000000', 'consum', 0.0225, 'lps'),
	(466851, 123, '2015-04-01 00:22:14.000000', 'consum', 0.0235, 'lps'),
	(466852, 123, '2015-04-01 00:22:15.000000', 'consum', 0.0233, 'lps'),
	(466853, 123, '2015-04-01 00:22:16.000000', 'consum', 0.0223, 'lps'),
	(466854, 123, '2015-04-01 00:22:17.000000', 'consum', 0.0235, 'lps'),
	(466855, 123, '2015-04-01 00:22:18.000000', 'consum', 0.0214, 'lps'),
	(466856, 123, '2015-04-01 00:22:19.000000', 'consum', 0.0210, 'lps'),
	(466857, 123, '2015-04-01 00:22:20.000000', 'consum', 0.0225, 'lps'),
	(466858, 123, '2015-04-01 00:22:21.000000', 'consum', 0.0230, 'lps'),
	(466859, 123, '2015-04-01 00:22:22.000000', 'consum', 0.0237, 'lps'),
	(466860, 123, '2015-04-01 00:22:23.000000', 'consum', 0.0229, 'lps'),
	(466861, 123, '2015-04-01 00:22:24.000000', 'consum', 0.0225, 'lps'),
	(466862, 123, '2015-04-01 00:22:25.000000', 'consum', 0.0228, 'lps'),
	(466863, 123, '2015-04-01 00:22:26.000000', 'consum', 0.0226, 'lps'),
	(466864, 123, '2015-04-01 00:22:27.000000', 'consum', 0.0237, 'lps'),
	(466865, 123, '2015-04-01 00:22:28.000000', 'consum', 0.0216, 'lps'),
	(466866, 123, '2015-04-01 00:22:29.000000', 'consum', 0.0215, 'lps'),
	(466867, 123, '2015-04-01 00:22:30.000000', 'consum', 0.0216, 'lps'),
	(466868, 123, '2015-04-01 00:22:31.000000', 'consum', 0.0226, 'lps'),
	(466869, 123, '2015-04-01 00:22:32.000000', 'consum', 0.0217, 'lps'),
	(466870, 123, '2015-04-01 00:22:33.000000', 'consum', 0.0226, 'lps'),
	(466871, 123, '2015-04-01 00:22:34.000000', 'consum', 0.0212, 'lps'),
	(466872, 123, '2015-04-01 00:22:35.000000', 'consum', 0.0230, 'lps'),
	(466873, 123, '2015-04-01 00:22:36.000000', 'consum', 0.0222, 'lps'),
	(466874, 123, '2015-04-01 00:22:37.000000', 'consum', 0.0236, 'lps'),
	(466875, 123, '2015-04-01 00:22:38.000000', 'consum', 0.0222, 'lps'),
	(466876, 123, '2015-04-01 00:22:39.000000', 'consum', 0.0218, 'lps'),
	(466877, 123, '2015-04-01 00:22:40.000000', 'consum', 0.0216, 'lps'),
	(466878, 123, '2015-04-01 00:22:41.000000', 'consum', 0.0216, 'lps'),
	(466879, 123, '2015-04-01 00:22:42.000000', 'consum', 0.0224, 'lps'),
	(466880, 123, '2015-04-01 00:22:43.000000', 'consum', 0.0235, 'lps'),
	(466881, 123, '2015-04-01 00:22:44.000000', 'consum', 0.0210, 'lps'),
	(466882, 123, '2015-04-01 00:22:45.000000', 'consum', 0.0219, 'lps'),
	(466883, 123, '2015-04-01 00:22:46.000000', 'consum', 0.0226, 'lps'),
	(466884, 123, '2015-04-01 00:22:47.000000', 'consum', 0.0235, 'lps'),
	(466885, 123, '2015-04-01 00:22:48.000000', 'consum', 0.0234, 'lps'),
	(466886, 123, '2015-04-01 00:22:49.000000', 'consum', 0.0228, 'lps'),
	(466887, 123, '2015-04-01 00:22:50.000000', 'consum', 0.0226, 'lps'),
	(466888, 123, '2015-04-01 00:22:51.000000', 'consum', 0.0237, 'lps'),
	(466889, 123, '2015-04-01 00:22:52.000000', 'consum', 0.0215, 'lps'),
	(466890, 123, '2015-04-01 00:22:53.000000', 'consum', 0.0211, 'lps'),
	(466891, 123, '2015-04-01 00:22:54.000000', 'consum', 0.0227, 'lps'),
	(466892, 123, '2015-04-01 00:22:55.000000', 'consum', 0.0237, 'lps'),
	(466893, 123, '2015-04-01 00:22:56.000000', 'consum', 0.0210, 'lps'),
	(466894, 123, '2015-04-01 00:22:57.000000', 'consum', 0.0215, 'lps'),
	(466895, 123, '2015-04-01 00:22:58.000000', 'consum', 0.0234, 'lps'),
	(466896, 123, '2015-04-01 00:22:59.000000', 'consum', 0.0233, 'lps'),
	(466897, 123, '2015-04-01 00:23:00.000000', 'consum', 0.0225, 'lps'),
	(466898, 123, '2015-04-01 00:23:01.000000', 'consum', 0.0216, 'lps'),
	(466899, 123, '2015-04-01 00:23:02.000000', 'consum', 0.0224, 'lps'),
	(466900, 123, '2015-04-01 00:23:03.000000', 'consum', 0.0234, 'lps'),
	(466901, 123, '2015-04-01 00:23:04.000000', 'consum', 0.0232, 'lps'),
	(466902, 123, '2015-04-01 00:23:05.000000', 'consum', 0.0222, 'lps'),
	(466903, 123, '2015-04-01 00:23:06.000000', 'consum', 0.0234, 'lps'),
	(466904, 123, '2015-04-01 00:23:07.000000', 'consum', 0.0236, 'lps'),
	(466905, 123, '2015-04-01 00:23:08.000000', 'consum', 0.0211, 'lps'),
	(466906, 123, '2015-04-01 00:23:09.000000', 'consum', 0.0224, 'lps'),
	(466907, 123, '2015-04-01 00:23:10.000000', 'consum', 0.0222, 'lps'),
	(466908, 123, '2015-04-01 00:23:11.000000', 'consum', 0.0226, 'lps'),
	(466909, 123, '2015-04-01 00:23:12.000000', 'consum', 0.0227, 'lps'),
	(466910, 123, '2015-04-01 00:23:13.000000', 'consum', 0.0222, 'lps'),
	(466911, 123, '2015-04-01 00:23:14.000000', 'consum', 0.0216, 'lps'),
	(466912, 123, '2015-04-01 00:23:15.000000', 'consum', 0.0235, 'lps'),
	(466913, 123, '2015-04-01 00:23:16.000000', 'consum', 0.0231, 'lps'),
	(466914, 123, '2015-04-01 00:23:17.000000', 'consum', 0.0215, 'lps'),
	(466915, 123, '2015-04-01 00:23:18.000000', 'consum', 0.0229, 'lps'),
	(466916, 123, '2015-04-01 00:23:19.000000', 'consum', 0.0236, 'lps'),
	(466917, 123, '2015-04-01 00:23:20.000000', 'consum', 0.0224, 'lps'),
	(466918, 123, '2015-04-01 00:23:21.000000', 'consum', 0.0233, 'lps'),
	(466919, 123, '2015-04-01 00:23:22.000000', 'consum', 0.0227, 'lps'),
	(466920, 123, '2015-04-01 00:23:23.000000', 'consum', 0.0225, 'lps'),
	(466921, 123, '2015-04-01 00:23:24.000000', 'consum', 0.0236, 'lps'),
	(466922, 123, '2015-04-01 00:23:25.000000', 'consum', 0.0212, 'lps'),
	(466923, 123, '2015-04-01 00:23:26.000000', 'consum', 0.0227, 'lps'),
	(466924, 123, '2015-04-01 00:23:27.000000', 'consum', 0.0233, 'lps'),
	(466925, 123, '2015-04-01 00:23:28.000000', 'consum', 0.0220, 'lps'),
	(466926, 123, '2015-04-01 00:23:29.000000', 'consum', 0.0220, 'lps'),
	(466927, 123, '2015-04-01 00:23:30.000000', 'consum', 0.0227, 'lps'),
	(466928, 123, '2015-04-01 00:23:31.000000', 'consum', 0.0212, 'lps'),
	(466929, 123, '2015-04-01 00:23:32.000000', 'consum', 0.0226, 'lps'),
	(466930, 123, '2015-04-01 00:23:33.000000', 'consum', 0.0228, 'lps'),
	(466931, 123, '2015-04-01 00:23:34.000000', 'consum', 0.0226, 'lps'),
	(466932, 123, '2015-04-01 00:23:35.000000', 'consum', 0.0233, 'lps'),
	(466933, 123, '2015-04-01 00:23:36.000000', 'consum', 0.0224, 'lps'),
	(466934, 123, '2015-04-01 00:23:37.000000', 'consum', 0.0211, 'lps'),
	(466935, 123, '2015-04-01 00:23:38.000000', 'consum', 0.0228, 'lps'),
	(466936, 123, '2015-04-01 00:23:39.000000', 'consum', 0.0213, 'lps'),
	(466937, 123, '2015-04-01 00:23:40.000000', 'consum', 0.0226, 'lps'),
	(466938, 123, '2015-04-01 00:23:41.000000', 'consum', 0.0229, 'lps'),
	(466939, 123, '2015-04-01 00:23:42.000000', 'consum', 0.0230, 'lps'),
	(466940, 123, '2015-04-01 00:23:43.000000', 'consum', 0.0222, 'lps'),
	(466941, 123, '2015-04-01 00:23:44.000000', 'consum', 0.0214, 'lps'),
	(466942, 123, '2015-04-01 00:23:45.000000', 'consum', 0.0219, 'lps'),
	(466943, 123, '2015-04-01 00:23:46.000000', 'consum', 0.0218, 'lps'),
	(466944, 123, '2015-04-01 00:23:47.000000', 'consum', 0.0223, 'lps'),
	(466945, 123, '2015-04-01 00:23:48.000000', 'consum', 0.0222, 'lps'),
	(466946, 123, '2015-04-01 00:23:49.000000', 'consum', 0.0232, 'lps'),
	(466947, 123, '2015-04-01 00:23:50.000000', 'consum', 0.0228, 'lps'),
	(466948, 123, '2015-04-01 00:23:51.000000', 'consum', 0.0234, 'lps'),
	(466949, 123, '2015-04-01 00:23:52.000000', 'consum', 0.0223, 'lps'),
	(466950, 123, '2015-04-01 00:23:53.000000', 'consum', 0.0231, 'lps'),
	(466951, 123, '2015-04-01 00:23:54.000000', 'consum', 0.0218, 'lps'),
	(466952, 123, '2015-04-01 00:23:55.000000', 'consum', 0.0216, 'lps'),
	(466953, 123, '2015-04-01 00:23:56.000000', 'consum', 0.0218, 'lps'),
	(466954, 123, '2015-04-01 00:23:57.000000', 'consum', 0.0233, 'lps'),
	(466955, 123, '2015-04-01 00:23:58.000000', 'consum', 0.0216, 'lps'),
	(466956, 123, '2015-04-01 00:23:59.000000', 'consum', 0.0228, 'lps'),
	(466957, 123, '2015-04-01 00:24:00.000000', 'consum', 0.0226, 'lps'),
	(466958, 123, '2015-04-01 00:24:01.000000', 'consum', 0.0237, 'lps'),
	(466959, 123, '2015-04-01 00:24:02.000000', 'consum', 0.0212, 'lps'),
	(466960, 123, '2015-04-01 00:24:03.000000', 'consum', 0.0223, 'lps'),
	(466961, 123, '2015-04-01 00:24:04.000000', 'consum', 0.0213, 'lps'),
	(466962, 123, '2015-04-01 00:24:05.000000', 'consum', 0.0217, 'lps'),
	(466963, 123, '2015-04-01 00:24:06.000000', 'consum', 0.0235, 'lps'),
	(466964, 123, '2015-04-01 00:24:07.000000', 'consum', 0.0233, 'lps'),
	(466965, 123, '2015-04-01 00:24:08.000000', 'consum', 0.0220, 'lps'),
	(466966, 123, '2015-04-01 00:24:09.000000', 'consum', 0.0222, 'lps'),
	(466967, 123, '2015-04-01 00:24:10.000000', 'consum', 0.0237, 'lps'),
	(466968, 123, '2015-04-01 00:24:11.000000', 'consum', 0.0229, 'lps'),
	(466969, 123, '2015-04-01 00:24:12.000000', 'consum', 0.0223, 'lps'),
	(466970, 123, '2015-04-01 00:24:13.000000', 'consum', 0.0217, 'lps'),
	(466971, 123, '2015-04-01 00:24:14.000000', 'consum', 0.0234, 'lps'),
	(466972, 123, '2015-04-01 00:24:15.000000', 'consum', 0.0227, 'lps'),
	(466973, 123, '2015-04-01 00:24:16.000000', 'consum', 0.0225, 'lps'),
	(466974, 123, '2015-04-01 00:24:17.000000', 'consum', 0.0233, 'lps'),
	(466975, 123, '2015-04-01 00:24:18.000000', 'consum', 0.0225, 'lps'),
	(466976, 123, '2015-04-01 00:24:19.000000', 'consum', 0.0215, 'lps'),
	(466977, 123, '2015-04-01 00:24:20.000000', 'consum', 0.0217, 'lps'),
	(466978, 123, '2015-04-01 00:24:21.000000', 'consum', 0.0234, 'lps'),
	(466979, 123, '2015-04-01 00:24:22.000000', 'consum', 0.0223, 'lps'),
	(466980, 123, '2015-04-01 00:24:23.000000', 'consum', 0.0234, 'lps'),
	(466981, 123, '2015-04-01 00:24:24.000000', 'consum', 0.0232, 'lps'),
	(466982, 123, '2015-04-01 00:24:25.000000', 'consum', 0.0223, 'lps'),
	(466983, 123, '2015-04-01 00:24:26.000000', 'consum', 0.0237, 'lps'),
	(466984, 123, '2015-04-01 00:24:27.000000', 'consum', 0.0223, 'lps'),
	(466985, 123, '2015-04-01 00:24:28.000000', 'consum', 0.0220, 'lps'),
	(466986, 123, '2015-04-01 00:24:29.000000', 'consum', 0.0225, 'lps'),
	(466987, 123, '2015-04-01 00:24:30.000000', 'consum', 0.0225, 'lps'),
	(466988, 123, '2015-04-01 00:24:31.000000', 'consum', 0.0212, 'lps'),
	(466989, 123, '2015-04-01 00:24:32.000000', 'consum', 0.0235, 'lps'),
	(466990, 123, '2015-04-01 00:24:33.000000', 'consum', 0.0214, 'lps'),
	(466991, 123, '2015-04-01 00:24:34.000000', 'consum', 0.0211, 'lps'),
	(466992, 123, '2015-04-01 00:24:35.000000', 'consum', 0.0231, 'lps'),
	(466993, 123, '2015-04-01 00:24:36.000000', 'consum', 0.0230, 'lps'),
	(466994, 123, '2015-04-01 00:24:37.000000', 'consum', 0.0218, 'lps'),
	(466995, 123, '2015-04-01 00:24:38.000000', 'consum', 0.0219, 'lps'),
	(466996, 123, '2015-04-01 00:24:39.000000', 'consum', 0.0233, 'lps'),
	(466997, 123, '2015-04-01 00:24:40.000000', 'consum', 0.0214, 'lps'),
	(466998, 123, '2015-04-01 00:24:41.000000', 'consum', 0.0218, 'lps'),
	(466999, 123, '2015-04-01 00:24:42.000000', 'consum', 0.0237, 'lps'),
	(467000, 123, '2015-04-01 00:24:43.000000', 'consum', 0.0211, 'lps'),
	(467001, 123, '2015-04-01 00:24:44.000000', 'consum', 0.0218, 'lps'),
	(467002, 123, '2015-04-01 00:24:45.000000', 'consum', 0.0220, 'lps'),
	(467003, 123, '2015-04-01 00:24:46.000000', 'consum', 0.0235, 'lps'),
	(467004, 123, '2015-04-01 00:24:47.000000', 'consum', 0.0222, 'lps'),
	(467005, 123, '2015-04-01 00:24:48.000000', 'consum', 0.0224, 'lps'),
	(467006, 123, '2015-04-01 00:24:49.000000', 'consum', 0.0216, 'lps'),
	(467007, 123, '2015-04-01 00:24:50.000000', 'consum', 0.0225, 'lps'),
	(467008, 123, '2015-04-01 00:24:51.000000', 'consum', 0.0215, 'lps'),
	(467009, 123, '2015-04-01 00:24:52.000000', 'consum', 0.0215, 'lps'),
	(467010, 123, '2015-04-01 00:24:53.000000', 'consum', 0.0222, 'lps'),
	(467011, 123, '2015-04-01 00:24:54.000000', 'consum', 0.0229, 'lps'),
	(467012, 123, '2015-04-01 00:24:55.000000', 'consum', 0.0213, 'lps'),
	(467013, 123, '2015-04-01 00:24:56.000000', 'consum', 0.0222, 'lps'),
	(467014, 123, '2015-04-01 00:24:57.000000', 'consum', 0.0236, 'lps'),
	(467015, 123, '2015-04-01 00:24:58.000000', 'consum', 0.0221, 'lps'),
	(467016, 123, '2015-04-01 00:24:59.000000', 'consum', 0.0213, 'lps'),
	(467017, 123, '2015-04-01 00:25:00.000000', 'consum', 0.0220, 'lps'),
	(467018, 123, '2015-04-01 00:25:01.000000', 'consum', 0.0227, 'lps'),
	(467019, 123, '2015-04-01 00:25:02.000000', 'consum', 0.0235, 'lps'),
	(467020, 123, '2015-04-01 00:25:03.000000', 'consum', 0.0227, 'lps'),
	(467021, 123, '2015-04-01 00:25:04.000000', 'consum', 0.0222, 'lps'),
	(467022, 123, '2015-04-01 00:25:05.000000', 'consum', 0.0220, 'lps'),
	(467023, 123, '2015-04-01 00:25:06.000000', 'consum', 0.0226, 'lps'),
	(467024, 123, '2015-04-01 00:25:07.000000', 'consum', 0.0232, 'lps'),
	(467025, 123, '2015-04-01 00:25:08.000000', 'consum', 0.0217, 'lps'),
	(467026, 123, '2015-04-01 00:25:09.000000', 'consum', 0.0237, 'lps'),
	(467027, 123, '2015-04-01 00:25:10.000000', 'consum', 0.0237, 'lps'),
	(467028, 123, '2015-04-01 00:25:11.000000', 'consum', 0.0237, 'lps'),
	(467029, 123, '2015-04-01 00:25:12.000000', 'consum', 0.0237, 'lps'),
	(467030, 123, '2015-04-01 00:25:13.000000', 'consum', 0.0237, 'lps'),
	(467031, 123, '2015-04-01 00:25:14.000000', 'consum', 0.0236, 'lps'),
	(467032, 123, '2015-04-01 00:25:15.000000', 'consum', 0.0230, 'lps'),
	(467033, 123, '2015-04-01 00:25:16.000000', 'consum', 0.0233, 'lps'),
	(467034, 123, '2015-04-01 00:25:17.000000', 'consum', 0.0211, 'lps'),
	(467035, 123, '2015-04-01 00:25:18.000000', 'consum', 0.0230, 'lps'),
	(467036, 123, '2015-04-01 00:25:19.000000', 'consum', 0.0222, 'lps'),
	(467037, 123, '2015-04-01 00:25:20.000000', 'consum', 0.0213, 'lps'),
	(467038, 123, '2015-04-01 00:25:21.000000', 'consum', 0.0216, 'lps'),
	(467039, 123, '2015-04-01 00:25:22.000000', 'consum', 0.0233, 'lps'),
	(467040, 123, '2015-04-01 00:25:23.000000', 'consum', 0.0222, 'lps'),
	(467041, 123, '2015-04-01 00:25:24.000000', 'consum', 0.0228, 'lps'),
	(467042, 123, '2015-04-01 00:25:25.000000', 'consum', 0.0212, 'lps'),
	(467043, 123, '2015-04-01 00:25:26.000000', 'consum', 0.0219, 'lps'),
	(467044, 123, '2015-04-01 00:25:27.000000', 'consum', 0.0224, 'lps'),
	(467045, 123, '2015-04-01 00:25:28.000000', 'consum', 0.0224, 'lps'),
	(467046, 123, '2015-04-01 00:25:29.000000', 'consum', 0.0212, 'lps'),
	(467047, 123, '2015-04-01 00:25:30.000000', 'consum', 0.0235, 'lps'),
	(467048, 123, '2015-04-01 00:25:31.000000', 'consum', 0.0216, 'lps'),
	(467049, 123, '2015-04-01 00:25:32.000000', 'consum', 0.0221, 'lps'),
	(467050, 123, '2015-04-01 00:25:33.000000', 'consum', 0.0220, 'lps'),
	(467051, 123, '2015-04-01 00:25:34.000000', 'consum', 0.0230, 'lps'),
	(467052, 123, '2015-04-01 00:25:35.000000', 'consum', 0.0221, 'lps'),
	(467053, 123, '2015-04-01 00:25:36.000000', 'consum', 0.0234, 'lps'),
	(467054, 123, '2015-04-01 00:25:37.000000', 'consum', 0.0216, 'lps'),
	(467055, 123, '2015-04-01 00:25:38.000000', 'consum', 0.0222, 'lps'),
	(467056, 123, '2015-04-01 00:25:39.000000', 'consum', 0.0224, 'lps'),
	(467057, 123, '2015-04-01 00:25:40.000000', 'consum', 0.0216, 'lps'),
	(467058, 123, '2015-04-01 00:25:41.000000', 'consum', 0.0228, 'lps'),
	(467059, 123, '2015-04-01 00:25:42.000000', 'consum', 0.0226, 'lps'),
	(467060, 123, '2015-04-01 00:25:43.000000', 'consum', 0.0236, 'lps'),
	(467061, 123, '2015-04-01 00:25:44.000000', 'consum', 0.0237, 'lps'),
	(467062, 123, '2015-04-01 00:25:45.000000', 'consum', 0.0213, 'lps'),
	(467063, 123, '2015-04-01 00:25:46.000000', 'consum', 0.0227, 'lps'),
	(467064, 123, '2015-04-01 00:25:47.000000', 'consum', 0.0229, 'lps'),
	(467065, 123, '2015-04-01 00:25:48.000000', 'consum', 0.0229, 'lps'),
	(467066, 123, '2015-04-01 00:25:49.000000', 'consum', 0.0219, 'lps'),
	(467067, 123, '2015-04-01 00:25:50.000000', 'consum', 0.0227, 'lps'),
	(467068, 123, '2015-04-01 00:25:51.000000', 'consum', 0.0213, 'lps'),
	(467069, 123, '2015-04-01 00:25:52.000000', 'consum', 0.0231, 'lps'),
	(467070, 123, '2015-04-01 00:25:53.000000', 'consum', 0.0220, 'lps'),
	(467071, 123, '2015-04-01 00:25:54.000000', 'consum', 0.0229, 'lps'),
	(467072, 123, '2015-04-01 00:25:55.000000', 'consum', 0.0216, 'lps'),
	(467073, 123, '2015-04-01 00:25:56.000000', 'consum', 0.0213, 'lps'),
	(467074, 123, '2015-04-01 00:25:57.000000', 'consum', 0.0236, 'lps'),
	(467075, 123, '2015-04-01 00:25:58.000000', 'consum', 0.0217, 'lps'),
	(467076, 123, '2015-04-01 00:25:59.000000', 'consum', 0.0226, 'lps'),
	(467077, 123, '2015-04-01 00:26:00.000000', 'consum', 0.0215, 'lps'),
	(467078, 123, '2015-04-01 00:26:01.000000', 'consum', 0.0213, 'lps'),
	(467079, 123, '2015-04-01 00:26:02.000000', 'consum', 0.0213, 'lps'),
	(467080, 123, '2015-04-01 00:26:03.000000', 'consum', 0.0215, 'lps'),
	(467081, 123, '2015-04-01 00:26:04.000000', 'consum', 0.0227, 'lps'),
	(467082, 123, '2015-04-01 00:26:05.000000', 'consum', 0.0222, 'lps'),
	(467083, 123, '2015-04-01 00:26:06.000000', 'consum', 0.0223, 'lps'),
	(467084, 123, '2015-04-01 00:26:07.000000', 'consum', 0.0210, 'lps'),
	(467085, 123, '2015-04-01 00:26:08.000000', 'consum', 0.0226, 'lps'),
	(467086, 123, '2015-04-01 00:26:09.000000', 'consum', 0.0234, 'lps'),
	(467087, 123, '2015-04-01 00:26:10.000000', 'consum', 0.0229, 'lps'),
	(467088, 123, '2015-04-01 00:26:11.000000', 'consum', 0.0231, 'lps'),
	(467089, 123, '2015-04-01 00:26:12.000000', 'consum', 0.0231, 'lps'),
	(467090, 123, '2015-04-01 00:26:13.000000', 'consum', 0.0226, 'lps'),
	(467091, 123, '2015-04-01 00:26:14.000000', 'consum', 0.0227, 'lps'),
	(467092, 123, '2015-04-01 00:26:15.000000', 'consum', 0.0219, 'lps'),
	(467093, 123, '2015-04-01 00:26:16.000000', 'consum', 0.0234, 'lps'),
	(467094, 123, '2015-04-01 00:26:17.000000', 'consum', 0.0220, 'lps'),
	(467095, 123, '2015-04-01 00:26:18.000000', 'consum', 0.0216, 'lps'),
	(467096, 123, '2015-04-01 00:26:19.000000', 'consum', 0.0212, 'lps'),
	(467097, 123, '2015-04-01 00:26:20.000000', 'consum', 0.0227, 'lps'),
	(467098, 123, '2015-04-01 00:26:21.000000', 'consum', 0.0237, 'lps'),
	(467099, 123, '2015-04-01 00:26:22.000000', 'consum', 0.0235, 'lps'),
	(467100, 123, '2015-04-01 00:26:23.000000', 'consum', 0.0228, 'lps'),
	(467101, 123, '2015-04-01 00:26:24.000000', 'consum', 0.0226, 'lps'),
	(467102, 123, '2015-04-01 00:26:25.000000', 'consum', 0.0236, 'lps'),
	(467103, 123, '2015-04-01 00:26:26.000000', 'consum', 0.0235, 'lps'),
	(467104, 123, '2015-04-01 00:26:27.000000', 'consum', 0.0231, 'lps'),
	(467105, 123, '2015-04-01 00:26:28.000000', 'consum', 0.0212, 'lps'),
	(467106, 123, '2015-04-01 00:26:29.000000', 'consum', 0.0213, 'lps'),
	(467107, 123, '2015-04-01 00:26:30.000000', 'consum', 0.0218, 'lps'),
	(467108, 123, '2015-04-01 00:26:31.000000', 'consum', 0.0214, 'lps'),
	(467109, 123, '2015-04-01 00:26:32.000000', 'consum', 0.0235, 'lps'),
	(467110, 123, '2015-04-01 00:26:33.000000', 'consum', 0.0214, 'lps'),
	(467111, 123, '2015-04-01 00:26:34.000000', 'consum', 0.0236, 'lps'),
	(467112, 123, '2015-04-01 00:26:35.000000', 'consum', 0.0217, 'lps'),
	(467113, 123, '2015-04-01 00:26:36.000000', 'consum', 0.0222, 'lps'),
	(467114, 123, '2015-04-01 00:26:37.000000', 'consum', 0.0224, 'lps'),
	(467115, 123, '2015-04-01 00:26:38.000000', 'consum', 0.0214, 'lps'),
	(467116, 123, '2015-04-01 00:26:39.000000', 'consum', 0.0220, 'lps'),
	(467117, 123, '2015-04-01 00:26:40.000000', 'consum', 0.0217, 'lps'),
	(467118, 123, '2015-04-01 00:26:41.000000', 'consum', 0.0219, 'lps'),
	(467119, 123, '2015-04-01 00:26:42.000000', 'consum', 0.0231, 'lps'),
	(467120, 123, '2015-04-01 00:26:43.000000', 'consum', 0.0234, 'lps'),
	(467121, 123, '2015-04-01 00:26:44.000000', 'consum', 0.0213, 'lps'),
	(467122, 123, '2015-04-01 00:26:45.000000', 'consum', 0.0235, 'lps'),
	(467123, 123, '2015-04-01 00:26:46.000000', 'consum', 0.0217, 'lps'),
	(467124, 123, '2015-04-01 00:26:47.000000', 'consum', 0.0226, 'lps'),
	(467125, 123, '2015-04-01 00:26:48.000000', 'consum', 0.0212, 'lps'),
	(467126, 123, '2015-04-01 00:26:49.000000', 'consum', 0.0228, 'lps'),
	(467127, 123, '2015-04-01 00:26:50.000000', 'consum', 0.0212, 'lps'),
	(467128, 123, '2015-04-01 00:26:51.000000', 'consum', 0.0220, 'lps'),
	(467129, 123, '2015-04-01 00:26:52.000000', 'consum', 0.0228, 'lps'),
	(467130, 123, '2015-04-01 00:26:53.000000', 'consum', 0.0216, 'lps'),
	(467131, 123, '2015-04-01 00:26:54.000000', 'consum', 0.0213, 'lps'),
	(467132, 123, '2015-04-01 00:26:55.000000', 'consum', 0.0237, 'lps'),
	(467133, 123, '2015-04-01 00:26:56.000000', 'consum', 0.0222, 'lps'),
	(467134, 123, '2015-04-01 00:26:57.000000', 'consum', 0.0219, 'lps'),
	(467135, 123, '2015-04-01 00:26:58.000000', 'consum', 0.0217, 'lps'),
	(467136, 123, '2015-04-01 00:26:59.000000', 'consum', 0.0222, 'lps'),
	(467137, 123, '2015-04-01 00:27:00.000000', 'consum', 0.0218, 'lps'),
	(467138, 123, '2015-04-01 00:27:01.000000', 'consum', 0.0217, 'lps'),
	(467139, 123, '2015-04-01 00:27:02.000000', 'consum', 0.0220, 'lps'),
	(467140, 123, '2015-04-01 00:27:03.000000', 'consum', 0.0212, 'lps'),
	(467141, 123, '2015-04-01 00:27:04.000000', 'consum', 0.0217, 'lps'),
	(467142, 123, '2015-04-01 00:27:05.000000', 'consum', 0.0211, 'lps'),
	(467143, 123, '2015-04-01 00:27:06.000000', 'consum', 0.0223, 'lps'),
	(467144, 123, '2015-04-01 00:27:07.000000', 'consum', 0.0215, 'lps'),
	(467145, 123, '2015-04-01 00:27:08.000000', 'consum', 0.0227, 'lps'),
	(467146, 123, '2015-04-01 00:27:09.000000', 'consum', 0.0222, 'lps'),
	(467147, 123, '2015-04-01 00:27:10.000000', 'consum', 0.0219, 'lps'),
	(467148, 123, '2015-04-01 00:27:11.000000', 'consum', 0.0222, 'lps'),
	(467149, 123, '2015-04-01 00:27:12.000000', 'consum', 0.0215, 'lps'),
	(467150, 123, '2015-04-01 00:27:13.000000', 'consum', 0.0226, 'lps'),
	(467151, 123, '2015-04-01 00:27:14.000000', 'consum', 0.0219, 'lps'),
	(467152, 123, '2015-04-01 00:27:15.000000', 'consum', 0.0237, 'lps'),
	(467153, 123, '2015-04-01 00:27:16.000000', 'consum', 0.0233, 'lps'),
	(467154, 123, '2015-04-01 00:27:17.000000', 'consum', 0.0217, 'lps'),
	(467155, 123, '2015-04-01 00:27:18.000000', 'consum', 0.0234, 'lps'),
	(467156, 123, '2015-04-01 00:27:19.000000', 'consum', 0.0226, 'lps'),
	(467157, 123, '2015-04-01 00:27:20.000000', 'consum', 0.0218, 'lps'),
	(467158, 123, '2015-04-01 00:27:21.000000', 'consum', 0.0231, 'lps'),
	(467159, 123, '2015-04-01 00:27:22.000000', 'consum', 0.0237, 'lps'),
	(467160, 123, '2015-04-01 00:27:23.000000', 'consum', 0.0225, 'lps'),
	(467161, 123, '2015-04-01 00:27:24.000000', 'consum', 0.0233, 'lps'),
	(467162, 123, '2015-04-01 00:27:25.000000', 'consum', 0.0222, 'lps'),
	(467163, 123, '2015-04-01 00:27:26.000000', 'consum', 0.0233, 'lps'),
	(467164, 123, '2015-04-01 00:27:27.000000', 'consum', 0.0230, 'lps'),
	(467165, 123, '2015-04-01 00:27:28.000000', 'consum', 0.0216, 'lps'),
	(467166, 123, '2015-04-01 00:27:29.000000', 'consum', 0.0235, 'lps'),
	(467167, 123, '2015-04-01 00:27:30.000000', 'consum', 0.0235, 'lps'),
	(467168, 123, '2015-04-01 00:27:31.000000', 'consum', 0.0231, 'lps'),
	(467169, 123, '2015-04-01 00:27:32.000000', 'consum', 0.0213, 'lps'),
	(467170, 123, '2015-04-01 00:27:33.000000', 'consum', 0.0220, 'lps'),
	(467171, 123, '2015-04-01 00:27:34.000000', 'consum', 0.0224, 'lps'),
	(467172, 123, '2015-04-01 00:27:35.000000', 'consum', 0.0222, 'lps'),
	(467173, 123, '2015-04-01 00:27:36.000000', 'consum', 0.0230, 'lps'),
	(467174, 123, '2015-04-01 00:27:37.000000', 'consum', 0.0215, 'lps'),
	(467175, 123, '2015-04-01 00:27:38.000000', 'consum', 0.0235, 'lps'),
	(467176, 123, '2015-04-01 00:27:39.000000', 'consum', 0.0236, 'lps'),
	(467177, 123, '2015-04-01 00:27:40.000000', 'consum', 0.0235, 'lps'),
	(467178, 123, '2015-04-01 00:27:41.000000', 'consum', 0.0232, 'lps'),
	(467179, 123, '2015-04-01 00:27:42.000000', 'consum', 0.0217, 'lps'),
	(467180, 123, '2015-04-01 00:27:43.000000', 'consum', 0.0234, 'lps'),
	(467181, 123, '2015-04-01 00:27:44.000000', 'consum', 0.0226, 'lps'),
	(467182, 123, '2015-04-01 00:27:45.000000', 'consum', 0.0217, 'lps'),
	(467183, 123, '2015-04-01 00:27:46.000000', 'consum', 0.0227, 'lps'),
	(467184, 123, '2015-04-01 00:27:47.000000', 'consum', 0.0220, 'lps'),
	(467185, 123, '2015-04-01 00:27:48.000000', 'consum', 0.0210, 'lps'),
	(467186, 123, '2015-04-01 00:27:49.000000', 'consum', 0.0234, 'lps'),
	(467187, 123, '2015-04-01 00:27:50.000000', 'consum', 0.0218, 'lps'),
	(467188, 123, '2015-04-01 00:27:51.000000', 'consum', 0.0237, 'lps'),
	(467189, 123, '2015-04-01 00:27:52.000000', 'consum', 0.0235, 'lps'),
	(467190, 123, '2015-04-01 00:27:53.000000', 'consum', 0.0228, 'lps'),
	(467191, 123, '2015-04-01 00:27:54.000000', 'consum', 0.0226, 'lps'),
	(467192, 123, '2015-04-01 00:27:55.000000', 'consum', 0.0237, 'lps'),
	(467193, 123, '2015-04-01 00:27:56.000000', 'consum', 0.0215, 'lps'),
	(467194, 123, '2015-04-01 00:27:57.000000', 'consum', 0.0235, 'lps'),
	(467195, 123, '2015-04-01 00:27:58.000000', 'consum', 0.0237, 'lps'),
	(467196, 123, '2015-04-01 00:27:59.000000', 'consum', 0.0216, 'lps'),
	(467197, 123, '2015-04-01 00:28:00.000000', 'consum', 0.0216, 'lps'),
	(467198, 123, '2015-04-01 00:28:01.000000', 'consum', 0.0223, 'lps'),
	(467199, 123, '2015-04-01 00:28:02.000000', 'consum', 0.0230, 'lps'),
	(467200, 123, '2015-04-01 00:28:03.000000', 'consum', 0.0214, 'lps'),
	(467201, 123, '2015-04-01 00:28:04.000000', 'consum', 0.0227, 'lps'),
	(467202, 123, '2015-04-01 00:28:05.000000', 'consum', 0.0229, 'lps'),
	(467203, 123, '2015-04-01 00:28:06.000000', 'consum', 0.0225, 'lps'),
	(467204, 123, '2015-04-01 00:28:07.000000', 'consum', 0.0229, 'lps'),
	(467205, 123, '2015-04-01 00:28:08.000000', 'consum', 0.0234, 'lps'),
	(467206, 123, '2015-04-01 00:28:09.000000', 'consum', 0.0215, 'lps'),
	(467207, 123, '2015-04-01 00:28:10.000000', 'consum', 0.0222, 'lps'),
	(467208, 123, '2015-04-01 00:28:11.000000', 'consum', 0.0225, 'lps'),
	(467209, 123, '2015-04-01 00:28:12.000000', 'consum', 0.0221, 'lps'),
	(467210, 123, '2015-04-01 00:28:13.000000', 'consum', 0.0220, 'lps'),
	(467211, 123, '2015-04-01 00:28:14.000000', 'consum', 0.0227, 'lps'),
	(467212, 123, '2015-04-01 00:28:15.000000', 'consum', 0.0212, 'lps'),
	(467213, 123, '2015-04-01 00:28:16.000000', 'consum', 0.0226, 'lps'),
	(467214, 123, '2015-04-01 00:28:17.000000', 'consum', 0.0227, 'lps'),
	(467215, 123, '2015-04-01 00:28:18.000000', 'consum', 0.0220, 'lps'),
	(467216, 123, '2015-04-01 00:28:19.000000', 'consum', 0.0236, 'lps'),
	(467217, 123, '2015-04-01 00:28:20.000000', 'consum', 0.0226, 'lps'),
	(467218, 123, '2015-04-01 00:28:21.000000', 'consum', 0.0215, 'lps'),
	(467219, 123, '2015-04-01 00:28:22.000000', 'consum', 0.0214, 'lps'),
	(467220, 123, '2015-04-01 00:28:23.000000', 'consum', 0.0217, 'lps'),
	(467221, 123, '2015-04-01 00:28:24.000000', 'consum', 0.0233, 'lps'),
	(467222, 123, '2015-04-01 00:28:25.000000', 'consum', 0.0221, 'lps'),
	(467223, 123, '2015-04-01 00:28:26.000000', 'consum', 0.0223, 'lps'),
	(467224, 123, '2015-04-01 00:28:27.000000', 'consum', 0.0216, 'lps'),
	(467225, 123, '2015-04-01 00:28:28.000000', 'consum', 0.0231, 'lps'),
	(467226, 123, '2015-04-01 00:28:29.000000', 'consum', 0.0211, 'lps'),
	(467227, 123, '2015-04-01 00:28:30.000000', 'consum', 0.0237, 'lps'),
	(467228, 123, '2015-04-01 00:28:31.000000', 'consum', 0.0229, 'lps'),
	(467229, 123, '2015-04-01 00:28:32.000000', 'consum', 0.0227, 'lps'),
	(467230, 123, '2015-04-01 00:28:33.000000', 'consum', 0.0237, 'lps'),
	(467231, 123, '2015-04-01 00:28:34.000000', 'consum', 0.0210, 'lps'),
	(467232, 123, '2015-04-01 00:28:35.000000', 'consum', 0.0216, 'lps'),
	(467233, 123, '2015-04-01 00:28:36.000000', 'consum', 0.0211, 'lps'),
	(467234, 123, '2015-04-01 00:28:37.000000', 'consum', 0.0227, 'lps'),
	(467235, 123, '2015-04-01 00:28:38.000000', 'consum', 0.0234, 'lps'),
	(467236, 123, '2015-04-01 00:28:39.000000', 'consum', 0.0223, 'lps'),
	(467237, 123, '2015-04-01 00:28:40.000000', 'consum', 0.0233, 'lps'),
	(467238, 123, '2015-04-01 00:28:41.000000', 'consum', 0.0231, 'lps'),
	(467239, 123, '2015-04-01 00:28:42.000000', 'consum', 0.0218, 'lps'),
	(467240, 123, '2015-04-01 00:28:43.000000', 'consum', 0.0217, 'lps'),
	(467241, 123, '2015-04-01 00:28:44.000000', 'consum', 0.0220, 'lps'),
	(467242, 123, '2015-04-01 00:28:45.000000', 'consum', 0.0211, 'lps'),
	(467243, 123, '2015-04-01 00:28:46.000000', 'consum', 0.0216, 'lps'),
	(467244, 123, '2015-04-01 00:28:47.000000', 'consum', 0.0236, 'lps'),
	(467245, 123, '2015-04-01 00:28:48.000000', 'consum', 0.0210, 'lps'),
	(467246, 123, '2015-04-01 00:28:49.000000', 'consum', 0.0217, 'lps'),
	(467247, 123, '2015-04-01 00:28:50.000000', 'consum', 0.0216, 'lps'),
	(467248, 123, '2015-04-01 00:28:51.000000', 'consum', 0.0219, 'lps'),
	(467249, 123, '2015-04-01 00:28:52.000000', 'consum', 0.0212, 'lps'),
	(467250, 123, '2015-04-01 00:28:53.000000', 'consum', 0.0221, 'lps'),
	(467251, 123, '2015-04-01 00:28:54.000000', 'consum', 0.0230, 'lps'),
	(467252, 123, '2015-04-01 00:28:55.000000', 'consum', 0.0222, 'lps'),
	(467253, 123, '2015-04-01 00:28:56.000000', 'consum', 0.0210, 'lps'),
	(467254, 123, '2015-04-01 00:28:57.000000', 'consum', 0.0232, 'lps'),
	(467255, 123, '2015-04-01 00:28:58.000000', 'consum', 0.0237, 'lps'),
	(467256, 123, '2015-04-01 00:28:59.000000', 'consum', 0.0221, 'lps'),
	(467257, 123, '2015-04-01 00:29:00.000000', 'consum', 0.0215, 'lps'),
	(467258, 123, '2015-04-01 00:29:01.000000', 'consum', 0.0231, 'lps'),
	(467259, 123, '2015-04-01 00:29:02.000000', 'consum', 0.0217, 'lps'),
	(467260, 123, '2015-04-01 00:29:03.000000', 'consum', 0.0211, 'lps'),
	(467261, 123, '2015-04-01 00:29:04.000000', 'consum', 0.0222, 'lps'),
	(467262, 123, '2015-04-01 00:29:05.000000', 'consum', 0.0212, 'lps'),
	(467263, 123, '2015-04-01 00:29:06.000000', 'consum', 0.0213, 'lps'),
	(467264, 123, '2015-04-01 00:29:07.000000', 'consum', 0.0218, 'lps'),
	(467265, 123, '2015-04-01 00:29:08.000000', 'consum', 0.0216, 'lps'),
	(467266, 123, '2015-04-01 00:29:09.000000', 'consum', 0.0214, 'lps'),
	(467267, 123, '2015-04-01 00:29:10.000000', 'consum', 0.0214, 'lps'),
	(467268, 123, '2015-04-01 00:29:11.000000', 'consum', 0.0216, 'lps'),
	(467269, 123, '2015-04-01 00:29:12.000000', 'consum', 0.0232, 'lps'),
	(467270, 123, '2015-04-01 00:29:13.000000', 'consum', 0.0216, 'lps'),
	(467271, 123, '2015-04-01 00:29:14.000000', 'consum', 0.0233, 'lps'),
	(467272, 123, '2015-04-01 00:29:15.000000', 'consum', 0.0222, 'lps'),
	(467273, 123, '2015-04-01 00:29:16.000000', 'consum', 0.0230, 'lps'),
	(467274, 123, '2015-04-01 00:29:17.000000', 'consum', 0.0220, 'lps'),
	(467275, 123, '2015-04-01 00:29:18.000000', 'consum', 0.0225, 'lps'),
	(467276, 123, '2015-04-01 00:29:19.000000', 'consum', 0.0231, 'lps'),
	(467277, 123, '2015-04-01 00:29:20.000000', 'consum', 0.0213, 'lps'),
	(467278, 123, '2015-04-01 00:29:21.000000', 'consum', 0.0221, 'lps'),
	(467279, 123, '2015-04-01 00:29:22.000000', 'consum', 0.0225, 'lps'),
	(467280, 123, '2015-04-01 00:29:23.000000', 'consum', 0.0227, 'lps'),
	(467281, 123, '2015-04-01 00:29:24.000000', 'consum', 0.0221, 'lps'),
	(467282, 123, '2015-04-01 00:29:25.000000', 'consum', 0.0216, 'lps'),
	(467283, 123, '2015-04-01 00:29:26.000000', 'consum', 0.0236, 'lps'),
	(467284, 123, '2015-04-01 00:29:27.000000', 'consum', 0.0236, 'lps'),
	(467285, 123, '2015-04-01 00:29:28.000000', 'consum', 0.0235, 'lps'),
	(467286, 123, '2015-04-01 00:29:29.000000', 'consum', 0.0229, 'lps'),
	(467287, 123, '2015-04-01 00:29:30.000000', 'consum', 0.0230, 'lps'),
	(467288, 123, '2015-04-01 00:29:31.000000', 'consum', 0.0228, 'lps'),
	(467289, 123, '2015-04-01 00:29:32.000000', 'consum', 0.0237, 'lps'),
	(467290, 123, '2015-04-01 00:29:33.000000', 'consum', 0.0211, 'lps'),
	(467291, 123, '2015-04-01 00:29:34.000000', 'consum', 0.0216, 'lps'),
	(467292, 123, '2015-04-01 00:29:35.000000', 'consum', 0.0211, 'lps'),
	(467293, 123, '2015-04-01 00:29:36.000000', 'consum', 0.0226, 'lps'),
	(467294, 123, '2015-04-01 00:29:37.000000', 'consum', 0.0229, 'lps'),
	(467295, 123, '2015-04-01 00:29:38.000000', 'consum', 0.0232, 'lps'),
	(467296, 123, '2015-04-01 00:29:39.000000', 'consum', 0.0233, 'lps'),
	(467297, 123, '2015-04-01 00:29:40.000000', 'consum', 0.0235, 'lps'),
	(467298, 123, '2015-04-01 00:29:41.000000', 'consum', 0.0235, 'lps'),
	(467299, 123, '2015-04-01 00:29:42.000000', 'consum', 0.0234, 'lps'),
	(467300, 123, '2015-04-01 00:29:43.000000', 'consum', 0.0229, 'lps'),
	(467301, 123, '2015-04-01 00:29:44.000000', 'consum', 0.0232, 'lps'),
	(467302, 123, '2015-04-01 00:29:45.000000', 'consum', 0.0236, 'lps'),
	(467303, 123, '2015-04-01 00:29:46.000000', 'consum', 0.0219, 'lps'),
	(467304, 123, '2015-04-01 00:29:47.000000', 'consum', 0.0232, 'lps'),
	(467305, 123, '2015-04-01 00:29:48.000000', 'consum', 0.0210, 'lps'),
	(467306, 123, '2015-04-01 00:29:49.000000', 'consum', 0.0227, 'lps'),
	(467307, 123, '2015-04-01 00:29:50.000000', 'consum', 0.0214, 'lps'),
	(467308, 123, '2015-04-01 00:29:51.000000', 'consum', 0.0236, 'lps'),
	(467309, 123, '2015-04-01 00:29:52.000000', 'consum', 0.0215, 'lps'),
	(467310, 123, '2015-04-01 00:29:53.000000', 'consum', 0.0215, 'lps'),
	(467311, 123, '2015-04-01 00:29:54.000000', 'consum', 0.0220, 'lps'),
	(467312, 123, '2015-04-01 00:29:55.000000', 'consum', 0.0218, 'lps'),
	(467313, 123, '2015-04-01 00:29:56.000000', 'consum', 0.0222, 'lps'),
	(467314, 123, '2015-04-01 00:29:57.000000', 'consum', 0.0217, 'lps'),
	(467315, 123, '2015-04-01 00:29:58.000000', 'consum', 0.0210, 'lps'),
	(467316, 123, '2015-04-01 00:29:59.000000', 'consum', 0.0216, 'lps'),
	(467317, 123, '2015-04-01 00:30:00.000000', 'consum', 0.0212, 'lps'),
	(467318, 123, '2015-04-01 00:30:01.000000', 'consum', 0.0232, 'lps'),
	(467319, 123, '2015-04-01 00:30:02.000000', 'consum', 0.0229, 'lps'),
	(467320, 123, '2015-04-01 00:30:03.000000', 'consum', 0.0212, 'lps'),
	(467321, 123, '2015-04-01 00:30:04.000000', 'consum', 0.0220, 'lps'),
	(467322, 123, '2015-04-01 00:30:05.000000', 'consum', 0.0224, 'lps'),
	(467323, 123, '2015-04-01 00:30:06.000000', 'consum', 0.0226, 'lps'),
	(467324, 123, '2015-04-01 00:30:07.000000', 'consum', 0.0219, 'lps'),
	(467325, 123, '2015-04-01 00:30:08.000000', 'consum', 0.0235, 'lps'),
	(467326, 123, '2015-04-01 00:30:09.000000', 'consum', 0.0226, 'lps'),
	(467327, 123, '2015-04-01 00:30:10.000000', 'consum', 0.0215, 'lps'),
	(467328, 123, '2015-04-01 00:30:11.000000', 'consum', 0.0215, 'lps'),
	(467329, 123, '2015-04-01 00:30:12.000000', 'consum', 0.0221, 'lps'),
	(467330, 123, '2015-04-01 00:30:13.000000', 'consum', 0.0224, 'lps'),
	(467331, 123, '2015-04-01 00:30:14.000000', 'consum', 0.0217, 'lps'),
	(467332, 123, '2015-04-01 00:30:15.000000', 'consum', 0.0231, 'lps'),
	(467333, 123, '2015-04-01 00:30:16.000000', 'consum', 0.0210, 'lps'),
	(467334, 123, '2015-04-01 00:30:17.000000', 'consum', 0.0234, 'lps'),
	(467335, 123, '2015-04-01 00:30:18.000000', 'consum', 0.0216, 'lps'),
	(467336, 123, '2015-04-01 00:30:19.000000', 'consum', 0.0224, 'lps'),
	(467337, 123, '2015-04-01 00:30:20.000000', 'consum', 0.0235, 'lps'),
	(467338, 123, '2015-04-01 00:30:21.000000', 'consum', 0.0237, 'lps'),
	(467339, 123, '2015-04-01 00:30:22.000000', 'consum', 0.0215, 'lps'),
	(467340, 123, '2015-04-01 00:30:23.000000', 'consum', 0.0236, 'lps'),
	(467341, 123, '2015-04-01 00:30:24.000000', 'consum', 0.0217, 'lps'),
	(467342, 123, '2015-04-01 00:30:25.000000', 'consum', 0.0224, 'lps'),
	(467343, 123, '2015-04-01 00:30:26.000000', 'consum', 0.0231, 'lps'),
	(467344, 123, '2015-04-01 00:30:27.000000', 'consum', 0.0217, 'lps'),
	(467345, 123, '2015-04-01 00:30:28.000000', 'consum', 0.0210, 'lps'),
	(467346, 123, '2015-04-01 00:30:29.000000', 'consum', 0.0217, 'lps'),
	(467347, 123, '2015-04-01 00:30:30.000000', 'consum', 0.0219, 'lps'),
	(467348, 123, '2015-04-01 00:30:31.000000', 'consum', 0.0236, 'lps'),
	(467349, 123, '2015-04-01 00:30:32.000000', 'consum', 0.0227, 'lps'),
	(467350, 123, '2015-04-01 00:30:33.000000', 'consum', 0.0217, 'lps'),
	(467351, 123, '2015-04-01 00:30:34.000000', 'consum', 0.0225, 'lps'),
	(467352, 123, '2015-04-01 00:30:35.000000', 'consum', 0.0236, 'lps'),
	(467353, 123, '2015-04-01 00:30:36.000000', 'consum', 0.0237, 'lps'),
	(467354, 123, '2015-04-01 00:30:37.000000', 'consum', 0.0214, 'lps'),
	(467355, 123, '2015-04-01 00:30:38.000000', 'consum', 0.0233, 'lps'),
	(467356, 123, '2015-04-01 00:30:39.000000', 'consum', 0.0230, 'lps'),
	(467357, 123, '2015-04-01 00:30:40.000000', 'consum', 0.0214, 'lps'),
	(467358, 123, '2015-04-01 00:30:41.000000', 'consum', 0.0226, 'lps'),
	(467359, 123, '2015-04-01 00:30:42.000000', 'consum', 0.0222, 'lps'),
	(467360, 123, '2015-04-01 00:30:43.000000', 'consum', 0.0222, 'lps'),
	(467361, 123, '2015-04-01 00:30:44.000000', 'consum', 0.0233, 'lps'),
	(467362, 123, '2015-04-01 00:30:45.000000', 'consum', 0.0237, 'lps'),
	(467363, 123, '2015-04-01 00:30:46.000000', 'consum', 0.0217, 'lps'),
	(467364, 123, '2015-04-01 00:30:47.000000', 'consum', 0.0223, 'lps'),
	(467365, 123, '2015-04-01 00:30:48.000000', 'consum', 0.0224, 'lps'),
	(467366, 123, '2015-04-01 00:30:49.000000', 'consum', 0.0216, 'lps'),
	(467367, 123, '2015-04-01 00:30:50.000000', 'consum', 0.0226, 'lps'),
	(467368, 123, '2015-04-01 00:30:51.000000', 'consum', 0.0218, 'lps'),
	(467369, 123, '2015-04-01 00:30:52.000000', 'consum', 0.0228, 'lps'),
	(467370, 123, '2015-04-01 00:30:53.000000', 'consum', 0.0221, 'lps'),
	(467371, 123, '2015-04-01 00:30:54.000000', 'consum', 0.0212, 'lps'),
	(467372, 123, '2015-04-01 00:30:55.000000', 'consum', 0.0217, 'lps'),
	(467373, 123, '2015-04-01 00:30:56.000000', 'consum', 0.0212, 'lps'),
	(467374, 123, '2015-04-01 00:30:57.000000', 'consum', 0.0226, 'lps'),
	(467375, 123, '2015-04-01 00:30:58.000000', 'consum', 0.0228, 'lps'),
	(467376, 123, '2015-04-01 00:30:59.000000', 'consum', 0.0225, 'lps'),
	(467377, 123, '2015-04-01 00:31:00.000000', 'consum', 0.0232, 'lps'),
	(467378, 123, '2015-04-01 00:31:01.000000', 'consum', 0.0221, 'lps'),
	(467379, 123, '2015-04-01 00:31:02.000000', 'consum', 0.0227, 'lps'),
	(467380, 123, '2015-04-01 00:31:03.000000', 'consum', 0.0235, 'lps'),
	(467381, 123, '2015-04-01 00:31:04.000000', 'consum', 0.0229, 'lps'),
	(467382, 123, '2015-04-01 00:31:05.000000', 'consum', 0.0229, 'lps'),
	(467383, 123, '2015-04-01 00:31:06.000000', 'consum', 0.0219, 'lps'),
	(467384, 123, '2015-04-01 00:31:07.000000', 'consum', 0.0228, 'lps'),
	(467385, 123, '2015-04-01 00:31:08.000000', 'consum', 0.0216, 'lps'),
	(467386, 123, '2015-04-01 00:31:09.000000', 'consum', 0.0216, 'lps'),
	(467387, 123, '2015-04-01 00:31:10.000000', 'consum', 0.0221, 'lps'),
	(467388, 123, '2015-04-01 00:31:11.000000', 'consum', 0.0222, 'lps'),
	(467389, 123, '2015-04-01 00:31:12.000000', 'consum', 0.0236, 'lps'),
	(467390, 123, '2015-04-01 00:31:13.000000', 'consum', 0.0223, 'lps'),
	(467391, 123, '2015-04-01 00:31:14.000000', 'consum', 0.0223, 'lps'),
	(467392, 123, '2015-04-01 00:31:15.000000', 'consum', 0.0237, 'lps'),
	(467393, 123, '2015-04-01 00:31:16.000000', 'consum', 0.0224, 'lps'),
	(467394, 123, '2015-04-01 00:31:17.000000', 'consum', 0.0225, 'lps'),
	(467395, 123, '2015-04-01 00:31:18.000000', 'consum', 0.0217, 'lps'),
	(467396, 123, '2015-04-01 00:31:19.000000', 'consum', 0.0229, 'lps'),
	(467397, 123, '2015-04-01 00:31:20.000000', 'consum', 0.0226, 'lps'),
	(467398, 123, '2015-04-01 00:31:21.000000', 'consum', 0.0236, 'lps'),
	(467399, 123, '2015-04-01 00:31:22.000000', 'consum', 0.0210, 'lps'),
	(467400, 123, '2015-04-01 00:31:23.000000', 'consum', 0.0214, 'lps'),
	(467401, 123, '2015-04-01 00:31:24.000000', 'consum', 0.0230, 'lps'),
	(467402, 123, '2015-04-01 00:31:25.000000', 'consum', 0.0214, 'lps'),
	(467403, 123, '2015-04-01 00:31:26.000000', 'consum', 0.0229, 'lps'),
	(467404, 123, '2015-04-01 00:31:27.000000', 'consum', 0.0210, 'lps'),
	(467405, 123, '2015-04-01 00:31:28.000000', 'consum', 0.0236, 'lps'),
	(467406, 123, '2015-04-01 00:31:29.000000', 'consum', 0.0229, 'lps'),
	(467407, 123, '2015-04-01 00:31:30.000000', 'consum', 0.0226, 'lps'),
	(467408, 123, '2015-04-01 00:31:31.000000', 'consum', 0.0236, 'lps'),
	(467409, 123, '2015-04-01 00:31:32.000000', 'consum', 0.0236, 'lps'),
	(467410, 123, '2015-04-01 00:31:33.000000', 'consum', 0.0233, 'lps'),
	(467411, 123, '2015-04-01 00:31:34.000000', 'consum', 0.0222, 'lps'),
	(467412, 123, '2015-04-01 00:31:35.000000', 'consum', 0.0227, 'lps'),
	(467413, 123, '2015-04-01 00:31:36.000000', 'consum', 0.0235, 'lps'),
	(467414, 123, '2015-04-01 00:31:37.000000', 'consum', 0.0225, 'lps'),
	(467415, 123, '2015-04-01 00:31:38.000000', 'consum', 0.0210, 'lps'),
	(467416, 123, '2015-04-01 00:31:39.000000', 'consum', 0.0224, 'lps'),
	(467417, 123, '2015-04-01 00:31:40.000000', 'consum', 0.0221, 'lps'),
	(467418, 123, '2015-04-01 00:31:41.000000', 'consum', 0.0227, 'lps'),
	(467419, 123, '2015-04-01 00:31:42.000000', 'consum', 0.0235, 'lps'),
	(467420, 123, '2015-04-01 00:31:43.000000', 'consum', 0.0228, 'lps'),
	(467421, 123, '2015-04-01 00:31:44.000000', 'consum', 0.0224, 'lps'),
	(467422, 123, '2015-04-01 00:31:45.000000', 'consum', 0.0228, 'lps'),
	(467423, 123, '2015-04-01 00:31:46.000000', 'consum', 0.0230, 'lps'),
	(467424, 123, '2015-04-01 00:31:47.000000', 'consum', 0.0227, 'lps'),
	(467425, 123, '2015-04-01 00:31:48.000000', 'consum', 0.0235, 'lps'),
	(467426, 123, '2015-04-01 00:31:49.000000', 'consum', 0.0229, 'lps'),
	(467427, 123, '2015-04-01 00:31:50.000000', 'consum', 0.0229, 'lps'),
	(467428, 123, '2015-04-01 00:31:51.000000', 'consum', 0.0221, 'lps'),
	(467429, 123, '2015-04-01 00:31:52.000000', 'consum', 0.0211, 'lps'),
	(467430, 123, '2015-04-01 00:31:53.000000', 'consum', 0.0237, 'lps'),
	(467431, 123, '2015-04-01 00:31:54.000000', 'consum', 0.0230, 'lps'),
	(467432, 123, '2015-04-01 00:31:55.000000', 'consum', 0.0229, 'lps'),
	(467433, 123, '2015-04-01 00:31:56.000000', 'consum', 0.0219, 'lps'),
	(467434, 123, '2015-04-01 00:31:57.000000', 'consum', 0.0226, 'lps'),
	(467435, 123, '2015-04-01 00:31:58.000000', 'consum', 0.0234, 'lps'),
	(467436, 123, '2015-04-01 00:31:59.000000', 'consum', 0.0228, 'lps'),
	(467437, 123, '2015-04-01 00:32:00.000000', 'consum', 0.0227, 'lps'),
	(467438, 123, '2015-04-01 00:32:01.000000', 'consum', 0.0216, 'lps'),
	(467439, 123, '2015-04-01 00:32:02.000000', 'consum', 0.0215, 'lps'),
	(467440, 123, '2015-04-01 00:32:03.000000', 'consum', 0.0219, 'lps'),
	(467441, 123, '2015-04-01 00:32:04.000000', 'consum', 0.0212, 'lps'),
	(467442, 123, '2015-04-01 00:32:05.000000', 'consum', 0.0223, 'lps'),
	(467443, 123, '2015-04-01 00:32:06.000000', 'consum', 0.0211, 'lps'),
	(467444, 123, '2015-04-01 00:32:07.000000', 'consum', 0.0234, 'lps'),
	(467445, 123, '2015-04-01 00:32:08.000000', 'consum', 0.0215, 'lps'),
	(467446, 123, '2015-04-01 00:32:09.000000', 'consum', 0.0219, 'lps'),
	(467447, 123, '2015-04-01 00:32:10.000000', 'consum', 0.0214, 'lps'),
	(467448, 123, '2015-04-01 00:32:11.000000', 'consum', 0.0231, 'lps'),
	(467449, 123, '2015-04-01 00:32:12.000000', 'consum', 0.0219, 'lps'),
	(467450, 123, '2015-04-01 00:32:13.000000', 'consum', 0.0221, 'lps'),
	(467451, 123, '2015-04-01 00:32:14.000000', 'consum', 0.0211, 'lps'),
	(467452, 123, '2015-04-01 00:32:15.000000', 'consum', 0.0211, 'lps'),
	(467453, 123, '2015-04-01 00:32:16.000000', 'consum', 0.0212, 'lps'),
	(467454, 123, '2015-04-01 00:32:17.000000', 'consum', 0.0217, 'lps'),
	(467455, 123, '2015-04-01 00:32:18.000000', 'consum', 0.0210, 'lps'),
	(467456, 123, '2015-04-01 00:32:19.000000', 'consum', 0.0218, 'lps'),
	(467457, 123, '2015-04-01 00:32:20.000000', 'consum', 0.0224, 'lps'),
	(467458, 123, '2015-04-01 00:32:21.000000', 'consum', 0.0229, 'lps'),
	(467459, 123, '2015-04-01 00:32:22.000000', 'consum', 0.0235, 'lps'),
	(467460, 123, '2015-04-01 00:32:23.000000', 'consum', 0.0223, 'lps'),
	(467461, 123, '2015-04-01 00:32:24.000000', 'consum', 0.0230, 'lps'),
	(467462, 123, '2015-04-01 00:32:25.000000', 'consum', 0.0214, 'lps'),
	(467463, 123, '2015-04-01 00:32:26.000000', 'consum', 0.0226, 'lps'),
	(467464, 123, '2015-04-01 00:32:27.000000', 'consum', 0.0221, 'lps'),
	(467465, 123, '2015-04-01 00:32:28.000000', 'consum', 0.0219, 'lps'),
	(467466, 123, '2015-04-01 00:32:29.000000', 'consum', 0.0223, 'lps'),
	(467467, 123, '2015-04-01 00:32:30.000000', 'consum', 0.0218, 'lps'),
	(467468, 123, '2015-04-01 00:32:31.000000', 'consum', 0.0213, 'lps'),
	(467469, 123, '2015-04-01 00:32:32.000000', 'consum', 0.0231, 'lps'),
	(467470, 123, '2015-04-01 00:32:33.000000', 'consum', 0.0221, 'lps'),
	(467471, 123, '2015-04-01 00:32:34.000000', 'consum', 0.0231, 'lps'),
	(467472, 123, '2015-04-01 00:32:35.000000', 'consum', 0.0229, 'lps'),
	(467473, 123, '2015-04-01 00:32:36.000000', 'consum', 0.0211, 'lps'),
	(467474, 123, '2015-04-01 00:32:37.000000', 'consum', 0.0214, 'lps'),
	(467475, 123, '2015-04-01 00:32:38.000000', 'consum', 0.0227, 'lps'),
	(467476, 123, '2015-04-01 00:32:39.000000', 'consum', 0.0229, 'lps'),
	(467477, 123, '2015-04-01 00:32:40.000000', 'consum', 0.0226, 'lps'),
	(467478, 123, '2015-04-01 00:32:41.000000', 'consum', 0.0234, 'lps'),
	(467479, 123, '2015-04-01 00:32:42.000000', 'consum', 0.0226, 'lps'),
	(467480, 123, '2015-04-01 00:32:43.000000', 'consum', 0.0217, 'lps'),
	(467481, 123, '2015-04-01 00:32:44.000000', 'consum', 0.0226, 'lps'),
	(467482, 123, '2015-04-01 00:32:45.000000', 'consum', 0.0213, 'lps'),
	(467483, 123, '2015-04-01 00:32:46.000000', 'consum', 0.0232, 'lps'),
	(467484, 123, '2015-04-01 00:32:47.000000', 'consum', 0.0230, 'lps'),
	(467485, 123, '2015-04-01 00:32:48.000000', 'consum', 0.0216, 'lps'),
	(467486, 123, '2015-04-01 00:32:49.000000', 'consum', 0.0235, 'lps'),
	(467487, 123, '2015-04-01 00:32:50.000000', 'consum', 0.0234, 'lps'),
	(467488, 123, '2015-04-01 00:32:51.000000', 'consum', 0.0229, 'lps'),
	(467489, 123, '2015-04-01 00:32:52.000000', 'consum', 0.0233, 'lps'),
	(467490, 123, '2015-04-01 00:32:53.000000', 'consum', 0.0213, 'lps'),
	(467491, 123, '2015-04-01 00:32:54.000000', 'consum', 0.0211, 'lps'),
	(467492, 123, '2015-04-01 00:32:55.000000', 'consum', 0.0234, 'lps'),
	(467493, 123, '2015-04-01 00:32:56.000000', 'consum', 0.0216, 'lps'),
	(467494, 123, '2015-04-01 00:32:57.000000', 'consum', 0.0223, 'lps'),
	(467495, 123, '2015-04-01 00:32:58.000000', 'consum', 0.0231, 'lps'),
	(467496, 123, '2015-04-01 00:32:59.000000', 'consum', 0.0221, 'lps'),
	(467497, 123, '2015-04-01 00:33:00.000000', 'consum', 0.0230, 'lps'),
	(467498, 123, '2015-04-01 00:33:01.000000', 'consum', 0.0220, 'lps'),
	(467499, 123, '2015-04-01 00:33:02.000000', 'consum', 0.0229, 'lps'),
	(467500, 123, '2015-04-01 00:33:03.000000', 'consum', 0.0221, 'lps'),
	(467501, 123, '2015-04-01 00:33:04.000000', 'consum', 0.0237, 'lps'),
	(467502, 123, '2015-04-01 00:33:05.000000', 'consum', 0.0227, 'lps'),
	(467503, 123, '2015-04-01 00:33:06.000000', 'consum', 0.0214, 'lps'),
	(467504, 123, '2015-04-01 00:33:07.000000', 'consum', 0.0234, 'lps'),
	(467505, 123, '2015-04-01 00:33:08.000000', 'consum', 0.0236, 'lps'),
	(467506, 123, '2015-04-01 00:33:09.000000', 'consum', 0.0213, 'lps'),
	(467507, 123, '2015-04-01 00:33:10.000000', 'consum', 0.0233, 'lps'),
	(467508, 123, '2015-04-01 00:33:11.000000', 'consum', 0.0232, 'lps'),
	(467509, 123, '2015-04-01 00:33:12.000000', 'consum', 0.0224, 'lps'),
	(467510, 123, '2015-04-01 00:33:13.000000', 'consum', 0.0212, 'lps'),
	(467511, 123, '2015-04-01 00:33:14.000000', 'consum', 0.0237, 'lps'),
	(467512, 123, '2015-04-01 00:33:15.000000', 'consum', 0.0225, 'lps'),
	(467513, 123, '2015-04-01 00:33:16.000000', 'consum', 0.0236, 'lps'),
	(467514, 123, '2015-04-01 00:33:17.000000', 'consum', 0.0236, 'lps'),
	(467515, 123, '2015-04-01 00:33:18.000000', 'consum', 0.0237, 'lps'),
	(467516, 123, '2015-04-01 00:33:19.000000', 'consum', 0.0212, 'lps'),
	(467517, 123, '2015-04-01 00:33:20.000000', 'consum', 0.0221, 'lps'),
	(467518, 123, '2015-04-01 00:33:21.000000', 'consum', 0.0231, 'lps'),
	(467519, 123, '2015-04-01 00:33:22.000000', 'consum', 0.0226, 'lps'),
	(467520, 123, '2015-04-01 00:33:23.000000', 'consum', 0.0228, 'lps'),
	(467521, 123, '2015-04-01 00:33:24.000000', 'consum', 0.0227, 'lps'),
	(467522, 123, '2015-04-01 00:33:25.000000', 'consum', 0.0212, 'lps'),
	(467523, 123, '2015-04-01 00:33:26.000000', 'consum', 0.0225, 'lps'),
	(467524, 123, '2015-04-01 00:33:27.000000', 'consum', 0.0223, 'lps'),
	(467525, 123, '2015-04-01 00:33:28.000000', 'consum', 0.0231, 'lps'),
	(467526, 123, '2015-04-01 00:33:29.000000', 'consum', 0.0222, 'lps'),
	(467527, 123, '2015-04-01 00:33:30.000000', 'consum', 0.0235, 'lps'),
	(467528, 123, '2015-04-01 00:33:31.000000', 'consum', 0.0216, 'lps'),
	(467529, 123, '2015-04-01 00:33:32.000000', 'consum', 0.0219, 'lps'),
	(467530, 123, '2015-04-01 00:33:33.000000', 'consum', 0.0212, 'lps'),
	(467531, 123, '2015-04-01 00:33:34.000000', 'consum', 0.0222, 'lps'),
	(467532, 123, '2015-04-01 00:33:35.000000', 'consum', 0.0236, 'lps'),
	(467533, 123, '2015-04-01 00:33:36.000000', 'consum', 0.0219, 'lps'),
	(467534, 123, '2015-04-01 00:33:37.000000', 'consum', 0.0234, 'lps'),
	(467535, 123, '2015-04-01 00:33:38.000000', 'consum', 0.0218, 'lps'),
	(467536, 123, '2015-04-01 00:33:39.000000', 'consum', 0.0234, 'lps'),
	(467537, 123, '2015-04-01 00:33:40.000000', 'consum', 0.0225, 'lps'),
	(467538, 123, '2015-04-01 00:33:41.000000', 'consum', 0.0212, 'lps'),
	(467539, 123, '2015-04-01 00:33:42.000000', 'consum', 0.0233, 'lps'),
	(467540, 123, '2015-04-01 00:33:43.000000', 'consum', 0.0233, 'lps'),
	(467541, 123, '2015-04-01 00:33:44.000000', 'consum', 0.0231, 'lps'),
	(467542, 123, '2015-04-01 00:33:45.000000', 'consum', 0.0216, 'lps'),
	(467543, 123, '2015-04-01 00:33:46.000000', 'consum', 0.0234, 'lps'),
	(467544, 123, '2015-04-01 00:33:47.000000', 'consum', 0.0228, 'lps'),
	(467545, 123, '2015-04-01 00:33:48.000000', 'consum', 0.0229, 'lps'),
	(467546, 123, '2015-04-01 00:33:49.000000', 'consum', 0.0225, 'lps'),
	(467547, 123, '2015-04-01 00:33:50.000000', 'consum', 0.0226, 'lps'),
	(467548, 123, '2015-04-01 00:33:51.000000', 'consum', 0.0218, 'lps'),
	(467549, 123, '2015-04-01 00:33:52.000000', 'consum', 0.0231, 'lps'),
	(467550, 123, '2015-04-01 00:33:53.000000', 'consum', 0.0237, 'lps'),
	(467551, 123, '2015-04-01 00:33:54.000000', 'consum', 0.0224, 'lps'),
	(467552, 123, '2015-04-01 00:33:55.000000', 'consum', 0.0228, 'lps'),
	(467553, 123, '2015-04-01 00:33:56.000000', 'consum', 0.0231, 'lps'),
	(467554, 123, '2015-04-01 00:33:57.000000', 'consum', 0.0234, 'lps'),
	(467555, 123, '2015-04-01 00:33:58.000000', 'consum', 0.0213, 'lps'),
	(467556, 123, '2015-04-01 00:33:59.000000', 'consum', 0.0236, 'lps'),
	(467557, 123, '2015-04-01 00:34:00.000000', 'consum', 0.0220, 'lps'),
	(467558, 123, '2015-04-01 00:34:01.000000', 'consum', 0.0210, 'lps'),
	(467559, 123, '2015-04-01 00:34:02.000000', 'consum', 0.0210, 'lps'),
	(467560, 123, '2015-04-01 00:34:03.000000', 'consum', 0.0236, 'lps'),
	(467561, 123, '2015-04-01 00:34:04.000000', 'consum', 0.0229, 'lps'),
	(467562, 123, '2015-04-01 00:34:05.000000', 'consum', 0.0228, 'lps'),
	(467563, 123, '2015-04-01 00:34:06.000000', 'consum', 0.0214, 'lps'),
	(467564, 123, '2015-04-01 00:34:07.000000', 'consum', 0.0234, 'lps'),
	(467565, 123, '2015-04-01 00:34:08.000000', 'consum', 0.0232, 'lps'),
	(467566, 123, '2015-04-01 00:34:09.000000', 'consum', 0.0223, 'lps'),
	(467567, 123, '2015-04-01 00:34:10.000000', 'consum', 0.0237, 'lps'),
	(467568, 123, '2015-04-01 00:34:11.000000', 'consum', 0.0224, 'lps'),
	(467569, 123, '2015-04-01 00:34:12.000000', 'consum', 0.0228, 'lps'),
	(467570, 123, '2015-04-01 00:34:13.000000', 'consum', 0.0228, 'lps'),
	(467571, 123, '2015-04-01 00:34:14.000000', 'consum', 0.0221, 'lps'),
	(467572, 123, '2015-04-01 00:34:15.000000', 'consum', 0.0210, 'lps'),
	(467573, 123, '2015-04-01 00:34:16.000000', 'consum', 0.0233, 'lps'),
	(467574, 123, '2015-04-01 00:34:17.000000', 'consum', 0.0214, 'lps'),
	(467575, 123, '2015-04-01 00:34:18.000000', 'consum', 0.0219, 'lps'),
	(467576, 123, '2015-04-01 00:34:19.000000', 'consum', 0.0217, 'lps'),
	(467577, 123, '2015-04-01 00:34:20.000000', 'consum', 0.0215, 'lps'),
	(467578, 123, '2015-04-01 00:34:21.000000', 'consum', 0.0214, 'lps'),
	(467579, 123, '2015-04-01 00:34:22.000000', 'consum', 0.0217, 'lps'),
	(467580, 123, '2015-04-01 00:34:23.000000', 'consum', 0.0233, 'lps'),
	(467581, 123, '2015-04-01 00:34:24.000000', 'consum', 0.0222, 'lps'),
	(467582, 123, '2015-04-01 00:34:25.000000', 'consum', 0.0228, 'lps'),
	(467583, 123, '2015-04-01 00:34:26.000000', 'consum', 0.0237, 'lps'),
	(467584, 123, '2015-04-01 00:34:27.000000', 'consum', 0.0233, 'lps'),
	(467585, 123, '2015-04-01 00:34:28.000000', 'consum', 0.0220, 'lps'),
	(467586, 123, '2015-04-01 00:34:29.000000', 'consum', 0.0218, 'lps'),
	(467587, 123, '2015-04-01 00:34:30.000000', 'consum', 0.0223, 'lps'),
	(467588, 123, '2015-04-01 00:34:31.000000', 'consum', 0.0221, 'lps'),
	(467589, 123, '2015-04-01 00:34:32.000000', 'consum', 0.0226, 'lps'),
	(467590, 123, '2015-04-01 00:34:33.000000', 'consum', 0.0232, 'lps'),
	(467591, 123, '2015-04-01 00:34:34.000000', 'consum', 0.0216, 'lps'),
	(467592, 123, '2015-04-01 00:34:35.000000', 'consum', 0.0230, 'lps'),
	(467593, 123, '2015-04-01 00:34:36.000000', 'consum', 0.0236, 'lps'),
	(467594, 123, '2015-04-01 00:34:37.000000', 'consum', 0.0225, 'lps'),
	(467595, 123, '2015-04-01 00:34:38.000000', 'consum', 0.0234, 'lps'),
	(467596, 123, '2015-04-01 00:34:39.000000', 'consum', 0.0229, 'lps'),
	(467597, 123, '2015-04-01 00:34:40.000000', 'consum', 0.0237, 'lps'),
	(467598, 123, '2015-04-01 00:34:41.000000', 'consum', 0.0229, 'lps'),
	(467599, 123, '2015-04-01 00:34:42.000000', 'consum', 0.0224, 'lps'),
	(467600, 123, '2015-04-01 00:34:43.000000', 'consum', 0.0226, 'lps'),
	(467601, 123, '2015-04-01 00:34:44.000000', 'consum', 0.0220, 'lps'),
	(467602, 123, '2015-04-01 00:34:45.000000', 'consum', 0.0211, 'lps'),
	(467603, 123, '2015-04-01 00:34:46.000000', 'consum', 0.0212, 'lps'),
	(467604, 123, '2015-04-01 00:34:47.000000', 'consum', 0.0221, 'lps'),
	(467605, 123, '2015-04-01 00:34:48.000000', 'consum', 0.0230, 'lps'),
	(467606, 123, '2015-04-01 00:34:49.000000', 'consum', 0.0222, 'lps'),
	(467607, 123, '2015-04-01 00:34:50.000000', 'consum', 0.0211, 'lps'),
	(467608, 123, '2015-04-01 00:34:51.000000', 'consum', 0.0237, 'lps'),
	(467609, 123, '2015-04-01 00:34:52.000000', 'consum', 0.0229, 'lps'),
	(467610, 123, '2015-04-01 00:34:53.000000', 'consum', 0.0224, 'lps'),
	(467611, 123, '2015-04-01 00:34:54.000000', 'consum', 0.0224, 'lps'),
	(467612, 123, '2015-04-01 00:34:55.000000', 'consum', 0.0210, 'lps'),
	(467613, 123, '2015-04-01 00:34:56.000000', 'consum', 0.0223, 'lps'),
	(467614, 123, '2015-04-01 00:34:57.000000', 'consum', 0.0222, 'lps'),
	(467615, 123, '2015-04-01 00:34:58.000000', 'consum', 0.0229, 'lps'),
	(467616, 123, '2015-04-01 00:34:59.000000', 'consum', 0.0213, 'lps'),
	(467617, 123, '2015-04-01 00:35:00.000000', 'consum', 0.0225, 'lps'),
	(467618, 123, '2015-04-01 00:35:01.000000', 'consum', 0.0223, 'lps'),
	(467619, 123, '2015-04-01 00:35:02.000000', 'consum', 0.0227, 'lps'),
	(467620, 123, '2015-04-01 00:35:03.000000', 'consum', 0.0230, 'lps'),
	(467621, 123, '2015-04-01 00:35:04.000000', 'consum', 0.0233, 'lps'),
	(467622, 123, '2015-04-01 00:35:05.000000', 'consum', 0.0210, 'lps'),
	(467623, 123, '2015-04-01 00:35:06.000000', 'consum', 0.0223, 'lps'),
	(467624, 123, '2015-04-01 00:35:07.000000', 'consum', 0.0221, 'lps'),
	(467625, 123, '2015-04-01 00:35:08.000000', 'consum', 0.0228, 'lps'),
	(467626, 123, '2015-04-01 00:35:09.000000', 'consum', 0.0236, 'lps'),
	(467627, 123, '2015-04-01 00:35:10.000000', 'consum', 0.0232, 'lps'),
	(467628, 123, '2015-04-01 00:35:11.000000', 'consum', 0.0216, 'lps'),
	(467629, 123, '2015-04-01 00:35:12.000000', 'consum', 0.0228, 'lps'),
	(467630, 123, '2015-04-01 00:35:13.000000', 'consum', 0.0227, 'lps'),
	(467631, 123, '2015-04-01 00:35:14.000000', 'consum', 0.0215, 'lps'),
	(467632, 123, '2015-04-01 00:35:15.000000', 'consum', 0.0211, 'lps'),
	(467633, 123, '2015-04-01 00:35:16.000000', 'consum', 0.0229, 'lps'),
	(467634, 123, '2015-04-01 00:35:17.000000', 'consum', 0.0217, 'lps'),
	(467635, 123, '2015-04-01 00:35:18.000000', 'consum', 0.0216, 'lps'),
	(467636, 123, '2015-04-01 00:35:19.000000', 'consum', 0.0221, 'lps'),
	(467637, 123, '2015-04-01 00:35:20.000000', 'consum', 0.0219, 'lps'),
	(467638, 123, '2015-04-01 00:35:21.000000', 'consum', 0.0224, 'lps'),
	(467639, 123, '2015-04-01 00:35:22.000000', 'consum', 0.0225, 'lps'),
	(467640, 123, '2015-04-01 00:35:23.000000', 'consum', 0.0213, 'lps'),
	(467641, 123, '2015-04-01 00:35:24.000000', 'consum', 0.0211, 'lps'),
	(467642, 123, '2015-04-01 00:35:25.000000', 'consum', 0.0236, 'lps'),
	(467643, 123, '2015-04-01 00:35:26.000000', 'consum', 0.0222, 'lps'),
	(467644, 123, '2015-04-01 00:35:27.000000', 'consum', 0.0221, 'lps'),
	(467645, 123, '2015-04-01 00:35:28.000000', 'consum', 0.0232, 'lps'),
	(467646, 123, '2015-04-01 00:35:29.000000', 'consum', 0.0230, 'lps'),
	(467647, 123, '2015-04-01 00:35:30.000000', 'consum', 0.0215, 'lps'),
	(467648, 123, '2015-04-01 00:35:31.000000', 'consum', 0.0232, 'lps'),
	(467649, 123, '2015-04-01 00:35:32.000000', 'consum', 0.0224, 'lps'),
	(467650, 123, '2015-04-01 00:35:33.000000', 'consum', 0.0213, 'lps'),
	(467651, 123, '2015-04-01 00:35:34.000000', 'consum', 0.0212, 'lps'),
	(467652, 123, '2015-04-01 00:35:35.000000', 'consum', 0.0212, 'lps'),
	(467653, 123, '2015-04-01 00:35:36.000000', 'consum', 0.0215, 'lps'),
	(467654, 123, '2015-04-01 00:35:37.000000', 'consum', 0.0229, 'lps'),
	(467655, 123, '2015-04-01 00:35:38.000000', 'consum', 0.0236, 'lps'),
	(467656, 123, '2015-04-01 00:35:39.000000', 'consum', 0.0225, 'lps'),
	(467657, 123, '2015-04-01 00:35:40.000000', 'consum', 0.0234, 'lps'),
	(467658, 123, '2015-04-01 00:35:41.000000', 'consum', 0.0233, 'lps'),
	(467659, 123, '2015-04-01 00:35:42.000000', 'consum', 0.0223, 'lps'),
	(467660, 123, '2015-04-01 00:35:43.000000', 'consum', 0.0234, 'lps'),
	(467661, 123, '2015-04-01 00:35:44.000000', 'consum', 0.0235, 'lps'),
	(467662, 123, '2015-04-01 00:35:45.000000', 'consum', 0.0236, 'lps'),
	(467663, 123, '2015-04-01 00:35:46.000000', 'consum', 0.0210, 'lps'),
	(467664, 123, '2015-04-01 00:35:47.000000', 'consum', 0.0216, 'lps'),
	(467665, 123, '2015-04-01 00:35:48.000000', 'consum', 0.0212, 'lps'),
	(467666, 123, '2015-04-01 00:35:49.000000', 'consum', 0.0233, 'lps'),
	(467667, 123, '2015-04-01 00:35:50.000000', 'consum', 0.0232, 'lps'),
	(467668, 123, '2015-04-01 00:35:51.000000', 'consum', 0.0227, 'lps'),
	(467669, 123, '2015-04-01 00:35:52.000000', 'consum', 0.0228, 'lps'),
	(467670, 123, '2015-04-01 00:35:53.000000', 'consum', 0.0221, 'lps'),
	(467671, 123, '2015-04-01 00:35:54.000000', 'consum', 0.0213, 'lps'),
	(467672, 123, '2015-04-01 00:35:55.000000', 'consum', 0.0220, 'lps'),
	(467673, 123, '2015-04-01 00:35:56.000000', 'consum', 0.0225, 'lps'),
	(467674, 123, '2015-04-01 00:35:57.000000', 'consum', 0.0227, 'lps'),
	(467675, 123, '2015-04-01 00:35:58.000000', 'consum', 0.0222, 'lps'),
	(467676, 123, '2015-04-01 00:35:59.000000', 'consum', 0.0221, 'lps'),
	(467677, 123, '2015-04-01 00:36:00.000000', 'consum', 0.0228, 'lps'),
	(467678, 123, '2015-04-01 00:36:01.000000', 'consum', 0.0211, 'lps'),
	(467679, 123, '2015-04-01 00:36:02.000000', 'consum', 0.0217, 'lps'),
	(467680, 123, '2015-04-01 00:36:03.000000', 'consum', 0.0215, 'lps'),
	(467681, 123, '2015-04-01 00:36:04.000000', 'consum', 0.0213, 'lps'),
	(467682, 123, '2015-04-01 00:36:05.000000', 'consum', 0.0211, 'lps'),
	(467683, 123, '2015-04-01 00:36:06.000000', 'consum', 0.0236, 'lps'),
	(467684, 123, '2015-04-01 00:36:07.000000', 'consum', 0.0224, 'lps'),
	(467685, 123, '2015-04-01 00:36:08.000000', 'consum', 0.0233, 'lps'),
	(467686, 123, '2015-04-01 00:36:09.000000', 'consum', 0.0225, 'lps'),
	(467687, 123, '2015-04-01 00:36:10.000000', 'consum', 0.0217, 'lps'),
	(467688, 123, '2015-04-01 00:36:11.000000', 'consum', 0.0230, 'lps'),
	(467689, 123, '2015-04-01 00:36:12.000000', 'consum', 0.0232, 'lps'),
	(467690, 123, '2015-04-01 00:36:13.000000', 'consum', 0.0235, 'lps'),
	(467691, 123, '2015-04-01 00:36:14.000000', 'consum', 0.0210, 'lps'),
	(467692, 123, '2015-04-01 00:36:15.000000', 'consum', 0.0223, 'lps'),
	(467693, 123, '2015-04-01 00:36:16.000000', 'consum', 0.0216, 'lps'),
	(467694, 123, '2015-04-01 00:36:17.000000', 'consum', 0.0233, 'lps'),
	(467695, 123, '2015-04-01 00:36:18.000000', 'consum', 0.0222, 'lps'),
	(467696, 123, '2015-04-01 00:36:19.000000', 'consum', 0.0228, 'lps'),
	(467697, 123, '2015-04-01 00:36:20.000000', 'consum', 0.0236, 'lps'),
	(467698, 123, '2015-04-01 00:36:21.000000', 'consum', 0.0233, 'lps'),
	(467699, 123, '2015-04-01 00:36:22.000000', 'consum', 0.0219, 'lps'),
	(467700, 123, '2015-04-01 00:36:23.000000', 'consum', 0.0215, 'lps'),
	(467701, 123, '2015-04-01 00:36:24.000000', 'consum', 0.0235, 'lps'),
	(467702, 123, '2015-04-01 00:36:25.000000', 'consum', 0.0237, 'lps'),
	(467703, 123, '2015-04-01 00:36:26.000000', 'consum', 0.0213, 'lps'),
	(467704, 123, '2015-04-01 00:36:27.000000', 'consum', 0.0230, 'lps'),
	(467705, 123, '2015-04-01 00:36:28.000000', 'consum', 0.0215, 'lps'),
	(467706, 123, '2015-04-01 00:36:29.000000', 'consum', 0.0235, 'lps'),
	(467707, 123, '2015-04-01 00:36:30.000000', 'consum', 0.0236, 'lps'),
	(467708, 123, '2015-04-01 00:36:31.000000', 'consum', 0.0237, 'lps'),
	(467709, 123, '2015-04-01 00:36:32.000000', 'consum', 0.0237, 'lps'),
	(467710, 123, '2015-04-01 00:36:33.000000', 'consum', 0.0211, 'lps'),
	(467711, 123, '2015-04-01 00:36:34.000000', 'consum', 0.0220, 'lps'),
	(467712, 123, '2015-04-01 00:36:35.000000', 'consum', 0.0228, 'lps'),
	(467713, 123, '2015-04-01 00:36:36.000000', 'consum', 0.0216, 'lps'),
	(467714, 123, '2015-04-01 00:36:37.000000', 'consum', 0.0213, 'lps'),
	(467715, 123, '2015-04-01 00:36:38.000000', 'consum', 0.0234, 'lps'),
	(467716, 123, '2015-04-01 00:36:39.000000', 'consum', 0.0212, 'lps'),
	(467717, 123, '2015-04-01 00:36:40.000000', 'consum', 0.0234, 'lps'),
	(467718, 123, '2015-04-01 00:36:41.000000', 'consum', 0.0210, 'lps'),
	(467719, 123, '2015-04-01 00:36:42.000000', 'consum', 0.0223, 'lps'),
	(467720, 123, '2015-04-01 00:36:43.000000', 'consum', 0.0218, 'lps'),
	(467721, 123, '2015-04-01 00:36:44.000000', 'consum', 0.0211, 'lps'),
	(467722, 123, '2015-04-01 00:36:45.000000', 'consum', 0.0221, 'lps'),
	(467723, 123, '2015-04-01 00:36:46.000000', 'consum', 0.0236, 'lps'),
	(467724, 123, '2015-04-01 00:36:47.000000', 'consum', 0.0223, 'lps'),
	(467725, 123, '2015-04-01 00:36:48.000000', 'consum', 0.0224, 'lps'),
	(467726, 123, '2015-04-01 00:36:49.000000', 'consum', 0.0215, 'lps'),
	(467727, 123, '2015-04-01 00:36:50.000000', 'consum', 0.0221, 'lps'),
	(467728, 123, '2015-04-01 00:36:51.000000', 'consum', 0.0221, 'lps'),
	(467729, 123, '2015-04-01 00:36:52.000000', 'consum', 0.0235, 'lps'),
	(467730, 123, '2015-04-01 00:36:53.000000', 'consum', 0.0216, 'lps'),
	(467731, 123, '2015-04-01 00:36:54.000000', 'consum', 0.0224, 'lps'),
	(467732, 123, '2015-04-01 00:36:55.000000', 'consum', 0.0232, 'lps'),
	(467733, 123, '2015-04-01 00:36:56.000000', 'consum', 0.0225, 'lps'),
	(467734, 123, '2015-04-01 00:36:57.000000', 'consum', 0.0218, 'lps'),
	(467735, 123, '2015-04-01 00:36:58.000000', 'consum', 0.0232, 'lps'),
	(467736, 123, '2015-04-01 00:36:59.000000', 'consum', 0.0215, 'lps'),
	(467737, 123, '2015-04-01 00:37:00.000000', 'consum', 0.0226, 'lps'),
	(467738, 123, '2015-04-01 00:37:01.000000', 'consum', 0.0220, 'lps'),
	(467739, 123, '2015-04-01 00:37:02.000000', 'consum', 0.0212, 'lps'),
	(467740, 123, '2015-04-01 00:37:03.000000', 'consum', 0.0219, 'lps'),
	(467741, 123, '2015-04-01 00:37:04.000000', 'consum', 0.0222, 'lps'),
	(467742, 123, '2015-04-01 00:37:05.000000', 'consum', 0.0214, 'lps'),
	(467743, 123, '2015-04-01 00:37:06.000000', 'consum', 0.0222, 'lps'),
	(467744, 123, '2015-04-01 00:37:07.000000', 'consum', 0.0232, 'lps'),
	(467745, 123, '2015-04-01 00:37:08.000000', 'consum', 0.0226, 'lps'),
	(467746, 123, '2015-04-01 00:37:09.000000', 'consum', 0.0226, 'lps'),
	(467747, 123, '2015-04-01 00:37:10.000000', 'consum', 0.0213, 'lps'),
	(467748, 123, '2015-04-01 00:37:11.000000', 'consum', 0.0236, 'lps'),
	(467749, 123, '2015-04-01 00:37:12.000000', 'consum', 0.0218, 'lps'),
	(467750, 123, '2015-04-01 00:37:13.000000', 'consum', 0.0227, 'lps'),
	(467751, 123, '2015-04-01 00:37:14.000000', 'consum', 0.0217, 'lps'),
	(467752, 123, '2015-04-01 00:37:15.000000', 'consum', 0.0224, 'lps'),
	(467753, 123, '2015-04-01 00:37:16.000000', 'consum', 0.0230, 'lps'),
	(467754, 123, '2015-04-01 00:37:17.000000', 'consum', 0.0211, 'lps'),
	(467755, 123, '2015-04-01 00:37:18.000000', 'consum', 0.0213, 'lps'),
	(467756, 123, '2015-04-01 00:37:19.000000', 'consum', 0.0223, 'lps'),
	(467757, 123, '2015-04-01 00:37:20.000000', 'consum', 0.0210, 'lps'),
	(467758, 123, '2015-04-01 00:37:21.000000', 'consum', 0.0227, 'lps'),
	(467759, 123, '2015-04-01 00:37:22.000000', 'consum', 0.0210, 'lps'),
	(467760, 123, '2015-04-01 00:37:23.000000', 'consum', 0.0219, 'lps'),
	(467761, 123, '2015-04-01 00:37:24.000000', 'consum', 0.0226, 'lps'),
	(467762, 123, '2015-04-01 00:37:25.000000', 'consum', 0.0233, 'lps'),
	(467763, 123, '2015-04-01 00:37:26.000000', 'consum', 0.0225, 'lps'),
	(467764, 123, '2015-04-01 00:37:27.000000', 'consum', 0.0214, 'lps'),
	(467765, 123, '2015-04-01 00:37:28.000000', 'consum', 0.0216, 'lps'),
	(467766, 123, '2015-04-01 00:37:29.000000', 'consum', 0.0228, 'lps'),
	(467767, 123, '2015-04-01 00:37:30.000000', 'consum', 0.0225, 'lps'),
	(467768, 123, '2015-04-01 00:37:31.000000', 'consum', 0.0234, 'lps'),
	(467769, 123, '2015-04-01 00:37:32.000000', 'consum', 0.0230, 'lps'),
	(467770, 123, '2015-04-01 00:37:33.000000', 'consum', 0.0237, 'lps'),
	(467771, 123, '2015-04-01 00:37:34.000000', 'consum', 0.0229, 'lps'),
	(467772, 123, '2015-04-01 00:37:35.000000', 'consum', 0.0223, 'lps'),
	(467773, 123, '2015-04-01 00:37:36.000000', 'consum', 0.0221, 'lps'),
	(467774, 123, '2015-04-01 00:37:37.000000', 'consum', 0.0226, 'lps'),
	(467775, 123, '2015-04-01 00:37:38.000000', 'consum', 0.0227, 'lps'),
	(467776, 123, '2015-04-01 00:37:39.000000', 'consum', 0.0222, 'lps'),
	(467777, 123, '2015-04-01 00:37:40.000000', 'consum', 0.0219, 'lps'),
	(467778, 123, '2015-04-01 00:37:41.000000', 'consum', 0.0220, 'lps'),
	(467779, 123, '2015-04-01 00:37:42.000000', 'consum', 0.0231, 'lps'),
	(467780, 123, '2015-04-01 00:37:43.000000', 'consum', 0.0232, 'lps'),
	(467781, 123, '2015-04-01 00:37:44.000000', 'consum', 0.0229, 'lps'),
	(467782, 123, '2015-04-01 00:37:45.000000', 'consum', 0.0212, 'lps'),
	(467783, 123, '2015-04-01 00:37:46.000000', 'consum', 0.0220, 'lps'),
	(467784, 123, '2015-04-01 00:37:47.000000', 'consum', 0.0225, 'lps'),
	(467785, 123, '2015-04-01 00:37:48.000000', 'consum', 0.0227, 'lps'),
	(467786, 123, '2015-04-01 00:37:49.000000', 'consum', 0.0224, 'lps'),
	(467787, 123, '2015-04-01 00:37:50.000000', 'consum', 0.0230, 'lps'),
	(467788, 123, '2015-04-01 00:37:51.000000', 'consum', 0.0211, 'lps'),
	(467789, 123, '2015-04-01 00:37:52.000000', 'consum', 0.0210, 'lps'),
	(467790, 123, '2015-04-01 00:37:53.000000', 'consum', 0.0210, 'lps'),
	(467791, 123, '2015-04-01 00:37:54.000000', 'consum', 0.0210, 'lps'),
	(467792, 123, '2015-04-01 00:37:55.000000', 'consum', 0.0211, 'lps'),
	(467793, 123, '2015-04-01 00:37:56.000000', 'consum', 0.0216, 'lps'),
	(467794, 123, '2015-04-01 00:37:57.000000', 'consum', 0.0237, 'lps'),
	(467795, 123, '2015-04-01 00:37:58.000000', 'consum', 0.0216, 'lps'),
	(467796, 123, '2015-04-01 00:37:59.000000', 'consum', 0.0215, 'lps'),
	(467797, 123, '2015-04-01 00:38:00.000000', 'consum', 0.0217, 'lps'),
	(467798, 123, '2015-04-01 00:38:01.000000', 'consum', 0.0230, 'lps'),
	(467799, 123, '2015-04-01 00:38:02.000000', 'consum', 0.0233, 'lps'),
	(467800, 123, '2015-04-01 00:38:03.000000', 'consum', 0.0211, 'lps'),
	(467801, 123, '2015-04-01 00:38:04.000000', 'consum', 0.0230, 'lps'),
	(467802, 123, '2015-04-01 00:38:05.000000', 'consum', 0.0224, 'lps'),
	(467803, 123, '2015-04-01 00:38:06.000000', 'consum', 0.0221, 'lps'),
	(467804, 123, '2015-04-01 00:38:07.000000', 'consum', 0.0224, 'lps'),
	(467805, 123, '2015-04-01 00:38:08.000000', 'consum', 0.0217, 'lps'),
	(467806, 123, '2015-04-01 00:38:09.000000', 'consum', 0.0233, 'lps'),
	(467807, 123, '2015-04-01 00:38:10.000000', 'consum', 0.0218, 'lps'),
	(467808, 123, '2015-04-01 00:38:11.000000', 'consum', 0.0212, 'lps'),
	(467809, 123, '2015-04-01 00:38:12.000000', 'consum', 0.0224, 'lps'),
	(467810, 123, '2015-04-01 00:38:13.000000', 'consum', 0.0217, 'lps'),
	(467811, 123, '2015-04-01 00:38:14.000000', 'consum', 0.0230, 'lps'),
	(467812, 123, '2015-04-01 00:38:15.000000', 'consum', 0.0237, 'lps'),
	(467813, 123, '2015-04-01 00:38:16.000000', 'consum', 0.0230, 'lps'),
	(467814, 123, '2015-04-01 00:38:17.000000', 'consum', 0.0226, 'lps'),
	(467815, 123, '2015-04-01 00:38:18.000000', 'consum', 0.0233, 'lps'),
	(467816, 123, '2015-04-01 00:38:19.000000', 'consum', 0.0223, 'lps'),
	(467817, 123, '2015-04-01 00:38:20.000000', 'consum', 0.0233, 'lps'),
	(467818, 123, '2015-04-01 00:38:21.000000', 'consum', 0.0230, 'lps'),
	(467819, 123, '2015-04-01 00:38:22.000000', 'consum', 0.0212, 'lps'),
	(467820, 123, '2015-04-01 00:38:23.000000', 'consum', 0.0219, 'lps'),
	(467821, 123, '2015-04-01 00:38:24.000000', 'consum', 0.0219, 'lps'),
	(467822, 123, '2015-04-01 00:38:25.000000', 'consum', 0.0228, 'lps'),
	(467823, 123, '2015-04-01 00:38:26.000000', 'consum', 0.0220, 'lps'),
	(467824, 123, '2015-04-01 00:38:27.000000', 'consum', 0.0231, 'lps'),
	(467825, 123, '2015-04-01 00:38:28.000000', 'consum', 0.0233, 'lps'),
	(467826, 123, '2015-04-01 00:38:29.000000', 'consum', 0.0235, 'lps'),
	(467827, 123, '2015-04-01 00:38:30.000000', 'consum', 0.0236, 'lps'),
	(467828, 123, '2015-04-01 00:38:31.000000', 'consum', 0.0237, 'lps'),
	(467829, 123, '2015-04-01 00:38:32.000000', 'consum', 0.0213, 'lps'),
	(467830, 123, '2015-04-01 00:38:33.000000', 'consum', 0.0228, 'lps'),
	(467831, 123, '2015-04-01 00:38:34.000000', 'consum', 0.0235, 'lps'),
	(467832, 123, '2015-04-01 00:38:35.000000', 'consum', 0.0226, 'lps'),
	(467833, 123, '2015-04-01 00:38:36.000000', 'consum', 0.0216, 'lps'),
	(467834, 123, '2015-04-01 00:38:37.000000', 'consum', 0.0222, 'lps'),
	(467835, 123, '2015-04-01 00:38:38.000000', 'consum', 0.0224, 'lps'),
	(467836, 123, '2015-04-01 00:38:39.000000', 'consum', 0.0214, 'lps'),
	(467837, 123, '2015-04-01 00:38:40.000000', 'consum', 0.0217, 'lps'),
	(467838, 123, '2015-04-01 00:38:41.000000', 'consum', 0.0236, 'lps'),
	(467839, 123, '2015-04-01 00:38:42.000000', 'consum', 0.0232, 'lps'),
	(467840, 123, '2015-04-01 00:38:43.000000', 'consum', 0.0217, 'lps'),
	(467841, 123, '2015-04-01 00:38:44.000000', 'consum', 0.0236, 'lps'),
	(467842, 123, '2015-04-01 00:38:45.000000', 'consum', 0.0237, 'lps'),
	(467843, 123, '2015-04-01 00:38:46.000000', 'consum', 0.0237, 'lps'),
	(467844, 123, '2015-04-01 00:38:47.000000', 'consum', 0.0236, 'lps'),
	(467845, 123, '2015-04-01 00:38:48.000000', 'consum', 0.0234, 'lps'),
	(467846, 123, '2015-04-01 00:38:49.000000', 'consum', 0.0225, 'lps'),
	(467847, 123, '2015-04-01 00:38:50.000000', 'consum', 0.0212, 'lps'),
	(467848, 123, '2015-04-01 00:38:51.000000', 'consum', 0.0232, 'lps'),
	(467849, 123, '2015-04-01 00:38:52.000000', 'consum', 0.0230, 'lps'),
	(467850, 123, '2015-04-01 00:38:53.000000', 'consum', 0.0215, 'lps'),
	(467851, 123, '2015-04-01 00:38:54.000000', 'consum', 0.0231, 'lps'),
	(467852, 123, '2015-04-01 00:38:55.000000', 'consum', 0.0219, 'lps'),
	(467853, 123, '2015-04-01 00:38:56.000000', 'consum', 0.0219, 'lps'),
	(467854, 123, '2015-04-01 00:38:57.000000', 'consum', 0.0228, 'lps'),
	(467855, 123, '2015-04-01 00:38:58.000000', 'consum', 0.0219, 'lps'),
	(467856, 123, '2015-04-01 00:38:59.000000', 'consum', 0.0230, 'lps'),
	(467857, 123, '2015-04-01 00:39:00.000000', 'consum', 0.0227, 'lps'),
	(467858, 123, '2015-04-01 00:39:01.000000', 'consum', 0.0235, 'lps'),
	(467859, 123, '2015-04-01 00:39:02.000000', 'consum', 0.0227, 'lps'),
	(467860, 123, '2015-04-01 00:39:03.000000', 'consum', 0.0220, 'lps'),
	(467861, 123, '2015-04-01 00:39:04.000000', 'consum', 0.0211, 'lps'),
	(467862, 123, '2015-04-01 00:39:05.000000', 'consum', 0.0215, 'lps'),
	(467863, 123, '2015-04-01 00:39:06.000000', 'consum', 0.0230, 'lps'),
	(467864, 123, '2015-04-01 00:39:07.000000', 'consum', 0.0212, 'lps'),
	(467865, 123, '2015-04-01 00:39:08.000000', 'consum', 0.0217, 'lps'),
	(467866, 123, '2015-04-01 00:39:09.000000', 'consum', 0.0213, 'lps'),
	(467867, 123, '2015-04-01 00:39:10.000000', 'consum', 0.0229, 'lps'),
	(467868, 123, '2015-04-01 00:39:11.000000', 'consum', 0.0216, 'lps'),
	(467869, 123, '2015-04-01 00:39:12.000000', 'consum', 0.0210, 'lps'),
	(467870, 123, '2015-04-01 00:39:13.000000', 'consum', 0.0219, 'lps'),
	(467871, 123, '2015-04-01 00:39:14.000000', 'consum', 0.0227, 'lps'),
	(467872, 123, '2015-04-01 00:39:15.000000', 'consum', 0.0214, 'lps'),
	(467873, 123, '2015-04-01 00:39:16.000000', 'consum', 0.0233, 'lps'),
	(467874, 123, '2015-04-01 00:39:17.000000', 'consum', 0.0233, 'lps'),
	(467875, 123, '2015-04-01 00:39:18.000000', 'consum', 0.0227, 'lps'),
	(467876, 123, '2015-04-01 00:39:19.000000', 'consum', 0.0229, 'lps'),
	(467877, 123, '2015-04-01 00:39:20.000000', 'consum', 0.0223, 'lps'),
	(467878, 123, '2015-04-01 00:39:21.000000', 'consum', 0.0221, 'lps'),
	(467879, 123, '2015-04-01 00:39:22.000000', 'consum', 0.0224, 'lps'),
	(467880, 123, '2015-04-01 00:39:23.000000', 'consum', 0.0221, 'lps'),
	(467881, 123, '2015-04-01 00:39:24.000000', 'consum', 0.0222, 'lps'),
	(467882, 123, '2015-04-01 00:39:25.000000', 'consum', 0.0212, 'lps'),
	(467883, 123, '2015-04-01 00:39:26.000000', 'consum', 0.0210, 'lps'),
	(467884, 123, '2015-04-01 00:39:27.000000', 'consum', 0.0235, 'lps'),
	(467885, 123, '2015-04-01 00:39:28.000000', 'consum', 0.0221, 'lps'),
	(467886, 123, '2015-04-01 00:39:29.000000', 'consum', 0.0219, 'lps'),
	(467887, 123, '2015-04-01 00:39:30.000000', 'consum', 0.0224, 'lps'),
	(467888, 123, '2015-04-01 00:39:31.000000', 'consum', 0.0225, 'lps'),
	(467889, 123, '2015-04-01 00:39:32.000000', 'consum', 0.0215, 'lps'),
	(467890, 123, '2015-04-01 00:39:33.000000', 'consum', 0.0218, 'lps'),
	(467891, 123, '2015-04-01 00:39:34.000000', 'consum', 0.0235, 'lps'),
	(467892, 123, '2015-04-01 00:39:35.000000', 'consum', 0.0228, 'lps'),
	(467893, 123, '2015-04-01 00:39:36.000000', 'consum', 0.0226, 'lps'),
	(467894, 123, '2015-04-01 00:39:37.000000', 'consum', 0.0236, 'lps'),
	(467895, 123, '2015-04-01 00:39:38.000000', 'consum', 0.0210, 'lps'),
	(467896, 123, '2015-04-01 00:39:39.000000', 'consum', 0.0215, 'lps'),
	(467897, 123, '2015-04-01 00:39:40.000000', 'consum', 0.0210, 'lps'),
	(467898, 123, '2015-04-01 00:39:41.000000', 'consum', 0.0222, 'lps'),
	(467899, 123, '2015-04-01 00:39:42.000000', 'consum', 0.0213, 'lps'),
	(467900, 123, '2015-04-01 00:39:43.000000', 'consum', 0.0217, 'lps'),
	(467901, 123, '2015-04-01 00:39:44.000000', 'consum', 0.0236, 'lps'),
	(467902, 123, '2015-04-01 00:39:45.000000', 'consum', 0.0211, 'lps'),
	(467903, 123, '2015-04-01 00:39:46.000000', 'consum', 0.0218, 'lps'),
	(467904, 123, '2015-04-01 00:39:47.000000', 'consum', 0.0221, 'lps'),
	(467905, 123, '2015-04-01 00:39:48.000000', 'consum', 0.0212, 'lps'),
	(467906, 123, '2015-04-01 00:39:49.000000', 'consum', 0.0216, 'lps'),
	(467907, 123, '2015-04-01 00:39:50.000000', 'consum', 0.0235, 'lps'),
	(467908, 123, '2015-04-01 00:39:51.000000', 'consum', 0.0234, 'lps'),
	(467909, 123, '2015-04-01 00:39:52.000000', 'consum', 0.0228, 'lps'),
	(467910, 123, '2015-04-01 00:39:53.000000', 'consum', 0.0228, 'lps'),
	(467911, 123, '2015-04-01 00:39:54.000000', 'consum', 0.0217, 'lps'),
	(467912, 123, '2015-04-01 00:39:55.000000', 'consum', 0.0219, 'lps'),
	(467913, 123, '2015-04-01 00:39:56.000000', 'consum', 0.0237, 'lps'),
	(467914, 123, '2015-04-01 00:39:57.000000', 'consum', 0.0232, 'lps'),
	(467915, 123, '2015-04-01 00:39:58.000000', 'consum', 0.0210, 'lps'),
	(467916, 123, '2015-04-01 00:39:59.000000', 'consum', 0.0232, 'lps'),
	(467917, 123, '2015-04-01 00:40:00.000000', 'consum', 0.0235, 'lps'),
	(467918, 123, '2015-04-01 00:40:01.000000', 'consum', 0.0214, 'lps'),
	(467919, 123, '2015-04-01 00:40:02.000000', 'consum', 0.0211, 'lps'),
	(467920, 123, '2015-04-01 00:40:03.000000', 'consum', 0.0231, 'lps'),
	(467921, 123, '2015-04-01 00:40:04.000000', 'consum', 0.0227, 'lps'),
	(467922, 123, '2015-04-01 00:40:05.000000', 'consum', 0.0233, 'lps'),
	(467923, 123, '2015-04-01 00:40:06.000000', 'consum', 0.0221, 'lps'),
	(467924, 123, '2015-04-01 00:40:07.000000', 'consum', 0.0224, 'lps'),
	(467925, 123, '2015-04-01 00:40:08.000000', 'consum', 0.0219, 'lps'),
	(467926, 123, '2015-04-01 00:40:09.000000', 'consum', 0.0215, 'lps'),
	(467927, 123, '2015-04-01 00:40:10.000000', 'consum', 0.0235, 'lps'),
	(467928, 123, '2015-04-01 00:40:11.000000', 'consum', 0.0236, 'lps'),
	(467929, 123, '2015-04-01 00:40:12.000000', 'consum', 0.0211, 'lps'),
	(467930, 123, '2015-04-01 00:40:13.000000', 'consum', 0.0219, 'lps'),
	(467931, 123, '2015-04-01 00:40:14.000000', 'consum', 0.0227, 'lps'),
	(467932, 123, '2015-04-01 00:40:15.000000', 'consum', 0.0214, 'lps'),
	(467933, 123, '2015-04-01 00:40:16.000000', 'consum', 0.0233, 'lps'),
	(467934, 123, '2015-04-01 00:40:17.000000', 'consum', 0.0230, 'lps'),
	(467935, 123, '2015-04-01 00:40:18.000000', 'consum', 0.0213, 'lps'),
	(467936, 123, '2015-04-01 00:40:19.000000', 'consum', 0.0223, 'lps'),
	(467937, 123, '2015-04-01 00:40:20.000000', 'consum', 0.0210, 'lps'),
	(467938, 123, '2015-04-01 00:40:21.000000', 'consum', 0.0227, 'lps'),
	(467939, 123, '2015-04-01 00:40:22.000000', 'consum', 0.0212, 'lps'),
	(467940, 123, '2015-04-01 00:40:23.000000', 'consum', 0.0225, 'lps'),
	(467941, 123, '2015-04-01 00:40:24.000000', 'consum', 0.0225, 'lps'),
	(467942, 123, '2015-04-01 00:40:25.000000', 'consum', 0.0213, 'lps'),
	(467943, 123, '2015-04-01 00:40:26.000000', 'consum', 0.0236, 'lps'),
	(467944, 123, '2015-04-01 00:40:27.000000', 'consum', 0.0218, 'lps'),
	(467945, 123, '2015-04-01 00:40:28.000000', 'consum', 0.0229, 'lps'),
	(467946, 123, '2015-04-01 00:40:29.000000', 'consum', 0.0226, 'lps'),
	(467947, 123, '2015-04-01 00:40:30.000000', 'consum', 0.0234, 'lps'),
	(467948, 123, '2015-04-01 00:40:31.000000', 'consum', 0.0226, 'lps'),
	(467949, 123, '2015-04-01 00:40:32.000000', 'consum', 0.0218, 'lps'),
	(467950, 123, '2015-04-01 00:40:33.000000', 'consum', 0.0232, 'lps'),
	(467951, 123, '2015-04-01 00:40:34.000000', 'consum', 0.0213, 'lps'),
	(467952, 123, '2015-04-01 00:40:35.000000', 'consum', 0.0213, 'lps'),
	(467953, 123, '2015-04-01 00:40:36.000000', 'consum', 0.0219, 'lps'),
	(467954, 123, '2015-04-01 00:40:37.000000', 'consum', 0.0217, 'lps'),
	(467955, 123, '2015-04-01 00:40:38.000000', 'consum', 0.0219, 'lps'),
	(467956, 123, '2015-04-01 00:40:39.000000', 'consum', 0.0234, 'lps'),
	(467957, 123, '2015-04-01 00:40:40.000000', 'consum', 0.0221, 'lps'),
	(467958, 123, '2015-04-01 00:40:41.000000', 'consum', 0.0221, 'lps'),
	(467959, 123, '2015-04-01 00:40:42.000000', 'consum', 0.0231, 'lps'),
	(467960, 123, '2015-04-01 00:40:43.000000', 'consum', 0.0229, 'lps'),
	(467961, 123, '2015-04-01 00:40:44.000000', 'consum', 0.0214, 'lps'),
	(467962, 123, '2015-04-01 00:40:45.000000', 'consum', 0.0229, 'lps'),
	(467963, 123, '2015-04-01 00:40:46.000000', 'consum', 0.0237, 'lps'),
	(467964, 123, '2015-04-01 00:40:47.000000', 'consum', 0.0232, 'lps'),
	(467965, 123, '2015-04-01 00:40:48.000000', 'consum', 0.0211, 'lps'),
	(467966, 123, '2015-04-01 00:40:49.000000', 'consum', 0.0233, 'lps'),
	(467967, 123, '2015-04-01 00:40:50.000000', 'consum', 0.0213, 'lps'),
	(467968, 123, '2015-04-01 00:40:51.000000', 'consum', 0.0237, 'lps'),
	(467969, 123, '2015-04-01 00:40:52.000000', 'consum', 0.0227, 'lps'),
	(467970, 123, '2015-04-01 00:40:53.000000', 'consum', 0.0215, 'lps'),
	(467971, 123, '2015-04-01 00:40:54.000000', 'consum', 0.0210, 'lps'),
	(467972, 123, '2015-04-01 00:40:55.000000', 'consum', 0.0227, 'lps'),
	(467973, 123, '2015-04-01 00:40:56.000000', 'consum', 0.0236, 'lps'),
	(467974, 123, '2015-04-01 00:40:57.000000', 'consum', 0.0236, 'lps'),
	(467975, 123, '2015-04-01 00:40:58.000000', 'consum', 0.0232, 'lps'),
	(467976, 123, '2015-04-01 00:40:59.000000', 'consum', 0.0214, 'lps'),
	(467977, 123, '2015-04-01 00:41:00.000000', 'consum', 0.0223, 'lps'),
	(467978, 123, '2015-04-01 00:41:01.000000', 'consum', 0.0234, 'lps'),
	(467979, 123, '2015-04-01 00:41:02.000000', 'consum', 0.0235, 'lps'),
	(467980, 123, '2015-04-01 00:41:03.000000', 'consum', 0.0237, 'lps'),
	(467981, 123, '2015-04-01 00:41:04.000000', 'consum', 0.0215, 'lps'),
	(467982, 123, '2015-04-01 00:41:05.000000', 'consum', 0.0210, 'lps'),
	(467983, 123, '2015-04-01 00:41:06.000000', 'consum', 0.0221, 'lps'),
	(467984, 123, '2015-04-01 00:41:07.000000', 'consum', 0.0212, 'lps'),
	(467985, 123, '2015-04-01 00:41:08.000000', 'consum', 0.0214, 'lps'),
	(467986, 123, '2015-04-01 00:41:09.000000', 'consum', 0.0227, 'lps'),
	(467987, 123, '2015-04-01 00:41:10.000000', 'consum', 0.0225, 'lps'),
	(467988, 123, '2015-04-01 00:41:11.000000', 'consum', 0.0237, 'lps'),
	(467989, 123, '2015-04-01 00:41:12.000000', 'consum', 0.0217, 'lps'),
	(467990, 123, '2015-04-01 00:41:13.000000', 'consum', 0.0218, 'lps'),
	(467991, 123, '2015-04-01 00:41:14.000000', 'consum', 0.0232, 'lps'),
	(467992, 123, '2015-04-01 00:41:15.000000', 'consum', 0.0211, 'lps'),
	(467993, 123, '2015-04-01 00:41:16.000000', 'consum', 0.0232, 'lps'),
	(467994, 123, '2015-04-01 00:41:17.000000', 'consum', 0.0234, 'lps'),
	(467995, 123, '2015-04-01 00:41:18.000000', 'consum', 0.0210, 'lps'),
	(467996, 123, '2015-04-01 00:41:19.000000', 'consum', 0.0221, 'lps'),
	(467997, 123, '2015-04-01 00:41:20.000000', 'consum', 0.0210, 'lps'),
	(467998, 123, '2015-04-01 00:41:21.000000', 'consum', 0.0234, 'lps'),
	(467999, 123, '2015-04-01 00:41:22.000000', 'consum', 0.0219, 'lps'),
	(468000, 123, '2015-04-01 00:41:23.000000', 'consum', 0.0212, 'lps'),
	(468001, 123, '2015-04-01 00:41:24.000000', 'consum', 0.0219, 'lps'),
	(468002, 123, '2015-04-01 00:41:25.000000', 'consum', 0.0224, 'lps'),
	(468003, 123, '2015-04-01 00:41:26.000000', 'consum', 0.0226, 'lps'),
	(468004, 123, '2015-04-01 00:41:27.000000', 'consum', 0.0220, 'lps'),
	(468005, 123, '2015-04-01 00:41:28.000000', 'consum', 0.0211, 'lps'),
	(468006, 123, '2015-04-01 00:41:29.000000', 'consum', 0.0216, 'lps'),
	(468007, 123, '2015-04-01 00:41:30.000000', 'consum', 0.0210, 'lps'),
	(468008, 123, '2015-04-01 00:41:31.000000', 'consum', 0.0220, 'lps'),
	(468009, 123, '2015-04-01 00:41:32.000000', 'consum', 0.0233, 'lps'),
	(468010, 123, '2015-04-01 00:41:33.000000', 'consum', 0.0212, 'lps'),
	(468011, 123, '2015-04-01 00:41:34.000000', 'consum', 0.0234, 'lps'),
	(468012, 123, '2015-04-01 00:41:35.000000', 'consum', 0.0213, 'lps'),
	(468013, 123, '2015-04-01 00:41:36.000000', 'consum', 0.0210, 'lps'),
	(468014, 123, '2015-04-01 00:41:37.000000', 'consum', 0.0229, 'lps'),
	(468015, 123, '2015-04-01 00:41:38.000000', 'consum', 0.0222, 'lps'),
	(468016, 123, '2015-04-01 00:41:39.000000', 'consum', 0.0215, 'lps'),
	(468017, 123, '2015-04-01 00:41:40.000000', 'consum', 0.0226, 'lps'),
	(468018, 123, '2015-04-01 00:41:41.000000', 'consum', 0.0222, 'lps'),
	(468019, 123, '2015-04-01 00:41:42.000000', 'consum', 0.0219, 'lps'),
	(468020, 123, '2015-04-01 00:41:43.000000', 'consum', 0.0220, 'lps'),
	(468021, 123, '2015-04-01 00:41:44.000000', 'consum', 0.0236, 'lps'),
	(468022, 123, '2015-04-01 00:41:45.000000', 'consum', 0.0225, 'lps'),
	(468023, 123, '2015-04-01 00:41:46.000000', 'consum', 0.0210, 'lps'),
	(468024, 123, '2015-04-01 00:41:47.000000', 'consum', 0.0219, 'lps'),
	(468025, 123, '2015-04-01 00:41:48.000000', 'consum', 0.0226, 'lps'),
	(468026, 123, '2015-04-01 00:41:49.000000', 'consum', 0.0237, 'lps'),
	(468027, 123, '2015-04-01 00:41:50.000000', 'consum', 0.0212, 'lps'),
	(468028, 123, '2015-04-01 00:41:51.000000', 'consum', 0.0225, 'lps'),
	(468029, 123, '2015-04-01 00:41:52.000000', 'consum', 0.0223, 'lps'),
	(468030, 123, '2015-04-01 00:41:53.000000', 'consum', 0.0231, 'lps'),
	(468031, 123, '2015-04-01 00:41:54.000000', 'consum', 0.0222, 'lps'),
	(468032, 123, '2015-04-01 00:41:55.000000', 'consum', 0.0236, 'lps'),
	(468033, 123, '2015-04-01 00:41:56.000000', 'consum', 0.0217, 'lps'),
	(468034, 123, '2015-04-01 00:41:57.000000', 'consum', 0.0227, 'lps'),
	(468035, 123, '2015-04-01 00:41:58.000000', 'consum', 0.0216, 'lps'),
	(468036, 123, '2015-04-01 00:41:59.000000', 'consum', 0.0220, 'lps'),
	(468037, 123, '2015-04-01 00:42:00.000000', 'consum', 0.0212, 'lps'),
	(468038, 123, '2015-04-01 00:42:01.000000', 'consum', 0.0219, 'lps'),
	(468039, 123, '2015-04-01 00:42:02.000000', 'consum', 0.0222, 'lps'),
	(468040, 123, '2015-04-01 00:42:03.000000', 'consum', 0.0213, 'lps'),
	(468041, 123, '2015-04-01 00:42:04.000000', 'consum', 0.0221, 'lps'),
	(468042, 123, '2015-04-01 00:42:05.000000', 'consum', 0.0226, 'lps'),
	(468043, 123, '2015-04-01 00:42:06.000000', 'consum', 0.0228, 'lps'),
	(468044, 123, '2015-04-01 00:42:07.000000', 'consum', 0.0228, 'lps'),
	(468045, 123, '2015-04-01 00:42:08.000000', 'consum', 0.0217, 'lps'),
	(468046, 123, '2015-04-01 00:42:09.000000', 'consum', 0.0221, 'lps'),
	(468047, 123, '2015-04-01 00:42:10.000000', 'consum', 0.0214, 'lps'),
	(468048, 123, '2015-04-01 00:42:11.000000', 'consum', 0.0226, 'lps'),
	(468049, 123, '2015-04-01 00:42:12.000000', 'consum', 0.0222, 'lps'),
	(468050, 123, '2015-04-01 00:42:13.000000', 'consum', 0.0223, 'lps'),
	(468051, 123, '2015-04-01 00:42:14.000000', 'consum', 0.0213, 'lps'),
	(468052, 123, '2015-04-01 00:42:15.000000', 'consum', 0.0213, 'lps'),
	(468053, 123, '2015-04-01 00:42:16.000000', 'consum', 0.0218, 'lps'),
	(468054, 123, '2015-04-01 00:42:17.000000', 'consum', 0.0211, 'lps'),
	(468055, 123, '2015-04-01 00:42:18.000000', 'consum', 0.0220, 'lps'),
	(468056, 123, '2015-04-01 00:42:19.000000', 'consum', 0.0231, 'lps'),
	(468057, 123, '2015-04-01 00:42:20.000000', 'consum', 0.0229, 'lps'),
	(468058, 123, '2015-04-01 00:42:21.000000', 'consum', 0.0215, 'lps'),
	(468059, 123, '2015-04-01 00:42:22.000000', 'consum', 0.0235, 'lps'),
	(468060, 123, '2015-04-01 00:42:23.000000', 'consum', 0.0237, 'lps'),
	(468061, 123, '2015-04-01 00:42:24.000000', 'consum', 0.0212, 'lps'),
	(468062, 123, '2015-04-01 00:42:25.000000', 'consum', 0.0223, 'lps'),
	(468063, 123, '2015-04-01 00:42:26.000000', 'consum', 0.0214, 'lps'),
	(468064, 123, '2015-04-01 00:42:27.000000', 'consum', 0.0218, 'lps'),
	(468065, 123, '2015-04-01 00:42:28.000000', 'consum', 0.0212, 'lps'),
	(468066, 123, '2015-04-01 00:42:29.000000', 'consum', 0.0224, 'lps'),
	(468067, 123, '2015-04-01 00:42:30.000000', 'consum', 0.0219, 'lps'),
	(468068, 123, '2015-04-01 00:42:31.000000', 'consum', 0.0211, 'lps'),
	(468069, 123, '2015-04-01 00:42:32.000000', 'consum', 0.0219, 'lps'),
	(468070, 123, '2015-04-01 00:42:33.000000', 'consum', 0.0225, 'lps'),
	(468071, 123, '2015-04-01 00:42:34.000000', 'consum', 0.0229, 'lps'),
	(468072, 123, '2015-04-01 00:42:35.000000', 'consum', 0.0231, 'lps'),
	(468073, 123, '2015-04-01 00:42:36.000000', 'consum', 0.0232, 'lps'),
	(468074, 123, '2015-04-01 00:42:37.000000', 'consum', 0.0230, 'lps'),
	(468075, 123, '2015-04-01 00:42:38.000000', 'consum', 0.0217, 'lps'),
	(468076, 123, '2015-04-01 00:42:39.000000', 'consum', 0.0214, 'lps'),
	(468077, 123, '2015-04-01 00:42:40.000000', 'consum', 0.0211, 'lps'),
	(468078, 123, '2015-04-01 00:42:41.000000', 'consum', 0.0229, 'lps'),
	(468079, 123, '2015-04-01 00:42:42.000000', 'consum', 0.0218, 'lps'),
	(468080, 123, '2015-04-01 00:42:43.000000', 'consum', 0.0220, 'lps'),
	(468081, 123, '2015-04-01 00:42:44.000000', 'consum', 0.0212, 'lps'),
	(468082, 123, '2015-04-01 00:42:45.000000', 'consum', 0.0216, 'lps'),
	(468083, 123, '2015-04-01 00:42:46.000000', 'consum', 0.0235, 'lps'),
	(468084, 123, '2015-04-01 00:42:47.000000', 'consum', 0.0233, 'lps'),
	(468085, 123, '2015-04-01 00:42:48.000000', 'consum', 0.0224, 'lps'),
	(468086, 123, '2015-04-01 00:42:49.000000', 'consum', 0.0213, 'lps'),
	(468087, 123, '2015-04-01 00:42:50.000000', 'consum', 0.0237, 'lps'),
	(468088, 123, '2015-04-01 00:42:51.000000', 'consum', 0.0226, 'lps'),
	(468089, 123, '2015-04-01 00:42:52.000000', 'consum', 0.0236, 'lps'),
	(468090, 123, '2015-04-01 00:42:53.000000', 'consum', 0.0235, 'lps'),
	(468091, 123, '2015-04-01 00:42:54.000000', 'consum', 0.0232, 'lps'),
	(468092, 123, '2015-04-01 00:42:55.000000', 'consum', 0.0218, 'lps'),
	(468093, 123, '2015-04-01 00:42:56.000000', 'consum', 0.0214, 'lps'),
	(468094, 123, '2015-04-01 00:42:57.000000', 'consum', 0.0232, 'lps'),
	(468095, 123, '2015-04-01 00:42:58.000000', 'consum', 0.0225, 'lps'),
	(468096, 123, '2015-04-01 00:42:59.000000', 'consum', 0.0220, 'lps'),
	(468097, 123, '2015-04-01 00:43:00.000000', 'consum', 0.0214, 'lps'),
	(468098, 123, '2015-04-01 00:43:01.000000', 'consum', 0.0230, 'lps'),
	(468099, 123, '2015-04-01 00:43:02.000000', 'consum', 0.0214, 'lps'),
	(468100, 123, '2015-04-01 00:43:03.000000', 'consum', 0.0227, 'lps'),
	(468101, 123, '2015-04-01 00:43:04.000000', 'consum', 0.0227, 'lps'),
	(468102, 123, '2015-04-01 00:43:05.000000', 'consum', 0.0218, 'lps'),
	(468103, 123, '2015-04-01 00:43:06.000000', 'consum', 0.0228, 'lps'),
	(468104, 123, '2015-04-01 00:43:07.000000', 'consum', 0.0221, 'lps'),
	(468105, 123, '2015-04-01 00:43:08.000000', 'consum', 0.0210, 'lps'),
	(468106, 123, '2015-04-01 00:43:09.000000', 'consum', 0.0234, 'lps'),
	(468107, 123, '2015-04-01 00:43:10.000000', 'consum', 0.0217, 'lps'),
	(468108, 123, '2015-04-01 00:43:11.000000', 'consum', 0.0231, 'lps'),
	(468109, 123, '2015-04-01 00:43:12.000000', 'consum', 0.0236, 'lps'),
	(468110, 123, '2015-04-01 00:43:13.000000', 'consum', 0.0223, 'lps'),
	(468111, 123, '2015-04-01 00:43:14.000000', 'consum', 0.0228, 'lps'),
	(468112, 123, '2015-04-01 00:43:15.000000', 'consum', 0.0230, 'lps'),
	(468113, 123, '2015-04-01 00:43:16.000000', 'consum', 0.0230, 'lps'),
	(468114, 123, '2015-04-01 00:43:17.000000', 'consum', 0.0221, 'lps'),
	(468115, 123, '2015-04-01 00:43:18.000000', 'consum', 0.0233, 'lps'),
	(468116, 123, '2015-04-01 00:43:19.000000', 'consum', 0.0210, 'lps'),
	(468117, 123, '2015-04-01 00:43:20.000000', 'consum', 0.0225, 'lps'),
	(468118, 123, '2015-04-01 00:43:21.000000', 'consum', 0.0229, 'lps'),
	(468119, 123, '2015-04-01 00:43:22.000000', 'consum', 0.0234, 'lps'),
	(468120, 123, '2015-04-01 00:43:23.000000', 'consum', 0.0218, 'lps'),
	(468121, 123, '2015-04-01 00:43:24.000000', 'consum', 0.0234, 'lps'),
	(468122, 123, '2015-04-01 00:43:25.000000', 'consum', 0.0221, 'lps'),
	(468123, 123, '2015-04-01 00:43:26.000000', 'consum', 0.0221, 'lps'),
	(468124, 123, '2015-04-01 00:43:27.000000', 'consum', 0.0232, 'lps'),
	(468125, 123, '2015-04-01 00:43:28.000000', 'consum', 0.0232, 'lps'),
	(468126, 123, '2015-04-01 00:43:29.000000', 'consum', 0.0225, 'lps'),
	(468127, 123, '2015-04-01 00:43:30.000000', 'consum', 0.0221, 'lps'),
	(468128, 123, '2015-04-01 00:43:31.000000', 'consum', 0.0221, 'lps'),
	(468129, 123, '2015-04-01 00:43:32.000000', 'consum', 0.0233, 'lps'),
	(468130, 123, '2015-04-01 00:43:33.000000', 'consum', 0.0210, 'lps'),
	(468131, 123, '2015-04-01 00:43:34.000000', 'consum', 0.0223, 'lps'),
	(468132, 123, '2015-04-01 00:43:35.000000', 'consum', 0.0220, 'lps'),
	(468133, 123, '2015-04-01 00:43:36.000000', 'consum', 0.0220, 'lps'),
	(468134, 123, '2015-04-01 00:43:37.000000', 'consum', 0.0231, 'lps'),
	(468135, 123, '2015-04-01 00:43:38.000000', 'consum', 0.0228, 'lps'),
	(468136, 123, '2015-04-01 00:43:39.000000', 'consum', 0.0211, 'lps'),
	(468137, 123, '2015-04-01 00:43:40.000000', 'consum', 0.0218, 'lps'),
	(468138, 123, '2015-04-01 00:43:41.000000', 'consum', 0.0219, 'lps'),
	(468139, 123, '2015-04-01 00:43:42.000000', 'consum', 0.0233, 'lps'),
	(468140, 123, '2015-04-01 00:43:43.000000', 'consum', 0.0213, 'lps'),
	(468141, 123, '2015-04-01 00:43:44.000000', 'consum', 0.0213, 'lps'),
	(468142, 123, '2015-04-01 00:43:45.000000', 'consum', 0.0218, 'lps'),
	(468143, 123, '2015-04-01 00:43:46.000000', 'consum', 0.0210, 'lps'),
	(468144, 123, '2015-04-01 00:43:47.000000', 'consum', 0.0218, 'lps'),
	(468145, 123, '2015-04-01 00:43:48.000000', 'consum', 0.0221, 'lps'),
	(468146, 123, '2015-04-01 00:43:49.000000', 'consum', 0.0213, 'lps'),
	(468147, 123, '2015-04-01 00:43:50.000000', 'consum', 0.0220, 'lps'),
	(468148, 123, '2015-04-01 00:43:51.000000', 'consum', 0.0226, 'lps'),
	(468149, 123, '2015-04-01 00:43:52.000000', 'consum', 0.0229, 'lps'),
	(468150, 123, '2015-04-01 00:43:53.000000', 'consum', 0.0233, 'lps'),
	(468151, 123, '2015-04-01 00:43:54.000000', 'consum', 0.0212, 'lps'),
	(468152, 123, '2015-04-01 00:43:55.000000', 'consum', 0.0234, 'lps'),
	(468153, 123, '2015-04-01 00:43:56.000000', 'consum', 0.0212, 'lps'),
	(468154, 123, '2015-04-01 00:43:57.000000', 'consum', 0.0232, 'lps'),
	(468155, 123, '2015-04-01 00:43:58.000000', 'consum', 0.0232, 'lps'),
	(468156, 123, '2015-04-01 00:43:59.000000', 'consum', 0.0225, 'lps'),
	(468157, 123, '2015-04-01 00:44:00.000000', 'consum', 0.0222, 'lps'),
	(468158, 123, '2015-04-01 00:44:01.000000', 'consum', 0.0225, 'lps'),
	(468159, 123, '2015-04-01 00:44:02.000000', 'consum', 0.0219, 'lps'),
	(468160, 123, '2015-04-01 00:44:03.000000', 'consum', 0.0213, 'lps'),
	(468161, 123, '2015-04-01 00:44:04.000000', 'consum', 0.0226, 'lps'),
	(468162, 123, '2015-04-01 00:44:05.000000', 'consum', 0.0226, 'lps'),
	(468163, 123, '2015-04-01 00:44:06.000000', 'consum', 0.0215, 'lps'),
	(468164, 123, '2015-04-01 00:44:07.000000', 'consum', 0.0217, 'lps'),
	(468165, 123, '2015-04-01 00:44:08.000000', 'consum', 0.0227, 'lps'),
	(468166, 123, '2015-04-01 00:44:09.000000', 'consum', 0.0220, 'lps'),
	(468167, 123, '2015-04-01 00:44:10.000000', 'consum', 0.0210, 'lps'),
	(468168, 123, '2015-04-01 00:44:11.000000', 'consum', 0.0237, 'lps'),
	(468169, 123, '2015-04-01 00:44:12.000000', 'consum', 0.0234, 'lps'),
	(468170, 123, '2015-04-01 00:44:13.000000', 'consum', 0.0219, 'lps'),
	(468171, 123, '2015-04-01 00:44:14.000000', 'consum', 0.0211, 'lps'),
	(468172, 123, '2015-04-01 00:44:15.000000', 'consum', 0.0220, 'lps'),
	(468173, 123, '2015-04-01 00:44:16.000000', 'consum', 0.0227, 'lps'),
	(468174, 123, '2015-04-01 00:44:17.000000', 'consum', 0.0211, 'lps'),
	(468175, 123, '2015-04-01 00:44:18.000000', 'consum', 0.0219, 'lps'),
	(468176, 123, '2015-04-01 00:44:19.000000', 'consum', 0.0224, 'lps'),
	(468177, 123, '2015-04-01 00:44:20.000000', 'consum', 0.0225, 'lps'),
	(468178, 123, '2015-04-01 00:44:21.000000', 'consum', 0.0216, 'lps'),
	(468179, 123, '2015-04-01 00:44:22.000000', 'consum', 0.0224, 'lps'),
	(468180, 123, '2015-04-01 00:44:23.000000', 'consum', 0.0234, 'lps'),
	(468181, 123, '2015-04-01 00:44:24.000000', 'consum', 0.0231, 'lps'),
	(468182, 123, '2015-04-01 00:44:25.000000', 'consum', 0.0216, 'lps'),
	(468183, 123, '2015-04-01 00:44:26.000000', 'consum', 0.0234, 'lps'),
	(468184, 123, '2015-04-01 00:44:27.000000', 'consum', 0.0227, 'lps'),
	(468185, 123, '2015-04-01 00:44:28.000000', 'consum', 0.0224, 'lps'),
	(468186, 123, '2015-04-01 00:44:29.000000', 'consum', 0.0231, 'lps'),
	(468187, 123, '2015-04-01 00:44:30.000000', 'consum', 0.0216, 'lps'),
	(468188, 123, '2015-04-01 00:44:31.000000', 'consum', 0.0236, 'lps'),
	(468189, 123, '2015-04-01 00:44:32.000000', 'consum', 0.0235, 'lps'),
	(468190, 123, '2015-04-01 00:44:33.000000', 'consum', 0.0233, 'lps'),
	(468191, 123, '2015-04-01 00:44:34.000000', 'consum', 0.0221, 'lps'),
	(468192, 123, '2015-04-01 00:44:35.000000', 'consum', 0.0225, 'lps'),
	(468193, 123, '2015-04-01 00:44:36.000000', 'consum', 0.0223, 'lps'),
	(468194, 123, '2015-04-01 00:44:37.000000', 'consum', 0.0233, 'lps'),
	(468195, 123, '2015-04-01 00:44:38.000000', 'consum', 0.0228, 'lps'),
	(468196, 123, '2015-04-01 00:44:39.000000', 'consum', 0.0231, 'lps'),
	(468197, 123, '2015-04-01 00:44:40.000000', 'consum', 0.0234, 'lps'),
	(468198, 123, '2015-04-01 00:44:41.000000', 'consum', 0.0212, 'lps'),
	(468199, 123, '2015-04-01 00:44:42.000000', 'consum', 0.0231, 'lps'),
	(468200, 123, '2015-04-01 00:44:43.000000', 'consum', 0.0228, 'lps'),
	(468201, 123, '2015-04-01 00:44:44.000000', 'consum', 0.0236, 'lps'),
	(468202, 123, '2015-04-01 00:44:45.000000', 'consum', 0.0232, 'lps'),
	(468203, 123, '2015-04-01 00:44:46.000000', 'consum', 0.0214, 'lps'),
	(468204, 123, '2015-04-01 00:44:47.000000', 'consum', 0.0221, 'lps'),
	(468205, 123, '2015-04-01 00:44:48.000000', 'consum', 0.0223, 'lps'),
	(468206, 123, '2015-04-01 00:44:49.000000', 'consum', 0.0217, 'lps'),
	(468207, 123, '2015-04-01 00:44:50.000000', 'consum', 0.0232, 'lps'),
	(468208, 123, '2015-04-01 00:44:51.000000', 'consum', 0.0218, 'lps'),
	(468209, 123, '2015-04-01 00:44:52.000000', 'consum', 0.0211, 'lps'),
	(468210, 123, '2015-04-01 00:44:53.000000', 'consum', 0.0221, 'lps'),
	(468211, 123, '2015-04-01 00:44:54.000000', 'consum', 0.0232, 'lps'),
	(468212, 123, '2015-04-01 00:44:55.000000', 'consum', 0.0232, 'lps'),
	(468213, 123, '2015-04-01 00:44:56.000000', 'consum', 0.0228, 'lps'),
	(468214, 123, '2015-04-01 00:44:57.000000', 'consum', 0.0236, 'lps'),
	(468215, 123, '2015-04-01 00:44:58.000000', 'consum', 0.0228, 'lps'),
	(468216, 123, '2015-04-01 00:44:59.000000', 'consum', 0.0222, 'lps'),
	(468217, 123, '2015-04-01 00:45:00.000000', 'consum', 0.0217, 'lps'),
	(468218, 123, '2015-04-01 00:45:01.000000', 'consum', 0.0212, 'lps'),
	(468219, 123, '2015-04-01 00:45:02.000000', 'consum', 0.0224, 'lps'),
	(468220, 123, '2015-04-01 00:45:03.000000', 'consum', 0.0221, 'lps'),
	(468221, 123, '2015-04-01 00:45:04.000000', 'consum', 0.0222, 'lps'),
	(468222, 123, '2015-04-01 00:45:05.000000', 'consum', 0.0237, 'lps'),
	(468223, 123, '2015-04-01 00:45:06.000000', 'consum', 0.0227, 'lps'),
	(468224, 123, '2015-04-01 00:45:07.000000', 'consum', 0.0212, 'lps'),
	(468225, 123, '2015-04-01 00:45:08.000000', 'consum', 0.0226, 'lps'),
	(468226, 123, '2015-04-01 00:45:09.000000', 'consum', 0.0230, 'lps'),
	(468227, 123, '2015-04-01 00:45:10.000000', 'consum', 0.0232, 'lps'),
	(468228, 123, '2015-04-01 00:45:11.000000', 'consum', 0.0234, 'lps'),
	(468229, 123, '2015-04-01 00:45:12.000000', 'consum', 0.0235, 'lps'),
	(468230, 123, '2015-04-01 00:45:13.000000', 'consum', 0.0235, 'lps'),
	(468231, 123, '2015-04-01 00:45:14.000000', 'consum', 0.0235, 'lps'),
	(468232, 123, '2015-04-01 00:45:15.000000', 'consum', 0.0234, 'lps'),
	(468233, 123, '2015-04-01 00:45:16.000000', 'consum', 0.0224, 'lps'),
	(468234, 123, '2015-04-01 00:45:17.000000', 'consum', 0.0237, 'lps'),
	(468235, 123, '2015-04-01 00:45:18.000000', 'consum', 0.0218, 'lps'),
	(468236, 123, '2015-04-01 00:45:19.000000', 'consum', 0.0229, 'lps'),
	(468237, 123, '2015-04-01 00:45:20.000000', 'consum', 0.0223, 'lps'),
	(468238, 123, '2015-04-01 00:45:21.000000', 'consum', 0.0221, 'lps'),
	(468239, 123, '2015-04-01 00:45:22.000000', 'consum', 0.0225, 'lps'),
	(468240, 123, '2015-04-01 00:45:23.000000', 'consum', 0.0223, 'lps'),
	(468241, 123, '2015-04-01 00:45:24.000000', 'consum', 0.0233, 'lps'),
	(468242, 123, '2015-04-01 00:45:25.000000', 'consum', 0.0230, 'lps'),
	(468243, 123, '2015-04-01 00:45:26.000000', 'consum', 0.0211, 'lps'),
	(468244, 123, '2015-04-01 00:45:27.000000', 'consum', 0.0215, 'lps'),
	(468245, 123, '2015-04-01 00:45:28.000000', 'consum', 0.0230, 'lps'),
	(468246, 123, '2015-04-01 00:45:29.000000', 'consum', 0.0211, 'lps'),
	(468247, 123, '2015-04-01 00:45:30.000000', 'consum', 0.0214, 'lps'),
	(468248, 123, '2015-04-01 00:45:31.000000', 'consum', 0.0228, 'lps'),
	(468249, 123, '2015-04-01 00:45:32.000000', 'consum', 0.0233, 'lps'),
	(468250, 123, '2015-04-01 00:45:33.000000', 'consum', 0.0216, 'lps'),
	(468251, 123, '2015-04-01 00:45:34.000000', 'consum', 0.0226, 'lps'),
	(468252, 123, '2015-04-01 00:45:35.000000', 'consum', 0.0216, 'lps'),
	(468253, 123, '2015-04-01 00:45:36.000000', 'consum', 0.0221, 'lps'),
	(468254, 123, '2015-04-01 00:45:37.000000', 'consum', 0.0219, 'lps'),
	(468255, 123, '2015-04-01 00:45:38.000000', 'consum', 0.0224, 'lps'),
	(468256, 123, '2015-04-01 00:45:39.000000', 'consum', 0.0223, 'lps'),
	(468257, 123, '2015-04-01 00:45:40.000000', 'consum', 0.0235, 'lps'),
	(468258, 123, '2015-04-01 00:45:41.000000', 'consum', 0.0214, 'lps'),
	(468259, 123, '2015-04-01 00:45:42.000000', 'consum', 0.0237, 'lps'),
	(468260, 123, '2015-04-01 00:45:43.000000', 'consum', 0.0223, 'lps'),
	(468261, 123, '2015-04-01 00:45:44.000000', 'consum', 0.0220, 'lps'),
	(468262, 123, '2015-04-01 00:45:45.000000', 'consum', 0.0224, 'lps'),
	(468263, 123, '2015-04-01 00:45:46.000000', 'consum', 0.0224, 'lps'),
	(468264, 123, '2015-04-01 00:45:47.000000', 'consum', 0.0236, 'lps'),
	(468265, 123, '2015-04-01 00:45:48.000000', 'consum', 0.0214, 'lps'),
	(468266, 123, '2015-04-01 00:45:49.000000', 'consum', 0.0210, 'lps'),
	(468267, 123, '2015-04-01 00:45:50.000000', 'consum', 0.0226, 'lps'),
	(468268, 123, '2015-04-01 00:45:51.000000', 'consum', 0.0233, 'lps'),
	(468269, 123, '2015-04-01 00:45:52.000000', 'consum', 0.0222, 'lps'),
	(468270, 123, '2015-04-01 00:45:53.000000', 'consum', 0.0228, 'lps'),
	(468271, 123, '2015-04-01 00:45:54.000000', 'consum', 0.0210, 'lps'),
	(468272, 123, '2015-04-01 00:45:55.000000', 'consum', 0.0212, 'lps'),
	(468273, 123, '2015-04-01 00:45:56.000000', 'consum', 0.0220, 'lps'),
	(468274, 123, '2015-04-01 00:45:57.000000', 'consum', 0.0228, 'lps'),
	(468275, 123, '2015-04-01 00:45:58.000000', 'consum', 0.0215, 'lps'),
	(468276, 123, '2015-04-01 00:45:59.000000', 'consum', 0.0236, 'lps'),
	(468277, 123, '2015-04-01 00:46:00.000000', 'consum', 0.0213, 'lps'),
	(468278, 123, '2015-04-01 00:46:01.000000', 'consum', 0.0230, 'lps'),
	(468279, 123, '2015-04-01 00:46:02.000000', 'consum', 0.0220, 'lps'),
	(468280, 123, '2015-04-01 00:46:03.000000', 'consum', 0.0230, 'lps'),
	(468281, 123, '2015-04-01 00:46:04.000000', 'consum', 0.0222, 'lps'),
	(468282, 123, '2015-04-01 00:46:05.000000', 'consum', 0.0210, 'lps'),
	(468283, 123, '2015-04-01 00:46:06.000000', 'consum', 0.0233, 'lps'),
	(468284, 123, '2015-04-01 00:46:07.000000', 'consum', 0.0214, 'lps'),
	(468285, 123, '2015-04-01 00:46:08.000000', 'consum', 0.0215, 'lps'),
	(468286, 123, '2015-04-01 00:46:09.000000', 'consum', 0.0223, 'lps'),
	(468287, 123, '2015-04-01 00:46:10.000000', 'consum', 0.0233, 'lps'),
	(468288, 123, '2015-04-01 00:46:11.000000', 'consum', 0.0233, 'lps'),
	(468289, 123, '2015-04-01 00:46:12.000000', 'consum', 0.0225, 'lps'),
	(468290, 123, '2015-04-01 00:46:13.000000', 'consum', 0.0218, 'lps'),
	(468291, 123, '2015-04-01 00:46:14.000000', 'consum', 0.0235, 'lps'),
	(468292, 123, '2015-04-01 00:46:15.000000', 'consum', 0.0228, 'lps'),
	(468293, 123, '2015-04-01 00:46:16.000000', 'consum', 0.0225, 'lps'),
	(468294, 123, '2015-04-01 00:46:17.000000', 'consum', 0.0230, 'lps'),
	(468295, 123, '2015-04-01 00:46:18.000000', 'consum', 0.0210, 'lps'),
	(468296, 123, '2015-04-01 00:46:19.000000', 'consum', 0.0236, 'lps'),
	(468297, 123, '2015-04-01 00:46:20.000000', 'consum', 0.0229, 'lps'),
	(468298, 123, '2015-04-01 00:46:21.000000', 'consum', 0.0225, 'lps'),
	(468299, 123, '2015-04-01 00:46:22.000000', 'consum', 0.0229, 'lps'),
	(468300, 123, '2015-04-01 00:46:23.000000', 'consum', 0.0235, 'lps'),
	(468301, 123, '2015-04-01 00:46:24.000000', 'consum', 0.0221, 'lps'),
	(468302, 123, '2015-04-01 00:46:25.000000', 'consum', 0.0217, 'lps'),
	(468303, 123, '2015-04-01 00:46:26.000000', 'consum', 0.0212, 'lps'),
	(468304, 123, '2015-04-01 00:46:27.000000', 'consum', 0.0229, 'lps'),
	(468305, 123, '2015-04-01 00:46:28.000000', 'consum', 0.0214, 'lps'),
	(468306, 123, '2015-04-01 00:46:29.000000', 'consum', 0.0229, 'lps'),
	(468307, 123, '2015-04-01 00:46:30.000000', 'consum', 0.0210, 'lps'),
	(468308, 123, '2015-04-01 00:46:31.000000', 'consum', 0.0210, 'lps'),
	(468309, 123, '2015-04-01 00:46:32.000000', 'consum', 0.0236, 'lps'),
	(468310, 123, '2015-04-01 00:46:33.000000', 'consum', 0.0232, 'lps'),
	(468311, 123, '2015-04-01 00:46:34.000000', 'consum', 0.0214, 'lps'),
	(468312, 123, '2015-04-01 00:46:35.000000', 'consum', 0.0220, 'lps'),
	(468313, 123, '2015-04-01 00:46:36.000000', 'consum', 0.0222, 'lps'),
	(468314, 123, '2015-04-01 00:46:37.000000', 'consum', 0.0211, 'lps'),
	(468315, 123, '2015-04-01 00:46:38.000000', 'consum', 0.0236, 'lps'),
	(468316, 123, '2015-04-01 00:46:39.000000', 'consum', 0.0224, 'lps'),
	(468317, 123, '2015-04-01 00:46:40.000000', 'consum', 0.0233, 'lps'),
	(468318, 123, '2015-04-01 00:46:41.000000', 'consum', 0.0226, 'lps'),
	(468319, 123, '2015-04-01 00:46:42.000000', 'consum', 0.0220, 'lps'),
	(468320, 123, '2015-04-01 00:46:43.000000', 'consum', 0.0214, 'lps'),
	(468321, 123, '2015-04-01 00:46:44.000000', 'consum', 0.0227, 'lps'),
	(468322, 123, '2015-04-01 00:46:45.000000', 'consum', 0.0229, 'lps'),
	(468323, 123, '2015-04-01 00:46:46.000000', 'consum', 0.0227, 'lps'),
	(468324, 123, '2015-04-01 00:46:47.000000', 'consum', 0.0237, 'lps'),
	(468325, 123, '2015-04-01 00:46:48.000000', 'consum', 0.0210, 'lps'),
	(468326, 123, '2015-04-01 00:46:49.000000', 'consum', 0.0214, 'lps'),
	(468327, 123, '2015-04-01 00:46:50.000000', 'consum', 0.0232, 'lps'),
	(468328, 123, '2015-04-01 00:46:51.000000', 'consum', 0.0224, 'lps'),
	(468329, 123, '2015-04-01 00:46:52.000000', 'consum', 0.0215, 'lps'),
	(468330, 123, '2015-04-01 00:46:53.000000', 'consum', 0.0219, 'lps'),
	(468331, 123, '2015-04-01 00:46:54.000000', 'consum', 0.0214, 'lps'),
	(468332, 123, '2015-04-01 00:46:55.000000', 'consum', 0.0231, 'lps'),
	(468333, 123, '2015-04-01 00:46:56.000000', 'consum', 0.0218, 'lps'),
	(468334, 123, '2015-04-01 00:46:57.000000', 'consum', 0.0215, 'lps'),
	(468335, 123, '2015-04-01 00:46:58.000000', 'consum', 0.0213, 'lps'),
	(468336, 123, '2015-04-01 00:46:59.000000', 'consum', 0.0212, 'lps'),
	(468337, 123, '2015-04-01 00:47:00.000000', 'consum', 0.0237, 'lps'),
	(468338, 123, '2015-04-01 00:47:01.000000', 'consum', 0.0230, 'lps'),
	(468339, 123, '2015-04-01 00:47:02.000000', 'consum', 0.0228, 'lps'),
	(468340, 123, '2015-04-01 00:47:03.000000', 'consum', 0.0211, 'lps'),
	(468341, 123, '2015-04-01 00:47:04.000000', 'consum', 0.0218, 'lps'),
	(468342, 123, '2015-04-01 00:47:05.000000', 'consum', 0.0221, 'lps'),
	(468343, 123, '2015-04-01 00:47:06.000000', 'consum', 0.0212, 'lps'),
	(468344, 123, '2015-04-01 00:47:07.000000', 'consum', 0.0215, 'lps'),
	(468345, 123, '2015-04-01 00:47:08.000000', 'consum', 0.0228, 'lps'),
	(468346, 123, '2015-04-01 00:47:09.000000', 'consum', 0.0232, 'lps'),
	(468347, 123, '2015-04-01 00:47:10.000000', 'consum', 0.0211, 'lps'),
	(468348, 123, '2015-04-01 00:47:11.000000', 'consum', 0.0234, 'lps'),
	(468349, 123, '2015-04-01 00:47:12.000000', 'consum', 0.0216, 'lps'),
	(468350, 123, '2015-04-01 00:47:13.000000', 'consum', 0.0222, 'lps'),
	(468351, 123, '2015-04-01 00:47:14.000000', 'consum', 0.0227, 'lps'),
	(468352, 123, '2015-04-01 00:47:15.000000', 'consum', 0.0230, 'lps'),
	(468353, 123, '2015-04-01 00:47:16.000000', 'consum', 0.0234, 'lps'),
	(468354, 123, '2015-04-01 00:47:17.000000', 'consum', 0.0212, 'lps'),
	(468355, 123, '2015-04-01 00:47:18.000000', 'consum', 0.0231, 'lps'),
	(468356, 123, '2015-04-01 00:47:19.000000', 'consum', 0.0228, 'lps'),
	(468357, 123, '2015-04-01 00:47:20.000000', 'consum', 0.0211, 'lps'),
	(468358, 123, '2015-04-01 00:47:21.000000', 'consum', 0.0215, 'lps'),
	(468359, 123, '2015-04-01 00:47:22.000000', 'consum', 0.0232, 'lps'),
	(468360, 123, '2015-04-01 00:47:23.000000', 'consum', 0.0224, 'lps'),
	(468361, 123, '2015-04-01 00:47:24.000000', 'consum', 0.0215, 'lps'),
	(468362, 123, '2015-04-01 00:47:25.000000', 'consum', 0.0219, 'lps'),
	(468363, 123, '2015-04-01 00:47:26.000000', 'consum', 0.0213, 'lps'),
	(468364, 123, '2015-04-01 00:47:27.000000', 'consum', 0.0228, 'lps'),
	(468365, 123, '2015-04-01 00:47:28.000000', 'consum', 0.0233, 'lps'),
	(468366, 123, '2015-04-01 00:47:29.000000', 'consum', 0.0218, 'lps'),
	(468367, 123, '2015-04-01 00:47:30.000000', 'consum', 0.0236, 'lps'),
	(468368, 123, '2015-04-01 00:47:31.000000', 'consum', 0.0235, 'lps'),
	(468369, 123, '2015-04-01 00:47:32.000000', 'consum', 0.0227, 'lps'),
	(468370, 123, '2015-04-01 00:47:33.000000', 'consum', 0.0221, 'lps'),
	(468371, 123, '2015-04-01 00:47:34.000000', 'consum', 0.0213, 'lps'),
	(468372, 123, '2015-04-01 00:47:35.000000', 'consum', 0.0222, 'lps'),
	(468373, 123, '2015-04-01 00:47:36.000000', 'consum', 0.0233, 'lps'),
	(468374, 123, '2015-04-01 00:47:37.000000', 'consum', 0.0235, 'lps'),
	(468375, 123, '2015-04-01 00:47:38.000000', 'consum', 0.0210, 'lps'),
	(468376, 123, '2015-04-01 00:47:39.000000', 'consum', 0.0221, 'lps'),
	(468377, 123, '2015-04-01 00:47:40.000000', 'consum', 0.0236, 'lps'),
	(468378, 123, '2015-04-01 00:47:41.000000', 'consum', 0.0225, 'lps'),
	(468379, 123, '2015-04-01 00:47:42.000000', 'consum', 0.0236, 'lps'),
	(468380, 123, '2015-04-01 00:47:43.000000', 'consum', 0.0237, 'lps'),
	(468381, 123, '2015-04-01 00:47:44.000000', 'consum', 0.0214, 'lps'),
	(468382, 123, '2015-04-01 00:47:45.000000', 'consum', 0.0234, 'lps'),
	(468383, 123, '2015-04-01 00:47:46.000000', 'consum', 0.0235, 'lps'),
	(468384, 123, '2015-04-01 00:47:47.000000', 'consum', 0.0237, 'lps'),
	(468385, 123, '2015-04-01 00:47:48.000000', 'consum', 0.0211, 'lps'),
	(468386, 123, '2015-04-01 00:47:49.000000', 'consum', 0.0218, 'lps'),
	(468387, 123, '2015-04-01 00:47:50.000000', 'consum', 0.0220, 'lps'),
	(468388, 123, '2015-04-01 00:47:51.000000', 'consum', 0.0235, 'lps'),
	(468389, 123, '2015-04-01 00:47:52.000000', 'consum', 0.0224, 'lps'),
	(468390, 123, '2015-04-01 00:47:53.000000', 'consum', 0.0231, 'lps'),
	(468391, 123, '2015-04-01 00:47:54.000000', 'consum', 0.0218, 'lps'),
	(468392, 123, '2015-04-01 00:47:55.000000', 'consum', 0.0218, 'lps'),
	(468393, 123, '2015-04-01 00:47:56.000000', 'consum', 0.0223, 'lps'),
	(468394, 123, '2015-04-01 00:47:57.000000', 'consum', 0.0225, 'lps'),
	(468395, 123, '2015-04-01 00:47:58.000000', 'consum', 0.0219, 'lps'),
	(468396, 123, '2015-04-01 00:47:59.000000', 'consum', 0.0211, 'lps'),
	(468397, 123, '2015-04-01 00:48:00.000000', 'consum', 0.0216, 'lps'),
	(468398, 123, '2015-04-01 00:48:01.000000', 'consum', 0.0210, 'lps'),
	(468399, 123, '2015-04-01 00:48:02.000000', 'consum', 0.0220, 'lps'),
	(468400, 123, '2015-04-01 00:48:03.000000', 'consum', 0.0233, 'lps'),
	(468401, 123, '2015-04-01 00:48:04.000000', 'consum', 0.0237, 'lps'),
	(468402, 123, '2015-04-01 00:48:05.000000', 'consum', 0.0224, 'lps'),
	(468403, 123, '2015-04-01 00:48:06.000000', 'consum', 0.0226, 'lps'),
	(468404, 123, '2015-04-01 00:48:07.000000', 'consum', 0.0222, 'lps'),
	(468405, 123, '2015-04-01 00:48:08.000000', 'consum', 0.0221, 'lps'),
	(468406, 123, '2015-04-01 00:48:09.000000', 'consum', 0.0228, 'lps'),
	(468407, 123, '2015-04-01 00:48:10.000000', 'consum', 0.0215, 'lps'),
	(468408, 123, '2015-04-01 00:48:11.000000', 'consum', 0.0235, 'lps'),
	(468409, 123, '2015-04-01 00:48:12.000000', 'consum', 0.0210, 'lps'),
	(468410, 123, '2015-04-01 00:48:13.000000', 'consum', 0.0220, 'lps'),
	(468411, 123, '2015-04-01 00:48:14.000000', 'consum', 0.0230, 'lps'),
	(468412, 123, '2015-04-01 00:48:15.000000', 'consum', 0.0225, 'lps'),
	(468413, 123, '2015-04-01 00:48:16.000000', 'consum', 0.0224, 'lps'),
	(468414, 123, '2015-04-01 00:48:17.000000', 'consum', 0.0211, 'lps'),
	(468415, 123, '2015-04-01 00:48:18.000000', 'consum', 0.0227, 'lps'),
	(468416, 123, '2015-04-01 00:48:19.000000', 'consum', 0.0235, 'lps'),
	(468417, 123, '2015-04-01 00:48:20.000000', 'consum', 0.0232, 'lps'),
	(468418, 123, '2015-04-01 00:48:21.000000', 'consum', 0.0214, 'lps'),
	(468419, 123, '2015-04-01 00:48:22.000000', 'consum', 0.0224, 'lps'),
	(468420, 123, '2015-04-01 00:48:23.000000', 'consum', 0.0210, 'lps'),
	(468421, 123, '2015-04-01 00:48:24.000000', 'consum', 0.0225, 'lps'),
	(468422, 123, '2015-04-01 00:48:25.000000', 'consum', 0.0231, 'lps'),
	(468423, 123, '2015-04-01 00:48:26.000000', 'consum', 0.0213, 'lps'),
	(468424, 123, '2015-04-01 00:48:27.000000', 'consum', 0.0220, 'lps'),
	(468425, 123, '2015-04-01 00:48:28.000000', 'consum', 0.0223, 'lps'),
	(468426, 123, '2015-04-01 00:48:29.000000', 'consum', 0.0218, 'lps'),
	(468427, 123, '2015-04-01 00:48:30.000000', 'consum', 0.0212, 'lps'),
	(468428, 123, '2015-04-01 00:48:31.000000', 'consum', 0.0226, 'lps'),
	(468429, 123, '2015-04-01 00:48:32.000000', 'consum', 0.0226, 'lps'),
	(468430, 123, '2015-04-01 00:48:33.000000', 'consum', 0.0216, 'lps'),
	(468431, 123, '2015-04-01 00:48:34.000000', 'consum', 0.0218, 'lps'),
	(468432, 123, '2015-04-01 00:48:35.000000', 'consum', 0.0235, 'lps'),
	(468433, 123, '2015-04-01 00:48:36.000000', 'consum', 0.0227, 'lps'),
	(468434, 123, '2015-04-01 00:48:37.000000', 'consum', 0.0222, 'lps'),
	(468435, 123, '2015-04-01 00:48:38.000000', 'consum', 0.0220, 'lps'),
	(468436, 123, '2015-04-01 00:48:39.000000', 'consum', 0.0222, 'lps'),
	(468437, 123, '2015-04-01 00:48:40.000000', 'consum', 0.0212, 'lps'),
	(468438, 123, '2015-04-01 00:48:41.000000', 'consum', 0.0213, 'lps'),
	(468439, 123, '2015-04-01 00:48:42.000000', 'consum', 0.0221, 'lps'),
	(468440, 123, '2015-04-01 00:48:43.000000', 'consum', 0.0228, 'lps'),
	(468441, 123, '2015-04-01 00:48:44.000000', 'consum', 0.0211, 'lps'),
	(468442, 123, '2015-04-01 00:48:45.000000', 'consum', 0.0220, 'lps'),
	(468443, 123, '2015-04-01 00:48:46.000000', 'consum', 0.0226, 'lps'),
	(468444, 123, '2015-04-01 00:48:47.000000', 'consum', 0.0235, 'lps'),
	(468445, 123, '2015-04-01 00:48:48.000000', 'consum', 0.0230, 'lps'),
	(468446, 123, '2015-04-01 00:48:49.000000', 'consum', 0.0237, 'lps'),
	(468447, 123, '2015-04-01 00:48:50.000000', 'consum', 0.0227, 'lps'),
	(468448, 123, '2015-04-01 00:48:51.000000', 'consum', 0.0215, 'lps'),
	(468449, 123, '2015-04-01 00:48:52.000000', 'consum', 0.0213, 'lps'),
	(468450, 123, '2015-04-01 00:48:53.000000', 'consum', 0.0237, 'lps'),
	(468451, 123, '2015-04-01 00:48:54.000000', 'consum', 0.0224, 'lps'),
	(468452, 123, '2015-04-01 00:48:55.000000', 'consum', 0.0228, 'lps'),
	(468453, 123, '2015-04-01 00:48:56.000000', 'consum', 0.0232, 'lps'),
	(468454, 123, '2015-04-01 00:48:57.000000', 'consum', 0.0237, 'lps'),
	(468455, 123, '2015-04-01 00:48:58.000000', 'consum', 0.0222, 'lps'),
	(468456, 123, '2015-04-01 00:48:59.000000', 'consum', 0.0219, 'lps'),
	(468457, 123, '2015-04-01 00:49:00.000000', 'consum', 0.0219, 'lps'),
	(468458, 123, '2015-04-01 00:49:01.000000', 'consum', 0.0230, 'lps'),
	(468459, 123, '2015-04-01 00:49:02.000000', 'consum', 0.0228, 'lps'),
	(468460, 123, '2015-04-01 00:49:03.000000', 'consum', 0.0212, 'lps'),
	(468461, 123, '2015-04-01 00:49:04.000000', 'consum', 0.0221, 'lps'),
	(468462, 123, '2015-04-01 00:49:05.000000', 'consum', 0.0231, 'lps'),
	(468463, 123, '2015-04-01 00:49:06.000000', 'consum', 0.0226, 'lps'),
	(468464, 123, '2015-04-01 00:49:07.000000', 'consum', 0.0228, 'lps'),
	(468465, 123, '2015-04-01 00:49:08.000000', 'consum', 0.0226, 'lps'),
	(468466, 123, '2015-04-01 00:49:09.000000', 'consum', 0.0236, 'lps'),
	(468467, 123, '2015-04-01 00:49:10.000000', 'consum', 0.0237, 'lps'),
	(468468, 123, '2015-04-01 00:49:11.000000', 'consum', 0.0213, 'lps'),
	(468469, 123, '2015-04-01 00:49:12.000000', 'consum', 0.0227, 'lps'),
	(468470, 123, '2015-04-01 00:49:13.000000', 'consum', 0.0232, 'lps'),
	(468471, 123, '2015-04-01 00:49:14.000000', 'consum', 0.0214, 'lps'),
	(468472, 123, '2015-04-01 00:49:15.000000', 'consum', 0.0221, 'lps'),
	(468473, 123, '2015-04-01 00:49:16.000000', 'consum', 0.0223, 'lps'),
	(468474, 123, '2015-04-01 00:49:17.000000', 'consum', 0.0214, 'lps'),
	(468475, 123, '2015-04-01 00:49:18.000000', 'consum', 0.0221, 'lps'),
	(468476, 123, '2015-04-01 00:49:19.000000', 'consum', 0.0225, 'lps'),
	(468477, 123, '2015-04-01 00:49:20.000000', 'consum', 0.0224, 'lps'),
	(468478, 123, '2015-04-01 00:49:21.000000', 'consum', 0.0234, 'lps'),
	(468479, 123, '2015-04-01 00:49:22.000000', 'consum', 0.0233, 'lps'),
	(468480, 123, '2015-04-01 00:49:23.000000', 'consum', 0.0226, 'lps'),
	(468481, 123, '2015-04-01 00:49:24.000000', 'consum', 0.0223, 'lps'),
	(468482, 123, '2015-04-01 00:49:25.000000', 'consum', 0.0226, 'lps'),
	(468483, 123, '2015-04-01 00:49:26.000000', 'consum', 0.0223, 'lps'),
	(468484, 123, '2015-04-01 00:49:27.000000', 'consum', 0.0229, 'lps'),
	(468485, 123, '2015-04-01 00:49:28.000000', 'consum', 0.0237, 'lps'),
	(468486, 123, '2015-04-01 00:49:29.000000', 'consum', 0.0235, 'lps'),
	(468487, 123, '2015-04-01 00:49:30.000000', 'consum', 0.0225, 'lps'),
	(468488, 123, '2015-04-01 00:49:31.000000', 'consum', 0.0211, 'lps'),
	(468489, 123, '2015-04-01 00:49:32.000000', 'consum', 0.0226, 'lps'),
	(468490, 123, '2015-04-01 00:49:33.000000', 'consum', 0.0232, 'lps'),
	(468491, 123, '2015-04-01 00:49:34.000000', 'consum', 0.0216, 'lps'),
	(468492, 123, '2015-04-01 00:49:35.000000', 'consum', 0.0231, 'lps'),
	(468493, 123, '2015-04-01 00:49:36.000000', 'consum', 0.0214, 'lps'),
	(468494, 123, '2015-04-01 00:49:37.000000', 'consum', 0.0224, 'lps'),
	(468495, 123, '2015-04-01 00:49:38.000000', 'consum', 0.0210, 'lps'),
	(468496, 123, '2015-04-01 00:49:39.000000', 'consum', 0.0227, 'lps'),
	(468497, 123, '2015-04-01 00:49:40.000000', 'consum', 0.0237, 'lps'),
	(468498, 123, '2015-04-01 00:49:41.000000', 'consum', 0.0211, 'lps'),
	(468499, 123, '2015-04-01 00:49:42.000000', 'consum', 0.0217, 'lps'),
	(468500, 123, '2015-04-01 00:49:43.000000', 'consum', 0.0218, 'lps'),
	(468501, 123, '2015-04-01 00:49:44.000000', 'consum', 0.0226, 'lps'),
	(468502, 123, '2015-04-01 00:49:45.000000', 'consum', 0.0213, 'lps'),
	(468503, 123, '2015-04-01 00:49:46.000000', 'consum', 0.0233, 'lps'),
	(468504, 123, '2015-04-01 00:49:47.000000', 'consum', 0.0231, 'lps'),
	(468505, 123, '2015-04-01 00:49:48.000000', 'consum', 0.0218, 'lps'),
	(468506, 123, '2015-04-01 00:49:49.000000', 'consum', 0.0217, 'lps'),
	(468507, 123, '2015-04-01 00:49:50.000000', 'consum', 0.0222, 'lps'),
	(468508, 123, '2015-04-01 00:49:51.000000', 'consum', 0.0222, 'lps'),
	(468509, 123, '2015-04-01 00:49:52.000000', 'consum', 0.0234, 'lps'),
	(468510, 123, '2015-04-01 00:49:53.000000', 'consum', 0.0212, 'lps'),
	(468511, 123, '2015-04-01 00:49:54.000000', 'consum', 0.0232, 'lps'),
	(468512, 123, '2015-04-01 00:49:55.000000', 'consum', 0.0230, 'lps'),
	(468513, 123, '2015-04-01 00:49:56.000000', 'consum', 0.0218, 'lps'),
	(468514, 123, '2015-04-01 00:49:57.000000', 'consum', 0.0217, 'lps'),
	(468515, 123, '2015-04-01 00:49:58.000000', 'consum', 0.0224, 'lps'),
	(468516, 123, '2015-04-01 00:49:59.000000', 'consum', 0.0229, 'lps'),
	(468517, 123, '2015-04-01 00:50:00.000000', 'consum', 0.0237, 'lps'),
	(468518, 123, '2015-04-01 00:50:01.000000', 'consum', 0.0233, 'lps'),
	(468519, 123, '2015-04-01 00:50:02.000000', 'consum', 0.0216, 'lps'),
	(468520, 123, '2015-04-01 00:50:03.000000', 'consum', 0.0228, 'lps'),
	(468521, 123, '2015-04-01 00:50:04.000000', 'consum', 0.0227, 'lps'),
	(468522, 123, '2015-04-01 00:50:05.000000', 'consum', 0.0212, 'lps'),
	(468523, 123, '2015-04-01 00:50:06.000000', 'consum', 0.0226, 'lps'),
	(468524, 123, '2015-04-01 00:50:07.000000', 'consum', 0.0230, 'lps'),
	(468525, 123, '2015-04-01 00:50:08.000000', 'consum', 0.0235, 'lps'),
	(468526, 123, '2015-04-01 00:50:09.000000', 'consum', 0.0217, 'lps'),
	(468527, 123, '2015-04-01 00:50:10.000000', 'consum', 0.0226, 'lps'),
	(468528, 123, '2015-04-01 00:50:11.000000', 'consum', 0.0214, 'lps'),
	(468529, 123, '2015-04-01 00:50:12.000000', 'consum', 0.0211, 'lps'),
	(468530, 123, '2015-04-01 00:50:13.000000', 'consum', 0.0231, 'lps'),
	(468531, 123, '2015-04-01 00:50:14.000000', 'consum', 0.0227, 'lps'),
	(468532, 123, '2015-04-01 00:50:15.000000', 'consum', 0.0234, 'lps'),
	(468533, 123, '2015-04-01 00:50:16.000000', 'consum', 0.0224, 'lps'),
	(468534, 123, '2015-04-01 00:50:17.000000', 'consum', 0.0237, 'lps'),
	(468535, 123, '2015-04-01 00:50:18.000000', 'consum', 0.0219, 'lps'),
	(468536, 123, '2015-04-01 00:50:19.000000', 'consum', 0.0228, 'lps'),
	(468537, 123, '2015-04-01 00:50:20.000000', 'consum', 0.0221, 'lps'),
	(468538, 123, '2015-04-01 00:50:21.000000', 'consum', 0.0237, 'lps'),
	(468539, 123, '2015-04-01 00:50:22.000000', 'consum', 0.0231, 'lps'),
	(468540, 123, '2015-04-01 00:50:23.000000', 'consum', 0.0234, 'lps'),
	(468541, 123, '2015-04-01 00:50:24.000000', 'consum', 0.0212, 'lps'),
	(468542, 123, '2015-04-01 00:50:25.000000', 'consum', 0.0233, 'lps'),
	(468543, 123, '2015-04-01 00:50:26.000000', 'consum', 0.0235, 'lps'),
	(468544, 123, '2015-04-01 00:50:27.000000', 'consum', 0.0210, 'lps'),
	(468545, 123, '2015-04-01 00:50:28.000000', 'consum', 0.0220, 'lps'),
	(468546, 123, '2015-04-01 00:50:29.000000', 'consum', 0.0232, 'lps'),
	(468547, 123, '2015-04-01 00:50:30.000000', 'consum', 0.0233, 'lps'),
	(468548, 123, '2015-04-01 00:50:31.000000', 'consum', 0.0232, 'lps'),
	(468549, 123, '2015-04-01 00:50:32.000000', 'consum', 0.0225, 'lps'),
	(468550, 123, '2015-04-01 00:50:33.000000', 'consum', 0.0220, 'lps'),
	(468551, 123, '2015-04-01 00:50:34.000000', 'consum', 0.0217, 'lps'),
	(468552, 123, '2015-04-01 00:50:35.000000', 'consum', 0.0213, 'lps'),
	(468553, 123, '2015-04-01 00:50:36.000000', 'consum', 0.0232, 'lps'),
	(468554, 123, '2015-04-01 00:50:37.000000', 'consum', 0.0230, 'lps'),
	(468555, 123, '2015-04-01 00:50:38.000000', 'consum', 0.0217, 'lps'),
	(468556, 123, '2015-04-01 00:50:39.000000', 'consum', 0.0211, 'lps'),
	(468557, 123, '2015-04-01 00:50:40.000000', 'consum', 0.0223, 'lps'),
	(468558, 123, '2015-04-01 00:50:41.000000', 'consum', 0.0215, 'lps'),
	(468559, 123, '2015-04-01 00:50:42.000000', 'consum', 0.0227, 'lps'),
	(468560, 123, '2015-04-01 00:50:43.000000', 'consum', 0.0225, 'lps'),
	(468561, 123, '2015-04-01 00:50:44.000000', 'consum', 0.0234, 'lps'),
	(468562, 123, '2015-04-01 00:50:45.000000', 'consum', 0.0228, 'lps'),
	(468563, 123, '2015-04-01 00:50:46.000000', 'consum', 0.0229, 'lps'),
	(468564, 123, '2015-04-01 00:50:47.000000', 'consum', 0.0226, 'lps'),
	(468565, 123, '2015-04-01 00:50:48.000000', 'consum', 0.0230, 'lps'),
	(468566, 123, '2015-04-01 00:50:49.000000', 'consum', 0.0235, 'lps'),
	(468567, 123, '2015-04-01 00:50:50.000000', 'consum', 0.0220, 'lps'),
	(468568, 123, '2015-04-01 00:50:51.000000', 'consum', 0.0212, 'lps'),
	(468569, 123, '2015-04-01 00:50:52.000000', 'consum', 0.0222, 'lps'),
	(468570, 123, '2015-04-01 00:50:53.000000', 'consum', 0.0234, 'lps'),
	(468571, 123, '2015-04-01 00:50:54.000000', 'consum', 0.0237, 'lps'),
	(468572, 123, '2015-04-01 00:50:55.000000', 'consum', 0.0220, 'lps'),
	(468573, 123, '2015-04-01 00:50:56.000000', 'consum', 0.0235, 'lps'),
	(468574, 123, '2015-04-01 00:50:57.000000', 'consum', 0.0223, 'lps'),
	(468575, 123, '2015-04-01 00:50:58.000000', 'consum', 0.0226, 'lps'),
	(468576, 123, '2015-04-01 00:50:59.000000', 'consum', 0.0226, 'lps'),
	(468577, 123, '2015-04-01 00:51:00.000000', 'consum', 0.0213, 'lps'),
	(468578, 124, '2015-04-01 00:00:00.000000', 'consum', 0.0229, 'lps'),
	(468579, 124, '2015-04-01 00:00:01.000000', 'consum', 0.0215, 'lps'),
	(468580, 124, '2015-04-01 00:00:02.000000', 'consum', 0.0228, 'lps'),
	(468581, 124, '2015-04-01 00:00:03.000000', 'consum', 0.0234, 'lps'),
	(468582, 124, '2015-04-01 00:00:04.000000', 'consum', 0.0227, 'lps'),
	(468583, 124, '2015-04-01 00:00:05.000000', 'consum', 0.0222, 'lps'),
	(468584, 124, '2015-04-01 00:00:06.000000', 'consum', 0.0218, 'lps'),
	(468585, 124, '2015-04-01 00:00:07.000000', 'consum', 0.0217, 'lps'),
	(468586, 124, '2015-04-01 00:00:08.000000', 'consum', 0.0222, 'lps'),
	(468587, 124, '2015-04-01 00:00:09.000000', 'consum', 0.0224, 'lps'),
	(468588, 124, '2015-04-01 00:00:10.000000', 'consum', 0.0217, 'lps'),
	(468589, 124, '2015-04-01 00:00:11.000000', 'consum', 0.0229, 'lps'),
	(468590, 124, '2015-04-01 00:00:12.000000', 'consum', 0.0231, 'lps'),
	(468591, 124, '2015-04-01 00:00:13.000000', 'consum', 0.0210, 'lps'),
	(468592, 124, '2015-04-01 00:00:14.000000', 'consum', 0.0222, 'lps'),
	(468593, 124, '2015-04-01 00:00:15.000000', 'consum', 0.0220, 'lps'),
	(468594, 124, '2015-04-01 00:00:16.000000', 'consum', 0.0223, 'lps'),
	(468595, 124, '2015-04-01 00:00:17.000000', 'consum', 0.0222, 'lps'),
	(468596, 124, '2015-04-01 00:00:18.000000', 'consum', 0.0229, 'lps'),
	(468597, 124, '2015-04-01 00:00:19.000000', 'consum', 0.0219, 'lps'),
	(468598, 124, '2015-04-01 00:00:20.000000', 'consum', 0.0222, 'lps'),
	(468599, 124, '2015-04-01 00:00:21.000000', 'consum', 0.0220, 'lps'),
	(468600, 124, '2015-04-01 00:00:22.000000', 'consum', 0.0224, 'lps'),
	(468601, 124, '2015-04-01 00:00:23.000000', 'consum', 0.0225, 'lps'),
	(468602, 124, '2015-04-01 00:00:24.000000', 'consum', 0.0219, 'lps'),
	(468603, 124, '2015-04-01 00:00:25.000000', 'consum', 0.0210, 'lps'),
	(468604, 124, '2015-04-01 00:00:26.000000', 'consum', 0.0234, 'lps'),
	(468605, 124, '2015-04-01 00:00:27.000000', 'consum', 0.0225, 'lps'),
	(468606, 124, '2015-04-01 00:00:28.000000', 'consum', 0.0216, 'lps'),
	(468607, 124, '2015-04-01 00:00:29.000000', 'consum', 0.0220, 'lps'),
	(468608, 124, '2015-04-01 00:00:30.000000', 'consum', 0.0218, 'lps'),
	(468609, 124, '2015-04-01 00:00:31.000000', 'consum', 0.0220, 'lps'),
	(468610, 124, '2015-04-01 00:00:32.000000', 'consum', 0.0212, 'lps'),
	(468611, 124, '2015-04-01 00:00:33.000000', 'consum', 0.0217, 'lps'),
	(468612, 124, '2015-04-01 00:00:34.000000', 'consum', 0.0211, 'lps'),
	(468613, 124, '2015-04-01 00:00:35.000000', 'consum', 0.0222, 'lps'),
	(468614, 124, '2015-04-01 00:00:36.000000', 'consum', 0.0216, 'lps'),
	(468615, 124, '2015-04-01 00:00:37.000000', 'consum', 0.0229, 'lps'),
	(468616, 124, '2015-04-01 00:00:38.000000', 'consum', 0.0212, 'lps'),
	(468617, 124, '2015-04-01 00:00:39.000000', 'consum', 0.0214, 'lps'),
	(468618, 124, '2015-04-01 00:00:40.000000', 'consum', 0.0224, 'lps'),
	(468619, 124, '2015-04-01 00:00:41.000000', 'consum', 0.0216, 'lps'),
	(468620, 124, '2015-04-01 00:00:42.000000', 'consum', 0.0226, 'lps'),
	(468621, 124, '2015-04-01 00:00:43.000000', 'consum', 0.0220, 'lps'),
	(468622, 124, '2015-04-01 00:00:44.000000', 'consum', 0.0212, 'lps'),
	(468623, 124, '2015-04-01 00:00:45.000000', 'consum', 0.0216, 'lps'),
	(468624, 124, '2015-04-01 00:00:46.000000', 'consum', 0.0234, 'lps'),
	(468625, 124, '2015-04-01 00:00:47.000000', 'consum', 0.0235, 'lps'),
	(468626, 124, '2015-04-01 00:00:48.000000', 'consum', 0.0213, 'lps'),
	(468627, 124, '2015-04-01 00:00:49.000000', 'consum', 0.0228, 'lps'),
	(468628, 124, '2015-04-01 00:00:50.000000', 'consum', 0.0215, 'lps'),
	(468629, 124, '2015-04-01 00:00:51.000000', 'consum', 0.0231, 'lps'),
	(468630, 124, '2015-04-01 00:00:52.000000', 'consum', 0.0224, 'lps'),
	(468631, 124, '2015-04-01 00:00:53.000000', 'consum', 0.0217, 'lps'),
	(468632, 124, '2015-04-01 00:00:54.000000', 'consum', 0.0229, 'lps'),
	(468633, 124, '2015-04-01 00:00:55.000000', 'consum', 0.0234, 'lps'),
	(468634, 124, '2015-04-01 00:00:56.000000', 'consum', 0.0222, 'lps'),
	(468635, 124, '2015-04-01 00:00:57.000000', 'consum', 0.0225, 'lps'),
	(468636, 124, '2015-04-01 00:00:58.000000', 'consum', 0.0224, 'lps'),
	(468637, 124, '2015-04-01 00:00:59.000000', 'consum', 0.0233, 'lps'),
	(468638, 124, '2015-04-01 00:01:00.000000', 'consum', 0.0235, 'lps'),
	(468639, 124, '2015-04-01 00:01:01.000000', 'consum', 0.0211, 'lps'),
	(468640, 124, '2015-04-01 00:01:02.000000', 'consum', 0.0218, 'lps'),
	(468641, 124, '2015-04-01 00:01:03.000000', 'consum', 0.0224, 'lps'),
	(468642, 124, '2015-04-01 00:01:04.000000', 'consum', 0.0229, 'lps'),
	(468643, 124, '2015-04-01 00:01:05.000000', 'consum', 0.0211, 'lps'),
	(468644, 124, '2015-04-01 00:01:06.000000', 'consum', 0.0210, 'lps'),
	(468645, 124, '2015-04-01 00:01:07.000000', 'consum', 0.0232, 'lps'),
	(468646, 124, '2015-04-01 00:01:08.000000', 'consum', 0.0219, 'lps'),
	(468647, 124, '2015-04-01 00:01:09.000000', 'consum', 0.0216, 'lps'),
	(468648, 124, '2015-04-01 00:01:10.000000', 'consum', 0.0213, 'lps'),
	(468649, 124, '2015-04-01 00:01:11.000000', 'consum', 0.0232, 'lps'),
	(468650, 124, '2015-04-01 00:01:12.000000', 'consum', 0.0233, 'lps'),
	(468651, 124, '2015-04-01 00:01:13.000000', 'consum', 0.0234, 'lps'),
	(468652, 124, '2015-04-01 00:01:14.000000', 'consum', 0.0211, 'lps'),
	(468653, 124, '2015-04-01 00:01:15.000000', 'consum', 0.0221, 'lps'),
	(468654, 124, '2015-04-01 00:01:16.000000', 'consum', 0.0210, 'lps'),
	(468655, 124, '2015-04-01 00:01:17.000000', 'consum', 0.0231, 'lps'),
	(468656, 124, '2015-04-01 00:01:18.000000', 'consum', 0.0212, 'lps'),
	(468657, 124, '2015-04-01 00:01:19.000000', 'consum', 0.0232, 'lps'),
	(468658, 124, '2015-04-01 00:01:20.000000', 'consum', 0.0214, 'lps'),
	(468659, 124, '2015-04-01 00:01:21.000000', 'consum', 0.0216, 'lps'),
	(468660, 124, '2015-04-01 00:01:22.000000', 'consum', 0.0230, 'lps'),
	(468661, 124, '2015-04-01 00:01:23.000000', 'consum', 0.0212, 'lps'),
	(468662, 124, '2015-04-01 00:01:24.000000', 'consum', 0.0212, 'lps'),
	(468663, 124, '2015-04-01 00:01:25.000000', 'consum', 0.0214, 'lps'),
	(468664, 124, '2015-04-01 00:01:26.000000', 'consum', 0.0223, 'lps'),
	(468665, 124, '2015-04-01 00:01:27.000000', 'consum', 0.0215, 'lps'),
	(468666, 124, '2015-04-01 00:01:28.000000', 'consum', 0.0220, 'lps'),
	(468667, 124, '2015-04-01 00:01:29.000000', 'consum', 0.0221, 'lps'),
	(468668, 124, '2015-04-01 00:01:30.000000', 'consum', 0.0235, 'lps'),
	(468669, 124, '2015-04-01 00:01:31.000000', 'consum', 0.0226, 'lps'),
	(468670, 124, '2015-04-01 00:01:32.000000', 'consum', 0.0215, 'lps'),
	(468671, 124, '2015-04-01 00:01:33.000000', 'consum', 0.0212, 'lps'),
	(468672, 124, '2015-04-01 00:01:34.000000', 'consum', 0.0232, 'lps'),
	(468673, 124, '2015-04-01 00:01:35.000000', 'consum', 0.0210, 'lps'),
	(468674, 124, '2015-04-01 00:01:36.000000', 'consum', 0.0223, 'lps'),
	(468675, 124, '2015-04-01 00:01:37.000000', 'consum', 0.0224, 'lps'),
	(468676, 124, '2015-04-01 00:01:38.000000', 'consum', 0.0213, 'lps'),
	(468677, 124, '2015-04-01 00:01:39.000000', 'consum', 0.0212, 'lps'),
	(468678, 124, '2015-04-01 00:01:40.000000', 'consum', 0.0210, 'lps'),
	(468679, 124, '2015-04-01 00:01:41.000000', 'consum', 0.0230, 'lps'),
	(468680, 124, '2015-04-01 00:01:42.000000', 'consum', 0.0231, 'lps'),
	(468681, 124, '2015-04-01 00:01:43.000000', 'consum', 0.0232, 'lps'),
	(468682, 124, '2015-04-01 00:01:44.000000', 'consum', 0.0230, 'lps'),
	(468683, 124, '2015-04-01 00:01:45.000000', 'consum', 0.0219, 'lps'),
	(468684, 124, '2015-04-01 00:01:46.000000', 'consum', 0.0223, 'lps'),
	(468685, 124, '2015-04-01 00:01:47.000000', 'consum', 0.0220, 'lps'),
	(468686, 124, '2015-04-01 00:01:48.000000', 'consum', 0.0225, 'lps'),
	(468687, 124, '2015-04-01 00:01:49.000000', 'consum', 0.0226, 'lps'),
	(468688, 124, '2015-04-01 00:01:50.000000', 'consum', 0.0220, 'lps'),
	(468689, 124, '2015-04-01 00:01:51.000000', 'consum', 0.0213, 'lps'),
	(468690, 124, '2015-04-01 00:01:52.000000', 'consum', 0.0223, 'lps'),
	(468691, 124, '2015-04-01 00:01:53.000000', 'consum', 0.0214, 'lps'),
	(468692, 124, '2015-04-01 00:01:54.000000', 'consum', 0.0219, 'lps'),
	(468693, 124, '2015-04-01 00:01:55.000000', 'consum', 0.0217, 'lps'),
	(468694, 124, '2015-04-01 00:01:56.000000', 'consum', 0.0216, 'lps'),
	(468695, 124, '2015-04-01 00:01:57.000000', 'consum', 0.0221, 'lps'),
	(468696, 124, '2015-04-01 00:01:58.000000', 'consum', 0.0223, 'lps'),
	(468697, 124, '2015-04-01 00:01:59.000000', 'consum', 0.0213, 'lps'),
	(468698, 124, '2015-04-01 00:02:00.000000', 'consum', 0.0216, 'lps'),
	(468699, 124, '2015-04-01 00:02:01.000000', 'consum', 0.0228, 'lps'),
	(468700, 124, '2015-04-01 00:02:02.000000', 'consum', 0.0233, 'lps'),
	(468701, 124, '2015-04-01 00:02:03.000000', 'consum', 0.0220, 'lps'),
	(468702, 124, '2015-04-01 00:02:04.000000', 'consum', 0.0217, 'lps'),
	(468703, 124, '2015-04-01 00:02:05.000000', 'consum', 0.0216, 'lps'),
	(468704, 124, '2015-04-01 00:02:06.000000', 'consum', 0.0218, 'lps'),
	(468705, 124, '2015-04-01 00:02:07.000000', 'consum', 0.0235, 'lps'),
	(468706, 124, '2015-04-01 00:02:08.000000', 'consum', 0.0230, 'lps'),
	(468707, 124, '2015-04-01 00:02:09.000000', 'consum', 0.0211, 'lps'),
	(468708, 124, '2015-04-01 00:02:10.000000', 'consum', 0.0210, 'lps'),
	(468709, 124, '2015-04-01 00:02:11.000000', 'consum', 0.0230, 'lps'),
	(468710, 124, '2015-04-01 00:02:12.000000', 'consum', 0.0233, 'lps'),
	(468711, 124, '2015-04-01 00:02:13.000000', 'consum', 0.0216, 'lps'),
	(468712, 124, '2015-04-01 00:02:14.000000', 'consum', 0.0223, 'lps'),
	(468713, 124, '2015-04-01 00:02:15.000000', 'consum', 0.0230, 'lps'),
	(468714, 124, '2015-04-01 00:02:16.000000', 'consum', 0.0219, 'lps'),
	(468715, 124, '2015-04-01 00:02:17.000000', 'consum', 0.0222, 'lps'),
	(468716, 124, '2015-04-01 00:02:18.000000', 'consum', 0.0218, 'lps'),
	(468717, 124, '2015-04-01 00:02:19.000000', 'consum', 0.0214, 'lps'),
	(468718, 124, '2015-04-01 00:02:20.000000', 'consum', 0.0233, 'lps'),
	(468719, 124, '2015-04-01 00:02:21.000000', 'consum', 0.0235, 'lps'),
	(468720, 124, '2015-04-01 00:02:22.000000', 'consum', 0.0214, 'lps'),
	(468721, 124, '2015-04-01 00:02:23.000000', 'consum', 0.0234, 'lps'),
	(468722, 124, '2015-04-01 00:02:24.000000', 'consum', 0.0215, 'lps'),
	(468723, 124, '2015-04-01 00:02:25.000000', 'consum', 0.0215, 'lps'),
	(468724, 124, '2015-04-01 00:02:26.000000', 'consum', 0.0221, 'lps'),
	(468725, 124, '2015-04-01 00:02:27.000000', 'consum', 0.0223, 'lps'),
	(468726, 124, '2015-04-01 00:02:28.000000', 'consum', 0.0216, 'lps'),
	(468727, 124, '2015-04-01 00:02:29.000000', 'consum', 0.0229, 'lps'),
	(468728, 124, '2015-04-01 00:02:30.000000', 'consum', 0.0211, 'lps'),
	(468729, 124, '2015-04-01 00:02:31.000000', 'consum', 0.0235, 'lps'),
	(468730, 124, '2015-04-01 00:02:32.000000', 'consum', 0.0227, 'lps'),
	(468731, 124, '2015-04-01 00:02:33.000000', 'consum', 0.0221, 'lps'),
	(468732, 124, '2015-04-01 00:02:34.000000', 'consum', 0.0214, 'lps'),
	(468733, 124, '2015-04-01 00:02:35.000000', 'consum', 0.0224, 'lps'),
	(468734, 124, '2015-04-01 00:02:36.000000', 'consum', 0.0218, 'lps'),
	(468735, 124, '2015-04-01 00:02:37.000000', 'consum', 0.0234, 'lps'),
	(468736, 124, '2015-04-01 00:02:38.000000', 'consum', 0.0229, 'lps'),
	(468737, 124, '2015-04-01 00:02:39.000000', 'consum', 0.0234, 'lps'),
	(468738, 124, '2015-04-01 00:02:40.000000', 'consum', 0.0220, 'lps'),
	(468739, 124, '2015-04-01 00:02:41.000000', 'consum', 0.0214, 'lps'),
	(468740, 124, '2015-04-01 00:02:42.000000', 'consum', 0.0229, 'lps'),
	(468741, 124, '2015-04-01 00:02:43.000000', 'consum', 0.0213, 'lps'),
	(468742, 124, '2015-04-01 00:02:44.000000', 'consum', 0.0220, 'lps'),
	(468743, 124, '2015-04-01 00:02:45.000000', 'consum', 0.0228, 'lps'),
	(468744, 124, '2015-04-01 00:02:46.000000', 'consum', 0.0217, 'lps'),
	(468745, 124, '2015-04-01 00:02:47.000000', 'consum', 0.0219, 'lps'),
	(468746, 124, '2015-04-01 00:02:48.000000', 'consum', 0.0235, 'lps'),
	(468747, 124, '2015-04-01 00:02:49.000000', 'consum', 0.0229, 'lps'),
	(468748, 124, '2015-04-01 00:02:50.000000', 'consum', 0.0229, 'lps'),
	(468749, 124, '2015-04-01 00:02:51.000000', 'consum', 0.0225, 'lps'),
	(468750, 124, '2015-04-01 00:02:52.000000', 'consum', 0.0228, 'lps'),
	(468751, 124, '2015-04-01 00:02:53.000000', 'consum', 0.0229, 'lps'),
	(468752, 124, '2015-04-01 00:02:54.000000', 'consum', 0.0225, 'lps'),
	(468753, 124, '2015-04-01 00:02:55.000000', 'consum', 0.0229, 'lps'),
	(468754, 124, '2015-04-01 00:02:56.000000', 'consum', 0.0210, 'lps'),
	(468755, 124, '2015-04-01 00:02:57.000000', 'consum', 0.0232, 'lps'),
	(468756, 124, '2015-04-01 00:02:58.000000', 'consum', 0.0217, 'lps'),
	(468757, 124, '2015-04-01 00:02:59.000000', 'consum', 0.0231, 'lps'),
	(468758, 124, '2015-04-01 00:03:00.000000', 'consum', 0.0216, 'lps'),
	(468759, 124, '2015-04-01 00:03:01.000000', 'consum', 0.0229, 'lps'),
	(468760, 124, '2015-04-01 00:03:02.000000', 'consum', 0.0235, 'lps'),
	(468761, 124, '2015-04-01 00:03:03.000000', 'consum', 0.0228, 'lps'),
	(468762, 124, '2015-04-01 00:03:04.000000', 'consum', 0.0223, 'lps'),
	(468763, 124, '2015-04-01 00:03:05.000000', 'consum', 0.0225, 'lps'),
	(468764, 124, '2015-04-01 00:03:06.000000', 'consum', 0.0218, 'lps'),
	(468765, 124, '2015-04-01 00:03:07.000000', 'consum', 0.0231, 'lps'),
	(468766, 124, '2015-04-01 00:03:08.000000', 'consum', 0.0213, 'lps'),
	(468767, 124, '2015-04-01 00:03:09.000000', 'consum', 0.0216, 'lps'),
	(468768, 124, '2015-04-01 00:03:10.000000', 'consum', 0.0231, 'lps'),
	(468769, 124, '2015-04-01 00:03:11.000000', 'consum', 0.0221, 'lps'),
	(468770, 124, '2015-04-01 00:03:12.000000', 'consum', 0.0227, 'lps'),
	(468771, 124, '2015-04-01 00:03:13.000000', 'consum', 0.0210, 'lps'),
	(468772, 124, '2015-04-01 00:03:14.000000', 'consum', 0.0211, 'lps'),
	(468773, 124, '2015-04-01 00:03:15.000000', 'consum', 0.0218, 'lps'),
	(468774, 124, '2015-04-01 00:03:16.000000', 'consum', 0.0221, 'lps'),
	(468775, 124, '2015-04-01 00:03:17.000000', 'consum', 0.0213, 'lps'),
	(468776, 124, '2015-04-01 00:03:18.000000', 'consum', 0.0219, 'lps'),
	(468777, 124, '2015-04-01 00:03:19.000000', 'consum', 0.0222, 'lps'),
	(468778, 124, '2015-04-01 00:03:20.000000', 'consum', 0.0219, 'lps'),
	(468779, 124, '2015-04-01 00:03:21.000000', 'consum', 0.0217, 'lps'),
	(468780, 124, '2015-04-01 00:03:22.000000', 'consum', 0.0220, 'lps'),
	(468781, 124, '2015-04-01 00:03:23.000000', 'consum', 0.0211, 'lps'),
	(468782, 124, '2015-04-01 00:03:24.000000', 'consum', 0.0215, 'lps'),
	(468783, 124, '2015-04-01 00:03:25.000000', 'consum', 0.0229, 'lps'),
	(468784, 124, '2015-04-01 00:03:26.000000', 'consum', 0.0214, 'lps'),
	(468785, 124, '2015-04-01 00:03:27.000000', 'consum', 0.0224, 'lps'),
	(468786, 124, '2015-04-01 00:03:28.000000', 'consum', 0.0216, 'lps'),
	(468787, 124, '2015-04-01 00:03:29.000000', 'consum', 0.0227, 'lps'),
	(468788, 124, '2015-04-01 00:03:30.000000', 'consum', 0.0224, 'lps'),
	(468789, 124, '2015-04-01 00:03:31.000000', 'consum', 0.0230, 'lps'),
	(468790, 124, '2015-04-01 00:03:32.000000', 'consum', 0.0218, 'lps'),
	(468791, 124, '2015-04-01 00:03:33.000000', 'consum', 0.0214, 'lps'),
	(468792, 124, '2015-04-01 00:03:34.000000', 'consum', 0.0234, 'lps'),
	(468793, 124, '2015-04-01 00:03:35.000000', 'consum', 0.0214, 'lps'),
	(468794, 124, '2015-04-01 00:03:36.000000', 'consum', 0.0211, 'lps'),
	(468795, 124, '2015-04-01 00:03:37.000000', 'consum', 0.0230, 'lps'),
	(468796, 124, '2015-04-01 00:03:38.000000', 'consum', 0.0228, 'lps'),
	(468797, 124, '2015-04-01 00:03:39.000000', 'consum', 0.0216, 'lps'),
	(468798, 124, '2015-04-01 00:03:40.000000', 'consum', 0.0211, 'lps'),
	(468799, 124, '2015-04-01 00:03:41.000000', 'consum', 0.0226, 'lps'),
	(468800, 124, '2015-04-01 00:03:42.000000', 'consum', 0.0233, 'lps'),
	(468801, 124, '2015-04-01 00:03:43.000000', 'consum', 0.0225, 'lps'),
	(468802, 124, '2015-04-01 00:03:44.000000', 'consum', 0.0217, 'lps'),
	(468803, 124, '2015-04-01 00:03:45.000000', 'consum', 0.0225, 'lps'),
	(468804, 124, '2015-04-01 00:03:46.000000', 'consum', 0.0215, 'lps'),
	(468805, 124, '2015-04-01 00:03:47.000000', 'consum', 0.0217, 'lps'),
	(468806, 124, '2015-04-01 00:03:48.000000', 'consum', 0.0231, 'lps'),
	(468807, 124, '2015-04-01 00:03:49.000000', 'consum', 0.0216, 'lps'),
	(468808, 124, '2015-04-01 00:03:50.000000', 'consum', 0.0231, 'lps'),
	(468809, 124, '2015-04-01 00:03:51.000000', 'consum', 0.0217, 'lps'),
	(468810, 124, '2015-04-01 00:03:52.000000', 'consum', 0.0210, 'lps'),
	(468811, 124, '2015-04-01 00:03:53.000000', 'consum', 0.0217, 'lps'),
	(468812, 124, '2015-04-01 00:03:54.000000', 'consum', 0.0217, 'lps'),
	(468813, 124, '2015-04-01 00:03:55.000000', 'consum', 0.0226, 'lps'),
	(468814, 124, '2015-04-01 00:03:56.000000', 'consum', 0.0215, 'lps'),
	(468815, 124, '2015-04-01 00:03:57.000000', 'consum', 0.0216, 'lps'),
	(468816, 124, '2015-04-01 00:03:58.000000', 'consum', 0.0224, 'lps'),
	(468817, 124, '2015-04-01 00:03:59.000000', 'consum', 0.0211, 'lps'),
	(468818, 124, '2015-04-01 00:04:00.000000', 'consum', 0.0224, 'lps'),
	(468819, 124, '2015-04-01 00:04:01.000000', 'consum', 0.0225, 'lps'),
	(468820, 124, '2015-04-01 00:04:02.000000', 'consum', 0.0218, 'lps'),
	(468821, 124, '2015-04-01 00:04:03.000000', 'consum', 0.0230, 'lps'),
	(468822, 124, '2015-04-01 00:04:04.000000', 'consum', 0.0210, 'lps'),
	(468823, 124, '2015-04-01 00:04:05.000000', 'consum', 0.0230, 'lps'),
	(468824, 124, '2015-04-01 00:04:06.000000', 'consum', 0.0230, 'lps'),
	(468825, 124, '2015-04-01 00:04:07.000000', 'consum', 0.0226, 'lps'),
	(468826, 124, '2015-04-01 00:04:08.000000', 'consum', 0.0232, 'lps'),
	(468827, 124, '2015-04-01 00:04:09.000000', 'consum', 0.0219, 'lps'),
	(468828, 124, '2015-04-01 00:04:10.000000', 'consum', 0.0216, 'lps'),
	(468829, 124, '2015-04-01 00:04:11.000000', 'consum', 0.0212, 'lps'),
	(468830, 124, '2015-04-01 00:04:12.000000', 'consum', 0.0227, 'lps'),
	(468831, 124, '2015-04-01 00:04:13.000000', 'consum', 0.0215, 'lps'),
	(468832, 124, '2015-04-01 00:04:14.000000', 'consum', 0.0233, 'lps'),
	(468833, 124, '2015-04-01 00:04:15.000000', 'consum', 0.0235, 'lps'),
	(468834, 124, '2015-04-01 00:04:16.000000', 'consum', 0.0212, 'lps'),
	(468835, 124, '2015-04-01 00:04:17.000000', 'consum', 0.0226, 'lps'),
	(468836, 124, '2015-04-01 00:04:18.000000', 'consum', 0.0233, 'lps'),
	(468837, 124, '2015-04-01 00:04:19.000000', 'consum', 0.0226, 'lps'),
	(468838, 124, '2015-04-01 00:04:20.000000', 'consum', 0.0219, 'lps'),
	(468839, 124, '2015-04-01 00:04:21.000000', 'consum', 0.0210, 'lps'),
	(468840, 124, '2015-04-01 00:04:22.000000', 'consum', 0.0233, 'lps'),
	(468841, 124, '2015-04-01 00:04:23.000000', 'consum', 0.0223, 'lps'),
	(468842, 124, '2015-04-01 00:04:24.000000', 'consum', 0.0232, 'lps'),
	(468843, 124, '2015-04-01 00:04:25.000000', 'consum', 0.0230, 'lps'),
	(468844, 124, '2015-04-01 00:04:26.000000', 'consum', 0.0218, 'lps'),
	(468845, 124, '2015-04-01 00:04:27.000000', 'consum', 0.0216, 'lps'),
	(468846, 124, '2015-04-01 00:04:28.000000', 'consum', 0.0216, 'lps'),
	(468847, 124, '2015-04-01 00:04:29.000000', 'consum', 0.0221, 'lps'),
	(468848, 124, '2015-04-01 00:04:30.000000', 'consum', 0.0225, 'lps'),
	(468849, 124, '2015-04-01 00:04:31.000000', 'consum', 0.0223, 'lps'),
	(468850, 124, '2015-04-01 00:04:32.000000', 'consum', 0.0234, 'lps'),
	(468851, 124, '2015-04-01 00:04:33.000000', 'consum', 0.0212, 'lps'),
	(468852, 124, '2015-04-01 00:04:34.000000', 'consum', 0.0227, 'lps'),
	(468853, 124, '2015-04-01 00:04:35.000000', 'consum', 0.0210, 'lps'),
	(468854, 124, '2015-04-01 00:04:36.000000', 'consum', 0.0213, 'lps'),
	(468855, 124, '2015-04-01 00:04:37.000000', 'consum', 0.0225, 'lps'),
	(468856, 124, '2015-04-01 00:04:38.000000', 'consum', 0.0226, 'lps'),
	(468857, 124, '2015-04-01 00:04:39.000000', 'consum', 0.0217, 'lps'),
	(468858, 124, '2015-04-01 00:04:40.000000', 'consum', 0.0223, 'lps'),
	(468859, 124, '2015-04-01 00:04:41.000000', 'consum', 0.0228, 'lps'),
	(468860, 124, '2015-04-01 00:04:42.000000', 'consum', 0.0212, 'lps'),
	(468861, 124, '2015-04-01 00:04:43.000000', 'consum', 0.0217, 'lps'),
	(468862, 124, '2015-04-01 00:04:44.000000', 'consum', 0.0213, 'lps'),
	(468863, 124, '2015-04-01 00:04:45.000000', 'consum', 0.0232, 'lps'),
	(468864, 124, '2015-04-01 00:04:46.000000', 'consum', 0.0233, 'lps'),
	(468865, 124, '2015-04-01 00:04:47.000000', 'consum', 0.0232, 'lps'),
	(468866, 124, '2015-04-01 00:04:48.000000', 'consum', 0.0226, 'lps'),
	(468867, 124, '2015-04-01 00:04:49.000000', 'consum', 0.0223, 'lps'),
	(468868, 124, '2015-04-01 00:04:50.000000', 'consum', 0.0229, 'lps'),
	(468869, 124, '2015-04-01 00:04:51.000000', 'consum', 0.0215, 'lps'),
	(468870, 124, '2015-04-01 00:04:52.000000', 'consum', 0.0229, 'lps'),
	(468871, 124, '2015-04-01 00:04:53.000000', 'consum', 0.0212, 'lps'),
	(468872, 124, '2015-04-01 00:04:54.000000', 'consum', 0.0215, 'lps'),
	(468873, 124, '2015-04-01 00:04:55.000000', 'consum', 0.0229, 'lps'),
	(468874, 124, '2015-04-01 00:04:56.000000', 'consum', 0.0213, 'lps'),
	(468875, 124, '2015-04-01 00:04:57.000000', 'consum', 0.0222, 'lps'),
	(468876, 124, '2015-04-01 00:04:58.000000', 'consum', 0.0211, 'lps'),
	(468877, 124, '2015-04-01 00:04:59.000000', 'consum', 0.0228, 'lps'),
	(468878, 124, '2015-04-01 00:05:00.000000', 'consum', 0.0222, 'lps'),
	(468879, 124, '2015-04-01 00:05:01.000000', 'consum', 0.0215, 'lps'),
	(468880, 124, '2015-04-01 00:05:02.000000', 'consum', 0.0228, 'lps'),
	(468881, 124, '2015-04-01 00:05:03.000000', 'consum', 0.0230, 'lps'),
	(468882, 124, '2015-04-01 00:05:04.000000', 'consum', 0.0232, 'lps'),
	(468883, 124, '2015-04-01 00:05:05.000000', 'consum', 0.0234, 'lps'),
	(468884, 124, '2015-04-01 00:05:06.000000', 'consum', 0.0214, 'lps'),
	(468885, 124, '2015-04-01 00:05:07.000000', 'consum', 0.0210, 'lps'),
	(468886, 124, '2015-04-01 00:05:08.000000', 'consum', 0.0223, 'lps'),
	(468887, 124, '2015-04-01 00:05:09.000000', 'consum', 0.0224, 'lps'),
	(468888, 124, '2015-04-01 00:05:10.000000', 'consum', 0.0214, 'lps'),
	(468889, 124, '2015-04-01 00:05:11.000000', 'consum', 0.0214, 'lps'),
	(468890, 124, '2015-04-01 00:05:12.000000', 'consum', 0.0221, 'lps'),
	(468891, 124, '2015-04-01 00:05:13.000000', 'consum', 0.0227, 'lps'),
	(468892, 124, '2015-04-01 00:05:14.000000', 'consum', 0.0211, 'lps'),
	(468893, 124, '2015-04-01 00:05:15.000000', 'consum', 0.0217, 'lps'),
	(468894, 124, '2015-04-01 00:05:16.000000', 'consum', 0.0215, 'lps'),
	(468895, 124, '2015-04-01 00:05:17.000000', 'consum', 0.0214, 'lps'),
	(468896, 124, '2015-04-01 00:05:18.000000', 'consum', 0.0215, 'lps'),
	(468897, 124, '2015-04-01 00:05:19.000000', 'consum', 0.0225, 'lps'),
	(468898, 124, '2015-04-01 00:05:20.000000', 'consum', 0.0216, 'lps'),
	(468899, 124, '2015-04-01 00:05:21.000000', 'consum', 0.0225, 'lps'),
	(468900, 124, '2015-04-01 00:05:22.000000', 'consum', 0.0212, 'lps'),
	(468901, 124, '2015-04-01 00:05:23.000000', 'consum', 0.0230, 'lps'),
	(468902, 124, '2015-04-01 00:05:24.000000', 'consum', 0.0227, 'lps'),
	(468903, 124, '2015-04-01 00:05:25.000000', 'consum', 0.0210, 'lps'),
	(468904, 124, '2015-04-01 00:05:26.000000', 'consum', 0.0211, 'lps'),
	(468905, 124, '2015-04-01 00:05:27.000000', 'consum', 0.0215, 'lps'),
	(468906, 124, '2015-04-01 00:05:28.000000', 'consum', 0.0231, 'lps'),
	(468907, 124, '2015-04-01 00:05:29.000000', 'consum', 0.0222, 'lps'),
	(468908, 124, '2015-04-01 00:05:30.000000', 'consum', 0.0210, 'lps'),
	(468909, 124, '2015-04-01 00:05:31.000000', 'consum', 0.0224, 'lps'),
	(468910, 124, '2015-04-01 00:05:32.000000', 'consum', 0.0228, 'lps'),
	(468911, 124, '2015-04-01 00:05:33.000000', 'consum', 0.0234, 'lps'),
	(468912, 124, '2015-04-01 00:05:34.000000', 'consum', 0.0223, 'lps'),
	(468913, 124, '2015-04-01 00:05:35.000000', 'consum', 0.0231, 'lps'),
	(468914, 124, '2015-04-01 00:05:36.000000', 'consum', 0.0225, 'lps'),
	(468915, 124, '2015-04-01 00:05:37.000000', 'consum', 0.0220, 'lps'),
	(468916, 124, '2015-04-01 00:05:38.000000', 'consum', 0.0217, 'lps'),
	(468917, 124, '2015-04-01 00:05:39.000000', 'consum', 0.0214, 'lps'),
	(468918, 124, '2015-04-01 00:05:40.000000', 'consum', 0.0210, 'lps'),
	(468919, 124, '2015-04-01 00:05:41.000000', 'consum', 0.0225, 'lps'),
	(468920, 124, '2015-04-01 00:05:42.000000', 'consum', 0.0235, 'lps'),
	(468921, 124, '2015-04-01 00:05:43.000000', 'consum', 0.0212, 'lps'),
	(468922, 124, '2015-04-01 00:05:44.000000', 'consum', 0.0224, 'lps'),
	(468923, 124, '2015-04-01 00:05:45.000000', 'consum', 0.0222, 'lps'),
	(468924, 124, '2015-04-01 00:05:46.000000', 'consum', 0.0227, 'lps'),
	(468925, 124, '2015-04-01 00:05:47.000000', 'consum', 0.0233, 'lps'),
	(468926, 124, '2015-04-01 00:05:48.000000', 'consum', 0.0225, 'lps'),
	(468927, 124, '2015-04-01 00:05:49.000000', 'consum', 0.0215, 'lps'),
	(468928, 124, '2015-04-01 00:05:50.000000', 'consum', 0.0219, 'lps'),
	(468929, 124, '2015-04-01 00:05:51.000000', 'consum', 0.0212, 'lps'),
	(468930, 124, '2015-04-01 00:05:52.000000', 'consum', 0.0218, 'lps'),
	(468931, 124, '2015-04-01 00:05:53.000000', 'consum', 0.0222, 'lps'),
	(468932, 124, '2015-04-01 00:05:54.000000', 'consum', 0.0218, 'lps'),
	(468933, 124, '2015-04-01 00:05:55.000000', 'consum', 0.0215, 'lps'),
	(468934, 124, '2015-04-01 00:05:56.000000', 'consum', 0.0211, 'lps'),
	(468935, 124, '2015-04-01 00:05:57.000000', 'consum', 0.0226, 'lps'),
	(468936, 124, '2015-04-01 00:05:58.000000', 'consum', 0.0234, 'lps'),
	(468937, 124, '2015-04-01 00:05:59.000000', 'consum', 0.0233, 'lps'),
	(468938, 124, '2015-04-01 00:06:00.000000', 'consum', 0.0228, 'lps'),
	(468939, 124, '2015-04-01 00:06:01.000000', 'consum', 0.0231, 'lps'),
	(468940, 124, '2015-04-01 00:06:02.000000', 'consum', 0.0235, 'lps'),
	(468941, 124, '2015-04-01 00:06:03.000000', 'consum', 0.0222, 'lps'),
	(468942, 124, '2015-04-01 00:06:04.000000', 'consum', 0.0219, 'lps'),
	(468943, 124, '2015-04-01 00:06:05.000000', 'consum', 0.0220, 'lps'),
	(468944, 124, '2015-04-01 00:06:06.000000', 'consum', 0.0233, 'lps'),
	(468945, 124, '2015-04-01 00:06:07.000000', 'consum', 0.0217, 'lps'),
	(468946, 124, '2015-04-01 00:06:08.000000', 'consum', 0.0228, 'lps'),
	(468947, 124, '2015-04-01 00:06:09.000000', 'consum', 0.0226, 'lps'),
	(468948, 124, '2015-04-01 00:06:10.000000', 'consum', 0.0213, 'lps'),
	(468949, 124, '2015-04-01 00:06:11.000000', 'consum', 0.0231, 'lps'),
	(468950, 124, '2015-04-01 00:06:12.000000', 'consum', 0.0225, 'lps'),
	(468951, 124, '2015-04-01 00:06:13.000000', 'consum', 0.0225, 'lps'),
	(468952, 124, '2015-04-01 00:06:14.000000', 'consum', 0.0215, 'lps'),
	(468953, 124, '2015-04-01 00:06:15.000000', 'consum', 0.0215, 'lps'),
	(468954, 124, '2015-04-01 00:06:16.000000', 'consum', 0.0222, 'lps'),
	(468955, 124, '2015-04-01 00:06:17.000000', 'consum', 0.0230, 'lps'),
	(468956, 124, '2015-04-01 00:06:18.000000', 'consum', 0.0220, 'lps'),
	(468957, 124, '2015-04-01 00:06:19.000000', 'consum', 0.0229, 'lps'),
	(468958, 124, '2015-04-01 00:06:20.000000', 'consum', 0.0222, 'lps'),
	(468959, 124, '2015-04-01 00:06:21.000000', 'consum', 0.0216, 'lps'),
	(468960, 124, '2015-04-01 00:06:22.000000', 'consum', 0.0229, 'lps'),
	(468961, 124, '2015-04-01 00:06:23.000000', 'consum', 0.0235, 'lps'),
	(468962, 124, '2015-04-01 00:06:24.000000', 'consum', 0.0227, 'lps'),
	(468963, 124, '2015-04-01 00:06:25.000000', 'consum', 0.0220, 'lps'),
	(468964, 124, '2015-04-01 00:06:26.000000', 'consum', 0.0210, 'lps'),
	(468965, 124, '2015-04-01 00:06:27.000000', 'consum', 0.0232, 'lps'),
	(468966, 124, '2015-04-01 00:06:28.000000', 'consum', 0.0216, 'lps'),
	(468967, 124, '2015-04-01 00:06:29.000000', 'consum', 0.0226, 'lps'),
	(468968, 124, '2015-04-01 00:06:30.000000', 'consum', 0.0221, 'lps'),
	(468969, 124, '2015-04-01 00:06:31.000000', 'consum', 0.0219, 'lps'),
	(468970, 124, '2015-04-01 00:06:32.000000', 'consum', 0.0221, 'lps'),
	(468971, 124, '2015-04-01 00:06:33.000000', 'consum', 0.0214, 'lps'),
	(468972, 124, '2015-04-01 00:06:34.000000', 'consum', 0.0225, 'lps'),
	(468973, 124, '2015-04-01 00:06:35.000000', 'consum', 0.0219, 'lps'),
	(468974, 124, '2015-04-01 00:06:36.000000', 'consum', 0.0211, 'lps'),
	(468975, 124, '2015-04-01 00:06:37.000000', 'consum', 0.0216, 'lps'),
	(468976, 124, '2015-04-01 00:06:38.000000', 'consum', 0.0210, 'lps'),
	(468977, 124, '2015-04-01 00:06:39.000000', 'consum', 0.0219, 'lps'),
	(468978, 124, '2015-04-01 00:06:40.000000', 'consum', 0.0228, 'lps'),
	(468979, 124, '2015-04-01 00:06:41.000000', 'consum', 0.0223, 'lps'),
	(468980, 124, '2015-04-01 00:06:42.000000', 'consum', 0.0221, 'lps'),
	(468981, 124, '2015-04-01 00:06:43.000000', 'consum', 0.0228, 'lps'),
	(468982, 124, '2015-04-01 00:06:44.000000', 'consum', 0.0216, 'lps'),
	(468983, 124, '2015-04-01 00:06:45.000000', 'consum', 0.0212, 'lps'),
	(468984, 124, '2015-04-01 00:06:46.000000', 'consum', 0.0229, 'lps'),
	(468985, 124, '2015-04-01 00:06:47.000000', 'consum', 0.0222, 'lps'),
	(468986, 124, '2015-04-01 00:06:48.000000', 'consum', 0.0213, 'lps'),
	(468987, 124, '2015-04-01 00:06:49.000000', 'consum', 0.0213, 'lps'),
	(468988, 124, '2015-04-01 00:06:50.000000', 'consum', 0.0220, 'lps'),
	(468989, 124, '2015-04-01 00:06:51.000000', 'consum', 0.0224, 'lps'),
	(468990, 124, '2015-04-01 00:06:52.000000', 'consum', 0.0223, 'lps'),
	(468991, 124, '2015-04-01 00:06:53.000000', 'consum', 0.0235, 'lps'),
	(468992, 124, '2015-04-01 00:06:54.000000', 'consum', 0.0220, 'lps'),
	(468993, 124, '2015-04-01 00:06:55.000000', 'consum', 0.0234, 'lps'),
	(468994, 124, '2015-04-01 00:06:56.000000', 'consum', 0.0226, 'lps'),
	(468995, 124, '2015-04-01 00:06:57.000000', 'consum', 0.0217, 'lps'),
	(468996, 124, '2015-04-01 00:06:58.000000', 'consum', 0.0224, 'lps'),
	(468997, 124, '2015-04-01 00:06:59.000000', 'consum', 0.0232, 'lps'),
	(468998, 124, '2015-04-01 00:07:00.000000', 'consum', 0.0228, 'lps'),
	(468999, 124, '2015-04-01 00:07:01.000000', 'consum', 0.0210, 'lps'),
	(469000, 124, '2015-04-01 00:07:02.000000', 'consum', 0.0231, 'lps'),
	(469001, 124, '2015-04-01 00:07:03.000000', 'consum', 0.0215, 'lps'),
	(469002, 124, '2015-04-01 00:07:04.000000', 'consum', 0.0224, 'lps'),
	(469003, 124, '2015-04-01 00:07:05.000000', 'consum', 0.0212, 'lps'),
	(469004, 124, '2015-04-01 00:07:06.000000', 'consum', 0.0229, 'lps'),
	(469005, 124, '2015-04-01 00:07:07.000000', 'consum', 0.0225, 'lps'),
	(469006, 124, '2015-04-01 00:07:08.000000', 'consum', 0.0227, 'lps'),
	(469007, 124, '2015-04-01 00:07:09.000000', 'consum', 0.0223, 'lps'),
	(469008, 124, '2015-04-01 00:07:10.000000', 'consum', 0.0224, 'lps'),
	(469009, 124, '2015-04-01 00:07:11.000000', 'consum', 0.0214, 'lps'),
	(469010, 124, '2015-04-01 00:07:12.000000', 'consum', 0.0218, 'lps'),
	(469011, 124, '2015-04-01 00:07:13.000000', 'consum', 0.0213, 'lps'),
	(469012, 124, '2015-04-01 00:07:14.000000', 'consum', 0.0228, 'lps'),
	(469013, 124, '2015-04-01 00:07:15.000000', 'consum', 0.0211, 'lps'),
	(469014, 124, '2015-04-01 00:07:16.000000', 'consum', 0.0212, 'lps'),
	(469015, 124, '2015-04-01 00:07:17.000000', 'consum', 0.0221, 'lps'),
	(469016, 124, '2015-04-01 00:07:18.000000', 'consum', 0.0233, 'lps'),
	(469017, 124, '2015-04-01 00:07:19.000000', 'consum', 0.0212, 'lps'),
	(469018, 124, '2015-04-01 00:07:20.000000', 'consum', 0.0231, 'lps'),
	(469019, 124, '2015-04-01 00:07:21.000000', 'consum', 0.0232, 'lps'),
	(469020, 124, '2015-04-01 00:07:22.000000', 'consum', 0.0230, 'lps'),
	(469021, 124, '2015-04-01 00:07:23.000000', 'consum', 0.0218, 'lps'),
	(469022, 124, '2015-04-01 00:07:24.000000', 'consum', 0.0217, 'lps'),
	(469023, 124, '2015-04-01 00:07:25.000000', 'consum', 0.0221, 'lps'),
	(469024, 124, '2015-04-01 00:07:26.000000', 'consum', 0.0218, 'lps'),
	(469025, 124, '2015-04-01 00:07:27.000000', 'consum', 0.0219, 'lps'),
	(469026, 124, '2015-04-01 00:07:28.000000', 'consum', 0.0229, 'lps'),
	(469027, 124, '2015-04-01 00:07:29.000000', 'consum', 0.0228, 'lps'),
	(469028, 124, '2015-04-01 00:07:30.000000', 'consum', 0.0219, 'lps'),
	(469029, 124, '2015-04-01 00:07:31.000000', 'consum', 0.0225, 'lps'),
	(469030, 124, '2015-04-01 00:07:32.000000', 'consum', 0.0233, 'lps'),
	(469031, 124, '2015-04-01 00:07:33.000000', 'consum', 0.0231, 'lps'),
	(469032, 124, '2015-04-01 00:07:34.000000', 'consum', 0.0217, 'lps'),
	(469033, 124, '2015-04-01 00:07:35.000000', 'consum', 0.0210, 'lps'),
	(469034, 124, '2015-04-01 00:07:36.000000', 'consum', 0.0215, 'lps'),
	(469035, 124, '2015-04-01 00:07:37.000000', 'consum', 0.0234, 'lps'),
	(469036, 124, '2015-04-01 00:07:38.000000', 'consum', 0.0211, 'lps'),
	(469037, 124, '2015-04-01 00:07:39.000000', 'consum', 0.0224, 'lps'),
	(469038, 124, '2015-04-01 00:07:40.000000', 'consum', 0.0225, 'lps'),
	(469039, 124, '2015-04-01 00:07:41.000000', 'consum', 0.0219, 'lps'),
	(469040, 124, '2015-04-01 00:07:42.000000', 'consum', 0.0211, 'lps'),
	(469041, 124, '2015-04-01 00:07:43.000000', 'consum', 0.0212, 'lps'),
	(469042, 124, '2015-04-01 00:07:44.000000', 'consum', 0.0217, 'lps'),
	(469043, 124, '2015-04-01 00:07:45.000000', 'consum', 0.0213, 'lps'),
	(469044, 124, '2015-04-01 00:07:46.000000', 'consum', 0.0232, 'lps'),
	(469045, 124, '2015-04-01 00:07:47.000000', 'consum', 0.0233, 'lps'),
	(469046, 124, '2015-04-01 00:07:48.000000', 'consum', 0.0233, 'lps'),
	(469047, 124, '2015-04-01 00:07:49.000000', 'consum', 0.0233, 'lps'),
	(469048, 124, '2015-04-01 00:07:50.000000', 'consum', 0.0229, 'lps'),
	(469049, 124, '2015-04-01 00:07:51.000000', 'consum', 0.0211, 'lps'),
	(469050, 124, '2015-04-01 00:07:52.000000', 'consum', 0.0235, 'lps'),
	(469051, 124, '2015-04-01 00:07:53.000000', 'consum', 0.0228, 'lps'),
	(469052, 124, '2015-04-01 00:07:54.000000', 'consum', 0.0226, 'lps'),
	(469053, 124, '2015-04-01 00:07:55.000000', 'consum', 0.0210, 'lps'),
	(469054, 124, '2015-04-01 00:07:56.000000', 'consum', 0.0216, 'lps'),
	(469055, 124, '2015-04-01 00:07:57.000000', 'consum', 0.0213, 'lps'),
	(469056, 124, '2015-04-01 00:07:58.000000', 'consum', 0.0210, 'lps'),
	(469057, 124, '2015-04-01 00:07:59.000000', 'consum', 0.0227, 'lps'),
	(469058, 124, '2015-04-01 00:08:00.000000', 'consum', 0.0216, 'lps'),
	(469059, 124, '2015-04-01 00:08:01.000000', 'consum', 0.0217, 'lps'),
	(469060, 124, '2015-04-01 00:08:02.000000', 'consum', 0.0229, 'lps'),
	(469061, 124, '2015-04-01 00:08:03.000000', 'consum', 0.0229, 'lps'),
	(469062, 124, '2015-04-01 00:08:04.000000', 'consum', 0.0226, 'lps'),
	(469063, 124, '2015-04-01 00:08:05.000000', 'consum', 0.0230, 'lps'),
	(469064, 124, '2015-04-01 00:08:06.000000', 'consum', 0.0213, 'lps'),
	(469065, 124, '2015-04-01 00:08:07.000000', 'consum', 0.0218, 'lps'),
	(469066, 124, '2015-04-01 00:08:08.000000', 'consum', 0.0216, 'lps'),
	(469067, 124, '2015-04-01 00:08:09.000000', 'consum', 0.0218, 'lps'),
	(469068, 124, '2015-04-01 00:08:10.000000', 'consum', 0.0229, 'lps'),
	(469069, 124, '2015-04-01 00:08:11.000000', 'consum', 0.0232, 'lps'),
	(469070, 124, '2015-04-01 00:08:12.000000', 'consum', 0.0210, 'lps'),
	(469071, 124, '2015-04-01 00:08:13.000000', 'consum', 0.0222, 'lps'),
	(469072, 124, '2015-04-01 00:08:14.000000', 'consum', 0.0220, 'lps'),
	(469073, 124, '2015-04-01 00:08:15.000000', 'consum', 0.0225, 'lps'),
	(469074, 124, '2015-04-01 00:08:16.000000', 'consum', 0.0230, 'lps'),
	(469075, 124, '2015-04-01 00:08:17.000000', 'consum', 0.0214, 'lps'),
	(469076, 124, '2015-04-01 00:08:18.000000', 'consum', 0.0222, 'lps'),
	(469077, 124, '2015-04-01 00:08:19.000000', 'consum', 0.0232, 'lps'),
	(469078, 124, '2015-04-01 00:08:20.000000', 'consum', 0.0232, 'lps'),
	(469079, 124, '2015-04-01 00:08:21.000000', 'consum', 0.0228, 'lps'),
	(469080, 124, '2015-04-01 00:08:22.000000', 'consum', 0.0210, 'lps'),
	(469081, 124, '2015-04-01 00:08:23.000000', 'consum', 0.0235, 'lps'),
	(469082, 124, '2015-04-01 00:08:24.000000', 'consum', 0.0229, 'lps'),
	(469083, 124, '2015-04-01 00:08:25.000000', 'consum', 0.0231, 'lps'),
	(469084, 124, '2015-04-01 00:08:26.000000', 'consum', 0.0231, 'lps'),
	(469085, 124, '2015-04-01 00:08:27.000000', 'consum', 0.0228, 'lps'),
	(469086, 124, '2015-04-01 00:08:28.000000', 'consum', 0.0212, 'lps'),
	(469087, 124, '2015-04-01 00:08:29.000000', 'consum', 0.0217, 'lps'),
	(469088, 124, '2015-04-01 00:08:30.000000', 'consum', 0.0212, 'lps'),
	(469089, 124, '2015-04-01 00:08:31.000000', 'consum', 0.0228, 'lps'),
	(469090, 124, '2015-04-01 00:08:32.000000', 'consum', 0.0217, 'lps'),
	(469091, 124, '2015-04-01 00:08:33.000000', 'consum', 0.0215, 'lps'),
	(469092, 124, '2015-04-01 00:08:34.000000', 'consum', 0.0217, 'lps'),
	(469093, 124, '2015-04-01 00:08:35.000000', 'consum', 0.0229, 'lps'),
	(469094, 124, '2015-04-01 00:08:36.000000', 'consum', 0.0233, 'lps'),
	(469095, 124, '2015-04-01 00:08:37.000000', 'consum', 0.0215, 'lps'),
	(469096, 124, '2015-04-01 00:08:38.000000', 'consum', 0.0220, 'lps'),
	(469097, 124, '2015-04-01 00:08:39.000000', 'consum', 0.0221, 'lps'),
	(469098, 124, '2015-04-01 00:08:40.000000', 'consum', 0.0235, 'lps'),
	(469099, 124, '2015-04-01 00:08:41.000000', 'consum', 0.0226, 'lps'),
	(469100, 124, '2015-04-01 00:08:42.000000', 'consum', 0.0213, 'lps'),
	(469101, 124, '2015-04-01 00:08:43.000000', 'consum', 0.0232, 'lps'),
	(469102, 124, '2015-04-01 00:08:44.000000', 'consum', 0.0231, 'lps'),
	(469103, 124, '2015-04-01 00:08:45.000000', 'consum', 0.0224, 'lps'),
	(469104, 124, '2015-04-01 00:08:46.000000', 'consum', 0.0218, 'lps'),
	(469105, 124, '2015-04-01 00:08:47.000000', 'consum', 0.0235, 'lps'),
	(469106, 124, '2015-04-01 00:08:48.000000', 'consum', 0.0233, 'lps'),
	(469107, 124, '2015-04-01 00:08:49.000000', 'consum', 0.0226, 'lps'),
	(469108, 124, '2015-04-01 00:08:50.000000', 'consum', 0.0219, 'lps'),
	(469109, 124, '2015-04-01 00:08:51.000000', 'consum', 0.0234, 'lps'),
	(469110, 124, '2015-04-01 00:08:52.000000', 'consum', 0.0224, 'lps'),
	(469111, 124, '2015-04-01 00:08:53.000000', 'consum', 0.0211, 'lps'),
	(469112, 124, '2015-04-01 00:08:54.000000', 'consum', 0.0225, 'lps'),
	(469113, 124, '2015-04-01 00:08:55.000000', 'consum', 0.0230, 'lps'),
	(469114, 124, '2015-04-01 00:08:56.000000', 'consum', 0.0215, 'lps'),
	(469115, 124, '2015-04-01 00:08:57.000000', 'consum', 0.0225, 'lps'),
	(469116, 124, '2015-04-01 00:08:58.000000', 'consum', 0.0220, 'lps'),
	(469117, 124, '2015-04-01 00:08:59.000000', 'consum', 0.0214, 'lps'),
	(469118, 124, '2015-04-01 00:09:00.000000', 'consum', 0.0228, 'lps'),
	(469119, 124, '2015-04-01 00:09:01.000000', 'consum', 0.0210, 'lps'),
	(469120, 124, '2015-04-01 00:09:02.000000', 'consum', 0.0232, 'lps'),
	(469121, 124, '2015-04-01 00:09:03.000000', 'consum', 0.0220, 'lps'),
	(469122, 124, '2015-04-01 00:09:04.000000', 'consum', 0.0219, 'lps'),
	(469123, 124, '2015-04-01 00:09:05.000000', 'consum', 0.0226, 'lps'),
	(469124, 124, '2015-04-01 00:09:06.000000', 'consum', 0.0211, 'lps'),
	(469125, 124, '2015-04-01 00:09:07.000000', 'consum', 0.0218, 'lps'),
	(469126, 124, '2015-04-01 00:09:08.000000', 'consum', 0.0222, 'lps'),
	(469127, 124, '2015-04-01 00:09:09.000000', 'consum', 0.0219, 'lps'),
	(469128, 124, '2015-04-01 00:09:10.000000', 'consum', 0.0221, 'lps'),
	(469129, 124, '2015-04-01 00:09:11.000000', 'consum', 0.0210, 'lps'),
	(469130, 124, '2015-04-01 00:09:12.000000', 'consum', 0.0233, 'lps'),
	(469131, 124, '2015-04-01 00:09:13.000000', 'consum', 0.0221, 'lps'),
	(469132, 124, '2015-04-01 00:09:14.000000', 'consum', 0.0221, 'lps'),
	(469133, 124, '2015-04-01 00:09:15.000000', 'consum', 0.0234, 'lps'),
	(469134, 124, '2015-04-01 00:09:16.000000', 'consum', 0.0219, 'lps'),
	(469135, 124, '2015-04-01 00:09:17.000000', 'consum', 0.0234, 'lps'),
	(469136, 124, '2015-04-01 00:09:18.000000', 'consum', 0.0225, 'lps'),
	(469137, 124, '2015-04-01 00:09:19.000000', 'consum', 0.0215, 'lps'),
	(469138, 124, '2015-04-01 00:09:20.000000', 'consum', 0.0215, 'lps'),
	(469139, 124, '2015-04-01 00:09:21.000000', 'consum', 0.0223, 'lps'),
	(469140, 124, '2015-04-01 00:09:22.000000', 'consum', 0.0232, 'lps'),
	(469141, 124, '2015-04-01 00:09:23.000000', 'consum', 0.0231, 'lps'),
	(469142, 124, '2015-04-01 00:09:24.000000', 'consum', 0.0224, 'lps'),
	(469143, 124, '2015-04-01 00:09:25.000000', 'consum', 0.0216, 'lps'),
	(469144, 124, '2015-04-01 00:09:26.000000', 'consum', 0.0227, 'lps'),
	(469145, 124, '2015-04-01 00:09:27.000000', 'consum', 0.0225, 'lps'),
	(469146, 124, '2015-04-01 00:09:28.000000', 'consum', 0.0234, 'lps'),
	(469147, 124, '2015-04-01 00:09:29.000000', 'consum', 0.0234, 'lps'),
	(469148, 124, '2015-04-01 00:09:30.000000', 'consum', 0.0233, 'lps'),
	(469149, 124, '2015-04-01 00:09:31.000000', 'consum', 0.0228, 'lps'),
	(469150, 124, '2015-04-01 00:09:32.000000', 'consum', 0.0230, 'lps'),
	(469151, 124, '2015-04-01 00:09:33.000000', 'consum', 0.0231, 'lps'),
	(469152, 124, '2015-04-01 00:09:34.000000', 'consum', 0.0228, 'lps'),
	(469153, 124, '2015-04-01 00:09:35.000000', 'consum', 0.0213, 'lps'),
	(469154, 124, '2015-04-01 00:09:36.000000', 'consum', 0.0222, 'lps'),
	(469155, 124, '2015-04-01 00:09:37.000000', 'consum', 0.0235, 'lps'),
	(469156, 124, '2015-04-01 00:09:38.000000', 'consum', 0.0224, 'lps'),
	(469157, 124, '2015-04-01 00:09:39.000000', 'consum', 0.0229, 'lps'),
	(469158, 124, '2015-04-01 00:09:40.000000', 'consum', 0.0211, 'lps'),
	(469159, 124, '2015-04-01 00:09:41.000000', 'consum', 0.0213, 'lps'),
	(469160, 124, '2015-04-01 00:09:42.000000', 'consum', 0.0223, 'lps'),
	(469161, 124, '2015-04-01 00:09:43.000000', 'consum', 0.0214, 'lps'),
	(469162, 124, '2015-04-01 00:09:44.000000', 'consum', 0.0216, 'lps'),
	(469163, 124, '2015-04-01 00:09:45.000000', 'consum', 0.0227, 'lps'),
	(469164, 124, '2015-04-01 00:09:46.000000', 'consum', 0.0228, 'lps'),
	(469165, 124, '2015-04-01 00:09:47.000000', 'consum', 0.0225, 'lps'),
	(469166, 124, '2015-04-01 00:09:48.000000', 'consum', 0.0230, 'lps'),
	(469167, 124, '2015-04-01 00:09:49.000000', 'consum', 0.0212, 'lps'),
	(469168, 124, '2015-04-01 00:09:50.000000', 'consum', 0.0213, 'lps'),
	(469169, 124, '2015-04-01 00:09:51.000000', 'consum', 0.0222, 'lps'),
	(469170, 124, '2015-04-01 00:09:52.000000', 'consum', 0.0233, 'lps'),
	(469171, 124, '2015-04-01 00:09:53.000000', 'consum', 0.0212, 'lps'),
	(469172, 124, '2015-04-01 00:09:54.000000', 'consum', 0.0231, 'lps'),
	(469173, 124, '2015-04-01 00:09:55.000000', 'consum', 0.0232, 'lps'),
	(469174, 124, '2015-04-01 00:09:56.000000', 'consum', 0.0232, 'lps'),
	(469175, 124, '2015-04-01 00:09:57.000000', 'consum', 0.0227, 'lps'),
	(469176, 124, '2015-04-01 00:09:58.000000', 'consum', 0.0228, 'lps'),
	(469177, 124, '2015-04-01 00:09:59.000000', 'consum', 0.0227, 'lps'),
	(469178, 124, '2015-04-01 00:10:00.000000', 'consum', 0.0213, 'lps'),
	(469179, 124, '2015-04-01 00:10:01.000000', 'consum', 0.0228, 'lps'),
	(469180, 124, '2015-04-01 00:10:02.000000', 'consum', 0.0215, 'lps'),
	(469181, 124, '2015-04-01 00:10:03.000000', 'consum', 0.0230, 'lps'),
	(469182, 124, '2015-04-01 00:10:04.000000', 'consum', 0.0220, 'lps'),
	(469183, 124, '2015-04-01 00:10:05.000000', 'consum', 0.0224, 'lps'),
	(469184, 124, '2015-04-01 00:10:06.000000', 'consum', 0.0225, 'lps'),
	(469185, 124, '2015-04-01 00:10:07.000000', 'consum', 0.0220, 'lps'),
	(469186, 124, '2015-04-01 00:10:08.000000', 'consum', 0.0213, 'lps'),
	(469187, 124, '2015-04-01 00:10:09.000000', 'consum', 0.0221, 'lps'),
	(469188, 124, '2015-04-01 00:10:10.000000', 'consum', 0.0231, 'lps'),
	(469189, 124, '2015-04-01 00:10:11.000000', 'consum', 0.0231, 'lps'),
	(469190, 124, '2015-04-01 00:10:12.000000', 'consum', 0.0225, 'lps'),
	(469191, 124, '2015-04-01 00:10:13.000000', 'consum', 0.0225, 'lps'),
	(469192, 124, '2015-04-01 00:10:14.000000', 'consum', 0.0215, 'lps'),
	(469193, 124, '2015-04-01 00:10:15.000000', 'consum', 0.0215, 'lps'),
	(469194, 124, '2015-04-01 00:10:16.000000', 'consum', 0.0222, 'lps'),
	(469195, 124, '2015-04-01 00:10:17.000000', 'consum', 0.0230, 'lps'),
	(469196, 124, '2015-04-01 00:10:18.000000', 'consum', 0.0224, 'lps'),
	(469197, 124, '2015-04-01 00:10:19.000000', 'consum', 0.0217, 'lps'),
	(469198, 124, '2015-04-01 00:10:20.000000', 'consum', 0.0230, 'lps'),
	(469199, 124, '2015-04-01 00:10:21.000000', 'consum', 0.0212, 'lps'),
	(469200, 124, '2015-04-01 00:10:22.000000', 'consum', 0.0213, 'lps'),
	(469201, 124, '2015-04-01 00:10:23.000000', 'consum', 0.0218, 'lps'),
	(469202, 124, '2015-04-01 00:10:24.000000', 'consum', 0.0215, 'lps'),
	(469203, 124, '2015-04-01 00:10:25.000000', 'consum', 0.0212, 'lps'),
	(469204, 124, '2015-04-01 00:10:26.000000', 'consum', 0.0233, 'lps'),
	(469205, 124, '2015-04-01 00:10:27.000000', 'consum', 0.0213, 'lps'),
	(469206, 124, '2015-04-01 00:10:28.000000', 'consum', 0.0211, 'lps'),
	(469207, 124, '2015-04-01 00:10:29.000000', 'consum', 0.0230, 'lps'),
	(469208, 124, '2015-04-01 00:10:30.000000', 'consum', 0.0231, 'lps'),
	(469209, 124, '2015-04-01 00:10:31.000000', 'consum', 0.0227, 'lps'),
	(469210, 124, '2015-04-01 00:10:32.000000', 'consum', 0.0235, 'lps'),
	(469211, 124, '2015-04-01 00:10:33.000000', 'consum', 0.0232, 'lps'),
	(469212, 124, '2015-04-01 00:10:34.000000', 'consum', 0.0220, 'lps'),
	(469213, 124, '2015-04-01 00:10:35.000000', 'consum', 0.0219, 'lps'),
	(469214, 124, '2015-04-01 00:10:36.000000', 'consum', 0.0225, 'lps'),
	(469215, 124, '2015-04-01 00:10:37.000000', 'consum', 0.0232, 'lps'),
	(469216, 124, '2015-04-01 00:10:38.000000', 'consum', 0.0223, 'lps'),
	(469217, 124, '2015-04-01 00:10:39.000000', 'consum', 0.0211, 'lps'),
	(469218, 124, '2015-04-01 00:10:40.000000', 'consum', 0.0228, 'lps'),
	(469219, 124, '2015-04-01 00:10:41.000000', 'consum', 0.0222, 'lps'),
	(469220, 124, '2015-04-01 00:10:42.000000', 'consum', 0.0213, 'lps'),
	(469221, 124, '2015-04-01 00:10:43.000000', 'consum', 0.0219, 'lps'),
	(469222, 124, '2015-04-01 00:10:44.000000', 'consum', 0.0219, 'lps'),
	(469223, 124, '2015-04-01 00:10:45.000000', 'consum', 0.0227, 'lps'),
	(469224, 124, '2015-04-01 00:10:46.000000', 'consum', 0.0217, 'lps'),
	(469225, 124, '2015-04-01 00:10:47.000000', 'consum', 0.0222, 'lps'),
	(469226, 124, '2015-04-01 00:10:48.000000', 'consum', 0.0222, 'lps'),
	(469227, 124, '2015-04-01 00:10:49.000000', 'consum', 0.0211, 'lps'),
	(469228, 124, '2015-04-01 00:10:50.000000', 'consum', 0.0229, 'lps'),
	(469229, 124, '2015-04-01 00:10:51.000000', 'consum', 0.0223, 'lps'),
	(469230, 124, '2015-04-01 00:10:52.000000', 'consum', 0.0221, 'lps'),
	(469231, 124, '2015-04-01 00:10:53.000000', 'consum', 0.0226, 'lps'),
	(469232, 124, '2015-04-01 00:10:54.000000', 'consum', 0.0232, 'lps'),
	(469233, 124, '2015-04-01 00:10:55.000000', 'consum', 0.0218, 'lps'),
	(469234, 124, '2015-04-01 00:10:56.000000', 'consum', 0.0212, 'lps'),
	(469235, 124, '2015-04-01 00:10:57.000000', 'consum', 0.0224, 'lps'),
	(469236, 124, '2015-04-01 00:10:58.000000', 'consum', 0.0220, 'lps'),
	(469237, 124, '2015-04-01 00:10:59.000000', 'consum', 0.0220, 'lps'),
	(469238, 124, '2015-04-01 00:11:00.000000', 'consum', 0.0229, 'lps'),
	(469239, 124, '2015-04-01 00:11:01.000000', 'consum', 0.0225, 'lps'),
	(469240, 124, '2015-04-01 00:11:02.000000', 'consum', 0.0230, 'lps'),
	(469241, 124, '2015-04-01 00:11:03.000000', 'consum', 0.0211, 'lps'),
	(469242, 124, '2015-04-01 00:11:04.000000', 'consum', 0.0234, 'lps'),
	(469243, 124, '2015-04-01 00:11:05.000000', 'consum', 0.0223, 'lps'),
	(469244, 124, '2015-04-01 00:11:06.000000', 'consum', 0.0228, 'lps'),
	(469245, 124, '2015-04-01 00:11:07.000000', 'consum', 0.0211, 'lps'),
	(469246, 124, '2015-04-01 00:11:08.000000', 'consum', 0.0212, 'lps'),
	(469247, 124, '2015-04-01 00:11:09.000000', 'consum', 0.0220, 'lps'),
	(469248, 124, '2015-04-01 00:11:10.000000', 'consum', 0.0228, 'lps'),
	(469249, 124, '2015-04-01 00:11:11.000000', 'consum', 0.0220, 'lps'),
	(469250, 124, '2015-04-01 00:11:12.000000', 'consum', 0.0229, 'lps'),
	(469251, 124, '2015-04-01 00:11:13.000000', 'consum', 0.0226, 'lps'),
	(469252, 124, '2015-04-01 00:11:14.000000', 'consum', 0.0234, 'lps'),
	(469253, 124, '2015-04-01 00:11:15.000000', 'consum', 0.0228, 'lps'),
	(469254, 124, '2015-04-01 00:11:16.000000', 'consum', 0.0230, 'lps'),
	(469255, 124, '2015-04-01 00:11:17.000000', 'consum', 0.0229, 'lps'),
	(469256, 124, '2015-04-01 00:11:18.000000', 'consum', 0.0219, 'lps'),
	(469257, 124, '2015-04-01 00:11:19.000000', 'consum', 0.0227, 'lps'),
	(469258, 124, '2015-04-01 00:11:20.000000', 'consum', 0.0216, 'lps'),
	(469259, 124, '2015-04-01 00:11:21.000000', 'consum', 0.0215, 'lps'),
	(469260, 124, '2015-04-01 00:11:22.000000', 'consum', 0.0219, 'lps'),
	(469261, 124, '2015-04-01 00:11:23.000000', 'consum', 0.0214, 'lps'),
	(469262, 124, '2015-04-01 00:11:24.000000', 'consum', 0.0227, 'lps'),
	(469263, 124, '2015-04-01 00:11:25.000000', 'consum', 0.0234, 'lps'),
	(469264, 124, '2015-04-01 00:11:26.000000', 'consum', 0.0229, 'lps'),
	(469265, 124, '2015-04-01 00:11:27.000000', 'consum', 0.0231, 'lps'),
	(469266, 124, '2015-04-01 00:11:28.000000', 'consum', 0.0231, 'lps'),
	(469267, 124, '2015-04-01 00:11:29.000000', 'consum', 0.0229, 'lps'),
	(469268, 124, '2015-04-01 00:11:30.000000', 'consum', 0.0217, 'lps'),
	(469269, 124, '2015-04-01 00:11:31.000000', 'consum', 0.0213, 'lps'),
	(469270, 124, '2015-04-01 00:11:32.000000', 'consum', 0.0230, 'lps'),
	(469271, 124, '2015-04-01 00:11:33.000000', 'consum', 0.0226, 'lps'),
	(469272, 124, '2015-04-01 00:11:34.000000', 'consum', 0.0228, 'lps'),
	(469273, 124, '2015-04-01 00:11:35.000000', 'consum', 0.0227, 'lps'),
	(469274, 124, '2015-04-01 00:11:36.000000', 'consum', 0.0215, 'lps'),
	(469275, 124, '2015-04-01 00:11:37.000000', 'consum', 0.0213, 'lps'),
	(469276, 124, '2015-04-01 00:11:38.000000', 'consum', 0.0234, 'lps'),
	(469277, 124, '2015-04-01 00:11:39.000000', 'consum', 0.0216, 'lps'),
	(469278, 124, '2015-04-01 00:11:40.000000', 'consum', 0.0223, 'lps'),
	(469279, 124, '2015-04-01 00:11:41.000000', 'consum', 0.0230, 'lps'),
	(469280, 124, '2015-04-01 00:11:42.000000', 'consum', 0.0220, 'lps'),
	(469281, 124, '2015-04-01 00:11:43.000000', 'consum', 0.0227, 'lps'),
	(469282, 124, '2015-04-01 00:11:44.000000', 'consum', 0.0215, 'lps'),
	(469283, 124, '2015-04-01 00:11:45.000000', 'consum', 0.0234, 'lps'),
	(469284, 124, '2015-04-01 00:11:46.000000', 'consum', 0.0213, 'lps'),
	(469285, 124, '2015-04-01 00:11:47.000000', 'consum', 0.0229, 'lps'),
	(469286, 124, '2015-04-01 00:11:48.000000', 'consum', 0.0222, 'lps'),
	(469287, 124, '2015-04-01 00:11:49.000000', 'consum', 0.0211, 'lps'),
	(469288, 124, '2015-04-01 00:11:50.000000', 'consum', 0.0234, 'lps'),
	(469289, 124, '2015-04-01 00:11:51.000000', 'consum', 0.0223, 'lps'),
	(469290, 124, '2015-04-01 00:11:52.000000', 'consum', 0.0230, 'lps'),
	(469291, 124, '2015-04-01 00:11:53.000000', 'consum', 0.0217, 'lps'),
	(469292, 124, '2015-04-01 00:11:54.000000', 'consum', 0.0211, 'lps'),
	(469293, 124, '2015-04-01 00:11:55.000000', 'consum', 0.0223, 'lps'),
	(469294, 124, '2015-04-01 00:11:56.000000', 'consum', 0.0222, 'lps'),
	(469295, 124, '2015-04-01 00:11:57.000000', 'consum', 0.0228, 'lps'),
	(469296, 124, '2015-04-01 00:11:58.000000', 'consum', 0.0214, 'lps'),
	(469297, 124, '2015-04-01 00:11:59.000000', 'consum', 0.0229, 'lps'),
	(469298, 124, '2015-04-01 00:12:00.000000', 'consum', 0.0217, 'lps'),
	(469299, 124, '2015-04-01 00:12:01.000000', 'consum', 0.0213, 'lps'),
	(469300, 124, '2015-04-01 00:12:02.000000', 'consum', 0.0230, 'lps'),
	(469301, 124, '2015-04-01 00:12:03.000000', 'consum', 0.0224, 'lps'),
	(469302, 124, '2015-04-01 00:12:04.000000', 'consum', 0.0221, 'lps'),
	(469303, 124, '2015-04-01 00:12:05.000000', 'consum', 0.0221, 'lps'),
	(469304, 124, '2015-04-01 00:12:06.000000', 'consum', 0.0210, 'lps'),
	(469305, 124, '2015-04-01 00:12:07.000000', 'consum', 0.0226, 'lps'),
	(469306, 124, '2015-04-01 00:12:08.000000', 'consum', 0.0214, 'lps'),
	(469307, 124, '2015-04-01 00:12:09.000000', 'consum', 0.0235, 'lps'),
	(469308, 124, '2015-04-01 00:12:10.000000', 'consum', 0.0220, 'lps'),
	(469309, 124, '2015-04-01 00:12:11.000000', 'consum', 0.0212, 'lps'),
	(469310, 124, '2015-04-01 00:12:12.000000', 'consum', 0.0216, 'lps'),
	(469311, 124, '2015-04-01 00:12:13.000000', 'consum', 0.0232, 'lps'),
	(469312, 124, '2015-04-01 00:12:14.000000', 'consum', 0.0228, 'lps'),
	(469313, 124, '2015-04-01 00:12:15.000000', 'consum', 0.0231, 'lps'),
	(469314, 124, '2015-04-01 00:12:16.000000', 'consum', 0.0213, 'lps'),
	(469315, 124, '2015-04-01 00:12:17.000000', 'consum', 0.0214, 'lps'),
	(469316, 124, '2015-04-01 00:12:18.000000', 'consum', 0.0219, 'lps'),
	(469317, 124, '2015-04-01 00:12:19.000000', 'consum', 0.0219, 'lps'),
	(469318, 124, '2015-04-01 00:12:20.000000', 'consum', 0.0230, 'lps'),
	(469319, 124, '2015-04-01 00:12:21.000000', 'consum', 0.0231, 'lps'),
	(469320, 124, '2015-04-01 00:12:22.000000', 'consum', 0.0230, 'lps'),
	(469321, 124, '2015-04-01 00:12:23.000000', 'consum', 0.0222, 'lps'),
	(469322, 124, '2015-04-01 00:12:24.000000', 'consum', 0.0234, 'lps'),
	(469323, 124, '2015-04-01 00:12:25.000000', 'consum', 0.0219, 'lps'),
	(469324, 124, '2015-04-01 00:12:26.000000', 'consum', 0.0232, 'lps'),
	(469325, 124, '2015-04-01 00:12:27.000000', 'consum', 0.0219, 'lps'),
	(469326, 124, '2015-04-01 00:12:28.000000', 'consum', 0.0215, 'lps'),
	(469327, 124, '2015-04-01 00:12:29.000000', 'consum', 0.0235, 'lps'),
	(469328, 124, '2015-04-01 00:12:30.000000', 'consum', 0.0217, 'lps'),
	(469329, 124, '2015-04-01 00:12:31.000000', 'consum', 0.0220, 'lps'),
	(469330, 124, '2015-04-01 00:12:32.000000', 'consum', 0.0217, 'lps'),
	(469331, 124, '2015-04-01 00:12:33.000000', 'consum', 0.0213, 'lps'),
	(469332, 124, '2015-04-01 00:12:34.000000', 'consum', 0.0230, 'lps'),
	(469333, 124, '2015-04-01 00:12:35.000000', 'consum', 0.0224, 'lps'),
	(469334, 124, '2015-04-01 00:12:36.000000', 'consum', 0.0222, 'lps'),
	(469335, 124, '2015-04-01 00:12:37.000000', 'consum', 0.0227, 'lps'),
	(469336, 124, '2015-04-01 00:12:38.000000', 'consum', 0.0235, 'lps'),
	(469337, 124, '2015-04-01 00:12:39.000000', 'consum', 0.0234, 'lps'),
	(469338, 124, '2015-04-01 00:12:40.000000', 'consum', 0.0227, 'lps'),
	(469339, 124, '2015-04-01 00:12:41.000000', 'consum', 0.0226, 'lps'),
	(469340, 124, '2015-04-01 00:12:42.000000', 'consum', 0.0211, 'lps'),
	(469341, 124, '2015-04-01 00:12:43.000000', 'consum', 0.0219, 'lps'),
	(469342, 124, '2015-04-01 00:12:44.000000', 'consum', 0.0226, 'lps'),
	(469343, 124, '2015-04-01 00:12:45.000000', 'consum', 0.0211, 'lps'),
	(469344, 124, '2015-04-01 00:12:46.000000', 'consum', 0.0222, 'lps'),
	(469345, 124, '2015-04-01 00:12:47.000000', 'consum', 0.0215, 'lps'),
	(469346, 124, '2015-04-01 00:12:48.000000', 'consum', 0.0227, 'lps'),
	(469347, 124, '2015-04-01 00:12:49.000000', 'consum', 0.0227, 'lps'),
	(469348, 124, '2015-04-01 00:12:50.000000', 'consum', 0.0218, 'lps'),
	(469349, 124, '2015-04-01 00:12:51.000000', 'consum', 0.0226, 'lps'),
	(469350, 124, '2015-04-01 00:12:52.000000', 'consum', 0.0213, 'lps'),
	(469351, 124, '2015-04-01 00:12:53.000000', 'consum', 0.0231, 'lps'),
	(469352, 124, '2015-04-01 00:12:54.000000', 'consum', 0.0228, 'lps'),
	(469353, 124, '2015-04-01 00:12:55.000000', 'consum', 0.0213, 'lps'),
	(469354, 124, '2015-04-01 00:12:56.000000', 'consum', 0.0224, 'lps'),
	(469355, 124, '2015-04-01 00:12:57.000000', 'consum', 0.0219, 'lps'),
	(469356, 124, '2015-04-01 00:12:58.000000', 'consum', 0.0215, 'lps'),
	(469357, 124, '2015-04-01 00:12:59.000000', 'consum', 0.0233, 'lps'),
	(469358, 124, '2015-04-01 00:13:00.000000', 'consum', 0.0232, 'lps'),
	(469359, 124, '2015-04-01 00:13:01.000000', 'consum', 0.0227, 'lps'),
	(469360, 124, '2015-04-01 00:13:02.000000', 'consum', 0.0228, 'lps'),
	(469361, 124, '2015-04-01 00:13:03.000000', 'consum', 0.0224, 'lps'),
	(469362, 124, '2015-04-01 00:13:04.000000', 'consum', 0.0225, 'lps'),
	(469363, 124, '2015-04-01 00:13:05.000000', 'consum', 0.0218, 'lps'),
	(469364, 124, '2015-04-01 00:13:06.000000', 'consum', 0.0233, 'lps'),
	(469365, 124, '2015-04-01 00:13:07.000000', 'consum', 0.0225, 'lps'),
	(469366, 124, '2015-04-01 00:13:08.000000', 'consum', 0.0214, 'lps'),
	(469367, 124, '2015-04-01 00:13:09.000000', 'consum', 0.0211, 'lps'),
	(469368, 124, '2015-04-01 00:13:10.000000', 'consum', 0.0231, 'lps'),
	(469369, 124, '2015-04-01 00:13:11.000000', 'consum', 0.0232, 'lps'),
	(469370, 124, '2015-04-01 00:13:12.000000', 'consum', 0.0235, 'lps'),
	(469371, 124, '2015-04-01 00:13:13.000000', 'consum', 0.0215, 'lps'),
	(469372, 124, '2015-04-01 00:13:14.000000', 'consum', 0.0212, 'lps'),
	(469373, 124, '2015-04-01 00:13:15.000000', 'consum', 0.0230, 'lps'),
	(469374, 124, '2015-04-01 00:13:16.000000', 'consum', 0.0230, 'lps'),
	(469375, 124, '2015-04-01 00:13:17.000000', 'consum', 0.0223, 'lps'),
	(469376, 124, '2015-04-01 00:13:18.000000', 'consum', 0.0216, 'lps'),
	(469377, 124, '2015-04-01 00:13:19.000000', 'consum', 0.0227, 'lps'),
	(469378, 124, '2015-04-01 00:13:20.000000', 'consum', 0.0225, 'lps'),
	(469379, 124, '2015-04-01 00:13:21.000000', 'consum', 0.0235, 'lps'),
	(469380, 124, '2015-04-01 00:13:22.000000', 'consum', 0.0214, 'lps'),
	(469381, 124, '2015-04-01 00:13:23.000000', 'consum', 0.0234, 'lps'),
	(469382, 124, '2015-04-01 00:13:24.000000', 'consum', 0.0212, 'lps'),
	(469383, 124, '2015-04-01 00:13:25.000000', 'consum', 0.0229, 'lps'),
	(469384, 124, '2015-04-01 00:13:26.000000', 'consum', 0.0222, 'lps'),
	(469385, 124, '2015-04-01 00:13:27.000000', 'consum', 0.0213, 'lps'),
	(469386, 124, '2015-04-01 00:13:28.000000', 'consum', 0.0217, 'lps'),
	(469387, 124, '2015-04-01 00:13:29.000000', 'consum', 0.0235, 'lps'),
	(469388, 124, '2015-04-01 00:13:30.000000', 'consum', 0.0235, 'lps'),
	(469389, 124, '2015-04-01 00:13:31.000000', 'consum', 0.0234, 'lps'),
	(469390, 124, '2015-04-01 00:13:32.000000', 'consum', 0.0233, 'lps'),
	(469391, 124, '2015-04-01 00:13:33.000000', 'consum', 0.0225, 'lps'),
	(469392, 124, '2015-04-01 00:13:34.000000', 'consum', 0.0215, 'lps'),
	(469393, 124, '2015-04-01 00:13:35.000000', 'consum', 0.0219, 'lps'),
	(469394, 124, '2015-04-01 00:13:36.000000', 'consum', 0.0215, 'lps'),
	(469395, 124, '2015-04-01 00:13:37.000000', 'consum', 0.0210, 'lps'),
	(469396, 124, '2015-04-01 00:13:38.000000', 'consum', 0.0219, 'lps'),
	(469397, 124, '2015-04-01 00:13:39.000000', 'consum', 0.0230, 'lps'),
	(469398, 124, '2015-04-01 00:13:40.000000', 'consum', 0.0231, 'lps'),
	(469399, 124, '2015-04-01 00:13:41.000000', 'consum', 0.0230, 'lps'),
	(469400, 124, '2015-04-01 00:13:42.000000', 'consum', 0.0223, 'lps'),
	(469401, 124, '2015-04-01 00:13:43.000000', 'consum', 0.0213, 'lps'),
	(469402, 124, '2015-04-01 00:13:44.000000', 'consum', 0.0213, 'lps'),
	(469403, 124, '2015-04-01 00:13:45.000000', 'consum', 0.0216, 'lps'),
	(469404, 124, '2015-04-01 00:13:46.000000', 'consum', 0.0233, 'lps'),
	(469405, 124, '2015-04-01 00:13:47.000000', 'consum', 0.0230, 'lps'),
	(469406, 124, '2015-04-01 00:13:48.000000', 'consum', 0.0213, 'lps'),
	(469407, 124, '2015-04-01 00:13:49.000000', 'consum', 0.0219, 'lps'),
	(469408, 124, '2015-04-01 00:13:50.000000', 'consum', 0.0221, 'lps'),
	(469409, 124, '2015-04-01 00:13:51.000000', 'consum', 0.0211, 'lps'),
	(469410, 124, '2015-04-01 00:13:52.000000', 'consum', 0.0234, 'lps'),
	(469411, 124, '2015-04-01 00:13:53.000000', 'consum', 0.0222, 'lps'),
	(469412, 124, '2015-04-01 00:13:54.000000', 'consum', 0.0227, 'lps'),
	(469413, 124, '2015-04-01 00:13:55.000000', 'consum', 0.0234, 'lps'),
	(469414, 124, '2015-04-01 00:13:56.000000', 'consum', 0.0225, 'lps'),
	(469415, 124, '2015-04-01 00:13:57.000000', 'consum', 0.0214, 'lps'),
	(469416, 124, '2015-04-01 00:13:58.000000', 'consum', 0.0214, 'lps'),
	(469417, 124, '2015-04-01 00:13:59.000000', 'consum', 0.0216, 'lps'),
	(469418, 124, '2015-04-01 00:14:00.000000', 'consum', 0.0227, 'lps'),
	(469419, 124, '2015-04-01 00:14:01.000000', 'consum', 0.0229, 'lps'),
	(469420, 124, '2015-04-01 00:14:02.000000', 'consum', 0.0228, 'lps'),
	(469421, 124, '2015-04-01 00:14:03.000000', 'consum', 0.0216, 'lps'),
	(469422, 124, '2015-04-01 00:14:04.000000', 'consum', 0.0214, 'lps'),
	(469423, 124, '2015-04-01 00:14:05.000000', 'consum', 0.0210, 'lps'),
	(469424, 124, '2015-04-01 00:14:06.000000', 'consum', 0.0225, 'lps'),
	(469425, 124, '2015-04-01 00:14:07.000000', 'consum', 0.0210, 'lps'),
	(469426, 124, '2015-04-01 00:14:08.000000', 'consum', 0.0217, 'lps'),
	(469427, 124, '2015-04-01 00:14:09.000000', 'consum', 0.0217, 'lps'),
	(469428, 124, '2015-04-01 00:14:10.000000', 'consum', 0.0226, 'lps'),
	(469429, 124, '2015-04-01 00:14:11.000000', 'consum', 0.0219, 'lps'),
	(469430, 124, '2015-04-01 00:14:12.000000', 'consum', 0.0230, 'lps'),
	(469431, 124, '2015-04-01 00:14:13.000000', 'consum', 0.0234, 'lps'),
	(469432, 124, '2015-04-01 00:14:14.000000', 'consum', 0.0219, 'lps'),
	(469433, 124, '2015-04-01 00:14:15.000000', 'consum', 0.0234, 'lps'),
	(469434, 124, '2015-04-01 00:14:16.000000', 'consum', 0.0227, 'lps'),
	(469435, 124, '2015-04-01 00:14:17.000000', 'consum', 0.0222, 'lps'),
	(469436, 124, '2015-04-01 00:14:18.000000', 'consum', 0.0220, 'lps'),
	(469437, 124, '2015-04-01 00:14:19.000000', 'consum', 0.0225, 'lps'),
	(469438, 124, '2015-04-01 00:14:20.000000', 'consum', 0.0230, 'lps'),
	(469439, 124, '2015-04-01 00:14:21.000000', 'consum', 0.0212, 'lps'),
	(469440, 124, '2015-04-01 00:14:22.000000', 'consum', 0.0214, 'lps'),
	(469441, 124, '2015-04-01 00:14:23.000000', 'consum', 0.0223, 'lps'),
	(469442, 124, '2015-04-01 00:14:24.000000', 'consum', 0.0211, 'lps'),
	(469443, 124, '2015-04-01 00:14:25.000000', 'consum', 0.0231, 'lps'),
	(469444, 124, '2015-04-01 00:14:26.000000', 'consum', 0.0234, 'lps'),
	(469445, 124, '2015-04-01 00:14:27.000000', 'consum', 0.0216, 'lps'),
	(469446, 124, '2015-04-01 00:14:28.000000', 'consum', 0.0220, 'lps'),
	(469447, 124, '2015-04-01 00:14:29.000000', 'consum', 0.0215, 'lps'),
	(469448, 124, '2015-04-01 00:14:30.000000', 'consum', 0.0231, 'lps'),
	(469449, 124, '2015-04-01 00:14:31.000000', 'consum', 0.0225, 'lps'),
	(469450, 124, '2015-04-01 00:14:32.000000', 'consum', 0.0223, 'lps'),
	(469451, 124, '2015-04-01 00:14:33.000000', 'consum', 0.0229, 'lps'),
	(469452, 124, '2015-04-01 00:14:34.000000', 'consum', 0.0214, 'lps'),
	(469453, 124, '2015-04-01 00:14:35.000000', 'consum', 0.0227, 'lps'),
	(469454, 124, '2015-04-01 00:14:36.000000', 'consum', 0.0229, 'lps'),
	(469455, 124, '2015-04-01 00:14:37.000000', 'consum', 0.0230, 'lps'),
	(469456, 124, '2015-04-01 00:14:38.000000', 'consum', 0.0225, 'lps'),
	(469457, 124, '2015-04-01 00:14:39.000000', 'consum', 0.0228, 'lps'),
	(469458, 124, '2015-04-01 00:14:40.000000', 'consum', 0.0229, 'lps'),
	(469459, 124, '2015-04-01 00:14:41.000000', 'consum', 0.0226, 'lps'),
	(469460, 124, '2015-04-01 00:14:42.000000', 'consum', 0.0235, 'lps'),
	(469461, 124, '2015-04-01 00:14:43.000000', 'consum', 0.0235, 'lps'),
	(469462, 124, '2015-04-01 00:14:44.000000', 'consum', 0.0233, 'lps'),
	(469463, 124, '2015-04-01 00:14:45.000000', 'consum', 0.0226, 'lps'),
	(469464, 124, '2015-04-01 00:14:46.000000', 'consum', 0.0219, 'lps'),
	(469465, 124, '2015-04-01 00:14:47.000000', 'consum', 0.0210, 'lps'),
	(469466, 124, '2015-04-01 00:14:48.000000', 'consum', 0.0234, 'lps'),
	(469467, 124, '2015-04-01 00:14:49.000000', 'consum', 0.0228, 'lps'),
	(469468, 124, '2015-04-01 00:14:50.000000', 'consum', 0.0226, 'lps'),
	(469469, 124, '2015-04-01 00:14:51.000000', 'consum', 0.0212, 'lps'),
	(469470, 124, '2015-04-01 00:14:52.000000', 'consum', 0.0224, 'lps'),
	(469471, 124, '2015-04-01 00:14:53.000000', 'consum', 0.0224, 'lps'),
	(469472, 124, '2015-04-01 00:14:54.000000', 'consum', 0.0211, 'lps'),
	(469473, 124, '2015-04-01 00:14:55.000000', 'consum', 0.0226, 'lps'),
	(469474, 124, '2015-04-01 00:14:56.000000', 'consum', 0.0211, 'lps'),
	(469475, 124, '2015-04-01 00:14:57.000000', 'consum', 0.0218, 'lps'),
	(469476, 124, '2015-04-01 00:14:58.000000', 'consum', 0.0220, 'lps'),
	(469477, 124, '2015-04-01 00:14:59.000000', 'consum', 0.0212, 'lps'),
	(469478, 124, '2015-04-01 00:15:00.000000', 'consum', 0.0216, 'lps'),
	(469479, 124, '2015-04-01 00:15:01.000000', 'consum', 0.0234, 'lps'),
	(469480, 124, '2015-04-01 00:15:02.000000', 'consum', 0.0211, 'lps'),
	(469481, 124, '2015-04-01 00:15:03.000000', 'consum', 0.0219, 'lps'),
	(469482, 124, '2015-04-01 00:15:04.000000', 'consum', 0.0227, 'lps'),
	(469483, 124, '2015-04-01 00:15:05.000000', 'consum', 0.0215, 'lps'),
	(469484, 124, '2015-04-01 00:15:06.000000', 'consum', 0.0211, 'lps'),
	(469485, 124, '2015-04-01 00:15:07.000000', 'consum', 0.0229, 'lps'),
	(469486, 124, '2015-04-01 00:15:08.000000', 'consum', 0.0223, 'lps'),
	(469487, 124, '2015-04-01 00:15:09.000000', 'consum', 0.0218, 'lps'),
	(469488, 124, '2015-04-01 00:15:10.000000', 'consum', 0.0212, 'lps'),
	(469489, 124, '2015-04-01 00:15:11.000000', 'consum', 0.0224, 'lps'),
	(469490, 124, '2015-04-01 00:15:12.000000', 'consum', 0.0223, 'lps'),
	(469491, 124, '2015-04-01 00:15:13.000000', 'consum', 0.0234, 'lps'),
	(469492, 124, '2015-04-01 00:15:14.000000', 'consum', 0.0214, 'lps'),
	(469493, 124, '2015-04-01 00:15:15.000000', 'consum', 0.0234, 'lps'),
	(469494, 124, '2015-04-01 00:15:16.000000', 'consum', 0.0216, 'lps'),
	(469495, 124, '2015-04-01 00:15:17.000000', 'consum', 0.0220, 'lps'),
	(469496, 124, '2015-04-01 00:15:18.000000', 'consum', 0.0215, 'lps'),
	(469497, 124, '2015-04-01 00:15:19.000000', 'consum', 0.0231, 'lps'),
	(469498, 124, '2015-04-01 00:15:20.000000', 'consum', 0.0222, 'lps'),
	(469499, 124, '2015-04-01 00:15:21.000000', 'consum', 0.0210, 'lps'),
	(469500, 124, '2015-04-01 00:15:22.000000', 'consum', 0.0227, 'lps'),
	(469501, 124, '2015-04-01 00:15:23.000000', 'consum', 0.0215, 'lps'),
	(469502, 124, '2015-04-01 00:15:24.000000', 'consum', 0.0211, 'lps'),
	(469503, 124, '2015-04-01 00:15:25.000000', 'consum', 0.0228, 'lps'),
	(469504, 124, '2015-04-01 00:15:26.000000', 'consum', 0.0217, 'lps'),
	(469505, 124, '2015-04-01 00:15:27.000000', 'consum', 0.0218, 'lps'),
	(469506, 124, '2015-04-01 00:15:28.000000', 'consum', 0.0230, 'lps'),
	(469507, 124, '2015-04-01 00:15:29.000000', 'consum', 0.0235, 'lps'),
	(469508, 124, '2015-04-01 00:15:30.000000', 'consum', 0.0225, 'lps'),
	(469509, 124, '2015-04-01 00:15:31.000000', 'consum', 0.0210, 'lps'),
	(469510, 124, '2015-04-01 00:15:32.000000', 'consum', 0.0216, 'lps'),
	(469511, 124, '2015-04-01 00:15:33.000000', 'consum', 0.0217, 'lps'),
	(469512, 124, '2015-04-01 00:15:34.000000', 'consum', 0.0227, 'lps'),
	(469513, 124, '2015-04-01 00:15:35.000000', 'consum', 0.0220, 'lps'),
	(469514, 124, '2015-04-01 00:15:36.000000', 'consum', 0.0212, 'lps'),
	(469515, 124, '2015-04-01 00:15:37.000000', 'consum', 0.0215, 'lps'),
	(469516, 124, '2015-04-01 00:15:38.000000', 'consum', 0.0228, 'lps'),
	(469517, 124, '2015-04-01 00:15:39.000000', 'consum', 0.0210, 'lps'),
	(469518, 124, '2015-04-01 00:15:40.000000', 'consum', 0.0234, 'lps'),
	(469519, 124, '2015-04-01 00:15:41.000000', 'consum', 0.0225, 'lps'),
	(469520, 124, '2015-04-01 00:15:42.000000', 'consum', 0.0216, 'lps'),
	(469521, 124, '2015-04-01 00:15:43.000000', 'consum', 0.0219, 'lps'),
	(469522, 124, '2015-04-01 00:15:44.000000', 'consum', 0.0212, 'lps'),
	(469523, 124, '2015-04-01 00:15:45.000000', 'consum', 0.0218, 'lps'),
	(469524, 124, '2015-04-01 00:15:46.000000', 'consum', 0.0220, 'lps'),
	(469525, 124, '2015-04-01 00:15:47.000000', 'consum', 0.0212, 'lps'),
	(469526, 124, '2015-04-01 00:15:48.000000', 'consum', 0.0217, 'lps'),
	(469527, 124, '2015-04-01 00:15:49.000000', 'consum', 0.0213, 'lps'),
	(469528, 124, '2015-04-01 00:15:50.000000', 'consum', 0.0229, 'lps'),
	(469529, 124, '2015-04-01 00:15:51.000000', 'consum', 0.0221, 'lps'),
	(469530, 124, '2015-04-01 00:15:52.000000', 'consum', 0.0233, 'lps'),
	(469531, 124, '2015-04-01 00:15:53.000000', 'consum', 0.0216, 'lps'),
	(469532, 124, '2015-04-01 00:15:54.000000', 'consum', 0.0222, 'lps'),
	(469533, 124, '2015-04-01 00:15:55.000000', 'consum', 0.0228, 'lps'),
	(469534, 124, '2015-04-01 00:15:56.000000', 'consum', 0.0211, 'lps'),
	(469535, 124, '2015-04-01 00:15:57.000000', 'consum', 0.0212, 'lps'),
	(469536, 124, '2015-04-01 00:15:58.000000', 'consum', 0.0220, 'lps'),
	(469537, 124, '2015-04-01 00:15:59.000000', 'consum', 0.0226, 'lps'),
	(469538, 124, '2015-04-01 00:16:00.000000', 'consum', 0.0210, 'lps'),
	(469539, 124, '2015-04-01 00:16:01.000000', 'consum', 0.0216, 'lps'),
	(469540, 124, '2015-04-01 00:16:02.000000', 'consum', 0.0211, 'lps'),
	(469541, 124, '2015-04-01 00:16:03.000000', 'consum', 0.0227, 'lps'),
	(469542, 124, '2015-04-01 00:16:04.000000', 'consum', 0.0213, 'lps'),
	(469543, 124, '2015-04-01 00:16:05.000000', 'consum', 0.0227, 'lps'),
	(469544, 124, '2015-04-01 00:16:06.000000', 'consum', 0.0210, 'lps'),
	(469545, 124, '2015-04-01 00:16:07.000000', 'consum', 0.0211, 'lps'),
	(469546, 124, '2015-04-01 00:16:08.000000', 'consum', 0.0216, 'lps'),
	(469547, 124, '2015-04-01 00:16:09.000000', 'consum', 0.0211, 'lps'),
	(469548, 124, '2015-04-01 00:16:10.000000', 'consum', 0.0223, 'lps'),
	(469549, 124, '2015-04-01 00:16:11.000000', 'consum', 0.0220, 'lps'),
	(469550, 124, '2015-04-01 00:16:12.000000', 'consum', 0.0222, 'lps'),
	(469551, 124, '2015-04-01 00:16:13.000000', 'consum', 0.0214, 'lps'),
	(469552, 124, '2015-04-01 00:16:14.000000', 'consum', 0.0221, 'lps'),
	(469553, 124, '2015-04-01 00:16:15.000000', 'consum', 0.0226, 'lps'),
	(469554, 124, '2015-04-01 00:16:16.000000', 'consum', 0.0233, 'lps'),
	(469555, 124, '2015-04-01 00:16:17.000000', 'consum', 0.0225, 'lps'),
	(469556, 124, '2015-04-01 00:16:18.000000', 'consum', 0.0217, 'lps'),
	(469557, 124, '2015-04-01 00:16:19.000000', 'consum', 0.0226, 'lps'),
	(469558, 124, '2015-04-01 00:16:20.000000', 'consum', 0.0216, 'lps'),
	(469559, 124, '2015-04-01 00:16:21.000000', 'consum', 0.0220, 'lps'),
	(469560, 124, '2015-04-01 00:16:22.000000', 'consum', 0.0216, 'lps'),
	(469561, 124, '2015-04-01 00:16:23.000000', 'consum', 0.0235, 'lps'),
	(469562, 124, '2015-04-01 00:16:24.000000', 'consum', 0.0215, 'lps'),
	(469563, 124, '2015-04-01 00:16:25.000000', 'consum', 0.0213, 'lps'),
	(469564, 124, '2015-04-01 00:16:26.000000', 'consum', 0.0234, 'lps'),
	(469565, 124, '2015-04-01 00:16:27.000000', 'consum', 0.0219, 'lps'),
	(469566, 124, '2015-04-01 00:16:28.000000', 'consum', 0.0210, 'lps'),
	(469567, 124, '2015-04-01 00:16:29.000000', 'consum', 0.0211, 'lps'),
	(469568, 124, '2015-04-01 00:16:30.000000', 'consum', 0.0213, 'lps'),
	(469569, 124, '2015-04-01 00:16:31.000000', 'consum', 0.0223, 'lps'),
	(469570, 124, '2015-04-01 00:16:32.000000', 'consum', 0.0213, 'lps'),
	(469571, 124, '2015-04-01 00:16:33.000000', 'consum', 0.0213, 'lps'),
	(469572, 124, '2015-04-01 00:16:34.000000', 'consum', 0.0216, 'lps'),
	(469573, 124, '2015-04-01 00:16:35.000000', 'consum', 0.0233, 'lps'),
	(469574, 124, '2015-04-01 00:16:36.000000', 'consum', 0.0230, 'lps'),
	(469575, 124, '2015-04-01 00:16:37.000000', 'consum', 0.0217, 'lps'),
	(469576, 124, '2015-04-01 00:16:38.000000', 'consum', 0.0235, 'lps'),
	(469577, 124, '2015-04-01 00:16:39.000000', 'consum', 0.0211, 'lps'),
	(469578, 124, '2015-04-01 00:16:40.000000', 'consum', 0.0218, 'lps'),
	(469579, 124, '2015-04-01 00:16:41.000000', 'consum', 0.0224, 'lps'),
	(469580, 124, '2015-04-01 00:16:42.000000', 'consum', 0.0227, 'lps'),
	(469581, 124, '2015-04-01 00:16:43.000000', 'consum', 0.0229, 'lps'),
	(469582, 124, '2015-04-01 00:16:44.000000', 'consum', 0.0229, 'lps'),
	(469583, 124, '2015-04-01 00:16:45.000000', 'consum', 0.0223, 'lps'),
	(469584, 124, '2015-04-01 00:16:46.000000', 'consum', 0.0219, 'lps'),
	(469585, 124, '2015-04-01 00:16:47.000000', 'consum', 0.0217, 'lps'),
	(469586, 124, '2015-04-01 00:16:48.000000', 'consum', 0.0216, 'lps'),
	(469587, 124, '2015-04-01 00:16:49.000000', 'consum', 0.0221, 'lps'),
	(469588, 124, '2015-04-01 00:16:50.000000', 'consum', 0.0220, 'lps'),
	(469589, 124, '2015-04-01 00:16:51.000000', 'consum', 0.0226, 'lps'),
	(469590, 124, '2015-04-01 00:16:52.000000', 'consum', 0.0212, 'lps'),
	(469591, 124, '2015-04-01 00:16:53.000000', 'consum', 0.0222, 'lps'),
	(469592, 124, '2015-04-01 00:16:54.000000', 'consum', 0.0215, 'lps'),
	(469593, 124, '2015-04-01 00:16:55.000000', 'consum', 0.0225, 'lps'),
	(469594, 124, '2015-04-01 00:16:56.000000', 'consum', 0.0217, 'lps'),
	(469595, 124, '2015-04-01 00:16:57.000000', 'consum', 0.0228, 'lps'),
	(469596, 124, '2015-04-01 00:16:58.000000', 'consum', 0.0228, 'lps'),
	(469597, 124, '2015-04-01 00:16:59.000000', 'consum', 0.0220, 'lps'),
	(469598, 124, '2015-04-01 00:17:00.000000', 'consum', 0.0231, 'lps'),
	(469599, 124, '2015-04-01 00:17:01.000000', 'consum', 0.0234, 'lps'),
	(469600, 124, '2015-04-01 00:17:02.000000', 'consum', 0.0214, 'lps'),
	(469601, 124, '2015-04-01 00:17:03.000000', 'consum', 0.0212, 'lps'),
	(469602, 124, '2015-04-01 00:17:04.000000', 'consum', 0.0210, 'lps'),
	(469603, 124, '2015-04-01 00:17:05.000000', 'consum', 0.0228, 'lps'),
	(469604, 124, '2015-04-01 00:17:06.000000', 'consum', 0.0222, 'lps'),
	(469605, 124, '2015-04-01 00:17:07.000000', 'consum', 0.0216, 'lps'),
	(469606, 124, '2015-04-01 00:17:08.000000', 'consum', 0.0232, 'lps'),
	(469607, 124, '2015-04-01 00:17:09.000000', 'consum', 0.0222, 'lps'),
	(469608, 124, '2015-04-01 00:17:10.000000', 'consum', 0.0234, 'lps'),
	(469609, 124, '2015-04-01 00:17:11.000000', 'consum', 0.0214, 'lps'),
	(469610, 124, '2015-04-01 00:17:12.000000', 'consum', 0.0213, 'lps'),
	(469611, 124, '2015-04-01 00:17:13.000000', 'consum', 0.0211, 'lps'),
	(469612, 124, '2015-04-01 00:17:14.000000', 'consum', 0.0233, 'lps'),
	(469613, 124, '2015-04-01 00:17:15.000000', 'consum', 0.0220, 'lps'),
	(469614, 124, '2015-04-01 00:17:16.000000', 'consum', 0.0217, 'lps'),
	(469615, 124, '2015-04-01 00:17:17.000000', 'consum', 0.0217, 'lps'),
	(469616, 124, '2015-04-01 00:17:18.000000', 'consum', 0.0224, 'lps'),
	(469617, 124, '2015-04-01 00:17:19.000000', 'consum', 0.0234, 'lps'),
	(469618, 124, '2015-04-01 00:17:20.000000', 'consum', 0.0234, 'lps'),
	(469619, 124, '2015-04-01 00:17:21.000000', 'consum', 0.0234, 'lps'),
	(469620, 124, '2015-04-01 00:17:22.000000', 'consum', 0.0234, 'lps'),
	(469621, 124, '2015-04-01 00:17:23.000000', 'consum', 0.0231, 'lps'),
	(469622, 124, '2015-04-01 00:17:24.000000', 'consum', 0.0218, 'lps'),
	(469623, 124, '2015-04-01 00:17:25.000000', 'consum', 0.0213, 'lps'),
	(469624, 124, '2015-04-01 00:17:26.000000', 'consum', 0.0227, 'lps'),
	(469625, 124, '2015-04-01 00:17:27.000000', 'consum', 0.0211, 'lps'),
	(469626, 124, '2015-04-01 00:17:28.000000', 'consum', 0.0215, 'lps'),
	(469627, 124, '2015-04-01 00:17:29.000000', 'consum', 0.0233, 'lps'),
	(469628, 124, '2015-04-01 00:17:30.000000', 'consum', 0.0231, 'lps'),
	(469629, 124, '2015-04-01 00:17:31.000000', 'consum', 0.0220, 'lps'),
	(469630, 124, '2015-04-01 00:17:32.000000', 'consum', 0.0223, 'lps'),
	(469631, 124, '2015-04-01 00:17:33.000000', 'consum', 0.0219, 'lps'),
	(469632, 124, '2015-04-01 00:17:34.000000', 'consum', 0.0215, 'lps'),
	(469633, 124, '2015-04-01 00:17:35.000000', 'consum', 0.0212, 'lps'),
	(469634, 124, '2015-04-01 00:17:36.000000', 'consum', 0.0232, 'lps'),
	(469635, 124, '2015-04-01 00:17:37.000000', 'consum', 0.0234, 'lps'),
	(469636, 124, '2015-04-01 00:17:38.000000', 'consum', 0.0214, 'lps'),
	(469637, 124, '2015-04-01 00:17:39.000000', 'consum', 0.0210, 'lps'),
	(469638, 124, '2015-04-01 00:17:40.000000', 'consum', 0.0225, 'lps'),
	(469639, 124, '2015-04-01 00:17:41.000000', 'consum', 0.0232, 'lps'),
	(469640, 124, '2015-04-01 00:17:42.000000', 'consum', 0.0226, 'lps'),
	(469641, 124, '2015-04-01 00:17:43.000000', 'consum', 0.0222, 'lps'),
	(469642, 124, '2015-04-01 00:17:44.000000', 'consum', 0.0222, 'lps'),
	(469643, 124, '2015-04-01 00:17:45.000000', 'consum', 0.0235, 'lps'),
	(469644, 124, '2015-04-01 00:17:46.000000', 'consum', 0.0222, 'lps'),
	(469645, 124, '2015-04-01 00:17:47.000000', 'consum', 0.0223, 'lps'),
	(469646, 124, '2015-04-01 00:17:48.000000', 'consum', 0.0213, 'lps'),
	(469647, 124, '2015-04-01 00:17:49.000000', 'consum', 0.0213, 'lps'),
	(469648, 124, '2015-04-01 00:17:50.000000', 'consum', 0.0217, 'lps'),
	(469649, 124, '2015-04-01 00:17:51.000000', 'consum', 0.0234, 'lps'),
	(469650, 124, '2015-04-01 00:17:52.000000', 'consum', 0.0233, 'lps'),
	(469651, 124, '2015-04-01 00:17:53.000000', 'consum', 0.0225, 'lps'),
	(469652, 124, '2015-04-01 00:17:54.000000', 'consum', 0.0220, 'lps'),
	(469653, 124, '2015-04-01 00:17:55.000000', 'consum', 0.0213, 'lps'),
	(469654, 124, '2015-04-01 00:17:56.000000', 'consum', 0.0222, 'lps'),
	(469655, 124, '2015-04-01 00:17:57.000000', 'consum', 0.0210, 'lps'),
	(469656, 124, '2015-04-01 00:17:58.000000', 'consum', 0.0224, 'lps'),
	(469657, 124, '2015-04-01 00:17:59.000000', 'consum', 0.0231, 'lps'),
	(469658, 124, '2015-04-01 00:18:00.000000', 'consum', 0.0221, 'lps'),
	(469659, 124, '2015-04-01 00:18:01.000000', 'consum', 0.0228, 'lps'),
	(469660, 124, '2015-04-01 00:18:02.000000', 'consum', 0.0217, 'lps'),
	(469661, 124, '2015-04-01 00:18:03.000000', 'consum', 0.0217, 'lps'),
	(469662, 124, '2015-04-01 00:18:04.000000', 'consum', 0.0224, 'lps'),
	(469663, 124, '2015-04-01 00:18:05.000000', 'consum', 0.0233, 'lps'),
	(469664, 124, '2015-04-01 00:18:06.000000', 'consum', 0.0230, 'lps'),
	(469665, 124, '2015-04-01 00:18:07.000000', 'consum', 0.0219, 'lps'),
	(469666, 124, '2015-04-01 00:18:08.000000', 'consum', 0.0219, 'lps'),
	(469667, 124, '2015-04-01 00:18:09.000000', 'consum', 0.0230, 'lps'),
	(469668, 124, '2015-04-01 00:18:10.000000', 'consum', 0.0230, 'lps'),
	(469669, 124, '2015-04-01 00:18:11.000000', 'consum', 0.0226, 'lps'),
	(469670, 124, '2015-04-01 00:18:12.000000', 'consum', 0.0230, 'lps'),
	(469671, 124, '2015-04-01 00:18:13.000000', 'consum', 0.0235, 'lps'),
	(469672, 124, '2015-04-01 00:18:14.000000', 'consum', 0.0225, 'lps'),
	(469673, 124, '2015-04-01 00:18:15.000000', 'consum', 0.0235, 'lps'),
	(469674, 124, '2015-04-01 00:18:16.000000', 'consum', 0.0212, 'lps'),
	(469675, 124, '2015-04-01 00:18:17.000000', 'consum', 0.0223, 'lps'),
	(469676, 124, '2015-04-01 00:18:18.000000', 'consum', 0.0217, 'lps'),
	(469677, 124, '2015-04-01 00:18:19.000000', 'consum', 0.0232, 'lps'),
	(469678, 124, '2015-04-01 00:18:20.000000', 'consum', 0.0222, 'lps'),
	(469679, 124, '2015-04-01 00:18:21.000000', 'consum', 0.0229, 'lps'),
	(469680, 124, '2015-04-01 00:18:22.000000', 'consum', 0.0219, 'lps'),
	(469681, 124, '2015-04-01 00:18:23.000000', 'consum', 0.0224, 'lps'),
	(469682, 124, '2015-04-01 00:18:24.000000', 'consum', 0.0228, 'lps'),
	(469683, 124, '2015-04-01 00:18:25.000000', 'consum', 0.0233, 'lps'),
	(469684, 124, '2015-04-01 00:18:26.000000', 'consum', 0.0218, 'lps'),
	(469685, 124, '2015-04-01 00:18:27.000000', 'consum', 0.0235, 'lps'),
	(469686, 124, '2015-04-01 00:18:28.000000', 'consum', 0.0234, 'lps'),
	(469687, 124, '2015-04-01 00:18:29.000000', 'consum', 0.0229, 'lps'),
	(469688, 124, '2015-04-01 00:18:30.000000', 'consum', 0.0233, 'lps'),
	(469689, 124, '2015-04-01 00:18:31.000000', 'consum', 0.0215, 'lps'),
	(469690, 124, '2015-04-01 00:18:32.000000', 'consum', 0.0219, 'lps'),
	(469691, 124, '2015-04-01 00:18:33.000000', 'consum', 0.0213, 'lps'),
	(469692, 124, '2015-04-01 00:18:34.000000', 'consum', 0.0225, 'lps'),
	(469693, 124, '2015-04-01 00:18:35.000000', 'consum', 0.0227, 'lps'),
	(469694, 124, '2015-04-01 00:18:36.000000', 'consum', 0.0221, 'lps'),
	(469695, 124, '2015-04-01 00:18:37.000000', 'consum', 0.0217, 'lps'),
	(469696, 124, '2015-04-01 00:18:38.000000', 'consum', 0.0213, 'lps'),
	(469697, 124, '2015-04-01 00:18:39.000000', 'consum', 0.0230, 'lps'),
	(469698, 124, '2015-04-01 00:18:40.000000', 'consum', 0.0224, 'lps'),
	(469699, 124, '2015-04-01 00:18:41.000000', 'consum', 0.0221, 'lps'),
	(469700, 124, '2015-04-01 00:18:42.000000', 'consum', 0.0221, 'lps'),
	(469701, 124, '2015-04-01 00:18:43.000000', 'consum', 0.0233, 'lps'),
	(469702, 124, '2015-04-01 00:18:44.000000', 'consum', 0.0216, 'lps'),
	(469703, 124, '2015-04-01 00:18:45.000000', 'consum', 0.0222, 'lps'),
	(469704, 124, '2015-04-01 00:18:46.000000', 'consum', 0.0227, 'lps'),
	(469705, 124, '2015-04-01 00:18:47.000000', 'consum', 0.0210, 'lps'),
	(469706, 124, '2015-04-01 00:18:48.000000', 'consum', 0.0234, 'lps'),
	(469707, 124, '2015-04-01 00:18:49.000000', 'consum', 0.0230, 'lps'),
	(469708, 124, '2015-04-01 00:18:50.000000', 'consum', 0.0210, 'lps'),
	(469709, 124, '2015-04-01 00:18:51.000000', 'consum', 0.0229, 'lps'),
	(469710, 124, '2015-04-01 00:18:52.000000', 'consum', 0.0229, 'lps'),
	(469711, 124, '2015-04-01 00:18:53.000000', 'consum', 0.0223, 'lps'),
	(469712, 124, '2015-04-01 00:18:54.000000', 'consum', 0.0215, 'lps'),
	(469713, 124, '2015-04-01 00:18:55.000000', 'consum', 0.0226, 'lps'),
	(469714, 124, '2015-04-01 00:18:56.000000', 'consum', 0.0224, 'lps'),
	(469715, 124, '2015-04-01 00:18:57.000000', 'consum', 0.0230, 'lps'),
	(469716, 124, '2015-04-01 00:18:58.000000', 'consum', 0.0216, 'lps'),
	(469717, 124, '2015-04-01 00:18:59.000000', 'consum', 0.0235, 'lps'),
	(469718, 124, '2015-04-01 00:19:00.000000', 'consum', 0.0214, 'lps'),
	(469719, 124, '2015-04-01 00:19:01.000000', 'consum', 0.0231, 'lps'),
	(469720, 124, '2015-04-01 00:19:02.000000', 'consum', 0.0227, 'lps'),
	(469721, 124, '2015-04-01 00:19:03.000000', 'consum', 0.0231, 'lps'),
	(469722, 124, '2015-04-01 00:19:04.000000', 'consum', 0.0214, 'lps'),
	(469723, 124, '2015-04-01 00:19:05.000000', 'consum', 0.0220, 'lps'),
	(469724, 124, '2015-04-01 00:19:06.000000', 'consum', 0.0223, 'lps'),
	(469725, 124, '2015-04-01 00:19:07.000000', 'consum', 0.0218, 'lps'),
	(469726, 124, '2015-04-01 00:19:08.000000', 'consum', 0.0213, 'lps'),
	(469727, 124, '2015-04-01 00:19:09.000000', 'consum', 0.0228, 'lps'),
	(469728, 124, '2015-04-01 00:19:10.000000', 'consum', 0.0213, 'lps'),
	(469729, 124, '2015-04-01 00:19:11.000000', 'consum', 0.0221, 'lps'),
	(469730, 124, '2015-04-01 00:19:12.000000', 'consum', 0.0234, 'lps'),
	(469731, 124, '2015-04-01 00:19:13.000000', 'consum', 0.0219, 'lps'),
	(469732, 124, '2015-04-01 00:19:14.000000', 'consum', 0.0235, 'lps'),
	(469733, 124, '2015-04-01 00:19:15.000000', 'consum', 0.0231, 'lps'),
	(469734, 124, '2015-04-01 00:19:16.000000', 'consum', 0.0216, 'lps'),
	(469735, 124, '2015-04-01 00:19:17.000000', 'consum', 0.0228, 'lps'),
	(469736, 124, '2015-04-01 00:19:18.000000', 'consum', 0.0229, 'lps'),
	(469737, 124, '2015-04-01 00:19:19.000000', 'consum', 0.0227, 'lps'),
	(469738, 124, '2015-04-01 00:19:20.000000', 'consum', 0.0213, 'lps'),
	(469739, 124, '2015-04-01 00:19:21.000000', 'consum', 0.0227, 'lps'),
	(469740, 124, '2015-04-01 00:19:22.000000', 'consum', 0.0232, 'lps'),
	(469741, 124, '2015-04-01 00:19:23.000000', 'consum', 0.0220, 'lps'),
	(469742, 124, '2015-04-01 00:19:24.000000', 'consum', 0.0221, 'lps'),
	(469743, 124, '2015-04-01 00:19:25.000000', 'consum', 0.0210, 'lps'),
	(469744, 124, '2015-04-01 00:19:26.000000', 'consum', 0.0227, 'lps'),
	(469745, 124, '2015-04-01 00:19:27.000000', 'consum', 0.0217, 'lps'),
	(469746, 124, '2015-04-01 00:19:28.000000', 'consum', 0.0220, 'lps'),
	(469747, 124, '2015-04-01 00:19:29.000000', 'consum', 0.0215, 'lps'),
	(469748, 124, '2015-04-01 00:19:30.000000', 'consum', 0.0233, 'lps'),
	(469749, 124, '2015-04-01 00:19:31.000000', 'consum', 0.0230, 'lps'),
	(469750, 124, '2015-04-01 00:19:32.000000', 'consum', 0.0215, 'lps'),
	(469751, 124, '2015-04-01 00:19:33.000000', 'consum', 0.0229, 'lps'),
	(469752, 124, '2015-04-01 00:19:34.000000', 'consum', 0.0212, 'lps'),
	(469753, 124, '2015-04-01 00:19:35.000000', 'consum', 0.0214, 'lps'),
	(469754, 124, '2015-04-01 00:19:36.000000', 'consum', 0.0224, 'lps'),
	(469755, 124, '2015-04-01 00:19:37.000000', 'consum', 0.0220, 'lps'),
	(469756, 124, '2015-04-01 00:19:38.000000', 'consum', 0.0215, 'lps'),
	(469757, 124, '2015-04-01 00:19:39.000000', 'consum', 0.0232, 'lps'),
	(469758, 124, '2015-04-01 00:19:40.000000', 'consum', 0.0227, 'lps'),
	(469759, 124, '2015-04-01 00:19:41.000000', 'consum', 0.0228, 'lps'),
	(469760, 124, '2015-04-01 00:19:42.000000', 'consum', 0.0227, 'lps'),
	(469761, 124, '2015-04-01 00:19:43.000000', 'consum', 0.0214, 'lps'),
	(469762, 124, '2015-04-01 00:19:44.000000', 'consum', 0.0233, 'lps'),
	(469763, 124, '2015-04-01 00:19:45.000000', 'consum', 0.0234, 'lps'),
	(469764, 124, '2015-04-01 00:19:46.000000', 'consum', 0.0210, 'lps'),
	(469765, 124, '2015-04-01 00:19:47.000000', 'consum', 0.0215, 'lps'),
	(469766, 124, '2015-04-01 00:19:48.000000', 'consum', 0.0235, 'lps'),
	(469767, 124, '2015-04-01 00:19:49.000000', 'consum', 0.0216, 'lps'),
	(469768, 124, '2015-04-01 00:19:50.000000', 'consum', 0.0219, 'lps'),
	(469769, 124, '2015-04-01 00:19:51.000000', 'consum', 0.0212, 'lps'),
	(469770, 124, '2015-04-01 00:19:52.000000', 'consum', 0.0217, 'lps'),
	(469771, 124, '2015-04-01 00:19:53.000000', 'consum', 0.0214, 'lps'),
	(469772, 124, '2015-04-01 00:19:54.000000', 'consum', 0.0210, 'lps'),
	(469773, 124, '2015-04-01 00:19:55.000000', 'consum', 0.0225, 'lps'),
	(469774, 124, '2015-04-01 00:19:56.000000', 'consum', 0.0233, 'lps'),
	(469775, 124, '2015-04-01 00:19:57.000000', 'consum', 0.0231, 'lps'),
	(469776, 124, '2015-04-01 00:19:58.000000', 'consum', 0.0217, 'lps'),
	(469777, 124, '2015-04-01 00:19:59.000000', 'consum', 0.0212, 'lps'),
	(469778, 124, '2015-04-01 00:20:00.000000', 'consum', 0.0223, 'lps'),
	(469779, 124, '2015-04-01 00:20:01.000000', 'consum', 0.0216, 'lps'),
	(469780, 124, '2015-04-01 00:20:02.000000', 'consum', 0.0229, 'lps'),
	(469781, 124, '2015-04-01 00:20:03.000000', 'consum', 0.0211, 'lps'),
	(469782, 124, '2015-04-01 00:20:04.000000', 'consum', 0.0210, 'lps'),
	(469783, 124, '2015-04-01 00:20:05.000000', 'consum', 0.0233, 'lps'),
	(469784, 124, '2015-04-01 00:20:06.000000', 'consum', 0.0221, 'lps'),
	(469785, 124, '2015-04-01 00:20:07.000000', 'consum', 0.0222, 'lps'),
	(469786, 124, '2015-04-01 00:20:08.000000', 'consum', 0.0211, 'lps'),
	(469787, 124, '2015-04-01 00:20:09.000000', 'consum', 0.0233, 'lps'),
	(469788, 124, '2015-04-01 00:20:10.000000', 'consum', 0.0219, 'lps'),
	(469789, 124, '2015-04-01 00:20:11.000000', 'consum', 0.0211, 'lps'),
	(469790, 124, '2015-04-01 00:20:12.000000', 'consum', 0.0214, 'lps'),
	(469791, 124, '2015-04-01 00:20:13.000000', 'consum', 0.0229, 'lps'),
	(469792, 124, '2015-04-01 00:20:14.000000', 'consum', 0.0216, 'lps'),
	(469793, 124, '2015-04-01 00:20:15.000000', 'consum', 0.0210, 'lps'),
	(469794, 124, '2015-04-01 00:20:16.000000', 'consum', 0.0216, 'lps'),
	(469795, 124, '2015-04-01 00:20:17.000000', 'consum', 0.0216, 'lps'),
	(469796, 124, '2015-04-01 00:20:18.000000', 'consum', 0.0224, 'lps'),
	(469797, 124, '2015-04-01 00:20:19.000000', 'consum', 0.0210, 'lps'),
	(469798, 124, '2015-04-01 00:20:20.000000', 'consum', 0.0220, 'lps'),
	(469799, 124, '2015-04-01 00:20:21.000000', 'consum', 0.0234, 'lps'),
	(469800, 124, '2015-04-01 00:20:22.000000', 'consum', 0.0223, 'lps'),
	(469801, 124, '2015-04-01 00:20:23.000000', 'consum', 0.0228, 'lps'),
	(469802, 124, '2015-04-01 00:20:24.000000', 'consum', 0.0210, 'lps'),
	(469803, 124, '2015-04-01 00:20:25.000000', 'consum', 0.0234, 'lps'),
	(469804, 124, '2015-04-01 00:20:26.000000', 'consum', 0.0225, 'lps'),
	(469805, 124, '2015-04-01 00:20:27.000000', 'consum', 0.0215, 'lps'),
	(469806, 124, '2015-04-01 00:20:28.000000', 'consum', 0.0216, 'lps'),
	(469807, 124, '2015-04-01 00:20:29.000000', 'consum', 0.0225, 'lps'),
	(469808, 124, '2015-04-01 00:20:30.000000', 'consum', 0.0216, 'lps'),
	(469809, 124, '2015-04-01 00:20:31.000000', 'consum', 0.0221, 'lps'),
	(469810, 124, '2015-04-01 00:20:32.000000', 'consum', 0.0220, 'lps'),
	(469811, 124, '2015-04-01 00:20:33.000000', 'consum', 0.0230, 'lps'),
	(469812, 124, '2015-04-01 00:20:34.000000', 'consum', 0.0229, 'lps'),
	(469813, 124, '2015-04-01 00:20:35.000000', 'consum', 0.0217, 'lps'),
	(469814, 124, '2015-04-01 00:20:36.000000', 'consum', 0.0214, 'lps'),
	(469815, 124, '2015-04-01 00:20:37.000000', 'consum', 0.0210, 'lps'),
	(469816, 124, '2015-04-01 00:20:38.000000', 'consum', 0.0226, 'lps'),
	(469817, 124, '2015-04-01 00:20:39.000000', 'consum', 0.0213, 'lps'),
	(469818, 124, '2015-04-01 00:20:40.000000', 'consum', 0.0228, 'lps'),
	(469819, 124, '2015-04-01 00:20:41.000000', 'consum', 0.0213, 'lps'),
	(469820, 124, '2015-04-01 00:20:42.000000', 'consum', 0.0226, 'lps'),
	(469821, 124, '2015-04-01 00:20:43.000000', 'consum', 0.0227, 'lps'),
	(469822, 124, '2015-04-01 00:20:44.000000', 'consum', 0.0222, 'lps'),
	(469823, 124, '2015-04-01 00:20:45.000000', 'consum', 0.0218, 'lps'),
	(469824, 124, '2015-04-01 00:20:46.000000', 'consum', 0.0217, 'lps'),
	(469825, 124, '2015-04-01 00:20:47.000000', 'consum', 0.0222, 'lps'),
	(469826, 124, '2015-04-01 00:20:48.000000', 'consum', 0.0223, 'lps'),
	(469827, 124, '2015-04-01 00:20:49.000000', 'consum', 0.0215, 'lps'),
	(469828, 124, '2015-04-01 00:20:50.000000', 'consum', 0.0221, 'lps'),
	(469829, 124, '2015-04-01 00:20:51.000000', 'consum', 0.0224, 'lps'),
	(469830, 124, '2015-04-01 00:20:52.000000', 'consum', 0.0222, 'lps'),
	(469831, 124, '2015-04-01 00:20:53.000000', 'consum', 0.0228, 'lps'),
	(469832, 124, '2015-04-01 00:20:54.000000', 'consum', 0.0214, 'lps'),
	(469833, 124, '2015-04-01 00:20:55.000000', 'consum', 0.0229, 'lps'),
	(469834, 124, '2015-04-01 00:20:56.000000', 'consum', 0.0213, 'lps'),
	(469835, 124, '2015-04-01 00:20:57.000000', 'consum', 0.0220, 'lps'),
	(469836, 124, '2015-04-01 00:20:58.000000', 'consum', 0.0229, 'lps'),
	(469837, 124, '2015-04-01 00:20:59.000000', 'consum', 0.0220, 'lps'),
	(469838, 124, '2015-04-01 00:21:00.000000', 'consum', 0.0232, 'lps'),
	(469839, 124, '2015-04-01 00:21:01.000000', 'consum', 0.0213, 'lps'),
	(469840, 124, '2015-04-01 00:21:02.000000', 'consum', 0.0212, 'lps'),
	(469841, 124, '2015-04-01 00:21:03.000000', 'consum', 0.0211, 'lps'),
	(469842, 124, '2015-04-01 00:21:04.000000', 'consum', 0.0233, 'lps'),
	(469843, 124, '2015-04-01 00:21:05.000000', 'consum', 0.0221, 'lps'),
	(469844, 124, '2015-04-01 00:21:06.000000', 'consum', 0.0223, 'lps'),
	(469845, 124, '2015-04-01 00:21:07.000000', 'consum', 0.0215, 'lps'),
	(469846, 124, '2015-04-01 00:21:08.000000', 'consum', 0.0225, 'lps'),
	(469847, 124, '2015-04-01 00:21:09.000000', 'consum', 0.0217, 'lps'),
	(469848, 124, '2015-04-01 00:21:10.000000', 'consum', 0.0226, 'lps'),
	(469849, 124, '2015-04-01 00:21:11.000000', 'consum', 0.0219, 'lps'),
	(469850, 124, '2015-04-01 00:21:12.000000', 'consum', 0.0232, 'lps'),
	(469851, 124, '2015-04-01 00:21:13.000000', 'consum', 0.0217, 'lps'),
	(469852, 124, '2015-04-01 00:21:14.000000', 'consum', 0.0230, 'lps'),
	(469853, 124, '2015-04-01 00:21:15.000000', 'consum', 0.0213, 'lps'),
	(469854, 124, '2015-04-01 00:21:16.000000', 'consum', 0.0219, 'lps'),
	(469855, 124, '2015-04-01 00:21:17.000000', 'consum', 0.0218, 'lps'),
	(469856, 124, '2015-04-01 00:21:18.000000', 'consum', 0.0225, 'lps'),
	(469857, 124, '2015-04-01 00:21:19.000000', 'consum', 0.0234, 'lps'),
	(469858, 124, '2015-04-01 00:21:20.000000', 'consum', 0.0210, 'lps'),
	(469859, 124, '2015-04-01 00:21:21.000000', 'consum', 0.0215, 'lps'),
	(469860, 124, '2015-04-01 00:21:22.000000', 'consum', 0.0235, 'lps'),
	(469861, 124, '2015-04-01 00:21:23.000000', 'consum', 0.0215, 'lps'),
	(469862, 124, '2015-04-01 00:21:24.000000', 'consum', 0.0215, 'lps'),
	(469863, 124, '2015-04-01 00:21:25.000000', 'consum', 0.0219, 'lps'),
	(469864, 124, '2015-04-01 00:21:26.000000', 'consum', 0.0215, 'lps'),
	(469865, 124, '2015-04-01 00:21:27.000000', 'consum', 0.0234, 'lps'),
	(469866, 124, '2015-04-01 00:21:28.000000', 'consum', 0.0212, 'lps'),
	(469867, 124, '2015-04-01 00:21:29.000000', 'consum', 0.0227, 'lps'),
	(469868, 124, '2015-04-01 00:21:30.000000', 'consum', 0.0235, 'lps'),
	(469869, 124, '2015-04-01 00:21:31.000000', 'consum', 0.0235, 'lps'),
	(469870, 124, '2015-04-01 00:21:32.000000', 'consum', 0.0235, 'lps'),
	(469871, 124, '2015-04-01 00:21:33.000000', 'consum', 0.0235, 'lps'),
	(469872, 124, '2015-04-01 00:21:34.000000', 'consum', 0.0233, 'lps'),
	(469873, 124, '2015-04-01 00:21:35.000000', 'consum', 0.0224, 'lps'),
	(469874, 124, '2015-04-01 00:21:36.000000', 'consum', 0.0214, 'lps'),
	(469875, 124, '2015-04-01 00:21:37.000000', 'consum', 0.0212, 'lps'),
	(469876, 124, '2015-04-01 00:21:38.000000', 'consum', 0.0210, 'lps'),
	(469877, 124, '2015-04-01 00:21:39.000000', 'consum', 0.0232, 'lps'),
	(469878, 124, '2015-04-01 00:21:40.000000', 'consum', 0.0213, 'lps'),
	(469879, 124, '2015-04-01 00:21:41.000000', 'consum', 0.0214, 'lps'),
	(469880, 124, '2015-04-01 00:21:42.000000', 'consum', 0.0222, 'lps'),
	(469881, 124, '2015-04-01 00:21:43.000000', 'consum', 0.0232, 'lps'),
	(469882, 124, '2015-04-01 00:21:44.000000', 'consum', 0.0230, 'lps'),
	(469883, 124, '2015-04-01 00:21:45.000000', 'consum', 0.0222, 'lps'),
	(469884, 124, '2015-04-01 00:21:46.000000', 'consum', 0.0235, 'lps'),
	(469885, 124, '2015-04-01 00:21:47.000000', 'consum', 0.0220, 'lps'),
	(469886, 124, '2015-04-01 00:21:48.000000', 'consum', 0.0214, 'lps'),
	(469887, 124, '2015-04-01 00:21:49.000000', 'consum', 0.0226, 'lps'),
	(469888, 124, '2015-04-01 00:21:50.000000', 'consum', 0.0225, 'lps'),
	(469889, 124, '2015-04-01 00:21:51.000000', 'consum', 0.0211, 'lps'),
	(469890, 124, '2015-04-01 00:21:52.000000', 'consum', 0.0222, 'lps'),
	(469891, 124, '2015-04-01 00:21:53.000000', 'consum', 0.0215, 'lps'),
	(469892, 124, '2015-04-01 00:21:54.000000', 'consum', 0.0226, 'lps'),
	(469893, 124, '2015-04-01 00:21:55.000000', 'consum', 0.0225, 'lps'),
	(469894, 124, '2015-04-01 00:21:56.000000', 'consum', 0.0211, 'lps'),
	(469895, 124, '2015-04-01 00:21:57.000000', 'consum', 0.0221, 'lps'),
	(469896, 124, '2015-04-01 00:21:58.000000', 'consum', 0.0212, 'lps'),
	(469897, 124, '2015-04-01 00:21:59.000000', 'consum', 0.0212, 'lps'),
	(469898, 124, '2015-04-01 00:22:00.000000', 'consum', 0.0216, 'lps'),
	(469899, 124, '2015-04-01 00:22:01.000000', 'consum', 0.0232, 'lps'),
	(469900, 124, '2015-04-01 00:22:02.000000', 'consum', 0.0225, 'lps'),
	(469901, 124, '2015-04-01 00:22:03.000000', 'consum', 0.0222, 'lps'),
	(469902, 124, '2015-04-01 00:22:04.000000', 'consum', 0.0224, 'lps'),
	(469903, 124, '2015-04-01 00:22:05.000000', 'consum', 0.0220, 'lps'),
	(469904, 124, '2015-04-01 00:22:06.000000', 'consum', 0.0219, 'lps'),
	(469905, 124, '2015-04-01 00:22:07.000000', 'consum', 0.0223, 'lps'),
	(469906, 124, '2015-04-01 00:22:08.000000', 'consum', 0.0224, 'lps'),
	(469907, 124, '2015-04-01 00:22:09.000000', 'consum', 0.0215, 'lps'),
	(469908, 124, '2015-04-01 00:22:10.000000', 'consum', 0.0218, 'lps'),
	(469909, 124, '2015-04-01 00:22:11.000000', 'consum', 0.0212, 'lps'),
	(469910, 124, '2015-04-01 00:22:12.000000', 'consum', 0.0221, 'lps'),
	(469911, 124, '2015-04-01 00:22:13.000000', 'consum', 0.0233, 'lps'),
	(469912, 124, '2015-04-01 00:22:14.000000', 'consum', 0.0216, 'lps'),
	(469913, 124, '2015-04-01 00:22:15.000000', 'consum', 0.0223, 'lps'),
	(469914, 124, '2015-04-01 00:22:16.000000', 'consum', 0.0229, 'lps'),
	(469915, 124, '2015-04-01 00:22:17.000000', 'consum', 0.0218, 'lps'),
	(469916, 124, '2015-04-01 00:22:18.000000', 'consum', 0.0216, 'lps'),
	(469917, 124, '2015-04-01 00:22:19.000000', 'consum', 0.0219, 'lps'),
	(469918, 124, '2015-04-01 00:22:20.000000', 'consum', 0.0213, 'lps'),
	(469919, 124, '2015-04-01 00:22:21.000000', 'consum', 0.0222, 'lps'),
	(469920, 124, '2015-04-01 00:22:22.000000', 'consum', 0.0212, 'lps'),
	(469921, 124, '2015-04-01 00:22:23.000000', 'consum', 0.0233, 'lps'),
	(469922, 124, '2015-04-01 00:22:24.000000', 'consum', 0.0219, 'lps'),
	(469923, 124, '2015-04-01 00:22:25.000000', 'consum', 0.0212, 'lps'),
	(469924, 124, '2015-04-01 00:22:26.000000', 'consum', 0.0219, 'lps'),
	(469925, 124, '2015-04-01 00:22:27.000000', 'consum', 0.0222, 'lps'),
	(469926, 124, '2015-04-01 00:22:28.000000', 'consum', 0.0218, 'lps'),
	(469927, 124, '2015-04-01 00:22:29.000000', 'consum', 0.0214, 'lps'),
	(469928, 124, '2015-04-01 00:22:30.000000', 'consum', 0.0231, 'lps'),
	(469929, 124, '2015-04-01 00:22:31.000000', 'consum', 0.0227, 'lps'),
	(469930, 124, '2015-04-01 00:22:32.000000', 'consum', 0.0232, 'lps'),
	(469931, 124, '2015-04-01 00:22:33.000000', 'consum', 0.0218, 'lps'),
	(469932, 124, '2015-04-01 00:22:34.000000', 'consum', 0.0212, 'lps'),
	(469933, 124, '2015-04-01 00:22:35.000000', 'consum', 0.0222, 'lps'),
	(469934, 124, '2015-04-01 00:22:36.000000', 'consum', 0.0214, 'lps'),
	(469935, 124, '2015-04-01 00:22:37.000000', 'consum', 0.0219, 'lps'),
	(469936, 124, '2015-04-01 00:22:38.000000', 'consum', 0.0216, 'lps'),
	(469937, 124, '2015-04-01 00:22:39.000000', 'consum', 0.0216, 'lps'),
	(469938, 124, '2015-04-01 00:22:40.000000', 'consum', 0.0223, 'lps'),
	(469939, 124, '2015-04-01 00:22:41.000000', 'consum', 0.0229, 'lps'),
	(469940, 124, '2015-04-01 00:22:42.000000', 'consum', 0.0215, 'lps'),
	(469941, 124, '2015-04-01 00:22:43.000000', 'consum', 0.0229, 'lps'),
	(469942, 124, '2015-04-01 00:22:44.000000', 'consum', 0.0214, 'lps'),
	(469943, 124, '2015-04-01 00:22:45.000000', 'consum', 0.0226, 'lps'),
	(469944, 124, '2015-04-01 00:22:46.000000', 'consum', 0.0225, 'lps'),
	(469945, 124, '2015-04-01 00:22:47.000000', 'consum', 0.0214, 'lps'),
	(469946, 124, '2015-04-01 00:22:48.000000', 'consum', 0.0210, 'lps'),
	(469947, 124, '2015-04-01 00:22:49.000000', 'consum', 0.0225, 'lps'),
	(469948, 124, '2015-04-01 00:22:50.000000', 'consum', 0.0234, 'lps'),
	(469949, 124, '2015-04-01 00:22:51.000000', 'consum', 0.0231, 'lps'),
	(469950, 124, '2015-04-01 00:22:52.000000', 'consum', 0.0221, 'lps'),
	(469951, 124, '2015-04-01 00:22:53.000000', 'consum', 0.0226, 'lps'),
	(469952, 124, '2015-04-01 00:22:54.000000', 'consum', 0.0230, 'lps'),
	(469953, 124, '2015-04-01 00:22:55.000000', 'consum', 0.0214, 'lps'),
	(469954, 124, '2015-04-01 00:22:56.000000', 'consum', 0.0219, 'lps'),
	(469955, 124, '2015-04-01 00:22:57.000000', 'consum', 0.0220, 'lps'),
	(469956, 124, '2015-04-01 00:22:58.000000', 'consum', 0.0232, 'lps'),
	(469957, 124, '2015-04-01 00:22:59.000000', 'consum', 0.0213, 'lps'),
	(469958, 124, '2015-04-01 00:23:00.000000', 'consum', 0.0211, 'lps'),
	(469959, 124, '2015-04-01 00:23:01.000000', 'consum', 0.0232, 'lps'),
	(469960, 124, '2015-04-01 00:23:02.000000', 'consum', 0.0215, 'lps'),
	(469961, 124, '2015-04-01 00:23:03.000000', 'consum', 0.0221, 'lps'),
	(469962, 124, '2015-04-01 00:23:04.000000', 'consum', 0.0227, 'lps'),
	(469963, 124, '2015-04-01 00:23:05.000000', 'consum', 0.0233, 'lps'),
	(469964, 124, '2015-04-01 00:23:06.000000', 'consum', 0.0222, 'lps'),
	(469965, 124, '2015-04-01 00:23:07.000000', 'consum', 0.0230, 'lps'),
	(469966, 124, '2015-04-01 00:23:08.000000', 'consum', 0.0223, 'lps'),
	(469967, 124, '2015-04-01 00:23:09.000000', 'consum', 0.0214, 'lps'),
	(469968, 124, '2015-04-01 00:23:10.000000', 'consum', 0.0218, 'lps'),
	(469969, 124, '2015-04-01 00:23:11.000000', 'consum', 0.0212, 'lps'),
	(469970, 124, '2015-04-01 00:23:12.000000', 'consum', 0.0222, 'lps'),
	(469971, 124, '2015-04-01 00:23:13.000000', 'consum', 0.0214, 'lps'),
	(469972, 124, '2015-04-01 00:23:14.000000', 'consum', 0.0220, 'lps'),
	(469973, 124, '2015-04-01 00:23:15.000000', 'consum', 0.0222, 'lps'),
	(469974, 124, '2015-04-01 00:23:16.000000', 'consum', 0.0216, 'lps'),
	(469975, 124, '2015-04-01 00:23:17.000000', 'consum', 0.0232, 'lps'),
	(469976, 124, '2015-04-01 00:23:18.000000', 'consum', 0.0221, 'lps'),
	(469977, 124, '2015-04-01 00:23:19.000000', 'consum', 0.0228, 'lps'),
	(469978, 124, '2015-04-01 00:23:20.000000', 'consum', 0.0213, 'lps'),
	(469979, 124, '2015-04-01 00:23:21.000000', 'consum', 0.0226, 'lps'),
	(469980, 124, '2015-04-01 00:23:22.000000', 'consum', 0.0226, 'lps'),
	(469981, 124, '2015-04-01 00:23:23.000000', 'consum', 0.0220, 'lps'),
	(469982, 124, '2015-04-01 00:23:24.000000', 'consum', 0.0212, 'lps'),
	(469983, 124, '2015-04-01 00:23:25.000000', 'consum', 0.0216, 'lps'),
	(469984, 124, '2015-04-01 00:23:26.000000', 'consum', 0.0235, 'lps'),
	(469985, 124, '2015-04-01 00:23:27.000000', 'consum', 0.0214, 'lps'),
	(469986, 124, '2015-04-01 00:23:28.000000', 'consum', 0.0234, 'lps'),
	(469987, 124, '2015-04-01 00:23:29.000000', 'consum', 0.0215, 'lps'),
	(469988, 124, '2015-04-01 00:23:30.000000', 'consum', 0.0214, 'lps'),
	(469989, 124, '2015-04-01 00:23:31.000000', 'consum', 0.0217, 'lps'),
	(469990, 124, '2015-04-01 00:23:32.000000', 'consum', 0.0233, 'lps'),
	(469991, 124, '2015-04-01 00:23:33.000000', 'consum', 0.0228, 'lps'),
	(469992, 124, '2015-04-01 00:23:34.000000', 'consum', 0.0229, 'lps'),
	(469993, 124, '2015-04-01 00:23:35.000000', 'consum', 0.0225, 'lps'),
	(469994, 124, '2015-04-01 00:23:36.000000', 'consum', 0.0230, 'lps'),
	(469995, 124, '2015-04-01 00:23:37.000000', 'consum', 0.0213, 'lps'),
	(469996, 124, '2015-04-01 00:23:38.000000', 'consum', 0.0217, 'lps'),
	(469997, 124, '2015-04-01 00:23:39.000000', 'consum', 0.0210, 'lps'),
	(469998, 124, '2015-04-01 00:23:40.000000', 'consum', 0.0216, 'lps'),
	(469999, 124, '2015-04-01 00:23:41.000000', 'consum', 0.0215, 'lps'),
	(470000, 124, '2015-04-01 00:23:42.000000', 'consum', 0.0216, 'lps'),
	(470001, 124, '2015-04-01 00:23:43.000000', 'consum', 0.0228, 'lps'),
	(470002, 124, '2015-04-01 00:23:44.000000', 'consum', 0.0228, 'lps'),
	(470003, 124, '2015-04-01 00:23:45.000000', 'consum', 0.0221, 'lps'),
	(470004, 124, '2015-04-01 00:23:46.000000', 'consum', 0.0213, 'lps'),
	(470005, 124, '2015-04-01 00:23:47.000000', 'consum', 0.0216, 'lps'),
	(470006, 124, '2015-04-01 00:23:48.000000', 'consum', 0.0234, 'lps'),
	(470007, 124, '2015-04-01 00:23:49.000000', 'consum', 0.0235, 'lps'),
	(470008, 124, '2015-04-01 00:23:50.000000', 'consum', 0.0212, 'lps'),
	(470009, 124, '2015-04-01 00:23:51.000000', 'consum', 0.0223, 'lps'),
	(470010, 124, '2015-04-01 00:23:52.000000', 'consum', 0.0216, 'lps'),
	(470011, 124, '2015-04-01 00:23:53.000000', 'consum', 0.0227, 'lps'),
	(470012, 124, '2015-04-01 00:23:54.000000', 'consum', 0.0225, 'lps'),
	(470013, 124, '2015-04-01 00:23:55.000000', 'consum', 0.0211, 'lps'),
	(470014, 124, '2015-04-01 00:23:56.000000', 'consum', 0.0223, 'lps'),
	(470015, 124, '2015-04-01 00:23:57.000000', 'consum', 0.0218, 'lps'),
	(470016, 124, '2015-04-01 00:23:58.000000', 'consum', 0.0212, 'lps'),
	(470017, 124, '2015-04-01 00:23:59.000000', 'consum', 0.0222, 'lps'),
	(470018, 124, '2015-04-01 00:24:00.000000', 'consum', 0.0211, 'lps'),
	(470019, 124, '2015-04-01 00:24:01.000000', 'consum', 0.0233, 'lps'),
	(470020, 124, '2015-04-01 00:24:02.000000', 'consum', 0.0217, 'lps'),
	(470021, 124, '2015-04-01 00:24:03.000000', 'consum', 0.0230, 'lps'),
	(470022, 124, '2015-04-01 00:24:04.000000', 'consum', 0.0235, 'lps'),
	(470023, 124, '2015-04-01 00:24:05.000000', 'consum', 0.0226, 'lps'),
	(470024, 124, '2015-04-01 00:24:06.000000', 'consum', 0.0216, 'lps'),
	(470025, 124, '2015-04-01 00:24:07.000000', 'consum', 0.0220, 'lps'),
	(470026, 124, '2015-04-01 00:24:08.000000', 'consum', 0.0213, 'lps'),
	(470027, 124, '2015-04-01 00:24:09.000000', 'consum', 0.0222, 'lps'),
	(470028, 124, '2015-04-01 00:24:10.000000', 'consum', 0.0210, 'lps'),
	(470029, 124, '2015-04-01 00:24:11.000000', 'consum', 0.0226, 'lps'),
	(470030, 124, '2015-04-01 00:24:12.000000', 'consum', 0.0211, 'lps'),
	(470031, 124, '2015-04-01 00:24:13.000000', 'consum', 0.0220, 'lps'),
	(470032, 124, '2015-04-01 00:24:14.000000', 'consum', 0.0232, 'lps'),
	(470033, 124, '2015-04-01 00:24:15.000000', 'consum', 0.0214, 'lps'),
	(470034, 124, '2015-04-01 00:24:16.000000', 'consum', 0.0218, 'lps'),
	(470035, 124, '2015-04-01 00:24:17.000000', 'consum', 0.0235, 'lps'),
	(470036, 124, '2015-04-01 00:24:18.000000', 'consum', 0.0210, 'lps'),
	(470037, 124, '2015-04-01 00:24:19.000000', 'consum', 0.0211, 'lps'),
	(470038, 124, '2015-04-01 00:24:20.000000', 'consum', 0.0215, 'lps'),
	(470039, 124, '2015-04-01 00:24:21.000000', 'consum', 0.0232, 'lps'),
	(470040, 124, '2015-04-01 00:24:22.000000', 'consum', 0.0228, 'lps'),
	(470041, 124, '2015-04-01 00:24:23.000000', 'consum', 0.0233, 'lps'),
	(470042, 124, '2015-04-01 00:24:24.000000', 'consum', 0.0220, 'lps'),
	(470043, 124, '2015-04-01 00:24:25.000000', 'consum', 0.0219, 'lps'),
	(470044, 124, '2015-04-01 00:24:26.000000', 'consum', 0.0227, 'lps'),
	(470045, 124, '2015-04-01 00:24:27.000000', 'consum', 0.0215, 'lps'),
	(470046, 124, '2015-04-01 00:24:28.000000', 'consum', 0.0210, 'lps'),
	(470047, 124, '2015-04-01 00:24:29.000000', 'consum', 0.0221, 'lps'),
	(470048, 124, '2015-04-01 00:24:30.000000', 'consum', 0.0216, 'lps'),
	(470049, 124, '2015-04-01 00:24:31.000000', 'consum', 0.0231, 'lps'),
	(470050, 124, '2015-04-01 00:24:32.000000', 'consum', 0.0222, 'lps'),
	(470051, 124, '2015-04-01 00:24:33.000000', 'consum', 0.0233, 'lps'),
	(470052, 124, '2015-04-01 00:24:34.000000', 'consum', 0.0210, 'lps'),
	(470053, 124, '2015-04-01 00:24:35.000000', 'consum', 0.0222, 'lps'),
	(470054, 124, '2015-04-01 00:24:36.000000', 'consum', 0.0218, 'lps'),
	(470055, 124, '2015-04-01 00:24:37.000000', 'consum', 0.0213, 'lps'),
	(470056, 124, '2015-04-01 00:24:38.000000', 'consum', 0.0226, 'lps'),
	(470057, 124, '2015-04-01 00:24:39.000000', 'consum', 0.0233, 'lps'),
	(470058, 124, '2015-04-01 00:24:40.000000', 'consum', 0.0224, 'lps'),
	(470059, 124, '2015-04-01 00:24:41.000000', 'consum', 0.0211, 'lps'),
	(470060, 124, '2015-04-01 00:24:42.000000', 'consum', 0.0225, 'lps'),
	(470061, 124, '2015-04-01 00:24:43.000000', 'consum', 0.0229, 'lps'),
	(470062, 124, '2015-04-01 00:24:44.000000', 'consum', 0.0211, 'lps'),
	(470063, 124, '2015-04-01 00:24:45.000000', 'consum', 0.0235, 'lps'),
	(470064, 124, '2015-04-01 00:24:46.000000', 'consum', 0.0231, 'lps'),
	(470065, 124, '2015-04-01 00:24:47.000000', 'consum', 0.0213, 'lps'),
	(470066, 124, '2015-04-01 00:24:48.000000', 'consum', 0.0213, 'lps'),
	(470067, 124, '2015-04-01 00:24:49.000000', 'consum', 0.0218, 'lps'),
	(470068, 124, '2015-04-01 00:24:50.000000', 'consum', 0.0214, 'lps'),
	(470069, 124, '2015-04-01 00:24:51.000000', 'consum', 0.0232, 'lps'),
	(470070, 124, '2015-04-01 00:24:52.000000', 'consum', 0.0231, 'lps'),
	(470071, 124, '2015-04-01 00:24:53.000000', 'consum', 0.0225, 'lps'),
	(470072, 124, '2015-04-01 00:24:54.000000', 'consum', 0.0220, 'lps'),
	(470073, 124, '2015-04-01 00:24:55.000000', 'consum', 0.0217, 'lps'),
	(470074, 124, '2015-04-01 00:24:56.000000', 'consum', 0.0217, 'lps'),
	(470075, 124, '2015-04-01 00:24:57.000000', 'consum', 0.0224, 'lps'),
	(470076, 124, '2015-04-01 00:24:58.000000', 'consum', 0.0231, 'lps'),
	(470077, 124, '2015-04-01 00:24:59.000000', 'consum', 0.0223, 'lps'),
	(470078, 124, '2015-04-01 00:25:00.000000', 'consum', 0.0214, 'lps'),
	(470079, 124, '2015-04-01 00:25:01.000000', 'consum', 0.0215, 'lps'),
	(470080, 124, '2015-04-01 00:25:02.000000', 'consum', 0.0223, 'lps'),
	(470081, 124, '2015-04-01 00:25:03.000000', 'consum', 0.0210, 'lps'),
	(470082, 124, '2015-04-01 00:25:04.000000', 'consum', 0.0225, 'lps'),
	(470083, 124, '2015-04-01 00:25:05.000000', 'consum', 0.0231, 'lps'),
	(470084, 124, '2015-04-01 00:25:06.000000', 'consum', 0.0221, 'lps'),
	(470085, 124, '2015-04-01 00:25:07.000000', 'consum', 0.0226, 'lps'),
	(470086, 124, '2015-04-01 00:25:08.000000', 'consum', 0.0233, 'lps'),
	(470087, 124, '2015-04-01 00:25:09.000000', 'consum', 0.0226, 'lps'),
	(470088, 124, '2015-04-01 00:25:10.000000', 'consum', 0.0220, 'lps'),
	(470089, 124, '2015-04-01 00:25:11.000000', 'consum', 0.0215, 'lps'),
	(470090, 124, '2015-04-01 00:25:12.000000', 'consum', 0.0229, 'lps'),
	(470091, 124, '2015-04-01 00:25:13.000000', 'consum', 0.0214, 'lps'),
	(470092, 124, '2015-04-01 00:25:14.000000', 'consum', 0.0227, 'lps'),
	(470093, 124, '2015-04-01 00:25:15.000000', 'consum', 0.0230, 'lps'),
	(470094, 124, '2015-04-01 00:25:16.000000', 'consum', 0.0235, 'lps'),
	(470095, 124, '2015-04-01 00:25:17.000000', 'consum', 0.0224, 'lps'),
	(470096, 124, '2015-04-01 00:25:18.000000', 'consum', 0.0230, 'lps'),
	(470097, 124, '2015-04-01 00:25:19.000000', 'consum', 0.0216, 'lps'),
	(470098, 124, '2015-04-01 00:25:20.000000', 'consum', 0.0232, 'lps'),
	(470099, 124, '2015-04-01 00:25:21.000000', 'consum', 0.0227, 'lps'),
	(470100, 124, '2015-04-01 00:25:22.000000', 'consum', 0.0229, 'lps'),
	(470101, 124, '2015-04-01 00:25:23.000000', 'consum', 0.0227, 'lps'),
	(470102, 124, '2015-04-01 00:25:24.000000', 'consum', 0.0213, 'lps'),
	(470103, 124, '2015-04-01 00:25:25.000000', 'consum', 0.0225, 'lps'),
	(470104, 124, '2015-04-01 00:25:26.000000', 'consum', 0.0226, 'lps'),
	(470105, 124, '2015-04-01 00:25:27.000000', 'consum', 0.0220, 'lps'),
	(470106, 124, '2015-04-01 00:25:28.000000', 'consum', 0.0211, 'lps'),
	(470107, 124, '2015-04-01 00:25:29.000000', 'consum', 0.0214, 'lps'),
	(470108, 124, '2015-04-01 00:25:30.000000', 'consum', 0.0227, 'lps'),
	(470109, 124, '2015-04-01 00:25:31.000000', 'consum', 0.0233, 'lps'),
	(470110, 124, '2015-04-01 00:25:32.000000', 'consum', 0.0221, 'lps'),
	(470111, 124, '2015-04-01 00:25:33.000000', 'consum', 0.0220, 'lps'),
	(470112, 124, '2015-04-01 00:25:34.000000', 'consum', 0.0231, 'lps'),
	(470113, 124, '2015-04-01 00:25:35.000000', 'consum', 0.0233, 'lps'),
	(470114, 124, '2015-04-01 00:25:36.000000', 'consum', 0.0211, 'lps'),
	(470115, 124, '2015-04-01 00:25:37.000000', 'consum', 0.0222, 'lps'),
	(470116, 124, '2015-04-01 00:25:38.000000', 'consum', 0.0217, 'lps'),
	(470117, 124, '2015-04-01 00:25:39.000000', 'consum', 0.0210, 'lps'),
	(470118, 124, '2015-04-01 00:25:40.000000', 'consum', 0.0216, 'lps'),
	(470119, 124, '2015-04-01 00:25:41.000000', 'consum', 0.0213, 'lps'),
	(470120, 124, '2015-04-01 00:25:42.000000', 'consum', 0.0234, 'lps'),
	(470121, 124, '2015-04-01 00:25:43.000000', 'consum', 0.0219, 'lps'),
	(470122, 124, '2015-04-01 00:25:44.000000', 'consum', 0.0233, 'lps'),
	(470123, 124, '2015-04-01 00:25:45.000000', 'consum', 0.0223, 'lps'),
	(470124, 124, '2015-04-01 00:25:46.000000', 'consum', 0.0231, 'lps'),
	(470125, 124, '2015-04-01 00:25:47.000000', 'consum', 0.0225, 'lps'),
	(470126, 124, '2015-04-01 00:25:48.000000', 'consum', 0.0222, 'lps'),
	(470127, 124, '2015-04-01 00:25:49.000000', 'consum', 0.0227, 'lps'),
	(470128, 124, '2015-04-01 00:25:50.000000', 'consum', 0.0233, 'lps'),
	(470129, 124, '2015-04-01 00:25:51.000000', 'consum', 0.0223, 'lps'),
	(470130, 124, '2015-04-01 00:25:52.000000', 'consum', 0.0231, 'lps'),
	(470131, 124, '2015-04-01 00:25:53.000000', 'consum', 0.0225, 'lps'),
	(470132, 124, '2015-04-01 00:25:54.000000', 'consum', 0.0222, 'lps'),
	(470133, 124, '2015-04-01 00:25:55.000000', 'consum', 0.0225, 'lps'),
	(470134, 124, '2015-04-01 00:25:56.000000', 'consum', 0.0223, 'lps'),
	(470135, 124, '2015-04-01 00:25:57.000000', 'consum', 0.0229, 'lps'),
	(470136, 124, '2015-04-01 00:25:58.000000', 'consum', 0.0218, 'lps'),
	(470137, 124, '2015-04-01 00:25:59.000000', 'consum', 0.0218, 'lps'),
	(470138, 124, '2015-04-01 00:26:00.000000', 'consum', 0.0229, 'lps'),
	(470139, 124, '2015-04-01 00:26:01.000000', 'consum', 0.0227, 'lps'),
	(470140, 124, '2015-04-01 00:26:02.000000', 'consum', 0.0212, 'lps'),
	(470141, 124, '2015-04-01 00:26:03.000000', 'consum', 0.0221, 'lps'),
	(470142, 124, '2015-04-01 00:26:04.000000', 'consum', 0.0233, 'lps'),
	(470143, 124, '2015-04-01 00:26:05.000000', 'consum', 0.0218, 'lps'),
	(470144, 124, '2015-04-01 00:26:06.000000', 'consum', 0.0230, 'lps'),
	(470145, 124, '2015-04-01 00:26:07.000000', 'consum', 0.0210, 'lps'),
	(470146, 124, '2015-04-01 00:26:08.000000', 'consum', 0.0228, 'lps'),
	(470147, 124, '2015-04-01 00:26:09.000000', 'consum', 0.0222, 'lps'),
	(470148, 124, '2015-04-01 00:26:10.000000', 'consum', 0.0218, 'lps'),
	(470149, 124, '2015-04-01 00:26:11.000000', 'consum', 0.0214, 'lps'),
	(470150, 124, '2015-04-01 00:26:12.000000', 'consum', 0.0233, 'lps'),
	(470151, 124, '2015-04-01 00:26:13.000000', 'consum', 0.0210, 'lps'),
	(470152, 124, '2015-04-01 00:26:14.000000', 'consum', 0.0218, 'lps'),
	(470153, 124, '2015-04-01 00:26:15.000000', 'consum', 0.0226, 'lps'),
	(470154, 124, '2015-04-01 00:26:16.000000', 'consum', 0.0212, 'lps'),
	(470155, 124, '2015-04-01 00:26:17.000000', 'consum', 0.0226, 'lps'),
	(470156, 124, '2015-04-01 00:26:18.000000', 'consum', 0.0233, 'lps'),
	(470157, 124, '2015-04-01 00:26:19.000000', 'consum', 0.0225, 'lps'),
	(470158, 124, '2015-04-01 00:26:20.000000', 'consum', 0.0215, 'lps'),
	(470159, 124, '2015-04-01 00:26:21.000000', 'consum', 0.0216, 'lps'),
	(470160, 124, '2015-04-01 00:26:22.000000', 'consum', 0.0227, 'lps'),
	(470161, 124, '2015-04-01 00:26:23.000000', 'consum', 0.0226, 'lps'),
	(470162, 124, '2015-04-01 00:26:24.000000', 'consum', 0.0214, 'lps'),
	(470163, 124, '2015-04-01 00:26:25.000000', 'consum', 0.0233, 'lps'),
	(470164, 124, '2015-04-01 00:26:26.000000', 'consum', 0.0212, 'lps'),
	(470165, 124, '2015-04-01 00:26:27.000000', 'consum', 0.0228, 'lps'),
	(470166, 124, '2015-04-01 00:26:28.000000', 'consum', 0.0215, 'lps'),
	(470167, 124, '2015-04-01 00:26:29.000000', 'consum', 0.0233, 'lps'),
	(470168, 124, '2015-04-01 00:26:30.000000', 'consum', 0.0233, 'lps'),
	(470169, 124, '2015-04-01 00:26:31.000000', 'consum', 0.0231, 'lps'),
	(470170, 124, '2015-04-01 00:26:32.000000', 'consum', 0.0220, 'lps'),
	(470171, 124, '2015-04-01 00:26:33.000000', 'consum', 0.0225, 'lps'),
	(470172, 124, '2015-04-01 00:26:34.000000', 'consum', 0.0229, 'lps'),
	(470173, 124, '2015-04-01 00:26:35.000000', 'consum', 0.0210, 'lps'),
	(470174, 124, '2015-04-01 00:26:36.000000', 'consum', 0.0228, 'lps'),
	(470175, 124, '2015-04-01 00:26:37.000000', 'consum', 0.0226, 'lps'),
	(470176, 124, '2015-04-01 00:26:38.000000', 'consum', 0.0210, 'lps'),
	(470177, 124, '2015-04-01 00:26:39.000000', 'consum', 0.0212, 'lps'),
	(470178, 124, '2015-04-01 00:26:40.000000', 'consum', 0.0222, 'lps'),
	(470179, 124, '2015-04-01 00:26:41.000000', 'consum', 0.0211, 'lps'),
	(470180, 124, '2015-04-01 00:26:42.000000', 'consum', 0.0233, 'lps'),
	(470181, 124, '2015-04-01 00:26:43.000000', 'consum', 0.0220, 'lps'),
	(470182, 124, '2015-04-01 00:26:44.000000', 'consum', 0.0216, 'lps'),
	(470183, 124, '2015-04-01 00:26:45.000000', 'consum', 0.0211, 'lps'),
	(470184, 124, '2015-04-01 00:26:46.000000', 'consum', 0.0225, 'lps'),
	(470185, 124, '2015-04-01 00:26:47.000000', 'consum', 0.0230, 'lps'),
	(470186, 124, '2015-04-01 00:26:48.000000', 'consum', 0.0211, 'lps'),
	(470187, 124, '2015-04-01 00:26:49.000000', 'consum', 0.0210, 'lps'),
	(470188, 124, '2015-04-01 00:26:50.000000', 'consum', 0.0233, 'lps'),
	(470189, 124, '2015-04-01 00:26:51.000000', 'consum', 0.0223, 'lps'),
	(470190, 124, '2015-04-01 00:26:52.000000', 'consum', 0.0230, 'lps'),
	(470191, 124, '2015-04-01 00:26:53.000000', 'consum', 0.0222, 'lps'),
	(470192, 124, '2015-04-01 00:26:54.000000', 'consum', 0.0212, 'lps'),
	(470193, 124, '2015-04-01 00:26:55.000000', 'consum', 0.0233, 'lps'),
	(470194, 124, '2015-04-01 00:26:56.000000', 'consum', 0.0216, 'lps'),
	(470195, 124, '2015-04-01 00:26:57.000000', 'consum', 0.0222, 'lps'),
	(470196, 124, '2015-04-01 00:26:58.000000', 'consum', 0.0229, 'lps'),
	(470197, 124, '2015-04-01 00:26:59.000000', 'consum', 0.0215, 'lps'),
	(470198, 124, '2015-04-01 00:27:00.000000', 'consum', 0.0231, 'lps'),
	(470199, 124, '2015-04-01 00:27:01.000000', 'consum', 0.0225, 'lps'),
	(470200, 124, '2015-04-01 00:27:02.000000', 'consum', 0.0220, 'lps'),
	(470201, 124, '2015-04-01 00:27:03.000000', 'consum', 0.0217, 'lps'),
	(470202, 124, '2015-04-01 00:27:04.000000', 'consum', 0.0213, 'lps'),
	(470203, 124, '2015-04-01 00:27:05.000000', 'consum', 0.0232, 'lps'),
	(470204, 124, '2015-04-01 00:27:06.000000', 'consum', 0.0235, 'lps'),
	(470205, 124, '2015-04-01 00:27:07.000000', 'consum', 0.0216, 'lps'),
	(470206, 124, '2015-04-01 00:27:08.000000', 'consum', 0.0217, 'lps'),
	(470207, 124, '2015-04-01 00:27:09.000000', 'consum', 0.0229, 'lps'),
	(470208, 124, '2015-04-01 00:27:10.000000', 'consum', 0.0232, 'lps'),
	(470209, 124, '2015-04-01 00:27:11.000000', 'consum', 0.0211, 'lps'),
	(470210, 124, '2015-04-01 00:27:12.000000', 'consum', 0.0229, 'lps'),
	(470211, 124, '2015-04-01 00:27:13.000000', 'consum', 0.0222, 'lps'),
	(470212, 124, '2015-04-01 00:27:14.000000', 'consum', 0.0214, 'lps'),
	(470213, 124, '2015-04-01 00:27:15.000000', 'consum', 0.0221, 'lps'),
	(470214, 124, '2015-04-01 00:27:16.000000', 'consum', 0.0226, 'lps'),
	(470215, 124, '2015-04-01 00:27:17.000000', 'consum', 0.0233, 'lps'),
	(470216, 124, '2015-04-01 00:27:18.000000', 'consum', 0.0223, 'lps'),
	(470217, 124, '2015-04-01 00:27:19.000000', 'consum', 0.0235, 'lps'),
	(470218, 124, '2015-04-01 00:27:20.000000', 'consum', 0.0216, 'lps'),
	(470219, 124, '2015-04-01 00:27:21.000000', 'consum', 0.0219, 'lps'),
	(470220, 124, '2015-04-01 00:27:22.000000', 'consum', 0.0211, 'lps'),
	(470221, 124, '2015-04-01 00:27:23.000000', 'consum', 0.0215, 'lps'),
	(470222, 124, '2015-04-01 00:27:24.000000', 'consum', 0.0230, 'lps'),
	(470223, 124, '2015-04-01 00:27:25.000000', 'consum', 0.0221, 'lps'),
	(470224, 124, '2015-04-01 00:27:26.000000', 'consum', 0.0229, 'lps'),
	(470225, 124, '2015-04-01 00:27:27.000000', 'consum', 0.0220, 'lps'),
	(470226, 124, '2015-04-01 00:27:28.000000', 'consum', 0.0230, 'lps'),
	(470227, 124, '2015-04-01 00:27:29.000000', 'consum', 0.0230, 'lps'),
	(470228, 124, '2015-04-01 00:27:30.000000', 'consum', 0.0223, 'lps'),
	(470229, 124, '2015-04-01 00:27:31.000000', 'consum', 0.0214, 'lps'),
	(470230, 124, '2015-04-01 00:27:32.000000', 'consum', 0.0219, 'lps'),
	(470231, 124, '2015-04-01 00:27:33.000000', 'consum', 0.0218, 'lps'),
	(470232, 124, '2015-04-01 00:27:34.000000', 'consum', 0.0224, 'lps'),
	(470233, 124, '2015-04-01 00:27:35.000000', 'consum', 0.0231, 'lps'),
	(470234, 124, '2015-04-01 00:27:36.000000', 'consum', 0.0221, 'lps'),
	(470235, 124, '2015-04-01 00:27:37.000000', 'consum', 0.0228, 'lps'),
	(470236, 124, '2015-04-01 00:27:38.000000', 'consum', 0.0216, 'lps'),
	(470237, 124, '2015-04-01 00:27:39.000000', 'consum', 0.0213, 'lps'),
	(470238, 124, '2015-04-01 00:27:40.000000', 'consum', 0.0231, 'lps'),
	(470239, 124, '2015-04-01 00:27:41.000000', 'consum', 0.0231, 'lps'),
	(470240, 124, '2015-04-01 00:27:42.000000', 'consum', 0.0225, 'lps'),
	(470241, 124, '2015-04-01 00:27:43.000000', 'consum', 0.0224, 'lps'),
	(470242, 124, '2015-04-01 00:27:44.000000', 'consum', 0.0235, 'lps'),
	(470243, 124, '2015-04-01 00:27:45.000000', 'consum', 0.0213, 'lps'),
	(470244, 124, '2015-04-01 00:27:46.000000', 'consum', 0.0232, 'lps'),
	(470245, 124, '2015-04-01 00:27:47.000000', 'consum', 0.0231, 'lps'),
	(470246, 124, '2015-04-01 00:27:48.000000', 'consum', 0.0226, 'lps'),
	(470247, 124, '2015-04-01 00:27:49.000000', 'consum', 0.0225, 'lps'),
	(470248, 124, '2015-04-01 00:27:50.000000', 'consum', 0.0211, 'lps'),
	(470249, 124, '2015-04-01 00:27:51.000000', 'consum', 0.0223, 'lps'),
	(470250, 124, '2015-04-01 00:27:52.000000', 'consum', 0.0221, 'lps'),
	(470251, 124, '2015-04-01 00:27:53.000000', 'consum', 0.0225, 'lps'),
	(470252, 124, '2015-04-01 00:27:54.000000', 'consum', 0.0229, 'lps'),
	(470253, 124, '2015-04-01 00:27:55.000000', 'consum', 0.0232, 'lps'),
	(470254, 124, '2015-04-01 00:27:56.000000', 'consum', 0.0211, 'lps'),
	(470255, 124, '2015-04-01 00:27:57.000000', 'consum', 0.0228, 'lps'),
	(470256, 124, '2015-04-01 00:27:58.000000', 'consum', 0.0222, 'lps'),
	(470257, 124, '2015-04-01 00:27:59.000000', 'consum', 0.0215, 'lps'),
	(470258, 124, '2015-04-01 00:28:00.000000', 'consum', 0.0224, 'lps'),
	(470259, 124, '2015-04-01 00:28:01.000000', 'consum', 0.0216, 'lps'),
	(470260, 124, '2015-04-01 00:28:02.000000', 'consum', 0.0222, 'lps'),
	(470261, 124, '2015-04-01 00:28:03.000000', 'consum', 0.0227, 'lps'),
	(470262, 124, '2015-04-01 00:28:04.000000', 'consum', 0.0234, 'lps'),
	(470263, 124, '2015-04-01 00:28:05.000000', 'consum', 0.0229, 'lps'),
	(470264, 124, '2015-04-01 00:28:06.000000', 'consum', 0.0231, 'lps'),
	(470265, 124, '2015-04-01 00:28:07.000000', 'consum', 0.0235, 'lps'),
	(470266, 124, '2015-04-01 00:28:08.000000', 'consum', 0.0218, 'lps'),
	(470267, 124, '2015-04-01 00:28:09.000000', 'consum', 0.0229, 'lps'),
	(470268, 124, '2015-04-01 00:28:10.000000', 'consum', 0.0228, 'lps'),
	(470269, 124, '2015-04-01 00:28:11.000000', 'consum', 0.0217, 'lps'),
	(470270, 124, '2015-04-01 00:28:12.000000', 'consum', 0.0217, 'lps'),
	(470271, 124, '2015-04-01 00:28:13.000000', 'consum', 0.0225, 'lps'),
	(470272, 124, '2015-04-01 00:28:14.000000', 'consum', 0.0212, 'lps'),
	(470273, 124, '2015-04-01 00:28:15.000000', 'consum', 0.0229, 'lps'),
	(470274, 124, '2015-04-01 00:28:16.000000', 'consum', 0.0222, 'lps'),
	(470275, 124, '2015-04-01 00:28:17.000000', 'consum', 0.0212, 'lps'),
	(470276, 124, '2015-04-01 00:28:18.000000', 'consum', 0.0212, 'lps'),
	(470277, 124, '2015-04-01 00:28:19.000000', 'consum', 0.0213, 'lps'),
	(470278, 124, '2015-04-01 00:28:20.000000', 'consum', 0.0219, 'lps'),
	(470279, 124, '2015-04-01 00:28:21.000000', 'consum', 0.0219, 'lps'),
	(470280, 124, '2015-04-01 00:28:22.000000', 'consum', 0.0230, 'lps'),
	(470281, 124, '2015-04-01 00:28:23.000000', 'consum', 0.0234, 'lps'),
	(470282, 124, '2015-04-01 00:28:24.000000', 'consum', 0.0215, 'lps'),
	(470283, 124, '2015-04-01 00:28:25.000000', 'consum', 0.0216, 'lps'),
	(470284, 124, '2015-04-01 00:28:26.000000', 'consum', 0.0226, 'lps'),
	(470285, 124, '2015-04-01 00:28:27.000000', 'consum', 0.0220, 'lps'),
	(470286, 124, '2015-04-01 00:28:28.000000', 'consum', 0.0212, 'lps'),
	(470287, 124, '2015-04-01 00:28:29.000000', 'consum', 0.0219, 'lps'),
	(470288, 124, '2015-04-01 00:28:30.000000', 'consum', 0.0223, 'lps'),
	(470289, 124, '2015-04-01 00:28:31.000000', 'consum', 0.0223, 'lps'),
	(470290, 124, '2015-04-01 00:28:32.000000', 'consum', 0.0235, 'lps'),
	(470291, 124, '2015-04-01 00:28:33.000000', 'consum', 0.0217, 'lps'),
	(470292, 124, '2015-04-01 00:28:34.000000', 'consum', 0.0226, 'lps'),
	(470293, 124, '2015-04-01 00:28:35.000000', 'consum', 0.0215, 'lps'),
	(470294, 124, '2015-04-01 00:28:36.000000', 'consum', 0.0213, 'lps'),
	(470295, 124, '2015-04-01 00:28:37.000000', 'consum', 0.0212, 'lps'),
	(470296, 124, '2015-04-01 00:28:38.000000', 'consum', 0.0212, 'lps'),
	(470297, 124, '2015-04-01 00:28:39.000000', 'consum', 0.0215, 'lps'),
	(470298, 124, '2015-04-01 00:28:40.000000', 'consum', 0.0228, 'lps'),
	(470299, 124, '2015-04-01 00:28:41.000000', 'consum', 0.0235, 'lps'),
	(470300, 124, '2015-04-01 00:28:42.000000', 'consum', 0.0227, 'lps'),
	(470301, 124, '2015-04-01 00:28:43.000000', 'consum', 0.0221, 'lps'),
	(470302, 124, '2015-04-01 00:28:44.000000', 'consum', 0.0214, 'lps'),
	(470303, 124, '2015-04-01 00:28:45.000000', 'consum', 0.0223, 'lps'),
	(470304, 124, '2015-04-01 00:28:46.000000', 'consum', 0.0214, 'lps'),
	(470305, 124, '2015-04-01 00:28:47.000000', 'consum', 0.0218, 'lps'),
	(470306, 124, '2015-04-01 00:28:48.000000', 'consum', 0.0210, 'lps'),
	(470307, 124, '2015-04-01 00:28:49.000000', 'consum', 0.0211, 'lps'),
	(470308, 124, '2015-04-01 00:28:50.000000', 'consum', 0.0219, 'lps'),
	(470309, 124, '2015-04-01 00:28:51.000000', 'consum', 0.0226, 'lps'),
	(470310, 124, '2015-04-01 00:28:52.000000', 'consum', 0.0211, 'lps'),
	(470311, 124, '2015-04-01 00:28:53.000000', 'consum', 0.0220, 'lps'),
	(470312, 124, '2015-04-01 00:28:54.000000', 'consum', 0.0232, 'lps'),
	(470313, 124, '2015-04-01 00:28:55.000000', 'consum', 0.0214, 'lps'),
	(470314, 124, '2015-04-01 00:28:56.000000', 'consum', 0.0215, 'lps'),
	(470315, 124, '2015-04-01 00:28:57.000000', 'consum', 0.0223, 'lps'),
	(470316, 124, '2015-04-01 00:28:58.000000', 'consum', 0.0234, 'lps'),
	(470317, 124, '2015-04-01 00:28:59.000000', 'consum', 0.0215, 'lps'),
	(470318, 124, '2015-04-01 00:29:00.000000', 'consum', 0.0213, 'lps'),
	(470319, 124, '2015-04-01 00:29:01.000000', 'consum', 0.0213, 'lps'),
	(470320, 124, '2015-04-01 00:29:02.000000', 'consum', 0.0216, 'lps'),
	(470321, 124, '2015-04-01 00:29:03.000000', 'consum', 0.0230, 'lps'),
	(470322, 124, '2015-04-01 00:29:04.000000', 'consum', 0.0216, 'lps'),
	(470323, 124, '2015-04-01 00:29:05.000000', 'consum', 0.0233, 'lps'),
	(470324, 124, '2015-04-01 00:29:06.000000', 'consum', 0.0229, 'lps'),
	(470325, 124, '2015-04-01 00:29:07.000000', 'consum', 0.0210, 'lps'),
	(470326, 124, '2015-04-01 00:29:08.000000', 'consum', 0.0233, 'lps'),
	(470327, 124, '2015-04-01 00:29:09.000000', 'consum', 0.0223, 'lps'),
	(470328, 124, '2015-04-01 00:29:10.000000', 'consum', 0.0230, 'lps'),
	(470329, 124, '2015-04-01 00:29:11.000000', 'consum', 0.0218, 'lps'),
	(470330, 124, '2015-04-01 00:29:12.000000', 'consum', 0.0219, 'lps'),
	(470331, 124, '2015-04-01 00:29:13.000000', 'consum', 0.0229, 'lps'),
	(470332, 124, '2015-04-01 00:29:14.000000', 'consum', 0.0227, 'lps'),
	(470333, 124, '2015-04-01 00:29:15.000000', 'consum', 0.0215, 'lps'),
	(470334, 124, '2015-04-01 00:29:16.000000', 'consum', 0.0235, 'lps'),
	(470335, 124, '2015-04-01 00:29:17.000000', 'consum', 0.0216, 'lps'),
	(470336, 124, '2015-04-01 00:29:18.000000', 'consum', 0.0217, 'lps'),
	(470337, 124, '2015-04-01 00:29:19.000000', 'consum', 0.0230, 'lps'),
	(470338, 124, '2015-04-01 00:29:20.000000', 'consum', 0.0210, 'lps'),
	(470339, 124, '2015-04-01 00:29:21.000000', 'consum', 0.0227, 'lps'),
	(470340, 124, '2015-04-01 00:29:22.000000', 'consum', 0.0220, 'lps'),
	(470341, 124, '2015-04-01 00:29:23.000000', 'consum', 0.0232, 'lps'),
	(470342, 124, '2015-04-01 00:29:24.000000', 'consum', 0.0216, 'lps'),
	(470343, 124, '2015-04-01 00:29:25.000000', 'consum', 0.0226, 'lps'),
	(470344, 124, '2015-04-01 00:29:26.000000', 'consum', 0.0221, 'lps'),
	(470345, 124, '2015-04-01 00:29:27.000000', 'consum', 0.0215, 'lps'),
	(470346, 124, '2015-04-01 00:29:28.000000', 'consum', 0.0229, 'lps'),
	(470347, 124, '2015-04-01 00:29:29.000000', 'consum', 0.0215, 'lps'),
	(470348, 124, '2015-04-01 00:29:30.000000', 'consum', 0.0228, 'lps'),
	(470349, 124, '2015-04-01 00:29:31.000000', 'consum', 0.0210, 'lps'),
	(470350, 124, '2015-04-01 00:29:32.000000', 'consum', 0.0235, 'lps'),
	(470351, 124, '2015-04-01 00:29:33.000000', 'consum', 0.0229, 'lps'),
	(470352, 124, '2015-04-01 00:29:34.000000', 'consum', 0.0232, 'lps'),
	(470353, 124, '2015-04-01 00:29:35.000000', 'consum', 0.0210, 'lps'),
	(470354, 124, '2015-04-01 00:29:36.000000', 'consum', 0.0222, 'lps'),
	(470355, 124, '2015-04-01 00:29:37.000000', 'consum', 0.0218, 'lps'),
	(470356, 124, '2015-04-01 00:29:38.000000', 'consum', 0.0213, 'lps'),
	(470357, 124, '2015-04-01 00:29:39.000000', 'consum', 0.0231, 'lps'),
	(470358, 124, '2015-04-01 00:29:40.000000', 'consum', 0.0228, 'lps'),
	(470359, 124, '2015-04-01 00:29:41.000000', 'consum', 0.0235, 'lps'),
	(470360, 124, '2015-04-01 00:29:42.000000', 'consum', 0.0232, 'lps'),
	(470361, 124, '2015-04-01 00:29:43.000000', 'consum', 0.0218, 'lps'),
	(470362, 124, '2015-04-01 00:29:44.000000', 'consum', 0.0211, 'lps'),
	(470363, 124, '2015-04-01 00:29:45.000000', 'consum', 0.0219, 'lps'),
	(470364, 124, '2015-04-01 00:29:46.000000', 'consum', 0.0225, 'lps'),
	(470365, 124, '2015-04-01 00:29:47.000000', 'consum', 0.0235, 'lps'),
	(470366, 124, '2015-04-01 00:29:48.000000', 'consum', 0.0210, 'lps'),
	(470367, 124, '2015-04-01 00:29:49.000000', 'consum', 0.0213, 'lps'),
	(470368, 124, '2015-04-01 00:29:50.000000', 'consum', 0.0227, 'lps'),
	(470369, 124, '2015-04-01 00:29:51.000000', 'consum', 0.0234, 'lps'),
	(470370, 124, '2015-04-01 00:29:52.000000', 'consum', 0.0228, 'lps'),
	(470371, 124, '2015-04-01 00:29:53.000000', 'consum', 0.0230, 'lps'),
	(470372, 124, '2015-04-01 00:29:54.000000', 'consum', 0.0228, 'lps'),
	(470373, 124, '2015-04-01 00:29:55.000000', 'consum', 0.0214, 'lps'),
	(470374, 124, '2015-04-01 00:29:56.000000', 'consum', 0.0232, 'lps'),
	(470375, 124, '2015-04-01 00:29:57.000000', 'consum', 0.0227, 'lps'),
	(470376, 124, '2015-04-01 00:29:58.000000', 'consum', 0.0230, 'lps'),
	(470377, 124, '2015-04-01 00:29:59.000000', 'consum', 0.0234, 'lps'),
	(470378, 124, '2015-04-01 00:30:00.000000', 'consum', 0.0219, 'lps'),
	(470379, 124, '2015-04-01 00:30:01.000000', 'consum', 0.0234, 'lps'),
	(470380, 124, '2015-04-01 00:30:02.000000', 'consum', 0.0225, 'lps'),
	(470381, 124, '2015-04-01 00:30:03.000000', 'consum', 0.0213, 'lps'),
	(470382, 124, '2015-04-01 00:30:04.000000', 'consum', 0.0231, 'lps'),
	(470383, 124, '2015-04-01 00:30:05.000000', 'consum', 0.0232, 'lps'),
	(470384, 124, '2015-04-01 00:30:06.000000', 'consum', 0.0231, 'lps'),
	(470385, 124, '2015-04-01 00:30:07.000000', 'consum', 0.0224, 'lps'),
	(470386, 124, '2015-04-01 00:30:08.000000', 'consum', 0.0216, 'lps'),
	(470387, 124, '2015-04-01 00:30:09.000000', 'consum', 0.0225, 'lps'),
	(470388, 124, '2015-04-01 00:30:10.000000', 'consum', 0.0213, 'lps'),
	(470389, 124, '2015-04-01 00:30:11.000000', 'consum', 0.0210, 'lps'),
	(470390, 124, '2015-04-01 00:30:12.000000', 'consum', 0.0227, 'lps'),
	(470391, 124, '2015-04-01 00:30:13.000000', 'consum', 0.0218, 'lps'),
	(470392, 124, '2015-04-01 00:30:14.000000', 'consum', 0.0224, 'lps'),
	(470393, 124, '2015-04-01 00:30:15.000000', 'consum', 0.0229, 'lps'),
	(470394, 124, '2015-04-01 00:30:16.000000', 'consum', 0.0214, 'lps'),
	(470395, 124, '2015-04-01 00:30:17.000000', 'consum', 0.0227, 'lps'),
	(470396, 124, '2015-04-01 00:30:18.000000', 'consum', 0.0229, 'lps'),
	(470397, 124, '2015-04-01 00:30:19.000000', 'consum', 0.0228, 'lps'),
	(470398, 124, '2015-04-01 00:30:20.000000', 'consum', 0.0220, 'lps'),
	(470399, 124, '2015-04-01 00:30:21.000000', 'consum', 0.0233, 'lps'),
	(470400, 124, '2015-04-01 00:30:22.000000', 'consum', 0.0216, 'lps'),
	(470401, 124, '2015-04-01 00:30:23.000000', 'consum', 0.0225, 'lps'),
	(470402, 124, '2015-04-01 00:30:24.000000', 'consum', 0.0215, 'lps'),
	(470403, 124, '2015-04-01 00:30:25.000000', 'consum', 0.0214, 'lps'),
	(470404, 124, '2015-04-01 00:30:26.000000', 'consum', 0.0219, 'lps'),
	(470405, 124, '2015-04-01 00:30:27.000000', 'consum', 0.0216, 'lps'),
	(470406, 124, '2015-04-01 00:30:28.000000', 'consum', 0.0213, 'lps'),
	(470407, 124, '2015-04-01 00:30:29.000000', 'consum', 0.0232, 'lps'),
	(470408, 124, '2015-04-01 00:30:30.000000', 'consum', 0.0210, 'lps'),
	(470409, 124, '2015-04-01 00:30:31.000000', 'consum', 0.0220, 'lps'),
	(470410, 124, '2015-04-01 00:30:32.000000', 'consum', 0.0211, 'lps'),
	(470411, 124, '2015-04-01 00:30:33.000000', 'consum', 0.0235, 'lps'),
	(470412, 124, '2015-04-01 00:30:34.000000', 'consum', 0.0231, 'lps'),
	(470413, 124, '2015-04-01 00:30:35.000000', 'consum', 0.0213, 'lps'),
	(470414, 124, '2015-04-01 00:30:36.000000', 'consum', 0.0216, 'lps'),
	(470415, 124, '2015-04-01 00:30:37.000000', 'consum', 0.0233, 'lps'),
	(470416, 124, '2015-04-01 00:30:38.000000', 'consum', 0.0226, 'lps'),
	(470417, 124, '2015-04-01 00:30:39.000000', 'consum', 0.0223, 'lps'),
	(470418, 124, '2015-04-01 00:30:40.000000', 'consum', 0.0226, 'lps'),
	(470419, 124, '2015-04-01 00:30:41.000000', 'consum', 0.0228, 'lps'),
	(470420, 124, '2015-04-01 00:30:42.000000', 'consum', 0.0225, 'lps'),
	(470421, 124, '2015-04-01 00:30:43.000000', 'consum', 0.0232, 'lps'),
	(470422, 124, '2015-04-01 00:30:44.000000', 'consum', 0.0223, 'lps'),
	(470423, 124, '2015-04-01 00:30:45.000000', 'consum', 0.0211, 'lps'),
	(470424, 124, '2015-04-01 00:30:46.000000', 'consum', 0.0226, 'lps'),
	(470425, 124, '2015-04-01 00:30:47.000000', 'consum', 0.0212, 'lps'),
	(470426, 124, '2015-04-01 00:30:48.000000', 'consum', 0.0225, 'lps'),
	(470427, 124, '2015-04-01 00:30:49.000000', 'consum', 0.0228, 'lps'),
	(470428, 124, '2015-04-01 00:30:50.000000', 'consum', 0.0227, 'lps'),
	(470429, 124, '2015-04-01 00:30:51.000000', 'consum', 0.0215, 'lps'),
	(470430, 124, '2015-04-01 00:30:52.000000', 'consum', 0.0211, 'lps'),
	(470431, 124, '2015-04-01 00:30:53.000000', 'consum', 0.0225, 'lps'),
	(470432, 124, '2015-04-01 00:30:54.000000', 'consum', 0.0234, 'lps'),
	(470433, 124, '2015-04-01 00:30:55.000000', 'consum', 0.0231, 'lps'),
	(470434, 124, '2015-04-01 00:30:56.000000', 'consum', 0.0219, 'lps'),
	(470435, 124, '2015-04-01 00:30:57.000000', 'consum', 0.0220, 'lps'),
	(470436, 124, '2015-04-01 00:30:58.000000', 'consum', 0.0230, 'lps'),
	(470437, 124, '2015-04-01 00:30:59.000000', 'consum', 0.0230, 'lps'),
	(470438, 124, '2015-04-01 00:31:00.000000', 'consum', 0.0227, 'lps'),
	(470439, 124, '2015-04-01 00:31:01.000000', 'consum', 0.0232, 'lps'),
	(470440, 124, '2015-04-01 00:31:02.000000', 'consum', 0.0217, 'lps'),
	(470441, 124, '2015-04-01 00:31:03.000000', 'consum', 0.0233, 'lps'),
	(470442, 124, '2015-04-01 00:31:04.000000', 'consum', 0.0228, 'lps'),
	(470443, 124, '2015-04-01 00:31:05.000000', 'consum', 0.0229, 'lps'),
	(470444, 124, '2015-04-01 00:31:06.000000', 'consum', 0.0225, 'lps'),
	(470445, 124, '2015-04-01 00:31:07.000000', 'consum', 0.0231, 'lps'),
	(470446, 124, '2015-04-01 00:31:08.000000', 'consum', 0.0216, 'lps'),
	(470447, 124, '2015-04-01 00:31:09.000000', 'consum', 0.0230, 'lps'),
	(470448, 124, '2015-04-01 00:31:10.000000', 'consum', 0.0213, 'lps'),
	(470449, 124, '2015-04-01 00:31:11.000000', 'consum', 0.0219, 'lps'),
	(470450, 124, '2015-04-01 00:31:12.000000', 'consum', 0.0220, 'lps'),
	(470451, 124, '2015-04-01 00:31:13.000000', 'consum', 0.0233, 'lps'),
	(470452, 124, '2015-04-01 00:31:14.000000', 'consum', 0.0217, 'lps'),
	(470453, 124, '2015-04-01 00:31:15.000000', 'consum', 0.0227, 'lps'),
	(470454, 124, '2015-04-01 00:31:16.000000', 'consum', 0.0225, 'lps'),
	(470455, 124, '2015-04-01 00:31:17.000000', 'consum', 0.0210, 'lps'),
	(470456, 124, '2015-04-01 00:31:18.000000', 'consum', 0.0215, 'lps'),
	(470457, 124, '2015-04-01 00:31:19.000000', 'consum', 0.0235, 'lps'),
	(470458, 124, '2015-04-01 00:31:20.000000', 'consum', 0.0216, 'lps'),
	(470459, 124, '2015-04-01 00:31:21.000000', 'consum', 0.0219, 'lps'),
	(470460, 124, '2015-04-01 00:31:22.000000', 'consum', 0.0210, 'lps'),
	(470461, 124, '2015-04-01 00:31:23.000000', 'consum', 0.0234, 'lps'),
	(470462, 124, '2015-04-01 00:31:24.000000', 'consum', 0.0230, 'lps'),
	(470463, 124, '2015-04-01 00:31:25.000000', 'consum', 0.0210, 'lps'),
	(470464, 124, '2015-04-01 00:31:26.000000', 'consum', 0.0229, 'lps'),
	(470465, 124, '2015-04-01 00:31:27.000000', 'consum', 0.0228, 'lps'),
	(470466, 124, '2015-04-01 00:31:28.000000', 'consum', 0.0217, 'lps'),
	(470467, 124, '2015-04-01 00:31:29.000000', 'consum', 0.0217, 'lps'),
	(470468, 124, '2015-04-01 00:31:30.000000', 'consum', 0.0227, 'lps'),
	(470469, 124, '2015-04-01 00:31:31.000000', 'consum', 0.0220, 'lps'),
	(470470, 124, '2015-04-01 00:31:32.000000', 'consum', 0.0211, 'lps'),
	(470471, 124, '2015-04-01 00:31:33.000000', 'consum', 0.0213, 'lps'),
	(470472, 124, '2015-04-01 00:31:34.000000', 'consum', 0.0221, 'lps'),
	(470473, 124, '2015-04-01 00:31:35.000000', 'consum', 0.0231, 'lps'),
	(470474, 124, '2015-04-01 00:31:36.000000', 'consum', 0.0228, 'lps'),
	(470475, 124, '2015-04-01 00:31:37.000000', 'consum', 0.0214, 'lps'),
	(470476, 124, '2015-04-01 00:31:38.000000', 'consum', 0.0227, 'lps'),
	(470477, 124, '2015-04-01 00:31:39.000000', 'consum', 0.0234, 'lps'),
	(470478, 124, '2015-04-01 00:31:40.000000', 'consum', 0.0226, 'lps'),
	(470479, 124, '2015-04-01 00:31:41.000000', 'consum', 0.0218, 'lps'),
	(470480, 124, '2015-04-01 00:31:42.000000', 'consum', 0.0229, 'lps'),
	(470481, 124, '2015-04-01 00:31:43.000000', 'consum', 0.0228, 'lps'),
	(470482, 124, '2015-04-01 00:31:44.000000', 'consum', 0.0219, 'lps'),
	(470483, 124, '2015-04-01 00:31:45.000000', 'consum', 0.0229, 'lps'),
	(470484, 124, '2015-04-01 00:31:46.000000', 'consum', 0.0226, 'lps'),
	(470485, 124, '2015-04-01 00:31:47.000000', 'consum', 0.0234, 'lps'),
	(470486, 124, '2015-04-01 00:31:48.000000', 'consum', 0.0229, 'lps'),
	(470487, 124, '2015-04-01 00:31:49.000000', 'consum', 0.0235, 'lps'),
	(470488, 124, '2015-04-01 00:31:50.000000', 'consum', 0.0227, 'lps'),
	(470489, 124, '2015-04-01 00:31:51.000000', 'consum', 0.0220, 'lps'),
	(470490, 124, '2015-04-01 00:31:52.000000', 'consum', 0.0211, 'lps'),
	(470491, 124, '2015-04-01 00:31:53.000000', 'consum', 0.0234, 'lps'),
	(470492, 124, '2015-04-01 00:31:54.000000', 'consum', 0.0226, 'lps'),
	(470493, 124, '2015-04-01 00:31:55.000000', 'consum', 0.0219, 'lps'),
	(470494, 124, '2015-04-01 00:31:56.000000', 'consum', 0.0234, 'lps'),
	(470495, 124, '2015-04-01 00:31:57.000000', 'consum', 0.0224, 'lps'),
	(470496, 124, '2015-04-01 00:31:58.000000', 'consum', 0.0234, 'lps'),
	(470497, 124, '2015-04-01 00:31:59.000000', 'consum', 0.0212, 'lps'),
	(470498, 124, '2015-04-01 00:32:00.000000', 'consum', 0.0225, 'lps'),
	(470499, 124, '2015-04-01 00:32:01.000000', 'consum', 0.0230, 'lps'),
	(470500, 124, '2015-04-01 00:32:02.000000', 'consum', 0.0212, 'lps'),
	(470501, 124, '2015-04-01 00:32:03.000000', 'consum', 0.0214, 'lps'),
	(470502, 124, '2015-04-01 00:32:04.000000', 'consum', 0.0223, 'lps'),
	(470503, 124, '2015-04-01 00:32:05.000000', 'consum', 0.0213, 'lps'),
	(470504, 124, '2015-04-01 00:32:06.000000', 'consum', 0.0211, 'lps'),
	(470505, 124, '2015-04-01 00:32:07.000000', 'consum', 0.0231, 'lps'),
	(470506, 124, '2015-04-01 00:32:08.000000', 'consum', 0.0210, 'lps'),
	(470507, 124, '2015-04-01 00:32:09.000000', 'consum', 0.0227, 'lps'),
	(470508, 124, '2015-04-01 00:32:10.000000', 'consum', 0.0216, 'lps'),
	(470509, 124, '2015-04-01 00:32:11.000000', 'consum', 0.0216, 'lps'),
	(470510, 124, '2015-04-01 00:32:12.000000', 'consum', 0.0224, 'lps'),
	(470511, 124, '2015-04-01 00:32:13.000000', 'consum', 0.0211, 'lps'),
	(470512, 124, '2015-04-01 00:32:14.000000', 'consum', 0.0224, 'lps'),
	(470513, 124, '2015-04-01 00:32:15.000000', 'consum', 0.0224, 'lps'),
	(470514, 124, '2015-04-01 00:32:16.000000', 'consum', 0.0212, 'lps'),
	(470515, 124, '2015-04-01 00:32:17.000000', 'consum', 0.0232, 'lps'),
	(470516, 124, '2015-04-01 00:32:18.000000', 'consum', 0.0212, 'lps'),
	(470517, 124, '2015-04-01 00:32:19.000000', 'consum', 0.0232, 'lps'),
	(470518, 124, '2015-04-01 00:32:20.000000', 'consum', 0.0235, 'lps'),
	(470519, 124, '2015-04-01 00:32:21.000000', 'consum', 0.0219, 'lps'),
	(470520, 124, '2015-04-01 00:32:22.000000', 'consum', 0.0231, 'lps'),
	(470521, 124, '2015-04-01 00:32:23.000000', 'consum', 0.0210, 'lps'),
	(470522, 124, '2015-04-01 00:32:24.000000', 'consum', 0.0227, 'lps'),
	(470523, 124, '2015-04-01 00:32:25.000000', 'consum', 0.0219, 'lps'),
	(470524, 124, '2015-04-01 00:32:26.000000', 'consum', 0.0228, 'lps'),
	(470525, 124, '2015-04-01 00:32:27.000000', 'consum', 0.0221, 'lps'),
	(470526, 124, '2015-04-01 00:32:28.000000', 'consum', 0.0212, 'lps'),
	(470527, 124, '2015-04-01 00:32:29.000000', 'consum', 0.0213, 'lps'),
	(470528, 124, '2015-04-01 00:32:30.000000', 'consum', 0.0220, 'lps'),
	(470529, 124, '2015-04-01 00:32:31.000000', 'consum', 0.0226, 'lps'),
	(470530, 124, '2015-04-01 00:32:32.000000', 'consum', 0.0234, 'lps'),
	(470531, 124, '2015-04-01 00:32:33.000000', 'consum', 0.0232, 'lps'),
	(470532, 124, '2015-04-01 00:32:34.000000', 'consum', 0.0224, 'lps'),
	(470533, 124, '2015-04-01 00:32:35.000000', 'consum', 0.0211, 'lps'),
	(470534, 124, '2015-04-01 00:32:36.000000', 'consum', 0.0225, 'lps'),
	(470535, 124, '2015-04-01 00:32:37.000000', 'consum', 0.0233, 'lps'),
	(470536, 124, '2015-04-01 00:32:38.000000', 'consum', 0.0227, 'lps'),
	(470537, 124, '2015-04-01 00:32:39.000000', 'consum', 0.0225, 'lps'),
	(470538, 124, '2015-04-01 00:32:40.000000', 'consum', 0.0210, 'lps'),
	(470539, 124, '2015-04-01 00:32:41.000000', 'consum', 0.0218, 'lps'),
	(470540, 124, '2015-04-01 00:32:42.000000', 'consum', 0.0224, 'lps'),
	(470541, 124, '2015-04-01 00:32:43.000000', 'consum', 0.0230, 'lps'),
	(470542, 124, '2015-04-01 00:32:44.000000', 'consum', 0.0219, 'lps'),
	(470543, 124, '2015-04-01 00:32:45.000000', 'consum', 0.0219, 'lps'),
	(470544, 124, '2015-04-01 00:32:46.000000', 'consum', 0.0229, 'lps'),
	(470545, 124, '2015-04-01 00:32:47.000000', 'consum', 0.0228, 'lps'),
	(470546, 124, '2015-04-01 00:32:48.000000', 'consum', 0.0218, 'lps'),
	(470547, 124, '2015-04-01 00:32:49.000000', 'consum', 0.0222, 'lps'),
	(470548, 124, '2015-04-01 00:32:50.000000', 'consum', 0.0220, 'lps'),
	(470549, 124, '2015-04-01 00:32:51.000000', 'consum', 0.0227, 'lps'),
	(470550, 124, '2015-04-01 00:32:52.000000', 'consum', 0.0210, 'lps'),
	(470551, 124, '2015-04-01 00:32:53.000000', 'consum', 0.0211, 'lps'),
	(470552, 124, '2015-04-01 00:32:54.000000', 'consum', 0.0219, 'lps'),
	(470553, 124, '2015-04-01 00:32:55.000000', 'consum', 0.0223, 'lps'),
	(470554, 124, '2015-04-01 00:32:56.000000', 'consum', 0.0226, 'lps'),
	(470555, 124, '2015-04-01 00:32:57.000000', 'consum', 0.0222, 'lps'),
	(470556, 124, '2015-04-01 00:32:58.000000', 'consum', 0.0225, 'lps'),
	(470557, 124, '2015-04-01 00:32:59.000000', 'consum', 0.0224, 'lps'),
	(470558, 124, '2015-04-01 00:33:00.000000', 'consum', 0.0211, 'lps'),
	(470559, 124, '2015-04-01 00:33:01.000000', 'consum', 0.0223, 'lps'),
	(470560, 124, '2015-04-01 00:33:02.000000', 'consum', 0.0220, 'lps'),
	(470561, 124, '2015-04-01 00:33:03.000000', 'consum', 0.0222, 'lps'),
	(470562, 124, '2015-04-01 00:33:04.000000', 'consum', 0.0216, 'lps'),
	(470563, 124, '2015-04-01 00:33:05.000000', 'consum', 0.0230, 'lps'),
	(470564, 124, '2015-04-01 00:33:06.000000', 'consum', 0.0214, 'lps'),
	(470565, 124, '2015-04-01 00:33:07.000000', 'consum', 0.0223, 'lps'),
	(470566, 124, '2015-04-01 00:33:08.000000', 'consum', 0.0211, 'lps'),
	(470567, 124, '2015-04-01 00:33:09.000000', 'consum', 0.0229, 'lps'),
	(470568, 124, '2015-04-01 00:33:10.000000', 'consum', 0.0222, 'lps'),
	(470569, 124, '2015-04-01 00:33:11.000000', 'consum', 0.0216, 'lps'),
	(470570, 124, '2015-04-01 00:33:12.000000', 'consum', 0.0228, 'lps'),
	(470571, 124, '2015-04-01 00:33:13.000000', 'consum', 0.0233, 'lps'),
	(470572, 124, '2015-04-01 00:33:14.000000', 'consum', 0.0219, 'lps'),
	(470573, 124, '2015-04-01 00:33:15.000000', 'consum', 0.0214, 'lps'),
	(470574, 124, '2015-04-01 00:33:16.000000', 'consum', 0.0230, 'lps'),
	(470575, 124, '2015-04-01 00:33:17.000000', 'consum', 0.0220, 'lps'),
	(470576, 124, '2015-04-01 00:33:18.000000', 'consum', 0.0224, 'lps'),
	(470577, 124, '2015-04-01 00:33:19.000000', 'consum', 0.0226, 'lps'),
	(470578, 124, '2015-04-01 00:33:20.000000', 'consum', 0.0224, 'lps'),
	(470579, 124, '2015-04-01 00:33:21.000000', 'consum', 0.0232, 'lps'),
	(470580, 124, '2015-04-01 00:33:22.000000', 'consum', 0.0227, 'lps'),
	(470581, 124, '2015-04-01 00:33:23.000000', 'consum', 0.0230, 'lps'),
	(470582, 124, '2015-04-01 00:33:24.000000', 'consum', 0.0231, 'lps'),
	(470583, 124, '2015-04-01 00:33:25.000000', 'consum', 0.0230, 'lps'),
	(470584, 124, '2015-04-01 00:33:26.000000', 'consum', 0.0222, 'lps'),
	(470585, 124, '2015-04-01 00:33:27.000000', 'consum', 0.0211, 'lps'),
	(470586, 124, '2015-04-01 00:33:28.000000', 'consum', 0.0232, 'lps'),
	(470587, 124, '2015-04-01 00:33:29.000000', 'consum', 0.0214, 'lps'),
	(470588, 124, '2015-04-01 00:33:30.000000', 'consum', 0.0215, 'lps'),
	(470589, 124, '2015-04-01 00:33:31.000000', 'consum', 0.0226, 'lps'),
	(470590, 124, '2015-04-01 00:33:32.000000', 'consum', 0.0221, 'lps'),
	(470591, 124, '2015-04-01 00:33:33.000000', 'consum', 0.0216, 'lps'),
	(470592, 124, '2015-04-01 00:33:34.000000', 'consum', 0.0210, 'lps'),
	(470593, 124, '2015-04-01 00:33:35.000000', 'consum', 0.0219, 'lps'),
	(470594, 124, '2015-04-01 00:33:36.000000', 'consum', 0.0231, 'lps'),
	(470595, 124, '2015-04-01 00:33:37.000000', 'consum', 0.0234, 'lps'),
	(470596, 124, '2015-04-01 00:33:38.000000', 'consum', 0.0214, 'lps'),
	(470597, 124, '2015-04-01 00:33:39.000000', 'consum', 0.0213, 'lps'),
	(470598, 124, '2015-04-01 00:33:40.000000', 'consum', 0.0211, 'lps'),
	(470599, 124, '2015-04-01 00:33:41.000000', 'consum', 0.0235, 'lps'),
	(470600, 124, '2015-04-01 00:33:42.000000', 'consum', 0.0229, 'lps'),
	(470601, 124, '2015-04-01 00:33:43.000000', 'consum', 0.0230, 'lps'),
	(470602, 124, '2015-04-01 00:33:44.000000', 'consum', 0.0227, 'lps'),
	(470603, 124, '2015-04-01 00:33:45.000000', 'consum', 0.0211, 'lps'),
	(470604, 124, '2015-04-01 00:33:46.000000', 'consum', 0.0214, 'lps'),
	(470605, 124, '2015-04-01 00:33:47.000000', 'consum', 0.0228, 'lps'),
	(470606, 124, '2015-04-01 00:33:48.000000', 'consum', 0.0212, 'lps'),
	(470607, 124, '2015-04-01 00:33:49.000000', 'consum', 0.0219, 'lps'),
	(470608, 124, '2015-04-01 00:33:50.000000', 'consum', 0.0224, 'lps'),
	(470609, 124, '2015-04-01 00:33:51.000000', 'consum', 0.0225, 'lps'),
	(470610, 124, '2015-04-01 00:33:52.000000', 'consum', 0.0218, 'lps'),
	(470611, 124, '2015-04-01 00:33:53.000000', 'consum', 0.0234, 'lps'),
	(470612, 124, '2015-04-01 00:33:54.000000', 'consum', 0.0226, 'lps'),
	(470613, 124, '2015-04-01 00:33:55.000000', 'consum', 0.0220, 'lps'),
	(470614, 124, '2015-04-01 00:33:56.000000', 'consum', 0.0213, 'lps'),
	(470615, 124, '2015-04-01 00:33:57.000000', 'consum', 0.0220, 'lps'),
	(470616, 124, '2015-04-01 00:33:58.000000', 'consum', 0.0224, 'lps'),
	(470617, 124, '2015-04-01 00:33:59.000000', 'consum', 0.0228, 'lps'),
	(470618, 124, '2015-04-01 00:34:00.000000', 'consum', 0.0230, 'lps'),
	(470619, 124, '2015-04-01 00:34:01.000000', 'consum', 0.0231, 'lps'),
	(470620, 124, '2015-04-01 00:34:02.000000', 'consum', 0.0231, 'lps'),
	(470621, 124, '2015-04-01 00:34:03.000000', 'consum', 0.0226, 'lps'),
	(470622, 124, '2015-04-01 00:34:04.000000', 'consum', 0.0227, 'lps'),
	(470623, 124, '2015-04-01 00:34:05.000000', 'consum', 0.0224, 'lps'),
	(470624, 124, '2015-04-01 00:34:06.000000', 'consum', 0.0227, 'lps'),
	(470625, 124, '2015-04-01 00:34:07.000000', 'consum', 0.0227, 'lps'),
	(470626, 124, '2015-04-01 00:34:08.000000', 'consum', 0.0221, 'lps'),
	(470627, 124, '2015-04-01 00:34:09.000000', 'consum', 0.0213, 'lps'),
	(470628, 124, '2015-04-01 00:34:10.000000', 'consum', 0.0220, 'lps'),
	(470629, 124, '2015-04-01 00:34:11.000000', 'consum', 0.0225, 'lps'),
	(470630, 124, '2015-04-01 00:34:12.000000', 'consum', 0.0227, 'lps'),
	(470631, 124, '2015-04-01 00:34:13.000000', 'consum', 0.0228, 'lps'),
	(470632, 124, '2015-04-01 00:34:14.000000', 'consum', 0.0221, 'lps'),
	(470633, 124, '2015-04-01 00:34:15.000000', 'consum', 0.0211, 'lps'),
	(470634, 124, '2015-04-01 00:34:16.000000', 'consum', 0.0234, 'lps'),
	(470635, 124, '2015-04-01 00:34:17.000000', 'consum', 0.0224, 'lps'),
	(470636, 124, '2015-04-01 00:34:18.000000', 'consum', 0.0234, 'lps'),
	(470637, 124, '2015-04-01 00:34:19.000000', 'consum', 0.0211, 'lps'),
	(470638, 124, '2015-04-01 00:34:20.000000', 'consum', 0.0221, 'lps'),
	(470639, 124, '2015-04-01 00:34:21.000000', 'consum', 0.0211, 'lps'),
	(470640, 124, '2015-04-01 00:34:22.000000', 'consum', 0.0210, 'lps'),
	(470641, 124, '2015-04-01 00:34:23.000000', 'consum', 0.0231, 'lps'),
	(470642, 124, '2015-04-01 00:34:24.000000', 'consum', 0.0214, 'lps'),
	(470643, 124, '2015-04-01 00:34:25.000000', 'consum', 0.0219, 'lps'),
	(470644, 124, '2015-04-01 00:34:26.000000', 'consum', 0.0216, 'lps'),
	(470645, 124, '2015-04-01 00:34:27.000000', 'consum', 0.0213, 'lps'),
	(470646, 124, '2015-04-01 00:34:28.000000', 'consum', 0.0233, 'lps'),
	(470647, 124, '2015-04-01 00:34:29.000000', 'consum', 0.0213, 'lps'),
	(470648, 124, '2015-04-01 00:34:30.000000', 'consum', 0.0235, 'lps'),
	(470649, 124, '2015-04-01 00:34:31.000000', 'consum', 0.0222, 'lps'),
	(470650, 124, '2015-04-01 00:34:32.000000', 'consum', 0.0224, 'lps'),
	(470651, 124, '2015-04-01 00:34:33.000000', 'consum', 0.0215, 'lps'),
	(470652, 124, '2015-04-01 00:34:34.000000', 'consum', 0.0221, 'lps'),
	(470653, 124, '2015-04-01 00:34:35.000000', 'consum', 0.0225, 'lps'),
	(470654, 124, '2015-04-01 00:34:36.000000', 'consum', 0.0228, 'lps'),
	(470655, 124, '2015-04-01 00:34:37.000000', 'consum', 0.0227, 'lps'),
	(470656, 124, '2015-04-01 00:34:38.000000', 'consum', 0.0218, 'lps'),
	(470657, 124, '2015-04-01 00:34:39.000000', 'consum', 0.0224, 'lps'),
	(470658, 124, '2015-04-01 00:34:40.000000', 'consum', 0.0232, 'lps'),
	(470659, 124, '2015-04-01 00:34:41.000000', 'consum', 0.0224, 'lps'),
	(470660, 124, '2015-04-01 00:34:42.000000', 'consum', 0.0216, 'lps'),
	(470661, 124, '2015-04-01 00:34:43.000000', 'consum', 0.0224, 'lps'),
	(470662, 124, '2015-04-01 00:34:44.000000', 'consum', 0.0210, 'lps'),
	(470663, 124, '2015-04-01 00:34:45.000000', 'consum', 0.0220, 'lps'),
	(470664, 124, '2015-04-01 00:34:46.000000', 'consum', 0.0234, 'lps'),
	(470665, 124, '2015-04-01 00:34:47.000000', 'consum', 0.0224, 'lps'),
	(470666, 124, '2015-04-01 00:34:48.000000', 'consum', 0.0235, 'lps'),
	(470667, 124, '2015-04-01 00:34:49.000000', 'consum', 0.0214, 'lps'),
	(470668, 124, '2015-04-01 00:34:50.000000', 'consum', 0.0234, 'lps'),
	(470669, 124, '2015-04-01 00:34:51.000000', 'consum', 0.0214, 'lps'),
	(470670, 124, '2015-04-01 00:34:52.000000', 'consum', 0.0210, 'lps'),
	(470671, 124, '2015-04-01 00:34:53.000000', 'consum', 0.0225, 'lps'),
	(470672, 124, '2015-04-01 00:34:54.000000', 'consum', 0.0233, 'lps'),
	(470673, 124, '2015-04-01 00:34:55.000000', 'consum', 0.0230, 'lps'),
	(470674, 124, '2015-04-01 00:34:56.000000', 'consum', 0.0213, 'lps'),
	(470675, 124, '2015-04-01 00:34:57.000000', 'consum', 0.0218, 'lps'),
	(470676, 124, '2015-04-01 00:34:58.000000', 'consum', 0.0216, 'lps'),
	(470677, 124, '2015-04-01 00:34:59.000000', 'consum', 0.0217, 'lps'),
	(470678, 124, '2015-04-01 00:35:00.000000', 'consum', 0.0226, 'lps'),
	(470679, 124, '2015-04-01 00:35:01.000000', 'consum', 0.0219, 'lps'),
	(470680, 124, '2015-04-01 00:35:02.000000', 'consum', 0.0231, 'lps'),
	(470681, 124, '2015-04-01 00:35:03.000000', 'consum', 0.0213, 'lps'),
	(470682, 124, '2015-04-01 00:35:04.000000', 'consum', 0.0214, 'lps'),
	(470683, 124, '2015-04-01 00:35:05.000000', 'consum', 0.0220, 'lps'),
	(470684, 124, '2015-04-01 00:35:06.000000', 'consum', 0.0224, 'lps'),
	(470685, 124, '2015-04-01 00:35:07.000000', 'consum', 0.0226, 'lps'),
	(470686, 124, '2015-04-01 00:35:08.000000', 'consum', 0.0219, 'lps'),
	(470687, 124, '2015-04-01 00:35:09.000000', 'consum', 0.0211, 'lps'),
	(470688, 124, '2015-04-01 00:35:10.000000', 'consum', 0.0213, 'lps'),
	(470689, 124, '2015-04-01 00:35:11.000000', 'consum', 0.0221, 'lps'),
	(470690, 124, '2015-04-01 00:35:12.000000', 'consum', 0.0234, 'lps'),
	(470691, 124, '2015-04-01 00:35:13.000000', 'consum', 0.0216, 'lps'),
	(470692, 124, '2015-04-01 00:35:14.000000', 'consum', 0.0221, 'lps'),
	(470693, 124, '2015-04-01 00:35:15.000000', 'consum', 0.0222, 'lps'),
	(470694, 124, '2015-04-01 00:35:16.000000', 'consum', 0.0212, 'lps'),
	(470695, 124, '2015-04-01 00:35:17.000000', 'consum', 0.0210, 'lps'),
	(470696, 124, '2015-04-01 00:35:18.000000', 'consum', 0.0232, 'lps'),
	(470697, 124, '2015-04-01 00:35:19.000000', 'consum', 0.0214, 'lps'),
	(470698, 124, '2015-04-01 00:35:20.000000', 'consum', 0.0216, 'lps'),
	(470699, 124, '2015-04-01 00:35:21.000000', 'consum', 0.0231, 'lps'),
	(470700, 124, '2015-04-01 00:35:22.000000', 'consum', 0.0220, 'lps'),
	(470701, 124, '2015-04-01 00:35:23.000000', 'consum', 0.0224, 'lps'),
	(470702, 124, '2015-04-01 00:35:24.000000', 'consum', 0.0226, 'lps'),
	(470703, 124, '2015-04-01 00:35:25.000000', 'consum', 0.0219, 'lps'),
	(470704, 124, '2015-04-01 00:35:26.000000', 'consum', 0.0234, 'lps'),
	(470705, 124, '2015-04-01 00:35:27.000000', 'consum', 0.0224, 'lps'),
	(470706, 124, '2015-04-01 00:35:28.000000', 'consum', 0.0212, 'lps'),
	(470707, 124, '2015-04-01 00:35:29.000000', 'consum', 0.0229, 'lps'),
	(470708, 124, '2015-04-01 00:35:30.000000', 'consum', 0.0222, 'lps'),
	(470709, 124, '2015-04-01 00:35:31.000000', 'consum', 0.0213, 'lps'),
	(470710, 124, '2015-04-01 00:35:32.000000', 'consum', 0.0216, 'lps'),
	(470711, 124, '2015-04-01 00:35:33.000000', 'consum', 0.0231, 'lps'),
	(470712, 124, '2015-04-01 00:35:34.000000', 'consum', 0.0220, 'lps'),
	(470713, 124, '2015-04-01 00:35:35.000000', 'consum', 0.0222, 'lps'),
	(470714, 124, '2015-04-01 00:35:36.000000', 'consum', 0.0216, 'lps'),
	(470715, 124, '2015-04-01 00:35:37.000000', 'consum', 0.0230, 'lps'),
	(470716, 124, '2015-04-01 00:35:38.000000', 'consum', 0.0216, 'lps'),
	(470717, 124, '2015-04-01 00:35:39.000000', 'consum', 0.0230, 'lps'),
	(470718, 124, '2015-04-01 00:35:40.000000', 'consum', 0.0216, 'lps'),
	(470719, 124, '2015-04-01 00:35:41.000000', 'consum', 0.0234, 'lps'),
	(470720, 124, '2015-04-01 00:35:42.000000', 'consum', 0.0233, 'lps'),
	(470721, 124, '2015-04-01 00:35:43.000000', 'consum', 0.0226, 'lps'),
	(470722, 124, '2015-04-01 00:35:44.000000', 'consum', 0.0221, 'lps'),
	(470723, 124, '2015-04-01 00:35:45.000000', 'consum', 0.0217, 'lps'),
	(470724, 124, '2015-04-01 00:35:46.000000', 'consum', 0.0215, 'lps'),
	(470725, 124, '2015-04-01 00:35:47.000000', 'consum', 0.0214, 'lps'),
	(470726, 124, '2015-04-01 00:35:48.000000', 'consum', 0.0213, 'lps'),
	(470727, 124, '2015-04-01 00:35:49.000000', 'consum', 0.0215, 'lps'),
	(470728, 124, '2015-04-01 00:35:50.000000', 'consum', 0.0229, 'lps'),
	(470729, 124, '2015-04-01 00:35:51.000000', 'consum', 0.0235, 'lps'),
	(470730, 124, '2015-04-01 00:35:52.000000', 'consum', 0.0229, 'lps'),
	(470731, 124, '2015-04-01 00:35:53.000000', 'consum', 0.0230, 'lps'),
	(470732, 124, '2015-04-01 00:35:54.000000', 'consum', 0.0225, 'lps'),
	(470733, 124, '2015-04-01 00:35:55.000000', 'consum', 0.0228, 'lps'),
	(470734, 124, '2015-04-01 00:35:56.000000', 'consum', 0.0231, 'lps'),
	(470735, 124, '2015-04-01 00:35:57.000000', 'consum', 0.0233, 'lps'),
	(470736, 124, '2015-04-01 00:35:58.000000', 'consum', 0.0235, 'lps'),
	(470737, 124, '2015-04-01 00:35:59.000000', 'consum', 0.0216, 'lps'),
	(470738, 124, '2015-04-01 00:36:00.000000', 'consum', 0.0219, 'lps'),
	(470739, 124, '2015-04-01 00:36:01.000000', 'consum', 0.0235, 'lps'),
	(470740, 124, '2015-04-01 00:36:02.000000', 'consum', 0.0231, 'lps'),
	(470741, 124, '2015-04-01 00:36:03.000000', 'consum', 0.0217, 'lps'),
	(470742, 124, '2015-04-01 00:36:04.000000', 'consum', 0.0232, 'lps'),
	(470743, 124, '2015-04-01 00:36:05.000000', 'consum', 0.0221, 'lps'),
	(470744, 124, '2015-04-01 00:36:06.000000', 'consum', 0.0225, 'lps'),
	(470745, 124, '2015-04-01 00:36:07.000000', 'consum', 0.0228, 'lps'),
	(470746, 124, '2015-04-01 00:36:08.000000', 'consum', 0.0229, 'lps'),
	(470747, 124, '2015-04-01 00:36:09.000000', 'consum', 0.0226, 'lps'),
	(470748, 124, '2015-04-01 00:36:10.000000', 'consum', 0.0234, 'lps'),
	(470749, 124, '2015-04-01 00:36:11.000000', 'consum', 0.0229, 'lps'),
	(470750, 124, '2015-04-01 00:36:12.000000', 'consum', 0.0235, 'lps'),
	(470751, 124, '2015-04-01 00:36:13.000000', 'consum', 0.0224, 'lps'),
	(470752, 124, '2015-04-01 00:36:14.000000', 'consum', 0.0234, 'lps'),
	(470753, 124, '2015-04-01 00:36:15.000000', 'consum', 0.0210, 'lps'),
	(470754, 124, '2015-04-01 00:36:16.000000', 'consum', 0.0217, 'lps'),
	(470755, 124, '2015-04-01 00:36:17.000000', 'consum', 0.0218, 'lps'),
	(470756, 124, '2015-04-01 00:36:18.000000', 'consum', 0.0228, 'lps'),
	(470757, 124, '2015-04-01 00:36:19.000000', 'consum', 0.0227, 'lps'),
	(470758, 124, '2015-04-01 00:36:20.000000', 'consum', 0.0216, 'lps'),
	(470759, 124, '2015-04-01 00:36:21.000000', 'consum', 0.0213, 'lps'),
	(470760, 124, '2015-04-01 00:36:22.000000', 'consum', 0.0234, 'lps'),
	(470761, 124, '2015-04-01 00:36:23.000000', 'consum', 0.0218, 'lps'),
	(470762, 124, '2015-04-01 00:36:24.000000', 'consum', 0.0232, 'lps'),
	(470763, 124, '2015-04-01 00:36:25.000000', 'consum', 0.0217, 'lps'),
	(470764, 124, '2015-04-01 00:36:26.000000', 'consum', 0.0232, 'lps'),
	(470765, 124, '2015-04-01 00:36:27.000000', 'consum', 0.0222, 'lps'),
	(470766, 124, '2015-04-01 00:36:28.000000', 'consum', 0.0232, 'lps'),
	(470767, 124, '2015-04-01 00:36:29.000000', 'consum', 0.0232, 'lps'),
	(470768, 124, '2015-04-01 00:36:30.000000', 'consum', 0.0228, 'lps'),
	(470769, 124, '2015-04-01 00:36:31.000000', 'consum', 0.0234, 'lps'),
	(470770, 124, '2015-04-01 00:36:32.000000', 'consum', 0.0226, 'lps'),
	(470771, 124, '2015-04-01 00:36:33.000000', 'consum', 0.0219, 'lps'),
	(470772, 124, '2015-04-01 00:36:34.000000', 'consum', 0.0232, 'lps'),
	(470773, 124, '2015-04-01 00:36:35.000000', 'consum', 0.0215, 'lps'),
	(470774, 124, '2015-04-01 00:36:36.000000', 'consum', 0.0223, 'lps'),
	(470775, 124, '2015-04-01 00:36:37.000000', 'consum', 0.0235, 'lps'),
	(470776, 124, '2015-04-01 00:36:38.000000', 'consum', 0.0218, 'lps'),
	(470777, 124, '2015-04-01 00:36:39.000000', 'consum', 0.0225, 'lps'),
	(470778, 124, '2015-04-01 00:36:40.000000', 'consum', 0.0213, 'lps'),
	(470779, 124, '2015-04-01 00:36:41.000000', 'consum', 0.0230, 'lps'),
	(470780, 124, '2015-04-01 00:36:42.000000', 'consum', 0.0224, 'lps'),
	(470781, 124, '2015-04-01 00:36:43.000000', 'consum', 0.0221, 'lps'),
	(470782, 124, '2015-04-01 00:36:44.000000', 'consum', 0.0223, 'lps'),
	(470783, 124, '2015-04-01 00:36:45.000000', 'consum', 0.0215, 'lps'),
	(470784, 124, '2015-04-01 00:36:46.000000', 'consum', 0.0224, 'lps'),
	(470785, 124, '2015-04-01 00:36:47.000000', 'consum', 0.0215, 'lps'),
	(470786, 124, '2015-04-01 00:36:48.000000', 'consum', 0.0218, 'lps'),
	(470787, 124, '2015-04-01 00:36:49.000000', 'consum', 0.0211, 'lps'),
	(470788, 124, '2015-04-01 00:36:50.000000', 'consum', 0.0215, 'lps'),
	(470789, 124, '2015-04-01 00:36:51.000000', 'consum', 0.0232, 'lps'),
	(470790, 124, '2015-04-01 00:36:52.000000', 'consum', 0.0228, 'lps'),
	(470791, 124, '2015-04-01 00:36:53.000000', 'consum', 0.0235, 'lps'),
	(470792, 124, '2015-04-01 00:36:54.000000', 'consum', 0.0228, 'lps'),
	(470793, 124, '2015-04-01 00:36:55.000000', 'consum', 0.0228, 'lps'),
	(470794, 124, '2015-04-01 00:36:56.000000', 'consum', 0.0218, 'lps'),
	(470795, 124, '2015-04-01 00:36:57.000000', 'consum', 0.0222, 'lps'),
	(470796, 124, '2015-04-01 00:36:58.000000', 'consum', 0.0221, 'lps'),
	(470797, 124, '2015-04-01 00:36:59.000000', 'consum', 0.0229, 'lps'),
	(470798, 124, '2015-04-01 00:37:00.000000', 'consum', 0.0222, 'lps'),
	(470799, 124, '2015-04-01 00:37:01.000000', 'consum', 0.0211, 'lps'),
	(470800, 124, '2015-04-01 00:37:02.000000', 'consum', 0.0234, 'lps'),
	(470801, 124, '2015-04-01 00:37:03.000000', 'consum', 0.0221, 'lps'),
	(470802, 124, '2015-04-01 00:37:04.000000', 'consum', 0.0222, 'lps'),
	(470803, 124, '2015-04-01 00:37:05.000000', 'consum', 0.0210, 'lps'),
	(470804, 124, '2015-04-01 00:37:06.000000', 'consum', 0.0225, 'lps'),
	(470805, 124, '2015-04-01 00:37:07.000000', 'consum', 0.0210, 'lps'),
	(470806, 124, '2015-04-01 00:37:08.000000', 'consum', 0.0216, 'lps'),
	(470807, 124, '2015-04-01 00:37:09.000000', 'consum', 0.0217, 'lps'),
	(470808, 124, '2015-04-01 00:37:10.000000', 'consum', 0.0226, 'lps'),
	(470809, 124, '2015-04-01 00:37:11.000000', 'consum', 0.0220, 'lps'),
	(470810, 124, '2015-04-01 00:37:12.000000', 'consum', 0.0235, 'lps'),
	(470811, 124, '2015-04-01 00:37:13.000000', 'consum', 0.0231, 'lps'),
	(470812, 124, '2015-04-01 00:37:14.000000', 'consum', 0.0212, 'lps'),
	(470813, 124, '2015-04-01 00:37:15.000000', 'consum', 0.0212, 'lps'),
	(470814, 124, '2015-04-01 00:37:16.000000', 'consum', 0.0213, 'lps'),
	(470815, 124, '2015-04-01 00:37:17.000000', 'consum', 0.0220, 'lps'),
	(470816, 124, '2015-04-01 00:37:18.000000', 'consum', 0.0223, 'lps'),
	(470817, 124, '2015-04-01 00:37:19.000000', 'consum', 0.0222, 'lps'),
	(470818, 124, '2015-04-01 00:37:20.000000', 'consum', 0.0230, 'lps'),
	(470819, 124, '2015-04-01 00:37:21.000000', 'consum', 0.0221, 'lps'),
	(470820, 124, '2015-04-01 00:37:22.000000', 'consum', 0.0234, 'lps'),
	(470821, 124, '2015-04-01 00:37:23.000000', 'consum', 0.0217, 'lps'),
	(470822, 124, '2015-04-01 00:37:24.000000', 'consum', 0.0228, 'lps'),
	(470823, 124, '2015-04-01 00:37:25.000000', 'consum', 0.0225, 'lps'),
	(470824, 124, '2015-04-01 00:37:26.000000', 'consum', 0.0233, 'lps'),
	(470825, 124, '2015-04-01 00:37:27.000000', 'consum', 0.0230, 'lps'),
	(470826, 124, '2015-04-01 00:37:28.000000', 'consum', 0.0216, 'lps'),
	(470827, 124, '2015-04-01 00:37:29.000000', 'consum', 0.0230, 'lps'),
	(470828, 124, '2015-04-01 00:37:30.000000', 'consum', 0.0215, 'lps'),
	(470829, 124, '2015-04-01 00:37:31.000000', 'consum', 0.0227, 'lps'),
	(470830, 124, '2015-04-01 00:37:32.000000', 'consum', 0.0231, 'lps'),
	(470831, 124, '2015-04-01 00:37:33.000000', 'consum', 0.0210, 'lps'),
	(470832, 124, '2015-04-01 00:37:34.000000', 'consum', 0.0227, 'lps'),
	(470833, 124, '2015-04-01 00:37:35.000000', 'consum', 0.0218, 'lps'),
	(470834, 124, '2015-04-01 00:37:36.000000', 'consum', 0.0224, 'lps'),
	(470835, 124, '2015-04-01 00:37:37.000000', 'consum', 0.0232, 'lps'),
	(470836, 124, '2015-04-01 00:37:38.000000', 'consum', 0.0225, 'lps'),
	(470837, 124, '2015-04-01 00:37:39.000000', 'consum', 0.0219, 'lps'),
	(470838, 124, '2015-04-01 00:37:40.000000', 'consum', 0.0212, 'lps'),
	(470839, 124, '2015-04-01 00:37:41.000000', 'consum', 0.0220, 'lps'),
	(470840, 124, '2015-04-01 00:37:42.000000', 'consum', 0.0226, 'lps'),
	(470841, 124, '2015-04-01 00:37:43.000000', 'consum', 0.0210, 'lps'),
	(470842, 124, '2015-04-01 00:37:44.000000', 'consum', 0.0215, 'lps'),
	(470843, 124, '2015-04-01 00:37:45.000000', 'consum', 0.0210, 'lps'),
	(470844, 124, '2015-04-01 00:37:46.000000', 'consum', 0.0222, 'lps'),
	(470845, 124, '2015-04-01 00:37:47.000000', 'consum', 0.0216, 'lps'),
	(470846, 124, '2015-04-01 00:37:48.000000', 'consum', 0.0232, 'lps'),
	(470847, 124, '2015-04-01 00:37:49.000000', 'consum', 0.0223, 'lps'),
	(470848, 124, '2015-04-01 00:37:50.000000', 'consum', 0.0235, 'lps'),
	(470849, 124, '2015-04-01 00:37:51.000000', 'consum', 0.0221, 'lps'),
	(470850, 124, '2015-04-01 00:37:52.000000', 'consum', 0.0215, 'lps'),
	(470851, 124, '2015-04-01 00:37:53.000000', 'consum', 0.0227, 'lps'),
	(470852, 124, '2015-04-01 00:37:54.000000', 'consum', 0.0231, 'lps'),
	(470853, 124, '2015-04-01 00:37:55.000000', 'consum', 0.0211, 'lps'),
	(470854, 124, '2015-04-01 00:37:56.000000', 'consum', 0.0229, 'lps'),
	(470855, 124, '2015-04-01 00:37:57.000000', 'consum', 0.0226, 'lps'),
	(470856, 124, '2015-04-01 00:37:58.000000', 'consum', 0.0234, 'lps'),
	(470857, 124, '2015-04-01 00:37:59.000000', 'consum', 0.0230, 'lps'),
	(470858, 124, '2015-04-01 00:38:00.000000', 'consum', 0.0214, 'lps'),
	(470859, 124, '2015-04-01 00:38:01.000000', 'consum', 0.0220, 'lps'),
	(470860, 124, '2015-04-01 00:38:02.000000', 'consum', 0.0224, 'lps'),
	(470861, 124, '2015-04-01 00:38:03.000000', 'consum', 0.0225, 'lps'),
	(470862, 124, '2015-04-01 00:38:04.000000', 'consum', 0.0215, 'lps'),
	(470863, 124, '2015-04-01 00:38:05.000000', 'consum', 0.0220, 'lps'),
	(470864, 124, '2015-04-01 00:38:06.000000', 'consum', 0.0216, 'lps'),
	(470865, 124, '2015-04-01 00:38:07.000000', 'consum', 0.0212, 'lps'),
	(470866, 124, '2015-04-01 00:38:08.000000', 'consum', 0.0230, 'lps'),
	(470867, 124, '2015-04-01 00:38:09.000000', 'consum', 0.0224, 'lps'),
	(470868, 124, '2015-04-01 00:38:10.000000', 'consum', 0.0223, 'lps'),
	(470869, 124, '2015-04-01 00:38:11.000000', 'consum', 0.0231, 'lps'),
	(470870, 124, '2015-04-01 00:38:12.000000', 'consum', 0.0224, 'lps'),
	(470871, 124, '2015-04-01 00:38:13.000000', 'consum', 0.0218, 'lps'),
	(470872, 124, '2015-04-01 00:38:14.000000', 'consum', 0.0234, 'lps'),
	(470873, 124, '2015-04-01 00:38:15.000000', 'consum', 0.0231, 'lps'),
	(470874, 124, '2015-04-01 00:38:16.000000', 'consum', 0.0215, 'lps'),
	(470875, 124, '2015-04-01 00:38:17.000000', 'consum', 0.0225, 'lps'),
	(470876, 124, '2015-04-01 00:38:18.000000', 'consum', 0.0221, 'lps'),
	(470877, 124, '2015-04-01 00:38:19.000000', 'consum', 0.0217, 'lps'),
	(470878, 124, '2015-04-01 00:38:20.000000', 'consum', 0.0214, 'lps'),
	(470879, 124, '2015-04-01 00:38:21.000000', 'consum', 0.0234, 'lps'),
	(470880, 124, '2015-04-01 00:38:22.000000', 'consum', 0.0217, 'lps'),
	(470881, 124, '2015-04-01 00:38:23.000000', 'consum', 0.0223, 'lps'),
	(470882, 124, '2015-04-01 00:38:24.000000', 'consum', 0.0230, 'lps'),
	(470883, 124, '2015-04-01 00:38:25.000000', 'consum', 0.0220, 'lps'),
	(470884, 124, '2015-04-01 00:38:26.000000', 'consum', 0.0226, 'lps'),
	(470885, 124, '2015-04-01 00:38:27.000000', 'consum', 0.0234, 'lps'),
	(470886, 124, '2015-04-01 00:38:28.000000', 'consum', 0.0232, 'lps'),
	(470887, 124, '2015-04-01 00:38:29.000000', 'consum', 0.0222, 'lps'),
	(470888, 124, '2015-04-01 00:38:30.000000', 'consum', 0.0232, 'lps'),
	(470889, 124, '2015-04-01 00:38:31.000000', 'consum', 0.0231, 'lps'),
	(470890, 124, '2015-04-01 00:38:32.000000', 'consum', 0.0224, 'lps'),
	(470891, 124, '2015-04-01 00:38:33.000000', 'consum', 0.0216, 'lps'),
	(470892, 124, '2015-04-01 00:38:34.000000', 'consum', 0.0224, 'lps'),
	(470893, 124, '2015-04-01 00:38:35.000000', 'consum', 0.0211, 'lps'),
	(470894, 124, '2015-04-01 00:38:36.000000', 'consum', 0.0226, 'lps'),
	(470895, 124, '2015-04-01 00:38:37.000000', 'consum', 0.0235, 'lps'),
	(470896, 124, '2015-04-01 00:38:38.000000', 'consum', 0.0211, 'lps'),
	(470897, 124, '2015-04-01 00:38:39.000000', 'consum', 0.0218, 'lps'),
	(470898, 124, '2015-04-01 00:38:40.000000', 'consum', 0.0223, 'lps'),
	(470899, 124, '2015-04-01 00:38:41.000000', 'consum', 0.0224, 'lps'),
	(470900, 124, '2015-04-01 00:38:42.000000', 'consum', 0.0218, 'lps'),
	(470901, 124, '2015-04-01 00:38:43.000000', 'consum', 0.0232, 'lps'),
	(470902, 124, '2015-04-01 00:38:44.000000', 'consum', 0.0218, 'lps'),
	(470903, 124, '2015-04-01 00:38:45.000000', 'consum', 0.0213, 'lps'),
	(470904, 124, '2015-04-01 00:38:46.000000', 'consum', 0.0225, 'lps'),
	(470905, 124, '2015-04-01 00:38:47.000000', 'consum', 0.0223, 'lps'),
	(470906, 124, '2015-04-01 00:38:48.000000', 'consum', 0.0234, 'lps'),
	(470907, 124, '2015-04-01 00:38:49.000000', 'consum', 0.0214, 'lps'),
	(470908, 124, '2015-04-01 00:38:50.000000', 'consum', 0.0233, 'lps'),
	(470909, 124, '2015-04-01 00:38:51.000000', 'consum', 0.0213, 'lps'),
	(470910, 124, '2015-04-01 00:38:52.000000', 'consum', 0.0232, 'lps'),
	(470911, 124, '2015-04-01 00:38:53.000000', 'consum', 0.0234, 'lps'),
	(470912, 124, '2015-04-01 00:38:54.000000', 'consum', 0.0213, 'lps'),
	(470913, 124, '2015-04-01 00:38:55.000000', 'consum', 0.0233, 'lps'),
	(470914, 124, '2015-04-01 00:38:56.000000', 'consum', 0.0213, 'lps'),
	(470915, 124, '2015-04-01 00:38:57.000000', 'consum', 0.0234, 'lps'),
	(470916, 124, '2015-04-01 00:38:58.000000', 'consum', 0.0215, 'lps'),
	(470917, 124, '2015-04-01 00:38:59.000000', 'consum', 0.0218, 'lps'),
	(470918, 124, '2015-04-01 00:39:00.000000', 'consum', 0.0235, 'lps'),
	(470919, 124, '2015-04-01 00:39:01.000000', 'consum', 0.0232, 'lps'),
	(470920, 124, '2015-04-01 00:39:02.000000', 'consum', 0.0219, 'lps'),
	(470921, 124, '2015-04-01 00:39:03.000000', 'consum', 0.0218, 'lps'),
	(470922, 124, '2015-04-01 00:39:04.000000', 'consum', 0.0221, 'lps'),
	(470923, 124, '2015-04-01 00:39:05.000000', 'consum', 0.0217, 'lps'),
	(470924, 124, '2015-04-01 00:39:06.000000', 'consum', 0.0211, 'lps'),
	(470925, 124, '2015-04-01 00:39:07.000000', 'consum', 0.0221, 'lps'),
	(470926, 124, '2015-04-01 00:39:08.000000', 'consum', 0.0212, 'lps'),
	(470927, 124, '2015-04-01 00:39:09.000000', 'consum', 0.0214, 'lps'),
	(470928, 124, '2015-04-01 00:39:10.000000', 'consum', 0.0224, 'lps'),
	(470929, 124, '2015-04-01 00:39:11.000000', 'consum', 0.0216, 'lps'),
	(470930, 124, '2015-04-01 00:39:12.000000', 'consum', 0.0227, 'lps'),
	(470931, 124, '2015-04-01 00:39:13.000000', 'consum', 0.0222, 'lps'),
	(470932, 124, '2015-04-01 00:39:14.000000', 'consum', 0.0221, 'lps'),
	(470933, 124, '2015-04-01 00:39:15.000000', 'consum', 0.0228, 'lps'),
	(470934, 124, '2015-04-01 00:39:16.000000', 'consum', 0.0217, 'lps'),
	(470935, 124, '2015-04-01 00:39:17.000000', 'consum', 0.0215, 'lps'),
	(470936, 124, '2015-04-01 00:39:18.000000', 'consum', 0.0217, 'lps'),
	(470937, 124, '2015-04-01 00:39:19.000000', 'consum', 0.0230, 'lps'),
	(470938, 124, '2015-04-01 00:39:20.000000', 'consum', 0.0213, 'lps'),
	(470939, 124, '2015-04-01 00:39:21.000000', 'consum', 0.0215, 'lps'),
	(470940, 124, '2015-04-01 00:39:22.000000', 'consum', 0.0228, 'lps'),
	(470941, 124, '2015-04-01 00:39:23.000000', 'consum', 0.0233, 'lps'),
	(470942, 124, '2015-04-01 00:39:24.000000', 'consum', 0.0219, 'lps'),
	(470943, 124, '2015-04-01 00:39:25.000000', 'consum', 0.0211, 'lps'),
	(470944, 124, '2015-04-01 00:39:26.000000', 'consum', 0.0217, 'lps'),
	(470945, 124, '2015-04-01 00:39:27.000000', 'consum', 0.0214, 'lps'),
	(470946, 124, '2015-04-01 00:39:28.000000', 'consum', 0.0210, 'lps'),
	(470947, 124, '2015-04-01 00:39:29.000000', 'consum', 0.0226, 'lps'),
	(470948, 124, '2015-04-01 00:39:30.000000', 'consum', 0.0212, 'lps'),
	(470949, 124, '2015-04-01 00:39:31.000000', 'consum', 0.0223, 'lps'),
	(470950, 124, '2015-04-01 00:39:32.000000', 'consum', 0.0218, 'lps'),
	(470951, 124, '2015-04-01 00:39:33.000000', 'consum', 0.0211, 'lps'),
	(470952, 124, '2015-04-01 00:39:34.000000', 'consum', 0.0217, 'lps'),
	(470953, 124, '2015-04-01 00:39:35.000000', 'consum', 0.0217, 'lps'),
	(470954, 124, '2015-04-01 00:39:36.000000', 'consum', 0.0225, 'lps'),
	(470955, 124, '2015-04-01 00:39:37.000000', 'consum', 0.0214, 'lps'),
	(470956, 124, '2015-04-01 00:39:38.000000', 'consum', 0.0211, 'lps'),
	(470957, 124, '2015-04-01 00:39:39.000000', 'consum', 0.0230, 'lps'),
	(470958, 124, '2015-04-01 00:39:40.000000', 'consum', 0.0230, 'lps'),
	(470959, 124, '2015-04-01 00:39:41.000000', 'consum', 0.0224, 'lps'),
	(470960, 124, '2015-04-01 00:39:42.000000', 'consum', 0.0220, 'lps'),
	(470961, 124, '2015-04-01 00:39:43.000000', 'consum', 0.0219, 'lps'),
	(470962, 124, '2015-04-01 00:39:44.000000', 'consum', 0.0224, 'lps'),
	(470963, 124, '2015-04-01 00:39:45.000000', 'consum', 0.0229, 'lps'),
	(470964, 124, '2015-04-01 00:39:46.000000', 'consum', 0.0211, 'lps'),
	(470965, 124, '2015-04-01 00:39:47.000000', 'consum', 0.0211, 'lps'),
	(470966, 124, '2015-04-01 00:39:48.000000', 'consum', 0.0213, 'lps'),
	(470967, 124, '2015-04-01 00:39:49.000000', 'consum', 0.0222, 'lps'),
	(470968, 124, '2015-04-01 00:39:50.000000', 'consum', 0.0233, 'lps'),
	(470969, 124, '2015-04-01 00:39:51.000000', 'consum', 0.0215, 'lps'),
	(470970, 124, '2015-04-01 00:39:52.000000', 'consum', 0.0216, 'lps'),
	(470971, 124, '2015-04-01 00:39:53.000000', 'consum', 0.0225, 'lps'),
	(470972, 124, '2015-04-01 00:39:54.000000', 'consum', 0.0215, 'lps'),
	(470973, 124, '2015-04-01 00:39:55.000000', 'consum', 0.0220, 'lps'),
	(470974, 124, '2015-04-01 00:39:56.000000', 'consum', 0.0216, 'lps'),
	(470975, 124, '2015-04-01 00:39:57.000000', 'consum', 0.0211, 'lps'),
	(470976, 124, '2015-04-01 00:39:58.000000', 'consum', 0.0222, 'lps'),
	(470977, 124, '2015-04-01 00:39:59.000000', 'consum', 0.0219, 'lps'),
	(470978, 124, '2015-04-01 00:40:00.000000', 'consum', 0.0217, 'lps'),
	(470979, 124, '2015-04-01 00:40:01.000000', 'consum', 0.0220, 'lps'),
	(470980, 124, '2015-04-01 00:40:02.000000', 'consum', 0.0214, 'lps'),
	(470981, 124, '2015-04-01 00:40:03.000000', 'consum', 0.0227, 'lps'),
	(470982, 124, '2015-04-01 00:40:04.000000', 'consum', 0.0231, 'lps'),
	(470983, 124, '2015-04-01 00:40:05.000000', 'consum', 0.0211, 'lps'),
	(470984, 124, '2015-04-01 00:40:06.000000', 'consum', 0.0231, 'lps'),
	(470985, 124, '2015-04-01 00:40:07.000000', 'consum', 0.0210, 'lps'),
	(470986, 124, '2015-04-01 00:40:08.000000', 'consum', 0.0225, 'lps'),
	(470987, 124, '2015-04-01 00:40:09.000000', 'consum', 0.0235, 'lps'),
	(470988, 124, '2015-04-01 00:40:10.000000', 'consum', 0.0213, 'lps'),
	(470989, 124, '2015-04-01 00:40:11.000000', 'consum', 0.0226, 'lps'),
	(470990, 124, '2015-04-01 00:40:12.000000', 'consum', 0.0229, 'lps'),
	(470991, 124, '2015-04-01 00:40:13.000000', 'consum', 0.0232, 'lps'),
	(470992, 124, '2015-04-01 00:40:14.000000', 'consum', 0.0212, 'lps'),
	(470993, 124, '2015-04-01 00:40:15.000000', 'consum', 0.0232, 'lps'),
	(470994, 124, '2015-04-01 00:40:16.000000', 'consum', 0.0210, 'lps'),
	(470995, 124, '2015-04-01 00:40:17.000000', 'consum', 0.0221, 'lps'),
	(470996, 124, '2015-04-01 00:40:18.000000', 'consum', 0.0217, 'lps'),
	(470997, 124, '2015-04-01 00:40:19.000000', 'consum', 0.0211, 'lps'),
	(470998, 124, '2015-04-01 00:40:20.000000', 'consum', 0.0222, 'lps'),
	(470999, 124, '2015-04-01 00:40:21.000000', 'consum', 0.0213, 'lps'),
	(471000, 124, '2015-04-01 00:40:22.000000', 'consum', 0.0218, 'lps'),
	(471001, 124, '2015-04-01 00:40:23.000000', 'consum', 0.0213, 'lps'),
	(471002, 124, '2015-04-01 00:40:24.000000', 'consum', 0.0230, 'lps'),
	(471003, 124, '2015-04-01 00:40:25.000000', 'consum', 0.0222, 'lps'),
	(471004, 124, '2015-04-01 00:40:26.000000', 'consum', 0.0235, 'lps'),
	(471005, 124, '2015-04-01 00:40:27.000000', 'consum', 0.0223, 'lps'),
	(471006, 124, '2015-04-01 00:40:28.000000', 'consum', 0.0226, 'lps'),
	(471007, 124, '2015-04-01 00:40:29.000000', 'consum', 0.0224, 'lps'),
	(471008, 124, '2015-04-01 00:40:30.000000', 'consum', 0.0235, 'lps'),
	(471009, 124, '2015-04-01 00:40:31.000000', 'consum', 0.0216, 'lps'),
	(471010, 124, '2015-04-01 00:40:32.000000', 'consum', 0.0215, 'lps'),
	(471011, 124, '2015-04-01 00:40:33.000000', 'consum', 0.0217, 'lps'),
	(471012, 124, '2015-04-01 00:40:34.000000', 'consum', 0.0232, 'lps'),
	(471013, 124, '2015-04-01 00:40:35.000000', 'consum', 0.0222, 'lps'),
	(471014, 124, '2015-04-01 00:40:36.000000', 'consum', 0.0228, 'lps'),
	(471015, 124, '2015-04-01 00:40:37.000000', 'consum', 0.0216, 'lps'),
	(471016, 124, '2015-04-01 00:40:38.000000', 'consum', 0.0210, 'lps'),
	(471017, 124, '2015-04-01 00:40:39.000000', 'consum', 0.0219, 'lps'),
	(471018, 124, '2015-04-01 00:40:40.000000', 'consum', 0.0229, 'lps'),
	(471019, 124, '2015-04-01 00:40:41.000000', 'consum', 0.0226, 'lps'),
	(471020, 124, '2015-04-01 00:40:42.000000', 'consum', 0.0235, 'lps'),
	(471021, 124, '2015-04-01 00:40:43.000000', 'consum', 0.0210, 'lps'),
	(471022, 124, '2015-04-01 00:40:44.000000', 'consum', 0.0214, 'lps'),
	(471023, 124, '2015-04-01 00:40:45.000000', 'consum', 0.0230, 'lps'),
	(471024, 124, '2015-04-01 00:40:46.000000', 'consum', 0.0219, 'lps'),
	(471025, 124, '2015-04-01 00:40:47.000000', 'consum', 0.0224, 'lps'),
	(471026, 124, '2015-04-01 00:40:48.000000', 'consum', 0.0227, 'lps'),
	(471027, 124, '2015-04-01 00:40:49.000000', 'consum', 0.0227, 'lps'),
	(471028, 124, '2015-04-01 00:40:50.000000', 'consum', 0.0220, 'lps'),
	(471029, 124, '2015-04-01 00:40:51.000000', 'consum', 0.0234, 'lps'),
	(471030, 124, '2015-04-01 00:40:52.000000', 'consum', 0.0224, 'lps'),
	(471031, 124, '2015-04-01 00:40:53.000000', 'consum', 0.0210, 'lps'),
	(471032, 124, '2015-04-01 00:40:54.000000', 'consum', 0.0218, 'lps'),
	(471033, 124, '2015-04-01 00:40:55.000000', 'consum', 0.0224, 'lps'),
	(471034, 124, '2015-04-01 00:40:56.000000', 'consum', 0.0230, 'lps'),
	(471035, 124, '2015-04-01 00:40:57.000000', 'consum', 0.0218, 'lps'),
	(471036, 124, '2015-04-01 00:40:58.000000', 'consum', 0.0217, 'lps'),
	(471037, 124, '2015-04-01 00:40:59.000000', 'consum', 0.0219, 'lps'),
	(471038, 124, '2015-04-01 00:41:00.000000', 'consum', 0.0235, 'lps'),
	(471039, 124, '2015-04-01 00:41:01.000000', 'consum', 0.0232, 'lps'),
	(471040, 124, '2015-04-01 00:41:02.000000', 'consum', 0.0217, 'lps'),
	(471041, 124, '2015-04-01 00:41:03.000000', 'consum', 0.0233, 'lps'),
	(471042, 124, '2015-04-01 00:41:04.000000', 'consum', 0.0226, 'lps'),
	(471043, 124, '2015-04-01 00:41:05.000000', 'consum', 0.0223, 'lps'),
	(471044, 124, '2015-04-01 00:41:06.000000', 'consum', 0.0227, 'lps'),
	(471045, 124, '2015-04-01 00:41:07.000000', 'consum', 0.0231, 'lps'),
	(471046, 124, '2015-04-01 00:41:08.000000', 'consum', 0.0212, 'lps'),
	(471047, 124, '2015-04-01 00:41:09.000000', 'consum', 0.0235, 'lps'),
	(471048, 124, '2015-04-01 00:41:10.000000', 'consum', 0.0224, 'lps'),
	(471049, 124, '2015-04-01 00:41:11.000000', 'consum', 0.0233, 'lps'),
	(471050, 124, '2015-04-01 00:41:12.000000', 'consum', 0.0230, 'lps'),
	(471051, 124, '2015-04-01 00:41:13.000000', 'consum', 0.0215, 'lps'),
	(471052, 124, '2015-04-01 00:41:14.000000', 'consum', 0.0228, 'lps'),
	(471053, 124, '2015-04-01 00:41:15.000000', 'consum', 0.0235, 'lps'),
	(471054, 124, '2015-04-01 00:41:16.000000', 'consum', 0.0227, 'lps'),
	(471055, 124, '2015-04-01 00:41:17.000000', 'consum', 0.0220, 'lps'),
	(471056, 124, '2015-04-01 00:41:18.000000', 'consum', 0.0212, 'lps'),
	(471057, 124, '2015-04-01 00:41:19.000000', 'consum', 0.0215, 'lps'),
	(471058, 124, '2015-04-01 00:41:20.000000', 'consum', 0.0231, 'lps'),
	(471059, 124, '2015-04-01 00:41:21.000000', 'consum', 0.0221, 'lps'),
	(471060, 124, '2015-04-01 00:41:22.000000', 'consum', 0.0231, 'lps'),
	(471061, 124, '2015-04-01 00:41:23.000000', 'consum', 0.0229, 'lps'),
	(471062, 124, '2015-04-01 00:41:24.000000', 'consum', 0.0217, 'lps'),
	(471063, 124, '2015-04-01 00:41:25.000000', 'consum', 0.0213, 'lps'),
	(471064, 124, '2015-04-01 00:41:26.000000', 'consum', 0.0230, 'lps'),
	(471065, 124, '2015-04-01 00:41:27.000000', 'consum', 0.0225, 'lps'),
	(471066, 124, '2015-04-01 00:41:28.000000', 'consum', 0.0224, 'lps'),
	(471067, 124, '2015-04-01 00:41:29.000000', 'consum', 0.0211, 'lps'),
	(471068, 124, '2015-04-01 00:41:30.000000', 'consum', 0.0226, 'lps'),
	(471069, 124, '2015-04-01 00:41:31.000000', 'consum', 0.0234, 'lps'),
	(471070, 124, '2015-04-01 00:41:32.000000', 'consum', 0.0229, 'lps'),
	(471071, 124, '2015-04-01 00:41:33.000000', 'consum', 0.0210, 'lps'),
	(471072, 124, '2015-04-01 00:41:34.000000', 'consum', 0.0231, 'lps'),
	(471073, 124, '2015-04-01 00:41:35.000000', 'consum', 0.0210, 'lps'),
	(471074, 124, '2015-04-01 00:41:36.000000', 'consum', 0.0225, 'lps'),
	(471075, 124, '2015-04-01 00:41:37.000000', 'consum', 0.0210, 'lps'),
	(471076, 124, '2015-04-01 00:41:38.000000', 'consum', 0.0216, 'lps'),
	(471077, 124, '2015-04-01 00:41:39.000000', 'consum', 0.0216, 'lps'),
	(471078, 124, '2015-04-01 00:41:40.000000', 'consum', 0.0221, 'lps'),
	(471079, 124, '2015-04-01 00:41:41.000000', 'consum', 0.0224, 'lps'),
	(471080, 124, '2015-04-01 00:41:42.000000', 'consum', 0.0218, 'lps'),
	(471081, 124, '2015-04-01 00:41:43.000000', 'consum', 0.0212, 'lps'),
	(471082, 124, '2015-04-01 00:41:44.000000', 'consum', 0.0220, 'lps'),
	(471083, 124, '2015-04-01 00:41:45.000000', 'consum', 0.0230, 'lps'),
	(471084, 124, '2015-04-01 00:41:46.000000', 'consum', 0.0229, 'lps'),
	(471085, 124, '2015-04-01 00:41:47.000000', 'consum', 0.0220, 'lps'),
	(471086, 124, '2015-04-01 00:41:48.000000', 'consum', 0.0228, 'lps'),
	(471087, 124, '2015-04-01 00:41:49.000000', 'consum', 0.0220, 'lps'),
	(471088, 124, '2015-04-01 00:41:50.000000', 'consum', 0.0231, 'lps'),
	(471089, 124, '2015-04-01 00:41:51.000000', 'consum', 0.0210, 'lps'),
	(471090, 124, '2015-04-01 00:41:52.000000', 'consum', 0.0225, 'lps'),
	(471091, 124, '2015-04-01 00:41:53.000000', 'consum', 0.0232, 'lps'),
	(471092, 124, '2015-04-01 00:41:54.000000', 'consum', 0.0223, 'lps'),
	(471093, 124, '2015-04-01 00:41:55.000000', 'consum', 0.0211, 'lps'),
	(471094, 124, '2015-04-01 00:41:56.000000', 'consum', 0.0228, 'lps'),
	(471095, 124, '2015-04-01 00:41:57.000000', 'consum', 0.0219, 'lps'),
	(471096, 124, '2015-04-01 00:41:58.000000', 'consum', 0.0229, 'lps'),
	(471097, 124, '2015-04-01 00:41:59.000000', 'consum', 0.0227, 'lps'),
	(471098, 124, '2015-04-01 00:42:00.000000', 'consum', 0.0211, 'lps'),
	(471099, 124, '2015-04-01 00:42:01.000000', 'consum', 0.0216, 'lps'),
	(471100, 124, '2015-04-01 00:42:02.000000', 'consum', 0.0212, 'lps'),
	(471101, 124, '2015-04-01 00:42:03.000000', 'consum', 0.0230, 'lps'),
	(471102, 124, '2015-04-01 00:42:04.000000', 'consum', 0.0227, 'lps'),
	(471103, 124, '2015-04-01 00:42:05.000000', 'consum', 0.0210, 'lps'),
	(471104, 124, '2015-04-01 00:42:06.000000', 'consum', 0.0234, 'lps'),
	(471105, 124, '2015-04-01 00:42:07.000000', 'consum', 0.0229, 'lps'),
	(471106, 124, '2015-04-01 00:42:08.000000', 'consum', 0.0235, 'lps'),
	(471107, 124, '2015-04-01 00:42:09.000000', 'consum', 0.0224, 'lps'),
	(471108, 124, '2015-04-01 00:42:10.000000', 'consum', 0.0234, 'lps'),
	(471109, 124, '2015-04-01 00:42:11.000000', 'consum', 0.0235, 'lps'),
	(471110, 124, '2015-04-01 00:42:12.000000', 'consum', 0.0213, 'lps'),
	(471111, 124, '2015-04-01 00:42:13.000000', 'consum', 0.0228, 'lps'),
	(471112, 124, '2015-04-01 00:42:14.000000', 'consum', 0.0212, 'lps'),
	(471113, 124, '2015-04-01 00:42:15.000000', 'consum', 0.0219, 'lps'),
	(471114, 124, '2015-04-01 00:42:16.000000', 'consum', 0.0224, 'lps'),
	(471115, 124, '2015-04-01 00:42:17.000000', 'consum', 0.0228, 'lps'),
	(471116, 124, '2015-04-01 00:42:18.000000', 'consum', 0.0233, 'lps'),
	(471117, 124, '2015-04-01 00:42:19.000000', 'consum', 0.0221, 'lps'),
	(471118, 124, '2015-04-01 00:42:20.000000', 'consum', 0.0220, 'lps'),
	(471119, 124, '2015-04-01 00:42:21.000000', 'consum', 0.0228, 'lps'),
	(471120, 124, '2015-04-01 00:42:22.000000', 'consum', 0.0220, 'lps'),
	(471121, 124, '2015-04-01 00:42:23.000000', 'consum', 0.0231, 'lps'),
	(471122, 124, '2015-04-01 00:42:24.000000', 'consum', 0.0210, 'lps'),
	(471123, 124, '2015-04-01 00:42:25.000000', 'consum', 0.0224, 'lps'),
	(471124, 124, '2015-04-01 00:42:26.000000', 'consum', 0.0229, 'lps'),
	(471125, 124, '2015-04-01 00:42:27.000000', 'consum', 0.0210, 'lps'),
	(471126, 124, '2015-04-01 00:42:28.000000', 'consum', 0.0231, 'lps'),
	(471127, 124, '2015-04-01 00:42:29.000000', 'consum', 0.0213, 'lps'),
	(471128, 124, '2015-04-01 00:42:30.000000', 'consum', 0.0213, 'lps'),
	(471129, 124, '2015-04-01 00:42:31.000000', 'consum', 0.0218, 'lps'),
	(471130, 124, '2015-04-01 00:42:32.000000', 'consum', 0.0217, 'lps'),
	(471131, 124, '2015-04-01 00:42:33.000000', 'consum', 0.0220, 'lps'),
	(471132, 124, '2015-04-01 00:42:34.000000', 'consum', 0.0212, 'lps'),
	(471133, 124, '2015-04-01 00:42:35.000000', 'consum', 0.0217, 'lps'),
	(471134, 124, '2015-04-01 00:42:36.000000', 'consum', 0.0213, 'lps'),
	(471135, 124, '2015-04-01 00:42:37.000000', 'consum', 0.0229, 'lps'),
	(471136, 124, '2015-04-01 00:42:38.000000', 'consum', 0.0220, 'lps'),
	(471137, 124, '2015-04-01 00:42:39.000000', 'consum', 0.0230, 'lps'),
	(471138, 124, '2015-04-01 00:42:40.000000', 'consum', 0.0228, 'lps'),
	(471139, 124, '2015-04-01 00:42:41.000000', 'consum', 0.0213, 'lps'),
	(471140, 124, '2015-04-01 00:42:42.000000', 'consum', 0.0225, 'lps'),
	(471141, 124, '2015-04-01 00:42:43.000000', 'consum', 0.0225, 'lps'),
	(471142, 124, '2015-04-01 00:42:44.000000', 'consum', 0.0213, 'lps'),
	(471143, 124, '2015-04-01 00:42:45.000000', 'consum', 0.0232, 'lps'),
	(471144, 124, '2015-04-01 00:42:46.000000', 'consum', 0.0232, 'lps'),
	(471145, 124, '2015-04-01 00:42:47.000000', 'consum', 0.0231, 'lps'),
	(471146, 124, '2015-04-01 00:42:48.000000', 'consum', 0.0225, 'lps'),
	(471147, 124, '2015-04-01 00:42:49.000000', 'consum', 0.0220, 'lps'),
	(471148, 124, '2015-04-01 00:42:50.000000', 'consum', 0.0216, 'lps'),
	(471149, 124, '2015-04-01 00:42:51.000000', 'consum', 0.0213, 'lps'),
	(471150, 124, '2015-04-01 00:42:52.000000', 'consum', 0.0230, 'lps'),
	(471151, 124, '2015-04-01 00:42:53.000000', 'consum', 0.0225, 'lps'),
	(471152, 124, '2015-04-01 00:42:54.000000', 'consum', 0.0225, 'lps'),
	(471153, 124, '2015-04-01 00:42:55.000000', 'consum', 0.0216, 'lps'),
	(471154, 124, '2015-04-01 00:42:56.000000', 'consum', 0.0222, 'lps'),
	(471155, 124, '2015-04-01 00:42:57.000000', 'consum', 0.0226, 'lps'),
	(471156, 124, '2015-04-01 00:42:58.000000', 'consum', 0.0228, 'lps'),
	(471157, 124, '2015-04-01 00:42:59.000000', 'consum', 0.0225, 'lps'),
	(471158, 124, '2015-04-01 00:43:00.000000', 'consum', 0.0231, 'lps'),
	(471159, 124, '2015-04-01 00:43:01.000000', 'consum', 0.0219, 'lps'),
	(471160, 124, '2015-04-01 00:43:02.000000', 'consum', 0.0220, 'lps'),
	(471161, 124, '2015-04-01 00:43:03.000000', 'consum', 0.0234, 'lps'),
	(471162, 124, '2015-04-01 00:43:04.000000', 'consum', 0.0222, 'lps'),
	(471163, 124, '2015-04-01 00:43:05.000000', 'consum', 0.0224, 'lps'),
	(471164, 124, '2015-04-01 00:43:06.000000', 'consum', 0.0217, 'lps'),
	(471165, 124, '2015-04-01 00:43:07.000000', 'consum', 0.0229, 'lps'),
	(471166, 124, '2015-04-01 00:43:08.000000', 'consum', 0.0234, 'lps'),
	(471167, 124, '2015-04-01 00:43:09.000000', 'consum', 0.0219, 'lps'),
	(471168, 124, '2015-04-01 00:43:10.000000', 'consum', 0.0213, 'lps'),
	(471169, 124, '2015-04-01 00:43:11.000000', 'consum', 0.0222, 'lps'),
	(471170, 124, '2015-04-01 00:43:12.000000', 'consum', 0.0211, 'lps'),
	(471171, 124, '2015-04-01 00:43:13.000000', 'consum', 0.0230, 'lps'),
	(471172, 124, '2015-04-01 00:43:14.000000', 'consum', 0.0231, 'lps'),
	(471173, 124, '2015-04-01 00:43:15.000000', 'consum', 0.0230, 'lps'),
	(471174, 124, '2015-04-01 00:43:16.000000', 'consum', 0.0222, 'lps'),
	(471175, 124, '2015-04-01 00:43:17.000000', 'consum', 0.0210, 'lps'),
	(471176, 124, '2015-04-01 00:43:18.000000', 'consum', 0.0225, 'lps'),
	(471177, 124, '2015-04-01 00:43:19.000000', 'consum', 0.0210, 'lps'),
	(471178, 124, '2015-04-01 00:43:20.000000', 'consum', 0.0216, 'lps'),
	(471179, 124, '2015-04-01 00:43:21.000000', 'consum', 0.0214, 'lps'),
	(471180, 124, '2015-04-01 00:43:22.000000', 'consum', 0.0214, 'lps'),
	(471181, 124, '2015-04-01 00:43:23.000000', 'consum', 0.0218, 'lps'),
	(471182, 124, '2015-04-01 00:43:24.000000', 'consum', 0.0212, 'lps'),
	(471183, 124, '2015-04-01 00:43:25.000000', 'consum', 0.0222, 'lps'),
	(471184, 124, '2015-04-01 00:43:26.000000', 'consum', 0.0212, 'lps'),
	(471185, 124, '2015-04-01 00:43:27.000000', 'consum', 0.0211, 'lps'),
	(471186, 124, '2015-04-01 00:43:28.000000', 'consum', 0.0234, 'lps'),
	(471187, 124, '2015-04-01 00:43:29.000000', 'consum', 0.0224, 'lps'),
	(471188, 124, '2015-04-01 00:43:30.000000', 'consum', 0.0234, 'lps'),
	(471189, 124, '2015-04-01 00:43:31.000000', 'consum', 0.0211, 'lps'),
	(471190, 124, '2015-04-01 00:43:32.000000', 'consum', 0.0222, 'lps'),
	(471191, 124, '2015-04-01 00:43:33.000000', 'consum', 0.0214, 'lps'),
	(471192, 124, '2015-04-01 00:43:34.000000', 'consum', 0.0220, 'lps'),
	(471193, 124, '2015-04-01 00:43:35.000000', 'consum', 0.0222, 'lps'),
	(471194, 124, '2015-04-01 00:43:36.000000', 'consum', 0.0217, 'lps'),
	(471195, 124, '2015-04-01 00:43:37.000000', 'consum', 0.0234, 'lps'),
	(471196, 124, '2015-04-01 00:43:38.000000', 'consum', 0.0232, 'lps'),
	(471197, 124, '2015-04-01 00:43:39.000000', 'consum', 0.0223, 'lps'),
	(471198, 124, '2015-04-01 00:43:40.000000', 'consum', 0.0234, 'lps'),
	(471199, 124, '2015-04-01 00:43:41.000000', 'consum', 0.0215, 'lps'),
	(471200, 124, '2015-04-01 00:43:42.000000', 'consum', 0.0214, 'lps'),
	(471201, 124, '2015-04-01 00:43:43.000000', 'consum', 0.0217, 'lps'),
	(471202, 124, '2015-04-01 00:43:44.000000', 'consum', 0.0233, 'lps'),
	(471203, 124, '2015-04-01 00:43:45.000000', 'consum', 0.0224, 'lps'),
	(471204, 124, '2015-04-01 00:43:46.000000', 'consum', 0.0215, 'lps'),
	(471205, 124, '2015-04-01 00:43:47.000000', 'consum', 0.0219, 'lps'),
	(471206, 124, '2015-04-01 00:43:48.000000', 'consum', 0.0214, 'lps'),
	(471207, 124, '2015-04-01 00:43:49.000000', 'consum', 0.0231, 'lps'),
	(471208, 124, '2015-04-01 00:43:50.000000', 'consum', 0.0225, 'lps'),
	(471209, 124, '2015-04-01 00:43:51.000000', 'consum', 0.0223, 'lps'),
	(471210, 124, '2015-04-01 00:43:52.000000', 'consum', 0.0231, 'lps'),
	(471211, 124, '2015-04-01 00:43:53.000000', 'consum', 0.0224, 'lps'),
	(471212, 124, '2015-04-01 00:43:54.000000', 'consum', 0.0216, 'lps'),
	(471213, 124, '2015-04-01 00:43:55.000000', 'consum', 0.0227, 'lps'),
	(471214, 124, '2015-04-01 00:43:56.000000', 'consum', 0.0224, 'lps'),
	(471215, 124, '2015-04-01 00:43:57.000000', 'consum', 0.0232, 'lps'),
	(471216, 124, '2015-04-01 00:43:58.000000', 'consum', 0.0223, 'lps'),
	(471217, 124, '2015-04-01 00:43:59.000000', 'consum', 0.0211, 'lps'),
	(471218, 124, '2015-04-01 00:44:00.000000', 'consum', 0.0227, 'lps'),
	(471219, 124, '2015-04-01 00:44:01.000000', 'consum', 0.0216, 'lps'),
	(471220, 124, '2015-04-01 00:44:02.000000', 'consum', 0.0217, 'lps'),
	(471221, 124, '2015-04-01 00:44:03.000000', 'consum', 0.0226, 'lps'),
	(471222, 124, '2015-04-01 00:44:04.000000', 'consum', 0.0218, 'lps'),
	(471223, 124, '2015-04-01 00:44:05.000000', 'consum', 0.0227, 'lps'),
	(471224, 124, '2015-04-01 00:44:06.000000', 'consum', 0.0220, 'lps'),
	(471225, 124, '2015-04-01 00:44:07.000000', 'consum', 0.0210, 'lps'),
	(471226, 124, '2015-04-01 00:44:08.000000', 'consum', 0.0233, 'lps'),
	(471227, 124, '2015-04-01 00:44:09.000000', 'consum', 0.0221, 'lps'),
	(471228, 124, '2015-04-01 00:44:10.000000', 'consum', 0.0222, 'lps'),
	(471229, 124, '2015-04-01 00:44:11.000000', 'consum', 0.0210, 'lps'),
	(471230, 124, '2015-04-01 00:44:12.000000', 'consum', 0.0230, 'lps'),
	(471231, 124, '2015-04-01 00:44:13.000000', 'consum', 0.0229, 'lps'),
	(471232, 124, '2015-04-01 00:44:14.000000', 'consum', 0.0221, 'lps'),
	(471233, 124, '2015-04-01 00:44:15.000000', 'consum', 0.0234, 'lps'),
	(471234, 124, '2015-04-01 00:44:16.000000', 'consum', 0.0220, 'lps'),
	(471235, 124, '2015-04-01 00:44:17.000000', 'consum', 0.0214, 'lps'),
	(471236, 124, '2015-04-01 00:44:18.000000', 'consum', 0.0225, 'lps'),
	(471237, 124, '2015-04-01 00:44:19.000000', 'consum', 0.0222, 'lps'),
	(471238, 124, '2015-04-01 00:44:20.000000', 'consum', 0.0227, 'lps'),
	(471239, 124, '2015-04-01 00:44:21.000000', 'consum', 0.0231, 'lps'),
	(471240, 124, '2015-04-01 00:44:22.000000', 'consum', 0.0214, 'lps'),
	(471241, 124, '2015-04-01 00:44:23.000000', 'consum', 0.0219, 'lps'),
	(471242, 124, '2015-04-01 00:44:24.000000', 'consum', 0.0217, 'lps'),
	(471243, 124, '2015-04-01 00:44:25.000000', 'consum', 0.0219, 'lps'),
	(471244, 124, '2015-04-01 00:44:26.000000', 'consum', 0.0233, 'lps'),
	(471245, 124, '2015-04-01 00:44:27.000000', 'consum', 0.0220, 'lps'),
	(471246, 124, '2015-04-01 00:44:28.000000', 'consum', 0.0218, 'lps'),
	(471247, 124, '2015-04-01 00:44:29.000000', 'consum', 0.0222, 'lps'),
	(471248, 124, '2015-04-01 00:44:30.000000', 'consum', 0.0219, 'lps'),
	(471249, 124, '2015-04-01 00:44:31.000000', 'consum', 0.0220, 'lps'),
	(471250, 124, '2015-04-01 00:44:32.000000', 'consum', 0.0235, 'lps'),
	(471251, 124, '2015-04-01 00:44:33.000000', 'consum', 0.0224, 'lps'),
	(471252, 124, '2015-04-01 00:44:34.000000', 'consum', 0.0235, 'lps'),
	(471253, 124, '2015-04-01 00:44:35.000000', 'consum', 0.0213, 'lps'),
	(471254, 124, '2015-04-01 00:44:36.000000', 'consum', 0.0228, 'lps'),
	(471255, 124, '2015-04-01 00:44:37.000000', 'consum', 0.0216, 'lps'),
	(471256, 124, '2015-04-01 00:44:38.000000', 'consum', 0.0213, 'lps'),
	(471257, 124, '2015-04-01 00:44:39.000000', 'consum', 0.0233, 'lps'),
	(471258, 124, '2015-04-01 00:44:40.000000', 'consum', 0.0212, 'lps'),
	(471259, 124, '2015-04-01 00:44:41.000000', 'consum', 0.0227, 'lps'),
	(471260, 124, '2015-04-01 00:44:42.000000', 'consum', 0.0215, 'lps'),
	(471261, 124, '2015-04-01 00:44:43.000000', 'consum', 0.0211, 'lps'),
	(471262, 124, '2015-04-01 00:44:44.000000', 'consum', 0.0225, 'lps'),
	(471263, 124, '2015-04-01 00:44:45.000000', 'consum', 0.0230, 'lps'),
	(471264, 124, '2015-04-01 00:44:46.000000', 'consum', 0.0213, 'lps'),
	(471265, 124, '2015-04-01 00:44:47.000000', 'consum', 0.0217, 'lps'),
	(471266, 124, '2015-04-01 00:44:48.000000', 'consum', 0.0212, 'lps'),
	(471267, 124, '2015-04-01 00:44:49.000000', 'consum', 0.0224, 'lps'),
	(471268, 124, '2015-04-01 00:44:50.000000', 'consum', 0.0223, 'lps'),
	(471269, 124, '2015-04-01 00:44:51.000000', 'consum', 0.0210, 'lps'),
	(471270, 124, '2015-04-01 00:44:52.000000', 'consum', 0.0221, 'lps'),
	(471271, 124, '2015-04-01 00:44:53.000000', 'consum', 0.0213, 'lps'),
	(471272, 124, '2015-04-01 00:44:54.000000', 'consum', 0.0220, 'lps'),
	(471273, 124, '2015-04-01 00:44:55.000000', 'consum', 0.0223, 'lps'),
	(471274, 124, '2015-04-01 00:44:56.000000', 'consum', 0.0221, 'lps'),
	(471275, 124, '2015-04-01 00:44:57.000000', 'consum', 0.0226, 'lps'),
	(471276, 124, '2015-04-01 00:44:58.000000', 'consum', 0.0232, 'lps'),
	(471277, 124, '2015-04-01 00:44:59.000000', 'consum', 0.0221, 'lps'),
	(471278, 124, '2015-04-01 00:45:00.000000', 'consum', 0.0225, 'lps'),
	(471279, 124, '2015-04-01 00:45:01.000000', 'consum', 0.0226, 'lps'),
	(471280, 124, '2015-04-01 00:45:02.000000', 'consum', 0.0219, 'lps'),
	(471281, 124, '2015-04-01 00:45:03.000000', 'consum', 0.0235, 'lps'),
	(471282, 124, '2015-04-01 00:45:04.000000', 'consum', 0.0230, 'lps'),
	(471283, 124, '2015-04-01 00:45:05.000000', 'consum', 0.0211, 'lps'),
	(471284, 124, '2015-04-01 00:45:06.000000', 'consum', 0.0232, 'lps'),
	(471285, 124, '2015-04-01 00:45:07.000000', 'consum', 0.0216, 'lps'),
	(471286, 124, '2015-04-01 00:45:08.000000', 'consum', 0.0224, 'lps'),
	(471287, 124, '2015-04-01 00:45:09.000000', 'consum', 0.0211, 'lps'),
	(471288, 124, '2015-04-01 00:45:10.000000', 'consum', 0.0224, 'lps'),
	(471289, 124, '2015-04-01 00:45:11.000000', 'consum', 0.0226, 'lps'),
	(471290, 124, '2015-04-01 00:45:12.000000', 'consum', 0.0225, 'lps'),
	(471291, 124, '2015-04-01 00:45:13.000000', 'consum', 0.0235, 'lps'),
	(471292, 124, '2015-04-01 00:45:14.000000', 'consum', 0.0211, 'lps'),
	(471293, 124, '2015-04-01 00:45:15.000000', 'consum', 0.0221, 'lps'),
	(471294, 124, '2015-04-01 00:45:16.000000', 'consum', 0.0235, 'lps'),
	(471295, 124, '2015-04-01 00:45:17.000000', 'consum', 0.0226, 'lps'),
	(471296, 124, '2015-04-01 00:45:18.000000', 'consum', 0.0214, 'lps'),
	(471297, 124, '2015-04-01 00:45:19.000000', 'consum', 0.0233, 'lps'),
	(471298, 124, '2015-04-01 00:45:20.000000', 'consum', 0.0212, 'lps'),
	(471299, 124, '2015-04-01 00:45:21.000000', 'consum', 0.0229, 'lps'),
	(471300, 124, '2015-04-01 00:45:22.000000', 'consum', 0.0222, 'lps'),
	(471301, 124, '2015-04-01 00:45:23.000000', 'consum', 0.0214, 'lps'),
	(471302, 124, '2015-04-01 00:45:24.000000', 'consum', 0.0220, 'lps'),
	(471303, 124, '2015-04-01 00:45:25.000000', 'consum', 0.0222, 'lps'),
	(471304, 124, '2015-04-01 00:45:26.000000', 'consum', 0.0215, 'lps'),
	(471305, 124, '2015-04-01 00:45:27.000000', 'consum', 0.0225, 'lps'),
	(471306, 124, '2015-04-01 00:45:28.000000', 'consum', 0.0217, 'lps'),
	(471307, 124, '2015-04-01 00:45:29.000000', 'consum', 0.0226, 'lps'),
	(471308, 124, '2015-04-01 00:45:30.000000', 'consum', 0.0220, 'lps'),
	(471309, 124, '2015-04-01 00:45:31.000000', 'consum', 0.0213, 'lps'),
	(471310, 124, '2015-04-01 00:45:32.000000', 'consum', 0.0220, 'lps'),
	(471311, 124, '2015-04-01 00:45:33.000000', 'consum', 0.0224, 'lps'),
	(471312, 124, '2015-04-01 00:45:34.000000', 'consum', 0.0226, 'lps'),
	(471313, 124, '2015-04-01 00:45:35.000000', 'consum', 0.0222, 'lps'),
	(471314, 124, '2015-04-01 00:45:36.000000', 'consum', 0.0222, 'lps'),
	(471315, 124, '2015-04-01 00:45:37.000000', 'consum', 0.0211, 'lps'),
	(471316, 124, '2015-04-01 00:45:38.000000', 'consum', 0.0229, 'lps'),
	(471317, 124, '2015-04-01 00:45:39.000000', 'consum', 0.0223, 'lps'),
	(471318, 124, '2015-04-01 00:45:40.000000', 'consum', 0.0221, 'lps'),
	(471319, 124, '2015-04-01 00:45:41.000000', 'consum', 0.0227, 'lps'),
	(471320, 124, '2015-04-01 00:45:42.000000', 'consum', 0.0235, 'lps'),
	(471321, 124, '2015-04-01 00:45:43.000000', 'consum', 0.0233, 'lps'),
	(471322, 124, '2015-04-01 00:45:44.000000', 'consum', 0.0223, 'lps'),
	(471323, 124, '2015-04-01 00:45:45.000000', 'consum', 0.0232, 'lps'),
	(471324, 124, '2015-04-01 00:45:46.000000', 'consum', 0.0231, 'lps'),
	(471325, 124, '2015-04-01 00:45:47.000000', 'consum', 0.0222, 'lps'),
	(471326, 124, '2015-04-01 00:45:48.000000', 'consum', 0.0232, 'lps'),
	(471327, 124, '2015-04-01 00:45:49.000000', 'consum', 0.0235, 'lps'),
	(471328, 124, '2015-04-01 00:45:50.000000', 'consum', 0.0218, 'lps'),
	(471329, 124, '2015-04-01 00:45:51.000000', 'consum', 0.0227, 'lps'),
	(471330, 124, '2015-04-01 00:45:52.000000', 'consum', 0.0221, 'lps'),
	(471331, 124, '2015-04-01 00:45:53.000000', 'consum', 0.0212, 'lps'),
	(471332, 124, '2015-04-01 00:45:54.000000', 'consum', 0.0215, 'lps'),
	(471333, 124, '2015-04-01 00:45:55.000000', 'consum', 0.0230, 'lps'),
	(471334, 124, '2015-04-01 00:45:56.000000', 'consum', 0.0215, 'lps'),
	(471335, 124, '2015-04-01 00:45:57.000000', 'consum', 0.0230, 'lps'),
	(471336, 124, '2015-04-01 00:45:58.000000', 'consum', 0.0215, 'lps'),
	(471337, 124, '2015-04-01 00:45:59.000000', 'consum', 0.0230, 'lps'),
	(471338, 124, '2015-04-01 00:46:00.000000', 'consum', 0.0216, 'lps'),
	(471339, 124, '2015-04-01 00:46:01.000000', 'consum', 0.0231, 'lps'),
	(471340, 124, '2015-04-01 00:46:02.000000', 'consum', 0.0220, 'lps'),
	(471341, 124, '2015-04-01 00:46:03.000000', 'consum', 0.0226, 'lps'),
	(471342, 124, '2015-04-01 00:46:04.000000', 'consum', 0.0233, 'lps'),
	(471343, 124, '2015-04-01 00:46:05.000000', 'consum', 0.0225, 'lps'),
	(471344, 124, '2015-04-01 00:46:06.000000', 'consum', 0.0217, 'lps'),
	(471345, 124, '2015-04-01 00:46:07.000000', 'consum', 0.0225, 'lps'),
	(471346, 124, '2015-04-01 00:46:08.000000', 'consum', 0.0213, 'lps'),
	(471347, 124, '2015-04-01 00:46:09.000000', 'consum', 0.0232, 'lps'),
	(471348, 124, '2015-04-01 00:46:10.000000', 'consum', 0.0235, 'lps'),
	(471349, 124, '2015-04-01 00:46:11.000000', 'consum', 0.0217, 'lps'),
	(471350, 124, '2015-04-01 00:46:12.000000', 'consum', 0.0224, 'lps'),
	(471351, 124, '2015-04-01 00:46:13.000000', 'consum', 0.0234, 'lps'),
	(471352, 124, '2015-04-01 00:46:14.000000', 'consum', 0.0210, 'lps'),
	(471353, 124, '2015-04-01 00:46:15.000000', 'consum', 0.0217, 'lps'),
	(471354, 124, '2015-04-01 00:46:16.000000', 'consum', 0.0217, 'lps'),
	(471355, 124, '2015-04-01 00:46:17.000000', 'consum', 0.0225, 'lps'),
	(471356, 124, '2015-04-01 00:46:18.000000', 'consum', 0.0213, 'lps'),
	(471357, 124, '2015-04-01 00:46:19.000000', 'consum', 0.0231, 'lps'),
	(471358, 124, '2015-04-01 00:46:20.000000', 'consum', 0.0228, 'lps'),
	(471359, 124, '2015-04-01 00:46:21.000000', 'consum', 0.0211, 'lps'),
	(471360, 124, '2015-04-01 00:46:22.000000', 'consum', 0.0214, 'lps'),
	(471361, 124, '2015-04-01 00:46:23.000000', 'consum', 0.0230, 'lps'),
	(471362, 124, '2015-04-01 00:46:24.000000', 'consum', 0.0217, 'lps'),
	(471363, 124, '2015-04-01 00:46:25.000000', 'consum', 0.0214, 'lps'),
	(471364, 124, '2015-04-01 00:46:26.000000', 'consum', 0.0233, 'lps'),
	(471365, 124, '2015-04-01 00:46:27.000000', 'consum', 0.0210, 'lps'),
	(471366, 124, '2015-04-01 00:46:28.000000', 'consum', 0.0219, 'lps'),
	(471367, 124, '2015-04-01 00:46:29.000000', 'consum', 0.0230, 'lps'),
	(471368, 124, '2015-04-01 00:46:30.000000', 'consum', 0.0233, 'lps'),
	(471369, 124, '2015-04-01 00:46:31.000000', 'consum', 0.0212, 'lps'),
	(471370, 124, '2015-04-01 00:46:32.000000', 'consum', 0.0232, 'lps'),
	(471371, 124, '2015-04-01 00:46:33.000000', 'consum', 0.0234, 'lps'),
	(471372, 124, '2015-04-01 00:46:34.000000', 'consum', 0.0215, 'lps'),
	(471373, 124, '2015-04-01 00:46:35.000000', 'consum', 0.0215, 'lps'),
	(471374, 124, '2015-04-01 00:46:36.000000', 'consum', 0.0222, 'lps'),
	(471375, 124, '2015-04-01 00:46:37.000000', 'consum', 0.0228, 'lps'),
	(471376, 124, '2015-04-01 00:46:38.000000', 'consum', 0.0211, 'lps'),
	(471377, 124, '2015-04-01 00:46:39.000000', 'consum', 0.0214, 'lps'),
	(471378, 124, '2015-04-01 00:46:40.000000', 'consum', 0.0228, 'lps'),
	(471379, 124, '2015-04-01 00:46:41.000000', 'consum', 0.0211, 'lps'),
	(471380, 124, '2015-04-01 00:46:42.000000', 'consum', 0.0213, 'lps'),
	(471381, 124, '2015-04-01 00:46:43.000000', 'consum', 0.0221, 'lps'),
	(471382, 124, '2015-04-01 00:46:44.000000', 'consum', 0.0232, 'lps'),
	(471383, 124, '2015-04-01 00:46:45.000000', 'consum', 0.0211, 'lps'),
	(471384, 124, '2015-04-01 00:46:46.000000', 'consum', 0.0227, 'lps'),
	(471385, 124, '2015-04-01 00:46:47.000000', 'consum', 0.0214, 'lps'),
	(471386, 124, '2015-04-01 00:46:48.000000', 'consum', 0.0233, 'lps'),
	(471387, 124, '2015-04-01 00:46:49.000000', 'consum', 0.0210, 'lps'),
	(471388, 124, '2015-04-01 00:46:50.000000', 'consum', 0.0220, 'lps'),
	(471389, 124, '2015-04-01 00:46:51.000000', 'consum', 0.0234, 'lps'),
	(471390, 124, '2015-04-01 00:46:52.000000', 'consum', 0.0220, 'lps'),
	(471391, 124, '2015-04-01 00:46:53.000000', 'consum', 0.0218, 'lps'),
	(471392, 124, '2015-04-01 00:46:54.000000', 'consum', 0.0219, 'lps'),
	(471393, 124, '2015-04-01 00:46:55.000000', 'consum', 0.0232, 'lps'),
	(471394, 124, '2015-04-01 00:46:56.000000', 'consum', 0.0214, 'lps'),
	(471395, 124, '2015-04-01 00:46:57.000000', 'consum', 0.0217, 'lps'),
	(471396, 124, '2015-04-01 00:46:58.000000', 'consum', 0.0232, 'lps'),
	(471397, 124, '2015-04-01 00:46:59.000000', 'consum', 0.0222, 'lps'),
	(471398, 124, '2015-04-01 00:47:00.000000', 'consum', 0.0233, 'lps'),
	(471399, 124, '2015-04-01 00:47:01.000000', 'consum', 0.0210, 'lps'),
	(471400, 124, '2015-04-01 00:47:02.000000', 'consum', 0.0220, 'lps'),
	(471401, 124, '2015-04-01 00:47:03.000000', 'consum', 0.0234, 'lps'),
	(471402, 124, '2015-04-01 00:47:04.000000', 'consum', 0.0221, 'lps'),
	(471403, 124, '2015-04-01 00:47:05.000000', 'consum', 0.0223, 'lps'),
	(471404, 124, '2015-04-01 00:47:06.000000', 'consum', 0.0213, 'lps'),
	(471405, 124, '2015-04-01 00:47:07.000000', 'consum', 0.0215, 'lps'),
	(471406, 124, '2015-04-01 00:47:08.000000', 'consum', 0.0225, 'lps'),
	(471407, 124, '2015-04-01 00:47:09.000000', 'consum', 0.0219, 'lps'),
	(471408, 124, '2015-04-01 00:47:10.000000', 'consum', 0.0211, 'lps'),
	(471409, 124, '2015-04-01 00:47:11.000000', 'consum', 0.0214, 'lps'),
	(471410, 124, '2015-04-01 00:47:12.000000', 'consum', 0.0229, 'lps'),
	(471411, 124, '2015-04-01 00:47:13.000000', 'consum', 0.0216, 'lps'),
	(471412, 124, '2015-04-01 00:47:14.000000', 'consum', 0.0235, 'lps'),
	(471413, 124, '2015-04-01 00:47:15.000000', 'consum', 0.0214, 'lps'),
	(471414, 124, '2015-04-01 00:47:16.000000', 'consum', 0.0232, 'lps'),
	(471415, 124, '2015-04-01 00:47:17.000000', 'consum', 0.0231, 'lps'),
	(471416, 124, '2015-04-01 00:47:18.000000', 'consum', 0.0224, 'lps'),
	(471417, 124, '2015-04-01 00:47:19.000000', 'consum', 0.0219, 'lps'),
	(471418, 124, '2015-04-01 00:47:20.000000', 'consum', 0.0213, 'lps'),
	(471419, 124, '2015-04-01 00:47:21.000000', 'consum', 0.0226, 'lps'),
	(471420, 124, '2015-04-01 00:47:22.000000', 'consum', 0.0228, 'lps'),
	(471421, 124, '2015-04-01 00:47:23.000000', 'consum', 0.0228, 'lps'),
	(471422, 124, '2015-04-01 00:47:24.000000', 'consum', 0.0218, 'lps'),
	(471423, 124, '2015-04-01 00:47:25.000000', 'consum', 0.0225, 'lps'),
	(471424, 124, '2015-04-01 00:47:26.000000', 'consum', 0.0233, 'lps'),
	(471425, 124, '2015-04-01 00:47:27.000000', 'consum', 0.0231, 'lps'),
	(471426, 124, '2015-04-01 00:47:28.000000', 'consum', 0.0218, 'lps'),
	(471427, 124, '2015-04-01 00:47:29.000000', 'consum', 0.0216, 'lps'),
	(471428, 124, '2015-04-01 00:47:30.000000', 'consum', 0.0215, 'lps'),
	(471429, 124, '2015-04-01 00:47:31.000000', 'consum', 0.0216, 'lps'),
	(471430, 124, '2015-04-01 00:47:32.000000', 'consum', 0.0227, 'lps'),
	(471431, 124, '2015-04-01 00:47:33.000000', 'consum', 0.0224, 'lps'),
	(471432, 124, '2015-04-01 00:47:34.000000', 'consum', 0.0231, 'lps'),
	(471433, 124, '2015-04-01 00:47:35.000000', 'consum', 0.0223, 'lps'),
	(471434, 124, '2015-04-01 00:47:36.000000', 'consum', 0.0210, 'lps'),
	(471435, 124, '2015-04-01 00:47:37.000000', 'consum', 0.0223, 'lps'),
	(471436, 124, '2015-04-01 00:47:38.000000', 'consum', 0.0226, 'lps'),
	(471437, 124, '2015-04-01 00:47:39.000000', 'consum', 0.0224, 'lps'),
	(471438, 124, '2015-04-01 00:47:40.000000', 'consum', 0.0232, 'lps'),
	(471439, 124, '2015-04-01 00:47:41.000000', 'consum', 0.0227, 'lps'),
	(471440, 124, '2015-04-01 00:47:42.000000', 'consum', 0.0231, 'lps'),
	(471441, 124, '2015-04-01 00:47:43.000000', 'consum', 0.0212, 'lps'),
	(471442, 124, '2015-04-01 00:47:44.000000', 'consum', 0.0233, 'lps'),
	(471443, 124, '2015-04-01 00:47:45.000000', 'consum', 0.0217, 'lps'),
	(471444, 124, '2015-04-01 00:47:46.000000', 'consum', 0.0230, 'lps'),
	(471445, 124, '2015-04-01 00:47:47.000000', 'consum', 0.0235, 'lps'),
	(471446, 124, '2015-04-01 00:47:48.000000', 'consum', 0.0223, 'lps'),
	(471447, 124, '2015-04-01 00:47:49.000000', 'consum', 0.0227, 'lps'),
	(471448, 124, '2015-04-01 00:47:50.000000', 'consum', 0.0231, 'lps'),
	(471449, 124, '2015-04-01 00:47:51.000000', 'consum', 0.0214, 'lps'),
	(471450, 124, '2015-04-01 00:47:52.000000', 'consum', 0.0220, 'lps'),
	(471451, 124, '2015-04-01 00:47:53.000000', 'consum', 0.0219, 'lps'),
	(471452, 124, '2015-04-01 00:47:54.000000', 'consum', 0.0229, 'lps'),
	(471453, 124, '2015-04-01 00:47:55.000000', 'consum', 0.0226, 'lps'),
	(471454, 124, '2015-04-01 00:47:56.000000', 'consum', 0.0233, 'lps'),
	(471455, 124, '2015-04-01 00:47:57.000000', 'consum', 0.0227, 'lps'),
	(471456, 124, '2015-04-01 00:47:58.000000', 'consum', 0.0227, 'lps'),
	(471457, 124, '2015-04-01 00:47:59.000000', 'consum', 0.0217, 'lps'),
	(471458, 124, '2015-04-01 00:48:00.000000', 'consum', 0.0221, 'lps'),
	(471459, 124, '2015-04-01 00:48:01.000000', 'consum', 0.0217, 'lps'),
	(471460, 124, '2015-04-01 00:48:02.000000', 'consum', 0.0214, 'lps'),
	(471461, 124, '2015-04-01 00:48:03.000000', 'consum', 0.0234, 'lps'),
	(471462, 124, '2015-04-01 00:48:04.000000', 'consum', 0.0215, 'lps'),
	(471463, 124, '2015-04-01 00:48:05.000000', 'consum', 0.0214, 'lps'),
	(471464, 124, '2015-04-01 00:48:06.000000', 'consum', 0.0217, 'lps'),
	(471465, 124, '2015-04-01 00:48:07.000000', 'consum', 0.0234, 'lps'),
	(471466, 124, '2015-04-01 00:48:08.000000', 'consum', 0.0232, 'lps'),
	(471467, 124, '2015-04-01 00:48:09.000000', 'consum', 0.0224, 'lps'),
	(471468, 124, '2015-04-01 00:48:10.000000', 'consum', 0.0211, 'lps'),
	(471469, 124, '2015-04-01 00:48:11.000000', 'consum', 0.0227, 'lps'),
	(471470, 124, '2015-04-01 00:48:12.000000', 'consum', 0.0213, 'lps'),
	(471471, 124, '2015-04-01 00:48:13.000000', 'consum', 0.0227, 'lps'),
	(471472, 124, '2015-04-01 00:48:14.000000', 'consum', 0.0234, 'lps'),
	(471473, 124, '2015-04-01 00:48:15.000000', 'consum', 0.0228, 'lps'),
	(471474, 124, '2015-04-01 00:48:16.000000', 'consum', 0.0229, 'lps'),
	(471475, 124, '2015-04-01 00:48:17.000000', 'consum', 0.0225, 'lps'),
	(471476, 124, '2015-04-01 00:48:18.000000', 'consum', 0.0227, 'lps'),
	(471477, 124, '2015-04-01 00:48:19.000000', 'consum', 0.0225, 'lps'),
	(471478, 124, '2015-04-01 00:48:20.000000', 'consum', 0.0233, 'lps'),
	(471479, 124, '2015-04-01 00:48:21.000000', 'consum', 0.0230, 'lps'),
	(471480, 124, '2015-04-01 00:48:22.000000', 'consum', 0.0216, 'lps'),
	(471481, 124, '2015-04-01 00:48:23.000000', 'consum', 0.0230, 'lps'),
	(471482, 124, '2015-04-01 00:48:24.000000', 'consum', 0.0217, 'lps'),
	(471483, 124, '2015-04-01 00:48:25.000000', 'consum', 0.0210, 'lps'),
	(471484, 124, '2015-04-01 00:48:26.000000', 'consum', 0.0215, 'lps'),
	(471485, 124, '2015-04-01 00:48:27.000000', 'consum', 0.0211, 'lps'),
	(471486, 124, '2015-04-01 00:48:28.000000', 'consum', 0.0227, 'lps'),
	(471487, 124, '2015-04-01 00:48:29.000000', 'consum', 0.0214, 'lps'),
	(471488, 124, '2015-04-01 00:48:30.000000', 'consum', 0.0230, 'lps'),
	(471489, 124, '2015-04-01 00:48:31.000000', 'consum', 0.0222, 'lps'),
	(471490, 124, '2015-04-01 00:48:32.000000', 'consum', 0.0212, 'lps'),
	(471491, 124, '2015-04-01 00:48:33.000000', 'consum', 0.0234, 'lps'),
	(471492, 124, '2015-04-01 00:48:34.000000', 'consum', 0.0219, 'lps'),
	(471493, 124, '2015-04-01 00:48:35.000000', 'consum', 0.0212, 'lps'),
	(471494, 124, '2015-04-01 00:48:36.000000', 'consum', 0.0219, 'lps'),
	(471495, 124, '2015-04-01 00:48:37.000000', 'consum', 0.0222, 'lps'),
	(471496, 124, '2015-04-01 00:48:38.000000', 'consum', 0.0219, 'lps'),
	(471497, 124, '2015-04-01 00:48:39.000000', 'consum', 0.0220, 'lps'),
	(471498, 124, '2015-04-01 00:48:40.000000', 'consum', 0.0231, 'lps'),
	(471499, 124, '2015-04-01 00:48:41.000000', 'consum', 0.0210, 'lps'),
	(471500, 124, '2015-04-01 00:48:42.000000', 'consum', 0.0224, 'lps'),
	(471501, 124, '2015-04-01 00:48:43.000000', 'consum', 0.0230, 'lps'),
	(471502, 124, '2015-04-01 00:48:44.000000', 'consum', 0.0216, 'lps'),
	(471503, 124, '2015-04-01 00:48:45.000000', 'consum', 0.0231, 'lps'),
	(471504, 124, '2015-04-01 00:48:46.000000', 'consum', 0.0222, 'lps'),
	(471505, 124, '2015-04-01 00:48:47.000000', 'consum', 0.0233, 'lps'),
	(471506, 124, '2015-04-01 00:48:48.000000', 'consum', 0.0211, 'lps'),
	(471507, 124, '2015-04-01 00:48:49.000000', 'consum', 0.0225, 'lps'),
	(471508, 124, '2015-04-01 00:48:50.000000', 'consum', 0.0229, 'lps'),
	(471509, 124, '2015-04-01 00:48:51.000000', 'consum', 0.0211, 'lps'),
	(471510, 124, '2015-04-01 00:48:52.000000', 'consum', 0.0234, 'lps'),
	(471511, 124, '2015-04-01 00:48:53.000000', 'consum', 0.0226, 'lps'),
	(471512, 124, '2015-04-01 00:48:54.000000', 'consum', 0.0217, 'lps'),
	(471513, 124, '2015-04-01 00:48:55.000000', 'consum', 0.0225, 'lps'),
	(471514, 124, '2015-04-01 00:48:56.000000', 'consum', 0.0212, 'lps'),
	(471515, 124, '2015-04-01 00:48:57.000000', 'consum', 0.0227, 'lps'),
	(471516, 124, '2015-04-01 00:48:58.000000', 'consum', 0.0213, 'lps'),
	(471517, 124, '2015-04-01 00:48:59.000000', 'consum', 0.0225, 'lps'),
	(471518, 124, '2015-04-01 00:49:00.000000', 'consum', 0.0227, 'lps'),
	(471519, 124, '2015-04-01 00:49:01.000000', 'consum', 0.0222, 'lps'),
	(471520, 124, '2015-04-01 00:49:02.000000', 'consum', 0.0221, 'lps'),
	(471521, 124, '2015-04-01 00:49:03.000000', 'consum', 0.0230, 'lps'),
	(471522, 124, '2015-04-01 00:49:04.000000', 'consum', 0.0223, 'lps'),
	(471523, 124, '2015-04-01 00:49:05.000000', 'consum', 0.0218, 'lps'),
	(471524, 124, '2015-04-01 00:49:06.000000', 'consum', 0.0235, 'lps'),
	(471525, 124, '2015-04-01 00:49:07.000000', 'consum', 0.0233, 'lps'),
	(471526, 124, '2015-04-01 00:49:08.000000', 'consum', 0.0227, 'lps'),
	(471527, 124, '2015-04-01 00:49:09.000000', 'consum', 0.0227, 'lps'),
	(471528, 124, '2015-04-01 00:49:10.000000', 'consum', 0.0219, 'lps'),
	(471529, 124, '2015-04-01 00:49:11.000000', 'consum', 0.0229, 'lps'),
	(471530, 124, '2015-04-01 00:49:12.000000', 'consum', 0.0227, 'lps'),
	(471531, 124, '2015-04-01 00:49:13.000000', 'consum', 0.0212, 'lps'),
	(471532, 124, '2015-04-01 00:49:14.000000', 'consum', 0.0221, 'lps'),
	(471533, 124, '2015-04-01 00:49:15.000000', 'consum', 0.0235, 'lps'),
	(471534, 124, '2015-04-01 00:49:16.000000', 'consum', 0.0222, 'lps'),
	(471535, 124, '2015-04-01 00:49:17.000000', 'consum', 0.0224, 'lps'),
	(471536, 124, '2015-04-01 00:49:18.000000', 'consum', 0.0219, 'lps'),
	(471537, 124, '2015-04-01 00:49:19.000000', 'consum', 0.0211, 'lps'),
	(471538, 124, '2015-04-01 00:49:20.000000', 'consum', 0.0215, 'lps'),
	(471539, 124, '2015-04-01 00:49:21.000000', 'consum', 0.0232, 'lps'),
	(471540, 124, '2015-04-01 00:49:22.000000', 'consum', 0.0229, 'lps'),
	(471541, 124, '2015-04-01 00:49:23.000000', 'consum', 0.0214, 'lps'),
	(471542, 124, '2015-04-01 00:49:24.000000', 'consum', 0.0227, 'lps'),
	(471543, 124, '2015-04-01 00:49:25.000000', 'consum', 0.0228, 'lps'),
	(471544, 124, '2015-04-01 00:49:26.000000', 'consum', 0.0225, 'lps'),
	(471545, 124, '2015-04-01 00:49:27.000000', 'consum', 0.0231, 'lps'),
	(471546, 124, '2015-04-01 00:49:28.000000', 'consum', 0.0220, 'lps'),
	(471547, 124, '2015-04-01 00:49:29.000000', 'consum', 0.0222, 'lps'),
	(471548, 124, '2015-04-01 00:49:30.000000', 'consum', 0.0215, 'lps'),
	(471549, 124, '2015-04-01 00:49:31.000000', 'consum', 0.0224, 'lps'),
	(471550, 124, '2015-04-01 00:49:32.000000', 'consum', 0.0212, 'lps'),
	(471551, 124, '2015-04-01 00:49:33.000000', 'consum', 0.0234, 'lps'),
	(471552, 124, '2015-04-01 00:49:34.000000', 'consum', 0.0219, 'lps'),
	(471553, 124, '2015-04-01 00:49:35.000000', 'consum', 0.0211, 'lps'),
	(471554, 124, '2015-04-01 00:49:36.000000', 'consum', 0.0214, 'lps'),
	(471555, 124, '2015-04-01 00:49:37.000000', 'consum', 0.0226, 'lps'),
	(471556, 124, '2015-04-01 00:49:38.000000', 'consum', 0.0228, 'lps'),
	(471557, 124, '2015-04-01 00:49:39.000000', 'consum', 0.0224, 'lps'),
	(471558, 124, '2015-04-01 00:49:40.000000', 'consum', 0.0229, 'lps'),
	(471559, 124, '2015-04-01 00:49:41.000000', 'consum', 0.0212, 'lps'),
	(471560, 124, '2015-04-01 00:49:42.000000', 'consum', 0.0214, 'lps'),
	(471561, 124, '2015-04-01 00:49:43.000000', 'consum', 0.0224, 'lps'),
	(471562, 124, '2015-04-01 00:49:44.000000', 'consum', 0.0218, 'lps'),
	(471563, 124, '2015-04-01 00:49:45.000000', 'consum', 0.0234, 'lps'),
	(471564, 124, '2015-04-01 00:49:46.000000', 'consum', 0.0230, 'lps'),
	(471565, 124, '2015-04-01 00:49:47.000000', 'consum', 0.0212, 'lps'),
	(471566, 124, '2015-04-01 00:49:48.000000', 'consum', 0.0214, 'lps'),
	(471567, 124, '2015-04-01 00:49:49.000000', 'consum', 0.0221, 'lps'),
	(471568, 124, '2015-04-01 00:49:50.000000', 'consum', 0.0230, 'lps'),
	(471569, 124, '2015-04-01 00:49:51.000000', 'consum', 0.0227, 'lps'),
	(471570, 124, '2015-04-01 00:49:52.000000', 'consum', 0.0234, 'lps'),
	(471571, 124, '2015-04-01 00:49:53.000000', 'consum', 0.0226, 'lps'),
	(471572, 124, '2015-04-01 00:49:54.000000', 'consum', 0.0221, 'lps'),
	(471573, 124, '2015-04-01 00:49:55.000000', 'consum', 0.0217, 'lps'),
	(471574, 124, '2015-04-01 00:49:56.000000', 'consum', 0.0214, 'lps'),
	(471575, 124, '2015-04-01 00:49:57.000000', 'consum', 0.0235, 'lps'),
	(471576, 124, '2015-04-01 00:49:58.000000', 'consum', 0.0218, 'lps'),
	(471577, 124, '2015-04-01 00:49:59.000000', 'consum', 0.0229, 'lps'),
	(471578, 124, '2015-04-01 00:50:00.000000', 'consum', 0.0229, 'lps'),
	(471579, 124, '2015-04-01 00:50:01.000000', 'consum', 0.0221, 'lps'),
	(471580, 124, '2015-04-01 00:50:02.000000', 'consum', 0.0211, 'lps'),
	(471581, 124, '2015-04-01 00:50:03.000000', 'consum', 0.0235, 'lps'),
	(471582, 124, '2015-04-01 00:50:04.000000', 'consum', 0.0226, 'lps'),
	(471583, 124, '2015-04-01 00:50:05.000000', 'consum', 0.0218, 'lps'),
	(471584, 124, '2015-04-01 00:50:06.000000', 'consum', 0.0226, 'lps'),
	(471585, 124, '2015-04-01 00:50:07.000000', 'consum', 0.0215, 'lps'),
	(471586, 124, '2015-04-01 00:50:08.000000', 'consum', 0.0216, 'lps'),
	(471587, 124, '2015-04-01 00:50:09.000000', 'consum', 0.0223, 'lps'),
	(471588, 124, '2015-04-01 00:50:10.000000', 'consum', 0.0232, 'lps'),
	(471589, 124, '2015-04-01 00:50:11.000000', 'consum', 0.0228, 'lps'),
	(471590, 124, '2015-04-01 00:50:12.000000', 'consum', 0.0212, 'lps'),
	(471591, 124, '2015-04-01 00:50:13.000000', 'consum', 0.0215, 'lps'),
	(471592, 124, '2015-04-01 00:50:14.000000', 'consum', 0.0232, 'lps'),
	(471593, 124, '2015-04-01 00:50:15.000000', 'consum', 0.0227, 'lps'),
	(471594, 124, '2015-04-01 00:50:16.000000', 'consum', 0.0229, 'lps'),
	(471595, 124, '2015-04-01 00:50:17.000000', 'consum', 0.0228, 'lps'),
	(471596, 124, '2015-04-01 00:50:18.000000', 'consum', 0.0217, 'lps'),
	(471597, 124, '2015-04-01 00:50:19.000000', 'consum', 0.0218, 'lps'),
	(471598, 124, '2015-04-01 00:50:20.000000', 'consum', 0.0229, 'lps'),
	(471599, 124, '2015-04-01 00:50:21.000000', 'consum', 0.0231, 'lps'),
	(471600, 124, '2015-04-01 00:50:22.000000', 'consum', 0.0230, 'lps'),
	(471601, 124, '2015-04-01 00:50:23.000000', 'consum', 0.0224, 'lps'),
	(471602, 124, '2015-04-01 00:50:24.000000', 'consum', 0.0222, 'lps'),
	(471603, 124, '2015-04-01 00:50:25.000000', 'consum', 0.0225, 'lps'),
	(471604, 124, '2015-04-01 00:50:26.000000', 'consum', 0.0225, 'lps'),
	(471605, 124, '2015-04-01 00:50:27.000000', 'consum', 0.0213, 'lps'),
	(471606, 124, '2015-04-01 00:50:28.000000', 'consum', 0.0233, 'lps'),
	(471607, 124, '2015-04-01 00:50:29.000000', 'consum', 0.0214, 'lps'),
	(471608, 124, '2015-04-01 00:50:30.000000', 'consum', 0.0212, 'lps'),
	(471609, 124, '2015-04-01 00:50:31.000000', 'consum', 0.0235, 'lps'),
	(471610, 124, '2015-04-01 00:50:32.000000', 'consum', 0.0226, 'lps'),
	(471611, 124, '2015-04-01 00:50:33.000000', 'consum', 0.0213, 'lps'),
	(471612, 124, '2015-04-01 00:50:34.000000', 'consum', 0.0232, 'lps'),
	(471613, 124, '2015-04-01 00:50:35.000000', 'consum', 0.0231, 'lps'),
	(471614, 124, '2015-04-01 00:50:36.000000', 'consum', 0.0223, 'lps'),
	(471615, 124, '2015-04-01 00:50:37.000000', 'consum', 0.0216, 'lps'),
	(471616, 124, '2015-04-01 00:50:38.000000', 'consum', 0.0224, 'lps'),
	(471617, 124, '2015-04-01 00:50:39.000000', 'consum', 0.0212, 'lps'),
	(471618, 124, '2015-04-01 00:50:40.000000', 'consum', 0.0231, 'lps'),
	(471619, 124, '2015-04-01 00:50:41.000000', 'consum', 0.0229, 'lps'),
	(471620, 124, '2015-04-01 00:50:42.000000', 'consum', 0.0219, 'lps'),
	(471621, 124, '2015-04-01 00:50:43.000000', 'consum', 0.0222, 'lps'),
	(471622, 124, '2015-04-01 00:50:44.000000', 'consum', 0.0218, 'lps'),
	(471623, 124, '2015-04-01 00:50:45.000000', 'consum', 0.0216, 'lps'),
	(471624, 124, '2015-04-01 00:50:46.000000', 'consum', 0.0214, 'lps'),
	(471625, 124, '2015-04-01 00:50:47.000000', 'consum', 0.0213, 'lps'),
	(471626, 124, '2015-04-01 00:50:48.000000', 'consum', 0.0214, 'lps'),
	(471627, 124, '2015-04-01 00:50:49.000000', 'consum', 0.0221, 'lps'),
	(471628, 124, '2015-04-01 00:50:50.000000', 'consum', 0.0227, 'lps'),
	(471629, 124, '2015-04-01 00:50:51.000000', 'consum', 0.0212, 'lps'),
	(471630, 124, '2015-04-01 00:50:52.000000', 'consum', 0.0220, 'lps'),
	(471631, 124, '2015-04-01 00:50:53.000000', 'consum', 0.0228, 'lps'),
	(471632, 124, '2015-04-01 00:50:54.000000', 'consum', 0.0218, 'lps'),
	(471633, 124, '2015-04-01 00:50:55.000000', 'consum', 0.0222, 'lps'),
	(471634, 124, '2015-04-01 00:50:56.000000', 'consum', 0.0222, 'lps'),
	(471635, 124, '2015-04-01 00:50:57.000000', 'consum', 0.0235, 'lps'),
	(471636, 124, '2015-04-01 00:50:58.000000', 'consum', 0.0219, 'lps'),
	(471637, 124, '2015-04-01 00:50:59.000000', 'consum', 0.0234, 'lps'),
	(471638, 124, '2015-04-01 00:51:00.000000', 'consum', 0.0227, 'lps'),
	(471639, 124, '2015-04-01 00:51:01.000000', 'consum', 0.0222, 'lps'),
	(471640, 124, '2015-04-01 00:51:02.000000', 'consum', 0.0220, 'lps'),
	(471641, 124, '2015-04-01 00:51:03.000000', 'consum', 0.0226, 'lps'),
	(471642, 124, '2015-04-01 00:51:04.000000', 'consum', 0.0234, 'lps'),
	(471643, 124, '2015-04-01 00:51:05.000000', 'consum', 0.0231, 'lps'),
	(471644, 124, '2015-04-01 00:51:06.000000', 'consum', 0.0218, 'lps'),
	(471645, 124, '2015-04-01 00:51:07.000000', 'consum', 0.0213, 'lps'),
	(471646, 124, '2015-04-01 00:51:08.000000', 'consum', 0.0228, 'lps'),
	(471647, 124, '2015-04-01 00:51:09.000000', 'consum', 0.0212, 'lps'),
	(471648, 124, '2015-04-01 00:51:10.000000', 'consum', 0.0218, 'lps'),
	(471649, 124, '2015-04-01 00:51:11.000000', 'consum', 0.0220, 'lps'),
	(471650, 124, '2015-04-01 00:51:12.000000', 'consum', 0.0235, 'lps'),
	(471651, 124, '2015-04-01 00:51:13.000000', 'consum', 0.0227, 'lps'),
	(471652, 124, '2015-04-01 00:51:14.000000', 'consum', 0.0222, 'lps'),
	(471653, 124, '2015-04-01 00:51:15.000000', 'consum', 0.0218, 'lps'),
	(471654, 124, '2015-04-01 00:51:16.000000', 'consum', 0.0215, 'lps'),
	(471655, 124, '2015-04-01 00:51:17.000000', 'consum', 0.0211, 'lps'),
	(471656, 124, '2015-04-01 00:51:18.000000', 'consum', 0.0225, 'lps'),
	(471657, 124, '2015-04-01 00:51:19.000000', 'consum', 0.0231, 'lps'),
	(471658, 124, '2015-04-01 00:51:20.000000', 'consum', 0.0220, 'lps'),
	(471659, 124, '2015-04-01 00:51:21.000000', 'consum', 0.0225, 'lps'),
	(471660, 124, '2015-04-01 00:51:22.000000', 'consum', 0.0226, 'lps'),
	(471661, 124, '2015-04-01 00:51:23.000000', 'consum', 0.0223, 'lps'),
	(471662, 124, '2015-04-01 00:51:24.000000', 'consum', 0.0226, 'lps'),
	(471663, 124, '2015-04-01 00:51:25.000000', 'consum', 0.0226, 'lps'),
	(471664, 124, '2015-04-01 00:51:26.000000', 'consum', 0.0216, 'lps'),
	(471665, 124, '2015-04-01 00:51:27.000000', 'consum', 0.0219, 'lps'),
	(471666, 124, '2015-04-01 00:51:28.000000', 'consum', 0.0211, 'lps'),
	(471667, 124, '2015-04-01 00:51:29.000000', 'consum', 0.0217, 'lps'),
	(471668, 124, '2015-04-01 00:51:30.000000', 'consum', 0.0214, 'lps'),
	(471669, 124, '2015-04-01 00:51:31.000000', 'consum', 0.0210, 'lps'),
	(471670, 124, '2015-04-01 00:51:32.000000', 'consum', 0.0223, 'lps'),
	(471671, 124, '2015-04-01 00:51:33.000000', 'consum', 0.0223, 'lps'),
	(471672, 124, '2015-04-01 00:51:34.000000', 'consum', 0.0212, 'lps'),
	(471673, 124, '2015-04-01 00:51:35.000000', 'consum', 0.0234, 'lps'),
	(471674, 124, '2015-04-01 00:51:36.000000', 'consum', 0.0220, 'lps'),
	(471675, 124, '2015-04-01 00:51:37.000000', 'consum', 0.0213, 'lps'),
	(471676, 124, '2015-04-01 00:51:38.000000', 'consum', 0.0223, 'lps'),
	(471677, 124, '2015-04-01 00:51:39.000000', 'consum', 0.0213, 'lps'),
	(471678, 124, '2015-04-01 00:51:40.000000', 'consum', 0.0215, 'lps'),
	(471679, 124, '2015-04-01 00:51:41.000000', 'consum', 0.0226, 'lps'),
	(471680, 124, '2015-04-01 00:51:42.000000', 'consum', 0.0222, 'lps'),
	(471681, 124, '2015-04-01 00:51:43.000000', 'consum', 0.0222, 'lps'),
	(471682, 124, '2015-04-01 00:51:44.000000', 'consum', 0.0234, 'lps'),
	(471683, 124, '2015-04-01 00:51:45.000000', 'consum', 0.0217, 'lps'),
	(471684, 124, '2015-04-01 00:51:46.000000', 'consum', 0.0227, 'lps'),
	(471685, 124, '2015-04-01 00:51:47.000000', 'consum', 0.0221, 'lps'),
	(471686, 124, '2015-04-01 00:51:48.000000', 'consum', 0.0215, 'lps'),
	(471687, 124, '2015-04-01 00:51:49.000000', 'consum', 0.0228, 'lps'),
	(471688, 124, '2015-04-01 00:51:50.000000', 'consum', 0.0234, 'lps'),
	(471689, 124, '2015-04-01 00:51:51.000000', 'consum', 0.0226, 'lps'),
	(471690, 124, '2015-04-01 00:51:52.000000', 'consum', 0.0220, 'lps'),
	(471691, 124, '2015-04-01 00:51:53.000000', 'consum', 0.0235, 'lps'),
	(471692, 124, '2015-04-01 00:51:54.000000', 'consum', 0.0227, 'lps'),
	(471693, 124, '2015-04-01 00:51:55.000000', 'consum', 0.0220, 'lps'),
	(471694, 124, '2015-04-01 00:51:56.000000', 'consum', 0.0211, 'lps'),
	(471695, 124, '2015-04-01 00:51:57.000000', 'consum', 0.0211, 'lps'),
	(471696, 124, '2015-04-01 00:51:58.000000', 'consum', 0.0213, 'lps'),
	(471697, 124, '2015-04-01 00:51:59.000000', 'consum', 0.0222, 'lps'),
	(471698, 124, '2015-04-01 00:52:00.000000', 'consum', 0.0210, 'lps'),
	(471699, 124, '2015-04-01 00:52:01.000000', 'consum', 0.0226, 'lps'),
	(471700, 124, '2015-04-01 00:52:02.000000', 'consum', 0.0211, 'lps'),
	(471701, 124, '2015-04-01 00:52:03.000000', 'consum', 0.0223, 'lps'),
	(471702, 124, '2015-04-01 00:52:04.000000', 'consum', 0.0218, 'lps'),
	(471703, 124, '2015-04-01 00:52:05.000000', 'consum', 0.0212, 'lps'),
	(471704, 124, '2015-04-01 00:52:06.000000', 'consum', 0.0223, 'lps'),
	(471705, 124, '2015-04-01 00:52:07.000000', 'consum', 0.0219, 'lps'),
	(471706, 124, '2015-04-01 00:52:08.000000', 'consum', 0.0214, 'lps'),
	(471707, 124, '2015-04-01 00:52:09.000000', 'consum', 0.0231, 'lps'),
	(471708, 124, '2015-04-01 00:52:10.000000', 'consum', 0.0225, 'lps'),
	(471709, 124, '2015-04-01 00:52:11.000000', 'consum', 0.0225, 'lps'),
	(471710, 124, '2015-04-01 00:52:12.000000', 'consum', 0.0211, 'lps'),
	(471711, 124, '2015-04-01 00:52:13.000000', 'consum', 0.0225, 'lps'),
	(471712, 124, '2015-04-01 00:52:14.000000', 'consum', 0.0231, 'lps'),
	(471713, 124, '2015-04-01 00:52:15.000000', 'consum', 0.0217, 'lps'),
	(471714, 124, '2015-04-01 00:52:16.000000', 'consum', 0.0233, 'lps'),
	(471715, 124, '2015-04-01 00:52:17.000000', 'consum', 0.0227, 'lps'),
	(471716, 124, '2015-04-01 00:52:18.000000', 'consum', 0.0227, 'lps'),
	(471717, 124, '2015-04-01 00:52:19.000000', 'consum', 0.0220, 'lps'),
	(471718, 124, '2015-04-01 00:52:20.000000', 'consum', 0.0210, 'lps'),
	(471719, 124, '2015-04-01 00:52:21.000000', 'consum', 0.0233, 'lps'),
	(471720, 124, '2015-04-01 00:52:22.000000', 'consum', 0.0221, 'lps'),
	(471721, 124, '2015-04-01 00:52:23.000000', 'consum', 0.0221, 'lps'),
	(471722, 124, '2015-04-01 00:52:24.000000', 'consum', 0.0234, 'lps'),
	(471723, 124, '2015-04-01 00:52:25.000000', 'consum', 0.0221, 'lps'),
	(471724, 124, '2015-04-01 00:52:26.000000', 'consum', 0.0218, 'lps'),
	(471725, 124, '2015-04-01 00:52:27.000000', 'consum', 0.0218, 'lps'),
	(471726, 124, '2015-04-01 00:52:28.000000', 'consum', 0.0227, 'lps'),
	(471727, 124, '2015-04-01 00:52:29.000000', 'consum', 0.0219, 'lps'),
	(471728, 124, '2015-04-01 00:52:30.000000', 'consum', 0.0232, 'lps'),
	(471729, 124, '2015-04-01 00:52:31.000000', 'consum', 0.0214, 'lps'),
	(471730, 124, '2015-04-01 00:52:32.000000', 'consum', 0.0216, 'lps'),
	(471731, 124, '2015-04-01 00:52:33.000000', 'consum', 0.0231, 'lps'),
	(471732, 124, '2015-04-01 00:52:34.000000', 'consum', 0.0218, 'lps'),
	(471733, 124, '2015-04-01 00:52:35.000000', 'consum', 0.0213, 'lps'),
	(471734, 124, '2015-04-01 00:52:36.000000', 'consum', 0.0228, 'lps'),
	(471735, 124, '2015-04-01 00:52:37.000000', 'consum', 0.0214, 'lps'),
	(471736, 124, '2015-04-01 00:52:38.000000', 'consum', 0.0228, 'lps'),
	(471737, 124, '2015-04-01 00:52:39.000000', 'consum', 0.0212, 'lps'),
	(471738, 124, '2015-04-01 00:52:40.000000', 'consum', 0.0218, 'lps'),
	(471739, 124, '2015-04-01 00:52:41.000000', 'consum', 0.0216, 'lps'),
	(471740, 124, '2015-04-01 00:52:42.000000', 'consum', 0.0220, 'lps'),
	(471741, 124, '2015-04-01 00:52:43.000000', 'consum', 0.0213, 'lps'),
	(471742, 124, '2015-04-01 00:52:44.000000', 'consum', 0.0224, 'lps'),
	(471743, 124, '2015-04-01 00:52:45.000000', 'consum', 0.0218, 'lps'),
	(471744, 124, '2015-04-01 00:52:46.000000', 'consum', 0.0235, 'lps'),
	(471745, 124, '2015-04-01 00:52:47.000000', 'consum', 0.0234, 'lps'),
	(471746, 124, '2015-04-01 00:52:48.000000', 'consum', 0.0228, 'lps'),
	(471747, 124, '2015-04-01 00:52:49.000000', 'consum', 0.0231, 'lps'),
	(471748, 124, '2015-04-01 00:52:50.000000', 'consum', 0.0233, 'lps'),
	(471749, 124, '2015-04-01 00:52:51.000000', 'consum', 0.0211, 'lps'),
	(471750, 124, '2015-04-01 00:52:52.000000', 'consum', 0.0224, 'lps'),
	(471751, 124, '2015-04-01 00:52:53.000000', 'consum', 0.0228, 'lps'),
	(471752, 124, '2015-04-01 00:52:54.000000', 'consum', 0.0230, 'lps'),
	(471753, 124, '2015-04-01 00:52:55.000000', 'consum', 0.0230, 'lps'),
	(471754, 124, '2015-04-01 00:52:56.000000', 'consum', 0.0224, 'lps'),
	(471755, 124, '2015-04-01 00:52:57.000000', 'consum', 0.0220, 'lps'),
	(471756, 124, '2015-04-01 00:52:58.000000', 'consum', 0.0221, 'lps'),
	(471757, 124, '2015-04-01 00:52:59.000000', 'consum', 0.0235, 'lps'),
	(471758, 124, '2015-04-01 00:53:00.000000', 'consum', 0.0224, 'lps'),
	(471759, 124, '2015-04-01 00:53:01.000000', 'consum', 0.0231, 'lps'),
	(471760, 124, '2015-04-01 00:53:02.000000', 'consum', 0.0224, 'lps'),
	(471761, 124, '2015-04-01 00:53:03.000000', 'consum', 0.0215, 'lps'),
	(471762, 124, '2015-04-01 00:53:04.000000', 'consum', 0.0221, 'lps'),
	(471763, 124, '2015-04-01 00:53:05.000000', 'consum', 0.0226, 'lps'),
	(471764, 124, '2015-04-01 00:53:06.000000', 'consum', 0.0230, 'lps'),
	(471765, 124, '2015-04-01 00:53:07.000000', 'consum', 0.0210, 'lps'),
	(471766, 124, '2015-04-01 00:53:08.000000', 'consum', 0.0229, 'lps'),
	(471767, 124, '2015-04-01 00:53:09.000000', 'consum', 0.0226, 'lps'),
	(471768, 124, '2015-04-01 00:53:10.000000', 'consum', 0.0235, 'lps'),
	(471769, 124, '2015-04-01 00:53:11.000000', 'consum', 0.0235, 'lps'),
	(471770, 124, '2015-04-01 00:53:12.000000', 'consum', 0.0233, 'lps'),
	(471771, 124, '2015-04-01 00:53:13.000000', 'consum', 0.0227, 'lps'),
	(471772, 124, '2015-04-01 00:53:14.000000', 'consum', 0.0226, 'lps'),
	(471773, 124, '2015-04-01 00:53:15.000000', 'consum', 0.0212, 'lps'),
	(471774, 124, '2015-04-01 00:53:16.000000', 'consum', 0.0224, 'lps'),
	(471775, 124, '2015-04-01 00:53:17.000000', 'consum', 0.0225, 'lps'),
	(471776, 124, '2015-04-01 00:53:18.000000', 'consum', 0.0214, 'lps'),
	(471777, 124, '2015-04-01 00:53:19.000000', 'consum', 0.0215, 'lps'),
	(471778, 124, '2015-04-01 00:53:20.000000', 'consum', 0.0223, 'lps'),
	(471779, 124, '2015-04-01 00:53:21.000000', 'consum', 0.0233, 'lps'),
	(471780, 124, '2015-04-01 00:53:22.000000', 'consum', 0.0235, 'lps'),
	(471781, 124, '2015-04-01 00:53:23.000000', 'consum', 0.0214, 'lps'),
	(471782, 124, '2015-04-01 00:53:24.000000', 'consum', 0.0210, 'lps'),
	(471783, 124, '2015-04-01 00:53:25.000000', 'consum', 0.0223, 'lps'),
	(471784, 124, '2015-04-01 00:53:26.000000', 'consum', 0.0223, 'lps'),
	(471785, 124, '2015-04-01 00:53:27.000000', 'consum', 0.0212, 'lps'),
	(471786, 124, '2015-04-01 00:53:28.000000', 'consum', 0.0235, 'lps'),
	(471787, 124, '2015-04-01 00:53:29.000000', 'consum', 0.0223, 'lps'),
	(471788, 124, '2015-04-01 00:53:30.000000', 'consum', 0.0228, 'lps'),
	(471789, 124, '2015-04-01 00:53:31.000000', 'consum', 0.0235, 'lps'),
	(471790, 124, '2015-04-01 00:53:32.000000', 'consum', 0.0230, 'lps'),
	(471791, 124, '2015-04-01 00:53:33.000000', 'consum', 0.0234, 'lps'),
	(471792, 124, '2015-04-01 00:53:34.000000', 'consum', 0.0221, 'lps'),
	(471793, 124, '2015-04-01 00:53:35.000000', 'consum', 0.0217, 'lps'),
	(471794, 124, '2015-04-01 00:53:36.000000', 'consum', 0.0214, 'lps'),
	(471795, 124, '2015-04-01 00:53:37.000000', 'consum', 0.0210, 'lps'),
	(471796, 124, '2015-04-01 00:53:38.000000', 'consum', 0.0226, 'lps'),
	(471797, 124, '2015-04-01 00:53:39.000000', 'consum', 0.0211, 'lps'),
	(471798, 124, '2015-04-01 00:53:40.000000', 'consum', 0.0218, 'lps'),
	(471799, 124, '2015-04-01 00:53:41.000000', 'consum', 0.0222, 'lps'),
	(471800, 124, '2015-04-01 00:53:42.000000', 'consum', 0.0221, 'lps'),
	(471801, 124, '2015-04-01 00:53:43.000000', 'consum', 0.0228, 'lps'),
	(471802, 124, '2015-04-01 00:53:44.000000', 'consum', 0.0216, 'lps'),
	(471803, 124, '2015-04-01 00:53:45.000000', 'consum', 0.0212, 'lps'),
	(471804, 124, '2015-04-01 00:53:46.000000', 'consum', 0.0228, 'lps'),
	(471805, 124, '2015-04-01 00:53:47.000000', 'consum', 0.0216, 'lps'),
	(471806, 124, '2015-04-01 00:53:48.000000', 'consum', 0.0214, 'lps'),
	(471807, 124, '2015-04-01 00:53:49.000000', 'consum', 0.0213, 'lps'),
	(471808, 124, '2015-04-01 00:53:50.000000', 'consum', 0.0213, 'lps'),
	(471809, 124, '2015-04-01 00:53:51.000000', 'consum', 0.0215, 'lps'),
	(471810, 124, '2015-04-01 00:53:52.000000', 'consum', 0.0226, 'lps'),
	(471811, 124, '2015-04-01 00:53:53.000000', 'consum', 0.0224, 'lps'),
	(471812, 124, '2015-04-01 00:53:54.000000', 'consum', 0.0231, 'lps'),
	(471813, 124, '2015-04-01 00:53:55.000000', 'consum', 0.0224, 'lps'),
	(471814, 124, '2015-04-01 00:53:56.000000', 'consum', 0.0216, 'lps'),
	(471815, 124, '2015-04-01 00:53:57.000000', 'consum', 0.0223, 'lps'),
	(471816, 124, '2015-04-01 00:53:58.000000', 'consum', 0.0232, 'lps'),
	(471817, 124, '2015-04-01 00:53:59.000000', 'consum', 0.0231, 'lps'),
	(471818, 124, '2015-04-01 00:54:00.000000', 'consum', 0.0223, 'lps'),
	(471819, 124, '2015-04-01 00:54:01.000000', 'consum', 0.0212, 'lps'),
	(471820, 124, '2015-04-01 00:54:02.000000', 'consum', 0.0233, 'lps'),
	(471821, 124, '2015-04-01 00:54:03.000000', 'consum', 0.0215, 'lps'),
	(471822, 124, '2015-04-01 00:54:04.000000', 'consum', 0.0221, 'lps'),
	(471823, 124, '2015-04-01 00:54:05.000000', 'consum', 0.0223, 'lps'),
	(471824, 124, '2015-04-01 00:54:06.000000', 'consum', 0.0218, 'lps'),
	(471825, 124, '2015-04-01 00:54:07.000000', 'consum', 0.0235, 'lps'),
	(471826, 124, '2015-04-01 00:54:08.000000', 'consum', 0.0235, 'lps'),
	(471827, 124, '2015-04-01 00:54:09.000000', 'consum', 0.0232, 'lps'),
	(471828, 124, '2015-04-01 00:54:10.000000', 'consum', 0.0223, 'lps'),
	(471829, 124, '2015-04-01 00:54:11.000000', 'consum', 0.0232, 'lps'),
	(471830, 124, '2015-04-01 00:54:12.000000', 'consum', 0.0232, 'lps'),
	(471831, 124, '2015-04-01 00:54:13.000000', 'consum', 0.0230, 'lps'),
	(471832, 124, '2015-04-01 00:54:14.000000', 'consum', 0.0215, 'lps'),
	(471833, 124, '2015-04-01 00:54:15.000000', 'consum', 0.0230, 'lps'),
	(471834, 124, '2015-04-01 00:54:16.000000', 'consum', 0.0219, 'lps'),
	(471835, 124, '2015-04-01 00:54:17.000000', 'consum', 0.0218, 'lps'),
	(471836, 124, '2015-04-01 00:54:18.000000', 'consum', 0.0226, 'lps'),
	(471837, 124, '2015-04-01 00:54:19.000000', 'consum', 0.0213, 'lps'),
	(471838, 124, '2015-04-01 00:54:20.000000', 'consum', 0.0229, 'lps'),
	(471839, 124, '2015-04-01 00:54:21.000000', 'consum', 0.0219, 'lps'),
	(471840, 124, '2015-04-01 00:54:22.000000', 'consum', 0.0226, 'lps'),
	(471841, 124, '2015-04-01 00:54:23.000000', 'consum', 0.0235, 'lps'),
	(471842, 124, '2015-04-01 00:54:24.000000', 'consum', 0.0211, 'lps'),
	(471843, 124, '2015-04-01 00:54:25.000000', 'consum', 0.0217, 'lps'),
	(471844, 124, '2015-04-01 00:54:26.000000', 'consum', 0.0217, 'lps'),
	(471845, 124, '2015-04-01 00:54:27.000000', 'consum', 0.0225, 'lps'),
	(471846, 124, '2015-04-01 00:54:28.000000', 'consum', 0.0213, 'lps'),
	(471847, 124, '2015-04-01 00:54:29.000000', 'consum', 0.0233, 'lps'),
	(471848, 124, '2015-04-01 00:54:30.000000', 'consum', 0.0211, 'lps'),
	(471849, 124, '2015-04-01 00:54:31.000000', 'consum', 0.0227, 'lps'),
	(471850, 124, '2015-04-01 00:54:32.000000', 'consum', 0.0214, 'lps'),
	(471851, 124, '2015-04-01 00:54:33.000000', 'consum', 0.0229, 'lps'),
	(471852, 124, '2015-04-01 00:54:34.000000', 'consum', 0.0218, 'lps'),
	(471853, 124, '2015-04-01 00:54:35.000000', 'consum', 0.0217, 'lps'),
	(471854, 124, '2015-04-01 00:54:36.000000', 'consum', 0.0224, 'lps'),
	(471855, 124, '2015-04-01 00:54:37.000000', 'consum', 0.0232, 'lps'),
	(471856, 124, '2015-04-01 00:54:38.000000', 'consum', 0.0227, 'lps'),
	(471857, 124, '2015-04-01 00:54:39.000000', 'consum', 0.0229, 'lps'),
	(471858, 124, '2015-04-01 00:54:40.000000', 'consum', 0.0230, 'lps'),
	(471859, 124, '2015-04-01 00:54:41.000000', 'consum', 0.0228, 'lps'),
	(471860, 124, '2015-04-01 00:54:42.000000', 'consum', 0.0215, 'lps'),
	(471861, 124, '2015-04-01 00:54:43.000000', 'consum', 0.0233, 'lps'),
	(471862, 124, '2015-04-01 00:54:44.000000', 'consum', 0.0232, 'lps'),
	(471863, 124, '2015-04-01 00:54:45.000000', 'consum', 0.0227, 'lps'),
	(471864, 124, '2015-04-01 00:54:46.000000', 'consum', 0.0227, 'lps'),
	(471865, 124, '2015-04-01 00:54:47.000000', 'consum', 0.0218, 'lps'),
	(471866, 124, '2015-04-01 00:54:48.000000', 'consum', 0.0229, 'lps'),
	(471867, 124, '2015-04-01 00:54:49.000000', 'consum', 0.0226, 'lps'),
	(471868, 124, '2015-04-01 00:54:50.000000', 'consum', 0.0234, 'lps'),
	(471869, 124, '2015-04-01 00:54:51.000000', 'consum', 0.0231, 'lps'),
	(471870, 124, '2015-04-01 00:54:52.000000', 'consum', 0.0219, 'lps'),
	(471871, 124, '2015-04-01 00:54:53.000000', 'consum', 0.0216, 'lps'),
	(471872, 124, '2015-04-01 00:54:54.000000', 'consum', 0.0213, 'lps'),
	(471873, 124, '2015-04-01 00:54:55.000000', 'consum', 0.0235, 'lps'),
	(471874, 124, '2015-04-01 00:54:56.000000', 'consum', 0.0224, 'lps'),
	(471875, 124, '2015-04-01 00:54:57.000000', 'consum', 0.0229, 'lps'),
	(471876, 124, '2015-04-01 00:54:58.000000', 'consum', 0.0211, 'lps'),
	(471877, 124, '2015-04-01 00:54:59.000000', 'consum', 0.0235, 'lps'),
	(471878, 124, '2015-04-01 00:55:00.000000', 'consum', 0.0232, 'lps'),
	(471879, 124, '2015-04-01 00:55:01.000000', 'consum', 0.0218, 'lps'),
	(471880, 124, '2015-04-01 00:55:02.000000', 'consum', 0.0212, 'lps'),
	(471881, 124, '2015-04-01 00:55:03.000000', 'consum', 0.0222, 'lps'),
	(471882, 124, '2015-04-01 00:55:04.000000', 'consum', 0.0213, 'lps'),
	(471883, 124, '2015-04-01 00:55:05.000000', 'consum', 0.0214, 'lps'),
	(471884, 124, '2015-04-01 00:55:06.000000', 'consum', 0.0223, 'lps'),
	(471885, 124, '2015-04-01 00:55:07.000000', 'consum', 0.0212, 'lps'),
	(471886, 124, '2015-04-01 00:55:08.000000', 'consum', 0.0232, 'lps'),
	(471887, 124, '2015-04-01 00:55:09.000000', 'consum', 0.0210, 'lps'),
	(471888, 124, '2015-04-01 00:55:10.000000', 'consum', 0.0223, 'lps'),
	(471889, 124, '2015-04-01 00:55:11.000000', 'consum', 0.0223, 'lps'),
	(471890, 124, '2015-04-01 00:55:12.000000', 'consum', 0.0211, 'lps'),
	(471891, 124, '2015-04-01 00:55:13.000000', 'consum', 0.0231, 'lps'),
	(471892, 124, '2015-04-01 00:55:14.000000', 'consum', 0.0231, 'lps'),
	(471893, 124, '2015-04-01 00:55:15.000000', 'consum', 0.0228, 'lps'),
	(471894, 124, '2015-04-01 00:55:16.000000', 'consum', 0.0210, 'lps'),
	(471895, 124, '2015-04-01 00:55:17.000000', 'consum', 0.0210, 'lps'),
	(471896, 124, '2015-04-01 00:55:18.000000', 'consum', 0.0235, 'lps'),
	(471897, 124, '2015-04-01 00:55:19.000000', 'consum', 0.0231, 'lps'),
	(471898, 124, '2015-04-01 00:55:20.000000', 'consum', 0.0213, 'lps'),
	(471899, 124, '2015-04-01 00:55:21.000000', 'consum', 0.0218, 'lps'),
	(471900, 124, '2015-04-01 00:55:22.000000', 'consum', 0.0215, 'lps'),
	(471901, 124, '2015-04-01 00:55:23.000000', 'consum', 0.0211, 'lps'),
	(471902, 124, '2015-04-01 00:55:24.000000', 'consum', 0.0225, 'lps'),
	(471903, 124, '2015-04-01 00:55:25.000000', 'consum', 0.0231, 'lps'),
	(471904, 124, '2015-04-01 00:55:26.000000', 'consum', 0.0219, 'lps'),
	(471905, 124, '2015-04-01 00:55:27.000000', 'consum', 0.0220, 'lps'),
	(471906, 124, '2015-04-01 00:55:28.000000', 'consum', 0.0232, 'lps'),
	(471907, 124, '2015-04-01 00:55:29.000000', 'consum', 0.0212, 'lps'),
	(471908, 124, '2015-04-01 00:55:30.000000', 'consum', 0.0234, 'lps'),
	(471909, 124, '2015-04-01 00:55:31.000000', 'consum', 0.0219, 'lps'),
	(471910, 124, '2015-04-01 00:55:32.000000', 'consum', 0.0235, 'lps'),
	(471911, 124, '2015-04-01 00:55:33.000000', 'consum', 0.0230, 'lps'),
	(471912, 124, '2015-04-01 00:55:34.000000', 'consum', 0.0212, 'lps'),
	(471913, 124, '2015-04-01 00:55:35.000000', 'consum', 0.0212, 'lps'),
	(471914, 124, '2015-04-01 00:55:36.000000', 'consum', 0.0213, 'lps'),
	(471915, 124, '2015-04-01 00:55:37.000000', 'consum', 0.0222, 'lps'),
	(471916, 124, '2015-04-01 00:55:38.000000', 'consum', 0.0233, 'lps'),
	(471917, 124, '2015-04-01 00:55:39.000000', 'consum', 0.0213, 'lps'),
	(471918, 124, '2015-04-01 00:55:40.000000', 'consum', 0.0235, 'lps'),
	(471919, 124, '2015-04-01 00:55:41.000000', 'consum', 0.0221, 'lps'),
	(471920, 124, '2015-04-01 00:55:42.000000', 'consum', 0.0216, 'lps'),
	(471921, 124, '2015-04-01 00:55:43.000000', 'consum', 0.0210, 'lps'),
	(471922, 124, '2015-04-01 00:55:44.000000', 'consum', 0.0218, 'lps'),
	(471923, 124, '2015-04-01 00:55:45.000000', 'consum', 0.0226, 'lps'),
	(471924, 124, '2015-04-01 00:55:46.000000', 'consum', 0.0213, 'lps'),
	(471925, 124, '2015-04-01 00:55:47.000000', 'consum', 0.0228, 'lps'),
	(471926, 124, '2015-04-01 00:55:48.000000', 'consum', 0.0213, 'lps'),
	(471927, 124, '2015-04-01 00:55:49.000000', 'consum', 0.0226, 'lps'),
	(471928, 124, '2015-04-01 00:55:50.000000', 'consum', 0.0230, 'lps'),
	(471929, 124, '2015-04-01 00:55:51.000000', 'consum', 0.0235, 'lps'),
	(471930, 124, '2015-04-01 00:55:52.000000', 'consum', 0.0225, 'lps'),
	(471931, 124, '2015-04-01 00:55:53.000000', 'consum', 0.0210, 'lps'),
	(471932, 124, '2015-04-01 00:55:54.000000', 'consum', 0.0217, 'lps'),
	(471933, 124, '2015-04-01 00:55:55.000000', 'consum', 0.0219, 'lps'),
	(471934, 124, '2015-04-01 00:55:56.000000', 'consum', 0.0234, 'lps'),
	(471935, 124, '2015-04-01 00:55:57.000000', 'consum', 0.0226, 'lps'),
	(471936, 124, '2015-04-01 00:55:58.000000', 'consum', 0.0219, 'lps'),
	(471937, 124, '2015-04-01 00:55:59.000000', 'consum', 0.0235, 'lps'),
	(471938, 124, '2015-04-01 00:56:00.000000', 'consum', 0.0227, 'lps'),
	(471939, 124, '2015-04-01 00:56:01.000000', 'consum', 0.0223, 'lps'),
	(471940, 124, '2015-04-01 00:56:02.000000', 'consum', 0.0224, 'lps'),
	(471941, 124, '2015-04-01 00:56:03.000000', 'consum', 0.0216, 'lps'),
	(471942, 124, '2015-04-01 00:56:04.000000', 'consum', 0.0224, 'lps'),
	(471943, 124, '2015-04-01 00:56:05.000000', 'consum', 0.0212, 'lps'),
	(471944, 124, '2015-04-01 00:56:06.000000', 'consum', 0.0230, 'lps'),
	(471945, 124, '2015-04-01 00:56:07.000000', 'consum', 0.0227, 'lps'),
	(471946, 124, '2015-04-01 00:56:08.000000', 'consum', 0.0234, 'lps'),
	(471947, 124, '2015-04-01 00:56:09.000000', 'consum', 0.0227, 'lps'),
	(471948, 124, '2015-04-01 00:56:10.000000', 'consum', 0.0226, 'lps'),
	(471949, 124, '2015-04-01 00:56:11.000000', 'consum', 0.0212, 'lps'),
	(471950, 124, '2015-04-01 00:56:12.000000', 'consum', 0.0226, 'lps'),
	(471951, 124, '2015-04-01 00:56:13.000000', 'consum', 0.0233, 'lps'),
	(471952, 124, '2015-04-01 00:56:14.000000', 'consum', 0.0224, 'lps'),
	(471953, 124, '2015-04-01 00:56:15.000000', 'consum', 0.0213, 'lps'),
	(471954, 124, '2015-04-01 00:56:16.000000', 'consum', 0.0210, 'lps'),
	(471955, 124, '2015-04-01 00:56:17.000000', 'consum', 0.0225, 'lps'),
	(471956, 124, '2015-04-01 00:56:18.000000', 'consum', 0.0210, 'lps'),
	(471957, 124, '2015-04-01 00:56:19.000000', 'consum', 0.0216, 'lps'),
	(471958, 124, '2015-04-01 00:56:20.000000', 'consum', 0.0216, 'lps'),
	(471959, 124, '2015-04-01 00:56:21.000000', 'consum', 0.0223, 'lps'),
	(471960, 124, '2015-04-01 00:56:22.000000', 'consum', 0.0232, 'lps'),
	(471961, 124, '2015-04-01 00:56:23.000000', 'consum', 0.0228, 'lps'),
	(471962, 124, '2015-04-01 00:56:24.000000', 'consum', 0.0233, 'lps'),
	(471963, 124, '2015-04-01 00:56:25.000000', 'consum', 0.0221, 'lps'),
	(471964, 124, '2015-04-01 00:56:26.000000', 'consum', 0.0223, 'lps'),
	(471965, 124, '2015-04-01 00:56:27.000000', 'consum', 0.0217, 'lps'),
	(471966, 124, '2015-04-01 00:56:28.000000', 'consum', 0.0230, 'lps'),
	(471967, 124, '2015-04-01 00:56:29.000000', 'consum', 0.0214, 'lps'),
	(471968, 124, '2015-04-01 00:56:30.000000', 'consum', 0.0221, 'lps'),
	(471969, 124, '2015-04-01 00:56:31.000000', 'consum', 0.0227, 'lps'),
	(471970, 124, '2015-04-01 00:56:32.000000', 'consum', 0.0212, 'lps'),
	(471971, 124, '2015-04-01 00:56:33.000000', 'consum', 0.0222, 'lps'),
	(471972, 124, '2015-04-01 00:56:34.000000', 'consum', 0.0213, 'lps'),
	(471973, 124, '2015-04-01 00:56:35.000000', 'consum', 0.0215, 'lps'),
	(471974, 124, '2015-04-01 00:56:36.000000', 'consum', 0.0226, 'lps'),
	(471975, 124, '2015-04-01 00:56:37.000000', 'consum', 0.0225, 'lps'),
	(471976, 124, '2015-04-01 00:56:38.000000', 'consum', 0.0235, 'lps'),
	(471977, 124, '2015-04-01 00:56:39.000000', 'consum', 0.0212, 'lps'),
	(471978, 124, '2015-04-01 00:56:40.000000', 'consum', 0.0223, 'lps'),
	(471979, 124, '2015-04-01 00:56:41.000000', 'consum', 0.0219, 'lps'),
	(471980, 124, '2015-04-01 00:56:42.000000', 'consum', 0.0215, 'lps'),
	(471981, 124, '2015-04-01 00:56:43.000000', 'consum', 0.0233, 'lps'),
	(471982, 124, '2015-04-01 00:56:44.000000', 'consum', 0.0235, 'lps'),
	(471983, 124, '2015-04-01 00:56:45.000000', 'consum', 0.0216, 'lps'),
	(471984, 124, '2015-04-01 00:56:46.000000', 'consum', 0.0214, 'lps'),
	(471985, 124, '2015-04-01 00:56:47.000000', 'consum', 0.0215, 'lps'),
	(471986, 124, '2015-04-01 00:56:48.000000', 'consum', 0.0221, 'lps'),
	(471987, 124, '2015-04-01 00:56:49.000000', 'consum', 0.0225, 'lps'),
	(471988, 124, '2015-04-01 00:56:50.000000', 'consum', 0.0229, 'lps'),
	(471989, 124, '2015-04-01 00:56:51.000000', 'consum', 0.0233, 'lps'),
	(471990, 124, '2015-04-01 00:56:52.000000', 'consum', 0.0216, 'lps'),
	(471991, 124, '2015-04-01 00:56:53.000000', 'consum', 0.0224, 'lps'),
	(471992, 124, '2015-04-01 00:56:54.000000', 'consum', 0.0235, 'lps'),
	(471993, 124, '2015-04-01 00:56:55.000000', 'consum', 0.0214, 'lps'),
	(471994, 124, '2015-04-01 00:56:56.000000', 'consum', 0.0211, 'lps'),
	(471995, 124, '2015-04-01 00:56:57.000000', 'consum', 0.0230, 'lps'),
	(471996, 124, '2015-04-01 00:56:58.000000', 'consum', 0.0227, 'lps'),
	(471997, 124, '2015-04-01 00:56:59.000000', 'consum', 0.0212, 'lps'),
	(471998, 124, '2015-04-01 00:57:00.000000', 'consum', 0.0221, 'lps'),
	(471999, 124, '2015-04-01 00:57:01.000000', 'consum', 0.0234, 'lps'),
	(472000, 124, '2015-04-01 00:57:02.000000', 'consum', 0.0217, 'lps'),
	(472001, 124, '2015-04-01 00:57:03.000000', 'consum', 0.0228, 'lps'),
	(472002, 124, '2015-04-01 00:57:04.000000', 'consum', 0.0228, 'lps'),
	(472003, 124, '2015-04-01 00:57:05.000000', 'consum', 0.0219, 'lps'),
	(472004, 124, '2015-04-01 00:57:06.000000', 'consum', 0.0228, 'lps'),
	(472005, 124, '2015-04-01 00:57:07.000000', 'consum', 0.0219, 'lps'),
	(472006, 124, '2015-04-01 00:57:08.000000', 'consum', 0.0230, 'lps'),
	(472007, 124, '2015-04-01 00:57:09.000000', 'consum', 0.0233, 'lps'),
	(472008, 124, '2015-04-01 00:57:10.000000', 'consum', 0.0211, 'lps'),
	(472009, 124, '2015-04-01 00:57:11.000000', 'consum', 0.0225, 'lps'),
	(472010, 124, '2015-04-01 00:57:12.000000', 'consum', 0.0230, 'lps'),
	(472011, 124, '2015-04-01 00:57:13.000000', 'consum', 0.0213, 'lps'),
	(472012, 124, '2015-04-01 00:57:14.000000', 'consum', 0.0217, 'lps'),
	(472013, 124, '2015-04-01 00:57:15.000000', 'consum', 0.0210, 'lps'),
	(472014, 124, '2015-04-01 00:57:16.000000', 'consum', 0.0217, 'lps'),
	(472015, 124, '2015-04-01 00:57:17.000000', 'consum', 0.0220, 'lps'),
	(472016, 124, '2015-04-01 00:57:18.000000', 'consum', 0.0213, 'lps'),
	(472017, 124, '2015-04-01 00:57:19.000000', 'consum', 0.0222, 'lps'),
	(472018, 124, '2015-04-01 00:57:20.000000', 'consum', 0.0211, 'lps'),
	(472019, 124, '2015-04-01 00:57:21.000000', 'consum', 0.0228, 'lps'),
	(472020, 124, '2015-04-01 00:57:22.000000', 'consum', 0.0222, 'lps'),
	(472021, 124, '2015-04-01 00:57:23.000000', 'consum', 0.0216, 'lps'),
	(472022, 124, '2015-04-01 00:57:24.000000', 'consum', 0.0232, 'lps'),
	(472023, 124, '2015-04-01 00:57:25.000000', 'consum', 0.0224, 'lps'),
	(472024, 124, '2015-04-01 00:57:26.000000', 'consum', 0.0213, 'lps'),
	(472025, 124, '2015-04-01 00:57:27.000000', 'consum', 0.0212, 'lps'),
	(472026, 124, '2015-04-01 00:57:28.000000', 'consum', 0.0235, 'lps'),
	(472027, 124, '2015-04-01 00:57:29.000000', 'consum', 0.0228, 'lps'),
	(472028, 124, '2015-04-01 00:57:30.000000', 'consum', 0.0224, 'lps'),
	(472029, 124, '2015-04-01 00:57:31.000000', 'consum', 0.0227, 'lps'),
	(472030, 124, '2015-04-01 00:57:32.000000', 'consum', 0.0229, 'lps'),
	(472031, 124, '2015-04-01 00:57:33.000000', 'consum', 0.0226, 'lps'),
	(472032, 124, '2015-04-01 00:57:34.000000', 'consum', 0.0235, 'lps'),
	(472033, 124, '2015-04-01 00:57:35.000000', 'consum', 0.0235, 'lps'),
	(472034, 124, '2015-04-01 00:57:36.000000', 'consum', 0.0233, 'lps'),
	(472035, 124, '2015-04-01 00:57:37.000000', 'consum', 0.0225, 'lps'),
	(472036, 124, '2015-04-01 00:57:38.000000', 'consum', 0.0219, 'lps'),
	(472037, 124, '2015-04-01 00:57:39.000000', 'consum', 0.0235, 'lps'),
	(472038, 124, '2015-04-01 00:57:40.000000', 'consum', 0.0231, 'lps'),
	(472039, 124, '2015-04-01 00:57:41.000000', 'consum', 0.0215, 'lps'),
	(472040, 124, '2015-04-01 00:57:42.000000', 'consum', 0.0225, 'lps'),
	(472041, 124, '2015-04-01 00:57:43.000000', 'consum', 0.0218, 'lps'),
	(472042, 124, '2015-04-01 00:57:44.000000', 'consum', 0.0230, 'lps'),
	(472043, 124, '2015-04-01 00:57:45.000000', 'consum', 0.0211, 'lps'),
	(472044, 124, '2015-04-01 00:57:46.000000', 'consum', 0.0232, 'lps'),
	(472045, 124, '2015-04-01 00:57:47.000000', 'consum', 0.0212, 'lps'),
	(472046, 124, '2015-04-01 00:57:48.000000', 'consum', 0.0235, 'lps'),
	(472047, 124, '2015-04-01 00:57:49.000000', 'consum', 0.0226, 'lps'),
	(472048, 124, '2015-04-01 00:57:50.000000', 'consum', 0.0213, 'lps'),
	(472049, 124, '2015-04-01 00:57:51.000000', 'consum', 0.0231, 'lps'),
	(472050, 124, '2015-04-01 00:57:52.000000', 'consum', 0.0226, 'lps'),
	(472051, 124, '2015-04-01 00:57:53.000000', 'consum', 0.0231, 'lps'),
	(472052, 124, '2015-04-01 00:57:54.000000', 'consum', 0.0213, 'lps'),
	(472053, 124, '2015-04-01 00:57:55.000000', 'consum', 0.0214, 'lps'),
	(472054, 124, '2015-04-01 00:57:56.000000', 'consum', 0.0221, 'lps'),
	(472055, 124, '2015-04-01 00:57:57.000000', 'consum', 0.0228, 'lps'),
	(472056, 124, '2015-04-01 00:57:58.000000', 'consum', 0.0214, 'lps'),
	(472057, 124, '2015-04-01 00:57:59.000000', 'consum', 0.0230, 'lps'),
	(472058, 124, '2015-04-01 00:58:00.000000', 'consum', 0.0222, 'lps'),
	(472059, 124, '2015-04-01 00:58:01.000000', 'consum', 0.0234, 'lps'),
	(472060, 124, '2015-04-01 00:58:02.000000', 'consum', 0.0217, 'lps'),
	(472061, 124, '2015-04-01 00:58:03.000000', 'consum', 0.0224, 'lps'),
	(472062, 124, '2015-04-01 00:58:04.000000', 'consum', 0.0234, 'lps'),
	(472063, 124, '2015-04-01 00:58:05.000000', 'consum', 0.0212, 'lps'),
	(472064, 124, '2015-04-01 00:58:06.000000', 'consum', 0.0226, 'lps'),
	(472065, 124, '2015-04-01 00:58:07.000000', 'consum', 0.0233, 'lps'),
	(472066, 124, '2015-04-01 00:58:08.000000', 'consum', 0.0224, 'lps'),
	(472067, 124, '2015-04-01 00:58:09.000000', 'consum', 0.0213, 'lps'),
	(472068, 124, '2015-04-01 00:58:10.000000', 'consum', 0.0210, 'lps'),
	(472069, 124, '2015-04-01 00:58:11.000000', 'consum', 0.0226, 'lps'),
	(472070, 124, '2015-04-01 00:58:12.000000', 'consum', 0.0211, 'lps'),
	(472071, 124, '2015-04-01 00:58:13.000000', 'consum', 0.0221, 'lps'),
	(472072, 124, '2015-04-01 00:58:14.000000', 'consum', 0.0212, 'lps'),
	(472073, 124, '2015-04-01 00:58:15.000000', 'consum', 0.0214, 'lps'),
	(472074, 124, '2015-04-01 00:58:16.000000', 'consum', 0.0222, 'lps'),
	(472075, 124, '2015-04-01 00:58:17.000000', 'consum', 0.0235, 'lps'),
	(472076, 124, '2015-04-01 00:58:18.000000', 'consum', 0.0219, 'lps'),
	(472077, 124, '2015-04-01 00:58:19.000000', 'consum', 0.0233, 'lps'),
	(472078, 124, '2015-04-01 00:58:20.000000', 'consum', 0.0219, 'lps'),
	(472079, 124, '2015-04-01 00:58:21.000000', 'consum', 0.0216, 'lps'),
	(472080, 124, '2015-04-01 00:58:22.000000', 'consum', 0.0210, 'lps'),
	(472081, 124, '2015-04-01 00:58:23.000000', 'consum', 0.0220, 'lps'),
	(472082, 124, '2015-04-01 00:58:24.000000', 'consum', 0.0233, 'lps'),
	(472083, 124, '2015-04-01 00:58:25.000000', 'consum', 0.0218, 'lps'),
	(472084, 124, '2015-04-01 00:58:26.000000', 'consum', 0.0233, 'lps'),
	(472085, 124, '2015-04-01 00:58:27.000000', 'consum', 0.0224, 'lps'),
	(472086, 124, '2015-04-01 00:58:28.000000', 'consum', 0.0211, 'lps'),
	(472087, 124, '2015-04-01 00:58:29.000000', 'consum', 0.0224, 'lps'),
	(472088, 124, '2015-04-01 00:58:30.000000', 'consum', 0.0227, 'lps'),
	(472089, 124, '2015-04-01 00:58:31.000000', 'consum', 0.0228, 'lps'),
	(472090, 124, '2015-04-01 00:58:32.000000', 'consum', 0.0225, 'lps'),
	(472091, 124, '2015-04-01 00:58:33.000000', 'consum', 0.0229, 'lps'),
	(472092, 124, '2015-04-01 00:58:34.000000', 'consum', 0.0211, 'lps'),
	(472093, 124, '2015-04-01 00:58:35.000000', 'consum', 0.0235, 'lps'),
	(472094, 124, '2015-04-01 00:58:36.000000', 'consum', 0.0227, 'lps'),
	(472095, 124, '2015-04-01 00:58:37.000000', 'consum', 0.0221, 'lps'),
	(472096, 124, '2015-04-01 00:58:38.000000', 'consum', 0.0216, 'lps'),
	(472097, 124, '2015-04-01 00:58:39.000000', 'consum', 0.0232, 'lps'),
	(472098, 124, '2015-04-01 00:58:40.000000', 'consum', 0.0225, 'lps'),
	(472099, 124, '2015-04-01 00:58:41.000000', 'consum', 0.0219, 'lps'),
	(472100, 124, '2015-04-01 00:58:42.000000', 'consum', 0.0210, 'lps'),
	(472101, 124, '2015-04-01 00:58:43.000000', 'consum', 0.0235, 'lps'),
	(472102, 124, '2015-04-01 00:58:44.000000', 'consum', 0.0234, 'lps'),
	(472103, 124, '2015-04-01 00:58:45.000000', 'consum', 0.0229, 'lps'),
	(472104, 124, '2015-04-01 00:58:46.000000', 'consum', 0.0233, 'lps'),
	(472105, 124, '2015-04-01 00:58:47.000000', 'consum', 0.0219, 'lps'),
	(472106, 124, '2015-04-01 00:58:48.000000', 'consum', 0.0235, 'lps'),
	(472107, 124, '2015-04-01 00:58:49.000000', 'consum', 0.0233, 'lps'),
	(472108, 124, '2015-04-01 00:58:50.000000', 'consum', 0.0223, 'lps'),
	(472109, 124, '2015-04-01 00:58:51.000000', 'consum', 0.0231, 'lps'),
	(472110, 124, '2015-04-01 00:58:52.000000', 'consum', 0.0226, 'lps'),
	(472111, 124, '2015-04-01 00:58:53.000000', 'consum', 0.0228, 'lps'),
	(472112, 124, '2015-04-01 00:58:54.000000', 'consum', 0.0228, 'lps'),
	(472113, 124, '2015-04-01 00:58:55.000000', 'consum', 0.0218, 'lps'),
	(472114, 124, '2015-04-01 00:58:56.000000', 'consum', 0.0222, 'lps'),
	(472115, 124, '2015-04-01 00:58:57.000000', 'consum', 0.0219, 'lps'),
	(472116, 124, '2015-04-01 00:58:58.000000', 'consum', 0.0223, 'lps'),
	(472117, 124, '2015-04-01 00:58:59.000000', 'consum', 0.0219, 'lps'),
	(472118, 124, '2015-04-01 00:59:00.000000', 'consum', 0.0219, 'lps'),
	(472119, 124, '2015-04-01 00:59:01.000000', 'consum', 0.0226, 'lps'),
	(472120, 124, '2015-04-01 00:59:02.000000', 'consum', 0.0215, 'lps'),
	(472121, 124, '2015-04-01 00:59:03.000000', 'consum', 0.0212, 'lps'),
	(472122, 124, '2015-04-01 00:59:04.000000', 'consum', 0.0230, 'lps'),
	(472123, 124, '2015-04-01 00:59:05.000000', 'consum', 0.0227, 'lps'),
	(472124, 124, '2015-04-01 00:59:06.000000', 'consum', 0.0212, 'lps'),
	(472125, 124, '2015-04-01 00:59:07.000000', 'consum', 0.0218, 'lps'),
	(472126, 124, '2015-04-01 00:59:08.000000', 'consum', 0.0220, 'lps'),
	(472127, 124, '2015-04-01 00:59:09.000000', 'consum', 0.0212, 'lps'),
	(472128, 124, '2015-04-01 00:59:10.000000', 'consum', 0.0216, 'lps'),
	(472129, 124, '2015-04-01 00:59:11.000000', 'consum', 0.0235, 'lps'),
	(472130, 124, '2015-04-01 00:59:12.000000', 'consum', 0.0214, 'lps'),
	(472131, 124, '2015-04-01 00:59:13.000000', 'consum', 0.0233, 'lps'),
	(472132, 124, '2015-04-01 00:59:14.000000', 'consum', 0.0234, 'lps'),
	(472133, 124, '2015-04-01 00:59:15.000000', 'consum', 0.0212, 'lps'),
	(472134, 124, '2015-04-01 00:59:16.000000', 'consum', 0.0225, 'lps'),
	(472135, 124, '2015-04-01 00:59:17.000000', 'consum', 0.0226, 'lps'),
	(472136, 124, '2015-04-01 00:59:18.000000', 'consum', 0.0222, 'lps'),
	(472137, 124, '2015-04-01 00:59:19.000000', 'consum', 0.0220, 'lps'),
	(472138, 124, '2015-04-01 00:59:20.000000', 'consum', 0.0225, 'lps'),
	(472139, 124, '2015-04-01 00:59:21.000000', 'consum', 0.0229, 'lps'),
	(472140, 124, '2015-04-01 00:59:22.000000', 'consum', 0.0233, 'lps'),
	(472141, 124, '2015-04-01 00:59:23.000000', 'consum', 0.0219, 'lps'),
	(472142, 124, '2015-04-01 00:59:24.000000', 'consum', 0.0210, 'lps'),
	(472143, 124, '2015-04-01 00:59:25.000000', 'consum', 0.0210, 'lps'),
	(472144, 124, '2015-04-01 00:59:26.000000', 'consum', 0.0210, 'lps'),
	(472145, 124, '2015-04-01 00:59:27.000000', 'consum', 0.0210, 'lps'),
	(472146, 124, '2015-04-01 00:59:28.000000', 'consum', 0.0210, 'lps'),
	(472147, 124, '2015-04-01 00:59:29.000000', 'consum', 0.0210, 'lps'),
	(472148, 124, '2015-04-01 00:59:30.000000', 'consum', 0.0211, 'lps'),
	(472149, 124, '2015-04-01 00:59:31.000000', 'consum', 0.0216, 'lps'),
	(472150, 124, '2015-04-01 00:59:32.000000', 'consum', 0.0212, 'lps'),
	(472151, 124, '2015-04-01 00:59:33.000000', 'consum', 0.0228, 'lps'),
	(472152, 124, '2015-04-01 00:59:34.000000', 'consum', 0.0216, 'lps'),
	(472153, 124, '2015-04-01 00:59:35.000000', 'consum', 0.0212, 'lps'),
	(472154, 124, '2015-04-01 00:59:36.000000', 'consum', 0.0230, 'lps'),
	(472155, 124, '2015-04-01 00:59:37.000000', 'consum', 0.0225, 'lps'),
	(472156, 124, '2015-04-01 00:59:38.000000', 'consum', 0.0228, 'lps'),
	(472157, 124, '2015-04-01 00:59:39.000000', 'consum', 0.0228, 'lps'),
	(472158, 124, '2015-04-01 00:59:40.000000', 'consum', 0.0220, 'lps'),
	(472159, 124, '2015-04-01 00:59:41.000000', 'consum', 0.0232, 'lps'),
	(472160, 124, '2015-04-01 00:59:42.000000', 'consum', 0.0215, 'lps'),
	(472161, 124, '2015-04-01 00:59:43.000000', 'consum', 0.0220, 'lps'),
	(472162, 124, '2015-04-01 00:59:44.000000', 'consum', 0.0218, 'lps'),
	(472163, 124, '2015-04-01 00:59:45.000000', 'consum', 0.0222, 'lps'),
	(472164, 124, '2015-04-01 00:59:46.000000', 'consum', 0.0222, 'lps'),
	(472165, 124, '2015-04-01 00:59:47.000000', 'consum', 0.0232, 'lps'),
	(472166, 124, '2015-04-01 00:59:48.000000', 'consum', 0.0233, 'lps'),
	(472167, 124, '2015-04-01 00:59:49.000000', 'consum', 0.0210, 'lps'),
	(472168, 124, '2015-04-01 00:59:50.000000', 'consum', 0.0216, 'lps'),
	(472169, 124, '2015-04-01 00:59:51.000000', 'consum', 0.0217, 'lps'),
	(472170, 124, '2015-04-01 00:59:52.000000', 'consum', 0.0225, 'lps'),
	(472171, 124, '2015-04-01 00:59:53.000000', 'consum', 0.0215, 'lps'),
	(472172, 124, '2015-04-01 00:59:54.000000', 'consum', 0.0216, 'lps'),
	(472173, 124, '2015-04-01 00:59:55.000000', 'consum', 0.0226, 'lps'),
	(472174, 124, '2015-04-01 00:59:56.000000', 'consum', 0.0220, 'lps'),
	(472175, 124, '2015-04-01 00:59:57.000000', 'consum', 0.0211, 'lps'),
	(472176, 124, '2015-04-01 00:59:58.000000', 'consum', 0.0212, 'lps'),
	(472177, 124, '2015-04-01 00:59:59.000000', 'consum', 0.0220, 'lps'),
	(472178, 124, '2015-04-01 01:00:00.000000', 'consum', 0.0225, 'lps'),
	(472179, 124, '2015-04-01 01:00:01.000000', 'consum', 0.0231, 'lps'),
	(472180, 124, '2015-04-01 01:00:02.000000', 'consum', 0.0220, 'lps'),
	(472181, 124, '2015-04-01 01:00:03.000000', 'consum', 0.0222, 'lps'),
	(472182, 124, '2015-04-01 01:00:04.000000', 'consum', 0.0213, 'lps'),
	(472183, 124, '2015-04-01 01:00:05.000000', 'consum', 0.0217, 'lps'),
	(472184, 124, '2015-04-01 01:00:06.000000', 'consum', 0.0212, 'lps'),
	(472185, 124, '2015-04-01 01:00:07.000000', 'consum', 0.0222, 'lps'),
	(472186, 124, '2015-04-01 01:00:08.000000', 'consum', 0.0216, 'lps'),
	(472187, 124, '2015-04-01 01:00:09.000000', 'consum', 0.0230, 'lps'),
	(472188, 124, '2015-04-01 01:00:10.000000', 'consum', 0.0215, 'lps'),
	(472189, 124, '2015-04-01 01:00:11.000000', 'consum', 0.0228, 'lps'),
	(472190, 124, '2015-04-01 01:00:12.000000', 'consum', 0.0234, 'lps'),
	(472191, 124, '2015-04-01 01:00:13.000000', 'consum', 0.0223, 'lps'),
	(472192, 124, '2015-04-01 01:00:14.000000', 'consum', 0.0230, 'lps'),
	(472193, 124, '2015-04-01 01:00:15.000000', 'consum', 0.0217, 'lps'),
	(472194, 124, '2015-04-01 01:00:16.000000', 'consum', 0.0215, 'lps'),
	(472195, 124, '2015-04-01 01:00:17.000000', 'consum', 0.0214, 'lps'),
	(472196, 124, '2015-04-01 01:00:18.000000', 'consum', 0.0217, 'lps'),
	(472197, 124, '2015-04-01 01:00:19.000000', 'consum', 0.0230, 'lps'),
	(472198, 124, '2015-04-01 01:00:20.000000', 'consum', 0.0215, 'lps'),
	(472199, 124, '2015-04-01 01:00:21.000000', 'consum', 0.0225, 'lps'),
	(472200, 124, '2015-04-01 01:00:22.000000', 'consum', 0.0220, 'lps'),
	(472201, 124, '2015-04-01 01:00:23.000000', 'consum', 0.0214, 'lps'),
	(472202, 124, '2015-04-01 01:00:24.000000', 'consum', 0.0228, 'lps'),
	(472203, 124, '2015-04-01 01:00:25.000000', 'consum', 0.0212, 'lps'),
	(472204, 124, '2015-04-01 01:00:26.000000', 'consum', 0.0216, 'lps'),
	(472205, 124, '2015-04-01 01:00:27.000000', 'consum', 0.0233, 'lps'),
	(472206, 124, '2015-04-01 01:00:28.000000', 'consum', 0.0231, 'lps'),
	(472207, 124, '2015-04-01 01:00:29.000000', 'consum', 0.0222, 'lps'),
	(472208, 124, '2015-04-01 01:00:30.000000', 'consum', 0.0235, 'lps'),
	(472209, 124, '2015-04-01 01:00:31.000000', 'consum', 0.0218, 'lps'),
	(472210, 124, '2015-04-01 01:00:32.000000', 'consum', 0.0227, 'lps'),
	(472211, 124, '2015-04-01 01:00:33.000000', 'consum', 0.0222, 'lps'),
	(472212, 124, '2015-04-01 01:00:34.000000', 'consum', 0.0217, 'lps'),
	(472213, 124, '2015-04-01 01:00:35.000000', 'consum', 0.0234, 'lps'),
	(472214, 124, '2015-04-01 01:00:36.000000', 'consum', 0.0235, 'lps'),
	(472215, 124, '2015-04-01 01:00:37.000000', 'consum', 0.0212, 'lps'),
	(472216, 124, '2015-04-01 01:00:38.000000', 'consum', 0.0221, 'lps'),
	(472217, 124, '2015-04-01 01:00:39.000000', 'consum', 0.0234, 'lps'),
	(472218, 124, '2015-04-01 01:00:40.000000', 'consum', 0.0220, 'lps'),
	(472219, 124, '2015-04-01 01:00:41.000000', 'consum', 0.0213, 'lps'),
	(472220, 124, '2015-04-01 01:00:42.000000', 'consum', 0.0224, 'lps'),
	(472221, 124, '2015-04-01 01:00:43.000000', 'consum', 0.0218, 'lps'),
	(472222, 124, '2015-04-01 01:00:44.000000', 'consum', 0.0234, 'lps'),
	(472223, 124, '2015-04-01 01:00:45.000000', 'consum', 0.0229, 'lps'),
	(472224, 124, '2015-04-01 01:00:46.000000', 'consum', 0.0233, 'lps'),
	(472225, 124, '2015-04-01 01:00:47.000000', 'consum', 0.0217, 'lps'),
	(472226, 124, '2015-04-01 01:00:48.000000', 'consum', 0.0228, 'lps'),
	(472227, 124, '2015-04-01 01:00:49.000000', 'consum', 0.0227, 'lps'),
	(472228, 124, '2015-04-01 01:00:50.000000', 'consum', 0.0214, 'lps'),
	(472229, 124, '2015-04-01 01:00:51.000000', 'consum', 0.0233, 'lps'),
	(472230, 124, '2015-04-01 01:00:52.000000', 'consum', 0.0234, 'lps'),
	(472231, 124, '2015-04-01 01:00:53.000000', 'consum', 0.0211, 'lps'),
	(472232, 124, '2015-04-01 01:00:54.000000', 'consum', 0.0220, 'lps'),
	(472233, 124, '2015-04-01 01:00:55.000000', 'consum', 0.0232, 'lps'),
	(472234, 124, '2015-04-01 01:00:56.000000', 'consum', 0.0211, 'lps'),
	(472235, 124, '2015-04-01 01:00:57.000000', 'consum', 0.0227, 'lps'),
	(472236, 124, '2015-04-01 01:00:58.000000', 'consum', 0.0215, 'lps'),
	(472237, 124, '2015-04-01 01:00:59.000000', 'consum', 0.0211, 'lps'),
	(472238, 124, '2015-04-01 01:01:00.000000', 'consum', 0.0225, 'lps'),
	(472239, 124, '2015-04-01 01:01:01.000000', 'consum', 0.0231, 'lps'),
	(472240, 124, '2015-04-01 01:01:02.000000', 'consum', 0.0221, 'lps'),
	(472241, 124, '2015-04-01 01:01:03.000000', 'consum', 0.0226, 'lps'),
	(472242, 124, '2015-04-01 01:01:04.000000', 'consum', 0.0232, 'lps'),
	(472243, 124, '2015-04-01 01:01:05.000000', 'consum', 0.0221, 'lps'),
	(472244, 124, '2015-04-01 01:01:06.000000', 'consum', 0.0226, 'lps'),
	(472245, 124, '2015-04-01 01:01:07.000000', 'consum', 0.0229, 'lps'),
	(472246, 124, '2015-04-01 01:01:08.000000', 'consum', 0.0234, 'lps'),
	(472247, 124, '2015-04-01 01:01:09.000000', 'consum', 0.0219, 'lps'),
	(472248, 124, '2015-04-01 01:01:10.000000', 'consum', 0.0235, 'lps'),
	(472249, 124, '2015-04-01 01:01:11.000000', 'consum', 0.0233, 'lps'),
	(472250, 124, '2015-04-01 01:01:12.000000', 'consum', 0.0224, 'lps'),
	(472251, 124, '2015-04-01 01:01:13.000000', 'consum', 0.0213, 'lps'),
	(472252, 124, '2015-04-01 01:01:14.000000', 'consum', 0.0235, 'lps'),
	(472253, 124, '2015-04-01 01:01:15.000000', 'consum', 0.0223, 'lps'),
	(472254, 124, '2015-04-01 01:01:16.000000', 'consum', 0.0224, 'lps'),
	(472255, 124, '2015-04-01 01:01:17.000000', 'consum', 0.0218, 'lps'),
	(472256, 124, '2015-04-01 01:01:18.000000', 'consum', 0.0232, 'lps'),
	(472257, 124, '2015-04-01 01:01:19.000000', 'consum', 0.0220, 'lps'),
	(472258, 124, '2015-04-01 01:01:20.000000', 'consum', 0.0221, 'lps'),
	(472259, 124, '2015-04-01 01:01:21.000000', 'consum', 0.0210, 'lps'),
	(472260, 124, '2015-04-01 01:01:22.000000', 'consum', 0.0231, 'lps'),
	(472261, 124, '2015-04-01 01:01:23.000000', 'consum', 0.0235, 'lps'),
	(472262, 124, '2015-04-01 01:01:24.000000', 'consum', 0.0220, 'lps'),
	(472263, 124, '2015-04-01 01:01:25.000000', 'consum', 0.0211, 'lps'),
	(472264, 124, '2015-04-01 01:01:26.000000', 'consum', 0.0214, 'lps'),
	(472265, 124, '2015-04-01 01:01:27.000000', 'consum', 0.0225, 'lps'),
	(472266, 124, '2015-04-01 01:01:28.000000', 'consum', 0.0221, 'lps'),
	(472267, 124, '2015-04-01 01:01:29.000000', 'consum', 0.0221, 'lps'),
	(472268, 124, '2015-04-01 01:01:30.000000', 'consum', 0.0235, 'lps'),
	(472269, 124, '2015-04-01 01:01:31.000000', 'consum', 0.0222, 'lps'),
	(472270, 124, '2015-04-01 01:01:32.000000', 'consum', 0.0222, 'lps'),
	(472271, 124, '2015-04-01 01:01:33.000000', 'consum', 0.0210, 'lps'),
	(472272, 124, '2015-04-01 01:01:34.000000', 'consum', 0.0225, 'lps'),
	(472273, 124, '2015-04-01 01:01:35.000000', 'consum', 0.0235, 'lps'),
	(472274, 124, '2015-04-01 01:01:36.000000', 'consum', 0.0210, 'lps'),
	(472275, 124, '2015-04-01 01:01:37.000000', 'consum', 0.0217, 'lps'),
	(472276, 124, '2015-04-01 01:01:38.000000', 'consum', 0.0216, 'lps'),
	(472277, 124, '2015-04-01 01:01:39.000000', 'consum', 0.0220, 'lps'),
	(472278, 124, '2015-04-01 01:01:40.000000', 'consum', 0.0217, 'lps'),
	(472279, 124, '2015-04-01 01:01:41.000000', 'consum', 0.0217, 'lps'),
	(472280, 124, '2015-04-01 01:01:42.000000', 'consum', 0.0224, 'lps'),
	(472281, 124, '2015-04-01 01:01:43.000000', 'consum', 0.0231, 'lps'),
	(472282, 124, '2015-04-01 01:01:44.000000', 'consum', 0.0225, 'lps'),
	(472283, 124, '2015-04-01 01:01:45.000000', 'consum', 0.0221, 'lps'),
	(472284, 124, '2015-04-01 01:01:46.000000', 'consum', 0.0222, 'lps'),
	(472285, 124, '2015-04-01 01:01:47.000000', 'consum', 0.0212, 'lps'),
	(472286, 124, '2015-04-01 01:01:48.000000', 'consum', 0.0210, 'lps'),
	(472287, 124, '2015-04-01 01:01:49.000000', 'consum', 0.0230, 'lps'),
	(472288, 124, '2015-04-01 01:01:50.000000', 'consum', 0.0234, 'lps'),
	(472289, 124, '2015-04-01 01:01:51.000000', 'consum', 0.0218, 'lps'),
	(472290, 124, '2015-04-01 01:01:52.000000', 'consum', 0.0232, 'lps'),
	(472291, 124, '2015-04-01 01:01:53.000000', 'consum', 0.0217, 'lps'),
	(472292, 124, '2015-04-01 01:01:54.000000', 'consum', 0.0233, 'lps'),
	(472293, 124, '2015-04-01 01:01:55.000000', 'consum', 0.0226, 'lps'),
	(472294, 124, '2015-04-01 01:01:56.000000', 'consum', 0.0223, 'lps'),
	(472295, 124, '2015-04-01 01:01:57.000000', 'consum', 0.0225, 'lps'),
	(472296, 124, '2015-04-01 01:01:58.000000', 'consum', 0.0221, 'lps'),
	(472297, 124, '2015-04-01 01:01:59.000000', 'consum', 0.0220, 'lps'),
	(472298, 124, '2015-04-01 01:02:00.000000', 'consum', 0.0227, 'lps'),
	(472299, 124, '2015-04-01 01:02:01.000000', 'consum', 0.0213, 'lps'),
	(472300, 124, '2015-04-01 01:02:02.000000', 'consum', 0.0229, 'lps'),
	(472301, 124, '2015-04-01 01:02:03.000000', 'consum', 0.0218, 'lps'),
	(472302, 124, '2015-04-01 01:02:04.000000', 'consum', 0.0218, 'lps'),
	(472303, 124, '2015-04-01 01:02:05.000000', 'consum', 0.0228, 'lps'),
	(472304, 124, '2015-04-01 01:02:06.000000', 'consum', 0.0225, 'lps'),
	(472305, 124, '2015-04-01 01:02:07.000000', 'consum', 0.0232, 'lps'),
	(472306, 124, '2015-04-01 01:02:08.000000', 'consum', 0.0221, 'lps'),
	(472307, 124, '2015-04-01 01:02:09.000000', 'consum', 0.0226, 'lps'),
	(472308, 124, '2015-04-01 01:02:10.000000', 'consum', 0.0231, 'lps'),
	(472309, 124, '2015-04-01 01:02:11.000000', 'consum', 0.0215, 'lps'),
	(472310, 124, '2015-04-01 01:02:12.000000', 'consum', 0.0225, 'lps'),
	(472311, 124, '2015-04-01 01:02:13.000000', 'consum', 0.0217, 'lps'),
	(472312, 124, '2015-04-01 01:02:14.000000', 'consum', 0.0228, 'lps'),
	(472313, 124, '2015-04-01 01:02:15.000000', 'consum', 0.0226, 'lps'),
	(472314, 124, '2015-04-01 01:02:16.000000', 'consum', 0.0212, 'lps'),
	(472315, 124, '2015-04-01 01:02:17.000000', 'consum', 0.0226, 'lps'),
	(472316, 124, '2015-04-01 01:02:18.000000', 'consum', 0.0231, 'lps'),
	(472317, 124, '2015-04-01 01:02:19.000000', 'consum', 0.0217, 'lps'),
	(472318, 124, '2015-04-01 01:02:20.000000', 'consum', 0.0234, 'lps'),
	(472319, 124, '2015-04-01 01:02:21.000000', 'consum', 0.0231, 'lps'),
	(472320, 124, '2015-04-01 01:02:22.000000', 'consum', 0.0219, 'lps'),
	(472321, 124, '2015-04-01 01:02:23.000000', 'consum', 0.0217, 'lps'),
	(472322, 124, '2015-04-01 01:02:24.000000', 'consum', 0.0219, 'lps'),
	(472323, 124, '2015-04-01 01:02:25.000000', 'consum', 0.0235, 'lps'),
	(472324, 124, '2015-04-01 01:02:26.000000', 'consum', 0.0228, 'lps'),
	(472325, 124, '2015-04-01 01:02:27.000000', 'consum', 0.0228, 'lps'),
	(472326, 124, '2015-04-01 01:02:28.000000', 'consum', 0.0220, 'lps'),
	(472327, 124, '2015-04-01 01:02:29.000000', 'consum', 0.0231, 'lps'),
	(472328, 124, '2015-04-01 01:02:30.000000', 'consum', 0.0210, 'lps'),
	(472329, 124, '2015-04-01 01:02:31.000000', 'consum', 0.0223, 'lps'),
	(472330, 124, '2015-04-01 01:02:32.000000', 'consum', 0.0224, 'lps'),
	(472331, 124, '2015-04-01 01:02:33.000000', 'consum', 0.0217, 'lps'),
	(472332, 124, '2015-04-01 01:02:34.000000', 'consum', 0.0227, 'lps'),
	(472333, 124, '2015-04-01 01:02:35.000000', 'consum', 0.0223, 'lps'),
	(472334, 124, '2015-04-01 01:02:36.000000', 'consum', 0.0225, 'lps'),
	(472335, 124, '2015-04-01 01:02:37.000000', 'consum', 0.0220, 'lps'),
	(472336, 124, '2015-04-01 01:02:38.000000', 'consum', 0.0216, 'lps'),
	(472337, 124, '2015-04-01 01:02:39.000000', 'consum', 0.0212, 'lps'),
	(472338, 124, '2015-04-01 01:02:40.000000', 'consum', 0.0227, 'lps'),
	(472339, 124, '2015-04-01 01:02:41.000000', 'consum', 0.0212, 'lps'),
	(472340, 124, '2015-04-01 01:02:42.000000', 'consum', 0.0220, 'lps'),
	(472341, 124, '2015-04-01 01:02:43.000000', 'consum', 0.0231, 'lps'),
	(472342, 124, '2015-04-01 01:02:44.000000', 'consum', 0.0231, 'lps'),
	(472343, 124, '2015-04-01 01:02:45.000000', 'consum', 0.0229, 'lps'),
	(472344, 124, '2015-04-01 01:02:46.000000', 'consum', 0.0216, 'lps'),
	(472345, 124, '2015-04-01 01:02:47.000000', 'consum', 0.0211, 'lps'),
	(472346, 124, '2015-04-01 01:02:48.000000', 'consum', 0.0222, 'lps'),
	(472347, 124, '2015-04-01 01:02:49.000000', 'consum', 0.0216, 'lps'),
	(472348, 124, '2015-04-01 01:02:50.000000', 'consum', 0.0232, 'lps'),
	(472349, 124, '2015-04-01 01:02:51.000000', 'consum', 0.0221, 'lps'),
	(472350, 124, '2015-04-01 01:02:52.000000', 'consum', 0.0228, 'lps'),
	(472351, 124, '2015-04-01 01:02:53.000000', 'consum', 0.0214, 'lps'),
	(472352, 124, '2015-04-01 01:02:54.000000', 'consum', 0.0230, 'lps'),
	(472353, 124, '2015-04-01 01:02:55.000000', 'consum', 0.0222, 'lps'),
	(472354, 124, '2015-04-01 01:02:56.000000', 'consum', 0.0233, 'lps'),
	(472355, 124, '2015-04-01 01:02:57.000000', 'consum', 0.0214, 'lps'),
	(472356, 124, '2015-04-01 01:02:58.000000', 'consum', 0.0211, 'lps'),
	(472357, 124, '2015-04-01 01:02:59.000000', 'consum', 0.0232, 'lps'),
	(472358, 124, '2015-04-01 01:03:00.000000', 'consum', 0.0211, 'lps'),
	(472359, 124, '2015-04-01 01:03:01.000000', 'consum', 0.0229, 'lps'),
	(472360, 124, '2015-04-01 01:03:02.000000', 'consum', 0.0226, 'lps'),
	(472361, 124, '2015-04-01 01:03:03.000000', 'consum', 0.0232, 'lps'),
	(472362, 124, '2015-04-01 01:03:04.000000', 'consum', 0.0221, 'lps'),
	(472363, 124, '2015-04-01 01:03:05.000000', 'consum', 0.0227, 'lps'),
	(472364, 124, '2015-04-01 01:03:06.000000', 'consum', 0.0210, 'lps'),
	(472365, 124, '2015-04-01 01:03:07.000000', 'consum', 0.0210, 'lps'),
	(472366, 124, '2015-04-01 01:03:08.000000', 'consum', 0.0212, 'lps'),
	(472367, 124, '2015-04-01 01:03:09.000000', 'consum', 0.0222, 'lps'),
	(472368, 124, '2015-04-01 01:03:10.000000', 'consum', 0.0211, 'lps'),
	(472369, 124, '2015-04-01 01:03:11.000000', 'consum', 0.0232, 'lps'),
	(472370, 124, '2015-04-01 01:03:12.000000', 'consum', 0.0213, 'lps'),
	(472371, 124, '2015-04-01 01:03:13.000000', 'consum', 0.0212, 'lps'),
	(472372, 124, '2015-04-01 01:03:14.000000', 'consum', 0.0213, 'lps'),
	(472373, 124, '2015-04-01 01:03:15.000000', 'consum', 0.0218, 'lps'),
	(472374, 124, '2015-04-01 01:03:16.000000', 'consum', 0.0217, 'lps'),
	(472375, 124, '2015-04-01 01:03:17.000000', 'consum', 0.0223, 'lps'),
	(472376, 124, '2015-04-01 01:03:18.000000', 'consum', 0.0226, 'lps'),
	(472377, 124, '2015-04-01 01:03:19.000000', 'consum', 0.0225, 'lps'),
	(472378, 124, '2015-04-01 01:03:20.000000', 'consum', 0.0211, 'lps'),
	(472379, 124, '2015-04-01 01:03:21.000000', 'consum', 0.0223, 'lps'),
	(472380, 124, '2015-04-01 01:03:22.000000', 'consum', 0.0221, 'lps'),
	(472381, 124, '2015-04-01 01:03:23.000000', 'consum', 0.0226, 'lps'),
	(472382, 124, '2015-04-01 01:03:24.000000', 'consum', 0.0230, 'lps'),
	(472383, 124, '2015-04-01 01:03:25.000000', 'consum', 0.0213, 'lps'),
	(472384, 124, '2015-04-01 01:03:26.000000', 'consum', 0.0215, 'lps'),
	(472385, 124, '2015-04-01 01:03:27.000000', 'consum', 0.0229, 'lps'),
	(472386, 124, '2015-04-01 01:03:28.000000', 'consum', 0.0213, 'lps'),
	(472387, 124, '2015-04-01 01:03:29.000000', 'consum', 0.0219, 'lps'),
	(472388, 124, '2015-04-01 01:03:30.000000', 'consum', 0.0223, 'lps'),
	(472389, 124, '2015-04-01 01:03:31.000000', 'consum', 0.0220, 'lps'),
	(472390, 124, '2015-04-01 01:03:32.000000', 'consum', 0.0221, 'lps'),
	(472391, 124, '2015-04-01 01:03:33.000000', 'consum', 0.0210, 'lps'),
	(472392, 124, '2015-04-01 01:03:34.000000', 'consum', 0.0232, 'lps'),
	(472393, 124, '2015-04-01 01:03:35.000000', 'consum', 0.0213, 'lps'),
	(472394, 124, '2015-04-01 01:03:36.000000', 'consum', 0.0213, 'lps'),
	(472395, 124, '2015-04-01 01:03:37.000000', 'consum', 0.0214, 'lps'),
	(472396, 124, '2015-04-01 01:03:38.000000', 'consum', 0.0225, 'lps'),
	(472397, 124, '2015-04-01 01:03:39.000000', 'consum', 0.0218, 'lps'),
	(472398, 124, '2015-04-01 01:03:40.000000', 'consum', 0.0234, 'lps'),
	(472399, 124, '2015-04-01 01:03:41.000000', 'consum', 0.0228, 'lps'),
	(472400, 124, '2015-04-01 01:03:42.000000', 'consum', 0.0229, 'lps'),
	(472401, 124, '2015-04-01 01:03:43.000000', 'consum', 0.0227, 'lps'),
	(472402, 124, '2015-04-01 01:03:44.000000', 'consum', 0.0210, 'lps'),
	(472403, 124, '2015-04-01 01:03:45.000000', 'consum', 0.0214, 'lps'),
	(472404, 124, '2015-04-01 01:03:46.000000', 'consum', 0.0230, 'lps'),
	(472405, 124, '2015-04-01 01:03:47.000000', 'consum', 0.0222, 'lps'),
	(472406, 124, '2015-04-01 01:03:48.000000', 'consum', 0.0210, 'lps'),
	(472407, 124, '2015-04-01 01:03:49.000000', 'consum', 0.0224, 'lps'),
	(472408, 124, '2015-04-01 01:03:50.000000', 'consum', 0.0230, 'lps'),
	(472409, 124, '2015-04-01 01:03:51.000000', 'consum', 0.0218, 'lps'),
	(472410, 124, '2015-04-01 01:03:52.000000', 'consum', 0.0215, 'lps'),
	(472411, 124, '2015-04-01 01:03:53.000000', 'consum', 0.0211, 'lps'),
	(472412, 124, '2015-04-01 01:03:54.000000', 'consum', 0.0229, 'lps'),
	(472413, 124, '2015-04-01 01:03:55.000000', 'consum', 0.0223, 'lps'),
	(472414, 124, '2015-04-01 01:03:56.000000', 'consum', 0.0217, 'lps'),
	(472415, 124, '2015-04-01 01:03:57.000000', 'consum', 0.0232, 'lps'),
	(472416, 124, '2015-04-01 01:03:58.000000', 'consum', 0.0224, 'lps'),
	(472417, 124, '2015-04-01 01:03:59.000000', 'consum', 0.0214, 'lps'),
	(472418, 124, '2015-04-01 01:04:00.000000', 'consum', 0.0216, 'lps'),
	(472419, 124, '2015-04-01 01:04:01.000000', 'consum', 0.0226, 'lps'),
	(472420, 124, '2015-04-01 01:04:02.000000', 'consum', 0.0223, 'lps'),
	(472421, 124, '2015-04-01 01:04:03.000000', 'consum', 0.0228, 'lps'),
	(472422, 124, '2015-04-01 01:04:04.000000', 'consum', 0.0235, 'lps'),
	(472423, 124, '2015-04-01 01:04:05.000000', 'consum', 0.0228, 'lps'),
	(472424, 124, '2015-04-01 01:04:06.000000', 'consum', 0.0227, 'lps'),
	(472425, 124, '2015-04-01 01:04:07.000000', 'consum', 0.0217, 'lps'),
	(472426, 124, '2015-04-01 01:04:08.000000', 'consum', 0.0219, 'lps'),
	(472427, 124, '2015-04-01 01:04:09.000000', 'consum', 0.0233, 'lps'),
	(472428, 124, '2015-04-01 01:04:10.000000', 'consum', 0.0223, 'lps'),
	(472429, 124, '2015-04-01 01:04:11.000000', 'consum', 0.0230, 'lps'),
	(472430, 124, '2015-04-01 01:04:12.000000', 'consum', 0.0222, 'lps'),
	(472431, 124, '2015-04-01 01:04:13.000000', 'consum', 0.0234, 'lps'),
	(472432, 124, '2015-04-01 01:04:14.000000', 'consum', 0.0216, 'lps'),
	(472433, 124, '2015-04-01 01:04:15.000000', 'consum', 0.0221, 'lps'),
	(472434, 124, '2015-04-01 01:04:16.000000', 'consum', 0.0220, 'lps'),
	(472435, 124, '2015-04-01 01:04:17.000000', 'consum', 0.0229, 'lps'),
	(472436, 124, '2015-04-01 01:04:18.000000', 'consum', 0.0223, 'lps'),
	(472437, 124, '2015-04-01 01:04:19.000000', 'consum', 0.0221, 'lps'),
	(472438, 124, '2015-04-01 01:04:20.000000', 'consum', 0.0223, 'lps'),
	(472439, 124, '2015-04-01 01:04:21.000000', 'consum', 0.0219, 'lps'),
	(472440, 124, '2015-04-01 01:04:22.000000', 'consum', 0.0216, 'lps'),
	(472441, 124, '2015-04-01 01:04:23.000000', 'consum', 0.0213, 'lps'),
	(472442, 124, '2015-04-01 01:04:24.000000', 'consum', 0.0235, 'lps'),
	(472443, 124, '2015-04-01 01:04:25.000000', 'consum', 0.0224, 'lps'),
	(472444, 124, '2015-04-01 01:04:26.000000', 'consum', 0.0228, 'lps'),
	(472445, 124, '2015-04-01 01:04:27.000000', 'consum', 0.0233, 'lps'),
	(472446, 124, '2015-04-01 01:04:28.000000', 'consum', 0.0218, 'lps'),
	(472447, 124, '2015-04-01 01:04:29.000000', 'consum', 0.0235, 'lps'),
	(472448, 124, '2015-04-01 01:04:30.000000', 'consum', 0.0235, 'lps'),
	(472449, 124, '2015-04-01 01:04:31.000000', 'consum', 0.0232, 'lps'),
	(472450, 124, '2015-04-01 01:04:32.000000', 'consum', 0.0220, 'lps'),
	(472451, 124, '2015-04-01 01:04:33.000000', 'consum', 0.0219, 'lps'),
	(472452, 124, '2015-04-01 01:04:34.000000', 'consum', 0.0229, 'lps'),
	(472453, 124, '2015-04-01 01:04:35.000000', 'consum', 0.0223, 'lps'),
	(472454, 124, '2015-04-01 01:04:36.000000', 'consum', 0.0220, 'lps'),
	(472455, 124, '2015-04-01 01:04:37.000000', 'consum', 0.0223, 'lps'),
	(472456, 124, '2015-04-01 01:04:38.000000', 'consum', 0.0219, 'lps'),
	(472457, 124, '2015-04-01 01:04:39.000000', 'consum', 0.0215, 'lps'),
	(472458, 124, '2015-04-01 01:04:40.000000', 'consum', 0.0210, 'lps'),
	(472459, 124, '2015-04-01 01:04:41.000000', 'consum', 0.0220, 'lps'),
	(472460, 124, '2015-04-01 01:04:42.000000', 'consum', 0.0234, 'lps'),
	(472461, 124, '2015-04-01 01:04:43.000000', 'consum', 0.0222, 'lps'),
	(472462, 124, '2015-04-01 01:04:44.000000', 'consum', 0.0227, 'lps'),
	(472463, 124, '2015-04-01 01:04:45.000000', 'consum', 0.0231, 'lps'),
	(472464, 124, '2015-04-01 01:04:46.000000', 'consum', 0.0211, 'lps'),
	(472465, 124, '2015-04-01 01:04:47.000000', 'consum', 0.0234, 'lps'),
	(472466, 124, '2015-04-01 01:04:48.000000', 'consum', 0.0222, 'lps'),
	(472467, 124, '2015-04-01 01:04:49.000000', 'consum', 0.0224, 'lps'),
	(472468, 124, '2015-04-01 01:04:50.000000', 'consum', 0.0218, 'lps'),
	(472469, 124, '2015-04-01 01:04:51.000000', 'consum', 0.0234, 'lps'),
	(472470, 124, '2015-04-01 01:04:52.000000', 'consum', 0.0231, 'lps'),
	(472471, 124, '2015-04-01 01:04:53.000000', 'consum', 0.0217, 'lps'),
	(472472, 124, '2015-04-01 01:04:54.000000', 'consum', 0.0233, 'lps'),
	(472473, 124, '2015-04-01 01:04:55.000000', 'consum', 0.0229, 'lps'),
	(472474, 124, '2015-04-01 01:04:56.000000', 'consum', 0.0211, 'lps'),
	(472475, 124, '2015-04-01 01:04:57.000000', 'consum', 0.0234, 'lps'),
	(472476, 124, '2015-04-01 01:04:58.000000', 'consum', 0.0223, 'lps'),
	(472477, 124, '2015-04-01 01:04:59.000000', 'consum', 0.0230, 'lps'),
	(472478, 124, '2015-04-01 01:05:00.000000', 'consum', 0.0222, 'lps'),
	(472479, 124, '2015-04-01 01:05:01.000000', 'consum', 0.0234, 'lps'),
	(472480, 124, '2015-04-01 01:05:02.000000', 'consum', 0.0219, 'lps'),
	(472481, 124, '2015-04-01 01:05:03.000000', 'consum', 0.0232, 'lps'),
	(472482, 124, '2015-04-01 01:05:04.000000', 'consum', 0.0219, 'lps'),
	(472483, 124, '2015-04-01 01:05:05.000000', 'consum', 0.0214, 'lps'),
	(472484, 124, '2015-04-01 01:05:06.000000', 'consum', 0.0229, 'lps'),
	(472485, 124, '2015-04-01 01:05:07.000000', 'consum', 0.0216, 'lps'),
	(472486, 124, '2015-04-01 01:05:08.000000', 'consum', 0.0210, 'lps'),
	(472487, 124, '2015-04-01 01:05:09.000000', 'consum', 0.0217, 'lps'),
	(472488, 124, '2015-04-01 01:05:10.000000', 'consum', 0.0220, 'lps'),
	(472489, 124, '2015-04-01 01:05:11.000000', 'consum', 0.0213, 'lps'),
	(472490, 124, '2015-04-01 01:05:12.000000', 'consum', 0.0221, 'lps'),
	(472491, 124, '2015-04-01 01:05:13.000000', 'consum', 0.0232, 'lps'),
	(472492, 124, '2015-04-01 01:05:14.000000', 'consum', 0.0234, 'lps'),
	(472493, 124, '2015-04-01 01:05:15.000000', 'consum', 0.0212, 'lps'),
	(472494, 124, '2015-04-01 01:05:16.000000', 'consum', 0.0228, 'lps'),
	(472495, 124, '2015-04-01 01:05:17.000000', 'consum', 0.0214, 'lps'),
	(472496, 124, '2015-04-01 01:05:18.000000', 'consum', 0.0231, 'lps'),
	(472497, 124, '2015-04-01 01:05:19.000000', 'consum', 0.0224, 'lps'),
	(472498, 124, '2015-04-01 01:05:20.000000', 'consum', 0.0219, 'lps'),
	(472499, 124, '2015-04-01 01:05:21.000000', 'consum', 0.0213, 'lps'),
	(472500, 124, '2015-04-01 01:05:22.000000', 'consum', 0.0225, 'lps'),
	(472501, 124, '2015-04-01 01:05:23.000000', 'consum', 0.0223, 'lps'),
	(472502, 124, '2015-04-01 01:05:24.000000', 'consum', 0.0233, 'lps'),
	(472503, 124, '2015-04-01 01:05:25.000000', 'consum', 0.0234, 'lps'),
	(472504, 124, '2015-04-01 01:05:26.000000', 'consum', 0.0234, 'lps'),
	(472505, 124, '2015-04-01 01:05:27.000000', 'consum', 0.0233, 'lps'),
	(472506, 124, '2015-04-01 01:05:28.000000', 'consum', 0.0228, 'lps'),
	(472507, 124, '2015-04-01 01:05:29.000000', 'consum', 0.0233, 'lps'),
	(472508, 124, '2015-04-01 01:05:30.000000', 'consum', 0.0219, 'lps'),
	(472509, 124, '2015-04-01 01:05:31.000000', 'consum', 0.0213, 'lps'),
	(472510, 124, '2015-04-01 01:05:32.000000', 'consum', 0.0222, 'lps'),
	(472511, 124, '2015-04-01 01:05:33.000000', 'consum', 0.0212, 'lps'),
	(472512, 124, '2015-04-01 01:05:34.000000', 'consum', 0.0234, 'lps'),
	(472513, 124, '2015-04-01 01:05:35.000000', 'consum', 0.0223, 'lps'),
	(472514, 124, '2015-04-01 01:05:36.000000', 'consum', 0.0231, 'lps'),
	(472515, 124, '2015-04-01 01:05:37.000000', 'consum', 0.0221, 'lps'),
	(472516, 124, '2015-04-01 01:05:38.000000', 'consum', 0.0231, 'lps'),
	(472517, 124, '2015-04-01 01:05:39.000000', 'consum', 0.0232, 'lps'),
	(472518, 124, '2015-04-01 01:05:40.000000', 'consum', 0.0229, 'lps'),
	(472519, 124, '2015-04-01 01:05:41.000000', 'consum', 0.0213, 'lps'),
	(472520, 124, '2015-04-01 01:05:42.000000', 'consum', 0.0222, 'lps'),
	(472521, 124, '2015-04-01 01:05:43.000000', 'consum', 0.0210, 'lps'),
	(472522, 124, '2015-04-01 01:05:44.000000', 'consum', 0.0224, 'lps'),
	(472523, 124, '2015-04-01 01:05:45.000000', 'consum', 0.0228, 'lps'),
	(472524, 124, '2015-04-01 01:05:46.000000', 'consum', 0.0235, 'lps'),
	(472525, 124, '2015-04-01 01:05:47.000000', 'consum', 0.0227, 'lps'),
	(472526, 124, '2015-04-01 01:05:48.000000', 'consum', 0.0222, 'lps'),
	(472527, 124, '2015-04-01 01:05:49.000000', 'consum', 0.0218, 'lps'),
	(472528, 124, '2015-04-01 01:05:50.000000', 'consum', 0.0214, 'lps'),
	(472529, 124, '2015-04-01 01:05:51.000000', 'consum', 0.0232, 'lps'),
	(472530, 124, '2015-04-01 01:05:52.000000', 'consum', 0.0232, 'lps'),
	(472531, 124, '2015-04-01 01:05:53.000000', 'consum', 0.0226, 'lps'),
	(472532, 124, '2015-04-01 01:05:54.000000', 'consum', 0.0227, 'lps'),
	(472533, 124, '2015-04-01 01:05:55.000000', 'consum', 0.0222, 'lps'),
	(472534, 124, '2015-04-01 01:05:56.000000', 'consum', 0.0218, 'lps'),
	(472535, 124, '2015-04-01 01:05:57.000000', 'consum', 0.0214, 'lps'),
	(472536, 124, '2015-04-01 01:05:58.000000', 'consum', 0.0234, 'lps'),
	(472537, 124, '2015-04-01 01:05:59.000000', 'consum', 0.0215, 'lps'),
	(472538, 124, '2015-04-01 01:06:00.000000', 'consum', 0.0213, 'lps'),
	(472539, 124, '2015-04-01 01:06:01.000000', 'consum', 0.0212, 'lps'),
	(472540, 124, '2015-04-01 01:06:02.000000', 'consum', 0.0210, 'lps'),
	(472541, 124, '2015-04-01 01:06:03.000000', 'consum', 0.0233, 'lps'),
	(472542, 124, '2015-04-01 01:06:04.000000', 'consum', 0.0220, 'lps'),
	(472543, 124, '2015-04-01 01:06:05.000000', 'consum', 0.0216, 'lps'),
	(472544, 124, '2015-04-01 01:06:06.000000', 'consum', 0.0213, 'lps'),
	(472545, 124, '2015-04-01 01:06:07.000000', 'consum', 0.0232, 'lps'),
	(472546, 124, '2015-04-01 01:06:08.000000', 'consum', 0.0234, 'lps'),
	(472547, 124, '2015-04-01 01:06:09.000000', 'consum', 0.0211, 'lps'),
	(472548, 124, '2015-04-01 01:06:10.000000', 'consum', 0.0221, 'lps'),
	(472549, 124, '2015-04-01 01:06:11.000000', 'consum', 0.0211, 'lps'),
	(472550, 124, '2015-04-01 01:06:12.000000', 'consum', 0.0234, 'lps'),
	(472551, 124, '2015-04-01 01:06:13.000000', 'consum', 0.0225, 'lps'),
	(472552, 124, '2015-04-01 01:06:14.000000', 'consum', 0.0211, 'lps'),
	(472553, 124, '2015-04-01 01:06:15.000000', 'consum', 0.0225, 'lps'),
	(472554, 124, '2015-04-01 01:06:16.000000', 'consum', 0.0232, 'lps'),
	(472555, 124, '2015-04-01 01:06:17.000000', 'consum', 0.0221, 'lps'),
	(472556, 124, '2015-04-01 01:06:18.000000', 'consum', 0.0225, 'lps'),
	(472557, 124, '2015-04-01 01:06:19.000000', 'consum', 0.0228, 'lps'),
	(472558, 124, '2015-04-01 01:06:20.000000', 'consum', 0.0229, 'lps'),
	(472559, 124, '2015-04-01 01:06:21.000000', 'consum', 0.0224, 'lps'),
	(472560, 124, '2015-04-01 01:06:22.000000', 'consum', 0.0226, 'lps'),
	(472561, 124, '2015-04-01 01:06:23.000000', 'consum', 0.0223, 'lps'),
	(472562, 124, '2015-04-01 01:06:24.000000', 'consum', 0.0227, 'lps'),
	(472563, 124, '2015-04-01 01:06:25.000000', 'consum', 0.0231, 'lps'),
	(472564, 124, '2015-04-01 01:06:26.000000', 'consum', 0.0211, 'lps'),
	(472565, 124, '2015-04-01 01:06:27.000000', 'consum', 0.0231, 'lps'),
	(472566, 124, '2015-04-01 01:06:28.000000', 'consum', 0.0232, 'lps'),
	(472567, 124, '2015-04-01 01:06:29.000000', 'consum', 0.0235, 'lps'),
	(472568, 124, '2015-04-01 01:06:30.000000', 'consum', 0.0218, 'lps'),
	(472569, 124, '2015-04-01 01:06:31.000000', 'consum', 0.0226, 'lps'),
	(472570, 124, '2015-04-01 01:06:32.000000', 'consum', 0.0214, 'lps'),
	(472571, 124, '2015-04-01 01:06:33.000000', 'consum', 0.0235, 'lps'),
	(472572, 124, '2015-04-01 01:06:34.000000', 'consum', 0.0217, 'lps'),
	(472573, 124, '2015-04-01 01:06:35.000000', 'consum', 0.0226, 'lps'),
	(472574, 124, '2015-04-01 01:06:36.000000', 'consum', 0.0218, 'lps'),
	(472575, 124, '2015-04-01 01:06:37.000000', 'consum', 0.0226, 'lps'),
	(472576, 124, '2015-04-01 01:06:38.000000', 'consum', 0.0217, 'lps'),
	(472577, 124, '2015-04-01 01:06:39.000000', 'consum', 0.0221, 'lps'),
	(472578, 124, '2015-04-01 01:06:40.000000', 'consum', 0.0219, 'lps'),
	(472579, 124, '2015-04-01 01:06:41.000000', 'consum', 0.0223, 'lps'),
	(472580, 124, '2015-04-01 01:06:42.000000', 'consum', 0.0223, 'lps'),
	(472581, 124, '2015-04-01 01:06:43.000000', 'consum', 0.0235, 'lps'),
	(472582, 124, '2015-04-01 01:06:44.000000', 'consum', 0.0217, 'lps'),
	(472583, 124, '2015-04-01 01:06:45.000000', 'consum', 0.0225, 'lps'),
	(472584, 124, '2015-04-01 01:06:46.000000', 'consum', 0.0212, 'lps'),
	(472585, 124, '2015-04-01 01:06:47.000000', 'consum', 0.0229, 'lps'),
	(472586, 124, '2015-04-01 01:06:48.000000', 'consum', 0.0220, 'lps'),
	(472587, 124, '2015-04-01 01:06:49.000000', 'consum', 0.0232, 'lps'),
	(472588, 124, '2015-04-01 01:06:50.000000', 'consum', 0.0210, 'lps'),
	(472589, 124, '2015-04-01 01:06:51.000000', 'consum', 0.0224, 'lps'),
	(472590, 124, '2015-04-01 01:06:52.000000', 'consum', 0.0228, 'lps'),
	(472591, 124, '2015-04-01 01:06:53.000000', 'consum', 0.0232, 'lps'),
	(472592, 124, '2015-04-01 01:06:54.000000', 'consum', 0.0215, 'lps'),
	(472593, 124, '2015-04-01 01:06:55.000000', 'consum', 0.0223, 'lps'),
	(472594, 124, '2015-04-01 01:06:56.000000', 'consum', 0.0234, 'lps'),
	(472595, 124, '2015-04-01 01:06:57.000000', 'consum', 0.0213, 'lps'),
	(472596, 124, '2015-04-01 01:06:58.000000', 'consum', 0.0233, 'lps'),
	(472597, 124, '2015-04-01 01:06:59.000000', 'consum', 0.0235, 'lps'),
	(472598, 124, '2015-04-01 01:07:00.000000', 'consum', 0.0218, 'lps'),
	(472599, 124, '2015-04-01 01:07:01.000000', 'consum', 0.0227, 'lps'),
	(472600, 124, '2015-04-01 01:07:02.000000', 'consum', 0.0218, 'lps'),
	(472601, 124, '2015-04-01 01:07:03.000000', 'consum', 0.0227, 'lps'),
	(472602, 124, '2015-04-01 01:07:04.000000', 'consum', 0.0221, 'lps'),
	(472603, 124, '2015-04-01 01:07:05.000000', 'consum', 0.0212, 'lps'),
	(472604, 124, '2015-04-01 01:07:06.000000', 'consum', 0.0214, 'lps'),
	(472605, 124, '2015-04-01 01:07:07.000000', 'consum', 0.0226, 'lps'),
	(472606, 124, '2015-04-01 01:07:08.000000', 'consum', 0.0228, 'lps'),
	(472607, 124, '2015-04-01 01:07:09.000000', 'consum', 0.0223, 'lps'),
	(472608, 124, '2015-04-01 01:07:10.000000', 'consum', 0.0224, 'lps'),
	(472609, 124, '2015-04-01 01:07:11.000000', 'consum', 0.0216, 'lps'),
	(472610, 124, '2015-04-01 01:07:12.000000', 'consum', 0.0225, 'lps'),
	(472611, 124, '2015-04-01 01:07:13.000000', 'consum', 0.0214, 'lps'),
	(472612, 124, '2015-04-01 01:07:14.000000', 'consum', 0.0211, 'lps'),
	(472613, 124, '2015-04-01 01:07:15.000000', 'consum', 0.0229, 'lps'),
	(472614, 124, '2015-04-01 01:07:16.000000', 'consum', 0.0226, 'lps'),
	(472615, 124, '2015-04-01 01:07:17.000000', 'consum', 0.0231, 'lps'),
	(472616, 124, '2015-04-01 01:07:18.000000', 'consum', 0.0219, 'lps'),
	(472617, 124, '2015-04-01 01:07:19.000000', 'consum', 0.0216, 'lps'),
	(472618, 124, '2015-04-01 01:07:20.000000', 'consum', 0.0215, 'lps'),
	(472619, 124, '2015-04-01 01:07:21.000000', 'consum', 0.0215, 'lps'),
	(472620, 124, '2015-04-01 01:07:22.000000', 'consum', 0.0222, 'lps'),
	(472621, 124, '2015-04-01 01:07:23.000000', 'consum', 0.0230, 'lps'),
	(472622, 124, '2015-04-01 01:07:24.000000', 'consum', 0.0223, 'lps'),
	(472623, 124, '2015-04-01 01:07:25.000000', 'consum', 0.0216, 'lps'),
	(472624, 124, '2015-04-01 01:07:26.000000', 'consum', 0.0225, 'lps'),
	(472625, 124, '2015-04-01 01:07:27.000000', 'consum', 0.0216, 'lps'),
	(472626, 124, '2015-04-01 01:07:28.000000', 'consum', 0.0222, 'lps'),
	(472627, 124, '2015-04-01 01:07:29.000000', 'consum', 0.0226, 'lps'),
	(472628, 124, '2015-04-01 01:07:30.000000', 'consum', 0.0228, 'lps'),
	(472629, 124, '2015-04-01 01:07:31.000000', 'consum', 0.0229, 'lps'),
	(472630, 124, '2015-04-01 01:07:32.000000', 'consum', 0.0225, 'lps'),
	(472631, 124, '2015-04-01 01:07:33.000000', 'consum', 0.0228, 'lps'),
	(472632, 124, '2015-04-01 01:07:34.000000', 'consum', 0.0229, 'lps'),
	(472633, 124, '2015-04-01 01:07:35.000000', 'consum', 0.0224, 'lps'),
	(472634, 124, '2015-04-01 01:07:36.000000', 'consum', 0.0224, 'lps'),
	(472635, 124, '2015-04-01 01:07:37.000000', 'consum', 0.0214, 'lps'),
	(472636, 124, '2015-04-01 01:07:38.000000', 'consum', 0.0215, 'lps'),
	(472637, 124, '2015-04-01 01:07:39.000000', 'consum', 0.0221, 'lps'),
	(472638, 124, '2015-04-01 01:07:40.000000', 'consum', 0.0225, 'lps'),
	(472639, 124, '2015-04-01 01:07:41.000000', 'consum', 0.0227, 'lps'),
	(472640, 124, '2015-04-01 01:07:42.000000', 'consum', 0.0223, 'lps'),
	(472641, 124, '2015-04-01 01:07:43.000000', 'consum', 0.0224, 'lps'),
	(472642, 124, '2015-04-01 01:07:44.000000', 'consum', 0.0216, 'lps'),
	(472643, 124, '2015-04-01 01:07:45.000000', 'consum', 0.0223, 'lps'),
	(472644, 124, '2015-04-01 01:07:46.000000', 'consum', 0.0233, 'lps'),
	(472645, 124, '2015-04-01 01:07:47.000000', 'consum', 0.0210, 'lps'),
	(472646, 124, '2015-04-01 01:07:48.000000', 'consum', 0.0217, 'lps'),
	(472647, 124, '2015-04-01 01:07:49.000000', 'consum', 0.0221, 'lps'),
	(472648, 124, '2015-04-01 01:07:50.000000', 'consum', 0.0217, 'lps'),
	(472649, 124, '2015-04-01 01:07:51.000000', 'consum', 0.0214, 'lps'),
	(472650, 124, '2015-04-01 01:07:52.000000', 'consum', 0.0210, 'lps'),
	(472651, 124, '2015-04-01 01:07:53.000000', 'consum', 0.0224, 'lps'),
	(472652, 124, '2015-04-01 01:07:54.000000', 'consum', 0.0230, 'lps'),
	(472653, 124, '2015-04-01 01:07:55.000000', 'consum', 0.0217, 'lps'),
	(472654, 124, '2015-04-01 01:07:56.000000', 'consum', 0.0235, 'lps'),
	(472655, 124, '2015-04-01 01:07:57.000000', 'consum', 0.0213, 'lps'),
	(472656, 124, '2015-04-01 01:07:58.000000', 'consum', 0.0228, 'lps'),
	(472657, 124, '2015-04-01 01:07:59.000000', 'consum', 0.0214, 'lps'),
	(472658, 124, '2015-04-01 01:08:00.000000', 'consum', 0.0229, 'lps'),
	(472659, 124, '2015-04-01 01:08:01.000000', 'consum', 0.0214, 'lps'),
	(472660, 124, '2015-04-01 01:08:02.000000', 'consum', 0.0225, 'lps'),
	(472661, 124, '2015-04-01 01:08:03.000000', 'consum', 0.0220, 'lps'),
	(472662, 124, '2015-04-01 01:08:04.000000', 'consum', 0.0217, 'lps'),
	(472663, 124, '2015-04-01 01:08:05.000000', 'consum', 0.0218, 'lps'),
	(472664, 124, '2015-04-01 01:08:06.000000', 'consum', 0.0226, 'lps'),
	(472665, 124, '2015-04-01 01:08:07.000000', 'consum', 0.0214, 'lps'),
	(472666, 124, '2015-04-01 01:08:08.000000', 'consum', 0.0211, 'lps'),
	(472667, 124, '2015-04-01 01:08:09.000000', 'consum', 0.0229, 'lps'),
	(472668, 124, '2015-04-01 01:08:10.000000', 'consum', 0.0226, 'lps'),
	(472669, 124, '2015-04-01 01:08:11.000000', 'consum', 0.0233, 'lps'),
	(472670, 124, '2015-04-01 01:08:12.000000', 'consum', 0.0227, 'lps'),
	(472671, 124, '2015-04-01 01:08:13.000000', 'consum', 0.0224, 'lps'),
	(472672, 124, '2015-04-01 01:08:14.000000', 'consum', 0.0231, 'lps'),
	(472673, 124, '2015-04-01 01:08:15.000000', 'consum', 0.0222, 'lps'),
	(472674, 124, '2015-04-01 01:08:16.000000', 'consum', 0.0233, 'lps'),
	(472675, 124, '2015-04-01 01:08:17.000000', 'consum', 0.0213, 'lps'),
	(472676, 124, '2015-04-01 01:08:18.000000', 'consum', 0.0235, 'lps'),
	(472677, 124, '2015-04-01 01:08:19.000000', 'consum', 0.0221, 'lps'),
	(472678, 124, '2015-04-01 01:08:20.000000', 'consum', 0.0216, 'lps'),
	(472679, 124, '2015-04-01 01:08:21.000000', 'consum', 0.0232, 'lps'),
	(472680, 124, '2015-04-01 01:08:22.000000', 'consum', 0.0227, 'lps'),
	(472681, 124, '2015-04-01 01:08:23.000000', 'consum', 0.0229, 'lps'),
	(472682, 124, '2015-04-01 01:08:24.000000', 'consum', 0.0226, 'lps'),
	(472683, 124, '2015-04-01 01:08:25.000000', 'consum', 0.0211, 'lps'),
	(472684, 124, '2015-04-01 01:08:26.000000', 'consum', 0.0217, 'lps'),
	(472685, 124, '2015-04-01 01:08:27.000000', 'consum', 0.0216, 'lps'),
	(472686, 124, '2015-04-01 01:08:28.000000', 'consum', 0.0219, 'lps'),
	(472687, 124, '2015-04-01 01:08:29.000000', 'consum', 0.0211, 'lps'),
	(472688, 124, '2015-04-01 01:08:30.000000', 'consum', 0.0216, 'lps'),
	(472689, 124, '2015-04-01 01:08:31.000000', 'consum', 0.0210, 'lps'),
	(472690, 124, '2015-04-01 01:08:32.000000', 'consum', 0.0219, 'lps'),
	(472691, 124, '2015-04-01 01:08:33.000000', 'consum', 0.0228, 'lps'),
	(472692, 124, '2015-04-01 01:08:34.000000', 'consum', 0.0224, 'lps'),
	(472693, 124, '2015-04-01 01:08:35.000000', 'consum', 0.0226, 'lps'),
	(472694, 124, '2015-04-01 01:08:36.000000', 'consum', 0.0222, 'lps'),
	(472695, 124, '2015-04-01 01:08:37.000000', 'consum', 0.0223, 'lps'),
	(472696, 124, '2015-04-01 01:08:38.000000', 'consum', 0.0212, 'lps'),
	(472697, 124, '2015-04-01 01:08:39.000000', 'consum', 0.0235, 'lps'),
	(472698, 124, '2015-04-01 01:08:40.000000', 'consum', 0.0224, 'lps'),
	(472699, 124, '2015-04-01 01:08:41.000000', 'consum', 0.0231, 'lps'),
	(472700, 124, '2015-04-01 01:08:42.000000', 'consum', 0.0221, 'lps'),
	(472701, 124, '2015-04-01 01:08:43.000000', 'consum', 0.0229, 'lps'),
	(472702, 124, '2015-04-01 01:08:44.000000', 'consum', 0.0221, 'lps'),
	(472703, 124, '2015-04-01 01:08:45.000000', 'consum', 0.0232, 'lps'),
	(472704, 124, '2015-04-01 01:08:46.000000', 'consum', 0.0212, 'lps'),
	(472705, 124, '2015-04-01 01:08:47.000000', 'consum', 0.0233, 'lps'),
	(472706, 124, '2015-04-01 01:08:48.000000', 'consum', 0.0215, 'lps'),
	(472707, 124, '2015-04-01 01:08:49.000000', 'consum', 0.0218, 'lps'),
	(472708, 124, '2015-04-01 01:08:50.000000', 'consum', 0.0235, 'lps'),
	(472709, 124, '2015-04-01 01:08:51.000000', 'consum', 0.0234, 'lps'),
	(472710, 124, '2015-04-01 01:08:52.000000', 'consum', 0.0228, 'lps'),
	(472711, 124, '2015-04-01 01:08:53.000000', 'consum', 0.0230, 'lps'),
	(472712, 124, '2015-04-01 01:08:54.000000', 'consum', 0.0229, 'lps'),
	(472713, 124, '2015-04-01 01:08:55.000000', 'consum', 0.0221, 'lps'),
	(472714, 124, '2015-04-01 01:08:56.000000', 'consum', 0.0235, 'lps'),
	(472715, 124, '2015-04-01 01:08:57.000000', 'consum', 0.0223, 'lps'),
	(472716, 124, '2015-04-01 01:08:58.000000', 'consum', 0.0228, 'lps'),
	(472717, 124, '2015-04-01 01:08:59.000000', 'consum', 0.0233, 'lps'),
	(472718, 124, '2015-04-01 01:09:00.000000', 'consum', 0.0221, 'lps'),
	(472719, 124, '2015-04-01 01:09:01.000000', 'consum', 0.0222, 'lps'),
	(472720, 124, '2015-04-01 01:09:02.000000', 'consum', 0.0213, 'lps'),
	(472721, 124, '2015-04-01 01:09:03.000000', 'consum', 0.0214, 'lps'),
	(472722, 124, '2015-04-01 01:09:04.000000', 'consum', 0.0220, 'lps'),
	(472723, 124, '2015-04-01 01:09:05.000000', 'consum', 0.0225, 'lps'),
	(472724, 124, '2015-04-01 01:09:06.000000', 'consum', 0.0227, 'lps'),
	(472725, 124, '2015-04-01 01:09:07.000000', 'consum', 0.0224, 'lps'),
	(472726, 124, '2015-04-01 01:09:08.000000', 'consum', 0.0230, 'lps'),
	(472727, 124, '2015-04-01 01:09:09.000000', 'consum', 0.0219, 'lps'),
	(472728, 124, '2015-04-01 01:09:10.000000', 'consum', 0.0219, 'lps'),
	(472729, 124, '2015-04-01 01:09:11.000000', 'consum', 0.0228, 'lps'),
	(472730, 124, '2015-04-01 01:09:12.000000', 'consum', 0.0222, 'lps'),
	(472731, 124, '2015-04-01 01:09:13.000000', 'consum', 0.0217, 'lps'),
	(472732, 124, '2015-04-01 01:09:14.000000', 'consum', 0.0234, 'lps'),
	(472733, 124, '2015-04-01 01:09:15.000000', 'consum', 0.0234, 'lps'),
	(472734, 124, '2015-04-01 01:09:16.000000', 'consum', 0.0233, 'lps'),
	(472735, 124, '2015-04-01 01:09:17.000000', 'consum', 0.0228, 'lps'),
	(472736, 124, '2015-04-01 01:09:18.000000', 'consum', 0.0231, 'lps'),
	(472737, 124, '2015-04-01 01:09:19.000000', 'consum', 0.0210, 'lps'),
	(472738, 124, '2015-04-01 01:09:20.000000', 'consum', 0.0223, 'lps'),
	(472739, 124, '2015-04-01 01:09:21.000000', 'consum', 0.0225, 'lps'),
	(472740, 124, '2015-04-01 01:09:22.000000', 'consum', 0.0222, 'lps'),
	(472741, 124, '2015-04-01 01:09:23.000000', 'consum', 0.0223, 'lps'),
	(472742, 124, '2015-04-01 01:09:24.000000', 'consum', 0.0216, 'lps'),
	(472743, 124, '2015-04-01 01:09:25.000000', 'consum', 0.0225, 'lps'),
	(472744, 124, '2015-04-01 01:09:26.000000', 'consum', 0.0217, 'lps'),
	(472745, 124, '2015-04-01 01:09:27.000000', 'consum', 0.0227, 'lps'),
	(472746, 124, '2015-04-01 01:09:28.000000', 'consum', 0.0222, 'lps'),
	(472747, 124, '2015-04-01 01:09:29.000000', 'consum', 0.0219, 'lps'),
	(472748, 124, '2015-04-01 01:09:30.000000', 'consum', 0.0219, 'lps'),
	(472749, 124, '2015-04-01 01:09:31.000000', 'consum', 0.0229, 'lps'),
	(472750, 124, '2015-04-01 01:09:32.000000', 'consum', 0.0228, 'lps'),
	(472751, 124, '2015-04-01 01:09:33.000000', 'consum', 0.0217, 'lps'),
	(472752, 124, '2015-04-01 01:09:34.000000', 'consum', 0.0217, 'lps'),
	(472753, 124, '2015-04-01 01:09:35.000000', 'consum', 0.0224, 'lps'),
	(472754, 124, '2015-04-01 01:09:36.000000', 'consum', 0.0210, 'lps'),
	(472755, 124, '2015-04-01 01:09:37.000000', 'consum', 0.0218, 'lps'),
	(472756, 124, '2015-04-01 01:09:38.000000', 'consum', 0.0226, 'lps'),
	(472757, 124, '2015-04-01 01:09:39.000000', 'consum', 0.0213, 'lps'),
	(472758, 124, '2015-04-01 01:09:40.000000', 'consum', 0.0232, 'lps'),
	(472759, 124, '2015-04-01 01:09:41.000000', 'consum', 0.0233, 'lps'),
	(472760, 124, '2015-04-01 01:09:42.000000', 'consum', 0.0233, 'lps'),
	(472761, 124, '2015-04-01 01:09:43.000000', 'consum', 0.0231, 'lps'),
	(472762, 124, '2015-04-01 01:09:44.000000', 'consum', 0.0221, 'lps'),
	(472763, 124, '2015-04-01 01:09:45.000000', 'consum', 0.0228, 'lps'),
	(472764, 124, '2015-04-01 01:09:46.000000', 'consum', 0.0216, 'lps'),
	(472765, 124, '2015-04-01 01:09:47.000000', 'consum', 0.0211, 'lps'),
	(472766, 124, '2015-04-01 01:09:48.000000', 'consum', 0.0225, 'lps'),
	(472767, 124, '2015-04-01 01:09:49.000000', 'consum', 0.0228, 'lps'),
	(472768, 124, '2015-04-01 01:09:50.000000', 'consum', 0.0232, 'lps'),
	(472769, 124, '2015-04-01 01:09:51.000000', 'consum', 0.0216, 'lps'),
	(472770, 124, '2015-04-01 01:09:52.000000', 'consum', 0.0223, 'lps'),
	(472771, 124, '2015-04-01 01:09:53.000000', 'consum', 0.0232, 'lps'),
	(472772, 124, '2015-04-01 01:09:54.000000', 'consum', 0.0231, 'lps'),
	(472773, 124, '2015-04-01 01:09:55.000000', 'consum', 0.0223, 'lps'),
	(472774, 124, '2015-04-01 01:09:56.000000', 'consum', 0.0213, 'lps'),
	(472775, 124, '2015-04-01 01:09:57.000000', 'consum', 0.0212, 'lps'),
	(472776, 124, '2015-04-01 01:09:58.000000', 'consum', 0.0211, 'lps'),
	(472777, 124, '2015-04-01 01:09:59.000000', 'consum', 0.0211, 'lps'),
	(472778, 124, '2015-04-01 01:10:00.000000', 'consum', 0.0212, 'lps'),
	(472779, 124, '2015-04-01 01:10:01.000000', 'consum', 0.0217, 'lps'),
	(472780, 124, '2015-04-01 01:10:02.000000', 'consum', 0.0214, 'lps'),
	(472781, 124, '2015-04-01 01:10:03.000000', 'consum', 0.0211, 'lps'),
	(472782, 124, '2015-04-01 01:10:04.000000', 'consum', 0.0229, 'lps'),
	(472783, 124, '2015-04-01 01:10:05.000000', 'consum', 0.0222, 'lps'),
	(472784, 124, '2015-04-01 01:10:06.000000', 'consum', 0.0217, 'lps'),
	(472785, 124, '2015-04-01 01:10:07.000000', 'consum', 0.0233, 'lps'),
	(472786, 124, '2015-04-01 01:10:08.000000', 'consum', 0.0229, 'lps'),
	(472787, 124, '2015-04-01 01:10:09.000000', 'consum', 0.0234, 'lps'),
	(472788, 124, '2015-04-01 01:10:10.000000', 'consum', 0.0224, 'lps'),
	(472789, 124, '2015-04-01 01:10:11.000000', 'consum', 0.0233, 'lps'),
	(472790, 124, '2015-04-01 01:10:12.000000', 'consum', 0.0230, 'lps'),
	(472791, 124, '2015-04-01 01:10:13.000000', 'consum', 0.0216, 'lps'),
	(472792, 124, '2015-04-01 01:10:14.000000', 'consum', 0.0235, 'lps'),
	(472793, 124, '2015-04-01 01:10:15.000000', 'consum', 0.0211, 'lps'),
	(472794, 124, '2015-04-01 01:10:16.000000', 'consum', 0.0220, 'lps'),
	(472795, 124, '2015-04-01 01:10:17.000000', 'consum', 0.0232, 'lps'),
	(472796, 124, '2015-04-01 01:10:18.000000', 'consum', 0.0210, 'lps'),
	(472797, 124, '2015-04-01 01:10:19.000000', 'consum', 0.0224, 'lps'),
	(472798, 124, '2015-04-01 01:10:20.000000', 'consum', 0.0229, 'lps'),
	(472799, 124, '2015-04-01 01:10:21.000000', 'consum', 0.0235, 'lps'),
	(472800, 124, '2015-04-01 01:10:22.000000', 'consum', 0.0230, 'lps'),
	(472801, 124, '2015-04-01 01:10:23.000000', 'consum', 0.0234, 'lps'),
	(472802, 124, '2015-04-01 01:10:24.000000', 'consum', 0.0219, 'lps'),
	(472803, 124, '2015-04-01 01:10:25.000000', 'consum', 0.0210, 'lps'),
	(472804, 124, '2015-04-01 01:10:26.000000', 'consum', 0.0210, 'lps'),
	(472805, 124, '2015-04-01 01:10:27.000000', 'consum', 0.0211, 'lps'),
	(472806, 124, '2015-04-01 01:10:28.000000', 'consum', 0.0213, 'lps'),
	(472807, 124, '2015-04-01 01:10:29.000000', 'consum', 0.0225, 'lps'),
	(472808, 124, '2015-04-01 01:10:30.000000', 'consum', 0.0224, 'lps'),
	(472809, 124, '2015-04-01 01:10:31.000000', 'consum', 0.0211, 'lps'),
	(472810, 124, '2015-04-01 01:10:32.000000', 'consum', 0.0223, 'lps'),
	(472811, 124, '2015-04-01 01:10:33.000000', 'consum', 0.0221, 'lps'),
	(472812, 124, '2015-04-01 01:10:34.000000', 'consum', 0.0225, 'lps'),
	(472813, 124, '2015-04-01 01:10:35.000000', 'consum', 0.0227, 'lps'),
	(472814, 124, '2015-04-01 01:10:36.000000', 'consum', 0.0227, 'lps'),
	(472815, 124, '2015-04-01 01:10:37.000000', 'consum', 0.0216, 'lps'),
	(472816, 124, '2015-04-01 01:10:38.000000', 'consum', 0.0217, 'lps'),
	(472817, 124, '2015-04-01 01:10:39.000000', 'consum', 0.0226, 'lps'),
	(472818, 124, '2015-04-01 01:10:40.000000', 'consum', 0.0219, 'lps'),
	(472819, 124, '2015-04-01 01:10:41.000000', 'consum', 0.0234, 'lps'),
	(472820, 124, '2015-04-01 01:10:42.000000', 'consum', 0.0223, 'lps'),
	(472821, 124, '2015-04-01 01:10:43.000000', 'consum', 0.0230, 'lps'),
	(472822, 124, '2015-04-01 01:10:44.000000', 'consum', 0.0219, 'lps'),
	(472823, 124, '2015-04-01 01:10:45.000000', 'consum', 0.0223, 'lps'),
	(472824, 124, '2015-04-01 01:10:46.000000', 'consum', 0.0223, 'lps'),
	(472825, 124, '2015-04-01 01:10:47.000000', 'consum', 0.0211, 'lps'),
	(472826, 124, '2015-04-01 01:10:48.000000', 'consum', 0.0230, 'lps'),
	(472827, 124, '2015-04-01 01:10:49.000000', 'consum', 0.0226, 'lps'),
	(472828, 124, '2015-04-01 01:10:50.000000', 'consum', 0.0233, 'lps'),
	(472829, 124, '2015-04-01 01:10:51.000000', 'consum', 0.0226, 'lps'),
	(472830, 124, '2015-04-01 01:10:52.000000', 'consum', 0.0218, 'lps'),
	(472831, 124, '2015-04-01 01:10:53.000000', 'consum', 0.0232, 'lps'),
	(472832, 124, '2015-04-01 01:10:54.000000', 'consum', 0.0219, 'lps'),
	(472833, 124, '2015-04-01 01:10:55.000000', 'consum', 0.0214, 'lps'),
	(472834, 124, '2015-04-01 01:10:56.000000', 'consum', 0.0230, 'lps'),
	(472835, 124, '2015-04-01 01:10:57.000000', 'consum', 0.0222, 'lps'),
	(472836, 124, '2015-04-01 01:10:58.000000', 'consum', 0.0235, 'lps'),
	(472837, 124, '2015-04-01 01:10:59.000000', 'consum', 0.0220, 'lps'),
	(472838, 124, '2015-04-01 01:11:00.000000', 'consum', 0.0215, 'lps'),
	(472839, 124, '2015-04-01 01:11:01.000000', 'consum', 0.0228, 'lps'),
	(472840, 124, '2015-04-01 01:11:02.000000', 'consum', 0.0234, 'lps'),
	(472841, 124, '2015-04-01 01:11:03.000000', 'consum', 0.0224, 'lps'),
	(472842, 124, '2015-04-01 01:11:04.000000', 'consum', 0.0211, 'lps'),
	(472843, 124, '2015-04-01 01:11:05.000000', 'consum', 0.0226, 'lps'),
	(472844, 124, '2015-04-01 01:11:06.000000', 'consum', 0.0232, 'lps'),
	(472845, 124, '2015-04-01 01:11:07.000000', 'consum', 0.0224, 'lps'),
	(472846, 124, '2015-04-01 01:11:08.000000', 'consum', 0.0213, 'lps'),
	(472847, 124, '2015-04-01 01:11:09.000000', 'consum', 0.0234, 'lps'),
	(472848, 124, '2015-04-01 01:11:10.000000', 'consum', 0.0216, 'lps'),
	(472849, 124, '2015-04-01 01:11:11.000000', 'consum', 0.0224, 'lps'),
	(472850, 124, '2015-04-01 01:11:12.000000', 'consum', 0.0211, 'lps'),
	(472851, 124, '2015-04-01 01:11:13.000000', 'consum', 0.0226, 'lps'),
	(472852, 124, '2015-04-01 01:11:14.000000', 'consum', 0.0233, 'lps'),
	(472853, 124, '2015-04-01 01:11:15.000000', 'consum', 0.0228, 'lps'),
	(472854, 124, '2015-04-01 01:11:16.000000', 'consum', 0.0232, 'lps'),
	(472855, 124, '2015-04-01 01:11:17.000000', 'consum', 0.0215, 'lps'),
	(472856, 124, '2015-04-01 01:11:18.000000', 'consum', 0.0223, 'lps'),
	(472857, 124, '2015-04-01 01:11:19.000000', 'consum', 0.0231, 'lps'),
	(472858, 124, '2015-04-01 01:11:20.000000', 'consum', 0.0224, 'lps'),
	(472859, 124, '2015-04-01 01:11:21.000000', 'consum', 0.0219, 'lps'),
	(472860, 124, '2015-04-01 01:11:22.000000', 'consum', 0.0212, 'lps'),
	(472861, 124, '2015-04-01 01:11:23.000000', 'consum', 0.0219, 'lps'),
	(472862, 124, '2015-04-01 01:11:24.000000', 'consum', 0.0226, 'lps'),
	(472863, 124, '2015-04-01 01:11:25.000000', 'consum', 0.0212, 'lps'),
	(472864, 124, '2015-04-01 01:11:26.000000', 'consum', 0.0225, 'lps'),
	(472865, 124, '2015-04-01 01:11:27.000000', 'consum', 0.0226, 'lps'),
	(472866, 124, '2015-04-01 01:11:28.000000', 'consum', 0.0221, 'lps'),
	(472867, 124, '2015-04-01 01:11:29.000000', 'consum', 0.0215, 'lps'),
	(472868, 124, '2015-04-01 01:11:30.000000', 'consum', 0.0228, 'lps'),
	(472869, 124, '2015-04-01 01:11:31.000000', 'consum', 0.0234, 'lps'),
	(472870, 124, '2015-04-01 01:11:32.000000', 'consum', 0.0226, 'lps'),
	(472871, 124, '2015-04-01 01:11:33.000000', 'consum', 0.0219, 'lps'),
	(472872, 124, '2015-04-01 01:11:34.000000', 'consum', 0.0233, 'lps'),
	(472873, 124, '2015-04-01 01:11:35.000000', 'consum', 0.0219, 'lps'),
	(472874, 124, '2015-04-01 01:11:36.000000', 'consum', 0.0215, 'lps'),
	(472875, 124, '2015-04-01 01:11:37.000000', 'consum', 0.0233, 'lps'),
	(472876, 124, '2015-04-01 01:11:38.000000', 'consum', 0.0234, 'lps'),
	(472877, 124, '2015-04-01 01:11:39.000000', 'consum', 0.0210, 'lps'),
	(472878, 124, '2015-04-01 01:11:40.000000', 'consum', 0.0217, 'lps'),
	(472879, 124, '2015-04-01 01:11:41.000000', 'consum', 0.0217, 'lps'),
	(472880, 124, '2015-04-01 01:11:42.000000', 'consum', 0.0225, 'lps'),
	(472881, 124, '2015-04-01 01:11:43.000000', 'consum', 0.0213, 'lps'),
	(472882, 124, '2015-04-01 01:11:44.000000', 'consum', 0.0234, 'lps'),
	(472883, 124, '2015-04-01 01:11:45.000000', 'consum', 0.0215, 'lps'),
	(472884, 124, '2015-04-01 01:11:46.000000', 'consum', 0.0217, 'lps'),
	(472885, 124, '2015-04-01 01:11:47.000000', 'consum', 0.0232, 'lps'),
	(472886, 124, '2015-04-01 01:11:48.000000', 'consum', 0.0219, 'lps'),
	(472887, 124, '2015-04-01 01:11:49.000000', 'consum', 0.0217, 'lps'),
	(472888, 124, '2015-04-01 01:11:50.000000', 'consum', 0.0218, 'lps'),
	(472889, 124, '2015-04-01 01:11:51.000000', 'consum', 0.0232, 'lps'),
	(472890, 124, '2015-04-01 01:11:52.000000', 'consum', 0.0215, 'lps'),
	(472891, 124, '2015-04-01 01:11:53.000000', 'consum', 0.0221, 'lps'),
	(472892, 124, '2015-04-01 01:11:54.000000', 'consum', 0.0227, 'lps'),
	(472893, 124, '2015-04-01 01:11:55.000000', 'consum', 0.0235, 'lps'),
	(472894, 124, '2015-04-01 01:11:56.000000', 'consum', 0.0232, 'lps'),
	(472895, 124, '2015-04-01 01:11:57.000000', 'consum', 0.0219, 'lps'),
	(472896, 124, '2015-04-01 01:11:58.000000', 'consum', 0.0214, 'lps'),
	(472897, 124, '2015-04-01 01:11:59.000000', 'consum', 0.0233, 'lps'),
	(472898, 124, '2015-04-01 01:12:00.000000', 'consum', 0.0233, 'lps'),
	(472899, 124, '2015-04-01 01:12:01.000000', 'consum', 0.0229, 'lps'),
	(472900, 124, '2015-04-01 01:12:02.000000', 'consum', 0.0213, 'lps'),
	(472901, 124, '2015-04-01 01:12:03.000000', 'consum', 0.0221, 'lps'),
	(472902, 124, '2015-04-01 01:12:04.000000', 'consum', 0.0228, 'lps'),
	(472903, 124, '2015-04-01 01:12:05.000000', 'consum', 0.0217, 'lps'),
	(472904, 124, '2015-04-01 01:12:06.000000', 'consum', 0.0219, 'lps'),
	(472905, 124, '2015-04-01 01:12:07.000000', 'consum', 0.0235, 'lps'),
	(472906, 124, '2015-04-01 01:12:08.000000', 'consum', 0.0230, 'lps'),
	(472907, 124, '2015-04-01 01:12:09.000000', 'consum', 0.0233, 'lps'),
	(472908, 124, '2015-04-01 01:12:10.000000', 'consum', 0.0216, 'lps'),
	(472909, 124, '2015-04-01 01:12:11.000000', 'consum', 0.0222, 'lps'),
	(472910, 124, '2015-04-01 01:12:12.000000', 'consum', 0.0228, 'lps'),
	(472911, 124, '2015-04-01 01:12:13.000000', 'consum', 0.0212, 'lps'),
	(472912, 124, '2015-04-01 01:12:14.000000', 'consum', 0.0220, 'lps'),
	(472913, 124, '2015-04-01 01:12:15.000000', 'consum', 0.0229, 'lps'),
	(472914, 124, '2015-04-01 01:12:16.000000', 'consum', 0.0223, 'lps'),
	(472915, 124, '2015-04-01 01:12:17.000000', 'consum', 0.0216, 'lps'),
	(472916, 124, '2015-04-01 01:12:18.000000', 'consum', 0.0230, 'lps'),
	(472917, 124, '2015-04-01 01:12:19.000000', 'consum', 0.0213, 'lps'),
	(472918, 124, '2015-04-01 01:12:20.000000', 'consum', 0.0217, 'lps'),
	(472919, 124, '2015-04-01 01:12:21.000000', 'consum', 0.0210, 'lps'),
	(472920, 124, '2015-04-01 01:12:22.000000', 'consum', 0.0218, 'lps'),
	(472921, 124, '2015-04-01 01:12:23.000000', 'consum', 0.0225, 'lps'),
	(472922, 124, '2015-04-01 01:12:24.000000', 'consum', 0.0233, 'lps'),
	(472923, 124, '2015-04-01 01:12:25.000000', 'consum', 0.0229, 'lps'),
	(472924, 124, '2015-04-01 01:12:26.000000', 'consum', 0.0212, 'lps'),
	(472925, 124, '2015-04-01 01:12:27.000000', 'consum', 0.0213, 'lps'),
	(472926, 124, '2015-04-01 01:12:28.000000', 'consum', 0.0220, 'lps'),
	(472927, 124, '2015-04-01 01:12:29.000000', 'consum', 0.0228, 'lps'),
	(472928, 124, '2015-04-01 01:12:30.000000', 'consum', 0.0216, 'lps'),
	(472929, 124, '2015-04-01 01:12:31.000000', 'consum', 0.0213, 'lps'),
	(472930, 124, '2015-04-01 01:12:32.000000', 'consum', 0.0233, 'lps'),
	(472931, 124, '2015-04-01 01:12:33.000000', 'consum', 0.0215, 'lps'),
	(472932, 124, '2015-04-01 01:12:34.000000', 'consum', 0.0216, 'lps'),
	(472933, 124, '2015-04-01 01:12:35.000000', 'consum', 0.0224, 'lps'),
	(472934, 124, '2015-04-01 01:12:36.000000', 'consum', 0.0214, 'lps'),
	(472935, 124, '2015-04-01 01:12:37.000000', 'consum', 0.0213, 'lps'),
	(472936, 124, '2015-04-01 01:12:38.000000', 'consum', 0.0215, 'lps'),
	(472937, 124, '2015-04-01 01:12:39.000000', 'consum', 0.0224, 'lps'),
	(472938, 124, '2015-04-01 01:12:40.000000', 'consum', 0.0216, 'lps'),
	(472939, 124, '2015-04-01 01:12:41.000000', 'consum', 0.0225, 'lps'),
	(472940, 124, '2015-04-01 01:12:42.000000', 'consum', 0.0214, 'lps'),
	(472941, 124, '2015-04-01 01:12:43.000000', 'consum', 0.0212, 'lps'),
	(472942, 124, '2015-04-01 01:12:44.000000', 'consum', 0.0210, 'lps'),
	(472943, 124, '2015-04-01 01:12:45.000000', 'consum', 0.0230, 'lps'),
	(472944, 124, '2015-04-01 01:12:46.000000', 'consum', 0.0232, 'lps'),
	(472945, 124, '2015-04-01 01:12:47.000000', 'consum', 0.0234, 'lps'),
	(472946, 124, '2015-04-01 01:12:48.000000', 'consum', 0.0213, 'lps'),
	(472947, 124, '2015-04-01 01:12:49.000000', 'consum', 0.0232, 'lps'),
	(472948, 124, '2015-04-01 01:12:50.000000', 'consum', 0.0234, 'lps'),
	(472949, 124, '2015-04-01 01:12:51.000000', 'consum', 0.0213, 'lps'),
	(472950, 124, '2015-04-01 01:12:52.000000', 'consum', 0.0231, 'lps'),
	(472951, 124, '2015-04-01 01:12:53.000000', 'consum', 0.0227, 'lps'),
	(472952, 124, '2015-04-01 01:12:54.000000', 'consum', 0.0234, 'lps'),
	(472953, 124, '2015-04-01 01:12:55.000000', 'consum', 0.0229, 'lps'),
	(472954, 124, '2015-04-01 01:12:56.000000', 'consum', 0.0231, 'lps'),
	(472955, 124, '2015-04-01 01:12:57.000000', 'consum', 0.0235, 'lps'),
	(472956, 124, '2015-04-01 01:12:58.000000', 'consum', 0.0217, 'lps'),
	(472957, 124, '2015-04-01 01:12:59.000000', 'consum', 0.0225, 'lps'),
	(472958, 124, '2015-04-01 01:13:00.000000', 'consum', 0.0213, 'lps'),
	(472959, 124, '2015-04-01 01:13:01.000000', 'consum', 0.0233, 'lps'),
	(472960, 124, '2015-04-01 01:13:02.000000', 'consum', 0.0210, 'lps'),
	(472961, 124, '2015-04-01 01:13:03.000000', 'consum', 0.0219, 'lps'),
	(472962, 124, '2015-04-01 01:13:04.000000', 'consum', 0.0229, 'lps'),
	(472963, 124, '2015-04-01 01:13:05.000000', 'consum', 0.0228, 'lps'),
	(472964, 124, '2015-04-01 01:13:06.000000', 'consum', 0.0218, 'lps'),
	(472965, 124, '2015-04-01 01:13:07.000000', 'consum', 0.0220, 'lps'),
	(472966, 124, '2015-04-01 01:13:08.000000', 'consum', 0.0213, 'lps'),
	(472967, 124, '2015-04-01 01:13:09.000000', 'consum', 0.0222, 'lps'),
	(472968, 124, '2015-04-01 01:13:10.000000', 'consum', 0.0233, 'lps'),
	(472969, 124, '2015-04-01 01:13:11.000000', 'consum', 0.0212, 'lps'),
	(472970, 124, '2015-04-01 01:13:12.000000', 'consum', 0.0229, 'lps'),
	(472971, 124, '2015-04-01 01:13:13.000000', 'consum', 0.0221, 'lps'),
	(472972, 124, '2015-04-01 01:13:14.000000', 'consum', 0.0235, 'lps'),
	(472973, 124, '2015-04-01 01:13:15.000000', 'consum', 0.0223, 'lps'),
	(472974, 124, '2015-04-01 01:13:16.000000', 'consum', 0.0227, 'lps'),
	(472975, 124, '2015-04-01 01:13:17.000000', 'consum', 0.0231, 'lps'),
	(472976, 124, '2015-04-01 01:13:18.000000', 'consum', 0.0213, 'lps'),
	(472977, 124, '2015-04-01 01:13:19.000000', 'consum', 0.0215, 'lps'),
	(472978, 124, '2015-04-01 01:13:20.000000', 'consum', 0.0225, 'lps'),
	(472979, 124, '2015-04-01 01:13:21.000000', 'consum', 0.0220, 'lps'),
	(472980, 124, '2015-04-01 01:13:22.000000', 'consum', 0.0213, 'lps'),
	(472981, 124, '2015-04-01 01:13:23.000000', 'consum', 0.0224, 'lps'),
	(472982, 124, '2015-04-01 01:13:24.000000', 'consum', 0.0218, 'lps'),
	(472983, 124, '2015-04-01 01:13:25.000000', 'consum', 0.0234, 'lps'),
	(472984, 124, '2015-04-01 01:13:26.000000', 'consum', 0.0230, 'lps'),
	(472985, 124, '2015-04-01 01:13:27.000000', 'consum', 0.0213, 'lps'),
	(472986, 124, '2015-04-01 01:13:28.000000', 'consum', 0.0218, 'lps'),
	(472987, 124, '2015-04-01 01:13:29.000000', 'consum', 0.0215, 'lps'),
	(472988, 124, '2015-04-01 01:13:30.000000', 'consum', 0.0235, 'lps'),
	(472989, 124, '2015-04-01 01:13:31.000000', 'consum', 0.0219, 'lps'),
	(472990, 124, '2015-04-01 01:13:32.000000', 'consum', 0.0233, 'lps'),
	(472991, 124, '2015-04-01 01:13:33.000000', 'consum', 0.0221, 'lps'),
	(472992, 124, '2015-04-01 01:13:34.000000', 'consum', 0.0220, 'lps'),
	(472993, 124, '2015-04-01 01:13:35.000000', 'consum', 0.0227, 'lps'),
	(472994, 124, '2015-04-01 01:13:36.000000', 'consum', 0.0216, 'lps'),
	(472995, 124, '2015-04-01 01:13:37.000000', 'consum', 0.0216, 'lps'),
	(472996, 124, '2015-04-01 01:13:38.000000', 'consum', 0.0222, 'lps'),
	(472997, 124, '2015-04-01 01:13:39.000000', 'consum', 0.0224, 'lps'),
	(472998, 124, '2015-04-01 01:13:40.000000', 'consum', 0.0220, 'lps'),
	(472999, 124, '2015-04-01 01:13:41.000000', 'consum', 0.0219, 'lps'),
	(473000, 124, '2015-04-01 01:13:42.000000', 'consum', 0.0225, 'lps'),
	(473001, 124, '2015-04-01 01:13:43.000000', 'consum', 0.0233, 'lps'),
	(473002, 124, '2015-04-01 01:13:44.000000', 'consum', 0.0228, 'lps'),
	(473003, 124, '2015-04-01 01:13:45.000000', 'consum', 0.0233, 'lps'),
	(473004, 124, '2015-04-01 01:13:46.000000', 'consum', 0.0218, 'lps'),
	(473005, 124, '2015-04-01 01:13:47.000000', 'consum', 0.0234, 'lps'),
	(473006, 124, '2015-04-01 01:13:48.000000', 'consum', 0.0229, 'lps'),
	(473007, 124, '2015-04-01 01:13:49.000000', 'consum', 0.0232, 'lps'),
	(473008, 124, '2015-04-01 01:13:50.000000', 'consum', 0.0211, 'lps'),
	(473009, 124, '2015-04-01 01:13:51.000000', 'consum', 0.0230, 'lps'),
	(473010, 124, '2015-04-01 01:13:52.000000', 'consum', 0.0227, 'lps'),
	(473011, 124, '2015-04-01 01:13:53.000000', 'consum', 0.0211, 'lps'),
	(473012, 124, '2015-04-01 01:13:54.000000', 'consum', 0.0217, 'lps'),
	(473013, 124, '2015-04-01 01:13:55.000000', 'consum', 0.0216, 'lps'),
	(473014, 124, '2015-04-01 01:13:56.000000', 'consum', 0.0221, 'lps'),
	(473015, 124, '2015-04-01 01:13:57.000000', 'consum', 0.0219, 'lps'),
	(473016, 124, '2015-04-01 01:13:58.000000', 'consum', 0.0224, 'lps'),
	(473017, 124, '2015-04-01 01:13:59.000000', 'consum', 0.0228, 'lps'),
	(473018, 124, '2015-04-01 01:14:00.000000', 'consum', 0.0233, 'lps'),
	(473019, 124, '2015-04-01 01:14:01.000000', 'consum', 0.0220, 'lps'),
	(473020, 124, '2015-04-01 01:14:02.000000', 'consum', 0.0215, 'lps'),
	(473021, 124, '2015-04-01 01:14:03.000000', 'consum', 0.0232, 'lps'),
	(473022, 124, '2015-04-01 01:14:04.000000', 'consum', 0.0227, 'lps'),
	(473023, 124, '2015-04-01 01:14:05.000000', 'consum', 0.0231, 'lps'),
	(473024, 124, '2015-04-01 01:14:06.000000', 'consum', 0.0211, 'lps'),
	(473025, 124, '2015-04-01 01:14:07.000000', 'consum', 0.0233, 'lps'),
	(473026, 124, '2015-04-01 01:14:08.000000', 'consum', 0.0218, 'lps'),
	(473027, 124, '2015-04-01 01:14:09.000000', 'consum', 0.0235, 'lps'),
	(473028, 124, '2015-04-01 01:14:10.000000', 'consum', 0.0231, 'lps'),
	(473029, 124, '2015-04-01 01:14:11.000000', 'consum', 0.0214, 'lps'),
	(473030, 124, '2015-04-01 01:14:12.000000', 'consum', 0.0222, 'lps'),
	(473031, 124, '2015-04-01 01:14:13.000000', 'consum', 0.0233, 'lps'),
	(473032, 124, '2015-04-01 01:14:14.000000', 'consum', 0.0210, 'lps'),
	(473033, 124, '2015-04-01 01:14:15.000000', 'consum', 0.0221, 'lps'),
	(473034, 124, '2015-04-01 01:14:16.000000', 'consum', 0.0212, 'lps'),
	(473035, 124, '2015-04-01 01:14:17.000000', 'consum', 0.0213, 'lps'),
	(473036, 124, '2015-04-01 01:14:18.000000', 'consum', 0.0221, 'lps'),
	(473037, 124, '2015-04-01 01:14:19.000000', 'consum', 0.0229, 'lps'),
	(473038, 124, '2015-04-01 01:14:20.000000', 'consum', 0.0222, 'lps'),
	(473039, 124, '2015-04-01 01:14:21.000000', 'consum', 0.0212, 'lps'),
	(473040, 124, '2015-04-01 01:14:22.000000', 'consum', 0.0212, 'lps'),
	(473041, 124, '2015-04-01 01:14:23.000000', 'consum', 0.0212, 'lps'),
	(473042, 124, '2015-04-01 01:14:24.000000', 'consum', 0.0217, 'lps'),
	(473043, 124, '2015-04-01 01:14:25.000000', 'consum', 0.0211, 'lps'),
	(473044, 124, '2015-04-01 01:14:26.000000', 'consum', 0.0220, 'lps'),
	(473045, 124, '2015-04-01 01:14:27.000000', 'consum', 0.0232, 'lps'),
	(473046, 124, '2015-04-01 01:14:28.000000', 'consum', 0.0213, 'lps'),
	(473047, 124, '2015-04-01 01:14:29.000000', 'consum', 0.0235, 'lps'),
	(473048, 124, '2015-04-01 01:14:30.000000', 'consum', 0.0226, 'lps'),
	(473049, 124, '2015-04-01 01:14:31.000000', 'consum', 0.0215, 'lps'),
	(473050, 124, '2015-04-01 01:14:32.000000', 'consum', 0.0213, 'lps'),
	(473051, 124, '2015-04-01 01:14:33.000000', 'consum', 0.0235, 'lps'),
	(473052, 124, '2015-04-01 01:14:34.000000', 'consum', 0.0222, 'lps'),
	(473053, 124, '2015-04-01 01:14:35.000000', 'consum', 0.0222, 'lps'),
	(473054, 124, '2015-04-01 01:14:36.000000', 'consum', 0.0235, 'lps'),
	(473055, 124, '2015-04-01 01:14:37.000000', 'consum', 0.0222, 'lps'),
	(473056, 124, '2015-04-01 01:14:38.000000', 'consum', 0.0222, 'lps'),
	(473057, 124, '2015-04-01 01:14:39.000000', 'consum', 0.0234, 'lps'),
	(473058, 124, '2015-04-01 01:14:40.000000', 'consum', 0.0216, 'lps'),
	(473059, 124, '2015-04-01 01:14:41.000000', 'consum', 0.0221, 'lps'),
	(473060, 124, '2015-04-01 01:14:42.000000', 'consum', 0.0223, 'lps'),
	(473061, 124, '2015-04-01 01:14:43.000000', 'consum', 0.0217, 'lps'),
	(473062, 124, '2015-04-01 01:14:44.000000', 'consum', 0.0231, 'lps'),
	(473063, 124, '2015-04-01 01:14:45.000000', 'consum', 0.0218, 'lps'),
	(473064, 124, '2015-04-01 01:14:46.000000', 'consum', 0.0211, 'lps'),
	(473065, 124, '2015-04-01 01:14:47.000000', 'consum', 0.0220, 'lps'),
	(473066, 124, '2015-04-01 01:14:48.000000', 'consum', 0.0231, 'lps'),
	(473067, 124, '2015-04-01 01:14:49.000000', 'consum', 0.0234, 'lps'),
	(473068, 124, '2015-04-01 01:14:50.000000', 'consum', 0.0215, 'lps'),
	(473069, 124, '2015-04-01 01:14:51.000000', 'consum', 0.0215, 'lps'),
	(473070, 124, '2015-04-01 01:14:52.000000', 'consum', 0.0221, 'lps'),
	(473071, 124, '2015-04-01 01:14:53.000000', 'consum', 0.0224, 'lps'),
	(473072, 124, '2015-04-01 01:14:54.000000', 'consum', 0.0222, 'lps'),
	(473073, 124, '2015-04-01 01:14:55.000000', 'consum', 0.0229, 'lps'),
	(473074, 124, '2015-04-01 01:14:56.000000', 'consum', 0.0216, 'lps'),
	(473075, 124, '2015-04-01 01:14:57.000000', 'consum', 0.0235, 'lps'),
	(473076, 124, '2015-04-01 01:14:58.000000', 'consum', 0.0216, 'lps'),
	(473077, 124, '2015-04-01 01:14:59.000000', 'consum', 0.0216, 'lps'),
	(473078, 124, '2015-04-01 01:15:00.000000', 'consum', 0.0225, 'lps'),
	(473079, 124, '2015-04-01 01:15:01.000000', 'consum', 0.0213, 'lps'),
	(473080, 124, '2015-04-01 01:15:02.000000', 'consum', 0.0235, 'lps'),
	(473081, 124, '2015-04-01 01:15:03.000000', 'consum', 0.0220, 'lps'),
	(473082, 124, '2015-04-01 01:15:04.000000', 'consum', 0.0211, 'lps'),
	(473083, 124, '2015-04-01 01:15:05.000000', 'consum', 0.0214, 'lps'),
	(473084, 124, '2015-04-01 01:15:06.000000', 'consum', 0.0227, 'lps'),
	(473085, 124, '2015-04-01 01:15:07.000000', 'consum', 0.0231, 'lps'),
	(473086, 124, '2015-04-01 01:15:08.000000', 'consum', 0.0214, 'lps'),
	(473087, 124, '2015-04-01 01:15:09.000000', 'consum', 0.0219, 'lps'),
	(473088, 124, '2015-04-01 01:15:10.000000', 'consum', 0.0216, 'lps'),
	(473089, 124, '2015-04-01 01:15:11.000000', 'consum', 0.0214, 'lps'),
	(473090, 124, '2015-04-01 01:15:12.000000', 'consum', 0.0211, 'lps'),
	(473091, 124, '2015-04-01 01:15:13.000000', 'consum', 0.0232, 'lps'),
	(473092, 124, '2015-04-01 01:15:14.000000', 'consum', 0.0214, 'lps'),
	(473093, 124, '2015-04-01 01:15:15.000000', 'consum', 0.0216, 'lps'),
	(473094, 124, '2015-04-01 01:15:16.000000', 'consum', 0.0228, 'lps'),
	(473095, 124, '2015-04-01 01:15:17.000000', 'consum', 0.0231, 'lps'),
	(473096, 124, '2015-04-01 01:15:18.000000', 'consum', 0.0233, 'lps'),
	(473097, 124, '2015-04-01 01:15:19.000000', 'consum', 0.0214, 'lps'),
	(473098, 124, '2015-04-01 01:15:20.000000', 'consum', 0.0213, 'lps'),
	(473099, 124, '2015-04-01 01:15:21.000000', 'consum', 0.0211, 'lps'),
	(473100, 124, '2015-04-01 01:15:22.000000', 'consum', 0.0233, 'lps'),
	(473101, 124, '2015-04-01 01:15:23.000000', 'consum', 0.0221, 'lps'),
	(473102, 124, '2015-04-01 01:15:24.000000', 'consum', 0.0220, 'lps'),
	(473103, 124, '2015-04-01 01:15:25.000000', 'consum', 0.0229, 'lps'),
	(473104, 124, '2015-04-01 01:15:26.000000', 'consum', 0.0221, 'lps'),
	(473105, 124, '2015-04-01 01:15:27.000000', 'consum', 0.0212, 'lps'),
	(473106, 124, '2015-04-01 01:15:28.000000', 'consum', 0.0210, 'lps'),
	(473107, 124, '2015-04-01 01:15:29.000000', 'consum', 0.0233, 'lps'),
	(473108, 124, '2015-04-01 01:15:30.000000', 'consum', 0.0221, 'lps'),
	(473109, 124, '2015-04-01 01:15:31.000000', 'consum', 0.0223, 'lps'),
	(473110, 124, '2015-04-01 01:15:32.000000', 'consum', 0.0218, 'lps'),
	(473111, 124, '2015-04-01 01:15:33.000000', 'consum', 0.0210, 'lps'),
	(473112, 124, '2015-04-01 01:15:34.000000', 'consum', 0.0214, 'lps'),
	(473113, 124, '2015-04-01 01:15:35.000000', 'consum', 0.0228, 'lps'),
	(473114, 124, '2015-04-01 01:15:36.000000', 'consum', 0.0210, 'lps'),
	(473115, 124, '2015-04-01 01:15:37.000000', 'consum', 0.0235, 'lps'),
	(473116, 124, '2015-04-01 01:15:38.000000', 'consum', 0.0230, 'lps'),
	(473117, 124, '2015-04-01 01:15:39.000000', 'consum', 0.0212, 'lps'),
	(473118, 124, '2015-04-01 01:15:40.000000', 'consum', 0.0214, 'lps'),
	(473119, 124, '2015-04-01 01:15:41.000000', 'consum', 0.0221, 'lps'),
	(473120, 124, '2015-04-01 01:15:42.000000', 'consum', 0.0229, 'lps'),
	(473121, 124, '2015-04-01 01:15:43.000000', 'consum', 0.0218, 'lps'),
	(473122, 124, '2015-04-01 01:15:44.000000', 'consum', 0.0223, 'lps'),
	(473123, 124, '2015-04-01 01:15:45.000000', 'consum', 0.0225, 'lps'),
	(473124, 124, '2015-04-01 01:15:46.000000', 'consum', 0.0221, 'lps'),
	(473125, 124, '2015-04-01 01:15:47.000000', 'consum', 0.0219, 'lps'),
	(473126, 124, '2015-04-01 01:15:48.000000', 'consum', 0.0225, 'lps'),
	(473127, 124, '2015-04-01 01:15:49.000000', 'consum', 0.0230, 'lps'),
	(473128, 124, '2015-04-01 01:15:50.000000', 'consum', 0.0215, 'lps'),
	(473129, 124, '2015-04-01 01:15:51.000000', 'consum', 0.0226, 'lps'),
	(473130, 124, '2015-04-01 01:15:52.000000', 'consum', 0.0223, 'lps'),
	(473131, 124, '2015-04-01 01:15:53.000000', 'consum', 0.0226, 'lps'),
	(473132, 124, '2015-04-01 01:15:54.000000', 'consum', 0.0228, 'lps'),
	(473133, 124, '2015-04-01 01:15:55.000000', 'consum', 0.0226, 'lps'),
	(473134, 124, '2015-04-01 01:15:56.000000', 'consum', 0.0235, 'lps'),
	(473135, 124, '2015-04-01 01:15:57.000000', 'consum', 0.0235, 'lps'),
	(473136, 124, '2015-04-01 01:15:58.000000', 'consum', 0.0235, 'lps'),
	(473137, 124, '2015-04-01 01:15:59.000000', 'consum', 0.0210, 'lps'),
	(473138, 124, '2015-04-01 01:16:00.000000', 'consum', 0.0213, 'lps'),
	(473139, 124, '2015-04-01 01:16:01.000000', 'consum', 0.0227, 'lps'),
	(473140, 124, '2015-04-01 01:16:02.000000', 'consum', 0.0232, 'lps'),
	(473141, 124, '2015-04-01 01:16:03.000000', 'consum', 0.0219, 'lps'),
	(473142, 124, '2015-04-01 01:16:04.000000', 'consum', 0.0214, 'lps'),
	(473143, 124, '2015-04-01 01:16:05.000000', 'consum', 0.0231, 'lps'),
	(473144, 124, '2015-04-01 01:16:06.000000', 'consum', 0.0227, 'lps'),
	(473145, 124, '2015-04-01 01:16:07.000000', 'consum', 0.0229, 'lps'),
	(473146, 124, '2015-04-01 01:16:08.000000', 'consum', 0.0232, 'lps'),
	(473147, 124, '2015-04-01 01:16:09.000000', 'consum', 0.0210, 'lps'),
	(473148, 124, '2015-04-01 01:16:10.000000', 'consum', 0.0223, 'lps'),
	(473149, 124, '2015-04-01 01:16:11.000000', 'consum', 0.0225, 'lps'),
	(473150, 124, '2015-04-01 01:16:12.000000', 'consum', 0.0219, 'lps'),
	(473151, 124, '2015-04-01 01:16:13.000000', 'consum', 0.0212, 'lps'),
	(473152, 124, '2015-04-01 01:16:14.000000', 'consum', 0.0220, 'lps'),
	(473153, 124, '2015-04-01 01:16:15.000000', 'consum', 0.0227, 'lps'),
	(473154, 124, '2015-04-01 01:16:16.000000', 'consum', 0.0213, 'lps'),
	(473155, 124, '2015-04-01 01:16:17.000000', 'consum', 0.0228, 'lps'),
	(473156, 124, '2015-04-01 01:16:18.000000', 'consum', 0.0213, 'lps'),
	(473157, 124, '2015-04-01 01:16:19.000000', 'consum', 0.0224, 'lps'),
	(473158, 124, '2015-04-01 01:16:20.000000', 'consum', 0.0219, 'lps'),
	(473159, 124, '2015-04-01 01:16:21.000000', 'consum', 0.0213, 'lps'),
	(473160, 124, '2015-04-01 01:16:22.000000', 'consum', 0.0223, 'lps'),
	(473161, 124, '2015-04-01 01:16:23.000000', 'consum', 0.0218, 'lps'),
	(473162, 124, '2015-04-01 01:16:24.000000', 'consum', 0.0210, 'lps'),
	(473163, 124, '2015-04-01 01:16:25.000000', 'consum', 0.0211, 'lps'),
	(473164, 124, '2015-04-01 01:16:26.000000', 'consum', 0.0217, 'lps'),
	(473165, 124, '2015-04-01 01:16:27.000000', 'consum', 0.0216, 'lps'),
	(473166, 124, '2015-04-01 01:16:28.000000', 'consum', 0.0221, 'lps'),
	(473167, 124, '2015-04-01 01:16:29.000000', 'consum', 0.0219, 'lps'),
	(473168, 124, '2015-04-01 01:16:30.000000', 'consum', 0.0221, 'lps'),
	(473169, 124, '2015-04-01 01:16:31.000000', 'consum', 0.0216, 'lps'),
	(473170, 124, '2015-04-01 01:16:32.000000', 'consum', 0.0233, 'lps'),
	(473171, 124, '2015-04-01 01:16:33.000000', 'consum', 0.0230, 'lps'),
	(473172, 124, '2015-04-01 01:16:34.000000', 'consum', 0.0214, 'lps'),
	(473173, 124, '2015-04-01 01:16:35.000000', 'consum', 0.0224, 'lps'),
	(473174, 124, '2015-04-01 01:16:36.000000', 'consum', 0.0215, 'lps'),
	(473175, 124, '2015-04-01 01:16:37.000000', 'consum', 0.0222, 'lps'),
	(473176, 124, '2015-04-01 01:16:38.000000', 'consum', 0.0227, 'lps'),
	(473177, 124, '2015-04-01 01:16:39.000000', 'consum', 0.0234, 'lps'),
	(473178, 124, '2015-04-01 01:16:40.000000', 'consum', 0.0226, 'lps'),
	(473179, 124, '2015-04-01 01:16:41.000000', 'consum', 0.0219, 'lps'),
	(473180, 124, '2015-04-01 01:16:42.000000', 'consum', 0.0232, 'lps'),
	(473181, 124, '2015-04-01 01:16:43.000000', 'consum', 0.0219, 'lps'),
	(473182, 124, '2015-04-01 01:16:44.000000', 'consum', 0.0213, 'lps'),
	(473183, 124, '2015-04-01 01:16:45.000000', 'consum', 0.0224, 'lps'),
	(473184, 124, '2015-04-01 01:16:46.000000', 'consum', 0.0222, 'lps'),
	(473185, 124, '2015-04-01 01:16:47.000000', 'consum', 0.0229, 'lps'),
	(473186, 124, '2015-04-01 01:16:48.000000', 'consum', 0.0215, 'lps'),
	(473187, 124, '2015-04-01 01:16:49.000000', 'consum', 0.0233, 'lps'),
	(473188, 124, '2015-04-01 01:16:50.000000', 'consum', 0.0233, 'lps'),
	(473189, 124, '2015-04-01 01:16:51.000000', 'consum', 0.0229, 'lps'),
	(473190, 124, '2015-04-01 01:16:52.000000', 'consum', 0.0212, 'lps'),
	(473191, 124, '2015-04-01 01:16:53.000000', 'consum', 0.0214, 'lps'),
	(473192, 124, '2015-04-01 01:16:54.000000', 'consum', 0.0223, 'lps'),
	(473193, 124, '2015-04-01 01:16:55.000000', 'consum', 0.0213, 'lps'),
	(473194, 124, '2015-04-01 01:16:56.000000', 'consum', 0.0211, 'lps'),
	(473195, 124, '2015-04-01 01:16:57.000000', 'consum', 0.0234, 'lps'),
	(473196, 124, '2015-04-01 01:16:58.000000', 'consum', 0.0222, 'lps'),
	(473197, 124, '2015-04-01 01:16:59.000000', 'consum', 0.0226, 'lps'),
	(473198, 124, '2015-04-01 01:17:00.000000', 'consum', 0.0227, 'lps'),
	(473199, 124, '2015-04-01 01:17:01.000000', 'consum', 0.0222, 'lps'),
	(473200, 124, '2015-04-01 01:17:02.000000', 'consum', 0.0220, 'lps'),
	(473201, 124, '2015-04-01 01:17:03.000000', 'consum', 0.0224, 'lps'),
	(473202, 124, '2015-04-01 01:17:04.000000', 'consum', 0.0223, 'lps'),
	(473203, 124, '2015-04-01 01:17:05.000000', 'consum', 0.0234, 'lps'),
	(473204, 124, '2015-04-01 01:17:06.000000', 'consum', 0.0212, 'lps'),
	(473205, 124, '2015-04-01 01:17:07.000000', 'consum', 0.0230, 'lps'),
	(473206, 124, '2015-04-01 01:17:08.000000', 'consum', 0.0223, 'lps'),
	(473207, 124, '2015-04-01 01:17:09.000000', 'consum', 0.0218, 'lps'),
	(473208, 124, '2015-04-01 01:17:10.000000', 'consum', 0.0235, 'lps'),
	(473209, 124, '2015-04-01 01:17:11.000000', 'consum', 0.0235, 'lps'),
	(473210, 124, '2015-04-01 01:17:12.000000', 'consum', 0.0233, 'lps'),
	(473211, 124, '2015-04-01 01:17:13.000000', 'consum', 0.0224, 'lps'),
	(473212, 124, '2015-04-01 01:17:14.000000', 'consum', 0.0214, 'lps'),
	(473213, 124, '2015-04-01 01:17:15.000000', 'consum', 0.0211, 'lps'),
	(473214, 124, '2015-04-01 01:17:16.000000', 'consum', 0.0233, 'lps'),
	(473215, 124, '2015-04-01 01:17:17.000000', 'consum', 0.0218, 'lps'),
	(473216, 124, '2015-04-01 01:17:18.000000', 'consum', 0.0231, 'lps'),
	(473217, 124, '2015-04-01 01:17:19.000000', 'consum', 0.0214, 'lps'),
	(473218, 124, '2015-04-01 01:17:20.000000', 'consum', 0.0222, 'lps'),
	(473219, 124, '2015-04-01 01:17:21.000000', 'consum', 0.0232, 'lps'),
	(473220, 124, '2015-04-01 01:17:22.000000', 'consum', 0.0231, 'lps'),
	(473221, 124, '2015-04-01 01:17:23.000000', 'consum', 0.0225, 'lps'),
	(473222, 124, '2015-04-01 01:17:24.000000', 'consum', 0.0221, 'lps'),
	(473223, 124, '2015-04-01 01:17:25.000000', 'consum', 0.0223, 'lps'),
	(473224, 124, '2015-04-01 01:17:26.000000', 'consum', 0.0216, 'lps'),
	(473225, 124, '2015-04-01 01:17:27.000000', 'consum', 0.0226, 'lps'),
	(473226, 124, '2015-04-01 01:17:28.000000', 'consum', 0.0223, 'lps'),
	(473227, 124, '2015-04-01 01:17:29.000000', 'consum', 0.0227, 'lps'),
	(473228, 124, '2015-04-01 01:17:30.000000', 'consum', 0.0230, 'lps'),
	(473229, 124, '2015-04-01 01:17:31.000000', 'consum', 0.0234, 'lps'),
	(473230, 124, '2015-04-01 01:17:32.000000', 'consum', 0.0218, 'lps'),
	(473231, 124, '2015-04-01 01:17:33.000000', 'consum', 0.0228, 'lps'),
	(473232, 124, '2015-04-01 01:17:34.000000', 'consum', 0.0228, 'lps'),
	(473233, 124, '2015-04-01 01:17:35.000000', 'consum', 0.0220, 'lps'),
	(473234, 124, '2015-04-01 01:17:36.000000', 'consum', 0.0234, 'lps'),
	(473235, 124, '2015-04-01 01:17:37.000000', 'consum', 0.0219, 'lps'),
	(473236, 124, '2015-04-01 01:17:38.000000', 'consum', 0.0212, 'lps'),
	(473237, 124, '2015-04-01 01:17:39.000000', 'consum', 0.0220, 'lps'),
	(473238, 124, '2015-04-01 01:17:40.000000', 'consum', 0.0226, 'lps'),
	(473239, 124, '2015-04-01 01:17:41.000000', 'consum', 0.0211, 'lps'),
	(473240, 124, '2015-04-01 01:17:42.000000', 'consum', 0.0218, 'lps'),
	(473241, 124, '2015-04-01 01:17:43.000000', 'consum', 0.0223, 'lps'),
	(473242, 124, '2015-04-01 01:17:44.000000', 'consum', 0.0224, 'lps'),
	(473243, 124, '2015-04-01 01:17:45.000000', 'consum', 0.0215, 'lps'),
	(473244, 124, '2015-04-01 01:17:46.000000', 'consum', 0.0219, 'lps'),
	(473245, 124, '2015-04-01 01:17:47.000000', 'consum', 0.0216, 'lps'),
	(473246, 124, '2015-04-01 01:17:48.000000', 'consum', 0.0211, 'lps'),
	(473247, 124, '2015-04-01 01:17:49.000000', 'consum', 0.0225, 'lps'),
	(473248, 124, '2015-04-01 01:17:50.000000', 'consum', 0.0229, 'lps'),
	(473249, 124, '2015-04-01 01:17:51.000000', 'consum', 0.0210, 'lps'),
	(473250, 124, '2015-04-01 01:17:52.000000', 'consum', 0.0233, 'lps'),
	(473251, 124, '2015-04-01 01:17:53.000000', 'consum', 0.0221, 'lps'),
	(473252, 124, '2015-04-01 01:17:54.000000', 'consum', 0.0223, 'lps'),
	(473253, 124, '2015-04-01 01:17:55.000000', 'consum', 0.0216, 'lps'),
	(473254, 124, '2015-04-01 01:17:56.000000', 'consum', 0.0228, 'lps'),
	(473255, 124, '2015-04-01 01:17:57.000000', 'consum', 0.0228, 'lps'),
	(473256, 124, '2015-04-01 01:17:58.000000', 'consum', 0.0223, 'lps'),
	(473257, 124, '2015-04-01 01:17:59.000000', 'consum', 0.0220, 'lps'),
	(473258, 124, '2015-04-01 01:18:00.000000', 'consum', 0.0222, 'lps'),
	(473259, 124, '2015-04-01 01:18:01.000000', 'consum', 0.0215, 'lps'),
	(473260, 124, '2015-04-01 01:18:02.000000', 'consum', 0.0225, 'lps'),
	(473261, 124, '2015-04-01 01:18:03.000000', 'consum', 0.0220, 'lps'),
	(473262, 124, '2015-04-01 01:18:04.000000', 'consum', 0.0216, 'lps'),
	(473263, 124, '2015-04-01 01:18:05.000000', 'consum', 0.0234, 'lps'),
	(473264, 124, '2015-04-01 01:18:06.000000', 'consum', 0.0210, 'lps'),
	(473265, 124, '2015-04-01 01:18:07.000000', 'consum', 0.0215, 'lps'),
	(473266, 124, '2015-04-01 01:18:08.000000', 'consum', 0.0211, 'lps'),
	(473267, 124, '2015-04-01 01:18:09.000000', 'consum', 0.0227, 'lps'),
	(473268, 124, '2015-04-01 01:18:10.000000', 'consum', 0.0212, 'lps'),
	(473269, 124, '2015-04-01 01:18:11.000000', 'consum', 0.0222, 'lps'),
	(473270, 124, '2015-04-01 01:18:12.000000', 'consum', 0.0212, 'lps'),
	(473271, 124, '2015-04-01 01:18:13.000000', 'consum', 0.0210, 'lps'),
	(473272, 124, '2015-04-01 01:18:14.000000', 'consum', 0.0231, 'lps'),
	(473273, 124, '2015-04-01 01:18:15.000000', 'consum', 0.0210, 'lps'),
	(473274, 124, '2015-04-01 01:18:16.000000', 'consum', 0.0226, 'lps'),
	(473275, 124, '2015-04-01 01:18:17.000000', 'consum', 0.0215, 'lps'),
	(473276, 124, '2015-04-01 01:18:18.000000', 'consum', 0.0211, 'lps'),
	(473277, 124, '2015-04-01 01:18:19.000000', 'consum', 0.0229, 'lps'),
	(473278, 124, '2015-04-01 01:18:20.000000', 'consum', 0.0223, 'lps'),
	(473279, 124, '2015-04-01 01:18:21.000000', 'consum', 0.0219, 'lps'),
	(473280, 124, '2015-04-01 01:18:22.000000', 'consum', 0.0216, 'lps'),
	(473281, 124, '2015-04-01 01:18:23.000000', 'consum', 0.0213, 'lps'),
	(473282, 124, '2015-04-01 01:18:24.000000', 'consum', 0.0232, 'lps'),
	(473283, 124, '2015-04-01 01:18:25.000000', 'consum', 0.0210, 'lps'),
	(473284, 124, '2015-04-01 01:18:26.000000', 'consum', 0.0224, 'lps'),
	(473285, 124, '2015-04-01 01:18:27.000000', 'consum', 0.0226, 'lps'),
	(473286, 124, '2015-04-01 01:18:28.000000', 'consum', 0.0222, 'lps'),
	(473287, 124, '2015-04-01 01:18:29.000000', 'consum', 0.0221, 'lps'),
	(473288, 124, '2015-04-01 01:18:30.000000', 'consum', 0.0232, 'lps'),
	(473289, 124, '2015-04-01 01:18:31.000000', 'consum', 0.0235, 'lps'),
	(473290, 124, '2015-04-01 01:18:32.000000', 'consum', 0.0216, 'lps'),
	(473291, 124, '2015-04-01 01:18:33.000000', 'consum', 0.0217, 'lps'),
	(473292, 124, '2015-04-01 01:18:34.000000', 'consum', 0.0228, 'lps'),
	(473293, 124, '2015-04-01 01:18:35.000000', 'consum', 0.0230, 'lps'),
	(473294, 124, '2015-04-01 01:18:36.000000', 'consum', 0.0227, 'lps'),
	(473295, 124, '2015-04-01 01:18:37.000000', 'consum', 0.0211, 'lps'),
	(473296, 124, '2015-04-01 01:18:38.000000', 'consum', 0.0219, 'lps'),
	(473297, 124, '2015-04-01 01:18:39.000000', 'consum', 0.0223, 'lps'),
	(473298, 124, '2015-04-01 01:18:40.000000', 'consum', 0.0223, 'lps'),
	(473299, 124, '2015-04-01 01:18:41.000000', 'consum', 0.0235, 'lps'),
	(473300, 124, '2015-04-01 01:18:42.000000', 'consum', 0.0220, 'lps'),
	(473301, 124, '2015-04-01 01:18:43.000000', 'consum', 0.0210, 'lps'),
	(473302, 124, '2015-04-01 01:18:44.000000', 'consum', 0.0234, 'lps'),
	(473303, 124, '2015-04-01 01:18:45.000000', 'consum', 0.0227, 'lps'),
	(473304, 124, '2015-04-01 01:18:46.000000', 'consum', 0.0224, 'lps'),
	(473305, 124, '2015-04-01 01:18:47.000000', 'consum', 0.0228, 'lps'),
	(473306, 124, '2015-04-01 01:18:48.000000', 'consum', 0.0232, 'lps'),
	(473307, 124, '2015-04-01 01:18:49.000000', 'consum', 0.0216, 'lps'),
	(473308, 124, '2015-04-01 01:18:50.000000', 'consum', 0.0225, 'lps'),
	(473309, 124, '2015-04-01 01:18:51.000000', 'consum', 0.0216, 'lps'),
	(473310, 124, '2015-04-01 01:18:52.000000', 'consum', 0.0222, 'lps'),
	(473311, 124, '2015-04-01 01:18:53.000000', 'consum', 0.0225, 'lps'),
	(473312, 124, '2015-04-01 01:18:54.000000', 'consum', 0.0222, 'lps'),
	(473313, 124, '2015-04-01 01:18:55.000000', 'consum', 0.0228, 'lps'),
	(473314, 124, '2015-04-01 01:18:56.000000', 'consum', 0.0213, 'lps'),
	(473315, 124, '2015-04-01 01:18:57.000000', 'consum', 0.0223, 'lps'),
	(473316, 124, '2015-04-01 01:18:58.000000', 'consum', 0.0215, 'lps'),
	(473317, 124, '2015-04-01 01:18:59.000000', 'consum', 0.0220, 'lps'),
	(473318, 124, '2015-04-01 01:19:00.000000', 'consum', 0.0222, 'lps'),
	(473319, 124, '2015-04-01 01:19:01.000000', 'consum', 0.0212, 'lps'),
	(473320, 124, '2015-04-01 01:19:02.000000', 'consum', 0.0211, 'lps'),
	(473321, 124, '2015-04-01 01:19:03.000000', 'consum', 0.0235, 'lps'),
	(473322, 124, '2015-04-01 01:19:04.000000', 'consum', 0.0229, 'lps'),
	(473323, 124, '2015-04-01 01:19:05.000000', 'consum', 0.0229, 'lps'),
	(473324, 124, '2015-04-01 01:19:06.000000', 'consum', 0.0222, 'lps'),
	(473325, 124, '2015-04-01 01:19:07.000000', 'consum', 0.0214, 'lps'),
	(473326, 124, '2015-04-01 01:19:08.000000', 'consum', 0.0221, 'lps'),
	(473327, 124, '2015-04-01 01:19:09.000000', 'consum', 0.0226, 'lps'),
	(473328, 124, '2015-04-01 01:19:10.000000', 'consum', 0.0231, 'lps'),
	(473329, 124, '2015-04-01 01:19:11.000000', 'consum', 0.0219, 'lps'),
	(473330, 124, '2015-04-01 01:19:12.000000', 'consum', 0.0215, 'lps'),
	(473331, 124, '2015-04-01 01:19:13.000000', 'consum', 0.0235, 'lps'),
	(473332, 124, '2015-04-01 01:19:14.000000', 'consum', 0.0218, 'lps'),
	(473333, 124, '2015-04-01 01:19:15.000000', 'consum', 0.0229, 'lps'),
	(473334, 124, '2015-04-01 01:19:16.000000', 'consum', 0.0227, 'lps'),
	(473335, 124, '2015-04-01 01:19:17.000000', 'consum', 0.0215, 'lps'),
	(473336, 124, '2015-04-01 01:19:18.000000', 'consum', 0.0235, 'lps'),
	(473337, 124, '2015-04-01 01:19:19.000000', 'consum', 0.0215, 'lps'),
	(473338, 124, '2015-04-01 01:19:20.000000', 'consum', 0.0213, 'lps'),
	(473339, 124, '2015-04-01 01:19:21.000000', 'consum', 0.0235, 'lps'),
	(473340, 124, '2015-04-01 01:19:22.000000', 'consum', 0.0226, 'lps'),
	(473341, 124, '2015-04-01 01:19:23.000000', 'consum', 0.0212, 'lps'),
	(473342, 124, '2015-04-01 01:19:24.000000', 'consum', 0.0227, 'lps'),
	(473343, 124, '2015-04-01 01:19:25.000000', 'consum', 0.0211, 'lps'),
	(473344, 124, '2015-04-01 01:19:26.000000', 'consum', 0.0215, 'lps'),
	(473345, 124, '2015-04-01 01:19:27.000000', 'consum', 0.0232, 'lps'),
	(473346, 124, '2015-04-01 01:19:28.000000', 'consum', 0.0226, 'lps'),
	(473347, 124, '2015-04-01 01:19:29.000000', 'consum', 0.0228, 'lps'),
	(473348, 124, '2015-04-01 01:19:30.000000', 'consum', 0.0224, 'lps'),
	(473349, 124, '2015-04-01 01:19:31.000000', 'consum', 0.0228, 'lps'),
	(473350, 124, '2015-04-01 01:19:32.000000', 'consum', 0.0234, 'lps'),
	(473351, 124, '2015-04-01 01:19:33.000000', 'consum', 0.0222, 'lps'),
	(473352, 124, '2015-04-01 01:19:34.000000', 'consum', 0.0224, 'lps'),
	(473353, 124, '2015-04-01 01:19:35.000000', 'consum', 0.0219, 'lps'),
	(473354, 124, '2015-04-01 01:19:36.000000', 'consum', 0.0214, 'lps'),
	(473355, 124, '2015-04-01 01:19:37.000000', 'consum', 0.0229, 'lps'),
	(473356, 124, '2015-04-01 01:19:38.000000', 'consum', 0.0215, 'lps'),
	(473357, 124, '2015-04-01 01:19:39.000000', 'consum', 0.0231, 'lps'),
	(473358, 124, '2015-04-01 01:19:40.000000', 'consum', 0.0223, 'lps'),
	(473359, 124, '2015-04-01 01:19:41.000000', 'consum', 0.0211, 'lps'),
	(473360, 124, '2015-04-01 01:19:42.000000', 'consum', 0.0229, 'lps'),
	(473361, 124, '2015-04-01 01:19:43.000000', 'consum', 0.0224, 'lps'),
	(473362, 124, '2015-04-01 01:19:44.000000', 'consum', 0.0224, 'lps'),
	(473363, 124, '2015-04-01 01:19:45.000000', 'consum', 0.0214, 'lps'),
	(473364, 124, '2015-04-01 01:19:46.000000', 'consum', 0.0212, 'lps'),
	(473365, 124, '2015-04-01 01:19:47.000000', 'consum', 0.0234, 'lps'),
	(473366, 124, '2015-04-01 01:19:48.000000', 'consum', 0.0223, 'lps'),
	(473367, 124, '2015-04-01 01:19:49.000000', 'consum', 0.0229, 'lps'),
	(473368, 124, '2015-04-01 01:19:50.000000', 'consum', 0.0215, 'lps'),
	(473369, 124, '2015-04-01 01:19:51.000000', 'consum', 0.0232, 'lps'),
	(473370, 124, '2015-04-01 01:19:52.000000', 'consum', 0.0225, 'lps'),
	(473371, 124, '2015-04-01 01:19:53.000000', 'consum', 0.0218, 'lps'),
	(473372, 124, '2015-04-01 01:19:54.000000', 'consum', 0.0235, 'lps'),
	(473373, 124, '2015-04-01 01:19:55.000000', 'consum', 0.0231, 'lps'),
	(473374, 124, '2015-04-01 01:19:56.000000', 'consum', 0.0214, 'lps'),
	(473375, 124, '2015-04-01 01:19:57.000000', 'consum', 0.0222, 'lps'),
	(473376, 124, '2015-04-01 01:19:58.000000', 'consum', 0.0232, 'lps'),
	(473377, 124, '2015-04-01 01:19:59.000000', 'consum', 0.0231, 'lps'),
	(473378, 124, '2015-04-01 01:20:00.000000', 'consum', 0.0224, 'lps'),
	(473379, 124, '2015-04-01 01:20:01.000000', 'consum', 0.0216, 'lps'),
	(473380, 124, '2015-04-01 01:20:02.000000', 'consum', 0.0225, 'lps'),
	(473381, 124, '2015-04-01 01:20:03.000000', 'consum', 0.0214, 'lps'),
	(473382, 124, '2015-04-01 01:20:04.000000', 'consum', 0.0214, 'lps'),
	(473383, 124, '2015-04-01 01:20:05.000000', 'consum', 0.0218, 'lps'),
	(473384, 124, '2015-04-01 01:20:06.000000', 'consum', 0.0213, 'lps'),
	(473385, 124, '2015-04-01 01:20:07.000000', 'consum', 0.0225, 'lps'),
	(473386, 124, '2015-04-01 01:20:08.000000', 'consum', 0.0227, 'lps'),
	(473387, 124, '2015-04-01 01:20:09.000000', 'consum', 0.0223, 'lps'),
	(473388, 124, '2015-04-01 01:20:10.000000', 'consum', 0.0223, 'lps'),
	(473389, 124, '2015-04-01 01:20:11.000000', 'consum', 0.0212, 'lps'),
	(473390, 124, '2015-04-01 01:20:12.000000', 'consum', 0.0235, 'lps'),
	(473391, 124, '2015-04-01 01:20:13.000000', 'consum', 0.0223, 'lps'),
	(473392, 124, '2015-04-01 01:20:14.000000', 'consum', 0.0227, 'lps'),
	(473393, 124, '2015-04-01 01:20:15.000000', 'consum', 0.0232, 'lps'),
	(473394, 124, '2015-04-01 01:20:16.000000', 'consum', 0.0216, 'lps'),
	(473395, 124, '2015-04-01 01:20:17.000000', 'consum', 0.0229, 'lps'),
	(473396, 124, '2015-04-01 01:20:18.000000', 'consum', 0.0234, 'lps'),
	(473397, 124, '2015-04-01 01:20:19.000000', 'consum', 0.0223, 'lps'),
	(473398, 124, '2015-04-01 01:20:20.000000', 'consum', 0.0228, 'lps'),
	(473399, 124, '2015-04-01 01:20:21.000000', 'consum', 0.0210, 'lps'),
	(473400, 124, '2015-04-01 01:20:22.000000', 'consum', 0.0234, 'lps'),
	(473401, 124, '2015-04-01 01:20:23.000000', 'consum', 0.0226, 'lps'),
	(473402, 124, '2015-04-01 01:20:24.000000', 'consum', 0.0219, 'lps'),
	(473403, 124, '2015-04-01 01:20:25.000000', 'consum', 0.0234, 'lps'),
	(473404, 124, '2015-04-01 01:20:26.000000', 'consum', 0.0224, 'lps'),
	(473405, 124, '2015-04-01 01:20:27.000000', 'consum', 0.0235, 'lps'),
	(473406, 124, '2015-04-01 01:20:28.000000', 'consum', 0.0217, 'lps'),
	(473407, 124, '2015-04-01 01:20:29.000000', 'consum', 0.0222, 'lps'),
	(473408, 124, '2015-04-01 01:20:30.000000', 'consum', 0.0221, 'lps'),
	(473409, 124, '2015-04-01 01:20:31.000000', 'consum', 0.0232, 'lps'),
	(473410, 124, '2015-04-01 01:20:32.000000', 'consum', 0.0235, 'lps'),
	(473411, 124, '2015-04-01 01:20:33.000000', 'consum', 0.0216, 'lps'),
	(473412, 124, '2015-04-01 01:20:34.000000', 'consum', 0.0217, 'lps'),
	(473413, 124, '2015-04-01 01:20:35.000000', 'consum', 0.0228, 'lps'),
	(473414, 124, '2015-04-01 01:20:36.000000', 'consum', 0.0227, 'lps'),
	(473415, 124, '2015-04-01 01:20:37.000000', 'consum', 0.0218, 'lps'),
	(473416, 124, '2015-04-01 01:20:38.000000', 'consum', 0.0223, 'lps'),
	(473417, 124, '2015-04-01 01:20:39.000000', 'consum', 0.0224, 'lps'),
	(473418, 124, '2015-04-01 01:20:40.000000', 'consum', 0.0219, 'lps'),
	(473419, 124, '2015-04-01 01:20:41.000000', 'consum', 0.0213, 'lps'),
	(473420, 124, '2015-04-01 01:20:42.000000', 'consum', 0.0224, 'lps'),
	(473421, 124, '2015-04-01 01:20:43.000000', 'consum', 0.0219, 'lps'),
	(473422, 124, '2015-04-01 01:20:44.000000', 'consum', 0.0214, 'lps'),
	(473423, 124, '2015-04-01 01:20:45.000000', 'consum', 0.0229, 'lps'),
	(473424, 124, '2015-04-01 01:20:46.000000', 'consum', 0.0215, 'lps'),
	(473425, 124, '2015-04-01 01:20:47.000000', 'consum', 0.0229, 'lps'),
	(473426, 124, '2015-04-01 01:20:48.000000', 'consum', 0.0215, 'lps'),
	(473427, 124, '2015-04-01 01:20:49.000000', 'consum', 0.0230, 'lps'),
	(473428, 124, '2015-04-01 01:20:50.000000', 'consum', 0.0216, 'lps'),
	(473429, 124, '2015-04-01 01:20:51.000000', 'consum', 0.0233, 'lps'),
	(473430, 124, '2015-04-01 01:20:52.000000', 'consum', 0.0231, 'lps'),
	(473431, 124, '2015-04-01 01:20:53.000000', 'consum', 0.0221, 'lps'),
	(473432, 124, '2015-04-01 01:20:54.000000', 'consum', 0.0229, 'lps'),
	(473433, 124, '2015-04-01 01:20:55.000000', 'consum', 0.0219, 'lps'),
	(473434, 124, '2015-04-01 01:20:56.000000', 'consum', 0.0226, 'lps'),
	(473435, 124, '2015-04-01 01:20:57.000000', 'consum', 0.0211, 'lps'),
	(473436, 124, '2015-04-01 01:20:58.000000', 'consum', 0.0220, 'lps'),
	(473437, 124, '2015-04-01 01:20:59.000000', 'consum', 0.0231, 'lps'),
	(473438, 124, '2015-04-01 01:21:00.000000', 'consum', 0.0232, 'lps'),
	(473439, 124, '2015-04-01 01:21:01.000000', 'consum', 0.0231, 'lps'),
	(473440, 124, '2015-04-01 01:21:02.000000', 'consum', 0.0225, 'lps'),
	(473441, 124, '2015-04-01 01:21:03.000000', 'consum', 0.0223, 'lps'),
	(473442, 124, '2015-04-01 01:21:04.000000', 'consum', 0.0231, 'lps'),
	(473443, 124, '2015-04-01 01:21:05.000000', 'consum', 0.0224, 'lps'),
	(473444, 124, '2015-04-01 01:21:06.000000', 'consum', 0.0219, 'lps'),
	(473445, 124, '2015-04-01 01:21:07.000000', 'consum', 0.0213, 'lps'),
	(473446, 124, '2015-04-01 01:21:08.000000', 'consum', 0.0223, 'lps'),
	(473447, 124, '2015-04-01 01:21:09.000000', 'consum', 0.0214, 'lps'),
	(473448, 124, '2015-04-01 01:21:10.000000', 'consum', 0.0219, 'lps'),
	(473449, 124, '2015-04-01 01:21:11.000000', 'consum', 0.0216, 'lps'),
	(473450, 124, '2015-04-01 01:21:12.000000', 'consum', 0.0214, 'lps'),
	(473451, 124, '2015-04-01 01:21:13.000000', 'consum', 0.0211, 'lps'),
	(473452, 124, '2015-04-01 01:21:14.000000', 'consum', 0.0232, 'lps'),
	(473453, 124, '2015-04-01 01:21:15.000000', 'consum', 0.0212, 'lps'),
	(473454, 124, '2015-04-01 01:21:16.000000', 'consum', 0.0234, 'lps'),
	(473455, 124, '2015-04-01 01:21:17.000000', 'consum', 0.0221, 'lps'),
	(473456, 124, '2015-04-01 01:21:18.000000', 'consum', 0.0220, 'lps'),
	(473457, 124, '2015-04-01 01:21:19.000000', 'consum', 0.0227, 'lps'),
	(473458, 124, '2015-04-01 01:21:20.000000', 'consum', 0.0213, 'lps'),
	(473459, 124, '2015-04-01 01:21:21.000000', 'consum', 0.0225, 'lps'),
	(473460, 124, '2015-04-01 01:21:22.000000', 'consum', 0.0227, 'lps'),
	(473461, 124, '2015-04-01 01:21:23.000000', 'consum', 0.0224, 'lps'),
	(473462, 124, '2015-04-01 01:21:24.000000', 'consum', 0.0231, 'lps'),
	(473463, 124, '2015-04-01 01:21:25.000000', 'consum', 0.0219, 'lps'),
	(473464, 124, '2015-04-01 01:21:26.000000', 'consum', 0.0221, 'lps'),
	(473465, 124, '2015-04-01 01:21:27.000000', 'consum', 0.0212, 'lps'),
	(473466, 124, '2015-04-01 01:21:28.000000', 'consum', 0.0212, 'lps'),
	(473467, 124, '2015-04-01 01:21:29.000000', 'consum', 0.0214, 'lps'),
	(473468, 124, '2015-04-01 01:21:30.000000', 'consum', 0.0223, 'lps'),
	(473469, 124, '2015-04-01 01:21:31.000000', 'consum', 0.0214, 'lps'),
	(473470, 124, '2015-04-01 01:21:32.000000', 'consum', 0.0218, 'lps'),
	(473471, 124, '2015-04-01 01:21:33.000000', 'consum', 0.0214, 'lps'),
	(473472, 124, '2015-04-01 01:21:34.000000', 'consum', 0.0229, 'lps'),
	(473473, 124, '2015-04-01 01:21:35.000000', 'consum', 0.0217, 'lps'),
	(473474, 124, '2015-04-01 01:21:36.000000', 'consum', 0.0215, 'lps'),
	(473475, 124, '2015-04-01 01:21:37.000000', 'consum', 0.0214, 'lps'),
	(473476, 124, '2015-04-01 01:21:38.000000', 'consum', 0.0215, 'lps'),
	(473477, 124, '2015-04-01 01:21:39.000000', 'consum', 0.0225, 'lps'),
	(473478, 124, '2015-04-01 01:21:40.000000', 'consum', 0.0216, 'lps'),
	(473479, 124, '2015-04-01 01:21:41.000000', 'consum', 0.0223, 'lps'),
	(473480, 124, '2015-04-01 01:21:42.000000', 'consum', 0.0233, 'lps'),
	(473481, 124, '2015-04-01 01:21:43.000000', 'consum', 0.0234, 'lps'),
	(473482, 124, '2015-04-01 01:21:44.000000', 'consum', 0.0234, 'lps'),
	(473483, 124, '2015-04-01 01:21:45.000000', 'consum', 0.0231, 'lps'),
	(473484, 124, '2015-04-01 01:21:46.000000', 'consum', 0.0221, 'lps'),
	(473485, 124, '2015-04-01 01:21:47.000000', 'consum', 0.0227, 'lps'),
	(473486, 124, '2015-04-01 01:21:48.000000', 'consum', 0.0212, 'lps'),
	(473487, 124, '2015-04-01 01:21:49.000000', 'consum', 0.0219, 'lps'),
	(473488, 124, '2015-04-01 01:21:50.000000', 'consum', 0.0222, 'lps'),
	(473489, 124, '2015-04-01 01:21:51.000000', 'consum', 0.0221, 'lps'),
	(473490, 124, '2015-04-01 01:21:52.000000', 'consum', 0.0230, 'lps'),
	(473491, 124, '2015-04-01 01:21:53.000000', 'consum', 0.0223, 'lps'),
	(473492, 124, '2015-04-01 01:21:54.000000', 'consum', 0.0216, 'lps'),
	(473493, 124, '2015-04-01 01:21:55.000000', 'consum', 0.0226, 'lps'),
	(473494, 124, '2015-04-01 01:21:56.000000', 'consum', 0.0223, 'lps'),
	(473495, 124, '2015-04-01 01:21:57.000000', 'consum', 0.0225, 'lps'),
	(473496, 124, '2015-04-01 01:21:58.000000', 'consum', 0.0222, 'lps'),
	(473497, 124, '2015-04-01 01:21:59.000000', 'consum', 0.0224, 'lps'),
	(473498, 124, '2015-04-01 01:22:00.000000', 'consum', 0.0221, 'lps'),
	(473499, 124, '2015-04-01 01:22:01.000000', 'consum', 0.0223, 'lps'),
	(473500, 124, '2015-04-01 01:22:02.000000', 'consum', 0.0214, 'lps'),
	(473501, 124, '2015-04-01 01:22:03.000000', 'consum', 0.0220, 'lps'),
	(473502, 124, '2015-04-01 01:22:04.000000', 'consum', 0.0224, 'lps'),
	(473503, 124, '2015-04-01 01:22:05.000000', 'consum', 0.0221, 'lps'),
	(473504, 124, '2015-04-01 01:22:06.000000', 'consum', 0.0225, 'lps'),
	(473505, 124, '2015-04-01 01:22:07.000000', 'consum', 0.0225, 'lps'),
	(473506, 124, '2015-04-01 01:22:08.000000', 'consum', 0.0215, 'lps'),
	(473507, 124, '2015-04-01 01:22:09.000000', 'consum', 0.0219, 'lps'),
	(473508, 124, '2015-04-01 01:22:10.000000', 'consum', 0.0211, 'lps'),
	(473509, 124, '2015-04-01 01:22:11.000000', 'consum', 0.0218, 'lps'),
	(473510, 124, '2015-04-01 01:22:12.000000', 'consum', 0.0218, 'lps'),
	(473511, 124, '2015-04-01 01:22:13.000000', 'consum', 0.0229, 'lps'),
	(473512, 124, '2015-04-01 01:22:14.000000', 'consum', 0.0227, 'lps'),
	(473513, 124, '2015-04-01 01:22:15.000000', 'consum', 0.0216, 'lps'),
	(473514, 124, '2015-04-01 01:22:16.000000', 'consum', 0.0212, 'lps'),
	(473515, 124, '2015-04-01 01:22:17.000000', 'consum', 0.0232, 'lps'),
	(473516, 124, '2015-04-01 01:22:18.000000', 'consum', 0.0233, 'lps'),
	(473517, 124, '2015-04-01 01:22:19.000000', 'consum', 0.0211, 'lps'),
	(473518, 124, '2015-04-01 01:22:20.000000', 'consum', 0.0223, 'lps'),
	(473519, 124, '2015-04-01 01:22:21.000000', 'consum', 0.0220, 'lps'),
	(473520, 124, '2015-04-01 01:22:22.000000', 'consum', 0.0220, 'lps'),
	(473521, 124, '2015-04-01 01:22:23.000000', 'consum', 0.0234, 'lps'),
	(473522, 124, '2015-04-01 01:22:24.000000', 'consum', 0.0219, 'lps'),
	(473523, 124, '2015-04-01 01:22:25.000000', 'consum', 0.0213, 'lps'),
	(473524, 124, '2015-04-01 01:22:26.000000', 'consum', 0.0223, 'lps'),
	(473525, 124, '2015-04-01 01:22:27.000000', 'consum', 0.0214, 'lps'),
	(473526, 124, '2015-04-01 01:22:28.000000', 'consum', 0.0218, 'lps'),
	(473527, 124, '2015-04-01 01:22:29.000000', 'consum', 0.0212, 'lps'),
	(473528, 124, '2015-04-01 01:22:30.000000', 'consum', 0.0224, 'lps'),
	(473529, 124, '2015-04-01 01:22:31.000000', 'consum', 0.0221, 'lps'),
	(473530, 124, '2015-04-01 01:22:32.000000', 'consum', 0.0226, 'lps'),
	(473531, 124, '2015-04-01 01:22:33.000000', 'consum', 0.0228, 'lps'),
	(473532, 124, '2015-04-01 01:22:34.000000', 'consum', 0.0228, 'lps'),
	(473533, 124, '2015-04-01 01:22:35.000000', 'consum', 0.0221, 'lps'),
	(473534, 124, '2015-04-01 01:22:36.000000', 'consum', 0.0212, 'lps'),
	(473535, 124, '2015-04-01 01:22:37.000000', 'consum', 0.0212, 'lps'),
	(473536, 124, '2015-04-01 01:22:38.000000', 'consum', 0.0215, 'lps'),
	(473537, 124, '2015-04-01 01:22:39.000000', 'consum', 0.0230, 'lps'),
	(473538, 124, '2015-04-01 01:22:40.000000', 'consum', 0.0215, 'lps'),
	(473539, 124, '2015-04-01 01:22:41.000000', 'consum', 0.0230, 'lps'),
	(473540, 124, '2015-04-01 01:22:42.000000', 'consum', 0.0219, 'lps'),
	(473541, 124, '2015-04-01 01:22:43.000000', 'consum', 0.0219, 'lps'),
	(473542, 124, '2015-04-01 01:22:44.000000', 'consum', 0.0229, 'lps'),
	(473543, 124, '2015-04-01 01:22:45.000000', 'consum', 0.0228, 'lps'),
	(473544, 124, '2015-04-01 01:22:46.000000', 'consum', 0.0216, 'lps'),
	(473545, 124, '2015-04-01 01:22:47.000000', 'consum', 0.0214, 'lps'),
	(473546, 124, '2015-04-01 01:22:48.000000', 'consum', 0.0211, 'lps'),
	(473547, 124, '2015-04-01 01:22:49.000000', 'consum', 0.0230, 'lps'),
	(473548, 124, '2015-04-01 01:22:50.000000', 'consum', 0.0230, 'lps'),
	(473549, 124, '2015-04-01 01:22:51.000000', 'consum', 0.0226, 'lps'),
	(473550, 124, '2015-04-01 01:22:52.000000', 'consum', 0.0229, 'lps'),
	(473551, 124, '2015-04-01 01:22:53.000000', 'consum', 0.0232, 'lps'),
	(473552, 124, '2015-04-01 01:22:54.000000', 'consum', 0.0235, 'lps'),
	(473553, 124, '2015-04-01 01:22:55.000000', 'consum', 0.0220, 'lps'),
	(473554, 124, '2015-04-01 01:22:56.000000', 'consum', 0.0212, 'lps'),
	(473555, 124, '2015-04-01 01:22:57.000000', 'consum', 0.0214, 'lps'),
	(473556, 124, '2015-04-01 01:22:58.000000', 'consum', 0.0226, 'lps'),
	(473557, 124, '2015-04-01 01:22:59.000000', 'consum', 0.0227, 'lps'),
	(473558, 124, '2015-04-01 01:23:00.000000', 'consum', 0.0221, 'lps'),
	(473559, 124, '2015-04-01 01:23:01.000000', 'consum', 0.0214, 'lps'),
	(473560, 124, '2015-04-01 01:23:02.000000', 'consum', 0.0222, 'lps'),
	(473561, 124, '2015-04-01 01:23:03.000000', 'consum', 0.0235, 'lps'),
	(473562, 124, '2015-04-01 01:23:04.000000', 'consum', 0.0222, 'lps'),
	(473563, 124, '2015-04-01 01:23:05.000000', 'consum', 0.0219, 'lps'),
	(473564, 124, '2015-04-01 01:23:06.000000', 'consum', 0.0219, 'lps'),
	(473565, 124, '2015-04-01 01:23:07.000000', 'consum', 0.0229, 'lps'),
	(473566, 124, '2015-04-01 01:23:08.000000', 'consum', 0.0225, 'lps'),
	(473567, 124, '2015-04-01 01:23:09.000000', 'consum', 0.0230, 'lps'),
	(473568, 124, '2015-04-01 01:23:10.000000', 'consum', 0.0215, 'lps'),
	(473569, 124, '2015-04-01 01:23:11.000000', 'consum', 0.0228, 'lps'),
	(473570, 124, '2015-04-01 01:23:12.000000', 'consum', 0.0233, 'lps'),
	(473571, 124, '2015-04-01 01:23:13.000000', 'consum', 0.0221, 'lps'),
	(473572, 124, '2015-04-01 01:23:14.000000', 'consum', 0.0221, 'lps'),
	(473573, 124, '2015-04-01 01:23:15.000000', 'consum', 0.0231, 'lps'),
	(473574, 124, '2015-04-01 01:23:16.000000', 'consum', 0.0233, 'lps'),
	(473575, 124, '2015-04-01 01:23:17.000000', 'consum', 0.0210, 'lps'),
	(473576, 124, '2015-04-01 01:23:18.000000', 'consum', 0.0218, 'lps'),
	(473577, 124, '2015-04-01 01:23:19.000000', 'consum', 0.0227, 'lps'),
	(473578, 124, '2015-04-01 01:23:20.000000', 'consum', 0.0219, 'lps'),
	(473579, 124, '2015-04-01 01:23:21.000000', 'consum', 0.0228, 'lps'),
	(473580, 124, '2015-04-01 01:23:22.000000', 'consum', 0.0225, 'lps'),
	(473581, 124, '2015-04-01 01:23:23.000000', 'consum', 0.0228, 'lps'),
	(473582, 124, '2015-04-01 01:23:24.000000', 'consum', 0.0233, 'lps'),
	(473583, 124, '2015-04-01 01:23:25.000000', 'consum', 0.0217, 'lps'),
	(473584, 124, '2015-04-01 01:23:26.000000', 'consum', 0.0230, 'lps'),
	(473585, 124, '2015-04-01 01:23:27.000000', 'consum', 0.0213, 'lps'),
	(473586, 124, '2015-04-01 01:23:28.000000', 'consum', 0.0216, 'lps'),
	(473587, 124, '2015-04-01 01:23:29.000000', 'consum', 0.0232, 'lps'),
	(473588, 124, '2015-04-01 01:23:30.000000', 'consum', 0.0224, 'lps'),
	(473589, 124, '2015-04-01 01:23:31.000000', 'consum', 0.0213, 'lps'),
	(473590, 124, '2015-04-01 01:23:32.000000', 'consum', 0.0235, 'lps'),
	(473591, 124, '2015-04-01 01:23:33.000000', 'consum', 0.0222, 'lps'),
	(473592, 124, '2015-04-01 01:23:34.000000', 'consum', 0.0224, 'lps'),
	(473593, 124, '2015-04-01 01:23:35.000000', 'consum', 0.0216, 'lps'),
	(473594, 124, '2015-04-01 01:23:36.000000', 'consum', 0.0224, 'lps'),
	(473595, 124, '2015-04-01 01:23:37.000000', 'consum', 0.0214, 'lps'),
	(473596, 124, '2015-04-01 01:23:38.000000', 'consum', 0.0211, 'lps'),
	(473597, 124, '2015-04-01 01:23:39.000000', 'consum', 0.0231, 'lps'),
	(473598, 124, '2015-04-01 01:23:40.000000', 'consum', 0.0234, 'lps'),
	(473599, 124, '2015-04-01 01:23:41.000000', 'consum', 0.0216, 'lps'),
	(473600, 124, '2015-04-01 01:23:42.000000', 'consum', 0.0218, 'lps'),
	(473601, 124, '2015-04-01 01:23:43.000000', 'consum', 0.0210, 'lps'),
	(473602, 124, '2015-04-01 01:23:44.000000', 'consum', 0.0211, 'lps'),
	(473603, 124, '2015-04-01 01:23:45.000000', 'consum', 0.0217, 'lps'),
	(473604, 124, '2015-04-01 01:23:46.000000', 'consum', 0.0217, 'lps'),
	(473605, 124, '2015-04-01 01:23:47.000000', 'consum', 0.0224, 'lps'),
	(473606, 124, '2015-04-01 01:23:48.000000', 'consum', 0.0234, 'lps'),
	(473607, 124, '2015-04-01 01:23:49.000000', 'consum', 0.0235, 'lps'),
	(473608, 124, '2015-04-01 01:23:50.000000', 'consum', 0.0210, 'lps'),
	(473609, 124, '2015-04-01 01:23:51.000000', 'consum', 0.0215, 'lps'),
	(473610, 124, '2015-04-01 01:23:52.000000', 'consum', 0.0210, 'lps'),
	(473611, 124, '2015-04-01 01:23:53.000000', 'consum', 0.0221, 'lps'),
	(473612, 124, '2015-04-01 01:23:54.000000', 'consum', 0.0216, 'lps'),
	(473613, 124, '2015-04-01 01:23:55.000000', 'consum', 0.0230, 'lps'),
	(473614, 124, '2015-04-01 01:23:56.000000', 'consum', 0.0216, 'lps'),
	(473615, 124, '2015-04-01 01:23:57.000000', 'consum', 0.0232, 'lps'),
	(473616, 124, '2015-04-01 01:23:58.000000', 'consum', 0.0226, 'lps'),
	(473617, 124, '2015-04-01 01:23:59.000000', 'consum', 0.0224, 'lps'),
	(473618, 124, '2015-04-01 01:24:00.000000', 'consum', 0.0231, 'lps'),
	(473619, 124, '2015-04-01 01:24:01.000000', 'consum', 0.0221, 'lps'),
	(473620, 124, '2015-04-01 01:24:02.000000', 'consum', 0.0228, 'lps'),
	(473621, 124, '2015-04-01 01:24:03.000000', 'consum', 0.0215, 'lps'),
	(473622, 124, '2015-04-01 01:24:04.000000', 'consum', 0.0234, 'lps'),
	(473623, 124, '2015-04-01 01:24:05.000000', 'consum', 0.0214, 'lps'),
	(473624, 124, '2015-04-01 01:24:06.000000', 'consum', 0.0234, 'lps'),
	(473625, 124, '2015-04-01 01:24:07.000000', 'consum', 0.0214, 'lps'),
	(473626, 124, '2015-04-01 01:24:08.000000', 'consum', 0.0213, 'lps'),
	(473627, 124, '2015-04-01 01:24:09.000000', 'consum', 0.0210, 'lps'),
	(473628, 124, '2015-04-01 01:24:10.000000', 'consum', 0.0230, 'lps'),
	(473629, 124, '2015-04-01 01:24:11.000000', 'consum', 0.0234, 'lps'),
	(473630, 124, '2015-04-01 01:24:12.000000', 'consum', 0.0216, 'lps'),
	(473631, 124, '2015-04-01 01:24:13.000000', 'consum', 0.0220, 'lps'),
	(473632, 124, '2015-04-01 01:24:14.000000', 'consum', 0.0216, 'lps'),
	(473633, 124, '2015-04-01 01:24:15.000000', 'consum', 0.0210, 'lps'),
	(473634, 124, '2015-04-01 01:24:16.000000', 'consum', 0.0220, 'lps'),
	(473635, 124, '2015-04-01 01:24:17.000000', 'consum', 0.0235, 'lps'),
	(473636, 124, '2015-04-01 01:24:18.000000', 'consum', 0.0225, 'lps'),
	(473637, 124, '2015-04-01 01:24:19.000000', 'consum', 0.0213, 'lps'),
	(473638, 124, '2015-04-01 01:24:20.000000', 'consum', 0.0234, 'lps'),
	(473639, 124, '2015-04-01 01:24:21.000000', 'consum', 0.0214, 'lps'),
	(473640, 124, '2015-04-01 01:24:22.000000', 'consum', 0.0213, 'lps'),
	(473641, 124, '2015-04-01 01:24:23.000000', 'consum', 0.0213, 'lps'),
	(473642, 124, '2015-04-01 01:24:24.000000', 'consum', 0.0218, 'lps'),
	(473643, 124, '2015-04-01 01:24:25.000000', 'consum', 0.0213, 'lps'),
	(473644, 124, '2015-04-01 01:24:26.000000', 'consum', 0.0229, 'lps'),
	(473645, 124, '2015-04-01 01:24:27.000000', 'consum', 0.0216, 'lps'),
	(473646, 124, '2015-04-01 01:24:28.000000', 'consum', 0.0211, 'lps'),
	(473647, 124, '2015-04-01 01:24:29.000000', 'consum', 0.0224, 'lps'),
	(473648, 124, '2015-04-01 01:24:30.000000', 'consum', 0.0227, 'lps'),
	(473649, 124, '2015-04-01 01:24:31.000000', 'consum', 0.0227, 'lps'),
	(473650, 124, '2015-04-01 01:24:32.000000', 'consum', 0.0216, 'lps'),
	(473651, 124, '2015-04-01 01:24:33.000000', 'consum', 0.0218, 'lps'),
	(473652, 124, '2015-04-01 01:24:34.000000', 'consum', 0.0230, 'lps'),
	(473653, 124, '2015-04-01 01:24:35.000000', 'consum', 0.0210, 'lps'),
	(473654, 124, '2015-04-01 01:24:36.000000', 'consum', 0.0227, 'lps'),
	(473655, 124, '2015-04-01 01:24:37.000000', 'consum', 0.0218, 'lps'),
	(473656, 124, '2015-04-01 01:24:38.000000', 'consum', 0.0226, 'lps'),
	(473657, 124, '2015-04-01 01:24:39.000000', 'consum', 0.0216, 'lps'),
	(473658, 124, '2015-04-01 01:24:40.000000', 'consum', 0.0217, 'lps'),
	(473659, 124, '2015-04-01 01:24:41.000000', 'consum', 0.0228, 'lps'),
	(473660, 124, '2015-04-01 01:24:42.000000', 'consum', 0.0226, 'lps'),
	(473661, 124, '2015-04-01 01:24:43.000000', 'consum', 0.0213, 'lps'),
	(473662, 124, '2015-04-01 01:24:44.000000', 'consum', 0.0228, 'lps'),
	(473663, 124, '2015-04-01 01:24:45.000000', 'consum', 0.0213, 'lps'),
	(473664, 124, '2015-04-01 01:24:46.000000', 'consum', 0.0226, 'lps'),
	(473665, 124, '2015-04-01 01:24:47.000000', 'consum', 0.0227, 'lps'),
	(473666, 124, '2015-04-01 01:24:48.000000', 'consum', 0.0221, 'lps'),
	(473667, 124, '2015-04-01 01:24:49.000000', 'consum', 0.0214, 'lps'),
	(473668, 124, '2015-04-01 01:24:50.000000', 'consum', 0.0226, 'lps'),
	(473669, 124, '2015-04-01 01:24:51.000000', 'consum', 0.0227, 'lps'),
	(473670, 124, '2015-04-01 01:24:52.000000', 'consum', 0.0222, 'lps'),
	(473671, 124, '2015-04-01 01:24:53.000000', 'consum', 0.0217, 'lps'),
	(473672, 124, '2015-04-01 01:24:54.000000', 'consum', 0.0210, 'lps'),
	(473673, 124, '2015-04-01 01:24:55.000000', 'consum', 0.0217, 'lps'),
	(473674, 124, '2015-04-01 01:24:56.000000', 'consum', 0.0221, 'lps'),
	(473675, 124, '2015-04-01 01:24:57.000000', 'consum', 0.0216, 'lps'),
	(473676, 124, '2015-04-01 01:24:58.000000', 'consum', 0.0233, 'lps'),
	(473677, 124, '2015-04-01 01:24:59.000000', 'consum', 0.0229, 'lps'),
	(473678, 124, '2015-04-01 01:25:00.000000', 'consum', 0.0213, 'lps'),
	(473679, 124, '2015-04-01 01:25:01.000000', 'consum', 0.0219, 'lps'),
	(473680, 124, '2015-04-01 01:25:02.000000', 'consum', 0.0223, 'lps'),
	(473681, 124, '2015-04-01 01:25:03.000000', 'consum', 0.0220, 'lps'),
	(473682, 124, '2015-04-01 01:25:04.000000', 'consum', 0.0223, 'lps'),
	(473683, 124, '2015-04-01 01:25:05.000000', 'consum', 0.0219, 'lps'),
	(473684, 124, '2015-04-01 01:25:06.000000', 'consum', 0.0218, 'lps'),
	(473685, 124, '2015-04-01 01:25:07.000000', 'consum', 0.0222, 'lps'),
	(473686, 124, '2015-04-01 01:25:08.000000', 'consum', 0.0223, 'lps'),
	(473687, 124, '2015-04-01 01:25:09.000000', 'consum', 0.0210, 'lps'),
	(473688, 124, '2015-04-01 01:25:10.000000', 'consum', 0.0226, 'lps'),
	(473689, 124, '2015-04-01 01:25:11.000000', 'consum', 0.0211, 'lps'),
	(473690, 124, '2015-04-01 01:25:12.000000', 'consum', 0.0218, 'lps'),
	(473691, 124, '2015-04-01 01:25:13.000000', 'consum', 0.0223, 'lps'),
	(473692, 124, '2015-04-01 01:25:14.000000', 'consum', 0.0225, 'lps'),
	(473693, 124, '2015-04-01 01:25:15.000000', 'consum', 0.0219, 'lps'),
	(473694, 124, '2015-04-01 01:25:16.000000', 'consum', 0.0211, 'lps'),
	(473695, 124, '2015-04-01 01:25:17.000000', 'consum', 0.0213, 'lps'),
	(473696, 124, '2015-04-01 01:25:18.000000', 'consum', 0.0225, 'lps'),
	(473697, 124, '2015-04-01 01:25:19.000000', 'consum', 0.0224, 'lps'),
	(473698, 124, '2015-04-01 01:25:20.000000', 'consum', 0.0234, 'lps'),
	(473699, 124, '2015-04-01 01:25:21.000000', 'consum', 0.0211, 'lps'),
	(473700, 124, '2015-04-01 01:25:22.000000', 'consum', 0.0223, 'lps'),
	(473701, 124, '2015-04-01 01:25:23.000000', 'consum', 0.0218, 'lps'),
	(473702, 124, '2015-04-01 01:25:24.000000', 'consum', 0.0215, 'lps'),
	(473703, 124, '2015-04-01 01:25:25.000000', 'consum', 0.0234, 'lps'),
	(473704, 124, '2015-04-01 01:25:26.000000', 'consum', 0.0212, 'lps'),
	(473705, 124, '2015-04-01 01:25:27.000000', 'consum', 0.0227, 'lps'),
	(473706, 124, '2015-04-01 01:25:28.000000', 'consum', 0.0210, 'lps'),
	(473707, 124, '2015-04-01 01:25:29.000000', 'consum', 0.0214, 'lps'),
	(473708, 124, '2015-04-01 01:25:30.000000', 'consum', 0.0228, 'lps'),
	(473709, 124, '2015-04-01 01:25:31.000000', 'consum', 0.0211, 'lps'),
	(473710, 124, '2015-04-01 01:25:32.000000', 'consum', 0.0213, 'lps'),
	(473711, 124, '2015-04-01 01:25:33.000000', 'consum', 0.0225, 'lps'),
	(473712, 124, '2015-04-01 01:25:34.000000', 'consum', 0.0223, 'lps'),
	(473713, 124, '2015-04-01 01:25:35.000000', 'consum', 0.0230, 'lps'),
	(473714, 124, '2015-04-01 01:25:36.000000', 'consum', 0.0219, 'lps'),
	(473715, 124, '2015-04-01 01:25:37.000000', 'consum', 0.0222, 'lps'),
	(473716, 124, '2015-04-01 01:25:38.000000', 'consum', 0.0219, 'lps'),
	(473717, 124, '2015-04-01 01:25:39.000000', 'consum', 0.0218, 'lps'),
	(473718, 124, '2015-04-01 01:25:40.000000', 'consum', 0.0222, 'lps'),
	(473719, 124, '2015-04-01 01:25:41.000000', 'consum', 0.0223, 'lps'),
	(473720, 124, '2015-04-01 01:25:42.000000', 'consum', 0.0214, 'lps'),
	(473721, 124, '2015-04-01 01:25:43.000000', 'consum', 0.0217, 'lps'),
	(473722, 124, '2015-04-01 01:25:44.000000', 'consum', 0.0232, 'lps'),
	(473723, 124, '2015-04-01 01:25:45.000000', 'consum', 0.0221, 'lps'),
	(473724, 124, '2015-04-01 01:25:46.000000', 'consum', 0.0225, 'lps'),
	(473725, 124, '2015-04-01 01:25:47.000000', 'consum', 0.0226, 'lps'),
	(473726, 124, '2015-04-01 01:25:48.000000', 'consum', 0.0223, 'lps'),
	(473727, 124, '2015-04-01 01:25:49.000000', 'consum', 0.0224, 'lps'),
	(473728, 124, '2015-04-01 01:25:50.000000', 'consum', 0.0216, 'lps'),
	(473729, 124, '2015-04-01 01:25:51.000000', 'consum', 0.0225, 'lps'),
	(473730, 124, '2015-04-01 01:25:52.000000', 'consum', 0.0215, 'lps'),
	(473731, 124, '2015-04-01 01:25:53.000000', 'consum', 0.0218, 'lps'),
	(473732, 124, '2015-04-01 01:25:54.000000', 'consum', 0.0233, 'lps'),
	(473733, 124, '2015-04-01 01:25:55.000000', 'consum', 0.0223, 'lps'),
	(473734, 124, '2015-04-01 01:25:56.000000', 'consum', 0.0234, 'lps'),
	(473735, 124, '2015-04-01 01:25:57.000000', 'consum', 0.0213, 'lps'),
	(473736, 124, '2015-04-01 01:25:58.000000', 'consum', 0.0230, 'lps'),
	(473737, 124, '2015-04-01 01:25:59.000000', 'consum', 0.0225, 'lps'),
	(473738, 124, '2015-04-01 01:26:00.000000', 'consum', 0.0225, 'lps'),
	(473739, 124, '2015-04-01 01:26:01.000000', 'consum', 0.0216, 'lps'),
	(473740, 124, '2015-04-01 01:26:02.000000', 'consum', 0.0219, 'lps'),
	(473741, 124, '2015-04-01 01:26:03.000000', 'consum', 0.0211, 'lps'),
	(473742, 124, '2015-04-01 01:26:04.000000', 'consum', 0.0215, 'lps'),
	(473743, 124, '2015-04-01 01:26:05.000000', 'consum', 0.0232, 'lps'),
	(473744, 124, '2015-04-01 01:26:06.000000', 'consum', 0.0226, 'lps'),
	(473745, 124, '2015-04-01 01:26:07.000000', 'consum', 0.0227, 'lps'),
	(473746, 124, '2015-04-01 01:26:08.000000', 'consum', 0.0221, 'lps'),
	(473747, 124, '2015-04-01 01:26:09.000000', 'consum', 0.0216, 'lps'),
	(473748, 124, '2015-04-01 01:26:10.000000', 'consum', 0.0233, 'lps'),
	(473749, 124, '2015-04-01 01:26:11.000000', 'consum', 0.0230, 'lps'),
	(473750, 124, '2015-04-01 01:26:12.000000', 'consum', 0.0217, 'lps'),
	(473751, 124, '2015-04-01 01:26:13.000000', 'consum', 0.0234, 'lps'),
	(473752, 124, '2015-04-01 01:26:14.000000', 'consum', 0.0233, 'lps'),
	(473753, 124, '2015-04-01 01:26:15.000000', 'consum', 0.0229, 'lps'),
	(473754, 124, '2015-04-01 01:26:16.000000', 'consum', 0.0234, 'lps'),
	(473755, 124, '2015-04-01 01:26:17.000000', 'consum', 0.0222, 'lps'),
	(473756, 124, '2015-04-01 01:26:18.000000', 'consum', 0.0224, 'lps'),
	(473757, 124, '2015-04-01 01:26:19.000000', 'consum', 0.0218, 'lps'),
	(473758, 124, '2015-04-01 01:26:20.000000', 'consum', 0.0210, 'lps'),
	(473759, 124, '2015-04-01 01:26:21.000000', 'consum', 0.0213, 'lps'),
	(473760, 124, '2015-04-01 01:26:22.000000', 'consum', 0.0227, 'lps'),
	(473761, 124, '2015-04-01 01:26:23.000000', 'consum', 0.0231, 'lps'),
	(473762, 124, '2015-04-01 01:26:24.000000', 'consum', 0.0215, 'lps'),
	(473763, 124, '2015-04-01 01:26:25.000000', 'consum', 0.0222, 'lps'),
	(473764, 124, '2015-04-01 01:26:26.000000', 'consum', 0.0233, 'lps'),
	(473765, 124, '2015-04-01 01:26:27.000000', 'consum', 0.0234, 'lps'),
	(473766, 124, '2015-04-01 01:26:28.000000', 'consum', 0.0212, 'lps'),
	(473767, 124, '2015-04-01 01:26:29.000000', 'consum', 0.0224, 'lps'),
	(473768, 124, '2015-04-01 01:26:30.000000', 'consum', 0.0223, 'lps'),
	(473769, 124, '2015-04-01 01:26:31.000000', 'consum', 0.0235, 'lps'),
	(473770, 124, '2015-04-01 01:26:32.000000', 'consum', 0.0216, 'lps'),
	(473771, 124, '2015-04-01 01:26:33.000000', 'consum', 0.0219, 'lps'),
	(473772, 124, '2015-04-01 01:26:34.000000', 'consum', 0.0210, 'lps'),
	(473773, 124, '2015-04-01 01:26:35.000000', 'consum', 0.0210, 'lps'),
	(473774, 124, '2015-04-01 01:26:36.000000', 'consum', 0.0235, 'lps'),
	(473775, 124, '2015-04-01 01:26:37.000000', 'consum', 0.0233, 'lps'),
	(473776, 124, '2015-04-01 01:26:38.000000', 'consum', 0.0223, 'lps'),
	(473777, 124, '2015-04-01 01:26:39.000000', 'consum', 0.0235, 'lps'),
	(473778, 124, '2015-04-01 01:26:40.000000', 'consum', 0.0216, 'lps'),
	(473779, 124, '2015-04-01 01:26:41.000000', 'consum', 0.0219, 'lps'),
	(473780, 124, '2015-04-01 01:26:42.000000', 'consum', 0.0212, 'lps'),
	(473781, 124, '2015-04-01 01:26:43.000000', 'consum', 0.0220, 'lps'),
	(473782, 124, '2015-04-01 01:26:44.000000', 'consum', 0.0230, 'lps'),
	(473783, 124, '2015-04-01 01:26:45.000000', 'consum', 0.0225, 'lps'),
	(473784, 124, '2015-04-01 01:26:46.000000', 'consum', 0.0229, 'lps'),
	(473785, 124, '2015-04-01 01:26:47.000000', 'consum', 0.0232, 'lps'),
	(473786, 124, '2015-04-01 01:26:48.000000', 'consum', 0.0210, 'lps'),
	(473787, 124, '2015-04-01 01:26:49.000000', 'consum', 0.0226, 'lps'),
	(473788, 124, '2015-04-01 01:26:50.000000', 'consum', 0.0210, 'lps'),
	(473789, 124, '2015-04-01 01:26:51.000000', 'consum', 0.0216, 'lps'),
	(473790, 124, '2015-04-01 01:26:52.000000', 'consum', 0.0216, 'lps'),
	(473791, 124, '2015-04-01 01:26:53.000000', 'consum', 0.0220, 'lps'),
	(473792, 124, '2015-04-01 01:26:54.000000', 'consum', 0.0218, 'lps'),
	(473793, 124, '2015-04-01 01:26:55.000000', 'consum', 0.0218, 'lps'),
	(473794, 124, '2015-04-01 01:26:56.000000', 'consum', 0.0228, 'lps'),
	(473795, 124, '2015-04-01 01:26:57.000000', 'consum', 0.0224, 'lps'),
	(473796, 124, '2015-04-01 01:26:58.000000', 'consum', 0.0227, 'lps'),
	(473797, 124, '2015-04-01 01:26:59.000000', 'consum', 0.0227, 'lps'),
	(473798, 124, '2015-04-01 01:27:00.000000', 'consum', 0.0219, 'lps'),
	(473799, 124, '2015-04-01 01:27:01.000000', 'consum', 0.0228, 'lps'),
	(473800, 124, '2015-04-01 01:27:02.000000', 'consum', 0.0224, 'lps'),
	(473801, 124, '2015-04-01 01:27:03.000000', 'consum', 0.0228, 'lps'),
	(473802, 124, '2015-04-01 01:27:04.000000', 'consum', 0.0229, 'lps'),
	(473803, 124, '2015-04-01 01:27:05.000000', 'consum', 0.0228, 'lps'),
	(473804, 124, '2015-04-01 01:27:06.000000', 'consum', 0.0215, 'lps'),
	(473805, 124, '2015-04-01 01:27:07.000000', 'consum', 0.0210, 'lps'),
	(473806, 124, '2015-04-01 01:27:08.000000', 'consum', 0.0220, 'lps'),
	(473807, 124, '2015-04-01 01:27:09.000000', 'consum', 0.0210, 'lps'),
	(473808, 124, '2015-04-01 01:27:10.000000', 'consum', 0.0232, 'lps'),
	(473809, 124, '2015-04-01 01:27:11.000000', 'consum', 0.0218, 'lps'),
	(473810, 124, '2015-04-01 01:27:12.000000', 'consum', 0.0210, 'lps'),
	(473811, 124, '2015-04-01 01:27:13.000000', 'consum', 0.0214, 'lps'),
	(473812, 124, '2015-04-01 01:27:14.000000', 'consum', 0.0230, 'lps'),
	(473813, 124, '2015-04-01 01:27:15.000000', 'consum', 0.0218, 'lps'),
	(473814, 124, '2015-04-01 01:27:16.000000', 'consum', 0.0217, 'lps'),
	(473815, 124, '2015-04-01 01:27:17.000000', 'consum', 0.0222, 'lps'),
	(473816, 124, '2015-04-01 01:27:18.000000', 'consum', 0.0225, 'lps'),
	(473817, 124, '2015-04-01 01:27:19.000000', 'consum', 0.0222, 'lps'),
	(473818, 124, '2015-04-01 01:27:20.000000', 'consum', 0.0226, 'lps'),
	(473819, 124, '2015-04-01 01:27:21.000000', 'consum', 0.0230, 'lps'),
	(473820, 124, '2015-04-01 01:27:22.000000', 'consum', 0.0211, 'lps'),
	(473821, 124, '2015-04-01 01:27:23.000000', 'consum', 0.0232, 'lps'),
	(473822, 124, '2015-04-01 01:27:24.000000', 'consum', 0.0212, 'lps'),
	(473823, 124, '2015-04-01 01:27:25.000000', 'consum', 0.0234, 'lps'),
	(473824, 124, '2015-04-01 01:27:26.000000', 'consum', 0.0221, 'lps'),
	(473825, 124, '2015-04-01 01:27:27.000000', 'consum', 0.0219, 'lps'),
	(473826, 124, '2015-04-01 01:27:28.000000', 'consum', 0.0222, 'lps'),
	(473827, 124, '2015-04-01 01:27:29.000000', 'consum', 0.0218, 'lps'),
	(473828, 124, '2015-04-01 01:27:30.000000', 'consum', 0.0214, 'lps'),
	(473829, 124, '2015-04-01 01:27:31.000000', 'consum', 0.0233, 'lps'),
	(473830, 124, '2015-04-01 01:27:32.000000', 'consum', 0.0210, 'lps'),
	(473831, 124, '2015-04-01 01:27:33.000000', 'consum', 0.0220, 'lps'),
	(473832, 124, '2015-04-01 01:27:34.000000', 'consum', 0.0235, 'lps'),
	(473833, 124, '2015-04-01 01:27:35.000000', 'consum', 0.0228, 'lps'),
	(473834, 124, '2015-04-01 01:27:36.000000', 'consum', 0.0226, 'lps'),
	(473835, 124, '2015-04-01 01:27:37.000000', 'consum', 0.0235, 'lps'),
	(473836, 124, '2015-04-01 01:27:38.000000', 'consum', 0.0235, 'lps'),
	(473837, 124, '2015-04-01 01:27:39.000000', 'consum', 0.0234, 'lps'),
	(473838, 124, '2015-04-01 01:27:40.000000', 'consum', 0.0231, 'lps'),
	(473839, 124, '2015-04-01 01:27:41.000000', 'consum', 0.0215, 'lps'),
	(473840, 124, '2015-04-01 01:27:42.000000', 'consum', 0.0226, 'lps'),
	(473841, 124, '2015-04-01 01:27:43.000000', 'consum', 0.0222, 'lps'),
	(473842, 124, '2015-04-01 01:27:44.000000', 'consum', 0.0224, 'lps'),
	(473843, 124, '2015-04-01 01:27:45.000000', 'consum', 0.0219, 'lps'),
	(473844, 124, '2015-04-01 01:27:46.000000', 'consum', 0.0215, 'lps'),
	(473845, 124, '2015-04-01 01:27:47.000000', 'consum', 0.0232, 'lps'),
	(473846, 124, '2015-04-01 01:27:48.000000', 'consum', 0.0229, 'lps'),
	(473847, 124, '2015-04-01 01:27:49.000000', 'consum', 0.0211, 'lps'),
	(473848, 124, '2015-04-01 01:27:50.000000', 'consum', 0.0212, 'lps'),
	(473849, 124, '2015-04-01 01:27:51.000000', 'consum', 0.0216, 'lps'),
	(473850, 124, '2015-04-01 01:27:52.000000', 'consum', 0.0211, 'lps'),
	(473851, 124, '2015-04-01 01:27:53.000000', 'consum', 0.0222, 'lps'),
	(473852, 124, '2015-04-01 01:27:54.000000', 'consum', 0.0216, 'lps'),
	(473853, 124, '2015-04-01 01:27:55.000000', 'consum', 0.0232, 'lps'),
	(473854, 124, '2015-04-01 01:27:56.000000', 'consum', 0.0222, 'lps'),
	(473855, 124, '2015-04-01 01:27:57.000000', 'consum', 0.0232, 'lps'),
	(473856, 124, '2015-04-01 01:27:58.000000', 'consum', 0.0234, 'lps'),
	(473857, 124, '2015-04-01 01:27:59.000000', 'consum', 0.0212, 'lps'),
	(473858, 124, '2015-04-01 01:28:00.000000', 'consum', 0.0227, 'lps'),
	(473859, 124, '2015-04-01 01:28:01.000000', 'consum', 0.0211, 'lps'),
	(473860, 124, '2015-04-01 01:28:02.000000', 'consum', 0.0216, 'lps'),
	(473861, 124, '2015-04-01 01:28:03.000000', 'consum', 0.0212, 'lps'),
	(473862, 124, '2015-04-01 01:28:04.000000', 'consum', 0.0227, 'lps'),
	(473863, 124, '2015-04-01 01:28:05.000000', 'consum', 0.0214, 'lps'),
	(473864, 124, '2015-04-01 01:28:06.000000', 'consum', 0.0232, 'lps'),
	(473865, 124, '2015-04-01 01:28:07.000000', 'consum', 0.0230, 'lps'),
	(473866, 124, '2015-04-01 01:28:08.000000', 'consum', 0.0218, 'lps'),
	(473867, 124, '2015-04-01 01:28:09.000000', 'consum', 0.0217, 'lps'),
	(473868, 124, '2015-04-01 01:28:10.000000', 'consum', 0.0220, 'lps'),
	(473869, 124, '2015-04-01 01:28:11.000000', 'consum', 0.0212, 'lps'),
	(473870, 124, '2015-04-01 01:28:12.000000', 'consum', 0.0219, 'lps'),
	(473871, 124, '2015-04-01 01:28:13.000000', 'consum', 0.0224, 'lps'),
	(473872, 124, '2015-04-01 01:28:14.000000', 'consum', 0.0226, 'lps'),
	(473873, 124, '2015-04-01 01:28:15.000000', 'consum', 0.0222, 'lps'),
	(473874, 124, '2015-04-01 01:28:16.000000', 'consum', 0.0224, 'lps'),
	(473875, 124, '2015-04-01 01:28:17.000000', 'consum', 0.0220, 'lps'),
	(473876, 124, '2015-04-01 01:28:18.000000', 'consum', 0.0217, 'lps'),
	(473877, 124, '2015-04-01 01:28:19.000000', 'consum', 0.0215, 'lps'),
	(473878, 124, '2015-04-01 01:28:20.000000', 'consum', 0.0214, 'lps'),
	(473879, 124, '2015-04-01 01:28:21.000000', 'consum', 0.0218, 'lps'),
	(473880, 124, '2015-04-01 01:28:22.000000', 'consum', 0.0210, 'lps'),
	(473881, 124, '2015-04-01 01:28:23.000000', 'consum', 0.0212, 'lps'),
	(473882, 124, '2015-04-01 01:28:24.000000', 'consum', 0.0222, 'lps'),
	(473883, 124, '2015-04-01 01:28:25.000000', 'consum', 0.0214, 'lps'),
	(473884, 124, '2015-04-01 01:28:26.000000', 'consum', 0.0220, 'lps'),
	(473885, 124, '2015-04-01 01:28:27.000000', 'consum', 0.0220, 'lps'),
	(473886, 124, '2015-04-01 01:28:28.000000', 'consum', 0.0233, 'lps'),
	(473887, 124, '2015-04-01 01:28:29.000000', 'consum', 0.0218, 'lps'),
	(473888, 124, '2015-04-01 01:28:30.000000', 'consum', 0.0235, 'lps'),
	(473889, 124, '2015-04-01 01:28:31.000000', 'consum', 0.0231, 'lps'),
	(473890, 124, '2015-04-01 01:28:32.000000', 'consum', 0.0213, 'lps'),
	(473891, 124, '2015-04-01 01:28:33.000000', 'consum', 0.0216, 'lps'),
	(473892, 124, '2015-04-01 01:28:34.000000', 'consum', 0.0231, 'lps'),
	(473893, 124, '2015-04-01 01:28:35.000000', 'consum', 0.0220, 'lps'),
	(473894, 124, '2015-04-01 01:28:36.000000', 'consum', 0.0222, 'lps'),
	(473895, 124, '2015-04-01 01:28:37.000000', 'consum', 0.0216, 'lps'),
	(473896, 124, '2015-04-01 01:28:38.000000', 'consum', 0.0232, 'lps'),
	(473897, 124, '2015-04-01 01:28:39.000000', 'consum', 0.0221, 'lps'),
	(473898, 124, '2015-04-01 01:28:40.000000', 'consum', 0.0228, 'lps'),
	(473899, 124, '2015-04-01 01:28:41.000000', 'consum', 0.0215, 'lps'),
	(473900, 124, '2015-04-01 01:28:42.000000', 'consum', 0.0234, 'lps'),
	(473901, 124, '2015-04-01 01:28:43.000000', 'consum', 0.0235, 'lps'),
	(473902, 124, '2015-04-01 01:28:44.000000', 'consum', 0.0214, 'lps'),
	(473903, 124, '2015-04-01 01:28:45.000000', 'consum', 0.0235, 'lps'),
	(473904, 124, '2015-04-01 01:28:46.000000', 'consum', 0.0216, 'lps'),
	(473905, 124, '2015-04-01 01:28:47.000000', 'consum', 0.0218, 'lps'),
	(473906, 124, '2015-04-01 01:28:48.000000', 'consum', 0.0235, 'lps'),
	(473907, 124, '2015-04-01 01:28:49.000000', 'consum', 0.0232, 'lps'),
	(473908, 124, '2015-04-01 01:28:50.000000', 'consum', 0.0220, 'lps'),
	(473909, 124, '2015-04-01 01:28:51.000000', 'consum', 0.0218, 'lps'),
	(473910, 124, '2015-04-01 01:28:52.000000', 'consum', 0.0223, 'lps'),
	(473911, 124, '2015-04-01 01:28:53.000000', 'consum', 0.0225, 'lps'),
	(473912, 124, '2015-04-01 01:28:54.000000', 'consum', 0.0222, 'lps'),
	(473913, 124, '2015-04-01 01:28:55.000000', 'consum', 0.0224, 'lps'),
	(473914, 124, '2015-04-01 01:28:56.000000', 'consum', 0.0218, 'lps'),
	(473915, 124, '2015-04-01 01:28:57.000000', 'consum', 0.0210, 'lps'),
	(473916, 124, '2015-04-01 01:28:58.000000', 'consum', 0.0212, 'lps'),
	(473917, 124, '2015-04-01 01:28:59.000000', 'consum', 0.0221, 'lps'),
	(473918, 124, '2015-04-01 01:29:00.000000', 'consum', 0.0233, 'lps'),
	(473919, 124, '2015-04-01 01:29:01.000000', 'consum', 0.0215, 'lps'),
	(473920, 124, '2015-04-01 01:29:02.000000', 'consum', 0.0219, 'lps'),
	(473921, 124, '2015-04-01 01:29:03.000000', 'consum', 0.0213, 'lps'),
	(473922, 124, '2015-04-01 01:29:04.000000', 'consum', 0.0227, 'lps'),
	(473923, 124, '2015-04-01 01:29:05.000000', 'consum', 0.0234, 'lps'),
	(473924, 124, '2015-04-01 01:29:06.000000', 'consum', 0.0227, 'lps'),
	(473925, 124, '2015-04-01 01:29:07.000000', 'consum', 0.0225, 'lps'),
	(473926, 124, '2015-04-01 01:29:08.000000', 'consum', 0.0233, 'lps'),
	(473927, 124, '2015-04-01 01:29:09.000000', 'consum', 0.0227, 'lps'),
	(473928, 124, '2015-04-01 01:29:10.000000', 'consum', 0.0227, 'lps'),
	(473929, 124, '2015-04-01 01:29:11.000000', 'consum', 0.0220, 'lps'),
	(473930, 124, '2015-04-01 01:29:12.000000', 'consum', 0.0234, 'lps'),
	(473931, 124, '2015-04-01 01:29:13.000000', 'consum', 0.0222, 'lps'),
	(473932, 124, '2015-04-01 01:29:14.000000', 'consum', 0.0226, 'lps'),
	(473933, 124, '2015-04-01 01:29:15.000000', 'consum', 0.0230, 'lps'),
	(473934, 124, '2015-04-01 01:29:16.000000', 'consum', 0.0235, 'lps'),
	(473935, 124, '2015-04-01 01:29:17.000000', 'consum', 0.0222, 'lps'),
	(473936, 124, '2015-04-01 01:29:18.000000', 'consum', 0.0223, 'lps'),
	(473937, 124, '2015-04-01 01:29:19.000000', 'consum', 0.0212, 'lps'),
	(473938, 124, '2015-04-01 01:29:20.000000', 'consum', 0.0234, 'lps'),
	(473939, 124, '2015-04-01 01:29:21.000000', 'consum', 0.0221, 'lps'),
	(473940, 124, '2015-04-01 01:29:22.000000', 'consum', 0.0220, 'lps'),
	(473941, 124, '2015-04-01 01:29:23.000000', 'consum', 0.0227, 'lps'),
	(473942, 124, '2015-04-01 01:29:24.000000', 'consum', 0.0215, 'lps'),
	(473943, 124, '2015-04-01 01:29:25.000000', 'consum', 0.0234, 'lps'),
	(473944, 124, '2015-04-01 01:29:26.000000', 'consum', 0.0213, 'lps'),
	(473945, 124, '2015-04-01 01:29:27.000000', 'consum', 0.0230, 'lps'),
	(473946, 124, '2015-04-01 01:29:28.000000', 'consum', 0.0225, 'lps'),
	(473947, 124, '2015-04-01 01:29:29.000000', 'consum', 0.0226, 'lps'),
	(473948, 124, '2015-04-01 01:29:30.000000', 'consum', 0.0217, 'lps'),
	(473949, 124, '2015-04-01 01:29:31.000000', 'consum', 0.0227, 'lps'),
	(473950, 124, '2015-04-01 01:29:32.000000', 'consum', 0.0220, 'lps'),
	(473951, 124, '2015-04-01 01:29:33.000000', 'consum', 0.0212, 'lps'),
	(473952, 124, '2015-04-01 01:29:34.000000', 'consum', 0.0216, 'lps'),
	(473953, 124, '2015-04-01 01:29:35.000000', 'consum', 0.0232, 'lps'),
	(473954, 124, '2015-04-01 01:29:36.000000', 'consum', 0.0225, 'lps'),
	(473955, 124, '2015-04-01 01:29:37.000000', 'consum', 0.0220, 'lps'),
	(473956, 124, '2015-04-01 01:29:38.000000', 'consum', 0.0217, 'lps'),
	(473957, 124, '2015-04-01 01:29:39.000000', 'consum', 0.0213, 'lps'),
	(473958, 124, '2015-04-01 01:29:40.000000', 'consum', 0.0233, 'lps'),
	(473959, 124, '2015-04-01 01:29:41.000000', 'consum', 0.0211, 'lps'),
	(473960, 124, '2015-04-01 01:29:42.000000', 'consum', 0.0224, 'lps'),
	(473961, 124, '2015-04-01 01:29:43.000000', 'consum', 0.0227, 'lps'),
	(473962, 124, '2015-04-01 01:29:44.000000', 'consum', 0.0228, 'lps'),
	(473963, 124, '2015-04-01 01:29:45.000000', 'consum', 0.0222, 'lps'),
	(473964, 124, '2015-04-01 01:29:46.000000', 'consum', 0.0217, 'lps'),
	(473965, 124, '2015-04-01 01:29:47.000000', 'consum', 0.0235, 'lps'),
	(473966, 124, '2015-04-01 01:29:48.000000', 'consum', 0.0235, 'lps'),
	(473967, 124, '2015-04-01 01:29:49.000000', 'consum', 0.0235, 'lps'),
	(473968, 124, '2015-04-01 01:29:50.000000', 'consum', 0.0235, 'lps'),
	(473969, 124, '2015-04-01 01:29:51.000000', 'consum', 0.0233, 'lps'),
	(473970, 124, '2015-04-01 01:29:52.000000', 'consum', 0.0223, 'lps'),
	(473971, 124, '2015-04-01 01:29:53.000000', 'consum', 0.0210, 'lps'),
	(473972, 124, '2015-04-01 01:29:54.000000', 'consum', 0.0224, 'lps'),
	(473973, 124, '2015-04-01 01:29:55.000000', 'consum', 0.0225, 'lps'),
	(473974, 124, '2015-04-01 01:29:56.000000', 'consum', 0.0221, 'lps'),
	(473975, 124, '2015-04-01 01:29:57.000000', 'consum', 0.0219, 'lps'),
	(473976, 124, '2015-04-01 01:29:58.000000', 'consum', 0.0223, 'lps'),
	(473977, 124, '2015-04-01 01:29:59.000000', 'consum', 0.0220, 'lps'),
	(473978, 124, '2015-04-01 01:30:00.000000', 'consum', 0.0224, 'lps'),
	(473979, 124, '2015-04-01 01:30:01.000000', 'consum', 0.0225, 'lps'),
	(473980, 124, '2015-04-01 01:30:02.000000', 'consum', 0.0215, 'lps'),
	(473981, 124, '2015-04-01 01:30:03.000000', 'consum', 0.0217, 'lps'),
	(473982, 124, '2015-04-01 01:30:04.000000', 'consum', 0.0229, 'lps'),
	(473983, 124, '2015-04-01 01:30:05.000000', 'consum', 0.0235, 'lps'),
	(473984, 124, '2015-04-01 01:30:06.000000', 'consum', 0.0227, 'lps'),
	(473985, 124, '2015-04-01 01:30:07.000000', 'consum', 0.0219, 'lps'),
	(473986, 124, '2015-04-01 01:30:08.000000', 'consum', 0.0231, 'lps'),
	(473987, 124, '2015-04-01 01:30:09.000000', 'consum', 0.0235, 'lps'),
	(473988, 124, '2015-04-01 01:30:10.000000', 'consum', 0.0220, 'lps'),
	(473989, 124, '2015-04-01 01:30:11.000000', 'consum', 0.0214, 'lps'),
	(473990, 124, '2015-04-01 01:30:12.000000', 'consum', 0.0226, 'lps'),
	(473991, 124, '2015-04-01 01:30:13.000000', 'consum', 0.0224, 'lps'),
	(473992, 124, '2015-04-01 01:30:14.000000', 'consum', 0.0235, 'lps'),
	(473993, 124, '2015-04-01 01:30:15.000000', 'consum', 0.0217, 'lps'),
	(473994, 124, '2015-04-01 01:30:16.000000', 'consum', 0.0219, 'lps'),
	(473995, 124, '2015-04-01 01:30:17.000000', 'consum', 0.0211, 'lps'),
	(473996, 124, '2015-04-01 01:30:18.000000', 'consum', 0.0213, 'lps'),
	(473997, 124, '2015-04-01 01:30:19.000000', 'consum', 0.0221, 'lps'),
	(473998, 124, '2015-04-01 01:30:20.000000', 'consum', 0.0233, 'lps'),
	(473999, 124, '2015-04-01 01:30:21.000000', 'consum', 0.0216, 'lps'),
	(474000, 124, '2015-04-01 01:30:22.000000', 'consum', 0.0221, 'lps'),
	(474001, 124, '2015-04-01 01:30:23.000000', 'consum', 0.0222, 'lps'),
	(474002, 124, '2015-04-01 01:30:24.000000', 'consum', 0.0214, 'lps'),
	(474003, 124, '2015-04-01 01:30:25.000000', 'consum', 0.0218, 'lps'),
	(474004, 124, '2015-04-01 01:30:26.000000', 'consum', 0.0212, 'lps'),
	(474005, 124, '2015-04-01 01:30:27.000000', 'consum', 0.0221, 'lps'),
	(474006, 124, '2015-04-01 01:30:28.000000', 'consum', 0.0211, 'lps'),
	(474007, 124, '2015-04-01 01:30:29.000000', 'consum', 0.0233, 'lps'),
	(474008, 124, '2015-04-01 01:30:30.000000', 'consum', 0.0219, 'lps'),
	(474009, 124, '2015-04-01 01:30:31.000000', 'consum', 0.0213, 'lps'),
	(474010, 124, '2015-04-01 01:30:32.000000', 'consum', 0.0225, 'lps'),
	(474011, 124, '2015-04-01 01:30:33.000000', 'consum', 0.0223, 'lps'),
	(474012, 124, '2015-04-01 01:30:34.000000', 'consum', 0.0232, 'lps'),
	(474013, 124, '2015-04-01 01:30:35.000000', 'consum', 0.0229, 'lps'),
	(474014, 124, '2015-04-01 01:30:36.000000', 'consum', 0.0215, 'lps'),
	(474015, 124, '2015-04-01 01:30:37.000000', 'consum', 0.0230, 'lps'),
	(474016, 124, '2015-04-01 01:30:38.000000', 'consum', 0.0216, 'lps'),
	(474017, 124, '2015-04-01 01:30:39.000000', 'consum', 0.0235, 'lps'),
	(474018, 124, '2015-04-01 01:30:40.000000', 'consum', 0.0212, 'lps'),
	(474019, 124, '2015-04-01 01:30:41.000000', 'consum', 0.0223, 'lps'),
	(474020, 124, '2015-04-01 01:30:42.000000', 'consum', 0.0218, 'lps'),
	(474021, 124, '2015-04-01 01:30:43.000000', 'consum', 0.0213, 'lps'),
	(474022, 124, '2015-04-01 01:30:44.000000', 'consum', 0.0226, 'lps'),
	(474023, 124, '2015-04-01 01:30:45.000000', 'consum', 0.0229, 'lps'),
	(474024, 124, '2015-04-01 01:30:46.000000', 'consum', 0.0233, 'lps'),
	(474025, 124, '2015-04-01 01:30:47.000000', 'consum', 0.0214, 'lps'),
	(474026, 124, '2015-04-01 01:30:48.000000', 'consum', 0.0216, 'lps'),
	(474027, 124, '2015-04-01 01:30:49.000000', 'consum', 0.0227, 'lps'),
	(474028, 124, '2015-04-01 01:30:50.000000', 'consum', 0.0227, 'lps'),
	(474029, 124, '2015-04-01 01:30:51.000000', 'consum', 0.0218, 'lps'),
	(474030, 124, '2015-04-01 01:30:52.000000', 'consum', 0.0227, 'lps'),
	(474031, 124, '2015-04-01 01:30:53.000000', 'consum', 0.0218, 'lps'),
	(474032, 124, '2015-04-01 01:30:54.000000', 'consum', 0.0225, 'lps'),
	(474033, 124, '2015-04-01 01:30:55.000000', 'consum', 0.0211, 'lps'),
	(474034, 124, '2015-04-01 01:30:56.000000', 'consum', 0.0223, 'lps'),
	(474035, 124, '2015-04-01 01:30:57.000000', 'consum', 0.0222, 'lps'),
	(474036, 124, '2015-04-01 01:30:58.000000', 'consum', 0.0228, 'lps'),
	(474037, 124, '2015-04-01 01:30:59.000000', 'consum', 0.0213, 'lps'),
	(474038, 124, '2015-04-01 01:31:00.000000', 'consum', 0.0223, 'lps'),
	(474039, 124, '2015-04-01 01:31:01.000000', 'consum', 0.0214, 'lps'),
	(474040, 124, '2015-04-01 01:31:02.000000', 'consum', 0.0219, 'lps'),
	(474041, 124, '2015-04-01 01:31:03.000000', 'consum', 0.0216, 'lps'),
	(474042, 124, '2015-04-01 01:31:04.000000', 'consum', 0.0212, 'lps'),
	(474043, 124, '2015-04-01 01:31:05.000000', 'consum', 0.0230, 'lps'),
	(474044, 124, '2015-04-01 01:31:06.000000', 'consum', 0.0228, 'lps'),
	(474045, 124, '2015-04-01 01:31:07.000000', 'consum', 0.0215, 'lps'),
	(474046, 124, '2015-04-01 01:31:08.000000', 'consum', 0.0233, 'lps'),
	(474047, 124, '2015-04-01 01:31:09.000000', 'consum', 0.0233, 'lps'),
	(474048, 124, '2015-04-01 01:31:10.000000', 'consum', 0.0232, 'lps'),
	(474049, 124, '2015-04-01 01:31:11.000000', 'consum', 0.0224, 'lps'),
	(474050, 124, '2015-04-01 01:31:12.000000', 'consum', 0.0214, 'lps'),
	(474051, 124, '2015-04-01 01:31:13.000000', 'consum', 0.0214, 'lps'),
	(474052, 124, '2015-04-01 01:31:14.000000', 'consum', 0.0218, 'lps'),
	(474053, 124, '2015-04-01 01:31:15.000000', 'consum', 0.0211, 'lps'),
	(474054, 124, '2015-04-01 01:31:16.000000', 'consum', 0.0221, 'lps'),
	(474055, 124, '2015-04-01 01:31:17.000000', 'consum', 0.0210, 'lps'),
	(474056, 124, '2015-04-01 01:31:18.000000', 'consum', 0.0227, 'lps'),
	(474057, 124, '2015-04-01 01:31:19.000000', 'consum', 0.0219, 'lps'),
	(474058, 124, '2015-04-01 01:31:20.000000', 'consum', 0.0231, 'lps'),
	(474059, 124, '2015-04-01 01:31:21.000000', 'consum', 0.0235, 'lps'),
	(474060, 124, '2015-04-01 01:31:22.000000', 'consum', 0.0221, 'lps'),
	(474061, 124, '2015-04-01 01:31:23.000000', 'consum', 0.0218, 'lps'),
	(474062, 124, '2015-04-01 01:31:24.000000', 'consum', 0.0216, 'lps'),
	(474063, 124, '2015-04-01 01:31:25.000000', 'consum', 0.0215, 'lps'),
	(474064, 124, '2015-04-01 01:31:26.000000', 'consum', 0.0219, 'lps'),
	(474065, 124, '2015-04-01 01:31:27.000000', 'consum', 0.0213, 'lps'),
	(474066, 124, '2015-04-01 01:31:28.000000', 'consum', 0.0225, 'lps'),
	(474067, 124, '2015-04-01 01:31:29.000000', 'consum', 0.0224, 'lps'),
	(474068, 124, '2015-04-01 01:31:30.000000', 'consum', 0.0212, 'lps'),
	(474069, 124, '2015-04-01 01:31:31.000000', 'consum', 0.0227, 'lps'),
	(474070, 124, '2015-04-01 01:31:32.000000', 'consum', 0.0214, 'lps'),
	(474071, 124, '2015-04-01 01:31:33.000000', 'consum', 0.0230, 'lps'),
	(474072, 124, '2015-04-01 01:31:34.000000', 'consum', 0.0221, 'lps'),
	(474073, 124, '2015-04-01 01:31:35.000000', 'consum', 0.0231, 'lps'),
	(474074, 124, '2015-04-01 01:31:36.000000', 'consum', 0.0231, 'lps'),
	(474075, 124, '2015-04-01 01:31:37.000000', 'consum', 0.0226, 'lps'),
	(474076, 124, '2015-04-01 01:31:38.000000', 'consum', 0.0229, 'lps'),
	(474077, 124, '2015-04-01 01:31:39.000000', 'consum', 0.0229, 'lps'),
	(474078, 124, '2015-04-01 01:31:40.000000', 'consum', 0.0222, 'lps'),
	(474079, 124, '2015-04-01 01:31:41.000000', 'consum', 0.0214, 'lps'),
	(474080, 124, '2015-04-01 01:31:42.000000', 'consum', 0.0220, 'lps'),
	(474081, 124, '2015-04-01 01:31:43.000000', 'consum', 0.0223, 'lps'),
	(474082, 124, '2015-04-01 01:31:44.000000', 'consum', 0.0221, 'lps'),
	(474083, 124, '2015-04-01 01:31:45.000000', 'consum', 0.0226, 'lps'),
	(474084, 124, '2015-04-01 01:31:46.000000', 'consum', 0.0229, 'lps'),
	(474085, 124, '2015-04-01 01:31:47.000000', 'consum', 0.0234, 'lps'),
	(474086, 124, '2015-04-01 01:31:48.000000', 'consum', 0.0222, 'lps'),
	(474087, 124, '2015-04-01 01:31:49.000000', 'consum', 0.0225, 'lps'),
	(474088, 124, '2015-04-01 01:31:50.000000', 'consum', 0.0222, 'lps'),
	(474089, 124, '2015-04-01 01:31:51.000000', 'consum', 0.0226, 'lps'),
	(474090, 124, '2015-04-01 01:31:52.000000', 'consum', 0.0227, 'lps'),
	(474091, 124, '2015-04-01 01:31:53.000000', 'consum', 0.0223, 'lps'),
	(474092, 124, '2015-04-01 01:31:54.000000', 'consum', 0.0225, 'lps'),
	(474093, 124, '2015-04-01 01:31:55.000000', 'consum', 0.0219, 'lps'),
	(474094, 124, '2015-04-01 01:31:56.000000', 'consum', 0.0212, 'lps'),
	(474095, 124, '2015-04-01 01:31:57.000000', 'consum', 0.0220, 'lps'),
	(474096, 124, '2015-04-01 01:31:58.000000', 'consum', 0.0226, 'lps'),
	(474097, 124, '2015-04-01 01:31:59.000000', 'consum', 0.0212, 'lps'),
	(474098, 124, '2015-04-01 01:32:00.000000', 'consum', 0.0222, 'lps'),
	(474099, 124, '2015-04-01 01:32:01.000000', 'consum', 0.0214, 'lps'),
	(474100, 124, '2015-04-01 01:32:02.000000', 'consum', 0.0221, 'lps'),
	(474101, 124, '2015-04-01 01:32:03.000000', 'consum', 0.0229, 'lps'),
	(474102, 124, '2015-04-01 01:32:04.000000', 'consum', 0.0217, 'lps'),
	(474103, 124, '2015-04-01 01:32:05.000000', 'consum', 0.0216, 'lps'),
	(474104, 124, '2015-04-01 01:32:06.000000', 'consum', 0.0218, 'lps'),
	(474105, 124, '2015-04-01 01:32:07.000000', 'consum', 0.0235, 'lps'),
	(474106, 124, '2015-04-01 01:32:08.000000', 'consum', 0.0234, 'lps'),
	(474107, 124, '2015-04-01 01:32:09.000000', 'consum', 0.0229, 'lps'),
	(474108, 124, '2015-04-01 01:32:10.000000', 'consum', 0.0234, 'lps'),
	(474109, 124, '2015-04-01 01:32:11.000000', 'consum', 0.0219, 'lps'),
	(474110, 124, '2015-04-01 01:32:12.000000', 'consum', 0.0211, 'lps'),
	(474111, 124, '2015-04-01 01:32:13.000000', 'consum', 0.0214, 'lps'),
	(474112, 124, '2015-04-01 01:32:14.000000', 'consum', 0.0227, 'lps'),
	(474113, 124, '2015-04-01 01:32:15.000000', 'consum', 0.0231, 'lps'),
	(474114, 124, '2015-04-01 01:32:16.000000', 'consum', 0.0214, 'lps'),
	(474115, 124, '2015-04-01 01:32:17.000000', 'consum', 0.0217, 'lps'),
	(474116, 124, '2015-04-01 01:32:18.000000', 'consum', 0.0235, 'lps'),
	(474117, 124, '2015-04-01 01:32:19.000000', 'consum', 0.0212, 'lps'),
	(474118, 124, '2015-04-01 01:32:20.000000', 'consum', 0.0222, 'lps'),
	(474119, 124, '2015-04-01 01:32:21.000000', 'consum', 0.0211, 'lps'),
	(474120, 124, '2015-04-01 01:32:22.000000', 'consum', 0.0232, 'lps'),
	(474121, 124, '2015-04-01 01:32:23.000000', 'consum', 0.0212, 'lps'),
	(474122, 124, '2015-04-01 01:32:24.000000', 'consum', 0.0210, 'lps'),
	(474123, 124, '2015-04-01 01:32:25.000000', 'consum', 0.0229, 'lps'),
	(474124, 124, '2015-04-01 01:32:26.000000', 'consum', 0.0226, 'lps'),
	(474125, 124, '2015-04-01 01:32:27.000000', 'consum', 0.0210, 'lps'),
	(474126, 124, '2015-04-01 01:32:28.000000', 'consum', 0.0214, 'lps'),
	(474127, 124, '2015-04-01 01:32:29.000000', 'consum', 0.0229, 'lps'),
	(474128, 124, '2015-04-01 01:32:30.000000', 'consum', 0.0215, 'lps'),
	(474129, 124, '2015-04-01 01:32:31.000000', 'consum', 0.0233, 'lps'),
	(474130, 124, '2015-04-01 01:32:32.000000', 'consum', 0.0233, 'lps'),
	(474131, 124, '2015-04-01 01:32:33.000000', 'consum', 0.0230, 'lps'),
	(474132, 124, '2015-04-01 01:32:34.000000', 'consum', 0.0213, 'lps'),
	(474133, 124, '2015-04-01 01:32:35.000000', 'consum', 0.0219, 'lps'),
	(474134, 124, '2015-04-01 01:32:36.000000', 'consum', 0.0220, 'lps'),
	(474135, 124, '2015-04-01 01:32:37.000000', 'consum', 0.0233, 'lps'),
	(474136, 124, '2015-04-01 01:32:38.000000', 'consum', 0.0220, 'lps'),
	(474137, 124, '2015-04-01 01:32:39.000000', 'consum', 0.0217, 'lps'),
	(474138, 124, '2015-04-01 01:32:40.000000', 'consum', 0.0215, 'lps'),
	(474139, 124, '2015-04-01 01:32:41.000000', 'consum', 0.0216, 'lps'),
	(474140, 124, '2015-04-01 01:32:42.000000', 'consum', 0.0224, 'lps'),
	(474141, 124, '2015-04-01 01:32:43.000000', 'consum', 0.0211, 'lps'),
	(474142, 124, '2015-04-01 01:32:44.000000', 'consum', 0.0227, 'lps'),
	(474143, 124, '2015-04-01 01:32:45.000000', 'consum', 0.0215, 'lps'),
	(474144, 124, '2015-04-01 01:32:46.000000', 'consum', 0.0211, 'lps'),
	(474145, 124, '2015-04-01 01:32:47.000000', 'consum', 0.0225, 'lps'),
	(474146, 125, '2015-04-01 00:00:00.000000', 'consum', 0.0224, 'lps'),
	(474147, 125, '2015-04-01 00:00:01.000000', 'consum', 0.0212, 'lps'),
	(474148, 125, '2015-04-01 00:00:02.000000', 'consum', 0.0226, 'lps'),
	(474149, 125, '2015-04-01 00:00:03.000000', 'consum', 0.0212, 'lps'),
	(474150, 125, '2015-04-01 00:00:04.000000', 'consum', 0.0220, 'lps'),
	(474151, 125, '2015-04-01 00:00:05.000000', 'consum', 0.0232, 'lps'),
	(474152, 125, '2015-04-01 00:00:06.000000', 'consum', 0.0217, 'lps'),
	(474153, 125, '2015-04-01 00:00:07.000000', 'consum', 0.0226, 'lps'),
	(474154, 125, '2015-04-01 00:00:08.000000', 'consum', 0.0224, 'lps'),
	(474155, 125, '2015-04-01 00:00:09.000000', 'consum', 0.0230, 'lps'),
	(474156, 125, '2015-04-01 00:00:10.000000', 'consum', 0.0223, 'lps'),
	(474157, 125, '2015-04-01 00:00:11.000000', 'consum', 0.0214, 'lps'),
	(474158, 125, '2015-04-01 00:00:12.000000', 'consum', 0.0214, 'lps'),
	(474159, 125, '2015-04-01 00:00:13.000000', 'consum', 0.0221, 'lps'),
	(474160, 125, '2015-04-01 00:00:14.000000', 'consum', 0.0230, 'lps'),
	(474161, 125, '2015-04-01 00:00:15.000000', 'consum', 0.0227, 'lps'),
	(474162, 125, '2015-04-01 00:00:16.000000', 'consum', 0.0212, 'lps'),
	(474163, 125, '2015-04-01 00:00:17.000000', 'consum', 0.0218, 'lps'),
	(474164, 125, '2015-04-01 00:00:18.000000', 'consum', 0.0220, 'lps'),
	(474165, 125, '2015-04-01 00:00:19.000000', 'consum', 0.0213, 'lps'),
	(474166, 125, '2015-04-01 00:00:20.000000', 'consum', 0.0218, 'lps'),
	(474167, 125, '2015-04-01 00:00:21.000000', 'consum', 0.0218, 'lps'),
	(474168, 125, '2015-04-01 00:00:22.000000', 'consum', 0.0226, 'lps'),
	(474169, 125, '2015-04-01 00:00:23.000000', 'consum', 0.0221, 'lps'),
	(474170, 125, '2015-04-01 00:00:24.000000', 'consum', 0.0214, 'lps'),
	(474171, 125, '2015-04-01 00:00:25.000000', 'consum', 0.0225, 'lps'),
	(474172, 125, '2015-04-01 00:00:26.000000', 'consum', 0.0224, 'lps'),
	(474173, 125, '2015-04-01 00:00:27.000000', 'consum', 0.0210, 'lps'),
	(474174, 125, '2015-04-01 00:00:28.000000', 'consum', 0.0220, 'lps'),
	(474175, 125, '2015-04-01 00:00:29.000000', 'consum', 0.0233, 'lps'),
	(474176, 125, '2015-04-01 00:00:30.000000', 'consum', 0.0226, 'lps'),
	(474177, 125, '2015-04-01 00:00:31.000000', 'consum', 0.0223, 'lps'),
	(474178, 125, '2015-04-01 00:00:32.000000', 'consum', 0.0224, 'lps'),
	(474179, 125, '2015-04-01 00:00:33.000000', 'consum', 0.0218, 'lps'),
	(474180, 125, '2015-04-01 00:00:34.000000', 'consum', 0.0233, 'lps'),
	(474181, 125, '2015-04-01 00:00:35.000000', 'consum', 0.0229, 'lps'),
	(474182, 125, '2015-04-01 00:00:36.000000', 'consum', 0.0211, 'lps'),
	(474183, 125, '2015-04-01 00:00:37.000000', 'consum', 0.0233, 'lps'),
	(474184, 125, '2015-04-01 00:00:38.000000', 'consum', 0.0227, 'lps'),
	(474185, 125, '2015-04-01 00:00:39.000000', 'consum', 0.0226, 'lps'),
	(474186, 125, '2015-04-01 00:00:40.000000', 'consum', 0.0216, 'lps'),
	(474187, 125, '2015-04-01 00:00:41.000000', 'consum', 0.0216, 'lps'),
	(474188, 125, '2015-04-01 00:00:42.000000', 'consum', 0.0220, 'lps'),
	(474189, 125, '2015-04-01 00:00:43.000000', 'consum', 0.0222, 'lps'),
	(474190, 125, '2015-04-01 00:00:44.000000', 'consum', 0.0213, 'lps'),
	(474191, 125, '2015-04-01 00:00:45.000000', 'consum', 0.0217, 'lps'),
	(474192, 125, '2015-04-01 00:00:46.000000', 'consum', 0.0210, 'lps'),
	(474193, 125, '2015-04-01 00:00:47.000000', 'consum', 0.0213, 'lps'),
	(474194, 125, '2015-04-01 00:00:48.000000', 'consum', 0.0226, 'lps'),
	(474195, 125, '2015-04-01 00:00:49.000000', 'consum', 0.0212, 'lps'),
	(474196, 125, '2015-04-01 00:00:50.000000', 'consum', 0.0218, 'lps'),
	(474197, 125, '2015-04-01 00:00:51.000000', 'consum', 0.0219, 'lps'),
	(474198, 125, '2015-04-01 00:00:52.000000', 'consum', 0.0211, 'lps'),
	(474199, 125, '2015-04-01 00:00:53.000000', 'consum', 0.0211, 'lps'),
	(474200, 125, '2015-04-01 00:00:54.000000', 'consum', 0.0214, 'lps'),
	(474201, 125, '2015-04-01 00:00:55.000000', 'consum', 0.0227, 'lps'),
	(474202, 125, '2015-04-01 00:00:56.000000', 'consum', 0.0210, 'lps'),
	(474203, 125, '2015-04-01 00:00:57.000000', 'consum', 0.0233, 'lps'),
	(474204, 125, '2015-04-01 00:00:58.000000', 'consum', 0.0229, 'lps'),
	(474205, 125, '2015-04-01 00:00:59.000000', 'consum', 0.0214, 'lps'),
	(474206, 125, '2015-04-01 00:01:00.000000', 'consum', 0.0219, 'lps'),
	(474207, 125, '2015-04-01 00:01:01.000000', 'consum', 0.0222, 'lps'),
	(474208, 125, '2015-04-01 00:01:02.000000', 'consum', 0.0220, 'lps'),
	(474209, 125, '2015-04-01 00:01:03.000000', 'consum', 0.0225, 'lps'),
	(474210, 125, '2015-04-01 00:01:04.000000', 'consum', 0.0229, 'lps'),
	(474211, 125, '2015-04-01 00:01:05.000000', 'consum', 0.0215, 'lps'),
	(474212, 125, '2015-04-01 00:01:06.000000', 'consum', 0.0225, 'lps'),
	(474213, 125, '2015-04-01 00:01:07.000000', 'consum', 0.0221, 'lps'),
	(474214, 125, '2015-04-01 00:01:08.000000', 'consum', 0.0224, 'lps'),
	(474215, 125, '2015-04-01 00:01:09.000000', 'consum', 0.0220, 'lps'),
	(474216, 125, '2015-04-01 00:01:10.000000', 'consum', 0.0220, 'lps'),
	(474217, 125, '2015-04-01 00:01:11.000000', 'consum', 0.0231, 'lps'),
	(474218, 125, '2015-04-01 00:01:12.000000', 'consum', 0.0213, 'lps'),
	(474219, 125, '2015-04-01 00:01:13.000000', 'consum', 0.0211, 'lps'),
	(474220, 125, '2015-04-01 00:01:14.000000', 'consum', 0.0229, 'lps'),
	(474221, 125, '2015-04-01 00:01:15.000000', 'consum', 0.0232, 'lps'),
	(474222, 125, '2015-04-01 00:01:16.000000', 'consum', 0.0214, 'lps'),
	(474223, 125, '2015-04-01 00:01:17.000000', 'consum', 0.0214, 'lps'),
	(474224, 125, '2015-04-01 00:01:18.000000', 'consum', 0.0216, 'lps'),
	(474225, 125, '2015-04-01 00:01:19.000000', 'consum', 0.0231, 'lps'),
	(474226, 125, '2015-04-01 00:01:20.000000', 'consum', 0.0223, 'lps'),
	(474227, 125, '2015-04-01 00:01:21.000000', 'consum', 0.0212, 'lps'),
	(474228, 125, '2015-04-01 00:01:22.000000', 'consum', 0.0232, 'lps'),
	(474229, 125, '2015-04-01 00:01:23.000000', 'consum', 0.0217, 'lps'),
	(474230, 125, '2015-04-01 00:01:24.000000', 'consum', 0.0228, 'lps'),
	(474231, 125, '2015-04-01 00:01:25.000000', 'consum', 0.0233, 'lps'),
	(474232, 125, '2015-04-01 00:01:26.000000', 'consum', 0.0222, 'lps'),
	(474233, 125, '2015-04-01 00:01:27.000000', 'consum', 0.0225, 'lps'),
	(474234, 125, '2015-04-01 00:01:28.000000', 'consum', 0.0227, 'lps'),
	(474235, 125, '2015-04-01 00:01:29.000000', 'consum', 0.0225, 'lps'),
	(474236, 125, '2015-04-01 00:01:30.000000', 'consum', 0.0210, 'lps'),
	(474237, 125, '2015-04-01 00:01:31.000000', 'consum', 0.0213, 'lps'),
	(474238, 125, '2015-04-01 00:01:32.000000', 'consum', 0.0225, 'lps'),
	(474239, 125, '2015-04-01 00:01:33.000000', 'consum', 0.0228, 'lps'),
	(474240, 125, '2015-04-01 00:01:34.000000', 'consum', 0.0230, 'lps'),
	(474241, 125, '2015-04-01 00:01:35.000000', 'consum', 0.0212, 'lps'),
	(474242, 125, '2015-04-01 00:01:36.000000', 'consum', 0.0232, 'lps'),
	(474243, 125, '2015-04-01 00:01:37.000000', 'consum', 0.0218, 'lps'),
	(474244, 125, '2015-04-01 00:01:38.000000', 'consum', 0.0232, 'lps'),
	(474245, 125, '2015-04-01 00:01:39.000000', 'consum', 0.0226, 'lps'),
	(474246, 125, '2015-04-01 00:01:40.000000', 'consum', 0.0222, 'lps'),
	(474247, 125, '2015-04-01 00:01:41.000000', 'consum', 0.0223, 'lps'),
	(474248, 125, '2015-04-01 00:01:42.000000', 'consum', 0.0214, 'lps'),
	(474249, 125, '2015-04-01 00:01:43.000000', 'consum', 0.0217, 'lps'),
	(474250, 125, '2015-04-01 00:01:44.000000', 'consum', 0.0233, 'lps'),
	(474251, 125, '2015-04-01 00:01:45.000000', 'consum', 0.0210, 'lps'),
	(474252, 125, '2015-04-01 00:01:46.000000', 'consum', 0.0213, 'lps'),
	(474253, 125, '2015-04-01 00:01:47.000000', 'consum', 0.0225, 'lps'),
	(474254, 125, '2015-04-01 00:01:48.000000', 'consum', 0.0228, 'lps'),
	(474255, 125, '2015-04-01 00:01:49.000000', 'consum', 0.0231, 'lps'),
	(474256, 125, '2015-04-01 00:01:50.000000', 'consum', 0.0213, 'lps'),
	(474257, 125, '2015-04-01 00:01:51.000000', 'consum', 0.0210, 'lps'),
	(474258, 125, '2015-04-01 00:01:52.000000', 'consum', 0.0226, 'lps'),
	(474259, 125, '2015-04-01 00:01:53.000000', 'consum', 0.0217, 'lps'),
	(474260, 125, '2015-04-01 00:01:54.000000', 'consum', 0.0223, 'lps'),
	(474261, 125, '2015-04-01 00:01:55.000000', 'consum', 0.0232, 'lps'),
	(474262, 125, '2015-04-01 00:01:56.000000', 'consum', 0.0210, 'lps'),
	(474263, 125, '2015-04-01 00:01:57.000000', 'consum', 0.0216, 'lps'),
	(474264, 125, '2015-04-01 00:01:58.000000', 'consum', 0.0214, 'lps'),
	(474265, 125, '2015-04-01 00:01:59.000000', 'consum', 0.0214, 'lps'),
	(474266, 125, '2015-04-01 00:02:00.000000', 'consum', 0.0220, 'lps'),
	(474267, 125, '2015-04-01 00:02:01.000000', 'consum', 0.0223, 'lps'),
	(474268, 125, '2015-04-01 00:02:02.000000', 'consum', 0.0221, 'lps'),
	(474269, 125, '2015-04-01 00:02:03.000000', 'consum', 0.0227, 'lps'),
	(474270, 125, '2015-04-01 00:02:04.000000', 'consum', 0.0213, 'lps'),
	(474271, 125, '2015-04-01 00:02:05.000000', 'consum', 0.0225, 'lps'),
	(474272, 125, '2015-04-01 00:02:06.000000', 'consum', 0.0227, 'lps'),
	(474273, 125, '2015-04-01 00:02:07.000000', 'consum', 0.0229, 'lps'),
	(474274, 125, '2015-04-01 00:02:08.000000', 'consum', 0.0227, 'lps'),
	(474275, 125, '2015-04-01 00:02:09.000000', 'consum', 0.0217, 'lps'),
	(474276, 125, '2015-04-01 00:02:10.000000', 'consum', 0.0218, 'lps'),
	(474277, 125, '2015-04-01 00:02:11.000000', 'consum', 0.0229, 'lps'),
	(474278, 125, '2015-04-01 00:02:12.000000', 'consum', 0.0210, 'lps'),
	(474279, 125, '2015-04-01 00:02:13.000000', 'consum', 0.0223, 'lps'),
	(474280, 125, '2015-04-01 00:02:14.000000', 'consum', 0.0230, 'lps'),
	(474281, 125, '2015-04-01 00:02:15.000000', 'consum', 0.0222, 'lps'),
	(474282, 125, '2015-04-01 00:02:16.000000', 'consum', 0.0213, 'lps'),
	(474283, 125, '2015-04-01 00:02:17.000000', 'consum', 0.0210, 'lps'),
	(474284, 125, '2015-04-01 00:02:18.000000', 'consum', 0.0228, 'lps'),
	(474285, 125, '2015-04-01 00:02:19.000000', 'consum', 0.0228, 'lps'),
	(474286, 125, '2015-04-01 00:02:20.000000', 'consum', 0.0220, 'lps'),
	(474287, 125, '2015-04-01 00:02:21.000000', 'consum', 0.0210, 'lps'),
	(474288, 125, '2015-04-01 00:02:22.000000', 'consum', 0.0228, 'lps'),
	(474289, 125, '2015-04-01 00:02:23.000000', 'consum', 0.0229, 'lps'),
	(474290, 125, '2015-04-01 00:02:24.000000', 'consum', 0.0228, 'lps'),
	(474291, 125, '2015-04-01 00:02:25.000000', 'consum', 0.0219, 'lps'),
	(474292, 125, '2015-04-01 00:02:26.000000', 'consum', 0.0224, 'lps'),
	(474293, 125, '2015-04-01 00:02:27.000000', 'consum', 0.0232, 'lps'),
	(474294, 125, '2015-04-01 00:02:28.000000', 'consum', 0.0230, 'lps'),
	(474295, 125, '2015-04-01 00:02:29.000000', 'consum', 0.0220, 'lps'),
	(474296, 125, '2015-04-01 00:02:30.000000', 'consum', 0.0226, 'lps'),
	(474297, 125, '2015-04-01 00:02:31.000000', 'consum', 0.0213, 'lps'),
	(474298, 125, '2015-04-01 00:02:32.000000', 'consum', 0.0223, 'lps'),
	(474299, 125, '2015-04-01 00:02:33.000000', 'consum', 0.0218, 'lps'),
	(474300, 125, '2015-04-01 00:02:34.000000', 'consum', 0.0213, 'lps'),
	(474301, 125, '2015-04-01 00:02:35.000000', 'consum', 0.0226, 'lps'),
	(474302, 125, '2015-04-01 00:02:36.000000', 'consum', 0.0210, 'lps'),
	(474303, 125, '2015-04-01 00:02:37.000000', 'consum', 0.0212, 'lps'),
	(474304, 125, '2015-04-01 00:02:38.000000', 'consum', 0.0218, 'lps'),
	(474305, 125, '2015-04-01 00:02:39.000000', 'consum', 0.0219, 'lps'),
	(474306, 125, '2015-04-01 00:02:40.000000', 'consum', 0.0211, 'lps'),
	(474307, 125, '2015-04-01 00:02:41.000000', 'consum', 0.0210, 'lps'),
	(474308, 125, '2015-04-01 00:02:42.000000', 'consum', 0.0210, 'lps'),
	(474309, 125, '2015-04-01 00:02:43.000000', 'consum', 0.0232, 'lps'),
	(474310, 125, '2015-04-01 00:02:44.000000', 'consum', 0.0227, 'lps'),
	(474311, 125, '2015-04-01 00:02:45.000000', 'consum', 0.0229, 'lps'),
	(474312, 125, '2015-04-01 00:02:46.000000', 'consum', 0.0232, 'lps'),
	(474313, 125, '2015-04-01 00:02:47.000000', 'consum', 0.0214, 'lps'),
	(474314, 125, '2015-04-01 00:02:48.000000', 'consum', 0.0211, 'lps'),
	(474315, 125, '2015-04-01 00:02:49.000000', 'consum', 0.0229, 'lps'),
	(474316, 125, '2015-04-01 00:02:50.000000', 'consum', 0.0231, 'lps'),
	(474317, 125, '2015-04-01 00:02:51.000000', 'consum', 0.0211, 'lps'),
	(474318, 125, '2015-04-01 00:02:52.000000', 'consum', 0.0222, 'lps'),
	(474319, 125, '2015-04-01 00:02:53.000000', 'consum', 0.0219, 'lps'),
	(474320, 125, '2015-04-01 00:02:54.000000', 'consum', 0.0223, 'lps'),
	(474321, 125, '2015-04-01 00:02:55.000000', 'consum', 0.0222, 'lps'),
	(474322, 125, '2015-04-01 00:02:56.000000', 'consum', 0.0232, 'lps'),
	(474323, 125, '2015-04-01 00:02:57.000000', 'consum', 0.0212, 'lps'),
	(474324, 125, '2015-04-01 00:02:58.000000', 'consum', 0.0226, 'lps'),
	(474325, 125, '2015-04-01 00:02:59.000000', 'consum', 0.0215, 'lps'),
	(474326, 125, '2015-04-01 00:03:00.000000', 'consum', 0.0233, 'lps'),
	(474327, 125, '2015-04-01 00:03:01.000000', 'consum', 0.0216, 'lps'),
	(474328, 125, '2015-04-01 00:03:02.000000', 'consum', 0.0218, 'lps'),
	(474329, 125, '2015-04-01 00:03:03.000000', 'consum', 0.0232, 'lps'),
	(474330, 125, '2015-04-01 00:03:04.000000', 'consum', 0.0226, 'lps'),
	(474331, 125, '2015-04-01 00:03:05.000000', 'consum', 0.0222, 'lps'),
	(474332, 125, '2015-04-01 00:03:06.000000', 'consum', 0.0226, 'lps'),
	(474333, 125, '2015-04-01 00:03:07.000000', 'consum', 0.0229, 'lps'),
	(474334, 125, '2015-04-01 00:03:08.000000', 'consum', 0.0210, 'lps'),
	(474335, 125, '2015-04-01 00:03:09.000000', 'consum', 0.0225, 'lps'),
	(474336, 125, '2015-04-01 00:03:10.000000', 'consum', 0.0215, 'lps'),
	(474337, 125, '2015-04-01 00:03:11.000000', 'consum', 0.0214, 'lps'),
	(474338, 125, '2015-04-01 00:03:12.000000', 'consum', 0.0217, 'lps'),
	(474339, 125, '2015-04-01 00:03:13.000000', 'consum', 0.0233, 'lps'),
	(474340, 125, '2015-04-01 00:03:14.000000', 'consum', 0.0232, 'lps'),
	(474341, 125, '2015-04-01 00:03:15.000000', 'consum', 0.0226, 'lps'),
	(474342, 125, '2015-04-01 00:03:16.000000', 'consum', 0.0225, 'lps'),
	(474343, 125, '2015-04-01 00:03:17.000000', 'consum', 0.0213, 'lps'),
	(474344, 125, '2015-04-01 00:03:18.000000', 'consum', 0.0230, 'lps'),
	(474345, 125, '2015-04-01 00:03:19.000000', 'consum', 0.0228, 'lps'),
	(474346, 125, '2015-04-01 00:03:20.000000', 'consum', 0.0216, 'lps'),
	(474347, 125, '2015-04-01 00:03:21.000000', 'consum', 0.0211, 'lps'),
	(474348, 125, '2015-04-01 00:03:22.000000', 'consum', 0.0223, 'lps'),
	(474349, 125, '2015-04-01 00:03:23.000000', 'consum', 0.0222, 'lps'),
	(474350, 125, '2015-04-01 00:03:24.000000', 'consum', 0.0210, 'lps'),
	(474351, 125, '2015-04-01 00:03:25.000000', 'consum', 0.0223, 'lps'),
	(474352, 125, '2015-04-01 00:03:26.000000', 'consum', 0.0226, 'lps'),
	(474353, 125, '2015-04-01 00:03:27.000000', 'consum', 0.0226, 'lps'),
	(474354, 125, '2015-04-01 00:03:28.000000', 'consum', 0.0222, 'lps'),
	(474355, 125, '2015-04-01 00:03:29.000000', 'consum', 0.0220, 'lps'),
	(474356, 125, '2015-04-01 00:03:30.000000', 'consum', 0.0224, 'lps'),
	(474357, 125, '2015-04-01 00:03:31.000000', 'consum', 0.0227, 'lps'),
	(474358, 125, '2015-04-01 00:03:32.000000', 'consum', 0.0228, 'lps'),
	(474359, 125, '2015-04-01 00:03:33.000000', 'consum', 0.0228, 'lps'),
	(474360, 125, '2015-04-01 00:03:34.000000', 'consum', 0.0222, 'lps'),
	(474361, 125, '2015-04-01 00:03:35.000000', 'consum', 0.0216, 'lps'),
	(474362, 125, '2015-04-01 00:03:36.000000', 'consum', 0.0229, 'lps'),
	(474363, 125, '2015-04-01 00:03:37.000000', 'consum', 0.0214, 'lps'),
	(474364, 125, '2015-04-01 00:03:38.000000', 'consum', 0.0224, 'lps'),
	(474365, 125, '2015-04-01 00:03:39.000000', 'consum', 0.0219, 'lps'),
	(474366, 125, '2015-04-01 00:03:40.000000', 'consum', 0.0215, 'lps'),
	(474367, 125, '2015-04-01 00:03:41.000000', 'consum', 0.0233, 'lps'),
	(474368, 125, '2015-04-01 00:03:42.000000', 'consum', 0.0212, 'lps'),
	(474369, 125, '2015-04-01 00:03:43.000000', 'consum', 0.0223, 'lps'),
	(474370, 125, '2015-04-01 00:03:44.000000', 'consum', 0.0223, 'lps'),
	(474371, 125, '2015-04-01 00:03:45.000000', 'consum', 0.0210, 'lps'),
	(474372, 125, '2015-04-01 00:03:46.000000', 'consum', 0.0223, 'lps'),
	(474373, 125, '2015-04-01 00:03:47.000000', 'consum', 0.0227, 'lps'),
	(474374, 125, '2015-04-01 00:03:48.000000', 'consum', 0.0230, 'lps'),
	(474375, 125, '2015-04-01 00:03:49.000000', 'consum', 0.0214, 'lps'),
	(474376, 125, '2015-04-01 00:03:50.000000', 'consum', 0.0219, 'lps'),
	(474377, 125, '2015-04-01 00:03:51.000000', 'consum', 0.0220, 'lps'),
	(474378, 125, '2015-04-01 00:03:52.000000', 'consum', 0.0233, 'lps'),
	(474379, 125, '2015-04-01 00:03:53.000000', 'consum', 0.0223, 'lps'),
	(474380, 125, '2015-04-01 00:03:54.000000', 'consum', 0.0232, 'lps'),
	(474381, 125, '2015-04-01 00:03:55.000000', 'consum', 0.0231, 'lps'),
	(474382, 125, '2015-04-01 00:03:56.000000', 'consum', 0.0228, 'lps'),
	(474383, 125, '2015-04-01 00:03:57.000000', 'consum', 0.0214, 'lps'),
	(474384, 125, '2015-04-01 00:03:58.000000', 'consum', 0.0222, 'lps'),
	(474385, 125, '2015-04-01 00:03:59.000000', 'consum', 0.0212, 'lps'),
	(474386, 125, '2015-04-01 00:04:00.000000', 'consum', 0.0233, 'lps'),
	(474387, 125, '2015-04-01 00:04:01.000000', 'consum', 0.0223, 'lps'),
	(474388, 125, '2015-04-01 00:04:02.000000', 'consum', 0.0230, 'lps'),
	(474389, 125, '2015-04-01 00:04:03.000000', 'consum', 0.0225, 'lps'),
	(474390, 125, '2015-04-01 00:04:04.000000', 'consum', 0.0224, 'lps'),
	(474391, 125, '2015-04-01 00:04:05.000000', 'consum', 0.0212, 'lps'),
	(474392, 125, '2015-04-01 00:04:06.000000', 'consum', 0.0227, 'lps'),
	(474393, 125, '2015-04-01 00:04:07.000000', 'consum', 0.0218, 'lps'),
	(474394, 125, '2015-04-01 00:04:08.000000', 'consum', 0.0224, 'lps'),
	(474395, 125, '2015-04-01 00:04:09.000000', 'consum', 0.0230, 'lps'),
	(474396, 125, '2015-04-01 00:04:10.000000', 'consum', 0.0221, 'lps'),
	(474397, 125, '2015-04-01 00:04:11.000000', 'consum', 0.0232, 'lps'),
	(474398, 125, '2015-04-01 00:04:12.000000', 'consum', 0.0214, 'lps'),
	(474399, 125, '2015-04-01 00:04:13.000000', 'consum', 0.0214, 'lps'),
	(474400, 125, '2015-04-01 00:04:14.000000', 'consum', 0.0217, 'lps'),
	(474401, 125, '2015-04-01 00:04:15.000000', 'consum', 0.0232, 'lps'),
	(474402, 125, '2015-04-01 00:04:16.000000', 'consum', 0.0228, 'lps'),
	(474403, 125, '2015-04-01 00:04:17.000000', 'consum', 0.0211, 'lps'),
	(474404, 125, '2015-04-01 00:04:18.000000', 'consum', 0.0233, 'lps'),
	(474405, 125, '2015-04-01 00:04:19.000000', 'consum', 0.0229, 'lps'),
	(474406, 125, '2015-04-01 00:04:20.000000', 'consum', 0.0210, 'lps'),
	(474407, 125, '2015-04-01 00:04:21.000000', 'consum', 0.0226, 'lps'),
	(474408, 125, '2015-04-01 00:04:22.000000', 'consum', 0.0217, 'lps'),
	(474409, 125, '2015-04-01 00:04:23.000000', 'consum', 0.0222, 'lps'),
	(474410, 125, '2015-04-01 00:04:24.000000', 'consum', 0.0225, 'lps'),
	(474411, 125, '2015-04-01 00:04:25.000000', 'consum', 0.0228, 'lps'),
	(474412, 125, '2015-04-01 00:04:26.000000', 'consum', 0.0229, 'lps'),
	(474413, 125, '2015-04-01 00:04:27.000000', 'consum', 0.0229, 'lps'),
	(474414, 125, '2015-04-01 00:04:28.000000', 'consum', 0.0224, 'lps'),
	(474415, 125, '2015-04-01 00:04:29.000000', 'consum', 0.0224, 'lps'),
	(474416, 125, '2015-04-01 00:04:30.000000', 'consum', 0.0214, 'lps'),
	(474417, 125, '2015-04-01 00:04:31.000000', 'consum', 0.0211, 'lps'),
	(474418, 125, '2015-04-01 00:04:32.000000', 'consum', 0.0227, 'lps'),
	(474419, 125, '2015-04-01 00:04:33.000000', 'consum', 0.0221, 'lps'),
	(474420, 125, '2015-04-01 00:04:34.000000', 'consum', 0.0216, 'lps'),
	(474421, 125, '2015-04-01 00:04:35.000000', 'consum', 0.0231, 'lps'),
	(474422, 125, '2015-04-01 00:04:36.000000', 'consum', 0.0227, 'lps'),
	(474423, 125, '2015-04-01 00:04:37.000000', 'consum', 0.0232, 'lps'),
	(474424, 125, '2015-04-01 00:04:38.000000', 'consum', 0.0219, 'lps'),
	(474425, 125, '2015-04-01 00:04:39.000000', 'consum', 0.0216, 'lps'),
	(474426, 125, '2015-04-01 00:04:40.000000', 'consum', 0.0215, 'lps'),
	(474427, 125, '2015-04-01 00:04:41.000000', 'consum', 0.0215, 'lps'),
	(474428, 125, '2015-04-01 00:04:42.000000', 'consum', 0.0223, 'lps'),
	(474429, 125, '2015-04-01 00:04:43.000000', 'consum', 0.0211, 'lps'),
	(474430, 125, '2015-04-01 00:04:44.000000', 'consum', 0.0223, 'lps'),
	(474431, 125, '2015-04-01 00:04:45.000000', 'consum', 0.0224, 'lps'),
	(474432, 125, '2015-04-01 00:04:46.000000', 'consum', 0.0217, 'lps'),
	(474433, 125, '2015-04-01 00:04:47.000000', 'consum', 0.0227, 'lps'),
	(474434, 125, '2015-04-01 00:04:48.000000', 'consum', 0.0226, 'lps'),
	(474435, 125, '2015-04-01 00:04:49.000000', 'consum', 0.0217, 'lps'),
	(474436, 125, '2015-04-01 00:04:50.000000', 'consum', 0.0222, 'lps'),
	(474437, 125, '2015-04-01 00:04:51.000000', 'consum', 0.0224, 'lps'),
	(474438, 125, '2015-04-01 00:04:52.000000', 'consum', 0.0223, 'lps'),
	(474439, 125, '2015-04-01 00:04:53.000000', 'consum', 0.0233, 'lps'),
	(474440, 125, '2015-04-01 00:04:54.000000', 'consum', 0.0216, 'lps'),
	(474441, 125, '2015-04-01 00:04:55.000000', 'consum', 0.0217, 'lps'),
	(474442, 125, '2015-04-01 00:04:56.000000', 'consum', 0.0229, 'lps'),
	(474443, 125, '2015-04-01 00:04:57.000000', 'consum', 0.0212, 'lps'),
	(474444, 125, '2015-04-01 00:04:58.000000', 'consum', 0.0211, 'lps'),
	(474445, 125, '2015-04-01 00:04:59.000000', 'consum', 0.0211, 'lps'),
	(474446, 125, '2015-04-01 00:05:00.000000', 'consum', 0.0214, 'lps'),
	(474447, 125, '2015-04-01 00:05:01.000000', 'consum', 0.0225, 'lps'),
	(474448, 125, '2015-04-01 00:05:02.000000', 'consum', 0.0227, 'lps'),
	(474449, 125, '2015-04-01 00:05:03.000000', 'consum', 0.0224, 'lps'),
	(474450, 125, '2015-04-01 00:05:04.000000', 'consum', 0.0232, 'lps'),
	(474451, 125, '2015-04-01 00:05:05.000000', 'consum', 0.0229, 'lps'),
	(474452, 125, '2015-04-01 00:05:06.000000', 'consum', 0.0216, 'lps'),
	(474453, 125, '2015-04-01 00:05:07.000000', 'consum', 0.0232, 'lps'),
	(474454, 125, '2015-04-01 00:05:08.000000', 'consum', 0.0230, 'lps'),
	(474455, 125, '2015-04-01 00:05:09.000000', 'consum', 0.0220, 'lps'),
	(474456, 125, '2015-04-01 00:05:10.000000', 'consum', 0.0225, 'lps'),
	(474457, 125, '2015-04-01 00:05:11.000000', 'consum', 0.0231, 'lps'),
	(474458, 125, '2015-04-01 00:05:12.000000', 'consum', 0.0223, 'lps'),
	(474459, 125, '2015-04-01 00:05:13.000000', 'consum', 0.0212, 'lps'),
	(474460, 125, '2015-04-01 00:05:14.000000', 'consum', 0.0231, 'lps'),
	(474461, 125, '2015-04-01 00:05:15.000000', 'consum', 0.0213, 'lps'),
	(474462, 125, '2015-04-01 00:05:16.000000', 'consum', 0.0210, 'lps'),
	(474463, 125, '2015-04-01 00:05:17.000000', 'consum', 0.0226, 'lps'),
	(474464, 125, '2015-04-01 00:05:18.000000', 'consum', 0.0217, 'lps'),
	(474465, 125, '2015-04-01 00:05:19.000000', 'consum', 0.0221, 'lps'),
	(474466, 125, '2015-04-01 00:05:20.000000', 'consum', 0.0223, 'lps'),
	(474467, 125, '2015-04-01 00:05:21.000000', 'consum', 0.0218, 'lps'),
	(474468, 125, '2015-04-01 00:05:22.000000', 'consum', 0.0212, 'lps'),
	(474469, 125, '2015-04-01 00:05:23.000000', 'consum', 0.0219, 'lps'),
	(474470, 125, '2015-04-01 00:05:24.000000', 'consum', 0.0225, 'lps'),
	(474471, 125, '2015-04-01 00:05:25.000000', 'consum', 0.0212, 'lps'),
	(474472, 125, '2015-04-01 00:05:26.000000', 'consum', 0.0225, 'lps'),
	(474473, 125, '2015-04-01 00:05:27.000000', 'consum', 0.0230, 'lps'),
	(474474, 125, '2015-04-01 00:05:28.000000', 'consum', 0.0219, 'lps'),
	(474475, 125, '2015-04-01 00:05:29.000000', 'consum', 0.0220, 'lps'),
	(474476, 125, '2015-04-01 00:05:30.000000', 'consum', 0.0210, 'lps'),
	(474477, 125, '2015-04-01 00:05:31.000000', 'consum', 0.0227, 'lps'),
	(474478, 125, '2015-04-01 00:05:32.000000', 'consum', 0.0224, 'lps'),
	(474479, 125, '2015-04-01 00:05:33.000000', 'consum', 0.0230, 'lps'),
	(474480, 125, '2015-04-01 00:05:34.000000', 'consum', 0.0219, 'lps'),
	(474481, 125, '2015-04-01 00:05:35.000000', 'consum', 0.0221, 'lps'),
	(474482, 125, '2015-04-01 00:05:36.000000', 'consum', 0.0212, 'lps'),
	(474483, 125, '2015-04-01 00:05:37.000000', 'consum', 0.0213, 'lps'),
	(474484, 125, '2015-04-01 00:05:38.000000', 'consum', 0.0221, 'lps'),
	(474485, 125, '2015-04-01 00:05:39.000000', 'consum', 0.0232, 'lps'),
	(474486, 125, '2015-04-01 00:05:40.000000', 'consum', 0.0215, 'lps'),
	(474487, 125, '2015-04-01 00:05:41.000000', 'consum', 0.0217, 'lps'),
	(474488, 125, '2015-04-01 00:05:42.000000', 'consum', 0.0231, 'lps'),
	(474489, 125, '2015-04-01 00:05:43.000000', 'consum', 0.0221, 'lps'),
	(474490, 125, '2015-04-01 00:05:44.000000', 'consum', 0.0227, 'lps'),
	(474491, 125, '2015-04-01 00:05:45.000000', 'consum', 0.0215, 'lps'),
	(474492, 125, '2015-04-01 00:05:46.000000', 'consum', 0.0211, 'lps'),
	(474493, 125, '2015-04-01 00:05:47.000000', 'consum', 0.0221, 'lps'),
	(474494, 125, '2015-04-01 00:05:48.000000', 'consum', 0.0214, 'lps'),
	(474495, 125, '2015-04-01 00:05:49.000000', 'consum', 0.0224, 'lps'),
	(474496, 125, '2015-04-01 00:05:50.000000', 'consum', 0.0220, 'lps'),
	(474497, 125, '2015-04-01 00:05:51.000000', 'consum', 0.0219, 'lps'),
	(474498, 125, '2015-04-01 00:05:52.000000', 'consum', 0.0225, 'lps'),
	(474499, 125, '2015-04-01 00:05:53.000000', 'consum', 0.0211, 'lps'),
	(474500, 125, '2015-04-01 00:05:54.000000', 'consum', 0.0220, 'lps'),
	(474501, 125, '2015-04-01 00:05:55.000000', 'consum', 0.0231, 'lps'),
	(474502, 125, '2015-04-01 00:05:56.000000', 'consum', 0.0215, 'lps'),
	(474503, 125, '2015-04-01 00:05:57.000000', 'consum', 0.0218, 'lps'),
	(474504, 125, '2015-04-01 00:05:58.000000', 'consum', 0.0214, 'lps'),
	(474505, 125, '2015-04-01 00:05:59.000000', 'consum', 0.0231, 'lps'),
	(474506, 125, '2015-04-01 00:06:00.000000', 'consum', 0.0231, 'lps'),
	(474507, 125, '2015-04-01 00:06:01.000000', 'consum', 0.0229, 'lps'),
	(474508, 125, '2015-04-01 00:06:02.000000', 'consum', 0.0218, 'lps'),
	(474509, 125, '2015-04-01 00:06:03.000000', 'consum', 0.0217, 'lps'),
	(474510, 125, '2015-04-01 00:06:04.000000', 'consum', 0.0224, 'lps'),
	(474511, 125, '2015-04-01 00:06:05.000000', 'consum', 0.0232, 'lps'),
	(474512, 125, '2015-04-01 00:06:06.000000', 'consum', 0.0210, 'lps'),
	(474513, 125, '2015-04-01 00:06:07.000000', 'consum', 0.0213, 'lps'),
	(474514, 125, '2015-04-01 00:06:08.000000', 'consum', 0.0228, 'lps'),
	(474515, 125, '2015-04-01 00:06:09.000000', 'consum', 0.0217, 'lps'),
	(474516, 125, '2015-04-01 00:06:10.000000', 'consum', 0.0218, 'lps'),
	(474517, 125, '2015-04-01 00:06:11.000000', 'consum', 0.0230, 'lps'),
	(474518, 125, '2015-04-01 00:06:12.000000', 'consum', 0.0215, 'lps'),
	(474519, 125, '2015-04-01 00:06:13.000000', 'consum', 0.0222, 'lps'),
	(474520, 125, '2015-04-01 00:06:14.000000', 'consum', 0.0210, 'lps'),
	(474521, 125, '2015-04-01 00:06:15.000000', 'consum', 0.0219, 'lps'),
	(474522, 125, '2015-04-01 00:06:16.000000', 'consum', 0.0210, 'lps'),
	(474523, 125, '2015-04-01 00:06:17.000000', 'consum', 0.0230, 'lps'),
	(474524, 125, '2015-04-01 00:06:18.000000', 'consum', 0.0216, 'lps'),
	(474525, 125, '2015-04-01 00:06:19.000000', 'consum', 0.0226, 'lps'),
	(474526, 125, '2015-04-01 00:06:20.000000', 'consum', 0.0226, 'lps'),
	(474527, 125, '2015-04-01 00:06:21.000000', 'consum', 0.0216, 'lps'),
	(474528, 125, '2015-04-01 00:06:22.000000', 'consum', 0.0220, 'lps'),
	(474529, 125, '2015-04-01 00:06:23.000000', 'consum', 0.0217, 'lps'),
	(474530, 125, '2015-04-01 00:06:24.000000', 'consum', 0.0217, 'lps'),
	(474531, 125, '2015-04-01 00:06:25.000000', 'consum', 0.0225, 'lps'),
	(474532, 125, '2015-04-01 00:06:26.000000', 'consum', 0.0217, 'lps'),
	(474533, 125, '2015-04-01 00:06:27.000000', 'consum', 0.0223, 'lps'),
	(474534, 125, '2015-04-01 00:06:28.000000', 'consum', 0.0231, 'lps'),
	(474535, 125, '2015-04-01 00:06:29.000000', 'consum', 0.0227, 'lps'),
	(474536, 125, '2015-04-01 00:06:30.000000', 'consum', 0.0233, 'lps'),
	(474537, 125, '2015-04-01 00:06:31.000000', 'consum', 0.0228, 'lps'),
	(474538, 125, '2015-04-01 00:06:32.000000', 'consum', 0.0233, 'lps'),
	(474539, 125, '2015-04-01 00:06:33.000000', 'consum', 0.0220, 'lps'),
	(474540, 125, '2015-04-01 00:06:34.000000', 'consum', 0.0216, 'lps'),
	(474541, 125, '2015-04-01 00:06:35.000000', 'consum', 0.0211, 'lps'),
	(474542, 125, '2015-04-01 00:06:36.000000', 'consum', 0.0221, 'lps'),
	(474543, 125, '2015-04-01 00:06:37.000000', 'consum', 0.0216, 'lps'),
	(474544, 125, '2015-04-01 00:06:38.000000', 'consum', 0.0232, 'lps'),
	(474545, 125, '2015-04-01 00:06:39.000000', 'consum', 0.0229, 'lps'),
	(474546, 125, '2015-04-01 00:06:40.000000', 'consum', 0.0216, 'lps'),
	(474547, 125, '2015-04-01 00:06:41.000000', 'consum', 0.0231, 'lps'),
	(474548, 125, '2015-04-01 00:06:42.000000', 'consum', 0.0227, 'lps'),
	(474549, 125, '2015-04-01 00:06:43.000000', 'consum', 0.0231, 'lps'),
	(474550, 125, '2015-04-01 00:06:44.000000', 'consum', 0.0217, 'lps'),
	(474551, 125, '2015-04-01 00:06:45.000000', 'consum', 0.0229, 'lps'),
	(474552, 125, '2015-04-01 00:06:46.000000', 'consum', 0.0213, 'lps'),
	(474553, 125, '2015-04-01 00:06:47.000000', 'consum', 0.0218, 'lps'),
	(474554, 125, '2015-04-01 00:06:48.000000', 'consum', 0.0216, 'lps'),
	(474555, 125, '2015-04-01 00:06:49.000000', 'consum', 0.0217, 'lps'),
	(474556, 125, '2015-04-01 00:06:50.000000', 'consum', 0.0227, 'lps'),
	(474557, 125, '2015-04-01 00:06:51.000000', 'consum', 0.0226, 'lps'),
	(474558, 125, '2015-04-01 00:06:52.000000', 'consum', 0.0218, 'lps'),
	(474559, 125, '2015-04-01 00:06:53.000000', 'consum', 0.0225, 'lps'),
	(474560, 125, '2015-04-01 00:06:54.000000', 'consum', 0.0214, 'lps'),
	(474561, 125, '2015-04-01 00:06:55.000000', 'consum', 0.0210, 'lps'),
	(474562, 125, '2015-04-01 00:06:56.000000', 'consum', 0.0223, 'lps'),
	(474563, 125, '2015-04-01 00:06:57.000000', 'consum', 0.0227, 'lps'),
	(474564, 125, '2015-04-01 00:06:58.000000', 'consum', 0.0231, 'lps'),
	(474565, 125, '2015-04-01 00:06:59.000000', 'consum', 0.0216, 'lps'),
	(474566, 125, '2015-04-01 00:07:00.000000', 'consum', 0.0225, 'lps'),
	(474567, 125, '2015-04-01 00:07:01.000000', 'consum', 0.0221, 'lps'),
	(474568, 125, '2015-04-01 00:07:02.000000', 'consum', 0.0221, 'lps'),
	(474569, 125, '2015-04-01 00:07:03.000000', 'consum', 0.0231, 'lps'),
	(474570, 125, '2015-04-01 00:07:04.000000', 'consum', 0.0210, 'lps'),
	(474571, 125, '2015-04-01 00:07:05.000000', 'consum', 0.0219, 'lps'),
	(474572, 125, '2015-04-01 00:07:06.000000', 'consum', 0.0233, 'lps'),
	(474573, 125, '2015-04-01 00:07:07.000000', 'consum', 0.0227, 'lps'),
	(474574, 125, '2015-04-01 00:07:08.000000', 'consum', 0.0227, 'lps'),
	(474575, 125, '2015-04-01 00:07:09.000000', 'consum', 0.0220, 'lps'),
	(474576, 125, '2015-04-01 00:07:10.000000', 'consum', 0.0210, 'lps'),
	(474577, 125, '2015-04-01 00:07:11.000000', 'consum', 0.0228, 'lps'),
	(474578, 125, '2015-04-01 00:07:12.000000', 'consum', 0.0228, 'lps'),
	(474579, 125, '2015-04-01 00:07:13.000000', 'consum', 0.0222, 'lps'),
	(474580, 125, '2015-04-01 00:07:14.000000', 'consum', 0.0218, 'lps'),
	(474581, 125, '2015-04-01 00:07:15.000000', 'consum', 0.0214, 'lps'),
	(474582, 125, '2015-04-01 00:07:16.000000', 'consum', 0.0228, 'lps'),
	(474583, 125, '2015-04-01 00:07:17.000000', 'consum', 0.0220, 'lps'),
	(474584, 125, '2015-04-01 00:07:18.000000', 'consum', 0.0229, 'lps'),
	(474585, 125, '2015-04-01 00:07:19.000000', 'consum', 0.0227, 'lps'),
	(474586, 125, '2015-04-01 00:07:20.000000', 'consum', 0.0216, 'lps'),
	(474587, 125, '2015-04-01 00:07:21.000000', 'consum', 0.0214, 'lps'),
	(474588, 125, '2015-04-01 00:07:22.000000', 'consum', 0.0213, 'lps'),
	(474589, 125, '2015-04-01 00:07:23.000000', 'consum', 0.0215, 'lps'),
	(474590, 125, '2015-04-01 00:07:24.000000', 'consum', 0.0223, 'lps'),
	(474591, 125, '2015-04-01 00:07:25.000000', 'consum', 0.0214, 'lps'),
	(474592, 125, '2015-04-01 00:07:26.000000', 'consum', 0.0216, 'lps'),
	(474593, 125, '2015-04-01 00:07:27.000000', 'consum', 0.0226, 'lps'),
	(474594, 125, '2015-04-01 00:07:28.000000', 'consum', 0.0227, 'lps'),
	(474595, 125, '2015-04-01 00:07:29.000000', 'consum', 0.0224, 'lps'),
	(474596, 125, '2015-04-01 00:07:30.000000', 'consum', 0.0228, 'lps'),
	(474597, 125, '2015-04-01 00:07:31.000000', 'consum', 0.0211, 'lps'),
	(474598, 125, '2015-04-01 00:07:32.000000', 'consum', 0.0210, 'lps'),
	(474599, 125, '2015-04-01 00:07:33.000000', 'consum', 0.0230, 'lps'),
	(474600, 125, '2015-04-01 00:07:34.000000', 'consum', 0.0215, 'lps'),
	(474601, 125, '2015-04-01 00:07:35.000000', 'consum', 0.0222, 'lps'),
	(474602, 125, '2015-04-01 00:07:36.000000', 'consum', 0.0210, 'lps'),
	(474603, 125, '2015-04-01 00:07:37.000000', 'consum', 0.0220, 'lps'),
	(474604, 125, '2015-04-01 00:07:38.000000', 'consum', 0.0212, 'lps'),
	(474605, 125, '2015-04-01 00:07:39.000000', 'consum', 0.0217, 'lps'),
	(474606, 125, '2015-04-01 00:07:40.000000', 'consum', 0.0214, 'lps'),
	(474607, 125, '2015-04-01 00:07:41.000000', 'consum', 0.0212, 'lps'),
	(474608, 125, '2015-04-01 00:07:42.000000', 'consum', 0.0231, 'lps'),
	(474609, 125, '2015-04-01 00:07:43.000000', 'consum', 0.0212, 'lps'),
	(474610, 125, '2015-04-01 00:07:44.000000', 'consum', 0.0230, 'lps'),
	(474611, 125, '2015-04-01 00:07:45.000000', 'consum', 0.0232, 'lps'),
	(474612, 125, '2015-04-01 00:07:46.000000', 'consum', 0.0213, 'lps'),
	(474613, 125, '2015-04-01 00:07:47.000000', 'consum', 0.0233, 'lps'),
	(474614, 125, '2015-04-01 00:07:48.000000', 'consum', 0.0218, 'lps'),
	(474615, 125, '2015-04-01 00:07:49.000000', 'consum', 0.0229, 'lps'),
	(474616, 125, '2015-04-01 00:07:50.000000', 'consum', 0.0233, 'lps'),
	(474617, 125, '2015-04-01 00:07:51.000000', 'consum', 0.0220, 'lps'),
	(474618, 125, '2015-04-01 00:07:52.000000', 'consum', 0.0216, 'lps'),
	(474619, 125, '2015-04-01 00:07:53.000000', 'consum', 0.0210, 'lps'),
	(474620, 125, '2015-04-01 00:07:54.000000', 'consum', 0.0217, 'lps'),
	(474621, 125, '2015-04-01 00:07:55.000000', 'consum', 0.0222, 'lps'),
	(474622, 125, '2015-04-01 00:07:56.000000', 'consum', 0.0225, 'lps'),
	(474623, 125, '2015-04-01 00:07:57.000000', 'consum', 0.0228, 'lps'),
	(474624, 125, '2015-04-01 00:07:58.000000', 'consum', 0.0228, 'lps'),
	(474625, 125, '2015-04-01 00:07:59.000000', 'consum', 0.0225, 'lps'),
	(474626, 125, '2015-04-01 00:08:00.000000', 'consum', 0.0229, 'lps'),
	(474627, 125, '2015-04-01 00:08:01.000000', 'consum', 0.0212, 'lps'),
	(474628, 125, '2015-04-01 00:08:02.000000', 'consum', 0.0212, 'lps'),
	(474629, 125, '2015-04-01 00:08:03.000000', 'consum', 0.0217, 'lps'),
	(474630, 125, '2015-04-01 00:08:04.000000', 'consum', 0.0213, 'lps'),
	(474631, 125, '2015-04-01 00:08:05.000000', 'consum', 0.0229, 'lps'),
	(474632, 125, '2015-04-01 00:08:06.000000', 'consum', 0.0225, 'lps'),
	(474633, 125, '2015-04-01 00:08:07.000000', 'consum', 0.0228, 'lps'),
	(474634, 125, '2015-04-01 00:08:08.000000', 'consum', 0.0231, 'lps'),
	(474635, 125, '2015-04-01 00:08:09.000000', 'consum', 0.0216, 'lps'),
	(474636, 125, '2015-04-01 00:08:10.000000', 'consum', 0.0224, 'lps'),
	(474637, 125, '2015-04-01 00:08:11.000000', 'consum', 0.0214, 'lps'),
	(474638, 125, '2015-04-01 00:08:12.000000', 'consum', 0.0211, 'lps'),
	(474639, 125, '2015-04-01 00:08:13.000000', 'consum', 0.0228, 'lps'),
	(474640, 125, '2015-04-01 00:08:14.000000', 'consum', 0.0225, 'lps'),
	(474641, 125, '2015-04-01 00:08:15.000000', 'consum', 0.0232, 'lps'),
	(474642, 125, '2015-04-01 00:08:16.000000', 'consum', 0.0227, 'lps'),
	(474643, 125, '2015-04-01 00:08:17.000000', 'consum', 0.0228, 'lps'),
	(474644, 125, '2015-04-01 00:08:18.000000', 'consum', 0.0227, 'lps'),
	(474645, 125, '2015-04-01 00:08:19.000000', 'consum', 0.0216, 'lps'),
	(474646, 125, '2015-04-01 00:08:20.000000', 'consum', 0.0215, 'lps'),
	(474647, 125, '2015-04-01 00:08:21.000000', 'consum', 0.0218, 'lps'),
	(474648, 125, '2015-04-01 00:08:22.000000', 'consum', 0.0233, 'lps'),
	(474649, 125, '2015-04-01 00:08:23.000000', 'consum', 0.0231, 'lps'),
	(474650, 125, '2015-04-01 00:08:24.000000', 'consum', 0.0220, 'lps'),
	(474651, 125, '2015-04-01 00:08:25.000000', 'consum', 0.0224, 'lps'),
	(474652, 125, '2015-04-01 00:08:26.000000', 'consum', 0.0227, 'lps'),
	(474653, 125, '2015-04-01 00:08:27.000000', 'consum', 0.0227, 'lps'),
	(474654, 125, '2015-04-01 00:08:28.000000', 'consum', 0.0222, 'lps'),
	(474655, 125, '2015-04-01 00:08:29.000000', 'consum', 0.0221, 'lps'),
	(474656, 125, '2015-04-01 00:08:30.000000', 'consum', 0.0227, 'lps'),
	(474657, 125, '2015-04-01 00:08:31.000000', 'consum', 0.0213, 'lps'),
	(474658, 125, '2015-04-01 00:08:32.000000', 'consum', 0.0226, 'lps'),
	(474659, 125, '2015-04-01 00:08:33.000000', 'consum', 0.0230, 'lps'),
	(474660, 125, '2015-04-01 00:08:34.000000', 'consum', 0.0217, 'lps'),
	(474661, 125, '2015-04-01 00:08:35.000000', 'consum', 0.0210, 'lps'),
	(474662, 125, '2015-04-01 00:08:36.000000', 'consum', 0.0213, 'lps'),
	(474663, 125, '2015-04-01 00:08:37.000000', 'consum', 0.0224, 'lps'),
	(474664, 125, '2015-04-01 00:08:38.000000', 'consum', 0.0226, 'lps'),
	(474665, 125, '2015-04-01 00:08:39.000000', 'consum', 0.0225, 'lps'),
	(474666, 125, '2015-04-01 00:08:40.000000', 'consum', 0.0211, 'lps'),
	(474667, 125, '2015-04-01 00:08:41.000000', 'consum', 0.0221, 'lps'),
	(474668, 125, '2015-04-01 00:08:42.000000', 'consum', 0.0214, 'lps'),
	(474669, 125, '2015-04-01 00:08:43.000000', 'consum', 0.0220, 'lps'),
	(474670, 125, '2015-04-01 00:08:44.000000', 'consum', 0.0225, 'lps'),
	(474671, 125, '2015-04-01 00:08:45.000000', 'consum', 0.0233, 'lps'),
	(474672, 125, '2015-04-01 00:08:46.000000', 'consum', 0.0232, 'lps'),
	(474673, 125, '2015-04-01 00:08:47.000000', 'consum', 0.0228, 'lps'),
	(474674, 125, '2015-04-01 00:08:48.000000', 'consum', 0.0232, 'lps'),
	(474675, 125, '2015-04-01 00:08:49.000000', 'consum', 0.0219, 'lps'),
	(474676, 125, '2015-04-01 00:08:50.000000', 'consum', 0.0215, 'lps'),
	(474677, 125, '2015-04-01 00:08:51.000000', 'consum', 0.0210, 'lps'),
	(474678, 125, '2015-04-01 00:08:52.000000', 'consum', 0.0217, 'lps'),
	(474679, 125, '2015-04-01 00:08:53.000000', 'consum', 0.0223, 'lps'),
	(474680, 125, '2015-04-01 00:08:54.000000', 'consum', 0.0232, 'lps'),
	(474681, 125, '2015-04-01 00:08:55.000000', 'consum', 0.0231, 'lps'),
	(474682, 125, '2015-04-01 00:08:56.000000', 'consum', 0.0228, 'lps'),
	(474683, 125, '2015-04-01 00:08:57.000000', 'consum', 0.0212, 'lps'),
	(474684, 125, '2015-04-01 00:08:58.000000', 'consum', 0.0213, 'lps'),
	(474685, 125, '2015-04-01 00:08:59.000000', 'consum', 0.0219, 'lps'),
	(474686, 125, '2015-04-01 00:09:00.000000', 'consum', 0.0223, 'lps'),
	(474687, 125, '2015-04-01 00:09:01.000000', 'consum', 0.0227, 'lps'),
	(474688, 125, '2015-04-01 00:09:02.000000', 'consum', 0.0231, 'lps'),
	(474689, 125, '2015-04-01 00:09:03.000000', 'consum', 0.0216, 'lps'),
	(474690, 125, '2015-04-01 00:09:04.000000', 'consum', 0.0226, 'lps'),
	(474691, 125, '2015-04-01 00:09:05.000000', 'consum', 0.0222, 'lps'),
	(474692, 125, '2015-04-01 00:09:06.000000', 'consum', 0.0226, 'lps'),
	(474693, 125, '2015-04-01 00:09:07.000000', 'consum', 0.0228, 'lps'),
	(474694, 125, '2015-04-01 00:09:08.000000', 'consum', 0.0230, 'lps'),
	(474695, 125, '2015-04-01 00:09:09.000000', 'consum', 0.0232, 'lps'),
	(474696, 125, '2015-04-01 00:09:10.000000', 'consum', 0.0213, 'lps'),
	(474697, 125, '2015-04-01 00:09:11.000000', 'consum', 0.0232, 'lps'),
	(474698, 125, '2015-04-01 00:09:12.000000', 'consum', 0.0215, 'lps'),
	(474699, 125, '2015-04-01 00:09:13.000000', 'consum', 0.0219, 'lps'),
	(474700, 125, '2015-04-01 00:09:14.000000', 'consum', 0.0215, 'lps'),
	(474701, 125, '2015-04-01 00:09:15.000000', 'consum', 0.0231, 'lps'),
	(474702, 125, '2015-04-01 00:09:16.000000', 'consum', 0.0230, 'lps'),
	(474703, 125, '2015-04-01 00:09:17.000000', 'consum', 0.0225, 'lps'),
	(474704, 125, '2015-04-01 00:09:18.000000', 'consum', 0.0224, 'lps'),
	(474705, 125, '2015-04-01 00:09:19.000000', 'consum', 0.0214, 'lps'),
	(474706, 125, '2015-04-01 00:09:20.000000', 'consum', 0.0210, 'lps'),
	(474707, 125, '2015-04-01 00:09:21.000000', 'consum', 0.0223, 'lps'),
	(474708, 125, '2015-04-01 00:09:22.000000', 'consum', 0.0229, 'lps'),
	(474709, 125, '2015-04-01 00:09:23.000000', 'consum', 0.0217, 'lps'),
	(474710, 125, '2015-04-01 00:09:24.000000', 'consum', 0.0211, 'lps'),
	(474711, 125, '2015-04-01 00:09:25.000000', 'consum', 0.0220, 'lps'),
	(474712, 125, '2015-04-01 00:09:26.000000', 'consum', 0.0232, 'lps'),
	(474713, 125, '2015-04-01 00:09:27.000000', 'consum', 0.0220, 'lps'),
	(474714, 125, '2015-04-01 00:09:28.000000', 'consum', 0.0218, 'lps'),
	(474715, 125, '2015-04-01 00:09:29.000000', 'consum', 0.0220, 'lps'),
	(474716, 125, '2015-04-01 00:09:30.000000', 'consum', 0.0211, 'lps'),
	(474717, 125, '2015-04-01 00:09:31.000000', 'consum', 0.0210, 'lps'),
	(474718, 125, '2015-04-01 00:09:32.000000', 'consum', 0.0232, 'lps'),
	(474719, 125, '2015-04-01 00:09:33.000000', 'consum', 0.0224, 'lps'),
	(474720, 125, '2015-04-01 00:09:34.000000', 'consum', 0.0215, 'lps'),
	(474721, 125, '2015-04-01 00:09:35.000000', 'consum', 0.0219, 'lps'),
	(474722, 125, '2015-04-01 00:09:36.000000', 'consum', 0.0217, 'lps'),
	(474723, 125, '2015-04-01 00:09:37.000000', 'consum', 0.0217, 'lps'),
	(474724, 125, '2015-04-01 00:09:38.000000', 'consum', 0.0225, 'lps'),
	(474725, 125, '2015-04-01 00:09:39.000000', 'consum', 0.0218, 'lps'),
	(474726, 125, '2015-04-01 00:09:40.000000', 'consum', 0.0230, 'lps'),
	(474727, 125, '2015-04-01 00:09:41.000000', 'consum', 0.0215, 'lps'),
	(474728, 125, '2015-04-01 00:09:42.000000', 'consum', 0.0221, 'lps'),
	(474729, 125, '2015-04-01 00:09:43.000000', 'consum', 0.0227, 'lps'),
	(474730, 125, '2015-04-01 00:09:44.000000', 'consum', 0.0214, 'lps'),
	(474731, 125, '2015-04-01 00:09:45.000000', 'consum', 0.0226, 'lps'),
	(474732, 125, '2015-04-01 00:09:46.000000', 'consum', 0.0233, 'lps'),
	(474733, 125, '2015-04-01 00:09:47.000000', 'consum', 0.0228, 'lps'),
	(474734, 125, '2015-04-01 00:09:48.000000', 'consum', 0.0231, 'lps'),
	(474735, 125, '2015-04-01 00:09:49.000000', 'consum', 0.0216, 'lps'),
	(474736, 125, '2015-04-01 00:09:50.000000', 'consum', 0.0225, 'lps'),
	(474737, 125, '2015-04-01 00:09:51.000000', 'consum', 0.0218, 'lps'),
	(474738, 125, '2015-04-01 00:09:52.000000', 'consum', 0.0230, 'lps'),
	(474739, 125, '2015-04-01 00:09:53.000000', 'consum', 0.0214, 'lps'),
	(474740, 125, '2015-04-01 00:09:54.000000', 'consum', 0.0217, 'lps'),
	(474741, 125, '2015-04-01 00:09:55.000000', 'consum', 0.0212, 'lps'),
	(474742, 125, '2015-04-01 00:09:56.000000', 'consum', 0.0224, 'lps'),
	(474743, 125, '2015-04-01 00:09:57.000000', 'consum', 0.0225, 'lps'),
	(474744, 125, '2015-04-01 00:09:58.000000', 'consum', 0.0221, 'lps'),
	(474745, 125, '2015-04-01 00:09:59.000000', 'consum', 0.0220, 'lps'),
	(474746, 125, '2015-04-01 00:10:00.000000', 'consum', 0.0228, 'lps'),
	(474747, 125, '2015-04-01 00:10:01.000000', 'consum', 0.0220, 'lps'),
	(474748, 125, '2015-04-01 00:10:02.000000', 'consum', 0.0210, 'lps'),
	(474749, 125, '2015-04-01 00:10:03.000000', 'consum', 0.0227, 'lps'),
	(474750, 125, '2015-04-01 00:10:04.000000', 'consum', 0.0222, 'lps'),
	(474751, 125, '2015-04-01 00:10:05.000000', 'consum', 0.0220, 'lps'),
	(474752, 125, '2015-04-01 00:10:06.000000', 'consum', 0.0226, 'lps'),
	(474753, 125, '2015-04-01 00:10:07.000000', 'consum', 0.0211, 'lps'),
	(474754, 125, '2015-04-01 00:10:08.000000', 'consum', 0.0217, 'lps'),
	(474755, 125, '2015-04-01 00:10:09.000000', 'consum', 0.0219, 'lps'),
	(474756, 125, '2015-04-01 00:10:10.000000', 'consum', 0.0210, 'lps'),
	(474757, 125, '2015-04-01 00:10:11.000000', 'consum', 0.0231, 'lps'),
	(474758, 125, '2015-04-01 00:10:12.000000', 'consum', 0.0218, 'lps'),
	(474759, 125, '2015-04-01 00:10:13.000000', 'consum', 0.0211, 'lps'),
	(474760, 125, '2015-04-01 00:10:14.000000', 'consum', 0.0216, 'lps'),
	(474761, 125, '2015-04-01 00:10:15.000000', 'consum', 0.0214, 'lps'),
	(474762, 125, '2015-04-01 00:10:16.000000', 'consum', 0.0214, 'lps'),
	(474763, 125, '2015-04-01 00:10:17.000000', 'consum', 0.0217, 'lps'),
	(474764, 125, '2015-04-01 00:10:18.000000', 'consum', 0.0211, 'lps'),
	(474765, 125, '2015-04-01 00:10:19.000000', 'consum', 0.0218, 'lps'),
	(474766, 125, '2015-04-01 00:10:20.000000', 'consum', 0.0221, 'lps'),
	(474767, 125, '2015-04-01 00:10:21.000000', 'consum', 0.0220, 'lps'),
	(474768, 125, '2015-04-01 00:10:22.000000', 'consum', 0.0228, 'lps'),
	(474769, 125, '2015-04-01 00:10:23.000000', 'consum', 0.0221, 'lps'),
	(474770, 125, '2015-04-01 00:10:24.000000', 'consum', 0.0212, 'lps'),
	(474771, 125, '2015-04-01 00:10:25.000000', 'consum', 0.0211, 'lps'),
	(474772, 125, '2015-04-01 00:10:26.000000', 'consum', 0.0232, 'lps'),
	(474773, 125, '2015-04-01 00:10:27.000000', 'consum', 0.0223, 'lps'),
	(474774, 125, '2015-04-01 00:10:28.000000', 'consum', 0.0233, 'lps'),
	(474775, 125, '2015-04-01 00:10:29.000000', 'consum', 0.0215, 'lps'),
	(474776, 125, '2015-04-01 00:10:30.000000', 'consum', 0.0216, 'lps'),
	(474777, 125, '2015-04-01 00:10:31.000000', 'consum', 0.0225, 'lps'),
	(474778, 125, '2015-04-01 00:10:32.000000', 'consum', 0.0221, 'lps'),
	(474779, 125, '2015-04-01 00:10:33.000000', 'consum', 0.0220, 'lps'),
	(474780, 125, '2015-04-01 00:10:34.000000', 'consum', 0.0226, 'lps'),
	(474781, 125, '2015-04-01 00:10:35.000000', 'consum', 0.0212, 'lps'),
	(474782, 125, '2015-04-01 00:10:36.000000', 'consum', 0.0221, 'lps'),
	(474783, 125, '2015-04-01 00:10:37.000000', 'consum', 0.0212, 'lps'),
	(474784, 125, '2015-04-01 00:10:38.000000', 'consum', 0.0211, 'lps'),
	(474785, 125, '2015-04-01 00:10:39.000000', 'consum', 0.0233, 'lps'),
	(474786, 125, '2015-04-01 00:10:40.000000', 'consum', 0.0228, 'lps'),
	(474787, 125, '2015-04-01 00:10:41.000000', 'consum', 0.0229, 'lps'),
	(474788, 125, '2015-04-01 00:10:42.000000', 'consum', 0.0229, 'lps'),
	(474789, 125, '2015-04-01 00:10:43.000000', 'consum', 0.0223, 'lps'),
	(474790, 125, '2015-04-01 00:10:44.000000', 'consum', 0.0218, 'lps'),
	(474791, 125, '2015-04-01 00:10:45.000000', 'consum', 0.0211, 'lps'),
	(474792, 125, '2015-04-01 00:10:46.000000', 'consum', 0.0217, 'lps'),
	(474793, 125, '2015-04-01 00:10:47.000000', 'consum', 0.0218, 'lps'),
	(474794, 125, '2015-04-01 00:10:48.000000', 'consum', 0.0228, 'lps'),
	(474795, 125, '2015-04-01 00:10:49.000000', 'consum', 0.0229, 'lps'),
	(474796, 125, '2015-04-01 00:10:50.000000', 'consum', 0.0229, 'lps'),
	(474797, 125, '2015-04-01 00:10:51.000000', 'consum', 0.0222, 'lps'),
	(474798, 125, '2015-04-01 00:10:52.000000', 'consum', 0.0215, 'lps'),
	(474799, 125, '2015-04-01 00:10:53.000000', 'consum', 0.0224, 'lps'),
	(474800, 125, '2015-04-01 00:10:54.000000', 'consum', 0.0216, 'lps'),
	(474801, 125, '2015-04-01 00:10:55.000000', 'consum', 0.0222, 'lps'),
	(474802, 125, '2015-04-01 00:10:56.000000', 'consum', 0.0229, 'lps'),
	(474803, 125, '2015-04-01 00:10:57.000000', 'consum', 0.0224, 'lps'),
	(474804, 125, '2015-04-01 00:10:58.000000', 'consum', 0.0221, 'lps'),
	(474805, 125, '2015-04-01 00:10:59.000000', 'consum', 0.0225, 'lps'),
	(474806, 125, '2015-04-01 00:11:00.000000', 'consum', 0.0228, 'lps'),
	(474807, 125, '2015-04-01 00:11:01.000000', 'consum', 0.0232, 'lps'),
	(474808, 125, '2015-04-01 00:11:02.000000', 'consum', 0.0216, 'lps'),
	(474809, 125, '2015-04-01 00:11:03.000000', 'consum', 0.0226, 'lps'),
	(474810, 125, '2015-04-01 00:11:04.000000', 'consum', 0.0222, 'lps'),
	(474811, 125, '2015-04-01 00:11:05.000000', 'consum', 0.0222, 'lps'),
	(474812, 125, '2015-04-01 00:11:06.000000', 'consum', 0.0211, 'lps'),
	(474813, 125, '2015-04-01 00:11:07.000000', 'consum', 0.0227, 'lps'),
	(474814, 125, '2015-04-01 00:11:08.000000', 'consum', 0.0222, 'lps'),
	(474815, 125, '2015-04-01 00:11:09.000000', 'consum', 0.0220, 'lps'),
	(474816, 125, '2015-04-01 00:11:10.000000', 'consum', 0.0226, 'lps'),
	(474817, 125, '2015-04-01 00:11:11.000000', 'consum', 0.0233, 'lps'),
	(474818, 125, '2015-04-01 00:11:12.000000', 'consum', 0.0230, 'lps'),
	(474819, 125, '2015-04-01 00:11:13.000000', 'consum', 0.0218, 'lps'),
	(474820, 125, '2015-04-01 00:11:14.000000', 'consum', 0.0216, 'lps'),
	(474821, 125, '2015-04-01 00:11:15.000000', 'consum', 0.0217, 'lps'),
	(474822, 125, '2015-04-01 00:11:16.000000', 'consum', 0.0227, 'lps'),
	(474823, 125, '2015-04-01 00:11:17.000000', 'consum', 0.0226, 'lps'),
	(474824, 125, '2015-04-01 00:11:18.000000', 'consum', 0.0214, 'lps'),
	(474825, 125, '2015-04-01 00:11:19.000000', 'consum', 0.0210, 'lps'),
	(474826, 125, '2015-04-01 00:11:20.000000', 'consum', 0.0219, 'lps'),
	(474827, 125, '2015-04-01 00:11:21.000000', 'consum', 0.0233, 'lps'),
	(474828, 125, '2015-04-01 00:11:22.000000', 'consum', 0.0226, 'lps'),
	(474829, 125, '2015-04-01 00:11:23.000000', 'consum', 0.0220, 'lps'),
	(474830, 125, '2015-04-01 00:11:24.000000', 'consum', 0.0215, 'lps'),
	(474831, 125, '2015-04-01 00:11:25.000000', 'consum', 0.0230, 'lps'),
	(474832, 125, '2015-04-01 00:11:26.000000', 'consum', 0.0223, 'lps'),
	(474833, 125, '2015-04-01 00:11:27.000000', 'consum', 0.0215, 'lps'),
	(474834, 125, '2015-04-01 00:11:28.000000', 'consum', 0.0222, 'lps'),
	(474835, 125, '2015-04-01 00:11:29.000000', 'consum', 0.0231, 'lps'),
	(474836, 125, '2015-04-01 00:11:30.000000', 'consum', 0.0230, 'lps'),
	(474837, 125, '2015-04-01 00:11:31.000000', 'consum', 0.0223, 'lps'),
	(474838, 125, '2015-04-01 00:11:32.000000', 'consum', 0.0217, 'lps'),
	(474839, 125, '2015-04-01 00:11:33.000000', 'consum', 0.0230, 'lps'),
	(474840, 125, '2015-04-01 00:11:34.000000', 'consum', 0.0218, 'lps'),
	(474841, 125, '2015-04-01 00:11:35.000000', 'consum', 0.0214, 'lps'),
	(474842, 125, '2015-04-01 00:11:36.000000', 'consum', 0.0231, 'lps'),
	(474843, 125, '2015-04-01 00:11:37.000000', 'consum', 0.0230, 'lps'),
	(474844, 125, '2015-04-01 00:11:38.000000', 'consum', 0.0222, 'lps'),
	(474845, 125, '2015-04-01 00:11:39.000000', 'consum', 0.0214, 'lps'),
	(474846, 125, '2015-04-01 00:11:40.000000', 'consum', 0.0217, 'lps'),
	(474847, 125, '2015-04-01 00:11:41.000000', 'consum', 0.0232, 'lps'),
	(474848, 125, '2015-04-01 00:11:42.000000', 'consum', 0.0228, 'lps'),
	(474849, 125, '2015-04-01 00:11:43.000000', 'consum', 0.0233, 'lps'),
	(474850, 125, '2015-04-01 00:11:44.000000', 'consum', 0.0224, 'lps'),
	(474851, 125, '2015-04-01 00:11:45.000000', 'consum', 0.0214, 'lps'),
	(474852, 125, '2015-04-01 00:11:46.000000', 'consum', 0.0210, 'lps'),
	(474853, 125, '2015-04-01 00:11:47.000000', 'consum', 0.0225, 'lps'),
	(474854, 125, '2015-04-01 00:11:48.000000', 'consum', 0.0213, 'lps'),
	(474855, 125, '2015-04-01 00:11:49.000000', 'consum', 0.0227, 'lps'),
	(474856, 125, '2015-04-01 00:11:50.000000', 'consum', 0.0215, 'lps'),
	(474857, 125, '2015-04-01 00:11:51.000000', 'consum', 0.0233, 'lps'),
	(474858, 125, '2015-04-01 00:11:52.000000', 'consum', 0.0216, 'lps'),
	(474859, 125, '2015-04-01 00:11:53.000000', 'consum', 0.0218, 'lps'),
	(474860, 125, '2015-04-01 00:11:54.000000', 'consum', 0.0233, 'lps'),
	(474861, 125, '2015-04-01 00:11:55.000000', 'consum', 0.0231, 'lps'),
	(474862, 125, '2015-04-01 00:11:56.000000', 'consum', 0.0223, 'lps'),
	(474863, 125, '2015-04-01 00:11:57.000000', 'consum', 0.0210, 'lps'),
	(474864, 125, '2015-04-01 00:11:58.000000', 'consum', 0.0218, 'lps'),
	(474865, 125, '2015-04-01 00:11:59.000000', 'consum', 0.0230, 'lps'),
	(474866, 125, '2015-04-01 00:12:00.000000', 'consum', 0.0212, 'lps'),
	(474867, 125, '2015-04-01 00:12:01.000000', 'consum', 0.0233, 'lps'),
	(474868, 125, '2015-04-01 00:12:02.000000', 'consum', 0.0226, 'lps'),
	(474869, 125, '2015-04-01 00:12:03.000000', 'consum', 0.0219, 'lps'),
	(474870, 125, '2015-04-01 00:12:04.000000', 'consum', 0.0230, 'lps'),
	(474871, 125, '2015-04-01 00:12:05.000000', 'consum', 0.0214, 'lps'),
	(474872, 125, '2015-04-01 00:12:06.000000', 'consum', 0.0219, 'lps'),
	(474873, 125, '2015-04-01 00:12:07.000000', 'consum', 0.0219, 'lps'),
	(474874, 125, '2015-04-01 00:12:08.000000', 'consum', 0.0226, 'lps'),
	(474875, 125, '2015-04-01 00:12:09.000000', 'consum', 0.0219, 'lps'),
	(474876, 125, '2015-04-01 00:12:10.000000', 'consum', 0.0229, 'lps'),
	(474877, 125, '2015-04-01 00:12:11.000000', 'consum', 0.0230, 'lps'),
	(474878, 125, '2015-04-01 00:12:12.000000', 'consum', 0.0231, 'lps'),
	(474879, 125, '2015-04-01 00:12:13.000000', 'consum', 0.0231, 'lps'),
	(474880, 125, '2015-04-01 00:12:14.000000', 'consum', 0.0229, 'lps'),
	(474881, 125, '2015-04-01 00:12:15.000000', 'consum', 0.0217, 'lps'),
	(474882, 125, '2015-04-01 00:12:16.000000', 'consum', 0.0212, 'lps'),
	(474883, 125, '2015-04-01 00:12:17.000000', 'consum', 0.0223, 'lps'),
	(474884, 125, '2015-04-01 00:12:18.000000', 'consum', 0.0220, 'lps'),
	(474885, 125, '2015-04-01 00:12:19.000000', 'consum', 0.0225, 'lps'),
	(474886, 125, '2015-04-01 00:12:20.000000', 'consum', 0.0230, 'lps'),
	(474887, 125, '2015-04-01 00:12:21.000000', 'consum', 0.0217, 'lps'),
	(474888, 125, '2015-04-01 00:12:22.000000', 'consum', 0.0210, 'lps'),
	(474889, 125, '2015-04-01 00:12:23.000000', 'consum', 0.0214, 'lps'),
	(474890, 125, '2015-04-01 00:12:24.000000', 'consum', 0.0232, 'lps'),
	(474891, 125, '2015-04-01 00:12:25.000000', 'consum', 0.0212, 'lps'),
	(474892, 125, '2015-04-01 00:12:26.000000', 'consum', 0.0226, 'lps'),
	(474893, 125, '2015-04-01 00:12:27.000000', 'consum', 0.0213, 'lps'),
	(474894, 125, '2015-04-01 00:12:28.000000', 'consum', 0.0227, 'lps'),
	(474895, 125, '2015-04-01 00:12:29.000000', 'consum', 0.0212, 'lps'),
	(474896, 125, '2015-04-01 00:12:30.000000', 'consum', 0.0219, 'lps'),
	(474897, 125, '2015-04-01 00:12:31.000000', 'consum', 0.0223, 'lps'),
	(474898, 125, '2015-04-01 00:12:32.000000', 'consum', 0.0226, 'lps'),
	(474899, 125, '2015-04-01 00:12:33.000000', 'consum', 0.0226, 'lps'),
	(474900, 125, '2015-04-01 00:12:34.000000', 'consum', 0.0221, 'lps'),
	(474901, 125, '2015-04-01 00:12:35.000000', 'consum', 0.0215, 'lps'),
	(474902, 125, '2015-04-01 00:12:36.000000', 'consum', 0.0226, 'lps'),
	(474903, 125, '2015-04-01 00:12:37.000000', 'consum', 0.0227, 'lps'),
	(474904, 125, '2015-04-01 00:12:38.000000', 'consum', 0.0225, 'lps'),
	(474905, 125, '2015-04-01 00:12:39.000000', 'consum', 0.0233, 'lps'),
	(474906, 125, '2015-04-01 00:12:40.000000', 'consum', 0.0233, 'lps'),
	(474907, 125, '2015-04-01 00:12:41.000000', 'consum', 0.0210, 'lps'),
	(474908, 125, '2015-04-01 00:12:42.000000', 'consum', 0.0211, 'lps'),
	(474909, 125, '2015-04-01 00:12:43.000000', 'consum', 0.0218, 'lps'),
	(474910, 125, '2015-04-01 00:12:44.000000', 'consum', 0.0221, 'lps'),
	(474911, 125, '2015-04-01 00:12:45.000000', 'consum', 0.0218, 'lps'),
	(474912, 125, '2015-04-01 00:12:46.000000', 'consum', 0.0220, 'lps'),
	(474913, 125, '2015-04-01 00:12:47.000000', 'consum', 0.0233, 'lps'),
	(474914, 125, '2015-04-01 00:12:48.000000', 'consum', 0.0225, 'lps'),
	(474915, 125, '2015-04-01 00:12:49.000000', 'consum', 0.0215, 'lps'),
	(474916, 125, '2015-04-01 00:12:50.000000', 'consum', 0.0214, 'lps'),
	(474917, 125, '2015-04-01 00:12:51.000000', 'consum', 0.0215, 'lps'),
	(474918, 125, '2015-04-01 00:12:52.000000', 'consum', 0.0223, 'lps'),
	(474919, 125, '2015-04-01 00:12:53.000000', 'consum', 0.0215, 'lps'),
	(474920, 125, '2015-04-01 00:12:54.000000', 'consum', 0.0218, 'lps'),
	(474921, 125, '2015-04-01 00:12:55.000000', 'consum', 0.0211, 'lps'),
	(474922, 125, '2015-04-01 00:12:56.000000', 'consum', 0.0215, 'lps'),
	(474923, 125, '2015-04-01 00:12:57.000000', 'consum', 0.0210, 'lps'),
	(474924, 125, '2015-04-01 00:12:58.000000', 'consum', 0.0220, 'lps'),
	(474925, 125, '2015-04-01 00:12:59.000000', 'consum', 0.0212, 'lps'),
	(474926, 125, '2015-04-01 00:13:00.000000', 'consum', 0.0214, 'lps'),
	(474927, 125, '2015-04-01 00:13:01.000000', 'consum', 0.0227, 'lps'),
	(474928, 125, '2015-04-01 00:13:02.000000', 'consum', 0.0232, 'lps'),
	(474929, 125, '2015-04-01 00:13:03.000000', 'consum', 0.0225, 'lps'),
	(474930, 125, '2015-04-01 00:13:04.000000', 'consum', 0.0217, 'lps'),
	(474931, 125, '2015-04-01 00:13:05.000000', 'consum', 0.0226, 'lps'),
	(474932, 125, '2015-04-01 00:13:06.000000', 'consum', 0.0220, 'lps'),
	(474933, 125, '2015-04-01 00:13:07.000000', 'consum', 0.0212, 'lps'),
	(474934, 125, '2015-04-01 00:13:08.000000', 'consum', 0.0214, 'lps'),
	(474935, 125, '2015-04-01 00:13:09.000000', 'consum', 0.0224, 'lps'),
	(474936, 125, '2015-04-01 00:13:10.000000', 'consum', 0.0222, 'lps'),
	(474937, 125, '2015-04-01 00:13:11.000000', 'consum', 0.0227, 'lps'),
	(474938, 125, '2015-04-01 00:13:12.000000', 'consum', 0.0213, 'lps'),
	(474939, 125, '2015-04-01 00:13:13.000000', 'consum', 0.0222, 'lps'),
	(474940, 125, '2015-04-01 00:13:14.000000', 'consum', 0.0213, 'lps'),
	(474941, 125, '2015-04-01 00:13:15.000000', 'consum', 0.0214, 'lps'),
	(474942, 125, '2015-04-01 00:13:16.000000', 'consum', 0.0221, 'lps'),
	(474943, 125, '2015-04-01 00:13:17.000000', 'consum', 0.0231, 'lps'),
	(474944, 125, '2015-04-01 00:13:18.000000', 'consum', 0.0211, 'lps'),
	(474945, 125, '2015-04-01 00:13:19.000000', 'consum', 0.0225, 'lps'),
	(474946, 125, '2015-04-01 00:13:20.000000', 'consum', 0.0232, 'lps'),
	(474947, 125, '2015-04-01 00:13:21.000000', 'consum', 0.0227, 'lps'),
	(474948, 125, '2015-04-01 00:13:22.000000', 'consum', 0.0232, 'lps'),
	(474949, 125, '2015-04-01 00:13:23.000000', 'consum', 0.0219, 'lps'),
	(474950, 125, '2015-04-01 00:13:24.000000', 'consum', 0.0214, 'lps'),
	(474951, 125, '2015-04-01 00:13:25.000000', 'consum', 0.0229, 'lps'),
	(474952, 125, '2015-04-01 00:13:26.000000', 'consum', 0.0220, 'lps'),
	(474953, 125, '2015-04-01 00:13:27.000000', 'consum', 0.0227, 'lps'),
	(474954, 125, '2015-04-01 00:13:28.000000', 'consum', 0.0220, 'lps'),
	(474955, 125, '2015-04-01 00:13:29.000000', 'consum', 0.0232, 'lps'),
	(474956, 125, '2015-04-01 00:13:30.000000', 'consum', 0.0219, 'lps'),
	(474957, 125, '2015-04-01 00:13:31.000000', 'consum', 0.0213, 'lps'),
	(474958, 125, '2015-04-01 00:13:32.000000', 'consum', 0.0222, 'lps'),
	(474959, 125, '2015-04-01 00:13:33.000000', 'consum', 0.0213, 'lps'),
	(474960, 125, '2015-04-01 00:13:34.000000', 'consum', 0.0216, 'lps'),
	(474961, 125, '2015-04-01 00:13:35.000000', 'consum', 0.0230, 'lps'),
	(474962, 125, '2015-04-01 00:13:36.000000', 'consum', 0.0220, 'lps'),
	(474963, 125, '2015-04-01 00:13:37.000000', 'consum', 0.0227, 'lps'),
	(474964, 125, '2015-04-01 00:13:38.000000', 'consum', 0.0216, 'lps'),
	(474965, 125, '2015-04-01 00:13:39.000000', 'consum', 0.0212, 'lps'),
	(474966, 125, '2015-04-01 00:13:40.000000', 'consum', 0.0230, 'lps'),
	(474967, 125, '2015-04-01 00:13:41.000000', 'consum', 0.0229, 'lps'),
	(474968, 125, '2015-04-01 00:13:42.000000', 'consum', 0.0222, 'lps'),
	(474969, 125, '2015-04-01 00:13:43.000000', 'consum', 0.0214, 'lps'),
	(474970, 125, '2015-04-01 00:13:44.000000', 'consum', 0.0217, 'lps'),
	(474971, 125, '2015-04-01 00:13:45.000000', 'consum', 0.0233, 'lps'),
	(474972, 125, '2015-04-01 00:13:46.000000', 'consum', 0.0233, 'lps'),
	(474973, 125, '2015-04-01 00:13:47.000000', 'consum', 0.0232, 'lps'),
	(474974, 125, '2015-04-01 00:13:48.000000', 'consum', 0.0229, 'lps'),
	(474975, 125, '2015-04-01 00:13:49.000000', 'consum', 0.0215, 'lps'),
	(474976, 125, '2015-04-01 00:13:50.000000', 'consum', 0.0228, 'lps'),
	(474977, 125, '2015-04-01 00:13:51.000000', 'consum', 0.0212, 'lps'),
	(474978, 125, '2015-04-01 00:13:52.000000', 'consum', 0.0216, 'lps'),
	(474979, 125, '2015-04-01 00:13:53.000000', 'consum', 0.0211, 'lps'),
	(474980, 125, '2015-04-01 00:13:54.000000', 'consum', 0.0221, 'lps'),
	(474981, 125, '2015-04-01 00:13:55.000000', 'consum', 0.0215, 'lps'),
	(474982, 125, '2015-04-01 00:13:56.000000', 'consum', 0.0225, 'lps'),
	(474983, 125, '2015-04-01 00:13:57.000000', 'consum', 0.0225, 'lps'),
	(474984, 125, '2015-04-01 00:13:58.000000', 'consum', 0.0215, 'lps'),
	(474985, 125, '2015-04-01 00:13:59.000000', 'consum', 0.0216, 'lps'),
	(474986, 125, '2015-04-01 00:14:00.000000', 'consum', 0.0224, 'lps'),
	(474987, 125, '2015-04-01 00:14:01.000000', 'consum', 0.0217, 'lps'),
	(474988, 125, '2015-04-01 00:14:02.000000', 'consum', 0.0226, 'lps'),
	(474989, 125, '2015-04-01 00:14:03.000000', 'consum', 0.0220, 'lps'),
	(474990, 125, '2015-04-01 00:14:04.000000', 'consum', 0.0212, 'lps'),
	(474991, 125, '2015-04-01 00:14:05.000000', 'consum', 0.0216, 'lps'),
	(474992, 125, '2015-04-01 00:14:06.000000', 'consum', 0.0211, 'lps'),
	(474993, 125, '2015-04-01 00:14:07.000000', 'consum', 0.0219, 'lps'),
	(474994, 125, '2015-04-01 00:14:08.000000', 'consum', 0.0232, 'lps'),
	(474995, 125, '2015-04-01 00:14:09.000000', 'consum', 0.0218, 'lps'),
	(474996, 125, '2015-04-01 00:14:10.000000', 'consum', 0.0212, 'lps'),
	(474997, 125, '2015-04-01 00:14:11.000000', 'consum', 0.0217, 'lps'),
	(474998, 125, '2015-04-01 00:14:12.000000', 'consum', 0.0219, 'lps'),
	(474999, 125, '2015-04-01 00:14:13.000000', 'consum', 0.0232, 'lps'),
	(475000, 125, '2015-04-01 00:14:14.000000', 'consum', 0.0224, 'lps'),
	(475001, 125, '2015-04-01 00:14:15.000000', 'consum', 0.0213, 'lps'),
	(475002, 125, '2015-04-01 00:14:16.000000', 'consum', 0.0232, 'lps'),
	(475003, 125, '2015-04-01 00:14:17.000000', 'consum', 0.0215, 'lps'),
	(475004, 125, '2015-04-01 00:14:18.000000', 'consum', 0.0220, 'lps'),
	(475005, 125, '2015-04-01 00:14:19.000000', 'consum', 0.0218, 'lps'),
	(475006, 125, '2015-04-01 00:14:20.000000', 'consum', 0.0222, 'lps'),
	(475007, 125, '2015-04-01 00:14:21.000000', 'consum', 0.0222, 'lps'),
	(475008, 125, '2015-04-01 00:14:22.000000', 'consum', 0.0213, 'lps'),
	(475009, 125, '2015-04-01 00:14:23.000000', 'consum', 0.0211, 'lps'),
	(475010, 125, '2015-04-01 00:14:24.000000', 'consum', 0.0229, 'lps'),
	(475011, 125, '2015-04-01 00:14:25.000000', 'consum', 0.0233, 'lps'),
	(475012, 125, '2015-04-01 00:14:26.000000', 'consum', 0.0220, 'lps'),
	(475013, 125, '2015-04-01 00:14:27.000000', 'consum', 0.0216, 'lps'),
	(475014, 125, '2015-04-01 00:14:28.000000', 'consum', 0.0210, 'lps'),
	(475015, 125, '2015-04-01 00:14:29.000000', 'consum', 0.0216, 'lps'),
	(475016, 125, '2015-04-01 00:14:30.000000', 'consum', 0.0216, 'lps'),
	(475017, 125, '2015-04-01 00:14:31.000000', 'consum', 0.0222, 'lps'),
	(475018, 125, '2015-04-01 00:14:32.000000', 'consum', 0.0227, 'lps'),
	(475019, 125, '2015-04-01 00:14:33.000000', 'consum', 0.0215, 'lps'),
	(475020, 125, '2015-04-01 00:14:34.000000', 'consum', 0.0231, 'lps'),
	(475021, 125, '2015-04-01 00:14:35.000000', 'consum', 0.0230, 'lps'),
	(475022, 125, '2015-04-01 00:14:36.000000', 'consum', 0.0221, 'lps'),
	(475023, 125, '2015-04-01 00:14:37.000000', 'consum', 0.0229, 'lps'),
	(475024, 125, '2015-04-01 00:14:38.000000', 'consum', 0.0225, 'lps'),
	(475025, 125, '2015-04-01 00:14:39.000000', 'consum', 0.0228, 'lps'),
	(475026, 125, '2015-04-01 00:14:40.000000', 'consum', 0.0231, 'lps'),
	(475027, 125, '2015-04-01 00:14:41.000000', 'consum', 0.0215, 'lps'),
	(475028, 125, '2015-04-01 00:14:42.000000', 'consum', 0.0219, 'lps'),
	(475029, 125, '2015-04-01 00:14:43.000000', 'consum', 0.0216, 'lps'),
	(475030, 125, '2015-04-01 00:14:44.000000', 'consum', 0.0213, 'lps'),
	(475031, 125, '2015-04-01 00:14:45.000000', 'consum', 0.0233, 'lps'),
	(475032, 125, '2015-04-01 00:14:46.000000', 'consum', 0.0220, 'lps'),
	(475033, 125, '2015-04-01 00:14:47.000000', 'consum', 0.0215, 'lps'),
	(475034, 125, '2015-04-01 00:14:48.000000', 'consum', 0.0229, 'lps'),
	(475035, 125, '2015-04-01 00:14:49.000000', 'consum', 0.0218, 'lps'),
	(475036, 125, '2015-04-01 00:14:50.000000', 'consum', 0.0220, 'lps'),
	(475037, 125, '2015-04-01 00:14:51.000000', 'consum', 0.0213, 'lps'),
	(475038, 125, '2015-04-01 00:14:52.000000', 'consum', 0.0217, 'lps'),
	(475039, 125, '2015-04-01 00:14:53.000000', 'consum', 0.0216, 'lps'),
	(475040, 125, '2015-04-01 00:14:54.000000', 'consum', 0.0216, 'lps'),
	(475041, 125, '2015-04-01 00:14:55.000000', 'consum', 0.0223, 'lps'),
	(475042, 125, '2015-04-01 00:14:56.000000', 'consum', 0.0233, 'lps'),
	(475043, 125, '2015-04-01 00:14:57.000000', 'consum', 0.0217, 'lps'),
	(475044, 125, '2015-04-01 00:14:58.000000', 'consum', 0.0223, 'lps'),
	(475045, 125, '2015-04-01 00:14:59.000000', 'consum', 0.0233, 'lps'),
	(475046, 125, '2015-04-01 00:15:00.000000', 'consum', 0.0212, 'lps'),
	(475047, 125, '2015-04-01 00:15:01.000000', 'consum', 0.0223, 'lps'),
	(475048, 125, '2015-04-01 00:15:02.000000', 'consum', 0.0221, 'lps'),
	(475049, 125, '2015-04-01 00:15:03.000000', 'consum', 0.0229, 'lps'),
	(475050, 125, '2015-04-01 00:15:04.000000', 'consum', 0.0223, 'lps'),
	(475051, 125, '2015-04-01 00:15:05.000000', 'consum', 0.0218, 'lps'),
	(475052, 125, '2015-04-01 00:15:06.000000', 'consum', 0.0210, 'lps'),
	(475053, 125, '2015-04-01 00:15:07.000000', 'consum', 0.0213, 'lps'),
	(475054, 125, '2015-04-01 00:15:08.000000', 'consum', 0.0223, 'lps'),
	(475055, 125, '2015-04-01 00:15:09.000000', 'consum', 0.0221, 'lps'),
	(475056, 125, '2015-04-01 00:15:10.000000', 'consum', 0.0226, 'lps'),
	(475057, 125, '2015-04-01 00:15:11.000000', 'consum', 0.0232, 'lps'),
	(475058, 125, '2015-04-01 00:15:12.000000', 'consum', 0.0225, 'lps'),
	(475059, 125, '2015-04-01 00:15:13.000000', 'consum', 0.0219, 'lps'),
	(475060, 125, '2015-04-01 00:15:14.000000', 'consum', 0.0210, 'lps'),
	(475061, 125, '2015-04-01 00:15:15.000000', 'consum', 0.0210, 'lps'),
	(475062, 125, '2015-04-01 00:15:16.000000', 'consum', 0.0232, 'lps'),
	(475063, 125, '2015-04-01 00:15:17.000000', 'consum', 0.0227, 'lps'),
	(475064, 125, '2015-04-01 00:15:18.000000', 'consum', 0.0230, 'lps'),
	(475065, 125, '2015-04-01 00:15:19.000000', 'consum', 0.0233, 'lps'),
	(475066, 125, '2015-04-01 00:15:20.000000', 'consum', 0.0220, 'lps'),
	(475067, 125, '2015-04-01 00:15:21.000000', 'consum', 0.0215, 'lps'),
	(475068, 125, '2015-04-01 00:15:22.000000', 'consum', 0.0228, 'lps'),
	(475069, 125, '2015-04-01 00:15:23.000000', 'consum', 0.0213, 'lps'),
	(475070, 125, '2015-04-01 00:15:24.000000', 'consum', 0.0222, 'lps'),
	(475071, 125, '2015-04-01 00:15:25.000000', 'consum', 0.0214, 'lps'),
	(475072, 125, '2015-04-01 00:15:26.000000', 'consum', 0.0218, 'lps'),
	(475073, 125, '2015-04-01 00:15:27.000000', 'consum', 0.0212, 'lps'),
	(475074, 125, '2015-04-01 00:15:28.000000', 'consum', 0.0222, 'lps'),
	(475075, 125, '2015-04-01 00:15:29.000000', 'consum', 0.0215, 'lps'),
	(475076, 125, '2015-04-01 00:15:30.000000', 'consum', 0.0224, 'lps'),
	(475077, 125, '2015-04-01 00:15:31.000000', 'consum', 0.0216, 'lps'),
	(475078, 125, '2015-04-01 00:15:32.000000', 'consum', 0.0224, 'lps'),
	(475079, 125, '2015-04-01 00:15:33.000000', 'consum', 0.0213, 'lps'),
	(475080, 125, '2015-04-01 00:15:34.000000', 'consum', 0.0210, 'lps'),
	(475081, 125, '2015-04-01 00:15:35.000000', 'consum', 0.0223, 'lps'),
	(475082, 125, '2015-04-01 00:15:36.000000', 'consum', 0.0228, 'lps'),
	(475083, 125, '2015-04-01 00:15:37.000000', 'consum', 0.0216, 'lps'),
	(475084, 125, '2015-04-01 00:15:38.000000', 'consum', 0.0232, 'lps'),
	(475085, 125, '2015-04-01 00:15:39.000000', 'consum', 0.0232, 'lps'),
	(475086, 125, '2015-04-01 00:15:40.000000', 'consum', 0.0228, 'lps'),
	(475087, 125, '2015-04-01 00:15:41.000000', 'consum', 0.0212, 'lps'),
	(475088, 125, '2015-04-01 00:15:42.000000', 'consum', 0.0216, 'lps'),
	(475089, 125, '2015-04-01 00:15:43.000000', 'consum', 0.0211, 'lps'),
	(475090, 125, '2015-04-01 00:15:44.000000', 'consum', 0.0221, 'lps'),
	(475091, 125, '2015-04-01 00:15:45.000000', 'consum', 0.0214, 'lps'),
	(475092, 125, '2015-04-01 00:15:46.000000', 'consum', 0.0222, 'lps'),
	(475093, 125, '2015-04-01 00:15:47.000000', 'consum', 0.0232, 'lps'),
	(475094, 125, '2015-04-01 00:15:48.000000', 'consum', 0.0216, 'lps'),
	(475095, 125, '2015-04-01 00:15:49.000000', 'consum', 0.0221, 'lps'),
	(475096, 125, '2015-04-01 00:15:50.000000', 'consum', 0.0224, 'lps'),
	(475097, 125, '2015-04-01 00:15:51.000000', 'consum', 0.0222, 'lps'),
	(475098, 125, '2015-04-01 00:15:52.000000', 'consum', 0.0227, 'lps'),
	(475099, 125, '2015-04-01 00:15:53.000000', 'consum', 0.0214, 'lps'),
	(475100, 125, '2015-04-01 00:15:54.000000', 'consum', 0.0227, 'lps'),
	(475101, 125, '2015-04-01 00:15:55.000000', 'consum', 0.0211, 'lps'),
	(475102, 125, '2015-04-01 00:15:56.000000', 'consum', 0.0212, 'lps'),
	(475103, 125, '2015-04-01 00:15:57.000000', 'consum', 0.0218, 'lps'),
	(475104, 125, '2015-04-01 00:15:58.000000', 'consum', 0.0219, 'lps'),
	(475105, 125, '2015-04-01 00:15:59.000000', 'consum', 0.0231, 'lps'),
	(475106, 125, '2015-04-01 00:16:00.000000', 'consum', 0.0217, 'lps'),
	(475107, 125, '2015-04-01 00:16:01.000000', 'consum', 0.0233, 'lps'),
	(475108, 125, '2015-04-01 00:16:02.000000', 'consum', 0.0231, 'lps'),
	(475109, 125, '2015-04-01 00:16:03.000000', 'consum', 0.0220, 'lps'),
	(475110, 125, '2015-04-01 00:16:04.000000', 'consum', 0.0225, 'lps'),
	(475111, 125, '2015-04-01 00:16:05.000000', 'consum', 0.0231, 'lps'),
	(475112, 125, '2015-04-01 00:16:06.000000', 'consum', 0.0220, 'lps'),
	(475113, 125, '2015-04-01 00:16:07.000000', 'consum', 0.0225, 'lps'),
	(475114, 125, '2015-04-01 00:16:08.000000', 'consum', 0.0230, 'lps'),
	(475115, 125, '2015-04-01 00:16:09.000000', 'consum', 0.0217, 'lps'),
	(475116, 125, '2015-04-01 00:16:10.000000', 'consum', 0.0233, 'lps'),
	(475117, 125, '2015-04-01 00:16:11.000000', 'consum', 0.0210, 'lps'),
	(475118, 125, '2015-04-01 00:16:12.000000', 'consum', 0.0213, 'lps'),
	(475119, 125, '2015-04-01 00:16:13.000000', 'consum', 0.0225, 'lps'),
	(475120, 125, '2015-04-01 00:16:14.000000', 'consum', 0.0228, 'lps'),
	(475121, 125, '2015-04-01 00:16:15.000000', 'consum', 0.0233, 'lps'),
	(475122, 125, '2015-04-01 00:16:16.000000', 'consum', 0.0223, 'lps'),
	(475123, 125, '2015-04-01 00:16:17.000000', 'consum', 0.0231, 'lps'),
	(475124, 125, '2015-04-01 00:16:18.000000', 'consum', 0.0226, 'lps'),
	(475125, 125, '2015-04-01 00:16:19.000000', 'consum', 0.0229, 'lps'),
	(475126, 125, '2015-04-01 00:16:20.000000', 'consum', 0.0232, 'lps'),
	(475127, 125, '2015-04-01 00:16:21.000000', 'consum', 0.0217, 'lps'),
	(475128, 125, '2015-04-01 00:16:22.000000', 'consum', 0.0228, 'lps'),
	(475129, 125, '2015-04-01 00:16:23.000000', 'consum', 0.0232, 'lps'),
	(475130, 125, '2015-04-01 00:16:24.000000', 'consum', 0.0219, 'lps'),
	(475131, 125, '2015-04-01 00:16:25.000000', 'consum', 0.0212, 'lps'),
	(475132, 125, '2015-04-01 00:16:26.000000', 'consum', 0.0219, 'lps'),
	(475133, 125, '2015-04-01 00:16:27.000000', 'consum', 0.0224, 'lps'),
	(475134, 125, '2015-04-01 00:16:28.000000', 'consum', 0.0229, 'lps'),
	(475135, 125, '2015-04-01 00:16:29.000000', 'consum', 0.0216, 'lps'),
	(475136, 125, '2015-04-01 00:16:30.000000', 'consum', 0.0231, 'lps'),
	(475137, 125, '2015-04-01 00:16:31.000000', 'consum', 0.0228, 'lps'),
	(475138, 125, '2015-04-01 00:16:32.000000', 'consum', 0.0211, 'lps'),
	(475139, 125, '2015-04-01 00:16:33.000000', 'consum', 0.0233, 'lps'),
	(475140, 125, '2015-04-01 00:16:34.000000', 'consum', 0.0228, 'lps'),
	(475141, 125, '2015-04-01 00:16:35.000000', 'consum', 0.0229, 'lps'),
	(475142, 125, '2015-04-01 00:16:36.000000', 'consum', 0.0230, 'lps'),
	(475143, 125, '2015-04-01 00:16:37.000000', 'consum', 0.0231, 'lps'),
	(475144, 125, '2015-04-01 00:16:38.000000', 'consum', 0.0229, 'lps'),
	(475145, 125, '2015-04-01 00:16:39.000000', 'consum', 0.0218, 'lps'),
	(475146, 125, '2015-04-01 00:16:40.000000', 'consum', 0.0216, 'lps'),
	(475147, 125, '2015-04-01 00:16:41.000000', 'consum', 0.0219, 'lps'),
	(475148, 125, '2015-04-01 00:16:42.000000', 'consum', 0.0212, 'lps'),
	(475149, 125, '2015-04-01 00:16:43.000000', 'consum', 0.0220, 'lps'),
	(475150, 125, '2015-04-01 00:16:44.000000', 'consum', 0.0227, 'lps'),
	(475151, 125, '2015-04-01 00:16:45.000000', 'consum', 0.0221, 'lps'),
	(475152, 125, '2015-04-01 00:16:46.000000', 'consum', 0.0211, 'lps'),
	(475153, 125, '2015-04-01 00:16:47.000000', 'consum', 0.0232, 'lps'),
	(475154, 125, '2015-04-01 00:16:48.000000', 'consum', 0.0223, 'lps'),
	(475155, 125, '2015-04-01 00:16:49.000000', 'consum', 0.0210, 'lps'),
	(475156, 125, '2015-04-01 00:16:50.000000', 'consum', 0.0217, 'lps'),
	(475157, 125, '2015-04-01 00:16:51.000000', 'consum', 0.0223, 'lps'),
	(475158, 125, '2015-04-01 00:16:52.000000', 'consum', 0.0231, 'lps'),
	(475159, 125, '2015-04-01 00:16:53.000000', 'consum', 0.0228, 'lps'),
	(475160, 125, '2015-04-01 00:16:54.000000', 'consum', 0.0215, 'lps'),
	(475161, 125, '2015-04-01 00:16:55.000000', 'consum', 0.0227, 'lps'),
	(475162, 125, '2015-04-01 00:16:56.000000', 'consum', 0.0211, 'lps'),
	(475163, 125, '2015-04-01 00:16:57.000000', 'consum', 0.0211, 'lps'),
	(475164, 125, '2015-04-01 00:16:58.000000', 'consum', 0.0211, 'lps'),
	(475165, 125, '2015-04-01 00:16:59.000000', 'consum', 0.0213, 'lps'),
	(475166, 125, '2015-04-01 00:17:00.000000', 'consum', 0.0223, 'lps'),
	(475167, 125, '2015-04-01 00:17:01.000000', 'consum', 0.0218, 'lps'),
	(475168, 125, '2015-04-01 00:17:02.000000', 'consum', 0.0212, 'lps'),
	(475169, 125, '2015-04-01 00:17:03.000000', 'consum', 0.0219, 'lps'),
	(475170, 125, '2015-04-01 00:17:04.000000', 'consum', 0.0225, 'lps'),
	(475171, 125, '2015-04-01 00:17:05.000000', 'consum', 0.0210, 'lps'),
	(475172, 125, '2015-04-01 00:17:06.000000', 'consum', 0.0213, 'lps'),
	(475173, 125, '2015-04-01 00:17:07.000000', 'consum', 0.0228, 'lps'),
	(475174, 125, '2015-04-01 00:17:08.000000', 'consum', 0.0219, 'lps'),
	(475175, 125, '2015-04-01 00:17:09.000000', 'consum', 0.0223, 'lps'),
	(475176, 125, '2015-04-01 00:17:10.000000', 'consum', 0.0228, 'lps'),
	(475177, 125, '2015-04-01 00:17:11.000000', 'consum', 0.0211, 'lps'),
	(475178, 125, '2015-04-01 00:17:12.000000', 'consum', 0.0210, 'lps'),
	(475179, 125, '2015-04-01 00:17:13.000000', 'consum', 0.0231, 'lps'),
	(475180, 125, '2015-04-01 00:17:14.000000', 'consum', 0.0218, 'lps'),
	(475181, 125, '2015-04-01 00:17:15.000000', 'consum', 0.0213, 'lps'),
	(475182, 125, '2015-04-01 00:17:16.000000', 'consum', 0.0226, 'lps'),
	(475183, 125, '2015-04-01 00:17:17.000000', 'consum', 0.0232, 'lps'),
	(475184, 125, '2015-04-01 00:17:18.000000', 'consum', 0.0224, 'lps'),
	(475185, 125, '2015-04-01 00:17:19.000000', 'consum', 0.0216, 'lps'),
	(475186, 125, '2015-04-01 00:17:20.000000', 'consum', 0.0224, 'lps'),
	(475187, 125, '2015-04-01 00:17:21.000000', 'consum', 0.0213, 'lps'),
	(475188, 125, '2015-04-01 00:17:22.000000', 'consum', 0.0232, 'lps'),
	(475189, 125, '2015-04-01 00:17:23.000000', 'consum', 0.0217, 'lps'),
	(475190, 125, '2015-04-01 00:17:24.000000', 'consum', 0.0225, 'lps'),
	(475191, 125, '2015-04-01 00:17:25.000000', 'consum', 0.0217, 'lps'),
	(475192, 125, '2015-04-01 00:17:26.000000', 'consum', 0.0224, 'lps'),
	(475193, 125, '2015-04-01 00:17:27.000000', 'consum', 0.0214, 'lps'),
	(475194, 125, '2015-04-01 00:17:28.000000', 'consum', 0.0233, 'lps'),
	(475195, 125, '2015-04-01 00:17:29.000000', 'consum', 0.0221, 'lps'),
	(475196, 125, '2015-04-01 00:17:30.000000', 'consum', 0.0219, 'lps'),
	(475197, 125, '2015-04-01 00:17:31.000000', 'consum', 0.0222, 'lps'),
	(475198, 125, '2015-04-01 00:17:32.000000', 'consum', 0.0221, 'lps'),
	(475199, 125, '2015-04-01 00:17:33.000000', 'consum', 0.0229, 'lps'),
	(475200, 125, '2015-04-01 00:17:34.000000', 'consum', 0.0223, 'lps'),
	(475201, 125, '2015-04-01 00:17:35.000000', 'consum', 0.0220, 'lps'),
	(475202, 125, '2015-04-01 00:17:36.000000', 'consum', 0.0222, 'lps'),
	(475203, 125, '2015-04-01 00:17:37.000000', 'consum', 0.0214, 'lps'),
	(475204, 125, '2015-04-01 00:17:38.000000', 'consum', 0.0221, 'lps'),
	(475205, 125, '2015-04-01 00:17:39.000000', 'consum', 0.0227, 'lps'),
	(475206, 125, '2015-04-01 00:17:40.000000', 'consum', 0.0216, 'lps'),
	(475207, 125, '2015-04-01 00:17:41.000000', 'consum', 0.0214, 'lps'),
	(475208, 125, '2015-04-01 00:17:42.000000', 'consum', 0.0213, 'lps'),
	(475209, 125, '2015-04-01 00:17:43.000000', 'consum', 0.0212, 'lps'),
	(475210, 125, '2015-04-01 00:17:44.000000', 'consum', 0.0211, 'lps'),
	(475211, 125, '2015-04-01 00:17:45.000000', 'consum', 0.0233, 'lps'),
	(475212, 125, '2015-04-01 00:17:46.000000', 'consum', 0.0227, 'lps'),
	(475213, 125, '2015-04-01 00:17:47.000000', 'consum', 0.0227, 'lps'),
	(475214, 125, '2015-04-01 00:17:48.000000', 'consum', 0.0219, 'lps'),
	(475215, 125, '2015-04-01 00:17:49.000000', 'consum', 0.0227, 'lps'),
	(475216, 125, '2015-04-01 00:17:50.000000', 'consum', 0.0224, 'lps'),
	(475217, 125, '2015-04-01 00:17:51.000000', 'consum', 0.0229, 'lps'),
	(475218, 125, '2015-04-01 00:17:52.000000', 'consum', 0.0216, 'lps'),
	(475219, 125, '2015-04-01 00:17:53.000000', 'consum', 0.0231, 'lps'),
	(475220, 125, '2015-04-01 00:17:54.000000', 'consum', 0.0224, 'lps'),
	(475221, 125, '2015-04-01 00:17:55.000000', 'consum', 0.0218, 'lps'),
	(475222, 125, '2015-04-01 00:17:56.000000', 'consum', 0.0231, 'lps'),
	(475223, 125, '2015-04-01 00:17:57.000000', 'consum', 0.0222, 'lps'),
	(475224, 125, '2015-04-01 00:17:58.000000', 'consum', 0.0232, 'lps'),
	(475225, 125, '2015-04-01 00:17:59.000000', 'consum', 0.0213, 'lps'),
	(475226, 125, '2015-04-01 00:18:00.000000', 'consum', 0.0229, 'lps'),
	(475227, 125, '2015-04-01 00:18:01.000000', 'consum', 0.0227, 'lps'),
	(475228, 125, '2015-04-01 00:18:02.000000', 'consum', 0.0212, 'lps'),
	(475229, 125, '2015-04-01 00:18:03.000000', 'consum', 0.0219, 'lps'),
	(475230, 125, '2015-04-01 00:18:04.000000', 'consum', 0.0225, 'lps'),
	(475231, 125, '2015-04-01 00:18:05.000000', 'consum', 0.0212, 'lps'),
	(475232, 125, '2015-04-01 00:18:06.000000', 'consum', 0.0222, 'lps'),
	(475233, 125, '2015-04-01 00:18:07.000000', 'consum', 0.0217, 'lps'),
	(475234, 125, '2015-04-01 00:18:08.000000', 'consum', 0.0232, 'lps'),
	(475235, 125, '2015-04-01 00:18:09.000000', 'consum', 0.0228, 'lps'),
	(475236, 125, '2015-04-01 00:18:10.000000', 'consum', 0.0210, 'lps'),
	(475237, 125, '2015-04-01 00:18:11.000000', 'consum', 0.0228, 'lps'),
	(475238, 125, '2015-04-01 00:18:12.000000', 'consum', 0.0228, 'lps'),
	(475239, 125, '2015-04-01 00:18:13.000000', 'consum', 0.0225, 'lps'),
	(475240, 125, '2015-04-01 00:18:14.000000', 'consum', 0.0232, 'lps'),
	(475241, 125, '2015-04-01 00:18:15.000000', 'consum', 0.0228, 'lps'),
	(475242, 125, '2015-04-01 00:18:16.000000', 'consum', 0.0210, 'lps'),
	(475243, 125, '2015-04-01 00:18:17.000000', 'consum', 0.0228, 'lps'),
	(475244, 125, '2015-04-01 00:18:18.000000', 'consum', 0.0231, 'lps'),
	(475245, 125, '2015-04-01 00:18:19.000000', 'consum', 0.0210, 'lps'),
	(475246, 125, '2015-04-01 00:18:20.000000', 'consum', 0.0219, 'lps'),
	(475247, 125, '2015-04-01 00:18:21.000000', 'consum', 0.0210, 'lps'),
	(475248, 125, '2015-04-01 00:18:22.000000', 'consum', 0.0230, 'lps'),
	(475249, 125, '2015-04-01 00:18:23.000000', 'consum', 0.0216, 'lps'),
	(475250, 125, '2015-04-01 00:18:24.000000', 'consum', 0.0230, 'lps'),
	(475251, 125, '2015-04-01 00:18:25.000000', 'consum', 0.0217, 'lps'),
	(475252, 125, '2015-04-01 00:18:26.000000', 'consum', 0.0211, 'lps'),
	(475253, 125, '2015-04-01 00:18:27.000000', 'consum', 0.0220, 'lps'),
	(475254, 125, '2015-04-01 00:18:28.000000', 'consum', 0.0232, 'lps'),
	(475255, 125, '2015-04-01 00:18:29.000000', 'consum', 0.0219, 'lps'),
	(475256, 125, '2015-04-01 00:18:30.000000', 'consum', 0.0214, 'lps'),
	(475257, 125, '2015-04-01 00:18:31.000000', 'consum', 0.0226, 'lps'),
	(475258, 125, '2015-04-01 00:18:32.000000', 'consum', 0.0232, 'lps'),
	(475259, 125, '2015-04-01 00:18:33.000000', 'consum', 0.0225, 'lps'),
	(475260, 125, '2015-04-01 00:18:34.000000', 'consum', 0.0218, 'lps'),
	(475261, 125, '2015-04-01 00:18:35.000000', 'consum', 0.0229, 'lps'),
	(475262, 125, '2015-04-01 00:18:36.000000', 'consum', 0.0212, 'lps'),
	(475263, 125, '2015-04-01 00:18:37.000000', 'consum', 0.0233, 'lps'),
	(475264, 125, '2015-04-01 00:18:38.000000', 'consum', 0.0224, 'lps'),
	(475265, 125, '2015-04-01 00:18:39.000000', 'consum', 0.0211, 'lps'),
	(475266, 125, '2015-04-01 00:18:40.000000', 'consum', 0.0221, 'lps'),
	(475267, 125, '2015-04-01 00:18:41.000000', 'consum', 0.0216, 'lps'),
	(475268, 125, '2015-04-01 00:18:42.000000', 'consum', 0.0233, 'lps'),
	(475269, 125, '2015-04-01 00:18:43.000000', 'consum', 0.0210, 'lps'),
	(475270, 125, '2015-04-01 00:18:44.000000', 'consum', 0.0214, 'lps'),
	(475271, 125, '2015-04-01 00:18:45.000000', 'consum', 0.0232, 'lps'),
	(475272, 125, '2015-04-01 00:18:46.000000', 'consum', 0.0210, 'lps'),
	(475273, 125, '2015-04-01 00:18:47.000000', 'consum', 0.0219, 'lps'),
	(475274, 125, '2015-04-01 00:18:48.000000', 'consum', 0.0229, 'lps'),
	(475275, 125, '2015-04-01 00:18:49.000000', 'consum', 0.0232, 'lps'),
	(475276, 125, '2015-04-01 00:18:50.000000', 'consum', 0.0217, 'lps'),
	(475277, 125, '2015-04-01 00:18:51.000000', 'consum', 0.0227, 'lps'),
	(475278, 125, '2015-04-01 00:18:52.000000', 'consum', 0.0226, 'lps'),
	(475279, 125, '2015-04-01 00:18:53.000000', 'consum', 0.0213, 'lps'),
	(475280, 125, '2015-04-01 00:18:54.000000', 'consum', 0.0229, 'lps'),
	(475281, 125, '2015-04-01 00:18:55.000000', 'consum', 0.0224, 'lps'),
	(475282, 125, '2015-04-01 00:18:56.000000', 'consum', 0.0224, 'lps'),
	(475283, 125, '2015-04-01 00:18:57.000000', 'consum', 0.0214, 'lps'),
	(475284, 125, '2015-04-01 00:18:58.000000', 'consum', 0.0211, 'lps'),
	(475285, 125, '2015-04-01 00:18:59.000000', 'consum', 0.0227, 'lps'),
	(475286, 125, '2015-04-01 00:19:00.000000', 'consum', 0.0220, 'lps'),
	(475287, 125, '2015-04-01 00:19:01.000000', 'consum', 0.0233, 'lps'),
	(475288, 125, '2015-04-01 00:19:02.000000', 'consum', 0.0223, 'lps'),
	(475289, 125, '2015-04-01 00:19:03.000000', 'consum', 0.0232, 'lps'),
	(475290, 125, '2015-04-01 00:19:04.000000', 'consum', 0.0211, 'lps'),
	(475291, 125, '2015-04-01 00:19:05.000000', 'consum', 0.0221, 'lps'),
	(475292, 125, '2015-04-01 00:19:06.000000', 'consum', 0.0216, 'lps'),
	(475293, 125, '2015-04-01 00:19:07.000000', 'consum', 0.0229, 'lps'),
	(475294, 125, '2015-04-01 00:19:08.000000', 'consum', 0.0217, 'lps'),
	(475295, 125, '2015-04-01 00:19:09.000000', 'consum', 0.0214, 'lps'),
	(475296, 125, '2015-04-01 00:19:10.000000', 'consum', 0.0232, 'lps'),
	(475297, 125, '2015-04-01 00:19:11.000000', 'consum', 0.0211, 'lps'),
	(475298, 125, '2015-04-01 00:19:12.000000', 'consum', 0.0221, 'lps'),
	(475299, 125, '2015-04-01 00:19:13.000000', 'consum', 0.0215, 'lps'),
	(475300, 125, '2015-04-01 00:19:14.000000', 'consum', 0.0228, 'lps'),
	(475301, 125, '2015-04-01 00:19:15.000000', 'consum', 0.0212, 'lps'),
	(475302, 125, '2015-04-01 00:19:16.000000', 'consum', 0.0214, 'lps'),
	(475303, 125, '2015-04-01 00:19:17.000000', 'consum', 0.0226, 'lps'),
	(475304, 125, '2015-04-01 00:19:18.000000', 'consum', 0.0232, 'lps'),
	(475305, 125, '2015-04-01 00:19:19.000000', 'consum', 0.0222, 'lps'),
	(475306, 125, '2015-04-01 00:19:20.000000', 'consum', 0.0230, 'lps'),
	(475307, 125, '2015-04-01 00:19:21.000000', 'consum', 0.0225, 'lps'),
	(475308, 125, '2015-04-01 00:19:22.000000', 'consum', 0.0224, 'lps'),
	(475309, 125, '2015-04-01 00:19:23.000000', 'consum', 0.0215, 'lps'),
	(475310, 125, '2015-04-01 00:19:24.000000', 'consum', 0.0216, 'lps'),
	(475311, 125, '2015-04-01 00:19:25.000000', 'consum', 0.0226, 'lps'),
	(475312, 125, '2015-04-01 00:19:26.000000', 'consum', 0.0224, 'lps'),
	(475313, 125, '2015-04-01 00:19:27.000000', 'consum', 0.0211, 'lps'),
	(475314, 125, '2015-04-01 00:19:28.000000', 'consum', 0.0218, 'lps'),
	(475315, 125, '2015-04-01 00:19:29.000000', 'consum', 0.0226, 'lps'),
	(475316, 125, '2015-04-01 00:19:30.000000', 'consum', 0.0219, 'lps'),
	(475317, 125, '2015-04-01 00:19:31.000000', 'consum', 0.0229, 'lps'),
	(475318, 125, '2015-04-01 00:19:32.000000', 'consum', 0.0231, 'lps'),
	(475319, 125, '2015-04-01 00:19:33.000000', 'consum', 0.0210, 'lps'),
	(475320, 125, '2015-04-01 00:19:34.000000', 'consum', 0.0222, 'lps'),
	(475321, 125, '2015-04-01 00:19:35.000000', 'consum', 0.0222, 'lps'),
	(475322, 125, '2015-04-01 00:19:36.000000', 'consum', 0.0233, 'lps'),
	(475323, 125, '2015-04-01 00:19:37.000000', 'consum', 0.0219, 'lps'),
	(475324, 125, '2015-04-01 00:19:38.000000', 'consum', 0.0210, 'lps'),
	(475325, 125, '2015-04-01 00:19:39.000000', 'consum', 0.0233, 'lps'),
	(475326, 125, '2015-04-01 00:19:40.000000', 'consum', 0.0230, 'lps'),
	(475327, 125, '2015-04-01 00:19:41.000000', 'consum', 0.0218, 'lps'),
	(475328, 125, '2015-04-01 00:19:42.000000', 'consum', 0.0215, 'lps'),
	(475329, 125, '2015-04-01 00:19:43.000000', 'consum', 0.0233, 'lps'),
	(475330, 125, '2015-04-01 00:19:44.000000', 'consum', 0.0217, 'lps'),
	(475331, 125, '2015-04-01 00:19:45.000000', 'consum', 0.0224, 'lps'),
	(475332, 125, '2015-04-01 00:19:46.000000', 'consum', 0.0213, 'lps'),
	(475333, 125, '2015-04-01 00:19:47.000000', 'consum', 0.0230, 'lps'),
	(475334, 125, '2015-04-01 00:19:48.000000', 'consum', 0.0229, 'lps'),
	(475335, 125, '2015-04-01 00:19:49.000000', 'consum', 0.0221, 'lps'),
	(475336, 125, '2015-04-01 00:19:50.000000', 'consum', 0.0233, 'lps'),
	(475337, 125, '2015-04-01 00:19:51.000000', 'consum', 0.0221, 'lps'),
	(475338, 125, '2015-04-01 00:19:52.000000', 'consum', 0.0222, 'lps'),
	(475339, 125, '2015-04-01 00:19:53.000000', 'consum', 0.0213, 'lps'),
	(475340, 125, '2015-04-01 00:19:54.000000', 'consum', 0.0214, 'lps'),
	(475341, 125, '2015-04-01 00:19:55.000000', 'consum', 0.0221, 'lps'),
	(475342, 125, '2015-04-01 00:19:56.000000', 'consum', 0.0229, 'lps'),
	(475343, 125, '2015-04-01 00:19:57.000000', 'consum', 0.0224, 'lps'),
	(475344, 125, '2015-04-01 00:19:58.000000', 'consum', 0.0223, 'lps'),
	(475345, 125, '2015-04-01 00:19:59.000000', 'consum', 0.0232, 'lps'),
	(475346, 125, '2015-04-01 00:20:00.000000', 'consum', 0.0213, 'lps'),
	(475347, 125, '2015-04-01 00:20:01.000000', 'consum', 0.0230, 'lps'),
	(475348, 125, '2015-04-01 00:20:02.000000', 'consum', 0.0230, 'lps'),
	(475349, 125, '2015-04-01 00:20:03.000000', 'consum', 0.0224, 'lps'),
	(475350, 125, '2015-04-01 00:20:04.000000', 'consum', 0.0223, 'lps'),
	(475351, 125, '2015-04-01 00:20:05.000000', 'consum', 0.0211, 'lps'),
	(475352, 125, '2015-04-01 00:20:06.000000', 'consum', 0.0221, 'lps'),
	(475353, 125, '2015-04-01 00:20:07.000000', 'consum', 0.0217, 'lps'),
	(475354, 125, '2015-04-01 00:20:08.000000', 'consum', 0.0212, 'lps'),
	(475355, 125, '2015-04-01 00:20:09.000000', 'consum', 0.0224, 'lps'),
	(475356, 125, '2015-04-01 00:20:10.000000', 'consum', 0.0225, 'lps'),
	(475357, 125, '2015-04-01 00:20:11.000000', 'consum', 0.0222, 'lps'),
	(475358, 125, '2015-04-01 00:20:12.000000', 'consum', 0.0223, 'lps'),
	(475359, 125, '2015-04-01 00:20:13.000000', 'consum', 0.0216, 'lps'),
	(475360, 125, '2015-04-01 00:20:14.000000', 'consum', 0.0228, 'lps'),
	(475361, 125, '2015-04-01 00:20:15.000000', 'consum', 0.0231, 'lps'),
	(475362, 125, '2015-04-01 00:20:16.000000', 'consum', 0.0216, 'lps'),
	(475363, 125, '2015-04-01 00:20:17.000000', 'consum', 0.0226, 'lps'),
	(475364, 125, '2015-04-01 00:20:18.000000', 'consum', 0.0222, 'lps'),
	(475365, 125, '2015-04-01 00:20:19.000000', 'consum', 0.0224, 'lps'),
	(475366, 125, '2015-04-01 00:20:20.000000', 'consum', 0.0221, 'lps'),
	(475367, 125, '2015-04-01 00:20:21.000000', 'consum', 0.0224, 'lps'),
	(475368, 125, '2015-04-01 00:20:22.000000', 'consum', 0.0224, 'lps'),
	(475369, 125, '2015-04-01 00:20:23.000000', 'consum', 0.0212, 'lps'),
	(475370, 125, '2015-04-01 00:20:24.000000', 'consum', 0.0227, 'lps'),
	(475371, 125, '2015-04-01 00:20:25.000000', 'consum', 0.0217, 'lps'),
	(475372, 125, '2015-04-01 00:20:26.000000', 'consum', 0.0221, 'lps'),
	(475373, 125, '2015-04-01 00:20:27.000000', 'consum', 0.0218, 'lps'),
	(475374, 125, '2015-04-01 00:20:28.000000', 'consum', 0.0218, 'lps'),
	(475375, 125, '2015-04-01 00:20:29.000000', 'consum', 0.0225, 'lps'),
	(475376, 125, '2015-04-01 00:20:30.000000', 'consum', 0.0213, 'lps'),
	(475377, 125, '2015-04-01 00:20:31.000000', 'consum', 0.0230, 'lps'),
	(475378, 125, '2015-04-01 00:20:32.000000', 'consum', 0.0230, 'lps'),
	(475379, 125, '2015-04-01 00:20:33.000000', 'consum', 0.0225, 'lps'),
	(475380, 125, '2015-04-01 00:20:34.000000', 'consum', 0.0228, 'lps'),
	(475381, 125, '2015-04-01 00:20:35.000000', 'consum', 0.0228, 'lps'),
	(475382, 125, '2015-04-01 00:20:36.000000', 'consum', 0.0226, 'lps'),
	(475383, 125, '2015-04-01 00:20:37.000000', 'consum', 0.0210, 'lps'),
	(475384, 125, '2015-04-01 00:20:38.000000', 'consum', 0.0213, 'lps'),
	(475385, 125, '2015-04-01 00:20:39.000000', 'consum', 0.0224, 'lps'),
	(475386, 125, '2015-04-01 00:20:40.000000', 'consum', 0.0225, 'lps'),
	(475387, 125, '2015-04-01 00:20:41.000000', 'consum', 0.0218, 'lps'),
	(475388, 125, '2015-04-01 00:20:42.000000', 'consum', 0.0229, 'lps'),
	(475389, 125, '2015-04-01 00:20:43.000000', 'consum', 0.0232, 'lps'),
	(475390, 125, '2015-04-01 00:20:44.000000', 'consum', 0.0217, 'lps'),
	(475391, 125, '2015-04-01 00:20:45.000000', 'consum', 0.0229, 'lps'),
	(475392, 125, '2015-04-01 00:20:46.000000', 'consum', 0.0233, 'lps'),
	(475393, 125, '2015-04-01 00:20:47.000000', 'consum', 0.0224, 'lps'),
	(475394, 125, '2015-04-01 00:20:48.000000', 'consum', 0.0210, 'lps'),
	(475395, 125, '2015-04-01 00:20:49.000000', 'consum', 0.0215, 'lps'),
	(475396, 125, '2015-04-01 00:20:50.000000', 'consum', 0.0213, 'lps'),
	(475397, 125, '2015-04-01 00:20:51.000000', 'consum', 0.0211, 'lps'),
	(475398, 125, '2015-04-01 00:20:52.000000', 'consum', 0.0229, 'lps'),
	(475399, 125, '2015-04-01 00:20:53.000000', 'consum', 0.0232, 'lps'),
	(475400, 125, '2015-04-01 00:20:54.000000', 'consum', 0.0215, 'lps'),
	(475401, 125, '2015-04-01 00:20:55.000000', 'consum', 0.0215, 'lps'),
	(475402, 125, '2015-04-01 00:20:56.000000', 'consum', 0.0224, 'lps'),
	(475403, 125, '2015-04-01 00:20:57.000000', 'consum', 0.0215, 'lps'),
	(475404, 125, '2015-04-01 00:20:58.000000', 'consum', 0.0217, 'lps'),
	(475405, 125, '2015-04-01 00:20:59.000000', 'consum', 0.0230, 'lps'),
	(475406, 125, '2015-04-01 00:21:00.000000', 'consum', 0.0218, 'lps'),
	(475407, 125, '2015-04-01 00:21:01.000000', 'consum', 0.0216, 'lps'),
	(475408, 125, '2015-04-01 00:21:02.000000', 'consum', 0.0218, 'lps'),
	(475409, 125, '2015-04-01 00:21:03.000000', 'consum', 0.0230, 'lps'),
	(475410, 125, '2015-04-01 00:21:04.000000', 'consum', 0.0213, 'lps'),
	(475411, 125, '2015-04-01 00:21:05.000000', 'consum', 0.0217, 'lps'),
	(475412, 125, '2015-04-01 00:21:06.000000', 'consum', 0.0211, 'lps'),
	(475413, 125, '2015-04-01 00:21:07.000000', 'consum', 0.0217, 'lps'),
	(475414, 125, '2015-04-01 00:21:08.000000', 'consum', 0.0220, 'lps'),
	(475415, 125, '2015-04-01 00:21:09.000000', 'consum', 0.0215, 'lps'),
	(475416, 125, '2015-04-01 00:21:10.000000', 'consum', 0.0231, 'lps'),
	(475417, 125, '2015-04-01 00:21:11.000000', 'consum', 0.0230, 'lps'),
	(475418, 125, '2015-04-01 00:21:12.000000', 'consum', 0.0220, 'lps'),
	(475419, 125, '2015-04-01 00:21:13.000000', 'consum', 0.0228, 'lps'),
	(475420, 125, '2015-04-01 00:21:14.000000', 'consum', 0.0220, 'lps'),
	(475421, 125, '2015-04-01 00:21:15.000000', 'consum', 0.0230, 'lps'),
	(475422, 125, '2015-04-01 00:21:16.000000', 'consum', 0.0233, 'lps'),
	(475423, 125, '2015-04-01 00:21:17.000000', 'consum', 0.0216, 'lps'),
	(475424, 125, '2015-04-01 00:21:18.000000', 'consum', 0.0220, 'lps'),
	(475425, 125, '2015-04-01 00:21:19.000000', 'consum', 0.0221, 'lps'),
	(475426, 125, '2015-04-01 00:21:20.000000', 'consum', 0.0232, 'lps'),
	(475427, 125, '2015-04-01 00:21:21.000000', 'consum', 0.0219, 'lps'),
	(475428, 125, '2015-04-01 00:21:22.000000', 'consum', 0.0212, 'lps'),
	(475429, 125, '2015-04-01 00:21:23.000000', 'consum', 0.0216, 'lps'),
	(475430, 125, '2015-04-01 00:21:24.000000', 'consum', 0.0212, 'lps'),
	(475431, 125, '2015-04-01 00:21:25.000000', 'consum', 0.0224, 'lps'),
	(475432, 125, '2015-04-01 00:21:26.000000', 'consum', 0.0229, 'lps'),
	(475433, 125, '2015-04-01 00:21:27.000000', 'consum', 0.0215, 'lps'),
	(475434, 125, '2015-04-01 00:21:28.000000', 'consum', 0.0228, 'lps'),
	(475435, 125, '2015-04-01 00:21:29.000000', 'consum', 0.0213, 'lps'),
	(475436, 125, '2015-04-01 00:21:30.000000', 'consum', 0.0220, 'lps'),
	(475437, 125, '2015-04-01 00:21:31.000000', 'consum', 0.0227, 'lps'),
	(475438, 125, '2015-04-01 00:21:32.000000', 'consum', 0.0216, 'lps'),
	(475439, 125, '2015-04-01 00:21:33.000000', 'consum', 0.0216, 'lps'),
	(475440, 125, '2015-04-01 00:21:34.000000', 'consum', 0.0221, 'lps'),
	(475441, 125, '2015-04-01 00:21:35.000000', 'consum', 0.0223, 'lps'),
	(475442, 125, '2015-04-01 00:21:36.000000', 'consum', 0.0217, 'lps'),
	(475443, 125, '2015-04-01 00:21:37.000000', 'consum', 0.0232, 'lps'),
	(475444, 125, '2015-04-01 00:21:38.000000', 'consum', 0.0228, 'lps'),
	(475445, 125, '2015-04-01 00:21:39.000000', 'consum', 0.0233, 'lps'),
	(475446, 125, '2015-04-01 00:21:40.000000', 'consum', 0.0222, 'lps'),
	(475447, 125, '2015-04-01 00:21:41.000000', 'consum', 0.0229, 'lps'),
	(475448, 125, '2015-04-01 00:21:42.000000', 'consum', 0.0219, 'lps'),
	(475449, 125, '2015-04-01 00:21:43.000000', 'consum', 0.0224, 'lps'),
	(475450, 125, '2015-04-01 00:21:44.000000', 'consum', 0.0231, 'lps'),
	(475451, 125, '2015-04-01 00:21:45.000000', 'consum', 0.0223, 'lps'),
	(475452, 125, '2015-04-01 00:21:46.000000', 'consum', 0.0211, 'lps'),
	(475453, 125, '2015-04-01 00:21:47.000000', 'consum', 0.0227, 'lps'),
	(475454, 125, '2015-04-01 00:21:48.000000', 'consum', 0.0220, 'lps'),
	(475455, 125, '2015-04-01 00:21:49.000000', 'consum', 0.0233, 'lps'),
	(475456, 125, '2015-04-01 00:21:50.000000', 'consum', 0.0225, 'lps'),
	(475457, 125, '2015-04-01 00:21:51.000000', 'consum', 0.0215, 'lps'),
	(475458, 125, '2015-04-01 00:21:52.000000', 'consum', 0.0214, 'lps'),
	(475459, 125, '2015-04-01 00:21:53.000000', 'consum', 0.0216, 'lps'),
	(475460, 125, '2015-04-01 00:21:54.000000', 'consum', 0.0228, 'lps'),
	(475461, 125, '2015-04-01 00:21:55.000000', 'consum', 0.0211, 'lps'),
	(475462, 125, '2015-04-01 00:21:56.000000', 'consum', 0.0233, 'lps'),
	(475463, 125, '2015-04-01 00:21:57.000000', 'consum', 0.0227, 'lps'),
	(475464, 125, '2015-04-01 00:21:58.000000', 'consum', 0.0227, 'lps'),
	(475465, 125, '2015-04-01 00:21:59.000000', 'consum', 0.0218, 'lps'),
	(475466, 125, '2015-04-01 00:22:00.000000', 'consum', 0.0226, 'lps'),
	(475467, 125, '2015-04-01 00:22:01.000000', 'consum', 0.0216, 'lps'),
	(475468, 125, '2015-04-01 00:22:02.000000', 'consum', 0.0218, 'lps'),
	(475469, 125, '2015-04-01 00:22:03.000000', 'consum', 0.0233, 'lps'),
	(475470, 125, '2015-04-01 00:22:04.000000', 'consum', 0.0228, 'lps'),
	(475471, 125, '2015-04-01 00:22:05.000000', 'consum', 0.0232, 'lps'),
	(475472, 125, '2015-04-01 00:22:06.000000', 'consum', 0.0218, 'lps'),
	(475473, 125, '2015-04-01 00:22:07.000000', 'consum', 0.0211, 'lps'),
	(475474, 125, '2015-04-01 00:22:08.000000', 'consum', 0.0214, 'lps'),
	(475475, 125, '2015-04-01 00:22:09.000000', 'consum', 0.0228, 'lps'),
	(475476, 125, '2015-04-01 00:22:10.000000', 'consum', 0.0216, 'lps'),
	(475477, 125, '2015-04-01 00:22:11.000000', 'consum', 0.0233, 'lps'),
	(475478, 125, '2015-04-01 00:22:12.000000', 'consum', 0.0214, 'lps'),
	(475479, 125, '2015-04-01 00:22:13.000000', 'consum', 0.0232, 'lps'),
	(475480, 125, '2015-04-01 00:22:14.000000', 'consum', 0.0214, 'lps'),
	(475481, 125, '2015-04-01 00:22:15.000000', 'consum', 0.0211, 'lps'),
	(475482, 125, '2015-04-01 00:22:16.000000', 'consum', 0.0227, 'lps'),
	(475483, 125, '2015-04-01 00:22:17.000000', 'consum', 0.0223, 'lps'),
	(475484, 125, '2015-04-01 00:22:18.000000', 'consum', 0.0225, 'lps'),
	(475485, 125, '2015-04-01 00:22:19.000000', 'consum', 0.0219, 'lps'),
	(475486, 125, '2015-04-01 00:22:20.000000', 'consum', 0.0214, 'lps'),
	(475487, 125, '2015-04-01 00:22:21.000000', 'consum', 0.0224, 'lps'),
	(475488, 125, '2015-04-01 00:22:22.000000', 'consum', 0.0224, 'lps'),
	(475489, 125, '2015-04-01 00:22:23.000000', 'consum', 0.0211, 'lps'),
	(475490, 125, '2015-04-01 00:22:24.000000', 'consum', 0.0223, 'lps'),
	(475491, 125, '2015-04-01 00:22:25.000000', 'consum', 0.0225, 'lps'),
	(475492, 125, '2015-04-01 00:22:26.000000', 'consum', 0.0220, 'lps'),
	(475493, 125, '2015-04-01 00:22:27.000000', 'consum', 0.0218, 'lps'),
	(475494, 125, '2015-04-01 00:22:28.000000', 'consum', 0.0219, 'lps'),
	(475495, 125, '2015-04-01 00:22:29.000000', 'consum', 0.0233, 'lps'),
	(475496, 125, '2015-04-01 00:22:30.000000', 'consum', 0.0228, 'lps'),
	(475497, 125, '2015-04-01 00:22:31.000000', 'consum', 0.0229, 'lps'),
	(475498, 125, '2015-04-01 00:22:32.000000', 'consum', 0.0230, 'lps'),
	(475499, 125, '2015-04-01 00:22:33.000000', 'consum', 0.0227, 'lps'),
	(475500, 125, '2015-04-01 00:22:34.000000', 'consum', 0.0213, 'lps'),
	(475501, 125, '2015-04-01 00:22:35.000000', 'consum', 0.0222, 'lps'),
	(475502, 125, '2015-04-01 00:22:36.000000', 'consum', 0.0213, 'lps'),
	(475503, 125, '2015-04-01 00:22:37.000000', 'consum', 0.0215, 'lps'),
	(475504, 125, '2015-04-01 00:22:38.000000', 'consum', 0.0227, 'lps'),
	(475505, 125, '2015-04-01 00:22:39.000000', 'consum', 0.0231, 'lps'),
	(475506, 125, '2015-04-01 00:22:40.000000', 'consum', 0.0215, 'lps'),
	(475507, 125, '2015-04-01 00:22:41.000000', 'consum', 0.0221, 'lps'),
	(475508, 125, '2015-04-01 00:22:42.000000', 'consum', 0.0228, 'lps'),
	(475509, 125, '2015-04-01 00:22:43.000000', 'consum', 0.0219, 'lps'),
	(475510, 125, '2015-04-01 00:22:44.000000', 'consum', 0.0224, 'lps'),
	(475511, 125, '2015-04-01 00:22:45.000000', 'consum', 0.0229, 'lps'),
	(475512, 125, '2015-04-01 00:22:46.000000', 'consum', 0.0215, 'lps'),
	(475513, 125, '2015-04-01 00:22:47.000000', 'consum', 0.0226, 'lps'),
	(475514, 125, '2015-04-01 00:22:48.000000', 'consum', 0.0229, 'lps'),
	(475515, 125, '2015-04-01 00:22:49.000000', 'consum', 0.0211, 'lps'),
	(475516, 125, '2015-04-01 00:22:50.000000', 'consum', 0.0231, 'lps'),
	(475517, 125, '2015-04-01 00:22:51.000000', 'consum', 0.0214, 'lps'),
	(475518, 125, '2015-04-01 00:22:52.000000', 'consum', 0.0216, 'lps'),
	(475519, 125, '2015-04-01 00:22:53.000000', 'consum', 0.0229, 'lps'),
	(475520, 125, '2015-04-01 00:22:54.000000', 'consum', 0.0216, 'lps'),
	(475521, 125, '2015-04-01 00:22:55.000000', 'consum', 0.0233, 'lps'),
	(475522, 125, '2015-04-01 00:22:56.000000', 'consum', 0.0233, 'lps'),
	(475523, 125, '2015-04-01 00:22:57.000000', 'consum', 0.0232, 'lps'),
	(475524, 125, '2015-04-01 00:22:58.000000', 'consum', 0.0227, 'lps'),
	(475525, 125, '2015-04-01 00:22:59.000000', 'consum', 0.0233, 'lps'),
	(475526, 125, '2015-04-01 00:23:00.000000', 'consum', 0.0223, 'lps'),
	(475527, 125, '2015-04-01 00:23:01.000000', 'consum', 0.0231, 'lps'),
	(475528, 125, '2015-04-01 00:23:02.000000', 'consum', 0.0228, 'lps'),
	(475529, 125, '2015-04-01 00:23:03.000000', 'consum', 0.0213, 'lps'),
	(475530, 125, '2015-04-01 00:23:04.000000', 'consum', 0.0220, 'lps'),
	(475531, 125, '2015-04-01 00:23:05.000000', 'consum', 0.0226, 'lps'),
	(475532, 125, '2015-04-01 00:23:06.000000', 'consum', 0.0214, 'lps'),
	(475533, 125, '2015-04-01 00:23:07.000000', 'consum', 0.0230, 'lps'),
	(475534, 125, '2015-04-01 00:23:08.000000', 'consum', 0.0225, 'lps'),
	(475535, 125, '2015-04-01 00:23:09.000000', 'consum', 0.0226, 'lps'),
	(475536, 125, '2015-04-01 00:23:10.000000', 'consum', 0.0221, 'lps'),
	(475537, 125, '2015-04-01 00:23:11.000000', 'consum', 0.0216, 'lps'),
	(475538, 125, '2015-04-01 00:23:12.000000', 'consum', 0.0210, 'lps'),
	(475539, 125, '2015-04-01 00:23:13.000000', 'consum', 0.0216, 'lps'),
	(475540, 125, '2015-04-01 00:23:14.000000', 'consum', 0.0216, 'lps'),
	(475541, 125, '2015-04-01 00:23:15.000000', 'consum', 0.0221, 'lps'),
	(475542, 125, '2015-04-01 00:23:16.000000', 'consum', 0.0226, 'lps'),
	(475543, 125, '2015-04-01 00:23:17.000000', 'consum', 0.0210, 'lps'),
	(475544, 125, '2015-04-01 00:23:18.000000', 'consum', 0.0232, 'lps'),
	(475545, 125, '2015-04-01 00:23:19.000000', 'consum', 0.0226, 'lps'),
	(475546, 125, '2015-04-01 00:23:20.000000', 'consum', 0.0223, 'lps'),
	(475547, 125, '2015-04-01 00:23:21.000000', 'consum', 0.0230, 'lps'),
	(475548, 125, '2015-04-01 00:23:22.000000', 'consum', 0.0220, 'lps'),
	(475549, 125, '2015-04-01 00:23:23.000000', 'consum', 0.0228, 'lps'),
	(475550, 125, '2015-04-01 00:23:24.000000', 'consum', 0.0221, 'lps'),
	(475551, 125, '2015-04-01 00:23:25.000000', 'consum', 0.0210, 'lps'),
	(475552, 125, '2015-04-01 00:23:26.000000', 'consum', 0.0227, 'lps'),
	(475553, 125, '2015-04-01 00:23:27.000000', 'consum', 0.0224, 'lps'),
	(475554, 125, '2015-04-01 00:23:28.000000', 'consum', 0.0231, 'lps'),
	(475555, 125, '2015-04-01 00:23:29.000000', 'consum', 0.0223, 'lps'),
	(475556, 125, '2015-04-01 00:23:30.000000', 'consum', 0.0212, 'lps'),
	(475557, 125, '2015-04-01 00:23:31.000000', 'consum', 0.0231, 'lps'),
	(475558, 125, '2015-04-01 00:23:32.000000', 'consum', 0.0213, 'lps'),
	(475559, 125, '2015-04-01 00:23:33.000000', 'consum', 0.0211, 'lps'),
	(475560, 125, '2015-04-01 00:23:34.000000', 'consum', 0.0231, 'lps'),
	(475561, 125, '2015-04-01 00:23:35.000000', 'consum', 0.0215, 'lps'),
	(475562, 125, '2015-04-01 00:23:36.000000', 'consum', 0.0222, 'lps'),
	(475563, 125, '2015-04-01 00:23:37.000000', 'consum', 0.0231, 'lps'),
	(475564, 125, '2015-04-01 00:23:38.000000', 'consum', 0.0230, 'lps'),
	(475565, 125, '2015-04-01 00:23:39.000000', 'consum', 0.0223, 'lps'),
	(475566, 125, '2015-04-01 00:23:40.000000', 'consum', 0.0216, 'lps'),
	(475567, 125, '2015-04-01 00:23:41.000000', 'consum', 0.0226, 'lps'),
	(475568, 125, '2015-04-01 00:23:42.000000', 'consum', 0.0225, 'lps'),
	(475569, 125, '2015-04-01 00:23:43.000000', 'consum', 0.0214, 'lps'),
	(475570, 125, '2015-04-01 00:23:44.000000', 'consum', 0.0233, 'lps'),
	(475571, 125, '2015-04-01 00:23:45.000000', 'consum', 0.0217, 'lps'),
	(475572, 125, '2015-04-01 00:23:46.000000', 'consum', 0.0224, 'lps'),
	(475573, 125, '2015-04-01 00:23:47.000000', 'consum', 0.0212, 'lps'),
	(475574, 125, '2015-04-01 00:23:48.000000', 'consum', 0.0228, 'lps'),
	(475575, 125, '2015-04-01 00:23:49.000000', 'consum', 0.0219, 'lps'),
	(475576, 125, '2015-04-01 00:23:50.000000', 'consum', 0.0229, 'lps'),
	(475577, 125, '2015-04-01 00:23:51.000000', 'consum', 0.0229, 'lps'),
	(475578, 125, '2015-04-01 00:23:52.000000', 'consum', 0.0223, 'lps'),
	(475579, 125, '2015-04-01 00:23:53.000000', 'consum', 0.0219, 'lps'),
	(475580, 125, '2015-04-01 00:23:54.000000', 'consum', 0.0217, 'lps'),
	(475581, 125, '2015-04-01 00:23:55.000000', 'consum', 0.0217, 'lps'),
	(475582, 125, '2015-04-01 00:23:56.000000', 'consum', 0.0223, 'lps'),
	(475583, 125, '2015-04-01 00:23:57.000000', 'consum', 0.0210, 'lps'),
	(475584, 125, '2015-04-01 00:23:58.000000', 'consum', 0.0218, 'lps'),
	(475585, 125, '2015-04-01 00:23:59.000000', 'consum', 0.0228, 'lps'),
	(475586, 125, '2015-04-01 00:24:00.000000', 'consum', 0.0226, 'lps'),
	(475587, 125, '2015-04-01 00:24:01.000000', 'consum', 0.0215, 'lps'),
	(475588, 125, '2015-04-01 00:24:02.000000', 'consum', 0.0211, 'lps'),
	(475589, 125, '2015-04-01 00:24:03.000000', 'consum', 0.0223, 'lps'),
	(475590, 125, '2015-04-01 00:24:04.000000', 'consum', 0.0227, 'lps'),
	(475591, 125, '2015-04-01 00:24:05.000000', 'consum', 0.0233, 'lps'),
	(475592, 125, '2015-04-01 00:24:06.000000', 'consum', 0.0224, 'lps'),
	(475593, 125, '2015-04-01 00:24:07.000000', 'consum', 0.0212, 'lps'),
	(475594, 125, '2015-04-01 00:24:08.000000', 'consum', 0.0229, 'lps'),
	(475595, 125, '2015-04-01 00:24:09.000000', 'consum', 0.0224, 'lps'),
	(475596, 125, '2015-04-01 00:24:10.000000', 'consum', 0.0226, 'lps'),
	(475597, 125, '2015-04-01 00:24:11.000000', 'consum', 0.0224, 'lps'),
	(475598, 125, '2015-04-01 00:24:12.000000', 'consum', 0.0233, 'lps'),
	(475599, 125, '2015-04-01 00:24:13.000000', 'consum', 0.0210, 'lps'),
	(475600, 125, '2015-04-01 00:24:14.000000', 'consum', 0.0214, 'lps'),
	(475601, 125, '2015-04-01 00:24:15.000000', 'consum', 0.0232, 'lps'),
	(475602, 125, '2015-04-01 00:24:16.000000', 'consum', 0.0211, 'lps'),
	(475603, 125, '2015-04-01 00:24:17.000000', 'consum', 0.0223, 'lps'),
	(475604, 125, '2015-04-01 00:24:18.000000', 'consum', 0.0224, 'lps'),
	(475605, 125, '2015-04-01 00:24:19.000000', 'consum', 0.0219, 'lps'),
	(475606, 125, '2015-04-01 00:24:20.000000', 'consum', 0.0211, 'lps'),
	(475607, 125, '2015-04-01 00:24:21.000000', 'consum', 0.0213, 'lps'),
	(475608, 125, '2015-04-01 00:24:22.000000', 'consum', 0.0223, 'lps'),
	(475609, 125, '2015-04-01 00:24:23.000000', 'consum', 0.0218, 'lps'),
	(475610, 125, '2015-04-01 00:24:24.000000', 'consum', 0.0213, 'lps'),
	(475611, 125, '2015-04-01 00:24:25.000000', 'consum', 0.0225, 'lps'),
	(475612, 125, '2015-04-01 00:24:26.000000', 'consum', 0.0229, 'lps'),
	(475613, 125, '2015-04-01 00:24:27.000000', 'consum', 0.0213, 'lps'),
	(475614, 125, '2015-04-01 00:24:28.000000', 'consum', 0.0214, 'lps'),
	(475615, 125, '2015-04-01 00:24:29.000000', 'consum', 0.0222, 'lps'),
	(475616, 125, '2015-04-01 00:24:30.000000', 'consum', 0.0213, 'lps'),
	(475617, 125, '2015-04-01 00:24:31.000000', 'consum', 0.0210, 'lps'),
	(475618, 125, '2015-04-01 00:24:32.000000', 'consum', 0.0229, 'lps'),
	(475619, 125, '2015-04-01 00:24:33.000000', 'consum', 0.0231, 'lps'),
	(475620, 125, '2015-04-01 00:24:34.000000', 'consum', 0.0213, 'lps'),
	(475621, 125, '2015-04-01 00:24:35.000000', 'consum', 0.0211, 'lps'),
	(475622, 125, '2015-04-01 00:24:36.000000', 'consum', 0.0228, 'lps'),
	(475623, 125, '2015-04-01 00:24:37.000000', 'consum', 0.0228, 'lps'),
	(475624, 125, '2015-04-01 00:24:38.000000', 'consum', 0.0221, 'lps'),
	(475625, 125, '2015-04-01 00:24:39.000000', 'consum', 0.0212, 'lps'),
	(475626, 125, '2015-04-01 00:24:40.000000', 'consum', 0.0213, 'lps'),
	(475627, 125, '2015-04-01 00:24:41.000000', 'consum', 0.0218, 'lps'),
	(475628, 125, '2015-04-01 00:24:42.000000', 'consum', 0.0217, 'lps'),
	(475629, 125, '2015-04-01 00:24:43.000000', 'consum', 0.0223, 'lps'),
	(475630, 125, '2015-04-01 00:24:44.000000', 'consum', 0.0231, 'lps'),
	(475631, 125, '2015-04-01 00:24:45.000000', 'consum', 0.0227, 'lps'),
	(475632, 125, '2015-04-01 00:24:46.000000', 'consum', 0.0233, 'lps'),
	(475633, 125, '2015-04-01 00:24:47.000000', 'consum', 0.0226, 'lps'),
	(475634, 125, '2015-04-01 00:24:48.000000', 'consum', 0.0223, 'lps'),
	(475635, 125, '2015-04-01 00:24:49.000000', 'consum', 0.0228, 'lps'),
	(475636, 125, '2015-04-01 00:24:50.000000', 'consum', 0.0212, 'lps'),
	(475637, 125, '2015-04-01 00:24:51.000000', 'consum', 0.0214, 'lps'),
	(475638, 125, '2015-04-01 00:24:52.000000', 'consum', 0.0227, 'lps'),
	(475639, 125, '2015-04-01 00:24:53.000000', 'consum', 0.0233, 'lps'),
	(475640, 125, '2015-04-01 00:24:54.000000', 'consum', 0.0227, 'lps'),
	(475641, 125, '2015-04-01 00:24:55.000000', 'consum', 0.0228, 'lps'),
	(475642, 125, '2015-04-01 00:24:56.000000', 'consum', 0.0226, 'lps'),
	(475643, 125, '2015-04-01 00:24:57.000000', 'consum', 0.0210, 'lps'),
	(475644, 125, '2015-04-01 00:24:58.000000', 'consum', 0.0213, 'lps'),
	(475645, 125, '2015-04-01 00:24:59.000000', 'consum', 0.0224, 'lps'),
	(475646, 125, '2015-04-01 00:25:00.000000', 'consum', 0.0222, 'lps'),
	(475647, 125, '2015-04-01 00:25:01.000000', 'consum', 0.0229, 'lps'),
	(475648, 125, '2015-04-01 00:25:02.000000', 'consum', 0.0221, 'lps'),
	(475649, 125, '2015-04-01 00:25:03.000000', 'consum', 0.0232, 'lps'),
	(475650, 125, '2015-04-01 00:25:04.000000', 'consum', 0.0218, 'lps'),
	(475651, 125, '2015-04-01 00:25:05.000000', 'consum', 0.0232, 'lps'),
	(475652, 125, '2015-04-01 00:25:06.000000', 'consum', 0.0224, 'lps'),
	(475653, 125, '2015-04-01 00:25:07.000000', 'consum', 0.0214, 'lps'),
	(475654, 125, '2015-04-01 00:25:08.000000', 'consum', 0.0214, 'lps'),
	(475655, 125, '2015-04-01 00:25:09.000000', 'consum', 0.0217, 'lps'),
	(475656, 125, '2015-04-01 00:25:10.000000', 'consum', 0.0211, 'lps'),
	(475657, 125, '2015-04-01 00:25:11.000000', 'consum', 0.0220, 'lps'),
	(475658, 125, '2015-04-01 00:25:12.000000', 'consum', 0.0231, 'lps'),
	(475659, 125, '2015-04-01 00:25:13.000000', 'consum', 0.0212, 'lps'),
	(475660, 125, '2015-04-01 00:25:14.000000', 'consum', 0.0231, 'lps'),
	(475661, 125, '2015-04-01 00:25:15.000000', 'consum', 0.0214, 'lps'),
	(475662, 125, '2015-04-01 00:25:16.000000', 'consum', 0.0217, 'lps'),
	(475663, 125, '2015-04-01 00:25:17.000000', 'consum', 0.0232, 'lps'),
	(475664, 125, '2015-04-01 00:25:18.000000', 'consum', 0.0226, 'lps'),
	(475665, 125, '2015-04-01 00:25:19.000000', 'consum', 0.0225, 'lps'),
	(475666, 125, '2015-04-01 00:25:20.000000', 'consum', 0.0213, 'lps'),
	(475667, 125, '2015-04-01 00:25:21.000000', 'consum', 0.0231, 'lps'),
	(475668, 125, '2015-04-01 00:25:22.000000', 'consum', 0.0233, 'lps'),
	(475669, 125, '2015-04-01 00:25:23.000000', 'consum', 0.0214, 'lps'),
	(475670, 125, '2015-04-01 00:25:24.000000', 'consum', 0.0233, 'lps'),
	(475671, 125, '2015-04-01 00:25:25.000000', 'consum', 0.0218, 'lps'),
	(475672, 125, '2015-04-01 00:25:26.000000', 'consum', 0.0229, 'lps'),
	(475673, 125, '2015-04-01 00:25:27.000000', 'consum', 0.0211, 'lps'),
	(475674, 125, '2015-04-01 00:25:28.000000', 'consum', 0.0231, 'lps'),
	(475675, 125, '2015-04-01 00:25:29.000000', 'consum', 0.0217, 'lps'),
	(475676, 125, '2015-04-01 00:25:30.000000', 'consum', 0.0228, 'lps'),
	(475677, 125, '2015-04-01 00:25:31.000000', 'consum', 0.0233, 'lps'),
	(475678, 125, '2015-04-01 00:25:32.000000', 'consum', 0.0224, 'lps'),
	(475679, 125, '2015-04-01 00:25:33.000000', 'consum', 0.0211, 'lps'),
	(475680, 125, '2015-04-01 00:25:34.000000', 'consum', 0.0222, 'lps'),
	(475681, 125, '2015-04-01 00:25:35.000000', 'consum', 0.0221, 'lps'),
	(475682, 125, '2015-04-01 00:25:36.000000', 'consum', 0.0229, 'lps'),
	(475683, 125, '2015-04-01 00:25:37.000000', 'consum', 0.0222, 'lps'),
	(475684, 125, '2015-04-01 00:25:38.000000', 'consum', 0.0215, 'lps'),
	(475685, 125, '2015-04-01 00:25:39.000000', 'consum', 0.0222, 'lps'),
	(475686, 125, '2015-04-01 00:25:40.000000', 'consum', 0.0210, 'lps'),
	(475687, 125, '2015-04-01 00:25:41.000000', 'consum', 0.0222, 'lps'),
	(475688, 125, '2015-04-01 00:25:42.000000', 'consum', 0.0224, 'lps'),
	(475689, 125, '2015-04-01 00:25:43.000000', 'consum', 0.0219, 'lps'),
	(475690, 125, '2015-04-01 00:25:44.000000', 'consum', 0.0212, 'lps'),
	(475691, 125, '2015-04-01 00:25:45.000000', 'consum', 0.0218, 'lps'),
	(475692, 125, '2015-04-01 00:25:46.000000', 'consum', 0.0223, 'lps'),
	(475693, 125, '2015-04-01 00:25:47.000000', 'consum', 0.0225, 'lps'),
	(475694, 125, '2015-04-01 00:25:48.000000', 'consum', 0.0225, 'lps'),
	(475695, 125, '2015-04-01 00:25:49.000000', 'consum', 0.0216, 'lps'),
	(475696, 125, '2015-04-01 00:25:50.000000', 'consum', 0.0218, 'lps'),
	(475697, 125, '2015-04-01 00:25:51.000000', 'consum', 0.0231, 'lps'),
	(475698, 125, '2015-04-01 00:25:52.000000', 'consum', 0.0223, 'lps'),
	(475699, 125, '2015-04-01 00:25:53.000000', 'consum', 0.0211, 'lps'),
	(475700, 125, '2015-04-01 00:25:54.000000', 'consum', 0.0226, 'lps'),
	(475701, 125, '2015-04-01 00:25:55.000000', 'consum', 0.0215, 'lps'),
	(475702, 125, '2015-04-01 00:25:56.000000', 'consum', 0.0212, 'lps'),
	(475703, 125, '2015-04-01 00:25:57.000000', 'consum', 0.0229, 'lps'),
	(475704, 125, '2015-04-01 00:25:58.000000', 'consum', 0.0228, 'lps'),
	(475705, 125, '2015-04-01 00:25:59.000000', 'consum', 0.0217, 'lps'),
	(475706, 125, '2015-04-01 00:26:00.000000', 'consum', 0.0218, 'lps'),
	(475707, 125, '2015-04-01 00:26:01.000000', 'consum', 0.0230, 'lps'),
	(475708, 125, '2015-04-01 00:26:02.000000', 'consum', 0.0213, 'lps'),
	(475709, 125, '2015-04-01 00:26:03.000000', 'consum', 0.0216, 'lps'),
	(475710, 125, '2015-04-01 00:26:04.000000', 'consum', 0.0228, 'lps'),
	(475711, 125, '2015-04-01 00:26:05.000000', 'consum', 0.0213, 'lps'),
	(475712, 125, '2015-04-01 00:26:06.000000', 'consum', 0.0220, 'lps'),
	(475713, 125, '2015-04-01 00:26:07.000000', 'consum', 0.0226, 'lps'),
	(475714, 125, '2015-04-01 00:26:08.000000', 'consum', 0.0215, 'lps'),
	(475715, 125, '2015-04-01 00:26:09.000000', 'consum', 0.0210, 'lps'),
	(475716, 125, '2015-04-01 00:26:10.000000', 'consum', 0.0220, 'lps'),
	(475717, 125, '2015-04-01 00:26:11.000000', 'consum', 0.0211, 'lps'),
	(475718, 125, '2015-04-01 00:26:12.000000', 'consum', 0.0211, 'lps'),
	(475719, 125, '2015-04-01 00:26:13.000000', 'consum', 0.0212, 'lps'),
	(475720, 125, '2015-04-01 00:26:14.000000', 'consum', 0.0219, 'lps'),
	(475721, 125, '2015-04-01 00:26:15.000000', 'consum', 0.0224, 'lps'),
	(475722, 125, '2015-04-01 00:26:16.000000', 'consum', 0.0229, 'lps'),
	(475723, 125, '2015-04-01 00:26:17.000000', 'consum', 0.0214, 'lps'),
	(475724, 125, '2015-04-01 00:26:18.000000', 'consum', 0.0223, 'lps'),
	(475725, 125, '2015-04-01 00:26:19.000000', 'consum', 0.0216, 'lps'),
	(475726, 125, '2015-04-01 00:26:20.000000', 'consum', 0.0224, 'lps'),
	(475727, 125, '2015-04-01 00:26:21.000000', 'consum', 0.0214, 'lps'),
	(475728, 125, '2015-04-01 00:26:22.000000', 'consum', 0.0215, 'lps'),
	(475729, 125, '2015-04-01 00:26:23.000000', 'consum', 0.0223, 'lps'),
	(475730, 125, '2015-04-01 00:26:24.000000', 'consum', 0.0213, 'lps'),
	(475731, 125, '2015-04-01 00:26:25.000000', 'consum', 0.0212, 'lps'),
	(475732, 125, '2015-04-01 00:26:26.000000', 'consum', 0.0232, 'lps'),
	(475733, 125, '2015-04-01 00:26:27.000000', 'consum', 0.0221, 'lps'),
	(475734, 125, '2015-04-01 00:26:28.000000', 'consum', 0.0221, 'lps'),
	(475735, 125, '2015-04-01 00:26:29.000000', 'consum', 0.0210, 'lps'),
	(475736, 125, '2015-04-01 00:26:30.000000', 'consum', 0.0224, 'lps'),
	(475737, 125, '2015-04-01 00:26:31.000000', 'consum', 0.0233, 'lps'),
	(475738, 125, '2015-04-01 00:26:32.000000', 'consum', 0.0210, 'lps'),
	(475739, 125, '2015-04-01 00:26:33.000000', 'consum', 0.0215, 'lps'),
	(475740, 125, '2015-04-01 00:26:34.000000', 'consum', 0.0210, 'lps'),
	(475741, 125, '2015-04-01 00:26:35.000000', 'consum', 0.0222, 'lps'),
	(475742, 125, '2015-04-01 00:26:36.000000', 'consum', 0.0219, 'lps'),
	(475743, 125, '2015-04-01 00:26:37.000000', 'consum', 0.0223, 'lps'),
	(475744, 125, '2015-04-01 00:26:38.000000', 'consum', 0.0223, 'lps'),
	(475745, 125, '2015-04-01 00:26:39.000000', 'consum', 0.0211, 'lps'),
	(475746, 125, '2015-04-01 00:26:40.000000', 'consum', 0.0227, 'lps'),
	(475747, 125, '2015-04-01 00:26:41.000000', 'consum', 0.0218, 'lps'),
	(475748, 125, '2015-04-01 00:26:42.000000', 'consum', 0.0224, 'lps'),
	(475749, 125, '2015-04-01 00:26:43.000000', 'consum', 0.0232, 'lps'),
	(475750, 125, '2015-04-01 00:26:44.000000', 'consum', 0.0230, 'lps'),
	(475751, 125, '2015-04-01 00:26:45.000000', 'consum', 0.0221, 'lps'),
	(475752, 125, '2015-04-01 00:26:46.000000', 'consum', 0.0230, 'lps'),
	(475753, 125, '2015-04-01 00:26:47.000000', 'consum', 0.0229, 'lps'),
	(475754, 125, '2015-04-01 00:26:48.000000', 'consum', 0.0222, 'lps'),
	(475755, 125, '2015-04-01 00:26:49.000000', 'consum', 0.0212, 'lps'),
	(475756, 125, '2015-04-01 00:26:50.000000', 'consum', 0.0210, 'lps'),
	(475757, 125, '2015-04-01 00:26:51.000000', 'consum', 0.0230, 'lps'),
	(475758, 125, '2015-04-01 00:26:52.000000', 'consum', 0.0211, 'lps'),
	(475759, 125, '2015-04-01 00:26:53.000000', 'consum', 0.0231, 'lps'),
	(475760, 125, '2015-04-01 00:26:54.000000', 'consum', 0.0215, 'lps'),
	(475761, 125, '2015-04-01 00:26:55.000000', 'consum', 0.0222, 'lps'),
	(475762, 125, '2015-04-01 00:26:56.000000', 'consum', 0.0228, 'lps'),
	(475763, 125, '2015-04-01 00:26:57.000000', 'consum', 0.0220, 'lps'),
	(475764, 125, '2015-04-01 00:26:58.000000', 'consum', 0.0231, 'lps'),
	(475765, 125, '2015-04-01 00:26:59.000000', 'consum', 0.0212, 'lps'),
	(475766, 125, '2015-04-01 00:27:00.000000', 'consum', 0.0228, 'lps'),
	(475767, 125, '2015-04-01 00:27:01.000000', 'consum', 0.0224, 'lps'),
	(475768, 125, '2015-04-01 00:27:02.000000', 'consum', 0.0227, 'lps'),
	(475769, 125, '2015-04-01 00:27:03.000000', 'consum', 0.0230, 'lps'),
	(475770, 125, '2015-04-01 00:27:04.000000', 'consum', 0.0210, 'lps'),
	(475771, 125, '2015-04-01 00:27:05.000000', 'consum', 0.0223, 'lps'),
	(475772, 125, '2015-04-01 00:27:06.000000', 'consum', 0.0227, 'lps'),
	(475773, 125, '2015-04-01 00:27:07.000000', 'consum', 0.0232, 'lps'),
	(475774, 125, '2015-04-01 00:27:08.000000', 'consum', 0.0221, 'lps'),
	(475775, 125, '2015-04-01 00:27:09.000000', 'consum', 0.0224, 'lps'),
	(475776, 125, '2015-04-01 00:27:10.000000', 'consum', 0.0225, 'lps'),
	(475777, 125, '2015-04-01 00:27:11.000000', 'consum', 0.0220, 'lps'),
	(475778, 125, '2015-04-01 00:27:12.000000', 'consum', 0.0215, 'lps'),
	(475779, 125, '2015-04-01 00:27:13.000000', 'consum', 0.0228, 'lps'),
	(475780, 125, '2015-04-01 00:27:14.000000', 'consum', 0.0214, 'lps'),
	(475781, 125, '2015-04-01 00:27:15.000000', 'consum', 0.0224, 'lps'),
	(475782, 125, '2015-04-01 00:27:16.000000', 'consum', 0.0220, 'lps'),
	(475783, 125, '2015-04-01 00:27:17.000000', 'consum', 0.0220, 'lps'),
	(475784, 125, '2015-04-01 00:27:18.000000', 'consum', 0.0230, 'lps'),
	(475785, 125, '2015-04-01 00:27:19.000000', 'consum', 0.0231, 'lps'),
	(475786, 125, '2015-04-01 00:27:20.000000', 'consum', 0.0233, 'lps'),
	(475787, 125, '2015-04-01 00:27:21.000000', 'consum', 0.0214, 'lps'),
	(475788, 125, '2015-04-01 00:27:22.000000', 'consum', 0.0210, 'lps'),
	(475789, 125, '2015-04-01 00:27:23.000000', 'consum', 0.0224, 'lps'),
	(475790, 125, '2015-04-01 00:27:24.000000', 'consum', 0.0231, 'lps'),
	(475791, 125, '2015-04-01 00:27:25.000000', 'consum', 0.0224, 'lps'),
	(475792, 125, '2015-04-01 00:27:26.000000', 'consum', 0.0219, 'lps'),
	(475793, 125, '2015-04-01 00:27:27.000000', 'consum', 0.0212, 'lps'),
	(475794, 125, '2015-04-01 00:27:28.000000', 'consum', 0.0219, 'lps'),
	(475795, 125, '2015-04-01 00:27:29.000000', 'consum', 0.0224, 'lps'),
	(475796, 125, '2015-04-01 00:27:30.000000', 'consum', 0.0230, 'lps'),
	(475797, 125, '2015-04-01 00:27:31.000000', 'consum', 0.0220, 'lps'),
	(475798, 125, '2015-04-01 00:27:32.000000', 'consum', 0.0226, 'lps'),
	(475799, 125, '2015-04-01 00:27:33.000000', 'consum', 0.0210, 'lps'),
	(475800, 125, '2015-04-01 00:27:34.000000', 'consum', 0.0211, 'lps'),
	(475801, 125, '2015-04-01 00:27:35.000000', 'consum', 0.0218, 'lps'),
	(475802, 125, '2015-04-01 00:27:36.000000', 'consum', 0.0222, 'lps'),
	(475803, 125, '2015-04-01 00:27:37.000000', 'consum', 0.0224, 'lps'),
	(475804, 125, '2015-04-01 00:27:38.000000', 'consum', 0.0218, 'lps'),
	(475805, 125, '2015-04-01 00:27:39.000000', 'consum', 0.0233, 'lps'),
	(475806, 125, '2015-04-01 00:27:40.000000', 'consum', 0.0232, 'lps'),
	(475807, 125, '2015-04-01 00:27:41.000000', 'consum', 0.0224, 'lps'),
	(475808, 125, '2015-04-01 00:27:42.000000', 'consum', 0.0216, 'lps'),
	(475809, 125, '2015-04-01 00:27:43.000000', 'consum', 0.0221, 'lps'),
	(475810, 125, '2015-04-01 00:27:44.000000', 'consum', 0.0226, 'lps'),
	(475811, 125, '2015-04-01 00:27:45.000000', 'consum', 0.0231, 'lps'),
	(475812, 125, '2015-04-01 00:27:46.000000', 'consum', 0.0221, 'lps'),
	(475813, 125, '2015-04-01 00:27:47.000000', 'consum', 0.0224, 'lps'),
	(475814, 125, '2015-04-01 00:27:48.000000', 'consum', 0.0225, 'lps'),
	(475815, 125, '2015-04-01 00:27:49.000000', 'consum', 0.0221, 'lps'),
	(475816, 125, '2015-04-01 00:27:50.000000', 'consum', 0.0218, 'lps'),
	(475817, 125, '2015-04-01 00:27:51.000000', 'consum', 0.0218, 'lps'),
	(475818, 125, '2015-04-01 00:27:52.000000', 'consum', 0.0228, 'lps'),
	(475819, 125, '2015-04-01 00:27:53.000000', 'consum', 0.0229, 'lps'),
	(475820, 125, '2015-04-01 00:27:54.000000', 'consum', 0.0227, 'lps'),
	(475821, 125, '2015-04-01 00:27:55.000000', 'consum', 0.0216, 'lps'),
	(475822, 125, '2015-04-01 00:27:56.000000', 'consum', 0.0210, 'lps'),
	(475823, 125, '2015-04-01 00:27:57.000000', 'consum', 0.0220, 'lps'),
	(475824, 125, '2015-04-01 00:27:58.000000', 'consum', 0.0211, 'lps'),
	(475825, 125, '2015-04-01 00:27:59.000000', 'consum', 0.0212, 'lps'),
	(475826, 125, '2015-04-01 00:28:00.000000', 'consum', 0.0214, 'lps'),
	(475827, 125, '2015-04-01 00:28:01.000000', 'consum', 0.0227, 'lps'),
	(475828, 125, '2015-04-01 00:28:02.000000', 'consum', 0.0233, 'lps'),
	(475829, 125, '2015-04-01 00:28:03.000000', 'consum', 0.0229, 'lps'),
	(475830, 125, '2015-04-01 00:28:04.000000', 'consum', 0.0211, 'lps'),
	(475831, 125, '2015-04-01 00:28:05.000000', 'consum', 0.0230, 'lps'),
	(475832, 125, '2015-04-01 00:28:06.000000', 'consum', 0.0213, 'lps'),
	(475833, 125, '2015-04-01 00:28:07.000000', 'consum', 0.0214, 'lps'),
	(475834, 125, '2015-04-01 00:28:08.000000', 'consum', 0.0219, 'lps'),
	(475835, 125, '2015-04-01 00:28:09.000000', 'consum', 0.0220, 'lps'),
	(475836, 125, '2015-04-01 00:28:10.000000', 'consum', 0.0211, 'lps'),
	(475837, 125, '2015-04-01 00:28:11.000000', 'consum', 0.0232, 'lps'),
	(475838, 125, '2015-04-01 00:28:12.000000', 'consum', 0.0223, 'lps'),
	(475839, 125, '2015-04-01 00:28:13.000000', 'consum', 0.0231, 'lps'),
	(475840, 125, '2015-04-01 00:28:14.000000', 'consum', 0.0230, 'lps'),
	(475841, 125, '2015-04-01 00:28:15.000000', 'consum', 0.0224, 'lps'),
	(475842, 125, '2015-04-01 00:28:16.000000', 'consum', 0.0221, 'lps'),
	(475843, 125, '2015-04-01 00:28:17.000000', 'consum', 0.0222, 'lps'),
	(475844, 125, '2015-04-01 00:28:18.000000', 'consum', 0.0215, 'lps'),
	(475845, 125, '2015-04-01 00:28:19.000000', 'consum', 0.0223, 'lps'),
	(475846, 125, '2015-04-01 00:28:20.000000', 'consum', 0.0213, 'lps'),
	(475847, 125, '2015-04-01 00:28:21.000000', 'consum', 0.0211, 'lps'),
	(475848, 125, '2015-04-01 00:28:22.000000', 'consum', 0.0230, 'lps'),
	(475849, 125, '2015-04-01 00:28:23.000000', 'consum', 0.0210, 'lps'),
	(475850, 125, '2015-04-01 00:28:24.000000', 'consum', 0.0224, 'lps'),
	(475851, 125, '2015-04-01 00:28:25.000000', 'consum', 0.0230, 'lps'),
	(475852, 125, '2015-04-01 00:28:26.000000', 'consum', 0.0222, 'lps'),
	(475853, 125, '2015-04-01 00:28:27.000000', 'consum', 0.0212, 'lps'),
	(475854, 125, '2015-04-01 00:28:28.000000', 'consum', 0.0231, 'lps'),
	(475855, 125, '2015-04-01 00:28:29.000000', 'consum', 0.0213, 'lps'),
	(475856, 125, '2015-04-01 00:28:30.000000', 'consum', 0.0233, 'lps'),
	(475857, 125, '2015-04-01 00:28:31.000000', 'consum', 0.0222, 'lps'),
	(475858, 125, '2015-04-01 00:28:32.000000', 'consum', 0.0226, 'lps'),
	(475859, 125, '2015-04-01 00:28:33.000000', 'consum', 0.0228, 'lps'),
	(475860, 125, '2015-04-01 00:28:34.000000', 'consum', 0.0232, 'lps'),
	(475861, 125, '2015-04-01 00:28:35.000000', 'consum', 0.0216, 'lps'),
	(475862, 125, '2015-04-01 00:28:36.000000', 'consum', 0.0224, 'lps'),
	(475863, 125, '2015-04-01 00:28:37.000000', 'consum', 0.0214, 'lps'),
	(475864, 125, '2015-04-01 00:28:38.000000', 'consum', 0.0214, 'lps'),
	(475865, 125, '2015-04-01 00:28:39.000000', 'consum', 0.0216, 'lps'),
	(475866, 125, '2015-04-01 00:28:40.000000', 'consum', 0.0230, 'lps'),
	(475867, 125, '2015-04-01 00:28:41.000000', 'consum', 0.0222, 'lps'),
	(475868, 125, '2015-04-01 00:28:42.000000', 'consum', 0.0210, 'lps'),
	(475869, 125, '2015-04-01 00:28:43.000000', 'consum', 0.0223, 'lps'),
	(475870, 125, '2015-04-01 00:28:44.000000', 'consum', 0.0227, 'lps'),
	(475871, 125, '2015-04-01 00:28:45.000000', 'consum', 0.0231, 'lps'),
	(475872, 125, '2015-04-01 00:28:46.000000', 'consum', 0.0218, 'lps'),
	(475873, 125, '2015-04-01 00:28:47.000000', 'consum', 0.0210, 'lps'),
	(475874, 125, '2015-04-01 00:28:48.000000', 'consum', 0.0213, 'lps'),
	(475875, 125, '2015-04-01 00:28:49.000000', 'consum', 0.0225, 'lps'),
	(475876, 125, '2015-04-01 00:28:50.000000', 'consum', 0.0228, 'lps'),
	(475877, 125, '2015-04-01 00:28:51.000000', 'consum', 0.0230, 'lps'),
	(475878, 125, '2015-04-01 00:28:52.000000', 'consum', 0.0232, 'lps'),
	(475879, 125, '2015-04-01 00:28:53.000000', 'consum', 0.0213, 'lps'),
	(475880, 125, '2015-04-01 00:28:54.000000', 'consum', 0.0231, 'lps'),
	(475881, 125, '2015-04-01 00:28:55.000000', 'consum', 0.0213, 'lps'),
	(475882, 125, '2015-04-01 00:28:56.000000', 'consum', 0.0232, 'lps'),
	(475883, 125, '2015-04-01 00:28:57.000000', 'consum', 0.0215, 'lps'),
	(475884, 125, '2015-04-01 00:28:58.000000', 'consum', 0.0219, 'lps'),
	(475885, 125, '2015-04-01 00:28:59.000000', 'consum', 0.0216, 'lps'),
	(475886, 125, '2015-04-01 00:29:00.000000', 'consum', 0.0213, 'lps'),
	(475887, 125, '2015-04-01 00:29:01.000000', 'consum', 0.0230, 'lps'),
	(475888, 125, '2015-04-01 00:29:02.000000', 'consum', 0.0232, 'lps'),
	(475889, 125, '2015-04-01 00:29:03.000000', 'consum', 0.0212, 'lps'),
	(475890, 125, '2015-04-01 00:29:04.000000', 'consum', 0.0225, 'lps'),
	(475891, 125, '2015-04-01 00:29:05.000000', 'consum', 0.0233, 'lps'),
	(475892, 125, '2015-04-01 00:29:06.000000', 'consum', 0.0230, 'lps'),
	(475893, 125, '2015-04-01 00:29:07.000000', 'consum', 0.0219, 'lps'),
	(475894, 125, '2015-04-01 00:29:08.000000', 'consum', 0.0219, 'lps'),
	(475895, 125, '2015-04-01 00:29:09.000000', 'consum', 0.0231, 'lps'),
	(475896, 125, '2015-04-01 00:29:10.000000', 'consum', 0.0214, 'lps'),
	(475897, 125, '2015-04-01 00:29:11.000000', 'consum', 0.0217, 'lps'),
	(475898, 125, '2015-04-01 00:29:12.000000', 'consum', 0.0231, 'lps'),
	(475899, 125, '2015-04-01 00:29:13.000000', 'consum', 0.0224, 'lps'),
	(475900, 125, '2015-04-01 00:29:14.000000', 'consum', 0.0219, 'lps'),
	(475901, 125, '2015-04-01 00:29:15.000000', 'consum', 0.0212, 'lps'),
	(475902, 125, '2015-04-01 00:29:16.000000', 'consum', 0.0218, 'lps'),
	(475903, 125, '2015-04-01 00:29:17.000000', 'consum', 0.0221, 'lps'),
	(475904, 125, '2015-04-01 00:29:18.000000', 'consum', 0.0217, 'lps'),
	(475905, 125, '2015-04-01 00:29:19.000000', 'consum', 0.0214, 'lps'),
	(475906, 125, '2015-04-01 00:29:20.000000', 'consum', 0.0232, 'lps'),
	(475907, 125, '2015-04-01 00:29:21.000000', 'consum', 0.0212, 'lps'),
	(475908, 125, '2015-04-01 00:29:22.000000', 'consum', 0.0229, 'lps'),
	(475909, 125, '2015-04-01 00:29:23.000000', 'consum', 0.0227, 'lps'),
	(475910, 125, '2015-04-01 00:29:24.000000', 'consum', 0.0213, 'lps'),
	(475911, 125, '2015-04-01 00:29:25.000000', 'consum', 0.0223, 'lps'),
	(475912, 125, '2015-04-01 00:29:26.000000', 'consum', 0.0218, 'lps'),
	(475913, 125, '2015-04-01 00:29:27.000000', 'consum', 0.0211, 'lps'),
	(475914, 125, '2015-04-01 00:29:28.000000', 'consum', 0.0214, 'lps'),
	(475915, 125, '2015-04-01 00:29:29.000000', 'consum', 0.0231, 'lps'),
	(475916, 125, '2015-04-01 00:29:30.000000', 'consum', 0.0229, 'lps'),
	(475917, 125, '2015-04-01 00:29:31.000000', 'consum', 0.0221, 'lps'),
	(475918, 125, '2015-04-01 00:29:32.000000', 'consum', 0.0232, 'lps'),
	(475919, 125, '2015-04-01 00:29:33.000000', 'consum', 0.0217, 'lps'),
	(475920, 125, '2015-04-01 00:29:34.000000', 'consum', 0.0225, 'lps'),
	(475921, 125, '2015-04-01 00:29:35.000000', 'consum', 0.0217, 'lps'),
	(475922, 125, '2015-04-01 00:29:36.000000', 'consum', 0.0226, 'lps'),
	(475923, 125, '2015-04-01 00:29:37.000000', 'consum', 0.0222, 'lps'),
	(475924, 125, '2015-04-01 00:29:38.000000', 'consum', 0.0222, 'lps'),
	(475925, 125, '2015-04-01 00:29:39.000000', 'consum', 0.0210, 'lps'),
	(475926, 125, '2015-04-01 00:29:40.000000', 'consum', 0.0221, 'lps'),
	(475927, 125, '2015-04-01 00:29:41.000000', 'consum', 0.0218, 'lps'),
	(475928, 125, '2015-04-01 00:29:42.000000', 'consum', 0.0218, 'lps'),
	(475929, 125, '2015-04-01 00:29:43.000000', 'consum', 0.0226, 'lps'),
	(475930, 125, '2015-04-01 00:29:44.000000', 'consum', 0.0217, 'lps'),
	(475931, 125, '2015-04-01 00:29:45.000000', 'consum', 0.0222, 'lps'),
	(475932, 125, '2015-04-01 00:29:46.000000', 'consum', 0.0224, 'lps'),
	(475933, 125, '2015-04-01 00:29:47.000000', 'consum', 0.0222, 'lps'),
	(475934, 125, '2015-04-01 00:29:48.000000', 'consum', 0.0228, 'lps'),
	(475935, 125, '2015-04-01 00:29:49.000000', 'consum', 0.0216, 'lps'),
	(475936, 125, '2015-04-01 00:29:50.000000', 'consum', 0.0212, 'lps'),
	(475937, 125, '2015-04-01 00:29:51.000000', 'consum', 0.0228, 'lps'),
	(475938, 125, '2015-04-01 00:29:52.000000', 'consum', 0.0219, 'lps'),
	(475939, 125, '2015-04-01 00:29:53.000000', 'consum', 0.0228, 'lps'),
	(475940, 125, '2015-04-01 00:29:54.000000', 'consum', 0.0224, 'lps'),
	(475941, 125, '2015-04-01 00:29:55.000000', 'consum', 0.0227, 'lps'),
	(475942, 125, '2015-04-01 00:29:56.000000', 'consum', 0.0231, 'lps'),
	(475943, 125, '2015-04-01 00:29:57.000000', 'consum', 0.0218, 'lps'),
	(475944, 125, '2015-04-01 00:29:58.000000', 'consum', 0.0232, 'lps'),
	(475945, 125, '2015-04-01 00:29:59.000000', 'consum', 0.0224, 'lps'),
	(475946, 125, '2015-04-01 00:30:00.000000', 'consum', 0.0215, 'lps'),
	(475947, 125, '2015-04-01 00:30:01.000000', 'consum', 0.0220, 'lps'),
	(475948, 125, '2015-04-01 00:30:02.000000', 'consum', 0.0218, 'lps'),
	(475949, 125, '2015-04-01 00:30:03.000000', 'consum', 0.0223, 'lps'),
	(475950, 125, '2015-04-01 00:30:04.000000', 'consum', 0.0226, 'lps'),
	(475951, 125, '2015-04-01 00:30:05.000000', 'consum', 0.0227, 'lps'),
	(475952, 125, '2015-04-01 00:30:06.000000', 'consum', 0.0226, 'lps'),
	(475953, 125, '2015-04-01 00:30:07.000000', 'consum', 0.0216, 'lps'),
	(475954, 125, '2015-04-01 00:30:08.000000', 'consum', 0.0214, 'lps'),
	(475955, 125, '2015-04-01 00:30:09.000000', 'consum', 0.0215, 'lps'),
	(475956, 125, '2015-04-01 00:30:10.000000', 'consum', 0.0223, 'lps'),
	(475957, 125, '2015-04-01 00:30:11.000000', 'consum', 0.0210, 'lps'),
	(475958, 125, '2015-04-01 00:30:12.000000', 'consum', 0.0223, 'lps'),
	(475959, 125, '2015-04-01 00:30:13.000000', 'consum', 0.0225, 'lps'),
	(475960, 125, '2015-04-01 00:30:14.000000', 'consum', 0.0224, 'lps'),
	(475961, 125, '2015-04-01 00:30:15.000000', 'consum', 0.0233, 'lps'),
	(475962, 125, '2015-04-01 00:30:16.000000', 'consum', 0.0214, 'lps'),
	(475963, 125, '2015-04-01 00:30:17.000000', 'consum', 0.0232, 'lps'),
	(475964, 125, '2015-04-01 00:30:18.000000', 'consum', 0.0215, 'lps'),
	(475965, 125, '2015-04-01 00:30:19.000000', 'consum', 0.0214, 'lps'),
	(475966, 125, '2015-04-01 00:30:20.000000', 'consum', 0.0219, 'lps'),
	(475967, 125, '2015-04-01 00:30:21.000000', 'consum', 0.0218, 'lps'),
	(475968, 125, '2015-04-01 00:30:22.000000', 'consum', 0.0225, 'lps'),
	(475969, 125, '2015-04-01 00:30:23.000000', 'consum', 0.0214, 'lps'),
	(475970, 125, '2015-04-01 00:30:24.000000', 'consum', 0.0211, 'lps'),
	(475971, 125, '2015-04-01 00:30:25.000000', 'consum', 0.0224, 'lps'),
	(475972, 125, '2015-04-01 00:30:26.000000', 'consum', 0.0229, 'lps'),
	(475973, 125, '2015-04-01 00:30:27.000000', 'consum', 0.0217, 'lps'),
	(475974, 125, '2015-04-01 00:30:28.000000', 'consum', 0.0213, 'lps'),
	(475975, 125, '2015-04-01 00:30:29.000000', 'consum', 0.0227, 'lps'),
	(475976, 125, '2015-04-01 00:30:30.000000', 'consum', 0.0214, 'lps'),
	(475977, 125, '2015-04-01 00:30:31.000000', 'consum', 0.0227, 'lps'),
	(475978, 125, '2015-04-01 00:30:32.000000', 'consum', 0.0211, 'lps'),
	(475979, 125, '2015-04-01 00:30:33.000000', 'consum', 0.0214, 'lps'),
	(475980, 125, '2015-04-01 00:30:34.000000', 'consum', 0.0226, 'lps'),
	(475981, 125, '2015-04-01 00:30:35.000000', 'consum', 0.0229, 'lps'),
	(475982, 125, '2015-04-01 00:30:36.000000', 'consum', 0.0213, 'lps'),
	(475983, 125, '2015-04-01 00:30:37.000000', 'consum', 0.0216, 'lps'),
	(475984, 125, '2015-04-01 00:30:38.000000', 'consum', 0.0229, 'lps'),
	(475985, 125, '2015-04-01 00:30:39.000000', 'consum', 0.0216, 'lps'),
	(475986, 125, '2015-04-01 00:30:40.000000', 'consum', 0.0232, 'lps'),
	(475987, 125, '2015-04-01 00:30:41.000000', 'consum', 0.0232, 'lps'),
	(475988, 125, '2015-04-01 00:30:42.000000', 'consum', 0.0230, 'lps'),
	(475989, 125, '2015-04-01 00:30:43.000000', 'consum', 0.0219, 'lps'),
	(475990, 125, '2015-04-01 00:30:44.000000', 'consum', 0.0219, 'lps'),
	(475991, 125, '2015-04-01 00:30:45.000000', 'consum', 0.0231, 'lps'),
	(475992, 125, '2015-04-01 00:30:46.000000', 'consum', 0.0216, 'lps'),
	(475993, 125, '2015-04-01 00:30:47.000000', 'consum', 0.0226, 'lps'),
	(475994, 125, '2015-04-01 00:30:48.000000', 'consum', 0.0226, 'lps'),
	(475995, 125, '2015-04-01 00:30:49.000000', 'consum', 0.0216, 'lps'),
	(475996, 125, '2015-04-01 00:30:50.000000', 'consum', 0.0219, 'lps'),
	(475997, 125, '2015-04-01 00:30:51.000000', 'consum', 0.0213, 'lps'),
	(475998, 125, '2015-04-01 00:30:52.000000', 'consum', 0.0224, 'lps'),
	(475999, 125, '2015-04-01 00:30:53.000000', 'consum', 0.0222, 'lps'),
	(476000, 125, '2015-04-01 00:30:54.000000', 'consum', 0.0228, 'lps'),
	(476001, 125, '2015-04-01 00:30:55.000000', 'consum', 0.0218, 'lps'),
	(476002, 125, '2015-04-01 00:30:56.000000', 'consum', 0.0218, 'lps'),
	(476003, 125, '2015-04-01 00:30:57.000000', 'consum', 0.0229, 'lps'),
	(476004, 125, '2015-04-01 00:30:58.000000', 'consum', 0.0232, 'lps'),
	(476005, 125, '2015-04-01 00:30:59.000000', 'consum', 0.0217, 'lps'),
	(476006, 125, '2015-04-01 00:31:00.000000', 'consum', 0.0225, 'lps'),
	(476007, 125, '2015-04-01 00:31:01.000000', 'consum', 0.0217, 'lps'),
	(476008, 125, '2015-04-01 00:31:02.000000', 'consum', 0.0225, 'lps'),
	(476009, 125, '2015-04-01 00:31:03.000000', 'consum', 0.0216, 'lps'),
	(476010, 125, '2015-04-01 00:31:04.000000', 'consum', 0.0220, 'lps'),
	(476011, 125, '2015-04-01 00:31:05.000000', 'consum', 0.0219, 'lps'),
	(476012, 125, '2015-04-01 00:31:06.000000', 'consum', 0.0226, 'lps'),
	(476013, 125, '2015-04-01 00:31:07.000000', 'consum', 0.0215, 'lps'),
	(476014, 125, '2015-04-01 00:31:08.000000', 'consum', 0.0213, 'lps'),
	(476015, 125, '2015-04-01 00:31:09.000000', 'consum', 0.0232, 'lps'),
	(476016, 125, '2015-04-01 00:31:10.000000', 'consum', 0.0216, 'lps'),
	(476017, 125, '2015-04-01 00:31:11.000000', 'consum', 0.0221, 'lps'),
	(476018, 125, '2015-04-01 00:31:12.000000', 'consum', 0.0225, 'lps'),
	(476019, 125, '2015-04-01 00:31:13.000000', 'consum', 0.0230, 'lps'),
	(476020, 125, '2015-04-01 00:31:14.000000', 'consum', 0.0217, 'lps'),
	(476021, 125, '2015-04-01 00:31:15.000000', 'consum', 0.0210, 'lps'),
	(476022, 125, '2015-04-01 00:31:16.000000', 'consum', 0.0213, 'lps'),
	(476023, 125, '2015-04-01 00:31:17.000000', 'consum', 0.0227, 'lps'),
	(476024, 125, '2015-04-01 00:31:18.000000', 'consum', 0.0215, 'lps'),
	(476025, 125, '2015-04-01 00:31:19.000000', 'consum', 0.0232, 'lps'),
	(476026, 125, '2015-04-01 00:31:20.000000', 'consum', 0.0210, 'lps'),
	(476027, 125, '2015-04-01 00:31:21.000000', 'consum', 0.0217, 'lps'),
	(476028, 125, '2015-04-01 00:31:22.000000', 'consum', 0.0220, 'lps'),
	(476029, 125, '2015-04-01 00:31:23.000000', 'consum', 0.0217, 'lps'),
	(476030, 125, '2015-04-01 00:31:24.000000', 'consum', 0.0214, 'lps'),
	(476031, 125, '2015-04-01 00:31:25.000000', 'consum', 0.0210, 'lps'),
	(476032, 125, '2015-04-01 00:31:26.000000', 'consum', 0.0223, 'lps'),
	(476033, 125, '2015-04-01 00:31:27.000000', 'consum', 0.0227, 'lps'),
	(476034, 125, '2015-04-01 00:31:28.000000', 'consum', 0.0233, 'lps'),
	(476035, 125, '2015-04-01 00:31:29.000000', 'consum', 0.0228, 'lps'),
	(476036, 125, '2015-04-01 00:31:30.000000', 'consum', 0.0231, 'lps'),
	(476037, 125, '2015-04-01 00:31:31.000000', 'consum', 0.0212, 'lps'),
	(476038, 125, '2015-04-01 00:31:32.000000', 'consum', 0.0231, 'lps'),
	(476039, 125, '2015-04-01 00:31:33.000000', 'consum', 0.0215, 'lps'),
	(476040, 125, '2015-04-01 00:31:34.000000', 'consum', 0.0218, 'lps'),
	(476041, 125, '2015-04-01 00:31:35.000000', 'consum', 0.0211, 'lps'),
	(476042, 125, '2015-04-01 00:31:36.000000', 'consum', 0.0216, 'lps'),
	(476043, 125, '2015-04-01 00:31:37.000000', 'consum', 0.0216, 'lps'),
	(476044, 125, '2015-04-01 00:31:38.000000', 'consum', 0.0220, 'lps'),
	(476045, 125, '2015-04-01 00:31:39.000000', 'consum', 0.0218, 'lps'),
	(476046, 125, '2015-04-01 00:31:40.000000', 'consum', 0.0223, 'lps'),
	(476047, 125, '2015-04-01 00:31:41.000000', 'consum', 0.0228, 'lps'),
	(476048, 125, '2015-04-01 00:31:42.000000', 'consum', 0.0211, 'lps'),
	(476049, 125, '2015-04-01 00:31:43.000000', 'consum', 0.0212, 'lps'),
	(476050, 125, '2015-04-01 00:31:44.000000', 'consum', 0.0217, 'lps'),
	(476051, 125, '2015-04-01 00:31:45.000000', 'consum', 0.0217, 'lps'),
	(476052, 125, '2015-04-01 00:31:46.000000', 'consum', 0.0224, 'lps'),
	(476053, 125, '2015-04-01 00:31:47.000000', 'consum', 0.0211, 'lps'),
	(476054, 125, '2015-04-01 00:31:48.000000', 'consum', 0.0222, 'lps'),
	(476055, 125, '2015-04-01 00:31:49.000000', 'consum', 0.0221, 'lps'),
	(476056, 125, '2015-04-01 00:31:50.000000', 'consum', 0.0229, 'lps'),
	(476057, 125, '2015-04-01 00:31:51.000000', 'consum', 0.0223, 'lps'),
	(476058, 125, '2015-04-01 00:31:52.000000', 'consum', 0.0218, 'lps'),
	(476059, 125, '2015-04-01 00:31:53.000000', 'consum', 0.0211, 'lps'),
	(476060, 125, '2015-04-01 00:31:54.000000', 'consum', 0.0215, 'lps'),
	(476061, 125, '2015-04-01 00:31:55.000000', 'consum', 0.0211, 'lps'),
	(476062, 125, '2015-04-01 00:31:56.000000', 'consum', 0.0221, 'lps'),
	(476063, 125, '2015-04-01 00:31:57.000000', 'consum', 0.0218, 'lps'),
	(476064, 125, '2015-04-01 00:31:58.000000', 'consum', 0.0218, 'lps'),
	(476065, 125, '2015-04-01 00:31:59.000000', 'consum', 0.0223, 'lps'),
	(476066, 125, '2015-04-01 00:32:00.000000', 'consum', 0.0231, 'lps'),
	(476067, 125, '2015-04-01 00:32:01.000000', 'consum', 0.0226, 'lps'),
	(476068, 125, '2015-04-01 00:32:02.000000', 'consum', 0.0230, 'lps'),
	(476069, 125, '2015-04-01 00:32:03.000000', 'consum', 0.0214, 'lps'),
	(476070, 125, '2015-04-01 00:32:04.000000', 'consum', 0.0220, 'lps'),
	(476071, 125, '2015-04-01 00:32:05.000000', 'consum', 0.0222, 'lps'),
	(476072, 125, '2015-04-01 00:32:06.000000', 'consum', 0.0216, 'lps'),
	(476073, 125, '2015-04-01 00:32:07.000000', 'consum', 0.0227, 'lps'),
	(476074, 125, '2015-04-01 00:32:08.000000', 'consum', 0.0233, 'lps'),
	(476075, 125, '2015-04-01 00:32:09.000000', 'consum', 0.0227, 'lps'),
	(476076, 125, '2015-04-01 00:32:10.000000', 'consum', 0.0223, 'lps'),
	(476077, 125, '2015-04-01 00:32:11.000000', 'consum', 0.0227, 'lps'),
	(476078, 125, '2015-04-01 00:32:12.000000', 'consum', 0.0233, 'lps'),
	(476079, 125, '2015-04-01 00:32:13.000000', 'consum', 0.0228, 'lps'),
	(476080, 125, '2015-04-01 00:32:14.000000', 'consum', 0.0228, 'lps'),
	(476081, 125, '2015-04-01 00:32:15.000000', 'consum', 0.0225, 'lps'),
	(476082, 125, '2015-04-01 00:32:16.000000', 'consum', 0.0230, 'lps'),
	(476083, 125, '2015-04-01 00:32:17.000000', 'consum', 0.0218, 'lps'),
	(476084, 125, '2015-04-01 00:32:18.000000', 'consum', 0.0214, 'lps'),
	(476085, 125, '2015-04-01 00:32:19.000000', 'consum', 0.0230, 'lps'),
	(476086, 125, '2015-04-01 00:32:20.000000', 'consum', 0.0227, 'lps'),
	(476087, 125, '2015-04-01 00:32:21.000000', 'consum', 0.0213, 'lps'),
	(476088, 125, '2015-04-01 00:32:22.000000', 'consum', 0.0220, 'lps'),
	(476089, 125, '2015-04-01 00:32:23.000000', 'consum', 0.0230, 'lps'),
	(476090, 125, '2015-04-01 00:32:24.000000', 'consum', 0.0230, 'lps'),
	(476091, 125, '2015-04-01 00:32:25.000000', 'consum', 0.0229, 'lps'),
	(476092, 125, '2015-04-01 00:32:26.000000', 'consum', 0.0219, 'lps'),
	(476093, 125, '2015-04-01 00:32:27.000000', 'consum', 0.0226, 'lps'),
	(476094, 125, '2015-04-01 00:32:28.000000', 'consum', 0.0212, 'lps'),
	(476095, 125, '2015-04-01 00:32:29.000000', 'consum', 0.0222, 'lps'),
	(476096, 125, '2015-04-01 00:32:30.000000', 'consum', 0.0215, 'lps'),
	(476097, 125, '2015-04-01 00:32:31.000000', 'consum', 0.0222, 'lps'),
	(476098, 125, '2015-04-01 00:32:32.000000', 'consum', 0.0211, 'lps'),
	(476099, 125, '2015-04-01 00:32:33.000000', 'consum', 0.0227, 'lps'),
	(476100, 125, '2015-04-01 00:32:34.000000', 'consum', 0.0219, 'lps'),
	(476101, 125, '2015-04-01 00:32:35.000000', 'consum', 0.0229, 'lps'),
	(476102, 125, '2015-04-01 00:32:36.000000', 'consum', 0.0231, 'lps'),
	(476103, 125, '2015-04-01 00:32:37.000000', 'consum', 0.0233, 'lps'),
	(476104, 125, '2015-04-01 00:32:38.000000', 'consum', 0.0215, 'lps'),
	(476105, 125, '2015-04-01 00:32:39.000000', 'consum', 0.0213, 'lps'),
	(476106, 125, '2015-04-01 00:32:40.000000', 'consum', 0.0212, 'lps'),
	(476107, 125, '2015-04-01 00:32:41.000000', 'consum', 0.0213, 'lps'),
	(476108, 125, '2015-04-01 00:32:42.000000', 'consum', 0.0219, 'lps'),
	(476109, 125, '2015-04-01 00:32:43.000000', 'consum', 0.0224, 'lps'),
	(476110, 125, '2015-04-01 00:32:44.000000', 'consum', 0.0227, 'lps'),
	(476111, 125, '2015-04-01 00:32:45.000000', 'consum', 0.0232, 'lps'),
	(476112, 125, '2015-04-01 00:32:46.000000', 'consum', 0.0218, 'lps'),
	(476113, 125, '2015-04-01 00:32:47.000000', 'consum', 0.0212, 'lps'),
	(476114, 125, '2015-04-01 00:32:48.000000', 'consum', 0.0219, 'lps'),
	(476115, 125, '2015-04-01 00:32:49.000000', 'consum', 0.0226, 'lps'),
	(476116, 125, '2015-04-01 00:32:50.000000', 'consum', 0.0216, 'lps'),
	(476117, 125, '2015-04-01 00:32:51.000000', 'consum', 0.0216, 'lps'),
	(476118, 125, '2015-04-01 00:32:52.000000', 'consum', 0.0222, 'lps'),
	(476119, 125, '2015-04-01 00:32:53.000000', 'consum', 0.0228, 'lps'),
	(476120, 125, '2015-04-01 00:32:54.000000', 'consum', 0.0215, 'lps'),
	(476121, 125, '2015-04-01 00:32:55.000000', 'consum', 0.0233, 'lps'),
	(476122, 125, '2015-04-01 00:32:56.000000', 'consum', 0.0211, 'lps'),
	(476123, 125, '2015-04-01 00:32:57.000000', 'consum', 0.0222, 'lps'),
	(476124, 125, '2015-04-01 00:32:58.000000', 'consum', 0.0217, 'lps'),
	(476125, 125, '2015-04-01 00:32:59.000000', 'consum', 0.0211, 'lps'),
	(476126, 125, '2015-04-01 00:33:00.000000', 'consum', 0.0217, 'lps'),
	(476127, 125, '2015-04-01 00:33:01.000000', 'consum', 0.0218, 'lps'),
	(476128, 125, '2015-04-01 00:33:02.000000', 'consum', 0.0228, 'lps'),
	(476129, 125, '2015-04-01 00:33:03.000000', 'consum', 0.0232, 'lps'),
	(476130, 125, '2015-04-01 00:33:04.000000', 'consum', 0.0216, 'lps'),
	(476131, 125, '2015-04-01 00:33:05.000000', 'consum', 0.0225, 'lps'),
	(476132, 125, '2015-04-01 00:33:06.000000', 'consum', 0.0219, 'lps'),
	(476133, 125, '2015-04-01 00:33:07.000000', 'consum', 0.0211, 'lps'),
	(476134, 125, '2015-04-01 00:33:08.000000', 'consum', 0.0213, 'lps'),
	(476135, 125, '2015-04-01 00:33:09.000000', 'consum', 0.0223, 'lps'),
	(476136, 125, '2015-04-01 00:33:10.000000', 'consum', 0.0219, 'lps'),
	(476137, 125, '2015-04-01 00:33:11.000000', 'consum', 0.0216, 'lps'),
	(476138, 125, '2015-04-01 00:33:12.000000', 'consum', 0.0211, 'lps'),
	(476139, 125, '2015-04-01 00:33:13.000000', 'consum', 0.0225, 'lps'),
	(476140, 125, '2015-04-01 00:33:14.000000', 'consum', 0.0232, 'lps'),
	(476141, 125, '2015-04-01 00:33:15.000000', 'consum', 0.0227, 'lps'),
	(476142, 125, '2015-04-01 00:33:16.000000', 'consum', 0.0232, 'lps'),
	(476143, 125, '2015-04-01 00:33:17.000000', 'consum', 0.0219, 'lps'),
	(476144, 125, '2015-04-01 00:33:18.000000', 'consum', 0.0215, 'lps'),
	(476145, 125, '2015-04-01 00:33:19.000000', 'consum', 0.0231, 'lps'),
	(476146, 125, '2015-04-01 00:33:20.000000', 'consum', 0.0231, 'lps'),
	(476147, 125, '2015-04-01 00:33:21.000000', 'consum', 0.0225, 'lps'),
	(476148, 125, '2015-04-01 00:33:22.000000', 'consum', 0.0225, 'lps'),
	(476149, 125, '2015-04-01 00:33:23.000000', 'consum', 0.0218, 'lps'),
	(476150, 125, '2015-04-01 00:33:24.000000', 'consum', 0.0227, 'lps'),
	(476151, 125, '2015-04-01 00:33:25.000000', 'consum', 0.0224, 'lps'),
	(476152, 125, '2015-04-01 00:33:26.000000', 'consum', 0.0231, 'lps'),
	(476153, 125, '2015-04-01 00:33:27.000000', 'consum', 0.0224, 'lps'),
	(476154, 125, '2015-04-01 00:33:28.000000', 'consum', 0.0218, 'lps'),
	(476155, 125, '2015-04-01 00:33:29.000000', 'consum', 0.0232, 'lps'),
	(476156, 125, '2015-04-01 00:33:30.000000', 'consum', 0.0225, 'lps'),
	(476157, 125, '2015-04-01 00:33:31.000000', 'consum', 0.0221, 'lps'),
	(476158, 125, '2015-04-01 00:33:32.000000', 'consum', 0.0218, 'lps'),
	(476159, 125, '2015-04-01 00:33:33.000000', 'consum', 0.0217, 'lps'),
	(476160, 125, '2015-04-01 00:33:34.000000', 'consum', 0.0221, 'lps'),
	(476161, 125, '2015-04-01 00:33:35.000000', 'consum', 0.0219, 'lps'),
	(476162, 125, '2015-04-01 00:33:36.000000', 'consum', 0.0226, 'lps'),
	(476163, 125, '2015-04-01 00:33:37.000000', 'consum', 0.0215, 'lps'),
	(476164, 125, '2015-04-01 00:33:38.000000', 'consum', 0.0212, 'lps'),
	(476165, 125, '2015-04-01 00:33:39.000000', 'consum', 0.0229, 'lps'),
	(476166, 125, '2015-04-01 00:33:40.000000', 'consum', 0.0225, 'lps'),
	(476167, 125, '2015-04-01 00:33:41.000000', 'consum', 0.0232, 'lps'),
	(476168, 125, '2015-04-01 00:33:42.000000', 'consum', 0.0225, 'lps'),
	(476169, 125, '2015-04-01 00:33:43.000000', 'consum', 0.0222, 'lps'),
	(476170, 125, '2015-04-01 00:33:44.000000', 'consum', 0.0224, 'lps'),
	(476171, 125, '2015-04-01 00:33:45.000000', 'consum', 0.0221, 'lps'),
	(476172, 125, '2015-04-01 00:33:46.000000', 'consum', 0.0225, 'lps'),
	(476173, 125, '2015-04-01 00:33:47.000000', 'consum', 0.0227, 'lps'),
	(476174, 125, '2015-04-01 00:33:48.000000', 'consum', 0.0228, 'lps'),
	(476175, 125, '2015-04-01 00:33:49.000000', 'consum', 0.0225, 'lps'),
	(476176, 125, '2015-04-01 00:33:50.000000', 'consum', 0.0230, 'lps'),
	(476177, 125, '2015-04-01 00:33:51.000000', 'consum', 0.0219, 'lps'),
	(476178, 125, '2015-04-01 00:33:52.000000', 'consum', 0.0218, 'lps'),
	(476179, 125, '2015-04-01 00:33:53.000000', 'consum', 0.0223, 'lps'),
	(476180, 125, '2015-04-01 00:33:54.000000', 'consum', 0.0228, 'lps'),
	(476181, 125, '2015-04-01 00:33:55.000000', 'consum', 0.0212, 'lps'),
	(476182, 125, '2015-04-01 00:33:56.000000', 'consum', 0.0217, 'lps'),
	(476183, 125, '2015-04-01 00:33:57.000000', 'consum', 0.0213, 'lps'),
	(476184, 125, '2015-04-01 00:33:58.000000', 'consum', 0.0230, 'lps'),
	(476185, 125, '2015-04-01 00:33:59.000000', 'consum', 0.0228, 'lps'),
	(476186, 125, '2015-04-01 00:34:00.000000', 'consum', 0.0216, 'lps'),
	(476187, 125, '2015-04-01 00:34:01.000000', 'consum', 0.0210, 'lps'),
	(476188, 125, '2015-04-01 00:34:02.000000', 'consum', 0.0219, 'lps'),
	(476189, 125, '2015-04-01 00:34:03.000000', 'consum', 0.0230, 'lps'),
	(476190, 125, '2015-04-01 00:34:04.000000', 'consum', 0.0212, 'lps'),
	(476191, 125, '2015-04-01 00:34:05.000000', 'consum', 0.0233, 'lps'),
	(476192, 125, '2015-04-01 00:34:06.000000', 'consum', 0.0224, 'lps'),
	(476193, 125, '2015-04-01 00:34:07.000000', 'consum', 0.0213, 'lps'),
	(476194, 125, '2015-04-01 00:34:08.000000', 'consum', 0.0230, 'lps'),
	(476195, 125, '2015-04-01 00:34:09.000000', 'consum', 0.0228, 'lps'),
	(476196, 125, '2015-04-01 00:34:10.000000', 'consum', 0.0217, 'lps'),
	(476197, 125, '2015-04-01 00:34:11.000000', 'consum', 0.0218, 'lps'),
	(476198, 125, '2015-04-01 00:34:12.000000', 'consum', 0.0226, 'lps'),
	(476199, 125, '2015-04-01 00:34:13.000000', 'consum', 0.0222, 'lps'),
	(476200, 125, '2015-04-01 00:34:14.000000', 'consum', 0.0221, 'lps'),
	(476201, 125, '2015-04-01 00:34:15.000000', 'consum', 0.0230, 'lps'),
	(476202, 125, '2015-04-01 00:34:16.000000', 'consum', 0.0228, 'lps'),
	(476203, 125, '2015-04-01 00:34:17.000000', 'consum', 0.0215, 'lps'),
	(476204, 125, '2015-04-01 00:34:18.000000', 'consum', 0.0232, 'lps'),
	(476205, 125, '2015-04-01 00:34:19.000000', 'consum', 0.0210, 'lps'),
	(476206, 125, '2015-04-01 00:34:20.000000', 'consum', 0.0217, 'lps'),
	(476207, 125, '2015-04-01 00:34:21.000000', 'consum', 0.0223, 'lps'),
	(476208, 125, '2015-04-01 00:34:22.000000', 'consum', 0.0227, 'lps'),
	(476209, 125, '2015-04-01 00:34:23.000000', 'consum', 0.0233, 'lps'),
	(476210, 125, '2015-04-01 00:34:24.000000', 'consum', 0.0228, 'lps'),
	(476211, 125, '2015-04-01 00:34:25.000000', 'consum', 0.0231, 'lps'),
	(476212, 125, '2015-04-01 00:34:26.000000', 'consum', 0.0211, 'lps'),
	(476213, 125, '2015-04-01 00:34:27.000000', 'consum', 0.0228, 'lps'),
	(476214, 125, '2015-04-01 00:34:28.000000', 'consum', 0.0224, 'lps'),
	(476215, 125, '2015-04-01 00:34:29.000000', 'consum', 0.0227, 'lps'),
	(476216, 125, '2015-04-01 00:34:30.000000', 'consum', 0.0230, 'lps'),
	(476217, 125, '2015-04-01 00:34:31.000000', 'consum', 0.0212, 'lps'),
	(476218, 125, '2015-04-01 00:34:32.000000', 'consum', 0.0233, 'lps'),
	(476219, 125, '2015-04-01 00:34:33.000000', 'consum', 0.0221, 'lps'),
	(476220, 125, '2015-04-01 00:34:34.000000', 'consum', 0.0220, 'lps'),
	(476221, 125, '2015-04-01 00:34:35.000000', 'consum', 0.0228, 'lps'),
	(476222, 125, '2015-04-01 00:34:36.000000', 'consum', 0.0223, 'lps'),
	(476223, 125, '2015-04-01 00:34:37.000000', 'consum', 0.0223, 'lps'),
	(476224, 125, '2015-04-01 00:34:38.000000', 'consum', 0.0211, 'lps'),
	(476225, 125, '2015-04-01 00:34:39.000000', 'consum', 0.0226, 'lps'),
	(476226, 125, '2015-04-01 00:34:40.000000', 'consum', 0.0216, 'lps'),
	(476227, 125, '2015-04-01 00:34:41.000000', 'consum', 0.0215, 'lps'),
	(476228, 125, '2015-04-01 00:34:42.000000', 'consum', 0.0218, 'lps'),
	(476229, 125, '2015-04-01 00:34:43.000000', 'consum', 0.0212, 'lps'),
	(476230, 125, '2015-04-01 00:34:44.000000', 'consum', 0.0219, 'lps'),
	(476231, 125, '2015-04-01 00:34:45.000000', 'consum', 0.0228, 'lps'),
	(476232, 125, '2015-04-01 00:34:46.000000', 'consum', 0.0224, 'lps'),
	(476233, 125, '2015-04-01 00:34:47.000000', 'consum', 0.0226, 'lps'),
	(476234, 125, '2015-04-01 00:34:48.000000', 'consum', 0.0226, 'lps'),
	(476235, 125, '2015-04-01 00:34:49.000000', 'consum', 0.0218, 'lps'),
	(476236, 125, '2015-04-01 00:34:50.000000', 'consum', 0.0225, 'lps'),
	(476237, 125, '2015-04-01 00:34:51.000000', 'consum', 0.0216, 'lps'),
	(476238, 125, '2015-04-01 00:34:52.000000', 'consum', 0.0219, 'lps'),
	(476239, 125, '2015-04-01 00:34:53.000000', 'consum', 0.0212, 'lps'),
	(476240, 125, '2015-04-01 00:34:54.000000', 'consum', 0.0218, 'lps'),
	(476241, 125, '2015-04-01 00:34:55.000000', 'consum', 0.0220, 'lps'),
	(476242, 125, '2015-04-01 00:34:56.000000', 'consum', 0.0215, 'lps'),
	(476243, 125, '2015-04-01 00:34:57.000000', 'consum', 0.0227, 'lps'),
	(476244, 125, '2015-04-01 00:34:58.000000', 'consum', 0.0211, 'lps'),
	(476245, 125, '2015-04-01 00:34:59.000000', 'consum', 0.0210, 'lps'),
	(476246, 125, '2015-04-01 00:35:00.000000', 'consum', 0.0233, 'lps'),
	(476247, 125, '2015-04-01 00:35:01.000000', 'consum', 0.0229, 'lps'),
	(476248, 125, '2015-04-01 00:35:02.000000', 'consum', 0.0214, 'lps'),
	(476249, 125, '2015-04-01 00:35:03.000000', 'consum', 0.0219, 'lps'),
	(476250, 125, '2015-04-01 00:35:04.000000', 'consum', 0.0219, 'lps'),
	(476251, 125, '2015-04-01 00:35:05.000000', 'consum', 0.0231, 'lps'),
	(476252, 125, '2015-04-01 00:35:06.000000', 'consum', 0.0216, 'lps'),
	(476253, 125, '2015-04-01 00:35:07.000000', 'consum', 0.0225, 'lps'),
	(476254, 125, '2015-04-01 00:35:08.000000', 'consum', 0.0221, 'lps'),
	(476255, 125, '2015-04-01 00:35:09.000000', 'consum', 0.0221, 'lps'),
	(476256, 125, '2015-04-01 00:35:10.000000', 'consum', 0.0233, 'lps'),
	(476257, 125, '2015-04-01 00:35:11.000000', 'consum', 0.0221, 'lps'),
	(476258, 125, '2015-04-01 00:35:12.000000', 'consum', 0.0220, 'lps'),
	(476259, 125, '2015-04-01 00:35:13.000000', 'consum', 0.0226, 'lps'),
	(476260, 125, '2015-04-01 00:35:14.000000', 'consum', 0.0214, 'lps'),
	(476261, 125, '2015-04-01 00:35:15.000000', 'consum', 0.0231, 'lps'),
	(476262, 125, '2015-04-01 00:35:16.000000', 'consum', 0.0233, 'lps'),
	(476263, 125, '2015-04-01 00:35:17.000000', 'consum', 0.0213, 'lps'),
	(476264, 125, '2015-04-01 00:35:18.000000', 'consum', 0.0227, 'lps'),
	(476265, 125, '2015-04-01 00:35:19.000000', 'consum', 0.0213, 'lps'),
	(476266, 125, '2015-04-01 00:35:20.000000', 'consum', 0.0226, 'lps'),
	(476267, 125, '2015-04-01 00:35:21.000000', 'consum', 0.0233, 'lps'),
	(476268, 125, '2015-04-01 00:35:22.000000', 'consum', 0.0229, 'lps'),
	(476269, 125, '2015-04-01 00:35:23.000000', 'consum', 0.0213, 'lps'),
	(476270, 125, '2015-04-01 00:35:24.000000', 'consum', 0.0215, 'lps'),
	(476271, 125, '2015-04-01 00:35:25.000000', 'consum', 0.0226, 'lps'),
	(476272, 125, '2015-04-01 00:35:26.000000', 'consum', 0.0229, 'lps'),
	(476273, 125, '2015-04-01 00:35:27.000000', 'consum', 0.0233, 'lps'),
	(476274, 125, '2015-04-01 00:35:28.000000', 'consum', 0.0221, 'lps'),
	(476275, 125, '2015-04-01 00:35:29.000000', 'consum', 0.0220, 'lps'),
	(476276, 125, '2015-04-01 00:35:30.000000', 'consum', 0.0229, 'lps'),
	(476277, 125, '2015-04-01 00:35:31.000000', 'consum', 0.0227, 'lps'),
	(476278, 125, '2015-04-01 00:35:32.000000', 'consum', 0.0215, 'lps'),
	(476279, 125, '2015-04-01 00:35:33.000000', 'consum', 0.0230, 'lps'),
	(476280, 125, '2015-04-01 00:35:34.000000', 'consum', 0.0225, 'lps'),
	(476281, 125, '2015-04-01 00:35:35.000000', 'consum', 0.0226, 'lps'),
	(476282, 125, '2015-04-01 00:35:36.000000', 'consum', 0.0221, 'lps'),
	(476283, 125, '2015-04-01 00:35:37.000000', 'consum', 0.0217, 'lps'),
	(476284, 125, '2015-04-01 00:35:38.000000', 'consum', 0.0214, 'lps'),
	(476285, 125, '2015-04-01 00:35:39.000000', 'consum', 0.0232, 'lps'),
	(476286, 125, '2015-04-01 00:35:40.000000', 'consum', 0.0214, 'lps'),
	(476287, 125, '2015-04-01 00:35:41.000000', 'consum', 0.0213, 'lps'),
	(476288, 125, '2015-04-01 00:35:42.000000', 'consum', 0.0214, 'lps'),
	(476289, 125, '2015-04-01 00:35:43.000000', 'consum', 0.0219, 'lps'),
	(476290, 125, '2015-04-01 00:35:44.000000', 'consum', 0.0219, 'lps'),
	(476291, 125, '2015-04-01 00:35:45.000000', 'consum', 0.0231, 'lps'),
	(476292, 125, '2015-04-01 00:35:46.000000', 'consum', 0.0215, 'lps'),
	(476293, 125, '2015-04-01 00:35:47.000000', 'consum', 0.0222, 'lps'),
	(476294, 125, '2015-04-01 00:35:48.000000', 'consum', 0.0229, 'lps'),
	(476295, 125, '2015-04-01 00:35:49.000000', 'consum', 0.0223, 'lps'),
	(476296, 125, '2015-04-01 00:35:50.000000', 'consum', 0.0219, 'lps'),
	(476297, 125, '2015-04-01 00:35:51.000000', 'consum', 0.0217, 'lps'),
	(476298, 125, '2015-04-01 00:35:52.000000', 'consum', 0.0216, 'lps'),
	(476299, 125, '2015-04-01 00:35:53.000000', 'consum', 0.0223, 'lps'),
	(476300, 125, '2015-04-01 00:35:54.000000', 'consum', 0.0231, 'lps'),
	(476301, 125, '2015-04-01 00:35:55.000000', 'consum', 0.0227, 'lps'),
	(476302, 125, '2015-04-01 00:35:56.000000', 'consum', 0.0212, 'lps'),
	(476303, 125, '2015-04-01 00:35:57.000000', 'consum', 0.0215, 'lps'),
	(476304, 125, '2015-04-01 00:35:58.000000', 'consum', 0.0228, 'lps'),
	(476305, 125, '2015-04-01 00:35:59.000000', 'consum', 0.0217, 'lps'),
	(476306, 125, '2015-04-01 00:36:00.000000', 'consum', 0.0212, 'lps'),
	(476307, 125, '2015-04-01 00:36:01.000000', 'consum', 0.0225, 'lps'),
	(476308, 125, '2015-04-01 00:36:02.000000', 'consum', 0.0233, 'lps'),
	(476309, 125, '2015-04-01 00:36:03.000000', 'consum', 0.0229, 'lps'),
	(476310, 125, '2015-04-01 00:36:04.000000', 'consum', 0.0216, 'lps'),
	(476311, 125, '2015-04-01 00:36:05.000000', 'consum', 0.0231, 'lps'),
	(476312, 125, '2015-04-01 00:36:06.000000', 'consum', 0.0224, 'lps'),
	(476313, 125, '2015-04-01 00:36:07.000000', 'consum', 0.0218, 'lps'),
	(476314, 125, '2015-04-01 00:36:08.000000', 'consum', 0.0210, 'lps'),
	(476315, 125, '2015-04-01 00:36:09.000000', 'consum', 0.0211, 'lps'),
	(476316, 125, '2015-04-01 00:36:10.000000', 'consum', 0.0216, 'lps'),
	(476317, 125, '2015-04-01 00:36:11.000000', 'consum', 0.0212, 'lps'),
	(476318, 125, '2015-04-01 00:36:12.000000', 'consum', 0.0226, 'lps'),
	(476319, 125, '2015-04-01 00:36:13.000000', 'consum', 0.0212, 'lps'),
	(476320, 125, '2015-04-01 00:36:14.000000', 'consum', 0.0220, 'lps'),
	(476321, 125, '2015-04-01 00:36:15.000000', 'consum', 0.0229, 'lps'),
	(476322, 125, '2015-04-01 00:36:16.000000', 'consum', 0.0231, 'lps'),
	(476323, 125, '2015-04-01 00:36:17.000000', 'consum', 0.0233, 'lps'),
	(476324, 125, '2015-04-01 00:36:18.000000', 'consum', 0.0216, 'lps'),
	(476325, 125, '2015-04-01 00:36:19.000000', 'consum', 0.0217, 'lps'),
	(476326, 125, '2015-04-01 00:36:20.000000', 'consum', 0.0229, 'lps'),
	(476327, 125, '2015-04-01 00:36:21.000000', 'consum', 0.0212, 'lps'),
	(476328, 125, '2015-04-01 00:36:22.000000', 'consum', 0.0214, 'lps'),
	(476329, 125, '2015-04-01 00:36:23.000000', 'consum', 0.0222, 'lps'),
	(476330, 125, '2015-04-01 00:36:24.000000', 'consum', 0.0233, 'lps'),
	(476331, 125, '2015-04-01 00:36:25.000000', 'consum', 0.0220, 'lps'),
	(476332, 125, '2015-04-01 00:36:26.000000', 'consum', 0.0214, 'lps'),
	(476333, 125, '2015-04-01 00:36:27.000000', 'consum', 0.0226, 'lps'),
	(476334, 125, '2015-04-01 00:36:28.000000', 'consum', 0.0230, 'lps'),
	(476335, 125, '2015-04-01 00:36:29.000000', 'consum', 0.0214, 'lps'),
	(476336, 125, '2015-04-01 00:36:30.000000', 'consum', 0.0218, 'lps'),
	(476337, 125, '2015-04-01 00:36:31.000000', 'consum', 0.0216, 'lps'),
	(476338, 125, '2015-04-01 00:36:32.000000', 'consum', 0.0217, 'lps'),
	(476339, 125, '2015-04-01 00:36:33.000000', 'consum', 0.0226, 'lps'),
	(476340, 125, '2015-04-01 00:36:34.000000', 'consum', 0.0224, 'lps'),
	(476341, 125, '2015-04-01 00:36:35.000000', 'consum', 0.0232, 'lps'),
	(476342, 125, '2015-04-01 00:36:36.000000', 'consum', 0.0228, 'lps'),
	(476343, 125, '2015-04-01 00:36:37.000000', 'consum', 0.0212, 'lps'),
	(476344, 125, '2015-04-01 00:36:38.000000', 'consum', 0.0215, 'lps'),
	(476345, 125, '2015-04-01 00:36:39.000000', 'consum', 0.0230, 'lps'),
	(476346, 125, '2015-04-01 00:36:40.000000', 'consum', 0.0224, 'lps'),
	(476347, 125, '2015-04-01 00:36:41.000000', 'consum', 0.0221, 'lps'),
	(476348, 125, '2015-04-01 00:36:42.000000', 'consum', 0.0224, 'lps'),
	(476349, 125, '2015-04-01 00:36:43.000000', 'consum', 0.0224, 'lps'),
	(476350, 125, '2015-04-01 00:36:44.000000', 'consum', 0.0214, 'lps'),
	(476351, 125, '2015-04-01 00:36:45.000000', 'consum', 0.0211, 'lps'),
	(476352, 125, '2015-04-01 00:36:46.000000', 'consum', 0.0229, 'lps'),
	(476353, 125, '2015-04-01 00:36:47.000000', 'consum', 0.0229, 'lps'),
	(476354, 125, '2015-04-01 00:36:48.000000', 'consum', 0.0225, 'lps'),
	(476355, 125, '2015-04-01 00:36:49.000000', 'consum', 0.0229, 'lps'),
	(476356, 125, '2015-04-01 00:36:50.000000', 'consum', 0.0214, 'lps'),
	(476357, 125, '2015-04-01 00:36:51.000000', 'consum', 0.0220, 'lps'),
	(476358, 125, '2015-04-01 00:36:52.000000', 'consum', 0.0225, 'lps'),
	(476359, 125, '2015-04-01 00:36:53.000000', 'consum', 0.0231, 'lps'),
	(476360, 125, '2015-04-01 00:36:54.000000', 'consum', 0.0223, 'lps'),
	(476361, 125, '2015-04-01 00:36:55.000000', 'consum', 0.0213, 'lps'),
	(476362, 125, '2015-04-01 00:36:56.000000', 'consum', 0.0212, 'lps'),
	(476363, 125, '2015-04-01 00:36:57.000000', 'consum', 0.0210, 'lps'),
	(476364, 125, '2015-04-01 00:36:58.000000', 'consum', 0.0229, 'lps'),
	(476365, 125, '2015-04-01 00:36:59.000000', 'consum', 0.0210, 'lps'),
	(476366, 125, '2015-04-01 00:37:00.000000', 'consum', 0.0225, 'lps'),
	(476367, 125, '2015-04-01 00:37:01.000000', 'consum', 0.0212, 'lps'),
	(476368, 125, '2015-04-01 00:37:02.000000', 'consum', 0.0227, 'lps'),
	(476369, 125, '2015-04-01 00:37:03.000000', 'consum', 0.0214, 'lps'),
	(476370, 125, '2015-04-01 00:37:04.000000', 'consum', 0.0230, 'lps'),
	(476371, 125, '2015-04-01 00:37:05.000000', 'consum', 0.0224, 'lps'),
	(476372, 125, '2015-04-01 00:37:06.000000', 'consum', 0.0221, 'lps'),
	(476373, 125, '2015-04-01 00:37:07.000000', 'consum', 0.0223, 'lps'),
	(476374, 125, '2015-04-01 00:37:08.000000', 'consum', 0.0220, 'lps'),
	(476375, 125, '2015-04-01 00:37:09.000000', 'consum', 0.0220, 'lps'),
	(476376, 125, '2015-04-01 00:37:10.000000', 'consum', 0.0232, 'lps'),
	(476377, 125, '2015-04-01 00:37:11.000000', 'consum', 0.0218, 'lps'),
	(476378, 125, '2015-04-01 00:37:12.000000', 'consum', 0.0210, 'lps'),
	(476379, 125, '2015-04-01 00:37:13.000000', 'consum', 0.0233, 'lps'),
	(476380, 125, '2015-04-01 00:37:14.000000', 'consum', 0.0229, 'lps'),
	(476381, 125, '2015-04-01 00:37:15.000000', 'consum', 0.0213, 'lps'),
	(476382, 125, '2015-04-01 00:37:16.000000', 'consum', 0.0218, 'lps'),
	(476383, 125, '2015-04-01 00:37:17.000000', 'consum', 0.0216, 'lps'),
	(476384, 125, '2015-04-01 00:37:18.000000', 'consum', 0.0215, 'lps'),
	(476385, 125, '2015-04-01 00:37:19.000000', 'consum', 0.0221, 'lps'),
	(476386, 125, '2015-04-01 00:37:20.000000', 'consum', 0.0223, 'lps'),
	(476387, 125, '2015-04-01 00:37:21.000000', 'consum', 0.0220, 'lps'),
	(476388, 125, '2015-04-01 00:37:22.000000', 'consum', 0.0221, 'lps'),
	(476389, 125, '2015-04-01 00:37:23.000000', 'consum', 0.0211, 'lps'),
	(476390, 125, '2015-04-01 00:37:24.000000', 'consum', 0.0232, 'lps'),
	(476391, 125, '2015-04-01 00:37:25.000000', 'consum', 0.0223, 'lps'),
	(476392, 125, '2015-04-01 00:37:26.000000', 'consum', 0.0231, 'lps'),
	(476393, 125, '2015-04-01 00:37:27.000000', 'consum', 0.0229, 'lps'),
	(476394, 125, '2015-04-01 00:37:28.000000', 'consum', 0.0217, 'lps'),
	(476395, 125, '2015-04-01 00:37:29.000000', 'consum', 0.0215, 'lps'),
	(476396, 125, '2015-04-01 00:37:30.000000', 'consum', 0.0213, 'lps'),
	(476397, 125, '2015-04-01 00:37:31.000000', 'consum', 0.0210, 'lps'),
	(476398, 125, '2015-04-01 00:37:32.000000', 'consum', 0.0227, 'lps'),
	(476399, 125, '2015-04-01 00:37:33.000000', 'consum', 0.0221, 'lps'),
	(476400, 125, '2015-04-01 00:37:34.000000', 'consum', 0.0216, 'lps'),
	(476401, 125, '2015-04-01 00:37:35.000000', 'consum', 0.0231, 'lps'),
	(476402, 125, '2015-04-01 00:37:36.000000', 'consum', 0.0226, 'lps'),
	(476403, 125, '2015-04-01 00:37:37.000000', 'consum', 0.0228, 'lps'),
	(476404, 125, '2015-04-01 00:37:38.000000', 'consum', 0.0228, 'lps'),
	(476405, 125, '2015-04-01 00:37:39.000000', 'consum', 0.0222, 'lps'),
	(476406, 125, '2015-04-01 00:37:40.000000', 'consum', 0.0216, 'lps'),
	(476407, 125, '2015-04-01 00:37:41.000000', 'consum', 0.0228, 'lps'),
	(476408, 125, '2015-04-01 00:37:42.000000', 'consum', 0.0212, 'lps'),
	(476409, 125, '2015-04-01 00:37:43.000000', 'consum', 0.0214, 'lps'),
	(476410, 125, '2015-04-01 00:37:44.000000', 'consum', 0.0223, 'lps'),
	(476411, 125, '2015-04-01 00:37:45.000000', 'consum', 0.0217, 'lps'),
	(476412, 125, '2015-04-01 00:37:46.000000', 'consum', 0.0232, 'lps'),
	(476413, 125, '2015-04-01 00:37:47.000000', 'consum', 0.0226, 'lps'),
	(476414, 125, '2015-04-01 00:37:48.000000', 'consum', 0.0224, 'lps'),
	(476415, 125, '2015-04-01 00:37:49.000000', 'consum', 0.0231, 'lps'),
	(476416, 125, '2015-04-01 00:37:50.000000', 'consum', 0.0228, 'lps'),
	(476417, 125, '2015-04-01 00:37:51.000000', 'consum', 0.0214, 'lps'),
	(476418, 125, '2015-04-01 00:37:52.000000', 'consum', 0.0224, 'lps'),
	(476419, 125, '2015-04-01 00:37:53.000000', 'consum', 0.0219, 'lps'),
	(476420, 125, '2015-04-01 00:37:54.000000', 'consum', 0.0214, 'lps'),
	(476421, 125, '2015-04-01 00:37:55.000000', 'consum', 0.0227, 'lps'),
	(476422, 125, '2015-04-01 00:37:56.000000', 'consum', 0.0213, 'lps'),
	(476423, 125, '2015-04-01 00:37:57.000000', 'consum', 0.0223, 'lps'),
	(476424, 125, '2015-04-01 00:37:58.000000', 'consum', 0.0216, 'lps'),
	(476425, 125, '2015-04-01 00:37:59.000000', 'consum', 0.0226, 'lps'),
	(476426, 125, '2015-04-01 00:38:00.000000', 'consum', 0.0224, 'lps'),
	(476427, 125, '2015-04-01 00:38:01.000000', 'consum', 0.0211, 'lps'),
	(476428, 125, '2015-04-01 00:38:02.000000', 'consum', 0.0221, 'lps'),
	(476429, 125, '2015-04-01 00:38:03.000000', 'consum', 0.0212, 'lps'),
	(476430, 125, '2015-04-01 00:38:04.000000', 'consum', 0.0214, 'lps'),
	(476431, 125, '2015-04-01 00:38:05.000000', 'consum', 0.0224, 'lps'),
	(476432, 125, '2015-04-01 00:38:06.000000', 'consum', 0.0220, 'lps'),
	(476433, 125, '2015-04-01 00:38:07.000000', 'consum', 0.0218, 'lps'),
	(476434, 125, '2015-04-01 00:38:08.000000', 'consum', 0.0222, 'lps'),
	(476435, 125, '2015-04-01 00:38:09.000000', 'consum', 0.0222, 'lps'),
	(476436, 125, '2015-04-01 00:38:10.000000', 'consum', 0.0211, 'lps'),
	(476437, 125, '2015-04-01 00:38:11.000000', 'consum', 0.0225, 'lps'),
	(476438, 125, '2015-04-01 00:38:12.000000', 'consum', 0.0214, 'lps'),
	(476439, 125, '2015-04-01 00:38:13.000000', 'consum', 0.0230, 'lps'),
	(476440, 125, '2015-04-01 00:38:14.000000', 'consum', 0.0229, 'lps'),
	(476441, 125, '2015-04-01 00:38:15.000000', 'consum', 0.0219, 'lps'),
	(476442, 125, '2015-04-01 00:38:16.000000', 'consum', 0.0222, 'lps'),
	(476443, 125, '2015-04-01 00:38:17.000000', 'consum', 0.0222, 'lps'),
	(476444, 125, '2015-04-01 00:38:18.000000', 'consum', 0.0233, 'lps'),
	(476445, 125, '2015-04-01 00:38:19.000000', 'consum', 0.0216, 'lps'),
	(476446, 125, '2015-04-01 00:38:20.000000', 'consum', 0.0221, 'lps'),
	(476447, 125, '2015-04-01 00:38:21.000000', 'consum', 0.0224, 'lps'),
	(476448, 125, '2015-04-01 00:38:22.000000', 'consum', 0.0222, 'lps'),
	(476449, 125, '2015-04-01 00:38:23.000000', 'consum', 0.0230, 'lps'),
	(476450, 125, '2015-04-01 00:38:24.000000', 'consum', 0.0228, 'lps'),
	(476451, 125, '2015-04-01 00:38:25.000000', 'consum', 0.0215, 'lps'),
	(476452, 125, '2015-04-01 00:38:26.000000', 'consum', 0.0229, 'lps'),
	(476453, 125, '2015-04-01 00:38:27.000000', 'consum', 0.0218, 'lps'),
	(476454, 125, '2015-04-01 00:38:28.000000', 'consum', 0.0219, 'lps'),
	(476455, 125, '2015-04-01 00:38:29.000000', 'consum', 0.0229, 'lps'),
	(476456, 125, '2015-04-01 00:38:30.000000', 'consum', 0.0231, 'lps'),
	(476457, 125, '2015-04-01 00:38:31.000000', 'consum', 0.0212, 'lps'),
	(476458, 125, '2015-04-01 00:38:32.000000', 'consum', 0.0230, 'lps'),
	(476459, 125, '2015-04-01 00:38:33.000000', 'consum', 0.0233, 'lps'),
	(476460, 125, '2015-04-01 00:38:34.000000', 'consum', 0.0219, 'lps'),
	(476461, 125, '2015-04-01 00:38:35.000000', 'consum', 0.0231, 'lps'),
	(476462, 125, '2015-04-01 00:38:36.000000', 'consum', 0.0219, 'lps'),
	(476463, 125, '2015-04-01 00:38:37.000000', 'consum', 0.0215, 'lps'),
	(476464, 125, '2015-04-01 00:38:38.000000', 'consum', 0.0232, 'lps'),
	(476465, 125, '2015-04-01 00:38:39.000000', 'consum', 0.0233, 'lps'),
	(476466, 125, '2015-04-01 00:38:40.000000', 'consum', 0.0214, 'lps'),
	(476467, 125, '2015-04-01 00:38:41.000000', 'consum', 0.0231, 'lps'),
	(476468, 125, '2015-04-01 00:38:42.000000', 'consum', 0.0233, 'lps'),
	(476469, 125, '2015-04-01 00:38:43.000000', 'consum', 0.0212, 'lps'),
	(476470, 125, '2015-04-01 00:38:44.000000', 'consum', 0.0225, 'lps'),
	(476471, 125, '2015-04-01 00:38:45.000000', 'consum', 0.0232, 'lps'),
	(476472, 125, '2015-04-01 00:38:46.000000', 'consum', 0.0228, 'lps'),
	(476473, 125, '2015-04-01 00:38:47.000000', 'consum', 0.0212, 'lps'),
	(476474, 125, '2015-04-01 00:38:48.000000', 'consum', 0.0211, 'lps'),
	(476475, 125, '2015-04-01 00:38:49.000000', 'consum', 0.0211, 'lps'),
	(476476, 125, '2015-04-01 00:38:50.000000', 'consum', 0.0214, 'lps'),
	(476477, 125, '2015-04-01 00:38:51.000000', 'consum', 0.0228, 'lps'),
	(476478, 125, '2015-04-01 00:38:52.000000', 'consum', 0.0214, 'lps'),
	(476479, 125, '2015-04-01 00:38:53.000000', 'consum', 0.0224, 'lps'),
	(476480, 125, '2015-04-01 00:38:54.000000', 'consum', 0.0224, 'lps'),
	(476481, 125, '2015-04-01 00:38:55.000000', 'consum', 0.0211, 'lps'),
	(476482, 125, '2015-04-01 00:38:56.000000', 'consum', 0.0224, 'lps'),
	(476483, 125, '2015-04-01 00:38:57.000000', 'consum', 0.0228, 'lps'),
	(476484, 125, '2015-04-01 00:38:58.000000', 'consum', 0.0212, 'lps'),
	(476485, 125, '2015-04-01 00:38:59.000000', 'consum', 0.0215, 'lps'),
	(476486, 125, '2015-04-01 00:39:00.000000', 'consum', 0.0230, 'lps'),
	(476487, 125, '2015-04-01 00:39:01.000000', 'consum', 0.0221, 'lps'),
	(476488, 125, '2015-04-01 00:39:02.000000', 'consum', 0.0232, 'lps'),
	(476489, 125, '2015-04-01 00:39:03.000000', 'consum', 0.0216, 'lps'),
	(476490, 125, '2015-04-01 00:39:04.000000', 'consum', 0.0220, 'lps'),
	(476491, 125, '2015-04-01 00:39:05.000000', 'consum', 0.0221, 'lps'),
	(476492, 125, '2015-04-01 00:39:06.000000', 'consum', 0.0211, 'lps'),
	(476493, 125, '2015-04-01 00:39:07.000000', 'consum', 0.0232, 'lps'),
	(476494, 125, '2015-04-01 00:39:08.000000', 'consum', 0.0220, 'lps'),
	(476495, 125, '2015-04-01 00:39:09.000000', 'consum', 0.0219, 'lps'),
	(476496, 125, '2015-04-01 00:39:10.000000', 'consum', 0.0226, 'lps'),
	(476497, 125, '2015-04-01 00:39:11.000000', 'consum', 0.0215, 'lps'),
	(476498, 125, '2015-04-01 00:39:12.000000', 'consum', 0.0212, 'lps'),
	(476499, 125, '2015-04-01 00:39:13.000000', 'consum', 0.0231, 'lps'),
	(476500, 125, '2015-04-01 00:39:14.000000', 'consum', 0.0212, 'lps'),
	(476501, 125, '2015-04-01 00:39:15.000000', 'consum', 0.0229, 'lps'),
	(476502, 125, '2015-04-01 00:39:16.000000', 'consum', 0.0226, 'lps'),
	(476503, 125, '2015-04-01 00:39:17.000000', 'consum', 0.0213, 'lps'),
	(476504, 125, '2015-04-01 00:39:18.000000', 'consum', 0.0222, 'lps'),
	(476505, 125, '2015-04-01 00:39:19.000000', 'consum', 0.0216, 'lps'),
	(476506, 125, '2015-04-01 00:39:20.000000', 'consum', 0.0229, 'lps'),
	(476507, 125, '2015-04-01 00:39:21.000000', 'consum', 0.0215, 'lps'),
	(476508, 125, '2015-04-01 00:39:22.000000', 'consum', 0.0227, 'lps'),
	(476509, 125, '2015-04-01 00:39:23.000000', 'consum', 0.0210, 'lps'),
	(476510, 125, '2015-04-01 00:39:24.000000', 'consum', 0.0230, 'lps'),
	(476511, 125, '2015-04-01 00:39:25.000000', 'consum', 0.0213, 'lps'),
	(476512, 125, '2015-04-01 00:39:26.000000', 'consum', 0.0214, 'lps'),
	(476513, 125, '2015-04-01 00:39:27.000000', 'consum', 0.0220, 'lps'),
	(476514, 125, '2015-04-01 00:39:28.000000', 'consum', 0.0227, 'lps'),
	(476515, 125, '2015-04-01 00:39:29.000000', 'consum', 0.0217, 'lps'),
	(476516, 125, '2015-04-01 00:39:30.000000', 'consum', 0.0216, 'lps'),
	(476517, 125, '2015-04-01 00:39:31.000000', 'consum', 0.0222, 'lps'),
	(476518, 125, '2015-04-01 00:39:32.000000', 'consum', 0.0229, 'lps'),
	(476519, 125, '2015-04-01 00:39:33.000000', 'consum', 0.0222, 'lps'),
	(476520, 125, '2015-04-01 00:39:34.000000', 'consum', 0.0213, 'lps'),
	(476521, 125, '2015-04-01 00:39:35.000000', 'consum', 0.0212, 'lps'),
	(476522, 125, '2015-04-01 00:39:36.000000', 'consum', 0.0210, 'lps'),
	(476523, 125, '2015-04-01 00:39:37.000000', 'consum', 0.0231, 'lps'),
	(476524, 125, '2015-04-01 00:39:38.000000', 'consum', 0.0219, 'lps'),
	(476525, 125, '2015-04-01 00:39:39.000000', 'consum', 0.0218, 'lps'),
	(476526, 125, '2015-04-01 00:39:40.000000', 'consum', 0.0221, 'lps'),
	(476527, 125, '2015-04-01 00:39:41.000000', 'consum', 0.0218, 'lps'),
	(476528, 125, '2015-04-01 00:39:42.000000', 'consum', 0.0216, 'lps'),
	(476529, 125, '2015-04-01 00:39:43.000000', 'consum', 0.0219, 'lps'),
	(476530, 125, '2015-04-01 00:39:44.000000', 'consum', 0.0214, 'lps'),
	(476531, 125, '2015-04-01 00:39:45.000000', 'consum', 0.0228, 'lps'),
	(476532, 125, '2015-04-01 00:39:46.000000', 'consum', 0.0215, 'lps'),
	(476533, 125, '2015-04-01 00:39:47.000000', 'consum', 0.0229, 'lps'),
	(476534, 125, '2015-04-01 00:39:48.000000', 'consum', 0.0219, 'lps'),
	(476535, 125, '2015-04-01 00:39:49.000000', 'consum', 0.0222, 'lps'),
	(476536, 125, '2015-04-01 00:39:50.000000', 'consum', 0.0221, 'lps'),
	(476537, 125, '2015-04-01 00:39:51.000000', 'consum', 0.0230, 'lps'),
	(476538, 125, '2015-04-01 00:39:52.000000', 'consum', 0.0227, 'lps'),
	(476539, 125, '2015-04-01 00:39:53.000000', 'consum', 0.0211, 'lps'),
	(476540, 125, '2015-04-01 00:39:54.000000', 'consum', 0.0212, 'lps'),
	(476541, 125, '2015-04-01 00:39:55.000000', 'consum', 0.0219, 'lps'),
	(476542, 125, '2015-04-01 00:39:56.000000', 'consum', 0.0223, 'lps'),
	(476543, 125, '2015-04-01 00:39:57.000000', 'consum', 0.0227, 'lps'),
	(476544, 125, '2015-04-01 00:39:58.000000', 'consum', 0.0232, 'lps'),
	(476545, 125, '2015-04-01 00:39:59.000000', 'consum', 0.0222, 'lps'),
	(476546, 125, '2015-04-01 00:40:00.000000', 'consum', 0.0227, 'lps'),
	(476547, 125, '2015-04-01 00:40:01.000000', 'consum', 0.0214, 'lps'),
	(476548, 125, '2015-04-01 00:40:02.000000', 'consum', 0.0224, 'lps'),
	(476549, 125, '2015-04-01 00:40:03.000000', 'consum', 0.0223, 'lps'),
	(476550, 125, '2015-04-01 00:40:04.000000', 'consum', 0.0211, 'lps'),
	(476551, 125, '2015-04-01 00:40:05.000000', 'consum', 0.0222, 'lps'),
	(476552, 125, '2015-04-01 00:40:06.000000', 'consum', 0.0218, 'lps'),
	(476553, 125, '2015-04-01 00:40:07.000000', 'consum', 0.0217, 'lps'),
	(476554, 125, '2015-04-01 00:40:08.000000', 'consum', 0.0220, 'lps'),
	(476555, 125, '2015-04-01 00:40:09.000000', 'consum', 0.0216, 'lps'),
	(476556, 125, '2015-04-01 00:40:10.000000', 'consum', 0.0210, 'lps'),
	(476557, 125, '2015-04-01 00:40:11.000000', 'consum', 0.0215, 'lps'),
	(476558, 125, '2015-04-01 00:40:12.000000', 'consum', 0.0214, 'lps'),
	(476559, 125, '2015-04-01 00:40:13.000000', 'consum', 0.0213, 'lps'),
	(476560, 125, '2015-04-01 00:40:14.000000', 'consum', 0.0213, 'lps'),
	(476561, 125, '2015-04-01 00:40:15.000000', 'consum', 0.0217, 'lps'),
	(476562, 125, '2015-04-01 00:40:16.000000', 'consum', 0.0211, 'lps'),
	(476563, 125, '2015-04-01 00:40:17.000000', 'consum', 0.0219, 'lps'),
	(476564, 125, '2015-04-01 00:40:18.000000', 'consum', 0.0231, 'lps'),
	(476565, 125, '2015-04-01 00:40:19.000000', 'consum', 0.0215, 'lps'),
	(476566, 125, '2015-04-01 00:40:20.000000', 'consum', 0.0222, 'lps'),
	(476567, 125, '2015-04-01 00:40:21.000000', 'consum', 0.0229, 'lps'),
	(476568, 125, '2015-04-01 00:40:22.000000', 'consum', 0.0223, 'lps'),
	(476569, 125, '2015-04-01 00:40:23.000000', 'consum', 0.0220, 'lps'),
	(476570, 125, '2015-04-01 00:40:24.000000', 'consum', 0.0218, 'lps'),
	(476571, 125, '2015-04-01 00:40:25.000000', 'consum', 0.0223, 'lps'),
	(476572, 125, '2015-04-01 00:40:26.000000', 'consum', 0.0225, 'lps'),
	(476573, 125, '2015-04-01 00:40:27.000000', 'consum', 0.0225, 'lps'),
	(476574, 125, '2015-04-01 00:40:28.000000', 'consum', 0.0216, 'lps'),
	(476575, 125, '2015-04-01 00:40:29.000000', 'consum', 0.0221, 'lps'),
	(476576, 125, '2015-04-01 00:40:30.000000', 'consum', 0.0223, 'lps'),
	(476577, 125, '2015-04-01 00:40:31.000000', 'consum', 0.0216, 'lps'),
	(476578, 125, '2015-04-01 00:40:32.000000', 'consum', 0.0227, 'lps'),
	(476579, 125, '2015-04-01 00:40:33.000000', 'consum', 0.0227, 'lps'),
	(476580, 125, '2015-04-01 00:40:34.000000', 'consum', 0.0224, 'lps'),
	(476581, 125, '2015-04-01 00:40:35.000000', 'consum', 0.0227, 'lps'),
	(476582, 125, '2015-04-01 00:40:36.000000', 'consum', 0.0231, 'lps'),
	(476583, 125, '2015-04-01 00:40:37.000000', 'consum', 0.0217, 'lps'),
	(476584, 125, '2015-04-01 00:40:38.000000', 'consum', 0.0232, 'lps'),
	(476585, 125, '2015-04-01 00:40:39.000000', 'consum', 0.0226, 'lps'),
	(476586, 125, '2015-04-01 00:40:40.000000', 'consum', 0.0223, 'lps'),
	(476587, 125, '2015-04-01 00:40:41.000000', 'consum', 0.0228, 'lps'),
	(476588, 125, '2015-04-01 00:40:42.000000', 'consum', 0.0213, 'lps'),
	(476589, 125, '2015-04-01 00:40:43.000000', 'consum', 0.0222, 'lps'),
	(476590, 125, '2015-04-01 00:40:44.000000', 'consum', 0.0212, 'lps'),
	(476591, 125, '2015-04-01 00:40:45.000000', 'consum', 0.0233, 'lps'),
	(476592, 125, '2015-04-01 00:40:46.000000', 'consum', 0.0221, 'lps'),
	(476593, 125, '2015-04-01 00:40:47.000000', 'consum', 0.0223, 'lps'),
	(476594, 125, '2015-04-01 00:40:48.000000', 'consum', 0.0216, 'lps'),
	(476595, 125, '2015-04-01 00:40:49.000000', 'consum', 0.0226, 'lps'),
	(476596, 125, '2015-04-01 00:40:50.000000', 'consum', 0.0226, 'lps'),
	(476597, 125, '2015-04-01 00:40:51.000000', 'consum', 0.0218, 'lps'),
	(476598, 125, '2015-04-01 00:40:52.000000', 'consum', 0.0228, 'lps'),
	(476599, 125, '2015-04-01 00:40:53.000000', 'consum', 0.0229, 'lps'),
	(476600, 125, '2015-04-01 00:40:54.000000', 'consum', 0.0224, 'lps'),
	(476601, 125, '2015-04-01 00:40:55.000000', 'consum', 0.0226, 'lps'),
	(476602, 125, '2015-04-01 00:40:56.000000', 'consum', 0.0225, 'lps'),
	(476603, 125, '2015-04-01 00:40:57.000000', 'consum', 0.0212, 'lps'),
	(476604, 125, '2015-04-01 00:40:58.000000', 'consum', 0.0222, 'lps'),
	(476605, 125, '2015-04-01 00:40:59.000000', 'consum', 0.0220, 'lps'),
	(476606, 125, '2015-04-01 00:41:00.000000', 'consum', 0.0222, 'lps'),
	(476607, 125, '2015-04-01 00:41:01.000000', 'consum', 0.0216, 'lps'),
	(476608, 125, '2015-04-01 00:41:02.000000', 'consum', 0.0230, 'lps'),
	(476609, 125, '2015-04-01 00:41:03.000000', 'consum', 0.0221, 'lps'),
	(476610, 125, '2015-04-01 00:41:04.000000', 'consum', 0.0227, 'lps'),
	(476611, 125, '2015-04-01 00:41:05.000000', 'consum', 0.0217, 'lps'),
	(476612, 125, '2015-04-01 00:41:06.000000', 'consum', 0.0218, 'lps'),
	(476613, 125, '2015-04-01 00:41:07.000000', 'consum', 0.0231, 'lps'),
	(476614, 125, '2015-04-01 00:41:08.000000', 'consum', 0.0219, 'lps'),
	(476615, 125, '2015-04-01 00:41:09.000000', 'consum', 0.0215, 'lps'),
	(476616, 125, '2015-04-01 00:41:10.000000', 'consum', 0.0231, 'lps'),
	(476617, 125, '2015-04-01 00:41:11.000000', 'consum', 0.0230, 'lps'),
	(476618, 125, '2015-04-01 00:41:12.000000', 'consum', 0.0226, 'lps'),
	(476619, 125, '2015-04-01 00:41:13.000000', 'consum', 0.0227, 'lps'),
	(476620, 125, '2015-04-01 00:41:14.000000', 'consum', 0.0224, 'lps'),
	(476621, 125, '2015-04-01 00:41:15.000000', 'consum', 0.0228, 'lps'),
	(476622, 125, '2015-04-01 00:41:16.000000', 'consum', 0.0213, 'lps'),
	(476623, 125, '2015-04-01 00:41:17.000000', 'consum', 0.0219, 'lps'),
	(476624, 125, '2015-04-01 00:41:18.000000', 'consum', 0.0222, 'lps'),
	(476625, 125, '2015-04-01 00:41:19.000000', 'consum', 0.0220, 'lps'),
	(476626, 125, '2015-04-01 00:41:20.000000', 'consum', 0.0225, 'lps'),
	(476627, 125, '2015-04-01 00:41:21.000000', 'consum', 0.0232, 'lps'),
	(476628, 125, '2015-04-01 00:41:22.000000', 'consum', 0.0226, 'lps'),
	(476629, 125, '2015-04-01 00:41:23.000000', 'consum', 0.0227, 'lps'),
	(476630, 125, '2015-04-01 00:41:24.000000', 'consum', 0.0222, 'lps'),
	(476631, 125, '2015-04-01 00:41:25.000000', 'consum', 0.0219, 'lps'),
	(476632, 125, '2015-04-01 00:41:26.000000', 'consum', 0.0219, 'lps'),
	(476633, 125, '2015-04-01 00:41:27.000000', 'consum', 0.0229, 'lps'),
	(476634, 125, '2015-04-01 00:41:28.000000', 'consum', 0.0231, 'lps'),
	(476635, 125, '2015-04-01 00:41:29.000000', 'consum', 0.0233, 'lps'),
	(476636, 125, '2015-04-01 00:41:30.000000', 'consum', 0.0213, 'lps'),
	(476637, 125, '2015-04-01 00:41:31.000000', 'consum', 0.0232, 'lps'),
	(476638, 125, '2015-04-01 00:41:32.000000', 'consum', 0.0214, 'lps'),
	(476639, 125, '2015-04-01 00:41:33.000000', 'consum', 0.0213, 'lps'),
	(476640, 125, '2015-04-01 00:41:34.000000', 'consum', 0.0212, 'lps'),
	(476641, 125, '2015-04-01 00:41:35.000000', 'consum', 0.0212, 'lps'),
	(476642, 125, '2015-04-01 00:41:36.000000', 'consum', 0.0216, 'lps'),
	(476643, 125, '2015-04-01 00:41:37.000000', 'consum', 0.0210, 'lps'),
	(476644, 125, '2015-04-01 00:41:38.000000', 'consum', 0.0216, 'lps'),
	(476645, 125, '2015-04-01 00:41:39.000000', 'consum', 0.0216, 'lps'),
	(476646, 125, '2015-04-01 00:41:40.000000', 'consum', 0.0222, 'lps'),
	(476647, 125, '2015-04-01 00:41:41.000000', 'consum', 0.0228, 'lps'),
	(476648, 125, '2015-04-01 00:41:42.000000', 'consum', 0.0218, 'lps'),
	(476649, 125, '2015-04-01 00:41:43.000000', 'consum', 0.0221, 'lps'),
	(476650, 125, '2015-04-01 00:41:44.000000', 'consum', 0.0217, 'lps'),
	(476651, 125, '2015-04-01 00:41:45.000000', 'consum', 0.0210, 'lps'),
	(476652, 125, '2015-04-01 00:41:46.000000', 'consum', 0.0217, 'lps'),
	(476653, 125, '2015-04-01 00:41:47.000000', 'consum', 0.0221, 'lps'),
	(476654, 125, '2015-04-01 00:41:48.000000', 'consum', 0.0221, 'lps'),
	(476655, 125, '2015-04-01 00:41:49.000000', 'consum', 0.0231, 'lps'),
	(476656, 125, '2015-04-01 00:41:50.000000', 'consum', 0.0211, 'lps'),
	(476657, 125, '2015-04-01 00:41:51.000000', 'consum', 0.0223, 'lps'),
	(476658, 125, '2015-04-01 00:41:52.000000', 'consum', 0.0227, 'lps'),
	(476659, 125, '2015-04-01 00:41:53.000000', 'consum', 0.0230, 'lps'),
	(476660, 125, '2015-04-01 00:41:54.000000', 'consum', 0.0213, 'lps'),
	(476661, 125, '2015-04-01 00:41:55.000000', 'consum', 0.0213, 'lps'),
	(476662, 125, '2015-04-01 00:41:56.000000', 'consum', 0.0219, 'lps'),
	(476663, 125, '2015-04-01 00:41:57.000000', 'consum', 0.0219, 'lps'),
	(476664, 125, '2015-04-01 00:41:58.000000', 'consum', 0.0229, 'lps'),
	(476665, 125, '2015-04-01 00:41:59.000000', 'consum', 0.0231, 'lps'),
	(476666, 125, '2015-04-01 00:42:00.000000', 'consum', 0.0233, 'lps'),
	(476667, 125, '2015-04-01 00:42:01.000000', 'consum', 0.0216, 'lps'),
	(476668, 125, '2015-04-01 00:42:02.000000', 'consum', 0.0217, 'lps'),
	(476669, 125, '2015-04-01 00:42:03.000000', 'consum', 0.0230, 'lps'),
	(476670, 125, '2015-04-01 00:42:04.000000', 'consum', 0.0216, 'lps'),
	(476671, 125, '2015-04-01 00:42:05.000000', 'consum', 0.0229, 'lps'),
	(476672, 125, '2015-04-01 00:42:06.000000', 'consum', 0.0214, 'lps'),
	(476673, 125, '2015-04-01 00:42:07.000000', 'consum', 0.0221, 'lps'),
	(476674, 125, '2015-04-01 00:42:08.000000', 'consum', 0.0232, 'lps'),
	(476675, 125, '2015-04-01 00:42:09.000000', 'consum', 0.0216, 'lps'),
	(476676, 125, '2015-04-01 00:42:10.000000', 'consum', 0.0221, 'lps'),
	(476677, 125, '2015-04-01 00:42:11.000000', 'consum', 0.0223, 'lps'),
	(476678, 125, '2015-04-01 00:42:12.000000', 'consum', 0.0220, 'lps'),
	(476679, 125, '2015-04-01 00:42:13.000000', 'consum', 0.0220, 'lps'),
	(476680, 125, '2015-04-01 00:42:14.000000', 'consum', 0.0231, 'lps'),
	(476681, 125, '2015-04-01 00:42:15.000000', 'consum', 0.0211, 'lps'),
	(476682, 125, '2015-04-01 00:42:16.000000', 'consum', 0.0228, 'lps'),
	(476683, 125, '2015-04-01 00:42:17.000000', 'consum', 0.0226, 'lps'),
	(476684, 125, '2015-04-01 00:42:18.000000', 'consum', 0.0212, 'lps'),
	(476685, 125, '2015-04-01 00:42:19.000000', 'consum', 0.0220, 'lps'),
	(476686, 125, '2015-04-01 00:42:20.000000', 'consum', 0.0232, 'lps'),
	(476687, 125, '2015-04-01 00:42:21.000000', 'consum', 0.0217, 'lps'),
	(476688, 125, '2015-04-01 00:42:22.000000', 'consum', 0.0226, 'lps'),
	(476689, 125, '2015-04-01 00:42:23.000000', 'consum', 0.0223, 'lps'),
	(476690, 125, '2015-04-01 00:42:24.000000', 'consum', 0.0228, 'lps'),
	(476691, 125, '2015-04-01 00:42:25.000000', 'consum', 0.0215, 'lps'),
	(476692, 125, '2015-04-01 00:42:26.000000', 'consum', 0.0228, 'lps'),
	(476693, 125, '2015-04-01 00:42:27.000000', 'consum', 0.0214, 'lps'),
	(476694, 125, '2015-04-01 00:42:28.000000', 'consum', 0.0224, 'lps'),
	(476695, 125, '2015-04-01 00:42:29.000000', 'consum', 0.0223, 'lps'),
	(476696, 125, '2015-04-01 00:42:30.000000', 'consum', 0.0230, 'lps'),
	(476697, 125, '2015-04-01 00:42:31.000000', 'consum', 0.0226, 'lps'),
	(476698, 125, '2015-04-01 00:42:32.000000', 'consum', 0.0232, 'lps'),
	(476699, 125, '2015-04-01 00:42:33.000000', 'consum', 0.0221, 'lps'),
	(476700, 125, '2015-04-01 00:42:34.000000', 'consum', 0.0225, 'lps'),
	(476701, 125, '2015-04-01 00:42:35.000000', 'consum', 0.0230, 'lps'),
	(476702, 125, '2015-04-01 00:42:36.000000', 'consum', 0.0215, 'lps'),
	(476703, 125, '2015-04-01 00:42:37.000000', 'consum', 0.0224, 'lps'),
	(476704, 125, '2015-04-01 00:42:38.000000', 'consum', 0.0217, 'lps'),
	(476705, 125, '2015-04-01 00:42:39.000000', 'consum', 0.0230, 'lps'),
	(476706, 125, '2015-04-01 00:42:40.000000', 'consum', 0.0215, 'lps'),
	(476707, 125, '2015-04-01 00:42:41.000000', 'consum', 0.0224, 'lps'),
	(476708, 125, '2015-04-01 00:42:42.000000', 'consum', 0.0216, 'lps'),
	(476709, 125, '2015-04-01 00:42:43.000000', 'consum', 0.0224, 'lps'),
	(476710, 125, '2015-04-01 00:42:44.000000', 'consum', 0.0213, 'lps'),
	(476711, 125, '2015-04-01 00:42:45.000000', 'consum', 0.0233, 'lps'),
	(476712, 125, '2015-04-01 00:42:46.000000', 'consum', 0.0220, 'lps'),
	(476713, 125, '2015-04-01 00:42:47.000000', 'consum', 0.0214, 'lps'),
	(476714, 125, '2015-04-01 00:42:48.000000', 'consum', 0.0227, 'lps'),
	(476715, 125, '2015-04-01 00:42:49.000000', 'consum', 0.0211, 'lps'),
	(476716, 125, '2015-04-01 00:42:50.000000', 'consum', 0.0213, 'lps'),
	(476717, 125, '2015-04-01 00:42:51.000000', 'consum', 0.0224, 'lps'),
	(476718, 125, '2015-04-01 00:42:52.000000', 'consum', 0.0221, 'lps'),
	(476719, 125, '2015-04-01 00:42:53.000000', 'consum', 0.0223, 'lps'),
	(476720, 125, '2015-04-01 00:42:54.000000', 'consum', 0.0218, 'lps'),
	(476721, 125, '2015-04-01 00:42:55.000000', 'consum', 0.0213, 'lps'),
	(476722, 125, '2015-04-01 00:42:56.000000', 'consum', 0.0223, 'lps'),
	(476723, 125, '2015-04-01 00:42:57.000000', 'consum', 0.0222, 'lps'),
	(476724, 125, '2015-04-01 00:42:58.000000', 'consum', 0.0230, 'lps'),
	(476725, 125, '2015-04-01 00:42:59.000000', 'consum', 0.0227, 'lps'),
	(476726, 125, '2015-04-01 00:43:00.000000', 'consum', 0.0213, 'lps'),
	(476727, 125, '2015-04-01 00:43:01.000000', 'consum', 0.0221, 'lps'),
	(476728, 125, '2015-04-01 00:43:02.000000', 'consum', 0.0210, 'lps'),
	(476729, 125, '2015-04-01 00:43:03.000000', 'consum', 0.0224, 'lps'),
	(476730, 125, '2015-04-01 00:43:04.000000', 'consum', 0.0232, 'lps'),
	(476731, 125, '2015-04-01 00:43:05.000000', 'consum', 0.0233, 'lps'),
	(476732, 125, '2015-04-01 00:43:06.000000', 'consum', 0.0210, 'lps'),
	(476733, 125, '2015-04-01 00:43:07.000000', 'consum', 0.0215, 'lps'),
	(476734, 125, '2015-04-01 00:43:08.000000', 'consum', 0.0232, 'lps'),
	(476735, 125, '2015-04-01 00:43:09.000000', 'consum', 0.0213, 'lps'),
	(476736, 125, '2015-04-01 00:43:10.000000', 'consum', 0.0232, 'lps'),
	(476737, 125, '2015-04-01 00:43:11.000000', 'consum', 0.0214, 'lps'),
	(476738, 125, '2015-04-01 00:43:12.000000', 'consum', 0.0213, 'lps'),
	(476739, 125, '2015-04-01 00:43:13.000000', 'consum', 0.0212, 'lps'),
	(476740, 125, '2015-04-01 00:43:14.000000', 'consum', 0.0212, 'lps'),
	(476741, 125, '2015-04-01 00:43:15.000000', 'consum', 0.0214, 'lps'),
	(476742, 125, '2015-04-01 00:43:16.000000', 'consum', 0.0223, 'lps'),
	(476743, 125, '2015-04-01 00:43:17.000000', 'consum', 0.0218, 'lps'),
	(476744, 125, '2015-04-01 00:43:18.000000', 'consum', 0.0233, 'lps'),
	(476745, 125, '2015-04-01 00:43:19.000000', 'consum', 0.0231, 'lps'),
	(476746, 125, '2015-04-01 00:43:20.000000', 'consum', 0.0222, 'lps'),
	(476747, 125, '2015-04-01 00:43:21.000000', 'consum', 0.0233, 'lps'),
	(476748, 125, '2015-04-01 00:43:22.000000', 'consum', 0.0215, 'lps'),
	(476749, 125, '2015-04-01 00:43:23.000000', 'consum', 0.0216, 'lps'),
	(476750, 125, '2015-04-01 00:43:24.000000', 'consum', 0.0224, 'lps'),
	(476751, 125, '2015-04-01 00:43:25.000000', 'consum', 0.0216, 'lps'),
	(476752, 125, '2015-04-01 00:43:26.000000', 'consum', 0.0222, 'lps'),
	(476753, 125, '2015-04-01 00:43:27.000000', 'consum', 0.0228, 'lps'),
	(476754, 125, '2015-04-01 00:43:28.000000', 'consum', 0.0217, 'lps'),
	(476755, 125, '2015-04-01 00:43:29.000000', 'consum', 0.0214, 'lps'),
	(476756, 125, '2015-04-01 00:43:30.000000', 'consum', 0.0210, 'lps'),
	(476757, 125, '2015-04-01 00:43:31.000000', 'consum', 0.0222, 'lps'),
	(476758, 125, '2015-04-01 00:43:32.000000', 'consum', 0.0222, 'lps'),
	(476759, 125, '2015-04-01 00:43:33.000000', 'consum', 0.0210, 'lps'),
	(476760, 125, '2015-04-01 00:43:34.000000', 'consum', 0.0224, 'lps'),
	(476761, 125, '2015-04-01 00:43:35.000000', 'consum', 0.0233, 'lps'),
	(476762, 125, '2015-04-01 00:43:36.000000', 'consum', 0.0211, 'lps'),
	(476763, 125, '2015-04-01 00:43:37.000000', 'consum', 0.0219, 'lps'),
	(476764, 125, '2015-04-01 00:43:38.000000', 'consum', 0.0227, 'lps'),
	(476765, 125, '2015-04-01 00:43:39.000000', 'consum', 0.0220, 'lps'),
	(476766, 125, '2015-04-01 00:43:40.000000', 'consum', 0.0212, 'lps'),
	(476767, 125, '2015-04-01 00:43:41.000000', 'consum', 0.0215, 'lps'),
	(476768, 125, '2015-04-01 00:43:42.000000', 'consum', 0.0229, 'lps'),
	(476769, 125, '2015-04-01 00:43:43.000000', 'consum', 0.0216, 'lps'),
	(476770, 125, '2015-04-01 00:43:44.000000', 'consum', 0.0211, 'lps'),
	(476771, 125, '2015-04-01 00:43:45.000000', 'consum', 0.0219, 'lps'),
	(476772, 125, '2015-04-01 00:43:46.000000', 'consum', 0.0229, 'lps'),
	(476773, 125, '2015-04-01 00:43:47.000000', 'consum', 0.0229, 'lps'),
	(476774, 125, '2015-04-01 00:43:48.000000', 'consum', 0.0227, 'lps'),
	(476775, 125, '2015-04-01 00:43:49.000000', 'consum', 0.0216, 'lps'),
	(476776, 125, '2015-04-01 00:43:50.000000', 'consum', 0.0211, 'lps'),
	(476777, 125, '2015-04-01 00:43:51.000000', 'consum', 0.0220, 'lps'),
	(476778, 125, '2015-04-01 00:43:52.000000', 'consum', 0.0211, 'lps'),
	(476779, 125, '2015-04-01 00:43:53.000000', 'consum', 0.0211, 'lps'),
	(476780, 125, '2015-04-01 00:43:54.000000', 'consum', 0.0211, 'lps'),
	(476781, 125, '2015-04-01 00:43:55.000000', 'consum', 0.0212, 'lps'),
	(476782, 125, '2015-04-01 00:43:56.000000', 'consum', 0.0220, 'lps'),
	(476783, 125, '2015-04-01 00:43:57.000000', 'consum', 0.0228, 'lps'),
	(476784, 125, '2015-04-01 00:43:58.000000', 'consum', 0.0225, 'lps'),
	(476785, 125, '2015-04-01 00:43:59.000000', 'consum', 0.0231, 'lps'),
	(476786, 125, '2015-04-01 00:44:00.000000', 'consum', 0.0220, 'lps'),
	(476787, 125, '2015-04-01 00:44:01.000000', 'consum', 0.0223, 'lps'),
	(476788, 125, '2015-04-01 00:44:02.000000', 'consum', 0.0220, 'lps'),
	(476789, 125, '2015-04-01 00:44:03.000000', 'consum', 0.0222, 'lps'),
	(476790, 125, '2015-04-01 00:44:04.000000', 'consum', 0.0215, 'lps'),
	(476791, 125, '2015-04-01 00:44:05.000000', 'consum', 0.0224, 'lps'),
	(476792, 125, '2015-04-01 00:44:06.000000', 'consum', 0.0220, 'lps'),
	(476793, 125, '2015-04-01 00:44:07.000000', 'consum', 0.0217, 'lps'),
	(476794, 125, '2015-04-01 00:44:08.000000', 'consum', 0.0215, 'lps'),
	(476795, 125, '2015-04-01 00:44:09.000000', 'consum', 0.0217, 'lps'),
	(476796, 125, '2015-04-01 00:44:10.000000', 'consum', 0.0228, 'lps'),
	(476797, 125, '2015-04-01 00:44:11.000000', 'consum', 0.0233, 'lps'),
	(476798, 125, '2015-04-01 00:44:12.000000', 'consum', 0.0221, 'lps'),
	(476799, 125, '2015-04-01 00:44:13.000000', 'consum', 0.0223, 'lps'),
	(476800, 125, '2015-04-01 00:44:14.000000', 'consum', 0.0217, 'lps'),
	(476801, 125, '2015-04-01 00:44:15.000000', 'consum', 0.0229, 'lps'),
	(476802, 125, '2015-04-01 00:44:16.000000', 'consum', 0.0216, 'lps'),
	(476803, 125, '2015-04-01 00:44:17.000000', 'consum', 0.0229, 'lps'),
	(476804, 125, '2015-04-01 00:44:18.000000', 'consum', 0.0216, 'lps'),
	(476805, 125, '2015-04-01 00:44:19.000000', 'consum', 0.0232, 'lps'),
	(476806, 125, '2015-04-01 00:44:20.000000', 'consum', 0.0228, 'lps'),
	(476807, 125, '2015-04-01 00:44:21.000000', 'consum', 0.0213, 'lps'),
	(476808, 125, '2015-04-01 00:44:22.000000', 'consum', 0.0218, 'lps'),
	(476809, 125, '2015-04-01 00:44:23.000000', 'consum', 0.0219, 'lps'),
	(476810, 125, '2015-04-01 00:44:24.000000', 'consum', 0.0229, 'lps'),
	(476811, 125, '2015-04-01 00:44:25.000000', 'consum', 0.0233, 'lps'),
	(476812, 125, '2015-04-01 00:44:26.000000', 'consum', 0.0222, 'lps'),
	(476813, 125, '2015-04-01 00:44:27.000000', 'consum', 0.0223, 'lps'),
	(476814, 125, '2015-04-01 00:44:28.000000', 'consum', 0.0215, 'lps'),
	(476815, 125, '2015-04-01 00:44:29.000000', 'consum', 0.0221, 'lps'),
	(476816, 125, '2015-04-01 00:44:30.000000', 'consum', 0.0226, 'lps'),
	(476817, 125, '2015-04-01 00:44:31.000000', 'consum', 0.0232, 'lps'),
	(476818, 125, '2015-04-01 00:44:32.000000', 'consum', 0.0227, 'lps'),
	(476819, 125, '2015-04-01 00:44:33.000000', 'consum', 0.0230, 'lps'),
	(476820, 125, '2015-04-01 00:44:34.000000', 'consum', 0.0210, 'lps'),
	(476821, 125, '2015-04-01 00:44:35.000000', 'consum', 0.0224, 'lps'),
	(476822, 125, '2015-04-01 00:44:36.000000', 'consum', 0.0233, 'lps'),
	(476823, 125, '2015-04-01 00:44:37.000000', 'consum', 0.0211, 'lps'),
	(476824, 125, '2015-04-01 00:44:38.000000', 'consum', 0.0219, 'lps'),
	(476825, 125, '2015-04-01 00:44:39.000000', 'consum', 0.0228, 'lps'),
	(476826, 125, '2015-04-01 00:44:40.000000', 'consum', 0.0224, 'lps'),
	(476827, 125, '2015-04-01 00:44:41.000000', 'consum', 0.0228, 'lps'),
	(476828, 125, '2015-04-01 00:44:42.000000', 'consum', 0.0233, 'lps'),
	(476829, 125, '2015-04-01 00:44:43.000000', 'consum', 0.0225, 'lps'),
	(476830, 125, '2015-04-01 00:44:44.000000', 'consum', 0.0215, 'lps'),
	(476831, 125, '2015-04-01 00:44:45.000000', 'consum', 0.0217, 'lps'),
	(476832, 125, '2015-04-01 00:44:46.000000', 'consum', 0.0231, 'lps'),
	(476833, 125, '2015-04-01 00:44:47.000000', 'consum', 0.0220, 'lps'),
	(476834, 125, '2015-04-01 00:44:48.000000', 'consum', 0.0221, 'lps'),
	(476835, 125, '2015-04-01 00:44:49.000000', 'consum', 0.0211, 'lps'),
	(476836, 125, '2015-04-01 00:44:50.000000', 'consum', 0.0231, 'lps'),
	(476837, 125, '2015-04-01 00:44:51.000000', 'consum', 0.0217, 'lps'),
	(476838, 125, '2015-04-01 00:44:52.000000', 'consum', 0.0230, 'lps'),
	(476839, 125, '2015-04-01 00:44:53.000000', 'consum', 0.0216, 'lps'),
	(476840, 125, '2015-04-01 00:44:54.000000', 'consum', 0.0230, 'lps'),
	(476841, 125, '2015-04-01 00:44:55.000000', 'consum', 0.0219, 'lps'),
	(476842, 125, '2015-04-01 00:44:56.000000', 'consum', 0.0221, 'lps'),
	(476843, 125, '2015-04-01 00:44:57.000000', 'consum', 0.0216, 'lps'),
	(476844, 125, '2015-04-01 00:44:58.000000', 'consum', 0.0231, 'lps'),
	(476845, 125, '2015-04-01 00:44:59.000000', 'consum', 0.0225, 'lps'),
	(476846, 125, '2015-04-01 00:45:00.000000', 'consum', 0.0220, 'lps'),
	(476847, 125, '2015-04-01 00:45:01.000000', 'consum', 0.0219, 'lps'),
	(476848, 125, '2015-04-01 00:45:02.000000', 'consum', 0.0223, 'lps'),
	(476849, 125, '2015-04-01 00:45:03.000000', 'consum', 0.0227, 'lps'),
	(476850, 125, '2015-04-01 00:45:04.000000', 'consum', 0.0233, 'lps'),
	(476851, 125, '2015-04-01 00:45:05.000000', 'consum', 0.0224, 'lps'),
	(476852, 125, '2015-04-01 00:45:06.000000', 'consum', 0.0212, 'lps'),
	(476853, 125, '2015-04-01 00:45:07.000000', 'consum', 0.0227, 'lps'),
	(476854, 125, '2015-04-01 00:45:08.000000', 'consum', 0.0218, 'lps'),
	(476855, 125, '2015-04-01 00:45:09.000000', 'consum', 0.0221, 'lps'),
	(476856, 125, '2015-04-01 00:45:10.000000', 'consum', 0.0220, 'lps'),
	(476857, 125, '2015-04-01 00:45:11.000000', 'consum', 0.0226, 'lps'),
	(476858, 125, '2015-04-01 00:45:12.000000', 'consum', 0.0212, 'lps'),
	(476859, 125, '2015-04-01 00:45:13.000000', 'consum', 0.0221, 'lps'),
	(476860, 125, '2015-04-01 00:45:14.000000', 'consum', 0.0212, 'lps'),
	(476861, 125, '2015-04-01 00:45:15.000000', 'consum', 0.0210, 'lps'),
	(476862, 125, '2015-04-01 00:45:16.000000', 'consum', 0.0231, 'lps'),
	(476863, 125, '2015-04-01 00:45:17.000000', 'consum', 0.0220, 'lps'),
	(476864, 125, '2015-04-01 00:45:18.000000', 'consum', 0.0219, 'lps'),
	(476865, 125, '2015-04-01 00:45:19.000000', 'consum', 0.0225, 'lps'),
	(476866, 125, '2015-04-01 00:45:20.000000', 'consum', 0.0211, 'lps'),
	(476867, 125, '2015-04-01 00:45:21.000000', 'consum', 0.0221, 'lps'),
	(476868, 125, '2015-04-01 00:45:22.000000', 'consum', 0.0212, 'lps'),
	(476869, 125, '2015-04-01 00:45:23.000000', 'consum', 0.0212, 'lps'),
	(476870, 125, '2015-04-01 00:45:24.000000', 'consum', 0.0217, 'lps'),
	(476871, 125, '2015-04-01 00:45:25.000000', 'consum', 0.0212, 'lps'),
	(476872, 125, '2015-04-01 00:45:26.000000', 'consum', 0.0225, 'lps'),
	(476873, 125, '2015-04-01 00:45:27.000000', 'consum', 0.0232, 'lps'),
	(476874, 125, '2015-04-01 00:45:28.000000', 'consum', 0.0227, 'lps'),
	(476875, 125, '2015-04-01 00:45:29.000000', 'consum', 0.0229, 'lps'),
	(476876, 125, '2015-04-01 00:45:30.000000', 'consum', 0.0229, 'lps'),
	(476877, 125, '2015-04-01 00:45:31.000000', 'consum', 0.0228, 'lps'),
	(476878, 125, '2015-04-01 00:45:32.000000', 'consum', 0.0216, 'lps'),
	(476879, 125, '2015-04-01 00:45:33.000000', 'consum', 0.0213, 'lps'),
	(476880, 125, '2015-04-01 00:45:34.000000', 'consum', 0.0230, 'lps'),
	(476881, 125, '2015-04-01 00:45:35.000000', 'consum', 0.0229, 'lps'),
	(476882, 125, '2015-04-01 00:45:36.000000', 'consum', 0.0224, 'lps'),
	(476883, 125, '2015-04-01 00:45:37.000000', 'consum', 0.0220, 'lps'),
	(476884, 125, '2015-04-01 00:45:38.000000', 'consum', 0.0222, 'lps'),
	(476885, 125, '2015-04-01 00:45:39.000000', 'consum', 0.0214, 'lps'),
	(476886, 125, '2015-04-01 00:45:40.000000', 'consum', 0.0219, 'lps'),
	(476887, 125, '2015-04-01 00:45:41.000000', 'consum', 0.0220, 'lps'),
	(476888, 125, '2015-04-01 00:45:42.000000', 'consum', 0.0210, 'lps'),
	(476889, 125, '2015-04-01 00:45:43.000000', 'consum', 0.0230, 'lps'),
	(476890, 125, '2015-04-01 00:45:44.000000', 'consum', 0.0212, 'lps'),
	(476891, 125, '2015-04-01 00:45:45.000000', 'consum', 0.0211, 'lps'),
	(476892, 125, '2015-04-01 00:45:46.000000', 'consum', 0.0231, 'lps'),
	(476893, 125, '2015-04-01 00:45:47.000000', 'consum', 0.0217, 'lps'),
	(476894, 125, '2015-04-01 00:45:48.000000', 'consum', 0.0231, 'lps'),
	(476895, 125, '2015-04-01 00:45:49.000000', 'consum', 0.0220, 'lps'),
	(476896, 125, '2015-04-01 00:45:50.000000', 'consum', 0.0225, 'lps'),
	(476897, 125, '2015-04-01 00:45:51.000000', 'consum', 0.0228, 'lps'),
	(476898, 125, '2015-04-01 00:45:52.000000', 'consum', 0.0210, 'lps'),
	(476899, 125, '2015-04-01 00:45:53.000000', 'consum', 0.0229, 'lps'),
	(476900, 125, '2015-04-01 00:45:54.000000', 'consum', 0.0231, 'lps'),
	(476901, 125, '2015-04-01 00:45:55.000000', 'consum', 0.0213, 'lps'),
	(476902, 125, '2015-04-01 00:45:56.000000', 'consum', 0.0211, 'lps'),
	(476903, 125, '2015-04-01 00:45:57.000000', 'consum', 0.0230, 'lps'),
	(476904, 125, '2015-04-01 00:45:58.000000', 'consum', 0.0213, 'lps'),
	(476905, 125, '2015-04-01 00:45:59.000000', 'consum', 0.0210, 'lps'),
	(476906, 125, '2015-04-01 00:46:00.000000', 'consum', 0.0227, 'lps'),
	(476907, 125, '2015-04-01 00:46:01.000000', 'consum', 0.0226, 'lps'),
	(476908, 125, '2015-04-01 00:46:02.000000', 'consum', 0.0212, 'lps'),
	(476909, 125, '2015-04-01 00:46:03.000000', 'consum', 0.0222, 'lps'),
	(476910, 125, '2015-04-01 00:46:04.000000', 'consum', 0.0218, 'lps'),
	(476911, 125, '2015-04-01 00:46:05.000000', 'consum', 0.0213, 'lps'),
	(476912, 125, '2015-04-01 00:46:06.000000', 'consum', 0.0225, 'lps'),
	(476913, 125, '2015-04-01 00:46:07.000000', 'consum', 0.0230, 'lps'),
	(476914, 125, '2015-04-01 00:46:08.000000', 'consum', 0.0219, 'lps'),
	(476915, 125, '2015-04-01 00:46:09.000000', 'consum', 0.0217, 'lps'),
	(476916, 125, '2015-04-01 00:46:10.000000', 'consum', 0.0221, 'lps'),
	(476917, 125, '2015-04-01 00:46:11.000000', 'consum', 0.0218, 'lps'),
	(476918, 125, '2015-04-01 00:46:12.000000', 'consum', 0.0219, 'lps'),
	(476919, 125, '2015-04-01 00:46:13.000000', 'consum', 0.0233, 'lps'),
	(476920, 125, '2015-04-01 00:46:14.000000', 'consum', 0.0224, 'lps'),
	(476921, 125, '2015-04-01 00:46:15.000000', 'consum', 0.0214, 'lps'),
	(476922, 125, '2015-04-01 00:46:16.000000', 'consum', 0.0212, 'lps'),
	(476923, 125, '2015-04-01 00:46:17.000000', 'consum', 0.0231, 'lps'),
	(476924, 125, '2015-04-01 00:46:18.000000', 'consum', 0.0215, 'lps'),
	(476925, 125, '2015-04-01 00:46:19.000000', 'consum', 0.0221, 'lps'),
	(476926, 125, '2015-04-01 00:46:20.000000', 'consum', 0.0227, 'lps'),
	(476927, 125, '2015-04-01 00:46:21.000000', 'consum', 0.0213, 'lps'),
	(476928, 125, '2015-04-01 00:46:22.000000', 'consum', 0.0222, 'lps'),
	(476929, 125, '2015-04-01 00:46:23.000000', 'consum', 0.0213, 'lps'),
	(476930, 125, '2015-04-01 00:46:24.000000', 'consum', 0.0216, 'lps'),
	(476931, 125, '2015-04-01 00:46:25.000000', 'consum', 0.0232, 'lps'),
	(476932, 125, '2015-04-01 00:46:26.000000', 'consum', 0.0230, 'lps'),
	(476933, 125, '2015-04-01 00:46:27.000000', 'consum', 0.0218, 'lps'),
	(476934, 125, '2015-04-01 00:46:28.000000', 'consum', 0.0218, 'lps'),
	(476935, 125, '2015-04-01 00:46:29.000000', 'consum', 0.0223, 'lps'),
	(476936, 125, '2015-04-01 00:46:30.000000', 'consum', 0.0230, 'lps'),
	(476937, 125, '2015-04-01 00:46:31.000000', 'consum', 0.0222, 'lps'),
	(476938, 125, '2015-04-01 00:46:32.000000', 'consum', 0.0211, 'lps'),
	(476939, 125, '2015-04-01 00:46:33.000000', 'consum', 0.0229, 'lps'),
	(476940, 125, '2015-04-01 00:46:34.000000', 'consum', 0.0230, 'lps'),
	(476941, 125, '2015-04-01 00:46:35.000000', 'consum', 0.0229, 'lps'),
	(476942, 125, '2015-04-01 00:46:36.000000', 'consum', 0.0223, 'lps'),
	(476943, 125, '2015-04-01 00:46:37.000000', 'consum', 0.0217, 'lps'),
	(476944, 125, '2015-04-01 00:46:38.000000', 'consum', 0.0230, 'lps'),
	(476945, 125, '2015-04-01 00:46:39.000000', 'consum', 0.0217, 'lps'),
	(476946, 125, '2015-04-01 00:46:40.000000', 'consum', 0.0211, 'lps'),
	(476947, 125, '2015-04-01 00:46:41.000000', 'consum', 0.0218, 'lps'),
	(476948, 125, '2015-04-01 00:46:42.000000', 'consum', 0.0223, 'lps'),
	(476949, 125, '2015-04-01 00:46:43.000000', 'consum', 0.0227, 'lps'),
	(476950, 125, '2015-04-01 00:46:44.000000', 'consum', 0.0211, 'lps'),
	(476951, 125, '2015-04-01 00:46:45.000000', 'consum', 0.0210, 'lps'),
	(476952, 125, '2015-04-01 00:46:46.000000', 'consum', 0.0231, 'lps'),
	(476953, 125, '2015-04-01 00:46:47.000000', 'consum', 0.0222, 'lps'),
	(476954, 125, '2015-04-01 00:46:48.000000', 'consum', 0.0232, 'lps'),
	(476955, 125, '2015-04-01 00:46:49.000000', 'consum', 0.0213, 'lps'),
	(476956, 125, '2015-04-01 00:46:50.000000', 'consum', 0.0232, 'lps'),
	(476957, 125, '2015-04-01 00:46:51.000000', 'consum', 0.0212, 'lps'),
	(476958, 125, '2015-04-01 00:46:52.000000', 'consum', 0.0230, 'lps'),
	(476959, 125, '2015-04-01 00:46:53.000000', 'consum', 0.0230, 'lps'),
	(476960, 125, '2015-04-01 00:46:54.000000', 'consum', 0.0226, 'lps'),
	(476961, 125, '2015-04-01 00:46:55.000000', 'consum', 0.0232, 'lps'),
	(476962, 125, '2015-04-01 00:46:56.000000', 'consum', 0.0223, 'lps'),
	(476963, 125, '2015-04-01 00:46:57.000000', 'consum', 0.0212, 'lps'),
	(476964, 125, '2015-04-01 00:46:58.000000', 'consum', 0.0230, 'lps'),
	(476965, 125, '2015-04-01 00:46:59.000000', 'consum', 0.0231, 'lps'),
	(476966, 125, '2015-04-01 00:47:00.000000', 'consum', 0.0230, 'lps'),
	(476967, 125, '2015-04-01 00:47:01.000000', 'consum', 0.0224, 'lps'),
	(476968, 125, '2015-04-01 00:47:02.000000', 'consum', 0.0223, 'lps'),
	(476969, 125, '2015-04-01 00:47:03.000000', 'consum', 0.0231, 'lps'),
	(476970, 125, '2015-04-01 00:47:04.000000', 'consum', 0.0228, 'lps'),
	(476971, 125, '2015-04-01 00:47:05.000000', 'consum', 0.0216, 'lps'),
	(476972, 125, '2015-04-01 00:47:06.000000', 'consum', 0.0233, 'lps'),
	(476973, 125, '2015-04-01 00:47:07.000000', 'consum', 0.0211, 'lps'),
	(476974, 125, '2015-04-01 00:47:08.000000', 'consum', 0.0219, 'lps'),
	(476975, 125, '2015-04-01 00:47:09.000000', 'consum', 0.0229, 'lps'),
	(476976, 125, '2015-04-01 00:47:10.000000', 'consum', 0.0232, 'lps'),
	(476977, 125, '2015-04-01 00:47:11.000000', 'consum', 0.0213, 'lps'),
	(476978, 125, '2015-04-01 00:47:12.000000', 'consum', 0.0210, 'lps'),
	(476979, 125, '2015-04-01 00:47:13.000000', 'consum', 0.0226, 'lps'),
	(476980, 125, '2015-04-01 00:47:14.000000', 'consum', 0.0219, 'lps'),
	(476981, 125, '2015-04-01 00:47:15.000000', 'consum', 0.0232, 'lps'),
	(476982, 125, '2015-04-01 00:47:16.000000', 'consum', 0.0220, 'lps'),
	(476983, 125, '2015-04-01 00:47:17.000000', 'consum', 0.0219, 'lps'),
	(476984, 125, '2015-04-01 00:47:18.000000', 'consum', 0.0224, 'lps'),
	(476985, 125, '2015-04-01 00:47:19.000000', 'consum', 0.0229, 'lps'),
	(476986, 125, '2015-04-01 00:47:20.000000', 'consum', 0.0218, 'lps'),
	(476987, 125, '2015-04-01 00:47:21.000000', 'consum', 0.0218, 'lps'),
	(476988, 125, '2015-04-01 00:47:22.000000', 'consum', 0.0225, 'lps'),
	(476989, 125, '2015-04-01 00:47:23.000000', 'consum', 0.0215, 'lps'),
	(476990, 125, '2015-04-01 00:47:24.000000', 'consum', 0.0213, 'lps'),
	(476991, 125, '2015-04-01 00:47:25.000000', 'consum', 0.0212, 'lps'),
	(476992, 125, '2015-04-01 00:47:26.000000', 'consum', 0.0212, 'lps'),
	(476993, 125, '2015-04-01 00:47:27.000000', 'consum', 0.0212, 'lps'),
	(476994, 125, '2015-04-01 00:47:28.000000', 'consum', 0.0214, 'lps'),
	(476995, 125, '2015-04-01 00:47:29.000000', 'consum', 0.0225, 'lps'),
	(476996, 125, '2015-04-01 00:47:30.000000', 'consum', 0.0226, 'lps'),
	(476997, 125, '2015-04-01 00:47:31.000000', 'consum', 0.0220, 'lps'),
	(476998, 125, '2015-04-01 00:47:32.000000', 'consum', 0.0212, 'lps'),
	(476999, 125, '2015-04-01 00:47:33.000000', 'consum', 0.0217, 'lps'),
	(477000, 125, '2015-04-01 00:47:34.000000', 'consum', 0.0214, 'lps'),
	(477001, 125, '2015-04-01 00:47:35.000000', 'consum', 0.0211, 'lps'),
	(477002, 125, '2015-04-01 00:47:36.000000', 'consum', 0.0225, 'lps'),
	(477003, 125, '2015-04-01 00:47:37.000000', 'consum', 0.0210, 'lps'),
	(477004, 125, '2015-04-01 00:47:38.000000', 'consum', 0.0215, 'lps'),
	(477005, 125, '2015-04-01 00:47:39.000000', 'consum', 0.0212, 'lps'),
	(477006, 125, '2015-04-01 00:47:40.000000', 'consum', 0.0231, 'lps'),
	(477007, 125, '2015-04-01 00:47:41.000000', 'consum', 0.0212, 'lps'),
	(477008, 125, '2015-04-01 00:47:42.000000', 'consum', 0.0229, 'lps'),
	(477009, 125, '2015-04-01 00:47:43.000000', 'consum', 0.0227, 'lps'),
	(477010, 125, '2015-04-01 00:47:44.000000', 'consum', 0.0215, 'lps'),
	(477011, 125, '2015-04-01 00:47:45.000000', 'consum', 0.0211, 'lps'),
	(477012, 125, '2015-04-01 00:47:46.000000', 'consum', 0.0221, 'lps'),
	(477013, 125, '2015-04-01 00:47:47.000000', 'consum', 0.0217, 'lps'),
	(477014, 125, '2015-04-01 00:47:48.000000', 'consum', 0.0213, 'lps'),
	(477015, 125, '2015-04-01 00:47:49.000000', 'consum', 0.0226, 'lps'),
	(477016, 125, '2015-04-01 00:47:50.000000', 'consum', 0.0211, 'lps'),
	(477017, 125, '2015-04-01 00:47:51.000000', 'consum', 0.0215, 'lps'),
	(477018, 125, '2015-04-01 00:47:52.000000', 'consum', 0.0233, 'lps'),
	(477019, 125, '2015-04-01 00:47:53.000000', 'consum', 0.0216, 'lps'),
	(477020, 125, '2015-04-01 00:47:54.000000', 'consum', 0.0218, 'lps'),
	(477021, 125, '2015-04-01 00:47:55.000000', 'consum', 0.0231, 'lps'),
	(477022, 125, '2015-04-01 00:47:56.000000', 'consum', 0.0220, 'lps'),
	(477023, 125, '2015-04-01 00:47:57.000000', 'consum', 0.0223, 'lps'),
	(477024, 125, '2015-04-01 00:47:58.000000', 'consum', 0.0221, 'lps'),
	(477025, 125, '2015-04-01 00:47:59.000000', 'consum', 0.0226, 'lps'),
	(477026, 125, '2015-04-01 00:48:00.000000', 'consum', 0.0232, 'lps'),
	(477027, 125, '2015-04-01 00:48:01.000000', 'consum', 0.0225, 'lps'),
	(477028, 125, '2015-04-01 00:48:02.000000', 'consum', 0.0221, 'lps'),
	(477029, 125, '2015-04-01 00:48:03.000000', 'consum', 0.0220, 'lps'),
	(477030, 125, '2015-04-01 00:48:04.000000', 'consum', 0.0227, 'lps'),
	(477031, 125, '2015-04-01 00:48:05.000000', 'consum', 0.0219, 'lps'),
	(477032, 125, '2015-04-01 00:48:06.000000', 'consum', 0.0226, 'lps'),
	(477033, 125, '2015-04-01 00:48:07.000000', 'consum', 0.0216, 'lps'),
	(477034, 125, '2015-04-01 00:48:08.000000', 'consum', 0.0217, 'lps'),
	(477035, 125, '2015-04-01 00:48:09.000000', 'consum', 0.0229, 'lps'),
	(477036, 125, '2015-04-01 00:48:10.000000', 'consum', 0.0211, 'lps'),
	(477037, 125, '2015-04-01 00:48:11.000000', 'consum', 0.0233, 'lps'),
	(477038, 125, '2015-04-01 00:48:12.000000', 'consum', 0.0223, 'lps'),
	(477039, 125, '2015-04-01 00:48:13.000000', 'consum', 0.0232, 'lps'),
	(477040, 125, '2015-04-01 00:48:14.000000', 'consum', 0.0211, 'lps'),
	(477041, 125, '2015-04-01 00:48:15.000000', 'consum', 0.0222, 'lps'),
	(477042, 125, '2015-04-01 00:48:16.000000', 'consum', 0.0220, 'lps'),
	(477043, 125, '2015-04-01 00:48:17.000000', 'consum', 0.0222, 'lps'),
	(477044, 125, '2015-04-01 00:48:18.000000', 'consum', 0.0218, 'lps'),
	(477045, 125, '2015-04-01 00:48:19.000000', 'consum', 0.0214, 'lps'),
	(477046, 125, '2015-04-01 00:48:20.000000', 'consum', 0.0231, 'lps'),
	(477047, 125, '2015-04-01 00:48:21.000000', 'consum', 0.0231, 'lps'),
	(477048, 125, '2015-04-01 00:48:22.000000', 'consum', 0.0230, 'lps'),
	(477049, 125, '2015-04-01 00:48:23.000000', 'consum', 0.0221, 'lps'),
	(477050, 125, '2015-04-01 00:48:24.000000', 'consum', 0.0230, 'lps'),
	(477051, 125, '2015-04-01 00:48:25.000000', 'consum', 0.0229, 'lps'),
	(477052, 125, '2015-04-01 00:48:26.000000', 'consum', 0.0223, 'lps'),
	(477053, 125, '2015-04-01 00:48:27.000000', 'consum', 0.0218, 'lps'),
	(477054, 125, '2015-04-01 00:48:28.000000', 'consum', 0.0211, 'lps'),
	(477055, 125, '2015-04-01 00:48:29.000000', 'consum', 0.0216, 'lps'),
	(477056, 125, '2015-04-01 00:48:30.000000', 'consum', 0.0214, 'lps'),
	(477057, 125, '2015-04-01 00:48:31.000000', 'consum', 0.0211, 'lps'),
	(477058, 125, '2015-04-01 00:48:32.000000', 'consum', 0.0228, 'lps'),
	(477059, 125, '2015-04-01 00:48:33.000000', 'consum', 0.0224, 'lps'),
	(477060, 125, '2015-04-01 00:48:34.000000', 'consum', 0.0228, 'lps'),
	(477061, 125, '2015-04-01 00:48:35.000000', 'consum', 0.0233, 'lps'),
	(477062, 125, '2015-04-01 00:48:36.000000', 'consum', 0.0223, 'lps'),
	(477063, 125, '2015-04-01 00:48:37.000000', 'consum', 0.0233, 'lps'),
	(477064, 125, '2015-04-01 00:48:38.000000', 'consum', 0.0212, 'lps'),
	(477065, 125, '2015-04-01 00:48:39.000000', 'consum', 0.0226, 'lps'),
	(477066, 125, '2015-04-01 00:48:40.000000', 'consum', 0.0233, 'lps'),
	(477067, 125, '2015-04-01 00:48:41.000000', 'consum', 0.0233, 'lps'),
	(477068, 125, '2015-04-01 00:48:42.000000', 'consum', 0.0233, 'lps'),
	(477069, 125, '2015-04-01 00:48:43.000000', 'consum', 0.0230, 'lps'),
	(477070, 125, '2015-04-01 00:48:44.000000', 'consum', 0.0218, 'lps'),
	(477071, 125, '2015-04-01 00:48:45.000000', 'consum', 0.0213, 'lps'),
	(477072, 125, '2015-04-01 00:48:46.000000', 'consum', 0.0225, 'lps'),
	(477073, 125, '2015-04-01 00:48:47.000000', 'consum', 0.0231, 'lps'),
	(477074, 125, '2015-04-01 00:48:48.000000', 'consum', 0.0224, 'lps'),
	(477075, 125, '2015-04-01 00:48:49.000000', 'consum', 0.0214, 'lps'),
	(477076, 125, '2015-04-01 00:48:50.000000', 'consum', 0.0215, 'lps'),
	(477077, 125, '2015-04-01 00:48:51.000000', 'consum', 0.0222, 'lps'),
	(477078, 125, '2015-04-01 00:48:52.000000', 'consum', 0.0231, 'lps'),
	(477079, 125, '2015-04-01 00:48:53.000000', 'consum', 0.0232, 'lps'),
	(477080, 125, '2015-04-01 00:48:54.000000', 'consum', 0.0210, 'lps'),
	(477081, 125, '2015-04-01 00:48:55.000000', 'consum', 0.0217, 'lps'),
	(477082, 125, '2015-04-01 00:48:56.000000', 'consum', 0.0220, 'lps'),
	(477083, 125, '2015-04-01 00:48:57.000000', 'consum', 0.0215, 'lps'),
	(477084, 125, '2015-04-01 00:48:58.000000', 'consum', 0.0232, 'lps'),
	(477085, 125, '2015-04-01 00:48:59.000000', 'consum', 0.0233, 'lps'),
	(477086, 125, '2015-04-01 00:49:00.000000', 'consum', 0.0210, 'lps'),
	(477087, 125, '2015-04-01 00:49:01.000000', 'consum', 0.0213, 'lps'),
	(477088, 125, '2015-04-01 00:49:02.000000', 'consum', 0.0226, 'lps'),
	(477089, 125, '2015-04-01 00:49:03.000000', 'consum', 0.0233, 'lps'),
	(477090, 125, '2015-04-01 00:49:04.000000', 'consum', 0.0230, 'lps'),
	(477091, 125, '2015-04-01 00:49:05.000000', 'consum', 0.0217, 'lps'),
	(477092, 125, '2015-04-01 00:49:06.000000', 'consum', 0.0211, 'lps'),
	(477093, 125, '2015-04-01 00:49:07.000000', 'consum', 0.0218, 'lps'),
	(477094, 125, '2015-04-01 00:49:08.000000', 'consum', 0.0222, 'lps'),
	(477095, 125, '2015-04-01 00:49:09.000000', 'consum', 0.0225, 'lps'),
	(477096, 125, '2015-04-01 00:49:10.000000', 'consum', 0.0226, 'lps'),
	(477097, 125, '2015-04-01 00:49:11.000000', 'consum', 0.0221, 'lps'),
	(477098, 125, '2015-04-01 00:49:12.000000', 'consum', 0.0215, 'lps'),
	(477099, 125, '2015-04-01 00:49:13.000000', 'consum', 0.0229, 'lps'),
	(477100, 125, '2015-04-01 00:49:14.000000', 'consum', 0.0217, 'lps'),
	(477101, 125, '2015-04-01 00:49:15.000000', 'consum', 0.0213, 'lps'),
	(477102, 125, '2015-04-01 00:49:16.000000', 'consum', 0.0229, 'lps'),
	(477103, 125, '2015-04-01 00:49:17.000000', 'consum', 0.0226, 'lps'),
	(477104, 125, '2015-04-01 00:49:18.000000', 'consum', 0.0233, 'lps'),
	(477105, 125, '2015-04-01 00:49:19.000000', 'consum', 0.0231, 'lps'),
	(477106, 125, '2015-04-01 00:49:20.000000', 'consum', 0.0219, 'lps'),
	(477107, 125, '2015-04-01 00:49:21.000000', 'consum', 0.0218, 'lps'),
	(477108, 125, '2015-04-01 00:49:22.000000', 'consum', 0.0225, 'lps'),
	(477109, 125, '2015-04-01 00:49:23.000000', 'consum', 0.0214, 'lps'),
	(477110, 125, '2015-04-01 00:49:24.000000', 'consum', 0.0231, 'lps'),
	(477111, 125, '2015-04-01 00:49:25.000000', 'consum', 0.0232, 'lps'),
	(477112, 125, '2015-04-01 00:49:26.000000', 'consum', 0.0233, 'lps'),
	(477113, 125, '2015-04-01 00:49:27.000000', 'consum', 0.0211, 'lps'),
	(477114, 125, '2015-04-01 00:49:28.000000', 'consum', 0.0218, 'lps'),
	(477115, 125, '2015-04-01 00:49:29.000000', 'consum', 0.0224, 'lps'),
	(477116, 125, '2015-04-01 00:49:30.000000', 'consum', 0.0232, 'lps'),
	(477117, 125, '2015-04-01 00:49:31.000000', 'consum', 0.0232, 'lps'),
	(477118, 125, '2015-04-01 00:49:32.000000', 'consum', 0.0232, 'lps'),
	(477119, 125, '2015-04-01 00:49:33.000000', 'consum', 0.0228, 'lps'),
	(477120, 125, '2015-04-01 00:49:34.000000', 'consum', 0.0210, 'lps'),
	(477121, 125, '2015-04-01 00:49:35.000000', 'consum', 0.0229, 'lps'),
	(477122, 125, '2015-04-01 00:49:36.000000', 'consum', 0.0233, 'lps'),
	(477123, 125, '2015-04-01 00:49:37.000000', 'consum', 0.0222, 'lps'),
	(477124, 125, '2015-04-01 00:49:38.000000', 'consum', 0.0227, 'lps'),
	(477125, 125, '2015-04-01 00:49:39.000000', 'consum', 0.0233, 'lps'),
	(477126, 125, '2015-04-01 00:49:40.000000', 'consum', 0.0227, 'lps'),
	(477127, 125, '2015-04-01 00:49:41.000000', 'consum', 0.0227, 'lps'),
	(477128, 125, '2015-04-01 00:49:42.000000', 'consum', 0.0221, 'lps'),
	(477129, 125, '2015-04-01 00:49:43.000000', 'consum', 0.0213, 'lps'),
	(477130, 125, '2015-04-01 00:49:44.000000', 'consum', 0.0215, 'lps'),
	(477131, 125, '2015-04-01 00:49:45.000000', 'consum', 0.0229, 'lps'),
	(477132, 125, '2015-04-01 00:49:46.000000', 'consum', 0.0218, 'lps'),
	(477133, 125, '2015-04-01 00:49:47.000000', 'consum', 0.0215, 'lps'),
	(477134, 125, '2015-04-01 00:49:48.000000', 'consum', 0.0215, 'lps'),
	(477135, 125, '2015-04-01 00:49:49.000000', 'consum', 0.0218, 'lps'),
	(477136, 125, '2015-04-01 00:49:50.000000', 'consum', 0.0213, 'lps'),
	(477137, 125, '2015-04-01 00:49:51.000000', 'consum', 0.0225, 'lps'),
	(477138, 125, '2015-04-01 00:49:52.000000', 'consum', 0.0230, 'lps'),
	(477139, 125, '2015-04-01 00:49:53.000000', 'consum', 0.0214, 'lps'),
	(477140, 125, '2015-04-01 00:49:54.000000', 'consum', 0.0222, 'lps'),
	(477141, 125, '2015-04-01 00:49:55.000000', 'consum', 0.0210, 'lps'),
	(477142, 125, '2015-04-01 00:49:56.000000', 'consum', 0.0223, 'lps'),
	(477143, 125, '2015-04-01 00:49:57.000000', 'consum', 0.0229, 'lps'),
	(477144, 125, '2015-04-01 00:49:58.000000', 'consum', 0.0215, 'lps'),
	(477145, 125, '2015-04-01 00:49:59.000000', 'consum', 0.0229, 'lps'),
	(477146, 125, '2015-04-01 00:50:00.000000', 'consum', 0.0219, 'lps'),
	(477147, 125, '2015-04-01 00:50:01.000000', 'consum', 0.0221, 'lps'),
	(477148, 125, '2015-04-01 00:50:02.000000', 'consum', 0.0217, 'lps'),
	(477149, 125, '2015-04-01 00:50:03.000000', 'consum', 0.0211, 'lps'),
	(477150, 125, '2015-04-01 00:50:04.000000', 'consum', 0.0219, 'lps'),
	(477151, 125, '2015-04-01 00:50:05.000000', 'consum', 0.0230, 'lps'),
	(477152, 125, '2015-04-01 00:50:06.000000', 'consum', 0.0211, 'lps'),
	(477153, 125, '2015-04-01 00:50:07.000000', 'consum', 0.0228, 'lps'),
	(477154, 125, '2015-04-01 00:50:08.000000', 'consum', 0.0225, 'lps'),
	(477155, 125, '2015-04-01 00:50:09.000000', 'consum', 0.0232, 'lps'),
	(477156, 125, '2015-04-01 00:50:10.000000', 'consum', 0.0227, 'lps'),
	(477157, 125, '2015-04-01 00:50:11.000000', 'consum', 0.0232, 'lps'),
	(477158, 125, '2015-04-01 00:50:12.000000', 'consum', 0.0218, 'lps'),
	(477159, 125, '2015-04-01 00:50:13.000000', 'consum', 0.0210, 'lps'),
	(477160, 125, '2015-04-01 00:50:14.000000', 'consum', 0.0212, 'lps'),
	(477161, 125, '2015-04-01 00:50:15.000000', 'consum', 0.0220, 'lps'),
	(477162, 125, '2015-04-01 00:50:16.000000', 'consum', 0.0229, 'lps'),
	(477163, 125, '2015-04-01 00:50:17.000000', 'consum', 0.0230, 'lps'),
	(477164, 125, '2015-04-01 00:50:18.000000', 'consum', 0.0229, 'lps'),
	(477165, 125, '2015-04-01 00:50:19.000000', 'consum', 0.0222, 'lps'),
	(477166, 125, '2015-04-01 00:50:20.000000', 'consum', 0.0211, 'lps'),
	(477167, 125, '2015-04-01 00:50:21.000000', 'consum', 0.0230, 'lps'),
	(477168, 125, '2015-04-01 00:50:22.000000', 'consum', 0.0211, 'lps'),
	(477169, 125, '2015-04-01 00:50:23.000000', 'consum', 0.0227, 'lps'),
	(477170, 125, '2015-04-01 00:50:24.000000', 'consum', 0.0220, 'lps'),
	(477171, 125, '2015-04-01 00:50:25.000000', 'consum', 0.0212, 'lps'),
	(477172, 125, '2015-04-01 00:50:26.000000', 'consum', 0.0212, 'lps'),
	(477173, 125, '2015-04-01 00:50:27.000000', 'consum', 0.0213, 'lps'),
	(477174, 125, '2015-04-01 00:50:28.000000', 'consum', 0.0222, 'lps'),
	(477175, 125, '2015-04-01 00:50:29.000000', 'consum', 0.0214, 'lps'),
	(477176, 125, '2015-04-01 00:50:30.000000', 'consum', 0.0216, 'lps'),
	(477177, 125, '2015-04-01 00:50:31.000000', 'consum', 0.0232, 'lps'),
	(477178, 125, '2015-04-01 00:50:32.000000', 'consum', 0.0228, 'lps'),
	(477179, 125, '2015-04-01 00:50:33.000000', 'consum', 0.0210, 'lps'),
	(477180, 125, '2015-04-01 00:50:34.000000', 'consum', 0.0227, 'lps'),
	(477181, 125, '2015-04-01 00:50:35.000000', 'consum', 0.0227, 'lps'),
	(477182, 125, '2015-04-01 00:50:36.000000', 'consum', 0.0219, 'lps'),
	(477183, 125, '2015-04-01 00:50:37.000000', 'consum', 0.0227, 'lps'),
	(477184, 125, '2015-04-01 00:50:38.000000', 'consum', 0.0221, 'lps'),
	(477185, 125, '2015-04-01 00:50:39.000000', 'consum', 0.0215, 'lps'),
	(477186, 125, '2015-04-01 00:50:40.000000', 'consum', 0.0227, 'lps'),
	(477187, 125, '2015-04-01 00:50:41.000000', 'consum', 0.0232, 'lps'),
	(477188, 125, '2015-04-01 00:50:42.000000', 'consum', 0.0223, 'lps'),
	(477189, 125, '2015-04-01 00:50:43.000000', 'consum', 0.0233, 'lps'),
	(477190, 125, '2015-04-01 00:50:44.000000', 'consum', 0.0213, 'lps'),
	(477191, 125, '2015-04-01 00:50:45.000000', 'consum', 0.0228, 'lps'),
	(477192, 125, '2015-04-01 00:50:46.000000', 'consum', 0.0222, 'lps'),
	(477193, 125, '2015-04-01 00:50:47.000000', 'consum', 0.0214, 'lps'),
	(477194, 125, '2015-04-01 00:50:48.000000', 'consum', 0.0218, 'lps'),
	(477195, 125, '2015-04-01 00:50:49.000000', 'consum', 0.0215, 'lps'),
	(477196, 125, '2015-04-01 00:50:50.000000', 'consum', 0.0214, 'lps'),
	(477197, 125, '2015-04-01 00:50:51.000000', 'consum', 0.0213, 'lps'),
	(477198, 125, '2015-04-01 00:50:52.000000', 'consum', 0.0216, 'lps'),
	(477199, 125, '2015-04-01 00:50:53.000000', 'consum', 0.0229, 'lps'),
	(477200, 125, '2015-04-01 00:50:54.000000', 'consum', 0.0215, 'lps'),
	(477201, 125, '2015-04-01 00:50:55.000000', 'consum', 0.0228, 'lps'),
	(477202, 125, '2015-04-01 00:50:56.000000', 'consum', 0.0214, 'lps'),
	(477203, 125, '2015-04-01 00:50:57.000000', 'consum', 0.0224, 'lps'),
	(477204, 125, '2015-04-01 00:50:58.000000', 'consum', 0.0218, 'lps'),
	(477205, 125, '2015-04-01 00:50:59.000000', 'consum', 0.0211, 'lps'),
	(477206, 125, '2015-04-01 00:51:00.000000', 'consum', 0.0217, 'lps'),
	(477207, 125, '2015-04-01 00:51:01.000000', 'consum', 0.0215, 'lps'),
	(477208, 125, '2015-04-01 00:51:02.000000', 'consum', 0.0217, 'lps'),
	(477209, 125, '2015-04-01 00:51:03.000000', 'consum', 0.0229, 'lps'),
	(477210, 125, '2015-04-01 00:51:04.000000', 'consum', 0.0212, 'lps'),
	(477211, 125, '2015-04-01 00:51:05.000000', 'consum', 0.0213, 'lps'),
	(477212, 125, '2015-04-01 00:51:06.000000', 'consum', 0.0221, 'lps'),
	(477213, 125, '2015-04-01 00:51:07.000000', 'consum', 0.0230, 'lps'),
	(477214, 125, '2015-04-01 00:51:08.000000', 'consum', 0.0229, 'lps'),
	(477215, 125, '2015-04-01 00:51:09.000000', 'consum', 0.0220, 'lps'),
	(477216, 125, '2015-04-01 00:51:10.000000', 'consum', 0.0231, 'lps'),
	(477217, 125, '2015-04-01 00:51:11.000000', 'consum', 0.0210, 'lps'),
	(477218, 125, '2015-04-01 00:51:12.000000', 'consum', 0.0223, 'lps'),
	(477219, 125, '2015-04-01 00:51:13.000000', 'consum', 0.0224, 'lps'),
	(477220, 125, '2015-04-01 00:51:14.000000', 'consum', 0.0221, 'lps'),
	(477221, 125, '2015-04-01 00:51:15.000000', 'consum', 0.0221, 'lps'),
	(477222, 125, '2015-04-01 00:51:16.000000', 'consum', 0.0233, 'lps'),
	(477223, 125, '2015-04-01 00:51:17.000000', 'consum', 0.0220, 'lps'),
	(477224, 125, '2015-04-01 00:51:18.000000', 'consum', 0.0215, 'lps'),
	(477225, 125, '2015-04-01 00:51:19.000000', 'consum', 0.0229, 'lps'),
	(477226, 125, '2015-04-01 00:51:20.000000', 'consum', 0.0221, 'lps'),
	(477227, 125, '2015-04-01 00:51:21.000000', 'consum', 0.0230, 'lps'),
	(477228, 125, '2015-04-01 00:51:22.000000', 'consum', 0.0232, 'lps'),
	(477229, 125, '2015-04-01 00:51:23.000000', 'consum', 0.0210, 'lps'),
	(477230, 125, '2015-04-01 00:51:24.000000', 'consum', 0.0217, 'lps'),
	(477231, 125, '2015-04-01 00:51:25.000000', 'consum', 0.0220, 'lps'),
	(477232, 125, '2015-04-01 00:51:26.000000', 'consum', 0.0217, 'lps'),
	(477233, 125, '2015-04-01 00:51:27.000000', 'consum', 0.0216, 'lps'),
	(477234, 125, '2015-04-01 00:51:28.000000', 'consum', 0.0220, 'lps'),
	(477235, 125, '2015-04-01 00:51:29.000000', 'consum', 0.0216, 'lps'),
	(477236, 125, '2015-04-01 00:51:30.000000', 'consum', 0.0213, 'lps'),
	(477237, 125, '2015-04-01 00:51:31.000000', 'consum', 0.0229, 'lps'),
	(477238, 125, '2015-04-01 00:51:32.000000', 'consum', 0.0225, 'lps'),
	(477239, 125, '2015-04-01 00:51:33.000000', 'consum', 0.0229, 'lps'),
	(477240, 125, '2015-04-01 00:51:34.000000', 'consum', 0.0213, 'lps'),
	(477241, 125, '2015-04-01 00:51:35.000000', 'consum', 0.0214, 'lps'),
	(477242, 125, '2015-04-01 00:51:36.000000', 'consum', 0.0224, 'lps'),
	(477243, 125, '2015-04-01 00:51:37.000000', 'consum', 0.0219, 'lps'),
	(477244, 125, '2015-04-01 00:51:38.000000', 'consum', 0.0215, 'lps'),
	(477245, 125, '2015-04-01 00:51:39.000000', 'consum', 0.0233, 'lps'),
	(477246, 125, '2015-04-01 00:51:40.000000', 'consum', 0.0212, 'lps'),
	(477247, 125, '2015-04-01 00:51:41.000000', 'consum', 0.0223, 'lps'),
	(477248, 125, '2015-04-01 00:51:42.000000', 'consum', 0.0221, 'lps'),
	(477249, 125, '2015-04-01 00:51:43.000000', 'consum', 0.0229, 'lps'),
	(477250, 125, '2015-04-01 00:51:44.000000', 'consum', 0.0225, 'lps'),
	(477251, 125, '2015-04-01 00:51:45.000000', 'consum', 0.0227, 'lps'),
	(477252, 125, '2015-04-01 00:51:46.000000', 'consum', 0.0225, 'lps'),
	(477253, 125, '2015-04-01 00:51:47.000000', 'consum', 0.0214, 'lps'),
	(477254, 125, '2015-04-01 00:51:48.000000', 'consum', 0.0231, 'lps'),
	(477255, 125, '2015-04-01 00:51:49.000000', 'consum', 0.0230, 'lps'),
	(477256, 125, '2015-04-01 00:51:50.000000', 'consum', 0.0227, 'lps'),
	(477257, 125, '2015-04-01 00:51:51.000000', 'consum', 0.0210, 'lps'),
	(477258, 125, '2015-04-01 00:51:52.000000', 'consum', 0.0233, 'lps'),
	(477259, 125, '2015-04-01 00:51:53.000000', 'consum', 0.0229, 'lps'),
	(477260, 125, '2015-04-01 00:51:54.000000', 'consum', 0.0214, 'lps'),
	(477261, 125, '2015-04-01 00:51:55.000000', 'consum', 0.0220, 'lps'),
	(477262, 125, '2015-04-01 00:51:56.000000', 'consum', 0.0226, 'lps'),
	(477263, 125, '2015-04-01 00:51:57.000000', 'consum', 0.0211, 'lps'),
	(477264, 125, '2015-04-01 00:51:58.000000', 'consum', 0.0215, 'lps'),
	(477265, 125, '2015-04-01 00:51:59.000000', 'consum', 0.0233, 'lps'),
	(477266, 125, '2015-04-01 00:52:00.000000', 'consum', 0.0214, 'lps'),
	(477267, 125, '2015-04-01 00:52:01.000000', 'consum', 0.0211, 'lps'),
	(477268, 125, '2015-04-01 00:52:02.000000', 'consum', 0.0228, 'lps'),
	(477269, 125, '2015-04-01 00:52:03.000000', 'consum', 0.0225, 'lps'),
	(477270, 125, '2015-04-01 00:52:04.000000', 'consum', 0.0232, 'lps'),
	(477271, 125, '2015-04-01 00:52:05.000000', 'consum', 0.0227, 'lps'),
	(477272, 125, '2015-04-01 00:52:06.000000', 'consum', 0.0231, 'lps'),
	(477273, 125, '2015-04-01 00:52:07.000000', 'consum', 0.0216, 'lps'),
	(477274, 125, '2015-04-01 00:52:08.000000', 'consum', 0.0224, 'lps'),
	(477275, 125, '2015-04-01 00:52:09.000000', 'consum', 0.0217, 'lps'),
	(477276, 125, '2015-04-01 00:52:10.000000', 'consum', 0.0226, 'lps'),
	(477277, 125, '2015-04-01 00:52:11.000000', 'consum', 0.0222, 'lps'),
	(477278, 125, '2015-04-01 00:52:12.000000', 'consum', 0.0222, 'lps'),
	(477279, 125, '2015-04-01 00:52:13.000000', 'consum', 0.0210, 'lps'),
	(477280, 125, '2015-04-01 00:52:14.000000', 'consum', 0.0222, 'lps'),
	(477281, 125, '2015-04-01 00:52:15.000000', 'consum', 0.0223, 'lps'),
	(477282, 125, '2015-04-01 00:52:16.000000', 'consum', 0.0214, 'lps'),
	(477283, 125, '2015-04-01 00:52:17.000000', 'consum', 0.0219, 'lps'),
	(477284, 125, '2015-04-01 00:52:18.000000', 'consum', 0.0217, 'lps'),
	(477285, 125, '2015-04-01 00:52:19.000000', 'consum', 0.0218, 'lps'),
	(477286, 125, '2015-04-01 00:52:20.000000', 'consum', 0.0231, 'lps'),
	(477287, 125, '2015-04-01 00:52:21.000000', 'consum', 0.0219, 'lps'),
	(477288, 125, '2015-04-01 00:52:22.000000', 'consum', 0.0215, 'lps'),
	(477289, 125, '2015-04-01 00:52:23.000000', 'consum', 0.0211, 'lps'),
	(477290, 125, '2015-04-01 00:52:24.000000', 'consum', 0.0223, 'lps'),
	(477291, 125, '2015-04-01 00:52:25.000000', 'consum', 0.0225, 'lps'),
	(477292, 125, '2015-04-01 00:52:26.000000', 'consum', 0.0224, 'lps'),
	(477293, 125, '2015-04-01 00:52:27.000000', 'consum', 0.0233, 'lps'),
	(477294, 125, '2015-04-01 00:52:28.000000', 'consum', 0.0213, 'lps'),
	(477295, 125, '2015-04-01 00:52:29.000000', 'consum', 0.0228, 'lps'),
	(477296, 125, '2015-04-01 00:52:30.000000', 'consum', 0.0222, 'lps'),
	(477297, 125, '2015-04-01 00:52:31.000000', 'consum', 0.0213, 'lps'),
	(477298, 125, '2015-04-01 00:52:32.000000', 'consum', 0.0216, 'lps'),
	(477299, 125, '2015-04-01 00:52:33.000000', 'consum', 0.0232, 'lps'),
	(477300, 125, '2015-04-01 00:52:34.000000', 'consum', 0.0231, 'lps'),
	(477301, 125, '2015-04-01 00:52:35.000000', 'consum', 0.0222, 'lps'),
	(477302, 125, '2015-04-01 00:52:36.000000', 'consum', 0.0211, 'lps'),
	(477303, 125, '2015-04-01 00:52:37.000000', 'consum', 0.0227, 'lps'),
	(477304, 125, '2015-04-01 00:52:38.000000', 'consum', 0.0221, 'lps'),
	(477305, 125, '2015-04-01 00:52:39.000000', 'consum', 0.0214, 'lps'),
	(477306, 125, '2015-04-01 00:52:40.000000', 'consum', 0.0221, 'lps'),
	(477307, 125, '2015-04-01 00:52:41.000000', 'consum', 0.0231, 'lps'),
	(477308, 125, '2015-04-01 00:52:42.000000', 'consum', 0.0232, 'lps'),
	(477309, 125, '2015-04-01 00:52:43.000000', 'consum', 0.0212, 'lps'),
	(477310, 125, '2015-04-01 00:52:44.000000', 'consum', 0.0226, 'lps'),
	(477311, 125, '2015-04-01 00:52:45.000000', 'consum', 0.0211, 'lps'),
	(477312, 125, '2015-04-01 00:52:46.000000', 'consum', 0.0218, 'lps'),
	(477313, 125, '2015-04-01 00:52:47.000000', 'consum', 0.0224, 'lps'),
	(477314, 125, '2015-04-01 00:52:48.000000', 'consum', 0.0231, 'lps'),
	(477315, 125, '2015-04-01 00:52:49.000000', 'consum', 0.0228, 'lps'),
	(477316, 125, '2015-04-01 00:52:50.000000', 'consum', 0.0211, 'lps'),
	(477317, 125, '2015-04-01 00:52:51.000000', 'consum', 0.0211, 'lps'),
	(477318, 125, '2015-04-01 00:52:52.000000', 'consum', 0.0211, 'lps'),
	(477319, 125, '2015-04-01 00:52:53.000000', 'consum', 0.0215, 'lps'),
	(477320, 125, '2015-04-01 00:52:54.000000', 'consum', 0.0232, 'lps'),
	(477321, 125, '2015-04-01 00:52:55.000000', 'consum', 0.0232, 'lps'),
	(477322, 125, '2015-04-01 00:52:56.000000', 'consum', 0.0231, 'lps'),
	(477323, 125, '2015-04-01 00:52:57.000000', 'consum', 0.0227, 'lps'),
	(477324, 125, '2015-04-01 00:52:58.000000', 'consum', 0.0210, 'lps'),
	(477325, 125, '2015-04-01 00:52:59.000000', 'consum', 0.0228, 'lps'),
	(477326, 125, '2015-04-01 00:53:00.000000', 'consum', 0.0228, 'lps'),
	(477327, 125, '2015-04-01 00:53:01.000000', 'consum', 0.0225, 'lps'),
	(477328, 125, '2015-04-01 00:53:02.000000', 'consum', 0.0230, 'lps'),
	(477329, 125, '2015-04-01 00:53:03.000000', 'consum', 0.0216, 'lps'),
	(477330, 125, '2015-04-01 00:53:04.000000', 'consum', 0.0232, 'lps'),
	(477331, 125, '2015-04-01 00:53:05.000000', 'consum', 0.0229, 'lps'),
	(477332, 125, '2015-04-01 00:53:06.000000', 'consum', 0.0214, 'lps'),
	(477333, 125, '2015-04-01 00:53:07.000000', 'consum', 0.0222, 'lps'),
	(477334, 125, '2015-04-01 00:53:08.000000', 'consum', 0.0233, 'lps'),
	(477335, 125, '2015-04-01 00:53:09.000000', 'consum', 0.0221, 'lps'),
	(477336, 125, '2015-04-01 00:53:10.000000', 'consum', 0.0217, 'lps'),
	(477337, 125, '2015-04-01 00:53:11.000000', 'consum', 0.0214, 'lps'),
	(477338, 125, '2015-04-01 00:53:12.000000', 'consum', 0.0211, 'lps'),
	(477339, 125, '2015-04-01 00:53:13.000000', 'consum', 0.0227, 'lps'),
	(477340, 125, '2015-04-01 00:53:14.000000', 'consum', 0.0221, 'lps'),
	(477341, 125, '2015-04-01 00:53:15.000000', 'consum', 0.0214, 'lps'),
	(477342, 125, '2015-04-01 00:53:16.000000', 'consum', 0.0220, 'lps'),
	(477343, 125, '2015-04-01 00:53:17.000000', 'consum', 0.0227, 'lps'),
	(477344, 125, '2015-04-01 00:53:18.000000', 'consum', 0.0216, 'lps'),
	(477345, 125, '2015-04-01 00:53:19.000000', 'consum', 0.0216, 'lps'),
	(477346, 125, '2015-04-01 00:53:20.000000', 'consum', 0.0219, 'lps'),
	(477347, 125, '2015-04-01 00:53:21.000000', 'consum', 0.0217, 'lps'),
	(477348, 125, '2015-04-01 00:53:22.000000', 'consum', 0.0217, 'lps'),
	(477349, 125, '2015-04-01 00:53:23.000000', 'consum', 0.0225, 'lps'),
	(477350, 125, '2015-04-01 00:53:24.000000', 'consum', 0.0215, 'lps'),
	(477351, 125, '2015-04-01 00:53:25.000000', 'consum', 0.0214, 'lps'),
	(477352, 125, '2015-04-01 00:53:26.000000', 'consum', 0.0215, 'lps'),
	(477353, 125, '2015-04-01 00:53:27.000000', 'consum', 0.0226, 'lps'),
	(477354, 125, '2015-04-01 00:53:28.000000', 'consum', 0.0226, 'lps'),
	(477355, 125, '2015-04-01 00:53:29.000000', 'consum', 0.0218, 'lps'),
	(477356, 125, '2015-04-01 00:53:30.000000', 'consum', 0.0226, 'lps'),
	(477357, 125, '2015-04-01 00:53:31.000000', 'consum', 0.0220, 'lps'),
	(477358, 125, '2015-04-01 00:53:32.000000', 'consum', 0.0213, 'lps'),
	(477359, 125, '2015-04-01 00:53:33.000000', 'consum', 0.0219, 'lps'),
	(477360, 125, '2015-04-01 00:53:34.000000', 'consum', 0.0222, 'lps'),
	(477361, 125, '2015-04-01 00:53:35.000000', 'consum', 0.0221, 'lps'),
	(477362, 125, '2015-04-01 00:53:36.000000', 'consum', 0.0229, 'lps'),
	(477363, 125, '2015-04-01 00:53:37.000000', 'consum', 0.0225, 'lps'),
	(477364, 125, '2015-04-01 00:53:38.000000', 'consum', 0.0229, 'lps'),
	(477365, 125, '2015-04-01 00:53:39.000000', 'consum', 0.0213, 'lps'),
	(477366, 125, '2015-04-01 00:53:40.000000', 'consum', 0.0214, 'lps'),
	(477367, 125, '2015-04-01 00:53:41.000000', 'consum', 0.0223, 'lps'),
	(477368, 125, '2015-04-01 00:53:42.000000', 'consum', 0.0217, 'lps'),
	(477369, 125, '2015-04-01 00:53:43.000000', 'consum', 0.0230, 'lps'),
	(477370, 125, '2015-04-01 00:53:44.000000', 'consum', 0.0216, 'lps'),
	(477371, 125, '2015-04-01 00:53:45.000000', 'consum', 0.0230, 'lps'),
	(477372, 125, '2015-04-01 00:53:46.000000', 'consum', 0.0219, 'lps'),
	(477373, 125, '2015-04-01 00:53:47.000000', 'consum', 0.0220, 'lps'),
	(477374, 125, '2015-04-01 00:53:48.000000', 'consum', 0.0232, 'lps'),
	(477375, 125, '2015-04-01 00:53:49.000000', 'consum', 0.0219, 'lps'),
	(477376, 125, '2015-04-01 00:53:50.000000', 'consum', 0.0216, 'lps'),
	(477377, 125, '2015-04-01 00:53:51.000000', 'consum', 0.0210, 'lps'),
	(477378, 125, '2015-04-01 00:53:52.000000', 'consum', 0.0219, 'lps'),
	(477379, 125, '2015-04-01 00:53:53.000000', 'consum', 0.0230, 'lps'),
	(477380, 125, '2015-04-01 00:53:54.000000', 'consum', 0.0212, 'lps'),
	(477381, 125, '2015-04-01 00:53:55.000000', 'consum', 0.0210, 'lps'),
	(477382, 125, '2015-04-01 00:53:56.000000', 'consum', 0.0227, 'lps'),
	(477383, 125, '2015-04-01 00:53:57.000000', 'consum', 0.0222, 'lps'),
	(477384, 125, '2015-04-01 00:53:58.000000', 'consum', 0.0221, 'lps'),
	(477385, 125, '2015-04-01 00:53:59.000000', 'consum', 0.0231, 'lps'),
	(477386, 125, '2015-04-01 00:54:00.000000', 'consum', 0.0232, 'lps'),
	(477387, 125, '2015-04-01 00:54:01.000000', 'consum', 0.0211, 'lps'),
	(477388, 125, '2015-04-01 00:54:02.000000', 'consum', 0.0220, 'lps'),
	(477389, 125, '2015-04-01 00:54:03.000000', 'consum', 0.0211, 'lps'),
	(477390, 125, '2015-04-01 00:54:04.000000', 'consum', 0.0210, 'lps'),
	(477391, 125, '2015-04-01 00:54:05.000000', 'consum', 0.0230, 'lps'),
	(477392, 125, '2015-04-01 00:54:06.000000', 'consum', 0.0215, 'lps'),
	(477393, 125, '2015-04-01 00:54:07.000000', 'consum', 0.0222, 'lps'),
	(477394, 125, '2015-04-01 00:54:08.000000', 'consum', 0.0233, 'lps'),
	(477395, 125, '2015-04-01 00:54:09.000000', 'consum', 0.0215, 'lps'),
	(477396, 125, '2015-04-01 00:54:10.000000', 'consum', 0.0216, 'lps'),
	(477397, 125, '2015-04-01 00:54:11.000000', 'consum', 0.0227, 'lps'),
	(477398, 125, '2015-04-01 00:54:12.000000', 'consum', 0.0228, 'lps'),
	(477399, 125, '2015-04-01 00:54:13.000000', 'consum', 0.0226, 'lps'),
	(477400, 125, '2015-04-01 00:54:14.000000', 'consum', 0.0212, 'lps'),
	(477401, 125, '2015-04-01 00:54:15.000000', 'consum', 0.0222, 'lps'),
	(477402, 125, '2015-04-01 00:54:16.000000', 'consum', 0.0216, 'lps'),
	(477403, 125, '2015-04-01 00:54:17.000000', 'consum', 0.0227, 'lps'),
	(477404, 125, '2015-04-01 00:54:18.000000', 'consum', 0.0229, 'lps'),
	(477405, 125, '2015-04-01 00:54:19.000000', 'consum', 0.0231, 'lps'),
	(477406, 125, '2015-04-01 00:54:20.000000', 'consum', 0.0210, 'lps'),
	(477407, 125, '2015-04-01 00:54:21.000000', 'consum', 0.0220, 'lps'),
	(477408, 125, '2015-04-01 00:54:22.000000', 'consum', 0.0212, 'lps'),
	(477409, 125, '2015-04-01 00:54:23.000000', 'consum', 0.0217, 'lps'),
	(477410, 125, '2015-04-01 00:54:24.000000', 'consum', 0.0213, 'lps'),
	(477411, 125, '2015-04-01 00:54:25.000000', 'consum', 0.0228, 'lps'),
	(477412, 125, '2015-04-01 00:54:26.000000', 'consum', 0.0220, 'lps'),
	(477413, 125, '2015-04-01 00:54:27.000000', 'consum', 0.0230, 'lps'),
	(477414, 125, '2015-04-01 00:54:28.000000', 'consum', 0.0233, 'lps'),
	(477415, 125, '2015-04-01 00:54:29.000000', 'consum', 0.0219, 'lps'),
	(477416, 125, '2015-04-01 00:54:30.000000', 'consum', 0.0231, 'lps'),
	(477417, 125, '2015-04-01 00:54:31.000000', 'consum', 0.0220, 'lps'),
	(477418, 125, '2015-04-01 00:54:32.000000', 'consum', 0.0220, 'lps'),
	(477419, 125, '2015-04-01 00:54:33.000000', 'consum', 0.0232, 'lps'),
	(477420, 125, '2015-04-01 00:54:34.000000', 'consum', 0.0220, 'lps'),
	(477421, 125, '2015-04-01 00:54:35.000000', 'consum', 0.0215, 'lps'),
	(477422, 125, '2015-04-01 00:54:36.000000', 'consum', 0.0232, 'lps'),
	(477423, 125, '2015-04-01 00:54:37.000000', 'consum', 0.0233, 'lps'),
	(477424, 125, '2015-04-01 00:54:38.000000', 'consum', 0.0212, 'lps'),
	(477425, 125, '2015-04-01 00:54:39.000000', 'consum', 0.0222, 'lps'),
	(477426, 125, '2015-04-01 00:54:40.000000', 'consum', 0.0219, 'lps'),
	(477427, 125, '2015-04-01 00:54:41.000000', 'consum', 0.0219, 'lps'),
	(477428, 125, '2015-04-01 00:54:42.000000', 'consum', 0.0228, 'lps'),
	(477429, 125, '2015-04-01 00:54:43.000000', 'consum', 0.0223, 'lps'),
	(477430, 125, '2015-04-01 00:54:44.000000', 'consum', 0.0225, 'lps'),
	(477431, 125, '2015-04-01 00:54:45.000000', 'consum', 0.0223, 'lps'),
	(477432, 125, '2015-04-01 00:54:46.000000', 'consum', 0.0228, 'lps'),
	(477433, 125, '2015-04-01 00:54:47.000000', 'consum', 0.0216, 'lps'),
	(477434, 125, '2015-04-01 00:54:48.000000', 'consum', 0.0210, 'lps'),
	(477435, 125, '2015-04-01 00:54:49.000000', 'consum', 0.0214, 'lps'),
	(477436, 125, '2015-04-01 00:54:50.000000', 'consum', 0.0233, 'lps'),
	(477437, 125, '2015-04-01 00:54:51.000000', 'consum', 0.0216, 'lps'),
	(477438, 125, '2015-04-01 00:54:52.000000', 'consum', 0.0222, 'lps'),
	(477439, 125, '2015-04-01 00:54:53.000000', 'consum', 0.0228, 'lps'),
	(477440, 125, '2015-04-01 00:54:54.000000', 'consum', 0.0214, 'lps'),
	(477441, 125, '2015-04-01 00:54:55.000000', 'consum', 0.0225, 'lps'),
	(477442, 125, '2015-04-01 00:54:56.000000', 'consum', 0.0226, 'lps'),
	(477443, 125, '2015-04-01 00:54:57.000000', 'consum', 0.0221, 'lps'),
	(477444, 125, '2015-04-01 00:54:58.000000', 'consum', 0.0217, 'lps'),
	(477445, 125, '2015-04-01 00:54:59.000000', 'consum', 0.0213, 'lps'),
	(477446, 125, '2015-04-01 00:55:00.000000', 'consum', 0.0228, 'lps'),
	(477447, 125, '2015-04-01 00:55:01.000000', 'consum', 0.0221, 'lps'),
	(477448, 125, '2015-04-01 00:55:02.000000', 'consum', 0.0212, 'lps'),
	(477449, 125, '2015-04-01 00:55:03.000000', 'consum', 0.0212, 'lps'),
	(477450, 125, '2015-04-01 00:55:04.000000', 'consum', 0.0215, 'lps'),
	(477451, 125, '2015-04-01 00:55:05.000000', 'consum', 0.0229, 'lps'),
	(477452, 125, '2015-04-01 00:55:06.000000', 'consum', 0.0219, 'lps'),
	(477453, 125, '2015-04-01 00:55:07.000000', 'consum', 0.0221, 'lps'),
	(477454, 125, '2015-04-01 00:55:08.000000', 'consum', 0.0214, 'lps'),
	(477455, 125, '2015-04-01 00:55:09.000000', 'consum', 0.0220, 'lps'),
	(477456, 125, '2015-04-01 00:55:10.000000', 'consum', 0.0227, 'lps'),
	(477457, 125, '2015-04-01 00:55:11.000000', 'consum', 0.0218, 'lps'),
	(477458, 125, '2015-04-01 00:55:12.000000', 'consum', 0.0221, 'lps'),
	(477459, 125, '2015-04-01 00:55:13.000000', 'consum', 0.0218, 'lps'),
	(477460, 125, '2015-04-01 00:55:14.000000', 'consum', 0.0220, 'lps'),
	(477461, 125, '2015-04-01 00:55:15.000000', 'consum', 0.0233, 'lps'),
	(477462, 125, '2015-04-01 00:55:16.000000', 'consum', 0.0226, 'lps'),
	(477463, 125, '2015-04-01 00:55:17.000000', 'consum', 0.0222, 'lps'),
	(477464, 125, '2015-04-01 00:55:18.000000', 'consum', 0.0222, 'lps'),
	(477465, 125, '2015-04-01 00:55:19.000000', 'consum', 0.0210, 'lps'),
	(477466, 125, '2015-04-01 00:55:20.000000', 'consum', 0.0222, 'lps'),
	(477467, 125, '2015-04-01 00:55:21.000000', 'consum', 0.0222, 'lps'),
	(477468, 125, '2015-04-01 00:55:22.000000', 'consum', 0.0211, 'lps'),
	(477469, 125, '2015-04-01 00:55:23.000000', 'consum', 0.0228, 'lps'),
	(477470, 125, '2015-04-01 00:55:24.000000', 'consum', 0.0224, 'lps'),
	(477471, 125, '2015-04-01 00:55:25.000000', 'consum', 0.0226, 'lps'),
	(477472, 125, '2015-04-01 00:55:26.000000', 'consum', 0.0225, 'lps'),
	(477473, 125, '2015-04-01 00:55:27.000000', 'consum', 0.0216, 'lps'),
	(477474, 125, '2015-04-01 00:55:28.000000', 'consum', 0.0216, 'lps'),
	(477475, 125, '2015-04-01 00:55:29.000000', 'consum', 0.0225, 'lps'),
	(477476, 125, '2015-04-01 00:55:30.000000', 'consum', 0.0218, 'lps'),
	(477477, 125, '2015-04-01 00:55:31.000000', 'consum', 0.0229, 'lps'),
	(477478, 125, '2015-04-01 00:55:32.000000', 'consum', 0.0210, 'lps'),
	(477479, 125, '2015-04-01 00:55:33.000000', 'consum', 0.0225, 'lps'),
	(477480, 125, '2015-04-01 00:55:34.000000', 'consum', 0.0215, 'lps'),
	(477481, 125, '2015-04-01 00:55:35.000000', 'consum', 0.0215, 'lps'),
	(477482, 125, '2015-04-01 00:55:36.000000', 'consum', 0.0219, 'lps'),
	(477483, 125, '2015-04-01 00:55:37.000000', 'consum', 0.0216, 'lps'),
	(477484, 125, '2015-04-01 00:55:38.000000', 'consum', 0.0215, 'lps'),
	(477485, 125, '2015-04-01 00:55:39.000000', 'consum', 0.0215, 'lps'),
	(477486, 125, '2015-04-01 00:55:40.000000', 'consum', 0.0223, 'lps'),
	(477487, 125, '2015-04-01 00:55:41.000000', 'consum', 0.0210, 'lps'),
	(477488, 125, '2015-04-01 00:55:42.000000', 'consum', 0.0219, 'lps'),
	(477489, 125, '2015-04-01 00:55:43.000000', 'consum', 0.0232, 'lps'),
	(477490, 125, '2015-04-01 00:55:44.000000', 'consum', 0.0221, 'lps'),
	(477491, 125, '2015-04-01 00:55:45.000000', 'consum', 0.0224, 'lps'),
	(477492, 125, '2015-04-01 00:55:46.000000', 'consum', 0.0223, 'lps'),
	(477493, 125, '2015-04-01 00:55:47.000000', 'consum', 0.0212, 'lps'),
	(477494, 125, '2015-04-01 00:55:48.000000', 'consum', 0.0226, 'lps'),
	(477495, 125, '2015-04-01 00:55:49.000000', 'consum', 0.0216, 'lps'),
	(477496, 125, '2015-04-01 00:55:50.000000', 'consum', 0.0215, 'lps'),
	(477497, 125, '2015-04-01 00:55:51.000000', 'consum', 0.0219, 'lps'),
	(477498, 125, '2015-04-01 00:55:52.000000', 'consum', 0.0214, 'lps'),
	(477499, 125, '2015-04-01 00:55:53.000000', 'consum', 0.0228, 'lps'),
	(477500, 125, '2015-04-01 00:55:54.000000', 'consum', 0.0216, 'lps'),
	(477501, 125, '2015-04-01 00:55:55.000000', 'consum', 0.0211, 'lps'),
	(477502, 125, '2015-04-01 00:55:56.000000', 'consum', 0.0222, 'lps'),
	(477503, 125, '2015-04-01 00:55:57.000000', 'consum', 0.0217, 'lps'),
	(477504, 125, '2015-04-01 00:55:58.000000', 'consum', 0.0213, 'lps'),
	(477505, 125, '2015-04-01 00:55:59.000000', 'consum', 0.0226, 'lps'),
	(477506, 125, '2015-04-01 00:56:00.000000', 'consum', 0.0210, 'lps'),
	(477507, 125, '2015-04-01 00:56:01.000000', 'consum', 0.0212, 'lps'),
	(477508, 125, '2015-04-01 00:56:02.000000', 'consum', 0.0218, 'lps'),
	(477509, 125, '2015-04-01 00:56:03.000000', 'consum', 0.0221, 'lps'),
	(477510, 125, '2015-04-01 00:56:04.000000', 'consum', 0.0218, 'lps'),
	(477511, 125, '2015-04-01 00:56:05.000000', 'consum', 0.0217, 'lps'),
	(477512, 125, '2015-04-01 00:56:06.000000', 'consum', 0.0223, 'lps'),
	(477513, 125, '2015-04-01 00:56:07.000000', 'consum', 0.0229, 'lps'),
	(477514, 125, '2015-04-01 00:56:08.000000', 'consum', 0.0219, 'lps'),
	(477515, 125, '2015-04-01 00:56:09.000000', 'consum', 0.0223, 'lps'),
	(477516, 125, '2015-04-01 00:56:10.000000', 'consum', 0.0222, 'lps'),
	(477517, 125, '2015-04-01 00:56:11.000000', 'consum', 0.0233, 'lps'),
	(477518, 125, '2015-04-01 00:56:12.000000', 'consum', 0.0218, 'lps'),
	(477519, 125, '2015-04-01 00:56:13.000000', 'consum', 0.0228, 'lps'),
	(477520, 125, '2015-04-01 00:56:14.000000', 'consum', 0.0230, 'lps'),
	(477521, 125, '2015-04-01 00:56:15.000000', 'consum', 0.0232, 'lps'),
	(477522, 125, '2015-04-01 00:56:16.000000', 'consum', 0.0215, 'lps'),
	(477523, 125, '2015-04-01 00:56:17.000000', 'consum', 0.0214, 'lps'),
	(477524, 125, '2015-04-01 00:56:18.000000', 'consum', 0.0216, 'lps'),
	(477525, 125, '2015-04-01 00:56:19.000000', 'consum', 0.0230, 'lps'),
	(477526, 125, '2015-04-01 00:56:20.000000', 'consum', 0.0219, 'lps'),
	(477527, 125, '2015-04-01 00:56:21.000000', 'consum', 0.0220, 'lps'),
	(477528, 125, '2015-04-01 00:56:22.000000', 'consum', 0.0233, 'lps'),
	(477529, 125, '2015-04-01 00:56:23.000000', 'consum', 0.0223, 'lps'),
	(477530, 125, '2015-04-01 00:56:24.000000', 'consum', 0.0233, 'lps'),
	(477531, 125, '2015-04-01 00:56:25.000000', 'consum', 0.0212, 'lps'),
	(477532, 125, '2015-04-01 00:56:26.000000', 'consum', 0.0224, 'lps'),
	(477533, 125, '2015-04-01 00:56:27.000000', 'consum', 0.0228, 'lps'),
	(477534, 125, '2015-04-01 00:56:28.000000', 'consum', 0.0210, 'lps'),
	(477535, 125, '2015-04-01 00:56:29.000000', 'consum', 0.0228, 'lps'),
	(477536, 125, '2015-04-01 00:56:30.000000', 'consum', 0.0230, 'lps'),
	(477537, 125, '2015-04-01 00:56:31.000000', 'consum', 0.0231, 'lps'),
	(477538, 125, '2015-04-01 00:56:32.000000', 'consum', 0.0232, 'lps'),
	(477539, 125, '2015-04-01 00:56:33.000000', 'consum', 0.0210, 'lps'),
	(477540, 125, '2015-04-01 00:56:34.000000', 'consum', 0.0216, 'lps'),
	(477541, 125, '2015-04-01 00:56:35.000000', 'consum', 0.0215, 'lps'),
	(477542, 125, '2015-04-01 00:56:36.000000', 'consum', 0.0217, 'lps'),
	(477543, 125, '2015-04-01 00:56:37.000000', 'consum', 0.0231, 'lps'),
	(477544, 125, '2015-04-01 00:56:38.000000', 'consum', 0.0224, 'lps'),
	(477545, 125, '2015-04-01 00:56:39.000000', 'consum', 0.0216, 'lps'),
	(477546, 125, '2015-04-01 00:56:40.000000', 'consum', 0.0222, 'lps'),
	(477547, 125, '2015-04-01 00:56:41.000000', 'consum', 0.0229, 'lps'),
	(477548, 125, '2015-04-01 00:56:42.000000', 'consum', 0.0220, 'lps'),
	(477549, 125, '2015-04-01 00:56:43.000000', 'consum', 0.0227, 'lps'),
	(477550, 125, '2015-04-01 00:56:44.000000', 'consum', 0.0218, 'lps'),
	(477551, 125, '2015-04-01 00:56:45.000000', 'consum', 0.0226, 'lps'),
	(477552, 125, '2015-04-01 00:56:46.000000', 'consum', 0.0216, 'lps'),
	(477553, 125, '2015-04-01 00:56:47.000000', 'consum', 0.0219, 'lps'),
	(477554, 125, '2015-04-01 00:56:48.000000', 'consum', 0.0212, 'lps'),
	(477555, 125, '2015-04-01 00:56:49.000000', 'consum', 0.0216, 'lps'),
	(477556, 125, '2015-04-01 00:56:50.000000', 'consum', 0.0213, 'lps'),
	(477557, 125, '2015-04-01 00:56:51.000000', 'consum', 0.0231, 'lps'),
	(477558, 125, '2015-04-01 00:56:52.000000', 'consum', 0.0210, 'lps'),
	(477559, 125, '2015-04-01 00:56:53.000000', 'consum', 0.0220, 'lps'),
	(477560, 125, '2015-04-01 00:56:54.000000', 'consum', 0.0213, 'lps'),
	(477561, 125, '2015-04-01 00:56:55.000000', 'consum', 0.0219, 'lps'),
	(477562, 125, '2015-04-01 00:56:56.000000', 'consum', 0.0221, 'lps'),
	(477563, 125, '2015-04-01 00:56:57.000000', 'consum', 0.0216, 'lps'),
	(477564, 125, '2015-04-01 00:56:58.000000', 'consum', 0.0231, 'lps'),
	(477565, 125, '2015-04-01 00:56:59.000000', 'consum', 0.0228, 'lps'),
	(477566, 125, '2015-04-01 00:57:00.000000', 'consum', 0.0210, 'lps'),
	(477567, 125, '2015-04-01 00:57:01.000000', 'consum', 0.0230, 'lps'),
	(477568, 125, '2015-04-01 00:57:02.000000', 'consum', 0.0214, 'lps'),
	(477569, 125, '2015-04-01 00:57:03.000000', 'consum', 0.0219, 'lps'),
	(477570, 125, '2015-04-01 00:57:04.000000', 'consum', 0.0219, 'lps'),
	(477571, 125, '2015-04-01 00:57:05.000000', 'consum', 0.0229, 'lps'),
	(477572, 125, '2015-04-01 00:57:06.000000', 'consum', 0.0231, 'lps'),
	(477573, 125, '2015-04-01 00:57:07.000000', 'consum', 0.0210, 'lps'),
	(477574, 125, '2015-04-01 00:57:08.000000', 'consum', 0.0218, 'lps'),
	(477575, 125, '2015-04-01 00:57:09.000000', 'consum', 0.0227, 'lps'),
	(477576, 125, '2015-04-01 00:57:10.000000', 'consum', 0.0226, 'lps'),
	(477577, 125, '2015-04-01 00:57:11.000000', 'consum', 0.0212, 'lps'),
	(477578, 125, '2015-04-01 00:57:12.000000', 'consum', 0.0224, 'lps'),
	(477579, 125, '2015-04-01 00:57:13.000000', 'consum', 0.0224, 'lps'),
	(477580, 125, '2015-04-01 00:57:14.000000', 'consum', 0.0217, 'lps'),
	(477581, 125, '2015-04-01 00:57:15.000000', 'consum', 0.0226, 'lps'),
	(477582, 125, '2015-04-01 00:57:16.000000', 'consum', 0.0220, 'lps'),
	(477583, 125, '2015-04-01 00:57:17.000000', 'consum', 0.0212, 'lps'),
	(477584, 125, '2015-04-01 00:57:18.000000', 'consum', 0.0217, 'lps'),
	(477585, 125, '2015-04-01 00:57:19.000000', 'consum', 0.0217, 'lps'),
	(477586, 125, '2015-04-01 00:57:20.000000', 'consum', 0.0221, 'lps'),
	(477587, 125, '2015-04-01 00:57:21.000000', 'consum', 0.0221, 'lps'),
	(477588, 125, '2015-04-01 00:57:22.000000', 'consum', 0.0211, 'lps'),
	(477589, 125, '2015-04-01 00:57:23.000000', 'consum', 0.0229, 'lps'),
	(477590, 125, '2015-04-01 00:57:24.000000', 'consum', 0.0232, 'lps'),
	(477591, 125, '2015-04-01 00:57:25.000000', 'consum', 0.0214, 'lps'),
	(477592, 125, '2015-04-01 00:57:26.000000', 'consum', 0.0213, 'lps'),
	(477593, 125, '2015-04-01 00:57:27.000000', 'consum', 0.0214, 'lps'),
	(477594, 125, '2015-04-01 00:57:28.000000', 'consum', 0.0221, 'lps'),
	(477595, 125, '2015-04-01 00:57:29.000000', 'consum', 0.0228, 'lps'),
	(477596, 125, '2015-04-01 00:57:30.000000', 'consum', 0.0219, 'lps'),
	(477597, 125, '2015-04-01 00:57:31.000000', 'consum', 0.0226, 'lps'),
	(477598, 125, '2015-04-01 00:57:32.000000', 'consum', 0.0217, 'lps'),
	(477599, 125, '2015-04-01 00:57:33.000000', 'consum', 0.0221, 'lps'),
	(477600, 125, '2015-04-01 00:57:34.000000', 'consum', 0.0220, 'lps'),
	(477601, 125, '2015-04-01 00:57:35.000000', 'consum', 0.0227, 'lps'),
	(477602, 125, '2015-04-01 00:57:36.000000', 'consum', 0.0217, 'lps'),
	(477603, 125, '2015-04-01 00:57:37.000000', 'consum', 0.0219, 'lps'),
	(477604, 125, '2015-04-01 00:57:38.000000', 'consum', 0.0210, 'lps'),
	(477605, 125, '2015-04-01 00:57:39.000000', 'consum', 0.0233, 'lps'),
	(477606, 125, '2015-04-01 00:57:40.000000', 'consum', 0.0228, 'lps'),
	(477607, 125, '2015-04-01 00:57:41.000000', 'consum', 0.0231, 'lps'),
	(477608, 125, '2015-04-01 00:57:42.000000', 'consum', 0.0215, 'lps'),
	(477609, 125, '2015-04-01 00:57:43.000000', 'consum', 0.0218, 'lps'),
	(477610, 125, '2015-04-01 00:57:44.000000', 'consum', 0.0215, 'lps'),
	(477611, 125, '2015-04-01 00:57:45.000000', 'consum', 0.0210, 'lps'),
	(477612, 125, '2015-04-01 00:57:46.000000', 'consum', 0.0218, 'lps'),
	(477613, 125, '2015-04-01 00:57:47.000000', 'consum', 0.0228, 'lps'),
	(477614, 125, '2015-04-01 00:57:48.000000', 'consum', 0.0227, 'lps'),
	(477615, 125, '2015-04-01 00:57:49.000000', 'consum', 0.0220, 'lps'),
	(477616, 125, '2015-04-01 00:57:50.000000', 'consum', 0.0232, 'lps'),
	(477617, 125, '2015-04-01 00:57:51.000000', 'consum', 0.0218, 'lps'),
	(477618, 125, '2015-04-01 00:57:52.000000', 'consum', 0.0210, 'lps'),
	(477619, 125, '2015-04-01 00:57:53.000000', 'consum', 0.0232, 'lps'),
	(477620, 125, '2015-04-01 00:57:54.000000', 'consum', 0.0226, 'lps'),
	(477621, 125, '2015-04-01 00:57:55.000000', 'consum', 0.0224, 'lps'),
	(477622, 125, '2015-04-01 00:57:56.000000', 'consum', 0.0232, 'lps'),
	(477623, 125, '2015-04-01 00:57:57.000000', 'consum', 0.0230, 'lps'),
	(477624, 125, '2015-04-01 00:57:58.000000', 'consum', 0.0221, 'lps'),
	(477625, 125, '2015-04-01 00:57:59.000000', 'consum', 0.0231, 'lps'),
	(477626, 125, '2015-04-01 00:58:00.000000', 'consum', 0.0233, 'lps'),
	(477627, 125, '2015-04-01 00:58:01.000000', 'consum', 0.0215, 'lps'),
	(477628, 125, '2015-04-01 00:58:02.000000', 'consum', 0.0216, 'lps'),
	(477629, 125, '2015-04-01 00:58:03.000000', 'consum', 0.0226, 'lps'),
	(477630, 125, '2015-04-01 00:58:04.000000', 'consum', 0.0223, 'lps'),
	(477631, 125, '2015-04-01 00:58:05.000000', 'consum', 0.0227, 'lps'),
	(477632, 125, '2015-04-01 00:58:06.000000', 'consum', 0.0210, 'lps'),
	(477633, 125, '2015-04-01 00:58:07.000000', 'consum', 0.0230, 'lps'),
	(477634, 125, '2015-04-01 00:58:08.000000', 'consum', 0.0214, 'lps'),
	(477635, 125, '2015-04-01 00:58:09.000000', 'consum', 0.0220, 'lps'),
	(477636, 125, '2015-04-01 00:58:10.000000', 'consum', 0.0223, 'lps'),
	(477637, 125, '2015-04-01 00:58:11.000000', 'consum', 0.0222, 'lps'),
	(477638, 125, '2015-04-01 00:58:12.000000', 'consum', 0.0232, 'lps'),
	(477639, 125, '2015-04-01 00:58:13.000000', 'consum', 0.0210, 'lps'),
	(477640, 125, '2015-04-01 00:58:14.000000', 'consum', 0.0219, 'lps'),
	(477641, 125, '2015-04-01 00:58:15.000000', 'consum', 0.0231, 'lps'),
	(477642, 125, '2015-04-01 00:58:16.000000', 'consum', 0.0216, 'lps'),
	(477643, 125, '2015-04-01 00:58:17.000000', 'consum', 0.0224, 'lps'),
	(477644, 125, '2015-04-01 00:58:18.000000', 'consum', 0.0215, 'lps'),
	(477645, 125, '2015-04-01 00:58:19.000000', 'consum', 0.0217, 'lps'),
	(477646, 125, '2015-04-01 00:58:20.000000', 'consum', 0.0232, 'lps'),
	(477647, 125, '2015-04-01 00:58:21.000000', 'consum', 0.0227, 'lps'),
	(477648, 125, '2015-04-01 00:58:22.000000', 'consum', 0.0229, 'lps'),
	(477649, 125, '2015-04-01 00:58:23.000000', 'consum', 0.0230, 'lps'),
	(477650, 125, '2015-04-01 00:58:24.000000', 'consum', 0.0229, 'lps'),
	(477651, 125, '2015-04-01 00:58:25.000000', 'consum', 0.0223, 'lps'),
	(477652, 125, '2015-04-01 00:58:26.000000', 'consum', 0.0217, 'lps'),
	(477653, 125, '2015-04-01 00:58:27.000000', 'consum', 0.0232, 'lps'),
	(477654, 125, '2015-04-01 00:58:28.000000', 'consum', 0.0226, 'lps'),
	(477655, 125, '2015-04-01 00:58:29.000000', 'consum', 0.0224, 'lps'),
	(477656, 125, '2015-04-01 00:58:30.000000', 'consum', 0.0232, 'lps'),
	(477657, 125, '2015-04-01 00:58:31.000000', 'consum', 0.0232, 'lps'),
	(477658, 125, '2015-04-01 00:58:32.000000', 'consum', 0.0232, 'lps'),
	(477659, 125, '2015-04-01 00:58:33.000000', 'consum', 0.0230, 'lps'),
	(477660, 125, '2015-04-01 00:58:34.000000', 'consum', 0.0219, 'lps'),
	(477661, 125, '2015-04-01 00:58:35.000000', 'consum', 0.0221, 'lps'),
	(477662, 125, '2015-04-01 00:58:36.000000', 'consum', 0.0216, 'lps'),
	(477663, 125, '2015-04-01 00:58:37.000000', 'consum', 0.0229, 'lps'),
	(477664, 125, '2015-04-01 00:58:38.000000', 'consum', 0.0214, 'lps'),
	(477665, 125, '2015-04-01 00:58:39.000000', 'consum', 0.0225, 'lps'),
	(477666, 125, '2015-04-01 00:58:40.000000', 'consum', 0.0224, 'lps'),
	(477667, 125, '2015-04-01 00:58:41.000000', 'consum', 0.0210, 'lps'),
	(477668, 125, '2015-04-01 00:58:42.000000', 'consum', 0.0217, 'lps'),
	(477669, 125, '2015-04-01 00:58:43.000000', 'consum', 0.0222, 'lps'),
	(477670, 125, '2015-04-01 00:58:44.000000', 'consum', 0.0225, 'lps'),
	(477671, 125, '2015-04-01 00:58:45.000000', 'consum', 0.0227, 'lps'),
	(477672, 125, '2015-04-01 00:58:46.000000', 'consum', 0.0227, 'lps'),
	(477673, 125, '2015-04-01 00:58:47.000000', 'consum', 0.0220, 'lps'),
	(477674, 125, '2015-04-01 00:58:48.000000', 'consum', 0.0233, 'lps'),
	(477675, 125, '2015-04-01 00:58:49.000000', 'consum', 0.0225, 'lps'),
	(477676, 125, '2015-04-01 00:58:50.000000', 'consum', 0.0217, 'lps'),
	(477677, 125, '2015-04-01 00:58:51.000000', 'consum', 0.0222, 'lps'),
	(477678, 125, '2015-04-01 00:58:52.000000', 'consum', 0.0226, 'lps'),
	(477679, 125, '2015-04-01 00:58:53.000000', 'consum', 0.0231, 'lps'),
	(477680, 125, '2015-04-01 00:58:54.000000', 'consum', 0.0219, 'lps'),
	(477681, 125, '2015-04-01 00:58:55.000000', 'consum', 0.0217, 'lps'),
	(477682, 125, '2015-04-01 00:58:56.000000', 'consum', 0.0218, 'lps'),
	(477683, 125, '2015-04-01 00:58:57.000000', 'consum', 0.0228, 'lps'),
	(477684, 125, '2015-04-01 00:58:58.000000', 'consum', 0.0229, 'lps'),
	(477685, 125, '2015-04-01 00:58:59.000000', 'consum', 0.0230, 'lps'),
	(477686, 125, '2015-04-01 00:59:00.000000', 'consum', 0.0228, 'lps'),
	(477687, 125, '2015-04-01 00:59:01.000000', 'consum', 0.0214, 'lps'),
	(477688, 125, '2015-04-01 00:59:02.000000', 'consum', 0.0228, 'lps'),
	(477689, 125, '2015-04-01 00:59:03.000000', 'consum', 0.0217, 'lps'),
	(477690, 125, '2015-04-01 00:59:04.000000', 'consum', 0.0213, 'lps'),
	(477691, 125, '2015-04-01 00:59:05.000000', 'consum', 0.0229, 'lps'),
	(477692, 125, '2015-04-01 00:59:06.000000', 'consum', 0.0224, 'lps'),
	(477693, 125, '2015-04-01 00:59:07.000000', 'consum', 0.0224, 'lps'),
	(477694, 125, '2015-04-01 00:59:08.000000', 'consum', 0.0214, 'lps'),
	(477695, 125, '2015-04-01 00:59:09.000000', 'consum', 0.0214, 'lps'),
	(477696, 125, '2015-04-01 00:59:10.000000', 'consum', 0.0218, 'lps'),
	(477697, 125, '2015-04-01 00:59:11.000000', 'consum', 0.0215, 'lps'),
	(477698, 125, '2015-04-01 00:59:12.000000', 'consum', 0.0213, 'lps'),
	(477699, 125, '2015-04-01 00:59:13.000000', 'consum', 0.0210, 'lps'),
	(477700, 125, '2015-04-01 00:59:14.000000', 'consum', 0.0223, 'lps'),
	(477701, 125, '2015-04-01 00:59:15.000000', 'consum', 0.0229, 'lps'),
	(477702, 125, '2015-04-01 00:59:16.000000', 'consum', 0.0220, 'lps'),
	(477703, 125, '2015-04-01 00:59:17.000000', 'consum', 0.0227, 'lps'),
	(477704, 125, '2015-04-01 00:59:18.000000', 'consum', 0.0218, 'lps'),
	(477705, 125, '2015-04-01 00:59:19.000000', 'consum', 0.0225, 'lps'),
	(477706, 125, '2015-04-01 00:59:20.000000', 'consum', 0.0212, 'lps'),
	(477707, 125, '2015-04-01 00:59:21.000000', 'consum', 0.0222, 'lps'),
	(477708, 125, '2015-04-01 00:59:22.000000', 'consum', 0.0219, 'lps'),
	(477709, 125, '2015-04-01 00:59:23.000000', 'consum', 0.0219, 'lps'),
	(477710, 125, '2015-04-01 00:59:24.000000', 'consum', 0.0228, 'lps'),
	(477711, 125, '2015-04-01 00:59:25.000000', 'consum', 0.0225, 'lps'),
	(477712, 125, '2015-04-01 00:59:26.000000', 'consum', 0.0232, 'lps'),
	(477713, 125, '2015-04-01 00:59:27.000000', 'consum', 0.0227, 'lps'),
	(477714, 125, '2015-04-01 00:59:28.000000', 'consum', 0.0229, 'lps'),
	(477715, 125, '2015-04-01 00:59:29.000000', 'consum', 0.0232, 'lps'),
	(477716, 125, '2015-04-01 00:59:30.000000', 'consum', 0.0216, 'lps'),
	(477717, 125, '2015-04-01 00:59:31.000000', 'consum', 0.0221, 'lps'),
	(477718, 125, '2015-04-01 00:59:32.000000', 'consum', 0.0222, 'lps'),
	(477719, 125, '2015-04-01 00:59:33.000000', 'consum', 0.0216, 'lps'),
	(477720, 125, '2015-04-01 00:59:34.000000', 'consum', 0.0228, 'lps'),
	(477721, 125, '2015-04-01 00:59:35.000000', 'consum', 0.0233, 'lps'),
	(477722, 125, '2015-04-01 00:59:36.000000', 'consum', 0.0224, 'lps'),
	(477723, 125, '2015-04-01 00:59:37.000000', 'consum', 0.0210, 'lps'),
	(477724, 125, '2015-04-01 00:59:38.000000', 'consum', 0.0218, 'lps'),
	(477725, 125, '2015-04-01 00:59:39.000000', 'consum', 0.0225, 'lps'),
	(477726, 125, '2015-04-01 00:59:40.000000', 'consum', 0.0215, 'lps'),
	(477727, 125, '2015-04-01 00:59:41.000000', 'consum', 0.0215, 'lps'),
	(477728, 125, '2015-04-01 00:59:42.000000', 'consum', 0.0218, 'lps'),
	(477729, 125, '2015-04-01 00:59:43.000000', 'consum', 0.0213, 'lps'),
	(477730, 125, '2015-04-01 00:59:44.000000', 'consum', 0.0226, 'lps'),
	(477731, 125, '2015-04-01 00:59:45.000000', 'consum', 0.0210, 'lps'),
	(477732, 125, '2015-04-01 00:59:46.000000', 'consum', 0.0233, 'lps'),
	(477733, 125, '2015-04-01 00:59:47.000000', 'consum', 0.0232, 'lps'),
	(477734, 125, '2015-04-01 00:59:48.000000', 'consum', 0.0226, 'lps'),
	(477735, 125, '2015-04-01 00:59:49.000000', 'consum', 0.0225, 'lps'),
	(477736, 125, '2015-04-01 00:59:50.000000', 'consum', 0.0213, 'lps'),
	(477737, 125, '2015-04-01 00:59:51.000000', 'consum', 0.0229, 'lps'),
	(477738, 125, '2015-04-01 00:59:52.000000', 'consum', 0.0224, 'lps'),
	(477739, 125, '2015-04-01 00:59:53.000000', 'consum', 0.0223, 'lps'),
	(477740, 125, '2015-04-01 00:59:54.000000', 'consum', 0.0232, 'lps'),
	(477741, 125, '2015-04-01 00:59:55.000000', 'consum', 0.0211, 'lps'),
	(477742, 125, '2015-04-01 00:59:56.000000', 'consum', 0.0221, 'lps'),
	(477743, 125, '2015-04-01 00:59:57.000000', 'consum', 0.0217, 'lps'),
	(477744, 125, '2015-04-01 00:59:58.000000', 'consum', 0.0210, 'lps'),
	(477745, 125, '2015-04-01 00:59:59.000000', 'consum', 0.0213, 'lps'),
	(477746, 125, '2015-04-01 01:00:00.000000', 'consum', 0.0226, 'lps'),
	(477747, 125, '2015-04-01 01:00:01.000000', 'consum', 0.0211, 'lps'),
	(477748, 125, '2015-04-01 01:00:02.000000', 'consum', 0.0213, 'lps'),
	(477749, 125, '2015-04-01 01:00:03.000000', 'consum', 0.0224, 'lps'),
	(477750, 125, '2015-04-01 01:00:04.000000', 'consum', 0.0221, 'lps'),
	(477751, 125, '2015-04-01 01:00:05.000000', 'consum', 0.0227, 'lps'),
	(477752, 125, '2015-04-01 01:00:06.000000', 'consum', 0.0214, 'lps'),
	(477753, 125, '2015-04-01 01:00:07.000000', 'consum', 0.0227, 'lps'),
	(477754, 125, '2015-04-01 01:00:08.000000', 'consum', 0.0210, 'lps'),
	(477755, 125, '2015-04-01 01:00:09.000000', 'consum', 0.0210, 'lps'),
	(477756, 125, '2015-04-01 01:00:10.000000', 'consum', 0.0232, 'lps'),
	(477757, 125, '2015-04-01 01:00:11.000000', 'consum', 0.0226, 'lps'),
	(477758, 125, '2015-04-01 01:00:12.000000', 'consum', 0.0226, 'lps'),
	(477759, 125, '2015-04-01 01:00:13.000000', 'consum', 0.0216, 'lps'),
	(477760, 125, '2015-04-01 01:00:14.000000', 'consum', 0.0219, 'lps'),
	(477761, 125, '2015-04-01 01:00:15.000000', 'consum', 0.0213, 'lps'),
	(477762, 125, '2015-04-01 01:00:16.000000', 'consum', 0.0222, 'lps'),
	(477763, 125, '2015-04-01 01:00:17.000000', 'consum', 0.0215, 'lps'),
	(477764, 125, '2015-04-01 01:00:18.000000', 'consum', 0.0221, 'lps'),
	(477765, 125, '2015-04-01 01:00:19.000000', 'consum', 0.0229, 'lps'),
	(477766, 125, '2015-04-01 01:00:20.000000', 'consum', 0.0224, 'lps'),
	(477767, 125, '2015-04-01 01:00:21.000000', 'consum', 0.0223, 'lps'),
	(477768, 125, '2015-04-01 01:00:22.000000', 'consum', 0.0231, 'lps'),
	(477769, 125, '2015-04-01 01:00:23.000000', 'consum', 0.0232, 'lps'),
	(477770, 125, '2015-04-01 01:00:24.000000', 'consum', 0.0210, 'lps'),
	(477771, 125, '2015-04-01 01:00:25.000000', 'consum', 0.0216, 'lps'),
	(477772, 125, '2015-04-01 01:00:26.000000', 'consum', 0.0216, 'lps'),
	(477773, 125, '2015-04-01 01:00:27.000000', 'consum', 0.0223, 'lps'),
	(477774, 125, '2015-04-01 01:00:28.000000', 'consum', 0.0231, 'lps'),
	(477775, 125, '2015-04-01 01:00:29.000000', 'consum', 0.0231, 'lps'),
	(477776, 125, '2015-04-01 01:00:30.000000', 'consum', 0.0227, 'lps'),
	(477777, 125, '2015-04-01 01:00:31.000000', 'consum', 0.0210, 'lps'),
	(477778, 125, '2015-04-01 01:00:32.000000', 'consum', 0.0231, 'lps'),
	(477779, 125, '2015-04-01 01:00:33.000000', 'consum', 0.0218, 'lps'),
	(477780, 125, '2015-04-01 01:00:34.000000', 'consum', 0.0214, 'lps'),
	(477781, 125, '2015-04-01 01:00:35.000000', 'consum', 0.0228, 'lps'),
	(477782, 125, '2015-04-01 01:00:36.000000', 'consum', 0.0220, 'lps'),
	(477783, 125, '2015-04-01 01:00:37.000000', 'consum', 0.0227, 'lps'),
	(477784, 125, '2015-04-01 01:00:38.000000', 'consum', 0.0219, 'lps'),
	(477785, 125, '2015-04-01 01:00:39.000000', 'consum', 0.0229, 'lps'),
	(477786, 125, '2015-04-01 01:00:40.000000', 'consum', 0.0230, 'lps'),
	(477787, 125, '2015-04-01 01:00:41.000000', 'consum', 0.0227, 'lps'),
	(477788, 125, '2015-04-01 01:00:42.000000', 'consum', 0.0215, 'lps'),
	(477789, 125, '2015-04-01 01:00:43.000000', 'consum', 0.0232, 'lps'),
	(477790, 125, '2015-04-01 01:00:44.000000', 'consum', 0.0233, 'lps'),
	(477791, 125, '2015-04-01 01:00:45.000000', 'consum', 0.0211, 'lps'),
	(477792, 125, '2015-04-01 01:00:46.000000', 'consum', 0.0220, 'lps'),
	(477793, 125, '2015-04-01 01:00:47.000000', 'consum', 0.0232, 'lps'),
	(477794, 125, '2015-04-01 01:00:48.000000', 'consum', 0.0217, 'lps'),
	(477795, 125, '2015-04-01 01:00:49.000000', 'consum', 0.0229, 'lps'),
	(477796, 125, '2015-04-01 01:00:50.000000', 'consum', 0.0211, 'lps'),
	(477797, 125, '2015-04-01 01:00:51.000000', 'consum', 0.0232, 'lps'),
	(477798, 125, '2015-04-01 01:00:52.000000', 'consum', 0.0223, 'lps'),
	(477799, 125, '2015-04-01 01:00:53.000000', 'consum', 0.0233, 'lps'),
	(477800, 125, '2015-04-01 01:00:54.000000', 'consum', 0.0213, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(477801, 125, '2015-04-01 01:00:55.000000', 'consum', 0.0231, 'lps'),
	(477802, 125, '2015-04-01 01:00:56.000000', 'consum', 0.0231, 'lps'),
	(477803, 125, '2015-04-01 01:00:57.000000', 'consum', 0.0231, 'lps'),
	(477804, 125, '2015-04-01 01:00:58.000000', 'consum', 0.0229, 'lps'),
	(477805, 125, '2015-04-01 01:00:59.000000', 'consum', 0.0216, 'lps'),
	(477806, 125, '2015-04-01 01:01:00.000000', 'consum', 0.0233, 'lps'),
	(477807, 125, '2015-04-01 01:01:01.000000', 'consum', 0.0211, 'lps'),
	(477808, 125, '2015-04-01 01:01:02.000000', 'consum', 0.0218, 'lps'),
	(477809, 125, '2015-04-01 01:01:03.000000', 'consum', 0.0226, 'lps'),
	(477810, 125, '2015-04-01 01:01:04.000000', 'consum', 0.0217, 'lps'),
	(477811, 125, '2015-04-01 01:01:05.000000', 'consum', 0.0221, 'lps'),
	(477812, 125, '2015-04-01 01:01:06.000000', 'consum', 0.0223, 'lps'),
	(477813, 125, '2015-04-01 01:01:07.000000', 'consum', 0.0216, 'lps'),
	(477814, 125, '2015-04-01 01:01:08.000000', 'consum', 0.0225, 'lps'),
	(477815, 125, '2015-04-01 01:01:09.000000', 'consum', 0.0219, 'lps'),
	(477816, 125, '2015-04-01 01:01:10.000000', 'consum', 0.0212, 'lps'),
	(477817, 125, '2015-04-01 01:01:11.000000', 'consum', 0.0217, 'lps'),
	(477818, 125, '2015-04-01 01:01:12.000000', 'consum', 0.0217, 'lps'),
	(477819, 125, '2015-04-01 01:01:13.000000', 'consum', 0.0224, 'lps'),
	(477820, 125, '2015-04-01 01:01:14.000000', 'consum', 0.0213, 'lps'),
	(477821, 125, '2015-04-01 01:01:15.000000', 'consum', 0.0230, 'lps'),
	(477822, 125, '2015-04-01 01:01:16.000000', 'consum', 0.0228, 'lps'),
	(477823, 125, '2015-04-01 01:01:17.000000', 'consum', 0.0218, 'lps'),
	(477824, 125, '2015-04-01 01:01:18.000000', 'consum', 0.0219, 'lps'),
	(477825, 125, '2015-04-01 01:01:19.000000', 'consum', 0.0210, 'lps'),
	(477826, 125, '2015-04-01 01:01:20.000000', 'consum', 0.0230, 'lps'),
	(477827, 125, '2015-04-01 01:01:21.000000', 'consum', 0.0214, 'lps'),
	(477828, 125, '2015-04-01 01:01:22.000000', 'consum', 0.0219, 'lps'),
	(477829, 125, '2015-04-01 01:01:23.000000', 'consum', 0.0218, 'lps'),
	(477830, 125, '2015-04-01 01:01:24.000000', 'consum', 0.0226, 'lps'),
	(477831, 125, '2015-04-01 01:01:25.000000', 'consum', 0.0218, 'lps'),
	(477832, 125, '2015-04-01 01:01:26.000000', 'consum', 0.0227, 'lps'),
	(477833, 125, '2015-04-01 01:01:27.000000', 'consum', 0.0222, 'lps'),
	(477834, 125, '2015-04-01 01:01:28.000000', 'consum', 0.0220, 'lps'),
	(477835, 125, '2015-04-01 01:01:29.000000', 'consum', 0.0226, 'lps'),
	(477836, 125, '2015-04-01 01:01:30.000000', 'consum', 0.0213, 'lps'),
	(477837, 125, '2015-04-01 01:01:31.000000', 'consum', 0.0225, 'lps'),
	(477838, 125, '2015-04-01 01:01:32.000000', 'consum', 0.0228, 'lps'),
	(477839, 125, '2015-04-01 01:01:33.000000', 'consum', 0.0232, 'lps'),
	(477840, 125, '2015-04-01 01:01:34.000000', 'consum', 0.0217, 'lps'),
	(477841, 125, '2015-04-01 01:01:35.000000', 'consum', 0.0229, 'lps'),
	(477842, 125, '2015-04-01 01:01:36.000000', 'consum', 0.0212, 'lps'),
	(477843, 125, '2015-04-01 01:01:37.000000', 'consum', 0.0213, 'lps'),
	(477844, 125, '2015-04-01 01:01:38.000000', 'consum', 0.0220, 'lps'),
	(477845, 125, '2015-04-01 01:01:39.000000', 'consum', 0.0224, 'lps'),
	(477846, 125, '2015-04-01 01:01:40.000000', 'consum', 0.0230, 'lps'),
	(477847, 125, '2015-04-01 01:01:41.000000', 'consum', 0.0219, 'lps'),
	(477848, 125, '2015-04-01 01:01:42.000000', 'consum', 0.0218, 'lps'),
	(477849, 125, '2015-04-01 01:01:43.000000', 'consum', 0.0226, 'lps'),
	(477850, 125, '2015-04-01 01:01:44.000000', 'consum', 0.0217, 'lps'),
	(477851, 125, '2015-04-01 01:01:45.000000', 'consum', 0.0221, 'lps'),
	(477852, 125, '2015-04-01 01:01:46.000000', 'consum', 0.0223, 'lps'),
	(477853, 125, '2015-04-01 01:01:47.000000', 'consum', 0.0216, 'lps'),
	(477854, 125, '2015-04-01 01:01:48.000000', 'consum', 0.0224, 'lps'),
	(477855, 125, '2015-04-01 01:01:49.000000', 'consum', 0.0218, 'lps'),
	(477856, 125, '2015-04-01 01:01:50.000000', 'consum', 0.0229, 'lps'),
	(477857, 125, '2015-04-01 01:01:51.000000', 'consum', 0.0213, 'lps'),
	(477858, 125, '2015-04-01 01:01:52.000000', 'consum', 0.0216, 'lps'),
	(477859, 125, '2015-04-01 01:01:53.000000', 'consum', 0.0229, 'lps'),
	(477860, 125, '2015-04-01 01:01:54.000000', 'consum', 0.0219, 'lps'),
	(477861, 125, '2015-04-01 01:01:55.000000', 'consum', 0.0221, 'lps'),
	(477862, 125, '2015-04-01 01:01:56.000000', 'consum', 0.0214, 'lps'),
	(477863, 125, '2015-04-01 01:01:57.000000', 'consum', 0.0221, 'lps'),
	(477864, 125, '2015-04-01 01:01:58.000000', 'consum', 0.0230, 'lps'),
	(477865, 125, '2015-04-01 01:01:59.000000', 'consum', 0.0229, 'lps'),
	(477866, 125, '2015-04-01 01:02:00.000000', 'consum', 0.0221, 'lps'),
	(477867, 125, '2015-04-01 01:02:01.000000', 'consum', 0.0210, 'lps'),
	(477868, 125, '2015-04-01 01:02:02.000000', 'consum', 0.0227, 'lps'),
	(477869, 125, '2015-04-01 01:02:03.000000', 'consum', 0.0221, 'lps'),
	(477870, 125, '2015-04-01 01:02:04.000000', 'consum', 0.0215, 'lps'),
	(477871, 125, '2015-04-01 01:02:05.000000', 'consum', 0.0228, 'lps'),
	(477872, 125, '2015-04-01 01:02:06.000000', 'consum', 0.0215, 'lps'),
	(477873, 125, '2015-04-01 01:02:07.000000', 'consum', 0.0226, 'lps'),
	(477874, 125, '2015-04-01 01:02:08.000000', 'consum', 0.0227, 'lps'),
	(477875, 125, '2015-04-01 01:02:09.000000', 'consum', 0.0226, 'lps'),
	(477876, 125, '2015-04-01 01:02:10.000000', 'consum', 0.0216, 'lps'),
	(477877, 125, '2015-04-01 01:02:11.000000', 'consum', 0.0217, 'lps'),
	(477878, 125, '2015-04-01 01:02:12.000000', 'consum', 0.0227, 'lps'),
	(477879, 125, '2015-04-01 01:02:13.000000', 'consum', 0.0224, 'lps'),
	(477880, 125, '2015-04-01 01:02:14.000000', 'consum', 0.0232, 'lps'),
	(477881, 125, '2015-04-01 01:02:15.000000', 'consum', 0.0230, 'lps'),
	(477882, 125, '2015-04-01 01:02:16.000000', 'consum', 0.0219, 'lps'),
	(477883, 125, '2015-04-01 01:02:17.000000', 'consum', 0.0222, 'lps'),
	(477884, 125, '2015-04-01 01:02:18.000000', 'consum', 0.0217, 'lps'),
	(477885, 125, '2015-04-01 01:02:19.000000', 'consum', 0.0212, 'lps'),
	(477886, 125, '2015-04-01 01:02:20.000000', 'consum', 0.0222, 'lps'),
	(477887, 125, '2015-04-01 01:02:21.000000', 'consum', 0.0215, 'lps'),
	(477888, 125, '2015-04-01 01:02:22.000000', 'consum', 0.0224, 'lps'),
	(477889, 125, '2015-04-01 01:02:23.000000', 'consum', 0.0217, 'lps'),
	(477890, 125, '2015-04-01 01:02:24.000000', 'consum', 0.0227, 'lps'),
	(477891, 125, '2015-04-01 01:02:25.000000', 'consum', 0.0229, 'lps'),
	(477892, 125, '2015-04-01 01:02:26.000000', 'consum', 0.0228, 'lps'),
	(477893, 125, '2015-04-01 01:02:27.000000', 'consum', 0.0220, 'lps'),
	(477894, 125, '2015-04-01 01:02:28.000000', 'consum', 0.0229, 'lps'),
	(477895, 125, '2015-04-01 01:02:29.000000', 'consum', 0.0228, 'lps'),
	(477896, 125, '2015-04-01 01:02:30.000000', 'consum', 0.0220, 'lps'),
	(477897, 125, '2015-04-01 01:02:31.000000', 'consum', 0.0230, 'lps'),
	(477898, 125, '2015-04-01 01:02:32.000000', 'consum', 0.0231, 'lps'),
	(477899, 125, '2015-04-01 01:02:33.000000', 'consum', 0.0232, 'lps'),
	(477900, 125, '2015-04-01 01:02:34.000000', 'consum', 0.0232, 'lps'),
	(477901, 125, '2015-04-01 01:02:35.000000', 'consum', 0.0233, 'lps'),
	(477902, 125, '2015-04-01 01:02:36.000000', 'consum', 0.0212, 'lps'),
	(477903, 125, '2015-04-01 01:02:37.000000', 'consum', 0.0222, 'lps'),
	(477904, 125, '2015-04-01 01:02:38.000000', 'consum', 0.0216, 'lps'),
	(477905, 125, '2015-04-01 01:02:39.000000', 'consum', 0.0229, 'lps'),
	(477906, 125, '2015-04-01 01:02:40.000000', 'consum', 0.0217, 'lps'),
	(477907, 125, '2015-04-01 01:02:41.000000', 'consum', 0.0214, 'lps'),
	(477908, 125, '2015-04-01 01:02:42.000000', 'consum', 0.0230, 'lps'),
	(477909, 125, '2015-04-01 01:02:43.000000', 'consum', 0.0228, 'lps'),
	(477910, 125, '2015-04-01 01:02:44.000000', 'consum', 0.0218, 'lps'),
	(477911, 125, '2015-04-01 01:02:45.000000', 'consum', 0.0221, 'lps'),
	(477912, 125, '2015-04-01 01:02:46.000000', 'consum', 0.0216, 'lps'),
	(477913, 125, '2015-04-01 01:02:47.000000', 'consum', 0.0230, 'lps'),
	(477914, 125, '2015-04-01 01:02:48.000000', 'consum', 0.0223, 'lps'),
	(477915, 125, '2015-04-01 01:02:49.000000', 'consum', 0.0213, 'lps'),
	(477916, 125, '2015-04-01 01:02:50.000000', 'consum', 0.0210, 'lps'),
	(477917, 125, '2015-04-01 01:02:51.000000', 'consum', 0.0226, 'lps'),
	(477918, 125, '2015-04-01 01:02:52.000000', 'consum', 0.0218, 'lps'),
	(477919, 125, '2015-04-01 01:02:53.000000', 'consum', 0.0226, 'lps'),
	(477920, 125, '2015-04-01 01:02:54.000000', 'consum', 0.0220, 'lps'),
	(477921, 125, '2015-04-01 01:02:55.000000', 'consum', 0.0213, 'lps'),
	(477922, 125, '2015-04-01 01:02:56.000000', 'consum', 0.0217, 'lps'),
	(477923, 125, '2015-04-01 01:02:57.000000', 'consum', 0.0215, 'lps'),
	(477924, 125, '2015-04-01 01:02:58.000000', 'consum', 0.0212, 'lps'),
	(477925, 125, '2015-04-01 01:02:59.000000', 'consum', 0.0230, 'lps'),
	(477926, 125, '2015-04-01 01:03:00.000000', 'consum', 0.0232, 'lps'),
	(477927, 125, '2015-04-01 01:03:01.000000', 'consum', 0.0212, 'lps'),
	(477928, 125, '2015-04-01 01:03:02.000000', 'consum', 0.0226, 'lps'),
	(477929, 125, '2015-04-01 01:03:03.000000', 'consum', 0.0215, 'lps'),
	(477930, 125, '2015-04-01 01:03:04.000000', 'consum', 0.0212, 'lps'),
	(477931, 125, '2015-04-01 01:03:05.000000', 'consum', 0.0230, 'lps'),
	(477932, 125, '2015-04-01 01:03:06.000000', 'consum', 0.0229, 'lps'),
	(477933, 125, '2015-04-01 01:03:07.000000', 'consum', 0.0225, 'lps'),
	(477934, 125, '2015-04-01 01:03:08.000000', 'consum', 0.0228, 'lps'),
	(477935, 125, '2015-04-01 01:03:09.000000', 'consum', 0.0233, 'lps'),
	(477936, 125, '2015-04-01 01:03:10.000000', 'consum', 0.0222, 'lps'),
	(477937, 125, '2015-04-01 01:03:11.000000', 'consum', 0.0226, 'lps'),
	(477938, 125, '2015-04-01 01:03:12.000000', 'consum', 0.0232, 'lps'),
	(477939, 125, '2015-04-01 01:03:13.000000', 'consum', 0.0225, 'lps'),
	(477940, 125, '2015-04-01 01:03:14.000000', 'consum', 0.0217, 'lps'),
	(477941, 125, '2015-04-01 01:03:15.000000', 'consum', 0.0225, 'lps'),
	(477942, 125, '2015-04-01 01:03:16.000000', 'consum', 0.0215, 'lps'),
	(477943, 125, '2015-04-01 01:03:17.000000', 'consum', 0.0215, 'lps'),
	(477944, 125, '2015-04-01 01:03:18.000000', 'consum', 0.0219, 'lps'),
	(477945, 125, '2015-04-01 01:03:19.000000', 'consum', 0.0219, 'lps'),
	(477946, 125, '2015-04-01 01:03:20.000000', 'consum', 0.0228, 'lps'),
	(477947, 125, '2015-04-01 01:03:21.000000', 'consum', 0.0225, 'lps'),
	(477948, 125, '2015-04-01 01:03:22.000000', 'consum', 0.0233, 'lps'),
	(477949, 125, '2015-04-01 01:03:23.000000', 'consum', 0.0233, 'lps'),
	(477950, 125, '2015-04-01 01:03:24.000000', 'consum', 0.0233, 'lps'),
	(477951, 125, '2015-04-01 01:03:25.000000', 'consum', 0.0232, 'lps'),
	(477952, 125, '2015-04-01 01:03:26.000000', 'consum', 0.0229, 'lps'),
	(477953, 125, '2015-04-01 01:03:27.000000', 'consum', 0.0213, 'lps'),
	(477954, 125, '2015-04-01 01:03:28.000000', 'consum', 0.0216, 'lps'),
	(477955, 125, '2015-04-01 01:03:29.000000', 'consum', 0.0233, 'lps'),
	(477956, 125, '2015-04-01 01:03:30.000000', 'consum', 0.0210, 'lps'),
	(477957, 125, '2015-04-01 01:03:31.000000', 'consum', 0.0213, 'lps'),
	(477958, 125, '2015-04-01 01:03:32.000000', 'consum', 0.0227, 'lps'),
	(477959, 125, '2015-04-01 01:03:33.000000', 'consum', 0.0215, 'lps'),
	(477960, 125, '2015-04-01 01:03:34.000000', 'consum', 0.0232, 'lps'),
	(477961, 125, '2015-04-01 01:03:35.000000', 'consum', 0.0231, 'lps'),
	(477962, 125, '2015-04-01 01:03:36.000000', 'consum', 0.0229, 'lps'),
	(477963, 125, '2015-04-01 01:03:37.000000', 'consum', 0.0217, 'lps'),
	(477964, 125, '2015-04-01 01:03:38.000000', 'consum', 0.0211, 'lps'),
	(477965, 125, '2015-04-01 01:03:39.000000', 'consum', 0.0222, 'lps'),
	(477966, 125, '2015-04-01 01:03:40.000000', 'consum', 0.0217, 'lps'),
	(477967, 125, '2015-04-01 01:03:41.000000', 'consum', 0.0232, 'lps'),
	(477968, 125, '2015-04-01 01:03:42.000000', 'consum', 0.0230, 'lps'),
	(477969, 125, '2015-04-01 01:03:43.000000', 'consum', 0.0221, 'lps'),
	(477970, 125, '2015-04-01 01:03:44.000000', 'consum', 0.0227, 'lps'),
	(477971, 125, '2015-04-01 01:03:45.000000', 'consum', 0.0217, 'lps'),
	(477972, 125, '2015-04-01 01:03:46.000000', 'consum', 0.0216, 'lps'),
	(477973, 125, '2015-04-01 01:03:47.000000', 'consum', 0.0221, 'lps'),
	(477974, 125, '2015-04-01 01:03:48.000000', 'consum', 0.0224, 'lps'),
	(477975, 125, '2015-04-01 01:03:49.000000', 'consum', 0.0224, 'lps'),
	(477976, 125, '2015-04-01 01:03:50.000000', 'consum', 0.0216, 'lps'),
	(477977, 125, '2015-04-01 01:03:51.000000', 'consum', 0.0220, 'lps'),
	(477978, 125, '2015-04-01 01:03:52.000000', 'consum', 0.0221, 'lps'),
	(477979, 125, '2015-04-01 01:03:53.000000', 'consum', 0.0210, 'lps'),
	(477980, 125, '2015-04-01 01:03:54.000000', 'consum', 0.0227, 'lps'),
	(477981, 125, '2015-04-01 01:03:55.000000', 'consum', 0.0222, 'lps'),
	(477982, 125, '2015-04-01 01:03:56.000000', 'consum', 0.0221, 'lps'),
	(477983, 125, '2015-04-01 01:03:57.000000', 'consum', 0.0230, 'lps'),
	(477984, 125, '2015-04-01 01:03:58.000000', 'consum', 0.0229, 'lps'),
	(477985, 125, '2015-04-01 01:03:59.000000', 'consum', 0.0221, 'lps'),
	(477986, 125, '2015-04-01 01:04:00.000000', 'consum', 0.0231, 'lps'),
	(477987, 125, '2015-04-01 01:04:01.000000', 'consum', 0.0213, 'lps'),
	(477988, 125, '2015-04-01 01:04:02.000000', 'consum', 0.0232, 'lps'),
	(477989, 125, '2015-04-01 01:04:03.000000', 'consum', 0.0217, 'lps'),
	(477990, 125, '2015-04-01 01:04:04.000000', 'consum', 0.0226, 'lps'),
	(477991, 125, '2015-04-01 01:04:05.000000', 'consum', 0.0223, 'lps'),
	(477992, 125, '2015-04-01 01:04:06.000000', 'consum', 0.0228, 'lps'),
	(477993, 125, '2015-04-01 01:04:07.000000', 'consum', 0.0212, 'lps'),
	(477994, 125, '2015-04-01 01:04:08.000000', 'consum', 0.0217, 'lps'),
	(477995, 125, '2015-04-01 01:04:09.000000', 'consum', 0.0212, 'lps'),
	(477996, 125, '2015-04-01 01:04:10.000000', 'consum', 0.0226, 'lps'),
	(477997, 125, '2015-04-01 01:04:11.000000', 'consum', 0.0211, 'lps'),
	(477998, 125, '2015-04-01 01:04:12.000000', 'consum', 0.0218, 'lps'),
	(477999, 125, '2015-04-01 01:04:13.000000', 'consum', 0.0222, 'lps'),
	(478000, 125, '2015-04-01 01:04:14.000000', 'consum', 0.0222, 'lps'),
	(478001, 125, '2015-04-01 01:04:15.000000', 'consum', 0.0212, 'lps'),
	(478002, 125, '2015-04-01 01:04:16.000000', 'consum', 0.0232, 'lps'),
	(478003, 125, '2015-04-01 01:04:17.000000', 'consum', 0.0217, 'lps'),
	(478004, 125, '2015-04-01 01:04:18.000000', 'consum', 0.0227, 'lps'),
	(478005, 125, '2015-04-01 01:04:19.000000', 'consum', 0.0227, 'lps'),
	(478006, 125, '2015-04-01 01:04:20.000000', 'consum', 0.0222, 'lps'),
	(478007, 125, '2015-04-01 01:04:21.000000', 'consum', 0.0219, 'lps'),
	(478008, 125, '2015-04-01 01:04:22.000000', 'consum', 0.0220, 'lps'),
	(478009, 125, '2015-04-01 01:04:23.000000', 'consum', 0.0231, 'lps'),
	(478010, 125, '2015-04-01 01:04:24.000000', 'consum', 0.0215, 'lps'),
	(478011, 125, '2015-04-01 01:04:25.000000', 'consum', 0.0220, 'lps'),
	(478012, 125, '2015-04-01 01:04:26.000000', 'consum', 0.0222, 'lps'),
	(478013, 125, '2015-04-01 01:04:27.000000', 'consum', 0.0218, 'lps'),
	(478014, 125, '2015-04-01 01:04:28.000000', 'consum', 0.0214, 'lps'),
	(478015, 125, '2015-04-01 01:04:29.000000', 'consum', 0.0230, 'lps'),
	(478016, 125, '2015-04-01 01:04:30.000000', 'consum', 0.0224, 'lps'),
	(478017, 125, '2015-04-01 01:04:31.000000', 'consum', 0.0224, 'lps'),
	(478018, 125, '2015-04-01 01:04:32.000000', 'consum', 0.0214, 'lps'),
	(478019, 125, '2015-04-01 01:04:33.000000', 'consum', 0.0213, 'lps'),
	(478020, 125, '2015-04-01 01:04:34.000000', 'consum', 0.0213, 'lps'),
	(478021, 125, '2015-04-01 01:04:35.000000', 'consum', 0.0215, 'lps'),
	(478022, 125, '2015-04-01 01:04:36.000000', 'consum', 0.0227, 'lps'),
	(478023, 125, '2015-04-01 01:04:37.000000', 'consum', 0.0232, 'lps'),
	(478024, 125, '2015-04-01 01:04:38.000000', 'consum', 0.0223, 'lps'),
	(478025, 125, '2015-04-01 01:04:39.000000', 'consum', 0.0233, 'lps'),
	(478026, 125, '2015-04-01 01:04:40.000000', 'consum', 0.0214, 'lps'),
	(478027, 125, '2015-04-01 01:04:41.000000', 'consum', 0.0211, 'lps'),
	(478028, 125, '2015-04-01 01:04:42.000000', 'consum', 0.0228, 'lps'),
	(478029, 125, '2015-04-01 01:04:43.000000', 'consum', 0.0224, 'lps'),
	(478030, 125, '2015-04-01 01:04:44.000000', 'consum', 0.0225, 'lps'),
	(478031, 125, '2015-04-01 01:04:45.000000', 'consum', 0.0222, 'lps'),
	(478032, 125, '2015-04-01 01:04:46.000000', 'consum', 0.0227, 'lps'),
	(478033, 125, '2015-04-01 01:04:47.000000', 'consum', 0.0233, 'lps'),
	(478034, 125, '2015-04-01 01:04:48.000000', 'consum', 0.0227, 'lps'),
	(478035, 125, '2015-04-01 01:04:49.000000', 'consum', 0.0227, 'lps'),
	(478036, 125, '2015-04-01 01:04:50.000000', 'consum', 0.0220, 'lps'),
	(478037, 125, '2015-04-01 01:04:51.000000', 'consum', 0.0232, 'lps'),
	(478038, 125, '2015-04-01 01:04:52.000000', 'consum', 0.0221, 'lps'),
	(478039, 125, '2015-04-01 01:04:53.000000', 'consum', 0.0225, 'lps'),
	(478040, 125, '2015-04-01 01:04:54.000000', 'consum', 0.0225, 'lps'),
	(478041, 125, '2015-04-01 01:04:55.000000', 'consum', 0.0219, 'lps'),
	(478042, 125, '2015-04-01 01:04:56.000000', 'consum', 0.0211, 'lps'),
	(478043, 125, '2015-04-01 01:04:57.000000', 'consum', 0.0211, 'lps'),
	(478044, 125, '2015-04-01 01:04:58.000000', 'consum', 0.0214, 'lps'),
	(478045, 125, '2015-04-01 01:04:59.000000', 'consum', 0.0229, 'lps'),
	(478046, 125, '2015-04-01 01:05:00.000000', 'consum', 0.0218, 'lps'),
	(478047, 125, '2015-04-01 01:05:01.000000', 'consum', 0.0218, 'lps'),
	(478048, 125, '2015-04-01 01:05:02.000000', 'consum', 0.0228, 'lps'),
	(478049, 125, '2015-04-01 01:05:03.000000', 'consum', 0.0229, 'lps'),
	(478050, 125, '2015-04-01 01:05:04.000000', 'consum', 0.0227, 'lps'),
	(478051, 125, '2015-04-01 01:05:05.000000', 'consum', 0.0214, 'lps'),
	(478052, 125, '2015-04-01 01:05:06.000000', 'consum', 0.0229, 'lps'),
	(478053, 125, '2015-04-01 01:05:07.000000', 'consum', 0.0220, 'lps'),
	(478054, 125, '2015-04-01 01:05:08.000000', 'consum', 0.0229, 'lps'),
	(478055, 125, '2015-04-01 01:05:09.000000', 'consum', 0.0227, 'lps'),
	(478056, 125, '2015-04-01 01:05:10.000000', 'consum', 0.0213, 'lps'),
	(478057, 125, '2015-04-01 01:05:11.000000', 'consum', 0.0224, 'lps'),
	(478058, 125, '2015-04-01 01:05:12.000000', 'consum', 0.0225, 'lps'),
	(478059, 125, '2015-04-01 01:05:13.000000', 'consum', 0.0219, 'lps'),
	(478060, 125, '2015-04-01 01:05:14.000000', 'consum', 0.0233, 'lps'),
	(478061, 125, '2015-04-01 01:05:15.000000', 'consum', 0.0225, 'lps'),
	(478062, 125, '2015-04-01 01:05:16.000000', 'consum', 0.0218, 'lps'),
	(478063, 125, '2015-04-01 01:05:17.000000', 'consum', 0.0230, 'lps'),
	(478064, 125, '2015-04-01 01:05:18.000000', 'consum', 0.0213, 'lps'),
	(478065, 125, '2015-04-01 01:05:19.000000', 'consum', 0.0214, 'lps'),
	(478066, 125, '2015-04-01 01:05:20.000000', 'consum', 0.0221, 'lps'),
	(478067, 125, '2015-04-01 01:05:21.000000', 'consum', 0.0231, 'lps'),
	(478068, 125, '2015-04-01 01:05:22.000000', 'consum', 0.0233, 'lps'),
	(478069, 125, '2015-04-01 01:05:23.000000', 'consum', 0.0217, 'lps'),
	(478070, 125, '2015-04-01 01:05:24.000000', 'consum', 0.0223, 'lps'),
	(478071, 125, '2015-04-01 01:05:25.000000', 'consum', 0.0230, 'lps'),
	(478072, 125, '2015-04-01 01:05:26.000000', 'consum', 0.0225, 'lps'),
	(478073, 125, '2015-04-01 01:05:27.000000', 'consum', 0.0223, 'lps'),
	(478074, 125, '2015-04-01 01:05:28.000000', 'consum', 0.0233, 'lps'),
	(478075, 125, '2015-04-01 01:05:29.000000', 'consum', 0.0214, 'lps'),
	(478076, 125, '2015-04-01 01:05:30.000000', 'consum', 0.0233, 'lps'),
	(478077, 125, '2015-04-01 01:05:31.000000', 'consum', 0.0217, 'lps'),
	(478078, 125, '2015-04-01 01:05:32.000000', 'consum', 0.0226, 'lps'),
	(478079, 125, '2015-04-01 01:05:33.000000', 'consum', 0.0222, 'lps'),
	(478080, 125, '2015-04-01 01:05:34.000000', 'consum', 0.0223, 'lps'),
	(478081, 125, '2015-04-01 01:05:35.000000', 'consum', 0.0216, 'lps'),
	(478082, 125, '2015-04-01 01:05:36.000000', 'consum', 0.0226, 'lps'),
	(478083, 125, '2015-04-01 01:05:37.000000', 'consum', 0.0222, 'lps'),
	(478084, 125, '2015-04-01 01:05:38.000000', 'consum', 0.0225, 'lps'),
	(478085, 125, '2015-04-01 01:05:39.000000', 'consum', 0.0223, 'lps'),
	(478086, 125, '2015-04-01 01:05:40.000000', 'consum', 0.0232, 'lps'),
	(478087, 125, '2015-04-01 01:05:41.000000', 'consum', 0.0232, 'lps'),
	(478088, 125, '2015-04-01 01:05:42.000000', 'consum', 0.0230, 'lps'),
	(478089, 125, '2015-04-01 01:05:43.000000', 'consum', 0.0223, 'lps'),
	(478090, 125, '2015-04-01 01:05:44.000000', 'consum', 0.0216, 'lps'),
	(478091, 125, '2015-04-01 01:05:45.000000', 'consum', 0.0226, 'lps'),
	(478092, 125, '2015-04-01 01:05:46.000000', 'consum', 0.0225, 'lps'),
	(478093, 125, '2015-04-01 01:05:47.000000', 'consum', 0.0214, 'lps'),
	(478094, 125, '2015-04-01 01:05:48.000000', 'consum', 0.0233, 'lps'),
	(478095, 125, '2015-04-01 01:05:49.000000', 'consum', 0.0219, 'lps'),
	(478096, 125, '2015-04-01 01:05:50.000000', 'consum', 0.0232, 'lps'),
	(478097, 125, '2015-04-01 01:05:51.000000', 'consum', 0.0223, 'lps'),
	(478098, 125, '2015-04-01 01:05:52.000000', 'consum', 0.0211, 'lps'),
	(478099, 125, '2015-04-01 01:05:53.000000', 'consum', 0.0221, 'lps'),
	(478100, 125, '2015-04-01 01:05:54.000000', 'consum', 0.0216, 'lps'),
	(478101, 125, '2015-04-01 01:05:55.000000', 'consum', 0.0233, 'lps'),
	(478102, 125, '2015-04-01 01:05:56.000000', 'consum', 0.0211, 'lps'),
	(478103, 125, '2015-04-01 01:05:57.000000', 'consum', 0.0220, 'lps'),
	(478104, 125, '2015-04-01 01:05:58.000000', 'consum', 0.0230, 'lps'),
	(478105, 125, '2015-04-01 01:05:59.000000', 'consum', 0.0211, 'lps'),
	(478106, 125, '2015-04-01 01:06:00.000000', 'consum', 0.0227, 'lps'),
	(478107, 125, '2015-04-01 01:06:01.000000', 'consum', 0.0222, 'lps'),
	(478108, 125, '2015-04-01 01:06:02.000000', 'consum', 0.0219, 'lps'),
	(478109, 125, '2015-04-01 01:06:03.000000', 'consum', 0.0218, 'lps'),
	(478110, 125, '2015-04-01 01:06:04.000000', 'consum', 0.0225, 'lps'),
	(478111, 125, '2015-04-01 01:06:05.000000', 'consum', 0.0214, 'lps'),
	(478112, 125, '2015-04-01 01:06:06.000000', 'consum', 0.0233, 'lps'),
	(478113, 125, '2015-04-01 01:06:07.000000', 'consum', 0.0218, 'lps'),
	(478114, 125, '2015-04-01 01:06:08.000000', 'consum', 0.0231, 'lps'),
	(478115, 125, '2015-04-01 01:06:09.000000', 'consum', 0.0216, 'lps'),
	(478116, 125, '2015-04-01 01:06:10.000000', 'consum', 0.0228, 'lps'),
	(478117, 125, '2015-04-01 01:06:11.000000', 'consum', 0.0212, 'lps'),
	(478118, 125, '2015-04-01 01:06:12.000000', 'consum', 0.0211, 'lps'),
	(478119, 125, '2015-04-01 01:06:13.000000', 'consum', 0.0212, 'lps'),
	(478120, 125, '2015-04-01 01:06:14.000000', 'consum', 0.0215, 'lps'),
	(478121, 125, '2015-04-01 01:06:15.000000', 'consum', 0.0233, 'lps'),
	(478122, 125, '2015-04-01 01:06:16.000000', 'consum', 0.0211, 'lps'),
	(478123, 125, '2015-04-01 01:06:17.000000', 'consum', 0.0221, 'lps'),
	(478124, 125, '2015-04-01 01:06:18.000000', 'consum', 0.0213, 'lps'),
	(478125, 125, '2015-04-01 01:06:19.000000', 'consum', 0.0216, 'lps'),
	(478126, 125, '2015-04-01 01:06:20.000000', 'consum', 0.0231, 'lps'),
	(478127, 125, '2015-04-01 01:06:21.000000', 'consum', 0.0228, 'lps'),
	(478128, 125, '2015-04-01 01:06:22.000000', 'consum', 0.0214, 'lps'),
	(478129, 125, '2015-04-01 01:06:23.000000', 'consum', 0.0222, 'lps'),
	(478130, 125, '2015-04-01 01:06:24.000000', 'consum', 0.0210, 'lps'),
	(478131, 125, '2015-04-01 01:06:25.000000', 'consum', 0.0225, 'lps'),
	(478132, 125, '2015-04-01 01:06:26.000000', 'consum', 0.0215, 'lps'),
	(478133, 125, '2015-04-01 01:06:27.000000', 'consum', 0.0211, 'lps'),
	(478134, 125, '2015-04-01 01:06:28.000000', 'consum', 0.0225, 'lps'),
	(478135, 125, '2015-04-01 01:06:29.000000', 'consum', 0.0210, 'lps'),
	(478136, 125, '2015-04-01 01:06:30.000000', 'consum', 0.0213, 'lps'),
	(478137, 125, '2015-04-01 01:06:31.000000', 'consum', 0.0225, 'lps'),
	(478138, 125, '2015-04-01 01:06:32.000000', 'consum', 0.0228, 'lps'),
	(478139, 125, '2015-04-01 01:06:33.000000', 'consum', 0.0210, 'lps'),
	(478140, 125, '2015-04-01 01:06:34.000000', 'consum', 0.0229, 'lps'),
	(478141, 125, '2015-04-01 01:06:35.000000', 'consum', 0.0231, 'lps'),
	(478142, 125, '2015-04-01 01:06:36.000000', 'consum', 0.0211, 'lps'),
	(478143, 125, '2015-04-01 01:06:37.000000', 'consum', 0.0227, 'lps'),
	(478144, 125, '2015-04-01 01:06:38.000000', 'consum', 0.0217, 'lps'),
	(478145, 125, '2015-04-01 01:06:39.000000', 'consum', 0.0220, 'lps'),
	(478146, 125, '2015-04-01 01:06:40.000000', 'consum', 0.0215, 'lps'),
	(478147, 125, '2015-04-01 01:06:41.000000', 'consum', 0.0230, 'lps'),
	(478148, 125, '2015-04-01 01:06:42.000000', 'consum', 0.0222, 'lps'),
	(478149, 125, '2015-04-01 01:06:43.000000', 'consum', 0.0212, 'lps'),
	(478150, 125, '2015-04-01 01:06:44.000000', 'consum', 0.0230, 'lps'),
	(478151, 125, '2015-04-01 01:06:45.000000', 'consum', 0.0210, 'lps'),
	(478152, 125, '2015-04-01 01:06:46.000000', 'consum', 0.0224, 'lps'),
	(478153, 125, '2015-04-01 01:06:47.000000', 'consum', 0.0232, 'lps'),
	(478154, 125, '2015-04-01 01:06:48.000000', 'consum', 0.0230, 'lps'),
	(478155, 125, '2015-04-01 01:06:49.000000', 'consum', 0.0220, 'lps'),
	(478156, 125, '2015-04-01 01:06:50.000000', 'consum', 0.0224, 'lps'),
	(478157, 125, '2015-04-01 01:06:51.000000', 'consum', 0.0229, 'lps'),
	(478158, 125, '2015-04-01 01:06:52.000000', 'consum', 0.0212, 'lps'),
	(478159, 125, '2015-04-01 01:06:53.000000', 'consum', 0.0214, 'lps'),
	(478160, 125, '2015-04-01 01:06:54.000000', 'consum', 0.0224, 'lps'),
	(478161, 125, '2015-04-01 01:06:55.000000', 'consum', 0.0221, 'lps'),
	(478162, 125, '2015-04-01 01:06:56.000000', 'consum', 0.0222, 'lps'),
	(478163, 125, '2015-04-01 01:06:57.000000', 'consum', 0.0213, 'lps'),
	(478164, 125, '2015-04-01 01:06:58.000000', 'consum', 0.0213, 'lps'),
	(478165, 125, '2015-04-01 01:06:59.000000', 'consum', 0.0217, 'lps'),
	(478166, 125, '2015-04-01 01:07:00.000000', 'consum', 0.0211, 'lps'),
	(478167, 125, '2015-04-01 01:07:01.000000', 'consum', 0.0219, 'lps'),
	(478168, 125, '2015-04-01 01:07:02.000000', 'consum', 0.0231, 'lps'),
	(478169, 125, '2015-04-01 01:07:03.000000', 'consum', 0.0215, 'lps'),
	(478170, 125, '2015-04-01 01:07:04.000000', 'consum', 0.0221, 'lps'),
	(478171, 125, '2015-04-01 01:07:05.000000', 'consum', 0.0226, 'lps'),
	(478172, 125, '2015-04-01 01:07:06.000000', 'consum', 0.0211, 'lps'),
	(478173, 125, '2015-04-01 01:07:07.000000', 'consum', 0.0216, 'lps'),
	(478174, 125, '2015-04-01 01:07:08.000000', 'consum', 0.0214, 'lps'),
	(478175, 125, '2015-04-01 01:07:09.000000', 'consum', 0.0211, 'lps'),
	(478176, 125, '2015-04-01 01:07:10.000000', 'consum', 0.0228, 'lps'),
	(478177, 125, '2015-04-01 01:07:11.000000', 'consum', 0.0227, 'lps'),
	(478178, 125, '2015-04-01 01:07:12.000000', 'consum', 0.0217, 'lps'),
	(478179, 125, '2015-04-01 01:07:13.000000', 'consum', 0.0219, 'lps'),
	(478180, 125, '2015-04-01 01:07:14.000000', 'consum', 0.0233, 'lps'),
	(478181, 125, '2015-04-01 01:07:15.000000', 'consum', 0.0225, 'lps'),
	(478182, 125, '2015-04-01 01:07:16.000000', 'consum', 0.0218, 'lps'),
	(478183, 125, '2015-04-01 01:07:17.000000', 'consum', 0.0229, 'lps'),
	(478184, 125, '2015-04-01 01:07:18.000000', 'consum', 0.0211, 'lps'),
	(478185, 125, '2015-04-01 01:07:19.000000', 'consum', 0.0231, 'lps'),
	(478186, 125, '2015-04-01 01:07:20.000000', 'consum', 0.0215, 'lps'),
	(478187, 125, '2015-04-01 01:07:21.000000', 'consum', 0.0221, 'lps'),
	(478188, 125, '2015-04-01 01:07:22.000000', 'consum', 0.0224, 'lps'),
	(478189, 125, '2015-04-01 01:07:23.000000', 'consum', 0.0227, 'lps'),
	(478190, 125, '2015-04-01 01:07:24.000000', 'consum', 0.0227, 'lps'),
	(478191, 125, '2015-04-01 01:07:25.000000', 'consum', 0.0221, 'lps'),
	(478192, 125, '2015-04-01 01:07:26.000000', 'consum', 0.0213, 'lps'),
	(478193, 125, '2015-04-01 01:07:27.000000', 'consum', 0.0218, 'lps'),
	(478194, 125, '2015-04-01 01:07:28.000000', 'consum', 0.0215, 'lps'),
	(478195, 125, '2015-04-01 01:07:29.000000', 'consum', 0.0215, 'lps'),
	(478196, 125, '2015-04-01 01:07:30.000000', 'consum', 0.0218, 'lps'),
	(478197, 125, '2015-04-01 01:07:31.000000', 'consum', 0.0210, 'lps'),
	(478198, 125, '2015-04-01 01:07:32.000000', 'consum', 0.0213, 'lps'),
	(478199, 125, '2015-04-01 01:07:33.000000', 'consum', 0.0226, 'lps'),
	(478200, 125, '2015-04-01 01:07:34.000000', 'consum', 0.0210, 'lps'),
	(478201, 125, '2015-04-01 01:07:35.000000', 'consum', 0.0232, 'lps'),
	(478202, 125, '2015-04-01 01:07:36.000000', 'consum', 0.0227, 'lps'),
	(478203, 125, '2015-04-01 01:07:37.000000', 'consum', 0.0229, 'lps'),
	(478204, 125, '2015-04-01 01:07:38.000000', 'consum', 0.0230, 'lps'),
	(478205, 125, '2015-04-01 01:07:39.000000', 'consum', 0.0228, 'lps'),
	(478206, 125, '2015-04-01 01:07:40.000000', 'consum', 0.0216, 'lps'),
	(478207, 125, '2015-04-01 01:07:41.000000', 'consum', 0.0212, 'lps'),
	(478208, 125, '2015-04-01 01:07:42.000000', 'consum', 0.0227, 'lps'),
	(478209, 125, '2015-04-01 01:07:43.000000', 'consum', 0.0219, 'lps'),
	(478210, 125, '2015-04-01 01:07:44.000000', 'consum', 0.0227, 'lps'),
	(478211, 125, '2015-04-01 01:07:45.000000', 'consum', 0.0223, 'lps'),
	(478212, 125, '2015-04-01 01:07:46.000000', 'consum', 0.0221, 'lps'),
	(478213, 125, '2015-04-01 01:07:47.000000', 'consum', 0.0229, 'lps'),
	(478214, 125, '2015-04-01 01:07:48.000000', 'consum', 0.0223, 'lps'),
	(478215, 125, '2015-04-01 01:07:49.000000', 'consum', 0.0221, 'lps'),
	(478216, 125, '2015-04-01 01:07:50.000000', 'consum', 0.0225, 'lps'),
	(478217, 125, '2015-04-01 01:07:51.000000', 'consum', 0.0229, 'lps'),
	(478218, 125, '2015-04-01 01:07:52.000000', 'consum', 0.0212, 'lps'),
	(478219, 125, '2015-04-01 01:07:53.000000', 'consum', 0.0214, 'lps'),
	(478220, 125, '2015-04-01 01:07:54.000000', 'consum', 0.0222, 'lps'),
	(478221, 125, '2015-04-01 01:07:55.000000', 'consum', 0.0233, 'lps'),
	(478222, 125, '2015-04-01 01:07:56.000000', 'consum', 0.0219, 'lps'),
	(478223, 125, '2015-04-01 01:07:57.000000', 'consum', 0.0211, 'lps'),
	(478224, 125, '2015-04-01 01:07:58.000000', 'consum', 0.0211, 'lps'),
	(478225, 125, '2015-04-01 01:07:59.000000', 'consum', 0.0215, 'lps'),
	(478226, 125, '2015-04-01 01:08:00.000000', 'consum', 0.0231, 'lps'),
	(478227, 125, '2015-04-01 01:08:01.000000', 'consum', 0.0229, 'lps'),
	(478228, 125, '2015-04-01 01:08:02.000000', 'consum', 0.0218, 'lps'),
	(478229, 125, '2015-04-01 01:08:03.000000', 'consum', 0.0216, 'lps'),
	(478230, 125, '2015-04-01 01:08:04.000000', 'consum', 0.0218, 'lps'),
	(478231, 125, '2015-04-01 01:08:05.000000', 'consum', 0.0231, 'lps'),
	(478232, 125, '2015-04-01 01:08:06.000000', 'consum', 0.0219, 'lps'),
	(478233, 125, '2015-04-01 01:08:07.000000', 'consum', 0.0219, 'lps'),
	(478234, 125, '2015-04-01 01:08:08.000000', 'consum', 0.0229, 'lps'),
	(478235, 125, '2015-04-01 01:08:09.000000', 'consum', 0.0231, 'lps'),
	(478236, 125, '2015-04-01 01:08:10.000000', 'consum', 0.0233, 'lps'),
	(478237, 125, '2015-04-01 01:08:11.000000', 'consum', 0.0213, 'lps'),
	(478238, 125, '2015-04-01 01:08:12.000000', 'consum', 0.0229, 'lps'),
	(478239, 125, '2015-04-01 01:08:13.000000', 'consum', 0.0227, 'lps'),
	(478240, 125, '2015-04-01 01:08:14.000000', 'consum', 0.0212, 'lps'),
	(478241, 125, '2015-04-01 01:08:15.000000', 'consum', 0.0219, 'lps'),
	(478242, 125, '2015-04-01 01:08:16.000000', 'consum', 0.0224, 'lps'),
	(478243, 125, '2015-04-01 01:08:17.000000', 'consum', 0.0229, 'lps'),
	(478244, 125, '2015-04-01 01:08:18.000000', 'consum', 0.0218, 'lps'),
	(478245, 125, '2015-04-01 01:08:19.000000', 'consum', 0.0217, 'lps'),
	(478246, 125, '2015-04-01 01:08:20.000000', 'consum', 0.0222, 'lps'),
	(478247, 125, '2015-04-01 01:08:21.000000', 'consum', 0.0226, 'lps'),
	(478248, 125, '2015-04-01 01:08:22.000000', 'consum', 0.0231, 'lps'),
	(478249, 125, '2015-04-01 01:08:23.000000', 'consum', 0.0219, 'lps'),
	(478250, 125, '2015-04-01 01:08:24.000000', 'consum', 0.0217, 'lps'),
	(478251, 125, '2015-04-01 01:08:25.000000', 'consum', 0.0220, 'lps'),
	(478252, 125, '2015-04-01 01:08:26.000000', 'consum', 0.0212, 'lps'),
	(478253, 125, '2015-04-01 01:08:27.000000', 'consum', 0.0216, 'lps'),
	(478254, 125, '2015-04-01 01:08:28.000000', 'consum', 0.0211, 'lps'),
	(478255, 125, '2015-04-01 01:08:29.000000', 'consum', 0.0221, 'lps'),
	(478256, 125, '2015-04-01 01:08:30.000000', 'consum', 0.0216, 'lps'),
	(478257, 125, '2015-04-01 01:08:31.000000', 'consum', 0.0230, 'lps'),
	(478258, 125, '2015-04-01 01:08:32.000000', 'consum', 0.0220, 'lps'),
	(478259, 125, '2015-04-01 01:08:33.000000', 'consum', 0.0225, 'lps'),
	(478260, 125, '2015-04-01 01:08:34.000000', 'consum', 0.0233, 'lps'),
	(478261, 125, '2015-04-01 01:08:35.000000', 'consum', 0.0231, 'lps'),
	(478262, 125, '2015-04-01 01:08:36.000000', 'consum', 0.0221, 'lps'),
	(478263, 125, '2015-04-01 01:08:37.000000', 'consum', 0.0229, 'lps'),
	(478264, 125, '2015-04-01 01:08:38.000000', 'consum', 0.0222, 'lps'),
	(478265, 125, '2015-04-01 01:08:39.000000', 'consum', 0.0214, 'lps'),
	(478266, 125, '2015-04-01 01:08:40.000000', 'consum', 0.0219, 'lps'),
	(478267, 125, '2015-04-01 01:08:41.000000', 'consum', 0.0219, 'lps'),
	(478268, 125, '2015-04-01 01:08:42.000000', 'consum', 0.0228, 'lps'),
	(478269, 125, '2015-04-01 01:08:43.000000', 'consum', 0.0228, 'lps'),
	(478270, 125, '2015-04-01 01:08:44.000000', 'consum', 0.0221, 'lps'),
	(478271, 125, '2015-04-01 01:08:45.000000', 'consum', 0.0213, 'lps'),
	(478272, 125, '2015-04-01 01:08:46.000000', 'consum', 0.0214, 'lps'),
	(478273, 125, '2015-04-01 01:08:47.000000', 'consum', 0.0224, 'lps'),
	(478274, 125, '2015-04-01 01:08:48.000000', 'consum', 0.0220, 'lps'),
	(478275, 125, '2015-04-01 01:08:49.000000', 'consum', 0.0218, 'lps'),
	(478276, 125, '2015-04-01 01:08:50.000000', 'consum', 0.0222, 'lps'),
	(478277, 125, '2015-04-01 01:08:51.000000', 'consum', 0.0223, 'lps'),
	(478278, 125, '2015-04-01 01:08:52.000000', 'consum', 0.0214, 'lps'),
	(478279, 125, '2015-04-01 01:08:53.000000', 'consum', 0.0215, 'lps'),
	(478280, 125, '2015-04-01 01:08:54.000000', 'consum', 0.0226, 'lps'),
	(478281, 125, '2015-04-01 01:08:55.000000', 'consum', 0.0227, 'lps'),
	(478282, 125, '2015-04-01 01:08:56.000000', 'consum', 0.0223, 'lps'),
	(478283, 125, '2015-04-01 01:08:57.000000', 'consum', 0.0226, 'lps'),
	(478284, 125, '2015-04-01 01:08:58.000000', 'consum', 0.0226, 'lps'),
	(478285, 125, '2015-04-01 01:08:59.000000', 'consum', 0.0218, 'lps'),
	(478286, 125, '2015-04-01 01:09:00.000000', 'consum', 0.0226, 'lps'),
	(478287, 125, '2015-04-01 01:09:01.000000', 'consum', 0.0221, 'lps'),
	(478288, 125, '2015-04-01 01:09:02.000000', 'consum', 0.0215, 'lps'),
	(478289, 125, '2015-04-01 01:09:03.000000', 'consum', 0.0228, 'lps'),
	(478290, 125, '2015-04-01 01:09:04.000000', 'consum', 0.0214, 'lps'),
	(478291, 125, '2015-04-01 01:09:05.000000', 'consum', 0.0224, 'lps'),
	(478292, 125, '2015-04-01 01:09:06.000000', 'consum', 0.0219, 'lps'),
	(478293, 125, '2015-04-01 01:09:07.000000', 'consum', 0.0213, 'lps'),
	(478294, 125, '2015-04-01 01:09:08.000000', 'consum', 0.0222, 'lps'),
	(478295, 125, '2015-04-01 01:09:09.000000', 'consum', 0.0214, 'lps'),
	(478296, 125, '2015-04-01 01:09:10.000000', 'consum', 0.0218, 'lps'),
	(478297, 125, '2015-04-01 01:09:11.000000', 'consum', 0.0215, 'lps'),
	(478298, 125, '2015-04-01 01:09:12.000000', 'consum', 0.0212, 'lps'),
	(478299, 125, '2015-04-01 01:09:13.000000', 'consum', 0.0227, 'lps'),
	(478300, 125, '2015-04-01 01:09:14.000000', 'consum', 0.0219, 'lps'),
	(478301, 125, '2015-04-01 01:09:15.000000', 'consum', 0.0230, 'lps'),
	(478302, 125, '2015-04-01 01:09:16.000000', 'consum', 0.0212, 'lps'),
	(478303, 125, '2015-04-01 01:09:17.000000', 'consum', 0.0233, 'lps'),
	(478304, 125, '2015-04-01 01:09:18.000000', 'consum', 0.0223, 'lps'),
	(478305, 125, '2015-04-01 01:09:19.000000', 'consum', 0.0230, 'lps'),
	(478306, 125, '2015-04-01 01:09:20.000000', 'consum', 0.0223, 'lps'),
	(478307, 125, '2015-04-01 01:09:21.000000', 'consum', 0.0218, 'lps'),
	(478308, 125, '2015-04-01 01:09:22.000000', 'consum', 0.0233, 'lps'),
	(478309, 125, '2015-04-01 01:09:23.000000', 'consum', 0.0230, 'lps'),
	(478310, 125, '2015-04-01 01:09:24.000000', 'consum', 0.0218, 'lps'),
	(478311, 125, '2015-04-01 01:09:25.000000', 'consum', 0.0215, 'lps'),
	(478312, 125, '2015-04-01 01:09:26.000000', 'consum', 0.0210, 'lps'),
	(478313, 125, '2015-04-01 01:09:27.000000', 'consum', 0.0220, 'lps'),
	(478314, 125, '2015-04-01 01:09:28.000000', 'consum', 0.0214, 'lps'),
	(478315, 125, '2015-04-01 01:09:29.000000', 'consum', 0.0224, 'lps'),
	(478316, 125, '2015-04-01 01:09:30.000000', 'consum', 0.0219, 'lps'),
	(478317, 125, '2015-04-01 01:09:31.000000', 'consum', 0.0214, 'lps'),
	(478318, 125, '2015-04-01 01:09:32.000000', 'consum', 0.0228, 'lps'),
	(478319, 125, '2015-04-01 01:09:33.000000', 'consum', 0.0215, 'lps'),
	(478320, 125, '2015-04-01 01:09:34.000000', 'consum', 0.0229, 'lps'),
	(478321, 125, '2015-04-01 01:09:35.000000', 'consum', 0.0218, 'lps'),
	(478322, 125, '2015-04-01 01:09:36.000000', 'consum', 0.0218, 'lps'),
	(478323, 125, '2015-04-01 01:09:37.000000', 'consum', 0.0227, 'lps'),
	(478324, 125, '2015-04-01 01:09:38.000000', 'consum', 0.0226, 'lps'),
	(478325, 125, '2015-04-01 01:09:39.000000', 'consum', 0.0212, 'lps'),
	(478326, 125, '2015-04-01 01:09:40.000000', 'consum', 0.0220, 'lps'),
	(478327, 125, '2015-04-01 01:09:41.000000', 'consum', 0.0210, 'lps'),
	(478328, 125, '2015-04-01 01:09:42.000000', 'consum', 0.0226, 'lps'),
	(478329, 125, '2015-04-01 01:09:43.000000', 'consum', 0.0219, 'lps'),
	(478330, 125, '2015-04-01 01:09:44.000000', 'consum', 0.0232, 'lps'),
	(478331, 125, '2015-04-01 01:09:45.000000', 'consum', 0.0219, 'lps'),
	(478332, 125, '2015-04-01 01:09:46.000000', 'consum', 0.0216, 'lps'),
	(478333, 125, '2015-04-01 01:09:47.000000', 'consum', 0.0213, 'lps'),
	(478334, 125, '2015-04-01 01:09:48.000000', 'consum', 0.0230, 'lps'),
	(478335, 125, '2015-04-01 01:09:49.000000', 'consum', 0.0232, 'lps'),
	(478336, 125, '2015-04-01 01:09:50.000000', 'consum', 0.0210, 'lps'),
	(478337, 125, '2015-04-01 01:09:51.000000', 'consum', 0.0219, 'lps'),
	(478338, 125, '2015-04-01 01:09:52.000000', 'consum', 0.0230, 'lps'),
	(478339, 125, '2015-04-01 01:09:53.000000', 'consum', 0.0213, 'lps'),
	(478340, 125, '2015-04-01 01:09:54.000000', 'consum', 0.0212, 'lps'),
	(478341, 125, '2015-04-01 01:09:55.000000', 'consum', 0.0211, 'lps'),
	(478342, 125, '2015-04-01 01:09:56.000000', 'consum', 0.0211, 'lps'),
	(478343, 125, '2015-04-01 01:09:57.000000', 'consum', 0.0213, 'lps'),
	(478344, 125, '2015-04-01 01:09:58.000000', 'consum', 0.0223, 'lps'),
	(478345, 125, '2015-04-01 01:09:59.000000', 'consum', 0.0216, 'lps'),
	(478346, 125, '2015-04-01 01:10:00.000000', 'consum', 0.0228, 'lps'),
	(478347, 125, '2015-04-01 01:10:01.000000', 'consum', 0.0211, 'lps'),
	(478348, 125, '2015-04-01 01:10:02.000000', 'consum', 0.0231, 'lps'),
	(478349, 125, '2015-04-01 01:10:03.000000', 'consum', 0.0219, 'lps'),
	(478350, 125, '2015-04-01 01:10:04.000000', 'consum', 0.0214, 'lps'),
	(478351, 125, '2015-04-01 01:10:05.000000', 'consum', 0.0229, 'lps'),
	(478352, 125, '2015-04-01 01:10:06.000000', 'consum', 0.0221, 'lps'),
	(478353, 125, '2015-04-01 01:10:07.000000', 'consum', 0.0211, 'lps'),
	(478354, 125, '2015-04-01 01:10:08.000000', 'consum', 0.0227, 'lps'),
	(478355, 125, '2015-04-01 01:10:09.000000', 'consum', 0.0222, 'lps'),
	(478356, 125, '2015-04-01 01:10:10.000000', 'consum', 0.0221, 'lps'),
	(478357, 125, '2015-04-01 01:10:11.000000', 'consum', 0.0230, 'lps'),
	(478358, 125, '2015-04-01 01:10:12.000000', 'consum', 0.0228, 'lps'),
	(478359, 125, '2015-04-01 01:10:13.000000', 'consum', 0.0215, 'lps'),
	(478360, 125, '2015-04-01 01:10:14.000000', 'consum', 0.0232, 'lps'),
	(478361, 125, '2015-04-01 01:10:15.000000', 'consum', 0.0232, 'lps'),
	(478362, 125, '2015-04-01 01:10:16.000000', 'consum', 0.0231, 'lps'),
	(478363, 125, '2015-04-01 01:10:17.000000', 'consum', 0.0225, 'lps'),
	(478364, 125, '2015-04-01 01:10:18.000000', 'consum', 0.0224, 'lps'),
	(478365, 125, '2015-04-01 01:10:19.000000', 'consum', 0.0212, 'lps'),
	(478366, 125, '2015-04-01 01:10:20.000000', 'consum', 0.0228, 'lps'),
	(478367, 125, '2015-04-01 01:10:21.000000', 'consum', 0.0219, 'lps'),
	(478368, 125, '2015-04-01 01:10:22.000000', 'consum', 0.0227, 'lps'),
	(478369, 125, '2015-04-01 01:10:23.000000', 'consum', 0.0222, 'lps'),
	(478370, 125, '2015-04-01 01:10:24.000000', 'consum', 0.0217, 'lps'),
	(478371, 125, '2015-04-01 01:10:25.000000', 'consum', 0.0212, 'lps'),
	(478372, 125, '2015-04-01 01:10:26.000000', 'consum', 0.0223, 'lps'),
	(478373, 125, '2015-04-01 01:10:27.000000', 'consum', 0.0222, 'lps'),
	(478374, 125, '2015-04-01 01:10:28.000000', 'consum', 0.0232, 'lps'),
	(478375, 125, '2015-04-01 01:10:29.000000', 'consum', 0.0213, 'lps'),
	(478376, 125, '2015-04-01 01:10:30.000000', 'consum', 0.0232, 'lps'),
	(478377, 125, '2015-04-01 01:10:31.000000', 'consum', 0.0215, 'lps'),
	(478378, 125, '2015-04-01 01:10:32.000000', 'consum', 0.0218, 'lps'),
	(478379, 125, '2015-04-01 01:10:33.000000', 'consum', 0.0211, 'lps'),
	(478380, 125, '2015-04-01 01:10:34.000000', 'consum', 0.0214, 'lps'),
	(478381, 125, '2015-04-01 01:10:35.000000', 'consum', 0.0229, 'lps'),
	(478382, 125, '2015-04-01 01:10:36.000000', 'consum', 0.0222, 'lps'),
	(478383, 125, '2015-04-01 01:10:37.000000', 'consum', 0.0212, 'lps'),
	(478384, 125, '2015-04-01 01:10:38.000000', 'consum', 0.0210, 'lps'),
	(478385, 125, '2015-04-01 01:10:39.000000', 'consum', 0.0229, 'lps'),
	(478386, 125, '2015-04-01 01:10:40.000000', 'consum', 0.0233, 'lps'),
	(478387, 125, '2015-04-01 01:10:41.000000', 'consum', 0.0219, 'lps'),
	(478388, 125, '2015-04-01 01:10:42.000000', 'consum', 0.0212, 'lps'),
	(478389, 125, '2015-04-01 01:10:43.000000', 'consum', 0.0218, 'lps'),
	(478390, 125, '2015-04-01 01:10:44.000000', 'consum', 0.0219, 'lps'),
	(478391, 125, '2015-04-01 01:10:45.000000', 'consum', 0.0233, 'lps'),
	(478392, 125, '2015-04-01 01:10:46.000000', 'consum', 0.0228, 'lps'),
	(478393, 125, '2015-04-01 01:10:47.000000', 'consum', 0.0229, 'lps'),
	(478394, 125, '2015-04-01 01:10:48.000000', 'consum', 0.0230, 'lps'),
	(478395, 125, '2015-04-01 01:10:49.000000', 'consum', 0.0229, 'lps'),
	(478396, 125, '2015-04-01 01:10:50.000000', 'consum', 0.0222, 'lps'),
	(478397, 125, '2015-04-01 01:10:51.000000', 'consum', 0.0215, 'lps'),
	(478398, 125, '2015-04-01 01:10:52.000000', 'consum', 0.0220, 'lps'),
	(478399, 125, '2015-04-01 01:10:53.000000', 'consum', 0.0222, 'lps'),
	(478400, 125, '2015-04-01 01:10:54.000000', 'consum', 0.0217, 'lps'),
	(478401, 125, '2015-04-01 01:10:55.000000', 'consum', 0.0212, 'lps'),
	(478402, 125, '2015-04-01 01:10:56.000000', 'consum', 0.0220, 'lps'),
	(478403, 125, '2015-04-01 01:10:57.000000', 'consum', 0.0230, 'lps'),
	(478404, 125, '2015-04-01 01:10:58.000000', 'consum', 0.0212, 'lps'),
	(478405, 125, '2015-04-01 01:10:59.000000', 'consum', 0.0229, 'lps'),
	(478406, 125, '2015-04-01 01:11:00.000000', 'consum', 0.0228, 'lps'),
	(478407, 125, '2015-04-01 01:11:01.000000', 'consum', 0.0222, 'lps'),
	(478408, 125, '2015-04-01 01:11:02.000000', 'consum', 0.0215, 'lps'),
	(478409, 125, '2015-04-01 01:11:03.000000', 'consum', 0.0224, 'lps'),
	(478410, 125, '2015-04-01 01:11:04.000000', 'consum', 0.0218, 'lps'),
	(478411, 125, '2015-04-01 01:11:05.000000', 'consum', 0.0210, 'lps'),
	(478412, 125, '2015-04-01 01:11:06.000000', 'consum', 0.0232, 'lps'),
	(478413, 125, '2015-04-01 01:11:07.000000', 'consum', 0.0225, 'lps'),
	(478414, 125, '2015-04-01 01:11:08.000000', 'consum', 0.0221, 'lps'),
	(478415, 125, '2015-04-01 01:11:09.000000', 'consum', 0.0220, 'lps'),
	(478416, 125, '2015-04-01 01:11:10.000000', 'consum', 0.0229, 'lps'),
	(478417, 125, '2015-04-01 01:11:11.000000', 'consum', 0.0227, 'lps'),
	(478418, 125, '2015-04-01 01:11:12.000000', 'consum', 0.0216, 'lps'),
	(478419, 125, '2015-04-01 01:11:13.000000', 'consum', 0.0212, 'lps'),
	(478420, 125, '2015-04-01 01:11:14.000000', 'consum', 0.0228, 'lps'),
	(478421, 125, '2015-04-01 01:11:15.000000', 'consum', 0.0221, 'lps'),
	(478422, 125, '2015-04-01 01:11:16.000000', 'consum', 0.0212, 'lps'),
	(478423, 125, '2015-04-01 01:11:17.000000', 'consum', 0.0211, 'lps'),
	(478424, 125, '2015-04-01 01:11:18.000000', 'consum', 0.0233, 'lps'),
	(478425, 125, '2015-04-01 01:11:19.000000', 'consum', 0.0225, 'lps'),
	(478426, 125, '2015-04-01 01:11:20.000000', 'consum', 0.0219, 'lps'),
	(478427, 125, '2015-04-01 01:11:21.000000', 'consum', 0.0232, 'lps'),
	(478428, 125, '2015-04-01 01:11:22.000000', 'consum', 0.0223, 'lps'),
	(478429, 125, '2015-04-01 01:11:23.000000', 'consum', 0.0231, 'lps'),
	(478430, 125, '2015-04-01 01:11:24.000000', 'consum', 0.0231, 'lps'),
	(478431, 125, '2015-04-01 01:11:25.000000', 'consum', 0.0228, 'lps'),
	(478432, 125, '2015-04-01 01:11:26.000000', 'consum', 0.0214, 'lps'),
	(478433, 125, '2015-04-01 01:11:27.000000', 'consum', 0.0223, 'lps'),
	(478434, 125, '2015-04-01 01:11:28.000000', 'consum', 0.0216, 'lps'),
	(478435, 125, '2015-04-01 01:11:29.000000', 'consum', 0.0227, 'lps'),
	(478436, 125, '2015-04-01 01:11:30.000000', 'consum', 0.0229, 'lps'),
	(478437, 125, '2015-04-01 01:11:31.000000', 'consum', 0.0231, 'lps'),
	(478438, 125, '2015-04-01 01:11:32.000000', 'consum', 0.0233, 'lps'),
	(478439, 125, '2015-04-01 01:11:33.000000', 'consum', 0.0217, 'lps'),
	(478440, 125, '2015-04-01 01:11:34.000000', 'consum', 0.0224, 'lps'),
	(478441, 125, '2015-04-01 01:11:35.000000', 'consum', 0.0210, 'lps'),
	(478442, 125, '2015-04-01 01:11:36.000000', 'consum', 0.0216, 'lps'),
	(478443, 125, '2015-04-01 01:11:37.000000', 'consum', 0.0219, 'lps'),
	(478444, 125, '2015-04-01 01:11:38.000000', 'consum', 0.0210, 'lps'),
	(478445, 125, '2015-04-01 01:11:39.000000', 'consum', 0.0211, 'lps'),
	(478446, 125, '2015-04-01 01:11:40.000000', 'consum', 0.0214, 'lps'),
	(478447, 125, '2015-04-01 01:11:41.000000', 'consum', 0.0227, 'lps'),
	(478448, 125, '2015-04-01 01:11:42.000000', 'consum', 0.0210, 'lps'),
	(478449, 125, '2015-04-01 01:11:43.000000', 'consum', 0.0210, 'lps'),
	(478450, 125, '2015-04-01 01:11:44.000000', 'consum', 0.0210, 'lps'),
	(478451, 125, '2015-04-01 01:11:45.000000', 'consum', 0.0211, 'lps'),
	(478452, 125, '2015-04-01 01:11:46.000000', 'consum', 0.0216, 'lps'),
	(478453, 125, '2015-04-01 01:11:47.000000', 'consum', 0.0214, 'lps'),
	(478454, 125, '2015-04-01 01:11:48.000000', 'consum', 0.0210, 'lps'),
	(478455, 125, '2015-04-01 01:11:49.000000', 'consum', 0.0224, 'lps'),
	(478456, 125, '2015-04-01 01:11:50.000000', 'consum', 0.0232, 'lps'),
	(478457, 125, '2015-04-01 01:11:51.000000', 'consum', 0.0232, 'lps'),
	(478458, 125, '2015-04-01 01:11:52.000000', 'consum', 0.0229, 'lps'),
	(478459, 125, '2015-04-01 01:11:53.000000', 'consum', 0.0215, 'lps'),
	(478460, 125, '2015-04-01 01:11:54.000000', 'consum', 0.0228, 'lps'),
	(478461, 125, '2015-04-01 01:11:55.000000', 'consum', 0.0213, 'lps'),
	(478462, 125, '2015-04-01 01:11:56.000000', 'consum', 0.0217, 'lps'),
	(478463, 125, '2015-04-01 01:11:57.000000', 'consum', 0.0216, 'lps'),
	(478464, 125, '2015-04-01 01:11:58.000000', 'consum', 0.0218, 'lps'),
	(478465, 125, '2015-04-01 01:11:59.000000', 'consum', 0.0231, 'lps'),
	(478466, 125, '2015-04-01 01:12:00.000000', 'consum', 0.0221, 'lps'),
	(478467, 125, '2015-04-01 01:12:01.000000', 'consum', 0.0226, 'lps'),
	(478468, 125, '2015-04-01 01:12:02.000000', 'consum', 0.0232, 'lps'),
	(478469, 125, '2015-04-01 01:12:03.000000', 'consum', 0.0225, 'lps'),
	(478470, 125, '2015-04-01 01:12:04.000000', 'consum', 0.0222, 'lps'),
	(478471, 125, '2015-04-01 01:12:05.000000', 'consum', 0.0224, 'lps'),
	(478472, 125, '2015-04-01 01:12:06.000000', 'consum', 0.0218, 'lps'),
	(478473, 125, '2015-04-01 01:12:07.000000', 'consum', 0.0212, 'lps'),
	(478474, 125, '2015-04-01 01:12:08.000000', 'consum', 0.0221, 'lps'),
	(478475, 125, '2015-04-01 01:12:09.000000', 'consum', 0.0211, 'lps'),
	(478476, 125, '2015-04-01 01:12:10.000000', 'consum', 0.0229, 'lps'),
	(478477, 125, '2015-04-01 01:12:11.000000', 'consum', 0.0230, 'lps'),
	(478478, 125, '2015-04-01 01:12:12.000000', 'consum', 0.0232, 'lps'),
	(478479, 125, '2015-04-01 01:12:13.000000', 'consum', 0.0210, 'lps'),
	(478480, 125, '2015-04-01 01:12:14.000000', 'consum', 0.0219, 'lps'),
	(478481, 125, '2015-04-01 01:12:15.000000', 'consum', 0.0231, 'lps'),
	(478482, 125, '2015-04-01 01:12:16.000000', 'consum', 0.0216, 'lps'),
	(478483, 125, '2015-04-01 01:12:17.000000', 'consum', 0.0224, 'lps'),
	(478484, 125, '2015-04-01 01:12:18.000000', 'consum', 0.0214, 'lps'),
	(478485, 125, '2015-04-01 01:12:19.000000', 'consum', 0.0213, 'lps'),
	(478486, 125, '2015-04-01 01:12:20.000000', 'consum', 0.0214, 'lps'),
	(478487, 125, '2015-04-01 01:12:21.000000', 'consum', 0.0223, 'lps'),
	(478488, 125, '2015-04-01 01:12:22.000000', 'consum', 0.0216, 'lps'),
	(478489, 125, '2015-04-01 01:12:23.000000', 'consum', 0.0225, 'lps'),
	(478490, 125, '2015-04-01 01:12:24.000000', 'consum', 0.0217, 'lps'),
	(478491, 125, '2015-04-01 01:12:25.000000', 'consum', 0.0226, 'lps'),
	(478492, 125, '2015-04-01 01:12:26.000000', 'consum', 0.0220, 'lps'),
	(478493, 125, '2015-04-01 01:12:27.000000', 'consum', 0.0214, 'lps'),
	(478494, 125, '2015-04-01 01:12:28.000000', 'consum', 0.0225, 'lps'),
	(478495, 125, '2015-04-01 01:12:29.000000', 'consum', 0.0227, 'lps'),
	(478496, 125, '2015-04-01 01:12:30.000000', 'consum', 0.0223, 'lps'),
	(478497, 125, '2015-04-01 01:12:31.000000', 'consum', 0.0226, 'lps'),
	(478498, 125, '2015-04-01 01:12:32.000000', 'consum', 0.0226, 'lps'),
	(478499, 125, '2015-04-01 01:12:33.000000', 'consum', 0.0222, 'lps'),
	(478500, 125, '2015-04-01 01:12:34.000000', 'consum', 0.0219, 'lps'),
	(478501, 125, '2015-04-01 01:12:35.000000', 'consum', 0.0220, 'lps'),
	(478502, 125, '2015-04-01 01:12:36.000000', 'consum', 0.0233, 'lps'),
	(478503, 125, '2015-04-01 01:12:37.000000', 'consum', 0.0223, 'lps'),
	(478504, 125, '2015-04-01 01:12:38.000000', 'consum', 0.0231, 'lps'),
	(478505, 125, '2015-04-01 01:12:39.000000', 'consum', 0.0231, 'lps'),
	(478506, 125, '2015-04-01 01:12:40.000000', 'consum', 0.0226, 'lps'),
	(478507, 125, '2015-04-01 01:12:41.000000', 'consum', 0.0228, 'lps'),
	(478508, 125, '2015-04-01 01:12:42.000000', 'consum', 0.0227, 'lps'),
	(478509, 125, '2015-04-01 01:12:43.000000', 'consum', 0.0219, 'lps'),
	(478510, 125, '2015-04-01 01:12:44.000000', 'consum', 0.0229, 'lps'),
	(478511, 125, '2015-04-01 01:12:45.000000', 'consum', 0.0231, 'lps'),
	(478512, 125, '2015-04-01 01:12:46.000000', 'consum', 0.0210, 'lps'),
	(478513, 125, '2015-04-01 01:12:47.000000', 'consum', 0.0221, 'lps'),
	(478514, 125, '2015-04-01 01:12:48.000000', 'consum', 0.0214, 'lps'),
	(478515, 125, '2015-04-01 01:12:49.000000', 'consum', 0.0225, 'lps'),
	(478516, 125, '2015-04-01 01:12:50.000000', 'consum', 0.0225, 'lps'),
	(478517, 125, '2015-04-01 01:12:51.000000', 'consum', 0.0215, 'lps'),
	(478518, 125, '2015-04-01 01:12:52.000000', 'consum', 0.0215, 'lps'),
	(478519, 125, '2015-04-01 01:12:53.000000', 'consum', 0.0219, 'lps'),
	(478520, 125, '2015-04-01 01:12:54.000000', 'consum', 0.0216, 'lps'),
	(478521, 125, '2015-04-01 01:12:55.000000', 'consum', 0.0213, 'lps'),
	(478522, 125, '2015-04-01 01:12:56.000000', 'consum', 0.0231, 'lps'),
	(478523, 125, '2015-04-01 01:12:57.000000', 'consum', 0.0214, 'lps'),
	(478524, 125, '2015-04-01 01:12:58.000000', 'consum', 0.0212, 'lps'),
	(478525, 125, '2015-04-01 01:12:59.000000', 'consum', 0.0210, 'lps'),
	(478526, 125, '2015-04-01 01:13:00.000000', 'consum', 0.0226, 'lps'),
	(478527, 125, '2015-04-01 01:13:01.000000', 'consum', 0.0222, 'lps'),
	(478528, 125, '2015-04-01 01:13:02.000000', 'consum', 0.0222, 'lps'),
	(478529, 125, '2015-04-01 01:13:03.000000', 'consum', 0.0210, 'lps'),
	(478530, 125, '2015-04-01 01:13:04.000000', 'consum', 0.0223, 'lps'),
	(478531, 125, '2015-04-01 01:13:05.000000', 'consum', 0.0227, 'lps'),
	(478532, 125, '2015-04-01 01:13:06.000000', 'consum', 0.0232, 'lps'),
	(478533, 125, '2015-04-01 01:13:07.000000', 'consum', 0.0221, 'lps'),
	(478534, 125, '2015-04-01 01:13:08.000000', 'consum', 0.0223, 'lps'),
	(478535, 125, '2015-04-01 01:13:09.000000', 'consum', 0.0220, 'lps'),
	(478536, 125, '2015-04-01 01:13:10.000000', 'consum', 0.0223, 'lps'),
	(478537, 125, '2015-04-01 01:13:11.000000', 'consum', 0.0220, 'lps'),
	(478538, 125, '2015-04-01 01:13:12.000000', 'consum', 0.0220, 'lps'),
	(478539, 125, '2015-04-01 01:13:13.000000', 'consum', 0.0230, 'lps'),
	(478540, 125, '2015-04-01 01:13:14.000000', 'consum', 0.0232, 'lps'),
	(478541, 125, '2015-04-01 01:13:15.000000', 'consum', 0.0215, 'lps'),
	(478542, 125, '2015-04-01 01:13:16.000000', 'consum', 0.0216, 'lps'),
	(478543, 125, '2015-04-01 01:13:17.000000', 'consum', 0.0228, 'lps'),
	(478544, 125, '2015-04-01 01:13:18.000000', 'consum', 0.0232, 'lps'),
	(478545, 125, '2015-04-01 01:13:19.000000', 'consum', 0.0221, 'lps'),
	(478546, 125, '2015-04-01 01:13:20.000000', 'consum', 0.0221, 'lps'),
	(478547, 125, '2015-04-01 01:13:21.000000', 'consum', 0.0231, 'lps'),
	(478548, 125, '2015-04-01 01:13:22.000000', 'consum', 0.0214, 'lps'),
	(478549, 125, '2015-04-01 01:13:23.000000', 'consum', 0.0213, 'lps'),
	(478550, 125, '2015-04-01 01:13:24.000000', 'consum', 0.0216, 'lps'),
	(478551, 125, '2015-04-01 01:13:25.000000', 'consum', 0.0230, 'lps'),
	(478552, 125, '2015-04-01 01:13:26.000000', 'consum', 0.0221, 'lps'),
	(478553, 125, '2015-04-01 01:13:27.000000', 'consum', 0.0230, 'lps'),
	(478554, 125, '2015-04-01 01:13:28.000000', 'consum', 0.0229, 'lps'),
	(478555, 125, '2015-04-01 01:13:29.000000', 'consum', 0.0223, 'lps'),
	(478556, 125, '2015-04-01 01:13:30.000000', 'consum', 0.0216, 'lps'),
	(478557, 125, '2015-04-01 01:13:31.000000', 'consum', 0.0226, 'lps'),
	(478558, 125, '2015-04-01 01:13:32.000000', 'consum', 0.0227, 'lps'),
	(478559, 125, '2015-04-01 01:13:33.000000', 'consum', 0.0221, 'lps'),
	(478560, 125, '2015-04-01 01:13:34.000000', 'consum', 0.0215, 'lps'),
	(478561, 125, '2015-04-01 01:13:35.000000', 'consum', 0.0227, 'lps'),
	(478562, 125, '2015-04-01 01:13:36.000000', 'consum', 0.0231, 'lps'),
	(478563, 125, '2015-04-01 01:13:37.000000', 'consum', 0.0219, 'lps'),
	(478564, 125, '2015-04-01 01:13:38.000000', 'consum', 0.0214, 'lps'),
	(478565, 125, '2015-04-01 01:13:39.000000', 'consum', 0.0227, 'lps'),
	(478566, 125, '2015-04-01 01:13:40.000000', 'consum', 0.0214, 'lps'),
	(478567, 125, '2015-04-01 01:13:41.000000', 'consum', 0.0227, 'lps'),
	(478568, 125, '2015-04-01 01:13:42.000000', 'consum', 0.0212, 'lps'),
	(478569, 125, '2015-04-01 01:13:43.000000', 'consum', 0.0215, 'lps'),
	(478570, 125, '2015-04-01 01:13:44.000000', 'consum', 0.0230, 'lps'),
	(478571, 125, '2015-04-01 01:13:45.000000', 'consum', 0.0224, 'lps'),
	(478572, 125, '2015-04-01 01:13:46.000000', 'consum', 0.0221, 'lps'),
	(478573, 125, '2015-04-01 01:13:47.000000', 'consum', 0.0224, 'lps'),
	(478574, 125, '2015-04-01 01:13:48.000000', 'consum', 0.0225, 'lps'),
	(478575, 125, '2015-04-01 01:13:49.000000', 'consum', 0.0216, 'lps'),
	(478576, 125, '2015-04-01 01:13:50.000000', 'consum', 0.0221, 'lps'),
	(478577, 125, '2015-04-01 01:13:51.000000', 'consum', 0.0224, 'lps'),
	(478578, 125, '2015-04-01 01:13:52.000000', 'consum', 0.0222, 'lps'),
	(478579, 125, '2015-04-01 01:13:53.000000', 'consum', 0.0231, 'lps'),
	(478580, 125, '2015-04-01 01:13:54.000000', 'consum', 0.0231, 'lps'),
	(478581, 125, '2015-04-01 01:13:55.000000', 'consum', 0.0228, 'lps'),
	(478582, 125, '2015-04-01 01:13:56.000000', 'consum', 0.0216, 'lps'),
	(478583, 125, '2015-04-01 01:13:57.000000', 'consum', 0.0231, 'lps'),
	(478584, 125, '2015-04-01 01:13:58.000000', 'consum', 0.0228, 'lps'),
	(478585, 125, '2015-04-01 01:13:59.000000', 'consum', 0.0212, 'lps'),
	(478586, 125, '2015-04-01 01:14:00.000000', 'consum', 0.0216, 'lps'),
	(478587, 125, '2015-04-01 01:14:01.000000', 'consum', 0.0211, 'lps'),
	(478588, 125, '2015-04-01 01:14:02.000000', 'consum', 0.0219, 'lps'),
	(478589, 125, '2015-04-01 01:14:03.000000', 'consum', 0.0228, 'lps'),
	(478590, 125, '2015-04-01 01:14:04.000000', 'consum', 0.0229, 'lps'),
	(478591, 125, '2015-04-01 01:14:05.000000', 'consum', 0.0224, 'lps'),
	(478592, 125, '2015-04-01 01:14:06.000000', 'consum', 0.0226, 'lps'),
	(478593, 125, '2015-04-01 01:14:07.000000', 'consum', 0.0224, 'lps'),
	(478594, 125, '2015-04-01 01:14:08.000000', 'consum', 0.0232, 'lps'),
	(478595, 125, '2015-04-01 01:14:09.000000', 'consum', 0.0232, 'lps'),
	(478596, 125, '2015-04-01 01:14:10.000000', 'consum', 0.0231, 'lps'),
	(478597, 125, '2015-04-01 01:14:11.000000', 'consum', 0.0225, 'lps'),
	(478598, 125, '2015-04-01 01:14:12.000000', 'consum', 0.0222, 'lps'),
	(478599, 125, '2015-04-01 01:14:13.000000', 'consum', 0.0224, 'lps'),
	(478600, 125, '2015-04-01 01:14:14.000000', 'consum', 0.0221, 'lps'),
	(478601, 125, '2015-04-01 01:14:15.000000', 'consum', 0.0226, 'lps'),
	(478602, 125, '2015-04-01 01:14:16.000000', 'consum', 0.0232, 'lps'),
	(478603, 125, '2015-04-01 01:14:17.000000', 'consum', 0.0226, 'lps'),
	(478604, 125, '2015-04-01 01:14:18.000000', 'consum', 0.0223, 'lps'),
	(478605, 125, '2015-04-01 01:14:19.000000', 'consum', 0.0229, 'lps'),
	(478606, 125, '2015-04-01 01:14:20.000000', 'consum', 0.0217, 'lps'),
	(478607, 125, '2015-04-01 01:14:21.000000', 'consum', 0.0211, 'lps'),
	(478608, 125, '2015-04-01 01:14:22.000000', 'consum', 0.0221, 'lps'),
	(478609, 125, '2015-04-01 01:14:23.000000', 'consum', 0.0214, 'lps'),
	(478610, 125, '2015-04-01 01:14:24.000000', 'consum', 0.0220, 'lps'),
	(478611, 125, '2015-04-01 01:14:25.000000', 'consum', 0.0226, 'lps'),
	(478612, 125, '2015-04-01 01:14:26.000000', 'consum', 0.0212, 'lps'),
	(478613, 125, '2015-04-01 01:14:27.000000', 'consum', 0.0220, 'lps'),
	(478614, 125, '2015-04-01 01:14:28.000000', 'consum', 0.0230, 'lps'),
	(478615, 125, '2015-04-01 01:14:29.000000', 'consum', 0.0210, 'lps'),
	(478616, 125, '2015-04-01 01:14:30.000000', 'consum', 0.0221, 'lps'),
	(478617, 125, '2015-04-01 01:14:31.000000', 'consum', 0.0217, 'lps'),
	(478618, 125, '2015-04-01 01:14:32.000000', 'consum', 0.0212, 'lps'),
	(478619, 125, '2015-04-01 01:14:33.000000', 'consum', 0.0224, 'lps'),
	(478620, 125, '2015-04-01 01:14:34.000000', 'consum', 0.0229, 'lps'),
	(478621, 125, '2015-04-01 01:14:35.000000', 'consum', 0.0212, 'lps'),
	(478622, 125, '2015-04-01 01:14:36.000000', 'consum', 0.0215, 'lps'),
	(478623, 125, '2015-04-01 01:14:37.000000', 'consum', 0.0226, 'lps'),
	(478624, 125, '2015-04-01 01:14:38.000000', 'consum', 0.0228, 'lps'),
	(478625, 125, '2015-04-01 01:14:39.000000', 'consum', 0.0231, 'lps'),
	(478626, 125, '2015-04-01 01:14:40.000000', 'consum', 0.0212, 'lps'),
	(478627, 125, '2015-04-01 01:14:41.000000', 'consum', 0.0229, 'lps'),
	(478628, 125, '2015-04-01 01:14:42.000000', 'consum', 0.0228, 'lps'),
	(478629, 125, '2015-04-01 01:14:43.000000', 'consum', 0.0221, 'lps'),
	(478630, 125, '2015-04-01 01:14:44.000000', 'consum', 0.0233, 'lps'),
	(478631, 125, '2015-04-01 01:14:45.000000', 'consum', 0.0221, 'lps'),
	(478632, 125, '2015-04-01 01:14:46.000000', 'consum', 0.0223, 'lps'),
	(478633, 125, '2015-04-01 01:14:47.000000', 'consum', 0.0216, 'lps'),
	(478634, 125, '2015-04-01 01:14:48.000000', 'consum', 0.0224, 'lps'),
	(478635, 125, '2015-04-01 01:14:49.000000', 'consum', 0.0218, 'lps'),
	(478636, 125, '2015-04-01 01:14:50.000000', 'consum', 0.0231, 'lps'),
	(478637, 125, '2015-04-01 01:14:51.000000', 'consum', 0.0218, 'lps'),
	(478638, 125, '2015-04-01 01:14:52.000000', 'consum', 0.0214, 'lps'),
	(478639, 125, '2015-04-01 01:14:53.000000', 'consum', 0.0228, 'lps'),
	(478640, 125, '2015-04-01 01:14:54.000000', 'consum', 0.0218, 'lps'),
	(478641, 125, '2015-04-01 01:14:55.000000', 'consum', 0.0220, 'lps'),
	(478642, 125, '2015-04-01 01:14:56.000000', 'consum', 0.0211, 'lps'),
	(478643, 125, '2015-04-01 01:14:57.000000', 'consum', 0.0212, 'lps'),
	(478644, 125, '2015-04-01 01:14:58.000000', 'consum', 0.0217, 'lps'),
	(478645, 125, '2015-04-01 01:14:59.000000', 'consum', 0.0216, 'lps'),
	(478646, 125, '2015-04-01 01:15:00.000000', 'consum', 0.0217, 'lps'),
	(478647, 125, '2015-04-01 01:15:01.000000', 'consum', 0.0229, 'lps'),
	(478648, 125, '2015-04-01 01:15:02.000000', 'consum', 0.0211, 'lps'),
	(478649, 125, '2015-04-01 01:15:03.000000', 'consum', 0.0231, 'lps'),
	(478650, 125, '2015-04-01 01:15:04.000000', 'consum', 0.0218, 'lps'),
	(478651, 125, '2015-04-01 01:15:05.000000', 'consum', 0.0212, 'lps'),
	(478652, 125, '2015-04-01 01:15:06.000000', 'consum', 0.0221, 'lps'),
	(478653, 125, '2015-04-01 01:15:07.000000', 'consum', 0.0233, 'lps'),
	(478654, 125, '2015-04-01 01:15:08.000000', 'consum', 0.0222, 'lps'),
	(478655, 125, '2015-04-01 01:15:09.000000', 'consum', 0.0223, 'lps'),
	(478656, 125, '2015-04-01 01:15:10.000000', 'consum', 0.0218, 'lps'),
	(478657, 125, '2015-04-01 01:15:11.000000', 'consum', 0.0233, 'lps'),
	(478658, 125, '2015-04-01 01:15:12.000000', 'consum', 0.0232, 'lps'),
	(478659, 125, '2015-04-01 01:15:13.000000', 'consum', 0.0225, 'lps'),
	(478660, 125, '2015-04-01 01:15:14.000000', 'consum', 0.0220, 'lps'),
	(478661, 125, '2015-04-01 01:15:15.000000', 'consum', 0.0214, 'lps'),
	(478662, 125, '2015-04-01 01:15:16.000000', 'consum', 0.0228, 'lps'),
	(478663, 125, '2015-04-01 01:15:17.000000', 'consum', 0.0215, 'lps'),
	(478664, 125, '2015-04-01 01:15:18.000000', 'consum', 0.0229, 'lps'),
	(478665, 125, '2015-04-01 01:15:19.000000', 'consum', 0.0220, 'lps'),
	(478666, 125, '2015-04-01 01:15:20.000000', 'consum', 0.0228, 'lps'),
	(478667, 125, '2015-04-01 01:15:21.000000', 'consum', 0.0223, 'lps'),
	(478668, 125, '2015-04-01 01:15:22.000000', 'consum', 0.0222, 'lps'),
	(478669, 125, '2015-04-01 01:15:23.000000', 'consum', 0.0231, 'lps'),
	(478670, 125, '2015-04-01 01:15:24.000000', 'consum', 0.0232, 'lps'),
	(478671, 125, '2015-04-01 01:15:25.000000', 'consum', 0.0232, 'lps'),
	(478672, 125, '2015-04-01 01:15:26.000000', 'consum', 0.0232, 'lps'),
	(478673, 125, '2015-04-01 01:15:27.000000', 'consum', 0.0230, 'lps'),
	(478674, 125, '2015-04-01 01:15:28.000000', 'consum', 0.0218, 'lps'),
	(478675, 125, '2015-04-01 01:15:29.000000', 'consum', 0.0218, 'lps'),
	(478676, 125, '2015-04-01 01:15:30.000000', 'consum', 0.0223, 'lps'),
	(478677, 125, '2015-04-01 01:15:31.000000', 'consum', 0.0231, 'lps'),
	(478678, 125, '2015-04-01 01:15:32.000000', 'consum', 0.0227, 'lps'),
	(478679, 125, '2015-04-01 01:15:33.000000', 'consum', 0.0231, 'lps'),
	(478680, 125, '2015-04-01 01:15:34.000000', 'consum', 0.0216, 'lps'),
	(478681, 125, '2015-04-01 01:15:35.000000', 'consum', 0.0228, 'lps'),
	(478682, 125, '2015-04-01 01:15:36.000000', 'consum', 0.0233, 'lps'),
	(478683, 125, '2015-04-01 01:15:37.000000', 'consum', 0.0226, 'lps'),
	(478684, 125, '2015-04-01 01:15:38.000000', 'consum', 0.0218, 'lps'),
	(478685, 125, '2015-04-01 01:15:39.000000', 'consum', 0.0229, 'lps'),
	(478686, 125, '2015-04-01 01:15:40.000000', 'consum', 0.0210, 'lps'),
	(478687, 125, '2015-04-01 01:15:41.000000', 'consum', 0.0225, 'lps'),
	(478688, 125, '2015-04-01 01:15:42.000000', 'consum', 0.0215, 'lps'),
	(478689, 125, '2015-04-01 01:15:43.000000', 'consum', 0.0215, 'lps'),
	(478690, 125, '2015-04-01 01:15:44.000000', 'consum', 0.0219, 'lps'),
	(478691, 125, '2015-04-01 01:15:45.000000', 'consum', 0.0215, 'lps'),
	(478692, 125, '2015-04-01 01:15:46.000000', 'consum', 0.0212, 'lps'),
	(478693, 125, '2015-04-01 01:15:47.000000', 'consum', 0.0226, 'lps'),
	(478694, 125, '2015-04-01 01:15:48.000000', 'consum', 0.0214, 'lps'),
	(478695, 125, '2015-04-01 01:15:49.000000', 'consum', 0.0232, 'lps'),
	(478696, 125, '2015-04-01 01:15:50.000000', 'consum', 0.0210, 'lps'),
	(478697, 125, '2015-04-01 01:15:51.000000', 'consum', 0.0216, 'lps'),
	(478698, 125, '2015-04-01 01:15:52.000000', 'consum', 0.0220, 'lps'),
	(478699, 125, '2015-04-01 01:15:53.000000', 'consum', 0.0215, 'lps'),
	(478700, 125, '2015-04-01 01:15:54.000000', 'consum', 0.0231, 'lps'),
	(478701, 125, '2015-04-01 01:15:55.000000', 'consum', 0.0226, 'lps'),
	(478702, 125, '2015-04-01 01:15:56.000000', 'consum', 0.0230, 'lps'),
	(478703, 125, '2015-04-01 01:15:57.000000', 'consum', 0.0215, 'lps'),
	(478704, 125, '2015-04-01 01:15:58.000000', 'consum', 0.0225, 'lps'),
	(478705, 125, '2015-04-01 01:15:59.000000', 'consum', 0.0220, 'lps'),
	(478706, 125, '2015-04-01 01:16:00.000000', 'consum', 0.0214, 'lps'),
	(478707, 125, '2015-04-01 01:16:01.000000', 'consum', 0.0228, 'lps'),
	(478708, 125, '2015-04-01 01:16:02.000000', 'consum', 0.0215, 'lps'),
	(478709, 125, '2015-04-01 01:16:03.000000', 'consum', 0.0228, 'lps'),
	(478710, 125, '2015-04-01 01:16:04.000000', 'consum', 0.0213, 'lps'),
	(478711, 125, '2015-04-01 01:16:05.000000', 'consum', 0.0220, 'lps'),
	(478712, 125, '2015-04-01 01:16:06.000000', 'consum', 0.0230, 'lps'),
	(478713, 125, '2015-04-01 01:16:07.000000', 'consum', 0.0231, 'lps'),
	(478714, 125, '2015-04-01 01:16:08.000000', 'consum', 0.0233, 'lps'),
	(478715, 125, '2015-04-01 01:16:09.000000', 'consum', 0.0212, 'lps'),
	(478716, 125, '2015-04-01 01:16:10.000000', 'consum', 0.0223, 'lps'),
	(478717, 125, '2015-04-01 01:16:11.000000', 'consum', 0.0221, 'lps'),
	(478718, 125, '2015-04-01 01:16:12.000000', 'consum', 0.0229, 'lps'),
	(478719, 125, '2015-04-01 01:16:13.000000', 'consum', 0.0224, 'lps'),
	(478720, 125, '2015-04-01 01:16:14.000000', 'consum', 0.0225, 'lps'),
	(478721, 125, '2015-04-01 01:16:15.000000', 'consum', 0.0218, 'lps'),
	(478722, 125, '2015-04-01 01:16:16.000000', 'consum', 0.0229, 'lps'),
	(478723, 125, '2015-04-01 01:16:17.000000', 'consum', 0.0233, 'lps'),
	(478724, 125, '2015-04-01 01:16:18.000000', 'consum', 0.0222, 'lps'),
	(478725, 125, '2015-04-01 01:16:19.000000', 'consum', 0.0223, 'lps'),
	(478726, 125, '2015-04-01 01:16:20.000000', 'consum', 0.0217, 'lps'),
	(478727, 125, '2015-04-01 01:16:21.000000', 'consum', 0.0232, 'lps'),
	(478728, 125, '2015-04-01 01:16:22.000000', 'consum', 0.0227, 'lps'),
	(478729, 125, '2015-04-01 01:16:23.000000', 'consum', 0.0227, 'lps'),
	(478730, 125, '2015-04-01 01:16:24.000000', 'consum', 0.0223, 'lps'),
	(478731, 125, '2015-04-01 01:16:25.000000', 'consum', 0.0225, 'lps'),
	(478732, 125, '2015-04-01 01:16:26.000000', 'consum', 0.0220, 'lps'),
	(478733, 125, '2015-04-01 01:16:27.000000', 'consum', 0.0217, 'lps'),
	(478734, 125, '2015-04-01 01:16:28.000000', 'consum', 0.0216, 'lps'),
	(478735, 125, '2015-04-01 01:16:29.000000', 'consum', 0.0220, 'lps'),
	(478736, 125, '2015-04-01 01:16:30.000000', 'consum', 0.0216, 'lps'),
	(478737, 125, '2015-04-01 01:16:31.000000', 'consum', 0.0211, 'lps'),
	(478738, 125, '2015-04-01 01:16:32.000000', 'consum', 0.0223, 'lps'),
	(478739, 125, '2015-04-01 01:16:33.000000', 'consum', 0.0222, 'lps'),
	(478740, 125, '2015-04-01 01:16:34.000000', 'consum', 0.0210, 'lps'),
	(478741, 125, '2015-04-01 01:16:35.000000', 'consum', 0.0220, 'lps'),
	(478742, 125, '2015-04-01 01:16:36.000000', 'consum', 0.0214, 'lps'),
	(478743, 125, '2015-04-01 01:16:37.000000', 'consum', 0.0223, 'lps'),
	(478744, 125, '2015-04-01 01:16:38.000000', 'consum', 0.0216, 'lps'),
	(478745, 125, '2015-04-01 01:16:39.000000', 'consum', 0.0224, 'lps'),
	(478746, 125, '2015-04-01 01:16:40.000000', 'consum', 0.0218, 'lps'),
	(478747, 125, '2015-04-01 01:16:41.000000', 'consum', 0.0230, 'lps'),
	(478748, 125, '2015-04-01 01:16:42.000000', 'consum', 0.0215, 'lps'),
	(478749, 125, '2015-04-01 01:16:43.000000', 'consum', 0.0222, 'lps'),
	(478750, 125, '2015-04-01 01:16:44.000000', 'consum', 0.0210, 'lps'),
	(478751, 125, '2015-04-01 01:16:45.000000', 'consum', 0.0220, 'lps'),
	(478752, 125, '2015-04-01 01:16:46.000000', 'consum', 0.0215, 'lps'),
	(478753, 125, '2015-04-01 01:16:47.000000', 'consum', 0.0229, 'lps'),
	(478754, 125, '2015-04-01 01:16:48.000000', 'consum', 0.0217, 'lps'),
	(478755, 125, '2015-04-01 01:16:49.000000', 'consum', 0.0214, 'lps'),
	(478756, 125, '2015-04-01 01:16:50.000000', 'consum', 0.0233, 'lps'),
	(478757, 125, '2015-04-01 01:16:51.000000', 'consum', 0.0216, 'lps'),
	(478758, 125, '2015-04-01 01:16:52.000000', 'consum', 0.0222, 'lps'),
	(478759, 125, '2015-04-01 01:16:53.000000', 'consum', 0.0229, 'lps'),
	(478760, 125, '2015-04-01 01:16:54.000000', 'consum', 0.0220, 'lps'),
	(478761, 125, '2015-04-01 01:16:55.000000', 'consum', 0.0229, 'lps'),
	(478762, 125, '2015-04-01 01:16:56.000000', 'consum', 0.0228, 'lps'),
	(478763, 125, '2015-04-01 01:16:57.000000', 'consum', 0.0220, 'lps'),
	(478764, 125, '2015-04-01 01:16:58.000000', 'consum', 0.0228, 'lps'),
	(478765, 125, '2015-04-01 01:16:59.000000', 'consum', 0.0223, 'lps'),
	(478766, 125, '2015-04-01 01:17:00.000000', 'consum', 0.0224, 'lps'),
	(478767, 125, '2015-04-01 01:17:01.000000', 'consum', 0.0214, 'lps'),
	(478768, 125, '2015-04-01 01:17:02.000000', 'consum', 0.0215, 'lps'),
	(478769, 125, '2015-04-01 01:17:03.000000', 'consum', 0.0225, 'lps'),
	(478770, 125, '2015-04-01 01:17:04.000000', 'consum', 0.0220, 'lps'),
	(478771, 125, '2015-04-01 01:17:05.000000', 'consum', 0.0217, 'lps'),
	(478772, 125, '2015-04-01 01:17:06.000000', 'consum', 0.0214, 'lps'),
	(478773, 125, '2015-04-01 01:17:07.000000', 'consum', 0.0212, 'lps'),
	(478774, 125, '2015-04-01 01:17:08.000000', 'consum', 0.0231, 'lps'),
	(478775, 125, '2015-04-01 01:17:09.000000', 'consum', 0.0216, 'lps'),
	(478776, 125, '2015-04-01 01:17:10.000000', 'consum', 0.0223, 'lps'),
	(478777, 125, '2015-04-01 01:17:11.000000', 'consum', 0.0232, 'lps'),
	(478778, 125, '2015-04-01 01:17:12.000000', 'consum', 0.0212, 'lps'),
	(478779, 125, '2015-04-01 01:17:13.000000', 'consum', 0.0226, 'lps'),
	(478780, 125, '2015-04-01 01:17:14.000000', 'consum', 0.0214, 'lps'),
	(478781, 125, '2015-04-01 01:17:15.000000', 'consum', 0.0228, 'lps'),
	(478782, 125, '2015-04-01 01:17:16.000000', 'consum', 0.0216, 'lps'),
	(478783, 125, '2015-04-01 01:17:17.000000', 'consum', 0.0211, 'lps'),
	(478784, 125, '2015-04-01 01:17:18.000000', 'consum', 0.0222, 'lps'),
	(478785, 125, '2015-04-01 01:17:19.000000', 'consum', 0.0220, 'lps'),
	(478786, 125, '2015-04-01 01:17:20.000000', 'consum', 0.0225, 'lps'),
	(478787, 125, '2015-04-01 01:17:21.000000', 'consum', 0.0233, 'lps'),
	(478788, 125, '2015-04-01 01:17:22.000000', 'consum', 0.0229, 'lps'),
	(478789, 125, '2015-04-01 01:17:23.000000', 'consum', 0.0214, 'lps'),
	(478790, 125, '2015-04-01 01:17:24.000000', 'consum', 0.0223, 'lps'),
	(478791, 125, '2015-04-01 01:17:25.000000', 'consum', 0.0213, 'lps'),
	(478792, 125, '2015-04-01 01:17:26.000000', 'consum', 0.0212, 'lps'),
	(478793, 125, '2015-04-01 01:17:27.000000', 'consum', 0.0210, 'lps'),
	(478794, 125, '2015-04-01 01:17:28.000000', 'consum', 0.0230, 'lps'),
	(478795, 125, '2015-04-01 01:17:29.000000', 'consum', 0.0213, 'lps'),
	(478796, 125, '2015-04-01 01:17:30.000000', 'consum', 0.0214, 'lps'),
	(478797, 125, '2015-04-01 01:17:31.000000', 'consum', 0.0223, 'lps'),
	(478798, 125, '2015-04-01 01:17:32.000000', 'consum', 0.0214, 'lps'),
	(478799, 125, '2015-04-01 01:17:33.000000', 'consum', 0.0215, 'lps'),
	(478800, 125, '2015-04-01 01:17:34.000000', 'consum', 0.0225, 'lps'),
	(478801, 125, '2015-04-01 01:17:35.000000', 'consum', 0.0223, 'lps'),
	(478802, 125, '2015-04-01 01:17:36.000000', 'consum', 0.0230, 'lps'),
	(478803, 125, '2015-04-01 01:17:37.000000', 'consum', 0.0222, 'lps'),
	(478804, 125, '2015-04-01 01:17:38.000000', 'consum', 0.0212, 'lps'),
	(478805, 125, '2015-04-01 01:17:39.000000', 'consum', 0.0231, 'lps'),
	(478806, 125, '2015-04-01 01:17:40.000000', 'consum', 0.0214, 'lps'),
	(478807, 125, '2015-04-01 01:17:41.000000', 'consum', 0.0214, 'lps'),
	(478808, 125, '2015-04-01 01:17:42.000000', 'consum', 0.0222, 'lps'),
	(478809, 125, '2015-04-01 01:17:43.000000', 'consum', 0.0231, 'lps'),
	(478810, 125, '2015-04-01 01:17:44.000000', 'consum', 0.0233, 'lps'),
	(478811, 125, '2015-04-01 01:17:45.000000', 'consum', 0.0216, 'lps'),
	(478812, 125, '2015-04-01 01:17:46.000000', 'consum', 0.0219, 'lps'),
	(478813, 125, '2015-04-01 01:17:47.000000', 'consum', 0.0215, 'lps'),
	(478814, 125, '2015-04-01 01:17:48.000000', 'consum', 0.0232, 'lps'),
	(478815, 125, '2015-04-01 01:17:49.000000', 'consum', 0.0232, 'lps'),
	(478816, 125, '2015-04-01 01:17:50.000000', 'consum', 0.0233, 'lps'),
	(478817, 125, '2015-04-01 01:17:51.000000', 'consum', 0.0211, 'lps'),
	(478818, 125, '2015-04-01 01:17:52.000000', 'consum', 0.0219, 'lps'),
	(478819, 125, '2015-04-01 01:17:53.000000', 'consum', 0.0228, 'lps'),
	(478820, 125, '2015-04-01 01:17:54.000000', 'consum', 0.0225, 'lps'),
	(478821, 125, '2015-04-01 01:17:55.000000', 'consum', 0.0230, 'lps'),
	(478822, 125, '2015-04-01 01:17:56.000000', 'consum', 0.0220, 'lps'),
	(478823, 125, '2015-04-01 01:17:57.000000', 'consum', 0.0223, 'lps'),
	(478824, 125, '2015-04-01 01:17:58.000000', 'consum', 0.0222, 'lps'),
	(478825, 125, '2015-04-01 01:17:59.000000', 'consum', 0.0230, 'lps'),
	(478826, 125, '2015-04-01 01:18:00.000000', 'consum', 0.0228, 'lps'),
	(478827, 125, '2015-04-01 01:18:01.000000', 'consum', 0.0217, 'lps'),
	(478828, 125, '2015-04-01 01:18:02.000000', 'consum', 0.0217, 'lps'),
	(478829, 125, '2015-04-01 01:18:03.000000', 'consum', 0.0221, 'lps'),
	(478830, 125, '2015-04-01 01:18:04.000000', 'consum', 0.0222, 'lps'),
	(478831, 125, '2015-04-01 01:18:05.000000', 'consum', 0.0212, 'lps'),
	(478832, 125, '2015-04-01 01:18:06.000000', 'consum', 0.0211, 'lps'),
	(478833, 125, '2015-04-01 01:18:07.000000', 'consum', 0.0231, 'lps'),
	(478834, 125, '2015-04-01 01:18:08.000000', 'consum', 0.0217, 'lps'),
	(478835, 125, '2015-04-01 01:18:09.000000', 'consum', 0.0232, 'lps'),
	(478836, 125, '2015-04-01 01:18:10.000000', 'consum', 0.0228, 'lps'),
	(478837, 125, '2015-04-01 01:18:11.000000', 'consum', 0.0233, 'lps'),
	(478838, 125, '2015-04-01 01:18:12.000000', 'consum', 0.0224, 'lps'),
	(478839, 125, '2015-04-01 01:18:13.000000', 'consum', 0.0212, 'lps'),
	(478840, 125, '2015-04-01 01:18:14.000000', 'consum', 0.0225, 'lps'),
	(478841, 125, '2015-04-01 01:18:15.000000', 'consum', 0.0233, 'lps'),
	(478842, 125, '2015-04-01 01:18:16.000000', 'consum', 0.0233, 'lps'),
	(478843, 125, '2015-04-01 01:18:17.000000', 'consum', 0.0231, 'lps'),
	(478844, 125, '2015-04-01 01:18:18.000000', 'consum', 0.0221, 'lps'),
	(478845, 125, '2015-04-01 01:18:19.000000', 'consum', 0.0229, 'lps'),
	(478846, 125, '2015-04-01 01:18:20.000000', 'consum', 0.0224, 'lps'),
	(478847, 125, '2015-04-01 01:18:21.000000', 'consum', 0.0225, 'lps'),
	(478848, 125, '2015-04-01 01:18:22.000000', 'consum', 0.0217, 'lps'),
	(478849, 125, '2015-04-01 01:18:23.000000', 'consum', 0.0224, 'lps'),
	(478850, 125, '2015-04-01 01:18:24.000000', 'consum', 0.0213, 'lps'),
	(478851, 125, '2015-04-01 01:18:25.000000', 'consum', 0.0232, 'lps'),
	(478852, 125, '2015-04-01 01:18:26.000000', 'consum', 0.0217, 'lps'),
	(478853, 125, '2015-04-01 01:18:27.000000', 'consum', 0.0226, 'lps'),
	(478854, 125, '2015-04-01 01:18:28.000000', 'consum', 0.0220, 'lps'),
	(478855, 125, '2015-04-01 01:18:29.000000', 'consum', 0.0214, 'lps'),
	(478856, 125, '2015-04-01 01:18:30.000000', 'consum', 0.0223, 'lps'),
	(478857, 125, '2015-04-01 01:18:31.000000', 'consum', 0.0217, 'lps'),
	(478858, 125, '2015-04-01 01:18:32.000000', 'consum', 0.0228, 'lps'),
	(478859, 125, '2015-04-01 01:18:33.000000', 'consum', 0.0211, 'lps'),
	(478860, 125, '2015-04-01 01:18:34.000000', 'consum', 0.0230, 'lps'),
	(478861, 125, '2015-04-01 01:18:35.000000', 'consum', 0.0215, 'lps'),
	(478862, 125, '2015-04-01 01:18:36.000000', 'consum', 0.0220, 'lps'),
	(478863, 125, '2015-04-01 01:18:37.000000', 'consum', 0.0223, 'lps'),
	(478864, 125, '2015-04-01 01:18:38.000000', 'consum', 0.0220, 'lps'),
	(478865, 125, '2015-04-01 01:18:39.000000', 'consum', 0.0224, 'lps'),
	(478866, 125, '2015-04-01 01:18:40.000000', 'consum', 0.0225, 'lps'),
	(478867, 125, '2015-04-01 01:18:41.000000', 'consum', 0.0218, 'lps'),
	(478868, 125, '2015-04-01 01:18:42.000000', 'consum', 0.0232, 'lps'),
	(478869, 125, '2015-04-01 01:18:43.000000', 'consum', 0.0224, 'lps'),
	(478870, 125, '2015-04-01 01:18:44.000000', 'consum', 0.0213, 'lps'),
	(478871, 125, '2015-04-01 01:18:45.000000', 'consum', 0.0210, 'lps'),
	(478872, 125, '2015-04-01 01:18:46.000000', 'consum', 0.0226, 'lps'),
	(478873, 125, '2015-04-01 01:18:47.000000', 'consum', 0.0215, 'lps'),
	(478874, 125, '2015-04-01 01:18:48.000000', 'consum', 0.0215, 'lps'),
	(478875, 125, '2015-04-01 01:18:49.000000', 'consum', 0.0218, 'lps'),
	(478876, 125, '2015-04-01 01:18:50.000000', 'consum', 0.0212, 'lps'),
	(478877, 125, '2015-04-01 01:18:51.000000', 'consum', 0.0219, 'lps'),
	(478878, 125, '2015-04-01 01:18:52.000000', 'consum', 0.0227, 'lps'),
	(478879, 125, '2015-04-01 01:18:53.000000', 'consum', 0.0221, 'lps'),
	(478880, 125, '2015-04-01 01:18:54.000000', 'consum', 0.0213, 'lps'),
	(478881, 125, '2015-04-01 01:18:55.000000', 'consum', 0.0215, 'lps'),
	(478882, 125, '2015-04-01 01:18:56.000000', 'consum', 0.0229, 'lps'),
	(478883, 125, '2015-04-01 01:18:57.000000', 'consum', 0.0218, 'lps'),
	(478884, 125, '2015-04-01 01:18:58.000000', 'consum', 0.0215, 'lps'),
	(478885, 125, '2015-04-01 01:18:59.000000', 'consum', 0.0215, 'lps'),
	(478886, 125, '2015-04-01 01:19:00.000000', 'consum', 0.0220, 'lps'),
	(478887, 125, '2015-04-01 01:19:01.000000', 'consum', 0.0220, 'lps'),
	(478888, 125, '2015-04-01 01:19:02.000000', 'consum', 0.0232, 'lps'),
	(478889, 125, '2015-04-01 01:19:03.000000', 'consum', 0.0220, 'lps'),
	(478890, 125, '2015-04-01 01:19:04.000000', 'consum', 0.0216, 'lps'),
	(478891, 125, '2015-04-01 01:19:05.000000', 'consum', 0.0212, 'lps'),
	(478892, 125, '2015-04-01 01:19:06.000000', 'consum', 0.0226, 'lps'),
	(478893, 125, '2015-04-01 01:19:07.000000', 'consum', 0.0213, 'lps'),
	(478894, 125, '2015-04-01 01:19:08.000000', 'consum', 0.0224, 'lps'),
	(478895, 125, '2015-04-01 01:19:09.000000', 'consum', 0.0226, 'lps'),
	(478896, 125, '2015-04-01 01:19:10.000000', 'consum', 0.0223, 'lps'),
	(478897, 125, '2015-04-01 01:19:11.000000', 'consum', 0.0227, 'lps'),
	(478898, 125, '2015-04-01 01:19:12.000000', 'consum', 0.0231, 'lps'),
	(478899, 125, '2015-04-01 01:19:13.000000', 'consum', 0.0218, 'lps'),
	(478900, 125, '2015-04-01 01:19:14.000000', 'consum', 0.0211, 'lps'),
	(478901, 125, '2015-04-01 01:19:15.000000', 'consum', 0.0215, 'lps'),
	(478902, 125, '2015-04-01 01:19:16.000000', 'consum', 0.0210, 'lps'),
	(478903, 125, '2015-04-01 01:19:17.000000', 'consum', 0.0220, 'lps'),
	(478904, 125, '2015-04-01 01:19:18.000000', 'consum', 0.0212, 'lps'),
	(478905, 125, '2015-04-01 01:19:19.000000', 'consum', 0.0215, 'lps'),
	(478906, 125, '2015-04-01 01:19:20.000000', 'consum', 0.0230, 'lps'),
	(478907, 125, '2015-04-01 01:19:21.000000', 'consum', 0.0224, 'lps'),
	(478908, 125, '2015-04-01 01:19:22.000000', 'consum', 0.0218, 'lps'),
	(478909, 125, '2015-04-01 01:19:23.000000', 'consum', 0.0232, 'lps'),
	(478910, 125, '2015-04-01 01:19:24.000000', 'consum', 0.0226, 'lps'),
	(478911, 125, '2015-04-01 01:19:25.000000', 'consum', 0.0224, 'lps'),
	(478912, 125, '2015-04-01 01:19:26.000000', 'consum', 0.0210, 'lps'),
	(478913, 125, '2015-04-01 01:19:27.000000', 'consum', 0.0215, 'lps'),
	(478914, 125, '2015-04-01 01:19:28.000000', 'consum', 0.0212, 'lps'),
	(478915, 125, '2015-04-01 01:19:29.000000', 'consum', 0.0231, 'lps'),
	(478916, 125, '2015-04-01 01:19:30.000000', 'consum', 0.0213, 'lps'),
	(478917, 125, '2015-04-01 01:19:31.000000', 'consum', 0.0233, 'lps'),
	(478918, 125, '2015-04-01 01:19:32.000000', 'consum', 0.0219, 'lps'),
	(478919, 125, '2015-04-01 01:19:33.000000', 'consum', 0.0213, 'lps'),
	(478920, 125, '2015-04-01 01:19:34.000000', 'consum', 0.0223, 'lps'),
	(478921, 125, '2015-04-01 01:19:35.000000', 'consum', 0.0218, 'lps'),
	(478922, 125, '2015-04-01 01:19:36.000000', 'consum', 0.0212, 'lps'),
	(478923, 125, '2015-04-01 01:19:37.000000', 'consum', 0.0220, 'lps'),
	(478924, 125, '2015-04-01 01:19:38.000000', 'consum', 0.0231, 'lps'),
	(478925, 125, '2015-04-01 01:19:39.000000', 'consum', 0.0215, 'lps'),
	(478926, 125, '2015-04-01 01:19:40.000000', 'consum', 0.0218, 'lps'),
	(478927, 125, '2015-04-01 01:19:41.000000', 'consum', 0.0214, 'lps'),
	(478928, 125, '2015-04-01 01:19:42.000000', 'consum', 0.0228, 'lps'),
	(478929, 125, '2015-04-01 01:19:43.000000', 'consum', 0.0216, 'lps'),
	(478930, 125, '2015-04-01 01:19:44.000000', 'consum', 0.0213, 'lps'),
	(478931, 125, '2015-04-01 01:19:45.000000', 'consum', 0.0230, 'lps'),
	(478932, 125, '2015-04-01 01:19:46.000000', 'consum', 0.0230, 'lps'),
	(478933, 125, '2015-04-01 01:19:47.000000', 'consum', 0.0228, 'lps'),
	(478934, 125, '2015-04-01 01:19:48.000000', 'consum', 0.0215, 'lps'),
	(478935, 125, '2015-04-01 01:19:49.000000', 'consum', 0.0229, 'lps'),
	(478936, 125, '2015-04-01 01:19:50.000000', 'consum', 0.0219, 'lps'),
	(478937, 125, '2015-04-01 01:19:51.000000', 'consum', 0.0220, 'lps'),
	(478938, 125, '2015-04-01 01:19:52.000000', 'consum', 0.0213, 'lps'),
	(478939, 125, '2015-04-01 01:19:53.000000', 'consum', 0.0220, 'lps'),
	(478940, 125, '2015-04-01 01:19:54.000000', 'consum', 0.0226, 'lps'),
	(478941, 125, '2015-04-01 01:19:55.000000', 'consum', 0.0211, 'lps'),
	(478942, 125, '2015-04-01 01:19:56.000000', 'consum', 0.0217, 'lps'),
	(478943, 125, '2015-04-01 01:19:57.000000', 'consum', 0.0218, 'lps'),
	(478944, 125, '2015-04-01 01:19:58.000000', 'consum', 0.0228, 'lps'),
	(478945, 125, '2015-04-01 01:19:59.000000', 'consum', 0.0231, 'lps'),
	(478946, 125, '2015-04-01 01:20:00.000000', 'consum', 0.0214, 'lps'),
	(478947, 125, '2015-04-01 01:20:01.000000', 'consum', 0.0216, 'lps'),
	(478948, 125, '2015-04-01 01:20:02.000000', 'consum', 0.0229, 'lps'),
	(478949, 125, '2015-04-01 01:20:03.000000', 'consum', 0.0213, 'lps'),
	(478950, 125, '2015-04-01 01:20:04.000000', 'consum', 0.0219, 'lps'),
	(478951, 125, '2015-04-01 01:20:05.000000', 'consum', 0.0223, 'lps'),
	(478952, 125, '2015-04-01 01:20:06.000000', 'consum', 0.0225, 'lps'),
	(478953, 125, '2015-04-01 01:20:07.000000', 'consum', 0.0223, 'lps'),
	(478954, 125, '2015-04-01 01:20:08.000000', 'consum', 0.0230, 'lps'),
	(478955, 125, '2015-04-01 01:20:09.000000', 'consum', 0.0222, 'lps'),
	(478956, 125, '2015-04-01 01:20:10.000000', 'consum', 0.0212, 'lps'),
	(478957, 125, '2015-04-01 01:20:11.000000', 'consum', 0.0230, 'lps'),
	(478958, 125, '2015-04-01 01:20:12.000000', 'consum', 0.0212, 'lps'),
	(478959, 125, '2015-04-01 01:20:13.000000', 'consum', 0.0229, 'lps'),
	(478960, 125, '2015-04-01 01:20:14.000000', 'consum', 0.0229, 'lps'),
	(478961, 125, '2015-04-01 01:20:15.000000', 'consum', 0.0225, 'lps'),
	(478962, 125, '2015-04-01 01:20:16.000000', 'consum', 0.0226, 'lps'),
	(478963, 125, '2015-04-01 01:20:17.000000', 'consum', 0.0224, 'lps'),
	(478964, 125, '2015-04-01 01:20:18.000000', 'consum', 0.0231, 'lps'),
	(478965, 125, '2015-04-01 01:20:19.000000', 'consum', 0.0227, 'lps'),
	(478966, 125, '2015-04-01 01:20:20.000000', 'consum', 0.0233, 'lps'),
	(478967, 125, '2015-04-01 01:20:21.000000', 'consum', 0.0226, 'lps'),
	(478968, 125, '2015-04-01 01:20:22.000000', 'consum', 0.0222, 'lps'),
	(478969, 125, '2015-04-01 01:20:23.000000', 'consum', 0.0221, 'lps'),
	(478970, 125, '2015-04-01 01:20:24.000000', 'consum', 0.0228, 'lps'),
	(478971, 125, '2015-04-01 01:20:25.000000', 'consum', 0.0223, 'lps'),
	(478972, 125, '2015-04-01 01:20:26.000000', 'consum', 0.0220, 'lps'),
	(478973, 125, '2015-04-01 01:20:27.000000', 'consum', 0.0221, 'lps'),
	(478974, 125, '2015-04-01 01:20:28.000000', 'consum', 0.0211, 'lps'),
	(478975, 125, '2015-04-01 01:20:29.000000', 'consum', 0.0233, 'lps'),
	(478976, 125, '2015-04-01 01:20:30.000000', 'consum', 0.0224, 'lps'),
	(478977, 125, '2015-04-01 01:20:31.000000', 'consum', 0.0214, 'lps'),
	(478978, 125, '2015-04-01 01:20:32.000000', 'consum', 0.0233, 'lps'),
	(478979, 125, '2015-04-01 01:20:33.000000', 'consum', 0.0220, 'lps'),
	(478980, 125, '2015-04-01 01:20:34.000000', 'consum', 0.0216, 'lps'),
	(478981, 125, '2015-04-01 01:20:35.000000', 'consum', 0.0210, 'lps'),
	(478982, 125, '2015-04-01 01:20:36.000000', 'consum', 0.0217, 'lps'),
	(478983, 125, '2015-04-01 01:20:37.000000', 'consum', 0.0221, 'lps'),
	(478984, 125, '2015-04-01 01:20:38.000000', 'consum', 0.0221, 'lps'),
	(478985, 125, '2015-04-01 01:20:39.000000', 'consum', 0.0230, 'lps'),
	(478986, 125, '2015-04-01 01:20:40.000000', 'consum', 0.0231, 'lps'),
	(478987, 125, '2015-04-01 01:20:41.000000', 'consum', 0.0233, 'lps'),
	(478988, 125, '2015-04-01 01:20:42.000000', 'consum', 0.0215, 'lps'),
	(478989, 125, '2015-04-01 01:20:43.000000', 'consum', 0.0213, 'lps'),
	(478990, 125, '2015-04-01 01:20:44.000000', 'consum', 0.0213, 'lps'),
	(478991, 125, '2015-04-01 01:20:45.000000', 'consum', 0.0214, 'lps'),
	(478992, 125, '2015-04-01 01:20:46.000000', 'consum', 0.0224, 'lps'),
	(478993, 125, '2015-04-01 01:20:47.000000', 'consum', 0.0220, 'lps'),
	(478994, 125, '2015-04-01 01:20:48.000000', 'consum', 0.0217, 'lps'),
	(478995, 125, '2015-04-01 01:20:49.000000', 'consum', 0.0217, 'lps'),
	(478996, 125, '2015-04-01 01:20:50.000000', 'consum', 0.0223, 'lps'),
	(478997, 125, '2015-04-01 01:20:51.000000', 'consum', 0.0232, 'lps'),
	(478998, 125, '2015-04-01 01:20:52.000000', 'consum', 0.0231, 'lps'),
	(478999, 125, '2015-04-01 01:20:53.000000', 'consum', 0.0226, 'lps'),
	(479000, 125, '2015-04-01 01:20:54.000000', 'consum', 0.0229, 'lps'),
	(479001, 125, '2015-04-01 01:20:55.000000', 'consum', 0.0231, 'lps'),
	(479002, 125, '2015-04-01 01:20:56.000000', 'consum', 0.0213, 'lps'),
	(479003, 125, '2015-04-01 01:20:57.000000', 'consum', 0.0211, 'lps'),
	(479004, 125, '2015-04-01 01:20:58.000000', 'consum', 0.0230, 'lps'),
	(479005, 125, '2015-04-01 01:20:59.000000', 'consum', 0.0212, 'lps'),
	(479006, 125, '2015-04-01 01:21:00.000000', 'consum', 0.0210, 'lps'),
	(479007, 125, '2015-04-01 01:21:01.000000', 'consum', 0.0226, 'lps'),
	(479008, 125, '2015-04-01 01:21:02.000000', 'consum', 0.0221, 'lps'),
	(479009, 125, '2015-04-01 01:21:03.000000', 'consum', 0.0215, 'lps'),
	(479010, 125, '2015-04-01 01:21:04.000000', 'consum', 0.0229, 'lps'),
	(479011, 125, '2015-04-01 01:21:05.000000', 'consum', 0.0217, 'lps'),
	(479012, 125, '2015-04-01 01:21:06.000000', 'consum', 0.0213, 'lps'),
	(479013, 125, '2015-04-01 01:21:07.000000', 'consum', 0.0229, 'lps'),
	(479014, 125, '2015-04-01 01:21:08.000000', 'consum', 0.0224, 'lps'),
	(479015, 125, '2015-04-01 01:21:09.000000', 'consum', 0.0225, 'lps'),
	(479016, 125, '2015-04-01 01:21:10.000000', 'consum', 0.0220, 'lps'),
	(479017, 125, '2015-04-01 01:21:11.000000', 'consum', 0.0216, 'lps'),
	(479018, 125, '2015-04-01 01:21:12.000000', 'consum', 0.0232, 'lps'),
	(479019, 125, '2015-04-01 01:21:13.000000', 'consum', 0.0232, 'lps'),
	(479020, 125, '2015-04-01 01:21:14.000000', 'consum', 0.0231, 'lps'),
	(479021, 125, '2015-04-01 01:21:15.000000', 'consum', 0.0224, 'lps'),
	(479022, 125, '2015-04-01 01:21:16.000000', 'consum', 0.0219, 'lps'),
	(479023, 125, '2015-04-01 01:21:17.000000', 'consum', 0.0215, 'lps'),
	(479024, 125, '2015-04-01 01:21:18.000000', 'consum', 0.0230, 'lps'),
	(479025, 125, '2015-04-01 01:21:19.000000', 'consum', 0.0223, 'lps'),
	(479026, 125, '2015-04-01 01:21:20.000000', 'consum', 0.0216, 'lps'),
	(479027, 125, '2015-04-01 01:21:21.000000', 'consum', 0.0224, 'lps'),
	(479028, 125, '2015-04-01 01:21:22.000000', 'consum', 0.0215, 'lps'),
	(479029, 125, '2015-04-01 01:21:23.000000', 'consum', 0.0219, 'lps'),
	(479030, 125, '2015-04-01 01:21:24.000000', 'consum', 0.0218, 'lps'),
	(479031, 125, '2015-04-01 01:21:25.000000', 'consum', 0.0222, 'lps'),
	(479032, 125, '2015-04-01 01:21:26.000000', 'consum', 0.0220, 'lps'),
	(479033, 125, '2015-04-01 01:21:27.000000', 'consum', 0.0228, 'lps'),
	(479034, 125, '2015-04-01 01:21:28.000000', 'consum', 0.0223, 'lps'),
	(479035, 125, '2015-04-01 01:21:29.000000', 'consum', 0.0219, 'lps'),
	(479036, 125, '2015-04-01 01:21:30.000000', 'consum', 0.0216, 'lps'),
	(479037, 125, '2015-04-01 01:21:31.000000', 'consum', 0.0216, 'lps'),
	(479038, 125, '2015-04-01 01:21:32.000000', 'consum', 0.0221, 'lps'),
	(479039, 125, '2015-04-01 01:21:33.000000', 'consum', 0.0224, 'lps'),
	(479040, 125, '2015-04-01 01:21:34.000000', 'consum', 0.0224, 'lps'),
	(479041, 125, '2015-04-01 01:21:35.000000', 'consum', 0.0216, 'lps'),
	(479042, 125, '2015-04-01 01:21:36.000000', 'consum', 0.0220, 'lps'),
	(479043, 125, '2015-04-01 01:21:37.000000', 'consum', 0.0221, 'lps'),
	(479044, 125, '2015-04-01 01:21:38.000000', 'consum', 0.0233, 'lps'),
	(479045, 125, '2015-04-01 01:21:39.000000', 'consum', 0.0223, 'lps'),
	(479046, 125, '2015-04-01 01:21:40.000000', 'consum', 0.0229, 'lps'),
	(479047, 125, '2015-04-01 01:21:41.000000', 'consum', 0.0218, 'lps'),
	(479048, 125, '2015-04-01 01:21:42.000000', 'consum', 0.0220, 'lps'),
	(479049, 125, '2015-04-01 01:21:43.000000', 'consum', 0.0233, 'lps'),
	(479050, 125, '2015-04-01 01:21:44.000000', 'consum', 0.0225, 'lps'),
	(479051, 125, '2015-04-01 01:21:45.000000', 'consum', 0.0218, 'lps'),
	(479052, 125, '2015-04-01 01:21:46.000000', 'consum', 0.0229, 'lps'),
	(479053, 125, '2015-04-01 01:21:47.000000', 'consum', 0.0210, 'lps'),
	(479054, 125, '2015-04-01 01:21:48.000000', 'consum', 0.0224, 'lps'),
	(479055, 125, '2015-04-01 01:21:49.000000', 'consum', 0.0232, 'lps'),
	(479056, 125, '2015-04-01 01:21:50.000000', 'consum', 0.0231, 'lps'),
	(479057, 125, '2015-04-01 01:21:51.000000', 'consum', 0.0225, 'lps'),
	(479058, 125, '2015-04-01 01:21:52.000000', 'consum', 0.0223, 'lps'),
	(479059, 125, '2015-04-01 01:21:53.000000', 'consum', 0.0231, 'lps'),
	(479060, 125, '2015-04-01 01:21:54.000000', 'consum', 0.0227, 'lps'),
	(479061, 125, '2015-04-01 01:21:55.000000', 'consum', 0.0211, 'lps'),
	(479062, 125, '2015-04-01 01:21:56.000000', 'consum', 0.0233, 'lps'),
	(479063, 125, '2015-04-01 01:21:57.000000', 'consum', 0.0229, 'lps'),
	(479064, 125, '2015-04-01 01:21:58.000000', 'consum', 0.0211, 'lps'),
	(479065, 125, '2015-04-01 01:21:59.000000', 'consum', 0.0232, 'lps'),
	(479066, 125, '2015-04-01 01:22:00.000000', 'consum', 0.0220, 'lps'),
	(479067, 125, '2015-04-01 01:22:01.000000', 'consum', 0.0220, 'lps'),
	(479068, 125, '2015-04-01 01:22:02.000000', 'consum', 0.0230, 'lps'),
	(479069, 125, '2015-04-01 01:22:03.000000', 'consum', 0.0231, 'lps'),
	(479070, 125, '2015-04-01 01:22:04.000000', 'consum', 0.0210, 'lps'),
	(479071, 125, '2015-04-01 01:22:05.000000', 'consum', 0.0217, 'lps'),
	(479072, 125, '2015-04-01 01:22:06.000000', 'consum', 0.0222, 'lps'),
	(479073, 125, '2015-04-01 01:22:07.000000', 'consum', 0.0226, 'lps'),
	(479074, 125, '2015-04-01 01:22:08.000000', 'consum', 0.0230, 'lps'),
	(479075, 125, '2015-04-01 01:22:09.000000', 'consum', 0.0216, 'lps'),
	(479076, 125, '2015-04-01 01:22:10.000000', 'consum', 0.0227, 'lps'),
	(479077, 125, '2015-04-01 01:22:11.000000', 'consum', 0.0229, 'lps'),
	(479078, 125, '2015-04-01 01:22:12.000000', 'consum', 0.0233, 'lps'),
	(479079, 125, '2015-04-01 01:22:13.000000', 'consum', 0.0218, 'lps'),
	(479080, 125, '2015-04-01 01:22:14.000000', 'consum', 0.0229, 'lps'),
	(479081, 125, '2015-04-01 01:22:15.000000', 'consum', 0.0212, 'lps'),
	(479082, 125, '2015-04-01 01:22:16.000000', 'consum', 0.0212, 'lps'),
	(479083, 125, '2015-04-01 01:22:17.000000', 'consum', 0.0213, 'lps'),
	(479084, 125, '2015-04-01 01:22:18.000000', 'consum', 0.0219, 'lps'),
	(479085, 125, '2015-04-01 01:22:19.000000', 'consum', 0.0222, 'lps'),
	(479086, 125, '2015-04-01 01:22:20.000000', 'consum', 0.0220, 'lps'),
	(479087, 125, '2015-04-01 01:22:21.000000', 'consum', 0.0226, 'lps'),
	(479088, 125, '2015-04-01 01:22:22.000000', 'consum', 0.0210, 'lps'),
	(479089, 125, '2015-04-01 01:22:23.000000', 'consum', 0.0214, 'lps'),
	(479090, 125, '2015-04-01 01:22:24.000000', 'consum', 0.0227, 'lps'),
	(479091, 125, '2015-04-01 01:22:25.000000', 'consum', 0.0215, 'lps'),
	(479092, 125, '2015-04-01 01:22:26.000000', 'consum', 0.0229, 'lps'),
	(479093, 125, '2015-04-01 01:22:27.000000', 'consum', 0.0222, 'lps'),
	(479094, 125, '2015-04-01 01:22:28.000000', 'consum', 0.0211, 'lps'),
	(479095, 125, '2015-04-01 01:22:29.000000', 'consum', 0.0230, 'lps'),
	(479096, 125, '2015-04-01 01:22:30.000000', 'consum', 0.0233, 'lps'),
	(479097, 125, '2015-04-01 01:22:31.000000', 'consum', 0.0218, 'lps'),
	(479098, 125, '2015-04-01 01:22:32.000000', 'consum', 0.0230, 'lps'),
	(479099, 125, '2015-04-01 01:22:33.000000', 'consum', 0.0214, 'lps'),
	(479100, 125, '2015-04-01 01:22:34.000000', 'consum', 0.0218, 'lps'),
	(479101, 125, '2015-04-01 01:22:35.000000', 'consum', 0.0216, 'lps'),
	(479102, 125, '2015-04-01 01:22:36.000000', 'consum', 0.0214, 'lps'),
	(479103, 125, '2015-04-01 01:22:37.000000', 'consum', 0.0215, 'lps'),
	(479104, 125, '2015-04-01 01:22:38.000000', 'consum', 0.0221, 'lps'),
	(479105, 125, '2015-04-01 01:22:39.000000', 'consum', 0.0227, 'lps'),
	(479106, 125, '2015-04-01 01:22:40.000000', 'consum', 0.0213, 'lps'),
	(479107, 125, '2015-04-01 01:22:41.000000', 'consum', 0.0225, 'lps'),
	(479108, 125, '2015-04-01 01:22:42.000000', 'consum', 0.0229, 'lps'),
	(479109, 125, '2015-04-01 01:22:43.000000', 'consum', 0.0211, 'lps'),
	(479110, 125, '2015-04-01 01:22:44.000000', 'consum', 0.0229, 'lps'),
	(479111, 125, '2015-04-01 01:22:45.000000', 'consum', 0.0232, 'lps'),
	(479112, 125, '2015-04-01 01:22:46.000000', 'consum', 0.0217, 'lps'),
	(479113, 125, '2015-04-01 01:22:47.000000', 'consum', 0.0228, 'lps'),
	(479114, 125, '2015-04-01 01:22:48.000000', 'consum', 0.0229, 'lps'),
	(479115, 125, '2015-04-01 01:22:49.000000', 'consum', 0.0227, 'lps'),
	(479116, 125, '2015-04-01 01:22:50.000000', 'consum', 0.0214, 'lps'),
	(479117, 125, '2015-04-01 01:22:51.000000', 'consum', 0.0228, 'lps'),
	(479118, 125, '2015-04-01 01:22:52.000000', 'consum', 0.0216, 'lps'),
	(479119, 125, '2015-04-01 01:22:53.000000', 'consum', 0.0213, 'lps'),
	(479120, 125, '2015-04-01 01:22:54.000000', 'consum', 0.0231, 'lps'),
	(479121, 125, '2015-04-01 01:22:55.000000', 'consum', 0.0210, 'lps'),
	(479122, 125, '2015-04-01 01:22:56.000000', 'consum', 0.0219, 'lps'),
	(479123, 125, '2015-04-01 01:22:57.000000', 'consum', 0.0231, 'lps'),
	(479124, 125, '2015-04-01 01:22:58.000000', 'consum', 0.0218, 'lps'),
	(479125, 125, '2015-04-01 01:22:59.000000', 'consum', 0.0211, 'lps'),
	(479126, 125, '2015-04-01 01:23:00.000000', 'consum', 0.0216, 'lps'),
	(479127, 125, '2015-04-01 01:23:01.000000', 'consum', 0.0211, 'lps'),
	(479128, 125, '2015-04-01 01:23:02.000000', 'consum', 0.0225, 'lps'),
	(479129, 125, '2015-04-01 01:23:03.000000', 'consum', 0.0233, 'lps'),
	(479130, 125, '2015-04-01 01:23:04.000000', 'consum', 0.0211, 'lps'),
	(479131, 125, '2015-04-01 01:23:05.000000', 'consum', 0.0215, 'lps'),
	(479132, 125, '2015-04-01 01:23:06.000000', 'consum', 0.0210, 'lps'),
	(479133, 125, '2015-04-01 01:23:07.000000', 'consum', 0.0220, 'lps'),
	(479134, 125, '2015-04-01 01:23:08.000000', 'consum', 0.0211, 'lps'),
	(479135, 125, '2015-04-01 01:23:09.000000', 'consum', 0.0233, 'lps'),
	(479136, 125, '2015-04-01 01:23:10.000000', 'consum', 0.0227, 'lps'),
	(479137, 125, '2015-04-01 01:23:11.000000', 'consum', 0.0229, 'lps'),
	(479138, 125, '2015-04-01 01:23:12.000000', 'consum', 0.0227, 'lps'),
	(479139, 125, '2015-04-01 01:23:13.000000', 'consum', 0.0215, 'lps'),
	(479140, 125, '2015-04-01 01:23:14.000000', 'consum', 0.0210, 'lps'),
	(479141, 125, '2015-04-01 01:23:15.000000', 'consum', 0.0219, 'lps'),
	(479142, 125, '2015-04-01 01:23:16.000000', 'consum', 0.0232, 'lps'),
	(479143, 125, '2015-04-01 01:23:17.000000', 'consum', 0.0221, 'lps'),
	(479144, 125, '2015-04-01 01:23:18.000000', 'consum', 0.0225, 'lps'),
	(479145, 125, '2015-04-01 01:23:19.000000', 'consum', 0.0229, 'lps'),
	(479146, 125, '2015-04-01 01:23:20.000000', 'consum', 0.0210, 'lps'),
	(479147, 125, '2015-04-01 01:23:21.000000', 'consum', 0.0226, 'lps'),
	(479148, 125, '2015-04-01 01:23:22.000000', 'consum', 0.0220, 'lps'),
	(479149, 125, '2015-04-01 01:23:23.000000', 'consum', 0.0211, 'lps'),
	(479150, 125, '2015-04-01 01:23:24.000000', 'consum', 0.0211, 'lps'),
	(479151, 125, '2015-04-01 01:23:25.000000', 'consum', 0.0211, 'lps'),
	(479152, 125, '2015-04-01 01:23:26.000000', 'consum', 0.0212, 'lps'),
	(479153, 125, '2015-04-01 01:23:27.000000', 'consum', 0.0220, 'lps'),
	(479154, 125, '2015-04-01 01:23:28.000000', 'consum', 0.0229, 'lps'),
	(479155, 125, '2015-04-01 01:23:29.000000', 'consum', 0.0227, 'lps'),
	(479156, 125, '2015-04-01 01:23:30.000000', 'consum', 0.0216, 'lps'),
	(479157, 125, '2015-04-01 01:23:31.000000', 'consum', 0.0214, 'lps'),
	(479158, 125, '2015-04-01 01:23:32.000000', 'consum', 0.0213, 'lps'),
	(479159, 125, '2015-04-01 01:23:33.000000', 'consum', 0.0211, 'lps'),
	(479160, 125, '2015-04-01 01:23:34.000000', 'consum', 0.0231, 'lps'),
	(479161, 125, '2015-04-01 01:23:35.000000', 'consum', 0.0219, 'lps'),
	(479162, 125, '2015-04-01 01:23:36.000000', 'consum', 0.0213, 'lps'),
	(479163, 125, '2015-04-01 01:23:37.000000', 'consum', 0.0224, 'lps'),
	(479164, 125, '2015-04-01 01:23:38.000000', 'consum', 0.0225, 'lps'),
	(479165, 125, '2015-04-01 01:23:39.000000', 'consum', 0.0218, 'lps'),
	(479166, 125, '2015-04-01 01:23:40.000000', 'consum', 0.0228, 'lps'),
	(479167, 125, '2015-04-01 01:23:41.000000', 'consum', 0.0229, 'lps'),
	(479168, 125, '2015-04-01 01:23:42.000000', 'consum', 0.0230, 'lps'),
	(479169, 125, '2015-04-01 01:23:43.000000', 'consum', 0.0227, 'lps'),
	(479170, 125, '2015-04-01 01:23:44.000000', 'consum', 0.0213, 'lps'),
	(479171, 125, '2015-04-01 01:23:45.000000', 'consum', 0.0224, 'lps'),
	(479172, 125, '2015-04-01 01:23:46.000000', 'consum', 0.0220, 'lps'),
	(479173, 125, '2015-04-01 01:23:47.000000', 'consum', 0.0222, 'lps'),
	(479174, 125, '2015-04-01 01:23:48.000000', 'consum', 0.0215, 'lps'),
	(479175, 125, '2015-04-01 01:23:49.000000', 'consum', 0.0225, 'lps'),
	(479176, 125, '2015-04-01 01:23:50.000000', 'consum', 0.0220, 'lps'),
	(479177, 125, '2015-04-01 01:23:51.000000', 'consum', 0.0217, 'lps'),
	(479178, 125, '2015-04-01 01:23:52.000000', 'consum', 0.0214, 'lps'),
	(479179, 125, '2015-04-01 01:23:53.000000', 'consum', 0.0210, 'lps'),
	(479180, 125, '2015-04-01 01:23:54.000000', 'consum', 0.0224, 'lps'),
	(479181, 125, '2015-04-01 01:23:55.000000', 'consum', 0.0230, 'lps'),
	(479182, 125, '2015-04-01 01:23:56.000000', 'consum', 0.0224, 'lps'),
	(479183, 125, '2015-04-01 01:23:57.000000', 'consum', 0.0217, 'lps'),
	(479184, 125, '2015-04-01 01:23:58.000000', 'consum', 0.0228, 'lps'),
	(479185, 125, '2015-04-01 01:23:59.000000', 'consum', 0.0231, 'lps'),
	(479186, 125, '2015-04-01 01:24:00.000000', 'consum', 0.0213, 'lps'),
	(479187, 125, '2015-04-01 01:24:01.000000', 'consum', 0.0212, 'lps'),
	(479188, 125, '2015-04-01 01:24:02.000000', 'consum', 0.0211, 'lps'),
	(479189, 125, '2015-04-01 01:24:03.000000', 'consum', 0.0233, 'lps'),
	(479190, 125, '2015-04-01 01:24:04.000000', 'consum', 0.0229, 'lps'),
	(479191, 125, '2015-04-01 01:24:05.000000', 'consum', 0.0210, 'lps'),
	(479192, 125, '2015-04-01 01:24:06.000000', 'consum', 0.0227, 'lps'),
	(479193, 125, '2015-04-01 01:24:07.000000', 'consum', 0.0222, 'lps'),
	(479194, 125, '2015-04-01 01:24:08.000000', 'consum', 0.0218, 'lps'),
	(479195, 125, '2015-04-01 01:24:09.000000', 'consum', 0.0217, 'lps'),
	(479196, 125, '2015-04-01 01:24:10.000000', 'consum', 0.0223, 'lps'),
	(479197, 125, '2015-04-01 01:24:11.000000', 'consum', 0.0227, 'lps'),
	(479198, 125, '2015-04-01 01:24:12.000000', 'consum', 0.0210, 'lps'),
	(479199, 125, '2015-04-01 01:24:13.000000', 'consum', 0.0232, 'lps'),
	(479200, 125, '2015-04-01 01:24:14.000000', 'consum', 0.0222, 'lps'),
	(479201, 125, '2015-04-01 01:24:15.000000', 'consum', 0.0231, 'lps'),
	(479202, 125, '2015-04-01 01:24:16.000000', 'consum', 0.0229, 'lps'),
	(479203, 125, '2015-04-01 01:24:17.000000', 'consum', 0.0221, 'lps'),
	(479204, 125, '2015-04-01 01:24:18.000000', 'consum', 0.0231, 'lps'),
	(479205, 125, '2015-04-01 01:24:19.000000', 'consum', 0.0213, 'lps'),
	(479206, 125, '2015-04-01 01:24:20.000000', 'consum', 0.0231, 'lps'),
	(479207, 125, '2015-04-01 01:24:21.000000', 'consum', 0.0212, 'lps'),
	(479208, 125, '2015-04-01 01:24:22.000000', 'consum', 0.0230, 'lps'),
	(479209, 125, '2015-04-01 01:24:23.000000', 'consum', 0.0210, 'lps'),
	(479210, 125, '2015-04-01 01:24:24.000000', 'consum', 0.0221, 'lps'),
	(479211, 125, '2015-04-01 01:24:25.000000', 'consum', 0.0218, 'lps'),
	(479212, 125, '2015-04-01 01:24:26.000000', 'consum', 0.0218, 'lps'),
	(479213, 125, '2015-04-01 01:24:27.000000', 'consum', 0.0226, 'lps'),
	(479214, 125, '2015-04-01 01:24:28.000000', 'consum', 0.0218, 'lps'),
	(479215, 125, '2015-04-01 01:24:29.000000', 'consum', 0.0228, 'lps'),
	(479216, 125, '2015-04-01 01:24:30.000000', 'consum', 0.0228, 'lps'),
	(479217, 125, '2015-04-01 01:24:31.000000', 'consum', 0.0224, 'lps'),
	(479218, 125, '2015-04-01 01:24:32.000000', 'consum', 0.0226, 'lps'),
	(479219, 125, '2015-04-01 01:24:33.000000', 'consum', 0.0226, 'lps'),
	(479220, 125, '2015-04-01 01:24:34.000000', 'consum', 0.0218, 'lps'),
	(479221, 125, '2015-04-01 01:24:35.000000', 'consum', 0.0224, 'lps'),
	(479222, 125, '2015-04-01 01:24:36.000000', 'consum', 0.0211, 'lps'),
	(479223, 125, '2015-04-01 01:24:37.000000', 'consum', 0.0221, 'lps'),
	(479224, 125, '2015-04-01 01:24:38.000000', 'consum', 0.0215, 'lps'),
	(479225, 125, '2015-04-01 01:24:39.000000', 'consum', 0.0228, 'lps'),
	(479226, 125, '2015-04-01 01:24:40.000000', 'consum', 0.0211, 'lps'),
	(479227, 125, '2015-04-01 01:24:41.000000', 'consum', 0.0210, 'lps'),
	(479228, 125, '2015-04-01 01:24:42.000000', 'consum', 0.0232, 'lps'),
	(479229, 125, '2015-04-01 01:24:43.000000', 'consum', 0.0225, 'lps'),
	(479230, 125, '2015-04-01 01:24:44.000000', 'consum', 0.0219, 'lps'),
	(479231, 125, '2015-04-01 01:24:45.000000', 'consum', 0.0213, 'lps'),
	(479232, 125, '2015-04-01 01:24:46.000000', 'consum', 0.0219, 'lps'),
	(479233, 125, '2015-04-01 01:24:47.000000', 'consum', 0.0223, 'lps'),
	(479234, 125, '2015-04-01 01:24:48.000000', 'consum', 0.0225, 'lps'),
	(479235, 125, '2015-04-01 01:24:49.000000', 'consum', 0.0225, 'lps'),
	(479236, 125, '2015-04-01 01:24:50.000000', 'consum', 0.0213, 'lps'),
	(479237, 125, '2015-04-01 01:24:51.000000', 'consum', 0.0231, 'lps'),
	(479238, 125, '2015-04-01 01:24:52.000000', 'consum', 0.0233, 'lps'),
	(479239, 125, '2015-04-01 01:24:53.000000', 'consum', 0.0215, 'lps'),
	(479240, 125, '2015-04-01 01:24:54.000000', 'consum', 0.0216, 'lps'),
	(479241, 125, '2015-04-01 01:24:55.000000', 'consum', 0.0223, 'lps'),
	(479242, 125, '2015-04-01 01:24:56.000000', 'consum', 0.0212, 'lps'),
	(479243, 125, '2015-04-01 01:24:57.000000', 'consum', 0.0228, 'lps'),
	(479244, 125, '2015-04-01 01:24:58.000000', 'consum', 0.0223, 'lps'),
	(479245, 125, '2015-04-01 01:24:59.000000', 'consum', 0.0221, 'lps'),
	(479246, 125, '2015-04-01 01:25:00.000000', 'consum', 0.0226, 'lps'),
	(479247, 125, '2015-04-01 01:25:01.000000', 'consum', 0.0212, 'lps'),
	(479248, 125, '2015-04-01 01:25:02.000000', 'consum', 0.0219, 'lps'),
	(479249, 125, '2015-04-01 01:25:03.000000', 'consum', 0.0224, 'lps'),
	(479250, 125, '2015-04-01 01:25:04.000000', 'consum', 0.0230, 'lps'),
	(479251, 125, '2015-04-01 01:25:05.000000', 'consum', 0.0223, 'lps'),
	(479252, 125, '2015-04-01 01:25:06.000000', 'consum', 0.0213, 'lps'),
	(479253, 125, '2015-04-01 01:25:07.000000', 'consum', 0.0233, 'lps'),
	(479254, 125, '2015-04-01 01:25:08.000000', 'consum', 0.0223, 'lps'),
	(479255, 125, '2015-04-01 01:25:09.000000', 'consum', 0.0229, 'lps'),
	(479256, 125, '2015-04-01 01:25:10.000000', 'consum', 0.0219, 'lps'),
	(479257, 125, '2015-04-01 01:25:11.000000', 'consum', 0.0223, 'lps'),
	(479258, 125, '2015-04-01 01:25:12.000000', 'consum', 0.0223, 'lps'),
	(479259, 125, '2015-04-01 01:25:13.000000', 'consum', 0.0213, 'lps'),
	(479260, 125, '2015-04-01 01:25:14.000000', 'consum', 0.0210, 'lps'),
	(479261, 125, '2015-04-01 01:25:15.000000', 'consum', 0.0225, 'lps'),
	(479262, 125, '2015-04-01 01:25:16.000000', 'consum', 0.0212, 'lps'),
	(479263, 125, '2015-04-01 01:25:17.000000', 'consum', 0.0227, 'lps'),
	(479264, 125, '2015-04-01 01:25:18.000000', 'consum', 0.0214, 'lps'),
	(479265, 125, '2015-04-01 01:25:19.000000', 'consum', 0.0231, 'lps'),
	(479266, 125, '2015-04-01 01:25:20.000000', 'consum', 0.0228, 'lps'),
	(479267, 125, '2015-04-01 01:25:21.000000', 'consum', 0.0216, 'lps'),
	(479268, 125, '2015-04-01 01:25:22.000000', 'consum', 0.0232, 'lps'),
	(479269, 125, '2015-04-01 01:25:23.000000', 'consum', 0.0230, 'lps'),
	(479270, 125, '2015-04-01 01:25:24.000000', 'consum', 0.0224, 'lps'),
	(479271, 125, '2015-04-01 01:25:25.000000', 'consum', 0.0217, 'lps'),
	(479272, 125, '2015-04-01 01:25:26.000000', 'consum', 0.0230, 'lps'),
	(479273, 125, '2015-04-01 01:25:27.000000', 'consum', 0.0215, 'lps'),
	(479274, 125, '2015-04-01 01:25:28.000000', 'consum', 0.0224, 'lps'),
	(479275, 125, '2015-04-01 01:25:29.000000', 'consum', 0.0216, 'lps'),
	(479276, 125, '2015-04-01 01:25:30.000000', 'consum', 0.0225, 'lps'),
	(479277, 125, '2015-04-01 01:25:31.000000', 'consum', 0.0217, 'lps'),
	(479278, 125, '2015-04-01 01:25:32.000000', 'consum', 0.0227, 'lps'),
	(479279, 125, '2015-04-01 01:25:33.000000', 'consum', 0.0226, 'lps'),
	(479280, 125, '2015-04-01 01:25:34.000000', 'consum', 0.0215, 'lps'),
	(479281, 125, '2015-04-01 01:25:35.000000', 'consum', 0.0210, 'lps'),
	(479282, 125, '2015-04-01 01:25:36.000000', 'consum', 0.0222, 'lps'),
	(479283, 125, '2015-04-01 01:25:37.000000', 'consum', 0.0223, 'lps'),
	(479284, 125, '2015-04-01 01:25:38.000000', 'consum', 0.0213, 'lps'),
	(479285, 125, '2015-04-01 01:25:39.000000', 'consum', 0.0213, 'lps'),
	(479286, 125, '2015-04-01 01:25:40.000000', 'consum', 0.0215, 'lps'),
	(479287, 125, '2015-04-01 01:25:41.000000', 'consum', 0.0226, 'lps'),
	(479288, 125, '2015-04-01 01:25:42.000000', 'consum', 0.0226, 'lps'),
	(479289, 125, '2015-04-01 01:25:43.000000', 'consum', 0.0221, 'lps'),
	(479290, 125, '2015-04-01 01:25:44.000000', 'consum', 0.0219, 'lps'),
	(479291, 125, '2015-04-01 01:25:45.000000', 'consum', 0.0220, 'lps'),
	(479292, 125, '2015-04-01 01:25:46.000000', 'consum', 0.0211, 'lps'),
	(479293, 125, '2015-04-01 01:25:47.000000', 'consum', 0.0233, 'lps'),
	(479294, 125, '2015-04-01 01:25:48.000000', 'consum', 0.0227, 'lps'),
	(479295, 125, '2015-04-01 01:25:49.000000', 'consum', 0.0227, 'lps'),
	(479296, 125, '2015-04-01 01:25:50.000000', 'consum', 0.0221, 'lps'),
	(479297, 125, '2015-04-01 01:25:51.000000', 'consum', 0.0216, 'lps'),
	(479298, 125, '2015-04-01 01:25:52.000000', 'consum', 0.0228, 'lps'),
	(479299, 125, '2015-04-01 01:25:53.000000', 'consum', 0.0213, 'lps'),
	(479300, 125, '2015-04-01 01:25:54.000000', 'consum', 0.0219, 'lps'),
	(479301, 125, '2015-04-01 01:25:55.000000', 'consum', 0.0222, 'lps'),
	(479302, 125, '2015-04-01 01:25:56.000000', 'consum', 0.0222, 'lps'),
	(479303, 125, '2015-04-01 01:25:57.000000', 'consum', 0.0231, 'lps'),
	(479304, 125, '2015-04-01 01:25:58.000000', 'consum', 0.0210, 'lps'),
	(479305, 125, '2015-04-01 01:25:59.000000', 'consum', 0.0219, 'lps'),
	(479306, 125, '2015-04-01 01:26:00.000000', 'consum', 0.0231, 'lps'),
	(479307, 125, '2015-04-01 01:26:01.000000', 'consum', 0.0217, 'lps'),
	(479308, 125, '2015-04-01 01:26:02.000000', 'consum', 0.0228, 'lps'),
	(479309, 125, '2015-04-01 01:26:03.000000', 'consum', 0.0211, 'lps'),
	(479310, 125, '2015-04-01 01:26:04.000000', 'consum', 0.0230, 'lps'),
	(479311, 125, '2015-04-01 01:26:05.000000', 'consum', 0.0215, 'lps'),
	(479312, 125, '2015-04-01 01:26:06.000000', 'consum', 0.0221, 'lps'),
	(479313, 125, '2015-04-01 01:26:07.000000', 'consum', 0.0228, 'lps'),
	(479314, 125, '2015-04-01 01:26:08.000000', 'consum', 0.0219, 'lps'),
	(479315, 125, '2015-04-01 01:26:09.000000', 'consum', 0.0225, 'lps'),
	(479316, 125, '2015-04-01 01:26:10.000000', 'consum', 0.0210, 'lps'),
	(479317, 125, '2015-04-01 01:26:11.000000', 'consum', 0.0215, 'lps'),
	(479318, 125, '2015-04-01 01:26:12.000000', 'consum', 0.0213, 'lps'),
	(479319, 125, '2015-04-01 01:26:13.000000', 'consum', 0.0232, 'lps'),
	(479320, 125, '2015-04-01 01:26:14.000000', 'consum', 0.0217, 'lps'),
	(479321, 125, '2015-04-01 01:26:15.000000', 'consum', 0.0226, 'lps'),
	(479322, 125, '2015-04-01 01:26:16.000000', 'consum', 0.0221, 'lps'),
	(479323, 125, '2015-04-01 01:26:17.000000', 'consum', 0.0220, 'lps'),
	(479324, 125, '2015-04-01 01:26:18.000000', 'consum', 0.0227, 'lps'),
	(479325, 125, '2015-04-01 01:26:19.000000', 'consum', 0.0217, 'lps'),
	(479326, 125, '2015-04-01 01:26:20.000000', 'consum', 0.0220, 'lps'),
	(479327, 125, '2015-04-01 01:26:21.000000', 'consum', 0.0216, 'lps'),
	(479328, 125, '2015-04-01 01:26:22.000000', 'consum', 0.0210, 'lps'),
	(479329, 125, '2015-04-01 01:26:23.000000', 'consum', 0.0218, 'lps'),
	(479330, 125, '2015-04-01 01:26:24.000000', 'consum', 0.0225, 'lps'),
	(479331, 125, '2015-04-01 01:26:25.000000', 'consum', 0.0213, 'lps'),
	(479332, 125, '2015-04-01 01:26:26.000000', 'consum', 0.0231, 'lps'),
	(479333, 125, '2015-04-01 01:26:27.000000', 'consum', 0.0232, 'lps'),
	(479334, 125, '2015-04-01 01:26:28.000000', 'consum', 0.0211, 'lps'),
	(479335, 125, '2015-04-01 01:26:29.000000', 'consum', 0.0220, 'lps'),
	(479336, 125, '2015-04-01 01:26:30.000000', 'consum', 0.0211, 'lps'),
	(479337, 125, '2015-04-01 01:26:31.000000', 'consum', 0.0231, 'lps'),
	(479338, 125, '2015-04-01 01:26:32.000000', 'consum', 0.0219, 'lps'),
	(479339, 125, '2015-04-01 01:26:33.000000', 'consum', 0.0216, 'lps'),
	(479340, 125, '2015-04-01 01:26:34.000000', 'consum', 0.0214, 'lps'),
	(479341, 125, '2015-04-01 01:26:35.000000', 'consum', 0.0212, 'lps'),
	(479342, 125, '2015-04-01 01:26:36.000000', 'consum', 0.0210, 'lps'),
	(479343, 125, '2015-04-01 01:26:37.000000', 'consum', 0.0228, 'lps'),
	(479344, 125, '2015-04-01 01:26:38.000000', 'consum', 0.0226, 'lps'),
	(479345, 125, '2015-04-01 01:26:39.000000', 'consum', 0.0215, 'lps'),
	(479346, 125, '2015-04-01 01:26:40.000000', 'consum', 0.0233, 'lps'),
	(479347, 125, '2015-04-01 01:26:41.000000', 'consum', 0.0215, 'lps'),
	(479348, 125, '2015-04-01 01:26:42.000000', 'consum', 0.0213, 'lps'),
	(479349, 125, '2015-04-01 01:26:43.000000', 'consum', 0.0213, 'lps'),
	(479350, 125, '2015-04-01 01:26:44.000000', 'consum', 0.0214, 'lps'),
	(479351, 125, '2015-04-01 01:26:45.000000', 'consum', 0.0222, 'lps'),
	(479352, 125, '2015-04-01 01:26:46.000000', 'consum', 0.0212, 'lps'),
	(479353, 125, '2015-04-01 01:26:47.000000', 'consum', 0.0233, 'lps'),
	(479354, 125, '2015-04-01 01:26:48.000000', 'consum', 0.0223, 'lps'),
	(479355, 125, '2015-04-01 01:26:49.000000', 'consum', 0.0230, 'lps'),
	(479356, 125, '2015-04-01 01:26:50.000000', 'consum', 0.0223, 'lps'),
	(479357, 125, '2015-04-01 01:26:51.000000', 'consum', 0.0217, 'lps'),
	(479358, 125, '2015-04-01 01:26:52.000000', 'consum', 0.0228, 'lps'),
	(479359, 125, '2015-04-01 01:26:53.000000', 'consum', 0.0231, 'lps'),
	(479360, 125, '2015-04-01 01:26:54.000000', 'consum', 0.0217, 'lps'),
	(479361, 125, '2015-04-01 01:26:55.000000', 'consum', 0.0227, 'lps'),
	(479362, 125, '2015-04-01 01:26:56.000000', 'consum', 0.0228, 'lps'),
	(479363, 125, '2015-04-01 01:26:57.000000', 'consum', 0.0226, 'lps'),
	(479364, 125, '2015-04-01 01:26:58.000000', 'consum', 0.0213, 'lps'),
	(479365, 125, '2015-04-01 01:26:59.000000', 'consum', 0.0226, 'lps'),
	(479366, 125, '2015-04-01 01:27:00.000000', 'consum', 0.0233, 'lps'),
	(479367, 125, '2015-04-01 01:27:01.000000', 'consum', 0.0230, 'lps'),
	(479368, 125, '2015-04-01 01:27:02.000000', 'consum', 0.0218, 'lps'),
	(479369, 125, '2015-04-01 01:27:03.000000', 'consum', 0.0214, 'lps'),
	(479370, 125, '2015-04-01 01:27:04.000000', 'consum', 0.0232, 'lps'),
	(479371, 125, '2015-04-01 01:27:05.000000', 'consum', 0.0213, 'lps'),
	(479372, 125, '2015-04-01 01:27:06.000000', 'consum', 0.0232, 'lps'),
	(479373, 125, '2015-04-01 01:27:07.000000', 'consum', 0.0214, 'lps'),
	(479374, 125, '2015-04-01 01:27:08.000000', 'consum', 0.0212, 'lps'),
	(479375, 125, '2015-04-01 01:27:09.000000', 'consum', 0.0232, 'lps'),
	(479376, 125, '2015-04-01 01:27:10.000000', 'consum', 0.0219, 'lps'),
	(479377, 125, '2015-04-01 01:27:11.000000', 'consum', 0.0213, 'lps'),
	(479378, 125, '2015-04-01 01:27:12.000000', 'consum', 0.0221, 'lps'),
	(479379, 125, '2015-04-01 01:27:13.000000', 'consum', 0.0210, 'lps'),
	(479380, 125, '2015-04-01 01:27:14.000000', 'consum', 0.0226, 'lps'),
	(479381, 125, '2015-04-01 01:27:15.000000', 'consum', 0.0217, 'lps'),
	(479382, 125, '2015-04-01 01:27:16.000000', 'consum', 0.0221, 'lps'),
	(479383, 125, '2015-04-01 01:27:17.000000', 'consum', 0.0222, 'lps'),
	(479384, 125, '2015-04-01 01:27:18.000000', 'consum', 0.0214, 'lps'),
	(479385, 125, '2015-04-01 01:27:19.000000', 'consum', 0.0220, 'lps'),
	(479386, 125, '2015-04-01 01:27:20.000000', 'consum', 0.0222, 'lps'),
	(479387, 125, '2015-04-01 01:27:21.000000', 'consum', 0.0216, 'lps'),
	(479388, 125, '2015-04-01 01:27:22.000000', 'consum', 0.0231, 'lps'),
	(479389, 125, '2015-04-01 01:27:23.000000', 'consum', 0.0222, 'lps'),
	(479390, 125, '2015-04-01 01:27:24.000000', 'consum', 0.0211, 'lps'),
	(479391, 125, '2015-04-01 01:27:25.000000', 'consum', 0.0225, 'lps'),
	(479392, 125, '2015-04-01 01:27:26.000000', 'consum', 0.0213, 'lps'),
	(479393, 125, '2015-04-01 01:27:27.000000', 'consum', 0.0227, 'lps'),
	(479394, 125, '2015-04-01 01:27:28.000000', 'consum', 0.0216, 'lps'),
	(479395, 125, '2015-04-01 01:27:29.000000', 'consum', 0.0214, 'lps'),
	(479396, 125, '2015-04-01 01:27:30.000000', 'consum', 0.0212, 'lps'),
	(479397, 125, '2015-04-01 01:27:31.000000', 'consum', 0.0233, 'lps'),
	(479398, 125, '2015-04-01 01:27:32.000000', 'consum', 0.0221, 'lps'),
	(479399, 125, '2015-04-01 01:27:33.000000', 'consum', 0.0223, 'lps'),
	(479400, 125, '2015-04-01 01:27:34.000000', 'consum', 0.0217, 'lps'),
	(479401, 125, '2015-04-01 01:27:35.000000', 'consum', 0.0230, 'lps'),
	(479402, 125, '2015-04-01 01:27:36.000000', 'consum', 0.0218, 'lps'),
	(479403, 125, '2015-04-01 01:27:37.000000', 'consum', 0.0215, 'lps'),
	(479404, 125, '2015-04-01 01:27:38.000000', 'consum', 0.0210, 'lps'),
	(479405, 125, '2015-04-01 01:27:39.000000', 'consum', 0.0222, 'lps'),
	(479406, 125, '2015-04-01 01:27:40.000000', 'consum', 0.0223, 'lps'),
	(479407, 125, '2015-04-01 01:27:41.000000', 'consum', 0.0215, 'lps'),
	(479408, 125, '2015-04-01 01:27:42.000000', 'consum', 0.0222, 'lps'),
	(479409, 125, '2015-04-01 01:27:43.000000', 'consum', 0.0229, 'lps'),
	(479410, 125, '2015-04-01 01:27:44.000000', 'consum', 0.0221, 'lps'),
	(479411, 125, '2015-04-01 01:27:45.000000', 'consum', 0.0210, 'lps'),
	(479412, 125, '2015-04-01 01:27:46.000000', 'consum', 0.0227, 'lps'),
	(479413, 125, '2015-04-01 01:27:47.000000', 'consum', 0.0222, 'lps'),
	(479414, 125, '2015-04-01 01:27:48.000000', 'consum', 0.0221, 'lps'),
	(479415, 125, '2015-04-01 01:27:49.000000', 'consum', 0.0227, 'lps'),
	(479416, 125, '2015-04-01 01:27:50.000000', 'consum', 0.0217, 'lps'),
	(479417, 125, '2015-04-01 01:27:51.000000', 'consum', 0.0217, 'lps'),
	(479418, 125, '2015-04-01 01:27:52.000000', 'consum', 0.0223, 'lps'),
	(479419, 125, '2015-04-01 01:27:53.000000', 'consum', 0.0233, 'lps'),
	(479420, 125, '2015-04-01 01:27:54.000000', 'consum', 0.0215, 'lps'),
	(479421, 125, '2015-04-01 01:27:55.000000', 'consum', 0.0213, 'lps'),
	(479422, 125, '2015-04-01 01:27:56.000000', 'consum', 0.0210, 'lps'),
	(479423, 125, '2015-04-01 01:27:57.000000', 'consum', 0.0225, 'lps'),
	(479424, 125, '2015-04-01 01:27:58.000000', 'consum', 0.0213, 'lps'),
	(479425, 125, '2015-04-01 01:27:59.000000', 'consum', 0.0229, 'lps'),
	(479426, 125, '2015-04-01 01:28:00.000000', 'consum', 0.0225, 'lps'),
	(479427, 125, '2015-04-01 01:28:01.000000', 'consum', 0.0230, 'lps'),
	(479428, 125, '2015-04-01 01:28:02.000000', 'consum', 0.0218, 'lps'),
	(479429, 125, '2015-04-01 01:28:03.000000', 'consum', 0.0214, 'lps'),
	(479430, 125, '2015-04-01 01:28:04.000000', 'consum', 0.0232, 'lps'),
	(479431, 125, '2015-04-01 01:28:05.000000', 'consum', 0.0211, 'lps'),
	(479432, 125, '2015-04-01 01:28:06.000000', 'consum', 0.0223, 'lps'),
	(479433, 125, '2015-04-01 01:28:07.000000', 'consum', 0.0222, 'lps'),
	(479434, 125, '2015-04-01 01:28:08.000000', 'consum', 0.0230, 'lps'),
	(479435, 125, '2015-04-01 01:28:09.000000', 'consum', 0.0230, 'lps'),
	(479436, 125, '2015-04-01 01:28:10.000000', 'consum', 0.0226, 'lps'),
	(479437, 125, '2015-04-01 01:28:11.000000', 'consum', 0.0229, 'lps'),
	(479438, 125, '2015-04-01 01:28:12.000000', 'consum', 0.0210, 'lps'),
	(479439, 125, '2015-04-01 01:28:13.000000', 'consum', 0.0228, 'lps'),
	(479440, 125, '2015-04-01 01:28:14.000000', 'consum', 0.0225, 'lps'),
	(479441, 125, '2015-04-01 01:28:15.000000', 'consum', 0.0233, 'lps'),
	(479442, 125, '2015-04-01 01:28:16.000000', 'consum', 0.0232, 'lps'),
	(479443, 125, '2015-04-01 01:28:17.000000', 'consum', 0.0229, 'lps'),
	(479444, 125, '2015-04-01 01:28:18.000000', 'consum', 0.0214, 'lps'),
	(479445, 125, '2015-04-01 01:28:19.000000', 'consum', 0.0220, 'lps'),
	(479446, 125, '2015-04-01 01:28:20.000000', 'consum', 0.0226, 'lps'),
	(479447, 125, '2015-04-01 01:28:21.000000', 'consum', 0.0213, 'lps'),
	(479448, 125, '2015-04-01 01:28:22.000000', 'consum', 0.0227, 'lps'),
	(479449, 125, '2015-04-01 01:28:23.000000', 'consum', 0.0213, 'lps'),
	(479450, 125, '2015-04-01 01:28:24.000000', 'consum', 0.0221, 'lps'),
	(479451, 125, '2015-04-01 01:28:25.000000', 'consum', 0.0233, 'lps'),
	(479452, 125, '2015-04-01 01:28:26.000000', 'consum', 0.0219, 'lps'),
	(479453, 125, '2015-04-01 01:28:27.000000', 'consum', 0.0213, 'lps'),
	(479454, 125, '2015-04-01 01:28:28.000000', 'consum', 0.0222, 'lps'),
	(479455, 125, '2015-04-01 01:28:29.000000', 'consum', 0.0215, 'lps'),
	(479456, 125, '2015-04-01 01:28:30.000000', 'consum', 0.0224, 'lps'),
	(479457, 125, '2015-04-01 01:28:31.000000', 'consum', 0.0216, 'lps'),
	(479458, 125, '2015-04-01 01:28:32.000000', 'consum', 0.0223, 'lps'),
	(479459, 125, '2015-04-01 01:28:33.000000', 'consum', 0.0210, 'lps'),
	(479460, 125, '2015-04-01 01:28:34.000000', 'consum', 0.0218, 'lps'),
	(479461, 125, '2015-04-01 01:28:35.000000', 'consum', 0.0227, 'lps'),
	(479462, 125, '2015-04-01 01:28:36.000000', 'consum', 0.0223, 'lps'),
	(479463, 125, '2015-04-01 01:28:37.000000', 'consum', 0.0224, 'lps'),
	(479464, 125, '2015-04-01 01:28:38.000000', 'consum', 0.0220, 'lps'),
	(479465, 125, '2015-04-01 01:28:39.000000', 'consum', 0.0215, 'lps'),
	(479466, 125, '2015-04-01 01:28:40.000000', 'consum', 0.0232, 'lps'),
	(479467, 125, '2015-04-01 01:28:41.000000', 'consum', 0.0210, 'lps'),
	(479468, 125, '2015-04-01 01:28:42.000000', 'consum', 0.0214, 'lps'),
	(479469, 125, '2015-04-01 01:28:43.000000', 'consum', 0.0230, 'lps'),
	(479470, 125, '2015-04-01 01:28:44.000000', 'consum', 0.0228, 'lps'),
	(479471, 125, '2015-04-01 01:28:45.000000', 'consum', 0.0216, 'lps'),
	(479472, 125, '2015-04-01 01:28:46.000000', 'consum', 0.0213, 'lps'),
	(479473, 125, '2015-04-01 01:28:47.000000', 'consum', 0.0228, 'lps'),
	(479474, 125, '2015-04-01 01:28:48.000000', 'consum', 0.0221, 'lps'),
	(479475, 125, '2015-04-01 01:28:49.000000', 'consum', 0.0210, 'lps'),
	(479476, 125, '2015-04-01 01:28:50.000000', 'consum', 0.0227, 'lps'),
	(479477, 125, '2015-04-01 01:28:51.000000', 'consum', 0.0222, 'lps'),
	(479478, 125, '2015-04-01 01:28:52.000000', 'consum', 0.0219, 'lps'),
	(479479, 125, '2015-04-01 01:28:53.000000', 'consum', 0.0222, 'lps'),
	(479480, 125, '2015-04-01 01:28:54.000000', 'consum', 0.0217, 'lps'),
	(479481, 125, '2015-04-01 01:28:55.000000', 'consum', 0.0211, 'lps'),
	(479482, 125, '2015-04-01 01:28:56.000000', 'consum', 0.0218, 'lps'),
	(479483, 125, '2015-04-01 01:28:57.000000', 'consum', 0.0223, 'lps'),
	(479484, 125, '2015-04-01 01:28:58.000000', 'consum', 0.0227, 'lps'),
	(479485, 125, '2015-04-01 01:28:59.000000', 'consum', 0.0210, 'lps'),
	(479486, 125, '2015-04-01 01:29:00.000000', 'consum', 0.0229, 'lps'),
	(479487, 125, '2015-04-01 01:29:01.000000', 'consum', 0.0210, 'lps'),
	(479488, 125, '2015-04-01 01:29:02.000000', 'consum', 0.0227, 'lps'),
	(479489, 125, '2015-04-01 01:29:03.000000', 'consum', 0.0223, 'lps'),
	(479490, 125, '2015-04-01 01:29:04.000000', 'consum', 0.0225, 'lps'),
	(479491, 125, '2015-04-01 01:29:05.000000', 'consum', 0.0221, 'lps'),
	(479492, 125, '2015-04-01 01:29:06.000000', 'consum', 0.0220, 'lps'),
	(479493, 125, '2015-04-01 01:29:07.000000', 'consum', 0.0228, 'lps'),
	(479494, 125, '2015-04-01 01:29:08.000000', 'consum', 0.0224, 'lps'),
	(479495, 125, '2015-04-01 01:29:09.000000', 'consum', 0.0227, 'lps'),
	(479496, 125, '2015-04-01 01:29:10.000000', 'consum', 0.0230, 'lps'),
	(479497, 125, '2015-04-01 01:29:11.000000', 'consum', 0.0210, 'lps'),
	(479498, 125, '2015-04-01 01:29:12.000000', 'consum', 0.0224, 'lps'),
	(479499, 125, '2015-04-01 01:29:13.000000', 'consum', 0.0231, 'lps'),
	(479500, 125, '2015-04-01 01:29:14.000000', 'consum', 0.0227, 'lps'),
	(479501, 125, '2015-04-01 01:29:15.000000', 'consum', 0.0230, 'lps'),
	(479502, 125, '2015-04-01 01:29:16.000000', 'consum', 0.0215, 'lps'),
	(479503, 125, '2015-04-01 01:29:17.000000', 'consum', 0.0220, 'lps'),
	(479504, 125, '2015-04-01 01:29:18.000000', 'consum', 0.0222, 'lps'),
	(479505, 125, '2015-04-01 01:29:19.000000', 'consum', 0.0217, 'lps'),
	(479506, 125, '2015-04-01 01:29:20.000000', 'consum', 0.0210, 'lps'),
	(479507, 125, '2015-04-01 01:29:21.000000', 'consum', 0.0211, 'lps'),
	(479508, 125, '2015-04-01 01:29:22.000000', 'consum', 0.0218, 'lps'),
	(479509, 125, '2015-04-01 01:29:23.000000', 'consum', 0.0222, 'lps'),
	(479510, 125, '2015-04-01 01:29:24.000000', 'consum', 0.0223, 'lps'),
	(479511, 125, '2015-04-01 01:29:25.000000', 'consum', 0.0215, 'lps'),
	(479512, 125, '2015-04-01 01:29:26.000000', 'consum', 0.0220, 'lps'),
	(479513, 125, '2015-04-01 01:29:27.000000', 'consum', 0.0222, 'lps'),
	(479514, 125, '2015-04-01 01:29:28.000000', 'consum', 0.0217, 'lps'),
	(479515, 125, '2015-04-01 01:29:29.000000', 'consum', 0.0210, 'lps'),
	(479516, 125, '2015-04-01 01:29:30.000000', 'consum', 0.0212, 'lps'),
	(479517, 125, '2015-04-01 01:29:31.000000', 'consum', 0.0220, 'lps'),
	(479518, 125, '2015-04-01 01:29:32.000000', 'consum', 0.0233, 'lps'),
	(479519, 125, '2015-04-01 01:29:33.000000', 'consum', 0.0224, 'lps'),
	(479520, 125, '2015-04-01 01:29:34.000000', 'consum', 0.0233, 'lps'),
	(479521, 125, '2015-04-01 01:29:35.000000', 'consum', 0.0214, 'lps'),
	(479522, 125, '2015-04-01 01:29:36.000000', 'consum', 0.0210, 'lps'),
	(479523, 125, '2015-04-01 01:29:37.000000', 'consum', 0.0223, 'lps'),
	(479524, 125, '2015-04-01 01:29:38.000000', 'consum', 0.0226, 'lps'),
	(479525, 125, '2015-04-01 01:29:39.000000', 'consum', 0.0227, 'lps'),
	(479526, 125, '2015-04-01 01:29:40.000000', 'consum', 0.0225, 'lps'),
	(479527, 125, '2015-04-01 01:29:41.000000', 'consum', 0.0211, 'lps'),
	(479528, 125, '2015-04-01 01:29:42.000000', 'consum', 0.0216, 'lps'),
	(479529, 125, '2015-04-01 01:29:43.000000', 'consum', 0.0214, 'lps'),
	(479530, 125, '2015-04-01 01:29:44.000000', 'consum', 0.0212, 'lps'),
	(479531, 125, '2015-04-01 01:29:45.000000', 'consum', 0.0233, 'lps'),
	(479532, 125, '2015-04-01 01:29:46.000000', 'consum', 0.0223, 'lps'),
	(479533, 125, '2015-04-01 01:29:47.000000', 'consum', 0.0233, 'lps'),
	(479534, 125, '2015-04-01 01:29:48.000000', 'consum', 0.0213, 'lps'),
	(479535, 125, '2015-04-01 01:29:49.000000', 'consum', 0.0228, 'lps'),
	(479536, 125, '2015-04-01 01:29:50.000000', 'consum', 0.0221, 'lps'),
	(479537, 125, '2015-04-01 01:29:51.000000', 'consum', 0.0210, 'lps'),
	(479538, 125, '2015-04-01 01:29:52.000000', 'consum', 0.0225, 'lps'),
	(479539, 125, '2015-04-01 01:29:53.000000', 'consum', 0.0216, 'lps'),
	(479540, 125, '2015-04-01 01:29:54.000000', 'consum', 0.0218, 'lps'),
	(479541, 125, '2015-04-01 01:29:55.000000', 'consum', 0.0231, 'lps'),
	(479542, 125, '2015-04-01 01:29:56.000000', 'consum', 0.0221, 'lps'),
	(479543, 125, '2015-04-01 01:29:57.000000', 'consum', 0.0228, 'lps'),
	(479544, 125, '2015-04-01 01:29:58.000000', 'consum', 0.0218, 'lps'),
	(479545, 125, '2015-04-01 01:29:59.000000', 'consum', 0.0219, 'lps'),
	(479546, 125, '2015-04-01 01:30:00.000000', 'consum', 0.0210, 'lps'),
	(479547, 125, '2015-04-01 01:30:01.000000', 'consum', 0.0229, 'lps'),
	(479548, 125, '2015-04-01 01:30:02.000000', 'consum', 0.0233, 'lps'),
	(479549, 125, '2015-04-01 01:30:03.000000', 'consum', 0.0223, 'lps'),
	(479550, 125, '2015-04-01 01:30:04.000000', 'consum', 0.0228, 'lps'),
	(479551, 125, '2015-04-01 01:30:05.000000', 'consum', 0.0215, 'lps'),
	(479552, 125, '2015-04-01 01:30:06.000000', 'consum', 0.0229, 'lps'),
	(479553, 125, '2015-04-01 01:30:07.000000', 'consum', 0.0220, 'lps'),
	(479554, 125, '2015-04-01 01:30:08.000000', 'consum', 0.0228, 'lps'),
	(479555, 125, '2015-04-01 01:30:09.000000', 'consum', 0.0222, 'lps'),
	(479556, 125, '2015-04-01 01:30:10.000000', 'consum', 0.0217, 'lps'),
	(479557, 125, '2015-04-01 01:30:11.000000', 'consum', 0.0232, 'lps'),
	(479558, 125, '2015-04-01 01:30:12.000000', 'consum', 0.0229, 'lps'),
	(479559, 125, '2015-04-01 01:30:13.000000', 'consum', 0.0216, 'lps'),
	(479560, 125, '2015-04-01 01:30:14.000000', 'consum', 0.0233, 'lps'),
	(479561, 125, '2015-04-01 01:30:15.000000', 'consum', 0.0233, 'lps'),
	(479562, 125, '2015-04-01 01:30:16.000000', 'consum', 0.0211, 'lps'),
	(479563, 125, '2015-04-01 01:30:17.000000', 'consum', 0.0216, 'lps'),
	(479564, 125, '2015-04-01 01:30:18.000000', 'consum', 0.0215, 'lps'),
	(479565, 125, '2015-04-01 01:30:19.000000', 'consum', 0.0218, 'lps'),
	(479566, 125, '2015-04-01 01:30:20.000000', 'consum', 0.0211, 'lps'),
	(479567, 125, '2015-04-01 01:30:21.000000', 'consum', 0.0216, 'lps'),
	(479568, 125, '2015-04-01 01:30:22.000000', 'consum', 0.0213, 'lps'),
	(479569, 125, '2015-04-01 01:30:23.000000', 'consum', 0.0233, 'lps'),
	(479570, 125, '2015-04-01 01:30:24.000000', 'consum', 0.0218, 'lps'),
	(479571, 125, '2015-04-01 01:30:25.000000', 'consum', 0.0231, 'lps'),
	(479572, 125, '2015-04-01 01:30:26.000000', 'consum', 0.0217, 'lps'),
	(479573, 125, '2015-04-01 01:30:27.000000', 'consum', 0.0210, 'lps'),
	(479574, 125, '2015-04-01 01:30:28.000000', 'consum', 0.0212, 'lps'),
	(479575, 125, '2015-04-01 01:30:29.000000', 'consum', 0.0220, 'lps'),
	(479576, 125, '2015-04-01 01:30:30.000000', 'consum', 0.0232, 'lps'),
	(479577, 125, '2015-04-01 01:30:31.000000', 'consum', 0.0217, 'lps'),
	(479578, 125, '2015-04-01 01:30:32.000000', 'consum', 0.0226, 'lps'),
	(479579, 125, '2015-04-01 01:30:33.000000', 'consum', 0.0224, 'lps'),
	(479580, 125, '2015-04-01 01:30:34.000000', 'consum', 0.0231, 'lps'),
	(479581, 125, '2015-04-01 01:30:35.000000', 'consum', 0.0227, 'lps'),
	(479582, 125, '2015-04-01 01:30:36.000000', 'consum', 0.0233, 'lps'),
	(479583, 125, '2015-04-01 01:30:37.000000', 'consum', 0.0226, 'lps'),
	(479584, 125, '2015-04-01 01:30:38.000000', 'consum', 0.0221, 'lps'),
	(479585, 125, '2015-04-01 01:30:39.000000', 'consum', 0.0218, 'lps'),
	(479586, 125, '2015-04-01 01:30:40.000000', 'consum', 0.0218, 'lps'),
	(479587, 125, '2015-04-01 01:30:41.000000', 'consum', 0.0225, 'lps'),
	(479588, 125, '2015-04-01 01:30:42.000000', 'consum', 0.0213, 'lps'),
	(479589, 125, '2015-04-01 01:30:43.000000', 'consum', 0.0227, 'lps'),
	(479590, 125, '2015-04-01 01:30:44.000000', 'consum', 0.0218, 'lps'),
	(479591, 125, '2015-04-01 01:30:45.000000', 'consum', 0.0222, 'lps'),
	(479592, 125, '2015-04-01 01:30:46.000000', 'consum', 0.0222, 'lps'),
	(479593, 125, '2015-04-01 01:30:47.000000', 'consum', 0.0213, 'lps'),
	(479594, 125, '2015-04-01 01:30:48.000000', 'consum', 0.0211, 'lps'),
	(479595, 125, '2015-04-01 01:30:49.000000', 'consum', 0.0231, 'lps'),
	(479596, 125, '2015-04-01 01:30:50.000000', 'consum', 0.0217, 'lps'),
	(479597, 125, '2015-04-01 01:30:51.000000', 'consum', 0.0232, 'lps'),
	(479598, 125, '2015-04-01 01:30:52.000000', 'consum', 0.0226, 'lps'),
	(479599, 125, '2015-04-01 01:30:53.000000', 'consum', 0.0227, 'lps'),
	(479600, 125, '2015-04-01 01:30:54.000000', 'consum', 0.0221, 'lps'),
	(479601, 125, '2015-04-01 01:30:55.000000', 'consum', 0.0215, 'lps'),
	(479602, 125, '2015-04-01 01:30:56.000000', 'consum', 0.0225, 'lps'),
	(479603, 125, '2015-04-01 01:30:57.000000', 'consum', 0.0224, 'lps'),
	(479604, 125, '2015-04-01 01:30:58.000000', 'consum', 0.0211, 'lps'),
	(479605, 125, '2015-04-01 01:30:59.000000', 'consum', 0.0221, 'lps'),
	(479606, 125, '2015-04-01 01:31:00.000000', 'consum', 0.0214, 'lps'),
	(479607, 125, '2015-04-01 01:31:01.000000', 'consum', 0.0221, 'lps'),
	(479608, 125, '2015-04-01 01:31:02.000000', 'consum', 0.0232, 'lps'),
	(479609, 125, '2015-04-01 01:31:03.000000', 'consum', 0.0214, 'lps'),
	(479610, 125, '2015-04-01 01:31:04.000000', 'consum', 0.0212, 'lps'),
	(479611, 125, '2015-04-01 01:31:05.000000', 'consum', 0.0210, 'lps'),
	(479612, 125, '2015-04-01 01:31:06.000000', 'consum', 0.0229, 'lps'),
	(479613, 125, '2015-04-01 01:31:07.000000', 'consum', 0.0210, 'lps'),
	(479614, 125, '2015-04-01 01:31:08.000000', 'consum', 0.0226, 'lps'),
	(479615, 125, '2015-04-01 01:31:09.000000', 'consum', 0.0219, 'lps'),
	(479616, 125, '2015-04-01 01:31:10.000000', 'consum', 0.0229, 'lps'),
	(479617, 125, '2015-04-01 01:31:11.000000', 'consum', 0.0232, 'lps'),
	(479618, 125, '2015-04-01 01:31:12.000000', 'consum', 0.0214, 'lps'),
	(479619, 125, '2015-04-01 01:31:13.000000', 'consum', 0.0213, 'lps'),
	(479620, 125, '2015-04-01 01:31:14.000000', 'consum', 0.0213, 'lps'),
	(479621, 125, '2015-04-01 01:31:15.000000', 'consum', 0.0218, 'lps'),
	(479622, 125, '2015-04-01 01:31:16.000000', 'consum', 0.0219, 'lps'),
	(479623, 125, '2015-04-01 01:31:17.000000', 'consum', 0.0229, 'lps'),
	(479624, 125, '2015-04-01 01:31:18.000000', 'consum', 0.0231, 'lps'),
	(479625, 125, '2015-04-01 01:31:19.000000', 'consum', 0.0213, 'lps'),
	(479626, 125, '2015-04-01 01:31:20.000000', 'consum', 0.0231, 'lps'),
	(479627, 125, '2015-04-01 01:31:21.000000', 'consum', 0.0212, 'lps'),
	(479628, 125, '2015-04-01 01:31:22.000000', 'consum', 0.0231, 'lps'),
	(479629, 125, '2015-04-01 01:31:23.000000', 'consum', 0.0214, 'lps'),
	(479630, 125, '2015-04-01 01:31:24.000000', 'consum', 0.0213, 'lps'),
	(479631, 125, '2015-04-01 01:31:25.000000', 'consum', 0.0215, 'lps'),
	(479632, 125, '2015-04-01 01:31:26.000000', 'consum', 0.0226, 'lps'),
	(479633, 125, '2015-04-01 01:31:27.000000', 'consum', 0.0229, 'lps'),
	(479634, 125, '2015-04-01 01:31:28.000000', 'consum', 0.0233, 'lps'),
	(479635, 125, '2015-04-01 01:31:29.000000', 'consum', 0.0219, 'lps'),
	(479636, 125, '2015-04-01 01:31:30.000000', 'consum', 0.0212, 'lps'),
	(479637, 125, '2015-04-01 01:31:31.000000', 'consum', 0.0217, 'lps'),
	(479638, 125, '2015-04-01 01:31:32.000000', 'consum', 0.0216, 'lps'),
	(479639, 125, '2015-04-01 01:31:33.000000', 'consum', 0.0218, 'lps'),
	(479640, 125, '2015-04-01 01:31:34.000000', 'consum', 0.0233, 'lps'),
	(479641, 125, '2015-04-01 01:31:35.000000', 'consum', 0.0231, 'lps'),
	(479642, 125, '2015-04-01 01:31:36.000000', 'consum', 0.0222, 'lps'),
	(479643, 125, '2015-04-01 01:31:37.000000', 'consum', 0.0230, 'lps'),
	(479644, 125, '2015-04-01 01:31:38.000000', 'consum', 0.0227, 'lps'),
	(479645, 125, '2015-04-01 01:31:39.000000', 'consum', 0.0212, 'lps'),
	(479646, 125, '2015-04-01 01:31:40.000000', 'consum', 0.0219, 'lps'),
	(479647, 125, '2015-04-01 01:31:41.000000', 'consum', 0.0222, 'lps'),
	(479648, 125, '2015-04-01 01:31:42.000000', 'consum', 0.0222, 'lps'),
	(479649, 125, '2015-04-01 01:31:43.000000', 'consum', 0.0211, 'lps'),
	(479650, 125, '2015-04-01 01:31:44.000000', 'consum', 0.0225, 'lps'),
	(479651, 125, '2015-04-01 01:31:45.000000', 'consum', 0.0212, 'lps'),
	(479652, 125, '2015-04-01 01:31:46.000000', 'consum', 0.0225, 'lps'),
	(479653, 125, '2015-04-01 01:31:47.000000', 'consum', 0.0228, 'lps'),
	(479654, 125, '2015-04-01 01:31:48.000000', 'consum', 0.0211, 'lps'),
	(479655, 125, '2015-04-01 01:31:49.000000', 'consum', 0.0231, 'lps'),
	(479656, 125, '2015-04-01 01:31:50.000000', 'consum', 0.0218, 'lps'),
	(479657, 125, '2015-04-01 01:31:51.000000', 'consum', 0.0211, 'lps'),
	(479658, 125, '2015-04-01 01:31:52.000000', 'consum', 0.0215, 'lps'),
	(479659, 125, '2015-04-01 01:31:53.000000', 'consum', 0.0233, 'lps'),
	(479660, 125, '2015-04-01 01:31:54.000000', 'consum', 0.0213, 'lps'),
	(479661, 125, '2015-04-01 01:31:55.000000', 'consum', 0.0232, 'lps'),
	(479662, 125, '2015-04-01 01:31:56.000000', 'consum', 0.0212, 'lps'),
	(479663, 125, '2015-04-01 01:31:57.000000', 'consum', 0.0228, 'lps'),
	(479664, 125, '2015-04-01 01:31:58.000000', 'consum', 0.0224, 'lps'),
	(479665, 125, '2015-04-01 01:31:59.000000', 'consum', 0.0224, 'lps'),
	(479666, 125, '2015-04-01 01:32:00.000000', 'consum', 0.0217, 'lps'),
	(479667, 125, '2015-04-01 01:32:01.000000', 'consum', 0.0228, 'lps'),
	(479668, 125, '2015-04-01 01:32:02.000000', 'consum', 0.0231, 'lps'),
	(479669, 125, '2015-04-01 01:32:03.000000', 'consum', 0.0212, 'lps'),
	(479670, 125, '2015-04-01 01:32:04.000000', 'consum', 0.0229, 'lps'),
	(479671, 125, '2015-04-01 01:32:05.000000', 'consum', 0.0229, 'lps'),
	(479672, 125, '2015-04-01 01:32:06.000000', 'consum', 0.0225, 'lps'),
	(479673, 125, '2015-04-01 01:32:07.000000', 'consum', 0.0227, 'lps'),
	(479674, 125, '2015-04-01 01:32:08.000000', 'consum', 0.0226, 'lps'),
	(479675, 125, '2015-04-01 01:32:09.000000', 'consum', 0.0216, 'lps'),
	(479676, 125, '2015-04-01 01:32:10.000000', 'consum', 0.0218, 'lps'),
	(479677, 125, '2015-04-01 01:32:11.000000', 'consum', 0.0230, 'lps'),
	(479678, 125, '2015-04-01 01:32:12.000000', 'consum', 0.0217, 'lps'),
	(479679, 125, '2015-04-01 01:32:13.000000', 'consum', 0.0210, 'lps'),
	(479680, 125, '2015-04-01 01:32:14.000000', 'consum', 0.0211, 'lps'),
	(479681, 125, '2015-04-01 01:32:15.000000', 'consum', 0.0216, 'lps'),
	(479682, 125, '2015-04-01 01:32:16.000000', 'consum', 0.0213, 'lps'),
	(479683, 125, '2015-04-01 01:32:17.000000', 'consum', 0.0231, 'lps'),
	(479684, 125, '2015-04-01 01:32:18.000000', 'consum', 0.0211, 'lps'),
	(479685, 125, '2015-04-01 01:32:19.000000', 'consum', 0.0224, 'lps'),
	(479686, 125, '2015-04-01 01:32:20.000000', 'consum', 0.0231, 'lps'),
	(479687, 125, '2015-04-01 01:32:21.000000', 'consum', 0.0227, 'lps'),
	(479688, 125, '2015-04-01 01:32:22.000000', 'consum', 0.0230, 'lps'),
	(479689, 125, '2015-04-01 01:32:23.000000', 'consum', 0.0210, 'lps'),
	(479690, 125, '2015-04-01 01:32:24.000000', 'consum', 0.0225, 'lps'),
	(479691, 125, '2015-04-01 01:32:25.000000', 'consum', 0.0214, 'lps'),
	(479692, 125, '2015-04-01 01:32:26.000000', 'consum', 0.0232, 'lps'),
	(479693, 125, '2015-04-01 01:32:27.000000', 'consum', 0.0211, 'lps'),
	(479694, 125, '2015-04-01 01:32:28.000000', 'consum', 0.0225, 'lps'),
	(479695, 125, '2015-04-01 01:32:29.000000', 'consum', 0.0233, 'lps'),
	(479696, 125, '2015-04-01 01:32:30.000000', 'consum', 0.0233, 'lps'),
	(479697, 125, '2015-04-01 01:32:31.000000', 'consum', 0.0231, 'lps'),
	(479698, 125, '2015-04-01 01:32:32.000000', 'consum', 0.0224, 'lps'),
	(479699, 125, '2015-04-01 01:32:33.000000', 'consum', 0.0215, 'lps'),
	(479700, 125, '2015-04-01 01:32:34.000000', 'consum', 0.0221, 'lps'),
	(479701, 125, '2015-04-01 01:32:35.000000', 'consum', 0.0223, 'lps'),
	(479702, 125, '2015-04-01 01:32:36.000000', 'consum', 0.0220, 'lps'),
	(479703, 125, '2015-04-01 01:32:37.000000', 'consum', 0.0222, 'lps'),
	(479704, 125, '2015-04-01 01:32:38.000000', 'consum', 0.0218, 'lps'),
	(479705, 125, '2015-04-01 01:32:39.000000', 'consum', 0.0211, 'lps'),
	(479706, 125, '2015-04-01 01:32:40.000000', 'consum', 0.0219, 'lps'),
	(479707, 125, '2015-04-01 01:32:41.000000', 'consum', 0.0227, 'lps'),
	(479708, 125, '2015-04-01 01:32:42.000000', 'consum', 0.0222, 'lps'),
	(479709, 125, '2015-04-01 01:32:43.000000', 'consum', 0.0220, 'lps'),
	(479710, 125, '2015-04-01 01:32:44.000000', 'consum', 0.0223, 'lps'),
	(479711, 125, '2015-04-01 01:32:45.000000', 'consum', 0.0222, 'lps'),
	(479712, 125, '2015-04-01 01:32:46.000000', 'consum', 0.0233, 'lps'),
	(479713, 125, '2015-04-01 01:32:47.000000', 'consum', 0.0216, 'lps'),
	(479714, 125, '2015-04-01 01:32:48.000000', 'consum', 0.0221, 'lps'),
	(479715, 125, '2015-04-01 01:32:49.000000', 'consum', 0.0221, 'lps'),
	(479716, 125, '2015-04-01 01:32:50.000000', 'consum', 0.0210, 'lps'),
	(479717, 125, '2015-04-01 01:32:51.000000', 'consum', 0.0225, 'lps'),
	(479718, 125, '2015-04-01 01:32:52.000000', 'consum', 0.0215, 'lps'),
	(479719, 125, '2015-04-01 01:32:53.000000', 'consum', 0.0212, 'lps'),
	(479720, 125, '2015-04-01 01:32:54.000000', 'consum', 0.0231, 'lps'),
	(479721, 125, '2015-04-01 01:32:55.000000', 'consum', 0.0212, 'lps'),
	(479722, 125, '2015-04-01 01:32:56.000000', 'consum', 0.0229, 'lps'),
	(479723, 125, '2015-04-01 01:32:57.000000', 'consum', 0.0227, 'lps'),
	(479724, 125, '2015-04-01 01:32:58.000000', 'consum', 0.0217, 'lps'),
	(479725, 125, '2015-04-01 01:32:59.000000', 'consum', 0.0217, 'lps'),
	(479726, 125, '2015-04-01 01:33:00.000000', 'consum', 0.0224, 'lps'),
	(479727, 125, '2015-04-01 01:33:01.000000', 'consum', 0.0211, 'lps'),
	(479728, 125, '2015-04-01 01:33:02.000000', 'consum', 0.0223, 'lps'),
	(479729, 125, '2015-04-01 01:33:03.000000', 'consum', 0.0226, 'lps'),
	(479730, 125, '2015-04-01 01:33:04.000000', 'consum', 0.0225, 'lps'),
	(479731, 125, '2015-04-01 01:33:05.000000', 'consum', 0.0216, 'lps'),
	(479732, 125, '2015-04-01 01:33:06.000000', 'consum', 0.0219, 'lps'),
	(479733, 125, '2015-04-01 01:33:07.000000', 'consum', 0.0212, 'lps'),
	(479734, 125, '2015-04-01 01:33:08.000000', 'consum', 0.0216, 'lps'),
	(479735, 125, '2015-04-01 01:33:09.000000', 'consum', 0.0213, 'lps'),
	(479736, 125, '2015-04-01 01:33:10.000000', 'consum', 0.0231, 'lps'),
	(479737, 125, '2015-04-01 01:33:11.000000', 'consum', 0.0211, 'lps'),
	(479738, 125, '2015-04-01 01:33:12.000000', 'consum', 0.0225, 'lps'),
	(479739, 125, '2015-04-01 01:33:13.000000', 'consum', 0.0210, 'lps'),
	(479740, 125, '2015-04-01 01:33:14.000000', 'consum', 0.0215, 'lps'),
	(479741, 125, '2015-04-01 01:33:15.000000', 'consum', 0.0210, 'lps'),
	(479742, 125, '2015-04-01 01:33:16.000000', 'consum', 0.0222, 'lps'),
	(479743, 125, '2015-04-01 01:33:17.000000', 'consum', 0.0219, 'lps'),
	(479744, 125, '2015-04-01 01:33:18.000000', 'consum', 0.0222, 'lps'),
	(479745, 125, '2015-04-01 01:33:19.000000', 'consum', 0.0219, 'lps'),
	(479746, 125, '2015-04-01 01:33:20.000000', 'consum', 0.0217, 'lps'),
	(479747, 125, '2015-04-01 01:33:21.000000', 'consum', 0.0221, 'lps'),
	(479748, 125, '2015-04-01 01:33:22.000000', 'consum', 0.0220, 'lps'),
	(479749, 125, '2015-04-01 01:33:23.000000', 'consum', 0.0229, 'lps'),
	(479750, 125, '2015-04-01 01:33:24.000000', 'consum', 0.0226, 'lps'),
	(479751, 125, '2015-04-01 01:33:25.000000', 'consum', 0.0212, 'lps'),
	(479752, 125, '2015-04-01 01:33:26.000000', 'consum', 0.0217, 'lps'),
	(479753, 125, '2015-04-01 01:33:27.000000', 'consum', 0.0217, 'lps'),
	(479754, 125, '2015-04-01 01:33:28.000000', 'consum', 0.0223, 'lps'),
	(479755, 125, '2015-04-01 01:33:29.000000', 'consum', 0.0229, 'lps'),
	(479756, 125, '2015-04-01 01:33:30.000000', 'consum', 0.0222, 'lps'),
	(479757, 125, '2015-04-01 01:33:31.000000', 'consum', 0.0211, 'lps'),
	(479758, 125, '2015-04-01 01:33:32.000000', 'consum', 0.0228, 'lps'),
	(479759, 125, '2015-04-01 01:33:33.000000', 'consum', 0.0228, 'lps'),
	(479760, 125, '2015-04-01 01:33:34.000000', 'consum', 0.0219, 'lps'),
	(479761, 125, '2015-04-01 01:33:35.000000', 'consum', 0.0228, 'lps'),
	(479762, 125, '2015-04-01 01:33:36.000000', 'consum', 0.0223, 'lps'),
	(479763, 125, '2015-04-01 01:33:37.000000', 'consum', 0.0222, 'lps'),
	(479764, 125, '2015-04-01 01:33:38.000000', 'consum', 0.0231, 'lps'),
	(479765, 125, '2015-04-01 01:33:39.000000', 'consum', 0.0210, 'lps'),
	(479766, 125, '2015-04-01 01:33:40.000000', 'consum', 0.0219, 'lps'),
	(479767, 125, '2015-04-01 01:33:41.000000', 'consum', 0.0230, 'lps'),
	(479768, 125, '2015-04-01 01:33:42.000000', 'consum', 0.0213, 'lps'),
	(479769, 125, '2015-04-01 01:33:43.000000', 'consum', 0.0213, 'lps'),
	(479770, 125, '2015-04-01 01:33:44.000000', 'consum', 0.0217, 'lps'),
	(479771, 125, '2015-04-01 01:33:45.000000', 'consum', 0.0210, 'lps'),
	(479772, 125, '2015-04-01 01:33:46.000000', 'consum', 0.0215, 'lps'),
	(479773, 125, '2015-04-01 01:33:47.000000', 'consum', 0.0211, 'lps'),
	(479774, 125, '2015-04-01 01:33:48.000000', 'consum', 0.0225, 'lps'),
	(479775, 125, '2015-04-01 01:33:49.000000', 'consum', 0.0233, 'lps'),
	(479776, 125, '2015-04-01 01:33:50.000000', 'consum', 0.0211, 'lps'),
	(479777, 125, '2015-04-01 01:33:51.000000', 'consum', 0.0217, 'lps'),
	(479778, 125, '2015-04-01 01:33:52.000000', 'consum', 0.0218, 'lps'),
	(479779, 125, '2015-04-01 01:33:53.000000', 'consum', 0.0229, 'lps'),
	(479780, 125, '2015-04-01 01:33:54.000000', 'consum', 0.0233, 'lps'),
	(479781, 125, '2015-04-01 01:33:55.000000', 'consum', 0.0220, 'lps'),
	(479782, 125, '2015-04-01 01:33:56.000000', 'consum', 0.0217, 'lps'),
	(479783, 125, '2015-04-01 01:33:57.000000', 'consum', 0.0214, 'lps'),
	(479784, 125, '2015-04-01 01:33:58.000000', 'consum', 0.0210, 'lps'),
	(479785, 125, '2015-04-01 01:33:59.000000', 'consum', 0.0221, 'lps'),
	(479786, 125, '2015-04-01 01:34:00.000000', 'consum', 0.0218, 'lps'),
	(479787, 125, '2015-04-01 01:34:01.000000', 'consum', 0.0218, 'lps'),
	(479788, 125, '2015-04-01 01:34:02.000000', 'consum', 0.0227, 'lps'),
	(479789, 125, '2015-04-01 01:34:03.000000', 'consum', 0.0224, 'lps'),
	(479790, 125, '2015-04-01 01:34:04.000000', 'consum', 0.0227, 'lps'),
	(479791, 125, '2015-04-01 01:34:05.000000', 'consum', 0.0230, 'lps'),
	(479792, 125, '2015-04-01 01:34:06.000000', 'consum', 0.0213, 'lps'),
	(479793, 125, '2015-04-01 01:34:07.000000', 'consum', 0.0214, 'lps'),
	(479794, 125, '2015-04-01 01:34:08.000000', 'consum', 0.0222, 'lps'),
	(479795, 125, '2015-04-01 01:34:09.000000', 'consum', 0.0210, 'lps'),
	(479796, 125, '2015-04-01 01:34:10.000000', 'consum', 0.0221, 'lps'),
	(479797, 125, '2015-04-01 01:34:11.000000', 'consum', 0.0219, 'lps'),
	(479798, 125, '2015-04-01 01:34:12.000000', 'consum', 0.0223, 'lps'),
	(479799, 125, '2015-04-01 01:34:13.000000', 'consum', 0.0222, 'lps'),
	(479800, 125, '2015-04-01 01:34:14.000000', 'consum', 0.0232, 'lps'),
	(479801, 125, '2015-04-01 01:34:15.000000', 'consum', 0.0215, 'lps'),
	(479802, 125, '2015-04-01 01:34:16.000000', 'consum', 0.0214, 'lps'),
	(479803, 125, '2015-04-01 01:34:17.000000', 'consum', 0.0217, 'lps'),
	(479804, 125, '2015-04-01 01:34:18.000000', 'consum', 0.0211, 'lps'),
	(479805, 125, '2015-04-01 01:34:19.000000', 'consum', 0.0218, 'lps'),
	(479806, 125, '2015-04-01 01:34:20.000000', 'consum', 0.0222, 'lps'),
	(479807, 125, '2015-04-01 01:34:21.000000', 'consum', 0.0225, 'lps'),
	(479808, 125, '2015-04-01 01:34:22.000000', 'consum', 0.0223, 'lps'),
	(479809, 125, '2015-04-01 01:34:23.000000', 'consum', 0.0231, 'lps'),
	(479810, 125, '2015-04-01 01:34:24.000000', 'consum', 0.0231, 'lps'),
	(479811, 125, '2015-04-01 01:34:25.000000', 'consum', 0.0226, 'lps'),
	(479812, 125, '2015-04-01 01:34:26.000000', 'consum', 0.0227, 'lps'),
	(479813, 125, '2015-04-01 01:34:27.000000', 'consum', 0.0223, 'lps'),
	(479814, 125, '2015-04-01 01:34:28.000000', 'consum', 0.0225, 'lps'),
	(479815, 125, '2015-04-01 01:34:29.000000', 'consum', 0.0221, 'lps'),
	(479816, 125, '2015-04-01 01:34:30.000000', 'consum', 0.0222, 'lps'),
	(479817, 125, '2015-04-01 01:34:31.000000', 'consum', 0.0215, 'lps'),
	(479818, 125, '2015-04-01 01:34:32.000000', 'consum', 0.0223, 'lps'),
	(479819, 125, '2015-04-01 01:34:33.000000', 'consum', 0.0211, 'lps'),
	(479820, 125, '2015-04-01 01:34:34.000000', 'consum', 0.0224, 'lps'),
	(479821, 125, '2015-04-01 01:34:35.000000', 'consum', 0.0229, 'lps'),
	(479822, 125, '2015-04-01 01:34:36.000000', 'consum', 0.0215, 'lps'),
	(479823, 125, '2015-04-01 01:34:37.000000', 'consum', 0.0229, 'lps'),
	(479824, 125, '2015-04-01 01:34:38.000000', 'consum', 0.0218, 'lps'),
	(479825, 125, '2015-04-01 01:34:39.000000', 'consum', 0.0216, 'lps'),
	(479826, 125, '2015-04-01 01:34:40.000000', 'consum', 0.0219, 'lps'),
	(479827, 125, '2015-04-01 01:34:41.000000', 'consum', 0.0211, 'lps'),
	(479828, 125, '2015-04-01 01:34:42.000000', 'consum', 0.0215, 'lps'),
	(479829, 125, '2015-04-01 01:34:43.000000', 'consum', 0.0233, 'lps'),
	(479830, 125, '2015-04-01 01:34:44.000000', 'consum', 0.0215, 'lps'),
	(479831, 125, '2015-04-01 01:34:45.000000', 'consum', 0.0212, 'lps'),
	(479832, 125, '2015-04-01 01:34:46.000000', 'consum', 0.0230, 'lps'),
	(479833, 125, '2015-04-01 01:34:47.000000', 'consum', 0.0231, 'lps'),
	(479834, 125, '2015-04-01 01:34:48.000000', 'consum', 0.0233, 'lps'),
	(479835, 125, '2015-04-01 01:34:49.000000', 'consum', 0.0216, 'lps'),
	(479836, 125, '2015-04-01 01:34:50.000000', 'consum', 0.0217, 'lps'),
	(479837, 125, '2015-04-01 01:34:51.000000', 'consum', 0.0228, 'lps'),
	(479838, 125, '2015-04-01 01:34:52.000000', 'consum', 0.0230, 'lps'),
	(479839, 125, '2015-04-01 01:34:53.000000', 'consum', 0.0211, 'lps'),
	(479840, 125, '2015-04-01 01:34:54.000000', 'consum', 0.0227, 'lps'),
	(479841, 125, '2015-04-01 01:34:55.000000', 'consum', 0.0220, 'lps'),
	(479842, 125, '2015-04-01 01:34:56.000000', 'consum', 0.0233, 'lps'),
	(479843, 125, '2015-04-01 01:34:57.000000', 'consum', 0.0223, 'lps'),
	(479844, 125, '2015-04-01 01:34:58.000000', 'consum', 0.0230, 'lps'),
	(479845, 125, '2015-04-01 01:34:59.000000', 'consum', 0.0226, 'lps'),
	(479846, 125, '2015-04-01 01:35:00.000000', 'consum', 0.0229, 'lps'),
	(479847, 125, '2015-04-01 01:35:01.000000', 'consum', 0.0211, 'lps'),
	(479848, 125, '2015-04-01 01:35:02.000000', 'consum', 0.0231, 'lps'),
	(479849, 125, '2015-04-01 01:35:03.000000', 'consum', 0.0215, 'lps'),
	(479850, 125, '2015-04-01 01:35:04.000000', 'consum', 0.0220, 'lps'),
	(479851, 125, '2015-04-01 01:35:05.000000', 'consum', 0.0222, 'lps'),
	(479852, 125, '2015-04-01 01:35:06.000000', 'consum', 0.0215, 'lps'),
	(479853, 125, '2015-04-01 01:35:07.000000', 'consum', 0.0225, 'lps'),
	(479854, 125, '2015-04-01 01:35:08.000000', 'consum', 0.0223, 'lps'),
	(479855, 125, '2015-04-01 01:35:09.000000', 'consum', 0.0229, 'lps'),
	(479856, 125, '2015-04-01 01:35:10.000000', 'consum', 0.0218, 'lps'),
	(479857, 125, '2015-04-01 01:35:11.000000', 'consum', 0.0220, 'lps'),
	(479858, 125, '2015-04-01 01:35:12.000000', 'consum', 0.0233, 'lps'),
	(479859, 125, '2015-04-01 01:35:13.000000', 'consum', 0.0226, 'lps'),
	(479860, 125, '2015-04-01 01:35:14.000000', 'consum', 0.0221, 'lps'),
	(479861, 125, '2015-04-01 01:35:15.000000', 'consum', 0.0219, 'lps'),
	(479862, 125, '2015-04-01 01:35:16.000000', 'consum', 0.0223, 'lps'),
	(479863, 125, '2015-04-01 01:35:17.000000', 'consum', 0.0225, 'lps'),
	(479864, 125, '2015-04-01 01:35:18.000000', 'consum', 0.0220, 'lps'),
	(479865, 125, '2015-04-01 01:35:19.000000', 'consum', 0.0218, 'lps'),
	(479866, 125, '2015-04-01 01:35:20.000000', 'consum', 0.0217, 'lps'),
	(479867, 125, '2015-04-01 01:35:21.000000', 'consum', 0.0225, 'lps'),
	(479868, 125, '2015-04-01 01:35:22.000000', 'consum', 0.0216, 'lps'),
	(479869, 125, '2015-04-01 01:35:23.000000', 'consum', 0.0217, 'lps'),
	(479870, 125, '2015-04-01 01:35:24.000000', 'consum', 0.0231, 'lps'),
	(479871, 125, '2015-04-01 01:35:25.000000', 'consum', 0.0220, 'lps'),
	(479872, 125, '2015-04-01 01:35:26.000000', 'consum', 0.0224, 'lps'),
	(479873, 125, '2015-04-01 01:35:27.000000', 'consum', 0.0225, 'lps'),
	(479874, 125, '2015-04-01 01:35:28.000000', 'consum', 0.0221, 'lps'),
	(479875, 125, '2015-04-01 01:35:29.000000', 'consum', 0.0220, 'lps'),
	(479876, 125, '2015-04-01 01:35:30.000000', 'consum', 0.0227, 'lps'),
	(479877, 125, '2015-04-01 01:35:31.000000', 'consum', 0.0218, 'lps'),
	(479878, 125, '2015-04-01 01:35:32.000000', 'consum', 0.0224, 'lps'),
	(479879, 125, '2015-04-01 01:35:33.000000', 'consum', 0.0231, 'lps'),
	(479880, 125, '2015-04-01 01:35:34.000000', 'consum', 0.0228, 'lps'),
	(479881, 125, '2015-04-01 01:35:35.000000', 'consum', 0.0212, 'lps'),
	(479882, 125, '2015-04-01 01:35:36.000000', 'consum', 0.0216, 'lps'),
	(479883, 125, '2015-04-01 01:35:37.000000', 'consum', 0.0211, 'lps'),
	(479884, 125, '2015-04-01 01:35:38.000000', 'consum', 0.0221, 'lps'),
	(479885, 125, '2015-04-01 01:35:39.000000', 'consum', 0.0213, 'lps'),
	(479886, 125, '2015-04-01 01:35:40.000000', 'consum', 0.0216, 'lps'),
	(479887, 125, '2015-04-01 01:35:41.000000', 'consum', 0.0233, 'lps'),
	(479888, 125, '2015-04-01 01:35:42.000000', 'consum', 0.0210, 'lps'),
	(479889, 125, '2015-04-01 01:35:43.000000', 'consum', 0.0216, 'lps'),
	(479890, 125, '2015-04-01 01:35:44.000000', 'consum', 0.0214, 'lps'),
	(479891, 125, '2015-04-01 01:35:45.000000', 'consum', 0.0213, 'lps'),
	(479892, 125, '2015-04-01 01:35:46.000000', 'consum', 0.0214, 'lps'),
	(479893, 125, '2015-04-01 01:35:47.000000', 'consum', 0.0222, 'lps'),
	(479894, 125, '2015-04-01 01:35:48.000000', 'consum', 0.0212, 'lps'),
	(479895, 125, '2015-04-01 01:35:49.000000', 'consum', 0.0232, 'lps'),
	(479896, 125, '2015-04-01 01:35:50.000000', 'consum', 0.0216, 'lps'),
	(479897, 125, '2015-04-01 01:35:51.000000', 'consum', 0.0226, 'lps'),
	(479898, 125, '2015-04-01 01:35:52.000000', 'consum', 0.0221, 'lps'),
	(479899, 125, '2015-04-01 01:35:53.000000', 'consum', 0.0218, 'lps'),
	(479900, 125, '2015-04-01 01:35:54.000000', 'consum', 0.0219, 'lps'),
	(479901, 125, '2015-04-01 01:35:55.000000', 'consum', 0.0233, 'lps'),
	(479902, 125, '2015-04-01 01:35:56.000000', 'consum', 0.0223, 'lps'),
	(479903, 125, '2015-04-01 01:35:57.000000', 'consum', 0.0232, 'lps'),
	(479904, 125, '2015-04-01 01:35:58.000000', 'consum', 0.0211, 'lps'),
	(479905, 125, '2015-04-01 01:35:59.000000', 'consum', 0.0219, 'lps'),
	(479906, 125, '2015-04-01 01:36:00.000000', 'consum', 0.0231, 'lps'),
	(479907, 125, '2015-04-01 01:36:01.000000', 'consum', 0.0217, 'lps'),
	(479908, 125, '2015-04-01 01:36:02.000000', 'consum', 0.0230, 'lps'),
	(479909, 125, '2015-04-01 01:36:03.000000', 'consum', 0.0219, 'lps'),
	(479910, 125, '2015-04-01 01:36:04.000000', 'consum', 0.0216, 'lps'),
	(479911, 125, '2015-04-01 01:36:05.000000', 'consum', 0.0215, 'lps'),
	(479912, 125, '2015-04-01 01:36:06.000000', 'consum', 0.0218, 'lps'),
	(479913, 125, '2015-04-01 01:36:07.000000', 'consum', 0.0212, 'lps'),
	(479914, 125, '2015-04-01 01:36:08.000000', 'consum', 0.0221, 'lps'),
	(479915, 125, '2015-04-01 01:36:09.000000', 'consum', 0.0212, 'lps'),
	(479916, 125, '2015-04-01 01:36:10.000000', 'consum', 0.0213, 'lps'),
	(479917, 125, '2015-04-01 01:36:11.000000', 'consum', 0.0216, 'lps'),
	(479918, 125, '2015-04-01 01:36:12.000000', 'consum', 0.0232, 'lps'),
	(479919, 125, '2015-04-01 01:36:13.000000', 'consum', 0.0232, 'lps'),
	(479920, 125, '2015-04-01 01:36:14.000000', 'consum', 0.0231, 'lps'),
	(479921, 125, '2015-04-01 01:36:15.000000', 'consum', 0.0226, 'lps'),
	(479922, 125, '2015-04-01 01:36:16.000000', 'consum', 0.0226, 'lps'),
	(479923, 125, '2015-04-01 01:36:17.000000', 'consum', 0.0220, 'lps'),
	(479924, 125, '2015-04-01 01:36:18.000000', 'consum', 0.0211, 'lps'),
	(479925, 125, '2015-04-01 01:36:19.000000', 'consum', 0.0211, 'lps'),
	(479926, 125, '2015-04-01 01:36:20.000000', 'consum', 0.0213, 'lps'),
	(479927, 125, '2015-04-01 01:36:21.000000', 'consum', 0.0222, 'lps'),
	(479928, 125, '2015-04-01 01:36:22.000000', 'consum', 0.0213, 'lps'),
	(479929, 125, '2015-04-01 01:36:23.000000', 'consum', 0.0216, 'lps'),
	(479930, 125, '2015-04-01 01:36:24.000000', 'consum', 0.0229, 'lps'),
	(479931, 125, '2015-04-01 01:36:25.000000', 'consum', 0.0215, 'lps'),
	(479932, 125, '2015-04-01 01:36:26.000000', 'consum', 0.0227, 'lps'),
	(479933, 125, '2015-04-01 01:36:27.000000', 'consum', 0.0210, 'lps'),
	(479934, 125, '2015-04-01 01:36:28.000000', 'consum', 0.0233, 'lps'),
	(479935, 125, '2015-04-01 01:36:29.000000', 'consum', 0.0226, 'lps'),
	(479936, 125, '2015-04-01 01:36:30.000000', 'consum', 0.0225, 'lps'),
	(479937, 125, '2015-04-01 01:36:31.000000', 'consum', 0.0211, 'lps'),
	(479938, 125, '2015-04-01 01:36:32.000000', 'consum', 0.0219, 'lps'),
	(479939, 125, '2015-04-01 01:36:33.000000', 'consum', 0.0229, 'lps'),
	(479940, 125, '2015-04-01 01:36:34.000000', 'consum', 0.0230, 'lps'),
	(479941, 125, '2015-04-01 01:36:35.000000', 'consum', 0.0229, 'lps'),
	(479942, 125, '2015-04-01 01:36:36.000000', 'consum', 0.0221, 'lps'),
	(479943, 125, '2015-04-01 01:36:37.000000', 'consum', 0.0232, 'lps'),
	(479944, 125, '2015-04-01 01:36:38.000000', 'consum', 0.0215, 'lps'),
	(479945, 125, '2015-04-01 01:36:39.000000', 'consum', 0.0216, 'lps'),
	(479946, 125, '2015-04-01 01:36:40.000000', 'consum', 0.0229, 'lps'),
	(479947, 125, '2015-04-01 01:36:41.000000', 'consum', 0.0213, 'lps'),
	(479948, 125, '2015-04-01 01:36:42.000000', 'consum', 0.0217, 'lps'),
	(479949, 125, '2015-04-01 01:36:43.000000', 'consum', 0.0211, 'lps'),
	(479950, 125, '2015-04-01 01:36:44.000000', 'consum', 0.0219, 'lps'),
	(479951, 125, '2015-04-01 01:36:45.000000', 'consum', 0.0228, 'lps'),
	(479952, 125, '2015-04-01 01:36:46.000000', 'consum', 0.0228, 'lps'),
	(479953, 125, '2015-04-01 01:36:47.000000', 'consum', 0.0222, 'lps'),
	(479954, 125, '2015-04-01 01:36:48.000000', 'consum', 0.0217, 'lps'),
	(479955, 125, '2015-04-01 01:36:49.000000', 'consum', 0.0232, 'lps'),
	(479956, 125, '2015-04-01 01:36:50.000000', 'consum', 0.0226, 'lps'),
	(479957, 125, '2015-04-01 01:36:51.000000', 'consum', 0.0228, 'lps'),
	(479958, 125, '2015-04-01 01:36:52.000000', 'consum', 0.0225, 'lps'),
	(479959, 125, '2015-04-01 01:36:53.000000', 'consum', 0.0233, 'lps'),
	(479960, 125, '2015-04-01 01:36:54.000000', 'consum', 0.0210, 'lps'),
	(479961, 125, '2015-04-01 01:36:55.000000', 'consum', 0.0210, 'lps'),
	(479962, 125, '2015-04-01 01:36:56.000000', 'consum', 0.0214, 'lps'),
	(479963, 125, '2015-04-01 01:36:57.000000', 'consum', 0.0231, 'lps'),
	(479964, 125, '2015-04-01 01:36:58.000000', 'consum', 0.0229, 'lps'),
	(479965, 125, '2015-04-01 01:36:59.000000', 'consum', 0.0219, 'lps'),
	(479966, 125, '2015-04-01 01:37:00.000000', 'consum', 0.0222, 'lps'),
	(479967, 125, '2015-04-01 01:37:01.000000', 'consum', 0.0218, 'lps'),
	(479968, 125, '2015-04-01 01:37:02.000000', 'consum', 0.0216, 'lps'),
	(479969, 125, '2015-04-01 01:37:03.000000', 'consum', 0.0218, 'lps'),
	(479970, 125, '2015-04-01 01:37:04.000000', 'consum', 0.0230, 'lps'),
	(479971, 125, '2015-04-01 01:37:05.000000', 'consum', 0.0215, 'lps'),
	(479972, 125, '2015-04-01 01:37:06.000000', 'consum', 0.0223, 'lps'),
	(479973, 125, '2015-04-01 01:37:07.000000', 'consum', 0.0212, 'lps'),
	(479974, 125, '2015-04-01 01:37:08.000000', 'consum', 0.0232, 'lps'),
	(479975, 125, '2015-04-01 01:37:09.000000', 'consum', 0.0216, 'lps'),
	(479976, 125, '2015-04-01 01:37:10.000000', 'consum', 0.0225, 'lps'),
	(479977, 125, '2015-04-01 01:37:11.000000', 'consum', 0.0218, 'lps'),
	(479978, 125, '2015-04-01 01:37:12.000000', 'consum', 0.0229, 'lps'),
	(479979, 125, '2015-04-01 01:37:13.000000', 'consum', 0.0212, 'lps'),
	(479980, 125, '2015-04-01 01:37:14.000000', 'consum', 0.0210, 'lps'),
	(479981, 125, '2015-04-01 01:37:15.000000', 'consum', 0.0228, 'lps'),
	(479982, 125, '2015-04-01 01:37:16.000000', 'consum', 0.0227, 'lps'),
	(479983, 125, '2015-04-01 01:37:17.000000', 'consum', 0.0221, 'lps'),
	(479984, 125, '2015-04-01 01:37:18.000000', 'consum', 0.0212, 'lps'),
	(479985, 125, '2015-04-01 01:37:19.000000', 'consum', 0.0210, 'lps'),
	(479986, 125, '2015-04-01 01:37:20.000000', 'consum', 0.0230, 'lps'),
	(479987, 125, '2015-04-01 01:37:21.000000', 'consum', 0.0216, 'lps'),
	(479988, 125, '2015-04-01 01:37:22.000000', 'consum', 0.0229, 'lps'),
	(479989, 125, '2015-04-01 01:37:23.000000', 'consum', 0.0213, 'lps'),
	(479990, 125, '2015-04-01 01:37:24.000000', 'consum', 0.0217, 'lps'),
	(479991, 125, '2015-04-01 01:37:25.000000', 'consum', 0.0212, 'lps'),
	(479992, 125, '2015-04-01 01:37:26.000000', 'consum', 0.0225, 'lps'),
	(479993, 125, '2015-04-01 01:37:27.000000', 'consum', 0.0229, 'lps'),
	(479994, 125, '2015-04-01 01:37:28.000000', 'consum', 0.0213, 'lps'),
	(479995, 125, '2015-04-01 01:37:29.000000', 'consum', 0.0219, 'lps'),
	(479996, 125, '2015-04-01 01:37:30.000000', 'consum', 0.0221, 'lps'),
	(479997, 125, '2015-04-01 01:37:31.000000', 'consum', 0.0214, 'lps'),
	(479998, 125, '2015-04-01 01:37:32.000000', 'consum', 0.0224, 'lps'),
	(479999, 125, '2015-04-01 01:37:33.000000', 'consum', 0.0218, 'lps'),
	(480000, 125, '2015-04-01 01:37:34.000000', 'consum', 0.0233, 'lps'),
	(480001, 125, '2015-04-01 01:37:35.000000', 'consum', 0.0231, 'lps'),
	(480002, 125, '2015-04-01 01:37:36.000000', 'consum', 0.0221, 'lps'),
	(480003, 125, '2015-04-01 01:37:37.000000', 'consum', 0.0226, 'lps'),
	(480004, 125, '2015-04-01 01:37:38.000000', 'consum', 0.0211, 'lps'),
	(480005, 125, '2015-04-01 01:37:39.000000', 'consum', 0.0213, 'lps'),
	(480006, 125, '2015-04-01 01:37:40.000000', 'consum', 0.0225, 'lps'),
	(480007, 125, '2015-04-01 01:37:41.000000', 'consum', 0.0227, 'lps'),
	(480008, 125, '2015-04-01 01:37:42.000000', 'consum', 0.0226, 'lps'),
	(480009, 125, '2015-04-01 01:37:43.000000', 'consum', 0.0216, 'lps'),
	(480010, 125, '2015-04-01 01:37:44.000000', 'consum', 0.0217, 'lps'),
	(480011, 125, '2015-04-01 01:37:45.000000', 'consum', 0.0227, 'lps'),
	(480012, 125, '2015-04-01 01:37:46.000000', 'consum', 0.0228, 'lps'),
	(480013, 125, '2015-04-01 01:37:47.000000', 'consum', 0.0225, 'lps'),
	(480014, 125, '2015-04-01 01:37:48.000000', 'consum', 0.0233, 'lps'),
	(480015, 125, '2015-04-01 01:37:49.000000', 'consum', 0.0232, 'lps'),
	(480016, 125, '2015-04-01 01:37:50.000000', 'consum', 0.0227, 'lps'),
	(480017, 125, '2015-04-01 01:37:51.000000', 'consum', 0.0230, 'lps'),
	(480018, 125, '2015-04-01 01:37:52.000000', 'consum', 0.0212, 'lps'),
	(480019, 125, '2015-04-01 01:37:53.000000', 'consum', 0.0230, 'lps'),
	(480020, 125, '2015-04-01 01:37:54.000000', 'consum', 0.0233, 'lps'),
	(480021, 125, '2015-04-01 01:37:55.000000', 'consum', 0.0217, 'lps'),
	(480022, 125, '2015-04-01 01:37:56.000000', 'consum', 0.0227, 'lps'),
	(480023, 125, '2015-04-01 01:37:57.000000', 'consum', 0.0227, 'lps'),
	(480024, 125, '2015-04-01 01:37:58.000000', 'consum', 0.0217, 'lps'),
	(480025, 125, '2015-04-01 01:37:59.000000', 'consum', 0.0221, 'lps'),
	(480026, 125, '2015-04-01 01:38:00.000000', 'consum', 0.0222, 'lps'),
	(480027, 125, '2015-04-01 01:38:01.000000', 'consum', 0.0210, 'lps'),
	(480028, 125, '2015-04-01 01:38:02.000000', 'consum', 0.0224, 'lps'),
	(480029, 125, '2015-04-01 01:38:03.000000', 'consum', 0.0210, 'lps'),
	(480030, 125, '2015-04-01 01:38:04.000000', 'consum', 0.0214, 'lps'),
	(480031, 125, '2015-04-01 01:38:05.000000', 'consum', 0.0232, 'lps'),
	(480032, 125, '2015-04-01 01:38:06.000000', 'consum', 0.0211, 'lps'),
	(480033, 125, '2015-04-01 01:38:07.000000', 'consum', 0.0222, 'lps'),
	(480034, 126, '2015-04-01 00:00:00.000000', 'consum', 0.0216, 'lps'),
	(480035, 126, '2015-04-01 00:00:01.000000', 'consum', 0.0215, 'lps'),
	(480036, 126, '2015-04-01 00:00:02.000000', 'consum', 0.0217, 'lps'),
	(480037, 126, '2015-04-01 00:00:03.000000', 'consum', 0.0214, 'lps'),
	(480038, 126, '2015-04-01 00:00:04.000000', 'consum', 0.0227, 'lps'),
	(480039, 126, '2015-04-01 00:00:05.000000', 'consum', 0.0227, 'lps'),
	(480040, 126, '2015-04-01 00:00:06.000000', 'consum', 0.0227, 'lps'),
	(480041, 126, '2015-04-01 00:00:07.000000', 'consum', 0.0211, 'lps'),
	(480042, 126, '2015-04-01 00:00:08.000000', 'consum', 0.0216, 'lps'),
	(480043, 126, '2015-04-01 00:00:09.000000', 'consum', 0.0219, 'lps'),
	(480044, 126, '2015-04-01 00:00:10.000000', 'consum', 0.0221, 'lps'),
	(480045, 126, '2015-04-01 00:00:11.000000', 'consum', 0.0220, 'lps'),
	(480046, 126, '2015-04-01 00:00:12.000000', 'consum', 0.0226, 'lps'),
	(480047, 126, '2015-04-01 00:00:13.000000', 'consum', 0.0226, 'lps'),
	(480048, 126, '2015-04-01 00:00:14.000000', 'consum', 0.0223, 'lps'),
	(480049, 126, '2015-04-01 00:00:15.000000', 'consum', 0.0211, 'lps'),
	(480050, 126, '2015-04-01 00:00:16.000000', 'consum', 0.0214, 'lps'),
	(480051, 126, '2015-04-01 00:00:17.000000', 'consum', 0.0225, 'lps'),
	(480052, 126, '2015-04-01 00:00:18.000000', 'consum', 0.0222, 'lps'),
	(480053, 126, '2015-04-01 00:00:19.000000', 'consum', 0.0225, 'lps'),
	(480054, 126, '2015-04-01 00:00:20.000000', 'consum', 0.0214, 'lps'),
	(480055, 126, '2015-04-01 00:00:21.000000', 'consum', 0.0223, 'lps'),
	(480056, 126, '2015-04-01 00:00:22.000000', 'consum', 0.0225, 'lps'),
	(480057, 126, '2015-04-01 00:00:23.000000', 'consum', 0.0227, 'lps'),
	(480058, 126, '2015-04-01 00:00:24.000000', 'consum', 0.0217, 'lps'),
	(480059, 126, '2015-04-01 00:00:25.000000', 'consum', 0.0211, 'lps'),
	(480060, 126, '2015-04-01 00:00:26.000000', 'consum', 0.0211, 'lps'),
	(480061, 126, '2015-04-01 00:00:27.000000', 'consum', 0.0214, 'lps'),
	(480062, 126, '2015-04-01 00:00:28.000000', 'consum', 0.0211, 'lps'),
	(480063, 126, '2015-04-01 00:00:29.000000', 'consum', 0.0222, 'lps'),
	(480064, 126, '2015-04-01 00:00:30.000000', 'consum', 0.0214, 'lps'),
	(480065, 126, '2015-04-01 00:00:31.000000', 'consum', 0.0211, 'lps'),
	(480066, 126, '2015-04-01 00:00:32.000000', 'consum', 0.0223, 'lps'),
	(480067, 126, '2015-04-01 00:00:33.000000', 'consum', 0.0217, 'lps'),
	(480068, 126, '2015-04-01 00:00:34.000000', 'consum', 0.0225, 'lps'),
	(480069, 126, '2015-04-01 00:00:35.000000', 'consum', 0.0210, 'lps'),
	(480070, 126, '2015-04-01 00:00:36.000000', 'consum', 0.0222, 'lps'),
	(480071, 126, '2015-04-01 00:00:37.000000', 'consum', 0.0214, 'lps'),
	(480072, 126, '2015-04-01 00:00:38.000000', 'consum', 0.0212, 'lps'),
	(480073, 126, '2015-04-01 00:00:39.000000', 'consum', 0.0210, 'lps'),
	(480074, 126, '2015-04-01 00:00:40.000000', 'consum', 0.0223, 'lps'),
	(480075, 126, '2015-04-01 00:00:41.000000', 'consum', 0.0220, 'lps'),
	(480076, 126, '2015-04-01 00:00:42.000000', 'consum', 0.0224, 'lps'),
	(480077, 126, '2015-04-01 00:00:43.000000', 'consum', 0.0214, 'lps'),
	(480078, 126, '2015-04-01 00:00:44.000000', 'consum', 0.0223, 'lps'),
	(480079, 126, '2015-04-01 00:00:45.000000', 'consum', 0.0211, 'lps'),
	(480080, 126, '2015-04-01 00:00:46.000000', 'consum', 0.0211, 'lps'),
	(480081, 126, '2015-04-01 00:00:47.000000', 'consum', 0.0213, 'lps'),
	(480082, 126, '2015-04-01 00:00:48.000000', 'consum', 0.0224, 'lps'),
	(480083, 126, '2015-04-01 00:00:49.000000', 'consum', 0.0218, 'lps'),
	(480084, 126, '2015-04-01 00:00:50.000000', 'consum', 0.0225, 'lps'),
	(480085, 126, '2015-04-01 00:00:51.000000', 'consum', 0.0226, 'lps'),
	(480086, 126, '2015-04-01 00:00:52.000000', 'consum', 0.0210, 'lps'),
	(480087, 126, '2015-04-01 00:00:53.000000', 'consum', 0.0214, 'lps'),
	(480088, 126, '2015-04-01 00:00:54.000000', 'consum', 0.0214, 'lps'),
	(480089, 126, '2015-04-01 00:00:55.000000', 'consum', 0.0220, 'lps'),
	(480090, 126, '2015-04-01 00:00:56.000000', 'consum', 0.0212, 'lps'),
	(480091, 126, '2015-04-01 00:00:57.000000', 'consum', 0.0225, 'lps'),
	(480092, 126, '2015-04-01 00:00:58.000000', 'consum', 0.0226, 'lps'),
	(480093, 126, '2015-04-01 00:00:59.000000', 'consum', 0.0227, 'lps'),
	(480094, 126, '2015-04-01 00:01:00.000000', 'consum', 0.0213, 'lps'),
	(480095, 126, '2015-04-01 00:01:01.000000', 'consum', 0.0227, 'lps'),
	(480096, 126, '2015-04-01 00:01:02.000000', 'consum', 0.0214, 'lps'),
	(480097, 126, '2015-04-01 00:01:03.000000', 'consum', 0.0215, 'lps'),
	(480098, 126, '2015-04-01 00:01:04.000000', 'consum', 0.0225, 'lps'),
	(480099, 126, '2015-04-01 00:01:05.000000', 'consum', 0.0216, 'lps'),
	(480100, 126, '2015-04-01 00:01:06.000000', 'consum', 0.0213, 'lps'),
	(480101, 126, '2015-04-01 00:01:07.000000', 'consum', 0.0226, 'lps'),
	(480102, 126, '2015-04-01 00:01:08.000000', 'consum', 0.0227, 'lps'),
	(480103, 126, '2015-04-01 00:01:09.000000', 'consum', 0.0211, 'lps'),
	(480104, 126, '2015-04-01 00:01:10.000000', 'consum', 0.0219, 'lps'),
	(480105, 126, '2015-04-01 00:01:11.000000', 'consum', 0.0216, 'lps'),
	(480106, 126, '2015-04-01 00:01:12.000000', 'consum', 0.0214, 'lps'),
	(480107, 126, '2015-04-01 00:01:13.000000', 'consum', 0.0213, 'lps'),
	(480108, 126, '2015-04-01 00:01:14.000000', 'consum', 0.0212, 'lps'),
	(480109, 126, '2015-04-01 00:01:15.000000', 'consum', 0.0212, 'lps'),
	(480110, 126, '2015-04-01 00:01:16.000000', 'consum', 0.0215, 'lps'),
	(480111, 126, '2015-04-01 00:01:17.000000', 'consum', 0.0211, 'lps'),
	(480112, 126, '2015-04-01 00:01:18.000000', 'consum', 0.0219, 'lps'),
	(480113, 126, '2015-04-01 00:01:19.000000', 'consum', 0.0218, 'lps'),
	(480114, 126, '2015-04-01 00:01:20.000000', 'consum', 0.0222, 'lps'),
	(480115, 126, '2015-04-01 00:01:21.000000', 'consum', 0.0227, 'lps'),
	(480116, 126, '2015-04-01 00:01:22.000000', 'consum', 0.0226, 'lps'),
	(480117, 126, '2015-04-01 00:01:23.000000', 'consum', 0.0219, 'lps'),
	(480118, 126, '2015-04-01 00:01:24.000000', 'consum', 0.0227, 'lps'),
	(480119, 126, '2015-04-01 00:01:25.000000', 'consum', 0.0212, 'lps'),
	(480120, 126, '2015-04-01 00:01:26.000000', 'consum', 0.0227, 'lps'),
	(480121, 126, '2015-04-01 00:01:27.000000', 'consum', 0.0216, 'lps'),
	(480122, 126, '2015-04-01 00:01:28.000000', 'consum', 0.0224, 'lps'),
	(480123, 126, '2015-04-01 00:01:29.000000', 'consum', 0.0210, 'lps'),
	(480124, 126, '2015-04-01 00:01:30.000000', 'consum', 0.0221, 'lps'),
	(480125, 126, '2015-04-01 00:01:31.000000', 'consum', 0.0214, 'lps'),
	(480126, 126, '2015-04-01 00:01:32.000000', 'consum', 0.0215, 'lps'),
	(480127, 126, '2015-04-01 00:01:33.000000', 'consum', 0.0222, 'lps'),
	(480128, 126, '2015-04-01 00:01:34.000000', 'consum', 0.0219, 'lps'),
	(480129, 126, '2015-04-01 00:01:35.000000', 'consum', 0.0219, 'lps'),
	(480130, 126, '2015-04-01 00:01:36.000000', 'consum', 0.0212, 'lps'),
	(480131, 126, '2015-04-01 00:01:37.000000', 'consum', 0.0213, 'lps'),
	(480132, 126, '2015-04-01 00:01:38.000000', 'consum', 0.0219, 'lps'),
	(480133, 126, '2015-04-01 00:01:39.000000', 'consum', 0.0226, 'lps'),
	(480134, 126, '2015-04-01 00:01:40.000000', 'consum', 0.0210, 'lps'),
	(480135, 126, '2015-04-01 00:01:41.000000', 'consum', 0.0217, 'lps'),
	(480136, 126, '2015-04-01 00:01:42.000000', 'consum', 0.0212, 'lps'),
	(480137, 126, '2015-04-01 00:01:43.000000', 'consum', 0.0214, 'lps'),
	(480138, 126, '2015-04-01 00:01:44.000000', 'consum', 0.0227, 'lps'),
	(480139, 126, '2015-04-01 00:01:45.000000', 'consum', 0.0210, 'lps'),
	(480140, 126, '2015-04-01 00:01:46.000000', 'consum', 0.0216, 'lps'),
	(480141, 126, '2015-04-01 00:01:47.000000', 'consum', 0.0220, 'lps'),
	(480142, 126, '2015-04-01 00:01:48.000000', 'consum', 0.0225, 'lps'),
	(480143, 126, '2015-04-01 00:01:49.000000', 'consum', 0.0220, 'lps'),
	(480144, 126, '2015-04-01 00:01:50.000000', 'consum', 0.0217, 'lps'),
	(480145, 126, '2015-04-01 00:01:51.000000', 'consum', 0.0214, 'lps'),
	(480146, 126, '2015-04-01 00:01:52.000000', 'consum', 0.0226, 'lps'),
	(480147, 126, '2015-04-01 00:01:53.000000', 'consum', 0.0224, 'lps'),
	(480148, 126, '2015-04-01 00:01:54.000000', 'consum', 0.0215, 'lps'),
	(480149, 126, '2015-04-01 00:01:55.000000', 'consum', 0.0213, 'lps'),
	(480150, 126, '2015-04-01 00:01:56.000000', 'consum', 0.0226, 'lps'),
	(480151, 126, '2015-04-01 00:01:57.000000', 'consum', 0.0211, 'lps'),
	(480152, 126, '2015-04-01 00:01:58.000000', 'consum', 0.0223, 'lps'),
	(480153, 126, '2015-04-01 00:01:59.000000', 'consum', 0.0219, 'lps'),
	(480154, 126, '2015-04-01 00:02:00.000000', 'consum', 0.0216, 'lps'),
	(480155, 126, '2015-04-01 00:02:01.000000', 'consum', 0.0214, 'lps'),
	(480156, 126, '2015-04-01 00:02:02.000000', 'consum', 0.0214, 'lps'),
	(480157, 126, '2015-04-01 00:02:03.000000', 'consum', 0.0216, 'lps'),
	(480158, 126, '2015-04-01 00:02:04.000000', 'consum', 0.0212, 'lps'),
	(480159, 126, '2015-04-01 00:02:05.000000', 'consum', 0.0220, 'lps'),
	(480160, 126, '2015-04-01 00:02:06.000000', 'consum', 0.0217, 'lps'),
	(480161, 126, '2015-04-01 00:02:07.000000', 'consum', 0.0216, 'lps'),
	(480162, 126, '2015-04-01 00:02:08.000000', 'consum', 0.0220, 'lps'),
	(480163, 126, '2015-04-01 00:02:09.000000', 'consum', 0.0225, 'lps'),
	(480164, 126, '2015-04-01 00:02:10.000000', 'consum', 0.0217, 'lps'),
	(480165, 126, '2015-04-01 00:02:11.000000', 'consum', 0.0222, 'lps'),
	(480166, 126, '2015-04-01 00:02:12.000000', 'consum', 0.0211, 'lps'),
	(480167, 126, '2015-04-01 00:02:13.000000', 'consum', 0.0214, 'lps'),
	(480168, 126, '2015-04-01 00:02:14.000000', 'consum', 0.0213, 'lps'),
	(480169, 126, '2015-04-01 00:02:15.000000', 'consum', 0.0210, 'lps'),
	(480170, 126, '2015-04-01 00:02:16.000000', 'consum', 0.0223, 'lps'),
	(480171, 126, '2015-04-01 00:02:17.000000', 'consum', 0.0219, 'lps'),
	(480172, 126, '2015-04-01 00:02:18.000000', 'consum', 0.0216, 'lps'),
	(480173, 126, '2015-04-01 00:02:19.000000', 'consum', 0.0214, 'lps'),
	(480174, 126, '2015-04-01 00:02:20.000000', 'consum', 0.0211, 'lps'),
	(480175, 126, '2015-04-01 00:02:21.000000', 'consum', 0.0224, 'lps'),
	(480176, 126, '2015-04-01 00:02:22.000000', 'consum', 0.0223, 'lps'),
	(480177, 126, '2015-04-01 00:02:23.000000', 'consum', 0.0214, 'lps'),
	(480178, 126, '2015-04-01 00:02:24.000000', 'consum', 0.0212, 'lps'),
	(480179, 126, '2015-04-01 00:02:25.000000', 'consum', 0.0224, 'lps'),
	(480180, 126, '2015-04-01 00:02:26.000000', 'consum', 0.0222, 'lps'),
	(480181, 126, '2015-04-01 00:02:27.000000', 'consum', 0.0211, 'lps'),
	(480182, 126, '2015-04-01 00:02:28.000000', 'consum', 0.0217, 'lps'),
	(480183, 126, '2015-04-01 00:02:29.000000', 'consum', 0.0221, 'lps'),
	(480184, 126, '2015-04-01 00:02:30.000000', 'consum', 0.0211, 'lps'),
	(480185, 126, '2015-04-01 00:02:31.000000', 'consum', 0.0216, 'lps'),
	(480186, 126, '2015-04-01 00:02:32.000000', 'consum', 0.0221, 'lps'),
	(480187, 126, '2015-04-01 00:02:33.000000', 'consum', 0.0211, 'lps'),
	(480188, 126, '2015-04-01 00:02:34.000000', 'consum', 0.0221, 'lps'),
	(480189, 126, '2015-04-01 00:02:35.000000', 'consum', 0.0224, 'lps'),
	(480190, 126, '2015-04-01 00:02:36.000000', 'consum', 0.0213, 'lps'),
	(480191, 126, '2015-04-01 00:02:37.000000', 'consum', 0.0219, 'lps'),
	(480192, 126, '2015-04-01 00:02:38.000000', 'consum', 0.0227, 'lps'),
	(480193, 126, '2015-04-01 00:02:39.000000', 'consum', 0.0214, 'lps'),
	(480194, 126, '2015-04-01 00:02:40.000000', 'consum', 0.0215, 'lps'),
	(480195, 126, '2015-04-01 00:02:41.000000', 'consum', 0.0226, 'lps'),
	(480196, 126, '2015-04-01 00:02:42.000000', 'consum', 0.0221, 'lps'),
	(480197, 126, '2015-04-01 00:02:43.000000', 'consum', 0.0217, 'lps'),
	(480198, 126, '2015-04-01 00:02:44.000000', 'consum', 0.0213, 'lps'),
	(480199, 126, '2015-04-01 00:02:45.000000', 'consum', 0.0221, 'lps'),
	(480200, 126, '2015-04-01 00:02:46.000000', 'consum', 0.0221, 'lps'),
	(480201, 126, '2015-04-01 00:02:47.000000', 'consum', 0.0215, 'lps'),
	(480202, 126, '2015-04-01 00:02:48.000000', 'consum', 0.0222, 'lps'),
	(480203, 126, '2015-04-01 00:02:49.000000', 'consum', 0.0219, 'lps'),
	(480204, 126, '2015-04-01 00:02:50.000000', 'consum', 0.0219, 'lps'),
	(480205, 126, '2015-04-01 00:02:51.000000', 'consum', 0.0227, 'lps'),
	(480206, 126, '2015-04-01 00:02:52.000000', 'consum', 0.0214, 'lps'),
	(480207, 126, '2015-04-01 00:02:53.000000', 'consum', 0.0217, 'lps'),
	(480208, 126, '2015-04-01 00:02:54.000000', 'consum', 0.0215, 'lps'),
	(480209, 126, '2015-04-01 00:02:55.000000', 'consum', 0.0216, 'lps'),
	(480210, 126, '2015-04-01 00:02:56.000000', 'consum', 0.0225, 'lps'),
	(480211, 126, '2015-04-01 00:02:57.000000', 'consum', 0.0215, 'lps'),
	(480212, 126, '2015-04-01 00:02:58.000000', 'consum', 0.0224, 'lps'),
	(480213, 126, '2015-04-01 00:02:59.000000', 'consum', 0.0212, 'lps'),
	(480214, 126, '2015-04-01 00:03:00.000000', 'consum', 0.0217, 'lps'),
	(480215, 126, '2015-04-01 00:03:01.000000', 'consum', 0.0218, 'lps'),
	(480216, 126, '2015-04-01 00:03:02.000000', 'consum', 0.0214, 'lps'),
	(480217, 126, '2015-04-01 00:03:03.000000', 'consum', 0.0225, 'lps'),
	(480218, 126, '2015-04-01 00:03:04.000000', 'consum', 0.0217, 'lps'),
	(480219, 126, '2015-04-01 00:03:05.000000', 'consum', 0.0219, 'lps'),
	(480220, 126, '2015-04-01 00:03:06.000000', 'consum', 0.0218, 'lps'),
	(480221, 126, '2015-04-01 00:03:07.000000', 'consum', 0.0225, 'lps'),
	(480222, 126, '2015-04-01 00:03:08.000000', 'consum', 0.0223, 'lps'),
	(480223, 126, '2015-04-01 00:03:09.000000', 'consum', 0.0211, 'lps'),
	(480224, 126, '2015-04-01 00:03:10.000000', 'consum', 0.0216, 'lps'),
	(480225, 126, '2015-04-01 00:03:11.000000', 'consum', 0.0219, 'lps'),
	(480226, 126, '2015-04-01 00:03:12.000000', 'consum', 0.0218, 'lps'),
	(480227, 126, '2015-04-01 00:03:13.000000', 'consum', 0.0222, 'lps'),
	(480228, 126, '2015-04-01 00:03:14.000000', 'consum', 0.0212, 'lps'),
	(480229, 126, '2015-04-01 00:03:15.000000', 'consum', 0.0222, 'lps'),
	(480230, 126, '2015-04-01 00:03:16.000000', 'consum', 0.0226, 'lps'),
	(480231, 126, '2015-04-01 00:03:17.000000', 'consum', 0.0220, 'lps'),
	(480232, 126, '2015-04-01 00:03:18.000000', 'consum', 0.0211, 'lps'),
	(480233, 126, '2015-04-01 00:03:19.000000', 'consum', 0.0221, 'lps'),
	(480234, 126, '2015-04-01 00:03:20.000000', 'consum', 0.0226, 'lps'),
	(480235, 126, '2015-04-01 00:03:21.000000', 'consum', 0.0221, 'lps'),
	(480236, 126, '2015-04-01 00:03:22.000000', 'consum', 0.0217, 'lps'),
	(480237, 126, '2015-04-01 00:03:23.000000', 'consum', 0.0213, 'lps'),
	(480238, 126, '2015-04-01 00:03:24.000000', 'consum', 0.0222, 'lps'),
	(480239, 126, '2015-04-01 00:03:25.000000', 'consum', 0.0225, 'lps'),
	(480240, 126, '2015-04-01 00:03:26.000000', 'consum', 0.0215, 'lps'),
	(480241, 126, '2015-04-01 00:03:27.000000', 'consum', 0.0227, 'lps'),
	(480242, 126, '2015-04-01 00:03:28.000000', 'consum', 0.0225, 'lps'),
	(480243, 126, '2015-04-01 00:03:29.000000', 'consum', 0.0216, 'lps'),
	(480244, 126, '2015-04-01 00:03:30.000000', 'consum', 0.0216, 'lps'),
	(480245, 126, '2015-04-01 00:03:31.000000', 'consum', 0.0219, 'lps'),
	(480246, 126, '2015-04-01 00:03:32.000000', 'consum', 0.0222, 'lps'),
	(480247, 126, '2015-04-01 00:03:33.000000', 'consum', 0.0227, 'lps'),
	(480248, 126, '2015-04-01 00:03:34.000000', 'consum', 0.0220, 'lps'),
	(480249, 126, '2015-04-01 00:03:35.000000', 'consum', 0.0213, 'lps'),
	(480250, 126, '2015-04-01 00:03:36.000000', 'consum', 0.0211, 'lps'),
	(480251, 126, '2015-04-01 00:03:37.000000', 'consum', 0.0224, 'lps'),
	(480252, 126, '2015-04-01 00:03:38.000000', 'consum', 0.0225, 'lps'),
	(480253, 126, '2015-04-01 00:03:39.000000', 'consum', 0.0225, 'lps'),
	(480254, 126, '2015-04-01 00:03:40.000000', 'consum', 0.0221, 'lps'),
	(480255, 126, '2015-04-01 00:03:41.000000', 'consum', 0.0222, 'lps'),
	(480256, 126, '2015-04-01 00:03:42.000000', 'consum', 0.0218, 'lps'),
	(480257, 126, '2015-04-01 00:03:43.000000', 'consum', 0.0215, 'lps'),
	(480258, 126, '2015-04-01 00:03:44.000000', 'consum', 0.0214, 'lps'),
	(480259, 126, '2015-04-01 00:03:45.000000', 'consum', 0.0213, 'lps'),
	(480260, 126, '2015-04-01 00:03:46.000000', 'consum', 0.0215, 'lps'),
	(480261, 126, '2015-04-01 00:03:47.000000', 'consum', 0.0225, 'lps'),
	(480262, 126, '2015-04-01 00:03:48.000000', 'consum', 0.0219, 'lps'),
	(480263, 126, '2015-04-01 00:03:49.000000', 'consum', 0.0226, 'lps'),
	(480264, 126, '2015-04-01 00:03:50.000000', 'consum', 0.0227, 'lps'),
	(480265, 126, '2015-04-01 00:03:51.000000', 'consum', 0.0211, 'lps'),
	(480266, 126, '2015-04-01 00:03:52.000000', 'consum', 0.0220, 'lps'),
	(480267, 126, '2015-04-01 00:03:53.000000', 'consum', 0.0220, 'lps'),
	(480268, 126, '2015-04-01 00:03:54.000000', 'consum', 0.0214, 'lps'),
	(480269, 126, '2015-04-01 00:03:55.000000', 'consum', 0.0217, 'lps'),
	(480270, 126, '2015-04-01 00:03:56.000000', 'consum', 0.0216, 'lps'),
	(480271, 126, '2015-04-01 00:03:57.000000', 'consum', 0.0218, 'lps'),
	(480272, 126, '2015-04-01 00:03:58.000000', 'consum', 0.0216, 'lps'),
	(480273, 126, '2015-04-01 00:03:59.000000', 'consum', 0.0216, 'lps'),
	(480274, 126, '2015-04-01 00:04:00.000000', 'consum', 0.0224, 'lps'),
	(480275, 126, '2015-04-01 00:04:01.000000', 'consum', 0.0224, 'lps'),
	(480276, 126, '2015-04-01 00:04:02.000000', 'consum', 0.0222, 'lps'),
	(480277, 126, '2015-04-01 00:04:03.000000', 'consum', 0.0211, 'lps'),
	(480278, 126, '2015-04-01 00:04:04.000000', 'consum', 0.0215, 'lps'),
	(480279, 126, '2015-04-01 00:04:05.000000', 'consum', 0.0216, 'lps'),
	(480280, 126, '2015-04-01 00:04:06.000000', 'consum', 0.0225, 'lps'),
	(480281, 126, '2015-04-01 00:04:07.000000', 'consum', 0.0214, 'lps'),
	(480282, 126, '2015-04-01 00:04:08.000000', 'consum', 0.0222, 'lps'),
	(480283, 126, '2015-04-01 00:04:09.000000', 'consum', 0.0221, 'lps'),
	(480284, 126, '2015-04-01 00:04:10.000000', 'consum', 0.0213, 'lps'),
	(480285, 126, '2015-04-01 00:04:11.000000', 'consum', 0.0226, 'lps'),
	(480286, 126, '2015-04-01 00:04:12.000000', 'consum', 0.0210, 'lps'),
	(480287, 126, '2015-04-01 00:04:13.000000', 'consum', 0.0219, 'lps'),
	(480288, 126, '2015-04-01 00:04:14.000000', 'consum', 0.0218, 'lps'),
	(480289, 126, '2015-04-01 00:04:15.000000', 'consum', 0.0223, 'lps'),
	(480290, 126, '2015-04-01 00:04:16.000000', 'consum', 0.0214, 'lps'),
	(480291, 126, '2015-04-01 00:04:17.000000', 'consum', 0.0212, 'lps'),
	(480292, 126, '2015-04-01 00:04:18.000000', 'consum', 0.0227, 'lps'),
	(480293, 126, '2015-04-01 00:04:19.000000', 'consum', 0.0214, 'lps'),
	(480294, 126, '2015-04-01 00:04:20.000000', 'consum', 0.0219, 'lps'),
	(480295, 126, '2015-04-01 00:04:21.000000', 'consum', 0.0226, 'lps'),
	(480296, 126, '2015-04-01 00:04:22.000000', 'consum', 0.0226, 'lps'),
	(480297, 126, '2015-04-01 00:04:23.000000', 'consum', 0.0224, 'lps'),
	(480298, 126, '2015-04-01 00:04:24.000000', 'consum', 0.0216, 'lps'),
	(480299, 126, '2015-04-01 00:04:25.000000', 'consum', 0.0216, 'lps'),
	(480300, 126, '2015-04-01 00:04:26.000000', 'consum', 0.0224, 'lps'),
	(480301, 126, '2015-04-01 00:04:27.000000', 'consum', 0.0226, 'lps'),
	(480302, 126, '2015-04-01 00:04:28.000000', 'consum', 0.0211, 'lps'),
	(480303, 126, '2015-04-01 00:04:29.000000', 'consum', 0.0220, 'lps'),
	(480304, 126, '2015-04-01 00:04:30.000000', 'consum', 0.0224, 'lps'),
	(480305, 126, '2015-04-01 00:04:31.000000', 'consum', 0.0215, 'lps'),
	(480306, 126, '2015-04-01 00:04:32.000000', 'consum', 0.0212, 'lps'),
	(480307, 126, '2015-04-01 00:04:33.000000', 'consum', 0.0225, 'lps'),
	(480308, 126, '2015-04-01 00:04:34.000000', 'consum', 0.0222, 'lps'),
	(480309, 126, '2015-04-01 00:04:35.000000', 'consum', 0.0226, 'lps'),
	(480310, 126, '2015-04-01 00:04:36.000000', 'consum', 0.0219, 'lps'),
	(480311, 126, '2015-04-01 00:04:37.000000', 'consum', 0.0226, 'lps'),
	(480312, 126, '2015-04-01 00:04:38.000000', 'consum', 0.0225, 'lps'),
	(480313, 126, '2015-04-01 00:04:39.000000', 'consum', 0.0222, 'lps'),
	(480314, 126, '2015-04-01 00:04:40.000000', 'consum', 0.0224, 'lps'),
	(480315, 126, '2015-04-01 00:04:41.000000', 'consum', 0.0226, 'lps'),
	(480316, 126, '2015-04-01 00:04:42.000000', 'consum', 0.0214, 'lps'),
	(480317, 126, '2015-04-01 00:04:43.000000', 'consum', 0.0218, 'lps'),
	(480318, 126, '2015-04-01 00:04:44.000000', 'consum', 0.0220, 'lps'),
	(480319, 126, '2015-04-01 00:04:45.000000', 'consum', 0.0217, 'lps'),
	(480320, 126, '2015-04-01 00:04:46.000000', 'consum', 0.0218, 'lps'),
	(480321, 126, '2015-04-01 00:04:47.000000', 'consum', 0.0213, 'lps'),
	(480322, 126, '2015-04-01 00:04:48.000000', 'consum', 0.0217, 'lps'),
	(480323, 126, '2015-04-01 00:04:49.000000', 'consum', 0.0219, 'lps'),
	(480324, 126, '2015-04-01 00:04:50.000000', 'consum', 0.0216, 'lps'),
	(480325, 126, '2015-04-01 00:04:51.000000', 'consum', 0.0214, 'lps'),
	(480326, 126, '2015-04-01 00:04:52.000000', 'consum', 0.0214, 'lps'),
	(480327, 126, '2015-04-01 00:04:53.000000', 'consum', 0.0219, 'lps'),
	(480328, 126, '2015-04-01 00:04:54.000000', 'consum', 0.0224, 'lps'),
	(480329, 126, '2015-04-01 00:04:55.000000', 'consum', 0.0218, 'lps'),
	(480330, 126, '2015-04-01 00:04:56.000000', 'consum', 0.0227, 'lps'),
	(480331, 126, '2015-04-01 00:04:57.000000', 'consum', 0.0219, 'lps'),
	(480332, 126, '2015-04-01 00:04:58.000000', 'consum', 0.0222, 'lps'),
	(480333, 126, '2015-04-01 00:04:59.000000', 'consum', 0.0224, 'lps'),
	(480334, 126, '2015-04-01 00:05:00.000000', 'consum', 0.0211, 'lps'),
	(480335, 126, '2015-04-01 00:05:01.000000', 'consum', 0.0227, 'lps'),
	(480336, 126, '2015-04-01 00:05:02.000000', 'consum', 0.0220, 'lps'),
	(480337, 126, '2015-04-01 00:05:03.000000', 'consum', 0.0227, 'lps'),
	(480338, 126, '2015-04-01 00:05:04.000000', 'consum', 0.0214, 'lps'),
	(480339, 126, '2015-04-01 00:05:05.000000', 'consum', 0.0213, 'lps'),
	(480340, 126, '2015-04-01 00:05:06.000000', 'consum', 0.0214, 'lps'),
	(480341, 126, '2015-04-01 00:05:07.000000', 'consum', 0.0221, 'lps'),
	(480342, 126, '2015-04-01 00:05:08.000000', 'consum', 0.0219, 'lps'),
	(480343, 126, '2015-04-01 00:05:09.000000', 'consum', 0.0221, 'lps'),
	(480344, 126, '2015-04-01 00:05:10.000000', 'consum', 0.0221, 'lps'),
	(480345, 126, '2015-04-01 00:05:11.000000', 'consum', 0.0216, 'lps'),
	(480346, 126, '2015-04-01 00:05:12.000000', 'consum', 0.0226, 'lps'),
	(480347, 126, '2015-04-01 00:05:13.000000', 'consum', 0.0217, 'lps'),
	(480348, 126, '2015-04-01 00:05:14.000000', 'consum', 0.0216, 'lps'),
	(480349, 126, '2015-04-01 00:05:15.000000', 'consum', 0.0218, 'lps'),
	(480350, 126, '2015-04-01 00:05:16.000000', 'consum', 0.0216, 'lps'),
	(480351, 126, '2015-04-01 00:05:17.000000', 'consum', 0.0215, 'lps'),
	(480352, 126, '2015-04-01 00:05:18.000000', 'consum', 0.0216, 'lps'),
	(480353, 126, '2015-04-01 00:05:19.000000', 'consum', 0.0210, 'lps'),
	(480354, 126, '2015-04-01 00:05:20.000000', 'consum', 0.0210, 'lps'),
	(480355, 126, '2015-04-01 00:05:21.000000', 'consum', 0.0227, 'lps'),
	(480356, 126, '2015-04-01 00:05:22.000000', 'consum', 0.0224, 'lps'),
	(480357, 126, '2015-04-01 00:05:23.000000', 'consum', 0.0210, 'lps'),
	(480358, 126, '2015-04-01 00:05:24.000000', 'consum', 0.0224, 'lps'),
	(480359, 126, '2015-04-01 00:05:25.000000', 'consum', 0.0210, 'lps'),
	(480360, 126, '2015-04-01 00:05:26.000000', 'consum', 0.0219, 'lps'),
	(480361, 126, '2015-04-01 00:05:27.000000', 'consum', 0.0223, 'lps'),
	(480362, 126, '2015-04-01 00:05:28.000000', 'consum', 0.0211, 'lps'),
	(480363, 126, '2015-04-01 00:05:29.000000', 'consum', 0.0212, 'lps'),
	(480364, 126, '2015-04-01 00:05:30.000000', 'consum', 0.0216, 'lps'),
	(480365, 126, '2015-04-01 00:05:31.000000', 'consum', 0.0219, 'lps'),
	(480366, 126, '2015-04-01 00:05:32.000000', 'consum', 0.0218, 'lps'),
	(480367, 126, '2015-04-01 00:05:33.000000', 'consum', 0.0225, 'lps'),
	(480368, 126, '2015-04-01 00:05:34.000000', 'consum', 0.0225, 'lps'),
	(480369, 126, '2015-04-01 00:05:35.000000', 'consum', 0.0222, 'lps'),
	(480370, 126, '2015-04-01 00:05:36.000000', 'consum', 0.0224, 'lps'),
	(480371, 126, '2015-04-01 00:05:37.000000', 'consum', 0.0211, 'lps'),
	(480372, 126, '2015-04-01 00:05:38.000000', 'consum', 0.0226, 'lps'),
	(480373, 126, '2015-04-01 00:05:39.000000', 'consum', 0.0215, 'lps'),
	(480374, 126, '2015-04-01 00:05:40.000000', 'consum', 0.0224, 'lps'),
	(480375, 126, '2015-04-01 00:05:41.000000', 'consum', 0.0211, 'lps'),
	(480376, 126, '2015-04-01 00:05:42.000000', 'consum', 0.0226, 'lps'),
	(480377, 126, '2015-04-01 00:05:43.000000', 'consum', 0.0217, 'lps'),
	(480378, 126, '2015-04-01 00:05:44.000000', 'consum', 0.0213, 'lps'),
	(480379, 126, '2015-04-01 00:05:45.000000', 'consum', 0.0226, 'lps'),
	(480380, 126, '2015-04-01 00:05:46.000000', 'consum', 0.0226, 'lps'),
	(480381, 126, '2015-04-01 00:05:47.000000', 'consum', 0.0227, 'lps'),
	(480382, 126, '2015-04-01 00:05:48.000000', 'consum', 0.0227, 'lps'),
	(480383, 126, '2015-04-01 00:05:49.000000', 'consum', 0.0226, 'lps'),
	(480384, 126, '2015-04-01 00:05:50.000000', 'consum', 0.0221, 'lps'),
	(480385, 126, '2015-04-01 00:05:51.000000', 'consum', 0.0219, 'lps'),
	(480386, 126, '2015-04-01 00:05:52.000000', 'consum', 0.0221, 'lps'),
	(480387, 126, '2015-04-01 00:05:53.000000', 'consum', 0.0222, 'lps'),
	(480388, 126, '2015-04-01 00:05:54.000000', 'consum', 0.0219, 'lps'),
	(480389, 126, '2015-04-01 00:05:55.000000', 'consum', 0.0221, 'lps'),
	(480390, 126, '2015-04-01 00:05:56.000000', 'consum', 0.0218, 'lps'),
	(480391, 126, '2015-04-01 00:05:57.000000', 'consum', 0.0219, 'lps'),
	(480392, 126, '2015-04-01 00:05:58.000000', 'consum', 0.0213, 'lps'),
	(480393, 126, '2015-04-01 00:05:59.000000', 'consum', 0.0216, 'lps'),
	(480394, 126, '2015-04-01 00:06:00.000000', 'consum', 0.0216, 'lps'),
	(480395, 126, '2015-04-01 00:06:01.000000', 'consum', 0.0220, 'lps'),
	(480396, 126, '2015-04-01 00:06:02.000000', 'consum', 0.0224, 'lps'),
	(480397, 126, '2015-04-01 00:06:03.000000', 'consum', 0.0215, 'lps'),
	(480398, 126, '2015-04-01 00:06:04.000000', 'consum', 0.0213, 'lps'),
	(480399, 126, '2015-04-01 00:06:05.000000', 'consum', 0.0225, 'lps'),
	(480400, 126, '2015-04-01 00:06:06.000000', 'consum', 0.0226, 'lps'),
	(480401, 126, '2015-04-01 00:06:07.000000', 'consum', 0.0210, 'lps'),
	(480402, 126, '2015-04-01 00:06:08.000000', 'consum', 0.0217, 'lps'),
	(480403, 126, '2015-04-01 00:06:09.000000', 'consum', 0.0225, 'lps'),
	(480404, 126, '2015-04-01 00:06:10.000000', 'consum', 0.0211, 'lps'),
	(480405, 126, '2015-04-01 00:06:11.000000', 'consum', 0.0226, 'lps'),
	(480406, 126, '2015-04-01 00:06:12.000000', 'consum', 0.0216, 'lps'),
	(480407, 126, '2015-04-01 00:06:13.000000', 'consum', 0.0226, 'lps'),
	(480408, 126, '2015-04-01 00:06:14.000000', 'consum', 0.0221, 'lps'),
	(480409, 126, '2015-04-01 00:06:15.000000', 'consum', 0.0215, 'lps'),
	(480410, 126, '2015-04-01 00:06:16.000000', 'consum', 0.0220, 'lps'),
	(480411, 126, '2015-04-01 00:06:17.000000', 'consum', 0.0212, 'lps'),
	(480412, 126, '2015-04-01 00:06:18.000000', 'consum', 0.0226, 'lps'),
	(480413, 126, '2015-04-01 00:06:19.000000', 'consum', 0.0211, 'lps'),
	(480414, 126, '2015-04-01 00:06:20.000000', 'consum', 0.0221, 'lps'),
	(480415, 126, '2015-04-01 00:06:21.000000', 'consum', 0.0225, 'lps'),
	(480416, 126, '2015-04-01 00:06:22.000000', 'consum', 0.0220, 'lps'),
	(480417, 126, '2015-04-01 00:06:23.000000', 'consum', 0.0214, 'lps'),
	(480418, 126, '2015-04-01 00:06:24.000000', 'consum', 0.0220, 'lps'),
	(480419, 126, '2015-04-01 00:06:25.000000', 'consum', 0.0211, 'lps'),
	(480420, 126, '2015-04-01 00:06:26.000000', 'consum', 0.0221, 'lps'),
	(480421, 126, '2015-04-01 00:06:27.000000', 'consum', 0.0210, 'lps'),
	(480422, 126, '2015-04-01 00:06:28.000000', 'consum', 0.0212, 'lps'),
	(480423, 126, '2015-04-01 00:06:29.000000', 'consum', 0.0222, 'lps'),
	(480424, 126, '2015-04-01 00:06:30.000000', 'consum', 0.0211, 'lps'),
	(480425, 126, '2015-04-01 00:06:31.000000', 'consum', 0.0214, 'lps'),
	(480426, 126, '2015-04-01 00:06:32.000000', 'consum', 0.0227, 'lps'),
	(480427, 126, '2015-04-01 00:06:33.000000', 'consum', 0.0213, 'lps'),
	(480428, 126, '2015-04-01 00:06:34.000000', 'consum', 0.0210, 'lps'),
	(480429, 126, '2015-04-01 00:06:35.000000', 'consum', 0.0221, 'lps'),
	(480430, 126, '2015-04-01 00:06:36.000000', 'consum', 0.0212, 'lps'),
	(480431, 126, '2015-04-01 00:06:37.000000', 'consum', 0.0222, 'lps'),
	(480432, 126, '2015-04-01 00:06:38.000000', 'consum', 0.0212, 'lps'),
	(480433, 126, '2015-04-01 00:06:39.000000', 'consum', 0.0218, 'lps'),
	(480434, 126, '2015-04-01 00:06:40.000000', 'consum', 0.0227, 'lps'),
	(480435, 126, '2015-04-01 00:06:41.000000', 'consum', 0.0217, 'lps'),
	(480436, 126, '2015-04-01 00:06:42.000000', 'consum', 0.0214, 'lps'),
	(480437, 126, '2015-04-01 00:06:43.000000', 'consum', 0.0225, 'lps'),
	(480438, 126, '2015-04-01 00:06:44.000000', 'consum', 0.0220, 'lps'),
	(480439, 126, '2015-04-01 00:06:45.000000', 'consum', 0.0217, 'lps'),
	(480440, 126, '2015-04-01 00:06:46.000000', 'consum', 0.0213, 'lps'),
	(480441, 126, '2015-04-01 00:06:47.000000', 'consum', 0.0225, 'lps'),
	(480442, 126, '2015-04-01 00:06:48.000000', 'consum', 0.0220, 'lps'),
	(480443, 126, '2015-04-01 00:06:49.000000', 'consum', 0.0217, 'lps'),
	(480444, 126, '2015-04-01 00:06:50.000000', 'consum', 0.0215, 'lps'),
	(480445, 126, '2015-04-01 00:06:51.000000', 'consum', 0.0216, 'lps'),
	(480446, 126, '2015-04-01 00:06:52.000000', 'consum', 0.0227, 'lps'),
	(480447, 126, '2015-04-01 00:06:53.000000', 'consum', 0.0220, 'lps'),
	(480448, 126, '2015-04-01 00:06:54.000000', 'consum', 0.0211, 'lps'),
	(480449, 126, '2015-04-01 00:06:55.000000', 'consum', 0.0220, 'lps'),
	(480450, 126, '2015-04-01 00:06:56.000000', 'consum', 0.0223, 'lps'),
	(480451, 126, '2015-04-01 00:06:57.000000', 'consum', 0.0211, 'lps'),
	(480452, 126, '2015-04-01 00:06:58.000000', 'consum', 0.0211, 'lps'),
	(480453, 126, '2015-04-01 00:06:59.000000', 'consum', 0.0214, 'lps'),
	(480454, 126, '2015-04-01 00:07:00.000000', 'consum', 0.0225, 'lps'),
	(480455, 126, '2015-04-01 00:07:01.000000', 'consum', 0.0219, 'lps'),
	(480456, 126, '2015-04-01 00:07:02.000000', 'consum', 0.0211, 'lps'),
	(480457, 126, '2015-04-01 00:07:03.000000', 'consum', 0.0226, 'lps'),
	(480458, 126, '2015-04-01 00:07:04.000000', 'consum', 0.0216, 'lps'),
	(480459, 126, '2015-04-01 00:07:05.000000', 'consum', 0.0227, 'lps'),
	(480460, 126, '2015-04-01 00:07:06.000000', 'consum', 0.0224, 'lps'),
	(480461, 126, '2015-04-01 00:07:07.000000', 'consum', 0.0210, 'lps'),
	(480462, 126, '2015-04-01 00:07:08.000000', 'consum', 0.0224, 'lps'),
	(480463, 126, '2015-04-01 00:07:09.000000', 'consum', 0.0224, 'lps'),
	(480464, 126, '2015-04-01 00:07:10.000000', 'consum', 0.0222, 'lps'),
	(480465, 126, '2015-04-01 00:07:11.000000', 'consum', 0.0212, 'lps'),
	(480466, 126, '2015-04-01 00:07:12.000000', 'consum', 0.0221, 'lps'),
	(480467, 126, '2015-04-01 00:07:13.000000', 'consum', 0.0221, 'lps'),
	(480468, 126, '2015-04-01 00:07:14.000000', 'consum', 0.0214, 'lps'),
	(480469, 126, '2015-04-01 00:07:15.000000', 'consum', 0.0217, 'lps'),
	(480470, 126, '2015-04-01 00:07:16.000000', 'consum', 0.0217, 'lps'),
	(480471, 126, '2015-04-01 00:07:17.000000', 'consum', 0.0222, 'lps'),
	(480472, 126, '2015-04-01 00:07:18.000000', 'consum', 0.0213, 'lps'),
	(480473, 126, '2015-04-01 00:07:19.000000', 'consum', 0.0225, 'lps'),
	(480474, 126, '2015-04-01 00:07:20.000000', 'consum', 0.0222, 'lps'),
	(480475, 126, '2015-04-01 00:07:21.000000', 'consum', 0.0225, 'lps'),
	(480476, 126, '2015-04-01 00:07:22.000000', 'consum', 0.0216, 'lps'),
	(480477, 126, '2015-04-01 00:07:23.000000', 'consum', 0.0211, 'lps'),
	(480478, 126, '2015-04-01 00:07:24.000000', 'consum', 0.0218, 'lps'),
	(480479, 126, '2015-04-01 00:07:25.000000', 'consum', 0.0212, 'lps'),
	(480480, 126, '2015-04-01 00:07:26.000000', 'consum', 0.0212, 'lps'),
	(480481, 126, '2015-04-01 00:07:27.000000', 'consum', 0.0215, 'lps'),
	(480482, 126, '2015-04-01 00:07:28.000000', 'consum', 0.0213, 'lps'),
	(480483, 126, '2015-04-01 00:07:29.000000', 'consum', 0.0210, 'lps'),
	(480484, 126, '2015-04-01 00:07:30.000000', 'consum', 0.0218, 'lps'),
	(480485, 126, '2015-04-01 00:07:31.000000', 'consum', 0.0216, 'lps'),
	(480486, 126, '2015-04-01 00:07:32.000000', 'consum', 0.0217, 'lps'),
	(480487, 126, '2015-04-01 00:07:33.000000', 'consum', 0.0227, 'lps'),
	(480488, 126, '2015-04-01 00:07:34.000000', 'consum', 0.0220, 'lps'),
	(480489, 126, '2015-04-01 00:07:35.000000', 'consum', 0.0211, 'lps'),
	(480490, 126, '2015-04-01 00:07:36.000000', 'consum', 0.0222, 'lps'),
	(480491, 126, '2015-04-01 00:07:37.000000', 'consum', 0.0211, 'lps'),
	(480492, 126, '2015-04-01 00:07:38.000000', 'consum', 0.0215, 'lps'),
	(480493, 126, '2015-04-01 00:07:39.000000', 'consum', 0.0216, 'lps'),
	(480494, 126, '2015-04-01 00:07:40.000000', 'consum', 0.0224, 'lps'),
	(480495, 126, '2015-04-01 00:07:41.000000', 'consum', 0.0226, 'lps'),
	(480496, 126, '2015-04-01 00:07:42.000000', 'consum', 0.0213, 'lps'),
	(480497, 126, '2015-04-01 00:07:43.000000', 'consum', 0.0213, 'lps'),
	(480498, 126, '2015-04-01 00:07:44.000000', 'consum', 0.0217, 'lps'),
	(480499, 126, '2015-04-01 00:07:45.000000', 'consum', 0.0216, 'lps'),
	(480500, 126, '2015-04-01 00:07:46.000000', 'consum', 0.0223, 'lps'),
	(480501, 126, '2015-04-01 00:07:47.000000', 'consum', 0.0221, 'lps'),
	(480502, 126, '2015-04-01 00:07:48.000000', 'consum', 0.0227, 'lps'),
	(480503, 126, '2015-04-01 00:07:49.000000', 'consum', 0.0225, 'lps'),
	(480504, 126, '2015-04-01 00:07:50.000000', 'consum', 0.0217, 'lps'),
	(480505, 126, '2015-04-01 00:07:51.000000', 'consum', 0.0219, 'lps'),
	(480506, 126, '2015-04-01 00:07:52.000000', 'consum', 0.0215, 'lps'),
	(480507, 126, '2015-04-01 00:07:53.000000', 'consum', 0.0210, 'lps'),
	(480508, 126, '2015-04-01 00:07:54.000000', 'consum', 0.0214, 'lps'),
	(480509, 126, '2015-04-01 00:07:55.000000', 'consum', 0.0211, 'lps'),
	(480510, 126, '2015-04-01 00:07:56.000000', 'consum', 0.0224, 'lps'),
	(480511, 126, '2015-04-01 00:07:57.000000', 'consum', 0.0220, 'lps'),
	(480512, 126, '2015-04-01 00:07:58.000000', 'consum', 0.0221, 'lps'),
	(480513, 126, '2015-04-01 00:07:59.000000', 'consum', 0.0216, 'lps'),
	(480514, 126, '2015-04-01 00:08:00.000000', 'consum', 0.0227, 'lps'),
	(480515, 126, '2015-04-01 00:08:01.000000', 'consum', 0.0225, 'lps'),
	(480516, 126, '2015-04-01 00:08:02.000000', 'consum', 0.0214, 'lps'),
	(480517, 126, '2015-04-01 00:08:03.000000', 'consum', 0.0224, 'lps'),
	(480518, 126, '2015-04-01 00:08:04.000000', 'consum', 0.0211, 'lps'),
	(480519, 126, '2015-04-01 00:08:05.000000', 'consum', 0.0212, 'lps'),
	(480520, 126, '2015-04-01 00:08:06.000000', 'consum', 0.0219, 'lps'),
	(480521, 126, '2015-04-01 00:08:07.000000', 'consum', 0.0211, 'lps'),
	(480522, 126, '2015-04-01 00:08:08.000000', 'consum', 0.0225, 'lps'),
	(480523, 126, '2015-04-01 00:08:09.000000', 'consum', 0.0213, 'lps'),
	(480524, 126, '2015-04-01 00:08:10.000000', 'consum', 0.0213, 'lps'),
	(480525, 126, '2015-04-01 00:08:11.000000', 'consum', 0.0217, 'lps'),
	(480526, 126, '2015-04-01 00:08:12.000000', 'consum', 0.0218, 'lps'),
	(480527, 126, '2015-04-01 00:08:13.000000', 'consum', 0.0214, 'lps'),
	(480528, 126, '2015-04-01 00:08:14.000000', 'consum', 0.0221, 'lps'),
	(480529, 126, '2015-04-01 00:08:15.000000', 'consum', 0.0221, 'lps'),
	(480530, 126, '2015-04-01 00:08:16.000000', 'consum', 0.0213, 'lps'),
	(480531, 126, '2015-04-01 00:08:17.000000', 'consum', 0.0227, 'lps'),
	(480532, 126, '2015-04-01 00:08:18.000000', 'consum', 0.0217, 'lps'),
	(480533, 126, '2015-04-01 00:08:19.000000', 'consum', 0.0211, 'lps'),
	(480534, 126, '2015-04-01 00:08:20.000000', 'consum', 0.0211, 'lps'),
	(480535, 126, '2015-04-01 00:08:21.000000', 'consum', 0.0215, 'lps'),
	(480536, 126, '2015-04-01 00:08:22.000000', 'consum', 0.0216, 'lps'),
	(480537, 126, '2015-04-01 00:08:23.000000', 'consum', 0.0223, 'lps'),
	(480538, 126, '2015-04-01 00:08:24.000000', 'consum', 0.0222, 'lps'),
	(480539, 126, '2015-04-01 00:08:25.000000', 'consum', 0.0215, 'lps'),
	(480540, 126, '2015-04-01 00:08:26.000000', 'consum', 0.0215, 'lps'),
	(480541, 126, '2015-04-01 00:08:27.000000', 'consum', 0.0221, 'lps'),
	(480542, 126, '2015-04-01 00:08:28.000000', 'consum', 0.0213, 'lps'),
	(480543, 126, '2015-04-01 00:08:29.000000', 'consum', 0.0212, 'lps'),
	(480544, 126, '2015-04-01 00:08:30.000000', 'consum', 0.0210, 'lps'),
	(480545, 126, '2015-04-01 00:08:31.000000', 'consum', 0.0222, 'lps'),
	(480546, 126, '2015-04-01 00:08:32.000000', 'consum', 0.0216, 'lps'),
	(480547, 126, '2015-04-01 00:08:33.000000', 'consum', 0.0224, 'lps'),
	(480548, 126, '2015-04-01 00:08:34.000000', 'consum', 0.0227, 'lps'),
	(480549, 126, '2015-04-01 00:08:35.000000', 'consum', 0.0216, 'lps'),
	(480550, 126, '2015-04-01 00:08:36.000000', 'consum', 0.0225, 'lps'),
	(480551, 126, '2015-04-01 00:08:37.000000', 'consum', 0.0215, 'lps'),
	(480552, 126, '2015-04-01 00:08:38.000000', 'consum', 0.0224, 'lps'),
	(480553, 126, '2015-04-01 00:08:39.000000', 'consum', 0.0212, 'lps'),
	(480554, 126, '2015-04-01 00:08:40.000000', 'consum', 0.0217, 'lps'),
	(480555, 126, '2015-04-01 00:08:41.000000', 'consum', 0.0219, 'lps'),
	(480556, 126, '2015-04-01 00:08:42.000000', 'consum', 0.0218, 'lps'),
	(480557, 126, '2015-04-01 00:08:43.000000', 'consum', 0.0225, 'lps'),
	(480558, 126, '2015-04-01 00:08:44.000000', 'consum', 0.0224, 'lps'),
	(480559, 126, '2015-04-01 00:08:45.000000', 'consum', 0.0219, 'lps'),
	(480560, 126, '2015-04-01 00:08:46.000000', 'consum', 0.0211, 'lps'),
	(480561, 126, '2015-04-01 00:08:47.000000', 'consum', 0.0225, 'lps'),
	(480562, 126, '2015-04-01 00:08:48.000000', 'consum', 0.0211, 'lps'),
	(480563, 126, '2015-04-01 00:08:49.000000', 'consum', 0.0227, 'lps'),
	(480564, 126, '2015-04-01 00:08:50.000000', 'consum', 0.0217, 'lps'),
	(480565, 126, '2015-04-01 00:08:51.000000', 'consum', 0.0212, 'lps'),
	(480566, 126, '2015-04-01 00:08:52.000000', 'consum', 0.0219, 'lps'),
	(480567, 126, '2015-04-01 00:08:53.000000', 'consum', 0.0214, 'lps'),
	(480568, 126, '2015-04-01 00:08:54.000000', 'consum', 0.0222, 'lps'),
	(480569, 126, '2015-04-01 00:08:55.000000', 'consum', 0.0223, 'lps'),
	(480570, 126, '2015-04-01 00:08:56.000000', 'consum', 0.0223, 'lps'),
	(480571, 126, '2015-04-01 00:08:57.000000', 'consum', 0.0215, 'lps'),
	(480572, 126, '2015-04-01 00:08:58.000000', 'consum', 0.0215, 'lps'),
	(480573, 126, '2015-04-01 00:08:59.000000', 'consum', 0.0221, 'lps'),
	(480574, 126, '2015-04-01 00:09:00.000000', 'consum', 0.0213, 'lps'),
	(480575, 126, '2015-04-01 00:09:01.000000', 'consum', 0.0212, 'lps'),
	(480576, 126, '2015-04-01 00:09:02.000000', 'consum', 0.0213, 'lps'),
	(480577, 126, '2015-04-01 00:09:03.000000', 'consum', 0.0218, 'lps'),
	(480578, 126, '2015-04-01 00:09:04.000000', 'consum', 0.0223, 'lps'),
	(480579, 126, '2015-04-01 00:09:05.000000', 'consum', 0.0215, 'lps'),
	(480580, 126, '2015-04-01 00:09:06.000000', 'consum', 0.0214, 'lps'),
	(480581, 126, '2015-04-01 00:09:07.000000', 'consum', 0.0218, 'lps'),
	(480582, 126, '2015-04-01 00:09:08.000000', 'consum', 0.0217, 'lps'),
	(480583, 126, '2015-04-01 00:09:09.000000', 'consum', 0.0225, 'lps'),
	(480584, 126, '2015-04-01 00:09:10.000000', 'consum', 0.0226, 'lps'),
	(480585, 126, '2015-04-01 00:09:11.000000', 'consum', 0.0210, 'lps'),
	(480586, 126, '2015-04-01 00:09:12.000000', 'consum', 0.0215, 'lps'),
	(480587, 126, '2015-04-01 00:09:13.000000', 'consum', 0.0221, 'lps'),
	(480588, 126, '2015-04-01 00:09:14.000000', 'consum', 0.0212, 'lps'),
	(480589, 126, '2015-04-01 00:09:15.000000', 'consum', 0.0224, 'lps'),
	(480590, 126, '2015-04-01 00:09:16.000000', 'consum', 0.0221, 'lps'),
	(480591, 126, '2015-04-01 00:09:17.000000', 'consum', 0.0224, 'lps'),
	(480592, 126, '2015-04-01 00:09:18.000000', 'consum', 0.0213, 'lps'),
	(480593, 126, '2015-04-01 00:09:19.000000', 'consum', 0.0217, 'lps'),
	(480594, 126, '2015-04-01 00:09:20.000000', 'consum', 0.0218, 'lps'),
	(480595, 126, '2015-04-01 00:09:21.000000', 'consum', 0.0212, 'lps'),
	(480596, 126, '2015-04-01 00:09:22.000000', 'consum', 0.0216, 'lps'),
	(480597, 126, '2015-04-01 00:09:23.000000', 'consum', 0.0215, 'lps'),
	(480598, 126, '2015-04-01 00:09:24.000000', 'consum', 0.0218, 'lps'),
	(480599, 126, '2015-04-01 00:09:25.000000', 'consum', 0.0218, 'lps'),
	(480600, 126, '2015-04-01 00:09:26.000000', 'consum', 0.0210, 'lps'),
	(480601, 126, '2015-04-01 00:09:27.000000', 'consum', 0.0220, 'lps'),
	(480602, 126, '2015-04-01 00:09:28.000000', 'consum', 0.0227, 'lps'),
	(480603, 126, '2015-04-01 00:09:29.000000', 'consum', 0.0211, 'lps'),
	(480604, 126, '2015-04-01 00:09:30.000000', 'consum', 0.0216, 'lps'),
	(480605, 126, '2015-04-01 00:09:31.000000', 'consum', 0.0221, 'lps'),
	(480606, 126, '2015-04-01 00:09:32.000000', 'consum', 0.0213, 'lps'),
	(480607, 126, '2015-04-01 00:09:33.000000', 'consum', 0.0211, 'lps'),
	(480608, 126, '2015-04-01 00:09:34.000000', 'consum', 0.0224, 'lps'),
	(480609, 126, '2015-04-01 00:09:35.000000', 'consum', 0.0224, 'lps'),
	(480610, 126, '2015-04-01 00:09:36.000000', 'consum', 0.0221, 'lps'),
	(480611, 126, '2015-04-01 00:09:37.000000', 'consum', 0.0223, 'lps'),
	(480612, 126, '2015-04-01 00:09:38.000000', 'consum', 0.0223, 'lps'),
	(480613, 126, '2015-04-01 00:09:39.000000', 'consum', 0.0220, 'lps'),
	(480614, 126, '2015-04-01 00:09:40.000000', 'consum', 0.0221, 'lps'),
	(480615, 126, '2015-04-01 00:09:41.000000', 'consum', 0.0217, 'lps'),
	(480616, 126, '2015-04-01 00:09:42.000000', 'consum', 0.0213, 'lps'),
	(480617, 126, '2015-04-01 00:09:43.000000', 'consum', 0.0221, 'lps'),
	(480618, 126, '2015-04-01 00:09:44.000000', 'consum', 0.0222, 'lps'),
	(480619, 126, '2015-04-01 00:09:45.000000', 'consum', 0.0218, 'lps'),
	(480620, 126, '2015-04-01 00:09:46.000000', 'consum', 0.0215, 'lps'),
	(480621, 126, '2015-04-01 00:09:47.000000', 'consum', 0.0210, 'lps'),
	(480622, 126, '2015-04-01 00:09:48.000000', 'consum', 0.0213, 'lps'),
	(480623, 126, '2015-04-01 00:09:49.000000', 'consum', 0.0211, 'lps'),
	(480624, 126, '2015-04-01 00:09:50.000000', 'consum', 0.0222, 'lps'),
	(480625, 126, '2015-04-01 00:09:51.000000', 'consum', 0.0214, 'lps'),
	(480626, 126, '2015-04-01 00:09:52.000000', 'consum', 0.0212, 'lps'),
	(480627, 126, '2015-04-01 00:09:53.000000', 'consum', 0.0226, 'lps'),
	(480628, 126, '2015-04-01 00:09:54.000000', 'consum', 0.0212, 'lps'),
	(480629, 126, '2015-04-01 00:09:55.000000', 'consum', 0.0226, 'lps'),
	(480630, 126, '2015-04-01 00:09:56.000000', 'consum', 0.0212, 'lps'),
	(480631, 126, '2015-04-01 00:09:57.000000', 'consum', 0.0210, 'lps'),
	(480632, 126, '2015-04-01 00:09:58.000000', 'consum', 0.0223, 'lps'),
	(480633, 126, '2015-04-01 00:09:59.000000', 'consum', 0.0222, 'lps'),
	(480634, 126, '2015-04-01 00:10:00.000000', 'consum', 0.0211, 'lps'),
	(480635, 126, '2015-04-01 00:10:01.000000', 'consum', 0.0217, 'lps'),
	(480636, 126, '2015-04-01 00:10:02.000000', 'consum', 0.0223, 'lps'),
	(480637, 126, '2015-04-01 00:10:03.000000', 'consum', 0.0217, 'lps'),
	(480638, 126, '2015-04-01 00:10:04.000000', 'consum', 0.0210, 'lps'),
	(480639, 126, '2015-04-01 00:10:05.000000', 'consum', 0.0225, 'lps'),
	(480640, 126, '2015-04-01 00:10:06.000000', 'consum', 0.0213, 'lps'),
	(480641, 126, '2015-04-01 00:10:07.000000', 'consum', 0.0215, 'lps'),
	(480642, 126, '2015-04-01 00:10:08.000000', 'consum', 0.0211, 'lps'),
	(480643, 126, '2015-04-01 00:10:09.000000', 'consum', 0.0218, 'lps'),
	(480644, 126, '2015-04-01 00:10:10.000000', 'consum', 0.0211, 'lps'),
	(480645, 126, '2015-04-01 00:10:11.000000', 'consum', 0.0226, 'lps'),
	(480646, 126, '2015-04-01 00:10:12.000000', 'consum', 0.0216, 'lps'),
	(480647, 126, '2015-04-01 00:10:13.000000', 'consum', 0.0213, 'lps'),
	(480648, 126, '2015-04-01 00:10:14.000000', 'consum', 0.0224, 'lps'),
	(480649, 126, '2015-04-01 00:10:15.000000', 'consum', 0.0219, 'lps'),
	(480650, 126, '2015-04-01 00:10:16.000000', 'consum', 0.0213, 'lps'),
	(480651, 126, '2015-04-01 00:10:17.000000', 'consum', 0.0217, 'lps'),
	(480652, 126, '2015-04-01 00:10:18.000000', 'consum', 0.0217, 'lps'),
	(480653, 126, '2015-04-01 00:10:19.000000', 'consum', 0.0226, 'lps'),
	(480654, 126, '2015-04-01 00:10:20.000000', 'consum', 0.0213, 'lps'),
	(480655, 126, '2015-04-01 00:10:21.000000', 'consum', 0.0216, 'lps'),
	(480656, 126, '2015-04-01 00:10:22.000000', 'consum', 0.0212, 'lps'),
	(480657, 126, '2015-04-01 00:10:23.000000', 'consum', 0.0219, 'lps'),
	(480658, 126, '2015-04-01 00:10:24.000000', 'consum', 0.0216, 'lps'),
	(480659, 126, '2015-04-01 00:10:25.000000', 'consum', 0.0214, 'lps'),
	(480660, 126, '2015-04-01 00:10:26.000000', 'consum', 0.0212, 'lps'),
	(480661, 126, '2015-04-01 00:10:27.000000', 'consum', 0.0227, 'lps'),
	(480662, 126, '2015-04-01 00:10:28.000000', 'consum', 0.0215, 'lps'),
	(480663, 126, '2015-04-01 00:10:29.000000', 'consum', 0.0224, 'lps'),
	(480664, 126, '2015-04-01 00:10:30.000000', 'consum', 0.0227, 'lps'),
	(480665, 126, '2015-04-01 00:10:31.000000', 'consum', 0.0218, 'lps'),
	(480666, 126, '2015-04-01 00:10:32.000000', 'consum', 0.0217, 'lps'),
	(480667, 126, '2015-04-01 00:10:33.000000', 'consum', 0.0222, 'lps'),
	(480668, 126, '2015-04-01 00:10:34.000000', 'consum', 0.0213, 'lps'),
	(480669, 126, '2015-04-01 00:10:35.000000', 'consum', 0.0225, 'lps'),
	(480670, 126, '2015-04-01 00:10:36.000000', 'consum', 0.0224, 'lps'),
	(480671, 126, '2015-04-01 00:10:37.000000', 'consum', 0.0215, 'lps'),
	(480672, 126, '2015-04-01 00:10:38.000000', 'consum', 0.0213, 'lps'),
	(480673, 126, '2015-04-01 00:10:39.000000', 'consum', 0.0211, 'lps'),
	(480674, 126, '2015-04-01 00:10:40.000000', 'consum', 0.0222, 'lps'),
	(480675, 126, '2015-04-01 00:10:41.000000', 'consum', 0.0215, 'lps'),
	(480676, 126, '2015-04-01 00:10:42.000000', 'consum', 0.0218, 'lps'),
	(480677, 126, '2015-04-01 00:10:43.000000', 'consum', 0.0216, 'lps'),
	(480678, 126, '2015-04-01 00:10:44.000000', 'consum', 0.0218, 'lps'),
	(480679, 126, '2015-04-01 00:10:45.000000', 'consum', 0.0213, 'lps'),
	(480680, 126, '2015-04-01 00:10:46.000000', 'consum', 0.0222, 'lps'),
	(480681, 126, '2015-04-01 00:10:47.000000', 'consum', 0.0225, 'lps'),
	(480682, 126, '2015-04-01 00:10:48.000000', 'consum', 0.0213, 'lps'),
	(480683, 126, '2015-04-01 00:10:49.000000', 'consum', 0.0214, 'lps'),
	(480684, 126, '2015-04-01 00:10:50.000000', 'consum', 0.0225, 'lps'),
	(480685, 126, '2015-04-01 00:10:51.000000', 'consum', 0.0217, 'lps'),
	(480686, 126, '2015-04-01 00:10:52.000000', 'consum', 0.0219, 'lps'),
	(480687, 126, '2015-04-01 00:10:53.000000', 'consum', 0.0216, 'lps'),
	(480688, 126, '2015-04-01 00:10:54.000000', 'consum', 0.0215, 'lps'),
	(480689, 126, '2015-04-01 00:10:55.000000', 'consum', 0.0218, 'lps'),
	(480690, 126, '2015-04-01 00:10:56.000000', 'consum', 0.0218, 'lps'),
	(480691, 126, '2015-04-01 00:10:57.000000', 'consum', 0.0224, 'lps'),
	(480692, 126, '2015-04-01 00:10:58.000000', 'consum', 0.0222, 'lps'),
	(480693, 126, '2015-04-01 00:10:59.000000', 'consum', 0.0211, 'lps'),
	(480694, 126, '2015-04-01 00:11:00.000000', 'consum', 0.0215, 'lps'),
	(480695, 126, '2015-04-01 00:11:01.000000', 'consum', 0.0216, 'lps'),
	(480696, 126, '2015-04-01 00:11:02.000000', 'consum', 0.0224, 'lps'),
	(480697, 126, '2015-04-01 00:11:03.000000', 'consum', 0.0225, 'lps'),
	(480698, 126, '2015-04-01 00:11:04.000000', 'consum', 0.0226, 'lps'),
	(480699, 126, '2015-04-01 00:11:05.000000', 'consum', 0.0227, 'lps'),
	(480700, 126, '2015-04-01 00:11:06.000000', 'consum', 0.0211, 'lps'),
	(480701, 126, '2015-04-01 00:11:07.000000', 'consum', 0.0218, 'lps'),
	(480702, 126, '2015-04-01 00:11:08.000000', 'consum', 0.0211, 'lps'),
	(480703, 126, '2015-04-01 00:11:09.000000', 'consum', 0.0212, 'lps'),
	(480704, 126, '2015-04-01 00:11:10.000000', 'consum', 0.0217, 'lps'),
	(480705, 126, '2015-04-01 00:11:11.000000', 'consum', 0.0223, 'lps'),
	(480706, 126, '2015-04-01 00:11:12.000000', 'consum', 0.0217, 'lps'),
	(480707, 126, '2015-04-01 00:11:13.000000', 'consum', 0.0224, 'lps'),
	(480708, 126, '2015-04-01 00:11:14.000000', 'consum', 0.0223, 'lps'),
	(480709, 126, '2015-04-01 00:11:15.000000', 'consum', 0.0216, 'lps'),
	(480710, 126, '2015-04-01 00:11:16.000000', 'consum', 0.0221, 'lps'),
	(480711, 126, '2015-04-01 00:11:17.000000', 'consum', 0.0211, 'lps'),
	(480712, 126, '2015-04-01 00:11:18.000000', 'consum', 0.0219, 'lps'),
	(480713, 126, '2015-04-01 00:11:19.000000', 'consum', 0.0217, 'lps'),
	(480714, 126, '2015-04-01 00:11:20.000000', 'consum', 0.0216, 'lps'),
	(480715, 126, '2015-04-01 00:11:21.000000', 'consum', 0.0221, 'lps'),
	(480716, 126, '2015-04-01 00:11:22.000000', 'consum', 0.0211, 'lps'),
	(480717, 126, '2015-04-01 00:11:23.000000', 'consum', 0.0221, 'lps'),
	(480718, 126, '2015-04-01 00:11:24.000000', 'consum', 0.0223, 'lps'),
	(480719, 126, '2015-04-01 00:11:25.000000', 'consum', 0.0225, 'lps'),
	(480720, 126, '2015-04-01 00:11:26.000000', 'consum', 0.0211, 'lps'),
	(480721, 126, '2015-04-01 00:11:27.000000', 'consum', 0.0226, 'lps'),
	(480722, 126, '2015-04-01 00:11:28.000000', 'consum', 0.0213, 'lps'),
	(480723, 126, '2015-04-01 00:11:29.000000', 'consum', 0.0216, 'lps'),
	(480724, 126, '2015-04-01 00:11:30.000000', 'consum', 0.0211, 'lps'),
	(480725, 126, '2015-04-01 00:11:31.000000', 'consum', 0.0218, 'lps'),
	(480726, 126, '2015-04-01 00:11:32.000000', 'consum', 0.0211, 'lps'),
	(480727, 126, '2015-04-01 00:11:33.000000', 'consum', 0.0227, 'lps'),
	(480728, 126, '2015-04-01 00:11:34.000000', 'consum', 0.0219, 'lps'),
	(480729, 126, '2015-04-01 00:11:35.000000', 'consum', 0.0224, 'lps'),
	(480730, 126, '2015-04-01 00:11:36.000000', 'consum', 0.0216, 'lps'),
	(480731, 126, '2015-04-01 00:11:37.000000', 'consum', 0.0218, 'lps'),
	(480732, 126, '2015-04-01 00:11:38.000000', 'consum', 0.0215, 'lps'),
	(480733, 126, '2015-04-01 00:11:39.000000', 'consum', 0.0210, 'lps'),
	(480734, 126, '2015-04-01 00:11:40.000000', 'consum', 0.0214, 'lps'),
	(480735, 126, '2015-04-01 00:11:41.000000', 'consum', 0.0214, 'lps'),
	(480736, 126, '2015-04-01 00:11:42.000000', 'consum', 0.0219, 'lps'),
	(480737, 126, '2015-04-01 00:11:43.000000', 'consum', 0.0225, 'lps'),
	(480738, 126, '2015-04-01 00:11:44.000000', 'consum', 0.0224, 'lps'),
	(480739, 126, '2015-04-01 00:11:45.000000', 'consum', 0.0216, 'lps'),
	(480740, 126, '2015-04-01 00:11:46.000000', 'consum', 0.0218, 'lps'),
	(480741, 126, '2015-04-01 00:11:47.000000', 'consum', 0.0214, 'lps'),
	(480742, 126, '2015-04-01 00:11:48.000000', 'consum', 0.0225, 'lps'),
	(480743, 126, '2015-04-01 00:11:49.000000', 'consum', 0.0218, 'lps'),
	(480744, 126, '2015-04-01 00:11:50.000000', 'consum', 0.0226, 'lps'),
	(480745, 126, '2015-04-01 00:11:51.000000', 'consum', 0.0210, 'lps'),
	(480746, 126, '2015-04-01 00:11:52.000000', 'consum', 0.0219, 'lps'),
	(480747, 126, '2015-04-01 00:11:53.000000', 'consum', 0.0217, 'lps'),
	(480748, 126, '2015-04-01 00:11:54.000000', 'consum', 0.0219, 'lps'),
	(480749, 126, '2015-04-01 00:11:55.000000', 'consum', 0.0216, 'lps'),
	(480750, 126, '2015-04-01 00:11:56.000000', 'consum', 0.0214, 'lps'),
	(480751, 126, '2015-04-01 00:11:57.000000', 'consum', 0.0212, 'lps'),
	(480752, 126, '2015-04-01 00:11:58.000000', 'consum', 0.0210, 'lps'),
	(480753, 126, '2015-04-01 00:11:59.000000', 'consum', 0.0223, 'lps'),
	(480754, 126, '2015-04-01 00:12:00.000000', 'consum', 0.0222, 'lps'),
	(480755, 126, '2015-04-01 00:12:01.000000', 'consum', 0.0214, 'lps'),
	(480756, 126, '2015-04-01 00:12:02.000000', 'consum', 0.0212, 'lps'),
	(480757, 126, '2015-04-01 00:12:03.000000', 'consum', 0.0210, 'lps'),
	(480758, 126, '2015-04-01 00:12:04.000000', 'consum', 0.0222, 'lps'),
	(480759, 126, '2015-04-01 00:12:05.000000', 'consum', 0.0215, 'lps'),
	(480760, 126, '2015-04-01 00:12:06.000000', 'consum', 0.0217, 'lps'),
	(480761, 126, '2015-04-01 00:12:07.000000', 'consum', 0.0214, 'lps'),
	(480762, 126, '2015-04-01 00:12:08.000000', 'consum', 0.0226, 'lps'),
	(480763, 126, '2015-04-01 00:12:09.000000', 'consum', 0.0223, 'lps'),
	(480764, 126, '2015-04-01 00:12:10.000000', 'consum', 0.0213, 'lps'),
	(480765, 126, '2015-04-01 00:12:11.000000', 'consum', 0.0221, 'lps'),
	(480766, 126, '2015-04-01 00:12:12.000000', 'consum', 0.0219, 'lps'),
	(480767, 126, '2015-04-01 00:12:13.000000', 'consum', 0.0225, 'lps'),
	(480768, 126, '2015-04-01 00:12:14.000000', 'consum', 0.0223, 'lps'),
	(480769, 126, '2015-04-01 00:12:15.000000', 'consum', 0.0210, 'lps'),
	(480770, 126, '2015-04-01 00:12:16.000000', 'consum', 0.0227, 'lps'),
	(480771, 126, '2015-04-01 00:12:17.000000', 'consum', 0.0221, 'lps'),
	(480772, 126, '2015-04-01 00:12:18.000000', 'consum', 0.0216, 'lps'),
	(480773, 126, '2015-04-01 00:12:19.000000', 'consum', 0.0226, 'lps'),
	(480774, 126, '2015-04-01 00:12:20.000000', 'consum', 0.0219, 'lps'),
	(480775, 126, '2015-04-01 00:12:21.000000', 'consum', 0.0227, 'lps'),
	(480776, 126, '2015-04-01 00:12:22.000000', 'consum', 0.0213, 'lps'),
	(480777, 126, '2015-04-01 00:12:23.000000', 'consum', 0.0227, 'lps'),
	(480778, 126, '2015-04-01 00:12:24.000000', 'consum', 0.0218, 'lps'),
	(480779, 126, '2015-04-01 00:12:25.000000', 'consum', 0.0214, 'lps'),
	(480780, 126, '2015-04-01 00:12:26.000000', 'consum', 0.0225, 'lps'),
	(480781, 126, '2015-04-01 00:12:27.000000', 'consum', 0.0220, 'lps'),
	(480782, 126, '2015-04-01 00:12:28.000000', 'consum', 0.0215, 'lps'),
	(480783, 126, '2015-04-01 00:12:29.000000', 'consum', 0.0223, 'lps'),
	(480784, 126, '2015-04-01 00:12:30.000000', 'consum', 0.0226, 'lps'),
	(480785, 126, '2015-04-01 00:12:31.000000', 'consum', 0.0217, 'lps'),
	(480786, 126, '2015-04-01 00:12:32.000000', 'consum', 0.0212, 'lps'),
	(480787, 126, '2015-04-01 00:12:33.000000', 'consum', 0.0219, 'lps'),
	(480788, 126, '2015-04-01 00:12:34.000000', 'consum', 0.0213, 'lps'),
	(480789, 126, '2015-04-01 00:12:35.000000', 'consum', 0.0217, 'lps'),
	(480790, 126, '2015-04-01 00:12:36.000000', 'consum', 0.0220, 'lps'),
	(480791, 126, '2015-04-01 00:12:37.000000', 'consum', 0.0221, 'lps'),
	(480792, 126, '2015-04-01 00:12:38.000000', 'consum', 0.0216, 'lps'),
	(480793, 126, '2015-04-01 00:12:39.000000', 'consum', 0.0226, 'lps'),
	(480794, 126, '2015-04-01 00:12:40.000000', 'consum', 0.0218, 'lps'),
	(480795, 126, '2015-04-01 00:12:41.000000', 'consum', 0.0220, 'lps'),
	(480796, 126, '2015-04-01 00:12:42.000000', 'consum', 0.0221, 'lps'),
	(480797, 126, '2015-04-01 00:12:43.000000', 'consum', 0.0217, 'lps'),
	(480798, 126, '2015-04-01 00:12:44.000000', 'consum', 0.0212, 'lps'),
	(480799, 126, '2015-04-01 00:12:45.000000', 'consum', 0.0219, 'lps'),
	(480800, 126, '2015-04-01 00:12:46.000000', 'consum', 0.0213, 'lps'),
	(480801, 126, '2015-04-01 00:12:47.000000', 'consum', 0.0216, 'lps'),
	(480802, 126, '2015-04-01 00:12:48.000000', 'consum', 0.0212, 'lps'),
	(480803, 126, '2015-04-01 00:12:49.000000', 'consum', 0.0223, 'lps'),
	(480804, 126, '2015-04-01 00:12:50.000000', 'consum', 0.0214, 'lps'),
	(480805, 126, '2015-04-01 00:12:51.000000', 'consum', 0.0227, 'lps'),
	(480806, 126, '2015-04-01 00:12:52.000000', 'consum', 0.0210, 'lps'),
	(480807, 126, '2015-04-01 00:12:53.000000', 'consum', 0.0216, 'lps'),
	(480808, 126, '2015-04-01 00:12:54.000000', 'consum', 0.0221, 'lps'),
	(480809, 126, '2015-04-01 00:12:55.000000', 'consum', 0.0214, 'lps'),
	(480810, 126, '2015-04-01 00:12:56.000000', 'consum', 0.0214, 'lps'),
	(480811, 126, '2015-04-01 00:12:57.000000', 'consum', 0.0221, 'lps'),
	(480812, 126, '2015-04-01 00:12:58.000000', 'consum', 0.0214, 'lps'),
	(480813, 126, '2015-04-01 00:12:59.000000', 'consum', 0.0217, 'lps'),
	(480814, 126, '2015-04-01 00:13:00.000000', 'consum', 0.0214, 'lps'),
	(480815, 126, '2015-04-01 00:13:01.000000', 'consum', 0.0212, 'lps'),
	(480816, 126, '2015-04-01 00:13:02.000000', 'consum', 0.0224, 'lps'),
	(480817, 126, '2015-04-01 00:13:03.000000', 'consum', 0.0223, 'lps'),
	(480818, 126, '2015-04-01 00:13:04.000000', 'consum', 0.0214, 'lps'),
	(480819, 126, '2015-04-01 00:13:05.000000', 'consum', 0.0226, 'lps'),
	(480820, 126, '2015-04-01 00:13:06.000000', 'consum', 0.0210, 'lps'),
	(480821, 126, '2015-04-01 00:13:07.000000', 'consum', 0.0213, 'lps'),
	(480822, 126, '2015-04-01 00:13:08.000000', 'consum', 0.0211, 'lps'),
	(480823, 126, '2015-04-01 00:13:09.000000', 'consum', 0.0222, 'lps'),
	(480824, 126, '2015-04-01 00:13:10.000000', 'consum', 0.0213, 'lps'),
	(480825, 126, '2015-04-01 00:13:11.000000', 'consum', 0.0210, 'lps'),
	(480826, 126, '2015-04-01 00:13:12.000000', 'consum', 0.0217, 'lps'),
	(480827, 126, '2015-04-01 00:13:13.000000', 'consum', 0.0210, 'lps'),
	(480828, 126, '2015-04-01 00:13:14.000000', 'consum', 0.0225, 'lps'),
	(480829, 126, '2015-04-01 00:13:15.000000', 'consum', 0.0212, 'lps'),
	(480830, 126, '2015-04-01 00:13:16.000000', 'consum', 0.0213, 'lps'),
	(480831, 126, '2015-04-01 00:13:17.000000', 'consum', 0.0220, 'lps'),
	(480832, 126, '2015-04-01 00:13:18.000000', 'consum', 0.0216, 'lps'),
	(480833, 126, '2015-04-01 00:13:19.000000', 'consum', 0.0212, 'lps'),
	(480834, 126, '2015-04-01 00:13:20.000000', 'consum', 0.0217, 'lps'),
	(480835, 126, '2015-04-01 00:13:21.000000', 'consum', 0.0224, 'lps'),
	(480836, 126, '2015-04-01 00:13:22.000000', 'consum', 0.0224, 'lps'),
	(480837, 126, '2015-04-01 00:13:23.000000', 'consum', 0.0220, 'lps'),
	(480838, 126, '2015-04-01 00:13:24.000000', 'consum', 0.0218, 'lps'),
	(480839, 126, '2015-04-01 00:13:25.000000', 'consum', 0.0222, 'lps'),
	(480840, 126, '2015-04-01 00:13:26.000000', 'consum', 0.0210, 'lps'),
	(480841, 126, '2015-04-01 00:13:27.000000', 'consum', 0.0227, 'lps'),
	(480842, 126, '2015-04-01 00:13:28.000000', 'consum', 0.0225, 'lps'),
	(480843, 126, '2015-04-01 00:13:29.000000', 'consum', 0.0217, 'lps'),
	(480844, 126, '2015-04-01 00:13:30.000000', 'consum', 0.0216, 'lps'),
	(480845, 126, '2015-04-01 00:13:31.000000', 'consum', 0.0221, 'lps'),
	(480846, 126, '2015-04-01 00:13:32.000000', 'consum', 0.0211, 'lps'),
	(480847, 126, '2015-04-01 00:13:33.000000', 'consum', 0.0220, 'lps'),
	(480848, 126, '2015-04-01 00:13:34.000000', 'consum', 0.0222, 'lps'),
	(480849, 126, '2015-04-01 00:13:35.000000', 'consum', 0.0220, 'lps'),
	(480850, 126, '2015-04-01 00:13:36.000000', 'consum', 0.0224, 'lps'),
	(480851, 126, '2015-04-01 00:13:37.000000', 'consum', 0.0214, 'lps'),
	(480852, 126, '2015-04-01 00:13:38.000000', 'consum', 0.0226, 'lps'),
	(480853, 126, '2015-04-01 00:13:39.000000', 'consum', 0.0224, 'lps'),
	(480854, 126, '2015-04-01 00:13:40.000000', 'consum', 0.0213, 'lps'),
	(480855, 126, '2015-04-01 00:13:41.000000', 'consum', 0.0219, 'lps'),
	(480856, 126, '2015-04-01 00:13:42.000000', 'consum', 0.0214, 'lps'),
	(480857, 126, '2015-04-01 00:13:43.000000', 'consum', 0.0219, 'lps'),
	(480858, 126, '2015-04-01 00:13:44.000000', 'consum', 0.0225, 'lps'),
	(480859, 126, '2015-04-01 00:13:45.000000', 'consum', 0.0225, 'lps'),
	(480860, 126, '2015-04-01 00:13:46.000000', 'consum', 0.0220, 'lps'),
	(480861, 126, '2015-04-01 00:13:47.000000', 'consum', 0.0218, 'lps'),
	(480862, 126, '2015-04-01 00:13:48.000000', 'consum', 0.0221, 'lps'),
	(480863, 126, '2015-04-01 00:13:49.000000', 'consum', 0.0221, 'lps'),
	(480864, 126, '2015-04-01 00:13:50.000000', 'consum', 0.0216, 'lps'),
	(480865, 126, '2015-04-01 00:13:51.000000', 'consum', 0.0227, 'lps'),
	(480866, 126, '2015-04-01 00:13:52.000000', 'consum', 0.0222, 'lps'),
	(480867, 126, '2015-04-01 00:13:53.000000', 'consum', 0.0218, 'lps'),
	(480868, 126, '2015-04-01 00:13:54.000000', 'consum', 0.0216, 'lps'),
	(480869, 126, '2015-04-01 00:13:55.000000', 'consum', 0.0218, 'lps'),
	(480870, 126, '2015-04-01 00:13:56.000000', 'consum', 0.0213, 'lps'),
	(480871, 126, '2015-04-01 00:13:57.000000', 'consum', 0.0221, 'lps'),
	(480872, 126, '2015-04-01 00:13:58.000000', 'consum', 0.0221, 'lps'),
	(480873, 126, '2015-04-01 00:13:59.000000', 'consum', 0.0212, 'lps'),
	(480874, 126, '2015-04-01 00:14:00.000000', 'consum', 0.0223, 'lps'),
	(480875, 126, '2015-04-01 00:14:01.000000', 'consum', 0.0214, 'lps'),
	(480876, 126, '2015-04-01 00:14:02.000000', 'consum', 0.0213, 'lps'),
	(480877, 126, '2015-04-01 00:14:03.000000', 'consum', 0.0213, 'lps'),
	(480878, 126, '2015-04-01 00:14:04.000000', 'consum', 0.0217, 'lps'),
	(480879, 126, '2015-04-01 00:14:05.000000', 'consum', 0.0219, 'lps'),
	(480880, 126, '2015-04-01 00:14:06.000000', 'consum', 0.0216, 'lps'),
	(480881, 126, '2015-04-01 00:14:07.000000', 'consum', 0.0213, 'lps'),
	(480882, 126, '2015-04-01 00:14:08.000000', 'consum', 0.0224, 'lps'),
	(480883, 126, '2015-04-01 00:14:09.000000', 'consum', 0.0220, 'lps'),
	(480884, 126, '2015-04-01 00:14:10.000000', 'consum', 0.0216, 'lps'),
	(480885, 126, '2015-04-01 00:14:11.000000', 'consum', 0.0214, 'lps'),
	(480886, 126, '2015-04-01 00:14:12.000000', 'consum', 0.0227, 'lps'),
	(480887, 126, '2015-04-01 00:14:13.000000', 'consum', 0.0213, 'lps'),
	(480888, 126, '2015-04-01 00:14:14.000000', 'consum', 0.0212, 'lps'),
	(480889, 126, '2015-04-01 00:14:15.000000', 'consum', 0.0210, 'lps'),
	(480890, 126, '2015-04-01 00:14:16.000000', 'consum', 0.0222, 'lps'),
	(480891, 126, '2015-04-01 00:14:17.000000', 'consum', 0.0219, 'lps'),
	(480892, 126, '2015-04-01 00:14:18.000000', 'consum', 0.0218, 'lps'),
	(480893, 126, '2015-04-01 00:14:19.000000', 'consum', 0.0224, 'lps'),
	(480894, 126, '2015-04-01 00:14:20.000000', 'consum', 0.0221, 'lps'),
	(480895, 126, '2015-04-01 00:14:21.000000', 'consum', 0.0222, 'lps'),
	(480896, 126, '2015-04-01 00:14:22.000000', 'consum', 0.0218, 'lps'),
	(480897, 126, '2015-04-01 00:14:23.000000', 'consum', 0.0218, 'lps'),
	(480898, 126, '2015-04-01 00:14:24.000000', 'consum', 0.0226, 'lps'),
	(480899, 126, '2015-04-01 00:14:25.000000', 'consum', 0.0210, 'lps'),
	(480900, 126, '2015-04-01 00:14:26.000000', 'consum', 0.0218, 'lps'),
	(480901, 126, '2015-04-01 00:14:27.000000', 'consum', 0.0215, 'lps'),
	(480902, 126, '2015-04-01 00:14:28.000000', 'consum', 0.0212, 'lps'),
	(480903, 126, '2015-04-01 00:14:29.000000', 'consum', 0.0223, 'lps'),
	(480904, 126, '2015-04-01 00:14:30.000000', 'consum', 0.0216, 'lps'),
	(480905, 126, '2015-04-01 00:14:31.000000', 'consum', 0.0219, 'lps'),
	(480906, 126, '2015-04-01 00:14:32.000000', 'consum', 0.0219, 'lps'),
	(480907, 126, '2015-04-01 00:14:33.000000', 'consum', 0.0212, 'lps'),
	(480908, 126, '2015-04-01 00:14:34.000000', 'consum', 0.0212, 'lps'),
	(480909, 126, '2015-04-01 00:14:35.000000', 'consum', 0.0212, 'lps'),
	(480910, 126, '2015-04-01 00:14:36.000000', 'consum', 0.0216, 'lps'),
	(480911, 126, '2015-04-01 00:14:37.000000', 'consum', 0.0218, 'lps'),
	(480912, 126, '2015-04-01 00:14:38.000000', 'consum', 0.0211, 'lps'),
	(480913, 126, '2015-04-01 00:14:39.000000', 'consum', 0.0213, 'lps'),
	(480914, 126, '2015-04-01 00:14:40.000000', 'consum', 0.0222, 'lps'),
	(480915, 126, '2015-04-01 00:14:41.000000', 'consum', 0.0223, 'lps'),
	(480916, 126, '2015-04-01 00:14:42.000000', 'consum', 0.0224, 'lps'),
	(480917, 126, '2015-04-01 00:14:43.000000', 'consum', 0.0222, 'lps'),
	(480918, 126, '2015-04-01 00:14:44.000000', 'consum', 0.0210, 'lps'),
	(480919, 126, '2015-04-01 00:14:45.000000', 'consum', 0.0211, 'lps'),
	(480920, 126, '2015-04-01 00:14:46.000000', 'consum', 0.0216, 'lps'),
	(480921, 126, '2015-04-01 00:14:47.000000', 'consum', 0.0220, 'lps'),
	(480922, 126, '2015-04-01 00:14:48.000000', 'consum', 0.0226, 'lps'),
	(480923, 126, '2015-04-01 00:14:49.000000', 'consum', 0.0221, 'lps'),
	(480924, 126, '2015-04-01 00:14:50.000000', 'consum', 0.0221, 'lps'),
	(480925, 126, '2015-04-01 00:14:51.000000', 'consum', 0.0212, 'lps'),
	(480926, 126, '2015-04-01 00:14:52.000000', 'consum', 0.0223, 'lps'),
	(480927, 126, '2015-04-01 00:14:53.000000', 'consum', 0.0215, 'lps'),
	(480928, 126, '2015-04-01 00:14:54.000000', 'consum', 0.0215, 'lps'),
	(480929, 126, '2015-04-01 00:14:55.000000', 'consum', 0.0223, 'lps'),
	(480930, 126, '2015-04-01 00:14:56.000000', 'consum', 0.0221, 'lps'),
	(480931, 126, '2015-04-01 00:14:57.000000', 'consum', 0.0211, 'lps'),
	(480932, 126, '2015-04-01 00:14:58.000000', 'consum', 0.0216, 'lps'),
	(480933, 126, '2015-04-01 00:14:59.000000', 'consum', 0.0221, 'lps'),
	(480934, 126, '2015-04-01 00:15:00.000000', 'consum', 0.0213, 'lps'),
	(480935, 126, '2015-04-01 00:15:01.000000', 'consum', 0.0227, 'lps'),
	(480936, 126, '2015-04-01 00:15:02.000000', 'consum', 0.0213, 'lps'),
	(480937, 126, '2015-04-01 00:15:03.000000', 'consum', 0.0211, 'lps'),
	(480938, 126, '2015-04-01 00:15:04.000000', 'consum', 0.0225, 'lps'),
	(480939, 126, '2015-04-01 00:15:05.000000', 'consum', 0.0211, 'lps'),
	(480940, 126, '2015-04-01 00:15:06.000000', 'consum', 0.0222, 'lps'),
	(480941, 126, '2015-04-01 00:15:07.000000', 'consum', 0.0216, 'lps'),
	(480942, 126, '2015-04-01 00:15:08.000000', 'consum', 0.0221, 'lps'),
	(480943, 126, '2015-04-01 00:15:09.000000', 'consum', 0.0212, 'lps'),
	(480944, 126, '2015-04-01 00:15:10.000000', 'consum', 0.0225, 'lps'),
	(480945, 126, '2015-04-01 00:15:11.000000', 'consum', 0.0225, 'lps'),
	(480946, 126, '2015-04-01 00:15:12.000000', 'consum', 0.0224, 'lps'),
	(480947, 126, '2015-04-01 00:15:13.000000', 'consum', 0.0215, 'lps'),
	(480948, 126, '2015-04-01 00:15:14.000000', 'consum', 0.0211, 'lps'),
	(480949, 126, '2015-04-01 00:15:15.000000', 'consum', 0.0217, 'lps'),
	(480950, 126, '2015-04-01 00:15:16.000000', 'consum', 0.0210, 'lps'),
	(480951, 126, '2015-04-01 00:15:17.000000', 'consum', 0.0224, 'lps'),
	(480952, 126, '2015-04-01 00:15:18.000000', 'consum', 0.0227, 'lps'),
	(480953, 126, '2015-04-01 00:15:19.000000', 'consum', 0.0219, 'lps'),
	(480954, 126, '2015-04-01 00:15:20.000000', 'consum', 0.0220, 'lps'),
	(480955, 126, '2015-04-01 00:15:21.000000', 'consum', 0.0217, 'lps'),
	(480956, 126, '2015-04-01 00:15:22.000000', 'consum', 0.0213, 'lps'),
	(480957, 126, '2015-04-01 00:15:23.000000', 'consum', 0.0226, 'lps'),
	(480958, 126, '2015-04-01 00:15:24.000000', 'consum', 0.0226, 'lps'),
	(480959, 126, '2015-04-01 00:15:25.000000', 'consum', 0.0226, 'lps'),
	(480960, 126, '2015-04-01 00:15:26.000000', 'consum', 0.0225, 'lps'),
	(480961, 126, '2015-04-01 00:15:27.000000', 'consum', 0.0220, 'lps'),
	(480962, 126, '2015-04-01 00:15:28.000000', 'consum', 0.0215, 'lps'),
	(480963, 126, '2015-04-01 00:15:29.000000', 'consum', 0.0224, 'lps'),
	(480964, 126, '2015-04-01 00:15:30.000000', 'consum', 0.0210, 'lps'),
	(480965, 126, '2015-04-01 00:15:31.000000', 'consum', 0.0224, 'lps'),
	(480966, 126, '2015-04-01 00:15:32.000000', 'consum', 0.0227, 'lps'),
	(480967, 126, '2015-04-01 00:15:33.000000', 'consum', 0.0219, 'lps'),
	(480968, 126, '2015-04-01 00:15:34.000000', 'consum', 0.0219, 'lps'),
	(480969, 126, '2015-04-01 00:15:35.000000', 'consum', 0.0214, 'lps'),
	(480970, 126, '2015-04-01 00:15:36.000000', 'consum', 0.0219, 'lps'),
	(480971, 126, '2015-04-01 00:15:37.000000', 'consum', 0.0226, 'lps'),
	(480972, 126, '2015-04-01 00:15:38.000000', 'consum', 0.0226, 'lps'),
	(480973, 126, '2015-04-01 00:15:39.000000', 'consum', 0.0226, 'lps'),
	(480974, 126, '2015-04-01 00:15:40.000000', 'consum', 0.0226, 'lps'),
	(480975, 126, '2015-04-01 00:15:41.000000', 'consum', 0.0222, 'lps'),
	(480976, 126, '2015-04-01 00:15:42.000000', 'consum', 0.0222, 'lps'),
	(480977, 126, '2015-04-01 00:15:43.000000', 'consum', 0.0218, 'lps'),
	(480978, 126, '2015-04-01 00:15:44.000000', 'consum', 0.0214, 'lps'),
	(480979, 126, '2015-04-01 00:15:45.000000', 'consum', 0.0224, 'lps'),
	(480980, 126, '2015-04-01 00:15:46.000000', 'consum', 0.0217, 'lps'),
	(480981, 126, '2015-04-01 00:15:47.000000', 'consum', 0.0219, 'lps'),
	(480982, 126, '2015-04-01 00:15:48.000000', 'consum', 0.0219, 'lps'),
	(480983, 126, '2015-04-01 00:15:49.000000', 'consum', 0.0226, 'lps'),
	(480984, 126, '2015-04-01 00:15:50.000000', 'consum', 0.0212, 'lps'),
	(480985, 126, '2015-04-01 00:15:51.000000', 'consum', 0.0225, 'lps'),
	(480986, 126, '2015-04-01 00:15:52.000000', 'consum', 0.0224, 'lps'),
	(480987, 126, '2015-04-01 00:15:53.000000', 'consum', 0.0221, 'lps'),
	(480988, 126, '2015-04-01 00:15:54.000000', 'consum', 0.0221, 'lps'),
	(480989, 126, '2015-04-01 00:15:55.000000', 'consum', 0.0217, 'lps'),
	(480990, 126, '2015-04-01 00:15:56.000000', 'consum', 0.0210, 'lps'),
	(480991, 126, '2015-04-01 00:15:57.000000', 'consum', 0.0226, 'lps'),
	(480992, 126, '2015-04-01 00:15:58.000000', 'consum', 0.0218, 'lps'),
	(480993, 126, '2015-04-01 00:15:59.000000', 'consum', 0.0222, 'lps'),
	(480994, 126, '2015-04-01 00:16:00.000000', 'consum', 0.0210, 'lps'),
	(480995, 126, '2015-04-01 00:16:01.000000', 'consum', 0.0227, 'lps'),
	(480996, 126, '2015-04-01 00:16:02.000000', 'consum', 0.0222, 'lps'),
	(480997, 126, '2015-04-01 00:16:03.000000', 'consum', 0.0223, 'lps'),
	(480998, 126, '2015-04-01 00:16:04.000000', 'consum', 0.0220, 'lps'),
	(480999, 126, '2015-04-01 00:16:05.000000', 'consum', 0.0220, 'lps'),
	(481000, 126, '2015-04-01 00:16:06.000000', 'consum', 0.0216, 'lps'),
	(481001, 126, '2015-04-01 00:16:07.000000', 'consum', 0.0225, 'lps'),
	(481002, 126, '2015-04-01 00:16:08.000000', 'consum', 0.0216, 'lps'),
	(481003, 126, '2015-04-01 00:16:09.000000', 'consum', 0.0214, 'lps'),
	(481004, 126, '2015-04-01 00:16:10.000000', 'consum', 0.0211, 'lps'),
	(481005, 126, '2015-04-01 00:16:11.000000', 'consum', 0.0220, 'lps'),
	(481006, 126, '2015-04-01 00:16:12.000000', 'consum', 0.0224, 'lps'),
	(481007, 126, '2015-04-01 00:16:13.000000', 'consum', 0.0214, 'lps'),
	(481008, 126, '2015-04-01 00:16:14.000000', 'consum', 0.0223, 'lps'),
	(481009, 126, '2015-04-01 00:16:15.000000', 'consum', 0.0212, 'lps'),
	(481010, 126, '2015-04-01 00:16:16.000000', 'consum', 0.0217, 'lps'),
	(481011, 126, '2015-04-01 00:16:17.000000', 'consum', 0.0220, 'lps'),
	(481012, 126, '2015-04-01 00:16:18.000000', 'consum', 0.0223, 'lps'),
	(481013, 126, '2015-04-01 00:16:19.000000', 'consum', 0.0210, 'lps'),
	(481014, 126, '2015-04-01 00:16:20.000000', 'consum', 0.0227, 'lps'),
	(481015, 126, '2015-04-01 00:16:21.000000', 'consum', 0.0221, 'lps'),
	(481016, 126, '2015-04-01 00:16:22.000000', 'consum', 0.0214, 'lps'),
	(481017, 126, '2015-04-01 00:16:23.000000', 'consum', 0.0216, 'lps'),
	(481018, 126, '2015-04-01 00:16:24.000000', 'consum', 0.0210, 'lps'),
	(481019, 126, '2015-04-01 00:16:25.000000', 'consum', 0.0212, 'lps'),
	(481020, 126, '2015-04-01 00:16:26.000000', 'consum', 0.0219, 'lps'),
	(481021, 126, '2015-04-01 00:16:27.000000', 'consum', 0.0214, 'lps'),
	(481022, 126, '2015-04-01 00:16:28.000000', 'consum', 0.0222, 'lps'),
	(481023, 126, '2015-04-01 00:16:29.000000', 'consum', 0.0221, 'lps'),
	(481024, 126, '2015-04-01 00:16:30.000000', 'consum', 0.0211, 'lps'),
	(481025, 126, '2015-04-01 00:16:31.000000', 'consum', 0.0219, 'lps'),
	(481026, 126, '2015-04-01 00:16:32.000000', 'consum', 0.0217, 'lps'),
	(481027, 126, '2015-04-01 00:16:33.000000', 'consum', 0.0218, 'lps'),
	(481028, 126, '2015-04-01 00:16:34.000000', 'consum', 0.0210, 'lps'),
	(481029, 126, '2015-04-01 00:16:35.000000', 'consum', 0.0225, 'lps'),
	(481030, 126, '2015-04-01 00:16:36.000000', 'consum', 0.0211, 'lps'),
	(481031, 126, '2015-04-01 00:16:37.000000', 'consum', 0.0226, 'lps'),
	(481032, 126, '2015-04-01 00:16:38.000000', 'consum', 0.0216, 'lps'),
	(481033, 126, '2015-04-01 00:16:39.000000', 'consum', 0.0227, 'lps'),
	(481034, 126, '2015-04-01 00:16:40.000000', 'consum', 0.0224, 'lps'),
	(481035, 126, '2015-04-01 00:16:41.000000', 'consum', 0.0212, 'lps'),
	(481036, 126, '2015-04-01 00:16:42.000000', 'consum', 0.0214, 'lps'),
	(481037, 126, '2015-04-01 00:16:43.000000', 'consum', 0.0224, 'lps'),
	(481038, 126, '2015-04-01 00:16:44.000000', 'consum', 0.0216, 'lps'),
	(481039, 126, '2015-04-01 00:16:45.000000', 'consum', 0.0218, 'lps'),
	(481040, 126, '2015-04-01 00:16:46.000000', 'consum', 0.0212, 'lps'),
	(481041, 126, '2015-04-01 00:16:47.000000', 'consum', 0.0213, 'lps'),
	(481042, 126, '2015-04-01 00:16:48.000000', 'consum', 0.0221, 'lps'),
	(481043, 126, '2015-04-01 00:16:49.000000', 'consum', 0.0222, 'lps'),
	(481044, 126, '2015-04-01 00:16:50.000000', 'consum', 0.0219, 'lps'),
	(481045, 126, '2015-04-01 00:16:51.000000', 'consum', 0.0219, 'lps'),
	(481046, 126, '2015-04-01 00:16:52.000000', 'consum', 0.0210, 'lps'),
	(481047, 126, '2015-04-01 00:16:53.000000', 'consum', 0.0219, 'lps'),
	(481048, 126, '2015-04-01 00:16:54.000000', 'consum', 0.0220, 'lps'),
	(481049, 126, '2015-04-01 00:16:55.000000', 'consum', 0.0215, 'lps'),
	(481050, 126, '2015-04-01 00:16:56.000000', 'consum', 0.0224, 'lps'),
	(481051, 126, '2015-04-01 00:16:57.000000', 'consum', 0.0212, 'lps'),
	(481052, 126, '2015-04-01 00:16:58.000000', 'consum', 0.0213, 'lps'),
	(481053, 126, '2015-04-01 00:16:59.000000', 'consum', 0.0222, 'lps'),
	(481054, 126, '2015-04-01 00:17:00.000000', 'consum', 0.0224, 'lps'),
	(481055, 126, '2015-04-01 00:17:01.000000', 'consum', 0.0210, 'lps'),
	(481056, 126, '2015-04-01 00:17:02.000000', 'consum', 0.0221, 'lps'),
	(481057, 126, '2015-04-01 00:17:03.000000', 'consum', 0.0212, 'lps'),
	(481058, 126, '2015-04-01 00:17:04.000000', 'consum', 0.0225, 'lps'),
	(481059, 126, '2015-04-01 00:17:05.000000', 'consum', 0.0226, 'lps'),
	(481060, 126, '2015-04-01 00:17:06.000000', 'consum', 0.0210, 'lps'),
	(481061, 126, '2015-04-01 00:17:07.000000', 'consum', 0.0217, 'lps'),
	(481062, 126, '2015-04-01 00:17:08.000000', 'consum', 0.0210, 'lps'),
	(481063, 126, '2015-04-01 00:17:09.000000', 'consum', 0.0224, 'lps'),
	(481064, 126, '2015-04-01 00:17:10.000000', 'consum', 0.0210, 'lps'),
	(481065, 126, '2015-04-01 00:17:11.000000', 'consum', 0.0221, 'lps'),
	(481066, 126, '2015-04-01 00:17:12.000000', 'consum', 0.0212, 'lps'),
	(481067, 126, '2015-04-01 00:17:13.000000', 'consum', 0.0222, 'lps'),
	(481068, 126, '2015-04-01 00:17:14.000000', 'consum', 0.0212, 'lps'),
	(481069, 126, '2015-04-01 00:17:15.000000', 'consum', 0.0218, 'lps'),
	(481070, 126, '2015-04-01 00:17:16.000000', 'consum', 0.0211, 'lps'),
	(481071, 126, '2015-04-01 00:17:17.000000', 'consum', 0.0210, 'lps'),
	(481072, 126, '2015-04-01 00:17:18.000000', 'consum', 0.0223, 'lps'),
	(481073, 126, '2015-04-01 00:17:19.000000', 'consum', 0.0221, 'lps'),
	(481074, 126, '2015-04-01 00:17:20.000000', 'consum', 0.0226, 'lps'),
	(481075, 126, '2015-04-01 00:17:21.000000', 'consum', 0.0223, 'lps'),
	(481076, 126, '2015-04-01 00:17:22.000000', 'consum', 0.0210, 'lps'),
	(481077, 126, '2015-04-01 00:17:23.000000', 'consum', 0.0225, 'lps'),
	(481078, 126, '2015-04-01 00:17:24.000000', 'consum', 0.0215, 'lps'),
	(481079, 126, '2015-04-01 00:17:25.000000', 'consum', 0.0227, 'lps'),
	(481080, 126, '2015-04-01 00:17:26.000000', 'consum', 0.0226, 'lps'),
	(481081, 126, '2015-04-01 00:17:27.000000', 'consum', 0.0223, 'lps'),
	(481082, 126, '2015-04-01 00:17:28.000000', 'consum', 0.0226, 'lps'),
	(481083, 126, '2015-04-01 00:17:29.000000', 'consum', 0.0216, 'lps'),
	(481084, 126, '2015-04-01 00:17:30.000000', 'consum', 0.0227, 'lps'),
	(481085, 126, '2015-04-01 00:17:31.000000', 'consum', 0.0225, 'lps'),
	(481086, 126, '2015-04-01 00:17:32.000000', 'consum', 0.0217, 'lps'),
	(481087, 126, '2015-04-01 00:17:33.000000', 'consum', 0.0220, 'lps'),
	(481088, 126, '2015-04-01 00:17:34.000000', 'consum', 0.0219, 'lps'),
	(481089, 126, '2015-04-01 00:17:35.000000', 'consum', 0.0225, 'lps'),
	(481090, 126, '2015-04-01 00:17:36.000000', 'consum', 0.0222, 'lps'),
	(481091, 126, '2015-04-01 00:17:37.000000', 'consum', 0.0226, 'lps'),
	(481092, 126, '2015-04-01 00:17:38.000000', 'consum', 0.0219, 'lps'),
	(481093, 126, '2015-04-01 00:17:39.000000', 'consum', 0.0226, 'lps'),
	(481094, 126, '2015-04-01 00:17:40.000000', 'consum', 0.0211, 'lps'),
	(481095, 126, '2015-04-01 00:17:41.000000', 'consum', 0.0220, 'lps'),
	(481096, 126, '2015-04-01 00:17:42.000000', 'consum', 0.0223, 'lps'),
	(481097, 126, '2015-04-01 00:17:43.000000', 'consum', 0.0226, 'lps'),
	(481098, 126, '2015-04-01 00:17:44.000000', 'consum', 0.0216, 'lps'),
	(481099, 126, '2015-04-01 00:17:45.000000', 'consum', 0.0212, 'lps'),
	(481100, 126, '2015-04-01 00:17:46.000000', 'consum', 0.0221, 'lps'),
	(481101, 126, '2015-04-01 00:17:47.000000', 'consum', 0.0220, 'lps'),
	(481102, 126, '2015-04-01 00:17:48.000000', 'consum', 0.0212, 'lps'),
	(481103, 126, '2015-04-01 00:17:49.000000', 'consum', 0.0210, 'lps'),
	(481104, 126, '2015-04-01 00:17:50.000000', 'consum', 0.0220, 'lps'),
	(481105, 126, '2015-04-01 00:17:51.000000', 'consum', 0.0225, 'lps'),
	(481106, 126, '2015-04-01 00:17:52.000000', 'consum', 0.0221, 'lps'),
	(481107, 126, '2015-04-01 00:17:53.000000', 'consum', 0.0219, 'lps'),
	(481108, 126, '2015-04-01 00:17:54.000000', 'consum', 0.0225, 'lps'),
	(481109, 126, '2015-04-01 00:17:55.000000', 'consum', 0.0219, 'lps'),
	(481110, 126, '2015-04-01 00:17:56.000000', 'consum', 0.0213, 'lps'),
	(481111, 126, '2015-04-01 00:17:57.000000', 'consum', 0.0216, 'lps'),
	(481112, 126, '2015-04-01 00:17:58.000000', 'consum', 0.0213, 'lps'),
	(481113, 126, '2015-04-01 00:17:59.000000', 'consum', 0.0224, 'lps'),
	(481114, 126, '2015-04-01 00:18:00.000000', 'consum', 0.0217, 'lps'),
	(481115, 126, '2015-04-01 00:18:01.000000', 'consum', 0.0223, 'lps'),
	(481116, 126, '2015-04-01 00:18:02.000000', 'consum', 0.0218, 'lps'),
	(481117, 126, '2015-04-01 00:18:03.000000', 'consum', 0.0211, 'lps'),
	(481118, 126, '2015-04-01 00:18:04.000000', 'consum', 0.0211, 'lps'),
	(481119, 126, '2015-04-01 00:18:05.000000', 'consum', 0.0212, 'lps'),
	(481120, 126, '2015-04-01 00:18:06.000000', 'consum', 0.0218, 'lps'),
	(481121, 126, '2015-04-01 00:18:07.000000', 'consum', 0.0226, 'lps'),
	(481122, 126, '2015-04-01 00:18:08.000000', 'consum', 0.0213, 'lps'),
	(481123, 126, '2015-04-01 00:18:09.000000', 'consum', 0.0215, 'lps'),
	(481124, 126, '2015-04-01 00:18:10.000000', 'consum', 0.0226, 'lps'),
	(481125, 126, '2015-04-01 00:18:11.000000', 'consum', 0.0222, 'lps'),
	(481126, 126, '2015-04-01 00:18:12.000000', 'consum', 0.0223, 'lps'),
	(481127, 126, '2015-04-01 00:18:13.000000', 'consum', 0.0221, 'lps'),
	(481128, 126, '2015-04-01 00:18:14.000000', 'consum', 0.0210, 'lps'),
	(481129, 126, '2015-04-01 00:18:15.000000', 'consum', 0.0213, 'lps'),
	(481130, 126, '2015-04-01 00:18:16.000000', 'consum', 0.0225, 'lps'),
	(481131, 126, '2015-04-01 00:18:17.000000', 'consum', 0.0224, 'lps'),
	(481132, 126, '2015-04-01 00:18:18.000000', 'consum', 0.0218, 'lps'),
	(481133, 126, '2015-04-01 00:18:19.000000', 'consum', 0.0225, 'lps'),
	(481134, 126, '2015-04-01 00:18:20.000000', 'consum', 0.0210, 'lps'),
	(481135, 126, '2015-04-01 00:18:21.000000', 'consum', 0.0216, 'lps'),
	(481136, 126, '2015-04-01 00:18:22.000000', 'consum', 0.0225, 'lps'),
	(481137, 126, '2015-04-01 00:18:23.000000', 'consum', 0.0212, 'lps'),
	(481138, 126, '2015-04-01 00:18:24.000000', 'consum', 0.0211, 'lps'),
	(481139, 126, '2015-04-01 00:18:25.000000', 'consum', 0.0211, 'lps'),
	(481140, 126, '2015-04-01 00:18:26.000000', 'consum', 0.0210, 'lps'),
	(481141, 126, '2015-04-01 00:18:27.000000', 'consum', 0.0211, 'lps'),
	(481142, 126, '2015-04-01 00:18:28.000000', 'consum', 0.0212, 'lps'),
	(481143, 126, '2015-04-01 00:18:29.000000', 'consum', 0.0218, 'lps'),
	(481144, 126, '2015-04-01 00:18:30.000000', 'consum', 0.0211, 'lps'),
	(481145, 126, '2015-04-01 00:18:31.000000', 'consum', 0.0226, 'lps'),
	(481146, 126, '2015-04-01 00:18:32.000000', 'consum', 0.0215, 'lps'),
	(481147, 126, '2015-04-01 00:18:33.000000', 'consum', 0.0223, 'lps'),
	(481148, 126, '2015-04-01 00:18:34.000000', 'consum', 0.0225, 'lps'),
	(481149, 126, '2015-04-01 00:18:35.000000', 'consum', 0.0227, 'lps'),
	(481150, 126, '2015-04-01 00:18:36.000000', 'consum', 0.0215, 'lps'),
	(481151, 126, '2015-04-01 00:18:37.000000', 'consum', 0.0223, 'lps'),
	(481152, 126, '2015-04-01 00:18:38.000000', 'consum', 0.0223, 'lps'),
	(481153, 126, '2015-04-01 00:18:39.000000', 'consum', 0.0218, 'lps'),
	(481154, 126, '2015-04-01 00:18:40.000000', 'consum', 0.0210, 'lps'),
	(481155, 126, '2015-04-01 00:18:41.000000', 'consum', 0.0224, 'lps'),
	(481156, 126, '2015-04-01 00:18:42.000000', 'consum', 0.0227, 'lps'),
	(481157, 126, '2015-04-01 00:18:43.000000', 'consum', 0.0217, 'lps'),
	(481158, 126, '2015-04-01 00:18:44.000000', 'consum', 0.0213, 'lps'),
	(481159, 126, '2015-04-01 00:18:45.000000', 'consum', 0.0224, 'lps'),
	(481160, 126, '2015-04-01 00:18:46.000000', 'consum', 0.0215, 'lps'),
	(481161, 126, '2015-04-01 00:18:47.000000', 'consum', 0.0212, 'lps'),
	(481162, 126, '2015-04-01 00:18:48.000000', 'consum', 0.0223, 'lps'),
	(481163, 126, '2015-04-01 00:18:49.000000', 'consum', 0.0215, 'lps'),
	(481164, 126, '2015-04-01 00:18:50.000000', 'consum', 0.0214, 'lps'),
	(481165, 126, '2015-04-01 00:18:51.000000', 'consum', 0.0218, 'lps'),
	(481166, 126, '2015-04-01 00:18:52.000000', 'consum', 0.0221, 'lps'),
	(481167, 126, '2015-04-01 00:18:53.000000', 'consum', 0.0224, 'lps'),
	(481168, 126, '2015-04-01 00:18:54.000000', 'consum', 0.0227, 'lps'),
	(481169, 126, '2015-04-01 00:18:55.000000', 'consum', 0.0218, 'lps'),
	(481170, 126, '2015-04-01 00:18:56.000000', 'consum', 0.0218, 'lps'),
	(481171, 126, '2015-04-01 00:18:57.000000', 'consum', 0.0227, 'lps'),
	(481172, 126, '2015-04-01 00:18:58.000000', 'consum', 0.0216, 'lps'),
	(481173, 126, '2015-04-01 00:18:59.000000', 'consum', 0.0227, 'lps'),
	(481174, 126, '2015-04-01 00:19:00.000000', 'consum', 0.0221, 'lps'),
	(481175, 126, '2015-04-01 00:19:01.000000', 'consum', 0.0217, 'lps'),
	(481176, 126, '2015-04-01 00:19:02.000000', 'consum', 0.0213, 'lps'),
	(481177, 126, '2015-04-01 00:19:03.000000', 'consum', 0.0222, 'lps'),
	(481178, 126, '2015-04-01 00:19:04.000000', 'consum', 0.0225, 'lps'),
	(481179, 126, '2015-04-01 00:19:05.000000', 'consum', 0.0213, 'lps'),
	(481180, 126, '2015-04-01 00:19:06.000000', 'consum', 0.0216, 'lps'),
	(481181, 126, '2015-04-01 00:19:07.000000', 'consum', 0.0212, 'lps'),
	(481182, 126, '2015-04-01 00:19:08.000000', 'consum', 0.0222, 'lps'),
	(481183, 126, '2015-04-01 00:19:09.000000', 'consum', 0.0211, 'lps'),
	(481184, 126, '2015-04-01 00:19:10.000000', 'consum', 0.0216, 'lps'),
	(481185, 126, '2015-04-01 00:19:11.000000', 'consum', 0.0217, 'lps'),
	(481186, 126, '2015-04-01 00:19:12.000000', 'consum', 0.0210, 'lps'),
	(481187, 126, '2015-04-01 00:19:13.000000', 'consum', 0.0227, 'lps'),
	(481188, 126, '2015-04-01 00:19:14.000000', 'consum', 0.0222, 'lps'),
	(481189, 126, '2015-04-01 00:19:15.000000', 'consum', 0.0219, 'lps'),
	(481190, 126, '2015-04-01 00:19:16.000000', 'consum', 0.0221, 'lps'),
	(481191, 126, '2015-04-01 00:19:17.000000', 'consum', 0.0219, 'lps'),
	(481192, 126, '2015-04-01 00:19:18.000000', 'consum', 0.0224, 'lps'),
	(481193, 126, '2015-04-01 00:19:19.000000', 'consum', 0.0219, 'lps'),
	(481194, 126, '2015-04-01 00:19:20.000000', 'consum', 0.0211, 'lps'),
	(481195, 126, '2015-04-01 00:19:21.000000', 'consum', 0.0224, 'lps'),
	(481196, 126, '2015-04-01 00:19:22.000000', 'consum', 0.0225, 'lps'),
	(481197, 126, '2015-04-01 00:19:23.000000', 'consum', 0.0224, 'lps'),
	(481198, 126, '2015-04-01 00:19:24.000000', 'consum', 0.0217, 'lps'),
	(481199, 126, '2015-04-01 00:19:25.000000', 'consum', 0.0224, 'lps'),
	(481200, 126, '2015-04-01 00:19:26.000000', 'consum', 0.0222, 'lps'),
	(481201, 126, '2015-04-01 00:19:27.000000', 'consum', 0.0211, 'lps'),
	(481202, 126, '2015-04-01 00:19:28.000000', 'consum', 0.0217, 'lps'),
	(481203, 126, '2015-04-01 00:19:29.000000', 'consum', 0.0224, 'lps'),
	(481204, 126, '2015-04-01 00:19:30.000000', 'consum', 0.0222, 'lps'),
	(481205, 126, '2015-04-01 00:19:31.000000', 'consum', 0.0213, 'lps'),
	(481206, 126, '2015-04-01 00:19:32.000000', 'consum', 0.0223, 'lps'),
	(481207, 126, '2015-04-01 00:19:33.000000', 'consum', 0.0215, 'lps'),
	(481208, 126, '2015-04-01 00:19:34.000000', 'consum', 0.0213, 'lps'),
	(481209, 126, '2015-04-01 00:19:35.000000', 'consum', 0.0227, 'lps'),
	(481210, 126, '2015-04-01 00:19:36.000000', 'consum', 0.0216, 'lps'),
	(481211, 126, '2015-04-01 00:19:37.000000', 'consum', 0.0225, 'lps'),
	(481212, 126, '2015-04-01 00:19:38.000000', 'consum', 0.0214, 'lps'),
	(481213, 126, '2015-04-01 00:19:39.000000', 'consum', 0.0222, 'lps'),
	(481214, 126, '2015-04-01 00:19:40.000000', 'consum', 0.0223, 'lps'),
	(481215, 126, '2015-04-01 00:19:41.000000', 'consum', 0.0220, 'lps'),
	(481216, 126, '2015-04-01 00:19:42.000000', 'consum', 0.0223, 'lps'),
	(481217, 126, '2015-04-01 00:19:43.000000', 'consum', 0.0226, 'lps'),
	(481218, 126, '2015-04-01 00:19:44.000000', 'consum', 0.0215, 'lps'),
	(481219, 126, '2015-04-01 00:19:45.000000', 'consum', 0.0225, 'lps'),
	(481220, 126, '2015-04-01 00:19:46.000000', 'consum', 0.0217, 'lps'),
	(481221, 126, '2015-04-01 00:19:47.000000', 'consum', 0.0219, 'lps'),
	(481222, 126, '2015-04-01 00:19:48.000000', 'consum', 0.0214, 'lps'),
	(481223, 126, '2015-04-01 00:19:49.000000', 'consum', 0.0221, 'lps'),
	(481224, 126, '2015-04-01 00:19:50.000000', 'consum', 0.0217, 'lps'),
	(481225, 126, '2015-04-01 00:19:51.000000', 'consum', 0.0212, 'lps'),
	(481226, 126, '2015-04-01 00:19:52.000000', 'consum', 0.0221, 'lps'),
	(481227, 126, '2015-04-01 00:19:53.000000', 'consum', 0.0220, 'lps'),
	(481228, 126, '2015-04-01 00:19:54.000000', 'consum', 0.0210, 'lps'),
	(481229, 126, '2015-04-01 00:19:55.000000', 'consum', 0.0216, 'lps'),
	(481230, 126, '2015-04-01 00:19:56.000000', 'consum', 0.0221, 'lps'),
	(481231, 126, '2015-04-01 00:19:57.000000', 'consum', 0.0214, 'lps'),
	(481232, 126, '2015-04-01 00:19:58.000000', 'consum', 0.0213, 'lps'),
	(481233, 126, '2015-04-01 00:19:59.000000', 'consum', 0.0216, 'lps'),
	(481234, 126, '2015-04-01 00:20:00.000000', 'consum', 0.0212, 'lps'),
	(481235, 126, '2015-04-01 00:20:01.000000', 'consum', 0.0220, 'lps'),
	(481236, 126, '2015-04-01 00:20:02.000000', 'consum', 0.0221, 'lps'),
	(481237, 126, '2015-04-01 00:20:03.000000', 'consum', 0.0214, 'lps'),
	(481238, 126, '2015-04-01 00:20:04.000000', 'consum', 0.0218, 'lps'),
	(481239, 126, '2015-04-01 00:20:05.000000', 'consum', 0.0220, 'lps'),
	(481240, 126, '2015-04-01 00:20:06.000000', 'consum', 0.0218, 'lps'),
	(481241, 126, '2015-04-01 00:20:07.000000', 'consum', 0.0220, 'lps'),
	(481242, 126, '2015-04-01 00:20:08.000000', 'consum', 0.0219, 'lps'),
	(481243, 126, '2015-04-01 00:20:09.000000', 'consum', 0.0225, 'lps'),
	(481244, 126, '2015-04-01 00:20:10.000000', 'consum', 0.0221, 'lps'),
	(481245, 126, '2015-04-01 00:20:11.000000', 'consum', 0.0223, 'lps'),
	(481246, 126, '2015-04-01 00:20:12.000000', 'consum', 0.0222, 'lps'),
	(481247, 126, '2015-04-01 00:20:13.000000', 'consum', 0.0213, 'lps'),
	(481248, 126, '2015-04-01 00:20:14.000000', 'consum', 0.0225, 'lps'),
	(481249, 126, '2015-04-01 00:20:15.000000', 'consum', 0.0225, 'lps'),
	(481250, 126, '2015-04-01 00:20:16.000000', 'consum', 0.0222, 'lps'),
	(481251, 126, '2015-04-01 00:20:17.000000', 'consum', 0.0227, 'lps'),
	(481252, 126, '2015-04-01 00:20:18.000000', 'consum', 0.0221, 'lps'),
	(481253, 126, '2015-04-01 00:20:19.000000', 'consum', 0.0215, 'lps'),
	(481254, 126, '2015-04-01 00:20:20.000000', 'consum', 0.0221, 'lps'),
	(481255, 126, '2015-04-01 00:20:21.000000', 'consum', 0.0213, 'lps'),
	(481256, 126, '2015-04-01 00:20:22.000000', 'consum', 0.0212, 'lps'),
	(481257, 126, '2015-04-01 00:20:23.000000', 'consum', 0.0210, 'lps'),
	(481258, 126, '2015-04-01 00:20:24.000000', 'consum', 0.0224, 'lps'),
	(481259, 126, '2015-04-01 00:20:25.000000', 'consum', 0.0226, 'lps'),
	(481260, 126, '2015-04-01 00:20:26.000000', 'consum', 0.0212, 'lps'),
	(481261, 126, '2015-04-01 00:20:27.000000', 'consum', 0.0227, 'lps'),
	(481262, 126, '2015-04-01 00:20:28.000000', 'consum', 0.0217, 'lps'),
	(481263, 126, '2015-04-01 00:20:29.000000', 'consum', 0.0213, 'lps'),
	(481264, 126, '2015-04-01 00:20:30.000000', 'consum', 0.0224, 'lps'),
	(481265, 126, '2015-04-01 00:20:31.000000', 'consum', 0.0216, 'lps'),
	(481266, 126, '2015-04-01 00:20:32.000000', 'consum', 0.0216, 'lps'),
	(481267, 126, '2015-04-01 00:20:33.000000', 'consum', 0.0222, 'lps'),
	(481268, 126, '2015-04-01 00:20:34.000000', 'consum', 0.0218, 'lps'),
	(481269, 126, '2015-04-01 00:20:35.000000', 'consum', 0.0214, 'lps'),
	(481270, 126, '2015-04-01 00:20:36.000000', 'consum', 0.0226, 'lps'),
	(481271, 126, '2015-04-01 00:20:37.000000', 'consum', 0.0223, 'lps'),
	(481272, 126, '2015-04-01 00:20:38.000000', 'consum', 0.0210, 'lps'),
	(481273, 126, '2015-04-01 00:20:39.000000', 'consum', 0.0227, 'lps'),
	(481274, 126, '2015-04-01 00:20:40.000000', 'consum', 0.0221, 'lps'),
	(481275, 126, '2015-04-01 00:20:41.000000', 'consum', 0.0214, 'lps'),
	(481276, 126, '2015-04-01 00:20:42.000000', 'consum', 0.0218, 'lps'),
	(481277, 126, '2015-04-01 00:20:43.000000', 'consum', 0.0219, 'lps'),
	(481278, 126, '2015-04-01 00:20:44.000000', 'consum', 0.0213, 'lps'),
	(481279, 126, '2015-04-01 00:20:45.000000', 'consum', 0.0216, 'lps'),
	(481280, 126, '2015-04-01 00:20:46.000000', 'consum', 0.0215, 'lps'),
	(481281, 126, '2015-04-01 00:20:47.000000', 'consum', 0.0217, 'lps'),
	(481282, 126, '2015-04-01 00:20:48.000000', 'consum', 0.0212, 'lps'),
	(481283, 126, '2015-04-01 00:20:49.000000', 'consum', 0.0219, 'lps'),
	(481284, 126, '2015-04-01 00:20:50.000000', 'consum', 0.0213, 'lps'),
	(481285, 126, '2015-04-01 00:20:51.000000', 'consum', 0.0218, 'lps'),
	(481286, 126, '2015-04-01 00:20:52.000000', 'consum', 0.0223, 'lps'),
	(481287, 126, '2015-04-01 00:20:53.000000', 'consum', 0.0215, 'lps'),
	(481288, 126, '2015-04-01 00:20:54.000000', 'consum', 0.0216, 'lps'),
	(481289, 126, '2015-04-01 00:20:55.000000', 'consum', 0.0226, 'lps'),
	(481290, 126, '2015-04-01 00:20:56.000000', 'consum', 0.0216, 'lps'),
	(481291, 126, '2015-04-01 00:20:57.000000', 'consum', 0.0213, 'lps'),
	(481292, 126, '2015-04-01 00:20:58.000000', 'consum', 0.0225, 'lps'),
	(481293, 126, '2015-04-01 00:20:59.000000', 'consum', 0.0221, 'lps'),
	(481294, 126, '2015-04-01 00:21:00.000000', 'consum', 0.0223, 'lps'),
	(481295, 126, '2015-04-01 00:21:01.000000', 'consum', 0.0223, 'lps'),
	(481296, 126, '2015-04-01 00:21:02.000000', 'consum', 0.0220, 'lps'),
	(481297, 126, '2015-04-01 00:21:03.000000', 'consum', 0.0219, 'lps'),
	(481298, 126, '2015-04-01 00:21:04.000000', 'consum', 0.0210, 'lps'),
	(481299, 126, '2015-04-01 00:21:05.000000', 'consum', 0.0217, 'lps'),
	(481300, 126, '2015-04-01 00:21:06.000000', 'consum', 0.0211, 'lps'),
	(481301, 126, '2015-04-01 00:21:07.000000', 'consum', 0.0212, 'lps'),
	(481302, 126, '2015-04-01 00:21:08.000000', 'consum', 0.0220, 'lps'),
	(481303, 126, '2015-04-01 00:21:09.000000', 'consum', 0.0215, 'lps'),
	(481304, 126, '2015-04-01 00:21:10.000000', 'consum', 0.0227, 'lps'),
	(481305, 126, '2015-04-01 00:21:11.000000', 'consum', 0.0223, 'lps'),
	(481306, 126, '2015-04-01 00:21:12.000000', 'consum', 0.0226, 'lps'),
	(481307, 126, '2015-04-01 00:21:13.000000', 'consum', 0.0217, 'lps'),
	(481308, 126, '2015-04-01 00:21:14.000000', 'consum', 0.0215, 'lps'),
	(481309, 126, '2015-04-01 00:21:15.000000', 'consum', 0.0212, 'lps'),
	(481310, 126, '2015-04-01 00:21:16.000000', 'consum', 0.0226, 'lps'),
	(481311, 126, '2015-04-01 00:21:17.000000', 'consum', 0.0211, 'lps'),
	(481312, 126, '2015-04-01 00:21:18.000000', 'consum', 0.0224, 'lps'),
	(481313, 126, '2015-04-01 00:21:19.000000', 'consum', 0.0223, 'lps'),
	(481314, 126, '2015-04-01 00:21:20.000000', 'consum', 0.0214, 'lps'),
	(481315, 126, '2015-04-01 00:21:21.000000', 'consum', 0.0212, 'lps'),
	(481316, 126, '2015-04-01 00:21:22.000000', 'consum', 0.0225, 'lps'),
	(481317, 126, '2015-04-01 00:21:23.000000', 'consum', 0.0210, 'lps'),
	(481318, 126, '2015-04-01 00:21:24.000000', 'consum', 0.0216, 'lps'),
	(481319, 126, '2015-04-01 00:21:25.000000', 'consum', 0.0224, 'lps'),
	(481320, 126, '2015-04-01 00:21:26.000000', 'consum', 0.0227, 'lps'),
	(481321, 126, '2015-04-01 00:21:27.000000', 'consum', 0.0218, 'lps'),
	(481322, 126, '2015-04-01 00:21:28.000000', 'consum', 0.0215, 'lps'),
	(481323, 126, '2015-04-01 00:21:29.000000', 'consum', 0.0212, 'lps'),
	(481324, 126, '2015-04-01 00:21:30.000000', 'consum', 0.0222, 'lps'),
	(481325, 126, '2015-04-01 00:21:31.000000', 'consum', 0.0212, 'lps'),
	(481326, 126, '2015-04-01 00:21:32.000000', 'consum', 0.0219, 'lps'),
	(481327, 126, '2015-04-01 00:21:33.000000', 'consum', 0.0214, 'lps'),
	(481328, 126, '2015-04-01 00:21:34.000000', 'consum', 0.0222, 'lps'),
	(481329, 126, '2015-04-01 00:21:35.000000', 'consum', 0.0222, 'lps'),
	(481330, 126, '2015-04-01 00:21:36.000000', 'consum', 0.0216, 'lps'),
	(481331, 126, '2015-04-01 00:21:37.000000', 'consum', 0.0225, 'lps'),
	(481332, 126, '2015-04-01 00:21:38.000000', 'consum', 0.0211, 'lps'),
	(481333, 126, '2015-04-01 00:21:39.000000', 'consum', 0.0227, 'lps'),
	(481334, 126, '2015-04-01 00:21:40.000000', 'consum', 0.0219, 'lps'),
	(481335, 126, '2015-04-01 00:21:41.000000', 'consum', 0.0222, 'lps'),
	(481336, 126, '2015-04-01 00:21:42.000000', 'consum', 0.0226, 'lps'),
	(481337, 126, '2015-04-01 00:21:43.000000', 'consum', 0.0218, 'lps'),
	(481338, 126, '2015-04-01 00:21:44.000000', 'consum', 0.0221, 'lps'),
	(481339, 126, '2015-04-01 00:21:45.000000', 'consum', 0.0222, 'lps'),
	(481340, 126, '2015-04-01 00:21:46.000000', 'consum', 0.0222, 'lps'),
	(481341, 126, '2015-04-01 00:21:47.000000', 'consum', 0.0215, 'lps'),
	(481342, 126, '2015-04-01 00:21:48.000000', 'consum', 0.0216, 'lps'),
	(481343, 126, '2015-04-01 00:21:49.000000', 'consum', 0.0227, 'lps'),
	(481344, 126, '2015-04-01 00:21:50.000000', 'consum', 0.0223, 'lps'),
	(481345, 126, '2015-04-01 00:21:51.000000', 'consum', 0.0225, 'lps'),
	(481346, 126, '2015-04-01 00:21:52.000000', 'consum', 0.0211, 'lps'),
	(481347, 126, '2015-04-01 00:21:53.000000', 'consum', 0.0224, 'lps'),
	(481348, 126, '2015-04-01 00:21:54.000000', 'consum', 0.0225, 'lps'),
	(481349, 126, '2015-04-01 00:21:55.000000', 'consum', 0.0224, 'lps'),
	(481350, 126, '2015-04-01 00:21:56.000000', 'consum', 0.0216, 'lps'),
	(481351, 126, '2015-04-01 00:21:57.000000', 'consum', 0.0220, 'lps'),
	(481352, 126, '2015-04-01 00:21:58.000000', 'consum', 0.0221, 'lps'),
	(481353, 126, '2015-04-01 00:21:59.000000', 'consum', 0.0221, 'lps'),
	(481354, 126, '2015-04-01 00:22:00.000000', 'consum', 0.0212, 'lps'),
	(481355, 126, '2015-04-01 00:22:01.000000', 'consum', 0.0223, 'lps'),
	(481356, 126, '2015-04-01 00:22:02.000000', 'consum', 0.0216, 'lps'),
	(481357, 126, '2015-04-01 00:22:03.000000', 'consum', 0.0221, 'lps'),
	(481358, 126, '2015-04-01 00:22:04.000000', 'consum', 0.0227, 'lps'),
	(481359, 126, '2015-04-01 00:22:05.000000', 'consum', 0.0227, 'lps'),
	(481360, 126, '2015-04-01 00:22:06.000000', 'consum', 0.0225, 'lps'),
	(481361, 126, '2015-04-01 00:22:07.000000', 'consum', 0.0218, 'lps'),
	(481362, 126, '2015-04-01 00:22:08.000000', 'consum', 0.0223, 'lps'),
	(481363, 126, '2015-04-01 00:22:09.000000', 'consum', 0.0218, 'lps'),
	(481364, 126, '2015-04-01 00:22:10.000000', 'consum', 0.0210, 'lps'),
	(481365, 126, '2015-04-01 00:22:11.000000', 'consum', 0.0221, 'lps'),
	(481366, 126, '2015-04-01 00:22:12.000000', 'consum', 0.0212, 'lps'),
	(481367, 126, '2015-04-01 00:22:13.000000', 'consum', 0.0224, 'lps'),
	(481368, 126, '2015-04-01 00:22:14.000000', 'consum', 0.0220, 'lps'),
	(481369, 126, '2015-04-01 00:22:15.000000', 'consum', 0.0217, 'lps'),
	(481370, 126, '2015-04-01 00:22:16.000000', 'consum', 0.0217, 'lps'),
	(481371, 126, '2015-04-01 00:22:17.000000', 'consum', 0.0222, 'lps'),
	(481372, 126, '2015-04-01 00:22:18.000000', 'consum', 0.0216, 'lps'),
	(481373, 126, '2015-04-01 00:22:19.000000', 'consum', 0.0223, 'lps'),
	(481374, 126, '2015-04-01 00:22:20.000000', 'consum', 0.0219, 'lps'),
	(481375, 126, '2015-04-01 00:22:21.000000', 'consum', 0.0216, 'lps'),
	(481376, 126, '2015-04-01 00:22:22.000000', 'consum', 0.0215, 'lps'),
	(481377, 126, '2015-04-01 00:22:23.000000', 'consum', 0.0216, 'lps'),
	(481378, 126, '2015-04-01 00:22:24.000000', 'consum', 0.0225, 'lps'),
	(481379, 126, '2015-04-01 00:22:25.000000', 'consum', 0.0215, 'lps'),
	(481380, 126, '2015-04-01 00:22:26.000000', 'consum', 0.0227, 'lps'),
	(481381, 126, '2015-04-01 00:22:27.000000', 'consum', 0.0226, 'lps'),
	(481382, 126, '2015-04-01 00:22:28.000000', 'consum', 0.0222, 'lps'),
	(481383, 126, '2015-04-01 00:22:29.000000', 'consum', 0.0222, 'lps'),
	(481384, 126, '2015-04-01 00:22:30.000000', 'consum', 0.0216, 'lps'),
	(481385, 126, '2015-04-01 00:22:31.000000', 'consum', 0.0222, 'lps'),
	(481386, 126, '2015-04-01 00:22:32.000000', 'consum', 0.0219, 'lps'),
	(481387, 126, '2015-04-01 00:22:33.000000', 'consum', 0.0219, 'lps'),
	(481388, 126, '2015-04-01 00:22:34.000000', 'consum', 0.0227, 'lps'),
	(481389, 126, '2015-04-01 00:22:35.000000', 'consum', 0.0214, 'lps'),
	(481390, 126, '2015-04-01 00:22:36.000000', 'consum', 0.0217, 'lps'),
	(481391, 126, '2015-04-01 00:22:37.000000', 'consum', 0.0213, 'lps'),
	(481392, 126, '2015-04-01 00:22:38.000000', 'consum', 0.0225, 'lps'),
	(481393, 126, '2015-04-01 00:22:39.000000', 'consum', 0.0224, 'lps'),
	(481394, 126, '2015-04-01 00:22:40.000000', 'consum', 0.0214, 'lps'),
	(481395, 126, '2015-04-01 00:22:41.000000', 'consum', 0.0226, 'lps'),
	(481396, 126, '2015-04-01 00:22:42.000000', 'consum', 0.0225, 'lps'),
	(481397, 126, '2015-04-01 00:22:43.000000', 'consum', 0.0220, 'lps'),
	(481398, 126, '2015-04-01 00:22:44.000000', 'consum', 0.0215, 'lps'),
	(481399, 126, '2015-04-01 00:22:45.000000', 'consum', 0.0224, 'lps'),
	(481400, 126, '2015-04-01 00:22:46.000000', 'consum', 0.0211, 'lps'),
	(481401, 126, '2015-04-01 00:22:47.000000', 'consum', 0.0211, 'lps'),
	(481402, 126, '2015-04-01 00:22:48.000000', 'consum', 0.0211, 'lps'),
	(481403, 126, '2015-04-01 00:22:49.000000', 'consum', 0.0211, 'lps'),
	(481404, 126, '2015-04-01 00:22:50.000000', 'consum', 0.0216, 'lps'),
	(481405, 126, '2015-04-01 00:22:51.000000', 'consum', 0.0217, 'lps'),
	(481406, 126, '2015-04-01 00:22:52.000000', 'consum', 0.0212, 'lps'),
	(481407, 126, '2015-04-01 00:22:53.000000', 'consum', 0.0215, 'lps'),
	(481408, 126, '2015-04-01 00:22:54.000000', 'consum', 0.0211, 'lps'),
	(481409, 126, '2015-04-01 00:22:55.000000', 'consum', 0.0218, 'lps'),
	(481410, 126, '2015-04-01 00:22:56.000000', 'consum', 0.0213, 'lps'),
	(481411, 126, '2015-04-01 00:22:57.000000', 'consum', 0.0217, 'lps'),
	(481412, 126, '2015-04-01 00:22:58.000000', 'consum', 0.0222, 'lps'),
	(481413, 126, '2015-04-01 00:22:59.000000', 'consum', 0.0211, 'lps'),
	(481414, 126, '2015-04-01 00:23:00.000000', 'consum', 0.0217, 'lps'),
	(481415, 126, '2015-04-01 00:23:01.000000', 'consum', 0.0225, 'lps'),
	(481416, 126, '2015-04-01 00:23:02.000000', 'consum', 0.0210, 'lps'),
	(481417, 126, '2015-04-01 00:23:03.000000', 'consum', 0.0219, 'lps'),
	(481418, 126, '2015-04-01 00:23:04.000000', 'consum', 0.0218, 'lps'),
	(481419, 126, '2015-04-01 00:23:05.000000', 'consum', 0.0225, 'lps'),
	(481420, 126, '2015-04-01 00:23:06.000000', 'consum', 0.0227, 'lps'),
	(481421, 126, '2015-04-01 00:23:07.000000', 'consum', 0.0212, 'lps'),
	(481422, 126, '2015-04-01 00:23:08.000000', 'consum', 0.0225, 'lps'),
	(481423, 126, '2015-04-01 00:23:09.000000', 'consum', 0.0225, 'lps'),
	(481424, 126, '2015-04-01 00:23:10.000000', 'consum', 0.0223, 'lps'),
	(481425, 126, '2015-04-01 00:23:11.000000', 'consum', 0.0211, 'lps'),
	(481426, 126, '2015-04-01 00:23:12.000000', 'consum', 0.0214, 'lps'),
	(481427, 126, '2015-04-01 00:23:13.000000', 'consum', 0.0226, 'lps'),
	(481428, 126, '2015-04-01 00:23:14.000000', 'consum', 0.0223, 'lps'),
	(481429, 126, '2015-04-01 00:23:15.000000', 'consum', 0.0213, 'lps'),
	(481430, 126, '2015-04-01 00:23:16.000000', 'consum', 0.0220, 'lps'),
	(481431, 126, '2015-04-01 00:23:17.000000', 'consum', 0.0218, 'lps'),
	(481432, 126, '2015-04-01 00:23:18.000000', 'consum', 0.0221, 'lps'),
	(481433, 126, '2015-04-01 00:23:19.000000', 'consum', 0.0220, 'lps'),
	(481434, 126, '2015-04-01 00:23:20.000000', 'consum', 0.0213, 'lps'),
	(481435, 126, '2015-04-01 00:23:21.000000', 'consum', 0.0211, 'lps'),
	(481436, 126, '2015-04-01 00:23:22.000000', 'consum', 0.0227, 'lps'),
	(481437, 126, '2015-04-01 00:23:23.000000', 'consum', 0.0221, 'lps'),
	(481438, 126, '2015-04-01 00:23:24.000000', 'consum', 0.0213, 'lps'),
	(481439, 126, '2015-04-01 00:23:25.000000', 'consum', 0.0211, 'lps'),
	(481440, 126, '2015-04-01 00:23:26.000000', 'consum', 0.0223, 'lps'),
	(481441, 126, '2015-04-01 00:23:27.000000', 'consum', 0.0220, 'lps'),
	(481442, 126, '2015-04-01 00:23:28.000000', 'consum', 0.0220, 'lps'),
	(481443, 126, '2015-04-01 00:23:29.000000', 'consum', 0.0214, 'lps'),
	(481444, 126, '2015-04-01 00:23:30.000000', 'consum', 0.0217, 'lps'),
	(481445, 126, '2015-04-01 00:23:31.000000', 'consum', 0.0218, 'lps'),
	(481446, 126, '2015-04-01 00:23:32.000000', 'consum', 0.0211, 'lps'),
	(481447, 126, '2015-04-01 00:23:33.000000', 'consum', 0.0227, 'lps'),
	(481448, 126, '2015-04-01 00:23:34.000000', 'consum', 0.0220, 'lps'),
	(481449, 126, '2015-04-01 00:23:35.000000', 'consum', 0.0227, 'lps'),
	(481450, 126, '2015-04-01 00:23:36.000000', 'consum', 0.0210, 'lps'),
	(481451, 126, '2015-04-01 00:23:37.000000', 'consum', 0.0217, 'lps'),
	(481452, 126, '2015-04-01 00:23:38.000000', 'consum', 0.0225, 'lps'),
	(481453, 126, '2015-04-01 00:23:39.000000', 'consum', 0.0212, 'lps'),
	(481454, 126, '2015-04-01 00:23:40.000000', 'consum', 0.0212, 'lps'),
	(481455, 126, '2015-04-01 00:23:41.000000', 'consum', 0.0215, 'lps'),
	(481456, 126, '2015-04-01 00:23:42.000000', 'consum', 0.0211, 'lps'),
	(481457, 126, '2015-04-01 00:23:43.000000', 'consum', 0.0218, 'lps'),
	(481458, 126, '2015-04-01 00:23:44.000000', 'consum', 0.0212, 'lps'),
	(481459, 126, '2015-04-01 00:23:45.000000', 'consum', 0.0213, 'lps'),
	(481460, 126, '2015-04-01 00:23:46.000000', 'consum', 0.0221, 'lps'),
	(481461, 126, '2015-04-01 00:23:47.000000', 'consum', 0.0219, 'lps'),
	(481462, 126, '2015-04-01 00:23:48.000000', 'consum', 0.0222, 'lps'),
	(481463, 126, '2015-04-01 00:23:49.000000', 'consum', 0.0224, 'lps'),
	(481464, 126, '2015-04-01 00:23:50.000000', 'consum', 0.0212, 'lps'),
	(481465, 126, '2015-04-01 00:23:51.000000', 'consum', 0.0211, 'lps'),
	(481466, 126, '2015-04-01 00:23:52.000000', 'consum', 0.0212, 'lps'),
	(481467, 126, '2015-04-01 00:23:53.000000', 'consum', 0.0215, 'lps'),
	(481468, 126, '2015-04-01 00:23:54.000000', 'consum', 0.0214, 'lps'),
	(481469, 126, '2015-04-01 00:23:55.000000', 'consum', 0.0213, 'lps'),
	(481470, 126, '2015-04-01 00:23:56.000000', 'consum', 0.0216, 'lps'),
	(481471, 126, '2015-04-01 00:23:57.000000', 'consum', 0.0212, 'lps'),
	(481472, 126, '2015-04-01 00:23:58.000000', 'consum', 0.0222, 'lps'),
	(481473, 126, '2015-04-01 00:23:59.000000', 'consum', 0.0211, 'lps'),
	(481474, 126, '2015-04-01 00:24:00.000000', 'consum', 0.0213, 'lps'),
	(481475, 126, '2015-04-01 00:24:01.000000', 'consum', 0.0225, 'lps'),
	(481476, 126, '2015-04-01 00:24:02.000000', 'consum', 0.0221, 'lps'),
	(481477, 126, '2015-04-01 00:24:03.000000', 'consum', 0.0222, 'lps'),
	(481478, 126, '2015-04-01 00:24:04.000000', 'consum', 0.0219, 'lps'),
	(481479, 126, '2015-04-01 00:24:05.000000', 'consum', 0.0219, 'lps'),
	(481480, 126, '2015-04-01 00:24:06.000000', 'consum', 0.0212, 'lps'),
	(481481, 126, '2015-04-01 00:24:07.000000', 'consum', 0.0213, 'lps'),
	(481482, 126, '2015-04-01 00:24:08.000000', 'consum', 0.0217, 'lps'),
	(481483, 126, '2015-04-01 00:24:09.000000', 'consum', 0.0217, 'lps'),
	(481484, 126, '2015-04-01 00:24:10.000000', 'consum', 0.0210, 'lps'),
	(481485, 126, '2015-04-01 00:24:11.000000', 'consum', 0.0222, 'lps'),
	(481486, 126, '2015-04-01 00:24:12.000000', 'consum', 0.0219, 'lps'),
	(481487, 126, '2015-04-01 00:24:13.000000', 'consum', 0.0218, 'lps'),
	(481488, 126, '2015-04-01 00:24:14.000000', 'consum', 0.0224, 'lps'),
	(481489, 126, '2015-04-01 00:24:15.000000', 'consum', 0.0220, 'lps'),
	(481490, 126, '2015-04-01 00:24:16.000000', 'consum', 0.0219, 'lps'),
	(481491, 126, '2015-04-01 00:24:17.000000', 'consum', 0.0224, 'lps'),
	(481492, 126, '2015-04-01 00:24:18.000000', 'consum', 0.0219, 'lps'),
	(481493, 126, '2015-04-01 00:24:19.000000', 'consum', 0.0211, 'lps'),
	(481494, 126, '2015-04-01 00:24:20.000000', 'consum', 0.0227, 'lps'),
	(481495, 126, '2015-04-01 00:24:21.000000', 'consum', 0.0218, 'lps'),
	(481496, 126, '2015-04-01 00:24:22.000000', 'consum', 0.0218, 'lps'),
	(481497, 126, '2015-04-01 00:24:23.000000', 'consum', 0.0225, 'lps'),
	(481498, 126, '2015-04-01 00:24:24.000000', 'consum', 0.0211, 'lps'),
	(481499, 126, '2015-04-01 00:24:25.000000', 'consum', 0.0223, 'lps'),
	(481500, 126, '2015-04-01 00:24:26.000000', 'consum', 0.0218, 'lps'),
	(481501, 126, '2015-04-01 00:24:27.000000', 'consum', 0.0211, 'lps'),
	(481502, 126, '2015-04-01 00:24:28.000000', 'consum', 0.0227, 'lps'),
	(481503, 126, '2015-04-01 00:24:29.000000', 'consum', 0.0220, 'lps'),
	(481504, 126, '2015-04-01 00:24:30.000000', 'consum', 0.0212, 'lps'),
	(481505, 126, '2015-04-01 00:24:31.000000', 'consum', 0.0227, 'lps'),
	(481506, 126, '2015-04-01 00:24:32.000000', 'consum', 0.0217, 'lps'),
	(481507, 126, '2015-04-01 00:24:33.000000', 'consum', 0.0210, 'lps'),
	(481508, 126, '2015-04-01 00:24:34.000000', 'consum', 0.0210, 'lps'),
	(481509, 126, '2015-04-01 00:24:35.000000', 'consum', 0.0226, 'lps'),
	(481510, 126, '2015-04-01 00:24:36.000000', 'consum', 0.0219, 'lps'),
	(481511, 126, '2015-04-01 00:24:37.000000', 'consum', 0.0210, 'lps'),
	(481512, 126, '2015-04-01 00:24:38.000000', 'consum', 0.0218, 'lps'),
	(481513, 126, '2015-04-01 00:24:39.000000', 'consum', 0.0214, 'lps'),
	(481514, 126, '2015-04-01 00:24:40.000000', 'consum', 0.0223, 'lps'),
	(481515, 126, '2015-04-01 00:24:41.000000', 'consum', 0.0212, 'lps'),
	(481516, 126, '2015-04-01 00:24:42.000000', 'consum', 0.0215, 'lps'),
	(481517, 126, '2015-04-01 00:24:43.000000', 'consum', 0.0214, 'lps'),
	(481518, 126, '2015-04-01 00:24:44.000000', 'consum', 0.0217, 'lps'),
	(481519, 126, '2015-04-01 00:24:45.000000', 'consum', 0.0212, 'lps'),
	(481520, 126, '2015-04-01 00:24:46.000000', 'consum', 0.0220, 'lps'),
	(481521, 126, '2015-04-01 00:24:47.000000', 'consum', 0.0220, 'lps'),
	(481522, 126, '2015-04-01 00:24:48.000000', 'consum', 0.0227, 'lps'),
	(481523, 126, '2015-04-01 00:24:49.000000', 'consum', 0.0212, 'lps'),
	(481524, 126, '2015-04-01 00:24:50.000000', 'consum', 0.0226, 'lps'),
	(481525, 126, '2015-04-01 00:24:51.000000', 'consum', 0.0227, 'lps'),
	(481526, 126, '2015-04-01 00:24:52.000000', 'consum', 0.0213, 'lps'),
	(481527, 126, '2015-04-01 00:24:53.000000', 'consum', 0.0213, 'lps'),
	(481528, 126, '2015-04-01 00:24:54.000000', 'consum', 0.0213, 'lps'),
	(481529, 126, '2015-04-01 00:24:55.000000', 'consum', 0.0218, 'lps'),
	(481530, 126, '2015-04-01 00:24:56.000000', 'consum', 0.0223, 'lps'),
	(481531, 126, '2015-04-01 00:24:57.000000', 'consum', 0.0217, 'lps'),
	(481532, 126, '2015-04-01 00:24:58.000000', 'consum', 0.0222, 'lps'),
	(481533, 126, '2015-04-01 00:24:59.000000', 'consum', 0.0215, 'lps'),
	(481534, 126, '2015-04-01 00:25:00.000000', 'consum', 0.0216, 'lps'),
	(481535, 126, '2015-04-01 00:25:01.000000', 'consum', 0.0226, 'lps'),
	(481536, 126, '2015-04-01 00:25:02.000000', 'consum', 0.0217, 'lps'),
	(481537, 126, '2015-04-01 00:25:03.000000', 'consum', 0.0217, 'lps'),
	(481538, 126, '2015-04-01 00:25:04.000000', 'consum', 0.0223, 'lps'),
	(481539, 126, '2015-04-01 00:25:05.000000', 'consum', 0.0221, 'lps'),
	(481540, 126, '2015-04-01 00:25:06.000000', 'consum', 0.0227, 'lps'),
	(481541, 126, '2015-04-01 00:25:07.000000', 'consum', 0.0227, 'lps'),
	(481542, 126, '2015-04-01 00:25:08.000000', 'consum', 0.0224, 'lps'),
	(481543, 126, '2015-04-01 00:25:09.000000', 'consum', 0.0214, 'lps'),
	(481544, 126, '2015-04-01 00:25:10.000000', 'consum', 0.0222, 'lps'),
	(481545, 126, '2015-04-01 00:25:11.000000', 'consum', 0.0224, 'lps'),
	(481546, 126, '2015-04-01 00:25:12.000000', 'consum', 0.0226, 'lps'),
	(481547, 126, '2015-04-01 00:25:13.000000', 'consum', 0.0214, 'lps'),
	(481548, 126, '2015-04-01 00:25:14.000000', 'consum', 0.0217, 'lps'),
	(481549, 126, '2015-04-01 00:25:15.000000', 'consum', 0.0215, 'lps'),
	(481550, 126, '2015-04-01 00:25:16.000000', 'consum', 0.0214, 'lps'),
	(481551, 126, '2015-04-01 00:25:17.000000', 'consum', 0.0218, 'lps'),
	(481552, 126, '2015-04-01 00:25:18.000000', 'consum', 0.0217, 'lps'),
	(481553, 126, '2015-04-01 00:25:19.000000', 'consum', 0.0225, 'lps'),
	(481554, 126, '2015-04-01 00:25:20.000000', 'consum', 0.0227, 'lps'),
	(481555, 126, '2015-04-01 00:25:21.000000', 'consum', 0.0213, 'lps'),
	(481556, 126, '2015-04-01 00:25:22.000000', 'consum', 0.0213, 'lps'),
	(481557, 126, '2015-04-01 00:25:23.000000', 'consum', 0.0215, 'lps'),
	(481558, 126, '2015-04-01 00:25:24.000000', 'consum', 0.0225, 'lps'),
	(481559, 126, '2015-04-01 00:25:25.000000', 'consum', 0.0219, 'lps'),
	(481560, 126, '2015-04-01 00:25:26.000000', 'consum', 0.0211, 'lps'),
	(481561, 126, '2015-04-01 00:25:27.000000', 'consum', 0.0224, 'lps'),
	(481562, 126, '2015-04-01 00:25:28.000000', 'consum', 0.0221, 'lps'),
	(481563, 126, '2015-04-01 00:25:29.000000', 'consum', 0.0227, 'lps'),
	(481564, 126, '2015-04-01 00:25:30.000000', 'consum', 0.0226, 'lps'),
	(481565, 126, '2015-04-01 00:25:31.000000', 'consum', 0.0219, 'lps'),
	(481566, 126, '2015-04-01 00:25:32.000000', 'consum', 0.0210, 'lps'),
	(481567, 126, '2015-04-01 00:25:33.000000', 'consum', 0.0218, 'lps'),
	(481568, 126, '2015-04-01 00:25:34.000000', 'consum', 0.0216, 'lps'),
	(481569, 126, '2015-04-01 00:25:35.000000', 'consum', 0.0218, 'lps'),
	(481570, 126, '2015-04-01 00:25:36.000000', 'consum', 0.0211, 'lps'),
	(481571, 126, '2015-04-01 00:25:37.000000', 'consum', 0.0211, 'lps'),
	(481572, 126, '2015-04-01 00:25:38.000000', 'consum', 0.0211, 'lps'),
	(481573, 126, '2015-04-01 00:25:39.000000', 'consum', 0.0213, 'lps'),
	(481574, 126, '2015-04-01 00:25:40.000000', 'consum', 0.0221, 'lps'),
	(481575, 126, '2015-04-01 00:25:41.000000', 'consum', 0.0221, 'lps'),
	(481576, 126, '2015-04-01 00:25:42.000000', 'consum', 0.0215, 'lps'),
	(481577, 126, '2015-04-01 00:25:43.000000', 'consum', 0.0219, 'lps'),
	(481578, 126, '2015-04-01 00:25:44.000000', 'consum', 0.0226, 'lps'),
	(481579, 126, '2015-04-01 00:25:45.000000', 'consum', 0.0224, 'lps'),
	(481580, 126, '2015-04-01 00:25:46.000000', 'consum', 0.0218, 'lps'),
	(481581, 126, '2015-04-01 00:25:47.000000', 'consum', 0.0223, 'lps'),
	(481582, 126, '2015-04-01 00:25:48.000000', 'consum', 0.0218, 'lps'),
	(481583, 126, '2015-04-01 00:25:49.000000', 'consum', 0.0210, 'lps'),
	(481584, 126, '2015-04-01 00:25:50.000000', 'consum', 0.0222, 'lps'),
	(481585, 126, '2015-04-01 00:25:51.000000', 'consum', 0.0218, 'lps'),
	(481586, 126, '2015-04-01 00:25:52.000000', 'consum', 0.0214, 'lps'),
	(481587, 126, '2015-04-01 00:25:53.000000', 'consum', 0.0223, 'lps'),
	(481588, 126, '2015-04-01 00:25:54.000000', 'consum', 0.0211, 'lps'),
	(481589, 126, '2015-04-01 00:25:55.000000', 'consum', 0.0214, 'lps'),
	(481590, 126, '2015-04-01 00:25:56.000000', 'consum', 0.0225, 'lps'),
	(481591, 126, '2015-04-01 00:25:57.000000', 'consum', 0.0222, 'lps'),
	(481592, 126, '2015-04-01 00:25:58.000000', 'consum', 0.0226, 'lps'),
	(481593, 126, '2015-04-01 00:25:59.000000', 'consum', 0.0215, 'lps'),
	(481594, 126, '2015-04-01 00:26:00.000000', 'consum', 0.0227, 'lps'),
	(481595, 126, '2015-04-01 00:26:01.000000', 'consum', 0.0223, 'lps'),
	(481596, 126, '2015-04-01 00:26:02.000000', 'consum', 0.0227, 'lps'),
	(481597, 126, '2015-04-01 00:26:03.000000', 'consum', 0.0221, 'lps'),
	(481598, 126, '2015-04-01 00:26:04.000000', 'consum', 0.0214, 'lps'),
	(481599, 126, '2015-04-01 00:26:05.000000', 'consum', 0.0213, 'lps'),
	(481600, 126, '2015-04-01 00:26:06.000000', 'consum', 0.0217, 'lps'),
	(481601, 126, '2015-04-01 00:26:07.000000', 'consum', 0.0217, 'lps'),
	(481602, 126, '2015-04-01 00:26:08.000000', 'consum', 0.0224, 'lps'),
	(481603, 126, '2015-04-01 00:26:09.000000', 'consum', 0.0224, 'lps'),
	(481604, 126, '2015-04-01 00:26:10.000000', 'consum', 0.0222, 'lps'),
	(481605, 126, '2015-04-01 00:26:11.000000', 'consum', 0.0211, 'lps'),
	(481606, 126, '2015-04-01 00:26:12.000000', 'consum', 0.0214, 'lps'),
	(481607, 126, '2015-04-01 00:26:13.000000', 'consum', 0.0211, 'lps'),
	(481608, 126, '2015-04-01 00:26:14.000000', 'consum', 0.0222, 'lps'),
	(481609, 126, '2015-04-01 00:26:15.000000', 'consum', 0.0213, 'lps'),
	(481610, 126, '2015-04-01 00:26:16.000000', 'consum', 0.0227, 'lps'),
	(481611, 126, '2015-04-01 00:26:17.000000', 'consum', 0.0211, 'lps'),
	(481612, 126, '2015-04-01 00:26:18.000000', 'consum', 0.0221, 'lps'),
	(481613, 126, '2015-04-01 00:26:19.000000', 'consum', 0.0224, 'lps'),
	(481614, 126, '2015-04-01 00:26:20.000000', 'consum', 0.0213, 'lps'),
	(481615, 126, '2015-04-01 00:26:21.000000', 'consum', 0.0217, 'lps'),
	(481616, 126, '2015-04-01 00:26:22.000000', 'consum', 0.0221, 'lps'),
	(481617, 126, '2015-04-01 00:26:23.000000', 'consum', 0.0210, 'lps'),
	(481618, 126, '2015-04-01 00:26:24.000000', 'consum', 0.0211, 'lps'),
	(481619, 126, '2015-04-01 00:26:25.000000', 'consum', 0.0217, 'lps'),
	(481620, 126, '2015-04-01 00:26:26.000000', 'consum', 0.0224, 'lps'),
	(481621, 126, '2015-04-01 00:26:27.000000', 'consum', 0.0224, 'lps'),
	(481622, 126, '2015-04-01 00:26:28.000000', 'consum', 0.0219, 'lps'),
	(481623, 126, '2015-04-01 00:26:29.000000', 'consum', 0.0214, 'lps'),
	(481624, 126, '2015-04-01 00:26:30.000000', 'consum', 0.0221, 'lps'),
	(481625, 126, '2015-04-01 00:26:31.000000', 'consum', 0.0218, 'lps'),
	(481626, 126, '2015-04-01 00:26:32.000000', 'consum', 0.0216, 'lps'),
	(481627, 126, '2015-04-01 00:26:33.000000', 'consum', 0.0218, 'lps'),
	(481628, 126, '2015-04-01 00:26:34.000000', 'consum', 0.0212, 'lps'),
	(481629, 126, '2015-04-01 00:26:35.000000', 'consum', 0.0217, 'lps'),
	(481630, 126, '2015-04-01 00:26:36.000000', 'consum', 0.0219, 'lps'),
	(481631, 126, '2015-04-01 00:26:37.000000', 'consum', 0.0218, 'lps'),
	(481632, 126, '2015-04-01 00:26:38.000000', 'consum', 0.0224, 'lps'),
	(481633, 126, '2015-04-01 00:26:39.000000', 'consum', 0.0218, 'lps'),
	(481634, 126, '2015-04-01 00:26:40.000000', 'consum', 0.0211, 'lps'),
	(481635, 126, '2015-04-01 00:26:41.000000', 'consum', 0.0227, 'lps'),
	(481636, 126, '2015-04-01 00:26:42.000000', 'consum', 0.0222, 'lps'),
	(481637, 126, '2015-04-01 00:26:43.000000', 'consum', 0.0218, 'lps'),
	(481638, 126, '2015-04-01 00:26:44.000000', 'consum', 0.0214, 'lps'),
	(481639, 126, '2015-04-01 00:26:45.000000', 'consum', 0.0226, 'lps'),
	(481640, 126, '2015-04-01 00:26:46.000000', 'consum', 0.0226, 'lps'),
	(481641, 126, '2015-04-01 00:26:47.000000', 'consum', 0.0221, 'lps'),
	(481642, 126, '2015-04-01 00:26:48.000000', 'consum', 0.0220, 'lps'),
	(481643, 126, '2015-04-01 00:26:49.000000', 'consum', 0.0225, 'lps'),
	(481644, 126, '2015-04-01 00:26:50.000000', 'consum', 0.0220, 'lps'),
	(481645, 126, '2015-04-01 00:26:51.000000', 'consum', 0.0218, 'lps'),
	(481646, 126, '2015-04-01 00:26:52.000000', 'consum', 0.0219, 'lps'),
	(481647, 126, '2015-04-01 00:26:53.000000', 'consum', 0.0215, 'lps'),
	(481648, 126, '2015-04-01 00:26:54.000000', 'consum', 0.0227, 'lps'),
	(481649, 126, '2015-04-01 00:26:55.000000', 'consum', 0.0226, 'lps'),
	(481650, 126, '2015-04-01 00:26:56.000000', 'consum', 0.0220, 'lps'),
	(481651, 126, '2015-04-01 00:26:57.000000', 'consum', 0.0215, 'lps'),
	(481652, 126, '2015-04-01 00:26:58.000000', 'consum', 0.0222, 'lps'),
	(481653, 126, '2015-04-01 00:26:59.000000', 'consum', 0.0220, 'lps'),
	(481654, 126, '2015-04-01 00:27:00.000000', 'consum', 0.0226, 'lps'),
	(481655, 126, '2015-04-01 00:27:01.000000', 'consum', 0.0224, 'lps'),
	(481656, 126, '2015-04-01 00:27:02.000000', 'consum', 0.0212, 'lps'),
	(481657, 126, '2015-04-01 00:27:03.000000', 'consum', 0.0217, 'lps'),
	(481658, 126, '2015-04-01 00:27:04.000000', 'consum', 0.0222, 'lps'),
	(481659, 126, '2015-04-01 00:27:05.000000', 'consum', 0.0215, 'lps'),
	(481660, 126, '2015-04-01 00:27:06.000000', 'consum', 0.0215, 'lps'),
	(481661, 126, '2015-04-01 00:27:07.000000', 'consum', 0.0220, 'lps'),
	(481662, 126, '2015-04-01 00:27:08.000000', 'consum', 0.0227, 'lps'),
	(481663, 126, '2015-04-01 00:27:09.000000', 'consum', 0.0211, 'lps'),
	(481664, 126, '2015-04-01 00:27:10.000000', 'consum', 0.0218, 'lps'),
	(481665, 126, '2015-04-01 00:27:11.000000', 'consum', 0.0215, 'lps'),
	(481666, 126, '2015-04-01 00:27:12.000000', 'consum', 0.0226, 'lps'),
	(481667, 126, '2015-04-01 00:27:13.000000', 'consum', 0.0221, 'lps'),
	(481668, 126, '2015-04-01 00:27:14.000000', 'consum', 0.0219, 'lps'),
	(481669, 126, '2015-04-01 00:27:15.000000', 'consum', 0.0224, 'lps'),
	(481670, 126, '2015-04-01 00:27:16.000000', 'consum', 0.0215, 'lps'),
	(481671, 126, '2015-04-01 00:27:17.000000', 'consum', 0.0211, 'lps'),
	(481672, 126, '2015-04-01 00:27:18.000000', 'consum', 0.0220, 'lps'),
	(481673, 126, '2015-04-01 00:27:19.000000', 'consum', 0.0222, 'lps'),
	(481674, 126, '2015-04-01 00:27:20.000000', 'consum', 0.0223, 'lps'),
	(481675, 126, '2015-04-01 00:27:21.000000', 'consum', 0.0221, 'lps'),
	(481676, 126, '2015-04-01 00:27:22.000000', 'consum', 0.0210, 'lps'),
	(481677, 126, '2015-04-01 00:27:23.000000', 'consum', 0.0212, 'lps'),
	(481678, 126, '2015-04-01 00:27:24.000000', 'consum', 0.0219, 'lps'),
	(481679, 126, '2015-04-01 00:27:25.000000', 'consum', 0.0213, 'lps'),
	(481680, 126, '2015-04-01 00:27:26.000000', 'consum', 0.0219, 'lps'),
	(481681, 126, '2015-04-01 00:27:27.000000', 'consum', 0.0227, 'lps'),
	(481682, 126, '2015-04-01 00:27:28.000000', 'consum', 0.0214, 'lps'),
	(481683, 126, '2015-04-01 00:27:29.000000', 'consum', 0.0217, 'lps'),
	(481684, 126, '2015-04-01 00:27:30.000000', 'consum', 0.0213, 'lps'),
	(481685, 126, '2015-04-01 00:27:31.000000', 'consum', 0.0225, 'lps'),
	(481686, 126, '2015-04-01 00:27:32.000000', 'consum', 0.0222, 'lps'),
	(481687, 126, '2015-04-01 00:27:33.000000', 'consum', 0.0226, 'lps'),
	(481688, 126, '2015-04-01 00:27:34.000000', 'consum', 0.0219, 'lps'),
	(481689, 126, '2015-04-01 00:27:35.000000', 'consum', 0.0224, 'lps'),
	(481690, 126, '2015-04-01 00:27:36.000000', 'consum', 0.0217, 'lps'),
	(481691, 126, '2015-04-01 00:27:37.000000', 'consum', 0.0222, 'lps'),
	(481692, 126, '2015-04-01 00:27:38.000000', 'consum', 0.0212, 'lps'),
	(481693, 126, '2015-04-01 00:27:39.000000', 'consum', 0.0222, 'lps'),
	(481694, 126, '2015-04-01 00:27:40.000000', 'consum', 0.0227, 'lps'),
	(481695, 126, '2015-04-01 00:27:41.000000', 'consum', 0.0223, 'lps'),
	(481696, 126, '2015-04-01 00:27:42.000000', 'consum', 0.0227, 'lps'),
	(481697, 126, '2015-04-01 00:27:43.000000', 'consum', 0.0220, 'lps'),
	(481698, 126, '2015-04-01 00:27:44.000000', 'consum', 0.0211, 'lps'),
	(481699, 126, '2015-04-01 00:27:45.000000', 'consum', 0.0220, 'lps'),
	(481700, 126, '2015-04-01 00:27:46.000000', 'consum', 0.0223, 'lps'),
	(481701, 126, '2015-04-01 00:27:47.000000', 'consum', 0.0226, 'lps'),
	(481702, 126, '2015-04-01 00:27:48.000000', 'consum', 0.0216, 'lps'),
	(481703, 126, '2015-04-01 00:27:49.000000', 'consum', 0.0210, 'lps'),
	(481704, 126, '2015-04-01 00:27:50.000000', 'consum', 0.0227, 'lps'),
	(481705, 126, '2015-04-01 00:27:51.000000', 'consum', 0.0224, 'lps'),
	(481706, 126, '2015-04-01 00:27:52.000000', 'consum', 0.0213, 'lps'),
	(481707, 126, '2015-04-01 00:27:53.000000', 'consum', 0.0219, 'lps'),
	(481708, 126, '2015-04-01 00:27:54.000000', 'consum', 0.0211, 'lps'),
	(481709, 126, '2015-04-01 00:27:55.000000', 'consum', 0.0225, 'lps'),
	(481710, 126, '2015-04-01 00:27:56.000000', 'consum', 0.0227, 'lps'),
	(481711, 126, '2015-04-01 00:27:57.000000', 'consum', 0.0214, 'lps'),
	(481712, 126, '2015-04-01 00:27:58.000000', 'consum', 0.0214, 'lps'),
	(481713, 126, '2015-04-01 00:27:59.000000', 'consum', 0.0222, 'lps'),
	(481714, 126, '2015-04-01 00:28:00.000000', 'consum', 0.0221, 'lps'),
	(481715, 126, '2015-04-01 00:28:01.000000', 'consum', 0.0213, 'lps'),
	(481716, 126, '2015-04-01 00:28:02.000000', 'consum', 0.0227, 'lps'),
	(481717, 126, '2015-04-01 00:28:03.000000', 'consum', 0.0215, 'lps'),
	(481718, 126, '2015-04-01 00:28:04.000000', 'consum', 0.0221, 'lps'),
	(481719, 126, '2015-04-01 00:28:05.000000', 'consum', 0.0215, 'lps'),
	(481720, 126, '2015-04-01 00:28:06.000000', 'consum', 0.0221, 'lps'),
	(481721, 126, '2015-04-01 00:28:07.000000', 'consum', 0.0216, 'lps'),
	(481722, 126, '2015-04-01 00:28:08.000000', 'consum', 0.0222, 'lps'),
	(481723, 126, '2015-04-01 00:28:09.000000', 'consum', 0.0218, 'lps'),
	(481724, 126, '2015-04-01 00:28:10.000000', 'consum', 0.0213, 'lps'),
	(481725, 126, '2015-04-01 00:28:11.000000', 'consum', 0.0218, 'lps'),
	(481726, 126, '2015-04-01 00:28:12.000000', 'consum', 0.0227, 'lps'),
	(481727, 126, '2015-04-01 00:28:13.000000', 'consum', 0.0215, 'lps'),
	(481728, 126, '2015-04-01 00:28:14.000000', 'consum', 0.0223, 'lps'),
	(481729, 126, '2015-04-01 00:28:15.000000', 'consum', 0.0222, 'lps'),
	(481730, 126, '2015-04-01 00:28:16.000000', 'consum', 0.0214, 'lps'),
	(481731, 126, '2015-04-01 00:28:17.000000', 'consum', 0.0211, 'lps'),
	(481732, 126, '2015-04-01 00:28:18.000000', 'consum', 0.0223, 'lps'),
	(481733, 126, '2015-04-01 00:28:19.000000', 'consum', 0.0220, 'lps'),
	(481734, 126, '2015-04-01 00:28:20.000000', 'consum', 0.0222, 'lps'),
	(481735, 126, '2015-04-01 00:28:21.000000', 'consum', 0.0221, 'lps'),
	(481736, 126, '2015-04-01 00:28:22.000000', 'consum', 0.0211, 'lps'),
	(481737, 126, '2015-04-01 00:28:23.000000', 'consum', 0.0220, 'lps'),
	(481738, 126, '2015-04-01 00:28:24.000000', 'consum', 0.0221, 'lps'),
	(481739, 126, '2015-04-01 00:28:25.000000', 'consum', 0.0216, 'lps'),
	(481740, 126, '2015-04-01 00:28:26.000000', 'consum', 0.0225, 'lps'),
	(481741, 126, '2015-04-01 00:28:27.000000', 'consum', 0.0214, 'lps'),
	(481742, 126, '2015-04-01 00:28:28.000000', 'consum', 0.0224, 'lps'),
	(481743, 126, '2015-04-01 00:28:29.000000', 'consum', 0.0211, 'lps'),
	(481744, 126, '2015-04-01 00:28:30.000000', 'consum', 0.0212, 'lps'),
	(481745, 126, '2015-04-01 00:28:31.000000', 'consum', 0.0215, 'lps'),
	(481746, 126, '2015-04-01 00:28:32.000000', 'consum', 0.0213, 'lps'),
	(481747, 126, '2015-04-01 00:28:33.000000', 'consum', 0.0212, 'lps'),
	(481748, 126, '2015-04-01 00:28:34.000000', 'consum', 0.0227, 'lps'),
	(481749, 126, '2015-04-01 00:28:35.000000', 'consum', 0.0220, 'lps'),
	(481750, 126, '2015-04-01 00:28:36.000000', 'consum', 0.0225, 'lps'),
	(481751, 126, '2015-04-01 00:28:37.000000', 'consum', 0.0220, 'lps'),
	(481752, 126, '2015-04-01 00:28:38.000000', 'consum', 0.0217, 'lps'),
	(481753, 126, '2015-04-01 00:28:39.000000', 'consum', 0.0216, 'lps'),
	(481754, 126, '2015-04-01 00:28:40.000000', 'consum', 0.0217, 'lps'),
	(481755, 126, '2015-04-01 00:28:41.000000', 'consum', 0.0211, 'lps'),
	(481756, 126, '2015-04-01 00:28:42.000000', 'consum', 0.0211, 'lps'),
	(481757, 126, '2015-04-01 00:28:43.000000', 'consum', 0.0215, 'lps'),
	(481758, 126, '2015-04-01 00:28:44.000000', 'consum', 0.0213, 'lps'),
	(481759, 126, '2015-04-01 00:28:45.000000', 'consum', 0.0227, 'lps'),
	(481760, 126, '2015-04-01 00:28:46.000000', 'consum', 0.0217, 'lps'),
	(481761, 126, '2015-04-01 00:28:47.000000', 'consum', 0.0212, 'lps'),
	(481762, 126, '2015-04-01 00:28:48.000000', 'consum', 0.0218, 'lps'),
	(481763, 126, '2015-04-01 00:28:49.000000', 'consum', 0.0225, 'lps'),
	(481764, 126, '2015-04-01 00:28:50.000000', 'consum', 0.0225, 'lps'),
	(481765, 126, '2015-04-01 00:28:51.000000', 'consum', 0.0225, 'lps'),
	(481766, 126, '2015-04-01 00:28:52.000000', 'consum', 0.0223, 'lps'),
	(481767, 126, '2015-04-01 00:28:53.000000', 'consum', 0.0213, 'lps'),
	(481768, 126, '2015-04-01 00:28:54.000000', 'consum', 0.0220, 'lps'),
	(481769, 126, '2015-04-01 00:28:55.000000', 'consum', 0.0216, 'lps'),
	(481770, 126, '2015-04-01 00:28:56.000000', 'consum', 0.0213, 'lps'),
	(481771, 126, '2015-04-01 00:28:57.000000', 'consum', 0.0222, 'lps'),
	(481772, 126, '2015-04-01 00:28:58.000000', 'consum', 0.0210, 'lps'),
	(481773, 126, '2015-04-01 00:28:59.000000', 'consum', 0.0226, 'lps'),
	(481774, 126, '2015-04-01 00:29:00.000000', 'consum', 0.0220, 'lps'),
	(481775, 126, '2015-04-01 00:29:01.000000', 'consum', 0.0213, 'lps'),
	(481776, 126, '2015-04-01 00:29:02.000000', 'consum', 0.0214, 'lps'),
	(481777, 126, '2015-04-01 00:29:03.000000', 'consum', 0.0220, 'lps'),
	(481778, 126, '2015-04-01 00:29:04.000000', 'consum', 0.0212, 'lps'),
	(481779, 126, '2015-04-01 00:29:05.000000', 'consum', 0.0211, 'lps'),
	(481780, 126, '2015-04-01 00:29:06.000000', 'consum', 0.0227, 'lps'),
	(481781, 126, '2015-04-01 00:29:07.000000', 'consum', 0.0218, 'lps'),
	(481782, 126, '2015-04-01 00:29:08.000000', 'consum', 0.0219, 'lps'),
	(481783, 126, '2015-04-01 00:29:09.000000', 'consum', 0.0212, 'lps'),
	(481784, 126, '2015-04-01 00:29:10.000000', 'consum', 0.0211, 'lps'),
	(481785, 126, '2015-04-01 00:29:11.000000', 'consum', 0.0212, 'lps'),
	(481786, 126, '2015-04-01 00:29:12.000000', 'consum', 0.0215, 'lps'),
	(481787, 126, '2015-04-01 00:29:13.000000', 'consum', 0.0211, 'lps'),
	(481788, 126, '2015-04-01 00:29:14.000000', 'consum', 0.0221, 'lps'),
	(481789, 126, '2015-04-01 00:29:15.000000', 'consum', 0.0226, 'lps'),
	(481790, 126, '2015-04-01 00:29:16.000000', 'consum', 0.0220, 'lps'),
	(481791, 126, '2015-04-01 00:29:17.000000', 'consum', 0.0212, 'lps'),
	(481792, 126, '2015-04-01 00:29:18.000000', 'consum', 0.0211, 'lps'),
	(481793, 126, '2015-04-01 00:29:19.000000', 'consum', 0.0227, 'lps'),
	(481794, 126, '2015-04-01 00:29:20.000000', 'consum', 0.0220, 'lps'),
	(481795, 126, '2015-04-01 00:29:21.000000', 'consum', 0.0227, 'lps'),
	(481796, 126, '2015-04-01 00:29:22.000000', 'consum', 0.0213, 'lps'),
	(481797, 126, '2015-04-01 00:29:23.000000', 'consum', 0.0210, 'lps'),
	(481798, 126, '2015-04-01 00:29:24.000000', 'consum', 0.0220, 'lps'),
	(481799, 126, '2015-04-01 00:29:25.000000', 'consum', 0.0223, 'lps'),
	(481800, 126, '2015-04-01 00:29:26.000000', 'consum', 0.0210, 'lps'),
	(481801, 126, '2015-04-01 00:29:27.000000', 'consum', 0.0225, 'lps'),
	(481802, 126, '2015-04-01 00:29:28.000000', 'consum', 0.0212, 'lps'),
	(481803, 126, '2015-04-01 00:29:29.000000', 'consum', 0.0214, 'lps'),
	(481804, 126, '2015-04-01 00:29:30.000000', 'consum', 0.0223, 'lps'),
	(481805, 126, '2015-04-01 00:29:31.000000', 'consum', 0.0227, 'lps'),
	(481806, 126, '2015-04-01 00:29:32.000000', 'consum', 0.0220, 'lps'),
	(481807, 126, '2015-04-01 00:29:33.000000', 'consum', 0.0227, 'lps'),
	(481808, 126, '2015-04-01 00:29:34.000000', 'consum', 0.0212, 'lps'),
	(481809, 126, '2015-04-01 00:29:35.000000', 'consum', 0.0222, 'lps'),
	(481810, 126, '2015-04-01 00:29:36.000000', 'consum', 0.0213, 'lps'),
	(481811, 126, '2015-04-01 00:29:37.000000', 'consum', 0.0226, 'lps'),
	(481812, 126, '2015-04-01 00:29:38.000000', 'consum', 0.0210, 'lps'),
	(481813, 126, '2015-04-01 00:29:39.000000', 'consum', 0.0214, 'lps'),
	(481814, 126, '2015-04-01 00:29:40.000000', 'consum', 0.0212, 'lps'),
	(481815, 126, '2015-04-01 00:29:41.000000', 'consum', 0.0212, 'lps'),
	(481816, 126, '2015-04-01 00:29:42.000000', 'consum', 0.0211, 'lps'),
	(481817, 126, '2015-04-01 00:29:43.000000', 'consum', 0.0210, 'lps'),
	(481818, 126, '2015-04-01 00:29:44.000000', 'consum', 0.0226, 'lps'),
	(481819, 126, '2015-04-01 00:29:45.000000', 'consum', 0.0217, 'lps'),
	(481820, 126, '2015-04-01 00:29:46.000000', 'consum', 0.0217, 'lps'),
	(481821, 126, '2015-04-01 00:29:47.000000', 'consum', 0.0224, 'lps'),
	(481822, 126, '2015-04-01 00:29:48.000000', 'consum', 0.0226, 'lps'),
	(481823, 126, '2015-04-01 00:29:49.000000', 'consum', 0.0227, 'lps'),
	(481824, 126, '2015-04-01 00:29:50.000000', 'consum', 0.0213, 'lps'),
	(481825, 126, '2015-04-01 00:29:51.000000', 'consum', 0.0211, 'lps'),
	(481826, 126, '2015-04-01 00:29:52.000000', 'consum', 0.0222, 'lps'),
	(481827, 126, '2015-04-01 00:29:53.000000', 'consum', 0.0215, 'lps'),
	(481828, 126, '2015-04-01 00:29:54.000000', 'consum', 0.0217, 'lps'),
	(481829, 126, '2015-04-01 00:29:55.000000', 'consum', 0.0213, 'lps'),
	(481830, 126, '2015-04-01 00:29:56.000000', 'consum', 0.0222, 'lps'),
	(481831, 126, '2015-04-01 00:29:57.000000', 'consum', 0.0226, 'lps'),
	(481832, 126, '2015-04-01 00:29:58.000000', 'consum', 0.0220, 'lps'),
	(481833, 126, '2015-04-01 00:29:59.000000', 'consum', 0.0212, 'lps'),
	(481834, 126, '2015-04-01 00:30:00.000000', 'consum', 0.0210, 'lps'),
	(481835, 126, '2015-04-01 00:30:01.000000', 'consum', 0.0220, 'lps'),
	(481836, 126, '2015-04-01 00:30:02.000000', 'consum', 0.0223, 'lps'),
	(481837, 126, '2015-04-01 00:30:03.000000', 'consum', 0.0212, 'lps'),
	(481838, 126, '2015-04-01 00:30:04.000000', 'consum', 0.0216, 'lps'),
	(481839, 126, '2015-04-01 00:30:05.000000', 'consum', 0.0218, 'lps'),
	(481840, 126, '2015-04-01 00:30:06.000000', 'consum', 0.0215, 'lps'),
	(481841, 126, '2015-04-01 00:30:07.000000', 'consum', 0.0213, 'lps'),
	(481842, 126, '2015-04-01 00:30:08.000000', 'consum', 0.0225, 'lps'),
	(481843, 126, '2015-04-01 00:30:09.000000', 'consum', 0.0225, 'lps'),
	(481844, 126, '2015-04-01 00:30:10.000000', 'consum', 0.0220, 'lps'),
	(481845, 126, '2015-04-01 00:30:11.000000', 'consum', 0.0219, 'lps'),
	(481846, 126, '2015-04-01 00:30:12.000000', 'consum', 0.0222, 'lps'),
	(481847, 126, '2015-04-01 00:30:13.000000', 'consum', 0.0227, 'lps'),
	(481848, 126, '2015-04-01 00:30:14.000000', 'consum', 0.0224, 'lps'),
	(481849, 126, '2015-04-01 00:30:15.000000', 'consum', 0.0212, 'lps'),
	(481850, 126, '2015-04-01 00:30:16.000000', 'consum', 0.0212, 'lps'),
	(481851, 126, '2015-04-01 00:30:17.000000', 'consum', 0.0216, 'lps'),
	(481852, 126, '2015-04-01 00:30:18.000000', 'consum', 0.0216, 'lps'),
	(481853, 126, '2015-04-01 00:30:19.000000', 'consum', 0.0223, 'lps'),
	(481854, 126, '2015-04-01 00:30:20.000000', 'consum', 0.0220, 'lps'),
	(481855, 126, '2015-04-01 00:30:21.000000', 'consum', 0.0223, 'lps'),
	(481856, 126, '2015-04-01 00:30:22.000000', 'consum', 0.0226, 'lps'),
	(481857, 126, '2015-04-01 00:30:23.000000', 'consum', 0.0216, 'lps'),
	(481858, 126, '2015-04-01 00:30:24.000000', 'consum', 0.0227, 'lps'),
	(481859, 126, '2015-04-01 00:30:25.000000', 'consum', 0.0225, 'lps'),
	(481860, 126, '2015-04-01 00:30:26.000000', 'consum', 0.0216, 'lps'),
	(481861, 126, '2015-04-01 00:30:27.000000', 'consum', 0.0212, 'lps'),
	(481862, 126, '2015-04-01 00:30:28.000000', 'consum', 0.0222, 'lps'),
	(481863, 126, '2015-04-01 00:30:29.000000', 'consum', 0.0211, 'lps'),
	(481864, 126, '2015-04-01 00:30:30.000000', 'consum', 0.0215, 'lps'),
	(481865, 126, '2015-04-01 00:30:31.000000', 'consum', 0.0212, 'lps'),
	(481866, 126, '2015-04-01 00:30:32.000000', 'consum', 0.0227, 'lps'),
	(481867, 126, '2015-04-01 00:30:33.000000', 'consum', 0.0215, 'lps'),
	(481868, 126, '2015-04-01 00:30:34.000000', 'consum', 0.0222, 'lps'),
	(481869, 126, '2015-04-01 00:30:35.000000', 'consum', 0.0219, 'lps'),
	(481870, 126, '2015-04-01 00:30:36.000000', 'consum', 0.0218, 'lps'),
	(481871, 126, '2015-04-01 00:30:37.000000', 'consum', 0.0225, 'lps'),
	(481872, 126, '2015-04-01 00:30:38.000000', 'consum', 0.0225, 'lps'),
	(481873, 126, '2015-04-01 00:30:39.000000', 'consum', 0.0222, 'lps'),
	(481874, 126, '2015-04-01 00:30:40.000000', 'consum', 0.0225, 'lps'),
	(481875, 126, '2015-04-01 00:30:41.000000', 'consum', 0.0216, 'lps'),
	(481876, 126, '2015-04-01 00:30:42.000000', 'consum', 0.0213, 'lps'),
	(481877, 126, '2015-04-01 00:30:43.000000', 'consum', 0.0224, 'lps'),
	(481878, 126, '2015-04-01 00:30:44.000000', 'consum', 0.0217, 'lps'),
	(481879, 126, '2015-04-01 00:30:45.000000', 'consum', 0.0222, 'lps'),
	(481880, 126, '2015-04-01 00:30:46.000000', 'consum', 0.0215, 'lps'),
	(481881, 126, '2015-04-01 00:30:47.000000', 'consum', 0.0217, 'lps'),
	(481882, 126, '2015-04-01 00:30:48.000000', 'consum', 0.0211, 'lps'),
	(481883, 126, '2015-04-01 00:30:49.000000', 'consum', 0.0212, 'lps'),
	(481884, 126, '2015-04-01 00:30:50.000000', 'consum', 0.0220, 'lps'),
	(481885, 126, '2015-04-01 00:30:51.000000', 'consum', 0.0217, 'lps'),
	(481886, 126, '2015-04-01 00:30:52.000000', 'consum', 0.0215, 'lps'),
	(481887, 126, '2015-04-01 00:30:53.000000', 'consum', 0.0214, 'lps'),
	(481888, 126, '2015-04-01 00:30:54.000000', 'consum', 0.0216, 'lps'),
	(481889, 126, '2015-04-01 00:30:55.000000', 'consum', 0.0227, 'lps'),
	(481890, 126, '2015-04-01 00:30:56.000000', 'consum', 0.0224, 'lps'),
	(481891, 126, '2015-04-01 00:30:57.000000', 'consum', 0.0213, 'lps'),
	(481892, 126, '2015-04-01 00:30:58.000000', 'consum', 0.0220, 'lps'),
	(481893, 126, '2015-04-01 00:30:59.000000', 'consum', 0.0217, 'lps'),
	(481894, 126, '2015-04-01 00:31:00.000000', 'consum', 0.0212, 'lps'),
	(481895, 126, '2015-04-01 00:31:01.000000', 'consum', 0.0218, 'lps'),
	(481896, 126, '2015-04-01 00:31:02.000000', 'consum', 0.0210, 'lps'),
	(481897, 126, '2015-04-01 00:31:03.000000', 'consum', 0.0221, 'lps'),
	(481898, 126, '2015-04-01 00:31:04.000000', 'consum', 0.0213, 'lps'),
	(481899, 126, '2015-04-01 00:31:05.000000', 'consum', 0.0210, 'lps'),
	(481900, 126, '2015-04-01 00:31:06.000000', 'consum', 0.0218, 'lps'),
	(481901, 126, '2015-04-01 00:31:07.000000', 'consum', 0.0217, 'lps'),
	(481902, 126, '2015-04-01 00:31:08.000000', 'consum', 0.0221, 'lps'),
	(481903, 126, '2015-04-01 00:31:09.000000', 'consum', 0.0225, 'lps'),
	(481904, 126, '2015-04-01 00:31:10.000000', 'consum', 0.0219, 'lps'),
	(481905, 126, '2015-04-01 00:31:11.000000', 'consum', 0.0225, 'lps'),
	(481906, 126, '2015-04-01 00:31:12.000000', 'consum', 0.0226, 'lps'),
	(481907, 126, '2015-04-01 00:31:13.000000', 'consum', 0.0225, 'lps'),
	(481908, 126, '2015-04-01 00:31:14.000000', 'consum', 0.0220, 'lps'),
	(481909, 126, '2015-04-01 00:31:15.000000', 'consum', 0.0217, 'lps'),
	(481910, 126, '2015-04-01 00:31:16.000000', 'consum', 0.0213, 'lps'),
	(481911, 126, '2015-04-01 00:31:17.000000', 'consum', 0.0225, 'lps'),
	(481912, 126, '2015-04-01 00:31:18.000000', 'consum', 0.0220, 'lps'),
	(481913, 126, '2015-04-01 00:31:19.000000', 'consum', 0.0217, 'lps'),
	(481914, 126, '2015-04-01 00:31:20.000000', 'consum', 0.0215, 'lps'),
	(481915, 126, '2015-04-01 00:31:21.000000', 'consum', 0.0213, 'lps'),
	(481916, 126, '2015-04-01 00:31:22.000000', 'consum', 0.0214, 'lps'),
	(481917, 126, '2015-04-01 00:31:23.000000', 'consum', 0.0219, 'lps'),
	(481918, 126, '2015-04-01 00:31:24.000000', 'consum', 0.0226, 'lps'),
	(481919, 126, '2015-04-01 00:31:25.000000', 'consum', 0.0226, 'lps'),
	(481920, 126, '2015-04-01 00:31:26.000000', 'consum', 0.0224, 'lps'),
	(481921, 126, '2015-04-01 00:31:27.000000', 'consum', 0.0214, 'lps'),
	(481922, 126, '2015-04-01 00:31:28.000000', 'consum', 0.0225, 'lps'),
	(481923, 126, '2015-04-01 00:31:29.000000', 'consum', 0.0219, 'lps'),
	(481924, 126, '2015-04-01 00:31:30.000000', 'consum', 0.0212, 'lps'),
	(481925, 126, '2015-04-01 00:31:31.000000', 'consum', 0.0211, 'lps'),
	(481926, 126, '2015-04-01 00:31:32.000000', 'consum', 0.0210, 'lps'),
	(481927, 126, '2015-04-01 00:31:33.000000', 'consum', 0.0224, 'lps'),
	(481928, 126, '2015-04-01 00:31:34.000000', 'consum', 0.0227, 'lps'),
	(481929, 126, '2015-04-01 00:31:35.000000', 'consum', 0.0216, 'lps'),
	(481930, 126, '2015-04-01 00:31:36.000000', 'consum', 0.0226, 'lps'),
	(481931, 126, '2015-04-01 00:31:37.000000', 'consum', 0.0218, 'lps'),
	(481932, 126, '2015-04-01 00:31:38.000000', 'consum', 0.0223, 'lps'),
	(481933, 126, '2015-04-01 00:31:39.000000', 'consum', 0.0214, 'lps'),
	(481934, 126, '2015-04-01 00:31:40.000000', 'consum', 0.0226, 'lps'),
	(481935, 126, '2015-04-01 00:31:41.000000', 'consum', 0.0210, 'lps'),
	(481936, 126, '2015-04-01 00:31:42.000000', 'consum', 0.0213, 'lps'),
	(481937, 126, '2015-04-01 00:31:43.000000', 'consum', 0.0227, 'lps'),
	(481938, 126, '2015-04-01 00:31:44.000000', 'consum', 0.0213, 'lps'),
	(481939, 126, '2015-04-01 00:31:45.000000', 'consum', 0.0213, 'lps'),
	(481940, 126, '2015-04-01 00:31:46.000000', 'consum', 0.0216, 'lps'),
	(481941, 126, '2015-04-01 00:31:47.000000', 'consum', 0.0214, 'lps'),
	(481942, 126, '2015-04-01 00:31:48.000000', 'consum', 0.0214, 'lps'),
	(481943, 126, '2015-04-01 00:31:49.000000', 'consum', 0.0216, 'lps'),
	(481944, 126, '2015-04-01 00:31:50.000000', 'consum', 0.0211, 'lps'),
	(481945, 126, '2015-04-01 00:31:51.000000', 'consum', 0.0217, 'lps'),
	(481946, 126, '2015-04-01 00:31:52.000000', 'consum', 0.0224, 'lps'),
	(481947, 126, '2015-04-01 00:31:53.000000', 'consum', 0.0223, 'lps'),
	(481948, 126, '2015-04-01 00:31:54.000000', 'consum', 0.0214, 'lps'),
	(481949, 126, '2015-04-01 00:31:55.000000', 'consum', 0.0227, 'lps'),
	(481950, 126, '2015-04-01 00:31:56.000000', 'consum', 0.0213, 'lps'),
	(481951, 126, '2015-04-01 00:31:57.000000', 'consum', 0.0210, 'lps'),
	(481952, 126, '2015-04-01 00:31:58.000000', 'consum', 0.0220, 'lps'),
	(481953, 126, '2015-04-01 00:31:59.000000', 'consum', 0.0224, 'lps'),
	(481954, 126, '2015-04-01 00:32:00.000000', 'consum', 0.0214, 'lps'),
	(481955, 126, '2015-04-01 00:32:01.000000', 'consum', 0.0223, 'lps'),
	(481956, 126, '2015-04-01 00:32:02.000000', 'consum', 0.0212, 'lps'),
	(481957, 126, '2015-04-01 00:32:03.000000', 'consum', 0.0218, 'lps'),
	(481958, 126, '2015-04-01 00:32:04.000000', 'consum', 0.0225, 'lps'),
	(481959, 126, '2015-04-01 00:32:05.000000', 'consum', 0.0226, 'lps'),
	(481960, 126, '2015-04-01 00:32:06.000000', 'consum', 0.0211, 'lps'),
	(481961, 126, '2015-04-01 00:32:07.000000', 'consum', 0.0222, 'lps'),
	(481962, 126, '2015-04-01 00:32:08.000000', 'consum', 0.0211, 'lps'),
	(481963, 126, '2015-04-01 00:32:09.000000', 'consum', 0.0215, 'lps'),
	(481964, 126, '2015-04-01 00:32:10.000000', 'consum', 0.0214, 'lps'),
	(481965, 126, '2015-04-01 00:32:11.000000', 'consum', 0.0217, 'lps'),
	(481966, 126, '2015-04-01 00:32:12.000000', 'consum', 0.0216, 'lps'),
	(481967, 126, '2015-04-01 00:32:13.000000', 'consum', 0.0219, 'lps'),
	(481968, 126, '2015-04-01 00:32:14.000000', 'consum', 0.0220, 'lps'),
	(481969, 126, '2015-04-01 00:32:15.000000', 'consum', 0.0214, 'lps'),
	(481970, 126, '2015-04-01 00:32:16.000000', 'consum', 0.0221, 'lps'),
	(481971, 126, '2015-04-01 00:32:17.000000', 'consum', 0.0215, 'lps'),
	(481972, 126, '2015-04-01 00:32:18.000000', 'consum', 0.0219, 'lps'),
	(481973, 126, '2015-04-01 00:32:19.000000', 'consum', 0.0226, 'lps'),
	(481974, 126, '2015-04-01 00:32:20.000000', 'consum', 0.0227, 'lps'),
	(481975, 126, '2015-04-01 00:32:21.000000', 'consum', 0.0227, 'lps'),
	(481976, 126, '2015-04-01 00:32:22.000000', 'consum', 0.0212, 'lps'),
	(481977, 126, '2015-04-01 00:32:23.000000', 'consum', 0.0220, 'lps'),
	(481978, 126, '2015-04-01 00:32:24.000000', 'consum', 0.0221, 'lps'),
	(481979, 126, '2015-04-01 00:32:25.000000', 'consum', 0.0215, 'lps'),
	(481980, 126, '2015-04-01 00:32:26.000000', 'consum', 0.0222, 'lps'),
	(481981, 126, '2015-04-01 00:32:27.000000', 'consum', 0.0218, 'lps'),
	(481982, 126, '2015-04-01 00:32:28.000000', 'consum', 0.0214, 'lps'),
	(481983, 126, '2015-04-01 00:32:29.000000', 'consum', 0.0225, 'lps'),
	(481984, 126, '2015-04-01 00:32:30.000000', 'consum', 0.0219, 'lps'),
	(481985, 126, '2015-04-01 00:32:31.000000', 'consum', 0.0212, 'lps'),
	(481986, 126, '2015-04-01 00:32:32.000000', 'consum', 0.0212, 'lps'),
	(481987, 126, '2015-04-01 00:32:33.000000', 'consum', 0.0212, 'lps'),
	(481988, 126, '2015-04-01 00:32:34.000000', 'consum', 0.0217, 'lps'),
	(481989, 126, '2015-04-01 00:32:35.000000', 'consum', 0.0222, 'lps'),
	(481990, 126, '2015-04-01 00:32:36.000000', 'consum', 0.0213, 'lps'),
	(481991, 126, '2015-04-01 00:32:37.000000', 'consum', 0.0224, 'lps'),
	(481992, 126, '2015-04-01 00:32:38.000000', 'consum', 0.0219, 'lps'),
	(481993, 126, '2015-04-01 00:32:39.000000', 'consum', 0.0213, 'lps'),
	(481994, 126, '2015-04-01 00:32:40.000000', 'consum', 0.0215, 'lps'),
	(481995, 126, '2015-04-01 00:32:41.000000', 'consum', 0.0210, 'lps'),
	(481996, 126, '2015-04-01 00:32:42.000000', 'consum', 0.0212, 'lps'),
	(481997, 126, '2015-04-01 00:32:43.000000', 'consum', 0.0221, 'lps'),
	(481998, 126, '2015-04-01 00:32:44.000000', 'consum', 0.0224, 'lps'),
	(481999, 126, '2015-04-01 00:32:45.000000', 'consum', 0.0211, 'lps'),
	(482000, 126, '2015-04-01 00:32:46.000000', 'consum', 0.0210, 'lps'),
	(482001, 126, '2015-04-01 00:32:47.000000', 'consum', 0.0227, 'lps'),
	(482002, 126, '2015-04-01 00:32:48.000000', 'consum', 0.0221, 'lps'),
	(482003, 126, '2015-04-01 00:32:49.000000', 'consum', 0.0215, 'lps'),
	(482004, 126, '2015-04-01 00:32:50.000000', 'consum', 0.0220, 'lps'),
	(482005, 126, '2015-04-01 00:32:51.000000', 'consum', 0.0210, 'lps'),
	(482006, 126, '2015-04-01 00:32:52.000000', 'consum', 0.0216, 'lps'),
	(482007, 126, '2015-04-01 00:32:53.000000', 'consum', 0.0225, 'lps'),
	(482008, 126, '2015-04-01 00:32:54.000000', 'consum', 0.0211, 'lps'),
	(482009, 126, '2015-04-01 00:32:55.000000', 'consum', 0.0226, 'lps'),
	(482010, 126, '2015-04-01 00:32:56.000000', 'consum', 0.0214, 'lps'),
	(482011, 126, '2015-04-01 00:32:57.000000', 'consum', 0.0218, 'lps'),
	(482012, 126, '2015-04-01 00:32:58.000000', 'consum', 0.0222, 'lps'),
	(482013, 126, '2015-04-01 00:32:59.000000', 'consum', 0.0211, 'lps'),
	(482014, 126, '2015-04-01 00:33:00.000000', 'consum', 0.0215, 'lps'),
	(482015, 126, '2015-04-01 00:33:01.000000', 'consum', 0.0213, 'lps'),
	(482016, 126, '2015-04-01 00:33:02.000000', 'consum', 0.0213, 'lps'),
	(482017, 126, '2015-04-01 00:33:03.000000', 'consum', 0.0214, 'lps'),
	(482018, 126, '2015-04-01 00:33:04.000000', 'consum', 0.0222, 'lps'),
	(482019, 126, '2015-04-01 00:33:05.000000', 'consum', 0.0223, 'lps'),
	(482020, 126, '2015-04-01 00:33:06.000000', 'consum', 0.0221, 'lps'),
	(482021, 126, '2015-04-01 00:33:07.000000', 'consum', 0.0210, 'lps'),
	(482022, 126, '2015-04-01 00:33:08.000000', 'consum', 0.0211, 'lps'),
	(482023, 126, '2015-04-01 00:33:09.000000', 'consum', 0.0215, 'lps'),
	(482024, 126, '2015-04-01 00:33:10.000000', 'consum', 0.0214, 'lps'),
	(482025, 126, '2015-04-01 00:33:11.000000', 'consum', 0.0217, 'lps'),
	(482026, 126, '2015-04-01 00:33:12.000000', 'consum', 0.0216, 'lps'),
	(482027, 126, '2015-04-01 00:33:13.000000', 'consum', 0.0219, 'lps'),
	(482028, 126, '2015-04-01 00:33:14.000000', 'consum', 0.0218, 'lps'),
	(482029, 126, '2015-04-01 00:33:15.000000', 'consum', 0.0224, 'lps'),
	(482030, 126, '2015-04-01 00:33:16.000000', 'consum', 0.0222, 'lps'),
	(482031, 126, '2015-04-01 00:33:17.000000', 'consum', 0.0210, 'lps'),
	(482032, 126, '2015-04-01 00:33:18.000000', 'consum', 0.0226, 'lps'),
	(482033, 126, '2015-04-01 00:33:19.000000', 'consum', 0.0221, 'lps'),
	(482034, 126, '2015-04-01 00:33:20.000000', 'consum', 0.0217, 'lps'),
	(482035, 126, '2015-04-01 00:33:21.000000', 'consum', 0.0213, 'lps'),
	(482036, 126, '2015-04-01 00:33:22.000000', 'consum', 0.0222, 'lps'),
	(482037, 126, '2015-04-01 00:33:23.000000', 'consum', 0.0227, 'lps'),
	(482038, 126, '2015-04-01 00:33:24.000000', 'consum', 0.0222, 'lps'),
	(482039, 126, '2015-04-01 00:33:25.000000', 'consum', 0.0222, 'lps'),
	(482040, 126, '2015-04-01 00:33:26.000000', 'consum', 0.0214, 'lps'),
	(482041, 126, '2015-04-01 00:33:27.000000', 'consum', 0.0212, 'lps'),
	(482042, 126, '2015-04-01 00:33:28.000000', 'consum', 0.0227, 'lps'),
	(482043, 126, '2015-04-01 00:33:29.000000', 'consum', 0.0219, 'lps'),
	(482044, 126, '2015-04-01 00:33:30.000000', 'consum', 0.0224, 'lps'),
	(482045, 126, '2015-04-01 00:33:31.000000', 'consum', 0.0214, 'lps'),
	(482046, 126, '2015-04-01 00:33:32.000000', 'consum', 0.0225, 'lps'),
	(482047, 126, '2015-04-01 00:33:33.000000', 'consum', 0.0222, 'lps'),
	(482048, 126, '2015-04-01 00:33:34.000000', 'consum', 0.0222, 'lps'),
	(482049, 126, '2015-04-01 00:33:35.000000', 'consum', 0.0218, 'lps'),
	(482050, 126, '2015-04-01 00:33:36.000000', 'consum', 0.0216, 'lps'),
	(482051, 126, '2015-04-01 00:33:37.000000', 'consum', 0.0215, 'lps'),
	(482052, 126, '2015-04-01 00:33:38.000000', 'consum', 0.0220, 'lps'),
	(482053, 126, '2015-04-01 00:33:39.000000', 'consum', 0.0224, 'lps'),
	(482054, 126, '2015-04-01 00:33:40.000000', 'consum', 0.0218, 'lps'),
	(482055, 126, '2015-04-01 00:33:41.000000', 'consum', 0.0224, 'lps'),
	(482056, 126, '2015-04-01 00:33:42.000000', 'consum', 0.0223, 'lps'),
	(482057, 126, '2015-04-01 00:33:43.000000', 'consum', 0.0214, 'lps'),
	(482058, 126, '2015-04-01 00:33:44.000000', 'consum', 0.0227, 'lps'),
	(482059, 126, '2015-04-01 00:33:45.000000', 'consum', 0.0214, 'lps'),
	(482060, 126, '2015-04-01 00:33:46.000000', 'consum', 0.0213, 'lps'),
	(482061, 126, '2015-04-01 00:33:47.000000', 'consum', 0.0214, 'lps'),
	(482062, 126, '2015-04-01 00:33:48.000000', 'consum', 0.0220, 'lps'),
	(482063, 126, '2015-04-01 00:33:49.000000', 'consum', 0.0212, 'lps'),
	(482064, 126, '2015-04-01 00:33:50.000000', 'consum', 0.0211, 'lps'),
	(482065, 126, '2015-04-01 00:33:51.000000', 'consum', 0.0225, 'lps'),
	(482066, 126, '2015-04-01 00:33:52.000000', 'consum', 0.0210, 'lps'),
	(482067, 126, '2015-04-01 00:33:53.000000', 'consum', 0.0219, 'lps'),
	(482068, 126, '2015-04-01 00:33:54.000000', 'consum', 0.0219, 'lps'),
	(482069, 126, '2015-04-01 00:33:55.000000', 'consum', 0.0210, 'lps'),
	(482070, 126, '2015-04-01 00:33:56.000000', 'consum', 0.0219, 'lps'),
	(482071, 126, '2015-04-01 00:33:57.000000', 'consum', 0.0223, 'lps'),
	(482072, 126, '2015-04-01 00:33:58.000000', 'consum', 0.0227, 'lps'),
	(482073, 126, '2015-04-01 00:33:59.000000', 'consum', 0.0223, 'lps'),
	(482074, 126, '2015-04-01 00:34:00.000000', 'consum', 0.0225, 'lps'),
	(482075, 126, '2015-04-01 00:34:01.000000', 'consum', 0.0226, 'lps'),
	(482076, 126, '2015-04-01 00:34:02.000000', 'consum', 0.0212, 'lps'),
	(482077, 126, '2015-04-01 00:34:03.000000', 'consum', 0.0224, 'lps'),
	(482078, 126, '2015-04-01 00:34:04.000000', 'consum', 0.0220, 'lps'),
	(482079, 126, '2015-04-01 00:34:05.000000', 'consum', 0.0218, 'lps'),
	(482080, 126, '2015-04-01 00:34:06.000000', 'consum', 0.0221, 'lps'),
	(482081, 126, '2015-04-01 00:34:07.000000', 'consum', 0.0226, 'lps'),
	(482082, 126, '2015-04-01 00:34:08.000000', 'consum', 0.0218, 'lps'),
	(482083, 126, '2015-04-01 00:34:09.000000', 'consum', 0.0224, 'lps'),
	(482084, 126, '2015-04-01 00:34:10.000000', 'consum', 0.0219, 'lps'),
	(482085, 126, '2015-04-01 00:34:11.000000', 'consum', 0.0212, 'lps'),
	(482086, 126, '2015-04-01 00:34:12.000000', 'consum', 0.0214, 'lps'),
	(482087, 126, '2015-04-01 00:34:13.000000', 'consum', 0.0223, 'lps'),
	(482088, 126, '2015-04-01 00:34:14.000000', 'consum', 0.0210, 'lps'),
	(482089, 126, '2015-04-01 00:34:15.000000', 'consum', 0.0224, 'lps'),
	(482090, 126, '2015-04-01 00:34:16.000000', 'consum', 0.0226, 'lps'),
	(482091, 126, '2015-04-01 00:34:17.000000', 'consum', 0.0213, 'lps'),
	(482092, 126, '2015-04-01 00:34:18.000000', 'consum', 0.0213, 'lps'),
	(482093, 126, '2015-04-01 00:34:19.000000', 'consum', 0.0217, 'lps'),
	(482094, 126, '2015-04-01 00:34:20.000000', 'consum', 0.0217, 'lps'),
	(482095, 126, '2015-04-01 00:34:21.000000', 'consum', 0.0225, 'lps'),
	(482096, 126, '2015-04-01 00:34:22.000000', 'consum', 0.0210, 'lps'),
	(482097, 126, '2015-04-01 00:34:23.000000', 'consum', 0.0219, 'lps'),
	(482098, 126, '2015-04-01 00:34:24.000000', 'consum', 0.0219, 'lps'),
	(482099, 126, '2015-04-01 00:34:25.000000', 'consum', 0.0210, 'lps'),
	(482100, 126, '2015-04-01 00:34:26.000000', 'consum', 0.0220, 'lps'),
	(482101, 126, '2015-04-01 00:34:27.000000', 'consum', 0.0226, 'lps'),
	(482102, 126, '2015-04-01 00:34:28.000000', 'consum', 0.0226, 'lps'),
	(482103, 126, '2015-04-01 00:34:29.000000', 'consum', 0.0222, 'lps'),
	(482104, 126, '2015-04-01 00:34:30.000000', 'consum', 0.0221, 'lps'),
	(482105, 126, '2015-04-01 00:34:31.000000', 'consum', 0.0214, 'lps'),
	(482106, 126, '2015-04-01 00:34:32.000000', 'consum', 0.0214, 'lps'),
	(482107, 126, '2015-04-01 00:34:33.000000', 'consum', 0.0217, 'lps'),
	(482108, 126, '2015-04-01 00:34:34.000000', 'consum', 0.0217, 'lps'),
	(482109, 126, '2015-04-01 00:34:35.000000', 'consum', 0.0223, 'lps'),
	(482110, 126, '2015-04-01 00:34:36.000000', 'consum', 0.0219, 'lps'),
	(482111, 126, '2015-04-01 00:34:37.000000', 'consum', 0.0216, 'lps'),
	(482112, 126, '2015-04-01 00:34:38.000000', 'consum', 0.0213, 'lps'),
	(482113, 126, '2015-04-01 00:34:39.000000', 'consum', 0.0225, 'lps'),
	(482114, 126, '2015-04-01 00:34:40.000000', 'consum', 0.0221, 'lps'),
	(482115, 126, '2015-04-01 00:34:41.000000', 'consum', 0.0224, 'lps'),
	(482116, 126, '2015-04-01 00:34:42.000000', 'consum', 0.0226, 'lps'),
	(482117, 126, '2015-04-01 00:34:43.000000', 'consum', 0.0216, 'lps'),
	(482118, 126, '2015-04-01 00:34:44.000000', 'consum', 0.0227, 'lps'),
	(482119, 126, '2015-04-01 00:34:45.000000', 'consum', 0.0224, 'lps'),
	(482120, 126, '2015-04-01 00:34:46.000000', 'consum', 0.0210, 'lps'),
	(482121, 126, '2015-04-01 00:34:47.000000', 'consum', 0.0225, 'lps'),
	(482122, 126, '2015-04-01 00:34:48.000000', 'consum', 0.0214, 'lps'),
	(482123, 126, '2015-04-01 00:34:49.000000', 'consum', 0.0219, 'lps'),
	(482124, 126, '2015-04-01 00:34:50.000000', 'consum', 0.0210, 'lps'),
	(482125, 126, '2015-04-01 00:34:51.000000', 'consum', 0.0219, 'lps'),
	(482126, 126, '2015-04-01 00:34:52.000000', 'consum', 0.0219, 'lps'),
	(482127, 126, '2015-04-01 00:34:53.000000', 'consum', 0.0211, 'lps'),
	(482128, 126, '2015-04-01 00:34:54.000000', 'consum', 0.0225, 'lps'),
	(482129, 126, '2015-04-01 00:34:55.000000', 'consum', 0.0226, 'lps'),
	(482130, 126, '2015-04-01 00:34:56.000000', 'consum', 0.0213, 'lps'),
	(482131, 126, '2015-04-01 00:34:57.000000', 'consum', 0.0211, 'lps'),
	(482132, 126, '2015-04-01 00:34:58.000000', 'consum', 0.0226, 'lps'),
	(482133, 126, '2015-04-01 00:34:59.000000', 'consum', 0.0215, 'lps'),
	(482134, 126, '2015-04-01 00:35:00.000000', 'consum', 0.0225, 'lps'),
	(482135, 126, '2015-04-01 00:35:01.000000', 'consum', 0.0214, 'lps'),
	(482136, 126, '2015-04-01 00:35:02.000000', 'consum', 0.0222, 'lps'),
	(482137, 126, '2015-04-01 00:35:03.000000', 'consum', 0.0224, 'lps'),
	(482138, 126, '2015-04-01 00:35:04.000000', 'consum', 0.0227, 'lps'),
	(482139, 126, '2015-04-01 00:35:05.000000', 'consum', 0.0218, 'lps'),
	(482140, 126, '2015-04-01 00:35:06.000000', 'consum', 0.0218, 'lps'),
	(482141, 126, '2015-04-01 00:35:07.000000', 'consum', 0.0225, 'lps'),
	(482142, 126, '2015-04-01 00:35:08.000000', 'consum', 0.0225, 'lps'),
	(482143, 126, '2015-04-01 00:35:09.000000', 'consum', 0.0223, 'lps'),
	(482144, 126, '2015-04-01 00:35:10.000000', 'consum', 0.0212, 'lps'),
	(482145, 126, '2015-04-01 00:35:11.000000', 'consum', 0.0218, 'lps'),
	(482146, 126, '2015-04-01 00:35:12.000000', 'consum', 0.0225, 'lps'),
	(482147, 126, '2015-04-01 00:35:13.000000', 'consum', 0.0227, 'lps'),
	(482148, 126, '2015-04-01 00:35:14.000000', 'consum', 0.0216, 'lps'),
	(482149, 126, '2015-04-01 00:35:15.000000', 'consum', 0.0222, 'lps'),
	(482150, 126, '2015-04-01 00:35:16.000000', 'consum', 0.0219, 'lps'),
	(482151, 126, '2015-04-01 00:35:17.000000', 'consum', 0.0219, 'lps'),
	(482152, 126, '2015-04-01 00:35:18.000000', 'consum', 0.0226, 'lps'),
	(482153, 126, '2015-04-01 00:35:19.000000', 'consum', 0.0212, 'lps'),
	(482154, 126, '2015-04-01 00:35:20.000000', 'consum', 0.0210, 'lps'),
	(482155, 126, '2015-04-01 00:35:21.000000', 'consum', 0.0220, 'lps'),
	(482156, 126, '2015-04-01 00:35:22.000000', 'consum', 0.0226, 'lps'),
	(482157, 126, '2015-04-01 00:35:23.000000', 'consum', 0.0223, 'lps'),
	(482158, 126, '2015-04-01 00:35:24.000000', 'consum', 0.0211, 'lps'),
	(482159, 126, '2015-04-01 00:35:25.000000', 'consum', 0.0211, 'lps'),
	(482160, 126, '2015-04-01 00:35:26.000000', 'consum', 0.0212, 'lps'),
	(482161, 126, '2015-04-01 00:35:27.000000', 'consum', 0.0219, 'lps'),
	(482162, 126, '2015-04-01 00:35:28.000000', 'consum', 0.0214, 'lps'),
	(482163, 126, '2015-04-01 00:35:29.000000', 'consum', 0.0221, 'lps'),
	(482164, 126, '2015-04-01 00:35:30.000000', 'consum', 0.0216, 'lps'),
	(482165, 126, '2015-04-01 00:35:31.000000', 'consum', 0.0226, 'lps'),
	(482166, 126, '2015-04-01 00:35:32.000000', 'consum', 0.0221, 'lps'),
	(482167, 126, '2015-04-01 00:35:33.000000', 'consum', 0.0214, 'lps'),
	(482168, 126, '2015-04-01 00:35:34.000000', 'consum', 0.0218, 'lps'),
	(482169, 126, '2015-04-01 00:35:35.000000', 'consum', 0.0218, 'lps'),
	(482170, 126, '2015-04-01 00:35:36.000000', 'consum', 0.0227, 'lps'),
	(482171, 126, '2015-04-01 00:35:37.000000', 'consum', 0.0217, 'lps'),
	(482172, 126, '2015-04-01 00:35:38.000000', 'consum', 0.0212, 'lps'),
	(482173, 126, '2015-04-01 00:35:39.000000', 'consum', 0.0217, 'lps'),
	(482174, 126, '2015-04-01 00:35:40.000000', 'consum', 0.0221, 'lps'),
	(482175, 126, '2015-04-01 00:35:41.000000', 'consum', 0.0211, 'lps'),
	(482176, 126, '2015-04-01 00:35:42.000000', 'consum', 0.0219, 'lps'),
	(482177, 126, '2015-04-01 00:35:43.000000', 'consum', 0.0215, 'lps'),
	(482178, 126, '2015-04-01 00:35:44.000000', 'consum', 0.0210, 'lps'),
	(482179, 126, '2015-04-01 00:35:45.000000', 'consum', 0.0212, 'lps'),
	(482180, 126, '2015-04-01 00:35:46.000000', 'consum', 0.0219, 'lps'),
	(482181, 126, '2015-04-01 00:35:47.000000', 'consum', 0.0214, 'lps'),
	(482182, 126, '2015-04-01 00:35:48.000000', 'consum', 0.0224, 'lps'),
	(482183, 126, '2015-04-01 00:35:49.000000', 'consum', 0.0212, 'lps'),
	(482184, 126, '2015-04-01 00:35:50.000000', 'consum', 0.0215, 'lps'),
	(482185, 126, '2015-04-01 00:35:51.000000', 'consum', 0.0211, 'lps'),
	(482186, 126, '2015-04-01 00:35:52.000000', 'consum', 0.0219, 'lps'),
	(482187, 126, '2015-04-01 00:35:53.000000', 'consum', 0.0218, 'lps'),
	(482188, 126, '2015-04-01 00:35:54.000000', 'consum', 0.0223, 'lps'),
	(482189, 126, '2015-04-01 00:35:55.000000', 'consum', 0.0213, 'lps'),
	(482190, 126, '2015-04-01 00:35:56.000000', 'consum', 0.0225, 'lps'),
	(482191, 126, '2015-04-01 00:35:57.000000', 'consum', 0.0220, 'lps'),
	(482192, 126, '2015-04-01 00:35:58.000000', 'consum', 0.0218, 'lps'),
	(482193, 126, '2015-04-01 00:35:59.000000', 'consum', 0.0221, 'lps'),
	(482194, 126, '2015-04-01 00:36:00.000000', 'consum', 0.0222, 'lps'),
	(482195, 126, '2015-04-01 00:36:01.000000', 'consum', 0.0220, 'lps'),
	(482196, 126, '2015-04-01 00:36:02.000000', 'consum', 0.0223, 'lps'),
	(482197, 126, '2015-04-01 00:36:03.000000', 'consum', 0.0227, 'lps'),
	(482198, 126, '2015-04-01 00:36:04.000000', 'consum', 0.0220, 'lps'),
	(482199, 126, '2015-04-01 00:36:05.000000', 'consum', 0.0210, 'lps'),
	(482200, 126, '2015-04-01 00:36:06.000000', 'consum', 0.0217, 'lps'),
	(482201, 126, '2015-04-01 00:36:07.000000', 'consum', 0.0211, 'lps'),
	(482202, 126, '2015-04-01 00:36:08.000000', 'consum', 0.0210, 'lps'),
	(482203, 126, '2015-04-01 00:36:09.000000', 'consum', 0.0227, 'lps'),
	(482204, 126, '2015-04-01 00:36:10.000000', 'consum', 0.0223, 'lps'),
	(482205, 126, '2015-04-01 00:36:11.000000', 'consum', 0.0226, 'lps'),
	(482206, 126, '2015-04-01 00:36:12.000000', 'consum', 0.0214, 'lps'),
	(482207, 126, '2015-04-01 00:36:13.000000', 'consum', 0.0220, 'lps'),
	(482208, 126, '2015-04-01 00:36:14.000000', 'consum', 0.0214, 'lps'),
	(482209, 126, '2015-04-01 00:36:15.000000', 'consum', 0.0216, 'lps'),
	(482210, 126, '2015-04-01 00:36:16.000000', 'consum', 0.0210, 'lps'),
	(482211, 126, '2015-04-01 00:36:17.000000', 'consum', 0.0210, 'lps'),
	(482212, 126, '2015-04-01 00:36:18.000000', 'consum', 0.0212, 'lps'),
	(482213, 126, '2015-04-01 00:36:19.000000', 'consum', 0.0221, 'lps'),
	(482214, 126, '2015-04-01 00:36:20.000000', 'consum', 0.0224, 'lps'),
	(482215, 126, '2015-04-01 00:36:21.000000', 'consum', 0.0210, 'lps'),
	(482216, 126, '2015-04-01 00:36:22.000000', 'consum', 0.0223, 'lps'),
	(482217, 126, '2015-04-01 00:36:23.000000', 'consum', 0.0223, 'lps'),
	(482218, 126, '2015-04-01 00:36:24.000000', 'consum', 0.0216, 'lps'),
	(482219, 126, '2015-04-01 00:36:25.000000', 'consum', 0.0220, 'lps'),
	(482220, 126, '2015-04-01 00:36:26.000000', 'consum', 0.0226, 'lps'),
	(482221, 126, '2015-04-01 00:36:27.000000', 'consum', 0.0225, 'lps'),
	(482222, 126, '2015-04-01 00:36:28.000000', 'consum', 0.0218, 'lps'),
	(482223, 126, '2015-04-01 00:36:29.000000', 'consum', 0.0226, 'lps'),
	(482224, 126, '2015-04-01 00:36:30.000000', 'consum', 0.0227, 'lps'),
	(482225, 126, '2015-04-01 00:36:31.000000', 'consum', 0.0213, 'lps'),
	(482226, 126, '2015-04-01 00:36:32.000000', 'consum', 0.0211, 'lps'),
	(482227, 126, '2015-04-01 00:36:33.000000', 'consum', 0.0226, 'lps'),
	(482228, 126, '2015-04-01 00:36:34.000000', 'consum', 0.0215, 'lps'),
	(482229, 126, '2015-04-01 00:36:35.000000', 'consum', 0.0222, 'lps'),
	(482230, 126, '2015-04-01 00:36:36.000000', 'consum', 0.0221, 'lps'),
	(482231, 126, '2015-04-01 00:36:37.000000', 'consum', 0.0213, 'lps'),
	(482232, 126, '2015-04-01 00:36:38.000000', 'consum', 0.0226, 'lps'),
	(482233, 126, '2015-04-01 00:36:39.000000', 'consum', 0.0226, 'lps'),
	(482234, 126, '2015-04-01 00:36:40.000000', 'consum', 0.0227, 'lps'),
	(482235, 126, '2015-04-01 00:36:41.000000', 'consum', 0.0211, 'lps'),
	(482236, 126, '2015-04-01 00:36:42.000000', 'consum', 0.0217, 'lps'),
	(482237, 126, '2015-04-01 00:36:43.000000', 'consum', 0.0226, 'lps'),
	(482238, 126, '2015-04-01 00:36:44.000000', 'consum', 0.0217, 'lps'),
	(482239, 126, '2015-04-01 00:36:45.000000', 'consum', 0.0213, 'lps'),
	(482240, 126, '2015-04-01 00:36:46.000000', 'consum', 0.0223, 'lps'),
	(482241, 126, '2015-04-01 00:36:47.000000', 'consum', 0.0213, 'lps'),
	(482242, 126, '2015-04-01 00:36:48.000000', 'consum', 0.0221, 'lps'),
	(482243, 126, '2015-04-01 00:36:49.000000', 'consum', 0.0220, 'lps'),
	(482244, 126, '2015-04-01 00:36:50.000000', 'consum', 0.0210, 'lps'),
	(482245, 126, '2015-04-01 00:36:51.000000', 'consum', 0.0218, 'lps'),
	(482246, 126, '2015-04-01 00:36:52.000000', 'consum', 0.0216, 'lps'),
	(482247, 126, '2015-04-01 00:36:53.000000', 'consum', 0.0213, 'lps'),
	(482248, 126, '2015-04-01 00:36:54.000000', 'consum', 0.0227, 'lps'),
	(482249, 126, '2015-04-01 00:36:55.000000', 'consum', 0.0216, 'lps'),
	(482250, 126, '2015-04-01 00:36:56.000000', 'consum', 0.0227, 'lps'),
	(482251, 126, '2015-04-01 00:36:57.000000', 'consum', 0.0220, 'lps'),
	(482252, 126, '2015-04-01 00:36:58.000000', 'consum', 0.0227, 'lps'),
	(482253, 126, '2015-04-01 00:36:59.000000', 'consum', 0.0211, 'lps'),
	(482254, 126, '2015-04-01 00:37:00.000000', 'consum', 0.0220, 'lps'),
	(482255, 126, '2015-04-01 00:37:01.000000', 'consum', 0.0222, 'lps'),
	(482256, 126, '2015-04-01 00:37:02.000000', 'consum', 0.0223, 'lps'),
	(482257, 126, '2015-04-01 00:37:03.000000', 'consum', 0.0221, 'lps'),
	(482258, 126, '2015-04-01 00:37:04.000000', 'consum', 0.0226, 'lps'),
	(482259, 126, '2015-04-01 00:37:05.000000', 'consum', 0.0220, 'lps'),
	(482260, 126, '2015-04-01 00:37:06.000000', 'consum', 0.0213, 'lps'),
	(482261, 126, '2015-04-01 00:37:07.000000', 'consum', 0.0215, 'lps'),
	(482262, 126, '2015-04-01 00:37:08.000000', 'consum', 0.0226, 'lps'),
	(482263, 126, '2015-04-01 00:37:09.000000', 'consum', 0.0220, 'lps'),
	(482264, 126, '2015-04-01 00:37:10.000000', 'consum', 0.0214, 'lps'),
	(482265, 126, '2015-04-01 00:37:11.000000', 'consum', 0.0220, 'lps'),
	(482266, 126, '2015-04-01 00:37:12.000000', 'consum', 0.0210, 'lps'),
	(482267, 126, '2015-04-01 00:37:13.000000', 'consum', 0.0216, 'lps'),
	(482268, 126, '2015-04-01 00:37:14.000000', 'consum', 0.0222, 'lps'),
	(482269, 126, '2015-04-01 00:37:15.000000', 'consum', 0.0218, 'lps'),
	(482270, 126, '2015-04-01 00:37:16.000000', 'consum', 0.0212, 'lps'),
	(482271, 126, '2015-04-01 00:37:17.000000', 'consum', 0.0217, 'lps'),
	(482272, 126, '2015-04-01 00:37:18.000000', 'consum', 0.0223, 'lps'),
	(482273, 126, '2015-04-01 00:37:19.000000', 'consum', 0.0216, 'lps'),
	(482274, 126, '2015-04-01 00:37:20.000000', 'consum', 0.0221, 'lps'),
	(482275, 126, '2015-04-01 00:37:21.000000', 'consum', 0.0212, 'lps'),
	(482276, 126, '2015-04-01 00:37:22.000000', 'consum', 0.0222, 'lps'),
	(482277, 126, '2015-04-01 00:37:23.000000', 'consum', 0.0212, 'lps'),
	(482278, 126, '2015-04-01 00:37:24.000000', 'consum', 0.0220, 'lps'),
	(482279, 126, '2015-04-01 00:37:25.000000', 'consum', 0.0219, 'lps'),
	(482280, 126, '2015-04-01 00:37:26.000000', 'consum', 0.0224, 'lps'),
	(482281, 126, '2015-04-01 00:37:27.000000', 'consum', 0.0219, 'lps'),
	(482282, 126, '2015-04-01 00:37:28.000000', 'consum', 0.0213, 'lps'),
	(482283, 126, '2015-04-01 00:37:29.000000', 'consum', 0.0218, 'lps'),
	(482284, 126, '2015-04-01 00:37:30.000000', 'consum', 0.0221, 'lps'),
	(482285, 126, '2015-04-01 00:37:31.000000', 'consum', 0.0224, 'lps'),
	(482286, 126, '2015-04-01 00:37:32.000000', 'consum', 0.0213, 'lps'),
	(482287, 126, '2015-04-01 00:37:33.000000', 'consum', 0.0220, 'lps'),
	(482288, 126, '2015-04-01 00:37:34.000000', 'consum', 0.0214, 'lps'),
	(482289, 126, '2015-04-01 00:37:35.000000', 'consum', 0.0218, 'lps'),
	(482290, 126, '2015-04-01 00:37:36.000000', 'consum', 0.0220, 'lps'),
	(482291, 126, '2015-04-01 00:37:37.000000', 'consum', 0.0218, 'lps'),
	(482292, 126, '2015-04-01 00:37:38.000000', 'consum', 0.0222, 'lps'),
	(482293, 126, '2015-04-01 00:37:39.000000', 'consum', 0.0210, 'lps'),
	(482294, 126, '2015-04-01 00:37:40.000000', 'consum', 0.0213, 'lps'),
	(482295, 126, '2015-04-01 00:37:41.000000', 'consum', 0.0222, 'lps'),
	(482296, 126, '2015-04-01 00:37:42.000000', 'consum', 0.0210, 'lps'),
	(482297, 126, '2015-04-01 00:37:43.000000', 'consum', 0.0210, 'lps'),
	(482298, 126, '2015-04-01 00:37:44.000000', 'consum', 0.0226, 'lps'),
	(482299, 126, '2015-04-01 00:37:45.000000', 'consum', 0.0221, 'lps'),
	(482300, 126, '2015-04-01 00:37:46.000000', 'consum', 0.0219, 'lps'),
	(482301, 126, '2015-04-01 00:37:47.000000', 'consum', 0.0221, 'lps'),
	(482302, 126, '2015-04-01 00:37:48.000000', 'consum', 0.0219, 'lps'),
	(482303, 126, '2015-04-01 00:37:49.000000', 'consum', 0.0223, 'lps'),
	(482304, 126, '2015-04-01 00:37:50.000000', 'consum', 0.0212, 'lps'),
	(482305, 126, '2015-04-01 00:37:51.000000', 'consum', 0.0216, 'lps'),
	(482306, 126, '2015-04-01 00:37:52.000000', 'consum', 0.0218, 'lps'),
	(482307, 126, '2015-04-01 00:37:53.000000', 'consum', 0.0216, 'lps'),
	(482308, 126, '2015-04-01 00:37:54.000000', 'consum', 0.0215, 'lps'),
	(482309, 126, '2015-04-01 00:37:55.000000', 'consum', 0.0220, 'lps'),
	(482310, 126, '2015-04-01 00:37:56.000000', 'consum', 0.0225, 'lps'),
	(482311, 126, '2015-04-01 00:37:57.000000', 'consum', 0.0219, 'lps'),
	(482312, 126, '2015-04-01 00:37:58.000000', 'consum', 0.0212, 'lps'),
	(482313, 126, '2015-04-01 00:37:59.000000', 'consum', 0.0211, 'lps'),
	(482314, 126, '2015-04-01 00:38:00.000000', 'consum', 0.0226, 'lps'),
	(482315, 126, '2015-04-01 00:38:01.000000', 'consum', 0.0215, 'lps'),
	(482316, 126, '2015-04-01 00:38:02.000000', 'consum', 0.0225, 'lps'),
	(482317, 126, '2015-04-01 00:38:03.000000', 'consum', 0.0215, 'lps'),
	(482318, 126, '2015-04-01 00:38:04.000000', 'consum', 0.0211, 'lps'),
	(482319, 126, '2015-04-01 00:38:05.000000', 'consum', 0.0217, 'lps'),
	(482320, 126, '2015-04-01 00:38:06.000000', 'consum', 0.0226, 'lps'),
	(482321, 126, '2015-04-01 00:38:07.000000', 'consum', 0.0213, 'lps'),
	(482322, 126, '2015-04-01 00:38:08.000000', 'consum', 0.0216, 'lps'),
	(482323, 126, '2015-04-01 00:38:09.000000', 'consum', 0.0211, 'lps'),
	(482324, 126, '2015-04-01 00:38:10.000000', 'consum', 0.0215, 'lps'),
	(482325, 126, '2015-04-01 00:38:11.000000', 'consum', 0.0216, 'lps'),
	(482326, 126, '2015-04-01 00:38:12.000000', 'consum', 0.0226, 'lps'),
	(482327, 126, '2015-04-01 00:38:13.000000', 'consum', 0.0218, 'lps'),
	(482328, 126, '2015-04-01 00:38:14.000000', 'consum', 0.0220, 'lps'),
	(482329, 126, '2015-04-01 00:38:15.000000', 'consum', 0.0221, 'lps'),
	(482330, 126, '2015-04-01 00:38:16.000000', 'consum', 0.0214, 'lps'),
	(482331, 126, '2015-04-01 00:38:17.000000', 'consum', 0.0217, 'lps'),
	(482332, 126, '2015-04-01 00:38:18.000000', 'consum', 0.0216, 'lps'),
	(482333, 126, '2015-04-01 00:38:19.000000', 'consum', 0.0218, 'lps'),
	(482334, 126, '2015-04-01 00:38:20.000000', 'consum', 0.0216, 'lps'),
	(482335, 126, '2015-04-01 00:38:21.000000', 'consum', 0.0214, 'lps'),
	(482336, 126, '2015-04-01 00:38:22.000000', 'consum', 0.0213, 'lps'),
	(482337, 126, '2015-04-01 00:38:23.000000', 'consum', 0.0216, 'lps'),
	(482338, 126, '2015-04-01 00:38:24.000000', 'consum', 0.0211, 'lps'),
	(482339, 126, '2015-04-01 00:38:25.000000', 'consum', 0.0218, 'lps'),
	(482340, 126, '2015-04-01 00:38:26.000000', 'consum', 0.0227, 'lps'),
	(482341, 126, '2015-04-01 00:38:27.000000', 'consum', 0.0220, 'lps'),
	(482342, 126, '2015-04-01 00:38:28.000000', 'consum', 0.0224, 'lps'),
	(482343, 126, '2015-04-01 00:38:29.000000', 'consum', 0.0218, 'lps'),
	(482344, 126, '2015-04-01 00:38:30.000000', 'consum', 0.0227, 'lps'),
	(482345, 126, '2015-04-01 00:38:31.000000', 'consum', 0.0215, 'lps'),
	(482346, 126, '2015-04-01 00:38:32.000000', 'consum', 0.0220, 'lps'),
	(482347, 126, '2015-04-01 00:38:33.000000', 'consum', 0.0211, 'lps'),
	(482348, 126, '2015-04-01 00:38:34.000000', 'consum', 0.0221, 'lps'),
	(482349, 126, '2015-04-01 00:38:35.000000', 'consum', 0.0225, 'lps'),
	(482350, 126, '2015-04-01 00:38:36.000000', 'consum', 0.0217, 'lps'),
	(482351, 126, '2015-04-01 00:38:37.000000', 'consum', 0.0219, 'lps'),
	(482352, 126, '2015-04-01 00:38:38.000000', 'consum', 0.0218, 'lps'),
	(482353, 126, '2015-04-01 00:38:39.000000', 'consum', 0.0222, 'lps'),
	(482354, 126, '2015-04-01 00:38:40.000000', 'consum', 0.0210, 'lps'),
	(482355, 126, '2015-04-01 00:38:41.000000', 'consum', 0.0211, 'lps'),
	(482356, 126, '2015-04-01 00:38:42.000000', 'consum', 0.0214, 'lps'),
	(482357, 126, '2015-04-01 00:38:43.000000', 'consum', 0.0212, 'lps'),
	(482358, 126, '2015-04-01 00:38:44.000000', 'consum', 0.0226, 'lps'),
	(482359, 126, '2015-04-01 00:38:45.000000', 'consum', 0.0211, 'lps'),
	(482360, 126, '2015-04-01 00:38:46.000000', 'consum', 0.0223, 'lps'),
	(482361, 126, '2015-04-01 00:38:47.000000', 'consum', 0.0219, 'lps'),
	(482362, 126, '2015-04-01 00:38:48.000000', 'consum', 0.0214, 'lps'),
	(482363, 126, '2015-04-01 00:38:49.000000', 'consum', 0.0224, 'lps'),
	(482364, 126, '2015-04-01 00:38:50.000000', 'consum', 0.0212, 'lps'),
	(482365, 126, '2015-04-01 00:38:51.000000', 'consum', 0.0217, 'lps'),
	(482366, 126, '2015-04-01 00:38:52.000000', 'consum', 0.0220, 'lps'),
	(482367, 126, '2015-04-01 00:38:53.000000', 'consum', 0.0221, 'lps'),
	(482368, 126, '2015-04-01 00:38:54.000000', 'consum', 0.0217, 'lps'),
	(482369, 126, '2015-04-01 00:38:55.000000', 'consum', 0.0214, 'lps'),
	(482370, 126, '2015-04-01 00:38:56.000000', 'consum', 0.0227, 'lps'),
	(482371, 126, '2015-04-01 00:38:57.000000', 'consum', 0.0212, 'lps'),
	(482372, 126, '2015-04-01 00:38:58.000000', 'consum', 0.0225, 'lps'),
	(482373, 126, '2015-04-01 00:38:59.000000', 'consum', 0.0223, 'lps'),
	(482374, 126, '2015-04-01 00:39:00.000000', 'consum', 0.0215, 'lps'),
	(482375, 126, '2015-04-01 00:39:01.000000', 'consum', 0.0212, 'lps'),
	(482376, 126, '2015-04-01 00:39:02.000000', 'consum', 0.0224, 'lps'),
	(482377, 126, '2015-04-01 00:39:03.000000', 'consum', 0.0220, 'lps'),
	(482378, 126, '2015-04-01 00:39:04.000000', 'consum', 0.0220, 'lps'),
	(482379, 126, '2015-04-01 00:39:05.000000', 'consum', 0.0210, 'lps'),
	(482380, 126, '2015-04-01 00:39:06.000000', 'consum', 0.0218, 'lps'),
	(482381, 126, '2015-04-01 00:39:07.000000', 'consum', 0.0215, 'lps'),
	(482382, 126, '2015-04-01 00:39:08.000000', 'consum', 0.0212, 'lps'),
	(482383, 126, '2015-04-01 00:39:09.000000', 'consum', 0.0223, 'lps'),
	(482384, 126, '2015-04-01 00:39:10.000000', 'consum', 0.0214, 'lps'),
	(482385, 126, '2015-04-01 00:39:11.000000', 'consum', 0.0211, 'lps'),
	(482386, 126, '2015-04-01 00:39:12.000000', 'consum', 0.0219, 'lps'),
	(482387, 126, '2015-04-01 00:39:13.000000', 'consum', 0.0219, 'lps'),
	(482388, 126, '2015-04-01 00:39:14.000000', 'consum', 0.0227, 'lps'),
	(482389, 126, '2015-04-01 00:39:15.000000', 'consum', 0.0217, 'lps'),
	(482390, 126, '2015-04-01 00:39:16.000000', 'consum', 0.0210, 'lps'),
	(482391, 126, '2015-04-01 00:39:17.000000', 'consum', 0.0227, 'lps'),
	(482392, 126, '2015-04-01 00:39:18.000000', 'consum', 0.0224, 'lps'),
	(482393, 126, '2015-04-01 00:39:19.000000', 'consum', 0.0212, 'lps'),
	(482394, 126, '2015-04-01 00:39:20.000000', 'consum', 0.0212, 'lps'),
	(482395, 126, '2015-04-01 00:39:21.000000', 'consum', 0.0217, 'lps'),
	(482396, 126, '2015-04-01 00:39:22.000000', 'consum', 0.0219, 'lps'),
	(482397, 126, '2015-04-01 00:39:23.000000', 'consum', 0.0218, 'lps'),
	(482398, 126, '2015-04-01 00:39:24.000000', 'consum', 0.0222, 'lps'),
	(482399, 126, '2015-04-01 00:39:25.000000', 'consum', 0.0212, 'lps'),
	(482400, 126, '2015-04-01 00:39:26.000000', 'consum', 0.0218, 'lps'),
	(482401, 126, '2015-04-01 00:39:27.000000', 'consum', 0.0210, 'lps'),
	(482402, 126, '2015-04-01 00:39:28.000000', 'consum', 0.0224, 'lps'),
	(482403, 126, '2015-04-01 00:39:29.000000', 'consum', 0.0226, 'lps'),
	(482404, 126, '2015-04-01 00:39:30.000000', 'consum', 0.0212, 'lps'),
	(482405, 126, '2015-04-01 00:39:31.000000', 'consum', 0.0226, 'lps'),
	(482406, 126, '2015-04-01 00:39:32.000000', 'consum', 0.0211, 'lps'),
	(482407, 126, '2015-04-01 00:39:33.000000', 'consum', 0.0222, 'lps'),
	(482408, 126, '2015-04-01 00:39:34.000000', 'consum', 0.0213, 'lps'),
	(482409, 126, '2015-04-01 00:39:35.000000', 'consum', 0.0226, 'lps'),
	(482410, 126, '2015-04-01 00:39:36.000000', 'consum', 0.0227, 'lps'),
	(482411, 126, '2015-04-01 00:39:37.000000', 'consum', 0.0214, 'lps'),
	(482412, 126, '2015-04-01 00:39:38.000000', 'consum', 0.0214, 'lps'),
	(482413, 126, '2015-04-01 00:39:39.000000', 'consum', 0.0217, 'lps'),
	(482414, 126, '2015-04-01 00:39:40.000000', 'consum', 0.0219, 'lps'),
	(482415, 126, '2015-04-01 00:39:41.000000', 'consum', 0.0213, 'lps'),
	(482416, 126, '2015-04-01 00:39:42.000000', 'consum', 0.0217, 'lps'),
	(482417, 126, '2015-04-01 00:39:43.000000', 'consum', 0.0219, 'lps'),
	(482418, 126, '2015-04-01 00:39:44.000000', 'consum', 0.0216, 'lps'),
	(482419, 126, '2015-04-01 00:39:45.000000', 'consum', 0.0215, 'lps'),
	(482420, 126, '2015-04-01 00:39:46.000000', 'consum', 0.0215, 'lps'),
	(482421, 126, '2015-04-01 00:39:47.000000', 'consum', 0.0223, 'lps'),
	(482422, 126, '2015-04-01 00:39:48.000000', 'consum', 0.0223, 'lps'),
	(482423, 126, '2015-04-01 00:39:49.000000', 'consum', 0.0219, 'lps'),
	(482424, 126, '2015-04-01 00:39:50.000000', 'consum', 0.0215, 'lps'),
	(482425, 126, '2015-04-01 00:39:51.000000', 'consum', 0.0227, 'lps'),
	(482426, 126, '2015-04-01 00:39:52.000000', 'consum', 0.0227, 'lps'),
	(482427, 126, '2015-04-01 00:39:53.000000', 'consum', 0.0225, 'lps'),
	(482428, 126, '2015-04-01 00:39:54.000000', 'consum', 0.0217, 'lps'),
	(482429, 126, '2015-04-01 00:39:55.000000', 'consum', 0.0220, 'lps'),
	(482430, 126, '2015-04-01 00:39:56.000000', 'consum', 0.0221, 'lps'),
	(482431, 126, '2015-04-01 00:39:57.000000', 'consum', 0.0215, 'lps'),
	(482432, 126, '2015-04-01 00:39:58.000000', 'consum', 0.0223, 'lps'),
	(482433, 126, '2015-04-01 00:39:59.000000', 'consum', 0.0224, 'lps'),
	(482434, 126, '2015-04-01 00:40:00.000000', 'consum', 0.0223, 'lps'),
	(482435, 126, '2015-04-01 00:40:01.000000', 'consum', 0.0215, 'lps'),
	(482436, 126, '2015-04-01 00:40:02.000000', 'consum', 0.0216, 'lps'),
	(482437, 126, '2015-04-01 00:40:03.000000', 'consum', 0.0226, 'lps'),
	(482438, 126, '2015-04-01 00:40:04.000000', 'consum', 0.0216, 'lps'),
	(482439, 126, '2015-04-01 00:40:05.000000', 'consum', 0.0212, 'lps'),
	(482440, 126, '2015-04-01 00:40:06.000000', 'consum', 0.0219, 'lps'),
	(482441, 126, '2015-04-01 00:40:07.000000', 'consum', 0.0214, 'lps'),
	(482442, 126, '2015-04-01 00:40:08.000000', 'consum', 0.0224, 'lps'),
	(482443, 126, '2015-04-01 00:40:09.000000', 'consum', 0.0212, 'lps'),
	(482444, 126, '2015-04-01 00:40:10.000000', 'consum', 0.0215, 'lps'),
	(482445, 126, '2015-04-01 00:40:11.000000', 'consum', 0.0210, 'lps'),
	(482446, 126, '2015-04-01 00:40:12.000000', 'consum', 0.0213, 'lps'),
	(482447, 126, '2015-04-01 00:40:13.000000', 'consum', 0.0227, 'lps'),
	(482448, 126, '2015-04-01 00:40:14.000000', 'consum', 0.0215, 'lps'),
	(482449, 126, '2015-04-01 00:40:15.000000', 'consum', 0.0219, 'lps'),
	(482450, 126, '2015-04-01 00:40:16.000000', 'consum', 0.0222, 'lps'),
	(482451, 126, '2015-04-01 00:40:17.000000', 'consum', 0.0210, 'lps'),
	(482452, 126, '2015-04-01 00:40:18.000000', 'consum', 0.0211, 'lps'),
	(482453, 126, '2015-04-01 00:40:19.000000', 'consum', 0.0214, 'lps'),
	(482454, 126, '2015-04-01 00:40:20.000000', 'consum', 0.0210, 'lps'),
	(482455, 126, '2015-04-01 00:40:21.000000', 'consum', 0.0216, 'lps'),
	(482456, 126, '2015-04-01 00:40:22.000000', 'consum', 0.0223, 'lps'),
	(482457, 126, '2015-04-01 00:40:23.000000', 'consum', 0.0221, 'lps'),
	(482458, 126, '2015-04-01 00:40:24.000000', 'consum', 0.0227, 'lps'),
	(482459, 126, '2015-04-01 00:40:25.000000', 'consum', 0.0226, 'lps'),
	(482460, 126, '2015-04-01 00:40:26.000000', 'consum', 0.0222, 'lps'),
	(482461, 126, '2015-04-01 00:40:27.000000', 'consum', 0.0221, 'lps'),
	(482462, 126, '2015-04-01 00:40:28.000000', 'consum', 0.0214, 'lps'),
	(482463, 126, '2015-04-01 00:40:29.000000', 'consum', 0.0216, 'lps'),
	(482464, 126, '2015-04-01 00:40:30.000000', 'consum', 0.0226, 'lps'),
	(482465, 126, '2015-04-01 00:40:31.000000', 'consum', 0.0220, 'lps'),
	(482466, 126, '2015-04-01 00:40:32.000000', 'consum', 0.0212, 'lps'),
	(482467, 126, '2015-04-01 00:40:33.000000', 'consum', 0.0211, 'lps'),
	(482468, 126, '2015-04-01 00:40:34.000000', 'consum', 0.0224, 'lps'),
	(482469, 126, '2015-04-01 00:40:35.000000', 'consum', 0.0225, 'lps'),
	(482470, 126, '2015-04-01 00:40:36.000000', 'consum', 0.0226, 'lps'),
	(482471, 126, '2015-04-01 00:40:37.000000', 'consum', 0.0210, 'lps'),
	(482472, 126, '2015-04-01 00:40:38.000000', 'consum', 0.0217, 'lps'),
	(482473, 126, '2015-04-01 00:40:39.000000', 'consum', 0.0225, 'lps'),
	(482474, 126, '2015-04-01 00:40:40.000000', 'consum', 0.0211, 'lps'),
	(482475, 126, '2015-04-01 00:40:41.000000', 'consum', 0.0225, 'lps'),
	(482476, 126, '2015-04-01 00:40:42.000000', 'consum', 0.0211, 'lps'),
	(482477, 126, '2015-04-01 00:40:43.000000', 'consum', 0.0224, 'lps'),
	(482478, 126, '2015-04-01 00:40:44.000000', 'consum', 0.0223, 'lps'),
	(482479, 126, '2015-04-01 00:40:45.000000', 'consum', 0.0217, 'lps'),
	(482480, 126, '2015-04-01 00:40:46.000000', 'consum', 0.0222, 'lps'),
	(482481, 126, '2015-04-01 00:40:47.000000', 'consum', 0.0215, 'lps'),
	(482482, 126, '2015-04-01 00:40:48.000000', 'consum', 0.0218, 'lps'),
	(482483, 126, '2015-04-01 00:40:49.000000', 'consum', 0.0217, 'lps'),
	(482484, 126, '2015-04-01 00:40:50.000000', 'consum', 0.0223, 'lps'),
	(482485, 126, '2015-04-01 00:40:51.000000', 'consum', 0.0217, 'lps'),
	(482486, 126, '2015-04-01 00:40:52.000000', 'consum', 0.0224, 'lps'),
	(482487, 126, '2015-04-01 00:40:53.000000', 'consum', 0.0224, 'lps'),
	(482488, 126, '2015-04-01 00:40:54.000000', 'consum', 0.0221, 'lps'),
	(482489, 126, '2015-04-01 00:40:55.000000', 'consum', 0.0224, 'lps'),
	(482490, 126, '2015-04-01 00:40:56.000000', 'consum', 0.0210, 'lps'),
	(482491, 126, '2015-04-01 00:40:57.000000', 'consum', 0.0222, 'lps'),
	(482492, 126, '2015-04-01 00:40:58.000000', 'consum', 0.0218, 'lps'),
	(482493, 126, '2015-04-01 00:40:59.000000', 'consum', 0.0212, 'lps'),
	(482494, 126, '2015-04-01 00:41:00.000000', 'consum', 0.0217, 'lps'),
	(482495, 126, '2015-04-01 00:41:01.000000', 'consum', 0.0220, 'lps'),
	(482496, 126, '2015-04-01 00:41:02.000000', 'consum', 0.0223, 'lps'),
	(482497, 126, '2015-04-01 00:41:03.000000', 'consum', 0.0225, 'lps'),
	(482498, 126, '2015-04-01 00:41:04.000000', 'consum', 0.0214, 'lps'),
	(482499, 126, '2015-04-01 00:41:05.000000', 'consum', 0.0219, 'lps'),
	(482500, 126, '2015-04-01 00:41:06.000000', 'consum', 0.0210, 'lps'),
	(482501, 126, '2015-04-01 00:41:07.000000', 'consum', 0.0219, 'lps'),
	(482502, 126, '2015-04-01 00:41:08.000000', 'consum', 0.0217, 'lps'),
	(482503, 126, '2015-04-01 00:41:09.000000', 'consum', 0.0220, 'lps'),
	(482504, 126, '2015-04-01 00:41:10.000000', 'consum', 0.0221, 'lps'),
	(482505, 126, '2015-04-01 00:41:11.000000', 'consum', 0.0219, 'lps'),
	(482506, 126, '2015-04-01 00:41:12.000000', 'consum', 0.0223, 'lps'),
	(482507, 126, '2015-04-01 00:41:13.000000', 'consum', 0.0227, 'lps'),
	(482508, 126, '2015-04-01 00:41:14.000000', 'consum', 0.0224, 'lps'),
	(482509, 126, '2015-04-01 00:41:15.000000', 'consum', 0.0211, 'lps'),
	(482510, 126, '2015-04-01 00:41:16.000000', 'consum', 0.0227, 'lps'),
	(482511, 126, '2015-04-01 00:41:17.000000', 'consum', 0.0222, 'lps'),
	(482512, 126, '2015-04-01 00:41:18.000000', 'consum', 0.0219, 'lps'),
	(482513, 126, '2015-04-01 00:41:19.000000', 'consum', 0.0218, 'lps'),
	(482514, 126, '2015-04-01 00:41:20.000000', 'consum', 0.0225, 'lps'),
	(482515, 126, '2015-04-01 00:41:21.000000', 'consum', 0.0224, 'lps'),
	(482516, 126, '2015-04-01 00:41:22.000000', 'consum', 0.0217, 'lps'),
	(482517, 126, '2015-04-01 00:41:23.000000', 'consum', 0.0223, 'lps'),
	(482518, 126, '2015-04-01 00:41:24.000000', 'consum', 0.0219, 'lps'),
	(482519, 126, '2015-04-01 00:41:25.000000', 'consum', 0.0216, 'lps'),
	(482520, 126, '2015-04-01 00:41:26.000000', 'consum', 0.0213, 'lps'),
	(482521, 126, '2015-04-01 00:41:27.000000', 'consum', 0.0227, 'lps'),
	(482522, 126, '2015-04-01 00:41:28.000000', 'consum', 0.0213, 'lps'),
	(482523, 126, '2015-04-01 00:41:29.000000', 'consum', 0.0210, 'lps'),
	(482524, 126, '2015-04-01 00:41:30.000000', 'consum', 0.0220, 'lps'),
	(482525, 126, '2015-04-01 00:41:31.000000', 'consum', 0.0225, 'lps'),
	(482526, 126, '2015-04-01 00:41:32.000000', 'consum', 0.0220, 'lps'),
	(482527, 126, '2015-04-01 00:41:33.000000', 'consum', 0.0215, 'lps'),
	(482528, 126, '2015-04-01 00:41:34.000000', 'consum', 0.0226, 'lps'),
	(482529, 126, '2015-04-01 00:41:35.000000', 'consum', 0.0218, 'lps'),
	(482530, 126, '2015-04-01 00:41:36.000000', 'consum', 0.0222, 'lps'),
	(482531, 126, '2015-04-01 00:41:37.000000', 'consum', 0.0227, 'lps'),
	(482532, 126, '2015-04-01 00:41:38.000000', 'consum', 0.0225, 'lps'),
	(482533, 126, '2015-04-01 00:41:39.000000', 'consum', 0.0215, 'lps'),
	(482534, 126, '2015-04-01 00:41:40.000000', 'consum', 0.0227, 'lps'),
	(482535, 126, '2015-04-01 00:41:41.000000', 'consum', 0.0227, 'lps'),
	(482536, 126, '2015-04-01 00:41:42.000000', 'consum', 0.0210, 'lps'),
	(482537, 126, '2015-04-01 00:41:43.000000', 'consum', 0.0210, 'lps'),
	(482538, 126, '2015-04-01 00:41:44.000000', 'consum', 0.0213, 'lps'),
	(482539, 126, '2015-04-01 00:41:45.000000', 'consum', 0.0227, 'lps'),
	(482540, 126, '2015-04-01 00:41:46.000000', 'consum', 0.0212, 'lps'),
	(482541, 126, '2015-04-01 00:41:47.000000', 'consum', 0.0226, 'lps'),
	(482542, 126, '2015-04-01 00:41:48.000000', 'consum', 0.0213, 'lps'),
	(482543, 126, '2015-04-01 00:41:49.000000', 'consum', 0.0210, 'lps'),
	(482544, 126, '2015-04-01 00:41:50.000000', 'consum', 0.0222, 'lps'),
	(482545, 126, '2015-04-01 00:41:51.000000', 'consum', 0.0217, 'lps'),
	(482546, 126, '2015-04-01 00:41:52.000000', 'consum', 0.0210, 'lps'),
	(482547, 126, '2015-04-01 00:41:53.000000', 'consum', 0.0226, 'lps'),
	(482548, 126, '2015-04-01 00:41:54.000000', 'consum', 0.0216, 'lps'),
	(482549, 126, '2015-04-01 00:41:55.000000', 'consum', 0.0213, 'lps'),
	(482550, 126, '2015-04-01 00:41:56.000000', 'consum', 0.0224, 'lps'),
	(482551, 126, '2015-04-01 00:41:57.000000', 'consum', 0.0216, 'lps'),
	(482552, 126, '2015-04-01 00:41:58.000000', 'consum', 0.0218, 'lps'),
	(482553, 126, '2015-04-01 00:41:59.000000', 'consum', 0.0213, 'lps'),
	(482554, 126, '2015-04-01 00:42:00.000000', 'consum', 0.0220, 'lps'),
	(482555, 126, '2015-04-01 00:42:01.000000', 'consum', 0.0216, 'lps'),
	(482556, 126, '2015-04-01 00:42:02.000000', 'consum', 0.0212, 'lps'),
	(482557, 126, '2015-04-01 00:42:03.000000', 'consum', 0.0221, 'lps'),
	(482558, 126, '2015-04-01 00:42:04.000000', 'consum', 0.0221, 'lps'),
	(482559, 126, '2015-04-01 00:42:05.000000', 'consum', 0.0216, 'lps'),
	(482560, 126, '2015-04-01 00:42:06.000000', 'consum', 0.0226, 'lps'),
	(482561, 126, '2015-04-01 00:42:07.000000', 'consum', 0.0218, 'lps'),
	(482562, 126, '2015-04-01 00:42:08.000000', 'consum', 0.0221, 'lps'),
	(482563, 126, '2015-04-01 00:42:09.000000', 'consum', 0.0222, 'lps'),
	(482564, 126, '2015-04-01 00:42:10.000000', 'consum', 0.0221, 'lps'),
	(482565, 126, '2015-04-01 00:42:11.000000', 'consum', 0.0213, 'lps'),
	(482566, 126, '2015-04-01 00:42:12.000000', 'consum', 0.0225, 'lps'),
	(482567, 126, '2015-04-01 00:42:13.000000', 'consum', 0.0224, 'lps'),
	(482568, 126, '2015-04-01 00:42:14.000000', 'consum', 0.0217, 'lps'),
	(482569, 126, '2015-04-01 00:42:15.000000', 'consum', 0.0221, 'lps'),
	(482570, 126, '2015-04-01 00:42:16.000000', 'consum', 0.0210, 'lps'),
	(482571, 126, '2015-04-01 00:42:17.000000', 'consum', 0.0211, 'lps'),
	(482572, 126, '2015-04-01 00:42:18.000000', 'consum', 0.0216, 'lps'),
	(482573, 126, '2015-04-01 00:42:19.000000', 'consum', 0.0219, 'lps'),
	(482574, 126, '2015-04-01 00:42:20.000000', 'consum', 0.0220, 'lps'),
	(482575, 126, '2015-04-01 00:42:21.000000', 'consum', 0.0217, 'lps'),
	(482576, 126, '2015-04-01 00:42:22.000000', 'consum', 0.0214, 'lps'),
	(482577, 126, '2015-04-01 00:42:23.000000', 'consum', 0.0212, 'lps'),
	(482578, 126, '2015-04-01 00:42:24.000000', 'consum', 0.0223, 'lps'),
	(482579, 126, '2015-04-01 00:42:25.000000', 'consum', 0.0217, 'lps'),
	(482580, 126, '2015-04-01 00:42:26.000000', 'consum', 0.0225, 'lps'),
	(482581, 126, '2015-04-01 00:42:27.000000', 'consum', 0.0226, 'lps'),
	(482582, 126, '2015-04-01 00:42:28.000000', 'consum', 0.0213, 'lps'),
	(482583, 126, '2015-04-01 00:42:29.000000', 'consum', 0.0212, 'lps'),
	(482584, 126, '2015-04-01 00:42:30.000000', 'consum', 0.0211, 'lps'),
	(482585, 126, '2015-04-01 00:42:31.000000', 'consum', 0.0227, 'lps'),
	(482586, 126, '2015-04-01 00:42:32.000000', 'consum', 0.0220, 'lps'),
	(482587, 126, '2015-04-01 00:42:33.000000', 'consum', 0.0211, 'lps'),
	(482588, 126, '2015-04-01 00:42:34.000000', 'consum', 0.0222, 'lps'),
	(482589, 126, '2015-04-01 00:42:35.000000', 'consum', 0.0215, 'lps'),
	(482590, 126, '2015-04-01 00:42:36.000000', 'consum', 0.0215, 'lps'),
	(482591, 126, '2015-04-01 00:42:37.000000', 'consum', 0.0221, 'lps'),
	(482592, 126, '2015-04-01 00:42:38.000000', 'consum', 0.0214, 'lps'),
	(482593, 126, '2015-04-01 00:42:39.000000', 'consum', 0.0214, 'lps'),
	(482594, 126, '2015-04-01 00:42:40.000000', 'consum', 0.0221, 'lps'),
	(482595, 126, '2015-04-01 00:42:41.000000', 'consum', 0.0219, 'lps'),
	(482596, 126, '2015-04-01 00:42:42.000000', 'consum', 0.0220, 'lps'),
	(482597, 126, '2015-04-01 00:42:43.000000', 'consum', 0.0215, 'lps'),
	(482598, 126, '2015-04-01 00:42:44.000000', 'consum', 0.0226, 'lps'),
	(482599, 126, '2015-04-01 00:42:45.000000', 'consum', 0.0219, 'lps'),
	(482600, 126, '2015-04-01 00:42:46.000000', 'consum', 0.0226, 'lps'),
	(482601, 126, '2015-04-01 00:42:47.000000', 'consum', 0.0227, 'lps'),
	(482602, 126, '2015-04-01 00:42:48.000000', 'consum', 0.0211, 'lps'),
	(482603, 126, '2015-04-01 00:42:49.000000', 'consum', 0.0219, 'lps'),
	(482604, 126, '2015-04-01 00:42:50.000000', 'consum', 0.0215, 'lps'),
	(482605, 126, '2015-04-01 00:42:51.000000', 'consum', 0.0211, 'lps'),
	(482606, 126, '2015-04-01 00:42:52.000000', 'consum', 0.0216, 'lps'),
	(482607, 126, '2015-04-01 00:42:53.000000', 'consum', 0.0223, 'lps'),
	(482608, 126, '2015-04-01 00:42:54.000000', 'consum', 0.0219, 'lps'),
	(482609, 126, '2015-04-01 00:42:55.000000', 'consum', 0.0215, 'lps'),
	(482610, 126, '2015-04-01 00:42:56.000000', 'consum', 0.0210, 'lps'),
	(482611, 126, '2015-04-01 00:42:57.000000', 'consum', 0.0213, 'lps'),
	(482612, 126, '2015-04-01 00:42:58.000000', 'consum', 0.0210, 'lps'),
	(482613, 126, '2015-04-01 00:42:59.000000', 'consum', 0.0218, 'lps'),
	(482614, 126, '2015-04-01 00:43:00.000000', 'consum', 0.0214, 'lps'),
	(482615, 126, '2015-04-01 00:43:01.000000', 'consum', 0.0224, 'lps'),
	(482616, 126, '2015-04-01 00:43:02.000000', 'consum', 0.0215, 'lps'),
	(482617, 126, '2015-04-01 00:43:03.000000', 'consum', 0.0211, 'lps'),
	(482618, 126, '2015-04-01 00:43:04.000000', 'consum', 0.0217, 'lps'),
	(482619, 126, '2015-04-01 00:43:05.000000', 'consum', 0.0210, 'lps'),
	(482620, 126, '2015-04-01 00:43:06.000000', 'consum', 0.0222, 'lps'),
	(482621, 126, '2015-04-01 00:43:07.000000', 'consum', 0.0218, 'lps'),
	(482622, 126, '2015-04-01 00:43:08.000000', 'consum', 0.0215, 'lps'),
	(482623, 126, '2015-04-01 00:43:09.000000', 'consum', 0.0213, 'lps'),
	(482624, 126, '2015-04-01 00:43:10.000000', 'consum', 0.0226, 'lps'),
	(482625, 126, '2015-04-01 00:43:11.000000', 'consum', 0.0210, 'lps'),
	(482626, 126, '2015-04-01 00:43:12.000000', 'consum', 0.0217, 'lps'),
	(482627, 126, '2015-04-01 00:43:13.000000', 'consum', 0.0210, 'lps'),
	(482628, 126, '2015-04-01 00:43:14.000000', 'consum', 0.0226, 'lps'),
	(482629, 126, '2015-04-01 00:43:15.000000', 'consum', 0.0219, 'lps'),
	(482630, 126, '2015-04-01 00:43:16.000000', 'consum', 0.0224, 'lps'),
	(482631, 126, '2015-04-01 00:43:17.000000', 'consum', 0.0216, 'lps'),
	(482632, 126, '2015-04-01 00:43:18.000000', 'consum', 0.0219, 'lps'),
	(482633, 126, '2015-04-01 00:43:19.000000', 'consum', 0.0218, 'lps'),
	(482634, 126, '2015-04-01 00:43:20.000000', 'consum', 0.0222, 'lps'),
	(482635, 126, '2015-04-01 00:43:21.000000', 'consum', 0.0212, 'lps'),
	(482636, 126, '2015-04-01 00:43:22.000000', 'consum', 0.0222, 'lps'),
	(482637, 126, '2015-04-01 00:43:23.000000', 'consum', 0.0210, 'lps'),
	(482638, 126, '2015-04-01 00:43:24.000000', 'consum', 0.0227, 'lps'),
	(482639, 126, '2015-04-01 00:43:25.000000', 'consum', 0.0222, 'lps'),
	(482640, 126, '2015-04-01 00:43:26.000000', 'consum', 0.0223, 'lps'),
	(482641, 126, '2015-04-01 00:43:27.000000', 'consum', 0.0220, 'lps'),
	(482642, 126, '2015-04-01 00:43:28.000000', 'consum', 0.0222, 'lps'),
	(482643, 126, '2015-04-01 00:43:29.000000', 'consum', 0.0224, 'lps'),
	(482644, 126, '2015-04-01 00:43:30.000000', 'consum', 0.0225, 'lps'),
	(482645, 126, '2015-04-01 00:43:31.000000', 'consum', 0.0225, 'lps'),
	(482646, 126, '2015-04-01 00:43:32.000000', 'consum', 0.0223, 'lps'),
	(482647, 126, '2015-04-01 00:43:33.000000', 'consum', 0.0215, 'lps'),
	(482648, 126, '2015-04-01 00:43:34.000000', 'consum', 0.0211, 'lps'),
	(482649, 126, '2015-04-01 00:43:35.000000', 'consum', 0.0220, 'lps'),
	(482650, 126, '2015-04-01 00:43:36.000000', 'consum', 0.0220, 'lps'),
	(482651, 126, '2015-04-01 00:43:37.000000', 'consum', 0.0212, 'lps'),
	(482652, 126, '2015-04-01 00:43:38.000000', 'consum', 0.0226, 'lps'),
	(482653, 126, '2015-04-01 00:43:39.000000', 'consum', 0.0212, 'lps'),
	(482654, 126, '2015-04-01 00:43:40.000000', 'consum', 0.0211, 'lps'),
	(482655, 126, '2015-04-01 00:43:41.000000', 'consum', 0.0225, 'lps'),
	(482656, 126, '2015-04-01 00:43:42.000000', 'consum', 0.0210, 'lps'),
	(482657, 126, '2015-04-01 00:43:43.000000', 'consum', 0.0223, 'lps'),
	(482658, 126, '2015-04-01 00:43:44.000000', 'consum', 0.0219, 'lps'),
	(482659, 126, '2015-04-01 00:43:45.000000', 'consum', 0.0215, 'lps'),
	(482660, 126, '2015-04-01 00:43:46.000000', 'consum', 0.0210, 'lps'),
	(482661, 126, '2015-04-01 00:43:47.000000', 'consum', 0.0213, 'lps'),
	(482662, 126, '2015-04-01 00:43:48.000000', 'consum', 0.0225, 'lps'),
	(482663, 126, '2015-04-01 00:43:49.000000', 'consum', 0.0223, 'lps'),
	(482664, 126, '2015-04-01 00:43:50.000000', 'consum', 0.0214, 'lps'),
	(482665, 126, '2015-04-01 00:43:51.000000', 'consum', 0.0210, 'lps'),
	(482666, 126, '2015-04-01 00:43:52.000000', 'consum', 0.0214, 'lps'),
	(482667, 126, '2015-04-01 00:43:53.000000', 'consum', 0.0214, 'lps'),
	(482668, 126, '2015-04-01 00:43:54.000000', 'consum', 0.0219, 'lps'),
	(482669, 126, '2015-04-01 00:43:55.000000', 'consum', 0.0227, 'lps'),
	(482670, 126, '2015-04-01 00:43:56.000000', 'consum', 0.0213, 'lps'),
	(482671, 126, '2015-04-01 00:43:57.000000', 'consum', 0.0227, 'lps'),
	(482672, 126, '2015-04-01 00:43:58.000000', 'consum', 0.0214, 'lps'),
	(482673, 126, '2015-04-01 00:43:59.000000', 'consum', 0.0215, 'lps'),
	(482674, 126, '2015-04-01 00:44:00.000000', 'consum', 0.0225, 'lps'),
	(482675, 126, '2015-04-01 00:44:01.000000', 'consum', 0.0216, 'lps'),
	(482676, 126, '2015-04-01 00:44:02.000000', 'consum', 0.0215, 'lps'),
	(482677, 126, '2015-04-01 00:44:03.000000', 'consum', 0.0218, 'lps'),
	(482678, 126, '2015-04-01 00:44:04.000000', 'consum', 0.0218, 'lps'),
	(482679, 126, '2015-04-01 00:44:05.000000', 'consum', 0.0226, 'lps'),
	(482680, 126, '2015-04-01 00:44:06.000000', 'consum', 0.0212, 'lps'),
	(482681, 126, '2015-04-01 00:44:07.000000', 'consum', 0.0210, 'lps'),
	(482682, 126, '2015-04-01 00:44:08.000000', 'consum', 0.0221, 'lps'),
	(482683, 126, '2015-04-01 00:44:09.000000', 'consum', 0.0211, 'lps'),
	(482684, 126, '2015-04-01 00:44:10.000000', 'consum', 0.0218, 'lps'),
	(482685, 126, '2015-04-01 00:44:11.000000', 'consum', 0.0214, 'lps'),
	(482686, 126, '2015-04-01 00:44:12.000000', 'consum', 0.0221, 'lps'),
	(482687, 126, '2015-04-01 00:44:13.000000', 'consum', 0.0220, 'lps'),
	(482688, 126, '2015-04-01 00:44:14.000000', 'consum', 0.0227, 'lps'),
	(482689, 126, '2015-04-01 00:44:15.000000', 'consum', 0.0211, 'lps'),
	(482690, 126, '2015-04-01 00:44:16.000000', 'consum', 0.0219, 'lps'),
	(482691, 126, '2015-04-01 00:44:17.000000', 'consum', 0.0218, 'lps'),
	(482692, 126, '2015-04-01 00:44:18.000000', 'consum', 0.0222, 'lps'),
	(482693, 126, '2015-04-01 00:44:19.000000', 'consum', 0.0213, 'lps'),
	(482694, 126, '2015-04-01 00:44:20.000000', 'consum', 0.0222, 'lps'),
	(482695, 126, '2015-04-01 00:44:21.000000', 'consum', 0.0227, 'lps'),
	(482696, 126, '2015-04-01 00:44:22.000000', 'consum', 0.0225, 'lps'),
	(482697, 126, '2015-04-01 00:44:23.000000', 'consum', 0.0214, 'lps'),
	(482698, 126, '2015-04-01 00:44:24.000000', 'consum', 0.0224, 'lps'),
	(482699, 126, '2015-04-01 00:44:25.000000', 'consum', 0.0215, 'lps'),
	(482700, 126, '2015-04-01 00:44:26.000000', 'consum', 0.0210, 'lps'),
	(482701, 126, '2015-04-01 00:44:27.000000', 'consum', 0.0213, 'lps'),
	(482702, 126, '2015-04-01 00:44:28.000000', 'consum', 0.0226, 'lps'),
	(482703, 126, '2015-04-01 00:44:29.000000', 'consum', 0.0227, 'lps'),
	(482704, 126, '2015-04-01 00:44:30.000000', 'consum', 0.0213, 'lps'),
	(482705, 126, '2015-04-01 00:44:31.000000', 'consum', 0.0226, 'lps'),
	(482706, 126, '2015-04-01 00:44:32.000000', 'consum', 0.0211, 'lps'),
	(482707, 126, '2015-04-01 00:44:33.000000', 'consum', 0.0222, 'lps'),
	(482708, 126, '2015-04-01 00:44:34.000000', 'consum', 0.0214, 'lps'),
	(482709, 126, '2015-04-01 00:44:35.000000', 'consum', 0.0210, 'lps'),
	(482710, 126, '2015-04-01 00:44:36.000000', 'consum', 0.0219, 'lps'),
	(482711, 126, '2015-04-01 00:44:37.000000', 'consum', 0.0219, 'lps'),
	(482712, 126, '2015-04-01 00:44:38.000000', 'consum', 0.0212, 'lps'),
	(482713, 126, '2015-04-01 00:44:39.000000', 'consum', 0.0211, 'lps'),
	(482714, 126, '2015-04-01 00:44:40.000000', 'consum', 0.0227, 'lps'),
	(482715, 126, '2015-04-01 00:44:41.000000', 'consum', 0.0219, 'lps'),
	(482716, 126, '2015-04-01 00:44:42.000000', 'consum', 0.0225, 'lps'),
	(482717, 126, '2015-04-01 00:44:43.000000', 'consum', 0.0222, 'lps'),
	(482718, 126, '2015-04-01 00:44:44.000000', 'consum', 0.0223, 'lps'),
	(482719, 126, '2015-04-01 00:44:45.000000', 'consum', 0.0223, 'lps'),
	(482720, 126, '2015-04-01 00:44:46.000000', 'consum', 0.0219, 'lps'),
	(482721, 126, '2015-04-01 00:44:47.000000', 'consum', 0.0215, 'lps'),
	(482722, 126, '2015-04-01 00:44:48.000000', 'consum', 0.0227, 'lps'),
	(482723, 126, '2015-04-01 00:44:49.000000', 'consum', 0.0226, 'lps'),
	(482724, 126, '2015-04-01 00:44:50.000000', 'consum', 0.0222, 'lps'),
	(482725, 126, '2015-04-01 00:44:51.000000', 'consum', 0.0224, 'lps'),
	(482726, 126, '2015-04-01 00:44:52.000000', 'consum', 0.0224, 'lps'),
	(482727, 126, '2015-04-01 00:44:53.000000', 'consum', 0.0220, 'lps'),
	(482728, 126, '2015-04-01 00:44:54.000000', 'consum', 0.0219, 'lps'),
	(482729, 126, '2015-04-01 00:44:55.000000', 'consum', 0.0210, 'lps'),
	(482730, 126, '2015-04-01 00:44:56.000000', 'consum', 0.0217, 'lps'),
	(482731, 126, '2015-04-01 00:44:57.000000', 'consum', 0.0227, 'lps'),
	(482732, 126, '2015-04-01 00:44:58.000000', 'consum', 0.0222, 'lps'),
	(482733, 126, '2015-04-01 00:44:59.000000', 'consum', 0.0217, 'lps'),
	(482734, 126, '2015-04-01 00:45:00.000000', 'consum', 0.0213, 'lps'),
	(482735, 126, '2015-04-01 00:45:01.000000', 'consum', 0.0221, 'lps'),
	(482736, 126, '2015-04-01 00:45:02.000000', 'consum', 0.0222, 'lps'),
	(482737, 126, '2015-04-01 00:45:03.000000', 'consum', 0.0218, 'lps'),
	(482738, 126, '2015-04-01 00:45:04.000000', 'consum', 0.0213, 'lps'),
	(482739, 126, '2015-04-01 00:45:05.000000', 'consum', 0.0222, 'lps'),
	(482740, 126, '2015-04-01 00:45:06.000000', 'consum', 0.0225, 'lps'),
	(482741, 126, '2015-04-01 00:45:07.000000', 'consum', 0.0214, 'lps'),
	(482742, 126, '2015-04-01 00:45:08.000000', 'consum', 0.0222, 'lps'),
	(482743, 126, '2015-04-01 00:45:09.000000', 'consum', 0.0222, 'lps'),
	(482744, 126, '2015-04-01 00:45:10.000000', 'consum', 0.0217, 'lps'),
	(482745, 126, '2015-04-01 00:45:11.000000', 'consum', 0.0211, 'lps'),
	(482746, 126, '2015-04-01 00:45:12.000000', 'consum', 0.0210, 'lps'),
	(482747, 126, '2015-04-01 00:45:13.000000', 'consum', 0.0226, 'lps'),
	(482748, 126, '2015-04-01 00:45:14.000000', 'consum', 0.0217, 'lps'),
	(482749, 126, '2015-04-01 00:45:15.000000', 'consum', 0.0216, 'lps'),
	(482750, 126, '2015-04-01 00:45:16.000000', 'consum', 0.0220, 'lps'),
	(482751, 126, '2015-04-01 00:45:17.000000', 'consum', 0.0225, 'lps'),
	(482752, 126, '2015-04-01 00:45:18.000000', 'consum', 0.0218, 'lps'),
	(482753, 126, '2015-04-01 00:45:19.000000', 'consum', 0.0226, 'lps'),
	(482754, 126, '2015-04-01 00:45:20.000000', 'consum', 0.0212, 'lps'),
	(482755, 126, '2015-04-01 00:45:21.000000', 'consum', 0.0210, 'lps'),
	(482756, 126, '2015-04-01 00:45:22.000000', 'consum', 0.0220, 'lps'),
	(482757, 126, '2015-04-01 00:45:23.000000', 'consum', 0.0223, 'lps'),
	(482758, 126, '2015-04-01 00:45:24.000000', 'consum', 0.0213, 'lps'),
	(482759, 126, '2015-04-01 00:45:25.000000', 'consum', 0.0222, 'lps'),
	(482760, 126, '2015-04-01 00:45:26.000000', 'consum', 0.0224, 'lps'),
	(482761, 126, '2015-04-01 00:45:27.000000', 'consum', 0.0226, 'lps'),
	(482762, 126, '2015-04-01 00:45:28.000000', 'consum', 0.0213, 'lps'),
	(482763, 126, '2015-04-01 00:45:29.000000', 'consum', 0.0212, 'lps'),
	(482764, 126, '2015-04-01 00:45:30.000000', 'consum', 0.0215, 'lps'),
	(482765, 126, '2015-04-01 00:45:31.000000', 'consum', 0.0226, 'lps'),
	(482766, 126, '2015-04-01 00:45:32.000000', 'consum', 0.0224, 'lps'),
	(482767, 126, '2015-04-01 00:45:33.000000', 'consum', 0.0215, 'lps'),
	(482768, 126, '2015-04-01 00:45:34.000000', 'consum', 0.0212, 'lps'),
	(482769, 126, '2015-04-01 00:45:35.000000', 'consum', 0.0225, 'lps'),
	(482770, 126, '2015-04-01 00:45:36.000000', 'consum', 0.0222, 'lps'),
	(482771, 126, '2015-04-01 00:45:37.000000', 'consum', 0.0226, 'lps'),
	(482772, 126, '2015-04-01 00:45:38.000000', 'consum', 0.0217, 'lps'),
	(482773, 126, '2015-04-01 00:45:39.000000', 'consum', 0.0217, 'lps'),
	(482774, 126, '2015-04-01 00:45:40.000000', 'consum', 0.0224, 'lps'),
	(482775, 126, '2015-04-01 00:45:41.000000', 'consum', 0.0225, 'lps'),
	(482776, 126, '2015-04-01 00:45:42.000000', 'consum', 0.0224, 'lps'),
	(482777, 126, '2015-04-01 00:45:43.000000', 'consum', 0.0217, 'lps'),
	(482778, 126, '2015-04-01 00:45:44.000000', 'consum', 0.0221, 'lps'),
	(482779, 126, '2015-04-01 00:45:45.000000', 'consum', 0.0227, 'lps'),
	(482780, 126, '2015-04-01 00:45:46.000000', 'consum', 0.0227, 'lps'),
	(482781, 126, '2015-04-01 00:45:47.000000', 'consum', 0.0210, 'lps'),
	(482782, 126, '2015-04-01 00:45:48.000000', 'consum', 0.0213, 'lps'),
	(482783, 126, '2015-04-01 00:45:49.000000', 'consum', 0.0227, 'lps'),
	(482784, 126, '2015-04-01 00:45:50.000000', 'consum', 0.0212, 'lps'),
	(482785, 126, '2015-04-01 00:45:51.000000', 'consum', 0.0223, 'lps'),
	(482786, 126, '2015-04-01 00:45:52.000000', 'consum', 0.0216, 'lps'),
	(482787, 126, '2015-04-01 00:45:53.000000', 'consum', 0.0221, 'lps'),
	(482788, 126, '2015-04-01 00:45:54.000000', 'consum', 0.0212, 'lps'),
	(482789, 126, '2015-04-01 00:45:55.000000', 'consum', 0.0222, 'lps'),
	(482790, 126, '2015-04-01 00:45:56.000000', 'consum', 0.0210, 'lps'),
	(482791, 126, '2015-04-01 00:45:57.000000', 'consum', 0.0212, 'lps'),
	(482792, 126, '2015-04-01 00:45:58.000000', 'consum', 0.0221, 'lps'),
	(482793, 126, '2015-04-01 00:45:59.000000', 'consum', 0.0224, 'lps'),
	(482794, 126, '2015-04-01 00:46:00.000000', 'consum', 0.0212, 'lps'),
	(482795, 126, '2015-04-01 00:46:01.000000', 'consum', 0.0214, 'lps'),
	(482796, 126, '2015-04-01 00:46:02.000000', 'consum', 0.0223, 'lps'),
	(482797, 126, '2015-04-01 00:46:03.000000', 'consum', 0.0210, 'lps'),
	(482798, 126, '2015-04-01 00:46:04.000000', 'consum', 0.0226, 'lps'),
	(482799, 126, '2015-04-01 00:46:05.000000', 'consum', 0.0220, 'lps'),
	(482800, 126, '2015-04-01 00:46:06.000000', 'consum', 0.0212, 'lps'),
	(482801, 126, '2015-04-01 00:46:07.000000', 'consum', 0.0227, 'lps'),
	(482802, 126, '2015-04-01 00:46:08.000000', 'consum', 0.0216, 'lps'),
	(482803, 126, '2015-04-01 00:46:09.000000', 'consum', 0.0225, 'lps'),
	(482804, 126, '2015-04-01 00:46:10.000000', 'consum', 0.0216, 'lps'),
	(482805, 126, '2015-04-01 00:46:11.000000', 'consum', 0.0213, 'lps'),
	(482806, 126, '2015-04-01 00:46:12.000000', 'consum', 0.0226, 'lps'),
	(482807, 126, '2015-04-01 00:46:13.000000', 'consum', 0.0211, 'lps'),
	(482808, 126, '2015-04-01 00:46:14.000000', 'consum', 0.0219, 'lps'),
	(482809, 126, '2015-04-01 00:46:15.000000', 'consum', 0.0217, 'lps'),
	(482810, 126, '2015-04-01 00:46:16.000000', 'consum', 0.0218, 'lps'),
	(482811, 126, '2015-04-01 00:46:17.000000', 'consum', 0.0211, 'lps'),
	(482812, 126, '2015-04-01 00:46:18.000000', 'consum', 0.0210, 'lps'),
	(482813, 126, '2015-04-01 00:46:19.000000', 'consum', 0.0210, 'lps'),
	(482814, 126, '2015-04-01 00:46:20.000000', 'consum', 0.0226, 'lps'),
	(482815, 126, '2015-04-01 00:46:21.000000', 'consum', 0.0218, 'lps'),
	(482816, 126, '2015-04-01 00:46:22.000000', 'consum', 0.0219, 'lps'),
	(482817, 126, '2015-04-01 00:46:23.000000', 'consum', 0.0217, 'lps'),
	(482818, 126, '2015-04-01 00:46:24.000000', 'consum', 0.0218, 'lps'),
	(482819, 126, '2015-04-01 00:46:25.000000', 'consum', 0.0210, 'lps'),
	(482820, 126, '2015-04-01 00:46:26.000000', 'consum', 0.0222, 'lps'),
	(482821, 126, '2015-04-01 00:46:27.000000', 'consum', 0.0217, 'lps'),
	(482822, 126, '2015-04-01 00:46:28.000000', 'consum', 0.0210, 'lps'),
	(482823, 126, '2015-04-01 00:46:29.000000', 'consum', 0.0225, 'lps'),
	(482824, 126, '2015-04-01 00:46:30.000000', 'consum', 0.0215, 'lps'),
	(482825, 126, '2015-04-01 00:46:31.000000', 'consum', 0.0225, 'lps'),
	(482826, 126, '2015-04-01 00:46:32.000000', 'consum', 0.0218, 'lps'),
	(482827, 126, '2015-04-01 00:46:33.000000', 'consum', 0.0223, 'lps'),
	(482828, 126, '2015-04-01 00:46:34.000000', 'consum', 0.0215, 'lps'),
	(482829, 126, '2015-04-01 00:46:35.000000', 'consum', 0.0216, 'lps'),
	(482830, 126, '2015-04-01 00:46:36.000000', 'consum', 0.0225, 'lps'),
	(482831, 126, '2015-04-01 00:46:37.000000', 'consum', 0.0214, 'lps'),
	(482832, 126, '2015-04-01 00:46:38.000000', 'consum', 0.0219, 'lps'),
	(482833, 126, '2015-04-01 00:46:39.000000', 'consum', 0.0227, 'lps'),
	(482834, 126, '2015-04-01 00:46:40.000000', 'consum', 0.0214, 'lps'),
	(482835, 126, '2015-04-01 00:46:41.000000', 'consum', 0.0215, 'lps'),
	(482836, 126, '2015-04-01 00:46:42.000000', 'consum', 0.0224, 'lps'),
	(482837, 126, '2015-04-01 00:46:43.000000', 'consum', 0.0211, 'lps'),
	(482838, 126, '2015-04-01 00:46:44.000000', 'consum', 0.0226, 'lps'),
	(482839, 126, '2015-04-01 00:46:45.000000', 'consum', 0.0219, 'lps'),
	(482840, 126, '2015-04-01 00:46:46.000000', 'consum', 0.0222, 'lps'),
	(482841, 126, '2015-04-01 00:46:47.000000', 'consum', 0.0210, 'lps'),
	(482842, 126, '2015-04-01 00:46:48.000000', 'consum', 0.0226, 'lps'),
	(482843, 126, '2015-04-01 00:46:49.000000', 'consum', 0.0218, 'lps'),
	(482844, 126, '2015-04-01 00:46:50.000000', 'consum', 0.0222, 'lps'),
	(482845, 126, '2015-04-01 00:46:51.000000', 'consum', 0.0211, 'lps'),
	(482846, 126, '2015-04-01 00:46:52.000000', 'consum', 0.0214, 'lps'),
	(482847, 126, '2015-04-01 00:46:53.000000', 'consum', 0.0227, 'lps'),
	(482848, 126, '2015-04-01 00:46:54.000000', 'consum', 0.0212, 'lps'),
	(482849, 126, '2015-04-01 00:46:55.000000', 'consum', 0.0223, 'lps'),
	(482850, 126, '2015-04-01 00:46:56.000000', 'consum', 0.0216, 'lps'),
	(482851, 126, '2015-04-01 00:46:57.000000', 'consum', 0.0217, 'lps'),
	(482852, 126, '2015-04-01 00:46:58.000000', 'consum', 0.0213, 'lps'),
	(482853, 126, '2015-04-01 00:46:59.000000', 'consum', 0.0222, 'lps'),
	(482854, 126, '2015-04-01 00:47:00.000000', 'consum', 0.0223, 'lps'),
	(482855, 126, '2015-04-01 00:47:01.000000', 'consum', 0.0224, 'lps'),
	(482856, 126, '2015-04-01 00:47:02.000000', 'consum', 0.0223, 'lps'),
	(482857, 126, '2015-04-01 00:47:03.000000', 'consum', 0.0217, 'lps'),
	(482858, 126, '2015-04-01 00:47:04.000000', 'consum', 0.0224, 'lps'),
	(482859, 126, '2015-04-01 00:47:05.000000', 'consum', 0.0225, 'lps'),
	(482860, 126, '2015-04-01 00:47:06.000000', 'consum', 0.0223, 'lps'),
	(482861, 126, '2015-04-01 00:47:07.000000', 'consum', 0.0213, 'lps'),
	(482862, 126, '2015-04-01 00:47:08.000000', 'consum', 0.0223, 'lps'),
	(482863, 126, '2015-04-01 00:47:09.000000', 'consum', 0.0211, 'lps'),
	(482864, 126, '2015-04-01 00:47:10.000000', 'consum', 0.0214, 'lps'),
	(482865, 126, '2015-04-01 00:47:11.000000', 'consum', 0.0227, 'lps'),
	(482866, 126, '2015-04-01 00:47:12.000000', 'consum', 0.0211, 'lps'),
	(482867, 126, '2015-04-01 00:47:13.000000', 'consum', 0.0219, 'lps'),
	(482868, 126, '2015-04-01 00:47:14.000000', 'consum', 0.0216, 'lps'),
	(482869, 126, '2015-04-01 00:47:15.000000', 'consum', 0.0214, 'lps'),
	(482870, 126, '2015-04-01 00:47:16.000000', 'consum', 0.0212, 'lps'),
	(482871, 126, '2015-04-01 00:47:17.000000', 'consum', 0.0225, 'lps'),
	(482872, 126, '2015-04-01 00:47:18.000000', 'consum', 0.0210, 'lps'),
	(482873, 126, '2015-04-01 00:47:19.000000', 'consum', 0.0217, 'lps'),
	(482874, 126, '2015-04-01 00:47:20.000000', 'consum', 0.0210, 'lps'),
	(482875, 126, '2015-04-01 00:47:21.000000', 'consum', 0.0210, 'lps'),
	(482876, 126, '2015-04-01 00:47:22.000000', 'consum', 0.0226, 'lps'),
	(482877, 126, '2015-04-01 00:47:23.000000', 'consum', 0.0218, 'lps'),
	(482878, 126, '2015-04-01 00:47:24.000000', 'consum', 0.0222, 'lps'),
	(482879, 126, '2015-04-01 00:47:25.000000', 'consum', 0.0226, 'lps'),
	(482880, 126, '2015-04-01 00:47:26.000000', 'consum', 0.0222, 'lps'),
	(482881, 126, '2015-04-01 00:47:27.000000', 'consum', 0.0219, 'lps'),
	(482882, 126, '2015-04-01 00:47:28.000000', 'consum', 0.0222, 'lps'),
	(482883, 126, '2015-04-01 00:47:29.000000', 'consum', 0.0225, 'lps'),
	(482884, 126, '2015-04-01 00:47:30.000000', 'consum', 0.0215, 'lps'),
	(482885, 126, '2015-04-01 00:47:31.000000', 'consum', 0.0227, 'lps'),
	(482886, 126, '2015-04-01 00:47:32.000000', 'consum', 0.0223, 'lps'),
	(482887, 126, '2015-04-01 00:47:33.000000', 'consum', 0.0227, 'lps'),
	(482888, 126, '2015-04-01 00:47:34.000000', 'consum', 0.0221, 'lps'),
	(482889, 126, '2015-04-01 00:47:35.000000', 'consum', 0.0214, 'lps'),
	(482890, 126, '2015-04-01 00:47:36.000000', 'consum', 0.0217, 'lps'),
	(482891, 126, '2015-04-01 00:47:37.000000', 'consum', 0.0216, 'lps'),
	(482892, 126, '2015-04-01 00:47:38.000000', 'consum', 0.0217, 'lps'),
	(482893, 126, '2015-04-01 00:47:39.000000', 'consum', 0.0212, 'lps'),
	(482894, 126, '2015-04-01 00:47:40.000000', 'consum', 0.0218, 'lps'),
	(482895, 126, '2015-04-01 00:47:41.000000', 'consum', 0.0225, 'lps'),
	(482896, 126, '2015-04-01 00:47:42.000000', 'consum', 0.0224, 'lps'),
	(482897, 126, '2015-04-01 00:47:43.000000', 'consum', 0.0218, 'lps'),
	(482898, 126, '2015-04-01 00:47:44.000000', 'consum', 0.0210, 'lps'),
	(482899, 126, '2015-04-01 00:47:45.000000', 'consum', 0.0224, 'lps'),
	(482900, 126, '2015-04-01 00:47:46.000000', 'consum', 0.0223, 'lps'),
	(482901, 126, '2015-04-01 00:47:47.000000', 'consum', 0.0219, 'lps'),
	(482902, 126, '2015-04-01 00:47:48.000000', 'consum', 0.0213, 'lps'),
	(482903, 126, '2015-04-01 00:47:49.000000', 'consum', 0.0220, 'lps'),
	(482904, 126, '2015-04-01 00:47:50.000000', 'consum', 0.0213, 'lps'),
	(482905, 126, '2015-04-01 00:47:51.000000', 'consum', 0.0216, 'lps'),
	(482906, 126, '2015-04-01 00:47:52.000000', 'consum', 0.0212, 'lps'),
	(482907, 126, '2015-04-01 00:47:53.000000', 'consum', 0.0220, 'lps'),
	(482908, 126, '2015-04-01 00:47:54.000000', 'consum', 0.0218, 'lps'),
	(482909, 126, '2015-04-01 00:47:55.000000', 'consum', 0.0220, 'lps'),
	(482910, 126, '2015-04-01 00:47:56.000000', 'consum', 0.0219, 'lps'),
	(482911, 126, '2015-04-01 00:47:57.000000', 'consum', 0.0227, 'lps'),
	(482912, 126, '2015-04-01 00:47:58.000000', 'consum', 0.0213, 'lps'),
	(482913, 126, '2015-04-01 00:47:59.000000', 'consum', 0.0212, 'lps'),
	(482914, 126, '2015-04-01 00:48:00.000000', 'consum', 0.0210, 'lps'),
	(482915, 126, '2015-04-01 00:48:01.000000', 'consum', 0.0223, 'lps'),
	(482916, 126, '2015-04-01 00:48:02.000000', 'consum', 0.0223, 'lps'),
	(482917, 126, '2015-04-01 00:48:03.000000', 'consum', 0.0216, 'lps'),
	(482918, 126, '2015-04-01 00:48:04.000000', 'consum', 0.0220, 'lps'),
	(482919, 126, '2015-04-01 00:48:05.000000', 'consum', 0.0225, 'lps'),
	(482920, 126, '2015-04-01 00:48:06.000000', 'consum', 0.0219, 'lps'),
	(482921, 126, '2015-04-01 00:48:07.000000', 'consum', 0.0227, 'lps'),
	(482922, 126, '2015-04-01 00:48:08.000000', 'consum', 0.0214, 'lps'),
	(482923, 126, '2015-04-01 00:48:09.000000', 'consum', 0.0218, 'lps'),
	(482924, 126, '2015-04-01 00:48:10.000000', 'consum', 0.0220, 'lps'),
	(482925, 126, '2015-04-01 00:48:11.000000', 'consum', 0.0217, 'lps'),
	(482926, 126, '2015-04-01 00:48:12.000000', 'consum', 0.0218, 'lps'),
	(482927, 126, '2015-04-01 00:48:13.000000', 'consum', 0.0211, 'lps'),
	(482928, 126, '2015-04-01 00:48:14.000000', 'consum', 0.0225, 'lps'),
	(482929, 126, '2015-04-01 00:48:15.000000', 'consum', 0.0214, 'lps'),
	(482930, 126, '2015-04-01 00:48:16.000000', 'consum', 0.0220, 'lps'),
	(482931, 126, '2015-04-01 00:48:17.000000', 'consum', 0.0212, 'lps'),
	(482932, 126, '2015-04-01 00:48:18.000000', 'consum', 0.0225, 'lps'),
	(482933, 126, '2015-04-01 00:48:19.000000', 'consum', 0.0210, 'lps'),
	(482934, 126, '2015-04-01 00:48:20.000000', 'consum', 0.0220, 'lps'),
	(482935, 126, '2015-04-01 00:48:21.000000', 'consum', 0.0222, 'lps'),
	(482936, 126, '2015-04-01 00:48:22.000000', 'consum', 0.0224, 'lps'),
	(482937, 126, '2015-04-01 00:48:23.000000', 'consum', 0.0227, 'lps'),
	(482938, 126, '2015-04-01 00:48:24.000000', 'consum', 0.0218, 'lps'),
	(482939, 126, '2015-04-01 00:48:25.000000', 'consum', 0.0217, 'lps'),
	(482940, 126, '2015-04-01 00:48:26.000000', 'consum', 0.0223, 'lps'),
	(482941, 126, '2015-04-01 00:48:27.000000', 'consum', 0.0216, 'lps'),
	(482942, 126, '2015-04-01 00:48:28.000000', 'consum', 0.0219, 'lps'),
	(482943, 126, '2015-04-01 00:48:29.000000', 'consum', 0.0221, 'lps'),
	(482944, 126, '2015-04-01 00:48:30.000000', 'consum', 0.0221, 'lps'),
	(482945, 126, '2015-04-01 00:48:31.000000', 'consum', 0.0216, 'lps'),
	(482946, 126, '2015-04-01 00:48:32.000000', 'consum', 0.0223, 'lps'),
	(482947, 126, '2015-04-01 00:48:33.000000', 'consum', 0.0221, 'lps'),
	(482948, 126, '2015-04-01 00:48:34.000000', 'consum', 0.0226, 'lps'),
	(482949, 126, '2015-04-01 00:48:35.000000', 'consum', 0.0223, 'lps'),
	(482950, 126, '2015-04-01 00:48:36.000000', 'consum', 0.0211, 'lps'),
	(482951, 126, '2015-04-01 00:48:37.000000', 'consum', 0.0210, 'lps'),
	(482952, 126, '2015-04-01 00:48:38.000000', 'consum', 0.0227, 'lps'),
	(482953, 126, '2015-04-01 00:48:39.000000', 'consum', 0.0221, 'lps'),
	(482954, 126, '2015-04-01 00:48:40.000000', 'consum', 0.0218, 'lps'),
	(482955, 126, '2015-04-01 00:48:41.000000', 'consum', 0.0216, 'lps'),
	(482956, 126, '2015-04-01 00:48:42.000000', 'consum', 0.0215, 'lps'),
	(482957, 126, '2015-04-01 00:48:43.000000', 'consum', 0.0217, 'lps'),
	(482958, 126, '2015-04-01 00:48:44.000000', 'consum', 0.0213, 'lps'),
	(482959, 126, '2015-04-01 00:48:45.000000', 'consum', 0.0225, 'lps'),
	(482960, 126, '2015-04-01 00:48:46.000000', 'consum', 0.0220, 'lps'),
	(482961, 126, '2015-04-01 00:48:47.000000', 'consum', 0.0215, 'lps'),
	(482962, 126, '2015-04-01 00:48:48.000000', 'consum', 0.0224, 'lps'),
	(482963, 126, '2015-04-01 00:48:49.000000', 'consum', 0.0213, 'lps'),
	(482964, 126, '2015-04-01 00:48:50.000000', 'consum', 0.0220, 'lps'),
	(482965, 126, '2015-04-01 00:48:51.000000', 'consum', 0.0214, 'lps'),
	(482966, 126, '2015-04-01 00:48:52.000000', 'consum', 0.0220, 'lps'),
	(482967, 126, '2015-04-01 00:48:53.000000', 'consum', 0.0210, 'lps'),
	(482968, 126, '2015-04-01 00:48:54.000000', 'consum', 0.0217, 'lps'),
	(482969, 126, '2015-04-01 00:48:55.000000', 'consum', 0.0227, 'lps'),
	(482970, 126, '2015-04-01 00:48:56.000000', 'consum', 0.0223, 'lps'),
	(482971, 126, '2015-04-01 00:48:57.000000', 'consum', 0.0223, 'lps'),
	(482972, 126, '2015-04-01 00:48:58.000000', 'consum', 0.0217, 'lps'),
	(482973, 126, '2015-04-01 00:48:59.000000', 'consum', 0.0226, 'lps'),
	(482974, 126, '2015-04-01 00:49:00.000000', 'consum', 0.0216, 'lps'),
	(482975, 126, '2015-04-01 00:49:01.000000', 'consum', 0.0211, 'lps'),
	(482976, 126, '2015-04-01 00:49:02.000000', 'consum', 0.0216, 'lps'),
	(482977, 126, '2015-04-01 00:49:03.000000', 'consum', 0.0221, 'lps'),
	(482978, 126, '2015-04-01 00:49:04.000000', 'consum', 0.0226, 'lps'),
	(482979, 126, '2015-04-01 00:49:05.000000', 'consum', 0.0225, 'lps'),
	(482980, 126, '2015-04-01 00:49:06.000000', 'consum', 0.0217, 'lps'),
	(482981, 126, '2015-04-01 00:49:07.000000', 'consum', 0.0219, 'lps'),
	(482982, 126, '2015-04-01 00:49:08.000000', 'consum', 0.0218, 'lps'),
	(482983, 126, '2015-04-01 00:49:09.000000', 'consum', 0.0222, 'lps'),
	(482984, 126, '2015-04-01 00:49:10.000000', 'consum', 0.0213, 'lps'),
	(482985, 126, '2015-04-01 00:49:11.000000', 'consum', 0.0224, 'lps'),
	(482986, 126, '2015-04-01 00:49:12.000000', 'consum', 0.0216, 'lps'),
	(482987, 126, '2015-04-01 00:49:13.000000', 'consum', 0.0217, 'lps'),
	(482988, 126, '2015-04-01 00:49:14.000000', 'consum', 0.0226, 'lps'),
	(482989, 126, '2015-04-01 00:49:15.000000', 'consum', 0.0217, 'lps'),
	(482990, 126, '2015-04-01 00:49:16.000000', 'consum', 0.0217, 'lps'),
	(482991, 126, '2015-04-01 00:49:17.000000', 'consum', 0.0222, 'lps'),
	(482992, 126, '2015-04-01 00:49:18.000000', 'consum', 0.0214, 'lps'),
	(482993, 126, '2015-04-01 00:49:19.000000', 'consum', 0.0212, 'lps'),
	(482994, 126, '2015-04-01 00:49:20.000000', 'consum', 0.0226, 'lps'),
	(482995, 126, '2015-04-01 00:49:21.000000', 'consum', 0.0213, 'lps'),
	(482996, 126, '2015-04-01 00:49:22.000000', 'consum', 0.0215, 'lps'),
	(482997, 126, '2015-04-01 00:49:23.000000', 'consum', 0.0226, 'lps'),
	(482998, 126, '2015-04-01 00:49:24.000000', 'consum', 0.0222, 'lps'),
	(482999, 126, '2015-04-01 00:49:25.000000', 'consum', 0.0224, 'lps'),
	(483000, 126, '2015-04-01 00:49:26.000000', 'consum', 0.0224, 'lps'),
	(483001, 126, '2015-04-01 00:49:27.000000', 'consum', 0.0219, 'lps'),
	(483002, 126, '2015-04-01 00:49:28.000000', 'consum', 0.0215, 'lps'),
	(483003, 126, '2015-04-01 00:49:29.000000', 'consum', 0.0211, 'lps'),
	(483004, 126, '2015-04-01 00:49:30.000000', 'consum', 0.0215, 'lps'),
	(483005, 126, '2015-04-01 00:49:31.000000', 'consum', 0.0216, 'lps'),
	(483006, 126, '2015-04-01 00:49:32.000000', 'consum', 0.0223, 'lps'),
	(483007, 126, '2015-04-01 00:49:33.000000', 'consum', 0.0224, 'lps'),
	(483008, 126, '2015-04-01 00:49:34.000000', 'consum', 0.0223, 'lps'),
	(483009, 126, '2015-04-01 00:49:35.000000', 'consum', 0.0216, 'lps'),
	(483010, 126, '2015-04-01 00:49:36.000000', 'consum', 0.0221, 'lps'),
	(483011, 126, '2015-04-01 00:49:37.000000', 'consum', 0.0210, 'lps'),
	(483012, 126, '2015-04-01 00:49:38.000000', 'consum', 0.0213, 'lps'),
	(483013, 126, '2015-04-01 00:49:39.000000', 'consum', 0.0227, 'lps'),
	(483014, 126, '2015-04-01 00:49:40.000000', 'consum', 0.0213, 'lps'),
	(483015, 126, '2015-04-01 00:49:41.000000', 'consum', 0.0212, 'lps'),
	(483016, 126, '2015-04-01 00:49:42.000000', 'consum', 0.0227, 'lps'),
	(483017, 126, '2015-04-01 00:49:43.000000', 'consum', 0.0218, 'lps'),
	(483018, 126, '2015-04-01 00:49:44.000000', 'consum', 0.0218, 'lps'),
	(483019, 126, '2015-04-01 00:49:45.000000', 'consum', 0.0224, 'lps'),
	(483020, 126, '2015-04-01 00:49:46.000000', 'consum', 0.0224, 'lps'),
	(483021, 126, '2015-04-01 00:49:47.000000', 'consum', 0.0220, 'lps'),
	(483022, 126, '2015-04-01 00:49:48.000000', 'consum', 0.0216, 'lps'),
	(483023, 126, '2015-04-01 00:49:49.000000', 'consum', 0.0212, 'lps'),
	(483024, 126, '2015-04-01 00:49:50.000000', 'consum', 0.0222, 'lps'),
	(483025, 126, '2015-04-01 00:49:51.000000', 'consum', 0.0210, 'lps'),
	(483026, 126, '2015-04-01 00:49:52.000000', 'consum', 0.0227, 'lps'),
	(483027, 126, '2015-04-01 00:49:53.000000', 'consum', 0.0222, 'lps'),
	(483028, 126, '2015-04-01 00:49:54.000000', 'consum', 0.0222, 'lps'),
	(483029, 126, '2015-04-01 00:49:55.000000', 'consum', 0.0214, 'lps'),
	(483030, 126, '2015-04-01 00:49:56.000000', 'consum', 0.0214, 'lps'),
	(483031, 126, '2015-04-01 00:49:57.000000', 'consum', 0.0218, 'lps'),
	(483032, 126, '2015-04-01 00:49:58.000000', 'consum', 0.0222, 'lps'),
	(483033, 126, '2015-04-01 00:49:59.000000', 'consum', 0.0227, 'lps'),
	(483034, 126, '2015-04-01 00:50:00.000000', 'consum', 0.0223, 'lps'),
	(483035, 126, '2015-04-01 00:50:01.000000', 'consum', 0.0224, 'lps'),
	(483036, 126, '2015-04-01 00:50:02.000000', 'consum', 0.0223, 'lps'),
	(483037, 126, '2015-04-01 00:50:03.000000', 'consum', 0.0216, 'lps'),
	(483038, 126, '2015-04-01 00:50:04.000000', 'consum', 0.0222, 'lps'),
	(483039, 126, '2015-04-01 00:50:05.000000', 'consum', 0.0213, 'lps'),
	(483040, 126, '2015-04-01 00:50:06.000000', 'consum', 0.0227, 'lps'),
	(483041, 126, '2015-04-01 00:50:07.000000', 'consum', 0.0214, 'lps'),
	(483042, 126, '2015-04-01 00:50:08.000000', 'consum', 0.0215, 'lps'),
	(483043, 126, '2015-04-01 00:50:09.000000', 'consum', 0.0224, 'lps'),
	(483044, 126, '2015-04-01 00:50:10.000000', 'consum', 0.0213, 'lps'),
	(483045, 126, '2015-04-01 00:50:11.000000', 'consum', 0.0219, 'lps'),
	(483046, 126, '2015-04-01 00:50:12.000000', 'consum', 0.0211, 'lps'),
	(483047, 126, '2015-04-01 00:50:13.000000', 'consum', 0.0223, 'lps'),
	(483048, 126, '2015-04-01 00:50:14.000000', 'consum', 0.0220, 'lps'),
	(483049, 126, '2015-04-01 00:50:15.000000', 'consum', 0.0223, 'lps'),
	(483050, 126, '2015-04-01 00:50:16.000000', 'consum', 0.0224, 'lps'),
	(483051, 126, '2015-04-01 00:50:17.000000', 'consum', 0.0227, 'lps'),
	(483052, 126, '2015-04-01 00:50:18.000000', 'consum', 0.0215, 'lps'),
	(483053, 126, '2015-04-01 00:50:19.000000', 'consum', 0.0221, 'lps'),
	(483054, 126, '2015-04-01 00:50:20.000000', 'consum', 0.0216, 'lps'),
	(483055, 126, '2015-04-01 00:50:21.000000', 'consum', 0.0225, 'lps'),
	(483056, 126, '2015-04-01 00:50:22.000000', 'consum', 0.0213, 'lps'),
	(483057, 126, '2015-04-01 00:50:23.000000', 'consum', 0.0218, 'lps'),
	(483058, 126, '2015-04-01 00:50:24.000000', 'consum', 0.0221, 'lps'),
	(483059, 126, '2015-04-01 00:50:25.000000', 'consum', 0.0226, 'lps'),
	(483060, 126, '2015-04-01 00:50:26.000000', 'consum', 0.0222, 'lps'),
	(483061, 126, '2015-04-01 00:50:27.000000', 'consum', 0.0223, 'lps'),
	(483062, 126, '2015-04-01 00:50:28.000000', 'consum', 0.0223, 'lps'),
	(483063, 126, '2015-04-01 00:50:29.000000', 'consum', 0.0215, 'lps'),
	(483064, 126, '2015-04-01 00:50:30.000000', 'consum', 0.0214, 'lps'),
	(483065, 126, '2015-04-01 00:50:31.000000', 'consum', 0.0217, 'lps'),
	(483066, 126, '2015-04-01 00:50:32.000000', 'consum', 0.0217, 'lps'),
	(483067, 126, '2015-04-01 00:50:33.000000', 'consum', 0.0223, 'lps'),
	(483068, 126, '2015-04-01 00:50:34.000000', 'consum', 0.0219, 'lps'),
	(483069, 126, '2015-04-01 00:50:35.000000', 'consum', 0.0218, 'lps'),
	(483070, 126, '2015-04-01 00:50:36.000000', 'consum', 0.0222, 'lps'),
	(483071, 126, '2015-04-01 00:50:37.000000', 'consum', 0.0210, 'lps'),
	(483072, 126, '2015-04-01 00:50:38.000000', 'consum', 0.0210, 'lps'),
	(483073, 126, '2015-04-01 00:50:39.000000', 'consum', 0.0227, 'lps'),
	(483074, 126, '2015-04-01 00:50:40.000000', 'consum', 0.0226, 'lps'),
	(483075, 126, '2015-04-01 00:50:41.000000', 'consum', 0.0223, 'lps'),
	(483076, 126, '2015-04-01 00:50:42.000000', 'consum', 0.0225, 'lps'),
	(483077, 126, '2015-04-01 00:50:43.000000', 'consum', 0.0213, 'lps'),
	(483078, 126, '2015-04-01 00:50:44.000000', 'consum', 0.0215, 'lps'),
	(483079, 126, '2015-04-01 00:50:45.000000', 'consum', 0.0211, 'lps'),
	(483080, 126, '2015-04-01 00:50:46.000000', 'consum', 0.0216, 'lps'),
	(483081, 126, '2015-04-01 00:50:47.000000', 'consum', 0.0219, 'lps'),
	(483082, 126, '2015-04-01 00:50:48.000000', 'consum', 0.0218, 'lps'),
	(483083, 126, '2015-04-01 00:50:49.000000', 'consum', 0.0226, 'lps'),
	(483084, 126, '2015-04-01 00:50:50.000000', 'consum', 0.0212, 'lps'),
	(483085, 126, '2015-04-01 00:50:51.000000', 'consum', 0.0227, 'lps'),
	(483086, 126, '2015-04-01 00:50:52.000000', 'consum', 0.0218, 'lps'),
	(483087, 126, '2015-04-01 00:50:53.000000', 'consum', 0.0217, 'lps'),
	(483088, 126, '2015-04-01 00:50:54.000000', 'consum', 0.0221, 'lps'),
	(483089, 126, '2015-04-01 00:50:55.000000', 'consum', 0.0210, 'lps'),
	(483090, 126, '2015-04-01 00:50:56.000000', 'consum', 0.0212, 'lps'),
	(483091, 126, '2015-04-01 00:50:57.000000', 'consum', 0.0221, 'lps'),
	(483092, 126, '2015-04-01 00:50:58.000000', 'consum', 0.0222, 'lps'),
	(483093, 126, '2015-04-01 00:50:59.000000', 'consum', 0.0221, 'lps'),
	(483094, 126, '2015-04-01 00:51:00.000000', 'consum', 0.0210, 'lps'),
	(483095, 126, '2015-04-01 00:51:01.000000', 'consum', 0.0213, 'lps'),
	(483096, 126, '2015-04-01 00:51:02.000000', 'consum', 0.0224, 'lps'),
	(483097, 126, '2015-04-01 00:51:03.000000', 'consum', 0.0221, 'lps'),
	(483098, 126, '2015-04-01 00:51:04.000000', 'consum', 0.0223, 'lps'),
	(483099, 126, '2015-04-01 00:51:05.000000', 'consum', 0.0224, 'lps'),
	(483100, 126, '2015-04-01 00:51:06.000000', 'consum', 0.0225, 'lps'),
	(483101, 126, '2015-04-01 00:51:07.000000', 'consum', 0.0224, 'lps'),
	(483102, 126, '2015-04-01 00:51:08.000000', 'consum', 0.0218, 'lps'),
	(483103, 126, '2015-04-01 00:51:09.000000', 'consum', 0.0225, 'lps'),
	(483104, 126, '2015-04-01 00:51:10.000000', 'consum', 0.0227, 'lps'),
	(483105, 126, '2015-04-01 00:51:11.000000', 'consum', 0.0212, 'lps'),
	(483106, 126, '2015-04-01 00:51:12.000000', 'consum', 0.0226, 'lps'),
	(483107, 126, '2015-04-01 00:51:13.000000', 'consum', 0.0213, 'lps'),
	(483108, 126, '2015-04-01 00:51:14.000000', 'consum', 0.0213, 'lps'),
	(483109, 126, '2015-04-01 00:51:15.000000', 'consum', 0.0216, 'lps'),
	(483110, 126, '2015-04-01 00:51:16.000000', 'consum', 0.0213, 'lps'),
	(483111, 126, '2015-04-01 00:51:17.000000', 'consum', 0.0225, 'lps'),
	(483112, 126, '2015-04-01 00:51:18.000000', 'consum', 0.0223, 'lps'),
	(483113, 126, '2015-04-01 00:51:19.000000', 'consum', 0.0215, 'lps'),
	(483114, 126, '2015-04-01 00:51:20.000000', 'consum', 0.0212, 'lps'),
	(483115, 126, '2015-04-01 00:51:21.000000', 'consum', 0.0223, 'lps'),
	(483116, 126, '2015-04-01 00:51:22.000000', 'consum', 0.0217, 'lps'),
	(483117, 126, '2015-04-01 00:51:23.000000', 'consum', 0.0226, 'lps'),
	(483118, 126, '2015-04-01 00:51:24.000000', 'consum', 0.0212, 'lps'),
	(483119, 126, '2015-04-01 00:51:25.000000', 'consum', 0.0212, 'lps'),
	(483120, 126, '2015-04-01 00:51:26.000000', 'consum', 0.0212, 'lps'),
	(483121, 126, '2015-04-01 00:51:27.000000', 'consum', 0.0214, 'lps'),
	(483122, 126, '2015-04-01 00:51:28.000000', 'consum', 0.0224, 'lps'),
	(483123, 126, '2015-04-01 00:51:29.000000', 'consum', 0.0217, 'lps'),
	(483124, 126, '2015-04-01 00:51:30.000000', 'consum', 0.0220, 'lps'),
	(483125, 126, '2015-04-01 00:51:31.000000', 'consum', 0.0224, 'lps'),
	(483126, 126, '2015-04-01 00:51:32.000000', 'consum', 0.0212, 'lps'),
	(483127, 126, '2015-04-01 00:51:33.000000', 'consum', 0.0216, 'lps'),
	(483128, 126, '2015-04-01 00:51:34.000000', 'consum', 0.0214, 'lps'),
	(483129, 126, '2015-04-01 00:51:35.000000', 'consum', 0.0215, 'lps'),
	(483130, 126, '2015-04-01 00:51:36.000000', 'consum', 0.0223, 'lps'),
	(483131, 126, '2015-04-01 00:51:37.000000', 'consum', 0.0224, 'lps'),
	(483132, 126, '2015-04-01 00:51:38.000000', 'consum', 0.0223, 'lps'),
	(483133, 126, '2015-04-01 00:51:39.000000', 'consum', 0.0218, 'lps'),
	(483134, 126, '2015-04-01 00:51:40.000000', 'consum', 0.0227, 'lps'),
	(483135, 126, '2015-04-01 00:51:41.000000', 'consum', 0.0219, 'lps'),
	(483136, 126, '2015-04-01 00:51:42.000000', 'consum', 0.0223, 'lps'),
	(483137, 126, '2015-04-01 00:51:43.000000', 'consum', 0.0214, 'lps'),
	(483138, 126, '2015-04-01 00:51:44.000000', 'consum', 0.0224, 'lps'),
	(483139, 126, '2015-04-01 00:51:45.000000', 'consum', 0.0216, 'lps'),
	(483140, 126, '2015-04-01 00:51:46.000000', 'consum', 0.0217, 'lps'),
	(483141, 126, '2015-04-01 00:51:47.000000', 'consum', 0.0225, 'lps'),
	(483142, 126, '2015-04-01 00:51:48.000000', 'consum', 0.0212, 'lps'),
	(483143, 126, '2015-04-01 00:51:49.000000', 'consum', 0.0210, 'lps'),
	(483144, 126, '2015-04-01 00:51:50.000000', 'consum', 0.0224, 'lps'),
	(483145, 126, '2015-04-01 00:51:51.000000', 'consum', 0.0227, 'lps'),
	(483146, 126, '2015-04-01 00:51:52.000000', 'consum', 0.0215, 'lps'),
	(483147, 126, '2015-04-01 00:51:53.000000', 'consum', 0.0223, 'lps'),
	(483148, 126, '2015-04-01 00:51:54.000000', 'consum', 0.0223, 'lps'),
	(483149, 126, '2015-04-01 00:51:55.000000', 'consum', 0.0220, 'lps'),
	(483150, 126, '2015-04-01 00:51:56.000000', 'consum', 0.0223, 'lps'),
	(483151, 126, '2015-04-01 00:51:57.000000', 'consum', 0.0225, 'lps'),
	(483152, 126, '2015-04-01 00:51:58.000000', 'consum', 0.0210, 'lps'),
	(483153, 126, '2015-04-01 00:51:59.000000', 'consum', 0.0220, 'lps'),
	(483154, 126, '2015-04-01 00:52:00.000000', 'consum', 0.0223, 'lps'),
	(483155, 126, '2015-04-01 00:52:01.000000', 'consum', 0.0227, 'lps'),
	(483156, 126, '2015-04-01 00:52:02.000000', 'consum', 0.0223, 'lps'),
	(483157, 126, '2015-04-01 00:52:03.000000', 'consum', 0.0225, 'lps'),
	(483158, 126, '2015-04-01 00:52:04.000000', 'consum', 0.0226, 'lps'),
	(483159, 126, '2015-04-01 00:52:05.000000', 'consum', 0.0210, 'lps'),
	(483160, 126, '2015-04-01 00:52:06.000000', 'consum', 0.0216, 'lps'),
	(483161, 126, '2015-04-01 00:52:07.000000', 'consum', 0.0223, 'lps'),
	(483162, 126, '2015-04-01 00:52:08.000000', 'consum', 0.0220, 'lps'),
	(483163, 126, '2015-04-01 00:52:09.000000', 'consum', 0.0224, 'lps'),
	(483164, 126, '2015-04-01 00:52:10.000000', 'consum', 0.0215, 'lps'),
	(483165, 126, '2015-04-01 00:52:11.000000', 'consum', 0.0210, 'lps'),
	(483166, 126, '2015-04-01 00:52:12.000000', 'consum', 0.0212, 'lps'),
	(483167, 126, '2015-04-01 00:52:13.000000', 'consum', 0.0221, 'lps'),
	(483168, 126, '2015-04-01 00:52:14.000000', 'consum', 0.0225, 'lps'),
	(483169, 126, '2015-04-01 00:52:15.000000', 'consum', 0.0214, 'lps'),
	(483170, 126, '2015-04-01 00:52:16.000000', 'consum', 0.0222, 'lps'),
	(483171, 126, '2015-04-01 00:52:17.000000', 'consum', 0.0225, 'lps'),
	(483172, 126, '2015-04-01 00:52:18.000000', 'consum', 0.0211, 'lps'),
	(483173, 126, '2015-04-01 00:52:19.000000', 'consum', 0.0224, 'lps'),
	(483174, 126, '2015-04-01 00:52:20.000000', 'consum', 0.0224, 'lps'),
	(483175, 126, '2015-04-01 00:52:21.000000', 'consum', 0.0220, 'lps'),
	(483176, 126, '2015-04-01 00:52:22.000000', 'consum', 0.0220, 'lps'),
	(483177, 126, '2015-04-01 00:52:23.000000', 'consum', 0.0212, 'lps'),
	(483178, 126, '2015-04-01 00:52:24.000000', 'consum', 0.0226, 'lps'),
	(483179, 126, '2015-04-01 00:52:25.000000', 'consum', 0.0212, 'lps'),
	(483180, 126, '2015-04-01 00:52:26.000000', 'consum', 0.0210, 'lps'),
	(483181, 126, '2015-04-01 00:52:27.000000', 'consum', 0.0221, 'lps'),
	(483182, 126, '2015-04-01 00:52:28.000000', 'consum', 0.0214, 'lps'),
	(483183, 126, '2015-04-01 00:52:29.000000', 'consum', 0.0214, 'lps'),
	(483184, 126, '2015-04-01 00:52:30.000000', 'consum', 0.0217, 'lps'),
	(483185, 126, '2015-04-01 00:52:31.000000', 'consum', 0.0216, 'lps'),
	(483186, 126, '2015-04-01 00:52:32.000000', 'consum', 0.0219, 'lps'),
	(483187, 126, '2015-04-01 00:52:33.000000', 'consum', 0.0218, 'lps'),
	(483188, 126, '2015-04-01 00:52:34.000000', 'consum', 0.0227, 'lps'),
	(483189, 126, '2015-04-01 00:52:35.000000', 'consum', 0.0216, 'lps'),
	(483190, 126, '2015-04-01 00:52:36.000000', 'consum', 0.0227, 'lps'),
	(483191, 126, '2015-04-01 00:52:37.000000', 'consum', 0.0221, 'lps'),
	(483192, 126, '2015-04-01 00:52:38.000000', 'consum', 0.0216, 'lps'),
	(483193, 126, '2015-04-01 00:52:39.000000', 'consum', 0.0227, 'lps'),
	(483194, 126, '2015-04-01 00:52:40.000000', 'consum', 0.0221, 'lps'),
	(483195, 126, '2015-04-01 00:52:41.000000', 'consum', 0.0214, 'lps'),
	(483196, 126, '2015-04-01 00:52:42.000000', 'consum', 0.0214, 'lps'),
	(483197, 126, '2015-04-01 00:52:43.000000', 'consum', 0.0222, 'lps'),
	(483198, 126, '2015-04-01 00:52:44.000000', 'consum', 0.0220, 'lps'),
	(483199, 126, '2015-04-01 00:52:45.000000', 'consum', 0.0227, 'lps'),
	(483200, 126, '2015-04-01 00:52:46.000000', 'consum', 0.0210, 'lps'),
	(483201, 126, '2015-04-01 00:52:47.000000', 'consum', 0.0213, 'lps'),
	(483202, 126, '2015-04-01 00:52:48.000000', 'consum', 0.0227, 'lps'),
	(483203, 126, '2015-04-01 00:52:49.000000', 'consum', 0.0212, 'lps'),
	(483204, 126, '2015-04-01 00:52:50.000000', 'consum', 0.0225, 'lps'),
	(483205, 126, '2015-04-01 00:52:51.000000', 'consum', 0.0226, 'lps'),
	(483206, 126, '2015-04-01 00:52:52.000000', 'consum', 0.0227, 'lps'),
	(483207, 126, '2015-04-01 00:52:53.000000', 'consum', 0.0210, 'lps'),
	(483208, 126, '2015-04-01 00:52:54.000000', 'consum', 0.0213, 'lps'),
	(483209, 126, '2015-04-01 00:52:55.000000', 'consum', 0.0210, 'lps'),
	(483210, 126, '2015-04-01 00:52:56.000000', 'consum', 0.0220, 'lps'),
	(483211, 126, '2015-04-01 00:52:57.000000', 'consum', 0.0224, 'lps'),
	(483212, 126, '2015-04-01 00:52:58.000000', 'consum', 0.0214, 'lps'),
	(483213, 126, '2015-04-01 00:52:59.000000', 'consum', 0.0225, 'lps'),
	(483214, 126, '2015-04-01 00:53:00.000000', 'consum', 0.0219, 'lps'),
	(483215, 126, '2015-04-01 00:53:01.000000', 'consum', 0.0212, 'lps'),
	(483216, 126, '2015-04-01 00:53:02.000000', 'consum', 0.0212, 'lps'),
	(483217, 126, '2015-04-01 00:53:03.000000', 'consum', 0.0212, 'lps'),
	(483218, 126, '2015-04-01 00:53:04.000000', 'consum', 0.0215, 'lps'),
	(483219, 126, '2015-04-01 00:53:05.000000', 'consum', 0.0212, 'lps'),
	(483220, 126, '2015-04-01 00:53:06.000000', 'consum', 0.0223, 'lps'),
	(483221, 126, '2015-04-01 00:53:07.000000', 'consum', 0.0216, 'lps'),
	(483222, 126, '2015-04-01 00:53:08.000000', 'consum', 0.0219, 'lps'),
	(483223, 126, '2015-04-01 00:53:09.000000', 'consum', 0.0221, 'lps'),
	(483224, 126, '2015-04-01 00:53:10.000000', 'consum', 0.0219, 'lps'),
	(483225, 126, '2015-04-01 00:53:11.000000', 'consum', 0.0221, 'lps'),
	(483226, 126, '2015-04-01 00:53:12.000000', 'consum', 0.0222, 'lps'),
	(483227, 126, '2015-04-01 00:53:13.000000', 'consum', 0.0218, 'lps'),
	(483228, 126, '2015-04-01 00:53:14.000000', 'consum', 0.0214, 'lps'),
	(483229, 126, '2015-04-01 00:53:15.000000', 'consum', 0.0210, 'lps'),
	(483230, 126, '2015-04-01 00:53:16.000000', 'consum', 0.0213, 'lps'),
	(483231, 126, '2015-04-01 00:53:17.000000', 'consum', 0.0225, 'lps'),
	(483232, 126, '2015-04-01 00:53:18.000000', 'consum', 0.0225, 'lps'),
	(483233, 126, '2015-04-01 00:53:19.000000', 'consum', 0.0223, 'lps'),
	(483234, 126, '2015-04-01 00:53:20.000000', 'consum', 0.0213, 'lps'),
	(483235, 126, '2015-04-01 00:53:21.000000', 'consum', 0.0221, 'lps'),
	(483236, 126, '2015-04-01 00:53:22.000000', 'consum', 0.0223, 'lps'),
	(483237, 126, '2015-04-01 00:53:23.000000', 'consum', 0.0222, 'lps'),
	(483238, 126, '2015-04-01 00:53:24.000000', 'consum', 0.0213, 'lps'),
	(483239, 126, '2015-04-01 00:53:25.000000', 'consum', 0.0225, 'lps'),
	(483240, 126, '2015-04-01 00:53:26.000000', 'consum', 0.0222, 'lps'),
	(483241, 126, '2015-04-01 00:53:27.000000', 'consum', 0.0226, 'lps'),
	(483242, 126, '2015-04-01 00:53:28.000000', 'consum', 0.0217, 'lps'),
	(483243, 126, '2015-04-01 00:53:29.000000', 'consum', 0.0217, 'lps'),
	(483244, 126, '2015-04-01 00:53:30.000000', 'consum', 0.0225, 'lps'),
	(483245, 126, '2015-04-01 00:53:31.000000', 'consum', 0.0211, 'lps'),
	(483246, 126, '2015-04-01 00:53:32.000000', 'consum', 0.0225, 'lps'),
	(483247, 126, '2015-04-01 00:53:33.000000', 'consum', 0.0227, 'lps'),
	(483248, 126, '2015-04-01 00:53:34.000000', 'consum', 0.0215, 'lps'),
	(483249, 126, '2015-04-01 00:53:35.000000', 'consum', 0.0222, 'lps'),
	(483250, 126, '2015-04-01 00:53:36.000000', 'consum', 0.0221, 'lps'),
	(483251, 126, '2015-04-01 00:53:37.000000', 'consum', 0.0226, 'lps'),
	(483252, 126, '2015-04-01 00:53:38.000000', 'consum', 0.0222, 'lps'),
	(483253, 126, '2015-04-01 00:53:39.000000', 'consum', 0.0222, 'lps'),
	(483254, 126, '2015-04-01 00:53:40.000000', 'consum', 0.0217, 'lps'),
	(483255, 126, '2015-04-01 00:53:41.000000', 'consum', 0.0227, 'lps'),
	(483256, 126, '2015-04-01 00:53:42.000000', 'consum', 0.0222, 'lps'),
	(483257, 126, '2015-04-01 00:53:43.000000', 'consum', 0.0219, 'lps'),
	(483258, 126, '2015-04-01 00:53:44.000000', 'consum', 0.0220, 'lps'),
	(483259, 126, '2015-04-01 00:53:45.000000', 'consum', 0.0214, 'lps'),
	(483260, 126, '2015-04-01 00:53:46.000000', 'consum', 0.0220, 'lps'),
	(483261, 126, '2015-04-01 00:53:47.000000', 'consum', 0.0211, 'lps'),
	(483262, 126, '2015-04-01 00:53:48.000000', 'consum', 0.0222, 'lps'),
	(483263, 126, '2015-04-01 00:53:49.000000', 'consum', 0.0215, 'lps'),
	(483264, 126, '2015-04-01 00:53:50.000000', 'consum', 0.0217, 'lps'),
	(483265, 126, '2015-04-01 00:53:51.000000', 'consum', 0.0213, 'lps'),
	(483266, 126, '2015-04-01 00:53:52.000000', 'consum', 0.0223, 'lps'),
	(483267, 126, '2015-04-01 00:53:53.000000', 'consum', 0.0213, 'lps'),
	(483268, 126, '2015-04-01 00:53:54.000000', 'consum', 0.0222, 'lps'),
	(483269, 126, '2015-04-01 00:53:55.000000', 'consum', 0.0226, 'lps'),
	(483270, 126, '2015-04-01 00:53:56.000000', 'consum', 0.0219, 'lps'),
	(483271, 126, '2015-04-01 00:53:57.000000', 'consum', 0.0225, 'lps'),
	(483272, 126, '2015-04-01 00:53:58.000000', 'consum', 0.0224, 'lps'),
	(483273, 126, '2015-04-01 00:53:59.000000', 'consum', 0.0216, 'lps'),
	(483274, 126, '2015-04-01 00:54:00.000000', 'consum', 0.0218, 'lps'),
	(483275, 126, '2015-04-01 00:54:01.000000', 'consum', 0.0212, 'lps'),
	(483276, 126, '2015-04-01 00:54:02.000000', 'consum', 0.0216, 'lps'),
	(483277, 126, '2015-04-01 00:54:03.000000', 'consum', 0.0218, 'lps'),
	(483278, 126, '2015-04-01 00:54:04.000000', 'consum', 0.0215, 'lps'),
	(483279, 126, '2015-04-01 00:54:05.000000', 'consum', 0.0227, 'lps'),
	(483280, 126, '2015-04-01 00:54:06.000000', 'consum', 0.0226, 'lps'),
	(483281, 126, '2015-04-01 00:54:07.000000', 'consum', 0.0224, 'lps'),
	(483282, 126, '2015-04-01 00:54:08.000000', 'consum', 0.0215, 'lps'),
	(483283, 126, '2015-04-01 00:54:09.000000', 'consum', 0.0210, 'lps'),
	(483284, 126, '2015-04-01 00:54:10.000000', 'consum', 0.0213, 'lps'),
	(483285, 126, '2015-04-01 00:54:11.000000', 'consum', 0.0226, 'lps'),
	(483286, 126, '2015-04-01 00:54:12.000000', 'consum', 0.0210, 'lps'),
	(483287, 126, '2015-04-01 00:54:13.000000', 'consum', 0.0217, 'lps'),
	(483288, 126, '2015-04-01 00:54:14.000000', 'consum', 0.0226, 'lps'),
	(483289, 126, '2015-04-01 00:54:15.000000', 'consum', 0.0214, 'lps'),
	(483290, 126, '2015-04-01 00:54:16.000000', 'consum', 0.0222, 'lps'),
	(483291, 126, '2015-04-01 00:54:17.000000', 'consum', 0.0221, 'lps'),
	(483292, 126, '2015-04-01 00:54:18.000000', 'consum', 0.0212, 'lps'),
	(483293, 126, '2015-04-01 00:54:19.000000', 'consum', 0.0222, 'lps'),
	(483294, 126, '2015-04-01 00:54:20.000000', 'consum', 0.0210, 'lps'),
	(483295, 126, '2015-04-01 00:54:21.000000', 'consum', 0.0212, 'lps'),
	(483296, 126, '2015-04-01 00:54:22.000000', 'consum', 0.0218, 'lps'),
	(483297, 126, '2015-04-01 00:54:23.000000', 'consum', 0.0212, 'lps'),
	(483298, 126, '2015-04-01 00:54:24.000000', 'consum', 0.0212, 'lps'),
	(483299, 126, '2015-04-01 00:54:25.000000', 'consum', 0.0216, 'lps'),
	(483300, 126, '2015-04-01 00:54:26.000000', 'consum', 0.0214, 'lps'),
	(483301, 126, '2015-04-01 00:54:27.000000', 'consum', 0.0215, 'lps'),
	(483302, 126, '2015-04-01 00:54:28.000000', 'consum', 0.0222, 'lps'),
	(483303, 126, '2015-04-01 00:54:29.000000', 'consum', 0.0219, 'lps'),
	(483304, 126, '2015-04-01 00:54:30.000000', 'consum', 0.0219, 'lps'),
	(483305, 126, '2015-04-01 00:54:31.000000', 'consum', 0.0212, 'lps'),
	(483306, 126, '2015-04-01 00:54:32.000000', 'consum', 0.0210, 'lps'),
	(483307, 126, '2015-04-01 00:54:33.000000', 'consum', 0.0225, 'lps'),
	(483308, 126, '2015-04-01 00:54:34.000000', 'consum', 0.0212, 'lps'),
	(483309, 126, '2015-04-01 00:54:35.000000', 'consum', 0.0213, 'lps'),
	(483310, 126, '2015-04-01 00:54:36.000000', 'consum', 0.0218, 'lps'),
	(483311, 126, '2015-04-01 00:54:37.000000', 'consum', 0.0225, 'lps'),
	(483312, 126, '2015-04-01 00:54:38.000000', 'consum', 0.0225, 'lps'),
	(483313, 126, '2015-04-01 00:54:39.000000', 'consum', 0.0220, 'lps'),
	(483314, 126, '2015-04-01 00:54:40.000000', 'consum', 0.0218, 'lps'),
	(483315, 126, '2015-04-01 00:54:41.000000', 'consum', 0.0220, 'lps'),
	(483316, 126, '2015-04-01 00:54:42.000000', 'consum', 0.0220, 'lps'),
	(483317, 126, '2015-04-01 00:54:43.000000', 'consum', 0.0227, 'lps'),
	(483318, 126, '2015-04-01 00:54:44.000000', 'consum', 0.0215, 'lps'),
	(483319, 126, '2015-04-01 00:54:45.000000', 'consum', 0.0218, 'lps'),
	(483320, 126, '2015-04-01 00:54:46.000000', 'consum', 0.0216, 'lps'),
	(483321, 126, '2015-04-01 00:54:47.000000', 'consum', 0.0220, 'lps'),
	(483322, 126, '2015-04-01 00:54:48.000000', 'consum', 0.0223, 'lps'),
	(483323, 126, '2015-04-01 00:54:49.000000', 'consum', 0.0212, 'lps'),
	(483324, 126, '2015-04-01 00:54:50.000000', 'consum', 0.0214, 'lps'),
	(483325, 126, '2015-04-01 00:54:51.000000', 'consum', 0.0225, 'lps'),
	(483326, 126, '2015-04-01 00:54:52.000000', 'consum', 0.0221, 'lps'),
	(483327, 126, '2015-04-01 00:54:53.000000', 'consum', 0.0218, 'lps'),
	(483328, 126, '2015-04-01 00:54:54.000000', 'consum', 0.0220, 'lps'),
	(483329, 126, '2015-04-01 00:54:55.000000', 'consum', 0.0216, 'lps'),
	(483330, 126, '2015-04-01 00:54:56.000000', 'consum', 0.0212, 'lps'),
	(483331, 126, '2015-04-01 00:54:57.000000', 'consum', 0.0221, 'lps'),
	(483332, 126, '2015-04-01 00:54:58.000000', 'consum', 0.0221, 'lps'),
	(483333, 126, '2015-04-01 00:54:59.000000', 'consum', 0.0216, 'lps'),
	(483334, 126, '2015-04-01 00:55:00.000000', 'consum', 0.0227, 'lps'),
	(483335, 126, '2015-04-01 00:55:01.000000', 'consum', 0.0221, 'lps'),
	(483336, 126, '2015-04-01 00:55:02.000000', 'consum', 0.0215, 'lps'),
	(483337, 126, '2015-04-01 00:55:03.000000', 'consum', 0.0223, 'lps'),
	(483338, 126, '2015-04-01 00:55:04.000000', 'consum', 0.0222, 'lps'),
	(483339, 126, '2015-04-01 00:55:05.000000', 'consum', 0.0213, 'lps'),
	(483340, 126, '2015-04-01 00:55:06.000000', 'consum', 0.0226, 'lps'),
	(483341, 126, '2015-04-01 00:55:07.000000', 'consum', 0.0227, 'lps'),
	(483342, 126, '2015-04-01 00:55:08.000000', 'consum', 0.0212, 'lps'),
	(483343, 126, '2015-04-01 00:55:09.000000', 'consum', 0.0223, 'lps'),
	(483344, 126, '2015-04-01 00:55:10.000000', 'consum', 0.0216, 'lps'),
	(483345, 126, '2015-04-01 00:55:11.000000', 'consum', 0.0220, 'lps'),
	(483346, 126, '2015-04-01 00:55:12.000000', 'consum', 0.0223, 'lps'),
	(483347, 126, '2015-04-01 00:55:13.000000', 'consum', 0.0226, 'lps'),
	(483348, 126, '2015-04-01 00:55:14.000000', 'consum', 0.0218, 'lps'),
	(483349, 126, '2015-04-01 00:55:15.000000', 'consum', 0.0219, 'lps'),
	(483350, 126, '2015-04-01 00:55:16.000000', 'consum', 0.0216, 'lps'),
	(483351, 126, '2015-04-01 00:55:17.000000', 'consum', 0.0212, 'lps'),
	(483352, 126, '2015-04-01 00:55:18.000000', 'consum', 0.0220, 'lps'),
	(483353, 126, '2015-04-01 00:55:19.000000', 'consum', 0.0221, 'lps'),
	(483354, 126, '2015-04-01 00:55:20.000000', 'consum', 0.0216, 'lps'),
	(483355, 126, '2015-04-01 00:55:21.000000', 'consum', 0.0225, 'lps'),
	(483356, 126, '2015-04-01 00:55:22.000000', 'consum', 0.0212, 'lps'),
	(483357, 126, '2015-04-01 00:55:23.000000', 'consum', 0.0213, 'lps'),
	(483358, 126, '2015-04-01 00:55:24.000000', 'consum', 0.0219, 'lps'),
	(483359, 126, '2015-04-01 00:55:25.000000', 'consum', 0.0210, 'lps'),
	(483360, 126, '2015-04-01 00:55:26.000000', 'consum', 0.0221, 'lps'),
	(483361, 126, '2015-04-01 00:55:27.000000', 'consum', 0.0212, 'lps'),
	(483362, 126, '2015-04-01 00:55:28.000000', 'consum', 0.0224, 'lps'),
	(483363, 126, '2015-04-01 00:55:29.000000', 'consum', 0.0218, 'lps'),
	(483364, 126, '2015-04-01 00:55:30.000000', 'consum', 0.0211, 'lps'),
	(483365, 126, '2015-04-01 00:55:31.000000', 'consum', 0.0210, 'lps'),
	(483366, 126, '2015-04-01 00:55:32.000000', 'consum', 0.0226, 'lps'),
	(483367, 126, '2015-04-01 00:55:33.000000', 'consum', 0.0218, 'lps'),
	(483368, 126, '2015-04-01 00:55:34.000000', 'consum', 0.0220, 'lps'),
	(483369, 126, '2015-04-01 00:55:35.000000', 'consum', 0.0219, 'lps'),
	(483370, 126, '2015-04-01 00:55:36.000000', 'consum', 0.0223, 'lps'),
	(483371, 126, '2015-04-01 00:55:37.000000', 'consum', 0.0216, 'lps'),
	(483372, 126, '2015-04-01 00:55:38.000000', 'consum', 0.0218, 'lps'),
	(483373, 126, '2015-04-01 00:55:39.000000', 'consum', 0.0215, 'lps'),
	(483374, 126, '2015-04-01 00:55:40.000000', 'consum', 0.0212, 'lps'),
	(483375, 126, '2015-04-01 00:55:41.000000', 'consum', 0.0221, 'lps'),
	(483376, 126, '2015-04-01 00:55:42.000000', 'consum', 0.0226, 'lps'),
	(483377, 126, '2015-04-01 00:55:43.000000', 'consum', 0.0220, 'lps'),
	(483378, 126, '2015-04-01 00:55:44.000000', 'consum', 0.0213, 'lps'),
	(483379, 126, '2015-04-01 00:55:45.000000', 'consum', 0.0213, 'lps'),
	(483380, 126, '2015-04-01 00:55:46.000000', 'consum', 0.0217, 'lps'),
	(483381, 126, '2015-04-01 00:55:47.000000', 'consum', 0.0218, 'lps'),
	(483382, 126, '2015-04-01 00:55:48.000000', 'consum', 0.0211, 'lps'),
	(483383, 126, '2015-04-01 00:55:49.000000', 'consum', 0.0227, 'lps'),
	(483384, 126, '2015-04-01 00:55:50.000000', 'consum', 0.0219, 'lps'),
	(483385, 126, '2015-04-01 00:55:51.000000', 'consum', 0.0225, 'lps'),
	(483386, 126, '2015-04-01 00:55:52.000000', 'consum', 0.0221, 'lps'),
	(483387, 126, '2015-04-01 00:55:53.000000', 'consum', 0.0220, 'lps'),
	(483388, 126, '2015-04-01 00:55:54.000000', 'consum', 0.0211, 'lps'),
	(483389, 126, '2015-04-01 00:55:55.000000', 'consum', 0.0221, 'lps'),
	(483390, 126, '2015-04-01 00:55:56.000000', 'consum', 0.0225, 'lps'),
	(483391, 126, '2015-04-01 00:55:57.000000', 'consum', 0.0218, 'lps'),
	(483392, 126, '2015-04-01 00:55:58.000000', 'consum', 0.0221, 'lps'),
	(483393, 126, '2015-04-01 00:55:59.000000', 'consum', 0.0226, 'lps'),
	(483394, 126, '2015-04-01 00:56:00.000000', 'consum', 0.0222, 'lps'),
	(483395, 126, '2015-04-01 00:56:01.000000', 'consum', 0.0222, 'lps'),
	(483396, 126, '2015-04-01 00:56:02.000000', 'consum', 0.0214, 'lps'),
	(483397, 126, '2015-04-01 00:56:03.000000', 'consum', 0.0215, 'lps'),
	(483398, 126, '2015-04-01 00:56:04.000000', 'consum', 0.0221, 'lps'),
	(483399, 126, '2015-04-01 00:56:05.000000', 'consum', 0.0217, 'lps'),
	(483400, 126, '2015-04-01 00:56:06.000000', 'consum', 0.0211, 'lps'),
	(483401, 126, '2015-04-01 00:56:07.000000', 'consum', 0.0214, 'lps'),
	(483402, 126, '2015-04-01 00:56:08.000000', 'consum', 0.0227, 'lps'),
	(483403, 126, '2015-04-01 00:56:09.000000', 'consum', 0.0213, 'lps'),
	(483404, 126, '2015-04-01 00:56:10.000000', 'consum', 0.0211, 'lps'),
	(483405, 126, '2015-04-01 00:56:11.000000', 'consum', 0.0225, 'lps'),
	(483406, 126, '2015-04-01 00:56:12.000000', 'consum', 0.0226, 'lps'),
	(483407, 126, '2015-04-01 00:56:13.000000', 'consum', 0.0210, 'lps'),
	(483408, 126, '2015-04-01 00:56:14.000000', 'consum', 0.0215, 'lps'),
	(483409, 126, '2015-04-01 00:56:15.000000', 'consum', 0.0219, 'lps'),
	(483410, 126, '2015-04-01 00:56:16.000000', 'consum', 0.0222, 'lps'),
	(483411, 126, '2015-04-01 00:56:17.000000', 'consum', 0.0225, 'lps'),
	(483412, 126, '2015-04-01 00:56:18.000000', 'consum', 0.0214, 'lps'),
	(483413, 126, '2015-04-01 00:56:19.000000', 'consum', 0.0222, 'lps'),
	(483414, 126, '2015-04-01 00:56:20.000000', 'consum', 0.0223, 'lps'),
	(483415, 126, '2015-04-01 00:56:21.000000', 'consum', 0.0222, 'lps'),
	(483416, 126, '2015-04-01 00:56:22.000000', 'consum', 0.0211, 'lps'),
	(483417, 126, '2015-04-01 00:56:23.000000', 'consum', 0.0218, 'lps'),
	(483418, 126, '2015-04-01 00:56:24.000000', 'consum', 0.0211, 'lps'),
	(483419, 126, '2015-04-01 00:56:25.000000', 'consum', 0.0210, 'lps'),
	(483420, 126, '2015-04-01 00:56:26.000000', 'consum', 0.0226, 'lps'),
	(483421, 126, '2015-04-01 00:56:27.000000', 'consum', 0.0217, 'lps'),
	(483422, 126, '2015-04-01 00:56:28.000000', 'consum', 0.0217, 'lps'),
	(483423, 126, '2015-04-01 00:56:29.000000', 'consum', 0.0224, 'lps'),
	(483424, 126, '2015-04-01 00:56:30.000000', 'consum', 0.0223, 'lps'),
	(483425, 126, '2015-04-01 00:56:31.000000', 'consum', 0.0216, 'lps'),
	(483426, 126, '2015-04-01 00:56:32.000000', 'consum', 0.0221, 'lps'),
	(483427, 126, '2015-04-01 00:56:33.000000', 'consum', 0.0212, 'lps'),
	(483428, 126, '2015-04-01 00:56:34.000000', 'consum', 0.0222, 'lps'),
	(483429, 126, '2015-04-01 00:56:35.000000', 'consum', 0.0211, 'lps'),
	(483430, 126, '2015-04-01 00:56:36.000000', 'consum', 0.0216, 'lps'),
	(483431, 126, '2015-04-01 00:56:37.000000', 'consum', 0.0218, 'lps'),
	(483432, 126, '2015-04-01 00:56:38.000000', 'consum', 0.0214, 'lps'),
	(483433, 126, '2015-04-01 00:56:39.000000', 'consum', 0.0226, 'lps'),
	(483434, 126, '2015-04-01 00:56:40.000000', 'consum', 0.0223, 'lps'),
	(483435, 126, '2015-04-01 00:56:41.000000', 'consum', 0.0212, 'lps'),
	(483436, 126, '2015-04-01 00:56:42.000000', 'consum', 0.0215, 'lps'),
	(483437, 126, '2015-04-01 00:56:43.000000', 'consum', 0.0212, 'lps'),
	(483438, 126, '2015-04-01 00:56:44.000000', 'consum', 0.0225, 'lps'),
	(483439, 126, '2015-04-01 00:56:45.000000', 'consum', 0.0225, 'lps'),
	(483440, 126, '2015-04-01 00:56:46.000000', 'consum', 0.0224, 'lps'),
	(483441, 126, '2015-04-01 00:56:47.000000', 'consum', 0.0215, 'lps'),
	(483442, 126, '2015-04-01 00:56:48.000000', 'consum', 0.0210, 'lps'),
	(483443, 126, '2015-04-01 00:56:49.000000', 'consum', 0.0217, 'lps'),
	(483444, 126, '2015-04-01 00:56:50.000000', 'consum', 0.0226, 'lps'),
	(483445, 126, '2015-04-01 00:56:51.000000', 'consum', 0.0214, 'lps'),
	(483446, 126, '2015-04-01 00:56:52.000000', 'consum', 0.0218, 'lps'),
	(483447, 126, '2015-04-01 00:56:53.000000', 'consum', 0.0222, 'lps'),
	(483448, 126, '2015-04-01 00:56:54.000000', 'consum', 0.0212, 'lps'),
	(483449, 126, '2015-04-01 00:56:55.000000', 'consum', 0.0217, 'lps'),
	(483450, 126, '2015-04-01 00:56:56.000000', 'consum', 0.0225, 'lps'),
	(483451, 126, '2015-04-01 00:56:57.000000', 'consum', 0.0227, 'lps'),
	(483452, 126, '2015-04-01 00:56:58.000000', 'consum', 0.0215, 'lps'),
	(483453, 126, '2015-04-01 00:56:59.000000', 'consum', 0.0221, 'lps'),
	(483454, 126, '2015-04-01 00:57:00.000000', 'consum', 0.0212, 'lps'),
	(483455, 126, '2015-04-01 00:57:01.000000', 'consum', 0.0225, 'lps'),
	(483456, 126, '2015-04-01 00:57:02.000000', 'consum', 0.0223, 'lps'),
	(483457, 126, '2015-04-01 00:57:03.000000', 'consum', 0.0216, 'lps'),
	(483458, 126, '2015-04-01 00:57:04.000000', 'consum', 0.0217, 'lps'),
	(483459, 126, '2015-04-01 00:57:05.000000', 'consum', 0.0211, 'lps'),
	(483460, 126, '2015-04-01 00:57:06.000000', 'consum', 0.0213, 'lps'),
	(483461, 126, '2015-04-01 00:57:07.000000', 'consum', 0.0222, 'lps'),
	(483462, 126, '2015-04-01 00:57:08.000000', 'consum', 0.0223, 'lps'),
	(483463, 126, '2015-04-01 00:57:09.000000', 'consum', 0.0224, 'lps'),
	(483464, 126, '2015-04-01 00:57:10.000000', 'consum', 0.0224, 'lps'),
	(483465, 126, '2015-04-01 00:57:11.000000', 'consum', 0.0219, 'lps'),
	(483466, 126, '2015-04-01 00:57:12.000000', 'consum', 0.0215, 'lps'),
	(483467, 126, '2015-04-01 00:57:13.000000', 'consum', 0.0210, 'lps'),
	(483468, 126, '2015-04-01 00:57:14.000000', 'consum', 0.0210, 'lps'),
	(483469, 126, '2015-04-01 00:57:15.000000', 'consum', 0.0212, 'lps'),
	(483470, 126, '2015-04-01 00:57:16.000000', 'consum', 0.0220, 'lps'),
	(483471, 126, '2015-04-01 00:57:17.000000', 'consum', 0.0219, 'lps'),
	(483472, 126, '2015-04-01 00:57:18.000000', 'consum', 0.0226, 'lps'),
	(483473, 126, '2015-04-01 00:57:19.000000', 'consum', 0.0227, 'lps'),
	(483474, 126, '2015-04-01 00:57:20.000000', 'consum', 0.0210, 'lps'),
	(483475, 126, '2015-04-01 00:57:21.000000', 'consum', 0.0215, 'lps'),
	(483476, 126, '2015-04-01 00:57:22.000000', 'consum', 0.0218, 'lps'),
	(483477, 126, '2015-04-01 00:57:23.000000', 'consum', 0.0217, 'lps'),
	(483478, 126, '2015-04-01 00:57:24.000000', 'consum', 0.0219, 'lps'),
	(483479, 126, '2015-04-01 00:57:25.000000', 'consum', 0.0220, 'lps'),
	(483480, 126, '2015-04-01 00:57:26.000000', 'consum', 0.0216, 'lps'),
	(483481, 126, '2015-04-01 00:57:27.000000', 'consum', 0.0225, 'lps'),
	(483482, 126, '2015-04-01 00:57:28.000000', 'consum', 0.0216, 'lps'),
	(483483, 126, '2015-04-01 00:57:29.000000', 'consum', 0.0212, 'lps'),
	(483484, 126, '2015-04-01 00:57:30.000000', 'consum', 0.0222, 'lps'),
	(483485, 126, '2015-04-01 00:57:31.000000', 'consum', 0.0226, 'lps'),
	(483486, 126, '2015-04-01 00:57:32.000000', 'consum', 0.0222, 'lps'),
	(483487, 126, '2015-04-01 00:57:33.000000', 'consum', 0.0220, 'lps'),
	(483488, 126, '2015-04-01 00:57:34.000000', 'consum', 0.0226, 'lps'),
	(483489, 126, '2015-04-01 00:57:35.000000', 'consum', 0.0223, 'lps'),
	(483490, 126, '2015-04-01 00:57:36.000000', 'consum', 0.0211, 'lps'),
	(483491, 126, '2015-04-01 00:57:37.000000', 'consum', 0.0211, 'lps'),
	(483492, 126, '2015-04-01 00:57:38.000000', 'consum', 0.0215, 'lps'),
	(483493, 126, '2015-04-01 00:57:39.000000', 'consum', 0.0214, 'lps'),
	(483494, 126, '2015-04-01 00:57:40.000000', 'consum', 0.0213, 'lps'),
	(483495, 126, '2015-04-01 00:57:41.000000', 'consum', 0.0216, 'lps'),
	(483496, 126, '2015-04-01 00:57:42.000000', 'consum', 0.0212, 'lps'),
	(483497, 126, '2015-04-01 00:57:43.000000', 'consum', 0.0221, 'lps'),
	(483498, 126, '2015-04-01 00:57:44.000000', 'consum', 0.0222, 'lps'),
	(483499, 126, '2015-04-01 00:57:45.000000', 'consum', 0.0223, 'lps'),
	(483500, 126, '2015-04-01 00:57:46.000000', 'consum', 0.0218, 'lps'),
	(483501, 126, '2015-04-01 00:57:47.000000', 'consum', 0.0211, 'lps'),
	(483502, 126, '2015-04-01 00:57:48.000000', 'consum', 0.0213, 'lps'),
	(483503, 126, '2015-04-01 00:57:49.000000', 'consum', 0.0219, 'lps'),
	(483504, 126, '2015-04-01 00:57:50.000000', 'consum', 0.0213, 'lps'),
	(483505, 126, '2015-04-01 00:57:51.000000', 'consum', 0.0217, 'lps'),
	(483506, 126, '2015-04-01 00:57:52.000000', 'consum', 0.0217, 'lps'),
	(483507, 126, '2015-04-01 00:57:53.000000', 'consum', 0.0224, 'lps'),
	(483508, 126, '2015-04-01 00:57:54.000000', 'consum', 0.0226, 'lps'),
	(483509, 126, '2015-04-01 00:57:55.000000', 'consum', 0.0210, 'lps'),
	(483510, 126, '2015-04-01 00:57:56.000000', 'consum', 0.0217, 'lps'),
	(483511, 126, '2015-04-01 00:57:57.000000', 'consum', 0.0227, 'lps'),
	(483512, 126, '2015-04-01 00:57:58.000000', 'consum', 0.0223, 'lps'),
	(483513, 126, '2015-04-01 00:57:59.000000', 'consum', 0.0223, 'lps'),
	(483514, 126, '2015-04-01 00:58:00.000000', 'consum', 0.0219, 'lps'),
	(483515, 126, '2015-04-01 00:58:01.000000', 'consum', 0.0216, 'lps'),
	(483516, 126, '2015-04-01 00:58:02.000000', 'consum', 0.0212, 'lps'),
	(483517, 126, '2015-04-01 00:58:03.000000', 'consum', 0.0224, 'lps'),
	(483518, 126, '2015-04-01 00:58:04.000000', 'consum', 0.0217, 'lps'),
	(483519, 126, '2015-04-01 00:58:05.000000', 'consum', 0.0223, 'lps'),
	(483520, 126, '2015-04-01 00:58:06.000000', 'consum', 0.0217, 'lps'),
	(483521, 126, '2015-04-01 00:58:07.000000', 'consum', 0.0224, 'lps'),
	(483522, 126, '2015-04-01 00:58:08.000000', 'consum', 0.0225, 'lps'),
	(483523, 126, '2015-04-01 00:58:09.000000', 'consum', 0.0227, 'lps'),
	(483524, 126, '2015-04-01 00:58:10.000000', 'consum', 0.0212, 'lps'),
	(483525, 126, '2015-04-01 00:58:11.000000', 'consum', 0.0223, 'lps'),
	(483526, 126, '2015-04-01 00:58:12.000000', 'consum', 0.0215, 'lps'),
	(483527, 126, '2015-04-01 00:58:13.000000', 'consum', 0.0217, 'lps'),
	(483528, 126, '2015-04-01 00:58:14.000000', 'consum', 0.0213, 'lps'),
	(483529, 126, '2015-04-01 00:58:15.000000', 'consum', 0.0221, 'lps'),
	(483530, 126, '2015-04-01 00:58:16.000000', 'consum', 0.0220, 'lps'),
	(483531, 126, '2015-04-01 00:58:17.000000', 'consum', 0.0226, 'lps'),
	(483532, 126, '2015-04-01 00:58:18.000000', 'consum', 0.0210, 'lps'),
	(483533, 126, '2015-04-01 00:58:19.000000', 'consum', 0.0214, 'lps'),
	(483534, 126, '2015-04-01 00:58:20.000000', 'consum', 0.0214, 'lps'),
	(483535, 126, '2015-04-01 00:58:21.000000', 'consum', 0.0217, 'lps'),
	(483536, 126, '2015-04-01 00:58:22.000000', 'consum', 0.0216, 'lps'),
	(483537, 126, '2015-04-01 00:58:23.000000', 'consum', 0.0221, 'lps'),
	(483538, 126, '2015-04-01 00:58:24.000000', 'consum', 0.0227, 'lps'),
	(483539, 126, '2015-04-01 00:58:25.000000', 'consum', 0.0226, 'lps'),
	(483540, 126, '2015-04-01 00:58:26.000000', 'consum', 0.0221, 'lps'),
	(483541, 126, '2015-04-01 00:58:27.000000', 'consum', 0.0218, 'lps'),
	(483542, 126, '2015-04-01 00:58:28.000000', 'consum', 0.0218, 'lps'),
	(483543, 126, '2015-04-01 00:58:29.000000', 'consum', 0.0210, 'lps'),
	(483544, 126, '2015-04-01 00:58:30.000000', 'consum', 0.0221, 'lps'),
	(483545, 126, '2015-04-01 00:58:31.000000', 'consum', 0.0212, 'lps'),
	(483546, 126, '2015-04-01 00:58:32.000000', 'consum', 0.0225, 'lps'),
	(483547, 126, '2015-04-01 00:58:33.000000', 'consum', 0.0226, 'lps'),
	(483548, 126, '2015-04-01 00:58:34.000000', 'consum', 0.0227, 'lps'),
	(483549, 126, '2015-04-01 00:58:35.000000', 'consum', 0.0212, 'lps'),
	(483550, 126, '2015-04-01 00:58:36.000000', 'consum', 0.0222, 'lps'),
	(483551, 126, '2015-04-01 00:58:37.000000', 'consum', 0.0210, 'lps'),
	(483552, 126, '2015-04-01 00:58:38.000000', 'consum', 0.0213, 'lps'),
	(483553, 126, '2015-04-01 00:58:39.000000', 'consum', 0.0225, 'lps'),
	(483554, 126, '2015-04-01 00:58:40.000000', 'consum', 0.0222, 'lps'),
	(483555, 126, '2015-04-01 00:58:41.000000', 'consum', 0.0225, 'lps'),
	(483556, 126, '2015-04-01 00:58:42.000000', 'consum', 0.0214, 'lps'),
	(483557, 126, '2015-04-01 00:58:43.000000', 'consum', 0.0221, 'lps'),
	(483558, 126, '2015-04-01 00:58:44.000000', 'consum', 0.0217, 'lps'),
	(483559, 126, '2015-04-01 00:58:45.000000', 'consum', 0.0215, 'lps'),
	(483560, 126, '2015-04-01 00:58:46.000000', 'consum', 0.0213, 'lps'),
	(483561, 126, '2015-04-01 00:58:47.000000', 'consum', 0.0211, 'lps'),
	(483562, 126, '2015-04-01 00:58:48.000000', 'consum', 0.0224, 'lps'),
	(483563, 126, '2015-04-01 00:58:49.000000', 'consum', 0.0224, 'lps'),
	(483564, 126, '2015-04-01 00:58:50.000000', 'consum', 0.0222, 'lps'),
	(483565, 126, '2015-04-01 00:58:51.000000', 'consum', 0.0210, 'lps'),
	(483566, 126, '2015-04-01 00:58:52.000000', 'consum', 0.0227, 'lps'),
	(483567, 126, '2015-04-01 00:58:53.000000', 'consum', 0.0226, 'lps'),
	(483568, 126, '2015-04-01 00:58:54.000000', 'consum', 0.0221, 'lps'),
	(483569, 126, '2015-04-01 00:58:55.000000', 'consum', 0.0215, 'lps'),
	(483570, 126, '2015-04-01 00:58:56.000000', 'consum', 0.0222, 'lps'),
	(483571, 126, '2015-04-01 00:58:57.000000', 'consum', 0.0221, 'lps'),
	(483572, 126, '2015-04-01 00:58:58.000000', 'consum', 0.0210, 'lps'),
	(483573, 126, '2015-04-01 00:58:59.000000', 'consum', 0.0212, 'lps'),
	(483574, 126, '2015-04-01 00:59:00.000000', 'consum', 0.0223, 'lps'),
	(483575, 126, '2015-04-01 00:59:01.000000', 'consum', 0.0216, 'lps'),
	(483576, 126, '2015-04-01 00:59:02.000000', 'consum', 0.0219, 'lps'),
	(483577, 126, '2015-04-01 00:59:03.000000', 'consum', 0.0220, 'lps'),
	(483578, 126, '2015-04-01 00:59:04.000000', 'consum', 0.0217, 'lps'),
	(483579, 126, '2015-04-01 00:59:05.000000', 'consum', 0.0212, 'lps'),
	(483580, 126, '2015-04-01 00:59:06.000000', 'consum', 0.0220, 'lps'),
	(483581, 126, '2015-04-01 00:59:07.000000', 'consum', 0.0219, 'lps'),
	(483582, 126, '2015-04-01 00:59:08.000000', 'consum', 0.0225, 'lps'),
	(483583, 126, '2015-04-01 00:59:09.000000', 'consum', 0.0222, 'lps'),
	(483584, 126, '2015-04-01 00:59:10.000000', 'consum', 0.0226, 'lps'),
	(483585, 126, '2015-04-01 00:59:11.000000', 'consum', 0.0219, 'lps'),
	(483586, 126, '2015-04-01 00:59:12.000000', 'consum', 0.0224, 'lps'),
	(483587, 126, '2015-04-01 00:59:13.000000', 'consum', 0.0219, 'lps'),
	(483588, 126, '2015-04-01 00:59:14.000000', 'consum', 0.0215, 'lps'),
	(483589, 126, '2015-04-01 00:59:15.000000', 'consum', 0.0225, 'lps'),
	(483590, 126, '2015-04-01 00:59:16.000000', 'consum', 0.0218, 'lps'),
	(483591, 126, '2015-04-01 00:59:17.000000', 'consum', 0.0223, 'lps'),
	(483592, 126, '2015-04-01 00:59:18.000000', 'consum', 0.0214, 'lps'),
	(483593, 126, '2015-04-01 00:59:19.000000', 'consum', 0.0227, 'lps'),
	(483594, 126, '2015-04-01 00:59:20.000000', 'consum', 0.0211, 'lps'),
	(483595, 126, '2015-04-01 00:59:21.000000', 'consum', 0.0219, 'lps'),
	(483596, 126, '2015-04-01 00:59:22.000000', 'consum', 0.0219, 'lps'),
	(483597, 126, '2015-04-01 00:59:23.000000', 'consum', 0.0225, 'lps'),
	(483598, 126, '2015-04-01 00:59:24.000000', 'consum', 0.0224, 'lps'),
	(483599, 126, '2015-04-01 00:59:25.000000', 'consum', 0.0216, 'lps'),
	(483600, 126, '2015-04-01 00:59:26.000000', 'consum', 0.0219, 'lps'),
	(483601, 126, '2015-04-01 00:59:27.000000', 'consum', 0.0217, 'lps'),
	(483602, 126, '2015-04-01 00:59:28.000000', 'consum', 0.0218, 'lps'),
	(483603, 126, '2015-04-01 00:59:29.000000', 'consum', 0.0214, 'lps'),
	(483604, 126, '2015-04-01 00:59:30.000000', 'consum', 0.0223, 'lps'),
	(483605, 126, '2015-04-01 00:59:31.000000', 'consum', 0.0226, 'lps'),
	(483606, 126, '2015-04-01 00:59:32.000000', 'consum', 0.0217, 'lps'),
	(483607, 126, '2015-04-01 00:59:33.000000', 'consum', 0.0216, 'lps'),
	(483608, 126, '2015-04-01 00:59:34.000000', 'consum', 0.0220, 'lps'),
	(483609, 126, '2015-04-01 00:59:35.000000', 'consum', 0.0223, 'lps'),
	(483610, 126, '2015-04-01 00:59:36.000000', 'consum', 0.0227, 'lps'),
	(483611, 126, '2015-04-01 00:59:37.000000', 'consum', 0.0220, 'lps'),
	(483612, 126, '2015-04-01 00:59:38.000000', 'consum', 0.0212, 'lps'),
	(483613, 126, '2015-04-01 00:59:39.000000', 'consum', 0.0225, 'lps'),
	(483614, 126, '2015-04-01 00:59:40.000000', 'consum', 0.0225, 'lps'),
	(483615, 126, '2015-04-01 00:59:41.000000', 'consum', 0.0223, 'lps'),
	(483616, 126, '2015-04-01 00:59:42.000000', 'consum', 0.0214, 'lps'),
	(483617, 126, '2015-04-01 00:59:43.000000', 'consum', 0.0226, 'lps'),
	(483618, 126, '2015-04-01 00:59:44.000000', 'consum', 0.0223, 'lps'),
	(483619, 126, '2015-04-01 00:59:45.000000', 'consum', 0.0212, 'lps'),
	(483620, 126, '2015-04-01 00:59:46.000000', 'consum', 0.0215, 'lps'),
	(483621, 126, '2015-04-01 00:59:47.000000', 'consum', 0.0212, 'lps'),
	(483622, 126, '2015-04-01 00:59:48.000000', 'consum', 0.0224, 'lps'),
	(483623, 126, '2015-04-01 00:59:49.000000', 'consum', 0.0222, 'lps'),
	(483624, 126, '2015-04-01 00:59:50.000000', 'consum', 0.0227, 'lps'),
	(483625, 126, '2015-04-01 00:59:51.000000', 'consum', 0.0223, 'lps'),
	(483626, 126, '2015-04-01 00:59:52.000000', 'consum', 0.0226, 'lps'),
	(483627, 126, '2015-04-01 00:59:53.000000', 'consum', 0.0215, 'lps'),
	(483628, 126, '2015-04-01 00:59:54.000000', 'consum', 0.0225, 'lps'),
	(483629, 126, '2015-04-01 00:59:55.000000', 'consum', 0.0217, 'lps'),
	(483630, 126, '2015-04-01 00:59:56.000000', 'consum', 0.0217, 'lps'),
	(483631, 126, '2015-04-01 00:59:57.000000', 'consum', 0.0225, 'lps'),
	(483632, 126, '2015-04-01 00:59:58.000000', 'consum', 0.0210, 'lps'),
	(483633, 126, '2015-04-01 00:59:59.000000', 'consum', 0.0220, 'lps'),
	(483634, 126, '2015-04-01 01:00:00.000000', 'consum', 0.0225, 'lps'),
	(483635, 126, '2015-04-01 01:00:01.000000', 'consum', 0.0221, 'lps'),
	(483636, 126, '2015-04-01 01:00:02.000000', 'consum', 0.0220, 'lps'),
	(483637, 126, '2015-04-01 01:00:03.000000', 'consum', 0.0226, 'lps'),
	(483638, 126, '2015-04-01 01:00:04.000000', 'consum', 0.0223, 'lps'),
	(483639, 126, '2015-04-01 01:00:05.000000', 'consum', 0.0212, 'lps'),
	(483640, 126, '2015-04-01 01:00:06.000000', 'consum', 0.0218, 'lps'),
	(483641, 126, '2015-04-01 01:00:07.000000', 'consum', 0.0226, 'lps'),
	(483642, 126, '2015-04-01 01:00:08.000000', 'consum', 0.0210, 'lps'),
	(483643, 126, '2015-04-01 01:00:09.000000', 'consum', 0.0220, 'lps'),
	(483644, 126, '2015-04-01 01:00:10.000000', 'consum', 0.0222, 'lps'),
	(483645, 126, '2015-04-01 01:00:11.000000', 'consum', 0.0223, 'lps'),
	(483646, 126, '2015-04-01 01:00:12.000000', 'consum', 0.0220, 'lps'),
	(483647, 126, '2015-04-01 01:00:13.000000', 'consum', 0.0221, 'lps'),
	(483648, 126, '2015-04-01 01:00:14.000000', 'consum', 0.0218, 'lps'),
	(483649, 126, '2015-04-01 01:00:15.000000', 'consum', 0.0220, 'lps'),
	(483650, 126, '2015-04-01 01:00:16.000000', 'consum', 0.0218, 'lps'),
	(483651, 126, '2015-04-01 01:00:17.000000', 'consum', 0.0218, 'lps'),
	(483652, 126, '2015-04-01 01:00:18.000000', 'consum', 0.0210, 'lps'),
	(483653, 126, '2015-04-01 01:00:19.000000', 'consum', 0.0224, 'lps'),
	(483654, 126, '2015-04-01 01:00:20.000000', 'consum', 0.0226, 'lps'),
	(483655, 126, '2015-04-01 01:00:21.000000', 'consum', 0.0214, 'lps'),
	(483656, 126, '2015-04-01 01:00:22.000000', 'consum', 0.0217, 'lps'),
	(483657, 126, '2015-04-01 01:00:23.000000', 'consum', 0.0214, 'lps'),
	(483658, 126, '2015-04-01 01:00:24.000000', 'consum', 0.0211, 'lps'),
	(483659, 126, '2015-04-01 01:00:25.000000', 'consum', 0.0220, 'lps'),
	(483660, 126, '2015-04-01 01:00:26.000000', 'consum', 0.0221, 'lps'),
	(483661, 126, '2015-04-01 01:00:27.000000', 'consum', 0.0217, 'lps'),
	(483662, 126, '2015-04-01 01:00:28.000000', 'consum', 0.0215, 'lps'),
	(483663, 126, '2015-04-01 01:00:29.000000', 'consum', 0.0215, 'lps'),
	(483664, 126, '2015-04-01 01:00:30.000000', 'consum', 0.0221, 'lps'),
	(483665, 126, '2015-04-01 01:00:31.000000', 'consum', 0.0213, 'lps'),
	(483666, 126, '2015-04-01 01:00:32.000000', 'consum', 0.0212, 'lps'),
	(483667, 126, '2015-04-01 01:00:33.000000', 'consum', 0.0211, 'lps'),
	(483668, 126, '2015-04-01 01:00:34.000000', 'consum', 0.0227, 'lps'),
	(483669, 126, '2015-04-01 01:00:35.000000', 'consum', 0.0222, 'lps'),
	(483670, 126, '2015-04-01 01:00:36.000000', 'consum', 0.0221, 'lps'),
	(483671, 126, '2015-04-01 01:00:37.000000', 'consum', 0.0226, 'lps'),
	(483672, 126, '2015-04-01 01:00:38.000000', 'consum', 0.0223, 'lps'),
	(483673, 126, '2015-04-01 01:00:39.000000', 'consum', 0.0211, 'lps'),
	(483674, 126, '2015-04-01 01:00:40.000000', 'consum', 0.0211, 'lps'),
	(483675, 126, '2015-04-01 01:00:41.000000', 'consum', 0.0211, 'lps'),
	(483676, 126, '2015-04-01 01:00:42.000000', 'consum', 0.0213, 'lps'),
	(483677, 126, '2015-04-01 01:00:43.000000', 'consum', 0.0222, 'lps'),
	(483678, 126, '2015-04-01 01:00:44.000000', 'consum', 0.0226, 'lps'),
	(483679, 126, '2015-04-01 01:00:45.000000', 'consum', 0.0218, 'lps'),
	(483680, 126, '2015-04-01 01:00:46.000000', 'consum', 0.0222, 'lps'),
	(483681, 126, '2015-04-01 01:00:47.000000', 'consum', 0.0227, 'lps'),
	(483682, 126, '2015-04-01 01:00:48.000000', 'consum', 0.0224, 'lps'),
	(483683, 126, '2015-04-01 01:00:49.000000', 'consum', 0.0227, 'lps'),
	(483684, 126, '2015-04-01 01:00:50.000000', 'consum', 0.0221, 'lps'),
	(483685, 126, '2015-04-01 01:00:51.000000', 'consum', 0.0214, 'lps'),
	(483686, 126, '2015-04-01 01:00:52.000000', 'consum', 0.0215, 'lps'),
	(483687, 126, '2015-04-01 01:00:53.000000', 'consum', 0.0225, 'lps'),
	(483688, 126, '2015-04-01 01:00:54.000000', 'consum', 0.0215, 'lps'),
	(483689, 126, '2015-04-01 01:00:55.000000', 'consum', 0.0227, 'lps'),
	(483690, 126, '2015-04-01 01:00:56.000000', 'consum', 0.0227, 'lps'),
	(483691, 126, '2015-04-01 01:00:57.000000', 'consum', 0.0226, 'lps'),
	(483692, 126, '2015-04-01 01:00:58.000000', 'consum', 0.0221, 'lps'),
	(483693, 126, '2015-04-01 01:00:59.000000', 'consum', 0.0217, 'lps'),
	(483694, 126, '2015-04-01 01:01:00.000000', 'consum', 0.0214, 'lps'),
	(483695, 126, '2015-04-01 01:01:01.000000', 'consum', 0.0225, 'lps'),
	(483696, 126, '2015-04-01 01:01:02.000000', 'consum', 0.0221, 'lps'),
	(483697, 126, '2015-04-01 01:01:03.000000', 'consum', 0.0220, 'lps'),
	(483698, 126, '2015-04-01 01:01:04.000000', 'consum', 0.0211, 'lps'),
	(483699, 126, '2015-04-01 01:01:05.000000', 'consum', 0.0219, 'lps'),
	(483700, 126, '2015-04-01 01:01:06.000000', 'consum', 0.0219, 'lps'),
	(483701, 126, '2015-04-01 01:01:07.000000', 'consum', 0.0210, 'lps'),
	(483702, 126, '2015-04-01 01:01:08.000000', 'consum', 0.0218, 'lps'),
	(483703, 126, '2015-04-01 01:01:09.000000', 'consum', 0.0215, 'lps'),
	(483704, 126, '2015-04-01 01:01:10.000000', 'consum', 0.0213, 'lps'),
	(483705, 126, '2015-04-01 01:01:11.000000', 'consum', 0.0226, 'lps'),
	(483706, 126, '2015-04-01 01:01:12.000000', 'consum', 0.0213, 'lps'),
	(483707, 126, '2015-04-01 01:01:13.000000', 'consum', 0.0211, 'lps'),
	(483708, 126, '2015-04-01 01:01:14.000000', 'consum', 0.0224, 'lps'),
	(483709, 126, '2015-04-01 01:01:15.000000', 'consum', 0.0224, 'lps'),
	(483710, 126, '2015-04-01 01:01:16.000000', 'consum', 0.0222, 'lps'),
	(483711, 126, '2015-04-01 01:01:17.000000', 'consum', 0.0225, 'lps'),
	(483712, 126, '2015-04-01 01:01:18.000000', 'consum', 0.0217, 'lps'),
	(483713, 126, '2015-04-01 01:01:19.000000', 'consum', 0.0218, 'lps'),
	(483714, 126, '2015-04-01 01:01:20.000000', 'consum', 0.0212, 'lps'),
	(483715, 126, '2015-04-01 01:01:21.000000', 'consum', 0.0215, 'lps'),
	(483716, 126, '2015-04-01 01:01:22.000000', 'consum', 0.0212, 'lps'),
	(483717, 126, '2015-04-01 01:01:23.000000', 'consum', 0.0222, 'lps'),
	(483718, 126, '2015-04-01 01:01:24.000000', 'consum', 0.0212, 'lps'),
	(483719, 126, '2015-04-01 01:01:25.000000', 'consum', 0.0222, 'lps'),
	(483720, 126, '2015-04-01 01:01:26.000000', 'consum', 0.0225, 'lps'),
	(483721, 126, '2015-04-01 01:01:27.000000', 'consum', 0.0214, 'lps'),
	(483722, 126, '2015-04-01 01:01:28.000000', 'consum', 0.0223, 'lps'),
	(483723, 126, '2015-04-01 01:01:29.000000', 'consum', 0.0225, 'lps'),
	(483724, 126, '2015-04-01 01:01:30.000000', 'consum', 0.0212, 'lps'),
	(483725, 126, '2015-04-01 01:01:31.000000', 'consum', 0.0212, 'lps'),
	(483726, 126, '2015-04-01 01:01:32.000000', 'consum', 0.0216, 'lps'),
	(483727, 126, '2015-04-01 01:01:33.000000', 'consum', 0.0215, 'lps'),
	(483728, 126, '2015-04-01 01:01:34.000000', 'consum', 0.0217, 'lps'),
	(483729, 126, '2015-04-01 01:01:35.000000', 'consum', 0.0213, 'lps'),
	(483730, 126, '2015-04-01 01:01:36.000000', 'consum', 0.0221, 'lps'),
	(483731, 126, '2015-04-01 01:01:37.000000', 'consum', 0.0220, 'lps'),
	(483732, 126, '2015-04-01 01:01:38.000000', 'consum', 0.0227, 'lps'),
	(483733, 126, '2015-04-01 01:01:39.000000', 'consum', 0.0211, 'lps'),
	(483734, 126, '2015-04-01 01:01:40.000000', 'consum', 0.0221, 'lps'),
	(483735, 126, '2015-04-01 01:01:41.000000', 'consum', 0.0225, 'lps'),
	(483736, 126, '2015-04-01 01:01:42.000000', 'consum', 0.0218, 'lps'),
	(483737, 126, '2015-04-01 01:01:43.000000', 'consum', 0.0221, 'lps'),
	(483738, 126, '2015-04-01 01:01:44.000000', 'consum', 0.0224, 'lps'),
	(483739, 126, '2015-04-01 01:01:45.000000', 'consum', 0.0211, 'lps'),
	(483740, 126, '2015-04-01 01:01:46.000000', 'consum', 0.0212, 'lps'),
	(483741, 126, '2015-04-01 01:01:47.000000', 'consum', 0.0216, 'lps'),
	(483742, 126, '2015-04-01 01:01:48.000000', 'consum', 0.0218, 'lps'),
	(483743, 126, '2015-04-01 01:01:49.000000', 'consum', 0.0212, 'lps'),
	(483744, 126, '2015-04-01 01:01:50.000000', 'consum', 0.0216, 'lps'),
	(483745, 126, '2015-04-01 01:01:51.000000', 'consum', 0.0217, 'lps'),
	(483746, 126, '2015-04-01 01:01:52.000000', 'consum', 0.0227, 'lps'),
	(483747, 126, '2015-04-01 01:01:53.000000', 'consum', 0.0219, 'lps'),
	(483748, 126, '2015-04-01 01:01:54.000000', 'consum', 0.0223, 'lps'),
	(483749, 126, '2015-04-01 01:01:55.000000', 'consum', 0.0212, 'lps'),
	(483750, 126, '2015-04-01 01:01:56.000000', 'consum', 0.0218, 'lps'),
	(483751, 126, '2015-04-01 01:01:57.000000', 'consum', 0.0226, 'lps'),
	(483752, 126, '2015-04-01 01:01:58.000000', 'consum', 0.0213, 'lps'),
	(483753, 126, '2015-04-01 01:01:59.000000', 'consum', 0.0214, 'lps'),
	(483754, 126, '2015-04-01 01:02:00.000000', 'consum', 0.0222, 'lps'),
	(483755, 126, '2015-04-01 01:02:01.000000', 'consum', 0.0224, 'lps'),
	(483756, 126, '2015-04-01 01:02:02.000000', 'consum', 0.0225, 'lps'),
	(483757, 126, '2015-04-01 01:02:03.000000', 'consum', 0.0223, 'lps'),
	(483758, 126, '2015-04-01 01:02:04.000000', 'consum', 0.0216, 'lps'),
	(483759, 126, '2015-04-01 01:02:05.000000', 'consum', 0.0219, 'lps'),
	(483760, 126, '2015-04-01 01:02:06.000000', 'consum', 0.0217, 'lps'),
	(483761, 126, '2015-04-01 01:02:07.000000', 'consum', 0.0221, 'lps'),
	(483762, 126, '2015-04-01 01:02:08.000000', 'consum', 0.0227, 'lps'),
	(483763, 126, '2015-04-01 01:02:09.000000', 'consum', 0.0224, 'lps'),
	(483764, 126, '2015-04-01 01:02:10.000000', 'consum', 0.0215, 'lps'),
	(483765, 126, '2015-04-01 01:02:11.000000', 'consum', 0.0226, 'lps'),
	(483766, 126, '2015-04-01 01:02:12.000000', 'consum', 0.0223, 'lps'),
	(483767, 126, '2015-04-01 01:02:13.000000', 'consum', 0.0210, 'lps'),
	(483768, 126, '2015-04-01 01:02:14.000000', 'consum', 0.0224, 'lps'),
	(483769, 126, '2015-04-01 01:02:15.000000', 'consum', 0.0227, 'lps'),
	(483770, 126, '2015-04-01 01:02:16.000000', 'consum', 0.0219, 'lps'),
	(483771, 126, '2015-04-01 01:02:17.000000', 'consum', 0.0221, 'lps'),
	(483772, 126, '2015-04-01 01:02:18.000000', 'consum', 0.0219, 'lps'),
	(483773, 126, '2015-04-01 01:02:19.000000', 'consum', 0.0224, 'lps'),
	(483774, 126, '2015-04-01 01:02:20.000000', 'consum', 0.0219, 'lps'),
	(483775, 126, '2015-04-01 01:02:21.000000', 'consum', 0.0212, 'lps'),
	(483776, 126, '2015-04-01 01:02:22.000000', 'consum', 0.0212, 'lps'),
	(483777, 126, '2015-04-01 01:02:23.000000', 'consum', 0.0216, 'lps'),
	(483778, 126, '2015-04-01 01:02:24.000000', 'consum', 0.0213, 'lps'),
	(483779, 126, '2015-04-01 01:02:25.000000', 'consum', 0.0210, 'lps'),
	(483780, 126, '2015-04-01 01:02:26.000000', 'consum', 0.0220, 'lps'),
	(483781, 126, '2015-04-01 01:02:27.000000', 'consum', 0.0223, 'lps'),
	(483782, 126, '2015-04-01 01:02:28.000000', 'consum', 0.0227, 'lps'),
	(483783, 126, '2015-04-01 01:02:29.000000', 'consum', 0.0219, 'lps'),
	(483784, 126, '2015-04-01 01:02:30.000000', 'consum', 0.0224, 'lps'),
	(483785, 126, '2015-04-01 01:02:31.000000', 'consum', 0.0219, 'lps'),
	(483786, 126, '2015-04-01 01:02:32.000000', 'consum', 0.0212, 'lps'),
	(483787, 126, '2015-04-01 01:02:33.000000', 'consum', 0.0210, 'lps'),
	(483788, 126, '2015-04-01 01:02:34.000000', 'consum', 0.0226, 'lps'),
	(483789, 126, '2015-04-01 01:02:35.000000', 'consum', 0.0216, 'lps'),
	(483790, 126, '2015-04-01 01:02:36.000000', 'consum', 0.0212, 'lps'),
	(483791, 126, '2015-04-01 01:02:37.000000', 'consum', 0.0218, 'lps'),
	(483792, 126, '2015-04-01 01:02:38.000000', 'consum', 0.0211, 'lps'),
	(483793, 126, '2015-04-01 01:02:39.000000', 'consum', 0.0211, 'lps'),
	(483794, 126, '2015-04-01 01:02:40.000000', 'consum', 0.0227, 'lps'),
	(483795, 126, '2015-04-01 01:02:41.000000', 'consum', 0.0222, 'lps'),
	(483796, 126, '2015-04-01 01:02:42.000000', 'consum', 0.0218, 'lps'),
	(483797, 126, '2015-04-01 01:02:43.000000', 'consum', 0.0216, 'lps'),
	(483798, 126, '2015-04-01 01:02:44.000000', 'consum', 0.0217, 'lps'),
	(483799, 126, '2015-04-01 01:02:45.000000', 'consum', 0.0226, 'lps'),
	(483800, 126, '2015-04-01 01:02:46.000000', 'consum', 0.0216, 'lps'),
	(483801, 126, '2015-04-01 01:02:47.000000', 'consum', 0.0210, 'lps'),
	(483802, 126, '2015-04-01 01:02:48.000000', 'consum', 0.0227, 'lps'),
	(483803, 126, '2015-04-01 01:02:49.000000', 'consum', 0.0224, 'lps'),
	(483804, 126, '2015-04-01 01:02:50.000000', 'consum', 0.0214, 'lps'),
	(483805, 126, '2015-04-01 01:02:51.000000', 'consum', 0.0223, 'lps'),
	(483806, 126, '2015-04-01 01:02:52.000000', 'consum', 0.0226, 'lps'),
	(483807, 126, '2015-04-01 01:02:53.000000', 'consum', 0.0216, 'lps'),
	(483808, 126, '2015-04-01 01:02:54.000000', 'consum', 0.0211, 'lps'),
	(483809, 126, '2015-04-01 01:02:55.000000', 'consum', 0.0217, 'lps'),
	(483810, 126, '2015-04-01 01:02:56.000000', 'consum', 0.0222, 'lps'),
	(483811, 126, '2015-04-01 01:02:57.000000', 'consum', 0.0214, 'lps'),
	(483812, 126, '2015-04-01 01:02:58.000000', 'consum', 0.0213, 'lps'),
	(483813, 126, '2015-04-01 01:02:59.000000', 'consum', 0.0212, 'lps'),
	(483814, 126, '2015-04-01 01:03:00.000000', 'consum', 0.0211, 'lps'),
	(483815, 126, '2015-04-01 01:03:01.000000', 'consum', 0.0212, 'lps'),
	(483816, 126, '2015-04-01 01:03:02.000000', 'consum', 0.0214, 'lps'),
	(483817, 126, '2015-04-01 01:03:03.000000', 'consum', 0.0210, 'lps'),
	(483818, 126, '2015-04-01 01:03:04.000000', 'consum', 0.0214, 'lps'),
	(483819, 126, '2015-04-01 01:03:05.000000', 'consum', 0.0213, 'lps'),
	(483820, 126, '2015-04-01 01:03:06.000000', 'consum', 0.0215, 'lps'),
	(483821, 126, '2015-04-01 01:03:07.000000', 'consum', 0.0224, 'lps'),
	(483822, 126, '2015-04-01 01:03:08.000000', 'consum', 0.0212, 'lps'),
	(483823, 126, '2015-04-01 01:03:09.000000', 'consum', 0.0213, 'lps'),
	(483824, 126, '2015-04-01 01:03:10.000000', 'consum', 0.0222, 'lps'),
	(483825, 126, '2015-04-01 01:03:11.000000', 'consum', 0.0225, 'lps'),
	(483826, 126, '2015-04-01 01:03:12.000000', 'consum', 0.0211, 'lps'),
	(483827, 126, '2015-04-01 01:03:13.000000', 'consum', 0.0210, 'lps'),
	(483828, 126, '2015-04-01 01:03:14.000000', 'consum', 0.0222, 'lps'),
	(483829, 126, '2015-04-01 01:03:15.000000', 'consum', 0.0219, 'lps'),
	(483830, 126, '2015-04-01 01:03:16.000000', 'consum', 0.0218, 'lps'),
	(483831, 126, '2015-04-01 01:03:17.000000', 'consum', 0.0222, 'lps'),
	(483832, 126, '2015-04-01 01:03:18.000000', 'consum', 0.0212, 'lps'),
	(483833, 126, '2015-04-01 01:03:19.000000', 'consum', 0.0221, 'lps'),
	(483834, 126, '2015-04-01 01:03:20.000000', 'consum', 0.0221, 'lps'),
	(483835, 126, '2015-04-01 01:03:21.000000', 'consum', 0.0217, 'lps'),
	(483836, 126, '2015-04-01 01:03:22.000000', 'consum', 0.0211, 'lps'),
	(483837, 126, '2015-04-01 01:03:23.000000', 'consum', 0.0213, 'lps'),
	(483838, 126, '2015-04-01 01:03:24.000000', 'consum', 0.0221, 'lps'),
	(483839, 126, '2015-04-01 01:03:25.000000', 'consum', 0.0220, 'lps'),
	(483840, 126, '2015-04-01 01:03:26.000000', 'consum', 0.0210, 'lps'),
	(483841, 126, '2015-04-01 01:03:27.000000', 'consum', 0.0216, 'lps'),
	(483842, 126, '2015-04-01 01:03:28.000000', 'consum', 0.0225, 'lps'),
	(483843, 126, '2015-04-01 01:03:29.000000', 'consum', 0.0213, 'lps'),
	(483844, 126, '2015-04-01 01:03:30.000000', 'consum', 0.0218, 'lps'),
	(483845, 126, '2015-04-01 01:03:31.000000', 'consum', 0.0221, 'lps'),
	(483846, 126, '2015-04-01 01:03:32.000000', 'consum', 0.0224, 'lps'),
	(483847, 126, '2015-04-01 01:03:33.000000', 'consum', 0.0214, 'lps'),
	(483848, 126, '2015-04-01 01:03:34.000000', 'consum', 0.0222, 'lps'),
	(483849, 126, '2015-04-01 01:03:35.000000', 'consum', 0.0223, 'lps'),
	(483850, 126, '2015-04-01 01:03:36.000000', 'consum', 0.0220, 'lps'),
	(483851, 126, '2015-04-01 01:03:37.000000', 'consum', 0.0224, 'lps'),
	(483852, 126, '2015-04-01 01:03:38.000000', 'consum', 0.0215, 'lps'),
	(483853, 126, '2015-04-01 01:03:39.000000', 'consum', 0.0211, 'lps'),
	(483854, 126, '2015-04-01 01:03:40.000000', 'consum', 0.0219, 'lps'),
	(483855, 126, '2015-04-01 01:03:41.000000', 'consum', 0.0216, 'lps'),
	(483856, 126, '2015-04-01 01:03:42.000000', 'consum', 0.0213, 'lps'),
	(483857, 126, '2015-04-01 01:03:43.000000', 'consum', 0.0210, 'lps'),
	(483858, 126, '2015-04-01 01:03:44.000000', 'consum', 0.0217, 'lps'),
	(483859, 126, '2015-04-01 01:03:45.000000', 'consum', 0.0210, 'lps'),
	(483860, 126, '2015-04-01 01:03:46.000000', 'consum', 0.0225, 'lps'),
	(483861, 126, '2015-04-01 01:03:47.000000', 'consum', 0.0215, 'lps'),
	(483862, 126, '2015-04-01 01:03:48.000000', 'consum', 0.0224, 'lps'),
	(483863, 126, '2015-04-01 01:03:49.000000', 'consum', 0.0212, 'lps'),
	(483864, 126, '2015-04-01 01:03:50.000000', 'consum', 0.0214, 'lps'),
	(483865, 126, '2015-04-01 01:03:51.000000', 'consum', 0.0223, 'lps'),
	(483866, 126, '2015-04-01 01:03:52.000000', 'consum', 0.0213, 'lps'),
	(483867, 126, '2015-04-01 01:03:53.000000', 'consum', 0.0220, 'lps'),
	(483868, 126, '2015-04-01 01:03:54.000000', 'consum', 0.0216, 'lps'),
	(483869, 126, '2015-04-01 01:03:55.000000', 'consum', 0.0227, 'lps'),
	(483870, 126, '2015-04-01 01:03:56.000000', 'consum', 0.0227, 'lps'),
	(483871, 126, '2015-04-01 01:03:57.000000', 'consum', 0.0223, 'lps'),
	(483872, 126, '2015-04-01 01:03:58.000000', 'consum', 0.0226, 'lps'),
	(483873, 126, '2015-04-01 01:03:59.000000', 'consum', 0.0217, 'lps'),
	(483874, 126, '2015-04-01 01:04:00.000000', 'consum', 0.0216, 'lps'),
	(483875, 126, '2015-04-01 01:04:01.000000', 'consum', 0.0216, 'lps'),
	(483876, 126, '2015-04-01 01:04:02.000000', 'consum', 0.0226, 'lps'),
	(483877, 126, '2015-04-01 01:04:03.000000', 'consum', 0.0218, 'lps'),
	(483878, 126, '2015-04-01 01:04:04.000000', 'consum', 0.0218, 'lps'),
	(483879, 126, '2015-04-01 01:04:05.000000', 'consum', 0.0211, 'lps'),
	(483880, 126, '2015-04-01 01:04:06.000000', 'consum', 0.0210, 'lps'),
	(483881, 126, '2015-04-01 01:04:07.000000', 'consum', 0.0227, 'lps'),
	(483882, 126, '2015-04-01 01:04:08.000000', 'consum', 0.0220, 'lps'),
	(483883, 126, '2015-04-01 01:04:09.000000', 'consum', 0.0212, 'lps'),
	(483884, 126, '2015-04-01 01:04:10.000000', 'consum', 0.0227, 'lps'),
	(483885, 126, '2015-04-01 01:04:11.000000', 'consum', 0.0217, 'lps'),
	(483886, 126, '2015-04-01 01:04:12.000000', 'consum', 0.0212, 'lps'),
	(483887, 126, '2015-04-01 01:04:13.000000', 'consum', 0.0216, 'lps'),
	(483888, 126, '2015-04-01 01:04:14.000000', 'consum', 0.0218, 'lps'),
	(483889, 126, '2015-04-01 01:04:15.000000', 'consum', 0.0216, 'lps'),
	(483890, 126, '2015-04-01 01:04:16.000000', 'consum', 0.0216, 'lps'),
	(483891, 126, '2015-04-01 01:04:17.000000', 'consum', 0.0221, 'lps'),
	(483892, 126, '2015-04-01 01:04:18.000000', 'consum', 0.0210, 'lps'),
	(483893, 126, '2015-04-01 01:04:19.000000', 'consum', 0.0217, 'lps'),
	(483894, 126, '2015-04-01 01:04:20.000000', 'consum', 0.0224, 'lps'),
	(483895, 126, '2015-04-01 01:04:21.000000', 'consum', 0.0226, 'lps'),
	(483896, 126, '2015-04-01 01:04:22.000000', 'consum', 0.0211, 'lps'),
	(483897, 126, '2015-04-01 01:04:23.000000', 'consum', 0.0223, 'lps'),
	(483898, 126, '2015-04-01 01:04:24.000000', 'consum', 0.0217, 'lps'),
	(483899, 126, '2015-04-01 01:04:25.000000', 'consum', 0.0223, 'lps'),
	(483900, 126, '2015-04-01 01:04:26.000000', 'consum', 0.0222, 'lps'),
	(483901, 126, '2015-04-01 01:04:27.000000', 'consum', 0.0212, 'lps'),
	(483902, 126, '2015-04-01 01:04:28.000000', 'consum', 0.0222, 'lps'),
	(483903, 126, '2015-04-01 01:04:29.000000', 'consum', 0.0211, 'lps'),
	(483904, 126, '2015-04-01 01:04:30.000000', 'consum', 0.0213, 'lps'),
	(483905, 126, '2015-04-01 01:04:31.000000', 'consum', 0.0225, 'lps'),
	(483906, 126, '2015-04-01 01:04:32.000000', 'consum', 0.0222, 'lps'),
	(483907, 126, '2015-04-01 01:04:33.000000', 'consum', 0.0226, 'lps'),
	(483908, 126, '2015-04-01 01:04:34.000000', 'consum', 0.0217, 'lps'),
	(483909, 126, '2015-04-01 01:04:35.000000', 'consum', 0.0217, 'lps'),
	(483910, 126, '2015-04-01 01:04:36.000000', 'consum', 0.0223, 'lps'),
	(483911, 126, '2015-04-01 01:04:37.000000', 'consum', 0.0220, 'lps'),
	(483912, 126, '2015-04-01 01:04:38.000000', 'consum', 0.0219, 'lps'),
	(483913, 126, '2015-04-01 01:04:39.000000', 'consum', 0.0227, 'lps'),
	(483914, 126, '2015-04-01 01:04:40.000000', 'consum', 0.0212, 'lps'),
	(483915, 126, '2015-04-01 01:04:41.000000', 'consum', 0.0227, 'lps'),
	(483916, 126, '2015-04-01 01:04:42.000000', 'consum', 0.0214, 'lps'),
	(483917, 126, '2015-04-01 01:04:43.000000', 'consum', 0.0218, 'lps'),
	(483918, 126, '2015-04-01 01:04:44.000000', 'consum', 0.0222, 'lps'),
	(483919, 126, '2015-04-01 01:04:45.000000', 'consum', 0.0226, 'lps'),
	(483920, 126, '2015-04-01 01:04:46.000000', 'consum', 0.0219, 'lps'),
	(483921, 126, '2015-04-01 01:04:47.000000', 'consum', 0.0226, 'lps'),
	(483922, 126, '2015-04-01 01:04:48.000000', 'consum', 0.0211, 'lps'),
	(483923, 126, '2015-04-01 01:04:49.000000', 'consum', 0.0219, 'lps'),
	(483924, 126, '2015-04-01 01:04:50.000000', 'consum', 0.0217, 'lps'),
	(483925, 126, '2015-04-01 01:04:51.000000', 'consum', 0.0219, 'lps'),
	(483926, 126, '2015-04-01 01:04:52.000000', 'consum', 0.0217, 'lps'),
	(483927, 126, '2015-04-01 01:04:53.000000', 'consum', 0.0219, 'lps'),
	(483928, 126, '2015-04-01 01:04:54.000000', 'consum', 0.0215, 'lps'),
	(483929, 126, '2015-04-01 01:04:55.000000', 'consum', 0.0225, 'lps'),
	(483930, 126, '2015-04-01 01:04:56.000000', 'consum', 0.0218, 'lps'),
	(483931, 126, '2015-04-01 01:04:57.000000', 'consum', 0.0222, 'lps'),
	(483932, 126, '2015-04-01 01:04:58.000000', 'consum', 0.0211, 'lps'),
	(483933, 126, '2015-04-01 01:04:59.000000', 'consum', 0.0217, 'lps'),
	(483934, 126, '2015-04-01 01:05:00.000000', 'consum', 0.0224, 'lps'),
	(483935, 126, '2015-04-01 01:05:01.000000', 'consum', 0.0225, 'lps'),
	(483936, 126, '2015-04-01 01:05:02.000000', 'consum', 0.0224, 'lps'),
	(483937, 126, '2015-04-01 01:05:03.000000', 'consum', 0.0220, 'lps'),
	(483938, 126, '2015-04-01 01:05:04.000000', 'consum', 0.0215, 'lps'),
	(483939, 126, '2015-04-01 01:05:05.000000', 'consum', 0.0225, 'lps'),
	(483940, 126, '2015-04-01 01:05:06.000000', 'consum', 0.0215, 'lps'),
	(483941, 126, '2015-04-01 01:05:07.000000', 'consum', 0.0226, 'lps'),
	(483942, 126, '2015-04-01 01:05:08.000000', 'consum', 0.0224, 'lps'),
	(483943, 126, '2015-04-01 01:05:09.000000', 'consum', 0.0211, 'lps'),
	(483944, 126, '2015-04-01 01:05:10.000000', 'consum', 0.0213, 'lps'),
	(483945, 126, '2015-04-01 01:05:11.000000', 'consum', 0.0222, 'lps'),
	(483946, 126, '2015-04-01 01:05:12.000000', 'consum', 0.0225, 'lps'),
	(483947, 126, '2015-04-01 01:05:13.000000', 'consum', 0.0212, 'lps'),
	(483948, 126, '2015-04-01 01:05:14.000000', 'consum', 0.0214, 'lps'),
	(483949, 126, '2015-04-01 01:05:15.000000', 'consum', 0.0223, 'lps'),
	(483950, 126, '2015-04-01 01:05:16.000000', 'consum', 0.0212, 'lps'),
	(483951, 126, '2015-04-01 01:05:17.000000', 'consum', 0.0215, 'lps'),
	(483952, 126, '2015-04-01 01:05:18.000000', 'consum', 0.0211, 'lps'),
	(483953, 126, '2015-04-01 01:05:19.000000', 'consum', 0.0220, 'lps'),
	(483954, 126, '2015-04-01 01:05:20.000000', 'consum', 0.0221, 'lps'),
	(483955, 126, '2015-04-01 01:05:21.000000', 'consum', 0.0218, 'lps'),
	(483956, 126, '2015-04-01 01:05:22.000000', 'consum', 0.0218, 'lps'),
	(483957, 126, '2015-04-01 01:05:23.000000', 'consum', 0.0225, 'lps'),
	(483958, 126, '2015-04-01 01:05:24.000000', 'consum', 0.0210, 'lps'),
	(483959, 126, '2015-04-01 01:05:25.000000', 'consum', 0.0218, 'lps'),
	(483960, 126, '2015-04-01 01:05:26.000000', 'consum', 0.0215, 'lps'),
	(483961, 126, '2015-04-01 01:05:27.000000', 'consum', 0.0213, 'lps'),
	(483962, 126, '2015-04-01 01:05:28.000000', 'consum', 0.0226, 'lps'),
	(483963, 126, '2015-04-01 01:05:29.000000', 'consum', 0.0210, 'lps'),
	(483964, 126, '2015-04-01 01:05:30.000000', 'consum', 0.0219, 'lps'),
	(483965, 126, '2015-04-01 01:05:31.000000', 'consum', 0.0216, 'lps'),
	(483966, 126, '2015-04-01 01:05:32.000000', 'consum', 0.0215, 'lps'),
	(483967, 126, '2015-04-01 01:05:33.000000', 'consum', 0.0217, 'lps'),
	(483968, 126, '2015-04-01 01:05:34.000000', 'consum', 0.0213, 'lps'),
	(483969, 126, '2015-04-01 01:05:35.000000', 'consum', 0.0222, 'lps'),
	(483970, 126, '2015-04-01 01:05:36.000000', 'consum', 0.0226, 'lps'),
	(483971, 126, '2015-04-01 01:05:37.000000', 'consum', 0.0218, 'lps'),
	(483972, 126, '2015-04-01 01:05:38.000000', 'consum', 0.0221, 'lps'),
	(483973, 126, '2015-04-01 01:05:39.000000', 'consum', 0.0224, 'lps'),
	(483974, 126, '2015-04-01 01:05:40.000000', 'consum', 0.0210, 'lps'),
	(483975, 126, '2015-04-01 01:05:41.000000', 'consum', 0.0223, 'lps'),
	(483976, 126, '2015-04-01 01:05:42.000000', 'consum', 0.0222, 'lps'),
	(483977, 126, '2015-04-01 01:05:43.000000', 'consum', 0.0214, 'lps'),
	(483978, 126, '2015-04-01 01:05:44.000000', 'consum', 0.0213, 'lps'),
	(483979, 126, '2015-04-01 01:05:45.000000', 'consum', 0.0212, 'lps'),
	(483980, 126, '2015-04-01 01:05:46.000000', 'consum', 0.0214, 'lps'),
	(483981, 126, '2015-04-01 01:05:47.000000', 'consum', 0.0221, 'lps'),
	(483982, 126, '2015-04-01 01:05:48.000000', 'consum', 0.0219, 'lps'),
	(483983, 126, '2015-04-01 01:05:49.000000', 'consum', 0.0224, 'lps'),
	(483984, 126, '2015-04-01 01:05:50.000000', 'consum', 0.0218, 'lps'),
	(483985, 126, '2015-04-01 01:05:51.000000', 'consum', 0.0227, 'lps'),
	(483986, 126, '2015-04-01 01:05:52.000000', 'consum', 0.0217, 'lps'),
	(483987, 126, '2015-04-01 01:05:53.000000', 'consum', 0.0212, 'lps'),
	(483988, 126, '2015-04-01 01:05:54.000000', 'consum', 0.0216, 'lps'),
	(483989, 126, '2015-04-01 01:05:55.000000', 'consum', 0.0219, 'lps'),
	(483990, 126, '2015-04-01 01:05:56.000000', 'consum', 0.0218, 'lps'),
	(483991, 126, '2015-04-01 01:05:57.000000', 'consum', 0.0225, 'lps'),
	(483992, 126, '2015-04-01 01:05:58.000000', 'consum', 0.0225, 'lps'),
	(483993, 126, '2015-04-01 01:05:59.000000', 'consum', 0.0222, 'lps'),
	(483994, 126, '2015-04-01 01:06:00.000000', 'consum', 0.0224, 'lps'),
	(483995, 126, '2015-04-01 01:06:01.000000', 'consum', 0.0211, 'lps'),
	(483996, 126, '2015-04-01 01:06:02.000000', 'consum', 0.0226, 'lps'),
	(483997, 126, '2015-04-01 01:06:03.000000', 'consum', 0.0214, 'lps'),
	(483998, 126, '2015-04-01 01:06:04.000000', 'consum', 0.0221, 'lps'),
	(483999, 126, '2015-04-01 01:06:05.000000', 'consum', 0.0218, 'lps'),
	(484000, 126, '2015-04-01 01:06:06.000000', 'consum', 0.0215, 'lps'),
	(484001, 126, '2015-04-01 01:06:07.000000', 'consum', 0.0214, 'lps'),
	(484002, 126, '2015-04-01 01:06:08.000000', 'consum', 0.0213, 'lps'),
	(484003, 126, '2015-04-01 01:06:09.000000', 'consum', 0.0213, 'lps'),
	(484004, 126, '2015-04-01 01:06:10.000000', 'consum', 0.0216, 'lps'),
	(484005, 126, '2015-04-01 01:06:11.000000', 'consum', 0.0215, 'lps'),
	(484006, 126, '2015-04-01 01:06:12.000000', 'consum', 0.0215, 'lps'),
	(484007, 126, '2015-04-01 01:06:13.000000', 'consum', 0.0223, 'lps'),
	(484008, 126, '2015-04-01 01:06:14.000000', 'consum', 0.0222, 'lps'),
	(484009, 126, '2015-04-01 01:06:15.000000', 'consum', 0.0214, 'lps'),
	(484010, 126, '2015-04-01 01:06:16.000000', 'consum', 0.0213, 'lps'),
	(484011, 126, '2015-04-01 01:06:17.000000', 'consum', 0.0212, 'lps'),
	(484012, 126, '2015-04-01 01:06:18.000000', 'consum', 0.0211, 'lps'),
	(484013, 126, '2015-04-01 01:06:19.000000', 'consum', 0.0212, 'lps'),
	(484014, 126, '2015-04-01 01:06:20.000000', 'consum', 0.0218, 'lps'),
	(484015, 126, '2015-04-01 01:06:21.000000', 'consum', 0.0226, 'lps'),
	(484016, 126, '2015-04-01 01:06:22.000000', 'consum', 0.0210, 'lps'),
	(484017, 126, '2015-04-01 01:06:23.000000', 'consum', 0.0220, 'lps'),
	(484018, 126, '2015-04-01 01:06:24.000000', 'consum', 0.0222, 'lps'),
	(484019, 126, '2015-04-01 01:06:25.000000', 'consum', 0.0223, 'lps'),
	(484020, 126, '2015-04-01 01:06:26.000000', 'consum', 0.0223, 'lps'),
	(484021, 126, '2015-04-01 01:06:27.000000', 'consum', 0.0217, 'lps'),
	(484022, 126, '2015-04-01 01:06:28.000000', 'consum', 0.0226, 'lps'),
	(484023, 126, '2015-04-01 01:06:29.000000', 'consum', 0.0213, 'lps'),
	(484024, 126, '2015-04-01 01:06:30.000000', 'consum', 0.0213, 'lps'),
	(484025, 126, '2015-04-01 01:06:31.000000', 'consum', 0.0218, 'lps'),
	(484026, 126, '2015-04-01 01:06:32.000000', 'consum', 0.0222, 'lps'),
	(484027, 126, '2015-04-01 01:06:33.000000', 'consum', 0.0213, 'lps'),
	(484028, 126, '2015-04-01 01:06:34.000000', 'consum', 0.0224, 'lps'),
	(484029, 126, '2015-04-01 01:06:35.000000', 'consum', 0.0216, 'lps'),
	(484030, 126, '2015-04-01 01:06:36.000000', 'consum', 0.0216, 'lps'),
	(484031, 126, '2015-04-01 01:06:37.000000', 'consum', 0.0225, 'lps'),
	(484032, 126, '2015-04-01 01:06:38.000000', 'consum', 0.0214, 'lps'),
	(484033, 126, '2015-04-01 01:06:39.000000', 'consum', 0.0223, 'lps'),
	(484034, 126, '2015-04-01 01:06:40.000000', 'consum', 0.0224, 'lps'),
	(484035, 126, '2015-04-01 01:06:41.000000', 'consum', 0.0224, 'lps'),
	(484036, 126, '2015-04-01 01:06:42.000000', 'consum', 0.0220, 'lps'),
	(484037, 126, '2015-04-01 01:06:43.000000', 'consum', 0.0218, 'lps'),
	(484038, 126, '2015-04-01 01:06:44.000000', 'consum', 0.0219, 'lps'),
	(484039, 126, '2015-04-01 01:06:45.000000', 'consum', 0.0217, 'lps'),
	(484040, 126, '2015-04-01 01:06:46.000000', 'consum', 0.0215, 'lps'),
	(484041, 126, '2015-04-01 01:06:47.000000', 'consum', 0.0217, 'lps'),
	(484042, 126, '2015-04-01 01:06:48.000000', 'consum', 0.0212, 'lps'),
	(484043, 126, '2015-04-01 01:06:49.000000', 'consum', 0.0217, 'lps'),
	(484044, 126, '2015-04-01 01:06:50.000000', 'consum', 0.0224, 'lps'),
	(484045, 126, '2015-04-01 01:06:51.000000', 'consum', 0.0220, 'lps'),
	(484046, 126, '2015-04-01 01:06:52.000000', 'consum', 0.0220, 'lps'),
	(484047, 126, '2015-04-01 01:06:53.000000', 'consum', 0.0211, 'lps'),
	(484048, 126, '2015-04-01 01:06:54.000000', 'consum', 0.0223, 'lps'),
	(484049, 126, '2015-04-01 01:06:55.000000', 'consum', 0.0219, 'lps'),
	(484050, 126, '2015-04-01 01:06:56.000000', 'consum', 0.0215, 'lps'),
	(484051, 126, '2015-04-01 01:06:57.000000', 'consum', 0.0226, 'lps'),
	(484052, 126, '2015-04-01 01:06:58.000000', 'consum', 0.0223, 'lps'),
	(484053, 126, '2015-04-01 01:06:59.000000', 'consum', 0.0211, 'lps'),
	(484054, 126, '2015-04-01 01:07:00.000000', 'consum', 0.0210, 'lps'),
	(484055, 126, '2015-04-01 01:07:01.000000', 'consum', 0.0225, 'lps'),
	(484056, 126, '2015-04-01 01:07:02.000000', 'consum', 0.0214, 'lps'),
	(484057, 126, '2015-04-01 01:07:03.000000', 'consum', 0.0221, 'lps'),
	(484058, 126, '2015-04-01 01:07:04.000000', 'consum', 0.0218, 'lps'),
	(484059, 126, '2015-04-01 01:07:05.000000', 'consum', 0.0218, 'lps'),
	(484060, 126, '2015-04-01 01:07:06.000000', 'consum', 0.0225, 'lps'),
	(484061, 126, '2015-04-01 01:07:07.000000', 'consum', 0.0225, 'lps'),
	(484062, 126, '2015-04-01 01:07:08.000000', 'consum', 0.0223, 'lps'),
	(484063, 126, '2015-04-01 01:07:09.000000', 'consum', 0.0211, 'lps'),
	(484064, 126, '2015-04-01 01:07:10.000000', 'consum', 0.0213, 'lps'),
	(484065, 126, '2015-04-01 01:07:11.000000', 'consum', 0.0221, 'lps'),
	(484066, 126, '2015-04-01 01:07:12.000000', 'consum', 0.0221, 'lps'),
	(484067, 126, '2015-04-01 01:07:13.000000', 'consum', 0.0217, 'lps'),
	(484068, 126, '2015-04-01 01:07:14.000000', 'consum', 0.0210, 'lps'),
	(484069, 126, '2015-04-01 01:07:15.000000', 'consum', 0.0226, 'lps'),
	(484070, 126, '2015-04-01 01:07:16.000000', 'consum', 0.0219, 'lps'),
	(484071, 126, '2015-04-01 01:07:17.000000', 'consum', 0.0225, 'lps'),
	(484072, 126, '2015-04-01 01:07:18.000000', 'consum', 0.0222, 'lps'),
	(484073, 126, '2015-04-01 01:07:19.000000', 'consum', 0.0225, 'lps'),
	(484074, 126, '2015-04-01 01:07:20.000000', 'consum', 0.0216, 'lps'),
	(484075, 126, '2015-04-01 01:07:21.000000', 'consum', 0.0211, 'lps'),
	(484076, 126, '2015-04-01 01:07:22.000000', 'consum', 0.0214, 'lps'),
	(484077, 126, '2015-04-01 01:07:23.000000', 'consum', 0.0213, 'lps'),
	(484078, 126, '2015-04-01 01:07:24.000000', 'consum', 0.0210, 'lps'),
	(484079, 126, '2015-04-01 01:07:25.000000', 'consum', 0.0222, 'lps'),
	(484080, 126, '2015-04-01 01:07:26.000000', 'consum', 0.0215, 'lps'),
	(484081, 126, '2015-04-01 01:07:27.000000', 'consum', 0.0219, 'lps'),
	(484082, 126, '2015-04-01 01:07:28.000000', 'consum', 0.0221, 'lps'),
	(484083, 126, '2015-04-01 01:07:29.000000', 'consum', 0.0222, 'lps'),
	(484084, 126, '2015-04-01 01:07:30.000000', 'consum', 0.0218, 'lps'),
	(484085, 126, '2015-04-01 01:07:31.000000', 'consum', 0.0216, 'lps'),
	(484086, 126, '2015-04-01 01:07:32.000000', 'consum', 0.0215, 'lps'),
	(484087, 126, '2015-04-01 01:07:33.000000', 'consum', 0.0216, 'lps'),
	(484088, 126, '2015-04-01 01:07:34.000000', 'consum', 0.0227, 'lps'),
	(484089, 126, '2015-04-01 01:07:35.000000', 'consum', 0.0225, 'lps'),
	(484090, 126, '2015-04-01 01:07:36.000000', 'consum', 0.0214, 'lps'),
	(484091, 126, '2015-04-01 01:07:37.000000', 'consum', 0.0223, 'lps'),
	(484092, 126, '2015-04-01 01:07:38.000000', 'consum', 0.0225, 'lps'),
	(484093, 126, '2015-04-01 01:07:39.000000', 'consum', 0.0212, 'lps'),
	(484094, 126, '2015-04-01 01:07:40.000000', 'consum', 0.0212, 'lps'),
	(484095, 126, '2015-04-01 01:07:41.000000', 'consum', 0.0212, 'lps'),
	(484096, 126, '2015-04-01 01:07:42.000000', 'consum', 0.0218, 'lps'),
	(484097, 126, '2015-04-01 01:07:43.000000', 'consum', 0.0223, 'lps'),
	(484098, 126, '2015-04-01 01:07:44.000000', 'consum', 0.0219, 'lps'),
	(484099, 126, '2015-04-01 01:07:45.000000', 'consum', 0.0213, 'lps'),
	(484100, 126, '2015-04-01 01:07:46.000000', 'consum', 0.0220, 'lps'),
	(484101, 126, '2015-04-01 01:07:47.000000', 'consum', 0.0212, 'lps'),
	(484102, 126, '2015-04-01 01:07:48.000000', 'consum', 0.0212, 'lps'),
	(484103, 126, '2015-04-01 01:07:49.000000', 'consum', 0.0212, 'lps'),
	(484104, 126, '2015-04-01 01:07:50.000000', 'consum', 0.0215, 'lps'),
	(484105, 126, '2015-04-01 01:07:51.000000', 'consum', 0.0212, 'lps'),
	(484106, 126, '2015-04-01 01:07:52.000000', 'consum', 0.0223, 'lps'),
	(484107, 126, '2015-04-01 01:07:53.000000', 'consum', 0.0217, 'lps'),
	(484108, 126, '2015-04-01 01:07:54.000000', 'consum', 0.0223, 'lps'),
	(484109, 126, '2015-04-01 01:07:55.000000', 'consum', 0.0217, 'lps'),
	(484110, 126, '2015-04-01 01:07:56.000000', 'consum', 0.0226, 'lps'),
	(484111, 126, '2015-04-01 01:07:57.000000', 'consum', 0.0217, 'lps'),
	(484112, 126, '2015-04-01 01:07:58.000000', 'consum', 0.0216, 'lps'),
	(484113, 126, '2015-04-01 01:07:59.000000', 'consum', 0.0217, 'lps'),
	(484114, 126, '2015-04-01 01:08:00.000000', 'consum', 0.0227, 'lps'),
	(484115, 126, '2015-04-01 01:08:01.000000', 'consum', 0.0223, 'lps'),
	(484116, 126, '2015-04-01 01:08:02.000000', 'consum', 0.0222, 'lps'),
	(484117, 126, '2015-04-01 01:08:03.000000', 'consum', 0.0214, 'lps'),
	(484118, 126, '2015-04-01 01:08:04.000000', 'consum', 0.0214, 'lps'),
	(484119, 126, '2015-04-01 01:08:05.000000', 'consum', 0.0217, 'lps'),
	(484120, 126, '2015-04-01 01:08:06.000000', 'consum', 0.0214, 'lps'),
	(484121, 126, '2015-04-01 01:08:07.000000', 'consum', 0.0211, 'lps'),
	(484122, 126, '2015-04-01 01:08:08.000000', 'consum', 0.0221, 'lps'),
	(484123, 126, '2015-04-01 01:08:09.000000', 'consum', 0.0225, 'lps'),
	(484124, 126, '2015-04-01 01:08:10.000000', 'consum', 0.0219, 'lps'),
	(484125, 126, '2015-04-01 01:08:11.000000', 'consum', 0.0226, 'lps'),
	(484126, 126, '2015-04-01 01:08:12.000000', 'consum', 0.0227, 'lps'),
	(484127, 126, '2015-04-01 01:08:13.000000', 'consum', 0.0214, 'lps'),
	(484128, 126, '2015-04-01 01:08:14.000000', 'consum', 0.0216, 'lps'),
	(484129, 126, '2015-04-01 01:08:15.000000', 'consum', 0.0210, 'lps'),
	(484130, 126, '2015-04-01 01:08:16.000000', 'consum', 0.0212, 'lps'),
	(484131, 126, '2015-04-01 01:08:17.000000', 'consum', 0.0220, 'lps'),
	(484132, 126, '2015-04-01 01:08:18.000000', 'consum', 0.0218, 'lps'),
	(484133, 126, '2015-04-01 01:08:19.000000', 'consum', 0.0220, 'lps'),
	(484134, 126, '2015-04-01 01:08:20.000000', 'consum', 0.0218, 'lps'),
	(484135, 126, '2015-04-01 01:08:21.000000', 'consum', 0.0220, 'lps'),
	(484136, 126, '2015-04-01 01:08:22.000000', 'consum', 0.0220, 'lps'),
	(484137, 126, '2015-04-01 01:08:23.000000', 'consum', 0.0213, 'lps'),
	(484138, 126, '2015-04-01 01:08:24.000000', 'consum', 0.0213, 'lps'),
	(484139, 126, '2015-04-01 01:08:25.000000', 'consum', 0.0216, 'lps'),
	(484140, 126, '2015-04-01 01:08:26.000000', 'consum', 0.0212, 'lps'),
	(484141, 126, '2015-04-01 01:08:27.000000', 'consum', 0.0221, 'lps'),
	(484142, 126, '2015-04-01 01:08:28.000000', 'consum', 0.0225, 'lps'),
	(484143, 126, '2015-04-01 01:08:29.000000', 'consum', 0.0217, 'lps'),
	(484144, 126, '2015-04-01 01:08:30.000000', 'consum', 0.0216, 'lps'),
	(484145, 126, '2015-04-01 01:08:31.000000', 'consum', 0.0221, 'lps'),
	(484146, 126, '2015-04-01 01:08:32.000000', 'consum', 0.0227, 'lps'),
	(484147, 126, '2015-04-01 01:08:33.000000', 'consum', 0.0212, 'lps'),
	(484148, 126, '2015-04-01 01:08:34.000000', 'consum', 0.0222, 'lps'),
	(484149, 126, '2015-04-01 01:08:35.000000', 'consum', 0.0213, 'lps'),
	(484150, 126, '2015-04-01 01:08:36.000000', 'consum', 0.0222, 'lps'),
	(484151, 126, '2015-04-01 01:08:37.000000', 'consum', 0.0211, 'lps'),
	(484152, 126, '2015-04-01 01:08:38.000000', 'consum', 0.0212, 'lps'),
	(484153, 126, '2015-04-01 01:08:39.000000', 'consum', 0.0221, 'lps'),
	(484154, 126, '2015-04-01 01:08:40.000000', 'consum', 0.0221, 'lps'),
	(484155, 126, '2015-04-01 01:08:41.000000', 'consum', 0.0214, 'lps'),
	(484156, 126, '2015-04-01 01:08:42.000000', 'consum', 0.0218, 'lps'),
	(484157, 126, '2015-04-01 01:08:43.000000', 'consum', 0.0220, 'lps'),
	(484158, 126, '2015-04-01 01:08:44.000000', 'consum', 0.0218, 'lps'),
	(484159, 126, '2015-04-01 01:08:45.000000', 'consum', 0.0220, 'lps'),
	(484160, 126, '2015-04-01 01:08:46.000000', 'consum', 0.0217, 'lps'),
	(484161, 126, '2015-04-01 01:08:47.000000', 'consum', 0.0216, 'lps'),
	(484162, 126, '2015-04-01 01:08:48.000000', 'consum', 0.0219, 'lps'),
	(484163, 126, '2015-04-01 01:08:49.000000', 'consum', 0.0219, 'lps'),
	(484164, 126, '2015-04-01 01:08:50.000000', 'consum', 0.0212, 'lps'),
	(484165, 126, '2015-04-01 01:08:51.000000', 'consum', 0.0210, 'lps'),
	(484166, 126, '2015-04-01 01:08:52.000000', 'consum', 0.0223, 'lps'),
	(484167, 126, '2015-04-01 01:08:53.000000', 'consum', 0.0220, 'lps'),
	(484168, 126, '2015-04-01 01:08:54.000000', 'consum', 0.0224, 'lps'),
	(484169, 126, '2015-04-01 01:08:55.000000', 'consum', 0.0213, 'lps'),
	(484170, 126, '2015-04-01 01:08:56.000000', 'consum', 0.0222, 'lps'),
	(484171, 126, '2015-04-01 01:08:57.000000', 'consum', 0.0222, 'lps'),
	(484172, 126, '2015-04-01 01:08:58.000000', 'consum', 0.0219, 'lps'),
	(484173, 126, '2015-04-01 01:08:59.000000', 'consum', 0.0221, 'lps'),
	(484174, 126, '2015-04-01 01:09:00.000000', 'consum', 0.0218, 'lps'),
	(484175, 126, '2015-04-01 01:09:01.000000', 'consum', 0.0217, 'lps'),
	(484176, 126, '2015-04-01 01:09:02.000000', 'consum', 0.0223, 'lps'),
	(484177, 126, '2015-04-01 01:09:03.000000', 'consum', 0.0218, 'lps'),
	(484178, 126, '2015-04-01 01:09:04.000000', 'consum', 0.0212, 'lps'),
	(484179, 126, '2015-04-01 01:09:05.000000', 'consum', 0.0215, 'lps'),
	(484180, 126, '2015-04-01 01:09:06.000000', 'consum', 0.0227, 'lps'),
	(484181, 126, '2015-04-01 01:09:07.000000', 'consum', 0.0211, 'lps'),
	(484182, 126, '2015-04-01 01:09:08.000000', 'consum', 0.0218, 'lps'),
	(484183, 126, '2015-04-01 01:09:09.000000', 'consum', 0.0211, 'lps'),
	(484184, 126, '2015-04-01 01:09:10.000000', 'consum', 0.0210, 'lps'),
	(484185, 126, '2015-04-01 01:09:11.000000', 'consum', 0.0226, 'lps'),
	(484186, 126, '2015-04-01 01:09:12.000000', 'consum', 0.0218, 'lps'),
	(484187, 126, '2015-04-01 01:09:13.000000', 'consum', 0.0222, 'lps'),
	(484188, 126, '2015-04-01 01:09:14.000000', 'consum', 0.0225, 'lps'),
	(484189, 126, '2015-04-01 01:09:15.000000', 'consum', 0.0217, 'lps'),
	(484190, 126, '2015-04-01 01:09:16.000000', 'consum', 0.0218, 'lps'),
	(484191, 126, '2015-04-01 01:09:17.000000', 'consum', 0.0227, 'lps'),
	(484192, 126, '2015-04-01 01:09:18.000000', 'consum', 0.0219, 'lps'),
	(484193, 126, '2015-04-01 01:09:19.000000', 'consum', 0.0223, 'lps'),
	(484194, 126, '2015-04-01 01:09:20.000000', 'consum', 0.0212, 'lps'),
	(484195, 126, '2015-04-01 01:09:21.000000', 'consum', 0.0219, 'lps'),
	(484196, 126, '2015-04-01 01:09:22.000000', 'consum', 0.0214, 'lps'),
	(484197, 126, '2015-04-01 01:09:23.000000', 'consum', 0.0222, 'lps'),
	(484198, 126, '2015-04-01 01:09:24.000000', 'consum', 0.0221, 'lps'),
	(484199, 126, '2015-04-01 01:09:25.000000', 'consum', 0.0211, 'lps'),
	(484200, 126, '2015-04-01 01:09:26.000000', 'consum', 0.0218, 'lps'),
	(484201, 126, '2015-04-01 01:09:27.000000', 'consum', 0.0213, 'lps'),
	(484202, 126, '2015-04-01 01:09:28.000000', 'consum', 0.0218, 'lps'),
	(484203, 126, '2015-04-01 01:09:29.000000', 'consum', 0.0225, 'lps'),
	(484204, 126, '2015-04-01 01:09:30.000000', 'consum', 0.0223, 'lps'),
	(484205, 126, '2015-04-01 01:09:31.000000', 'consum', 0.0213, 'lps'),
	(484206, 126, '2015-04-01 01:09:32.000000', 'consum', 0.0225, 'lps'),
	(484207, 126, '2015-04-01 01:09:33.000000', 'consum', 0.0220, 'lps'),
	(484208, 126, '2015-04-01 01:09:34.000000', 'consum', 0.0216, 'lps'),
	(484209, 126, '2015-04-01 01:09:35.000000', 'consum', 0.0227, 'lps'),
	(484210, 126, '2015-04-01 01:09:36.000000', 'consum', 0.0223, 'lps'),
	(484211, 126, '2015-04-01 01:09:37.000000', 'consum', 0.0225, 'lps'),
	(484212, 126, '2015-04-01 01:09:38.000000', 'consum', 0.0211, 'lps'),
	(484213, 126, '2015-04-01 01:09:39.000000', 'consum', 0.0224, 'lps'),
	(484214, 126, '2015-04-01 01:09:40.000000', 'consum', 0.0224, 'lps'),
	(484215, 126, '2015-04-01 01:09:41.000000', 'consum', 0.0221, 'lps'),
	(484216, 126, '2015-04-01 01:09:42.000000', 'consum', 0.0222, 'lps'),
	(484217, 126, '2015-04-01 01:09:43.000000', 'consum', 0.0222, 'lps'),
	(484218, 126, '2015-04-01 01:09:44.000000', 'consum', 0.0216, 'lps'),
	(484219, 126, '2015-04-01 01:09:45.000000', 'consum', 0.0220, 'lps'),
	(484220, 126, '2015-04-01 01:09:46.000000', 'consum', 0.0227, 'lps'),
	(484221, 126, '2015-04-01 01:09:47.000000', 'consum', 0.0211, 'lps'),
	(484222, 126, '2015-04-01 01:09:48.000000', 'consum', 0.0220, 'lps'),
	(484223, 126, '2015-04-01 01:09:49.000000', 'consum', 0.0221, 'lps'),
	(484224, 126, '2015-04-01 01:09:50.000000', 'consum', 0.0216, 'lps'),
	(484225, 126, '2015-04-01 01:09:51.000000', 'consum', 0.0210, 'lps'),
	(484226, 126, '2015-04-01 01:09:52.000000', 'consum', 0.0210, 'lps'),
	(484227, 126, '2015-04-01 01:09:53.000000', 'consum', 0.0227, 'lps'),
	(484228, 126, '2015-04-01 01:09:54.000000', 'consum', 0.0224, 'lps'),
	(484229, 126, '2015-04-01 01:09:55.000000', 'consum', 0.0210, 'lps'),
	(484230, 126, '2015-04-01 01:09:56.000000', 'consum', 0.0224, 'lps'),
	(484231, 126, '2015-04-01 01:09:57.000000', 'consum', 0.0225, 'lps'),
	(484232, 126, '2015-04-01 01:09:58.000000', 'consum', 0.0224, 'lps'),
	(484233, 126, '2015-04-01 01:09:59.000000', 'consum', 0.0221, 'lps'),
	(484234, 126, '2015-04-01 01:10:00.000000', 'consum', 0.0221, 'lps'),
	(484235, 126, '2015-04-01 01:10:01.000000', 'consum', 0.0216, 'lps'),
	(484236, 126, '2015-04-01 01:10:02.000000', 'consum', 0.0223, 'lps'),
	(484237, 126, '2015-04-01 01:10:03.000000', 'consum', 0.0223, 'lps'),
	(484238, 126, '2015-04-01 01:10:04.000000', 'consum', 0.0217, 'lps'),
	(484239, 126, '2015-04-01 01:10:05.000000', 'consum', 0.0224, 'lps'),
	(484240, 126, '2015-04-01 01:10:06.000000', 'consum', 0.0224, 'lps'),
	(484241, 126, '2015-04-01 01:10:07.000000', 'consum', 0.0222, 'lps'),
	(484242, 126, '2015-04-01 01:10:08.000000', 'consum', 0.0210, 'lps'),
	(484243, 126, '2015-04-01 01:10:09.000000', 'consum', 0.0212, 'lps'),
	(484244, 126, '2015-04-01 01:10:10.000000', 'consum', 0.0220, 'lps'),
	(484245, 126, '2015-04-01 01:10:11.000000', 'consum', 0.0220, 'lps'),
	(484246, 126, '2015-04-01 01:10:12.000000', 'consum', 0.0211, 'lps'),
	(484247, 126, '2015-04-01 01:10:13.000000', 'consum', 0.0220, 'lps'),
	(484248, 126, '2015-04-01 01:10:14.000000', 'consum', 0.0222, 'lps'),
	(484249, 126, '2015-04-01 01:10:15.000000', 'consum', 0.0224, 'lps'),
	(484250, 126, '2015-04-01 01:10:16.000000', 'consum', 0.0225, 'lps'),
	(484251, 126, '2015-04-01 01:10:17.000000', 'consum', 0.0226, 'lps'),
	(484252, 126, '2015-04-01 01:10:18.000000', 'consum', 0.0210, 'lps'),
	(484253, 126, '2015-04-01 01:10:19.000000', 'consum', 0.0214, 'lps'),
	(484254, 126, '2015-04-01 01:10:20.000000', 'consum', 0.0214, 'lps'),
	(484255, 126, '2015-04-01 01:10:21.000000', 'consum', 0.0220, 'lps'),
	(484256, 126, '2015-04-01 01:10:22.000000', 'consum', 0.0213, 'lps'),
	(484257, 126, '2015-04-01 01:10:23.000000', 'consum', 0.0213, 'lps'),
	(484258, 126, '2015-04-01 01:10:24.000000', 'consum', 0.0217, 'lps'),
	(484259, 126, '2015-04-01 01:10:25.000000', 'consum', 0.0219, 'lps'),
	(484260, 126, '2015-04-01 01:10:26.000000', 'consum', 0.0216, 'lps'),
	(484261, 126, '2015-04-01 01:10:27.000000', 'consum', 0.0212, 'lps'),
	(484262, 126, '2015-04-01 01:10:28.000000', 'consum', 0.0222, 'lps'),
	(484263, 126, '2015-04-01 01:10:29.000000', 'consum', 0.0226, 'lps'),
	(484264, 126, '2015-04-01 01:10:30.000000', 'consum', 0.0221, 'lps'),
	(484265, 126, '2015-04-01 01:10:31.000000', 'consum', 0.0216, 'lps'),
	(484266, 126, '2015-04-01 01:10:32.000000', 'consum', 0.0226, 'lps'),
	(484267, 126, '2015-04-01 01:10:33.000000', 'consum', 0.0218, 'lps'),
	(484268, 126, '2015-04-01 01:10:34.000000', 'consum', 0.0220, 'lps'),
	(484269, 126, '2015-04-01 01:10:35.000000', 'consum', 0.0218, 'lps'),
	(484270, 126, '2015-04-01 01:10:36.000000', 'consum', 0.0223, 'lps'),
	(484271, 126, '2015-04-01 01:10:37.000000', 'consum', 0.0213, 'lps'),
	(484272, 126, '2015-04-01 01:10:38.000000', 'consum', 0.0225, 'lps'),
	(484273, 126, '2015-04-01 01:10:39.000000', 'consum', 0.0223, 'lps'),
	(484274, 126, '2015-04-01 01:10:40.000000', 'consum', 0.0212, 'lps'),
	(484275, 126, '2015-04-01 01:10:41.000000', 'consum', 0.0218, 'lps'),
	(484276, 126, '2015-04-01 01:10:42.000000', 'consum', 0.0210, 'lps'),
	(484277, 126, '2015-04-01 01:10:43.000000', 'consum', 0.0220, 'lps'),
	(484278, 126, '2015-04-01 01:10:44.000000', 'consum', 0.0224, 'lps'),
	(484279, 126, '2015-04-01 01:10:45.000000', 'consum', 0.0214, 'lps'),
	(484280, 126, '2015-04-01 01:10:46.000000', 'consum', 0.0224, 'lps'),
	(484281, 126, '2015-04-01 01:10:47.000000', 'consum', 0.0215, 'lps'),
	(484282, 126, '2015-04-01 01:10:48.000000', 'consum', 0.0211, 'lps'),
	(484283, 126, '2015-04-01 01:10:49.000000', 'consum', 0.0218, 'lps'),
	(484284, 126, '2015-04-01 01:10:50.000000', 'consum', 0.0213, 'lps'),
	(484285, 126, '2015-04-01 01:10:51.000000', 'consum', 0.0219, 'lps'),
	(484286, 126, '2015-04-01 01:10:52.000000', 'consum', 0.0212, 'lps'),
	(484287, 126, '2015-04-01 01:10:53.000000', 'consum', 0.0212, 'lps'),
	(484288, 126, '2015-04-01 01:10:54.000000', 'consum', 0.0213, 'lps'),
	(484289, 126, '2015-04-01 01:10:55.000000', 'consum', 0.0218, 'lps'),
	(484290, 126, '2015-04-01 01:10:56.000000', 'consum', 0.0224, 'lps'),
	(484291, 126, '2015-04-01 01:10:57.000000', 'consum', 0.0221, 'lps'),
	(484292, 126, '2015-04-01 01:10:58.000000', 'consum', 0.0225, 'lps'),
	(484293, 126, '2015-04-01 01:10:59.000000', 'consum', 0.0217, 'lps'),
	(484294, 126, '2015-04-01 01:11:00.000000', 'consum', 0.0217, 'lps'),
	(484295, 126, '2015-04-01 01:11:01.000000', 'consum', 0.0225, 'lps'),
	(484296, 126, '2015-04-01 01:11:02.000000', 'consum', 0.0210, 'lps'),
	(484297, 126, '2015-04-01 01:11:03.000000', 'consum', 0.0220, 'lps'),
	(484298, 126, '2015-04-01 01:11:04.000000', 'consum', 0.0224, 'lps'),
	(484299, 126, '2015-04-01 01:11:05.000000', 'consum', 0.0215, 'lps'),
	(484300, 126, '2015-04-01 01:11:06.000000', 'consum', 0.0227, 'lps'),
	(484301, 126, '2015-04-01 01:11:07.000000', 'consum', 0.0211, 'lps'),
	(484302, 126, '2015-04-01 01:11:08.000000', 'consum', 0.0218, 'lps'),
	(484303, 126, '2015-04-01 01:11:09.000000', 'consum', 0.0212, 'lps'),
	(484304, 126, '2015-04-01 01:11:10.000000', 'consum', 0.0213, 'lps'),
	(484305, 126, '2015-04-01 01:11:11.000000', 'consum', 0.0222, 'lps'),
	(484306, 126, '2015-04-01 01:11:12.000000', 'consum', 0.0224, 'lps'),
	(484307, 126, '2015-04-01 01:11:13.000000', 'consum', 0.0227, 'lps'),
	(484308, 126, '2015-04-01 01:11:14.000000', 'consum', 0.0215, 'lps'),
	(484309, 126, '2015-04-01 01:11:15.000000', 'consum', 0.0224, 'lps'),
	(484310, 126, '2015-04-01 01:11:16.000000', 'consum', 0.0227, 'lps'),
	(484311, 126, '2015-04-01 01:11:17.000000', 'consum', 0.0220, 'lps'),
	(484312, 126, '2015-04-01 01:11:18.000000', 'consum', 0.0226, 'lps'),
	(484313, 126, '2015-04-01 01:11:19.000000', 'consum', 0.0225, 'lps'),
	(484314, 126, '2015-04-01 01:11:20.000000', 'consum', 0.0221, 'lps'),
	(484315, 126, '2015-04-01 01:11:21.000000', 'consum', 0.0220, 'lps'),
	(484316, 126, '2015-04-01 01:11:22.000000', 'consum', 0.0211, 'lps'),
	(484317, 126, '2015-04-01 01:11:23.000000', 'consum', 0.0221, 'lps'),
	(484318, 126, '2015-04-01 01:11:24.000000', 'consum', 0.0225, 'lps'),
	(484319, 126, '2015-04-01 01:11:25.000000', 'consum', 0.0219, 'lps'),
	(484320, 126, '2015-04-01 01:11:26.000000', 'consum', 0.0227, 'lps'),
	(484321, 126, '2015-04-01 01:11:27.000000', 'consum', 0.0214, 'lps'),
	(484322, 126, '2015-04-01 01:11:28.000000', 'consum', 0.0214, 'lps'),
	(484323, 126, '2015-04-01 01:11:29.000000', 'consum', 0.0221, 'lps'),
	(484324, 126, '2015-04-01 01:11:30.000000', 'consum', 0.0216, 'lps'),
	(484325, 126, '2015-04-01 01:11:31.000000', 'consum', 0.0225, 'lps'),
	(484326, 126, '2015-04-01 01:11:32.000000', 'consum', 0.0216, 'lps'),
	(484327, 126, '2015-04-01 01:11:33.000000', 'consum', 0.0212, 'lps'),
	(484328, 126, '2015-04-01 01:11:34.000000', 'consum', 0.0222, 'lps'),
	(484329, 126, '2015-04-01 01:11:35.000000', 'consum', 0.0226, 'lps'),
	(484330, 126, '2015-04-01 01:11:36.000000', 'consum', 0.0221, 'lps'),
	(484331, 126, '2015-04-01 01:11:37.000000', 'consum', 0.0216, 'lps'),
	(484332, 126, '2015-04-01 01:11:38.000000', 'consum', 0.0225, 'lps'),
	(484333, 126, '2015-04-01 01:11:39.000000', 'consum', 0.0215, 'lps'),
	(484334, 126, '2015-04-01 01:11:40.000000', 'consum', 0.0227, 'lps'),
	(484335, 126, '2015-04-01 01:11:41.000000', 'consum', 0.0224, 'lps'),
	(484336, 126, '2015-04-01 01:11:42.000000', 'consum', 0.0212, 'lps'),
	(484337, 126, '2015-04-01 01:11:43.000000', 'consum', 0.0213, 'lps'),
	(484338, 126, '2015-04-01 01:11:44.000000', 'consum', 0.0223, 'lps'),
	(484339, 126, '2015-04-01 01:11:45.000000', 'consum', 0.0227, 'lps'),
	(484340, 126, '2015-04-01 01:11:46.000000', 'consum', 0.0222, 'lps'),
	(484341, 126, '2015-04-01 01:11:47.000000', 'consum', 0.0219, 'lps'),
	(484342, 126, '2015-04-01 01:11:48.000000', 'consum', 0.0221, 'lps'),
	(484343, 126, '2015-04-01 01:11:49.000000', 'consum', 0.0220, 'lps'),
	(484344, 126, '2015-04-01 01:11:50.000000', 'consum', 0.0210, 'lps'),
	(484345, 126, '2015-04-01 01:11:51.000000', 'consum', 0.0216, 'lps'),
	(484346, 126, '2015-04-01 01:11:52.000000', 'consum', 0.0222, 'lps'),
	(484347, 126, '2015-04-01 01:11:53.000000', 'consum', 0.0218, 'lps'),
	(484348, 126, '2015-04-01 01:11:54.000000', 'consum', 0.0212, 'lps'),
	(484349, 126, '2015-04-01 01:11:55.000000', 'consum', 0.0214, 'lps'),
	(484350, 126, '2015-04-01 01:11:56.000000', 'consum', 0.0225, 'lps'),
	(484351, 126, '2015-04-01 01:11:57.000000', 'consum', 0.0219, 'lps'),
	(484352, 126, '2015-04-01 01:11:58.000000', 'consum', 0.0212, 'lps'),
	(484353, 126, '2015-04-01 01:11:59.000000', 'consum', 0.0210, 'lps'),
	(484354, 126, '2015-04-01 01:12:00.000000', 'consum', 0.0222, 'lps'),
	(484355, 126, '2015-04-01 01:12:01.000000', 'consum', 0.0217, 'lps'),
	(484356, 126, '2015-04-01 01:12:02.000000', 'consum', 0.0210, 'lps'),
	(484357, 126, '2015-04-01 01:12:03.000000', 'consum', 0.0227, 'lps'),
	(484358, 126, '2015-04-01 01:12:04.000000', 'consum', 0.0223, 'lps'),
	(484359, 126, '2015-04-01 01:12:05.000000', 'consum', 0.0225, 'lps'),
	(484360, 126, '2015-04-01 01:12:06.000000', 'consum', 0.0211, 'lps'),
	(484361, 126, '2015-04-01 01:12:07.000000', 'consum', 0.0222, 'lps'),
	(484362, 126, '2015-04-01 01:12:08.000000', 'consum', 0.0215, 'lps'),
	(484363, 126, '2015-04-01 01:12:09.000000', 'consum', 0.0217, 'lps'),
	(484364, 126, '2015-04-01 01:12:10.000000', 'consum', 0.0212, 'lps'),
	(484365, 126, '2015-04-01 01:12:11.000000', 'consum', 0.0217, 'lps'),
	(484366, 126, '2015-04-01 01:12:12.000000', 'consum', 0.0221, 'lps'),
	(484367, 126, '2015-04-01 01:12:13.000000', 'consum', 0.0226, 'lps'),
	(484368, 126, '2015-04-01 01:12:14.000000', 'consum', 0.0223, 'lps'),
	(484369, 126, '2015-04-01 01:12:15.000000', 'consum', 0.0210, 'lps'),
	(484370, 126, '2015-04-01 01:12:16.000000', 'consum', 0.0224, 'lps'),
	(484371, 126, '2015-04-01 01:12:17.000000', 'consum', 0.0211, 'lps'),
	(484372, 126, '2015-04-01 01:12:18.000000', 'consum', 0.0226, 'lps'),
	(484373, 126, '2015-04-01 01:12:19.000000', 'consum', 0.0218, 'lps'),
	(484374, 126, '2015-04-01 01:12:20.000000', 'consum', 0.0217, 'lps'),
	(484375, 126, '2015-04-01 01:12:21.000000', 'consum', 0.0222, 'lps'),
	(484376, 126, '2015-04-01 01:12:22.000000', 'consum', 0.0216, 'lps'),
	(484377, 126, '2015-04-01 01:12:23.000000', 'consum', 0.0220, 'lps'),
	(484378, 126, '2015-04-01 01:12:24.000000', 'consum', 0.0225, 'lps'),
	(484379, 126, '2015-04-01 01:12:25.000000', 'consum', 0.0219, 'lps'),
	(484380, 126, '2015-04-01 01:12:26.000000', 'consum', 0.0210, 'lps'),
	(484381, 126, '2015-04-01 01:12:27.000000', 'consum', 0.0218, 'lps'),
	(484382, 126, '2015-04-01 01:12:28.000000', 'consum', 0.0216, 'lps'),
	(484383, 126, '2015-04-01 01:12:29.000000', 'consum', 0.0218, 'lps'),
	(484384, 126, '2015-04-01 01:12:30.000000', 'consum', 0.0215, 'lps'),
	(484385, 126, '2015-04-01 01:12:31.000000', 'consum', 0.0212, 'lps'),
	(484386, 126, '2015-04-01 01:12:32.000000', 'consum', 0.0222, 'lps'),
	(484387, 126, '2015-04-01 01:12:33.000000', 'consum', 0.0210, 'lps'),
	(484388, 126, '2015-04-01 01:12:34.000000', 'consum', 0.0210, 'lps'),
	(484389, 126, '2015-04-01 01:12:35.000000', 'consum', 0.0210, 'lps'),
	(484390, 126, '2015-04-01 01:12:36.000000', 'consum', 0.0211, 'lps'),
	(484391, 126, '2015-04-01 01:12:37.000000', 'consum', 0.0215, 'lps'),
	(484392, 126, '2015-04-01 01:12:38.000000', 'consum', 0.0216, 'lps'),
	(484393, 126, '2015-04-01 01:12:39.000000', 'consum', 0.0227, 'lps'),
	(484394, 126, '2015-04-01 01:12:40.000000', 'consum', 0.0221, 'lps'),
	(484395, 126, '2015-04-01 01:12:41.000000', 'consum', 0.0217, 'lps'),
	(484396, 126, '2015-04-01 01:12:42.000000', 'consum', 0.0210, 'lps'),
	(484397, 126, '2015-04-01 01:12:43.000000', 'consum', 0.0210, 'lps'),
	(484398, 126, '2015-04-01 01:12:44.000000', 'consum', 0.0226, 'lps'),
	(484399, 126, '2015-04-01 01:12:45.000000', 'consum', 0.0219, 'lps'),
	(484400, 126, '2015-04-01 01:12:46.000000', 'consum', 0.0225, 'lps'),
	(484401, 126, '2015-04-01 01:12:47.000000', 'consum', 0.0224, 'lps'),
	(484402, 126, '2015-04-01 01:12:48.000000', 'consum', 0.0216, 'lps'),
	(484403, 126, '2015-04-01 01:12:49.000000', 'consum', 0.0219, 'lps'),
	(484404, 126, '2015-04-01 01:12:50.000000', 'consum', 0.0219, 'lps'),
	(484405, 126, '2015-04-01 01:12:51.000000', 'consum', 0.0211, 'lps'),
	(484406, 126, '2015-04-01 01:12:52.000000', 'consum', 0.0222, 'lps'),
	(484407, 126, '2015-04-01 01:12:53.000000', 'consum', 0.0214, 'lps'),
	(484408, 126, '2015-04-01 01:12:54.000000', 'consum', 0.0212, 'lps'),
	(484409, 126, '2015-04-01 01:12:55.000000', 'consum', 0.0227, 'lps'),
	(484410, 126, '2015-04-01 01:12:56.000000', 'consum', 0.0220, 'lps'),
	(484411, 126, '2015-04-01 01:12:57.000000', 'consum', 0.0224, 'lps'),
	(484412, 126, '2015-04-01 01:12:58.000000', 'consum', 0.0215, 'lps'),
	(484413, 126, '2015-04-01 01:12:59.000000', 'consum', 0.0214, 'lps'),
	(484414, 126, '2015-04-01 01:13:00.000000', 'consum', 0.0213, 'lps'),
	(484415, 126, '2015-04-01 01:13:01.000000', 'consum', 0.0214, 'lps'),
	(484416, 126, '2015-04-01 01:13:02.000000', 'consum', 0.0220, 'lps'),
	(484417, 126, '2015-04-01 01:13:03.000000', 'consum', 0.0213, 'lps'),
	(484418, 126, '2015-04-01 01:13:04.000000', 'consum', 0.0216, 'lps'),
	(484419, 126, '2015-04-01 01:13:05.000000', 'consum', 0.0212, 'lps'),
	(484420, 126, '2015-04-01 01:13:06.000000', 'consum', 0.0221, 'lps'),
	(484421, 126, '2015-04-01 01:13:07.000000', 'consum', 0.0223, 'lps'),
	(484422, 126, '2015-04-01 01:13:08.000000', 'consum', 0.0224, 'lps'),
	(484423, 126, '2015-04-01 01:13:09.000000', 'consum', 0.0223, 'lps'),
	(484424, 126, '2015-04-01 01:13:10.000000', 'consum', 0.0216, 'lps'),
	(484425, 126, '2015-04-01 01:13:11.000000', 'consum', 0.0221, 'lps'),
	(484426, 126, '2015-04-01 01:13:12.000000', 'consum', 0.0227, 'lps'),
	(484427, 126, '2015-04-01 01:13:13.000000', 'consum', 0.0210, 'lps'),
	(484428, 126, '2015-04-01 01:13:14.000000', 'consum', 0.0215, 'lps'),
	(484429, 126, '2015-04-01 01:13:15.000000', 'consum', 0.0215, 'lps'),
	(484430, 126, '2015-04-01 01:13:16.000000', 'consum', 0.0222, 'lps'),
	(484431, 126, '2015-04-01 01:13:17.000000', 'consum', 0.0220, 'lps'),
	(484432, 126, '2015-04-01 01:13:18.000000', 'consum', 0.0223, 'lps'),
	(484433, 126, '2015-04-01 01:13:19.000000', 'consum', 0.0226, 'lps'),
	(484434, 126, '2015-04-01 01:13:20.000000', 'consum', 0.0217, 'lps'),
	(484435, 126, '2015-04-01 01:13:21.000000', 'consum', 0.0214, 'lps'),
	(484436, 126, '2015-04-01 01:13:22.000000', 'consum', 0.0212, 'lps'),
	(484437, 126, '2015-04-01 01:13:23.000000', 'consum', 0.0225, 'lps'),
	(484438, 126, '2015-04-01 01:13:24.000000', 'consum', 0.0226, 'lps'),
	(484439, 126, '2015-04-01 01:13:25.000000', 'consum', 0.0211, 'lps'),
	(484440, 126, '2015-04-01 01:13:26.000000', 'consum', 0.0221, 'lps'),
	(484441, 126, '2015-04-01 01:13:27.000000', 'consum', 0.0210, 'lps'),
	(484442, 126, '2015-04-01 01:13:28.000000', 'consum', 0.0213, 'lps'),
	(484443, 126, '2015-04-01 01:13:29.000000', 'consum', 0.0224, 'lps'),
	(484444, 126, '2015-04-01 01:13:30.000000', 'consum', 0.0217, 'lps'),
	(484445, 126, '2015-04-01 01:13:31.000000', 'consum', 0.0223, 'lps'),
	(484446, 126, '2015-04-01 01:13:32.000000', 'consum', 0.0220, 'lps'),
	(484447, 126, '2015-04-01 01:13:33.000000', 'consum', 0.0219, 'lps'),
	(484448, 126, '2015-04-01 01:13:34.000000', 'consum', 0.0227, 'lps'),
	(484449, 126, '2015-04-01 01:13:35.000000', 'consum', 0.0215, 'lps'),
	(484450, 126, '2015-04-01 01:13:36.000000', 'consum', 0.0220, 'lps'),
	(484451, 126, '2015-04-01 01:13:37.000000', 'consum', 0.0210, 'lps'),
	(484452, 126, '2015-04-01 01:13:38.000000', 'consum', 0.0216, 'lps'),
	(484453, 126, '2015-04-01 01:13:39.000000', 'consum', 0.0224, 'lps'),
	(484454, 126, '2015-04-01 01:13:40.000000', 'consum', 0.0223, 'lps'),
	(484455, 126, '2015-04-01 01:13:41.000000', 'consum', 0.0219, 'lps'),
	(484456, 126, '2015-04-01 01:13:42.000000', 'consum', 0.0216, 'lps'),
	(484457, 126, '2015-04-01 01:13:43.000000', 'consum', 0.0214, 'lps'),
	(484458, 126, '2015-04-01 01:13:44.000000', 'consum', 0.0212, 'lps'),
	(484459, 126, '2015-04-01 01:13:45.000000', 'consum', 0.0225, 'lps'),
	(484460, 126, '2015-04-01 01:13:46.000000', 'consum', 0.0226, 'lps'),
	(484461, 126, '2015-04-01 01:13:47.000000', 'consum', 0.0211, 'lps'),
	(484462, 126, '2015-04-01 01:13:48.000000', 'consum', 0.0222, 'lps'),
	(484463, 126, '2015-04-01 01:13:49.000000', 'consum', 0.0212, 'lps'),
	(484464, 126, '2015-04-01 01:13:50.000000', 'consum', 0.0221, 'lps'),
	(484465, 126, '2015-04-01 01:13:51.000000', 'consum', 0.0222, 'lps'),
	(484466, 126, '2015-04-01 01:13:52.000000', 'consum', 0.0221, 'lps'),
	(484467, 126, '2015-04-01 01:13:53.000000', 'consum', 0.0212, 'lps'),
	(484468, 126, '2015-04-01 01:13:54.000000', 'consum', 0.0221, 'lps'),
	(484469, 126, '2015-04-01 01:13:55.000000', 'consum', 0.0224, 'lps'),
	(484470, 126, '2015-04-01 01:13:56.000000', 'consum', 0.0212, 'lps'),
	(484471, 126, '2015-04-01 01:13:57.000000', 'consum', 0.0213, 'lps'),
	(484472, 126, '2015-04-01 01:13:58.000000', 'consum', 0.0221, 'lps'),
	(484473, 126, '2015-04-01 01:13:59.000000', 'consum', 0.0219, 'lps'),
	(484474, 126, '2015-04-01 01:14:00.000000', 'consum', 0.0222, 'lps'),
	(484475, 126, '2015-04-01 01:14:01.000000', 'consum', 0.0225, 'lps'),
	(484476, 126, '2015-04-01 01:14:02.000000', 'consum', 0.0214, 'lps'),
	(484477, 126, '2015-04-01 01:14:03.000000', 'consum', 0.0221, 'lps'),
	(484478, 126, '2015-04-01 01:14:04.000000', 'consum', 0.0217, 'lps'),
	(484479, 126, '2015-04-01 01:14:05.000000', 'consum', 0.0212, 'lps'),
	(484480, 126, '2015-04-01 01:14:06.000000', 'consum', 0.0220, 'lps'),
	(484481, 126, '2015-04-01 01:14:07.000000', 'consum', 0.0219, 'lps'),
	(484482, 126, '2015-04-01 01:14:08.000000', 'consum', 0.0226, 'lps'),
	(484483, 126, '2015-04-01 01:14:09.000000', 'consum', 0.0224, 'lps'),
	(484484, 126, '2015-04-01 01:14:10.000000', 'consum', 0.0218, 'lps'),
	(484485, 126, '2015-04-01 01:14:11.000000', 'consum', 0.0226, 'lps'),
	(484486, 126, '2015-04-01 01:14:12.000000', 'consum', 0.0212, 'lps'),
	(484487, 126, '2015-04-01 01:14:13.000000', 'consum', 0.0225, 'lps'),
	(484488, 126, '2015-04-01 01:14:14.000000', 'consum', 0.0210, 'lps'),
	(484489, 126, '2015-04-01 01:14:15.000000', 'consum', 0.0219, 'lps'),
	(484490, 126, '2015-04-01 01:14:16.000000', 'consum', 0.0221, 'lps'),
	(484491, 126, '2015-04-01 01:14:17.000000', 'consum', 0.0217, 'lps'),
	(484492, 126, '2015-04-01 01:14:18.000000', 'consum', 0.0215, 'lps'),
	(484493, 126, '2015-04-01 01:14:19.000000', 'consum', 0.0215, 'lps'),
	(484494, 126, '2015-04-01 01:14:20.000000', 'consum', 0.0220, 'lps'),
	(484495, 126, '2015-04-01 01:14:21.000000', 'consum', 0.0210, 'lps'),
	(484496, 126, '2015-04-01 01:14:22.000000', 'consum', 0.0217, 'lps'),
	(484497, 126, '2015-04-01 01:14:23.000000', 'consum', 0.0227, 'lps'),
	(484498, 126, '2015-04-01 01:14:24.000000', 'consum', 0.0220, 'lps'),
	(484499, 126, '2015-04-01 01:14:25.000000', 'consum', 0.0226, 'lps'),
	(484500, 126, '2015-04-01 01:14:26.000000', 'consum', 0.0226, 'lps'),
	(484501, 126, '2015-04-01 01:14:27.000000', 'consum', 0.0225, 'lps'),
	(484502, 126, '2015-04-01 01:14:28.000000', 'consum', 0.0217, 'lps'),
	(484503, 126, '2015-04-01 01:14:29.000000', 'consum', 0.0220, 'lps'),
	(484504, 126, '2015-04-01 01:14:30.000000', 'consum', 0.0223, 'lps'),
	(484505, 126, '2015-04-01 01:14:31.000000', 'consum', 0.0225, 'lps'),
	(484506, 126, '2015-04-01 01:14:32.000000', 'consum', 0.0212, 'lps'),
	(484507, 126, '2015-04-01 01:14:33.000000', 'consum', 0.0210, 'lps'),
	(484508, 126, '2015-04-01 01:14:34.000000', 'consum', 0.0225, 'lps'),
	(484509, 126, '2015-04-01 01:14:35.000000', 'consum', 0.0211, 'lps'),
	(484510, 126, '2015-04-01 01:14:36.000000', 'consum', 0.0225, 'lps'),
	(484511, 126, '2015-04-01 01:14:37.000000', 'consum', 0.0211, 'lps'),
	(484512, 126, '2015-04-01 01:14:38.000000', 'consum', 0.0223, 'lps'),
	(484513, 126, '2015-04-01 01:14:39.000000', 'consum', 0.0218, 'lps'),
	(484514, 126, '2015-04-01 01:14:40.000000', 'consum', 0.0210, 'lps'),
	(484515, 126, '2015-04-01 01:14:41.000000', 'consum', 0.0226, 'lps'),
	(484516, 126, '2015-04-01 01:14:42.000000', 'consum', 0.0218, 'lps'),
	(484517, 126, '2015-04-01 01:14:43.000000', 'consum', 0.0220, 'lps'),
	(484518, 126, '2015-04-01 01:14:44.000000', 'consum', 0.0217, 'lps'),
	(484519, 126, '2015-04-01 01:14:45.000000', 'consum', 0.0215, 'lps'),
	(484520, 126, '2015-04-01 01:14:46.000000', 'consum', 0.0215, 'lps'),
	(484521, 126, '2015-04-01 01:14:47.000000', 'consum', 0.0220, 'lps'),
	(484522, 126, '2015-04-01 01:14:48.000000', 'consum', 0.0212, 'lps'),
	(484523, 126, '2015-04-01 01:14:49.000000', 'consum', 0.0225, 'lps'),
	(484524, 126, '2015-04-01 01:14:50.000000', 'consum', 0.0226, 'lps'),
	(484525, 126, '2015-04-01 01:14:51.000000', 'consum', 0.0226, 'lps'),
	(484526, 126, '2015-04-01 01:14:52.000000', 'consum', 0.0227, 'lps'),
	(484527, 126, '2015-04-01 01:14:53.000000', 'consum', 0.0210, 'lps'),
	(484528, 126, '2015-04-01 01:14:54.000000', 'consum', 0.0214, 'lps'),
	(484529, 126, '2015-04-01 01:14:55.000000', 'consum', 0.0214, 'lps'),
	(484530, 126, '2015-04-01 01:14:56.000000', 'consum', 0.0218, 'lps'),
	(484531, 126, '2015-04-01 01:14:57.000000', 'consum', 0.0221, 'lps'),
	(484532, 126, '2015-04-01 01:14:58.000000', 'consum', 0.0223, 'lps'),
	(484533, 126, '2015-04-01 01:14:59.000000', 'consum', 0.0222, 'lps'),
	(484534, 126, '2015-04-01 01:15:00.000000', 'consum', 0.0217, 'lps'),
	(484535, 126, '2015-04-01 01:15:01.000000', 'consum', 0.0225, 'lps'),
	(484536, 126, '2015-04-01 01:15:02.000000', 'consum', 0.0212, 'lps'),
	(484537, 126, '2015-04-01 01:15:03.000000', 'consum', 0.0213, 'lps'),
	(484538, 126, '2015-04-01 01:15:04.000000', 'consum', 0.0216, 'lps'),
	(484539, 126, '2015-04-01 01:15:05.000000', 'consum', 0.0217, 'lps'),
	(484540, 126, '2015-04-01 01:15:06.000000', 'consum', 0.0225, 'lps'),
	(484541, 126, '2015-04-01 01:15:07.000000', 'consum', 0.0212, 'lps'),
	(484542, 126, '2015-04-01 01:15:08.000000', 'consum', 0.0227, 'lps'),
	(484543, 126, '2015-04-01 01:15:09.000000', 'consum', 0.0219, 'lps'),
	(484544, 126, '2015-04-01 01:15:10.000000', 'consum', 0.0221, 'lps'),
	(484545, 126, '2015-04-01 01:15:11.000000', 'consum', 0.0221, 'lps'),
	(484546, 126, '2015-04-01 01:15:12.000000', 'consum', 0.0215, 'lps'),
	(484547, 126, '2015-04-01 01:15:13.000000', 'consum', 0.0218, 'lps'),
	(484548, 126, '2015-04-01 01:15:14.000000', 'consum', 0.0221, 'lps'),
	(484549, 126, '2015-04-01 01:15:15.000000', 'consum', 0.0221, 'lps'),
	(484550, 126, '2015-04-01 01:15:16.000000', 'consum', 0.0216, 'lps'),
	(484551, 126, '2015-04-01 01:15:17.000000', 'consum', 0.0225, 'lps'),
	(484552, 126, '2015-04-01 01:15:18.000000', 'consum', 0.0213, 'lps'),
	(484553, 126, '2015-04-01 01:15:19.000000', 'consum', 0.0218, 'lps'),
	(484554, 126, '2015-04-01 01:15:20.000000', 'consum', 0.0222, 'lps'),
	(484555, 126, '2015-04-01 01:15:21.000000', 'consum', 0.0210, 'lps'),
	(484556, 126, '2015-04-01 01:15:22.000000', 'consum', 0.0212, 'lps'),
	(484557, 126, '2015-04-01 01:15:23.000000', 'consum', 0.0219, 'lps'),
	(484558, 126, '2015-04-01 01:15:24.000000', 'consum', 0.0214, 'lps'),
	(484559, 126, '2015-04-01 01:15:25.000000', 'consum', 0.0220, 'lps'),
	(484560, 126, '2015-04-01 01:15:26.000000', 'consum', 0.0216, 'lps'),
	(484561, 126, '2015-04-01 01:15:27.000000', 'consum', 0.0226, 'lps'),
	(484562, 126, '2015-04-01 01:15:28.000000', 'consum', 0.0217, 'lps'),
	(484563, 126, '2015-04-01 01:15:29.000000', 'consum', 0.0218, 'lps'),
	(484564, 126, '2015-04-01 01:15:30.000000', 'consum', 0.0211, 'lps'),
	(484565, 126, '2015-04-01 01:15:31.000000', 'consum', 0.0227, 'lps'),
	(484566, 126, '2015-04-01 01:15:32.000000', 'consum', 0.0223, 'lps'),
	(484567, 126, '2015-04-01 01:15:33.000000', 'consum', 0.0222, 'lps'),
	(484568, 126, '2015-04-01 01:15:34.000000', 'consum', 0.0214, 'lps'),
	(484569, 126, '2015-04-01 01:15:35.000000', 'consum', 0.0212, 'lps'),
	(484570, 126, '2015-04-01 01:15:36.000000', 'consum', 0.0225, 'lps'),
	(484571, 126, '2015-04-01 01:15:37.000000', 'consum', 0.0210, 'lps'),
	(484572, 126, '2015-04-01 01:15:38.000000', 'consum', 0.0221, 'lps'),
	(484573, 126, '2015-04-01 01:15:39.000000', 'consum', 0.0226, 'lps'),
	(484574, 126, '2015-04-01 01:15:40.000000', 'consum', 0.0222, 'lps'),
	(484575, 126, '2015-04-01 01:15:41.000000', 'consum', 0.0222, 'lps'),
	(484576, 126, '2015-04-01 01:15:42.000000', 'consum', 0.0217, 'lps'),
	(484577, 126, '2015-04-01 01:15:43.000000', 'consum', 0.0227, 'lps'),
	(484578, 126, '2015-04-01 01:15:44.000000', 'consum', 0.0221, 'lps'),
	(484579, 126, '2015-04-01 01:15:45.000000', 'consum', 0.0214, 'lps'),
	(484580, 126, '2015-04-01 01:15:46.000000', 'consum', 0.0217, 'lps'),
	(484581, 126, '2015-04-01 01:15:47.000000', 'consum', 0.0216, 'lps'),
	(484582, 126, '2015-04-01 01:15:48.000000', 'consum', 0.0216, 'lps'),
	(484583, 126, '2015-04-01 01:15:49.000000', 'consum', 0.0226, 'lps'),
	(484584, 126, '2015-04-01 01:15:50.000000', 'consum', 0.0218, 'lps'),
	(484585, 126, '2015-04-01 01:15:51.000000', 'consum', 0.0221, 'lps'),
	(484586, 126, '2015-04-01 01:15:52.000000', 'consum', 0.0223, 'lps'),
	(484587, 126, '2015-04-01 01:15:53.000000', 'consum', 0.0223, 'lps'),
	(484588, 126, '2015-04-01 01:15:54.000000', 'consum', 0.0219, 'lps'),
	(484589, 126, '2015-04-01 01:15:55.000000', 'consum', 0.0217, 'lps'),
	(484590, 126, '2015-04-01 01:15:56.000000', 'consum', 0.0217, 'lps'),
	(484591, 126, '2015-04-01 01:15:57.000000', 'consum', 0.0227, 'lps'),
	(484592, 126, '2015-04-01 01:15:58.000000', 'consum', 0.0221, 'lps'),
	(484593, 126, '2015-04-01 01:15:59.000000', 'consum', 0.0215, 'lps'),
	(484594, 126, '2015-04-01 01:16:00.000000', 'consum', 0.0218, 'lps'),
	(484595, 126, '2015-04-01 01:16:01.000000', 'consum', 0.0219, 'lps'),
	(484596, 126, '2015-04-01 01:16:02.000000', 'consum', 0.0213, 'lps'),
	(484597, 126, '2015-04-01 01:16:03.000000', 'consum', 0.0218, 'lps'),
	(484598, 126, '2015-04-01 01:16:04.000000', 'consum', 0.0222, 'lps'),
	(484599, 126, '2015-04-01 01:16:05.000000', 'consum', 0.0212, 'lps'),
	(484600, 126, '2015-04-01 01:16:06.000000', 'consum', 0.0221, 'lps'),
	(484601, 126, '2015-04-01 01:16:07.000000', 'consum', 0.0221, 'lps'),
	(484602, 126, '2015-04-01 01:16:08.000000', 'consum', 0.0217, 'lps'),
	(484603, 126, '2015-04-01 01:16:09.000000', 'consum', 0.0210, 'lps'),
	(484604, 126, '2015-04-01 01:16:10.000000', 'consum', 0.0227, 'lps'),
	(484605, 126, '2015-04-01 01:16:11.000000', 'consum', 0.0224, 'lps'),
	(484606, 126, '2015-04-01 01:16:12.000000', 'consum', 0.0213, 'lps'),
	(484607, 126, '2015-04-01 01:16:13.000000', 'consum', 0.0218, 'lps'),
	(484608, 126, '2015-04-01 01:16:14.000000', 'consum', 0.0222, 'lps'),
	(484609, 126, '2015-04-01 01:16:15.000000', 'consum', 0.0211, 'lps'),
	(484610, 127, '2014-01-15 00:00:00.000000', 'consum', 0.0225, 'lps'),
	(484611, 127, '2014-01-15 00:00:01.000000', 'consum', 0.0220, 'lps'),
	(484612, 127, '2014-01-15 00:00:02.000000', 'consum', 0.0217, 'lps'),
	(484613, 127, '2014-01-15 00:00:03.000000', 'consum', 0.0217, 'lps'),
	(484614, 127, '2014-01-15 00:00:04.000000', 'consum', 0.0225, 'lps'),
	(484615, 127, '2014-01-15 00:00:05.000000', 'consum', 0.0214, 'lps'),
	(484616, 127, '2014-01-15 00:00:06.000000', 'consum', 0.0217, 'lps'),
	(484617, 127, '2014-01-15 00:00:07.000000', 'consum', 0.0215, 'lps'),
	(484618, 127, '2014-01-15 00:00:08.000000', 'consum', 0.0218, 'lps'),
	(484619, 127, '2014-01-15 00:00:09.000000', 'consum', 0.0218, 'lps'),
	(484620, 127, '2014-01-15 00:00:10.000000', 'consum', 0.0226, 'lps'),
	(484621, 127, '2014-01-15 00:00:11.000000', 'consum', 0.0216, 'lps'),
	(484622, 127, '2014-01-15 00:00:12.000000', 'consum', 0.0226, 'lps'),
	(484623, 127, '2014-01-15 00:00:13.000000', 'consum', 0.0220, 'lps'),
	(484624, 127, '2014-01-15 00:00:14.000000', 'consum', 0.0215, 'lps'),
	(484625, 127, '2014-01-15 00:00:15.000000', 'consum', 0.0222, 'lps'),
	(484626, 127, '2014-01-15 00:00:16.000000', 'consum', 0.0222, 'lps'),
	(484627, 127, '2014-01-15 00:00:17.000000', 'consum', 0.0215, 'lps'),
	(484628, 127, '2014-01-15 00:00:18.000000', 'consum', 0.0219, 'lps'),
	(484629, 127, '2014-01-15 00:00:19.000000', 'consum', 0.0222, 'lps'),
	(484630, 127, '2014-01-15 00:00:20.000000', 'consum', 0.0225, 'lps'),
	(484631, 127, '2014-01-15 00:00:21.000000', 'consum', 0.0216, 'lps'),
	(484632, 127, '2014-01-15 00:00:22.000000', 'consum', 0.0214, 'lps'),
	(484633, 127, '2014-01-15 00:00:23.000000', 'consum', 0.0211, 'lps'),
	(484634, 127, '2014-01-15 00:00:24.000000', 'consum', 0.0223, 'lps'),
	(484635, 127, '2014-01-15 00:00:25.000000', 'consum', 0.0219, 'lps'),
	(484636, 127, '2014-01-15 00:00:26.000000', 'consum', 0.0217, 'lps'),
	(484637, 127, '2014-01-15 00:00:27.000000', 'consum', 0.0217, 'lps'),
	(484638, 127, '2014-01-15 00:00:28.000000', 'consum', 0.0226, 'lps'),
	(484639, 127, '2014-01-15 00:00:29.000000', 'consum', 0.0216, 'lps'),
	(484640, 127, '2014-01-15 00:00:30.000000', 'consum', 0.0212, 'lps'),
	(484641, 127, '2014-01-15 00:00:31.000000', 'consum', 0.0218, 'lps'),
	(484642, 127, '2014-01-15 00:00:32.000000', 'consum', 0.0211, 'lps'),
	(484643, 127, '2014-01-15 00:00:33.000000', 'consum', 0.0225, 'lps'),
	(484644, 127, '2014-01-15 00:00:34.000000', 'consum', 0.0214, 'lps'),
	(484645, 127, '2014-01-15 00:00:35.000000', 'consum', 0.0219, 'lps'),
	(484646, 127, '2014-01-15 00:00:36.000000', 'consum', 0.0210, 'lps'),
	(484647, 127, '2014-01-15 00:00:37.000000', 'consum', 0.0216, 'lps'),
	(484648, 127, '2014-01-15 00:00:38.000000', 'consum', 0.0224, 'lps'),
	(484649, 127, '2014-01-15 00:00:39.000000', 'consum', 0.0212, 'lps'),
	(484650, 127, '2014-01-15 00:00:40.000000', 'consum', 0.0212, 'lps'),
	(484651, 127, '2014-01-15 00:00:41.000000', 'consum', 0.0213, 'lps'),
	(484652, 127, '2014-01-15 00:00:42.000000', 'consum', 0.0221, 'lps'),
	(484653, 127, '2014-01-15 00:00:43.000000', 'consum', 0.0223, 'lps'),
	(484654, 127, '2014-01-15 00:00:44.000000', 'consum', 0.0226, 'lps'),
	(484655, 127, '2014-01-15 00:00:45.000000', 'consum', 0.0216, 'lps'),
	(484656, 127, '2014-01-15 00:00:46.000000', 'consum', 0.0225, 'lps'),
	(484657, 127, '2014-01-15 00:00:47.000000', 'consum', 0.0218, 'lps'),
	(484658, 127, '2014-01-15 00:00:48.000000', 'consum', 0.0221, 'lps'),
	(484659, 127, '2014-01-15 00:00:49.000000', 'consum', 0.0210, 'lps'),
	(484660, 127, '2014-01-15 00:00:50.000000', 'consum', 0.0210, 'lps'),
	(484661, 127, '2014-01-15 00:00:51.000000', 'consum', 0.0226, 'lps'),
	(484662, 127, '2014-01-15 00:00:52.000000', 'consum', 0.0223, 'lps'),
	(484663, 127, '2014-01-15 00:00:53.000000', 'consum', 0.0212, 'lps'),
	(484664, 127, '2014-01-15 00:00:54.000000', 'consum', 0.0216, 'lps'),
	(484665, 127, '2014-01-15 00:00:55.000000', 'consum', 0.0218, 'lps'),
	(484666, 127, '2014-01-15 00:00:56.000000', 'consum', 0.0214, 'lps'),
	(484667, 127, '2014-01-15 00:00:57.000000', 'consum', 0.0225, 'lps'),
	(484668, 127, '2014-01-15 00:00:58.000000', 'consum', 0.0224, 'lps'),
	(484669, 127, '2014-01-15 00:00:59.000000', 'consum', 0.0215, 'lps'),
	(484670, 127, '2014-01-15 00:01:00.000000', 'consum', 0.0211, 'lps'),
	(484671, 127, '2014-01-15 00:01:01.000000', 'consum', 0.0219, 'lps'),
	(484672, 127, '2014-01-15 00:01:02.000000', 'consum', 0.0217, 'lps'),
	(484673, 127, '2014-01-15 00:01:03.000000', 'consum', 0.0218, 'lps'),
	(484674, 127, '2014-01-15 00:01:04.000000', 'consum', 0.0215, 'lps'),
	(484675, 127, '2014-01-15 00:01:05.000000', 'consum', 0.0212, 'lps'),
	(484676, 127, '2014-01-15 00:01:06.000000', 'consum', 0.0220, 'lps'),
	(484677, 127, '2014-01-15 00:01:07.000000', 'consum', 0.0219, 'lps'),
	(484678, 127, '2014-01-15 00:01:08.000000', 'consum', 0.0211, 'lps'),
	(484679, 127, '2014-01-15 00:01:09.000000', 'consum', 0.0224, 'lps'),
	(484680, 127, '2014-01-15 00:01:10.000000', 'consum', 0.0225, 'lps'),
	(484681, 127, '2014-01-15 00:01:11.000000', 'consum', 0.0211, 'lps'),
	(484682, 127, '2014-01-15 00:01:12.000000', 'consum', 0.0219, 'lps'),
	(484683, 127, '2014-01-15 00:01:13.000000', 'consum', 0.0218, 'lps'),
	(484684, 127, '2014-01-15 00:01:14.000000', 'consum', 0.0223, 'lps'),
	(484685, 127, '2014-01-15 00:01:15.000000', 'consum', 0.0217, 'lps'),
	(484686, 127, '2014-01-15 00:01:16.000000', 'consum', 0.0224, 'lps'),
	(484687, 127, '2014-01-15 00:01:17.000000', 'consum', 0.0225, 'lps'),
	(484688, 127, '2014-01-15 00:01:18.000000', 'consum', 0.0210, 'lps'),
	(484689, 127, '2014-01-15 00:01:19.000000', 'consum', 0.0215, 'lps'),
	(484690, 127, '2014-01-15 00:01:20.000000', 'consum', 0.0220, 'lps'),
	(484691, 127, '2014-01-15 00:01:21.000000', 'consum', 0.0211, 'lps'),
	(484692, 127, '2014-01-15 00:01:22.000000', 'consum', 0.0222, 'lps'),
	(484693, 127, '2014-01-15 00:01:23.000000', 'consum', 0.0214, 'lps'),
	(484694, 127, '2014-01-15 00:01:24.000000', 'consum', 0.0211, 'lps'),
	(484695, 127, '2014-01-15 00:01:25.000000', 'consum', 0.0219, 'lps'),
	(484696, 127, '2014-01-15 00:01:26.000000', 'consum', 0.0222, 'lps'),
	(484697, 127, '2014-01-15 00:01:27.000000', 'consum', 0.0225, 'lps'),
	(484698, 127, '2014-01-15 00:01:28.000000', 'consum', 0.0214, 'lps'),
	(484699, 127, '2014-01-15 00:01:29.000000', 'consum', 0.0221, 'lps'),
	(484700, 127, '2014-01-15 00:01:30.000000', 'consum', 0.0220, 'lps'),
	(484701, 127, '2014-01-15 00:01:31.000000', 'consum', 0.0211, 'lps'),
	(484702, 127, '2014-01-15 00:01:32.000000', 'consum', 0.0221, 'lps'),
	(484703, 127, '2014-01-15 00:01:33.000000', 'consum', 0.0226, 'lps'),
	(484704, 127, '2014-01-15 00:01:34.000000', 'consum', 0.0224, 'lps'),
	(484705, 127, '2014-01-15 00:01:35.000000', 'consum', 0.0214, 'lps'),
	(484706, 127, '2014-01-15 00:01:36.000000', 'consum', 0.0222, 'lps'),
	(484707, 127, '2014-01-15 00:01:37.000000', 'consum', 0.0210, 'lps'),
	(484708, 127, '2014-01-15 00:01:38.000000', 'consum', 0.0224, 'lps'),
	(484709, 127, '2014-01-15 00:01:39.000000', 'consum', 0.0212, 'lps'),
	(484710, 127, '2014-01-15 00:01:40.000000', 'consum', 0.0215, 'lps'),
	(484711, 127, '2014-01-15 00:01:41.000000', 'consum', 0.0210, 'lps'),
	(484712, 127, '2014-01-15 00:01:42.000000', 'consum', 0.0213, 'lps'),
	(484713, 127, '2014-01-15 00:01:43.000000', 'consum', 0.0210, 'lps'),
	(484714, 127, '2014-01-15 00:01:44.000000', 'consum', 0.0216, 'lps'),
	(484715, 127, '2014-01-15 00:01:45.000000', 'consum', 0.0226, 'lps'),
	(484716, 127, '2014-01-15 00:01:46.000000', 'consum', 0.0221, 'lps'),
	(484717, 127, '2014-01-15 00:01:47.000000', 'consum', 0.0217, 'lps'),
	(484718, 127, '2014-01-15 00:01:48.000000', 'consum', 0.0212, 'lps'),
	(484719, 127, '2014-01-15 00:01:49.000000', 'consum', 0.0218, 'lps'),
	(484720, 127, '2014-01-15 00:01:50.000000', 'consum', 0.0225, 'lps'),
	(484721, 127, '2014-01-15 00:01:51.000000', 'consum', 0.0213, 'lps'),
	(484722, 127, '2014-01-15 00:01:52.000000', 'consum', 0.0213, 'lps'),
	(484723, 127, '2014-01-15 00:01:53.000000', 'consum', 0.0215, 'lps'),
	(484724, 127, '2014-01-15 00:01:54.000000', 'consum', 0.0211, 'lps'),
	(484725, 127, '2014-01-15 00:01:55.000000', 'consum', 0.0216, 'lps'),
	(484726, 127, '2014-01-15 00:01:56.000000', 'consum', 0.0224, 'lps'),
	(484727, 127, '2014-01-15 00:01:57.000000', 'consum', 0.0225, 'lps'),
	(484728, 127, '2014-01-15 00:01:58.000000', 'consum', 0.0210, 'lps'),
	(484729, 127, '2014-01-15 00:01:59.000000', 'consum', 0.0216, 'lps'),
	(484730, 127, '2014-01-15 00:02:00.000000', 'consum', 0.0225, 'lps'),
	(484731, 127, '2014-01-15 00:02:01.000000', 'consum', 0.0214, 'lps'),
	(484732, 127, '2014-01-15 00:02:02.000000', 'consum', 0.0222, 'lps'),
	(484733, 127, '2014-01-15 00:02:03.000000', 'consum', 0.0223, 'lps'),
	(484734, 127, '2014-01-15 00:02:04.000000', 'consum', 0.0222, 'lps'),
	(484735, 127, '2014-01-15 00:02:05.000000', 'consum', 0.0213, 'lps'),
	(484736, 127, '2014-01-15 00:02:06.000000', 'consum', 0.0210, 'lps'),
	(484737, 127, '2014-01-15 00:02:07.000000', 'consum', 0.0217, 'lps'),
	(484738, 127, '2014-01-15 00:02:08.000000', 'consum', 0.0213, 'lps'),
	(484739, 127, '2014-01-15 00:02:09.000000', 'consum', 0.0220, 'lps'),
	(484740, 127, '2014-01-15 00:02:10.000000', 'consum', 0.0218, 'lps'),
	(484741, 127, '2014-01-15 00:02:11.000000', 'consum', 0.0222, 'lps'),
	(484742, 127, '2014-01-15 00:02:12.000000', 'consum', 0.0226, 'lps'),
	(484743, 127, '2014-01-15 00:02:13.000000', 'consum', 0.0223, 'lps'),
	(484744, 127, '2014-01-15 00:02:14.000000', 'consum', 0.0212, 'lps'),
	(484745, 127, '2014-01-15 00:02:15.000000', 'consum', 0.0212, 'lps'),
	(484746, 127, '2014-01-15 00:02:16.000000', 'consum', 0.0217, 'lps'),
	(484747, 127, '2014-01-15 00:02:17.000000', 'consum', 0.0221, 'lps'),
	(484748, 127, '2014-01-15 00:02:18.000000', 'consum', 0.0210, 'lps'),
	(484749, 127, '2014-01-15 00:02:19.000000', 'consum', 0.0214, 'lps'),
	(484750, 127, '2014-01-15 00:02:20.000000', 'consum', 0.0212, 'lps'),
	(484751, 127, '2014-01-15 00:02:21.000000', 'consum', 0.0224, 'lps'),
	(484752, 127, '2014-01-15 00:02:22.000000', 'consum', 0.0224, 'lps'),
	(484753, 127, '2014-01-15 00:02:23.000000', 'consum', 0.0220, 'lps'),
	(484754, 127, '2014-01-15 00:02:24.000000', 'consum', 0.0221, 'lps'),
	(484755, 127, '2014-01-15 00:02:25.000000', 'consum', 0.0217, 'lps'),
	(484756, 127, '2014-01-15 00:02:26.000000', 'consum', 0.0212, 'lps'),
	(484757, 127, '2014-01-15 00:02:27.000000', 'consum', 0.0216, 'lps'),
	(484758, 127, '2014-01-15 00:02:28.000000', 'consum', 0.0220, 'lps'),
	(484759, 127, '2014-01-15 00:02:29.000000', 'consum', 0.0225, 'lps'),
	(484760, 127, '2014-01-15 00:02:30.000000', 'consum', 0.0219, 'lps'),
	(484761, 127, '2014-01-15 00:02:31.000000', 'consum', 0.0214, 'lps'),
	(484762, 127, '2014-01-15 00:02:32.000000', 'consum', 0.0218, 'lps'),
	(484763, 127, '2014-01-15 00:02:33.000000', 'consum', 0.0221, 'lps'),
	(484764, 127, '2014-01-15 00:02:34.000000', 'consum', 0.0225, 'lps'),
	(484765, 127, '2014-01-15 00:02:35.000000', 'consum', 0.0219, 'lps'),
	(484766, 127, '2014-01-15 00:02:36.000000', 'consum', 0.0211, 'lps'),
	(484767, 127, '2014-01-15 00:02:37.000000', 'consum', 0.0221, 'lps'),
	(484768, 127, '2014-01-15 00:02:38.000000', 'consum', 0.0210, 'lps'),
	(484769, 127, '2014-01-15 00:02:39.000000', 'consum', 0.0215, 'lps'),
	(484770, 127, '2014-01-15 00:02:40.000000', 'consum', 0.0216, 'lps'),
	(484771, 127, '2014-01-15 00:02:41.000000', 'consum', 0.0225, 'lps'),
	(484772, 127, '2014-01-15 00:02:42.000000', 'consum', 0.0218, 'lps'),
	(484773, 127, '2014-01-15 00:02:43.000000', 'consum', 0.0223, 'lps'),
	(484774, 127, '2014-01-15 00:02:44.000000', 'consum', 0.0216, 'lps'),
	(484775, 127, '2014-01-15 00:02:45.000000', 'consum', 0.0218, 'lps'),
	(484776, 127, '2014-01-15 00:02:46.000000', 'consum', 0.0215, 'lps'),
	(484777, 127, '2014-01-15 00:02:47.000000', 'consum', 0.0210, 'lps'),
	(484778, 127, '2014-01-15 00:02:48.000000', 'consum', 0.0216, 'lps'),
	(484779, 127, '2014-01-15 00:02:49.000000', 'consum', 0.0221, 'lps'),
	(484780, 127, '2014-01-15 00:02:50.000000', 'consum', 0.0215, 'lps'),
	(484781, 127, '2014-01-15 00:02:51.000000', 'consum', 0.0218, 'lps'),
	(484782, 127, '2014-01-15 00:02:52.000000', 'consum', 0.0219, 'lps'),
	(484783, 127, '2014-01-15 00:02:53.000000', 'consum', 0.0216, 'lps'),
	(484784, 127, '2014-01-15 00:02:54.000000', 'consum', 0.0215, 'lps'),
	(484785, 127, '2014-01-15 00:02:55.000000', 'consum', 0.0214, 'lps'),
	(484786, 127, '2014-01-15 00:02:56.000000', 'consum', 0.0219, 'lps'),
	(484787, 127, '2014-01-15 00:02:57.000000', 'consum', 0.0223, 'lps'),
	(484788, 127, '2014-01-15 00:02:58.000000', 'consum', 0.0217, 'lps'),
	(484789, 127, '2014-01-15 00:02:59.000000', 'consum', 0.0223, 'lps'),
	(484790, 127, '2014-01-15 00:03:00.000000', 'consum', 0.0220, 'lps'),
	(484791, 127, '2014-01-15 00:03:01.000000', 'consum', 0.0221, 'lps'),
	(484792, 127, '2014-01-15 00:03:02.000000', 'consum', 0.0219, 'lps'),
	(484793, 127, '2014-01-15 00:03:03.000000', 'consum', 0.0221, 'lps'),
	(484794, 127, '2014-01-15 00:03:04.000000', 'consum', 0.0222, 'lps'),
	(484795, 127, '2014-01-15 00:03:05.000000', 'consum', 0.0222, 'lps'),
	(484796, 127, '2014-01-15 00:03:06.000000', 'consum', 0.0215, 'lps'),
	(484797, 127, '2014-01-15 00:03:07.000000', 'consum', 0.0219, 'lps'),
	(484798, 127, '2014-01-15 00:03:08.000000', 'consum', 0.0222, 'lps'),
	(484799, 127, '2014-01-15 00:03:09.000000', 'consum', 0.0225, 'lps'),
	(484800, 127, '2014-01-15 00:03:10.000000', 'consum', 0.0216, 'lps'),
	(484801, 127, '2014-01-15 00:03:11.000000', 'consum', 0.0213, 'lps'),
	(484802, 127, '2014-01-15 00:03:12.000000', 'consum', 0.0224, 'lps'),
	(484803, 127, '2014-01-15 00:03:13.000000', 'consum', 0.0219, 'lps'),
	(484804, 127, '2014-01-15 00:03:14.000000', 'consum', 0.0217, 'lps'),
	(484805, 127, '2014-01-15 00:03:15.000000', 'consum', 0.0216, 'lps'),
	(484806, 127, '2014-01-15 00:03:16.000000', 'consum', 0.0220, 'lps'),
	(484807, 127, '2014-01-15 00:03:17.000000', 'consum', 0.0210, 'lps'),
	(484808, 127, '2014-01-15 00:03:18.000000', 'consum', 0.0212, 'lps'),
	(484809, 127, '2014-01-15 00:03:19.000000', 'consum', 0.0223, 'lps'),
	(484810, 127, '2014-01-15 00:03:20.000000', 'consum', 0.0219, 'lps'),
	(484811, 127, '2014-01-15 00:03:21.000000', 'consum', 0.0217, 'lps'),
	(484812, 127, '2014-01-15 00:03:22.000000', 'consum', 0.0217, 'lps'),
	(484813, 127, '2014-01-15 00:03:23.000000', 'consum', 0.0210, 'lps'),
	(484814, 127, '2014-01-15 00:03:24.000000', 'consum', 0.0220, 'lps'),
	(484815, 127, '2014-01-15 00:03:25.000000', 'consum', 0.0213, 'lps'),
	(484816, 127, '2014-01-15 00:03:26.000000', 'consum', 0.0226, 'lps'),
	(484817, 127, '2014-01-15 00:03:27.000000', 'consum', 0.0216, 'lps'),
	(484818, 127, '2014-01-15 00:03:28.000000', 'consum', 0.0226, 'lps'),
	(484819, 127, '2014-01-15 00:03:29.000000', 'consum', 0.0221, 'lps'),
	(484820, 127, '2014-01-15 00:03:30.000000', 'consum', 0.0220, 'lps'),
	(484821, 127, '2014-01-15 00:03:31.000000', 'consum', 0.0224, 'lps'),
	(484822, 127, '2014-01-15 00:03:32.000000', 'consum', 0.0220, 'lps'),
	(484823, 127, '2014-01-15 00:03:33.000000', 'consum', 0.0215, 'lps'),
	(484824, 127, '2014-01-15 00:03:34.000000', 'consum', 0.0224, 'lps'),
	(484825, 127, '2014-01-15 00:03:35.000000', 'consum', 0.0214, 'lps'),
	(484826, 127, '2014-01-15 00:03:36.000000', 'consum', 0.0221, 'lps'),
	(484827, 127, '2014-01-15 00:03:37.000000', 'consum', 0.0221, 'lps'),
	(484828, 127, '2014-01-15 00:03:38.000000', 'consum', 0.0216, 'lps'),
	(484829, 127, '2014-01-15 00:03:39.000000', 'consum', 0.0225, 'lps'),
	(484830, 127, '2014-01-15 00:03:40.000000', 'consum', 0.0214, 'lps'),
	(484831, 127, '2014-01-15 00:03:41.000000', 'consum', 0.0222, 'lps'),
	(484832, 127, '2014-01-15 00:03:42.000000', 'consum', 0.0223, 'lps'),
	(484833, 127, '2014-01-15 00:03:43.000000', 'consum', 0.0225, 'lps'),
	(484834, 127, '2014-01-15 00:03:44.000000', 'consum', 0.0211, 'lps'),
	(484835, 127, '2014-01-15 00:03:45.000000', 'consum', 0.0222, 'lps'),
	(484836, 127, '2014-01-15 00:03:46.000000', 'consum', 0.0217, 'lps'),
	(484837, 127, '2014-01-15 00:03:47.000000', 'consum', 0.0210, 'lps'),
	(484838, 127, '2014-01-15 00:03:48.000000', 'consum', 0.0222, 'lps'),
	(484839, 127, '2014-01-15 00:03:49.000000', 'consum', 0.0222, 'lps'),
	(484840, 127, '2014-01-15 00:03:50.000000', 'consum', 0.0215, 'lps'),
	(484841, 127, '2014-01-15 00:03:51.000000', 'consum', 0.0215, 'lps'),
	(484842, 127, '2014-01-15 00:03:52.000000', 'consum', 0.0224, 'lps'),
	(484843, 127, '2014-01-15 00:03:53.000000', 'consum', 0.0214, 'lps'),
	(484844, 127, '2014-01-15 00:03:54.000000', 'consum', 0.0223, 'lps'),
	(484845, 127, '2014-01-15 00:03:55.000000', 'consum', 0.0210, 'lps'),
	(484846, 127, '2014-01-15 00:03:56.000000', 'consum', 0.0223, 'lps'),
	(484847, 127, '2014-01-15 00:03:57.000000', 'consum', 0.0226, 'lps'),
	(484848, 127, '2014-01-15 00:03:58.000000', 'consum', 0.0218, 'lps'),
	(484849, 127, '2014-01-15 00:03:59.000000', 'consum', 0.0221, 'lps'),
	(484850, 127, '2014-01-15 00:04:00.000000', 'consum', 0.0221, 'lps'),
	(484851, 127, '2014-01-15 00:04:01.000000', 'consum', 0.0216, 'lps'),
	(484852, 127, '2014-01-15 00:04:02.000000', 'consum', 0.0210, 'lps'),
	(484853, 127, '2014-01-15 00:04:03.000000', 'consum', 0.0225, 'lps'),
	(484854, 127, '2014-01-15 00:04:04.000000', 'consum', 0.0217, 'lps'),
	(484855, 127, '2014-01-15 00:04:05.000000', 'consum', 0.0218, 'lps'),
	(484856, 127, '2014-01-15 00:04:06.000000', 'consum', 0.0211, 'lps'),
	(484857, 127, '2014-01-15 00:04:07.000000', 'consum', 0.0226, 'lps'),
	(484858, 127, '2014-01-15 00:04:08.000000', 'consum', 0.0219, 'lps'),
	(484859, 127, '2014-01-15 00:04:09.000000', 'consum', 0.0223, 'lps'),
	(484860, 127, '2014-01-15 00:04:10.000000', 'consum', 0.0216, 'lps'),
	(484861, 127, '2014-01-15 00:04:11.000000', 'consum', 0.0220, 'lps'),
	(484862, 127, '2014-01-15 00:04:12.000000', 'consum', 0.0224, 'lps'),
	(484863, 127, '2014-01-15 00:04:13.000000', 'consum', 0.0216, 'lps'),
	(484864, 127, '2014-01-15 00:04:14.000000', 'consum', 0.0216, 'lps'),
	(484865, 127, '2014-01-15 00:04:15.000000', 'consum', 0.0223, 'lps'),
	(484866, 127, '2014-01-15 00:04:16.000000', 'consum', 0.0225, 'lps'),
	(484867, 127, '2014-01-15 00:04:17.000000', 'consum', 0.0210, 'lps'),
	(484868, 127, '2014-01-15 00:04:18.000000', 'consum', 0.0217, 'lps'),
	(484869, 127, '2014-01-15 00:04:19.000000', 'consum', 0.0213, 'lps'),
	(484870, 127, '2014-01-15 00:04:20.000000', 'consum', 0.0221, 'lps'),
	(484871, 127, '2014-01-15 00:04:21.000000', 'consum', 0.0223, 'lps'),
	(484872, 127, '2014-01-15 00:04:22.000000', 'consum', 0.0223, 'lps'),
	(484873, 127, '2014-01-15 00:04:23.000000', 'consum', 0.0221, 'lps'),
	(484874, 127, '2014-01-15 00:04:24.000000', 'consum', 0.0225, 'lps'),
	(484875, 127, '2014-01-15 00:04:25.000000', 'consum', 0.0219, 'lps'),
	(484876, 127, '2014-01-15 00:04:26.000000', 'consum', 0.0226, 'lps'),
	(484877, 127, '2014-01-15 00:04:27.000000', 'consum', 0.0216, 'lps'),
	(484878, 127, '2014-01-15 00:04:28.000000', 'consum', 0.0225, 'lps'),
	(484879, 127, '2014-01-15 00:04:29.000000', 'consum', 0.0215, 'lps'),
	(484880, 127, '2014-01-15 00:04:30.000000', 'consum', 0.0224, 'lps'),
	(484881, 127, '2014-01-15 00:04:31.000000', 'consum', 0.0217, 'lps'),
	(484882, 127, '2014-01-15 00:04:32.000000', 'consum', 0.0220, 'lps'),
	(484883, 127, '2014-01-15 00:04:33.000000', 'consum', 0.0222, 'lps'),
	(484884, 127, '2014-01-15 00:04:34.000000', 'consum', 0.0222, 'lps'),
	(484885, 127, '2014-01-15 00:04:35.000000', 'consum', 0.0221, 'lps'),
	(484886, 127, '2014-01-15 00:04:36.000000', 'consum', 0.0210, 'lps'),
	(484887, 127, '2014-01-15 00:04:37.000000', 'consum', 0.0211, 'lps'),
	(484888, 127, '2014-01-15 00:04:38.000000', 'consum', 0.0217, 'lps'),
	(484889, 127, '2014-01-15 00:04:39.000000', 'consum', 0.0225, 'lps'),
	(484890, 127, '2014-01-15 00:04:40.000000', 'consum', 0.0214, 'lps'),
	(484891, 127, '2014-01-15 00:04:41.000000', 'consum', 0.0219, 'lps'),
	(484892, 127, '2014-01-15 00:04:42.000000', 'consum', 0.0211, 'lps'),
	(484893, 127, '2014-01-15 00:04:43.000000', 'consum', 0.0221, 'lps'),
	(484894, 127, '2014-01-15 00:04:44.000000', 'consum', 0.0214, 'lps'),
	(484895, 127, '2014-01-15 00:04:45.000000', 'consum', 0.0211, 'lps'),
	(484896, 127, '2014-01-15 00:04:46.000000', 'consum', 0.0223, 'lps'),
	(484897, 127, '2014-01-15 00:04:47.000000', 'consum', 0.0219, 'lps'),
	(484898, 127, '2014-01-15 00:04:48.000000', 'consum', 0.0219, 'lps'),
	(484899, 127, '2014-01-15 00:04:49.000000', 'consum', 0.0212, 'lps'),
	(484900, 127, '2014-01-15 00:04:50.000000', 'consum', 0.0225, 'lps'),
	(484901, 127, '2014-01-15 00:04:51.000000', 'consum', 0.0215, 'lps'),
	(484902, 127, '2014-01-15 00:04:52.000000', 'consum', 0.0221, 'lps'),
	(484903, 127, '2014-01-15 00:04:53.000000', 'consum', 0.0219, 'lps'),
	(484904, 127, '2014-01-15 00:04:54.000000', 'consum', 0.0220, 'lps'),
	(484905, 127, '2014-01-15 00:04:55.000000', 'consum', 0.0216, 'lps'),
	(484906, 127, '2014-01-15 00:04:56.000000', 'consum', 0.0212, 'lps'),
	(484907, 127, '2014-01-15 00:04:57.000000', 'consum', 0.0218, 'lps'),
	(484908, 127, '2014-01-15 00:04:58.000000', 'consum', 0.0210, 'lps'),
	(484909, 127, '2014-01-15 00:04:59.000000', 'consum', 0.0223, 'lps'),
	(484910, 127, '2014-01-15 00:05:00.000000', 'consum', 0.0225, 'lps'),
	(484911, 127, '2014-01-15 00:05:01.000000', 'consum', 0.0213, 'lps'),
	(484912, 127, '2014-01-15 00:05:02.000000', 'consum', 0.0212, 'lps'),
	(484913, 127, '2014-01-15 00:05:03.000000', 'consum', 0.0213, 'lps'),
	(484914, 127, '2014-01-15 00:05:04.000000', 'consum', 0.0217, 'lps'),
	(484915, 127, '2014-01-15 00:05:05.000000', 'consum', 0.0221, 'lps'),
	(484916, 127, '2014-01-15 00:05:06.000000', 'consum', 0.0212, 'lps'),
	(484917, 127, '2014-01-15 00:05:07.000000', 'consum', 0.0222, 'lps'),
	(484918, 127, '2014-01-15 00:05:08.000000', 'consum', 0.0212, 'lps'),
	(484919, 127, '2014-01-15 00:05:09.000000', 'consum', 0.0220, 'lps'),
	(484920, 127, '2014-01-15 00:05:10.000000', 'consum', 0.0220, 'lps'),
	(484921, 127, '2014-01-15 00:05:11.000000', 'consum', 0.0212, 'lps'),
	(484922, 127, '2014-01-15 00:05:12.000000', 'consum', 0.0226, 'lps'),
	(484923, 127, '2014-01-15 00:05:13.000000', 'consum', 0.0215, 'lps'),
	(484924, 127, '2014-01-15 00:05:14.000000', 'consum', 0.0224, 'lps'),
	(484925, 127, '2014-01-15 00:05:15.000000', 'consum', 0.0214, 'lps'),
	(484926, 127, '2014-01-15 00:05:16.000000', 'consum', 0.0220, 'lps'),
	(484927, 127, '2014-01-15 00:05:17.000000', 'consum', 0.0215, 'lps'),
	(484928, 127, '2014-01-15 00:05:18.000000', 'consum', 0.0225, 'lps'),
	(484929, 127, '2014-01-15 00:05:19.000000', 'consum', 0.0217, 'lps'),
	(484930, 127, '2014-01-15 00:05:20.000000', 'consum', 0.0220, 'lps'),
	(484931, 127, '2014-01-15 00:05:21.000000', 'consum', 0.0223, 'lps'),
	(484932, 127, '2014-01-15 00:05:22.000000', 'consum', 0.0210, 'lps'),
	(484933, 127, '2014-01-15 00:05:23.000000', 'consum', 0.0222, 'lps'),
	(484934, 127, '2014-01-15 00:05:24.000000', 'consum', 0.0222, 'lps'),
	(484935, 127, '2014-01-15 00:05:25.000000', 'consum', 0.0215, 'lps'),
	(484936, 127, '2014-01-15 00:05:26.000000', 'consum', 0.0219, 'lps'),
	(484937, 127, '2014-01-15 00:05:27.000000', 'consum', 0.0223, 'lps'),
	(484938, 127, '2014-01-15 00:05:28.000000', 'consum', 0.0212, 'lps'),
	(484939, 127, '2014-01-15 00:05:29.000000', 'consum', 0.0217, 'lps'),
	(484940, 127, '2014-01-15 00:05:30.000000', 'consum', 0.0221, 'lps'),
	(484941, 127, '2014-01-15 00:05:31.000000', 'consum', 0.0214, 'lps'),
	(484942, 127, '2014-01-15 00:05:32.000000', 'consum', 0.0211, 'lps'),
	(484943, 127, '2014-01-15 00:05:33.000000', 'consum', 0.0221, 'lps'),
	(484944, 127, '2014-01-15 00:05:34.000000', 'consum', 0.0210, 'lps'),
	(484945, 127, '2014-01-15 00:05:35.000000', 'consum', 0.0214, 'lps'),
	(484946, 127, '2014-01-15 00:05:36.000000', 'consum', 0.0214, 'lps'),
	(484947, 127, '2014-01-15 00:05:37.000000', 'consum', 0.0218, 'lps'),
	(484948, 127, '2014-01-15 00:05:38.000000', 'consum', 0.0220, 'lps'),
	(484949, 127, '2014-01-15 00:05:39.000000', 'consum', 0.0219, 'lps'),
	(484950, 127, '2014-01-15 00:05:40.000000', 'consum', 0.0210, 'lps'),
	(484951, 127, '2014-01-15 00:05:41.000000', 'consum', 0.0216, 'lps'),
	(484952, 127, '2014-01-15 00:05:42.000000', 'consum', 0.0225, 'lps'),
	(484953, 127, '2014-01-15 00:05:43.000000', 'consum', 0.0216, 'lps'),
	(484954, 127, '2014-01-15 00:05:44.000000', 'consum', 0.0212, 'lps'),
	(484955, 127, '2014-01-15 00:05:45.000000', 'consum', 0.0220, 'lps'),
	(484956, 127, '2014-01-15 00:05:46.000000', 'consum', 0.0220, 'lps'),
	(484957, 127, '2014-01-15 00:05:47.000000', 'consum', 0.0215, 'lps'),
	(484958, 127, '2014-01-15 00:05:48.000000', 'consum', 0.0221, 'lps'),
	(484959, 127, '2014-01-15 00:05:49.000000', 'consum', 0.0215, 'lps'),
	(484960, 127, '2014-01-15 00:05:50.000000', 'consum', 0.0222, 'lps'),
	(484961, 127, '2014-01-15 00:05:51.000000', 'consum', 0.0219, 'lps'),
	(484962, 127, '2014-01-15 00:05:52.000000', 'consum', 0.0221, 'lps'),
	(484963, 127, '2014-01-15 00:05:53.000000', 'consum', 0.0222, 'lps'),
	(484964, 127, '2014-01-15 00:05:54.000000', 'consum', 0.0220, 'lps'),
	(484965, 127, '2014-01-15 00:05:55.000000', 'consum', 0.0224, 'lps'),
	(484966, 127, '2014-01-15 00:05:56.000000', 'consum', 0.0217, 'lps'),
	(484967, 127, '2014-01-15 00:05:57.000000', 'consum', 0.0222, 'lps'),
	(484968, 127, '2014-01-15 00:05:58.000000', 'consum', 0.0214, 'lps'),
	(484969, 127, '2014-01-15 00:05:59.000000', 'consum', 0.0210, 'lps'),
	(484970, 127, '2014-01-15 00:06:00.000000', 'consum', 0.0218, 'lps'),
	(484971, 127, '2014-01-15 00:06:01.000000', 'consum', 0.0216, 'lps'),
	(484972, 127, '2014-01-15 00:06:02.000000', 'consum', 0.0218, 'lps'),
	(484973, 127, '2014-01-15 00:06:03.000000', 'consum', 0.0213, 'lps'),
	(484974, 127, '2014-01-15 00:06:04.000000', 'consum', 0.0221, 'lps'),
	(484975, 127, '2014-01-15 00:06:05.000000', 'consum', 0.0220, 'lps'),
	(484976, 127, '2014-01-15 00:06:06.000000', 'consum', 0.0213, 'lps'),
	(484977, 127, '2014-01-15 00:06:07.000000', 'consum', 0.0213, 'lps'),
	(484978, 127, '2014-01-15 00:06:08.000000', 'consum', 0.0217, 'lps'),
	(484979, 127, '2014-01-15 00:06:09.000000', 'consum', 0.0219, 'lps'),
	(484980, 127, '2014-01-15 00:06:10.000000', 'consum', 0.0215, 'lps'),
	(484981, 127, '2014-01-15 00:06:11.000000', 'consum', 0.0210, 'lps'),
	(484982, 127, '2014-01-15 00:06:12.000000', 'consum', 0.0211, 'lps'),
	(484983, 127, '2014-01-15 00:06:13.000000', 'consum', 0.0218, 'lps'),
	(484984, 127, '2014-01-15 00:06:14.000000', 'consum', 0.0213, 'lps'),
	(484985, 127, '2014-01-15 00:06:15.000000', 'consum', 0.0216, 'lps'),
	(484986, 127, '2014-01-15 00:06:16.000000', 'consum', 0.0218, 'lps'),
	(484987, 127, '2014-01-15 00:06:17.000000', 'consum', 0.0213, 'lps'),
	(484988, 127, '2014-01-15 00:06:18.000000', 'consum', 0.0220, 'lps'),
	(484989, 127, '2014-01-15 00:06:19.000000', 'consum', 0.0216, 'lps'),
	(484990, 127, '2014-01-15 00:06:20.000000', 'consum', 0.0212, 'lps'),
	(484991, 127, '2014-01-15 00:06:21.000000', 'consum', 0.0217, 'lps'),
	(484992, 127, '2014-01-15 00:06:22.000000', 'consum', 0.0225, 'lps'),
	(484993, 127, '2014-01-15 00:06:23.000000', 'consum', 0.0214, 'lps'),
	(484994, 127, '2014-01-15 00:06:24.000000', 'consum', 0.0217, 'lps'),
	(484995, 127, '2014-01-15 00:06:25.000000', 'consum', 0.0217, 'lps'),
	(484996, 127, '2014-01-15 00:06:26.000000', 'consum', 0.0224, 'lps'),
	(484997, 127, '2014-01-15 00:06:27.000000', 'consum', 0.0211, 'lps'),
	(484998, 127, '2014-01-15 00:06:28.000000', 'consum', 0.0222, 'lps'),
	(484999, 127, '2014-01-15 00:06:29.000000', 'consum', 0.0215, 'lps'),
	(485000, 127, '2014-01-15 00:06:30.000000', 'consum', 0.0219, 'lps'),
	(485001, 127, '2014-01-15 00:06:31.000000', 'consum', 0.0225, 'lps'),
	(485002, 127, '2014-01-15 00:06:32.000000', 'consum', 0.0222, 'lps'),
	(485003, 127, '2014-01-15 00:06:33.000000', 'consum', 0.0211, 'lps'),
	(485004, 127, '2014-01-15 00:06:34.000000', 'consum', 0.0212, 'lps'),
	(485005, 127, '2014-01-15 00:06:35.000000', 'consum', 0.0216, 'lps'),
	(485006, 127, '2014-01-15 00:06:36.000000', 'consum', 0.0219, 'lps'),
	(485007, 127, '2014-01-15 00:06:37.000000', 'consum', 0.0222, 'lps'),
	(485008, 127, '2014-01-15 00:06:38.000000', 'consum', 0.0224, 'lps'),
	(485009, 127, '2014-01-15 00:06:39.000000', 'consum', 0.0212, 'lps'),
	(485010, 127, '2014-01-15 00:06:40.000000', 'consum', 0.0212, 'lps'),
	(485011, 127, '2014-01-15 00:06:41.000000', 'consum', 0.0213, 'lps'),
	(485012, 127, '2014-01-15 00:06:42.000000', 'consum', 0.0222, 'lps'),
	(485013, 127, '2014-01-15 00:06:43.000000', 'consum', 0.0210, 'lps'),
	(485014, 127, '2014-01-15 00:06:44.000000', 'consum', 0.0224, 'lps'),
	(485015, 127, '2014-01-15 00:06:45.000000', 'consum', 0.0211, 'lps'),
	(485016, 127, '2014-01-15 00:06:46.000000', 'consum', 0.0211, 'lps'),
	(485017, 127, '2014-01-15 00:06:47.000000', 'consum', 0.0210, 'lps'),
	(485018, 127, '2014-01-15 00:06:48.000000', 'consum', 0.0226, 'lps'),
	(485019, 127, '2014-01-15 00:06:49.000000', 'consum', 0.0223, 'lps'),
	(485020, 127, '2014-01-15 00:06:50.000000', 'consum', 0.0211, 'lps'),
	(485021, 127, '2014-01-15 00:06:51.000000', 'consum', 0.0212, 'lps'),
	(485022, 127, '2014-01-15 00:06:52.000000', 'consum', 0.0214, 'lps'),
	(485023, 127, '2014-01-15 00:06:53.000000', 'consum', 0.0225, 'lps'),
	(485024, 127, '2014-01-15 00:06:54.000000', 'consum', 0.0224, 'lps'),
	(485025, 127, '2014-01-15 00:06:55.000000', 'consum', 0.0216, 'lps'),
	(485026, 127, '2014-01-15 00:06:56.000000', 'consum', 0.0216, 'lps'),
	(485027, 127, '2014-01-15 00:06:57.000000', 'consum', 0.0224, 'lps'),
	(485028, 127, '2014-01-15 00:06:58.000000', 'consum', 0.0212, 'lps'),
	(485029, 127, '2014-01-15 00:06:59.000000', 'consum', 0.0212, 'lps'),
	(485030, 127, '2014-01-15 00:07:00.000000', 'consum', 0.0215, 'lps'),
	(485031, 127, '2014-01-15 00:07:01.000000', 'consum', 0.0210, 'lps'),
	(485032, 127, '2014-01-15 00:07:02.000000', 'consum', 0.0215, 'lps'),
	(485033, 127, '2014-01-15 00:07:03.000000', 'consum', 0.0220, 'lps'),
	(485034, 127, '2014-01-15 00:07:04.000000', 'consum', 0.0225, 'lps'),
	(485035, 127, '2014-01-15 00:07:05.000000', 'consum', 0.0223, 'lps'),
	(485036, 127, '2014-01-15 00:07:06.000000', 'consum', 0.0214, 'lps'),
	(485037, 127, '2014-01-15 00:07:07.000000', 'consum', 0.0226, 'lps'),
	(485038, 127, '2014-01-15 00:07:08.000000', 'consum', 0.0226, 'lps'),
	(485039, 127, '2014-01-15 00:07:09.000000', 'consum', 0.0225, 'lps'),
	(485040, 127, '2014-01-15 00:07:10.000000', 'consum', 0.0222, 'lps'),
	(485041, 127, '2014-01-15 00:07:11.000000', 'consum', 0.0226, 'lps'),
	(485042, 127, '2014-01-15 00:07:12.000000', 'consum', 0.0222, 'lps'),
	(485043, 127, '2014-01-15 00:07:13.000000', 'consum', 0.0221, 'lps'),
	(485044, 127, '2014-01-15 00:07:14.000000', 'consum', 0.0211, 'lps'),
	(485045, 127, '2014-01-15 00:07:15.000000', 'consum', 0.0216, 'lps'),
	(485046, 127, '2014-01-15 00:07:16.000000', 'consum', 0.0221, 'lps'),
	(485047, 127, '2014-01-15 00:07:17.000000', 'consum', 0.0216, 'lps'),
	(485048, 127, '2014-01-15 00:07:18.000000', 'consum', 0.0223, 'lps'),
	(485049, 127, '2014-01-15 00:07:19.000000', 'consum', 0.0224, 'lps'),
	(485050, 127, '2014-01-15 00:07:20.000000', 'consum', 0.0224, 'lps'),
	(485051, 127, '2014-01-15 00:07:21.000000', 'consum', 0.0222, 'lps'),
	(485052, 127, '2014-01-15 00:07:22.000000', 'consum', 0.0213, 'lps'),
	(485053, 127, '2014-01-15 00:07:23.000000', 'consum', 0.0223, 'lps'),
	(485054, 127, '2014-01-15 00:07:24.000000', 'consum', 0.0214, 'lps'),
	(485055, 127, '2014-01-15 00:07:25.000000', 'consum', 0.0210, 'lps'),
	(485056, 127, '2014-01-15 00:07:26.000000', 'consum', 0.0216, 'lps'),
	(485057, 127, '2014-01-15 00:07:27.000000', 'consum', 0.0223, 'lps'),
	(485058, 127, '2014-01-15 00:07:28.000000', 'consum', 0.0222, 'lps'),
	(485059, 127, '2014-01-15 00:07:29.000000', 'consum', 0.0215, 'lps'),
	(485060, 127, '2014-01-15 00:07:30.000000', 'consum', 0.0219, 'lps'),
	(485061, 127, '2014-01-15 00:07:31.000000', 'consum', 0.0221, 'lps'),
	(485062, 127, '2014-01-15 00:07:32.000000', 'consum', 0.0222, 'lps'),
	(485063, 127, '2014-01-15 00:07:33.000000', 'consum', 0.0220, 'lps'),
	(485064, 127, '2014-01-15 00:07:34.000000', 'consum', 0.0223, 'lps'),
	(485065, 127, '2014-01-15 00:07:35.000000', 'consum', 0.0213, 'lps'),
	(485066, 127, '2014-01-15 00:07:36.000000', 'consum', 0.0221, 'lps'),
	(485067, 127, '2014-01-15 00:07:37.000000', 'consum', 0.0222, 'lps'),
	(485068, 127, '2014-01-15 00:07:38.000000', 'consum', 0.0219, 'lps'),
	(485069, 127, '2014-01-15 00:07:39.000000', 'consum', 0.0222, 'lps'),
	(485070, 127, '2014-01-15 00:07:40.000000', 'consum', 0.0225, 'lps'),
	(485071, 127, '2014-01-15 00:07:41.000000', 'consum', 0.0217, 'lps'),
	(485072, 127, '2014-01-15 00:07:42.000000', 'consum', 0.0219, 'lps'),
	(485073, 127, '2014-01-15 00:07:43.000000', 'consum', 0.0215, 'lps'),
	(485074, 127, '2014-01-15 00:07:44.000000', 'consum', 0.0226, 'lps'),
	(485075, 127, '2014-01-15 00:07:45.000000', 'consum', 0.0225, 'lps'),
	(485076, 127, '2014-01-15 00:07:46.000000', 'consum', 0.0219, 'lps'),
	(485077, 127, '2014-01-15 00:07:47.000000', 'consum', 0.0213, 'lps'),
	(485078, 127, '2014-01-15 00:07:48.000000', 'consum', 0.0214, 'lps'),
	(485079, 127, '2014-01-15 00:07:49.000000', 'consum', 0.0222, 'lps'),
	(485080, 127, '2014-01-15 00:07:50.000000', 'consum', 0.0224, 'lps'),
	(485081, 127, '2014-01-15 00:07:51.000000', 'consum', 0.0212, 'lps'),
	(485082, 127, '2014-01-15 00:07:52.000000', 'consum', 0.0212, 'lps'),
	(485083, 127, '2014-01-15 00:07:53.000000', 'consum', 0.0216, 'lps'),
	(485084, 127, '2014-01-15 00:07:54.000000', 'consum', 0.0216, 'lps'),
	(485085, 127, '2014-01-15 00:07:55.000000', 'consum', 0.0225, 'lps'),
	(485086, 127, '2014-01-15 00:07:56.000000', 'consum', 0.0214, 'lps'),
	(485087, 127, '2014-01-15 00:07:57.000000', 'consum', 0.0218, 'lps'),
	(485088, 127, '2014-01-15 00:07:58.000000', 'consum', 0.0223, 'lps'),
	(485089, 127, '2014-01-15 00:07:59.000000', 'consum', 0.0219, 'lps'),
	(485090, 127, '2014-01-15 00:08:00.000000', 'consum', 0.0216, 'lps'),
	(485091, 127, '2014-01-15 00:08:01.000000', 'consum', 0.0211, 'lps'),
	(485092, 127, '2014-01-15 00:08:02.000000', 'consum', 0.0217, 'lps'),
	(485093, 127, '2014-01-15 00:08:03.000000', 'consum', 0.0226, 'lps'),
	(485094, 127, '2014-01-15 00:08:04.000000', 'consum', 0.0219, 'lps'),
	(485095, 127, '2014-01-15 00:08:05.000000', 'consum', 0.0223, 'lps'),
	(485096, 127, '2014-01-15 00:08:06.000000', 'consum', 0.0216, 'lps'),
	(485097, 127, '2014-01-15 00:08:07.000000', 'consum', 0.0216, 'lps'),
	(485098, 127, '2014-01-15 00:08:08.000000', 'consum', 0.0225, 'lps'),
	(485099, 127, '2014-01-15 00:08:09.000000', 'consum', 0.0216, 'lps'),
	(485100, 127, '2014-01-15 00:08:10.000000', 'consum', 0.0212, 'lps'),
	(485101, 127, '2014-01-15 00:08:11.000000', 'consum', 0.0219, 'lps'),
	(485102, 127, '2014-01-15 00:08:12.000000', 'consum', 0.0218, 'lps'),
	(485103, 127, '2014-01-15 00:08:13.000000', 'consum', 0.0220, 'lps'),
	(485104, 127, '2014-01-15 00:08:14.000000', 'consum', 0.0221, 'lps'),
	(485105, 127, '2014-01-15 00:08:15.000000', 'consum', 0.0220, 'lps'),
	(485106, 127, '2014-01-15 00:08:16.000000', 'consum', 0.0225, 'lps'),
	(485107, 127, '2014-01-15 00:08:17.000000', 'consum', 0.0223, 'lps'),
	(485108, 127, '2014-01-15 00:08:18.000000', 'consum', 0.0211, 'lps'),
	(485109, 127, '2014-01-15 00:08:19.000000', 'consum', 0.0214, 'lps'),
	(485110, 127, '2014-01-15 00:08:20.000000', 'consum', 0.0226, 'lps'),
	(485111, 127, '2014-01-15 00:08:21.000000', 'consum', 0.0211, 'lps'),
	(485112, 127, '2014-01-15 00:08:22.000000', 'consum', 0.0218, 'lps'),
	(485113, 127, '2014-01-15 00:08:23.000000', 'consum', 0.0215, 'lps'),
	(485114, 127, '2014-01-15 00:08:24.000000', 'consum', 0.0225, 'lps'),
	(485115, 127, '2014-01-15 00:08:25.000000', 'consum', 0.0223, 'lps'),
	(485116, 127, '2014-01-15 00:08:26.000000', 'consum', 0.0212, 'lps'),
	(485117, 127, '2014-01-15 00:08:27.000000', 'consum', 0.0218, 'lps'),
	(485118, 127, '2014-01-15 00:08:28.000000', 'consum', 0.0224, 'lps'),
	(485119, 127, '2014-01-15 00:08:29.000000', 'consum', 0.0226, 'lps'),
	(485120, 127, '2014-01-15 00:08:30.000000', 'consum', 0.0212, 'lps'),
	(485121, 127, '2014-01-15 00:08:31.000000', 'consum', 0.0226, 'lps'),
	(485122, 127, '2014-01-15 00:08:32.000000', 'consum', 0.0216, 'lps'),
	(485123, 127, '2014-01-15 00:08:33.000000', 'consum', 0.0211, 'lps'),
	(485124, 127, '2014-01-15 00:08:34.000000', 'consum', 0.0214, 'lps'),
	(485125, 127, '2014-01-15 00:08:35.000000', 'consum', 0.0225, 'lps'),
	(485126, 127, '2014-01-15 00:08:36.000000', 'consum', 0.0223, 'lps'),
	(485127, 127, '2014-01-15 00:08:37.000000', 'consum', 0.0215, 'lps'),
	(485128, 127, '2014-01-15 00:08:38.000000', 'consum', 0.0212, 'lps'),
	(485129, 127, '2014-01-15 00:08:39.000000', 'consum', 0.0223, 'lps'),
	(485130, 127, '2014-01-15 00:08:40.000000', 'consum', 0.0217, 'lps'),
	(485131, 127, '2014-01-15 00:08:41.000000', 'consum', 0.0225, 'lps'),
	(485132, 127, '2014-01-15 00:08:42.000000', 'consum', 0.0215, 'lps'),
	(485133, 127, '2014-01-15 00:08:43.000000', 'consum', 0.0224, 'lps'),
	(485134, 127, '2014-01-15 00:08:44.000000', 'consum', 0.0212, 'lps'),
	(485135, 127, '2014-01-15 00:08:45.000000', 'consum', 0.0215, 'lps'),
	(485136, 127, '2014-01-15 00:08:46.000000', 'consum', 0.0213, 'lps'),
	(485137, 127, '2014-01-15 00:08:47.000000', 'consum', 0.0225, 'lps'),
	(485138, 127, '2014-01-15 00:08:48.000000', 'consum', 0.0211, 'lps'),
	(485139, 127, '2014-01-15 00:08:49.000000', 'consum', 0.0222, 'lps'),
	(485140, 127, '2014-01-15 00:08:50.000000', 'consum', 0.0214, 'lps'),
	(485141, 127, '2014-01-15 00:08:51.000000', 'consum', 0.0212, 'lps'),
	(485142, 127, '2014-01-15 00:08:52.000000', 'consum', 0.0225, 'lps'),
	(485143, 127, '2014-01-15 00:08:53.000000', 'consum', 0.0212, 'lps'),
	(485144, 127, '2014-01-15 00:08:54.000000', 'consum', 0.0225, 'lps'),
	(485145, 127, '2014-01-15 00:08:55.000000', 'consum', 0.0212, 'lps'),
	(485146, 127, '2014-01-15 00:08:56.000000', 'consum', 0.0211, 'lps'),
	(485147, 127, '2014-01-15 00:08:57.000000', 'consum', 0.0224, 'lps'),
	(485148, 127, '2014-01-15 00:08:58.000000', 'consum', 0.0212, 'lps'),
	(485149, 127, '2014-01-15 00:08:59.000000', 'consum', 0.0214, 'lps'),
	(485150, 127, '2014-01-15 00:09:00.000000', 'consum', 0.0221, 'lps'),
	(485151, 127, '2014-01-15 00:09:01.000000', 'consum', 0.0222, 'lps'),
	(485152, 127, '2014-01-15 00:09:02.000000', 'consum', 0.0218, 'lps'),
	(485153, 127, '2014-01-15 00:09:03.000000', 'consum', 0.0216, 'lps'),
	(485154, 127, '2014-01-15 00:09:04.000000', 'consum', 0.0214, 'lps'),
	(485155, 127, '2014-01-15 00:09:05.000000', 'consum', 0.0215, 'lps'),
	(485156, 127, '2014-01-15 00:09:06.000000', 'consum', 0.0223, 'lps'),
	(485157, 127, '2014-01-15 00:09:07.000000', 'consum', 0.0211, 'lps'),
	(485158, 127, '2014-01-15 00:09:08.000000', 'consum', 0.0211, 'lps'),
	(485159, 127, '2014-01-15 00:09:09.000000', 'consum', 0.0213, 'lps'),
	(485160, 127, '2014-01-15 00:09:10.000000', 'consum', 0.0221, 'lps'),
	(485161, 127, '2014-01-15 00:09:11.000000', 'consum', 0.0221, 'lps'),
	(485162, 127, '2014-01-15 00:09:12.000000', 'consum', 0.0217, 'lps'),
	(485163, 127, '2014-01-15 00:09:13.000000', 'consum', 0.0213, 'lps'),
	(485164, 127, '2014-01-15 00:09:14.000000', 'consum', 0.0221, 'lps'),
	(485165, 127, '2014-01-15 00:09:15.000000', 'consum', 0.0224, 'lps'),
	(485166, 127, '2014-01-15 00:09:16.000000', 'consum', 0.0213, 'lps'),
	(485167, 127, '2014-01-15 00:09:17.000000', 'consum', 0.0218, 'lps'),
	(485168, 127, '2014-01-15 00:09:18.000000', 'consum', 0.0222, 'lps'),
	(485169, 127, '2014-01-15 00:09:19.000000', 'consum', 0.0213, 'lps'),
	(485170, 127, '2014-01-15 00:09:20.000000', 'consum', 0.0223, 'lps'),
	(485171, 127, '2014-01-15 00:09:21.000000', 'consum', 0.0216, 'lps'),
	(485172, 127, '2014-01-15 00:09:22.000000', 'consum', 0.0218, 'lps'),
	(485173, 127, '2014-01-15 00:09:23.000000', 'consum', 0.0217, 'lps'),
	(485174, 127, '2014-01-15 00:09:24.000000', 'consum', 0.0221, 'lps'),
	(485175, 127, '2014-01-15 00:09:25.000000', 'consum', 0.0210, 'lps'),
	(485176, 127, '2014-01-15 00:09:26.000000', 'consum', 0.0210, 'lps'),
	(485177, 127, '2014-01-15 00:09:27.000000', 'consum', 0.0212, 'lps'),
	(485178, 127, '2014-01-15 00:09:28.000000', 'consum', 0.0218, 'lps'),
	(485179, 127, '2014-01-15 00:09:29.000000', 'consum', 0.0214, 'lps'),
	(485180, 127, '2014-01-15 00:09:30.000000', 'consum', 0.0221, 'lps'),
	(485181, 127, '2014-01-15 00:09:31.000000', 'consum', 0.0219, 'lps'),
	(485182, 127, '2014-01-15 00:09:32.000000', 'consum', 0.0225, 'lps'),
	(485183, 127, '2014-01-15 00:09:33.000000', 'consum', 0.0222, 'lps'),
	(485184, 127, '2014-01-15 00:09:34.000000', 'consum', 0.0210, 'lps'),
	(485185, 127, '2014-01-15 00:09:35.000000', 'consum', 0.0224, 'lps'),
	(485186, 127, '2014-01-15 00:09:36.000000', 'consum', 0.0212, 'lps'),
	(485187, 127, '2014-01-15 00:09:37.000000', 'consum', 0.0213, 'lps'),
	(485188, 127, '2014-01-15 00:09:38.000000', 'consum', 0.0221, 'lps'),
	(485189, 127, '2014-01-15 00:09:39.000000', 'consum', 0.0220, 'lps'),
	(485190, 127, '2014-01-15 00:09:40.000000', 'consum', 0.0212, 'lps'),
	(485191, 127, '2014-01-15 00:09:41.000000', 'consum', 0.0223, 'lps'),
	(485192, 127, '2014-01-15 00:09:42.000000', 'consum', 0.0220, 'lps'),
	(485193, 127, '2014-01-15 00:09:43.000000', 'consum', 0.0221, 'lps'),
	(485194, 127, '2014-01-15 00:09:44.000000', 'consum', 0.0217, 'lps'),
	(485195, 127, '2014-01-15 00:09:45.000000', 'consum', 0.0215, 'lps'),
	(485196, 127, '2014-01-15 00:09:46.000000', 'consum', 0.0215, 'lps'),
	(485197, 127, '2014-01-15 00:09:47.000000', 'consum', 0.0221, 'lps'),
	(485198, 127, '2014-01-15 00:09:48.000000', 'consum', 0.0214, 'lps'),
	(485199, 127, '2014-01-15 00:09:49.000000', 'consum', 0.0216, 'lps'),
	(485200, 127, '2014-01-15 00:09:50.000000', 'consum', 0.0210, 'lps'),
	(485201, 127, '2014-01-15 00:09:51.000000', 'consum', 0.0212, 'lps'),
	(485202, 127, '2014-01-15 00:09:52.000000', 'consum', 0.0219, 'lps'),
	(485203, 127, '2014-01-15 00:09:53.000000', 'consum', 0.0217, 'lps'),
	(485204, 127, '2014-01-15 00:09:54.000000', 'consum', 0.0219, 'lps'),
	(485205, 127, '2014-01-15 00:09:55.000000', 'consum', 0.0215, 'lps'),
	(485206, 127, '2014-01-15 00:09:56.000000', 'consum', 0.0210, 'lps'),
	(485207, 127, '2014-01-15 00:09:57.000000', 'consum', 0.0212, 'lps'),
	(485208, 127, '2014-01-15 00:09:58.000000', 'consum', 0.0219, 'lps'),
	(485209, 127, '2014-01-15 00:09:59.000000', 'consum', 0.0217, 'lps'),
	(485210, 127, '2014-01-15 00:10:00.000000', 'consum', 0.0216, 'lps'),
	(485211, 127, '2014-01-15 00:10:01.000000', 'consum', 0.0222, 'lps'),
	(485212, 127, '2014-01-15 00:10:02.000000', 'consum', 0.0217, 'lps'),
	(485213, 127, '2014-01-15 00:10:03.000000', 'consum', 0.0210, 'lps'),
	(485214, 127, '2014-01-15 00:10:04.000000', 'consum', 0.0224, 'lps'),
	(485215, 127, '2014-01-15 00:10:05.000000', 'consum', 0.0210, 'lps'),
	(485216, 127, '2014-01-15 00:10:06.000000', 'consum', 0.0223, 'lps'),
	(485217, 127, '2014-01-15 00:10:07.000000', 'consum', 0.0222, 'lps'),
	(485218, 127, '2014-01-15 00:10:08.000000', 'consum', 0.0216, 'lps'),
	(485219, 127, '2014-01-15 00:10:09.000000', 'consum', 0.0221, 'lps'),
	(485220, 127, '2014-01-15 00:10:10.000000', 'consum', 0.0212, 'lps'),
	(485221, 127, '2014-01-15 00:10:11.000000', 'consum', 0.0222, 'lps'),
	(485222, 127, '2014-01-15 00:10:12.000000', 'consum', 0.0214, 'lps'),
	(485223, 127, '2014-01-15 00:10:13.000000', 'consum', 0.0226, 'lps'),
	(485224, 127, '2014-01-15 00:10:14.000000', 'consum', 0.0213, 'lps'),
	(485225, 127, '2014-01-15 00:10:15.000000', 'consum', 0.0212, 'lps'),
	(485226, 127, '2014-01-15 00:10:16.000000', 'consum', 0.0212, 'lps'),
	(485227, 127, '2014-01-15 00:10:17.000000', 'consum', 0.0215, 'lps'),
	(485228, 127, '2014-01-15 00:10:18.000000', 'consum', 0.0213, 'lps'),
	(485229, 127, '2014-01-15 00:10:19.000000', 'consum', 0.0225, 'lps'),
	(485230, 127, '2014-01-15 00:10:20.000000', 'consum', 0.0211, 'lps'),
	(485231, 127, '2014-01-15 00:10:21.000000', 'consum', 0.0221, 'lps'),
	(485232, 127, '2014-01-15 00:10:22.000000', 'consum', 0.0210, 'lps'),
	(485233, 127, '2014-01-15 00:10:23.000000', 'consum', 0.0211, 'lps'),
	(485234, 127, '2014-01-15 00:10:24.000000', 'consum', 0.0215, 'lps'),
	(485235, 127, '2014-01-15 00:10:25.000000', 'consum', 0.0218, 'lps'),
	(485236, 127, '2014-01-15 00:10:26.000000', 'consum', 0.0219, 'lps'),
	(485237, 127, '2014-01-15 00:10:27.000000', 'consum', 0.0213, 'lps'),
	(485238, 127, '2014-01-15 00:10:28.000000', 'consum', 0.0216, 'lps'),
	(485239, 127, '2014-01-15 00:10:29.000000', 'consum', 0.0214, 'lps'),
	(485240, 127, '2014-01-15 00:10:30.000000', 'consum', 0.0214, 'lps'),
	(485241, 127, '2014-01-15 00:10:31.000000', 'consum', 0.0219, 'lps'),
	(485242, 127, '2014-01-15 00:10:32.000000', 'consum', 0.0225, 'lps'),
	(485243, 127, '2014-01-15 00:10:33.000000', 'consum', 0.0226, 'lps'),
	(485244, 127, '2014-01-15 00:10:34.000000', 'consum', 0.0211, 'lps'),
	(485245, 127, '2014-01-15 00:10:35.000000', 'consum', 0.0220, 'lps'),
	(485246, 127, '2014-01-15 00:10:36.000000', 'consum', 0.0224, 'lps'),
	(485247, 127, '2014-01-15 00:10:37.000000', 'consum', 0.0214, 'lps'),
	(485248, 127, '2014-01-15 00:10:38.000000', 'consum', 0.0222, 'lps'),
	(485249, 127, '2014-01-15 00:10:39.000000', 'consum', 0.0224, 'lps'),
	(485250, 127, '2014-01-15 00:10:40.000000', 'consum', 0.0210, 'lps'),
	(485251, 127, '2014-01-15 00:10:41.000000', 'consum', 0.0220, 'lps'),
	(485252, 127, '2014-01-15 00:10:42.000000', 'consum', 0.0210, 'lps'),
	(485253, 127, '2014-01-15 00:10:43.000000', 'consum', 0.0213, 'lps'),
	(485254, 127, '2014-01-15 00:10:44.000000', 'consum', 0.0226, 'lps'),
	(485255, 127, '2014-01-15 00:10:45.000000', 'consum', 0.0216, 'lps'),
	(485256, 127, '2014-01-15 00:10:46.000000', 'consum', 0.0224, 'lps'),
	(485257, 127, '2014-01-15 00:10:47.000000', 'consum', 0.0211, 'lps'),
	(485258, 127, '2014-01-15 00:10:48.000000', 'consum', 0.0226, 'lps'),
	(485259, 127, '2014-01-15 00:10:49.000000', 'consum', 0.0220, 'lps'),
	(485260, 127, '2014-01-15 00:10:50.000000', 'consum', 0.0213, 'lps'),
	(485261, 127, '2014-01-15 00:10:51.000000', 'consum', 0.0211, 'lps'),
	(485262, 127, '2014-01-15 00:10:52.000000', 'consum', 0.0224, 'lps'),
	(485263, 127, '2014-01-15 00:10:53.000000', 'consum', 0.0211, 'lps'),
	(485264, 127, '2014-01-15 00:10:54.000000', 'consum', 0.0222, 'lps'),
	(485265, 127, '2014-01-15 00:10:55.000000', 'consum', 0.0216, 'lps'),
	(485266, 127, '2014-01-15 00:10:56.000000', 'consum', 0.0222, 'lps'),
	(485267, 127, '2014-01-15 00:10:57.000000', 'consum', 0.0218, 'lps'),
	(485268, 127, '2014-01-15 00:10:58.000000', 'consum', 0.0217, 'lps'),
	(485269, 127, '2014-01-15 00:10:59.000000', 'consum', 0.0219, 'lps'),
	(485270, 127, '2014-01-15 00:11:00.000000', 'consum', 0.0220, 'lps'),
	(485271, 127, '2014-01-15 00:11:01.000000', 'consum', 0.0216, 'lps'),
	(485272, 127, '2014-01-15 00:11:02.000000', 'consum', 0.0211, 'lps'),
	(485273, 127, '2014-01-15 00:11:03.000000', 'consum', 0.0216, 'lps'),
	(485274, 127, '2014-01-15 00:11:04.000000', 'consum', 0.0218, 'lps'),
	(485275, 127, '2014-01-15 00:11:05.000000', 'consum', 0.0216, 'lps'),
	(485276, 127, '2014-01-15 00:11:06.000000', 'consum', 0.0215, 'lps'),
	(485277, 127, '2014-01-15 00:11:07.000000', 'consum', 0.0218, 'lps'),
	(485278, 127, '2014-01-15 00:11:08.000000', 'consum', 0.0220, 'lps'),
	(485279, 127, '2014-01-15 00:11:09.000000', 'consum', 0.0217, 'lps'),
	(485280, 127, '2014-01-15 00:11:10.000000', 'consum', 0.0218, 'lps'),
	(485281, 127, '2014-01-15 00:11:11.000000', 'consum', 0.0213, 'lps'),
	(485282, 127, '2014-01-15 00:11:12.000000', 'consum', 0.0216, 'lps'),
	(485283, 127, '2014-01-15 00:11:13.000000', 'consum', 0.0216, 'lps'),
	(485284, 127, '2014-01-15 00:11:14.000000', 'consum', 0.0222, 'lps'),
	(485285, 127, '2014-01-15 00:11:15.000000', 'consum', 0.0218, 'lps'),
	(485286, 127, '2014-01-15 00:11:16.000000', 'consum', 0.0215, 'lps'),
	(485287, 127, '2014-01-15 00:11:17.000000', 'consum', 0.0210, 'lps'),
	(485288, 127, '2014-01-15 00:11:18.000000', 'consum', 0.0215, 'lps'),
	(485289, 127, '2014-01-15 00:11:19.000000', 'consum', 0.0219, 'lps'),
	(485290, 127, '2014-01-15 00:11:20.000000', 'consum', 0.0222, 'lps'),
	(485291, 127, '2014-01-15 00:11:21.000000', 'consum', 0.0210, 'lps'),
	(485292, 127, '2014-01-15 00:11:22.000000', 'consum', 0.0224, 'lps'),
	(485293, 127, '2014-01-15 00:11:23.000000', 'consum', 0.0212, 'lps'),
	(485294, 127, '2014-01-15 00:11:24.000000', 'consum', 0.0215, 'lps'),
	(485295, 127, '2014-01-15 00:11:25.000000', 'consum', 0.0211, 'lps'),
	(485296, 127, '2014-01-15 00:11:26.000000', 'consum', 0.0217, 'lps'),
	(485297, 127, '2014-01-15 00:11:27.000000', 'consum', 0.0210, 'lps'),
	(485298, 127, '2014-01-15 00:11:28.000000', 'consum', 0.0223, 'lps'),
	(485299, 127, '2014-01-15 00:11:29.000000', 'consum', 0.0224, 'lps'),
	(485300, 127, '2014-01-15 00:11:30.000000', 'consum', 0.0225, 'lps'),
	(485301, 127, '2014-01-15 00:11:31.000000', 'consum', 0.0225, 'lps'),
	(485302, 127, '2014-01-15 00:11:32.000000', 'consum', 0.0222, 'lps'),
	(485303, 127, '2014-01-15 00:11:33.000000', 'consum', 0.0212, 'lps'),
	(485304, 127, '2014-01-15 00:11:34.000000', 'consum', 0.0218, 'lps'),
	(485305, 127, '2014-01-15 00:11:35.000000', 'consum', 0.0210, 'lps'),
	(485306, 127, '2014-01-15 00:11:36.000000', 'consum', 0.0222, 'lps'),
	(485307, 127, '2014-01-15 00:11:37.000000', 'consum', 0.0217, 'lps'),
	(485308, 127, '2014-01-15 00:11:38.000000', 'consum', 0.0211, 'lps'),
	(485309, 127, '2014-01-15 00:11:39.000000', 'consum', 0.0211, 'lps'),
	(485310, 127, '2014-01-15 00:11:40.000000', 'consum', 0.0211, 'lps'),
	(485311, 127, '2014-01-15 00:11:41.000000', 'consum', 0.0212, 'lps'),
	(485312, 127, '2014-01-15 00:11:42.000000', 'consum', 0.0219, 'lps'),
	(485313, 127, '2014-01-15 00:11:43.000000', 'consum', 0.0215, 'lps'),
	(485314, 127, '2014-01-15 00:11:44.000000', 'consum', 0.0224, 'lps'),
	(485315, 127, '2014-01-15 00:11:45.000000', 'consum', 0.0216, 'lps'),
	(485316, 127, '2014-01-15 00:11:46.000000', 'consum', 0.0216, 'lps'),
	(485317, 127, '2014-01-15 00:11:47.000000', 'consum', 0.0221, 'lps'),
	(485318, 127, '2014-01-15 00:11:48.000000', 'consum', 0.0214, 'lps'),
	(485319, 127, '2014-01-15 00:11:49.000000', 'consum', 0.0213, 'lps'),
	(485320, 127, '2014-01-15 00:11:50.000000', 'consum', 0.0214, 'lps'),
	(485321, 127, '2014-01-15 00:11:51.000000', 'consum', 0.0220, 'lps'),
	(485322, 127, '2014-01-15 00:11:52.000000', 'consum', 0.0218, 'lps'),
	(485323, 127, '2014-01-15 00:11:53.000000', 'consum', 0.0217, 'lps'),
	(485324, 127, '2014-01-15 00:11:54.000000', 'consum', 0.0224, 'lps'),
	(485325, 127, '2014-01-15 00:11:55.000000', 'consum', 0.0226, 'lps'),
	(485326, 127, '2014-01-15 00:11:56.000000', 'consum', 0.0213, 'lps'),
	(485327, 127, '2014-01-15 00:11:57.000000', 'consum', 0.0212, 'lps'),
	(485328, 127, '2014-01-15 00:11:58.000000', 'consum', 0.0210, 'lps'),
	(485329, 127, '2014-01-15 00:11:59.000000', 'consum', 0.0223, 'lps'),
	(485330, 127, '2014-01-15 00:12:00.000000', 'consum', 0.0224, 'lps'),
	(485331, 127, '2014-01-15 00:12:01.000000', 'consum', 0.0226, 'lps'),
	(485332, 127, '2014-01-15 00:12:02.000000', 'consum', 0.0215, 'lps'),
	(485333, 127, '2014-01-15 00:12:03.000000', 'consum', 0.0220, 'lps'),
	(485334, 127, '2014-01-15 00:12:04.000000', 'consum', 0.0213, 'lps'),
	(485335, 127, '2014-01-15 00:12:05.000000', 'consum', 0.0210, 'lps'),
	(485336, 127, '2014-01-15 00:12:06.000000', 'consum', 0.0220, 'lps'),
	(485337, 127, '2014-01-15 00:12:07.000000', 'consum', 0.0211, 'lps'),
	(485338, 127, '2014-01-15 00:12:08.000000', 'consum', 0.0217, 'lps'),
	(485339, 127, '2014-01-15 00:12:09.000000', 'consum', 0.0226, 'lps'),
	(485340, 127, '2014-01-15 00:12:10.000000', 'consum', 0.0219, 'lps'),
	(485341, 127, '2014-01-15 00:12:11.000000', 'consum', 0.0225, 'lps'),
	(485342, 127, '2014-01-15 00:12:12.000000', 'consum', 0.0224, 'lps'),
	(485343, 127, '2014-01-15 00:12:13.000000', 'consum', 0.0216, 'lps'),
	(485344, 127, '2014-01-15 00:12:14.000000', 'consum', 0.0219, 'lps'),
	(485345, 127, '2014-01-15 00:12:15.000000', 'consum', 0.0220, 'lps'),
	(485346, 127, '2014-01-15 00:12:16.000000', 'consum', 0.0214, 'lps'),
	(485347, 127, '2014-01-15 00:12:17.000000', 'consum', 0.0221, 'lps'),
	(485348, 127, '2014-01-15 00:12:18.000000', 'consum', 0.0218, 'lps'),
	(485349, 127, '2014-01-15 00:12:19.000000', 'consum', 0.0218, 'lps'),
	(485350, 127, '2014-01-15 00:12:20.000000', 'consum', 0.0226, 'lps'),
	(485351, 127, '2014-01-15 00:12:21.000000', 'consum', 0.0214, 'lps'),
	(485352, 127, '2014-01-15 00:12:22.000000', 'consum', 0.0218, 'lps'),
	(485353, 127, '2014-01-15 00:12:23.000000', 'consum', 0.0221, 'lps'),
	(485354, 127, '2014-01-15 00:12:24.000000', 'consum', 0.0223, 'lps'),
	(485355, 127, '2014-01-15 00:12:25.000000', 'consum', 0.0212, 'lps'),
	(485356, 127, '2014-01-15 00:12:26.000000', 'consum', 0.0212, 'lps'),
	(485357, 127, '2014-01-15 00:12:27.000000', 'consum', 0.0215, 'lps'),
	(485358, 127, '2014-01-15 00:12:28.000000', 'consum', 0.0214, 'lps'),
	(485359, 127, '2014-01-15 00:12:29.000000', 'consum', 0.0214, 'lps'),
	(485360, 127, '2014-01-15 00:12:30.000000', 'consum', 0.0218, 'lps'),
	(485361, 127, '2014-01-15 00:12:31.000000', 'consum', 0.0223, 'lps'),
	(485362, 127, '2014-01-15 00:12:32.000000', 'consum', 0.0216, 'lps'),
	(485363, 127, '2014-01-15 00:12:33.000000', 'consum', 0.0220, 'lps'),
	(485364, 127, '2014-01-15 00:12:34.000000', 'consum', 0.0225, 'lps'),
	(485365, 127, '2014-01-15 00:12:35.000000', 'consum', 0.0223, 'lps'),
	(485366, 127, '2014-01-15 00:12:36.000000', 'consum', 0.0214, 'lps'),
	(485367, 127, '2014-01-15 00:12:37.000000', 'consum', 0.0223, 'lps'),
	(485368, 127, '2014-01-15 00:12:38.000000', 'consum', 0.0214, 'lps'),
	(485369, 127, '2014-01-15 00:12:39.000000', 'consum', 0.0225, 'lps'),
	(485370, 127, '2014-01-15 00:12:40.000000', 'consum', 0.0221, 'lps'),
	(485371, 127, '2014-01-15 00:12:41.000000', 'consum', 0.0223, 'lps'),
	(485372, 127, '2014-01-15 00:12:42.000000', 'consum', 0.0226, 'lps'),
	(485373, 127, '2014-01-15 00:12:43.000000', 'consum', 0.0218, 'lps'),
	(485374, 127, '2014-01-15 00:12:44.000000', 'consum', 0.0221, 'lps'),
	(485375, 127, '2014-01-15 00:12:45.000000', 'consum', 0.0221, 'lps'),
	(485376, 127, '2014-01-15 00:12:46.000000', 'consum', 0.0216, 'lps'),
	(485377, 127, '2014-01-15 00:12:47.000000', 'consum', 0.0223, 'lps'),
	(485378, 127, '2014-01-15 00:12:48.000000', 'consum', 0.0224, 'lps'),
	(485379, 127, '2014-01-15 00:12:49.000000', 'consum', 0.0210, 'lps'),
	(485380, 127, '2014-01-15 00:12:50.000000', 'consum', 0.0219, 'lps'),
	(485381, 127, '2014-01-15 00:12:51.000000', 'consum', 0.0220, 'lps'),
	(485382, 127, '2014-01-15 00:12:52.000000', 'consum', 0.0217, 'lps'),
	(485383, 127, '2014-01-15 00:12:53.000000', 'consum', 0.0215, 'lps'),
	(485384, 127, '2014-01-15 00:12:54.000000', 'consum', 0.0216, 'lps'),
	(485385, 127, '2014-01-15 00:12:55.000000', 'consum', 0.0225, 'lps'),
	(485386, 127, '2014-01-15 00:12:56.000000', 'consum', 0.0217, 'lps'),
	(485387, 127, '2014-01-15 00:12:57.000000', 'consum', 0.0217, 'lps'),
	(485388, 127, '2014-01-15 00:12:58.000000', 'consum', 0.0225, 'lps'),
	(485389, 127, '2014-01-15 00:12:59.000000', 'consum', 0.0212, 'lps'),
	(485390, 127, '2014-01-15 00:13:00.000000', 'consum', 0.0211, 'lps'),
	(485391, 127, '2014-01-15 00:13:01.000000', 'consum', 0.0210, 'lps'),
	(485392, 127, '2014-01-15 00:13:02.000000', 'consum', 0.0225, 'lps'),
	(485393, 127, '2014-01-15 00:13:03.000000', 'consum', 0.0215, 'lps'),
	(485394, 127, '2014-01-15 00:13:04.000000', 'consum', 0.0210, 'lps'),
	(485395, 127, '2014-01-15 00:13:05.000000', 'consum', 0.0211, 'lps'),
	(485396, 127, '2014-01-15 00:13:06.000000', 'consum', 0.0217, 'lps'),
	(485397, 127, '2014-01-15 00:13:07.000000', 'consum', 0.0223, 'lps'),
	(485398, 127, '2014-01-15 00:13:08.000000', 'consum', 0.0220, 'lps'),
	(485399, 127, '2014-01-15 00:13:09.000000', 'consum', 0.0225, 'lps'),
	(485400, 127, '2014-01-15 00:13:10.000000', 'consum', 0.0218, 'lps'),
	(485401, 127, '2014-01-15 00:13:11.000000', 'consum', 0.0225, 'lps'),
	(485402, 127, '2014-01-15 00:13:12.000000', 'consum', 0.0211, 'lps'),
	(485403, 127, '2014-01-15 00:13:13.000000', 'consum', 0.0220, 'lps'),
	(485404, 127, '2014-01-15 00:13:14.000000', 'consum', 0.0224, 'lps'),
	(485405, 127, '2014-01-15 00:13:15.000000', 'consum', 0.0217, 'lps'),
	(485406, 127, '2014-01-15 00:13:16.000000', 'consum', 0.0220, 'lps'),
	(485407, 127, '2014-01-15 00:13:17.000000', 'consum', 0.0222, 'lps'),
	(485408, 127, '2014-01-15 00:13:18.000000', 'consum', 0.0222, 'lps'),
	(485409, 127, '2014-01-15 00:13:19.000000', 'consum', 0.0219, 'lps'),
	(485410, 127, '2014-01-15 00:13:20.000000', 'consum', 0.0221, 'lps'),
	(485411, 127, '2014-01-15 00:13:21.000000', 'consum', 0.0219, 'lps'),
	(485412, 127, '2014-01-15 00:13:22.000000', 'consum', 0.0223, 'lps'),
	(485413, 127, '2014-01-15 00:13:23.000000', 'consum', 0.0216, 'lps'),
	(485414, 127, '2014-01-15 00:13:24.000000', 'consum', 0.0216, 'lps'),
	(485415, 127, '2014-01-15 00:13:25.000000', 'consum', 0.0224, 'lps'),
	(485416, 127, '2014-01-15 00:13:26.000000', 'consum', 0.0211, 'lps'),
	(485417, 127, '2014-01-15 00:13:27.000000', 'consum', 0.0226, 'lps'),
	(485418, 127, '2014-01-15 00:13:28.000000', 'consum', 0.0219, 'lps'),
	(485419, 127, '2014-01-15 00:13:29.000000', 'consum', 0.0224, 'lps'),
	(485420, 127, '2014-01-15 00:13:30.000000', 'consum', 0.0220, 'lps'),
	(485421, 127, '2014-01-15 00:13:31.000000', 'consum', 0.0220, 'lps'),
	(485422, 127, '2014-01-15 00:13:32.000000', 'consum', 0.0212, 'lps'),
	(485423, 127, '2014-01-15 00:13:33.000000', 'consum', 0.0223, 'lps'),
	(485424, 127, '2014-01-15 00:13:34.000000', 'consum', 0.0221, 'lps'),
	(485425, 127, '2014-01-15 00:13:35.000000', 'consum', 0.0225, 'lps'),
	(485426, 127, '2014-01-15 00:13:36.000000', 'consum', 0.0218, 'lps'),
	(485427, 127, '2014-01-15 00:13:37.000000', 'consum', 0.0222, 'lps'),
	(485428, 127, '2014-01-15 00:13:38.000000', 'consum', 0.0213, 'lps'),
	(485429, 127, '2014-01-15 00:13:39.000000', 'consum', 0.0225, 'lps'),
	(485430, 127, '2014-01-15 00:13:40.000000', 'consum', 0.0225, 'lps'),
	(485431, 127, '2014-01-15 00:13:41.000000', 'consum', 0.0223, 'lps'),
	(485432, 127, '2014-01-15 00:13:42.000000', 'consum', 0.0213, 'lps'),
	(485433, 127, '2014-01-15 00:13:43.000000', 'consum', 0.0223, 'lps'),
	(485434, 127, '2014-01-15 00:13:44.000000', 'consum', 0.0213, 'lps'),
	(485435, 127, '2014-01-15 00:13:45.000000', 'consum', 0.0221, 'lps'),
	(485436, 127, '2014-01-15 00:13:46.000000', 'consum', 0.0223, 'lps'),
	(485437, 127, '2014-01-15 00:13:47.000000', 'consum', 0.0223, 'lps'),
	(485438, 127, '2014-01-15 00:13:48.000000', 'consum', 0.0223, 'lps'),
	(485439, 127, '2014-01-15 00:13:49.000000', 'consum', 0.0219, 'lps'),
	(485440, 127, '2014-01-15 00:13:50.000000', 'consum', 0.0216, 'lps'),
	(485441, 127, '2014-01-15 00:13:51.000000', 'consum', 0.0215, 'lps'),
	(485442, 127, '2014-01-15 00:13:52.000000', 'consum', 0.0218, 'lps'),
	(485443, 127, '2014-01-15 00:13:53.000000', 'consum', 0.0216, 'lps'),
	(485444, 127, '2014-01-15 00:13:54.000000', 'consum', 0.0219, 'lps'),
	(485445, 127, '2014-01-15 00:13:55.000000', 'consum', 0.0219, 'lps'),
	(485446, 127, '2014-01-15 00:13:56.000000', 'consum', 0.0211, 'lps'),
	(485447, 127, '2014-01-15 00:13:57.000000', 'consum', 0.0221, 'lps'),
	(485448, 127, '2014-01-15 00:13:58.000000', 'consum', 0.0214, 'lps'),
	(485449, 127, '2014-01-15 00:13:59.000000', 'consum', 0.0212, 'lps'),
	(485450, 127, '2014-01-15 00:14:00.000000', 'consum', 0.0210, 'lps'),
	(485451, 127, '2014-01-15 00:14:01.000000', 'consum', 0.0222, 'lps'),
	(485452, 127, '2014-01-15 00:14:02.000000', 'consum', 0.0220, 'lps'),
	(485453, 127, '2014-01-15 00:14:03.000000', 'consum', 0.0226, 'lps'),
	(485454, 127, '2014-01-15 00:14:04.000000', 'consum', 0.0224, 'lps'),
	(485455, 127, '2014-01-15 00:14:05.000000', 'consum', 0.0216, 'lps'),
	(485456, 127, '2014-01-15 00:14:06.000000', 'consum', 0.0216, 'lps'),
	(485457, 127, '2014-01-15 00:14:07.000000', 'consum', 0.0221, 'lps'),
	(485458, 127, '2014-01-15 00:14:08.000000', 'consum', 0.0213, 'lps'),
	(485459, 127, '2014-01-15 00:14:09.000000', 'consum', 0.0211, 'lps'),
	(485460, 127, '2014-01-15 00:14:10.000000', 'consum', 0.0221, 'lps'),
	(485461, 127, '2014-01-15 00:14:11.000000', 'consum', 0.0213, 'lps'),
	(485462, 127, '2014-01-15 00:14:12.000000', 'consum', 0.0226, 'lps'),
	(485463, 127, '2014-01-15 00:14:13.000000', 'consum', 0.0214, 'lps'),
	(485464, 127, '2014-01-15 00:14:14.000000', 'consum', 0.0217, 'lps'),
	(485465, 127, '2014-01-15 00:14:15.000000', 'consum', 0.0215, 'lps'),
	(485466, 127, '2014-01-15 00:14:16.000000', 'consum', 0.0214, 'lps'),
	(485467, 127, '2014-01-15 00:14:17.000000', 'consum', 0.0218, 'lps'),
	(485468, 127, '2014-01-15 00:14:18.000000', 'consum', 0.0219, 'lps'),
	(485469, 127, '2014-01-15 00:14:19.000000', 'consum', 0.0216, 'lps'),
	(485470, 127, '2014-01-15 00:14:20.000000', 'consum', 0.0213, 'lps'),
	(485471, 127, '2014-01-15 00:14:21.000000', 'consum', 0.0226, 'lps'),
	(485472, 127, '2014-01-15 00:14:22.000000', 'consum', 0.0214, 'lps'),
	(485473, 127, '2014-01-15 00:14:23.000000', 'consum', 0.0214, 'lps'),
	(485474, 127, '2014-01-15 00:14:24.000000', 'consum', 0.0218, 'lps'),
	(485475, 127, '2014-01-15 00:14:25.000000', 'consum', 0.0222, 'lps'),
	(485476, 127, '2014-01-15 00:14:26.000000', 'consum', 0.0213, 'lps'),
	(485477, 127, '2014-01-15 00:14:27.000000', 'consum', 0.0223, 'lps'),
	(485478, 127, '2014-01-15 00:14:28.000000', 'consum', 0.0216, 'lps'),
	(485479, 127, '2014-01-15 00:14:29.000000', 'consum', 0.0217, 'lps'),
	(485480, 127, '2014-01-15 00:14:30.000000', 'consum', 0.0226, 'lps'),
	(485481, 127, '2014-01-15 00:14:31.000000', 'consum', 0.0222, 'lps'),
	(485482, 127, '2014-01-15 00:14:32.000000', 'consum', 0.0221, 'lps'),
	(485483, 127, '2014-01-15 00:14:33.000000', 'consum', 0.0212, 'lps'),
	(485484, 127, '2014-01-15 00:14:34.000000', 'consum', 0.0221, 'lps'),
	(485485, 127, '2014-01-15 00:14:35.000000', 'consum', 0.0210, 'lps'),
	(485486, 127, '2014-01-15 00:14:36.000000', 'consum', 0.0210, 'lps'),
	(485487, 127, '2014-01-15 00:14:37.000000', 'consum', 0.0211, 'lps'),
	(485488, 127, '2014-01-15 00:14:38.000000', 'consum', 0.0216, 'lps'),
	(485489, 127, '2014-01-15 00:14:39.000000', 'consum', 0.0222, 'lps'),
	(485490, 127, '2014-01-15 00:14:40.000000', 'consum', 0.0219, 'lps'),
	(485491, 127, '2014-01-15 00:14:41.000000', 'consum', 0.0216, 'lps'),
	(485492, 127, '2014-01-15 00:14:42.000000', 'consum', 0.0216, 'lps'),
	(485493, 127, '2014-01-15 00:14:43.000000', 'consum', 0.0222, 'lps'),
	(485494, 127, '2014-01-15 00:14:44.000000', 'consum', 0.0219, 'lps'),
	(485495, 127, '2014-01-15 00:14:45.000000', 'consum', 0.0219, 'lps'),
	(485496, 127, '2014-01-15 00:14:46.000000', 'consum', 0.0210, 'lps'),
	(485497, 127, '2014-01-15 00:14:47.000000', 'consum', 0.0220, 'lps'),
	(485498, 127, '2014-01-15 00:14:48.000000', 'consum', 0.0211, 'lps'),
	(485499, 127, '2014-01-15 00:14:49.000000', 'consum', 0.0216, 'lps'),
	(485500, 127, '2014-01-15 00:14:50.000000', 'consum', 0.0223, 'lps'),
	(485501, 127, '2014-01-15 00:14:51.000000', 'consum', 0.0221, 'lps'),
	(485502, 127, '2014-01-15 00:14:52.000000', 'consum', 0.0212, 'lps'),
	(485503, 127, '2014-01-15 00:14:53.000000', 'consum', 0.0219, 'lps'),
	(485504, 127, '2014-01-15 00:14:54.000000', 'consum', 0.0216, 'lps'),
	(485505, 127, '2014-01-15 00:14:55.000000', 'consum', 0.0213, 'lps'),
	(485506, 127, '2014-01-15 00:14:56.000000', 'consum', 0.0226, 'lps'),
	(485507, 127, '2014-01-15 00:14:57.000000', 'consum', 0.0215, 'lps'),
	(485508, 127, '2014-01-15 00:14:58.000000', 'consum', 0.0220, 'lps'),
	(485509, 127, '2014-01-15 00:14:59.000000', 'consum', 0.0211, 'lps'),
	(485510, 127, '2014-01-15 00:15:00.000000', 'consum', 0.0219, 'lps'),
	(485511, 127, '2014-01-15 00:15:01.000000', 'consum', 0.0221, 'lps'),
	(485512, 127, '2014-01-15 00:15:02.000000', 'consum', 0.0219, 'lps'),
	(485513, 127, '2014-01-15 00:15:03.000000', 'consum', 0.0225, 'lps'),
	(485514, 127, '2014-01-15 00:15:04.000000', 'consum', 0.0221, 'lps'),
	(485515, 127, '2014-01-15 00:15:05.000000', 'consum', 0.0223, 'lps'),
	(485516, 127, '2014-01-15 00:15:06.000000', 'consum', 0.0225, 'lps'),
	(485517, 127, '2014-01-15 00:15:07.000000', 'consum', 0.0212, 'lps'),
	(485518, 127, '2014-01-15 00:15:08.000000', 'consum', 0.0225, 'lps'),
	(485519, 127, '2014-01-15 00:15:09.000000', 'consum', 0.0212, 'lps'),
	(485520, 127, '2014-01-15 00:15:10.000000', 'consum', 0.0210, 'lps'),
	(485521, 127, '2014-01-15 00:15:11.000000', 'consum', 0.0221, 'lps'),
	(485522, 127, '2014-01-15 00:15:12.000000', 'consum', 0.0215, 'lps'),
	(485523, 127, '2014-01-15 00:15:13.000000', 'consum', 0.0220, 'lps'),
	(485524, 127, '2014-01-15 00:15:14.000000', 'consum', 0.0212, 'lps'),
	(485525, 127, '2014-01-15 00:15:15.000000', 'consum', 0.0222, 'lps'),
	(485526, 127, '2014-01-15 00:15:16.000000', 'consum', 0.0216, 'lps'),
	(485527, 127, '2014-01-15 00:15:17.000000', 'consum', 0.0219, 'lps'),
	(485528, 127, '2014-01-15 00:15:18.000000', 'consum', 0.0220, 'lps'),
	(485529, 127, '2014-01-15 00:15:19.000000', 'consum', 0.0216, 'lps'),
	(485530, 127, '2014-01-15 00:15:20.000000', 'consum', 0.0213, 'lps'),
	(485531, 127, '2014-01-15 00:15:21.000000', 'consum', 0.0225, 'lps'),
	(485532, 127, '2014-01-15 00:15:22.000000', 'consum', 0.0226, 'lps'),
	(485533, 127, '2014-01-15 00:15:23.000000', 'consum', 0.0211, 'lps'),
	(485534, 127, '2014-01-15 00:15:24.000000', 'consum', 0.0218, 'lps'),
	(485535, 127, '2014-01-15 00:15:25.000000', 'consum', 0.0212, 'lps'),
	(485536, 127, '2014-01-15 00:15:26.000000', 'consum', 0.0216, 'lps'),
	(485537, 127, '2014-01-15 00:15:27.000000', 'consum', 0.0218, 'lps'),
	(485538, 127, '2014-01-15 00:15:28.000000', 'consum', 0.0216, 'lps'),
	(485539, 127, '2014-01-15 00:15:29.000000', 'consum', 0.0214, 'lps'),
	(485540, 127, '2014-01-15 00:15:30.000000', 'consum', 0.0213, 'lps'),
	(485541, 127, '2014-01-15 00:15:31.000000', 'consum', 0.0212, 'lps'),
	(485542, 127, '2014-01-15 00:15:32.000000', 'consum', 0.0214, 'lps'),
	(485543, 127, '2014-01-15 00:15:33.000000', 'consum', 0.0222, 'lps'),
	(485544, 127, '2014-01-15 00:15:34.000000', 'consum', 0.0225, 'lps'),
	(485545, 127, '2014-01-15 00:15:35.000000', 'consum', 0.0217, 'lps'),
	(485546, 127, '2014-01-15 00:15:36.000000', 'consum', 0.0216, 'lps'),
	(485547, 127, '2014-01-15 00:15:37.000000', 'consum', 0.0219, 'lps'),
	(485548, 127, '2014-01-15 00:15:38.000000', 'consum', 0.0220, 'lps'),
	(485549, 127, '2014-01-15 00:15:39.000000', 'consum', 0.0216, 'lps'),
	(485550, 127, '2014-01-15 00:15:40.000000', 'consum', 0.0213, 'lps'),
	(485551, 127, '2014-01-15 00:15:41.000000', 'consum', 0.0222, 'lps'),
	(485552, 127, '2014-01-15 00:15:42.000000', 'consum', 0.0212, 'lps'),
	(485553, 127, '2014-01-15 00:15:43.000000', 'consum', 0.0220, 'lps'),
	(485554, 127, '2014-01-15 00:15:44.000000', 'consum', 0.0220, 'lps'),
	(485555, 127, '2014-01-15 00:15:45.000000', 'consum', 0.0214, 'lps'),
	(485556, 127, '2014-01-15 00:15:46.000000', 'consum', 0.0218, 'lps'),
	(485557, 127, '2014-01-15 00:15:47.000000', 'consum', 0.0220, 'lps'),
	(485558, 127, '2014-01-15 00:15:48.000000', 'consum', 0.0222, 'lps'),
	(485559, 127, '2014-01-15 00:15:49.000000', 'consum', 0.0220, 'lps'),
	(485560, 127, '2014-01-15 00:15:50.000000', 'consum', 0.0211, 'lps'),
	(485561, 127, '2014-01-15 00:15:51.000000', 'consum', 0.0218, 'lps'),
	(485562, 127, '2014-01-15 00:15:52.000000', 'consum', 0.0214, 'lps'),
	(485563, 127, '2014-01-15 00:15:53.000000', 'consum', 0.0224, 'lps'),
	(485564, 127, '2014-01-15 00:15:54.000000', 'consum', 0.0219, 'lps'),
	(485565, 127, '2014-01-15 00:15:55.000000', 'consum', 0.0211, 'lps'),
	(485566, 127, '2014-01-15 00:15:56.000000', 'consum', 0.0222, 'lps'),
	(485567, 127, '2014-01-15 00:15:57.000000', 'consum', 0.0217, 'lps'),
	(485568, 127, '2014-01-15 00:15:58.000000', 'consum', 0.0225, 'lps'),
	(485569, 127, '2014-01-15 00:15:59.000000', 'consum', 0.0214, 'lps'),
	(485570, 127, '2014-01-15 00:16:00.000000', 'consum', 0.0222, 'lps'),
	(485571, 127, '2014-01-15 00:16:01.000000', 'consum', 0.0224, 'lps'),
	(485572, 127, '2014-01-15 00:16:02.000000', 'consum', 0.0226, 'lps'),
	(485573, 127, '2014-01-15 00:16:03.000000', 'consum', 0.0214, 'lps'),
	(485574, 127, '2014-01-15 00:16:04.000000', 'consum', 0.0219, 'lps'),
	(485575, 127, '2014-01-15 00:16:05.000000', 'consum', 0.0210, 'lps'),
	(485576, 127, '2014-01-15 00:16:06.000000', 'consum', 0.0215, 'lps'),
	(485577, 127, '2014-01-15 00:16:07.000000', 'consum', 0.0221, 'lps'),
	(485578, 127, '2014-01-15 00:16:08.000000', 'consum', 0.0217, 'lps'),
	(485579, 127, '2014-01-15 00:16:09.000000', 'consum', 0.0212, 'lps'),
	(485580, 127, '2014-01-15 00:16:10.000000', 'consum', 0.0216, 'lps'),
	(485581, 127, '2014-01-15 00:16:11.000000', 'consum', 0.0217, 'lps'),
	(485582, 127, '2014-01-15 00:16:12.000000', 'consum', 0.0213, 'lps'),
	(485583, 127, '2014-01-15 00:16:13.000000', 'consum', 0.0219, 'lps'),
	(485584, 127, '2014-01-15 00:16:14.000000', 'consum', 0.0215, 'lps'),
	(485585, 127, '2014-01-15 00:16:15.000000', 'consum', 0.0225, 'lps'),
	(485586, 127, '2014-01-15 00:16:16.000000', 'consum', 0.0218, 'lps'),
	(485587, 127, '2014-01-15 00:16:17.000000', 'consum', 0.0223, 'lps'),
	(485588, 127, '2014-01-15 00:16:18.000000', 'consum', 0.0218, 'lps'),
	(485589, 127, '2014-01-15 00:16:19.000000', 'consum', 0.0210, 'lps'),
	(485590, 127, '2014-01-15 00:16:20.000000', 'consum', 0.0223, 'lps'),
	(485591, 127, '2014-01-15 00:16:21.000000', 'consum', 0.0222, 'lps'),
	(485592, 127, '2014-01-15 00:16:22.000000', 'consum', 0.0216, 'lps'),
	(485593, 127, '2014-01-15 00:16:23.000000', 'consum', 0.0222, 'lps'),
	(485594, 127, '2014-01-15 00:16:24.000000', 'consum', 0.0217, 'lps'),
	(485595, 127, '2014-01-15 00:16:25.000000', 'consum', 0.0226, 'lps'),
	(485596, 127, '2014-01-15 00:16:26.000000', 'consum', 0.0217, 'lps'),
	(485597, 127, '2014-01-15 00:16:27.000000', 'consum', 0.0218, 'lps'),
	(485598, 127, '2014-01-15 00:16:28.000000', 'consum', 0.0211, 'lps'),
	(485599, 127, '2014-01-15 00:16:29.000000', 'consum', 0.0210, 'lps'),
	(485600, 127, '2014-01-15 00:16:30.000000', 'consum', 0.0225, 'lps'),
	(485601, 127, '2014-01-15 00:16:31.000000', 'consum', 0.0215, 'lps'),
	(485602, 127, '2014-01-15 00:16:32.000000', 'consum', 0.0210, 'lps'),
	(485603, 127, '2014-01-15 00:16:33.000000', 'consum', 0.0213, 'lps'),
	(485604, 127, '2014-01-15 00:16:34.000000', 'consum', 0.0223, 'lps'),
	(485605, 127, '2014-01-15 00:16:35.000000', 'consum', 0.0217, 'lps'),
	(485606, 127, '2014-01-15 00:16:36.000000', 'consum', 0.0225, 'lps'),
	(485607, 127, '2014-01-15 00:16:37.000000', 'consum', 0.0212, 'lps'),
	(485608, 127, '2014-01-15 00:16:38.000000', 'consum', 0.0210, 'lps'),
	(485609, 127, '2014-01-15 00:16:39.000000', 'consum', 0.0219, 'lps'),
	(485610, 127, '2014-01-15 00:16:40.000000', 'consum', 0.0225, 'lps'),
	(485611, 127, '2014-01-15 00:16:41.000000', 'consum', 0.0222, 'lps'),
	(485612, 127, '2014-01-15 00:16:42.000000', 'consum', 0.0226, 'lps'),
	(485613, 127, '2014-01-15 00:16:43.000000', 'consum', 0.0222, 'lps'),
	(485614, 127, '2014-01-15 00:16:44.000000', 'consum', 0.0221, 'lps'),
	(485615, 127, '2014-01-15 00:16:45.000000', 'consum', 0.0213, 'lps'),
	(485616, 127, '2014-01-15 00:16:46.000000', 'consum', 0.0211, 'lps'),
	(485617, 127, '2014-01-15 00:16:47.000000', 'consum', 0.0221, 'lps'),
	(485618, 127, '2014-01-15 00:16:48.000000', 'consum', 0.0213, 'lps'),
	(485619, 127, '2014-01-15 00:16:49.000000', 'consum', 0.0225, 'lps'),
	(485620, 127, '2014-01-15 00:16:50.000000', 'consum', 0.0224, 'lps'),
	(485621, 127, '2014-01-15 00:16:51.000000', 'consum', 0.0221, 'lps'),
	(485622, 127, '2014-01-15 00:16:52.000000', 'consum', 0.0224, 'lps'),
	(485623, 127, '2014-01-15 00:16:53.000000', 'consum', 0.0213, 'lps'),
	(485624, 127, '2014-01-15 00:16:54.000000', 'consum', 0.0219, 'lps'),
	(485625, 127, '2014-01-15 00:16:55.000000', 'consum', 0.0212, 'lps'),
	(485626, 127, '2014-01-15 00:16:56.000000', 'consum', 0.0212, 'lps'),
	(485627, 127, '2014-01-15 00:16:57.000000', 'consum', 0.0213, 'lps'),
	(485628, 127, '2014-01-15 00:16:58.000000', 'consum', 0.0220, 'lps'),
	(485629, 127, '2014-01-15 00:16:59.000000', 'consum', 0.0219, 'lps'),
	(485630, 127, '2014-01-15 00:17:00.000000', 'consum', 0.0225, 'lps'),
	(485631, 127, '2014-01-15 00:17:01.000000', 'consum', 0.0223, 'lps'),
	(485632, 127, '2014-01-15 00:17:02.000000', 'consum', 0.0213, 'lps'),
	(485633, 127, '2014-01-15 00:17:03.000000', 'consum', 0.0220, 'lps'),
	(485634, 127, '2014-01-15 00:17:04.000000', 'consum', 0.0217, 'lps'),
	(485635, 127, '2014-01-15 00:17:05.000000', 'consum', 0.0218, 'lps'),
	(485636, 127, '2014-01-15 00:17:06.000000', 'consum', 0.0212, 'lps'),
	(485637, 127, '2014-01-15 00:17:07.000000', 'consum', 0.0211, 'lps'),
	(485638, 127, '2014-01-15 00:17:08.000000', 'consum', 0.0211, 'lps'),
	(485639, 127, '2014-01-15 00:17:09.000000', 'consum', 0.0213, 'lps'),
	(485640, 127, '2014-01-15 00:17:10.000000', 'consum', 0.0220, 'lps'),
	(485641, 127, '2014-01-15 00:17:11.000000', 'consum', 0.0220, 'lps'),
	(485642, 127, '2014-01-15 00:17:12.000000', 'consum', 0.0212, 'lps'),
	(485643, 127, '2014-01-15 00:17:13.000000', 'consum', 0.0223, 'lps'),
	(485644, 127, '2014-01-15 00:17:14.000000', 'consum', 0.0221, 'lps'),
	(485645, 127, '2014-01-15 00:17:15.000000', 'consum', 0.0210, 'lps'),
	(485646, 127, '2014-01-15 00:17:16.000000', 'consum', 0.0211, 'lps'),
	(485647, 127, '2014-01-15 00:17:17.000000', 'consum', 0.0214, 'lps'),
	(485648, 127, '2014-01-15 00:17:18.000000', 'consum', 0.0212, 'lps'),
	(485649, 127, '2014-01-15 00:17:19.000000', 'consum', 0.0224, 'lps'),
	(485650, 127, '2014-01-15 00:17:20.000000', 'consum', 0.0224, 'lps'),
	(485651, 127, '2014-01-15 00:17:21.000000', 'consum', 0.0222, 'lps'),
	(485652, 127, '2014-01-15 00:17:22.000000', 'consum', 0.0212, 'lps'),
	(485653, 127, '2014-01-15 00:17:23.000000', 'consum', 0.0219, 'lps'),
	(485654, 127, '2014-01-15 00:17:24.000000', 'consum', 0.0213, 'lps'),
	(485655, 127, '2014-01-15 00:17:25.000000', 'consum', 0.0216, 'lps'),
	(485656, 127, '2014-01-15 00:17:26.000000', 'consum', 0.0217, 'lps'),
	(485657, 127, '2014-01-15 00:17:27.000000', 'consum', 0.0225, 'lps'),
	(485658, 127, '2014-01-15 00:17:28.000000', 'consum', 0.0213, 'lps'),
	(485659, 127, '2014-01-15 00:17:29.000000', 'consum', 0.0214, 'lps'),
	(485660, 127, '2014-01-15 00:17:30.000000', 'consum', 0.0223, 'lps'),
	(485661, 127, '2014-01-15 00:17:31.000000', 'consum', 0.0213, 'lps'),
	(485662, 127, '2014-01-15 00:17:32.000000', 'consum', 0.0222, 'lps'),
	(485663, 127, '2014-01-15 00:17:33.000000', 'consum', 0.0226, 'lps'),
	(485664, 127, '2014-01-15 00:17:34.000000', 'consum', 0.0219, 'lps'),
	(485665, 127, '2014-01-15 00:17:35.000000', 'consum', 0.0210, 'lps'),
	(485666, 127, '2014-01-15 00:17:36.000000', 'consum', 0.0216, 'lps'),
	(485667, 127, '2014-01-15 00:17:37.000000', 'consum', 0.0225, 'lps'),
	(485668, 127, '2014-01-15 00:17:38.000000', 'consum', 0.0214, 'lps'),
	(485669, 127, '2014-01-15 00:17:39.000000', 'consum', 0.0219, 'lps'),
	(485670, 127, '2014-01-15 00:17:40.000000', 'consum', 0.0210, 'lps'),
	(485671, 127, '2014-01-15 00:17:41.000000', 'consum', 0.0219, 'lps'),
	(485672, 127, '2014-01-15 00:17:42.000000', 'consum', 0.0221, 'lps'),
	(485673, 127, '2014-01-15 00:17:43.000000', 'consum', 0.0223, 'lps'),
	(485674, 127, '2014-01-15 00:17:44.000000', 'consum', 0.0225, 'lps'),
	(485675, 127, '2014-01-15 00:17:45.000000', 'consum', 0.0211, 'lps'),
	(485676, 127, '2014-01-15 00:17:46.000000', 'consum', 0.0222, 'lps'),
	(485677, 127, '2014-01-15 00:17:47.000000', 'consum', 0.0217, 'lps'),
	(485678, 127, '2014-01-15 00:17:48.000000', 'consum', 0.0224, 'lps'),
	(485679, 127, '2014-01-15 00:17:49.000000', 'consum', 0.0211, 'lps'),
	(485680, 127, '2014-01-15 00:17:50.000000', 'consum', 0.0224, 'lps'),
	(485681, 127, '2014-01-15 00:17:51.000000', 'consum', 0.0211, 'lps'),
	(485682, 127, '2014-01-15 00:17:52.000000', 'consum', 0.0221, 'lps'),
	(485683, 127, '2014-01-15 00:17:53.000000', 'consum', 0.0215, 'lps'),
	(485684, 127, '2014-01-15 00:17:54.000000', 'consum', 0.0217, 'lps'),
	(485685, 127, '2014-01-15 00:17:55.000000', 'consum', 0.0216, 'lps'),
	(485686, 127, '2014-01-15 00:17:56.000000', 'consum', 0.0220, 'lps'),
	(485687, 127, '2014-01-15 00:17:57.000000', 'consum', 0.0225, 'lps'),
	(485688, 127, '2014-01-15 00:17:58.000000', 'consum', 0.0222, 'lps'),
	(485689, 127, '2014-01-15 00:17:59.000000', 'consum', 0.0224, 'lps'),
	(485690, 127, '2014-01-15 00:18:00.000000', 'consum', 0.0226, 'lps'),
	(485691, 127, '2014-01-15 00:18:01.000000', 'consum', 0.0217, 'lps'),
	(485692, 127, '2014-01-15 00:18:02.000000', 'consum', 0.0213, 'lps'),
	(485693, 127, '2014-01-15 00:18:03.000000', 'consum', 0.0222, 'lps'),
	(485694, 127, '2014-01-15 00:18:04.000000', 'consum', 0.0210, 'lps'),
	(485695, 127, '2014-01-15 00:18:05.000000', 'consum', 0.0226, 'lps'),
	(485696, 127, '2014-01-15 00:18:06.000000', 'consum', 0.0224, 'lps'),
	(485697, 127, '2014-01-15 00:18:07.000000', 'consum', 0.0217, 'lps'),
	(485698, 127, '2014-01-15 00:18:08.000000', 'consum', 0.0217, 'lps'),
	(485699, 127, '2014-01-15 00:18:09.000000', 'consum', 0.0224, 'lps'),
	(485700, 127, '2014-01-15 00:18:10.000000', 'consum', 0.0226, 'lps'),
	(485701, 127, '2014-01-15 00:18:11.000000', 'consum', 0.0214, 'lps'),
	(485702, 127, '2014-01-15 00:18:12.000000', 'consum', 0.0217, 'lps'),
	(485703, 127, '2014-01-15 00:18:13.000000', 'consum', 0.0215, 'lps'),
	(485704, 127, '2014-01-15 00:18:14.000000', 'consum', 0.0217, 'lps'),
	(485705, 127, '2014-01-15 00:18:15.000000', 'consum', 0.0212, 'lps'),
	(485706, 127, '2014-01-15 00:18:16.000000', 'consum', 0.0217, 'lps'),
	(485707, 127, '2014-01-15 00:18:17.000000', 'consum', 0.0223, 'lps'),
	(485708, 127, '2014-01-15 00:18:18.000000', 'consum', 0.0218, 'lps'),
	(485709, 127, '2014-01-15 00:18:19.000000', 'consum', 0.0214, 'lps'),
	(485710, 127, '2014-01-15 00:18:20.000000', 'consum', 0.0223, 'lps'),
	(485711, 127, '2014-01-15 00:18:21.000000', 'consum', 0.0211, 'lps'),
	(485712, 127, '2014-01-15 00:18:22.000000', 'consum', 0.0211, 'lps'),
	(485713, 127, '2014-01-15 00:18:23.000000', 'consum', 0.0213, 'lps'),
	(485714, 127, '2014-01-15 00:18:24.000000', 'consum', 0.0224, 'lps'),
	(485715, 127, '2014-01-15 00:18:25.000000', 'consum', 0.0221, 'lps'),
	(485716, 127, '2014-01-15 00:18:26.000000', 'consum', 0.0222, 'lps'),
	(485717, 127, '2014-01-15 00:18:27.000000', 'consum', 0.0221, 'lps'),
	(485718, 127, '2014-01-15 00:18:28.000000', 'consum', 0.0212, 'lps'),
	(485719, 127, '2014-01-15 00:18:29.000000', 'consum', 0.0221, 'lps'),
	(485720, 127, '2014-01-15 00:18:30.000000', 'consum', 0.0224, 'lps'),
	(485721, 127, '2014-01-15 00:18:31.000000', 'consum', 0.0214, 'lps'),
	(485722, 127, '2014-01-15 00:18:32.000000', 'consum', 0.0225, 'lps'),
	(485723, 127, '2014-01-15 00:18:33.000000', 'consum', 0.0222, 'lps'),
	(485724, 127, '2014-01-15 00:18:34.000000', 'consum', 0.0226, 'lps'),
	(485725, 127, '2014-01-15 00:18:35.000000', 'consum', 0.0220, 'lps'),
	(485726, 127, '2014-01-15 00:18:36.000000', 'consum', 0.0212, 'lps'),
	(485727, 127, '2014-01-15 00:18:37.000000', 'consum', 0.0223, 'lps'),
	(485728, 127, '2014-01-15 00:18:38.000000', 'consum', 0.0221, 'lps'),
	(485729, 127, '2014-01-15 00:18:39.000000', 'consum', 0.0224, 'lps'),
	(485730, 127, '2014-01-15 00:18:40.000000', 'consum', 0.0213, 'lps'),
	(485731, 127, '2014-01-15 00:18:41.000000', 'consum', 0.0217, 'lps'),
	(485732, 127, '2014-01-15 00:18:42.000000', 'consum', 0.0221, 'lps'),
	(485733, 127, '2014-01-15 00:18:43.000000', 'consum', 0.0226, 'lps'),
	(485734, 127, '2014-01-15 00:18:44.000000', 'consum', 0.0223, 'lps'),
	(485735, 127, '2014-01-15 00:18:45.000000', 'consum', 0.0210, 'lps'),
	(485736, 127, '2014-01-15 00:18:46.000000', 'consum', 0.0224, 'lps'),
	(485737, 127, '2014-01-15 00:18:47.000000', 'consum', 0.0211, 'lps'),
	(485738, 127, '2014-01-15 00:18:48.000000', 'consum', 0.0225, 'lps'),
	(485739, 127, '2014-01-15 00:18:49.000000', 'consum', 0.0213, 'lps'),
	(485740, 127, '2014-01-15 00:18:50.000000', 'consum', 0.0214, 'lps'),
	(485741, 127, '2014-01-15 00:18:51.000000', 'consum', 0.0222, 'lps'),
	(485742, 127, '2014-01-15 00:18:52.000000', 'consum', 0.0210, 'lps'),
	(485743, 127, '2014-01-15 00:18:53.000000', 'consum', 0.0225, 'lps'),
	(485744, 127, '2014-01-15 00:18:54.000000', 'consum', 0.0215, 'lps'),
	(485745, 127, '2014-01-15 00:18:55.000000', 'consum', 0.0225, 'lps'),
	(485746, 127, '2014-01-15 00:18:56.000000', 'consum', 0.0220, 'lps'),
	(485747, 127, '2014-01-15 00:18:57.000000', 'consum', 0.0217, 'lps'),
	(485748, 127, '2014-01-15 00:18:58.000000', 'consum', 0.0216, 'lps'),
	(485749, 127, '2014-01-15 00:18:59.000000', 'consum', 0.0218, 'lps'),
	(485750, 127, '2014-01-15 00:19:00.000000', 'consum', 0.0216, 'lps'),
	(485751, 127, '2014-01-15 00:19:01.000000', 'consum', 0.0216, 'lps'),
	(485752, 127, '2014-01-15 00:19:02.000000', 'consum', 0.0222, 'lps'),
	(485753, 127, '2014-01-15 00:19:03.000000', 'consum', 0.0220, 'lps'),
	(485754, 127, '2014-01-15 00:19:04.000000', 'consum', 0.0224, 'lps'),
	(485755, 127, '2014-01-15 00:19:05.000000', 'consum', 0.0214, 'lps'),
	(485756, 127, '2014-01-15 00:19:06.000000', 'consum', 0.0225, 'lps'),
	(485757, 127, '2014-01-15 00:19:07.000000', 'consum', 0.0224, 'lps'),
	(485758, 127, '2014-01-15 00:19:08.000000', 'consum', 0.0216, 'lps'),
	(485759, 127, '2014-01-15 00:19:09.000000', 'consum', 0.0218, 'lps'),
	(485760, 127, '2014-01-15 00:19:10.000000', 'consum', 0.0214, 'lps'),
	(485761, 127, '2014-01-15 00:19:11.000000', 'consum', 0.0223, 'lps'),
	(485762, 127, '2014-01-15 00:19:12.000000', 'consum', 0.0214, 'lps'),
	(485763, 127, '2014-01-15 00:19:13.000000', 'consum', 0.0225, 'lps'),
	(485764, 127, '2014-01-15 00:19:14.000000', 'consum', 0.0222, 'lps'),
	(485765, 127, '2014-01-15 00:19:15.000000', 'consum', 0.0225, 'lps'),
	(485766, 127, '2014-01-15 00:19:16.000000', 'consum', 0.0217, 'lps'),
	(485767, 127, '2014-01-15 00:19:17.000000', 'consum', 0.0215, 'lps'),
	(485768, 127, '2014-01-15 00:19:18.000000', 'consum', 0.0217, 'lps'),
	(485769, 127, '2014-01-15 00:19:19.000000', 'consum', 0.0214, 'lps'),
	(485770, 127, '2014-01-15 00:19:20.000000', 'consum', 0.0226, 'lps'),
	(485771, 127, '2014-01-15 00:19:21.000000', 'consum', 0.0210, 'lps'),
	(485772, 127, '2014-01-15 00:19:22.000000', 'consum', 0.0213, 'lps'),
	(485773, 127, '2014-01-15 00:19:23.000000', 'consum', 0.0225, 'lps'),
	(485774, 127, '2014-01-15 00:19:24.000000', 'consum', 0.0211, 'lps'),
	(485775, 127, '2014-01-15 00:19:25.000000', 'consum', 0.0220, 'lps'),
	(485776, 127, '2014-01-15 00:19:26.000000', 'consum', 0.0223, 'lps'),
	(485777, 127, '2014-01-15 00:19:27.000000', 'consum', 0.0210, 'lps'),
	(485778, 127, '2014-01-15 00:19:28.000000', 'consum', 0.0224, 'lps'),
	(485779, 127, '2014-01-15 00:19:29.000000', 'consum', 0.0213, 'lps'),
	(485780, 127, '2014-01-15 00:19:30.000000', 'consum', 0.0216, 'lps'),
	(485781, 127, '2014-01-15 00:19:31.000000', 'consum', 0.0214, 'lps'),
	(485782, 127, '2014-01-15 00:19:32.000000', 'consum', 0.0214, 'lps'),
	(485783, 127, '2014-01-15 00:19:33.000000', 'consum', 0.0219, 'lps'),
	(485784, 127, '2014-01-15 00:19:34.000000', 'consum', 0.0211, 'lps'),
	(485785, 127, '2014-01-15 00:19:35.000000', 'consum', 0.0219, 'lps'),
	(485786, 127, '2014-01-15 00:19:36.000000', 'consum', 0.0222, 'lps'),
	(485787, 127, '2014-01-15 00:19:37.000000', 'consum', 0.0224, 'lps'),
	(485788, 127, '2014-01-15 00:19:38.000000', 'consum', 0.0212, 'lps'),
	(485789, 127, '2014-01-15 00:19:39.000000', 'consum', 0.0213, 'lps'),
	(485790, 127, '2014-01-15 00:19:40.000000', 'consum', 0.0220, 'lps'),
	(485791, 127, '2014-01-15 00:19:41.000000', 'consum', 0.0218, 'lps'),
	(485792, 127, '2014-01-15 00:19:42.000000', 'consum', 0.0220, 'lps'),
	(485793, 127, '2014-01-15 00:19:43.000000', 'consum', 0.0220, 'lps'),
	(485794, 127, '2014-01-15 00:19:44.000000', 'consum', 0.0211, 'lps'),
	(485795, 127, '2014-01-15 00:19:45.000000', 'consum', 0.0222, 'lps'),
	(485796, 127, '2014-01-15 00:19:46.000000', 'consum', 0.0216, 'lps'),
	(485797, 127, '2014-01-15 00:19:47.000000', 'consum', 0.0222, 'lps'),
	(485798, 127, '2014-01-15 00:19:48.000000', 'consum', 0.0218, 'lps'),
	(485799, 127, '2014-01-15 00:19:49.000000', 'consum', 0.0216, 'lps'),
	(485800, 127, '2014-01-15 00:19:50.000000', 'consum', 0.0216, 'lps'),
	(485801, 127, '2014-01-15 00:19:51.000000', 'consum', 0.0222, 'lps'),
	(485802, 127, '2014-01-15 00:19:52.000000', 'consum', 0.0218, 'lps'),
	(485803, 127, '2014-01-15 00:19:53.000000', 'consum', 0.0215, 'lps'),
	(485804, 127, '2014-01-15 00:19:54.000000', 'consum', 0.0212, 'lps'),
	(485805, 127, '2014-01-15 00:19:55.000000', 'consum', 0.0221, 'lps'),
	(485806, 127, '2014-01-15 00:19:56.000000', 'consum', 0.0211, 'lps'),
	(485807, 127, '2014-01-15 00:19:57.000000', 'consum', 0.0217, 'lps'),
	(485808, 127, '2014-01-15 00:19:58.000000', 'consum', 0.0223, 'lps'),
	(485809, 127, '2014-01-15 00:19:59.000000', 'consum', 0.0223, 'lps'),
	(485810, 127, '2014-01-15 00:20:00.000000', 'consum', 0.0220, 'lps'),
	(485811, 127, '2014-01-15 00:20:01.000000', 'consum', 0.0220, 'lps'),
	(485812, 127, '2014-01-15 00:20:02.000000', 'consum', 0.0214, 'lps'),
	(485813, 127, '2014-01-15 00:20:03.000000', 'consum', 0.0217, 'lps'),
	(485814, 127, '2014-01-15 00:20:04.000000', 'consum', 0.0218, 'lps'),
	(485815, 127, '2014-01-15 00:20:05.000000', 'consum', 0.0212, 'lps'),
	(485816, 127, '2014-01-15 00:20:06.000000', 'consum', 0.0215, 'lps'),
	(485817, 127, '2014-01-15 00:20:07.000000', 'consum', 0.0210, 'lps'),
	(485818, 127, '2014-01-15 00:20:08.000000', 'consum', 0.0212, 'lps'),
	(485819, 127, '2014-01-15 00:20:09.000000', 'consum', 0.0222, 'lps'),
	(485820, 127, '2014-01-15 00:20:10.000000', 'consum', 0.0214, 'lps'),
	(485821, 127, '2014-01-15 00:20:11.000000', 'consum', 0.0211, 'lps'),
	(485822, 127, '2014-01-15 00:20:12.000000', 'consum', 0.0219, 'lps'),
	(485823, 127, '2014-01-15 00:20:13.000000', 'consum', 0.0219, 'lps'),
	(485824, 127, '2014-01-15 00:20:14.000000', 'consum', 0.0212, 'lps'),
	(485825, 127, '2014-01-15 00:20:15.000000', 'consum', 0.0211, 'lps'),
	(485826, 127, '2014-01-15 00:20:16.000000', 'consum', 0.0211, 'lps'),
	(485827, 127, '2014-01-15 00:20:17.000000', 'consum', 0.0226, 'lps'),
	(485828, 127, '2014-01-15 00:20:18.000000', 'consum', 0.0222, 'lps'),
	(485829, 127, '2014-01-15 00:20:19.000000', 'consum', 0.0220, 'lps'),
	(485830, 127, '2014-01-15 00:20:20.000000', 'consum', 0.0224, 'lps'),
	(485831, 127, '2014-01-15 00:20:21.000000', 'consum', 0.0219, 'lps'),
	(485832, 127, '2014-01-15 00:20:22.000000', 'consum', 0.0213, 'lps'),
	(485833, 127, '2014-01-15 00:20:23.000000', 'consum', 0.0214, 'lps'),
	(485834, 127, '2014-01-15 00:20:24.000000', 'consum', 0.0224, 'lps'),
	(485835, 127, '2014-01-15 00:20:25.000000', 'consum', 0.0218, 'lps'),
	(485836, 127, '2014-01-15 00:20:26.000000', 'consum', 0.0226, 'lps'),
	(485837, 127, '2014-01-15 00:20:27.000000', 'consum', 0.0214, 'lps'),
	(485838, 127, '2014-01-15 00:20:28.000000', 'consum', 0.0217, 'lps'),
	(485839, 127, '2014-01-15 00:20:29.000000', 'consum', 0.0216, 'lps'),
	(485840, 127, '2014-01-15 00:20:30.000000', 'consum', 0.0221, 'lps'),
	(485841, 127, '2014-01-15 00:20:31.000000', 'consum', 0.0212, 'lps'),
	(485842, 127, '2014-01-15 00:20:32.000000', 'consum', 0.0220, 'lps'),
	(485843, 127, '2014-01-15 00:20:33.000000', 'consum', 0.0222, 'lps'),
	(485844, 127, '2014-01-15 00:20:34.000000', 'consum', 0.0223, 'lps'),
	(485845, 127, '2014-01-15 00:20:35.000000', 'consum', 0.0224, 'lps'),
	(485846, 127, '2014-01-15 00:20:36.000000', 'consum', 0.0226, 'lps'),
	(485847, 127, '2014-01-15 00:20:37.000000', 'consum', 0.0211, 'lps'),
	(485848, 127, '2014-01-15 00:20:38.000000', 'consum', 0.0221, 'lps'),
	(485849, 127, '2014-01-15 00:20:39.000000', 'consum', 0.0212, 'lps'),
	(485850, 127, '2014-01-15 00:20:40.000000', 'consum', 0.0220, 'lps'),
	(485851, 127, '2014-01-15 00:20:41.000000', 'consum', 0.0222, 'lps'),
	(485852, 127, '2014-01-15 00:20:42.000000', 'consum', 0.0224, 'lps'),
	(485853, 127, '2014-01-15 00:20:43.000000', 'consum', 0.0211, 'lps'),
	(485854, 127, '2014-01-15 00:20:44.000000', 'consum', 0.0225, 'lps'),
	(485855, 127, '2014-01-15 00:20:45.000000', 'consum', 0.0214, 'lps'),
	(485856, 127, '2014-01-15 00:20:46.000000', 'consum', 0.0219, 'lps'),
	(485857, 127, '2014-01-15 00:20:47.000000', 'consum', 0.0210, 'lps'),
	(485858, 127, '2014-01-15 00:20:48.000000', 'consum', 0.0215, 'lps'),
	(485859, 127, '2014-01-15 00:20:49.000000', 'consum', 0.0222, 'lps'),
	(485860, 127, '2014-01-15 00:20:50.000000', 'consum', 0.0219, 'lps'),
	(485861, 127, '2014-01-15 00:20:51.000000', 'consum', 0.0219, 'lps'),
	(485862, 127, '2014-01-15 00:20:52.000000', 'consum', 0.0214, 'lps'),
	(485863, 127, '2014-01-15 00:20:53.000000', 'consum', 0.0221, 'lps'),
	(485864, 127, '2014-01-15 00:20:54.000000', 'consum', 0.0218, 'lps'),
	(485865, 127, '2014-01-15 00:20:55.000000', 'consum', 0.0220, 'lps'),
	(485866, 127, '2014-01-15 00:20:56.000000', 'consum', 0.0217, 'lps'),
	(485867, 127, '2014-01-15 00:20:57.000000', 'consum', 0.0216, 'lps'),
	(485868, 127, '2014-01-15 00:20:58.000000', 'consum', 0.0218, 'lps'),
	(485869, 127, '2014-01-15 00:20:59.000000', 'consum', 0.0218, 'lps'),
	(485870, 127, '2014-01-15 00:21:00.000000', 'consum', 0.0225, 'lps'),
	(485871, 127, '2014-01-15 00:21:01.000000', 'consum', 0.0210, 'lps'),
	(485872, 127, '2014-01-15 00:21:02.000000', 'consum', 0.0219, 'lps'),
	(485873, 127, '2014-01-15 00:21:03.000000', 'consum', 0.0221, 'lps'),
	(485874, 127, '2014-01-15 00:21:04.000000', 'consum', 0.0220, 'lps'),
	(485875, 127, '2014-01-15 00:21:05.000000', 'consum', 0.0211, 'lps'),
	(485876, 127, '2014-01-15 00:21:06.000000', 'consum', 0.0218, 'lps'),
	(485877, 127, '2014-01-15 00:21:07.000000', 'consum', 0.0214, 'lps'),
	(485878, 127, '2014-01-15 00:21:08.000000', 'consum', 0.0224, 'lps'),
	(485879, 127, '2014-01-15 00:21:09.000000', 'consum', 0.0217, 'lps'),
	(485880, 127, '2014-01-15 00:21:10.000000', 'consum', 0.0220, 'lps'),
	(485881, 127, '2014-01-15 00:21:11.000000', 'consum', 0.0223, 'lps'),
	(485882, 127, '2014-01-15 00:21:12.000000', 'consum', 0.0213, 'lps'),
	(485883, 127, '2014-01-15 00:21:13.000000', 'consum', 0.0219, 'lps'),
	(485884, 127, '2014-01-15 00:21:14.000000', 'consum', 0.0215, 'lps'),
	(485885, 127, '2014-01-15 00:21:15.000000', 'consum', 0.0224, 'lps'),
	(485886, 127, '2014-01-15 00:21:16.000000', 'consum', 0.0214, 'lps'),
	(485887, 127, '2014-01-15 00:21:17.000000', 'consum', 0.0223, 'lps'),
	(485888, 127, '2014-01-15 00:21:18.000000', 'consum', 0.0214, 'lps'),
	(485889, 127, '2014-01-15 00:21:19.000000', 'consum', 0.0226, 'lps'),
	(485890, 127, '2014-01-15 00:21:20.000000', 'consum', 0.0225, 'lps'),
	(485891, 127, '2014-01-15 00:21:21.000000', 'consum', 0.0221, 'lps'),
	(485892, 127, '2014-01-15 00:21:22.000000', 'consum', 0.0220, 'lps'),
	(485893, 127, '2014-01-15 00:21:23.000000', 'consum', 0.0210, 'lps'),
	(485894, 127, '2014-01-15 00:21:24.000000', 'consum', 0.0217, 'lps'),
	(485895, 127, '2014-01-15 00:21:25.000000', 'consum', 0.0225, 'lps'),
	(485896, 127, '2014-01-15 00:21:26.000000', 'consum', 0.0216, 'lps'),
	(485897, 127, '2014-01-15 00:21:27.000000', 'consum', 0.0211, 'lps'),
	(485898, 127, '2014-01-15 00:21:28.000000', 'consum', 0.0217, 'lps'),
	(485899, 127, '2014-01-15 00:21:29.000000', 'consum', 0.0225, 'lps'),
	(485900, 127, '2014-01-15 00:21:30.000000', 'consum', 0.0213, 'lps'),
	(485901, 127, '2014-01-15 00:21:31.000000', 'consum', 0.0216, 'lps'),
	(485902, 127, '2014-01-15 00:21:32.000000', 'consum', 0.0215, 'lps'),
	(485903, 127, '2014-01-15 00:21:33.000000', 'consum', 0.0218, 'lps'),
	(485904, 127, '2014-01-15 00:21:34.000000', 'consum', 0.0219, 'lps'),
	(485905, 127, '2014-01-15 00:21:35.000000', 'consum', 0.0215, 'lps'),
	(485906, 127, '2014-01-15 00:21:36.000000', 'consum', 0.0225, 'lps'),
	(485907, 127, '2014-01-15 00:21:37.000000', 'consum', 0.0219, 'lps'),
	(485908, 127, '2014-01-15 00:21:38.000000', 'consum', 0.0210, 'lps'),
	(485909, 127, '2014-01-15 00:21:39.000000', 'consum', 0.0217, 'lps'),
	(485910, 127, '2014-01-15 00:21:40.000000', 'consum', 0.0213, 'lps'),
	(485911, 127, '2014-01-15 00:21:41.000000', 'consum', 0.0221, 'lps'),
	(485912, 127, '2014-01-15 00:21:42.000000', 'consum', 0.0223, 'lps'),
	(485913, 127, '2014-01-15 00:21:43.000000', 'consum', 0.0210, 'lps'),
	(485914, 127, '2014-01-15 00:21:44.000000', 'consum', 0.0219, 'lps'),
	(485915, 127, '2014-01-15 00:21:45.000000', 'consum', 0.0224, 'lps'),
	(485916, 127, '2014-01-15 00:21:46.000000', 'consum', 0.0218, 'lps'),
	(485917, 127, '2014-01-15 00:21:47.000000', 'consum', 0.0210, 'lps'),
	(485918, 127, '2014-01-15 00:21:48.000000', 'consum', 0.0221, 'lps'),
	(485919, 127, '2014-01-15 00:21:49.000000', 'consum', 0.0213, 'lps'),
	(485920, 127, '2014-01-15 00:21:50.000000', 'consum', 0.0212, 'lps'),
	(485921, 127, '2014-01-15 00:21:51.000000', 'consum', 0.0210, 'lps'),
	(485922, 127, '2014-01-15 00:21:52.000000', 'consum', 0.0221, 'lps'),
	(485923, 127, '2014-01-15 00:21:53.000000', 'consum', 0.0215, 'lps'),
	(485924, 127, '2014-01-15 00:21:54.000000', 'consum', 0.0219, 'lps'),
	(485925, 127, '2014-01-15 00:21:55.000000', 'consum', 0.0224, 'lps'),
	(485926, 127, '2014-01-15 00:21:56.000000', 'consum', 0.0221, 'lps'),
	(485927, 127, '2014-01-15 00:21:57.000000', 'consum', 0.0223, 'lps'),
	(485928, 127, '2014-01-15 00:21:58.000000', 'consum', 0.0225, 'lps'),
	(485929, 127, '2014-01-15 00:21:59.000000', 'consum', 0.0214, 'lps'),
	(485930, 127, '2014-01-15 00:22:00.000000', 'consum', 0.0217, 'lps'),
	(485931, 127, '2014-01-15 00:22:01.000000', 'consum', 0.0219, 'lps'),
	(485932, 127, '2014-01-15 00:22:02.000000', 'consum', 0.0217, 'lps'),
	(485933, 127, '2014-01-15 00:22:03.000000', 'consum', 0.0218, 'lps'),
	(485934, 127, '2014-01-15 00:22:04.000000', 'consum', 0.0212, 'lps'),
	(485935, 127, '2014-01-15 00:22:05.000000', 'consum', 0.0215, 'lps'),
	(485936, 127, '2014-01-15 00:22:06.000000', 'consum', 0.0212, 'lps'),
	(485937, 127, '2014-01-15 00:22:07.000000', 'consum', 0.0223, 'lps'),
	(485938, 127, '2014-01-15 00:22:08.000000', 'consum', 0.0216, 'lps'),
	(485939, 127, '2014-01-15 00:22:09.000000', 'consum', 0.0220, 'lps'),
	(485940, 127, '2014-01-15 00:22:10.000000', 'consum', 0.0225, 'lps'),
	(485941, 127, '2014-01-15 00:22:11.000000', 'consum', 0.0222, 'lps'),
	(485942, 127, '2014-01-15 00:22:12.000000', 'consum', 0.0225, 'lps'),
	(485943, 127, '2014-01-15 00:22:13.000000', 'consum', 0.0216, 'lps'),
	(485944, 127, '2014-01-15 00:22:14.000000', 'consum', 0.0213, 'lps'),
	(485945, 127, '2014-01-15 00:22:15.000000', 'consum', 0.0224, 'lps'),
	(485946, 127, '2014-01-15 00:22:16.000000', 'consum', 0.0218, 'lps'),
	(485947, 127, '2014-01-15 00:22:17.000000', 'consum', 0.0212, 'lps'),
	(485948, 127, '2014-01-15 00:22:18.000000', 'consum', 0.0214, 'lps'),
	(485949, 127, '2014-01-15 00:22:19.000000', 'consum', 0.0222, 'lps'),
	(485950, 127, '2014-01-15 00:22:20.000000', 'consum', 0.0225, 'lps'),
	(485951, 127, '2014-01-15 00:22:21.000000', 'consum', 0.0217, 'lps'),
	(485952, 127, '2014-01-15 00:22:22.000000', 'consum', 0.0216, 'lps'),
	(485953, 127, '2014-01-15 00:22:23.000000', 'consum', 0.0220, 'lps'),
	(485954, 127, '2014-01-15 00:22:24.000000', 'consum', 0.0226, 'lps'),
	(485955, 127, '2014-01-15 00:22:25.000000', 'consum', 0.0226, 'lps'),
	(485956, 127, '2014-01-15 00:22:26.000000', 'consum', 0.0223, 'lps'),
	(485957, 127, '2014-01-15 00:22:27.000000', 'consum', 0.0214, 'lps'),
	(485958, 127, '2014-01-15 00:22:28.000000', 'consum', 0.0226, 'lps'),
	(485959, 127, '2014-01-15 00:22:29.000000', 'consum', 0.0225, 'lps'),
	(485960, 127, '2014-01-15 00:22:30.000000', 'consum', 0.0221, 'lps'),
	(485961, 127, '2014-01-15 00:22:31.000000', 'consum', 0.0221, 'lps'),
	(485962, 127, '2014-01-15 00:22:32.000000', 'consum', 0.0217, 'lps'),
	(485963, 127, '2014-01-15 00:22:33.000000', 'consum', 0.0212, 'lps'),
	(485964, 127, '2014-01-15 00:22:34.000000', 'consum', 0.0216, 'lps'),
	(485965, 127, '2014-01-15 00:22:35.000000', 'consum', 0.0218, 'lps'),
	(485966, 127, '2014-01-15 00:22:36.000000', 'consum', 0.0215, 'lps'),
	(485967, 127, '2014-01-15 00:22:37.000000', 'consum', 0.0212, 'lps'),
	(485968, 127, '2014-01-15 00:22:38.000000', 'consum', 0.0221, 'lps'),
	(485969, 127, '2014-01-15 00:22:39.000000', 'consum', 0.0210, 'lps'),
	(485970, 127, '2014-01-15 00:22:40.000000', 'consum', 0.0212, 'lps'),
	(485971, 127, '2014-01-15 00:22:41.000000', 'consum', 0.0218, 'lps'),
	(485972, 127, '2014-01-15 00:22:42.000000', 'consum', 0.0211, 'lps'),
	(485973, 127, '2014-01-15 00:22:43.000000', 'consum', 0.0226, 'lps'),
	(485974, 127, '2014-01-15 00:22:44.000000', 'consum', 0.0218, 'lps'),
	(485975, 127, '2014-01-15 00:22:45.000000', 'consum', 0.0219, 'lps'),
	(485976, 127, '2014-01-15 00:22:46.000000', 'consum', 0.0215, 'lps'),
	(485977, 127, '2014-01-15 00:22:47.000000', 'consum', 0.0225, 'lps'),
	(485978, 127, '2014-01-15 00:22:48.000000', 'consum', 0.0220, 'lps'),
	(485979, 127, '2014-01-15 00:22:49.000000', 'consum', 0.0217, 'lps'),
	(485980, 127, '2014-01-15 00:22:50.000000', 'consum', 0.0213, 'lps'),
	(485981, 127, '2014-01-15 00:22:51.000000', 'consum', 0.0221, 'lps'),
	(485982, 127, '2014-01-15 00:22:52.000000', 'consum', 0.0222, 'lps'),
	(485983, 127, '2014-01-15 00:22:53.000000', 'consum', 0.0221, 'lps'),
	(485984, 127, '2014-01-15 00:22:54.000000', 'consum', 0.0211, 'lps'),
	(485985, 127, '2014-01-15 00:22:55.000000', 'consum', 0.0218, 'lps'),
	(485986, 127, '2014-01-15 00:22:56.000000', 'consum', 0.0215, 'lps'),
	(485987, 127, '2014-01-15 00:22:57.000000', 'consum', 0.0210, 'lps'),
	(485988, 127, '2014-01-15 00:22:58.000000', 'consum', 0.0214, 'lps'),
	(485989, 127, '2014-01-15 00:22:59.000000', 'consum', 0.0213, 'lps'),
	(485990, 127, '2014-01-15 00:23:00.000000', 'consum', 0.0215, 'lps'),
	(485991, 127, '2014-01-15 00:23:01.000000', 'consum', 0.0210, 'lps'),
	(485992, 127, '2014-01-15 00:23:02.000000', 'consum', 0.0226, 'lps'),
	(485993, 127, '2014-01-15 00:23:03.000000', 'consum', 0.0226, 'lps'),
	(485994, 127, '2014-01-15 00:23:04.000000', 'consum', 0.0223, 'lps'),
	(485995, 127, '2014-01-15 00:23:05.000000', 'consum', 0.0226, 'lps'),
	(485996, 127, '2014-01-15 00:23:06.000000', 'consum', 0.0221, 'lps'),
	(485997, 127, '2014-01-15 00:23:07.000000', 'consum', 0.0215, 'lps'),
	(485998, 127, '2014-01-15 00:23:08.000000', 'consum', 0.0220, 'lps'),
	(485999, 127, '2014-01-15 00:23:09.000000', 'consum', 0.0211, 'lps'),
	(486000, 127, '2014-01-15 00:23:10.000000', 'consum', 0.0222, 'lps'),
	(486001, 127, '2014-01-15 00:23:11.000000', 'consum', 0.0214, 'lps'),
	(486002, 127, '2014-01-15 00:23:12.000000', 'consum', 0.0210, 'lps'),
	(486003, 127, '2014-01-15 00:23:13.000000', 'consum', 0.0219, 'lps'),
	(486004, 127, '2014-01-15 00:23:14.000000', 'consum', 0.0219, 'lps'),
	(486005, 127, '2014-01-15 00:23:15.000000', 'consum', 0.0212, 'lps'),
	(486006, 127, '2014-01-15 00:23:16.000000', 'consum', 0.0226, 'lps'),
	(486007, 127, '2014-01-15 00:23:17.000000', 'consum', 0.0219, 'lps'),
	(486008, 127, '2014-01-15 00:23:18.000000', 'consum', 0.0224, 'lps'),
	(486009, 127, '2014-01-15 00:23:19.000000', 'consum', 0.0219, 'lps'),
	(486010, 127, '2014-01-15 00:23:20.000000', 'consum', 0.0214, 'lps'),
	(486011, 127, '2014-01-15 00:23:21.000000', 'consum', 0.0220, 'lps'),
	(486012, 127, '2014-01-15 00:23:22.000000', 'consum', 0.0216, 'lps'),
	(486013, 127, '2014-01-15 00:23:23.000000', 'consum', 0.0210, 'lps'),
	(486014, 127, '2014-01-15 00:23:24.000000', 'consum', 0.0211, 'lps'),
	(486015, 127, '2014-01-15 00:23:25.000000', 'consum', 0.0212, 'lps'),
	(486016, 127, '2014-01-15 00:23:26.000000', 'consum', 0.0221, 'lps'),
	(486017, 127, '2014-01-15 00:23:27.000000', 'consum', 0.0225, 'lps'),
	(486018, 127, '2014-01-15 00:23:28.000000', 'consum', 0.0216, 'lps'),
	(486019, 127, '2014-01-15 00:23:29.000000', 'consum', 0.0214, 'lps'),
	(486020, 127, '2014-01-15 00:23:30.000000', 'consum', 0.0211, 'lps'),
	(486021, 127, '2014-01-15 00:23:31.000000', 'consum', 0.0223, 'lps'),
	(486022, 127, '2014-01-15 00:23:32.000000', 'consum', 0.0219, 'lps'),
	(486023, 127, '2014-01-15 00:23:33.000000', 'consum', 0.0216, 'lps'),
	(486024, 127, '2014-01-15 00:23:34.000000', 'consum', 0.0215, 'lps'),
	(486025, 127, '2014-01-15 00:23:35.000000', 'consum', 0.0217, 'lps'),
	(486026, 127, '2014-01-15 00:23:36.000000', 'consum', 0.0215, 'lps'),
	(486027, 127, '2014-01-15 00:23:37.000000', 'consum', 0.0214, 'lps'),
	(486028, 127, '2014-01-15 00:23:38.000000', 'consum', 0.0216, 'lps'),
	(486029, 127, '2014-01-15 00:23:39.000000', 'consum', 0.0210, 'lps'),
	(486030, 127, '2014-01-15 00:23:40.000000', 'consum', 0.0211, 'lps'),
	(486031, 127, '2014-01-15 00:23:41.000000', 'consum', 0.0216, 'lps'),
	(486032, 127, '2014-01-15 00:23:42.000000', 'consum', 0.0218, 'lps'),
	(486033, 127, '2014-01-15 00:23:43.000000', 'consum', 0.0215, 'lps'),
	(486034, 127, '2014-01-15 00:23:44.000000', 'consum', 0.0213, 'lps'),
	(486035, 127, '2014-01-15 00:23:45.000000', 'consum', 0.0210, 'lps'),
	(486036, 127, '2014-01-15 00:23:46.000000', 'consum', 0.0221, 'lps'),
	(486037, 127, '2014-01-15 00:23:47.000000', 'consum', 0.0211, 'lps'),
	(486038, 127, '2014-01-15 00:23:48.000000', 'consum', 0.0218, 'lps'),
	(486039, 127, '2014-01-15 00:23:49.000000', 'consum', 0.0212, 'lps'),
	(486040, 127, '2014-01-15 00:23:50.000000', 'consum', 0.0215, 'lps'),
	(486041, 127, '2014-01-15 00:23:51.000000', 'consum', 0.0213, 'lps'),
	(486042, 127, '2014-01-15 00:23:52.000000', 'consum', 0.0211, 'lps'),
	(486043, 127, '2014-01-15 00:23:53.000000', 'consum', 0.0223, 'lps'),
	(486044, 127, '2014-01-15 00:23:54.000000', 'consum', 0.0222, 'lps'),
	(486045, 127, '2014-01-15 00:23:55.000000', 'consum', 0.0215, 'lps'),
	(486046, 127, '2014-01-15 00:23:56.000000', 'consum', 0.0215, 'lps'),
	(486047, 127, '2014-01-15 00:23:57.000000', 'consum', 0.0219, 'lps'),
	(486048, 127, '2014-01-15 00:23:58.000000', 'consum', 0.0225, 'lps'),
	(486049, 127, '2014-01-15 00:23:59.000000', 'consum', 0.0224, 'lps'),
	(486050, 127, '2014-01-15 00:24:00.000000', 'consum', 0.0218, 'lps'),
	(486051, 127, '2014-01-15 00:24:01.000000', 'consum', 0.0225, 'lps'),
	(486052, 127, '2014-01-15 00:24:02.000000', 'consum', 0.0210, 'lps'),
	(486053, 127, '2014-01-15 00:24:03.000000', 'consum', 0.0216, 'lps'),
	(486054, 127, '2014-01-15 00:24:04.000000', 'consum', 0.0226, 'lps'),
	(486055, 127, '2014-01-15 00:24:05.000000', 'consum', 0.0222, 'lps'),
	(486056, 127, '2014-01-15 00:24:06.000000', 'consum', 0.0221, 'lps'),
	(486057, 127, '2014-01-15 00:24:07.000000', 'consum', 0.0214, 'lps'),
	(486058, 127, '2014-01-15 00:24:08.000000', 'consum', 0.0212, 'lps'),
	(486059, 127, '2014-01-15 00:24:09.000000', 'consum', 0.0210, 'lps'),
	(486060, 127, '2014-01-15 00:24:10.000000', 'consum', 0.0222, 'lps'),
	(486061, 127, '2014-01-15 00:24:11.000000', 'consum', 0.0221, 'lps'),
	(486062, 127, '2014-01-15 00:24:12.000000', 'consum', 0.0210, 'lps'),
	(486063, 127, '2014-01-15 00:24:13.000000', 'consum', 0.0214, 'lps'),
	(486064, 127, '2014-01-15 00:24:14.000000', 'consum', 0.0213, 'lps'),
	(486065, 127, '2014-01-15 00:24:15.000000', 'consum', 0.0212, 'lps'),
	(486066, 127, '2014-01-15 00:24:16.000000', 'consum', 0.0213, 'lps'),
	(486067, 127, '2014-01-15 00:24:17.000000', 'consum', 0.0220, 'lps'),
	(486068, 127, '2014-01-15 00:24:18.000000', 'consum', 0.0216, 'lps'),
	(486069, 127, '2014-01-15 00:24:19.000000', 'consum', 0.0212, 'lps'),
	(486070, 127, '2014-01-15 00:24:20.000000', 'consum', 0.0218, 'lps'),
	(486071, 127, '2014-01-15 00:24:21.000000', 'consum', 0.0212, 'lps'),
	(486072, 127, '2014-01-15 00:24:22.000000', 'consum', 0.0212, 'lps'),
	(486073, 127, '2014-01-15 00:24:23.000000', 'consum', 0.0216, 'lps'),
	(486074, 127, '2014-01-15 00:24:24.000000', 'consum', 0.0216, 'lps'),
	(486075, 127, '2014-01-15 00:24:25.000000', 'consum', 0.0223, 'lps'),
	(486076, 127, '2014-01-15 00:24:26.000000', 'consum', 0.0224, 'lps'),
	(486077, 127, '2014-01-15 00:24:27.000000', 'consum', 0.0225, 'lps'),
	(486078, 127, '2014-01-15 00:24:28.000000', 'consum', 0.0211, 'lps'),
	(486079, 127, '2014-01-15 00:24:29.000000', 'consum', 0.0219, 'lps'),
	(486080, 127, '2014-01-15 00:24:30.000000', 'consum', 0.0219, 'lps'),
	(486081, 127, '2014-01-15 00:24:31.000000', 'consum', 0.0212, 'lps'),
	(486082, 127, '2014-01-15 00:24:32.000000', 'consum', 0.0210, 'lps'),
	(486083, 127, '2014-01-15 00:24:33.000000', 'consum', 0.0223, 'lps'),
	(486084, 127, '2014-01-15 00:24:34.000000', 'consum', 0.0224, 'lps'),
	(486085, 127, '2014-01-15 00:24:35.000000', 'consum', 0.0224, 'lps'),
	(486086, 127, '2014-01-15 00:24:36.000000', 'consum', 0.0223, 'lps'),
	(486087, 127, '2014-01-15 00:24:37.000000', 'consum', 0.0217, 'lps'),
	(486088, 127, '2014-01-15 00:24:38.000000', 'consum', 0.0221, 'lps'),
	(486089, 127, '2014-01-15 00:24:39.000000', 'consum', 0.0210, 'lps'),
	(486090, 127, '2014-01-15 00:24:40.000000', 'consum', 0.0213, 'lps'),
	(486091, 127, '2014-01-15 00:24:41.000000', 'consum', 0.0210, 'lps'),
	(486092, 127, '2014-01-15 00:24:42.000000', 'consum', 0.0216, 'lps'),
	(486093, 127, '2014-01-15 00:24:43.000000', 'consum', 0.0223, 'lps'),
	(486094, 127, '2014-01-15 00:24:44.000000', 'consum', 0.0225, 'lps'),
	(486095, 127, '2014-01-15 00:24:45.000000', 'consum', 0.0214, 'lps'),
	(486096, 127, '2014-01-15 00:24:46.000000', 'consum', 0.0217, 'lps'),
	(486097, 127, '2014-01-15 00:24:47.000000', 'consum', 0.0218, 'lps'),
	(486098, 127, '2014-01-15 00:24:48.000000', 'consum', 0.0210, 'lps'),
	(486099, 127, '2014-01-15 00:24:49.000000', 'consum', 0.0222, 'lps'),
	(486100, 127, '2014-01-15 00:24:50.000000', 'consum', 0.0220, 'lps'),
	(486101, 127, '2014-01-15 00:24:51.000000', 'consum', 0.0223, 'lps'),
	(486102, 127, '2014-01-15 00:24:52.000000', 'consum', 0.0210, 'lps'),
	(486103, 127, '2014-01-15 00:24:53.000000', 'consum', 0.0226, 'lps'),
	(486104, 127, '2014-01-15 00:24:54.000000', 'consum', 0.0221, 'lps'),
	(486105, 127, '2014-01-15 00:24:55.000000', 'consum', 0.0218, 'lps'),
	(486106, 127, '2014-01-15 00:24:56.000000', 'consum', 0.0218, 'lps'),
	(486107, 127, '2014-01-15 00:24:57.000000', 'consum', 0.0211, 'lps'),
	(486108, 127, '2014-01-15 00:24:58.000000', 'consum', 0.0223, 'lps'),
	(486109, 127, '2014-01-15 00:24:59.000000', 'consum', 0.0222, 'lps'),
	(486110, 127, '2014-01-15 00:25:00.000000', 'consum', 0.0215, 'lps'),
	(486111, 127, '2014-01-15 00:25:01.000000', 'consum', 0.0215, 'lps'),
	(486112, 127, '2014-01-15 00:25:02.000000', 'consum', 0.0222, 'lps'),
	(486113, 127, '2014-01-15 00:25:03.000000', 'consum', 0.0221, 'lps'),
	(486114, 127, '2014-01-15 00:25:04.000000', 'consum', 0.0214, 'lps'),
	(486115, 127, '2014-01-15 00:25:05.000000', 'consum', 0.0214, 'lps'),
	(486116, 127, '2014-01-15 00:25:06.000000', 'consum', 0.0218, 'lps'),
	(486117, 127, '2014-01-15 00:25:07.000000', 'consum', 0.0223, 'lps'),
	(486118, 127, '2014-01-15 00:25:08.000000', 'consum', 0.0216, 'lps'),
	(486119, 127, '2014-01-15 00:25:09.000000', 'consum', 0.0219, 'lps'),
	(486120, 127, '2014-01-15 00:25:10.000000', 'consum', 0.0221, 'lps'),
	(486121, 127, '2014-01-15 00:25:11.000000', 'consum', 0.0223, 'lps'),
	(486122, 127, '2014-01-15 00:25:12.000000', 'consum', 0.0222, 'lps'),
	(486123, 127, '2014-01-15 00:25:13.000000', 'consum', 0.0216, 'lps'),
	(486124, 127, '2014-01-15 00:25:14.000000', 'consum', 0.0223, 'lps'),
	(486125, 127, '2014-01-15 00:25:15.000000', 'consum', 0.0224, 'lps'),
	(486126, 127, '2014-01-15 00:25:16.000000', 'consum', 0.0224, 'lps'),
	(486127, 127, '2014-01-15 00:25:17.000000', 'consum', 0.0221, 'lps'),
	(486128, 127, '2014-01-15 00:25:18.000000', 'consum', 0.0225, 'lps'),
	(486129, 127, '2014-01-15 00:25:19.000000', 'consum', 0.0219, 'lps'),
	(486130, 127, '2014-01-15 00:25:20.000000', 'consum', 0.0225, 'lps'),
	(486131, 127, '2014-01-15 00:25:21.000000', 'consum', 0.0225, 'lps'),
	(486132, 127, '2014-01-15 00:25:22.000000', 'consum', 0.0224, 'lps'),
	(486133, 127, '2014-01-15 00:25:23.000000', 'consum', 0.0217, 'lps'),
	(486134, 127, '2014-01-15 00:25:24.000000', 'consum', 0.0223, 'lps'),
	(486135, 127, '2014-01-15 00:25:25.000000', 'consum', 0.0221, 'lps'),
	(486136, 127, '2014-01-15 00:25:26.000000', 'consum', 0.0210, 'lps'),
	(486137, 127, '2014-01-15 00:25:27.000000', 'consum', 0.0226, 'lps'),
	(486138, 127, '2014-01-15 00:25:28.000000', 'consum', 0.0225, 'lps'),
	(486139, 127, '2014-01-15 00:25:29.000000', 'consum', 0.0221, 'lps'),
	(486140, 127, '2014-01-15 00:25:30.000000', 'consum', 0.0221, 'lps'),
	(486141, 127, '2014-01-15 00:25:31.000000', 'consum', 0.0215, 'lps'),
	(486142, 127, '2014-01-15 00:25:32.000000', 'consum', 0.0220, 'lps'),
	(486143, 127, '2014-01-15 00:25:33.000000', 'consum', 0.0226, 'lps'),
	(486144, 127, '2014-01-15 00:25:34.000000', 'consum', 0.0211, 'lps'),
	(486145, 127, '2014-01-15 00:25:35.000000', 'consum', 0.0218, 'lps'),
	(486146, 127, '2014-01-15 00:25:36.000000', 'consum', 0.0214, 'lps'),
	(486147, 127, '2014-01-15 00:25:37.000000', 'consum', 0.0225, 'lps'),
	(486148, 127, '2014-01-15 00:25:38.000000', 'consum', 0.0222, 'lps'),
	(486149, 127, '2014-01-15 00:25:39.000000', 'consum', 0.0224, 'lps'),
	(486150, 127, '2014-01-15 00:25:40.000000', 'consum', 0.0213, 'lps'),
	(486151, 127, '2014-01-15 00:25:41.000000', 'consum', 0.0217, 'lps'),
	(486152, 127, '2014-01-15 00:25:42.000000', 'consum', 0.0218, 'lps'),
	(486153, 127, '2014-01-15 00:25:43.000000', 'consum', 0.0215, 'lps'),
	(486154, 127, '2014-01-15 00:25:44.000000', 'consum', 0.0225, 'lps'),
	(486155, 127, '2014-01-15 00:25:45.000000', 'consum', 0.0221, 'lps'),
	(486156, 127, '2014-01-15 00:25:46.000000', 'consum', 0.0222, 'lps'),
	(486157, 127, '2014-01-15 00:25:47.000000', 'consum', 0.0221, 'lps'),
	(486158, 127, '2014-01-15 00:25:48.000000', 'consum', 0.0212, 'lps'),
	(486159, 127, '2014-01-15 00:25:49.000000', 'consum', 0.0223, 'lps'),
	(486160, 127, '2014-01-15 00:25:50.000000', 'consum', 0.0216, 'lps'),
	(486161, 127, '2014-01-15 00:25:51.000000', 'consum', 0.0220, 'lps'),
	(486162, 127, '2014-01-15 00:25:52.000000', 'consum', 0.0226, 'lps'),
	(486163, 127, '2014-01-15 00:25:53.000000', 'consum', 0.0225, 'lps'),
	(486164, 127, '2014-01-15 00:25:54.000000', 'consum', 0.0223, 'lps'),
	(486165, 127, '2014-01-15 00:25:55.000000', 'consum', 0.0213, 'lps'),
	(486166, 127, '2014-01-15 00:25:56.000000', 'consum', 0.0220, 'lps'),
	(486167, 127, '2014-01-15 00:25:57.000000', 'consum', 0.0219, 'lps'),
	(486168, 127, '2014-01-15 00:25:58.000000', 'consum', 0.0223, 'lps'),
	(486169, 127, '2014-01-15 00:25:59.000000', 'consum', 0.0217, 'lps'),
	(486170, 127, '2014-01-15 00:26:00.000000', 'consum', 0.0222, 'lps'),
	(486171, 127, '2014-01-15 00:26:01.000000', 'consum', 0.0218, 'lps'),
	(486172, 127, '2014-01-15 00:26:02.000000', 'consum', 0.0212, 'lps'),
	(486173, 127, '2014-01-15 00:26:03.000000', 'consum', 0.0216, 'lps'),
	(486174, 127, '2014-01-15 00:26:04.000000', 'consum', 0.0217, 'lps'),
	(486175, 127, '2014-01-15 00:26:05.000000', 'consum', 0.0211, 'lps'),
	(486176, 127, '2014-01-15 00:26:06.000000', 'consum', 0.0213, 'lps'),
	(486177, 127, '2014-01-15 00:26:07.000000', 'consum', 0.0219, 'lps'),
	(486178, 127, '2014-01-15 00:26:08.000000', 'consum', 0.0213, 'lps'),
	(486179, 127, '2014-01-15 00:26:09.000000', 'consum', 0.0217, 'lps'),
	(486180, 127, '2014-01-15 00:26:10.000000', 'consum', 0.0220, 'lps'),
	(486181, 127, '2014-01-15 00:26:11.000000', 'consum', 0.0222, 'lps'),
	(486182, 127, '2014-01-15 00:26:12.000000', 'consum', 0.0225, 'lps'),
	(486183, 127, '2014-01-15 00:26:13.000000', 'consum', 0.0213, 'lps'),
	(486184, 127, '2014-01-15 00:26:14.000000', 'consum', 0.0217, 'lps'),
	(486185, 127, '2014-01-15 00:26:15.000000', 'consum', 0.0217, 'lps'),
	(486186, 127, '2014-01-15 00:26:16.000000', 'consum', 0.0226, 'lps'),
	(486187, 127, '2014-01-15 00:26:17.000000', 'consum', 0.0219, 'lps'),
	(486188, 127, '2014-01-15 00:26:18.000000', 'consum', 0.0225, 'lps'),
	(486189, 127, '2014-01-15 00:26:19.000000', 'consum', 0.0226, 'lps'),
	(486190, 127, '2014-01-15 00:26:20.000000', 'consum', 0.0225, 'lps'),
	(486191, 127, '2014-01-15 00:26:21.000000', 'consum', 0.0223, 'lps'),
	(486192, 127, '2014-01-15 00:26:22.000000', 'consum', 0.0211, 'lps'),
	(486193, 127, '2014-01-15 00:26:23.000000', 'consum', 0.0210, 'lps'),
	(486194, 127, '2014-01-15 00:26:24.000000', 'consum', 0.0210, 'lps'),
	(486195, 127, '2014-01-15 00:26:25.000000', 'consum', 0.0210, 'lps'),
	(486196, 127, '2014-01-15 00:26:26.000000', 'consum', 0.0225, 'lps'),
	(486197, 127, '2014-01-15 00:26:27.000000', 'consum', 0.0221, 'lps'),
	(486198, 127, '2014-01-15 00:26:28.000000', 'consum', 0.0219, 'lps'),
	(486199, 127, '2014-01-15 00:26:29.000000', 'consum', 0.0224, 'lps'),
	(486200, 127, '2014-01-15 00:26:30.000000', 'consum', 0.0218, 'lps'),
	(486201, 127, '2014-01-15 00:26:31.000000', 'consum', 0.0210, 'lps'),
	(486202, 127, '2014-01-15 00:26:32.000000', 'consum', 0.0221, 'lps'),
	(486203, 127, '2014-01-15 00:26:33.000000', 'consum', 0.0212, 'lps'),
	(486204, 127, '2014-01-15 00:26:34.000000', 'consum', 0.0221, 'lps'),
	(486205, 127, '2014-01-15 00:26:35.000000', 'consum', 0.0225, 'lps'),
	(486206, 127, '2014-01-15 00:26:36.000000', 'consum', 0.0220, 'lps'),
	(486207, 127, '2014-01-15 00:26:37.000000', 'consum', 0.0217, 'lps'),
	(486208, 127, '2014-01-15 00:26:38.000000', 'consum', 0.0212, 'lps'),
	(486209, 127, '2014-01-15 00:26:39.000000', 'consum', 0.0219, 'lps'),
	(486210, 127, '2014-01-15 00:26:40.000000', 'consum', 0.0214, 'lps'),
	(486211, 127, '2014-01-15 00:26:41.000000', 'consum', 0.0221, 'lps'),
	(486212, 127, '2014-01-15 00:26:42.000000', 'consum', 0.0219, 'lps'),
	(486213, 127, '2014-01-15 00:26:43.000000', 'consum', 0.0222, 'lps'),
	(486214, 127, '2014-01-15 00:26:44.000000', 'consum', 0.0212, 'lps'),
	(486215, 127, '2014-01-15 00:26:45.000000', 'consum', 0.0216, 'lps'),
	(486216, 127, '2014-01-15 00:26:46.000000', 'consum', 0.0217, 'lps'),
	(486217, 127, '2014-01-15 00:26:47.000000', 'consum', 0.0211, 'lps'),
	(486218, 127, '2014-01-15 00:26:48.000000', 'consum', 0.0212, 'lps'),
	(486219, 127, '2014-01-15 00:26:49.000000', 'consum', 0.0219, 'lps'),
	(486220, 127, '2014-01-15 00:26:50.000000', 'consum', 0.0215, 'lps'),
	(486221, 127, '2014-01-15 00:26:51.000000', 'consum', 0.0225, 'lps'),
	(486222, 127, '2014-01-15 00:26:52.000000', 'consum', 0.0220, 'lps'),
	(486223, 127, '2014-01-15 00:26:53.000000', 'consum', 0.0215, 'lps'),
	(486224, 127, '2014-01-15 00:26:54.000000', 'consum', 0.0223, 'lps'),
	(486225, 127, '2014-01-15 00:26:55.000000', 'consum', 0.0211, 'lps'),
	(486226, 127, '2014-01-15 00:26:56.000000', 'consum', 0.0211, 'lps'),
	(486227, 127, '2014-01-15 00:26:57.000000', 'consum', 0.0210, 'lps'),
	(486228, 127, '2014-01-15 00:26:58.000000', 'consum', 0.0225, 'lps'),
	(486229, 127, '2014-01-15 00:26:59.000000', 'consum', 0.0216, 'lps'),
	(486230, 127, '2014-01-15 00:27:00.000000', 'consum', 0.0213, 'lps'),
	(486231, 127, '2014-01-15 00:27:01.000000', 'consum', 0.0223, 'lps'),
	(486232, 127, '2014-01-15 00:27:02.000000', 'consum', 0.0218, 'lps'),
	(486233, 127, '2014-01-15 00:27:03.000000', 'consum', 0.0226, 'lps'),
	(486234, 127, '2014-01-15 00:27:04.000000', 'consum', 0.0215, 'lps'),
	(486235, 127, '2014-01-15 00:27:05.000000', 'consum', 0.0223, 'lps'),
	(486236, 127, '2014-01-15 00:27:06.000000', 'consum', 0.0224, 'lps'),
	(486237, 127, '2014-01-15 00:27:07.000000', 'consum', 0.0211, 'lps'),
	(486238, 127, '2014-01-15 00:27:08.000000', 'consum', 0.0224, 'lps'),
	(486239, 127, '2014-01-15 00:27:09.000000', 'consum', 0.0225, 'lps'),
	(486240, 127, '2014-01-15 00:27:10.000000', 'consum', 0.0225, 'lps'),
	(486241, 127, '2014-01-15 00:27:11.000000', 'consum', 0.0226, 'lps'),
	(486242, 127, '2014-01-15 00:27:12.000000', 'consum', 0.0226, 'lps'),
	(486243, 127, '2014-01-15 00:27:13.000000', 'consum', 0.0212, 'lps'),
	(486244, 127, '2014-01-15 00:27:14.000000', 'consum', 0.0220, 'lps'),
	(486245, 127, '2014-01-15 00:27:15.000000', 'consum', 0.0223, 'lps'),
	(486246, 127, '2014-01-15 00:27:16.000000', 'consum', 0.0226, 'lps'),
	(486247, 127, '2014-01-15 00:27:17.000000', 'consum', 0.0220, 'lps'),
	(486248, 127, '2014-01-15 00:27:18.000000', 'consum', 0.0211, 'lps'),
	(486249, 127, '2014-01-15 00:27:19.000000', 'consum', 0.0219, 'lps'),
	(486250, 127, '2014-01-15 00:27:20.000000', 'consum', 0.0218, 'lps'),
	(486251, 127, '2014-01-15 00:27:21.000000', 'consum', 0.0223, 'lps'),
	(486252, 127, '2014-01-15 00:27:22.000000', 'consum', 0.0219, 'lps'),
	(486253, 127, '2014-01-15 00:27:23.000000', 'consum', 0.0216, 'lps'),
	(486254, 127, '2014-01-15 00:27:24.000000', 'consum', 0.0214, 'lps'),
	(486255, 127, '2014-01-15 00:27:25.000000', 'consum', 0.0212, 'lps'),
	(486256, 127, '2014-01-15 00:27:26.000000', 'consum', 0.0211, 'lps'),
	(486257, 127, '2014-01-15 00:27:27.000000', 'consum', 0.0223, 'lps'),
	(486258, 127, '2014-01-15 00:27:28.000000', 'consum', 0.0224, 'lps'),
	(486259, 127, '2014-01-15 00:27:29.000000', 'consum', 0.0224, 'lps'),
	(486260, 127, '2014-01-15 00:27:30.000000', 'consum', 0.0222, 'lps'),
	(486261, 127, '2014-01-15 00:27:31.000000', 'consum', 0.0212, 'lps'),
	(486262, 127, '2014-01-15 00:27:32.000000', 'consum', 0.0218, 'lps'),
	(486263, 127, '2014-01-15 00:27:33.000000', 'consum', 0.0212, 'lps'),
	(486264, 127, '2014-01-15 00:27:34.000000', 'consum', 0.0212, 'lps'),
	(486265, 127, '2014-01-15 00:27:35.000000', 'consum', 0.0214, 'lps'),
	(486266, 127, '2014-01-15 00:27:36.000000', 'consum', 0.0226, 'lps'),
	(486267, 127, '2014-01-15 00:27:37.000000', 'consum', 0.0226, 'lps'),
	(486268, 127, '2014-01-15 00:27:38.000000', 'consum', 0.0225, 'lps'),
	(486269, 127, '2014-01-15 00:27:39.000000', 'consum', 0.0220, 'lps'),
	(486270, 127, '2014-01-15 00:27:40.000000', 'consum', 0.0215, 'lps'),
	(486271, 127, '2014-01-15 00:27:41.000000', 'consum', 0.0225, 'lps'),
	(486272, 127, '2014-01-15 00:27:42.000000', 'consum', 0.0218, 'lps'),
	(486273, 127, '2014-01-15 00:27:43.000000', 'consum', 0.0221, 'lps'),
	(486274, 127, '2014-01-15 00:27:44.000000', 'consum', 0.0225, 'lps'),
	(486275, 127, '2014-01-15 00:27:45.000000', 'consum', 0.0221, 'lps'),
	(486276, 127, '2014-01-15 00:27:46.000000', 'consum', 0.0219, 'lps'),
	(486277, 127, '2014-01-15 00:27:47.000000', 'consum', 0.0223, 'lps'),
	(486278, 127, '2014-01-15 00:27:48.000000', 'consum', 0.0213, 'lps'),
	(486279, 127, '2014-01-15 00:27:49.000000', 'consum', 0.0223, 'lps'),
	(486280, 127, '2014-01-15 00:27:50.000000', 'consum', 0.0215, 'lps'),
	(486281, 127, '2014-01-15 00:27:51.000000', 'consum', 0.0214, 'lps'),
	(486282, 127, '2014-01-15 00:27:52.000000', 'consum', 0.0215, 'lps'),
	(486283, 127, '2014-01-15 00:27:53.000000', 'consum', 0.0225, 'lps'),
	(486284, 127, '2014-01-15 00:27:54.000000', 'consum', 0.0218, 'lps'),
	(486285, 127, '2014-01-15 00:27:55.000000', 'consum', 0.0223, 'lps'),
	(486286, 127, '2014-01-15 00:27:56.000000', 'consum', 0.0219, 'lps'),
	(486287, 127, '2014-01-15 00:27:57.000000', 'consum', 0.0213, 'lps'),
	(486288, 127, '2014-01-15 00:27:58.000000', 'consum', 0.0218, 'lps'),
	(486289, 127, '2014-01-15 00:27:59.000000', 'consum', 0.0226, 'lps'),
	(486290, 127, '2014-01-15 00:28:00.000000', 'consum', 0.0213, 'lps'),
	(486291, 127, '2014-01-15 00:28:01.000000', 'consum', 0.0212, 'lps'),
	(486292, 127, '2014-01-15 00:28:02.000000', 'consum', 0.0210, 'lps'),
	(486293, 127, '2014-01-15 00:28:03.000000', 'consum', 0.0223, 'lps'),
	(486294, 127, '2014-01-15 00:28:04.000000', 'consum', 0.0225, 'lps'),
	(486295, 127, '2014-01-15 00:28:05.000000', 'consum', 0.0210, 'lps'),
	(486296, 127, '2014-01-15 00:28:06.000000', 'consum', 0.0218, 'lps'),
	(486297, 127, '2014-01-15 00:28:07.000000', 'consum', 0.0216, 'lps'),
	(486298, 127, '2014-01-15 00:28:08.000000', 'consum', 0.0217, 'lps'),
	(486299, 127, '2014-01-15 00:28:09.000000', 'consum', 0.0212, 'lps'),
	(486300, 127, '2014-01-15 00:28:10.000000', 'consum', 0.0214, 'lps'),
	(486301, 127, '2014-01-15 00:28:11.000000', 'consum', 0.0224, 'lps'),
	(486302, 127, '2014-01-15 00:28:12.000000', 'consum', 0.0216, 'lps'),
	(486303, 127, '2014-01-15 00:28:13.000000', 'consum', 0.0219, 'lps'),
	(486304, 127, '2014-01-15 00:28:14.000000', 'consum', 0.0219, 'lps'),
	(486305, 127, '2014-01-15 00:28:15.000000', 'consum', 0.0213, 'lps'),
	(486306, 127, '2014-01-15 00:28:16.000000', 'consum', 0.0213, 'lps'),
	(486307, 127, '2014-01-15 00:28:17.000000', 'consum', 0.0217, 'lps'),
	(486308, 127, '2014-01-15 00:28:18.000000', 'consum', 0.0219, 'lps'),
	(486309, 127, '2014-01-15 00:28:19.000000', 'consum', 0.0219, 'lps'),
	(486310, 127, '2014-01-15 00:28:20.000000', 'consum', 0.0211, 'lps'),
	(486311, 127, '2014-01-15 00:28:21.000000', 'consum', 0.0222, 'lps'),
	(486312, 127, '2014-01-15 00:28:22.000000', 'consum', 0.0218, 'lps'),
	(486313, 127, '2014-01-15 00:28:23.000000', 'consum', 0.0213, 'lps'),
	(486314, 127, '2014-01-15 00:28:24.000000', 'consum', 0.0221, 'lps'),
	(486315, 127, '2014-01-15 00:28:25.000000', 'consum', 0.0220, 'lps'),
	(486316, 127, '2014-01-15 00:28:26.000000', 'consum', 0.0211, 'lps'),
	(486317, 127, '2014-01-15 00:28:27.000000', 'consum', 0.0221, 'lps'),
	(486318, 127, '2014-01-15 00:28:28.000000', 'consum', 0.0210, 'lps'),
	(486319, 127, '2014-01-15 00:28:29.000000', 'consum', 0.0213, 'lps'),
	(486320, 127, '2014-01-15 00:28:30.000000', 'consum', 0.0226, 'lps'),
	(486321, 127, '2014-01-15 00:28:31.000000', 'consum', 0.0211, 'lps'),
	(486322, 127, '2014-01-15 00:28:32.000000', 'consum', 0.0221, 'lps'),
	(486323, 127, '2014-01-15 00:28:33.000000', 'consum', 0.0226, 'lps'),
	(486324, 127, '2014-01-15 00:28:34.000000', 'consum', 0.0226, 'lps'),
	(486325, 127, '2014-01-15 00:28:35.000000', 'consum', 0.0225, 'lps'),
	(486326, 127, '2014-01-15 00:28:36.000000', 'consum', 0.0220, 'lps'),
	(486327, 127, '2014-01-15 00:28:37.000000', 'consum', 0.0216, 'lps'),
	(486328, 127, '2014-01-15 00:28:38.000000', 'consum', 0.0212, 'lps'),
	(486329, 127, '2014-01-15 00:28:39.000000', 'consum', 0.0217, 'lps'),
	(486330, 127, '2014-01-15 00:28:40.000000', 'consum', 0.0223, 'lps'),
	(486331, 127, '2014-01-15 00:28:41.000000', 'consum', 0.0221, 'lps'),
	(486332, 127, '2014-01-15 00:28:42.000000', 'consum', 0.0211, 'lps'),
	(486333, 127, '2014-01-15 00:28:43.000000', 'consum', 0.0215, 'lps'),
	(486334, 127, '2014-01-15 00:28:44.000000', 'consum', 0.0214, 'lps'),
	(486335, 127, '2014-01-15 00:28:45.000000', 'consum', 0.0217, 'lps'),
	(486336, 127, '2014-01-15 00:28:46.000000', 'consum', 0.0214, 'lps'),
	(486337, 127, '2014-01-15 00:28:47.000000', 'consum', 0.0213, 'lps'),
	(486338, 127, '2014-01-15 00:28:48.000000', 'consum', 0.0211, 'lps'),
	(486339, 127, '2014-01-15 00:28:49.000000', 'consum', 0.0224, 'lps'),
	(486340, 127, '2014-01-15 00:28:50.000000', 'consum', 0.0225, 'lps'),
	(486341, 127, '2014-01-15 00:28:51.000000', 'consum', 0.0226, 'lps'),
	(486342, 127, '2014-01-15 00:28:52.000000', 'consum', 0.0213, 'lps'),
	(486343, 127, '2014-01-15 00:28:53.000000', 'consum', 0.0210, 'lps'),
	(486344, 127, '2014-01-15 00:28:54.000000', 'consum', 0.0220, 'lps'),
	(486345, 127, '2014-01-15 00:28:55.000000', 'consum', 0.0211, 'lps'),
	(486346, 127, '2014-01-15 00:28:56.000000', 'consum', 0.0217, 'lps'),
	(486347, 127, '2014-01-15 00:28:57.000000', 'consum', 0.0226, 'lps'),
	(486348, 127, '2014-01-15 00:28:58.000000', 'consum', 0.0219, 'lps'),
	(486349, 127, '2014-01-15 00:28:59.000000', 'consum', 0.0225, 'lps'),
	(486350, 127, '2014-01-15 00:29:00.000000', 'consum', 0.0224, 'lps'),
	(486351, 127, '2014-01-15 00:29:01.000000', 'consum', 0.0219, 'lps'),
	(486352, 127, '2014-01-15 00:29:02.000000', 'consum', 0.0212, 'lps'),
	(486353, 127, '2014-01-15 00:29:03.000000', 'consum', 0.0210, 'lps'),
	(486354, 127, '2014-01-15 00:29:04.000000', 'consum', 0.0224, 'lps'),
	(486355, 127, '2014-01-15 00:29:05.000000', 'consum', 0.0211, 'lps'),
	(486356, 127, '2014-01-15 00:29:06.000000', 'consum', 0.0224, 'lps'),
	(486357, 127, '2014-01-15 00:29:07.000000', 'consum', 0.0210, 'lps'),
	(486358, 127, '2014-01-15 00:29:08.000000', 'consum', 0.0219, 'lps'),
	(486359, 127, '2014-01-15 00:29:09.000000', 'consum', 0.0223, 'lps'),
	(486360, 127, '2014-01-15 00:29:10.000000', 'consum', 0.0215, 'lps'),
	(486361, 127, '2014-01-15 00:29:11.000000', 'consum', 0.0213, 'lps'),
	(486362, 127, '2014-01-15 00:29:12.000000', 'consum', 0.0212, 'lps'),
	(486363, 127, '2014-01-15 00:29:13.000000', 'consum', 0.0212, 'lps'),
	(486364, 127, '2014-01-15 00:29:14.000000', 'consum', 0.0211, 'lps'),
	(486365, 127, '2014-01-15 00:29:15.000000', 'consum', 0.0212, 'lps'),
	(486366, 127, '2014-01-15 00:29:16.000000', 'consum', 0.0218, 'lps'),
	(486367, 127, '2014-01-15 00:29:17.000000', 'consum', 0.0210, 'lps'),
	(486368, 127, '2014-01-15 00:29:18.000000', 'consum', 0.0219, 'lps'),
	(486369, 127, '2014-01-15 00:29:19.000000', 'consum', 0.0222, 'lps'),
	(486370, 127, '2014-01-15 00:29:20.000000', 'consum', 0.0225, 'lps'),
	(486371, 127, '2014-01-15 00:29:21.000000', 'consum', 0.0216, 'lps'),
	(486372, 127, '2014-01-15 00:29:22.000000', 'consum', 0.0212, 'lps'),
	(486373, 127, '2014-01-15 00:29:23.000000', 'consum', 0.0222, 'lps'),
	(486374, 127, '2014-01-15 00:29:24.000000', 'consum', 0.0210, 'lps'),
	(486375, 127, '2014-01-15 00:29:25.000000', 'consum', 0.0211, 'lps'),
	(486376, 127, '2014-01-15 00:29:26.000000', 'consum', 0.0213, 'lps'),
	(486377, 127, '2014-01-15 00:29:27.000000', 'consum', 0.0224, 'lps'),
	(486378, 127, '2014-01-15 00:29:28.000000', 'consum', 0.0219, 'lps'),
	(486379, 127, '2014-01-15 00:29:29.000000', 'consum', 0.0215, 'lps'),
	(486380, 127, '2014-01-15 00:29:30.000000', 'consum', 0.0225, 'lps'),
	(486381, 127, '2014-01-15 00:29:31.000000', 'consum', 0.0220, 'lps'),
	(486382, 127, '2014-01-15 00:29:32.000000', 'consum', 0.0216, 'lps'),
	(486383, 127, '2014-01-15 00:29:33.000000', 'consum', 0.0226, 'lps'),
	(486384, 127, '2014-01-15 00:29:34.000000', 'consum', 0.0220, 'lps'),
	(486385, 127, '2014-01-15 00:29:35.000000', 'consum', 0.0215, 'lps'),
	(486386, 127, '2014-01-15 00:29:36.000000', 'consum', 0.0223, 'lps'),
	(486387, 127, '2014-01-15 00:29:37.000000', 'consum', 0.0225, 'lps'),
	(486388, 127, '2014-01-15 00:29:38.000000', 'consum', 0.0211, 'lps'),
	(486389, 127, '2014-01-15 00:29:39.000000', 'consum', 0.0222, 'lps'),
	(486390, 127, '2014-01-15 00:29:40.000000', 'consum', 0.0219, 'lps'),
	(486391, 127, '2014-01-15 00:29:41.000000', 'consum', 0.0217, 'lps'),
	(486392, 127, '2014-01-15 00:29:42.000000', 'consum', 0.0218, 'lps'),
	(486393, 127, '2014-01-15 00:29:43.000000', 'consum', 0.0215, 'lps'),
	(486394, 127, '2014-01-15 00:29:44.000000', 'consum', 0.0210, 'lps'),
	(486395, 127, '2014-01-15 00:29:45.000000', 'consum', 0.0213, 'lps'),
	(486396, 127, '2014-01-15 00:29:46.000000', 'consum', 0.0224, 'lps'),
	(486397, 127, '2014-01-15 00:29:47.000000', 'consum', 0.0221, 'lps'),
	(486398, 127, '2014-01-15 00:29:48.000000', 'consum', 0.0226, 'lps'),
	(486399, 127, '2014-01-15 00:29:49.000000', 'consum', 0.0221, 'lps'),
	(486400, 127, '2014-01-15 00:29:50.000000', 'consum', 0.0217, 'lps'),
	(486401, 127, '2014-01-15 00:29:51.000000', 'consum', 0.0215, 'lps'),
	(486402, 127, '2014-01-15 00:29:52.000000', 'consum', 0.0212, 'lps'),
	(486403, 127, '2014-01-15 00:29:53.000000', 'consum', 0.0224, 'lps'),
	(486404, 127, '2014-01-15 00:29:54.000000', 'consum', 0.0223, 'lps'),
	(486405, 127, '2014-01-15 00:29:55.000000', 'consum', 0.0215, 'lps'),
	(486406, 127, '2014-01-15 00:29:56.000000', 'consum', 0.0215, 'lps'),
	(486407, 127, '2014-01-15 00:29:57.000000', 'consum', 0.0222, 'lps'),
	(486408, 127, '2014-01-15 00:29:58.000000', 'consum', 0.0219, 'lps'),
	(486409, 127, '2014-01-15 00:29:59.000000', 'consum', 0.0222, 'lps'),
	(486410, 127, '2014-01-15 00:30:00.000000', 'consum', 0.0223, 'lps'),
	(486411, 127, '2014-01-15 00:30:01.000000', 'consum', 0.0225, 'lps'),
	(486412, 127, '2014-01-15 00:30:02.000000', 'consum', 0.0214, 'lps'),
	(486413, 127, '2014-01-15 00:30:03.000000', 'consum', 0.0217, 'lps'),
	(486414, 127, '2014-01-15 00:30:04.000000', 'consum', 0.0217, 'lps'),
	(486415, 127, '2014-01-15 00:30:05.000000', 'consum', 0.0226, 'lps'),
	(486416, 127, '2014-01-15 00:30:06.000000', 'consum', 0.0219, 'lps'),
	(486417, 127, '2014-01-15 00:30:07.000000', 'consum', 0.0224, 'lps'),
	(486418, 127, '2014-01-15 00:30:08.000000', 'consum', 0.0217, 'lps'),
	(486419, 127, '2014-01-15 00:30:09.000000', 'consum', 0.0222, 'lps'),
	(486420, 127, '2014-01-15 00:30:10.000000', 'consum', 0.0216, 'lps'),
	(486421, 127, '2014-01-15 00:30:11.000000', 'consum', 0.0223, 'lps'),
	(486422, 127, '2014-01-15 00:30:12.000000', 'consum', 0.0221, 'lps'),
	(486423, 127, '2014-01-15 00:30:13.000000', 'consum', 0.0226, 'lps'),
	(486424, 127, '2014-01-15 00:30:14.000000', 'consum', 0.0226, 'lps'),
	(486425, 127, '2014-01-15 00:30:15.000000', 'consum', 0.0225, 'lps'),
	(486426, 127, '2014-01-15 00:30:16.000000', 'consum', 0.0219, 'lps'),
	(486427, 127, '2014-01-15 00:30:17.000000', 'consum', 0.0211, 'lps'),
	(486428, 127, '2014-01-15 00:30:18.000000', 'consum', 0.0223, 'lps'),
	(486429, 127, '2014-01-15 00:30:19.000000', 'consum', 0.0219, 'lps'),
	(486430, 127, '2014-01-15 00:30:20.000000', 'consum', 0.0220, 'lps'),
	(486431, 127, '2014-01-15 00:30:21.000000', 'consum', 0.0215, 'lps'),
	(486432, 127, '2014-01-15 00:30:22.000000', 'consum', 0.0223, 'lps'),
	(486433, 127, '2014-01-15 00:30:23.000000', 'consum', 0.0225, 'lps'),
	(486434, 127, '2014-01-15 00:30:24.000000', 'consum', 0.0215, 'lps'),
	(486435, 127, '2014-01-15 00:30:25.000000', 'consum', 0.0224, 'lps'),
	(486436, 127, '2014-01-15 00:30:26.000000', 'consum', 0.0215, 'lps'),
	(486437, 127, '2014-01-15 00:30:27.000000', 'consum', 0.0226, 'lps'),
	(486438, 127, '2014-01-15 00:30:28.000000', 'consum', 0.0225, 'lps'),
	(486439, 127, '2014-01-15 00:30:29.000000', 'consum', 0.0222, 'lps'),
	(486440, 127, '2014-01-15 00:30:30.000000', 'consum', 0.0223, 'lps'),
	(486441, 127, '2014-01-15 00:30:31.000000', 'consum', 0.0222, 'lps'),
	(486442, 127, '2014-01-15 00:30:32.000000', 'consum', 0.0214, 'lps'),
	(486443, 127, '2014-01-15 00:30:33.000000', 'consum', 0.0215, 'lps'),
	(486444, 127, '2014-01-15 00:30:34.000000', 'consum', 0.0221, 'lps'),
	(486445, 127, '2014-01-15 00:30:35.000000', 'consum', 0.0216, 'lps'),
	(486446, 127, '2014-01-15 00:30:36.000000', 'consum', 0.0224, 'lps'),
	(486447, 127, '2014-01-15 00:30:37.000000', 'consum', 0.0214, 'lps'),
	(486448, 127, '2014-01-15 00:30:38.000000', 'consum', 0.0222, 'lps'),
	(486449, 127, '2014-01-15 00:30:39.000000', 'consum', 0.0223, 'lps'),
	(486450, 127, '2014-01-15 00:30:40.000000', 'consum', 0.0222, 'lps'),
	(486451, 127, '2014-01-15 00:30:41.000000', 'consum', 0.0214, 'lps'),
	(486452, 127, '2014-01-15 00:30:42.000000', 'consum', 0.0211, 'lps'),
	(486453, 127, '2014-01-15 00:30:43.000000', 'consum', 0.0222, 'lps'),
	(486454, 127, '2014-01-15 00:30:44.000000', 'consum', 0.0214, 'lps'),
	(486455, 127, '2014-01-15 00:30:45.000000', 'consum', 0.0213, 'lps'),
	(486456, 127, '2014-01-15 00:30:46.000000', 'consum', 0.0215, 'lps'),
	(486457, 127, '2014-01-15 00:30:47.000000', 'consum', 0.0226, 'lps'),
	(486458, 127, '2014-01-15 00:30:48.000000', 'consum', 0.0224, 'lps'),
	(486459, 127, '2014-01-15 00:30:49.000000', 'consum', 0.0217, 'lps'),
	(486460, 127, '2014-01-15 00:30:50.000000', 'consum', 0.0217, 'lps'),
	(486461, 127, '2014-01-15 00:30:51.000000', 'consum', 0.0211, 'lps'),
	(486462, 127, '2014-01-15 00:30:52.000000', 'consum', 0.0211, 'lps'),
	(486463, 127, '2014-01-15 00:30:53.000000', 'consum', 0.0213, 'lps'),
	(486464, 127, '2014-01-15 00:30:54.000000', 'consum', 0.0223, 'lps'),
	(486465, 127, '2014-01-15 00:30:55.000000', 'consum', 0.0213, 'lps'),
	(486466, 127, '2014-01-15 00:30:56.000000', 'consum', 0.0223, 'lps'),
	(486467, 127, '2014-01-15 00:30:57.000000', 'consum', 0.0214, 'lps'),
	(486468, 127, '2014-01-15 00:30:58.000000', 'consum', 0.0210, 'lps'),
	(486469, 127, '2014-01-15 00:30:59.000000', 'consum', 0.0217, 'lps'),
	(486470, 127, '2014-01-15 00:31:00.000000', 'consum', 0.0225, 'lps'),
	(486471, 127, '2014-01-15 00:31:01.000000', 'consum', 0.0215, 'lps'),
	(486472, 127, '2014-01-15 00:31:02.000000', 'consum', 0.0224, 'lps'),
	(486473, 127, '2014-01-15 00:31:03.000000', 'consum', 0.0216, 'lps'),
	(486474, 127, '2014-01-15 00:31:04.000000', 'consum', 0.0213, 'lps'),
	(486475, 127, '2014-01-15 00:31:05.000000', 'consum', 0.0210, 'lps'),
	(486476, 127, '2014-01-15 00:31:06.000000', 'consum', 0.0217, 'lps'),
	(486477, 127, '2014-01-15 00:31:07.000000', 'consum', 0.0214, 'lps'),
	(486478, 127, '2014-01-15 00:31:08.000000', 'consum', 0.0223, 'lps'),
	(486479, 127, '2014-01-15 00:31:09.000000', 'consum', 0.0216, 'lps'),
	(486480, 127, '2014-01-15 00:31:10.000000', 'consum', 0.0216, 'lps'),
	(486481, 127, '2014-01-15 00:31:11.000000', 'consum', 0.0224, 'lps'),
	(486482, 127, '2014-01-15 00:31:12.000000', 'consum', 0.0226, 'lps'),
	(486483, 127, '2014-01-15 00:31:13.000000', 'consum', 0.0218, 'lps'),
	(486484, 127, '2014-01-15 00:31:14.000000', 'consum', 0.0217, 'lps'),
	(486485, 127, '2014-01-15 00:31:15.000000', 'consum', 0.0223, 'lps'),
	(486486, 127, '2014-01-15 00:31:16.000000', 'consum', 0.0221, 'lps'),
	(486487, 127, '2014-01-15 00:31:17.000000', 'consum', 0.0224, 'lps'),
	(486488, 127, '2014-01-15 00:31:18.000000', 'consum', 0.0215, 'lps'),
	(486489, 127, '2014-01-15 00:31:19.000000', 'consum', 0.0226, 'lps'),
	(486490, 127, '2014-01-15 00:31:20.000000', 'consum', 0.0226, 'lps'),
	(486491, 127, '2014-01-15 00:31:21.000000', 'consum', 0.0225, 'lps'),
	(486492, 127, '2014-01-15 00:31:22.000000', 'consum', 0.0219, 'lps'),
	(486493, 127, '2014-01-15 00:31:23.000000', 'consum', 0.0213, 'lps'),
	(486494, 127, '2014-01-15 00:31:24.000000', 'consum', 0.0214, 'lps'),
	(486495, 127, '2014-01-15 00:31:25.000000', 'consum', 0.0224, 'lps'),
	(486496, 127, '2014-01-15 00:31:26.000000', 'consum', 0.0216, 'lps'),
	(486497, 127, '2014-01-15 00:31:27.000000', 'consum', 0.0214, 'lps'),
	(486498, 127, '2014-01-15 00:31:28.000000', 'consum', 0.0212, 'lps'),
	(486499, 127, '2014-01-15 00:31:29.000000', 'consum', 0.0225, 'lps'),
	(486500, 127, '2014-01-15 00:31:30.000000', 'consum', 0.0214, 'lps'),
	(486501, 127, '2014-01-15 00:31:31.000000', 'consum', 0.0218, 'lps'),
	(486502, 127, '2014-01-15 00:31:32.000000', 'consum', 0.0223, 'lps'),
	(486503, 127, '2014-01-15 00:31:33.000000', 'consum', 0.0217, 'lps'),
	(486504, 127, '2014-01-15 00:31:34.000000', 'consum', 0.0223, 'lps'),
	(486505, 127, '2014-01-15 00:31:35.000000', 'consum', 0.0222, 'lps'),
	(486506, 127, '2014-01-15 00:31:36.000000', 'consum', 0.0216, 'lps'),
	(486507, 127, '2014-01-15 00:31:37.000000', 'consum', 0.0218, 'lps'),
	(486508, 127, '2014-01-15 00:31:38.000000', 'consum', 0.0216, 'lps'),
	(486509, 127, '2014-01-15 00:31:39.000000', 'consum', 0.0215, 'lps'),
	(486510, 127, '2014-01-15 00:31:40.000000', 'consum', 0.0219, 'lps'),
	(486511, 127, '2014-01-15 00:31:41.000000', 'consum', 0.0225, 'lps'),
	(486512, 127, '2014-01-15 00:31:42.000000', 'consum', 0.0225, 'lps'),
	(486513, 127, '2014-01-15 00:31:43.000000', 'consum', 0.0224, 'lps'),
	(486514, 127, '2014-01-15 00:31:44.000000', 'consum', 0.0216, 'lps'),
	(486515, 127, '2014-01-15 00:31:45.000000', 'consum', 0.0219, 'lps'),
	(486516, 127, '2014-01-15 00:31:46.000000', 'consum', 0.0217, 'lps'),
	(486517, 127, '2014-01-15 00:31:47.000000', 'consum', 0.0220, 'lps'),
	(486518, 127, '2014-01-15 00:31:48.000000', 'consum', 0.0222, 'lps'),
	(486519, 127, '2014-01-15 00:31:49.000000', 'consum', 0.0224, 'lps'),
	(486520, 127, '2014-01-15 00:31:50.000000', 'consum', 0.0212, 'lps'),
	(486521, 127, '2014-01-15 00:31:51.000000', 'consum', 0.0226, 'lps'),
	(486522, 127, '2014-01-15 00:31:52.000000', 'consum', 0.0219, 'lps'),
	(486523, 127, '2014-01-15 00:31:53.000000', 'consum', 0.0224, 'lps'),
	(486524, 127, '2014-01-15 00:31:54.000000', 'consum', 0.0220, 'lps'),
	(486525, 127, '2014-01-15 00:31:55.000000', 'consum', 0.0217, 'lps'),
	(486526, 127, '2014-01-15 00:31:56.000000', 'consum', 0.0216, 'lps'),
	(486527, 127, '2014-01-15 00:31:57.000000', 'consum', 0.0222, 'lps'),
	(486528, 127, '2014-01-15 00:31:58.000000', 'consum', 0.0215, 'lps'),
	(486529, 127, '2014-01-15 00:31:59.000000', 'consum', 0.0219, 'lps'),
	(486530, 127, '2014-01-15 00:32:00.000000', 'consum', 0.0224, 'lps'),
	(486531, 127, '2014-01-15 00:32:01.000000', 'consum', 0.0217, 'lps'),
	(486532, 127, '2014-01-15 00:32:02.000000', 'consum', 0.0222, 'lps'),
	(486533, 127, '2014-01-15 00:32:03.000000', 'consum', 0.0215, 'lps'),
	(486534, 127, '2014-01-15 00:32:04.000000', 'consum', 0.0215, 'lps'),
	(486535, 127, '2014-01-15 00:32:05.000000', 'consum', 0.0223, 'lps'),
	(486536, 127, '2014-01-15 00:32:06.000000', 'consum', 0.0225, 'lps'),
	(486537, 127, '2014-01-15 00:32:07.000000', 'consum', 0.0211, 'lps'),
	(486538, 127, '2014-01-15 00:32:08.000000', 'consum', 0.0223, 'lps'),
	(486539, 127, '2014-01-15 00:32:09.000000', 'consum', 0.0222, 'lps'),
	(486540, 127, '2014-01-15 00:32:10.000000', 'consum', 0.0216, 'lps'),
	(486541, 127, '2014-01-15 00:32:11.000000', 'consum', 0.0219, 'lps'),
	(486542, 127, '2014-01-15 00:32:12.000000', 'consum', 0.0221, 'lps'),
	(486543, 127, '2014-01-15 00:32:13.000000', 'consum', 0.0221, 'lps'),
	(486544, 127, '2014-01-15 00:32:14.000000', 'consum', 0.0214, 'lps'),
	(486545, 127, '2014-01-15 00:32:15.000000', 'consum', 0.0216, 'lps'),
	(486546, 127, '2014-01-15 00:32:16.000000', 'consum', 0.0212, 'lps'),
	(486547, 127, '2014-01-15 00:32:17.000000', 'consum', 0.0218, 'lps'),
	(486548, 127, '2014-01-15 00:32:18.000000', 'consum', 0.0210, 'lps'),
	(486549, 127, '2014-01-15 00:32:19.000000', 'consum', 0.0220, 'lps'),
	(486550, 127, '2014-01-15 00:32:20.000000', 'consum', 0.0210, 'lps'),
	(486551, 127, '2014-01-15 00:32:21.000000', 'consum', 0.0215, 'lps'),
	(486552, 127, '2014-01-15 00:32:22.000000', 'consum', 0.0217, 'lps'),
	(486553, 127, '2014-01-15 00:32:23.000000', 'consum', 0.0213, 'lps'),
	(486554, 127, '2014-01-15 00:32:24.000000', 'consum', 0.0224, 'lps'),
	(486555, 127, '2014-01-15 00:32:25.000000', 'consum', 0.0221, 'lps'),
	(486556, 127, '2014-01-15 00:32:26.000000', 'consum', 0.0221, 'lps'),
	(486557, 127, '2014-01-15 00:32:27.000000', 'consum', 0.0216, 'lps'),
	(486558, 127, '2014-01-15 00:32:28.000000', 'consum', 0.0226, 'lps'),
	(486559, 127, '2014-01-15 00:32:29.000000', 'consum', 0.0219, 'lps'),
	(486560, 127, '2014-01-15 00:32:30.000000', 'consum', 0.0226, 'lps'),
	(486561, 127, '2014-01-15 00:32:31.000000', 'consum', 0.0214, 'lps'),
	(486562, 127, '2014-01-15 00:32:32.000000', 'consum', 0.0214, 'lps'),
	(486563, 127, '2014-01-15 00:32:33.000000', 'consum', 0.0220, 'lps'),
	(486564, 127, '2014-01-15 00:32:34.000000', 'consum', 0.0213, 'lps'),
	(486565, 127, '2014-01-15 00:32:35.000000', 'consum', 0.0213, 'lps'),
	(486566, 127, '2014-01-15 00:32:36.000000', 'consum', 0.0218, 'lps'),
	(486567, 127, '2014-01-15 00:32:37.000000', 'consum', 0.0224, 'lps'),
	(486568, 127, '2014-01-15 00:32:38.000000', 'consum', 0.0222, 'lps'),
	(486569, 127, '2014-01-15 00:32:39.000000', 'consum', 0.0211, 'lps'),
	(486570, 127, '2014-01-15 00:32:40.000000', 'consum', 0.0214, 'lps'),
	(486571, 127, '2014-01-15 00:32:41.000000', 'consum', 0.0211, 'lps'),
	(486572, 127, '2014-01-15 00:32:42.000000', 'consum', 0.0222, 'lps'),
	(486573, 127, '2014-01-15 00:32:43.000000', 'consum', 0.0216, 'lps'),
	(486574, 127, '2014-01-15 00:32:44.000000', 'consum', 0.0220, 'lps'),
	(486575, 127, '2014-01-15 00:32:45.000000', 'consum', 0.0226, 'lps'),
	(486576, 127, '2014-01-15 00:32:46.000000', 'consum', 0.0211, 'lps'),
	(486577, 127, '2014-01-15 00:32:47.000000', 'consum', 0.0218, 'lps'),
	(486578, 127, '2014-01-15 00:32:48.000000', 'consum', 0.0211, 'lps'),
	(486579, 127, '2014-01-15 00:32:49.000000', 'consum', 0.0212, 'lps'),
	(486580, 127, '2014-01-15 00:32:50.000000', 'consum', 0.0216, 'lps'),
	(486581, 127, '2014-01-15 00:32:51.000000', 'consum', 0.0216, 'lps'),
	(486582, 127, '2014-01-15 00:32:52.000000', 'consum', 0.0225, 'lps'),
	(486583, 127, '2014-01-15 00:32:53.000000', 'consum', 0.0217, 'lps'),
	(486584, 127, '2014-01-15 00:32:54.000000', 'consum', 0.0214, 'lps'),
	(486585, 127, '2014-01-15 00:32:55.000000', 'consum', 0.0213, 'lps'),
	(486586, 127, '2014-01-15 00:32:56.000000', 'consum', 0.0213, 'lps'),
	(486587, 127, '2014-01-15 00:32:57.000000', 'consum', 0.0214, 'lps'),
	(486588, 127, '2014-01-15 00:32:58.000000', 'consum', 0.0223, 'lps'),
	(486589, 127, '2014-01-15 00:32:59.000000', 'consum', 0.0213, 'lps'),
	(486590, 127, '2014-01-15 00:33:00.000000', 'consum', 0.0222, 'lps'),
	(486591, 127, '2014-01-15 00:33:01.000000', 'consum', 0.0226, 'lps'),
	(486592, 127, '2014-01-15 00:33:02.000000', 'consum', 0.0219, 'lps'),
	(486593, 127, '2014-01-15 00:33:03.000000', 'consum', 0.0226, 'lps'),
	(486594, 127, '2014-01-15 00:33:04.000000', 'consum', 0.0210, 'lps'),
	(486595, 127, '2014-01-15 00:33:05.000000', 'consum', 0.0216, 'lps'),
	(486596, 127, '2014-01-15 00:33:06.000000', 'consum', 0.0223, 'lps'),
	(486597, 127, '2014-01-15 00:33:07.000000', 'consum', 0.0222, 'lps'),
	(486598, 127, '2014-01-15 00:33:08.000000', 'consum', 0.0216, 'lps'),
	(486599, 127, '2014-01-15 00:33:09.000000', 'consum', 0.0223, 'lps'),
	(486600, 127, '2014-01-15 00:33:10.000000', 'consum', 0.0222, 'lps'),
	(486601, 127, '2014-01-15 00:33:11.000000', 'consum', 0.0213, 'lps'),
	(486602, 127, '2014-01-15 00:33:12.000000', 'consum', 0.0226, 'lps'),
	(486603, 127, '2014-01-15 00:33:13.000000', 'consum', 0.0213, 'lps'),
	(486604, 127, '2014-01-15 00:33:14.000000', 'consum', 0.0213, 'lps'),
	(486605, 127, '2014-01-15 00:33:15.000000', 'consum', 0.0214, 'lps'),
	(486606, 127, '2014-01-15 00:33:16.000000', 'consum', 0.0224, 'lps'),
	(486607, 127, '2014-01-15 00:33:17.000000', 'consum', 0.0216, 'lps'),
	(486608, 127, '2014-01-15 00:33:18.000000', 'consum', 0.0218, 'lps'),
	(486609, 127, '2014-01-15 00:33:19.000000', 'consum', 0.0212, 'lps'),
	(486610, 127, '2014-01-15 00:33:20.000000', 'consum', 0.0217, 'lps'),
	(486611, 127, '2014-01-15 00:33:21.000000', 'consum', 0.0219, 'lps'),
	(486612, 127, '2014-01-15 00:33:22.000000', 'consum', 0.0221, 'lps'),
	(486613, 127, '2014-01-15 00:33:23.000000', 'consum', 0.0219, 'lps'),
	(486614, 127, '2014-01-15 00:33:24.000000', 'consum', 0.0222, 'lps'),
	(486615, 127, '2014-01-15 00:33:25.000000', 'consum', 0.0226, 'lps'),
	(486616, 127, '2014-01-15 00:33:26.000000', 'consum', 0.0220, 'lps'),
	(486617, 127, '2014-01-15 00:33:27.000000', 'consum', 0.0213, 'lps'),
	(486618, 127, '2014-01-15 00:33:28.000000', 'consum', 0.0212, 'lps'),
	(486619, 127, '2014-01-15 00:33:29.000000', 'consum', 0.0214, 'lps'),
	(486620, 127, '2014-01-15 00:33:30.000000', 'consum', 0.0222, 'lps'),
	(486621, 127, '2014-01-15 00:33:31.000000', 'consum', 0.0223, 'lps'),
	(486622, 127, '2014-01-15 00:33:32.000000', 'consum', 0.0225, 'lps'),
	(486623, 127, '2014-01-15 00:33:33.000000', 'consum', 0.0214, 'lps'),
	(486624, 127, '2014-01-15 00:33:34.000000', 'consum', 0.0216, 'lps'),
	(486625, 127, '2014-01-15 00:33:35.000000', 'consum', 0.0213, 'lps'),
	(486626, 127, '2014-01-15 00:33:36.000000', 'consum', 0.0223, 'lps'),
	(486627, 127, '2014-01-15 00:33:37.000000', 'consum', 0.0217, 'lps'),
	(486628, 127, '2014-01-15 00:33:38.000000', 'consum', 0.0224, 'lps'),
	(486629, 127, '2014-01-15 00:33:39.000000', 'consum', 0.0223, 'lps'),
	(486630, 127, '2014-01-15 00:33:40.000000', 'consum', 0.0219, 'lps'),
	(486631, 127, '2014-01-15 00:33:41.000000', 'consum', 0.0216, 'lps'),
	(486632, 127, '2014-01-15 00:33:42.000000', 'consum', 0.0212, 'lps'),
	(486633, 127, '2014-01-15 00:33:43.000000', 'consum', 0.0221, 'lps'),
	(486634, 127, '2014-01-15 00:33:44.000000', 'consum', 0.0225, 'lps'),
	(486635, 127, '2014-01-15 00:33:45.000000', 'consum', 0.0217, 'lps'),
	(486636, 127, '2014-01-15 00:33:46.000000', 'consum', 0.0220, 'lps'),
	(486637, 127, '2014-01-15 00:33:47.000000', 'consum', 0.0220, 'lps'),
	(486638, 127, '2014-01-15 00:33:48.000000', 'consum', 0.0217, 'lps'),
	(486639, 127, '2014-01-15 00:33:49.000000', 'consum', 0.0212, 'lps'),
	(486640, 127, '2014-01-15 00:33:50.000000', 'consum', 0.0217, 'lps'),
	(486641, 127, '2014-01-15 00:33:51.000000', 'consum', 0.0221, 'lps'),
	(486642, 127, '2014-01-15 00:33:52.000000', 'consum', 0.0213, 'lps'),
	(486643, 127, '2014-01-15 00:33:53.000000', 'consum', 0.0226, 'lps'),
	(486644, 127, '2014-01-15 00:33:54.000000', 'consum', 0.0213, 'lps'),
	(486645, 127, '2014-01-15 00:33:55.000000', 'consum', 0.0212, 'lps'),
	(486646, 127, '2014-01-15 00:33:56.000000', 'consum', 0.0211, 'lps'),
	(486647, 127, '2014-01-15 00:33:57.000000', 'consum', 0.0211, 'lps'),
	(486648, 127, '2014-01-15 00:33:58.000000', 'consum', 0.0210, 'lps'),
	(486649, 127, '2014-01-15 00:33:59.000000', 'consum', 0.0211, 'lps'),
	(486650, 127, '2014-01-15 00:34:00.000000', 'consum', 0.0212, 'lps'),
	(486651, 127, '2014-01-15 00:34:01.000000', 'consum', 0.0219, 'lps'),
	(486652, 127, '2014-01-15 00:34:02.000000', 'consum', 0.0217, 'lps'),
	(486653, 127, '2014-01-15 00:34:03.000000', 'consum', 0.0218, 'lps'),
	(486654, 127, '2014-01-15 00:34:04.000000', 'consum', 0.0212, 'lps'),
	(486655, 127, '2014-01-15 00:34:05.000000', 'consum', 0.0215, 'lps'),
	(486656, 127, '2014-01-15 00:34:06.000000', 'consum', 0.0211, 'lps'),
	(486657, 127, '2014-01-15 00:34:07.000000', 'consum', 0.0216, 'lps'),
	(486658, 127, '2014-01-15 00:34:08.000000', 'consum', 0.0224, 'lps'),
	(486659, 127, '2014-01-15 00:34:09.000000', 'consum', 0.0226, 'lps'),
	(486660, 127, '2014-01-15 00:34:10.000000', 'consum', 0.0214, 'lps'),
	(486661, 127, '2014-01-15 00:34:11.000000', 'consum', 0.0217, 'lps'),
	(486662, 127, '2014-01-15 00:34:12.000000', 'consum', 0.0215, 'lps'),
	(486663, 127, '2014-01-15 00:34:13.000000', 'consum', 0.0214, 'lps'),
	(486664, 127, '2014-01-15 00:34:14.000000', 'consum', 0.0219, 'lps'),
	(486665, 127, '2014-01-15 00:34:15.000000', 'consum', 0.0224, 'lps'),
	(486666, 127, '2014-01-15 00:34:16.000000', 'consum', 0.0221, 'lps'),
	(486667, 127, '2014-01-15 00:34:17.000000', 'consum', 0.0221, 'lps'),
	(486668, 127, '2014-01-15 00:34:18.000000', 'consum', 0.0216, 'lps'),
	(486669, 127, '2014-01-15 00:34:19.000000', 'consum', 0.0224, 'lps'),
	(486670, 127, '2014-01-15 00:34:20.000000', 'consum', 0.0211, 'lps'),
	(486671, 127, '2014-01-15 00:34:21.000000', 'consum', 0.0226, 'lps'),
	(486672, 127, '2014-01-15 00:34:22.000000', 'consum', 0.0218, 'lps'),
	(486673, 127, '2014-01-15 00:34:23.000000', 'consum', 0.0220, 'lps'),
	(486674, 127, '2014-01-15 00:34:24.000000', 'consum', 0.0218, 'lps'),
	(486675, 127, '2014-01-15 00:34:25.000000', 'consum', 0.0222, 'lps'),
	(486676, 127, '2014-01-15 00:34:26.000000', 'consum', 0.0212, 'lps'),
	(486677, 127, '2014-01-15 00:34:27.000000', 'consum', 0.0218, 'lps'),
	(486678, 127, '2014-01-15 00:34:28.000000', 'consum', 0.0210, 'lps'),
	(486679, 127, '2014-01-15 00:34:29.000000', 'consum', 0.0223, 'lps'),
	(486680, 127, '2014-01-15 00:34:30.000000', 'consum', 0.0221, 'lps'),
	(486681, 127, '2014-01-15 00:34:31.000000', 'consum', 0.0212, 'lps'),
	(486682, 127, '2014-01-15 00:34:32.000000', 'consum', 0.0221, 'lps'),
	(486683, 127, '2014-01-15 00:34:33.000000', 'consum', 0.0226, 'lps'),
	(486684, 127, '2014-01-15 00:34:34.000000', 'consum', 0.0224, 'lps'),
	(486685, 127, '2014-01-15 00:34:35.000000', 'consum', 0.0216, 'lps'),
	(486686, 127, '2014-01-15 00:34:36.000000', 'consum', 0.0216, 'lps'),
	(486687, 127, '2014-01-15 00:34:37.000000', 'consum', 0.0223, 'lps'),
	(486688, 127, '2014-01-15 00:34:38.000000', 'consum', 0.0221, 'lps'),
	(486689, 127, '2014-01-15 00:34:39.000000', 'consum', 0.0213, 'lps'),
	(486690, 127, '2014-01-15 00:34:40.000000', 'consum', 0.0223, 'lps'),
	(486691, 127, '2014-01-15 00:34:41.000000', 'consum', 0.0218, 'lps'),
	(486692, 127, '2014-01-15 00:34:42.000000', 'consum', 0.0210, 'lps'),
	(486693, 127, '2014-01-15 00:34:43.000000', 'consum', 0.0221, 'lps'),
	(486694, 127, '2014-01-15 00:34:44.000000', 'consum', 0.0214, 'lps'),
	(486695, 127, '2014-01-15 00:34:45.000000', 'consum', 0.0214, 'lps'),
	(486696, 127, '2014-01-15 00:34:46.000000', 'consum', 0.0218, 'lps'),
	(486697, 127, '2014-01-15 00:34:47.000000', 'consum', 0.0222, 'lps'),
	(486698, 127, '2014-01-15 00:34:48.000000', 'consum', 0.0214, 'lps'),
	(486699, 127, '2014-01-15 00:34:49.000000', 'consum', 0.0212, 'lps'),
	(486700, 127, '2014-01-15 00:34:50.000000', 'consum', 0.0224, 'lps'),
	(486701, 127, '2014-01-15 00:34:51.000000', 'consum', 0.0225, 'lps'),
	(486702, 127, '2014-01-15 00:34:52.000000', 'consum', 0.0224, 'lps'),
	(486703, 127, '2014-01-15 00:34:53.000000', 'consum', 0.0219, 'lps'),
	(486704, 127, '2014-01-15 00:34:54.000000', 'consum', 0.0216, 'lps'),
	(486705, 127, '2014-01-15 00:34:55.000000', 'consum', 0.0210, 'lps'),
	(486706, 127, '2014-01-15 00:34:56.000000', 'consum', 0.0213, 'lps'),
	(486707, 127, '2014-01-15 00:34:57.000000', 'consum', 0.0223, 'lps'),
	(486708, 127, '2014-01-15 00:34:58.000000', 'consum', 0.0214, 'lps'),
	(486709, 127, '2014-01-15 00:34:59.000000', 'consum', 0.0212, 'lps'),
	(486710, 127, '2014-01-15 00:35:00.000000', 'consum', 0.0224, 'lps'),
	(486711, 127, '2014-01-15 00:35:01.000000', 'consum', 0.0224, 'lps'),
	(486712, 127, '2014-01-15 00:35:02.000000', 'consum', 0.0223, 'lps'),
	(486713, 127, '2014-01-15 00:35:03.000000', 'consum', 0.0215, 'lps'),
	(486714, 127, '2014-01-15 00:35:04.000000', 'consum', 0.0214, 'lps'),
	(486715, 127, '2014-01-15 00:35:05.000000', 'consum', 0.0215, 'lps'),
	(486716, 127, '2014-01-15 00:35:06.000000', 'consum', 0.0224, 'lps'),
	(486717, 127, '2014-01-15 00:35:07.000000', 'consum', 0.0213, 'lps'),
	(486718, 127, '2014-01-15 00:35:08.000000', 'consum', 0.0220, 'lps'),
	(486719, 127, '2014-01-15 00:35:09.000000', 'consum', 0.0215, 'lps'),
	(486720, 127, '2014-01-15 00:35:10.000000', 'consum', 0.0225, 'lps'),
	(486721, 127, '2014-01-15 00:35:11.000000', 'consum', 0.0220, 'lps'),
	(486722, 127, '2014-01-15 00:35:12.000000', 'consum', 0.0213, 'lps'),
	(486723, 127, '2014-01-15 00:35:13.000000', 'consum', 0.0212, 'lps'),
	(486724, 127, '2014-01-15 00:35:14.000000', 'consum', 0.0213, 'lps'),
	(486725, 127, '2014-01-15 00:35:15.000000', 'consum', 0.0219, 'lps'),
	(486726, 127, '2014-01-15 00:35:16.000000', 'consum', 0.0214, 'lps'),
	(486727, 127, '2014-01-15 00:35:17.000000', 'consum', 0.0218, 'lps'),
	(486728, 127, '2014-01-15 00:35:18.000000', 'consum', 0.0220, 'lps'),
	(486729, 127, '2014-01-15 00:35:19.000000', 'consum', 0.0223, 'lps'),
	(486730, 127, '2014-01-15 00:35:20.000000', 'consum', 0.0211, 'lps'),
	(486731, 127, '2014-01-15 00:35:21.000000', 'consum', 0.0212, 'lps'),
	(486732, 127, '2014-01-15 00:35:22.000000', 'consum', 0.0214, 'lps'),
	(486733, 127, '2014-01-15 00:35:23.000000', 'consum', 0.0211, 'lps'),
	(486734, 127, '2014-01-15 00:35:24.000000', 'consum', 0.0218, 'lps'),
	(486735, 127, '2014-01-15 00:35:25.000000', 'consum', 0.0215, 'lps'),
	(486736, 127, '2014-01-15 00:35:26.000000', 'consum', 0.0211, 'lps'),
	(486737, 127, '2014-01-15 00:35:27.000000', 'consum', 0.0218, 'lps'),
	(486738, 127, '2014-01-15 00:35:28.000000', 'consum', 0.0213, 'lps'),
	(486739, 127, '2014-01-15 00:35:29.000000', 'consum', 0.0220, 'lps'),
	(486740, 127, '2014-01-15 00:35:30.000000', 'consum', 0.0215, 'lps'),
	(486741, 127, '2014-01-15 00:35:31.000000', 'consum', 0.0225, 'lps'),
	(486742, 127, '2014-01-15 00:35:32.000000', 'consum', 0.0217, 'lps'),
	(486743, 127, '2014-01-15 00:35:33.000000', 'consum', 0.0218, 'lps'),
	(486744, 127, '2014-01-15 00:35:34.000000', 'consum', 0.0213, 'lps'),
	(486745, 127, '2014-01-15 00:35:35.000000', 'consum', 0.0220, 'lps'),
	(486746, 127, '2014-01-15 00:35:36.000000', 'consum', 0.0218, 'lps'),
	(486747, 127, '2014-01-15 00:35:37.000000', 'consum', 0.0218, 'lps'),
	(486748, 127, '2014-01-15 00:35:38.000000', 'consum', 0.0210, 'lps'),
	(486749, 127, '2014-01-15 00:35:39.000000', 'consum', 0.0220, 'lps'),
	(486750, 127, '2014-01-15 00:35:40.000000', 'consum', 0.0212, 'lps'),
	(486751, 127, '2014-01-15 00:35:41.000000', 'consum', 0.0224, 'lps'),
	(486752, 127, '2014-01-15 00:35:42.000000', 'consum', 0.0223, 'lps'),
	(486753, 127, '2014-01-15 00:35:43.000000', 'consum', 0.0215, 'lps'),
	(486754, 127, '2014-01-15 00:35:44.000000', 'consum', 0.0214, 'lps'),
	(486755, 127, '2014-01-15 00:35:45.000000', 'consum', 0.0216, 'lps'),
	(486756, 127, '2014-01-15 00:35:46.000000', 'consum', 0.0213, 'lps'),
	(486757, 127, '2014-01-15 00:35:47.000000', 'consum', 0.0225, 'lps'),
	(486758, 127, '2014-01-15 00:35:48.000000', 'consum', 0.0226, 'lps'),
	(486759, 127, '2014-01-15 00:35:49.000000', 'consum', 0.0210, 'lps'),
	(486760, 127, '2014-01-15 00:35:50.000000', 'consum', 0.0214, 'lps'),
	(486761, 127, '2014-01-15 00:35:51.000000', 'consum', 0.0214, 'lps'),
	(486762, 127, '2014-01-15 00:35:52.000000', 'consum', 0.0217, 'lps'),
	(486763, 127, '2014-01-15 00:35:53.000000', 'consum', 0.0215, 'lps'),
	(486764, 127, '2014-01-15 00:35:54.000000', 'consum', 0.0217, 'lps'),
	(486765, 127, '2014-01-15 00:35:55.000000', 'consum', 0.0212, 'lps'),
	(486766, 127, '2014-01-15 00:35:56.000000', 'consum', 0.0216, 'lps'),
	(486767, 127, '2014-01-15 00:35:57.000000', 'consum', 0.0216, 'lps'),
	(486768, 127, '2014-01-15 00:35:58.000000', 'consum', 0.0226, 'lps'),
	(486769, 127, '2014-01-15 00:35:59.000000', 'consum', 0.0220, 'lps'),
	(486770, 127, '2014-01-15 00:36:00.000000', 'consum', 0.0215, 'lps'),
	(486771, 127, '2014-01-15 00:36:01.000000', 'consum', 0.0219, 'lps'),
	(486772, 127, '2014-01-15 00:36:02.000000', 'consum', 0.0225, 'lps'),
	(486773, 127, '2014-01-15 00:36:03.000000', 'consum', 0.0222, 'lps'),
	(486774, 127, '2014-01-15 00:36:04.000000', 'consum', 0.0211, 'lps'),
	(486775, 127, '2014-01-15 00:36:05.000000', 'consum', 0.0215, 'lps'),
	(486776, 127, '2014-01-15 00:36:06.000000', 'consum', 0.0213, 'lps'),
	(486777, 127, '2014-01-15 00:36:07.000000', 'consum', 0.0210, 'lps'),
	(486778, 127, '2014-01-15 00:36:08.000000', 'consum', 0.0220, 'lps'),
	(486779, 127, '2014-01-15 00:36:09.000000', 'consum', 0.0210, 'lps'),
	(486780, 127, '2014-01-15 00:36:10.000000', 'consum', 0.0213, 'lps'),
	(486781, 127, '2014-01-15 00:36:11.000000', 'consum', 0.0210, 'lps'),
	(486782, 127, '2014-01-15 00:36:12.000000', 'consum', 0.0217, 'lps'),
	(486783, 127, '2014-01-15 00:36:13.000000', 'consum', 0.0213, 'lps'),
	(486784, 127, '2014-01-15 00:36:14.000000', 'consum', 0.0219, 'lps'),
	(486785, 127, '2014-01-15 00:36:15.000000', 'consum', 0.0215, 'lps'),
	(486786, 127, '2014-01-15 00:36:16.000000', 'consum', 0.0226, 'lps'),
	(486787, 127, '2014-01-15 00:36:17.000000', 'consum', 0.0223, 'lps'),
	(486788, 127, '2014-01-15 00:36:18.000000', 'consum', 0.0211, 'lps'),
	(486789, 127, '2014-01-15 00:36:19.000000', 'consum', 0.0210, 'lps'),
	(486790, 127, '2014-01-15 00:36:20.000000', 'consum', 0.0223, 'lps'),
	(486791, 127, '2014-01-15 00:36:21.000000', 'consum', 0.0225, 'lps'),
	(486792, 127, '2014-01-15 00:36:22.000000', 'consum', 0.0215, 'lps'),
	(486793, 127, '2014-01-15 00:36:23.000000', 'consum', 0.0223, 'lps'),
	(486794, 127, '2014-01-15 00:36:24.000000', 'consum', 0.0212, 'lps'),
	(486795, 127, '2014-01-15 00:36:25.000000', 'consum', 0.0212, 'lps'),
	(486796, 127, '2014-01-15 00:36:26.000000', 'consum', 0.0216, 'lps'),
	(486797, 127, '2014-01-15 00:36:27.000000', 'consum', 0.0215, 'lps'),
	(486798, 127, '2014-01-15 00:36:28.000000', 'consum', 0.0221, 'lps'),
	(486799, 127, '2014-01-15 00:36:29.000000', 'consum', 0.0214, 'lps'),
	(486800, 127, '2014-01-15 00:36:30.000000', 'consum', 0.0215, 'lps'),
	(486801, 127, '2014-01-15 00:36:31.000000', 'consum', 0.0223, 'lps'),
	(486802, 127, '2014-01-15 00:36:32.000000', 'consum', 0.0226, 'lps'),
	(486803, 127, '2014-01-15 00:36:33.000000', 'consum', 0.0217, 'lps'),
	(486804, 127, '2014-01-15 00:36:34.000000', 'consum', 0.0217, 'lps'),
	(486805, 127, '2014-01-15 00:36:35.000000', 'consum', 0.0223, 'lps'),
	(486806, 127, '2014-01-15 00:36:36.000000', 'consum', 0.0219, 'lps'),
	(486807, 127, '2014-01-15 00:36:37.000000', 'consum', 0.0217, 'lps'),
	(486808, 127, '2014-01-15 00:36:38.000000', 'consum', 0.0220, 'lps'),
	(486809, 127, '2014-01-15 00:36:39.000000', 'consum', 0.0220, 'lps'),
	(486810, 127, '2014-01-15 00:36:40.000000', 'consum', 0.0213, 'lps'),
	(486811, 127, '2014-01-15 00:36:41.000000', 'consum', 0.0215, 'lps'),
	(486812, 127, '2014-01-15 00:36:42.000000', 'consum', 0.0210, 'lps'),
	(486813, 127, '2014-01-15 00:36:43.000000', 'consum', 0.0212, 'lps'),
	(486814, 127, '2014-01-15 00:36:44.000000', 'consum', 0.0221, 'lps'),
	(486815, 127, '2014-01-15 00:36:45.000000', 'consum', 0.0224, 'lps'),
	(486816, 127, '2014-01-15 00:36:46.000000', 'consum', 0.0212, 'lps'),
	(486817, 127, '2014-01-15 00:36:47.000000', 'consum', 0.0216, 'lps'),
	(486818, 127, '2014-01-15 00:36:48.000000', 'consum', 0.0215, 'lps'),
	(486819, 127, '2014-01-15 00:36:49.000000', 'consum', 0.0219, 'lps'),
	(486820, 127, '2014-01-15 00:36:50.000000', 'consum', 0.0224, 'lps'),
	(486821, 127, '2014-01-15 00:36:51.000000', 'consum', 0.0217, 'lps'),
	(486822, 127, '2014-01-15 00:36:52.000000', 'consum', 0.0221, 'lps'),
	(486823, 127, '2014-01-15 00:36:53.000000', 'consum', 0.0211, 'lps'),
	(486824, 127, '2014-01-15 00:36:54.000000', 'consum', 0.0217, 'lps'),
	(486825, 127, '2014-01-15 00:36:55.000000', 'consum', 0.0224, 'lps'),
	(486826, 127, '2014-01-15 00:36:56.000000', 'consum', 0.0226, 'lps'),
	(486827, 127, '2014-01-15 00:36:57.000000', 'consum', 0.0213, 'lps'),
	(486828, 127, '2014-01-15 00:36:58.000000', 'consum', 0.0214, 'lps'),
	(486829, 127, '2014-01-15 00:36:59.000000', 'consum', 0.0223, 'lps'),
	(486830, 127, '2014-01-15 00:37:00.000000', 'consum', 0.0226, 'lps'),
	(486831, 127, '2014-01-15 00:37:01.000000', 'consum', 0.0221, 'lps'),
	(486832, 127, '2014-01-15 00:37:02.000000', 'consum', 0.0215, 'lps'),
	(486833, 127, '2014-01-15 00:37:03.000000', 'consum', 0.0219, 'lps'),
	(486834, 127, '2014-01-15 00:37:04.000000', 'consum', 0.0223, 'lps'),
	(486835, 127, '2014-01-15 00:37:05.000000', 'consum', 0.0217, 'lps'),
	(486836, 127, '2014-01-15 00:37:06.000000', 'consum', 0.0222, 'lps'),
	(486837, 127, '2014-01-15 00:37:07.000000', 'consum', 0.0214, 'lps'),
	(486838, 127, '2014-01-15 00:37:08.000000', 'consum', 0.0214, 'lps'),
	(486839, 127, '2014-01-15 00:37:09.000000', 'consum', 0.0216, 'lps'),
	(486840, 127, '2014-01-15 00:37:10.000000', 'consum', 0.0211, 'lps'),
	(486841, 127, '2014-01-15 00:37:11.000000', 'consum', 0.0217, 'lps'),
	(486842, 127, '2014-01-15 00:37:12.000000', 'consum', 0.0224, 'lps'),
	(486843, 127, '2014-01-15 00:37:13.000000', 'consum', 0.0226, 'lps'),
	(486844, 127, '2014-01-15 00:37:14.000000', 'consum', 0.0216, 'lps'),
	(486845, 127, '2014-01-15 00:37:15.000000', 'consum', 0.0224, 'lps'),
	(486846, 127, '2014-01-15 00:37:16.000000', 'consum', 0.0214, 'lps'),
	(486847, 127, '2014-01-15 00:37:17.000000', 'consum', 0.0222, 'lps'),
	(486848, 127, '2014-01-15 00:37:18.000000', 'consum', 0.0225, 'lps'),
	(486849, 127, '2014-01-15 00:37:19.000000', 'consum', 0.0216, 'lps'),
	(486850, 127, '2014-01-15 00:37:20.000000', 'consum', 0.0212, 'lps'),
	(486851, 127, '2014-01-15 00:37:21.000000', 'consum', 0.0219, 'lps'),
	(486852, 127, '2014-01-15 00:37:22.000000', 'consum', 0.0214, 'lps'),
	(486853, 127, '2014-01-15 00:37:23.000000', 'consum', 0.0221, 'lps'),
	(486854, 127, '2014-01-15 00:37:24.000000', 'consum', 0.0218, 'lps'),
	(486855, 127, '2014-01-15 00:37:25.000000', 'consum', 0.0220, 'lps'),
	(486856, 127, '2014-01-15 00:37:26.000000', 'consum', 0.0217, 'lps'),
	(486857, 127, '2014-01-15 00:37:27.000000', 'consum', 0.0219, 'lps'),
	(486858, 127, '2014-01-15 00:37:28.000000', 'consum', 0.0215, 'lps'),
	(486859, 127, '2014-01-15 00:37:29.000000', 'consum', 0.0224, 'lps'),
	(486860, 127, '2014-01-15 00:37:30.000000', 'consum', 0.0216, 'lps'),
	(486861, 127, '2014-01-15 00:37:31.000000', 'consum', 0.0217, 'lps'),
	(486862, 127, '2014-01-15 00:37:32.000000', 'consum', 0.0210, 'lps'),
	(486863, 127, '2014-01-15 00:37:33.000000', 'consum', 0.0221, 'lps'),
	(486864, 127, '2014-01-15 00:37:34.000000', 'consum', 0.0218, 'lps'),
	(486865, 127, '2014-01-15 00:37:35.000000', 'consum', 0.0216, 'lps'),
	(486866, 127, '2014-01-15 00:37:36.000000', 'consum', 0.0216, 'lps'),
	(486867, 127, '2014-01-15 00:37:37.000000', 'consum', 0.0222, 'lps'),
	(486868, 127, '2014-01-15 00:37:38.000000', 'consum', 0.0220, 'lps'),
	(486869, 127, '2014-01-15 00:37:39.000000', 'consum', 0.0223, 'lps'),
	(486870, 127, '2014-01-15 00:37:40.000000', 'consum', 0.0214, 'lps'),
	(486871, 127, '2014-01-15 00:37:41.000000', 'consum', 0.0222, 'lps'),
	(486872, 127, '2014-01-15 00:37:42.000000', 'consum', 0.0211, 'lps'),
	(486873, 127, '2014-01-15 00:37:43.000000', 'consum', 0.0210, 'lps'),
	(486874, 127, '2014-01-15 00:37:44.000000', 'consum', 0.0210, 'lps'),
	(486875, 127, '2014-01-15 00:37:45.000000', 'consum', 0.0210, 'lps'),
	(486876, 127, '2014-01-15 00:37:46.000000', 'consum', 0.0212, 'lps'),
	(486877, 127, '2014-01-15 00:37:47.000000', 'consum', 0.0220, 'lps'),
	(486878, 127, '2014-01-15 00:37:48.000000', 'consum', 0.0219, 'lps'),
	(486879, 127, '2014-01-15 00:37:49.000000', 'consum', 0.0210, 'lps'),
	(486880, 127, '2014-01-15 00:37:50.000000', 'consum', 0.0218, 'lps'),
	(486881, 127, '2014-01-15 00:37:51.000000', 'consum', 0.0217, 'lps'),
	(486882, 127, '2014-01-15 00:37:52.000000', 'consum', 0.0219, 'lps'),
	(486883, 127, '2014-01-15 00:37:53.000000', 'consum', 0.0217, 'lps'),
	(486884, 127, '2014-01-15 00:37:54.000000', 'consum', 0.0218, 'lps'),
	(486885, 127, '2014-01-15 00:37:55.000000', 'consum', 0.0212, 'lps'),
	(486886, 127, '2014-01-15 00:37:56.000000', 'consum', 0.0215, 'lps'),
	(486887, 127, '2014-01-15 00:37:57.000000', 'consum', 0.0211, 'lps'),
	(486888, 127, '2014-01-15 00:37:58.000000', 'consum', 0.0218, 'lps'),
	(486889, 127, '2014-01-15 00:37:59.000000', 'consum', 0.0213, 'lps'),
	(486890, 127, '2014-01-15 00:38:00.000000', 'consum', 0.0218, 'lps'),
	(486891, 127, '2014-01-15 00:38:01.000000', 'consum', 0.0210, 'lps'),
	(486892, 127, '2014-01-15 00:38:02.000000', 'consum', 0.0220, 'lps'),
	(486893, 127, '2014-01-15 00:38:03.000000', 'consum', 0.0210, 'lps'),
	(486894, 127, '2014-01-15 00:38:04.000000', 'consum', 0.0216, 'lps'),
	(486895, 127, '2014-01-15 00:38:05.000000', 'consum', 0.0221, 'lps'),
	(486896, 127, '2014-01-15 00:38:06.000000', 'consum', 0.0216, 'lps'),
	(486897, 127, '2014-01-15 00:38:07.000000', 'consum', 0.0223, 'lps'),
	(486898, 127, '2014-01-15 00:38:08.000000', 'consum', 0.0225, 'lps'),
	(486899, 127, '2014-01-15 00:38:09.000000', 'consum', 0.0212, 'lps'),
	(486900, 127, '2014-01-15 00:38:10.000000', 'consum', 0.0224, 'lps'),
	(486901, 127, '2014-01-15 00:38:11.000000', 'consum', 0.0210, 'lps'),
	(486902, 127, '2014-01-15 00:38:12.000000', 'consum', 0.0218, 'lps'),
	(486903, 127, '2014-01-15 00:38:13.000000', 'consum', 0.0216, 'lps'),
	(486904, 127, '2014-01-15 00:38:14.000000', 'consum', 0.0216, 'lps'),
	(486905, 127, '2014-01-15 00:38:15.000000', 'consum', 0.0222, 'lps'),
	(486906, 127, '2014-01-15 00:38:16.000000', 'consum', 0.0220, 'lps'),
	(486907, 127, '2014-01-15 00:38:17.000000', 'consum', 0.0226, 'lps'),
	(486908, 127, '2014-01-15 00:38:18.000000', 'consum', 0.0224, 'lps'),
	(486909, 127, '2014-01-15 00:38:19.000000', 'consum', 0.0217, 'lps'),
	(486910, 127, '2014-01-15 00:38:20.000000', 'consum', 0.0220, 'lps'),
	(486911, 127, '2014-01-15 00:38:21.000000', 'consum', 0.0222, 'lps'),
	(486912, 127, '2014-01-15 00:38:22.000000', 'consum', 0.0222, 'lps'),
	(486913, 127, '2014-01-15 00:38:23.000000', 'consum', 0.0218, 'lps'),
	(486914, 127, '2014-01-15 00:38:24.000000', 'consum', 0.0216, 'lps'),
	(486915, 127, '2014-01-15 00:38:25.000000', 'consum', 0.0217, 'lps'),
	(486916, 127, '2014-01-15 00:38:26.000000', 'consum', 0.0225, 'lps'),
	(486917, 127, '2014-01-15 00:38:27.000000', 'consum', 0.0216, 'lps'),
	(486918, 127, '2014-01-15 00:38:28.000000', 'consum', 0.0213, 'lps'),
	(486919, 127, '2014-01-15 00:38:29.000000', 'consum', 0.0224, 'lps'),
	(486920, 127, '2014-01-15 00:38:30.000000', 'consum', 0.0220, 'lps'),
	(486921, 127, '2014-01-15 00:38:31.000000', 'consum', 0.0219, 'lps'),
	(486922, 127, '2014-01-15 00:38:32.000000', 'consum', 0.0225, 'lps'),
	(486923, 127, '2014-01-15 00:38:33.000000', 'consum', 0.0223, 'lps'),
	(486924, 127, '2014-01-15 00:38:34.000000', 'consum', 0.0216, 'lps'),
	(486925, 127, '2014-01-15 00:38:35.000000', 'consum', 0.0218, 'lps'),
	(486926, 127, '2014-01-15 00:38:36.000000', 'consum', 0.0213, 'lps'),
	(486927, 127, '2014-01-15 00:38:37.000000', 'consum', 0.0220, 'lps'),
	(486928, 127, '2014-01-15 00:38:38.000000', 'consum', 0.0219, 'lps'),
	(486929, 127, '2014-01-15 00:38:39.000000', 'consum', 0.0225, 'lps'),
	(486930, 127, '2014-01-15 00:38:40.000000', 'consum', 0.0224, 'lps'),
	(486931, 127, '2014-01-15 00:38:41.000000', 'consum', 0.0220, 'lps'),
	(486932, 127, '2014-01-15 00:38:42.000000', 'consum', 0.0218, 'lps'),
	(486933, 127, '2014-01-15 00:38:43.000000', 'consum', 0.0218, 'lps'),
	(486934, 127, '2014-01-15 00:38:44.000000', 'consum', 0.0211, 'lps'),
	(486935, 127, '2014-01-15 00:38:45.000000', 'consum', 0.0210, 'lps'),
	(486936, 127, '2014-01-15 00:38:46.000000', 'consum', 0.0222, 'lps'),
	(486937, 127, '2014-01-15 00:38:47.000000', 'consum', 0.0221, 'lps'),
	(486938, 127, '2014-01-15 00:38:48.000000', 'consum', 0.0214, 'lps'),
	(486939, 127, '2014-01-15 00:38:49.000000', 'consum', 0.0211, 'lps'),
	(486940, 127, '2014-01-15 00:38:50.000000', 'consum', 0.0224, 'lps'),
	(486941, 127, '2014-01-15 00:38:51.000000', 'consum', 0.0225, 'lps'),
	(486942, 127, '2014-01-15 00:38:52.000000', 'consum', 0.0226, 'lps'),
	(486943, 127, '2014-01-15 00:38:53.000000', 'consum', 0.0212, 'lps'),
	(486944, 127, '2014-01-15 00:38:54.000000', 'consum', 0.0222, 'lps'),
	(486945, 127, '2014-01-15 00:38:55.000000', 'consum', 0.0216, 'lps'),
	(486946, 127, '2014-01-15 00:38:56.000000', 'consum', 0.0222, 'lps'),
	(486947, 127, '2014-01-15 00:38:57.000000', 'consum', 0.0219, 'lps'),
	(486948, 127, '2014-01-15 00:38:58.000000', 'consum', 0.0216, 'lps'),
	(486949, 127, '2014-01-15 00:38:59.000000', 'consum', 0.0216, 'lps'),
	(486950, 127, '2014-01-15 00:39:00.000000', 'consum', 0.0223, 'lps'),
	(486951, 127, '2014-01-15 00:39:01.000000', 'consum', 0.0223, 'lps'),
	(486952, 127, '2014-01-15 00:39:02.000000', 'consum', 0.0220, 'lps'),
	(486953, 127, '2014-01-15 00:39:03.000000', 'consum', 0.0221, 'lps'),
	(486954, 127, '2014-01-15 00:39:04.000000', 'consum', 0.0216, 'lps'),
	(486955, 127, '2014-01-15 00:39:05.000000', 'consum', 0.0211, 'lps'),
	(486956, 127, '2014-01-15 00:39:06.000000', 'consum', 0.0214, 'lps'),
	(486957, 127, '2014-01-15 00:39:07.000000', 'consum', 0.0212, 'lps'),
	(486958, 127, '2014-01-15 00:39:08.000000', 'consum', 0.0224, 'lps'),
	(486959, 127, '2014-01-15 00:39:09.000000', 'consum', 0.0222, 'lps'),
	(486960, 127, '2014-01-15 00:39:10.000000', 'consum', 0.0211, 'lps'),
	(486961, 127, '2014-01-15 00:39:11.000000', 'consum', 0.0214, 'lps'),
	(486962, 127, '2014-01-15 00:39:12.000000', 'consum', 0.0211, 'lps'),
	(486963, 127, '2014-01-15 00:39:13.000000', 'consum', 0.0221, 'lps'),
	(486964, 127, '2014-01-15 00:39:14.000000', 'consum', 0.0211, 'lps'),
	(486965, 127, '2014-01-15 00:39:15.000000', 'consum', 0.0218, 'lps'),
	(486966, 127, '2014-01-15 00:39:16.000000', 'consum', 0.0213, 'lps'),
	(486967, 127, '2014-01-15 00:39:17.000000', 'consum', 0.0220, 'lps'),
	(486968, 127, '2014-01-15 00:39:18.000000', 'consum', 0.0215, 'lps'),
	(486969, 127, '2014-01-15 00:39:19.000000', 'consum', 0.0224, 'lps'),
	(486970, 127, '2014-01-15 00:39:20.000000', 'consum', 0.0213, 'lps'),
	(486971, 127, '2014-01-15 00:39:21.000000', 'consum', 0.0217, 'lps'),
	(486972, 127, '2014-01-15 00:39:22.000000', 'consum', 0.0218, 'lps'),
	(486973, 127, '2014-01-15 00:39:23.000000', 'consum', 0.0215, 'lps'),
	(486974, 127, '2014-01-15 00:39:24.000000', 'consum', 0.0212, 'lps'),
	(486975, 127, '2014-01-15 00:39:25.000000', 'consum', 0.0222, 'lps'),
	(486976, 127, '2014-01-15 00:39:26.000000', 'consum', 0.0213, 'lps'),
	(486977, 127, '2014-01-15 00:39:27.000000', 'consum', 0.0222, 'lps'),
	(486978, 127, '2014-01-15 00:39:28.000000', 'consum', 0.0211, 'lps'),
	(486979, 127, '2014-01-15 00:39:29.000000', 'consum', 0.0213, 'lps'),
	(486980, 127, '2014-01-15 00:39:30.000000', 'consum', 0.0225, 'lps'),
	(486981, 127, '2014-01-15 00:39:31.000000', 'consum', 0.0223, 'lps'),
	(486982, 127, '2014-01-15 00:39:32.000000', 'consum', 0.0216, 'lps'),
	(486983, 127, '2014-01-15 00:39:33.000000', 'consum', 0.0219, 'lps'),
	(486984, 127, '2014-01-15 00:39:34.000000', 'consum', 0.0219, 'lps'),
	(486985, 127, '2014-01-15 00:39:35.000000', 'consum', 0.0213, 'lps'),
	(486986, 127, '2014-01-15 00:39:36.000000', 'consum', 0.0215, 'lps'),
	(486987, 127, '2014-01-15 00:39:37.000000', 'consum', 0.0225, 'lps'),
	(486988, 127, '2014-01-15 00:39:38.000000', 'consum', 0.0219, 'lps'),
	(486989, 127, '2014-01-15 00:39:39.000000', 'consum', 0.0210, 'lps'),
	(486990, 127, '2014-01-15 00:39:40.000000', 'consum', 0.0220, 'lps'),
	(486991, 127, '2014-01-15 00:39:41.000000', 'consum', 0.0226, 'lps'),
	(486992, 127, '2014-01-15 00:39:42.000000', 'consum', 0.0210, 'lps'),
	(486993, 127, '2014-01-15 00:39:43.000000', 'consum', 0.0214, 'lps'),
	(486994, 127, '2014-01-15 00:39:44.000000', 'consum', 0.0214, 'lps'),
	(486995, 127, '2014-01-15 00:39:45.000000', 'consum', 0.0217, 'lps'),
	(486996, 127, '2014-01-15 00:39:46.000000', 'consum', 0.0215, 'lps'),
	(486997, 127, '2014-01-15 00:39:47.000000', 'consum', 0.0217, 'lps'),
	(486998, 127, '2014-01-15 00:39:48.000000', 'consum', 0.0212, 'lps'),
	(486999, 127, '2014-01-15 00:39:49.000000', 'consum', 0.0215, 'lps'),
	(487000, 127, '2014-01-15 00:39:50.000000', 'consum', 0.0214, 'lps'),
	(487001, 127, '2014-01-15 00:39:51.000000', 'consum', 0.0218, 'lps'),
	(487002, 127, '2014-01-15 00:39:52.000000', 'consum', 0.0218, 'lps'),
	(487003, 127, '2014-01-15 00:39:53.000000', 'consum', 0.0210, 'lps'),
	(487004, 127, '2014-01-15 00:39:54.000000', 'consum', 0.0220, 'lps'),
	(487005, 127, '2014-01-15 00:39:55.000000', 'consum', 0.0226, 'lps'),
	(487006, 127, '2014-01-15 00:39:56.000000', 'consum', 0.0226, 'lps'),
	(487007, 127, '2014-01-15 00:39:57.000000', 'consum', 0.0225, 'lps'),
	(487008, 127, '2014-01-15 00:39:58.000000', 'consum', 0.0223, 'lps'),
	(487009, 127, '2014-01-15 00:39:59.000000', 'consum', 0.0213, 'lps'),
	(487010, 127, '2014-01-15 00:40:00.000000', 'consum', 0.0220, 'lps'),
	(487011, 127, '2014-01-15 00:40:01.000000', 'consum', 0.0216, 'lps'),
	(487012, 127, '2014-01-15 00:40:02.000000', 'consum', 0.0212, 'lps'),
	(487013, 127, '2014-01-15 00:40:03.000000', 'consum', 0.0219, 'lps'),
	(487014, 127, '2014-01-15 00:40:04.000000', 'consum', 0.0217, 'lps'),
	(487015, 127, '2014-01-15 00:40:05.000000', 'consum', 0.0218, 'lps'),
	(487016, 127, '2014-01-15 00:40:06.000000', 'consum', 0.0214, 'lps'),
	(487017, 127, '2014-01-15 00:40:07.000000', 'consum', 0.0221, 'lps'),
	(487018, 127, '2014-01-15 00:40:08.000000', 'consum', 0.0218, 'lps'),
	(487019, 127, '2014-01-15 00:40:09.000000', 'consum', 0.0221, 'lps'),
	(487020, 127, '2014-01-15 00:40:10.000000', 'consum', 0.0224, 'lps'),
	(487021, 127, '2014-01-15 00:40:11.000000', 'consum', 0.0214, 'lps'),
	(487022, 127, '2014-01-15 00:40:12.000000', 'consum', 0.0223, 'lps'),
	(487023, 127, '2014-01-15 00:40:13.000000', 'consum', 0.0211, 'lps'),
	(487024, 127, '2014-01-15 00:40:14.000000', 'consum', 0.0213, 'lps'),
	(487025, 127, '2014-01-15 00:40:15.000000', 'consum', 0.0221, 'lps'),
	(487026, 127, '2014-01-15 00:40:16.000000', 'consum', 0.0225, 'lps'),
	(487027, 127, '2014-01-15 00:40:17.000000', 'consum', 0.0215, 'lps'),
	(487028, 127, '2014-01-15 00:40:18.000000', 'consum', 0.0224, 'lps'),
	(487029, 127, '2014-01-15 00:40:19.000000', 'consum', 0.0218, 'lps'),
	(487030, 127, '2014-01-15 00:40:20.000000', 'consum', 0.0222, 'lps'),
	(487031, 127, '2014-01-15 00:40:21.000000', 'consum', 0.0215, 'lps'),
	(487032, 127, '2014-01-15 00:40:22.000000', 'consum', 0.0216, 'lps'),
	(487033, 127, '2014-01-15 00:40:23.000000', 'consum', 0.0224, 'lps'),
	(487034, 127, '2014-01-15 00:40:24.000000', 'consum', 0.0212, 'lps'),
	(487035, 127, '2014-01-15 00:40:25.000000', 'consum', 0.0212, 'lps'),
	(487036, 127, '2014-01-15 00:40:26.000000', 'consum', 0.0216, 'lps'),
	(487037, 127, '2014-01-15 00:40:27.000000', 'consum', 0.0219, 'lps'),
	(487038, 127, '2014-01-15 00:40:28.000000', 'consum', 0.0218, 'lps'),
	(487039, 127, '2014-01-15 00:40:29.000000', 'consum', 0.0225, 'lps'),
	(487040, 127, '2014-01-15 00:40:30.000000', 'consum', 0.0212, 'lps'),
	(487041, 127, '2014-01-15 00:40:31.000000', 'consum', 0.0225, 'lps'),
	(487042, 127, '2014-01-15 00:40:32.000000', 'consum', 0.0212, 'lps'),
	(487043, 127, '2014-01-15 00:40:33.000000', 'consum', 0.0210, 'lps'),
	(487044, 127, '2014-01-15 00:40:34.000000', 'consum', 0.0222, 'lps'),
	(487045, 127, '2014-01-15 00:40:35.000000', 'consum', 0.0220, 'lps'),
	(487046, 127, '2014-01-15 00:40:36.000000', 'consum', 0.0222, 'lps'),
	(487047, 127, '2014-01-15 00:40:37.000000', 'consum', 0.0225, 'lps'),
	(487048, 127, '2014-01-15 00:40:38.000000', 'consum', 0.0217, 'lps'),
	(487049, 127, '2014-01-15 00:40:39.000000', 'consum', 0.0218, 'lps'),
	(487050, 127, '2014-01-15 00:40:40.000000', 'consum', 0.0210, 'lps'),
	(487051, 127, '2014-01-15 00:40:41.000000', 'consum', 0.0223, 'lps'),
	(487052, 127, '2014-01-15 00:40:42.000000', 'consum', 0.0222, 'lps'),
	(487053, 127, '2014-01-15 00:40:43.000000', 'consum', 0.0217, 'lps'),
	(487054, 127, '2014-01-15 00:40:44.000000', 'consum', 0.0226, 'lps'),
	(487055, 127, '2014-01-15 00:40:45.000000', 'consum', 0.0218, 'lps'),
	(487056, 127, '2014-01-15 00:40:46.000000', 'consum', 0.0219, 'lps'),
	(487057, 127, '2014-01-15 00:40:47.000000', 'consum', 0.0217, 'lps'),
	(487058, 127, '2014-01-15 00:40:48.000000', 'consum', 0.0216, 'lps'),
	(487059, 127, '2014-01-15 00:40:49.000000', 'consum', 0.0219, 'lps'),
	(487060, 127, '2014-01-15 00:40:50.000000', 'consum', 0.0223, 'lps'),
	(487061, 127, '2014-01-15 00:40:51.000000', 'consum', 0.0215, 'lps'),
	(487062, 127, '2014-01-15 00:40:52.000000', 'consum', 0.0212, 'lps'),
	(487063, 127, '2014-01-15 00:40:53.000000', 'consum', 0.0223, 'lps'),
	(487064, 127, '2014-01-15 00:40:54.000000', 'consum', 0.0218, 'lps'),
	(487065, 127, '2014-01-15 00:40:55.000000', 'consum', 0.0213, 'lps'),
	(487066, 127, '2014-01-15 00:40:56.000000', 'consum', 0.0219, 'lps'),
	(487067, 127, '2014-01-15 00:40:57.000000', 'consum', 0.0211, 'lps'),
	(487068, 127, '2014-01-15 00:40:58.000000', 'consum', 0.0221, 'lps'),
	(487069, 127, '2014-01-15 00:40:59.000000', 'consum', 0.0213, 'lps'),
	(487070, 127, '2014-01-15 00:41:00.000000', 'consum', 0.0225, 'lps'),
	(487071, 127, '2014-01-15 00:41:01.000000', 'consum', 0.0225, 'lps'),
	(487072, 127, '2014-01-15 00:41:02.000000', 'consum', 0.0226, 'lps'),
	(487073, 127, '2014-01-15 00:41:03.000000', 'consum', 0.0211, 'lps'),
	(487074, 127, '2014-01-15 00:41:04.000000', 'consum', 0.0219, 'lps'),
	(487075, 127, '2014-01-15 00:41:05.000000', 'consum', 0.0217, 'lps'),
	(487076, 127, '2014-01-15 00:41:06.000000', 'consum', 0.0220, 'lps'),
	(487077, 127, '2014-01-15 00:41:07.000000', 'consum', 0.0223, 'lps'),
	(487078, 127, '2014-01-15 00:41:08.000000', 'consum', 0.0211, 'lps'),
	(487079, 127, '2014-01-15 00:41:09.000000', 'consum', 0.0210, 'lps'),
	(487080, 127, '2014-01-15 00:41:10.000000', 'consum', 0.0226, 'lps'),
	(487081, 127, '2014-01-15 00:41:11.000000', 'consum', 0.0222, 'lps'),
	(487082, 127, '2014-01-15 00:41:12.000000', 'consum', 0.0221, 'lps'),
	(487083, 127, '2014-01-15 00:41:13.000000', 'consum', 0.0215, 'lps'),
	(487084, 127, '2014-01-15 00:41:14.000000', 'consum', 0.0220, 'lps'),
	(487085, 127, '2014-01-15 00:41:15.000000', 'consum', 0.0211, 'lps'),
	(487086, 127, '2014-01-15 00:41:16.000000', 'consum', 0.0218, 'lps'),
	(487087, 127, '2014-01-15 00:41:17.000000', 'consum', 0.0216, 'lps'),
	(487088, 127, '2014-01-15 00:41:18.000000', 'consum', 0.0214, 'lps'),
	(487089, 127, '2014-01-15 00:41:19.000000', 'consum', 0.0212, 'lps'),
	(487090, 127, '2014-01-15 00:41:20.000000', 'consum', 0.0210, 'lps'),
	(487091, 127, '2014-01-15 00:41:21.000000', 'consum', 0.0221, 'lps'),
	(487092, 127, '2014-01-15 00:41:22.000000', 'consum', 0.0216, 'lps'),
	(487093, 127, '2014-01-15 00:41:23.000000', 'consum', 0.0225, 'lps'),
	(487094, 127, '2014-01-15 00:41:24.000000', 'consum', 0.0214, 'lps'),
	(487095, 127, '2014-01-15 00:41:25.000000', 'consum', 0.0220, 'lps'),
	(487096, 127, '2014-01-15 00:41:26.000000', 'consum', 0.0215, 'lps'),
	(487097, 127, '2014-01-15 00:41:27.000000', 'consum', 0.0225, 'lps'),
	(487098, 127, '2014-01-15 00:41:28.000000', 'consum', 0.0216, 'lps'),
	(487099, 127, '2014-01-15 00:41:29.000000', 'consum', 0.0213, 'lps'),
	(487100, 127, '2014-01-15 00:41:30.000000', 'consum', 0.0223, 'lps'),
	(487101, 127, '2014-01-15 00:41:31.000000', 'consum', 0.0219, 'lps'),
	(487102, 127, '2014-01-15 00:41:32.000000', 'consum', 0.0213, 'lps'),
	(487103, 127, '2014-01-15 00:41:33.000000', 'consum', 0.0218, 'lps'),
	(487104, 127, '2014-01-15 00:41:34.000000', 'consum', 0.0222, 'lps'),
	(487105, 127, '2014-01-15 00:41:35.000000', 'consum', 0.0214, 'lps'),
	(487106, 127, '2014-01-15 00:41:36.000000', 'consum', 0.0213, 'lps'),
	(487107, 127, '2014-01-15 00:41:37.000000', 'consum', 0.0212, 'lps'),
	(487108, 127, '2014-01-15 00:41:38.000000', 'consum', 0.0211, 'lps'),
	(487109, 127, '2014-01-15 00:41:39.000000', 'consum', 0.0226, 'lps'),
	(487110, 127, '2014-01-15 00:41:40.000000', 'consum', 0.0219, 'lps'),
	(487111, 127, '2014-01-15 00:41:41.000000', 'consum', 0.0226, 'lps'),
	(487112, 127, '2014-01-15 00:41:42.000000', 'consum', 0.0212, 'lps'),
	(487113, 127, '2014-01-15 00:41:43.000000', 'consum', 0.0225, 'lps'),
	(487114, 127, '2014-01-15 00:41:44.000000', 'consum', 0.0211, 'lps'),
	(487115, 127, '2014-01-15 00:41:45.000000', 'consum', 0.0223, 'lps'),
	(487116, 127, '2014-01-15 00:41:46.000000', 'consum', 0.0220, 'lps'),
	(487117, 127, '2014-01-15 00:41:47.000000', 'consum', 0.0221, 'lps'),
	(487118, 127, '2014-01-15 00:41:48.000000', 'consum', 0.0220, 'lps'),
	(487119, 127, '2014-01-15 00:41:49.000000', 'consum', 0.0226, 'lps'),
	(487120, 127, '2014-01-15 00:41:50.000000', 'consum', 0.0211, 'lps'),
	(487121, 127, '2014-01-15 00:41:51.000000', 'consum', 0.0219, 'lps'),
	(487122, 127, '2014-01-15 00:41:52.000000', 'consum', 0.0219, 'lps'),
	(487123, 127, '2014-01-15 00:41:53.000000', 'consum', 0.0211, 'lps'),
	(487124, 127, '2014-01-15 00:41:54.000000', 'consum', 0.0220, 'lps'),
	(487125, 127, '2014-01-15 00:41:55.000000', 'consum', 0.0226, 'lps'),
	(487126, 127, '2014-01-15 00:41:56.000000', 'consum', 0.0210, 'lps'),
	(487127, 127, '2014-01-15 00:41:57.000000', 'consum', 0.0213, 'lps'),
	(487128, 127, '2014-01-15 00:41:58.000000', 'consum', 0.0223, 'lps'),
	(487129, 127, '2014-01-15 00:41:59.000000', 'consum', 0.0219, 'lps'),
	(487130, 127, '2014-01-15 00:42:00.000000', 'consum', 0.0214, 'lps'),
	(487131, 127, '2014-01-15 00:42:01.000000', 'consum', 0.0220, 'lps'),
	(487132, 127, '2014-01-15 00:42:02.000000', 'consum', 0.0217, 'lps'),
	(487133, 127, '2014-01-15 00:42:03.000000', 'consum', 0.0216, 'lps'),
	(487134, 127, '2014-01-15 00:42:04.000000', 'consum', 0.0218, 'lps'),
	(487135, 127, '2014-01-15 00:42:05.000000', 'consum', 0.0217, 'lps'),
	(487136, 127, '2014-01-15 00:42:06.000000', 'consum', 0.0219, 'lps'),
	(487137, 127, '2014-01-15 00:42:07.000000', 'consum', 0.0218, 'lps'),
	(487138, 127, '2014-01-15 00:42:08.000000', 'consum', 0.0223, 'lps'),
	(487139, 127, '2014-01-15 00:42:09.000000', 'consum', 0.0218, 'lps'),
	(487140, 127, '2014-01-15 00:42:10.000000', 'consum', 0.0212, 'lps'),
	(487141, 127, '2014-01-15 00:42:11.000000', 'consum', 0.0213, 'lps'),
	(487142, 127, '2014-01-15 00:42:12.000000', 'consum', 0.0218, 'lps'),
	(487143, 127, '2014-01-15 00:42:13.000000', 'consum', 0.0224, 'lps'),
	(487144, 127, '2014-01-15 00:42:14.000000', 'consum', 0.0225, 'lps'),
	(487145, 127, '2014-01-15 00:42:15.000000', 'consum', 0.0210, 'lps'),
	(487146, 127, '2014-01-15 00:42:16.000000', 'consum', 0.0216, 'lps'),
	(487147, 127, '2014-01-15 00:42:17.000000', 'consum', 0.0223, 'lps'),
	(487148, 127, '2014-01-15 00:42:18.000000', 'consum', 0.0223, 'lps'),
	(487149, 127, '2014-01-15 00:42:19.000000', 'consum', 0.0221, 'lps'),
	(487150, 127, '2014-01-15 00:42:20.000000', 'consum', 0.0226, 'lps'),
	(487151, 127, '2014-01-15 00:42:21.000000', 'consum', 0.0223, 'lps'),
	(487152, 127, '2014-01-15 00:42:22.000000', 'consum', 0.0211, 'lps'),
	(487153, 127, '2014-01-15 00:42:23.000000', 'consum', 0.0212, 'lps'),
	(487154, 127, '2014-01-15 00:42:24.000000', 'consum', 0.0218, 'lps'),
	(487155, 127, '2014-01-15 00:42:25.000000', 'consum', 0.0210, 'lps'),
	(487156, 127, '2014-01-15 00:42:26.000000', 'consum', 0.0220, 'lps'),
	(487157, 127, '2014-01-15 00:42:27.000000', 'consum', 0.0211, 'lps'),
	(487158, 127, '2014-01-15 00:42:28.000000', 'consum', 0.0217, 'lps'),
	(487159, 127, '2014-01-15 00:42:29.000000', 'consum', 0.0211, 'lps'),
	(487160, 127, '2014-01-15 00:42:30.000000', 'consum', 0.0226, 'lps'),
	(487161, 127, '2014-01-15 00:42:31.000000', 'consum', 0.0219, 'lps'),
	(487162, 127, '2014-01-15 00:42:32.000000', 'consum', 0.0210, 'lps'),
	(487163, 127, '2014-01-15 00:42:33.000000', 'consum', 0.0215, 'lps'),
	(487164, 127, '2014-01-15 00:42:34.000000', 'consum', 0.0221, 'lps'),
	(487165, 127, '2014-01-15 00:42:35.000000', 'consum', 0.0216, 'lps'),
	(487166, 127, '2014-01-15 00:42:36.000000', 'consum', 0.0222, 'lps'),
	(487167, 127, '2014-01-15 00:42:37.000000', 'consum', 0.0222, 'lps'),
	(487168, 127, '2014-01-15 00:42:38.000000', 'consum', 0.0216, 'lps'),
	(487169, 127, '2014-01-15 00:42:39.000000', 'consum', 0.0220, 'lps'),
	(487170, 127, '2014-01-15 00:42:40.000000', 'consum', 0.0211, 'lps'),
	(487171, 127, '2014-01-15 00:42:41.000000', 'consum', 0.0220, 'lps'),
	(487172, 127, '2014-01-15 00:42:42.000000', 'consum', 0.0224, 'lps'),
	(487173, 127, '2014-01-15 00:42:43.000000', 'consum', 0.0213, 'lps'),
	(487174, 127, '2014-01-15 00:42:44.000000', 'consum', 0.0221, 'lps'),
	(487175, 127, '2014-01-15 00:42:45.000000', 'consum', 0.0221, 'lps'),
	(487176, 127, '2014-01-15 00:42:46.000000', 'consum', 0.0214, 'lps'),
	(487177, 127, '2014-01-15 00:42:47.000000', 'consum', 0.0215, 'lps'),
	(487178, 127, '2014-01-15 00:42:48.000000', 'consum', 0.0225, 'lps'),
	(487179, 127, '2014-01-15 00:42:49.000000', 'consum', 0.0218, 'lps'),
	(487180, 127, '2014-01-15 00:42:50.000000', 'consum', 0.0222, 'lps'),
	(487181, 127, '2014-01-15 00:42:51.000000', 'consum', 0.0211, 'lps'),
	(487182, 127, '2014-01-15 00:42:52.000000', 'consum', 0.0217, 'lps'),
	(487183, 127, '2014-01-15 00:42:53.000000', 'consum', 0.0224, 'lps'),
	(487184, 127, '2014-01-15 00:42:54.000000', 'consum', 0.0226, 'lps'),
	(487185, 127, '2014-01-15 00:42:55.000000', 'consum', 0.0214, 'lps'),
	(487186, 127, '2014-01-15 00:42:56.000000', 'consum', 0.0215, 'lps'),
	(487187, 127, '2014-01-15 00:42:57.000000', 'consum', 0.0224, 'lps'),
	(487188, 127, '2014-01-15 00:42:58.000000', 'consum', 0.0216, 'lps'),
	(487189, 127, '2014-01-15 00:42:59.000000', 'consum', 0.0214, 'lps'),
	(487190, 127, '2014-01-15 00:43:00.000000', 'consum', 0.0212, 'lps'),
	(487191, 127, '2014-01-15 00:43:01.000000', 'consum', 0.0226, 'lps'),
	(487192, 127, '2014-01-15 00:43:02.000000', 'consum', 0.0218, 'lps'),
	(487193, 127, '2014-01-15 00:43:03.000000', 'consum', 0.0219, 'lps'),
	(487194, 127, '2014-01-15 00:43:04.000000', 'consum', 0.0213, 'lps'),
	(487195, 127, '2014-01-15 00:43:05.000000', 'consum', 0.0218, 'lps'),
	(487196, 127, '2014-01-15 00:43:06.000000', 'consum', 0.0225, 'lps'),
	(487197, 127, '2014-01-15 00:43:07.000000', 'consum', 0.0226, 'lps'),
	(487198, 127, '2014-01-15 00:43:08.000000', 'consum', 0.0211, 'lps'),
	(487199, 127, '2014-01-15 00:43:09.000000', 'consum', 0.0221, 'lps'),
	(487200, 127, '2014-01-15 00:43:10.000000', 'consum', 0.0226, 'lps'),
	(487201, 127, '2014-01-15 00:43:11.000000', 'consum', 0.0226, 'lps'),
	(487202, 127, '2014-01-15 00:43:12.000000', 'consum', 0.0222, 'lps'),
	(487203, 127, '2014-01-15 00:43:13.000000', 'consum', 0.0226, 'lps'),
	(487204, 127, '2014-01-15 00:43:14.000000', 'consum', 0.0218, 'lps'),
	(487205, 127, '2014-01-15 00:43:15.000000', 'consum', 0.0222, 'lps'),
	(487206, 127, '2014-01-15 00:43:16.000000', 'consum', 0.0213, 'lps'),
	(487207, 127, '2014-01-15 00:43:17.000000', 'consum', 0.0222, 'lps'),
	(487208, 127, '2014-01-15 00:43:18.000000', 'consum', 0.0211, 'lps'),
	(487209, 127, '2014-01-15 00:43:19.000000', 'consum', 0.0213, 'lps'),
	(487210, 127, '2014-01-15 00:43:20.000000', 'consum', 0.0224, 'lps'),
	(487211, 127, '2014-01-15 00:43:21.000000', 'consum', 0.0221, 'lps'),
	(487212, 127, '2014-01-15 00:43:22.000000', 'consum', 0.0221, 'lps'),
	(487213, 127, '2014-01-15 00:43:23.000000', 'consum', 0.0216, 'lps'),
	(487214, 127, '2014-01-15 00:43:24.000000', 'consum', 0.0223, 'lps'),
	(487215, 127, '2014-01-15 00:43:25.000000', 'consum', 0.0226, 'lps'),
	(487216, 127, '2014-01-15 00:43:26.000000', 'consum', 0.0218, 'lps'),
	(487217, 127, '2014-01-15 00:43:27.000000', 'consum', 0.0218, 'lps'),
	(487218, 127, '2014-01-15 00:43:28.000000', 'consum', 0.0225, 'lps'),
	(487219, 127, '2014-01-15 00:43:29.000000', 'consum', 0.0213, 'lps'),
	(487220, 127, '2014-01-15 00:43:30.000000', 'consum', 0.0212, 'lps'),
	(487221, 127, '2014-01-15 00:43:31.000000', 'consum', 0.0212, 'lps'),
	(487222, 127, '2014-01-15 00:43:32.000000', 'consum', 0.0213, 'lps'),
	(487223, 127, '2014-01-15 00:43:33.000000', 'consum', 0.0221, 'lps'),
	(487224, 127, '2014-01-15 00:43:34.000000', 'consum', 0.0222, 'lps'),
	(487225, 127, '2014-01-15 00:43:35.000000', 'consum', 0.0221, 'lps'),
	(487226, 127, '2014-01-15 00:43:36.000000', 'consum', 0.0210, 'lps'),
	(487227, 127, '2014-01-15 00:43:37.000000', 'consum', 0.0215, 'lps'),
	(487228, 127, '2014-01-15 00:43:38.000000', 'consum', 0.0217, 'lps'),
	(487229, 127, '2014-01-15 00:43:39.000000', 'consum', 0.0215, 'lps'),
	(487230, 127, '2014-01-15 00:43:40.000000', 'consum', 0.0214, 'lps'),
	(487231, 127, '2014-01-15 00:43:41.000000', 'consum', 0.0214, 'lps'),
	(487232, 127, '2014-01-15 00:43:42.000000', 'consum', 0.0218, 'lps'),
	(487233, 127, '2014-01-15 00:43:43.000000', 'consum', 0.0221, 'lps'),
	(487234, 127, '2014-01-15 00:43:44.000000', 'consum', 0.0224, 'lps'),
	(487235, 127, '2014-01-15 00:43:45.000000', 'consum', 0.0215, 'lps'),
	(487236, 127, '2014-01-15 00:43:46.000000', 'consum', 0.0212, 'lps'),
	(487237, 127, '2014-01-15 00:43:47.000000', 'consum', 0.0221, 'lps'),
	(487238, 127, '2014-01-15 00:43:48.000000', 'consum', 0.0210, 'lps'),
	(487239, 127, '2014-01-15 00:43:49.000000', 'consum', 0.0212, 'lps'),
	(487240, 127, '2014-01-15 00:43:50.000000', 'consum', 0.0220, 'lps'),
	(487241, 127, '2014-01-15 00:43:51.000000', 'consum', 0.0218, 'lps'),
	(487242, 127, '2014-01-15 00:43:52.000000', 'consum', 0.0222, 'lps'),
	(487243, 127, '2014-01-15 00:43:53.000000', 'consum', 0.0215, 'lps'),
	(487244, 127, '2014-01-15 00:43:54.000000', 'consum', 0.0213, 'lps'),
	(487245, 127, '2014-01-15 00:43:55.000000', 'consum', 0.0211, 'lps'),
	(487246, 127, '2014-01-15 00:43:56.000000', 'consum', 0.0226, 'lps'),
	(487247, 127, '2014-01-15 00:43:57.000000', 'consum', 0.0217, 'lps'),
	(487248, 127, '2014-01-15 00:43:58.000000', 'consum', 0.0215, 'lps'),
	(487249, 127, '2014-01-15 00:43:59.000000', 'consum', 0.0213, 'lps'),
	(487250, 127, '2014-01-15 00:44:00.000000', 'consum', 0.0210, 'lps'),
	(487251, 127, '2014-01-15 00:44:01.000000', 'consum', 0.0219, 'lps'),
	(487252, 127, '2014-01-15 00:44:02.000000', 'consum', 0.0224, 'lps'),
	(487253, 127, '2014-01-15 00:44:03.000000', 'consum', 0.0218, 'lps'),
	(487254, 127, '2014-01-15 00:44:04.000000', 'consum', 0.0225, 'lps'),
	(487255, 127, '2014-01-15 00:44:05.000000', 'consum', 0.0212, 'lps'),
	(487256, 127, '2014-01-15 00:44:06.000000', 'consum', 0.0224, 'lps'),
	(487257, 127, '2014-01-15 00:44:07.000000', 'consum', 0.0210, 'lps'),
	(487258, 127, '2014-01-15 00:44:08.000000', 'consum', 0.0217, 'lps'),
	(487259, 127, '2014-01-15 00:44:09.000000', 'consum', 0.0210, 'lps'),
	(487260, 127, '2014-01-15 00:44:10.000000', 'consum', 0.0225, 'lps'),
	(487261, 127, '2014-01-15 00:44:11.000000', 'consum', 0.0217, 'lps'),
	(487262, 127, '2014-01-15 00:44:12.000000', 'consum', 0.0218, 'lps'),
	(487263, 127, '2014-01-15 00:44:13.000000', 'consum', 0.0211, 'lps'),
	(487264, 127, '2014-01-15 00:44:14.000000', 'consum', 0.0211, 'lps'),
	(487265, 127, '2014-01-15 00:44:15.000000', 'consum', 0.0213, 'lps'),
	(487266, 127, '2014-01-15 00:44:16.000000', 'consum', 0.0220, 'lps'),
	(487267, 127, '2014-01-15 00:44:17.000000', 'consum', 0.0218, 'lps'),
	(487268, 127, '2014-01-15 00:44:18.000000', 'consum', 0.0221, 'lps'),
	(487269, 127, '2014-01-15 00:44:19.000000', 'consum', 0.0223, 'lps'),
	(487270, 127, '2014-01-15 00:44:20.000000', 'consum', 0.0212, 'lps'),
	(487271, 127, '2014-01-15 00:44:21.000000', 'consum', 0.0212, 'lps'),
	(487272, 127, '2014-01-15 00:44:22.000000', 'consum', 0.0215, 'lps'),
	(487273, 127, '2014-01-15 00:44:23.000000', 'consum', 0.0212, 'lps'),
	(487274, 127, '2014-01-15 00:44:24.000000', 'consum', 0.0225, 'lps'),
	(487275, 127, '2014-01-15 00:44:25.000000', 'consum', 0.0210, 'lps'),
	(487276, 127, '2014-01-15 00:44:26.000000', 'consum', 0.0216, 'lps'),
	(487277, 127, '2014-01-15 00:44:27.000000', 'consum', 0.0225, 'lps'),
	(487278, 127, '2014-01-15 00:44:28.000000', 'consum', 0.0215, 'lps'),
	(487279, 127, '2014-01-15 00:44:29.000000', 'consum', 0.0226, 'lps'),
	(487280, 127, '2014-01-15 00:44:30.000000', 'consum', 0.0223, 'lps'),
	(487281, 127, '2014-01-15 00:44:31.000000', 'consum', 0.0213, 'lps'),
	(487282, 127, '2014-01-15 00:44:32.000000', 'consum', 0.0219, 'lps'),
	(487283, 127, '2014-01-15 00:44:33.000000', 'consum', 0.0211, 'lps'),
	(487284, 127, '2014-01-15 00:44:34.000000', 'consum', 0.0224, 'lps'),
	(487285, 127, '2014-01-15 00:44:35.000000', 'consum', 0.0210, 'lps'),
	(487286, 127, '2014-01-15 00:44:36.000000', 'consum', 0.0221, 'lps'),
	(487287, 127, '2014-01-15 00:44:37.000000', 'consum', 0.0211, 'lps'),
	(487288, 127, '2014-01-15 00:44:38.000000', 'consum', 0.0220, 'lps'),
	(487289, 127, '2014-01-15 00:44:39.000000', 'consum', 0.0222, 'lps'),
	(487290, 127, '2014-01-15 00:44:40.000000', 'consum', 0.0222, 'lps'),
	(487291, 127, '2014-01-15 00:44:41.000000', 'consum', 0.0219, 'lps'),
	(487292, 127, '2014-01-15 00:44:42.000000', 'consum', 0.0221, 'lps'),
	(487293, 127, '2014-01-15 00:44:43.000000', 'consum', 0.0219, 'lps'),
	(487294, 127, '2014-01-15 00:44:44.000000', 'consum', 0.0224, 'lps'),
	(487295, 127, '2014-01-15 00:44:45.000000', 'consum', 0.0218, 'lps'),
	(487296, 127, '2014-01-15 00:44:46.000000', 'consum', 0.0210, 'lps'),
	(487297, 127, '2014-01-15 00:44:47.000000', 'consum', 0.0221, 'lps'),
	(487298, 127, '2014-01-15 00:44:48.000000', 'consum', 0.0215, 'lps'),
	(487299, 127, '2014-01-15 00:44:49.000000', 'consum', 0.0217, 'lps'),
	(487300, 127, '2014-01-15 00:44:50.000000', 'consum', 0.0217, 'lps'),
	(487301, 127, '2014-01-15 00:44:51.000000', 'consum', 0.0221, 'lps'),
	(487302, 127, '2014-01-15 00:44:52.000000', 'consum', 0.0213, 'lps'),
	(487303, 127, '2014-01-15 00:44:53.000000', 'consum', 0.0224, 'lps'),
	(487304, 127, '2014-01-15 00:44:54.000000', 'consum', 0.0220, 'lps'),
	(487305, 127, '2014-01-15 00:44:55.000000', 'consum', 0.0222, 'lps'),
	(487306, 127, '2014-01-15 00:44:56.000000', 'consum', 0.0220, 'lps'),
	(487307, 127, '2014-01-15 00:44:57.000000', 'consum', 0.0226, 'lps'),
	(487308, 127, '2014-01-15 00:44:58.000000', 'consum', 0.0211, 'lps'),
	(487309, 127, '2014-01-15 00:44:59.000000', 'consum', 0.0217, 'lps'),
	(487310, 127, '2014-01-15 00:45:00.000000', 'consum', 0.0225, 'lps'),
	(487311, 127, '2014-01-15 00:45:01.000000', 'consum', 0.0215, 'lps'),
	(487312, 127, '2014-01-15 00:45:02.000000', 'consum', 0.0224, 'lps'),
	(487313, 127, '2014-01-15 00:45:03.000000', 'consum', 0.0214, 'lps'),
	(487314, 127, '2014-01-15 00:45:04.000000', 'consum', 0.0222, 'lps'),
	(487315, 127, '2014-01-15 00:45:05.000000', 'consum', 0.0224, 'lps'),
	(487316, 127, '2014-01-15 00:45:06.000000', 'consum', 0.0210, 'lps'),
	(487317, 127, '2014-01-15 00:45:07.000000', 'consum', 0.0220, 'lps'),
	(487318, 127, '2014-01-15 00:45:08.000000', 'consum', 0.0210, 'lps'),
	(487319, 127, '2014-01-15 00:45:09.000000', 'consum', 0.0215, 'lps'),
	(487320, 127, '2014-01-15 00:45:10.000000', 'consum', 0.0218, 'lps'),
	(487321, 127, '2014-01-15 00:45:11.000000', 'consum', 0.0217, 'lps'),
	(487322, 127, '2014-01-15 00:45:12.000000', 'consum', 0.0223, 'lps'),
	(487323, 127, '2014-01-15 00:45:13.000000', 'consum', 0.0218, 'lps'),
	(487324, 127, '2014-01-15 00:45:14.000000', 'consum', 0.0214, 'lps'),
	(487325, 127, '2014-01-15 00:45:15.000000', 'consum', 0.0224, 'lps'),
	(487326, 127, '2014-01-15 00:45:16.000000', 'consum', 0.0216, 'lps'),
	(487327, 127, '2014-01-15 00:45:17.000000', 'consum', 0.0216, 'lps'),
	(487328, 127, '2014-01-15 00:45:18.000000', 'consum', 0.0221, 'lps'),
	(487329, 127, '2014-01-15 00:45:19.000000', 'consum', 0.0213, 'lps'),
	(487330, 127, '2014-01-15 00:45:20.000000', 'consum', 0.0226, 'lps'),
	(487331, 127, '2014-01-15 00:45:21.000000', 'consum', 0.0214, 'lps'),
	(487332, 127, '2014-01-15 00:45:22.000000', 'consum', 0.0216, 'lps'),
	(487333, 127, '2014-01-15 00:45:23.000000', 'consum', 0.0212, 'lps'),
	(487334, 127, '2014-01-15 00:45:24.000000', 'consum', 0.0219, 'lps'),
	(487335, 127, '2014-01-15 00:45:25.000000', 'consum', 0.0217, 'lps'),
	(487336, 127, '2014-01-15 00:45:26.000000', 'consum', 0.0216, 'lps'),
	(487337, 127, '2014-01-15 00:45:27.000000', 'consum', 0.0222, 'lps'),
	(487338, 127, '2014-01-15 00:45:28.000000', 'consum', 0.0216, 'lps'),
	(487339, 127, '2014-01-15 00:45:29.000000', 'consum', 0.0225, 'lps'),
	(487340, 127, '2014-01-15 00:45:30.000000', 'consum', 0.0214, 'lps'),
	(487341, 127, '2014-01-15 00:45:31.000000', 'consum', 0.0219, 'lps'),
	(487342, 127, '2014-01-15 00:45:32.000000', 'consum', 0.0210, 'lps'),
	(487343, 127, '2014-01-15 00:45:33.000000', 'consum', 0.0219, 'lps'),
	(487344, 127, '2014-01-15 00:45:34.000000', 'consum', 0.0220, 'lps'),
	(487345, 127, '2014-01-15 00:45:35.000000', 'consum', 0.0216, 'lps'),
	(487346, 127, '2014-01-15 00:45:36.000000', 'consum', 0.0226, 'lps'),
	(487347, 127, '2014-01-15 00:45:37.000000', 'consum', 0.0225, 'lps'),
	(487348, 127, '2014-01-15 00:45:38.000000', 'consum', 0.0220, 'lps'),
	(487349, 127, '2014-01-15 00:45:39.000000', 'consum', 0.0213, 'lps'),
	(487350, 127, '2014-01-15 00:45:40.000000', 'consum', 0.0215, 'lps'),
	(487351, 127, '2014-01-15 00:45:41.000000', 'consum', 0.0226, 'lps'),
	(487352, 127, '2014-01-15 00:45:42.000000', 'consum', 0.0222, 'lps'),
	(487353, 127, '2014-01-15 00:45:43.000000', 'consum', 0.0225, 'lps'),
	(487354, 127, '2014-01-15 00:45:44.000000', 'consum', 0.0214, 'lps'),
	(487355, 127, '2014-01-15 00:45:45.000000', 'consum', 0.0220, 'lps'),
	(487356, 127, '2014-01-15 00:45:46.000000', 'consum', 0.0216, 'lps'),
	(487357, 127, '2014-01-15 00:45:47.000000', 'consum', 0.0225, 'lps'),
	(487358, 127, '2014-01-15 00:45:48.000000', 'consum', 0.0216, 'lps'),
	(487359, 127, '2014-01-15 00:45:49.000000', 'consum', 0.0214, 'lps'),
	(487360, 127, '2014-01-15 00:45:50.000000', 'consum', 0.0213, 'lps'),
	(487361, 127, '2014-01-15 00:45:51.000000', 'consum', 0.0215, 'lps'),
	(487362, 127, '2014-01-15 00:45:52.000000', 'consum', 0.0225, 'lps'),
	(487363, 127, '2014-01-15 00:45:53.000000', 'consum', 0.0220, 'lps'),
	(487364, 127, '2014-01-15 00:45:54.000000', 'consum', 0.0217, 'lps'),
	(487365, 127, '2014-01-15 00:45:55.000000', 'consum', 0.0212, 'lps'),
	(487366, 127, '2014-01-15 00:45:56.000000', 'consum', 0.0219, 'lps'),
	(487367, 127, '2014-01-15 00:45:57.000000', 'consum', 0.0216, 'lps'),
	(487368, 127, '2014-01-15 00:45:58.000000', 'consum', 0.0214, 'lps'),
	(487369, 127, '2014-01-15 00:45:59.000000', 'consum', 0.0211, 'lps'),
	(487370, 127, '2014-01-15 00:46:00.000000', 'consum', 0.0222, 'lps'),
	(487371, 127, '2014-01-15 00:46:01.000000', 'consum', 0.0218, 'lps'),
	(487372, 127, '2014-01-15 00:46:02.000000', 'consum', 0.0211, 'lps'),
	(487373, 127, '2014-01-15 00:46:03.000000', 'consum', 0.0212, 'lps'),
	(487374, 127, '2014-01-15 00:46:04.000000', 'consum', 0.0214, 'lps'),
	(487375, 127, '2014-01-15 00:46:05.000000', 'consum', 0.0210, 'lps'),
	(487376, 127, '2014-01-15 00:46:06.000000', 'consum', 0.0213, 'lps'),
	(487377, 127, '2014-01-15 00:46:07.000000', 'consum', 0.0211, 'lps'),
	(487378, 127, '2014-01-15 00:46:08.000000', 'consum', 0.0221, 'lps'),
	(487379, 127, '2014-01-15 00:46:09.000000', 'consum', 0.0211, 'lps'),
	(487380, 127, '2014-01-15 00:46:10.000000', 'consum', 0.0217, 'lps'),
	(487381, 127, '2014-01-15 00:46:11.000000', 'consum', 0.0224, 'lps'),
	(487382, 127, '2014-01-15 00:46:12.000000', 'consum', 0.0211, 'lps'),
	(487383, 127, '2014-01-15 00:46:13.000000', 'consum', 0.0222, 'lps'),
	(487384, 127, '2014-01-15 00:46:14.000000', 'consum', 0.0217, 'lps'),
	(487385, 127, '2014-01-15 00:46:15.000000', 'consum', 0.0212, 'lps'),
	(487386, 127, '2014-01-15 00:46:16.000000', 'consum', 0.0215, 'lps'),
	(487387, 127, '2014-01-15 00:46:17.000000', 'consum', 0.0210, 'lps'),
	(487388, 127, '2014-01-15 00:46:18.000000', 'consum', 0.0216, 'lps'),
	(487389, 127, '2014-01-15 00:46:19.000000', 'consum', 0.0224, 'lps'),
	(487390, 127, '2014-01-15 00:46:20.000000', 'consum', 0.0211, 'lps'),
	(487391, 127, '2014-01-15 00:46:21.000000', 'consum', 0.0223, 'lps'),
	(487392, 127, '2014-01-15 00:46:22.000000', 'consum', 0.0221, 'lps'),
	(487393, 127, '2014-01-15 00:46:23.000000', 'consum', 0.0226, 'lps'),
	(487394, 127, '2014-01-15 00:46:24.000000', 'consum', 0.0223, 'lps'),
	(487395, 127, '2014-01-15 00:46:25.000000', 'consum', 0.0210, 'lps'),
	(487396, 127, '2014-01-15 00:46:26.000000', 'consum', 0.0223, 'lps'),
	(487397, 127, '2014-01-15 00:46:27.000000', 'consum', 0.0226, 'lps'),
	(487398, 127, '2014-01-15 00:46:28.000000', 'consum', 0.0216, 'lps'),
	(487399, 127, '2014-01-15 00:46:29.000000', 'consum', 0.0226, 'lps'),
	(487400, 127, '2014-01-15 00:46:30.000000', 'consum', 0.0222, 'lps'),
	(487401, 127, '2014-01-15 00:46:31.000000', 'consum', 0.0221, 'lps'),
	(487402, 127, '2014-01-15 00:46:32.000000', 'consum', 0.0213, 'lps'),
	(487403, 127, '2014-01-15 00:46:33.000000', 'consum', 0.0210, 'lps'),
	(487404, 127, '2014-01-15 00:46:34.000000', 'consum', 0.0216, 'lps'),
	(487405, 127, '2014-01-15 00:46:35.000000', 'consum', 0.0210, 'lps'),
	(487406, 127, '2014-01-15 00:46:36.000000', 'consum', 0.0224, 'lps'),
	(487407, 127, '2014-01-15 00:46:37.000000', 'consum', 0.0212, 'lps'),
	(487408, 127, '2014-01-15 00:46:38.000000', 'consum', 0.0214, 'lps'),
	(487409, 127, '2014-01-15 00:46:39.000000', 'consum', 0.0225, 'lps'),
	(487410, 127, '2014-01-15 00:46:40.000000', 'consum', 0.0222, 'lps'),
	(487411, 127, '2014-01-15 00:46:41.000000', 'consum', 0.0224, 'lps'),
	(487412, 127, '2014-01-15 00:46:42.000000', 'consum', 0.0210, 'lps'),
	(487413, 127, '2014-01-15 00:46:43.000000', 'consum', 0.0218, 'lps'),
	(487414, 127, '2014-01-15 00:46:44.000000', 'consum', 0.0220, 'lps'),
	(487415, 127, '2014-01-15 00:46:45.000000', 'consum', 0.0219, 'lps'),
	(487416, 127, '2014-01-15 00:46:46.000000', 'consum', 0.0224, 'lps'),
	(487417, 127, '2014-01-15 00:46:47.000000', 'consum', 0.0220, 'lps'),
	(487418, 127, '2014-01-15 00:46:48.000000', 'consum', 0.0217, 'lps'),
	(487419, 127, '2014-01-15 00:46:49.000000', 'consum', 0.0217, 'lps'),
	(487420, 127, '2014-01-15 00:46:50.000000', 'consum', 0.0223, 'lps'),
	(487421, 127, '2014-01-15 00:46:51.000000', 'consum', 0.0221, 'lps'),
	(487422, 127, '2014-01-15 00:46:52.000000', 'consum', 0.0211, 'lps'),
	(487423, 127, '2014-01-15 00:46:53.000000', 'consum', 0.0217, 'lps'),
	(487424, 127, '2014-01-15 00:46:54.000000', 'consum', 0.0224, 'lps'),
	(487425, 127, '2014-01-15 00:46:55.000000', 'consum', 0.0210, 'lps'),
	(487426, 127, '2014-01-15 00:46:56.000000', 'consum', 0.0220, 'lps'),
	(487427, 127, '2014-01-15 00:46:57.000000', 'consum', 0.0226, 'lps'),
	(487428, 127, '2014-01-15 00:46:58.000000', 'consum', 0.0225, 'lps'),
	(487429, 127, '2014-01-15 00:46:59.000000', 'consum', 0.0223, 'lps'),
	(487430, 127, '2014-01-15 00:47:00.000000', 'consum', 0.0213, 'lps'),
	(487431, 127, '2014-01-15 00:47:01.000000', 'consum', 0.0221, 'lps'),
	(487432, 127, '2014-01-15 00:47:02.000000', 'consum', 0.0223, 'lps'),
	(487433, 127, '2014-01-15 00:47:03.000000', 'consum', 0.0223, 'lps'),
	(487434, 127, '2014-01-15 00:47:04.000000', 'consum', 0.0220, 'lps'),
	(487435, 127, '2014-01-15 00:47:05.000000', 'consum', 0.0221, 'lps'),
	(487436, 127, '2014-01-15 00:47:06.000000', 'consum', 0.0219, 'lps'),
	(487437, 127, '2014-01-15 00:47:07.000000', 'consum', 0.0221, 'lps'),
	(487438, 127, '2014-01-15 00:47:08.000000', 'consum', 0.0224, 'lps'),
	(487439, 127, '2014-01-15 00:47:09.000000', 'consum', 0.0212, 'lps'),
	(487440, 127, '2014-01-15 00:47:10.000000', 'consum', 0.0213, 'lps'),
	(487441, 127, '2014-01-15 00:47:11.000000', 'consum', 0.0218, 'lps'),
	(487442, 127, '2014-01-15 00:47:12.000000', 'consum', 0.0226, 'lps'),
	(487443, 127, '2014-01-15 00:47:13.000000', 'consum', 0.0216, 'lps'),
	(487444, 127, '2014-01-15 00:47:14.000000', 'consum', 0.0224, 'lps'),
	(487445, 127, '2014-01-15 00:47:15.000000', 'consum', 0.0213, 'lps'),
	(487446, 127, '2014-01-15 00:47:16.000000', 'consum', 0.0219, 'lps'),
	(487447, 127, '2014-01-15 00:47:17.000000', 'consum', 0.0212, 'lps'),
	(487448, 127, '2014-01-15 00:47:18.000000', 'consum', 0.0211, 'lps'),
	(487449, 127, '2014-01-15 00:47:19.000000', 'consum', 0.0210, 'lps'),
	(487450, 127, '2014-01-15 00:47:20.000000', 'consum', 0.0224, 'lps'),
	(487451, 127, '2014-01-15 00:47:21.000000', 'consum', 0.0211, 'lps'),
	(487452, 127, '2014-01-15 00:47:22.000000', 'consum', 0.0210, 'lps'),
	(487453, 127, '2014-01-15 00:47:23.000000', 'consum', 0.0223, 'lps'),
	(487454, 127, '2014-01-15 00:47:24.000000', 'consum', 0.0223, 'lps'),
	(487455, 127, '2014-01-15 00:47:25.000000', 'consum', 0.0220, 'lps'),
	(487456, 127, '2014-01-15 00:47:26.000000', 'consum', 0.0222, 'lps'),
	(487457, 127, '2014-01-15 00:47:27.000000', 'consum', 0.0224, 'lps'),
	(487458, 127, '2014-01-15 00:47:28.000000', 'consum', 0.0211, 'lps'),
	(487459, 127, '2014-01-15 00:47:29.000000', 'consum', 0.0225, 'lps'),
	(487460, 127, '2014-01-15 00:47:30.000000', 'consum', 0.0215, 'lps'),
	(487461, 127, '2014-01-15 00:47:31.000000', 'consum', 0.0224, 'lps'),
	(487462, 127, '2014-01-15 00:47:32.000000', 'consum', 0.0213, 'lps'),
	(487463, 127, '2014-01-15 00:47:33.000000', 'consum', 0.0217, 'lps'),
	(487464, 127, '2014-01-15 00:47:34.000000', 'consum', 0.0220, 'lps'),
	(487465, 127, '2014-01-15 00:47:35.000000', 'consum', 0.0224, 'lps'),
	(487466, 127, '2014-01-15 00:47:36.000000', 'consum', 0.0215, 'lps'),
	(487467, 127, '2014-01-15 00:47:37.000000', 'consum', 0.0212, 'lps'),
	(487468, 127, '2014-01-15 00:47:38.000000', 'consum', 0.0222, 'lps'),
	(487469, 127, '2014-01-15 00:47:39.000000', 'consum', 0.0213, 'lps'),
	(487470, 127, '2014-01-15 00:47:40.000000', 'consum', 0.0226, 'lps'),
	(487471, 127, '2014-01-15 00:47:41.000000', 'consum', 0.0210, 'lps'),
	(487472, 127, '2014-01-15 00:47:42.000000', 'consum', 0.0215, 'lps'),
	(487473, 127, '2014-01-15 00:47:43.000000', 'consum', 0.0221, 'lps'),
	(487474, 127, '2014-01-15 00:47:44.000000', 'consum', 0.0213, 'lps'),
	(487475, 127, '2014-01-15 00:47:45.000000', 'consum', 0.0226, 'lps'),
	(487476, 127, '2014-01-15 00:47:46.000000', 'consum', 0.0216, 'lps'),
	(487477, 127, '2014-01-15 00:47:47.000000', 'consum', 0.0224, 'lps'),
	(487478, 127, '2014-01-15 00:47:48.000000', 'consum', 0.0212, 'lps'),
	(487479, 127, '2014-01-15 00:47:49.000000', 'consum', 0.0214, 'lps'),
	(487480, 127, '2014-01-15 00:47:50.000000', 'consum', 0.0224, 'lps'),
	(487481, 127, '2014-01-15 00:47:51.000000', 'consum', 0.0219, 'lps'),
	(487482, 127, '2014-01-15 00:47:52.000000', 'consum', 0.0212, 'lps'),
	(487483, 127, '2014-01-15 00:47:53.000000', 'consum', 0.0210, 'lps'),
	(487484, 127, '2014-01-15 00:47:54.000000', 'consum', 0.0223, 'lps'),
	(487485, 127, '2014-01-15 00:47:55.000000', 'consum', 0.0224, 'lps'),
	(487486, 127, '2014-01-15 00:47:56.000000', 'consum', 0.0225, 'lps'),
	(487487, 127, '2014-01-15 00:47:57.000000', 'consum', 0.0210, 'lps'),
	(487488, 127, '2014-01-15 00:47:58.000000', 'consum', 0.0215, 'lps'),
	(487489, 127, '2014-01-15 00:47:59.000000', 'consum', 0.0220, 'lps'),
	(487490, 127, '2014-01-15 00:48:00.000000', 'consum', 0.0210, 'lps'),
	(487491, 127, '2014-01-15 00:48:01.000000', 'consum', 0.0217, 'lps'),
	(487492, 127, '2014-01-15 00:48:02.000000', 'consum', 0.0225, 'lps'),
	(487493, 127, '2014-01-15 00:48:03.000000', 'consum', 0.0217, 'lps'),
	(487494, 127, '2014-01-15 00:48:04.000000', 'consum', 0.0217, 'lps'),
	(487495, 127, '2014-01-15 00:48:05.000000', 'consum', 0.0223, 'lps'),
	(487496, 127, '2014-01-15 00:48:06.000000', 'consum', 0.0221, 'lps'),
	(487497, 127, '2014-01-15 00:48:07.000000', 'consum', 0.0225, 'lps'),
	(487498, 127, '2014-01-15 00:48:08.000000', 'consum', 0.0222, 'lps'),
	(487499, 127, '2014-01-15 00:48:09.000000', 'consum', 0.0222, 'lps'),
	(487500, 127, '2014-01-15 00:48:10.000000', 'consum', 0.0219, 'lps'),
	(487501, 127, '2014-01-15 00:48:11.000000', 'consum', 0.0219, 'lps'),
	(487502, 127, '2014-01-15 00:48:12.000000', 'consum', 0.0213, 'lps'),
	(487503, 127, '2014-01-15 00:48:13.000000', 'consum', 0.0214, 'lps'),
	(487504, 127, '2014-01-15 00:48:14.000000', 'consum', 0.0223, 'lps'),
	(487505, 127, '2014-01-15 00:48:15.000000', 'consum', 0.0210, 'lps'),
	(487506, 127, '2014-01-15 00:48:16.000000', 'consum', 0.0224, 'lps'),
	(487507, 127, '2014-01-15 00:48:17.000000', 'consum', 0.0211, 'lps'),
	(487508, 127, '2014-01-15 00:48:18.000000', 'consum', 0.0224, 'lps'),
	(487509, 127, '2014-01-15 00:48:19.000000', 'consum', 0.0210, 'lps'),
	(487510, 127, '2014-01-15 00:48:20.000000', 'consum', 0.0219, 'lps'),
	(487511, 127, '2014-01-15 00:48:21.000000', 'consum', 0.0220, 'lps'),
	(487512, 127, '2014-01-15 00:48:22.000000', 'consum', 0.0219, 'lps'),
	(487513, 127, '2014-01-15 00:48:23.000000', 'consum', 0.0223, 'lps'),
	(487514, 127, '2014-01-15 00:48:24.000000', 'consum', 0.0218, 'lps'),
	(487515, 127, '2014-01-15 00:48:25.000000', 'consum', 0.0225, 'lps'),
	(487516, 127, '2014-01-15 00:48:26.000000', 'consum', 0.0212, 'lps'),
	(487517, 127, '2014-01-15 00:48:27.000000', 'consum', 0.0210, 'lps'),
	(487518, 127, '2014-01-15 00:48:28.000000', 'consum', 0.0219, 'lps'),
	(487519, 127, '2014-01-15 00:48:29.000000', 'consum', 0.0224, 'lps'),
	(487520, 127, '2014-01-15 00:48:30.000000', 'consum', 0.0220, 'lps'),
	(487521, 127, '2014-01-15 00:48:31.000000', 'consum', 0.0220, 'lps'),
	(487522, 127, '2014-01-15 00:48:32.000000', 'consum', 0.0210, 'lps'),
	(487523, 127, '2014-01-15 00:48:33.000000', 'consum', 0.0215, 'lps'),
	(487524, 127, '2014-01-15 00:48:34.000000', 'consum', 0.0220, 'lps'),
	(487525, 127, '2014-01-15 00:48:35.000000', 'consum', 0.0211, 'lps'),
	(487526, 127, '2014-01-15 00:48:36.000000', 'consum', 0.0221, 'lps'),
	(487527, 127, '2014-01-15 00:48:37.000000', 'consum', 0.0225, 'lps'),
	(487528, 127, '2014-01-15 00:48:38.000000', 'consum', 0.0222, 'lps'),
	(487529, 127, '2014-01-15 00:48:39.000000', 'consum', 0.0225, 'lps'),
	(487530, 127, '2014-01-15 00:48:40.000000', 'consum', 0.0214, 'lps'),
	(487531, 127, '2014-01-15 00:48:41.000000', 'consum', 0.0222, 'lps'),
	(487532, 127, '2014-01-15 00:48:42.000000', 'consum', 0.0222, 'lps'),
	(487533, 127, '2014-01-15 00:48:43.000000', 'consum', 0.0220, 'lps'),
	(487534, 127, '2014-01-15 00:48:44.000000', 'consum', 0.0222, 'lps'),
	(487535, 127, '2014-01-15 00:48:45.000000', 'consum', 0.0223, 'lps'),
	(487536, 127, '2014-01-15 00:48:46.000000', 'consum', 0.0222, 'lps'),
	(487537, 127, '2014-01-15 00:48:47.000000', 'consum', 0.0216, 'lps'),
	(487538, 127, '2014-01-15 00:48:48.000000', 'consum', 0.0221, 'lps'),
	(487539, 127, '2014-01-15 00:48:49.000000', 'consum', 0.0213, 'lps'),
	(487540, 127, '2014-01-15 00:48:50.000000', 'consum', 0.0211, 'lps'),
	(487541, 127, '2014-01-15 00:48:51.000000', 'consum', 0.0222, 'lps'),
	(487542, 127, '2014-01-15 00:48:52.000000', 'consum', 0.0216, 'lps'),
	(487543, 127, '2014-01-15 00:48:53.000000', 'consum', 0.0221, 'lps'),
	(487544, 127, '2014-01-15 00:48:54.000000', 'consum', 0.0214, 'lps'),
	(487545, 127, '2014-01-15 00:48:55.000000', 'consum', 0.0213, 'lps'),
	(487546, 127, '2014-01-15 00:48:56.000000', 'consum', 0.0214, 'lps'),
	(487547, 127, '2014-01-15 00:48:57.000000', 'consum', 0.0223, 'lps'),
	(487548, 127, '2014-01-15 00:48:58.000000', 'consum', 0.0210, 'lps'),
	(487549, 127, '2014-01-15 00:48:59.000000', 'consum', 0.0224, 'lps'),
	(487550, 127, '2014-01-15 00:49:00.000000', 'consum', 0.0210, 'lps'),
	(487551, 127, '2014-01-15 00:49:01.000000', 'consum', 0.0222, 'lps'),
	(487552, 127, '2014-01-15 00:49:02.000000', 'consum', 0.0219, 'lps'),
	(487553, 127, '2014-01-15 00:49:03.000000', 'consum', 0.0221, 'lps'),
	(487554, 127, '2014-01-15 00:49:04.000000', 'consum', 0.0218, 'lps'),
	(487555, 127, '2014-01-15 00:49:05.000000', 'consum', 0.0220, 'lps'),
	(487556, 127, '2014-01-15 00:49:06.000000', 'consum', 0.0220, 'lps'),
	(487557, 127, '2014-01-15 00:49:07.000000', 'consum', 0.0213, 'lps'),
	(487558, 127, '2014-01-15 00:49:08.000000', 'consum', 0.0211, 'lps'),
	(487559, 127, '2014-01-15 00:49:09.000000', 'consum', 0.0224, 'lps'),
	(487560, 127, '2014-01-15 00:49:10.000000', 'consum', 0.0211, 'lps'),
	(487561, 127, '2014-01-15 00:49:11.000000', 'consum', 0.0222, 'lps'),
	(487562, 127, '2014-01-15 00:49:12.000000', 'consum', 0.0216, 'lps'),
	(487563, 127, '2014-01-15 00:49:13.000000', 'consum', 0.0222, 'lps'),
	(487564, 127, '2014-01-15 00:49:14.000000', 'consum', 0.0217, 'lps'),
	(487565, 127, '2014-01-15 00:49:15.000000', 'consum', 0.0211, 'lps'),
	(487566, 127, '2014-01-15 00:49:16.000000', 'consum', 0.0210, 'lps'),
	(487567, 127, '2014-01-15 00:49:17.000000', 'consum', 0.0225, 'lps'),
	(487568, 127, '2014-01-15 00:49:18.000000', 'consum', 0.0218, 'lps'),
	(487569, 127, '2014-01-15 00:49:19.000000', 'consum', 0.0224, 'lps'),
	(487570, 127, '2014-01-15 00:49:20.000000', 'consum', 0.0220, 'lps'),
	(487571, 127, '2014-01-15 00:49:21.000000', 'consum', 0.0221, 'lps'),
	(487572, 127, '2014-01-15 00:49:22.000000', 'consum', 0.0218, 'lps'),
	(487573, 127, '2014-01-15 00:49:23.000000', 'consum', 0.0217, 'lps'),
	(487574, 127, '2014-01-15 00:49:24.000000', 'consum', 0.0223, 'lps'),
	(487575, 127, '2014-01-15 00:49:25.000000', 'consum', 0.0221, 'lps'),
	(487576, 127, '2014-01-15 00:49:26.000000', 'consum', 0.0226, 'lps'),
	(487577, 127, '2014-01-15 00:49:27.000000', 'consum', 0.0223, 'lps'),
	(487578, 127, '2014-01-15 00:49:28.000000', 'consum', 0.0226, 'lps'),
	(487579, 127, '2014-01-15 00:49:29.000000', 'consum', 0.0218, 'lps'),
	(487580, 127, '2014-01-15 00:49:30.000000', 'consum', 0.0220, 'lps'),
	(487581, 127, '2014-01-15 00:49:31.000000', 'consum', 0.0221, 'lps'),
	(487582, 127, '2014-01-15 00:49:32.000000', 'consum', 0.0218, 'lps'),
	(487583, 127, '2014-01-15 00:49:33.000000', 'consum', 0.0216, 'lps'),
	(487584, 127, '2014-01-15 00:49:34.000000', 'consum', 0.0216, 'lps'),
	(487585, 127, '2014-01-15 00:49:35.000000', 'consum', 0.0221, 'lps'),
	(487586, 127, '2014-01-15 00:49:36.000000', 'consum', 0.0217, 'lps'),
	(487587, 127, '2014-01-15 00:49:37.000000', 'consum', 0.0212, 'lps'),
	(487588, 127, '2014-01-15 00:49:38.000000', 'consum', 0.0214, 'lps'),
	(487589, 127, '2014-01-15 00:49:39.000000', 'consum', 0.0210, 'lps'),
	(487590, 127, '2014-01-15 00:49:40.000000', 'consum', 0.0215, 'lps'),
	(487591, 127, '2014-01-15 00:49:41.000000', 'consum', 0.0218, 'lps'),
	(487592, 127, '2014-01-15 00:49:42.000000', 'consum', 0.0217, 'lps'),
	(487593, 127, '2014-01-15 00:49:43.000000', 'consum', 0.0224, 'lps'),
	(487594, 127, '2014-01-15 00:49:44.000000', 'consum', 0.0224, 'lps'),
	(487595, 127, '2014-01-15 00:49:45.000000', 'consum', 0.0224, 'lps'),
	(487596, 127, '2014-01-15 00:49:46.000000', 'consum', 0.0219, 'lps'),
	(487597, 127, '2014-01-15 00:49:47.000000', 'consum', 0.0214, 'lps'),
	(487598, 127, '2014-01-15 00:49:48.000000', 'consum', 0.0221, 'lps'),
	(487599, 127, '2014-01-15 00:49:49.000000', 'consum', 0.0218, 'lps'),
	(487600, 127, '2014-01-15 00:49:50.000000', 'consum', 0.0217, 'lps'),
	(487601, 127, '2014-01-15 00:49:51.000000', 'consum', 0.0220, 'lps'),
	(487602, 127, '2014-01-15 00:49:52.000000', 'consum', 0.0226, 'lps'),
	(487603, 127, '2014-01-15 00:49:53.000000', 'consum', 0.0225, 'lps'),
	(487604, 127, '2014-01-15 00:49:54.000000', 'consum', 0.0219, 'lps'),
	(487605, 127, '2014-01-15 00:49:55.000000', 'consum', 0.0212, 'lps'),
	(487606, 127, '2014-01-15 00:49:56.000000', 'consum', 0.0226, 'lps'),
	(487607, 127, '2014-01-15 00:49:57.000000', 'consum', 0.0218, 'lps'),
	(487608, 127, '2014-01-15 00:49:58.000000', 'consum', 0.0220, 'lps'),
	(487609, 127, '2014-01-15 00:49:59.000000', 'consum', 0.0221, 'lps'),
	(487610, 127, '2014-01-15 00:50:00.000000', 'consum', 0.0217, 'lps'),
	(487611, 127, '2014-01-15 00:50:01.000000', 'consum', 0.0211, 'lps'),
	(487612, 127, '2014-01-15 00:50:02.000000', 'consum', 0.0213, 'lps'),
	(487613, 127, '2014-01-15 00:50:03.000000', 'consum', 0.0224, 'lps'),
	(487614, 127, '2014-01-15 00:50:04.000000', 'consum', 0.0219, 'lps'),
	(487615, 127, '2014-01-15 00:50:05.000000', 'consum', 0.0214, 'lps'),
	(487616, 127, '2014-01-15 00:50:06.000000', 'consum', 0.0220, 'lps'),
	(487617, 127, '2014-01-15 00:50:07.000000', 'consum', 0.0214, 'lps'),
	(487618, 127, '2014-01-15 00:50:08.000000', 'consum', 0.0217, 'lps'),
	(487619, 127, '2014-01-15 00:50:09.000000', 'consum', 0.0216, 'lps'),
	(487620, 127, '2014-01-15 00:50:10.000000', 'consum', 0.0218, 'lps'),
	(487621, 127, '2014-01-15 00:50:11.000000', 'consum', 0.0218, 'lps'),
	(487622, 127, '2014-01-15 00:50:12.000000', 'consum', 0.0211, 'lps'),
	(487623, 127, '2014-01-15 00:50:13.000000', 'consum', 0.0224, 'lps'),
	(487624, 127, '2014-01-15 00:50:14.000000', 'consum', 0.0226, 'lps'),
	(487625, 127, '2014-01-15 00:50:15.000000', 'consum', 0.0214, 'lps'),
	(487626, 127, '2014-01-15 00:50:16.000000', 'consum', 0.0217, 'lps'),
	(487627, 127, '2014-01-15 00:50:17.000000', 'consum', 0.0217, 'lps'),
	(487628, 127, '2014-01-15 00:50:18.000000', 'consum', 0.0223, 'lps'),
	(487629, 127, '2014-01-15 00:50:19.000000', 'consum', 0.0223, 'lps'),
	(487630, 127, '2014-01-15 00:50:20.000000', 'consum', 0.0218, 'lps'),
	(487631, 127, '2014-01-15 00:50:21.000000', 'consum', 0.0213, 'lps'),
	(487632, 127, '2014-01-15 00:50:22.000000', 'consum', 0.0218, 'lps'),
	(487633, 127, '2014-01-15 00:50:23.000000', 'consum', 0.0224, 'lps'),
	(487634, 127, '2014-01-15 00:50:24.000000', 'consum', 0.0223, 'lps'),
	(487635, 127, '2014-01-15 00:50:25.000000', 'consum', 0.0215, 'lps'),
	(487636, 127, '2014-01-15 00:50:26.000000', 'consum', 0.0215, 'lps'),
	(487637, 127, '2014-01-15 00:50:27.000000', 'consum', 0.0219, 'lps'),
	(487638, 127, '2014-01-15 00:50:28.000000', 'consum', 0.0224, 'lps'),
	(487639, 127, '2014-01-15 00:50:29.000000', 'consum', 0.0218, 'lps'),
	(487640, 127, '2014-01-15 00:50:30.000000', 'consum', 0.0226, 'lps'),
	(487641, 127, '2014-01-15 00:50:31.000000', 'consum', 0.0215, 'lps'),
	(487642, 127, '2014-01-15 00:50:32.000000', 'consum', 0.0221, 'lps'),
	(487643, 127, '2014-01-15 00:50:33.000000', 'consum', 0.0215, 'lps'),
	(487644, 127, '2014-01-15 00:50:34.000000', 'consum', 0.0222, 'lps'),
	(487645, 127, '2014-01-15 00:50:35.000000', 'consum', 0.0220, 'lps'),
	(487646, 127, '2014-01-15 00:50:36.000000', 'consum', 0.0226, 'lps'),
	(487647, 127, '2014-01-15 00:50:37.000000', 'consum', 0.0211, 'lps'),
	(487648, 127, '2014-01-15 00:50:38.000000', 'consum', 0.0216, 'lps'),
	(487649, 127, '2014-01-15 00:50:39.000000', 'consum', 0.0219, 'lps'),
	(487650, 127, '2014-01-15 00:50:40.000000', 'consum', 0.0222, 'lps'),
	(487651, 127, '2014-01-15 00:50:41.000000', 'consum', 0.0211, 'lps'),
	(487652, 127, '2014-01-15 00:50:42.000000', 'consum', 0.0212, 'lps'),
	(487653, 127, '2014-01-15 00:50:43.000000', 'consum', 0.0218, 'lps'),
	(487654, 127, '2014-01-15 00:50:44.000000', 'consum', 0.0210, 'lps'),
	(487655, 127, '2014-01-15 00:50:45.000000', 'consum', 0.0220, 'lps'),
	(487656, 127, '2014-01-15 00:50:46.000000', 'consum', 0.0211, 'lps'),
	(487657, 127, '2014-01-15 00:50:47.000000', 'consum', 0.0218, 'lps'),
	(487658, 127, '2014-01-15 00:50:48.000000', 'consum', 0.0212, 'lps'),
	(487659, 127, '2014-01-15 00:50:49.000000', 'consum', 0.0215, 'lps'),
	(487660, 127, '2014-01-15 00:50:50.000000', 'consum', 0.0214, 'lps'),
	(487661, 127, '2014-01-15 00:50:51.000000', 'consum', 0.0216, 'lps'),
	(487662, 127, '2014-01-15 00:50:52.000000', 'consum', 0.0210, 'lps'),
	(487663, 127, '2014-01-15 00:50:53.000000', 'consum', 0.0226, 'lps'),
	(487664, 127, '2014-01-15 00:50:54.000000', 'consum', 0.0224, 'lps'),
	(487665, 127, '2014-01-15 00:50:55.000000', 'consum', 0.0216, 'lps'),
	(487666, 127, '2014-01-15 00:50:56.000000', 'consum', 0.0213, 'lps'),
	(487667, 127, '2014-01-15 00:50:57.000000', 'consum', 0.0225, 'lps'),
	(487668, 127, '2014-01-15 00:50:58.000000', 'consum', 0.0210, 'lps'),
	(487669, 127, '2014-01-15 00:50:59.000000', 'consum', 0.0217, 'lps'),
	(487670, 127, '2014-01-15 00:51:00.000000', 'consum', 0.0210, 'lps'),
	(487671, 127, '2014-01-15 00:51:01.000000', 'consum', 0.0225, 'lps'),
	(487672, 127, '2014-01-15 00:51:02.000000', 'consum', 0.0216, 'lps'),
	(487673, 127, '2014-01-15 00:51:03.000000', 'consum', 0.0213, 'lps'),
	(487674, 127, '2014-01-15 00:51:04.000000', 'consum', 0.0224, 'lps'),
	(487675, 127, '2014-01-15 00:51:05.000000', 'consum', 0.0220, 'lps'),
	(487676, 127, '2014-01-15 00:51:06.000000', 'consum', 0.0221, 'lps'),
	(487677, 127, '2014-01-15 00:51:07.000000', 'consum', 0.0218, 'lps'),
	(487678, 127, '2014-01-15 00:51:08.000000', 'consum', 0.0218, 'lps'),
	(487679, 127, '2014-01-15 00:51:09.000000', 'consum', 0.0226, 'lps'),
	(487680, 127, '2014-01-15 00:51:10.000000', 'consum', 0.0214, 'lps'),
	(487681, 127, '2014-01-15 00:51:11.000000', 'consum', 0.0219, 'lps'),
	(487682, 127, '2014-01-15 00:51:12.000000', 'consum', 0.0210, 'lps'),
	(487683, 127, '2014-01-15 00:51:13.000000', 'consum', 0.0218, 'lps'),
	(487684, 127, '2014-01-15 00:51:14.000000', 'consum', 0.0215, 'lps'),
	(487685, 127, '2014-01-15 00:51:15.000000', 'consum', 0.0210, 'lps'),
	(487686, 127, '2014-01-15 00:51:16.000000', 'consum', 0.0216, 'lps'),
	(487687, 127, '2014-01-15 00:51:17.000000', 'consum', 0.0220, 'lps'),
	(487688, 127, '2014-01-15 00:51:18.000000', 'consum', 0.0210, 'lps'),
	(487689, 127, '2014-01-15 00:51:19.000000', 'consum', 0.0214, 'lps'),
	(487690, 127, '2014-01-15 00:51:20.000000', 'consum', 0.0212, 'lps'),
	(487691, 127, '2014-01-15 00:51:21.000000', 'consum', 0.0210, 'lps'),
	(487692, 127, '2014-01-15 00:51:22.000000', 'consum', 0.0219, 'lps'),
	(487693, 127, '2014-01-15 00:51:23.000000', 'consum', 0.0225, 'lps'),
	(487694, 127, '2014-01-15 00:51:24.000000', 'consum', 0.0221, 'lps'),
	(487695, 127, '2014-01-15 00:51:25.000000', 'consum', 0.0223, 'lps'),
	(487696, 127, '2014-01-15 00:51:26.000000', 'consum', 0.0225, 'lps'),
	(487697, 127, '2014-01-15 00:51:27.000000', 'consum', 0.0213, 'lps'),
	(487698, 127, '2014-01-15 00:51:28.000000', 'consum', 0.0214, 'lps'),
	(487699, 127, '2014-01-15 00:51:29.000000', 'consum', 0.0224, 'lps'),
	(487700, 127, '2014-01-15 00:51:30.000000', 'consum', 0.0214, 'lps'),
	(487701, 127, '2014-01-15 00:51:31.000000', 'consum', 0.0225, 'lps'),
	(487702, 127, '2014-01-15 00:51:32.000000', 'consum', 0.0221, 'lps'),
	(487703, 127, '2014-01-15 00:51:33.000000', 'consum', 0.0221, 'lps'),
	(487704, 127, '2014-01-15 00:51:34.000000', 'consum', 0.0217, 'lps'),
	(487705, 127, '2014-01-15 00:51:35.000000', 'consum', 0.0211, 'lps'),
	(487706, 127, '2014-01-15 00:51:36.000000', 'consum', 0.0212, 'lps'),
	(487707, 127, '2014-01-15 00:51:37.000000', 'consum', 0.0219, 'lps'),
	(487708, 127, '2014-01-15 00:51:38.000000', 'consum', 0.0213, 'lps'),
	(487709, 127, '2014-01-15 00:51:39.000000', 'consum', 0.0214, 'lps'),
	(487710, 127, '2014-01-15 00:51:40.000000', 'consum', 0.0225, 'lps'),
	(487711, 127, '2014-01-15 00:51:41.000000', 'consum', 0.0221, 'lps'),
	(487712, 127, '2014-01-15 00:51:42.000000', 'consum', 0.0222, 'lps'),
	(487713, 127, '2014-01-15 00:51:43.000000', 'consum', 0.0219, 'lps'),
	(487714, 127, '2014-01-15 00:51:44.000000', 'consum', 0.0218, 'lps'),
	(487715, 127, '2014-01-15 00:51:45.000000', 'consum', 0.0226, 'lps'),
	(487716, 127, '2014-01-15 00:51:46.000000', 'consum', 0.0217, 'lps'),
	(487717, 127, '2014-01-15 00:51:47.000000', 'consum', 0.0212, 'lps'),
	(487718, 127, '2014-01-15 00:51:48.000000', 'consum', 0.0216, 'lps'),
	(487719, 127, '2014-01-15 00:51:49.000000', 'consum', 0.0217, 'lps'),
	(487720, 127, '2014-01-15 00:51:50.000000', 'consum', 0.0210, 'lps'),
	(487721, 127, '2014-01-15 00:51:51.000000', 'consum', 0.0224, 'lps'),
	(487722, 127, '2014-01-15 00:51:52.000000', 'consum', 0.0211, 'lps'),
	(487723, 127, '2014-01-15 00:51:53.000000', 'consum', 0.0225, 'lps'),
	(487724, 127, '2014-01-15 00:51:54.000000', 'consum', 0.0215, 'lps'),
	(487725, 127, '2014-01-15 00:51:55.000000', 'consum', 0.0224, 'lps'),
	(487726, 127, '2014-01-15 00:51:56.000000', 'consum', 0.0213, 'lps'),
	(487727, 127, '2014-01-15 00:51:57.000000', 'consum', 0.0219, 'lps'),
	(487728, 127, '2014-01-15 00:51:58.000000', 'consum', 0.0214, 'lps'),
	(487729, 127, '2014-01-15 00:51:59.000000', 'consum', 0.0220, 'lps'),
	(487730, 127, '2014-01-15 00:52:00.000000', 'consum', 0.0213, 'lps'),
	(487731, 127, '2014-01-15 00:52:01.000000', 'consum', 0.0214, 'lps'),
	(487732, 127, '2014-01-15 00:52:02.000000', 'consum', 0.0219, 'lps'),
	(487733, 127, '2014-01-15 00:52:03.000000', 'consum', 0.0212, 'lps'),
	(487734, 127, '2014-01-15 00:52:04.000000', 'consum', 0.0210, 'lps'),
	(487735, 127, '2014-01-15 00:52:05.000000', 'consum', 0.0220, 'lps'),
	(487736, 127, '2014-01-15 00:52:06.000000', 'consum', 0.0210, 'lps'),
	(487737, 127, '2014-01-15 00:52:07.000000', 'consum', 0.0213, 'lps'),
	(487738, 127, '2014-01-15 00:52:08.000000', 'consum', 0.0211, 'lps'),
	(487739, 127, '2014-01-15 00:52:09.000000', 'consum', 0.0223, 'lps'),
	(487740, 127, '2014-01-15 00:52:10.000000', 'consum', 0.0223, 'lps'),
	(487741, 127, '2014-01-15 00:52:11.000000', 'consum', 0.0218, 'lps'),
	(487742, 127, '2014-01-15 00:52:12.000000', 'consum', 0.0212, 'lps'),
	(487743, 127, '2014-01-15 00:52:13.000000', 'consum', 0.0212, 'lps'),
	(487744, 127, '2014-01-15 00:52:14.000000', 'consum', 0.0213, 'lps'),
	(487745, 127, '2014-01-15 00:52:15.000000', 'consum', 0.0223, 'lps'),
	(487746, 127, '2014-01-15 00:52:16.000000', 'consum', 0.0214, 'lps'),
	(487747, 127, '2014-01-15 00:52:17.000000', 'consum', 0.0225, 'lps'),
	(487748, 127, '2014-01-15 00:52:18.000000', 'consum', 0.0221, 'lps'),
	(487749, 127, '2014-01-15 00:52:19.000000', 'consum', 0.0221, 'lps'),
	(487750, 127, '2014-01-15 00:52:20.000000', 'consum', 0.0218, 'lps'),
	(487751, 127, '2014-01-15 00:52:21.000000', 'consum', 0.0216, 'lps'),
	(487752, 127, '2014-01-15 00:52:22.000000', 'consum', 0.0217, 'lps'),
	(487753, 127, '2014-01-15 00:52:23.000000', 'consum', 0.0211, 'lps'),
	(487754, 127, '2014-01-15 00:52:24.000000', 'consum', 0.0211, 'lps'),
	(487755, 127, '2014-01-15 00:52:25.000000', 'consum', 0.0211, 'lps'),
	(487756, 127, '2014-01-15 00:52:26.000000', 'consum', 0.0215, 'lps'),
	(487757, 127, '2014-01-15 00:52:27.000000', 'consum', 0.0215, 'lps'),
	(487758, 127, '2014-01-15 00:52:28.000000', 'consum', 0.0219, 'lps'),
	(487759, 127, '2014-01-15 00:52:29.000000', 'consum', 0.0226, 'lps'),
	(487760, 127, '2014-01-15 00:52:30.000000', 'consum', 0.0212, 'lps'),
	(487761, 127, '2014-01-15 00:52:31.000000', 'consum', 0.0221, 'lps'),
	(487762, 127, '2014-01-15 00:52:32.000000', 'consum', 0.0211, 'lps'),
	(487763, 127, '2014-01-15 00:52:33.000000', 'consum', 0.0216, 'lps'),
	(487764, 127, '2014-01-15 00:52:34.000000', 'consum', 0.0221, 'lps'),
	(487765, 127, '2014-01-15 00:52:35.000000', 'consum', 0.0213, 'lps'),
	(487766, 127, '2014-01-15 00:52:36.000000', 'consum', 0.0226, 'lps'),
	(487767, 127, '2014-01-15 00:52:37.000000', 'consum', 0.0214, 'lps'),
	(487768, 127, '2014-01-15 00:52:38.000000', 'consum', 0.0216, 'lps'),
	(487769, 127, '2014-01-15 00:52:39.000000', 'consum', 0.0213, 'lps'),
	(487770, 127, '2014-01-15 00:52:40.000000', 'consum', 0.0223, 'lps'),
	(487771, 127, '2014-01-15 00:52:41.000000', 'consum', 0.0217, 'lps'),
	(487772, 127, '2014-01-15 00:52:42.000000', 'consum', 0.0224, 'lps'),
	(487773, 127, '2014-01-15 00:52:43.000000', 'consum', 0.0210, 'lps'),
	(487774, 127, '2014-01-15 00:52:44.000000', 'consum', 0.0217, 'lps'),
	(487775, 127, '2014-01-15 00:52:45.000000', 'consum', 0.0212, 'lps'),
	(487776, 127, '2014-01-15 00:52:46.000000', 'consum', 0.0216, 'lps'),
	(487777, 127, '2014-01-15 00:52:47.000000', 'consum', 0.0218, 'lps'),
	(487778, 127, '2014-01-15 00:52:48.000000', 'consum', 0.0214, 'lps'),
	(487779, 127, '2014-01-15 00:52:49.000000', 'consum', 0.0225, 'lps'),
	(487780, 127, '2014-01-15 00:52:50.000000', 'consum', 0.0222, 'lps'),
	(487781, 127, '2014-01-15 00:52:51.000000', 'consum', 0.0226, 'lps'),
	(487782, 127, '2014-01-15 00:52:52.000000', 'consum', 0.0218, 'lps'),
	(487783, 127, '2014-01-15 00:52:53.000000', 'consum', 0.0221, 'lps'),
	(487784, 127, '2014-01-15 00:52:54.000000', 'consum', 0.0226, 'lps'),
	(487785, 127, '2014-01-15 00:52:55.000000', 'consum', 0.0224, 'lps'),
	(487786, 127, '2014-01-15 00:52:56.000000', 'consum', 0.0216, 'lps'),
	(487787, 127, '2014-01-15 00:52:57.000000', 'consum', 0.0213, 'lps'),
	(487788, 127, '2014-01-15 00:52:58.000000', 'consum', 0.0225, 'lps'),
	(487789, 127, '2014-01-15 00:52:59.000000', 'consum', 0.0211, 'lps'),
	(487790, 127, '2014-01-15 00:53:00.000000', 'consum', 0.0219, 'lps'),
	(487791, 127, '2014-01-15 00:53:01.000000', 'consum', 0.0221, 'lps'),
	(487792, 127, '2014-01-15 00:53:02.000000', 'consum', 0.0221, 'lps'),
	(487793, 127, '2014-01-15 00:53:03.000000', 'consum', 0.0214, 'lps'),
	(487794, 127, '2014-01-15 00:53:04.000000', 'consum', 0.0213, 'lps'),
	(487795, 127, '2014-01-15 00:53:05.000000', 'consum', 0.0216, 'lps'),
	(487796, 127, '2014-01-15 00:53:06.000000', 'consum', 0.0215, 'lps'),
	(487797, 127, '2014-01-15 00:53:07.000000', 'consum', 0.0217, 'lps'),
	(487798, 127, '2014-01-15 00:53:08.000000', 'consum', 0.0212, 'lps'),
	(487799, 127, '2014-01-15 00:53:09.000000', 'consum', 0.0216, 'lps'),
	(487800, 127, '2014-01-15 00:53:10.000000', 'consum', 0.0220, 'lps'),
	(487801, 127, '2014-01-15 00:53:11.000000', 'consum', 0.0225, 'lps'),
	(487802, 127, '2014-01-15 00:53:12.000000', 'consum', 0.0221, 'lps'),
	(487803, 127, '2014-01-15 00:53:13.000000', 'consum', 0.0218, 'lps'),
	(487804, 127, '2014-01-15 00:53:14.000000', 'consum', 0.0221, 'lps'),
	(487805, 127, '2014-01-15 00:53:15.000000', 'consum', 0.0225, 'lps'),
	(487806, 127, '2014-01-15 00:53:16.000000', 'consum', 0.0218, 'lps'),
	(487807, 127, '2014-01-15 00:53:17.000000', 'consum', 0.0221, 'lps'),
	(487808, 127, '2014-01-15 00:53:18.000000', 'consum', 0.0223, 'lps'),
	(487809, 127, '2014-01-15 00:53:19.000000', 'consum', 0.0211, 'lps'),
	(487810, 127, '2014-01-15 00:53:20.000000', 'consum', 0.0211, 'lps'),
	(487811, 127, '2014-01-15 00:53:21.000000', 'consum', 0.0214, 'lps'),
	(487812, 127, '2014-01-15 00:53:22.000000', 'consum', 0.0224, 'lps'),
	(487813, 127, '2014-01-15 00:53:23.000000', 'consum', 0.0219, 'lps'),
	(487814, 127, '2014-01-15 00:53:24.000000', 'consum', 0.0213, 'lps'),
	(487815, 127, '2014-01-15 00:53:25.000000', 'consum', 0.0217, 'lps'),
	(487816, 127, '2014-01-15 00:53:26.000000', 'consum', 0.0220, 'lps'),
	(487817, 127, '2014-01-15 00:53:27.000000', 'consum', 0.0223, 'lps'),
	(487818, 127, '2014-01-15 00:53:28.000000', 'consum', 0.0211, 'lps'),
	(487819, 127, '2014-01-15 00:53:29.000000', 'consum', 0.0210, 'lps'),
	(487820, 127, '2014-01-15 00:53:30.000000', 'consum', 0.0225, 'lps'),
	(487821, 127, '2014-01-15 00:53:31.000000', 'consum', 0.0217, 'lps'),
	(487822, 127, '2014-01-15 00:53:32.000000', 'consum', 0.0219, 'lps'),
	(487823, 127, '2014-01-15 00:53:33.000000', 'consum', 0.0219, 'lps'),
	(487824, 127, '2014-01-15 00:53:34.000000', 'consum', 0.0225, 'lps'),
	(487825, 127, '2014-01-15 00:53:35.000000', 'consum', 0.0210, 'lps'),
	(487826, 127, '2014-01-15 00:53:36.000000', 'consum', 0.0214, 'lps'),
	(487827, 127, '2014-01-15 00:53:37.000000', 'consum', 0.0215, 'lps'),
	(487828, 127, '2014-01-15 00:53:38.000000', 'consum', 0.0223, 'lps'),
	(487829, 127, '2014-01-15 00:53:39.000000', 'consum', 0.0210, 'lps'),
	(487830, 127, '2014-01-15 00:53:40.000000', 'consum', 0.0220, 'lps'),
	(487831, 127, '2014-01-15 00:53:41.000000', 'consum', 0.0213, 'lps'),
	(487832, 127, '2014-01-15 00:53:42.000000', 'consum', 0.0211, 'lps'),
	(487833, 127, '2014-01-15 00:53:43.000000', 'consum', 0.0225, 'lps'),
	(487834, 127, '2014-01-15 00:53:44.000000', 'consum', 0.0213, 'lps'),
	(487835, 127, '2014-01-15 00:53:45.000000', 'consum', 0.0215, 'lps'),
	(487836, 127, '2014-01-15 00:53:46.000000', 'consum', 0.0225, 'lps'),
	(487837, 127, '2014-01-15 00:53:47.000000', 'consum', 0.0222, 'lps'),
	(487838, 127, '2014-01-15 00:53:48.000000', 'consum', 0.0225, 'lps'),
	(487839, 127, '2014-01-15 00:53:49.000000', 'consum', 0.0214, 'lps'),
	(487840, 127, '2014-01-15 00:53:50.000000', 'consum', 0.0220, 'lps'),
	(487841, 127, '2014-01-15 00:53:51.000000', 'consum', 0.0213, 'lps'),
	(487842, 127, '2014-01-15 00:53:52.000000', 'consum', 0.0213, 'lps'),
	(487843, 127, '2014-01-15 00:53:53.000000', 'consum', 0.0218, 'lps'),
	(487844, 127, '2014-01-15 00:53:54.000000', 'consum', 0.0222, 'lps'),
	(487845, 127, '2014-01-15 00:53:55.000000', 'consum', 0.0213, 'lps'),
	(487846, 127, '2014-01-15 00:53:56.000000', 'consum', 0.0222, 'lps'),
	(487847, 127, '2014-01-15 00:53:57.000000', 'consum', 0.0212, 'lps'),
	(487848, 127, '2014-01-15 00:53:58.000000', 'consum', 0.0220, 'lps'),
	(487849, 127, '2014-01-15 00:53:59.000000', 'consum', 0.0221, 'lps'),
	(487850, 127, '2014-01-15 00:54:00.000000', 'consum', 0.0218, 'lps'),
	(487851, 127, '2014-01-15 00:54:01.000000', 'consum', 0.0219, 'lps'),
	(487852, 127, '2014-01-15 00:54:02.000000', 'consum', 0.0214, 'lps'),
	(487853, 127, '2014-01-15 00:54:03.000000', 'consum', 0.0218, 'lps'),
	(487854, 127, '2014-01-15 00:54:04.000000', 'consum', 0.0224, 'lps'),
	(487855, 127, '2014-01-15 00:54:05.000000', 'consum', 0.0220, 'lps'),
	(487856, 127, '2014-01-15 00:54:06.000000', 'consum', 0.0218, 'lps'),
	(487857, 127, '2014-01-15 00:54:07.000000', 'consum', 0.0222, 'lps'),
	(487858, 127, '2014-01-15 00:54:08.000000', 'consum', 0.0211, 'lps'),
	(487859, 127, '2014-01-15 00:54:09.000000', 'consum', 0.0216, 'lps'),
	(487860, 127, '2014-01-15 00:54:10.000000', 'consum', 0.0217, 'lps'),
	(487861, 127, '2014-01-15 00:54:11.000000', 'consum', 0.0214, 'lps'),
	(487862, 127, '2014-01-15 00:54:12.000000', 'consum', 0.0225, 'lps'),
	(487863, 127, '2014-01-15 00:54:13.000000', 'consum', 0.0223, 'lps'),
	(487864, 127, '2014-01-15 00:54:14.000000', 'consum', 0.0212, 'lps'),
	(487865, 127, '2014-01-15 00:54:15.000000', 'consum', 0.0214, 'lps'),
	(487866, 127, '2014-01-15 00:54:16.000000', 'consum', 0.0210, 'lps'),
	(487867, 127, '2014-01-15 00:54:17.000000', 'consum', 0.0217, 'lps'),
	(487868, 127, '2014-01-15 00:54:18.000000', 'consum', 0.0226, 'lps'),
	(487869, 127, '2014-01-15 00:54:19.000000', 'consum', 0.0219, 'lps'),
	(487870, 127, '2014-01-15 00:54:20.000000', 'consum', 0.0223, 'lps'),
	(487871, 127, '2014-01-15 00:54:21.000000', 'consum', 0.0215, 'lps'),
	(487872, 127, '2014-01-15 00:54:22.000000', 'consum', 0.0216, 'lps'),
	(487873, 127, '2014-01-15 00:54:23.000000', 'consum', 0.0222, 'lps'),
	(487874, 127, '2014-01-15 00:54:24.000000', 'consum', 0.0220, 'lps'),
	(487875, 127, '2014-01-15 00:54:25.000000', 'consum', 0.0225, 'lps'),
	(487876, 127, '2014-01-15 00:54:26.000000', 'consum', 0.0220, 'lps'),
	(487877, 127, '2014-01-15 00:54:27.000000', 'consum', 0.0216, 'lps'),
	(487878, 127, '2014-01-15 00:54:28.000000', 'consum', 0.0212, 'lps'),
	(487879, 127, '2014-01-15 00:54:29.000000', 'consum', 0.0217, 'lps'),
	(487880, 127, '2014-01-15 00:54:30.000000', 'consum', 0.0222, 'lps'),
	(487881, 127, '2014-01-15 00:54:31.000000', 'consum', 0.0216, 'lps'),
	(487882, 127, '2014-01-15 00:54:32.000000', 'consum', 0.0220, 'lps'),
	(487883, 127, '2014-01-15 00:54:33.000000', 'consum', 0.0226, 'lps'),
	(487884, 127, '2014-01-15 00:54:34.000000', 'consum', 0.0210, 'lps'),
	(487885, 127, '2014-01-15 00:54:35.000000', 'consum', 0.0214, 'lps'),
	(487886, 127, '2014-01-15 00:54:36.000000', 'consum', 0.0212, 'lps'),
	(487887, 127, '2014-01-15 00:54:37.000000', 'consum', 0.0211, 'lps'),
	(487888, 127, '2014-01-15 00:54:38.000000', 'consum', 0.0224, 'lps'),
	(487889, 127, '2014-01-15 00:54:39.000000', 'consum', 0.0210, 'lps'),
	(487890, 127, '2014-01-15 00:54:40.000000', 'consum', 0.0221, 'lps'),
	(487891, 127, '2014-01-15 00:54:41.000000', 'consum', 0.0214, 'lps'),
	(487892, 127, '2014-01-15 00:54:42.000000', 'consum', 0.0213, 'lps'),
	(487893, 127, '2014-01-15 00:54:43.000000', 'consum', 0.0212, 'lps'),
	(487894, 127, '2014-01-15 00:54:44.000000', 'consum', 0.0215, 'lps'),
	(487895, 127, '2014-01-15 00:54:45.000000', 'consum', 0.0210, 'lps'),
	(487896, 127, '2014-01-15 00:54:46.000000', 'consum', 0.0213, 'lps'),
	(487897, 127, '2014-01-15 00:54:47.000000', 'consum', 0.0210, 'lps'),
	(487898, 127, '2014-01-15 00:54:48.000000', 'consum', 0.0217, 'lps'),
	(487899, 127, '2014-01-15 00:54:49.000000', 'consum', 0.0211, 'lps'),
	(487900, 127, '2014-01-15 00:54:50.000000', 'consum', 0.0212, 'lps'),
	(487901, 127, '2014-01-15 00:54:51.000000', 'consum', 0.0216, 'lps'),
	(487902, 127, '2014-01-15 00:54:52.000000', 'consum', 0.0219, 'lps'),
	(487903, 127, '2014-01-15 00:54:53.000000', 'consum', 0.0221, 'lps'),
	(487904, 127, '2014-01-15 00:54:54.000000', 'consum', 0.0222, 'lps'),
	(487905, 127, '2014-01-15 00:54:55.000000', 'consum', 0.0220, 'lps'),
	(487906, 127, '2014-01-15 00:54:56.000000', 'consum', 0.0225, 'lps'),
	(487907, 127, '2014-01-15 00:54:57.000000', 'consum', 0.0220, 'lps'),
	(487908, 127, '2014-01-15 00:54:58.000000', 'consum', 0.0218, 'lps'),
	(487909, 127, '2014-01-15 00:54:59.000000', 'consum', 0.0220, 'lps'),
	(487910, 127, '2014-01-15 00:55:00.000000', 'consum', 0.0218, 'lps'),
	(487911, 127, '2014-01-15 00:55:01.000000', 'consum', 0.0221, 'lps'),
	(487912, 127, '2014-01-15 00:55:02.000000', 'consum', 0.0225, 'lps'),
	(487913, 127, '2014-01-15 00:55:03.000000', 'consum', 0.0218, 'lps'),
	(487914, 127, '2014-01-15 00:55:04.000000', 'consum', 0.0221, 'lps'),
	(487915, 127, '2014-01-15 00:55:05.000000', 'consum', 0.0226, 'lps'),
	(487916, 127, '2014-01-15 00:55:06.000000', 'consum', 0.0224, 'lps'),
	(487917, 127, '2014-01-15 00:55:07.000000', 'consum', 0.0213, 'lps'),
	(487918, 127, '2014-01-15 00:55:08.000000', 'consum', 0.0220, 'lps'),
	(487919, 127, '2014-01-15 00:55:09.000000', 'consum', 0.0216, 'lps'),
	(487920, 127, '2014-01-15 00:55:10.000000', 'consum', 0.0213, 'lps'),
	(487921, 127, '2014-01-15 00:55:11.000000', 'consum', 0.0221, 'lps'),
	(487922, 127, '2014-01-15 00:55:12.000000', 'consum', 0.0225, 'lps'),
	(487923, 127, '2014-01-15 00:55:13.000000', 'consum', 0.0216, 'lps'),
	(487924, 127, '2014-01-15 00:55:14.000000', 'consum', 0.0216, 'lps'),
	(487925, 127, '2014-01-15 00:55:15.000000', 'consum', 0.0219, 'lps'),
	(487926, 127, '2014-01-15 00:55:16.000000', 'consum', 0.0221, 'lps'),
	(487927, 127, '2014-01-15 00:55:17.000000', 'consum', 0.0224, 'lps'),
	(487928, 127, '2014-01-15 00:55:18.000000', 'consum', 0.0212, 'lps'),
	(487929, 127, '2014-01-15 00:55:19.000000', 'consum', 0.0212, 'lps'),
	(487930, 127, '2014-01-15 00:55:20.000000', 'consum', 0.0217, 'lps'),
	(487931, 127, '2014-01-15 00:55:21.000000', 'consum', 0.0221, 'lps'),
	(487932, 127, '2014-01-15 00:55:22.000000', 'consum', 0.0210, 'lps'),
	(487933, 127, '2014-01-15 00:55:23.000000', 'consum', 0.0214, 'lps'),
	(487934, 127, '2014-01-15 00:55:24.000000', 'consum', 0.0210, 'lps'),
	(487935, 127, '2014-01-15 00:55:25.000000', 'consum', 0.0216, 'lps'),
	(487936, 127, '2014-01-15 00:55:26.000000', 'consum', 0.0226, 'lps'),
	(487937, 127, '2014-01-15 00:55:27.000000', 'consum', 0.0221, 'lps'),
	(487938, 127, '2014-01-15 00:55:28.000000', 'consum', 0.0218, 'lps'),
	(487939, 127, '2014-01-15 00:55:29.000000', 'consum', 0.0219, 'lps'),
	(487940, 127, '2014-01-15 00:55:30.000000', 'consum', 0.0211, 'lps'),
	(487941, 127, '2014-01-15 00:55:31.000000', 'consum', 0.0225, 'lps'),
	(487942, 127, '2014-01-15 00:55:32.000000', 'consum', 0.0212, 'lps'),
	(487943, 127, '2014-01-15 00:55:33.000000', 'consum', 0.0213, 'lps'),
	(487944, 127, '2014-01-15 00:55:34.000000', 'consum', 0.0216, 'lps'),
	(487945, 127, '2014-01-15 00:55:35.000000', 'consum', 0.0218, 'lps'),
	(487946, 127, '2014-01-15 00:55:36.000000', 'consum', 0.0213, 'lps'),
	(487947, 127, '2014-01-15 00:55:37.000000', 'consum', 0.0221, 'lps'),
	(487948, 127, '2014-01-15 00:55:38.000000', 'consum', 0.0220, 'lps'),
	(487949, 127, '2014-01-15 00:55:39.000000', 'consum', 0.0213, 'lps'),
	(487950, 127, '2014-01-15 00:55:40.000000', 'consum', 0.0213, 'lps'),
	(487951, 127, '2014-01-15 00:55:41.000000', 'consum', 0.0215, 'lps'),
	(487952, 127, '2014-01-15 00:55:42.000000', 'consum', 0.0226, 'lps'),
	(487953, 127, '2014-01-15 00:55:43.000000', 'consum', 0.0225, 'lps'),
	(487954, 127, '2014-01-15 00:55:44.000000', 'consum', 0.0222, 'lps'),
	(487955, 127, '2014-01-15 00:55:45.000000', 'consum', 0.0223, 'lps'),
	(487956, 127, '2014-01-15 00:55:46.000000', 'consum', 0.0223, 'lps'),
	(487957, 127, '2014-01-15 00:55:47.000000', 'consum', 0.0218, 'lps'),
	(487958, 127, '2014-01-15 00:55:48.000000', 'consum', 0.0212, 'lps'),
	(487959, 127, '2014-01-15 00:55:49.000000', 'consum', 0.0215, 'lps'),
	(487960, 127, '2014-01-15 00:55:50.000000', 'consum', 0.0211, 'lps'),
	(487961, 127, '2014-01-15 00:55:51.000000', 'consum', 0.0217, 'lps'),
	(487962, 127, '2014-01-15 00:55:52.000000', 'consum', 0.0225, 'lps'),
	(487963, 127, '2014-01-15 00:55:53.000000', 'consum', 0.0214, 'lps'),
	(487964, 127, '2014-01-15 00:55:54.000000', 'consum', 0.0220, 'lps'),
	(487965, 127, '2014-01-15 00:55:55.000000', 'consum', 0.0215, 'lps'),
	(487966, 127, '2014-01-15 00:55:56.000000', 'consum', 0.0222, 'lps'),
	(487967, 127, '2014-01-15 00:55:57.000000', 'consum', 0.0220, 'lps'),
	(487968, 127, '2014-01-15 00:55:58.000000', 'consum', 0.0211, 'lps'),
	(487969, 127, '2014-01-15 00:55:59.000000', 'consum', 0.0216, 'lps'),
	(487970, 127, '2014-01-15 00:56:00.000000', 'consum', 0.0221, 'lps'),
	(487971, 127, '2014-01-15 00:56:01.000000', 'consum', 0.0215, 'lps'),
	(487972, 127, '2014-01-15 00:56:02.000000', 'consum', 0.0219, 'lps'),
	(487973, 127, '2014-01-15 00:56:03.000000', 'consum', 0.0222, 'lps'),
	(487974, 127, '2014-01-15 00:56:04.000000', 'consum', 0.0211, 'lps'),
	(487975, 127, '2014-01-15 00:56:05.000000', 'consum', 0.0215, 'lps'),
	(487976, 127, '2014-01-15 00:56:06.000000', 'consum', 0.0212, 'lps'),
	(487977, 127, '2014-01-15 00:56:07.000000', 'consum', 0.0226, 'lps'),
	(487978, 127, '2014-01-15 00:56:08.000000', 'consum', 0.0213, 'lps'),
	(487979, 127, '2014-01-15 00:56:09.000000', 'consum', 0.0213, 'lps'),
	(487980, 127, '2014-01-15 00:56:10.000000', 'consum', 0.0216, 'lps'),
	(487981, 127, '2014-01-15 00:56:11.000000', 'consum', 0.0216, 'lps'),
	(487982, 127, '2014-01-15 00:56:12.000000', 'consum', 0.0222, 'lps'),
	(487983, 127, '2014-01-15 00:56:13.000000', 'consum', 0.0217, 'lps'),
	(487984, 127, '2014-01-15 00:56:14.000000', 'consum', 0.0226, 'lps'),
	(487985, 127, '2014-01-15 00:56:15.000000', 'consum', 0.0219, 'lps'),
	(487986, 127, '2014-01-15 00:56:16.000000', 'consum', 0.0224, 'lps'),
	(487987, 127, '2014-01-15 00:56:17.000000', 'consum', 0.0219, 'lps'),
	(487988, 127, '2014-01-15 00:56:18.000000', 'consum', 0.0216, 'lps'),
	(487989, 127, '2014-01-15 00:56:19.000000', 'consum', 0.0214, 'lps'),
	(487990, 127, '2014-01-15 00:56:20.000000', 'consum', 0.0226, 'lps'),
	(487991, 127, '2014-01-15 00:56:21.000000', 'consum', 0.0214, 'lps'),
	(487992, 127, '2014-01-15 00:56:22.000000', 'consum', 0.0216, 'lps'),
	(487993, 127, '2014-01-15 00:56:23.000000', 'consum', 0.0210, 'lps'),
	(487994, 127, '2014-01-15 00:56:24.000000', 'consum', 0.0212, 'lps'),
	(487995, 127, '2014-01-15 00:56:25.000000', 'consum', 0.0220, 'lps'),
	(487996, 127, '2014-01-15 00:56:26.000000', 'consum', 0.0220, 'lps'),
	(487997, 127, '2014-01-15 00:56:27.000000', 'consum', 0.0214, 'lps'),
	(487998, 127, '2014-01-15 00:56:28.000000', 'consum', 0.0217, 'lps'),
	(487999, 127, '2014-01-15 00:56:29.000000', 'consum', 0.0216, 'lps'),
	(488000, 127, '2014-01-15 00:56:30.000000', 'consum', 0.0219, 'lps'),
	(488001, 127, '2014-01-15 00:56:31.000000', 'consum', 0.0222, 'lps'),
	(488002, 127, '2014-01-15 00:56:32.000000', 'consum', 0.0210, 'lps'),
	(488003, 127, '2014-01-15 00:56:33.000000', 'consum', 0.0225, 'lps'),
	(488004, 127, '2014-01-15 00:56:34.000000', 'consum', 0.0217, 'lps'),
	(488005, 127, '2014-01-15 00:56:35.000000', 'consum', 0.0218, 'lps'),
	(488006, 127, '2014-01-15 00:56:36.000000', 'consum', 0.0211, 'lps'),
	(488007, 127, '2014-01-15 00:56:37.000000', 'consum', 0.0226, 'lps'),
	(488008, 127, '2014-01-15 00:56:38.000000', 'consum', 0.0220, 'lps'),
	(488009, 127, '2014-01-15 00:56:39.000000', 'consum', 0.0212, 'lps'),
	(488010, 127, '2014-01-15 00:56:40.000000', 'consum', 0.0210, 'lps'),
	(488011, 127, '2014-01-15 00:56:41.000000', 'consum', 0.0218, 'lps'),
	(488012, 127, '2014-01-15 00:56:42.000000', 'consum', 0.0217, 'lps'),
	(488013, 127, '2014-01-15 00:56:43.000000', 'consum', 0.0224, 'lps'),
	(488014, 127, '2014-01-15 00:56:44.000000', 'consum', 0.0222, 'lps'),
	(488015, 127, '2014-01-15 00:56:45.000000', 'consum', 0.0214, 'lps'),
	(488016, 127, '2014-01-15 00:56:46.000000', 'consum', 0.0210, 'lps'),
	(488017, 127, '2014-01-15 00:56:47.000000', 'consum', 0.0217, 'lps'),
	(488018, 127, '2014-01-15 00:56:48.000000', 'consum', 0.0212, 'lps'),
	(488019, 127, '2014-01-15 00:56:49.000000', 'consum', 0.0216, 'lps'),
	(488020, 127, '2014-01-15 00:56:50.000000', 'consum', 0.0216, 'lps'),
	(488021, 127, '2014-01-15 00:56:51.000000', 'consum', 0.0223, 'lps'),
	(488022, 127, '2014-01-15 00:56:52.000000', 'consum', 0.0223, 'lps'),
	(488023, 127, '2014-01-15 00:56:53.000000', 'consum', 0.0221, 'lps'),
	(488024, 127, '2014-01-15 00:56:54.000000', 'consum', 0.0225, 'lps'),
	(488025, 127, '2014-01-15 00:56:55.000000', 'consum', 0.0218, 'lps'),
	(488026, 127, '2014-01-15 00:56:56.000000', 'consum', 0.0224, 'lps'),
	(488027, 127, '2014-01-15 00:56:57.000000', 'consum', 0.0220, 'lps'),
	(488028, 127, '2014-01-15 00:56:58.000000', 'consum', 0.0221, 'lps'),
	(488029, 127, '2014-01-15 00:56:59.000000', 'consum', 0.0216, 'lps'),
	(488030, 127, '2014-01-15 00:57:00.000000', 'consum', 0.0210, 'lps'),
	(488031, 127, '2014-01-15 00:57:01.000000', 'consum', 0.0224, 'lps'),
	(488032, 127, '2014-01-15 00:57:02.000000', 'consum', 0.0212, 'lps'),
	(488033, 127, '2014-01-15 00:57:03.000000', 'consum', 0.0213, 'lps'),
	(488034, 127, '2014-01-15 00:57:04.000000', 'consum', 0.0220, 'lps'),
	(488035, 127, '2014-01-15 00:57:05.000000', 'consum', 0.0216, 'lps'),
	(488036, 127, '2014-01-15 00:57:06.000000', 'consum', 0.0210, 'lps'),
	(488037, 127, '2014-01-15 00:57:07.000000', 'consum', 0.0213, 'lps'),
	(488038, 127, '2014-01-15 00:57:08.000000', 'consum', 0.0222, 'lps'),
	(488039, 127, '2014-01-15 00:57:09.000000', 'consum', 0.0213, 'lps'),
	(488040, 127, '2014-01-15 00:57:10.000000', 'consum', 0.0222, 'lps'),
	(488041, 127, '2014-01-15 00:57:11.000000', 'consum', 0.0211, 'lps'),
	(488042, 127, '2014-01-15 00:57:12.000000', 'consum', 0.0214, 'lps'),
	(488043, 127, '2014-01-15 00:57:13.000000', 'consum', 0.0211, 'lps'),
	(488044, 127, '2014-01-15 00:57:14.000000', 'consum', 0.0218, 'lps'),
	(488045, 127, '2014-01-15 00:57:15.000000', 'consum', 0.0216, 'lps'),
	(488046, 127, '2014-01-15 00:57:16.000000', 'consum', 0.0216, 'lps'),
	(488047, 127, '2014-01-15 00:57:17.000000', 'consum', 0.0224, 'lps'),
	(488048, 127, '2014-01-15 00:57:18.000000', 'consum', 0.0210, 'lps'),
	(488049, 127, '2014-01-15 00:57:19.000000', 'consum', 0.0221, 'lps'),
	(488050, 127, '2014-01-15 00:57:20.000000', 'consum', 0.0214, 'lps'),
	(488051, 127, '2014-01-15 00:57:21.000000', 'consum', 0.0212, 'lps'),
	(488052, 127, '2014-01-15 00:57:22.000000', 'consum', 0.0211, 'lps'),
	(488053, 127, '2014-01-15 00:57:23.000000', 'consum', 0.0211, 'lps'),
	(488054, 127, '2014-01-15 00:57:24.000000', 'consum', 0.0211, 'lps'),
	(488055, 127, '2014-01-15 00:57:25.000000', 'consum', 0.0211, 'lps'),
	(488056, 127, '2014-01-15 00:57:26.000000', 'consum', 0.0215, 'lps'),
	(488057, 127, '2014-01-15 00:57:27.000000', 'consum', 0.0214, 'lps'),
	(488058, 127, '2014-01-15 00:57:28.000000', 'consum', 0.0217, 'lps'),
	(488059, 127, '2014-01-15 00:57:29.000000', 'consum', 0.0217, 'lps'),
	(488060, 127, '2014-01-15 00:57:30.000000', 'consum', 0.0224, 'lps'),
	(488061, 127, '2014-01-15 00:57:31.000000', 'consum', 0.0225, 'lps'),
	(488062, 127, '2014-01-15 00:57:32.000000', 'consum', 0.0225, 'lps'),
	(488063, 127, '2014-01-15 00:57:33.000000', 'consum', 0.0223, 'lps'),
	(488064, 127, '2014-01-15 00:57:34.000000', 'consum', 0.0215, 'lps'),
	(488065, 127, '2014-01-15 00:57:35.000000', 'consum', 0.0212, 'lps'),
	(488066, 127, '2014-01-15 00:57:36.000000', 'consum', 0.0223, 'lps'),
	(488067, 127, '2014-01-15 00:57:37.000000', 'consum', 0.0219, 'lps'),
	(488068, 127, '2014-01-15 00:57:38.000000', 'consum', 0.0215, 'lps'),
	(488069, 127, '2014-01-15 00:57:39.000000', 'consum', 0.0212, 'lps'),
	(488070, 127, '2014-01-15 00:57:40.000000', 'consum', 0.0219, 'lps'),
	(488071, 127, '2014-01-15 00:57:41.000000', 'consum', 0.0216, 'lps'),
	(488072, 127, '2014-01-15 00:57:42.000000', 'consum', 0.0212, 'lps'),
	(488073, 127, '2014-01-15 00:57:43.000000', 'consum', 0.0220, 'lps'),
	(488074, 127, '2014-01-15 00:57:44.000000', 'consum', 0.0222, 'lps'),
	(488075, 127, '2014-01-15 00:57:45.000000', 'consum', 0.0222, 'lps'),
	(488076, 127, '2014-01-15 00:57:46.000000', 'consum', 0.0219, 'lps'),
	(488077, 127, '2014-01-15 00:57:47.000000', 'consum', 0.0219, 'lps'),
	(488078, 127, '2014-01-15 00:57:48.000000', 'consum', 0.0210, 'lps'),
	(488079, 127, '2014-01-15 00:57:49.000000', 'consum', 0.0219, 'lps'),
	(488080, 127, '2014-01-15 00:57:50.000000', 'consum', 0.0223, 'lps'),
	(488081, 127, '2014-01-15 00:57:51.000000', 'consum', 0.0212, 'lps'),
	(488082, 127, '2014-01-15 00:57:52.000000', 'consum', 0.0215, 'lps'),
	(488083, 127, '2014-01-15 00:57:53.000000', 'consum', 0.0211, 'lps'),
	(488084, 127, '2014-01-15 00:57:54.000000', 'consum', 0.0221, 'lps'),
	(488085, 127, '2014-01-15 00:57:55.000000', 'consum', 0.0225, 'lps'),
	(488086, 127, '2014-01-15 00:57:56.000000', 'consum', 0.0222, 'lps'),
	(488087, 127, '2014-01-15 00:57:57.000000', 'consum', 0.0224, 'lps'),
	(488088, 127, '2014-01-15 00:57:58.000000', 'consum', 0.0226, 'lps'),
	(488089, 127, '2014-01-15 00:57:59.000000', 'consum', 0.0218, 'lps'),
	(488090, 127, '2014-01-15 00:58:00.000000', 'consum', 0.0217, 'lps'),
	(488091, 127, '2014-01-15 00:58:01.000000', 'consum', 0.0221, 'lps'),
	(488092, 127, '2014-01-15 00:58:02.000000', 'consum', 0.0213, 'lps'),
	(488093, 127, '2014-01-15 00:58:03.000000', 'consum', 0.0224, 'lps'),
	(488094, 127, '2014-01-15 00:58:04.000000', 'consum', 0.0223, 'lps'),
	(488095, 127, '2014-01-15 00:58:05.000000', 'consum', 0.0217, 'lps'),
	(488096, 127, '2014-01-15 00:58:06.000000', 'consum', 0.0223, 'lps'),
	(488097, 127, '2014-01-15 00:58:07.000000', 'consum', 0.0218, 'lps'),
	(488098, 127, '2014-01-15 00:58:08.000000', 'consum', 0.0214, 'lps'),
	(488099, 127, '2014-01-15 00:58:09.000000', 'consum', 0.0223, 'lps'),
	(488100, 127, '2014-01-15 00:58:10.000000', 'consum', 0.0210, 'lps'),
	(488101, 127, '2014-01-15 00:58:11.000000', 'consum', 0.0226, 'lps'),
	(488102, 127, '2014-01-15 00:58:12.000000', 'consum', 0.0221, 'lps'),
	(488103, 127, '2014-01-15 00:58:13.000000', 'consum', 0.0220, 'lps'),
	(488104, 127, '2014-01-15 00:58:14.000000', 'consum', 0.0224, 'lps'),
	(488105, 127, '2014-01-15 00:58:15.000000', 'consum', 0.0219, 'lps'),
	(488106, 127, '2014-01-15 00:58:16.000000', 'consum', 0.0211, 'lps'),
	(488107, 127, '2014-01-15 00:58:17.000000', 'consum', 0.0224, 'lps'),
	(488108, 127, '2014-01-15 00:58:18.000000', 'consum', 0.0210, 'lps'),
	(488109, 127, '2014-01-15 00:58:19.000000', 'consum', 0.0219, 'lps'),
	(488110, 127, '2014-01-15 00:58:20.000000', 'consum', 0.0221, 'lps'),
	(488111, 127, '2014-01-15 00:58:21.000000', 'consum', 0.0224, 'lps'),
	(488112, 127, '2014-01-15 00:58:22.000000', 'consum', 0.0211, 'lps'),
	(488113, 127, '2014-01-15 00:58:23.000000', 'consum', 0.0226, 'lps'),
	(488114, 127, '2014-01-15 00:58:24.000000', 'consum', 0.0217, 'lps'),
	(488115, 127, '2014-01-15 00:58:25.000000', 'consum', 0.0215, 'lps'),
	(488116, 127, '2014-01-15 00:58:26.000000', 'consum', 0.0216, 'lps'),
	(488117, 127, '2014-01-15 00:58:27.000000', 'consum', 0.0225, 'lps'),
	(488118, 127, '2014-01-15 00:58:28.000000', 'consum', 0.0218, 'lps'),
	(488119, 127, '2014-01-15 00:58:29.000000', 'consum', 0.0222, 'lps'),
	(488120, 127, '2014-01-15 00:58:30.000000', 'consum', 0.0212, 'lps'),
	(488121, 127, '2014-01-15 00:58:31.000000', 'consum', 0.0218, 'lps'),
	(488122, 127, '2014-01-15 00:58:32.000000', 'consum', 0.0210, 'lps'),
	(488123, 127, '2014-01-15 00:58:33.000000', 'consum', 0.0222, 'lps'),
	(488124, 127, '2014-01-15 00:58:34.000000', 'consum', 0.0219, 'lps'),
	(488125, 127, '2014-01-15 00:58:35.000000', 'consum', 0.0220, 'lps'),
	(488126, 127, '2014-01-15 00:58:36.000000', 'consum', 0.0215, 'lps'),
	(488127, 127, '2014-01-15 00:58:37.000000', 'consum', 0.0224, 'lps'),
	(488128, 127, '2014-01-15 00:58:38.000000', 'consum', 0.0214, 'lps'),
	(488129, 127, '2014-01-15 00:58:39.000000', 'consum', 0.0224, 'lps'),
	(488130, 127, '2014-01-15 00:58:40.000000', 'consum', 0.0217, 'lps'),
	(488131, 127, '2014-01-15 00:58:41.000000', 'consum', 0.0221, 'lps'),
	(488132, 127, '2014-01-15 00:58:42.000000', 'consum', 0.0212, 'lps'),
	(488133, 127, '2014-01-15 00:58:43.000000', 'consum', 0.0219, 'lps'),
	(488134, 127, '2014-01-15 00:58:44.000000', 'consum', 0.0214, 'lps'),
	(488135, 127, '2014-01-15 00:58:45.000000', 'consum', 0.0224, 'lps'),
	(488136, 127, '2014-01-15 00:58:46.000000', 'consum', 0.0217, 'lps'),
	(488137, 127, '2014-01-15 00:58:47.000000', 'consum', 0.0219, 'lps'),
	(488138, 127, '2014-01-15 00:58:48.000000', 'consum', 0.0217, 'lps'),
	(488139, 127, '2014-01-15 00:58:49.000000', 'consum', 0.0220, 'lps'),
	(488140, 127, '2014-01-15 00:58:50.000000', 'consum', 0.0223, 'lps'),
	(488141, 127, '2014-01-15 00:58:51.000000', 'consum', 0.0212, 'lps'),
	(488142, 127, '2014-01-15 00:58:52.000000', 'consum', 0.0214, 'lps'),
	(488143, 127, '2014-01-15 00:58:53.000000', 'consum', 0.0226, 'lps'),
	(488144, 127, '2014-01-15 00:58:54.000000', 'consum', 0.0210, 'lps'),
	(488145, 127, '2014-01-15 00:58:55.000000', 'consum', 0.0213, 'lps'),
	(488146, 127, '2014-01-15 00:58:56.000000', 'consum', 0.0226, 'lps'),
	(488147, 127, '2014-01-15 00:58:57.000000', 'consum', 0.0212, 'lps'),
	(488148, 127, '2014-01-15 00:58:58.000000', 'consum', 0.0226, 'lps'),
	(488149, 127, '2014-01-15 00:58:59.000000', 'consum', 0.0217, 'lps'),
	(488150, 127, '2014-01-15 00:59:00.000000', 'consum', 0.0212, 'lps'),
	(488151, 127, '2014-01-15 00:59:01.000000', 'consum', 0.0216, 'lps'),
	(488152, 127, '2014-01-15 00:59:02.000000', 'consum', 0.0219, 'lps'),
	(488153, 127, '2014-01-15 00:59:03.000000', 'consum', 0.0218, 'lps'),
	(488154, 127, '2014-01-15 00:59:04.000000', 'consum', 0.0226, 'lps'),
	(488155, 127, '2014-01-15 00:59:05.000000', 'consum', 0.0216, 'lps'),
	(488156, 127, '2014-01-15 00:59:06.000000', 'consum', 0.0226, 'lps'),
	(488157, 127, '2014-01-15 00:59:07.000000', 'consum', 0.0221, 'lps'),
	(488158, 127, '2014-01-15 00:59:08.000000', 'consum', 0.0219, 'lps'),
	(488159, 127, '2014-01-15 00:59:09.000000', 'consum', 0.0219, 'lps'),
	(488160, 127, '2014-01-15 00:59:10.000000', 'consum', 0.0215, 'lps'),
	(488161, 127, '2014-01-15 00:59:11.000000', 'consum', 0.0226, 'lps'),
	(488162, 127, '2014-01-15 00:59:12.000000', 'consum', 0.0223, 'lps'),
	(488163, 127, '2014-01-15 00:59:13.000000', 'consum', 0.0226, 'lps'),
	(488164, 127, '2014-01-15 00:59:14.000000', 'consum', 0.0218, 'lps'),
	(488165, 127, '2014-01-15 00:59:15.000000', 'consum', 0.0219, 'lps'),
	(488166, 127, '2014-01-15 00:59:16.000000', 'consum', 0.0214, 'lps'),
	(488167, 127, '2014-01-15 00:59:17.000000', 'consum', 0.0222, 'lps'),
	(488168, 127, '2014-01-15 00:59:18.000000', 'consum', 0.0225, 'lps'),
	(488169, 127, '2014-01-15 00:59:19.000000', 'consum', 0.0216, 'lps'),
	(488170, 127, '2014-01-15 00:59:20.000000', 'consum', 0.0211, 'lps'),
	(488171, 127, '2014-01-15 00:59:21.000000', 'consum', 0.0214, 'lps'),
	(488172, 127, '2014-01-15 00:59:22.000000', 'consum', 0.0213, 'lps'),
	(488173, 127, '2014-01-15 00:59:23.000000', 'consum', 0.0214, 'lps'),
	(488174, 127, '2014-01-15 00:59:24.000000', 'consum', 0.0218, 'lps'),
	(488175, 127, '2014-01-15 00:59:25.000000', 'consum', 0.0224, 'lps'),
	(488176, 127, '2014-01-15 00:59:26.000000', 'consum', 0.0222, 'lps'),
	(488177, 127, '2014-01-15 00:59:27.000000', 'consum', 0.0212, 'lps'),
	(488178, 127, '2014-01-15 00:59:28.000000', 'consum', 0.0217, 'lps'),
	(488179, 127, '2014-01-15 00:59:29.000000', 'consum', 0.0225, 'lps'),
	(488180, 127, '2014-01-15 00:59:30.000000', 'consum', 0.0211, 'lps'),
	(488181, 127, '2014-01-15 00:59:31.000000', 'consum', 0.0224, 'lps'),
	(488182, 127, '2014-01-15 00:59:32.000000', 'consum', 0.0224, 'lps'),
	(488183, 127, '2014-01-15 00:59:33.000000', 'consum', 0.0224, 'lps'),
	(488184, 127, '2014-01-15 00:59:34.000000', 'consum', 0.0219, 'lps'),
	(488185, 127, '2014-01-15 00:59:35.000000', 'consum', 0.0213, 'lps'),
	(488186, 127, '2014-01-15 00:59:36.000000', 'consum', 0.0215, 'lps'),
	(488187, 127, '2014-01-15 00:59:37.000000', 'consum', 0.0210, 'lps'),
	(488188, 127, '2014-01-15 00:59:38.000000', 'consum', 0.0214, 'lps'),
	(488189, 127, '2014-01-15 00:59:39.000000', 'consum', 0.0211, 'lps'),
	(488190, 127, '2014-01-15 00:59:40.000000', 'consum', 0.0220, 'lps'),
	(488191, 127, '2014-01-15 00:59:41.000000', 'consum', 0.0210, 'lps'),
	(488192, 127, '2014-01-15 00:59:42.000000', 'consum', 0.0212, 'lps'),
	(488193, 127, '2014-01-15 00:59:43.000000', 'consum', 0.0221, 'lps'),
	(488194, 127, '2014-01-15 00:59:44.000000', 'consum', 0.0210, 'lps'),
	(488195, 127, '2014-01-15 00:59:45.000000', 'consum', 0.0212, 'lps'),
	(488196, 127, '2014-01-15 00:59:46.000000', 'consum', 0.0219, 'lps'),
	(488197, 127, '2014-01-15 00:59:47.000000', 'consum', 0.0214, 'lps'),
	(488198, 127, '2014-01-15 00:59:48.000000', 'consum', 0.0221, 'lps'),
	(488199, 127, '2014-01-15 00:59:49.000000', 'consum', 0.0222, 'lps'),
	(488200, 127, '2014-01-15 00:59:50.000000', 'consum', 0.0219, 'lps'),
	(488201, 127, '2014-01-15 00:59:51.000000', 'consum', 0.0220, 'lps'),
	(488202, 127, '2014-01-15 00:59:52.000000', 'consum', 0.0216, 'lps'),
	(488203, 127, '2014-01-15 00:59:53.000000', 'consum', 0.0212, 'lps'),
	(488204, 127, '2014-01-15 00:59:54.000000', 'consum', 0.0218, 'lps'),
	(488205, 127, '2014-01-15 00:59:55.000000', 'consum', 0.0212, 'lps'),
	(488206, 127, '2014-01-15 00:59:56.000000', 'consum', 0.0211, 'lps'),
	(488207, 127, '2014-01-15 00:59:57.000000', 'consum', 0.0211, 'lps'),
	(488208, 127, '2014-01-15 00:59:58.000000', 'consum', 0.0214, 'lps'),
	(488209, 127, '2014-01-15 00:59:59.000000', 'consum', 0.0210, 'lps'),
	(488210, 127, '2014-01-15 01:00:00.000000', 'consum', 0.0215, 'lps'),
	(488211, 127, '2014-01-15 01:00:01.000000', 'consum', 0.0218, 'lps'),
	(488212, 127, '2014-01-15 01:00:02.000000', 'consum', 0.0219, 'lps'),
	(488213, 127, '2014-01-15 01:00:03.000000', 'consum', 0.0215, 'lps'),
	(488214, 127, '2014-01-15 01:00:04.000000', 'consum', 0.0224, 'lps'),
	(488215, 127, '2014-01-15 01:00:05.000000', 'consum', 0.0216, 'lps'),
	(488216, 127, '2014-01-15 01:00:06.000000', 'consum', 0.0215, 'lps'),
	(488217, 127, '2014-01-15 01:00:07.000000', 'consum', 0.0216, 'lps'),
	(488218, 127, '2014-01-15 01:00:08.000000', 'consum', 0.0226, 'lps'),
	(488219, 127, '2014-01-15 01:00:09.000000', 'consum', 0.0224, 'lps'),
	(488220, 127, '2014-01-15 01:00:10.000000', 'consum', 0.0214, 'lps'),
	(488221, 127, '2014-01-15 01:00:11.000000', 'consum', 0.0221, 'lps'),
	(488222, 127, '2014-01-15 01:00:12.000000', 'consum', 0.0219, 'lps'),
	(488223, 127, '2014-01-15 01:00:13.000000', 'consum', 0.0226, 'lps'),
	(488224, 127, '2014-01-15 01:00:14.000000', 'consum', 0.0226, 'lps'),
	(488225, 127, '2014-01-15 01:00:15.000000', 'consum', 0.0226, 'lps'),
	(488226, 127, '2014-01-15 01:00:16.000000', 'consum', 0.0226, 'lps'),
	(488227, 127, '2014-01-15 01:00:17.000000', 'consum', 0.0210, 'lps'),
	(488228, 127, '2014-01-15 01:00:18.000000', 'consum', 0.0211, 'lps'),
	(488229, 127, '2014-01-15 01:00:19.000000', 'consum', 0.0215, 'lps'),
	(488230, 127, '2014-01-15 01:00:20.000000', 'consum', 0.0216, 'lps'),
	(488231, 127, '2014-01-15 01:00:21.000000', 'consum', 0.0226, 'lps'),
	(488232, 127, '2014-01-15 01:00:22.000000', 'consum', 0.0223, 'lps'),
	(488233, 127, '2014-01-15 01:00:23.000000', 'consum', 0.0226, 'lps'),
	(488234, 127, '2014-01-15 01:00:24.000000', 'consum', 0.0219, 'lps'),
	(488235, 127, '2014-01-15 01:00:25.000000', 'consum', 0.0223, 'lps'),
	(488236, 127, '2014-01-15 01:00:26.000000', 'consum', 0.0214, 'lps'),
	(488237, 127, '2014-01-15 01:00:27.000000', 'consum', 0.0210, 'lps'),
	(488238, 127, '2014-01-15 01:00:28.000000', 'consum', 0.0215, 'lps'),
	(488239, 127, '2014-01-15 01:00:29.000000', 'consum', 0.0220, 'lps'),
	(488240, 127, '2014-01-15 01:00:30.000000', 'consum', 0.0226, 'lps'),
	(488241, 127, '2014-01-15 01:00:31.000000', 'consum', 0.0225, 'lps'),
	(488242, 127, '2014-01-15 01:00:32.000000', 'consum', 0.0224, 'lps'),
	(488243, 127, '2014-01-15 01:00:33.000000', 'consum', 0.0217, 'lps'),
	(488244, 127, '2014-01-15 01:00:34.000000', 'consum', 0.0220, 'lps'),
	(488245, 127, '2014-01-15 01:00:35.000000', 'consum', 0.0223, 'lps'),
	(488246, 127, '2014-01-15 01:00:36.000000', 'consum', 0.0212, 'lps'),
	(488247, 127, '2014-01-15 01:00:37.000000', 'consum', 0.0217, 'lps'),
	(488248, 127, '2014-01-15 01:00:38.000000', 'consum', 0.0221, 'lps'),
	(488249, 127, '2014-01-15 01:00:39.000000', 'consum', 0.0212, 'lps'),
	(488250, 127, '2014-01-15 01:00:40.000000', 'consum', 0.0222, 'lps'),
	(488251, 127, '2014-01-15 01:00:41.000000', 'consum', 0.0212, 'lps'),
	(488252, 127, '2014-01-15 01:00:42.000000', 'consum', 0.0217, 'lps'),
	(488253, 127, '2014-01-15 01:00:43.000000', 'consum', 0.0223, 'lps'),
	(488254, 127, '2014-01-15 01:00:44.000000', 'consum', 0.0220, 'lps'),
	(488255, 127, '2014-01-15 01:00:45.000000', 'consum', 0.0223, 'lps'),
	(488256, 127, '2014-01-15 01:00:46.000000', 'consum', 0.0226, 'lps'),
	(488257, 127, '2014-01-15 01:00:47.000000', 'consum', 0.0219, 'lps'),
	(488258, 127, '2014-01-15 01:00:48.000000', 'consum', 0.0224, 'lps'),
	(488259, 127, '2014-01-15 01:00:49.000000', 'consum', 0.0221, 'lps'),
	(488260, 127, '2014-01-15 01:00:50.000000', 'consum', 0.0221, 'lps'),
	(488261, 127, '2014-01-15 01:00:51.000000', 'consum', 0.0215, 'lps'),
	(488262, 127, '2014-01-15 01:00:52.000000', 'consum', 0.0222, 'lps'),
	(488263, 127, '2014-01-15 01:00:53.000000', 'consum', 0.0220, 'lps'),
	(488264, 127, '2014-01-15 01:00:54.000000', 'consum', 0.0210, 'lps'),
	(488265, 127, '2014-01-15 01:00:55.000000', 'consum', 0.0212, 'lps'),
	(488266, 127, '2014-01-15 01:00:56.000000', 'consum', 0.0219, 'lps'),
	(488267, 127, '2014-01-15 01:00:57.000000', 'consum', 0.0217, 'lps'),
	(488268, 127, '2014-01-15 01:00:58.000000', 'consum', 0.0220, 'lps'),
	(488269, 127, '2014-01-15 01:00:59.000000', 'consum', 0.0222, 'lps'),
	(488270, 127, '2014-01-15 01:01:00.000000', 'consum', 0.0222, 'lps'),
	(488271, 127, '2014-01-15 01:01:01.000000', 'consum', 0.0217, 'lps'),
	(488272, 127, '2014-01-15 01:01:02.000000', 'consum', 0.0212, 'lps'),
	(488273, 127, '2014-01-15 01:01:03.000000', 'consum', 0.0217, 'lps'),
	(488274, 127, '2014-01-15 01:01:04.000000', 'consum', 0.0223, 'lps'),
	(488275, 127, '2014-01-15 01:01:05.000000', 'consum', 0.0221, 'lps'),
	(488276, 127, '2014-01-15 01:01:06.000000', 'consum', 0.0210, 'lps'),
	(488277, 127, '2014-01-15 01:01:07.000000', 'consum', 0.0226, 'lps'),
	(488278, 127, '2014-01-15 01:01:08.000000', 'consum', 0.0224, 'lps'),
	(488279, 127, '2014-01-15 01:01:09.000000', 'consum', 0.0215, 'lps'),
	(488280, 127, '2014-01-15 01:01:10.000000', 'consum', 0.0211, 'lps'),
	(488281, 127, '2014-01-15 01:01:11.000000', 'consum', 0.0215, 'lps'),
	(488282, 127, '2014-01-15 01:01:12.000000', 'consum', 0.0217, 'lps'),
	(488283, 127, '2014-01-15 01:01:13.000000', 'consum', 0.0215, 'lps'),
	(488284, 127, '2014-01-15 01:01:14.000000', 'consum', 0.0215, 'lps'),
	(488285, 127, '2014-01-15 01:01:15.000000', 'consum', 0.0218, 'lps'),
	(488286, 127, '2014-01-15 01:01:16.000000', 'consum', 0.0219, 'lps'),
	(488287, 127, '2014-01-15 01:01:17.000000', 'consum', 0.0213, 'lps'),
	(488288, 127, '2014-01-15 01:01:18.000000', 'consum', 0.0217, 'lps'),
	(488289, 127, '2014-01-15 01:01:19.000000', 'consum', 0.0221, 'lps'),
	(488290, 127, '2014-01-15 01:01:20.000000', 'consum', 0.0225, 'lps'),
	(488291, 127, '2014-01-15 01:01:21.000000', 'consum', 0.0219, 'lps'),
	(488292, 127, '2014-01-15 01:01:22.000000', 'consum', 0.0210, 'lps'),
	(488293, 127, '2014-01-15 01:01:23.000000', 'consum', 0.0219, 'lps'),
	(488294, 127, '2014-01-15 01:01:24.000000', 'consum', 0.0219, 'lps'),
	(488295, 127, '2014-01-15 01:01:25.000000', 'consum', 0.0213, 'lps'),
	(488296, 127, '2014-01-15 01:01:26.000000', 'consum', 0.0213, 'lps'),
	(488297, 127, '2014-01-15 01:01:27.000000', 'consum', 0.0219, 'lps'),
	(488298, 127, '2014-01-15 01:01:28.000000', 'consum', 0.0212, 'lps'),
	(488299, 127, '2014-01-15 01:01:29.000000', 'consum', 0.0212, 'lps'),
	(488300, 127, '2014-01-15 01:01:30.000000', 'consum', 0.0215, 'lps'),
	(488301, 127, '2014-01-15 01:01:31.000000', 'consum', 0.0214, 'lps'),
	(488302, 127, '2014-01-15 01:01:32.000000', 'consum', 0.0212, 'lps'),
	(488303, 127, '2014-01-15 01:01:33.000000', 'consum', 0.0225, 'lps'),
	(488304, 127, '2014-01-15 01:01:34.000000', 'consum', 0.0214, 'lps'),
	(488305, 127, '2014-01-15 01:01:35.000000', 'consum', 0.0219, 'lps'),
	(488306, 127, '2014-01-15 01:01:36.000000', 'consum', 0.0210, 'lps'),
	(488307, 127, '2014-01-15 01:01:37.000000', 'consum', 0.0215, 'lps'),
	(488308, 127, '2014-01-15 01:01:38.000000', 'consum', 0.0222, 'lps'),
	(488309, 127, '2014-01-15 01:01:39.000000', 'consum', 0.0219, 'lps'),
	(488310, 127, '2014-01-15 01:01:40.000000', 'consum', 0.0219, 'lps'),
	(488311, 127, '2014-01-15 01:01:41.000000', 'consum', 0.0211, 'lps'),
	(488312, 127, '2014-01-15 01:01:42.000000', 'consum', 0.0222, 'lps'),
	(488313, 127, '2014-01-15 01:01:43.000000', 'consum', 0.0219, 'lps'),
	(488314, 127, '2014-01-15 01:01:44.000000', 'consum', 0.0217, 'lps'),
	(488315, 127, '2014-01-15 01:01:45.000000', 'consum', 0.0217, 'lps'),
	(488316, 127, '2014-01-15 01:01:46.000000', 'consum', 0.0211, 'lps'),
	(488317, 127, '2014-01-15 01:01:47.000000', 'consum', 0.0210, 'lps'),
	(488318, 127, '2014-01-15 01:01:48.000000', 'consum', 0.0210, 'lps'),
	(488319, 127, '2014-01-15 01:01:49.000000', 'consum', 0.0224, 'lps'),
	(488320, 127, '2014-01-15 01:01:50.000000', 'consum', 0.0214, 'lps'),
	(488321, 127, '2014-01-15 01:01:51.000000', 'consum', 0.0224, 'lps'),
	(488322, 127, '2014-01-15 01:01:52.000000', 'consum', 0.0217, 'lps'),
	(488323, 127, '2014-01-15 01:01:53.000000', 'consum', 0.0218, 'lps'),
	(488324, 127, '2014-01-15 01:01:54.000000', 'consum', 0.0216, 'lps'),
	(488325, 127, '2014-01-15 01:01:55.000000', 'consum', 0.0215, 'lps'),
	(488326, 127, '2014-01-15 01:01:56.000000', 'consum', 0.0219, 'lps'),
	(488327, 127, '2014-01-15 01:01:57.000000', 'consum', 0.0224, 'lps'),
	(488328, 127, '2014-01-15 01:01:58.000000', 'consum', 0.0218, 'lps'),
	(488329, 127, '2014-01-15 01:01:59.000000', 'consum', 0.0225, 'lps'),
	(488330, 127, '2014-01-15 01:02:00.000000', 'consum', 0.0213, 'lps'),
	(488331, 127, '2014-01-15 01:02:01.000000', 'consum', 0.0211, 'lps'),
	(488332, 127, '2014-01-15 01:02:02.000000', 'consum', 0.0225, 'lps'),
	(488333, 127, '2014-01-15 01:02:03.000000', 'consum', 0.0215, 'lps'),
	(488334, 127, '2014-01-15 01:02:04.000000', 'consum', 0.0224, 'lps'),
	(488335, 127, '2014-01-15 01:02:05.000000', 'consum', 0.0216, 'lps'),
	(488336, 127, '2014-01-15 01:02:06.000000', 'consum', 0.0214, 'lps'),
	(488337, 127, '2014-01-15 01:02:07.000000', 'consum', 0.0214, 'lps'),
	(488338, 127, '2014-01-15 01:02:08.000000', 'consum', 0.0216, 'lps'),
	(488339, 127, '2014-01-15 01:02:09.000000', 'consum', 0.0214, 'lps'),
	(488340, 127, '2014-01-15 01:02:10.000000', 'consum', 0.0212, 'lps'),
	(488341, 127, '2014-01-15 01:02:11.000000', 'consum', 0.0226, 'lps'),
	(488342, 127, '2014-01-15 01:02:12.000000', 'consum', 0.0216, 'lps'),
	(488343, 127, '2014-01-15 01:02:13.000000', 'consum', 0.0211, 'lps'),
	(488344, 127, '2014-01-15 01:02:14.000000', 'consum', 0.0215, 'lps'),
	(488345, 127, '2014-01-15 01:02:15.000000', 'consum', 0.0214, 'lps'),
	(488346, 127, '2014-01-15 01:02:16.000000', 'consum', 0.0216, 'lps'),
	(488347, 127, '2014-01-15 01:02:17.000000', 'consum', 0.0211, 'lps'),
	(488348, 127, '2014-01-15 01:02:18.000000', 'consum', 0.0213, 'lps'),
	(488349, 127, '2014-01-15 01:02:19.000000', 'consum', 0.0224, 'lps'),
	(488350, 127, '2014-01-15 01:02:20.000000', 'consum', 0.0220, 'lps'),
	(488351, 127, '2014-01-15 01:02:21.000000', 'consum', 0.0221, 'lps'),
	(488352, 127, '2014-01-15 01:02:22.000000', 'consum', 0.0216, 'lps'),
	(488353, 127, '2014-01-15 01:02:23.000000', 'consum', 0.0223, 'lps'),
	(488354, 127, '2014-01-15 01:02:24.000000', 'consum', 0.0226, 'lps'),
	(488355, 127, '2014-01-15 01:02:25.000000', 'consum', 0.0217, 'lps'),
	(488356, 127, '2014-01-15 01:02:26.000000', 'consum', 0.0213, 'lps'),
	(488357, 127, '2014-01-15 01:02:27.000000', 'consum', 0.0224, 'lps'),
	(488358, 127, '2014-01-15 01:02:28.000000', 'consum', 0.0220, 'lps'),
	(488359, 127, '2014-01-15 01:02:29.000000', 'consum', 0.0217, 'lps'),
	(488360, 127, '2014-01-15 01:02:30.000000', 'consum', 0.0217, 'lps'),
	(488361, 127, '2014-01-15 01:02:31.000000', 'consum', 0.0225, 'lps'),
	(488362, 127, '2014-01-15 01:02:32.000000', 'consum', 0.0213, 'lps'),
	(488363, 127, '2014-01-15 01:02:33.000000', 'consum', 0.0216, 'lps'),
	(488364, 127, '2014-01-15 01:02:34.000000', 'consum', 0.0212, 'lps'),
	(488365, 127, '2014-01-15 01:02:35.000000', 'consum', 0.0219, 'lps'),
	(488366, 127, '2014-01-15 01:02:36.000000', 'consum', 0.0216, 'lps'),
	(488367, 127, '2014-01-15 01:02:37.000000', 'consum', 0.0213, 'lps'),
	(488368, 127, '2014-01-15 01:02:38.000000', 'consum', 0.0226, 'lps'),
	(488369, 127, '2014-01-15 01:02:39.000000', 'consum', 0.0212, 'lps'),
	(488370, 127, '2014-01-15 01:02:40.000000', 'consum', 0.0224, 'lps'),
	(488371, 127, '2014-01-15 01:02:41.000000', 'consum', 0.0224, 'lps'),
	(488372, 127, '2014-01-15 01:02:42.000000', 'consum', 0.0222, 'lps'),
	(488373, 127, '2014-01-15 01:02:43.000000', 'consum', 0.0212, 'lps'),
	(488374, 127, '2014-01-15 01:02:44.000000', 'consum', 0.0216, 'lps'),
	(488375, 127, '2014-01-15 01:02:45.000000', 'consum', 0.0219, 'lps'),
	(488376, 127, '2014-01-15 01:02:46.000000', 'consum', 0.0222, 'lps'),
	(488377, 127, '2014-01-15 01:02:47.000000', 'consum', 0.0225, 'lps'),
	(488378, 127, '2014-01-15 01:02:48.000000', 'consum', 0.0216, 'lps'),
	(488379, 127, '2014-01-15 01:02:49.000000', 'consum', 0.0214, 'lps'),
	(488380, 127, '2014-01-15 01:02:50.000000', 'consum', 0.0212, 'lps'),
	(488381, 127, '2014-01-15 01:02:51.000000', 'consum', 0.0224, 'lps'),
	(488382, 127, '2014-01-15 01:02:52.000000', 'consum', 0.0224, 'lps'),
	(488383, 127, '2014-01-15 01:02:53.000000', 'consum', 0.0221, 'lps'),
	(488384, 127, '2014-01-15 01:02:54.000000', 'consum', 0.0226, 'lps'),
	(488385, 127, '2014-01-15 01:02:55.000000', 'consum', 0.0221, 'lps'),
	(488386, 127, '2014-01-15 01:02:56.000000', 'consum', 0.0219, 'lps'),
	(488387, 127, '2014-01-15 01:02:57.000000', 'consum', 0.0221, 'lps'),
	(488388, 127, '2014-01-15 01:02:58.000000', 'consum', 0.0221, 'lps'),
	(488389, 127, '2014-01-15 01:02:59.000000', 'consum', 0.0217, 'lps'),
	(488390, 127, '2014-01-15 01:03:00.000000', 'consum', 0.0212, 'lps'),
	(488391, 127, '2014-01-15 01:03:01.000000', 'consum', 0.0215, 'lps'),
	(488392, 127, '2014-01-15 01:03:02.000000', 'consum', 0.0213, 'lps'),
	(488393, 127, '2014-01-15 01:03:03.000000', 'consum', 0.0213, 'lps'),
	(488394, 127, '2014-01-15 01:03:04.000000', 'consum', 0.0214, 'lps'),
	(488395, 127, '2014-01-15 01:03:05.000000', 'consum', 0.0222, 'lps'),
	(488396, 127, '2014-01-15 01:03:06.000000', 'consum', 0.0224, 'lps'),
	(488397, 127, '2014-01-15 01:03:07.000000', 'consum', 0.0210, 'lps'),
	(488398, 127, '2014-01-15 01:03:08.000000', 'consum', 0.0222, 'lps'),
	(488399, 127, '2014-01-15 01:03:09.000000', 'consum', 0.0219, 'lps'),
	(488400, 127, '2014-01-15 01:03:10.000000', 'consum', 0.0217, 'lps'),
	(488401, 127, '2014-01-15 01:03:11.000000', 'consum', 0.0220, 'lps'),
	(488402, 127, '2014-01-15 01:03:12.000000', 'consum', 0.0222, 'lps'),
	(488403, 127, '2014-01-15 01:03:13.000000', 'consum', 0.0224, 'lps'),
	(488404, 127, '2014-01-15 01:03:14.000000', 'consum', 0.0212, 'lps'),
	(488405, 127, '2014-01-15 01:03:15.000000', 'consum', 0.0213, 'lps'),
	(488406, 127, '2014-01-15 01:03:16.000000', 'consum', 0.0219, 'lps'),
	(488407, 127, '2014-01-15 01:03:17.000000', 'consum', 0.0214, 'lps'),
	(488408, 127, '2014-01-15 01:03:18.000000', 'consum', 0.0218, 'lps'),
	(488409, 127, '2014-01-15 01:03:19.000000', 'consum', 0.0223, 'lps'),
	(488410, 127, '2014-01-15 01:03:20.000000', 'consum', 0.0218, 'lps'),
	(488411, 127, '2014-01-15 01:03:21.000000', 'consum', 0.0213, 'lps'),
	(488412, 127, '2014-01-15 01:03:22.000000', 'consum', 0.0216, 'lps'),
	(488413, 127, '2014-01-15 01:03:23.000000', 'consum', 0.0214, 'lps'),
	(488414, 127, '2014-01-15 01:03:24.000000', 'consum', 0.0215, 'lps'),
	(488415, 127, '2014-01-15 01:03:25.000000', 'consum', 0.0223, 'lps'),
	(488416, 127, '2014-01-15 01:03:26.000000', 'consum', 0.0211, 'lps'),
	(488417, 127, '2014-01-15 01:03:27.000000', 'consum', 0.0224, 'lps'),
	(488418, 127, '2014-01-15 01:03:28.000000', 'consum', 0.0212, 'lps'),
	(488419, 127, '2014-01-15 01:03:29.000000', 'consum', 0.0212, 'lps'),
	(488420, 127, '2014-01-15 01:03:30.000000', 'consum', 0.0213, 'lps'),
	(488421, 127, '2014-01-15 01:03:31.000000', 'consum', 0.0222, 'lps'),
	(488422, 127, '2014-01-15 01:03:32.000000', 'consum', 0.0211, 'lps'),
	(488423, 127, '2014-01-15 01:03:33.000000', 'consum', 0.0214, 'lps'),
	(488424, 127, '2014-01-15 01:03:34.000000', 'consum', 0.0210, 'lps'),
	(488425, 127, '2014-01-15 01:03:35.000000', 'consum', 0.0215, 'lps'),
	(488426, 127, '2014-01-15 01:03:36.000000', 'consum', 0.0220, 'lps'),
	(488427, 127, '2014-01-15 01:03:37.000000', 'consum', 0.0212, 'lps'),
	(488428, 127, '2014-01-15 01:03:38.000000', 'consum', 0.0224, 'lps'),
	(488429, 127, '2014-01-15 01:03:39.000000', 'consum', 0.0223, 'lps'),
	(488430, 127, '2014-01-15 01:03:40.000000', 'consum', 0.0217, 'lps'),
	(488431, 127, '2014-01-15 01:03:41.000000', 'consum', 0.0224, 'lps'),
	(488432, 127, '2014-01-15 01:03:42.000000', 'consum', 0.0226, 'lps'),
	(488433, 127, '2014-01-15 01:03:43.000000', 'consum', 0.0212, 'lps'),
	(488434, 127, '2014-01-15 01:03:44.000000', 'consum', 0.0223, 'lps'),
	(488435, 127, '2014-01-15 01:03:45.000000', 'consum', 0.0221, 'lps'),
	(488436, 127, '2014-01-15 01:03:46.000000', 'consum', 0.0225, 'lps'),
	(488437, 127, '2014-01-15 01:03:47.000000', 'consum', 0.0217, 'lps'),
	(488438, 127, '2014-01-15 01:03:48.000000', 'consum', 0.0220, 'lps'),
	(488439, 127, '2014-01-15 01:03:49.000000', 'consum', 0.0223, 'lps'),
	(488440, 127, '2014-01-15 01:03:50.000000', 'consum', 0.0211, 'lps'),
	(488441, 127, '2014-01-15 01:03:51.000000', 'consum', 0.0210, 'lps'),
	(488442, 127, '2014-01-15 01:03:52.000000', 'consum', 0.0224, 'lps'),
	(488443, 127, '2014-01-15 01:03:53.000000', 'consum', 0.0214, 'lps'),
	(488444, 127, '2014-01-15 01:03:54.000000', 'consum', 0.0222, 'lps'),
	(488445, 127, '2014-01-15 01:03:55.000000', 'consum', 0.0223, 'lps'),
	(488446, 127, '2014-01-15 01:03:56.000000', 'consum', 0.0224, 'lps'),
	(488447, 127, '2014-01-15 01:03:57.000000', 'consum', 0.0224, 'lps'),
	(488448, 127, '2014-01-15 01:03:58.000000', 'consum', 0.0223, 'lps'),
	(488449, 127, '2014-01-15 01:03:59.000000', 'consum', 0.0216, 'lps'),
	(488450, 127, '2014-01-15 01:04:00.000000', 'consum', 0.0220, 'lps'),
	(488451, 127, '2014-01-15 01:04:01.000000', 'consum', 0.0224, 'lps'),
	(488452, 127, '2014-01-15 01:04:02.000000', 'consum', 0.0217, 'lps'),
	(488453, 127, '2014-01-15 01:04:03.000000', 'consum', 0.0221, 'lps'),
	(488454, 127, '2014-01-15 01:04:04.000000', 'consum', 0.0225, 'lps'),
	(488455, 127, '2014-01-15 01:04:05.000000', 'consum', 0.0222, 'lps'),
	(488456, 127, '2014-01-15 01:04:06.000000', 'consum', 0.0223, 'lps'),
	(488457, 127, '2014-01-15 01:04:07.000000', 'consum', 0.0223, 'lps'),
	(488458, 127, '2014-01-15 01:04:08.000000', 'consum', 0.0219, 'lps'),
	(488459, 127, '2014-01-15 01:04:09.000000', 'consum', 0.0216, 'lps'),
	(488460, 127, '2014-01-15 01:04:10.000000', 'consum', 0.0216, 'lps'),
	(488461, 127, '2014-01-15 01:04:11.000000', 'consum', 0.0219, 'lps'),
	(488462, 127, '2014-01-15 01:04:12.000000', 'consum', 0.0223, 'lps'),
	(488463, 127, '2014-01-15 01:04:13.000000', 'consum', 0.0214, 'lps'),
	(488464, 127, '2014-01-15 01:04:14.000000', 'consum', 0.0226, 'lps'),
	(488465, 127, '2014-01-15 01:04:15.000000', 'consum', 0.0226, 'lps'),
	(488466, 127, '2014-01-15 01:04:16.000000', 'consum', 0.0224, 'lps'),
	(488467, 127, '2014-01-15 01:04:17.000000', 'consum', 0.0218, 'lps'),
	(488468, 127, '2014-01-15 01:04:18.000000', 'consum', 0.0223, 'lps'),
	(488469, 127, '2014-01-15 01:04:19.000000', 'consum', 0.0219, 'lps'),
	(488470, 127, '2014-01-15 01:04:20.000000', 'consum', 0.0216, 'lps'),
	(488471, 127, '2014-01-15 01:04:21.000000', 'consum', 0.0215, 'lps'),
	(488472, 127, '2014-01-15 01:04:22.000000', 'consum', 0.0215, 'lps'),
	(488473, 127, '2014-01-15 01:04:23.000000', 'consum', 0.0220, 'lps'),
	(488474, 127, '2014-01-15 01:04:24.000000', 'consum', 0.0214, 'lps'),
	(488475, 127, '2014-01-15 01:04:25.000000', 'consum', 0.0216, 'lps'),
	(488476, 127, '2014-01-15 01:04:26.000000', 'consum', 0.0212, 'lps'),
	(488477, 127, '2014-01-15 01:04:27.000000', 'consum', 0.0219, 'lps'),
	(488478, 127, '2014-01-15 01:04:28.000000', 'consum', 0.0215, 'lps'),
	(488479, 127, '2014-01-15 01:04:29.000000', 'consum', 0.0211, 'lps'),
	(488480, 127, '2014-01-15 01:04:30.000000', 'consum', 0.0214, 'lps'),
	(488481, 127, '2014-01-15 01:04:31.000000', 'consum', 0.0212, 'lps'),
	(488482, 127, '2014-01-15 01:04:32.000000', 'consum', 0.0226, 'lps'),
	(488483, 127, '2014-01-15 01:04:33.000000', 'consum', 0.0217, 'lps'),
	(488484, 127, '2014-01-15 01:04:34.000000', 'consum', 0.0215, 'lps'),
	(488485, 127, '2014-01-15 01:04:35.000000', 'consum', 0.0212, 'lps'),
	(488486, 127, '2014-01-15 01:04:36.000000', 'consum', 0.0224, 'lps'),
	(488487, 127, '2014-01-15 01:04:37.000000', 'consum', 0.0225, 'lps'),
	(488488, 127, '2014-01-15 01:04:38.000000', 'consum', 0.0224, 'lps'),
	(488489, 127, '2014-01-15 01:04:39.000000', 'consum', 0.0221, 'lps'),
	(488490, 127, '2014-01-15 01:04:40.000000', 'consum', 0.0222, 'lps'),
	(488491, 127, '2014-01-15 01:04:41.000000', 'consum', 0.0223, 'lps'),
	(488492, 127, '2014-01-15 01:04:42.000000', 'consum', 0.0220, 'lps'),
	(488493, 127, '2014-01-15 01:04:43.000000', 'consum', 0.0223, 'lps'),
	(488494, 127, '2014-01-15 01:04:44.000000', 'consum', 0.0213, 'lps'),
	(488495, 127, '2014-01-15 01:04:45.000000', 'consum', 0.0218, 'lps'),
	(488496, 127, '2014-01-15 01:04:46.000000', 'consum', 0.0224, 'lps'),
	(488497, 127, '2014-01-15 01:04:47.000000', 'consum', 0.0222, 'lps'),
	(488498, 127, '2014-01-15 01:04:48.000000', 'consum', 0.0212, 'lps'),
	(488499, 127, '2014-01-15 01:04:49.000000', 'consum', 0.0217, 'lps'),
	(488500, 127, '2014-01-15 01:04:50.000000', 'consum', 0.0224, 'lps'),
	(488501, 127, '2014-01-15 01:04:51.000000', 'consum', 0.0224, 'lps'),
	(488502, 127, '2014-01-15 01:04:52.000000', 'consum', 0.0222, 'lps'),
	(488503, 127, '2014-01-15 01:04:53.000000', 'consum', 0.0214, 'lps'),
	(488504, 127, '2014-01-15 01:04:54.000000', 'consum', 0.0226, 'lps'),
	(488505, 127, '2014-01-15 01:04:55.000000', 'consum', 0.0213, 'lps'),
	(488506, 127, '2014-01-15 01:04:56.000000', 'consum', 0.0211, 'lps'),
	(488507, 127, '2014-01-15 01:04:57.000000', 'consum', 0.0223, 'lps'),
	(488508, 127, '2014-01-15 01:04:58.000000', 'consum', 0.0221, 'lps'),
	(488509, 127, '2014-01-15 01:04:59.000000', 'consum', 0.0226, 'lps'),
	(488510, 127, '2014-01-15 01:05:00.000000', 'consum', 0.0224, 'lps'),
	(488511, 127, '2014-01-15 01:05:01.000000', 'consum', 0.0214, 'lps'),
	(488512, 127, '2014-01-15 01:05:02.000000', 'consum', 0.0225, 'lps'),
	(488513, 127, '2014-01-15 01:05:03.000000', 'consum', 0.0221, 'lps'),
	(488514, 127, '2014-01-15 01:05:04.000000', 'consum', 0.0220, 'lps'),
	(488515, 127, '2014-01-15 01:05:05.000000', 'consum', 0.0212, 'lps'),
	(488516, 127, '2014-01-15 01:05:06.000000', 'consum', 0.0223, 'lps'),
	(488517, 127, '2014-01-15 01:05:07.000000', 'consum', 0.0218, 'lps'),
	(488518, 127, '2014-01-15 01:05:08.000000', 'consum', 0.0211, 'lps'),
	(488519, 127, '2014-01-15 01:05:09.000000', 'consum', 0.0226, 'lps'),
	(488520, 127, '2014-01-15 01:05:10.000000', 'consum', 0.0220, 'lps'),
	(488521, 127, '2014-01-15 01:05:11.000000', 'consum', 0.0213, 'lps'),
	(488522, 127, '2014-01-15 01:05:12.000000', 'consum', 0.0211, 'lps'),
	(488523, 127, '2014-01-15 01:05:13.000000', 'consum', 0.0223, 'lps'),
	(488524, 127, '2014-01-15 01:05:14.000000', 'consum', 0.0223, 'lps'),
	(488525, 127, '2014-01-15 01:05:15.000000', 'consum', 0.0220, 'lps'),
	(488526, 127, '2014-01-15 01:05:16.000000', 'consum', 0.0223, 'lps'),
	(488527, 127, '2014-01-15 01:05:17.000000', 'consum', 0.0225, 'lps'),
	(488528, 127, '2014-01-15 01:05:18.000000', 'consum', 0.0214, 'lps'),
	(488529, 127, '2014-01-15 01:05:19.000000', 'consum', 0.0221, 'lps'),
	(488530, 127, '2014-01-15 01:05:20.000000', 'consum', 0.0218, 'lps'),
	(488531, 127, '2014-01-15 01:05:21.000000', 'consum', 0.0219, 'lps'),
	(488532, 127, '2014-01-15 01:05:22.000000', 'consum', 0.0214, 'lps'),
	(488533, 127, '2014-01-15 01:05:23.000000', 'consum', 0.0219, 'lps'),
	(488534, 127, '2014-01-15 01:05:24.000000', 'consum', 0.0211, 'lps'),
	(488535, 127, '2014-01-15 01:05:25.000000', 'consum', 0.0223, 'lps'),
	(488536, 127, '2014-01-15 01:05:26.000000', 'consum', 0.0221, 'lps'),
	(488537, 127, '2014-01-15 01:05:27.000000', 'consum', 0.0226, 'lps'),
	(488538, 127, '2014-01-15 01:05:28.000000', 'consum', 0.0224, 'lps'),
	(488539, 127, '2014-01-15 01:05:29.000000', 'consum', 0.0215, 'lps'),
	(488540, 127, '2014-01-15 01:05:30.000000', 'consum', 0.0211, 'lps'),
	(488541, 127, '2014-01-15 01:05:31.000000', 'consum', 0.0218, 'lps'),
	(488542, 127, '2014-01-15 01:05:32.000000', 'consum', 0.0214, 'lps'),
	(488543, 127, '2014-01-15 01:05:33.000000', 'consum', 0.0221, 'lps'),
	(488544, 127, '2014-01-15 01:05:34.000000', 'consum', 0.0221, 'lps'),
	(488545, 127, '2014-01-15 01:05:35.000000', 'consum', 0.0213, 'lps'),
	(488546, 127, '2014-01-15 01:05:36.000000', 'consum', 0.0212, 'lps'),
	(488547, 127, '2014-01-15 01:05:37.000000', 'consum', 0.0213, 'lps'),
	(488548, 127, '2014-01-15 01:05:38.000000', 'consum', 0.0217, 'lps'),
	(488549, 127, '2014-01-15 01:05:39.000000', 'consum', 0.0218, 'lps'),
	(488550, 127, '2014-01-15 01:05:40.000000', 'consum', 0.0216, 'lps'),
	(488551, 127, '2014-01-15 01:05:41.000000', 'consum', 0.0216, 'lps'),
	(488552, 127, '2014-01-15 01:05:42.000000', 'consum', 0.0221, 'lps'),
	(488553, 127, '2014-01-15 01:05:43.000000', 'consum', 0.0216, 'lps'),
	(488554, 127, '2014-01-15 01:05:44.000000', 'consum', 0.0222, 'lps'),
	(488555, 127, '2014-01-15 01:05:45.000000', 'consum', 0.0218, 'lps'),
	(488556, 127, '2014-01-15 01:05:46.000000', 'consum', 0.0216, 'lps'),
	(488557, 127, '2014-01-15 01:05:47.000000', 'consum', 0.0214, 'lps'),
	(488558, 127, '2014-01-15 01:05:48.000000', 'consum', 0.0214, 'lps'),
	(488559, 127, '2014-01-15 01:05:49.000000', 'consum', 0.0220, 'lps'),
	(488560, 127, '2014-01-15 01:05:50.000000', 'consum', 0.0215, 'lps'),
	(488561, 127, '2014-01-15 01:05:51.000000', 'consum', 0.0223, 'lps'),
	(488562, 127, '2014-01-15 01:05:52.000000', 'consum', 0.0226, 'lps'),
	(488563, 127, '2014-01-15 01:05:53.000000', 'consum', 0.0216, 'lps'),
	(488564, 127, '2014-01-15 01:05:54.000000', 'consum', 0.0211, 'lps'),
	(488565, 127, '2014-01-15 01:05:55.000000', 'consum', 0.0214, 'lps'),
	(488566, 127, '2014-01-15 01:05:56.000000', 'consum', 0.0225, 'lps'),
	(488567, 127, '2014-01-15 01:05:57.000000', 'consum', 0.0226, 'lps'),
	(488568, 127, '2014-01-15 01:05:58.000000', 'consum', 0.0211, 'lps'),
	(488569, 127, '2014-01-15 01:05:59.000000', 'consum', 0.0218, 'lps'),
	(488570, 127, '2014-01-15 01:06:00.000000', 'consum', 0.0213, 'lps'),
	(488571, 127, '2014-01-15 01:06:01.000000', 'consum', 0.0221, 'lps'),
	(488572, 127, '2014-01-15 01:06:02.000000', 'consum', 0.0221, 'lps'),
	(488573, 127, '2014-01-15 01:06:03.000000', 'consum', 0.0215, 'lps'),
	(488574, 127, '2014-01-15 01:06:04.000000', 'consum', 0.0221, 'lps'),
	(488575, 127, '2014-01-15 01:06:05.000000', 'consum', 0.0214, 'lps'),
	(488576, 127, '2014-01-15 01:06:06.000000', 'consum', 0.0218, 'lps'),
	(488577, 127, '2014-01-15 01:06:07.000000', 'consum', 0.0218, 'lps'),
	(488578, 127, '2014-01-15 01:06:08.000000', 'consum', 0.0212, 'lps'),
	(488579, 127, '2014-01-15 01:06:09.000000', 'consum', 0.0211, 'lps'),
	(488580, 127, '2014-01-15 01:06:10.000000', 'consum', 0.0212, 'lps'),
	(488581, 127, '2014-01-15 01:06:11.000000', 'consum', 0.0215, 'lps'),
	(488582, 127, '2014-01-15 01:06:12.000000', 'consum', 0.0215, 'lps'),
	(488583, 127, '2014-01-15 01:06:13.000000', 'consum', 0.0219, 'lps'),
	(488584, 127, '2014-01-15 01:06:14.000000', 'consum', 0.0222, 'lps'),
	(488585, 127, '2014-01-15 01:06:15.000000', 'consum', 0.0213, 'lps'),
	(488586, 127, '2014-01-15 01:06:16.000000', 'consum', 0.0221, 'lps'),
	(488587, 127, '2014-01-15 01:06:17.000000', 'consum', 0.0222, 'lps'),
	(488588, 127, '2014-01-15 01:06:18.000000', 'consum', 0.0223, 'lps'),
	(488589, 127, '2014-01-15 01:06:19.000000', 'consum', 0.0222, 'lps'),
	(488590, 127, '2014-01-15 01:06:20.000000', 'consum', 0.0212, 'lps'),
	(488591, 127, '2014-01-15 01:06:21.000000', 'consum', 0.0221, 'lps'),
	(488592, 127, '2014-01-15 01:06:22.000000', 'consum', 0.0224, 'lps'),
	(488593, 127, '2014-01-15 01:06:23.000000', 'consum', 0.0215, 'lps'),
	(488594, 127, '2014-01-15 01:06:24.000000', 'consum', 0.0210, 'lps'),
	(488595, 127, '2014-01-15 01:06:25.000000', 'consum', 0.0211, 'lps'),
	(488596, 127, '2014-01-15 01:06:26.000000', 'consum', 0.0216, 'lps'),
	(488597, 127, '2014-01-15 01:06:27.000000', 'consum', 0.0221, 'lps'),
	(488598, 127, '2014-01-15 01:06:28.000000', 'consum', 0.0212, 'lps'),
	(488599, 127, '2014-01-15 01:06:29.000000', 'consum', 0.0222, 'lps'),
	(488600, 127, '2014-01-15 01:06:30.000000', 'consum', 0.0213, 'lps'),
	(488601, 127, '2014-01-15 01:06:31.000000', 'consum', 0.0223, 'lps'),
	(488602, 127, '2014-01-15 01:06:32.000000', 'consum', 0.0214, 'lps'),
	(488603, 127, '2014-01-15 01:06:33.000000', 'consum', 0.0211, 'lps'),
	(488604, 127, '2014-01-15 01:06:34.000000', 'consum', 0.0219, 'lps'),
	(488605, 127, '2014-01-15 01:06:35.000000', 'consum', 0.0221, 'lps'),
	(488606, 127, '2014-01-15 01:06:36.000000', 'consum', 0.0219, 'lps'),
	(488607, 127, '2014-01-15 01:06:37.000000', 'consum', 0.0225, 'lps'),
	(488608, 127, '2014-01-15 01:06:38.000000', 'consum', 0.0222, 'lps'),
	(488609, 127, '2014-01-15 01:06:39.000000', 'consum', 0.0226, 'lps'),
	(488610, 127, '2014-01-15 01:06:40.000000', 'consum', 0.0219, 'lps'),
	(488611, 127, '2014-01-15 01:06:41.000000', 'consum', 0.0225, 'lps'),
	(488612, 127, '2014-01-15 01:06:42.000000', 'consum', 0.0226, 'lps'),
	(488613, 127, '2014-01-15 01:06:43.000000', 'consum', 0.0212, 'lps'),
	(488614, 127, '2014-01-15 01:06:44.000000', 'consum', 0.0223, 'lps'),
	(488615, 127, '2014-01-15 01:06:45.000000', 'consum', 0.0217, 'lps'),
	(488616, 127, '2014-01-15 01:06:46.000000', 'consum', 0.0226, 'lps'),
	(488617, 127, '2014-01-15 01:06:47.000000', 'consum', 0.0216, 'lps'),
	(488618, 127, '2014-01-15 01:06:48.000000', 'consum', 0.0211, 'lps'),
	(488619, 127, '2014-01-15 01:06:49.000000', 'consum', 0.0214, 'lps'),
	(488620, 127, '2014-01-15 01:06:50.000000', 'consum', 0.0211, 'lps'),
	(488621, 127, '2014-01-15 01:06:51.000000', 'consum', 0.0218, 'lps'),
	(488622, 127, '2014-01-15 01:06:52.000000', 'consum', 0.0216, 'lps'),
	(488623, 127, '2014-01-15 01:06:53.000000', 'consum', 0.0218, 'lps'),
	(488624, 127, '2014-01-15 01:06:54.000000', 'consum', 0.0214, 'lps'),
	(488625, 127, '2014-01-15 01:06:55.000000', 'consum', 0.0222, 'lps'),
	(488626, 127, '2014-01-15 01:06:56.000000', 'consum', 0.0226, 'lps'),
	(488627, 127, '2014-01-15 01:06:57.000000', 'consum', 0.0219, 'lps'),
	(488628, 127, '2014-01-15 01:06:58.000000', 'consum', 0.0225, 'lps'),
	(488629, 127, '2014-01-15 01:06:59.000000', 'consum', 0.0225, 'lps'),
	(488630, 127, '2014-01-15 01:07:00.000000', 'consum', 0.0224, 'lps'),
	(488631, 127, '2014-01-15 01:07:01.000000', 'consum', 0.0218, 'lps'),
	(488632, 127, '2014-01-15 01:07:02.000000', 'consum', 0.0226, 'lps'),
	(488633, 127, '2014-01-15 01:07:03.000000', 'consum', 0.0217, 'lps'),
	(488634, 127, '2014-01-15 01:07:04.000000', 'consum', 0.0213, 'lps'),
	(488635, 127, '2014-01-15 01:07:05.000000', 'consum', 0.0220, 'lps'),
	(488636, 127, '2014-01-15 01:07:06.000000', 'consum', 0.0218, 'lps'),
	(488637, 127, '2014-01-15 01:07:07.000000', 'consum', 0.0219, 'lps'),
	(488638, 127, '2014-01-15 01:07:08.000000', 'consum', 0.0216, 'lps'),
	(488639, 127, '2014-01-15 01:07:09.000000', 'consum', 0.0215, 'lps'),
	(488640, 127, '2014-01-15 01:07:10.000000', 'consum', 0.0218, 'lps'),
	(488641, 127, '2014-01-15 01:07:11.000000', 'consum', 0.0216, 'lps'),
	(488642, 127, '2014-01-15 01:07:12.000000', 'consum', 0.0216, 'lps'),
	(488643, 127, '2014-01-15 01:07:13.000000', 'consum', 0.0223, 'lps'),
	(488644, 127, '2014-01-15 01:07:14.000000', 'consum', 0.0222, 'lps'),
	(488645, 127, '2014-01-15 01:07:15.000000', 'consum', 0.0218, 'lps'),
	(488646, 127, '2014-01-15 01:07:16.000000', 'consum', 0.0212, 'lps'),
	(488647, 127, '2014-01-15 01:07:17.000000', 'consum', 0.0214, 'lps'),
	(488648, 127, '2014-01-15 01:07:18.000000', 'consum', 0.0225, 'lps'),
	(488649, 127, '2014-01-15 01:07:19.000000', 'consum', 0.0221, 'lps'),
	(488650, 127, '2014-01-15 01:07:20.000000', 'consum', 0.0221, 'lps'),
	(488651, 127, '2014-01-15 01:07:21.000000', 'consum', 0.0215, 'lps'),
	(488652, 127, '2014-01-15 01:07:22.000000', 'consum', 0.0218, 'lps'),
	(488653, 127, '2014-01-15 01:07:23.000000', 'consum', 0.0219, 'lps'),
	(488654, 127, '2014-01-15 01:07:24.000000', 'consum', 0.0217, 'lps'),
	(488655, 127, '2014-01-15 01:07:25.000000', 'consum', 0.0218, 'lps'),
	(488656, 127, '2014-01-15 01:07:26.000000', 'consum', 0.0211, 'lps'),
	(488657, 127, '2014-01-15 01:07:27.000000', 'consum', 0.0225, 'lps'),
	(488658, 127, '2014-01-15 01:07:28.000000', 'consum', 0.0217, 'lps'),
	(488659, 127, '2014-01-15 01:07:29.000000', 'consum', 0.0216, 'lps'),
	(488660, 127, '2014-01-15 01:07:30.000000', 'consum', 0.0220, 'lps'),
	(488661, 127, '2014-01-15 01:07:31.000000', 'consum', 0.0224, 'lps'),
	(488662, 127, '2014-01-15 01:07:32.000000', 'consum', 0.0217, 'lps'),
	(488663, 127, '2014-01-15 01:07:33.000000', 'consum', 0.0221, 'lps'),
	(488664, 127, '2014-01-15 01:07:34.000000', 'consum', 0.0211, 'lps'),
	(488665, 127, '2014-01-15 01:07:35.000000', 'consum', 0.0215, 'lps'),
	(488666, 127, '2014-01-15 01:07:36.000000', 'consum', 0.0215, 'lps'),
	(488667, 127, '2014-01-15 01:07:37.000000', 'consum', 0.0222, 'lps'),
	(488668, 127, '2014-01-15 01:07:38.000000', 'consum', 0.0220, 'lps'),
	(488669, 127, '2014-01-15 01:07:39.000000', 'consum', 0.0225, 'lps'),
	(488670, 127, '2014-01-15 01:07:40.000000', 'consum', 0.0223, 'lps'),
	(488671, 127, '2014-01-15 01:07:41.000000', 'consum', 0.0213, 'lps'),
	(488672, 127, '2014-01-15 01:07:42.000000', 'consum', 0.0220, 'lps'),
	(488673, 127, '2014-01-15 01:07:43.000000', 'consum', 0.0220, 'lps'),
	(488674, 127, '2014-01-15 01:07:44.000000', 'consum', 0.0210, 'lps'),
	(488675, 127, '2014-01-15 01:07:45.000000', 'consum', 0.0217, 'lps'),
	(488676, 127, '2014-01-15 01:07:46.000000', 'consum', 0.0210, 'lps'),
	(488677, 127, '2014-01-15 01:07:47.000000', 'consum', 0.0224, 'lps'),
	(488678, 127, '2014-01-15 01:07:48.000000', 'consum', 0.0213, 'lps'),
	(488679, 127, '2014-01-15 01:07:49.000000', 'consum', 0.0216, 'lps'),
	(488680, 127, '2014-01-15 01:07:50.000000', 'consum', 0.0214, 'lps'),
	(488681, 127, '2014-01-15 01:07:51.000000', 'consum', 0.0214, 'lps'),
	(488682, 127, '2014-01-15 01:07:52.000000', 'consum', 0.0219, 'lps'),
	(488683, 127, '2014-01-15 01:07:53.000000', 'consum', 0.0225, 'lps'),
	(488684, 127, '2014-01-15 01:07:54.000000', 'consum', 0.0225, 'lps'),
	(488685, 127, '2014-01-15 01:07:55.000000', 'consum', 0.0222, 'lps'),
	(488686, 127, '2014-01-15 01:07:56.000000', 'consum', 0.0225, 'lps'),
	(488687, 127, '2014-01-15 01:07:57.000000', 'consum', 0.0219, 'lps'),
	(488688, 127, '2014-01-15 01:07:58.000000', 'consum', 0.0224, 'lps'),
	(488689, 127, '2014-01-15 01:07:59.000000', 'consum', 0.0223, 'lps'),
	(488690, 127, '2014-01-15 01:08:00.000000', 'consum', 0.0214, 'lps'),
	(488691, 127, '2014-01-15 01:08:01.000000', 'consum', 0.0210, 'lps'),
	(488692, 127, '2014-01-15 01:08:02.000000', 'consum', 0.0216, 'lps'),
	(488693, 127, '2014-01-15 01:08:03.000000', 'consum', 0.0223, 'lps'),
	(488694, 127, '2014-01-15 01:08:04.000000', 'consum', 0.0222, 'lps'),
	(488695, 127, '2014-01-15 01:08:05.000000', 'consum', 0.0216, 'lps'),
	(488696, 127, '2014-01-15 01:08:06.000000', 'consum', 0.0220, 'lps'),
	(488697, 127, '2014-01-15 01:08:07.000000', 'consum', 0.0211, 'lps'),
	(488698, 127, '2014-01-15 01:08:08.000000', 'consum', 0.0217, 'lps'),
	(488699, 127, '2014-01-15 01:08:09.000000', 'consum', 0.0226, 'lps'),
	(488700, 127, '2014-01-15 01:08:10.000000', 'consum', 0.0217, 'lps'),
	(488701, 127, '2014-01-15 01:08:11.000000', 'consum', 0.0216, 'lps'),
	(488702, 127, '2014-01-15 01:08:12.000000', 'consum', 0.0219, 'lps'),
	(488703, 127, '2014-01-15 01:08:13.000000', 'consum', 0.0219, 'lps'),
	(488704, 127, '2014-01-15 01:08:14.000000', 'consum', 0.0212, 'lps'),
	(488705, 127, '2014-01-15 01:08:15.000000', 'consum', 0.0212, 'lps'),
	(488706, 127, '2014-01-15 01:08:16.000000', 'consum', 0.0213, 'lps'),
	(488707, 127, '2014-01-15 01:08:17.000000', 'consum', 0.0218, 'lps'),
	(488708, 127, '2014-01-15 01:08:18.000000', 'consum', 0.0210, 'lps'),
	(488709, 127, '2014-01-15 01:08:19.000000', 'consum', 0.0220, 'lps'),
	(488710, 127, '2014-01-15 01:08:20.000000', 'consum', 0.0226, 'lps'),
	(488711, 127, '2014-01-15 01:08:21.000000', 'consum', 0.0225, 'lps'),
	(488712, 127, '2014-01-15 01:08:22.000000', 'consum', 0.0221, 'lps'),
	(488713, 127, '2014-01-15 01:08:23.000000', 'consum', 0.0219, 'lps'),
	(488714, 127, '2014-01-15 01:08:24.000000', 'consum', 0.0224, 'lps'),
	(488715, 127, '2014-01-15 01:08:25.000000', 'consum', 0.0221, 'lps'),
	(488716, 127, '2014-01-15 01:08:26.000000', 'consum', 0.0224, 'lps'),
	(488717, 127, '2014-01-15 01:08:27.000000', 'consum', 0.0213, 'lps'),
	(488718, 127, '2014-01-15 01:08:28.000000', 'consum', 0.0217, 'lps'),
	(488719, 127, '2014-01-15 01:08:29.000000', 'consum', 0.0220, 'lps'),
	(488720, 127, '2014-01-15 01:08:30.000000', 'consum', 0.0222, 'lps'),
	(488721, 127, '2014-01-15 01:08:31.000000', 'consum', 0.0225, 'lps'),
	(488722, 127, '2014-01-15 01:08:32.000000', 'consum', 0.0213, 'lps'),
	(488723, 127, '2014-01-15 01:08:33.000000', 'consum', 0.0216, 'lps'),
	(488724, 127, '2014-01-15 01:08:34.000000', 'consum', 0.0214, 'lps'),
	(488725, 127, '2014-01-15 01:08:35.000000', 'consum', 0.0214, 'lps'),
	(488726, 127, '2014-01-15 01:08:36.000000', 'consum', 0.0217, 'lps'),
	(488727, 127, '2014-01-15 01:08:37.000000', 'consum', 0.0218, 'lps'),
	(488728, 127, '2014-01-15 01:08:38.000000', 'consum', 0.0212, 'lps'),
	(488729, 127, '2014-01-15 01:08:39.000000', 'consum', 0.0214, 'lps'),
	(488730, 127, '2014-01-15 01:08:40.000000', 'consum', 0.0226, 'lps'),
	(488731, 127, '2014-01-15 01:08:41.000000', 'consum', 0.0225, 'lps'),
	(488732, 127, '2014-01-15 01:08:42.000000', 'consum', 0.0221, 'lps'),
	(488733, 127, '2014-01-15 01:08:43.000000', 'consum', 0.0222, 'lps'),
	(488734, 127, '2014-01-15 01:08:44.000000', 'consum', 0.0220, 'lps'),
	(488735, 127, '2014-01-15 01:08:45.000000', 'consum', 0.0226, 'lps'),
	(488736, 127, '2014-01-15 01:08:46.000000', 'consum', 0.0224, 'lps'),
	(488737, 127, '2014-01-15 01:08:47.000000', 'consum', 0.0214, 'lps'),
	(488738, 127, '2014-01-15 01:08:48.000000', 'consum', 0.0226, 'lps'),
	(488739, 127, '2014-01-15 01:08:49.000000', 'consum', 0.0225, 'lps'),
	(488740, 127, '2014-01-15 01:08:50.000000', 'consum', 0.0219, 'lps'),
	(488741, 127, '2014-01-15 01:08:51.000000', 'consum', 0.0214, 'lps'),
	(488742, 127, '2014-01-15 01:08:52.000000', 'consum', 0.0218, 'lps'),
	(488743, 127, '2014-01-15 01:08:53.000000', 'consum', 0.0221, 'lps'),
	(488744, 127, '2014-01-15 01:08:54.000000', 'consum', 0.0210, 'lps'),
	(488745, 127, '2014-01-15 01:08:55.000000', 'consum', 0.0226, 'lps'),
	(488746, 127, '2014-01-15 01:08:56.000000', 'consum', 0.0222, 'lps'),
	(488747, 127, '2014-01-15 01:08:57.000000', 'consum', 0.0223, 'lps'),
	(488748, 127, '2014-01-15 01:08:58.000000', 'consum', 0.0224, 'lps'),
	(488749, 127, '2014-01-15 01:08:59.000000', 'consum', 0.0222, 'lps'),
	(488750, 127, '2014-01-15 01:09:00.000000', 'consum', 0.0213, 'lps'),
	(488751, 127, '2014-01-15 01:09:01.000000', 'consum', 0.0222, 'lps'),
	(488752, 127, '2014-01-15 01:09:02.000000', 'consum', 0.0213, 'lps'),
	(488753, 127, '2014-01-15 01:09:03.000000', 'consum', 0.0224, 'lps'),
	(488754, 127, '2014-01-15 01:09:04.000000', 'consum', 0.0221, 'lps'),
	(488755, 127, '2014-01-15 01:09:05.000000', 'consum', 0.0224, 'lps'),
	(488756, 127, '2014-01-15 01:09:06.000000', 'consum', 0.0211, 'lps'),
	(488757, 127, '2014-01-15 01:09:07.000000', 'consum', 0.0210, 'lps'),
	(488758, 127, '2014-01-15 01:09:08.000000', 'consum', 0.0224, 'lps'),
	(488759, 127, '2014-01-15 01:09:09.000000', 'consum', 0.0212, 'lps'),
	(488760, 127, '2014-01-15 01:09:10.000000', 'consum', 0.0213, 'lps'),
	(488761, 127, '2014-01-15 01:09:11.000000', 'consum', 0.0219, 'lps'),
	(488762, 127, '2014-01-15 01:09:12.000000', 'consum', 0.0214, 'lps'),
	(488763, 127, '2014-01-15 01:09:13.000000', 'consum', 0.0218, 'lps'),
	(488764, 127, '2014-01-15 01:09:14.000000', 'consum', 0.0223, 'lps'),
	(488765, 127, '2014-01-15 01:09:15.000000', 'consum', 0.0215, 'lps'),
	(488766, 127, '2014-01-15 01:09:16.000000', 'consum', 0.0216, 'lps'),
	(488767, 127, '2014-01-15 01:09:17.000000', 'consum', 0.0223, 'lps'),
	(488768, 127, '2014-01-15 01:09:18.000000', 'consum', 0.0224, 'lps'),
	(488769, 127, '2014-01-15 01:09:19.000000', 'consum', 0.0225, 'lps'),
	(488770, 127, '2014-01-15 01:09:20.000000', 'consum', 0.0225, 'lps'),
	(488771, 127, '2014-01-15 01:09:21.000000', 'consum', 0.0224, 'lps'),
	(488772, 127, '2014-01-15 01:09:22.000000', 'consum', 0.0219, 'lps'),
	(488773, 127, '2014-01-15 01:09:23.000000', 'consum', 0.0212, 'lps'),
	(488774, 127, '2014-01-15 01:09:24.000000', 'consum', 0.0211, 'lps'),
	(488775, 127, '2014-01-15 01:09:25.000000', 'consum', 0.0226, 'lps'),
	(488776, 127, '2014-01-15 01:09:26.000000', 'consum', 0.0220, 'lps'),
	(488777, 127, '2014-01-15 01:09:27.000000', 'consum', 0.0213, 'lps'),
	(488778, 127, '2014-01-15 01:09:28.000000', 'consum', 0.0214, 'lps'),
	(488779, 127, '2014-01-15 01:09:29.000000', 'consum', 0.0221, 'lps'),
	(488780, 127, '2014-01-15 01:09:30.000000', 'consum', 0.0219, 'lps'),
	(488781, 127, '2014-01-15 01:09:31.000000', 'consum', 0.0221, 'lps'),
	(488782, 127, '2014-01-15 01:09:32.000000', 'consum', 0.0224, 'lps'),
	(488783, 127, '2014-01-15 01:09:33.000000', 'consum', 0.0213, 'lps'),
	(488784, 127, '2014-01-15 01:09:34.000000', 'consum', 0.0216, 'lps'),
	(488785, 127, '2014-01-15 01:09:35.000000', 'consum', 0.0213, 'lps'),
	(488786, 127, '2014-01-15 01:09:36.000000', 'consum', 0.0210, 'lps'),
	(488787, 127, '2014-01-15 01:09:37.000000', 'consum', 0.0218, 'lps'),
	(488788, 127, '2014-01-15 01:09:38.000000', 'consum', 0.0218, 'lps'),
	(488789, 127, '2014-01-15 01:09:39.000000', 'consum', 0.0224, 'lps'),
	(488790, 127, '2014-01-15 01:09:40.000000', 'consum', 0.0223, 'lps'),
	(488791, 127, '2014-01-15 01:09:41.000000', 'consum', 0.0218, 'lps'),
	(488792, 127, '2014-01-15 01:09:42.000000', 'consum', 0.0226, 'lps'),
	(488793, 127, '2014-01-15 01:09:43.000000', 'consum', 0.0216, 'lps'),
	(488794, 127, '2014-01-15 01:09:44.000000', 'consum', 0.0210, 'lps'),
	(488795, 127, '2014-01-15 01:09:45.000000', 'consum', 0.0226, 'lps'),
	(488796, 127, '2014-01-15 01:09:46.000000', 'consum', 0.0223, 'lps'),
	(488797, 127, '2014-01-15 01:09:47.000000', 'consum', 0.0211, 'lps'),
	(488798, 127, '2014-01-15 01:09:48.000000', 'consum', 0.0210, 'lps'),
	(488799, 127, '2014-01-15 01:09:49.000000', 'consum', 0.0225, 'lps'),
	(488800, 127, '2014-01-15 01:09:50.000000', 'consum', 0.0218, 'lps'),
	(488801, 127, '2014-01-15 01:09:51.000000', 'consum', 0.0221, 'lps'),
	(488802, 127, '2014-01-15 01:09:52.000000', 'consum', 0.0223, 'lps'),
	(488803, 127, '2014-01-15 01:09:53.000000', 'consum', 0.0212, 'lps'),
	(488804, 127, '2014-01-15 01:09:54.000000', 'consum', 0.0214, 'lps'),
	(488805, 127, '2014-01-15 01:09:55.000000', 'consum', 0.0226, 'lps'),
	(488806, 127, '2014-01-15 01:09:56.000000', 'consum', 0.0225, 'lps'),
	(488807, 127, '2014-01-15 01:09:57.000000', 'consum', 0.0220, 'lps'),
	(488808, 127, '2014-01-15 01:09:58.000000', 'consum', 0.0215, 'lps'),
	(488809, 127, '2014-01-15 01:09:59.000000', 'consum', 0.0224, 'lps'),
	(488810, 127, '2014-01-15 01:10:00.000000', 'consum', 0.0214, 'lps'),
	(488811, 127, '2014-01-15 01:10:01.000000', 'consum', 0.0222, 'lps'),
	(488812, 127, '2014-01-15 01:10:02.000000', 'consum', 0.0226, 'lps'),
	(488813, 127, '2014-01-15 01:10:03.000000', 'consum', 0.0220, 'lps'),
	(488814, 127, '2014-01-15 01:10:04.000000', 'consum', 0.0214, 'lps'),
	(488815, 127, '2014-01-15 01:10:05.000000', 'consum', 0.0216, 'lps'),
	(488816, 127, '2014-01-15 01:10:06.000000', 'consum', 0.0212, 'lps'),
	(488817, 127, '2014-01-15 01:10:07.000000', 'consum', 0.0221, 'lps'),
	(488818, 127, '2014-01-15 01:10:08.000000', 'consum', 0.0225, 'lps'),
	(488819, 127, '2014-01-15 01:10:09.000000', 'consum', 0.0218, 'lps'),
	(488820, 127, '2014-01-15 01:10:10.000000', 'consum', 0.0221, 'lps'),
	(488821, 127, '2014-01-15 01:10:11.000000', 'consum', 0.0224, 'lps'),
	(488822, 127, '2014-01-15 01:10:12.000000', 'consum', 0.0214, 'lps'),
	(488823, 127, '2014-01-15 01:10:13.000000', 'consum', 0.0222, 'lps'),
	(488824, 127, '2014-01-15 01:10:14.000000', 'consum', 0.0224, 'lps'),
	(488825, 127, '2014-01-15 01:10:15.000000', 'consum', 0.0211, 'lps'),
	(488826, 127, '2014-01-15 01:10:16.000000', 'consum', 0.0226, 'lps'),
	(488827, 127, '2014-01-15 01:10:17.000000', 'consum', 0.0217, 'lps'),
	(488828, 127, '2014-01-15 01:10:18.000000', 'consum', 0.0216, 'lps'),
	(488829, 127, '2014-01-15 01:10:19.000000', 'consum', 0.0220, 'lps'),
	(488830, 127, '2014-01-15 01:10:20.000000', 'consum', 0.0225, 'lps'),
	(488831, 127, '2014-01-15 01:10:21.000000', 'consum', 0.0223, 'lps'),
	(488832, 127, '2014-01-15 01:10:22.000000', 'consum', 0.0213, 'lps'),
	(488833, 127, '2014-01-15 01:10:23.000000', 'consum', 0.0218, 'lps'),
	(488834, 127, '2014-01-15 01:10:24.000000', 'consum', 0.0210, 'lps'),
	(488835, 127, '2014-01-15 01:10:25.000000', 'consum', 0.0221, 'lps'),
	(488836, 127, '2014-01-15 01:10:26.000000', 'consum', 0.0214, 'lps'),
	(488837, 127, '2014-01-15 01:10:27.000000', 'consum', 0.0216, 'lps'),
	(488838, 127, '2014-01-15 01:10:28.000000', 'consum', 0.0226, 'lps'),
	(488839, 127, '2014-01-15 01:10:29.000000', 'consum', 0.0222, 'lps'),
	(488840, 127, '2014-01-15 01:10:30.000000', 'consum', 0.0221, 'lps'),
	(488841, 127, '2014-01-15 01:10:31.000000', 'consum', 0.0213, 'lps'),
	(488842, 127, '2014-01-15 01:10:32.000000', 'consum', 0.0210, 'lps'),
	(488843, 127, '2014-01-15 01:10:33.000000', 'consum', 0.0219, 'lps'),
	(488844, 127, '2014-01-15 01:10:34.000000', 'consum', 0.0222, 'lps'),
	(488845, 127, '2014-01-15 01:10:35.000000', 'consum', 0.0225, 'lps'),
	(488846, 127, '2014-01-15 01:10:36.000000', 'consum', 0.0218, 'lps'),
	(488847, 127, '2014-01-15 01:10:37.000000', 'consum', 0.0220, 'lps'),
	(488848, 127, '2014-01-15 01:10:38.000000', 'consum', 0.0221, 'lps'),
	(488849, 127, '2014-01-15 01:10:39.000000', 'consum', 0.0219, 'lps'),
	(488850, 127, '2014-01-15 01:10:40.000000', 'consum', 0.0224, 'lps'),
	(488851, 127, '2014-01-15 01:10:41.000000', 'consum', 0.0217, 'lps'),
	(488852, 127, '2014-01-15 01:10:42.000000', 'consum', 0.0221, 'lps'),
	(488853, 127, '2014-01-15 01:10:43.000000', 'consum', 0.0211, 'lps'),
	(488854, 127, '2014-01-15 01:10:44.000000', 'consum', 0.0214, 'lps'),
	(488855, 127, '2014-01-15 01:10:45.000000', 'consum', 0.0214, 'lps'),
	(488856, 127, '2014-01-15 01:10:46.000000', 'consum', 0.0217, 'lps'),
	(488857, 127, '2014-01-15 01:10:47.000000', 'consum', 0.0216, 'lps'),
	(488858, 127, '2014-01-15 01:10:48.000000', 'consum', 0.0219, 'lps'),
	(488859, 127, '2014-01-15 01:10:49.000000', 'consum', 0.0220, 'lps'),
	(488860, 127, '2014-01-15 01:10:50.000000', 'consum', 0.0218, 'lps'),
	(488861, 127, '2014-01-15 01:10:51.000000', 'consum', 0.0221, 'lps'),
	(488862, 127, '2014-01-15 01:10:52.000000', 'consum', 0.0224, 'lps'),
	(488863, 127, '2014-01-15 01:10:53.000000', 'consum', 0.0213, 'lps'),
	(488864, 127, '2014-01-15 01:10:54.000000', 'consum', 0.0219, 'lps'),
	(488865, 127, '2014-01-15 01:10:55.000000', 'consum', 0.0210, 'lps'),
	(488866, 127, '2014-01-15 01:10:56.000000', 'consum', 0.0218, 'lps'),
	(488867, 127, '2014-01-15 01:10:57.000000', 'consum', 0.0216, 'lps'),
	(488868, 127, '2014-01-15 01:10:58.000000', 'consum', 0.0217, 'lps'),
	(488869, 127, '2014-01-15 01:10:59.000000', 'consum', 0.0212, 'lps'),
	(488870, 127, '2014-01-15 01:11:00.000000', 'consum', 0.0217, 'lps'),
	(488871, 127, '2014-01-15 01:11:01.000000', 'consum', 0.0222, 'lps'),
	(488872, 127, '2014-01-15 01:11:02.000000', 'consum', 0.0217, 'lps'),
	(488873, 127, '2014-01-15 01:11:03.000000', 'consum', 0.0225, 'lps'),
	(488874, 127, '2014-01-15 01:11:04.000000', 'consum', 0.0212, 'lps'),
	(488875, 127, '2014-01-15 01:11:05.000000', 'consum', 0.0212, 'lps'),
	(488876, 127, '2014-01-15 01:11:06.000000', 'consum', 0.0216, 'lps'),
	(488877, 127, '2014-01-15 01:11:07.000000', 'consum', 0.0214, 'lps'),
	(488878, 127, '2014-01-15 01:11:08.000000', 'consum', 0.0215, 'lps'),
	(488879, 127, '2014-01-15 01:11:09.000000', 'consum', 0.0224, 'lps'),
	(488880, 127, '2014-01-15 01:11:10.000000', 'consum', 0.0212, 'lps'),
	(488881, 127, '2014-01-15 01:11:11.000000', 'consum', 0.0213, 'lps'),
	(488882, 127, '2014-01-15 01:11:12.000000', 'consum', 0.0218, 'lps'),
	(488883, 127, '2014-01-15 01:11:13.000000', 'consum', 0.0226, 'lps'),
	(488884, 127, '2014-01-15 01:11:14.000000', 'consum', 0.0213, 'lps'),
	(488885, 127, '2014-01-15 01:11:15.000000', 'consum', 0.0215, 'lps'),
	(488886, 127, '2014-01-15 01:11:16.000000', 'consum', 0.0225, 'lps'),
	(488887, 127, '2014-01-15 01:11:17.000000', 'consum', 0.0219, 'lps'),
	(488888, 127, '2014-01-15 01:11:18.000000', 'consum', 0.0211, 'lps'),
	(488889, 127, '2014-01-15 01:11:19.000000', 'consum', 0.0221, 'lps'),
	(488890, 127, '2014-01-15 01:11:20.000000', 'consum', 0.0214, 'lps'),
	(488891, 127, '2014-01-15 01:11:21.000000', 'consum', 0.0215, 'lps'),
	(488892, 127, '2014-01-15 01:11:22.000000', 'consum', 0.0221, 'lps'),
	(488893, 127, '2014-01-15 01:11:23.000000', 'consum', 0.0219, 'lps'),
	(488894, 127, '2014-01-15 01:11:24.000000', 'consum', 0.0223, 'lps'),
	(488895, 127, '2014-01-15 01:11:25.000000', 'consum', 0.0212, 'lps'),
	(488896, 127, '2014-01-15 01:11:26.000000', 'consum', 0.0216, 'lps'),
	(488897, 127, '2014-01-15 01:11:27.000000', 'consum', 0.0219, 'lps'),
	(488898, 127, '2014-01-15 01:11:28.000000', 'consum', 0.0218, 'lps'),
	(488899, 127, '2014-01-15 01:11:29.000000', 'consum', 0.0226, 'lps'),
	(488900, 127, '2014-01-15 01:11:30.000000', 'consum', 0.0214, 'lps'),
	(488901, 127, '2014-01-15 01:11:31.000000', 'consum', 0.0216, 'lps'),
	(488902, 127, '2014-01-15 01:11:32.000000', 'consum', 0.0211, 'lps'),
	(488903, 127, '2014-01-15 01:11:33.000000', 'consum', 0.0215, 'lps'),
	(488904, 127, '2014-01-15 01:11:34.000000', 'consum', 0.0214, 'lps'),
	(488905, 127, '2014-01-15 01:11:35.000000', 'consum', 0.0218, 'lps'),
	(488906, 127, '2014-01-15 01:11:36.000000', 'consum', 0.0220, 'lps'),
	(488907, 127, '2014-01-15 01:11:37.000000', 'consum', 0.0219, 'lps'),
	(488908, 127, '2014-01-15 01:11:38.000000', 'consum', 0.0210, 'lps'),
	(488909, 127, '2014-01-15 01:11:39.000000', 'consum', 0.0216, 'lps'),
	(488910, 127, '2014-01-15 01:11:40.000000', 'consum', 0.0223, 'lps'),
	(488911, 127, '2014-01-15 01:11:41.000000', 'consum', 0.0222, 'lps'),
	(488912, 127, '2014-01-15 01:11:42.000000', 'consum', 0.0218, 'lps'),
	(488913, 127, '2014-01-15 01:11:43.000000', 'consum', 0.0213, 'lps'),
	(488914, 127, '2014-01-15 01:11:44.000000', 'consum', 0.0220, 'lps'),
	(488915, 127, '2014-01-15 01:11:45.000000', 'consum', 0.0216, 'lps'),
	(488916, 127, '2014-01-15 01:11:46.000000', 'consum', 0.0211, 'lps'),
	(488917, 127, '2014-01-15 01:11:47.000000', 'consum', 0.0213, 'lps'),
	(488918, 127, '2014-01-15 01:11:48.000000', 'consum', 0.0224, 'lps'),
	(488919, 127, '2014-01-15 01:11:49.000000', 'consum', 0.0219, 'lps'),
	(488920, 127, '2014-01-15 01:11:50.000000', 'consum', 0.0215, 'lps'),
	(488921, 127, '2014-01-15 01:11:51.000000', 'consum', 0.0226, 'lps'),
	(488922, 127, '2014-01-15 01:11:52.000000', 'consum', 0.0226, 'lps'),
	(488923, 127, '2014-01-15 01:11:53.000000', 'consum', 0.0222, 'lps'),
	(488924, 127, '2014-01-15 01:11:54.000000', 'consum', 0.0225, 'lps'),
	(488925, 127, '2014-01-15 01:11:55.000000', 'consum', 0.0213, 'lps'),
	(488926, 127, '2014-01-15 01:11:56.000000', 'consum', 0.0217, 'lps'),
	(488927, 127, '2014-01-15 01:11:57.000000', 'consum', 0.0217, 'lps'),
	(488928, 127, '2014-01-15 01:11:58.000000', 'consum', 0.0226, 'lps'),
	(488929, 127, '2014-01-15 01:11:59.000000', 'consum', 0.0219, 'lps'),
	(488930, 127, '2014-01-15 01:12:00.000000', 'consum', 0.0223, 'lps'),
	(488931, 127, '2014-01-15 01:12:01.000000', 'consum', 0.0214, 'lps'),
	(488932, 127, '2014-01-15 01:12:02.000000', 'consum', 0.0224, 'lps'),
	(488933, 127, '2014-01-15 01:12:03.000000', 'consum', 0.0221, 'lps'),
	(488934, 127, '2014-01-15 01:12:04.000000', 'consum', 0.0221, 'lps'),
	(488935, 127, '2014-01-15 01:12:05.000000', 'consum', 0.0218, 'lps'),
	(488936, 127, '2014-01-15 01:12:06.000000', 'consum', 0.0218, 'lps'),
	(488937, 127, '2014-01-15 01:12:07.000000', 'consum', 0.0223, 'lps'),
	(488938, 127, '2014-01-15 01:12:08.000000', 'consum', 0.0221, 'lps'),
	(488939, 127, '2014-01-15 01:12:09.000000', 'consum', 0.0225, 'lps'),
	(488940, 127, '2014-01-15 01:12:10.000000', 'consum', 0.0217, 'lps'),
	(488941, 127, '2014-01-15 01:12:11.000000', 'consum', 0.0217, 'lps'),
	(488942, 127, '2014-01-15 01:12:12.000000', 'consum', 0.0210, 'lps'),
	(488943, 127, '2014-01-15 01:12:13.000000', 'consum', 0.0223, 'lps'),
	(488944, 127, '2014-01-15 01:12:14.000000', 'consum', 0.0224, 'lps'),
	(488945, 127, '2014-01-15 01:12:15.000000', 'consum', 0.0226, 'lps'),
	(488946, 127, '2014-01-15 01:12:16.000000', 'consum', 0.0213, 'lps'),
	(488947, 127, '2014-01-15 01:12:17.000000', 'consum', 0.0212, 'lps'),
	(488948, 127, '2014-01-15 01:12:18.000000', 'consum', 0.0210, 'lps'),
	(488949, 127, '2014-01-15 01:12:19.000000', 'consum', 0.0223, 'lps'),
	(488950, 127, '2014-01-15 01:12:20.000000', 'consum', 0.0226, 'lps'),
	(488951, 127, '2014-01-15 01:12:21.000000', 'consum', 0.0215, 'lps'),
	(488952, 127, '2014-01-15 01:12:22.000000', 'consum', 0.0223, 'lps'),
	(488953, 127, '2014-01-15 01:12:23.000000', 'consum', 0.0226, 'lps'),
	(488954, 127, '2014-01-15 01:12:24.000000', 'consum', 0.0216, 'lps'),
	(488955, 127, '2014-01-15 01:12:25.000000', 'consum', 0.0212, 'lps'),
	(488956, 127, '2014-01-15 01:12:26.000000', 'consum', 0.0219, 'lps'),
	(488957, 127, '2014-01-15 01:12:27.000000', 'consum', 0.0216, 'lps'),
	(488958, 127, '2014-01-15 01:12:28.000000', 'consum', 0.0211, 'lps'),
	(488959, 127, '2014-01-15 01:12:29.000000', 'consum', 0.0215, 'lps'),
	(488960, 127, '2014-01-15 01:12:30.000000', 'consum', 0.0215, 'lps'),
	(488961, 127, '2014-01-15 01:12:31.000000', 'consum', 0.0222, 'lps'),
	(488962, 127, '2014-01-15 01:12:32.000000', 'consum', 0.0223, 'lps'),
	(488963, 127, '2014-01-15 01:12:33.000000', 'consum', 0.0221, 'lps'),
	(488964, 127, '2014-01-15 01:12:34.000000', 'consum', 0.0225, 'lps'),
	(488965, 127, '2014-01-15 01:12:35.000000', 'consum', 0.0218, 'lps'),
	(488966, 127, '2014-01-15 01:12:36.000000', 'consum', 0.0222, 'lps'),
	(488967, 127, '2014-01-15 01:12:37.000000', 'consum', 0.0213, 'lps'),
	(488968, 127, '2014-01-15 01:12:38.000000', 'consum', 0.0224, 'lps'),
	(488969, 127, '2014-01-15 01:12:39.000000', 'consum', 0.0222, 'lps'),
	(488970, 127, '2014-01-15 01:12:40.000000', 'consum', 0.0212, 'lps'),
	(488971, 127, '2014-01-15 01:12:41.000000', 'consum', 0.0215, 'lps'),
	(488972, 127, '2014-01-15 01:12:42.000000', 'consum', 0.0216, 'lps'),
	(488973, 127, '2014-01-15 01:12:43.000000', 'consum', 0.0225, 'lps'),
	(488974, 127, '2014-01-15 01:12:44.000000', 'consum', 0.0217, 'lps'),
	(488975, 127, '2014-01-15 01:12:45.000000', 'consum', 0.0216, 'lps'),
	(488976, 127, '2014-01-15 01:12:46.000000', 'consum', 0.0221, 'lps'),
	(488977, 127, '2014-01-15 01:12:47.000000', 'consum', 0.0213, 'lps'),
	(488978, 127, '2014-01-15 01:12:48.000000', 'consum', 0.0225, 'lps'),
	(488979, 127, '2014-01-15 01:12:49.000000', 'consum', 0.0210, 'lps'),
	(488980, 127, '2014-01-15 01:12:50.000000', 'consum', 0.0218, 'lps'),
	(488981, 127, '2014-01-15 01:12:51.000000', 'consum', 0.0213, 'lps'),
	(488982, 127, '2014-01-15 01:12:52.000000', 'consum', 0.0222, 'lps'),
	(488983, 127, '2014-01-15 01:12:53.000000', 'consum', 0.0225, 'lps'),
	(488984, 127, '2014-01-15 01:12:54.000000', 'consum', 0.0214, 'lps'),
	(488985, 127, '2014-01-15 01:12:55.000000', 'consum', 0.0222, 'lps'),
	(488986, 127, '2014-01-15 01:12:56.000000', 'consum', 0.0223, 'lps'),
	(488987, 127, '2014-01-15 01:12:57.000000', 'consum', 0.0222, 'lps'),
	(488988, 127, '2014-01-15 01:12:58.000000', 'consum', 0.0215, 'lps'),
	(488989, 127, '2014-01-15 01:12:59.000000', 'consum', 0.0215, 'lps'),
	(488990, 127, '2014-01-15 01:13:00.000000', 'consum', 0.0220, 'lps'),
	(488991, 127, '2014-01-15 01:13:01.000000', 'consum', 0.0213, 'lps'),
	(488992, 127, '2014-01-15 01:13:02.000000', 'consum', 0.0213, 'lps'),
	(488993, 127, '2014-01-15 01:13:03.000000', 'consum', 0.0215, 'lps'),
	(488994, 127, '2014-01-15 01:13:04.000000', 'consum', 0.0210, 'lps'),
	(488995, 127, '2014-01-15 01:13:05.000000', 'consum', 0.0214, 'lps'),
	(488996, 127, '2014-01-15 01:13:06.000000', 'consum', 0.0211, 'lps'),
	(488997, 127, '2014-01-15 01:13:07.000000', 'consum', 0.0221, 'lps'),
	(488998, 127, '2014-01-15 01:13:08.000000', 'consum', 0.0213, 'lps'),
	(488999, 127, '2014-01-15 01:13:09.000000', 'consum', 0.0226, 'lps'),
	(489000, 127, '2014-01-15 01:13:10.000000', 'consum', 0.0212, 'lps'),
	(489001, 127, '2014-01-15 01:13:11.000000', 'consum', 0.0226, 'lps'),
	(489002, 127, '2014-01-15 01:13:12.000000', 'consum', 0.0217, 'lps'),
	(489003, 127, '2014-01-15 01:13:13.000000', 'consum', 0.0213, 'lps'),
	(489004, 127, '2014-01-15 01:13:14.000000', 'consum', 0.0222, 'lps'),
	(489005, 127, '2014-01-15 01:13:15.000000', 'consum', 0.0225, 'lps'),
	(489006, 127, '2014-01-15 01:13:16.000000', 'consum', 0.0219, 'lps'),
	(489007, 127, '2014-01-15 01:13:17.000000', 'consum', 0.0226, 'lps'),
	(489008, 127, '2014-01-15 01:13:18.000000', 'consum', 0.0212, 'lps'),
	(489009, 127, '2014-01-15 01:13:19.000000', 'consum', 0.0222, 'lps'),
	(489010, 127, '2014-01-15 01:13:20.000000', 'consum', 0.0216, 'lps'),
	(489011, 127, '2014-01-15 01:13:21.000000', 'consum', 0.0221, 'lps'),
	(489012, 127, '2014-01-15 01:13:22.000000', 'consum', 0.0212, 'lps'),
	(489013, 127, '2014-01-15 01:13:23.000000', 'consum', 0.0223, 'lps'),
	(489014, 127, '2014-01-15 01:13:24.000000', 'consum', 0.0217, 'lps'),
	(489015, 127, '2014-01-15 01:13:25.000000', 'consum', 0.0223, 'lps'),
	(489016, 127, '2014-01-15 01:13:26.000000', 'consum', 0.0222, 'lps'),
	(489017, 127, '2014-01-15 01:13:27.000000', 'consum', 0.0213, 'lps'),
	(489018, 127, '2014-01-15 01:13:28.000000', 'consum', 0.0223, 'lps'),
	(489019, 127, '2014-01-15 01:13:29.000000', 'consum', 0.0219, 'lps'),
	(489020, 127, '2014-01-15 01:13:30.000000', 'consum', 0.0213, 'lps'),
	(489021, 127, '2014-01-15 01:13:31.000000', 'consum', 0.0215, 'lps'),
	(489022, 127, '2014-01-15 01:13:32.000000', 'consum', 0.0226, 'lps'),
	(489023, 127, '2014-01-15 01:13:33.000000', 'consum', 0.0210, 'lps'),
	(489024, 127, '2014-01-15 01:13:34.000000', 'consum', 0.0213, 'lps'),
	(489025, 127, '2014-01-15 01:13:35.000000', 'consum', 0.0224, 'lps'),
	(489026, 127, '2014-01-15 01:13:36.000000', 'consum', 0.0220, 'lps'),
	(489027, 127, '2014-01-15 01:13:37.000000', 'consum', 0.0220, 'lps'),
	(489028, 127, '2014-01-15 01:13:38.000000', 'consum', 0.0213, 'lps'),
	(489029, 127, '2014-01-15 01:13:39.000000', 'consum', 0.0212, 'lps'),
	(489030, 127, '2014-01-15 01:13:40.000000', 'consum', 0.0213, 'lps'),
	(489031, 127, '2014-01-15 01:13:41.000000', 'consum', 0.0217, 'lps'),
	(489032, 127, '2014-01-15 01:13:42.000000', 'consum', 0.0222, 'lps'),
	(489033, 127, '2014-01-15 01:13:43.000000', 'consum', 0.0214, 'lps'),
	(489034, 127, '2014-01-15 01:13:44.000000', 'consum', 0.0211, 'lps'),
	(489035, 127, '2014-01-15 01:13:45.000000', 'consum', 0.0220, 'lps'),
	(489036, 127, '2014-01-15 01:13:46.000000', 'consum', 0.0223, 'lps'),
	(489037, 127, '2014-01-15 01:13:47.000000', 'consum', 0.0214, 'lps'),
	(489038, 127, '2014-01-15 01:13:48.000000', 'consum', 0.0225, 'lps'),
	(489039, 127, '2014-01-15 01:13:49.000000', 'consum', 0.0220, 'lps'),
	(489040, 127, '2014-01-15 01:13:50.000000', 'consum', 0.0217, 'lps'),
	(489041, 127, '2014-01-15 01:13:51.000000', 'consum', 0.0215, 'lps'),
	(489042, 127, '2014-01-15 01:13:52.000000', 'consum', 0.0216, 'lps'),
	(489043, 127, '2014-01-15 01:13:53.000000', 'consum', 0.0210, 'lps'),
	(489044, 127, '2014-01-15 01:13:54.000000', 'consum', 0.0223, 'lps'),
	(489045, 127, '2014-01-15 01:13:55.000000', 'consum', 0.0226, 'lps'),
	(489046, 127, '2014-01-15 01:13:56.000000', 'consum', 0.0217, 'lps'),
	(489047, 127, '2014-01-15 01:13:57.000000', 'consum', 0.0214, 'lps'),
	(489048, 127, '2014-01-15 01:13:58.000000', 'consum', 0.0212, 'lps'),
	(489049, 127, '2014-01-15 01:13:59.000000', 'consum', 0.0222, 'lps'),
	(489050, 127, '2014-01-15 01:14:00.000000', 'consum', 0.0216, 'lps'),
	(489051, 127, '2014-01-15 01:14:01.000000', 'consum', 0.0222, 'lps'),
	(489052, 127, '2014-01-15 01:14:02.000000', 'consum', 0.0219, 'lps'),
	(489053, 127, '2014-01-15 01:14:03.000000', 'consum', 0.0217, 'lps'),
	(489054, 127, '2014-01-15 01:14:04.000000', 'consum', 0.0219, 'lps'),
	(489055, 127, '2014-01-15 01:14:05.000000', 'consum', 0.0220, 'lps'),
	(489056, 127, '2014-01-15 01:14:06.000000', 'consum', 0.0213, 'lps'),
	(489057, 127, '2014-01-15 01:14:07.000000', 'consum', 0.0215, 'lps'),
	(489058, 127, '2014-01-15 01:14:08.000000', 'consum', 0.0226, 'lps'),
	(489059, 127, '2014-01-15 01:14:09.000000', 'consum', 0.0225, 'lps'),
	(489060, 127, '2014-01-15 01:14:10.000000', 'consum', 0.0220, 'lps'),
	(489061, 127, '2014-01-15 01:14:11.000000', 'consum', 0.0214, 'lps'),
	(489062, 127, '2014-01-15 01:14:12.000000', 'consum', 0.0217, 'lps'),
	(489063, 127, '2014-01-15 01:14:13.000000', 'consum', 0.0219, 'lps'),
	(489064, 127, '2014-01-15 01:14:14.000000', 'consum', 0.0216, 'lps'),
	(489065, 127, '2014-01-15 01:14:15.000000', 'consum', 0.0215, 'lps'),
	(489066, 127, '2014-01-15 01:14:16.000000', 'consum', 0.0215, 'lps'),
	(489067, 127, '2014-01-15 01:14:17.000000', 'consum', 0.0223, 'lps'),
	(489068, 127, '2014-01-15 01:14:18.000000', 'consum', 0.0210, 'lps'),
	(489069, 127, '2014-01-15 01:14:19.000000', 'consum', 0.0223, 'lps'),
	(489070, 127, '2014-01-15 01:14:20.000000', 'consum', 0.0223, 'lps'),
	(489071, 127, '2014-01-15 01:14:21.000000', 'consum', 0.0220, 'lps'),
	(489072, 127, '2014-01-15 01:14:22.000000', 'consum', 0.0220, 'lps'),
	(489073, 127, '2014-01-15 01:14:23.000000', 'consum', 0.0215, 'lps'),
	(489074, 127, '2014-01-15 01:14:24.000000', 'consum', 0.0222, 'lps'),
	(489075, 127, '2014-01-15 01:14:25.000000', 'consum', 0.0220, 'lps'),
	(489076, 127, '2014-01-15 01:14:26.000000', 'consum', 0.0225, 'lps'),
	(489077, 127, '2014-01-15 01:14:27.000000', 'consum', 0.0221, 'lps'),
	(489078, 127, '2014-01-15 01:14:28.000000', 'consum', 0.0220, 'lps'),
	(489079, 127, '2014-01-15 01:14:29.000000', 'consum', 0.0212, 'lps'),
	(489080, 127, '2014-01-15 01:14:30.000000', 'consum', 0.0225, 'lps'),
	(489081, 127, '2014-01-15 01:14:31.000000', 'consum', 0.0210, 'lps'),
	(489082, 127, '2014-01-15 01:14:32.000000', 'consum', 0.0215, 'lps'),
	(489083, 127, '2014-01-15 01:14:33.000000', 'consum', 0.0220, 'lps'),
	(489084, 127, '2014-01-15 01:14:34.000000', 'consum', 0.0213, 'lps'),
	(489085, 127, '2014-01-15 01:14:35.000000', 'consum', 0.0211, 'lps'),
	(489086, 127, '2014-01-15 01:14:36.000000', 'consum', 0.0224, 'lps'),
	(489087, 127, '2014-01-15 01:14:37.000000', 'consum', 0.0211, 'lps'),
	(489088, 127, '2014-01-15 01:14:38.000000', 'consum', 0.0224, 'lps'),
	(489089, 127, '2014-01-15 01:14:39.000000', 'consum', 0.0211, 'lps'),
	(489090, 127, '2014-01-15 01:14:40.000000', 'consum', 0.0222, 'lps'),
	(489091, 127, '2014-01-15 01:14:41.000000', 'consum', 0.0219, 'lps'),
	(489092, 127, '2014-01-15 01:14:42.000000', 'consum', 0.0220, 'lps'),
	(489093, 127, '2014-01-15 01:14:43.000000', 'consum', 0.0215, 'lps'),
	(489094, 127, '2014-01-15 01:14:44.000000', 'consum', 0.0224, 'lps'),
	(489095, 127, '2014-01-15 01:14:45.000000', 'consum', 0.0214, 'lps'),
	(489096, 127, '2014-01-15 01:14:46.000000', 'consum', 0.0223, 'lps'),
	(489097, 127, '2014-01-15 01:14:47.000000', 'consum', 0.0212, 'lps'),
	(489098, 127, '2014-01-15 01:14:48.000000', 'consum', 0.0215, 'lps'),
	(489099, 127, '2014-01-15 01:14:49.000000', 'consum', 0.0212, 'lps'),
	(489100, 127, '2014-01-15 01:14:50.000000', 'consum', 0.0225, 'lps'),
	(489101, 127, '2014-01-15 01:14:51.000000', 'consum', 0.0226, 'lps'),
	(489102, 127, '2014-01-15 01:14:52.000000', 'consum', 0.0212, 'lps'),
	(489103, 127, '2014-01-15 01:14:53.000000', 'consum', 0.0222, 'lps'),
	(489104, 127, '2014-01-15 01:14:54.000000', 'consum', 0.0215, 'lps'),
	(489105, 127, '2014-01-15 01:14:55.000000', 'consum', 0.0215, 'lps'),
	(489106, 127, '2014-01-15 01:14:56.000000', 'consum', 0.0222, 'lps'),
	(489107, 127, '2014-01-15 01:14:57.000000', 'consum', 0.0222, 'lps'),
	(489108, 127, '2014-01-15 01:14:58.000000', 'consum', 0.0215, 'lps'),
	(489109, 127, '2014-01-15 01:14:59.000000', 'consum', 0.0219, 'lps'),
	(489110, 127, '2014-01-15 01:15:00.000000', 'consum', 0.0224, 'lps'),
	(489111, 127, '2014-01-15 01:15:01.000000', 'consum', 0.0218, 'lps'),
	(489112, 127, '2014-01-15 01:15:02.000000', 'consum', 0.0224, 'lps'),
	(489113, 127, '2014-01-15 01:15:03.000000', 'consum', 0.0224, 'lps'),
	(489114, 127, '2014-01-15 01:15:04.000000', 'consum', 0.0222, 'lps'),
	(489115, 127, '2014-01-15 01:15:05.000000', 'consum', 0.0210, 'lps'),
	(489116, 127, '2014-01-15 01:15:06.000000', 'consum', 0.0211, 'lps'),
	(489117, 127, '2014-01-15 01:15:07.000000', 'consum', 0.0213, 'lps'),
	(489118, 127, '2014-01-15 01:15:08.000000', 'consum', 0.0223, 'lps'),
	(489119, 127, '2014-01-15 01:15:09.000000', 'consum', 0.0214, 'lps'),
	(489120, 127, '2014-01-15 01:15:10.000000', 'consum', 0.0212, 'lps'),
	(489121, 127, '2014-01-15 01:15:11.000000', 'consum', 0.0222, 'lps'),
	(489122, 127, '2014-01-15 01:15:12.000000', 'consum', 0.0217, 'lps'),
	(489123, 127, '2014-01-15 01:15:13.000000', 'consum', 0.0225, 'lps'),
	(489124, 127, '2014-01-15 01:15:14.000000', 'consum', 0.0213, 'lps'),
	(489125, 127, '2014-01-15 01:15:15.000000', 'consum', 0.0215, 'lps'),
	(489126, 127, '2014-01-15 01:15:16.000000', 'consum', 0.0225, 'lps'),
	(489127, 127, '2014-01-15 01:15:17.000000', 'consum', 0.0220, 'lps'),
	(489128, 127, '2014-01-15 01:15:18.000000', 'consum', 0.0215, 'lps'),
	(489129, 127, '2014-01-15 01:15:19.000000', 'consum', 0.0222, 'lps'),
	(489130, 127, '2014-01-15 01:15:20.000000', 'consum', 0.0222, 'lps'),
	(489131, 127, '2014-01-15 01:15:21.000000', 'consum', 0.0218, 'lps'),
	(489132, 127, '2014-01-15 01:15:22.000000', 'consum', 0.0215, 'lps'),
	(489133, 127, '2014-01-15 01:15:23.000000', 'consum', 0.0211, 'lps'),
	(489134, 127, '2014-01-15 01:15:24.000000', 'consum', 0.0217, 'lps'),
	(489135, 127, '2014-01-15 01:15:25.000000', 'consum', 0.0225, 'lps'),
	(489136, 127, '2014-01-15 01:15:26.000000', 'consum', 0.0215, 'lps'),
	(489137, 127, '2014-01-15 01:15:27.000000', 'consum', 0.0223, 'lps'),
	(489138, 127, '2014-01-15 01:15:28.000000', 'consum', 0.0225, 'lps'),
	(489139, 127, '2014-01-15 01:15:29.000000', 'consum', 0.0214, 'lps'),
	(489140, 127, '2014-01-15 01:15:30.000000', 'consum', 0.0221, 'lps'),
	(489141, 127, '2014-01-15 01:15:31.000000', 'consum', 0.0219, 'lps'),
	(489142, 127, '2014-01-15 01:15:32.000000', 'consum', 0.0220, 'lps'),
	(489143, 127, '2014-01-15 01:15:33.000000', 'consum', 0.0220, 'lps'),
	(489144, 127, '2014-01-15 01:15:34.000000', 'consum', 0.0210, 'lps'),
	(489145, 127, '2014-01-15 01:15:35.000000', 'consum', 0.0217, 'lps'),
	(489146, 127, '2014-01-15 01:15:36.000000', 'consum', 0.0211, 'lps'),
	(489147, 127, '2014-01-15 01:15:37.000000', 'consum', 0.0213, 'lps'),
	(489148, 127, '2014-01-15 01:15:38.000000', 'consum', 0.0220, 'lps'),
	(489149, 127, '2014-01-15 01:15:39.000000', 'consum', 0.0219, 'lps'),
	(489150, 127, '2014-01-15 01:15:40.000000', 'consum', 0.0225, 'lps'),
	(489151, 127, '2014-01-15 01:15:41.000000', 'consum', 0.0226, 'lps'),
	(489152, 127, '2014-01-15 01:15:42.000000', 'consum', 0.0210, 'lps'),
	(489153, 127, '2014-01-15 01:15:43.000000', 'consum', 0.0215, 'lps'),
	(489154, 127, '2014-01-15 01:15:44.000000', 'consum', 0.0219, 'lps'),
	(489155, 127, '2014-01-15 01:15:45.000000', 'consum', 0.0222, 'lps'),
	(489156, 127, '2014-01-15 01:15:46.000000', 'consum', 0.0210, 'lps'),
	(489157, 127, '2014-01-15 01:15:47.000000', 'consum', 0.0224, 'lps'),
	(489158, 127, '2014-01-15 01:15:48.000000', 'consum', 0.0212, 'lps'),
	(489159, 127, '2014-01-15 01:15:49.000000', 'consum', 0.0213, 'lps'),
	(489160, 127, '2014-01-15 01:15:50.000000', 'consum', 0.0220, 'lps'),
	(489161, 127, '2014-01-15 01:15:51.000000', 'consum', 0.0219, 'lps'),
	(489162, 127, '2014-01-15 01:15:52.000000', 'consum', 0.0223, 'lps'),
	(489163, 127, '2014-01-15 01:15:53.000000', 'consum', 0.0217, 'lps'),
	(489164, 127, '2014-01-15 01:15:54.000000', 'consum', 0.0223, 'lps'),
	(489165, 127, '2014-01-15 01:15:55.000000', 'consum', 0.0218, 'lps'),
	(489166, 127, '2014-01-15 01:15:56.000000', 'consum', 0.0213, 'lps'),
	(489167, 127, '2014-01-15 01:15:57.000000', 'consum', 0.0220, 'lps'),
	(489168, 127, '2014-01-15 01:15:58.000000', 'consum', 0.0214, 'lps'),
	(489169, 127, '2014-01-15 01:15:59.000000', 'consum', 0.0221, 'lps'),
	(489170, 127, '2014-01-15 01:16:00.000000', 'consum', 0.0216, 'lps'),
	(489171, 127, '2014-01-15 01:16:01.000000', 'consum', 0.0210, 'lps'),
	(489172, 127, '2014-01-15 01:16:02.000000', 'consum', 0.0225, 'lps'),
	(489173, 127, '2014-01-15 01:16:03.000000', 'consum', 0.0218, 'lps'),
	(489174, 127, '2014-01-15 01:16:04.000000', 'consum', 0.0224, 'lps'),
	(489175, 127, '2014-01-15 01:16:05.000000', 'consum', 0.0221, 'lps'),
	(489176, 127, '2014-01-15 01:16:06.000000', 'consum', 0.0222, 'lps'),
	(489177, 127, '2014-01-15 01:16:07.000000', 'consum', 0.0224, 'lps'),
	(489178, 127, '2014-01-15 01:16:08.000000', 'consum', 0.0224, 'lps'),
	(489179, 127, '2014-01-15 01:16:09.000000', 'consum', 0.0224, 'lps'),
	(489180, 127, '2014-01-15 01:16:10.000000', 'consum', 0.0221, 'lps'),
	(489181, 127, '2014-01-15 01:16:11.000000', 'consum', 0.0223, 'lps'),
	(489182, 127, '2014-01-15 01:16:12.000000', 'consum', 0.0210, 'lps'),
	(489183, 127, '2014-01-15 01:16:13.000000', 'consum', 0.0221, 'lps'),
	(489184, 127, '2014-01-15 01:16:14.000000', 'consum', 0.0215, 'lps'),
	(489185, 127, '2014-01-15 01:16:15.000000', 'consum', 0.0221, 'lps'),
	(489186, 127, '2014-01-15 01:16:16.000000', 'consum', 0.0214, 'lps'),
	(489187, 127, '2014-01-15 01:16:17.000000', 'consum', 0.0216, 'lps'),
	(489188, 127, '2014-01-15 01:16:18.000000', 'consum', 0.0212, 'lps'),
	(489189, 127, '2014-01-15 01:16:19.000000', 'consum', 0.0217, 'lps'),
	(489190, 127, '2014-01-15 01:16:20.000000', 'consum', 0.0225, 'lps'),
	(489191, 127, '2014-01-15 01:16:21.000000', 'consum', 0.0211, 'lps'),
	(489192, 127, '2014-01-15 01:16:22.000000', 'consum', 0.0222, 'lps'),
	(489193, 127, '2014-01-15 01:16:23.000000', 'consum', 0.0216, 'lps'),
	(489194, 127, '2014-01-15 01:16:24.000000', 'consum', 0.0222, 'lps'),
	(489195, 127, '2014-01-15 01:16:25.000000', 'consum', 0.0218, 'lps'),
	(489196, 127, '2014-01-15 01:16:26.000000', 'consum', 0.0214, 'lps'),
	(489197, 127, '2014-01-15 01:16:27.000000', 'consum', 0.0226, 'lps'),
	(489198, 127, '2014-01-15 01:16:28.000000', 'consum', 0.0226, 'lps'),
	(489199, 127, '2014-01-15 01:16:29.000000', 'consum', 0.0224, 'lps'),
	(489200, 127, '2014-01-15 01:16:30.000000', 'consum', 0.0216, 'lps'),
	(489201, 127, '2014-01-15 01:16:31.000000', 'consum', 0.0216, 'lps'),
	(489202, 127, '2014-01-15 01:16:32.000000', 'consum', 0.0224, 'lps'),
	(489203, 127, '2014-01-15 01:16:33.000000', 'consum', 0.0210, 'lps'),
	(489204, 127, '2014-01-15 01:16:34.000000', 'consum', 0.0220, 'lps'),
	(489205, 127, '2014-01-15 01:16:35.000000', 'consum', 0.0225, 'lps'),
	(489206, 127, '2014-01-15 01:16:36.000000', 'consum', 0.0224, 'lps'),
	(489207, 127, '2014-01-15 01:16:37.000000', 'consum', 0.0219, 'lps'),
	(489208, 127, '2014-01-15 01:16:38.000000', 'consum', 0.0213, 'lps'),
	(489209, 127, '2014-01-15 01:16:39.000000', 'consum', 0.0214, 'lps'),
	(489210, 127, '2014-01-15 01:16:40.000000', 'consum', 0.0221, 'lps'),
	(489211, 127, '2014-01-15 01:16:41.000000', 'consum', 0.0220, 'lps'),
	(489212, 127, '2014-01-15 01:16:42.000000', 'consum', 0.0210, 'lps'),
	(489213, 127, '2014-01-15 01:16:43.000000', 'consum', 0.0215, 'lps'),
	(489214, 127, '2014-01-15 01:16:44.000000', 'consum', 0.0217, 'lps'),
	(489215, 127, '2014-01-15 01:16:45.000000', 'consum', 0.0213, 'lps'),
	(489216, 127, '2014-01-15 01:16:46.000000', 'consum', 0.0224, 'lps'),
	(489217, 127, '2014-01-15 01:16:47.000000', 'consum', 0.0220, 'lps'),
	(489218, 127, '2014-01-15 01:16:48.000000', 'consum', 0.0217, 'lps'),
	(489219, 127, '2014-01-15 01:16:49.000000', 'consum', 0.0216, 'lps'),
	(489220, 127, '2014-01-15 01:16:50.000000', 'consum', 0.0218, 'lps'),
	(489221, 127, '2014-01-15 01:16:51.000000', 'consum', 0.0216, 'lps'),
	(489222, 127, '2014-01-15 01:16:52.000000', 'consum', 0.0217, 'lps'),
	(489223, 127, '2014-01-15 01:16:53.000000', 'consum', 0.0210, 'lps'),
	(489224, 127, '2014-01-15 01:16:54.000000', 'consum', 0.0225, 'lps'),
	(489225, 127, '2014-01-15 01:16:55.000000', 'consum', 0.0218, 'lps'),
	(489226, 127, '2014-01-15 01:16:56.000000', 'consum', 0.0224, 'lps'),
	(489227, 127, '2014-01-15 01:16:57.000000', 'consum', 0.0219, 'lps'),
	(489228, 127, '2014-01-15 01:16:58.000000', 'consum', 0.0214, 'lps'),
	(489229, 127, '2014-01-15 01:16:59.000000', 'consum', 0.0222, 'lps'),
	(489230, 127, '2014-01-15 01:17:00.000000', 'consum', 0.0222, 'lps'),
	(489231, 127, '2014-01-15 01:17:01.000000', 'consum', 0.0220, 'lps'),
	(489232, 127, '2014-01-15 01:17:02.000000', 'consum', 0.0224, 'lps'),
	(489233, 127, '2014-01-15 01:17:03.000000', 'consum', 0.0218, 'lps'),
	(489234, 127, '2014-01-15 01:17:04.000000', 'consum', 0.0225, 'lps'),
	(489235, 127, '2014-01-15 01:17:05.000000', 'consum', 0.0210, 'lps'),
	(489236, 127, '2014-01-15 01:17:06.000000', 'consum', 0.0215, 'lps'),
	(489237, 127, '2014-01-15 01:17:07.000000', 'consum', 0.0221, 'lps'),
	(489238, 127, '2014-01-15 01:17:08.000000', 'consum', 0.0216, 'lps'),
	(489239, 127, '2014-01-15 01:17:09.000000', 'consum', 0.0223, 'lps'),
	(489240, 127, '2014-01-15 01:17:10.000000', 'consum', 0.0224, 'lps'),
	(489241, 127, '2014-01-15 01:17:11.000000', 'consum', 0.0224, 'lps'),
	(489242, 127, '2014-01-15 01:17:12.000000', 'consum', 0.0220, 'lps'),
	(489243, 127, '2014-01-15 01:17:13.000000', 'consum', 0.0220, 'lps'),
	(489244, 127, '2014-01-15 01:17:14.000000', 'consum', 0.0211, 'lps'),
	(489245, 127, '2014-01-15 01:17:15.000000', 'consum', 0.0223, 'lps'),
	(489246, 127, '2014-01-15 01:17:16.000000', 'consum', 0.0219, 'lps'),
	(489247, 127, '2014-01-15 01:17:17.000000', 'consum', 0.0218, 'lps'),
	(489248, 127, '2014-01-15 01:17:18.000000', 'consum', 0.0225, 'lps'),
	(489249, 127, '2014-01-15 01:17:19.000000', 'consum', 0.0224, 'lps'),
	(489250, 127, '2014-01-15 01:17:20.000000', 'consum', 0.0221, 'lps'),
	(489251, 127, '2014-01-15 01:17:21.000000', 'consum', 0.0222, 'lps'),
	(489252, 127, '2014-01-15 01:17:22.000000', 'consum', 0.0223, 'lps'),
	(489253, 127, '2014-01-15 01:17:23.000000', 'consum', 0.0221, 'lps'),
	(489254, 127, '2014-01-15 01:17:24.000000', 'consum', 0.0211, 'lps'),
	(489255, 127, '2014-01-15 01:17:25.000000', 'consum', 0.0216, 'lps'),
	(489256, 127, '2014-01-15 01:17:26.000000', 'consum', 0.0222, 'lps'),
	(489257, 127, '2014-01-15 01:17:27.000000', 'consum', 0.0217, 'lps'),
	(489258, 127, '2014-01-15 01:17:28.000000', 'consum', 0.0226, 'lps'),
	(489259, 127, '2014-01-15 01:17:29.000000', 'consum', 0.0220, 'lps'),
	(489260, 127, '2014-01-15 01:17:30.000000', 'consum', 0.0214, 'lps'),
	(489261, 127, '2014-01-15 01:17:31.000000', 'consum', 0.0215, 'lps'),
	(489262, 127, '2014-01-15 01:17:32.000000', 'consum', 0.0224, 'lps'),
	(489263, 127, '2014-01-15 01:17:33.000000', 'consum', 0.0213, 'lps'),
	(489264, 127, '2014-01-15 01:17:34.000000', 'consum', 0.0219, 'lps'),
	(489265, 127, '2014-01-15 01:17:35.000000', 'consum', 0.0214, 'lps'),
	(489266, 127, '2014-01-15 01:17:36.000000', 'consum', 0.0220, 'lps'),
	(489267, 127, '2014-01-15 01:17:37.000000', 'consum', 0.0212, 'lps'),
	(489268, 127, '2014-01-15 01:17:38.000000', 'consum', 0.0211, 'lps'),
	(489269, 127, '2014-01-15 01:17:39.000000', 'consum', 0.0223, 'lps'),
	(489270, 127, '2014-01-15 01:17:40.000000', 'consum', 0.0222, 'lps'),
	(489271, 127, '2014-01-15 01:17:41.000000', 'consum', 0.0217, 'lps'),
	(489272, 127, '2014-01-15 01:17:42.000000', 'consum', 0.0226, 'lps'),
	(489273, 127, '2014-01-15 01:17:43.000000', 'consum', 0.0219, 'lps'),
	(489274, 127, '2014-01-15 01:17:44.000000', 'consum', 0.0226, 'lps'),
	(489275, 127, '2014-01-15 01:17:45.000000', 'consum', 0.0210, 'lps'),
	(489276, 127, '2014-01-15 01:17:46.000000', 'consum', 0.0214, 'lps'),
	(489277, 127, '2014-01-15 01:17:47.000000', 'consum', 0.0214, 'lps'),
	(489278, 127, '2014-01-15 01:17:48.000000', 'consum', 0.0219, 'lps'),
	(489279, 127, '2014-01-15 01:17:49.000000', 'consum', 0.0210, 'lps'),
	(489280, 127, '2014-01-15 01:17:50.000000', 'consum', 0.0219, 'lps'),
	(489281, 127, '2014-01-15 01:17:51.000000', 'consum', 0.0218, 'lps'),
	(489282, 127, '2014-01-15 01:17:52.000000', 'consum', 0.0226, 'lps'),
	(489283, 127, '2014-01-15 01:17:53.000000', 'consum', 0.0216, 'lps'),
	(489284, 127, '2014-01-15 01:17:54.000000', 'consum', 0.0225, 'lps'),
	(489285, 127, '2014-01-15 01:17:55.000000', 'consum', 0.0217, 'lps'),
	(489286, 127, '2014-01-15 01:17:56.000000', 'consum', 0.0220, 'lps'),
	(489287, 127, '2014-01-15 01:17:57.000000', 'consum', 0.0219, 'lps'),
	(489288, 127, '2014-01-15 01:17:58.000000', 'consum', 0.0226, 'lps'),
	(489289, 127, '2014-01-15 01:17:59.000000', 'consum', 0.0213, 'lps'),
	(489290, 127, '2014-01-15 01:18:00.000000', 'consum', 0.0213, 'lps'),
	(489291, 127, '2014-01-15 01:18:01.000000', 'consum', 0.0214, 'lps'),
	(489292, 127, '2014-01-15 01:18:02.000000', 'consum', 0.0223, 'lps'),
	(489293, 127, '2014-01-15 01:18:03.000000', 'consum', 0.0210, 'lps'),
	(489294, 127, '2014-01-15 01:18:04.000000', 'consum', 0.0224, 'lps'),
	(489295, 127, '2014-01-15 01:18:05.000000', 'consum', 0.0213, 'lps'),
	(489296, 127, '2014-01-15 01:18:06.000000', 'consum', 0.0218, 'lps'),
	(489297, 127, '2014-01-15 01:18:07.000000', 'consum', 0.0224, 'lps'),
	(489298, 127, '2014-01-15 01:18:08.000000', 'consum', 0.0223, 'lps'),
	(489299, 127, '2014-01-15 01:18:09.000000', 'consum', 0.0214, 'lps'),
	(489300, 127, '2014-01-15 01:18:10.000000', 'consum', 0.0211, 'lps'),
	(489301, 127, '2014-01-15 01:18:11.000000', 'consum', 0.0218, 'lps'),
	(489302, 127, '2014-01-15 01:18:12.000000', 'consum', 0.0216, 'lps'),
	(489303, 127, '2014-01-15 01:18:13.000000', 'consum', 0.0218, 'lps'),
	(489304, 127, '2014-01-15 01:18:14.000000', 'consum', 0.0212, 'lps'),
	(489305, 127, '2014-01-15 01:18:15.000000', 'consum', 0.0214, 'lps'),
	(489306, 127, '2014-01-15 01:18:16.000000', 'consum', 0.0225, 'lps'),
	(489307, 127, '2014-01-15 01:18:17.000000', 'consum', 0.0222, 'lps'),
	(489308, 127, '2014-01-15 01:18:18.000000', 'consum', 0.0225, 'lps'),
	(489309, 127, '2014-01-15 01:18:19.000000', 'consum', 0.0216, 'lps'),
	(489310, 127, '2014-01-15 01:18:20.000000', 'consum', 0.0213, 'lps'),
	(489311, 127, '2014-01-15 01:18:21.000000', 'consum', 0.0225, 'lps'),
	(489312, 127, '2014-01-15 01:18:22.000000', 'consum', 0.0226, 'lps'),
	(489313, 127, '2014-01-15 01:18:23.000000', 'consum', 0.0212, 'lps'),
	(489314, 127, '2014-01-15 01:18:24.000000', 'consum', 0.0221, 'lps'),
	(489315, 127, '2014-01-15 01:18:25.000000', 'consum', 0.0225, 'lps'),
	(489316, 127, '2014-01-15 01:18:26.000000', 'consum', 0.0221, 'lps'),
	(489317, 127, '2014-01-15 01:18:27.000000', 'consum', 0.0220, 'lps'),
	(489318, 127, '2014-01-15 01:18:28.000000', 'consum', 0.0226, 'lps'),
	(489319, 127, '2014-01-15 01:18:29.000000', 'consum', 0.0211, 'lps'),
	(489320, 127, '2014-01-15 01:18:30.000000', 'consum', 0.0216, 'lps'),
	(489321, 127, '2014-01-15 01:18:31.000000', 'consum', 0.0223, 'lps'),
	(489322, 127, '2014-01-15 01:18:32.000000', 'consum', 0.0222, 'lps'),
	(489323, 127, '2014-01-15 01:18:33.000000', 'consum', 0.0217, 'lps'),
	(489324, 127, '2014-01-15 01:18:34.000000', 'consum', 0.0223, 'lps'),
	(489325, 127, '2014-01-15 01:18:35.000000', 'consum', 0.0224, 'lps'),
	(489326, 127, '2014-01-15 01:18:36.000000', 'consum', 0.0222, 'lps'),
	(489327, 127, '2014-01-15 01:18:37.000000', 'consum', 0.0214, 'lps'),
	(489328, 127, '2014-01-15 01:18:38.000000', 'consum', 0.0212, 'lps'),
	(489329, 127, '2014-01-15 01:18:39.000000', 'consum', 0.0224, 'lps'),
	(489330, 127, '2014-01-15 01:18:40.000000', 'consum', 0.0226, 'lps'),
	(489331, 127, '2014-01-15 01:18:41.000000', 'consum', 0.0212, 'lps'),
	(489332, 127, '2014-01-15 01:18:42.000000', 'consum', 0.0222, 'lps'),
	(489333, 127, '2014-01-15 01:18:43.000000', 'consum', 0.0216, 'lps'),
	(489334, 127, '2014-01-15 01:18:44.000000', 'consum', 0.0222, 'lps'),
	(489335, 127, '2014-01-15 01:18:45.000000', 'consum', 0.0217, 'lps'),
	(489336, 127, '2014-01-15 01:18:46.000000', 'consum', 0.0226, 'lps'),
	(489337, 127, '2014-01-15 01:18:47.000000', 'consum', 0.0219, 'lps'),
	(489338, 127, '2014-01-15 01:18:48.000000', 'consum', 0.0224, 'lps'),
	(489339, 127, '2014-01-15 01:18:49.000000', 'consum', 0.0221, 'lps'),
	(489340, 127, '2014-01-15 01:18:50.000000', 'consum', 0.0221, 'lps'),
	(489341, 127, '2014-01-15 01:18:51.000000', 'consum', 0.0215, 'lps'),
	(489342, 127, '2014-01-15 01:18:52.000000', 'consum', 0.0221, 'lps'),
	(489343, 127, '2014-01-15 01:18:53.000000', 'consum', 0.0218, 'lps'),
	(489344, 127, '2014-01-15 01:18:54.000000', 'consum', 0.0216, 'lps'),
	(489345, 127, '2014-01-15 01:18:55.000000', 'consum', 0.0215, 'lps'),
	(489346, 127, '2014-01-15 01:18:56.000000', 'consum', 0.0220, 'lps'),
	(489347, 127, '2014-01-15 01:18:57.000000', 'consum', 0.0212, 'lps'),
	(489348, 127, '2014-01-15 01:18:58.000000', 'consum', 0.0222, 'lps'),
	(489349, 127, '2014-01-15 01:18:59.000000', 'consum', 0.0217, 'lps'),
	(489350, 127, '2014-01-15 01:19:00.000000', 'consum', 0.0223, 'lps'),
	(489351, 127, '2014-01-15 01:19:01.000000', 'consum', 0.0221, 'lps'),
	(489352, 127, '2014-01-15 01:19:02.000000', 'consum', 0.0226, 'lps'),
	(489353, 127, '2014-01-15 01:19:03.000000', 'consum', 0.0222, 'lps'),
	(489354, 127, '2014-01-15 01:19:04.000000', 'consum', 0.0226, 'lps'),
	(489355, 127, '2014-01-15 01:19:05.000000', 'consum', 0.0218, 'lps'),
	(489356, 127, '2014-01-15 01:19:06.000000', 'consum', 0.0221, 'lps'),
	(489357, 127, '2014-01-15 01:19:07.000000', 'consum', 0.0223, 'lps'),
	(489358, 127, '2014-01-15 01:19:08.000000', 'consum', 0.0225, 'lps'),
	(489359, 127, '2014-01-15 01:19:09.000000', 'consum', 0.0214, 'lps'),
	(489360, 127, '2014-01-15 01:19:10.000000', 'consum', 0.0221, 'lps'),
	(489361, 127, '2014-01-15 01:19:11.000000', 'consum', 0.0216, 'lps'),
	(489362, 127, '2014-01-15 01:19:12.000000', 'consum', 0.0226, 'lps'),
	(489363, 127, '2014-01-15 01:19:13.000000', 'consum', 0.0224, 'lps'),
	(489364, 127, '2014-01-15 01:19:14.000000', 'consum', 0.0212, 'lps'),
	(489365, 127, '2014-01-15 01:19:15.000000', 'consum', 0.0213, 'lps'),
	(489366, 127, '2014-01-15 01:19:16.000000', 'consum', 0.0220, 'lps'),
	(489367, 127, '2014-01-15 01:19:17.000000', 'consum', 0.0216, 'lps'),
	(489368, 127, '2014-01-15 01:19:18.000000', 'consum', 0.0211, 'lps'),
	(489369, 127, '2014-01-15 01:19:19.000000', 'consum', 0.0213, 'lps'),
	(489370, 127, '2014-01-15 01:19:20.000000', 'consum', 0.0226, 'lps'),
	(489371, 127, '2014-01-15 01:19:21.000000', 'consum', 0.0211, 'lps'),
	(489372, 127, '2014-01-15 01:19:22.000000', 'consum', 0.0218, 'lps'),
	(489373, 127, '2014-01-15 01:19:23.000000', 'consum', 0.0215, 'lps'),
	(489374, 127, '2014-01-15 01:19:24.000000', 'consum', 0.0213, 'lps'),
	(489375, 127, '2014-01-15 01:19:25.000000', 'consum', 0.0210, 'lps'),
	(489376, 127, '2014-01-15 01:19:26.000000', 'consum', 0.0217, 'lps'),
	(489377, 127, '2014-01-15 01:19:27.000000', 'consum', 0.0212, 'lps'),
	(489378, 127, '2014-01-15 01:19:28.000000', 'consum', 0.0215, 'lps'),
	(489379, 127, '2014-01-15 01:19:29.000000', 'consum', 0.0212, 'lps'),
	(489380, 127, '2014-01-15 01:19:30.000000', 'consum', 0.0225, 'lps'),
	(489381, 127, '2014-01-15 01:19:31.000000', 'consum', 0.0226, 'lps'),
	(489382, 127, '2014-01-15 01:19:32.000000', 'consum', 0.0213, 'lps'),
	(489383, 127, '2014-01-15 01:19:33.000000', 'consum', 0.0211, 'lps'),
	(489384, 127, '2014-01-15 01:19:34.000000', 'consum', 0.0224, 'lps'),
	(489385, 127, '2014-01-15 01:19:35.000000', 'consum', 0.0225, 'lps'),
	(489386, 127, '2014-01-15 01:19:36.000000', 'consum', 0.0210, 'lps'),
	(489387, 127, '2014-01-15 01:19:37.000000', 'consum', 0.0218, 'lps'),
	(489388, 127, '2014-01-15 01:19:38.000000', 'consum', 0.0216, 'lps'),
	(489389, 127, '2014-01-15 01:19:39.000000', 'consum', 0.0216, 'lps'),
	(489390, 127, '2014-01-15 01:19:40.000000', 'consum', 0.0222, 'lps'),
	(489391, 127, '2014-01-15 01:19:41.000000', 'consum', 0.0219, 'lps'),
	(489392, 127, '2014-01-15 01:19:42.000000', 'consum', 0.0219, 'lps'),
	(489393, 127, '2014-01-15 01:19:43.000000', 'consum', 0.0213, 'lps'),
	(489394, 127, '2014-01-15 01:19:44.000000', 'consum', 0.0216, 'lps'),
	(489395, 127, '2014-01-15 01:19:45.000000', 'consum', 0.0214, 'lps'),
	(489396, 127, '2014-01-15 01:19:46.000000', 'consum', 0.0212, 'lps'),
	(489397, 127, '2014-01-15 01:19:47.000000', 'consum', 0.0226, 'lps'),
	(489398, 127, '2014-01-15 01:19:48.000000', 'consum', 0.0217, 'lps'),
	(489399, 127, '2014-01-15 01:19:49.000000', 'consum', 0.0213, 'lps'),
	(489400, 127, '2014-01-15 01:19:50.000000', 'consum', 0.0221, 'lps'),
	(489401, 127, '2014-01-15 01:19:51.000000', 'consum', 0.0224, 'lps'),
	(489402, 127, '2014-01-15 01:19:52.000000', 'consum', 0.0214, 'lps'),
	(489403, 127, '2014-01-15 01:19:53.000000', 'consum', 0.0223, 'lps'),
	(489404, 127, '2014-01-15 01:19:54.000000', 'consum', 0.0212, 'lps'),
	(489405, 127, '2014-01-15 01:19:55.000000', 'consum', 0.0214, 'lps'),
	(489406, 127, '2014-01-15 01:19:56.000000', 'consum', 0.0226, 'lps'),
	(489407, 127, '2014-01-15 01:19:57.000000', 'consum', 0.0211, 'lps'),
	(489408, 127, '2014-01-15 01:19:58.000000', 'consum', 0.0218, 'lps'),
	(489409, 127, '2014-01-15 01:19:59.000000', 'consum', 0.0211, 'lps'),
	(489410, 127, '2014-01-15 01:20:00.000000', 'consum', 0.0212, 'lps'),
	(489411, 128, '2014-01-15 00:00:00.000000', 'consum', 0.0225, 'lps'),
	(489412, 128, '2014-01-15 00:00:01.000000', 'consum', 0.0212, 'lps'),
	(489413, 128, '2014-01-15 00:00:02.000000', 'consum', 0.0210, 'lps'),
	(489414, 128, '2014-01-15 00:00:03.000000', 'consum', 0.0220, 'lps'),
	(489415, 128, '2014-01-15 00:00:04.000000', 'consum', 0.0211, 'lps'),
	(489416, 128, '2014-01-15 00:00:05.000000', 'consum', 0.0219, 'lps'),
	(489417, 128, '2014-01-15 00:00:06.000000', 'consum', 0.0220, 'lps'),
	(489418, 128, '2014-01-15 00:00:07.000000', 'consum', 0.0216, 'lps'),
	(489419, 128, '2014-01-15 00:00:08.000000', 'consum', 0.0211, 'lps'),
	(489420, 128, '2014-01-15 00:00:09.000000', 'consum', 0.0213, 'lps'),
	(489421, 128, '2014-01-15 00:00:10.000000', 'consum', 0.0224, 'lps'),
	(489422, 128, '2014-01-15 00:00:11.000000', 'consum', 0.0224, 'lps'),
	(489423, 128, '2014-01-15 00:00:12.000000', 'consum', 0.0222, 'lps'),
	(489424, 128, '2014-01-15 00:00:13.000000', 'consum', 0.0214, 'lps'),
	(489425, 128, '2014-01-15 00:00:14.000000', 'consum', 0.0210, 'lps'),
	(489426, 128, '2014-01-15 00:00:15.000000', 'consum', 0.0214, 'lps'),
	(489427, 128, '2014-01-15 00:00:16.000000', 'consum', 0.0214, 'lps'),
	(489428, 128, '2014-01-15 00:00:17.000000', 'consum', 0.0217, 'lps'),
	(489429, 128, '2014-01-15 00:00:18.000000', 'consum', 0.0219, 'lps'),
	(489430, 128, '2014-01-15 00:00:19.000000', 'consum', 0.0218, 'lps'),
	(489431, 128, '2014-01-15 00:00:20.000000', 'consum', 0.0224, 'lps'),
	(489432, 128, '2014-01-15 00:00:21.000000', 'consum', 0.0224, 'lps'),
	(489433, 128, '2014-01-15 00:00:22.000000', 'consum', 0.0221, 'lps'),
	(489434, 128, '2014-01-15 00:00:23.000000', 'consum', 0.0223, 'lps'),
	(489435, 128, '2014-01-15 00:00:24.000000', 'consum', 0.0213, 'lps'),
	(489436, 128, '2014-01-15 00:00:25.000000', 'consum', 0.0218, 'lps'),
	(489437, 128, '2014-01-15 00:00:26.000000', 'consum', 0.0225, 'lps'),
	(489438, 128, '2014-01-15 00:00:27.000000', 'consum', 0.0215, 'lps'),
	(489439, 128, '2014-01-15 00:00:28.000000', 'consum', 0.0220, 'lps'),
	(489440, 128, '2014-01-15 00:00:29.000000', 'consum', 0.0215, 'lps'),
	(489441, 128, '2014-01-15 00:00:30.000000', 'consum', 0.0222, 'lps'),
	(489442, 128, '2014-01-15 00:00:31.000000', 'consum', 0.0224, 'lps'),
	(489443, 128, '2014-01-15 00:00:32.000000', 'consum', 0.0213, 'lps'),
	(489444, 128, '2014-01-15 00:00:33.000000', 'consum', 0.0214, 'lps'),
	(489445, 128, '2014-01-15 00:00:34.000000', 'consum', 0.0221, 'lps'),
	(489446, 128, '2014-01-15 00:00:35.000000', 'consum', 0.0223, 'lps'),
	(489447, 128, '2014-01-15 00:00:36.000000', 'consum', 0.0211, 'lps'),
	(489448, 128, '2014-01-15 00:00:37.000000', 'consum', 0.0222, 'lps'),
	(489449, 128, '2014-01-15 00:00:38.000000', 'consum', 0.0222, 'lps'),
	(489450, 128, '2014-01-15 00:00:39.000000', 'consum', 0.0216, 'lps'),
	(489451, 128, '2014-01-15 00:00:40.000000', 'consum', 0.0220, 'lps'),
	(489452, 128, '2014-01-15 00:00:41.000000', 'consum', 0.0212, 'lps'),
	(489453, 128, '2014-01-15 00:00:42.000000', 'consum', 0.0220, 'lps'),
	(489454, 128, '2014-01-15 00:00:43.000000', 'consum', 0.0210, 'lps'),
	(489455, 128, '2014-01-15 00:00:44.000000', 'consum', 0.0211, 'lps'),
	(489456, 128, '2014-01-15 00:00:45.000000', 'consum', 0.0216, 'lps'),
	(489457, 128, '2014-01-15 00:00:46.000000', 'consum', 0.0221, 'lps'),
	(489458, 128, '2014-01-15 00:00:47.000000', 'consum', 0.0216, 'lps'),
	(489459, 128, '2014-01-15 00:00:48.000000', 'consum', 0.0225, 'lps'),
	(489460, 128, '2014-01-15 00:00:49.000000', 'consum', 0.0217, 'lps'),
	(489461, 128, '2014-01-15 00:00:50.000000', 'consum', 0.0218, 'lps'),
	(489462, 128, '2014-01-15 00:00:51.000000', 'consum', 0.0214, 'lps'),
	(489463, 128, '2014-01-15 00:00:52.000000', 'consum', 0.0221, 'lps'),
	(489464, 128, '2014-01-15 00:00:53.000000', 'consum', 0.0221, 'lps'),
	(489465, 128, '2014-01-15 00:00:54.000000', 'consum', 0.0217, 'lps'),
	(489466, 128, '2014-01-15 00:00:55.000000', 'consum', 0.0215, 'lps'),
	(489467, 128, '2014-01-15 00:00:56.000000', 'consum', 0.0212, 'lps'),
	(489468, 128, '2014-01-15 00:00:57.000000', 'consum', 0.0222, 'lps'),
	(489469, 128, '2014-01-15 00:00:58.000000', 'consum', 0.0216, 'lps'),
	(489470, 128, '2014-01-15 00:00:59.000000', 'consum', 0.0220, 'lps'),
	(489471, 128, '2014-01-15 00:01:00.000000', 'consum', 0.0213, 'lps'),
	(489472, 128, '2014-01-15 00:01:01.000000', 'consum', 0.0225, 'lps'),
	(489473, 128, '2014-01-15 00:01:02.000000', 'consum', 0.0212, 'lps'),
	(489474, 128, '2014-01-15 00:01:03.000000', 'consum', 0.0224, 'lps'),
	(489475, 128, '2014-01-15 00:01:04.000000', 'consum', 0.0210, 'lps'),
	(489476, 128, '2014-01-15 00:01:05.000000', 'consum', 0.0219, 'lps'),
	(489477, 128, '2014-01-15 00:01:06.000000', 'consum', 0.0222, 'lps'),
	(489478, 128, '2014-01-15 00:01:07.000000', 'consum', 0.0212, 'lps'),
	(489479, 128, '2014-01-15 00:01:08.000000', 'consum', 0.0214, 'lps'),
	(489480, 128, '2014-01-15 00:01:09.000000', 'consum', 0.0211, 'lps'),
	(489481, 128, '2014-01-15 00:01:10.000000', 'consum', 0.0219, 'lps'),
	(489482, 128, '2014-01-15 00:01:11.000000', 'consum', 0.0219, 'lps'),
	(489483, 128, '2014-01-15 00:01:12.000000', 'consum', 0.0215, 'lps'),
	(489484, 128, '2014-01-15 00:01:13.000000', 'consum', 0.0222, 'lps'),
	(489485, 128, '2014-01-15 00:01:14.000000', 'consum', 0.0210, 'lps'),
	(489486, 128, '2014-01-15 00:01:15.000000', 'consum', 0.0221, 'lps'),
	(489487, 128, '2014-01-15 00:01:16.000000', 'consum', 0.0216, 'lps'),
	(489488, 128, '2014-01-15 00:01:17.000000', 'consum', 0.0223, 'lps'),
	(489489, 128, '2014-01-15 00:01:18.000000', 'consum', 0.0213, 'lps'),
	(489490, 128, '2014-01-15 00:01:19.000000', 'consum', 0.0215, 'lps'),
	(489491, 128, '2014-01-15 00:01:20.000000', 'consum', 0.0211, 'lps'),
	(489492, 128, '2014-01-15 00:01:21.000000', 'consum', 0.0219, 'lps'),
	(489493, 128, '2014-01-15 00:01:22.000000', 'consum', 0.0220, 'lps'),
	(489494, 128, '2014-01-15 00:01:23.000000', 'consum', 0.0215, 'lps'),
	(489495, 128, '2014-01-15 00:01:24.000000', 'consum', 0.0223, 'lps'),
	(489496, 128, '2014-01-15 00:01:25.000000', 'consum', 0.0215, 'lps'),
	(489497, 128, '2014-01-15 00:01:26.000000', 'consum', 0.0225, 'lps'),
	(489498, 128, '2014-01-15 00:01:27.000000', 'consum', 0.0222, 'lps'),
	(489499, 128, '2014-01-15 00:01:28.000000', 'consum', 0.0211, 'lps'),
	(489500, 128, '2014-01-15 00:01:29.000000', 'consum', 0.0212, 'lps'),
	(489501, 128, '2014-01-15 00:01:30.000000', 'consum', 0.0217, 'lps'),
	(489502, 128, '2014-01-15 00:01:31.000000', 'consum', 0.0223, 'lps'),
	(489503, 128, '2014-01-15 00:01:32.000000', 'consum', 0.0222, 'lps'),
	(489504, 128, '2014-01-15 00:01:33.000000', 'consum', 0.0214, 'lps'),
	(489505, 128, '2014-01-15 00:01:34.000000', 'consum', 0.0213, 'lps'),
	(489506, 128, '2014-01-15 00:01:35.000000', 'consum', 0.0214, 'lps'),
	(489507, 128, '2014-01-15 00:01:36.000000', 'consum', 0.0222, 'lps'),
	(489508, 128, '2014-01-15 00:01:37.000000', 'consum', 0.0211, 'lps'),
	(489509, 128, '2014-01-15 00:01:38.000000', 'consum', 0.0210, 'lps'),
	(489510, 128, '2014-01-15 00:01:39.000000', 'consum', 0.0225, 'lps'),
	(489511, 128, '2014-01-15 00:01:40.000000', 'consum', 0.0222, 'lps'),
	(489512, 128, '2014-01-15 00:01:41.000000', 'consum', 0.0210, 'lps'),
	(489513, 128, '2014-01-15 00:01:42.000000', 'consum', 0.0219, 'lps'),
	(489514, 128, '2014-01-15 00:01:43.000000', 'consum', 0.0211, 'lps'),
	(489515, 128, '2014-01-15 00:01:44.000000', 'consum', 0.0220, 'lps'),
	(489516, 128, '2014-01-15 00:01:45.000000', 'consum', 0.0211, 'lps'),
	(489517, 128, '2014-01-15 00:01:46.000000', 'consum', 0.0216, 'lps'),
	(489518, 128, '2014-01-15 00:01:47.000000', 'consum', 0.0223, 'lps'),
	(489519, 128, '2014-01-15 00:01:48.000000', 'consum', 0.0224, 'lps'),
	(489520, 128, '2014-01-15 00:01:49.000000', 'consum', 0.0212, 'lps'),
	(489521, 128, '2014-01-15 00:01:50.000000', 'consum', 0.0225, 'lps'),
	(489522, 128, '2014-01-15 00:01:51.000000', 'consum', 0.0214, 'lps'),
	(489523, 128, '2014-01-15 00:01:52.000000', 'consum', 0.0219, 'lps'),
	(489524, 128, '2014-01-15 00:01:53.000000', 'consum', 0.0211, 'lps'),
	(489525, 128, '2014-01-15 00:01:54.000000', 'consum', 0.0220, 'lps'),
	(489526, 128, '2014-01-15 00:01:55.000000', 'consum', 0.0225, 'lps'),
	(489527, 128, '2014-01-15 00:01:56.000000', 'consum', 0.0222, 'lps'),
	(489528, 128, '2014-01-15 00:01:57.000000', 'consum', 0.0212, 'lps'),
	(489529, 128, '2014-01-15 00:01:58.000000', 'consum', 0.0217, 'lps'),
	(489530, 128, '2014-01-15 00:01:59.000000', 'consum', 0.0224, 'lps'),
	(489531, 128, '2014-01-15 00:02:00.000000', 'consum', 0.0225, 'lps'),
	(489532, 128, '2014-01-15 00:02:01.000000', 'consum', 0.0213, 'lps'),
	(489533, 128, '2014-01-15 00:02:02.000000', 'consum', 0.0211, 'lps'),
	(489534, 128, '2014-01-15 00:02:03.000000', 'consum', 0.0222, 'lps'),
	(489535, 128, '2014-01-15 00:02:04.000000', 'consum', 0.0219, 'lps'),
	(489536, 128, '2014-01-15 00:02:05.000000', 'consum', 0.0219, 'lps'),
	(489537, 128, '2014-01-15 00:02:06.000000', 'consum', 0.0212, 'lps'),
	(489538, 128, '2014-01-15 00:02:07.000000', 'consum', 0.0211, 'lps'),
	(489539, 128, '2014-01-15 00:02:08.000000', 'consum', 0.0225, 'lps'),
	(489540, 128, '2014-01-15 00:02:09.000000', 'consum', 0.0218, 'lps'),
	(489541, 128, '2014-01-15 00:02:10.000000', 'consum', 0.0223, 'lps'),
	(489542, 128, '2014-01-15 00:02:11.000000', 'consum', 0.0220, 'lps'),
	(489543, 128, '2014-01-15 00:02:12.000000', 'consum', 0.0219, 'lps'),
	(489544, 128, '2014-01-15 00:02:13.000000', 'consum', 0.0210, 'lps'),
	(489545, 128, '2014-01-15 00:02:14.000000', 'consum', 0.0214, 'lps'),
	(489546, 128, '2014-01-15 00:02:15.000000', 'consum', 0.0217, 'lps'),
	(489547, 128, '2014-01-15 00:02:16.000000', 'consum', 0.0217, 'lps'),
	(489548, 128, '2014-01-15 00:02:17.000000', 'consum', 0.0225, 'lps'),
	(489549, 128, '2014-01-15 00:02:18.000000', 'consum', 0.0216, 'lps'),
	(489550, 128, '2014-01-15 00:02:19.000000', 'consum', 0.0210, 'lps'),
	(489551, 128, '2014-01-15 00:02:20.000000', 'consum', 0.0224, 'lps'),
	(489552, 128, '2014-01-15 00:02:21.000000', 'consum', 0.0219, 'lps'),
	(489553, 128, '2014-01-15 00:02:22.000000', 'consum', 0.0211, 'lps'),
	(489554, 128, '2014-01-15 00:02:23.000000', 'consum', 0.0220, 'lps'),
	(489555, 128, '2014-01-15 00:02:24.000000', 'consum', 0.0224, 'lps'),
	(489556, 128, '2014-01-15 00:02:25.000000', 'consum', 0.0222, 'lps'),
	(489557, 128, '2014-01-15 00:02:26.000000', 'consum', 0.0213, 'lps'),
	(489558, 128, '2014-01-15 00:02:27.000000', 'consum', 0.0219, 'lps'),
	(489559, 128, '2014-01-15 00:02:28.000000', 'consum', 0.0214, 'lps'),
	(489560, 128, '2014-01-15 00:02:29.000000', 'consum', 0.0222, 'lps'),
	(489561, 128, '2014-01-15 00:02:30.000000', 'consum', 0.0211, 'lps'),
	(489562, 128, '2014-01-15 00:02:31.000000', 'consum', 0.0211, 'lps'),
	(489563, 128, '2014-01-15 00:02:32.000000', 'consum', 0.0210, 'lps'),
	(489564, 128, '2014-01-15 00:02:33.000000', 'consum', 0.0225, 'lps'),
	(489565, 128, '2014-01-15 00:02:34.000000', 'consum', 0.0220, 'lps'),
	(489566, 128, '2014-01-15 00:02:35.000000', 'consum', 0.0218, 'lps'),
	(489567, 128, '2014-01-15 00:02:36.000000', 'consum', 0.0219, 'lps'),
	(489568, 128, '2014-01-15 00:02:37.000000', 'consum', 0.0214, 'lps'),
	(489569, 128, '2014-01-15 00:02:38.000000', 'consum', 0.0222, 'lps'),
	(489570, 128, '2014-01-15 00:02:39.000000', 'consum', 0.0212, 'lps'),
	(489571, 128, '2014-01-15 00:02:40.000000', 'consum', 0.0213, 'lps'),
	(489572, 128, '2014-01-15 00:02:41.000000', 'consum', 0.0222, 'lps'),
	(489573, 128, '2014-01-15 00:02:42.000000', 'consum', 0.0214, 'lps'),
	(489574, 128, '2014-01-15 00:02:43.000000', 'consum', 0.0223, 'lps'),
	(489575, 128, '2014-01-15 00:02:44.000000', 'consum', 0.0219, 'lps'),
	(489576, 128, '2014-01-15 00:02:45.000000', 'consum', 0.0216, 'lps'),
	(489577, 128, '2014-01-15 00:02:46.000000', 'consum', 0.0211, 'lps'),
	(489578, 128, '2014-01-15 00:02:47.000000', 'consum', 0.0217, 'lps'),
	(489579, 128, '2014-01-15 00:02:48.000000', 'consum', 0.0224, 'lps'),
	(489580, 128, '2014-01-15 00:02:49.000000', 'consum', 0.0212, 'lps'),
	(489581, 128, '2014-01-15 00:02:50.000000', 'consum', 0.0213, 'lps'),
	(489582, 128, '2014-01-15 00:02:51.000000', 'consum', 0.0217, 'lps'),
	(489583, 128, '2014-01-15 00:02:52.000000', 'consum', 0.0220, 'lps'),
	(489584, 128, '2014-01-15 00:02:53.000000', 'consum', 0.0223, 'lps'),
	(489585, 128, '2014-01-15 00:02:54.000000', 'consum', 0.0215, 'lps'),
	(489586, 128, '2014-01-15 00:02:55.000000', 'consum', 0.0211, 'lps'),
	(489587, 128, '2014-01-15 00:02:56.000000', 'consum', 0.0216, 'lps'),
	(489588, 128, '2014-01-15 00:02:57.000000', 'consum', 0.0222, 'lps'),
	(489589, 128, '2014-01-15 00:02:58.000000', 'consum', 0.0223, 'lps'),
	(489590, 128, '2014-01-15 00:02:59.000000', 'consum', 0.0220, 'lps'),
	(489591, 128, '2014-01-15 00:03:00.000000', 'consum', 0.0222, 'lps'),
	(489592, 128, '2014-01-15 00:03:01.000000', 'consum', 0.0210, 'lps'),
	(489593, 128, '2014-01-15 00:03:02.000000', 'consum', 0.0220, 'lps'),
	(489594, 128, '2014-01-15 00:03:03.000000', 'consum', 0.0215, 'lps'),
	(489595, 128, '2014-01-15 00:03:04.000000', 'consum', 0.0222, 'lps'),
	(489596, 128, '2014-01-15 00:03:05.000000', 'consum', 0.0221, 'lps'),
	(489597, 128, '2014-01-15 00:03:06.000000', 'consum', 0.0215, 'lps'),
	(489598, 128, '2014-01-15 00:03:07.000000', 'consum', 0.0218, 'lps'),
	(489599, 128, '2014-01-15 00:03:08.000000', 'consum', 0.0221, 'lps'),
	(489600, 128, '2014-01-15 00:03:09.000000', 'consum', 0.0224, 'lps'),
	(489601, 128, '2014-01-15 00:03:10.000000', 'consum', 0.0217, 'lps'),
	(489602, 128, '2014-01-15 00:03:11.000000', 'consum', 0.0220, 'lps'),
	(489603, 128, '2014-01-15 00:03:12.000000', 'consum', 0.0224, 'lps'),
	(489604, 128, '2014-01-15 00:03:13.000000', 'consum', 0.0218, 'lps'),
	(489605, 128, '2014-01-15 00:03:14.000000', 'consum', 0.0210, 'lps'),
	(489606, 128, '2014-01-15 00:03:15.000000', 'consum', 0.0218, 'lps'),
	(489607, 128, '2014-01-15 00:03:16.000000', 'consum', 0.0220, 'lps'),
	(489608, 128, '2014-01-15 00:03:17.000000', 'consum', 0.0219, 'lps'),
	(489609, 128, '2014-01-15 00:03:18.000000', 'consum', 0.0211, 'lps'),
	(489610, 128, '2014-01-15 00:03:19.000000', 'consum', 0.0219, 'lps'),
	(489611, 128, '2014-01-15 00:03:20.000000', 'consum', 0.0219, 'lps'),
	(489612, 128, '2014-01-15 00:03:21.000000', 'consum', 0.0215, 'lps'),
	(489613, 128, '2014-01-15 00:03:22.000000', 'consum', 0.0224, 'lps'),
	(489614, 128, '2014-01-15 00:03:23.000000', 'consum', 0.0219, 'lps'),
	(489615, 128, '2014-01-15 00:03:24.000000', 'consum', 0.0212, 'lps'),
	(489616, 128, '2014-01-15 00:03:25.000000', 'consum', 0.0211, 'lps'),
	(489617, 128, '2014-01-15 00:03:26.000000', 'consum', 0.0211, 'lps'),
	(489618, 128, '2014-01-15 00:03:27.000000', 'consum', 0.0225, 'lps'),
	(489619, 128, '2014-01-15 00:03:28.000000', 'consum', 0.0219, 'lps'),
	(489620, 128, '2014-01-15 00:03:29.000000', 'consum', 0.0212, 'lps'),
	(489621, 128, '2014-01-15 00:03:30.000000', 'consum', 0.0211, 'lps'),
	(489622, 128, '2014-01-15 00:03:31.000000', 'consum', 0.0222, 'lps'),
	(489623, 128, '2014-01-15 00:03:32.000000', 'consum', 0.0221, 'lps'),
	(489624, 128, '2014-01-15 00:03:33.000000', 'consum', 0.0215, 'lps'),
	(489625, 128, '2014-01-15 00:03:34.000000', 'consum', 0.0216, 'lps'),
	(489626, 128, '2014-01-15 00:03:35.000000', 'consum', 0.0211, 'lps'),
	(489627, 128, '2014-01-15 00:03:36.000000', 'consum', 0.0211, 'lps'),
	(489628, 128, '2014-01-15 00:03:37.000000', 'consum', 0.0215, 'lps'),
	(489629, 128, '2014-01-15 00:03:38.000000', 'consum', 0.0214, 'lps'),
	(489630, 128, '2014-01-15 00:03:39.000000', 'consum', 0.0216, 'lps'),
	(489631, 128, '2014-01-15 00:03:40.000000', 'consum', 0.0212, 'lps'),
	(489632, 128, '2014-01-15 00:03:41.000000', 'consum', 0.0218, 'lps'),
	(489633, 128, '2014-01-15 00:03:42.000000', 'consum', 0.0214, 'lps'),
	(489634, 128, '2014-01-15 00:03:43.000000', 'consum', 0.0222, 'lps'),
	(489635, 128, '2014-01-15 00:03:44.000000', 'consum', 0.0212, 'lps'),
	(489636, 128, '2014-01-15 00:03:45.000000', 'consum', 0.0215, 'lps'),
	(489637, 128, '2014-01-15 00:03:46.000000', 'consum', 0.0214, 'lps'),
	(489638, 128, '2014-01-15 00:03:47.000000', 'consum', 0.0215, 'lps'),
	(489639, 128, '2014-01-15 00:03:48.000000', 'consum', 0.0224, 'lps'),
	(489640, 128, '2014-01-15 00:03:49.000000', 'consum', 0.0216, 'lps'),
	(489641, 128, '2014-01-15 00:03:50.000000', 'consum', 0.0214, 'lps'),
	(489642, 128, '2014-01-15 00:03:51.000000', 'consum', 0.0216, 'lps'),
	(489643, 128, '2014-01-15 00:03:52.000000', 'consum', 0.0225, 'lps'),
	(489644, 128, '2014-01-15 00:03:53.000000', 'consum', 0.0222, 'lps'),
	(489645, 128, '2014-01-15 00:03:54.000000', 'consum', 0.0223, 'lps'),
	(489646, 128, '2014-01-15 00:03:55.000000', 'consum', 0.0225, 'lps'),
	(489647, 128, '2014-01-15 00:03:56.000000', 'consum', 0.0215, 'lps'),
	(489648, 128, '2014-01-15 00:03:57.000000', 'consum', 0.0220, 'lps'),
	(489649, 128, '2014-01-15 00:03:58.000000', 'consum', 0.0217, 'lps'),
	(489650, 128, '2014-01-15 00:03:59.000000', 'consum', 0.0212, 'lps'),
	(489651, 128, '2014-01-15 00:04:00.000000', 'consum', 0.0219, 'lps'),
	(489652, 128, '2014-01-15 00:04:01.000000', 'consum', 0.0216, 'lps'),
	(489653, 128, '2014-01-15 00:04:02.000000', 'consum', 0.0214, 'lps'),
	(489654, 128, '2014-01-15 00:04:03.000000', 'consum', 0.0211, 'lps'),
	(489655, 128, '2014-01-15 00:04:04.000000', 'consum', 0.0221, 'lps'),
	(489656, 128, '2014-01-15 00:04:05.000000', 'consum', 0.0212, 'lps'),
	(489657, 128, '2014-01-15 00:04:06.000000', 'consum', 0.0223, 'lps'),
	(489658, 128, '2014-01-15 00:04:07.000000', 'consum', 0.0219, 'lps'),
	(489659, 128, '2014-01-15 00:04:08.000000', 'consum', 0.0215, 'lps'),
	(489660, 128, '2014-01-15 00:04:09.000000', 'consum', 0.0211, 'lps'),
	(489661, 128, '2014-01-15 00:04:10.000000', 'consum', 0.0214, 'lps'),
	(489662, 128, '2014-01-15 00:04:11.000000', 'consum', 0.0212, 'lps'),
	(489663, 128, '2014-01-15 00:04:12.000000', 'consum', 0.0224, 'lps'),
	(489664, 128, '2014-01-15 00:04:13.000000', 'consum', 0.0211, 'lps'),
	(489665, 128, '2014-01-15 00:04:14.000000', 'consum', 0.0222, 'lps'),
	(489666, 128, '2014-01-15 00:04:15.000000', 'consum', 0.0219, 'lps'),
	(489667, 128, '2014-01-15 00:04:16.000000', 'consum', 0.0219, 'lps'),
	(489668, 128, '2014-01-15 00:04:17.000000', 'consum', 0.0212, 'lps'),
	(489669, 128, '2014-01-15 00:04:18.000000', 'consum', 0.0224, 'lps'),
	(489670, 128, '2014-01-15 00:04:19.000000', 'consum', 0.0213, 'lps'),
	(489671, 128, '2014-01-15 00:04:20.000000', 'consum', 0.0213, 'lps'),
	(489672, 128, '2014-01-15 00:04:21.000000', 'consum', 0.0218, 'lps'),
	(489673, 128, '2014-01-15 00:04:22.000000', 'consum', 0.0225, 'lps'),
	(489674, 128, '2014-01-15 00:04:23.000000', 'consum', 0.0215, 'lps'),
	(489675, 128, '2014-01-15 00:04:24.000000', 'consum', 0.0221, 'lps'),
	(489676, 128, '2014-01-15 00:04:25.000000', 'consum', 0.0218, 'lps'),
	(489677, 128, '2014-01-15 00:04:26.000000', 'consum', 0.0219, 'lps'),
	(489678, 128, '2014-01-15 00:04:27.000000', 'consum', 0.0217, 'lps'),
	(489679, 128, '2014-01-15 00:04:28.000000', 'consum', 0.0215, 'lps'),
	(489680, 128, '2014-01-15 00:04:29.000000', 'consum', 0.0218, 'lps'),
	(489681, 128, '2014-01-15 00:04:30.000000', 'consum', 0.0218, 'lps'),
	(489682, 128, '2014-01-15 00:04:31.000000', 'consum', 0.0210, 'lps'),
	(489683, 128, '2014-01-15 00:04:32.000000', 'consum', 0.0220, 'lps'),
	(489684, 128, '2014-01-15 00:04:33.000000', 'consum', 0.0212, 'lps'),
	(489685, 128, '2014-01-15 00:04:34.000000', 'consum', 0.0222, 'lps'),
	(489686, 128, '2014-01-15 00:04:35.000000', 'consum', 0.0219, 'lps'),
	(489687, 128, '2014-01-15 00:04:36.000000', 'consum', 0.0217, 'lps'),
	(489688, 128, '2014-01-15 00:04:37.000000', 'consum', 0.0218, 'lps'),
	(489689, 128, '2014-01-15 00:04:38.000000', 'consum', 0.0214, 'lps'),
	(489690, 128, '2014-01-15 00:04:39.000000', 'consum', 0.0222, 'lps'),
	(489691, 128, '2014-01-15 00:04:40.000000', 'consum', 0.0213, 'lps'),
	(489692, 128, '2014-01-15 00:04:41.000000', 'consum', 0.0219, 'lps'),
	(489693, 128, '2014-01-15 00:04:42.000000', 'consum', 0.0215, 'lps'),
	(489694, 128, '2014-01-15 00:04:43.000000', 'consum', 0.0225, 'lps'),
	(489695, 128, '2014-01-15 00:04:44.000000', 'consum', 0.0221, 'lps'),
	(489696, 128, '2014-01-15 00:04:45.000000', 'consum', 0.0222, 'lps'),
	(489697, 128, '2014-01-15 00:04:46.000000', 'consum', 0.0221, 'lps'),
	(489698, 128, '2014-01-15 00:04:47.000000', 'consum', 0.0215, 'lps'),
	(489699, 128, '2014-01-15 00:04:48.000000', 'consum', 0.0216, 'lps'),
	(489700, 128, '2014-01-15 00:04:49.000000', 'consum', 0.0211, 'lps'),
	(489701, 128, '2014-01-15 00:04:50.000000', 'consum', 0.0211, 'lps'),
	(489702, 128, '2014-01-15 00:04:51.000000', 'consum', 0.0216, 'lps'),
	(489703, 128, '2014-01-15 00:04:52.000000', 'consum', 0.0219, 'lps'),
	(489704, 128, '2014-01-15 00:04:53.000000', 'consum', 0.0220, 'lps'),
	(489705, 128, '2014-01-15 00:04:54.000000', 'consum', 0.0220, 'lps'),
	(489706, 128, '2014-01-15 00:04:55.000000', 'consum', 0.0215, 'lps'),
	(489707, 128, '2014-01-15 00:04:56.000000', 'consum', 0.0220, 'lps'),
	(489708, 128, '2014-01-15 00:04:57.000000', 'consum', 0.0214, 'lps'),
	(489709, 128, '2014-01-15 00:04:58.000000', 'consum', 0.0217, 'lps'),
	(489710, 128, '2014-01-15 00:04:59.000000', 'consum', 0.0218, 'lps'),
	(489711, 128, '2014-01-15 00:05:00.000000', 'consum', 0.0212, 'lps'),
	(489712, 128, '2014-01-15 00:05:01.000000', 'consum', 0.0214, 'lps'),
	(489713, 128, '2014-01-15 00:05:02.000000', 'consum', 0.0224, 'lps'),
	(489714, 128, '2014-01-15 00:05:03.000000', 'consum', 0.0220, 'lps'),
	(489715, 128, '2014-01-15 00:05:04.000000', 'consum', 0.0217, 'lps'),
	(489716, 128, '2014-01-15 00:05:05.000000', 'consum', 0.0216, 'lps'),
	(489717, 128, '2014-01-15 00:05:06.000000', 'consum', 0.0220, 'lps'),
	(489718, 128, '2014-01-15 00:05:07.000000', 'consum', 0.0212, 'lps'),
	(489719, 128, '2014-01-15 00:05:08.000000', 'consum', 0.0223, 'lps'),
	(489720, 128, '2014-01-15 00:05:09.000000', 'consum', 0.0221, 'lps'),
	(489721, 128, '2014-01-15 00:05:10.000000', 'consum', 0.0210, 'lps'),
	(489722, 128, '2014-01-15 00:05:11.000000', 'consum', 0.0211, 'lps'),
	(489723, 128, '2014-01-15 00:05:12.000000', 'consum', 0.0216, 'lps'),
	(489724, 128, '2014-01-15 00:05:13.000000', 'consum', 0.0222, 'lps'),
	(489725, 128, '2014-01-15 00:05:14.000000', 'consum', 0.0221, 'lps'),
	(489726, 128, '2014-01-15 00:05:15.000000', 'consum', 0.0211, 'lps'),
	(489727, 128, '2014-01-15 00:05:16.000000', 'consum', 0.0216, 'lps'),
	(489728, 128, '2014-01-15 00:05:17.000000', 'consum', 0.0223, 'lps'),
	(489729, 128, '2014-01-15 00:05:18.000000', 'consum', 0.0223, 'lps'),
	(489730, 128, '2014-01-15 00:05:19.000000', 'consum', 0.0221, 'lps'),
	(489731, 128, '2014-01-15 00:05:20.000000', 'consum', 0.0225, 'lps'),
	(489732, 128, '2014-01-15 00:05:21.000000', 'consum', 0.0221, 'lps'),
	(489733, 128, '2014-01-15 00:05:22.000000', 'consum', 0.0222, 'lps'),
	(489734, 128, '2014-01-15 00:05:23.000000', 'consum', 0.0220, 'lps'),
	(489735, 128, '2014-01-15 00:05:24.000000', 'consum', 0.0223, 'lps'),
	(489736, 128, '2014-01-15 00:05:25.000000', 'consum', 0.0216, 'lps'),
	(489737, 128, '2014-01-15 00:05:26.000000', 'consum', 0.0218, 'lps'),
	(489738, 128, '2014-01-15 00:05:27.000000', 'consum', 0.0216, 'lps'),
	(489739, 128, '2014-01-15 00:05:28.000000', 'consum', 0.0216, 'lps'),
	(489740, 128, '2014-01-15 00:05:29.000000', 'consum', 0.0224, 'lps'),
	(489741, 128, '2014-01-15 00:05:30.000000', 'consum', 0.0213, 'lps'),
	(489742, 128, '2014-01-15 00:05:31.000000', 'consum', 0.0216, 'lps'),
	(489743, 128, '2014-01-15 00:05:32.000000', 'consum', 0.0216, 'lps'),
	(489744, 128, '2014-01-15 00:05:33.000000', 'consum', 0.0224, 'lps'),
	(489745, 128, '2014-01-15 00:05:34.000000', 'consum', 0.0211, 'lps'),
	(489746, 128, '2014-01-15 00:05:35.000000', 'consum', 0.0223, 'lps'),
	(489747, 128, '2014-01-15 00:05:36.000000', 'consum', 0.0210, 'lps'),
	(489748, 128, '2014-01-15 00:05:37.000000', 'consum', 0.0219, 'lps'),
	(489749, 128, '2014-01-15 00:05:38.000000', 'consum', 0.0222, 'lps'),
	(489750, 128, '2014-01-15 00:05:39.000000', 'consum', 0.0213, 'lps'),
	(489751, 128, '2014-01-15 00:05:40.000000', 'consum', 0.0221, 'lps'),
	(489752, 128, '2014-01-15 00:05:41.000000', 'consum', 0.0225, 'lps'),
	(489753, 128, '2014-01-15 00:05:42.000000', 'consum', 0.0220, 'lps'),
	(489754, 128, '2014-01-15 00:05:43.000000', 'consum', 0.0214, 'lps'),
	(489755, 128, '2014-01-15 00:05:44.000000', 'consum', 0.0218, 'lps'),
	(489756, 128, '2014-01-15 00:05:45.000000', 'consum', 0.0220, 'lps'),
	(489757, 128, '2014-01-15 00:05:46.000000', 'consum', 0.0223, 'lps'),
	(489758, 128, '2014-01-15 00:05:47.000000', 'consum', 0.0214, 'lps'),
	(489759, 128, '2014-01-15 00:05:48.000000', 'consum', 0.0221, 'lps'),
	(489760, 128, '2014-01-15 00:05:49.000000', 'consum', 0.0221, 'lps'),
	(489761, 128, '2014-01-15 00:05:50.000000', 'consum', 0.0220, 'lps'),
	(489762, 128, '2014-01-15 00:05:51.000000', 'consum', 0.0225, 'lps'),
	(489763, 128, '2014-01-15 00:05:52.000000', 'consum', 0.0223, 'lps'),
	(489764, 128, '2014-01-15 00:05:53.000000', 'consum', 0.0215, 'lps'),
	(489765, 128, '2014-01-15 00:05:54.000000', 'consum', 0.0214, 'lps'),
	(489766, 128, '2014-01-15 00:05:55.000000', 'consum', 0.0214, 'lps'),
	(489767, 128, '2014-01-15 00:05:56.000000', 'consum', 0.0218, 'lps'),
	(489768, 128, '2014-01-15 00:05:57.000000', 'consum', 0.0222, 'lps'),
	(489769, 128, '2014-01-15 00:05:58.000000', 'consum', 0.0213, 'lps'),
	(489770, 128, '2014-01-15 00:05:59.000000', 'consum', 0.0224, 'lps'),
	(489771, 128, '2014-01-15 00:06:00.000000', 'consum', 0.0223, 'lps'),
	(489772, 128, '2014-01-15 00:06:01.000000', 'consum', 0.0218, 'lps'),
	(489773, 128, '2014-01-15 00:06:02.000000', 'consum', 0.0210, 'lps'),
	(489774, 128, '2014-01-15 00:06:03.000000', 'consum', 0.0219, 'lps'),
	(489775, 128, '2014-01-15 00:06:04.000000', 'consum', 0.0222, 'lps'),
	(489776, 128, '2014-01-15 00:06:05.000000', 'consum', 0.0212, 'lps'),
	(489777, 128, '2014-01-15 00:06:06.000000', 'consum', 0.0217, 'lps'),
	(489778, 128, '2014-01-15 00:06:07.000000', 'consum', 0.0224, 'lps'),
	(489779, 128, '2014-01-15 00:06:08.000000', 'consum', 0.0210, 'lps'),
	(489780, 128, '2014-01-15 00:06:09.000000', 'consum', 0.0219, 'lps'),
	(489781, 128, '2014-01-15 00:06:10.000000', 'consum', 0.0222, 'lps'),
	(489782, 128, '2014-01-15 00:06:11.000000', 'consum', 0.0212, 'lps'),
	(489783, 128, '2014-01-15 00:06:12.000000', 'consum', 0.0215, 'lps'),
	(489784, 128, '2014-01-15 00:06:13.000000', 'consum', 0.0214, 'lps'),
	(489785, 128, '2014-01-15 00:06:14.000000', 'consum', 0.0215, 'lps'),
	(489786, 128, '2014-01-15 00:06:15.000000', 'consum', 0.0225, 'lps'),
	(489787, 128, '2014-01-15 00:06:16.000000', 'consum', 0.0220, 'lps'),
	(489788, 128, '2014-01-15 00:06:17.000000', 'consum', 0.0217, 'lps'),
	(489789, 128, '2014-01-15 00:06:18.000000', 'consum', 0.0217, 'lps'),
	(489790, 128, '2014-01-15 00:06:19.000000', 'consum', 0.0223, 'lps'),
	(489791, 128, '2014-01-15 00:06:20.000000', 'consum', 0.0223, 'lps'),
	(489792, 128, '2014-01-15 00:06:21.000000', 'consum', 0.0218, 'lps'),
	(489793, 128, '2014-01-15 00:06:22.000000', 'consum', 0.0215, 'lps'),
	(489794, 128, '2014-01-15 00:06:23.000000', 'consum', 0.0225, 'lps'),
	(489795, 128, '2014-01-15 00:06:24.000000', 'consum', 0.0222, 'lps'),
	(489796, 128, '2014-01-15 00:06:25.000000', 'consum', 0.0212, 'lps'),
	(489797, 128, '2014-01-15 00:06:26.000000', 'consum', 0.0214, 'lps'),
	(489798, 128, '2014-01-15 00:06:27.000000', 'consum', 0.0224, 'lps'),
	(489799, 128, '2014-01-15 00:06:28.000000', 'consum', 0.0220, 'lps'),
	(489800, 128, '2014-01-15 00:06:29.000000', 'consum', 0.0221, 'lps'),
	(489801, 128, '2014-01-15 00:06:30.000000', 'consum', 0.0220, 'lps'),
	(489802, 128, '2014-01-15 00:06:31.000000', 'consum', 0.0210, 'lps'),
	(489803, 128, '2014-01-15 00:06:32.000000', 'consum', 0.0212, 'lps'),
	(489804, 128, '2014-01-15 00:06:33.000000', 'consum', 0.0220, 'lps'),
	(489805, 128, '2014-01-15 00:06:34.000000', 'consum', 0.0223, 'lps'),
	(489806, 128, '2014-01-15 00:06:35.000000', 'consum', 0.0213, 'lps'),
	(489807, 128, '2014-01-15 00:06:36.000000', 'consum', 0.0218, 'lps'),
	(489808, 128, '2014-01-15 00:06:37.000000', 'consum', 0.0211, 'lps'),
	(489809, 128, '2014-01-15 00:06:38.000000', 'consum', 0.0223, 'lps'),
	(489810, 128, '2014-01-15 00:06:39.000000', 'consum', 0.0223, 'lps'),
	(489811, 128, '2014-01-15 00:06:40.000000', 'consum', 0.0221, 'lps'),
	(489812, 128, '2014-01-15 00:06:41.000000', 'consum', 0.0211, 'lps'),
	(489813, 128, '2014-01-15 00:06:42.000000', 'consum', 0.0216, 'lps'),
	(489814, 128, '2014-01-15 00:06:43.000000', 'consum', 0.0221, 'lps'),
	(489815, 128, '2014-01-15 00:06:44.000000', 'consum', 0.0214, 'lps'),
	(489816, 128, '2014-01-15 00:06:45.000000', 'consum', 0.0216, 'lps'),
	(489817, 128, '2014-01-15 00:06:46.000000', 'consum', 0.0211, 'lps'),
	(489818, 128, '2014-01-15 00:06:47.000000', 'consum', 0.0214, 'lps'),
	(489819, 128, '2014-01-15 00:06:48.000000', 'consum', 0.0210, 'lps'),
	(489820, 128, '2014-01-15 00:06:49.000000', 'consum', 0.0215, 'lps'),
	(489821, 128, '2014-01-15 00:06:50.000000', 'consum', 0.0222, 'lps'),
	(489822, 128, '2014-01-15 00:06:51.000000', 'consum', 0.0221, 'lps'),
	(489823, 128, '2014-01-15 00:06:52.000000', 'consum', 0.0214, 'lps'),
	(489824, 128, '2014-01-15 00:06:53.000000', 'consum', 0.0214, 'lps'),
	(489825, 128, '2014-01-15 00:06:54.000000', 'consum', 0.0220, 'lps'),
	(489826, 128, '2014-01-15 00:06:55.000000', 'consum', 0.0214, 'lps'),
	(489827, 128, '2014-01-15 00:06:56.000000', 'consum', 0.0216, 'lps'),
	(489828, 128, '2014-01-15 00:06:57.000000', 'consum', 0.0215, 'lps'),
	(489829, 128, '2014-01-15 00:06:58.000000', 'consum', 0.0216, 'lps'),
	(489830, 128, '2014-01-15 00:06:59.000000', 'consum', 0.0224, 'lps'),
	(489831, 128, '2014-01-15 00:07:00.000000', 'consum', 0.0215, 'lps'),
	(489832, 128, '2014-01-15 00:07:01.000000', 'consum', 0.0225, 'lps'),
	(489833, 128, '2014-01-15 00:07:02.000000', 'consum', 0.0225, 'lps'),
	(489834, 128, '2014-01-15 00:07:03.000000', 'consum', 0.0222, 'lps'),
	(489835, 128, '2014-01-15 00:07:04.000000', 'consum', 0.0225, 'lps'),
	(489836, 128, '2014-01-15 00:07:05.000000', 'consum', 0.0218, 'lps'),
	(489837, 128, '2014-01-15 00:07:06.000000', 'consum', 0.0224, 'lps'),
	(489838, 128, '2014-01-15 00:07:07.000000', 'consum', 0.0221, 'lps'),
	(489839, 128, '2014-01-15 00:07:08.000000', 'consum', 0.0225, 'lps'),
	(489840, 128, '2014-01-15 00:07:09.000000', 'consum', 0.0220, 'lps'),
	(489841, 128, '2014-01-15 00:07:10.000000', 'consum', 0.0214, 'lps'),
	(489842, 128, '2014-01-15 00:07:11.000000', 'consum', 0.0219, 'lps'),
	(489843, 128, '2014-01-15 00:07:12.000000', 'consum', 0.0210, 'lps'),
	(489844, 128, '2014-01-15 00:07:13.000000', 'consum', 0.0215, 'lps'),
	(489845, 128, '2014-01-15 00:07:14.000000', 'consum', 0.0219, 'lps'),
	(489846, 128, '2014-01-15 00:07:15.000000', 'consum', 0.0210, 'lps'),
	(489847, 128, '2014-01-15 00:07:16.000000', 'consum', 0.0217, 'lps'),
	(489848, 128, '2014-01-15 00:07:17.000000', 'consum', 0.0211, 'lps'),
	(489849, 128, '2014-01-15 00:07:18.000000', 'consum', 0.0212, 'lps'),
	(489850, 128, '2014-01-15 00:07:19.000000', 'consum', 0.0216, 'lps'),
	(489851, 128, '2014-01-15 00:07:20.000000', 'consum', 0.0221, 'lps'),
	(489852, 128, '2014-01-15 00:07:21.000000', 'consum', 0.0213, 'lps'),
	(489853, 128, '2014-01-15 00:07:22.000000', 'consum', 0.0211, 'lps'),
	(489854, 128, '2014-01-15 00:07:23.000000', 'consum', 0.0223, 'lps'),
	(489855, 128, '2014-01-15 00:07:24.000000', 'consum', 0.0224, 'lps'),
	(489856, 128, '2014-01-15 00:07:25.000000', 'consum', 0.0223, 'lps'),
	(489857, 128, '2014-01-15 00:07:26.000000', 'consum', 0.0221, 'lps'),
	(489858, 128, '2014-01-15 00:07:27.000000', 'consum', 0.0225, 'lps'),
	(489859, 128, '2014-01-15 00:07:28.000000', 'consum', 0.0221, 'lps'),
	(489860, 128, '2014-01-15 00:07:29.000000', 'consum', 0.0222, 'lps'),
	(489861, 128, '2014-01-15 00:07:30.000000', 'consum', 0.0220, 'lps'),
	(489862, 128, '2014-01-15 00:07:31.000000', 'consum', 0.0223, 'lps'),
	(489863, 128, '2014-01-15 00:07:32.000000', 'consum', 0.0215, 'lps'),
	(489864, 128, '2014-01-15 00:07:33.000000', 'consum', 0.0212, 'lps'),
	(489865, 128, '2014-01-15 00:07:34.000000', 'consum', 0.0221, 'lps'),
	(489866, 128, '2014-01-15 00:07:35.000000', 'consum', 0.0212, 'lps'),
	(489867, 128, '2014-01-15 00:07:36.000000', 'consum', 0.0221, 'lps'),
	(489868, 128, '2014-01-15 00:07:37.000000', 'consum', 0.0211, 'lps'),
	(489869, 128, '2014-01-15 00:07:38.000000', 'consum', 0.0216, 'lps'),
	(489870, 128, '2014-01-15 00:07:39.000000', 'consum', 0.0219, 'lps'),
	(489871, 128, '2014-01-15 00:07:40.000000', 'consum', 0.0222, 'lps'),
	(489872, 128, '2014-01-15 00:07:41.000000', 'consum', 0.0213, 'lps'),
	(489873, 128, '2014-01-15 00:07:42.000000', 'consum', 0.0221, 'lps'),
	(489874, 128, '2014-01-15 00:07:43.000000', 'consum', 0.0210, 'lps'),
	(489875, 128, '2014-01-15 00:07:44.000000', 'consum', 0.0222, 'lps'),
	(489876, 128, '2014-01-15 00:07:45.000000', 'consum', 0.0225, 'lps'),
	(489877, 128, '2014-01-15 00:07:46.000000', 'consum', 0.0218, 'lps'),
	(489878, 128, '2014-01-15 00:07:47.000000', 'consum', 0.0222, 'lps'),
	(489879, 128, '2014-01-15 00:07:48.000000', 'consum', 0.0214, 'lps'),
	(489880, 128, '2014-01-15 00:07:49.000000', 'consum', 0.0210, 'lps'),
	(489881, 128, '2014-01-15 00:07:50.000000', 'consum', 0.0214, 'lps'),
	(489882, 128, '2014-01-15 00:07:51.000000', 'consum', 0.0215, 'lps'),
	(489883, 128, '2014-01-15 00:07:52.000000', 'consum', 0.0223, 'lps'),
	(489884, 128, '2014-01-15 00:07:53.000000', 'consum', 0.0215, 'lps'),
	(489885, 128, '2014-01-15 00:07:54.000000', 'consum', 0.0225, 'lps'),
	(489886, 128, '2014-01-15 00:07:55.000000', 'consum', 0.0225, 'lps'),
	(489887, 128, '2014-01-15 00:07:56.000000', 'consum', 0.0210, 'lps'),
	(489888, 128, '2014-01-15 00:07:57.000000', 'consum', 0.0211, 'lps'),
	(489889, 128, '2014-01-15 00:07:58.000000', 'consum', 0.0216, 'lps'),
	(489890, 128, '2014-01-15 00:07:59.000000', 'consum', 0.0220, 'lps'),
	(489891, 128, '2014-01-15 00:08:00.000000', 'consum', 0.0212, 'lps'),
	(489892, 128, '2014-01-15 00:08:01.000000', 'consum', 0.0223, 'lps'),
	(489893, 128, '2014-01-15 00:08:02.000000', 'consum', 0.0219, 'lps'),
	(489894, 128, '2014-01-15 00:08:03.000000', 'consum', 0.0218, 'lps'),
	(489895, 128, '2014-01-15 00:08:04.000000', 'consum', 0.0225, 'lps'),
	(489896, 128, '2014-01-15 00:08:05.000000', 'consum', 0.0213, 'lps'),
	(489897, 128, '2014-01-15 00:08:06.000000', 'consum', 0.0213, 'lps'),
	(489898, 128, '2014-01-15 00:08:07.000000', 'consum', 0.0215, 'lps'),
	(489899, 128, '2014-01-15 00:08:08.000000', 'consum', 0.0210, 'lps'),
	(489900, 128, '2014-01-15 00:08:09.000000', 'consum', 0.0214, 'lps'),
	(489901, 128, '2014-01-15 00:08:10.000000', 'consum', 0.0215, 'lps'),
	(489902, 128, '2014-01-15 00:08:11.000000', 'consum', 0.0221, 'lps'),
	(489903, 128, '2014-01-15 00:08:12.000000', 'consum', 0.0220, 'lps'),
	(489904, 128, '2014-01-15 00:08:13.000000', 'consum', 0.0211, 'lps'),
	(489905, 128, '2014-01-15 00:08:14.000000', 'consum', 0.0219, 'lps'),
	(489906, 128, '2014-01-15 00:08:15.000000', 'consum', 0.0218, 'lps'),
	(489907, 128, '2014-01-15 00:08:16.000000', 'consum', 0.0224, 'lps'),
	(489908, 128, '2014-01-15 00:08:17.000000', 'consum', 0.0224, 'lps'),
	(489909, 128, '2014-01-15 00:08:18.000000', 'consum', 0.0221, 'lps'),
	(489910, 128, '2014-01-15 00:08:19.000000', 'consum', 0.0210, 'lps'),
	(489911, 128, '2014-01-15 00:08:20.000000', 'consum', 0.0225, 'lps'),
	(489912, 128, '2014-01-15 00:08:21.000000', 'consum', 0.0223, 'lps'),
	(489913, 128, '2014-01-15 00:08:22.000000', 'consum', 0.0211, 'lps'),
	(489914, 128, '2014-01-15 00:08:23.000000', 'consum', 0.0212, 'lps'),
	(489915, 128, '2014-01-15 00:08:24.000000', 'consum', 0.0216, 'lps'),
	(489916, 128, '2014-01-15 00:08:25.000000', 'consum', 0.0219, 'lps'),
	(489917, 128, '2014-01-15 00:08:26.000000', 'consum', 0.0222, 'lps'),
	(489918, 128, '2014-01-15 00:08:27.000000', 'consum', 0.0211, 'lps'),
	(489919, 128, '2014-01-15 00:08:28.000000', 'consum', 0.0212, 'lps'),
	(489920, 128, '2014-01-15 00:08:29.000000', 'consum', 0.0216, 'lps'),
	(489921, 128, '2014-01-15 00:08:30.000000', 'consum', 0.0220, 'lps'),
	(489922, 128, '2014-01-15 00:08:31.000000', 'consum', 0.0212, 'lps'),
	(489923, 128, '2014-01-15 00:08:32.000000', 'consum', 0.0219, 'lps'),
	(489924, 128, '2014-01-15 00:08:33.000000', 'consum', 0.0219, 'lps'),
	(489925, 128, '2014-01-15 00:08:34.000000', 'consum', 0.0212, 'lps'),
	(489926, 128, '2014-01-15 00:08:35.000000', 'consum', 0.0212, 'lps'),
	(489927, 128, '2014-01-15 00:08:36.000000', 'consum', 0.0212, 'lps'),
	(489928, 128, '2014-01-15 00:08:37.000000', 'consum', 0.0214, 'lps'),
	(489929, 128, '2014-01-15 00:08:38.000000', 'consum', 0.0223, 'lps'),
	(489930, 128, '2014-01-15 00:08:39.000000', 'consum', 0.0218, 'lps'),
	(489931, 128, '2014-01-15 00:08:40.000000', 'consum', 0.0211, 'lps'),
	(489932, 128, '2014-01-15 00:08:41.000000', 'consum', 0.0223, 'lps'),
	(489933, 128, '2014-01-15 00:08:42.000000', 'consum', 0.0210, 'lps'),
	(489934, 128, '2014-01-15 00:08:43.000000', 'consum', 0.0218, 'lps'),
	(489935, 128, '2014-01-15 00:08:44.000000', 'consum', 0.0220, 'lps'),
	(489936, 128, '2014-01-15 00:08:45.000000', 'consum', 0.0220, 'lps'),
	(489937, 128, '2014-01-15 00:08:46.000000', 'consum', 0.0214, 'lps'),
	(489938, 128, '2014-01-15 00:08:47.000000', 'consum', 0.0215, 'lps'),
	(489939, 128, '2014-01-15 00:08:48.000000', 'consum', 0.0225, 'lps'),
	(489940, 128, '2014-01-15 00:08:49.000000', 'consum', 0.0221, 'lps'),
	(489941, 128, '2014-01-15 00:08:50.000000', 'consum', 0.0220, 'lps'),
	(489942, 128, '2014-01-15 00:08:51.000000', 'consum', 0.0212, 'lps'),
	(489943, 128, '2014-01-15 00:08:52.000000', 'consum', 0.0222, 'lps'),
	(489944, 128, '2014-01-15 00:08:53.000000', 'consum', 0.0219, 'lps'),
	(489945, 128, '2014-01-15 00:08:54.000000', 'consum', 0.0216, 'lps'),
	(489946, 128, '2014-01-15 00:08:55.000000', 'consum', 0.0217, 'lps'),
	(489947, 128, '2014-01-15 00:08:56.000000', 'consum', 0.0225, 'lps'),
	(489948, 128, '2014-01-15 00:08:57.000000', 'consum', 0.0217, 'lps'),
	(489949, 128, '2014-01-15 00:08:58.000000', 'consum', 0.0217, 'lps'),
	(489950, 128, '2014-01-15 00:08:59.000000', 'consum', 0.0225, 'lps'),
	(489951, 128, '2014-01-15 00:09:00.000000', 'consum', 0.0215, 'lps'),
	(489952, 128, '2014-01-15 00:09:01.000000', 'consum', 0.0224, 'lps'),
	(489953, 128, '2014-01-15 00:09:02.000000', 'consum', 0.0219, 'lps'),
	(489954, 128, '2014-01-15 00:09:03.000000', 'consum', 0.0211, 'lps'),
	(489955, 128, '2014-01-15 00:09:04.000000', 'consum', 0.0223, 'lps'),
	(489956, 128, '2014-01-15 00:09:05.000000', 'consum', 0.0222, 'lps'),
	(489957, 128, '2014-01-15 00:09:06.000000', 'consum', 0.0217, 'lps'),
	(489958, 128, '2014-01-15 00:09:07.000000', 'consum', 0.0224, 'lps'),
	(489959, 128, '2014-01-15 00:09:08.000000', 'consum', 0.0212, 'lps'),
	(489960, 128, '2014-01-15 00:09:09.000000', 'consum', 0.0212, 'lps'),
	(489961, 128, '2014-01-15 00:09:10.000000', 'consum', 0.0214, 'lps'),
	(489962, 128, '2014-01-15 00:09:11.000000', 'consum', 0.0224, 'lps'),
	(489963, 128, '2014-01-15 00:09:12.000000', 'consum', 0.0219, 'lps'),
	(489964, 128, '2014-01-15 00:09:13.000000', 'consum', 0.0215, 'lps'),
	(489965, 128, '2014-01-15 00:09:14.000000', 'consum', 0.0210, 'lps'),
	(489966, 128, '2014-01-15 00:09:15.000000', 'consum', 0.0211, 'lps'),
	(489967, 128, '2014-01-15 00:09:16.000000', 'consum', 0.0214, 'lps'),
	(489968, 128, '2014-01-15 00:09:17.000000', 'consum', 0.0212, 'lps'),
	(489969, 128, '2014-01-15 00:09:18.000000', 'consum', 0.0224, 'lps'),
	(489970, 128, '2014-01-15 00:09:19.000000', 'consum', 0.0225, 'lps'),
	(489971, 128, '2014-01-15 00:09:20.000000', 'consum', 0.0214, 'lps'),
	(489972, 128, '2014-01-15 00:09:21.000000', 'consum', 0.0215, 'lps'),
	(489973, 128, '2014-01-15 00:09:22.000000', 'consum', 0.0210, 'lps'),
	(489974, 128, '2014-01-15 00:09:23.000000', 'consum', 0.0225, 'lps'),
	(489975, 128, '2014-01-15 00:09:24.000000', 'consum', 0.0223, 'lps'),
	(489976, 128, '2014-01-15 00:09:25.000000', 'consum', 0.0213, 'lps'),
	(489977, 128, '2014-01-15 00:09:26.000000', 'consum', 0.0220, 'lps'),
	(489978, 128, '2014-01-15 00:09:27.000000', 'consum', 0.0221, 'lps'),
	(489979, 128, '2014-01-15 00:09:28.000000', 'consum', 0.0219, 'lps'),
	(489980, 128, '2014-01-15 00:09:29.000000', 'consum', 0.0220, 'lps'),
	(489981, 128, '2014-01-15 00:09:30.000000', 'consum', 0.0218, 'lps'),
	(489982, 128, '2014-01-15 00:09:31.000000', 'consum', 0.0222, 'lps'),
	(489983, 128, '2014-01-15 00:09:32.000000', 'consum', 0.0213, 'lps'),
	(489984, 128, '2014-01-15 00:09:33.000000', 'consum', 0.0223, 'lps'),
	(489985, 128, '2014-01-15 00:09:34.000000', 'consum', 0.0218, 'lps'),
	(489986, 128, '2014-01-15 00:09:35.000000', 'consum', 0.0213, 'lps'),
	(489987, 128, '2014-01-15 00:09:36.000000', 'consum', 0.0214, 'lps'),
	(489988, 128, '2014-01-15 00:09:37.000000', 'consum', 0.0224, 'lps'),
	(489989, 128, '2014-01-15 00:09:38.000000', 'consum', 0.0221, 'lps'),
	(489990, 128, '2014-01-15 00:09:39.000000', 'consum', 0.0223, 'lps'),
	(489991, 128, '2014-01-15 00:09:40.000000', 'consum', 0.0211, 'lps'),
	(489992, 128, '2014-01-15 00:09:41.000000', 'consum', 0.0222, 'lps'),
	(489993, 128, '2014-01-15 00:09:42.000000', 'consum', 0.0221, 'lps'),
	(489994, 128, '2014-01-15 00:09:43.000000', 'consum', 0.0212, 'lps'),
	(489995, 128, '2014-01-15 00:09:44.000000', 'consum', 0.0222, 'lps'),
	(489996, 128, '2014-01-15 00:09:45.000000', 'consum', 0.0215, 'lps'),
	(489997, 128, '2014-01-15 00:09:46.000000', 'consum', 0.0217, 'lps'),
	(489998, 128, '2014-01-15 00:09:47.000000', 'consum', 0.0213, 'lps'),
	(489999, 128, '2014-01-15 00:09:48.000000', 'consum', 0.0222, 'lps'),
	(490000, 128, '2014-01-15 00:09:49.000000', 'consum', 0.0212, 'lps'),
	(490001, 128, '2014-01-15 00:09:50.000000', 'consum', 0.0218, 'lps'),
	(490002, 128, '2014-01-15 00:09:51.000000', 'consum', 0.0212, 'lps'),
	(490003, 128, '2014-01-15 00:09:52.000000', 'consum', 0.0211, 'lps'),
	(490004, 128, '2014-01-15 00:09:53.000000', 'consum', 0.0211, 'lps'),
	(490005, 128, '2014-01-15 00:09:54.000000', 'consum', 0.0210, 'lps'),
	(490006, 128, '2014-01-15 00:09:55.000000', 'consum', 0.0210, 'lps'),
	(490007, 128, '2014-01-15 00:09:56.000000', 'consum', 0.0212, 'lps'),
	(490008, 128, '2014-01-15 00:09:57.000000', 'consum', 0.0218, 'lps'),
	(490009, 128, '2014-01-15 00:09:58.000000', 'consum', 0.0212, 'lps'),
	(490010, 128, '2014-01-15 00:09:59.000000', 'consum', 0.0212, 'lps'),
	(490011, 128, '2014-01-15 00:10:00.000000', 'consum', 0.0215, 'lps'),
	(490012, 128, '2014-01-15 00:10:01.000000', 'consum', 0.0212, 'lps'),
	(490013, 128, '2014-01-15 00:10:02.000000', 'consum', 0.0221, 'lps'),
	(490014, 128, '2014-01-15 00:10:03.000000', 'consum', 0.0215, 'lps'),
	(490015, 128, '2014-01-15 00:10:04.000000', 'consum', 0.0215, 'lps'),
	(490016, 128, '2014-01-15 00:10:05.000000', 'consum', 0.0224, 'lps'),
	(490017, 128, '2014-01-15 00:10:06.000000', 'consum', 0.0214, 'lps'),
	(490018, 128, '2014-01-15 00:10:07.000000', 'consum', 0.0223, 'lps'),
	(490019, 128, '2014-01-15 00:10:08.000000', 'consum', 0.0215, 'lps'),
	(490020, 128, '2014-01-15 00:10:09.000000', 'consum', 0.0213, 'lps'),
	(490021, 128, '2014-01-15 00:10:10.000000', 'consum', 0.0225, 'lps'),
	(490022, 128, '2014-01-15 00:10:11.000000', 'consum', 0.0215, 'lps'),
	(490023, 128, '2014-01-15 00:10:12.000000', 'consum', 0.0222, 'lps'),
	(490024, 128, '2014-01-15 00:10:13.000000', 'consum', 0.0224, 'lps'),
	(490025, 128, '2014-01-15 00:10:14.000000', 'consum', 0.0213, 'lps'),
	(490026, 128, '2014-01-15 00:10:15.000000', 'consum', 0.0216, 'lps'),
	(490027, 128, '2014-01-15 00:10:16.000000', 'consum', 0.0216, 'lps'),
	(490028, 128, '2014-01-15 00:10:17.000000', 'consum', 0.0220, 'lps'),
	(490029, 128, '2014-01-15 00:10:18.000000', 'consum', 0.0213, 'lps'),
	(490030, 128, '2014-01-15 00:10:19.000000', 'consum', 0.0211, 'lps'),
	(490031, 128, '2014-01-15 00:10:20.000000', 'consum', 0.0221, 'lps'),
	(490032, 128, '2014-01-15 00:10:21.000000', 'consum', 0.0217, 'lps'),
	(490033, 128, '2014-01-15 00:10:22.000000', 'consum', 0.0211, 'lps'),
	(490034, 128, '2014-01-15 00:10:23.000000', 'consum', 0.0211, 'lps'),
	(490035, 128, '2014-01-15 00:10:24.000000', 'consum', 0.0211, 'lps'),
	(490036, 128, '2014-01-15 00:10:25.000000', 'consum', 0.0212, 'lps'),
	(490037, 128, '2014-01-15 00:10:26.000000', 'consum', 0.0218, 'lps'),
	(490038, 128, '2014-01-15 00:10:27.000000', 'consum', 0.0214, 'lps'),
	(490039, 128, '2014-01-15 00:10:28.000000', 'consum', 0.0220, 'lps'),
	(490040, 128, '2014-01-15 00:10:29.000000', 'consum', 0.0219, 'lps'),
	(490041, 128, '2014-01-15 00:10:30.000000', 'consum', 0.0224, 'lps'),
	(490042, 128, '2014-01-15 00:10:31.000000', 'consum', 0.0223, 'lps'),
	(490043, 128, '2014-01-15 00:10:32.000000', 'consum', 0.0219, 'lps'),
	(490044, 128, '2014-01-15 00:10:33.000000', 'consum', 0.0213, 'lps'),
	(490045, 128, '2014-01-15 00:10:34.000000', 'consum', 0.0216, 'lps'),
	(490046, 128, '2014-01-15 00:10:35.000000', 'consum', 0.0215, 'lps'),
	(490047, 128, '2014-01-15 00:10:36.000000', 'consum', 0.0219, 'lps'),
	(490048, 128, '2014-01-15 00:10:37.000000', 'consum', 0.0222, 'lps'),
	(490049, 128, '2014-01-15 00:10:38.000000', 'consum', 0.0211, 'lps'),
	(490050, 128, '2014-01-15 00:10:39.000000', 'consum', 0.0211, 'lps'),
	(490051, 128, '2014-01-15 00:10:40.000000', 'consum', 0.0215, 'lps'),
	(490052, 128, '2014-01-15 00:10:41.000000', 'consum', 0.0215, 'lps'),
	(490053, 128, '2014-01-15 00:10:42.000000', 'consum', 0.0219, 'lps'),
	(490054, 128, '2014-01-15 00:10:43.000000', 'consum', 0.0211, 'lps'),
	(490055, 128, '2014-01-15 00:10:44.000000', 'consum', 0.0221, 'lps'),
	(490056, 128, '2014-01-15 00:10:45.000000', 'consum', 0.0214, 'lps'),
	(490057, 128, '2014-01-15 00:10:46.000000', 'consum', 0.0212, 'lps'),
	(490058, 128, '2014-01-15 00:10:47.000000', 'consum', 0.0223, 'lps'),
	(490059, 128, '2014-01-15 00:10:48.000000', 'consum', 0.0224, 'lps'),
	(490060, 128, '2014-01-15 00:10:49.000000', 'consum', 0.0225, 'lps'),
	(490061, 128, '2014-01-15 00:10:50.000000', 'consum', 0.0213, 'lps'),
	(490062, 128, '2014-01-15 00:10:51.000000', 'consum', 0.0225, 'lps'),
	(490063, 128, '2014-01-15 00:10:52.000000', 'consum', 0.0216, 'lps'),
	(490064, 128, '2014-01-15 00:10:53.000000', 'consum', 0.0225, 'lps'),
	(490065, 128, '2014-01-15 00:10:54.000000', 'consum', 0.0220, 'lps'),
	(490066, 128, '2014-01-15 00:10:55.000000', 'consum', 0.0214, 'lps'),
	(490067, 128, '2014-01-15 00:10:56.000000', 'consum', 0.0218, 'lps'),
	(490068, 128, '2014-01-15 00:10:57.000000', 'consum', 0.0223, 'lps'),
	(490069, 128, '2014-01-15 00:10:58.000000', 'consum', 0.0218, 'lps'),
	(490070, 128, '2014-01-15 00:10:59.000000', 'consum', 0.0214, 'lps'),
	(490071, 128, '2014-01-15 00:11:00.000000', 'consum', 0.0223, 'lps'),
	(490072, 128, '2014-01-15 00:11:01.000000', 'consum', 0.0213, 'lps'),
	(490073, 128, '2014-01-15 00:11:02.000000', 'consum', 0.0218, 'lps'),
	(490074, 128, '2014-01-15 00:11:03.000000', 'consum', 0.0211, 'lps'),
	(490075, 128, '2014-01-15 00:11:04.000000', 'consum', 0.0225, 'lps'),
	(490076, 128, '2014-01-15 00:11:05.000000', 'consum', 0.0216, 'lps'),
	(490077, 128, '2014-01-15 00:11:06.000000', 'consum', 0.0214, 'lps'),
	(490078, 128, '2014-01-15 00:11:07.000000', 'consum', 0.0211, 'lps'),
	(490079, 128, '2014-01-15 00:11:08.000000', 'consum', 0.0221, 'lps'),
	(490080, 128, '2014-01-15 00:11:09.000000', 'consum', 0.0214, 'lps'),
	(490081, 128, '2014-01-15 00:11:10.000000', 'consum', 0.0215, 'lps'),
	(490082, 128, '2014-01-15 00:11:11.000000', 'consum', 0.0221, 'lps'),
	(490083, 128, '2014-01-15 00:11:12.000000', 'consum', 0.0220, 'lps'),
	(490084, 128, '2014-01-15 00:11:13.000000', 'consum', 0.0225, 'lps'),
	(490085, 128, '2014-01-15 00:11:14.000000', 'consum', 0.0210, 'lps'),
	(490086, 128, '2014-01-15 00:11:15.000000', 'consum', 0.0211, 'lps'),
	(490087, 128, '2014-01-15 00:11:16.000000', 'consum', 0.0217, 'lps'),
	(490088, 128, '2014-01-15 00:11:17.000000', 'consum', 0.0210, 'lps'),
	(490089, 128, '2014-01-15 00:11:18.000000', 'consum', 0.0224, 'lps'),
	(490090, 128, '2014-01-15 00:11:19.000000', 'consum', 0.0213, 'lps'),
	(490091, 128, '2014-01-15 00:11:20.000000', 'consum', 0.0217, 'lps'),
	(490092, 128, '2014-01-15 00:11:21.000000', 'consum', 0.0219, 'lps'),
	(490093, 128, '2014-01-15 00:11:22.000000', 'consum', 0.0219, 'lps'),
	(490094, 128, '2014-01-15 00:11:23.000000', 'consum', 0.0214, 'lps'),
	(490095, 128, '2014-01-15 00:11:24.000000', 'consum', 0.0217, 'lps'),
	(490096, 128, '2014-01-15 00:11:25.000000', 'consum', 0.0218, 'lps'),
	(490097, 128, '2014-01-15 00:11:26.000000', 'consum', 0.0216, 'lps'),
	(490098, 128, '2014-01-15 00:11:27.000000', 'consum', 0.0214, 'lps'),
	(490099, 128, '2014-01-15 00:11:28.000000', 'consum', 0.0214, 'lps'),
	(490100, 128, '2014-01-15 00:11:29.000000', 'consum', 0.0217, 'lps'),
	(490101, 128, '2014-01-15 00:11:30.000000', 'consum', 0.0220, 'lps'),
	(490102, 128, '2014-01-15 00:11:31.000000', 'consum', 0.0223, 'lps'),
	(490103, 128, '2014-01-15 00:11:32.000000', 'consum', 0.0214, 'lps'),
	(490104, 128, '2014-01-15 00:11:33.000000', 'consum', 0.0224, 'lps'),
	(490105, 128, '2014-01-15 00:11:34.000000', 'consum', 0.0220, 'lps'),
	(490106, 128, '2014-01-15 00:11:35.000000', 'consum', 0.0217, 'lps'),
	(490107, 128, '2014-01-15 00:11:36.000000', 'consum', 0.0215, 'lps'),
	(490108, 128, '2014-01-15 00:11:37.000000', 'consum', 0.0217, 'lps'),
	(490109, 128, '2014-01-15 00:11:38.000000', 'consum', 0.0214, 'lps'),
	(490110, 128, '2014-01-15 00:11:39.000000', 'consum', 0.0225, 'lps'),
	(490111, 128, '2014-01-15 00:11:40.000000', 'consum', 0.0210, 'lps'),
	(490112, 128, '2014-01-15 00:11:41.000000', 'consum', 0.0212, 'lps'),
	(490113, 128, '2014-01-15 00:11:42.000000', 'consum', 0.0219, 'lps'),
	(490114, 128, '2014-01-15 00:11:43.000000', 'consum', 0.0221, 'lps'),
	(490115, 128, '2014-01-15 00:11:44.000000', 'consum', 0.0220, 'lps'),
	(490116, 128, '2014-01-15 00:11:45.000000', 'consum', 0.0211, 'lps'),
	(490117, 128, '2014-01-15 00:11:46.000000', 'consum', 0.0217, 'lps'),
	(490118, 128, '2014-01-15 00:11:47.000000', 'consum', 0.0213, 'lps'),
	(490119, 128, '2014-01-15 00:11:48.000000', 'consum', 0.0219, 'lps'),
	(490120, 128, '2014-01-15 00:11:49.000000', 'consum', 0.0215, 'lps'),
	(490121, 128, '2014-01-15 00:11:50.000000', 'consum', 0.0224, 'lps'),
	(490122, 128, '2014-01-15 00:11:51.000000', 'consum', 0.0220, 'lps'),
	(490123, 128, '2014-01-15 00:11:52.000000', 'consum', 0.0215, 'lps'),
	(490124, 128, '2014-01-15 00:11:53.000000', 'consum', 0.0224, 'lps'),
	(490125, 128, '2014-01-15 00:11:54.000000', 'consum', 0.0217, 'lps'),
	(490126, 128, '2014-01-15 00:11:55.000000', 'consum', 0.0219, 'lps'),
	(490127, 128, '2014-01-15 00:11:56.000000', 'consum', 0.0217, 'lps'),
	(490128, 128, '2014-01-15 00:11:57.000000', 'consum', 0.0222, 'lps'),
	(490129, 128, '2014-01-15 00:11:58.000000', 'consum', 0.0215, 'lps'),
	(490130, 128, '2014-01-15 00:11:59.000000', 'consum', 0.0216, 'lps'),
	(490131, 128, '2014-01-15 00:12:00.000000', 'consum', 0.0224, 'lps'),
	(490132, 128, '2014-01-15 00:12:01.000000', 'consum', 0.0214, 'lps'),
	(490133, 128, '2014-01-15 00:12:02.000000', 'consum', 0.0222, 'lps'),
	(490134, 128, '2014-01-15 00:12:03.000000', 'consum', 0.0212, 'lps'),
	(490135, 128, '2014-01-15 00:12:04.000000', 'consum', 0.0214, 'lps'),
	(490136, 128, '2014-01-15 00:12:05.000000', 'consum', 0.0210, 'lps'),
	(490137, 128, '2014-01-15 00:12:06.000000', 'consum', 0.0213, 'lps'),
	(490138, 128, '2014-01-15 00:12:07.000000', 'consum', 0.0210, 'lps'),
	(490139, 128, '2014-01-15 00:12:08.000000', 'consum', 0.0217, 'lps'),
	(490140, 128, '2014-01-15 00:12:09.000000', 'consum', 0.0213, 'lps'),
	(490141, 128, '2014-01-15 00:12:10.000000', 'consum', 0.0222, 'lps'),
	(490142, 128, '2014-01-15 00:12:11.000000', 'consum', 0.0211, 'lps'),
	(490143, 128, '2014-01-15 00:12:12.000000', 'consum', 0.0214, 'lps'),
	(490144, 128, '2014-01-15 00:12:13.000000', 'consum', 0.0211, 'lps'),
	(490145, 128, '2014-01-15 00:12:14.000000', 'consum', 0.0221, 'lps'),
	(490146, 128, '2014-01-15 00:12:15.000000', 'consum', 0.0213, 'lps'),
	(490147, 128, '2014-01-15 00:12:16.000000', 'consum', 0.0223, 'lps'),
	(490148, 128, '2014-01-15 00:12:17.000000', 'consum', 0.0220, 'lps'),
	(490149, 128, '2014-01-15 00:12:18.000000', 'consum', 0.0220, 'lps'),
	(490150, 128, '2014-01-15 00:12:19.000000', 'consum', 0.0216, 'lps'),
	(490151, 128, '2014-01-15 00:12:20.000000', 'consum', 0.0210, 'lps'),
	(490152, 128, '2014-01-15 00:12:21.000000', 'consum', 0.0224, 'lps'),
	(490153, 128, '2014-01-15 00:12:22.000000', 'consum', 0.0218, 'lps'),
	(490154, 128, '2014-01-15 00:12:23.000000', 'consum', 0.0225, 'lps'),
	(490155, 128, '2014-01-15 00:12:24.000000', 'consum', 0.0214, 'lps'),
	(490156, 128, '2014-01-15 00:12:25.000000', 'consum', 0.0216, 'lps'),
	(490157, 128, '2014-01-15 00:12:26.000000', 'consum', 0.0215, 'lps'),
	(490158, 128, '2014-01-15 00:12:27.000000', 'consum', 0.0215, 'lps'),
	(490159, 128, '2014-01-15 00:12:28.000000', 'consum', 0.0222, 'lps'),
	(490160, 128, '2014-01-15 00:12:29.000000', 'consum', 0.0224, 'lps'),
	(490161, 128, '2014-01-15 00:12:30.000000', 'consum', 0.0210, 'lps'),
	(490162, 128, '2014-01-15 00:12:31.000000', 'consum', 0.0218, 'lps'),
	(490163, 128, '2014-01-15 00:12:32.000000', 'consum', 0.0218, 'lps'),
	(490164, 128, '2014-01-15 00:12:33.000000', 'consum', 0.0212, 'lps'),
	(490165, 128, '2014-01-15 00:12:34.000000', 'consum', 0.0210, 'lps'),
	(490166, 128, '2014-01-15 00:12:35.000000', 'consum', 0.0222, 'lps'),
	(490167, 128, '2014-01-15 00:12:36.000000', 'consum', 0.0223, 'lps'),
	(490168, 128, '2014-01-15 00:12:37.000000', 'consum', 0.0221, 'lps'),
	(490169, 128, '2014-01-15 00:12:38.000000', 'consum', 0.0213, 'lps'),
	(490170, 128, '2014-01-15 00:12:39.000000', 'consum', 0.0223, 'lps'),
	(490171, 128, '2014-01-15 00:12:40.000000', 'consum', 0.0217, 'lps'),
	(490172, 128, '2014-01-15 00:12:41.000000', 'consum', 0.0225, 'lps'),
	(490173, 128, '2014-01-15 00:12:42.000000', 'consum', 0.0215, 'lps'),
	(490174, 128, '2014-01-15 00:12:43.000000', 'consum', 0.0223, 'lps'),
	(490175, 128, '2014-01-15 00:12:44.000000', 'consum', 0.0211, 'lps'),
	(490176, 128, '2014-01-15 00:12:45.000000', 'consum', 0.0224, 'lps'),
	(490177, 128, '2014-01-15 00:12:46.000000', 'consum', 0.0213, 'lps'),
	(490178, 128, '2014-01-15 00:12:47.000000', 'consum', 0.0216, 'lps'),
	(490179, 128, '2014-01-15 00:12:48.000000', 'consum', 0.0217, 'lps'),
	(490180, 128, '2014-01-15 00:12:49.000000', 'consum', 0.0210, 'lps'),
	(490181, 128, '2014-01-15 00:12:50.000000', 'consum', 0.0222, 'lps'),
	(490182, 128, '2014-01-15 00:12:51.000000', 'consum', 0.0223, 'lps'),
	(490183, 128, '2014-01-15 00:12:52.000000', 'consum', 0.0221, 'lps'),
	(490184, 128, '2014-01-15 00:12:53.000000', 'consum', 0.0214, 'lps'),
	(490185, 128, '2014-01-15 00:12:54.000000', 'consum', 0.0211, 'lps'),
	(490186, 128, '2014-01-15 00:12:55.000000', 'consum', 0.0222, 'lps'),
	(490187, 128, '2014-01-15 00:12:56.000000', 'consum', 0.0216, 'lps'),
	(490188, 128, '2014-01-15 00:12:57.000000', 'consum', 0.0224, 'lps'),
	(490189, 128, '2014-01-15 00:12:58.000000', 'consum', 0.0214, 'lps'),
	(490190, 128, '2014-01-15 00:12:59.000000', 'consum', 0.0220, 'lps'),
	(490191, 128, '2014-01-15 00:13:00.000000', 'consum', 0.0215, 'lps'),
	(490192, 128, '2014-01-15 00:13:01.000000', 'consum', 0.0224, 'lps'),
	(490193, 128, '2014-01-15 00:13:02.000000', 'consum', 0.0217, 'lps'),
	(490194, 128, '2014-01-15 00:13:03.000000', 'consum', 0.0217, 'lps'),
	(490195, 128, '2014-01-15 00:13:04.000000', 'consum', 0.0210, 'lps'),
	(490196, 128, '2014-01-15 00:13:05.000000', 'consum', 0.0222, 'lps'),
	(490197, 128, '2014-01-15 00:13:06.000000', 'consum', 0.0220, 'lps'),
	(490198, 128, '2014-01-15 00:13:07.000000', 'consum', 0.0212, 'lps'),
	(490199, 128, '2014-01-15 00:13:08.000000', 'consum', 0.0219, 'lps'),
	(490200, 128, '2014-01-15 00:13:09.000000', 'consum', 0.0219, 'lps'),
	(490201, 128, '2014-01-15 00:13:10.000000', 'consum', 0.0212, 'lps'),
	(490202, 128, '2014-01-15 00:13:11.000000', 'consum', 0.0211, 'lps'),
	(490203, 128, '2014-01-15 00:13:12.000000', 'consum', 0.0225, 'lps'),
	(490204, 128, '2014-01-15 00:13:13.000000', 'consum', 0.0217, 'lps'),
	(490205, 128, '2014-01-15 00:13:14.000000', 'consum', 0.0219, 'lps'),
	(490206, 128, '2014-01-15 00:13:15.000000', 'consum', 0.0217, 'lps'),
	(490207, 128, '2014-01-15 00:13:16.000000', 'consum', 0.0217, 'lps'),
	(490208, 128, '2014-01-15 00:13:17.000000', 'consum', 0.0224, 'lps'),
	(490209, 128, '2014-01-15 00:13:18.000000', 'consum', 0.0214, 'lps'),
	(490210, 128, '2014-01-15 00:13:19.000000', 'consum', 0.0220, 'lps'),
	(490211, 128, '2014-01-15 00:13:20.000000', 'consum', 0.0218, 'lps'),
	(490212, 128, '2014-01-15 00:13:21.000000', 'consum', 0.0220, 'lps'),
	(490213, 128, '2014-01-15 00:13:22.000000', 'consum', 0.0218, 'lps'),
	(490214, 128, '2014-01-15 00:13:23.000000', 'consum', 0.0221, 'lps'),
	(490215, 128, '2014-01-15 00:13:24.000000', 'consum', 0.0212, 'lps'),
	(490216, 128, '2014-01-15 00:13:25.000000', 'consum', 0.0217, 'lps'),
	(490217, 128, '2014-01-15 00:13:26.000000', 'consum', 0.0224, 'lps'),
	(490218, 128, '2014-01-15 00:13:27.000000', 'consum', 0.0212, 'lps'),
	(490219, 128, '2014-01-15 00:13:28.000000', 'consum', 0.0225, 'lps'),
	(490220, 128, '2014-01-15 00:13:29.000000', 'consum', 0.0216, 'lps'),
	(490221, 128, '2014-01-15 00:13:30.000000', 'consum', 0.0212, 'lps'),
	(490222, 128, '2014-01-15 00:13:31.000000', 'consum', 0.0218, 'lps'),
	(490223, 128, '2014-01-15 00:13:32.000000', 'consum', 0.0211, 'lps'),
	(490224, 128, '2014-01-15 00:13:33.000000', 'consum', 0.0225, 'lps'),
	(490225, 128, '2014-01-15 00:13:34.000000', 'consum', 0.0218, 'lps'),
	(490226, 128, '2014-01-15 00:13:35.000000', 'consum', 0.0223, 'lps'),
	(490227, 128, '2014-01-15 00:13:36.000000', 'consum', 0.0221, 'lps'),
	(490228, 128, '2014-01-15 00:13:37.000000', 'consum', 0.0223, 'lps'),
	(490229, 128, '2014-01-15 00:13:38.000000', 'consum', 0.0212, 'lps'),
	(490230, 128, '2014-01-15 00:13:39.000000', 'consum', 0.0213, 'lps'),
	(490231, 128, '2014-01-15 00:13:40.000000', 'consum', 0.0219, 'lps'),
	(490232, 128, '2014-01-15 00:13:41.000000', 'consum', 0.0215, 'lps'),
	(490233, 128, '2014-01-15 00:13:42.000000', 'consum', 0.0210, 'lps'),
	(490234, 128, '2014-01-15 00:13:43.000000', 'consum', 0.0211, 'lps'),
	(490235, 128, '2014-01-15 00:13:44.000000', 'consum', 0.0214, 'lps'),
	(490236, 128, '2014-01-15 00:13:45.000000', 'consum', 0.0211, 'lps'),
	(490237, 128, '2014-01-15 00:13:46.000000', 'consum', 0.0220, 'lps'),
	(490238, 128, '2014-01-15 00:13:47.000000', 'consum', 0.0210, 'lps'),
	(490239, 128, '2014-01-15 00:13:48.000000', 'consum', 0.0213, 'lps'),
	(490240, 128, '2014-01-15 00:13:49.000000', 'consum', 0.0225, 'lps'),
	(490241, 128, '2014-01-15 00:13:50.000000', 'consum', 0.0214, 'lps'),
	(490242, 128, '2014-01-15 00:13:51.000000', 'consum', 0.0216, 'lps'),
	(490243, 128, '2014-01-15 00:13:52.000000', 'consum', 0.0213, 'lps'),
	(490244, 128, '2014-01-15 00:13:53.000000', 'consum', 0.0225, 'lps'),
	(490245, 128, '2014-01-15 00:13:54.000000', 'consum', 0.0211, 'lps'),
	(490246, 128, '2014-01-15 00:13:55.000000', 'consum', 0.0218, 'lps'),
	(490247, 128, '2014-01-15 00:13:56.000000', 'consum', 0.0216, 'lps'),
	(490248, 128, '2014-01-15 00:13:57.000000', 'consum', 0.0216, 'lps'),
	(490249, 128, '2014-01-15 00:13:58.000000', 'consum', 0.0225, 'lps'),
	(490250, 128, '2014-01-15 00:13:59.000000', 'consum', 0.0217, 'lps'),
	(490251, 128, '2014-01-15 00:14:00.000000', 'consum', 0.0217, 'lps'),
	(490252, 128, '2014-01-15 00:14:01.000000', 'consum', 0.0224, 'lps'),
	(490253, 128, '2014-01-15 00:14:02.000000', 'consum', 0.0213, 'lps'),
	(490254, 128, '2014-01-15 00:14:03.000000', 'consum', 0.0214, 'lps'),
	(490255, 128, '2014-01-15 00:14:04.000000', 'consum', 0.0224, 'lps'),
	(490256, 128, '2014-01-15 00:14:05.000000', 'consum', 0.0218, 'lps'),
	(490257, 128, '2014-01-15 00:14:06.000000', 'consum', 0.0223, 'lps'),
	(490258, 128, '2014-01-15 00:14:07.000000', 'consum', 0.0222, 'lps'),
	(490259, 128, '2014-01-15 00:14:08.000000', 'consum', 0.0214, 'lps'),
	(490260, 128, '2014-01-15 00:14:09.000000', 'consum', 0.0212, 'lps'),
	(490261, 128, '2014-01-15 00:14:10.000000', 'consum', 0.0224, 'lps'),
	(490262, 128, '2014-01-15 00:14:11.000000', 'consum', 0.0211, 'lps'),
	(490263, 128, '2014-01-15 00:14:12.000000', 'consum', 0.0223, 'lps'),
	(490264, 128, '2014-01-15 00:14:13.000000', 'consum', 0.0223, 'lps'),
	(490265, 128, '2014-01-15 00:14:14.000000', 'consum', 0.0221, 'lps'),
	(490266, 128, '2014-01-15 00:14:15.000000', 'consum', 0.0210, 'lps'),
	(490267, 128, '2014-01-15 00:14:16.000000', 'consum', 0.0211, 'lps'),
	(490268, 128, '2014-01-15 00:14:17.000000', 'consum', 0.0214, 'lps'),
	(490269, 128, '2014-01-15 00:14:18.000000', 'consum', 0.0214, 'lps'),
	(490270, 128, '2014-01-15 00:14:19.000000', 'consum', 0.0215, 'lps'),
	(490271, 128, '2014-01-15 00:14:20.000000', 'consum', 0.0210, 'lps'),
	(490272, 128, '2014-01-15 00:14:21.000000', 'consum', 0.0212, 'lps'),
	(490273, 128, '2014-01-15 00:14:22.000000', 'consum', 0.0221, 'lps'),
	(490274, 128, '2014-01-15 00:14:23.000000', 'consum', 0.0225, 'lps'),
	(490275, 128, '2014-01-15 00:14:24.000000', 'consum', 0.0222, 'lps'),
	(490276, 128, '2014-01-15 00:14:25.000000', 'consum', 0.0223, 'lps'),
	(490277, 128, '2014-01-15 00:14:26.000000', 'consum', 0.0211, 'lps'),
	(490278, 128, '2014-01-15 00:14:27.000000', 'consum', 0.0221, 'lps'),
	(490279, 128, '2014-01-15 00:14:28.000000', 'consum', 0.0216, 'lps'),
	(490280, 128, '2014-01-15 00:14:29.000000', 'consum', 0.0224, 'lps'),
	(490281, 128, '2014-01-15 00:14:30.000000', 'consum', 0.0213, 'lps'),
	(490282, 128, '2014-01-15 00:14:31.000000', 'consum', 0.0218, 'lps'),
	(490283, 128, '2014-01-15 00:14:32.000000', 'consum', 0.0222, 'lps'),
	(490284, 128, '2014-01-15 00:14:33.000000', 'consum', 0.0217, 'lps'),
	(490285, 128, '2014-01-15 00:14:34.000000', 'consum', 0.0210, 'lps'),
	(490286, 128, '2014-01-15 00:14:35.000000', 'consum', 0.0222, 'lps'),
	(490287, 128, '2014-01-15 00:14:36.000000', 'consum', 0.0222, 'lps'),
	(490288, 128, '2014-01-15 00:14:37.000000', 'consum', 0.0220, 'lps'),
	(490289, 128, '2014-01-15 00:14:38.000000', 'consum', 0.0223, 'lps'),
	(490290, 128, '2014-01-15 00:14:39.000000', 'consum', 0.0216, 'lps'),
	(490291, 128, '2014-01-15 00:14:40.000000', 'consum', 0.0214, 'lps'),
	(490292, 128, '2014-01-15 00:14:41.000000', 'consum', 0.0213, 'lps'),
	(490293, 128, '2014-01-15 00:14:42.000000', 'consum', 0.0216, 'lps'),
	(490294, 128, '2014-01-15 00:14:43.000000', 'consum', 0.0215, 'lps'),
	(490295, 128, '2014-01-15 00:14:44.000000', 'consum', 0.0217, 'lps'),
	(490296, 128, '2014-01-15 00:14:45.000000', 'consum', 0.0216, 'lps'),
	(490297, 128, '2014-01-15 00:14:46.000000', 'consum', 0.0217, 'lps'),
	(490298, 128, '2014-01-15 00:14:47.000000', 'consum', 0.0213, 'lps'),
	(490299, 128, '2014-01-15 00:14:48.000000', 'consum', 0.0220, 'lps'),
	(490300, 128, '2014-01-15 00:14:49.000000', 'consum', 0.0218, 'lps'),
	(490301, 128, '2014-01-15 00:14:50.000000', 'consum', 0.0222, 'lps'),
	(490302, 128, '2014-01-15 00:14:51.000000', 'consum', 0.0212, 'lps'),
	(490303, 128, '2014-01-15 00:14:52.000000', 'consum', 0.0219, 'lps'),
	(490304, 128, '2014-01-15 00:14:53.000000', 'consum', 0.0215, 'lps'),
	(490305, 128, '2014-01-15 00:14:54.000000', 'consum', 0.0225, 'lps'),
	(490306, 128, '2014-01-15 00:14:55.000000', 'consum', 0.0225, 'lps'),
	(490307, 128, '2014-01-15 00:14:56.000000', 'consum', 0.0222, 'lps'),
	(490308, 128, '2014-01-15 00:14:57.000000', 'consum', 0.0212, 'lps'),
	(490309, 128, '2014-01-15 00:14:58.000000', 'consum', 0.0215, 'lps'),
	(490310, 128, '2014-01-15 00:14:59.000000', 'consum', 0.0214, 'lps'),
	(490311, 128, '2014-01-15 00:15:00.000000', 'consum', 0.0216, 'lps'),
	(490312, 128, '2014-01-15 00:15:01.000000', 'consum', 0.0212, 'lps'),
	(490313, 128, '2014-01-15 00:15:02.000000', 'consum', 0.0217, 'lps'),
	(490314, 128, '2014-01-15 00:15:03.000000', 'consum', 0.0211, 'lps'),
	(490315, 128, '2014-01-15 00:15:04.000000', 'consum', 0.0223, 'lps'),
	(490316, 128, '2014-01-15 00:15:05.000000', 'consum', 0.0210, 'lps'),
	(490317, 128, '2014-01-15 00:15:06.000000', 'consum', 0.0219, 'lps'),
	(490318, 128, '2014-01-15 00:15:07.000000', 'consum', 0.0223, 'lps'),
	(490319, 128, '2014-01-15 00:15:08.000000', 'consum', 0.0216, 'lps'),
	(490320, 128, '2014-01-15 00:15:09.000000', 'consum', 0.0216, 'lps'),
	(490321, 128, '2014-01-15 00:15:10.000000', 'consum', 0.0225, 'lps'),
	(490322, 128, '2014-01-15 00:15:11.000000', 'consum', 0.0220, 'lps'),
	(490323, 128, '2014-01-15 00:15:12.000000', 'consum', 0.0213, 'lps'),
	(490324, 128, '2014-01-15 00:15:13.000000', 'consum', 0.0211, 'lps'),
	(490325, 128, '2014-01-15 00:15:14.000000', 'consum', 0.0223, 'lps'),
	(490326, 128, '2014-01-15 00:15:15.000000', 'consum', 0.0223, 'lps'),
	(490327, 128, '2014-01-15 00:15:16.000000', 'consum', 0.0224, 'lps'),
	(490328, 128, '2014-01-15 00:15:17.000000', 'consum', 0.0224, 'lps'),
	(490329, 128, '2014-01-15 00:15:18.000000', 'consum', 0.0221, 'lps'),
	(490330, 128, '2014-01-15 00:15:19.000000', 'consum', 0.0223, 'lps'),
	(490331, 128, '2014-01-15 00:15:20.000000', 'consum', 0.0211, 'lps'),
	(490332, 128, '2014-01-15 00:15:21.000000', 'consum', 0.0224, 'lps'),
	(490333, 128, '2014-01-15 00:15:22.000000', 'consum', 0.0213, 'lps'),
	(490334, 128, '2014-01-15 00:15:23.000000', 'consum', 0.0218, 'lps'),
	(490335, 128, '2014-01-15 00:15:24.000000', 'consum', 0.0225, 'lps'),
	(490336, 128, '2014-01-15 00:15:25.000000', 'consum', 0.0214, 'lps'),
	(490337, 128, '2014-01-15 00:15:26.000000', 'consum', 0.0215, 'lps'),
	(490338, 128, '2014-01-15 00:15:27.000000', 'consum', 0.0210, 'lps'),
	(490339, 128, '2014-01-15 00:15:28.000000', 'consum', 0.0213, 'lps'),
	(490340, 128, '2014-01-15 00:15:29.000000', 'consum', 0.0222, 'lps'),
	(490341, 128, '2014-01-15 00:15:30.000000', 'consum', 0.0215, 'lps'),
	(490342, 128, '2014-01-15 00:15:31.000000', 'consum', 0.0215, 'lps'),
	(490343, 128, '2014-01-15 00:15:32.000000', 'consum', 0.0221, 'lps'),
	(490344, 128, '2014-01-15 00:15:33.000000', 'consum', 0.0217, 'lps'),
	(490345, 128, '2014-01-15 00:15:34.000000', 'consum', 0.0214, 'lps'),
	(490346, 128, '2014-01-15 00:15:35.000000', 'consum', 0.0225, 'lps'),
	(490347, 128, '2014-01-15 00:15:36.000000', 'consum', 0.0224, 'lps'),
	(490348, 128, '2014-01-15 00:15:37.000000', 'consum', 0.0221, 'lps'),
	(490349, 128, '2014-01-15 00:15:38.000000', 'consum', 0.0225, 'lps'),
	(490350, 128, '2014-01-15 00:15:39.000000', 'consum', 0.0221, 'lps'),
	(490351, 128, '2014-01-15 00:15:40.000000', 'consum', 0.0218, 'lps'),
	(490352, 128, '2014-01-15 00:15:41.000000', 'consum', 0.0217, 'lps'),
	(490353, 128, '2014-01-15 00:15:42.000000', 'consum', 0.0221, 'lps'),
	(490354, 128, '2014-01-15 00:15:43.000000', 'consum', 0.0212, 'lps'),
	(490355, 128, '2014-01-15 00:15:44.000000', 'consum', 0.0222, 'lps'),
	(490356, 128, '2014-01-15 00:15:45.000000', 'consum', 0.0215, 'lps'),
	(490357, 128, '2014-01-15 00:15:46.000000', 'consum', 0.0216, 'lps'),
	(490358, 128, '2014-01-15 00:15:47.000000', 'consum', 0.0211, 'lps'),
	(490359, 128, '2014-01-15 00:15:48.000000', 'consum', 0.0211, 'lps'),
	(490360, 128, '2014-01-15 00:15:49.000000', 'consum', 0.0215, 'lps'),
	(490361, 128, '2014-01-15 00:15:50.000000', 'consum', 0.0217, 'lps'),
	(490362, 128, '2014-01-15 00:15:51.000000', 'consum', 0.0212, 'lps'),
	(490363, 128, '2014-01-15 00:15:52.000000', 'consum', 0.0218, 'lps'),
	(490364, 128, '2014-01-15 00:15:53.000000', 'consum', 0.0212, 'lps'),
	(490365, 128, '2014-01-15 00:15:54.000000', 'consum', 0.0211, 'lps'),
	(490366, 128, '2014-01-15 00:15:55.000000', 'consum', 0.0225, 'lps'),
	(490367, 128, '2014-01-15 00:15:56.000000', 'consum', 0.0219, 'lps'),
	(490368, 128, '2014-01-15 00:15:57.000000', 'consum', 0.0210, 'lps'),
	(490369, 128, '2014-01-15 00:15:58.000000', 'consum', 0.0215, 'lps'),
	(490370, 128, '2014-01-15 00:15:59.000000', 'consum', 0.0221, 'lps'),
	(490371, 128, '2014-01-15 00:16:00.000000', 'consum', 0.0219, 'lps'),
	(490372, 128, '2014-01-15 00:16:01.000000', 'consum', 0.0223, 'lps'),
	(490373, 128, '2014-01-15 00:16:02.000000', 'consum', 0.0215, 'lps'),
	(490374, 128, '2014-01-15 00:16:03.000000', 'consum', 0.0215, 'lps'),
	(490375, 128, '2014-01-15 00:16:04.000000', 'consum', 0.0218, 'lps'),
	(490376, 128, '2014-01-15 00:16:05.000000', 'consum', 0.0221, 'lps'),
	(490377, 128, '2014-01-15 00:16:06.000000', 'consum', 0.0224, 'lps'),
	(490378, 128, '2014-01-15 00:16:07.000000', 'consum', 0.0218, 'lps'),
	(490379, 128, '2014-01-15 00:16:08.000000', 'consum', 0.0222, 'lps'),
	(490380, 128, '2014-01-15 00:16:09.000000', 'consum', 0.0216, 'lps'),
	(490381, 128, '2014-01-15 00:16:10.000000', 'consum', 0.0219, 'lps'),
	(490382, 128, '2014-01-15 00:16:11.000000', 'consum', 0.0223, 'lps'),
	(490383, 128, '2014-01-15 00:16:12.000000', 'consum', 0.0216, 'lps'),
	(490384, 128, '2014-01-15 00:16:13.000000', 'consum', 0.0218, 'lps'),
	(490385, 128, '2014-01-15 00:16:14.000000', 'consum', 0.0214, 'lps'),
	(490386, 128, '2014-01-15 00:16:15.000000', 'consum', 0.0224, 'lps'),
	(490387, 128, '2014-01-15 00:16:16.000000', 'consum', 0.0220, 'lps'),
	(490388, 128, '2014-01-15 00:16:17.000000', 'consum', 0.0220, 'lps'),
	(490389, 128, '2014-01-15 00:16:18.000000', 'consum', 0.0215, 'lps'),
	(490390, 128, '2014-01-15 00:16:19.000000', 'consum', 0.0220, 'lps'),
	(490391, 128, '2014-01-15 00:16:20.000000', 'consum', 0.0213, 'lps'),
	(490392, 128, '2014-01-15 00:16:21.000000', 'consum', 0.0212, 'lps'),
	(490393, 128, '2014-01-15 00:16:22.000000', 'consum', 0.0211, 'lps'),
	(490394, 128, '2014-01-15 00:16:23.000000', 'consum', 0.0212, 'lps'),
	(490395, 128, '2014-01-15 00:16:24.000000', 'consum', 0.0216, 'lps'),
	(490396, 128, '2014-01-15 00:16:25.000000', 'consum', 0.0219, 'lps'),
	(490397, 128, '2014-01-15 00:16:26.000000', 'consum', 0.0220, 'lps'),
	(490398, 128, '2014-01-15 00:16:27.000000', 'consum', 0.0217, 'lps'),
	(490399, 128, '2014-01-15 00:16:28.000000', 'consum', 0.0219, 'lps'),
	(490400, 128, '2014-01-15 00:16:29.000000', 'consum', 0.0215, 'lps'),
	(490401, 128, '2014-01-15 00:16:30.000000', 'consum', 0.0224, 'lps'),
	(490402, 128, '2014-01-15 00:16:31.000000', 'consum', 0.0218, 'lps'),
	(490403, 128, '2014-01-15 00:16:32.000000', 'consum', 0.0225, 'lps'),
	(490404, 128, '2014-01-15 00:16:33.000000', 'consum', 0.0212, 'lps'),
	(490405, 128, '2014-01-15 00:16:34.000000', 'consum', 0.0225, 'lps'),
	(490406, 128, '2014-01-15 00:16:35.000000', 'consum', 0.0213, 'lps'),
	(490407, 128, '2014-01-15 00:16:36.000000', 'consum', 0.0216, 'lps'),
	(490408, 128, '2014-01-15 00:16:37.000000', 'consum', 0.0212, 'lps'),
	(490409, 128, '2014-01-15 00:16:38.000000', 'consum', 0.0221, 'lps'),
	(490410, 128, '2014-01-15 00:16:39.000000', 'consum', 0.0211, 'lps'),
	(490411, 128, '2014-01-15 00:16:40.000000', 'consum', 0.0216, 'lps'),
	(490412, 128, '2014-01-15 00:16:41.000000', 'consum', 0.0223, 'lps'),
	(490413, 128, '2014-01-15 00:16:42.000000', 'consum', 0.0222, 'lps'),
	(490414, 128, '2014-01-15 00:16:43.000000', 'consum', 0.0215, 'lps'),
	(490415, 128, '2014-01-15 00:16:44.000000', 'consum', 0.0215, 'lps'),
	(490416, 128, '2014-01-15 00:16:45.000000', 'consum', 0.0220, 'lps'),
	(490417, 128, '2014-01-15 00:16:46.000000', 'consum', 0.0214, 'lps'),
	(490418, 128, '2014-01-15 00:16:47.000000', 'consum', 0.0215, 'lps'),
	(490419, 128, '2014-01-15 00:16:48.000000', 'consum', 0.0210, 'lps'),
	(490420, 128, '2014-01-15 00:16:49.000000', 'consum', 0.0213, 'lps'),
	(490421, 128, '2014-01-15 00:16:50.000000', 'consum', 0.0222, 'lps'),
	(490422, 128, '2014-01-15 00:16:51.000000', 'consum', 0.0214, 'lps'),
	(490423, 128, '2014-01-15 00:16:52.000000', 'consum', 0.0212, 'lps'),
	(490424, 128, '2014-01-15 00:16:53.000000', 'consum', 0.0224, 'lps'),
	(490425, 128, '2014-01-15 00:16:54.000000', 'consum', 0.0225, 'lps'),
	(490426, 128, '2014-01-15 00:16:55.000000', 'consum', 0.0212, 'lps'),
	(490427, 128, '2014-01-15 00:16:56.000000', 'consum', 0.0225, 'lps'),
	(490428, 128, '2014-01-15 00:16:57.000000', 'consum', 0.0213, 'lps'),
	(490429, 128, '2014-01-15 00:16:58.000000', 'consum', 0.0215, 'lps'),
	(490430, 128, '2014-01-15 00:16:59.000000', 'consum', 0.0211, 'lps'),
	(490431, 128, '2014-01-15 00:17:00.000000', 'consum', 0.0214, 'lps'),
	(490432, 128, '2014-01-15 00:17:01.000000', 'consum', 0.0214, 'lps'),
	(490433, 128, '2014-01-15 00:17:02.000000', 'consum', 0.0217, 'lps'),
	(490434, 128, '2014-01-15 00:17:03.000000', 'consum', 0.0218, 'lps'),
	(490435, 128, '2014-01-15 00:17:04.000000', 'consum', 0.0212, 'lps'),
	(490436, 128, '2014-01-15 00:17:05.000000', 'consum', 0.0212, 'lps'),
	(490437, 128, '2014-01-15 00:17:06.000000', 'consum', 0.0215, 'lps'),
	(490438, 128, '2014-01-15 00:17:07.000000', 'consum', 0.0214, 'lps'),
	(490439, 128, '2014-01-15 00:17:08.000000', 'consum', 0.0214, 'lps'),
	(490440, 128, '2014-01-15 00:17:09.000000', 'consum', 0.0220, 'lps'),
	(490441, 128, '2014-01-15 00:17:10.000000', 'consum', 0.0214, 'lps'),
	(490442, 128, '2014-01-15 00:17:11.000000', 'consum', 0.0220, 'lps'),
	(490443, 128, '2014-01-15 00:17:12.000000', 'consum', 0.0214, 'lps'),
	(490444, 128, '2014-01-15 00:17:13.000000', 'consum', 0.0219, 'lps'),
	(490445, 128, '2014-01-15 00:17:14.000000', 'consum', 0.0210, 'lps'),
	(490446, 128, '2014-01-15 00:17:15.000000', 'consum', 0.0215, 'lps'),
	(490447, 128, '2014-01-15 00:17:16.000000', 'consum', 0.0219, 'lps'),
	(490448, 128, '2014-01-15 00:17:17.000000', 'consum', 0.0224, 'lps'),
	(490449, 128, '2014-01-15 00:17:18.000000', 'consum', 0.0222, 'lps'),
	(490450, 128, '2014-01-15 00:17:19.000000', 'consum', 0.0212, 'lps'),
	(490451, 128, '2014-01-15 00:17:20.000000', 'consum', 0.0217, 'lps'),
	(490452, 128, '2014-01-15 00:17:21.000000', 'consum', 0.0223, 'lps'),
	(490453, 128, '2014-01-15 00:17:22.000000', 'consum', 0.0224, 'lps'),
	(490454, 128, '2014-01-15 00:17:23.000000', 'consum', 0.0224, 'lps'),
	(490455, 128, '2014-01-15 00:17:24.000000', 'consum', 0.0222, 'lps'),
	(490456, 128, '2014-01-15 00:17:25.000000', 'consum', 0.0211, 'lps'),
	(490457, 128, '2014-01-15 00:17:26.000000', 'consum', 0.0214, 'lps'),
	(490458, 128, '2014-01-15 00:17:27.000000', 'consum', 0.0225, 'lps'),
	(490459, 128, '2014-01-15 00:17:28.000000', 'consum', 0.0212, 'lps'),
	(490460, 128, '2014-01-15 00:17:29.000000', 'consum', 0.0221, 'lps'),
	(490461, 128, '2014-01-15 00:17:30.000000', 'consum', 0.0211, 'lps'),
	(490462, 128, '2014-01-15 00:17:31.000000', 'consum', 0.0215, 'lps'),
	(490463, 128, '2014-01-15 00:17:32.000000', 'consum', 0.0217, 'lps'),
	(490464, 128, '2014-01-15 00:17:33.000000', 'consum', 0.0214, 'lps'),
	(490465, 128, '2014-01-15 00:17:34.000000', 'consum', 0.0210, 'lps'),
	(490466, 128, '2014-01-15 00:17:35.000000', 'consum', 0.0216, 'lps'),
	(490467, 128, '2014-01-15 00:17:36.000000', 'consum', 0.0222, 'lps'),
	(490468, 128, '2014-01-15 00:17:37.000000', 'consum', 0.0222, 'lps'),
	(490469, 128, '2014-01-15 00:17:38.000000', 'consum', 0.0219, 'lps'),
	(490470, 128, '2014-01-15 00:17:39.000000', 'consum', 0.0220, 'lps'),
	(490471, 128, '2014-01-15 00:17:40.000000', 'consum', 0.0217, 'lps'),
	(490472, 128, '2014-01-15 00:17:41.000000', 'consum', 0.0213, 'lps'),
	(490473, 128, '2014-01-15 00:17:42.000000', 'consum', 0.0224, 'lps'),
	(490474, 128, '2014-01-15 00:17:43.000000', 'consum', 0.0222, 'lps'),
	(490475, 128, '2014-01-15 00:17:44.000000', 'consum', 0.0213, 'lps'),
	(490476, 128, '2014-01-15 00:17:45.000000', 'consum', 0.0221, 'lps'),
	(490477, 128, '2014-01-15 00:17:46.000000', 'consum', 0.0223, 'lps'),
	(490478, 128, '2014-01-15 00:17:47.000000', 'consum', 0.0213, 'lps'),
	(490479, 128, '2014-01-15 00:17:48.000000', 'consum', 0.0218, 'lps'),
	(490480, 128, '2014-01-15 00:17:49.000000', 'consum', 0.0224, 'lps'),
	(490481, 128, '2014-01-15 00:17:50.000000', 'consum', 0.0225, 'lps'),
	(490482, 128, '2014-01-15 00:17:51.000000', 'consum', 0.0212, 'lps'),
	(490483, 128, '2014-01-15 00:17:52.000000', 'consum', 0.0223, 'lps'),
	(490484, 128, '2014-01-15 00:17:53.000000', 'consum', 0.0224, 'lps'),
	(490485, 128, '2014-01-15 00:17:54.000000', 'consum', 0.0222, 'lps'),
	(490486, 128, '2014-01-15 00:17:55.000000', 'consum', 0.0214, 'lps'),
	(490487, 128, '2014-01-15 00:17:56.000000', 'consum', 0.0212, 'lps'),
	(490488, 128, '2014-01-15 00:17:57.000000', 'consum', 0.0223, 'lps'),
	(490489, 128, '2014-01-15 00:17:58.000000', 'consum', 0.0220, 'lps'),
	(490490, 128, '2014-01-15 00:17:59.000000', 'consum', 0.0223, 'lps'),
	(490491, 128, '2014-01-15 00:18:00.000000', 'consum', 0.0215, 'lps'),
	(490492, 128, '2014-01-15 00:18:01.000000', 'consum', 0.0211, 'lps'),
	(490493, 128, '2014-01-15 00:18:02.000000', 'consum', 0.0215, 'lps'),
	(490494, 128, '2014-01-15 00:18:03.000000', 'consum', 0.0219, 'lps'),
	(490495, 128, '2014-01-15 00:18:04.000000', 'consum', 0.0224, 'lps'),
	(490496, 128, '2014-01-15 00:18:05.000000', 'consum', 0.0220, 'lps'),
	(490497, 128, '2014-01-15 00:18:06.000000', 'consum', 0.0218, 'lps'),
	(490498, 128, '2014-01-15 00:18:07.000000', 'consum', 0.0221, 'lps'),
	(490499, 128, '2014-01-15 00:18:08.000000', 'consum', 0.0225, 'lps'),
	(490500, 128, '2014-01-15 00:18:09.000000', 'consum', 0.0220, 'lps'),
	(490501, 128, '2014-01-15 00:18:10.000000', 'consum', 0.0216, 'lps'),
	(490502, 128, '2014-01-15 00:18:11.000000', 'consum', 0.0210, 'lps'),
	(490503, 128, '2014-01-15 00:18:12.000000', 'consum', 0.0210, 'lps'),
	(490504, 128, '2014-01-15 00:18:13.000000', 'consum', 0.0210, 'lps'),
	(490505, 128, '2014-01-15 00:18:14.000000', 'consum', 0.0225, 'lps'),
	(490506, 128, '2014-01-15 00:18:15.000000', 'consum', 0.0221, 'lps'),
	(490507, 128, '2014-01-15 00:18:16.000000', 'consum', 0.0222, 'lps'),
	(490508, 128, '2014-01-15 00:18:17.000000', 'consum', 0.0223, 'lps'),
	(490509, 128, '2014-01-15 00:18:18.000000', 'consum', 0.0223, 'lps'),
	(490510, 128, '2014-01-15 00:18:19.000000', 'consum', 0.0219, 'lps'),
	(490511, 128, '2014-01-15 00:18:20.000000', 'consum', 0.0217, 'lps'),
	(490512, 128, '2014-01-15 00:18:21.000000', 'consum', 0.0219, 'lps'),
	(490513, 128, '2014-01-15 00:18:22.000000', 'consum', 0.0219, 'lps'),
	(490514, 128, '2014-01-15 00:18:23.000000', 'consum', 0.0214, 'lps'),
	(490515, 128, '2014-01-15 00:18:24.000000', 'consum', 0.0218, 'lps'),
	(490516, 128, '2014-01-15 00:18:25.000000', 'consum', 0.0223, 'lps'),
	(490517, 128, '2014-01-15 00:18:26.000000', 'consum', 0.0217, 'lps'),
	(490518, 128, '2014-01-15 00:18:27.000000', 'consum', 0.0224, 'lps'),
	(490519, 128, '2014-01-15 00:18:28.000000', 'consum', 0.0213, 'lps'),
	(490520, 128, '2014-01-15 00:18:29.000000', 'consum', 0.0214, 'lps'),
	(490521, 128, '2014-01-15 00:18:30.000000', 'consum', 0.0221, 'lps'),
	(490522, 128, '2014-01-15 00:18:31.000000', 'consum', 0.0221, 'lps'),
	(490523, 128, '2014-01-15 00:18:32.000000', 'consum', 0.0219, 'lps'),
	(490524, 128, '2014-01-15 00:18:33.000000', 'consum', 0.0219, 'lps'),
	(490525, 128, '2014-01-15 00:18:34.000000', 'consum', 0.0215, 'lps'),
	(490526, 128, '2014-01-15 00:18:35.000000', 'consum', 0.0225, 'lps'),
	(490527, 128, '2014-01-15 00:18:36.000000', 'consum', 0.0221, 'lps'),
	(490528, 128, '2014-01-15 00:18:37.000000', 'consum', 0.0222, 'lps'),
	(490529, 128, '2014-01-15 00:18:38.000000', 'consum', 0.0220, 'lps'),
	(490530, 128, '2014-01-15 00:18:39.000000', 'consum', 0.0211, 'lps'),
	(490531, 128, '2014-01-15 00:18:40.000000', 'consum', 0.0214, 'lps'),
	(490532, 128, '2014-01-15 00:18:41.000000', 'consum', 0.0214, 'lps'),
	(490533, 128, '2014-01-15 00:18:42.000000', 'consum', 0.0219, 'lps'),
	(490534, 128, '2014-01-15 00:18:43.000000', 'consum', 0.0212, 'lps'),
	(490535, 128, '2014-01-15 00:18:44.000000', 'consum', 0.0210, 'lps'),
	(490536, 128, '2014-01-15 00:18:45.000000', 'consum', 0.0219, 'lps'),
	(490537, 128, '2014-01-15 00:18:46.000000', 'consum', 0.0225, 'lps'),
	(490538, 128, '2014-01-15 00:18:47.000000', 'consum', 0.0212, 'lps'),
	(490539, 128, '2014-01-15 00:18:48.000000', 'consum', 0.0221, 'lps'),
	(490540, 128, '2014-01-15 00:18:49.000000', 'consum', 0.0211, 'lps'),
	(490541, 128, '2014-01-15 00:18:50.000000', 'consum', 0.0216, 'lps'),
	(490542, 128, '2014-01-15 00:18:51.000000', 'consum', 0.0222, 'lps'),
	(490543, 128, '2014-01-15 00:18:52.000000', 'consum', 0.0218, 'lps'),
	(490544, 128, '2014-01-15 00:18:53.000000', 'consum', 0.0218, 'lps'),
	(490545, 128, '2014-01-15 00:18:54.000000', 'consum', 0.0223, 'lps'),
	(490546, 128, '2014-01-15 00:18:55.000000', 'consum', 0.0223, 'lps'),
	(490547, 128, '2014-01-15 00:18:56.000000', 'consum', 0.0219, 'lps'),
	(490548, 128, '2014-01-15 00:18:57.000000', 'consum', 0.0216, 'lps'),
	(490549, 128, '2014-01-15 00:18:58.000000', 'consum', 0.0215, 'lps'),
	(490550, 128, '2014-01-15 00:18:59.000000', 'consum', 0.0215, 'lps'),
	(490551, 128, '2014-01-15 00:19:00.000000', 'consum', 0.0221, 'lps'),
	(490552, 128, '2014-01-15 00:19:01.000000', 'consum', 0.0220, 'lps'),
	(490553, 128, '2014-01-15 00:19:02.000000', 'consum', 0.0225, 'lps'),
	(490554, 128, '2014-01-15 00:19:03.000000', 'consum', 0.0225, 'lps'),
	(490555, 128, '2014-01-15 00:19:04.000000', 'consum', 0.0222, 'lps'),
	(490556, 128, '2014-01-15 00:19:05.000000', 'consum', 0.0213, 'lps'),
	(490557, 128, '2014-01-15 00:19:06.000000', 'consum', 0.0220, 'lps'),
	(490558, 128, '2014-01-15 00:19:07.000000', 'consum', 0.0221, 'lps'),
	(490559, 128, '2014-01-15 00:19:08.000000', 'consum', 0.0218, 'lps'),
	(490560, 128, '2014-01-15 00:19:09.000000', 'consum', 0.0216, 'lps'),
	(490561, 128, '2014-01-15 00:19:10.000000', 'consum', 0.0219, 'lps'),
	(490562, 128, '2014-01-15 00:19:11.000000', 'consum', 0.0220, 'lps'),
	(490563, 128, '2014-01-15 00:19:12.000000', 'consum', 0.0219, 'lps'),
	(490564, 128, '2014-01-15 00:19:13.000000', 'consum', 0.0211, 'lps'),
	(490565, 128, '2014-01-15 00:19:14.000000', 'consum', 0.0217, 'lps'),
	(490566, 128, '2014-01-15 00:19:15.000000', 'consum', 0.0212, 'lps'),
	(490567, 128, '2014-01-15 00:19:16.000000', 'consum', 0.0215, 'lps'),
	(490568, 128, '2014-01-15 00:19:17.000000', 'consum', 0.0212, 'lps'),
	(490569, 128, '2014-01-15 00:19:18.000000', 'consum', 0.0223, 'lps'),
	(490570, 128, '2014-01-15 00:19:19.000000', 'consum', 0.0222, 'lps'),
	(490571, 128, '2014-01-15 00:19:20.000000', 'consum', 0.0216, 'lps'),
	(490572, 128, '2014-01-15 00:19:21.000000', 'consum', 0.0220, 'lps'),
	(490573, 128, '2014-01-15 00:19:22.000000', 'consum', 0.0210, 'lps'),
	(490574, 128, '2014-01-15 00:19:23.000000', 'consum', 0.0211, 'lps'),
	(490575, 128, '2014-01-15 00:19:24.000000', 'consum', 0.0218, 'lps'),
	(490576, 128, '2014-01-15 00:19:25.000000', 'consum', 0.0214, 'lps'),
	(490577, 128, '2014-01-15 00:19:26.000000', 'consum', 0.0224, 'lps'),
	(490578, 128, '2014-01-15 00:19:27.000000', 'consum', 0.0219, 'lps'),
	(490579, 128, '2014-01-15 00:19:28.000000', 'consum', 0.0214, 'lps'),
	(490580, 128, '2014-01-15 00:19:29.000000', 'consum', 0.0219, 'lps'),
	(490581, 128, '2014-01-15 00:19:30.000000', 'consum', 0.0210, 'lps'),
	(490582, 128, '2014-01-15 00:19:31.000000', 'consum', 0.0219, 'lps'),
	(490583, 128, '2014-01-15 00:19:32.000000', 'consum', 0.0221, 'lps'),
	(490584, 128, '2014-01-15 00:19:33.000000', 'consum', 0.0221, 'lps'),
	(490585, 128, '2014-01-15 00:19:34.000000', 'consum', 0.0220, 'lps'),
	(490586, 128, '2014-01-15 00:19:35.000000', 'consum', 0.0224, 'lps'),
	(490587, 128, '2014-01-15 00:19:36.000000', 'consum', 0.0222, 'lps'),
	(490588, 128, '2014-01-15 00:19:37.000000', 'consum', 0.0225, 'lps'),
	(490589, 128, '2014-01-15 00:19:38.000000', 'consum', 0.0220, 'lps'),
	(490590, 128, '2014-01-15 00:19:39.000000', 'consum', 0.0217, 'lps'),
	(490591, 128, '2014-01-15 00:19:40.000000', 'consum', 0.0212, 'lps'),
	(490592, 128, '2014-01-15 00:19:41.000000', 'consum', 0.0218, 'lps'),
	(490593, 128, '2014-01-15 00:19:42.000000', 'consum', 0.0210, 'lps'),
	(490594, 128, '2014-01-15 00:19:43.000000', 'consum', 0.0219, 'lps'),
	(490595, 128, '2014-01-15 00:19:44.000000', 'consum', 0.0223, 'lps'),
	(490596, 128, '2014-01-15 00:19:45.000000', 'consum', 0.0215, 'lps'),
	(490597, 128, '2014-01-15 00:19:46.000000', 'consum', 0.0214, 'lps'),
	(490598, 128, '2014-01-15 00:19:47.000000', 'consum', 0.0217, 'lps'),
	(490599, 128, '2014-01-15 00:19:48.000000', 'consum', 0.0215, 'lps'),
	(490600, 128, '2014-01-15 00:19:49.000000', 'consum', 0.0214, 'lps'),
	(490601, 128, '2014-01-15 00:19:50.000000', 'consum', 0.0218, 'lps'),
	(490602, 128, '2014-01-15 00:19:51.000000', 'consum', 0.0222, 'lps'),
	(490603, 128, '2014-01-15 00:19:52.000000', 'consum', 0.0215, 'lps'),
	(490604, 128, '2014-01-15 00:19:53.000000', 'consum', 0.0214, 'lps'),
	(490605, 128, '2014-01-15 00:19:54.000000', 'consum', 0.0218, 'lps'),
	(490606, 128, '2014-01-15 00:19:55.000000', 'consum', 0.0220, 'lps'),
	(490607, 128, '2014-01-15 00:19:56.000000', 'consum', 0.0221, 'lps'),
	(490608, 128, '2014-01-15 00:19:57.000000', 'consum', 0.0218, 'lps'),
	(490609, 128, '2014-01-15 00:19:58.000000', 'consum', 0.0218, 'lps'),
	(490610, 128, '2014-01-15 00:19:59.000000', 'consum', 0.0211, 'lps'),
	(490611, 128, '2014-01-15 00:20:00.000000', 'consum', 0.0223, 'lps'),
	(490612, 128, '2014-01-15 00:20:01.000000', 'consum', 0.0211, 'lps'),
	(490613, 128, '2014-01-15 00:20:02.000000', 'consum', 0.0221, 'lps'),
	(490614, 128, '2014-01-15 00:20:03.000000', 'consum', 0.0218, 'lps'),
	(490615, 128, '2014-01-15 00:20:04.000000', 'consum', 0.0215, 'lps'),
	(490616, 128, '2014-01-15 00:20:05.000000', 'consum', 0.0214, 'lps'),
	(490617, 128, '2014-01-15 00:20:06.000000', 'consum', 0.0213, 'lps'),
	(490618, 128, '2014-01-15 00:20:07.000000', 'consum', 0.0215, 'lps'),
	(490619, 128, '2014-01-15 00:20:08.000000', 'consum', 0.0210, 'lps'),
	(490620, 128, '2014-01-15 00:20:09.000000', 'consum', 0.0225, 'lps'),
	(490621, 128, '2014-01-15 00:20:10.000000', 'consum', 0.0225, 'lps'),
	(490622, 128, '2014-01-15 00:20:11.000000', 'consum', 0.0224, 'lps'),
	(490623, 128, '2014-01-15 00:20:12.000000', 'consum', 0.0220, 'lps'),
	(490624, 128, '2014-01-15 00:20:13.000000', 'consum', 0.0219, 'lps'),
	(490625, 128, '2014-01-15 00:20:14.000000', 'consum', 0.0224, 'lps'),
	(490626, 128, '2014-01-15 00:20:15.000000', 'consum', 0.0222, 'lps'),
	(490627, 128, '2014-01-15 00:20:16.000000', 'consum', 0.0214, 'lps'),
	(490628, 128, '2014-01-15 00:20:17.000000', 'consum', 0.0224, 'lps'),
	(490629, 128, '2014-01-15 00:20:18.000000', 'consum', 0.0223, 'lps'),
	(490630, 128, '2014-01-15 00:20:19.000000', 'consum', 0.0215, 'lps'),
	(490631, 128, '2014-01-15 00:20:20.000000', 'consum', 0.0215, 'lps'),
	(490632, 128, '2014-01-15 00:20:21.000000', 'consum', 0.0217, 'lps'),
	(490633, 128, '2014-01-15 00:20:22.000000', 'consum', 0.0218, 'lps'),
	(490634, 128, '2014-01-15 00:20:23.000000', 'consum', 0.0213, 'lps'),
	(490635, 128, '2014-01-15 00:20:24.000000', 'consum', 0.0215, 'lps'),
	(490636, 128, '2014-01-15 00:20:25.000000', 'consum', 0.0213, 'lps'),
	(490637, 128, '2014-01-15 00:20:26.000000', 'consum', 0.0211, 'lps'),
	(490638, 128, '2014-01-15 00:20:27.000000', 'consum', 0.0222, 'lps'),
	(490639, 128, '2014-01-15 00:20:28.000000', 'consum', 0.0221, 'lps'),
	(490640, 128, '2014-01-15 00:20:29.000000', 'consum', 0.0213, 'lps'),
	(490641, 128, '2014-01-15 00:20:30.000000', 'consum', 0.0222, 'lps'),
	(490642, 128, '2014-01-15 00:20:31.000000', 'consum', 0.0214, 'lps'),
	(490643, 128, '2014-01-15 00:20:32.000000', 'consum', 0.0213, 'lps'),
	(490644, 128, '2014-01-15 00:20:33.000000', 'consum', 0.0210, 'lps'),
	(490645, 128, '2014-01-15 00:20:34.000000', 'consum', 0.0219, 'lps'),
	(490646, 128, '2014-01-15 00:20:35.000000', 'consum', 0.0210, 'lps'),
	(490647, 128, '2014-01-15 00:20:36.000000', 'consum', 0.0212, 'lps'),
	(490648, 128, '2014-01-15 00:20:37.000000', 'consum', 0.0220, 'lps'),
	(490649, 128, '2014-01-15 00:20:38.000000', 'consum', 0.0225, 'lps'),
	(490650, 128, '2014-01-15 00:20:39.000000', 'consum', 0.0222, 'lps'),
	(490651, 128, '2014-01-15 00:20:40.000000', 'consum', 0.0225, 'lps'),
	(490652, 128, '2014-01-15 00:20:41.000000', 'consum', 0.0219, 'lps'),
	(490653, 128, '2014-01-15 00:20:42.000000', 'consum', 0.0211, 'lps'),
	(490654, 128, '2014-01-15 00:20:43.000000', 'consum', 0.0218, 'lps'),
	(490655, 128, '2014-01-15 00:20:44.000000', 'consum', 0.0216, 'lps'),
	(490656, 128, '2014-01-15 00:20:45.000000', 'consum', 0.0217, 'lps'),
	(490657, 128, '2014-01-15 00:20:46.000000', 'consum', 0.0210, 'lps'),
	(490658, 128, '2014-01-15 00:20:47.000000', 'consum', 0.0223, 'lps'),
	(490659, 128, '2014-01-15 00:20:48.000000', 'consum', 0.0213, 'lps'),
	(490660, 128, '2014-01-15 00:20:49.000000', 'consum', 0.0217, 'lps'),
	(490661, 128, '2014-01-15 00:20:50.000000', 'consum', 0.0219, 'lps'),
	(490662, 128, '2014-01-15 00:20:51.000000', 'consum', 0.0221, 'lps'),
	(490663, 128, '2014-01-15 00:20:52.000000', 'consum', 0.0221, 'lps'),
	(490664, 128, '2014-01-15 00:20:53.000000', 'consum', 0.0218, 'lps'),
	(490665, 128, '2014-01-15 00:20:54.000000', 'consum', 0.0217, 'lps'),
	(490666, 128, '2014-01-15 00:20:55.000000', 'consum', 0.0220, 'lps'),
	(490667, 128, '2014-01-15 00:20:56.000000', 'consum', 0.0210, 'lps'),
	(490668, 128, '2014-01-15 00:20:57.000000', 'consum', 0.0213, 'lps'),
	(490669, 128, '2014-01-15 00:20:58.000000', 'consum', 0.0223, 'lps'),
	(490670, 128, '2014-01-15 00:20:59.000000', 'consum', 0.0221, 'lps'),
	(490671, 128, '2014-01-15 00:21:00.000000', 'consum', 0.0210, 'lps'),
	(490672, 128, '2014-01-15 00:21:01.000000', 'consum', 0.0225, 'lps'),
	(490673, 128, '2014-01-15 00:21:02.000000', 'consum', 0.0220, 'lps'),
	(490674, 128, '2014-01-15 00:21:03.000000', 'consum', 0.0215, 'lps'),
	(490675, 128, '2014-01-15 00:21:04.000000', 'consum', 0.0221, 'lps'),
	(490676, 128, '2014-01-15 00:21:05.000000', 'consum', 0.0220, 'lps'),
	(490677, 128, '2014-01-15 00:21:06.000000', 'consum', 0.0213, 'lps'),
	(490678, 128, '2014-01-15 00:21:07.000000', 'consum', 0.0211, 'lps'),
	(490679, 128, '2014-01-15 00:21:08.000000', 'consum', 0.0222, 'lps'),
	(490680, 128, '2014-01-15 00:21:09.000000', 'consum', 0.0220, 'lps'),
	(490681, 128, '2014-01-15 00:21:10.000000', 'consum', 0.0224, 'lps'),
	(490682, 128, '2014-01-15 00:21:11.000000', 'consum', 0.0220, 'lps'),
	(490683, 128, '2014-01-15 00:21:12.000000', 'consum', 0.0218, 'lps'),
	(490684, 128, '2014-01-15 00:21:13.000000', 'consum', 0.0221, 'lps'),
	(490685, 128, '2014-01-15 00:21:14.000000', 'consum', 0.0223, 'lps'),
	(490686, 128, '2014-01-15 00:21:15.000000', 'consum', 0.0213, 'lps'),
	(490687, 128, '2014-01-15 00:21:16.000000', 'consum', 0.0218, 'lps'),
	(490688, 128, '2014-01-15 00:21:17.000000', 'consum', 0.0210, 'lps'),
	(490689, 128, '2014-01-15 00:21:18.000000', 'consum', 0.0219, 'lps'),
	(490690, 128, '2014-01-15 00:21:19.000000', 'consum', 0.0225, 'lps'),
	(490691, 128, '2014-01-15 00:21:20.000000', 'consum', 0.0223, 'lps'),
	(490692, 128, '2014-01-15 00:21:21.000000', 'consum', 0.0216, 'lps'),
	(490693, 128, '2014-01-15 00:21:22.000000', 'consum', 0.0219, 'lps'),
	(490694, 128, '2014-01-15 00:21:23.000000', 'consum', 0.0221, 'lps'),
	(490695, 128, '2014-01-15 00:21:24.000000', 'consum', 0.0223, 'lps'),
	(490696, 128, '2014-01-15 00:21:25.000000', 'consum', 0.0212, 'lps'),
	(490697, 128, '2014-01-15 00:21:26.000000', 'consum', 0.0211, 'lps'),
	(490698, 128, '2014-01-15 00:21:27.000000', 'consum', 0.0211, 'lps'),
	(490699, 128, '2014-01-15 00:21:28.000000', 'consum', 0.0211, 'lps'),
	(490700, 128, '2014-01-15 00:21:29.000000', 'consum', 0.0212, 'lps'),
	(490701, 128, '2014-01-15 00:21:30.000000', 'consum', 0.0218, 'lps'),
	(490702, 128, '2014-01-15 00:21:31.000000', 'consum', 0.0213, 'lps'),
	(490703, 128, '2014-01-15 00:21:32.000000', 'consum', 0.0217, 'lps'),
	(490704, 128, '2014-01-15 00:21:33.000000', 'consum', 0.0219, 'lps'),
	(490705, 128, '2014-01-15 00:21:34.000000', 'consum', 0.0220, 'lps'),
	(490706, 128, '2014-01-15 00:21:35.000000', 'consum', 0.0216, 'lps'),
	(490707, 128, '2014-01-15 00:21:36.000000', 'consum', 0.0210, 'lps'),
	(490708, 128, '2014-01-15 00:21:37.000000', 'consum', 0.0211, 'lps'),
	(490709, 128, '2014-01-15 00:21:38.000000', 'consum', 0.0212, 'lps'),
	(490710, 128, '2014-01-15 00:21:39.000000', 'consum', 0.0221, 'lps'),
	(490711, 128, '2014-01-15 00:21:40.000000', 'consum', 0.0211, 'lps'),
	(490712, 128, '2014-01-15 00:21:41.000000', 'consum', 0.0213, 'lps'),
	(490713, 128, '2014-01-15 00:21:42.000000', 'consum', 0.0221, 'lps'),
	(490714, 128, '2014-01-15 00:21:43.000000', 'consum', 0.0211, 'lps'),
	(490715, 128, '2014-01-15 00:21:44.000000', 'consum', 0.0214, 'lps'),
	(490716, 128, '2014-01-15 00:21:45.000000', 'consum', 0.0212, 'lps'),
	(490717, 128, '2014-01-15 00:21:46.000000', 'consum', 0.0223, 'lps'),
	(490718, 128, '2014-01-15 00:21:47.000000', 'consum', 0.0221, 'lps'),
	(490719, 128, '2014-01-15 00:21:48.000000', 'consum', 0.0211, 'lps'),
	(490720, 128, '2014-01-15 00:21:49.000000', 'consum', 0.0216, 'lps'),
	(490721, 128, '2014-01-15 00:21:50.000000', 'consum', 0.0221, 'lps'),
	(490722, 128, '2014-01-15 00:21:51.000000', 'consum', 0.0216, 'lps'),
	(490723, 128, '2014-01-15 00:21:52.000000', 'consum', 0.0223, 'lps'),
	(490724, 128, '2014-01-15 00:21:53.000000', 'consum', 0.0210, 'lps'),
	(490725, 128, '2014-01-15 00:21:54.000000', 'consum', 0.0220, 'lps'),
	(490726, 128, '2014-01-15 00:21:55.000000', 'consum', 0.0213, 'lps'),
	(490727, 128, '2014-01-15 00:21:56.000000', 'consum', 0.0212, 'lps'),
	(490728, 128, '2014-01-15 00:21:57.000000', 'consum', 0.0211, 'lps'),
	(490729, 128, '2014-01-15 00:21:58.000000', 'consum', 0.0224, 'lps'),
	(490730, 128, '2014-01-15 00:21:59.000000', 'consum', 0.0215, 'lps'),
	(490731, 128, '2014-01-15 00:22:00.000000', 'consum', 0.0223, 'lps'),
	(490732, 128, '2014-01-15 00:22:01.000000', 'consum', 0.0215, 'lps'),
	(490733, 128, '2014-01-15 00:22:02.000000', 'consum', 0.0211, 'lps'),
	(490734, 128, '2014-01-15 00:22:03.000000', 'consum', 0.0217, 'lps'),
	(490735, 128, '2014-01-15 00:22:04.000000', 'consum', 0.0225, 'lps'),
	(490736, 128, '2014-01-15 00:22:05.000000', 'consum', 0.0218, 'lps'),
	(490737, 128, '2014-01-15 00:22:06.000000', 'consum', 0.0223, 'lps'),
	(490738, 128, '2014-01-15 00:22:07.000000', 'consum', 0.0216, 'lps'),
	(490739, 128, '2014-01-15 00:22:08.000000', 'consum', 0.0221, 'lps'),
	(490740, 128, '2014-01-15 00:22:09.000000', 'consum', 0.0212, 'lps'),
	(490741, 128, '2014-01-15 00:22:10.000000', 'consum', 0.0221, 'lps'),
	(490742, 128, '2014-01-15 00:22:11.000000', 'consum', 0.0213, 'lps'),
	(490743, 128, '2014-01-15 00:22:12.000000', 'consum', 0.0222, 'lps'),
	(490744, 128, '2014-01-15 00:22:13.000000', 'consum', 0.0216, 'lps'),
	(490745, 128, '2014-01-15 00:22:14.000000', 'consum', 0.0221, 'lps'),
	(490746, 128, '2014-01-15 00:22:15.000000', 'consum', 0.0213, 'lps'),
	(490747, 128, '2014-01-15 00:22:16.000000', 'consum', 0.0211, 'lps'),
	(490748, 128, '2014-01-15 00:22:17.000000', 'consum', 0.0220, 'lps'),
	(490749, 128, '2014-01-15 00:22:18.000000', 'consum', 0.0212, 'lps'),
	(490750, 128, '2014-01-15 00:22:19.000000', 'consum', 0.0221, 'lps'),
	(490751, 128, '2014-01-15 00:22:20.000000', 'consum', 0.0212, 'lps'),
	(490752, 128, '2014-01-15 00:22:21.000000', 'consum', 0.0220, 'lps'),
	(490753, 128, '2014-01-15 00:22:22.000000', 'consum', 0.0222, 'lps'),
	(490754, 128, '2014-01-15 00:22:23.000000', 'consum', 0.0223, 'lps'),
	(490755, 128, '2014-01-15 00:22:24.000000', 'consum', 0.0223, 'lps'),
	(490756, 128, '2014-01-15 00:22:25.000000', 'consum', 0.0220, 'lps'),
	(490757, 128, '2014-01-15 00:22:26.000000', 'consum', 0.0221, 'lps'),
	(490758, 128, '2014-01-15 00:22:27.000000', 'consum', 0.0222, 'lps'),
	(490759, 128, '2014-01-15 00:22:28.000000', 'consum', 0.0223, 'lps'),
	(490760, 128, '2014-01-15 00:22:29.000000', 'consum', 0.0220, 'lps'),
	(490761, 128, '2014-01-15 00:22:30.000000', 'consum', 0.0222, 'lps'),
	(490762, 128, '2014-01-15 00:22:31.000000', 'consum', 0.0210, 'lps'),
	(490763, 128, '2014-01-15 00:22:32.000000', 'consum', 0.0220, 'lps'),
	(490764, 128, '2014-01-15 00:22:33.000000', 'consum', 0.0216, 'lps'),
	(490765, 128, '2014-01-15 00:22:34.000000', 'consum', 0.0223, 'lps'),
	(490766, 128, '2014-01-15 00:22:35.000000', 'consum', 0.0212, 'lps'),
	(490767, 128, '2014-01-15 00:22:36.000000', 'consum', 0.0213, 'lps'),
	(490768, 128, '2014-01-15 00:22:37.000000', 'consum', 0.0217, 'lps'),
	(490769, 128, '2014-01-15 00:22:38.000000', 'consum', 0.0223, 'lps'),
	(490770, 128, '2014-01-15 00:22:39.000000', 'consum', 0.0222, 'lps'),
	(490771, 128, '2014-01-15 00:22:40.000000', 'consum', 0.0214, 'lps'),
	(490772, 128, '2014-01-15 00:22:41.000000', 'consum', 0.0212, 'lps'),
	(490773, 128, '2014-01-15 00:22:42.000000', 'consum', 0.0210, 'lps'),
	(490774, 128, '2014-01-15 00:22:43.000000', 'consum', 0.0218, 'lps'),
	(490775, 128, '2014-01-15 00:22:44.000000', 'consum', 0.0219, 'lps'),
	(490776, 128, '2014-01-15 00:22:45.000000', 'consum', 0.0217, 'lps'),
	(490777, 128, '2014-01-15 00:22:46.000000', 'consum', 0.0219, 'lps'),
	(490778, 128, '2014-01-15 00:22:47.000000', 'consum', 0.0216, 'lps'),
	(490779, 128, '2014-01-15 00:22:48.000000', 'consum', 0.0214, 'lps'),
	(490780, 128, '2014-01-15 00:22:49.000000', 'consum', 0.0211, 'lps'),
	(490781, 128, '2014-01-15 00:22:50.000000', 'consum', 0.0222, 'lps'),
	(490782, 128, '2014-01-15 00:22:51.000000', 'consum', 0.0220, 'lps'),
	(490783, 128, '2014-01-15 00:22:52.000000', 'consum', 0.0224, 'lps'),
	(490784, 128, '2014-01-15 00:22:53.000000', 'consum', 0.0217, 'lps'),
	(490785, 128, '2014-01-15 00:22:54.000000', 'consum', 0.0221, 'lps'),
	(490786, 128, '2014-01-15 00:22:55.000000', 'consum', 0.0214, 'lps'),
	(490787, 128, '2014-01-15 00:22:56.000000', 'consum', 0.0210, 'lps'),
	(490788, 128, '2014-01-15 00:22:57.000000', 'consum', 0.0216, 'lps'),
	(490789, 128, '2014-01-15 00:22:58.000000', 'consum', 0.0210, 'lps'),
	(490790, 128, '2014-01-15 00:22:59.000000', 'consum', 0.0222, 'lps'),
	(490791, 128, '2014-01-15 00:23:00.000000', 'consum', 0.0224, 'lps'),
	(490792, 128, '2014-01-15 00:23:01.000000', 'consum', 0.0213, 'lps'),
	(490793, 128, '2014-01-15 00:23:02.000000', 'consum', 0.0215, 'lps'),
	(490794, 128, '2014-01-15 00:23:03.000000', 'consum', 0.0225, 'lps'),
	(490795, 128, '2014-01-15 00:23:04.000000', 'consum', 0.0224, 'lps'),
	(490796, 128, '2014-01-15 00:23:05.000000', 'consum', 0.0217, 'lps'),
	(490797, 128, '2014-01-15 00:23:06.000000', 'consum', 0.0222, 'lps'),
	(490798, 128, '2014-01-15 00:23:07.000000', 'consum', 0.0219, 'lps'),
	(490799, 128, '2014-01-15 00:23:08.000000', 'consum', 0.0216, 'lps'),
	(490800, 128, '2014-01-15 00:23:09.000000', 'consum', 0.0215, 'lps'),
	(490801, 128, '2014-01-15 00:23:10.000000', 'consum', 0.0215, 'lps'),
	(490802, 128, '2014-01-15 00:23:11.000000', 'consum', 0.0224, 'lps'),
	(490803, 128, '2014-01-15 00:23:12.000000', 'consum', 0.0216, 'lps'),
	(490804, 128, '2014-01-15 00:23:13.000000', 'consum', 0.0214, 'lps'),
	(490805, 128, '2014-01-15 00:23:14.000000', 'consum', 0.0213, 'lps'),
	(490806, 128, '2014-01-15 00:23:15.000000', 'consum', 0.0216, 'lps'),
	(490807, 128, '2014-01-15 00:23:16.000000', 'consum', 0.0212, 'lps'),
	(490808, 128, '2014-01-15 00:23:17.000000', 'consum', 0.0218, 'lps'),
	(490809, 128, '2014-01-15 00:23:18.000000', 'consum', 0.0215, 'lps'),
	(490810, 128, '2014-01-15 00:23:19.000000', 'consum', 0.0225, 'lps'),
	(490811, 128, '2014-01-15 00:23:20.000000', 'consum', 0.0223, 'lps'),
	(490812, 128, '2014-01-15 00:23:21.000000', 'consum', 0.0215, 'lps'),
	(490813, 128, '2014-01-15 00:23:22.000000', 'consum', 0.0211, 'lps'),
	(490814, 128, '2014-01-15 00:23:23.000000', 'consum', 0.0219, 'lps'),
	(490815, 128, '2014-01-15 00:23:24.000000', 'consum', 0.0221, 'lps'),
	(490816, 128, '2014-01-15 00:23:25.000000', 'consum', 0.0221, 'lps'),
	(490817, 128, '2014-01-15 00:23:26.000000', 'consum', 0.0217, 'lps'),
	(490818, 128, '2014-01-15 00:23:27.000000', 'consum', 0.0211, 'lps'),
	(490819, 128, '2014-01-15 00:23:28.000000', 'consum', 0.0213, 'lps'),
	(490820, 128, '2014-01-15 00:23:29.000000', 'consum', 0.0223, 'lps'),
	(490821, 128, '2014-01-15 00:23:30.000000', 'consum', 0.0217, 'lps'),
	(490822, 128, '2014-01-15 00:23:31.000000', 'consum', 0.0224, 'lps'),
	(490823, 128, '2014-01-15 00:23:32.000000', 'consum', 0.0210, 'lps'),
	(490824, 128, '2014-01-15 00:23:33.000000', 'consum', 0.0218, 'lps'),
	(490825, 128, '2014-01-15 00:23:34.000000', 'consum', 0.0219, 'lps'),
	(490826, 128, '2014-01-15 00:23:35.000000', 'consum', 0.0213, 'lps'),
	(490827, 128, '2014-01-15 00:23:36.000000', 'consum', 0.0216, 'lps'),
	(490828, 128, '2014-01-15 00:23:37.000000', 'consum', 0.0214, 'lps'),
	(490829, 128, '2014-01-15 00:23:38.000000', 'consum', 0.0212, 'lps'),
	(490830, 128, '2014-01-15 00:23:39.000000', 'consum', 0.0210, 'lps'),
	(490831, 128, '2014-01-15 00:23:40.000000', 'consum', 0.0220, 'lps'),
	(490832, 128, '2014-01-15 00:23:41.000000', 'consum', 0.0213, 'lps'),
	(490833, 128, '2014-01-15 00:23:42.000000', 'consum', 0.0211, 'lps'),
	(490834, 128, '2014-01-15 00:23:43.000000', 'consum', 0.0223, 'lps'),
	(490835, 128, '2014-01-15 00:23:44.000000', 'consum', 0.0225, 'lps'),
	(490836, 128, '2014-01-15 00:23:45.000000', 'consum', 0.0212, 'lps'),
	(490837, 128, '2014-01-15 00:23:46.000000', 'consum', 0.0210, 'lps'),
	(490838, 128, '2014-01-15 00:23:47.000000', 'consum', 0.0221, 'lps'),
	(490839, 128, '2014-01-15 00:23:48.000000', 'consum', 0.0217, 'lps'),
	(490840, 128, '2014-01-15 00:23:49.000000', 'consum', 0.0210, 'lps'),
	(490841, 128, '2014-01-15 00:23:50.000000', 'consum', 0.0224, 'lps'),
	(490842, 128, '2014-01-15 00:23:51.000000', 'consum', 0.0215, 'lps'),
	(490843, 128, '2014-01-15 00:23:52.000000', 'consum', 0.0225, 'lps'),
	(490844, 128, '2014-01-15 00:23:53.000000', 'consum', 0.0223, 'lps'),
	(490845, 128, '2014-01-15 00:23:54.000000', 'consum', 0.0214, 'lps'),
	(490846, 128, '2014-01-15 00:23:55.000000', 'consum', 0.0223, 'lps'),
	(490847, 128, '2014-01-15 00:23:56.000000', 'consum', 0.0217, 'lps'),
	(490848, 128, '2014-01-15 00:23:57.000000', 'consum', 0.0224, 'lps'),
	(490849, 128, '2014-01-15 00:23:58.000000', 'consum', 0.0210, 'lps'),
	(490850, 128, '2014-01-15 00:23:59.000000', 'consum', 0.0215, 'lps'),
	(490851, 128, '2014-01-15 00:24:00.000000', 'consum', 0.0219, 'lps'),
	(490852, 128, '2014-01-15 00:24:01.000000', 'consum', 0.0224, 'lps'),
	(490853, 128, '2014-01-15 00:24:02.000000', 'consum', 0.0224, 'lps'),
	(490854, 128, '2014-01-15 00:24:03.000000', 'consum', 0.0224, 'lps'),
	(490855, 128, '2014-01-15 00:24:04.000000', 'consum', 0.0219, 'lps'),
	(490856, 128, '2014-01-15 00:24:05.000000', 'consum', 0.0214, 'lps'),
	(490857, 128, '2014-01-15 00:24:06.000000', 'consum', 0.0222, 'lps'),
	(490858, 128, '2014-01-15 00:24:07.000000', 'consum', 0.0225, 'lps'),
	(490859, 128, '2014-01-15 00:24:08.000000', 'consum', 0.0219, 'lps'),
	(490860, 128, '2014-01-15 00:24:09.000000', 'consum', 0.0210, 'lps'),
	(490861, 128, '2014-01-15 00:24:10.000000', 'consum', 0.0216, 'lps'),
	(490862, 128, '2014-01-15 00:24:11.000000', 'consum', 0.0225, 'lps'),
	(490863, 128, '2014-01-15 00:24:12.000000', 'consum', 0.0218, 'lps'),
	(490864, 128, '2014-01-15 00:24:13.000000', 'consum', 0.0224, 'lps'),
	(490865, 128, '2014-01-15 00:24:14.000000', 'consum', 0.0223, 'lps'),
	(490866, 128, '2014-01-15 00:24:15.000000', 'consum', 0.0218, 'lps'),
	(490867, 128, '2014-01-15 00:24:16.000000', 'consum', 0.0212, 'lps'),
	(490868, 128, '2014-01-15 00:24:17.000000', 'consum', 0.0211, 'lps'),
	(490869, 128, '2014-01-15 00:24:18.000000', 'consum', 0.0210, 'lps'),
	(490870, 128, '2014-01-15 00:24:19.000000', 'consum', 0.0222, 'lps'),
	(490871, 128, '2014-01-15 00:24:20.000000', 'consum', 0.0222, 'lps'),
	(490872, 128, '2014-01-15 00:24:21.000000', 'consum', 0.0222, 'lps'),
	(490873, 128, '2014-01-15 00:24:22.000000', 'consum', 0.0215, 'lps'),
	(490874, 128, '2014-01-15 00:24:23.000000', 'consum', 0.0217, 'lps'),
	(490875, 128, '2014-01-15 00:24:24.000000', 'consum', 0.0215, 'lps'),
	(490876, 128, '2014-01-15 00:24:25.000000', 'consum', 0.0212, 'lps'),
	(490877, 128, '2014-01-15 00:24:26.000000', 'consum', 0.0223, 'lps'),
	(490878, 128, '2014-01-15 00:24:27.000000', 'consum', 0.0221, 'lps'),
	(490879, 128, '2014-01-15 00:24:28.000000', 'consum', 0.0225, 'lps'),
	(490880, 128, '2014-01-15 00:24:29.000000', 'consum', 0.0223, 'lps'),
	(490881, 128, '2014-01-15 00:24:30.000000', 'consum', 0.0214, 'lps'),
	(490882, 128, '2014-01-15 00:24:31.000000', 'consum', 0.0223, 'lps'),
	(490883, 128, '2014-01-15 00:24:32.000000', 'consum', 0.0215, 'lps'),
	(490884, 128, '2014-01-15 00:24:33.000000', 'consum', 0.0214, 'lps'),
	(490885, 128, '2014-01-15 00:24:34.000000', 'consum', 0.0216, 'lps'),
	(490886, 128, '2014-01-15 00:24:35.000000', 'consum', 0.0211, 'lps'),
	(490887, 128, '2014-01-15 00:24:36.000000', 'consum', 0.0213, 'lps'),
	(490888, 128, '2014-01-15 00:24:37.000000', 'consum', 0.0225, 'lps'),
	(490889, 128, '2014-01-15 00:24:38.000000', 'consum', 0.0225, 'lps'),
	(490890, 128, '2014-01-15 00:24:39.000000', 'consum', 0.0211, 'lps'),
	(490891, 128, '2014-01-15 00:24:40.000000', 'consum', 0.0219, 'lps'),
	(490892, 128, '2014-01-15 00:24:41.000000', 'consum', 0.0220, 'lps'),
	(490893, 128, '2014-01-15 00:24:42.000000', 'consum', 0.0216, 'lps'),
	(490894, 128, '2014-01-15 00:24:43.000000', 'consum', 0.0210, 'lps'),
	(490895, 128, '2014-01-15 00:24:44.000000', 'consum', 0.0212, 'lps'),
	(490896, 128, '2014-01-15 00:24:45.000000', 'consum', 0.0217, 'lps'),
	(490897, 128, '2014-01-15 00:24:46.000000', 'consum', 0.0225, 'lps'),
	(490898, 128, '2014-01-15 00:24:47.000000', 'consum', 0.0216, 'lps'),
	(490899, 128, '2014-01-15 00:24:48.000000', 'consum', 0.0213, 'lps'),
	(490900, 128, '2014-01-15 00:24:49.000000', 'consum', 0.0222, 'lps'),
	(490901, 128, '2014-01-15 00:24:50.000000', 'consum', 0.0214, 'lps'),
	(490902, 128, '2014-01-15 00:24:51.000000', 'consum', 0.0210, 'lps'),
	(490903, 128, '2014-01-15 00:24:52.000000', 'consum', 0.0214, 'lps'),
	(490904, 128, '2014-01-15 00:24:53.000000', 'consum', 0.0215, 'lps'),
	(490905, 128, '2014-01-15 00:24:54.000000', 'consum', 0.0223, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(490906, 128, '2014-01-15 00:24:55.000000', 'consum', 0.0215, 'lps'),
	(490907, 128, '2014-01-15 00:24:56.000000', 'consum', 0.0210, 'lps'),
	(490908, 128, '2014-01-15 00:24:57.000000', 'consum', 0.0210, 'lps'),
	(490909, 128, '2014-01-15 00:24:58.000000', 'consum', 0.0213, 'lps'),
	(490910, 128, '2014-01-15 00:24:59.000000', 'consum', 0.0210, 'lps'),
	(490911, 128, '2014-01-15 00:25:00.000000', 'consum', 0.0218, 'lps'),
	(490912, 128, '2014-01-15 00:25:01.000000', 'consum', 0.0219, 'lps'),
	(490913, 128, '2014-01-15 00:25:02.000000', 'consum', 0.0215, 'lps'),
	(490914, 128, '2014-01-15 00:25:03.000000', 'consum', 0.0224, 'lps'),
	(490915, 128, '2014-01-15 00:25:04.000000', 'consum', 0.0216, 'lps'),
	(490916, 128, '2014-01-15 00:25:05.000000', 'consum', 0.0214, 'lps'),
	(490917, 128, '2014-01-15 00:25:06.000000', 'consum', 0.0215, 'lps'),
	(490918, 128, '2014-01-15 00:25:07.000000', 'consum', 0.0224, 'lps'),
	(490919, 128, '2014-01-15 00:25:08.000000', 'consum', 0.0216, 'lps'),
	(490920, 128, '2014-01-15 00:25:09.000000', 'consum', 0.0215, 'lps'),
	(490921, 128, '2014-01-15 00:25:10.000000', 'consum', 0.0218, 'lps'),
	(490922, 128, '2014-01-15 00:25:11.000000', 'consum', 0.0219, 'lps'),
	(490923, 128, '2014-01-15 00:25:12.000000', 'consum', 0.0217, 'lps'),
	(490924, 128, '2014-01-15 00:25:13.000000', 'consum', 0.0219, 'lps'),
	(490925, 128, '2014-01-15 00:25:14.000000', 'consum', 0.0217, 'lps'),
	(490926, 128, '2014-01-15 00:25:15.000000', 'consum', 0.0218, 'lps'),
	(490927, 128, '2014-01-15 00:25:16.000000', 'consum', 0.0216, 'lps'),
	(490928, 128, '2014-01-15 00:25:17.000000', 'consum', 0.0215, 'lps'),
	(490929, 128, '2014-01-15 00:25:18.000000', 'consum', 0.0216, 'lps'),
	(490930, 128, '2014-01-15 00:25:19.000000', 'consum', 0.0225, 'lps'),
	(490931, 128, '2014-01-15 00:25:20.000000', 'consum', 0.0219, 'lps'),
	(490932, 128, '2014-01-15 00:25:21.000000', 'consum', 0.0210, 'lps'),
	(490933, 128, '2014-01-15 00:25:22.000000', 'consum', 0.0219, 'lps'),
	(490934, 128, '2014-01-15 00:25:23.000000', 'consum', 0.0220, 'lps'),
	(490935, 128, '2014-01-15 00:25:24.000000', 'consum', 0.0219, 'lps'),
	(490936, 128, '2014-01-15 00:25:25.000000', 'consum', 0.0211, 'lps'),
	(490937, 128, '2014-01-15 00:25:26.000000', 'consum', 0.0220, 'lps'),
	(490938, 128, '2014-01-15 00:25:27.000000', 'consum', 0.0224, 'lps'),
	(490939, 128, '2014-01-15 00:25:28.000000', 'consum', 0.0219, 'lps'),
	(490940, 128, '2014-01-15 00:25:29.000000', 'consum', 0.0215, 'lps'),
	(490941, 128, '2014-01-15 00:25:30.000000', 'consum', 0.0224, 'lps'),
	(490942, 128, '2014-01-15 00:25:31.000000', 'consum', 0.0217, 'lps'),
	(490943, 128, '2014-01-15 00:25:32.000000', 'consum', 0.0219, 'lps'),
	(490944, 128, '2014-01-15 00:25:33.000000', 'consum', 0.0220, 'lps'),
	(490945, 128, '2014-01-15 00:25:34.000000', 'consum', 0.0217, 'lps'),
	(490946, 128, '2014-01-15 00:25:35.000000', 'consum', 0.0216, 'lps'),
	(490947, 128, '2014-01-15 00:25:36.000000', 'consum', 0.0220, 'lps'),
	(490948, 128, '2014-01-15 00:25:37.000000', 'consum', 0.0211, 'lps'),
	(490949, 128, '2014-01-15 00:25:38.000000', 'consum', 0.0217, 'lps'),
	(490950, 128, '2014-01-15 00:25:39.000000', 'consum', 0.0225, 'lps'),
	(490951, 128, '2014-01-15 00:25:40.000000', 'consum', 0.0216, 'lps'),
	(490952, 128, '2014-01-15 00:25:41.000000', 'consum', 0.0214, 'lps'),
	(490953, 128, '2014-01-15 00:25:42.000000', 'consum', 0.0211, 'lps'),
	(490954, 128, '2014-01-15 00:25:43.000000', 'consum', 0.0218, 'lps'),
	(490955, 128, '2014-01-15 00:25:44.000000', 'consum', 0.0216, 'lps'),
	(490956, 128, '2014-01-15 00:25:45.000000', 'consum', 0.0217, 'lps'),
	(490957, 128, '2014-01-15 00:25:46.000000', 'consum', 0.0214, 'lps'),
	(490958, 128, '2014-01-15 00:25:47.000000', 'consum', 0.0222, 'lps'),
	(490959, 128, '2014-01-15 00:25:48.000000', 'consum', 0.0212, 'lps'),
	(490960, 128, '2014-01-15 00:25:49.000000', 'consum', 0.0217, 'lps'),
	(490961, 128, '2014-01-15 00:25:50.000000', 'consum', 0.0223, 'lps'),
	(490962, 128, '2014-01-15 00:25:51.000000', 'consum', 0.0223, 'lps'),
	(490963, 128, '2014-01-15 00:25:52.000000', 'consum', 0.0219, 'lps'),
	(490964, 128, '2014-01-15 00:25:53.000000', 'consum', 0.0217, 'lps'),
	(490965, 128, '2014-01-15 00:25:54.000000', 'consum', 0.0217, 'lps'),
	(490966, 128, '2014-01-15 00:25:55.000000', 'consum', 0.0211, 'lps'),
	(490967, 128, '2014-01-15 00:25:56.000000', 'consum', 0.0210, 'lps'),
	(490968, 128, '2014-01-15 00:25:57.000000', 'consum', 0.0224, 'lps'),
	(490969, 128, '2014-01-15 00:25:58.000000', 'consum', 0.0216, 'lps'),
	(490970, 128, '2014-01-15 00:25:59.000000', 'consum', 0.0216, 'lps'),
	(490971, 128, '2014-01-15 00:26:00.000000', 'consum', 0.0222, 'lps'),
	(490972, 128, '2014-01-15 00:26:01.000000', 'consum', 0.0218, 'lps'),
	(490973, 128, '2014-01-15 00:26:02.000000', 'consum', 0.0216, 'lps'),
	(490974, 128, '2014-01-15 00:26:03.000000', 'consum', 0.0216, 'lps'),
	(490975, 128, '2014-01-15 00:26:04.000000', 'consum', 0.0222, 'lps'),
	(490976, 128, '2014-01-15 00:26:05.000000', 'consum', 0.0222, 'lps'),
	(490977, 128, '2014-01-15 00:26:06.000000', 'consum', 0.0219, 'lps'),
	(490978, 128, '2014-01-15 00:26:07.000000', 'consum', 0.0220, 'lps'),
	(490979, 128, '2014-01-15 00:26:08.000000', 'consum', 0.0218, 'lps'),
	(490980, 128, '2014-01-15 00:26:09.000000', 'consum', 0.0218, 'lps'),
	(490981, 128, '2014-01-15 00:26:10.000000', 'consum', 0.0212, 'lps'),
	(490982, 128, '2014-01-15 00:26:11.000000', 'consum', 0.0210, 'lps'),
	(490983, 128, '2014-01-15 00:26:12.000000', 'consum', 0.0223, 'lps'),
	(490984, 128, '2014-01-15 00:26:13.000000', 'consum', 0.0210, 'lps'),
	(490985, 128, '2014-01-15 00:26:14.000000', 'consum', 0.0219, 'lps'),
	(490986, 128, '2014-01-15 00:26:15.000000', 'consum', 0.0224, 'lps'),
	(490987, 128, '2014-01-15 00:26:16.000000', 'consum', 0.0222, 'lps'),
	(490988, 128, '2014-01-15 00:26:17.000000', 'consum', 0.0213, 'lps'),
	(490989, 128, '2014-01-15 00:26:18.000000', 'consum', 0.0222, 'lps'),
	(490990, 128, '2014-01-15 00:26:19.000000', 'consum', 0.0213, 'lps'),
	(490991, 128, '2014-01-15 00:26:20.000000', 'consum', 0.0220, 'lps'),
	(490992, 128, '2014-01-15 00:26:21.000000', 'consum', 0.0220, 'lps'),
	(490993, 128, '2014-01-15 00:26:22.000000', 'consum', 0.0215, 'lps'),
	(490994, 128, '2014-01-15 00:26:23.000000', 'consum', 0.0222, 'lps'),
	(490995, 128, '2014-01-15 00:26:24.000000', 'consum', 0.0223, 'lps'),
	(490996, 128, '2014-01-15 00:26:25.000000', 'consum', 0.0223, 'lps'),
	(490997, 128, '2014-01-15 00:26:26.000000', 'consum', 0.0221, 'lps'),
	(490998, 128, '2014-01-15 00:26:27.000000', 'consum', 0.0210, 'lps'),
	(490999, 128, '2014-01-15 00:26:28.000000', 'consum', 0.0225, 'lps'),
	(491000, 128, '2014-01-15 00:26:29.000000', 'consum', 0.0220, 'lps'),
	(491001, 128, '2014-01-15 00:26:30.000000', 'consum', 0.0217, 'lps'),
	(491002, 128, '2014-01-15 00:26:31.000000', 'consum', 0.0215, 'lps'),
	(491003, 128, '2014-01-15 00:26:32.000000', 'consum', 0.0214, 'lps'),
	(491004, 128, '2014-01-15 00:26:33.000000', 'consum', 0.0216, 'lps'),
	(491005, 128, '2014-01-15 00:26:34.000000', 'consum', 0.0211, 'lps'),
	(491006, 128, '2014-01-15 00:26:35.000000', 'consum', 0.0215, 'lps'),
	(491007, 128, '2014-01-15 00:26:36.000000', 'consum', 0.0216, 'lps'),
	(491008, 128, '2014-01-15 00:26:37.000000', 'consum', 0.0224, 'lps'),
	(491009, 128, '2014-01-15 00:26:38.000000', 'consum', 0.0214, 'lps'),
	(491010, 128, '2014-01-15 00:26:39.000000', 'consum', 0.0223, 'lps'),
	(491011, 128, '2014-01-15 00:26:40.000000', 'consum', 0.0215, 'lps'),
	(491012, 128, '2014-01-15 00:26:41.000000', 'consum', 0.0212, 'lps'),
	(491013, 128, '2014-01-15 00:26:42.000000', 'consum', 0.0221, 'lps'),
	(491014, 128, '2014-01-15 00:26:43.000000', 'consum', 0.0210, 'lps'),
	(491015, 128, '2014-01-15 00:26:44.000000', 'consum', 0.0212, 'lps'),
	(491016, 128, '2014-01-15 00:26:45.000000', 'consum', 0.0221, 'lps'),
	(491017, 128, '2014-01-15 00:26:46.000000', 'consum', 0.0212, 'lps'),
	(491018, 128, '2014-01-15 00:26:47.000000', 'consum', 0.0218, 'lps'),
	(491019, 128, '2014-01-15 00:26:48.000000', 'consum', 0.0212, 'lps'),
	(491020, 128, '2014-01-15 00:26:49.000000', 'consum', 0.0212, 'lps'),
	(491021, 128, '2014-01-15 00:26:50.000000', 'consum', 0.0217, 'lps'),
	(491022, 128, '2014-01-15 00:26:51.000000', 'consum', 0.0221, 'lps'),
	(491023, 128, '2014-01-15 00:26:52.000000', 'consum', 0.0215, 'lps'),
	(491024, 128, '2014-01-15 00:26:53.000000', 'consum', 0.0219, 'lps'),
	(491025, 128, '2014-01-15 00:26:54.000000', 'consum', 0.0224, 'lps'),
	(491026, 128, '2014-01-15 00:26:55.000000', 'consum', 0.0221, 'lps'),
	(491027, 128, '2014-01-15 00:26:56.000000', 'consum', 0.0225, 'lps'),
	(491028, 128, '2014-01-15 00:26:57.000000', 'consum', 0.0220, 'lps'),
	(491029, 128, '2014-01-15 00:26:58.000000', 'consum', 0.0217, 'lps'),
	(491030, 128, '2014-01-15 00:26:59.000000', 'consum', 0.0213, 'lps'),
	(491031, 128, '2014-01-15 00:27:00.000000', 'consum', 0.0220, 'lps'),
	(491032, 128, '2014-01-15 00:27:01.000000', 'consum', 0.0221, 'lps'),
	(491033, 128, '2014-01-15 00:27:02.000000', 'consum', 0.0221, 'lps'),
	(491034, 128, '2014-01-15 00:27:03.000000', 'consum', 0.0216, 'lps'),
	(491035, 128, '2014-01-15 00:27:04.000000', 'consum', 0.0223, 'lps'),
	(491036, 128, '2014-01-15 00:27:05.000000', 'consum', 0.0211, 'lps'),
	(491037, 128, '2014-01-15 00:27:06.000000', 'consum', 0.0224, 'lps'),
	(491038, 128, '2014-01-15 00:27:07.000000', 'consum', 0.0214, 'lps'),
	(491039, 128, '2014-01-15 00:27:08.000000', 'consum', 0.0220, 'lps'),
	(491040, 128, '2014-01-15 00:27:09.000000', 'consum', 0.0215, 'lps'),
	(491041, 128, '2014-01-15 00:27:10.000000', 'consum', 0.0225, 'lps'),
	(491042, 128, '2014-01-15 00:27:11.000000', 'consum', 0.0219, 'lps'),
	(491043, 128, '2014-01-15 00:27:12.000000', 'consum', 0.0210, 'lps'),
	(491044, 128, '2014-01-15 00:27:13.000000', 'consum', 0.0218, 'lps'),
	(491045, 128, '2014-01-15 00:27:14.000000', 'consum', 0.0218, 'lps'),
	(491046, 128, '2014-01-15 00:27:15.000000', 'consum', 0.0211, 'lps'),
	(491047, 128, '2014-01-15 00:27:16.000000', 'consum', 0.0225, 'lps'),
	(491048, 128, '2014-01-15 00:27:17.000000', 'consum', 0.0216, 'lps'),
	(491049, 128, '2014-01-15 00:27:18.000000', 'consum', 0.0212, 'lps'),
	(491050, 128, '2014-01-15 00:27:19.000000', 'consum', 0.0219, 'lps'),
	(491051, 128, '2014-01-15 00:27:20.000000', 'consum', 0.0218, 'lps'),
	(491052, 128, '2014-01-15 00:27:21.000000', 'consum', 0.0224, 'lps'),
	(491053, 128, '2014-01-15 00:27:22.000000', 'consum', 0.0222, 'lps'),
	(491054, 128, '2014-01-15 00:27:23.000000', 'consum', 0.0213, 'lps'),
	(491055, 128, '2014-01-15 00:27:24.000000', 'consum', 0.0222, 'lps'),
	(491056, 128, '2014-01-15 00:27:25.000000', 'consum', 0.0215, 'lps'),
	(491057, 128, '2014-01-15 00:27:26.000000', 'consum', 0.0213, 'lps'),
	(491058, 128, '2014-01-15 00:27:27.000000', 'consum', 0.0213, 'lps'),
	(491059, 128, '2014-01-15 00:27:28.000000', 'consum', 0.0213, 'lps'),
	(491060, 128, '2014-01-15 00:27:29.000000', 'consum', 0.0220, 'lps'),
	(491061, 128, '2014-01-15 00:27:30.000000', 'consum', 0.0218, 'lps'),
	(491062, 128, '2014-01-15 00:27:31.000000', 'consum', 0.0221, 'lps'),
	(491063, 128, '2014-01-15 00:27:32.000000', 'consum', 0.0225, 'lps'),
	(491064, 128, '2014-01-15 00:27:33.000000', 'consum', 0.0223, 'lps'),
	(491065, 128, '2014-01-15 00:27:34.000000', 'consum', 0.0212, 'lps'),
	(491066, 128, '2014-01-15 00:27:35.000000', 'consum', 0.0215, 'lps'),
	(491067, 128, '2014-01-15 00:27:36.000000', 'consum', 0.0211, 'lps'),
	(491068, 128, '2014-01-15 00:27:37.000000', 'consum', 0.0217, 'lps'),
	(491069, 128, '2014-01-15 00:27:38.000000', 'consum', 0.0210, 'lps'),
	(491070, 128, '2014-01-15 00:27:39.000000', 'consum', 0.0222, 'lps'),
	(491071, 128, '2014-01-15 00:27:40.000000', 'consum', 0.0221, 'lps'),
	(491072, 128, '2014-01-15 00:27:41.000000', 'consum', 0.0215, 'lps'),
	(491073, 128, '2014-01-15 00:27:42.000000', 'consum', 0.0218, 'lps'),
	(491074, 128, '2014-01-15 00:27:43.000000', 'consum', 0.0219, 'lps'),
	(491075, 128, '2014-01-15 00:27:44.000000', 'consum', 0.0217, 'lps'),
	(491076, 128, '2014-01-15 00:27:45.000000', 'consum', 0.0218, 'lps'),
	(491077, 128, '2014-01-15 00:27:46.000000', 'consum', 0.0213, 'lps'),
	(491078, 128, '2014-01-15 00:27:47.000000', 'consum', 0.0219, 'lps'),
	(491079, 128, '2014-01-15 00:27:48.000000', 'consum', 0.0213, 'lps'),
	(491080, 128, '2014-01-15 00:27:49.000000', 'consum', 0.0216, 'lps'),
	(491081, 128, '2014-01-15 00:27:50.000000', 'consum', 0.0214, 'lps'),
	(491082, 128, '2014-01-15 00:27:51.000000', 'consum', 0.0213, 'lps'),
	(491083, 128, '2014-01-15 00:27:52.000000', 'consum', 0.0215, 'lps'),
	(491084, 128, '2014-01-15 00:27:53.000000', 'consum', 0.0211, 'lps'),
	(491085, 128, '2014-01-15 00:27:54.000000', 'consum', 0.0215, 'lps'),
	(491086, 128, '2014-01-15 00:27:55.000000', 'consum', 0.0219, 'lps'),
	(491087, 128, '2014-01-15 00:27:56.000000', 'consum', 0.0221, 'lps'),
	(491088, 128, '2014-01-15 00:27:57.000000', 'consum', 0.0225, 'lps'),
	(491089, 128, '2014-01-15 00:27:58.000000', 'consum', 0.0221, 'lps'),
	(491090, 128, '2014-01-15 00:27:59.000000', 'consum', 0.0220, 'lps'),
	(491091, 128, '2014-01-15 00:28:00.000000', 'consum', 0.0211, 'lps'),
	(491092, 128, '2014-01-15 00:28:01.000000', 'consum', 0.0219, 'lps'),
	(491093, 128, '2014-01-15 00:28:02.000000', 'consum', 0.0218, 'lps'),
	(491094, 128, '2014-01-15 00:28:03.000000', 'consum', 0.0210, 'lps'),
	(491095, 128, '2014-01-15 00:28:04.000000', 'consum', 0.0219, 'lps'),
	(491096, 128, '2014-01-15 00:28:05.000000', 'consum', 0.0221, 'lps'),
	(491097, 128, '2014-01-15 00:28:06.000000', 'consum', 0.0222, 'lps'),
	(491098, 128, '2014-01-15 00:28:07.000000', 'consum', 0.0222, 'lps'),
	(491099, 128, '2014-01-15 00:28:08.000000', 'consum', 0.0217, 'lps'),
	(491100, 128, '2014-01-15 00:28:09.000000', 'consum', 0.0212, 'lps'),
	(491101, 128, '2014-01-15 00:28:10.000000', 'consum', 0.0215, 'lps'),
	(491102, 128, '2014-01-15 00:28:11.000000', 'consum', 0.0214, 'lps'),
	(491103, 128, '2014-01-15 00:28:12.000000', 'consum', 0.0213, 'lps'),
	(491104, 128, '2014-01-15 00:28:13.000000', 'consum', 0.0215, 'lps'),
	(491105, 128, '2014-01-15 00:28:14.000000', 'consum', 0.0212, 'lps'),
	(491106, 128, '2014-01-15 00:28:15.000000', 'consum', 0.0220, 'lps'),
	(491107, 128, '2014-01-15 00:28:16.000000', 'consum', 0.0222, 'lps'),
	(491108, 128, '2014-01-15 00:28:17.000000', 'consum', 0.0224, 'lps'),
	(491109, 128, '2014-01-15 00:28:18.000000', 'consum', 0.0213, 'lps'),
	(491110, 128, '2014-01-15 00:28:19.000000', 'consum', 0.0217, 'lps'),
	(491111, 128, '2014-01-15 00:28:20.000000', 'consum', 0.0220, 'lps'),
	(491112, 128, '2014-01-15 00:28:21.000000', 'consum', 0.0224, 'lps'),
	(491113, 128, '2014-01-15 00:28:22.000000', 'consum', 0.0216, 'lps'),
	(491114, 128, '2014-01-15 00:28:23.000000', 'consum', 0.0216, 'lps'),
	(491115, 128, '2014-01-15 00:28:24.000000', 'consum', 0.0221, 'lps'),
	(491116, 128, '2014-01-15 00:28:25.000000', 'consum', 0.0216, 'lps'),
	(491117, 128, '2014-01-15 00:28:26.000000', 'consum', 0.0225, 'lps'),
	(491118, 128, '2014-01-15 00:28:27.000000', 'consum', 0.0220, 'lps'),
	(491119, 128, '2014-01-15 00:28:28.000000', 'consum', 0.0217, 'lps'),
	(491120, 128, '2014-01-15 00:28:29.000000', 'consum', 0.0212, 'lps'),
	(491121, 128, '2014-01-15 00:28:30.000000', 'consum', 0.0217, 'lps'),
	(491122, 128, '2014-01-15 00:28:31.000000', 'consum', 0.0222, 'lps'),
	(491123, 128, '2014-01-15 00:28:32.000000', 'consum', 0.0217, 'lps'),
	(491124, 128, '2014-01-15 00:28:33.000000', 'consum', 0.0211, 'lps'),
	(491125, 128, '2014-01-15 00:28:34.000000', 'consum', 0.0224, 'lps'),
	(491126, 128, '2014-01-15 00:28:35.000000', 'consum', 0.0215, 'lps'),
	(491127, 128, '2014-01-15 00:28:36.000000', 'consum', 0.0211, 'lps'),
	(491128, 128, '2014-01-15 00:28:37.000000', 'consum', 0.0216, 'lps'),
	(491129, 128, '2014-01-15 00:28:38.000000', 'consum', 0.0220, 'lps'),
	(491130, 128, '2014-01-15 00:28:39.000000', 'consum', 0.0210, 'lps'),
	(491131, 128, '2014-01-15 00:28:40.000000', 'consum', 0.0212, 'lps'),
	(491132, 128, '2014-01-15 00:28:41.000000', 'consum', 0.0220, 'lps'),
	(491133, 128, '2014-01-15 00:28:42.000000', 'consum', 0.0223, 'lps'),
	(491134, 128, '2014-01-15 00:28:43.000000', 'consum', 0.0212, 'lps'),
	(491135, 128, '2014-01-15 00:28:44.000000', 'consum', 0.0214, 'lps'),
	(491136, 128, '2014-01-15 00:28:45.000000', 'consum', 0.0224, 'lps'),
	(491137, 128, '2014-01-15 00:28:46.000000', 'consum', 0.0220, 'lps'),
	(491138, 128, '2014-01-15 00:28:47.000000', 'consum', 0.0221, 'lps'),
	(491139, 128, '2014-01-15 00:28:48.000000', 'consum', 0.0220, 'lps'),
	(491140, 128, '2014-01-15 00:28:49.000000', 'consum', 0.0210, 'lps'),
	(491141, 128, '2014-01-15 00:28:50.000000', 'consum', 0.0212, 'lps'),
	(491142, 128, '2014-01-15 00:28:51.000000', 'consum', 0.0223, 'lps'),
	(491143, 128, '2014-01-15 00:28:52.000000', 'consum', 0.0220, 'lps'),
	(491144, 128, '2014-01-15 00:28:53.000000', 'consum', 0.0220, 'lps'),
	(491145, 128, '2014-01-15 00:28:54.000000', 'consum', 0.0217, 'lps'),
	(491146, 128, '2014-01-15 00:28:55.000000', 'consum', 0.0213, 'lps'),
	(491147, 128, '2014-01-15 00:28:56.000000', 'consum', 0.0220, 'lps'),
	(491148, 128, '2014-01-15 00:28:57.000000', 'consum', 0.0222, 'lps'),
	(491149, 128, '2014-01-15 00:28:58.000000', 'consum', 0.0224, 'lps'),
	(491150, 128, '2014-01-15 00:28:59.000000', 'consum', 0.0212, 'lps'),
	(491151, 128, '2014-01-15 00:29:00.000000', 'consum', 0.0211, 'lps'),
	(491152, 128, '2014-01-15 00:29:01.000000', 'consum', 0.0211, 'lps'),
	(491153, 128, '2014-01-15 00:29:02.000000', 'consum', 0.0211, 'lps'),
	(491154, 128, '2014-01-15 00:29:03.000000', 'consum', 0.0212, 'lps'),
	(491155, 128, '2014-01-15 00:29:04.000000', 'consum', 0.0219, 'lps'),
	(491156, 128, '2014-01-15 00:29:05.000000', 'consum', 0.0217, 'lps'),
	(491157, 128, '2014-01-15 00:29:06.000000', 'consum', 0.0220, 'lps'),
	(491158, 128, '2014-01-15 00:29:07.000000', 'consum', 0.0224, 'lps'),
	(491159, 128, '2014-01-15 00:29:08.000000', 'consum', 0.0218, 'lps'),
	(491160, 128, '2014-01-15 00:29:09.000000', 'consum', 0.0225, 'lps'),
	(491161, 128, '2014-01-15 00:29:10.000000', 'consum', 0.0214, 'lps'),
	(491162, 128, '2014-01-15 00:29:11.000000', 'consum', 0.0216, 'lps'),
	(491163, 128, '2014-01-15 00:29:12.000000', 'consum', 0.0212, 'lps'),
	(491164, 128, '2014-01-15 00:29:13.000000', 'consum', 0.0217, 'lps'),
	(491165, 128, '2014-01-15 00:29:14.000000', 'consum', 0.0211, 'lps'),
	(491166, 128, '2014-01-15 00:29:15.000000', 'consum', 0.0224, 'lps'),
	(491167, 128, '2014-01-15 00:29:16.000000', 'consum', 0.0215, 'lps'),
	(491168, 128, '2014-01-15 00:29:17.000000', 'consum', 0.0223, 'lps'),
	(491169, 128, '2014-01-15 00:29:18.000000', 'consum', 0.0216, 'lps'),
	(491170, 128, '2014-01-15 00:29:19.000000', 'consum', 0.0215, 'lps'),
	(491171, 128, '2014-01-15 00:29:20.000000', 'consum', 0.0220, 'lps'),
	(491172, 128, '2014-01-15 00:29:21.000000', 'consum', 0.0213, 'lps'),
	(491173, 128, '2014-01-15 00:29:22.000000', 'consum', 0.0211, 'lps'),
	(491174, 128, '2014-01-15 00:29:23.000000', 'consum', 0.0221, 'lps'),
	(491175, 128, '2014-01-15 00:29:24.000000', 'consum', 0.0215, 'lps'),
	(491176, 128, '2014-01-15 00:29:25.000000', 'consum', 0.0219, 'lps'),
	(491177, 128, '2014-01-15 00:29:26.000000', 'consum', 0.0225, 'lps'),
	(491178, 128, '2014-01-15 00:29:27.000000', 'consum', 0.0211, 'lps'),
	(491179, 128, '2014-01-15 00:29:28.000000', 'consum', 0.0220, 'lps'),
	(491180, 128, '2014-01-15 00:29:29.000000', 'consum', 0.0224, 'lps'),
	(491181, 128, '2014-01-15 00:29:30.000000', 'consum', 0.0219, 'lps'),
	(491182, 128, '2014-01-15 00:29:31.000000', 'consum', 0.0212, 'lps'),
	(491183, 128, '2014-01-15 00:29:32.000000', 'consum', 0.0210, 'lps'),
	(491184, 128, '2014-01-15 00:29:33.000000', 'consum', 0.0220, 'lps'),
	(491185, 128, '2014-01-15 00:29:34.000000', 'consum', 0.0215, 'lps'),
	(491186, 128, '2014-01-15 00:29:35.000000', 'consum', 0.0219, 'lps'),
	(491187, 128, '2014-01-15 00:29:36.000000', 'consum', 0.0211, 'lps'),
	(491188, 128, '2014-01-15 00:29:37.000000', 'consum', 0.0220, 'lps'),
	(491189, 128, '2014-01-15 00:29:38.000000', 'consum', 0.0225, 'lps'),
	(491190, 128, '2014-01-15 00:29:39.000000', 'consum', 0.0225, 'lps'),
	(491191, 128, '2014-01-15 00:29:40.000000', 'consum', 0.0223, 'lps'),
	(491192, 128, '2014-01-15 00:29:41.000000', 'consum', 0.0217, 'lps'),
	(491193, 128, '2014-01-15 00:29:42.000000', 'consum', 0.0220, 'lps'),
	(491194, 128, '2014-01-15 00:29:43.000000', 'consum', 0.0222, 'lps'),
	(491195, 128, '2014-01-15 00:29:44.000000', 'consum', 0.0211, 'lps'),
	(491196, 128, '2014-01-15 00:29:45.000000', 'consum', 0.0211, 'lps'),
	(491197, 128, '2014-01-15 00:29:46.000000', 'consum', 0.0213, 'lps'),
	(491198, 128, '2014-01-15 00:29:47.000000', 'consum', 0.0222, 'lps'),
	(491199, 128, '2014-01-15 00:29:48.000000', 'consum', 0.0216, 'lps'),
	(491200, 128, '2014-01-15 00:29:49.000000', 'consum', 0.0217, 'lps'),
	(491201, 128, '2014-01-15 00:29:50.000000', 'consum', 0.0213, 'lps'),
	(491202, 128, '2014-01-15 00:29:51.000000', 'consum', 0.0219, 'lps'),
	(491203, 128, '2014-01-15 00:29:52.000000', 'consum', 0.0214, 'lps'),
	(491204, 128, '2014-01-15 00:29:53.000000', 'consum', 0.0220, 'lps'),
	(491205, 128, '2014-01-15 00:29:54.000000', 'consum', 0.0217, 'lps'),
	(491206, 128, '2014-01-15 00:29:55.000000', 'consum', 0.0214, 'lps'),
	(491207, 128, '2014-01-15 00:29:56.000000', 'consum', 0.0225, 'lps'),
	(491208, 128, '2014-01-15 00:29:57.000000', 'consum', 0.0213, 'lps'),
	(491209, 128, '2014-01-15 00:29:58.000000', 'consum', 0.0225, 'lps'),
	(491210, 128, '2014-01-15 00:29:59.000000', 'consum', 0.0212, 'lps'),
	(491211, 128, '2014-01-15 00:30:00.000000', 'consum', 0.0210, 'lps'),
	(491212, 128, '2014-01-15 00:30:01.000000', 'consum', 0.0221, 'lps'),
	(491213, 128, '2014-01-15 00:30:02.000000', 'consum', 0.0218, 'lps'),
	(491214, 128, '2014-01-15 00:30:03.000000', 'consum', 0.0215, 'lps'),
	(491215, 128, '2014-01-15 00:30:04.000000', 'consum', 0.0213, 'lps'),
	(491216, 128, '2014-01-15 00:30:05.000000', 'consum', 0.0210, 'lps'),
	(491217, 128, '2014-01-15 00:30:06.000000', 'consum', 0.0217, 'lps'),
	(491218, 128, '2014-01-15 00:30:07.000000', 'consum', 0.0214, 'lps'),
	(491219, 128, '2014-01-15 00:30:08.000000', 'consum', 0.0223, 'lps'),
	(491220, 128, '2014-01-15 00:30:09.000000', 'consum', 0.0219, 'lps'),
	(491221, 128, '2014-01-15 00:30:10.000000', 'consum', 0.0217, 'lps'),
	(491222, 128, '2014-01-15 00:30:11.000000', 'consum', 0.0216, 'lps'),
	(491223, 128, '2014-01-15 00:30:12.000000', 'consum', 0.0222, 'lps'),
	(491224, 128, '2014-01-15 00:30:13.000000', 'consum', 0.0220, 'lps'),
	(491225, 128, '2014-01-15 00:30:14.000000', 'consum', 0.0225, 'lps'),
	(491226, 128, '2014-01-15 00:30:15.000000', 'consum', 0.0221, 'lps'),
	(491227, 128, '2014-01-15 00:30:16.000000', 'consum', 0.0222, 'lps'),
	(491228, 128, '2014-01-15 00:30:17.000000', 'consum', 0.0222, 'lps'),
	(491229, 128, '2014-01-15 00:30:18.000000', 'consum', 0.0217, 'lps'),
	(491230, 128, '2014-01-15 00:30:19.000000', 'consum', 0.0211, 'lps'),
	(491231, 128, '2014-01-15 00:30:20.000000', 'consum', 0.0210, 'lps'),
	(491232, 128, '2014-01-15 00:30:21.000000', 'consum', 0.0224, 'lps'),
	(491233, 128, '2014-01-15 00:30:22.000000', 'consum', 0.0217, 'lps'),
	(491234, 128, '2014-01-15 00:30:23.000000', 'consum', 0.0217, 'lps'),
	(491235, 128, '2014-01-15 00:30:24.000000', 'consum', 0.0211, 'lps'),
	(491236, 128, '2014-01-15 00:30:25.000000', 'consum', 0.0224, 'lps'),
	(491237, 128, '2014-01-15 00:30:26.000000', 'consum', 0.0213, 'lps'),
	(491238, 128, '2014-01-15 00:30:27.000000', 'consum', 0.0219, 'lps'),
	(491239, 128, '2014-01-15 00:30:28.000000', 'consum', 0.0211, 'lps'),
	(491240, 128, '2014-01-15 00:30:29.000000', 'consum', 0.0221, 'lps'),
	(491241, 128, '2014-01-15 00:30:30.000000', 'consum', 0.0214, 'lps'),
	(491242, 128, '2014-01-15 00:30:31.000000', 'consum', 0.0215, 'lps'),
	(491243, 128, '2014-01-15 00:30:32.000000', 'consum', 0.0223, 'lps'),
	(491244, 128, '2014-01-15 00:30:33.000000', 'consum', 0.0212, 'lps'),
	(491245, 128, '2014-01-15 00:30:34.000000', 'consum', 0.0214, 'lps'),
	(491246, 128, '2014-01-15 00:30:35.000000', 'consum', 0.0223, 'lps'),
	(491247, 128, '2014-01-15 00:30:36.000000', 'consum', 0.0217, 'lps'),
	(491248, 128, '2014-01-15 00:30:37.000000', 'consum', 0.0220, 'lps'),
	(491249, 128, '2014-01-15 00:30:38.000000', 'consum', 0.0210, 'lps'),
	(491250, 128, '2014-01-15 00:30:39.000000', 'consum', 0.0210, 'lps'),
	(491251, 128, '2014-01-15 00:30:40.000000', 'consum', 0.0214, 'lps'),
	(491252, 128, '2014-01-15 00:30:41.000000', 'consum', 0.0211, 'lps'),
	(491253, 128, '2014-01-15 00:30:42.000000', 'consum', 0.0222, 'lps'),
	(491254, 128, '2014-01-15 00:30:43.000000', 'consum', 0.0220, 'lps'),
	(491255, 128, '2014-01-15 00:30:44.000000', 'consum', 0.0223, 'lps'),
	(491256, 128, '2014-01-15 00:30:45.000000', 'consum', 0.0213, 'lps'),
	(491257, 128, '2014-01-15 00:30:46.000000', 'consum', 0.0220, 'lps'),
	(491258, 128, '2014-01-15 00:30:47.000000', 'consum', 0.0219, 'lps'),
	(491259, 128, '2014-01-15 00:30:48.000000', 'consum', 0.0225, 'lps'),
	(491260, 128, '2014-01-15 00:30:49.000000', 'consum', 0.0212, 'lps'),
	(491261, 128, '2014-01-15 00:30:50.000000', 'consum', 0.0221, 'lps'),
	(491262, 128, '2014-01-15 00:30:51.000000', 'consum', 0.0211, 'lps'),
	(491263, 128, '2014-01-15 00:30:52.000000', 'consum', 0.0216, 'lps'),
	(491264, 128, '2014-01-15 00:30:53.000000', 'consum', 0.0219, 'lps'),
	(491265, 128, '2014-01-15 00:30:54.000000', 'consum', 0.0224, 'lps'),
	(491266, 128, '2014-01-15 00:30:55.000000', 'consum', 0.0222, 'lps'),
	(491267, 128, '2014-01-15 00:30:56.000000', 'consum', 0.0211, 'lps'),
	(491268, 128, '2014-01-15 00:30:57.000000', 'consum', 0.0211, 'lps'),
	(491269, 128, '2014-01-15 00:30:58.000000', 'consum', 0.0213, 'lps'),
	(491270, 128, '2014-01-15 00:30:59.000000', 'consum', 0.0225, 'lps'),
	(491271, 128, '2014-01-15 00:31:00.000000', 'consum', 0.0210, 'lps'),
	(491272, 128, '2014-01-15 00:31:01.000000', 'consum', 0.0213, 'lps'),
	(491273, 128, '2014-01-15 00:31:02.000000', 'consum', 0.0211, 'lps'),
	(491274, 128, '2014-01-15 00:31:03.000000', 'consum', 0.0222, 'lps'),
	(491275, 128, '2014-01-15 00:31:04.000000', 'consum', 0.0217, 'lps'),
	(491276, 128, '2014-01-15 00:31:05.000000', 'consum', 0.0213, 'lps'),
	(491277, 128, '2014-01-15 00:31:06.000000', 'consum', 0.0219, 'lps'),
	(491278, 128, '2014-01-15 00:31:07.000000', 'consum', 0.0216, 'lps'),
	(491279, 128, '2014-01-15 00:31:08.000000', 'consum', 0.0212, 'lps'),
	(491280, 128, '2014-01-15 00:31:09.000000', 'consum', 0.0217, 'lps'),
	(491281, 128, '2014-01-15 00:31:10.000000', 'consum', 0.0211, 'lps'),
	(491282, 128, '2014-01-15 00:31:11.000000', 'consum', 0.0224, 'lps'),
	(491283, 128, '2014-01-15 00:31:12.000000', 'consum', 0.0213, 'lps'),
	(491284, 128, '2014-01-15 00:31:13.000000', 'consum', 0.0217, 'lps'),
	(491285, 128, '2014-01-15 00:31:14.000000', 'consum', 0.0220, 'lps'),
	(491286, 128, '2014-01-15 00:31:15.000000', 'consum', 0.0225, 'lps'),
	(491287, 128, '2014-01-15 00:31:16.000000', 'consum', 0.0225, 'lps'),
	(491288, 128, '2014-01-15 00:31:17.000000', 'consum', 0.0221, 'lps'),
	(491289, 128, '2014-01-15 00:31:18.000000', 'consum', 0.0221, 'lps'),
	(491290, 128, '2014-01-15 00:31:19.000000', 'consum', 0.0219, 'lps'),
	(491291, 128, '2014-01-15 00:31:20.000000', 'consum', 0.0221, 'lps'),
	(491292, 128, '2014-01-15 00:31:21.000000', 'consum', 0.0222, 'lps'),
	(491293, 128, '2014-01-15 00:31:22.000000', 'consum', 0.0223, 'lps'),
	(491294, 128, '2014-01-15 00:31:23.000000', 'consum', 0.0224, 'lps'),
	(491295, 128, '2014-01-15 00:31:24.000000', 'consum', 0.0224, 'lps'),
	(491296, 128, '2014-01-15 00:31:25.000000', 'consum', 0.0224, 'lps'),
	(491297, 128, '2014-01-15 00:31:26.000000', 'consum', 0.0220, 'lps'),
	(491298, 128, '2014-01-15 00:31:27.000000', 'consum', 0.0220, 'lps'),
	(491299, 128, '2014-01-15 00:31:28.000000', 'consum', 0.0212, 'lps'),
	(491300, 128, '2014-01-15 00:31:29.000000', 'consum', 0.0210, 'lps'),
	(491301, 128, '2014-01-15 00:31:30.000000', 'consum', 0.0217, 'lps'),
	(491302, 128, '2014-01-15 00:31:31.000000', 'consum', 0.0217, 'lps'),
	(491303, 128, '2014-01-15 00:31:32.000000', 'consum', 0.0222, 'lps'),
	(491304, 128, '2014-01-15 00:31:33.000000', 'consum', 0.0219, 'lps'),
	(491305, 128, '2014-01-15 00:31:34.000000', 'consum', 0.0218, 'lps'),
	(491306, 128, '2014-01-15 00:31:35.000000', 'consum', 0.0222, 'lps'),
	(491307, 128, '2014-01-15 00:31:36.000000', 'consum', 0.0218, 'lps'),
	(491308, 128, '2014-01-15 00:31:37.000000', 'consum', 0.0212, 'lps'),
	(491309, 128, '2014-01-15 00:31:38.000000', 'consum', 0.0215, 'lps'),
	(491310, 128, '2014-01-15 00:31:39.000000', 'consum', 0.0213, 'lps'),
	(491311, 128, '2014-01-15 00:31:40.000000', 'consum', 0.0225, 'lps'),
	(491312, 128, '2014-01-15 00:31:41.000000', 'consum', 0.0214, 'lps'),
	(491313, 128, '2014-01-15 00:31:42.000000', 'consum', 0.0216, 'lps'),
	(491314, 128, '2014-01-15 00:31:43.000000', 'consum', 0.0212, 'lps'),
	(491315, 128, '2014-01-15 00:31:44.000000', 'consum', 0.0220, 'lps'),
	(491316, 128, '2014-01-15 00:31:45.000000', 'consum', 0.0221, 'lps'),
	(491317, 128, '2014-01-15 00:31:46.000000', 'consum', 0.0221, 'lps'),
	(491318, 128, '2014-01-15 00:31:47.000000', 'consum', 0.0215, 'lps'),
	(491319, 128, '2014-01-15 00:31:48.000000', 'consum', 0.0220, 'lps'),
	(491320, 128, '2014-01-15 00:31:49.000000', 'consum', 0.0212, 'lps'),
	(491321, 128, '2014-01-15 00:31:50.000000', 'consum', 0.0225, 'lps'),
	(491322, 128, '2014-01-15 00:31:51.000000', 'consum', 0.0213, 'lps'),
	(491323, 128, '2014-01-15 00:31:52.000000', 'consum', 0.0212, 'lps'),
	(491324, 128, '2014-01-15 00:31:53.000000', 'consum', 0.0215, 'lps'),
	(491325, 128, '2014-01-15 00:31:54.000000', 'consum', 0.0210, 'lps'),
	(491326, 128, '2014-01-15 00:31:55.000000', 'consum', 0.0212, 'lps'),
	(491327, 128, '2014-01-15 00:31:56.000000', 'consum', 0.0220, 'lps'),
	(491328, 128, '2014-01-15 00:31:57.000000', 'consum', 0.0224, 'lps'),
	(491329, 128, '2014-01-15 00:31:58.000000', 'consum', 0.0219, 'lps'),
	(491330, 128, '2014-01-15 00:31:59.000000', 'consum', 0.0212, 'lps'),
	(491331, 128, '2014-01-15 00:32:00.000000', 'consum', 0.0212, 'lps'),
	(491332, 128, '2014-01-15 00:32:01.000000', 'consum', 0.0213, 'lps'),
	(491333, 128, '2014-01-15 00:32:02.000000', 'consum', 0.0221, 'lps'),
	(491334, 128, '2014-01-15 00:32:03.000000', 'consum', 0.0222, 'lps'),
	(491335, 128, '2014-01-15 00:32:04.000000', 'consum', 0.0221, 'lps'),
	(491336, 128, '2014-01-15 00:32:05.000000', 'consum', 0.0214, 'lps'),
	(491337, 128, '2014-01-15 00:32:06.000000', 'consum', 0.0215, 'lps'),
	(491338, 128, '2014-01-15 00:32:07.000000', 'consum', 0.0222, 'lps'),
	(491339, 128, '2014-01-15 00:32:08.000000', 'consum', 0.0225, 'lps'),
	(491340, 128, '2014-01-15 00:32:09.000000', 'consum', 0.0218, 'lps'),
	(491341, 128, '2014-01-15 00:32:10.000000', 'consum', 0.0219, 'lps'),
	(491342, 128, '2014-01-15 00:32:11.000000', 'consum', 0.0216, 'lps'),
	(491343, 128, '2014-01-15 00:32:12.000000', 'consum', 0.0215, 'lps'),
	(491344, 128, '2014-01-15 00:32:13.000000', 'consum', 0.0218, 'lps'),
	(491345, 128, '2014-01-15 00:32:14.000000', 'consum', 0.0217, 'lps'),
	(491346, 128, '2014-01-15 00:32:15.000000', 'consum', 0.0222, 'lps'),
	(491347, 128, '2014-01-15 00:32:16.000000', 'consum', 0.0217, 'lps'),
	(491348, 128, '2014-01-15 00:32:17.000000', 'consum', 0.0225, 'lps'),
	(491349, 128, '2014-01-15 00:32:18.000000', 'consum', 0.0218, 'lps'),
	(491350, 128, '2014-01-15 00:32:19.000000', 'consum', 0.0221, 'lps'),
	(491351, 128, '2014-01-15 00:32:20.000000', 'consum', 0.0211, 'lps'),
	(491352, 128, '2014-01-15 00:32:21.000000', 'consum', 0.0215, 'lps'),
	(491353, 128, '2014-01-15 00:32:22.000000', 'consum', 0.0214, 'lps'),
	(491354, 128, '2014-01-15 00:32:23.000000', 'consum', 0.0215, 'lps'),
	(491355, 128, '2014-01-15 00:32:24.000000', 'consum', 0.0210, 'lps'),
	(491356, 128, '2014-01-15 00:32:25.000000', 'consum', 0.0212, 'lps'),
	(491357, 128, '2014-01-15 00:32:26.000000', 'consum', 0.0218, 'lps'),
	(491358, 128, '2014-01-15 00:32:27.000000', 'consum', 0.0213, 'lps'),
	(491359, 128, '2014-01-15 00:32:28.000000', 'consum', 0.0219, 'lps'),
	(491360, 128, '2014-01-15 00:32:29.000000', 'consum', 0.0212, 'lps'),
	(491361, 128, '2014-01-15 00:32:30.000000', 'consum', 0.0211, 'lps'),
	(491362, 128, '2014-01-15 00:32:31.000000', 'consum', 0.0225, 'lps'),
	(491363, 128, '2014-01-15 00:32:32.000000', 'consum', 0.0220, 'lps'),
	(491364, 128, '2014-01-15 00:32:33.000000', 'consum', 0.0216, 'lps'),
	(491365, 128, '2014-01-15 00:32:34.000000', 'consum', 0.0210, 'lps'),
	(491366, 128, '2014-01-15 00:32:35.000000', 'consum', 0.0223, 'lps'),
	(491367, 128, '2014-01-15 00:32:36.000000', 'consum', 0.0213, 'lps'),
	(491368, 128, '2014-01-15 00:32:37.000000', 'consum', 0.0216, 'lps'),
	(491369, 128, '2014-01-15 00:32:38.000000', 'consum', 0.0219, 'lps'),
	(491370, 128, '2014-01-15 00:32:39.000000', 'consum', 0.0218, 'lps'),
	(491371, 128, '2014-01-15 00:32:40.000000', 'consum', 0.0225, 'lps'),
	(491372, 128, '2014-01-15 00:32:41.000000', 'consum', 0.0212, 'lps'),
	(491373, 128, '2014-01-15 00:32:42.000000', 'consum', 0.0210, 'lps'),
	(491374, 128, '2014-01-15 00:32:43.000000', 'consum', 0.0219, 'lps'),
	(491375, 128, '2014-01-15 00:32:44.000000', 'consum', 0.0224, 'lps'),
	(491376, 128, '2014-01-15 00:32:45.000000', 'consum', 0.0222, 'lps'),
	(491377, 128, '2014-01-15 00:32:46.000000', 'consum', 0.0213, 'lps'),
	(491378, 128, '2014-01-15 00:32:47.000000', 'consum', 0.0222, 'lps'),
	(491379, 128, '2014-01-15 00:32:48.000000', 'consum', 0.0215, 'lps'),
	(491380, 128, '2014-01-15 00:32:49.000000', 'consum', 0.0212, 'lps'),
	(491381, 128, '2014-01-15 00:32:50.000000', 'consum', 0.0224, 'lps'),
	(491382, 128, '2014-01-15 00:32:51.000000', 'consum', 0.0224, 'lps'),
	(491383, 128, '2014-01-15 00:32:52.000000', 'consum', 0.0210, 'lps'),
	(491384, 128, '2014-01-15 00:32:53.000000', 'consum', 0.0213, 'lps'),
	(491385, 128, '2014-01-15 00:32:54.000000', 'consum', 0.0211, 'lps'),
	(491386, 128, '2014-01-15 00:32:55.000000', 'consum', 0.0222, 'lps'),
	(491387, 128, '2014-01-15 00:32:56.000000', 'consum', 0.0219, 'lps'),
	(491388, 128, '2014-01-15 00:32:57.000000', 'consum', 0.0220, 'lps'),
	(491389, 128, '2014-01-15 00:32:58.000000', 'consum', 0.0217, 'lps'),
	(491390, 128, '2014-01-15 00:32:59.000000', 'consum', 0.0217, 'lps'),
	(491391, 128, '2014-01-15 00:33:00.000000', 'consum', 0.0224, 'lps'),
	(491392, 128, '2014-01-15 00:33:01.000000', 'consum', 0.0225, 'lps'),
	(491393, 128, '2014-01-15 00:33:02.000000', 'consum', 0.0215, 'lps'),
	(491394, 128, '2014-01-15 00:33:03.000000', 'consum', 0.0221, 'lps'),
	(491395, 128, '2014-01-15 00:33:04.000000', 'consum', 0.0220, 'lps'),
	(491396, 128, '2014-01-15 00:33:05.000000', 'consum', 0.0224, 'lps'),
	(491397, 128, '2014-01-15 00:33:06.000000', 'consum', 0.0222, 'lps'),
	(491398, 128, '2014-01-15 00:33:07.000000', 'consum', 0.0211, 'lps'),
	(491399, 128, '2014-01-15 00:33:08.000000', 'consum', 0.0214, 'lps'),
	(491400, 128, '2014-01-15 00:33:09.000000', 'consum', 0.0224, 'lps'),
	(491401, 128, '2014-01-15 00:33:10.000000', 'consum', 0.0222, 'lps'),
	(491402, 128, '2014-01-15 00:33:11.000000', 'consum', 0.0211, 'lps'),
	(491403, 128, '2014-01-15 00:33:12.000000', 'consum', 0.0214, 'lps'),
	(491404, 128, '2014-01-15 00:33:13.000000', 'consum', 0.0211, 'lps'),
	(491405, 128, '2014-01-15 00:33:14.000000', 'consum', 0.0218, 'lps'),
	(491406, 128, '2014-01-15 00:33:15.000000', 'consum', 0.0215, 'lps'),
	(491407, 128, '2014-01-15 00:33:16.000000', 'consum', 0.0212, 'lps'),
	(491408, 128, '2014-01-15 00:33:17.000000', 'consum', 0.0223, 'lps'),
	(491409, 128, '2014-01-15 00:33:18.000000', 'consum', 0.0221, 'lps'),
	(491410, 128, '2014-01-15 00:33:19.000000', 'consum', 0.0211, 'lps'),
	(491411, 128, '2014-01-15 00:33:20.000000', 'consum', 0.0214, 'lps'),
	(491412, 128, '2014-01-15 00:33:21.000000', 'consum', 0.0214, 'lps'),
	(491413, 128, '2014-01-15 00:33:22.000000', 'consum', 0.0215, 'lps'),
	(491414, 128, '2014-01-15 00:33:23.000000', 'consum', 0.0223, 'lps'),
	(491415, 128, '2014-01-15 00:33:24.000000', 'consum', 0.0215, 'lps'),
	(491416, 128, '2014-01-15 00:33:25.000000', 'consum', 0.0212, 'lps'),
	(491417, 128, '2014-01-15 00:33:26.000000', 'consum', 0.0221, 'lps'),
	(491418, 128, '2014-01-15 00:33:27.000000', 'consum', 0.0212, 'lps'),
	(491419, 128, '2014-01-15 00:33:28.000000', 'consum', 0.0219, 'lps'),
	(491420, 128, '2014-01-15 00:33:29.000000', 'consum', 0.0216, 'lps'),
	(491421, 128, '2014-01-15 00:33:30.000000', 'consum', 0.0215, 'lps'),
	(491422, 128, '2014-01-15 00:33:31.000000', 'consum', 0.0218, 'lps'),
	(491423, 128, '2014-01-15 00:33:32.000000', 'consum', 0.0218, 'lps'),
	(491424, 128, '2014-01-15 00:33:33.000000', 'consum', 0.0211, 'lps'),
	(491425, 128, '2014-01-15 00:33:34.000000', 'consum', 0.0223, 'lps'),
	(491426, 128, '2014-01-15 00:33:35.000000', 'consum', 0.0225, 'lps'),
	(491427, 128, '2014-01-15 00:33:36.000000', 'consum', 0.0212, 'lps'),
	(491428, 128, '2014-01-15 00:33:37.000000', 'consum', 0.0211, 'lps'),
	(491429, 128, '2014-01-15 00:33:38.000000', 'consum', 0.0225, 'lps'),
	(491430, 128, '2014-01-15 00:33:39.000000', 'consum', 0.0217, 'lps'),
	(491431, 128, '2014-01-15 00:33:40.000000', 'consum', 0.0216, 'lps'),
	(491432, 128, '2014-01-15 00:33:41.000000', 'consum', 0.0221, 'lps'),
	(491433, 128, '2014-01-15 00:33:42.000000', 'consum', 0.0217, 'lps'),
	(491434, 128, '2014-01-15 00:33:43.000000', 'consum', 0.0210, 'lps'),
	(491435, 128, '2014-01-15 00:33:44.000000', 'consum', 0.0223, 'lps'),
	(491436, 128, '2014-01-15 00:33:45.000000', 'consum', 0.0213, 'lps'),
	(491437, 128, '2014-01-15 00:33:46.000000', 'consum', 0.0218, 'lps'),
	(491438, 128, '2014-01-15 00:33:47.000000', 'consum', 0.0223, 'lps'),
	(491439, 128, '2014-01-15 00:33:48.000000', 'consum', 0.0221, 'lps'),
	(491440, 128, '2014-01-15 00:33:49.000000', 'consum', 0.0225, 'lps'),
	(491441, 128, '2014-01-15 00:33:50.000000', 'consum', 0.0221, 'lps'),
	(491442, 128, '2014-01-15 00:33:51.000000', 'consum', 0.0220, 'lps'),
	(491443, 128, '2014-01-15 00:33:52.000000', 'consum', 0.0212, 'lps'),
	(491444, 128, '2014-01-15 00:33:53.000000', 'consum', 0.0221, 'lps'),
	(491445, 128, '2014-01-15 00:33:54.000000', 'consum', 0.0215, 'lps'),
	(491446, 128, '2014-01-15 00:33:55.000000', 'consum', 0.0215, 'lps'),
	(491447, 128, '2014-01-15 00:33:56.000000', 'consum', 0.0223, 'lps'),
	(491448, 128, '2014-01-15 00:33:57.000000', 'consum', 0.0213, 'lps'),
	(491449, 128, '2014-01-15 00:33:58.000000', 'consum', 0.0219, 'lps'),
	(491450, 128, '2014-01-15 00:33:59.000000', 'consum', 0.0212, 'lps'),
	(491451, 128, '2014-01-15 00:34:00.000000', 'consum', 0.0211, 'lps'),
	(491452, 128, '2014-01-15 00:34:01.000000', 'consum', 0.0224, 'lps'),
	(491453, 128, '2014-01-15 00:34:02.000000', 'consum', 0.0216, 'lps'),
	(491454, 128, '2014-01-15 00:34:03.000000', 'consum', 0.0213, 'lps'),
	(491455, 128, '2014-01-15 00:34:04.000000', 'consum', 0.0225, 'lps'),
	(491456, 128, '2014-01-15 00:34:05.000000', 'consum', 0.0212, 'lps'),
	(491457, 128, '2014-01-15 00:34:06.000000', 'consum', 0.0225, 'lps'),
	(491458, 128, '2014-01-15 00:34:07.000000', 'consum', 0.0215, 'lps'),
	(491459, 128, '2014-01-15 00:34:08.000000', 'consum', 0.0221, 'lps'),
	(491460, 128, '2014-01-15 00:34:09.000000', 'consum', 0.0219, 'lps'),
	(491461, 128, '2014-01-15 00:34:10.000000', 'consum', 0.0224, 'lps'),
	(491462, 128, '2014-01-15 00:34:11.000000', 'consum', 0.0221, 'lps'),
	(491463, 128, '2014-01-15 00:34:12.000000', 'consum', 0.0225, 'lps'),
	(491464, 128, '2014-01-15 00:34:13.000000', 'consum', 0.0220, 'lps'),
	(491465, 128, '2014-01-15 00:34:14.000000', 'consum', 0.0214, 'lps'),
	(491466, 128, '2014-01-15 00:34:15.000000', 'consum', 0.0218, 'lps'),
	(491467, 128, '2014-01-15 00:34:16.000000', 'consum', 0.0222, 'lps'),
	(491468, 128, '2014-01-15 00:34:17.000000', 'consum', 0.0213, 'lps'),
	(491469, 128, '2014-01-15 00:34:18.000000', 'consum', 0.0225, 'lps'),
	(491470, 128, '2014-01-15 00:34:19.000000', 'consum', 0.0225, 'lps'),
	(491471, 128, '2014-01-15 00:34:20.000000', 'consum', 0.0225, 'lps'),
	(491472, 128, '2014-01-15 00:34:21.000000', 'consum', 0.0210, 'lps'),
	(491473, 128, '2014-01-15 00:34:22.000000', 'consum', 0.0214, 'lps'),
	(491474, 128, '2014-01-15 00:34:23.000000', 'consum', 0.0216, 'lps'),
	(491475, 128, '2014-01-15 00:34:24.000000', 'consum', 0.0225, 'lps'),
	(491476, 128, '2014-01-15 00:34:25.000000', 'consum', 0.0222, 'lps'),
	(491477, 128, '2014-01-15 00:34:26.000000', 'consum', 0.0225, 'lps'),
	(491478, 128, '2014-01-15 00:34:27.000000', 'consum', 0.0217, 'lps'),
	(491479, 128, '2014-01-15 00:34:28.000000', 'consum', 0.0215, 'lps'),
	(491480, 128, '2014-01-15 00:34:29.000000', 'consum', 0.0215, 'lps'),
	(491481, 128, '2014-01-15 00:34:30.000000', 'consum', 0.0222, 'lps'),
	(491482, 128, '2014-01-15 00:34:31.000000', 'consum', 0.0224, 'lps'),
	(491483, 128, '2014-01-15 00:34:32.000000', 'consum', 0.0211, 'lps'),
	(491484, 128, '2014-01-15 00:34:33.000000', 'consum', 0.0222, 'lps'),
	(491485, 128, '2014-01-15 00:34:34.000000', 'consum', 0.0217, 'lps'),
	(491486, 128, '2014-01-15 00:34:35.000000', 'consum', 0.0213, 'lps'),
	(491487, 128, '2014-01-15 00:34:36.000000', 'consum', 0.0219, 'lps'),
	(491488, 128, '2014-01-15 00:34:37.000000', 'consum', 0.0214, 'lps'),
	(491489, 128, '2014-01-15 00:34:38.000000', 'consum', 0.0220, 'lps'),
	(491490, 128, '2014-01-15 00:34:39.000000', 'consum', 0.0217, 'lps'),
	(491491, 128, '2014-01-15 00:34:40.000000', 'consum', 0.0216, 'lps'),
	(491492, 128, '2014-01-15 00:34:41.000000', 'consum', 0.0219, 'lps'),
	(491493, 128, '2014-01-15 00:34:42.000000', 'consum', 0.0222, 'lps'),
	(491494, 128, '2014-01-15 00:34:43.000000', 'consum', 0.0212, 'lps'),
	(491495, 128, '2014-01-15 00:34:44.000000', 'consum', 0.0215, 'lps'),
	(491496, 128, '2014-01-15 00:34:45.000000', 'consum', 0.0214, 'lps'),
	(491497, 128, '2014-01-15 00:34:46.000000', 'consum', 0.0214, 'lps'),
	(491498, 128, '2014-01-15 00:34:47.000000', 'consum', 0.0220, 'lps'),
	(491499, 128, '2014-01-15 00:34:48.000000', 'consum', 0.0218, 'lps'),
	(491500, 128, '2014-01-15 00:34:49.000000', 'consum', 0.0218, 'lps'),
	(491501, 128, '2014-01-15 00:34:50.000000', 'consum', 0.0212, 'lps'),
	(491502, 128, '2014-01-15 00:34:51.000000', 'consum', 0.0213, 'lps'),
	(491503, 128, '2014-01-15 00:34:52.000000', 'consum', 0.0218, 'lps'),
	(491504, 128, '2014-01-15 00:34:53.000000', 'consum', 0.0210, 'lps'),
	(491505, 128, '2014-01-15 00:34:54.000000', 'consum', 0.0218, 'lps'),
	(491506, 128, '2014-01-15 00:34:55.000000', 'consum', 0.0219, 'lps'),
	(491507, 128, '2014-01-15 00:34:56.000000', 'consum', 0.0214, 'lps'),
	(491508, 128, '2014-01-15 00:34:57.000000', 'consum', 0.0221, 'lps'),
	(491509, 128, '2014-01-15 00:34:58.000000', 'consum', 0.0221, 'lps'),
	(491510, 128, '2014-01-15 00:34:59.000000', 'consum', 0.0216, 'lps'),
	(491511, 128, '2014-01-15 00:35:00.000000', 'consum', 0.0223, 'lps'),
	(491512, 128, '2014-01-15 00:35:01.000000', 'consum', 0.0211, 'lps'),
	(491513, 128, '2014-01-15 00:35:02.000000', 'consum', 0.0224, 'lps'),
	(491514, 128, '2014-01-15 00:35:03.000000', 'consum', 0.0212, 'lps'),
	(491515, 128, '2014-01-15 00:35:04.000000', 'consum', 0.0212, 'lps'),
	(491516, 128, '2014-01-15 00:35:05.000000', 'consum', 0.0212, 'lps'),
	(491517, 128, '2014-01-15 00:35:06.000000', 'consum', 0.0218, 'lps'),
	(491518, 128, '2014-01-15 00:35:07.000000', 'consum', 0.0211, 'lps'),
	(491519, 128, '2014-01-15 00:35:08.000000', 'consum', 0.0225, 'lps'),
	(491520, 128, '2014-01-15 00:35:09.000000', 'consum', 0.0219, 'lps'),
	(491521, 128, '2014-01-15 00:35:10.000000', 'consum', 0.0223, 'lps'),
	(491522, 128, '2014-01-15 00:35:11.000000', 'consum', 0.0220, 'lps'),
	(491523, 128, '2014-01-15 00:35:12.000000', 'consum', 0.0222, 'lps'),
	(491524, 128, '2014-01-15 00:35:13.000000', 'consum', 0.0222, 'lps'),
	(491525, 128, '2014-01-15 00:35:14.000000', 'consum', 0.0218, 'lps'),
	(491526, 128, '2014-01-15 00:35:15.000000', 'consum', 0.0218, 'lps'),
	(491527, 128, '2014-01-15 00:35:16.000000', 'consum', 0.0223, 'lps'),
	(491528, 128, '2014-01-15 00:35:17.000000', 'consum', 0.0219, 'lps'),
	(491529, 128, '2014-01-15 00:35:18.000000', 'consum', 0.0219, 'lps'),
	(491530, 128, '2014-01-15 00:35:19.000000', 'consum', 0.0213, 'lps'),
	(491531, 128, '2014-01-15 00:35:20.000000', 'consum', 0.0215, 'lps'),
	(491532, 128, '2014-01-15 00:35:21.000000', 'consum', 0.0224, 'lps'),
	(491533, 128, '2014-01-15 00:35:22.000000', 'consum', 0.0218, 'lps'),
	(491534, 128, '2014-01-15 00:35:23.000000', 'consum', 0.0225, 'lps'),
	(491535, 128, '2014-01-15 00:35:24.000000', 'consum', 0.0215, 'lps'),
	(491536, 128, '2014-01-15 00:35:25.000000', 'consum', 0.0222, 'lps'),
	(491537, 128, '2014-01-15 00:35:26.000000', 'consum', 0.0223, 'lps'),
	(491538, 128, '2014-01-15 00:35:27.000000', 'consum', 0.0224, 'lps'),
	(491539, 128, '2014-01-15 00:35:28.000000', 'consum', 0.0225, 'lps'),
	(491540, 128, '2014-01-15 00:35:29.000000', 'consum', 0.0212, 'lps'),
	(491541, 128, '2014-01-15 00:35:30.000000', 'consum', 0.0223, 'lps'),
	(491542, 128, '2014-01-15 00:35:31.000000', 'consum', 0.0222, 'lps'),
	(491543, 128, '2014-01-15 00:35:32.000000', 'consum', 0.0217, 'lps'),
	(491544, 128, '2014-01-15 00:35:33.000000', 'consum', 0.0225, 'lps'),
	(491545, 128, '2014-01-15 00:35:34.000000', 'consum', 0.0216, 'lps'),
	(491546, 128, '2014-01-15 00:35:35.000000', 'consum', 0.0210, 'lps'),
	(491547, 128, '2014-01-15 00:35:36.000000', 'consum', 0.0224, 'lps'),
	(491548, 128, '2014-01-15 00:35:37.000000', 'consum', 0.0219, 'lps'),
	(491549, 128, '2014-01-15 00:35:38.000000', 'consum', 0.0211, 'lps'),
	(491550, 128, '2014-01-15 00:35:39.000000', 'consum', 0.0221, 'lps'),
	(491551, 128, '2014-01-15 00:35:40.000000', 'consum', 0.0216, 'lps'),
	(491552, 128, '2014-01-15 00:35:41.000000', 'consum', 0.0224, 'lps'),
	(491553, 128, '2014-01-15 00:35:42.000000', 'consum', 0.0215, 'lps'),
	(491554, 128, '2014-01-15 00:35:43.000000', 'consum', 0.0223, 'lps'),
	(491555, 128, '2014-01-15 00:35:44.000000', 'consum', 0.0212, 'lps'),
	(491556, 128, '2014-01-15 00:35:45.000000', 'consum', 0.0215, 'lps'),
	(491557, 128, '2014-01-15 00:35:46.000000', 'consum', 0.0214, 'lps'),
	(491558, 128, '2014-01-15 00:35:47.000000', 'consum', 0.0214, 'lps'),
	(491559, 128, '2014-01-15 00:35:48.000000', 'consum', 0.0220, 'lps'),
	(491560, 128, '2014-01-15 00:35:49.000000', 'consum', 0.0217, 'lps'),
	(491561, 128, '2014-01-15 00:35:50.000000', 'consum', 0.0216, 'lps'),
	(491562, 128, '2014-01-15 00:35:51.000000', 'consum', 0.0217, 'lps'),
	(491563, 128, '2014-01-15 00:35:52.000000', 'consum', 0.0211, 'lps'),
	(491564, 128, '2014-01-15 00:35:53.000000', 'consum', 0.0213, 'lps'),
	(491565, 128, '2014-01-15 00:35:54.000000', 'consum', 0.0223, 'lps'),
	(491566, 128, '2014-01-15 00:35:55.000000', 'consum', 0.0219, 'lps'),
	(491567, 128, '2014-01-15 00:35:56.000000', 'consum', 0.0215, 'lps'),
	(491568, 128, '2014-01-15 00:35:57.000000', 'consum', 0.0211, 'lps'),
	(491569, 128, '2014-01-15 00:35:58.000000', 'consum', 0.0214, 'lps'),
	(491570, 128, '2014-01-15 00:35:59.000000', 'consum', 0.0212, 'lps'),
	(491571, 128, '2014-01-15 00:36:00.000000', 'consum', 0.0210, 'lps'),
	(491572, 128, '2014-01-15 00:36:01.000000', 'consum', 0.0220, 'lps'),
	(491573, 128, '2014-01-15 00:36:02.000000', 'consum', 0.0213, 'lps'),
	(491574, 128, '2014-01-15 00:36:03.000000', 'consum', 0.0210, 'lps'),
	(491575, 128, '2014-01-15 00:36:04.000000', 'consum', 0.0220, 'lps'),
	(491576, 128, '2014-01-15 00:36:05.000000', 'consum', 0.0211, 'lps'),
	(491577, 128, '2014-01-15 00:36:06.000000', 'consum', 0.0217, 'lps'),
	(491578, 128, '2014-01-15 00:36:07.000000', 'consum', 0.0225, 'lps'),
	(491579, 128, '2014-01-15 00:36:08.000000', 'consum', 0.0218, 'lps'),
	(491580, 128, '2014-01-15 00:36:09.000000', 'consum', 0.0223, 'lps'),
	(491581, 128, '2014-01-15 00:36:10.000000', 'consum', 0.0216, 'lps'),
	(491582, 128, '2014-01-15 00:36:11.000000', 'consum', 0.0221, 'lps'),
	(491583, 128, '2014-01-15 00:36:12.000000', 'consum', 0.0214, 'lps'),
	(491584, 128, '2014-01-15 00:36:13.000000', 'consum', 0.0213, 'lps'),
	(491585, 128, '2014-01-15 00:36:14.000000', 'consum', 0.0216, 'lps'),
	(491586, 128, '2014-01-15 00:36:15.000000', 'consum', 0.0213, 'lps'),
	(491587, 128, '2014-01-15 00:36:16.000000', 'consum', 0.0224, 'lps'),
	(491588, 128, '2014-01-15 00:36:17.000000', 'consum', 0.0222, 'lps'),
	(491589, 128, '2014-01-15 00:36:18.000000', 'consum', 0.0215, 'lps'),
	(491590, 128, '2014-01-15 00:36:19.000000', 'consum', 0.0215, 'lps'),
	(491591, 128, '2014-01-15 00:36:20.000000', 'consum', 0.0219, 'lps'),
	(491592, 128, '2014-01-15 00:36:21.000000', 'consum', 0.0210, 'lps'),
	(491593, 128, '2014-01-15 00:36:22.000000', 'consum', 0.0216, 'lps'),
	(491594, 128, '2014-01-15 00:36:23.000000', 'consum', 0.0223, 'lps'),
	(491595, 128, '2014-01-15 00:36:24.000000', 'consum', 0.0224, 'lps'),
	(491596, 128, '2014-01-15 00:36:25.000000', 'consum', 0.0211, 'lps'),
	(491597, 128, '2014-01-15 00:36:26.000000', 'consum', 0.0223, 'lps'),
	(491598, 128, '2014-01-15 00:36:27.000000', 'consum', 0.0223, 'lps'),
	(491599, 128, '2014-01-15 00:36:28.000000', 'consum', 0.0222, 'lps'),
	(491600, 128, '2014-01-15 00:36:29.000000', 'consum', 0.0215, 'lps'),
	(491601, 128, '2014-01-15 00:36:30.000000', 'consum', 0.0213, 'lps'),
	(491602, 128, '2014-01-15 00:36:31.000000', 'consum', 0.0213, 'lps'),
	(491603, 128, '2014-01-15 00:36:32.000000', 'consum', 0.0216, 'lps'),
	(491604, 128, '2014-01-15 00:36:33.000000', 'consum', 0.0216, 'lps'),
	(491605, 128, '2014-01-15 00:36:34.000000', 'consum', 0.0223, 'lps'),
	(491606, 128, '2014-01-15 00:36:35.000000', 'consum', 0.0224, 'lps'),
	(491607, 128, '2014-01-15 00:36:36.000000', 'consum', 0.0210, 'lps'),
	(491608, 128, '2014-01-15 00:36:37.000000', 'consum', 0.0218, 'lps'),
	(491609, 128, '2014-01-15 00:36:38.000000', 'consum', 0.0218, 'lps'),
	(491610, 128, '2014-01-15 00:36:39.000000', 'consum', 0.0212, 'lps'),
	(491611, 128, '2014-01-15 00:36:40.000000', 'consum', 0.0210, 'lps'),
	(491612, 128, '2014-01-15 00:36:41.000000', 'consum', 0.0223, 'lps'),
	(491613, 128, '2014-01-15 00:36:42.000000', 'consum', 0.0210, 'lps'),
	(491614, 128, '2014-01-15 00:36:43.000000', 'consum', 0.0221, 'lps'),
	(491615, 128, '2014-01-15 00:36:44.000000', 'consum', 0.0218, 'lps'),
	(491616, 128, '2014-01-15 00:36:45.000000', 'consum', 0.0216, 'lps'),
	(491617, 128, '2014-01-15 00:36:46.000000', 'consum', 0.0215, 'lps'),
	(491618, 128, '2014-01-15 00:36:47.000000', 'consum', 0.0221, 'lps'),
	(491619, 128, '2014-01-15 00:36:48.000000', 'consum', 0.0216, 'lps'),
	(491620, 128, '2014-01-15 00:36:49.000000', 'consum', 0.0210, 'lps'),
	(491621, 128, '2014-01-15 00:36:50.000000', 'consum', 0.0223, 'lps'),
	(491622, 128, '2014-01-15 00:36:51.000000', 'consum', 0.0213, 'lps'),
	(491623, 128, '2014-01-15 00:36:52.000000', 'consum', 0.0217, 'lps'),
	(491624, 128, '2014-01-15 00:36:53.000000', 'consum', 0.0219, 'lps'),
	(491625, 128, '2014-01-15 00:36:54.000000', 'consum', 0.0221, 'lps'),
	(491626, 128, '2014-01-15 00:36:55.000000', 'consum', 0.0224, 'lps'),
	(491627, 128, '2014-01-15 00:36:56.000000', 'consum', 0.0213, 'lps'),
	(491628, 128, '2014-01-15 00:36:57.000000', 'consum', 0.0215, 'lps'),
	(491629, 128, '2014-01-15 00:36:58.000000', 'consum', 0.0213, 'lps'),
	(491630, 128, '2014-01-15 00:36:59.000000', 'consum', 0.0225, 'lps'),
	(491631, 128, '2014-01-15 00:37:00.000000', 'consum', 0.0213, 'lps'),
	(491632, 128, '2014-01-15 00:37:01.000000', 'consum', 0.0210, 'lps'),
	(491633, 128, '2014-01-15 00:37:02.000000', 'consum', 0.0221, 'lps'),
	(491634, 128, '2014-01-15 00:37:03.000000', 'consum', 0.0216, 'lps'),
	(491635, 128, '2014-01-15 00:37:04.000000', 'consum', 0.0222, 'lps'),
	(491636, 128, '2014-01-15 00:37:05.000000', 'consum', 0.0222, 'lps'),
	(491637, 128, '2014-01-15 00:37:06.000000', 'consum', 0.0217, 'lps'),
	(491638, 128, '2014-01-15 00:37:07.000000', 'consum', 0.0211, 'lps'),
	(491639, 128, '2014-01-15 00:37:08.000000', 'consum', 0.0210, 'lps'),
	(491640, 128, '2014-01-15 00:37:09.000000', 'consum', 0.0222, 'lps'),
	(491641, 128, '2014-01-15 00:37:10.000000', 'consum', 0.0224, 'lps'),
	(491642, 128, '2014-01-15 00:37:11.000000', 'consum', 0.0214, 'lps'),
	(491643, 128, '2014-01-15 00:37:12.000000', 'consum', 0.0220, 'lps'),
	(491644, 128, '2014-01-15 00:37:13.000000', 'consum', 0.0218, 'lps'),
	(491645, 128, '2014-01-15 00:37:14.000000', 'consum', 0.0219, 'lps'),
	(491646, 128, '2014-01-15 00:37:15.000000', 'consum', 0.0217, 'lps'),
	(491647, 128, '2014-01-15 00:37:16.000000', 'consum', 0.0217, 'lps'),
	(491648, 128, '2014-01-15 00:37:17.000000', 'consum', 0.0211, 'lps'),
	(491649, 128, '2014-01-15 00:37:18.000000', 'consum', 0.0223, 'lps'),
	(491650, 128, '2014-01-15 00:37:19.000000', 'consum', 0.0211, 'lps'),
	(491651, 128, '2014-01-15 00:37:20.000000', 'consum', 0.0210, 'lps'),
	(491652, 128, '2014-01-15 00:37:21.000000', 'consum', 0.0220, 'lps'),
	(491653, 128, '2014-01-15 00:37:22.000000', 'consum', 0.0216, 'lps'),
	(491654, 128, '2014-01-15 00:37:23.000000', 'consum', 0.0225, 'lps'),
	(491655, 128, '2014-01-15 00:37:24.000000', 'consum', 0.0218, 'lps'),
	(491656, 128, '2014-01-15 00:37:25.000000', 'consum', 0.0224, 'lps'),
	(491657, 128, '2014-01-15 00:37:26.000000', 'consum', 0.0225, 'lps'),
	(491658, 128, '2014-01-15 00:37:27.000000', 'consum', 0.0211, 'lps'),
	(491659, 128, '2014-01-15 00:37:28.000000', 'consum', 0.0218, 'lps'),
	(491660, 128, '2014-01-15 00:37:29.000000', 'consum', 0.0217, 'lps'),
	(491661, 128, '2014-01-15 00:37:30.000000', 'consum', 0.0220, 'lps'),
	(491662, 128, '2014-01-15 00:37:31.000000', 'consum', 0.0223, 'lps'),
	(491663, 128, '2014-01-15 00:37:32.000000', 'consum', 0.0213, 'lps'),
	(491664, 128, '2014-01-15 00:37:33.000000', 'consum', 0.0220, 'lps'),
	(491665, 128, '2014-01-15 00:37:34.000000', 'consum', 0.0217, 'lps'),
	(491666, 128, '2014-01-15 00:37:35.000000', 'consum', 0.0218, 'lps'),
	(491667, 128, '2014-01-15 00:37:36.000000', 'consum', 0.0212, 'lps'),
	(491668, 128, '2014-01-15 00:37:37.000000', 'consum', 0.0214, 'lps'),
	(491669, 128, '2014-01-15 00:37:38.000000', 'consum', 0.0225, 'lps'),
	(491670, 128, '2014-01-15 00:37:39.000000', 'consum', 0.0211, 'lps'),
	(491671, 128, '2014-01-15 00:37:40.000000', 'consum', 0.0215, 'lps'),
	(491672, 128, '2014-01-15 00:37:41.000000', 'consum', 0.0219, 'lps'),
	(491673, 128, '2014-01-15 00:37:42.000000', 'consum', 0.0225, 'lps'),
	(491674, 128, '2014-01-15 00:37:43.000000', 'consum', 0.0210, 'lps'),
	(491675, 128, '2014-01-15 00:37:44.000000', 'consum', 0.0211, 'lps'),
	(491676, 128, '2014-01-15 00:37:45.000000', 'consum', 0.0218, 'lps'),
	(491677, 128, '2014-01-15 00:37:46.000000', 'consum', 0.0214, 'lps'),
	(491678, 128, '2014-01-15 00:37:47.000000', 'consum', 0.0223, 'lps'),
	(491679, 128, '2014-01-15 00:37:48.000000', 'consum', 0.0216, 'lps'),
	(491680, 128, '2014-01-15 00:37:49.000000', 'consum', 0.0219, 'lps'),
	(491681, 128, '2014-01-15 00:37:50.000000', 'consum', 0.0219, 'lps'),
	(491682, 128, '2014-01-15 00:37:51.000000', 'consum', 0.0211, 'lps'),
	(491683, 128, '2014-01-15 00:37:52.000000', 'consum', 0.0223, 'lps'),
	(491684, 128, '2014-01-15 00:37:53.000000', 'consum', 0.0210, 'lps'),
	(491685, 128, '2014-01-15 00:37:54.000000', 'consum', 0.0216, 'lps'),
	(491686, 128, '2014-01-15 00:37:55.000000', 'consum', 0.0211, 'lps'),
	(491687, 128, '2014-01-15 00:37:56.000000', 'consum', 0.0214, 'lps'),
	(491688, 128, '2014-01-15 00:37:57.000000', 'consum', 0.0225, 'lps'),
	(491689, 128, '2014-01-15 00:37:58.000000', 'consum', 0.0212, 'lps'),
	(491690, 128, '2014-01-15 00:37:59.000000', 'consum', 0.0223, 'lps'),
	(491691, 128, '2014-01-15 00:38:00.000000', 'consum', 0.0220, 'lps'),
	(491692, 128, '2014-01-15 00:38:01.000000', 'consum', 0.0223, 'lps'),
	(491693, 128, '2014-01-15 00:38:02.000000', 'consum', 0.0211, 'lps'),
	(491694, 128, '2014-01-15 00:38:03.000000', 'consum', 0.0211, 'lps'),
	(491695, 128, '2014-01-15 00:38:04.000000', 'consum', 0.0213, 'lps'),
	(491696, 128, '2014-01-15 00:38:05.000000', 'consum', 0.0220, 'lps'),
	(491697, 128, '2014-01-15 00:38:06.000000', 'consum', 0.0219, 'lps'),
	(491698, 128, '2014-01-15 00:38:07.000000', 'consum', 0.0211, 'lps'),
	(491699, 128, '2014-01-15 00:38:08.000000', 'consum', 0.0220, 'lps'),
	(491700, 128, '2014-01-15 00:38:09.000000', 'consum', 0.0225, 'lps'),
	(491701, 128, '2014-01-15 00:38:10.000000', 'consum', 0.0225, 'lps'),
	(491702, 128, '2014-01-15 00:38:11.000000', 'consum', 0.0225, 'lps'),
	(491703, 128, '2014-01-15 00:38:12.000000', 'consum', 0.0224, 'lps'),
	(491704, 128, '2014-01-15 00:38:13.000000', 'consum', 0.0220, 'lps'),
	(491705, 128, '2014-01-15 00:38:14.000000', 'consum', 0.0219, 'lps'),
	(491706, 128, '2014-01-15 00:38:15.000000', 'consum', 0.0210, 'lps'),
	(491707, 128, '2014-01-15 00:38:16.000000', 'consum', 0.0216, 'lps'),
	(491708, 128, '2014-01-15 00:38:17.000000', 'consum', 0.0223, 'lps'),
	(491709, 128, '2014-01-15 00:38:18.000000', 'consum', 0.0210, 'lps'),
	(491710, 128, '2014-01-15 00:38:19.000000', 'consum', 0.0218, 'lps'),
	(491711, 128, '2014-01-15 00:38:20.000000', 'consum', 0.0221, 'lps'),
	(491712, 128, '2014-01-15 00:38:21.000000', 'consum', 0.0225, 'lps'),
	(491713, 128, '2014-01-15 00:38:22.000000', 'consum', 0.0219, 'lps'),
	(491714, 128, '2014-01-15 00:38:23.000000', 'consum', 0.0211, 'lps'),
	(491715, 128, '2014-01-15 00:38:24.000000', 'consum', 0.0223, 'lps'),
	(491716, 128, '2014-01-15 00:38:25.000000', 'consum', 0.0222, 'lps'),
	(491717, 128, '2014-01-15 00:38:26.000000', 'consum', 0.0217, 'lps'),
	(491718, 128, '2014-01-15 00:38:27.000000', 'consum', 0.0223, 'lps'),
	(491719, 128, '2014-01-15 00:38:28.000000', 'consum', 0.0225, 'lps'),
	(491720, 128, '2014-01-15 00:38:29.000000', 'consum', 0.0215, 'lps'),
	(491721, 128, '2014-01-15 00:38:30.000000', 'consum', 0.0222, 'lps'),
	(491722, 128, '2014-01-15 00:38:31.000000', 'consum', 0.0223, 'lps'),
	(491723, 128, '2014-01-15 00:38:32.000000', 'consum', 0.0224, 'lps'),
	(491724, 128, '2014-01-15 00:38:33.000000', 'consum', 0.0210, 'lps'),
	(491725, 128, '2014-01-15 00:38:34.000000', 'consum', 0.0216, 'lps'),
	(491726, 128, '2014-01-15 00:38:35.000000', 'consum', 0.0223, 'lps'),
	(491727, 128, '2014-01-15 00:38:36.000000', 'consum', 0.0212, 'lps'),
	(491728, 128, '2014-01-15 00:38:37.000000', 'consum', 0.0214, 'lps'),
	(491729, 128, '2014-01-15 00:38:38.000000', 'consum', 0.0224, 'lps'),
	(491730, 128, '2014-01-15 00:38:39.000000', 'consum', 0.0222, 'lps'),
	(491731, 128, '2014-01-15 00:38:40.000000', 'consum', 0.0212, 'lps'),
	(491732, 128, '2014-01-15 00:38:41.000000', 'consum', 0.0216, 'lps'),
	(491733, 128, '2014-01-15 00:38:42.000000', 'consum', 0.0217, 'lps'),
	(491734, 128, '2014-01-15 00:38:43.000000', 'consum', 0.0213, 'lps'),
	(491735, 128, '2014-01-15 00:38:44.000000', 'consum', 0.0218, 'lps'),
	(491736, 128, '2014-01-15 00:38:45.000000', 'consum', 0.0212, 'lps'),
	(491737, 128, '2014-01-15 00:38:46.000000', 'consum', 0.0211, 'lps'),
	(491738, 128, '2014-01-15 00:38:47.000000', 'consum', 0.0210, 'lps'),
	(491739, 128, '2014-01-15 00:38:48.000000', 'consum', 0.0222, 'lps'),
	(491740, 128, '2014-01-15 00:38:49.000000', 'consum', 0.0210, 'lps'),
	(491741, 128, '2014-01-15 00:38:50.000000', 'consum', 0.0219, 'lps'),
	(491742, 128, '2014-01-15 00:38:51.000000', 'consum', 0.0225, 'lps'),
	(491743, 128, '2014-01-15 00:38:52.000000', 'consum', 0.0212, 'lps'),
	(491744, 128, '2014-01-15 00:38:53.000000', 'consum', 0.0224, 'lps'),
	(491745, 128, '2014-01-15 00:38:54.000000', 'consum', 0.0211, 'lps'),
	(491746, 128, '2014-01-15 00:38:55.000000', 'consum', 0.0221, 'lps'),
	(491747, 128, '2014-01-15 00:38:56.000000', 'consum', 0.0212, 'lps'),
	(491748, 128, '2014-01-15 00:38:57.000000', 'consum', 0.0222, 'lps'),
	(491749, 128, '2014-01-15 00:38:58.000000', 'consum', 0.0214, 'lps'),
	(491750, 128, '2014-01-15 00:38:59.000000', 'consum', 0.0212, 'lps'),
	(491751, 128, '2014-01-15 00:39:00.000000', 'consum', 0.0225, 'lps'),
	(491752, 128, '2014-01-15 00:39:01.000000', 'consum', 0.0213, 'lps'),
	(491753, 128, '2014-01-15 00:39:02.000000', 'consum', 0.0216, 'lps'),
	(491754, 128, '2014-01-15 00:39:03.000000', 'consum', 0.0214, 'lps'),
	(491755, 128, '2014-01-15 00:39:04.000000', 'consum', 0.0213, 'lps'),
	(491756, 128, '2014-01-15 00:39:05.000000', 'consum', 0.0213, 'lps'),
	(491757, 128, '2014-01-15 00:39:06.000000', 'consum', 0.0217, 'lps'),
	(491758, 128, '2014-01-15 00:39:07.000000', 'consum', 0.0222, 'lps'),
	(491759, 128, '2014-01-15 00:39:08.000000', 'consum', 0.0217, 'lps'),
	(491760, 128, '2014-01-15 00:39:09.000000', 'consum', 0.0211, 'lps'),
	(491761, 128, '2014-01-15 00:39:10.000000', 'consum', 0.0224, 'lps'),
	(491762, 128, '2014-01-15 00:39:11.000000', 'consum', 0.0214, 'lps'),
	(491763, 128, '2014-01-15 00:39:12.000000', 'consum', 0.0221, 'lps'),
	(491764, 128, '2014-01-15 00:39:13.000000', 'consum', 0.0223, 'lps'),
	(491765, 128, '2014-01-15 00:39:14.000000', 'consum', 0.0225, 'lps'),
	(491766, 128, '2014-01-15 00:39:15.000000', 'consum', 0.0216, 'lps'),
	(491767, 128, '2014-01-15 00:39:16.000000', 'consum', 0.0212, 'lps'),
	(491768, 128, '2014-01-15 00:39:17.000000', 'consum', 0.0215, 'lps'),
	(491769, 128, '2014-01-15 00:39:18.000000', 'consum', 0.0217, 'lps'),
	(491770, 128, '2014-01-15 00:39:19.000000', 'consum', 0.0213, 'lps'),
	(491771, 128, '2014-01-15 00:39:20.000000', 'consum', 0.0220, 'lps'),
	(491772, 128, '2014-01-15 00:39:21.000000', 'consum', 0.0221, 'lps'),
	(491773, 128, '2014-01-15 00:39:22.000000', 'consum', 0.0219, 'lps'),
	(491774, 128, '2014-01-15 00:39:23.000000', 'consum', 0.0221, 'lps'),
	(491775, 128, '2014-01-15 00:39:24.000000', 'consum', 0.0224, 'lps'),
	(491776, 128, '2014-01-15 00:39:25.000000', 'consum', 0.0217, 'lps'),
	(491777, 128, '2014-01-15 00:39:26.000000', 'consum', 0.0216, 'lps'),
	(491778, 128, '2014-01-15 00:39:27.000000', 'consum', 0.0221, 'lps'),
	(491779, 128, '2014-01-15 00:39:28.000000', 'consum', 0.0217, 'lps'),
	(491780, 128, '2014-01-15 00:39:29.000000', 'consum', 0.0225, 'lps'),
	(491781, 128, '2014-01-15 00:39:30.000000', 'consum', 0.0220, 'lps'),
	(491782, 128, '2014-01-15 00:39:31.000000', 'consum', 0.0216, 'lps'),
	(491783, 128, '2014-01-15 00:39:32.000000', 'consum', 0.0224, 'lps'),
	(491784, 128, '2014-01-15 00:39:33.000000', 'consum', 0.0217, 'lps'),
	(491785, 128, '2014-01-15 00:39:34.000000', 'consum', 0.0218, 'lps'),
	(491786, 128, '2014-01-15 00:39:35.000000', 'consum', 0.0215, 'lps'),
	(491787, 128, '2014-01-15 00:39:36.000000', 'consum', 0.0210, 'lps'),
	(491788, 128, '2014-01-15 00:39:37.000000', 'consum', 0.0214, 'lps'),
	(491789, 128, '2014-01-15 00:39:38.000000', 'consum', 0.0213, 'lps'),
	(491790, 128, '2014-01-15 00:39:39.000000', 'consum', 0.0212, 'lps'),
	(491791, 128, '2014-01-15 00:39:40.000000', 'consum', 0.0213, 'lps'),
	(491792, 128, '2014-01-15 00:39:41.000000', 'consum', 0.0219, 'lps'),
	(491793, 128, '2014-01-15 00:39:42.000000', 'consum', 0.0216, 'lps'),
	(491794, 128, '2014-01-15 00:39:43.000000', 'consum', 0.0214, 'lps'),
	(491795, 128, '2014-01-15 00:39:44.000000', 'consum', 0.0225, 'lps'),
	(491796, 128, '2014-01-15 00:39:45.000000', 'consum', 0.0213, 'lps'),
	(491797, 128, '2014-01-15 00:39:46.000000', 'consum', 0.0211, 'lps'),
	(491798, 128, '2014-01-15 00:39:47.000000', 'consum', 0.0225, 'lps'),
	(491799, 128, '2014-01-15 00:39:48.000000', 'consum', 0.0215, 'lps'),
	(491800, 128, '2014-01-15 00:39:49.000000', 'consum', 0.0224, 'lps'),
	(491801, 128, '2014-01-15 00:39:50.000000', 'consum', 0.0216, 'lps'),
	(491802, 128, '2014-01-15 00:39:51.000000', 'consum', 0.0218, 'lps'),
	(491803, 128, '2014-01-15 00:39:52.000000', 'consum', 0.0213, 'lps'),
	(491804, 128, '2014-01-15 00:39:53.000000', 'consum', 0.0219, 'lps'),
	(491805, 128, '2014-01-15 00:39:54.000000', 'consum', 0.0214, 'lps'),
	(491806, 128, '2014-01-15 00:39:55.000000', 'consum', 0.0219, 'lps'),
	(491807, 128, '2014-01-15 00:39:56.000000', 'consum', 0.0210, 'lps'),
	(491808, 128, '2014-01-15 00:39:57.000000', 'consum', 0.0218, 'lps'),
	(491809, 128, '2014-01-15 00:39:58.000000', 'consum', 0.0219, 'lps'),
	(491810, 128, '2014-01-15 00:39:59.000000', 'consum', 0.0214, 'lps'),
	(491811, 128, '2014-01-15 00:40:00.000000', 'consum', 0.0218, 'lps'),
	(491812, 128, '2014-01-15 00:40:01.000000', 'consum', 0.0210, 'lps'),
	(491813, 128, '2014-01-15 00:40:02.000000', 'consum', 0.0217, 'lps'),
	(491814, 128, '2014-01-15 00:40:03.000000', 'consum', 0.0213, 'lps'),
	(491815, 128, '2014-01-15 00:40:04.000000', 'consum', 0.0219, 'lps'),
	(491816, 128, '2014-01-15 00:40:05.000000', 'consum', 0.0215, 'lps'),
	(491817, 128, '2014-01-15 00:40:06.000000', 'consum', 0.0223, 'lps'),
	(491818, 128, '2014-01-15 00:40:07.000000', 'consum', 0.0214, 'lps'),
	(491819, 128, '2014-01-15 00:40:08.000000', 'consum', 0.0225, 'lps'),
	(491820, 128, '2014-01-15 00:40:09.000000', 'consum', 0.0210, 'lps'),
	(491821, 128, '2014-01-15 00:40:10.000000', 'consum', 0.0212, 'lps'),
	(491822, 128, '2014-01-15 00:40:11.000000', 'consum', 0.0221, 'lps'),
	(491823, 128, '2014-01-15 00:40:12.000000', 'consum', 0.0210, 'lps'),
	(491824, 128, '2014-01-15 00:40:13.000000', 'consum', 0.0211, 'lps'),
	(491825, 128, '2014-01-15 00:40:14.000000', 'consum', 0.0213, 'lps'),
	(491826, 128, '2014-01-15 00:40:15.000000', 'consum', 0.0224, 'lps'),
	(491827, 128, '2014-01-15 00:40:16.000000', 'consum', 0.0225, 'lps'),
	(491828, 128, '2014-01-15 00:40:17.000000', 'consum', 0.0212, 'lps'),
	(491829, 128, '2014-01-15 00:40:18.000000', 'consum', 0.0220, 'lps'),
	(491830, 128, '2014-01-15 00:40:19.000000', 'consum', 0.0210, 'lps'),
	(491831, 128, '2014-01-15 00:40:20.000000', 'consum', 0.0212, 'lps'),
	(491832, 128, '2014-01-15 00:40:21.000000', 'consum', 0.0222, 'lps'),
	(491833, 128, '2014-01-15 00:40:22.000000', 'consum', 0.0214, 'lps'),
	(491834, 128, '2014-01-15 00:40:23.000000', 'consum', 0.0225, 'lps'),
	(491835, 128, '2014-01-15 00:40:24.000000', 'consum', 0.0213, 'lps'),
	(491836, 128, '2014-01-15 00:40:25.000000', 'consum', 0.0211, 'lps'),
	(491837, 128, '2014-01-15 00:40:26.000000', 'consum', 0.0222, 'lps'),
	(491838, 128, '2014-01-15 00:40:27.000000', 'consum', 0.0219, 'lps'),
	(491839, 128, '2014-01-15 00:40:28.000000', 'consum', 0.0220, 'lps'),
	(491840, 128, '2014-01-15 00:40:29.000000', 'consum', 0.0216, 'lps'),
	(491841, 128, '2014-01-15 00:40:30.000000', 'consum', 0.0214, 'lps'),
	(491842, 128, '2014-01-15 00:40:31.000000', 'consum', 0.0225, 'lps'),
	(491843, 128, '2014-01-15 00:40:32.000000', 'consum', 0.0211, 'lps'),
	(491844, 128, '2014-01-15 00:40:33.000000', 'consum', 0.0218, 'lps'),
	(491845, 128, '2014-01-15 00:40:34.000000', 'consum', 0.0216, 'lps'),
	(491846, 128, '2014-01-15 00:40:35.000000', 'consum', 0.0218, 'lps'),
	(491847, 128, '2014-01-15 00:40:36.000000', 'consum', 0.0214, 'lps'),
	(491848, 128, '2014-01-15 00:40:37.000000', 'consum', 0.0223, 'lps'),
	(491849, 128, '2014-01-15 00:40:38.000000', 'consum', 0.0214, 'lps'),
	(491850, 128, '2014-01-15 00:40:39.000000', 'consum', 0.0223, 'lps'),
	(491851, 128, '2014-01-15 00:40:40.000000', 'consum', 0.0219, 'lps'),
	(491852, 128, '2014-01-15 00:40:41.000000', 'consum', 0.0213, 'lps'),
	(491853, 128, '2014-01-15 00:40:42.000000', 'consum', 0.0217, 'lps'),
	(491854, 128, '2014-01-15 00:40:43.000000', 'consum', 0.0221, 'lps'),
	(491855, 128, '2014-01-15 00:40:44.000000', 'consum', 0.0214, 'lps'),
	(491856, 128, '2014-01-15 00:40:45.000000', 'consum', 0.0210, 'lps'),
	(491857, 128, '2014-01-15 00:40:46.000000', 'consum', 0.0218, 'lps'),
	(491858, 128, '2014-01-15 00:40:47.000000', 'consum', 0.0215, 'lps'),
	(491859, 128, '2014-01-15 00:40:48.000000', 'consum', 0.0214, 'lps'),
	(491860, 128, '2014-01-15 00:40:49.000000', 'consum', 0.0213, 'lps'),
	(491861, 128, '2014-01-15 00:40:50.000000', 'consum', 0.0214, 'lps'),
	(491862, 128, '2014-01-15 00:40:51.000000', 'consum', 0.0223, 'lps'),
	(491863, 128, '2014-01-15 00:40:52.000000', 'consum', 0.0215, 'lps'),
	(491864, 128, '2014-01-15 00:40:53.000000', 'consum', 0.0213, 'lps'),
	(491865, 128, '2014-01-15 00:40:54.000000', 'consum', 0.0225, 'lps'),
	(491866, 128, '2014-01-15 00:40:55.000000', 'consum', 0.0212, 'lps'),
	(491867, 128, '2014-01-15 00:40:56.000000', 'consum', 0.0224, 'lps'),
	(491868, 128, '2014-01-15 00:40:57.000000', 'consum', 0.0225, 'lps'),
	(491869, 128, '2014-01-15 00:40:58.000000', 'consum', 0.0211, 'lps'),
	(491870, 128, '2014-01-15 00:40:59.000000', 'consum', 0.0222, 'lps'),
	(491871, 128, '2014-01-15 00:41:00.000000', 'consum', 0.0216, 'lps'),
	(491872, 128, '2014-01-15 00:41:01.000000', 'consum', 0.0222, 'lps'),
	(491873, 128, '2014-01-15 00:41:02.000000', 'consum', 0.0219, 'lps'),
	(491874, 128, '2014-01-15 00:41:03.000000', 'consum', 0.0219, 'lps'),
	(491875, 128, '2014-01-15 00:41:04.000000', 'consum', 0.0213, 'lps'),
	(491876, 128, '2014-01-15 00:41:05.000000', 'consum', 0.0216, 'lps'),
	(491877, 128, '2014-01-15 00:41:06.000000', 'consum', 0.0214, 'lps'),
	(491878, 128, '2014-01-15 00:41:07.000000', 'consum', 0.0214, 'lps'),
	(491879, 128, '2014-01-15 00:41:08.000000', 'consum', 0.0217, 'lps'),
	(491880, 128, '2014-01-15 00:41:09.000000', 'consum', 0.0217, 'lps'),
	(491881, 128, '2014-01-15 00:41:10.000000', 'consum', 0.0211, 'lps'),
	(491882, 128, '2014-01-15 00:41:11.000000', 'consum', 0.0223, 'lps'),
	(491883, 128, '2014-01-15 00:41:12.000000', 'consum', 0.0211, 'lps'),
	(491884, 128, '2014-01-15 00:41:13.000000', 'consum', 0.0225, 'lps'),
	(491885, 128, '2014-01-15 00:41:14.000000', 'consum', 0.0219, 'lps'),
	(491886, 128, '2014-01-15 00:41:15.000000', 'consum', 0.0210, 'lps'),
	(491887, 128, '2014-01-15 00:41:16.000000', 'consum', 0.0216, 'lps'),
	(491888, 128, '2014-01-15 00:41:17.000000', 'consum', 0.0224, 'lps'),
	(491889, 128, '2014-01-15 00:41:18.000000', 'consum', 0.0216, 'lps'),
	(491890, 128, '2014-01-15 00:41:19.000000', 'consum', 0.0213, 'lps'),
	(491891, 128, '2014-01-15 00:41:20.000000', 'consum', 0.0223, 'lps'),
	(491892, 128, '2014-01-15 00:41:21.000000', 'consum', 0.0220, 'lps'),
	(491893, 128, '2014-01-15 00:41:22.000000', 'consum', 0.0223, 'lps'),
	(491894, 128, '2014-01-15 00:41:23.000000', 'consum', 0.0212, 'lps'),
	(491895, 128, '2014-01-15 00:41:24.000000', 'consum', 0.0213, 'lps'),
	(491896, 128, '2014-01-15 00:41:25.000000', 'consum', 0.0221, 'lps'),
	(491897, 128, '2014-01-15 00:41:26.000000', 'consum', 0.0224, 'lps'),
	(491898, 128, '2014-01-15 00:41:27.000000', 'consum', 0.0214, 'lps'),
	(491899, 128, '2014-01-15 00:41:28.000000', 'consum', 0.0220, 'lps'),
	(491900, 128, '2014-01-15 00:41:29.000000', 'consum', 0.0219, 'lps'),
	(491901, 128, '2014-01-15 00:41:30.000000', 'consum', 0.0222, 'lps'),
	(491902, 128, '2014-01-15 00:41:31.000000', 'consum', 0.0215, 'lps'),
	(491903, 128, '2014-01-15 00:41:32.000000', 'consum', 0.0213, 'lps'),
	(491904, 128, '2014-01-15 00:41:33.000000', 'consum', 0.0211, 'lps'),
	(491905, 128, '2014-01-15 00:41:34.000000', 'consum', 0.0221, 'lps'),
	(491906, 128, '2014-01-15 00:41:35.000000', 'consum', 0.0216, 'lps'),
	(491907, 128, '2014-01-15 00:41:36.000000', 'consum', 0.0225, 'lps'),
	(491908, 128, '2014-01-15 00:41:37.000000', 'consum', 0.0219, 'lps'),
	(491909, 128, '2014-01-15 00:41:38.000000', 'consum', 0.0211, 'lps'),
	(491910, 128, '2014-01-15 00:41:39.000000', 'consum', 0.0219, 'lps'),
	(491911, 128, '2014-01-15 00:41:40.000000', 'consum', 0.0223, 'lps'),
	(491912, 128, '2014-01-15 00:41:41.000000', 'consum', 0.0214, 'lps'),
	(491913, 128, '2014-01-15 00:41:42.000000', 'consum', 0.0225, 'lps'),
	(491914, 128, '2014-01-15 00:41:43.000000', 'consum', 0.0223, 'lps'),
	(491915, 128, '2014-01-15 00:41:44.000000', 'consum', 0.0217, 'lps'),
	(491916, 128, '2014-01-15 00:41:45.000000', 'consum', 0.0220, 'lps'),
	(491917, 128, '2014-01-15 00:41:46.000000', 'consum', 0.0225, 'lps'),
	(491918, 128, '2014-01-15 00:41:47.000000', 'consum', 0.0222, 'lps'),
	(491919, 128, '2014-01-15 00:41:48.000000', 'consum', 0.0210, 'lps'),
	(491920, 128, '2014-01-15 00:41:49.000000', 'consum', 0.0223, 'lps'),
	(491921, 128, '2014-01-15 00:41:50.000000', 'consum', 0.0211, 'lps'),
	(491922, 128, '2014-01-15 00:41:51.000000', 'consum', 0.0224, 'lps'),
	(491923, 128, '2014-01-15 00:41:52.000000', 'consum', 0.0214, 'lps'),
	(491924, 128, '2014-01-15 00:41:53.000000', 'consum', 0.0221, 'lps'),
	(491925, 128, '2014-01-15 00:41:54.000000', 'consum', 0.0223, 'lps'),
	(491926, 128, '2014-01-15 00:41:55.000000', 'consum', 0.0223, 'lps'),
	(491927, 128, '2014-01-15 00:41:56.000000', 'consum', 0.0224, 'lps'),
	(491928, 128, '2014-01-15 00:41:57.000000', 'consum', 0.0224, 'lps'),
	(491929, 128, '2014-01-15 00:41:58.000000', 'consum', 0.0221, 'lps'),
	(491930, 128, '2014-01-15 00:41:59.000000', 'consum', 0.0223, 'lps'),
	(491931, 128, '2014-01-15 00:42:00.000000', 'consum', 0.0210, 'lps'),
	(491932, 128, '2014-01-15 00:42:01.000000', 'consum', 0.0220, 'lps'),
	(491933, 128, '2014-01-15 00:42:02.000000', 'consum', 0.0213, 'lps'),
	(491934, 128, '2014-01-15 00:42:03.000000', 'consum', 0.0225, 'lps'),
	(491935, 128, '2014-01-15 00:42:04.000000', 'consum', 0.0216, 'lps'),
	(491936, 128, '2014-01-15 00:42:05.000000', 'consum', 0.0225, 'lps'),
	(491937, 128, '2014-01-15 00:42:06.000000', 'consum', 0.0222, 'lps'),
	(491938, 128, '2014-01-15 00:42:07.000000', 'consum', 0.0225, 'lps'),
	(491939, 128, '2014-01-15 00:42:08.000000', 'consum', 0.0216, 'lps'),
	(491940, 128, '2014-01-15 00:42:09.000000', 'consum', 0.0213, 'lps'),
	(491941, 128, '2014-01-15 00:42:10.000000', 'consum', 0.0224, 'lps'),
	(491942, 128, '2014-01-15 00:42:11.000000', 'consum', 0.0224, 'lps'),
	(491943, 128, '2014-01-15 00:42:12.000000', 'consum', 0.0222, 'lps'),
	(491944, 128, '2014-01-15 00:42:13.000000', 'consum', 0.0213, 'lps'),
	(491945, 128, '2014-01-15 00:42:14.000000', 'consum', 0.0223, 'lps'),
	(491946, 128, '2014-01-15 00:42:15.000000', 'consum', 0.0217, 'lps'),
	(491947, 128, '2014-01-15 00:42:16.000000', 'consum', 0.0222, 'lps'),
	(491948, 128, '2014-01-15 00:42:17.000000', 'consum', 0.0217, 'lps'),
	(491949, 128, '2014-01-15 00:42:18.000000', 'consum', 0.0224, 'lps'),
	(491950, 128, '2014-01-15 00:42:19.000000', 'consum', 0.0213, 'lps'),
	(491951, 128, '2014-01-15 00:42:20.000000', 'consum', 0.0216, 'lps'),
	(491952, 128, '2014-01-15 00:42:21.000000', 'consum', 0.0216, 'lps'),
	(491953, 128, '2014-01-15 00:42:22.000000', 'consum', 0.0221, 'lps'),
	(491954, 128, '2014-01-15 00:42:23.000000', 'consum', 0.0217, 'lps'),
	(491955, 128, '2014-01-15 00:42:24.000000', 'consum', 0.0212, 'lps'),
	(491956, 128, '2014-01-15 00:42:25.000000', 'consum', 0.0215, 'lps'),
	(491957, 128, '2014-01-15 00:42:26.000000', 'consum', 0.0216, 'lps'),
	(491958, 128, '2014-01-15 00:42:27.000000', 'consum', 0.0223, 'lps'),
	(491959, 128, '2014-01-15 00:42:28.000000', 'consum', 0.0225, 'lps'),
	(491960, 128, '2014-01-15 00:42:29.000000', 'consum', 0.0215, 'lps'),
	(491961, 128, '2014-01-15 00:42:30.000000', 'consum', 0.0223, 'lps'),
	(491962, 128, '2014-01-15 00:42:31.000000', 'consum', 0.0213, 'lps'),
	(491963, 128, '2014-01-15 00:42:32.000000', 'consum', 0.0219, 'lps'),
	(491964, 128, '2014-01-15 00:42:33.000000', 'consum', 0.0212, 'lps'),
	(491965, 128, '2014-01-15 00:42:34.000000', 'consum', 0.0211, 'lps'),
	(491966, 128, '2014-01-15 00:42:35.000000', 'consum', 0.0210, 'lps'),
	(491967, 128, '2014-01-15 00:42:36.000000', 'consum', 0.0222, 'lps'),
	(491968, 128, '2014-01-15 00:42:37.000000', 'consum', 0.0224, 'lps'),
	(491969, 128, '2014-01-15 00:42:38.000000', 'consum', 0.0210, 'lps'),
	(491970, 128, '2014-01-15 00:42:39.000000', 'consum', 0.0218, 'lps'),
	(491971, 128, '2014-01-15 00:42:40.000000', 'consum', 0.0217, 'lps'),
	(491972, 128, '2014-01-15 00:42:41.000000', 'consum', 0.0224, 'lps'),
	(491973, 128, '2014-01-15 00:42:42.000000', 'consum', 0.0210, 'lps'),
	(491974, 128, '2014-01-15 00:42:43.000000', 'consum', 0.0216, 'lps'),
	(491975, 128, '2014-01-15 00:42:44.000000', 'consum', 0.0210, 'lps'),
	(491976, 128, '2014-01-15 00:42:45.000000', 'consum', 0.0210, 'lps'),
	(491977, 128, '2014-01-15 00:42:46.000000', 'consum', 0.0225, 'lps'),
	(491978, 128, '2014-01-15 00:42:47.000000', 'consum', 0.0221, 'lps'),
	(491979, 128, '2014-01-15 00:42:48.000000', 'consum', 0.0222, 'lps'),
	(491980, 128, '2014-01-15 00:42:49.000000', 'consum', 0.0219, 'lps'),
	(491981, 128, '2014-01-15 00:42:50.000000', 'consum', 0.0219, 'lps'),
	(491982, 128, '2014-01-15 00:42:51.000000', 'consum', 0.0214, 'lps'),
	(491983, 128, '2014-01-15 00:42:52.000000', 'consum', 0.0220, 'lps'),
	(491984, 128, '2014-01-15 00:42:53.000000', 'consum', 0.0217, 'lps'),
	(491985, 128, '2014-01-15 00:42:54.000000', 'consum', 0.0214, 'lps'),
	(491986, 128, '2014-01-15 00:42:55.000000', 'consum', 0.0225, 'lps'),
	(491987, 128, '2014-01-15 00:42:56.000000', 'consum', 0.0210, 'lps'),
	(491988, 128, '2014-01-15 00:42:57.000000', 'consum', 0.0213, 'lps'),
	(491989, 128, '2014-01-15 00:42:58.000000', 'consum', 0.0225, 'lps'),
	(491990, 128, '2014-01-15 00:42:59.000000', 'consum', 0.0215, 'lps'),
	(491991, 128, '2014-01-15 00:43:00.000000', 'consum', 0.0222, 'lps'),
	(491992, 128, '2014-01-15 00:43:01.000000', 'consum', 0.0222, 'lps'),
	(491993, 128, '2014-01-15 00:43:02.000000', 'consum', 0.0217, 'lps'),
	(491994, 128, '2014-01-15 00:43:03.000000', 'consum', 0.0212, 'lps'),
	(491995, 128, '2014-01-15 00:43:04.000000', 'consum', 0.0213, 'lps'),
	(491996, 128, '2014-01-15 00:43:05.000000', 'consum', 0.0222, 'lps'),
	(491997, 128, '2014-01-15 00:43:06.000000', 'consum', 0.0214, 'lps'),
	(491998, 128, '2014-01-15 00:43:07.000000', 'consum', 0.0210, 'lps'),
	(491999, 128, '2014-01-15 00:43:08.000000', 'consum', 0.0213, 'lps'),
	(492000, 128, '2014-01-15 00:43:09.000000', 'consum', 0.0210, 'lps'),
	(492001, 128, '2014-01-15 00:43:10.000000', 'consum', 0.0217, 'lps'),
	(492002, 128, '2014-01-15 00:43:11.000000', 'consum', 0.0212, 'lps'),
	(492003, 128, '2014-01-15 00:43:12.000000', 'consum', 0.0219, 'lps'),
	(492004, 128, '2014-01-15 00:43:13.000000', 'consum', 0.0215, 'lps'),
	(492005, 128, '2014-01-15 00:43:14.000000', 'consum', 0.0225, 'lps'),
	(492006, 128, '2014-01-15 00:43:15.000000', 'consum', 0.0224, 'lps'),
	(492007, 128, '2014-01-15 00:43:16.000000', 'consum', 0.0218, 'lps'),
	(492008, 128, '2014-01-15 00:43:17.000000', 'consum', 0.0225, 'lps'),
	(492009, 128, '2014-01-15 00:43:18.000000', 'consum', 0.0214, 'lps'),
	(492010, 128, '2014-01-15 00:43:19.000000', 'consum', 0.0219, 'lps'),
	(492011, 128, '2014-01-15 00:43:20.000000', 'consum', 0.0211, 'lps'),
	(492012, 128, '2014-01-15 00:43:21.000000', 'consum', 0.0218, 'lps'),
	(492013, 128, '2014-01-15 00:43:22.000000', 'consum', 0.0217, 'lps'),
	(492014, 128, '2014-01-15 00:43:23.000000', 'consum', 0.0223, 'lps'),
	(492015, 128, '2014-01-15 00:43:24.000000', 'consum', 0.0222, 'lps'),
	(492016, 128, '2014-01-15 00:43:25.000000', 'consum', 0.0217, 'lps'),
	(492017, 128, '2014-01-15 00:43:26.000000', 'consum', 0.0225, 'lps'),
	(492018, 128, '2014-01-15 00:43:27.000000', 'consum', 0.0215, 'lps'),
	(492019, 128, '2014-01-15 00:43:28.000000', 'consum', 0.0221, 'lps'),
	(492020, 128, '2014-01-15 00:43:29.000000', 'consum', 0.0221, 'lps'),
	(492021, 128, '2014-01-15 00:43:30.000000', 'consum', 0.0215, 'lps'),
	(492022, 128, '2014-01-15 00:43:31.000000', 'consum', 0.0218, 'lps'),
	(492023, 128, '2014-01-15 00:43:32.000000', 'consum', 0.0219, 'lps'),
	(492024, 128, '2014-01-15 00:43:33.000000', 'consum', 0.0218, 'lps'),
	(492025, 128, '2014-01-15 00:43:34.000000', 'consum', 0.0222, 'lps'),
	(492026, 128, '2014-01-15 00:43:35.000000', 'consum', 0.0214, 'lps'),
	(492027, 128, '2014-01-15 00:43:36.000000', 'consum', 0.0212, 'lps'),
	(492028, 128, '2014-01-15 00:43:37.000000', 'consum', 0.0225, 'lps'),
	(492029, 128, '2014-01-15 00:43:38.000000', 'consum', 0.0216, 'lps'),
	(492030, 128, '2014-01-15 00:43:39.000000', 'consum', 0.0211, 'lps'),
	(492031, 128, '2014-01-15 00:43:40.000000', 'consum', 0.0214, 'lps'),
	(492032, 128, '2014-01-15 00:43:41.000000', 'consum', 0.0225, 'lps'),
	(492033, 128, '2014-01-15 00:43:42.000000', 'consum', 0.0213, 'lps'),
	(492034, 128, '2014-01-15 00:43:43.000000', 'consum', 0.0225, 'lps'),
	(492035, 128, '2014-01-15 00:43:44.000000', 'consum', 0.0215, 'lps'),
	(492036, 128, '2014-01-15 00:43:45.000000', 'consum', 0.0221, 'lps'),
	(492037, 128, '2014-01-15 00:43:46.000000', 'consum', 0.0221, 'lps'),
	(492038, 128, '2014-01-15 00:43:47.000000', 'consum', 0.0213, 'lps'),
	(492039, 128, '2014-01-15 00:43:48.000000', 'consum', 0.0211, 'lps'),
	(492040, 128, '2014-01-15 00:43:49.000000', 'consum', 0.0220, 'lps'),
	(492041, 128, '2014-01-15 00:43:50.000000', 'consum', 0.0212, 'lps'),
	(492042, 128, '2014-01-15 00:43:51.000000', 'consum', 0.0223, 'lps'),
	(492043, 128, '2014-01-15 00:43:52.000000', 'consum', 0.0222, 'lps'),
	(492044, 128, '2014-01-15 00:43:53.000000', 'consum', 0.0214, 'lps'),
	(492045, 128, '2014-01-15 00:43:54.000000', 'consum', 0.0213, 'lps'),
	(492046, 128, '2014-01-15 00:43:55.000000', 'consum', 0.0210, 'lps'),
	(492047, 128, '2014-01-15 00:43:56.000000', 'consum', 0.0219, 'lps'),
	(492048, 128, '2014-01-15 00:43:57.000000', 'consum', 0.0223, 'lps'),
	(492049, 128, '2014-01-15 00:43:58.000000', 'consum', 0.0215, 'lps'),
	(492050, 128, '2014-01-15 00:43:59.000000', 'consum', 0.0215, 'lps'),
	(492051, 128, '2014-01-15 00:44:00.000000', 'consum', 0.0220, 'lps'),
	(492052, 128, '2014-01-15 00:44:01.000000', 'consum', 0.0214, 'lps'),
	(492053, 128, '2014-01-15 00:44:02.000000', 'consum', 0.0217, 'lps'),
	(492054, 128, '2014-01-15 00:44:03.000000', 'consum', 0.0216, 'lps'),
	(492055, 128, '2014-01-15 00:44:04.000000', 'consum', 0.0218, 'lps'),
	(492056, 128, '2014-01-15 00:44:05.000000', 'consum', 0.0217, 'lps'),
	(492057, 128, '2014-01-15 00:44:06.000000', 'consum', 0.0224, 'lps'),
	(492058, 128, '2014-01-15 00:44:07.000000', 'consum', 0.0211, 'lps'),
	(492059, 128, '2014-01-15 00:44:08.000000', 'consum', 0.0223, 'lps'),
	(492060, 128, '2014-01-15 00:44:09.000000', 'consum', 0.0223, 'lps'),
	(492061, 128, '2014-01-15 00:44:10.000000', 'consum', 0.0219, 'lps'),
	(492062, 128, '2014-01-15 00:44:11.000000', 'consum', 0.0219, 'lps'),
	(492063, 128, '2014-01-15 00:44:12.000000', 'consum', 0.0211, 'lps'),
	(492064, 128, '2014-01-15 00:44:13.000000', 'consum', 0.0220, 'lps'),
	(492065, 128, '2014-01-15 00:44:14.000000', 'consum', 0.0211, 'lps'),
	(492066, 128, '2014-01-15 00:44:15.000000', 'consum', 0.0217, 'lps'),
	(492067, 128, '2014-01-15 00:44:16.000000', 'consum', 0.0212, 'lps'),
	(492068, 128, '2014-01-15 00:44:17.000000', 'consum', 0.0216, 'lps'),
	(492069, 128, '2014-01-15 00:44:18.000000', 'consum', 0.0219, 'lps'),
	(492070, 128, '2014-01-15 00:44:19.000000', 'consum', 0.0219, 'lps'),
	(492071, 128, '2014-01-15 00:44:20.000000', 'consum', 0.0215, 'lps'),
	(492072, 128, '2014-01-15 00:44:21.000000', 'consum', 0.0222, 'lps'),
	(492073, 128, '2014-01-15 00:44:22.000000', 'consum', 0.0223, 'lps'),
	(492074, 128, '2014-01-15 00:44:23.000000', 'consum', 0.0224, 'lps'),
	(492075, 128, '2014-01-15 00:44:24.000000', 'consum', 0.0211, 'lps'),
	(492076, 128, '2014-01-15 00:44:25.000000', 'consum', 0.0221, 'lps'),
	(492077, 128, '2014-01-15 00:44:26.000000', 'consum', 0.0216, 'lps'),
	(492078, 128, '2014-01-15 00:44:27.000000', 'consum', 0.0221, 'lps'),
	(492079, 128, '2014-01-15 00:44:28.000000', 'consum', 0.0217, 'lps'),
	(492080, 128, '2014-01-15 00:44:29.000000', 'consum', 0.0212, 'lps'),
	(492081, 128, '2014-01-15 00:44:30.000000', 'consum', 0.0216, 'lps'),
	(492082, 128, '2014-01-15 00:44:31.000000', 'consum', 0.0220, 'lps'),
	(492083, 128, '2014-01-15 00:44:32.000000', 'consum', 0.0223, 'lps'),
	(492084, 128, '2014-01-15 00:44:33.000000', 'consum', 0.0216, 'lps'),
	(492085, 128, '2014-01-15 00:44:34.000000', 'consum', 0.0216, 'lps'),
	(492086, 128, '2014-01-15 00:44:35.000000', 'consum', 0.0222, 'lps'),
	(492087, 128, '2014-01-15 00:44:36.000000', 'consum', 0.0223, 'lps'),
	(492088, 128, '2014-01-15 00:44:37.000000', 'consum', 0.0222, 'lps'),
	(492089, 128, '2014-01-15 00:44:38.000000', 'consum', 0.0215, 'lps'),
	(492090, 128, '2014-01-15 00:44:39.000000', 'consum', 0.0216, 'lps'),
	(492091, 128, '2014-01-15 00:44:40.000000', 'consum', 0.0223, 'lps'),
	(492092, 128, '2014-01-15 00:44:41.000000', 'consum', 0.0213, 'lps'),
	(492093, 128, '2014-01-15 00:44:42.000000', 'consum', 0.0217, 'lps'),
	(492094, 128, '2014-01-15 00:44:43.000000', 'consum', 0.0219, 'lps'),
	(492095, 128, '2014-01-15 00:44:44.000000', 'consum', 0.0219, 'lps'),
	(492096, 128, '2014-01-15 00:44:45.000000', 'consum', 0.0211, 'lps'),
	(492097, 128, '2014-01-15 00:44:46.000000', 'consum', 0.0222, 'lps'),
	(492098, 128, '2014-01-15 00:44:47.000000', 'consum', 0.0218, 'lps'),
	(492099, 128, '2014-01-15 00:44:48.000000', 'consum', 0.0217, 'lps'),
	(492100, 128, '2014-01-15 00:44:49.000000', 'consum', 0.0221, 'lps'),
	(492101, 128, '2014-01-15 00:44:50.000000', 'consum', 0.0210, 'lps'),
	(492102, 128, '2014-01-15 00:44:51.000000', 'consum', 0.0211, 'lps'),
	(492103, 128, '2014-01-15 00:44:52.000000', 'consum', 0.0216, 'lps'),
	(492104, 128, '2014-01-15 00:44:53.000000', 'consum', 0.0222, 'lps'),
	(492105, 128, '2014-01-15 00:44:54.000000', 'consum', 0.0221, 'lps'),
	(492106, 128, '2014-01-15 00:44:55.000000', 'consum', 0.0213, 'lps'),
	(492107, 128, '2014-01-15 00:44:56.000000', 'consum', 0.0224, 'lps'),
	(492108, 128, '2014-01-15 00:44:57.000000', 'consum', 0.0222, 'lps'),
	(492109, 128, '2014-01-15 00:44:58.000000', 'consum', 0.0212, 'lps'),
	(492110, 128, '2014-01-15 00:44:59.000000', 'consum', 0.0219, 'lps'),
	(492111, 128, '2014-01-15 00:45:00.000000', 'consum', 0.0216, 'lps'),
	(492112, 128, '2014-01-15 00:45:01.000000', 'consum', 0.0212, 'lps'),
	(492113, 128, '2014-01-15 00:45:02.000000', 'consum', 0.0221, 'lps'),
	(492114, 128, '2014-01-15 00:45:03.000000', 'consum', 0.0212, 'lps'),
	(492115, 128, '2014-01-15 00:45:04.000000', 'consum', 0.0219, 'lps'),
	(492116, 128, '2014-01-15 00:45:05.000000', 'consum', 0.0218, 'lps'),
	(492117, 128, '2014-01-15 00:45:06.000000', 'consum', 0.0224, 'lps'),
	(492118, 128, '2014-01-15 00:45:07.000000', 'consum', 0.0222, 'lps'),
	(492119, 128, '2014-01-15 00:45:08.000000', 'consum', 0.0215, 'lps'),
	(492120, 128, '2014-01-15 00:45:09.000000', 'consum', 0.0214, 'lps'),
	(492121, 128, '2014-01-15 00:45:10.000000', 'consum', 0.0215, 'lps'),
	(492122, 128, '2014-01-15 00:45:11.000000', 'consum', 0.0223, 'lps'),
	(492123, 128, '2014-01-15 00:45:12.000000', 'consum', 0.0214, 'lps'),
	(492124, 128, '2014-01-15 00:45:13.000000', 'consum', 0.0221, 'lps'),
	(492125, 128, '2014-01-15 00:45:14.000000', 'consum', 0.0225, 'lps'),
	(492126, 128, '2014-01-15 00:45:15.000000', 'consum', 0.0218, 'lps'),
	(492127, 128, '2014-01-15 00:45:16.000000', 'consum', 0.0222, 'lps'),
	(492128, 128, '2014-01-15 00:45:17.000000', 'consum', 0.0215, 'lps'),
	(492129, 128, '2014-01-15 00:45:18.000000', 'consum', 0.0214, 'lps'),
	(492130, 128, '2014-01-15 00:45:19.000000', 'consum', 0.0218, 'lps'),
	(492131, 128, '2014-01-15 00:45:20.000000', 'consum', 0.0220, 'lps'),
	(492132, 128, '2014-01-15 00:45:21.000000', 'consum', 0.0222, 'lps'),
	(492133, 128, '2014-01-15 00:45:22.000000', 'consum', 0.0224, 'lps'),
	(492134, 128, '2014-01-15 00:45:23.000000', 'consum', 0.0214, 'lps'),
	(492135, 128, '2014-01-15 00:45:24.000000', 'consum', 0.0219, 'lps'),
	(492136, 128, '2014-01-15 00:45:25.000000', 'consum', 0.0212, 'lps'),
	(492137, 128, '2014-01-15 00:45:26.000000', 'consum', 0.0223, 'lps'),
	(492138, 128, '2014-01-15 00:45:27.000000', 'consum', 0.0225, 'lps'),
	(492139, 128, '2014-01-15 00:45:28.000000', 'consum', 0.0214, 'lps'),
	(492140, 128, '2014-01-15 00:45:29.000000', 'consum', 0.0215, 'lps'),
	(492141, 128, '2014-01-15 00:45:30.000000', 'consum', 0.0211, 'lps'),
	(492142, 128, '2014-01-15 00:45:31.000000', 'consum', 0.0213, 'lps'),
	(492143, 128, '2014-01-15 00:45:32.000000', 'consum', 0.0225, 'lps'),
	(492144, 128, '2014-01-15 00:45:33.000000', 'consum', 0.0213, 'lps'),
	(492145, 128, '2014-01-15 00:45:34.000000', 'consum', 0.0212, 'lps'),
	(492146, 128, '2014-01-15 00:45:35.000000', 'consum', 0.0212, 'lps'),
	(492147, 128, '2014-01-15 00:45:36.000000', 'consum', 0.0212, 'lps'),
	(492148, 128, '2014-01-15 00:45:37.000000', 'consum', 0.0216, 'lps'),
	(492149, 128, '2014-01-15 00:45:38.000000', 'consum', 0.0220, 'lps'),
	(492150, 128, '2014-01-15 00:45:39.000000', 'consum', 0.0224, 'lps'),
	(492151, 128, '2014-01-15 00:45:40.000000', 'consum', 0.0219, 'lps'),
	(492152, 128, '2014-01-15 00:45:41.000000', 'consum', 0.0212, 'lps'),
	(492153, 128, '2014-01-15 00:45:42.000000', 'consum', 0.0210, 'lps'),
	(492154, 128, '2014-01-15 00:45:43.000000', 'consum', 0.0221, 'lps'),
	(492155, 128, '2014-01-15 00:45:44.000000', 'consum', 0.0217, 'lps'),
	(492156, 128, '2014-01-15 00:45:45.000000', 'consum', 0.0213, 'lps'),
	(492157, 128, '2014-01-15 00:45:46.000000', 'consum', 0.0218, 'lps'),
	(492158, 128, '2014-01-15 00:45:47.000000', 'consum', 0.0213, 'lps'),
	(492159, 128, '2014-01-15 00:45:48.000000', 'consum', 0.0214, 'lps'),
	(492160, 128, '2014-01-15 00:45:49.000000', 'consum', 0.0224, 'lps'),
	(492161, 128, '2014-01-15 00:45:50.000000', 'consum', 0.0219, 'lps'),
	(492162, 128, '2014-01-15 00:45:51.000000', 'consum', 0.0212, 'lps'),
	(492163, 128, '2014-01-15 00:45:52.000000', 'consum', 0.0212, 'lps'),
	(492164, 128, '2014-01-15 00:45:53.000000', 'consum', 0.0214, 'lps'),
	(492165, 128, '2014-01-15 00:45:54.000000', 'consum', 0.0223, 'lps'),
	(492166, 128, '2014-01-15 00:45:55.000000', 'consum', 0.0216, 'lps'),
	(492167, 128, '2014-01-15 00:45:56.000000', 'consum', 0.0219, 'lps'),
	(492168, 128, '2014-01-15 00:45:57.000000', 'consum', 0.0222, 'lps'),
	(492169, 128, '2014-01-15 00:45:58.000000', 'consum', 0.0212, 'lps'),
	(492170, 128, '2014-01-15 00:45:59.000000', 'consum', 0.0216, 'lps'),
	(492171, 128, '2014-01-15 00:46:00.000000', 'consum', 0.0218, 'lps'),
	(492172, 128, '2014-01-15 00:46:01.000000', 'consum', 0.0216, 'lps'),
	(492173, 128, '2014-01-15 00:46:02.000000', 'consum', 0.0219, 'lps'),
	(492174, 128, '2014-01-15 00:46:03.000000', 'consum', 0.0218, 'lps'),
	(492175, 128, '2014-01-15 00:46:04.000000', 'consum', 0.0210, 'lps'),
	(492176, 128, '2014-01-15 00:46:05.000000', 'consum', 0.0217, 'lps'),
	(492177, 128, '2014-01-15 00:46:06.000000', 'consum', 0.0212, 'lps'),
	(492178, 128, '2014-01-15 00:46:07.000000', 'consum', 0.0219, 'lps'),
	(492179, 128, '2014-01-15 00:46:08.000000', 'consum', 0.0215, 'lps'),
	(492180, 128, '2014-01-15 00:46:09.000000', 'consum', 0.0211, 'lps'),
	(492181, 128, '2014-01-15 00:46:10.000000', 'consum', 0.0216, 'lps'),
	(492182, 128, '2014-01-15 00:46:11.000000', 'consum', 0.0222, 'lps'),
	(492183, 128, '2014-01-15 00:46:12.000000', 'consum', 0.0220, 'lps'),
	(492184, 128, '2014-01-15 00:46:13.000000', 'consum', 0.0210, 'lps'),
	(492185, 128, '2014-01-15 00:46:14.000000', 'consum', 0.0225, 'lps'),
	(492186, 128, '2014-01-15 00:46:15.000000', 'consum', 0.0225, 'lps'),
	(492187, 128, '2014-01-15 00:46:16.000000', 'consum', 0.0221, 'lps'),
	(492188, 128, '2014-01-15 00:46:17.000000', 'consum', 0.0224, 'lps'),
	(492189, 128, '2014-01-15 00:46:18.000000', 'consum', 0.0213, 'lps'),
	(492190, 128, '2014-01-15 00:46:19.000000', 'consum', 0.0218, 'lps'),
	(492191, 128, '2014-01-15 00:46:20.000000', 'consum', 0.0223, 'lps'),
	(492192, 128, '2014-01-15 00:46:21.000000', 'consum', 0.0219, 'lps'),
	(492193, 128, '2014-01-15 00:46:22.000000', 'consum', 0.0216, 'lps'),
	(492194, 128, '2014-01-15 00:46:23.000000', 'consum', 0.0215, 'lps'),
	(492195, 128, '2014-01-15 00:46:24.000000', 'consum', 0.0217, 'lps'),
	(492196, 128, '2014-01-15 00:46:25.000000', 'consum', 0.0215, 'lps'),
	(492197, 128, '2014-01-15 00:46:26.000000', 'consum', 0.0215, 'lps'),
	(492198, 128, '2014-01-15 00:46:27.000000', 'consum', 0.0219, 'lps'),
	(492199, 128, '2014-01-15 00:46:28.000000', 'consum', 0.0211, 'lps'),
	(492200, 128, '2014-01-15 00:46:29.000000', 'consum', 0.0218, 'lps'),
	(492201, 128, '2014-01-15 00:46:30.000000', 'consum', 0.0218, 'lps'),
	(492202, 128, '2014-01-15 00:46:31.000000', 'consum', 0.0210, 'lps'),
	(492203, 128, '2014-01-15 00:46:32.000000', 'consum', 0.0218, 'lps'),
	(492204, 128, '2014-01-15 00:46:33.000000', 'consum', 0.0217, 'lps'),
	(492205, 128, '2014-01-15 00:46:34.000000', 'consum', 0.0222, 'lps'),
	(492206, 128, '2014-01-15 00:46:35.000000', 'consum', 0.0216, 'lps'),
	(492207, 128, '2014-01-15 00:46:36.000000', 'consum', 0.0222, 'lps'),
	(492208, 128, '2014-01-15 00:46:37.000000', 'consum', 0.0218, 'lps'),
	(492209, 128, '2014-01-15 00:46:38.000000', 'consum', 0.0217, 'lps'),
	(492210, 128, '2014-01-15 00:46:39.000000', 'consum', 0.0222, 'lps'),
	(492211, 128, '2014-01-15 00:46:40.000000', 'consum', 0.0218, 'lps'),
	(492212, 128, '2014-01-15 00:46:41.000000', 'consum', 0.0212, 'lps'),
	(492213, 128, '2014-01-15 00:46:42.000000', 'consum', 0.0215, 'lps'),
	(492214, 128, '2014-01-15 00:46:43.000000', 'consum', 0.0211, 'lps'),
	(492215, 128, '2014-01-15 00:46:44.000000', 'consum', 0.0219, 'lps'),
	(492216, 128, '2014-01-15 00:46:45.000000', 'consum', 0.0218, 'lps'),
	(492217, 128, '2014-01-15 00:46:46.000000', 'consum', 0.0223, 'lps'),
	(492218, 128, '2014-01-15 00:46:47.000000', 'consum', 0.0221, 'lps'),
	(492219, 128, '2014-01-15 00:46:48.000000', 'consum', 0.0224, 'lps'),
	(492220, 128, '2014-01-15 00:46:49.000000', 'consum', 0.0219, 'lps'),
	(492221, 128, '2014-01-15 00:46:50.000000', 'consum', 0.0211, 'lps'),
	(492222, 128, '2014-01-15 00:46:51.000000', 'consum', 0.0221, 'lps'),
	(492223, 128, '2014-01-15 00:46:52.000000', 'consum', 0.0213, 'lps'),
	(492224, 128, '2014-01-15 00:46:53.000000', 'consum', 0.0211, 'lps'),
	(492225, 128, '2014-01-15 00:46:54.000000', 'consum', 0.0223, 'lps'),
	(492226, 128, '2014-01-15 00:46:55.000000', 'consum', 0.0222, 'lps'),
	(492227, 128, '2014-01-15 00:46:56.000000', 'consum', 0.0217, 'lps'),
	(492228, 128, '2014-01-15 00:46:57.000000', 'consum', 0.0223, 'lps'),
	(492229, 128, '2014-01-15 00:46:58.000000', 'consum', 0.0225, 'lps'),
	(492230, 128, '2014-01-15 00:46:59.000000', 'consum', 0.0213, 'lps'),
	(492231, 128, '2014-01-15 00:47:00.000000', 'consum', 0.0211, 'lps'),
	(492232, 128, '2014-01-15 00:47:01.000000', 'consum', 0.0224, 'lps'),
	(492233, 128, '2014-01-15 00:47:02.000000', 'consum', 0.0214, 'lps'),
	(492234, 128, '2014-01-15 00:47:03.000000', 'consum', 0.0219, 'lps'),
	(492235, 128, '2014-01-15 00:47:04.000000', 'consum', 0.0212, 'lps'),
	(492236, 128, '2014-01-15 00:47:05.000000', 'consum', 0.0211, 'lps'),
	(492237, 128, '2014-01-15 00:47:06.000000', 'consum', 0.0210, 'lps'),
	(492238, 128, '2014-01-15 00:47:07.000000', 'consum', 0.0223, 'lps'),
	(492239, 128, '2014-01-15 00:47:08.000000', 'consum', 0.0213, 'lps'),
	(492240, 128, '2014-01-15 00:47:09.000000', 'consum', 0.0218, 'lps'),
	(492241, 128, '2014-01-15 00:47:10.000000', 'consum', 0.0224, 'lps'),
	(492242, 128, '2014-01-15 00:47:11.000000', 'consum', 0.0224, 'lps'),
	(492243, 128, '2014-01-15 00:47:12.000000', 'consum', 0.0222, 'lps'),
	(492244, 128, '2014-01-15 00:47:13.000000', 'consum', 0.0215, 'lps'),
	(492245, 128, '2014-01-15 00:47:14.000000', 'consum', 0.0215, 'lps'),
	(492246, 128, '2014-01-15 00:47:15.000000', 'consum', 0.0222, 'lps'),
	(492247, 128, '2014-01-15 00:47:16.000000', 'consum', 0.0223, 'lps'),
	(492248, 128, '2014-01-15 00:47:17.000000', 'consum', 0.0222, 'lps'),
	(492249, 128, '2014-01-15 00:47:18.000000', 'consum', 0.0216, 'lps'),
	(492250, 128, '2014-01-15 00:47:19.000000', 'consum', 0.0219, 'lps'),
	(492251, 128, '2014-01-15 00:47:20.000000', 'consum', 0.0223, 'lps'),
	(492252, 128, '2014-01-15 00:47:21.000000', 'consum', 0.0217, 'lps'),
	(492253, 128, '2014-01-15 00:47:22.000000', 'consum', 0.0223, 'lps'),
	(492254, 128, '2014-01-15 00:47:23.000000', 'consum', 0.0220, 'lps'),
	(492255, 128, '2014-01-15 00:47:24.000000', 'consum', 0.0224, 'lps'),
	(492256, 128, '2014-01-15 00:47:25.000000', 'consum', 0.0220, 'lps'),
	(492257, 128, '2014-01-15 00:47:26.000000', 'consum', 0.0215, 'lps'),
	(492258, 128, '2014-01-15 00:47:27.000000', 'consum', 0.0224, 'lps'),
	(492259, 128, '2014-01-15 00:47:28.000000', 'consum', 0.0216, 'lps'),
	(492260, 128, '2014-01-15 00:47:29.000000', 'consum', 0.0215, 'lps'),
	(492261, 128, '2014-01-15 00:47:30.000000', 'consum', 0.0217, 'lps'),
	(492262, 128, '2014-01-15 00:47:31.000000', 'consum', 0.0216, 'lps'),
	(492263, 128, '2014-01-15 00:47:32.000000', 'consum', 0.0219, 'lps'),
	(492264, 128, '2014-01-15 00:47:33.000000', 'consum', 0.0222, 'lps'),
	(492265, 128, '2014-01-15 00:47:34.000000', 'consum', 0.0211, 'lps'),
	(492266, 128, '2014-01-15 00:47:35.000000', 'consum', 0.0212, 'lps'),
	(492267, 128, '2014-01-15 00:47:36.000000', 'consum', 0.0216, 'lps'),
	(492268, 128, '2014-01-15 00:47:37.000000', 'consum', 0.0219, 'lps'),
	(492269, 128, '2014-01-15 00:47:38.000000', 'consum', 0.0220, 'lps'),
	(492270, 128, '2014-01-15 00:47:39.000000', 'consum', 0.0219, 'lps'),
	(492271, 128, '2014-01-15 00:47:40.000000', 'consum', 0.0225, 'lps'),
	(492272, 128, '2014-01-15 00:47:41.000000', 'consum', 0.0211, 'lps'),
	(492273, 128, '2014-01-15 00:47:42.000000', 'consum', 0.0220, 'lps'),
	(492274, 128, '2014-01-15 00:47:43.000000', 'consum', 0.0225, 'lps'),
	(492275, 128, '2014-01-15 00:47:44.000000', 'consum', 0.0224, 'lps'),
	(492276, 128, '2014-01-15 00:47:45.000000', 'consum', 0.0219, 'lps'),
	(492277, 128, '2014-01-15 00:47:46.000000', 'consum', 0.0213, 'lps'),
	(492278, 128, '2014-01-15 00:47:47.000000', 'consum', 0.0213, 'lps'),
	(492279, 128, '2014-01-15 00:47:48.000000', 'consum', 0.0217, 'lps'),
	(492280, 128, '2014-01-15 00:47:49.000000', 'consum', 0.0222, 'lps'),
	(492281, 128, '2014-01-15 00:47:50.000000', 'consum', 0.0216, 'lps'),
	(492282, 128, '2014-01-15 00:47:51.000000', 'consum', 0.0221, 'lps'),
	(492283, 128, '2014-01-15 00:47:52.000000', 'consum', 0.0215, 'lps'),
	(492284, 128, '2014-01-15 00:47:53.000000', 'consum', 0.0218, 'lps'),
	(492285, 128, '2014-01-15 00:47:54.000000', 'consum', 0.0222, 'lps'),
	(492286, 128, '2014-01-15 00:47:55.000000', 'consum', 0.0214, 'lps'),
	(492287, 128, '2014-01-15 00:47:56.000000', 'consum', 0.0210, 'lps'),
	(492288, 128, '2014-01-15 00:47:57.000000', 'consum', 0.0214, 'lps'),
	(492289, 128, '2014-01-15 00:47:58.000000', 'consum', 0.0215, 'lps'),
	(492290, 128, '2014-01-15 00:47:59.000000', 'consum', 0.0222, 'lps'),
	(492291, 128, '2014-01-15 00:48:00.000000', 'consum', 0.0210, 'lps'),
	(492292, 128, '2014-01-15 00:48:01.000000', 'consum', 0.0223, 'lps'),
	(492293, 128, '2014-01-15 00:48:02.000000', 'consum', 0.0212, 'lps'),
	(492294, 128, '2014-01-15 00:48:03.000000', 'consum', 0.0213, 'lps'),
	(492295, 128, '2014-01-15 00:48:04.000000', 'consum', 0.0219, 'lps'),
	(492296, 128, '2014-01-15 00:48:05.000000', 'consum', 0.0216, 'lps'),
	(492297, 128, '2014-01-15 00:48:06.000000', 'consum', 0.0212, 'lps'),
	(492298, 128, '2014-01-15 00:48:07.000000', 'consum', 0.0219, 'lps'),
	(492299, 128, '2014-01-15 00:48:08.000000', 'consum', 0.0218, 'lps'),
	(492300, 128, '2014-01-15 00:48:09.000000', 'consum', 0.0221, 'lps'),
	(492301, 128, '2014-01-15 00:48:10.000000', 'consum', 0.0211, 'lps'),
	(492302, 128, '2014-01-15 00:48:11.000000', 'consum', 0.0215, 'lps'),
	(492303, 128, '2014-01-15 00:48:12.000000', 'consum', 0.0216, 'lps'),
	(492304, 128, '2014-01-15 00:48:13.000000', 'consum', 0.0210, 'lps'),
	(492305, 128, '2014-01-15 00:48:14.000000', 'consum', 0.0210, 'lps'),
	(492306, 128, '2014-01-15 00:48:15.000000', 'consum', 0.0210, 'lps'),
	(492307, 128, '2014-01-15 00:48:16.000000', 'consum', 0.0225, 'lps'),
	(492308, 128, '2014-01-15 00:48:17.000000', 'consum', 0.0221, 'lps'),
	(492309, 128, '2014-01-15 00:48:18.000000', 'consum', 0.0219, 'lps'),
	(492310, 128, '2014-01-15 00:48:19.000000', 'consum', 0.0225, 'lps'),
	(492311, 128, '2014-01-15 00:48:20.000000', 'consum', 0.0210, 'lps'),
	(492312, 128, '2014-01-15 00:48:21.000000', 'consum', 0.0215, 'lps'),
	(492313, 128, '2014-01-15 00:48:22.000000', 'consum', 0.0220, 'lps'),
	(492314, 128, '2014-01-15 00:48:23.000000', 'consum', 0.0214, 'lps'),
	(492315, 128, '2014-01-15 00:48:24.000000', 'consum', 0.0213, 'lps'),
	(492316, 128, '2014-01-15 00:48:25.000000', 'consum', 0.0217, 'lps'),
	(492317, 128, '2014-01-15 00:48:26.000000', 'consum', 0.0219, 'lps'),
	(492318, 128, '2014-01-15 00:48:27.000000', 'consum', 0.0220, 'lps'),
	(492319, 128, '2014-01-15 00:48:28.000000', 'consum', 0.0217, 'lps'),
	(492320, 128, '2014-01-15 00:48:29.000000', 'consum', 0.0214, 'lps'),
	(492321, 128, '2014-01-15 00:48:30.000000', 'consum', 0.0225, 'lps'),
	(492322, 128, '2014-01-15 00:48:31.000000', 'consum', 0.0211, 'lps'),
	(492323, 128, '2014-01-15 00:48:32.000000', 'consum', 0.0217, 'lps'),
	(492324, 128, '2014-01-15 00:48:33.000000', 'consum', 0.0213, 'lps'),
	(492325, 128, '2014-01-15 00:48:34.000000', 'consum', 0.0219, 'lps'),
	(492326, 128, '2014-01-15 00:48:35.000000', 'consum', 0.0216, 'lps'),
	(492327, 128, '2014-01-15 00:48:36.000000', 'consum', 0.0212, 'lps'),
	(492328, 128, '2014-01-15 00:48:37.000000', 'consum', 0.0219, 'lps'),
	(492329, 128, '2014-01-15 00:48:38.000000', 'consum', 0.0218, 'lps'),
	(492330, 128, '2014-01-15 00:48:39.000000', 'consum', 0.0224, 'lps'),
	(492331, 128, '2014-01-15 00:48:40.000000', 'consum', 0.0224, 'lps'),
	(492332, 128, '2014-01-15 00:48:41.000000', 'consum', 0.0221, 'lps'),
	(492333, 128, '2014-01-15 00:48:42.000000', 'consum', 0.0225, 'lps'),
	(492334, 128, '2014-01-15 00:48:43.000000', 'consum', 0.0220, 'lps'),
	(492335, 128, '2014-01-15 00:48:44.000000', 'consum', 0.0215, 'lps'),
	(492336, 128, '2014-01-15 00:48:45.000000', 'consum', 0.0222, 'lps'),
	(492337, 128, '2014-01-15 00:48:46.000000', 'consum', 0.0222, 'lps'),
	(492338, 128, '2014-01-15 00:48:47.000000', 'consum', 0.0219, 'lps'),
	(492339, 128, '2014-01-15 00:48:48.000000', 'consum', 0.0222, 'lps'),
	(492340, 128, '2014-01-15 00:48:49.000000', 'consum', 0.0210, 'lps'),
	(492341, 128, '2014-01-15 00:48:50.000000', 'consum', 0.0222, 'lps'),
	(492342, 128, '2014-01-15 00:48:51.000000', 'consum', 0.0222, 'lps'),
	(492343, 128, '2014-01-15 00:48:52.000000', 'consum', 0.0218, 'lps'),
	(492344, 128, '2014-01-15 00:48:53.000000', 'consum', 0.0214, 'lps'),
	(492345, 128, '2014-01-15 00:48:54.000000', 'consum', 0.0225, 'lps'),
	(492346, 128, '2014-01-15 00:48:55.000000', 'consum', 0.0223, 'lps'),
	(492347, 128, '2014-01-15 00:48:56.000000', 'consum', 0.0213, 'lps'),
	(492348, 128, '2014-01-15 00:48:57.000000', 'consum', 0.0222, 'lps'),
	(492349, 128, '2014-01-15 00:48:58.000000', 'consum', 0.0213, 'lps'),
	(492350, 128, '2014-01-15 00:48:59.000000', 'consum', 0.0219, 'lps'),
	(492351, 128, '2014-01-15 00:49:00.000000', 'consum', 0.0217, 'lps'),
	(492352, 128, '2014-01-15 00:49:01.000000', 'consum', 0.0219, 'lps'),
	(492353, 128, '2014-01-15 00:49:02.000000', 'consum', 0.0218, 'lps'),
	(492354, 128, '2014-01-15 00:49:03.000000', 'consum', 0.0224, 'lps'),
	(492355, 128, '2014-01-15 00:49:04.000000', 'consum', 0.0223, 'lps'),
	(492356, 128, '2014-01-15 00:49:05.000000', 'consum', 0.0217, 'lps'),
	(492357, 128, '2014-01-15 00:49:06.000000', 'consum', 0.0225, 'lps'),
	(492358, 128, '2014-01-15 00:49:07.000000', 'consum', 0.0215, 'lps'),
	(492359, 128, '2014-01-15 00:49:08.000000', 'consum', 0.0224, 'lps'),
	(492360, 128, '2014-01-15 00:49:09.000000', 'consum', 0.0215, 'lps'),
	(492361, 128, '2014-01-15 00:49:10.000000', 'consum', 0.0210, 'lps'),
	(492362, 128, '2014-01-15 00:49:11.000000', 'consum', 0.0210, 'lps'),
	(492363, 128, '2014-01-15 00:49:12.000000', 'consum', 0.0213, 'lps'),
	(492364, 128, '2014-01-15 00:49:13.000000', 'consum', 0.0210, 'lps'),
	(492365, 128, '2014-01-15 00:49:14.000000', 'consum', 0.0215, 'lps'),
	(492366, 128, '2014-01-15 00:49:15.000000', 'consum', 0.0220, 'lps'),
	(492367, 128, '2014-01-15 00:49:16.000000', 'consum', 0.0215, 'lps'),
	(492368, 128, '2014-01-15 00:49:17.000000', 'consum', 0.0220, 'lps'),
	(492369, 128, '2014-01-15 00:49:18.000000', 'consum', 0.0216, 'lps'),
	(492370, 128, '2014-01-15 00:49:19.000000', 'consum', 0.0225, 'lps'),
	(492371, 128, '2014-01-15 00:49:20.000000', 'consum', 0.0218, 'lps'),
	(492372, 128, '2014-01-15 00:49:21.000000', 'consum', 0.0224, 'lps'),
	(492373, 128, '2014-01-15 00:49:22.000000', 'consum', 0.0225, 'lps'),
	(492374, 128, '2014-01-15 00:49:23.000000', 'consum', 0.0211, 'lps'),
	(492375, 128, '2014-01-15 00:49:24.000000', 'consum', 0.0219, 'lps'),
	(492376, 128, '2014-01-15 00:49:25.000000', 'consum', 0.0220, 'lps'),
	(492377, 128, '2014-01-15 00:49:26.000000', 'consum', 0.0216, 'lps'),
	(492378, 128, '2014-01-15 00:49:27.000000', 'consum', 0.0212, 'lps'),
	(492379, 128, '2014-01-15 00:49:28.000000', 'consum', 0.0220, 'lps'),
	(492380, 128, '2014-01-15 00:49:29.000000', 'consum', 0.0219, 'lps'),
	(492381, 128, '2014-01-15 00:49:30.000000', 'consum', 0.0213, 'lps'),
	(492382, 128, '2014-01-15 00:49:31.000000', 'consum', 0.0211, 'lps'),
	(492383, 128, '2014-01-15 00:49:32.000000', 'consum', 0.0224, 'lps'),
	(492384, 128, '2014-01-15 00:49:33.000000', 'consum', 0.0215, 'lps'),
	(492385, 128, '2014-01-15 00:49:34.000000', 'consum', 0.0225, 'lps'),
	(492386, 128, '2014-01-15 00:49:35.000000', 'consum', 0.0221, 'lps'),
	(492387, 128, '2014-01-15 00:49:36.000000', 'consum', 0.0221, 'lps'),
	(492388, 128, '2014-01-15 00:49:37.000000', 'consum', 0.0218, 'lps'),
	(492389, 128, '2014-01-15 00:49:38.000000', 'consum', 0.0218, 'lps'),
	(492390, 128, '2014-01-15 00:49:39.000000', 'consum', 0.0224, 'lps'),
	(492391, 128, '2014-01-15 00:49:40.000000', 'consum', 0.0225, 'lps'),
	(492392, 128, '2014-01-15 00:49:41.000000', 'consum', 0.0212, 'lps'),
	(492393, 128, '2014-01-15 00:49:42.000000', 'consum', 0.0224, 'lps'),
	(492394, 128, '2014-01-15 00:49:43.000000', 'consum', 0.0210, 'lps'),
	(492395, 128, '2014-01-15 00:49:44.000000', 'consum', 0.0219, 'lps'),
	(492396, 128, '2014-01-15 00:49:45.000000', 'consum', 0.0220, 'lps'),
	(492397, 128, '2014-01-15 00:49:46.000000', 'consum', 0.0218, 'lps'),
	(492398, 128, '2014-01-15 00:49:47.000000', 'consum', 0.0222, 'lps'),
	(492399, 128, '2014-01-15 00:49:48.000000', 'consum', 0.0215, 'lps'),
	(492400, 128, '2014-01-15 00:49:49.000000', 'consum', 0.0214, 'lps'),
	(492401, 128, '2014-01-15 00:49:50.000000', 'consum', 0.0216, 'lps'),
	(492402, 128, '2014-01-15 00:49:51.000000', 'consum', 0.0213, 'lps'),
	(492403, 128, '2014-01-15 00:49:52.000000', 'consum', 0.0221, 'lps'),
	(492404, 128, '2014-01-15 00:49:53.000000', 'consum', 0.0211, 'lps'),
	(492405, 128, '2014-01-15 00:49:54.000000', 'consum', 0.0216, 'lps'),
	(492406, 128, '2014-01-15 00:49:55.000000', 'consum', 0.0219, 'lps'),
	(492407, 128, '2014-01-15 00:49:56.000000', 'consum', 0.0221, 'lps'),
	(492408, 128, '2014-01-15 00:49:57.000000', 'consum', 0.0222, 'lps'),
	(492409, 128, '2014-01-15 00:49:58.000000', 'consum', 0.0224, 'lps'),
	(492410, 128, '2014-01-15 00:49:59.000000', 'consum', 0.0213, 'lps'),
	(492411, 128, '2014-01-15 00:50:00.000000', 'consum', 0.0212, 'lps'),
	(492412, 128, '2014-01-15 00:50:01.000000', 'consum', 0.0214, 'lps'),
	(492413, 128, '2014-01-15 00:50:02.000000', 'consum', 0.0225, 'lps'),
	(492414, 128, '2014-01-15 00:50:03.000000', 'consum', 0.0210, 'lps'),
	(492415, 128, '2014-01-15 00:50:04.000000', 'consum', 0.0212, 'lps'),
	(492416, 128, '2014-01-15 00:50:05.000000', 'consum', 0.0221, 'lps'),
	(492417, 128, '2014-01-15 00:50:06.000000', 'consum', 0.0211, 'lps'),
	(492418, 128, '2014-01-15 00:50:07.000000', 'consum', 0.0214, 'lps'),
	(492419, 128, '2014-01-15 00:50:08.000000', 'consum', 0.0213, 'lps'),
	(492420, 128, '2014-01-15 00:50:09.000000', 'consum', 0.0213, 'lps'),
	(492421, 128, '2014-01-15 00:50:10.000000', 'consum', 0.0216, 'lps'),
	(492422, 128, '2014-01-15 00:50:11.000000', 'consum', 0.0217, 'lps'),
	(492423, 128, '2014-01-15 00:50:12.000000', 'consum', 0.0225, 'lps'),
	(492424, 128, '2014-01-15 00:50:13.000000', 'consum', 0.0218, 'lps'),
	(492425, 128, '2014-01-15 00:50:14.000000', 'consum', 0.0223, 'lps'),
	(492426, 128, '2014-01-15 00:50:15.000000', 'consum', 0.0216, 'lps'),
	(492427, 128, '2014-01-15 00:50:16.000000', 'consum', 0.0221, 'lps'),
	(492428, 128, '2014-01-15 00:50:17.000000', 'consum', 0.0215, 'lps'),
	(492429, 128, '2014-01-15 00:50:18.000000', 'consum', 0.0216, 'lps'),
	(492430, 128, '2014-01-15 00:50:19.000000', 'consum', 0.0211, 'lps'),
	(492431, 128, '2014-01-15 00:50:20.000000', 'consum', 0.0213, 'lps'),
	(492432, 128, '2014-01-15 00:50:21.000000', 'consum', 0.0225, 'lps'),
	(492433, 128, '2014-01-15 00:50:22.000000', 'consum', 0.0210, 'lps'),
	(492434, 128, '2014-01-15 00:50:23.000000', 'consum', 0.0216, 'lps'),
	(492435, 128, '2014-01-15 00:50:24.000000', 'consum', 0.0224, 'lps'),
	(492436, 128, '2014-01-15 00:50:25.000000', 'consum', 0.0214, 'lps'),
	(492437, 128, '2014-01-15 00:50:26.000000', 'consum', 0.0221, 'lps'),
	(492438, 128, '2014-01-15 00:50:27.000000', 'consum', 0.0220, 'lps'),
	(492439, 128, '2014-01-15 00:50:28.000000', 'consum', 0.0211, 'lps'),
	(492440, 128, '2014-01-15 00:50:29.000000', 'consum', 0.0219, 'lps'),
	(492441, 128, '2014-01-15 00:50:30.000000', 'consum', 0.0221, 'lps'),
	(492442, 128, '2014-01-15 00:50:31.000000', 'consum', 0.0221, 'lps'),
	(492443, 128, '2014-01-15 00:50:32.000000', 'consum', 0.0215, 'lps'),
	(492444, 128, '2014-01-15 00:50:33.000000', 'consum', 0.0220, 'lps'),
	(492445, 128, '2014-01-15 00:50:34.000000', 'consum', 0.0214, 'lps'),
	(492446, 128, '2014-01-15 00:50:35.000000', 'consum', 0.0218, 'lps'),
	(492447, 128, '2014-01-15 00:50:36.000000', 'consum', 0.0220, 'lps'),
	(492448, 128, '2014-01-15 00:50:37.000000', 'consum', 0.0221, 'lps'),
	(492449, 128, '2014-01-15 00:50:38.000000', 'consum', 0.0221, 'lps'),
	(492450, 128, '2014-01-15 00:50:39.000000', 'consum', 0.0215, 'lps'),
	(492451, 128, '2014-01-15 00:50:40.000000', 'consum', 0.0220, 'lps'),
	(492452, 128, '2014-01-15 00:50:41.000000', 'consum', 0.0212, 'lps'),
	(492453, 128, '2014-01-15 00:50:42.000000', 'consum', 0.0225, 'lps'),
	(492454, 128, '2014-01-15 00:50:43.000000', 'consum', 0.0214, 'lps'),
	(492455, 128, '2014-01-15 00:50:44.000000', 'consum', 0.0218, 'lps'),
	(492456, 128, '2014-01-15 00:50:45.000000', 'consum', 0.0223, 'lps'),
	(492457, 128, '2014-01-15 00:50:46.000000', 'consum', 0.0221, 'lps'),
	(492458, 128, '2014-01-15 00:50:47.000000', 'consum', 0.0224, 'lps'),
	(492459, 128, '2014-01-15 00:50:48.000000', 'consum', 0.0216, 'lps'),
	(492460, 128, '2014-01-15 00:50:49.000000', 'consum', 0.0216, 'lps'),
	(492461, 128, '2014-01-15 00:50:50.000000', 'consum', 0.0221, 'lps'),
	(492462, 128, '2014-01-15 00:50:51.000000', 'consum', 0.0216, 'lps'),
	(492463, 128, '2014-01-15 00:50:52.000000', 'consum', 0.0224, 'lps'),
	(492464, 128, '2014-01-15 00:50:53.000000', 'consum', 0.0215, 'lps'),
	(492465, 128, '2014-01-15 00:50:54.000000', 'consum', 0.0210, 'lps'),
	(492466, 128, '2014-01-15 00:50:55.000000', 'consum', 0.0225, 'lps'),
	(492467, 128, '2014-01-15 00:50:56.000000', 'consum', 0.0224, 'lps'),
	(492468, 128, '2014-01-15 00:50:57.000000', 'consum', 0.0220, 'lps'),
	(492469, 128, '2014-01-15 00:50:58.000000', 'consum', 0.0216, 'lps'),
	(492470, 128, '2014-01-15 00:50:59.000000', 'consum', 0.0213, 'lps'),
	(492471, 128, '2014-01-15 00:51:00.000000', 'consum', 0.0225, 'lps'),
	(492472, 128, '2014-01-15 00:51:01.000000', 'consum', 0.0225, 'lps'),
	(492473, 128, '2014-01-15 00:51:02.000000', 'consum', 0.0210, 'lps'),
	(492474, 128, '2014-01-15 00:51:03.000000', 'consum', 0.0215, 'lps'),
	(492475, 128, '2014-01-15 00:51:04.000000', 'consum', 0.0220, 'lps'),
	(492476, 128, '2014-01-15 00:51:05.000000', 'consum', 0.0213, 'lps'),
	(492477, 128, '2014-01-15 00:51:06.000000', 'consum', 0.0211, 'lps'),
	(492478, 128, '2014-01-15 00:51:07.000000', 'consum', 0.0222, 'lps'),
	(492479, 128, '2014-01-15 00:51:08.000000', 'consum', 0.0221, 'lps'),
	(492480, 128, '2014-01-15 00:51:09.000000', 'consum', 0.0211, 'lps'),
	(492481, 128, '2014-01-15 00:51:10.000000', 'consum', 0.0217, 'lps'),
	(492482, 128, '2014-01-15 00:51:11.000000', 'consum', 0.0225, 'lps'),
	(492483, 128, '2014-01-15 00:51:12.000000', 'consum', 0.0218, 'lps'),
	(492484, 128, '2014-01-15 00:51:13.000000', 'consum', 0.0221, 'lps'),
	(492485, 128, '2014-01-15 00:51:14.000000', 'consum', 0.0210, 'lps'),
	(492486, 128, '2014-01-15 00:51:15.000000', 'consum', 0.0224, 'lps'),
	(492487, 128, '2014-01-15 00:51:16.000000', 'consum', 0.0217, 'lps'),
	(492488, 128, '2014-01-15 00:51:17.000000', 'consum', 0.0218, 'lps'),
	(492489, 128, '2014-01-15 00:51:18.000000', 'consum', 0.0214, 'lps'),
	(492490, 128, '2014-01-15 00:51:19.000000', 'consum', 0.0222, 'lps'),
	(492491, 128, '2014-01-15 00:51:20.000000', 'consum', 0.0212, 'lps'),
	(492492, 128, '2014-01-15 00:51:21.000000', 'consum', 0.0218, 'lps'),
	(492493, 128, '2014-01-15 00:51:22.000000', 'consum', 0.0225, 'lps'),
	(492494, 128, '2014-01-15 00:51:23.000000', 'consum', 0.0215, 'lps'),
	(492495, 128, '2014-01-15 00:51:24.000000', 'consum', 0.0222, 'lps'),
	(492496, 128, '2014-01-15 00:51:25.000000', 'consum', 0.0224, 'lps'),
	(492497, 128, '2014-01-15 00:51:26.000000', 'consum', 0.0211, 'lps'),
	(492498, 128, '2014-01-15 00:51:27.000000', 'consum', 0.0222, 'lps'),
	(492499, 128, '2014-01-15 00:51:28.000000', 'consum', 0.0220, 'lps'),
	(492500, 128, '2014-01-15 00:51:29.000000', 'consum', 0.0210, 'lps'),
	(492501, 128, '2014-01-15 00:51:30.000000', 'consum', 0.0212, 'lps'),
	(492502, 128, '2014-01-15 00:51:31.000000', 'consum', 0.0222, 'lps'),
	(492503, 128, '2014-01-15 00:51:32.000000', 'consum', 0.0215, 'lps'),
	(492504, 128, '2014-01-15 00:51:33.000000', 'consum', 0.0216, 'lps'),
	(492505, 128, '2014-01-15 00:51:34.000000', 'consum', 0.0210, 'lps'),
	(492506, 128, '2014-01-15 00:51:35.000000', 'consum', 0.0224, 'lps'),
	(492507, 128, '2014-01-15 00:51:36.000000', 'consum', 0.0216, 'lps'),
	(492508, 128, '2014-01-15 00:51:37.000000', 'consum', 0.0214, 'lps'),
	(492509, 128, '2014-01-15 00:51:38.000000', 'consum', 0.0214, 'lps'),
	(492510, 128, '2014-01-15 00:51:39.000000', 'consum', 0.0218, 'lps'),
	(492511, 128, '2014-01-15 00:51:40.000000', 'consum', 0.0224, 'lps'),
	(492512, 128, '2014-01-15 00:51:41.000000', 'consum', 0.0223, 'lps'),
	(492513, 128, '2014-01-15 00:51:42.000000', 'consum', 0.0216, 'lps'),
	(492514, 128, '2014-01-15 00:51:43.000000', 'consum', 0.0219, 'lps'),
	(492515, 128, '2014-01-15 00:51:44.000000', 'consum', 0.0223, 'lps'),
	(492516, 128, '2014-01-15 00:51:45.000000', 'consum', 0.0214, 'lps'),
	(492517, 128, '2014-01-15 00:51:46.000000', 'consum', 0.0224, 'lps'),
	(492518, 128, '2014-01-15 00:51:47.000000', 'consum', 0.0219, 'lps'),
	(492519, 128, '2014-01-15 00:51:48.000000', 'consum', 0.0213, 'lps'),
	(492520, 128, '2014-01-15 00:51:49.000000', 'consum', 0.0217, 'lps'),
	(492521, 128, '2014-01-15 00:51:50.000000', 'consum', 0.0219, 'lps'),
	(492522, 128, '2014-01-15 00:51:51.000000', 'consum', 0.0217, 'lps'),
	(492523, 128, '2014-01-15 00:51:52.000000', 'consum', 0.0219, 'lps'),
	(492524, 128, '2014-01-15 00:51:53.000000', 'consum', 0.0221, 'lps'),
	(492525, 128, '2014-01-15 00:51:54.000000', 'consum', 0.0221, 'lps'),
	(492526, 128, '2014-01-15 00:51:55.000000', 'consum', 0.0215, 'lps'),
	(492527, 128, '2014-01-15 00:51:56.000000', 'consum', 0.0219, 'lps'),
	(492528, 128, '2014-01-15 00:51:57.000000', 'consum', 0.0210, 'lps'),
	(492529, 128, '2014-01-15 00:51:58.000000', 'consum', 0.0214, 'lps'),
	(492530, 128, '2014-01-15 00:51:59.000000', 'consum', 0.0214, 'lps'),
	(492531, 128, '2014-01-15 00:52:00.000000', 'consum', 0.0220, 'lps'),
	(492532, 128, '2014-01-15 00:52:01.000000', 'consum', 0.0215, 'lps'),
	(492533, 128, '2014-01-15 00:52:02.000000', 'consum', 0.0221, 'lps'),
	(492534, 128, '2014-01-15 00:52:03.000000', 'consum', 0.0219, 'lps'),
	(492535, 128, '2014-01-15 00:52:04.000000', 'consum', 0.0223, 'lps'),
	(492536, 128, '2014-01-15 00:52:05.000000', 'consum', 0.0215, 'lps'),
	(492537, 128, '2014-01-15 00:52:06.000000', 'consum', 0.0213, 'lps'),
	(492538, 128, '2014-01-15 00:52:07.000000', 'consum', 0.0210, 'lps'),
	(492539, 128, '2014-01-15 00:52:08.000000', 'consum', 0.0218, 'lps'),
	(492540, 128, '2014-01-15 00:52:09.000000', 'consum', 0.0218, 'lps'),
	(492541, 128, '2014-01-15 00:52:10.000000', 'consum', 0.0211, 'lps'),
	(492542, 128, '2014-01-15 00:52:11.000000', 'consum', 0.0225, 'lps'),
	(492543, 128, '2014-01-15 00:52:12.000000', 'consum', 0.0218, 'lps'),
	(492544, 128, '2014-01-15 00:52:13.000000', 'consum', 0.0221, 'lps'),
	(492545, 128, '2014-01-15 00:52:14.000000', 'consum', 0.0225, 'lps'),
	(492546, 128, '2014-01-15 00:52:15.000000', 'consum', 0.0220, 'lps'),
	(492547, 128, '2014-01-15 00:52:16.000000', 'consum', 0.0216, 'lps'),
	(492548, 128, '2014-01-15 00:52:17.000000', 'consum', 0.0212, 'lps'),
	(492549, 128, '2014-01-15 00:52:18.000000', 'consum', 0.0217, 'lps'),
	(492550, 128, '2014-01-15 00:52:19.000000', 'consum', 0.0222, 'lps'),
	(492551, 128, '2014-01-15 00:52:20.000000', 'consum', 0.0219, 'lps'),
	(492552, 128, '2014-01-15 00:52:21.000000', 'consum', 0.0221, 'lps'),
	(492553, 128, '2014-01-15 00:52:22.000000', 'consum', 0.0220, 'lps'),
	(492554, 128, '2014-01-15 00:52:23.000000', 'consum', 0.0210, 'lps'),
	(492555, 128, '2014-01-15 00:52:24.000000', 'consum', 0.0216, 'lps'),
	(492556, 128, '2014-01-15 00:52:25.000000', 'consum', 0.0222, 'lps'),
	(492557, 128, '2014-01-15 00:52:26.000000', 'consum', 0.0222, 'lps'),
	(492558, 128, '2014-01-15 00:52:27.000000', 'consum', 0.0220, 'lps'),
	(492559, 128, '2014-01-15 00:52:28.000000', 'consum', 0.0224, 'lps'),
	(492560, 128, '2014-01-15 00:52:29.000000', 'consum', 0.0218, 'lps'),
	(492561, 128, '2014-01-15 00:52:30.000000', 'consum', 0.0223, 'lps'),
	(492562, 128, '2014-01-15 00:52:31.000000', 'consum', 0.0220, 'lps'),
	(492563, 128, '2014-01-15 00:52:32.000000', 'consum', 0.0220, 'lps'),
	(492564, 128, '2014-01-15 00:52:33.000000', 'consum', 0.0217, 'lps'),
	(492565, 128, '2014-01-15 00:52:34.000000', 'consum', 0.0214, 'lps'),
	(492566, 128, '2014-01-15 00:52:35.000000', 'consum', 0.0225, 'lps'),
	(492567, 128, '2014-01-15 00:52:36.000000', 'consum', 0.0212, 'lps'),
	(492568, 128, '2014-01-15 00:52:37.000000', 'consum', 0.0223, 'lps'),
	(492569, 128, '2014-01-15 00:52:38.000000', 'consum', 0.0223, 'lps'),
	(492570, 128, '2014-01-15 00:52:39.000000', 'consum', 0.0218, 'lps'),
	(492571, 128, '2014-01-15 00:52:40.000000', 'consum', 0.0212, 'lps'),
	(492572, 128, '2014-01-15 00:52:41.000000', 'consum', 0.0213, 'lps'),
	(492573, 128, '2014-01-15 00:52:42.000000', 'consum', 0.0220, 'lps'),
	(492574, 128, '2014-01-15 00:52:43.000000', 'consum', 0.0218, 'lps'),
	(492575, 128, '2014-01-15 00:52:44.000000', 'consum', 0.0220, 'lps'),
	(492576, 128, '2014-01-15 00:52:45.000000', 'consum', 0.0220, 'lps'),
	(492577, 128, '2014-01-15 00:52:46.000000', 'consum', 0.0215, 'lps'),
	(492578, 128, '2014-01-15 00:52:47.000000', 'consum', 0.0223, 'lps'),
	(492579, 128, '2014-01-15 00:52:48.000000', 'consum', 0.0214, 'lps'),
	(492580, 128, '2014-01-15 00:52:49.000000', 'consum', 0.0220, 'lps'),
	(492581, 128, '2014-01-15 00:52:50.000000', 'consum', 0.0217, 'lps'),
	(492582, 128, '2014-01-15 00:52:51.000000', 'consum', 0.0215, 'lps'),
	(492583, 128, '2014-01-15 00:52:52.000000', 'consum', 0.0214, 'lps'),
	(492584, 128, '2014-01-15 00:52:53.000000', 'consum', 0.0216, 'lps'),
	(492585, 128, '2014-01-15 00:52:54.000000', 'consum', 0.0213, 'lps'),
	(492586, 128, '2014-01-15 00:52:55.000000', 'consum', 0.0224, 'lps'),
	(492587, 128, '2014-01-15 00:52:56.000000', 'consum', 0.0225, 'lps'),
	(492588, 128, '2014-01-15 00:52:57.000000', 'consum', 0.0225, 'lps'),
	(492589, 128, '2014-01-15 00:52:58.000000', 'consum', 0.0210, 'lps'),
	(492590, 128, '2014-01-15 00:52:59.000000', 'consum', 0.0214, 'lps'),
	(492591, 128, '2014-01-15 00:53:00.000000', 'consum', 0.0216, 'lps'),
	(492592, 128, '2014-01-15 00:53:01.000000', 'consum', 0.0210, 'lps'),
	(492593, 128, '2014-01-15 00:53:02.000000', 'consum', 0.0210, 'lps'),
	(492594, 128, '2014-01-15 00:53:03.000000', 'consum', 0.0224, 'lps'),
	(492595, 128, '2014-01-15 00:53:04.000000', 'consum', 0.0220, 'lps'),
	(492596, 128, '2014-01-15 00:53:05.000000', 'consum', 0.0215, 'lps'),
	(492597, 128, '2014-01-15 00:53:06.000000', 'consum', 0.0223, 'lps'),
	(492598, 128, '2014-01-15 00:53:07.000000', 'consum', 0.0210, 'lps'),
	(492599, 128, '2014-01-15 00:53:08.000000', 'consum', 0.0223, 'lps'),
	(492600, 128, '2014-01-15 00:53:09.000000', 'consum', 0.0224, 'lps'),
	(492601, 128, '2014-01-15 00:53:10.000000', 'consum', 0.0213, 'lps'),
	(492602, 128, '2014-01-15 00:53:11.000000', 'consum', 0.0213, 'lps'),
	(492603, 128, '2014-01-15 00:53:12.000000', 'consum', 0.0216, 'lps'),
	(492604, 128, '2014-01-15 00:53:13.000000', 'consum', 0.0215, 'lps'),
	(492605, 128, '2014-01-15 00:53:14.000000', 'consum', 0.0216, 'lps'),
	(492606, 128, '2014-01-15 00:53:15.000000', 'consum', 0.0213, 'lps'),
	(492607, 128, '2014-01-15 00:53:16.000000', 'consum', 0.0222, 'lps'),
	(492608, 128, '2014-01-15 00:53:17.000000', 'consum', 0.0213, 'lps'),
	(492609, 128, '2014-01-15 00:53:18.000000', 'consum', 0.0220, 'lps'),
	(492610, 128, '2014-01-15 00:53:19.000000', 'consum', 0.0223, 'lps'),
	(492611, 128, '2014-01-15 00:53:20.000000', 'consum', 0.0211, 'lps'),
	(492612, 128, '2014-01-15 00:53:21.000000', 'consum', 0.0224, 'lps'),
	(492613, 128, '2014-01-15 00:53:22.000000', 'consum', 0.0214, 'lps'),
	(492614, 128, '2014-01-15 00:53:23.000000', 'consum', 0.0223, 'lps'),
	(492615, 128, '2014-01-15 00:53:24.000000', 'consum', 0.0213, 'lps'),
	(492616, 128, '2014-01-15 00:53:25.000000', 'consum', 0.0218, 'lps'),
	(492617, 128, '2014-01-15 00:53:26.000000', 'consum', 0.0210, 'lps'),
	(492618, 128, '2014-01-15 00:53:27.000000', 'consum', 0.0221, 'lps'),
	(492619, 128, '2014-01-15 00:53:28.000000', 'consum', 0.0215, 'lps'),
	(492620, 128, '2014-01-15 00:53:29.000000', 'consum', 0.0220, 'lps'),
	(492621, 128, '2014-01-15 00:53:30.000000', 'consum', 0.0211, 'lps'),
	(492622, 128, '2014-01-15 00:53:31.000000', 'consum', 0.0219, 'lps'),
	(492623, 128, '2014-01-15 00:53:32.000000', 'consum', 0.0222, 'lps'),
	(492624, 128, '2014-01-15 00:53:33.000000', 'consum', 0.0211, 'lps'),
	(492625, 128, '2014-01-15 00:53:34.000000', 'consum', 0.0225, 'lps'),
	(492626, 128, '2014-01-15 00:53:35.000000', 'consum', 0.0222, 'lps'),
	(492627, 128, '2014-01-15 00:53:36.000000', 'consum', 0.0223, 'lps'),
	(492628, 128, '2014-01-15 00:53:37.000000', 'consum', 0.0223, 'lps'),
	(492629, 128, '2014-01-15 00:53:38.000000', 'consum', 0.0220, 'lps'),
	(492630, 128, '2014-01-15 00:53:39.000000', 'consum', 0.0224, 'lps'),
	(492631, 128, '2014-01-15 00:53:40.000000', 'consum', 0.0218, 'lps'),
	(492632, 128, '2014-01-15 00:53:41.000000', 'consum', 0.0210, 'lps'),
	(492633, 128, '2014-01-15 00:53:42.000000', 'consum', 0.0217, 'lps'),
	(492634, 128, '2014-01-15 00:53:43.000000', 'consum', 0.0215, 'lps'),
	(492635, 128, '2014-01-15 00:53:44.000000', 'consum', 0.0216, 'lps'),
	(492636, 128, '2014-01-15 00:53:45.000000', 'consum', 0.0222, 'lps'),
	(492637, 128, '2014-01-15 00:53:46.000000', 'consum', 0.0222, 'lps'),
	(492638, 128, '2014-01-15 00:53:47.000000', 'consum', 0.0219, 'lps'),
	(492639, 128, '2014-01-15 00:53:48.000000', 'consum', 0.0217, 'lps'),
	(492640, 128, '2014-01-15 00:53:49.000000', 'consum', 0.0220, 'lps'),
	(492641, 128, '2014-01-15 00:53:50.000000', 'consum', 0.0222, 'lps'),
	(492642, 128, '2014-01-15 00:53:51.000000', 'consum', 0.0211, 'lps'),
	(492643, 128, '2014-01-15 00:53:52.000000', 'consum', 0.0211, 'lps'),
	(492644, 128, '2014-01-15 00:53:53.000000', 'consum', 0.0212, 'lps'),
	(492645, 128, '2014-01-15 00:53:54.000000', 'consum', 0.0219, 'lps'),
	(492646, 128, '2014-01-15 00:53:55.000000', 'consum', 0.0216, 'lps'),
	(492647, 128, '2014-01-15 00:53:56.000000', 'consum', 0.0213, 'lps'),
	(492648, 128, '2014-01-15 00:53:57.000000', 'consum', 0.0223, 'lps'),
	(492649, 128, '2014-01-15 00:53:58.000000', 'consum', 0.0218, 'lps'),
	(492650, 128, '2014-01-15 00:53:59.000000', 'consum', 0.0214, 'lps'),
	(492651, 128, '2014-01-15 00:54:00.000000', 'consum', 0.0223, 'lps'),
	(492652, 128, '2014-01-15 00:54:01.000000', 'consum', 0.0214, 'lps'),
	(492653, 128, '2014-01-15 00:54:02.000000', 'consum', 0.0223, 'lps'),
	(492654, 128, '2014-01-15 00:54:03.000000', 'consum', 0.0214, 'lps'),
	(492655, 128, '2014-01-15 00:54:04.000000', 'consum', 0.0210, 'lps'),
	(492656, 128, '2014-01-15 00:54:05.000000', 'consum', 0.0212, 'lps'),
	(492657, 128, '2014-01-15 00:54:06.000000', 'consum', 0.0223, 'lps'),
	(492658, 128, '2014-01-15 00:54:07.000000', 'consum', 0.0220, 'lps'),
	(492659, 128, '2014-01-15 00:54:08.000000', 'consum', 0.0222, 'lps'),
	(492660, 128, '2014-01-15 00:54:09.000000', 'consum', 0.0223, 'lps'),
	(492661, 128, '2014-01-15 00:54:10.000000', 'consum', 0.0210, 'lps'),
	(492662, 128, '2014-01-15 00:54:11.000000', 'consum', 0.0218, 'lps'),
	(492663, 128, '2014-01-15 00:54:12.000000', 'consum', 0.0220, 'lps'),
	(492664, 128, '2014-01-15 00:54:13.000000', 'consum', 0.0219, 'lps'),
	(492665, 128, '2014-01-15 00:54:14.000000', 'consum', 0.0210, 'lps'),
	(492666, 128, '2014-01-15 00:54:15.000000', 'consum', 0.0215, 'lps'),
	(492667, 128, '2014-01-15 00:54:16.000000', 'consum', 0.0221, 'lps'),
	(492668, 128, '2014-01-15 00:54:17.000000', 'consum', 0.0216, 'lps'),
	(492669, 128, '2014-01-15 00:54:18.000000', 'consum', 0.0210, 'lps'),
	(492670, 128, '2014-01-15 00:54:19.000000', 'consum', 0.0223, 'lps'),
	(492671, 128, '2014-01-15 00:54:20.000000', 'consum', 0.0212, 'lps'),
	(492672, 128, '2014-01-15 00:54:21.000000', 'consum', 0.0214, 'lps'),
	(492673, 128, '2014-01-15 00:54:22.000000', 'consum', 0.0225, 'lps'),
	(492674, 128, '2014-01-15 00:54:23.000000', 'consum', 0.0225, 'lps'),
	(492675, 128, '2014-01-15 00:54:24.000000', 'consum', 0.0223, 'lps'),
	(492676, 128, '2014-01-15 00:54:25.000000', 'consum', 0.0217, 'lps'),
	(492677, 128, '2014-01-15 00:54:26.000000', 'consum', 0.0222, 'lps'),
	(492678, 128, '2014-01-15 00:54:27.000000', 'consum', 0.0217, 'lps'),
	(492679, 128, '2014-01-15 00:54:28.000000', 'consum', 0.0225, 'lps'),
	(492680, 128, '2014-01-15 00:54:29.000000', 'consum', 0.0216, 'lps'),
	(492681, 128, '2014-01-15 00:54:30.000000', 'consum', 0.0210, 'lps'),
	(492682, 128, '2014-01-15 00:54:31.000000', 'consum', 0.0212, 'lps'),
	(492683, 128, '2014-01-15 00:54:32.000000', 'consum', 0.0218, 'lps'),
	(492684, 128, '2014-01-15 00:54:33.000000', 'consum', 0.0212, 'lps'),
	(492685, 128, '2014-01-15 00:54:34.000000', 'consum', 0.0214, 'lps'),
	(492686, 128, '2014-01-15 00:54:35.000000', 'consum', 0.0223, 'lps'),
	(492687, 128, '2014-01-15 00:54:36.000000', 'consum', 0.0214, 'lps'),
	(492688, 128, '2014-01-15 00:54:37.000000', 'consum', 0.0210, 'lps'),
	(492689, 128, '2014-01-15 00:54:38.000000', 'consum', 0.0215, 'lps'),
	(492690, 128, '2014-01-15 00:54:39.000000', 'consum', 0.0220, 'lps'),
	(492691, 128, '2014-01-15 00:54:40.000000', 'consum', 0.0212, 'lps'),
	(492692, 128, '2014-01-15 00:54:41.000000', 'consum', 0.0224, 'lps'),
	(492693, 128, '2014-01-15 00:54:42.000000', 'consum', 0.0225, 'lps'),
	(492694, 128, '2014-01-15 00:54:43.000000', 'consum', 0.0212, 'lps'),
	(492695, 128, '2014-01-15 00:54:44.000000', 'consum', 0.0223, 'lps'),
	(492696, 128, '2014-01-15 00:54:45.000000', 'consum', 0.0223, 'lps'),
	(492697, 128, '2014-01-15 00:54:46.000000', 'consum', 0.0218, 'lps'),
	(492698, 128, '2014-01-15 00:54:47.000000', 'consum', 0.0212, 'lps'),
	(492699, 128, '2014-01-15 00:54:48.000000', 'consum', 0.0215, 'lps'),
	(492700, 128, '2014-01-15 00:54:49.000000', 'consum', 0.0210, 'lps'),
	(492701, 128, '2014-01-15 00:54:50.000000', 'consum', 0.0213, 'lps'),
	(492702, 128, '2014-01-15 00:54:51.000000', 'consum', 0.0210, 'lps'),
	(492703, 128, '2014-01-15 00:54:52.000000', 'consum', 0.0216, 'lps'),
	(492704, 128, '2014-01-15 00:54:53.000000', 'consum', 0.0224, 'lps'),
	(492705, 128, '2014-01-15 00:54:54.000000', 'consum', 0.0214, 'lps'),
	(492706, 128, '2014-01-15 00:54:55.000000', 'consum', 0.0220, 'lps'),
	(492707, 128, '2014-01-15 00:54:56.000000', 'consum', 0.0218, 'lps'),
	(492708, 128, '2014-01-15 00:54:57.000000', 'consum', 0.0222, 'lps'),
	(492709, 128, '2014-01-15 00:54:58.000000', 'consum', 0.0212, 'lps'),
	(492710, 128, '2014-01-15 00:54:59.000000', 'consum', 0.0218, 'lps'),
	(492711, 128, '2014-01-15 00:55:00.000000', 'consum', 0.0214, 'lps'),
	(492712, 128, '2014-01-15 00:55:01.000000', 'consum', 0.0220, 'lps'),
	(492713, 128, '2014-01-15 00:55:02.000000', 'consum', 0.0216, 'lps'),
	(492714, 128, '2014-01-15 00:55:03.000000', 'consum', 0.0212, 'lps'),
	(492715, 128, '2014-01-15 00:55:04.000000', 'consum', 0.0217, 'lps'),
	(492716, 128, '2014-01-15 00:55:05.000000', 'consum', 0.0210, 'lps'),
	(492717, 128, '2014-01-15 00:55:06.000000', 'consum', 0.0219, 'lps'),
	(492718, 128, '2014-01-15 00:55:07.000000', 'consum', 0.0222, 'lps'),
	(492719, 128, '2014-01-15 00:55:08.000000', 'consum', 0.0215, 'lps'),
	(492720, 128, '2014-01-15 00:55:09.000000', 'consum', 0.0214, 'lps'),
	(492721, 128, '2014-01-15 00:55:10.000000', 'consum', 0.0217, 'lps'),
	(492722, 128, '2014-01-15 00:55:11.000000', 'consum', 0.0217, 'lps'),
	(492723, 128, '2014-01-15 00:55:12.000000', 'consum', 0.0224, 'lps'),
	(492724, 128, '2014-01-15 00:55:13.000000', 'consum', 0.0211, 'lps'),
	(492725, 128, '2014-01-15 00:55:14.000000', 'consum', 0.0223, 'lps'),
	(492726, 128, '2014-01-15 00:55:15.000000', 'consum', 0.0222, 'lps'),
	(492727, 128, '2014-01-15 00:55:16.000000', 'consum', 0.0215, 'lps'),
	(492728, 128, '2014-01-15 00:55:17.000000', 'consum', 0.0217, 'lps'),
	(492729, 128, '2014-01-15 00:55:18.000000', 'consum', 0.0216, 'lps'),
	(492730, 128, '2014-01-15 00:55:19.000000', 'consum', 0.0217, 'lps'),
	(492731, 128, '2014-01-15 00:55:20.000000', 'consum', 0.0210, 'lps'),
	(492732, 128, '2014-01-15 00:55:21.000000', 'consum', 0.0225, 'lps'),
	(492733, 128, '2014-01-15 00:55:22.000000', 'consum', 0.0221, 'lps'),
	(492734, 128, '2014-01-15 00:55:23.000000', 'consum', 0.0219, 'lps'),
	(492735, 128, '2014-01-15 00:55:24.000000', 'consum', 0.0224, 'lps'),
	(492736, 128, '2014-01-15 00:55:25.000000', 'consum', 0.0223, 'lps'),
	(492737, 128, '2014-01-15 00:55:26.000000', 'consum', 0.0216, 'lps'),
	(492738, 128, '2014-01-15 00:55:27.000000', 'consum', 0.0217, 'lps'),
	(492739, 128, '2014-01-15 00:55:28.000000', 'consum', 0.0210, 'lps'),
	(492740, 128, '2014-01-15 00:55:29.000000', 'consum', 0.0222, 'lps'),
	(492741, 128, '2014-01-15 00:55:30.000000', 'consum', 0.0224, 'lps'),
	(492742, 128, '2014-01-15 00:55:31.000000', 'consum', 0.0211, 'lps'),
	(492743, 128, '2014-01-15 00:55:32.000000', 'consum', 0.0222, 'lps'),
	(492744, 128, '2014-01-15 00:55:33.000000', 'consum', 0.0217, 'lps'),
	(492745, 128, '2014-01-15 00:55:34.000000', 'consum', 0.0213, 'lps'),
	(492746, 128, '2014-01-15 00:55:35.000000', 'consum', 0.0221, 'lps'),
	(492747, 128, '2014-01-15 00:55:36.000000', 'consum', 0.0222, 'lps'),
	(492748, 128, '2014-01-15 00:55:37.000000', 'consum', 0.0221, 'lps'),
	(492749, 128, '2014-01-15 00:55:38.000000', 'consum', 0.0213, 'lps'),
	(492750, 128, '2014-01-15 00:55:39.000000', 'consum', 0.0225, 'lps'),
	(492751, 128, '2014-01-15 00:55:40.000000', 'consum', 0.0214, 'lps'),
	(492752, 128, '2014-01-15 00:55:41.000000', 'consum', 0.0215, 'lps'),
	(492753, 128, '2014-01-15 00:55:42.000000', 'consum', 0.0224, 'lps'),
	(492754, 128, '2014-01-15 00:55:43.000000', 'consum', 0.0218, 'lps'),
	(492755, 128, '2014-01-15 00:55:44.000000', 'consum', 0.0210, 'lps'),
	(492756, 128, '2014-01-15 00:55:45.000000', 'consum', 0.0218, 'lps'),
	(492757, 128, '2014-01-15 00:55:46.000000', 'consum', 0.0220, 'lps'),
	(492758, 128, '2014-01-15 00:55:47.000000', 'consum', 0.0218, 'lps'),
	(492759, 128, '2014-01-15 00:55:48.000000', 'consum', 0.0220, 'lps'),
	(492760, 128, '2014-01-15 00:55:49.000000', 'consum', 0.0222, 'lps'),
	(492761, 128, '2014-01-15 00:55:50.000000', 'consum', 0.0224, 'lps'),
	(492762, 128, '2014-01-15 00:55:51.000000', 'consum', 0.0214, 'lps'),
	(492763, 128, '2014-01-15 00:55:52.000000', 'consum', 0.0221, 'lps'),
	(492764, 128, '2014-01-15 00:55:53.000000', 'consum', 0.0220, 'lps'),
	(492765, 128, '2014-01-15 00:55:54.000000', 'consum', 0.0212, 'lps'),
	(492766, 128, '2014-01-15 00:55:55.000000', 'consum', 0.0222, 'lps'),
	(492767, 128, '2014-01-15 00:55:56.000000', 'consum', 0.0216, 'lps'),
	(492768, 128, '2014-01-15 00:55:57.000000', 'consum', 0.0220, 'lps'),
	(492769, 128, '2014-01-15 00:55:58.000000', 'consum', 0.0211, 'lps'),
	(492770, 128, '2014-01-15 00:55:59.000000', 'consum', 0.0217, 'lps'),
	(492771, 128, '2014-01-15 00:56:00.000000', 'consum', 0.0211, 'lps'),
	(492772, 128, '2014-01-15 00:56:01.000000', 'consum', 0.0210, 'lps'),
	(492773, 128, '2014-01-15 00:56:02.000000', 'consum', 0.0224, 'lps'),
	(492774, 128, '2014-01-15 00:56:03.000000', 'consum', 0.0214, 'lps'),
	(492775, 128, '2014-01-15 00:56:04.000000', 'consum', 0.0224, 'lps'),
	(492776, 128, '2014-01-15 00:56:05.000000', 'consum', 0.0220, 'lps'),
	(492777, 128, '2014-01-15 00:56:06.000000', 'consum', 0.0218, 'lps'),
	(492778, 128, '2014-01-15 00:56:07.000000', 'consum', 0.0221, 'lps'),
	(492779, 128, '2014-01-15 00:56:08.000000', 'consum', 0.0210, 'lps'),
	(492780, 128, '2014-01-15 00:56:09.000000', 'consum', 0.0210, 'lps'),
	(492781, 128, '2014-01-15 00:56:10.000000', 'consum', 0.0225, 'lps'),
	(492782, 128, '2014-01-15 00:56:11.000000', 'consum', 0.0221, 'lps'),
	(492783, 128, '2014-01-15 00:56:12.000000', 'consum', 0.0220, 'lps'),
	(492784, 128, '2014-01-15 00:56:13.000000', 'consum', 0.0212, 'lps'),
	(492785, 128, '2014-01-15 00:56:14.000000', 'consum', 0.0221, 'lps'),
	(492786, 128, '2014-01-15 00:56:15.000000', 'consum', 0.0213, 'lps'),
	(492787, 128, '2014-01-15 00:56:16.000000', 'consum', 0.0224, 'lps'),
	(492788, 128, '2014-01-15 00:56:17.000000', 'consum', 0.0222, 'lps'),
	(492789, 128, '2014-01-15 00:56:18.000000', 'consum', 0.0212, 'lps'),
	(492790, 128, '2014-01-15 00:56:19.000000', 'consum', 0.0220, 'lps'),
	(492791, 128, '2014-01-15 00:56:20.000000', 'consum', 0.0219, 'lps'),
	(492792, 128, '2014-01-15 00:56:21.000000', 'consum', 0.0212, 'lps'),
	(492793, 128, '2014-01-15 00:56:22.000000', 'consum', 0.0210, 'lps'),
	(492794, 128, '2014-01-15 00:56:23.000000', 'consum', 0.0218, 'lps'),
	(492795, 128, '2014-01-15 00:56:24.000000', 'consum', 0.0218, 'lps'),
	(492796, 128, '2014-01-15 00:56:25.000000', 'consum', 0.0211, 'lps'),
	(492797, 128, '2014-01-15 00:56:26.000000', 'consum', 0.0210, 'lps'),
	(492798, 128, '2014-01-15 00:56:27.000000', 'consum', 0.0221, 'lps'),
	(492799, 128, '2014-01-15 00:56:28.000000', 'consum', 0.0219, 'lps'),
	(492800, 128, '2014-01-15 00:56:29.000000', 'consum', 0.0221, 'lps'),
	(492801, 128, '2014-01-15 00:56:30.000000', 'consum', 0.0223, 'lps'),
	(492802, 128, '2014-01-15 00:56:31.000000', 'consum', 0.0211, 'lps'),
	(492803, 128, '2014-01-15 00:56:32.000000', 'consum', 0.0225, 'lps'),
	(492804, 128, '2014-01-15 00:56:33.000000', 'consum', 0.0220, 'lps'),
	(492805, 128, '2014-01-15 00:56:34.000000', 'consum', 0.0212, 'lps'),
	(492806, 128, '2014-01-15 00:56:35.000000', 'consum', 0.0224, 'lps'),
	(492807, 128, '2014-01-15 00:56:36.000000', 'consum', 0.0225, 'lps'),
	(492808, 128, '2014-01-15 00:56:37.000000', 'consum', 0.0213, 'lps'),
	(492809, 128, '2014-01-15 00:56:38.000000', 'consum', 0.0214, 'lps'),
	(492810, 128, '2014-01-15 00:56:39.000000', 'consum', 0.0220, 'lps'),
	(492811, 128, '2014-01-15 00:56:40.000000', 'consum', 0.0215, 'lps'),
	(492812, 128, '2014-01-15 00:56:41.000000', 'consum', 0.0224, 'lps'),
	(492813, 128, '2014-01-15 00:56:42.000000', 'consum', 0.0218, 'lps'),
	(492814, 128, '2014-01-15 00:56:43.000000', 'consum', 0.0210, 'lps'),
	(492815, 128, '2014-01-15 00:56:44.000000', 'consum', 0.0215, 'lps'),
	(492816, 128, '2014-01-15 00:56:45.000000', 'consum', 0.0221, 'lps'),
	(492817, 128, '2014-01-15 00:56:46.000000', 'consum', 0.0220, 'lps'),
	(492818, 128, '2014-01-15 00:56:47.000000', 'consum', 0.0210, 'lps'),
	(492819, 128, '2014-01-15 00:56:48.000000', 'consum', 0.0213, 'lps'),
	(492820, 128, '2014-01-15 00:56:49.000000', 'consum', 0.0210, 'lps'),
	(492821, 128, '2014-01-15 00:56:50.000000', 'consum', 0.0216, 'lps'),
	(492822, 128, '2014-01-15 00:56:51.000000', 'consum', 0.0211, 'lps'),
	(492823, 128, '2014-01-15 00:56:52.000000', 'consum', 0.0211, 'lps'),
	(492824, 128, '2014-01-15 00:56:53.000000', 'consum', 0.0215, 'lps'),
	(492825, 128, '2014-01-15 00:56:54.000000', 'consum', 0.0217, 'lps'),
	(492826, 128, '2014-01-15 00:56:55.000000', 'consum', 0.0213, 'lps'),
	(492827, 128, '2014-01-15 00:56:56.000000', 'consum', 0.0220, 'lps'),
	(492828, 128, '2014-01-15 00:56:57.000000', 'consum', 0.0219, 'lps'),
	(492829, 128, '2014-01-15 00:56:58.000000', 'consum', 0.0211, 'lps'),
	(492830, 128, '2014-01-15 00:56:59.000000', 'consum', 0.0222, 'lps'),
	(492831, 128, '2014-01-15 00:57:00.000000', 'consum', 0.0218, 'lps'),
	(492832, 128, '2014-01-15 00:57:01.000000', 'consum', 0.0215, 'lps'),
	(492833, 128, '2014-01-15 00:57:02.000000', 'consum', 0.0225, 'lps'),
	(492834, 128, '2014-01-15 00:57:03.000000', 'consum', 0.0210, 'lps'),
	(492835, 128, '2014-01-15 00:57:04.000000', 'consum', 0.0212, 'lps'),
	(492836, 128, '2014-01-15 00:57:05.000000', 'consum', 0.0221, 'lps'),
	(492837, 128, '2014-01-15 00:57:06.000000', 'consum', 0.0211, 'lps'),
	(492838, 128, '2014-01-15 00:57:07.000000', 'consum', 0.0215, 'lps'),
	(492839, 128, '2014-01-15 00:57:08.000000', 'consum', 0.0216, 'lps'),
	(492840, 128, '2014-01-15 00:57:09.000000', 'consum', 0.0224, 'lps'),
	(492841, 128, '2014-01-15 00:57:10.000000', 'consum', 0.0214, 'lps'),
	(492842, 128, '2014-01-15 00:57:11.000000', 'consum', 0.0222, 'lps'),
	(492843, 128, '2014-01-15 00:57:12.000000', 'consum', 0.0224, 'lps'),
	(492844, 128, '2014-01-15 00:57:13.000000', 'consum', 0.0216, 'lps'),
	(492845, 128, '2014-01-15 00:57:14.000000', 'consum', 0.0213, 'lps'),
	(492846, 128, '2014-01-15 00:57:15.000000', 'consum', 0.0224, 'lps'),
	(492847, 128, '2014-01-15 00:57:16.000000', 'consum', 0.0222, 'lps'),
	(492848, 128, '2014-01-15 00:57:17.000000', 'consum', 0.0214, 'lps'),
	(492849, 128, '2014-01-15 00:57:18.000000', 'consum', 0.0211, 'lps'),
	(492850, 128, '2014-01-15 00:57:19.000000', 'consum', 0.0219, 'lps'),
	(492851, 128, '2014-01-15 00:57:20.000000', 'consum', 0.0219, 'lps'),
	(492852, 128, '2014-01-15 00:57:21.000000', 'consum', 0.0213, 'lps'),
	(492853, 128, '2014-01-15 00:57:22.000000', 'consum', 0.0213, 'lps'),
	(492854, 128, '2014-01-15 00:57:23.000000', 'consum', 0.0218, 'lps'),
	(492855, 128, '2014-01-15 00:57:24.000000', 'consum', 0.0211, 'lps'),
	(492856, 128, '2014-01-15 00:57:25.000000', 'consum', 0.0223, 'lps'),
	(492857, 128, '2014-01-15 00:57:26.000000', 'consum', 0.0225, 'lps'),
	(492858, 128, '2014-01-15 00:57:27.000000', 'consum', 0.0214, 'lps'),
	(492859, 128, '2014-01-15 00:57:28.000000', 'consum', 0.0215, 'lps'),
	(492860, 128, '2014-01-15 00:57:29.000000', 'consum', 0.0210, 'lps'),
	(492861, 128, '2014-01-15 00:57:30.000000', 'consum', 0.0212, 'lps'),
	(492862, 128, '2014-01-15 00:57:31.000000', 'consum', 0.0219, 'lps'),
	(492863, 128, '2014-01-15 00:57:32.000000', 'consum', 0.0216, 'lps'),
	(492864, 128, '2014-01-15 00:57:33.000000', 'consum', 0.0216, 'lps'),
	(492865, 128, '2014-01-15 00:57:34.000000', 'consum', 0.0221, 'lps'),
	(492866, 128, '2014-01-15 00:57:35.000000', 'consum', 0.0215, 'lps'),
	(492867, 128, '2014-01-15 00:57:36.000000', 'consum', 0.0220, 'lps'),
	(492868, 128, '2014-01-15 00:57:37.000000', 'consum', 0.0215, 'lps'),
	(492869, 128, '2014-01-15 00:57:38.000000', 'consum', 0.0218, 'lps'),
	(492870, 128, '2014-01-15 00:57:39.000000', 'consum', 0.0222, 'lps'),
	(492871, 128, '2014-01-15 00:57:40.000000', 'consum', 0.0214, 'lps'),
	(492872, 128, '2014-01-15 00:57:41.000000', 'consum', 0.0211, 'lps'),
	(492873, 128, '2014-01-15 00:57:42.000000', 'consum', 0.0221, 'lps'),
	(492874, 128, '2014-01-15 00:57:43.000000', 'consum', 0.0212, 'lps'),
	(492875, 128, '2014-01-15 00:57:44.000000', 'consum', 0.0221, 'lps'),
	(492876, 128, '2014-01-15 00:57:45.000000', 'consum', 0.0210, 'lps'),
	(492877, 128, '2014-01-15 00:57:46.000000', 'consum', 0.0210, 'lps'),
	(492878, 128, '2014-01-15 00:57:47.000000', 'consum', 0.0210, 'lps'),
	(492879, 128, '2014-01-15 00:57:48.000000', 'consum', 0.0211, 'lps'),
	(492880, 128, '2014-01-15 00:57:49.000000', 'consum', 0.0216, 'lps'),
	(492881, 128, '2014-01-15 00:57:50.000000', 'consum', 0.0221, 'lps'),
	(492882, 128, '2014-01-15 00:57:51.000000', 'consum', 0.0216, 'lps'),
	(492883, 128, '2014-01-15 00:57:52.000000', 'consum', 0.0221, 'lps'),
	(492884, 128, '2014-01-15 00:57:53.000000', 'consum', 0.0219, 'lps'),
	(492885, 128, '2014-01-15 00:57:54.000000', 'consum', 0.0219, 'lps'),
	(492886, 128, '2014-01-15 00:57:55.000000', 'consum', 0.0215, 'lps'),
	(492887, 128, '2014-01-15 00:57:56.000000', 'consum', 0.0225, 'lps'),
	(492888, 128, '2014-01-15 00:57:57.000000', 'consum', 0.0222, 'lps'),
	(492889, 128, '2014-01-15 00:57:58.000000', 'consum', 0.0225, 'lps'),
	(492890, 128, '2014-01-15 00:57:59.000000', 'consum', 0.0217, 'lps'),
	(492891, 128, '2014-01-15 00:58:00.000000', 'consum', 0.0219, 'lps'),
	(492892, 128, '2014-01-15 00:58:01.000000', 'consum', 0.0217, 'lps'),
	(492893, 128, '2014-01-15 00:58:02.000000', 'consum', 0.0217, 'lps'),
	(492894, 128, '2014-01-15 00:58:03.000000', 'consum', 0.0210, 'lps'),
	(492895, 128, '2014-01-15 00:58:04.000000', 'consum', 0.0222, 'lps'),
	(492896, 128, '2014-01-15 00:58:05.000000', 'consum', 0.0224, 'lps'),
	(492897, 128, '2014-01-15 00:58:06.000000', 'consum', 0.0225, 'lps'),
	(492898, 128, '2014-01-15 00:58:07.000000', 'consum', 0.0213, 'lps'),
	(492899, 128, '2014-01-15 00:58:08.000000', 'consum', 0.0214, 'lps'),
	(492900, 128, '2014-01-15 00:58:09.000000', 'consum', 0.0221, 'lps'),
	(492901, 128, '2014-01-15 00:58:10.000000', 'consum', 0.0222, 'lps'),
	(492902, 128, '2014-01-15 00:58:11.000000', 'consum', 0.0223, 'lps'),
	(492903, 128, '2014-01-15 00:58:12.000000', 'consum', 0.0221, 'lps'),
	(492904, 128, '2014-01-15 00:58:13.000000', 'consum', 0.0212, 'lps'),
	(492905, 128, '2014-01-15 00:58:14.000000', 'consum', 0.0219, 'lps'),
	(492906, 128, '2014-01-15 00:58:15.000000', 'consum', 0.0216, 'lps'),
	(492907, 128, '2014-01-15 00:58:16.000000', 'consum', 0.0214, 'lps'),
	(492908, 128, '2014-01-15 00:58:17.000000', 'consum', 0.0211, 'lps'),
	(492909, 128, '2014-01-15 00:58:18.000000', 'consum', 0.0221, 'lps'),
	(492910, 128, '2014-01-15 00:58:19.000000', 'consum', 0.0214, 'lps'),
	(492911, 128, '2014-01-15 00:58:20.000000', 'consum', 0.0213, 'lps'),
	(492912, 128, '2014-01-15 00:58:21.000000', 'consum', 0.0214, 'lps'),
	(492913, 128, '2014-01-15 00:58:22.000000', 'consum', 0.0222, 'lps'),
	(492914, 128, '2014-01-15 00:58:23.000000', 'consum', 0.0210, 'lps'),
	(492915, 128, '2014-01-15 00:58:24.000000', 'consum', 0.0222, 'lps'),
	(492916, 128, '2014-01-15 00:58:25.000000', 'consum', 0.0222, 'lps'),
	(492917, 128, '2014-01-15 00:58:26.000000', 'consum', 0.0221, 'lps'),
	(492918, 128, '2014-01-15 00:58:27.000000', 'consum', 0.0213, 'lps'),
	(492919, 128, '2014-01-15 00:58:28.000000', 'consum', 0.0225, 'lps'),
	(492920, 128, '2014-01-15 00:58:29.000000', 'consum', 0.0210, 'lps'),
	(492921, 128, '2014-01-15 00:58:30.000000', 'consum', 0.0213, 'lps'),
	(492922, 128, '2014-01-15 00:58:31.000000', 'consum', 0.0211, 'lps'),
	(492923, 128, '2014-01-15 00:58:32.000000', 'consum', 0.0223, 'lps'),
	(492924, 128, '2014-01-15 00:58:33.000000', 'consum', 0.0225, 'lps'),
	(492925, 128, '2014-01-15 00:58:34.000000', 'consum', 0.0212, 'lps'),
	(492926, 128, '2014-01-15 00:58:35.000000', 'consum', 0.0224, 'lps'),
	(492927, 128, '2014-01-15 00:58:36.000000', 'consum', 0.0210, 'lps'),
	(492928, 128, '2014-01-15 00:58:37.000000', 'consum', 0.0215, 'lps'),
	(492929, 128, '2014-01-15 00:58:38.000000', 'consum', 0.0223, 'lps'),
	(492930, 128, '2014-01-15 00:58:39.000000', 'consum', 0.0225, 'lps'),
	(492931, 128, '2014-01-15 00:58:40.000000', 'consum', 0.0216, 'lps'),
	(492932, 128, '2014-01-15 00:58:41.000000', 'consum', 0.0213, 'lps'),
	(492933, 128, '2014-01-15 00:58:42.000000', 'consum', 0.0222, 'lps'),
	(492934, 129, '2014-01-15 00:00:00.000000', 'consum', 0.0214, 'lps'),
	(492935, 129, '2014-01-15 00:00:01.000000', 'consum', 0.0214, 'lps'),
	(492936, 129, '2014-01-15 00:00:02.000000', 'consum', 0.0216, 'lps'),
	(492937, 129, '2014-01-15 00:00:03.000000', 'consum', 0.0214, 'lps'),
	(492938, 129, '2014-01-15 00:00:04.000000', 'consum', 0.0215, 'lps'),
	(492939, 129, '2014-01-15 00:00:05.000000', 'consum', 0.0221, 'lps'),
	(492940, 129, '2014-01-15 00:00:06.000000', 'consum', 0.0211, 'lps'),
	(492941, 129, '2014-01-15 00:00:07.000000', 'consum', 0.0223, 'lps'),
	(492942, 129, '2014-01-15 00:00:08.000000', 'consum', 0.0218, 'lps'),
	(492943, 129, '2014-01-15 00:00:09.000000', 'consum', 0.0213, 'lps'),
	(492944, 129, '2014-01-15 00:00:10.000000', 'consum', 0.0212, 'lps'),
	(492945, 129, '2014-01-15 00:00:11.000000', 'consum', 0.0214, 'lps'),
	(492946, 129, '2014-01-15 00:00:12.000000', 'consum', 0.0211, 'lps'),
	(492947, 129, '2014-01-15 00:00:13.000000', 'consum', 0.0219, 'lps'),
	(492948, 129, '2014-01-15 00:00:14.000000', 'consum', 0.0221, 'lps'),
	(492949, 129, '2014-01-15 00:00:15.000000', 'consum', 0.0213, 'lps'),
	(492950, 129, '2014-01-15 00:00:16.000000', 'consum', 0.0220, 'lps'),
	(492951, 129, '2014-01-15 00:00:17.000000', 'consum', 0.0211, 'lps'),
	(492952, 129, '2014-01-15 00:00:18.000000', 'consum', 0.0213, 'lps'),
	(492953, 129, '2014-01-15 00:00:19.000000', 'consum', 0.0221, 'lps'),
	(492954, 129, '2014-01-15 00:00:20.000000', 'consum', 0.0215, 'lps'),
	(492955, 129, '2014-01-15 00:00:21.000000', 'consum', 0.0215, 'lps'),
	(492956, 129, '2014-01-15 00:00:22.000000', 'consum', 0.0223, 'lps'),
	(492957, 129, '2014-01-15 00:00:23.000000', 'consum', 0.0216, 'lps'),
	(492958, 129, '2014-01-15 00:00:24.000000', 'consum', 0.0218, 'lps'),
	(492959, 129, '2014-01-15 00:00:25.000000', 'consum', 0.0217, 'lps'),
	(492960, 129, '2014-01-15 00:00:26.000000', 'consum', 0.0223, 'lps'),
	(492961, 129, '2014-01-15 00:00:27.000000', 'consum', 0.0211, 'lps'),
	(492962, 129, '2014-01-15 00:00:28.000000', 'consum', 0.0220, 'lps'),
	(492963, 129, '2014-01-15 00:00:29.000000', 'consum', 0.0216, 'lps'),
	(492964, 129, '2014-01-15 00:00:30.000000', 'consum', 0.0210, 'lps'),
	(492965, 129, '2014-01-15 00:00:31.000000', 'consum', 0.0219, 'lps'),
	(492966, 129, '2014-01-15 00:00:32.000000', 'consum', 0.0213, 'lps'),
	(492967, 129, '2014-01-15 00:00:33.000000', 'consum', 0.0212, 'lps'),
	(492968, 129, '2014-01-15 00:00:34.000000', 'consum', 0.0213, 'lps'),
	(492969, 129, '2014-01-15 00:00:35.000000', 'consum', 0.0217, 'lps'),
	(492970, 129, '2014-01-15 00:00:36.000000', 'consum', 0.0211, 'lps'),
	(492971, 129, '2014-01-15 00:00:37.000000', 'consum', 0.0220, 'lps'),
	(492972, 129, '2014-01-15 00:00:38.000000', 'consum', 0.0216, 'lps'),
	(492973, 129, '2014-01-15 00:00:39.000000', 'consum', 0.0211, 'lps'),
	(492974, 129, '2014-01-15 00:00:40.000000', 'consum', 0.0211, 'lps'),
	(492975, 129, '2014-01-15 00:00:41.000000', 'consum', 0.0211, 'lps'),
	(492976, 129, '2014-01-15 00:00:42.000000', 'consum', 0.0213, 'lps'),
	(492977, 129, '2014-01-15 00:00:43.000000', 'consum', 0.0210, 'lps'),
	(492978, 129, '2014-01-15 00:00:44.000000', 'consum', 0.0213, 'lps'),
	(492979, 129, '2014-01-15 00:00:45.000000', 'consum', 0.0215, 'lps'),
	(492980, 129, '2014-01-15 00:00:46.000000', 'consum', 0.0210, 'lps'),
	(492981, 129, '2014-01-15 00:00:47.000000', 'consum', 0.0211, 'lps'),
	(492982, 129, '2014-01-15 00:00:48.000000', 'consum', 0.0217, 'lps'),
	(492983, 129, '2014-01-15 00:00:49.000000', 'consum', 0.0212, 'lps'),
	(492984, 129, '2014-01-15 00:00:50.000000', 'consum', 0.0216, 'lps'),
	(492985, 129, '2014-01-15 00:00:51.000000', 'consum', 0.0217, 'lps'),
	(492986, 129, '2014-01-15 00:00:52.000000', 'consum', 0.0216, 'lps'),
	(492987, 129, '2014-01-15 00:00:53.000000', 'consum', 0.0219, 'lps'),
	(492988, 129, '2014-01-15 00:00:54.000000', 'consum', 0.0210, 'lps'),
	(492989, 129, '2014-01-15 00:00:55.000000', 'consum', 0.0210, 'lps'),
	(492990, 129, '2014-01-15 00:00:56.000000', 'consum', 0.0213, 'lps'),
	(492991, 129, '2014-01-15 00:00:57.000000', 'consum', 0.0212, 'lps'),
	(492992, 129, '2014-01-15 00:00:58.000000', 'consum', 0.0210, 'lps'),
	(492993, 129, '2014-01-15 00:00:59.000000', 'consum', 0.0220, 'lps'),
	(492994, 129, '2014-01-15 00:01:00.000000', 'consum', 0.0218, 'lps'),
	(492995, 129, '2014-01-15 00:01:01.000000', 'consum', 0.0222, 'lps'),
	(492996, 129, '2014-01-15 00:01:02.000000', 'consum', 0.0218, 'lps'),
	(492997, 129, '2014-01-15 00:01:03.000000', 'consum', 0.0212, 'lps'),
	(492998, 129, '2014-01-15 00:01:04.000000', 'consum', 0.0214, 'lps'),
	(492999, 129, '2014-01-15 00:01:05.000000', 'consum', 0.0221, 'lps'),
	(493000, 129, '2014-01-15 00:01:06.000000', 'consum', 0.0214, 'lps'),
	(493001, 129, '2014-01-15 00:01:07.000000', 'consum', 0.0213, 'lps'),
	(493002, 129, '2014-01-15 00:01:08.000000', 'consum', 0.0211, 'lps'),
	(493003, 129, '2014-01-15 00:01:09.000000', 'consum', 0.0220, 'lps'),
	(493004, 129, '2014-01-15 00:01:10.000000', 'consum', 0.0218, 'lps'),
	(493005, 129, '2014-01-15 00:01:11.000000', 'consum', 0.0221, 'lps'),
	(493006, 129, '2014-01-15 00:01:12.000000', 'consum', 0.0211, 'lps'),
	(493007, 129, '2014-01-15 00:01:13.000000', 'consum', 0.0211, 'lps'),
	(493008, 129, '2014-01-15 00:01:14.000000', 'consum', 0.0215, 'lps'),
	(493009, 129, '2014-01-15 00:01:15.000000', 'consum', 0.0217, 'lps'),
	(493010, 129, '2014-01-15 00:01:16.000000', 'consum', 0.0215, 'lps'),
	(493011, 129, '2014-01-15 00:01:17.000000', 'consum', 0.0216, 'lps'),
	(493012, 129, '2014-01-15 00:01:18.000000', 'consum', 0.0223, 'lps'),
	(493013, 129, '2014-01-15 00:01:19.000000', 'consum', 0.0217, 'lps'),
	(493014, 129, '2014-01-15 00:01:20.000000', 'consum', 0.0223, 'lps'),
	(493015, 129, '2014-01-15 00:01:21.000000', 'consum', 0.0223, 'lps'),
	(493016, 129, '2014-01-15 00:01:22.000000', 'consum', 0.0222, 'lps'),
	(493017, 129, '2014-01-15 00:01:23.000000', 'consum', 0.0220, 'lps'),
	(493018, 129, '2014-01-15 00:01:24.000000', 'consum', 0.0222, 'lps'),
	(493019, 129, '2014-01-15 00:01:25.000000', 'consum', 0.0215, 'lps'),
	(493020, 129, '2014-01-15 00:01:26.000000', 'consum', 0.0212, 'lps'),
	(493021, 129, '2014-01-15 00:01:27.000000', 'consum', 0.0220, 'lps'),
	(493022, 129, '2014-01-15 00:01:28.000000', 'consum', 0.0212, 'lps'),
	(493023, 129, '2014-01-15 00:01:29.000000', 'consum', 0.0219, 'lps'),
	(493024, 129, '2014-01-15 00:01:30.000000', 'consum', 0.0223, 'lps'),
	(493025, 129, '2014-01-15 00:01:31.000000', 'consum', 0.0219, 'lps'),
	(493026, 129, '2014-01-15 00:01:32.000000', 'consum', 0.0215, 'lps'),
	(493027, 129, '2014-01-15 00:01:33.000000', 'consum', 0.0210, 'lps'),
	(493028, 129, '2014-01-15 00:01:34.000000', 'consum', 0.0221, 'lps'),
	(493029, 129, '2014-01-15 00:01:35.000000', 'consum', 0.0212, 'lps'),
	(493030, 129, '2014-01-15 00:01:36.000000', 'consum', 0.0216, 'lps'),
	(493031, 129, '2014-01-15 00:01:37.000000', 'consum', 0.0220, 'lps'),
	(493032, 129, '2014-01-15 00:01:38.000000', 'consum', 0.0213, 'lps'),
	(493033, 129, '2014-01-15 00:01:39.000000', 'consum', 0.0223, 'lps'),
	(493034, 129, '2014-01-15 00:01:40.000000', 'consum', 0.0212, 'lps'),
	(493035, 129, '2014-01-15 00:01:41.000000', 'consum', 0.0211, 'lps'),
	(493036, 129, '2014-01-15 00:01:42.000000', 'consum', 0.0223, 'lps'),
	(493037, 129, '2014-01-15 00:01:43.000000', 'consum', 0.0217, 'lps'),
	(493038, 129, '2014-01-15 00:01:44.000000', 'consum', 0.0220, 'lps'),
	(493039, 129, '2014-01-15 00:01:45.000000', 'consum', 0.0212, 'lps'),
	(493040, 129, '2014-01-15 00:01:46.000000', 'consum', 0.0218, 'lps'),
	(493041, 129, '2014-01-15 00:01:47.000000', 'consum', 0.0215, 'lps'),
	(493042, 129, '2014-01-15 00:01:48.000000', 'consum', 0.0213, 'lps'),
	(493043, 129, '2014-01-15 00:01:49.000000', 'consum', 0.0222, 'lps'),
	(493044, 129, '2014-01-15 00:01:50.000000', 'consum', 0.0222, 'lps'),
	(493045, 129, '2014-01-15 00:01:51.000000', 'consum', 0.0218, 'lps'),
	(493046, 129, '2014-01-15 00:01:52.000000', 'consum', 0.0215, 'lps'),
	(493047, 129, '2014-01-15 00:01:53.000000', 'consum', 0.0211, 'lps'),
	(493048, 129, '2014-01-15 00:01:54.000000', 'consum', 0.0216, 'lps'),
	(493049, 129, '2014-01-15 00:01:55.000000', 'consum', 0.0223, 'lps'),
	(493050, 129, '2014-01-15 00:01:56.000000', 'consum', 0.0216, 'lps'),
	(493051, 129, '2014-01-15 00:01:57.000000', 'consum', 0.0214, 'lps'),
	(493052, 129, '2014-01-15 00:01:58.000000', 'consum', 0.0215, 'lps'),
	(493053, 129, '2014-01-15 00:01:59.000000', 'consum', 0.0222, 'lps'),
	(493054, 129, '2014-01-15 00:02:00.000000', 'consum', 0.0212, 'lps'),
	(493055, 129, '2014-01-15 00:02:01.000000', 'consum', 0.0212, 'lps'),
	(493056, 129, '2014-01-15 00:02:02.000000', 'consum', 0.0215, 'lps'),
	(493057, 129, '2014-01-15 00:02:03.000000', 'consum', 0.0217, 'lps'),
	(493058, 129, '2014-01-15 00:02:04.000000', 'consum', 0.0218, 'lps'),
	(493059, 129, '2014-01-15 00:02:05.000000', 'consum', 0.0213, 'lps'),
	(493060, 129, '2014-01-15 00:02:06.000000', 'consum', 0.0216, 'lps'),
	(493061, 129, '2014-01-15 00:02:07.000000', 'consum', 0.0218, 'lps'),
	(493062, 129, '2014-01-15 00:02:08.000000', 'consum', 0.0220, 'lps'),
	(493063, 129, '2014-01-15 00:02:09.000000', 'consum', 0.0223, 'lps'),
	(493064, 129, '2014-01-15 00:02:10.000000', 'consum', 0.0215, 'lps'),
	(493065, 129, '2014-01-15 00:02:11.000000', 'consum', 0.0213, 'lps'),
	(493066, 129, '2014-01-15 00:02:12.000000', 'consum', 0.0211, 'lps'),
	(493067, 129, '2014-01-15 00:02:13.000000', 'consum', 0.0220, 'lps'),
	(493068, 129, '2014-01-15 00:02:14.000000', 'consum', 0.0217, 'lps'),
	(493069, 129, '2014-01-15 00:02:15.000000', 'consum', 0.0214, 'lps'),
	(493070, 129, '2014-01-15 00:02:16.000000', 'consum', 0.0223, 'lps'),
	(493071, 129, '2014-01-15 00:02:17.000000', 'consum', 0.0223, 'lps'),
	(493072, 129, '2014-01-15 00:02:18.000000', 'consum', 0.0221, 'lps'),
	(493073, 129, '2014-01-15 00:02:19.000000', 'consum', 0.0211, 'lps'),
	(493074, 129, '2014-01-15 00:02:20.000000', 'consum', 0.0211, 'lps'),
	(493075, 129, '2014-01-15 00:02:21.000000', 'consum', 0.0215, 'lps'),
	(493076, 129, '2014-01-15 00:02:22.000000', 'consum', 0.0217, 'lps'),
	(493077, 129, '2014-01-15 00:02:23.000000', 'consum', 0.0216, 'lps'),
	(493078, 129, '2014-01-15 00:02:24.000000', 'consum', 0.0221, 'lps'),
	(493079, 129, '2014-01-15 00:02:25.000000', 'consum', 0.0219, 'lps'),
	(493080, 129, '2014-01-15 00:02:26.000000', 'consum', 0.0210, 'lps'),
	(493081, 129, '2014-01-15 00:02:27.000000', 'consum', 0.0222, 'lps'),
	(493082, 129, '2014-01-15 00:02:28.000000', 'consum', 0.0218, 'lps'),
	(493083, 129, '2014-01-15 00:02:29.000000', 'consum', 0.0214, 'lps'),
	(493084, 129, '2014-01-15 00:02:30.000000', 'consum', 0.0220, 'lps'),
	(493085, 129, '2014-01-15 00:02:31.000000', 'consum', 0.0222, 'lps'),
	(493086, 129, '2014-01-15 00:02:32.000000', 'consum', 0.0213, 'lps'),
	(493087, 129, '2014-01-15 00:02:33.000000', 'consum', 0.0216, 'lps'),
	(493088, 129, '2014-01-15 00:02:34.000000', 'consum', 0.0219, 'lps'),
	(493089, 129, '2014-01-15 00:02:35.000000', 'consum', 0.0223, 'lps'),
	(493090, 129, '2014-01-15 00:02:36.000000', 'consum', 0.0220, 'lps'),
	(493091, 129, '2014-01-15 00:02:37.000000', 'consum', 0.0221, 'lps'),
	(493092, 129, '2014-01-15 00:02:38.000000', 'consum', 0.0220, 'lps'),
	(493093, 129, '2014-01-15 00:02:39.000000', 'consum', 0.0216, 'lps'),
	(493094, 129, '2014-01-15 00:02:40.000000', 'consum', 0.0222, 'lps'),
	(493095, 129, '2014-01-15 00:02:41.000000', 'consum', 0.0213, 'lps'),
	(493096, 129, '2014-01-15 00:02:42.000000', 'consum', 0.0216, 'lps'),
	(493097, 129, '2014-01-15 00:02:43.000000', 'consum', 0.0216, 'lps'),
	(493098, 129, '2014-01-15 00:02:44.000000', 'consum', 0.0210, 'lps'),
	(493099, 129, '2014-01-15 00:02:45.000000', 'consum', 0.0221, 'lps'),
	(493100, 129, '2014-01-15 00:02:46.000000', 'consum', 0.0221, 'lps'),
	(493101, 129, '2014-01-15 00:02:47.000000', 'consum', 0.0222, 'lps'),
	(493102, 129, '2014-01-15 00:02:48.000000', 'consum', 0.0220, 'lps'),
	(493103, 129, '2014-01-15 00:02:49.000000', 'consum', 0.0212, 'lps'),
	(493104, 129, '2014-01-15 00:02:50.000000', 'consum', 0.0219, 'lps'),
	(493105, 129, '2014-01-15 00:02:51.000000', 'consum', 0.0221, 'lps'),
	(493106, 129, '2014-01-15 00:02:52.000000', 'consum', 0.0212, 'lps'),
	(493107, 129, '2014-01-15 00:02:53.000000', 'consum', 0.0216, 'lps'),
	(493108, 129, '2014-01-15 00:02:54.000000', 'consum', 0.0221, 'lps'),
	(493109, 129, '2014-01-15 00:02:55.000000', 'consum', 0.0220, 'lps'),
	(493110, 129, '2014-01-15 00:02:56.000000', 'consum', 0.0212, 'lps'),
	(493111, 129, '2014-01-15 00:02:57.000000', 'consum', 0.0217, 'lps'),
	(493112, 129, '2014-01-15 00:02:58.000000', 'consum', 0.0215, 'lps'),
	(493113, 129, '2014-01-15 00:02:59.000000', 'consum', 0.0212, 'lps'),
	(493114, 129, '2014-01-15 00:03:00.000000', 'consum', 0.0222, 'lps'),
	(493115, 129, '2014-01-15 00:03:01.000000', 'consum', 0.0220, 'lps'),
	(493116, 129, '2014-01-15 00:03:02.000000', 'consum', 0.0223, 'lps'),
	(493117, 129, '2014-01-15 00:03:03.000000', 'consum', 0.0221, 'lps'),
	(493118, 129, '2014-01-15 00:03:04.000000', 'consum', 0.0211, 'lps'),
	(493119, 129, '2014-01-15 00:03:05.000000', 'consum', 0.0212, 'lps'),
	(493120, 129, '2014-01-15 00:03:06.000000', 'consum', 0.0215, 'lps'),
	(493121, 129, '2014-01-15 00:03:07.000000', 'consum', 0.0217, 'lps'),
	(493122, 129, '2014-01-15 00:03:08.000000', 'consum', 0.0216, 'lps'),
	(493123, 129, '2014-01-15 00:03:09.000000', 'consum', 0.0218, 'lps'),
	(493124, 129, '2014-01-15 00:03:10.000000', 'consum', 0.0221, 'lps'),
	(493125, 129, '2014-01-15 00:03:11.000000', 'consum', 0.0214, 'lps'),
	(493126, 129, '2014-01-15 00:03:12.000000', 'consum', 0.0212, 'lps'),
	(493127, 129, '2014-01-15 00:03:13.000000', 'consum', 0.0223, 'lps'),
	(493128, 129, '2014-01-15 00:03:14.000000', 'consum', 0.0211, 'lps'),
	(493129, 129, '2014-01-15 00:03:15.000000', 'consum', 0.0220, 'lps'),
	(493130, 129, '2014-01-15 00:03:16.000000', 'consum', 0.0216, 'lps'),
	(493131, 129, '2014-01-15 00:03:17.000000', 'consum', 0.0222, 'lps'),
	(493132, 129, '2014-01-15 00:03:18.000000', 'consum', 0.0214, 'lps'),
	(493133, 129, '2014-01-15 00:03:19.000000', 'consum', 0.0220, 'lps'),
	(493134, 129, '2014-01-15 00:03:20.000000', 'consum', 0.0219, 'lps'),
	(493135, 129, '2014-01-15 00:03:21.000000', 'consum', 0.0214, 'lps'),
	(493136, 129, '2014-01-15 00:03:22.000000', 'consum', 0.0216, 'lps'),
	(493137, 129, '2014-01-15 00:03:23.000000', 'consum', 0.0213, 'lps'),
	(493138, 129, '2014-01-15 00:03:24.000000', 'consum', 0.0223, 'lps'),
	(493139, 129, '2014-01-15 00:03:25.000000', 'consum', 0.0212, 'lps'),
	(493140, 129, '2014-01-15 00:03:26.000000', 'consum', 0.0220, 'lps'),
	(493141, 129, '2014-01-15 00:03:27.000000', 'consum', 0.0216, 'lps'),
	(493142, 129, '2014-01-15 00:03:28.000000', 'consum', 0.0210, 'lps'),
	(493143, 129, '2014-01-15 00:03:29.000000', 'consum', 0.0221, 'lps'),
	(493144, 129, '2014-01-15 00:03:30.000000', 'consum', 0.0221, 'lps'),
	(493145, 129, '2014-01-15 00:03:31.000000', 'consum', 0.0220, 'lps'),
	(493146, 129, '2014-01-15 00:03:32.000000', 'consum', 0.0215, 'lps'),
	(493147, 129, '2014-01-15 00:03:33.000000', 'consum', 0.0218, 'lps'),
	(493148, 129, '2014-01-15 00:03:34.000000', 'consum', 0.0221, 'lps'),
	(493149, 129, '2014-01-15 00:03:35.000000', 'consum', 0.0216, 'lps'),
	(493150, 129, '2014-01-15 00:03:36.000000', 'consum', 0.0218, 'lps'),
	(493151, 129, '2014-01-15 00:03:37.000000', 'consum', 0.0220, 'lps'),
	(493152, 129, '2014-01-15 00:03:38.000000', 'consum', 0.0222, 'lps'),
	(493153, 129, '2014-01-15 00:03:39.000000', 'consum', 0.0212, 'lps'),
	(493154, 129, '2014-01-15 00:03:40.000000', 'consum', 0.0212, 'lps'),
	(493155, 129, '2014-01-15 00:03:41.000000', 'consum', 0.0214, 'lps'),
	(493156, 129, '2014-01-15 00:03:42.000000', 'consum', 0.0211, 'lps'),
	(493157, 129, '2014-01-15 00:03:43.000000', 'consum', 0.0220, 'lps'),
	(493158, 129, '2014-01-15 00:03:44.000000', 'consum', 0.0213, 'lps'),
	(493159, 129, '2014-01-15 00:03:45.000000', 'consum', 0.0222, 'lps'),
	(493160, 129, '2014-01-15 00:03:46.000000', 'consum', 0.0222, 'lps'),
	(493161, 129, '2014-01-15 00:03:47.000000', 'consum', 0.0220, 'lps'),
	(493162, 129, '2014-01-15 00:03:48.000000', 'consum', 0.0212, 'lps'),
	(493163, 129, '2014-01-15 00:03:49.000000', 'consum', 0.0216, 'lps'),
	(493164, 129, '2014-01-15 00:03:50.000000', 'consum', 0.0223, 'lps'),
	(493165, 129, '2014-01-15 00:03:51.000000', 'consum', 0.0214, 'lps'),
	(493166, 129, '2014-01-15 00:03:52.000000', 'consum', 0.0218, 'lps'),
	(493167, 129, '2014-01-15 00:03:53.000000', 'consum', 0.0211, 'lps'),
	(493168, 129, '2014-01-15 00:03:54.000000', 'consum', 0.0221, 'lps'),
	(493169, 129, '2014-01-15 00:03:55.000000', 'consum', 0.0222, 'lps'),
	(493170, 129, '2014-01-15 00:03:56.000000', 'consum', 0.0221, 'lps'),
	(493171, 129, '2014-01-15 00:03:57.000000', 'consum', 0.0216, 'lps'),
	(493172, 129, '2014-01-15 00:03:58.000000', 'consum', 0.0221, 'lps'),
	(493173, 129, '2014-01-15 00:03:59.000000', 'consum', 0.0221, 'lps'),
	(493174, 129, '2014-01-15 00:04:00.000000', 'consum', 0.0219, 'lps'),
	(493175, 129, '2014-01-15 00:04:01.000000', 'consum', 0.0210, 'lps'),
	(493176, 129, '2014-01-15 00:04:02.000000', 'consum', 0.0223, 'lps'),
	(493177, 129, '2014-01-15 00:04:03.000000', 'consum', 0.0219, 'lps'),
	(493178, 129, '2014-01-15 00:04:04.000000', 'consum', 0.0216, 'lps'),
	(493179, 129, '2014-01-15 00:04:05.000000', 'consum', 0.0216, 'lps'),
	(493180, 129, '2014-01-15 00:04:06.000000', 'consum', 0.0210, 'lps'),
	(493181, 129, '2014-01-15 00:04:07.000000', 'consum', 0.0217, 'lps'),
	(493182, 129, '2014-01-15 00:04:08.000000', 'consum', 0.0217, 'lps'),
	(493183, 129, '2014-01-15 00:04:09.000000', 'consum', 0.0211, 'lps'),
	(493184, 129, '2014-01-15 00:04:10.000000', 'consum', 0.0221, 'lps'),
	(493185, 129, '2014-01-15 00:04:11.000000', 'consum', 0.0222, 'lps'),
	(493186, 129, '2014-01-15 00:04:12.000000', 'consum', 0.0211, 'lps'),
	(493187, 129, '2014-01-15 00:04:13.000000', 'consum', 0.0222, 'lps'),
	(493188, 129, '2014-01-15 00:04:14.000000', 'consum', 0.0211, 'lps'),
	(493189, 129, '2014-01-15 00:04:15.000000', 'consum', 0.0222, 'lps'),
	(493190, 129, '2014-01-15 00:04:16.000000', 'consum', 0.0210, 'lps'),
	(493191, 129, '2014-01-15 00:04:17.000000', 'consum', 0.0217, 'lps'),
	(493192, 129, '2014-01-15 00:04:18.000000', 'consum', 0.0219, 'lps'),
	(493193, 129, '2014-01-15 00:04:19.000000', 'consum', 0.0218, 'lps'),
	(493194, 129, '2014-01-15 00:04:20.000000', 'consum', 0.0210, 'lps'),
	(493195, 129, '2014-01-15 00:04:21.000000', 'consum', 0.0216, 'lps'),
	(493196, 129, '2014-01-15 00:04:22.000000', 'consum', 0.0211, 'lps'),
	(493197, 129, '2014-01-15 00:04:23.000000', 'consum', 0.0212, 'lps'),
	(493198, 129, '2014-01-15 00:04:24.000000', 'consum', 0.0217, 'lps'),
	(493199, 129, '2014-01-15 00:04:25.000000', 'consum', 0.0210, 'lps'),
	(493200, 129, '2014-01-15 00:04:26.000000', 'consum', 0.0218, 'lps'),
	(493201, 129, '2014-01-15 00:04:27.000000', 'consum', 0.0222, 'lps'),
	(493202, 129, '2014-01-15 00:04:28.000000', 'consum', 0.0217, 'lps'),
	(493203, 129, '2014-01-15 00:04:29.000000', 'consum', 0.0213, 'lps'),
	(493204, 129, '2014-01-15 00:04:30.000000', 'consum', 0.0218, 'lps'),
	(493205, 129, '2014-01-15 00:04:31.000000', 'consum', 0.0211, 'lps'),
	(493206, 129, '2014-01-15 00:04:32.000000', 'consum', 0.0220, 'lps'),
	(493207, 129, '2014-01-15 00:04:33.000000', 'consum', 0.0215, 'lps'),
	(493208, 129, '2014-01-15 00:04:34.000000', 'consum', 0.0222, 'lps'),
	(493209, 129, '2014-01-15 00:04:35.000000', 'consum', 0.0214, 'lps'),
	(493210, 129, '2014-01-15 00:04:36.000000', 'consum', 0.0221, 'lps'),
	(493211, 129, '2014-01-15 00:04:37.000000', 'consum', 0.0211, 'lps'),
	(493212, 129, '2014-01-15 00:04:38.000000', 'consum', 0.0212, 'lps'),
	(493213, 129, '2014-01-15 00:04:39.000000', 'consum', 0.0216, 'lps'),
	(493214, 129, '2014-01-15 00:04:40.000000', 'consum', 0.0219, 'lps'),
	(493215, 129, '2014-01-15 00:04:41.000000', 'consum', 0.0213, 'lps'),
	(493216, 129, '2014-01-15 00:04:42.000000', 'consum', 0.0211, 'lps'),
	(493217, 129, '2014-01-15 00:04:43.000000', 'consum', 0.0220, 'lps'),
	(493218, 129, '2014-01-15 00:04:44.000000', 'consum', 0.0217, 'lps'),
	(493219, 129, '2014-01-15 00:04:45.000000', 'consum', 0.0214, 'lps'),
	(493220, 129, '2014-01-15 00:04:46.000000', 'consum', 0.0223, 'lps'),
	(493221, 129, '2014-01-15 00:04:47.000000', 'consum', 0.0222, 'lps'),
	(493222, 129, '2014-01-15 00:04:48.000000', 'consum', 0.0216, 'lps'),
	(493223, 129, '2014-01-15 00:04:49.000000', 'consum', 0.0219, 'lps'),
	(493224, 129, '2014-01-15 00:04:50.000000', 'consum', 0.0223, 'lps'),
	(493225, 129, '2014-01-15 00:04:51.000000', 'consum', 0.0219, 'lps'),
	(493226, 129, '2014-01-15 00:04:52.000000', 'consum', 0.0220, 'lps'),
	(493227, 129, '2014-01-15 00:04:53.000000', 'consum', 0.0217, 'lps'),
	(493228, 129, '2014-01-15 00:04:54.000000', 'consum', 0.0216, 'lps'),
	(493229, 129, '2014-01-15 00:04:55.000000', 'consum', 0.0221, 'lps'),
	(493230, 129, '2014-01-15 00:04:56.000000', 'consum', 0.0217, 'lps'),
	(493231, 129, '2014-01-15 00:04:57.000000', 'consum', 0.0214, 'lps'),
	(493232, 129, '2014-01-15 00:04:58.000000', 'consum', 0.0221, 'lps'),
	(493233, 129, '2014-01-15 00:04:59.000000', 'consum', 0.0215, 'lps'),
	(493234, 129, '2014-01-15 00:05:00.000000', 'consum', 0.0216, 'lps'),
	(493235, 129, '2014-01-15 00:05:01.000000', 'consum', 0.0211, 'lps'),
	(493236, 129, '2014-01-15 00:05:02.000000', 'consum', 0.0210, 'lps'),
	(493237, 129, '2014-01-15 00:05:03.000000', 'consum', 0.0222, 'lps'),
	(493238, 129, '2014-01-15 00:05:04.000000', 'consum', 0.0216, 'lps'),
	(493239, 129, '2014-01-15 00:05:05.000000', 'consum', 0.0220, 'lps'),
	(493240, 129, '2014-01-15 00:05:06.000000', 'consum', 0.0212, 'lps'),
	(493241, 129, '2014-01-15 00:05:07.000000', 'consum', 0.0220, 'lps'),
	(493242, 129, '2014-01-15 00:05:08.000000', 'consum', 0.0210, 'lps'),
	(493243, 129, '2014-01-15 00:05:09.000000', 'consum', 0.0211, 'lps'),
	(493244, 129, '2014-01-15 00:05:10.000000', 'consum', 0.0213, 'lps'),
	(493245, 129, '2014-01-15 00:05:11.000000', 'consum', 0.0210, 'lps'),
	(493246, 129, '2014-01-15 00:05:12.000000', 'consum', 0.0214, 'lps'),
	(493247, 129, '2014-01-15 00:05:13.000000', 'consum', 0.0217, 'lps'),
	(493248, 129, '2014-01-15 00:05:14.000000', 'consum', 0.0218, 'lps'),
	(493249, 129, '2014-01-15 00:05:15.000000', 'consum', 0.0217, 'lps'),
	(493250, 129, '2014-01-15 00:05:16.000000', 'consum', 0.0222, 'lps'),
	(493251, 129, '2014-01-15 00:05:17.000000', 'consum', 0.0222, 'lps'),
	(493252, 129, '2014-01-15 00:05:18.000000', 'consum', 0.0221, 'lps'),
	(493253, 129, '2014-01-15 00:05:19.000000', 'consum', 0.0214, 'lps'),
	(493254, 129, '2014-01-15 00:05:20.000000', 'consum', 0.0214, 'lps'),
	(493255, 129, '2014-01-15 00:05:21.000000', 'consum', 0.0217, 'lps'),
	(493256, 129, '2014-01-15 00:05:22.000000', 'consum', 0.0220, 'lps'),
	(493257, 129, '2014-01-15 00:05:23.000000', 'consum', 0.0212, 'lps'),
	(493258, 129, '2014-01-15 00:05:24.000000', 'consum', 0.0216, 'lps'),
	(493259, 129, '2014-01-15 00:05:25.000000', 'consum', 0.0221, 'lps'),
	(493260, 129, '2014-01-15 00:05:26.000000', 'consum', 0.0220, 'lps'),
	(493261, 129, '2014-01-15 00:05:27.000000', 'consum', 0.0213, 'lps'),
	(493262, 129, '2014-01-15 00:05:28.000000', 'consum', 0.0211, 'lps'),
	(493263, 129, '2014-01-15 00:05:29.000000', 'consum', 0.0220, 'lps'),
	(493264, 129, '2014-01-15 00:05:30.000000', 'consum', 0.0215, 'lps'),
	(493265, 129, '2014-01-15 00:05:31.000000', 'consum', 0.0222, 'lps'),
	(493266, 129, '2014-01-15 00:05:32.000000', 'consum', 0.0210, 'lps'),
	(493267, 129, '2014-01-15 00:05:33.000000', 'consum', 0.0218, 'lps'),
	(493268, 129, '2014-01-15 00:05:34.000000', 'consum', 0.0210, 'lps'),
	(493269, 129, '2014-01-15 00:05:35.000000', 'consum', 0.0215, 'lps'),
	(493270, 129, '2014-01-15 00:05:36.000000', 'consum', 0.0220, 'lps'),
	(493271, 129, '2014-01-15 00:05:37.000000', 'consum', 0.0219, 'lps'),
	(493272, 129, '2014-01-15 00:05:38.000000', 'consum', 0.0211, 'lps'),
	(493273, 129, '2014-01-15 00:05:39.000000', 'consum', 0.0216, 'lps'),
	(493274, 129, '2014-01-15 00:05:40.000000', 'consum', 0.0222, 'lps'),
	(493275, 129, '2014-01-15 00:05:41.000000', 'consum', 0.0212, 'lps'),
	(493276, 129, '2014-01-15 00:05:42.000000', 'consum', 0.0210, 'lps'),
	(493277, 129, '2014-01-15 00:05:43.000000', 'consum', 0.0221, 'lps'),
	(493278, 129, '2014-01-15 00:05:44.000000', 'consum', 0.0222, 'lps'),
	(493279, 129, '2014-01-15 00:05:45.000000', 'consum', 0.0210, 'lps'),
	(493280, 129, '2014-01-15 00:05:46.000000', 'consum', 0.0216, 'lps'),
	(493281, 129, '2014-01-15 00:05:47.000000', 'consum', 0.0213, 'lps'),
	(493282, 129, '2014-01-15 00:05:48.000000', 'consum', 0.0220, 'lps'),
	(493283, 129, '2014-01-15 00:05:49.000000', 'consum', 0.0212, 'lps'),
	(493284, 129, '2014-01-15 00:05:50.000000', 'consum', 0.0219, 'lps'),
	(493285, 129, '2014-01-15 00:05:51.000000', 'consum', 0.0222, 'lps'),
	(493286, 129, '2014-01-15 00:05:52.000000', 'consum', 0.0213, 'lps'),
	(493287, 129, '2014-01-15 00:05:53.000000', 'consum', 0.0220, 'lps'),
	(493288, 129, '2014-01-15 00:05:54.000000', 'consum', 0.0221, 'lps'),
	(493289, 129, '2014-01-15 00:05:55.000000', 'consum', 0.0223, 'lps'),
	(493290, 129, '2014-01-15 00:05:56.000000', 'consum', 0.0213, 'lps'),
	(493291, 129, '2014-01-15 00:05:57.000000', 'consum', 0.0214, 'lps'),
	(493292, 129, '2014-01-15 00:05:58.000000', 'consum', 0.0210, 'lps'),
	(493293, 129, '2014-01-15 00:05:59.000000', 'consum', 0.0213, 'lps'),
	(493294, 129, '2014-01-15 00:06:00.000000', 'consum', 0.0223, 'lps'),
	(493295, 129, '2014-01-15 00:06:01.000000', 'consum', 0.0210, 'lps'),
	(493296, 129, '2014-01-15 00:06:02.000000', 'consum', 0.0214, 'lps'),
	(493297, 129, '2014-01-15 00:06:03.000000', 'consum', 0.0215, 'lps'),
	(493298, 129, '2014-01-15 00:06:04.000000', 'consum', 0.0210, 'lps'),
	(493299, 129, '2014-01-15 00:06:05.000000', 'consum', 0.0211, 'lps'),
	(493300, 129, '2014-01-15 00:06:06.000000', 'consum', 0.0216, 'lps'),
	(493301, 129, '2014-01-15 00:06:07.000000', 'consum', 0.0210, 'lps'),
	(493302, 129, '2014-01-15 00:06:08.000000', 'consum', 0.0219, 'lps'),
	(493303, 129, '2014-01-15 00:06:09.000000', 'consum', 0.0216, 'lps'),
	(493304, 129, '2014-01-15 00:06:10.000000', 'consum', 0.0211, 'lps'),
	(493305, 129, '2014-01-15 00:06:11.000000', 'consum', 0.0212, 'lps'),
	(493306, 129, '2014-01-15 00:06:12.000000', 'consum', 0.0216, 'lps'),
	(493307, 129, '2014-01-15 00:06:13.000000', 'consum', 0.0223, 'lps'),
	(493308, 129, '2014-01-15 00:06:14.000000', 'consum', 0.0216, 'lps'),
	(493309, 129, '2014-01-15 00:06:15.000000', 'consum', 0.0214, 'lps'),
	(493310, 129, '2014-01-15 00:06:16.000000', 'consum', 0.0215, 'lps'),
	(493311, 129, '2014-01-15 00:06:17.000000', 'consum', 0.0221, 'lps'),
	(493312, 129, '2014-01-15 00:06:18.000000', 'consum', 0.0222, 'lps'),
	(493313, 129, '2014-01-15 00:06:19.000000', 'consum', 0.0210, 'lps'),
	(493314, 129, '2014-01-15 00:06:20.000000', 'consum', 0.0217, 'lps'),
	(493315, 129, '2014-01-15 00:06:21.000000', 'consum', 0.0218, 'lps'),
	(493316, 129, '2014-01-15 00:06:22.000000', 'consum', 0.0215, 'lps'),
	(493317, 129, '2014-01-15 00:06:23.000000', 'consum', 0.0213, 'lps'),
	(493318, 129, '2014-01-15 00:06:24.000000', 'consum', 0.0210, 'lps'),
	(493319, 129, '2014-01-15 00:06:25.000000', 'consum', 0.0217, 'lps'),
	(493320, 129, '2014-01-15 00:06:26.000000', 'consum', 0.0215, 'lps'),
	(493321, 129, '2014-01-15 00:06:27.000000', 'consum', 0.0216, 'lps'),
	(493322, 129, '2014-01-15 00:06:28.000000', 'consum', 0.0213, 'lps'),
	(493323, 129, '2014-01-15 00:06:29.000000', 'consum', 0.0220, 'lps'),
	(493324, 129, '2014-01-15 00:06:30.000000', 'consum', 0.0211, 'lps'),
	(493325, 129, '2014-01-15 00:06:31.000000', 'consum', 0.0211, 'lps'),
	(493326, 129, '2014-01-15 00:06:32.000000', 'consum', 0.0213, 'lps'),
	(493327, 129, '2014-01-15 00:06:33.000000', 'consum', 0.0223, 'lps'),
	(493328, 129, '2014-01-15 00:06:34.000000', 'consum', 0.0211, 'lps'),
	(493329, 129, '2014-01-15 00:06:35.000000', 'consum', 0.0220, 'lps'),
	(493330, 129, '2014-01-15 00:06:36.000000', 'consum', 0.0213, 'lps'),
	(493331, 129, '2014-01-15 00:06:37.000000', 'consum', 0.0223, 'lps'),
	(493332, 129, '2014-01-15 00:06:38.000000', 'consum', 0.0213, 'lps'),
	(493333, 129, '2014-01-15 00:06:39.000000', 'consum', 0.0213, 'lps'),
	(493334, 129, '2014-01-15 00:06:40.000000', 'consum', 0.0219, 'lps'),
	(493335, 129, '2014-01-15 00:06:41.000000', 'consum', 0.0216, 'lps'),
	(493336, 129, '2014-01-15 00:06:42.000000', 'consum', 0.0216, 'lps'),
	(493337, 129, '2014-01-15 00:06:43.000000', 'consum', 0.0222, 'lps'),
	(493338, 129, '2014-01-15 00:06:44.000000', 'consum', 0.0211, 'lps'),
	(493339, 129, '2014-01-15 00:06:45.000000', 'consum', 0.0219, 'lps'),
	(493340, 129, '2014-01-15 00:06:46.000000', 'consum', 0.0211, 'lps'),
	(493341, 129, '2014-01-15 00:06:47.000000', 'consum', 0.0218, 'lps'),
	(493342, 129, '2014-01-15 00:06:48.000000', 'consum', 0.0220, 'lps'),
	(493343, 129, '2014-01-15 00:06:49.000000', 'consum', 0.0220, 'lps'),
	(493344, 129, '2014-01-15 00:06:50.000000', 'consum', 0.0216, 'lps'),
	(493345, 129, '2014-01-15 00:06:51.000000', 'consum', 0.0213, 'lps'),
	(493346, 129, '2014-01-15 00:06:52.000000', 'consum', 0.0220, 'lps'),
	(493347, 129, '2014-01-15 00:06:53.000000', 'consum', 0.0223, 'lps'),
	(493348, 129, '2014-01-15 00:06:54.000000', 'consum', 0.0218, 'lps'),
	(493349, 129, '2014-01-15 00:06:55.000000', 'consum', 0.0212, 'lps'),
	(493350, 129, '2014-01-15 00:06:56.000000', 'consum', 0.0223, 'lps'),
	(493351, 129, '2014-01-15 00:06:57.000000', 'consum', 0.0216, 'lps'),
	(493352, 129, '2014-01-15 00:06:58.000000', 'consum', 0.0215, 'lps'),
	(493353, 129, '2014-01-15 00:06:59.000000', 'consum', 0.0216, 'lps'),
	(493354, 129, '2014-01-15 00:07:00.000000', 'consum', 0.0214, 'lps'),
	(493355, 129, '2014-01-15 00:07:01.000000', 'consum', 0.0211, 'lps'),
	(493356, 129, '2014-01-15 00:07:02.000000', 'consum', 0.0220, 'lps'),
	(493357, 129, '2014-01-15 00:07:03.000000', 'consum', 0.0212, 'lps'),
	(493358, 129, '2014-01-15 00:07:04.000000', 'consum', 0.0220, 'lps'),
	(493359, 129, '2014-01-15 00:07:05.000000', 'consum', 0.0212, 'lps'),
	(493360, 129, '2014-01-15 00:07:06.000000', 'consum', 0.0217, 'lps'),
	(493361, 129, '2014-01-15 00:07:07.000000', 'consum', 0.0211, 'lps'),
	(493362, 129, '2014-01-15 00:07:08.000000', 'consum', 0.0211, 'lps'),
	(493363, 129, '2014-01-15 00:07:09.000000', 'consum', 0.0212, 'lps'),
	(493364, 129, '2014-01-15 00:07:10.000000', 'consum', 0.0219, 'lps'),
	(493365, 129, '2014-01-15 00:07:11.000000', 'consum', 0.0221, 'lps'),
	(493366, 129, '2014-01-15 00:07:12.000000', 'consum', 0.0210, 'lps'),
	(493367, 129, '2014-01-15 00:07:13.000000', 'consum', 0.0218, 'lps'),
	(493368, 129, '2014-01-15 00:07:14.000000', 'consum', 0.0211, 'lps'),
	(493369, 129, '2014-01-15 00:07:15.000000', 'consum', 0.0221, 'lps'),
	(493370, 129, '2014-01-15 00:07:16.000000', 'consum', 0.0217, 'lps'),
	(493371, 129, '2014-01-15 00:07:17.000000', 'consum', 0.0212, 'lps'),
	(493372, 129, '2014-01-15 00:07:18.000000', 'consum', 0.0215, 'lps'),
	(493373, 129, '2014-01-15 00:07:19.000000', 'consum', 0.0216, 'lps'),
	(493374, 129, '2014-01-15 00:07:20.000000', 'consum', 0.0223, 'lps'),
	(493375, 129, '2014-01-15 00:07:21.000000', 'consum', 0.0219, 'lps'),
	(493376, 129, '2014-01-15 00:07:22.000000', 'consum', 0.0214, 'lps'),
	(493377, 129, '2014-01-15 00:07:23.000000', 'consum', 0.0220, 'lps'),
	(493378, 129, '2014-01-15 00:07:24.000000', 'consum', 0.0218, 'lps'),
	(493379, 129, '2014-01-15 00:07:25.000000', 'consum', 0.0219, 'lps'),
	(493380, 129, '2014-01-15 00:07:26.000000', 'consum', 0.0221, 'lps'),
	(493381, 129, '2014-01-15 00:07:27.000000', 'consum', 0.0222, 'lps'),
	(493382, 129, '2014-01-15 00:07:28.000000', 'consum', 0.0210, 'lps'),
	(493383, 129, '2014-01-15 00:07:29.000000', 'consum', 0.0216, 'lps'),
	(493384, 129, '2014-01-15 00:07:30.000000', 'consum', 0.0213, 'lps'),
	(493385, 129, '2014-01-15 00:07:31.000000', 'consum', 0.0220, 'lps'),
	(493386, 129, '2014-01-15 00:07:32.000000', 'consum', 0.0223, 'lps'),
	(493387, 129, '2014-01-15 00:07:33.000000', 'consum', 0.0220, 'lps'),
	(493388, 129, '2014-01-15 00:07:34.000000', 'consum', 0.0220, 'lps'),
	(493389, 129, '2014-01-15 00:07:35.000000', 'consum', 0.0215, 'lps'),
	(493390, 129, '2014-01-15 00:07:36.000000', 'consum', 0.0223, 'lps'),
	(493391, 129, '2014-01-15 00:07:37.000000', 'consum', 0.0216, 'lps'),
	(493392, 129, '2014-01-15 00:07:38.000000', 'consum', 0.0218, 'lps'),
	(493393, 129, '2014-01-15 00:07:39.000000', 'consum', 0.0216, 'lps'),
	(493394, 129, '2014-01-15 00:07:40.000000', 'consum', 0.0219, 'lps'),
	(493395, 129, '2014-01-15 00:07:41.000000', 'consum', 0.0221, 'lps'),
	(493396, 129, '2014-01-15 00:07:42.000000', 'consum', 0.0213, 'lps'),
	(493397, 129, '2014-01-15 00:07:43.000000', 'consum', 0.0220, 'lps'),
	(493398, 129, '2014-01-15 00:07:44.000000', 'consum', 0.0221, 'lps'),
	(493399, 129, '2014-01-15 00:07:45.000000', 'consum', 0.0223, 'lps'),
	(493400, 129, '2014-01-15 00:07:46.000000', 'consum', 0.0214, 'lps'),
	(493401, 129, '2014-01-15 00:07:47.000000', 'consum', 0.0222, 'lps'),
	(493402, 129, '2014-01-15 00:07:48.000000', 'consum', 0.0213, 'lps'),
	(493403, 129, '2014-01-15 00:07:49.000000', 'consum', 0.0221, 'lps'),
	(493404, 129, '2014-01-15 00:07:50.000000', 'consum', 0.0213, 'lps'),
	(493405, 129, '2014-01-15 00:07:51.000000', 'consum', 0.0221, 'lps'),
	(493406, 129, '2014-01-15 00:07:52.000000', 'consum', 0.0214, 'lps'),
	(493407, 129, '2014-01-15 00:07:53.000000', 'consum', 0.0210, 'lps'),
	(493408, 129, '2014-01-15 00:07:54.000000', 'consum', 0.0213, 'lps'),
	(493409, 129, '2014-01-15 00:07:55.000000', 'consum', 0.0210, 'lps'),
	(493410, 129, '2014-01-15 00:07:56.000000', 'consum', 0.0219, 'lps'),
	(493411, 129, '2014-01-15 00:07:57.000000', 'consum', 0.0212, 'lps'),
	(493412, 129, '2014-01-15 00:07:58.000000', 'consum', 0.0221, 'lps'),
	(493413, 129, '2014-01-15 00:07:59.000000', 'consum', 0.0219, 'lps'),
	(493414, 129, '2014-01-15 00:08:00.000000', 'consum', 0.0222, 'lps'),
	(493415, 129, '2014-01-15 00:08:01.000000', 'consum', 0.0213, 'lps'),
	(493416, 129, '2014-01-15 00:08:02.000000', 'consum', 0.0220, 'lps'),
	(493417, 129, '2014-01-15 00:08:03.000000', 'consum', 0.0223, 'lps'),
	(493418, 129, '2014-01-15 00:08:04.000000', 'consum', 0.0216, 'lps'),
	(493419, 129, '2014-01-15 00:08:05.000000', 'consum', 0.0215, 'lps'),
	(493420, 129, '2014-01-15 00:08:06.000000', 'consum', 0.0220, 'lps'),
	(493421, 129, '2014-01-15 00:08:07.000000', 'consum', 0.0216, 'lps'),
	(493422, 129, '2014-01-15 00:08:08.000000', 'consum', 0.0212, 'lps'),
	(493423, 129, '2014-01-15 00:08:09.000000', 'consum', 0.0216, 'lps'),
	(493424, 129, '2014-01-15 00:08:10.000000', 'consum', 0.0219, 'lps'),
	(493425, 129, '2014-01-15 00:08:11.000000', 'consum', 0.0211, 'lps'),
	(493426, 129, '2014-01-15 00:08:12.000000', 'consum', 0.0218, 'lps'),
	(493427, 129, '2014-01-15 00:08:13.000000', 'consum', 0.0216, 'lps'),
	(493428, 129, '2014-01-15 00:08:14.000000', 'consum', 0.0218, 'lps'),
	(493429, 129, '2014-01-15 00:08:15.000000', 'consum', 0.0219, 'lps'),
	(493430, 129, '2014-01-15 00:08:16.000000', 'consum', 0.0216, 'lps'),
	(493431, 129, '2014-01-15 00:08:17.000000', 'consum', 0.0216, 'lps'),
	(493432, 129, '2014-01-15 00:08:18.000000', 'consum', 0.0222, 'lps'),
	(493433, 129, '2014-01-15 00:08:19.000000', 'consum', 0.0223, 'lps'),
	(493434, 129, '2014-01-15 00:08:20.000000', 'consum', 0.0213, 'lps'),
	(493435, 129, '2014-01-15 00:08:21.000000', 'consum', 0.0213, 'lps'),
	(493436, 129, '2014-01-15 00:08:22.000000', 'consum', 0.0216, 'lps'),
	(493437, 129, '2014-01-15 00:08:23.000000', 'consum', 0.0220, 'lps'),
	(493438, 129, '2014-01-15 00:08:24.000000', 'consum', 0.0214, 'lps'),
	(493439, 129, '2014-01-15 00:08:25.000000', 'consum', 0.0216, 'lps'),
	(493440, 129, '2014-01-15 00:08:26.000000', 'consum', 0.0213, 'lps'),
	(493441, 129, '2014-01-15 00:08:27.000000', 'consum', 0.0220, 'lps'),
	(493442, 129, '2014-01-15 00:08:28.000000', 'consum', 0.0210, 'lps'),
	(493443, 129, '2014-01-15 00:08:29.000000', 'consum', 0.0221, 'lps'),
	(493444, 129, '2014-01-15 00:08:30.000000', 'consum', 0.0212, 'lps'),
	(493445, 129, '2014-01-15 00:08:31.000000', 'consum', 0.0214, 'lps'),
	(493446, 129, '2014-01-15 00:08:32.000000', 'consum', 0.0213, 'lps'),
	(493447, 129, '2014-01-15 00:08:33.000000', 'consum', 0.0212, 'lps'),
	(493448, 129, '2014-01-15 00:08:34.000000', 'consum', 0.0213, 'lps'),
	(493449, 129, '2014-01-15 00:08:35.000000', 'consum', 0.0217, 'lps'),
	(493450, 129, '2014-01-15 00:08:36.000000', 'consum', 0.0212, 'lps'),
	(493451, 129, '2014-01-15 00:08:37.000000', 'consum', 0.0210, 'lps'),
	(493452, 129, '2014-01-15 00:08:38.000000', 'consum', 0.0218, 'lps'),
	(493453, 129, '2014-01-15 00:08:39.000000', 'consum', 0.0212, 'lps'),
	(493454, 129, '2014-01-15 00:08:40.000000', 'consum', 0.0221, 'lps'),
	(493455, 129, '2014-01-15 00:08:41.000000', 'consum', 0.0221, 'lps'),
	(493456, 129, '2014-01-15 00:08:42.000000', 'consum', 0.0217, 'lps'),
	(493457, 129, '2014-01-15 00:08:43.000000', 'consum', 0.0211, 'lps'),
	(493458, 129, '2014-01-15 00:08:44.000000', 'consum', 0.0223, 'lps'),
	(493459, 129, '2014-01-15 00:08:45.000000', 'consum', 0.0218, 'lps'),
	(493460, 129, '2014-01-15 00:08:46.000000', 'consum', 0.0223, 'lps'),
	(493461, 129, '2014-01-15 00:08:47.000000', 'consum', 0.0211, 'lps'),
	(493462, 129, '2014-01-15 00:08:48.000000', 'consum', 0.0217, 'lps'),
	(493463, 129, '2014-01-15 00:08:49.000000', 'consum', 0.0215, 'lps'),
	(493464, 129, '2014-01-15 00:08:50.000000', 'consum', 0.0214, 'lps'),
	(493465, 129, '2014-01-15 00:08:51.000000', 'consum', 0.0216, 'lps'),
	(493466, 129, '2014-01-15 00:08:52.000000', 'consum', 0.0212, 'lps'),
	(493467, 129, '2014-01-15 00:08:53.000000', 'consum', 0.0220, 'lps'),
	(493468, 129, '2014-01-15 00:08:54.000000', 'consum', 0.0211, 'lps'),
	(493469, 129, '2014-01-15 00:08:55.000000', 'consum', 0.0214, 'lps'),
	(493470, 129, '2014-01-15 00:08:56.000000', 'consum', 0.0214, 'lps'),
	(493471, 129, '2014-01-15 00:08:57.000000', 'consum', 0.0219, 'lps'),
	(493472, 129, '2014-01-15 00:08:58.000000', 'consum', 0.0214, 'lps'),
	(493473, 129, '2014-01-15 00:08:59.000000', 'consum', 0.0220, 'lps'),
	(493474, 129, '2014-01-15 00:09:00.000000', 'consum', 0.0218, 'lps'),
	(493475, 129, '2014-01-15 00:09:01.000000', 'consum', 0.0219, 'lps'),
	(493476, 129, '2014-01-15 00:09:02.000000', 'consum', 0.0220, 'lps'),
	(493477, 129, '2014-01-15 00:09:03.000000', 'consum', 0.0220, 'lps'),
	(493478, 129, '2014-01-15 00:09:04.000000', 'consum', 0.0217, 'lps'),
	(493479, 129, '2014-01-15 00:09:05.000000', 'consum', 0.0217, 'lps'),
	(493480, 129, '2014-01-15 00:09:06.000000', 'consum', 0.0222, 'lps'),
	(493481, 129, '2014-01-15 00:09:07.000000', 'consum', 0.0220, 'lps'),
	(493482, 129, '2014-01-15 00:09:08.000000', 'consum', 0.0212, 'lps'),
	(493483, 129, '2014-01-15 00:09:09.000000', 'consum', 0.0219, 'lps'),
	(493484, 129, '2014-01-15 00:09:10.000000', 'consum', 0.0223, 'lps'),
	(493485, 129, '2014-01-15 00:09:11.000000', 'consum', 0.0219, 'lps'),
	(493486, 129, '2014-01-15 00:09:12.000000', 'consum', 0.0215, 'lps'),
	(493487, 129, '2014-01-15 00:09:13.000000', 'consum', 0.0211, 'lps'),
	(493488, 129, '2014-01-15 00:09:14.000000', 'consum', 0.0215, 'lps'),
	(493489, 129, '2014-01-15 00:09:15.000000', 'consum', 0.0216, 'lps'),
	(493490, 129, '2014-01-15 00:09:16.000000', 'consum', 0.0211, 'lps'),
	(493491, 129, '2014-01-15 00:09:17.000000', 'consum', 0.0213, 'lps'),
	(493492, 129, '2014-01-15 00:09:18.000000', 'consum', 0.0223, 'lps'),
	(493493, 129, '2014-01-15 00:09:19.000000', 'consum', 0.0211, 'lps'),
	(493494, 129, '2014-01-15 00:09:20.000000', 'consum', 0.0219, 'lps'),
	(493495, 129, '2014-01-15 00:09:21.000000', 'consum', 0.0222, 'lps'),
	(493496, 129, '2014-01-15 00:09:22.000000', 'consum', 0.0218, 'lps'),
	(493497, 129, '2014-01-15 00:09:23.000000', 'consum', 0.0213, 'lps'),
	(493498, 129, '2014-01-15 00:09:24.000000', 'consum', 0.0215, 'lps'),
	(493499, 129, '2014-01-15 00:09:25.000000', 'consum', 0.0213, 'lps'),
	(493500, 129, '2014-01-15 00:09:26.000000', 'consum', 0.0212, 'lps'),
	(493501, 129, '2014-01-15 00:09:27.000000', 'consum', 0.0212, 'lps'),
	(493502, 129, '2014-01-15 00:09:28.000000', 'consum', 0.0214, 'lps'),
	(493503, 129, '2014-01-15 00:09:29.000000', 'consum', 0.0211, 'lps'),
	(493504, 129, '2014-01-15 00:09:30.000000', 'consum', 0.0216, 'lps'),
	(493505, 129, '2014-01-15 00:09:31.000000', 'consum', 0.0211, 'lps'),
	(493506, 129, '2014-01-15 00:09:32.000000', 'consum', 0.0211, 'lps'),
	(493507, 129, '2014-01-15 00:09:33.000000', 'consum', 0.0214, 'lps'),
	(493508, 129, '2014-01-15 00:09:34.000000', 'consum', 0.0213, 'lps'),
	(493509, 129, '2014-01-15 00:09:35.000000', 'consum', 0.0212, 'lps'),
	(493510, 129, '2014-01-15 00:09:36.000000', 'consum', 0.0212, 'lps'),
	(493511, 129, '2014-01-15 00:09:37.000000', 'consum', 0.0213, 'lps'),
	(493512, 129, '2014-01-15 00:09:38.000000', 'consum', 0.0221, 'lps'),
	(493513, 129, '2014-01-15 00:09:39.000000', 'consum', 0.0216, 'lps'),
	(493514, 129, '2014-01-15 00:09:40.000000', 'consum', 0.0219, 'lps'),
	(493515, 129, '2014-01-15 00:09:41.000000', 'consum', 0.0211, 'lps'),
	(493516, 129, '2014-01-15 00:09:42.000000', 'consum', 0.0215, 'lps'),
	(493517, 129, '2014-01-15 00:09:43.000000', 'consum', 0.0221, 'lps'),
	(493518, 129, '2014-01-15 00:09:44.000000', 'consum', 0.0220, 'lps'),
	(493519, 129, '2014-01-15 00:09:45.000000', 'consum', 0.0213, 'lps'),
	(493520, 129, '2014-01-15 00:09:46.000000', 'consum', 0.0223, 'lps'),
	(493521, 129, '2014-01-15 00:09:47.000000', 'consum', 0.0213, 'lps'),
	(493522, 129, '2014-01-15 00:09:48.000000', 'consum', 0.0211, 'lps'),
	(493523, 129, '2014-01-15 00:09:49.000000', 'consum', 0.0210, 'lps'),
	(493524, 129, '2014-01-15 00:09:50.000000', 'consum', 0.0219, 'lps'),
	(493525, 129, '2014-01-15 00:09:51.000000', 'consum', 0.0216, 'lps'),
	(493526, 129, '2014-01-15 00:09:52.000000', 'consum', 0.0211, 'lps'),
	(493527, 129, '2014-01-15 00:09:53.000000', 'consum', 0.0213, 'lps'),
	(493528, 129, '2014-01-15 00:09:54.000000', 'consum', 0.0222, 'lps'),
	(493529, 129, '2014-01-15 00:09:55.000000', 'consum', 0.0219, 'lps'),
	(493530, 129, '2014-01-15 00:09:56.000000', 'consum', 0.0220, 'lps'),
	(493531, 129, '2014-01-15 00:09:57.000000', 'consum', 0.0221, 'lps'),
	(493532, 129, '2014-01-15 00:09:58.000000', 'consum', 0.0221, 'lps'),
	(493533, 129, '2014-01-15 00:09:59.000000', 'consum', 0.0218, 'lps'),
	(493534, 129, '2014-01-15 00:10:00.000000', 'consum', 0.0217, 'lps'),
	(493535, 129, '2014-01-15 00:10:01.000000', 'consum', 0.0220, 'lps'),
	(493536, 129, '2014-01-15 00:10:02.000000', 'consum', 0.0214, 'lps'),
	(493537, 129, '2014-01-15 00:10:03.000000', 'consum', 0.0215, 'lps'),
	(493538, 129, '2014-01-15 00:10:04.000000', 'consum', 0.0210, 'lps'),
	(493539, 129, '2014-01-15 00:10:05.000000', 'consum', 0.0222, 'lps'),
	(493540, 129, '2014-01-15 00:10:06.000000', 'consum', 0.0215, 'lps'),
	(493541, 129, '2014-01-15 00:10:07.000000', 'consum', 0.0214, 'lps'),
	(493542, 129, '2014-01-15 00:10:08.000000', 'consum', 0.0213, 'lps'),
	(493543, 129, '2014-01-15 00:10:09.000000', 'consum', 0.0216, 'lps'),
	(493544, 129, '2014-01-15 00:10:10.000000', 'consum', 0.0217, 'lps'),
	(493545, 129, '2014-01-15 00:10:11.000000', 'consum', 0.0213, 'lps'),
	(493546, 129, '2014-01-15 00:10:12.000000', 'consum', 0.0217, 'lps'),
	(493547, 129, '2014-01-15 00:10:13.000000', 'consum', 0.0211, 'lps'),
	(493548, 129, '2014-01-15 00:10:14.000000', 'consum', 0.0220, 'lps'),
	(493549, 129, '2014-01-15 00:10:15.000000', 'consum', 0.0219, 'lps'),
	(493550, 129, '2014-01-15 00:10:16.000000', 'consum', 0.0223, 'lps'),
	(493551, 129, '2014-01-15 00:10:17.000000', 'consum', 0.0220, 'lps'),
	(493552, 129, '2014-01-15 00:10:18.000000', 'consum', 0.0223, 'lps'),
	(493553, 129, '2014-01-15 00:10:19.000000', 'consum', 0.0218, 'lps'),
	(493554, 129, '2014-01-15 00:10:20.000000', 'consum', 0.0223, 'lps'),
	(493555, 129, '2014-01-15 00:10:21.000000', 'consum', 0.0212, 'lps'),
	(493556, 129, '2014-01-15 00:10:22.000000', 'consum', 0.0211, 'lps'),
	(493557, 129, '2014-01-15 00:10:23.000000', 'consum', 0.0221, 'lps'),
	(493558, 129, '2014-01-15 00:10:24.000000', 'consum', 0.0220, 'lps'),
	(493559, 129, '2014-01-15 00:10:25.000000', 'consum', 0.0212, 'lps'),
	(493560, 129, '2014-01-15 00:10:26.000000', 'consum', 0.0222, 'lps'),
	(493561, 129, '2014-01-15 00:10:27.000000', 'consum', 0.0219, 'lps'),
	(493562, 129, '2014-01-15 00:10:28.000000', 'consum', 0.0223, 'lps'),
	(493563, 129, '2014-01-15 00:10:29.000000', 'consum', 0.0218, 'lps'),
	(493564, 129, '2014-01-15 00:10:30.000000', 'consum', 0.0210, 'lps'),
	(493565, 129, '2014-01-15 00:10:31.000000', 'consum', 0.0218, 'lps'),
	(493566, 129, '2014-01-15 00:10:32.000000', 'consum', 0.0222, 'lps'),
	(493567, 129, '2014-01-15 00:10:33.000000', 'consum', 0.0219, 'lps'),
	(493568, 129, '2014-01-15 00:10:34.000000', 'consum', 0.0217, 'lps'),
	(493569, 129, '2014-01-15 00:10:35.000000', 'consum', 0.0219, 'lps'),
	(493570, 129, '2014-01-15 00:10:36.000000', 'consum', 0.0223, 'lps'),
	(493571, 129, '2014-01-15 00:10:37.000000', 'consum', 0.0220, 'lps'),
	(493572, 129, '2014-01-15 00:10:38.000000', 'consum', 0.0220, 'lps'),
	(493573, 129, '2014-01-15 00:10:39.000000', 'consum', 0.0215, 'lps'),
	(493574, 129, '2014-01-15 00:10:40.000000', 'consum', 0.0223, 'lps'),
	(493575, 129, '2014-01-15 00:10:41.000000', 'consum', 0.0215, 'lps'),
	(493576, 129, '2014-01-15 00:10:42.000000', 'consum', 0.0214, 'lps'),
	(493577, 129, '2014-01-15 00:10:43.000000', 'consum', 0.0213, 'lps'),
	(493578, 129, '2014-01-15 00:10:44.000000', 'consum', 0.0216, 'lps'),
	(493579, 129, '2014-01-15 00:10:45.000000', 'consum', 0.0216, 'lps'),
	(493580, 129, '2014-01-15 00:10:46.000000', 'consum', 0.0223, 'lps'),
	(493581, 129, '2014-01-15 00:10:47.000000', 'consum', 0.0217, 'lps'),
	(493582, 129, '2014-01-15 00:10:48.000000', 'consum', 0.0219, 'lps'),
	(493583, 129, '2014-01-15 00:10:49.000000', 'consum', 0.0223, 'lps'),
	(493584, 129, '2014-01-15 00:10:50.000000', 'consum', 0.0218, 'lps'),
	(493585, 129, '2014-01-15 00:10:51.000000', 'consum', 0.0211, 'lps'),
	(493586, 129, '2014-01-15 00:10:52.000000', 'consum', 0.0222, 'lps'),
	(493587, 129, '2014-01-15 00:10:53.000000', 'consum', 0.0210, 'lps'),
	(493588, 129, '2014-01-15 00:10:54.000000', 'consum', 0.0217, 'lps'),
	(493589, 129, '2014-01-15 00:10:55.000000', 'consum', 0.0216, 'lps'),
	(493590, 129, '2014-01-15 00:10:56.000000', 'consum', 0.0222, 'lps'),
	(493591, 129, '2014-01-15 00:10:57.000000', 'consum', 0.0222, 'lps'),
	(493592, 129, '2014-01-15 00:10:58.000000', 'consum', 0.0219, 'lps'),
	(493593, 129, '2014-01-15 00:10:59.000000', 'consum', 0.0223, 'lps'),
	(493594, 129, '2014-01-15 00:11:00.000000', 'consum', 0.0219, 'lps'),
	(493595, 129, '2014-01-15 00:11:01.000000', 'consum', 0.0217, 'lps'),
	(493596, 129, '2014-01-15 00:11:02.000000', 'consum', 0.0218, 'lps'),
	(493597, 129, '2014-01-15 00:11:03.000000', 'consum', 0.0214, 'lps'),
	(493598, 129, '2014-01-15 00:11:04.000000', 'consum', 0.0221, 'lps'),
	(493599, 129, '2014-01-15 00:11:05.000000', 'consum', 0.0212, 'lps'),
	(493600, 129, '2014-01-15 00:11:06.000000', 'consum', 0.0215, 'lps'),
	(493601, 129, '2014-01-15 00:11:07.000000', 'consum', 0.0216, 'lps'),
	(493602, 129, '2014-01-15 00:11:08.000000', 'consum', 0.0212, 'lps'),
	(493603, 129, '2014-01-15 00:11:09.000000', 'consum', 0.0216, 'lps'),
	(493604, 129, '2014-01-15 00:11:10.000000', 'consum', 0.0221, 'lps'),
	(493605, 129, '2014-01-15 00:11:11.000000', 'consum', 0.0217, 'lps'),
	(493606, 129, '2014-01-15 00:11:12.000000', 'consum', 0.0215, 'lps'),
	(493607, 129, '2014-01-15 00:11:13.000000', 'consum', 0.0212, 'lps'),
	(493608, 129, '2014-01-15 00:11:14.000000', 'consum', 0.0221, 'lps'),
	(493609, 129, '2014-01-15 00:11:15.000000', 'consum', 0.0217, 'lps'),
	(493610, 129, '2014-01-15 00:11:16.000000', 'consum', 0.0215, 'lps'),
	(493611, 129, '2014-01-15 00:11:17.000000', 'consum', 0.0211, 'lps'),
	(493612, 129, '2014-01-15 00:11:18.000000', 'consum', 0.0217, 'lps'),
	(493613, 129, '2014-01-15 00:11:19.000000', 'consum', 0.0214, 'lps'),
	(493614, 129, '2014-01-15 00:11:20.000000', 'consum', 0.0211, 'lps'),
	(493615, 129, '2014-01-15 00:11:21.000000', 'consum', 0.0216, 'lps'),
	(493616, 129, '2014-01-15 00:11:22.000000', 'consum', 0.0210, 'lps'),
	(493617, 129, '2014-01-15 00:11:23.000000', 'consum', 0.0219, 'lps'),
	(493618, 129, '2014-01-15 00:11:24.000000', 'consum', 0.0215, 'lps'),
	(493619, 129, '2014-01-15 00:11:25.000000', 'consum', 0.0222, 'lps'),
	(493620, 129, '2014-01-15 00:11:26.000000', 'consum', 0.0215, 'lps'),
	(493621, 129, '2014-01-15 00:11:27.000000', 'consum', 0.0212, 'lps'),
	(493622, 129, '2014-01-15 00:11:28.000000', 'consum', 0.0221, 'lps'),
	(493623, 129, '2014-01-15 00:11:29.000000', 'consum', 0.0216, 'lps'),
	(493624, 129, '2014-01-15 00:11:30.000000', 'consum', 0.0221, 'lps'),
	(493625, 129, '2014-01-15 00:11:31.000000', 'consum', 0.0221, 'lps'),
	(493626, 129, '2014-01-15 00:11:32.000000', 'consum', 0.0216, 'lps'),
	(493627, 129, '2014-01-15 00:11:33.000000', 'consum', 0.0223, 'lps'),
	(493628, 129, '2014-01-15 00:11:34.000000', 'consum', 0.0216, 'lps'),
	(493629, 129, '2014-01-15 00:11:35.000000', 'consum', 0.0214, 'lps'),
	(493630, 129, '2014-01-15 00:11:36.000000', 'consum', 0.0214, 'lps'),
	(493631, 129, '2014-01-15 00:11:37.000000', 'consum', 0.0219, 'lps'),
	(493632, 129, '2014-01-15 00:11:38.000000', 'consum', 0.0213, 'lps'),
	(493633, 129, '2014-01-15 00:11:39.000000', 'consum', 0.0214, 'lps'),
	(493634, 129, '2014-01-15 00:11:40.000000', 'consum', 0.0222, 'lps'),
	(493635, 129, '2014-01-15 00:11:41.000000', 'consum', 0.0215, 'lps'),
	(493636, 129, '2014-01-15 00:11:42.000000', 'consum', 0.0215, 'lps'),
	(493637, 129, '2014-01-15 00:11:43.000000', 'consum', 0.0220, 'lps'),
	(493638, 129, '2014-01-15 00:11:44.000000', 'consum', 0.0216, 'lps'),
	(493639, 129, '2014-01-15 00:11:45.000000', 'consum', 0.0211, 'lps'),
	(493640, 129, '2014-01-15 00:11:46.000000', 'consum', 0.0212, 'lps'),
	(493641, 129, '2014-01-15 00:11:47.000000', 'consum', 0.0219, 'lps'),
	(493642, 129, '2014-01-15 00:11:48.000000', 'consum', 0.0222, 'lps'),
	(493643, 129, '2014-01-15 00:11:49.000000', 'consum', 0.0214, 'lps'),
	(493644, 129, '2014-01-15 00:11:50.000000', 'consum', 0.0211, 'lps'),
	(493645, 129, '2014-01-15 00:11:51.000000', 'consum', 0.0215, 'lps'),
	(493646, 129, '2014-01-15 00:11:52.000000', 'consum', 0.0221, 'lps'),
	(493647, 129, '2014-01-15 00:11:53.000000', 'consum', 0.0221, 'lps'),
	(493648, 129, '2014-01-15 00:11:54.000000', 'consum', 0.0218, 'lps'),
	(493649, 129, '2014-01-15 00:11:55.000000', 'consum', 0.0218, 'lps'),
	(493650, 129, '2014-01-15 00:11:56.000000', 'consum', 0.0212, 'lps'),
	(493651, 129, '2014-01-15 00:11:57.000000', 'consum', 0.0212, 'lps'),
	(493652, 129, '2014-01-15 00:11:58.000000', 'consum', 0.0215, 'lps'),
	(493653, 129, '2014-01-15 00:11:59.000000', 'consum', 0.0215, 'lps'),
	(493654, 129, '2014-01-15 00:12:00.000000', 'consum', 0.0218, 'lps'),
	(493655, 129, '2014-01-15 00:12:01.000000', 'consum', 0.0210, 'lps'),
	(493656, 129, '2014-01-15 00:12:02.000000', 'consum', 0.0213, 'lps'),
	(493657, 129, '2014-01-15 00:12:03.000000', 'consum', 0.0211, 'lps'),
	(493658, 129, '2014-01-15 00:12:04.000000', 'consum', 0.0222, 'lps'),
	(493659, 129, '2014-01-15 00:12:05.000000', 'consum', 0.0210, 'lps'),
	(493660, 129, '2014-01-15 00:12:06.000000', 'consum', 0.0218, 'lps'),
	(493661, 129, '2014-01-15 00:12:07.000000', 'consum', 0.0223, 'lps'),
	(493662, 129, '2014-01-15 00:12:08.000000', 'consum', 0.0222, 'lps'),
	(493663, 129, '2014-01-15 00:12:09.000000', 'consum', 0.0216, 'lps'),
	(493664, 129, '2014-01-15 00:12:10.000000', 'consum', 0.0220, 'lps'),
	(493665, 129, '2014-01-15 00:12:11.000000', 'consum', 0.0216, 'lps'),
	(493666, 129, '2014-01-15 00:12:12.000000', 'consum', 0.0221, 'lps'),
	(493667, 129, '2014-01-15 00:12:13.000000', 'consum', 0.0223, 'lps'),
	(493668, 129, '2014-01-15 00:12:14.000000', 'consum', 0.0213, 'lps'),
	(493669, 129, '2014-01-15 00:12:15.000000', 'consum', 0.0215, 'lps'),
	(493670, 129, '2014-01-15 00:12:16.000000', 'consum', 0.0211, 'lps'),
	(493671, 129, '2014-01-15 00:12:17.000000', 'consum', 0.0216, 'lps'),
	(493672, 129, '2014-01-15 00:12:18.000000', 'consum', 0.0222, 'lps'),
	(493673, 129, '2014-01-15 00:12:19.000000', 'consum', 0.0211, 'lps'),
	(493674, 129, '2014-01-15 00:12:20.000000', 'consum', 0.0223, 'lps'),
	(493675, 129, '2014-01-15 00:12:21.000000', 'consum', 0.0217, 'lps'),
	(493676, 129, '2014-01-15 00:12:22.000000', 'consum', 0.0219, 'lps'),
	(493677, 129, '2014-01-15 00:12:23.000000', 'consum', 0.0221, 'lps'),
	(493678, 129, '2014-01-15 00:12:24.000000', 'consum', 0.0212, 'lps'),
	(493679, 129, '2014-01-15 00:12:25.000000', 'consum', 0.0216, 'lps'),
	(493680, 129, '2014-01-15 00:12:26.000000', 'consum', 0.0218, 'lps'),
	(493681, 129, '2014-01-15 00:12:27.000000', 'consum', 0.0218, 'lps'),
	(493682, 129, '2014-01-15 00:12:28.000000', 'consum', 0.0214, 'lps'),
	(493683, 129, '2014-01-15 00:12:29.000000', 'consum', 0.0222, 'lps'),
	(493684, 129, '2014-01-15 00:12:30.000000', 'consum', 0.0216, 'lps'),
	(493685, 129, '2014-01-15 00:12:31.000000', 'consum', 0.0217, 'lps'),
	(493686, 129, '2014-01-15 00:12:32.000000', 'consum', 0.0212, 'lps'),
	(493687, 129, '2014-01-15 00:12:33.000000', 'consum', 0.0216, 'lps'),
	(493688, 129, '2014-01-15 00:12:34.000000', 'consum', 0.0218, 'lps'),
	(493689, 129, '2014-01-15 00:12:35.000000', 'consum', 0.0220, 'lps'),
	(493690, 129, '2014-01-15 00:12:36.000000', 'consum', 0.0221, 'lps'),
	(493691, 129, '2014-01-15 00:12:37.000000', 'consum', 0.0222, 'lps'),
	(493692, 129, '2014-01-15 00:12:38.000000', 'consum', 0.0223, 'lps'),
	(493693, 129, '2014-01-15 00:12:39.000000', 'consum', 0.0210, 'lps'),
	(493694, 129, '2014-01-15 00:12:40.000000', 'consum', 0.0215, 'lps'),
	(493695, 129, '2014-01-15 00:12:41.000000', 'consum', 0.0222, 'lps'),
	(493696, 129, '2014-01-15 00:12:42.000000', 'consum', 0.0213, 'lps'),
	(493697, 129, '2014-01-15 00:12:43.000000', 'consum', 0.0218, 'lps'),
	(493698, 129, '2014-01-15 00:12:44.000000', 'consum', 0.0215, 'lps'),
	(493699, 129, '2014-01-15 00:12:45.000000', 'consum', 0.0212, 'lps'),
	(493700, 129, '2014-01-15 00:12:46.000000', 'consum', 0.0217, 'lps'),
	(493701, 129, '2014-01-15 00:12:47.000000', 'consum', 0.0212, 'lps'),
	(493702, 129, '2014-01-15 00:12:48.000000', 'consum', 0.0213, 'lps'),
	(493703, 129, '2014-01-15 00:12:49.000000', 'consum', 0.0220, 'lps'),
	(493704, 129, '2014-01-15 00:12:50.000000', 'consum', 0.0211, 'lps'),
	(493705, 129, '2014-01-15 00:12:51.000000', 'consum', 0.0212, 'lps'),
	(493706, 129, '2014-01-15 00:12:52.000000', 'consum', 0.0217, 'lps'),
	(493707, 129, '2014-01-15 00:12:53.000000', 'consum', 0.0211, 'lps'),
	(493708, 129, '2014-01-15 00:12:54.000000', 'consum', 0.0210, 'lps'),
	(493709, 129, '2014-01-15 00:12:55.000000', 'consum', 0.0222, 'lps'),
	(493710, 129, '2014-01-15 00:12:56.000000', 'consum', 0.0214, 'lps'),
	(493711, 129, '2014-01-15 00:12:57.000000', 'consum', 0.0222, 'lps'),
	(493712, 129, '2014-01-15 00:12:58.000000', 'consum', 0.0218, 'lps'),
	(493713, 129, '2014-01-15 00:12:59.000000', 'consum', 0.0215, 'lps'),
	(493714, 129, '2014-01-15 00:13:00.000000', 'consum', 0.0211, 'lps'),
	(493715, 129, '2014-01-15 00:13:01.000000', 'consum', 0.0215, 'lps'),
	(493716, 129, '2014-01-15 00:13:02.000000', 'consum', 0.0218, 'lps'),
	(493717, 129, '2014-01-15 00:13:03.000000', 'consum', 0.0220, 'lps'),
	(493718, 129, '2014-01-15 00:13:04.000000', 'consum', 0.0210, 'lps'),
	(493719, 129, '2014-01-15 00:13:05.000000', 'consum', 0.0221, 'lps'),
	(493720, 129, '2014-01-15 00:13:06.000000', 'consum', 0.0222, 'lps'),
	(493721, 129, '2014-01-15 00:13:07.000000', 'consum', 0.0212, 'lps'),
	(493722, 129, '2014-01-15 00:13:08.000000', 'consum', 0.0213, 'lps'),
	(493723, 129, '2014-01-15 00:13:09.000000', 'consum', 0.0219, 'lps'),
	(493724, 129, '2014-01-15 00:13:10.000000', 'consum', 0.0219, 'lps'),
	(493725, 129, '2014-01-15 00:13:11.000000', 'consum', 0.0214, 'lps'),
	(493726, 129, '2014-01-15 00:13:12.000000', 'consum', 0.0218, 'lps'),
	(493727, 129, '2014-01-15 00:13:13.000000', 'consum', 0.0210, 'lps'),
	(493728, 129, '2014-01-15 00:13:14.000000', 'consum', 0.0215, 'lps'),
	(493729, 129, '2014-01-15 00:13:15.000000', 'consum', 0.0221, 'lps'),
	(493730, 129, '2014-01-15 00:13:16.000000', 'consum', 0.0223, 'lps'),
	(493731, 129, '2014-01-15 00:13:17.000000', 'consum', 0.0212, 'lps'),
	(493732, 129, '2014-01-15 00:13:18.000000', 'consum', 0.0212, 'lps'),
	(493733, 129, '2014-01-15 00:13:19.000000', 'consum', 0.0214, 'lps'),
	(493734, 129, '2014-01-15 00:13:20.000000', 'consum', 0.0210, 'lps'),
	(493735, 129, '2014-01-15 00:13:21.000000', 'consum', 0.0213, 'lps'),
	(493736, 129, '2014-01-15 00:13:22.000000', 'consum', 0.0211, 'lps'),
	(493737, 129, '2014-01-15 00:13:23.000000', 'consum', 0.0220, 'lps'),
	(493738, 129, '2014-01-15 00:13:24.000000', 'consum', 0.0217, 'lps'),
	(493739, 129, '2014-01-15 00:13:25.000000', 'consum', 0.0216, 'lps'),
	(493740, 129, '2014-01-15 00:13:26.000000', 'consum', 0.0219, 'lps'),
	(493741, 129, '2014-01-15 00:13:27.000000', 'consum', 0.0222, 'lps'),
	(493742, 129, '2014-01-15 00:13:28.000000', 'consum', 0.0217, 'lps'),
	(493743, 129, '2014-01-15 00:13:29.000000', 'consum', 0.0223, 'lps'),
	(493744, 129, '2014-01-15 00:13:30.000000', 'consum', 0.0213, 'lps'),
	(493745, 129, '2014-01-15 00:13:31.000000', 'consum', 0.0214, 'lps'),
	(493746, 129, '2014-01-15 00:13:32.000000', 'consum', 0.0223, 'lps'),
	(493747, 129, '2014-01-15 00:13:33.000000', 'consum', 0.0219, 'lps'),
	(493748, 129, '2014-01-15 00:13:34.000000', 'consum', 0.0216, 'lps'),
	(493749, 129, '2014-01-15 00:13:35.000000', 'consum', 0.0215, 'lps'),
	(493750, 129, '2014-01-15 00:13:36.000000', 'consum', 0.0218, 'lps'),
	(493751, 129, '2014-01-15 00:13:37.000000', 'consum', 0.0222, 'lps'),
	(493752, 129, '2014-01-15 00:13:38.000000', 'consum', 0.0218, 'lps'),
	(493753, 129, '2014-01-15 00:13:39.000000', 'consum', 0.0215, 'lps'),
	(493754, 129, '2014-01-15 00:13:40.000000', 'consum', 0.0223, 'lps'),
	(493755, 129, '2014-01-15 00:13:41.000000', 'consum', 0.0222, 'lps'),
	(493756, 129, '2014-01-15 00:13:42.000000', 'consum', 0.0216, 'lps'),
	(493757, 129, '2014-01-15 00:13:43.000000', 'consum', 0.0217, 'lps'),
	(493758, 129, '2014-01-15 00:13:44.000000', 'consum', 0.0214, 'lps'),
	(493759, 129, '2014-01-15 00:13:45.000000', 'consum', 0.0210, 'lps'),
	(493760, 129, '2014-01-15 00:13:46.000000', 'consum', 0.0213, 'lps'),
	(493761, 129, '2014-01-15 00:13:47.000000', 'consum', 0.0211, 'lps'),
	(493762, 129, '2014-01-15 00:13:48.000000', 'consum', 0.0221, 'lps'),
	(493763, 129, '2014-01-15 00:13:49.000000', 'consum', 0.0222, 'lps'),
	(493764, 129, '2014-01-15 00:13:50.000000', 'consum', 0.0220, 'lps'),
	(493765, 129, '2014-01-15 00:13:51.000000', 'consum', 0.0213, 'lps'),
	(493766, 129, '2014-01-15 00:13:52.000000', 'consum', 0.0210, 'lps'),
	(493767, 129, '2014-01-15 00:13:53.000000', 'consum', 0.0213, 'lps'),
	(493768, 129, '2014-01-15 00:13:54.000000', 'consum', 0.0211, 'lps'),
	(493769, 129, '2014-01-15 00:13:55.000000', 'consum', 0.0222, 'lps'),
	(493770, 129, '2014-01-15 00:13:56.000000', 'consum', 0.0213, 'lps'),
	(493771, 129, '2014-01-15 00:13:57.000000', 'consum', 0.0217, 'lps'),
	(493772, 129, '2014-01-15 00:13:58.000000', 'consum', 0.0223, 'lps'),
	(493773, 129, '2014-01-15 00:13:59.000000', 'consum', 0.0211, 'lps'),
	(493774, 129, '2014-01-15 00:14:00.000000', 'consum', 0.0218, 'lps'),
	(493775, 129, '2014-01-15 00:14:01.000000', 'consum', 0.0222, 'lps'),
	(493776, 129, '2014-01-15 00:14:02.000000', 'consum', 0.0218, 'lps'),
	(493777, 129, '2014-01-15 00:14:03.000000', 'consum', 0.0214, 'lps'),
	(493778, 129, '2014-01-15 00:14:04.000000', 'consum', 0.0220, 'lps'),
	(493779, 129, '2014-01-15 00:14:05.000000', 'consum', 0.0222, 'lps'),
	(493780, 129, '2014-01-15 00:14:06.000000', 'consum', 0.0212, 'lps'),
	(493781, 129, '2014-01-15 00:14:07.000000', 'consum', 0.0214, 'lps'),
	(493782, 129, '2014-01-15 00:14:08.000000', 'consum', 0.0211, 'lps'),
	(493783, 129, '2014-01-15 00:14:09.000000', 'consum', 0.0214, 'lps'),
	(493784, 129, '2014-01-15 00:14:10.000000', 'consum', 0.0217, 'lps'),
	(493785, 129, '2014-01-15 00:14:11.000000', 'consum', 0.0217, 'lps'),
	(493786, 129, '2014-01-15 00:14:12.000000', 'consum', 0.0210, 'lps'),
	(493787, 129, '2014-01-15 00:14:13.000000', 'consum', 0.0219, 'lps'),
	(493788, 129, '2014-01-15 00:14:14.000000', 'consum', 0.0212, 'lps'),
	(493789, 129, '2014-01-15 00:14:15.000000', 'consum', 0.0222, 'lps'),
	(493790, 129, '2014-01-15 00:14:16.000000', 'consum', 0.0223, 'lps'),
	(493791, 129, '2014-01-15 00:14:17.000000', 'consum', 0.0213, 'lps'),
	(493792, 129, '2014-01-15 00:14:18.000000', 'consum', 0.0212, 'lps'),
	(493793, 129, '2014-01-15 00:14:19.000000', 'consum', 0.0212, 'lps'),
	(493794, 129, '2014-01-15 00:14:20.000000', 'consum', 0.0214, 'lps'),
	(493795, 129, '2014-01-15 00:14:21.000000', 'consum', 0.0211, 'lps'),
	(493796, 129, '2014-01-15 00:14:22.000000', 'consum', 0.0216, 'lps'),
	(493797, 129, '2014-01-15 00:14:23.000000', 'consum', 0.0223, 'lps'),
	(493798, 129, '2014-01-15 00:14:24.000000', 'consum', 0.0215, 'lps'),
	(493799, 129, '2014-01-15 00:14:25.000000', 'consum', 0.0212, 'lps'),
	(493800, 129, '2014-01-15 00:14:26.000000', 'consum', 0.0220, 'lps'),
	(493801, 129, '2014-01-15 00:14:27.000000', 'consum', 0.0211, 'lps'),
	(493802, 129, '2014-01-15 00:14:28.000000', 'consum', 0.0213, 'lps'),
	(493803, 129, '2014-01-15 00:14:29.000000', 'consum', 0.0211, 'lps'),
	(493804, 129, '2014-01-15 00:14:30.000000', 'consum', 0.0217, 'lps'),
	(493805, 129, '2014-01-15 00:14:31.000000', 'consum', 0.0218, 'lps'),
	(493806, 129, '2014-01-15 00:14:32.000000', 'consum', 0.0215, 'lps'),
	(493807, 129, '2014-01-15 00:14:33.000000', 'consum', 0.0212, 'lps'),
	(493808, 129, '2014-01-15 00:14:34.000000', 'consum', 0.0219, 'lps'),
	(493809, 129, '2014-01-15 00:14:35.000000', 'consum', 0.0221, 'lps'),
	(493810, 129, '2014-01-15 00:14:36.000000', 'consum', 0.0223, 'lps'),
	(493811, 129, '2014-01-15 00:14:37.000000', 'consum', 0.0214, 'lps'),
	(493812, 129, '2014-01-15 00:14:38.000000', 'consum', 0.0223, 'lps'),
	(493813, 129, '2014-01-15 00:14:39.000000', 'consum', 0.0219, 'lps'),
	(493814, 129, '2014-01-15 00:14:40.000000', 'consum', 0.0217, 'lps'),
	(493815, 129, '2014-01-15 00:14:41.000000', 'consum', 0.0217, 'lps'),
	(493816, 129, '2014-01-15 00:14:42.000000', 'consum', 0.0211, 'lps'),
	(493817, 129, '2014-01-15 00:14:43.000000', 'consum', 0.0222, 'lps'),
	(493818, 129, '2014-01-15 00:14:44.000000', 'consum', 0.0212, 'lps'),
	(493819, 129, '2014-01-15 00:14:45.000000', 'consum', 0.0214, 'lps'),
	(493820, 129, '2014-01-15 00:14:46.000000', 'consum', 0.0212, 'lps'),
	(493821, 129, '2014-01-15 00:14:47.000000', 'consum', 0.0219, 'lps'),
	(493822, 129, '2014-01-15 00:14:48.000000', 'consum', 0.0210, 'lps'),
	(493823, 129, '2014-01-15 00:14:49.000000', 'consum', 0.0211, 'lps'),
	(493824, 129, '2014-01-15 00:14:50.000000', 'consum', 0.0217, 'lps'),
	(493825, 129, '2014-01-15 00:14:51.000000', 'consum', 0.0214, 'lps'),
	(493826, 129, '2014-01-15 00:14:52.000000', 'consum', 0.0222, 'lps'),
	(493827, 129, '2014-01-15 00:14:53.000000', 'consum', 0.0218, 'lps'),
	(493828, 129, '2014-01-15 00:14:54.000000', 'consum', 0.0213, 'lps'),
	(493829, 129, '2014-01-15 00:14:55.000000', 'consum', 0.0216, 'lps'),
	(493830, 129, '2014-01-15 00:14:56.000000', 'consum', 0.0219, 'lps'),
	(493831, 129, '2014-01-15 00:14:57.000000', 'consum', 0.0223, 'lps'),
	(493832, 129, '2014-01-15 00:14:58.000000', 'consum', 0.0221, 'lps'),
	(493833, 129, '2014-01-15 00:14:59.000000', 'consum', 0.0211, 'lps'),
	(493834, 129, '2014-01-15 00:15:00.000000', 'consum', 0.0212, 'lps'),
	(493835, 129, '2014-01-15 00:15:01.000000', 'consum', 0.0219, 'lps'),
	(493836, 129, '2014-01-15 00:15:02.000000', 'consum', 0.0219, 'lps'),
	(493837, 129, '2014-01-15 00:15:03.000000', 'consum', 0.0213, 'lps'),
	(493838, 129, '2014-01-15 00:15:04.000000', 'consum', 0.0215, 'lps'),
	(493839, 129, '2014-01-15 00:15:05.000000', 'consum', 0.0213, 'lps'),
	(493840, 129, '2014-01-15 00:15:06.000000', 'consum', 0.0222, 'lps'),
	(493841, 129, '2014-01-15 00:15:07.000000', 'consum', 0.0221, 'lps'),
	(493842, 129, '2014-01-15 00:15:08.000000', 'consum', 0.0215, 'lps'),
	(493843, 129, '2014-01-15 00:15:09.000000', 'consum', 0.0215, 'lps'),
	(493844, 129, '2014-01-15 00:15:10.000000', 'consum', 0.0221, 'lps'),
	(493845, 129, '2014-01-15 00:15:11.000000', 'consum', 0.0222, 'lps'),
	(493846, 129, '2014-01-15 00:15:12.000000', 'consum', 0.0211, 'lps'),
	(493847, 129, '2014-01-15 00:15:13.000000', 'consum', 0.0222, 'lps'),
	(493848, 129, '2014-01-15 00:15:14.000000', 'consum', 0.0212, 'lps'),
	(493849, 129, '2014-01-15 00:15:15.000000', 'consum', 0.0211, 'lps'),
	(493850, 129, '2014-01-15 00:15:16.000000', 'consum', 0.0211, 'lps'),
	(493851, 129, '2014-01-15 00:15:17.000000', 'consum', 0.0210, 'lps'),
	(493852, 129, '2014-01-15 00:15:18.000000', 'consum', 0.0221, 'lps'),
	(493853, 129, '2014-01-15 00:15:19.000000', 'consum', 0.0212, 'lps'),
	(493854, 129, '2014-01-15 00:15:20.000000', 'consum', 0.0214, 'lps'),
	(493855, 129, '2014-01-15 00:15:21.000000', 'consum', 0.0210, 'lps'),
	(493856, 129, '2014-01-15 00:15:22.000000', 'consum', 0.0212, 'lps'),
	(493857, 129, '2014-01-15 00:15:23.000000', 'consum', 0.0220, 'lps'),
	(493858, 129, '2014-01-15 00:15:24.000000', 'consum', 0.0215, 'lps'),
	(493859, 129, '2014-01-15 00:15:25.000000', 'consum', 0.0217, 'lps'),
	(493860, 129, '2014-01-15 00:15:26.000000', 'consum', 0.0219, 'lps'),
	(493861, 129, '2014-01-15 00:15:27.000000', 'consum', 0.0220, 'lps'),
	(493862, 129, '2014-01-15 00:15:28.000000', 'consum', 0.0217, 'lps'),
	(493863, 129, '2014-01-15 00:15:29.000000', 'consum', 0.0218, 'lps'),
	(493864, 129, '2014-01-15 00:15:30.000000', 'consum', 0.0215, 'lps'),
	(493865, 129, '2014-01-15 00:15:31.000000', 'consum', 0.0210, 'lps'),
	(493866, 129, '2014-01-15 00:15:32.000000', 'consum', 0.0211, 'lps'),
	(493867, 129, '2014-01-15 00:15:33.000000', 'consum', 0.0216, 'lps'),
	(493868, 129, '2014-01-15 00:15:34.000000', 'consum', 0.0221, 'lps'),
	(493869, 129, '2014-01-15 00:15:35.000000', 'consum', 0.0223, 'lps'),
	(493870, 129, '2014-01-15 00:15:36.000000', 'consum', 0.0211, 'lps'),
	(493871, 129, '2014-01-15 00:15:37.000000', 'consum', 0.0220, 'lps'),
	(493872, 129, '2014-01-15 00:15:38.000000', 'consum', 0.0215, 'lps'),
	(493873, 129, '2014-01-15 00:15:39.000000', 'consum', 0.0219, 'lps'),
	(493874, 129, '2014-01-15 00:15:40.000000', 'consum', 0.0213, 'lps'),
	(493875, 129, '2014-01-15 00:15:41.000000', 'consum', 0.0212, 'lps'),
	(493876, 129, '2014-01-15 00:15:42.000000', 'consum', 0.0212, 'lps'),
	(493877, 129, '2014-01-15 00:15:43.000000', 'consum', 0.0214, 'lps'),
	(493878, 129, '2014-01-15 00:15:44.000000', 'consum', 0.0212, 'lps'),
	(493879, 129, '2014-01-15 00:15:45.000000', 'consum', 0.0222, 'lps'),
	(493880, 129, '2014-01-15 00:15:46.000000', 'consum', 0.0221, 'lps'),
	(493881, 129, '2014-01-15 00:15:47.000000', 'consum', 0.0214, 'lps'),
	(493882, 129, '2014-01-15 00:15:48.000000', 'consum', 0.0215, 'lps'),
	(493883, 129, '2014-01-15 00:15:49.000000', 'consum', 0.0223, 'lps'),
	(493884, 129, '2014-01-15 00:15:50.000000', 'consum', 0.0219, 'lps'),
	(493885, 129, '2014-01-15 00:15:51.000000', 'consum', 0.0215, 'lps'),
	(493886, 129, '2014-01-15 00:15:52.000000', 'consum', 0.0222, 'lps'),
	(493887, 129, '2014-01-15 00:15:53.000000', 'consum', 0.0216, 'lps'),
	(493888, 129, '2014-01-15 00:15:54.000000', 'consum', 0.0216, 'lps'),
	(493889, 129, '2014-01-15 00:15:55.000000', 'consum', 0.0211, 'lps'),
	(493890, 129, '2014-01-15 00:15:56.000000', 'consum', 0.0212, 'lps'),
	(493891, 129, '2014-01-15 00:15:57.000000', 'consum', 0.0218, 'lps'),
	(493892, 129, '2014-01-15 00:15:58.000000', 'consum', 0.0214, 'lps'),
	(493893, 129, '2014-01-15 00:15:59.000000', 'consum', 0.0220, 'lps'),
	(493894, 129, '2014-01-15 00:16:00.000000', 'consum', 0.0223, 'lps'),
	(493895, 129, '2014-01-15 00:16:01.000000', 'consum', 0.0218, 'lps'),
	(493896, 129, '2014-01-15 00:16:02.000000', 'consum', 0.0213, 'lps'),
	(493897, 129, '2014-01-15 00:16:03.000000', 'consum', 0.0212, 'lps'),
	(493898, 129, '2014-01-15 00:16:04.000000', 'consum', 0.0211, 'lps'),
	(493899, 129, '2014-01-15 00:16:05.000000', 'consum', 0.0211, 'lps'),
	(493900, 129, '2014-01-15 00:16:06.000000', 'consum', 0.0212, 'lps'),
	(493901, 129, '2014-01-15 00:16:07.000000', 'consum', 0.0219, 'lps'),
	(493902, 129, '2014-01-15 00:16:08.000000', 'consum', 0.0221, 'lps'),
	(493903, 129, '2014-01-15 00:16:09.000000', 'consum', 0.0222, 'lps'),
	(493904, 129, '2014-01-15 00:16:10.000000', 'consum', 0.0213, 'lps'),
	(493905, 129, '2014-01-15 00:16:11.000000', 'consum', 0.0216, 'lps'),
	(493906, 129, '2014-01-15 00:16:12.000000', 'consum', 0.0217, 'lps'),
	(493907, 129, '2014-01-15 00:16:13.000000', 'consum', 0.0216, 'lps'),
	(493908, 129, '2014-01-15 00:16:14.000000', 'consum', 0.0216, 'lps'),
	(493909, 129, '2014-01-15 00:16:15.000000', 'consum', 0.0210, 'lps'),
	(493910, 129, '2014-01-15 00:16:16.000000', 'consum', 0.0220, 'lps'),
	(493911, 129, '2014-01-15 00:16:17.000000', 'consum', 0.0217, 'lps'),
	(493912, 129, '2014-01-15 00:16:18.000000', 'consum', 0.0217, 'lps'),
	(493913, 129, '2014-01-15 00:16:19.000000', 'consum', 0.0223, 'lps'),
	(493914, 129, '2014-01-15 00:16:20.000000', 'consum', 0.0214, 'lps'),
	(493915, 129, '2014-01-15 00:16:21.000000', 'consum', 0.0219, 'lps'),
	(493916, 129, '2014-01-15 00:16:22.000000', 'consum', 0.0217, 'lps'),
	(493917, 129, '2014-01-15 00:16:23.000000', 'consum', 0.0216, 'lps'),
	(493918, 129, '2014-01-15 00:16:24.000000', 'consum', 0.0222, 'lps'),
	(493919, 129, '2014-01-15 00:16:25.000000', 'consum', 0.0211, 'lps'),
	(493920, 129, '2014-01-15 00:16:26.000000', 'consum', 0.0222, 'lps'),
	(493921, 129, '2014-01-15 00:16:27.000000', 'consum', 0.0223, 'lps'),
	(493922, 129, '2014-01-15 00:16:28.000000', 'consum', 0.0211, 'lps'),
	(493923, 129, '2014-01-15 00:16:29.000000', 'consum', 0.0218, 'lps'),
	(493924, 129, '2014-01-15 00:16:30.000000', 'consum', 0.0220, 'lps'),
	(493925, 129, '2014-01-15 00:16:31.000000', 'consum', 0.0221, 'lps'),
	(493926, 129, '2014-01-15 00:16:32.000000', 'consum', 0.0210, 'lps'),
	(493927, 129, '2014-01-15 00:16:33.000000', 'consum', 0.0220, 'lps'),
	(493928, 129, '2014-01-15 00:16:34.000000', 'consum', 0.0216, 'lps'),
	(493929, 129, '2014-01-15 00:16:35.000000', 'consum', 0.0211, 'lps'),
	(493930, 129, '2014-01-15 00:16:36.000000', 'consum', 0.0213, 'lps'),
	(493931, 129, '2014-01-15 00:16:37.000000', 'consum', 0.0222, 'lps'),
	(493932, 129, '2014-01-15 00:16:38.000000', 'consum', 0.0221, 'lps'),
	(493933, 129, '2014-01-15 00:16:39.000000', 'consum', 0.0215, 'lps'),
	(493934, 129, '2014-01-15 00:16:40.000000', 'consum', 0.0215, 'lps'),
	(493935, 129, '2014-01-15 00:16:41.000000', 'consum', 0.0223, 'lps'),
	(493936, 129, '2014-01-15 00:16:42.000000', 'consum', 0.0219, 'lps'),
	(493937, 129, '2014-01-15 00:16:43.000000', 'consum', 0.0213, 'lps'),
	(493938, 129, '2014-01-15 00:16:44.000000', 'consum', 0.0216, 'lps'),
	(493939, 129, '2014-01-15 00:16:45.000000', 'consum', 0.0214, 'lps'),
	(493940, 129, '2014-01-15 00:16:46.000000', 'consum', 0.0214, 'lps'),
	(493941, 129, '2014-01-15 00:16:47.000000', 'consum', 0.0219, 'lps'),
	(493942, 129, '2014-01-15 00:16:48.000000', 'consum', 0.0216, 'lps'),
	(493943, 129, '2014-01-15 00:16:49.000000', 'consum', 0.0213, 'lps'),
	(493944, 129, '2014-01-15 00:16:50.000000', 'consum', 0.0223, 'lps'),
	(493945, 129, '2014-01-15 00:16:51.000000', 'consum', 0.0223, 'lps'),
	(493946, 129, '2014-01-15 00:16:52.000000', 'consum', 0.0210, 'lps'),
	(493947, 129, '2014-01-15 00:16:53.000000', 'consum', 0.0215, 'lps'),
	(493948, 129, '2014-01-15 00:16:54.000000', 'consum', 0.0219, 'lps'),
	(493949, 129, '2014-01-15 00:16:55.000000', 'consum', 0.0213, 'lps'),
	(493950, 129, '2014-01-15 00:16:56.000000', 'consum', 0.0213, 'lps'),
	(493951, 129, '2014-01-15 00:16:57.000000', 'consum', 0.0216, 'lps'),
	(493952, 129, '2014-01-15 00:16:58.000000', 'consum', 0.0216, 'lps'),
	(493953, 129, '2014-01-15 00:16:59.000000', 'consum', 0.0222, 'lps'),
	(493954, 129, '2014-01-15 00:17:00.000000', 'consum', 0.0213, 'lps'),
	(493955, 129, '2014-01-15 00:17:01.000000', 'consum', 0.0215, 'lps'),
	(493956, 129, '2014-01-15 00:17:02.000000', 'consum', 0.0215, 'lps'),
	(493957, 129, '2014-01-15 00:17:03.000000', 'consum', 0.0222, 'lps'),
	(493958, 129, '2014-01-15 00:17:04.000000', 'consum', 0.0210, 'lps'),
	(493959, 129, '2014-01-15 00:17:05.000000', 'consum', 0.0217, 'lps'),
	(493960, 129, '2014-01-15 00:17:06.000000', 'consum', 0.0218, 'lps'),
	(493961, 129, '2014-01-15 00:17:07.000000', 'consum', 0.0216, 'lps'),
	(493962, 129, '2014-01-15 00:17:08.000000', 'consum', 0.0215, 'lps'),
	(493963, 129, '2014-01-15 00:17:09.000000', 'consum', 0.0219, 'lps'),
	(493964, 129, '2014-01-15 00:17:10.000000', 'consum', 0.0211, 'lps'),
	(493965, 129, '2014-01-15 00:17:11.000000', 'consum', 0.0219, 'lps'),
	(493966, 129, '2014-01-15 00:17:12.000000', 'consum', 0.0222, 'lps'),
	(493967, 129, '2014-01-15 00:17:13.000000', 'consum', 0.0218, 'lps'),
	(493968, 129, '2014-01-15 00:17:14.000000', 'consum', 0.0212, 'lps'),
	(493969, 129, '2014-01-15 00:17:15.000000', 'consum', 0.0223, 'lps'),
	(493970, 129, '2014-01-15 00:17:16.000000', 'consum', 0.0217, 'lps'),
	(493971, 129, '2014-01-15 00:17:17.000000', 'consum', 0.0217, 'lps'),
	(493972, 129, '2014-01-15 00:17:18.000000', 'consum', 0.0214, 'lps'),
	(493973, 129, '2014-01-15 00:17:19.000000', 'consum', 0.0220, 'lps'),
	(493974, 129, '2014-01-15 00:17:20.000000', 'consum', 0.0223, 'lps'),
	(493975, 129, '2014-01-15 00:17:21.000000', 'consum', 0.0217, 'lps'),
	(493976, 129, '2014-01-15 00:17:22.000000', 'consum', 0.0220, 'lps'),
	(493977, 129, '2014-01-15 00:17:23.000000', 'consum', 0.0213, 'lps'),
	(493978, 129, '2014-01-15 00:17:24.000000', 'consum', 0.0210, 'lps'),
	(493979, 129, '2014-01-15 00:17:25.000000', 'consum', 0.0217, 'lps'),
	(493980, 129, '2014-01-15 00:17:26.000000', 'consum', 0.0214, 'lps'),
	(493981, 129, '2014-01-15 00:17:27.000000', 'consum', 0.0213, 'lps'),
	(493982, 129, '2014-01-15 00:17:28.000000', 'consum', 0.0211, 'lps'),
	(493983, 129, '2014-01-15 00:17:29.000000', 'consum', 0.0220, 'lps'),
	(493984, 129, '2014-01-15 00:17:30.000000', 'consum', 0.0217, 'lps'),
	(493985, 129, '2014-01-15 00:17:31.000000', 'consum', 0.0216, 'lps'),
	(493986, 129, '2014-01-15 00:17:32.000000', 'consum', 0.0219, 'lps'),
	(493987, 129, '2014-01-15 00:17:33.000000', 'consum', 0.0211, 'lps'),
	(493988, 129, '2014-01-15 00:17:34.000000', 'consum', 0.0216, 'lps'),
	(493989, 129, '2014-01-15 00:17:35.000000', 'consum', 0.0222, 'lps'),
	(493990, 129, '2014-01-15 00:17:36.000000', 'consum', 0.0211, 'lps'),
	(493991, 129, '2014-01-15 00:17:37.000000', 'consum', 0.0220, 'lps'),
	(493992, 129, '2014-01-15 00:17:38.000000', 'consum', 0.0218, 'lps'),
	(493993, 129, '2014-01-15 00:17:39.000000', 'consum', 0.0222, 'lps'),
	(493994, 129, '2014-01-15 00:17:40.000000', 'consum', 0.0215, 'lps'),
	(493995, 129, '2014-01-15 00:17:41.000000', 'consum', 0.0214, 'lps'),
	(493996, 129, '2014-01-15 00:17:42.000000', 'consum', 0.0217, 'lps'),
	(493997, 129, '2014-01-15 00:17:43.000000', 'consum', 0.0217, 'lps'),
	(493998, 129, '2014-01-15 00:17:44.000000', 'consum', 0.0211, 'lps'),
	(493999, 129, '2014-01-15 00:17:45.000000', 'consum', 0.0221, 'lps'),
	(494000, 129, '2014-01-15 00:17:46.000000', 'consum', 0.0223, 'lps'),
	(494001, 129, '2014-01-15 00:17:47.000000', 'consum', 0.0214, 'lps'),
	(494002, 129, '2014-01-15 00:17:48.000000', 'consum', 0.0218, 'lps'),
	(494003, 129, '2014-01-15 00:17:49.000000', 'consum', 0.0210, 'lps'),
	(494004, 129, '2014-01-15 00:17:50.000000', 'consum', 0.0214, 'lps'),
	(494005, 129, '2014-01-15 00:17:51.000000', 'consum', 0.0220, 'lps'),
	(494006, 129, '2014-01-15 00:17:52.000000', 'consum', 0.0217, 'lps'),
	(494007, 129, '2014-01-15 00:17:53.000000', 'consum', 0.0215, 'lps'),
	(494008, 129, '2014-01-15 00:17:54.000000', 'consum', 0.0217, 'lps'),
	(494009, 129, '2014-01-15 00:17:55.000000', 'consum', 0.0216, 'lps'),
	(494010, 129, '2014-01-15 00:17:56.000000', 'consum', 0.0221, 'lps'),
	(494011, 129, '2014-01-15 00:17:57.000000', 'consum', 0.0220, 'lps'),
	(494012, 129, '2014-01-15 00:17:58.000000', 'consum', 0.0211, 'lps'),
	(494013, 129, '2014-01-15 00:17:59.000000', 'consum', 0.0213, 'lps'),
	(494014, 129, '2014-01-15 00:18:00.000000', 'consum', 0.0211, 'lps'),
	(494015, 129, '2014-01-15 00:18:01.000000', 'consum', 0.0221, 'lps'),
	(494016, 129, '2014-01-15 00:18:02.000000', 'consum', 0.0219, 'lps'),
	(494017, 129, '2014-01-15 00:18:03.000000', 'consum', 0.0221, 'lps'),
	(494018, 129, '2014-01-15 00:18:04.000000', 'consum', 0.0210, 'lps'),
	(494019, 129, '2014-01-15 00:18:05.000000', 'consum', 0.0222, 'lps'),
	(494020, 129, '2014-01-15 00:18:06.000000', 'consum', 0.0215, 'lps'),
	(494021, 129, '2014-01-15 00:18:07.000000', 'consum', 0.0214, 'lps'),
	(494022, 129, '2014-01-15 00:18:08.000000', 'consum', 0.0213, 'lps'),
	(494023, 129, '2014-01-15 00:18:09.000000', 'consum', 0.0214, 'lps'),
	(494024, 129, '2014-01-15 00:18:10.000000', 'consum', 0.0221, 'lps'),
	(494025, 129, '2014-01-15 00:18:11.000000', 'consum', 0.0212, 'lps'),
	(494026, 129, '2014-01-15 00:18:12.000000', 'consum', 0.0215, 'lps'),
	(494027, 129, '2014-01-15 00:18:13.000000', 'consum', 0.0217, 'lps'),
	(494028, 129, '2014-01-15 00:18:14.000000', 'consum', 0.0217, 'lps'),
	(494029, 129, '2014-01-15 00:18:15.000000', 'consum', 0.0223, 'lps'),
	(494030, 129, '2014-01-15 00:18:16.000000', 'consum', 0.0213, 'lps'),
	(494031, 129, '2014-01-15 00:18:17.000000', 'consum', 0.0214, 'lps'),
	(494032, 129, '2014-01-15 00:18:18.000000', 'consum', 0.0222, 'lps'),
	(494033, 129, '2014-01-15 00:18:19.000000', 'consum', 0.0216, 'lps'),
	(494034, 129, '2014-01-15 00:18:20.000000', 'consum', 0.0218, 'lps'),
	(494035, 129, '2014-01-15 00:18:21.000000', 'consum', 0.0219, 'lps'),
	(494036, 129, '2014-01-15 00:18:22.000000', 'consum', 0.0219, 'lps'),
	(494037, 129, '2014-01-15 00:18:23.000000', 'consum', 0.0212, 'lps'),
	(494038, 129, '2014-01-15 00:18:24.000000', 'consum', 0.0211, 'lps'),
	(494039, 129, '2014-01-15 00:18:25.000000', 'consum', 0.0220, 'lps'),
	(494040, 129, '2014-01-15 00:18:26.000000', 'consum', 0.0216, 'lps'),
	(494041, 129, '2014-01-15 00:18:27.000000', 'consum', 0.0212, 'lps'),
	(494042, 129, '2014-01-15 00:18:28.000000', 'consum', 0.0216, 'lps'),
	(494043, 129, '2014-01-15 00:18:29.000000', 'consum', 0.0220, 'lps'),
	(494044, 129, '2014-01-15 00:18:30.000000', 'consum', 0.0213, 'lps'),
	(494045, 129, '2014-01-15 00:18:31.000000', 'consum', 0.0223, 'lps'),
	(494046, 129, '2014-01-15 00:18:32.000000', 'consum', 0.0214, 'lps'),
	(494047, 129, '2014-01-15 00:18:33.000000', 'consum', 0.0216, 'lps'),
	(494048, 129, '2014-01-15 00:18:34.000000', 'consum', 0.0216, 'lps'),
	(494049, 129, '2014-01-15 00:18:35.000000', 'consum', 0.0223, 'lps'),
	(494050, 129, '2014-01-15 00:18:36.000000', 'consum', 0.0213, 'lps'),
	(494051, 129, '2014-01-15 00:18:37.000000', 'consum', 0.0216, 'lps'),
	(494052, 129, '2014-01-15 00:18:38.000000', 'consum', 0.0217, 'lps'),
	(494053, 129, '2014-01-15 00:18:39.000000', 'consum', 0.0213, 'lps'),
	(494054, 129, '2014-01-15 00:18:40.000000', 'consum', 0.0218, 'lps'),
	(494055, 129, '2014-01-15 00:18:41.000000', 'consum', 0.0212, 'lps'),
	(494056, 129, '2014-01-15 00:18:42.000000', 'consum', 0.0213, 'lps'),
	(494057, 129, '2014-01-15 00:18:43.000000', 'consum', 0.0219, 'lps'),
	(494058, 129, '2014-01-15 00:18:44.000000', 'consum', 0.0217, 'lps'),
	(494059, 129, '2014-01-15 00:18:45.000000', 'consum', 0.0220, 'lps'),
	(494060, 129, '2014-01-15 00:18:46.000000', 'consum', 0.0210, 'lps'),
	(494061, 129, '2014-01-15 00:18:47.000000', 'consum', 0.0223, 'lps'),
	(494062, 129, '2014-01-15 00:18:48.000000', 'consum', 0.0221, 'lps'),
	(494063, 129, '2014-01-15 00:18:49.000000', 'consum', 0.0210, 'lps'),
	(494064, 129, '2014-01-15 00:18:50.000000', 'consum', 0.0220, 'lps'),
	(494065, 129, '2014-01-15 00:18:51.000000', 'consum', 0.0220, 'lps'),
	(494066, 129, '2014-01-15 00:18:52.000000', 'consum', 0.0215, 'lps'),
	(494067, 129, '2014-01-15 00:18:53.000000', 'consum', 0.0222, 'lps'),
	(494068, 129, '2014-01-15 00:18:54.000000', 'consum', 0.0212, 'lps'),
	(494069, 129, '2014-01-15 00:18:55.000000', 'consum', 0.0211, 'lps'),
	(494070, 129, '2014-01-15 00:18:56.000000', 'consum', 0.0212, 'lps'),
	(494071, 129, '2014-01-15 00:18:57.000000', 'consum', 0.0219, 'lps'),
	(494072, 129, '2014-01-15 00:18:58.000000', 'consum', 0.0218, 'lps'),
	(494073, 129, '2014-01-15 00:18:59.000000', 'consum', 0.0211, 'lps'),
	(494074, 129, '2014-01-15 00:19:00.000000', 'consum', 0.0217, 'lps'),
	(494075, 129, '2014-01-15 00:19:01.000000', 'consum', 0.0218, 'lps'),
	(494076, 129, '2014-01-15 00:19:02.000000', 'consum', 0.0213, 'lps'),
	(494077, 129, '2014-01-15 00:19:03.000000', 'consum', 0.0218, 'lps'),
	(494078, 129, '2014-01-15 00:19:04.000000', 'consum', 0.0210, 'lps'),
	(494079, 129, '2014-01-15 00:19:05.000000', 'consum', 0.0217, 'lps'),
	(494080, 129, '2014-01-15 00:19:06.000000', 'consum', 0.0217, 'lps'),
	(494081, 129, '2014-01-15 00:19:07.000000', 'consum', 0.0211, 'lps'),
	(494082, 129, '2014-01-15 00:19:08.000000', 'consum', 0.0220, 'lps'),
	(494083, 129, '2014-01-15 00:19:09.000000', 'consum', 0.0218, 'lps'),
	(494084, 129, '2014-01-15 00:19:10.000000', 'consum', 0.0218, 'lps'),
	(494085, 129, '2014-01-15 00:19:11.000000', 'consum', 0.0214, 'lps'),
	(494086, 129, '2014-01-15 00:19:12.000000', 'consum', 0.0222, 'lps'),
	(494087, 129, '2014-01-15 00:19:13.000000', 'consum', 0.0213, 'lps'),
	(494088, 129, '2014-01-15 00:19:14.000000', 'consum', 0.0221, 'lps'),
	(494089, 129, '2014-01-15 00:19:15.000000', 'consum', 0.0213, 'lps'),
	(494090, 129, '2014-01-15 00:19:16.000000', 'consum', 0.0222, 'lps'),
	(494091, 129, '2014-01-15 00:19:17.000000', 'consum', 0.0220, 'lps'),
	(494092, 129, '2014-01-15 00:19:18.000000', 'consum', 0.0222, 'lps'),
	(494093, 129, '2014-01-15 00:19:19.000000', 'consum', 0.0212, 'lps'),
	(494094, 129, '2014-01-15 00:19:20.000000', 'consum', 0.0213, 'lps'),
	(494095, 129, '2014-01-15 00:19:21.000000', 'consum', 0.0221, 'lps'),
	(494096, 129, '2014-01-15 00:19:22.000000', 'consum', 0.0215, 'lps'),
	(494097, 129, '2014-01-15 00:19:23.000000', 'consum', 0.0215, 'lps'),
	(494098, 129, '2014-01-15 00:19:24.000000', 'consum', 0.0219, 'lps'),
	(494099, 129, '2014-01-15 00:19:25.000000', 'consum', 0.0215, 'lps'),
	(494100, 129, '2014-01-15 00:19:26.000000', 'consum', 0.0222, 'lps'),
	(494101, 129, '2014-01-15 00:19:27.000000', 'consum', 0.0215, 'lps'),
	(494102, 129, '2014-01-15 00:19:28.000000', 'consum', 0.0211, 'lps'),
	(494103, 129, '2014-01-15 00:19:29.000000', 'consum', 0.0217, 'lps'),
	(494104, 129, '2014-01-15 00:19:30.000000', 'consum', 0.0213, 'lps'),
	(494105, 129, '2014-01-15 00:19:31.000000', 'consum', 0.0217, 'lps'),
	(494106, 129, '2014-01-15 00:19:32.000000', 'consum', 0.0223, 'lps'),
	(494107, 129, '2014-01-15 00:19:33.000000', 'consum', 0.0211, 'lps'),
	(494108, 129, '2014-01-15 00:19:34.000000', 'consum', 0.0221, 'lps'),
	(494109, 129, '2014-01-15 00:19:35.000000', 'consum', 0.0221, 'lps'),
	(494110, 129, '2014-01-15 00:19:36.000000', 'consum', 0.0219, 'lps'),
	(494111, 129, '2014-01-15 00:19:37.000000', 'consum', 0.0219, 'lps'),
	(494112, 129, '2014-01-15 00:19:38.000000', 'consum', 0.0218, 'lps'),
	(494113, 129, '2014-01-15 00:19:39.000000', 'consum', 0.0223, 'lps'),
	(494114, 129, '2014-01-15 00:19:40.000000', 'consum', 0.0222, 'lps'),
	(494115, 129, '2014-01-15 00:19:41.000000', 'consum', 0.0216, 'lps'),
	(494116, 129, '2014-01-15 00:19:42.000000', 'consum', 0.0221, 'lps'),
	(494117, 129, '2014-01-15 00:19:43.000000', 'consum', 0.0220, 'lps'),
	(494118, 129, '2014-01-15 00:19:44.000000', 'consum', 0.0214, 'lps'),
	(494119, 129, '2014-01-15 00:19:45.000000', 'consum', 0.0212, 'lps'),
	(494120, 129, '2014-01-15 00:19:46.000000', 'consum', 0.0223, 'lps'),
	(494121, 129, '2014-01-15 00:19:47.000000', 'consum', 0.0214, 'lps'),
	(494122, 129, '2014-01-15 00:19:48.000000', 'consum', 0.0221, 'lps'),
	(494123, 129, '2014-01-15 00:19:49.000000', 'consum', 0.0210, 'lps'),
	(494124, 129, '2014-01-15 00:19:50.000000', 'consum', 0.0218, 'lps'),
	(494125, 129, '2014-01-15 00:19:51.000000', 'consum', 0.0212, 'lps'),
	(494126, 129, '2014-01-15 00:19:52.000000', 'consum', 0.0222, 'lps'),
	(494127, 129, '2014-01-15 00:19:53.000000', 'consum', 0.0223, 'lps'),
	(494128, 129, '2014-01-15 00:19:54.000000', 'consum', 0.0212, 'lps'),
	(494129, 129, '2014-01-15 00:19:55.000000', 'consum', 0.0211, 'lps'),
	(494130, 129, '2014-01-15 00:19:56.000000', 'consum', 0.0223, 'lps'),
	(494131, 129, '2014-01-15 00:19:57.000000', 'consum', 0.0217, 'lps'),
	(494132, 129, '2014-01-15 00:19:58.000000', 'consum', 0.0219, 'lps'),
	(494133, 129, '2014-01-15 00:19:59.000000', 'consum', 0.0222, 'lps'),
	(494134, 129, '2014-01-15 00:20:00.000000', 'consum', 0.0213, 'lps'),
	(494135, 129, '2014-01-15 00:20:01.000000', 'consum', 0.0219, 'lps'),
	(494136, 129, '2014-01-15 00:20:02.000000', 'consum', 0.0218, 'lps'),
	(494137, 129, '2014-01-15 00:20:03.000000', 'consum', 0.0211, 'lps'),
	(494138, 129, '2014-01-15 00:20:04.000000', 'consum', 0.0218, 'lps'),
	(494139, 129, '2014-01-15 00:20:05.000000', 'consum', 0.0219, 'lps'),
	(494140, 129, '2014-01-15 00:20:06.000000', 'consum', 0.0218, 'lps'),
	(494141, 129, '2014-01-15 00:20:07.000000', 'consum', 0.0223, 'lps'),
	(494142, 129, '2014-01-15 00:20:08.000000', 'consum', 0.0210, 'lps'),
	(494143, 129, '2014-01-15 00:20:09.000000', 'consum', 0.0212, 'lps'),
	(494144, 129, '2014-01-15 00:20:10.000000', 'consum', 0.0220, 'lps'),
	(494145, 129, '2014-01-15 00:20:11.000000', 'consum', 0.0212, 'lps'),
	(494146, 129, '2014-01-15 00:20:12.000000', 'consum', 0.0220, 'lps'),
	(494147, 129, '2014-01-15 00:20:13.000000', 'consum', 0.0214, 'lps'),
	(494148, 129, '2014-01-15 00:20:14.000000', 'consum', 0.0214, 'lps'),
	(494149, 129, '2014-01-15 00:20:15.000000', 'consum', 0.0217, 'lps'),
	(494150, 129, '2014-01-15 00:20:16.000000', 'consum', 0.0220, 'lps'),
	(494151, 129, '2014-01-15 00:20:17.000000', 'consum', 0.0211, 'lps'),
	(494152, 129, '2014-01-15 00:20:18.000000', 'consum', 0.0214, 'lps'),
	(494153, 129, '2014-01-15 00:20:19.000000', 'consum', 0.0211, 'lps'),
	(494154, 129, '2014-01-15 00:20:20.000000', 'consum', 0.0221, 'lps'),
	(494155, 129, '2014-01-15 00:20:21.000000', 'consum', 0.0220, 'lps'),
	(494156, 129, '2014-01-15 00:20:22.000000', 'consum', 0.0215, 'lps'),
	(494157, 129, '2014-01-15 00:20:23.000000', 'consum', 0.0218, 'lps'),
	(494158, 129, '2014-01-15 00:20:24.000000', 'consum', 0.0221, 'lps'),
	(494159, 129, '2014-01-15 00:20:25.000000', 'consum', 0.0215, 'lps'),
	(494160, 129, '2014-01-15 00:20:26.000000', 'consum', 0.0214, 'lps'),
	(494161, 129, '2014-01-15 00:20:27.000000', 'consum', 0.0216, 'lps'),
	(494162, 129, '2014-01-15 00:20:28.000000', 'consum', 0.0215, 'lps'),
	(494163, 129, '2014-01-15 00:20:29.000000', 'consum', 0.0217, 'lps'),
	(494164, 129, '2014-01-15 00:20:30.000000', 'consum', 0.0217, 'lps'),
	(494165, 129, '2014-01-15 00:20:31.000000', 'consum', 0.0211, 'lps'),
	(494166, 129, '2014-01-15 00:20:32.000000', 'consum', 0.0223, 'lps'),
	(494167, 129, '2014-01-15 00:20:33.000000', 'consum', 0.0216, 'lps'),
	(494168, 129, '2014-01-15 00:20:34.000000', 'consum', 0.0214, 'lps'),
	(494169, 129, '2014-01-15 00:20:35.000000', 'consum', 0.0212, 'lps'),
	(494170, 129, '2014-01-15 00:20:36.000000', 'consum', 0.0223, 'lps'),
	(494171, 129, '2014-01-15 00:20:37.000000', 'consum', 0.0212, 'lps'),
	(494172, 129, '2014-01-15 00:20:38.000000', 'consum', 0.0210, 'lps'),
	(494173, 129, '2014-01-15 00:20:39.000000', 'consum', 0.0218, 'lps'),
	(494174, 129, '2014-01-15 00:20:40.000000', 'consum', 0.0223, 'lps'),
	(494175, 129, '2014-01-15 00:20:41.000000', 'consum', 0.0212, 'lps'),
	(494176, 129, '2014-01-15 00:20:42.000000', 'consum', 0.0220, 'lps'),
	(494177, 129, '2014-01-15 00:20:43.000000', 'consum', 0.0214, 'lps'),
	(494178, 129, '2014-01-15 00:20:44.000000', 'consum', 0.0215, 'lps'),
	(494179, 129, '2014-01-15 00:20:45.000000', 'consum', 0.0223, 'lps'),
	(494180, 129, '2014-01-15 00:20:46.000000', 'consum', 0.0217, 'lps'),
	(494181, 129, '2014-01-15 00:20:47.000000', 'consum', 0.0221, 'lps'),
	(494182, 129, '2014-01-15 00:20:48.000000', 'consum', 0.0216, 'lps'),
	(494183, 129, '2014-01-15 00:20:49.000000', 'consum', 0.0210, 'lps'),
	(494184, 129, '2014-01-15 00:20:50.000000', 'consum', 0.0218, 'lps'),
	(494185, 129, '2014-01-15 00:20:51.000000', 'consum', 0.0211, 'lps'),
	(494186, 129, '2014-01-15 00:20:52.000000', 'consum', 0.0218, 'lps'),
	(494187, 129, '2014-01-15 00:20:53.000000', 'consum', 0.0220, 'lps'),
	(494188, 129, '2014-01-15 00:20:54.000000', 'consum', 0.0210, 'lps'),
	(494189, 129, '2014-01-15 00:20:55.000000', 'consum', 0.0220, 'lps'),
	(494190, 129, '2014-01-15 00:20:56.000000', 'consum', 0.0220, 'lps'),
	(494191, 129, '2014-01-15 00:20:57.000000', 'consum', 0.0216, 'lps'),
	(494192, 129, '2014-01-15 00:20:58.000000', 'consum', 0.0212, 'lps'),
	(494193, 129, '2014-01-15 00:20:59.000000', 'consum', 0.0214, 'lps'),
	(494194, 129, '2014-01-15 00:21:00.000000', 'consum', 0.0213, 'lps'),
	(494195, 129, '2014-01-15 00:21:01.000000', 'consum', 0.0214, 'lps'),
	(494196, 129, '2014-01-15 00:21:02.000000', 'consum', 0.0218, 'lps'),
	(494197, 129, '2014-01-15 00:21:03.000000', 'consum', 0.0214, 'lps'),
	(494198, 129, '2014-01-15 00:21:04.000000', 'consum', 0.0218, 'lps'),
	(494199, 129, '2014-01-15 00:21:05.000000', 'consum', 0.0211, 'lps'),
	(494200, 129, '2014-01-15 00:21:06.000000', 'consum', 0.0219, 'lps'),
	(494201, 129, '2014-01-15 00:21:07.000000', 'consum', 0.0210, 'lps'),
	(494202, 129, '2014-01-15 00:21:08.000000', 'consum', 0.0210, 'lps'),
	(494203, 129, '2014-01-15 00:21:09.000000', 'consum', 0.0213, 'lps'),
	(494204, 129, '2014-01-15 00:21:10.000000', 'consum', 0.0211, 'lps'),
	(494205, 129, '2014-01-15 00:21:11.000000', 'consum', 0.0219, 'lps'),
	(494206, 129, '2014-01-15 00:21:12.000000', 'consum', 0.0212, 'lps'),
	(494207, 129, '2014-01-15 00:21:13.000000', 'consum', 0.0221, 'lps'),
	(494208, 129, '2014-01-15 00:21:14.000000', 'consum', 0.0219, 'lps'),
	(494209, 129, '2014-01-15 00:21:15.000000', 'consum', 0.0222, 'lps'),
	(494210, 129, '2014-01-15 00:21:16.000000', 'consum', 0.0214, 'lps'),
	(494211, 129, '2014-01-15 00:21:17.000000', 'consum', 0.0210, 'lps'),
	(494212, 129, '2014-01-15 00:21:18.000000', 'consum', 0.0211, 'lps'),
	(494213, 129, '2014-01-15 00:21:19.000000', 'consum', 0.0218, 'lps'),
	(494214, 129, '2014-01-15 00:21:20.000000', 'consum', 0.0220, 'lps'),
	(494215, 129, '2014-01-15 00:21:21.000000', 'consum', 0.0220, 'lps'),
	(494216, 129, '2014-01-15 00:21:22.000000', 'consum', 0.0217, 'lps'),
	(494217, 129, '2014-01-15 00:21:23.000000', 'consum', 0.0215, 'lps'),
	(494218, 129, '2014-01-15 00:21:24.000000', 'consum', 0.0214, 'lps'),
	(494219, 129, '2014-01-15 00:21:25.000000', 'consum', 0.0218, 'lps'),
	(494220, 129, '2014-01-15 00:21:26.000000', 'consum', 0.0223, 'lps'),
	(494221, 129, '2014-01-15 00:21:27.000000', 'consum', 0.0210, 'lps'),
	(494222, 129, '2014-01-15 00:21:28.000000', 'consum', 0.0215, 'lps'),
	(494223, 129, '2014-01-15 00:21:29.000000', 'consum', 0.0220, 'lps'),
	(494224, 129, '2014-01-15 00:21:30.000000', 'consum', 0.0219, 'lps'),
	(494225, 129, '2014-01-15 00:21:31.000000', 'consum', 0.0211, 'lps'),
	(494226, 129, '2014-01-15 00:21:32.000000', 'consum', 0.0216, 'lps'),
	(494227, 129, '2014-01-15 00:21:33.000000', 'consum', 0.0210, 'lps'),
	(494228, 129, '2014-01-15 00:21:34.000000', 'consum', 0.0221, 'lps'),
	(494229, 129, '2014-01-15 00:21:35.000000', 'consum', 0.0223, 'lps'),
	(494230, 129, '2014-01-15 00:21:36.000000', 'consum', 0.0213, 'lps'),
	(494231, 129, '2014-01-15 00:21:37.000000', 'consum', 0.0215, 'lps'),
	(494232, 129, '2014-01-15 00:21:38.000000', 'consum', 0.0213, 'lps'),
	(494233, 129, '2014-01-15 00:21:39.000000', 'consum', 0.0223, 'lps'),
	(494234, 129, '2014-01-15 00:21:40.000000', 'consum', 0.0212, 'lps'),
	(494235, 129, '2014-01-15 00:21:41.000000', 'consum', 0.0210, 'lps'),
	(494236, 129, '2014-01-15 00:21:42.000000', 'consum', 0.0217, 'lps'),
	(494237, 129, '2014-01-15 00:21:43.000000', 'consum', 0.0217, 'lps'),
	(494238, 129, '2014-01-15 00:21:44.000000', 'consum', 0.0213, 'lps'),
	(494239, 129, '2014-01-15 00:21:45.000000', 'consum', 0.0217, 'lps'),
	(494240, 129, '2014-01-15 00:21:46.000000', 'consum', 0.0210, 'lps'),
	(494241, 129, '2014-01-15 00:21:47.000000', 'consum', 0.0217, 'lps'),
	(494242, 129, '2014-01-15 00:21:48.000000', 'consum', 0.0217, 'lps'),
	(494243, 129, '2014-01-15 00:21:49.000000', 'consum', 0.0211, 'lps'),
	(494244, 129, '2014-01-15 00:21:50.000000', 'consum', 0.0223, 'lps'),
	(494245, 129, '2014-01-15 00:21:51.000000', 'consum', 0.0218, 'lps'),
	(494246, 129, '2014-01-15 00:21:52.000000', 'consum', 0.0222, 'lps'),
	(494247, 129, '2014-01-15 00:21:53.000000', 'consum', 0.0221, 'lps'),
	(494248, 129, '2014-01-15 00:21:54.000000', 'consum', 0.0216, 'lps'),
	(494249, 129, '2014-01-15 00:21:55.000000', 'consum', 0.0220, 'lps'),
	(494250, 129, '2014-01-15 00:21:56.000000', 'consum', 0.0217, 'lps'),
	(494251, 129, '2014-01-15 00:21:57.000000', 'consum', 0.0213, 'lps'),
	(494252, 129, '2014-01-15 00:21:58.000000', 'consum', 0.0221, 'lps'),
	(494253, 129, '2014-01-15 00:21:59.000000', 'consum', 0.0214, 'lps'),
	(494254, 129, '2014-01-15 00:22:00.000000', 'consum', 0.0211, 'lps'),
	(494255, 129, '2014-01-15 00:22:01.000000', 'consum', 0.0219, 'lps'),
	(494256, 129, '2014-01-15 00:22:02.000000', 'consum', 0.0211, 'lps'),
	(494257, 129, '2014-01-15 00:22:03.000000', 'consum', 0.0216, 'lps'),
	(494258, 129, '2014-01-15 00:22:04.000000', 'consum', 0.0211, 'lps'),
	(494259, 129, '2014-01-15 00:22:05.000000', 'consum', 0.0211, 'lps'),
	(494260, 129, '2014-01-15 00:22:06.000000', 'consum', 0.0211, 'lps'),
	(494261, 129, '2014-01-15 00:22:07.000000', 'consum', 0.0212, 'lps'),
	(494262, 129, '2014-01-15 00:22:08.000000', 'consum', 0.0218, 'lps'),
	(494263, 129, '2014-01-15 00:22:09.000000', 'consum', 0.0218, 'lps'),
	(494264, 129, '2014-01-15 00:22:10.000000', 'consum', 0.0213, 'lps'),
	(494265, 129, '2014-01-15 00:22:11.000000', 'consum', 0.0215, 'lps'),
	(494266, 129, '2014-01-15 00:22:12.000000', 'consum', 0.0213, 'lps'),
	(494267, 129, '2014-01-15 00:22:13.000000', 'consum', 0.0212, 'lps'),
	(494268, 129, '2014-01-15 00:22:14.000000', 'consum', 0.0223, 'lps'),
	(494269, 129, '2014-01-15 00:22:15.000000', 'consum', 0.0215, 'lps'),
	(494270, 129, '2014-01-15 00:22:16.000000', 'consum', 0.0212, 'lps'),
	(494271, 129, '2014-01-15 00:22:17.000000', 'consum', 0.0218, 'lps'),
	(494272, 129, '2014-01-15 00:22:18.000000', 'consum', 0.0215, 'lps'),
	(494273, 129, '2014-01-15 00:22:19.000000', 'consum', 0.0211, 'lps'),
	(494274, 129, '2014-01-15 00:22:20.000000', 'consum', 0.0214, 'lps'),
	(494275, 129, '2014-01-15 00:22:21.000000', 'consum', 0.0215, 'lps'),
	(494276, 129, '2014-01-15 00:22:22.000000', 'consum', 0.0221, 'lps'),
	(494277, 129, '2014-01-15 00:22:23.000000', 'consum', 0.0212, 'lps'),
	(494278, 129, '2014-01-15 00:22:24.000000', 'consum', 0.0215, 'lps'),
	(494279, 129, '2014-01-15 00:22:25.000000', 'consum', 0.0214, 'lps'),
	(494280, 129, '2014-01-15 00:22:26.000000', 'consum', 0.0217, 'lps'),
	(494281, 129, '2014-01-15 00:22:27.000000', 'consum', 0.0220, 'lps'),
	(494282, 129, '2014-01-15 00:22:28.000000', 'consum', 0.0223, 'lps'),
	(494283, 129, '2014-01-15 00:22:29.000000', 'consum', 0.0217, 'lps'),
	(494284, 129, '2014-01-15 00:22:30.000000', 'consum', 0.0223, 'lps'),
	(494285, 129, '2014-01-15 00:22:31.000000', 'consum', 0.0212, 'lps'),
	(494286, 129, '2014-01-15 00:22:32.000000', 'consum', 0.0221, 'lps'),
	(494287, 129, '2014-01-15 00:22:33.000000', 'consum', 0.0221, 'lps'),
	(494288, 129, '2014-01-15 00:22:34.000000', 'consum', 0.0218, 'lps'),
	(494289, 129, '2014-01-15 00:22:35.000000', 'consum', 0.0216, 'lps'),
	(494290, 129, '2014-01-15 00:22:36.000000', 'consum', 0.0219, 'lps'),
	(494291, 129, '2014-01-15 00:22:37.000000', 'consum', 0.0220, 'lps'),
	(494292, 129, '2014-01-15 00:22:38.000000', 'consum', 0.0223, 'lps'),
	(494293, 129, '2014-01-15 00:22:39.000000', 'consum', 0.0216, 'lps'),
	(494294, 129, '2014-01-15 00:22:40.000000', 'consum', 0.0214, 'lps'),
	(494295, 129, '2014-01-15 00:22:41.000000', 'consum', 0.0213, 'lps'),
	(494296, 129, '2014-01-15 00:22:42.000000', 'consum', 0.0212, 'lps'),
	(494297, 129, '2014-01-15 00:22:43.000000', 'consum', 0.0213, 'lps'),
	(494298, 129, '2014-01-15 00:22:44.000000', 'consum', 0.0218, 'lps'),
	(494299, 129, '2014-01-15 00:22:45.000000', 'consum', 0.0213, 'lps'),
	(494300, 129, '2014-01-15 00:22:46.000000', 'consum', 0.0215, 'lps'),
	(494301, 129, '2014-01-15 00:22:47.000000', 'consum', 0.0212, 'lps'),
	(494302, 129, '2014-01-15 00:22:48.000000', 'consum', 0.0219, 'lps'),
	(494303, 129, '2014-01-15 00:22:49.000000', 'consum', 0.0221, 'lps'),
	(494304, 129, '2014-01-15 00:22:50.000000', 'consum', 0.0210, 'lps'),
	(494305, 129, '2014-01-15 00:22:51.000000', 'consum', 0.0222, 'lps'),
	(494306, 129, '2014-01-15 00:22:52.000000', 'consum', 0.0214, 'lps'),
	(494307, 129, '2014-01-15 00:22:53.000000', 'consum', 0.0222, 'lps'),
	(494308, 129, '2014-01-15 00:22:54.000000', 'consum', 0.0215, 'lps'),
	(494309, 129, '2014-01-15 00:22:55.000000', 'consum', 0.0216, 'lps'),
	(494310, 129, '2014-01-15 00:22:56.000000', 'consum', 0.0212, 'lps'),
	(494311, 129, '2014-01-15 00:22:57.000000', 'consum', 0.0216, 'lps'),
	(494312, 129, '2014-01-15 00:22:58.000000', 'consum', 0.0222, 'lps'),
	(494313, 129, '2014-01-15 00:22:59.000000', 'consum', 0.0210, 'lps'),
	(494314, 129, '2014-01-15 00:23:00.000000', 'consum', 0.0214, 'lps'),
	(494315, 129, '2014-01-15 00:23:01.000000', 'consum', 0.0220, 'lps'),
	(494316, 129, '2014-01-15 00:23:02.000000', 'consum', 0.0218, 'lps'),
	(494317, 129, '2014-01-15 00:23:03.000000', 'consum', 0.0222, 'lps'),
	(494318, 129, '2014-01-15 00:23:04.000000', 'consum', 0.0220, 'lps'),
	(494319, 129, '2014-01-15 00:23:05.000000', 'consum', 0.0221, 'lps'),
	(494320, 129, '2014-01-15 00:23:06.000000', 'consum', 0.0223, 'lps'),
	(494321, 129, '2014-01-15 00:23:07.000000', 'consum', 0.0213, 'lps'),
	(494322, 129, '2014-01-15 00:23:08.000000', 'consum', 0.0214, 'lps'),
	(494323, 129, '2014-01-15 00:23:09.000000', 'consum', 0.0223, 'lps'),
	(494324, 129, '2014-01-15 00:23:10.000000', 'consum', 0.0221, 'lps'),
	(494325, 129, '2014-01-15 00:23:11.000000', 'consum', 0.0214, 'lps'),
	(494326, 129, '2014-01-15 00:23:12.000000', 'consum', 0.0213, 'lps'),
	(494327, 129, '2014-01-15 00:23:13.000000', 'consum', 0.0210, 'lps'),
	(494328, 129, '2014-01-15 00:23:14.000000', 'consum', 0.0218, 'lps'),
	(494329, 129, '2014-01-15 00:23:15.000000', 'consum', 0.0223, 'lps'),
	(494330, 129, '2014-01-15 00:23:16.000000', 'consum', 0.0222, 'lps'),
	(494331, 129, '2014-01-15 00:23:17.000000', 'consum', 0.0217, 'lps'),
	(494332, 129, '2014-01-15 00:23:18.000000', 'consum', 0.0212, 'lps'),
	(494333, 129, '2014-01-15 00:23:19.000000', 'consum', 0.0213, 'lps'),
	(494334, 129, '2014-01-15 00:23:20.000000', 'consum', 0.0218, 'lps'),
	(494335, 129, '2014-01-15 00:23:21.000000', 'consum', 0.0214, 'lps'),
	(494336, 129, '2014-01-15 00:23:22.000000', 'consum', 0.0221, 'lps'),
	(494337, 129, '2014-01-15 00:23:23.000000', 'consum', 0.0210, 'lps'),
	(494338, 129, '2014-01-15 00:23:24.000000', 'consum', 0.0221, 'lps'),
	(494339, 129, '2014-01-15 00:23:25.000000', 'consum', 0.0223, 'lps'),
	(494340, 129, '2014-01-15 00:23:26.000000', 'consum', 0.0215, 'lps'),
	(494341, 129, '2014-01-15 00:23:27.000000', 'consum', 0.0210, 'lps'),
	(494342, 129, '2014-01-15 00:23:28.000000', 'consum', 0.0211, 'lps'),
	(494343, 129, '2014-01-15 00:23:29.000000', 'consum', 0.0215, 'lps'),
	(494344, 129, '2014-01-15 00:23:30.000000', 'consum', 0.0218, 'lps'),
	(494345, 129, '2014-01-15 00:23:31.000000', 'consum', 0.0222, 'lps'),
	(494346, 129, '2014-01-15 00:23:32.000000', 'consum', 0.0220, 'lps'),
	(494347, 129, '2014-01-15 00:23:33.000000', 'consum', 0.0222, 'lps'),
	(494348, 129, '2014-01-15 00:23:34.000000', 'consum', 0.0215, 'lps'),
	(494349, 129, '2014-01-15 00:23:35.000000', 'consum', 0.0211, 'lps'),
	(494350, 129, '2014-01-15 00:23:36.000000', 'consum', 0.0216, 'lps'),
	(494351, 129, '2014-01-15 00:23:37.000000', 'consum', 0.0223, 'lps'),
	(494352, 129, '2014-01-15 00:23:38.000000', 'consum', 0.0218, 'lps'),
	(494353, 129, '2014-01-15 00:23:39.000000', 'consum', 0.0222, 'lps'),
	(494354, 129, '2014-01-15 00:23:40.000000', 'consum', 0.0219, 'lps'),
	(494355, 129, '2014-01-15 00:23:41.000000', 'consum', 0.0220, 'lps'),
	(494356, 129, '2014-01-15 00:23:42.000000', 'consum', 0.0219, 'lps'),
	(494357, 129, '2014-01-15 00:23:43.000000', 'consum', 0.0214, 'lps'),
	(494358, 129, '2014-01-15 00:23:44.000000', 'consum', 0.0216, 'lps'),
	(494359, 129, '2014-01-15 00:23:45.000000', 'consum', 0.0213, 'lps'),
	(494360, 129, '2014-01-15 00:23:46.000000', 'consum', 0.0223, 'lps'),
	(494361, 129, '2014-01-15 00:23:47.000000', 'consum', 0.0212, 'lps'),
	(494362, 129, '2014-01-15 00:23:48.000000', 'consum', 0.0221, 'lps'),
	(494363, 129, '2014-01-15 00:23:49.000000', 'consum', 0.0217, 'lps'),
	(494364, 129, '2014-01-15 00:23:50.000000', 'consum', 0.0215, 'lps'),
	(494365, 129, '2014-01-15 00:23:51.000000', 'consum', 0.0212, 'lps'),
	(494366, 129, '2014-01-15 00:23:52.000000', 'consum', 0.0219, 'lps'),
	(494367, 129, '2014-01-15 00:23:53.000000', 'consum', 0.0223, 'lps'),
	(494368, 129, '2014-01-15 00:23:54.000000', 'consum', 0.0222, 'lps'),
	(494369, 129, '2014-01-15 00:23:55.000000', 'consum', 0.0218, 'lps'),
	(494370, 129, '2014-01-15 00:23:56.000000', 'consum', 0.0211, 'lps'),
	(494371, 129, '2014-01-15 00:23:57.000000', 'consum', 0.0222, 'lps'),
	(494372, 129, '2014-01-15 00:23:58.000000', 'consum', 0.0213, 'lps'),
	(494373, 129, '2014-01-15 00:23:59.000000', 'consum', 0.0215, 'lps'),
	(494374, 129, '2014-01-15 00:24:00.000000', 'consum', 0.0213, 'lps'),
	(494375, 129, '2014-01-15 00:24:01.000000', 'consum', 0.0212, 'lps'),
	(494376, 129, '2014-01-15 00:24:02.000000', 'consum', 0.0211, 'lps'),
	(494377, 129, '2014-01-15 00:24:03.000000', 'consum', 0.0210, 'lps'),
	(494378, 129, '2014-01-15 00:24:04.000000', 'consum', 0.0222, 'lps'),
	(494379, 129, '2014-01-15 00:24:05.000000', 'consum', 0.0216, 'lps'),
	(494380, 129, '2014-01-15 00:24:06.000000', 'consum', 0.0215, 'lps'),
	(494381, 129, '2014-01-15 00:24:07.000000', 'consum', 0.0220, 'lps'),
	(494382, 129, '2014-01-15 00:24:08.000000', 'consum', 0.0216, 'lps'),
	(494383, 129, '2014-01-15 00:24:09.000000', 'consum', 0.0212, 'lps'),
	(494384, 129, '2014-01-15 00:24:10.000000', 'consum', 0.0216, 'lps'),
	(494385, 129, '2014-01-15 00:24:11.000000', 'consum', 0.0222, 'lps'),
	(494386, 129, '2014-01-15 00:24:12.000000', 'consum', 0.0211, 'lps'),
	(494387, 129, '2014-01-15 00:24:13.000000', 'consum', 0.0219, 'lps'),
	(494388, 129, '2014-01-15 00:24:14.000000', 'consum', 0.0211, 'lps'),
	(494389, 129, '2014-01-15 00:24:15.000000', 'consum', 0.0217, 'lps'),
	(494390, 129, '2014-01-15 00:24:16.000000', 'consum', 0.0214, 'lps'),
	(494391, 129, '2014-01-15 00:24:17.000000', 'consum', 0.0222, 'lps'),
	(494392, 129, '2014-01-15 00:24:18.000000', 'consum', 0.0218, 'lps'),
	(494393, 129, '2014-01-15 00:24:19.000000', 'consum', 0.0215, 'lps'),
	(494394, 129, '2014-01-15 00:24:20.000000', 'consum', 0.0212, 'lps'),
	(494395, 129, '2014-01-15 00:24:21.000000', 'consum', 0.0220, 'lps'),
	(494396, 129, '2014-01-15 00:24:22.000000', 'consum', 0.0210, 'lps'),
	(494397, 129, '2014-01-15 00:24:23.000000', 'consum', 0.0211, 'lps'),
	(494398, 129, '2014-01-15 00:24:24.000000', 'consum', 0.0214, 'lps'),
	(494399, 129, '2014-01-15 00:24:25.000000', 'consum', 0.0215, 'lps'),
	(494400, 129, '2014-01-15 00:24:26.000000', 'consum', 0.0222, 'lps'),
	(494401, 129, '2014-01-15 00:24:27.000000', 'consum', 0.0215, 'lps'),
	(494402, 129, '2014-01-15 00:24:28.000000', 'consum', 0.0212, 'lps'),
	(494403, 129, '2014-01-15 00:24:29.000000', 'consum', 0.0219, 'lps'),
	(494404, 129, '2014-01-15 00:24:30.000000', 'consum', 0.0210, 'lps'),
	(494405, 129, '2014-01-15 00:24:31.000000', 'consum', 0.0210, 'lps'),
	(494406, 129, '2014-01-15 00:24:32.000000', 'consum', 0.0212, 'lps'),
	(494407, 129, '2014-01-15 00:24:33.000000', 'consum', 0.0220, 'lps'),
	(494408, 129, '2014-01-15 00:24:34.000000', 'consum', 0.0211, 'lps'),
	(494409, 129, '2014-01-15 00:24:35.000000', 'consum', 0.0215, 'lps'),
	(494410, 129, '2014-01-15 00:24:36.000000', 'consum', 0.0219, 'lps'),
	(494411, 129, '2014-01-15 00:24:37.000000', 'consum', 0.0211, 'lps'),
	(494412, 129, '2014-01-15 00:24:38.000000', 'consum', 0.0219, 'lps'),
	(494413, 129, '2014-01-15 00:24:39.000000', 'consum', 0.0223, 'lps'),
	(494414, 129, '2014-01-15 00:24:40.000000', 'consum', 0.0222, 'lps'),
	(494415, 129, '2014-01-15 00:24:41.000000', 'consum', 0.0217, 'lps'),
	(494416, 129, '2014-01-15 00:24:42.000000', 'consum', 0.0223, 'lps'),
	(494417, 129, '2014-01-15 00:24:43.000000', 'consum', 0.0212, 'lps'),
	(494418, 129, '2014-01-15 00:24:44.000000', 'consum', 0.0212, 'lps'),
	(494419, 129, '2014-01-15 00:24:45.000000', 'consum', 0.0211, 'lps'),
	(494420, 129, '2014-01-15 00:24:46.000000', 'consum', 0.0212, 'lps'),
	(494421, 129, '2014-01-15 00:24:47.000000', 'consum', 0.0217, 'lps'),
	(494422, 129, '2014-01-15 00:24:48.000000', 'consum', 0.0210, 'lps'),
	(494423, 129, '2014-01-15 00:24:49.000000', 'consum', 0.0218, 'lps'),
	(494424, 129, '2014-01-15 00:24:50.000000', 'consum', 0.0223, 'lps'),
	(494425, 129, '2014-01-15 00:24:51.000000', 'consum', 0.0222, 'lps'),
	(494426, 129, '2014-01-15 00:24:52.000000', 'consum', 0.0220, 'lps'),
	(494427, 129, '2014-01-15 00:24:53.000000', 'consum', 0.0223, 'lps'),
	(494428, 129, '2014-01-15 00:24:54.000000', 'consum', 0.0216, 'lps'),
	(494429, 129, '2014-01-15 00:24:55.000000', 'consum', 0.0216, 'lps'),
	(494430, 129, '2014-01-15 00:24:56.000000', 'consum', 0.0210, 'lps'),
	(494431, 129, '2014-01-15 00:24:57.000000', 'consum', 0.0219, 'lps'),
	(494432, 129, '2014-01-15 00:24:58.000000', 'consum', 0.0213, 'lps'),
	(494433, 129, '2014-01-15 00:24:59.000000', 'consum', 0.0215, 'lps'),
	(494434, 129, '2014-01-15 00:25:00.000000', 'consum', 0.0213, 'lps'),
	(494435, 129, '2014-01-15 00:25:01.000000', 'consum', 0.0223, 'lps'),
	(494436, 129, '2014-01-15 00:25:02.000000', 'consum', 0.0212, 'lps'),
	(494437, 129, '2014-01-15 00:25:03.000000', 'consum', 0.0221, 'lps'),
	(494438, 129, '2014-01-15 00:25:04.000000', 'consum', 0.0219, 'lps'),
	(494439, 129, '2014-01-15 00:25:05.000000', 'consum', 0.0223, 'lps'),
	(494440, 129, '2014-01-15 00:25:06.000000', 'consum', 0.0218, 'lps'),
	(494441, 129, '2014-01-15 00:25:07.000000', 'consum', 0.0215, 'lps'),
	(494442, 129, '2014-01-15 00:25:08.000000', 'consum', 0.0223, 'lps'),
	(494443, 129, '2014-01-15 00:25:09.000000', 'consum', 0.0221, 'lps'),
	(494444, 129, '2014-01-15 00:25:10.000000', 'consum', 0.0223, 'lps'),
	(494445, 129, '2014-01-15 00:25:11.000000', 'consum', 0.0217, 'lps'),
	(494446, 129, '2014-01-15 00:25:12.000000', 'consum', 0.0219, 'lps'),
	(494447, 129, '2014-01-15 00:25:13.000000', 'consum', 0.0221, 'lps'),
	(494448, 129, '2014-01-15 00:25:14.000000', 'consum', 0.0210, 'lps'),
	(494449, 129, '2014-01-15 00:25:15.000000', 'consum', 0.0220, 'lps'),
	(494450, 129, '2014-01-15 00:25:16.000000', 'consum', 0.0218, 'lps'),
	(494451, 129, '2014-01-15 00:25:17.000000', 'consum', 0.0220, 'lps'),
	(494452, 129, '2014-01-15 00:25:18.000000', 'consum', 0.0211, 'lps'),
	(494453, 129, '2014-01-15 00:25:19.000000', 'consum', 0.0211, 'lps'),
	(494454, 129, '2014-01-15 00:25:20.000000', 'consum', 0.0215, 'lps'),
	(494455, 129, '2014-01-15 00:25:21.000000', 'consum', 0.0217, 'lps'),
	(494456, 129, '2014-01-15 00:25:22.000000', 'consum', 0.0217, 'lps'),
	(494457, 129, '2014-01-15 00:25:23.000000', 'consum', 0.0210, 'lps'),
	(494458, 129, '2014-01-15 00:25:24.000000', 'consum', 0.0219, 'lps'),
	(494459, 129, '2014-01-15 00:25:25.000000', 'consum', 0.0212, 'lps'),
	(494460, 129, '2014-01-15 00:25:26.000000', 'consum', 0.0222, 'lps'),
	(494461, 129, '2014-01-15 00:25:27.000000', 'consum', 0.0223, 'lps'),
	(494462, 129, '2014-01-15 00:25:28.000000', 'consum', 0.0210, 'lps'),
	(494463, 129, '2014-01-15 00:25:29.000000', 'consum', 0.0212, 'lps'),
	(494464, 129, '2014-01-15 00:25:30.000000', 'consum', 0.0223, 'lps'),
	(494465, 129, '2014-01-15 00:25:31.000000', 'consum', 0.0214, 'lps'),
	(494466, 129, '2014-01-15 00:25:32.000000', 'consum', 0.0219, 'lps'),
	(494467, 129, '2014-01-15 00:25:33.000000', 'consum', 0.0217, 'lps'),
	(494468, 129, '2014-01-15 00:25:34.000000', 'consum', 0.0218, 'lps'),
	(494469, 129, '2014-01-15 00:25:35.000000', 'consum', 0.0213, 'lps'),
	(494470, 129, '2014-01-15 00:25:36.000000', 'consum', 0.0217, 'lps'),
	(494471, 129, '2014-01-15 00:25:37.000000', 'consum', 0.0221, 'lps'),
	(494472, 129, '2014-01-15 00:25:38.000000', 'consum', 0.0216, 'lps'),
	(494473, 129, '2014-01-15 00:25:39.000000', 'consum', 0.0222, 'lps'),
	(494474, 129, '2014-01-15 00:25:40.000000', 'consum', 0.0212, 'lps'),
	(494475, 129, '2014-01-15 00:25:41.000000', 'consum', 0.0211, 'lps'),
	(494476, 129, '2014-01-15 00:25:42.000000', 'consum', 0.0222, 'lps'),
	(494477, 129, '2014-01-15 00:25:43.000000', 'consum', 0.0214, 'lps'),
	(494478, 129, '2014-01-15 00:25:44.000000', 'consum', 0.0220, 'lps'),
	(494479, 129, '2014-01-15 00:25:45.000000', 'consum', 0.0222, 'lps'),
	(494480, 129, '2014-01-15 00:25:46.000000', 'consum', 0.0214, 'lps'),
	(494481, 129, '2014-01-15 00:25:47.000000', 'consum', 0.0222, 'lps'),
	(494482, 129, '2014-01-15 00:25:48.000000', 'consum', 0.0217, 'lps'),
	(494483, 129, '2014-01-15 00:25:49.000000', 'consum', 0.0221, 'lps'),
	(494484, 129, '2014-01-15 00:25:50.000000', 'consum', 0.0217, 'lps'),
	(494485, 129, '2014-01-15 00:25:51.000000', 'consum', 0.0214, 'lps'),
	(494486, 129, '2014-01-15 00:25:52.000000', 'consum', 0.0210, 'lps'),
	(494487, 129, '2014-01-15 00:25:53.000000', 'consum', 0.0212, 'lps'),
	(494488, 129, '2014-01-15 00:25:54.000000', 'consum', 0.0219, 'lps'),
	(494489, 129, '2014-01-15 00:25:55.000000', 'consum', 0.0222, 'lps'),
	(494490, 129, '2014-01-15 00:25:56.000000', 'consum', 0.0214, 'lps'),
	(494491, 129, '2014-01-15 00:25:57.000000', 'consum', 0.0223, 'lps'),
	(494492, 129, '2014-01-15 00:25:58.000000', 'consum', 0.0210, 'lps'),
	(494493, 129, '2014-01-15 00:25:59.000000', 'consum', 0.0212, 'lps'),
	(494494, 129, '2014-01-15 00:26:00.000000', 'consum', 0.0219, 'lps'),
	(494495, 129, '2014-01-15 00:26:01.000000', 'consum', 0.0210, 'lps'),
	(494496, 129, '2014-01-15 00:26:02.000000', 'consum', 0.0211, 'lps'),
	(494497, 129, '2014-01-15 00:26:03.000000', 'consum', 0.0213, 'lps'),
	(494498, 129, '2014-01-15 00:26:04.000000', 'consum', 0.0211, 'lps'),
	(494499, 129, '2014-01-15 00:26:05.000000', 'consum', 0.0220, 'lps'),
	(494500, 129, '2014-01-15 00:26:06.000000', 'consum', 0.0215, 'lps'),
	(494501, 129, '2014-01-15 00:26:07.000000', 'consum', 0.0221, 'lps'),
	(494502, 129, '2014-01-15 00:26:08.000000', 'consum', 0.0222, 'lps'),
	(494503, 129, '2014-01-15 00:26:09.000000', 'consum', 0.0211, 'lps'),
	(494504, 129, '2014-01-15 00:26:10.000000', 'consum', 0.0219, 'lps'),
	(494505, 129, '2014-01-15 00:26:11.000000', 'consum', 0.0210, 'lps'),
	(494506, 129, '2014-01-15 00:26:12.000000', 'consum', 0.0214, 'lps'),
	(494507, 129, '2014-01-15 00:26:13.000000', 'consum', 0.0214, 'lps'),
	(494508, 129, '2014-01-15 00:26:14.000000', 'consum', 0.0218, 'lps'),
	(494509, 129, '2014-01-15 00:26:15.000000', 'consum', 0.0211, 'lps'),
	(494510, 129, '2014-01-15 00:26:16.000000', 'consum', 0.0221, 'lps'),
	(494511, 129, '2014-01-15 00:26:17.000000', 'consum', 0.0218, 'lps'),
	(494512, 129, '2014-01-15 00:26:18.000000', 'consum', 0.0219, 'lps'),
	(494513, 129, '2014-01-15 00:26:19.000000', 'consum', 0.0216, 'lps'),
	(494514, 129, '2014-01-15 00:26:20.000000', 'consum', 0.0214, 'lps'),
	(494515, 129, '2014-01-15 00:26:21.000000', 'consum', 0.0211, 'lps'),
	(494516, 129, '2014-01-15 00:26:22.000000', 'consum', 0.0218, 'lps'),
	(494517, 129, '2014-01-15 00:26:23.000000', 'consum', 0.0221, 'lps'),
	(494518, 129, '2014-01-15 00:26:24.000000', 'consum', 0.0214, 'lps'),
	(494519, 129, '2014-01-15 00:26:25.000000', 'consum', 0.0210, 'lps'),
	(494520, 129, '2014-01-15 00:26:26.000000', 'consum', 0.0214, 'lps'),
	(494521, 129, '2014-01-15 00:26:27.000000', 'consum', 0.0217, 'lps'),
	(494522, 129, '2014-01-15 00:26:28.000000', 'consum', 0.0220, 'lps'),
	(494523, 129, '2014-01-15 00:26:29.000000', 'consum', 0.0210, 'lps'),
	(494524, 129, '2014-01-15 00:26:30.000000', 'consum', 0.0222, 'lps'),
	(494525, 129, '2014-01-15 00:26:31.000000', 'consum', 0.0214, 'lps'),
	(494526, 129, '2014-01-15 00:26:32.000000', 'consum', 0.0211, 'lps'),
	(494527, 129, '2014-01-15 00:26:33.000000', 'consum', 0.0217, 'lps'),
	(494528, 129, '2014-01-15 00:26:34.000000', 'consum', 0.0216, 'lps'),
	(494529, 129, '2014-01-15 00:26:35.000000', 'consum', 0.0217, 'lps'),
	(494530, 129, '2014-01-15 00:26:36.000000', 'consum', 0.0214, 'lps'),
	(494531, 129, '2014-01-15 00:26:37.000000', 'consum', 0.0210, 'lps'),
	(494532, 129, '2014-01-15 00:26:38.000000', 'consum', 0.0210, 'lps'),
	(494533, 129, '2014-01-15 00:26:39.000000', 'consum', 0.0213, 'lps'),
	(494534, 129, '2014-01-15 00:26:40.000000', 'consum', 0.0212, 'lps'),
	(494535, 129, '2014-01-15 00:26:41.000000', 'consum', 0.0213, 'lps'),
	(494536, 129, '2014-01-15 00:26:42.000000', 'consum', 0.0216, 'lps'),
	(494537, 129, '2014-01-15 00:26:43.000000', 'consum', 0.0218, 'lps'),
	(494538, 129, '2014-01-15 00:26:44.000000', 'consum', 0.0219, 'lps'),
	(494539, 129, '2014-01-15 00:26:45.000000', 'consum', 0.0216, 'lps'),
	(494540, 129, '2014-01-15 00:26:46.000000', 'consum', 0.0214, 'lps'),
	(494541, 129, '2014-01-15 00:26:47.000000', 'consum', 0.0215, 'lps'),
	(494542, 129, '2014-01-15 00:26:48.000000', 'consum', 0.0222, 'lps'),
	(494543, 129, '2014-01-15 00:26:49.000000', 'consum', 0.0211, 'lps'),
	(494544, 129, '2014-01-15 00:26:50.000000', 'consum', 0.0211, 'lps'),
	(494545, 129, '2014-01-15 00:26:51.000000', 'consum', 0.0212, 'lps'),
	(494546, 129, '2014-01-15 00:26:52.000000', 'consum', 0.0218, 'lps'),
	(494547, 129, '2014-01-15 00:26:53.000000', 'consum', 0.0217, 'lps'),
	(494548, 129, '2014-01-15 00:26:54.000000', 'consum', 0.0220, 'lps'),
	(494549, 129, '2014-01-15 00:26:55.000000', 'consum', 0.0212, 'lps'),
	(494550, 129, '2014-01-15 00:26:56.000000', 'consum', 0.0218, 'lps'),
	(494551, 129, '2014-01-15 00:26:57.000000', 'consum', 0.0216, 'lps'),
	(494552, 129, '2014-01-15 00:26:58.000000', 'consum', 0.0218, 'lps'),
	(494553, 129, '2014-01-15 00:26:59.000000', 'consum', 0.0219, 'lps'),
	(494554, 129, '2014-01-15 00:27:00.000000', 'consum', 0.0217, 'lps'),
	(494555, 129, '2014-01-15 00:27:01.000000', 'consum', 0.0216, 'lps'),
	(494556, 129, '2014-01-15 00:27:02.000000', 'consum', 0.0223, 'lps'),
	(494557, 129, '2014-01-15 00:27:03.000000', 'consum', 0.0214, 'lps'),
	(494558, 129, '2014-01-15 00:27:04.000000', 'consum', 0.0218, 'lps'),
	(494559, 129, '2014-01-15 00:27:05.000000', 'consum', 0.0211, 'lps'),
	(494560, 129, '2014-01-15 00:27:06.000000', 'consum', 0.0221, 'lps'),
	(494561, 129, '2014-01-15 00:27:07.000000', 'consum', 0.0222, 'lps'),
	(494562, 129, '2014-01-15 00:27:08.000000', 'consum', 0.0221, 'lps'),
	(494563, 129, '2014-01-15 00:27:09.000000', 'consum', 0.0217, 'lps'),
	(494564, 129, '2014-01-15 00:27:10.000000', 'consum', 0.0210, 'lps'),
	(494565, 129, '2014-01-15 00:27:11.000000', 'consum', 0.0220, 'lps'),
	(494566, 129, '2014-01-15 00:27:12.000000', 'consum', 0.0217, 'lps'),
	(494567, 129, '2014-01-15 00:27:13.000000', 'consum', 0.0216, 'lps'),
	(494568, 129, '2014-01-15 00:27:14.000000', 'consum', 0.0220, 'lps'),
	(494569, 129, '2014-01-15 00:27:15.000000', 'consum', 0.0213, 'lps'),
	(494570, 129, '2014-01-15 00:27:16.000000', 'consum', 0.0210, 'lps'),
	(494571, 129, '2014-01-15 00:27:17.000000', 'consum', 0.0214, 'lps'),
	(494572, 129, '2014-01-15 00:27:18.000000', 'consum', 0.0217, 'lps'),
	(494573, 129, '2014-01-15 00:27:19.000000', 'consum', 0.0222, 'lps'),
	(494574, 129, '2014-01-15 00:27:20.000000', 'consum', 0.0219, 'lps'),
	(494575, 129, '2014-01-15 00:27:21.000000', 'consum', 0.0220, 'lps'),
	(494576, 129, '2014-01-15 00:27:22.000000', 'consum', 0.0219, 'lps'),
	(494577, 129, '2014-01-15 00:27:23.000000', 'consum', 0.0211, 'lps'),
	(494578, 129, '2014-01-15 00:27:24.000000', 'consum', 0.0219, 'lps'),
	(494579, 129, '2014-01-15 00:27:25.000000', 'consum', 0.0223, 'lps'),
	(494580, 129, '2014-01-15 00:27:26.000000', 'consum', 0.0221, 'lps'),
	(494581, 129, '2014-01-15 00:27:27.000000', 'consum', 0.0211, 'lps'),
	(494582, 129, '2014-01-15 00:27:28.000000', 'consum', 0.0213, 'lps'),
	(494583, 129, '2014-01-15 00:27:29.000000', 'consum', 0.0222, 'lps'),
	(494584, 129, '2014-01-15 00:27:30.000000', 'consum', 0.0220, 'lps'),
	(494585, 129, '2014-01-15 00:27:31.000000', 'consum', 0.0211, 'lps'),
	(494586, 129, '2014-01-15 00:27:32.000000', 'consum', 0.0214, 'lps'),
	(494587, 129, '2014-01-15 00:27:33.000000', 'consum', 0.0214, 'lps'),
	(494588, 129, '2014-01-15 00:27:34.000000', 'consum', 0.0218, 'lps'),
	(494589, 129, '2014-01-15 00:27:35.000000', 'consum', 0.0212, 'lps'),
	(494590, 129, '2014-01-15 00:27:36.000000', 'consum', 0.0222, 'lps'),
	(494591, 129, '2014-01-15 00:27:37.000000', 'consum', 0.0210, 'lps'),
	(494592, 129, '2014-01-15 00:27:38.000000', 'consum', 0.0215, 'lps'),
	(494593, 129, '2014-01-15 00:27:39.000000', 'consum', 0.0223, 'lps'),
	(494594, 129, '2014-01-15 00:27:40.000000', 'consum', 0.0219, 'lps'),
	(494595, 129, '2014-01-15 00:27:41.000000', 'consum', 0.0216, 'lps'),
	(494596, 129, '2014-01-15 00:27:42.000000', 'consum', 0.0213, 'lps'),
	(494597, 129, '2014-01-15 00:27:43.000000', 'consum', 0.0210, 'lps'),
	(494598, 129, '2014-01-15 00:27:44.000000', 'consum', 0.0213, 'lps'),
	(494599, 129, '2014-01-15 00:27:45.000000', 'consum', 0.0213, 'lps'),
	(494600, 129, '2014-01-15 00:27:46.000000', 'consum', 0.0216, 'lps'),
	(494601, 129, '2014-01-15 00:27:47.000000', 'consum', 0.0216, 'lps'),
	(494602, 129, '2014-01-15 00:27:48.000000', 'consum', 0.0210, 'lps'),
	(494603, 129, '2014-01-15 00:27:49.000000', 'consum', 0.0222, 'lps'),
	(494604, 129, '2014-01-15 00:27:50.000000', 'consum', 0.0212, 'lps'),
	(494605, 129, '2014-01-15 00:27:51.000000', 'consum', 0.0215, 'lps'),
	(494606, 129, '2014-01-15 00:27:52.000000', 'consum', 0.0216, 'lps'),
	(494607, 129, '2014-01-15 00:27:53.000000', 'consum', 0.0212, 'lps'),
	(494608, 129, '2014-01-15 00:27:54.000000', 'consum', 0.0217, 'lps'),
	(494609, 129, '2014-01-15 00:27:55.000000', 'consum', 0.0223, 'lps'),
	(494610, 129, '2014-01-15 00:27:56.000000', 'consum', 0.0214, 'lps'),
	(494611, 129, '2014-01-15 00:27:57.000000', 'consum', 0.0220, 'lps'),
	(494612, 129, '2014-01-15 00:27:58.000000', 'consum', 0.0219, 'lps'),
	(494613, 129, '2014-01-15 00:27:59.000000', 'consum', 0.0210, 'lps'),
	(494614, 129, '2014-01-15 00:28:00.000000', 'consum', 0.0213, 'lps'),
	(494615, 129, '2014-01-15 00:28:01.000000', 'consum', 0.0211, 'lps'),
	(494616, 129, '2014-01-15 00:28:02.000000', 'consum', 0.0221, 'lps'),
	(494617, 129, '2014-01-15 00:28:03.000000', 'consum', 0.0221, 'lps'),
	(494618, 129, '2014-01-15 00:28:04.000000', 'consum', 0.0217, 'lps'),
	(494619, 129, '2014-01-15 00:28:05.000000', 'consum', 0.0214, 'lps'),
	(494620, 129, '2014-01-15 00:28:06.000000', 'consum', 0.0222, 'lps'),
	(494621, 129, '2014-01-15 00:28:07.000000', 'consum', 0.0218, 'lps'),
	(494622, 129, '2014-01-15 00:28:08.000000', 'consum', 0.0214, 'lps'),
	(494623, 129, '2014-01-15 00:28:09.000000', 'consum', 0.0222, 'lps'),
	(494624, 129, '2014-01-15 00:28:10.000000', 'consum', 0.0215, 'lps'),
	(494625, 129, '2014-01-15 00:28:11.000000', 'consum', 0.0212, 'lps'),
	(494626, 129, '2014-01-15 00:28:12.000000', 'consum', 0.0221, 'lps'),
	(494627, 129, '2014-01-15 00:28:13.000000', 'consum', 0.0215, 'lps'),
	(494628, 129, '2014-01-15 00:28:14.000000', 'consum', 0.0220, 'lps'),
	(494629, 129, '2014-01-15 00:28:15.000000', 'consum', 0.0216, 'lps'),
	(494630, 129, '2014-01-15 00:28:16.000000', 'consum', 0.0223, 'lps'),
	(494631, 129, '2014-01-15 00:28:17.000000', 'consum', 0.0214, 'lps'),
	(494632, 129, '2014-01-15 00:28:18.000000', 'consum', 0.0223, 'lps'),
	(494633, 129, '2014-01-15 00:28:19.000000', 'consum', 0.0222, 'lps'),
	(494634, 129, '2014-01-15 00:28:20.000000', 'consum', 0.0218, 'lps'),
	(494635, 129, '2014-01-15 00:28:21.000000', 'consum', 0.0212, 'lps'),
	(494636, 129, '2014-01-15 00:28:22.000000', 'consum', 0.0213, 'lps'),
	(494637, 129, '2014-01-15 00:28:23.000000', 'consum', 0.0219, 'lps'),
	(494638, 129, '2014-01-15 00:28:24.000000', 'consum', 0.0218, 'lps'),
	(494639, 129, '2014-01-15 00:28:25.000000', 'consum', 0.0222, 'lps'),
	(494640, 129, '2014-01-15 00:28:26.000000', 'consum', 0.0220, 'lps'),
	(494641, 129, '2014-01-15 00:28:27.000000', 'consum', 0.0212, 'lps'),
	(494642, 129, '2014-01-15 00:28:28.000000', 'consum', 0.0218, 'lps'),
	(494643, 129, '2014-01-15 00:28:29.000000', 'consum', 0.0215, 'lps'),
	(494644, 129, '2014-01-15 00:28:30.000000', 'consum', 0.0211, 'lps'),
	(494645, 129, '2014-01-15 00:28:31.000000', 'consum', 0.0214, 'lps'),
	(494646, 129, '2014-01-15 00:28:32.000000', 'consum', 0.0217, 'lps'),
	(494647, 129, '2014-01-15 00:28:33.000000', 'consum', 0.0216, 'lps'),
	(494648, 129, '2014-01-15 00:28:34.000000', 'consum', 0.0219, 'lps'),
	(494649, 129, '2014-01-15 00:28:35.000000', 'consum', 0.0213, 'lps'),
	(494650, 129, '2014-01-15 00:28:36.000000', 'consum', 0.0210, 'lps'),
	(494651, 129, '2014-01-15 00:28:37.000000', 'consum', 0.0215, 'lps'),
	(494652, 129, '2014-01-15 00:28:38.000000', 'consum', 0.0222, 'lps'),
	(494653, 129, '2014-01-15 00:28:39.000000', 'consum', 0.0214, 'lps'),
	(494654, 129, '2014-01-15 00:28:40.000000', 'consum', 0.0222, 'lps'),
	(494655, 129, '2014-01-15 00:28:41.000000', 'consum', 0.0218, 'lps'),
	(494656, 129, '2014-01-15 00:28:42.000000', 'consum', 0.0215, 'lps'),
	(494657, 129, '2014-01-15 00:28:43.000000', 'consum', 0.0212, 'lps'),
	(494658, 129, '2014-01-15 00:28:44.000000', 'consum', 0.0219, 'lps'),
	(494659, 129, '2014-01-15 00:28:45.000000', 'consum', 0.0223, 'lps'),
	(494660, 129, '2014-01-15 00:28:46.000000', 'consum', 0.0217, 'lps'),
	(494661, 129, '2014-01-15 00:28:47.000000', 'consum', 0.0223, 'lps'),
	(494662, 129, '2014-01-15 00:28:48.000000', 'consum', 0.0211, 'lps'),
	(494663, 129, '2014-01-15 00:28:49.000000', 'consum', 0.0220, 'lps'),
	(494664, 129, '2014-01-15 00:28:50.000000', 'consum', 0.0215, 'lps'),
	(494665, 129, '2014-01-15 00:28:51.000000', 'consum', 0.0218, 'lps'),
	(494666, 129, '2014-01-15 00:28:52.000000', 'consum', 0.0221, 'lps'),
	(494667, 129, '2014-01-15 00:28:53.000000', 'consum', 0.0216, 'lps'),
	(494668, 129, '2014-01-15 00:28:54.000000', 'consum', 0.0220, 'lps'),
	(494669, 129, '2014-01-15 00:28:55.000000', 'consum', 0.0216, 'lps'),
	(494670, 129, '2014-01-15 00:28:56.000000', 'consum', 0.0222, 'lps'),
	(494671, 129, '2014-01-15 00:28:57.000000', 'consum', 0.0212, 'lps'),
	(494672, 129, '2014-01-15 00:28:58.000000', 'consum', 0.0210, 'lps'),
	(494673, 129, '2014-01-15 00:28:59.000000', 'consum', 0.0221, 'lps'),
	(494674, 129, '2014-01-15 00:29:00.000000', 'consum', 0.0221, 'lps'),
	(494675, 129, '2014-01-15 00:29:01.000000', 'consum', 0.0221, 'lps'),
	(494676, 129, '2014-01-15 00:29:02.000000', 'consum', 0.0216, 'lps'),
	(494677, 129, '2014-01-15 00:29:03.000000', 'consum', 0.0210, 'lps'),
	(494678, 129, '2014-01-15 00:29:04.000000', 'consum', 0.0219, 'lps'),
	(494679, 129, '2014-01-15 00:29:05.000000', 'consum', 0.0213, 'lps'),
	(494680, 129, '2014-01-15 00:29:06.000000', 'consum', 0.0212, 'lps'),
	(494681, 129, '2014-01-15 00:29:07.000000', 'consum', 0.0214, 'lps'),
	(494682, 129, '2014-01-15 00:29:08.000000', 'consum', 0.0223, 'lps'),
	(494683, 129, '2014-01-15 00:29:09.000000', 'consum', 0.0222, 'lps'),
	(494684, 129, '2014-01-15 00:29:10.000000', 'consum', 0.0215, 'lps'),
	(494685, 129, '2014-01-15 00:29:11.000000', 'consum', 0.0217, 'lps'),
	(494686, 129, '2014-01-15 00:29:12.000000', 'consum', 0.0216, 'lps'),
	(494687, 129, '2014-01-15 00:29:13.000000', 'consum', 0.0218, 'lps'),
	(494688, 129, '2014-01-15 00:29:14.000000', 'consum', 0.0219, 'lps'),
	(494689, 129, '2014-01-15 00:29:15.000000', 'consum', 0.0216, 'lps'),
	(494690, 129, '2014-01-15 00:29:16.000000', 'consum', 0.0217, 'lps'),
	(494691, 129, '2014-01-15 00:29:17.000000', 'consum', 0.0210, 'lps'),
	(494692, 129, '2014-01-15 00:29:18.000000', 'consum', 0.0217, 'lps'),
	(494693, 129, '2014-01-15 00:29:19.000000', 'consum', 0.0221, 'lps'),
	(494694, 129, '2014-01-15 00:29:20.000000', 'consum', 0.0213, 'lps'),
	(494695, 129, '2014-01-15 00:29:21.000000', 'consum', 0.0223, 'lps'),
	(494696, 129, '2014-01-15 00:29:22.000000', 'consum', 0.0211, 'lps'),
	(494697, 129, '2014-01-15 00:29:23.000000', 'consum', 0.0217, 'lps'),
	(494698, 129, '2014-01-15 00:29:24.000000', 'consum', 0.0214, 'lps'),
	(494699, 129, '2014-01-15 00:29:25.000000', 'consum', 0.0211, 'lps'),
	(494700, 129, '2014-01-15 00:29:26.000000', 'consum', 0.0217, 'lps'),
	(494701, 129, '2014-01-15 00:29:27.000000', 'consum', 0.0214, 'lps'),
	(494702, 129, '2014-01-15 00:29:28.000000', 'consum', 0.0223, 'lps'),
	(494703, 129, '2014-01-15 00:29:29.000000', 'consum', 0.0210, 'lps'),
	(494704, 129, '2014-01-15 00:29:30.000000', 'consum', 0.0211, 'lps'),
	(494705, 129, '2014-01-15 00:29:31.000000', 'consum', 0.0216, 'lps'),
	(494706, 129, '2014-01-15 00:29:32.000000', 'consum', 0.0211, 'lps'),
	(494707, 129, '2014-01-15 00:29:33.000000', 'consum', 0.0212, 'lps'),
	(494708, 129, '2014-01-15 00:29:34.000000', 'consum', 0.0215, 'lps'),
	(494709, 129, '2014-01-15 00:29:35.000000', 'consum', 0.0217, 'lps'),
	(494710, 129, '2014-01-15 00:29:36.000000', 'consum', 0.0217, 'lps'),
	(494711, 129, '2014-01-15 00:29:37.000000', 'consum', 0.0212, 'lps'),
	(494712, 129, '2014-01-15 00:29:38.000000', 'consum', 0.0212, 'lps'),
	(494713, 129, '2014-01-15 00:29:39.000000', 'consum', 0.0216, 'lps'),
	(494714, 129, '2014-01-15 00:29:40.000000', 'consum', 0.0219, 'lps'),
	(494715, 129, '2014-01-15 00:29:41.000000', 'consum', 0.0222, 'lps'),
	(494716, 129, '2014-01-15 00:29:42.000000', 'consum', 0.0216, 'lps'),
	(494717, 129, '2014-01-15 00:29:43.000000', 'consum', 0.0218, 'lps'),
	(494718, 129, '2014-01-15 00:29:44.000000', 'consum', 0.0219, 'lps'),
	(494719, 129, '2014-01-15 00:29:45.000000', 'consum', 0.0219, 'lps'),
	(494720, 129, '2014-01-15 00:29:46.000000', 'consum', 0.0212, 'lps'),
	(494721, 129, '2014-01-15 00:29:47.000000', 'consum', 0.0222, 'lps'),
	(494722, 129, '2014-01-15 00:29:48.000000', 'consum', 0.0222, 'lps'),
	(494723, 129, '2014-01-15 00:29:49.000000', 'consum', 0.0222, 'lps'),
	(494724, 129, '2014-01-15 00:29:50.000000', 'consum', 0.0221, 'lps'),
	(494725, 129, '2014-01-15 00:29:51.000000', 'consum', 0.0216, 'lps'),
	(494726, 129, '2014-01-15 00:29:52.000000', 'consum', 0.0220, 'lps'),
	(494727, 129, '2014-01-15 00:29:53.000000', 'consum', 0.0213, 'lps'),
	(494728, 129, '2014-01-15 00:29:54.000000', 'consum', 0.0212, 'lps'),
	(494729, 129, '2014-01-15 00:29:55.000000', 'consum', 0.0223, 'lps'),
	(494730, 129, '2014-01-15 00:29:56.000000', 'consum', 0.0213, 'lps'),
	(494731, 129, '2014-01-15 00:29:57.000000', 'consum', 0.0216, 'lps'),
	(494732, 129, '2014-01-15 00:29:58.000000', 'consum', 0.0217, 'lps'),
	(494733, 129, '2014-01-15 00:29:59.000000', 'consum', 0.0214, 'lps'),
	(494734, 129, '2014-01-15 00:30:00.000000', 'consum', 0.0222, 'lps'),
	(494735, 129, '2014-01-15 00:30:01.000000', 'consum', 0.0217, 'lps'),
	(494736, 129, '2014-01-15 00:30:02.000000', 'consum', 0.0210, 'lps'),
	(494737, 129, '2014-01-15 00:30:03.000000', 'consum', 0.0216, 'lps'),
	(494738, 129, '2014-01-15 00:30:04.000000', 'consum', 0.0215, 'lps'),
	(494739, 129, '2014-01-15 00:30:05.000000', 'consum', 0.0215, 'lps'),
	(494740, 129, '2014-01-15 00:30:06.000000', 'consum', 0.0222, 'lps'),
	(494741, 129, '2014-01-15 00:30:07.000000', 'consum', 0.0214, 'lps'),
	(494742, 129, '2014-01-15 00:30:08.000000', 'consum', 0.0221, 'lps'),
	(494743, 129, '2014-01-15 00:30:09.000000', 'consum', 0.0213, 'lps'),
	(494744, 129, '2014-01-15 00:30:10.000000', 'consum', 0.0219, 'lps'),
	(494745, 129, '2014-01-15 00:30:11.000000', 'consum', 0.0219, 'lps'),
	(494746, 129, '2014-01-15 00:30:12.000000', 'consum', 0.0213, 'lps'),
	(494747, 129, '2014-01-15 00:30:13.000000', 'consum', 0.0214, 'lps'),
	(494748, 129, '2014-01-15 00:30:14.000000', 'consum', 0.0220, 'lps'),
	(494749, 129, '2014-01-15 00:30:15.000000', 'consum', 0.0221, 'lps'),
	(494750, 129, '2014-01-15 00:30:16.000000', 'consum', 0.0221, 'lps'),
	(494751, 129, '2014-01-15 00:30:17.000000', 'consum', 0.0219, 'lps'),
	(494752, 129, '2014-01-15 00:30:18.000000', 'consum', 0.0221, 'lps'),
	(494753, 129, '2014-01-15 00:30:19.000000', 'consum', 0.0211, 'lps'),
	(494754, 129, '2014-01-15 00:30:20.000000', 'consum', 0.0212, 'lps'),
	(494755, 129, '2014-01-15 00:30:21.000000', 'consum', 0.0215, 'lps'),
	(494756, 129, '2014-01-15 00:30:22.000000', 'consum', 0.0216, 'lps'),
	(494757, 129, '2014-01-15 00:30:23.000000', 'consum', 0.0211, 'lps'),
	(494758, 129, '2014-01-15 00:30:24.000000', 'consum', 0.0211, 'lps'),
	(494759, 129, '2014-01-15 00:30:25.000000', 'consum', 0.0212, 'lps'),
	(494760, 129, '2014-01-15 00:30:26.000000', 'consum', 0.0217, 'lps'),
	(494761, 129, '2014-01-15 00:30:27.000000', 'consum', 0.0214, 'lps'),
	(494762, 129, '2014-01-15 00:30:28.000000', 'consum', 0.0221, 'lps'),
	(494763, 129, '2014-01-15 00:30:29.000000', 'consum', 0.0214, 'lps'),
	(494764, 129, '2014-01-15 00:30:30.000000', 'consum', 0.0223, 'lps'),
	(494765, 129, '2014-01-15 00:30:31.000000', 'consum', 0.0220, 'lps'),
	(494766, 129, '2014-01-15 00:30:32.000000', 'consum', 0.0211, 'lps'),
	(494767, 129, '2014-01-15 00:30:33.000000', 'consum', 0.0212, 'lps'),
	(494768, 129, '2014-01-15 00:30:34.000000', 'consum', 0.0218, 'lps'),
	(494769, 129, '2014-01-15 00:30:35.000000', 'consum', 0.0217, 'lps'),
	(494770, 129, '2014-01-15 00:30:36.000000', 'consum', 0.0222, 'lps'),
	(494771, 129, '2014-01-15 00:30:37.000000', 'consum', 0.0220, 'lps'),
	(494772, 129, '2014-01-15 00:30:38.000000', 'consum', 0.0223, 'lps'),
	(494773, 129, '2014-01-15 00:30:39.000000', 'consum', 0.0219, 'lps'),
	(494774, 129, '2014-01-15 00:30:40.000000', 'consum', 0.0218, 'lps'),
	(494775, 129, '2014-01-15 00:30:41.000000', 'consum', 0.0222, 'lps'),
	(494776, 129, '2014-01-15 00:30:42.000000', 'consum', 0.0218, 'lps'),
	(494777, 129, '2014-01-15 00:30:43.000000', 'consum', 0.0215, 'lps'),
	(494778, 129, '2014-01-15 00:30:44.000000', 'consum', 0.0211, 'lps'),
	(494779, 129, '2014-01-15 00:30:45.000000', 'consum', 0.0214, 'lps'),
	(494780, 129, '2014-01-15 00:30:46.000000', 'consum', 0.0215, 'lps'),
	(494781, 129, '2014-01-15 00:30:47.000000', 'consum', 0.0222, 'lps'),
	(494782, 129, '2014-01-15 00:30:48.000000', 'consum', 0.0216, 'lps'),
	(494783, 129, '2014-01-15 00:30:49.000000', 'consum', 0.0216, 'lps'),
	(494784, 129, '2014-01-15 00:30:50.000000', 'consum', 0.0211, 'lps'),
	(494785, 129, '2014-01-15 00:30:51.000000', 'consum', 0.0223, 'lps'),
	(494786, 129, '2014-01-15 00:30:52.000000', 'consum', 0.0217, 'lps'),
	(494787, 129, '2014-01-15 00:30:53.000000', 'consum', 0.0221, 'lps'),
	(494788, 129, '2014-01-15 00:30:54.000000', 'consum', 0.0218, 'lps'),
	(494789, 129, '2014-01-15 00:30:55.000000', 'consum', 0.0216, 'lps'),
	(494790, 129, '2014-01-15 00:30:56.000000', 'consum', 0.0216, 'lps'),
	(494791, 129, '2014-01-15 00:30:57.000000', 'consum', 0.0222, 'lps'),
	(494792, 129, '2014-01-15 00:30:58.000000', 'consum', 0.0212, 'lps'),
	(494793, 129, '2014-01-15 00:30:59.000000', 'consum', 0.0211, 'lps'),
	(494794, 129, '2014-01-15 00:31:00.000000', 'consum', 0.0211, 'lps'),
	(494795, 129, '2014-01-15 00:31:01.000000', 'consum', 0.0212, 'lps'),
	(494796, 129, '2014-01-15 00:31:02.000000', 'consum', 0.0216, 'lps'),
	(494797, 129, '2014-01-15 00:31:03.000000', 'consum', 0.0221, 'lps'),
	(494798, 129, '2014-01-15 00:31:04.000000', 'consum', 0.0221, 'lps'),
	(494799, 129, '2014-01-15 00:31:05.000000', 'consum', 0.0216, 'lps'),
	(494800, 129, '2014-01-15 00:31:06.000000', 'consum', 0.0211, 'lps'),
	(494801, 129, '2014-01-15 00:31:07.000000', 'consum', 0.0222, 'lps'),
	(494802, 129, '2014-01-15 00:31:08.000000', 'consum', 0.0213, 'lps'),
	(494803, 129, '2014-01-15 00:31:09.000000', 'consum', 0.0216, 'lps'),
	(494804, 129, '2014-01-15 00:31:10.000000', 'consum', 0.0220, 'lps'),
	(494805, 129, '2014-01-15 00:31:11.000000', 'consum', 0.0214, 'lps'),
	(494806, 129, '2014-01-15 00:31:12.000000', 'consum', 0.0213, 'lps'),
	(494807, 129, '2014-01-15 00:31:13.000000', 'consum', 0.0213, 'lps'),
	(494808, 129, '2014-01-15 00:31:14.000000', 'consum', 0.0219, 'lps'),
	(494809, 129, '2014-01-15 00:31:15.000000', 'consum', 0.0215, 'lps'),
	(494810, 129, '2014-01-15 00:31:16.000000', 'consum', 0.0212, 'lps'),
	(494811, 129, '2014-01-15 00:31:17.000000', 'consum', 0.0218, 'lps'),
	(494812, 129, '2014-01-15 00:31:18.000000', 'consum', 0.0218, 'lps'),
	(494813, 129, '2014-01-15 00:31:19.000000', 'consum', 0.0211, 'lps'),
	(494814, 129, '2014-01-15 00:31:20.000000', 'consum', 0.0218, 'lps'),
	(494815, 129, '2014-01-15 00:31:21.000000', 'consum', 0.0222, 'lps'),
	(494816, 129, '2014-01-15 00:31:22.000000', 'consum', 0.0216, 'lps'),
	(494817, 129, '2014-01-15 00:31:23.000000', 'consum', 0.0218, 'lps'),
	(494818, 129, '2014-01-15 00:31:24.000000', 'consum', 0.0218, 'lps'),
	(494819, 129, '2014-01-15 00:31:25.000000', 'consum', 0.0215, 'lps'),
	(494820, 129, '2014-01-15 00:31:26.000000', 'consum', 0.0210, 'lps'),
	(494821, 129, '2014-01-15 00:31:27.000000', 'consum', 0.0223, 'lps'),
	(494822, 129, '2014-01-15 00:31:28.000000', 'consum', 0.0218, 'lps'),
	(494823, 129, '2014-01-15 00:31:29.000000', 'consum', 0.0214, 'lps'),
	(494824, 129, '2014-01-15 00:31:30.000000', 'consum', 0.0222, 'lps'),
	(494825, 129, '2014-01-15 00:31:31.000000', 'consum', 0.0214, 'lps'),
	(494826, 129, '2014-01-15 00:31:32.000000', 'consum', 0.0210, 'lps'),
	(494827, 129, '2014-01-15 00:31:33.000000', 'consum', 0.0210, 'lps'),
	(494828, 129, '2014-01-15 00:31:34.000000', 'consum', 0.0211, 'lps'),
	(494829, 129, '2014-01-15 00:31:35.000000', 'consum', 0.0218, 'lps'),
	(494830, 129, '2014-01-15 00:31:36.000000', 'consum', 0.0217, 'lps'),
	(494831, 129, '2014-01-15 00:31:37.000000', 'consum', 0.0210, 'lps'),
	(494832, 129, '2014-01-15 00:31:38.000000', 'consum', 0.0217, 'lps'),
	(494833, 129, '2014-01-15 00:31:39.000000', 'consum', 0.0216, 'lps'),
	(494834, 129, '2014-01-15 00:31:40.000000', 'consum', 0.0219, 'lps'),
	(494835, 129, '2014-01-15 00:31:41.000000', 'consum', 0.0223, 'lps'),
	(494836, 129, '2014-01-15 00:31:42.000000', 'consum', 0.0223, 'lps'),
	(494837, 129, '2014-01-15 00:31:43.000000', 'consum', 0.0223, 'lps'),
	(494838, 129, '2014-01-15 00:31:44.000000', 'consum', 0.0220, 'lps'),
	(494839, 129, '2014-01-15 00:31:45.000000', 'consum', 0.0210, 'lps'),
	(494840, 129, '2014-01-15 00:31:46.000000', 'consum', 0.0222, 'lps'),
	(494841, 129, '2014-01-15 00:31:47.000000', 'consum', 0.0214, 'lps'),
	(494842, 129, '2014-01-15 00:31:48.000000', 'consum', 0.0210, 'lps'),
	(494843, 129, '2014-01-15 00:31:49.000000', 'consum', 0.0213, 'lps'),
	(494844, 129, '2014-01-15 00:31:50.000000', 'consum', 0.0211, 'lps'),
	(494845, 129, '2014-01-15 00:31:51.000000', 'consum', 0.0221, 'lps'),
	(494846, 129, '2014-01-15 00:31:52.000000', 'consum', 0.0221, 'lps'),
	(494847, 129, '2014-01-15 00:31:53.000000', 'consum', 0.0220, 'lps'),
	(494848, 129, '2014-01-15 00:31:54.000000', 'consum', 0.0211, 'lps'),
	(494849, 129, '2014-01-15 00:31:55.000000', 'consum', 0.0215, 'lps'),
	(494850, 129, '2014-01-15 00:31:56.000000', 'consum', 0.0219, 'lps'),
	(494851, 129, '2014-01-15 00:31:57.000000', 'consum', 0.0213, 'lps'),
	(494852, 129, '2014-01-15 00:31:58.000000', 'consum', 0.0212, 'lps'),
	(494853, 129, '2014-01-15 00:31:59.000000', 'consum', 0.0210, 'lps'),
	(494854, 129, '2014-01-15 00:32:00.000000', 'consum', 0.0219, 'lps'),
	(494855, 129, '2014-01-15 00:32:01.000000', 'consum', 0.0214, 'lps'),
	(494856, 129, '2014-01-15 00:32:02.000000', 'consum', 0.0219, 'lps'),
	(494857, 129, '2014-01-15 00:32:03.000000', 'consum', 0.0214, 'lps'),
	(494858, 129, '2014-01-15 00:32:04.000000', 'consum', 0.0218, 'lps'),
	(494859, 129, '2014-01-15 00:32:05.000000', 'consum', 0.0210, 'lps'),
	(494860, 129, '2014-01-15 00:32:06.000000', 'consum', 0.0214, 'lps'),
	(494861, 129, '2014-01-15 00:32:07.000000', 'consum', 0.0216, 'lps'),
	(494862, 129, '2014-01-15 00:32:08.000000', 'consum', 0.0214, 'lps'),
	(494863, 129, '2014-01-15 00:32:09.000000', 'consum', 0.0215, 'lps'),
	(494864, 129, '2014-01-15 00:32:10.000000', 'consum', 0.0210, 'lps'),
	(494865, 129, '2014-01-15 00:32:11.000000', 'consum', 0.0223, 'lps'),
	(494866, 129, '2014-01-15 00:32:12.000000', 'consum', 0.0218, 'lps'),
	(494867, 129, '2014-01-15 00:32:13.000000', 'consum', 0.0211, 'lps'),
	(494868, 129, '2014-01-15 00:32:14.000000', 'consum', 0.0219, 'lps'),
	(494869, 129, '2014-01-15 00:32:15.000000', 'consum', 0.0212, 'lps'),
	(494870, 129, '2014-01-15 00:32:16.000000', 'consum', 0.0221, 'lps'),
	(494871, 129, '2014-01-15 00:32:17.000000', 'consum', 0.0216, 'lps'),
	(494872, 129, '2014-01-15 00:32:18.000000', 'consum', 0.0222, 'lps'),
	(494873, 129, '2014-01-15 00:32:19.000000', 'consum', 0.0211, 'lps'),
	(494874, 129, '2014-01-15 00:32:20.000000', 'consum', 0.0220, 'lps'),
	(494875, 129, '2014-01-15 00:32:21.000000', 'consum', 0.0218, 'lps'),
	(494876, 129, '2014-01-15 00:32:22.000000', 'consum', 0.0218, 'lps'),
	(494877, 129, '2014-01-15 00:32:23.000000', 'consum', 0.0214, 'lps'),
	(494878, 129, '2014-01-15 00:32:24.000000', 'consum', 0.0218, 'lps'),
	(494879, 129, '2014-01-15 00:32:25.000000', 'consum', 0.0214, 'lps'),
	(494880, 129, '2014-01-15 00:32:26.000000', 'consum', 0.0218, 'lps'),
	(494881, 129, '2014-01-15 00:32:27.000000', 'consum', 0.0210, 'lps'),
	(494882, 129, '2014-01-15 00:32:28.000000', 'consum', 0.0215, 'lps'),
	(494883, 129, '2014-01-15 00:32:29.000000', 'consum', 0.0221, 'lps'),
	(494884, 129, '2014-01-15 00:32:30.000000', 'consum', 0.0210, 'lps'),
	(494885, 129, '2014-01-15 00:32:31.000000', 'consum', 0.0221, 'lps'),
	(494886, 129, '2014-01-15 00:32:32.000000', 'consum', 0.0221, 'lps'),
	(494887, 129, '2014-01-15 00:32:33.000000', 'consum', 0.0219, 'lps'),
	(494888, 129, '2014-01-15 00:32:34.000000', 'consum', 0.0211, 'lps'),
	(494889, 129, '2014-01-15 00:32:35.000000', 'consum', 0.0213, 'lps'),
	(494890, 129, '2014-01-15 00:32:36.000000', 'consum', 0.0210, 'lps'),
	(494891, 129, '2014-01-15 00:32:37.000000', 'consum', 0.0216, 'lps'),
	(494892, 129, '2014-01-15 00:32:38.000000', 'consum', 0.0213, 'lps'),
	(494893, 129, '2014-01-15 00:32:39.000000', 'consum', 0.0223, 'lps'),
	(494894, 129, '2014-01-15 00:32:40.000000', 'consum', 0.0222, 'lps'),
	(494895, 129, '2014-01-15 00:32:41.000000', 'consum', 0.0219, 'lps'),
	(494896, 129, '2014-01-15 00:32:42.000000', 'consum', 0.0217, 'lps'),
	(494897, 129, '2014-01-15 00:32:43.000000', 'consum', 0.0220, 'lps'),
	(494898, 129, '2014-01-15 00:32:44.000000', 'consum', 0.0212, 'lps'),
	(494899, 129, '2014-01-15 00:32:45.000000', 'consum', 0.0219, 'lps'),
	(494900, 129, '2014-01-15 00:32:46.000000', 'consum', 0.0219, 'lps'),
	(494901, 129, '2014-01-15 00:32:47.000000', 'consum', 0.0216, 'lps'),
	(494902, 129, '2014-01-15 00:32:48.000000', 'consum', 0.0214, 'lps'),
	(494903, 129, '2014-01-15 00:32:49.000000', 'consum', 0.0212, 'lps'),
	(494904, 129, '2014-01-15 00:32:50.000000', 'consum', 0.0210, 'lps'),
	(494905, 129, '2014-01-15 00:32:51.000000', 'consum', 0.0218, 'lps'),
	(494906, 129, '2014-01-15 00:32:52.000000', 'consum', 0.0220, 'lps'),
	(494907, 129, '2014-01-15 00:32:53.000000', 'consum', 0.0210, 'lps'),
	(494908, 129, '2014-01-15 00:32:54.000000', 'consum', 0.0223, 'lps'),
	(494909, 129, '2014-01-15 00:32:55.000000', 'consum', 0.0218, 'lps'),
	(494910, 129, '2014-01-15 00:32:56.000000', 'consum', 0.0214, 'lps'),
	(494911, 129, '2014-01-15 00:32:57.000000', 'consum', 0.0221, 'lps'),
	(494912, 129, '2014-01-15 00:32:58.000000', 'consum', 0.0211, 'lps'),
	(494913, 129, '2014-01-15 00:32:59.000000', 'consum', 0.0211, 'lps'),
	(494914, 129, '2014-01-15 00:33:00.000000', 'consum', 0.0212, 'lps'),
	(494915, 129, '2014-01-15 00:33:01.000000', 'consum', 0.0216, 'lps'),
	(494916, 129, '2014-01-15 00:33:02.000000', 'consum', 0.0222, 'lps'),
	(494917, 129, '2014-01-15 00:33:03.000000', 'consum', 0.0211, 'lps'),
	(494918, 129, '2014-01-15 00:33:04.000000', 'consum', 0.0219, 'lps'),
	(494919, 129, '2014-01-15 00:33:05.000000', 'consum', 0.0211, 'lps'),
	(494920, 129, '2014-01-15 00:33:06.000000', 'consum', 0.0218, 'lps'),
	(494921, 129, '2014-01-15 00:33:07.000000', 'consum', 0.0220, 'lps'),
	(494922, 129, '2014-01-15 00:33:08.000000', 'consum', 0.0221, 'lps'),
	(494923, 129, '2014-01-15 00:33:09.000000', 'consum', 0.0210, 'lps'),
	(494924, 129, '2014-01-15 00:33:10.000000', 'consum', 0.0218, 'lps'),
	(494925, 129, '2014-01-15 00:33:11.000000', 'consum', 0.0211, 'lps'),
	(494926, 129, '2014-01-15 00:33:12.000000', 'consum', 0.0216, 'lps'),
	(494927, 129, '2014-01-15 00:33:13.000000', 'consum', 0.0211, 'lps'),
	(494928, 129, '2014-01-15 00:33:14.000000', 'consum', 0.0212, 'lps'),
	(494929, 129, '2014-01-15 00:33:15.000000', 'consum', 0.0217, 'lps'),
	(494930, 129, '2014-01-15 00:33:16.000000', 'consum', 0.0213, 'lps'),
	(494931, 129, '2014-01-15 00:33:17.000000', 'consum', 0.0219, 'lps'),
	(494932, 129, '2014-01-15 00:33:18.000000', 'consum', 0.0218, 'lps'),
	(494933, 129, '2014-01-15 00:33:19.000000', 'consum', 0.0210, 'lps'),
	(494934, 129, '2014-01-15 00:33:20.000000', 'consum', 0.0214, 'lps'),
	(494935, 129, '2014-01-15 00:33:21.000000', 'consum', 0.0217, 'lps'),
	(494936, 129, '2014-01-15 00:33:22.000000', 'consum', 0.0220, 'lps'),
	(494937, 129, '2014-01-15 00:33:23.000000', 'consum', 0.0212, 'lps'),
	(494938, 129, '2014-01-15 00:33:24.000000', 'consum', 0.0216, 'lps'),
	(494939, 129, '2014-01-15 00:33:25.000000', 'consum', 0.0221, 'lps'),
	(494940, 129, '2014-01-15 00:33:26.000000', 'consum', 0.0219, 'lps'),
	(494941, 129, '2014-01-15 00:33:27.000000', 'consum', 0.0221, 'lps'),
	(494942, 129, '2014-01-15 00:33:28.000000', 'consum', 0.0214, 'lps'),
	(494943, 129, '2014-01-15 00:33:29.000000', 'consum', 0.0210, 'lps'),
	(494944, 129, '2014-01-15 00:33:30.000000', 'consum', 0.0212, 'lps'),
	(494945, 129, '2014-01-15 00:33:31.000000', 'consum', 0.0220, 'lps'),
	(494946, 129, '2014-01-15 00:33:32.000000', 'consum', 0.0213, 'lps'),
	(494947, 129, '2014-01-15 00:33:33.000000', 'consum', 0.0223, 'lps'),
	(494948, 129, '2014-01-15 00:33:34.000000', 'consum', 0.0211, 'lps'),
	(494949, 129, '2014-01-15 00:33:35.000000', 'consum', 0.0219, 'lps'),
	(494950, 129, '2014-01-15 00:33:36.000000', 'consum', 0.0211, 'lps'),
	(494951, 129, '2014-01-15 00:33:37.000000', 'consum', 0.0216, 'lps'),
	(494952, 129, '2014-01-15 00:33:38.000000', 'consum', 0.0223, 'lps'),
	(494953, 129, '2014-01-15 00:33:39.000000', 'consum', 0.0216, 'lps'),
	(494954, 129, '2014-01-15 00:33:40.000000', 'consum', 0.0213, 'lps'),
	(494955, 129, '2014-01-15 00:33:41.000000', 'consum', 0.0211, 'lps'),
	(494956, 129, '2014-01-15 00:33:42.000000', 'consum', 0.0218, 'lps'),
	(494957, 129, '2014-01-15 00:33:43.000000', 'consum', 0.0220, 'lps'),
	(494958, 129, '2014-01-15 00:33:44.000000', 'consum', 0.0223, 'lps'),
	(494959, 129, '2014-01-15 00:33:45.000000', 'consum', 0.0216, 'lps'),
	(494960, 129, '2014-01-15 00:33:46.000000', 'consum', 0.0216, 'lps'),
	(494961, 129, '2014-01-15 00:33:47.000000', 'consum', 0.0222, 'lps'),
	(494962, 129, '2014-01-15 00:33:48.000000', 'consum', 0.0223, 'lps'),
	(494963, 129, '2014-01-15 00:33:49.000000', 'consum', 0.0214, 'lps'),
	(494964, 129, '2014-01-15 00:33:50.000000', 'consum', 0.0220, 'lps'),
	(494965, 129, '2014-01-15 00:33:51.000000', 'consum', 0.0218, 'lps'),
	(494966, 129, '2014-01-15 00:33:52.000000', 'consum', 0.0223, 'lps'),
	(494967, 129, '2014-01-15 00:33:53.000000', 'consum', 0.0221, 'lps'),
	(494968, 129, '2014-01-15 00:33:54.000000', 'consum', 0.0215, 'lps'),
	(494969, 129, '2014-01-15 00:33:55.000000', 'consum', 0.0214, 'lps'),
	(494970, 129, '2014-01-15 00:33:56.000000', 'consum', 0.0216, 'lps'),
	(494971, 129, '2014-01-15 00:33:57.000000', 'consum', 0.0215, 'lps'),
	(494972, 129, '2014-01-15 00:33:58.000000', 'consum', 0.0219, 'lps'),
	(494973, 129, '2014-01-15 00:33:59.000000', 'consum', 0.0210, 'lps'),
	(494974, 129, '2014-01-15 00:34:00.000000', 'consum', 0.0213, 'lps'),
	(494975, 129, '2014-01-15 00:34:01.000000', 'consum', 0.0223, 'lps'),
	(494976, 129, '2014-01-15 00:34:02.000000', 'consum', 0.0212, 'lps'),
	(494977, 129, '2014-01-15 00:34:03.000000', 'consum', 0.0211, 'lps'),
	(494978, 129, '2014-01-15 00:34:04.000000', 'consum', 0.0223, 'lps'),
	(494979, 129, '2014-01-15 00:34:05.000000', 'consum', 0.0215, 'lps'),
	(494980, 129, '2014-01-15 00:34:06.000000', 'consum', 0.0210, 'lps'),
	(494981, 129, '2014-01-15 00:34:07.000000', 'consum', 0.0211, 'lps'),
	(494982, 129, '2014-01-15 00:34:08.000000', 'consum', 0.0216, 'lps'),
	(494983, 129, '2014-01-15 00:34:09.000000', 'consum', 0.0211, 'lps'),
	(494984, 129, '2014-01-15 00:34:10.000000', 'consum', 0.0223, 'lps'),
	(494985, 129, '2014-01-15 00:34:11.000000', 'consum', 0.0216, 'lps'),
	(494986, 129, '2014-01-15 00:34:12.000000', 'consum', 0.0215, 'lps'),
	(494987, 129, '2014-01-15 00:34:13.000000', 'consum', 0.0219, 'lps'),
	(494988, 129, '2014-01-15 00:34:14.000000', 'consum', 0.0212, 'lps'),
	(494989, 129, '2014-01-15 00:34:15.000000', 'consum', 0.0223, 'lps'),
	(494990, 129, '2014-01-15 00:34:16.000000', 'consum', 0.0213, 'lps'),
	(494991, 129, '2014-01-15 00:34:17.000000', 'consum', 0.0214, 'lps'),
	(494992, 129, '2014-01-15 00:34:18.000000', 'consum', 0.0223, 'lps'),
	(494993, 129, '2014-01-15 00:34:19.000000', 'consum', 0.0219, 'lps'),
	(494994, 129, '2014-01-15 00:34:20.000000', 'consum', 0.0218, 'lps'),
	(494995, 129, '2014-01-15 00:34:21.000000', 'consum', 0.0222, 'lps'),
	(494996, 129, '2014-01-15 00:34:22.000000', 'consum', 0.0220, 'lps'),
	(494997, 129, '2014-01-15 00:34:23.000000', 'consum', 0.0211, 'lps'),
	(494998, 129, '2014-01-15 00:34:24.000000', 'consum', 0.0212, 'lps'),
	(494999, 129, '2014-01-15 00:34:25.000000', 'consum', 0.0218, 'lps'),
	(495000, 129, '2014-01-15 00:34:26.000000', 'consum', 0.0218, 'lps'),
	(495001, 129, '2014-01-15 00:34:27.000000', 'consum', 0.0213, 'lps'),
	(495002, 129, '2014-01-15 00:34:28.000000', 'consum', 0.0213, 'lps'),
	(495003, 129, '2014-01-15 00:34:29.000000', 'consum', 0.0219, 'lps'),
	(495004, 129, '2014-01-15 00:34:30.000000', 'consum', 0.0219, 'lps'),
	(495005, 129, '2014-01-15 00:34:31.000000', 'consum', 0.0213, 'lps'),
	(495006, 129, '2014-01-15 00:34:32.000000', 'consum', 0.0214, 'lps'),
	(495007, 129, '2014-01-15 00:34:33.000000', 'consum', 0.0221, 'lps'),
	(495008, 129, '2014-01-15 00:34:34.000000', 'consum', 0.0213, 'lps'),
	(495009, 129, '2014-01-15 00:34:35.000000', 'consum', 0.0219, 'lps'),
	(495010, 129, '2014-01-15 00:34:36.000000', 'consum', 0.0219, 'lps'),
	(495011, 129, '2014-01-15 00:34:37.000000', 'consum', 0.0214, 'lps'),
	(495012, 129, '2014-01-15 00:34:38.000000', 'consum', 0.0216, 'lps'),
	(495013, 129, '2014-01-15 00:34:39.000000', 'consum', 0.0217, 'lps'),
	(495014, 129, '2014-01-15 00:34:40.000000', 'consum', 0.0213, 'lps'),
	(495015, 129, '2014-01-15 00:34:41.000000', 'consum', 0.0220, 'lps'),
	(495016, 129, '2014-01-15 00:34:42.000000', 'consum', 0.0221, 'lps'),
	(495017, 129, '2014-01-15 00:34:43.000000', 'consum', 0.0210, 'lps'),
	(495018, 129, '2014-01-15 00:34:44.000000', 'consum', 0.0219, 'lps'),
	(495019, 129, '2014-01-15 00:34:45.000000', 'consum', 0.0213, 'lps'),
	(495020, 129, '2014-01-15 00:34:46.000000', 'consum', 0.0213, 'lps'),
	(495021, 129, '2014-01-15 00:34:47.000000', 'consum', 0.0217, 'lps'),
	(495022, 129, '2014-01-15 00:34:48.000000', 'consum', 0.0210, 'lps'),
	(495023, 129, '2014-01-15 00:34:49.000000', 'consum', 0.0215, 'lps'),
	(495024, 129, '2014-01-15 00:34:50.000000', 'consum', 0.0221, 'lps'),
	(495025, 129, '2014-01-15 00:34:51.000000', 'consum', 0.0222, 'lps'),
	(495026, 129, '2014-01-15 00:34:52.000000', 'consum', 0.0212, 'lps'),
	(495027, 129, '2014-01-15 00:34:53.000000', 'consum', 0.0210, 'lps'),
	(495028, 129, '2014-01-15 00:34:54.000000', 'consum', 0.0219, 'lps'),
	(495029, 129, '2014-01-15 00:34:55.000000', 'consum', 0.0212, 'lps'),
	(495030, 129, '2014-01-15 00:34:56.000000', 'consum', 0.0210, 'lps'),
	(495031, 129, '2014-01-15 00:34:57.000000', 'consum', 0.0219, 'lps'),
	(495032, 129, '2014-01-15 00:34:58.000000', 'consum', 0.0214, 'lps'),
	(495033, 129, '2014-01-15 00:34:59.000000', 'consum', 0.0216, 'lps'),
	(495034, 129, '2014-01-15 00:35:00.000000', 'consum', 0.0213, 'lps'),
	(495035, 129, '2014-01-15 00:35:01.000000', 'consum', 0.0222, 'lps'),
	(495036, 129, '2014-01-15 00:35:02.000000', 'consum', 0.0218, 'lps'),
	(495037, 129, '2014-01-15 00:35:03.000000', 'consum', 0.0216, 'lps'),
	(495038, 129, '2014-01-15 00:35:04.000000', 'consum', 0.0217, 'lps'),
	(495039, 129, '2014-01-15 00:35:05.000000', 'consum', 0.0213, 'lps'),
	(495040, 129, '2014-01-15 00:35:06.000000', 'consum', 0.0220, 'lps'),
	(495041, 129, '2014-01-15 00:35:07.000000', 'consum', 0.0210, 'lps'),
	(495042, 129, '2014-01-15 00:35:08.000000', 'consum', 0.0222, 'lps'),
	(495043, 129, '2014-01-15 00:35:09.000000', 'consum', 0.0216, 'lps'),
	(495044, 129, '2014-01-15 00:35:10.000000', 'consum', 0.0218, 'lps'),
	(495045, 129, '2014-01-15 00:35:11.000000', 'consum', 0.0218, 'lps'),
	(495046, 129, '2014-01-15 00:35:12.000000', 'consum', 0.0214, 'lps'),
	(495047, 129, '2014-01-15 00:35:13.000000', 'consum', 0.0221, 'lps'),
	(495048, 129, '2014-01-15 00:35:14.000000', 'consum', 0.0212, 'lps'),
	(495049, 129, '2014-01-15 00:35:15.000000', 'consum', 0.0213, 'lps'),
	(495050, 129, '2014-01-15 00:35:16.000000', 'consum', 0.0220, 'lps'),
	(495051, 129, '2014-01-15 00:35:17.000000', 'consum', 0.0223, 'lps'),
	(495052, 129, '2014-01-15 00:35:18.000000', 'consum', 0.0217, 'lps'),
	(495053, 129, '2014-01-15 00:35:19.000000', 'consum', 0.0220, 'lps'),
	(495054, 129, '2014-01-15 00:35:20.000000', 'consum', 0.0213, 'lps'),
	(495055, 129, '2014-01-15 00:35:21.000000', 'consum', 0.0211, 'lps'),
	(495056, 129, '2014-01-15 00:35:22.000000', 'consum', 0.0219, 'lps'),
	(495057, 129, '2014-01-15 00:35:23.000000', 'consum', 0.0223, 'lps'),
	(495058, 129, '2014-01-15 00:35:24.000000', 'consum', 0.0220, 'lps'),
	(495059, 129, '2014-01-15 00:35:25.000000', 'consum', 0.0210, 'lps'),
	(495060, 129, '2014-01-15 00:35:26.000000', 'consum', 0.0223, 'lps'),
	(495061, 129, '2014-01-15 00:35:27.000000', 'consum', 0.0217, 'lps'),
	(495062, 129, '2014-01-15 00:35:28.000000', 'consum', 0.0223, 'lps'),
	(495063, 129, '2014-01-15 00:35:29.000000', 'consum', 0.0210, 'lps'),
	(495064, 129, '2014-01-15 00:35:30.000000', 'consum', 0.0213, 'lps'),
	(495065, 129, '2014-01-15 00:35:31.000000', 'consum', 0.0213, 'lps'),
	(495066, 129, '2014-01-15 00:35:32.000000', 'consum', 0.0214, 'lps'),
	(495067, 129, '2014-01-15 00:35:33.000000', 'consum', 0.0223, 'lps'),
	(495068, 129, '2014-01-15 00:35:34.000000', 'consum', 0.0223, 'lps'),
	(495069, 129, '2014-01-15 00:35:35.000000', 'consum', 0.0222, 'lps'),
	(495070, 129, '2014-01-15 00:35:36.000000', 'consum', 0.0216, 'lps'),
	(495071, 129, '2014-01-15 00:35:37.000000', 'consum', 0.0219, 'lps'),
	(495072, 129, '2014-01-15 00:35:38.000000', 'consum', 0.0211, 'lps'),
	(495073, 129, '2014-01-15 00:35:39.000000', 'consum', 0.0214, 'lps'),
	(495074, 129, '2014-01-15 00:35:40.000000', 'consum', 0.0215, 'lps'),
	(495075, 129, '2014-01-15 00:35:41.000000', 'consum', 0.0222, 'lps'),
	(495076, 129, '2014-01-15 00:35:42.000000', 'consum', 0.0216, 'lps'),
	(495077, 129, '2014-01-15 00:35:43.000000', 'consum', 0.0217, 'lps'),
	(495078, 129, '2014-01-15 00:35:44.000000', 'consum', 0.0215, 'lps'),
	(495079, 129, '2014-01-15 00:35:45.000000', 'consum', 0.0212, 'lps'),
	(495080, 129, '2014-01-15 00:35:46.000000', 'consum', 0.0220, 'lps'),
	(495081, 129, '2014-01-15 00:35:47.000000', 'consum', 0.0211, 'lps'),
	(495082, 129, '2014-01-15 00:35:48.000000', 'consum', 0.0215, 'lps'),
	(495083, 129, '2014-01-15 00:35:49.000000', 'consum', 0.0217, 'lps'),
	(495084, 129, '2014-01-15 00:35:50.000000', 'consum', 0.0216, 'lps'),
	(495085, 129, '2014-01-15 00:35:51.000000', 'consum', 0.0222, 'lps'),
	(495086, 129, '2014-01-15 00:35:52.000000', 'consum', 0.0223, 'lps'),
	(495087, 129, '2014-01-15 00:35:53.000000', 'consum', 0.0213, 'lps'),
	(495088, 129, '2014-01-15 00:35:54.000000', 'consum', 0.0212, 'lps'),
	(495089, 129, '2014-01-15 00:35:55.000000', 'consum', 0.0211, 'lps'),
	(495090, 129, '2014-01-15 00:35:56.000000', 'consum', 0.0210, 'lps'),
	(495091, 129, '2014-01-15 00:35:57.000000', 'consum', 0.0220, 'lps'),
	(495092, 129, '2014-01-15 00:35:58.000000', 'consum', 0.0222, 'lps'),
	(495093, 129, '2014-01-15 00:35:59.000000', 'consum', 0.0210, 'lps'),
	(495094, 129, '2014-01-15 00:36:00.000000', 'consum', 0.0216, 'lps'),
	(495095, 129, '2014-01-15 00:36:01.000000', 'consum', 0.0214, 'lps'),
	(495096, 129, '2014-01-15 00:36:02.000000', 'consum', 0.0213, 'lps'),
	(495097, 129, '2014-01-15 00:36:03.000000', 'consum', 0.0214, 'lps'),
	(495098, 129, '2014-01-15 00:36:04.000000', 'consum', 0.0219, 'lps'),
	(495099, 129, '2014-01-15 00:36:05.000000', 'consum', 0.0215, 'lps'),
	(495100, 129, '2014-01-15 00:36:06.000000', 'consum', 0.0212, 'lps'),
	(495101, 129, '2014-01-15 00:36:07.000000', 'consum', 0.0216, 'lps'),
	(495102, 129, '2014-01-15 00:36:08.000000', 'consum', 0.0222, 'lps'),
	(495103, 129, '2014-01-15 00:36:09.000000', 'consum', 0.0223, 'lps'),
	(495104, 129, '2014-01-15 00:36:10.000000', 'consum', 0.0212, 'lps'),
	(495105, 129, '2014-01-15 00:36:11.000000', 'consum', 0.0223, 'lps'),
	(495106, 129, '2014-01-15 00:36:12.000000', 'consum', 0.0215, 'lps'),
	(495107, 129, '2014-01-15 00:36:13.000000', 'consum', 0.0223, 'lps'),
	(495108, 129, '2014-01-15 00:36:14.000000', 'consum', 0.0221, 'lps'),
	(495109, 129, '2014-01-15 00:36:15.000000', 'consum', 0.0223, 'lps'),
	(495110, 129, '2014-01-15 00:36:16.000000', 'consum', 0.0217, 'lps'),
	(495111, 129, '2014-01-15 00:36:17.000000', 'consum', 0.0220, 'lps'),
	(495112, 129, '2014-01-15 00:36:18.000000', 'consum', 0.0210, 'lps'),
	(495113, 129, '2014-01-15 00:36:19.000000', 'consum', 0.0210, 'lps'),
	(495114, 129, '2014-01-15 00:36:20.000000', 'consum', 0.0222, 'lps'),
	(495115, 129, '2014-01-15 00:36:21.000000', 'consum', 0.0218, 'lps'),
	(495116, 129, '2014-01-15 00:36:22.000000', 'consum', 0.0212, 'lps'),
	(495117, 129, '2014-01-15 00:36:23.000000', 'consum', 0.0213, 'lps'),
	(495118, 129, '2014-01-15 00:36:24.000000', 'consum', 0.0218, 'lps'),
	(495119, 129, '2014-01-15 00:36:25.000000', 'consum', 0.0214, 'lps'),
	(495120, 129, '2014-01-15 00:36:26.000000', 'consum', 0.0219, 'lps'),
	(495121, 129, '2014-01-15 00:36:27.000000', 'consum', 0.0215, 'lps'),
	(495122, 129, '2014-01-15 00:36:28.000000', 'consum', 0.0211, 'lps'),
	(495123, 129, '2014-01-15 00:36:29.000000', 'consum', 0.0212, 'lps'),
	(495124, 129, '2014-01-15 00:36:30.000000', 'consum', 0.0217, 'lps'),
	(495125, 129, '2014-01-15 00:36:31.000000', 'consum', 0.0214, 'lps'),
	(495126, 129, '2014-01-15 00:36:32.000000', 'consum', 0.0221, 'lps'),
	(495127, 129, '2014-01-15 00:36:33.000000', 'consum', 0.0212, 'lps'),
	(495128, 129, '2014-01-15 00:36:34.000000', 'consum', 0.0217, 'lps'),
	(495129, 129, '2014-01-15 00:36:35.000000', 'consum', 0.0211, 'lps'),
	(495130, 129, '2014-01-15 00:36:36.000000', 'consum', 0.0222, 'lps'),
	(495131, 129, '2014-01-15 00:36:37.000000', 'consum', 0.0213, 'lps'),
	(495132, 129, '2014-01-15 00:36:38.000000', 'consum', 0.0217, 'lps'),
	(495133, 129, '2014-01-15 00:36:39.000000', 'consum', 0.0221, 'lps'),
	(495134, 129, '2014-01-15 00:36:40.000000', 'consum', 0.0217, 'lps'),
	(495135, 129, '2014-01-15 00:36:41.000000', 'consum', 0.0212, 'lps'),
	(495136, 129, '2014-01-15 00:36:42.000000', 'consum', 0.0213, 'lps'),
	(495137, 129, '2014-01-15 00:36:43.000000', 'consum', 0.0220, 'lps'),
	(495138, 129, '2014-01-15 00:36:44.000000', 'consum', 0.0223, 'lps'),
	(495139, 129, '2014-01-15 00:36:45.000000', 'consum', 0.0219, 'lps'),
	(495140, 129, '2014-01-15 00:36:46.000000', 'consum', 0.0218, 'lps'),
	(495141, 129, '2014-01-15 00:36:47.000000', 'consum', 0.0221, 'lps'),
	(495142, 129, '2014-01-15 00:36:48.000000', 'consum', 0.0213, 'lps'),
	(495143, 129, '2014-01-15 00:36:49.000000', 'consum', 0.0223, 'lps'),
	(495144, 129, '2014-01-15 00:36:50.000000', 'consum', 0.0221, 'lps'),
	(495145, 129, '2014-01-15 00:36:51.000000', 'consum', 0.0216, 'lps'),
	(495146, 129, '2014-01-15 00:36:52.000000', 'consum', 0.0219, 'lps'),
	(495147, 129, '2014-01-15 00:36:53.000000', 'consum', 0.0212, 'lps'),
	(495148, 129, '2014-01-15 00:36:54.000000', 'consum', 0.0219, 'lps'),
	(495149, 129, '2014-01-15 00:36:55.000000', 'consum', 0.0210, 'lps'),
	(495150, 129, '2014-01-15 00:36:56.000000', 'consum', 0.0222, 'lps'),
	(495151, 129, '2014-01-15 00:36:57.000000', 'consum', 0.0218, 'lps'),
	(495152, 129, '2014-01-15 00:36:58.000000', 'consum', 0.0213, 'lps'),
	(495153, 129, '2014-01-15 00:36:59.000000', 'consum', 0.0214, 'lps'),
	(495154, 129, '2014-01-15 00:37:00.000000', 'consum', 0.0222, 'lps'),
	(495155, 129, '2014-01-15 00:37:01.000000', 'consum', 0.0216, 'lps'),
	(495156, 129, '2014-01-15 00:37:02.000000', 'consum', 0.0220, 'lps'),
	(495157, 129, '2014-01-15 00:37:03.000000', 'consum', 0.0216, 'lps'),
	(495158, 129, '2014-01-15 00:37:04.000000', 'consum', 0.0223, 'lps'),
	(495159, 129, '2014-01-15 00:37:05.000000', 'consum', 0.0214, 'lps'),
	(495160, 129, '2014-01-15 00:37:06.000000', 'consum', 0.0220, 'lps'),
	(495161, 129, '2014-01-15 00:37:07.000000', 'consum', 0.0221, 'lps'),
	(495162, 129, '2014-01-15 00:37:08.000000', 'consum', 0.0221, 'lps'),
	(495163, 129, '2014-01-15 00:37:09.000000', 'consum', 0.0219, 'lps'),
	(495164, 129, '2014-01-15 00:37:10.000000', 'consum', 0.0220, 'lps'),
	(495165, 129, '2014-01-15 00:37:11.000000', 'consum', 0.0222, 'lps'),
	(495166, 129, '2014-01-15 00:37:12.000000', 'consum', 0.0213, 'lps'),
	(495167, 129, '2014-01-15 00:37:13.000000', 'consum', 0.0215, 'lps'),
	(495168, 129, '2014-01-15 00:37:14.000000', 'consum', 0.0212, 'lps'),
	(495169, 129, '2014-01-15 00:37:15.000000', 'consum', 0.0222, 'lps'),
	(495170, 129, '2014-01-15 00:37:16.000000', 'consum', 0.0223, 'lps'),
	(495171, 129, '2014-01-15 00:37:17.000000', 'consum', 0.0211, 'lps'),
	(495172, 129, '2014-01-15 00:37:18.000000', 'consum', 0.0220, 'lps'),
	(495173, 129, '2014-01-15 00:37:19.000000', 'consum', 0.0214, 'lps'),
	(495174, 129, '2014-01-15 00:37:20.000000', 'consum', 0.0213, 'lps'),
	(495175, 129, '2014-01-15 00:37:21.000000', 'consum', 0.0213, 'lps'),
	(495176, 129, '2014-01-15 00:37:22.000000', 'consum', 0.0217, 'lps'),
	(495177, 129, '2014-01-15 00:37:23.000000', 'consum', 0.0223, 'lps'),
	(495178, 129, '2014-01-15 00:37:24.000000', 'consum', 0.0213, 'lps'),
	(495179, 129, '2014-01-15 00:37:25.000000', 'consum', 0.0212, 'lps'),
	(495180, 129, '2014-01-15 00:37:26.000000', 'consum', 0.0215, 'lps'),
	(495181, 129, '2014-01-15 00:37:27.000000', 'consum', 0.0214, 'lps'),
	(495182, 129, '2014-01-15 00:37:28.000000', 'consum', 0.0215, 'lps'),
	(495183, 129, '2014-01-15 00:37:29.000000', 'consum', 0.0212, 'lps'),
	(495184, 129, '2014-01-15 00:37:30.000000', 'consum', 0.0217, 'lps'),
	(495185, 129, '2014-01-15 00:37:31.000000', 'consum', 0.0212, 'lps'),
	(495186, 129, '2014-01-15 00:37:32.000000', 'consum', 0.0216, 'lps'),
	(495187, 129, '2014-01-15 00:37:33.000000', 'consum', 0.0217, 'lps'),
	(495188, 129, '2014-01-15 00:37:34.000000', 'consum', 0.0216, 'lps'),
	(495189, 129, '2014-01-15 00:37:35.000000', 'consum', 0.0220, 'lps'),
	(495190, 129, '2014-01-15 00:37:36.000000', 'consum', 0.0216, 'lps'),
	(495191, 129, '2014-01-15 00:37:37.000000', 'consum', 0.0221, 'lps'),
	(495192, 129, '2014-01-15 00:37:38.000000', 'consum', 0.0222, 'lps'),
	(495193, 129, '2014-01-15 00:37:39.000000', 'consum', 0.0222, 'lps'),
	(495194, 129, '2014-01-15 00:37:40.000000', 'consum', 0.0222, 'lps'),
	(495195, 129, '2014-01-15 00:37:41.000000', 'consum', 0.0219, 'lps'),
	(495196, 129, '2014-01-15 00:37:42.000000', 'consum', 0.0218, 'lps'),
	(495197, 129, '2014-01-15 00:37:43.000000', 'consum', 0.0212, 'lps'),
	(495198, 129, '2014-01-15 00:37:44.000000', 'consum', 0.0223, 'lps'),
	(495199, 129, '2014-01-15 00:37:45.000000', 'consum', 0.0214, 'lps'),
	(495200, 129, '2014-01-15 00:37:46.000000', 'consum', 0.0218, 'lps'),
	(495201, 129, '2014-01-15 00:37:47.000000', 'consum', 0.0212, 'lps'),
	(495202, 129, '2014-01-15 00:37:48.000000', 'consum', 0.0222, 'lps'),
	(495203, 129, '2014-01-15 00:37:49.000000', 'consum', 0.0211, 'lps'),
	(495204, 129, '2014-01-15 00:37:50.000000', 'consum', 0.0221, 'lps'),
	(495205, 129, '2014-01-15 00:37:51.000000', 'consum', 0.0221, 'lps'),
	(495206, 129, '2014-01-15 00:37:52.000000', 'consum', 0.0219, 'lps'),
	(495207, 129, '2014-01-15 00:37:53.000000', 'consum', 0.0220, 'lps'),
	(495208, 129, '2014-01-15 00:37:54.000000', 'consum', 0.0222, 'lps'),
	(495209, 129, '2014-01-15 00:37:55.000000', 'consum', 0.0213, 'lps'),
	(495210, 129, '2014-01-15 00:37:56.000000', 'consum', 0.0215, 'lps'),
	(495211, 129, '2014-01-15 00:37:57.000000', 'consum', 0.0215, 'lps'),
	(495212, 129, '2014-01-15 00:37:58.000000', 'consum', 0.0222, 'lps'),
	(495213, 129, '2014-01-15 00:37:59.000000', 'consum', 0.0210, 'lps'),
	(495214, 129, '2014-01-15 00:38:00.000000', 'consum', 0.0217, 'lps'),
	(495215, 129, '2014-01-15 00:38:01.000000', 'consum', 0.0220, 'lps'),
	(495216, 129, '2014-01-15 00:38:02.000000', 'consum', 0.0223, 'lps'),
	(495217, 129, '2014-01-15 00:38:03.000000', 'consum', 0.0219, 'lps'),
	(495218, 129, '2014-01-15 00:38:04.000000', 'consum', 0.0215, 'lps'),
	(495219, 129, '2014-01-15 00:38:05.000000', 'consum', 0.0223, 'lps'),
	(495220, 129, '2014-01-15 00:38:06.000000', 'consum', 0.0218, 'lps'),
	(495221, 129, '2014-01-15 00:38:07.000000', 'consum', 0.0212, 'lps'),
	(495222, 129, '2014-01-15 00:38:08.000000', 'consum', 0.0210, 'lps'),
	(495223, 129, '2014-01-15 00:38:09.000000', 'consum', 0.0221, 'lps'),
	(495224, 129, '2014-01-15 00:38:10.000000', 'consum', 0.0221, 'lps'),
	(495225, 129, '2014-01-15 00:38:11.000000', 'consum', 0.0217, 'lps'),
	(495226, 129, '2014-01-15 00:38:12.000000', 'consum', 0.0216, 'lps'),
	(495227, 129, '2014-01-15 00:38:13.000000', 'consum', 0.0216, 'lps'),
	(495228, 129, '2014-01-15 00:38:14.000000', 'consum', 0.0211, 'lps'),
	(495229, 129, '2014-01-15 00:38:15.000000', 'consum', 0.0210, 'lps'),
	(495230, 129, '2014-01-15 00:38:16.000000', 'consum', 0.0220, 'lps'),
	(495231, 129, '2014-01-15 00:38:17.000000', 'consum', 0.0220, 'lps'),
	(495232, 129, '2014-01-15 00:38:18.000000', 'consum', 0.0218, 'lps'),
	(495233, 129, '2014-01-15 00:38:19.000000', 'consum', 0.0217, 'lps'),
	(495234, 129, '2014-01-15 00:38:20.000000', 'consum', 0.0211, 'lps'),
	(495235, 129, '2014-01-15 00:38:21.000000', 'consum', 0.0221, 'lps'),
	(495236, 129, '2014-01-15 00:38:22.000000', 'consum', 0.0221, 'lps'),
	(495237, 129, '2014-01-15 00:38:23.000000', 'consum', 0.0217, 'lps'),
	(495238, 129, '2014-01-15 00:38:24.000000', 'consum', 0.0212, 'lps'),
	(495239, 129, '2014-01-15 00:38:25.000000', 'consum', 0.0214, 'lps'),
	(495240, 129, '2014-01-15 00:38:26.000000', 'consum', 0.0211, 'lps'),
	(495241, 129, '2014-01-15 00:38:27.000000', 'consum', 0.0217, 'lps'),
	(495242, 129, '2014-01-15 00:38:28.000000', 'consum', 0.0213, 'lps'),
	(495243, 129, '2014-01-15 00:38:29.000000', 'consum', 0.0220, 'lps'),
	(495244, 129, '2014-01-15 00:38:30.000000', 'consum', 0.0211, 'lps'),
	(495245, 129, '2014-01-15 00:38:31.000000', 'consum', 0.0214, 'lps'),
	(495246, 129, '2014-01-15 00:38:32.000000', 'consum', 0.0212, 'lps'),
	(495247, 129, '2014-01-15 00:38:33.000000', 'consum', 0.0210, 'lps'),
	(495248, 129, '2014-01-15 00:38:34.000000', 'consum', 0.0219, 'lps'),
	(495249, 129, '2014-01-15 00:38:35.000000', 'consum', 0.0214, 'lps'),
	(495250, 129, '2014-01-15 00:38:36.000000', 'consum', 0.0217, 'lps'),
	(495251, 129, '2014-01-15 00:38:37.000000', 'consum', 0.0220, 'lps'),
	(495252, 129, '2014-01-15 00:38:38.000000', 'consum', 0.0210, 'lps'),
	(495253, 129, '2014-01-15 00:38:39.000000', 'consum', 0.0210, 'lps'),
	(495254, 129, '2014-01-15 00:38:40.000000', 'consum', 0.0222, 'lps'),
	(495255, 129, '2014-01-15 00:38:41.000000', 'consum', 0.0217, 'lps'),
	(495256, 129, '2014-01-15 00:38:42.000000', 'consum', 0.0221, 'lps'),
	(495257, 129, '2014-01-15 00:38:43.000000', 'consum', 0.0217, 'lps'),
	(495258, 129, '2014-01-15 00:38:44.000000', 'consum', 0.0213, 'lps'),
	(495259, 129, '2014-01-15 00:38:45.000000', 'consum', 0.0218, 'lps'),
	(495260, 129, '2014-01-15 00:38:46.000000', 'consum', 0.0214, 'lps'),
	(495261, 129, '2014-01-15 00:38:47.000000', 'consum', 0.0222, 'lps'),
	(495262, 129, '2014-01-15 00:38:48.000000', 'consum', 0.0215, 'lps'),
	(495263, 129, '2014-01-15 00:38:49.000000', 'consum', 0.0213, 'lps'),
	(495264, 129, '2014-01-15 00:38:50.000000', 'consum', 0.0213, 'lps'),
	(495265, 129, '2014-01-15 00:38:51.000000', 'consum', 0.0214, 'lps'),
	(495266, 129, '2014-01-15 00:38:52.000000', 'consum', 0.0210, 'lps'),
	(495267, 129, '2014-01-15 00:38:53.000000', 'consum', 0.0213, 'lps'),
	(495268, 129, '2014-01-15 00:38:54.000000', 'consum', 0.0223, 'lps'),
	(495269, 129, '2014-01-15 00:38:55.000000', 'consum', 0.0212, 'lps'),
	(495270, 129, '2014-01-15 00:38:56.000000', 'consum', 0.0222, 'lps'),
	(495271, 129, '2014-01-15 00:38:57.000000', 'consum', 0.0222, 'lps'),
	(495272, 129, '2014-01-15 00:38:58.000000', 'consum', 0.0220, 'lps'),
	(495273, 129, '2014-01-15 00:38:59.000000', 'consum', 0.0211, 'lps'),
	(495274, 129, '2014-01-15 00:39:00.000000', 'consum', 0.0213, 'lps'),
	(495275, 129, '2014-01-15 00:39:01.000000', 'consum', 0.0210, 'lps'),
	(495276, 129, '2014-01-15 00:39:02.000000', 'consum', 0.0213, 'lps'),
	(495277, 129, '2014-01-15 00:39:03.000000', 'consum', 0.0214, 'lps'),
	(495278, 129, '2014-01-15 00:39:04.000000', 'consum', 0.0221, 'lps'),
	(495279, 129, '2014-01-15 00:39:05.000000', 'consum', 0.0212, 'lps'),
	(495280, 129, '2014-01-15 00:39:06.000000', 'consum', 0.0215, 'lps'),
	(495281, 129, '2014-01-15 00:39:07.000000', 'consum', 0.0215, 'lps'),
	(495282, 129, '2014-01-15 00:39:08.000000', 'consum', 0.0221, 'lps'),
	(495283, 129, '2014-01-15 00:39:09.000000', 'consum', 0.0221, 'lps'),
	(495284, 129, '2014-01-15 00:39:10.000000', 'consum', 0.0219, 'lps'),
	(495285, 129, '2014-01-15 00:39:11.000000', 'consum', 0.0223, 'lps'),
	(495286, 129, '2014-01-15 00:39:12.000000', 'consum', 0.0218, 'lps'),
	(495287, 129, '2014-01-15 00:39:13.000000', 'consum', 0.0214, 'lps'),
	(495288, 129, '2014-01-15 00:39:14.000000', 'consum', 0.0222, 'lps'),
	(495289, 129, '2014-01-15 00:39:15.000000', 'consum', 0.0215, 'lps'),
	(495290, 129, '2014-01-15 00:39:16.000000', 'consum', 0.0214, 'lps'),
	(495291, 129, '2014-01-15 00:39:17.000000', 'consum', 0.0217, 'lps'),
	(495292, 129, '2014-01-15 00:39:18.000000', 'consum', 0.0217, 'lps'),
	(495293, 129, '2014-01-15 00:39:19.000000', 'consum', 0.0212, 'lps'),
	(495294, 129, '2014-01-15 00:39:20.000000', 'consum', 0.0212, 'lps'),
	(495295, 129, '2014-01-15 00:39:21.000000', 'consum', 0.0216, 'lps'),
	(495296, 129, '2014-01-15 00:39:22.000000', 'consum', 0.0221, 'lps'),
	(495297, 129, '2014-01-15 00:39:23.000000', 'consum', 0.0218, 'lps'),
	(495298, 129, '2014-01-15 00:39:24.000000', 'consum', 0.0217, 'lps'),
	(495299, 129, '2014-01-15 00:39:25.000000', 'consum', 0.0221, 'lps'),
	(495300, 129, '2014-01-15 00:39:26.000000', 'consum', 0.0216, 'lps'),
	(495301, 129, '2014-01-15 00:39:27.000000', 'consum', 0.0222, 'lps'),
	(495302, 129, '2014-01-15 00:39:28.000000', 'consum', 0.0213, 'lps'),
	(495303, 129, '2014-01-15 00:39:29.000000', 'consum', 0.0216, 'lps'),
	(495304, 129, '2014-01-15 00:39:30.000000', 'consum', 0.0216, 'lps'),
	(495305, 129, '2014-01-15 00:39:31.000000', 'consum', 0.0211, 'lps'),
	(495306, 129, '2014-01-15 00:39:32.000000', 'consum', 0.0211, 'lps'),
	(495307, 129, '2014-01-15 00:39:33.000000', 'consum', 0.0213, 'lps'),
	(495308, 129, '2014-01-15 00:39:34.000000', 'consum', 0.0223, 'lps'),
	(495309, 129, '2014-01-15 00:39:35.000000', 'consum', 0.0210, 'lps'),
	(495310, 129, '2014-01-15 00:39:36.000000', 'consum', 0.0212, 'lps'),
	(495311, 129, '2014-01-15 00:39:37.000000', 'consum', 0.0220, 'lps'),
	(495312, 129, '2014-01-15 00:39:38.000000', 'consum', 0.0212, 'lps'),
	(495313, 129, '2014-01-15 00:39:39.000000', 'consum', 0.0221, 'lps'),
	(495314, 129, '2014-01-15 00:39:40.000000', 'consum', 0.0218, 'lps'),
	(495315, 129, '2014-01-15 00:39:41.000000', 'consum', 0.0217, 'lps'),
	(495316, 129, '2014-01-15 00:39:42.000000', 'consum', 0.0222, 'lps'),
	(495317, 129, '2014-01-15 00:39:43.000000', 'consum', 0.0222, 'lps'),
	(495318, 129, '2014-01-15 00:39:44.000000', 'consum', 0.0219, 'lps'),
	(495319, 129, '2014-01-15 00:39:45.000000', 'consum', 0.0222, 'lps'),
	(495320, 129, '2014-01-15 00:39:46.000000', 'consum', 0.0214, 'lps'),
	(495321, 129, '2014-01-15 00:39:47.000000', 'consum', 0.0221, 'lps'),
	(495322, 129, '2014-01-15 00:39:48.000000', 'consum', 0.0215, 'lps'),
	(495323, 129, '2014-01-15 00:39:49.000000', 'consum', 0.0214, 'lps'),
	(495324, 129, '2014-01-15 00:39:50.000000', 'consum', 0.0214, 'lps'),
	(495325, 129, '2014-01-15 00:39:51.000000', 'consum', 0.0221, 'lps'),
	(495326, 129, '2014-01-15 00:39:52.000000', 'consum', 0.0213, 'lps'),
	(495327, 129, '2014-01-15 00:39:53.000000', 'consum', 0.0217, 'lps'),
	(495328, 129, '2014-01-15 00:39:54.000000', 'consum', 0.0211, 'lps'),
	(495329, 129, '2014-01-15 00:39:55.000000', 'consum', 0.0220, 'lps'),
	(495330, 129, '2014-01-15 00:39:56.000000', 'consum', 0.0218, 'lps'),
	(495331, 129, '2014-01-15 00:39:57.000000', 'consum', 0.0221, 'lps'),
	(495332, 129, '2014-01-15 00:39:58.000000', 'consum', 0.0213, 'lps'),
	(495333, 129, '2014-01-15 00:39:59.000000', 'consum', 0.0221, 'lps'),
	(495334, 129, '2014-01-15 00:40:00.000000', 'consum', 0.0214, 'lps'),
	(495335, 129, '2014-01-15 00:40:01.000000', 'consum', 0.0214, 'lps'),
	(495336, 129, '2014-01-15 00:40:02.000000', 'consum', 0.0215, 'lps'),
	(495337, 129, '2014-01-15 00:40:03.000000', 'consum', 0.0223, 'lps'),
	(495338, 129, '2014-01-15 00:40:04.000000', 'consum', 0.0220, 'lps'),
	(495339, 129, '2014-01-15 00:40:05.000000', 'consum', 0.0220, 'lps'),
	(495340, 129, '2014-01-15 00:40:06.000000', 'consum', 0.0219, 'lps'),
	(495341, 129, '2014-01-15 00:40:07.000000', 'consum', 0.0223, 'lps'),
	(495342, 129, '2014-01-15 00:40:08.000000', 'consum', 0.0223, 'lps'),
	(495343, 129, '2014-01-15 00:40:09.000000', 'consum', 0.0222, 'lps'),
	(495344, 129, '2014-01-15 00:40:10.000000', 'consum', 0.0216, 'lps'),
	(495345, 129, '2014-01-15 00:40:11.000000', 'consum', 0.0220, 'lps'),
	(495346, 129, '2014-01-15 00:40:12.000000', 'consum', 0.0212, 'lps'),
	(495347, 129, '2014-01-15 00:40:13.000000', 'consum', 0.0220, 'lps'),
	(495348, 129, '2014-01-15 00:40:14.000000', 'consum', 0.0210, 'lps'),
	(495349, 129, '2014-01-15 00:40:15.000000', 'consum', 0.0212, 'lps'),
	(495350, 129, '2014-01-15 00:40:16.000000', 'consum', 0.0219, 'lps'),
	(495351, 129, '2014-01-15 00:40:17.000000', 'consum', 0.0221, 'lps'),
	(495352, 129, '2014-01-15 00:40:18.000000', 'consum', 0.0210, 'lps'),
	(495353, 129, '2014-01-15 00:40:19.000000', 'consum', 0.0219, 'lps'),
	(495354, 129, '2014-01-15 00:40:20.000000', 'consum', 0.0214, 'lps'),
	(495355, 129, '2014-01-15 00:40:21.000000', 'consum', 0.0216, 'lps'),
	(495356, 129, '2014-01-15 00:40:22.000000', 'consum', 0.0214, 'lps'),
	(495357, 129, '2014-01-15 00:40:23.000000', 'consum', 0.0214, 'lps'),
	(495358, 129, '2014-01-15 00:40:24.000000', 'consum', 0.0220, 'lps'),
	(495359, 129, '2014-01-15 00:40:25.000000', 'consum', 0.0218, 'lps'),
	(495360, 129, '2014-01-15 00:40:26.000000', 'consum', 0.0222, 'lps'),
	(495361, 129, '2014-01-15 00:40:27.000000', 'consum', 0.0220, 'lps'),
	(495362, 129, '2014-01-15 00:40:28.000000', 'consum', 0.0210, 'lps'),
	(495363, 129, '2014-01-15 00:40:29.000000', 'consum', 0.0220, 'lps'),
	(495364, 129, '2014-01-15 00:40:30.000000', 'consum', 0.0220, 'lps'),
	(495365, 129, '2014-01-15 00:40:31.000000', 'consum', 0.0215, 'lps'),
	(495366, 129, '2014-01-15 00:40:32.000000', 'consum', 0.0219, 'lps'),
	(495367, 129, '2014-01-15 00:40:33.000000', 'consum', 0.0214, 'lps'),
	(495368, 129, '2014-01-15 00:40:34.000000', 'consum', 0.0218, 'lps'),
	(495369, 129, '2014-01-15 00:40:35.000000', 'consum', 0.0223, 'lps'),
	(495370, 129, '2014-01-15 00:40:36.000000', 'consum', 0.0223, 'lps'),
	(495371, 129, '2014-01-15 00:40:37.000000', 'consum', 0.0210, 'lps'),
	(495372, 129, '2014-01-15 00:40:38.000000', 'consum', 0.0215, 'lps'),
	(495373, 129, '2014-01-15 00:40:39.000000', 'consum', 0.0220, 'lps'),
	(495374, 129, '2014-01-15 00:40:40.000000', 'consum', 0.0218, 'lps'),
	(495375, 129, '2014-01-15 00:40:41.000000', 'consum', 0.0218, 'lps'),
	(495376, 129, '2014-01-15 00:40:42.000000', 'consum', 0.0216, 'lps'),
	(495377, 129, '2014-01-15 00:40:43.000000', 'consum', 0.0216, 'lps'),
	(495378, 129, '2014-01-15 00:40:44.000000', 'consum', 0.0221, 'lps'),
	(495379, 129, '2014-01-15 00:40:45.000000', 'consum', 0.0220, 'lps'),
	(495380, 129, '2014-01-15 00:40:46.000000', 'consum', 0.0215, 'lps'),
	(495381, 129, '2014-01-15 00:40:47.000000', 'consum', 0.0220, 'lps'),
	(495382, 129, '2014-01-15 00:40:48.000000', 'consum', 0.0215, 'lps'),
	(495383, 129, '2014-01-15 00:40:49.000000', 'consum', 0.0223, 'lps'),
	(495384, 129, '2014-01-15 00:40:50.000000', 'consum', 0.0215, 'lps'),
	(495385, 129, '2014-01-15 00:40:51.000000', 'consum', 0.0211, 'lps'),
	(495386, 129, '2014-01-15 00:40:52.000000', 'consum', 0.0215, 'lps'),
	(495387, 129, '2014-01-15 00:40:53.000000', 'consum', 0.0220, 'lps'),
	(495388, 129, '2014-01-15 00:40:54.000000', 'consum', 0.0216, 'lps'),
	(495389, 129, '2014-01-15 00:40:55.000000', 'consum', 0.0223, 'lps'),
	(495390, 129, '2014-01-15 00:40:56.000000', 'consum', 0.0216, 'lps'),
	(495391, 129, '2014-01-15 00:40:57.000000', 'consum', 0.0218, 'lps'),
	(495392, 129, '2014-01-15 00:40:58.000000', 'consum', 0.0217, 'lps'),
	(495393, 129, '2014-01-15 00:40:59.000000', 'consum', 0.0221, 'lps'),
	(495394, 129, '2014-01-15 00:41:00.000000', 'consum', 0.0218, 'lps'),
	(495395, 129, '2014-01-15 00:41:01.000000', 'consum', 0.0216, 'lps'),
	(495396, 129, '2014-01-15 00:41:02.000000', 'consum', 0.0218, 'lps'),
	(495397, 129, '2014-01-15 00:41:03.000000', 'consum', 0.0219, 'lps'),
	(495398, 129, '2014-01-15 00:41:04.000000', 'consum', 0.0217, 'lps'),
	(495399, 129, '2014-01-15 00:41:05.000000', 'consum', 0.0220, 'lps'),
	(495400, 129, '2014-01-15 00:41:06.000000', 'consum', 0.0211, 'lps'),
	(495401, 129, '2014-01-15 00:41:07.000000', 'consum', 0.0211, 'lps'),
	(495402, 129, '2014-01-15 00:41:08.000000', 'consum', 0.0214, 'lps'),
	(495403, 129, '2014-01-15 00:41:09.000000', 'consum', 0.0214, 'lps'),
	(495404, 129, '2014-01-15 00:41:10.000000', 'consum', 0.0217, 'lps'),
	(495405, 129, '2014-01-15 00:41:11.000000', 'consum', 0.0219, 'lps'),
	(495406, 129, '2014-01-15 00:41:12.000000', 'consum', 0.0223, 'lps'),
	(495407, 129, '2014-01-15 00:41:13.000000', 'consum', 0.0218, 'lps'),
	(495408, 129, '2014-01-15 00:41:14.000000', 'consum', 0.0213, 'lps'),
	(495409, 129, '2014-01-15 00:41:15.000000', 'consum', 0.0214, 'lps'),
	(495410, 129, '2014-01-15 00:41:16.000000', 'consum', 0.0221, 'lps'),
	(495411, 129, '2014-01-15 00:41:17.000000', 'consum', 0.0210, 'lps'),
	(495412, 129, '2014-01-15 00:41:18.000000', 'consum', 0.0222, 'lps'),
	(495413, 129, '2014-01-15 00:41:19.000000', 'consum', 0.0215, 'lps'),
	(495414, 129, '2014-01-15 00:41:20.000000', 'consum', 0.0214, 'lps'),
	(495415, 129, '2014-01-15 00:41:21.000000', 'consum', 0.0214, 'lps'),
	(495416, 129, '2014-01-15 00:41:22.000000', 'consum', 0.0218, 'lps'),
	(495417, 129, '2014-01-15 00:41:23.000000', 'consum', 0.0211, 'lps'),
	(495418, 129, '2014-01-15 00:41:24.000000', 'consum', 0.0221, 'lps'),
	(495419, 129, '2014-01-15 00:41:25.000000', 'consum', 0.0221, 'lps'),
	(495420, 129, '2014-01-15 00:41:26.000000', 'consum', 0.0216, 'lps'),
	(495421, 129, '2014-01-15 00:41:27.000000', 'consum', 0.0210, 'lps'),
	(495422, 129, '2014-01-15 00:41:28.000000', 'consum', 0.0220, 'lps'),
	(495423, 129, '2014-01-15 00:41:29.000000', 'consum', 0.0217, 'lps'),
	(495424, 129, '2014-01-15 00:41:30.000000', 'consum', 0.0215, 'lps'),
	(495425, 129, '2014-01-15 00:41:31.000000', 'consum', 0.0216, 'lps'),
	(495426, 129, '2014-01-15 00:41:32.000000', 'consum', 0.0211, 'lps'),
	(495427, 129, '2014-01-15 00:41:33.000000', 'consum', 0.0210, 'lps'),
	(495428, 129, '2014-01-15 00:41:34.000000', 'consum', 0.0223, 'lps'),
	(495429, 129, '2014-01-15 00:41:35.000000', 'consum', 0.0218, 'lps'),
	(495430, 129, '2014-01-15 00:41:36.000000', 'consum', 0.0213, 'lps'),
	(495431, 129, '2014-01-15 00:41:37.000000', 'consum', 0.0216, 'lps'),
	(495432, 129, '2014-01-15 00:41:38.000000', 'consum', 0.0215, 'lps'),
	(495433, 129, '2014-01-15 00:41:39.000000', 'consum', 0.0218, 'lps'),
	(495434, 129, '2014-01-15 00:41:40.000000', 'consum', 0.0223, 'lps'),
	(495435, 129, '2014-01-15 00:41:41.000000', 'consum', 0.0223, 'lps'),
	(495436, 129, '2014-01-15 00:41:42.000000', 'consum', 0.0221, 'lps'),
	(495437, 129, '2014-01-15 00:41:43.000000', 'consum', 0.0213, 'lps'),
	(495438, 129, '2014-01-15 00:41:44.000000', 'consum', 0.0220, 'lps'),
	(495439, 129, '2014-01-15 00:41:45.000000', 'consum', 0.0223, 'lps'),
	(495440, 129, '2014-01-15 00:41:46.000000', 'consum', 0.0219, 'lps'),
	(495441, 129, '2014-01-15 00:41:47.000000', 'consum', 0.0217, 'lps'),
	(495442, 129, '2014-01-15 00:41:48.000000', 'consum', 0.0217, 'lps'),
	(495443, 129, '2014-01-15 00:41:49.000000', 'consum', 0.0210, 'lps'),
	(495444, 129, '2014-01-15 00:41:50.000000', 'consum', 0.0217, 'lps'),
	(495445, 129, '2014-01-15 00:41:51.000000', 'consum', 0.0218, 'lps'),
	(495446, 129, '2014-01-15 00:41:52.000000', 'consum', 0.0215, 'lps'),
	(495447, 129, '2014-01-15 00:41:53.000000', 'consum', 0.0212, 'lps'),
	(495448, 129, '2014-01-15 00:41:54.000000', 'consum', 0.0220, 'lps'),
	(495449, 129, '2014-01-15 00:41:55.000000', 'consum', 0.0213, 'lps'),
	(495450, 129, '2014-01-15 00:41:56.000000', 'consum', 0.0221, 'lps'),
	(495451, 129, '2014-01-15 00:41:57.000000', 'consum', 0.0216, 'lps'),
	(495452, 129, '2014-01-15 00:41:58.000000', 'consum', 0.0223, 'lps'),
	(495453, 129, '2014-01-15 00:41:59.000000', 'consum', 0.0213, 'lps'),
	(495454, 129, '2014-01-15 00:42:00.000000', 'consum', 0.0217, 'lps'),
	(495455, 129, '2014-01-15 00:42:01.000000', 'consum', 0.0221, 'lps'),
	(495456, 129, '2014-01-15 00:42:02.000000', 'consum', 0.0218, 'lps'),
	(495457, 129, '2014-01-15 00:42:03.000000', 'consum', 0.0218, 'lps'),
	(495458, 129, '2014-01-15 00:42:04.000000', 'consum', 0.0211, 'lps'),
	(495459, 129, '2014-01-15 00:42:05.000000', 'consum', 0.0218, 'lps'),
	(495460, 129, '2014-01-15 00:42:06.000000', 'consum', 0.0222, 'lps'),
	(495461, 129, '2014-01-15 00:42:07.000000', 'consum', 0.0217, 'lps'),
	(495462, 129, '2014-01-15 00:42:08.000000', 'consum', 0.0210, 'lps'),
	(495463, 129, '2014-01-15 00:42:09.000000', 'consum', 0.0216, 'lps'),
	(495464, 129, '2014-01-15 00:42:10.000000', 'consum', 0.0214, 'lps'),
	(495465, 129, '2014-01-15 00:42:11.000000', 'consum', 0.0210, 'lps'),
	(495466, 129, '2014-01-15 00:42:12.000000', 'consum', 0.0215, 'lps'),
	(495467, 129, '2014-01-15 00:42:13.000000', 'consum', 0.0220, 'lps'),
	(495468, 129, '2014-01-15 00:42:14.000000', 'consum', 0.0218, 'lps'),
	(495469, 129, '2014-01-15 00:42:15.000000', 'consum', 0.0219, 'lps'),
	(495470, 129, '2014-01-15 00:42:16.000000', 'consum', 0.0217, 'lps'),
	(495471, 129, '2014-01-15 00:42:17.000000', 'consum', 0.0219, 'lps'),
	(495472, 129, '2014-01-15 00:42:18.000000', 'consum', 0.0219, 'lps'),
	(495473, 129, '2014-01-15 00:42:19.000000', 'consum', 0.0216, 'lps'),
	(495474, 129, '2014-01-15 00:42:20.000000', 'consum', 0.0213, 'lps'),
	(495475, 129, '2014-01-15 00:42:21.000000', 'consum', 0.0222, 'lps'),
	(495476, 129, '2014-01-15 00:42:22.000000', 'consum', 0.0220, 'lps'),
	(495477, 129, '2014-01-15 00:42:23.000000', 'consum', 0.0222, 'lps'),
	(495478, 129, '2014-01-15 00:42:24.000000', 'consum', 0.0214, 'lps'),
	(495479, 129, '2014-01-15 00:42:25.000000', 'consum', 0.0210, 'lps'),
	(495480, 129, '2014-01-15 00:42:26.000000', 'consum', 0.0223, 'lps'),
	(495481, 129, '2014-01-15 00:42:27.000000', 'consum', 0.0223, 'lps'),
	(495482, 129, '2014-01-15 00:42:28.000000', 'consum', 0.0220, 'lps'),
	(495483, 129, '2014-01-15 00:42:29.000000', 'consum', 0.0210, 'lps'),
	(495484, 129, '2014-01-15 00:42:30.000000', 'consum', 0.0221, 'lps'),
	(495485, 129, '2014-01-15 00:42:31.000000', 'consum', 0.0210, 'lps'),
	(495486, 129, '2014-01-15 00:42:32.000000', 'consum', 0.0220, 'lps'),
	(495487, 129, '2014-01-15 00:42:33.000000', 'consum', 0.0217, 'lps'),
	(495488, 129, '2014-01-15 00:42:34.000000', 'consum', 0.0218, 'lps'),
	(495489, 129, '2014-01-15 00:42:35.000000', 'consum', 0.0213, 'lps'),
	(495490, 129, '2014-01-15 00:42:36.000000', 'consum', 0.0215, 'lps'),
	(495491, 129, '2014-01-15 00:42:37.000000', 'consum', 0.0213, 'lps'),
	(495492, 129, '2014-01-15 00:42:38.000000', 'consum', 0.0211, 'lps'),
	(495493, 129, '2014-01-15 00:42:39.000000', 'consum', 0.0219, 'lps'),
	(495494, 129, '2014-01-15 00:42:40.000000', 'consum', 0.0212, 'lps'),
	(495495, 129, '2014-01-15 00:42:41.000000', 'consum', 0.0221, 'lps'),
	(495496, 129, '2014-01-15 00:42:42.000000', 'consum', 0.0219, 'lps'),
	(495497, 129, '2014-01-15 00:42:43.000000', 'consum', 0.0220, 'lps'),
	(495498, 129, '2014-01-15 00:42:44.000000', 'consum', 0.0219, 'lps'),
	(495499, 129, '2014-01-15 00:42:45.000000', 'consum', 0.0214, 'lps'),
	(495500, 129, '2014-01-15 00:42:46.000000', 'consum', 0.0215, 'lps'),
	(495501, 129, '2014-01-15 00:42:47.000000', 'consum', 0.0223, 'lps'),
	(495502, 129, '2014-01-15 00:42:48.000000', 'consum', 0.0219, 'lps'),
	(495503, 129, '2014-01-15 00:42:49.000000', 'consum', 0.0215, 'lps'),
	(495504, 129, '2014-01-15 00:42:50.000000', 'consum', 0.0223, 'lps'),
	(495505, 129, '2014-01-15 00:42:51.000000', 'consum', 0.0219, 'lps'),
	(495506, 129, '2014-01-15 00:42:52.000000', 'consum', 0.0215, 'lps'),
	(495507, 129, '2014-01-15 00:42:53.000000', 'consum', 0.0211, 'lps'),
	(495508, 129, '2014-01-15 00:42:54.000000', 'consum', 0.0214, 'lps'),
	(495509, 129, '2014-01-15 00:42:55.000000', 'consum', 0.0212, 'lps'),
	(495510, 129, '2014-01-15 00:42:56.000000', 'consum', 0.0221, 'lps'),
	(495511, 129, '2014-01-15 00:42:57.000000', 'consum', 0.0221, 'lps'),
	(495512, 129, '2014-01-15 00:42:58.000000', 'consum', 0.0216, 'lps'),
	(495513, 129, '2014-01-15 00:42:59.000000', 'consum', 0.0223, 'lps'),
	(495514, 129, '2014-01-15 00:43:00.000000', 'consum', 0.0216, 'lps'),
	(495515, 129, '2014-01-15 00:43:01.000000', 'consum', 0.0214, 'lps'),
	(495516, 129, '2014-01-15 00:43:02.000000', 'consum', 0.0213, 'lps'),
	(495517, 129, '2014-01-15 00:43:03.000000', 'consum', 0.0215, 'lps'),
	(495518, 129, '2014-01-15 00:43:04.000000', 'consum', 0.0210, 'lps'),
	(495519, 129, '2014-01-15 00:43:05.000000', 'consum', 0.0210, 'lps'),
	(495520, 129, '2014-01-15 00:43:06.000000', 'consum', 0.0213, 'lps'),
	(495521, 129, '2014-01-15 00:43:07.000000', 'consum', 0.0222, 'lps'),
	(495522, 129, '2014-01-15 00:43:08.000000', 'consum', 0.0223, 'lps'),
	(495523, 129, '2014-01-15 00:43:09.000000', 'consum', 0.0223, 'lps'),
	(495524, 129, '2014-01-15 00:43:10.000000', 'consum', 0.0223, 'lps'),
	(495525, 129, '2014-01-15 00:43:11.000000', 'consum', 0.0210, 'lps'),
	(495526, 129, '2014-01-15 00:43:12.000000', 'consum', 0.0211, 'lps'),
	(495527, 129, '2014-01-15 00:43:13.000000', 'consum', 0.0218, 'lps'),
	(495528, 129, '2014-01-15 00:43:14.000000', 'consum', 0.0218, 'lps'),
	(495529, 129, '2014-01-15 00:43:15.000000', 'consum', 0.0211, 'lps'),
	(495530, 129, '2014-01-15 00:43:16.000000', 'consum', 0.0220, 'lps'),
	(495531, 129, '2014-01-15 00:43:17.000000', 'consum', 0.0216, 'lps'),
	(495532, 129, '2014-01-15 00:43:18.000000', 'consum', 0.0210, 'lps'),
	(495533, 129, '2014-01-15 00:43:19.000000', 'consum', 0.0220, 'lps'),
	(495534, 129, '2014-01-15 00:43:20.000000', 'consum', 0.0217, 'lps'),
	(495535, 129, '2014-01-15 00:43:21.000000', 'consum', 0.0219, 'lps'),
	(495536, 129, '2014-01-15 00:43:22.000000', 'consum', 0.0218, 'lps'),
	(495537, 129, '2014-01-15 00:43:23.000000', 'consum', 0.0212, 'lps'),
	(495538, 129, '2014-01-15 00:43:24.000000', 'consum', 0.0222, 'lps'),
	(495539, 129, '2014-01-15 00:43:25.000000', 'consum', 0.0221, 'lps'),
	(495540, 129, '2014-01-15 00:43:26.000000', 'consum', 0.0219, 'lps'),
	(495541, 129, '2014-01-15 00:43:27.000000', 'consum', 0.0220, 'lps'),
	(495542, 129, '2014-01-15 00:43:28.000000', 'consum', 0.0219, 'lps'),
	(495543, 129, '2014-01-15 00:43:29.000000', 'consum', 0.0214, 'lps'),
	(495544, 129, '2014-01-15 00:43:30.000000', 'consum', 0.0214, 'lps'),
	(495545, 129, '2014-01-15 00:43:31.000000', 'consum', 0.0222, 'lps'),
	(495546, 129, '2014-01-15 00:43:32.000000', 'consum', 0.0216, 'lps'),
	(495547, 129, '2014-01-15 00:43:33.000000', 'consum', 0.0217, 'lps'),
	(495548, 129, '2014-01-15 00:43:34.000000', 'consum', 0.0214, 'lps'),
	(495549, 129, '2014-01-15 00:43:35.000000', 'consum', 0.0223, 'lps'),
	(495550, 129, '2014-01-15 00:43:36.000000', 'consum', 0.0221, 'lps'),
	(495551, 129, '2014-01-15 00:43:37.000000', 'consum', 0.0214, 'lps'),
	(495552, 129, '2014-01-15 00:43:38.000000', 'consum', 0.0212, 'lps'),
	(495553, 129, '2014-01-15 00:43:39.000000', 'consum', 0.0221, 'lps'),
	(495554, 129, '2014-01-15 00:43:40.000000', 'consum', 0.0218, 'lps'),
	(495555, 129, '2014-01-15 00:43:41.000000', 'consum', 0.0218, 'lps'),
	(495556, 129, '2014-01-15 00:43:42.000000', 'consum', 0.0214, 'lps'),
	(495557, 129, '2014-01-15 00:43:43.000000', 'consum', 0.0217, 'lps'),
	(495558, 129, '2014-01-15 00:43:44.000000', 'consum', 0.0222, 'lps'),
	(495559, 129, '2014-01-15 00:43:45.000000', 'consum', 0.0219, 'lps'),
	(495560, 129, '2014-01-15 00:43:46.000000', 'consum', 0.0220, 'lps'),
	(495561, 129, '2014-01-15 00:43:47.000000', 'consum', 0.0221, 'lps'),
	(495562, 129, '2014-01-15 00:43:48.000000', 'consum', 0.0220, 'lps'),
	(495563, 129, '2014-01-15 00:43:49.000000', 'consum', 0.0215, 'lps'),
	(495564, 129, '2014-01-15 00:43:50.000000', 'consum', 0.0218, 'lps'),
	(495565, 129, '2014-01-15 00:43:51.000000', 'consum', 0.0222, 'lps'),
	(495566, 129, '2014-01-15 00:43:52.000000', 'consum', 0.0218, 'lps'),
	(495567, 129, '2014-01-15 00:43:53.000000', 'consum', 0.0214, 'lps'),
	(495568, 129, '2014-01-15 00:43:54.000000', 'consum', 0.0223, 'lps'),
	(495569, 129, '2014-01-15 00:43:55.000000', 'consum', 0.0219, 'lps'),
	(495570, 129, '2014-01-15 00:43:56.000000', 'consum', 0.0216, 'lps'),
	(495571, 129, '2014-01-15 00:43:57.000000', 'consum', 0.0215, 'lps'),
	(495572, 129, '2014-01-15 00:43:58.000000', 'consum', 0.0219, 'lps'),
	(495573, 129, '2014-01-15 00:43:59.000000', 'consum', 0.0210, 'lps'),
	(495574, 129, '2014-01-15 00:44:00.000000', 'consum', 0.0211, 'lps'),
	(495575, 129, '2014-01-15 00:44:01.000000', 'consum', 0.0216, 'lps'),
	(495576, 129, '2014-01-15 00:44:02.000000', 'consum', 0.0222, 'lps'),
	(495577, 129, '2014-01-15 00:44:03.000000', 'consum', 0.0214, 'lps'),
	(495578, 129, '2014-01-15 00:44:04.000000', 'consum', 0.0219, 'lps'),
	(495579, 129, '2014-01-15 00:44:05.000000', 'consum', 0.0217, 'lps'),
	(495580, 129, '2014-01-15 00:44:06.000000', 'consum', 0.0218, 'lps'),
	(495581, 129, '2014-01-15 00:44:07.000000', 'consum', 0.0217, 'lps'),
	(495582, 129, '2014-01-15 00:44:08.000000', 'consum', 0.0219, 'lps'),
	(495583, 129, '2014-01-15 00:44:09.000000', 'consum', 0.0222, 'lps'),
	(495584, 129, '2014-01-15 00:44:10.000000', 'consum', 0.0216, 'lps'),
	(495585, 129, '2014-01-15 00:44:11.000000', 'consum', 0.0217, 'lps'),
	(495586, 129, '2014-01-15 00:44:12.000000', 'consum', 0.0213, 'lps'),
	(495587, 129, '2014-01-15 00:44:13.000000', 'consum', 0.0218, 'lps'),
	(495588, 129, '2014-01-15 00:44:14.000000', 'consum', 0.0215, 'lps'),
	(495589, 129, '2014-01-15 00:44:15.000000', 'consum', 0.0211, 'lps'),
	(495590, 129, '2014-01-15 00:44:16.000000', 'consum', 0.0216, 'lps'),
	(495591, 129, '2014-01-15 00:44:17.000000', 'consum', 0.0221, 'lps'),
	(495592, 129, '2014-01-15 00:44:18.000000', 'consum', 0.0219, 'lps'),
	(495593, 129, '2014-01-15 00:44:19.000000', 'consum', 0.0223, 'lps'),
	(495594, 129, '2014-01-15 00:44:20.000000', 'consum', 0.0219, 'lps'),
	(495595, 129, '2014-01-15 00:44:21.000000', 'consum', 0.0218, 'lps'),
	(495596, 129, '2014-01-15 00:44:22.000000', 'consum', 0.0223, 'lps'),
	(495597, 129, '2014-01-15 00:44:23.000000', 'consum', 0.0210, 'lps'),
	(495598, 129, '2014-01-15 00:44:24.000000', 'consum', 0.0212, 'lps'),
	(495599, 129, '2014-01-15 00:44:25.000000', 'consum', 0.0220, 'lps'),
	(495600, 129, '2014-01-15 00:44:26.000000', 'consum', 0.0214, 'lps'),
	(495601, 129, '2014-01-15 00:44:27.000000', 'consum', 0.0216, 'lps'),
	(495602, 129, '2014-01-15 00:44:28.000000', 'consum', 0.0212, 'lps'),
	(495603, 129, '2014-01-15 00:44:29.000000', 'consum', 0.0217, 'lps'),
	(495604, 129, '2014-01-15 00:44:30.000000', 'consum', 0.0212, 'lps'),
	(495605, 129, '2014-01-15 00:44:31.000000', 'consum', 0.0215, 'lps'),
	(495606, 129, '2014-01-15 00:44:32.000000', 'consum', 0.0216, 'lps'),
	(495607, 129, '2014-01-15 00:44:33.000000', 'consum', 0.0211, 'lps'),
	(495608, 129, '2014-01-15 00:44:34.000000', 'consum', 0.0213, 'lps'),
	(495609, 129, '2014-01-15 00:44:35.000000', 'consum', 0.0222, 'lps'),
	(495610, 129, '2014-01-15 00:44:36.000000', 'consum', 0.0217, 'lps'),
	(495611, 129, '2014-01-15 00:44:37.000000', 'consum', 0.0213, 'lps'),
	(495612, 129, '2014-01-15 00:44:38.000000', 'consum', 0.0215, 'lps'),
	(495613, 129, '2014-01-15 00:44:39.000000', 'consum', 0.0215, 'lps'),
	(495614, 129, '2014-01-15 00:44:40.000000', 'consum', 0.0220, 'lps'),
	(495615, 129, '2014-01-15 00:44:41.000000', 'consum', 0.0217, 'lps'),
	(495616, 129, '2014-01-15 00:44:42.000000', 'consum', 0.0214, 'lps'),
	(495617, 129, '2014-01-15 00:44:43.000000', 'consum', 0.0211, 'lps'),
	(495618, 129, '2014-01-15 00:44:44.000000', 'consum', 0.0216, 'lps'),
	(495619, 129, '2014-01-15 00:44:45.000000', 'consum', 0.0210, 'lps'),
	(495620, 129, '2014-01-15 00:44:46.000000', 'consum', 0.0222, 'lps'),
	(495621, 129, '2014-01-15 00:44:47.000000', 'consum', 0.0212, 'lps'),
	(495622, 129, '2014-01-15 00:44:48.000000', 'consum', 0.0213, 'lps'),
	(495623, 129, '2014-01-15 00:44:49.000000', 'consum', 0.0220, 'lps'),
	(495624, 129, '2014-01-15 00:44:50.000000', 'consum', 0.0223, 'lps'),
	(495625, 129, '2014-01-15 00:44:51.000000', 'consum', 0.0216, 'lps'),
	(495626, 129, '2014-01-15 00:44:52.000000', 'consum', 0.0216, 'lps'),
	(495627, 129, '2014-01-15 00:44:53.000000', 'consum', 0.0211, 'lps'),
	(495628, 129, '2014-01-15 00:44:54.000000', 'consum', 0.0211, 'lps'),
	(495629, 129, '2014-01-15 00:44:55.000000', 'consum', 0.0211, 'lps'),
	(495630, 129, '2014-01-15 00:44:56.000000', 'consum', 0.0213, 'lps'),
	(495631, 129, '2014-01-15 00:44:57.000000', 'consum', 0.0223, 'lps'),
	(495632, 129, '2014-01-15 00:44:58.000000', 'consum', 0.0210, 'lps'),
	(495633, 129, '2014-01-15 00:44:59.000000', 'consum', 0.0215, 'lps'),
	(495634, 129, '2014-01-15 00:45:00.000000', 'consum', 0.0221, 'lps'),
	(495635, 129, '2014-01-15 00:45:01.000000', 'consum', 0.0223, 'lps'),
	(495636, 129, '2014-01-15 00:45:02.000000', 'consum', 0.0215, 'lps'),
	(495637, 129, '2014-01-15 00:45:03.000000', 'consum', 0.0210, 'lps'),
	(495638, 129, '2014-01-15 00:45:04.000000', 'consum', 0.0211, 'lps'),
	(495639, 129, '2014-01-15 00:45:05.000000', 'consum', 0.0216, 'lps'),
	(495640, 129, '2014-01-15 00:45:06.000000', 'consum', 0.0210, 'lps'),
	(495641, 129, '2014-01-15 00:45:07.000000', 'consum', 0.0218, 'lps'),
	(495642, 129, '2014-01-15 00:45:08.000000', 'consum', 0.0212, 'lps'),
	(495643, 129, '2014-01-15 00:45:09.000000', 'consum', 0.0221, 'lps'),
	(495644, 129, '2014-01-15 00:45:10.000000', 'consum', 0.0217, 'lps'),
	(495645, 129, '2014-01-15 00:45:11.000000', 'consum', 0.0215, 'lps'),
	(495646, 129, '2014-01-15 00:45:12.000000', 'consum', 0.0214, 'lps'),
	(495647, 129, '2014-01-15 00:45:13.000000', 'consum', 0.0214, 'lps'),
	(495648, 129, '2014-01-15 00:45:14.000000', 'consum', 0.0220, 'lps'),
	(495649, 129, '2014-01-15 00:45:15.000000', 'consum', 0.0219, 'lps'),
	(495650, 129, '2014-01-15 00:45:16.000000', 'consum', 0.0211, 'lps'),
	(495651, 129, '2014-01-15 00:45:17.000000', 'consum', 0.0218, 'lps'),
	(495652, 129, '2014-01-15 00:45:18.000000', 'consum', 0.0221, 'lps'),
	(495653, 129, '2014-01-15 00:45:19.000000', 'consum', 0.0212, 'lps'),
	(495654, 129, '2014-01-15 00:45:20.000000', 'consum', 0.0217, 'lps'),
	(495655, 129, '2014-01-15 00:45:21.000000', 'consum', 0.0223, 'lps'),
	(495656, 129, '2014-01-15 00:45:22.000000', 'consum', 0.0212, 'lps'),
	(495657, 129, '2014-01-15 00:45:23.000000', 'consum', 0.0211, 'lps'),
	(495658, 129, '2014-01-15 00:45:24.000000', 'consum', 0.0221, 'lps'),
	(495659, 129, '2014-01-15 00:45:25.000000', 'consum', 0.0210, 'lps'),
	(495660, 129, '2014-01-15 00:45:26.000000', 'consum', 0.0217, 'lps'),
	(495661, 129, '2014-01-15 00:45:27.000000', 'consum', 0.0218, 'lps'),
	(495662, 129, '2014-01-15 00:45:28.000000', 'consum', 0.0215, 'lps'),
	(495663, 129, '2014-01-15 00:45:29.000000', 'consum', 0.0213, 'lps'),
	(495664, 129, '2014-01-15 00:45:30.000000', 'consum', 0.0210, 'lps'),
	(495665, 129, '2014-01-15 00:45:31.000000', 'consum', 0.0215, 'lps'),
	(495666, 129, '2014-01-15 00:45:32.000000', 'consum', 0.0223, 'lps'),
	(495667, 129, '2014-01-15 00:45:33.000000', 'consum', 0.0216, 'lps'),
	(495668, 129, '2014-01-15 00:45:34.000000', 'consum', 0.0215, 'lps'),
	(495669, 129, '2014-01-15 00:45:35.000000', 'consum', 0.0217, 'lps'),
	(495670, 129, '2014-01-15 00:45:36.000000', 'consum', 0.0218, 'lps'),
	(495671, 129, '2014-01-15 00:45:37.000000', 'consum', 0.0214, 'lps'),
	(495672, 129, '2014-01-15 00:45:38.000000', 'consum', 0.0223, 'lps'),
	(495673, 129, '2014-01-15 00:45:39.000000', 'consum', 0.0219, 'lps'),
	(495674, 129, '2014-01-15 00:45:40.000000', 'consum', 0.0219, 'lps'),
	(495675, 129, '2014-01-15 00:45:41.000000', 'consum', 0.0213, 'lps'),
	(495676, 129, '2014-01-15 00:45:42.000000', 'consum', 0.0213, 'lps'),
	(495677, 129, '2014-01-15 00:45:43.000000', 'consum', 0.0216, 'lps'),
	(495678, 129, '2014-01-15 00:45:44.000000', 'consum', 0.0218, 'lps'),
	(495679, 129, '2014-01-15 00:45:45.000000', 'consum', 0.0216, 'lps'),
	(495680, 129, '2014-01-15 00:45:46.000000', 'consum', 0.0219, 'lps'),
	(495681, 129, '2014-01-15 00:45:47.000000', 'consum', 0.0223, 'lps'),
	(495682, 129, '2014-01-15 00:45:48.000000', 'consum', 0.0222, 'lps'),
	(495683, 129, '2014-01-15 00:45:49.000000', 'consum', 0.0215, 'lps'),
	(495684, 129, '2014-01-15 00:45:50.000000', 'consum', 0.0213, 'lps'),
	(495685, 129, '2014-01-15 00:45:51.000000', 'consum', 0.0213, 'lps'),
	(495686, 129, '2014-01-15 00:45:52.000000', 'consum', 0.0215, 'lps'),
	(495687, 129, '2014-01-15 00:45:53.000000', 'consum', 0.0214, 'lps'),
	(495688, 129, '2014-01-15 00:45:54.000000', 'consum', 0.0213, 'lps'),
	(495689, 129, '2014-01-15 00:45:55.000000', 'consum', 0.0215, 'lps'),
	(495690, 129, '2014-01-15 00:45:56.000000', 'consum', 0.0214, 'lps'),
	(495691, 129, '2014-01-15 00:45:57.000000', 'consum', 0.0215, 'lps'),
	(495692, 129, '2014-01-15 00:45:58.000000', 'consum', 0.0211, 'lps'),
	(495693, 129, '2014-01-15 00:45:59.000000', 'consum', 0.0212, 'lps'),
	(495694, 129, '2014-01-15 00:46:00.000000', 'consum', 0.0218, 'lps'),
	(495695, 129, '2014-01-15 00:46:01.000000', 'consum', 0.0216, 'lps'),
	(495696, 129, '2014-01-15 00:46:02.000000', 'consum', 0.0217, 'lps'),
	(495697, 129, '2014-01-15 00:46:03.000000', 'consum', 0.0215, 'lps'),
	(495698, 129, '2014-01-15 00:46:04.000000', 'consum', 0.0215, 'lps'),
	(495699, 129, '2014-01-15 00:46:05.000000', 'consum', 0.0217, 'lps'),
	(495700, 129, '2014-01-15 00:46:06.000000', 'consum', 0.0219, 'lps'),
	(495701, 129, '2014-01-15 00:46:07.000000', 'consum', 0.0221, 'lps'),
	(495702, 129, '2014-01-15 00:46:08.000000', 'consum', 0.0212, 'lps'),
	(495703, 129, '2014-01-15 00:46:09.000000', 'consum', 0.0212, 'lps'),
	(495704, 129, '2014-01-15 00:46:10.000000', 'consum', 0.0215, 'lps'),
	(495705, 129, '2014-01-15 00:46:11.000000', 'consum', 0.0216, 'lps'),
	(495706, 129, '2014-01-15 00:46:12.000000', 'consum', 0.0213, 'lps'),
	(495707, 129, '2014-01-15 00:46:13.000000', 'consum', 0.0218, 'lps'),
	(495708, 129, '2014-01-15 00:46:14.000000', 'consum', 0.0217, 'lps'),
	(495709, 129, '2014-01-15 00:46:15.000000', 'consum', 0.0220, 'lps'),
	(495710, 129, '2014-01-15 00:46:16.000000', 'consum', 0.0213, 'lps'),
	(495711, 129, '2014-01-15 00:46:17.000000', 'consum', 0.0211, 'lps'),
	(495712, 129, '2014-01-15 00:46:18.000000', 'consum', 0.0217, 'lps'),
	(495713, 129, '2014-01-15 00:46:19.000000', 'consum', 0.0217, 'lps'),
	(495714, 129, '2014-01-15 00:46:20.000000', 'consum', 0.0212, 'lps'),
	(495715, 129, '2014-01-15 00:46:21.000000', 'consum', 0.0211, 'lps'),
	(495716, 129, '2014-01-15 00:46:22.000000', 'consum', 0.0223, 'lps'),
	(495717, 129, '2014-01-15 00:46:23.000000', 'consum', 0.0219, 'lps'),
	(495718, 129, '2014-01-15 00:46:24.000000', 'consum', 0.0215, 'lps'),
	(495719, 129, '2014-01-15 00:46:25.000000', 'consum', 0.0222, 'lps'),
	(495720, 129, '2014-01-15 00:46:26.000000', 'consum', 0.0214, 'lps'),
	(495721, 129, '2014-01-15 00:46:27.000000', 'consum', 0.0222, 'lps'),
	(495722, 129, '2014-01-15 00:46:28.000000', 'consum', 0.0218, 'lps'),
	(495723, 129, '2014-01-15 00:46:29.000000', 'consum', 0.0214, 'lps'),
	(495724, 129, '2014-01-15 00:46:30.000000', 'consum', 0.0220, 'lps'),
	(495725, 129, '2014-01-15 00:46:31.000000', 'consum', 0.0221, 'lps'),
	(495726, 129, '2014-01-15 00:46:32.000000', 'consum', 0.0221, 'lps'),
	(495727, 129, '2014-01-15 00:46:33.000000', 'consum', 0.0219, 'lps'),
	(495728, 129, '2014-01-15 00:46:34.000000', 'consum', 0.0221, 'lps'),
	(495729, 129, '2014-01-15 00:46:35.000000', 'consum', 0.0210, 'lps'),
	(495730, 129, '2014-01-15 00:46:36.000000', 'consum', 0.0220, 'lps'),
	(495731, 129, '2014-01-15 00:46:37.000000', 'consum', 0.0220, 'lps'),
	(495732, 129, '2014-01-15 00:46:38.000000', 'consum', 0.0216, 'lps'),
	(495733, 129, '2014-01-15 00:46:39.000000', 'consum', 0.0223, 'lps'),
	(495734, 129, '2014-01-15 00:46:40.000000', 'consum', 0.0217, 'lps'),
	(495735, 129, '2014-01-15 00:46:41.000000', 'consum', 0.0222, 'lps'),
	(495736, 129, '2014-01-15 00:46:42.000000', 'consum', 0.0219, 'lps'),
	(495737, 129, '2014-01-15 00:46:43.000000', 'consum', 0.0220, 'lps'),
	(495738, 129, '2014-01-15 00:46:44.000000', 'consum', 0.0221, 'lps'),
	(495739, 129, '2014-01-15 00:46:45.000000', 'consum', 0.0220, 'lps'),
	(495740, 129, '2014-01-15 00:46:46.000000', 'consum', 0.0212, 'lps'),
	(495741, 129, '2014-01-15 00:46:47.000000', 'consum', 0.0221, 'lps'),
	(495742, 129, '2014-01-15 00:46:48.000000', 'consum', 0.0216, 'lps'),
	(495743, 129, '2014-01-15 00:46:49.000000', 'consum', 0.0210, 'lps'),
	(495744, 129, '2014-01-15 00:46:50.000000', 'consum', 0.0219, 'lps'),
	(495745, 129, '2014-01-15 00:46:51.000000', 'consum', 0.0212, 'lps'),
	(495746, 129, '2014-01-15 00:46:52.000000', 'consum', 0.0222, 'lps'),
	(495747, 129, '2014-01-15 00:46:53.000000', 'consum', 0.0210, 'lps'),
	(495748, 129, '2014-01-15 00:46:54.000000', 'consum', 0.0214, 'lps'),
	(495749, 129, '2014-01-15 00:46:55.000000', 'consum', 0.0218, 'lps'),
	(495750, 129, '2014-01-15 00:46:56.000000', 'consum', 0.0223, 'lps'),
	(495751, 129, '2014-01-15 00:46:57.000000', 'consum', 0.0211, 'lps'),
	(495752, 129, '2014-01-15 00:46:58.000000', 'consum', 0.0220, 'lps'),
	(495753, 129, '2014-01-15 00:46:59.000000', 'consum', 0.0213, 'lps'),
	(495754, 129, '2014-01-15 00:47:00.000000', 'consum', 0.0210, 'lps'),
	(495755, 129, '2014-01-15 00:47:01.000000', 'consum', 0.0214, 'lps'),
	(495756, 129, '2014-01-15 00:47:02.000000', 'consum', 0.0217, 'lps'),
	(495757, 129, '2014-01-15 00:47:03.000000', 'consum', 0.0219, 'lps'),
	(495758, 129, '2014-01-15 00:47:04.000000', 'consum', 0.0220, 'lps'),
	(495759, 129, '2014-01-15 00:47:05.000000', 'consum', 0.0218, 'lps'),
	(495760, 129, '2014-01-15 00:47:06.000000', 'consum', 0.0210, 'lps'),
	(495761, 129, '2014-01-15 00:47:07.000000', 'consum', 0.0213, 'lps'),
	(495762, 129, '2014-01-15 00:47:08.000000', 'consum', 0.0210, 'lps'),
	(495763, 129, '2014-01-15 00:47:09.000000', 'consum', 0.0219, 'lps'),
	(495764, 129, '2014-01-15 00:47:10.000000', 'consum', 0.0210, 'lps'),
	(495765, 129, '2014-01-15 00:47:11.000000', 'consum', 0.0212, 'lps'),
	(495766, 129, '2014-01-15 00:47:12.000000', 'consum', 0.0222, 'lps'),
	(495767, 129, '2014-01-15 00:47:13.000000', 'consum', 0.0222, 'lps'),
	(495768, 129, '2014-01-15 00:47:14.000000', 'consum', 0.0219, 'lps'),
	(495769, 129, '2014-01-15 00:47:15.000000', 'consum', 0.0220, 'lps'),
	(495770, 129, '2014-01-15 00:47:16.000000', 'consum', 0.0220, 'lps'),
	(495771, 129, '2014-01-15 00:47:17.000000', 'consum', 0.0216, 'lps'),
	(495772, 129, '2014-01-15 00:47:18.000000', 'consum', 0.0212, 'lps'),
	(495773, 129, '2014-01-15 00:47:19.000000', 'consum', 0.0216, 'lps'),
	(495774, 129, '2014-01-15 00:47:20.000000', 'consum', 0.0222, 'lps'),
	(495775, 129, '2014-01-15 00:47:21.000000', 'consum', 0.0222, 'lps'),
	(495776, 129, '2014-01-15 00:47:22.000000', 'consum', 0.0221, 'lps'),
	(495777, 129, '2014-01-15 00:47:23.000000', 'consum', 0.0218, 'lps'),
	(495778, 129, '2014-01-15 00:47:24.000000', 'consum', 0.0215, 'lps'),
	(495779, 129, '2014-01-15 00:47:25.000000', 'consum', 0.0211, 'lps'),
	(495780, 129, '2014-01-15 00:47:26.000000', 'consum', 0.0213, 'lps'),
	(495781, 129, '2014-01-15 00:47:27.000000', 'consum', 0.0212, 'lps'),
	(495782, 129, '2014-01-15 00:47:28.000000', 'consum', 0.0211, 'lps'),
	(495783, 129, '2014-01-15 00:47:29.000000', 'consum', 0.0222, 'lps'),
	(495784, 129, '2014-01-15 00:47:30.000000', 'consum', 0.0210, 'lps'),
	(495785, 129, '2014-01-15 00:47:31.000000', 'consum', 0.0219, 'lps'),
	(495786, 129, '2014-01-15 00:47:32.000000', 'consum', 0.0214, 'lps'),
	(495787, 129, '2014-01-15 00:47:33.000000', 'consum', 0.0217, 'lps'),
	(495788, 129, '2014-01-15 00:47:34.000000', 'consum', 0.0219, 'lps'),
	(495789, 129, '2014-01-15 00:47:35.000000', 'consum', 0.0222, 'lps'),
	(495790, 129, '2014-01-15 00:47:36.000000', 'consum', 0.0215, 'lps'),
	(495791, 129, '2014-01-15 00:47:37.000000', 'consum', 0.0213, 'lps'),
	(495792, 129, '2014-01-15 00:47:38.000000', 'consum', 0.0210, 'lps'),
	(495793, 129, '2014-01-15 00:47:39.000000', 'consum', 0.0217, 'lps'),
	(495794, 129, '2014-01-15 00:47:40.000000', 'consum', 0.0215, 'lps'),
	(495795, 129, '2014-01-15 00:47:41.000000', 'consum', 0.0214, 'lps'),
	(495796, 129, '2014-01-15 00:47:42.000000', 'consum', 0.0217, 'lps'),
	(495797, 129, '2014-01-15 00:47:43.000000', 'consum', 0.0220, 'lps'),
	(495798, 129, '2014-01-15 00:47:44.000000', 'consum', 0.0211, 'lps'),
	(495799, 129, '2014-01-15 00:47:45.000000', 'consum', 0.0214, 'lps'),
	(495800, 129, '2014-01-15 00:47:46.000000', 'consum', 0.0213, 'lps'),
	(495801, 129, '2014-01-15 00:47:47.000000', 'consum', 0.0214, 'lps'),
	(495802, 129, '2014-01-15 00:47:48.000000', 'consum', 0.0219, 'lps'),
	(495803, 129, '2014-01-15 00:47:49.000000', 'consum', 0.0219, 'lps'),
	(495804, 129, '2014-01-15 00:47:50.000000', 'consum', 0.0211, 'lps'),
	(495805, 129, '2014-01-15 00:47:51.000000', 'consum', 0.0220, 'lps'),
	(495806, 129, '2014-01-15 00:47:52.000000', 'consum', 0.0214, 'lps'),
	(495807, 129, '2014-01-15 00:47:53.000000', 'consum', 0.0214, 'lps'),
	(495808, 129, '2014-01-15 00:47:54.000000', 'consum', 0.0221, 'lps'),
	(495809, 129, '2014-01-15 00:47:55.000000', 'consum', 0.0210, 'lps'),
	(495810, 129, '2014-01-15 00:47:56.000000', 'consum', 0.0218, 'lps'),
	(495811, 129, '2014-01-15 00:47:57.000000', 'consum', 0.0221, 'lps'),
	(495812, 129, '2014-01-15 00:47:58.000000', 'consum', 0.0217, 'lps'),
	(495813, 129, '2014-01-15 00:47:59.000000', 'consum', 0.0213, 'lps'),
	(495814, 129, '2014-01-15 00:48:00.000000', 'consum', 0.0217, 'lps'),
	(495815, 129, '2014-01-15 00:48:01.000000', 'consum', 0.0222, 'lps'),
	(495816, 129, '2014-01-15 00:48:02.000000', 'consum', 0.0223, 'lps'),
	(495817, 129, '2014-01-15 00:48:03.000000', 'consum', 0.0213, 'lps'),
	(495818, 129, '2014-01-15 00:48:04.000000', 'consum', 0.0211, 'lps'),
	(495819, 129, '2014-01-15 00:48:05.000000', 'consum', 0.0223, 'lps'),
	(495820, 129, '2014-01-15 00:48:06.000000', 'consum', 0.0216, 'lps'),
	(495821, 129, '2014-01-15 00:48:07.000000', 'consum', 0.0214, 'lps'),
	(495822, 129, '2014-01-15 00:48:08.000000', 'consum', 0.0214, 'lps'),
	(495823, 129, '2014-01-15 00:48:09.000000', 'consum', 0.0218, 'lps'),
	(495824, 129, '2014-01-15 00:48:10.000000', 'consum', 0.0211, 'lps'),
	(495825, 129, '2014-01-15 00:48:11.000000', 'consum', 0.0219, 'lps'),
	(495826, 129, '2014-01-15 00:48:12.000000', 'consum', 0.0212, 'lps'),
	(495827, 129, '2014-01-15 00:48:13.000000', 'consum', 0.0222, 'lps'),
	(495828, 129, '2014-01-15 00:48:14.000000', 'consum', 0.0222, 'lps'),
	(495829, 129, '2014-01-15 00:48:15.000000', 'consum', 0.0222, 'lps'),
	(495830, 129, '2014-01-15 00:48:16.000000', 'consum', 0.0220, 'lps'),
	(495831, 129, '2014-01-15 00:48:17.000000', 'consum', 0.0210, 'lps'),
	(495832, 129, '2014-01-15 00:48:18.000000', 'consum', 0.0222, 'lps'),
	(495833, 129, '2014-01-15 00:48:19.000000', 'consum', 0.0213, 'lps'),
	(495834, 129, '2014-01-15 00:48:20.000000', 'consum', 0.0219, 'lps'),
	(495835, 129, '2014-01-15 00:48:21.000000', 'consum', 0.0218, 'lps'),
	(495836, 129, '2014-01-15 00:48:22.000000', 'consum', 0.0222, 'lps'),
	(495837, 129, '2014-01-15 00:48:23.000000', 'consum', 0.0221, 'lps'),
	(495838, 129, '2014-01-15 00:48:24.000000', 'consum', 0.0213, 'lps'),
	(495839, 129, '2014-01-15 00:48:25.000000', 'consum', 0.0220, 'lps'),
	(495840, 129, '2014-01-15 00:48:26.000000', 'consum', 0.0211, 'lps'),
	(495841, 129, '2014-01-15 00:48:27.000000', 'consum', 0.0213, 'lps'),
	(495842, 129, '2014-01-15 00:48:28.000000', 'consum', 0.0221, 'lps'),
	(495843, 129, '2014-01-15 00:48:29.000000', 'consum', 0.0217, 'lps'),
	(495844, 129, '2014-01-15 00:48:30.000000', 'consum', 0.0211, 'lps'),
	(495845, 129, '2014-01-15 00:48:31.000000', 'consum', 0.0222, 'lps'),
	(495846, 129, '2014-01-15 00:48:32.000000', 'consum', 0.0213, 'lps'),
	(495847, 129, '2014-01-15 00:48:33.000000', 'consum', 0.0219, 'lps'),
	(495848, 129, '2014-01-15 00:48:34.000000', 'consum', 0.0216, 'lps'),
	(495849, 129, '2014-01-15 00:48:35.000000', 'consum', 0.0216, 'lps'),
	(495850, 129, '2014-01-15 00:48:36.000000', 'consum', 0.0220, 'lps'),
	(495851, 129, '2014-01-15 00:48:37.000000', 'consum', 0.0214, 'lps'),
	(495852, 129, '2014-01-15 00:48:38.000000', 'consum', 0.0218, 'lps'),
	(495853, 129, '2014-01-15 00:48:39.000000', 'consum', 0.0221, 'lps'),
	(495854, 129, '2014-01-15 00:48:40.000000', 'consum', 0.0215, 'lps'),
	(495855, 129, '2014-01-15 00:48:41.000000', 'consum', 0.0216, 'lps'),
	(495856, 129, '2014-01-15 00:48:42.000000', 'consum', 0.0211, 'lps'),
	(495857, 129, '2014-01-15 00:48:43.000000', 'consum', 0.0213, 'lps'),
	(495858, 129, '2014-01-15 00:48:44.000000', 'consum', 0.0220, 'lps'),
	(495859, 129, '2014-01-15 00:48:45.000000', 'consum', 0.0210, 'lps'),
	(495860, 129, '2014-01-15 00:48:46.000000', 'consum', 0.0223, 'lps'),
	(495861, 129, '2014-01-15 00:48:47.000000', 'consum', 0.0220, 'lps'),
	(495862, 129, '2014-01-15 00:48:48.000000', 'consum', 0.0221, 'lps'),
	(495863, 129, '2014-01-15 00:48:49.000000', 'consum', 0.0210, 'lps'),
	(495864, 129, '2014-01-15 00:48:50.000000', 'consum', 0.0217, 'lps'),
	(495865, 129, '2014-01-15 00:48:51.000000', 'consum', 0.0216, 'lps'),
	(495866, 129, '2014-01-15 00:48:52.000000', 'consum', 0.0222, 'lps'),
	(495867, 129, '2014-01-15 00:48:53.000000', 'consum', 0.0210, 'lps'),
	(495868, 129, '2014-01-15 00:48:54.000000', 'consum', 0.0217, 'lps'),
	(495869, 129, '2014-01-15 00:48:55.000000', 'consum', 0.0219, 'lps'),
	(495870, 129, '2014-01-15 00:48:56.000000', 'consum', 0.0219, 'lps'),
	(495871, 129, '2014-01-15 00:48:57.000000', 'consum', 0.0216, 'lps'),
	(495872, 129, '2014-01-15 00:48:58.000000', 'consum', 0.0212, 'lps'),
	(495873, 129, '2014-01-15 00:48:59.000000', 'consum', 0.0215, 'lps'),
	(495874, 129, '2014-01-15 00:49:00.000000', 'consum', 0.0216, 'lps'),
	(495875, 129, '2014-01-15 00:49:01.000000', 'consum', 0.0213, 'lps'),
	(495876, 129, '2014-01-15 00:49:02.000000', 'consum', 0.0222, 'lps'),
	(495877, 129, '2014-01-15 00:49:03.000000', 'consum', 0.0220, 'lps'),
	(495878, 129, '2014-01-15 00:49:04.000000', 'consum', 0.0223, 'lps'),
	(495879, 129, '2014-01-15 00:49:05.000000', 'consum', 0.0217, 'lps'),
	(495880, 129, '2014-01-15 00:49:06.000000', 'consum', 0.0222, 'lps'),
	(495881, 129, '2014-01-15 00:49:07.000000', 'consum', 0.0221, 'lps'),
	(495882, 129, '2014-01-15 00:49:08.000000', 'consum', 0.0216, 'lps'),
	(495883, 129, '2014-01-15 00:49:09.000000', 'consum', 0.0220, 'lps'),
	(495884, 129, '2014-01-15 00:49:10.000000', 'consum', 0.0216, 'lps'),
	(495885, 129, '2014-01-15 00:49:11.000000', 'consum', 0.0222, 'lps'),
	(495886, 129, '2014-01-15 00:49:12.000000', 'consum', 0.0211, 'lps'),
	(495887, 129, '2014-01-15 00:49:13.000000', 'consum', 0.0223, 'lps'),
	(495888, 129, '2014-01-15 00:49:14.000000', 'consum', 0.0217, 'lps'),
	(495889, 129, '2014-01-15 00:49:15.000000', 'consum', 0.0219, 'lps'),
	(495890, 129, '2014-01-15 00:49:16.000000', 'consum', 0.0221, 'lps'),
	(495891, 129, '2014-01-15 00:49:17.000000', 'consum', 0.0223, 'lps'),
	(495892, 129, '2014-01-15 00:49:18.000000', 'consum', 0.0214, 'lps'),
	(495893, 129, '2014-01-15 00:49:19.000000', 'consum', 0.0220, 'lps'),
	(495894, 129, '2014-01-15 00:49:20.000000', 'consum', 0.0222, 'lps'),
	(495895, 129, '2014-01-15 00:49:21.000000', 'consum', 0.0212, 'lps'),
	(495896, 129, '2014-01-15 00:49:22.000000', 'consum', 0.0213, 'lps'),
	(495897, 129, '2014-01-15 00:49:23.000000', 'consum', 0.0219, 'lps'),
	(495898, 129, '2014-01-15 00:49:24.000000', 'consum', 0.0217, 'lps'),
	(495899, 129, '2014-01-15 00:49:25.000000', 'consum', 0.0221, 'lps'),
	(495900, 129, '2014-01-15 00:49:26.000000', 'consum', 0.0215, 'lps'),
	(495901, 129, '2014-01-15 00:49:27.000000', 'consum', 0.0218, 'lps'),
	(495902, 129, '2014-01-15 00:49:28.000000', 'consum', 0.0221, 'lps'),
	(495903, 129, '2014-01-15 00:49:29.000000', 'consum', 0.0212, 'lps'),
	(495904, 129, '2014-01-15 00:49:30.000000', 'consum', 0.0217, 'lps'),
	(495905, 129, '2014-01-15 00:49:31.000000', 'consum', 0.0211, 'lps'),
	(495906, 129, '2014-01-15 00:49:32.000000', 'consum', 0.0223, 'lps'),
	(495907, 129, '2014-01-15 00:49:33.000000', 'consum', 0.0217, 'lps'),
	(495908, 129, '2014-01-15 00:49:34.000000', 'consum', 0.0221, 'lps'),
	(495909, 129, '2014-01-15 00:49:35.000000', 'consum', 0.0216, 'lps'),
	(495910, 129, '2014-01-15 00:49:36.000000', 'consum', 0.0222, 'lps'),
	(495911, 129, '2014-01-15 00:49:37.000000', 'consum', 0.0210, 'lps'),
	(495912, 129, '2014-01-15 00:49:38.000000', 'consum', 0.0218, 'lps'),
	(495913, 129, '2014-01-15 00:49:39.000000', 'consum', 0.0220, 'lps'),
	(495914, 129, '2014-01-15 00:49:40.000000', 'consum', 0.0210, 'lps'),
	(495915, 129, '2014-01-15 00:49:41.000000', 'consum', 0.0222, 'lps'),
	(495916, 129, '2014-01-15 00:49:42.000000', 'consum', 0.0214, 'lps'),
	(495917, 129, '2014-01-15 00:49:43.000000', 'consum', 0.0210, 'lps'),
	(495918, 129, '2014-01-15 00:49:44.000000', 'consum', 0.0210, 'lps'),
	(495919, 129, '2014-01-15 00:49:45.000000', 'consum', 0.0211, 'lps'),
	(495920, 129, '2014-01-15 00:49:46.000000', 'consum', 0.0214, 'lps'),
	(495921, 129, '2014-01-15 00:49:47.000000', 'consum', 0.0216, 'lps'),
	(495922, 129, '2014-01-15 00:49:48.000000', 'consum', 0.0216, 'lps'),
	(495923, 129, '2014-01-15 00:49:49.000000', 'consum', 0.0220, 'lps'),
	(495924, 129, '2014-01-15 00:49:50.000000', 'consum', 0.0214, 'lps'),
	(495925, 129, '2014-01-15 00:49:51.000000', 'consum', 0.0215, 'lps'),
	(495926, 129, '2014-01-15 00:49:52.000000', 'consum', 0.0222, 'lps'),
	(495927, 129, '2014-01-15 00:49:53.000000', 'consum', 0.0214, 'lps'),
	(495928, 129, '2014-01-15 00:49:54.000000', 'consum', 0.0210, 'lps'),
	(495929, 129, '2014-01-15 00:49:55.000000', 'consum', 0.0210, 'lps'),
	(495930, 129, '2014-01-15 00:49:56.000000', 'consum', 0.0212, 'lps'),
	(495931, 129, '2014-01-15 00:49:57.000000', 'consum', 0.0220, 'lps'),
	(495932, 129, '2014-01-15 00:49:58.000000', 'consum', 0.0214, 'lps'),
	(495933, 129, '2014-01-15 00:49:59.000000', 'consum', 0.0214, 'lps'),
	(495934, 129, '2014-01-15 00:50:00.000000', 'consum', 0.0220, 'lps'),
	(495935, 129, '2014-01-15 00:50:01.000000', 'consum', 0.0218, 'lps'),
	(495936, 129, '2014-01-15 00:50:02.000000', 'consum', 0.0221, 'lps'),
	(495937, 129, '2014-01-15 00:50:03.000000', 'consum', 0.0215, 'lps'),
	(495938, 129, '2014-01-15 00:50:04.000000', 'consum', 0.0215, 'lps'),
	(495939, 129, '2014-01-15 00:50:05.000000', 'consum', 0.0219, 'lps'),
	(495940, 129, '2014-01-15 00:50:06.000000', 'consum', 0.0216, 'lps'),
	(495941, 129, '2014-01-15 00:50:07.000000', 'consum', 0.0210, 'lps'),
	(495942, 129, '2014-01-15 00:50:08.000000', 'consum', 0.0222, 'lps'),
	(495943, 129, '2014-01-15 00:50:09.000000', 'consum', 0.0214, 'lps'),
	(495944, 129, '2014-01-15 00:50:10.000000', 'consum', 0.0222, 'lps'),
	(495945, 129, '2014-01-15 00:50:11.000000', 'consum', 0.0217, 'lps'),
	(495946, 129, '2014-01-15 00:50:12.000000', 'consum', 0.0211, 'lps'),
	(495947, 129, '2014-01-15 00:50:13.000000', 'consum', 0.0221, 'lps'),
	(495948, 129, '2014-01-15 00:50:14.000000', 'consum', 0.0223, 'lps'),
	(495949, 129, '2014-01-15 00:50:15.000000', 'consum', 0.0211, 'lps'),
	(495950, 129, '2014-01-15 00:50:16.000000', 'consum', 0.0220, 'lps'),
	(495951, 129, '2014-01-15 00:50:17.000000', 'consum', 0.0216, 'lps'),
	(495952, 129, '2014-01-15 00:50:18.000000', 'consum', 0.0212, 'lps'),
	(495953, 129, '2014-01-15 00:50:19.000000', 'consum', 0.0215, 'lps'),
	(495954, 129, '2014-01-15 00:50:20.000000', 'consum', 0.0215, 'lps'),
	(495955, 129, '2014-01-15 00:50:21.000000', 'consum', 0.0219, 'lps'),
	(495956, 129, '2014-01-15 00:50:22.000000', 'consum', 0.0213, 'lps'),
	(495957, 129, '2014-01-15 00:50:23.000000', 'consum', 0.0214, 'lps'),
	(495958, 129, '2014-01-15 00:50:24.000000', 'consum', 0.0221, 'lps'),
	(495959, 129, '2014-01-15 00:50:25.000000', 'consum', 0.0214, 'lps'),
	(495960, 129, '2014-01-15 00:50:26.000000', 'consum', 0.0222, 'lps'),
	(495961, 129, '2014-01-15 00:50:27.000000', 'consum', 0.0216, 'lps'),
	(495962, 129, '2014-01-15 00:50:28.000000', 'consum', 0.0221, 'lps'),
	(495963, 129, '2014-01-15 00:50:29.000000', 'consum', 0.0216, 'lps'),
	(495964, 129, '2014-01-15 00:50:30.000000', 'consum', 0.0211, 'lps'),
	(495965, 129, '2014-01-15 00:50:31.000000', 'consum', 0.0212, 'lps'),
	(495966, 129, '2014-01-15 00:50:32.000000', 'consum', 0.0217, 'lps'),
	(495967, 129, '2014-01-15 00:50:33.000000', 'consum', 0.0223, 'lps'),
	(495968, 129, '2014-01-15 00:50:34.000000', 'consum', 0.0216, 'lps'),
	(495969, 129, '2014-01-15 00:50:35.000000', 'consum', 0.0214, 'lps'),
	(495970, 129, '2014-01-15 00:50:36.000000', 'consum', 0.0212, 'lps'),
	(495971, 129, '2014-01-15 00:50:37.000000', 'consum', 0.0223, 'lps'),
	(495972, 129, '2014-01-15 00:50:38.000000', 'consum', 0.0211, 'lps'),
	(495973, 129, '2014-01-15 00:50:39.000000', 'consum', 0.0222, 'lps'),
	(495974, 129, '2014-01-15 00:50:40.000000', 'consum', 0.0211, 'lps'),
	(495975, 129, '2014-01-15 00:50:41.000000', 'consum', 0.0222, 'lps'),
	(495976, 129, '2014-01-15 00:50:42.000000', 'consum', 0.0212, 'lps'),
	(495977, 129, '2014-01-15 00:50:43.000000', 'consum', 0.0212, 'lps'),
	(495978, 129, '2014-01-15 00:50:44.000000', 'consum', 0.0215, 'lps'),
	(495979, 129, '2014-01-15 00:50:45.000000', 'consum', 0.0214, 'lps'),
	(495980, 129, '2014-01-15 00:50:46.000000', 'consum', 0.0215, 'lps'),
	(495981, 129, '2014-01-15 00:50:47.000000', 'consum', 0.0211, 'lps'),
	(495982, 129, '2014-01-15 00:50:48.000000', 'consum', 0.0215, 'lps'),
	(495983, 129, '2014-01-15 00:50:49.000000', 'consum', 0.0217, 'lps'),
	(495984, 129, '2014-01-15 00:50:50.000000', 'consum', 0.0215, 'lps'),
	(495985, 129, '2014-01-15 00:50:51.000000', 'consum', 0.0217, 'lps'),
	(495986, 129, '2014-01-15 00:50:52.000000', 'consum', 0.0216, 'lps'),
	(495987, 129, '2014-01-15 00:50:53.000000', 'consum', 0.0220, 'lps'),
	(495988, 129, '2014-01-15 00:50:54.000000', 'consum', 0.0214, 'lps'),
	(495989, 129, '2014-01-15 00:50:55.000000', 'consum', 0.0213, 'lps'),
	(495990, 129, '2014-01-15 00:50:56.000000', 'consum', 0.0213, 'lps'),
	(495991, 129, '2014-01-15 00:50:57.000000', 'consum', 0.0217, 'lps'),
	(495992, 129, '2014-01-15 00:50:58.000000', 'consum', 0.0223, 'lps'),
	(495993, 129, '2014-01-15 00:50:59.000000', 'consum', 0.0211, 'lps'),
	(495994, 129, '2014-01-15 00:51:00.000000', 'consum', 0.0218, 'lps'),
	(495995, 129, '2014-01-15 00:51:01.000000', 'consum', 0.0219, 'lps'),
	(495996, 129, '2014-01-15 00:51:02.000000', 'consum', 0.0221, 'lps'),
	(495997, 129, '2014-01-15 00:51:03.000000', 'consum', 0.0221, 'lps'),
	(495998, 129, '2014-01-15 00:51:04.000000', 'consum', 0.0221, 'lps'),
	(495999, 129, '2014-01-15 00:51:05.000000', 'consum', 0.0216, 'lps'),
	(496000, 129, '2014-01-15 00:51:06.000000', 'consum', 0.0211, 'lps'),
	(496001, 129, '2014-01-15 00:51:07.000000', 'consum', 0.0222, 'lps'),
	(496002, 129, '2014-01-15 00:51:08.000000', 'consum', 0.0212, 'lps'),
	(496003, 129, '2014-01-15 00:51:09.000000', 'consum', 0.0212, 'lps'),
	(496004, 129, '2014-01-15 00:51:10.000000', 'consum', 0.0216, 'lps'),
	(496005, 129, '2014-01-15 00:51:11.000000', 'consum', 0.0218, 'lps'),
	(496006, 129, '2014-01-15 00:51:12.000000', 'consum', 0.0221, 'lps'),
	(496007, 129, '2014-01-15 00:51:13.000000', 'consum', 0.0213, 'lps'),
	(496008, 129, '2014-01-15 00:51:14.000000', 'consum', 0.0222, 'lps'),
	(496009, 129, '2014-01-15 00:51:15.000000', 'consum', 0.0219, 'lps'),
	(496010, 129, '2014-01-15 00:51:16.000000', 'consum', 0.0219, 'lps'),
	(496011, 129, '2014-01-15 00:51:17.000000', 'consum', 0.0216, 'lps'),
	(496012, 129, '2014-01-15 00:51:18.000000', 'consum', 0.0214, 'lps'),
	(496013, 129, '2014-01-15 00:51:19.000000', 'consum', 0.0213, 'lps'),
	(496014, 129, '2014-01-15 00:51:20.000000', 'consum', 0.0211, 'lps'),
	(496015, 129, '2014-01-15 00:51:21.000000', 'consum', 0.0219, 'lps'),
	(496016, 129, '2014-01-15 00:51:22.000000', 'consum', 0.0214, 'lps'),
	(496017, 129, '2014-01-15 00:51:23.000000', 'consum', 0.0216, 'lps'),
	(496018, 129, '2014-01-15 00:51:24.000000', 'consum', 0.0213, 'lps'),
	(496019, 129, '2014-01-15 00:51:25.000000', 'consum', 0.0221, 'lps'),
	(496020, 129, '2014-01-15 00:51:26.000000', 'consum', 0.0217, 'lps'),
	(496021, 129, '2014-01-15 00:51:27.000000', 'consum', 0.0210, 'lps'),
	(496022, 129, '2014-01-15 00:51:28.000000', 'consum', 0.0218, 'lps'),
	(496023, 129, '2014-01-15 00:51:29.000000', 'consum', 0.0221, 'lps'),
	(496024, 129, '2014-01-15 00:51:30.000000', 'consum', 0.0214, 'lps'),
	(496025, 129, '2014-01-15 00:51:31.000000', 'consum', 0.0214, 'lps'),
	(496026, 129, '2014-01-15 00:51:32.000000', 'consum', 0.0217, 'lps'),
	(496027, 129, '2014-01-15 00:51:33.000000', 'consum', 0.0221, 'lps'),
	(496028, 129, '2014-01-15 00:51:34.000000', 'consum', 0.0216, 'lps'),
	(496029, 129, '2014-01-15 00:51:35.000000', 'consum', 0.0220, 'lps'),
	(496030, 129, '2014-01-15 00:51:36.000000', 'consum', 0.0215, 'lps'),
	(496031, 129, '2014-01-15 00:51:37.000000', 'consum', 0.0219, 'lps'),
	(496032, 129, '2014-01-15 00:51:38.000000', 'consum', 0.0212, 'lps'),
	(496033, 129, '2014-01-15 00:51:39.000000', 'consum', 0.0210, 'lps'),
	(496034, 129, '2014-01-15 00:51:40.000000', 'consum', 0.0218, 'lps'),
	(496035, 129, '2014-01-15 00:51:41.000000', 'consum', 0.0210, 'lps'),
	(496036, 129, '2014-01-15 00:51:42.000000', 'consum', 0.0212, 'lps'),
	(496037, 129, '2014-01-15 00:51:43.000000', 'consum', 0.0222, 'lps'),
	(496038, 129, '2014-01-15 00:51:44.000000', 'consum', 0.0220, 'lps'),
	(496039, 129, '2014-01-15 00:51:45.000000', 'consum', 0.0214, 'lps'),
	(496040, 129, '2014-01-15 00:51:46.000000', 'consum', 0.0211, 'lps'),
	(496041, 129, '2014-01-15 00:51:47.000000', 'consum', 0.0219, 'lps'),
	(496042, 129, '2014-01-15 00:51:48.000000', 'consum', 0.0223, 'lps'),
	(496043, 129, '2014-01-15 00:51:49.000000', 'consum', 0.0220, 'lps'),
	(496044, 129, '2014-01-15 00:51:50.000000', 'consum', 0.0223, 'lps'),
	(496045, 129, '2014-01-15 00:51:51.000000', 'consum', 0.0216, 'lps'),
	(496046, 129, '2014-01-15 00:51:52.000000', 'consum', 0.0216, 'lps'),
	(496047, 129, '2014-01-15 00:51:53.000000', 'consum', 0.0221, 'lps'),
	(496048, 129, '2014-01-15 00:51:54.000000', 'consum', 0.0220, 'lps'),
	(496049, 129, '2014-01-15 00:51:55.000000', 'consum', 0.0214, 'lps'),
	(496050, 129, '2014-01-15 00:51:56.000000', 'consum', 0.0214, 'lps'),
	(496051, 129, '2014-01-15 00:51:57.000000', 'consum', 0.0220, 'lps'),
	(496052, 129, '2014-01-15 00:51:58.000000', 'consum', 0.0218, 'lps'),
	(496053, 129, '2014-01-15 00:51:59.000000', 'consum', 0.0223, 'lps'),
	(496054, 129, '2014-01-15 00:52:00.000000', 'consum', 0.0222, 'lps'),
	(496055, 129, '2014-01-15 00:52:01.000000', 'consum', 0.0219, 'lps'),
	(496056, 129, '2014-01-15 00:52:02.000000', 'consum', 0.0220, 'lps'),
	(496057, 129, '2014-01-15 00:52:03.000000', 'consum', 0.0220, 'lps'),
	(496058, 129, '2014-01-15 00:52:04.000000', 'consum', 0.0215, 'lps'),
	(496059, 129, '2014-01-15 00:52:05.000000', 'consum', 0.0218, 'lps'),
	(496060, 129, '2014-01-15 00:52:06.000000', 'consum', 0.0223, 'lps'),
	(496061, 129, '2014-01-15 00:52:07.000000', 'consum', 0.0222, 'lps'),
	(496062, 129, '2014-01-15 00:52:08.000000', 'consum', 0.0219, 'lps'),
	(496063, 129, '2014-01-15 00:52:09.000000', 'consum', 0.0221, 'lps'),
	(496064, 129, '2014-01-15 00:52:10.000000', 'consum', 0.0210, 'lps'),
	(496065, 129, '2014-01-15 00:52:11.000000', 'consum', 0.0220, 'lps'),
	(496066, 129, '2014-01-15 00:52:12.000000', 'consum', 0.0216, 'lps'),
	(496067, 129, '2014-01-15 00:52:13.000000', 'consum', 0.0212, 'lps'),
	(496068, 129, '2014-01-15 00:52:14.000000', 'consum', 0.0216, 'lps'),
	(496069, 129, '2014-01-15 00:52:15.000000', 'consum', 0.0222, 'lps'),
	(496070, 129, '2014-01-15 00:52:16.000000', 'consum', 0.0222, 'lps'),
	(496071, 129, '2014-01-15 00:52:17.000000', 'consum', 0.0210, 'lps'),
	(496072, 129, '2014-01-15 00:52:18.000000', 'consum', 0.0213, 'lps'),
	(496073, 129, '2014-01-15 00:52:19.000000', 'consum', 0.0214, 'lps'),
	(496074, 129, '2014-01-15 00:52:20.000000', 'consum', 0.0222, 'lps'),
	(496075, 129, '2014-01-15 00:52:21.000000', 'consum', 0.0216, 'lps'),
	(496076, 129, '2014-01-15 00:52:22.000000', 'consum', 0.0219, 'lps'),
	(496077, 129, '2014-01-15 00:52:23.000000', 'consum', 0.0223, 'lps'),
	(496078, 129, '2014-01-15 00:52:24.000000', 'consum', 0.0219, 'lps'),
	(496079, 129, '2014-01-15 00:52:25.000000', 'consum', 0.0219, 'lps'),
	(496080, 129, '2014-01-15 00:52:26.000000', 'consum', 0.0215, 'lps'),
	(496081, 129, '2014-01-15 00:52:27.000000', 'consum', 0.0223, 'lps'),
	(496082, 129, '2014-01-15 00:52:28.000000', 'consum', 0.0218, 'lps'),
	(496083, 129, '2014-01-15 00:52:29.000000', 'consum', 0.0213, 'lps'),
	(496084, 129, '2014-01-15 00:52:30.000000', 'consum', 0.0212, 'lps'),
	(496085, 129, '2014-01-15 00:52:31.000000', 'consum', 0.0213, 'lps'),
	(496086, 129, '2014-01-15 00:52:32.000000', 'consum', 0.0220, 'lps'),
	(496087, 129, '2014-01-15 00:52:33.000000', 'consum', 0.0223, 'lps'),
	(496088, 129, '2014-01-15 00:52:34.000000', 'consum', 0.0217, 'lps'),
	(496089, 129, '2014-01-15 00:52:35.000000', 'consum', 0.0220, 'lps'),
	(496090, 129, '2014-01-15 00:52:36.000000', 'consum', 0.0211, 'lps'),
	(496091, 129, '2014-01-15 00:52:37.000000', 'consum', 0.0215, 'lps'),
	(496092, 129, '2014-01-15 00:52:38.000000', 'consum', 0.0218, 'lps'),
	(496093, 129, '2014-01-15 00:52:39.000000', 'consum', 0.0221, 'lps'),
	(496094, 129, '2014-01-15 00:52:40.000000', 'consum', 0.0213, 'lps'),
	(496095, 129, '2014-01-15 00:52:41.000000', 'consum', 0.0221, 'lps'),
	(496096, 129, '2014-01-15 00:52:42.000000', 'consum', 0.0214, 'lps'),
	(496097, 129, '2014-01-15 00:52:43.000000', 'consum', 0.0211, 'lps'),
	(496098, 129, '2014-01-15 00:52:44.000000', 'consum', 0.0219, 'lps'),
	(496099, 129, '2014-01-15 00:52:45.000000', 'consum', 0.0212, 'lps'),
	(496100, 129, '2014-01-15 00:52:46.000000', 'consum', 0.0220, 'lps'),
	(496101, 129, '2014-01-15 00:52:47.000000', 'consum', 0.0212, 'lps'),
	(496102, 129, '2014-01-15 00:52:48.000000', 'consum', 0.0219, 'lps'),
	(496103, 129, '2014-01-15 00:52:49.000000', 'consum', 0.0222, 'lps'),
	(496104, 129, '2014-01-15 00:52:50.000000', 'consum', 0.0217, 'lps'),
	(496105, 129, '2014-01-15 00:52:51.000000', 'consum', 0.0221, 'lps'),
	(496106, 129, '2014-01-15 00:52:52.000000', 'consum', 0.0218, 'lps'),
	(496107, 129, '2014-01-15 00:52:53.000000', 'consum', 0.0219, 'lps'),
	(496108, 129, '2014-01-15 00:52:54.000000', 'consum', 0.0215, 'lps'),
	(496109, 129, '2014-01-15 00:52:55.000000', 'consum', 0.0222, 'lps'),
	(496110, 129, '2014-01-15 00:52:56.000000', 'consum', 0.0213, 'lps'),
	(496111, 129, '2014-01-15 00:52:57.000000', 'consum', 0.0220, 'lps'),
	(496112, 129, '2014-01-15 00:52:58.000000', 'consum', 0.0220, 'lps'),
	(496113, 129, '2014-01-15 00:52:59.000000', 'consum', 0.0220, 'lps'),
	(496114, 129, '2014-01-15 00:53:00.000000', 'consum', 0.0216, 'lps'),
	(496115, 129, '2014-01-15 00:53:01.000000', 'consum', 0.0223, 'lps'),
	(496116, 129, '2014-01-15 00:53:02.000000', 'consum', 0.0217, 'lps'),
	(496117, 129, '2014-01-15 00:53:03.000000', 'consum', 0.0221, 'lps'),
	(496118, 129, '2014-01-15 00:53:04.000000', 'consum', 0.0215, 'lps'),
	(496119, 129, '2014-01-15 00:53:05.000000', 'consum', 0.0218, 'lps'),
	(496120, 129, '2014-01-15 00:53:06.000000', 'consum', 0.0221, 'lps'),
	(496121, 129, '2014-01-15 00:53:07.000000', 'consum', 0.0212, 'lps'),
	(496122, 129, '2014-01-15 00:53:08.000000', 'consum', 0.0216, 'lps'),
	(496123, 129, '2014-01-15 00:53:09.000000', 'consum', 0.0222, 'lps'),
	(496124, 129, '2014-01-15 00:53:10.000000', 'consum', 0.0223, 'lps'),
	(496125, 129, '2014-01-15 00:53:11.000000', 'consum', 0.0213, 'lps'),
	(496126, 129, '2014-01-15 00:53:12.000000', 'consum', 0.0213, 'lps'),
	(496127, 129, '2014-01-15 00:53:13.000000', 'consum', 0.0216, 'lps'),
	(496128, 129, '2014-01-15 00:53:14.000000', 'consum', 0.0219, 'lps'),
	(496129, 129, '2014-01-15 00:53:15.000000', 'consum', 0.0211, 'lps'),
	(496130, 129, '2014-01-15 00:53:16.000000', 'consum', 0.0215, 'lps'),
	(496131, 129, '2014-01-15 00:53:17.000000', 'consum', 0.0217, 'lps'),
	(496132, 129, '2014-01-15 00:53:18.000000', 'consum', 0.0218, 'lps'),
	(496133, 129, '2014-01-15 00:53:19.000000', 'consum', 0.0213, 'lps'),
	(496134, 129, '2014-01-15 00:53:20.000000', 'consum', 0.0218, 'lps'),
	(496135, 129, '2014-01-15 00:53:21.000000', 'consum', 0.0212, 'lps'),
	(496136, 129, '2014-01-15 00:53:22.000000', 'consum', 0.0211, 'lps'),
	(496137, 129, '2014-01-15 00:53:23.000000', 'consum', 0.0223, 'lps'),
	(496138, 129, '2014-01-15 00:53:24.000000', 'consum', 0.0216, 'lps'),
	(496139, 129, '2014-01-15 00:53:25.000000', 'consum', 0.0218, 'lps'),
	(496140, 129, '2014-01-15 00:53:26.000000', 'consum', 0.0218, 'lps'),
	(496141, 129, '2014-01-15 00:53:27.000000', 'consum', 0.0212, 'lps'),
	(496142, 129, '2014-01-15 00:53:28.000000', 'consum', 0.0223, 'lps'),
	(496143, 129, '2014-01-15 00:53:29.000000', 'consum', 0.0214, 'lps'),
	(496144, 129, '2014-01-15 00:53:30.000000', 'consum', 0.0218, 'lps'),
	(496145, 129, '2014-01-15 00:53:31.000000', 'consum', 0.0213, 'lps'),
	(496146, 129, '2014-01-15 00:53:32.000000', 'consum', 0.0213, 'lps'),
	(496147, 129, '2014-01-15 00:53:33.000000', 'consum', 0.0219, 'lps'),
	(496148, 129, '2014-01-15 00:53:34.000000', 'consum', 0.0219, 'lps'),
	(496149, 129, '2014-01-15 00:53:35.000000', 'consum', 0.0214, 'lps'),
	(496150, 129, '2014-01-15 00:53:36.000000', 'consum', 0.0217, 'lps'),
	(496151, 129, '2014-01-15 00:53:37.000000', 'consum', 0.0221, 'lps'),
	(496152, 129, '2014-01-15 00:53:38.000000', 'consum', 0.0217, 'lps'),
	(496153, 129, '2014-01-15 00:53:39.000000', 'consum', 0.0212, 'lps'),
	(496154, 129, '2014-01-15 00:53:40.000000', 'consum', 0.0214, 'lps'),
	(496155, 129, '2014-01-15 00:53:41.000000', 'consum', 0.0222, 'lps'),
	(496156, 129, '2014-01-15 00:53:42.000000', 'consum', 0.0217, 'lps'),
	(496157, 129, '2014-01-15 00:53:43.000000', 'consum', 0.0211, 'lps'),
	(496158, 129, '2014-01-15 00:53:44.000000', 'consum', 0.0210, 'lps'),
	(496159, 129, '2014-01-15 00:53:45.000000', 'consum', 0.0219, 'lps'),
	(496160, 129, '2014-01-15 00:53:46.000000', 'consum', 0.0215, 'lps'),
	(496161, 129, '2014-01-15 00:53:47.000000', 'consum', 0.0210, 'lps'),
	(496162, 129, '2014-01-15 00:53:48.000000', 'consum', 0.0221, 'lps'),
	(496163, 129, '2014-01-15 00:53:49.000000', 'consum', 0.0223, 'lps'),
	(496164, 129, '2014-01-15 00:53:50.000000', 'consum', 0.0217, 'lps'),
	(496165, 129, '2014-01-15 00:53:51.000000', 'consum', 0.0220, 'lps'),
	(496166, 129, '2014-01-15 00:53:52.000000', 'consum', 0.0212, 'lps'),
	(496167, 129, '2014-01-15 00:53:53.000000', 'consum', 0.0216, 'lps'),
	(496168, 129, '2014-01-15 00:53:54.000000', 'consum', 0.0222, 'lps'),
	(496169, 129, '2014-01-15 00:53:55.000000', 'consum', 0.0210, 'lps'),
	(496170, 129, '2014-01-15 00:53:56.000000', 'consum', 0.0215, 'lps'),
	(496171, 129, '2014-01-15 00:53:57.000000', 'consum', 0.0221, 'lps'),
	(496172, 129, '2014-01-15 00:53:58.000000', 'consum', 0.0210, 'lps'),
	(496173, 129, '2014-01-15 00:53:59.000000', 'consum', 0.0218, 'lps'),
	(496174, 129, '2014-01-15 00:54:00.000000', 'consum', 0.0211, 'lps'),
	(496175, 129, '2014-01-15 00:54:01.000000', 'consum', 0.0217, 'lps'),
	(496176, 129, '2014-01-15 00:54:02.000000', 'consum', 0.0215, 'lps'),
	(496177, 129, '2014-01-15 00:54:03.000000', 'consum', 0.0216, 'lps'),
	(496178, 129, '2014-01-15 00:54:04.000000', 'consum', 0.0210, 'lps'),
	(496179, 129, '2014-01-15 00:54:05.000000', 'consum', 0.0222, 'lps'),
	(496180, 129, '2014-01-15 00:54:06.000000', 'consum', 0.0214, 'lps'),
	(496181, 129, '2014-01-15 00:54:07.000000', 'consum', 0.0210, 'lps'),
	(496182, 129, '2014-01-15 00:54:08.000000', 'consum', 0.0223, 'lps'),
	(496183, 129, '2014-01-15 00:54:09.000000', 'consum', 0.0223, 'lps'),
	(496184, 129, '2014-01-15 00:54:10.000000', 'consum', 0.0222, 'lps'),
	(496185, 129, '2014-01-15 00:54:11.000000', 'consum', 0.0217, 'lps'),
	(496186, 129, '2014-01-15 00:54:12.000000', 'consum', 0.0222, 'lps'),
	(496187, 129, '2014-01-15 00:54:13.000000', 'consum', 0.0221, 'lps'),
	(496188, 129, '2014-01-15 00:54:14.000000', 'consum', 0.0216, 'lps'),
	(496189, 129, '2014-01-15 00:54:15.000000', 'consum', 0.0222, 'lps'),
	(496190, 129, '2014-01-15 00:54:16.000000', 'consum', 0.0223, 'lps'),
	(496191, 129, '2014-01-15 00:54:17.000000', 'consum', 0.0213, 'lps'),
	(496192, 129, '2014-01-15 00:54:18.000000', 'consum', 0.0215, 'lps'),
	(496193, 129, '2014-01-15 00:54:19.000000', 'consum', 0.0214, 'lps'),
	(496194, 129, '2014-01-15 00:54:20.000000', 'consum', 0.0212, 'lps'),
	(496195, 129, '2014-01-15 00:54:21.000000', 'consum', 0.0211, 'lps'),
	(496196, 129, '2014-01-15 00:54:22.000000', 'consum', 0.0221, 'lps'),
	(496197, 129, '2014-01-15 00:54:23.000000', 'consum', 0.0222, 'lps'),
	(496198, 129, '2014-01-15 00:54:24.000000', 'consum', 0.0221, 'lps'),
	(496199, 129, '2014-01-15 00:54:25.000000', 'consum', 0.0219, 'lps'),
	(496200, 129, '2014-01-15 00:54:26.000000', 'consum', 0.0221, 'lps'),
	(496201, 129, '2014-01-15 00:54:27.000000', 'consum', 0.0223, 'lps'),
	(496202, 129, '2014-01-15 00:54:28.000000', 'consum', 0.0217, 'lps'),
	(496203, 129, '2014-01-15 00:54:29.000000', 'consum', 0.0222, 'lps'),
	(496204, 129, '2014-01-15 00:54:30.000000', 'consum', 0.0218, 'lps'),
	(496205, 129, '2014-01-15 00:54:31.000000', 'consum', 0.0216, 'lps'),
	(496206, 129, '2014-01-15 00:54:32.000000', 'consum', 0.0217, 'lps'),
	(496207, 129, '2014-01-15 00:54:33.000000', 'consum', 0.0214, 'lps'),
	(496208, 129, '2014-01-15 00:54:34.000000', 'consum', 0.0221, 'lps'),
	(496209, 129, '2014-01-15 00:54:35.000000', 'consum', 0.0214, 'lps'),
	(496210, 129, '2014-01-15 00:54:36.000000', 'consum', 0.0210, 'lps'),
	(496211, 129, '2014-01-15 00:54:37.000000', 'consum', 0.0215, 'lps'),
	(496212, 129, '2014-01-15 00:54:38.000000', 'consum', 0.0219, 'lps'),
	(496213, 129, '2014-01-15 00:54:39.000000', 'consum', 0.0213, 'lps'),
	(496214, 129, '2014-01-15 00:54:40.000000', 'consum', 0.0211, 'lps'),
	(496215, 129, '2014-01-15 00:54:41.000000', 'consum', 0.0223, 'lps'),
	(496216, 129, '2014-01-15 00:54:42.000000', 'consum', 0.0217, 'lps'),
	(496217, 129, '2014-01-15 00:54:43.000000', 'consum', 0.0219, 'lps'),
	(496218, 129, '2014-01-15 00:54:44.000000', 'consum', 0.0220, 'lps'),
	(496219, 129, '2014-01-15 00:54:45.000000', 'consum', 0.0221, 'lps'),
	(496220, 129, '2014-01-15 00:54:46.000000', 'consum', 0.0220, 'lps'),
	(496221, 129, '2014-01-15 00:54:47.000000', 'consum', 0.0215, 'lps'),
	(496222, 129, '2014-01-15 00:54:48.000000', 'consum', 0.0220, 'lps'),
	(496223, 129, '2014-01-15 00:54:49.000000', 'consum', 0.0215, 'lps'),
	(496224, 129, '2014-01-15 00:54:50.000000', 'consum', 0.0220, 'lps'),
	(496225, 129, '2014-01-15 00:54:51.000000', 'consum', 0.0216, 'lps'),
	(496226, 129, '2014-01-15 00:54:52.000000', 'consum', 0.0213, 'lps'),
	(496227, 129, '2014-01-15 00:54:53.000000', 'consum', 0.0222, 'lps'),
	(496228, 129, '2014-01-15 00:54:54.000000', 'consum', 0.0220, 'lps'),
	(496229, 129, '2014-01-15 00:54:55.000000', 'consum', 0.0222, 'lps'),
	(496230, 129, '2014-01-15 00:54:56.000000', 'consum', 0.0213, 'lps'),
	(496231, 129, '2014-01-15 00:54:57.000000', 'consum', 0.0220, 'lps'),
	(496232, 129, '2014-01-15 00:54:58.000000', 'consum', 0.0221, 'lps'),
	(496233, 129, '2014-01-15 00:54:59.000000', 'consum', 0.0221, 'lps'),
	(496234, 129, '2014-01-15 00:55:00.000000', 'consum', 0.0218, 'lps'),
	(496235, 129, '2014-01-15 00:55:01.000000', 'consum', 0.0218, 'lps'),
	(496236, 129, '2014-01-15 00:55:02.000000', 'consum', 0.0213, 'lps'),
	(496237, 129, '2014-01-15 00:55:03.000000', 'consum', 0.0213, 'lps'),
	(496238, 129, '2014-01-15 00:55:04.000000', 'consum', 0.0220, 'lps'),
	(496239, 129, '2014-01-15 00:55:05.000000', 'consum', 0.0221, 'lps'),
	(496240, 129, '2014-01-15 00:55:06.000000', 'consum', 0.0223, 'lps'),
	(496241, 129, '2014-01-15 00:55:07.000000', 'consum', 0.0213, 'lps'),
	(496242, 129, '2014-01-15 00:55:08.000000', 'consum', 0.0217, 'lps'),
	(496243, 129, '2014-01-15 00:55:09.000000', 'consum', 0.0220, 'lps'),
	(496244, 129, '2014-01-15 00:55:10.000000', 'consum', 0.0213, 'lps'),
	(496245, 129, '2014-01-15 00:55:11.000000', 'consum', 0.0221, 'lps'),
	(496246, 129, '2014-01-15 00:55:12.000000', 'consum', 0.0217, 'lps'),
	(496247, 129, '2014-01-15 00:55:13.000000', 'consum', 0.0214, 'lps'),
	(496248, 129, '2014-01-15 00:55:14.000000', 'consum', 0.0221, 'lps'),
	(496249, 129, '2014-01-15 00:55:15.000000', 'consum', 0.0213, 'lps'),
	(496250, 129, '2014-01-15 00:55:16.000000', 'consum', 0.0221, 'lps'),
	(496251, 129, '2014-01-15 00:55:17.000000', 'consum', 0.0215, 'lps'),
	(496252, 129, '2014-01-15 00:55:18.000000', 'consum', 0.0216, 'lps'),
	(496253, 129, '2014-01-15 00:55:19.000000', 'consum', 0.0213, 'lps'),
	(496254, 129, '2014-01-15 00:55:20.000000', 'consum', 0.0220, 'lps'),
	(496255, 129, '2014-01-15 00:55:21.000000', 'consum', 0.0222, 'lps'),
	(496256, 129, '2014-01-15 00:55:22.000000', 'consum', 0.0212, 'lps'),
	(496257, 129, '2014-01-15 00:55:23.000000', 'consum', 0.0213, 'lps'),
	(496258, 129, '2014-01-15 00:55:24.000000', 'consum', 0.0221, 'lps'),
	(496259, 129, '2014-01-15 00:55:25.000000', 'consum', 0.0216, 'lps'),
	(496260, 129, '2014-01-15 00:55:26.000000', 'consum', 0.0218, 'lps'),
	(496261, 129, '2014-01-15 00:55:27.000000', 'consum', 0.0219, 'lps'),
	(496262, 129, '2014-01-15 00:55:28.000000', 'consum', 0.0220, 'lps'),
	(496263, 129, '2014-01-15 00:55:29.000000', 'consum', 0.0218, 'lps'),
	(496264, 129, '2014-01-15 00:55:30.000000', 'consum', 0.0221, 'lps'),
	(496265, 129, '2014-01-15 00:55:31.000000', 'consum', 0.0211, 'lps'),
	(496266, 129, '2014-01-15 00:55:32.000000', 'consum', 0.0214, 'lps'),
	(496267, 129, '2014-01-15 00:55:33.000000', 'consum', 0.0211, 'lps'),
	(496268, 129, '2014-01-15 00:55:34.000000', 'consum', 0.0217, 'lps'),
	(496269, 129, '2014-01-15 00:55:35.000000', 'consum', 0.0217, 'lps'),
	(496270, 129, '2014-01-15 00:55:36.000000', 'consum', 0.0222, 'lps'),
	(496271, 129, '2014-01-15 00:55:37.000000', 'consum', 0.0210, 'lps'),
	(496272, 129, '2014-01-15 00:55:38.000000', 'consum', 0.0215, 'lps'),
	(496273, 129, '2014-01-15 00:55:39.000000', 'consum', 0.0222, 'lps'),
	(496274, 129, '2014-01-15 00:55:40.000000', 'consum', 0.0215, 'lps'),
	(496275, 129, '2014-01-15 00:55:41.000000', 'consum', 0.0212, 'lps'),
	(496276, 129, '2014-01-15 00:55:42.000000', 'consum', 0.0218, 'lps'),
	(496277, 129, '2014-01-15 00:55:43.000000', 'consum', 0.0219, 'lps'),
	(496278, 129, '2014-01-15 00:55:44.000000', 'consum', 0.0217, 'lps'),
	(496279, 129, '2014-01-15 00:55:45.000000', 'consum', 0.0220, 'lps'),
	(496280, 129, '2014-01-15 00:55:46.000000', 'consum', 0.0223, 'lps'),
	(496281, 129, '2014-01-15 00:55:47.000000', 'consum', 0.0218, 'lps'),
	(496282, 129, '2014-01-15 00:55:48.000000', 'consum', 0.0210, 'lps'),
	(496283, 129, '2014-01-15 00:55:49.000000', 'consum', 0.0217, 'lps'),
	(496284, 129, '2014-01-15 00:55:50.000000', 'consum', 0.0215, 'lps'),
	(496285, 129, '2014-01-15 00:55:51.000000', 'consum', 0.0215, 'lps'),
	(496286, 129, '2014-01-15 00:55:52.000000', 'consum', 0.0222, 'lps'),
	(496287, 129, '2014-01-15 00:55:53.000000', 'consum', 0.0212, 'lps'),
	(496288, 129, '2014-01-15 00:55:54.000000', 'consum', 0.0212, 'lps'),
	(496289, 129, '2014-01-15 00:55:55.000000', 'consum', 0.0215, 'lps'),
	(496290, 129, '2014-01-15 00:55:56.000000', 'consum', 0.0214, 'lps'),
	(496291, 129, '2014-01-15 00:55:57.000000', 'consum', 0.0216, 'lps'),
	(496292, 129, '2014-01-15 00:55:58.000000', 'consum', 0.0216, 'lps'),
	(496293, 129, '2014-01-15 00:55:59.000000', 'consum', 0.0220, 'lps'),
	(496294, 129, '2014-01-15 00:56:00.000000', 'consum', 0.0218, 'lps'),
	(496295, 129, '2014-01-15 00:56:01.000000', 'consum', 0.0218, 'lps'),
	(496296, 129, '2014-01-15 00:56:02.000000', 'consum', 0.0214, 'lps'),
	(496297, 129, '2014-01-15 00:56:03.000000', 'consum', 0.0221, 'lps'),
	(496298, 129, '2014-01-15 00:56:04.000000', 'consum', 0.0213, 'lps'),
	(496299, 129, '2014-01-15 00:56:05.000000', 'consum', 0.0217, 'lps'),
	(496300, 129, '2014-01-15 00:56:06.000000', 'consum', 0.0210, 'lps'),
	(496301, 129, '2014-01-15 00:56:07.000000', 'consum', 0.0215, 'lps'),
	(496302, 129, '2014-01-15 00:56:08.000000', 'consum', 0.0211, 'lps'),
	(496303, 129, '2014-01-15 00:56:09.000000', 'consum', 0.0214, 'lps'),
	(496304, 129, '2014-01-15 00:56:10.000000', 'consum', 0.0211, 'lps'),
	(496305, 129, '2014-01-15 00:56:11.000000', 'consum', 0.0220, 'lps'),
	(496306, 129, '2014-01-15 00:56:12.000000', 'consum', 0.0213, 'lps'),
	(496307, 129, '2014-01-15 00:56:13.000000', 'consum', 0.0213, 'lps'),
	(496308, 129, '2014-01-15 00:56:14.000000', 'consum', 0.0213, 'lps'),
	(496309, 129, '2014-01-15 00:56:15.000000', 'consum', 0.0218, 'lps'),
	(496310, 129, '2014-01-15 00:56:16.000000', 'consum', 0.0214, 'lps'),
	(496311, 129, '2014-01-15 00:56:17.000000', 'consum', 0.0220, 'lps'),
	(496312, 129, '2014-01-15 00:56:18.000000', 'consum', 0.0219, 'lps'),
	(496313, 129, '2014-01-15 00:56:19.000000', 'consum', 0.0214, 'lps'),
	(496314, 129, '2014-01-15 00:56:20.000000', 'consum', 0.0216, 'lps'),
	(496315, 129, '2014-01-15 00:56:21.000000', 'consum', 0.0215, 'lps'),
	(496316, 129, '2014-01-15 00:56:22.000000', 'consum', 0.0217, 'lps'),
	(496317, 129, '2014-01-15 00:56:23.000000', 'consum', 0.0217, 'lps'),
	(496318, 129, '2014-01-15 00:56:24.000000', 'consum', 0.0211, 'lps'),
	(496319, 129, '2014-01-15 00:56:25.000000', 'consum', 0.0222, 'lps'),
	(496320, 129, '2014-01-15 00:56:26.000000', 'consum', 0.0210, 'lps'),
	(496321, 129, '2014-01-15 00:56:27.000000', 'consum', 0.0218, 'lps'),
	(496322, 129, '2014-01-15 00:56:28.000000', 'consum', 0.0210, 'lps'),
	(496323, 129, '2014-01-15 00:56:29.000000', 'consum', 0.0214, 'lps'),
	(496324, 129, '2014-01-15 00:56:30.000000', 'consum', 0.0216, 'lps'),
	(496325, 129, '2014-01-15 00:56:31.000000', 'consum', 0.0214, 'lps'),
	(496326, 129, '2014-01-15 00:56:32.000000', 'consum', 0.0213, 'lps'),
	(496327, 129, '2014-01-15 00:56:33.000000', 'consum', 0.0212, 'lps'),
	(496328, 129, '2014-01-15 00:56:34.000000', 'consum', 0.0212, 'lps'),
	(496329, 129, '2014-01-15 00:56:35.000000', 'consum', 0.0216, 'lps'),
	(496330, 129, '2014-01-15 00:56:36.000000', 'consum', 0.0219, 'lps'),
	(496331, 129, '2014-01-15 00:56:37.000000', 'consum', 0.0223, 'lps'),
	(496332, 129, '2014-01-15 00:56:38.000000', 'consum', 0.0220, 'lps'),
	(496333, 129, '2014-01-15 00:56:39.000000', 'consum', 0.0210, 'lps'),
	(496334, 129, '2014-01-15 00:56:40.000000', 'consum', 0.0222, 'lps'),
	(496335, 129, '2014-01-15 00:56:41.000000', 'consum', 0.0216, 'lps'),
	(496336, 129, '2014-01-15 00:56:42.000000', 'consum', 0.0217, 'lps'),
	(496337, 129, '2014-01-15 00:56:43.000000', 'consum', 0.0215, 'lps'),
	(496338, 129, '2014-01-15 00:56:44.000000', 'consum', 0.0212, 'lps'),
	(496339, 129, '2014-01-15 00:56:45.000000', 'consum', 0.0221, 'lps'),
	(496340, 129, '2014-01-15 00:56:46.000000', 'consum', 0.0218, 'lps'),
	(496341, 129, '2014-01-15 00:56:47.000000', 'consum', 0.0218, 'lps'),
	(496342, 129, '2014-01-15 00:56:48.000000', 'consum', 0.0211, 'lps'),
	(496343, 129, '2014-01-15 00:56:49.000000', 'consum', 0.0218, 'lps'),
	(496344, 129, '2014-01-15 00:56:50.000000', 'consum', 0.0220, 'lps'),
	(496345, 129, '2014-01-15 00:56:51.000000', 'consum', 0.0211, 'lps'),
	(496346, 129, '2014-01-15 00:56:52.000000', 'consum', 0.0213, 'lps'),
	(496347, 129, '2014-01-15 00:56:53.000000', 'consum', 0.0210, 'lps'),
	(496348, 129, '2014-01-15 00:56:54.000000', 'consum', 0.0213, 'lps'),
	(496349, 129, '2014-01-15 00:56:55.000000', 'consum', 0.0213, 'lps'),
	(496350, 129, '2014-01-15 00:56:56.000000', 'consum', 0.0217, 'lps'),
	(496351, 129, '2014-01-15 00:56:57.000000', 'consum', 0.0222, 'lps'),
	(496352, 129, '2014-01-15 00:56:58.000000', 'consum', 0.0221, 'lps'),
	(496353, 129, '2014-01-15 00:56:59.000000', 'consum', 0.0214, 'lps'),
	(496354, 129, '2014-01-15 00:57:00.000000', 'consum', 0.0214, 'lps'),
	(496355, 129, '2014-01-15 00:57:01.000000', 'consum', 0.0218, 'lps'),
	(496356, 129, '2014-01-15 00:57:02.000000', 'consum', 0.0212, 'lps'),
	(496357, 129, '2014-01-15 00:57:03.000000', 'consum', 0.0223, 'lps'),
	(496358, 129, '2014-01-15 00:57:04.000000', 'consum', 0.0214, 'lps'),
	(496359, 129, '2014-01-15 00:57:05.000000', 'consum', 0.0220, 'lps'),
	(496360, 129, '2014-01-15 00:57:06.000000', 'consum', 0.0221, 'lps'),
	(496361, 129, '2014-01-15 00:57:07.000000', 'consum', 0.0219, 'lps'),
	(496362, 129, '2014-01-15 00:57:08.000000', 'consum', 0.0211, 'lps'),
	(496363, 129, '2014-01-15 00:57:09.000000', 'consum', 0.0214, 'lps'),
	(496364, 129, '2014-01-15 00:57:10.000000', 'consum', 0.0215, 'lps'),
	(496365, 129, '2014-01-15 00:57:11.000000', 'consum', 0.0221, 'lps'),
	(496366, 129, '2014-01-15 00:57:12.000000', 'consum', 0.0211, 'lps'),
	(496367, 129, '2014-01-15 00:57:13.000000', 'consum', 0.0223, 'lps'),
	(496368, 129, '2014-01-15 00:57:14.000000', 'consum', 0.0216, 'lps'),
	(496369, 129, '2014-01-15 00:57:15.000000', 'consum', 0.0215, 'lps'),
	(496370, 129, '2014-01-15 00:57:16.000000', 'consum', 0.0219, 'lps'),
	(496371, 129, '2014-01-15 00:57:17.000000', 'consum', 0.0213, 'lps'),
	(496372, 129, '2014-01-15 00:57:18.000000', 'consum', 0.0214, 'lps'),
	(496373, 129, '2014-01-15 00:57:19.000000', 'consum', 0.0219, 'lps'),
	(496374, 129, '2014-01-15 00:57:20.000000', 'consum', 0.0215, 'lps'),
	(496375, 129, '2014-01-15 00:57:21.000000', 'consum', 0.0211, 'lps'),
	(496376, 129, '2014-01-15 00:57:22.000000', 'consum', 0.0212, 'lps'),
	(496377, 129, '2014-01-15 00:57:23.000000', 'consum', 0.0219, 'lps'),
	(496378, 129, '2014-01-15 00:57:24.000000', 'consum', 0.0220, 'lps'),
	(496379, 129, '2014-01-15 00:57:25.000000', 'consum', 0.0222, 'lps'),
	(496380, 129, '2014-01-15 00:57:26.000000', 'consum', 0.0212, 'lps'),
	(496381, 129, '2014-01-15 00:57:27.000000', 'consum', 0.0214, 'lps'),
	(496382, 129, '2014-01-15 00:57:28.000000', 'consum', 0.0223, 'lps'),
	(496383, 129, '2014-01-15 00:57:29.000000', 'consum', 0.0220, 'lps'),
	(496384, 129, '2014-01-15 00:57:30.000000', 'consum', 0.0223, 'lps'),
	(496385, 129, '2014-01-15 00:57:31.000000', 'consum', 0.0218, 'lps'),
	(496386, 129, '2014-01-15 00:57:32.000000', 'consum', 0.0210, 'lps'),
	(496387, 129, '2014-01-15 00:57:33.000000', 'consum', 0.0215, 'lps'),
	(496388, 129, '2014-01-15 00:57:34.000000', 'consum', 0.0223, 'lps'),
	(496389, 129, '2014-01-15 00:57:35.000000', 'consum', 0.0216, 'lps'),
	(496390, 129, '2014-01-15 00:57:36.000000', 'consum', 0.0215, 'lps'),
	(496391, 129, '2014-01-15 00:57:37.000000', 'consum', 0.0219, 'lps'),
	(496392, 129, '2014-01-15 00:57:38.000000', 'consum', 0.0211, 'lps'),
	(496393, 129, '2014-01-15 00:57:39.000000', 'consum', 0.0218, 'lps'),
	(496394, 129, '2014-01-15 00:57:40.000000', 'consum', 0.0217, 'lps'),
	(496395, 129, '2014-01-15 00:57:41.000000', 'consum', 0.0210, 'lps'),
	(496396, 129, '2014-01-15 00:57:42.000000', 'consum', 0.0216, 'lps'),
	(496397, 129, '2014-01-15 00:57:43.000000', 'consum', 0.0214, 'lps'),
	(496398, 129, '2014-01-15 00:57:44.000000', 'consum', 0.0210, 'lps'),
	(496399, 129, '2014-01-15 00:57:45.000000', 'consum', 0.0213, 'lps'),
	(496400, 129, '2014-01-15 00:57:46.000000', 'consum', 0.0210, 'lps'),
	(496401, 129, '2014-01-15 00:57:47.000000', 'consum', 0.0217, 'lps'),
	(496402, 129, '2014-01-15 00:57:48.000000', 'consum', 0.0216, 'lps'),
	(496403, 129, '2014-01-15 00:57:49.000000', 'consum', 0.0222, 'lps'),
	(496404, 129, '2014-01-15 00:57:50.000000', 'consum', 0.0223, 'lps'),
	(496405, 129, '2014-01-15 00:57:51.000000', 'consum', 0.0211, 'lps'),
	(496406, 129, '2014-01-15 00:57:52.000000', 'consum', 0.0220, 'lps'),
	(496407, 129, '2014-01-15 00:57:53.000000', 'consum', 0.0216, 'lps'),
	(496408, 129, '2014-01-15 00:57:54.000000', 'consum', 0.0210, 'lps'),
	(496409, 129, '2014-01-15 00:57:55.000000', 'consum', 0.0220, 'lps'),
	(496410, 129, '2014-01-15 00:57:56.000000', 'consum', 0.0219, 'lps'),
	(496411, 129, '2014-01-15 00:57:57.000000', 'consum', 0.0212, 'lps'),
	(496412, 129, '2014-01-15 00:57:58.000000', 'consum', 0.0222, 'lps'),
	(496413, 129, '2014-01-15 00:57:59.000000', 'consum', 0.0221, 'lps'),
	(496414, 129, '2014-01-15 00:58:00.000000', 'consum', 0.0214, 'lps'),
	(496415, 129, '2014-01-15 00:58:01.000000', 'consum', 0.0213, 'lps'),
	(496416, 129, '2014-01-15 00:58:02.000000', 'consum', 0.0214, 'lps'),
	(496417, 129, '2014-01-15 00:58:03.000000', 'consum', 0.0220, 'lps'),
	(496418, 129, '2014-01-15 00:58:04.000000', 'consum', 0.0220, 'lps'),
	(496419, 129, '2014-01-15 00:58:05.000000', 'consum', 0.0218, 'lps'),
	(496420, 129, '2014-01-15 00:58:06.000000', 'consum', 0.0222, 'lps'),
	(496421, 129, '2014-01-15 00:58:07.000000', 'consum', 0.0217, 'lps'),
	(496422, 129, '2014-01-15 00:58:08.000000', 'consum', 0.0211, 'lps'),
	(496423, 129, '2014-01-15 00:58:09.000000', 'consum', 0.0221, 'lps'),
	(496424, 129, '2014-01-15 00:58:10.000000', 'consum', 0.0219, 'lps'),
	(496425, 129, '2014-01-15 00:58:11.000000', 'consum', 0.0211, 'lps'),
	(496426, 129, '2014-01-15 00:58:12.000000', 'consum', 0.0214, 'lps'),
	(496427, 129, '2014-01-15 00:58:13.000000', 'consum', 0.0216, 'lps'),
	(496428, 129, '2014-01-15 00:58:14.000000', 'consum', 0.0214, 'lps'),
	(496429, 129, '2014-01-15 00:58:15.000000', 'consum', 0.0212, 'lps'),
	(496430, 129, '2014-01-15 00:58:16.000000', 'consum', 0.0222, 'lps'),
	(496431, 129, '2014-01-15 00:58:17.000000', 'consum', 0.0210, 'lps'),
	(496432, 129, '2014-01-15 00:58:18.000000', 'consum', 0.0217, 'lps'),
	(496433, 129, '2014-01-15 00:58:19.000000', 'consum', 0.0217, 'lps'),
	(496434, 129, '2014-01-15 00:58:20.000000', 'consum', 0.0222, 'lps'),
	(496435, 129, '2014-01-15 00:58:21.000000', 'consum', 0.0211, 'lps'),
	(496436, 129, '2014-01-15 00:58:22.000000', 'consum', 0.0220, 'lps'),
	(496437, 129, '2014-01-15 00:58:23.000000', 'consum', 0.0216, 'lps'),
	(496438, 129, '2014-01-15 00:58:24.000000', 'consum', 0.0212, 'lps'),
	(496439, 129, '2014-01-15 00:58:25.000000', 'consum', 0.0216, 'lps'),
	(496440, 129, '2014-01-15 00:58:26.000000', 'consum', 0.0219, 'lps'),
	(496441, 129, '2014-01-15 00:58:27.000000', 'consum', 0.0212, 'lps'),
	(496442, 129, '2014-01-15 00:58:28.000000', 'consum', 0.0221, 'lps'),
	(496443, 129, '2014-01-15 00:58:29.000000', 'consum', 0.0216, 'lps'),
	(496444, 129, '2014-01-15 00:58:30.000000', 'consum', 0.0222, 'lps'),
	(496445, 129, '2014-01-15 00:58:31.000000', 'consum', 0.0210, 'lps'),
	(496446, 129, '2014-01-15 00:58:32.000000', 'consum', 0.0218, 'lps'),
	(496447, 129, '2014-01-15 00:58:33.000000', 'consum', 0.0222, 'lps'),
	(496448, 129, '2014-01-15 00:58:34.000000', 'consum', 0.0219, 'lps'),
	(496449, 129, '2014-01-15 00:58:35.000000', 'consum', 0.0220, 'lps'),
	(496450, 129, '2014-01-15 00:58:36.000000', 'consum', 0.0219, 'lps'),
	(496451, 129, '2014-01-15 00:58:37.000000', 'consum', 0.0210, 'lps'),
	(496452, 129, '2014-01-15 00:58:38.000000', 'consum', 0.0214, 'lps'),
	(496453, 129, '2014-01-15 00:58:39.000000', 'consum', 0.0215, 'lps'),
	(496454, 129, '2014-01-15 00:58:40.000000', 'consum', 0.0210, 'lps'),
	(496455, 129, '2014-01-15 00:58:41.000000', 'consum', 0.0211, 'lps'),
	(496456, 129, '2014-01-15 00:58:42.000000', 'consum', 0.0215, 'lps'),
	(496457, 129, '2014-01-15 00:58:43.000000', 'consum', 0.0217, 'lps'),
	(496458, 129, '2014-01-15 00:58:44.000000', 'consum', 0.0215, 'lps'),
	(496459, 129, '2014-01-15 00:58:45.000000', 'consum', 0.0217, 'lps'),
	(496460, 129, '2014-01-15 00:58:46.000000', 'consum', 0.0216, 'lps'),
	(496461, 129, '2014-01-15 00:58:47.000000', 'consum', 0.0217, 'lps'),
	(496462, 129, '2014-01-15 00:58:48.000000', 'consum', 0.0217, 'lps'),
	(496463, 129, '2014-01-15 00:58:49.000000', 'consum', 0.0223, 'lps'),
	(496464, 129, '2014-01-15 00:58:50.000000', 'consum', 0.0214, 'lps'),
	(496465, 129, '2014-01-15 00:58:51.000000', 'consum', 0.0217, 'lps'),
	(496466, 129, '2014-01-15 00:58:52.000000', 'consum', 0.0221, 'lps'),
	(496467, 129, '2014-01-15 00:58:53.000000', 'consum', 0.0217, 'lps'),
	(496468, 129, '2014-01-15 00:58:54.000000', 'consum', 0.0211, 'lps'),
	(496469, 129, '2014-01-15 00:58:55.000000', 'consum', 0.0210, 'lps'),
	(496470, 129, '2014-01-15 00:58:56.000000', 'consum', 0.0222, 'lps'),
	(496471, 129, '2014-01-15 00:58:57.000000', 'consum', 0.0214, 'lps'),
	(496472, 129, '2014-01-15 00:58:58.000000', 'consum', 0.0220, 'lps'),
	(496473, 129, '2014-01-15 00:58:59.000000', 'consum', 0.0223, 'lps'),
	(496474, 129, '2014-01-15 00:59:00.000000', 'consum', 0.0218, 'lps'),
	(496475, 129, '2014-01-15 00:59:01.000000', 'consum', 0.0223, 'lps'),
	(496476, 129, '2014-01-15 00:59:02.000000', 'consum', 0.0210, 'lps'),
	(496477, 129, '2014-01-15 00:59:03.000000', 'consum', 0.0215, 'lps'),
	(496478, 129, '2014-01-15 00:59:04.000000', 'consum', 0.0222, 'lps'),
	(496479, 129, '2014-01-15 00:59:05.000000', 'consum', 0.0214, 'lps'),
	(496480, 129, '2014-01-15 00:59:06.000000', 'consum', 0.0223, 'lps'),
	(496481, 129, '2014-01-15 00:59:07.000000', 'consum', 0.0220, 'lps'),
	(496482, 129, '2014-01-15 00:59:08.000000', 'consum', 0.0210, 'lps'),
	(496483, 129, '2014-01-15 00:59:09.000000', 'consum', 0.0219, 'lps'),
	(496484, 129, '2014-01-15 00:59:10.000000', 'consum', 0.0216, 'lps'),
	(496485, 129, '2014-01-15 00:59:11.000000', 'consum', 0.0214, 'lps'),
	(496486, 129, '2014-01-15 00:59:12.000000', 'consum', 0.0214, 'lps'),
	(496487, 129, '2014-01-15 00:59:13.000000', 'consum', 0.0215, 'lps'),
	(496488, 129, '2014-01-15 00:59:14.000000', 'consum', 0.0213, 'lps'),
	(496489, 129, '2014-01-15 00:59:15.000000', 'consum', 0.0222, 'lps'),
	(496490, 129, '2014-01-15 00:59:16.000000', 'consum', 0.0219, 'lps'),
	(496491, 129, '2014-01-15 00:59:17.000000', 'consum', 0.0222, 'lps'),
	(496492, 129, '2014-01-15 00:59:18.000000', 'consum', 0.0214, 'lps'),
	(496493, 129, '2014-01-15 00:59:19.000000', 'consum', 0.0222, 'lps'),
	(496494, 129, '2014-01-15 00:59:20.000000', 'consum', 0.0215, 'lps'),
	(496495, 129, '2014-01-15 00:59:21.000000', 'consum', 0.0214, 'lps'),
	(496496, 129, '2014-01-15 00:59:22.000000', 'consum', 0.0218, 'lps'),
	(496497, 129, '2014-01-15 00:59:23.000000', 'consum', 0.0222, 'lps'),
	(496498, 129, '2014-01-15 00:59:24.000000', 'consum', 0.0221, 'lps'),
	(496499, 129, '2014-01-15 00:59:25.000000', 'consum', 0.0214, 'lps'),
	(496500, 129, '2014-01-15 00:59:26.000000', 'consum', 0.0211, 'lps'),
	(496501, 129, '2014-01-15 00:59:27.000000', 'consum', 0.0218, 'lps'),
	(496502, 129, '2014-01-15 00:59:28.000000', 'consum', 0.0218, 'lps'),
	(496503, 129, '2014-01-15 00:59:29.000000', 'consum', 0.0213, 'lps'),
	(496504, 129, '2014-01-15 00:59:30.000000', 'consum', 0.0218, 'lps'),
	(496505, 129, '2014-01-15 00:59:31.000000', 'consum', 0.0210, 'lps'),
	(496506, 129, '2014-01-15 00:59:32.000000', 'consum', 0.0216, 'lps'),
	(496507, 129, '2014-01-15 00:59:33.000000', 'consum', 0.0211, 'lps'),
	(496508, 129, '2014-01-15 00:59:34.000000', 'consum', 0.0214, 'lps'),
	(496509, 129, '2014-01-15 00:59:35.000000', 'consum', 0.0212, 'lps'),
	(496510, 129, '2014-01-15 00:59:36.000000', 'consum', 0.0210, 'lps'),
	(496511, 129, '2014-01-15 00:59:37.000000', 'consum', 0.0219, 'lps'),
	(496512, 129, '2014-01-15 00:59:38.000000', 'consum', 0.0213, 'lps'),
	(496513, 129, '2014-01-15 00:59:39.000000', 'consum', 0.0213, 'lps'),
	(496514, 129, '2014-01-15 00:59:40.000000', 'consum', 0.0216, 'lps'),
	(496515, 129, '2014-01-15 00:59:41.000000', 'consum', 0.0216, 'lps'),
	(496516, 129, '2014-01-15 00:59:42.000000', 'consum', 0.0222, 'lps'),
	(496517, 129, '2014-01-15 00:59:43.000000', 'consum', 0.0212, 'lps'),
	(496518, 129, '2014-01-15 00:59:44.000000', 'consum', 0.0213, 'lps'),
	(496519, 129, '2014-01-15 00:59:45.000000', 'consum', 0.0220, 'lps'),
	(496520, 129, '2014-01-15 00:59:46.000000', 'consum', 0.0210, 'lps'),
	(496521, 129, '2014-01-15 00:59:47.000000', 'consum', 0.0222, 'lps'),
	(496522, 129, '2014-01-15 00:59:48.000000', 'consum', 0.0216, 'lps'),
	(496523, 129, '2014-01-15 00:59:49.000000', 'consum', 0.0215, 'lps'),
	(496524, 129, '2014-01-15 00:59:50.000000', 'consum', 0.0221, 'lps'),
	(496525, 129, '2014-01-15 00:59:51.000000', 'consum', 0.0222, 'lps'),
	(496526, 129, '2014-01-15 00:59:52.000000', 'consum', 0.0210, 'lps'),
	(496527, 129, '2014-01-15 00:59:53.000000', 'consum', 0.0214, 'lps'),
	(496528, 129, '2014-01-15 00:59:54.000000', 'consum', 0.0219, 'lps'),
	(496529, 129, '2014-01-15 00:59:55.000000', 'consum', 0.0213, 'lps'),
	(496530, 129, '2014-01-15 00:59:56.000000', 'consum', 0.0213, 'lps'),
	(496531, 129, '2014-01-15 00:59:57.000000', 'consum', 0.0216, 'lps'),
	(496532, 129, '2014-01-15 00:59:58.000000', 'consum', 0.0217, 'lps'),
	(496533, 129, '2014-01-15 00:59:59.000000', 'consum', 0.0213, 'lps'),
	(496534, 129, '2014-01-15 01:00:00.000000', 'consum', 0.0220, 'lps'),
	(496535, 129, '2014-01-15 01:00:01.000000', 'consum', 0.0222, 'lps'),
	(496536, 129, '2014-01-15 01:00:02.000000', 'consum', 0.0213, 'lps'),
	(496537, 129, '2014-01-15 01:00:03.000000', 'consum', 0.0219, 'lps'),
	(496538, 129, '2014-01-15 01:00:04.000000', 'consum', 0.0218, 'lps'),
	(496539, 129, '2014-01-15 01:00:05.000000', 'consum', 0.0210, 'lps'),
	(496540, 129, '2014-01-15 01:00:06.000000', 'consum', 0.0215, 'lps'),
	(496541, 129, '2014-01-15 01:00:07.000000', 'consum', 0.0222, 'lps'),
	(496542, 129, '2014-01-15 01:00:08.000000', 'consum', 0.0214, 'lps'),
	(496543, 129, '2014-01-15 01:00:09.000000', 'consum', 0.0221, 'lps'),
	(496544, 129, '2014-01-15 01:00:10.000000', 'consum', 0.0214, 'lps'),
	(496545, 129, '2014-01-15 01:00:11.000000', 'consum', 0.0210, 'lps'),
	(496546, 129, '2014-01-15 01:00:12.000000', 'consum', 0.0211, 'lps'),
	(496547, 129, '2014-01-15 01:00:13.000000', 'consum', 0.0215, 'lps'),
	(496548, 129, '2014-01-15 01:00:14.000000', 'consum', 0.0218, 'lps'),
	(496549, 129, '2014-01-15 01:00:15.000000', 'consum', 0.0223, 'lps'),
	(496550, 129, '2014-01-15 01:00:16.000000', 'consum', 0.0210, 'lps'),
	(496551, 129, '2014-01-15 01:00:17.000000', 'consum', 0.0215, 'lps'),
	(496552, 129, '2014-01-15 01:00:18.000000', 'consum', 0.0220, 'lps'),
	(496553, 129, '2014-01-15 01:00:19.000000', 'consum', 0.0216, 'lps'),
	(496554, 129, '2014-01-15 01:00:20.000000', 'consum', 0.0210, 'lps'),
	(496555, 129, '2014-01-15 01:00:21.000000', 'consum', 0.0223, 'lps'),
	(496556, 129, '2014-01-15 01:00:22.000000', 'consum', 0.0217, 'lps'),
	(496557, 129, '2014-01-15 01:00:23.000000', 'consum', 0.0223, 'lps'),
	(496558, 129, '2014-01-15 01:00:24.000000', 'consum', 0.0211, 'lps'),
	(496559, 129, '2014-01-15 01:00:25.000000', 'consum', 0.0219, 'lps'),
	(496560, 129, '2014-01-15 01:00:26.000000', 'consum', 0.0213, 'lps'),
	(496561, 129, '2014-01-15 01:00:27.000000', 'consum', 0.0223, 'lps'),
	(496562, 129, '2014-01-15 01:00:28.000000', 'consum', 0.0210, 'lps'),
	(496563, 129, '2014-01-15 01:00:29.000000', 'consum', 0.0216, 'lps'),
	(496564, 129, '2014-01-15 01:00:30.000000', 'consum', 0.0214, 'lps'),
	(496565, 129, '2014-01-15 01:00:31.000000', 'consum', 0.0223, 'lps'),
	(496566, 129, '2014-01-15 01:00:32.000000', 'consum', 0.0222, 'lps'),
	(496567, 129, '2014-01-15 01:00:33.000000', 'consum', 0.0218, 'lps'),
	(496568, 129, '2014-01-15 01:00:34.000000', 'consum', 0.0216, 'lps'),
	(496569, 129, '2014-01-15 01:00:35.000000', 'consum', 0.0216, 'lps'),
	(496570, 129, '2014-01-15 01:00:36.000000', 'consum', 0.0223, 'lps'),
	(496571, 129, '2014-01-15 01:00:37.000000', 'consum', 0.0216, 'lps'),
	(496572, 129, '2014-01-15 01:00:38.000000', 'consum', 0.0215, 'lps'),
	(496573, 129, '2014-01-15 01:00:39.000000', 'consum', 0.0216, 'lps'),
	(496574, 129, '2014-01-15 01:00:40.000000', 'consum', 0.0214, 'lps'),
	(496575, 129, '2014-01-15 01:00:41.000000', 'consum', 0.0211, 'lps'),
	(496576, 129, '2014-01-15 01:00:42.000000', 'consum', 0.0216, 'lps'),
	(496577, 129, '2014-01-15 01:00:43.000000', 'consum', 0.0223, 'lps'),
	(496578, 129, '2014-01-15 01:00:44.000000', 'consum', 0.0219, 'lps'),
	(496579, 129, '2014-01-15 01:00:45.000000', 'consum', 0.0213, 'lps'),
	(496580, 129, '2014-01-15 01:00:46.000000', 'consum', 0.0214, 'lps'),
	(496581, 129, '2014-01-15 01:00:47.000000', 'consum', 0.0222, 'lps'),
	(496582, 129, '2014-01-15 01:00:48.000000', 'consum', 0.0215, 'lps'),
	(496583, 129, '2014-01-15 01:00:49.000000', 'consum', 0.0216, 'lps'),
	(496584, 129, '2014-01-15 01:00:50.000000', 'consum', 0.0223, 'lps'),
	(496585, 129, '2014-01-15 01:00:51.000000', 'consum', 0.0215, 'lps'),
	(496586, 129, '2014-01-15 01:00:52.000000', 'consum', 0.0213, 'lps'),
	(496587, 129, '2014-01-15 01:00:53.000000', 'consum', 0.0210, 'lps'),
	(496588, 129, '2014-01-15 01:00:54.000000', 'consum', 0.0214, 'lps'),
	(496589, 129, '2014-01-15 01:00:55.000000', 'consum', 0.0216, 'lps'),
	(496590, 129, '2014-01-15 01:00:56.000000', 'consum', 0.0216, 'lps'),
	(496591, 129, '2014-01-15 01:00:57.000000', 'consum', 0.0220, 'lps'),
	(496592, 129, '2014-01-15 01:00:58.000000', 'consum', 0.0218, 'lps'),
	(496593, 129, '2014-01-15 01:00:59.000000', 'consum', 0.0218, 'lps'),
	(496594, 129, '2014-01-15 01:01:00.000000', 'consum', 0.0214, 'lps'),
	(496595, 129, '2014-01-15 01:01:01.000000', 'consum', 0.0219, 'lps'),
	(496596, 129, '2014-01-15 01:01:02.000000', 'consum', 0.0215, 'lps'),
	(496597, 129, '2014-01-15 01:01:03.000000', 'consum', 0.0211, 'lps'),
	(496598, 129, '2014-01-15 01:01:04.000000', 'consum', 0.0212, 'lps'),
	(496599, 129, '2014-01-15 01:01:05.000000', 'consum', 0.0217, 'lps'),
	(496600, 129, '2014-01-15 01:01:06.000000', 'consum', 0.0213, 'lps'),
	(496601, 129, '2014-01-15 01:01:07.000000', 'consum', 0.0217, 'lps'),
	(496602, 129, '2014-01-15 01:01:08.000000', 'consum', 0.0210, 'lps'),
	(496603, 129, '2014-01-15 01:01:09.000000', 'consum', 0.0216, 'lps'),
	(496604, 129, '2014-01-15 01:01:10.000000', 'consum', 0.0215, 'lps'),
	(496605, 129, '2014-01-15 01:01:11.000000', 'consum', 0.0216, 'lps'),
	(496606, 129, '2014-01-15 01:01:12.000000', 'consum', 0.0213, 'lps'),
	(496607, 129, '2014-01-15 01:01:13.000000', 'consum', 0.0220, 'lps'),
	(496608, 129, '2014-01-15 01:01:14.000000', 'consum', 0.0212, 'lps'),
	(496609, 129, '2014-01-15 01:01:15.000000', 'consum', 0.0215, 'lps'),
	(496610, 129, '2014-01-15 01:01:16.000000', 'consum', 0.0218, 'lps'),
	(496611, 129, '2014-01-15 01:01:17.000000', 'consum', 0.0222, 'lps'),
	(496612, 129, '2014-01-15 01:01:18.000000', 'consum', 0.0216, 'lps'),
	(496613, 129, '2014-01-15 01:01:19.000000', 'consum', 0.0218, 'lps'),
	(496614, 129, '2014-01-15 01:01:20.000000', 'consum', 0.0220, 'lps'),
	(496615, 129, '2014-01-15 01:01:21.000000', 'consum', 0.0221, 'lps'),
	(496616, 129, '2014-01-15 01:01:22.000000', 'consum', 0.0221, 'lps'),
	(496617, 129, '2014-01-15 01:01:23.000000', 'consum', 0.0218, 'lps'),
	(496618, 129, '2014-01-15 01:01:24.000000', 'consum', 0.0219, 'lps'),
	(496619, 129, '2014-01-15 01:01:25.000000', 'consum', 0.0219, 'lps'),
	(496620, 129, '2014-01-15 01:01:26.000000', 'consum', 0.0213, 'lps'),
	(496621, 129, '2014-01-15 01:01:27.000000', 'consum', 0.0212, 'lps'),
	(496622, 129, '2014-01-15 01:01:28.000000', 'consum', 0.0211, 'lps'),
	(496623, 129, '2014-01-15 01:01:29.000000', 'consum', 0.0223, 'lps'),
	(496624, 129, '2014-01-15 01:01:30.000000', 'consum', 0.0217, 'lps'),
	(496625, 129, '2014-01-15 01:01:31.000000', 'consum', 0.0220, 'lps'),
	(496626, 129, '2014-01-15 01:01:32.000000', 'consum', 0.0214, 'lps'),
	(496627, 129, '2014-01-15 01:01:33.000000', 'consum', 0.0212, 'lps'),
	(496628, 129, '2014-01-15 01:01:34.000000', 'consum', 0.0223, 'lps'),
	(496629, 129, '2014-01-15 01:01:35.000000', 'consum', 0.0212, 'lps'),
	(496630, 129, '2014-01-15 01:01:36.000000', 'consum', 0.0212, 'lps'),
	(496631, 129, '2014-01-15 01:01:37.000000', 'consum', 0.0212, 'lps'),
	(496632, 129, '2014-01-15 01:01:38.000000', 'consum', 0.0216, 'lps'),
	(496633, 129, '2014-01-15 01:01:39.000000', 'consum', 0.0219, 'lps'),
	(496634, 129, '2014-01-15 01:01:40.000000', 'consum', 0.0212, 'lps'),
	(496635, 129, '2014-01-15 01:01:41.000000', 'consum', 0.0219, 'lps'),
	(496636, 129, '2014-01-15 01:01:42.000000', 'consum', 0.0221, 'lps'),
	(496637, 129, '2014-01-15 01:01:43.000000', 'consum', 0.0210, 'lps'),
	(496638, 129, '2014-01-15 01:01:44.000000', 'consum', 0.0219, 'lps'),
	(496639, 129, '2014-01-15 01:01:45.000000', 'consum', 0.0215, 'lps'),
	(496640, 129, '2014-01-15 01:01:46.000000', 'consum', 0.0221, 'lps'),
	(496641, 129, '2014-01-15 01:01:47.000000', 'consum', 0.0222, 'lps'),
	(496642, 129, '2014-01-15 01:01:48.000000', 'consum', 0.0211, 'lps'),
	(496643, 129, '2014-01-15 01:01:49.000000', 'consum', 0.0221, 'lps'),
	(496644, 129, '2014-01-15 01:01:50.000000', 'consum', 0.0222, 'lps'),
	(496645, 129, '2014-01-15 01:01:51.000000', 'consum', 0.0220, 'lps'),
	(496646, 129, '2014-01-15 01:01:52.000000', 'consum', 0.0214, 'lps'),
	(496647, 129, '2014-01-15 01:01:53.000000', 'consum', 0.0213, 'lps'),
	(496648, 129, '2014-01-15 01:01:54.000000', 'consum', 0.0214, 'lps'),
	(496649, 129, '2014-01-15 01:01:55.000000', 'consum', 0.0223, 'lps'),
	(496650, 129, '2014-01-15 01:01:56.000000', 'consum', 0.0221, 'lps'),
	(496651, 129, '2014-01-15 01:01:57.000000', 'consum', 0.0214, 'lps'),
	(496652, 129, '2014-01-15 01:01:58.000000', 'consum', 0.0211, 'lps'),
	(496653, 129, '2014-01-15 01:01:59.000000', 'consum', 0.0216, 'lps'),
	(496654, 129, '2014-01-15 01:02:00.000000', 'consum', 0.0223, 'lps'),
	(496655, 129, '2014-01-15 01:02:01.000000', 'consum', 0.0218, 'lps'),
	(496656, 129, '2014-01-15 01:02:02.000000', 'consum', 0.0210, 'lps'),
	(496657, 129, '2014-01-15 01:02:03.000000', 'consum', 0.0213, 'lps'),
	(496658, 129, '2014-01-15 01:02:04.000000', 'consum', 0.0214, 'lps'),
	(496659, 129, '2014-01-15 01:02:05.000000', 'consum', 0.0219, 'lps'),
	(496660, 129, '2014-01-15 01:02:06.000000', 'consum', 0.0218, 'lps'),
	(496661, 129, '2014-01-15 01:02:07.000000', 'consum', 0.0223, 'lps'),
	(496662, 129, '2014-01-15 01:02:08.000000', 'consum', 0.0221, 'lps'),
	(496663, 129, '2014-01-15 01:02:09.000000', 'consum', 0.0214, 'lps'),
	(496664, 129, '2014-01-15 01:02:10.000000', 'consum', 0.0213, 'lps'),
	(496665, 129, '2014-01-15 01:02:11.000000', 'consum', 0.0212, 'lps'),
	(496666, 129, '2014-01-15 01:02:12.000000', 'consum', 0.0214, 'lps'),
	(496667, 129, '2014-01-15 01:02:13.000000', 'consum', 0.0223, 'lps'),
	(496668, 129, '2014-01-15 01:02:14.000000', 'consum', 0.0220, 'lps'),
	(496669, 129, '2014-01-15 01:02:15.000000', 'consum', 0.0210, 'lps'),
	(496670, 129, '2014-01-15 01:02:16.000000', 'consum', 0.0219, 'lps'),
	(496671, 129, '2014-01-15 01:02:17.000000', 'consum', 0.0217, 'lps'),
	(496672, 129, '2014-01-15 01:02:18.000000', 'consum', 0.0219, 'lps'),
	(496673, 129, '2014-01-15 01:02:19.000000', 'consum', 0.0218, 'lps'),
	(496674, 129, '2014-01-15 01:02:20.000000', 'consum', 0.0211, 'lps'),
	(496675, 129, '2014-01-15 01:02:21.000000', 'consum', 0.0220, 'lps'),
	(496676, 129, '2014-01-15 01:02:22.000000', 'consum', 0.0214, 'lps'),
	(496677, 129, '2014-01-15 01:02:23.000000', 'consum', 0.0213, 'lps'),
	(496678, 129, '2014-01-15 01:02:24.000000', 'consum', 0.0216, 'lps'),
	(496679, 129, '2014-01-15 01:02:25.000000', 'consum', 0.0215, 'lps'),
	(496680, 129, '2014-01-15 01:02:26.000000', 'consum', 0.0220, 'lps'),
	(496681, 129, '2014-01-15 01:02:27.000000', 'consum', 0.0215, 'lps'),
	(496682, 129, '2014-01-15 01:02:28.000000', 'consum', 0.0222, 'lps'),
	(496683, 129, '2014-01-15 01:02:29.000000', 'consum', 0.0211, 'lps'),
	(496684, 129, '2014-01-15 01:02:30.000000', 'consum', 0.0220, 'lps'),
	(496685, 129, '2014-01-15 01:02:31.000000', 'consum', 0.0219, 'lps'),
	(496686, 129, '2014-01-15 01:02:32.000000', 'consum', 0.0212, 'lps'),
	(496687, 129, '2014-01-15 01:02:33.000000', 'consum', 0.0220, 'lps'),
	(496688, 129, '2014-01-15 01:02:34.000000', 'consum', 0.0212, 'lps'),
	(496689, 129, '2014-01-15 01:02:35.000000', 'consum', 0.0219, 'lps'),
	(496690, 129, '2014-01-15 01:02:36.000000', 'consum', 0.0222, 'lps'),
	(496691, 129, '2014-01-15 01:02:37.000000', 'consum', 0.0213, 'lps'),
	(496692, 129, '2014-01-15 01:02:38.000000', 'consum', 0.0220, 'lps'),
	(496693, 129, '2014-01-15 01:02:39.000000', 'consum', 0.0211, 'lps'),
	(496694, 129, '2014-01-15 01:02:40.000000', 'consum', 0.0210, 'lps'),
	(496695, 129, '2014-01-15 01:02:41.000000', 'consum', 0.0211, 'lps'),
	(496696, 129, '2014-01-15 01:02:42.000000', 'consum', 0.0212, 'lps'),
	(496697, 129, '2014-01-15 01:02:43.000000', 'consum', 0.0219, 'lps'),
	(496698, 129, '2014-01-15 01:02:44.000000', 'consum', 0.0220, 'lps'),
	(496699, 129, '2014-01-15 01:02:45.000000', 'consum', 0.0219, 'lps'),
	(496700, 129, '2014-01-15 01:02:46.000000', 'consum', 0.0211, 'lps'),
	(496701, 129, '2014-01-15 01:02:47.000000', 'consum', 0.0217, 'lps'),
	(496702, 129, '2014-01-15 01:02:48.000000', 'consum', 0.0216, 'lps'),
	(496703, 129, '2014-01-15 01:02:49.000000', 'consum', 0.0220, 'lps'),
	(496704, 129, '2014-01-15 01:02:50.000000', 'consum', 0.0212, 'lps'),
	(496705, 129, '2014-01-15 01:02:51.000000', 'consum', 0.0221, 'lps'),
	(496706, 129, '2014-01-15 01:02:52.000000', 'consum', 0.0215, 'lps'),
	(496707, 129, '2014-01-15 01:02:53.000000', 'consum', 0.0217, 'lps'),
	(496708, 129, '2014-01-15 01:02:54.000000', 'consum', 0.0216, 'lps'),
	(496709, 129, '2014-01-15 01:02:55.000000', 'consum', 0.0221, 'lps'),
	(496710, 129, '2014-01-15 01:02:56.000000', 'consum', 0.0220, 'lps'),
	(496711, 129, '2014-01-15 01:02:57.000000', 'consum', 0.0212, 'lps'),
	(496712, 129, '2014-01-15 01:02:58.000000', 'consum', 0.0219, 'lps'),
	(496713, 129, '2014-01-15 01:02:59.000000', 'consum', 0.0223, 'lps'),
	(496714, 129, '2014-01-15 01:03:00.000000', 'consum', 0.0218, 'lps'),
	(496715, 129, '2014-01-15 01:03:01.000000', 'consum', 0.0212, 'lps'),
	(496716, 129, '2014-01-15 01:03:02.000000', 'consum', 0.0223, 'lps'),
	(496717, 129, '2014-01-15 01:03:03.000000', 'consum', 0.0214, 'lps'),
	(496718, 129, '2014-01-15 01:03:04.000000', 'consum', 0.0220, 'lps'),
	(496719, 129, '2014-01-15 01:03:05.000000', 'consum', 0.0222, 'lps'),
	(496720, 129, '2014-01-15 01:03:06.000000', 'consum', 0.0211, 'lps'),
	(496721, 129, '2014-01-15 01:03:07.000000', 'consum', 0.0210, 'lps'),
	(496722, 129, '2014-01-15 01:03:08.000000', 'consum', 0.0219, 'lps'),
	(496723, 129, '2014-01-15 01:03:09.000000', 'consum', 0.0212, 'lps'),
	(496724, 129, '2014-01-15 01:03:10.000000', 'consum', 0.0223, 'lps'),
	(496725, 129, '2014-01-15 01:03:11.000000', 'consum', 0.0215, 'lps'),
	(496726, 129, '2014-01-15 01:03:12.000000', 'consum', 0.0222, 'lps'),
	(496727, 129, '2014-01-15 01:03:13.000000', 'consum', 0.0214, 'lps'),
	(496728, 129, '2014-01-15 01:03:14.000000', 'consum', 0.0211, 'lps'),
	(496729, 129, '2014-01-15 01:03:15.000000', 'consum', 0.0215, 'lps'),
	(496730, 129, '2014-01-15 01:03:16.000000', 'consum', 0.0219, 'lps'),
	(496731, 129, '2014-01-15 01:03:17.000000', 'consum', 0.0213, 'lps'),
	(496732, 129, '2014-01-15 01:03:18.000000', 'consum', 0.0211, 'lps'),
	(496733, 129, '2014-01-15 01:03:19.000000', 'consum', 0.0221, 'lps'),
	(496734, 129, '2014-01-15 01:03:20.000000', 'consum', 0.0221, 'lps'),
	(496735, 129, '2014-01-15 01:03:21.000000', 'consum', 0.0218, 'lps'),
	(496736, 129, '2014-01-15 01:03:22.000000', 'consum', 0.0219, 'lps'),
	(496737, 129, '2014-01-15 01:03:23.000000', 'consum', 0.0215, 'lps'),
	(496738, 129, '2014-01-15 01:03:24.000000', 'consum', 0.0210, 'lps'),
	(496739, 129, '2014-01-15 01:03:25.000000', 'consum', 0.0211, 'lps'),
	(496740, 129, '2014-01-15 01:03:26.000000', 'consum', 0.0215, 'lps'),
	(496741, 129, '2014-01-15 01:03:27.000000', 'consum', 0.0219, 'lps'),
	(496742, 129, '2014-01-15 01:03:28.000000', 'consum', 0.0212, 'lps'),
	(496743, 129, '2014-01-15 01:03:29.000000', 'consum', 0.0220, 'lps'),
	(496744, 129, '2014-01-15 01:03:30.000000', 'consum', 0.0212, 'lps'),
	(496745, 129, '2014-01-15 01:03:31.000000', 'consum', 0.0221, 'lps'),
	(496746, 129, '2014-01-15 01:03:32.000000', 'consum', 0.0218, 'lps'),
	(496747, 129, '2014-01-15 01:03:33.000000', 'consum', 0.0214, 'lps'),
	(496748, 129, '2014-01-15 01:03:34.000000', 'consum', 0.0210, 'lps'),
	(496749, 129, '2014-01-15 01:03:35.000000', 'consum', 0.0213, 'lps'),
	(496750, 129, '2014-01-15 01:03:36.000000', 'consum', 0.0223, 'lps'),
	(496751, 129, '2014-01-15 01:03:37.000000', 'consum', 0.0210, 'lps'),
	(496752, 129, '2014-01-15 01:03:38.000000', 'consum', 0.0215, 'lps'),
	(496753, 129, '2014-01-15 01:03:39.000000', 'consum', 0.0219, 'lps'),
	(496754, 129, '2014-01-15 01:03:40.000000', 'consum', 0.0214, 'lps'),
	(496755, 129, '2014-01-15 01:03:41.000000', 'consum', 0.0220, 'lps'),
	(496756, 129, '2014-01-15 01:03:42.000000', 'consum', 0.0217, 'lps'),
	(496757, 129, '2014-01-15 01:03:43.000000', 'consum', 0.0217, 'lps'),
	(496758, 129, '2014-01-15 01:03:44.000000', 'consum', 0.0210, 'lps'),
	(496759, 129, '2014-01-15 01:03:45.000000', 'consum', 0.0216, 'lps'),
	(496760, 129, '2014-01-15 01:03:46.000000', 'consum', 0.0213, 'lps'),
	(496761, 129, '2014-01-15 01:03:47.000000', 'consum', 0.0222, 'lps'),
	(496762, 129, '2014-01-15 01:03:48.000000', 'consum', 0.0220, 'lps'),
	(496763, 129, '2014-01-15 01:03:49.000000', 'consum', 0.0223, 'lps'),
	(496764, 129, '2014-01-15 01:03:50.000000', 'consum', 0.0219, 'lps'),
	(496765, 129, '2014-01-15 01:03:51.000000', 'consum', 0.0218, 'lps'),
	(496766, 129, '2014-01-15 01:03:52.000000', 'consum', 0.0222, 'lps'),
	(496767, 129, '2014-01-15 01:03:53.000000', 'consum', 0.0218, 'lps'),
	(496768, 129, '2014-01-15 01:03:54.000000', 'consum', 0.0216, 'lps'),
	(496769, 129, '2014-01-15 01:03:55.000000', 'consum', 0.0216, 'lps'),
	(496770, 129, '2014-01-15 01:03:56.000000', 'consum', 0.0221, 'lps'),
	(496771, 129, '2014-01-15 01:03:57.000000', 'consum', 0.0219, 'lps'),
	(496772, 129, '2014-01-15 01:03:58.000000', 'consum', 0.0211, 'lps'),
	(496773, 129, '2014-01-15 01:03:59.000000', 'consum', 0.0215, 'lps'),
	(496774, 129, '2014-01-15 01:04:00.000000', 'consum', 0.0217, 'lps'),
	(496775, 129, '2014-01-15 01:04:01.000000', 'consum', 0.0217, 'lps'),
	(496776, 129, '2014-01-15 01:04:02.000000', 'consum', 0.0211, 'lps'),
	(496777, 129, '2014-01-15 01:04:03.000000', 'consum', 0.0220, 'lps'),
	(496778, 129, '2014-01-15 01:04:04.000000', 'consum', 0.0219, 'lps'),
	(496779, 129, '2014-01-15 01:04:05.000000', 'consum', 0.0212, 'lps'),
	(496780, 129, '2014-01-15 01:04:06.000000', 'consum', 0.0219, 'lps'),
	(496781, 129, '2014-01-15 01:04:07.000000', 'consum', 0.0222, 'lps'),
	(496782, 129, '2014-01-15 01:04:08.000000', 'consum', 0.0216, 'lps'),
	(496783, 129, '2014-01-15 01:04:09.000000', 'consum', 0.0220, 'lps'),
	(496784, 129, '2014-01-15 01:04:10.000000', 'consum', 0.0213, 'lps'),
	(496785, 129, '2014-01-15 01:04:11.000000', 'consum', 0.0223, 'lps'),
	(496786, 129, '2014-01-15 01:04:12.000000', 'consum', 0.0223, 'lps'),
	(496787, 129, '2014-01-15 01:04:13.000000', 'consum', 0.0212, 'lps'),
	(496788, 129, '2014-01-15 01:04:14.000000', 'consum', 0.0221, 'lps'),
	(496789, 129, '2014-01-15 01:04:15.000000', 'consum', 0.0220, 'lps'),
	(496790, 129, '2014-01-15 01:04:16.000000', 'consum', 0.0213, 'lps'),
	(496791, 129, '2014-01-15 01:04:17.000000', 'consum', 0.0222, 'lps'),
	(496792, 129, '2014-01-15 01:04:18.000000', 'consum', 0.0219, 'lps'),
	(496793, 129, '2014-01-15 01:04:19.000000', 'consum', 0.0222, 'lps'),
	(496794, 129, '2014-01-15 01:04:20.000000', 'consum', 0.0212, 'lps'),
	(496795, 129, '2014-01-15 01:04:21.000000', 'consum', 0.0215, 'lps'),
	(496796, 129, '2014-01-15 01:04:22.000000', 'consum', 0.0216, 'lps'),
	(496797, 129, '2014-01-15 01:04:23.000000', 'consum', 0.0213, 'lps'),
	(496798, 129, '2014-01-15 01:04:24.000000', 'consum', 0.0218, 'lps'),
	(496799, 129, '2014-01-15 01:04:25.000000', 'consum', 0.0214, 'lps'),
	(496800, 129, '2014-01-15 01:04:26.000000', 'consum', 0.0223, 'lps'),
	(496801, 129, '2014-01-15 01:04:27.000000', 'consum', 0.0221, 'lps'),
	(496802, 129, '2014-01-15 01:04:28.000000', 'consum', 0.0212, 'lps'),
	(496803, 129, '2014-01-15 01:04:29.000000', 'consum', 0.0216, 'lps'),
	(496804, 129, '2014-01-15 01:04:30.000000', 'consum', 0.0221, 'lps'),
	(496805, 129, '2014-01-15 01:04:31.000000', 'consum', 0.0221, 'lps'),
	(496806, 129, '2014-01-15 01:04:32.000000', 'consum', 0.0216, 'lps'),
	(496807, 129, '2014-01-15 01:04:33.000000', 'consum', 0.0220, 'lps'),
	(496808, 129, '2014-01-15 01:04:34.000000', 'consum', 0.0218, 'lps'),
	(496809, 129, '2014-01-15 01:04:35.000000', 'consum', 0.0218, 'lps'),
	(496810, 129, '2014-01-15 01:04:36.000000', 'consum', 0.0215, 'lps'),
	(496811, 129, '2014-01-15 01:04:37.000000', 'consum', 0.0210, 'lps'),
	(496812, 129, '2014-01-15 01:04:38.000000', 'consum', 0.0210, 'lps'),
	(496813, 129, '2014-01-15 01:04:39.000000', 'consum', 0.0211, 'lps'),
	(496814, 129, '2014-01-15 01:04:40.000000', 'consum', 0.0217, 'lps'),
	(496815, 129, '2014-01-15 01:04:41.000000', 'consum', 0.0213, 'lps'),
	(496816, 129, '2014-01-15 01:04:42.000000', 'consum', 0.0219, 'lps'),
	(496817, 129, '2014-01-15 01:04:43.000000', 'consum', 0.0219, 'lps'),
	(496818, 129, '2014-01-15 01:04:44.000000', 'consum', 0.0216, 'lps'),
	(496819, 129, '2014-01-15 01:04:45.000000', 'consum', 0.0210, 'lps'),
	(496820, 129, '2014-01-15 01:04:46.000000', 'consum', 0.0222, 'lps'),
	(496821, 129, '2014-01-15 01:04:47.000000', 'consum', 0.0217, 'lps'),
	(496822, 129, '2014-01-15 01:04:48.000000', 'consum', 0.0220, 'lps'),
	(496823, 129, '2014-01-15 01:04:49.000000', 'consum', 0.0212, 'lps'),
	(496824, 129, '2014-01-15 01:04:50.000000', 'consum', 0.0221, 'lps'),
	(496825, 129, '2014-01-15 01:04:51.000000', 'consum', 0.0215, 'lps'),
	(496826, 129, '2014-01-15 01:04:52.000000', 'consum', 0.0215, 'lps'),
	(496827, 129, '2014-01-15 01:04:53.000000', 'consum', 0.0223, 'lps'),
	(496828, 129, '2014-01-15 01:04:54.000000', 'consum', 0.0220, 'lps'),
	(496829, 129, '2014-01-15 01:04:55.000000', 'consum', 0.0218, 'lps'),
	(496830, 129, '2014-01-15 01:04:56.000000', 'consum', 0.0223, 'lps'),
	(496831, 129, '2014-01-15 01:04:57.000000', 'consum', 0.0221, 'lps'),
	(496832, 129, '2014-01-15 01:04:58.000000', 'consum', 0.0212, 'lps'),
	(496833, 129, '2014-01-15 01:04:59.000000', 'consum', 0.0218, 'lps'),
	(496834, 129, '2014-01-15 01:05:00.000000', 'consum', 0.0218, 'lps'),
	(496835, 129, '2014-01-15 01:05:01.000000', 'consum', 0.0210, 'lps'),
	(496836, 129, '2014-01-15 01:05:02.000000', 'consum', 0.0213, 'lps'),
	(496837, 129, '2014-01-15 01:05:03.000000', 'consum', 0.0213, 'lps'),
	(496838, 129, '2014-01-15 01:05:04.000000', 'consum', 0.0215, 'lps'),
	(496839, 129, '2014-01-15 01:05:05.000000', 'consum', 0.0213, 'lps'),
	(496840, 129, '2014-01-15 01:05:06.000000', 'consum', 0.0212, 'lps'),
	(496841, 129, '2014-01-15 01:05:07.000000', 'consum', 0.0223, 'lps'),
	(496842, 129, '2014-01-15 01:05:08.000000', 'consum', 0.0216, 'lps'),
	(496843, 129, '2014-01-15 01:05:09.000000', 'consum', 0.0214, 'lps'),
	(496844, 129, '2014-01-15 01:05:10.000000', 'consum', 0.0213, 'lps'),
	(496845, 129, '2014-01-15 01:05:11.000000', 'consum', 0.0212, 'lps'),
	(496846, 129, '2014-01-15 01:05:12.000000', 'consum', 0.0213, 'lps'),
	(496847, 129, '2014-01-15 01:05:13.000000', 'consum', 0.0221, 'lps'),
	(496848, 129, '2014-01-15 01:05:14.000000', 'consum', 0.0214, 'lps'),
	(496849, 129, '2014-01-15 01:05:15.000000', 'consum', 0.0211, 'lps'),
	(496850, 129, '2014-01-15 01:05:16.000000', 'consum', 0.0216, 'lps'),
	(496851, 129, '2014-01-15 01:05:17.000000', 'consum', 0.0210, 'lps'),
	(496852, 129, '2014-01-15 01:05:18.000000', 'consum', 0.0222, 'lps'),
	(496853, 129, '2014-01-15 01:05:19.000000', 'consum', 0.0213, 'lps'),
	(496854, 129, '2014-01-15 01:05:20.000000', 'consum', 0.0218, 'lps'),
	(496855, 129, '2014-01-15 01:05:21.000000', 'consum', 0.0215, 'lps'),
	(496856, 129, '2014-01-15 01:05:22.000000', 'consum', 0.0211, 'lps'),
	(496857, 129, '2014-01-15 01:05:23.000000', 'consum', 0.0214, 'lps'),
	(496858, 129, '2014-01-15 01:05:24.000000', 'consum', 0.0213, 'lps'),
	(496859, 129, '2014-01-15 01:05:25.000000', 'consum', 0.0214, 'lps'),
	(496860, 129, '2014-01-15 01:05:26.000000', 'consum', 0.0221, 'lps'),
	(496861, 129, '2014-01-15 01:05:27.000000', 'consum', 0.0213, 'lps'),
	(496862, 129, '2014-01-15 01:05:28.000000', 'consum', 0.0221, 'lps'),
	(496863, 129, '2014-01-15 01:05:29.000000', 'consum', 0.0215, 'lps'),
	(496864, 129, '2014-01-15 01:05:30.000000', 'consum', 0.0217, 'lps'),
	(496865, 129, '2014-01-15 01:05:31.000000', 'consum', 0.0216, 'lps'),
	(496866, 129, '2014-01-15 01:05:32.000000', 'consum', 0.0220, 'lps'),
	(496867, 129, '2014-01-15 01:05:33.000000', 'consum', 0.0213, 'lps'),
	(496868, 129, '2014-01-15 01:05:34.000000', 'consum', 0.0210, 'lps'),
	(496869, 129, '2014-01-15 01:05:35.000000', 'consum', 0.0216, 'lps'),
	(496870, 129, '2014-01-15 01:05:36.000000', 'consum', 0.0214, 'lps'),
	(496871, 129, '2014-01-15 01:05:37.000000', 'consum', 0.0211, 'lps'),
	(496872, 129, '2014-01-15 01:05:38.000000', 'consum', 0.0216, 'lps'),
	(496873, 129, '2014-01-15 01:05:39.000000', 'consum', 0.0223, 'lps'),
	(496874, 129, '2014-01-15 01:05:40.000000', 'consum', 0.0216, 'lps'),
	(496875, 129, '2014-01-15 01:05:41.000000', 'consum', 0.0214, 'lps'),
	(496876, 129, '2014-01-15 01:05:42.000000', 'consum', 0.0213, 'lps'),
	(496877, 129, '2014-01-15 01:05:43.000000', 'consum', 0.0215, 'lps'),
	(496878, 129, '2014-01-15 01:05:44.000000', 'consum', 0.0213, 'lps'),
	(496879, 129, '2014-01-15 01:05:45.000000', 'consum', 0.0210, 'lps'),
	(496880, 129, '2014-01-15 01:05:46.000000', 'consum', 0.0214, 'lps'),
	(496881, 129, '2014-01-15 01:05:47.000000', 'consum', 0.0217, 'lps'),
	(496882, 129, '2014-01-15 01:05:48.000000', 'consum', 0.0218, 'lps'),
	(496883, 129, '2014-01-15 01:05:49.000000', 'consum', 0.0218, 'lps'),
	(496884, 129, '2014-01-15 01:05:50.000000', 'consum', 0.0212, 'lps'),
	(496885, 129, '2014-01-15 01:05:51.000000', 'consum', 0.0222, 'lps'),
	(496886, 129, '2014-01-15 01:05:52.000000', 'consum', 0.0211, 'lps'),
	(496887, 129, '2014-01-15 01:05:53.000000', 'consum', 0.0220, 'lps'),
	(496888, 129, '2014-01-15 01:05:54.000000', 'consum', 0.0214, 'lps'),
	(496889, 129, '2014-01-15 01:05:55.000000', 'consum', 0.0217, 'lps'),
	(496890, 129, '2014-01-15 01:05:56.000000', 'consum', 0.0221, 'lps'),
	(496891, 129, '2014-01-15 01:05:57.000000', 'consum', 0.0213, 'lps'),
	(496892, 129, '2014-01-15 01:05:58.000000', 'consum', 0.0221, 'lps'),
	(496893, 129, '2014-01-15 01:05:59.000000', 'consum', 0.0216, 'lps'),
	(496894, 129, '2014-01-15 01:06:00.000000', 'consum', 0.0221, 'lps'),
	(496895, 129, '2014-01-15 01:06:01.000000', 'consum', 0.0220, 'lps'),
	(496896, 129, '2014-01-15 01:06:02.000000', 'consum', 0.0212, 'lps'),
	(496897, 129, '2014-01-15 01:06:03.000000', 'consum', 0.0220, 'lps'),
	(496898, 129, '2014-01-15 01:06:04.000000', 'consum', 0.0213, 'lps'),
	(496899, 129, '2014-01-15 01:06:05.000000', 'consum', 0.0223, 'lps'),
	(496900, 129, '2014-01-15 01:06:06.000000', 'consum', 0.0211, 'lps'),
	(496901, 129, '2014-01-15 01:06:07.000000', 'consum', 0.0218, 'lps'),
	(496902, 129, '2014-01-15 01:06:08.000000', 'consum', 0.0218, 'lps'),
	(496903, 129, '2014-01-15 01:06:09.000000', 'consum', 0.0213, 'lps'),
	(496904, 129, '2014-01-15 01:06:10.000000', 'consum', 0.0218, 'lps'),
	(496905, 129, '2014-01-15 01:06:11.000000', 'consum', 0.0212, 'lps'),
	(496906, 129, '2014-01-15 01:06:12.000000', 'consum', 0.0210, 'lps'),
	(496907, 129, '2014-01-15 01:06:13.000000', 'consum', 0.0220, 'lps'),
	(496908, 129, '2014-01-15 01:06:14.000000', 'consum', 0.0218, 'lps'),
	(496909, 129, '2014-01-15 01:06:15.000000', 'consum', 0.0221, 'lps'),
	(496910, 129, '2014-01-15 01:06:16.000000', 'consum', 0.0214, 'lps'),
	(496911, 129, '2014-01-15 01:06:17.000000', 'consum', 0.0223, 'lps'),
	(496912, 129, '2014-01-15 01:06:18.000000', 'consum', 0.0222, 'lps'),
	(496913, 129, '2014-01-15 01:06:19.000000', 'consum', 0.0218, 'lps'),
	(496914, 129, '2014-01-15 01:06:20.000000', 'consum', 0.0215, 'lps'),
	(496915, 129, '2014-01-15 01:06:21.000000', 'consum', 0.0211, 'lps'),
	(496916, 129, '2014-01-15 01:06:22.000000', 'consum', 0.0214, 'lps'),
	(496917, 129, '2014-01-15 01:06:23.000000', 'consum', 0.0214, 'lps'),
	(496918, 129, '2014-01-15 01:06:24.000000', 'consum', 0.0221, 'lps'),
	(496919, 129, '2014-01-15 01:06:25.000000', 'consum', 0.0222, 'lps'),
	(496920, 129, '2014-01-15 01:06:26.000000', 'consum', 0.0210, 'lps'),
	(496921, 129, '2014-01-15 01:06:27.000000', 'consum', 0.0216, 'lps'),
	(496922, 129, '2014-01-15 01:06:28.000000', 'consum', 0.0215, 'lps'),
	(496923, 129, '2014-01-15 01:06:29.000000', 'consum', 0.0215, 'lps'),
	(496924, 129, '2014-01-15 01:06:30.000000', 'consum', 0.0221, 'lps'),
	(496925, 129, '2014-01-15 01:06:31.000000', 'consum', 0.0210, 'lps'),
	(496926, 129, '2014-01-15 01:06:32.000000', 'consum', 0.0218, 'lps'),
	(496927, 129, '2014-01-15 01:06:33.000000', 'consum', 0.0210, 'lps'),
	(496928, 129, '2014-01-15 01:06:34.000000', 'consum', 0.0212, 'lps'),
	(496929, 129, '2014-01-15 01:06:35.000000', 'consum', 0.0222, 'lps'),
	(496930, 129, '2014-01-15 01:06:36.000000', 'consum', 0.0210, 'lps'),
	(496931, 129, '2014-01-15 01:06:37.000000', 'consum', 0.0217, 'lps'),
	(496932, 129, '2014-01-15 01:06:38.000000', 'consum', 0.0216, 'lps'),
	(496933, 129, '2014-01-15 01:06:39.000000', 'consum', 0.0218, 'lps'),
	(496934, 129, '2014-01-15 01:06:40.000000', 'consum', 0.0221, 'lps'),
	(496935, 129, '2014-01-15 01:06:41.000000', 'consum', 0.0210, 'lps'),
	(496936, 129, '2014-01-15 01:06:42.000000', 'consum', 0.0223, 'lps'),
	(496937, 129, '2014-01-15 01:06:43.000000', 'consum', 0.0220, 'lps'),
	(496938, 129, '2014-01-15 01:06:44.000000', 'consum', 0.0218, 'lps'),
	(496939, 129, '2014-01-15 01:06:45.000000', 'consum', 0.0223, 'lps'),
	(496940, 129, '2014-01-15 01:06:46.000000', 'consum', 0.0223, 'lps'),
	(496941, 129, '2014-01-15 01:06:47.000000', 'consum', 0.0223, 'lps'),
	(496942, 129, '2014-01-15 01:06:48.000000', 'consum', 0.0222, 'lps'),
	(496943, 129, '2014-01-15 01:06:49.000000', 'consum', 0.0217, 'lps'),
	(496944, 129, '2014-01-15 01:06:50.000000', 'consum', 0.0211, 'lps'),
	(496945, 129, '2014-01-15 01:06:51.000000', 'consum', 0.0210, 'lps'),
	(496946, 129, '2014-01-15 01:06:52.000000', 'consum', 0.0219, 'lps'),
	(496947, 129, '2014-01-15 01:06:53.000000', 'consum', 0.0215, 'lps'),
	(496948, 129, '2014-01-15 01:06:54.000000', 'consum', 0.0222, 'lps'),
	(496949, 129, '2014-01-15 01:06:55.000000', 'consum', 0.0212, 'lps'),
	(496950, 129, '2014-01-15 01:06:56.000000', 'consum', 0.0212, 'lps'),
	(496951, 129, '2014-01-15 01:06:57.000000', 'consum', 0.0217, 'lps'),
	(496952, 129, '2014-01-15 01:06:58.000000', 'consum', 0.0213, 'lps'),
	(496953, 129, '2014-01-15 01:06:59.000000', 'consum', 0.0215, 'lps'),
	(496954, 129, '2014-01-15 01:07:00.000000', 'consum', 0.0214, 'lps'),
	(496955, 129, '2014-01-15 01:07:01.000000', 'consum', 0.0215, 'lps'),
	(496956, 129, '2014-01-15 01:07:02.000000', 'consum', 0.0223, 'lps'),
	(496957, 129, '2014-01-15 01:07:03.000000', 'consum', 0.0218, 'lps'),
	(496958, 129, '2014-01-15 01:07:04.000000', 'consum', 0.0213, 'lps'),
	(496959, 129, '2014-01-15 01:07:05.000000', 'consum', 0.0214, 'lps'),
	(496960, 129, '2014-01-15 01:07:06.000000', 'consum', 0.0223, 'lps'),
	(496961, 129, '2014-01-15 01:07:07.000000', 'consum', 0.0223, 'lps'),
	(496962, 129, '2014-01-15 01:07:08.000000', 'consum', 0.0221, 'lps'),
	(496963, 129, '2014-01-15 01:07:09.000000', 'consum', 0.0213, 'lps'),
	(496964, 129, '2014-01-15 01:07:10.000000', 'consum', 0.0220, 'lps'),
	(496965, 129, '2014-01-15 01:07:11.000000', 'consum', 0.0222, 'lps'),
	(496966, 129, '2014-01-15 01:07:12.000000', 'consum', 0.0212, 'lps'),
	(496967, 129, '2014-01-15 01:07:13.000000', 'consum', 0.0213, 'lps'),
	(496968, 129, '2014-01-15 01:07:14.000000', 'consum', 0.0219, 'lps'),
	(496969, 129, '2014-01-15 01:07:15.000000', 'consum', 0.0220, 'lps'),
	(496970, 129, '2014-01-15 01:07:16.000000', 'consum', 0.0217, 'lps'),
	(496971, 129, '2014-01-15 01:07:17.000000', 'consum', 0.0219, 'lps'),
	(496972, 129, '2014-01-15 01:07:18.000000', 'consum', 0.0218, 'lps'),
	(496973, 129, '2014-01-15 01:07:19.000000', 'consum', 0.0212, 'lps'),
	(496974, 129, '2014-01-15 01:07:20.000000', 'consum', 0.0221, 'lps'),
	(496975, 129, '2014-01-15 01:07:21.000000', 'consum', 0.0220, 'lps'),
	(496976, 129, '2014-01-15 01:07:22.000000', 'consum', 0.0214, 'lps'),
	(496977, 129, '2014-01-15 01:07:23.000000', 'consum', 0.0216, 'lps'),
	(496978, 129, '2014-01-15 01:07:24.000000', 'consum', 0.0212, 'lps'),
	(496979, 129, '2014-01-15 01:07:25.000000', 'consum', 0.0215, 'lps'),
	(496980, 129, '2014-01-15 01:07:26.000000', 'consum', 0.0217, 'lps'),
	(496981, 129, '2014-01-15 01:07:27.000000', 'consum', 0.0218, 'lps'),
	(496982, 129, '2014-01-15 01:07:28.000000', 'consum', 0.0213, 'lps'),
	(496983, 129, '2014-01-15 01:07:29.000000', 'consum', 0.0216, 'lps'),
	(496984, 129, '2014-01-15 01:07:30.000000', 'consum', 0.0217, 'lps'),
	(496985, 129, '2014-01-15 01:07:31.000000', 'consum', 0.0214, 'lps'),
	(496986, 129, '2014-01-15 01:07:32.000000', 'consum', 0.0222, 'lps'),
	(496987, 129, '2014-01-15 01:07:33.000000', 'consum', 0.0216, 'lps'),
	(496988, 129, '2014-01-15 01:07:34.000000', 'consum', 0.0221, 'lps'),
	(496989, 129, '2014-01-15 01:07:35.000000', 'consum', 0.0218, 'lps'),
	(496990, 129, '2014-01-15 01:07:36.000000', 'consum', 0.0217, 'lps'),
	(496991, 129, '2014-01-15 01:07:37.000000', 'consum', 0.0221, 'lps'),
	(496992, 129, '2014-01-15 01:07:38.000000', 'consum', 0.0218, 'lps'),
	(496993, 129, '2014-01-15 01:07:39.000000', 'consum', 0.0217, 'lps'),
	(496994, 129, '2014-01-15 01:07:40.000000', 'consum', 0.0220, 'lps'),
	(496995, 129, '2014-01-15 01:07:41.000000', 'consum', 0.0211, 'lps'),
	(496996, 129, '2014-01-15 01:07:42.000000', 'consum', 0.0214, 'lps'),
	(496997, 129, '2014-01-15 01:07:43.000000', 'consum', 0.0213, 'lps'),
	(496998, 129, '2014-01-15 01:07:44.000000', 'consum', 0.0213, 'lps'),
	(496999, 129, '2014-01-15 01:07:45.000000', 'consum', 0.0216, 'lps'),
	(497000, 129, '2014-01-15 01:07:46.000000', 'consum', 0.0218, 'lps'),
	(497001, 129, '2014-01-15 01:07:47.000000', 'consum', 0.0219, 'lps'),
	(497002, 129, '2014-01-15 01:07:48.000000', 'consum', 0.0217, 'lps'),
	(497003, 129, '2014-01-15 01:07:49.000000', 'consum', 0.0218, 'lps'),
	(497004, 129, '2014-01-15 01:07:50.000000', 'consum', 0.0215, 'lps'),
	(497005, 129, '2014-01-15 01:07:51.000000', 'consum', 0.0211, 'lps'),
	(497006, 129, '2014-01-15 01:07:52.000000', 'consum', 0.0216, 'lps'),
	(497007, 129, '2014-01-15 01:07:53.000000', 'consum', 0.0222, 'lps'),
	(497008, 129, '2014-01-15 01:07:54.000000', 'consum', 0.0211, 'lps'),
	(497009, 129, '2014-01-15 01:07:55.000000', 'consum', 0.0221, 'lps'),
	(497010, 129, '2014-01-15 01:07:56.000000', 'consum', 0.0222, 'lps'),
	(497011, 129, '2014-01-15 01:07:57.000000', 'consum', 0.0222, 'lps'),
	(497012, 129, '2014-01-15 01:07:58.000000', 'consum', 0.0221, 'lps'),
	(497013, 129, '2014-01-15 01:07:59.000000', 'consum', 0.0213, 'lps'),
	(497014, 129, '2014-01-15 01:08:00.000000', 'consum', 0.0210, 'lps'),
	(497015, 129, '2014-01-15 01:08:01.000000', 'consum', 0.0216, 'lps'),
	(497016, 129, '2014-01-15 01:08:02.000000', 'consum', 0.0211, 'lps'),
	(497017, 129, '2014-01-15 01:08:03.000000', 'consum', 0.0213, 'lps'),
	(497018, 129, '2014-01-15 01:08:04.000000', 'consum', 0.0223, 'lps'),
	(497019, 129, '2014-01-15 01:08:05.000000', 'consum', 0.0222, 'lps'),
	(497020, 129, '2014-01-15 01:08:06.000000', 'consum', 0.0218, 'lps'),
	(497021, 129, '2014-01-15 01:08:07.000000', 'consum', 0.0214, 'lps'),
	(497022, 129, '2014-01-15 01:08:08.000000', 'consum', 0.0220, 'lps'),
	(497023, 129, '2014-01-15 01:08:09.000000', 'consum', 0.0220, 'lps'),
	(497024, 129, '2014-01-15 01:08:10.000000', 'consum', 0.0215, 'lps'),
	(497025, 129, '2014-01-15 01:08:11.000000', 'consum', 0.0223, 'lps'),
	(497026, 129, '2014-01-15 01:08:12.000000', 'consum', 0.0216, 'lps'),
	(497027, 129, '2014-01-15 01:08:13.000000', 'consum', 0.0216, 'lps'),
	(497028, 129, '2014-01-15 01:08:14.000000', 'consum', 0.0223, 'lps'),
	(497029, 129, '2014-01-15 01:08:15.000000', 'consum', 0.0214, 'lps'),
	(497030, 129, '2014-01-15 01:08:16.000000', 'consum', 0.0220, 'lps'),
	(497031, 129, '2014-01-15 01:08:17.000000', 'consum', 0.0221, 'lps'),
	(497032, 129, '2014-01-15 01:08:18.000000', 'consum', 0.0222, 'lps'),
	(497033, 129, '2014-01-15 01:08:19.000000', 'consum', 0.0222, 'lps'),
	(497034, 129, '2014-01-15 01:08:20.000000', 'consum', 0.0219, 'lps'),
	(497035, 129, '2014-01-15 01:08:21.000000', 'consum', 0.0222, 'lps'),
	(497036, 129, '2014-01-15 01:08:22.000000', 'consum', 0.0214, 'lps'),
	(497037, 129, '2014-01-15 01:08:23.000000', 'consum', 0.0221, 'lps'),
	(497038, 129, '2014-01-15 01:08:24.000000', 'consum', 0.0215, 'lps'),
	(497039, 129, '2014-01-15 01:08:25.000000', 'consum', 0.0214, 'lps'),
	(497040, 129, '2014-01-15 01:08:26.000000', 'consum', 0.0217, 'lps'),
	(497041, 129, '2014-01-15 01:08:27.000000', 'consum', 0.0220, 'lps'),
	(497042, 129, '2014-01-15 01:08:28.000000', 'consum', 0.0211, 'lps'),
	(497043, 129, '2014-01-15 01:08:29.000000', 'consum', 0.0212, 'lps'),
	(497044, 129, '2014-01-15 01:08:30.000000', 'consum', 0.0220, 'lps'),
	(497045, 129, '2014-01-15 01:08:31.000000', 'consum', 0.0213, 'lps'),
	(497046, 129, '2014-01-15 01:08:32.000000', 'consum', 0.0221, 'lps'),
	(497047, 129, '2014-01-15 01:08:33.000000', 'consum', 0.0214, 'lps'),
	(497048, 129, '2014-01-15 01:08:34.000000', 'consum', 0.0213, 'lps'),
	(497049, 129, '2014-01-15 01:08:35.000000', 'consum', 0.0212, 'lps'),
	(497050, 129, '2014-01-15 01:08:36.000000', 'consum', 0.0212, 'lps'),
	(497051, 129, '2014-01-15 01:08:37.000000', 'consum', 0.0217, 'lps'),
	(497052, 129, '2014-01-15 01:08:38.000000', 'consum', 0.0223, 'lps'),
	(497053, 129, '2014-01-15 01:08:39.000000', 'consum', 0.0213, 'lps'),
	(497054, 129, '2014-01-15 01:08:40.000000', 'consum', 0.0215, 'lps'),
	(497055, 129, '2014-01-15 01:08:41.000000', 'consum', 0.0212, 'lps'),
	(497056, 129, '2014-01-15 01:08:42.000000', 'consum', 0.0218, 'lps'),
	(497057, 129, '2014-01-15 01:08:43.000000', 'consum', 0.0219, 'lps'),
	(497058, 129, '2014-01-15 01:08:44.000000', 'consum', 0.0216, 'lps'),
	(497059, 129, '2014-01-15 01:08:45.000000', 'consum', 0.0213, 'lps'),
	(497060, 129, '2014-01-15 01:08:46.000000', 'consum', 0.0223, 'lps'),
	(497061, 129, '2014-01-15 01:08:47.000000', 'consum', 0.0210, 'lps'),
	(497062, 129, '2014-01-15 01:08:48.000000', 'consum', 0.0215, 'lps'),
	(497063, 129, '2014-01-15 01:08:49.000000', 'consum', 0.0219, 'lps'),
	(497064, 129, '2014-01-15 01:08:50.000000', 'consum', 0.0213, 'lps'),
	(497065, 129, '2014-01-15 01:08:51.000000', 'consum', 0.0212, 'lps'),
	(497066, 129, '2014-01-15 01:08:52.000000', 'consum', 0.0210, 'lps'),
	(497067, 129, '2014-01-15 01:08:53.000000', 'consum', 0.0221, 'lps'),
	(497068, 129, '2014-01-15 01:08:54.000000', 'consum', 0.0221, 'lps'),
	(497069, 129, '2014-01-15 01:08:55.000000', 'consum', 0.0220, 'lps'),
	(497070, 129, '2014-01-15 01:08:56.000000', 'consum', 0.0215, 'lps'),
	(497071, 129, '2014-01-15 01:08:57.000000', 'consum', 0.0218, 'lps'),
	(497072, 129, '2014-01-15 01:08:58.000000', 'consum', 0.0220, 'lps'),
	(497073, 129, '2014-01-15 01:08:59.000000', 'consum', 0.0210, 'lps'),
	(497074, 129, '2014-01-15 01:09:00.000000', 'consum', 0.0221, 'lps'),
	(497075, 129, '2014-01-15 01:09:01.000000', 'consum', 0.0223, 'lps'),
	(497076, 129, '2014-01-15 01:09:02.000000', 'consum', 0.0214, 'lps'),
	(497077, 129, '2014-01-15 01:09:03.000000', 'consum', 0.0222, 'lps'),
	(497078, 129, '2014-01-15 01:09:04.000000', 'consum', 0.0214, 'lps'),
	(497079, 129, '2014-01-15 01:09:05.000000', 'consum', 0.0223, 'lps'),
	(497080, 129, '2014-01-15 01:09:06.000000', 'consum', 0.0223, 'lps'),
	(497081, 129, '2014-01-15 01:09:07.000000', 'consum', 0.0222, 'lps'),
	(497082, 129, '2014-01-15 01:09:08.000000', 'consum', 0.0219, 'lps'),
	(497083, 129, '2014-01-15 01:09:09.000000', 'consum', 0.0218, 'lps'),
	(497084, 129, '2014-01-15 01:09:10.000000', 'consum', 0.0222, 'lps'),
	(497085, 129, '2014-01-15 01:09:11.000000', 'consum', 0.0221, 'lps'),
	(497086, 129, '2014-01-15 01:09:12.000000', 'consum', 0.0213, 'lps'),
	(497087, 129, '2014-01-15 01:09:13.000000', 'consum', 0.0222, 'lps'),
	(497088, 129, '2014-01-15 01:09:14.000000', 'consum', 0.0217, 'lps'),
	(497089, 129, '2014-01-15 01:09:15.000000', 'consum', 0.0212, 'lps'),
	(497090, 129, '2014-01-15 01:09:16.000000', 'consum', 0.0214, 'lps'),
	(497091, 129, '2014-01-15 01:09:17.000000', 'consum', 0.0222, 'lps'),
	(497092, 129, '2014-01-15 01:09:18.000000', 'consum', 0.0216, 'lps'),
	(497093, 129, '2014-01-15 01:09:19.000000', 'consum', 0.0221, 'lps'),
	(497094, 129, '2014-01-15 01:09:20.000000', 'consum', 0.0220, 'lps'),
	(497095, 129, '2014-01-15 01:09:21.000000', 'consum', 0.0215, 'lps'),
	(497096, 129, '2014-01-15 01:09:22.000000', 'consum', 0.0216, 'lps'),
	(497097, 129, '2014-01-15 01:09:23.000000', 'consum', 0.0213, 'lps'),
	(497098, 129, '2014-01-15 01:09:24.000000', 'consum', 0.0222, 'lps'),
	(497099, 129, '2014-01-15 01:09:25.000000', 'consum', 0.0219, 'lps'),
	(497100, 129, '2014-01-15 01:09:26.000000', 'consum', 0.0219, 'lps'),
	(497101, 129, '2014-01-15 01:09:27.000000', 'consum', 0.0215, 'lps'),
	(497102, 129, '2014-01-15 01:09:28.000000', 'consum', 0.0221, 'lps'),
	(497103, 129, '2014-01-15 01:09:29.000000', 'consum', 0.0210, 'lps'),
	(497104, 129, '2014-01-15 01:09:30.000000', 'consum', 0.0220, 'lps'),
	(497105, 129, '2014-01-15 01:09:31.000000', 'consum', 0.0217, 'lps'),
	(497106, 129, '2014-01-15 01:09:32.000000', 'consum', 0.0214, 'lps'),
	(497107, 129, '2014-01-15 01:09:33.000000', 'consum', 0.0212, 'lps'),
	(497108, 129, '2014-01-15 01:09:34.000000', 'consum', 0.0222, 'lps'),
	(497109, 129, '2014-01-15 01:09:35.000000', 'consum', 0.0210, 'lps'),
	(497110, 129, '2014-01-15 01:09:36.000000', 'consum', 0.0213, 'lps'),
	(497111, 129, '2014-01-15 01:09:37.000000', 'consum', 0.0214, 'lps'),
	(497112, 129, '2014-01-15 01:09:38.000000', 'consum', 0.0221, 'lps'),
	(497113, 129, '2014-01-15 01:09:39.000000', 'consum', 0.0213, 'lps'),
	(497114, 129, '2014-01-15 01:09:40.000000', 'consum', 0.0220, 'lps'),
	(497115, 129, '2014-01-15 01:09:41.000000', 'consum', 0.0222, 'lps'),
	(497116, 129, '2014-01-15 01:09:42.000000', 'consum', 0.0213, 'lps'),
	(497117, 129, '2014-01-15 01:09:43.000000', 'consum', 0.0217, 'lps'),
	(497118, 129, '2014-01-15 01:09:44.000000', 'consum', 0.0211, 'lps'),
	(497119, 129, '2014-01-15 01:09:45.000000', 'consum', 0.0220, 'lps'),
	(497120, 129, '2014-01-15 01:09:46.000000', 'consum', 0.0218, 'lps'),
	(497121, 129, '2014-01-15 01:09:47.000000', 'consum', 0.0220, 'lps'),
	(497122, 129, '2014-01-15 01:09:48.000000', 'consum', 0.0222, 'lps'),
	(497123, 129, '2014-01-15 01:09:49.000000', 'consum', 0.0211, 'lps'),
	(497124, 129, '2014-01-15 01:09:50.000000', 'consum', 0.0222, 'lps'),
	(497125, 129, '2014-01-15 01:09:51.000000', 'consum', 0.0211, 'lps'),
	(497126, 129, '2014-01-15 01:09:52.000000', 'consum', 0.0222, 'lps'),
	(497127, 129, '2014-01-15 01:09:53.000000', 'consum', 0.0210, 'lps'),
	(497128, 129, '2014-01-15 01:09:54.000000', 'consum', 0.0217, 'lps'),
	(497129, 129, '2014-01-15 01:09:55.000000', 'consum', 0.0217, 'lps'),
	(497130, 129, '2014-01-15 01:09:56.000000', 'consum', 0.0210, 'lps'),
	(497131, 129, '2014-01-15 01:09:57.000000', 'consum', 0.0218, 'lps'),
	(497132, 129, '2014-01-15 01:09:58.000000', 'consum', 0.0223, 'lps'),
	(497133, 129, '2014-01-15 01:09:59.000000', 'consum', 0.0211, 'lps'),
	(497134, 129, '2014-01-15 01:10:00.000000', 'consum', 0.0216, 'lps'),
	(497135, 129, '2014-01-15 01:10:01.000000', 'consum', 0.0211, 'lps'),
	(497136, 129, '2014-01-15 01:10:02.000000', 'consum', 0.0212, 'lps'),
	(497137, 129, '2014-01-15 01:10:03.000000', 'consum', 0.0216, 'lps'),
	(497138, 129, '2014-01-15 01:10:04.000000', 'consum', 0.0222, 'lps'),
	(497139, 129, '2014-01-15 01:10:05.000000', 'consum', 0.0211, 'lps'),
	(497140, 129, '2014-01-15 01:10:06.000000', 'consum', 0.0220, 'lps'),
	(497141, 129, '2014-01-15 01:10:07.000000', 'consum', 0.0215, 'lps'),
	(497142, 129, '2014-01-15 01:10:08.000000', 'consum', 0.0222, 'lps'),
	(497143, 129, '2014-01-15 01:10:09.000000', 'consum', 0.0212, 'lps'),
	(497144, 129, '2014-01-15 01:10:10.000000', 'consum', 0.0214, 'lps'),
	(497145, 129, '2014-01-15 01:10:11.000000', 'consum', 0.0211, 'lps'),
	(497146, 129, '2014-01-15 01:10:12.000000', 'consum', 0.0215, 'lps'),
	(497147, 129, '2014-01-15 01:10:13.000000', 'consum', 0.0221, 'lps'),
	(497148, 129, '2014-01-15 01:10:14.000000', 'consum', 0.0221, 'lps'),
	(497149, 129, '2014-01-15 01:10:15.000000', 'consum', 0.0221, 'lps'),
	(497150, 129, '2014-01-15 01:10:16.000000', 'consum', 0.0216, 'lps'),
	(497151, 129, '2014-01-15 01:10:17.000000', 'consum', 0.0210, 'lps'),
	(497152, 129, '2014-01-15 01:10:18.000000', 'consum', 0.0220, 'lps'),
	(497153, 129, '2014-01-15 01:10:19.000000', 'consum', 0.0218, 'lps'),
	(497154, 129, '2014-01-15 01:10:20.000000', 'consum', 0.0220, 'lps'),
	(497155, 129, '2014-01-15 01:10:21.000000', 'consum', 0.0222, 'lps'),
	(497156, 129, '2014-01-15 01:10:22.000000', 'consum', 0.0211, 'lps'),
	(497157, 129, '2014-01-15 01:10:23.000000', 'consum', 0.0210, 'lps'),
	(497158, 129, '2014-01-15 01:10:24.000000', 'consum', 0.0221, 'lps'),
	(497159, 129, '2014-01-15 01:10:25.000000', 'consum', 0.0210, 'lps'),
	(497160, 129, '2014-01-15 01:10:26.000000', 'consum', 0.0218, 'lps'),
	(497161, 129, '2014-01-15 01:10:27.000000', 'consum', 0.0210, 'lps'),
	(497162, 129, '2014-01-15 01:10:28.000000', 'consum', 0.0215, 'lps'),
	(497163, 129, '2014-01-15 01:10:29.000000', 'consum', 0.0220, 'lps'),
	(497164, 129, '2014-01-15 01:10:30.000000', 'consum', 0.0218, 'lps'),
	(497165, 129, '2014-01-15 01:10:31.000000', 'consum', 0.0220, 'lps'),
	(497166, 129, '2014-01-15 01:10:32.000000', 'consum', 0.0210, 'lps'),
	(497167, 129, '2014-01-15 01:10:33.000000', 'consum', 0.0223, 'lps'),
	(497168, 129, '2014-01-15 01:10:34.000000', 'consum', 0.0219, 'lps'),
	(497169, 129, '2014-01-15 01:10:35.000000', 'consum', 0.0215, 'lps'),
	(497170, 129, '2014-01-15 01:10:36.000000', 'consum', 0.0223, 'lps'),
	(497171, 129, '2014-01-15 01:10:37.000000', 'consum', 0.0217, 'lps'),
	(497172, 129, '2014-01-15 01:10:38.000000', 'consum', 0.0223, 'lps'),
	(497173, 129, '2014-01-15 01:10:39.000000', 'consum', 0.0210, 'lps'),
	(497174, 129, '2014-01-15 01:10:40.000000', 'consum', 0.0214, 'lps'),
	(497175, 129, '2014-01-15 01:10:41.000000', 'consum', 0.0218, 'lps'),
	(497176, 129, '2014-01-15 01:10:42.000000', 'consum', 0.0210, 'lps'),
	(497177, 129, '2014-01-15 01:10:43.000000', 'consum', 0.0215, 'lps'),
	(497178, 129, '2014-01-15 01:10:44.000000', 'consum', 0.0219, 'lps'),
	(497179, 129, '2014-01-15 01:10:45.000000', 'consum', 0.0216, 'lps'),
	(497180, 129, '2014-01-15 01:10:46.000000', 'consum', 0.0210, 'lps'),
	(497181, 129, '2014-01-15 01:10:47.000000', 'consum', 0.0210, 'lps'),
	(497182, 129, '2014-01-15 01:10:48.000000', 'consum', 0.0223, 'lps'),
	(497183, 129, '2014-01-15 01:10:49.000000', 'consum', 0.0221, 'lps'),
	(497184, 129, '2014-01-15 01:10:50.000000', 'consum', 0.0210, 'lps'),
	(497185, 129, '2014-01-15 01:10:51.000000', 'consum', 0.0221, 'lps'),
	(497186, 129, '2014-01-15 01:10:52.000000', 'consum', 0.0223, 'lps'),
	(497187, 129, '2014-01-15 01:10:53.000000', 'consum', 0.0216, 'lps'),
	(497188, 129, '2014-01-15 01:10:54.000000', 'consum', 0.0213, 'lps'),
	(497189, 129, '2014-01-15 01:10:55.000000', 'consum', 0.0223, 'lps'),
	(497190, 129, '2014-01-15 01:10:56.000000', 'consum', 0.0211, 'lps'),
	(497191, 129, '2014-01-15 01:10:57.000000', 'consum', 0.0216, 'lps'),
	(497192, 129, '2014-01-15 01:10:58.000000', 'consum', 0.0210, 'lps'),
	(497193, 129, '2014-01-15 01:10:59.000000', 'consum', 0.0222, 'lps'),
	(497194, 129, '2014-01-15 01:11:00.000000', 'consum', 0.0214, 'lps'),
	(497195, 129, '2014-01-15 01:11:01.000000', 'consum', 0.0221, 'lps'),
	(497196, 129, '2014-01-15 01:11:02.000000', 'consum', 0.0214, 'lps'),
	(497197, 129, '2014-01-15 01:11:03.000000', 'consum', 0.0223, 'lps'),
	(497198, 129, '2014-01-15 01:11:04.000000', 'consum', 0.0222, 'lps'),
	(497199, 129, '2014-01-15 01:11:05.000000', 'consum', 0.0216, 'lps'),
	(497200, 129, '2014-01-15 01:11:06.000000', 'consum', 0.0221, 'lps'),
	(497201, 129, '2014-01-15 01:11:07.000000', 'consum', 0.0218, 'lps'),
	(497202, 129, '2014-01-15 01:11:08.000000', 'consum', 0.0217, 'lps'),
	(497203, 129, '2014-01-15 01:11:09.000000', 'consum', 0.0222, 'lps'),
	(497204, 129, '2014-01-15 01:11:10.000000', 'consum', 0.0222, 'lps'),
	(497205, 129, '2014-01-15 01:11:11.000000', 'consum', 0.0220, 'lps'),
	(497206, 129, '2014-01-15 01:11:12.000000', 'consum', 0.0223, 'lps'),
	(497207, 129, '2014-01-15 01:11:13.000000', 'consum', 0.0221, 'lps'),
	(497208, 129, '2014-01-15 01:11:14.000000', 'consum', 0.0223, 'lps'),
	(497209, 129, '2014-01-15 01:11:15.000000', 'consum', 0.0217, 'lps'),
	(497210, 129, '2014-01-15 01:11:16.000000', 'consum', 0.0220, 'lps'),
	(497211, 129, '2014-01-15 01:11:17.000000', 'consum', 0.0211, 'lps'),
	(497212, 129, '2014-01-15 01:11:18.000000', 'consum', 0.0214, 'lps'),
	(497213, 129, '2014-01-15 01:11:19.000000', 'consum', 0.0212, 'lps'),
	(497214, 129, '2014-01-15 01:11:20.000000', 'consum', 0.0222, 'lps'),
	(497215, 129, '2014-01-15 01:11:21.000000', 'consum', 0.0210, 'lps'),
	(497216, 129, '2014-01-15 01:11:22.000000', 'consum', 0.0218, 'lps'),
	(497217, 129, '2014-01-15 01:11:23.000000', 'consum', 0.0221, 'lps'),
	(497218, 129, '2014-01-15 01:11:24.000000', 'consum', 0.0212, 'lps'),
	(497219, 129, '2014-01-15 01:11:25.000000', 'consum', 0.0216, 'lps'),
	(497220, 129, '2014-01-15 01:11:26.000000', 'consum', 0.0221, 'lps'),
	(497221, 129, '2014-01-15 01:11:27.000000', 'consum', 0.0218, 'lps'),
	(497222, 129, '2014-01-15 01:11:28.000000', 'consum', 0.0218, 'lps'),
	(497223, 129, '2014-01-15 01:11:29.000000', 'consum', 0.0212, 'lps'),
	(497224, 129, '2014-01-15 01:11:30.000000', 'consum', 0.0210, 'lps'),
	(497225, 129, '2014-01-15 01:11:31.000000', 'consum', 0.0221, 'lps'),
	(497226, 129, '2014-01-15 01:11:32.000000', 'consum', 0.0210, 'lps'),
	(497227, 129, '2014-01-15 01:11:33.000000', 'consum', 0.0217, 'lps'),
	(497228, 129, '2014-01-15 01:11:34.000000', 'consum', 0.0218, 'lps'),
	(497229, 129, '2014-01-15 01:11:35.000000', 'consum', 0.0218, 'lps'),
	(497230, 129, '2014-01-15 01:11:36.000000', 'consum', 0.0211, 'lps'),
	(497231, 129, '2014-01-15 01:11:37.000000', 'consum', 0.0218, 'lps'),
	(497232, 129, '2014-01-15 01:11:38.000000', 'consum', 0.0220, 'lps'),
	(497233, 129, '2014-01-15 01:11:39.000000', 'consum', 0.0222, 'lps'),
	(497234, 129, '2014-01-15 01:11:40.000000', 'consum', 0.0211, 'lps'),
	(497235, 129, '2014-01-15 01:11:41.000000', 'consum', 0.0210, 'lps'),
	(497236, 129, '2014-01-15 01:11:42.000000', 'consum', 0.0220, 'lps'),
	(497237, 129, '2014-01-15 01:11:43.000000', 'consum', 0.0217, 'lps'),
	(497238, 129, '2014-01-15 01:11:44.000000', 'consum', 0.0217, 'lps'),
	(497239, 129, '2014-01-15 01:11:45.000000', 'consum', 0.0210, 'lps'),
	(497240, 129, '2014-01-15 01:11:46.000000', 'consum', 0.0218, 'lps'),
	(497241, 129, '2014-01-15 01:11:47.000000', 'consum', 0.0210, 'lps'),
	(497242, 129, '2014-01-15 01:11:48.000000', 'consum', 0.0215, 'lps'),
	(497243, 129, '2014-01-15 01:11:49.000000', 'consum', 0.0219, 'lps'),
	(497244, 129, '2014-01-15 01:11:50.000000', 'consum', 0.0214, 'lps'),
	(497245, 129, '2014-01-15 01:11:51.000000', 'consum', 0.0216, 'lps'),
	(497246, 129, '2014-01-15 01:11:52.000000', 'consum', 0.0213, 'lps'),
	(497247, 129, '2014-01-15 01:11:53.000000', 'consum', 0.0210, 'lps'),
	(497248, 129, '2014-01-15 01:11:54.000000', 'consum', 0.0214, 'lps'),
	(497249, 129, '2014-01-15 01:11:55.000000', 'consum', 0.0218, 'lps'),
	(497250, 129, '2014-01-15 01:11:56.000000', 'consum', 0.0212, 'lps'),
	(497251, 129, '2014-01-15 01:11:57.000000', 'consum', 0.0223, 'lps'),
	(497252, 129, '2014-01-15 01:11:58.000000', 'consum', 0.0214, 'lps'),
	(497253, 129, '2014-01-15 01:11:59.000000', 'consum', 0.0217, 'lps'),
	(497254, 129, '2014-01-15 01:12:00.000000', 'consum', 0.0222, 'lps'),
	(497255, 129, '2014-01-15 01:12:01.000000', 'consum', 0.0223, 'lps'),
	(497256, 129, '2014-01-15 01:12:02.000000', 'consum', 0.0210, 'lps'),
	(497257, 129, '2014-01-15 01:12:03.000000', 'consum', 0.0212, 'lps'),
	(497258, 129, '2014-01-15 01:12:04.000000', 'consum', 0.0221, 'lps'),
	(497259, 129, '2014-01-15 01:12:05.000000', 'consum', 0.0217, 'lps'),
	(497260, 129, '2014-01-15 01:12:06.000000', 'consum', 0.0212, 'lps'),
	(497261, 129, '2014-01-15 01:12:07.000000', 'consum', 0.0213, 'lps'),
	(497262, 129, '2014-01-15 01:12:08.000000', 'consum', 0.0219, 'lps'),
	(497263, 129, '2014-01-15 01:12:09.000000', 'consum', 0.0221, 'lps'),
	(497264, 129, '2014-01-15 01:12:10.000000', 'consum', 0.0222, 'lps'),
	(497265, 129, '2014-01-15 01:12:11.000000', 'consum', 0.0223, 'lps'),
	(497266, 129, '2014-01-15 01:12:12.000000', 'consum', 0.0211, 'lps'),
	(497267, 129, '2014-01-15 01:12:13.000000', 'consum', 0.0217, 'lps'),
	(497268, 129, '2014-01-15 01:12:14.000000', 'consum', 0.0218, 'lps'),
	(497269, 129, '2014-01-15 01:12:15.000000', 'consum', 0.0215, 'lps'),
	(497270, 129, '2014-01-15 01:12:16.000000', 'consum', 0.0212, 'lps'),
	(497271, 129, '2014-01-15 01:12:17.000000', 'consum', 0.0218, 'lps'),
	(497272, 129, '2014-01-15 01:12:18.000000', 'consum', 0.0219, 'lps'),
	(497273, 129, '2014-01-15 01:12:19.000000', 'consum', 0.0215, 'lps'),
	(497274, 129, '2014-01-15 01:12:20.000000', 'consum', 0.0221, 'lps'),
	(497275, 129, '2014-01-15 01:12:21.000000', 'consum', 0.0212, 'lps'),
	(497276, 129, '2014-01-15 01:12:22.000000', 'consum', 0.0212, 'lps'),
	(497277, 129, '2014-01-15 01:12:23.000000', 'consum', 0.0217, 'lps'),
	(497278, 129, '2014-01-15 01:12:24.000000', 'consum', 0.0211, 'lps'),
	(497279, 129, '2014-01-15 01:12:25.000000', 'consum', 0.0223, 'lps'),
	(497280, 129, '2014-01-15 01:12:26.000000', 'consum', 0.0215, 'lps'),
	(497281, 129, '2014-01-15 01:12:27.000000', 'consum', 0.0212, 'lps'),
	(497282, 129, '2014-01-15 01:12:28.000000', 'consum', 0.0218, 'lps'),
	(497283, 129, '2014-01-15 01:12:29.000000', 'consum', 0.0215, 'lps'),
	(497284, 129, '2014-01-15 01:12:30.000000', 'consum', 0.0214, 'lps'),
	(497285, 129, '2014-01-15 01:12:31.000000', 'consum', 0.0213, 'lps'),
	(497286, 129, '2014-01-15 01:12:32.000000', 'consum', 0.0215, 'lps'),
	(497287, 129, '2014-01-15 01:12:33.000000', 'consum', 0.0213, 'lps'),
	(497288, 129, '2014-01-15 01:12:34.000000', 'consum', 0.0212, 'lps'),
	(497289, 129, '2014-01-15 01:12:35.000000', 'consum', 0.0222, 'lps'),
	(497290, 129, '2014-01-15 01:12:36.000000', 'consum', 0.0212, 'lps'),
	(497291, 129, '2014-01-15 01:12:37.000000', 'consum', 0.0210, 'lps'),
	(497292, 129, '2014-01-15 01:12:38.000000', 'consum', 0.0221, 'lps'),
	(497293, 129, '2014-01-15 01:12:39.000000', 'consum', 0.0221, 'lps'),
	(497294, 129, '2014-01-15 01:12:40.000000', 'consum', 0.0220, 'lps'),
	(497295, 129, '2014-01-15 01:12:41.000000', 'consum', 0.0211, 'lps'),
	(497296, 129, '2014-01-15 01:12:42.000000', 'consum', 0.0216, 'lps'),
	(497297, 129, '2014-01-15 01:12:43.000000', 'consum', 0.0223, 'lps'),
	(497298, 129, '2014-01-15 01:12:44.000000', 'consum', 0.0216, 'lps'),
	(497299, 129, '2014-01-15 01:12:45.000000', 'consum', 0.0216, 'lps'),
	(497300, 129, '2014-01-15 01:12:46.000000', 'consum', 0.0222, 'lps'),
	(497301, 129, '2014-01-15 01:12:47.000000', 'consum', 0.0211, 'lps'),
	(497302, 129, '2014-01-15 01:12:48.000000', 'consum', 0.0223, 'lps'),
	(497303, 129, '2014-01-15 01:12:49.000000', 'consum', 0.0215, 'lps'),
	(497304, 129, '2014-01-15 01:12:50.000000', 'consum', 0.0210, 'lps'),
	(497305, 129, '2014-01-15 01:12:51.000000', 'consum', 0.0210, 'lps'),
	(497306, 129, '2014-01-15 01:12:52.000000', 'consum', 0.0213, 'lps'),
	(497307, 129, '2014-01-15 01:12:53.000000', 'consum', 0.0222, 'lps'),
	(497308, 129, '2014-01-15 01:12:54.000000', 'consum', 0.0219, 'lps'),
	(497309, 129, '2014-01-15 01:12:55.000000', 'consum', 0.0223, 'lps'),
	(497310, 129, '2014-01-15 01:12:56.000000', 'consum', 0.0218, 'lps'),
	(497311, 129, '2014-01-15 01:12:57.000000', 'consum', 0.0212, 'lps'),
	(497312, 129, '2014-01-15 01:12:58.000000', 'consum', 0.0210, 'lps'),
	(497313, 129, '2014-01-15 01:12:59.000000', 'consum', 0.0220, 'lps'),
	(497314, 129, '2014-01-15 01:13:00.000000', 'consum', 0.0219, 'lps'),
	(497315, 129, '2014-01-15 01:13:01.000000', 'consum', 0.0210, 'lps'),
	(497316, 129, '2014-01-15 01:13:02.000000', 'consum', 0.0211, 'lps'),
	(497317, 129, '2014-01-15 01:13:03.000000', 'consum', 0.0216, 'lps'),
	(497318, 129, '2014-01-15 01:13:04.000000', 'consum', 0.0222, 'lps'),
	(497319, 129, '2014-01-15 01:13:05.000000', 'consum', 0.0212, 'lps'),
	(497320, 129, '2014-01-15 01:13:06.000000', 'consum', 0.0214, 'lps'),
	(497321, 129, '2014-01-15 01:13:07.000000', 'consum', 0.0210, 'lps'),
	(497322, 129, '2014-01-15 01:13:08.000000', 'consum', 0.0212, 'lps'),
	(497323, 129, '2014-01-15 01:13:09.000000', 'consum', 0.0222, 'lps'),
	(497324, 129, '2014-01-15 01:13:10.000000', 'consum', 0.0223, 'lps'),
	(497325, 129, '2014-01-15 01:13:11.000000', 'consum', 0.0212, 'lps'),
	(497326, 129, '2014-01-15 01:13:12.000000', 'consum', 0.0222, 'lps'),
	(497327, 129, '2014-01-15 01:13:13.000000', 'consum', 0.0223, 'lps'),
	(497328, 129, '2014-01-15 01:13:14.000000', 'consum', 0.0211, 'lps'),
	(497329, 129, '2014-01-15 01:13:15.000000', 'consum', 0.0220, 'lps'),
	(497330, 129, '2014-01-15 01:13:16.000000', 'consum', 0.0216, 'lps'),
	(497331, 129, '2014-01-15 01:13:17.000000', 'consum', 0.0223, 'lps'),
	(497332, 129, '2014-01-15 01:13:18.000000', 'consum', 0.0218, 'lps'),
	(497333, 129, '2014-01-15 01:13:19.000000', 'consum', 0.0223, 'lps'),
	(497334, 129, '2014-01-15 01:13:20.000000', 'consum', 0.0222, 'lps'),
	(497335, 129, '2014-01-15 01:13:21.000000', 'consum', 0.0221, 'lps'),
	(497336, 129, '2014-01-15 01:13:22.000000', 'consum', 0.0214, 'lps'),
	(497337, 129, '2014-01-15 01:13:23.000000', 'consum', 0.0213, 'lps'),
	(497338, 129, '2014-01-15 01:13:24.000000', 'consum', 0.0214, 'lps'),
	(497339, 129, '2014-01-15 01:13:25.000000', 'consum', 0.0221, 'lps'),
	(497340, 129, '2014-01-15 01:13:26.000000', 'consum', 0.0211, 'lps'),
	(497341, 129, '2014-01-15 01:13:27.000000', 'consum', 0.0213, 'lps'),
	(497342, 129, '2014-01-15 01:13:28.000000', 'consum', 0.0220, 'lps'),
	(497343, 129, '2014-01-15 01:13:29.000000', 'consum', 0.0222, 'lps'),
	(497344, 129, '2014-01-15 01:13:30.000000', 'consum', 0.0214, 'lps'),
	(497345, 129, '2014-01-15 01:13:31.000000', 'consum', 0.0221, 'lps'),
	(497346, 129, '2014-01-15 01:13:32.000000', 'consum', 0.0212, 'lps'),
	(497347, 129, '2014-01-15 01:13:33.000000', 'consum', 0.0214, 'lps'),
	(497348, 129, '2014-01-15 01:13:34.000000', 'consum', 0.0212, 'lps'),
	(497349, 129, '2014-01-15 01:13:35.000000', 'consum', 0.0221, 'lps'),
	(497350, 129, '2014-01-15 01:13:36.000000', 'consum', 0.0220, 'lps'),
	(497351, 129, '2014-01-15 01:13:37.000000', 'consum', 0.0212, 'lps'),
	(497352, 129, '2014-01-15 01:13:38.000000', 'consum', 0.0218, 'lps'),
	(497353, 129, '2014-01-15 01:13:39.000000', 'consum', 0.0217, 'lps'),
	(497354, 129, '2014-01-15 01:13:40.000000', 'consum', 0.0222, 'lps'),
	(497355, 129, '2014-01-15 01:13:41.000000', 'consum', 0.0223, 'lps'),
	(497356, 129, '2014-01-15 01:13:42.000000', 'consum', 0.0223, 'lps'),
	(497357, 129, '2014-01-15 01:13:43.000000', 'consum', 0.0222, 'lps'),
	(497358, 129, '2014-01-15 01:13:44.000000', 'consum', 0.0219, 'lps'),
	(497359, 129, '2014-01-15 01:13:45.000000', 'consum', 0.0219, 'lps'),
	(497360, 129, '2014-01-15 01:13:46.000000', 'consum', 0.0215, 'lps'),
	(497361, 129, '2014-01-15 01:13:47.000000', 'consum', 0.0223, 'lps'),
	(497362, 129, '2014-01-15 01:13:48.000000', 'consum', 0.0218, 'lps'),
	(497363, 129, '2014-01-15 01:13:49.000000', 'consum', 0.0210, 'lps'),
	(497364, 129, '2014-01-15 01:13:50.000000', 'consum', 0.0216, 'lps'),
	(497365, 129, '2014-01-15 01:13:51.000000', 'consum', 0.0214, 'lps'),
	(497366, 129, '2014-01-15 01:13:52.000000', 'consum', 0.0210, 'lps'),
	(497367, 129, '2014-01-15 01:13:53.000000', 'consum', 0.0215, 'lps'),
	(497368, 129, '2014-01-15 01:13:54.000000', 'consum', 0.0219, 'lps'),
	(497369, 129, '2014-01-15 01:13:55.000000', 'consum', 0.0212, 'lps'),
	(497370, 129, '2014-01-15 01:13:56.000000', 'consum', 0.0221, 'lps'),
	(497371, 129, '2014-01-15 01:13:57.000000', 'consum', 0.0219, 'lps'),
	(497372, 129, '2014-01-15 01:13:58.000000', 'consum', 0.0221, 'lps'),
	(497373, 129, '2014-01-15 01:13:59.000000', 'consum', 0.0210, 'lps'),
	(497374, 129, '2014-01-15 01:14:00.000000', 'consum', 0.0220, 'lps'),
	(497375, 129, '2014-01-15 01:14:01.000000', 'consum', 0.0220, 'lps'),
	(497376, 129, '2014-01-15 01:14:02.000000', 'consum', 0.0215, 'lps'),
	(497377, 129, '2014-01-15 01:14:03.000000', 'consum', 0.0219, 'lps'),
	(497378, 129, '2014-01-15 01:14:04.000000', 'consum', 0.0212, 'lps'),
	(497379, 129, '2014-01-15 01:14:05.000000', 'consum', 0.0222, 'lps'),
	(497380, 129, '2014-01-15 01:14:06.000000', 'consum', 0.0211, 'lps'),
	(497381, 129, '2014-01-15 01:14:07.000000', 'consum', 0.0218, 'lps'),
	(497382, 129, '2014-01-15 01:14:08.000000', 'consum', 0.0222, 'lps'),
	(497383, 129, '2014-01-15 01:14:09.000000', 'consum', 0.0216, 'lps'),
	(497384, 129, '2014-01-15 01:14:10.000000', 'consum', 0.0220, 'lps'),
	(497385, 129, '2014-01-15 01:14:11.000000', 'consum', 0.0214, 'lps'),
	(497386, 129, '2014-01-15 01:14:12.000000', 'consum', 0.0216, 'lps'),
	(497387, 129, '2014-01-15 01:14:13.000000', 'consum', 0.0214, 'lps'),
	(497388, 129, '2014-01-15 01:14:14.000000', 'consum', 0.0211, 'lps'),
	(497389, 129, '2014-01-15 01:14:15.000000', 'consum', 0.0220, 'lps'),
	(497390, 129, '2014-01-15 01:14:16.000000', 'consum', 0.0216, 'lps'),
	(497391, 129, '2014-01-15 01:14:17.000000', 'consum', 0.0211, 'lps'),
	(497392, 129, '2014-01-15 01:14:18.000000', 'consum', 0.0211, 'lps'),
	(497393, 129, '2014-01-15 01:14:19.000000', 'consum', 0.0211, 'lps'),
	(497394, 129, '2014-01-15 01:14:20.000000', 'consum', 0.0212, 'lps'),
	(497395, 129, '2014-01-15 01:14:21.000000', 'consum', 0.0220, 'lps'),
	(497396, 129, '2014-01-15 01:14:22.000000', 'consum', 0.0211, 'lps'),
	(497397, 129, '2014-01-15 01:14:23.000000', 'consum', 0.0214, 'lps'),
	(497398, 129, '2014-01-15 01:14:24.000000', 'consum', 0.0214, 'lps'),
	(497399, 129, '2014-01-15 01:14:25.000000', 'consum', 0.0218, 'lps'),
	(497400, 129, '2014-01-15 01:14:26.000000', 'consum', 0.0210, 'lps'),
	(497401, 129, '2014-01-15 01:14:27.000000', 'consum', 0.0217, 'lps'),
	(497402, 129, '2014-01-15 01:14:28.000000', 'consum', 0.0214, 'lps'),
	(497403, 129, '2014-01-15 01:14:29.000000', 'consum', 0.0212, 'lps'),
	(497404, 129, '2014-01-15 01:14:30.000000', 'consum', 0.0222, 'lps'),
	(497405, 129, '2014-01-15 01:14:31.000000', 'consum', 0.0210, 'lps'),
	(497406, 129, '2014-01-15 01:14:32.000000', 'consum', 0.0215, 'lps'),
	(497407, 129, '2014-01-15 01:14:33.000000', 'consum', 0.0220, 'lps'),
	(497408, 129, '2014-01-15 01:14:34.000000', 'consum', 0.0219, 'lps'),
	(497409, 129, '2014-01-15 01:14:35.000000', 'consum', 0.0213, 'lps'),
	(497410, 129, '2014-01-15 01:14:36.000000', 'consum', 0.0212, 'lps'),
	(497411, 129, '2014-01-15 01:14:37.000000', 'consum', 0.0210, 'lps'),
	(497412, 129, '2014-01-15 01:14:38.000000', 'consum', 0.0220, 'lps'),
	(497413, 129, '2014-01-15 01:14:39.000000', 'consum', 0.0217, 'lps'),
	(497414, 129, '2014-01-15 01:14:40.000000', 'consum', 0.0215, 'lps'),
	(497415, 129, '2014-01-15 01:14:41.000000', 'consum', 0.0215, 'lps'),
	(497416, 129, '2014-01-15 01:14:42.000000', 'consum', 0.0219, 'lps'),
	(497417, 129, '2014-01-15 01:14:43.000000', 'consum', 0.0215, 'lps'),
	(497418, 129, '2014-01-15 01:14:44.000000', 'consum', 0.0222, 'lps'),
	(497419, 129, '2014-01-15 01:14:45.000000', 'consum', 0.0214, 'lps'),
	(497420, 129, '2014-01-15 01:14:46.000000', 'consum', 0.0222, 'lps'),
	(497421, 129, '2014-01-15 01:14:47.000000', 'consum', 0.0216, 'lps'),
	(497422, 129, '2014-01-15 01:14:48.000000', 'consum', 0.0218, 'lps'),
	(497423, 129, '2014-01-15 01:14:49.000000', 'consum', 0.0220, 'lps'),
	(497424, 129, '2014-01-15 01:14:50.000000', 'consum', 0.0221, 'lps'),
	(497425, 129, '2014-01-15 01:14:51.000000', 'consum', 0.0222, 'lps'),
	(497426, 129, '2014-01-15 01:14:52.000000', 'consum', 0.0222, 'lps'),
	(497427, 129, '2014-01-15 01:14:53.000000', 'consum', 0.0222, 'lps'),
	(497428, 129, '2014-01-15 01:14:54.000000', 'consum', 0.0218, 'lps'),
	(497429, 129, '2014-01-15 01:14:55.000000', 'consum', 0.0218, 'lps'),
	(497430, 129, '2014-01-15 01:14:56.000000', 'consum', 0.0211, 'lps'),
	(497431, 129, '2014-01-15 01:14:57.000000', 'consum', 0.0221, 'lps'),
	(497432, 129, '2014-01-15 01:14:58.000000', 'consum', 0.0222, 'lps'),
	(497433, 129, '2014-01-15 01:14:59.000000', 'consum', 0.0220, 'lps'),
	(497434, 129, '2014-01-15 01:15:00.000000', 'consum', 0.0210, 'lps'),
	(497435, 129, '2014-01-15 01:15:01.000000', 'consum', 0.0211, 'lps'),
	(497436, 129, '2014-01-15 01:15:02.000000', 'consum', 0.0214, 'lps'),
	(497437, 129, '2014-01-15 01:15:03.000000', 'consum', 0.0212, 'lps'),
	(497438, 129, '2014-01-15 01:15:04.000000', 'consum', 0.0212, 'lps'),
	(497439, 129, '2014-01-15 01:15:05.000000', 'consum', 0.0211, 'lps'),
	(497440, 129, '2014-01-15 01:15:06.000000', 'consum', 0.0211, 'lps'),
	(497441, 129, '2014-01-15 01:15:07.000000', 'consum', 0.0212, 'lps'),
	(497442, 129, '2014-01-15 01:15:08.000000', 'consum', 0.0219, 'lps'),
	(497443, 129, '2014-01-15 01:15:09.000000', 'consum', 0.0221, 'lps'),
	(497444, 129, '2014-01-15 01:15:10.000000', 'consum', 0.0211, 'lps'),
	(497445, 129, '2014-01-15 01:15:11.000000', 'consum', 0.0211, 'lps'),
	(497446, 129, '2014-01-15 01:15:12.000000', 'consum', 0.0210, 'lps'),
	(497447, 129, '2014-01-15 01:15:13.000000', 'consum', 0.0222, 'lps'),
	(497448, 129, '2014-01-15 01:15:14.000000', 'consum', 0.0217, 'lps'),
	(497449, 129, '2014-01-15 01:15:15.000000', 'consum', 0.0222, 'lps'),
	(497450, 129, '2014-01-15 01:15:16.000000', 'consum', 0.0221, 'lps'),
	(497451, 129, '2014-01-15 01:15:17.000000', 'consum', 0.0216, 'lps'),
	(497452, 129, '2014-01-15 01:15:18.000000', 'consum', 0.0220, 'lps'),
	(497453, 129, '2014-01-15 01:15:19.000000', 'consum', 0.0214, 'lps'),
	(497454, 129, '2014-01-15 01:15:20.000000', 'consum', 0.0216, 'lps'),
	(497455, 129, '2014-01-15 01:15:21.000000', 'consum', 0.0216, 'lps'),
	(497456, 129, '2014-01-15 01:15:22.000000', 'consum', 0.0220, 'lps'),
	(497457, 129, '2014-01-15 01:15:23.000000', 'consum', 0.0215, 'lps'),
	(497458, 129, '2014-01-15 01:15:24.000000', 'consum', 0.0221, 'lps'),
	(497459, 129, '2014-01-15 01:15:25.000000', 'consum', 0.0222, 'lps'),
	(497460, 129, '2014-01-15 01:15:26.000000', 'consum', 0.0223, 'lps'),
	(497461, 129, '2014-01-15 01:15:27.000000', 'consum', 0.0211, 'lps'),
	(497462, 129, '2014-01-15 01:15:28.000000', 'consum', 0.0217, 'lps'),
	(497463, 129, '2014-01-15 01:15:29.000000', 'consum', 0.0216, 'lps'),
	(497464, 129, '2014-01-15 01:15:30.000000', 'consum', 0.0221, 'lps'),
	(497465, 129, '2014-01-15 01:15:31.000000', 'consum', 0.0218, 'lps'),
	(497466, 129, '2014-01-15 01:15:32.000000', 'consum', 0.0218, 'lps'),
	(497467, 129, '2014-01-15 01:15:33.000000', 'consum', 0.0214, 'lps'),
	(497468, 129, '2014-01-15 01:15:34.000000', 'consum', 0.0221, 'lps'),
	(497469, 129, '2014-01-15 01:15:35.000000', 'consum', 0.0223, 'lps'),
	(497470, 129, '2014-01-15 01:15:36.000000', 'consum', 0.0217, 'lps'),
	(497471, 129, '2014-01-15 01:15:37.000000', 'consum', 0.0219, 'lps'),
	(497472, 129, '2014-01-15 01:15:38.000000', 'consum', 0.0221, 'lps'),
	(497473, 129, '2014-01-15 01:15:39.000000', 'consum', 0.0222, 'lps'),
	(497474, 129, '2014-01-15 01:15:40.000000', 'consum', 0.0213, 'lps'),
	(497475, 129, '2014-01-15 01:15:41.000000', 'consum', 0.0216, 'lps'),
	(497476, 129, '2014-01-15 01:15:42.000000', 'consum', 0.0219, 'lps'),
	(497477, 129, '2014-01-15 01:15:43.000000', 'consum', 0.0222, 'lps'),
	(497478, 129, '2014-01-15 01:15:44.000000', 'consum', 0.0218, 'lps'),
	(497479, 129, '2014-01-15 01:15:45.000000', 'consum', 0.0212, 'lps'),
	(497480, 129, '2014-01-15 01:15:46.000000', 'consum', 0.0213, 'lps'),
	(497481, 129, '2014-01-15 01:15:47.000000', 'consum', 0.0218, 'lps'),
	(497482, 129, '2014-01-15 01:15:48.000000', 'consum', 0.0213, 'lps'),
	(497483, 129, '2014-01-15 01:15:49.000000', 'consum', 0.0214, 'lps'),
	(497484, 129, '2014-01-15 01:15:50.000000', 'consum', 0.0211, 'lps'),
	(497485, 129, '2014-01-15 01:15:51.000000', 'consum', 0.0216, 'lps'),
	(497486, 129, '2014-01-15 01:15:52.000000', 'consum', 0.0223, 'lps'),
	(497487, 129, '2014-01-15 01:15:53.000000', 'consum', 0.0215, 'lps'),
	(497488, 129, '2014-01-15 01:15:54.000000', 'consum', 0.0212, 'lps'),
	(497489, 129, '2014-01-15 01:15:55.000000', 'consum', 0.0218, 'lps'),
	(497490, 129, '2014-01-15 01:15:56.000000', 'consum', 0.0219, 'lps'),
	(497491, 129, '2014-01-15 01:15:57.000000', 'consum', 0.0217, 'lps'),
	(497492, 129, '2014-01-15 01:15:58.000000', 'consum', 0.0218, 'lps'),
	(497493, 129, '2014-01-15 01:15:59.000000', 'consum', 0.0216, 'lps'),
	(497494, 129, '2014-01-15 01:16:00.000000', 'consum', 0.0218, 'lps'),
	(497495, 129, '2014-01-15 01:16:01.000000', 'consum', 0.0217, 'lps'),
	(497496, 129, '2014-01-15 01:16:02.000000', 'consum', 0.0220, 'lps'),
	(497497, 129, '2014-01-15 01:16:03.000000', 'consum', 0.0214, 'lps'),
	(497498, 129, '2014-01-15 01:16:04.000000', 'consum', 0.0212, 'lps'),
	(497499, 129, '2014-01-15 01:16:05.000000', 'consum', 0.0223, 'lps'),
	(497500, 129, '2014-01-15 01:16:06.000000', 'consum', 0.0213, 'lps'),
	(497501, 129, '2014-01-15 01:16:07.000000', 'consum', 0.0217, 'lps'),
	(497502, 129, '2014-01-15 01:16:08.000000', 'consum', 0.0221, 'lps'),
	(497503, 129, '2014-01-15 01:16:09.000000', 'consum', 0.0216, 'lps'),
	(497504, 129, '2014-01-15 01:16:10.000000', 'consum', 0.0221, 'lps'),
	(497505, 129, '2014-01-15 01:16:11.000000', 'consum', 0.0221, 'lps'),
	(497506, 129, '2014-01-15 01:16:12.000000', 'consum', 0.0220, 'lps'),
	(497507, 129, '2014-01-15 01:16:13.000000', 'consum', 0.0211, 'lps'),
	(497508, 129, '2014-01-15 01:16:14.000000', 'consum', 0.0213, 'lps'),
	(497509, 129, '2014-01-15 01:16:15.000000', 'consum', 0.0223, 'lps'),
	(497510, 129, '2014-01-15 01:16:16.000000', 'consum', 0.0223, 'lps'),
	(497511, 129, '2014-01-15 01:16:17.000000', 'consum', 0.0211, 'lps'),
	(497512, 129, '2014-01-15 01:16:18.000000', 'consum', 0.0218, 'lps'),
	(497513, 129, '2014-01-15 01:16:19.000000', 'consum', 0.0219, 'lps'),
	(497514, 129, '2014-01-15 01:16:20.000000', 'consum', 0.0219, 'lps'),
	(497515, 129, '2014-01-15 01:16:21.000000', 'consum', 0.0215, 'lps'),
	(497516, 129, '2014-01-15 01:16:22.000000', 'consum', 0.0221, 'lps'),
	(497517, 129, '2014-01-15 01:16:23.000000', 'consum', 0.0222, 'lps'),
	(497518, 129, '2014-01-15 01:16:24.000000', 'consum', 0.0210, 'lps'),
	(497519, 129, '2014-01-15 01:16:25.000000', 'consum', 0.0216, 'lps'),
	(497520, 129, '2014-01-15 01:16:26.000000', 'consum', 0.0211, 'lps'),
	(497521, 129, '2014-01-15 01:16:27.000000', 'consum', 0.0213, 'lps'),
	(497522, 129, '2014-01-15 01:16:28.000000', 'consum', 0.0221, 'lps'),
	(497523, 129, '2014-01-15 01:16:29.000000', 'consum', 0.0215, 'lps'),
	(497524, 129, '2014-01-15 01:16:30.000000', 'consum', 0.0219, 'lps'),
	(497525, 129, '2014-01-15 01:16:31.000000', 'consum', 0.0210, 'lps'),
	(497526, 129, '2014-01-15 01:16:32.000000', 'consum', 0.0212, 'lps'),
	(497527, 129, '2014-01-15 01:16:33.000000', 'consum', 0.0221, 'lps'),
	(497528, 129, '2014-01-15 01:16:34.000000', 'consum', 0.0218, 'lps'),
	(497529, 129, '2014-01-15 01:16:35.000000', 'consum', 0.0218, 'lps'),
	(497530, 129, '2014-01-15 01:16:36.000000', 'consum', 0.0211, 'lps'),
	(497531, 129, '2014-01-15 01:16:37.000000', 'consum', 0.0222, 'lps'),
	(497532, 129, '2014-01-15 01:16:38.000000', 'consum', 0.0210, 'lps'),
	(497533, 129, '2014-01-15 01:16:39.000000', 'consum', 0.0218, 'lps'),
	(497534, 129, '2014-01-15 01:16:40.000000', 'consum', 0.0221, 'lps'),
	(497535, 129, '2014-01-15 01:16:41.000000', 'consum', 0.0215, 'lps'),
	(497536, 129, '2014-01-15 01:16:42.000000', 'consum', 0.0214, 'lps'),
	(497537, 129, '2014-01-15 01:16:43.000000', 'consum', 0.0215, 'lps'),
	(497538, 129, '2014-01-15 01:16:44.000000', 'consum', 0.0210, 'lps'),
	(497539, 129, '2014-01-15 01:16:45.000000', 'consum', 0.0211, 'lps'),
	(497540, 129, '2014-01-15 01:16:46.000000', 'consum', 0.0215, 'lps'),
	(497541, 129, '2014-01-15 01:16:47.000000', 'consum', 0.0219, 'lps'),
	(497542, 129, '2014-01-15 01:16:48.000000', 'consum', 0.0212, 'lps'),
	(497543, 129, '2014-01-15 01:16:49.000000', 'consum', 0.0222, 'lps'),
	(497544, 129, '2014-01-15 01:16:50.000000', 'consum', 0.0223, 'lps'),
	(497545, 129, '2014-01-15 01:16:51.000000', 'consum', 0.0211, 'lps'),
	(497546, 129, '2014-01-15 01:16:52.000000', 'consum', 0.0218, 'lps'),
	(497547, 129, '2014-01-15 01:16:53.000000', 'consum', 0.0221, 'lps'),
	(497548, 129, '2014-01-15 01:16:54.000000', 'consum', 0.0213, 'lps'),
	(497549, 129, '2014-01-15 01:16:55.000000', 'consum', 0.0220, 'lps'),
	(497550, 129, '2014-01-15 01:16:56.000000', 'consum', 0.0210, 'lps'),
	(497551, 129, '2014-01-15 01:16:57.000000', 'consum', 0.0210, 'lps'),
	(497552, 129, '2014-01-15 01:16:58.000000', 'consum', 0.0210, 'lps'),
	(497553, 129, '2014-01-15 01:16:59.000000', 'consum', 0.0211, 'lps'),
	(497554, 129, '2014-01-15 01:17:00.000000', 'consum', 0.0215, 'lps'),
	(497555, 129, '2014-01-15 01:17:01.000000', 'consum', 0.0221, 'lps'),
	(497556, 129, '2014-01-15 01:17:02.000000', 'consum', 0.0219, 'lps'),
	(497557, 129, '2014-01-15 01:17:03.000000', 'consum', 0.0222, 'lps'),
	(497558, 129, '2014-01-15 01:17:04.000000', 'consum', 0.0216, 'lps'),
	(497559, 129, '2014-01-15 01:17:05.000000', 'consum', 0.0220, 'lps'),
	(497560, 129, '2014-01-15 01:17:06.000000', 'consum', 0.0216, 'lps'),
	(497561, 129, '2014-01-15 01:17:07.000000', 'consum', 0.0221, 'lps'),
	(497562, 129, '2014-01-15 01:17:08.000000', 'consum', 0.0221, 'lps'),
	(497563, 129, '2014-01-15 01:17:09.000000', 'consum', 0.0219, 'lps'),
	(497564, 129, '2014-01-15 01:17:10.000000', 'consum', 0.0210, 'lps'),
	(497565, 129, '2014-01-15 01:17:11.000000', 'consum', 0.0223, 'lps'),
	(497566, 129, '2014-01-15 01:17:12.000000', 'consum', 0.0220, 'lps'),
	(497567, 129, '2014-01-15 01:17:13.000000', 'consum', 0.0221, 'lps'),
	(497568, 129, '2014-01-15 01:17:14.000000', 'consum', 0.0210, 'lps'),
	(497569, 129, '2014-01-15 01:17:15.000000', 'consum', 0.0218, 'lps'),
	(497570, 129, '2014-01-15 01:17:16.000000', 'consum', 0.0222, 'lps'),
	(497571, 129, '2014-01-15 01:17:17.000000', 'consum', 0.0221, 'lps'),
	(497572, 129, '2014-01-15 01:17:18.000000', 'consum', 0.0213, 'lps'),
	(497573, 129, '2014-01-15 01:17:19.000000', 'consum', 0.0222, 'lps'),
	(497574, 129, '2014-01-15 01:17:20.000000', 'consum', 0.0218, 'lps'),
	(497575, 129, '2014-01-15 01:17:21.000000', 'consum', 0.0217, 'lps'),
	(497576, 129, '2014-01-15 01:17:22.000000', 'consum', 0.0221, 'lps'),
	(497577, 129, '2014-01-15 01:17:23.000000', 'consum', 0.0214, 'lps'),
	(497578, 129, '2014-01-15 01:17:24.000000', 'consum', 0.0214, 'lps'),
	(497579, 129, '2014-01-15 01:17:25.000000', 'consum', 0.0218, 'lps'),
	(497580, 129, '2014-01-15 01:17:26.000000', 'consum', 0.0223, 'lps'),
	(497581, 129, '2014-01-15 01:17:27.000000', 'consum', 0.0223, 'lps'),
	(497582, 129, '2014-01-15 01:17:28.000000', 'consum', 0.0222, 'lps'),
	(497583, 129, '2014-01-15 01:17:29.000000', 'consum', 0.0219, 'lps'),
	(497584, 129, '2014-01-15 01:17:30.000000', 'consum', 0.0219, 'lps'),
	(497585, 129, '2014-01-15 01:17:31.000000', 'consum', 0.0215, 'lps'),
	(497586, 129, '2014-01-15 01:17:32.000000', 'consum', 0.0220, 'lps'),
	(497587, 129, '2014-01-15 01:17:33.000000', 'consum', 0.0221, 'lps'),
	(497588, 129, '2014-01-15 01:17:34.000000', 'consum', 0.0219, 'lps'),
	(497589, 129, '2014-01-15 01:17:35.000000', 'consum', 0.0210, 'lps'),
	(497590, 129, '2014-01-15 01:17:36.000000', 'consum', 0.0210, 'lps'),
	(497591, 129, '2014-01-15 01:17:37.000000', 'consum', 0.0211, 'lps'),
	(497592, 129, '2014-01-15 01:17:38.000000', 'consum', 0.0214, 'lps'),
	(497593, 129, '2014-01-15 01:17:39.000000', 'consum', 0.0214, 'lps'),
	(497594, 129, '2014-01-15 01:17:40.000000', 'consum', 0.0218, 'lps'),
	(497595, 129, '2014-01-15 01:17:41.000000', 'consum', 0.0212, 'lps'),
	(497596, 129, '2014-01-15 01:17:42.000000', 'consum', 0.0212, 'lps'),
	(497597, 129, '2014-01-15 01:17:43.000000', 'consum', 0.0212, 'lps'),
	(497598, 129, '2014-01-15 01:17:44.000000', 'consum', 0.0213, 'lps'),
	(497599, 129, '2014-01-15 01:17:45.000000', 'consum', 0.0222, 'lps'),
	(497600, 129, '2014-01-15 01:17:46.000000', 'consum', 0.0218, 'lps'),
	(497601, 129, '2014-01-15 01:17:47.000000', 'consum', 0.0216, 'lps'),
	(497602, 129, '2014-01-15 01:17:48.000000', 'consum', 0.0215, 'lps'),
	(497603, 129, '2014-01-15 01:17:49.000000', 'consum', 0.0216, 'lps'),
	(497604, 129, '2014-01-15 01:17:50.000000', 'consum', 0.0213, 'lps'),
	(497605, 129, '2014-01-15 01:17:51.000000', 'consum', 0.0221, 'lps'),
	(497606, 129, '2014-01-15 01:17:52.000000', 'consum', 0.0213, 'lps'),
	(497607, 129, '2014-01-15 01:17:53.000000', 'consum', 0.0222, 'lps'),
	(497608, 129, '2014-01-15 01:17:54.000000', 'consum', 0.0221, 'lps'),
	(497609, 129, '2014-01-15 01:17:55.000000', 'consum', 0.0215, 'lps'),
	(497610, 129, '2014-01-15 01:17:56.000000', 'consum', 0.0216, 'lps'),
	(497611, 129, '2014-01-15 01:17:57.000000', 'consum', 0.0214, 'lps'),
	(497612, 129, '2014-01-15 01:17:58.000000', 'consum', 0.0223, 'lps'),
	(497613, 129, '2014-01-15 01:17:59.000000', 'consum', 0.0221, 'lps'),
	(497614, 129, '2014-01-15 01:18:00.000000', 'consum', 0.0215, 'lps'),
	(497615, 129, '2014-01-15 01:18:01.000000', 'consum', 0.0214, 'lps'),
	(497616, 129, '2014-01-15 01:18:02.000000', 'consum', 0.0217, 'lps'),
	(497617, 129, '2014-01-15 01:18:03.000000', 'consum', 0.0219, 'lps'),
	(497618, 129, '2014-01-15 01:18:04.000000', 'consum', 0.0222, 'lps'),
	(497619, 129, '2014-01-15 01:18:05.000000', 'consum', 0.0214, 'lps'),
	(497620, 129, '2014-01-15 01:18:06.000000', 'consum', 0.0211, 'lps'),
	(497621, 129, '2014-01-15 01:18:07.000000', 'consum', 0.0216, 'lps'),
	(497622, 129, '2014-01-15 01:18:08.000000', 'consum', 0.0210, 'lps'),
	(497623, 129, '2014-01-15 01:18:09.000000', 'consum', 0.0222, 'lps'),
	(497624, 129, '2014-01-15 01:18:10.000000', 'consum', 0.0214, 'lps'),
	(497625, 129, '2014-01-15 01:18:11.000000', 'consum', 0.0221, 'lps'),
	(497626, 129, '2014-01-15 01:18:12.000000', 'consum', 0.0211, 'lps'),
	(497627, 129, '2014-01-15 01:18:13.000000', 'consum', 0.0223, 'lps'),
	(497628, 129, '2014-01-15 01:18:14.000000', 'consum', 0.0220, 'lps'),
	(497629, 129, '2014-01-15 01:18:15.000000', 'consum', 0.0220, 'lps'),
	(497630, 129, '2014-01-15 01:18:16.000000', 'consum', 0.0218, 'lps'),
	(497631, 129, '2014-01-15 01:18:17.000000', 'consum', 0.0219, 'lps'),
	(497632, 129, '2014-01-15 01:18:18.000000', 'consum', 0.0217, 'lps'),
	(497633, 129, '2014-01-15 01:18:19.000000', 'consum', 0.0221, 'lps'),
	(497634, 129, '2014-01-15 01:18:20.000000', 'consum', 0.0216, 'lps'),
	(497635, 129, '2014-01-15 01:18:21.000000', 'consum', 0.0222, 'lps'),
	(497636, 129, '2014-01-15 01:18:22.000000', 'consum', 0.0222, 'lps'),
	(497637, 129, '2014-01-15 01:18:23.000000', 'consum', 0.0223, 'lps'),
	(497638, 129, '2014-01-15 01:18:24.000000', 'consum', 0.0213, 'lps'),
	(497639, 129, '2014-01-15 01:18:25.000000', 'consum', 0.0211, 'lps'),
	(497640, 129, '2014-01-15 01:18:26.000000', 'consum', 0.0222, 'lps'),
	(497641, 129, '2014-01-15 01:18:27.000000', 'consum', 0.0210, 'lps'),
	(497642, 129, '2014-01-15 01:18:28.000000', 'consum', 0.0219, 'lps'),
	(497643, 129, '2014-01-15 01:18:29.000000', 'consum', 0.0211, 'lps'),
	(497644, 129, '2014-01-15 01:18:30.000000', 'consum', 0.0216, 'lps'),
	(497645, 129, '2014-01-15 01:18:31.000000', 'consum', 0.0212, 'lps'),
	(497646, 129, '2014-01-15 01:18:32.000000', 'consum', 0.0216, 'lps'),
	(497647, 129, '2014-01-15 01:18:33.000000', 'consum', 0.0220, 'lps'),
	(497648, 129, '2014-01-15 01:18:34.000000', 'consum', 0.0217, 'lps'),
	(497649, 129, '2014-01-15 01:18:35.000000', 'consum', 0.0213, 'lps'),
	(497650, 129, '2014-01-15 01:18:36.000000', 'consum', 0.0218, 'lps'),
	(497651, 129, '2014-01-15 01:18:37.000000', 'consum', 0.0214, 'lps'),
	(497652, 129, '2014-01-15 01:18:38.000000', 'consum', 0.0219, 'lps'),
	(497653, 129, '2014-01-15 01:18:39.000000', 'consum', 0.0215, 'lps'),
	(497654, 129, '2014-01-15 01:18:40.000000', 'consum', 0.0210, 'lps'),
	(497655, 129, '2014-01-15 01:18:41.000000', 'consum', 0.0211, 'lps'),
	(497656, 129, '2014-01-15 01:18:42.000000', 'consum', 0.0213, 'lps'),
	(497657, 129, '2014-01-15 01:18:43.000000', 'consum', 0.0223, 'lps'),
	(497658, 129, '2014-01-15 01:18:44.000000', 'consum', 0.0213, 'lps'),
	(497659, 129, '2014-01-15 01:18:45.000000', 'consum', 0.0213, 'lps'),
	(497660, 129, '2014-01-15 01:18:46.000000', 'consum', 0.0215, 'lps'),
	(497661, 129, '2014-01-15 01:18:47.000000', 'consum', 0.0213, 'lps'),
	(497662, 129, '2014-01-15 01:18:48.000000', 'consum', 0.0210, 'lps'),
	(497663, 129, '2014-01-15 01:18:49.000000', 'consum', 0.0215, 'lps'),
	(497664, 129, '2014-01-15 01:18:50.000000', 'consum', 0.0223, 'lps'),
	(497665, 129, '2014-01-15 01:18:51.000000', 'consum', 0.0219, 'lps'),
	(497666, 129, '2014-01-15 01:18:52.000000', 'consum', 0.0216, 'lps'),
	(497667, 129, '2014-01-15 01:18:53.000000', 'consum', 0.0213, 'lps'),
	(497668, 129, '2014-01-15 01:18:54.000000', 'consum', 0.0221, 'lps'),
	(497669, 129, '2014-01-15 01:18:55.000000', 'consum', 0.0216, 'lps'),
	(497670, 129, '2014-01-15 01:18:56.000000', 'consum', 0.0220, 'lps'),
	(497671, 129, '2014-01-15 01:18:57.000000', 'consum', 0.0214, 'lps'),
	(497672, 129, '2014-01-15 01:18:58.000000', 'consum', 0.0214, 'lps'),
	(497673, 129, '2014-01-15 01:18:59.000000', 'consum', 0.0221, 'lps'),
	(497674, 129, '2014-01-15 01:19:00.000000', 'consum', 0.0210, 'lps'),
	(497675, 129, '2014-01-15 01:19:01.000000', 'consum', 0.0220, 'lps'),
	(497676, 129, '2014-01-15 01:19:02.000000', 'consum', 0.0220, 'lps'),
	(497677, 129, '2014-01-15 01:19:03.000000', 'consum', 0.0215, 'lps'),
	(497678, 129, '2014-01-15 01:19:04.000000', 'consum', 0.0219, 'lps'),
	(497679, 129, '2014-01-15 01:19:05.000000', 'consum', 0.0211, 'lps'),
	(497680, 129, '2014-01-15 01:19:06.000000', 'consum', 0.0217, 'lps'),
	(497681, 129, '2014-01-15 01:19:07.000000', 'consum', 0.0217, 'lps'),
	(497682, 129, '2014-01-15 01:19:08.000000', 'consum', 0.0223, 'lps'),
	(497683, 129, '2014-01-15 01:19:09.000000', 'consum', 0.0211, 'lps'),
	(497684, 129, '2014-01-15 01:19:10.000000', 'consum', 0.0221, 'lps'),
	(497685, 129, '2014-01-15 01:19:11.000000', 'consum', 0.0220, 'lps'),
	(497686, 129, '2014-01-15 01:19:12.000000', 'consum', 0.0215, 'lps'),
	(497687, 129, '2014-01-15 01:19:13.000000', 'consum', 0.0219, 'lps'),
	(497688, 129, '2014-01-15 01:19:14.000000', 'consum', 0.0211, 'lps'),
	(497689, 129, '2014-01-15 01:19:15.000000', 'consum', 0.0216, 'lps'),
	(497690, 129, '2014-01-15 01:19:16.000000', 'consum', 0.0210, 'lps'),
	(497691, 129, '2014-01-15 01:19:17.000000', 'consum', 0.0222, 'lps'),
	(497692, 129, '2014-01-15 01:19:18.000000', 'consum', 0.0212, 'lps'),
	(497693, 129, '2014-01-15 01:19:19.000000', 'consum', 0.0212, 'lps'),
	(497694, 129, '2014-01-15 01:19:20.000000', 'consum', 0.0214, 'lps'),
	(497695, 129, '2014-01-15 01:19:21.000000', 'consum', 0.0213, 'lps'),
	(497696, 129, '2014-01-15 01:19:22.000000', 'consum', 0.0210, 'lps'),
	(497697, 129, '2014-01-15 01:19:23.000000', 'consum', 0.0219, 'lps'),
	(497698, 129, '2014-01-15 01:19:24.000000', 'consum', 0.0214, 'lps'),
	(497699, 129, '2014-01-15 01:19:25.000000', 'consum', 0.0216, 'lps'),
	(497700, 129, '2014-01-15 01:19:26.000000', 'consum', 0.0213, 'lps'),
	(497701, 129, '2014-01-15 01:19:27.000000', 'consum', 0.0211, 'lps'),
	(497702, 129, '2014-01-15 01:19:28.000000', 'consum', 0.0218, 'lps'),
	(497703, 129, '2014-01-15 01:19:29.000000', 'consum', 0.0219, 'lps'),
	(497704, 129, '2014-01-15 01:19:30.000000', 'consum', 0.0218, 'lps'),
	(497705, 129, '2014-01-15 01:19:31.000000', 'consum', 0.0211, 'lps'),
	(497706, 129, '2014-01-15 01:19:32.000000', 'consum', 0.0219, 'lps'),
	(497707, 129, '2014-01-15 01:19:33.000000', 'consum', 0.0211, 'lps'),
	(497708, 129, '2014-01-15 01:19:34.000000', 'consum', 0.0216, 'lps'),
	(497709, 129, '2014-01-15 01:19:35.000000', 'consum', 0.0210, 'lps'),
	(497710, 129, '2014-01-15 01:19:36.000000', 'consum', 0.0220, 'lps'),
	(497711, 129, '2014-01-15 01:19:37.000000', 'consum', 0.0218, 'lps'),
	(497712, 129, '2014-01-15 01:19:38.000000', 'consum', 0.0220, 'lps'),
	(497713, 129, '2014-01-15 01:19:39.000000', 'consum', 0.0223, 'lps'),
	(497714, 129, '2014-01-15 01:19:40.000000', 'consum', 0.0219, 'lps'),
	(497715, 129, '2014-01-15 01:19:41.000000', 'consum', 0.0214, 'lps'),
	(497716, 129, '2014-01-15 01:19:42.000000', 'consum', 0.0218, 'lps'),
	(497717, 129, '2014-01-15 01:19:43.000000', 'consum', 0.0213, 'lps'),
	(497718, 129, '2014-01-15 01:19:44.000000', 'consum', 0.0213, 'lps'),
	(497719, 129, '2014-01-15 01:19:45.000000', 'consum', 0.0216, 'lps'),
	(497720, 129, '2014-01-15 01:19:46.000000', 'consum', 0.0218, 'lps'),
	(497721, 129, '2014-01-15 01:19:47.000000', 'consum', 0.0219, 'lps'),
	(497722, 129, '2014-01-15 01:19:48.000000', 'consum', 0.0218, 'lps'),
	(497723, 129, '2014-01-15 01:19:49.000000', 'consum', 0.0211, 'lps'),
	(497724, 129, '2014-01-15 01:19:50.000000', 'consum', 0.0219, 'lps'),
	(497725, 129, '2014-01-15 01:19:51.000000', 'consum', 0.0222, 'lps'),
	(497726, 129, '2014-01-15 01:19:52.000000', 'consum', 0.0218, 'lps'),
	(497727, 129, '2014-01-15 01:19:53.000000', 'consum', 0.0212, 'lps'),
	(497728, 129, '2014-01-15 01:19:54.000000', 'consum', 0.0214, 'lps'),
	(497729, 129, '2014-01-15 01:19:55.000000', 'consum', 0.0222, 'lps'),
	(497730, 129, '2014-01-15 01:19:56.000000', 'consum', 0.0217, 'lps'),
	(497731, 129, '2014-01-15 01:19:57.000000', 'consum', 0.0210, 'lps'),
	(497732, 129, '2014-01-15 01:19:58.000000', 'consum', 0.0219, 'lps'),
	(497733, 129, '2014-01-15 01:19:59.000000', 'consum', 0.0212, 'lps'),
	(497734, 129, '2014-01-15 01:20:00.000000', 'consum', 0.0221, 'lps'),
	(497735, 129, '2014-01-15 01:20:01.000000', 'consum', 0.0216, 'lps'),
	(497736, 129, '2014-01-15 01:20:02.000000', 'consum', 0.0223, 'lps'),
	(497737, 129, '2014-01-15 01:20:03.000000', 'consum', 0.0216, 'lps'),
	(497738, 129, '2014-01-15 01:20:04.000000', 'consum', 0.0215, 'lps'),
	(497739, 129, '2014-01-15 01:20:05.000000', 'consum', 0.0219, 'lps'),
	(497740, 129, '2014-01-15 01:20:06.000000', 'consum', 0.0210, 'lps'),
	(497741, 129, '2014-01-15 01:20:07.000000', 'consum', 0.0211, 'lps'),
	(497742, 129, '2014-01-15 01:20:08.000000', 'consum', 0.0214, 'lps'),
	(497743, 129, '2014-01-15 01:20:09.000000', 'consum', 0.0217, 'lps'),
	(497744, 129, '2014-01-15 01:20:10.000000', 'consum', 0.0219, 'lps'),
	(497745, 129, '2014-01-15 01:20:11.000000', 'consum', 0.0221, 'lps'),
	(497746, 129, '2014-01-15 01:20:12.000000', 'consum', 0.0211, 'lps'),
	(497747, 129, '2014-01-15 01:20:13.000000', 'consum', 0.0211, 'lps'),
	(497748, 129, '2014-01-15 01:20:14.000000', 'consum', 0.0214, 'lps'),
	(497749, 129, '2014-01-15 01:20:15.000000', 'consum', 0.0210, 'lps'),
	(497750, 129, '2014-01-15 01:20:16.000000', 'consum', 0.0215, 'lps'),
	(497751, 129, '2014-01-15 01:20:17.000000', 'consum', 0.0219, 'lps'),
	(497752, 129, '2014-01-15 01:20:18.000000', 'consum', 0.0212, 'lps'),
	(497753, 129, '2014-01-15 01:20:19.000000', 'consum', 0.0210, 'lps'),
	(497754, 129, '2014-01-15 01:20:20.000000', 'consum', 0.0216, 'lps'),
	(497755, 129, '2014-01-15 01:20:21.000000', 'consum', 0.0215, 'lps'),
	(497756, 129, '2014-01-15 01:20:22.000000', 'consum', 0.0218, 'lps'),
	(497757, 129, '2014-01-15 01:20:23.000000', 'consum', 0.0221, 'lps'),
	(497758, 129, '2014-01-15 01:20:24.000000', 'consum', 0.0212, 'lps'),
	(497759, 129, '2014-01-15 01:20:25.000000', 'consum', 0.0217, 'lps'),
	(497760, 129, '2014-01-15 01:20:26.000000', 'consum', 0.0211, 'lps'),
	(497761, 129, '2014-01-15 01:20:27.000000', 'consum', 0.0221, 'lps'),
	(497762, 129, '2014-01-15 01:20:28.000000', 'consum', 0.0220, 'lps'),
	(497763, 129, '2014-01-15 01:20:29.000000', 'consum', 0.0214, 'lps'),
	(497764, 129, '2014-01-15 01:20:30.000000', 'consum', 0.0217, 'lps'),
	(497765, 129, '2014-01-15 01:20:31.000000', 'consum', 0.0217, 'lps'),
	(497766, 129, '2014-01-15 01:20:32.000000', 'consum', 0.0213, 'lps'),
	(497767, 129, '2014-01-15 01:20:33.000000', 'consum', 0.0218, 'lps'),
	(497768, 129, '2014-01-15 01:20:34.000000', 'consum', 0.0214, 'lps'),
	(497769, 129, '2014-01-15 01:20:35.000000', 'consum', 0.0221, 'lps'),
	(497770, 129, '2014-01-15 01:20:36.000000', 'consum', 0.0212, 'lps'),
	(497771, 129, '2014-01-15 01:20:37.000000', 'consum', 0.0215, 'lps'),
	(497772, 129, '2014-01-15 01:20:38.000000', 'consum', 0.0215, 'lps'),
	(497773, 129, '2014-01-15 01:20:39.000000', 'consum', 0.0220, 'lps'),
	(497774, 129, '2014-01-15 01:20:40.000000', 'consum', 0.0220, 'lps'),
	(497775, 129, '2014-01-15 01:20:41.000000', 'consum', 0.0214, 'lps'),
	(497776, 129, '2014-01-15 01:20:42.000000', 'consum', 0.0217, 'lps'),
	(497777, 129, '2014-01-15 01:20:43.000000', 'consum', 0.0219, 'lps'),
	(497778, 129, '2014-01-15 01:20:44.000000', 'consum', 0.0220, 'lps'),
	(497779, 129, '2014-01-15 01:20:45.000000', 'consum', 0.0220, 'lps'),
	(497780, 129, '2014-01-15 01:20:46.000000', 'consum', 0.0217, 'lps'),
	(497781, 129, '2014-01-15 01:20:47.000000', 'consum', 0.0214, 'lps'),
	(497782, 129, '2014-01-15 01:20:48.000000', 'consum', 0.0211, 'lps'),
	(497783, 129, '2014-01-15 01:20:49.000000', 'consum', 0.0216, 'lps'),
	(497784, 129, '2014-01-15 01:20:50.000000', 'consum', 0.0212, 'lps'),
	(497785, 129, '2014-01-15 01:20:51.000000', 'consum', 0.0216, 'lps'),
	(497786, 129, '2014-01-15 01:20:52.000000', 'consum', 0.0221, 'lps'),
	(497787, 129, '2014-01-15 01:20:53.000000', 'consum', 0.0218, 'lps'),
	(497788, 129, '2014-01-15 01:20:54.000000', 'consum', 0.0220, 'lps'),
	(497789, 129, '2014-01-15 01:20:55.000000', 'consum', 0.0221, 'lps'),
	(497790, 129, '2014-01-15 01:20:56.000000', 'consum', 0.0222, 'lps'),
	(497791, 129, '2014-01-15 01:20:57.000000', 'consum', 0.0223, 'lps'),
	(497792, 129, '2014-01-15 01:20:58.000000', 'consum', 0.0212, 'lps'),
	(497793, 129, '2014-01-15 01:20:59.000000', 'consum', 0.0223, 'lps'),
	(497794, 129, '2014-01-15 01:21:00.000000', 'consum', 0.0212, 'lps'),
	(497795, 129, '2014-01-15 01:21:01.000000', 'consum', 0.0210, 'lps'),
	(497796, 129, '2014-01-15 01:21:02.000000', 'consum', 0.0220, 'lps'),
	(497797, 129, '2014-01-15 01:21:03.000000', 'consum', 0.0218, 'lps'),
	(497798, 129, '2014-01-15 01:21:04.000000', 'consum', 0.0222, 'lps'),
	(497799, 129, '2014-01-15 01:21:05.000000', 'consum', 0.0218, 'lps'),
	(497800, 129, '2014-01-15 01:21:06.000000', 'consum', 0.0214, 'lps'),
	(497801, 129, '2014-01-15 01:21:07.000000', 'consum', 0.0220, 'lps'),
	(497802, 129, '2014-01-15 01:21:08.000000', 'consum', 0.0222, 'lps'),
	(497803, 129, '2014-01-15 01:21:09.000000', 'consum', 0.0213, 'lps'),
	(497804, 129, '2014-01-15 01:21:10.000000', 'consum', 0.0217, 'lps'),
	(497805, 129, '2014-01-15 01:21:11.000000', 'consum', 0.0210, 'lps'),
	(497806, 129, '2014-01-15 01:21:12.000000', 'consum', 0.0217, 'lps'),
	(497807, 129, '2014-01-15 01:21:13.000000', 'consum', 0.0217, 'lps'),
	(497808, 129, '2014-01-15 01:21:14.000000', 'consum', 0.0212, 'lps'),
	(497809, 129, '2014-01-15 01:21:15.000000', 'consum', 0.0213, 'lps'),
	(497810, 129, '2014-01-15 01:21:16.000000', 'consum', 0.0220, 'lps'),
	(497811, 129, '2014-01-15 01:21:17.000000', 'consum', 0.0222, 'lps'),
	(497812, 129, '2014-01-15 01:21:18.000000', 'consum', 0.0211, 'lps'),
	(497813, 129, '2014-01-15 01:21:19.000000', 'consum', 0.0210, 'lps'),
	(497814, 129, '2014-01-15 01:21:20.000000', 'consum', 0.0220, 'lps'),
	(497815, 129, '2014-01-15 01:21:21.000000', 'consum', 0.0221, 'lps'),
	(497816, 129, '2014-01-15 01:21:22.000000', 'consum', 0.0220, 'lps'),
	(497817, 129, '2014-01-15 01:21:23.000000', 'consum', 0.0212, 'lps'),
	(497818, 129, '2014-01-15 01:21:24.000000', 'consum', 0.0219, 'lps'),
	(497819, 129, '2014-01-15 01:21:25.000000', 'consum', 0.0210, 'lps'),
	(497820, 129, '2014-01-15 01:21:26.000000', 'consum', 0.0223, 'lps'),
	(497821, 129, '2014-01-15 01:21:27.000000', 'consum', 0.0221, 'lps'),
	(497822, 129, '2014-01-15 01:21:28.000000', 'consum', 0.0213, 'lps'),
	(497823, 129, '2014-01-15 01:21:29.000000', 'consum', 0.0221, 'lps'),
	(497824, 129, '2014-01-15 01:21:30.000000', 'consum', 0.0216, 'lps'),
	(497825, 129, '2014-01-15 01:21:31.000000', 'consum', 0.0218, 'lps'),
	(497826, 129, '2014-01-15 01:21:32.000000', 'consum', 0.0220, 'lps'),
	(497827, 129, '2014-01-15 01:21:33.000000', 'consum', 0.0221, 'lps'),
	(497828, 129, '2014-01-15 01:21:34.000000', 'consum', 0.0210, 'lps'),
	(497829, 129, '2014-01-15 01:21:35.000000', 'consum', 0.0217, 'lps'),
	(497830, 129, '2014-01-15 01:21:36.000000', 'consum', 0.0217, 'lps'),
	(497831, 129, '2014-01-15 01:21:37.000000', 'consum', 0.0212, 'lps'),
	(497832, 129, '2014-01-15 01:21:38.000000', 'consum', 0.0213, 'lps'),
	(497833, 129, '2014-01-15 01:21:39.000000', 'consum', 0.0219, 'lps'),
	(497834, 129, '2014-01-15 01:21:40.000000', 'consum', 0.0219, 'lps'),
	(497835, 129, '2014-01-15 01:21:41.000000', 'consum', 0.0215, 'lps'),
	(497836, 129, '2014-01-15 01:21:42.000000', 'consum', 0.0222, 'lps'),
	(497837, 129, '2014-01-15 01:21:43.000000', 'consum', 0.0216, 'lps'),
	(497838, 129, '2014-01-15 01:21:44.000000', 'consum', 0.0216, 'lps'),
	(497839, 129, '2014-01-15 01:21:45.000000', 'consum', 0.0221, 'lps'),
	(497840, 129, '2014-01-15 01:21:46.000000', 'consum', 0.0222, 'lps'),
	(497841, 129, '2014-01-15 01:21:47.000000', 'consum', 0.0210, 'lps'),
	(497842, 129, '2014-01-15 01:21:48.000000', 'consum', 0.0217, 'lps'),
	(497843, 129, '2014-01-15 01:21:49.000000', 'consum', 0.0216, 'lps'),
	(497844, 129, '2014-01-15 01:21:50.000000', 'consum', 0.0218, 'lps'),
	(497845, 129, '2014-01-15 01:21:51.000000', 'consum', 0.0219, 'lps'),
	(497846, 129, '2014-01-15 01:21:52.000000', 'consum', 0.0219, 'lps'),
	(497847, 129, '2014-01-15 01:21:53.000000', 'consum', 0.0214, 'lps'),
	(497848, 129, '2014-01-15 01:21:54.000000', 'consum', 0.0217, 'lps'),
	(497849, 129, '2014-01-15 01:21:55.000000', 'consum', 0.0218, 'lps'),
	(497850, 129, '2014-01-15 01:21:56.000000', 'consum', 0.0218, 'lps'),
	(497851, 129, '2014-01-15 01:21:57.000000', 'consum', 0.0214, 'lps'),
	(497852, 129, '2014-01-15 01:21:58.000000', 'consum', 0.0218, 'lps'),
	(497853, 129, '2014-01-15 01:21:59.000000', 'consum', 0.0223, 'lps'),
	(497854, 129, '2014-01-15 01:22:00.000000', 'consum', 0.0213, 'lps'),
	(497855, 129, '2014-01-15 01:22:01.000000', 'consum', 0.0212, 'lps'),
	(497856, 129, '2014-01-15 01:22:02.000000', 'consum', 0.0213, 'lps'),
	(497857, 129, '2014-01-15 01:22:03.000000', 'consum', 0.0219, 'lps'),
	(497858, 129, '2014-01-15 01:22:04.000000', 'consum', 0.0216, 'lps'),
	(497859, 129, '2014-01-15 01:22:05.000000', 'consum', 0.0217, 'lps'),
	(497860, 129, '2014-01-15 01:22:06.000000', 'consum', 0.0211, 'lps'),
	(497861, 129, '2014-01-15 01:22:07.000000', 'consum', 0.0210, 'lps'),
	(497862, 129, '2014-01-15 01:22:08.000000', 'consum', 0.0220, 'lps'),
	(497863, 129, '2014-01-15 01:22:09.000000', 'consum', 0.0219, 'lps'),
	(497864, 129, '2014-01-15 01:22:10.000000', 'consum', 0.0212, 'lps'),
	(497865, 129, '2014-01-15 01:22:11.000000', 'consum', 0.0221, 'lps'),
	(497866, 129, '2014-01-15 01:22:12.000000', 'consum', 0.0217, 'lps'),
	(497867, 129, '2014-01-15 01:22:13.000000', 'consum', 0.0214, 'lps'),
	(497868, 129, '2014-01-15 01:22:14.000000', 'consum', 0.0223, 'lps'),
	(497869, 129, '2014-01-15 01:22:15.000000', 'consum', 0.0220, 'lps'),
	(497870, 129, '2014-01-15 01:22:16.000000', 'consum', 0.0210, 'lps'),
	(497871, 129, '2014-01-15 01:22:17.000000', 'consum', 0.0223, 'lps'),
	(497872, 129, '2014-01-15 01:22:18.000000', 'consum', 0.0220, 'lps'),
	(497873, 129, '2014-01-15 01:22:19.000000', 'consum', 0.0222, 'lps'),
	(497874, 129, '2014-01-15 01:22:20.000000', 'consum', 0.0213, 'lps'),
	(497875, 129, '2014-01-15 01:22:21.000000', 'consum', 0.0215, 'lps'),
	(497876, 129, '2014-01-15 01:22:22.000000', 'consum', 0.0213, 'lps'),
	(497877, 129, '2014-01-15 01:22:23.000000', 'consum', 0.0210, 'lps'),
	(497878, 129, '2014-01-15 01:22:24.000000', 'consum', 0.0216, 'lps'),
	(497879, 129, '2014-01-15 01:22:25.000000', 'consum', 0.0214, 'lps'),
	(497880, 129, '2014-01-15 01:22:26.000000', 'consum', 0.0213, 'lps'),
	(497881, 129, '2014-01-15 01:22:27.000000', 'consum', 0.0212, 'lps'),
	(497882, 129, '2014-01-15 01:22:28.000000', 'consum', 0.0214, 'lps'),
	(497883, 129, '2014-01-15 01:22:29.000000', 'consum', 0.0223, 'lps'),
	(497884, 129, '2014-01-15 01:22:30.000000', 'consum', 0.0220, 'lps'),
	(497885, 129, '2014-01-15 01:22:31.000000', 'consum', 0.0210, 'lps'),
	(497886, 129, '2014-01-15 01:22:32.000000', 'consum', 0.0223, 'lps'),
	(497887, 129, '2014-01-15 01:22:33.000000', 'consum', 0.0219, 'lps'),
	(497888, 129, '2014-01-15 01:22:34.000000', 'consum', 0.0214, 'lps'),
	(497889, 129, '2014-01-15 01:22:35.000000', 'consum', 0.0219, 'lps'),
	(497890, 129, '2014-01-15 01:22:36.000000', 'consum', 0.0215, 'lps'),
	(497891, 129, '2014-01-15 01:22:37.000000', 'consum', 0.0210, 'lps'),
	(497892, 129, '2014-01-15 01:22:38.000000', 'consum', 0.0222, 'lps'),
	(497893, 129, '2014-01-15 01:22:39.000000', 'consum', 0.0215, 'lps'),
	(497894, 129, '2014-01-15 01:22:40.000000', 'consum', 0.0214, 'lps'),
	(497895, 129, '2014-01-15 01:22:41.000000', 'consum', 0.0213, 'lps'),
	(497896, 129, '2014-01-15 01:22:42.000000', 'consum', 0.0217, 'lps'),
	(497897, 129, '2014-01-15 01:22:43.000000', 'consum', 0.0222, 'lps'),
	(497898, 129, '2014-01-15 01:22:44.000000', 'consum', 0.0219, 'lps'),
	(497899, 129, '2014-01-15 01:22:45.000000', 'consum', 0.0221, 'lps'),
	(497900, 129, '2014-01-15 01:22:46.000000', 'consum', 0.0223, 'lps'),
	(497901, 129, '2014-01-15 01:22:47.000000', 'consum', 0.0214, 'lps'),
	(497902, 129, '2014-01-15 01:22:48.000000', 'consum', 0.0219, 'lps'),
	(497903, 129, '2014-01-15 01:22:49.000000', 'consum', 0.0218, 'lps'),
	(497904, 129, '2014-01-15 01:22:50.000000', 'consum', 0.0210, 'lps'),
	(497905, 129, '2014-01-15 01:22:51.000000', 'consum', 0.0214, 'lps'),
	(497906, 129, '2014-01-15 01:22:52.000000', 'consum', 0.0218, 'lps'),
	(497907, 129, '2014-01-15 01:22:53.000000', 'consum', 0.0222, 'lps'),
	(497908, 129, '2014-01-15 01:22:54.000000', 'consum', 0.0217, 'lps'),
	(497909, 129, '2014-01-15 01:22:55.000000', 'consum', 0.0212, 'lps'),
	(497910, 129, '2014-01-15 01:22:56.000000', 'consum', 0.0213, 'lps'),
	(497911, 129, '2014-01-15 01:22:57.000000', 'consum', 0.0220, 'lps'),
	(497912, 129, '2014-01-15 01:22:58.000000', 'consum', 0.0223, 'lps'),
	(497913, 129, '2014-01-15 01:22:59.000000', 'consum', 0.0218, 'lps'),
	(497914, 129, '2014-01-15 01:23:00.000000', 'consum', 0.0212, 'lps'),
	(497915, 129, '2014-01-15 01:23:01.000000', 'consum', 0.0210, 'lps'),
	(497916, 129, '2014-01-15 01:23:02.000000', 'consum', 0.0218, 'lps'),
	(497917, 129, '2014-01-15 01:23:03.000000', 'consum', 0.0223, 'lps'),
	(497918, 129, '2014-01-15 01:23:04.000000', 'consum', 0.0222, 'lps'),
	(497919, 129, '2014-01-15 01:23:05.000000', 'consum', 0.0218, 'lps'),
	(497920, 129, '2014-01-15 01:23:06.000000', 'consum', 0.0214, 'lps'),
	(497921, 129, '2014-01-15 01:23:07.000000', 'consum', 0.0223, 'lps'),
	(497922, 129, '2014-01-15 01:23:08.000000', 'consum', 0.0221, 'lps'),
	(497923, 129, '2014-01-15 01:23:09.000000', 'consum', 0.0211, 'lps'),
	(497924, 129, '2014-01-15 01:23:10.000000', 'consum', 0.0210, 'lps'),
	(497925, 129, '2014-01-15 01:23:11.000000', 'consum', 0.0221, 'lps'),
	(497926, 129, '2014-01-15 01:23:12.000000', 'consum', 0.0211, 'lps'),
	(497927, 129, '2014-01-15 01:23:13.000000', 'consum', 0.0210, 'lps'),
	(497928, 129, '2014-01-15 01:23:14.000000', 'consum', 0.0220, 'lps'),
	(497929, 129, '2014-01-15 01:23:15.000000', 'consum', 0.0218, 'lps'),
	(497930, 129, '2014-01-15 01:23:16.000000', 'consum', 0.0220, 'lps'),
	(497931, 129, '2014-01-15 01:23:17.000000', 'consum', 0.0222, 'lps'),
	(497932, 129, '2014-01-15 01:23:18.000000', 'consum', 0.0212, 'lps'),
	(497933, 129, '2014-01-15 01:23:19.000000', 'consum', 0.0213, 'lps'),
	(497934, 129, '2014-01-15 01:23:20.000000', 'consum', 0.0219, 'lps'),
	(497935, 129, '2014-01-15 01:23:21.000000', 'consum', 0.0217, 'lps'),
	(497936, 129, '2014-01-15 01:23:22.000000', 'consum', 0.0221, 'lps'),
	(497937, 129, '2014-01-15 01:23:23.000000', 'consum', 0.0217, 'lps'),
	(497938, 129, '2014-01-15 01:23:24.000000', 'consum', 0.0213, 'lps'),
	(497939, 129, '2014-01-15 01:23:25.000000', 'consum', 0.0216, 'lps'),
	(497940, 129, '2014-01-15 01:23:26.000000', 'consum', 0.0219, 'lps'),
	(497941, 129, '2014-01-15 01:23:27.000000', 'consum', 0.0223, 'lps'),
	(497942, 129, '2014-01-15 01:23:28.000000', 'consum', 0.0222, 'lps'),
	(497943, 129, '2014-01-15 01:23:29.000000', 'consum', 0.0218, 'lps'),
	(497944, 129, '2014-01-15 01:23:30.000000', 'consum', 0.0214, 'lps'),
	(497945, 129, '2014-01-15 01:23:31.000000', 'consum', 0.0222, 'lps'),
	(497946, 129, '2014-01-15 01:23:32.000000', 'consum', 0.0214, 'lps'),
	(497947, 129, '2014-01-15 01:23:33.000000', 'consum', 0.0223, 'lps'),
	(497948, 129, '2014-01-15 01:23:34.000000', 'consum', 0.0220, 'lps'),
	(497949, 129, '2014-01-15 01:23:35.000000', 'consum', 0.0221, 'lps'),
	(497950, 129, '2014-01-15 01:23:36.000000', 'consum', 0.0211, 'lps'),
	(497951, 129, '2014-01-15 01:23:37.000000', 'consum', 0.0222, 'lps'),
	(497952, 129, '2014-01-15 01:23:38.000000', 'consum', 0.0213, 'lps'),
	(497953, 129, '2014-01-15 01:23:39.000000', 'consum', 0.0216, 'lps'),
	(497954, 129, '2014-01-15 01:23:40.000000', 'consum', 0.0218, 'lps'),
	(497955, 129, '2014-01-15 01:23:41.000000', 'consum', 0.0220, 'lps'),
	(497956, 129, '2014-01-15 01:23:42.000000', 'consum', 0.0219, 'lps'),
	(497957, 129, '2014-01-15 01:23:43.000000', 'consum', 0.0215, 'lps'),
	(497958, 129, '2014-01-15 01:23:44.000000', 'consum', 0.0223, 'lps'),
	(497959, 129, '2014-01-15 01:23:45.000000', 'consum', 0.0215, 'lps'),
	(497960, 129, '2014-01-15 01:23:46.000000', 'consum', 0.0213, 'lps'),
	(497961, 129, '2014-01-15 01:23:47.000000', 'consum', 0.0223, 'lps'),
	(497962, 129, '2014-01-15 01:23:48.000000', 'consum', 0.0210, 'lps'),
	(497963, 129, '2014-01-15 01:23:49.000000', 'consum', 0.0216, 'lps'),
	(497964, 129, '2014-01-15 01:23:50.000000', 'consum', 0.0211, 'lps'),
	(497965, 129, '2014-01-15 01:23:51.000000', 'consum', 0.0210, 'lps'),
	(497966, 129, '2014-01-15 01:23:52.000000', 'consum', 0.0221, 'lps'),
	(497967, 129, '2014-01-15 01:23:53.000000', 'consum', 0.0212, 'lps'),
	(497968, 129, '2014-01-15 01:23:54.000000', 'consum', 0.0216, 'lps'),
	(497969, 129, '2014-01-15 01:23:55.000000', 'consum', 0.0219, 'lps'),
	(497970, 129, '2014-01-15 01:23:56.000000', 'consum', 0.0211, 'lps'),
	(497971, 129, '2014-01-15 01:23:57.000000', 'consum', 0.0216, 'lps'),
	(497972, 129, '2014-01-15 01:23:58.000000', 'consum', 0.0222, 'lps'),
	(497973, 129, '2014-01-15 01:23:59.000000', 'consum', 0.0213, 'lps'),
	(497974, 129, '2014-01-15 01:24:00.000000', 'consum', 0.0217, 'lps'),
	(497975, 129, '2014-01-15 01:24:01.000000', 'consum', 0.0222, 'lps'),
	(497976, 129, '2014-01-15 01:24:02.000000', 'consum', 0.0223, 'lps'),
	(497977, 129, '2014-01-15 01:24:03.000000', 'consum', 0.0223, 'lps'),
	(497978, 129, '2014-01-15 01:24:04.000000', 'consum', 0.0210, 'lps'),
	(497979, 129, '2014-01-15 01:24:05.000000', 'consum', 0.0213, 'lps'),
	(497980, 129, '2014-01-15 01:24:06.000000', 'consum', 0.0210, 'lps'),
	(497981, 129, '2014-01-15 01:24:07.000000', 'consum', 0.0218, 'lps'),
	(497982, 129, '2014-01-15 01:24:08.000000', 'consum', 0.0220, 'lps'),
	(497983, 129, '2014-01-15 01:24:09.000000', 'consum', 0.0223, 'lps'),
	(497984, 129, '2014-01-15 01:24:10.000000', 'consum', 0.0219, 'lps'),
	(497985, 129, '2014-01-15 01:24:11.000000', 'consum', 0.0218, 'lps'),
	(497986, 129, '2014-01-15 01:24:12.000000', 'consum', 0.0221, 'lps'),
	(497987, 129, '2014-01-15 01:24:13.000000', 'consum', 0.0215, 'lps'),
	(497988, 129, '2014-01-15 01:24:14.000000', 'consum', 0.0215, 'lps'),
	(497989, 129, '2014-01-15 01:24:15.000000', 'consum', 0.0221, 'lps'),
	(497990, 129, '2014-01-15 01:24:16.000000', 'consum', 0.0210, 'lps'),
	(497991, 129, '2014-01-15 01:24:17.000000', 'consum', 0.0218, 'lps'),
	(497992, 129, '2014-01-15 01:24:18.000000', 'consum', 0.0223, 'lps'),
	(497993, 129, '2014-01-15 01:24:19.000000', 'consum', 0.0222, 'lps'),
	(497994, 129, '2014-01-15 01:24:20.000000', 'consum', 0.0219, 'lps'),
	(497995, 129, '2014-01-15 01:24:21.000000', 'consum', 0.0221, 'lps'),
	(497996, 129, '2014-01-15 01:24:22.000000', 'consum', 0.0223, 'lps'),
	(497997, 129, '2014-01-15 01:24:23.000000', 'consum', 0.0217, 'lps'),
	(497998, 129, '2014-01-15 01:24:24.000000', 'consum', 0.0218, 'lps'),
	(497999, 129, '2014-01-15 01:24:25.000000', 'consum', 0.0214, 'lps'),
	(498000, 129, '2014-01-15 01:24:26.000000', 'consum', 0.0222, 'lps'),
	(498001, 129, '2014-01-15 01:24:27.000000', 'consum', 0.0216, 'lps'),
	(498002, 129, '2014-01-15 01:24:28.000000', 'consum', 0.0217, 'lps'),
	(498003, 129, '2014-01-15 01:24:29.000000', 'consum', 0.0214, 'lps'),
	(498004, 129, '2014-01-15 01:24:30.000000', 'consum', 0.0223, 'lps'),
	(498005, 129, '2014-01-15 01:24:31.000000', 'consum', 0.0222, 'lps'),
	(498006, 129, '2014-01-15 01:24:32.000000', 'consum', 0.0218, 'lps'),
	(498007, 129, '2014-01-15 01:24:33.000000', 'consum', 0.0213, 'lps'),
	(498008, 129, '2014-01-15 01:24:34.000000', 'consum', 0.0215, 'lps'),
	(498009, 129, '2014-01-15 01:24:35.000000', 'consum', 0.0212, 'lps'),
	(498010, 129, '2014-01-15 01:24:36.000000', 'consum', 0.0222, 'lps'),
	(498011, 129, '2014-01-15 01:24:37.000000', 'consum', 0.0223, 'lps'),
	(498012, 129, '2014-01-15 01:24:38.000000', 'consum', 0.0223, 'lps'),
	(498013, 129, '2014-01-15 01:24:39.000000', 'consum', 0.0210, 'lps'),
	(498014, 129, '2014-01-15 01:24:40.000000', 'consum', 0.0214, 'lps'),
	(498015, 129, '2014-01-15 01:24:41.000000', 'consum', 0.0214, 'lps'),
	(498016, 129, '2014-01-15 01:24:42.000000', 'consum', 0.0220, 'lps'),
	(498017, 129, '2014-01-15 01:24:43.000000', 'consum', 0.0221, 'lps'),
	(498018, 129, '2014-01-15 01:24:44.000000', 'consum', 0.0220, 'lps'),
	(498019, 129, '2014-01-15 01:24:45.000000', 'consum', 0.0214, 'lps'),
	(498020, 129, '2014-01-15 01:24:46.000000', 'consum', 0.0214, 'lps'),
	(498021, 129, '2014-01-15 01:24:47.000000', 'consum', 0.0218, 'lps'),
	(498022, 129, '2014-01-15 01:24:48.000000', 'consum', 0.0212, 'lps'),
	(498023, 129, '2014-01-15 01:24:49.000000', 'consum', 0.0223, 'lps'),
	(498024, 129, '2014-01-15 01:24:50.000000', 'consum', 0.0214, 'lps'),
	(498025, 129, '2014-01-15 01:24:51.000000', 'consum', 0.0221, 'lps'),
	(498026, 129, '2014-01-15 01:24:52.000000', 'consum', 0.0212, 'lps'),
	(498027, 129, '2014-01-15 01:24:53.000000', 'consum', 0.0213, 'lps'),
	(498028, 129, '2014-01-15 01:24:54.000000', 'consum', 0.0218, 'lps'),
	(498029, 129, '2014-01-15 01:24:55.000000', 'consum', 0.0217, 'lps'),
	(498030, 129, '2014-01-15 01:24:56.000000', 'consum', 0.0222, 'lps'),
	(498031, 129, '2014-01-15 01:24:57.000000', 'consum', 0.0218, 'lps'),
	(498032, 129, '2014-01-15 01:24:58.000000', 'consum', 0.0217, 'lps'),
	(498033, 129, '2014-01-15 01:24:59.000000', 'consum', 0.0220, 'lps'),
	(498034, 129, '2014-01-15 01:25:00.000000', 'consum', 0.0213, 'lps'),
	(498035, 129, '2014-01-15 01:25:01.000000', 'consum', 0.0210, 'lps'),
	(498036, 129, '2014-01-15 01:25:02.000000', 'consum', 0.0213, 'lps'),
	(498037, 129, '2014-01-15 01:25:03.000000', 'consum', 0.0213, 'lps'),
	(498038, 129, '2014-01-15 01:25:04.000000', 'consum', 0.0217, 'lps'),
	(498039, 129, '2014-01-15 01:25:05.000000', 'consum', 0.0210, 'lps'),
	(498040, 129, '2014-01-15 01:25:06.000000', 'consum', 0.0216, 'lps'),
	(498041, 129, '2014-01-15 01:25:07.000000', 'consum', 0.0214, 'lps'),
	(498042, 129, '2014-01-15 01:25:08.000000', 'consum', 0.0211, 'lps'),
	(498043, 129, '2014-01-15 01:25:09.000000', 'consum', 0.0218, 'lps'),
	(498044, 129, '2014-01-15 01:25:10.000000', 'consum', 0.0219, 'lps'),
	(498045, 129, '2014-01-15 01:25:11.000000', 'consum', 0.0216, 'lps'),
	(498046, 129, '2014-01-15 01:25:12.000000', 'consum', 0.0214, 'lps'),
	(498047, 129, '2014-01-15 01:25:13.000000', 'consum', 0.0215, 'lps'),
	(498048, 129, '2014-01-15 01:25:14.000000', 'consum', 0.0223, 'lps'),
	(498049, 129, '2014-01-15 01:25:15.000000', 'consum', 0.0216, 'lps'),
	(498050, 129, '2014-01-15 01:25:16.000000', 'consum', 0.0218, 'lps'),
	(498051, 129, '2014-01-15 01:25:17.000000', 'consum', 0.0219, 'lps'),
	(498052, 129, '2014-01-15 01:25:18.000000', 'consum', 0.0217, 'lps'),
	(498053, 129, '2014-01-15 01:25:19.000000', 'consum', 0.0217, 'lps'),
	(498054, 129, '2014-01-15 01:25:20.000000', 'consum', 0.0213, 'lps'),
	(498055, 129, '2014-01-15 01:25:21.000000', 'consum', 0.0216, 'lps'),
	(498056, 129, '2014-01-15 01:25:22.000000', 'consum', 0.0218, 'lps'),
	(498057, 129, '2014-01-15 01:25:23.000000', 'consum', 0.0219, 'lps'),
	(498058, 129, '2014-01-15 01:25:24.000000', 'consum', 0.0215, 'lps'),
	(498059, 129, '2014-01-15 01:25:25.000000', 'consum', 0.0211, 'lps'),
	(498060, 129, '2014-01-15 01:25:26.000000', 'consum', 0.0214, 'lps'),
	(498061, 129, '2014-01-15 01:25:27.000000', 'consum', 0.0214, 'lps'),
	(498062, 129, '2014-01-15 01:25:28.000000', 'consum', 0.0219, 'lps'),
	(498063, 129, '2014-01-15 01:25:29.000000', 'consum', 0.0217, 'lps'),
	(498064, 129, '2014-01-15 01:25:30.000000', 'consum', 0.0215, 'lps'),
	(498065, 129, '2014-01-15 01:25:31.000000', 'consum', 0.0217, 'lps'),
	(498066, 129, '2014-01-15 01:25:32.000000', 'consum', 0.0215, 'lps'),
	(498067, 129, '2014-01-15 01:25:33.000000', 'consum', 0.0217, 'lps'),
	(498068, 129, '2014-01-15 01:25:34.000000', 'consum', 0.0213, 'lps'),
	(498069, 129, '2014-01-15 01:25:35.000000', 'consum', 0.0220, 'lps'),
	(498070, 129, '2014-01-15 01:25:36.000000', 'consum', 0.0210, 'lps'),
	(498071, 129, '2014-01-15 01:25:37.000000', 'consum', 0.0221, 'lps'),
	(498072, 129, '2014-01-15 01:25:38.000000', 'consum', 0.0212, 'lps'),
	(498073, 129, '2014-01-15 01:25:39.000000', 'consum', 0.0215, 'lps'),
	(498074, 129, '2014-01-15 01:25:40.000000', 'consum', 0.0215, 'lps'),
	(498075, 129, '2014-01-15 01:25:41.000000', 'consum', 0.0221, 'lps'),
	(498076, 129, '2014-01-15 01:25:42.000000', 'consum', 0.0221, 'lps'),
	(498077, 129, '2014-01-15 01:25:43.000000', 'consum', 0.0219, 'lps'),
	(498078, 129, '2014-01-15 01:25:44.000000', 'consum', 0.0210, 'lps'),
	(498079, 129, '2014-01-15 01:25:45.000000', 'consum', 0.0223, 'lps'),
	(498080, 129, '2014-01-15 01:25:46.000000', 'consum', 0.0220, 'lps'),
	(498081, 129, '2014-01-15 01:25:47.000000', 'consum', 0.0223, 'lps'),
	(498082, 129, '2014-01-15 01:25:48.000000', 'consum', 0.0216, 'lps'),
	(498083, 129, '2014-01-15 01:25:49.000000', 'consum', 0.0215, 'lps'),
	(498084, 129, '2014-01-15 01:25:50.000000', 'consum', 0.0218, 'lps'),
	(498085, 129, '2014-01-15 01:25:51.000000', 'consum', 0.0223, 'lps'),
	(498086, 129, '2014-01-15 01:25:52.000000', 'consum', 0.0222, 'lps'),
	(498087, 129, '2014-01-15 01:25:53.000000', 'consum', 0.0220, 'lps'),
	(498088, 129, '2014-01-15 01:25:54.000000', 'consum', 0.0223, 'lps'),
	(498089, 129, '2014-01-15 01:25:55.000000', 'consum', 0.0216, 'lps'),
	(498090, 129, '2014-01-15 01:25:56.000000', 'consum', 0.0217, 'lps'),
	(498091, 129, '2014-01-15 01:25:57.000000', 'consum', 0.0215, 'lps'),
	(498092, 129, '2014-01-15 01:25:58.000000', 'consum', 0.0214, 'lps'),
	(498093, 129, '2014-01-15 01:25:59.000000', 'consum', 0.0216, 'lps'),
	(498094, 129, '2014-01-15 01:26:00.000000', 'consum', 0.0215, 'lps'),
	(498095, 129, '2014-01-15 01:26:01.000000', 'consum', 0.0219, 'lps'),
	(498096, 129, '2014-01-15 01:26:02.000000', 'consum', 0.0210, 'lps'),
	(498097, 129, '2014-01-15 01:26:03.000000', 'consum', 0.0210, 'lps'),
	(498098, 129, '2014-01-15 01:26:04.000000', 'consum', 0.0214, 'lps'),
	(498099, 129, '2014-01-15 01:26:05.000000', 'consum', 0.0215, 'lps'),
	(498100, 129, '2014-01-15 01:26:06.000000', 'consum', 0.0210, 'lps'),
	(498101, 129, '2014-01-15 01:26:07.000000', 'consum', 0.0223, 'lps'),
	(498102, 129, '2014-01-15 01:26:08.000000', 'consum', 0.0219, 'lps'),
	(498103, 129, '2014-01-15 01:26:09.000000', 'consum', 0.0217, 'lps'),
	(498104, 129, '2014-01-15 01:26:10.000000', 'consum', 0.0220, 'lps'),
	(498105, 129, '2014-01-15 01:26:11.000000', 'consum', 0.0223, 'lps'),
	(498106, 129, '2014-01-15 01:26:12.000000', 'consum', 0.0217, 'lps'),
	(498107, 129, '2014-01-15 01:26:13.000000', 'consum', 0.0223, 'lps'),
	(498108, 129, '2014-01-15 01:26:14.000000', 'consum', 0.0212, 'lps'),
	(498109, 129, '2014-01-15 01:26:15.000000', 'consum', 0.0211, 'lps'),
	(498110, 129, '2014-01-15 01:26:16.000000', 'consum', 0.0220, 'lps'),
	(498111, 129, '2014-01-15 01:26:17.000000', 'consum', 0.0217, 'lps'),
	(498112, 129, '2014-01-15 01:26:18.000000', 'consum', 0.0217, 'lps'),
	(498113, 129, '2014-01-15 01:26:19.000000', 'consum', 0.0210, 'lps'),
	(498114, 129, '2014-01-15 01:26:20.000000', 'consum', 0.0216, 'lps'),
	(498115, 129, '2014-01-15 01:26:21.000000', 'consum', 0.0214, 'lps'),
	(498116, 129, '2014-01-15 01:26:22.000000', 'consum', 0.0213, 'lps'),
	(498117, 129, '2014-01-15 01:26:23.000000', 'consum', 0.0211, 'lps'),
	(498118, 129, '2014-01-15 01:26:24.000000', 'consum', 0.0210, 'lps'),
	(498119, 129, '2014-01-15 01:26:25.000000', 'consum', 0.0218, 'lps'),
	(498120, 129, '2014-01-15 01:26:26.000000', 'consum', 0.0211, 'lps'),
	(498121, 129, '2014-01-15 01:26:27.000000', 'consum', 0.0219, 'lps'),
	(498122, 129, '2014-01-15 01:26:28.000000', 'consum', 0.0222, 'lps'),
	(498123, 129, '2014-01-15 01:26:29.000000', 'consum', 0.0219, 'lps'),
	(498124, 129, '2014-01-15 01:26:30.000000', 'consum', 0.0217, 'lps'),
	(498125, 129, '2014-01-15 01:26:31.000000', 'consum', 0.0220, 'lps'),
	(498126, 129, '2014-01-15 01:26:32.000000', 'consum', 0.0211, 'lps'),
	(498127, 129, '2014-01-15 01:26:33.000000', 'consum', 0.0214, 'lps'),
	(498128, 129, '2014-01-15 01:26:34.000000', 'consum', 0.0213, 'lps'),
	(498129, 129, '2014-01-15 01:26:35.000000', 'consum', 0.0215, 'lps'),
	(498130, 129, '2014-01-15 01:26:36.000000', 'consum', 0.0210, 'lps'),
	(498131, 129, '2014-01-15 01:26:37.000000', 'consum', 0.0212, 'lps'),
	(498132, 129, '2014-01-15 01:26:38.000000', 'consum', 0.0220, 'lps'),
	(498133, 129, '2014-01-15 01:26:39.000000', 'consum', 0.0214, 'lps'),
	(498134, 129, '2014-01-15 01:26:40.000000', 'consum', 0.0213, 'lps'),
	(498135, 129, '2014-01-15 01:26:41.000000', 'consum', 0.0212, 'lps'),
	(498136, 129, '2014-01-15 01:26:42.000000', 'consum', 0.0211, 'lps'),
	(498137, 129, '2014-01-15 01:26:43.000000', 'consum', 0.0223, 'lps'),
	(498138, 129, '2014-01-15 01:26:44.000000', 'consum', 0.0218, 'lps'),
	(498139, 129, '2014-01-15 01:26:45.000000', 'consum', 0.0213, 'lps'),
	(498140, 129, '2014-01-15 01:26:46.000000', 'consum', 0.0214, 'lps'),
	(498141, 129, '2014-01-15 01:26:47.000000', 'consum', 0.0223, 'lps'),
	(498142, 129, '2014-01-15 01:26:48.000000', 'consum', 0.0222, 'lps'),
	(498143, 129, '2014-01-15 01:26:49.000000', 'consum', 0.0215, 'lps'),
	(498144, 129, '2014-01-15 01:26:50.000000', 'consum', 0.0216, 'lps'),
	(498145, 129, '2014-01-15 01:26:51.000000', 'consum', 0.0213, 'lps'),
	(498146, 129, '2014-01-15 01:26:52.000000', 'consum', 0.0218, 'lps'),
	(498147, 129, '2014-01-15 01:26:53.000000', 'consum', 0.0215, 'lps'),
	(498148, 129, '2014-01-15 01:26:54.000000', 'consum', 0.0212, 'lps'),
	(498149, 129, '2014-01-15 01:26:55.000000', 'consum', 0.0217, 'lps'),
	(498150, 129, '2014-01-15 01:26:56.000000', 'consum', 0.0214, 'lps'),
	(498151, 129, '2014-01-15 01:26:57.000000', 'consum', 0.0210, 'lps'),
	(498152, 129, '2014-01-15 01:26:58.000000', 'consum', 0.0213, 'lps'),
	(498153, 129, '2014-01-15 01:26:59.000000', 'consum', 0.0212, 'lps'),
	(498154, 129, '2014-01-15 01:27:00.000000', 'consum', 0.0223, 'lps'),
	(498155, 129, '2014-01-15 01:27:01.000000', 'consum', 0.0214, 'lps'),
	(498156, 129, '2014-01-15 01:27:02.000000', 'consum', 0.0219, 'lps'),
	(498157, 129, '2014-01-15 01:27:03.000000', 'consum', 0.0215, 'lps'),
	(498158, 129, '2014-01-15 01:27:04.000000', 'consum', 0.0211, 'lps'),
	(498159, 129, '2014-01-15 01:27:05.000000', 'consum', 0.0213, 'lps'),
	(498160, 129, '2014-01-15 01:27:06.000000', 'consum', 0.0210, 'lps'),
	(498161, 129, '2014-01-15 01:27:07.000000', 'consum', 0.0214, 'lps'),
	(498162, 129, '2014-01-15 01:27:08.000000', 'consum', 0.0217, 'lps'),
	(498163, 129, '2014-01-15 01:27:09.000000', 'consum', 0.0218, 'lps'),
	(498164, 129, '2014-01-15 01:27:10.000000', 'consum', 0.0216, 'lps'),
	(498165, 129, '2014-01-15 01:27:11.000000', 'consum', 0.0219, 'lps'),
	(498166, 129, '2014-01-15 01:27:12.000000', 'consum', 0.0221, 'lps'),
	(498167, 129, '2014-01-15 01:27:13.000000', 'consum', 0.0210, 'lps'),
	(498168, 129, '2014-01-15 01:27:14.000000', 'consum', 0.0219, 'lps'),
	(498169, 129, '2014-01-15 01:27:15.000000', 'consum', 0.0214, 'lps'),
	(498170, 129, '2014-01-15 01:27:16.000000', 'consum', 0.0218, 'lps'),
	(498171, 129, '2014-01-15 01:27:17.000000', 'consum', 0.0223, 'lps'),
	(498172, 129, '2014-01-15 01:27:18.000000', 'consum', 0.0212, 'lps'),
	(498173, 129, '2014-01-15 01:27:19.000000', 'consum', 0.0221, 'lps'),
	(498174, 129, '2014-01-15 01:27:20.000000', 'consum', 0.0219, 'lps'),
	(498175, 129, '2014-01-15 01:27:21.000000', 'consum', 0.0220, 'lps'),
	(498176, 129, '2014-01-15 01:27:22.000000', 'consum', 0.0222, 'lps'),
	(498177, 129, '2014-01-15 01:27:23.000000', 'consum', 0.0213, 'lps'),
	(498178, 129, '2014-01-15 01:27:24.000000', 'consum', 0.0218, 'lps'),
	(498179, 129, '2014-01-15 01:27:25.000000', 'consum', 0.0212, 'lps'),
	(498180, 129, '2014-01-15 01:27:26.000000', 'consum', 0.0223, 'lps'),
	(498181, 129, '2014-01-15 01:27:27.000000', 'consum', 0.0216, 'lps'),
	(498182, 129, '2014-01-15 01:27:28.000000', 'consum', 0.0215, 'lps'),
	(498183, 129, '2014-01-15 01:27:29.000000', 'consum', 0.0218, 'lps'),
	(498184, 129, '2014-01-15 01:27:30.000000', 'consum', 0.0220, 'lps'),
	(498185, 129, '2014-01-15 01:27:31.000000', 'consum', 0.0223, 'lps'),
	(498186, 129, '2014-01-15 01:27:32.000000', 'consum', 0.0219, 'lps'),
	(498187, 129, '2014-01-15 01:27:33.000000', 'consum', 0.0218, 'lps'),
	(498188, 129, '2014-01-15 01:27:34.000000', 'consum', 0.0220, 'lps'),
	(498189, 129, '2014-01-15 01:27:35.000000', 'consum', 0.0223, 'lps'),
	(498190, 129, '2014-01-15 01:27:36.000000', 'consum', 0.0216, 'lps'),
	(498191, 129, '2014-01-15 01:27:37.000000', 'consum', 0.0218, 'lps'),
	(498192, 129, '2014-01-15 01:27:38.000000', 'consum', 0.0218, 'lps'),
	(498193, 129, '2014-01-15 01:27:39.000000', 'consum', 0.0211, 'lps'),
	(498194, 129, '2014-01-15 01:27:40.000000', 'consum', 0.0219, 'lps'),
	(498195, 129, '2014-01-15 01:27:41.000000', 'consum', 0.0213, 'lps'),
	(498196, 129, '2014-01-15 01:27:42.000000', 'consum', 0.0211, 'lps'),
	(498197, 129, '2014-01-15 01:27:43.000000', 'consum', 0.0221, 'lps'),
	(498198, 129, '2014-01-15 01:27:44.000000', 'consum', 0.0219, 'lps'),
	(498199, 129, '2014-01-15 01:27:45.000000', 'consum', 0.0223, 'lps'),
	(498200, 129, '2014-01-15 01:27:46.000000', 'consum', 0.0222, 'lps'),
	(498201, 129, '2014-01-15 01:27:47.000000', 'consum', 0.0216, 'lps'),
	(498202, 129, '2014-01-15 01:27:48.000000', 'consum', 0.0220, 'lps'),
	(498203, 129, '2014-01-15 01:27:49.000000', 'consum', 0.0212, 'lps'),
	(498204, 129, '2014-01-15 01:27:50.000000', 'consum', 0.0220, 'lps'),
	(498205, 129, '2014-01-15 01:27:51.000000', 'consum', 0.0213, 'lps'),
	(498206, 129, '2014-01-15 01:27:52.000000', 'consum', 0.0223, 'lps'),
	(498207, 129, '2014-01-15 01:27:53.000000', 'consum', 0.0223, 'lps'),
	(498208, 129, '2014-01-15 01:27:54.000000', 'consum', 0.0223, 'lps'),
	(498209, 129, '2014-01-15 01:27:55.000000', 'consum', 0.0211, 'lps'),
	(498210, 129, '2014-01-15 01:27:56.000000', 'consum', 0.0217, 'lps'),
	(498211, 129, '2014-01-15 01:27:57.000000', 'consum', 0.0215, 'lps'),
	(498212, 129, '2014-01-15 01:27:58.000000', 'consum', 0.0214, 'lps'),
	(498213, 129, '2014-01-15 01:27:59.000000', 'consum', 0.0217, 'lps'),
	(498214, 129, '2014-01-15 01:28:00.000000', 'consum', 0.0219, 'lps'),
	(498215, 129, '2014-01-15 01:28:01.000000', 'consum', 0.0220, 'lps'),
	(498216, 129, '2014-01-15 01:28:02.000000', 'consum', 0.0219, 'lps'),
	(498217, 129, '2014-01-15 01:28:03.000000', 'consum', 0.0211, 'lps'),
	(498218, 129, '2014-01-15 01:28:04.000000', 'consum', 0.0219, 'lps'),
	(498219, 129, '2014-01-15 01:28:05.000000', 'consum', 0.0222, 'lps'),
	(498220, 129, '2014-01-15 01:28:06.000000', 'consum', 0.0216, 'lps'),
	(498221, 129, '2014-01-15 01:28:07.000000', 'consum', 0.0218, 'lps'),
	(498222, 129, '2014-01-15 01:28:08.000000', 'consum', 0.0219, 'lps'),
	(498223, 129, '2014-01-15 01:28:09.000000', 'consum', 0.0216, 'lps'),
	(498224, 129, '2014-01-15 01:28:10.000000', 'consum', 0.0214, 'lps'),
	(498225, 129, '2014-01-15 01:28:11.000000', 'consum', 0.0211, 'lps'),
	(498226, 129, '2014-01-15 01:28:12.000000', 'consum', 0.0221, 'lps'),
	(498227, 129, '2014-01-15 01:28:13.000000', 'consum', 0.0219, 'lps'),
	(498228, 129, '2014-01-15 01:28:14.000000', 'consum', 0.0221, 'lps'),
	(498229, 129, '2014-01-15 01:28:15.000000', 'consum', 0.0210, 'lps'),
	(498230, 129, '2014-01-15 01:28:16.000000', 'consum', 0.0221, 'lps'),
	(498231, 129, '2014-01-15 01:28:17.000000', 'consum', 0.0222, 'lps'),
	(498232, 129, '2014-01-15 01:28:18.000000', 'consum', 0.0210, 'lps'),
	(498233, 129, '2014-01-15 01:28:19.000000', 'consum', 0.0215, 'lps'),
	(498234, 129, '2014-01-15 01:28:20.000000', 'consum', 0.0222, 'lps'),
	(498235, 129, '2014-01-15 01:28:21.000000', 'consum', 0.0213, 'lps'),
	(498236, 129, '2014-01-15 01:28:22.000000', 'consum', 0.0219, 'lps'),
	(498237, 129, '2014-01-15 01:28:23.000000', 'consum', 0.0219, 'lps'),
	(498238, 129, '2014-01-15 01:28:24.000000', 'consum', 0.0214, 'lps'),
	(498239, 129, '2014-01-15 01:28:25.000000', 'consum', 0.0217, 'lps'),
	(498240, 129, '2014-01-15 01:28:26.000000', 'consum', 0.0219, 'lps'),
	(498241, 129, '2014-01-15 01:28:27.000000', 'consum', 0.0221, 'lps'),
	(498242, 129, '2014-01-15 01:28:28.000000', 'consum', 0.0210, 'lps'),
	(498243, 129, '2014-01-15 01:28:29.000000', 'consum', 0.0220, 'lps'),
	(498244, 129, '2014-01-15 01:28:30.000000', 'consum', 0.0220, 'lps'),
	(498245, 129, '2014-01-15 01:28:31.000000', 'consum', 0.0215, 'lps'),
	(498246, 129, '2014-01-15 01:28:32.000000', 'consum', 0.0222, 'lps'),
	(498247, 129, '2014-01-15 01:28:33.000000', 'consum', 0.0210, 'lps'),
	(498248, 129, '2014-01-15 01:28:34.000000', 'consum', 0.0217, 'lps'),
	(498249, 129, '2014-01-15 01:28:35.000000', 'consum', 0.0219, 'lps'),
	(498250, 129, '2014-01-15 01:28:36.000000', 'consum', 0.0221, 'lps'),
	(498251, 129, '2014-01-15 01:28:37.000000', 'consum', 0.0211, 'lps'),
	(498252, 129, '2014-01-15 01:28:38.000000', 'consum', 0.0223, 'lps'),
	(498253, 129, '2014-01-15 01:28:39.000000', 'consum', 0.0217, 'lps'),
	(498254, 129, '2014-01-15 01:28:40.000000', 'consum', 0.0221, 'lps'),
	(498255, 129, '2014-01-15 01:28:41.000000', 'consum', 0.0218, 'lps'),
	(498256, 129, '2014-01-15 01:28:42.000000', 'consum', 0.0217, 'lps'),
	(498257, 129, '2014-01-15 01:28:43.000000', 'consum', 0.0219, 'lps'),
	(498258, 129, '2014-01-15 01:28:44.000000', 'consum', 0.0222, 'lps'),
	(498259, 129, '2014-01-15 01:28:45.000000', 'consum', 0.0215, 'lps'),
	(498260, 129, '2014-01-15 01:28:46.000000', 'consum', 0.0215, 'lps'),
	(498261, 129, '2014-01-15 01:28:47.000000', 'consum', 0.0219, 'lps'),
	(498262, 129, '2014-01-15 01:28:48.000000', 'consum', 0.0213, 'lps'),
	(498263, 129, '2014-01-15 01:28:49.000000', 'consum', 0.0210, 'lps'),
	(498264, 129, '2014-01-15 01:28:50.000000', 'consum', 0.0219, 'lps'),
	(498265, 129, '2014-01-15 01:28:51.000000', 'consum', 0.0211, 'lps'),
	(498266, 129, '2014-01-15 01:28:52.000000', 'consum', 0.0219, 'lps'),
	(498267, 129, '2014-01-15 01:28:53.000000', 'consum', 0.0223, 'lps'),
	(498268, 129, '2014-01-15 01:28:54.000000', 'consum', 0.0222, 'lps'),
	(498269, 129, '2014-01-15 01:28:55.000000', 'consum', 0.0216, 'lps'),
	(498270, 129, '2014-01-15 01:28:56.000000', 'consum', 0.0220, 'lps'),
	(498271, 129, '2014-01-15 01:28:57.000000', 'consum', 0.0215, 'lps'),
	(498272, 129, '2014-01-15 01:28:58.000000', 'consum', 0.0218, 'lps'),
	(498273, 129, '2014-01-15 01:28:59.000000', 'consum', 0.0222, 'lps'),
	(498274, 129, '2014-01-15 01:29:00.000000', 'consum', 0.0219, 'lps'),
	(498275, 129, '2014-01-15 01:29:01.000000', 'consum', 0.0220, 'lps'),
	(498276, 129, '2014-01-15 01:29:02.000000', 'consum', 0.0220, 'lps'),
	(498277, 129, '2014-01-15 01:29:03.000000', 'consum', 0.0216, 'lps'),
	(498278, 129, '2014-01-15 01:29:04.000000', 'consum', 0.0211, 'lps'),
	(498279, 129, '2014-01-15 01:29:05.000000', 'consum', 0.0211, 'lps'),
	(498280, 129, '2014-01-15 01:29:06.000000', 'consum', 0.0214, 'lps'),
	(498281, 129, '2014-01-15 01:29:07.000000', 'consum', 0.0211, 'lps'),
	(498282, 129, '2014-01-15 01:29:08.000000', 'consum', 0.0219, 'lps'),
	(498283, 129, '2014-01-15 01:29:09.000000', 'consum', 0.0223, 'lps'),
	(498284, 129, '2014-01-15 01:29:10.000000', 'consum', 0.0223, 'lps'),
	(498285, 129, '2014-01-15 01:29:11.000000', 'consum', 0.0220, 'lps'),
	(498286, 129, '2014-01-15 01:29:12.000000', 'consum', 0.0210, 'lps'),
	(498287, 129, '2014-01-15 01:29:13.000000', 'consum', 0.0222, 'lps'),
	(498288, 129, '2014-01-15 01:29:14.000000', 'consum', 0.0216, 'lps'),
	(498289, 129, '2014-01-15 01:29:15.000000', 'consum', 0.0216, 'lps'),
	(498290, 129, '2014-01-15 01:29:16.000000', 'consum', 0.0210, 'lps'),
	(498291, 129, '2014-01-15 01:29:17.000000', 'consum', 0.0219, 'lps'),
	(498292, 129, '2014-01-15 01:29:18.000000', 'consum', 0.0215, 'lps'),
	(498293, 129, '2014-01-15 01:29:19.000000', 'consum', 0.0210, 'lps'),
	(498294, 129, '2014-01-15 01:29:20.000000', 'consum', 0.0221, 'lps'),
	(498295, 129, '2014-01-15 01:29:21.000000', 'consum', 0.0210, 'lps'),
	(498296, 129, '2014-01-15 01:29:22.000000', 'consum', 0.0219, 'lps'),
	(498297, 129, '2014-01-15 01:29:23.000000', 'consum', 0.0213, 'lps'),
	(498298, 129, '2014-01-15 01:29:24.000000', 'consum', 0.0211, 'lps'),
	(498299, 129, '2014-01-15 01:29:25.000000', 'consum', 0.0223, 'lps'),
	(498300, 129, '2014-01-15 01:29:26.000000', 'consum', 0.0214, 'lps'),
	(498301, 129, '2014-01-15 01:29:27.000000', 'consum', 0.0221, 'lps'),
	(498302, 129, '2014-01-15 01:29:28.000000', 'consum', 0.0211, 'lps'),
	(498303, 129, '2014-01-15 01:29:29.000000', 'consum', 0.0211, 'lps'),
	(498304, 129, '2014-01-15 01:29:30.000000', 'consum', 0.0211, 'lps'),
	(498305, 129, '2014-01-15 01:29:31.000000', 'consum', 0.0215, 'lps'),
	(498306, 129, '2014-01-15 01:29:32.000000', 'consum', 0.0219, 'lps'),
	(498307, 129, '2014-01-15 01:29:33.000000', 'consum', 0.0212, 'lps'),
	(498308, 129, '2014-01-15 01:29:34.000000', 'consum', 0.0220, 'lps'),
	(498309, 129, '2014-01-15 01:29:35.000000', 'consum', 0.0212, 'lps'),
	(498310, 129, '2014-01-15 01:29:36.000000', 'consum', 0.0220, 'lps'),
	(498311, 129, '2014-01-15 01:29:37.000000', 'consum', 0.0213, 'lps'),
	(498312, 129, '2014-01-15 01:29:38.000000', 'consum', 0.0210, 'lps'),
	(498313, 129, '2014-01-15 01:29:39.000000', 'consum', 0.0215, 'lps'),
	(498314, 129, '2014-01-15 01:29:40.000000', 'consum', 0.0221, 'lps'),
	(498315, 129, '2014-01-15 01:29:41.000000', 'consum', 0.0223, 'lps'),
	(498316, 129, '2014-01-15 01:29:42.000000', 'consum', 0.0215, 'lps'),
	(498317, 129, '2014-01-15 01:29:43.000000', 'consum', 0.0210, 'lps'),
	(498318, 129, '2014-01-15 01:29:44.000000', 'consum', 0.0222, 'lps'),
	(498319, 129, '2014-01-15 01:29:45.000000', 'consum', 0.0214, 'lps'),
	(498320, 129, '2014-01-15 01:29:46.000000', 'consum', 0.0222, 'lps'),
	(498321, 129, '2014-01-15 01:29:47.000000', 'consum', 0.0218, 'lps'),
	(498322, 129, '2014-01-15 01:29:48.000000', 'consum', 0.0213, 'lps'),
	(498323, 129, '2014-01-15 01:29:49.000000', 'consum', 0.0217, 'lps'),
	(498324, 129, '2014-01-15 01:29:50.000000', 'consum', 0.0221, 'lps'),
	(498325, 129, '2014-01-15 01:29:51.000000', 'consum', 0.0217, 'lps'),
	(498326, 129, '2014-01-15 01:29:52.000000', 'consum', 0.0214, 'lps'),
	(498327, 129, '2014-01-15 01:29:53.000000', 'consum', 0.0222, 'lps'),
	(498328, 129, '2014-01-15 01:29:54.000000', 'consum', 0.0218, 'lps'),
	(498329, 129, '2014-01-15 01:29:55.000000', 'consum', 0.0216, 'lps'),
	(498330, 129, '2014-01-15 01:29:56.000000', 'consum', 0.0214, 'lps'),
	(498331, 129, '2014-01-15 01:29:57.000000', 'consum', 0.0215, 'lps'),
	(498332, 129, '2014-01-15 01:29:58.000000', 'consum', 0.0221, 'lps'),
	(498333, 129, '2014-01-15 01:29:59.000000', 'consum', 0.0210, 'lps'),
	(498334, 129, '2014-01-15 01:30:00.000000', 'consum', 0.0220, 'lps'),
	(498335, 129, '2014-01-15 01:30:01.000000', 'consum', 0.0220, 'lps'),
	(498336, 129, '2014-01-15 01:30:02.000000', 'consum', 0.0214, 'lps'),
	(498337, 130, '2014-01-15 00:00:00.000000', 'consum', 0.0220, 'lps'),
	(498338, 130, '2014-01-15 00:00:01.000000', 'consum', 0.0215, 'lps'),
	(498339, 130, '2014-01-15 00:00:02.000000', 'consum', 0.0224, 'lps'),
	(498340, 130, '2014-01-15 00:00:03.000000', 'consum', 0.0211, 'lps'),
	(498341, 130, '2014-01-15 00:00:04.000000', 'consum', 0.0225, 'lps'),
	(498342, 130, '2014-01-15 00:00:05.000000', 'consum', 0.0213, 'lps'),
	(498343, 130, '2014-01-15 00:00:06.000000', 'consum', 0.0217, 'lps'),
	(498344, 130, '2014-01-15 00:00:07.000000', 'consum', 0.0221, 'lps'),
	(498345, 130, '2014-01-15 00:00:08.000000', 'consum', 0.0225, 'lps'),
	(498346, 130, '2014-01-15 00:00:09.000000', 'consum', 0.0220, 'lps'),
	(498347, 130, '2014-01-15 00:00:10.000000', 'consum', 0.0213, 'lps'),
	(498348, 130, '2014-01-15 00:00:11.000000', 'consum', 0.0215, 'lps'),
	(498349, 130, '2014-01-15 00:00:12.000000', 'consum', 0.0226, 'lps'),
	(498350, 130, '2014-01-15 00:00:13.000000', 'consum', 0.0224, 'lps'),
	(498351, 130, '2014-01-15 00:00:14.000000', 'consum', 0.0217, 'lps'),
	(498352, 130, '2014-01-15 00:00:15.000000', 'consum', 0.0220, 'lps'),
	(498353, 130, '2014-01-15 00:00:16.000000', 'consum', 0.0222, 'lps'),
	(498354, 130, '2014-01-15 00:00:17.000000', 'consum', 0.0224, 'lps'),
	(498355, 130, '2014-01-15 00:00:18.000000', 'consum', 0.0212, 'lps'),
	(498356, 130, '2014-01-15 00:00:19.000000', 'consum', 0.0211, 'lps'),
	(498357, 130, '2014-01-15 00:00:20.000000', 'consum', 0.0212, 'lps'),
	(498358, 130, '2014-01-15 00:00:21.000000', 'consum', 0.0214, 'lps'),
	(498359, 130, '2014-01-15 00:00:22.000000', 'consum', 0.0211, 'lps'),
	(498360, 130, '2014-01-15 00:00:23.000000', 'consum', 0.0218, 'lps'),
	(498361, 130, '2014-01-15 00:00:24.000000', 'consum', 0.0216, 'lps'),
	(498362, 130, '2014-01-15 00:00:25.000000', 'consum', 0.0216, 'lps'),
	(498363, 130, '2014-01-15 00:00:26.000000', 'consum', 0.0222, 'lps'),
	(498364, 130, '2014-01-15 00:00:27.000000', 'consum', 0.0218, 'lps'),
	(498365, 130, '2014-01-15 00:00:28.000000', 'consum', 0.0215, 'lps'),
	(498366, 130, '2014-01-15 00:00:29.000000', 'consum', 0.0226, 'lps'),
	(498367, 130, '2014-01-15 00:00:30.000000', 'consum', 0.0211, 'lps'),
	(498368, 130, '2014-01-15 00:00:31.000000', 'consum', 0.0216, 'lps'),
	(498369, 130, '2014-01-15 00:00:32.000000', 'consum', 0.0220, 'lps'),
	(498370, 130, '2014-01-15 00:00:33.000000', 'consum', 0.0226, 'lps'),
	(498371, 130, '2014-01-15 00:00:34.000000', 'consum', 0.0211, 'lps'),
	(498372, 130, '2014-01-15 00:00:35.000000', 'consum', 0.0217, 'lps'),
	(498373, 130, '2014-01-15 00:00:36.000000', 'consum', 0.0224, 'lps'),
	(498374, 130, '2014-01-15 00:00:37.000000', 'consum', 0.0212, 'lps'),
	(498375, 130, '2014-01-15 00:00:38.000000', 'consum', 0.0211, 'lps'),
	(498376, 130, '2014-01-15 00:00:39.000000', 'consum', 0.0225, 'lps'),
	(498377, 130, '2014-01-15 00:00:40.000000', 'consum', 0.0214, 'lps'),
	(498378, 130, '2014-01-15 00:00:41.000000', 'consum', 0.0218, 'lps'),
	(498379, 130, '2014-01-15 00:00:42.000000', 'consum', 0.0225, 'lps'),
	(498380, 130, '2014-01-15 00:00:43.000000', 'consum', 0.0210, 'lps'),
	(498381, 130, '2014-01-15 00:00:44.000000', 'consum', 0.0218, 'lps'),
	(498382, 130, '2014-01-15 00:00:45.000000', 'consum', 0.0214, 'lps'),
	(498383, 130, '2014-01-15 00:00:46.000000', 'consum', 0.0226, 'lps'),
	(498384, 130, '2014-01-15 00:00:47.000000', 'consum', 0.0226, 'lps'),
	(498385, 130, '2014-01-15 00:00:48.000000', 'consum', 0.0224, 'lps'),
	(498386, 130, '2014-01-15 00:00:49.000000', 'consum', 0.0216, 'lps'),
	(498387, 130, '2014-01-15 00:00:50.000000', 'consum', 0.0214, 'lps'),
	(498388, 130, '2014-01-15 00:00:51.000000', 'consum', 0.0215, 'lps'),
	(498389, 130, '2014-01-15 00:00:52.000000', 'consum', 0.0221, 'lps'),
	(498390, 130, '2014-01-15 00:00:53.000000', 'consum', 0.0218, 'lps'),
	(498391, 130, '2014-01-15 00:00:54.000000', 'consum', 0.0217, 'lps'),
	(498392, 130, '2014-01-15 00:00:55.000000', 'consum', 0.0221, 'lps'),
	(498393, 130, '2014-01-15 00:00:56.000000', 'consum', 0.0226, 'lps'),
	(498394, 130, '2014-01-15 00:00:57.000000', 'consum', 0.0225, 'lps'),
	(498395, 130, '2014-01-15 00:00:58.000000', 'consum', 0.0222, 'lps'),
	(498396, 130, '2014-01-15 00:00:59.000000', 'consum', 0.0226, 'lps'),
	(498397, 130, '2014-01-15 00:01:00.000000', 'consum', 0.0217, 'lps'),
	(498398, 130, '2014-01-15 00:01:01.000000', 'consum', 0.0217, 'lps'),
	(498399, 130, '2014-01-15 00:01:02.000000', 'consum', 0.0225, 'lps'),
	(498400, 130, '2014-01-15 00:01:03.000000', 'consum', 0.0213, 'lps'),
	(498401, 130, '2014-01-15 00:01:04.000000', 'consum', 0.0213, 'lps'),
	(498402, 130, '2014-01-15 00:01:05.000000', 'consum', 0.0217, 'lps'),
	(498403, 130, '2014-01-15 00:01:06.000000', 'consum', 0.0220, 'lps'),
	(498404, 130, '2014-01-15 00:01:07.000000', 'consum', 0.0221, 'lps'),
	(498405, 130, '2014-01-15 00:01:08.000000', 'consum', 0.0218, 'lps'),
	(498406, 130, '2014-01-15 00:01:09.000000', 'consum', 0.0221, 'lps'),
	(498407, 130, '2014-01-15 00:01:10.000000', 'consum', 0.0221, 'lps'),
	(498408, 130, '2014-01-15 00:01:11.000000', 'consum', 0.0216, 'lps'),
	(498409, 130, '2014-01-15 00:01:12.000000', 'consum', 0.0225, 'lps'),
	(498410, 130, '2014-01-15 00:01:13.000000', 'consum', 0.0215, 'lps'),
	(498411, 130, '2014-01-15 00:01:14.000000', 'consum', 0.0225, 'lps'),
	(498412, 130, '2014-01-15 00:01:15.000000', 'consum', 0.0221, 'lps'),
	(498413, 130, '2014-01-15 00:01:16.000000', 'consum', 0.0220, 'lps'),
	(498414, 130, '2014-01-15 00:01:17.000000', 'consum', 0.0211, 'lps'),
	(498415, 130, '2014-01-15 00:01:18.000000', 'consum', 0.0218, 'lps'),
	(498416, 130, '2014-01-15 00:01:19.000000', 'consum', 0.0212, 'lps'),
	(498417, 130, '2014-01-15 00:01:20.000000', 'consum', 0.0216, 'lps'),
	(498418, 130, '2014-01-15 00:01:21.000000', 'consum', 0.0215, 'lps'),
	(498419, 130, '2014-01-15 00:01:22.000000', 'consum', 0.0219, 'lps'),
	(498420, 130, '2014-01-15 00:01:23.000000', 'consum', 0.0225, 'lps'),
	(498421, 130, '2014-01-15 00:01:24.000000', 'consum', 0.0224, 'lps'),
	(498422, 130, '2014-01-15 00:01:25.000000', 'consum', 0.0216, 'lps'),
	(498423, 130, '2014-01-15 00:01:26.000000', 'consum', 0.0219, 'lps'),
	(498424, 130, '2014-01-15 00:01:27.000000', 'consum', 0.0217, 'lps'),
	(498425, 130, '2014-01-15 00:01:28.000000', 'consum', 0.0221, 'lps'),
	(498426, 130, '2014-01-15 00:01:29.000000', 'consum', 0.0225, 'lps'),
	(498427, 130, '2014-01-15 00:01:30.000000', 'consum', 0.0220, 'lps'),
	(498428, 130, '2014-01-15 00:01:31.000000', 'consum', 0.0217, 'lps'),
	(498429, 130, '2014-01-15 00:01:32.000000', 'consum', 0.0215, 'lps'),
	(498430, 130, '2014-01-15 00:01:33.000000', 'consum', 0.0214, 'lps'),
	(498431, 130, '2014-01-15 00:01:34.000000', 'consum', 0.0215, 'lps'),
	(498432, 130, '2014-01-15 00:01:35.000000', 'consum', 0.0223, 'lps'),
	(498433, 130, '2014-01-15 00:01:36.000000', 'consum', 0.0211, 'lps'),
	(498434, 130, '2014-01-15 00:01:37.000000', 'consum', 0.0226, 'lps'),
	(498435, 130, '2014-01-15 00:01:38.000000', 'consum', 0.0221, 'lps'),
	(498436, 130, '2014-01-15 00:01:39.000000', 'consum', 0.0216, 'lps'),
	(498437, 130, '2014-01-15 00:01:40.000000', 'consum', 0.0225, 'lps'),
	(498438, 130, '2014-01-15 00:01:41.000000', 'consum', 0.0218, 'lps'),
	(498439, 130, '2014-01-15 00:01:42.000000', 'consum', 0.0223, 'lps'),
	(498440, 130, '2014-01-15 00:01:43.000000', 'consum', 0.0216, 'lps'),
	(498441, 130, '2014-01-15 00:01:44.000000', 'consum', 0.0218, 'lps'),
	(498442, 130, '2014-01-15 00:01:45.000000', 'consum', 0.0216, 'lps'),
	(498443, 130, '2014-01-15 00:01:46.000000', 'consum', 0.0217, 'lps'),
	(498444, 130, '2014-01-15 00:01:47.000000', 'consum', 0.0226, 'lps'),
	(498445, 130, '2014-01-15 00:01:48.000000', 'consum', 0.0220, 'lps'),
	(498446, 130, '2014-01-15 00:01:49.000000', 'consum', 0.0211, 'lps'),
	(498447, 130, '2014-01-15 00:01:50.000000', 'consum', 0.0220, 'lps'),
	(498448, 130, '2014-01-15 00:01:51.000000', 'consum', 0.0226, 'lps'),
	(498449, 130, '2014-01-15 00:01:52.000000', 'consum', 0.0224, 'lps'),
	(498450, 130, '2014-01-15 00:01:53.000000', 'consum', 0.0216, 'lps'),
	(498451, 130, '2014-01-15 00:01:54.000000', 'consum', 0.0214, 'lps'),
	(498452, 130, '2014-01-15 00:01:55.000000', 'consum', 0.0215, 'lps'),
	(498453, 130, '2014-01-15 00:01:56.000000', 'consum', 0.0223, 'lps'),
	(498454, 130, '2014-01-15 00:01:57.000000', 'consum', 0.0225, 'lps'),
	(498455, 130, '2014-01-15 00:01:58.000000', 'consum', 0.0214, 'lps'),
	(498456, 130, '2014-01-15 00:01:59.000000', 'consum', 0.0221, 'lps'),
	(498457, 130, '2014-01-15 00:02:00.000000', 'consum', 0.0218, 'lps'),
	(498458, 130, '2014-01-15 00:02:01.000000', 'consum', 0.0219, 'lps'),
	(498459, 130, '2014-01-15 00:02:02.000000', 'consum', 0.0213, 'lps'),
	(498460, 130, '2014-01-15 00:02:03.000000', 'consum', 0.0217, 'lps'),
	(498461, 130, '2014-01-15 00:02:04.000000', 'consum', 0.0219, 'lps'),
	(498462, 130, '2014-01-15 00:02:05.000000', 'consum', 0.0217, 'lps'),
	(498463, 130, '2014-01-15 00:02:06.000000', 'consum', 0.0221, 'lps'),
	(498464, 130, '2014-01-15 00:02:07.000000', 'consum', 0.0224, 'lps'),
	(498465, 130, '2014-01-15 00:02:08.000000', 'consum', 0.0215, 'lps'),
	(498466, 130, '2014-01-15 00:02:09.000000', 'consum', 0.0210, 'lps'),
	(498467, 130, '2014-01-15 00:02:10.000000', 'consum', 0.0213, 'lps'),
	(498468, 130, '2014-01-15 00:02:11.000000', 'consum', 0.0226, 'lps'),
	(498469, 130, '2014-01-15 00:02:12.000000', 'consum', 0.0212, 'lps'),
	(498470, 130, '2014-01-15 00:02:13.000000', 'consum', 0.0223, 'lps'),
	(498471, 130, '2014-01-15 00:02:14.000000', 'consum', 0.0221, 'lps'),
	(498472, 130, '2014-01-15 00:02:15.000000', 'consum', 0.0225, 'lps'),
	(498473, 130, '2014-01-15 00:02:16.000000', 'consum', 0.0221, 'lps'),
	(498474, 130, '2014-01-15 00:02:17.000000', 'consum', 0.0218, 'lps'),
	(498475, 130, '2014-01-15 00:02:18.000000', 'consum', 0.0216, 'lps'),
	(498476, 130, '2014-01-15 00:02:19.000000', 'consum', 0.0218, 'lps'),
	(498477, 130, '2014-01-15 00:02:20.000000', 'consum', 0.0216, 'lps'),
	(498478, 130, '2014-01-15 00:02:21.000000', 'consum', 0.0217, 'lps'),
	(498479, 130, '2014-01-15 00:02:22.000000', 'consum', 0.0226, 'lps'),
	(498480, 130, '2014-01-15 00:02:23.000000', 'consum', 0.0218, 'lps'),
	(498481, 130, '2014-01-15 00:02:24.000000', 'consum', 0.0220, 'lps'),
	(498482, 130, '2014-01-15 00:02:25.000000', 'consum', 0.0218, 'lps'),
	(498483, 130, '2014-01-15 00:02:26.000000', 'consum', 0.0223, 'lps'),
	(498484, 130, '2014-01-15 00:02:27.000000', 'consum', 0.0215, 'lps'),
	(498485, 130, '2014-01-15 00:02:28.000000', 'consum', 0.0216, 'lps'),
	(498486, 130, '2014-01-15 00:02:29.000000', 'consum', 0.0224, 'lps'),
	(498487, 130, '2014-01-15 00:02:30.000000', 'consum', 0.0212, 'lps'),
	(498488, 130, '2014-01-15 00:02:31.000000', 'consum', 0.0212, 'lps'),
	(498489, 130, '2014-01-15 00:02:32.000000', 'consum', 0.0215, 'lps'),
	(498490, 130, '2014-01-15 00:02:33.000000', 'consum', 0.0213, 'lps'),
	(498491, 130, '2014-01-15 00:02:34.000000', 'consum', 0.0212, 'lps'),
	(498492, 130, '2014-01-15 00:02:35.000000', 'consum', 0.0211, 'lps'),
	(498493, 130, '2014-01-15 00:02:36.000000', 'consum', 0.0225, 'lps'),
	(498494, 130, '2014-01-15 00:02:37.000000', 'consum', 0.0217, 'lps'),
	(498495, 130, '2014-01-15 00:02:38.000000', 'consum', 0.0217, 'lps'),
	(498496, 130, '2014-01-15 00:02:39.000000', 'consum', 0.0224, 'lps'),
	(498497, 130, '2014-01-15 00:02:40.000000', 'consum', 0.0211, 'lps'),
	(498498, 130, '2014-01-15 00:02:41.000000', 'consum', 0.0221, 'lps'),
	(498499, 130, '2014-01-15 00:02:42.000000', 'consum', 0.0212, 'lps'),
	(498500, 130, '2014-01-15 00:02:43.000000', 'consum', 0.0220, 'lps'),
	(498501, 130, '2014-01-15 00:02:44.000000', 'consum', 0.0222, 'lps'),
	(498502, 130, '2014-01-15 00:02:45.000000', 'consum', 0.0224, 'lps'),
	(498503, 130, '2014-01-15 00:02:46.000000', 'consum', 0.0211, 'lps'),
	(498504, 130, '2014-01-15 00:02:47.000000', 'consum', 0.0225, 'lps'),
	(498505, 130, '2014-01-15 00:02:48.000000', 'consum', 0.0213, 'lps'),
	(498506, 130, '2014-01-15 00:02:49.000000', 'consum', 0.0217, 'lps'),
	(498507, 130, '2014-01-15 00:02:50.000000', 'consum', 0.0217, 'lps'),
	(498508, 130, '2014-01-15 00:02:51.000000', 'consum', 0.0224, 'lps'),
	(498509, 130, '2014-01-15 00:02:52.000000', 'consum', 0.0225, 'lps'),
	(498510, 130, '2014-01-15 00:02:53.000000', 'consum', 0.0210, 'lps'),
	(498511, 130, '2014-01-15 00:02:54.000000', 'consum', 0.0217, 'lps'),
	(498512, 130, '2014-01-15 00:02:55.000000', 'consum', 0.0212, 'lps'),
	(498513, 130, '2014-01-15 00:02:56.000000', 'consum', 0.0215, 'lps'),
	(498514, 130, '2014-01-15 00:02:57.000000', 'consum', 0.0211, 'lps'),
	(498515, 130, '2014-01-15 00:02:58.000000', 'consum', 0.0220, 'lps'),
	(498516, 130, '2014-01-15 00:02:59.000000', 'consum', 0.0222, 'lps'),
	(498517, 130, '2014-01-15 00:03:00.000000', 'consum', 0.0225, 'lps'),
	(498518, 130, '2014-01-15 00:03:01.000000', 'consum', 0.0214, 'lps'),
	(498519, 130, '2014-01-15 00:03:02.000000', 'consum', 0.0220, 'lps'),
	(498520, 130, '2014-01-15 00:03:03.000000', 'consum', 0.0216, 'lps'),
	(498521, 130, '2014-01-15 00:03:04.000000', 'consum', 0.0226, 'lps'),
	(498522, 130, '2014-01-15 00:03:05.000000', 'consum', 0.0222, 'lps'),
	(498523, 130, '2014-01-15 00:03:06.000000', 'consum', 0.0223, 'lps'),
	(498524, 130, '2014-01-15 00:03:07.000000', 'consum', 0.0221, 'lps'),
	(498525, 130, '2014-01-15 00:03:08.000000', 'consum', 0.0226, 'lps'),
	(498526, 130, '2014-01-15 00:03:09.000000', 'consum', 0.0224, 'lps'),
	(498527, 130, '2014-01-15 00:03:10.000000', 'consum', 0.0216, 'lps'),
	(498528, 130, '2014-01-15 00:03:11.000000', 'consum', 0.0215, 'lps'),
	(498529, 130, '2014-01-15 00:03:12.000000', 'consum', 0.0218, 'lps'),
	(498530, 130, '2014-01-15 00:03:13.000000', 'consum', 0.0217, 'lps'),
	(498531, 130, '2014-01-15 00:03:14.000000', 'consum', 0.0224, 'lps'),
	(498532, 130, '2014-01-15 00:03:15.000000', 'consum', 0.0225, 'lps'),
	(498533, 130, '2014-01-15 00:03:16.000000', 'consum', 0.0210, 'lps'),
	(498534, 130, '2014-01-15 00:03:17.000000', 'consum', 0.0216, 'lps'),
	(498535, 130, '2014-01-15 00:03:18.000000', 'consum', 0.0222, 'lps'),
	(498536, 130, '2014-01-15 00:03:19.000000', 'consum', 0.0219, 'lps'),
	(498537, 130, '2014-01-15 00:03:20.000000', 'consum', 0.0218, 'lps'),
	(498538, 130, '2014-01-15 00:03:21.000000', 'consum', 0.0224, 'lps'),
	(498539, 130, '2014-01-15 00:03:22.000000', 'consum', 0.0225, 'lps'),
	(498540, 130, '2014-01-15 00:03:23.000000', 'consum', 0.0224, 'lps'),
	(498541, 130, '2014-01-15 00:03:24.000000', 'consum', 0.0217, 'lps'),
	(498542, 130, '2014-01-15 00:03:25.000000', 'consum', 0.0223, 'lps'),
	(498543, 130, '2014-01-15 00:03:26.000000', 'consum', 0.0221, 'lps'),
	(498544, 130, '2014-01-15 00:03:27.000000', 'consum', 0.0225, 'lps'),
	(498545, 130, '2014-01-15 00:03:28.000000', 'consum', 0.0221, 'lps'),
	(498546, 130, '2014-01-15 00:03:29.000000', 'consum', 0.0217, 'lps'),
	(498547, 130, '2014-01-15 00:03:30.000000', 'consum', 0.0215, 'lps'),
	(498548, 130, '2014-01-15 00:03:31.000000', 'consum', 0.0214, 'lps'),
	(498549, 130, '2014-01-15 00:03:32.000000', 'consum', 0.0216, 'lps'),
	(498550, 130, '2014-01-15 00:03:33.000000', 'consum', 0.0213, 'lps'),
	(498551, 130, '2014-01-15 00:03:34.000000', 'consum', 0.0222, 'lps'),
	(498552, 130, '2014-01-15 00:03:35.000000', 'consum', 0.0212, 'lps'),
	(498553, 130, '2014-01-15 00:03:36.000000', 'consum', 0.0219, 'lps'),
	(498554, 130, '2014-01-15 00:03:37.000000', 'consum', 0.0216, 'lps'),
	(498555, 130, '2014-01-15 00:03:38.000000', 'consum', 0.0211, 'lps'),
	(498556, 130, '2014-01-15 00:03:39.000000', 'consum', 0.0216, 'lps'),
	(498557, 130, '2014-01-15 00:03:40.000000', 'consum', 0.0222, 'lps'),
	(498558, 130, '2014-01-15 00:03:41.000000', 'consum', 0.0215, 'lps'),
	(498559, 130, '2014-01-15 00:03:42.000000', 'consum', 0.0219, 'lps'),
	(498560, 130, '2014-01-15 00:03:43.000000', 'consum', 0.0222, 'lps'),
	(498561, 130, '2014-01-15 00:03:44.000000', 'consum', 0.0226, 'lps'),
	(498562, 130, '2014-01-15 00:03:45.000000', 'consum', 0.0222, 'lps'),
	(498563, 130, '2014-01-15 00:03:46.000000', 'consum', 0.0223, 'lps'),
	(498564, 130, '2014-01-15 00:03:47.000000', 'consum', 0.0221, 'lps'),
	(498565, 130, '2014-01-15 00:03:48.000000', 'consum', 0.0212, 'lps'),
	(498566, 130, '2014-01-15 00:03:49.000000', 'consum', 0.0218, 'lps'),
	(498567, 130, '2014-01-15 00:03:50.000000', 'consum', 0.0213, 'lps'),
	(498568, 130, '2014-01-15 00:03:51.000000', 'consum', 0.0218, 'lps'),
	(498569, 130, '2014-01-15 00:03:52.000000', 'consum', 0.0225, 'lps'),
	(498570, 130, '2014-01-15 00:03:53.000000', 'consum', 0.0211, 'lps'),
	(498571, 130, '2014-01-15 00:03:54.000000', 'consum', 0.0221, 'lps'),
	(498572, 130, '2014-01-15 00:03:55.000000', 'consum', 0.0211, 'lps'),
	(498573, 130, '2014-01-15 00:03:56.000000', 'consum', 0.0215, 'lps'),
	(498574, 130, '2014-01-15 00:03:57.000000', 'consum', 0.0217, 'lps'),
	(498575, 130, '2014-01-15 00:03:58.000000', 'consum', 0.0215, 'lps'),
	(498576, 130, '2014-01-15 00:03:59.000000', 'consum', 0.0212, 'lps'),
	(498577, 130, '2014-01-15 00:04:00.000000', 'consum', 0.0221, 'lps'),
	(498578, 130, '2014-01-15 00:04:01.000000', 'consum', 0.0211, 'lps'),
	(498579, 130, '2014-01-15 00:04:02.000000', 'consum', 0.0218, 'lps'),
	(498580, 130, '2014-01-15 00:04:03.000000', 'consum', 0.0212, 'lps'),
	(498581, 130, '2014-01-15 00:04:04.000000', 'consum', 0.0213, 'lps'),
	(498582, 130, '2014-01-15 00:04:05.000000', 'consum', 0.0220, 'lps'),
	(498583, 130, '2014-01-15 00:04:06.000000', 'consum', 0.0216, 'lps'),
	(498584, 130, '2014-01-15 00:04:07.000000', 'consum', 0.0210, 'lps'),
	(498585, 130, '2014-01-15 00:04:08.000000', 'consum', 0.0211, 'lps'),
	(498586, 130, '2014-01-15 00:04:09.000000', 'consum', 0.0215, 'lps'),
	(498587, 130, '2014-01-15 00:04:10.000000', 'consum', 0.0216, 'lps'),
	(498588, 130, '2014-01-15 00:04:11.000000', 'consum', 0.0224, 'lps'),
	(498589, 130, '2014-01-15 00:04:12.000000', 'consum', 0.0214, 'lps'),
	(498590, 130, '2014-01-15 00:04:13.000000', 'consum', 0.0221, 'lps'),
	(498591, 130, '2014-01-15 00:04:14.000000', 'consum', 0.0221, 'lps'),
	(498592, 130, '2014-01-15 00:04:15.000000', 'consum', 0.0216, 'lps'),
	(498593, 130, '2014-01-15 00:04:16.000000', 'consum', 0.0222, 'lps'),
	(498594, 130, '2014-01-15 00:04:17.000000', 'consum', 0.0218, 'lps'),
	(498595, 130, '2014-01-15 00:04:18.000000', 'consum', 0.0214, 'lps'),
	(498596, 130, '2014-01-15 00:04:19.000000', 'consum', 0.0225, 'lps'),
	(498597, 130, '2014-01-15 00:04:20.000000', 'consum', 0.0223, 'lps'),
	(498598, 130, '2014-01-15 00:04:21.000000', 'consum', 0.0214, 'lps'),
	(498599, 130, '2014-01-15 00:04:22.000000', 'consum', 0.0223, 'lps'),
	(498600, 130, '2014-01-15 00:04:23.000000', 'consum', 0.0215, 'lps'),
	(498601, 130, '2014-01-15 00:04:24.000000', 'consum', 0.0213, 'lps'),
	(498602, 130, '2014-01-15 00:04:25.000000', 'consum', 0.0210, 'lps'),
	(498603, 130, '2014-01-15 00:04:26.000000', 'consum', 0.0220, 'lps'),
	(498604, 130, '2014-01-15 00:04:27.000000', 'consum', 0.0225, 'lps'),
	(498605, 130, '2014-01-15 00:04:28.000000', 'consum', 0.0220, 'lps'),
	(498606, 130, '2014-01-15 00:04:29.000000', 'consum', 0.0218, 'lps'),
	(498607, 130, '2014-01-15 00:04:30.000000', 'consum', 0.0219, 'lps'),
	(498608, 130, '2014-01-15 00:04:31.000000', 'consum', 0.0213, 'lps'),
	(498609, 130, '2014-01-15 00:04:32.000000', 'consum', 0.0218, 'lps'),
	(498610, 130, '2014-01-15 00:04:33.000000', 'consum', 0.0224, 'lps'),
	(498611, 130, '2014-01-15 00:04:34.000000', 'consum', 0.0222, 'lps'),
	(498612, 130, '2014-01-15 00:04:35.000000', 'consum', 0.0213, 'lps'),
	(498613, 130, '2014-01-15 00:04:36.000000', 'consum', 0.0223, 'lps'),
	(498614, 130, '2014-01-15 00:04:37.000000', 'consum', 0.0217, 'lps'),
	(498615, 130, '2014-01-15 00:04:38.000000', 'consum', 0.0221, 'lps'),
	(498616, 130, '2014-01-15 00:04:39.000000', 'consum', 0.0213, 'lps'),
	(498617, 130, '2014-01-15 00:04:40.000000', 'consum', 0.0226, 'lps'),
	(498618, 130, '2014-01-15 00:04:41.000000', 'consum', 0.0215, 'lps'),
	(498619, 130, '2014-01-15 00:04:42.000000', 'consum', 0.0220, 'lps'),
	(498620, 130, '2014-01-15 00:04:43.000000', 'consum', 0.0214, 'lps'),
	(498621, 130, '2014-01-15 00:04:44.000000', 'consum', 0.0214, 'lps'),
	(498622, 130, '2014-01-15 00:04:45.000000', 'consum', 0.0220, 'lps'),
	(498623, 130, '2014-01-15 00:04:46.000000', 'consum', 0.0215, 'lps'),
	(498624, 130, '2014-01-15 00:04:47.000000', 'consum', 0.0223, 'lps'),
	(498625, 130, '2014-01-15 00:04:48.000000', 'consum', 0.0210, 'lps'),
	(498626, 130, '2014-01-15 00:04:49.000000', 'consum', 0.0220, 'lps'),
	(498627, 130, '2014-01-15 00:04:50.000000', 'consum', 0.0212, 'lps'),
	(498628, 130, '2014-01-15 00:04:51.000000', 'consum', 0.0224, 'lps'),
	(498629, 130, '2014-01-15 00:04:52.000000', 'consum', 0.0225, 'lps'),
	(498630, 130, '2014-01-15 00:04:53.000000', 'consum', 0.0223, 'lps'),
	(498631, 130, '2014-01-15 00:04:54.000000', 'consum', 0.0217, 'lps'),
	(498632, 130, '2014-01-15 00:04:55.000000', 'consum', 0.0222, 'lps'),
	(498633, 130, '2014-01-15 00:04:56.000000', 'consum', 0.0217, 'lps'),
	(498634, 130, '2014-01-15 00:04:57.000000', 'consum', 0.0224, 'lps'),
	(498635, 130, '2014-01-15 00:04:58.000000', 'consum', 0.0211, 'lps'),
	(498636, 130, '2014-01-15 00:04:59.000000', 'consum', 0.0224, 'lps'),
	(498637, 130, '2014-01-15 00:05:00.000000', 'consum', 0.0210, 'lps'),
	(498638, 130, '2014-01-15 00:05:01.000000', 'consum', 0.0220, 'lps'),
	(498639, 130, '2014-01-15 00:05:02.000000', 'consum', 0.0226, 'lps'),
	(498640, 130, '2014-01-15 00:05:03.000000', 'consum', 0.0225, 'lps'),
	(498641, 130, '2014-01-15 00:05:04.000000', 'consum', 0.0221, 'lps'),
	(498642, 130, '2014-01-15 00:05:05.000000', 'consum', 0.0221, 'lps'),
	(498643, 130, '2014-01-15 00:05:06.000000', 'consum', 0.0217, 'lps'),
	(498644, 130, '2014-01-15 00:05:07.000000', 'consum', 0.0211, 'lps'),
	(498645, 130, '2014-01-15 00:05:08.000000', 'consum', 0.0212, 'lps'),
	(498646, 130, '2014-01-15 00:05:09.000000', 'consum', 0.0216, 'lps'),
	(498647, 130, '2014-01-15 00:05:10.000000', 'consum', 0.0220, 'lps'),
	(498648, 130, '2014-01-15 00:05:11.000000', 'consum', 0.0225, 'lps'),
	(498649, 130, '2014-01-15 00:05:12.000000', 'consum', 0.0219, 'lps'),
	(498650, 130, '2014-01-15 00:05:13.000000', 'consum', 0.0213, 'lps'),
	(498651, 130, '2014-01-15 00:05:14.000000', 'consum', 0.0215, 'lps'),
	(498652, 130, '2014-01-15 00:05:15.000000', 'consum', 0.0210, 'lps'),
	(498653, 130, '2014-01-15 00:05:16.000000', 'consum', 0.0214, 'lps'),
	(498654, 130, '2014-01-15 00:05:17.000000', 'consum', 0.0210, 'lps'),
	(498655, 130, '2014-01-15 00:05:18.000000', 'consum', 0.0218, 'lps'),
	(498656, 130, '2014-01-15 00:05:19.000000', 'consum', 0.0214, 'lps'),
	(498657, 130, '2014-01-15 00:05:20.000000', 'consum', 0.0226, 'lps'),
	(498658, 130, '2014-01-15 00:05:21.000000', 'consum', 0.0225, 'lps'),
	(498659, 130, '2014-01-15 00:05:22.000000', 'consum', 0.0221, 'lps'),
	(498660, 130, '2014-01-15 00:05:23.000000', 'consum', 0.0220, 'lps'),
	(498661, 130, '2014-01-15 00:05:24.000000', 'consum', 0.0212, 'lps'),
	(498662, 130, '2014-01-15 00:05:25.000000', 'consum', 0.0226, 'lps'),
	(498663, 130, '2014-01-15 00:05:26.000000', 'consum', 0.0214, 'lps'),
	(498664, 130, '2014-01-15 00:05:27.000000', 'consum', 0.0219, 'lps'),
	(498665, 130, '2014-01-15 00:05:28.000000', 'consum', 0.0223, 'lps'),
	(498666, 130, '2014-01-15 00:05:29.000000', 'consum', 0.0218, 'lps'),
	(498667, 130, '2014-01-15 00:05:30.000000', 'consum', 0.0210, 'lps'),
	(498668, 130, '2014-01-15 00:05:31.000000', 'consum', 0.0219, 'lps'),
	(498669, 130, '2014-01-15 00:05:32.000000', 'consum', 0.0223, 'lps'),
	(498670, 130, '2014-01-15 00:05:33.000000', 'consum', 0.0214, 'lps'),
	(498671, 130, '2014-01-15 00:05:34.000000', 'consum', 0.0210, 'lps'),
	(498672, 130, '2014-01-15 00:05:35.000000', 'consum', 0.0214, 'lps'),
	(498673, 130, '2014-01-15 00:05:36.000000', 'consum', 0.0214, 'lps'),
	(498674, 130, '2014-01-15 00:05:37.000000', 'consum', 0.0219, 'lps'),
	(498675, 130, '2014-01-15 00:05:38.000000', 'consum', 0.0210, 'lps'),
	(498676, 130, '2014-01-15 00:05:39.000000', 'consum', 0.0215, 'lps'),
	(498677, 130, '2014-01-15 00:05:40.000000', 'consum', 0.0219, 'lps'),
	(498678, 130, '2014-01-15 00:05:41.000000', 'consum', 0.0226, 'lps'),
	(498679, 130, '2014-01-15 00:05:42.000000', 'consum', 0.0226, 'lps'),
	(498680, 130, '2014-01-15 00:05:43.000000', 'consum', 0.0210, 'lps'),
	(498681, 130, '2014-01-15 00:05:44.000000', 'consum', 0.0215, 'lps'),
	(498682, 130, '2014-01-15 00:05:45.000000', 'consum', 0.0217, 'lps'),
	(498683, 130, '2014-01-15 00:05:46.000000', 'consum', 0.0212, 'lps'),
	(498684, 130, '2014-01-15 00:05:47.000000', 'consum', 0.0218, 'lps'),
	(498685, 130, '2014-01-15 00:05:48.000000', 'consum', 0.0212, 'lps'),
	(498686, 130, '2014-01-15 00:05:49.000000', 'consum', 0.0211, 'lps'),
	(498687, 130, '2014-01-15 00:05:50.000000', 'consum', 0.0212, 'lps'),
	(498688, 130, '2014-01-15 00:05:51.000000', 'consum', 0.0218, 'lps'),
	(498689, 130, '2014-01-15 00:05:52.000000', 'consum', 0.0226, 'lps'),
	(498690, 130, '2014-01-15 00:05:53.000000', 'consum', 0.0214, 'lps'),
	(498691, 130, '2014-01-15 00:05:54.000000', 'consum', 0.0219, 'lps'),
	(498692, 130, '2014-01-15 00:05:55.000000', 'consum', 0.0224, 'lps'),
	(498693, 130, '2014-01-15 00:05:56.000000', 'consum', 0.0219, 'lps'),
	(498694, 130, '2014-01-15 00:05:57.000000', 'consum', 0.0214, 'lps'),
	(498695, 130, '2014-01-15 00:05:58.000000', 'consum', 0.0221, 'lps'),
	(498696, 130, '2014-01-15 00:05:59.000000', 'consum', 0.0219, 'lps'),
	(498697, 130, '2014-01-15 00:06:00.000000', 'consum', 0.0223, 'lps'),
	(498698, 130, '2014-01-15 00:06:01.000000', 'consum', 0.0213, 'lps'),
	(498699, 130, '2014-01-15 00:06:02.000000', 'consum', 0.0222, 'lps'),
	(498700, 130, '2014-01-15 00:06:03.000000', 'consum', 0.0210, 'lps'),
	(498701, 130, '2014-01-15 00:06:04.000000', 'consum', 0.0225, 'lps'),
	(498702, 130, '2014-01-15 00:06:05.000000', 'consum', 0.0217, 'lps'),
	(498703, 130, '2014-01-15 00:06:06.000000', 'consum', 0.0218, 'lps'),
	(498704, 130, '2014-01-15 00:06:07.000000', 'consum', 0.0214, 'lps'),
	(498705, 130, '2014-01-15 00:06:08.000000', 'consum', 0.0224, 'lps'),
	(498706, 130, '2014-01-15 00:06:09.000000', 'consum', 0.0214, 'lps'),
	(498707, 130, '2014-01-15 00:06:10.000000', 'consum', 0.0226, 'lps'),
	(498708, 130, '2014-01-15 00:06:11.000000', 'consum', 0.0210, 'lps'),
	(498709, 130, '2014-01-15 00:06:12.000000', 'consum', 0.0212, 'lps'),
	(498710, 130, '2014-01-15 00:06:13.000000', 'consum', 0.0221, 'lps'),
	(498711, 130, '2014-01-15 00:06:14.000000', 'consum', 0.0211, 'lps'),
	(498712, 130, '2014-01-15 00:06:15.000000', 'consum', 0.0214, 'lps'),
	(498713, 130, '2014-01-15 00:06:16.000000', 'consum', 0.0210, 'lps'),
	(498714, 130, '2014-01-15 00:06:17.000000', 'consum', 0.0216, 'lps'),
	(498715, 130, '2014-01-15 00:06:18.000000', 'consum', 0.0225, 'lps'),
	(498716, 130, '2014-01-15 00:06:19.000000', 'consum', 0.0215, 'lps'),
	(498717, 130, '2014-01-15 00:06:20.000000', 'consum', 0.0226, 'lps'),
	(498718, 130, '2014-01-15 00:06:21.000000', 'consum', 0.0222, 'lps'),
	(498719, 130, '2014-01-15 00:06:22.000000', 'consum', 0.0226, 'lps'),
	(498720, 130, '2014-01-15 00:06:23.000000', 'consum', 0.0218, 'lps'),
	(498721, 130, '2014-01-15 00:06:24.000000', 'consum', 0.0219, 'lps'),
	(498722, 130, '2014-01-15 00:06:25.000000', 'consum', 0.0216, 'lps'),
	(498723, 130, '2014-01-15 00:06:26.000000', 'consum', 0.0213, 'lps'),
	(498724, 130, '2014-01-15 00:06:27.000000', 'consum', 0.0225, 'lps'),
	(498725, 130, '2014-01-15 00:06:28.000000', 'consum', 0.0225, 'lps'),
	(498726, 130, '2014-01-15 00:06:29.000000', 'consum', 0.0225, 'lps'),
	(498727, 130, '2014-01-15 00:06:30.000000', 'consum', 0.0223, 'lps'),
	(498728, 130, '2014-01-15 00:06:31.000000', 'consum', 0.0213, 'lps'),
	(498729, 130, '2014-01-15 00:06:32.000000', 'consum', 0.0221, 'lps'),
	(498730, 130, '2014-01-15 00:06:33.000000', 'consum', 0.0223, 'lps'),
	(498731, 130, '2014-01-15 00:06:34.000000', 'consum', 0.0226, 'lps'),
	(498732, 130, '2014-01-15 00:06:35.000000', 'consum', 0.0216, 'lps'),
	(498733, 130, '2014-01-15 00:06:36.000000', 'consum', 0.0210, 'lps'),
	(498734, 130, '2014-01-15 00:06:37.000000', 'consum', 0.0224, 'lps'),
	(498735, 130, '2014-01-15 00:06:38.000000', 'consum', 0.0216, 'lps'),
	(498736, 130, '2014-01-15 00:06:39.000000', 'consum', 0.0215, 'lps'),
	(498737, 130, '2014-01-15 00:06:40.000000', 'consum', 0.0217, 'lps'),
	(498738, 130, '2014-01-15 00:06:41.000000', 'consum', 0.0215, 'lps'),
	(498739, 130, '2014-01-15 00:06:42.000000', 'consum', 0.0212, 'lps'),
	(498740, 130, '2014-01-15 00:06:43.000000', 'consum', 0.0226, 'lps'),
	(498741, 130, '2014-01-15 00:06:44.000000', 'consum', 0.0213, 'lps'),
	(498742, 130, '2014-01-15 00:06:45.000000', 'consum', 0.0211, 'lps'),
	(498743, 130, '2014-01-15 00:06:46.000000', 'consum', 0.0210, 'lps'),
	(498744, 130, '2014-01-15 00:06:47.000000', 'consum', 0.0222, 'lps'),
	(498745, 130, '2014-01-15 00:06:48.000000', 'consum', 0.0220, 'lps'),
	(498746, 130, '2014-01-15 00:06:49.000000', 'consum', 0.0223, 'lps'),
	(498747, 130, '2014-01-15 00:06:50.000000', 'consum', 0.0214, 'lps'),
	(498748, 130, '2014-01-15 00:06:51.000000', 'consum', 0.0224, 'lps'),
	(498749, 130, '2014-01-15 00:06:52.000000', 'consum', 0.0218, 'lps'),
	(498750, 130, '2014-01-15 00:06:53.000000', 'consum', 0.0224, 'lps'),
	(498751, 130, '2014-01-15 00:06:54.000000', 'consum', 0.0225, 'lps'),
	(498752, 130, '2014-01-15 00:06:55.000000', 'consum', 0.0224, 'lps'),
	(498753, 130, '2014-01-15 00:06:56.000000', 'consum', 0.0219, 'lps'),
	(498754, 130, '2014-01-15 00:06:57.000000', 'consum', 0.0213, 'lps'),
	(498755, 130, '2014-01-15 00:06:58.000000', 'consum', 0.0216, 'lps'),
	(498756, 130, '2014-01-15 00:06:59.000000', 'consum', 0.0214, 'lps'),
	(498757, 130, '2014-01-15 00:07:00.000000', 'consum', 0.0215, 'lps'),
	(498758, 130, '2014-01-15 00:07:01.000000', 'consum', 0.0221, 'lps'),
	(498759, 130, '2014-01-15 00:07:02.000000', 'consum', 0.0215, 'lps'),
	(498760, 130, '2014-01-15 00:07:03.000000', 'consum', 0.0222, 'lps'),
	(498761, 130, '2014-01-15 00:07:04.000000', 'consum', 0.0220, 'lps'),
	(498762, 130, '2014-01-15 00:07:05.000000', 'consum', 0.0225, 'lps'),
	(498763, 130, '2014-01-15 00:07:06.000000', 'consum', 0.0221, 'lps'),
	(498764, 130, '2014-01-15 00:07:07.000000', 'consum', 0.0219, 'lps'),
	(498765, 130, '2014-01-15 00:07:08.000000', 'consum', 0.0226, 'lps'),
	(498766, 130, '2014-01-15 00:07:09.000000', 'consum', 0.0226, 'lps'),
	(498767, 130, '2014-01-15 00:07:10.000000', 'consum', 0.0212, 'lps'),
	(498768, 130, '2014-01-15 00:07:11.000000', 'consum', 0.0220, 'lps'),
	(498769, 130, '2014-01-15 00:07:12.000000', 'consum', 0.0223, 'lps'),
	(498770, 130, '2014-01-15 00:07:13.000000', 'consum', 0.0226, 'lps'),
	(498771, 130, '2014-01-15 00:07:14.000000', 'consum', 0.0219, 'lps'),
	(498772, 130, '2014-01-15 00:07:15.000000', 'consum', 0.0224, 'lps'),
	(498773, 130, '2014-01-15 00:07:16.000000', 'consum', 0.0218, 'lps'),
	(498774, 130, '2014-01-15 00:07:17.000000', 'consum', 0.0226, 'lps'),
	(498775, 130, '2014-01-15 00:07:18.000000', 'consum', 0.0215, 'lps'),
	(498776, 130, '2014-01-15 00:07:19.000000', 'consum', 0.0224, 'lps'),
	(498777, 130, '2014-01-15 00:07:20.000000', 'consum', 0.0213, 'lps'),
	(498778, 130, '2014-01-15 00:07:21.000000', 'consum', 0.0217, 'lps'),
	(498779, 130, '2014-01-15 00:07:22.000000', 'consum', 0.0219, 'lps'),
	(498780, 130, '2014-01-15 00:07:23.000000', 'consum', 0.0217, 'lps'),
	(498781, 130, '2014-01-15 00:07:24.000000', 'consum', 0.0219, 'lps'),
	(498782, 130, '2014-01-15 00:07:25.000000', 'consum', 0.0217, 'lps'),
	(498783, 130, '2014-01-15 00:07:26.000000', 'consum', 0.0219, 'lps'),
	(498784, 130, '2014-01-15 00:07:27.000000', 'consum', 0.0218, 'lps'),
	(498785, 130, '2014-01-15 00:07:28.000000', 'consum', 0.0222, 'lps'),
	(498786, 130, '2014-01-15 00:07:29.000000', 'consum', 0.0214, 'lps'),
	(498787, 130, '2014-01-15 00:07:30.000000', 'consum', 0.0212, 'lps'),
	(498788, 130, '2014-01-15 00:07:31.000000', 'consum', 0.0225, 'lps'),
	(498789, 130, '2014-01-15 00:07:32.000000', 'consum', 0.0212, 'lps'),
	(498790, 130, '2014-01-15 00:07:33.000000', 'consum', 0.0211, 'lps'),
	(498791, 130, '2014-01-15 00:07:34.000000', 'consum', 0.0225, 'lps'),
	(498792, 130, '2014-01-15 00:07:35.000000', 'consum', 0.0213, 'lps'),
	(498793, 130, '2014-01-15 00:07:36.000000', 'consum', 0.0217, 'lps'),
	(498794, 130, '2014-01-15 00:07:37.000000', 'consum', 0.0218, 'lps'),
	(498795, 130, '2014-01-15 00:07:38.000000', 'consum', 0.0214, 'lps'),
	(498796, 130, '2014-01-15 00:07:39.000000', 'consum', 0.0221, 'lps'),
	(498797, 130, '2014-01-15 00:07:40.000000', 'consum', 0.0221, 'lps'),
	(498798, 130, '2014-01-15 00:07:41.000000', 'consum', 0.0214, 'lps'),
	(498799, 130, '2014-01-15 00:07:42.000000', 'consum', 0.0217, 'lps'),
	(498800, 130, '2014-01-15 00:07:43.000000', 'consum', 0.0214, 'lps'),
	(498801, 130, '2014-01-15 00:07:44.000000', 'consum', 0.0213, 'lps'),
	(498802, 130, '2014-01-15 00:07:45.000000', 'consum', 0.0210, 'lps'),
	(498803, 130, '2014-01-15 00:07:46.000000', 'consum', 0.0218, 'lps'),
	(498804, 130, '2014-01-15 00:07:47.000000', 'consum', 0.0218, 'lps'),
	(498805, 130, '2014-01-15 00:07:48.000000', 'consum', 0.0226, 'lps'),
	(498806, 130, '2014-01-15 00:07:49.000000', 'consum', 0.0217, 'lps'),
	(498807, 130, '2014-01-15 00:07:50.000000', 'consum', 0.0213, 'lps'),
	(498808, 130, '2014-01-15 00:07:51.000000', 'consum', 0.0221, 'lps'),
	(498809, 130, '2014-01-15 00:07:52.000000', 'consum', 0.0221, 'lps'),
	(498810, 130, '2014-01-15 00:07:53.000000', 'consum', 0.0217, 'lps'),
	(498811, 130, '2014-01-15 00:07:54.000000', 'consum', 0.0213, 'lps'),
	(498812, 130, '2014-01-15 00:07:55.000000', 'consum', 0.0221, 'lps'),
	(498813, 130, '2014-01-15 00:07:56.000000', 'consum', 0.0221, 'lps'),
	(498814, 130, '2014-01-15 00:07:57.000000', 'consum', 0.0217, 'lps'),
	(498815, 130, '2014-01-15 00:07:58.000000', 'consum', 0.0212, 'lps'),
	(498816, 130, '2014-01-15 00:07:59.000000', 'consum', 0.0215, 'lps'),
	(498817, 130, '2014-01-15 00:08:00.000000', 'consum', 0.0214, 'lps'),
	(498818, 130, '2014-01-15 00:08:01.000000', 'consum', 0.0216, 'lps'),
	(498819, 130, '2014-01-15 00:08:02.000000', 'consum', 0.0211, 'lps'),
	(498820, 130, '2014-01-15 00:08:03.000000', 'consum', 0.0214, 'lps'),
	(498821, 130, '2014-01-15 00:08:04.000000', 'consum', 0.0212, 'lps'),
	(498822, 130, '2014-01-15 00:08:05.000000', 'consum', 0.0224, 'lps'),
	(498823, 130, '2014-01-15 00:08:06.000000', 'consum', 0.0222, 'lps'),
	(498824, 130, '2014-01-15 00:08:07.000000', 'consum', 0.0214, 'lps'),
	(498825, 130, '2014-01-15 00:08:08.000000', 'consum', 0.0212, 'lps'),
	(498826, 130, '2014-01-15 00:08:09.000000', 'consum', 0.0225, 'lps'),
	(498827, 130, '2014-01-15 00:08:10.000000', 'consum', 0.0212, 'lps'),
	(498828, 130, '2014-01-15 00:08:11.000000', 'consum', 0.0210, 'lps'),
	(498829, 130, '2014-01-15 00:08:12.000000', 'consum', 0.0222, 'lps'),
	(498830, 130, '2014-01-15 00:08:13.000000', 'consum', 0.0217, 'lps'),
	(498831, 130, '2014-01-15 00:08:14.000000', 'consum', 0.0211, 'lps'),
	(498832, 130, '2014-01-15 00:08:15.000000', 'consum', 0.0213, 'lps'),
	(498833, 130, '2014-01-15 00:08:16.000000', 'consum', 0.0223, 'lps'),
	(498834, 130, '2014-01-15 00:08:17.000000', 'consum', 0.0213, 'lps'),
	(498835, 130, '2014-01-15 00:08:18.000000', 'consum', 0.0220, 'lps'),
	(498836, 130, '2014-01-15 00:08:19.000000', 'consum', 0.0217, 'lps'),
	(498837, 130, '2014-01-15 00:08:20.000000', 'consum', 0.0215, 'lps'),
	(498838, 130, '2014-01-15 00:08:21.000000', 'consum', 0.0215, 'lps'),
	(498839, 130, '2014-01-15 00:08:22.000000', 'consum', 0.0220, 'lps'),
	(498840, 130, '2014-01-15 00:08:23.000000', 'consum', 0.0214, 'lps'),
	(498841, 130, '2014-01-15 00:08:24.000000', 'consum', 0.0217, 'lps'),
	(498842, 130, '2014-01-15 00:08:25.000000', 'consum', 0.0218, 'lps'),
	(498843, 130, '2014-01-15 00:08:26.000000', 'consum', 0.0226, 'lps'),
	(498844, 130, '2014-01-15 00:08:27.000000', 'consum', 0.0218, 'lps'),
	(498845, 130, '2014-01-15 00:08:28.000000', 'consum', 0.0219, 'lps'),
	(498846, 130, '2014-01-15 00:08:29.000000', 'consum', 0.0216, 'lps'),
	(498847, 130, '2014-01-15 00:08:30.000000', 'consum', 0.0211, 'lps'),
	(498848, 130, '2014-01-15 00:08:31.000000', 'consum', 0.0217, 'lps'),
	(498849, 130, '2014-01-15 00:08:32.000000', 'consum', 0.0226, 'lps'),
	(498850, 130, '2014-01-15 00:08:33.000000', 'consum', 0.0218, 'lps'),
	(498851, 130, '2014-01-15 00:08:34.000000', 'consum', 0.0218, 'lps'),
	(498852, 130, '2014-01-15 00:08:35.000000', 'consum', 0.0211, 'lps'),
	(498853, 130, '2014-01-15 00:08:36.000000', 'consum', 0.0226, 'lps'),
	(498854, 130, '2014-01-15 00:08:37.000000', 'consum', 0.0221, 'lps'),
	(498855, 130, '2014-01-15 00:08:38.000000', 'consum', 0.0214, 'lps'),
	(498856, 130, '2014-01-15 00:08:39.000000', 'consum', 0.0218, 'lps'),
	(498857, 130, '2014-01-15 00:08:40.000000', 'consum', 0.0219, 'lps'),
	(498858, 130, '2014-01-15 00:08:41.000000', 'consum', 0.0217, 'lps'),
	(498859, 130, '2014-01-15 00:08:42.000000', 'consum', 0.0218, 'lps'),
	(498860, 130, '2014-01-15 00:08:43.000000', 'consum', 0.0211, 'lps'),
	(498861, 130, '2014-01-15 00:08:44.000000', 'consum', 0.0225, 'lps'),
	(498862, 130, '2014-01-15 00:08:45.000000', 'consum', 0.0216, 'lps'),
	(498863, 130, '2014-01-15 00:08:46.000000', 'consum', 0.0213, 'lps'),
	(498864, 130, '2014-01-15 00:08:47.000000', 'consum', 0.0223, 'lps'),
	(498865, 130, '2014-01-15 00:08:48.000000', 'consum', 0.0215, 'lps'),
	(498866, 130, '2014-01-15 00:08:49.000000', 'consum', 0.0216, 'lps'),
	(498867, 130, '2014-01-15 00:08:50.000000', 'consum', 0.0223, 'lps'),
	(498868, 130, '2014-01-15 00:08:51.000000', 'consum', 0.0224, 'lps'),
	(498869, 130, '2014-01-15 00:08:52.000000', 'consum', 0.0210, 'lps'),
	(498870, 130, '2014-01-15 00:08:53.000000', 'consum', 0.0216, 'lps'),
	(498871, 130, '2014-01-15 00:08:54.000000', 'consum', 0.0226, 'lps'),
	(498872, 130, '2014-01-15 00:08:55.000000', 'consum', 0.0222, 'lps'),
	(498873, 130, '2014-01-15 00:08:56.000000', 'consum', 0.0220, 'lps'),
	(498874, 130, '2014-01-15 00:08:57.000000', 'consum', 0.0224, 'lps'),
	(498875, 130, '2014-01-15 00:08:58.000000', 'consum', 0.0218, 'lps'),
	(498876, 130, '2014-01-15 00:08:59.000000', 'consum', 0.0225, 'lps'),
	(498877, 130, '2014-01-15 00:09:00.000000', 'consum', 0.0211, 'lps'),
	(498878, 130, '2014-01-15 00:09:01.000000', 'consum', 0.0220, 'lps'),
	(498879, 130, '2014-01-15 00:09:02.000000', 'consum', 0.0224, 'lps'),
	(498880, 130, '2014-01-15 00:09:03.000000', 'consum', 0.0218, 'lps'),
	(498881, 130, '2014-01-15 00:09:04.000000', 'consum', 0.0224, 'lps'),
	(498882, 130, '2014-01-15 00:09:05.000000', 'consum', 0.0223, 'lps'),
	(498883, 130, '2014-01-15 00:09:06.000000', 'consum', 0.0214, 'lps'),
	(498884, 130, '2014-01-15 00:09:07.000000', 'consum', 0.0212, 'lps'),
	(498885, 130, '2014-01-15 00:09:08.000000', 'consum', 0.0222, 'lps'),
	(498886, 130, '2014-01-15 00:09:09.000000', 'consum', 0.0217, 'lps'),
	(498887, 130, '2014-01-15 00:09:10.000000', 'consum', 0.0225, 'lps'),
	(498888, 130, '2014-01-15 00:09:11.000000', 'consum', 0.0212, 'lps'),
	(498889, 130, '2014-01-15 00:09:12.000000', 'consum', 0.0226, 'lps'),
	(498890, 130, '2014-01-15 00:09:13.000000', 'consum', 0.0220, 'lps'),
	(498891, 130, '2014-01-15 00:09:14.000000', 'consum', 0.0210, 'lps'),
	(498892, 130, '2014-01-15 00:09:15.000000', 'consum', 0.0213, 'lps'),
	(498893, 130, '2014-01-15 00:09:16.000000', 'consum', 0.0211, 'lps'),
	(498894, 130, '2014-01-15 00:09:17.000000', 'consum', 0.0223, 'lps'),
	(498895, 130, '2014-01-15 00:09:18.000000', 'consum', 0.0223, 'lps'),
	(498896, 130, '2014-01-15 00:09:19.000000', 'consum', 0.0219, 'lps'),
	(498897, 130, '2014-01-15 00:09:20.000000', 'consum', 0.0215, 'lps'),
	(498898, 130, '2014-01-15 00:09:21.000000', 'consum', 0.0210, 'lps'),
	(498899, 130, '2014-01-15 00:09:22.000000', 'consum', 0.0213, 'lps'),
	(498900, 130, '2014-01-15 00:09:23.000000', 'consum', 0.0225, 'lps'),
	(498901, 130, '2014-01-15 00:09:24.000000', 'consum', 0.0223, 'lps'),
	(498902, 130, '2014-01-15 00:09:25.000000', 'consum', 0.0217, 'lps'),
	(498903, 130, '2014-01-15 00:09:26.000000', 'consum', 0.0221, 'lps'),
	(498904, 130, '2014-01-15 00:09:27.000000', 'consum', 0.0211, 'lps'),
	(498905, 130, '2014-01-15 00:09:28.000000', 'consum', 0.0215, 'lps'),
	(498906, 130, '2014-01-15 00:09:29.000000', 'consum', 0.0219, 'lps'),
	(498907, 130, '2014-01-15 00:09:30.000000', 'consum', 0.0221, 'lps'),
	(498908, 130, '2014-01-15 00:09:31.000000', 'consum', 0.0220, 'lps'),
	(498909, 130, '2014-01-15 00:09:32.000000', 'consum', 0.0213, 'lps'),
	(498910, 130, '2014-01-15 00:09:33.000000', 'consum', 0.0213, 'lps'),
	(498911, 130, '2014-01-15 00:09:34.000000', 'consum', 0.0215, 'lps'),
	(498912, 130, '2014-01-15 00:09:35.000000', 'consum', 0.0226, 'lps'),
	(498913, 130, '2014-01-15 00:09:36.000000', 'consum', 0.0224, 'lps'),
	(498914, 130, '2014-01-15 00:09:37.000000', 'consum', 0.0216, 'lps'),
	(498915, 130, '2014-01-15 00:09:38.000000', 'consum', 0.0217, 'lps'),
	(498916, 130, '2014-01-15 00:09:39.000000', 'consum', 0.0226, 'lps'),
	(498917, 130, '2014-01-15 00:09:40.000000', 'consum', 0.0218, 'lps'),
	(498918, 130, '2014-01-15 00:09:41.000000', 'consum', 0.0220, 'lps'),
	(498919, 130, '2014-01-15 00:09:42.000000', 'consum', 0.0221, 'lps'),
	(498920, 130, '2014-01-15 00:09:43.000000', 'consum', 0.0218, 'lps'),
	(498921, 130, '2014-01-15 00:09:44.000000', 'consum', 0.0216, 'lps'),
	(498922, 130, '2014-01-15 00:09:45.000000', 'consum', 0.0218, 'lps'),
	(498923, 130, '2014-01-15 00:09:46.000000', 'consum', 0.0216, 'lps'),
	(498924, 130, '2014-01-15 00:09:47.000000', 'consum', 0.0215, 'lps'),
	(498925, 130, '2014-01-15 00:09:48.000000', 'consum', 0.0217, 'lps'),
	(498926, 130, '2014-01-15 00:09:49.000000', 'consum', 0.0215, 'lps'),
	(498927, 130, '2014-01-15 00:09:50.000000', 'consum', 0.0214, 'lps'),
	(498928, 130, '2014-01-15 00:09:51.000000', 'consum', 0.0217, 'lps'),
	(498929, 130, '2014-01-15 00:09:52.000000', 'consum', 0.0214, 'lps'),
	(498930, 130, '2014-01-15 00:09:53.000000', 'consum', 0.0211, 'lps'),
	(498931, 130, '2014-01-15 00:09:54.000000', 'consum', 0.0219, 'lps'),
	(498932, 130, '2014-01-15 00:09:55.000000', 'consum', 0.0221, 'lps'),
	(498933, 130, '2014-01-15 00:09:56.000000', 'consum', 0.0220, 'lps'),
	(498934, 130, '2014-01-15 00:09:57.000000', 'consum', 0.0226, 'lps'),
	(498935, 130, '2014-01-15 00:09:58.000000', 'consum', 0.0226, 'lps'),
	(498936, 130, '2014-01-15 00:09:59.000000', 'consum', 0.0226, 'lps'),
	(498937, 130, '2014-01-15 00:10:00.000000', 'consum', 0.0211, 'lps'),
	(498938, 130, '2014-01-15 00:10:01.000000', 'consum', 0.0215, 'lps'),
	(498939, 130, '2014-01-15 00:10:02.000000', 'consum', 0.0217, 'lps'),
	(498940, 130, '2014-01-15 00:10:03.000000', 'consum', 0.0212, 'lps'),
	(498941, 130, '2014-01-15 00:10:04.000000', 'consum', 0.0219, 'lps'),
	(498942, 130, '2014-01-15 00:10:05.000000', 'consum', 0.0215, 'lps'),
	(498943, 130, '2014-01-15 00:10:06.000000', 'consum', 0.0210, 'lps'),
	(498944, 130, '2014-01-15 00:10:07.000000', 'consum', 0.0212, 'lps'),
	(498945, 130, '2014-01-15 00:10:08.000000', 'consum', 0.0222, 'lps'),
	(498946, 130, '2014-01-15 00:10:09.000000', 'consum', 0.0210, 'lps'),
	(498947, 130, '2014-01-15 00:10:10.000000', 'consum', 0.0212, 'lps'),
	(498948, 130, '2014-01-15 00:10:11.000000', 'consum', 0.0219, 'lps'),
	(498949, 130, '2014-01-15 00:10:12.000000', 'consum', 0.0214, 'lps'),
	(498950, 130, '2014-01-15 00:10:13.000000', 'consum', 0.0222, 'lps'),
	(498951, 130, '2014-01-15 00:10:14.000000', 'consum', 0.0224, 'lps'),
	(498952, 130, '2014-01-15 00:10:15.000000', 'consum', 0.0226, 'lps'),
	(498953, 130, '2014-01-15 00:10:16.000000', 'consum', 0.0217, 'lps'),
	(498954, 130, '2014-01-15 00:10:17.000000', 'consum', 0.0215, 'lps'),
	(498955, 130, '2014-01-15 00:10:18.000000', 'consum', 0.0212, 'lps'),
	(498956, 130, '2014-01-15 00:10:19.000000', 'consum', 0.0225, 'lps'),
	(498957, 130, '2014-01-15 00:10:20.000000', 'consum', 0.0212, 'lps'),
	(498958, 130, '2014-01-15 00:10:21.000000', 'consum', 0.0210, 'lps'),
	(498959, 130, '2014-01-15 00:10:22.000000', 'consum', 0.0222, 'lps'),
	(498960, 130, '2014-01-15 00:10:23.000000', 'consum', 0.0219, 'lps'),
	(498961, 130, '2014-01-15 00:10:24.000000', 'consum', 0.0219, 'lps'),
	(498962, 130, '2014-01-15 00:10:25.000000', 'consum', 0.0211, 'lps'),
	(498963, 130, '2014-01-15 00:10:26.000000', 'consum', 0.0224, 'lps'),
	(498964, 130, '2014-01-15 00:10:27.000000', 'consum', 0.0225, 'lps'),
	(498965, 130, '2014-01-15 00:10:28.000000', 'consum', 0.0211, 'lps'),
	(498966, 130, '2014-01-15 00:10:29.000000', 'consum', 0.0221, 'lps'),
	(498967, 130, '2014-01-15 00:10:30.000000', 'consum', 0.0212, 'lps'),
	(498968, 130, '2014-01-15 00:10:31.000000', 'consum', 0.0222, 'lps'),
	(498969, 130, '2014-01-15 00:10:32.000000', 'consum', 0.0213, 'lps'),
	(498970, 130, '2014-01-15 00:10:33.000000', 'consum', 0.0224, 'lps'),
	(498971, 130, '2014-01-15 00:10:34.000000', 'consum', 0.0220, 'lps'),
	(498972, 130, '2014-01-15 00:10:35.000000', 'consum', 0.0221, 'lps'),
	(498973, 130, '2014-01-15 00:10:36.000000', 'consum', 0.0215, 'lps'),
	(498974, 130, '2014-01-15 00:10:37.000000', 'consum', 0.0222, 'lps'),
	(498975, 130, '2014-01-15 00:10:38.000000', 'consum', 0.0219, 'lps'),
	(498976, 130, '2014-01-15 00:10:39.000000', 'consum', 0.0222, 'lps'),
	(498977, 130, '2014-01-15 00:10:40.000000', 'consum', 0.0226, 'lps'),
	(498978, 130, '2014-01-15 00:10:41.000000', 'consum', 0.0222, 'lps'),
	(498979, 130, '2014-01-15 00:10:42.000000', 'consum', 0.0221, 'lps'),
	(498980, 130, '2014-01-15 00:10:43.000000', 'consum', 0.0212, 'lps'),
	(498981, 130, '2014-01-15 00:10:44.000000', 'consum', 0.0222, 'lps'),
	(498982, 130, '2014-01-15 00:10:45.000000', 'consum', 0.0214, 'lps'),
	(498983, 130, '2014-01-15 00:10:46.000000', 'consum', 0.0210, 'lps'),
	(498984, 130, '2014-01-15 00:10:47.000000', 'consum', 0.0216, 'lps'),
	(498985, 130, '2014-01-15 00:10:48.000000', 'consum', 0.0225, 'lps'),
	(498986, 130, '2014-01-15 00:10:49.000000', 'consum', 0.0214, 'lps'),
	(498987, 130, '2014-01-15 00:10:50.000000', 'consum', 0.0219, 'lps'),
	(498988, 130, '2014-01-15 00:10:51.000000', 'consum', 0.0210, 'lps'),
	(498989, 130, '2014-01-15 00:10:52.000000', 'consum', 0.0216, 'lps'),
	(498990, 130, '2014-01-15 00:10:53.000000', 'consum', 0.0210, 'lps'),
	(498991, 130, '2014-01-15 00:10:54.000000', 'consum', 0.0225, 'lps'),
	(498992, 130, '2014-01-15 00:10:55.000000', 'consum', 0.0216, 'lps'),
	(498993, 130, '2014-01-15 00:10:56.000000', 'consum', 0.0215, 'lps'),
	(498994, 130, '2014-01-15 00:10:57.000000', 'consum', 0.0219, 'lps'),
	(498995, 130, '2014-01-15 00:10:58.000000', 'consum', 0.0220, 'lps'),
	(498996, 130, '2014-01-15 00:10:59.000000', 'consum', 0.0217, 'lps'),
	(498997, 130, '2014-01-15 00:11:00.000000', 'consum', 0.0216, 'lps'),
	(498998, 130, '2014-01-15 00:11:01.000000', 'consum', 0.0221, 'lps'),
	(498999, 130, '2014-01-15 00:11:02.000000', 'consum', 0.0211, 'lps'),
	(499000, 130, '2014-01-15 00:11:03.000000', 'consum', 0.0217, 'lps'),
	(499001, 130, '2014-01-15 00:11:04.000000', 'consum', 0.0226, 'lps'),
	(499002, 130, '2014-01-15 00:11:05.000000', 'consum', 0.0218, 'lps'),
	(499003, 130, '2014-01-15 00:11:06.000000', 'consum', 0.0221, 'lps'),
	(499004, 130, '2014-01-15 00:11:07.000000', 'consum', 0.0223, 'lps'),
	(499005, 130, '2014-01-15 00:11:08.000000', 'consum', 0.0226, 'lps'),
	(499006, 130, '2014-01-15 00:11:09.000000', 'consum', 0.0219, 'lps'),
	(499007, 130, '2014-01-15 00:11:10.000000', 'consum', 0.0222, 'lps'),
	(499008, 130, '2014-01-15 00:11:11.000000', 'consum', 0.0212, 'lps'),
	(499009, 130, '2014-01-15 00:11:12.000000', 'consum', 0.0216, 'lps'),
	(499010, 130, '2014-01-15 00:11:13.000000', 'consum', 0.0220, 'lps'),
	(499011, 130, '2014-01-15 00:11:14.000000', 'consum', 0.0226, 'lps'),
	(499012, 130, '2014-01-15 00:11:15.000000', 'consum', 0.0225, 'lps'),
	(499013, 130, '2014-01-15 00:11:16.000000', 'consum', 0.0223, 'lps'),
	(499014, 130, '2014-01-15 00:11:17.000000', 'consum', 0.0211, 'lps'),
	(499015, 130, '2014-01-15 00:11:18.000000', 'consum', 0.0211, 'lps'),
	(499016, 130, '2014-01-15 00:11:19.000000', 'consum', 0.0214, 'lps'),
	(499017, 130, '2014-01-15 00:11:20.000000', 'consum', 0.0226, 'lps'),
	(499018, 130, '2014-01-15 00:11:21.000000', 'consum', 0.0211, 'lps'),
	(499019, 130, '2014-01-15 00:11:22.000000', 'consum', 0.0219, 'lps'),
	(499020, 130, '2014-01-15 00:11:23.000000', 'consum', 0.0217, 'lps'),
	(499021, 130, '2014-01-15 00:11:24.000000', 'consum', 0.0221, 'lps'),
	(499022, 130, '2014-01-15 00:11:25.000000', 'consum', 0.0210, 'lps'),
	(499023, 130, '2014-01-15 00:11:26.000000', 'consum', 0.0213, 'lps'),
	(499024, 130, '2014-01-15 00:11:27.000000', 'consum', 0.0223, 'lps'),
	(499025, 130, '2014-01-15 00:11:28.000000', 'consum', 0.0217, 'lps'),
	(499026, 130, '2014-01-15 00:11:29.000000', 'consum', 0.0221, 'lps'),
	(499027, 130, '2014-01-15 00:11:30.000000', 'consum', 0.0214, 'lps'),
	(499028, 130, '2014-01-15 00:11:31.000000', 'consum', 0.0212, 'lps'),
	(499029, 130, '2014-01-15 00:11:32.000000', 'consum', 0.0210, 'lps'),
	(499030, 130, '2014-01-15 00:11:33.000000', 'consum', 0.0221, 'lps'),
	(499031, 130, '2014-01-15 00:11:34.000000', 'consum', 0.0213, 'lps'),
	(499032, 130, '2014-01-15 00:11:35.000000', 'consum', 0.0212, 'lps'),
	(499033, 130, '2014-01-15 00:11:36.000000', 'consum', 0.0212, 'lps'),
	(499034, 130, '2014-01-15 00:11:37.000000', 'consum', 0.0215, 'lps'),
	(499035, 130, '2014-01-15 00:11:38.000000', 'consum', 0.0212, 'lps'),
	(499036, 130, '2014-01-15 00:11:39.000000', 'consum', 0.0221, 'lps'),
	(499037, 130, '2014-01-15 00:11:40.000000', 'consum', 0.0210, 'lps'),
	(499038, 130, '2014-01-15 00:11:41.000000', 'consum', 0.0210, 'lps'),
	(499039, 130, '2014-01-15 00:11:42.000000', 'consum', 0.0211, 'lps'),
	(499040, 130, '2014-01-15 00:11:43.000000', 'consum', 0.0217, 'lps'),
	(499041, 130, '2014-01-15 00:11:44.000000', 'consum', 0.0224, 'lps'),
	(499042, 130, '2014-01-15 00:11:45.000000', 'consum', 0.0210, 'lps'),
	(499043, 130, '2014-01-15 00:11:46.000000', 'consum', 0.0219, 'lps'),
	(499044, 130, '2014-01-15 00:11:47.000000', 'consum', 0.0220, 'lps'),
	(499045, 130, '2014-01-15 00:11:48.000000', 'consum', 0.0218, 'lps'),
	(499046, 130, '2014-01-15 00:11:49.000000', 'consum', 0.0220, 'lps'),
	(499047, 130, '2014-01-15 00:11:50.000000', 'consum', 0.0219, 'lps'),
	(499048, 130, '2014-01-15 00:11:51.000000', 'consum', 0.0210, 'lps'),
	(499049, 130, '2014-01-15 00:11:52.000000', 'consum', 0.0218, 'lps'),
	(499050, 130, '2014-01-15 00:11:53.000000', 'consum', 0.0216, 'lps'),
	(499051, 130, '2014-01-15 00:11:54.000000', 'consum', 0.0215, 'lps'),
	(499052, 130, '2014-01-15 00:11:55.000000', 'consum', 0.0216, 'lps'),
	(499053, 130, '2014-01-15 00:11:56.000000', 'consum', 0.0212, 'lps'),
	(499054, 130, '2014-01-15 00:11:57.000000', 'consum', 0.0217, 'lps'),
	(499055, 130, '2014-01-15 00:11:58.000000', 'consum', 0.0225, 'lps'),
	(499056, 130, '2014-01-15 00:11:59.000000', 'consum', 0.0214, 'lps'),
	(499057, 130, '2014-01-15 00:12:00.000000', 'consum', 0.0219, 'lps'),
	(499058, 130, '2014-01-15 00:12:01.000000', 'consum', 0.0225, 'lps'),
	(499059, 130, '2014-01-15 00:12:02.000000', 'consum', 0.0223, 'lps'),
	(499060, 130, '2014-01-15 00:12:03.000000', 'consum', 0.0216, 'lps'),
	(499061, 130, '2014-01-15 00:12:04.000000', 'consum', 0.0216, 'lps'),
	(499062, 130, '2014-01-15 00:12:05.000000', 'consum', 0.0223, 'lps'),
	(499063, 130, '2014-01-15 00:12:06.000000', 'consum', 0.0224, 'lps'),
	(499064, 130, '2014-01-15 00:12:07.000000', 'consum', 0.0224, 'lps'),
	(499065, 130, '2014-01-15 00:12:08.000000', 'consum', 0.0220, 'lps'),
	(499066, 130, '2014-01-15 00:12:09.000000', 'consum', 0.0220, 'lps'),
	(499067, 130, '2014-01-15 00:12:10.000000', 'consum', 0.0212, 'lps'),
	(499068, 130, '2014-01-15 00:12:11.000000', 'consum', 0.0225, 'lps'),
	(499069, 130, '2014-01-15 00:12:12.000000', 'consum', 0.0212, 'lps'),
	(499070, 130, '2014-01-15 00:12:13.000000', 'consum', 0.0226, 'lps'),
	(499071, 130, '2014-01-15 00:12:14.000000', 'consum', 0.0215, 'lps'),
	(499072, 130, '2014-01-15 00:12:15.000000', 'consum', 0.0223, 'lps'),
	(499073, 130, '2014-01-15 00:12:16.000000', 'consum', 0.0225, 'lps'),
	(499074, 130, '2014-01-15 00:12:17.000000', 'consum', 0.0212, 'lps'),
	(499075, 130, '2014-01-15 00:12:18.000000', 'consum', 0.0212, 'lps'),
	(499076, 130, '2014-01-15 00:12:19.000000', 'consum', 0.0213, 'lps'),
	(499077, 130, '2014-01-15 00:12:20.000000', 'consum', 0.0222, 'lps'),
	(499078, 130, '2014-01-15 00:12:21.000000', 'consum', 0.0224, 'lps'),
	(499079, 130, '2014-01-15 00:12:22.000000', 'consum', 0.0213, 'lps'),
	(499080, 130, '2014-01-15 00:12:23.000000', 'consum', 0.0216, 'lps'),
	(499081, 130, '2014-01-15 00:12:24.000000', 'consum', 0.0216, 'lps'),
	(499082, 130, '2014-01-15 00:12:25.000000', 'consum', 0.0223, 'lps'),
	(499083, 130, '2014-01-15 00:12:26.000000', 'consum', 0.0222, 'lps'),
	(499084, 130, '2014-01-15 00:12:27.000000', 'consum', 0.0216, 'lps'),
	(499085, 130, '2014-01-15 00:12:28.000000', 'consum', 0.0223, 'lps'),
	(499086, 130, '2014-01-15 00:12:29.000000', 'consum', 0.0220, 'lps'),
	(499087, 130, '2014-01-15 00:12:30.000000', 'consum', 0.0224, 'lps'),
	(499088, 130, '2014-01-15 00:12:31.000000', 'consum', 0.0215, 'lps'),
	(499089, 130, '2014-01-15 00:12:32.000000', 'consum', 0.0213, 'lps'),
	(499090, 130, '2014-01-15 00:12:33.000000', 'consum', 0.0224, 'lps'),
	(499091, 130, '2014-01-15 00:12:34.000000', 'consum', 0.0223, 'lps'),
	(499092, 130, '2014-01-15 00:12:35.000000', 'consum', 0.0214, 'lps'),
	(499093, 130, '2014-01-15 00:12:36.000000', 'consum', 0.0226, 'lps'),
	(499094, 130, '2014-01-15 00:12:37.000000', 'consum', 0.0213, 'lps'),
	(499095, 130, '2014-01-15 00:12:38.000000', 'consum', 0.0226, 'lps'),
	(499096, 130, '2014-01-15 00:12:39.000000', 'consum', 0.0216, 'lps'),
	(499097, 130, '2014-01-15 00:12:40.000000', 'consum', 0.0224, 'lps'),
	(499098, 130, '2014-01-15 00:12:41.000000', 'consum', 0.0212, 'lps'),
	(499099, 130, '2014-01-15 00:12:42.000000', 'consum', 0.0212, 'lps'),
	(499100, 130, '2014-01-15 00:12:43.000000', 'consum', 0.0215, 'lps'),
	(499101, 130, '2014-01-15 00:12:44.000000', 'consum', 0.0212, 'lps'),
	(499102, 130, '2014-01-15 00:12:45.000000', 'consum', 0.0224, 'lps'),
	(499103, 130, '2014-01-15 00:12:46.000000', 'consum', 0.0224, 'lps'),
	(499104, 130, '2014-01-15 00:12:47.000000', 'consum', 0.0220, 'lps'),
	(499105, 130, '2014-01-15 00:12:48.000000', 'consum', 0.0219, 'lps'),
	(499106, 130, '2014-01-15 00:12:49.000000', 'consum', 0.0226, 'lps'),
	(499107, 130, '2014-01-15 00:12:50.000000', 'consum', 0.0212, 'lps'),
	(499108, 130, '2014-01-15 00:12:51.000000', 'consum', 0.0222, 'lps'),
	(499109, 130, '2014-01-15 00:12:52.000000', 'consum', 0.0213, 'lps'),
	(499110, 130, '2014-01-15 00:12:53.000000', 'consum', 0.0224, 'lps'),
	(499111, 130, '2014-01-15 00:12:54.000000', 'consum', 0.0223, 'lps'),
	(499112, 130, '2014-01-15 00:12:55.000000', 'consum', 0.0214, 'lps'),
	(499113, 130, '2014-01-15 00:12:56.000000', 'consum', 0.0225, 'lps'),
	(499114, 130, '2014-01-15 00:12:57.000000', 'consum', 0.0224, 'lps'),
	(499115, 130, '2014-01-15 00:12:58.000000', 'consum', 0.0218, 'lps'),
	(499116, 130, '2014-01-15 00:12:59.000000', 'consum', 0.0211, 'lps'),
	(499117, 130, '2014-01-15 00:13:00.000000', 'consum', 0.0222, 'lps'),
	(499118, 130, '2014-01-15 00:13:01.000000', 'consum', 0.0219, 'lps'),
	(499119, 130, '2014-01-15 00:13:02.000000', 'consum', 0.0219, 'lps'),
	(499120, 130, '2014-01-15 00:13:03.000000', 'consum', 0.0212, 'lps'),
	(499121, 130, '2014-01-15 00:13:04.000000', 'consum', 0.0225, 'lps'),
	(499122, 130, '2014-01-15 00:13:05.000000', 'consum', 0.0213, 'lps'),
	(499123, 130, '2014-01-15 00:13:06.000000', 'consum', 0.0214, 'lps'),
	(499124, 130, '2014-01-15 00:13:07.000000', 'consum', 0.0223, 'lps'),
	(499125, 130, '2014-01-15 00:13:08.000000', 'consum', 0.0213, 'lps'),
	(499126, 130, '2014-01-15 00:13:09.000000', 'consum', 0.0219, 'lps'),
	(499127, 130, '2014-01-15 00:13:10.000000', 'consum', 0.0212, 'lps'),
	(499128, 130, '2014-01-15 00:13:11.000000', 'consum', 0.0212, 'lps'),
	(499129, 130, '2014-01-15 00:13:12.000000', 'consum', 0.0213, 'lps'),
	(499130, 130, '2014-01-15 00:13:13.000000', 'consum', 0.0221, 'lps'),
	(499131, 130, '2014-01-15 00:13:14.000000', 'consum', 0.0221, 'lps'),
	(499132, 130, '2014-01-15 00:13:15.000000', 'consum', 0.0216, 'lps'),
	(499133, 130, '2014-01-15 00:13:16.000000', 'consum', 0.0224, 'lps'),
	(499134, 130, '2014-01-15 00:13:17.000000', 'consum', 0.0214, 'lps'),
	(499135, 130, '2014-01-15 00:13:18.000000', 'consum', 0.0220, 'lps'),
	(499136, 130, '2014-01-15 00:13:19.000000', 'consum', 0.0216, 'lps'),
	(499137, 130, '2014-01-15 00:13:20.000000', 'consum', 0.0226, 'lps'),
	(499138, 130, '2014-01-15 00:13:21.000000', 'consum', 0.0223, 'lps'),
	(499139, 130, '2014-01-15 00:13:22.000000', 'consum', 0.0212, 'lps'),
	(499140, 130, '2014-01-15 00:13:23.000000', 'consum', 0.0213, 'lps'),
	(499141, 130, '2014-01-15 00:13:24.000000', 'consum', 0.0219, 'lps'),
	(499142, 130, '2014-01-15 00:13:25.000000', 'consum', 0.0215, 'lps'),
	(499143, 130, '2014-01-15 00:13:26.000000', 'consum', 0.0223, 'lps'),
	(499144, 130, '2014-01-15 00:13:27.000000', 'consum', 0.0226, 'lps'),
	(499145, 130, '2014-01-15 00:13:28.000000', 'consum', 0.0220, 'lps'),
	(499146, 130, '2014-01-15 00:13:29.000000', 'consum', 0.0212, 'lps'),
	(499147, 130, '2014-01-15 00:13:30.000000', 'consum', 0.0225, 'lps'),
	(499148, 130, '2014-01-15 00:13:31.000000', 'consum', 0.0211, 'lps'),
	(499149, 130, '2014-01-15 00:13:32.000000', 'consum', 0.0219, 'lps'),
	(499150, 130, '2014-01-15 00:13:33.000000', 'consum', 0.0221, 'lps'),
	(499151, 130, '2014-01-15 00:13:34.000000', 'consum', 0.0223, 'lps'),
	(499152, 130, '2014-01-15 00:13:35.000000', 'consum', 0.0224, 'lps'),
	(499153, 130, '2014-01-15 00:13:36.000000', 'consum', 0.0225, 'lps'),
	(499154, 130, '2014-01-15 00:13:37.000000', 'consum', 0.0225, 'lps'),
	(499155, 130, '2014-01-15 00:13:38.000000', 'consum', 0.0224, 'lps'),
	(499156, 130, '2014-01-15 00:13:39.000000', 'consum', 0.0221, 'lps'),
	(499157, 130, '2014-01-15 00:13:40.000000', 'consum', 0.0221, 'lps'),
	(499158, 130, '2014-01-15 00:13:41.000000', 'consum', 0.0214, 'lps'),
	(499159, 130, '2014-01-15 00:13:42.000000', 'consum', 0.0217, 'lps'),
	(499160, 130, '2014-01-15 00:13:43.000000', 'consum', 0.0215, 'lps'),
	(499161, 130, '2014-01-15 00:13:44.000000', 'consum', 0.0217, 'lps'),
	(499162, 130, '2014-01-15 00:13:45.000000', 'consum', 0.0213, 'lps'),
	(499163, 130, '2014-01-15 00:13:46.000000', 'consum', 0.0220, 'lps'),
	(499164, 130, '2014-01-15 00:13:47.000000', 'consum', 0.0217, 'lps'),
	(499165, 130, '2014-01-15 00:13:48.000000', 'consum', 0.0215, 'lps'),
	(499166, 130, '2014-01-15 00:13:49.000000', 'consum', 0.0216, 'lps'),
	(499167, 130, '2014-01-15 00:13:50.000000', 'consum', 0.0225, 'lps'),
	(499168, 130, '2014-01-15 00:13:51.000000', 'consum', 0.0218, 'lps'),
	(499169, 130, '2014-01-15 00:13:52.000000', 'consum', 0.0220, 'lps'),
	(499170, 130, '2014-01-15 00:13:53.000000', 'consum', 0.0219, 'lps'),
	(499171, 130, '2014-01-15 00:13:54.000000', 'consum', 0.0210, 'lps'),
	(499172, 130, '2014-01-15 00:13:55.000000', 'consum', 0.0216, 'lps'),
	(499173, 130, '2014-01-15 00:13:56.000000', 'consum', 0.0224, 'lps'),
	(499174, 130, '2014-01-15 00:13:57.000000', 'consum', 0.0214, 'lps'),
	(499175, 130, '2014-01-15 00:13:58.000000', 'consum', 0.0219, 'lps'),
	(499176, 130, '2014-01-15 00:13:59.000000', 'consum', 0.0211, 'lps'),
	(499177, 130, '2014-01-15 00:14:00.000000', 'consum', 0.0222, 'lps'),
	(499178, 130, '2014-01-15 00:14:01.000000', 'consum', 0.0215, 'lps'),
	(499179, 130, '2014-01-15 00:14:02.000000', 'consum', 0.0219, 'lps'),
	(499180, 130, '2014-01-15 00:14:03.000000', 'consum', 0.0224, 'lps'),
	(499181, 130, '2014-01-15 00:14:04.000000', 'consum', 0.0221, 'lps'),
	(499182, 130, '2014-01-15 00:14:05.000000', 'consum', 0.0220, 'lps'),
	(499183, 130, '2014-01-15 00:14:06.000000', 'consum', 0.0211, 'lps'),
	(499184, 130, '2014-01-15 00:14:07.000000', 'consum', 0.0220, 'lps'),
	(499185, 130, '2014-01-15 00:14:08.000000', 'consum', 0.0222, 'lps'),
	(499186, 130, '2014-01-15 00:14:09.000000', 'consum', 0.0226, 'lps'),
	(499187, 130, '2014-01-15 00:14:10.000000', 'consum', 0.0219, 'lps'),
	(499188, 130, '2014-01-15 00:14:11.000000', 'consum', 0.0210, 'lps'),
	(499189, 130, '2014-01-15 00:14:12.000000', 'consum', 0.0214, 'lps'),
	(499190, 130, '2014-01-15 00:14:13.000000', 'consum', 0.0216, 'lps'),
	(499191, 130, '2014-01-15 00:14:14.000000', 'consum', 0.0210, 'lps'),
	(499192, 130, '2014-01-15 00:14:15.000000', 'consum', 0.0210, 'lps'),
	(499193, 130, '2014-01-15 00:14:16.000000', 'consum', 0.0211, 'lps'),
	(499194, 130, '2014-01-15 00:14:17.000000', 'consum', 0.0215, 'lps'),
	(499195, 130, '2014-01-15 00:14:18.000000', 'consum', 0.0217, 'lps'),
	(499196, 130, '2014-01-15 00:14:19.000000', 'consum', 0.0213, 'lps'),
	(499197, 130, '2014-01-15 00:14:20.000000', 'consum', 0.0222, 'lps'),
	(499198, 130, '2014-01-15 00:14:21.000000', 'consum', 0.0210, 'lps'),
	(499199, 130, '2014-01-15 00:14:22.000000', 'consum', 0.0210, 'lps'),
	(499200, 130, '2014-01-15 00:14:23.000000', 'consum', 0.0210, 'lps'),
	(499201, 130, '2014-01-15 00:14:24.000000', 'consum', 0.0226, 'lps'),
	(499202, 130, '2014-01-15 00:14:25.000000', 'consum', 0.0225, 'lps'),
	(499203, 130, '2014-01-15 00:14:26.000000', 'consum', 0.0218, 'lps'),
	(499204, 130, '2014-01-15 00:14:27.000000', 'consum', 0.0222, 'lps'),
	(499205, 130, '2014-01-15 00:14:28.000000', 'consum', 0.0214, 'lps'),
	(499206, 130, '2014-01-15 00:14:29.000000', 'consum', 0.0226, 'lps'),
	(499207, 130, '2014-01-15 00:14:30.000000', 'consum', 0.0212, 'lps'),
	(499208, 130, '2014-01-15 00:14:31.000000', 'consum', 0.0226, 'lps'),
	(499209, 130, '2014-01-15 00:14:32.000000', 'consum', 0.0213, 'lps'),
	(499210, 130, '2014-01-15 00:14:33.000000', 'consum', 0.0212, 'lps'),
	(499211, 130, '2014-01-15 00:14:34.000000', 'consum', 0.0213, 'lps'),
	(499212, 130, '2014-01-15 00:14:35.000000', 'consum', 0.0221, 'lps'),
	(499213, 130, '2014-01-15 00:14:36.000000', 'consum', 0.0220, 'lps'),
	(499214, 130, '2014-01-15 00:14:37.000000', 'consum', 0.0213, 'lps'),
	(499215, 130, '2014-01-15 00:14:38.000000', 'consum', 0.0212, 'lps'),
	(499216, 130, '2014-01-15 00:14:39.000000', 'consum', 0.0210, 'lps'),
	(499217, 130, '2014-01-15 00:14:40.000000', 'consum', 0.0223, 'lps'),
	(499218, 130, '2014-01-15 00:14:41.000000', 'consum', 0.0222, 'lps'),
	(499219, 130, '2014-01-15 00:14:42.000000', 'consum', 0.0217, 'lps'),
	(499220, 130, '2014-01-15 00:14:43.000000', 'consum', 0.0224, 'lps'),
	(499221, 130, '2014-01-15 00:14:44.000000', 'consum', 0.0225, 'lps'),
	(499222, 130, '2014-01-15 00:14:45.000000', 'consum', 0.0211, 'lps'),
	(499223, 130, '2014-01-15 00:14:46.000000', 'consum', 0.0223, 'lps'),
	(499224, 130, '2014-01-15 00:14:47.000000', 'consum', 0.0221, 'lps'),
	(499225, 130, '2014-01-15 00:14:48.000000', 'consum', 0.0211, 'lps'),
	(499226, 130, '2014-01-15 00:14:49.000000', 'consum', 0.0215, 'lps'),
	(499227, 130, '2014-01-15 00:14:50.000000', 'consum', 0.0217, 'lps'),
	(499228, 130, '2014-01-15 00:14:51.000000', 'consum', 0.0213, 'lps'),
	(499229, 130, '2014-01-15 00:14:52.000000', 'consum', 0.0220, 'lps'),
	(499230, 130, '2014-01-15 00:14:53.000000', 'consum', 0.0217, 'lps'),
	(499231, 130, '2014-01-15 00:14:54.000000', 'consum', 0.0215, 'lps'),
	(499232, 130, '2014-01-15 00:14:55.000000', 'consum', 0.0216, 'lps'),
	(499233, 130, '2014-01-15 00:14:56.000000', 'consum', 0.0225, 'lps'),
	(499234, 130, '2014-01-15 00:14:57.000000', 'consum', 0.0216, 'lps'),
	(499235, 130, '2014-01-15 00:14:58.000000', 'consum', 0.0214, 'lps'),
	(499236, 130, '2014-01-15 00:14:59.000000', 'consum', 0.0213, 'lps'),
	(499237, 130, '2014-01-15 00:15:00.000000', 'consum', 0.0215, 'lps'),
	(499238, 130, '2014-01-15 00:15:01.000000', 'consum', 0.0224, 'lps'),
	(499239, 130, '2014-01-15 00:15:02.000000', 'consum', 0.0213, 'lps'),
	(499240, 130, '2014-01-15 00:15:03.000000', 'consum', 0.0221, 'lps'),
	(499241, 130, '2014-01-15 00:15:04.000000', 'consum', 0.0220, 'lps'),
	(499242, 130, '2014-01-15 00:15:05.000000', 'consum', 0.0211, 'lps'),
	(499243, 130, '2014-01-15 00:15:06.000000', 'consum', 0.0220, 'lps'),
	(499244, 130, '2014-01-15 00:15:07.000000', 'consum', 0.0225, 'lps'),
	(499245, 130, '2014-01-15 00:15:08.000000', 'consum', 0.0222, 'lps'),
	(499246, 130, '2014-01-15 00:15:09.000000', 'consum', 0.0224, 'lps'),
	(499247, 130, '2014-01-15 00:15:10.000000', 'consum', 0.0211, 'lps'),
	(499248, 130, '2014-01-15 00:15:11.000000', 'consum', 0.0225, 'lps'),
	(499249, 130, '2014-01-15 00:15:12.000000', 'consum', 0.0215, 'lps'),
	(499250, 130, '2014-01-15 00:15:13.000000', 'consum', 0.0223, 'lps'),
	(499251, 130, '2014-01-15 00:15:14.000000', 'consum', 0.0225, 'lps'),
	(499252, 130, '2014-01-15 00:15:15.000000', 'consum', 0.0215, 'lps'),
	(499253, 130, '2014-01-15 00:15:16.000000', 'consum', 0.0225, 'lps'),
	(499254, 130, '2014-01-15 00:15:17.000000', 'consum', 0.0217, 'lps'),
	(499255, 130, '2014-01-15 00:15:18.000000', 'consum', 0.0218, 'lps'),
	(499256, 130, '2014-01-15 00:15:19.000000', 'consum', 0.0211, 'lps'),
	(499257, 130, '2014-01-15 00:15:20.000000', 'consum', 0.0211, 'lps'),
	(499258, 130, '2014-01-15 00:15:21.000000', 'consum', 0.0213, 'lps'),
	(499259, 130, '2014-01-15 00:15:22.000000', 'consum', 0.0221, 'lps'),
	(499260, 130, '2014-01-15 00:15:23.000000', 'consum', 0.0225, 'lps'),
	(499261, 130, '2014-01-15 00:15:24.000000', 'consum', 0.0217, 'lps'),
	(499262, 130, '2014-01-15 00:15:25.000000', 'consum', 0.0217, 'lps'),
	(499263, 130, '2014-01-15 00:15:26.000000', 'consum', 0.0226, 'lps'),
	(499264, 130, '2014-01-15 00:15:27.000000', 'consum', 0.0219, 'lps'),
	(499265, 130, '2014-01-15 00:15:28.000000', 'consum', 0.0223, 'lps'),
	(499266, 130, '2014-01-15 00:15:29.000000', 'consum', 0.0214, 'lps'),
	(499267, 130, '2014-01-15 00:15:30.000000', 'consum', 0.0225, 'lps'),
	(499268, 130, '2014-01-15 00:15:31.000000', 'consum', 0.0222, 'lps'),
	(499269, 130, '2014-01-15 00:15:32.000000', 'consum', 0.0210, 'lps'),
	(499270, 130, '2014-01-15 00:15:33.000000', 'consum', 0.0210, 'lps'),
	(499271, 130, '2014-01-15 00:15:34.000000', 'consum', 0.0225, 'lps'),
	(499272, 130, '2014-01-15 00:15:35.000000', 'consum', 0.0218, 'lps'),
	(499273, 130, '2014-01-15 00:15:36.000000', 'consum', 0.0221, 'lps'),
	(499274, 130, '2014-01-15 00:15:37.000000', 'consum', 0.0224, 'lps'),
	(499275, 130, '2014-01-15 00:15:38.000000', 'consum', 0.0215, 'lps'),
	(499276, 130, '2014-01-15 00:15:39.000000', 'consum', 0.0211, 'lps'),
	(499277, 130, '2014-01-15 00:15:40.000000', 'consum', 0.0218, 'lps'),
	(499278, 130, '2014-01-15 00:15:41.000000', 'consum', 0.0214, 'lps'),
	(499279, 130, '2014-01-15 00:15:42.000000', 'consum', 0.0223, 'lps'),
	(499280, 130, '2014-01-15 00:15:43.000000', 'consum', 0.0214, 'lps'),
	(499281, 130, '2014-01-15 00:15:44.000000', 'consum', 0.0224, 'lps'),
	(499282, 130, '2014-01-15 00:15:45.000000', 'consum', 0.0216, 'lps'),
	(499283, 130, '2014-01-15 00:15:46.000000', 'consum', 0.0218, 'lps'),
	(499284, 130, '2014-01-15 00:15:47.000000', 'consum', 0.0216, 'lps'),
	(499285, 130, '2014-01-15 00:15:48.000000', 'consum', 0.0217, 'lps'),
	(499286, 130, '2014-01-15 00:15:49.000000', 'consum', 0.0225, 'lps'),
	(499287, 130, '2014-01-15 00:15:50.000000', 'consum', 0.0213, 'lps'),
	(499288, 130, '2014-01-15 00:15:51.000000', 'consum', 0.0216, 'lps'),
	(499289, 130, '2014-01-15 00:15:52.000000', 'consum', 0.0216, 'lps'),
	(499290, 130, '2014-01-15 00:15:53.000000', 'consum', 0.0220, 'lps'),
	(499291, 130, '2014-01-15 00:15:54.000000', 'consum', 0.0210, 'lps'),
	(499292, 130, '2014-01-15 00:15:55.000000', 'consum', 0.0213, 'lps'),
	(499293, 130, '2014-01-15 00:15:56.000000', 'consum', 0.0210, 'lps'),
	(499294, 130, '2014-01-15 00:15:57.000000', 'consum', 0.0219, 'lps'),
	(499295, 130, '2014-01-15 00:15:58.000000', 'consum', 0.0222, 'lps'),
	(499296, 130, '2014-01-15 00:15:59.000000', 'consum', 0.0210, 'lps'),
	(499297, 130, '2014-01-15 00:16:00.000000', 'consum', 0.0210, 'lps'),
	(499298, 130, '2014-01-15 00:16:01.000000', 'consum', 0.0224, 'lps'),
	(499299, 130, '2014-01-15 00:16:02.000000', 'consum', 0.0214, 'lps'),
	(499300, 130, '2014-01-15 00:16:03.000000', 'consum', 0.0222, 'lps'),
	(499301, 130, '2014-01-15 00:16:04.000000', 'consum', 0.0223, 'lps'),
	(499302, 130, '2014-01-15 00:16:05.000000', 'consum', 0.0224, 'lps'),
	(499303, 130, '2014-01-15 00:16:06.000000', 'consum', 0.0223, 'lps'),
	(499304, 130, '2014-01-15 00:16:07.000000', 'consum', 0.0217, 'lps'),
	(499305, 130, '2014-01-15 00:16:08.000000', 'consum', 0.0224, 'lps'),
	(499306, 130, '2014-01-15 00:16:09.000000', 'consum', 0.0226, 'lps'),
	(499307, 130, '2014-01-15 00:16:10.000000', 'consum', 0.0215, 'lps'),
	(499308, 130, '2014-01-15 00:16:11.000000', 'consum', 0.0221, 'lps'),
	(499309, 130, '2014-01-15 00:16:12.000000', 'consum', 0.0218, 'lps'),
	(499310, 130, '2014-01-15 00:16:13.000000', 'consum', 0.0219, 'lps'),
	(499311, 130, '2014-01-15 00:16:14.000000', 'consum', 0.0211, 'lps'),
	(499312, 130, '2014-01-15 00:16:15.000000', 'consum', 0.0222, 'lps'),
	(499313, 130, '2014-01-15 00:16:16.000000', 'consum', 0.0216, 'lps'),
	(499314, 130, '2014-01-15 00:16:17.000000', 'consum', 0.0224, 'lps'),
	(499315, 130, '2014-01-15 00:16:18.000000', 'consum', 0.0226, 'lps'),
	(499316, 130, '2014-01-15 00:16:19.000000', 'consum', 0.0215, 'lps'),
	(499317, 130, '2014-01-15 00:16:20.000000', 'consum', 0.0222, 'lps'),
	(499318, 130, '2014-01-15 00:16:21.000000', 'consum', 0.0222, 'lps'),
	(499319, 130, '2014-01-15 00:16:22.000000', 'consum', 0.0219, 'lps'),
	(499320, 130, '2014-01-15 00:16:23.000000', 'consum', 0.0217, 'lps'),
	(499321, 130, '2014-01-15 00:16:24.000000', 'consum', 0.0221, 'lps'),
	(499322, 130, '2014-01-15 00:16:25.000000', 'consum', 0.0225, 'lps'),
	(499323, 130, '2014-01-15 00:16:26.000000', 'consum', 0.0220, 'lps'),
	(499324, 130, '2014-01-15 00:16:27.000000', 'consum', 0.0216, 'lps'),
	(499325, 130, '2014-01-15 00:16:28.000000', 'consum', 0.0211, 'lps'),
	(499326, 130, '2014-01-15 00:16:29.000000', 'consum', 0.0214, 'lps'),
	(499327, 130, '2014-01-15 00:16:30.000000', 'consum', 0.0210, 'lps'),
	(499328, 130, '2014-01-15 00:16:31.000000', 'consum', 0.0216, 'lps'),
	(499329, 130, '2014-01-15 00:16:32.000000', 'consum', 0.0223, 'lps'),
	(499330, 130, '2014-01-15 00:16:33.000000', 'consum', 0.0222, 'lps'),
	(499331, 130, '2014-01-15 00:16:34.000000', 'consum', 0.0216, 'lps'),
	(499332, 130, '2014-01-15 00:16:35.000000', 'consum', 0.0220, 'lps'),
	(499333, 130, '2014-01-15 00:16:36.000000', 'consum', 0.0210, 'lps'),
	(499334, 130, '2014-01-15 00:16:37.000000', 'consum', 0.0215, 'lps'),
	(499335, 130, '2014-01-15 00:16:38.000000', 'consum', 0.0217, 'lps'),
	(499336, 130, '2014-01-15 00:16:39.000000', 'consum', 0.0214, 'lps'),
	(499337, 130, '2014-01-15 00:16:40.000000', 'consum', 0.0225, 'lps'),
	(499338, 130, '2014-01-15 00:16:41.000000', 'consum', 0.0224, 'lps'),
	(499339, 130, '2014-01-15 00:16:42.000000', 'consum', 0.0218, 'lps'),
	(499340, 130, '2014-01-15 00:16:43.000000', 'consum', 0.0224, 'lps'),
	(499341, 130, '2014-01-15 00:16:44.000000', 'consum', 0.0222, 'lps'),
	(499342, 130, '2014-01-15 00:16:45.000000', 'consum', 0.0212, 'lps'),
	(499343, 130, '2014-01-15 00:16:46.000000', 'consum', 0.0219, 'lps'),
	(499344, 130, '2014-01-15 00:16:47.000000', 'consum', 0.0214, 'lps'),
	(499345, 130, '2014-01-15 00:16:48.000000', 'consum', 0.0221, 'lps'),
	(499346, 130, '2014-01-15 00:16:49.000000', 'consum', 0.0221, 'lps'),
	(499347, 130, '2014-01-15 00:16:50.000000', 'consum', 0.0216, 'lps'),
	(499348, 130, '2014-01-15 00:16:51.000000', 'consum', 0.0222, 'lps'),
	(499349, 130, '2014-01-15 00:16:52.000000', 'consum', 0.0219, 'lps'),
	(499350, 130, '2014-01-15 00:16:53.000000', 'consum', 0.0219, 'lps'),
	(499351, 130, '2014-01-15 00:16:54.000000', 'consum', 0.0213, 'lps'),
	(499352, 130, '2014-01-15 00:16:55.000000', 'consum', 0.0214, 'lps'),
	(499353, 130, '2014-01-15 00:16:56.000000', 'consum', 0.0224, 'lps'),
	(499354, 130, '2014-01-15 00:16:57.000000', 'consum', 0.0217, 'lps'),
	(499355, 130, '2014-01-15 00:16:58.000000', 'consum', 0.0221, 'lps'),
	(499356, 130, '2014-01-15 00:16:59.000000', 'consum', 0.0225, 'lps'),
	(499357, 130, '2014-01-15 00:17:00.000000', 'consum', 0.0222, 'lps'),
	(499358, 130, '2014-01-15 00:17:01.000000', 'consum', 0.0223, 'lps'),
	(499359, 130, '2014-01-15 00:17:02.000000', 'consum', 0.0223, 'lps'),
	(499360, 130, '2014-01-15 00:17:03.000000', 'consum', 0.0220, 'lps'),
	(499361, 130, '2014-01-15 00:17:04.000000', 'consum', 0.0223, 'lps'),
	(499362, 130, '2014-01-15 00:17:05.000000', 'consum', 0.0211, 'lps'),
	(499363, 130, '2014-01-15 00:17:06.000000', 'consum', 0.0211, 'lps'),
	(499364, 130, '2014-01-15 00:17:07.000000', 'consum', 0.0214, 'lps'),
	(499365, 130, '2014-01-15 00:17:08.000000', 'consum', 0.0224, 'lps'),
	(499366, 130, '2014-01-15 00:17:09.000000', 'consum', 0.0219, 'lps'),
	(499367, 130, '2014-01-15 00:17:10.000000', 'consum', 0.0214, 'lps'),
	(499368, 130, '2014-01-15 00:17:11.000000', 'consum', 0.0220, 'lps'),
	(499369, 130, '2014-01-15 00:17:12.000000', 'consum', 0.0215, 'lps'),
	(499370, 130, '2014-01-15 00:17:13.000000', 'consum', 0.0222, 'lps'),
	(499371, 130, '2014-01-15 00:17:14.000000', 'consum', 0.0223, 'lps'),
	(499372, 130, '2014-01-15 00:17:15.000000', 'consum', 0.0222, 'lps'),
	(499373, 130, '2014-01-15 00:17:16.000000', 'consum', 0.0216, 'lps'),
	(499374, 130, '2014-01-15 00:17:17.000000', 'consum', 0.0221, 'lps'),
	(499375, 130, '2014-01-15 00:17:18.000000', 'consum', 0.0214, 'lps'),
	(499376, 130, '2014-01-15 00:17:19.000000', 'consum', 0.0212, 'lps'),
	(499377, 130, '2014-01-15 00:17:20.000000', 'consum', 0.0211, 'lps'),
	(499378, 130, '2014-01-15 00:17:21.000000', 'consum', 0.0226, 'lps'),
	(499379, 130, '2014-01-15 00:17:22.000000', 'consum', 0.0218, 'lps'),
	(499380, 130, '2014-01-15 00:17:23.000000', 'consum', 0.0221, 'lps'),
	(499381, 130, '2014-01-15 00:17:24.000000', 'consum', 0.0226, 'lps'),
	(499382, 130, '2014-01-15 00:17:25.000000', 'consum', 0.0220, 'lps'),
	(499383, 130, '2014-01-15 00:17:26.000000', 'consum', 0.0215, 'lps'),
	(499384, 130, '2014-01-15 00:17:27.000000', 'consum', 0.0222, 'lps'),
	(499385, 130, '2014-01-15 00:17:28.000000', 'consum', 0.0222, 'lps'),
	(499386, 130, '2014-01-15 00:17:29.000000', 'consum', 0.0219, 'lps'),
	(499387, 130, '2014-01-15 00:17:30.000000', 'consum', 0.0218, 'lps'),
	(499388, 130, '2014-01-15 00:17:31.000000', 'consum', 0.0223, 'lps'),
	(499389, 130, '2014-01-15 00:17:32.000000', 'consum', 0.0218, 'lps'),
	(499390, 130, '2014-01-15 00:17:33.000000', 'consum', 0.0211, 'lps'),
	(499391, 130, '2014-01-15 00:17:34.000000', 'consum', 0.0210, 'lps'),
	(499392, 130, '2014-01-15 00:17:35.000000', 'consum', 0.0226, 'lps'),
	(499393, 130, '2014-01-15 00:17:36.000000', 'consum', 0.0219, 'lps'),
	(499394, 130, '2014-01-15 00:17:37.000000', 'consum', 0.0210, 'lps'),
	(499395, 130, '2014-01-15 00:17:38.000000', 'consum', 0.0216, 'lps'),
	(499396, 130, '2014-01-15 00:17:39.000000', 'consum', 0.0224, 'lps'),
	(499397, 130, '2014-01-15 00:17:40.000000', 'consum', 0.0211, 'lps'),
	(499398, 130, '2014-01-15 00:17:41.000000', 'consum', 0.0223, 'lps'),
	(499399, 130, '2014-01-15 00:17:42.000000', 'consum', 0.0222, 'lps'),
	(499400, 130, '2014-01-15 00:17:43.000000', 'consum', 0.0214, 'lps'),
	(499401, 130, '2014-01-15 00:17:44.000000', 'consum', 0.0212, 'lps'),
	(499402, 130, '2014-01-15 00:17:45.000000', 'consum', 0.0226, 'lps'),
	(499403, 130, '2014-01-15 00:17:46.000000', 'consum', 0.0218, 'lps'),
	(499404, 130, '2014-01-15 00:17:47.000000', 'consum', 0.0220, 'lps'),
	(499405, 130, '2014-01-15 00:17:48.000000', 'consum', 0.0217, 'lps'),
	(499406, 130, '2014-01-15 00:17:49.000000', 'consum', 0.0215, 'lps'),
	(499407, 130, '2014-01-15 00:17:50.000000', 'consum', 0.0214, 'lps'),
	(499408, 130, '2014-01-15 00:17:51.000000', 'consum', 0.0217, 'lps'),
	(499409, 130, '2014-01-15 00:17:52.000000', 'consum', 0.0216, 'lps'),
	(499410, 130, '2014-01-15 00:17:53.000000', 'consum', 0.0218, 'lps'),
	(499411, 130, '2014-01-15 00:17:54.000000', 'consum', 0.0216, 'lps'),
	(499412, 130, '2014-01-15 00:17:55.000000', 'consum', 0.0215, 'lps'),
	(499413, 130, '2014-01-15 00:17:56.000000', 'consum', 0.0221, 'lps'),
	(499414, 130, '2014-01-15 00:17:57.000000', 'consum', 0.0213, 'lps'),
	(499415, 130, '2014-01-15 00:17:58.000000', 'consum', 0.0212, 'lps'),
	(499416, 130, '2014-01-15 00:17:59.000000', 'consum', 0.0210, 'lps'),
	(499417, 130, '2014-01-15 00:18:00.000000', 'consum', 0.0220, 'lps'),
	(499418, 130, '2014-01-15 00:18:01.000000', 'consum', 0.0212, 'lps'),
	(499419, 130, '2014-01-15 00:18:02.000000', 'consum', 0.0223, 'lps'),
	(499420, 130, '2014-01-15 00:18:03.000000', 'consum', 0.0219, 'lps'),
	(499421, 130, '2014-01-15 00:18:04.000000', 'consum', 0.0216, 'lps'),
	(499422, 130, '2014-01-15 00:18:05.000000', 'consum', 0.0213, 'lps'),
	(499423, 130, '2014-01-15 00:18:06.000000', 'consum', 0.0226, 'lps'),
	(499424, 130, '2014-01-15 00:18:07.000000', 'consum', 0.0211, 'lps'),
	(499425, 130, '2014-01-15 00:18:08.000000', 'consum', 0.0221, 'lps'),
	(499426, 130, '2014-01-15 00:18:09.000000', 'consum', 0.0210, 'lps'),
	(499427, 130, '2014-01-15 00:18:10.000000', 'consum', 0.0213, 'lps'),
	(499428, 130, '2014-01-15 00:18:11.000000', 'consum', 0.0224, 'lps'),
	(499429, 130, '2014-01-15 00:18:12.000000', 'consum', 0.0219, 'lps'),
	(499430, 130, '2014-01-15 00:18:13.000000', 'consum', 0.0216, 'lps'),
	(499431, 130, '2014-01-15 00:18:14.000000', 'consum', 0.0212, 'lps'),
	(499432, 130, '2014-01-15 00:18:15.000000', 'consum', 0.0221, 'lps'),
	(499433, 130, '2014-01-15 00:18:16.000000', 'consum', 0.0224, 'lps'),
	(499434, 130, '2014-01-15 00:18:17.000000', 'consum', 0.0214, 'lps'),
	(499435, 130, '2014-01-15 00:18:18.000000', 'consum', 0.0223, 'lps'),
	(499436, 130, '2014-01-15 00:18:19.000000', 'consum', 0.0213, 'lps'),
	(499437, 130, '2014-01-15 00:18:20.000000', 'consum', 0.0221, 'lps'),
	(499438, 130, '2014-01-15 00:18:21.000000', 'consum', 0.0223, 'lps'),
	(499439, 130, '2014-01-15 00:18:22.000000', 'consum', 0.0226, 'lps'),
	(499440, 130, '2014-01-15 00:18:23.000000', 'consum', 0.0217, 'lps'),
	(499441, 130, '2014-01-15 00:18:24.000000', 'consum', 0.0214, 'lps'),
	(499442, 130, '2014-01-15 00:18:25.000000', 'consum', 0.0211, 'lps'),
	(499443, 130, '2014-01-15 00:18:26.000000', 'consum', 0.0222, 'lps'),
	(499444, 130, '2014-01-15 00:18:27.000000', 'consum', 0.0213, 'lps'),
	(499445, 130, '2014-01-15 00:18:28.000000', 'consum', 0.0225, 'lps'),
	(499446, 130, '2014-01-15 00:18:29.000000', 'consum', 0.0226, 'lps'),
	(499447, 130, '2014-01-15 00:18:30.000000', 'consum', 0.0210, 'lps'),
	(499448, 130, '2014-01-15 00:18:31.000000', 'consum', 0.0213, 'lps'),
	(499449, 130, '2014-01-15 00:18:32.000000', 'consum', 0.0210, 'lps'),
	(499450, 130, '2014-01-15 00:18:33.000000', 'consum', 0.0219, 'lps'),
	(499451, 130, '2014-01-15 00:18:34.000000', 'consum', 0.0220, 'lps'),
	(499452, 130, '2014-01-15 00:18:35.000000', 'consum', 0.0216, 'lps'),
	(499453, 130, '2014-01-15 00:18:36.000000', 'consum', 0.0212, 'lps'),
	(499454, 130, '2014-01-15 00:18:37.000000', 'consum', 0.0217, 'lps'),
	(499455, 130, '2014-01-15 00:18:38.000000', 'consum', 0.0224, 'lps'),
	(499456, 130, '2014-01-15 00:18:39.000000', 'consum', 0.0226, 'lps'),
	(499457, 130, '2014-01-15 00:18:40.000000', 'consum', 0.0216, 'lps'),
	(499458, 130, '2014-01-15 00:18:41.000000', 'consum', 0.0223, 'lps'),
	(499459, 130, '2014-01-15 00:18:42.000000', 'consum', 0.0226, 'lps'),
	(499460, 130, '2014-01-15 00:18:43.000000', 'consum', 0.0216, 'lps'),
	(499461, 130, '2014-01-15 00:18:44.000000', 'consum', 0.0225, 'lps'),
	(499462, 130, '2014-01-15 00:18:45.000000', 'consum', 0.0219, 'lps'),
	(499463, 130, '2014-01-15 00:18:46.000000', 'consum', 0.0210, 'lps'),
	(499464, 130, '2014-01-15 00:18:47.000000', 'consum', 0.0219, 'lps'),
	(499465, 130, '2014-01-15 00:18:48.000000', 'consum', 0.0219, 'lps'),
	(499466, 130, '2014-01-15 00:18:49.000000', 'consum', 0.0213, 'lps'),
	(499467, 130, '2014-01-15 00:18:50.000000', 'consum', 0.0213, 'lps'),
	(499468, 130, '2014-01-15 00:18:51.000000', 'consum', 0.0219, 'lps'),
	(499469, 130, '2014-01-15 00:18:52.000000', 'consum', 0.0214, 'lps'),
	(499470, 130, '2014-01-15 00:18:53.000000', 'consum', 0.0219, 'lps'),
	(499471, 130, '2014-01-15 00:18:54.000000', 'consum', 0.0225, 'lps'),
	(499472, 130, '2014-01-15 00:18:55.000000', 'consum', 0.0225, 'lps'),
	(499473, 130, '2014-01-15 00:18:56.000000', 'consum', 0.0225, 'lps'),
	(499474, 130, '2014-01-15 00:18:57.000000', 'consum', 0.0224, 'lps'),
	(499475, 130, '2014-01-15 00:18:58.000000', 'consum', 0.0218, 'lps'),
	(499476, 130, '2014-01-15 00:18:59.000000', 'consum', 0.0226, 'lps'),
	(499477, 130, '2014-01-15 00:19:00.000000', 'consum', 0.0216, 'lps'),
	(499478, 130, '2014-01-15 00:19:01.000000', 'consum', 0.0225, 'lps'),
	(499479, 130, '2014-01-15 00:19:02.000000', 'consum', 0.0216, 'lps'),
	(499480, 130, '2014-01-15 00:19:03.000000', 'consum', 0.0214, 'lps'),
	(499481, 130, '2014-01-15 00:19:04.000000', 'consum', 0.0212, 'lps'),
	(499482, 130, '2014-01-15 00:19:05.000000', 'consum', 0.0224, 'lps'),
	(499483, 130, '2014-01-15 00:19:06.000000', 'consum', 0.0224, 'lps'),
	(499484, 130, '2014-01-15 00:19:07.000000', 'consum', 0.0222, 'lps'),
	(499485, 130, '2014-01-15 00:19:08.000000', 'consum', 0.0210, 'lps'),
	(499486, 130, '2014-01-15 00:19:09.000000', 'consum', 0.0226, 'lps'),
	(499487, 130, '2014-01-15 00:19:10.000000', 'consum', 0.0224, 'lps'),
	(499488, 130, '2014-01-15 00:19:11.000000', 'consum', 0.0216, 'lps'),
	(499489, 130, '2014-01-15 00:19:12.000000', 'consum', 0.0214, 'lps'),
	(499490, 130, '2014-01-15 00:19:13.000000', 'consum', 0.0212, 'lps'),
	(499491, 130, '2014-01-15 00:19:14.000000', 'consum', 0.0210, 'lps'),
	(499492, 130, '2014-01-15 00:19:15.000000', 'consum', 0.0220, 'lps'),
	(499493, 130, '2014-01-15 00:19:16.000000', 'consum', 0.0226, 'lps'),
	(499494, 130, '2014-01-15 00:19:17.000000', 'consum', 0.0212, 'lps'),
	(499495, 130, '2014-01-15 00:19:18.000000', 'consum', 0.0223, 'lps'),
	(499496, 130, '2014-01-15 00:19:19.000000', 'consum', 0.0218, 'lps'),
	(499497, 130, '2014-01-15 00:19:20.000000', 'consum', 0.0214, 'lps'),
	(499498, 130, '2014-01-15 00:19:21.000000', 'consum', 0.0220, 'lps'),
	(499499, 130, '2014-01-15 00:19:22.000000', 'consum', 0.0217, 'lps'),
	(499500, 130, '2014-01-15 00:19:23.000000', 'consum', 0.0214, 'lps'),
	(499501, 130, '2014-01-15 00:19:24.000000', 'consum', 0.0225, 'lps'),
	(499502, 130, '2014-01-15 00:19:25.000000', 'consum', 0.0224, 'lps'),
	(499503, 130, '2014-01-15 00:19:26.000000', 'consum', 0.0219, 'lps'),
	(499504, 130, '2014-01-15 00:19:27.000000', 'consum', 0.0212, 'lps'),
	(499505, 130, '2014-01-15 00:19:28.000000', 'consum', 0.0211, 'lps'),
	(499506, 130, '2014-01-15 00:19:29.000000', 'consum', 0.0225, 'lps'),
	(499507, 130, '2014-01-15 00:19:30.000000', 'consum', 0.0216, 'lps'),
	(499508, 130, '2014-01-15 00:19:31.000000', 'consum', 0.0211, 'lps'),
	(499509, 130, '2014-01-15 00:19:32.000000', 'consum', 0.0217, 'lps'),
	(499510, 130, '2014-01-15 00:19:33.000000', 'consum', 0.0224, 'lps'),
	(499511, 130, '2014-01-15 00:19:34.000000', 'consum', 0.0225, 'lps'),
	(499512, 130, '2014-01-15 00:19:35.000000', 'consum', 0.0210, 'lps'),
	(499513, 130, '2014-01-15 00:19:36.000000', 'consum', 0.0217, 'lps'),
	(499514, 130, '2014-01-15 00:19:37.000000', 'consum', 0.0210, 'lps'),
	(499515, 130, '2014-01-15 00:19:38.000000', 'consum', 0.0225, 'lps'),
	(499516, 130, '2014-01-15 00:19:39.000000', 'consum', 0.0218, 'lps'),
	(499517, 130, '2014-01-15 00:19:40.000000', 'consum', 0.0221, 'lps'),
	(499518, 130, '2014-01-15 00:19:41.000000', 'consum', 0.0210, 'lps'),
	(499519, 130, '2014-01-15 00:19:42.000000', 'consum', 0.0210, 'lps'),
	(499520, 130, '2014-01-15 00:19:43.000000', 'consum', 0.0226, 'lps'),
	(499521, 130, '2014-01-15 00:19:44.000000', 'consum', 0.0226, 'lps'),
	(499522, 130, '2014-01-15 00:19:45.000000', 'consum', 0.0222, 'lps'),
	(499523, 130, '2014-01-15 00:19:46.000000', 'consum', 0.0226, 'lps'),
	(499524, 130, '2014-01-15 00:19:47.000000', 'consum', 0.0218, 'lps'),
	(499525, 130, '2014-01-15 00:19:48.000000', 'consum', 0.0220, 'lps'),
	(499526, 130, '2014-01-15 00:19:49.000000', 'consum', 0.0222, 'lps'),
	(499527, 130, '2014-01-15 00:19:50.000000', 'consum', 0.0220, 'lps'),
	(499528, 130, '2014-01-15 00:19:51.000000', 'consum', 0.0226, 'lps'),
	(499529, 130, '2014-01-15 00:19:52.000000', 'consum', 0.0226, 'lps'),
	(499530, 130, '2014-01-15 00:19:53.000000', 'consum', 0.0210, 'lps'),
	(499531, 130, '2014-01-15 00:19:54.000000', 'consum', 0.0213, 'lps'),
	(499532, 130, '2014-01-15 00:19:55.000000', 'consum', 0.0210, 'lps'),
	(499533, 130, '2014-01-15 00:19:56.000000', 'consum', 0.0218, 'lps'),
	(499534, 130, '2014-01-15 00:19:57.000000', 'consum', 0.0217, 'lps'),
	(499535, 130, '2014-01-15 00:19:58.000000', 'consum', 0.0220, 'lps'),
	(499536, 130, '2014-01-15 00:19:59.000000', 'consum', 0.0224, 'lps'),
	(499537, 130, '2014-01-15 00:20:00.000000', 'consum', 0.0215, 'lps'),
	(499538, 130, '2014-01-15 00:20:01.000000', 'consum', 0.0212, 'lps'),
	(499539, 130, '2014-01-15 00:20:02.000000', 'consum', 0.0221, 'lps'),
	(499540, 130, '2014-01-15 00:20:03.000000', 'consum', 0.0226, 'lps'),
	(499541, 130, '2014-01-15 00:20:04.000000', 'consum', 0.0223, 'lps'),
	(499542, 130, '2014-01-15 00:20:05.000000', 'consum', 0.0211, 'lps'),
	(499543, 130, '2014-01-15 00:20:06.000000', 'consum', 0.0210, 'lps'),
	(499544, 130, '2014-01-15 00:20:07.000000', 'consum', 0.0224, 'lps'),
	(499545, 130, '2014-01-15 00:20:08.000000', 'consum', 0.0215, 'lps'),
	(499546, 130, '2014-01-15 00:20:09.000000', 'consum', 0.0226, 'lps'),
	(499547, 130, '2014-01-15 00:20:10.000000', 'consum', 0.0224, 'lps'),
	(499548, 130, '2014-01-15 00:20:11.000000', 'consum', 0.0215, 'lps'),
	(499549, 130, '2014-01-15 00:20:12.000000', 'consum', 0.0226, 'lps'),
	(499550, 130, '2014-01-15 00:20:13.000000', 'consum', 0.0210, 'lps'),
	(499551, 130, '2014-01-15 00:20:14.000000', 'consum', 0.0211, 'lps'),
	(499552, 130, '2014-01-15 00:20:15.000000', 'consum', 0.0218, 'lps'),
	(499553, 130, '2014-01-15 00:20:16.000000', 'consum', 0.0211, 'lps'),
	(499554, 130, '2014-01-15 00:20:17.000000', 'consum', 0.0210, 'lps'),
	(499555, 130, '2014-01-15 00:20:18.000000', 'consum', 0.0224, 'lps'),
	(499556, 130, '2014-01-15 00:20:19.000000', 'consum', 0.0213, 'lps'),
	(499557, 130, '2014-01-15 00:20:20.000000', 'consum', 0.0218, 'lps'),
	(499558, 130, '2014-01-15 00:20:21.000000', 'consum', 0.0223, 'lps'),
	(499559, 130, '2014-01-15 00:20:22.000000', 'consum', 0.0218, 'lps'),
	(499560, 130, '2014-01-15 00:20:23.000000', 'consum', 0.0210, 'lps'),
	(499561, 130, '2014-01-15 00:20:24.000000', 'consum', 0.0220, 'lps'),
	(499562, 130, '2014-01-15 00:20:25.000000', 'consum', 0.0226, 'lps'),
	(499563, 130, '2014-01-15 00:20:26.000000', 'consum', 0.0212, 'lps'),
	(499564, 130, '2014-01-15 00:20:27.000000', 'consum', 0.0221, 'lps'),
	(499565, 130, '2014-01-15 00:20:28.000000', 'consum', 0.0210, 'lps'),
	(499566, 130, '2014-01-15 00:20:29.000000', 'consum', 0.0211, 'lps'),
	(499567, 130, '2014-01-15 00:20:30.000000', 'consum', 0.0217, 'lps'),
	(499568, 130, '2014-01-15 00:20:31.000000', 'consum', 0.0226, 'lps'),
	(499569, 130, '2014-01-15 00:20:32.000000', 'consum', 0.0215, 'lps'),
	(499570, 130, '2014-01-15 00:20:33.000000', 'consum', 0.0225, 'lps'),
	(499571, 130, '2014-01-15 00:20:34.000000', 'consum', 0.0219, 'lps'),
	(499572, 130, '2014-01-15 00:20:35.000000', 'consum', 0.0226, 'lps'),
	(499573, 130, '2014-01-15 00:20:36.000000', 'consum', 0.0214, 'lps'),
	(499574, 130, '2014-01-15 00:20:37.000000', 'consum', 0.0216, 'lps'),
	(499575, 130, '2014-01-15 00:20:38.000000', 'consum', 0.0211, 'lps'),
	(499576, 130, '2014-01-15 00:20:39.000000', 'consum', 0.0213, 'lps'),
	(499577, 130, '2014-01-15 00:20:40.000000', 'consum', 0.0224, 'lps'),
	(499578, 130, '2014-01-15 00:20:41.000000', 'consum', 0.0219, 'lps'),
	(499579, 130, '2014-01-15 00:20:42.000000', 'consum', 0.0215, 'lps'),
	(499580, 130, '2014-01-15 00:20:43.000000', 'consum', 0.0210, 'lps'),
	(499581, 130, '2014-01-15 00:20:44.000000', 'consum', 0.0211, 'lps'),
	(499582, 130, '2014-01-15 00:20:45.000000', 'consum', 0.0214, 'lps'),
	(499583, 130, '2014-01-15 00:20:46.000000', 'consum', 0.0210, 'lps'),
	(499584, 130, '2014-01-15 00:20:47.000000', 'consum', 0.0219, 'lps'),
	(499585, 130, '2014-01-15 00:20:48.000000', 'consum', 0.0219, 'lps'),
	(499586, 130, '2014-01-15 00:20:49.000000', 'consum', 0.0210, 'lps'),
	(499587, 130, '2014-01-15 00:20:50.000000', 'consum', 0.0220, 'lps'),
	(499588, 130, '2014-01-15 00:20:51.000000', 'consum', 0.0225, 'lps'),
	(499589, 130, '2014-01-15 00:20:52.000000', 'consum', 0.0223, 'lps'),
	(499590, 130, '2014-01-15 00:20:53.000000', 'consum', 0.0215, 'lps'),
	(499591, 130, '2014-01-15 00:20:54.000000', 'consum', 0.0212, 'lps'),
	(499592, 130, '2014-01-15 00:20:55.000000', 'consum', 0.0222, 'lps'),
	(499593, 130, '2014-01-15 00:20:56.000000', 'consum', 0.0214, 'lps'),
	(499594, 130, '2014-01-15 00:20:57.000000', 'consum', 0.0212, 'lps'),
	(499595, 130, '2014-01-15 00:20:58.000000', 'consum', 0.0226, 'lps'),
	(499596, 130, '2014-01-15 00:20:59.000000', 'consum', 0.0216, 'lps'),
	(499597, 130, '2014-01-15 00:21:00.000000', 'consum', 0.0226, 'lps'),
	(499598, 130, '2014-01-15 00:21:01.000000', 'consum', 0.0222, 'lps'),
	(499599, 130, '2014-01-15 00:21:02.000000', 'consum', 0.0222, 'lps'),
	(499600, 130, '2014-01-15 00:21:03.000000', 'consum', 0.0216, 'lps'),
	(499601, 130, '2014-01-15 00:21:04.000000', 'consum', 0.0222, 'lps'),
	(499602, 130, '2014-01-15 00:21:05.000000', 'consum', 0.0221, 'lps'),
	(499603, 130, '2014-01-15 00:21:06.000000', 'consum', 0.0211, 'lps'),
	(499604, 130, '2014-01-15 00:21:07.000000', 'consum', 0.0217, 'lps'),
	(499605, 130, '2014-01-15 00:21:08.000000', 'consum', 0.0226, 'lps'),
	(499606, 130, '2014-01-15 00:21:09.000000', 'consum', 0.0217, 'lps'),
	(499607, 130, '2014-01-15 00:21:10.000000', 'consum', 0.0213, 'lps'),
	(499608, 130, '2014-01-15 00:21:11.000000', 'consum', 0.0223, 'lps'),
	(499609, 130, '2014-01-15 00:21:12.000000', 'consum', 0.0217, 'lps'),
	(499610, 130, '2014-01-15 00:21:13.000000', 'consum', 0.0224, 'lps'),
	(499611, 130, '2014-01-15 00:21:14.000000', 'consum', 0.0226, 'lps'),
	(499612, 130, '2014-01-15 00:21:15.000000', 'consum', 0.0215, 'lps'),
	(499613, 130, '2014-01-15 00:21:16.000000', 'consum', 0.0221, 'lps'),
	(499614, 130, '2014-01-15 00:21:17.000000', 'consum', 0.0215, 'lps'),
	(499615, 130, '2014-01-15 00:21:18.000000', 'consum', 0.0219, 'lps'),
	(499616, 130, '2014-01-15 00:21:19.000000', 'consum', 0.0224, 'lps'),
	(499617, 130, '2014-01-15 00:21:20.000000', 'consum', 0.0218, 'lps'),
	(499618, 130, '2014-01-15 00:21:21.000000', 'consum', 0.0225, 'lps'),
	(499619, 130, '2014-01-15 00:21:22.000000', 'consum', 0.0212, 'lps'),
	(499620, 130, '2014-01-15 00:21:23.000000', 'consum', 0.0210, 'lps'),
	(499621, 130, '2014-01-15 00:21:24.000000', 'consum', 0.0221, 'lps'),
	(499622, 130, '2014-01-15 00:21:25.000000', 'consum', 0.0215, 'lps'),
	(499623, 130, '2014-01-15 00:21:26.000000', 'consum', 0.0220, 'lps'),
	(499624, 130, '2014-01-15 00:21:27.000000', 'consum', 0.0212, 'lps'),
	(499625, 130, '2014-01-15 00:21:28.000000', 'consum', 0.0223, 'lps'),
	(499626, 130, '2014-01-15 00:21:29.000000', 'consum', 0.0221, 'lps'),
	(499627, 130, '2014-01-15 00:21:30.000000', 'consum', 0.0223, 'lps'),
	(499628, 130, '2014-01-15 00:21:31.000000', 'consum', 0.0210, 'lps'),
	(499629, 130, '2014-01-15 00:21:32.000000', 'consum', 0.0223, 'lps'),
	(499630, 130, '2014-01-15 00:21:33.000000', 'consum', 0.0224, 'lps'),
	(499631, 130, '2014-01-15 00:21:34.000000', 'consum', 0.0224, 'lps'),
	(499632, 130, '2014-01-15 00:21:35.000000', 'consum', 0.0220, 'lps'),
	(499633, 130, '2014-01-15 00:21:36.000000', 'consum', 0.0221, 'lps'),
	(499634, 130, '2014-01-15 00:21:37.000000', 'consum', 0.0220, 'lps'),
	(499635, 130, '2014-01-15 00:21:38.000000', 'consum', 0.0224, 'lps'),
	(499636, 130, '2014-01-15 00:21:39.000000', 'consum', 0.0217, 'lps'),
	(499637, 130, '2014-01-15 00:21:40.000000', 'consum', 0.0222, 'lps'),
	(499638, 130, '2014-01-15 00:21:41.000000', 'consum', 0.0214, 'lps'),
	(499639, 130, '2014-01-15 00:21:42.000000', 'consum', 0.0210, 'lps'),
	(499640, 130, '2014-01-15 00:21:43.000000', 'consum', 0.0218, 'lps'),
	(499641, 130, '2014-01-15 00:21:44.000000', 'consum', 0.0214, 'lps'),
	(499642, 130, '2014-01-15 00:21:45.000000', 'consum', 0.0225, 'lps'),
	(499643, 130, '2014-01-15 00:21:46.000000', 'consum', 0.0223, 'lps'),
	(499644, 130, '2014-01-15 00:21:47.000000', 'consum', 0.0213, 'lps'),
	(499645, 130, '2014-01-15 00:21:48.000000', 'consum', 0.0220, 'lps'),
	(499646, 130, '2014-01-15 00:21:49.000000', 'consum', 0.0218, 'lps'),
	(499647, 130, '2014-01-15 00:21:50.000000', 'consum', 0.0221, 'lps'),
	(499648, 130, '2014-01-15 00:21:51.000000', 'consum', 0.0222, 'lps'),
	(499649, 130, '2014-01-15 00:21:52.000000', 'consum', 0.0222, 'lps'),
	(499650, 130, '2014-01-15 00:21:53.000000', 'consum', 0.0218, 'lps'),
	(499651, 130, '2014-01-15 00:21:54.000000', 'consum', 0.0213, 'lps'),
	(499652, 130, '2014-01-15 00:21:55.000000', 'consum', 0.0218, 'lps'),
	(499653, 130, '2014-01-15 00:21:56.000000', 'consum', 0.0225, 'lps'),
	(499654, 130, '2014-01-15 00:21:57.000000', 'consum', 0.0211, 'lps'),
	(499655, 130, '2014-01-15 00:21:58.000000', 'consum', 0.0222, 'lps'),
	(499656, 130, '2014-01-15 00:21:59.000000', 'consum', 0.0218, 'lps'),
	(499657, 130, '2014-01-15 00:22:00.000000', 'consum', 0.0212, 'lps'),
	(499658, 130, '2014-01-15 00:22:01.000000', 'consum', 0.0214, 'lps'),
	(499659, 130, '2014-01-15 00:22:02.000000', 'consum', 0.0225, 'lps'),
	(499660, 130, '2014-01-15 00:22:03.000000', 'consum', 0.0222, 'lps'),
	(499661, 130, '2014-01-15 00:22:04.000000', 'consum', 0.0226, 'lps'),
	(499662, 130, '2014-01-15 00:22:05.000000', 'consum', 0.0219, 'lps'),
	(499663, 130, '2014-01-15 00:22:06.000000', 'consum', 0.0210, 'lps'),
	(499664, 130, '2014-01-15 00:22:07.000000', 'consum', 0.0217, 'lps'),
	(499665, 130, '2014-01-15 00:22:08.000000', 'consum', 0.0211, 'lps'),
	(499666, 130, '2014-01-15 00:22:09.000000', 'consum', 0.0211, 'lps'),
	(499667, 130, '2014-01-15 00:22:10.000000', 'consum', 0.0211, 'lps'),
	(499668, 130, '2014-01-15 00:22:11.000000', 'consum', 0.0215, 'lps'),
	(499669, 130, '2014-01-15 00:22:12.000000', 'consum', 0.0213, 'lps'),
	(499670, 130, '2014-01-15 00:22:13.000000', 'consum', 0.0212, 'lps'),
	(499671, 130, '2014-01-15 00:22:14.000000', 'consum', 0.0213, 'lps'),
	(499672, 130, '2014-01-15 00:22:15.000000', 'consum', 0.0219, 'lps'),
	(499673, 130, '2014-01-15 00:22:16.000000', 'consum', 0.0211, 'lps'),
	(499674, 130, '2014-01-15 00:22:17.000000', 'consum', 0.0221, 'lps'),
	(499675, 130, '2014-01-15 00:22:18.000000', 'consum', 0.0214, 'lps'),
	(499676, 130, '2014-01-15 00:22:19.000000', 'consum', 0.0215, 'lps'),
	(499677, 130, '2014-01-15 00:22:20.000000', 'consum', 0.0221, 'lps'),
	(499678, 130, '2014-01-15 00:22:21.000000', 'consum', 0.0218, 'lps'),
	(499679, 130, '2014-01-15 00:22:22.000000', 'consum', 0.0218, 'lps'),
	(499680, 130, '2014-01-15 00:22:23.000000', 'consum', 0.0226, 'lps'),
	(499681, 130, '2014-01-15 00:22:24.000000', 'consum', 0.0216, 'lps'),
	(499682, 130, '2014-01-15 00:22:25.000000', 'consum', 0.0211, 'lps'),
	(499683, 130, '2014-01-15 00:22:26.000000', 'consum', 0.0214, 'lps'),
	(499684, 130, '2014-01-15 00:22:27.000000', 'consum', 0.0210, 'lps'),
	(499685, 130, '2014-01-15 00:22:28.000000', 'consum', 0.0213, 'lps'),
	(499686, 130, '2014-01-15 00:22:29.000000', 'consum', 0.0212, 'lps'),
	(499687, 130, '2014-01-15 00:22:30.000000', 'consum', 0.0226, 'lps'),
	(499688, 130, '2014-01-15 00:22:31.000000', 'consum', 0.0218, 'lps'),
	(499689, 130, '2014-01-15 00:22:32.000000', 'consum', 0.0218, 'lps'),
	(499690, 130, '2014-01-15 00:22:33.000000', 'consum', 0.0211, 'lps'),
	(499691, 130, '2014-01-15 00:22:34.000000', 'consum', 0.0225, 'lps'),
	(499692, 130, '2014-01-15 00:22:35.000000', 'consum', 0.0214, 'lps'),
	(499693, 130, '2014-01-15 00:22:36.000000', 'consum', 0.0221, 'lps'),
	(499694, 130, '2014-01-15 00:22:37.000000', 'consum', 0.0219, 'lps'),
	(499695, 130, '2014-01-15 00:22:38.000000', 'consum', 0.0223, 'lps'),
	(499696, 130, '2014-01-15 00:22:39.000000', 'consum', 0.0214, 'lps'),
	(499697, 130, '2014-01-15 00:22:40.000000', 'consum', 0.0224, 'lps'),
	(499698, 130, '2014-01-15 00:22:41.000000', 'consum', 0.0219, 'lps'),
	(499699, 130, '2014-01-15 00:22:42.000000', 'consum', 0.0214, 'lps'),
	(499700, 130, '2014-01-15 00:22:43.000000', 'consum', 0.0220, 'lps'),
	(499701, 130, '2014-01-15 00:22:44.000000', 'consum', 0.0216, 'lps'),
	(499702, 130, '2014-01-15 00:22:45.000000', 'consum', 0.0211, 'lps'),
	(499703, 130, '2014-01-15 00:22:46.000000', 'consum', 0.0213, 'lps'),
	(499704, 130, '2014-01-15 00:22:47.000000', 'consum', 0.0223, 'lps'),
	(499705, 130, '2014-01-15 00:22:48.000000', 'consum', 0.0215, 'lps'),
	(499706, 130, '2014-01-15 00:22:49.000000', 'consum', 0.0214, 'lps'),
	(499707, 130, '2014-01-15 00:22:50.000000', 'consum', 0.0214, 'lps'),
	(499708, 130, '2014-01-15 00:22:51.000000', 'consum', 0.0218, 'lps'),
	(499709, 130, '2014-01-15 00:22:52.000000', 'consum', 0.0222, 'lps'),
	(499710, 130, '2014-01-15 00:22:53.000000', 'consum', 0.0214, 'lps'),
	(499711, 130, '2014-01-15 00:22:54.000000', 'consum', 0.0210, 'lps'),
	(499712, 130, '2014-01-15 00:22:55.000000', 'consum', 0.0217, 'lps'),
	(499713, 130, '2014-01-15 00:22:56.000000', 'consum', 0.0212, 'lps'),
	(499714, 130, '2014-01-15 00:22:57.000000', 'consum', 0.0216, 'lps'),
	(499715, 130, '2014-01-15 00:22:58.000000', 'consum', 0.0218, 'lps'),
	(499716, 130, '2014-01-15 00:22:59.000000', 'consum', 0.0217, 'lps'),
	(499717, 130, '2014-01-15 00:23:00.000000', 'consum', 0.0219, 'lps'),
	(499718, 130, '2014-01-15 00:23:01.000000', 'consum', 0.0220, 'lps'),
	(499719, 130, '2014-01-15 00:23:02.000000', 'consum', 0.0215, 'lps'),
	(499720, 130, '2014-01-15 00:23:03.000000', 'consum', 0.0223, 'lps'),
	(499721, 130, '2014-01-15 00:23:04.000000', 'consum', 0.0211, 'lps'),
	(499722, 130, '2014-01-15 00:23:05.000000', 'consum', 0.0224, 'lps'),
	(499723, 130, '2014-01-15 00:23:06.000000', 'consum', 0.0213, 'lps'),
	(499724, 130, '2014-01-15 00:23:07.000000', 'consum', 0.0215, 'lps'),
	(499725, 130, '2014-01-15 00:23:08.000000', 'consum', 0.0212, 'lps'),
	(499726, 130, '2014-01-15 00:23:09.000000', 'consum', 0.0219, 'lps'),
	(499727, 130, '2014-01-15 00:23:10.000000', 'consum', 0.0219, 'lps'),
	(499728, 130, '2014-01-15 00:23:11.000000', 'consum', 0.0210, 'lps'),
	(499729, 130, '2014-01-15 00:23:12.000000', 'consum', 0.0216, 'lps'),
	(499730, 130, '2014-01-15 00:23:13.000000', 'consum', 0.0223, 'lps'),
	(499731, 130, '2014-01-15 00:23:14.000000', 'consum', 0.0223, 'lps'),
	(499732, 130, '2014-01-15 00:23:15.000000', 'consum', 0.0222, 'lps'),
	(499733, 130, '2014-01-15 00:23:16.000000', 'consum', 0.0216, 'lps'),
	(499734, 130, '2014-01-15 00:23:17.000000', 'consum', 0.0219, 'lps'),
	(499735, 130, '2014-01-15 00:23:18.000000', 'consum', 0.0219, 'lps'),
	(499736, 130, '2014-01-15 00:23:19.000000', 'consum', 0.0213, 'lps'),
	(499737, 130, '2014-01-15 00:23:20.000000', 'consum', 0.0216, 'lps'),
	(499738, 130, '2014-01-15 00:23:21.000000', 'consum', 0.0215, 'lps'),
	(499739, 130, '2014-01-15 00:23:22.000000', 'consum', 0.0217, 'lps'),
	(499740, 130, '2014-01-15 00:23:23.000000', 'consum', 0.0212, 'lps'),
	(499741, 130, '2014-01-15 00:23:24.000000', 'consum', 0.0215, 'lps'),
	(499742, 130, '2014-01-15 00:23:25.000000', 'consum', 0.0216, 'lps'),
	(499743, 130, '2014-01-15 00:23:26.000000', 'consum', 0.0225, 'lps'),
	(499744, 130, '2014-01-15 00:23:27.000000', 'consum', 0.0215, 'lps'),
	(499745, 130, '2014-01-15 00:23:28.000000', 'consum', 0.0223, 'lps'),
	(499746, 130, '2014-01-15 00:23:29.000000', 'consum', 0.0212, 'lps'),
	(499747, 130, '2014-01-15 00:23:30.000000', 'consum', 0.0213, 'lps'),
	(499748, 130, '2014-01-15 00:23:31.000000', 'consum', 0.0221, 'lps'),
	(499749, 130, '2014-01-15 00:23:32.000000', 'consum', 0.0221, 'lps'),
	(499750, 130, '2014-01-15 00:23:33.000000', 'consum', 0.0219, 'lps'),
	(499751, 130, '2014-01-15 00:23:34.000000', 'consum', 0.0219, 'lps'),
	(499752, 130, '2014-01-15 00:23:35.000000', 'consum', 0.0212, 'lps'),
	(499753, 130, '2014-01-15 00:23:36.000000', 'consum', 0.0211, 'lps'),
	(499754, 130, '2014-01-15 00:23:37.000000', 'consum', 0.0226, 'lps'),
	(499755, 130, '2014-01-15 00:23:38.000000', 'consum', 0.0218, 'lps'),
	(499756, 130, '2014-01-15 00:23:39.000000', 'consum', 0.0222, 'lps'),
	(499757, 130, '2014-01-15 00:23:40.000000', 'consum', 0.0210, 'lps'),
	(499758, 130, '2014-01-15 00:23:41.000000', 'consum', 0.0210, 'lps'),
	(499759, 130, '2014-01-15 00:23:42.000000', 'consum', 0.0212, 'lps'),
	(499760, 130, '2014-01-15 00:23:43.000000', 'consum', 0.0218, 'lps'),
	(499761, 130, '2014-01-15 00:23:44.000000', 'consum', 0.0212, 'lps'),
	(499762, 130, '2014-01-15 00:23:45.000000', 'consum', 0.0214, 'lps'),
	(499763, 130, '2014-01-15 00:23:46.000000', 'consum', 0.0224, 'lps'),
	(499764, 130, '2014-01-15 00:23:47.000000', 'consum', 0.0218, 'lps'),
	(499765, 130, '2014-01-15 00:23:48.000000', 'consum', 0.0226, 'lps'),
	(499766, 130, '2014-01-15 00:23:49.000000', 'consum', 0.0216, 'lps'),
	(499767, 130, '2014-01-15 00:23:50.000000', 'consum', 0.0226, 'lps'),
	(499768, 130, '2014-01-15 00:23:51.000000', 'consum', 0.0222, 'lps'),
	(499769, 130, '2014-01-15 00:23:52.000000', 'consum', 0.0222, 'lps'),
	(499770, 130, '2014-01-15 00:23:53.000000', 'consum', 0.0216, 'lps'),
	(499771, 130, '2014-01-15 00:23:54.000000', 'consum', 0.0225, 'lps'),
	(499772, 130, '2014-01-15 00:23:55.000000', 'consum', 0.0213, 'lps'),
	(499773, 130, '2014-01-15 00:23:56.000000', 'consum', 0.0216, 'lps'),
	(499774, 130, '2014-01-15 00:23:57.000000', 'consum', 0.0215, 'lps'),
	(499775, 130, '2014-01-15 00:23:58.000000', 'consum', 0.0215, 'lps'),
	(499776, 130, '2014-01-15 00:23:59.000000', 'consum', 0.0223, 'lps'),
	(499777, 130, '2014-01-15 00:24:00.000000', 'consum', 0.0210, 'lps'),
	(499778, 130, '2014-01-15 00:24:01.000000', 'consum', 0.0222, 'lps'),
	(499779, 130, '2014-01-15 00:24:02.000000', 'consum', 0.0221, 'lps'),
	(499780, 130, '2014-01-15 00:24:03.000000', 'consum', 0.0226, 'lps'),
	(499781, 130, '2014-01-15 00:24:04.000000', 'consum', 0.0226, 'lps'),
	(499782, 130, '2014-01-15 00:24:05.000000', 'consum', 0.0225, 'lps'),
	(499783, 130, '2014-01-15 00:24:06.000000', 'consum', 0.0221, 'lps'),
	(499784, 130, '2014-01-15 00:24:07.000000', 'consum', 0.0219, 'lps'),
	(499785, 130, '2014-01-15 00:24:08.000000', 'consum', 0.0224, 'lps'),
	(499786, 130, '2014-01-15 00:24:09.000000', 'consum', 0.0218, 'lps'),
	(499787, 130, '2014-01-15 00:24:10.000000', 'consum', 0.0210, 'lps'),
	(499788, 130, '2014-01-15 00:24:11.000000', 'consum', 0.0222, 'lps'),
	(499789, 130, '2014-01-15 00:24:12.000000', 'consum', 0.0218, 'lps'),
	(499790, 130, '2014-01-15 00:24:13.000000', 'consum', 0.0214, 'lps'),
	(499791, 130, '2014-01-15 00:24:14.000000', 'consum', 0.0223, 'lps'),
	(499792, 130, '2014-01-15 00:24:15.000000', 'consum', 0.0215, 'lps'),
	(499793, 130, '2014-01-15 00:24:16.000000', 'consum', 0.0212, 'lps'),
	(499794, 130, '2014-01-15 00:24:17.000000', 'consum', 0.0224, 'lps'),
	(499795, 130, '2014-01-15 00:24:18.000000', 'consum', 0.0223, 'lps'),
	(499796, 130, '2014-01-15 00:24:19.000000', 'consum', 0.0218, 'lps'),
	(499797, 130, '2014-01-15 00:24:20.000000', 'consum', 0.0225, 'lps'),
	(499798, 130, '2014-01-15 00:24:21.000000', 'consum', 0.0213, 'lps'),
	(499799, 130, '2014-01-15 00:24:22.000000', 'consum', 0.0213, 'lps'),
	(499800, 130, '2014-01-15 00:24:23.000000', 'consum', 0.0216, 'lps'),
	(499801, 130, '2014-01-15 00:24:24.000000', 'consum', 0.0215, 'lps'),
	(499802, 130, '2014-01-15 00:24:25.000000', 'consum', 0.0217, 'lps'),
	(499803, 130, '2014-01-15 00:24:26.000000', 'consum', 0.0212, 'lps'),
	(499804, 130, '2014-01-15 00:24:27.000000', 'consum', 0.0218, 'lps'),
	(499805, 130, '2014-01-15 00:24:28.000000', 'consum', 0.0212, 'lps'),
	(499806, 130, '2014-01-15 00:24:29.000000', 'consum', 0.0214, 'lps'),
	(499807, 130, '2014-01-15 00:24:30.000000', 'consum', 0.0226, 'lps'),
	(499808, 130, '2014-01-15 00:24:31.000000', 'consum', 0.0224, 'lps'),
	(499809, 130, '2014-01-15 00:24:32.000000', 'consum', 0.0215, 'lps'),
	(499810, 130, '2014-01-15 00:24:33.000000', 'consum', 0.0212, 'lps'),
	(499811, 130, '2014-01-15 00:24:34.000000', 'consum', 0.0220, 'lps'),
	(499812, 130, '2014-01-15 00:24:35.000000', 'consum', 0.0224, 'lps'),
	(499813, 130, '2014-01-15 00:24:36.000000', 'consum', 0.0213, 'lps'),
	(499814, 130, '2014-01-15 00:24:37.000000', 'consum', 0.0220, 'lps'),
	(499815, 130, '2014-01-15 00:24:38.000000', 'consum', 0.0217, 'lps'),
	(499816, 130, '2014-01-15 00:24:39.000000', 'consum', 0.0214, 'lps'),
	(499817, 130, '2014-01-15 00:24:40.000000', 'consum', 0.0211, 'lps'),
	(499818, 130, '2014-01-15 00:24:41.000000', 'consum', 0.0221, 'lps'),
	(499819, 130, '2014-01-15 00:24:42.000000', 'consum', 0.0226, 'lps'),
	(499820, 130, '2014-01-15 00:24:43.000000', 'consum', 0.0224, 'lps'),
	(499821, 130, '2014-01-15 00:24:44.000000', 'consum', 0.0215, 'lps'),
	(499822, 130, '2014-01-15 00:24:45.000000', 'consum', 0.0210, 'lps'),
	(499823, 130, '2014-01-15 00:24:46.000000', 'consum', 0.0212, 'lps'),
	(499824, 130, '2014-01-15 00:24:47.000000', 'consum', 0.0222, 'lps'),
	(499825, 130, '2014-01-15 00:24:48.000000', 'consum', 0.0213, 'lps'),
	(499826, 130, '2014-01-15 00:24:49.000000', 'consum', 0.0225, 'lps'),
	(499827, 130, '2014-01-15 00:24:50.000000', 'consum', 0.0225, 'lps'),
	(499828, 130, '2014-01-15 00:24:51.000000', 'consum', 0.0225, 'lps'),
	(499829, 130, '2014-01-15 00:24:52.000000', 'consum', 0.0222, 'lps'),
	(499830, 130, '2014-01-15 00:24:53.000000', 'consum', 0.0225, 'lps'),
	(499831, 130, '2014-01-15 00:24:54.000000', 'consum', 0.0218, 'lps'),
	(499832, 130, '2014-01-15 00:24:55.000000', 'consum', 0.0220, 'lps'),
	(499833, 130, '2014-01-15 00:24:56.000000', 'consum', 0.0221, 'lps'),
	(499834, 130, '2014-01-15 00:24:57.000000', 'consum', 0.0217, 'lps'),
	(499835, 130, '2014-01-15 00:24:58.000000', 'consum', 0.0214, 'lps'),
	(499836, 130, '2014-01-15 00:24:59.000000', 'consum', 0.0210, 'lps'),
	(499837, 130, '2014-01-15 00:25:00.000000', 'consum', 0.0213, 'lps'),
	(499838, 130, '2014-01-15 00:25:01.000000', 'consum', 0.0226, 'lps'),
	(499839, 130, '2014-01-15 00:25:02.000000', 'consum', 0.0216, 'lps'),
	(499840, 130, '2014-01-15 00:25:03.000000', 'consum', 0.0223, 'lps'),
	(499841, 130, '2014-01-15 00:25:04.000000', 'consum', 0.0226, 'lps'),
	(499842, 130, '2014-01-15 00:25:05.000000', 'consum', 0.0218, 'lps'),
	(499843, 130, '2014-01-15 00:25:06.000000', 'consum', 0.0219, 'lps'),
	(499844, 130, '2014-01-15 00:25:07.000000', 'consum', 0.0215, 'lps'),
	(499845, 130, '2014-01-15 00:25:08.000000', 'consum', 0.0225, 'lps'),
	(499846, 130, '2014-01-15 00:25:09.000000', 'consum', 0.0218, 'lps'),
	(499847, 130, '2014-01-15 00:25:10.000000', 'consum', 0.0225, 'lps'),
	(499848, 130, '2014-01-15 00:25:11.000000', 'consum', 0.0226, 'lps'),
	(499849, 130, '2014-01-15 00:25:12.000000', 'consum', 0.0214, 'lps'),
	(499850, 130, '2014-01-15 00:25:13.000000', 'consum', 0.0213, 'lps'),
	(499851, 130, '2014-01-15 00:25:14.000000', 'consum', 0.0215, 'lps'),
	(499852, 130, '2014-01-15 00:25:15.000000', 'consum', 0.0225, 'lps'),
	(499853, 130, '2014-01-15 00:25:16.000000', 'consum', 0.0222, 'lps'),
	(499854, 130, '2014-01-15 00:25:17.000000', 'consum', 0.0224, 'lps'),
	(499855, 130, '2014-01-15 00:25:18.000000', 'consum', 0.0226, 'lps'),
	(499856, 130, '2014-01-15 00:25:19.000000', 'consum', 0.0217, 'lps'),
	(499857, 130, '2014-01-15 00:25:20.000000', 'consum', 0.0212, 'lps'),
	(499858, 130, '2014-01-15 00:25:21.000000', 'consum', 0.0216, 'lps'),
	(499859, 130, '2014-01-15 00:25:22.000000', 'consum', 0.0217, 'lps'),
	(499860, 130, '2014-01-15 00:25:23.000000', 'consum', 0.0211, 'lps'),
	(499861, 130, '2014-01-15 00:25:24.000000', 'consum', 0.0213, 'lps'),
	(499862, 130, '2014-01-15 00:25:25.000000', 'consum', 0.0224, 'lps'),
	(499863, 130, '2014-01-15 00:25:26.000000', 'consum', 0.0217, 'lps'),
	(499864, 130, '2014-01-15 00:25:27.000000', 'consum', 0.0223, 'lps'),
	(499865, 130, '2014-01-15 00:25:28.000000', 'consum', 0.0221, 'lps'),
	(499866, 130, '2014-01-15 00:25:29.000000', 'consum', 0.0226, 'lps'),
	(499867, 130, '2014-01-15 00:25:30.000000', 'consum', 0.0225, 'lps'),
	(499868, 130, '2014-01-15 00:25:31.000000', 'consum', 0.0219, 'lps'),
	(499869, 130, '2014-01-15 00:25:32.000000', 'consum', 0.0210, 'lps'),
	(499870, 130, '2014-01-15 00:25:33.000000', 'consum', 0.0217, 'lps'),
	(499871, 130, '2014-01-15 00:25:34.000000', 'consum', 0.0213, 'lps'),
	(499872, 130, '2014-01-15 00:25:35.000000', 'consum', 0.0219, 'lps'),
	(499873, 130, '2014-01-15 00:25:36.000000', 'consum', 0.0216, 'lps'),
	(499874, 130, '2014-01-15 00:25:37.000000', 'consum', 0.0211, 'lps'),
	(499875, 130, '2014-01-15 00:25:38.000000', 'consum', 0.0215, 'lps'),
	(499876, 130, '2014-01-15 00:25:39.000000', 'consum', 0.0217, 'lps'),
	(499877, 130, '2014-01-15 00:25:40.000000', 'consum', 0.0214, 'lps'),
	(499878, 130, '2014-01-15 00:25:41.000000', 'consum', 0.0226, 'lps'),
	(499879, 130, '2014-01-15 00:25:42.000000', 'consum', 0.0225, 'lps'),
	(499880, 130, '2014-01-15 00:25:43.000000', 'consum', 0.0223, 'lps'),
	(499881, 130, '2014-01-15 00:25:44.000000', 'consum', 0.0212, 'lps'),
	(499882, 130, '2014-01-15 00:25:45.000000', 'consum', 0.0218, 'lps'),
	(499883, 130, '2014-01-15 00:25:46.000000', 'consum', 0.0226, 'lps'),
	(499884, 130, '2014-01-15 00:25:47.000000', 'consum', 0.0217, 'lps'),
	(499885, 130, '2014-01-15 00:25:48.000000', 'consum', 0.0215, 'lps'),
	(499886, 130, '2014-01-15 00:25:49.000000', 'consum', 0.0212, 'lps'),
	(499887, 130, '2014-01-15 00:25:50.000000', 'consum', 0.0224, 'lps'),
	(499888, 130, '2014-01-15 00:25:51.000000', 'consum', 0.0224, 'lps'),
	(499889, 130, '2014-01-15 00:25:52.000000', 'consum', 0.0220, 'lps'),
	(499890, 130, '2014-01-15 00:25:53.000000', 'consum', 0.0218, 'lps'),
	(499891, 130, '2014-01-15 00:25:54.000000', 'consum', 0.0219, 'lps'),
	(499892, 130, '2014-01-15 00:25:55.000000', 'consum', 0.0217, 'lps'),
	(499893, 130, '2014-01-15 00:25:56.000000', 'consum', 0.0219, 'lps'),
	(499894, 130, '2014-01-15 00:25:57.000000', 'consum', 0.0218, 'lps'),
	(499895, 130, '2014-01-15 00:25:58.000000', 'consum', 0.0224, 'lps'),
	(499896, 130, '2014-01-15 00:25:59.000000', 'consum', 0.0220, 'lps'),
	(499897, 130, '2014-01-15 00:26:00.000000', 'consum', 0.0220, 'lps'),
	(499898, 130, '2014-01-15 00:26:01.000000', 'consum', 0.0211, 'lps'),
	(499899, 130, '2014-01-15 00:26:02.000000', 'consum', 0.0223, 'lps'),
	(499900, 130, '2014-01-15 00:26:03.000000', 'consum', 0.0220, 'lps'),
	(499901, 130, '2014-01-15 00:26:04.000000', 'consum', 0.0221, 'lps'),
	(499902, 130, '2014-01-15 00:26:05.000000', 'consum', 0.0221, 'lps'),
	(499903, 130, '2014-01-15 00:26:06.000000', 'consum', 0.0214, 'lps'),
	(499904, 130, '2014-01-15 00:26:07.000000', 'consum', 0.0214, 'lps'),
	(499905, 130, '2014-01-15 00:26:08.000000', 'consum', 0.0221, 'lps'),
	(499906, 130, '2014-01-15 00:26:09.000000', 'consum', 0.0218, 'lps'),
	(499907, 130, '2014-01-15 00:26:10.000000', 'consum', 0.0216, 'lps'),
	(499908, 130, '2014-01-15 00:26:11.000000', 'consum', 0.0216, 'lps'),
	(499909, 130, '2014-01-15 00:26:12.000000', 'consum', 0.0222, 'lps'),
	(499910, 130, '2014-01-15 00:26:13.000000', 'consum', 0.0222, 'lps'),
	(499911, 130, '2014-01-15 00:26:14.000000', 'consum', 0.0214, 'lps'),
	(499912, 130, '2014-01-15 00:26:15.000000', 'consum', 0.0212, 'lps'),
	(499913, 130, '2014-01-15 00:26:16.000000', 'consum', 0.0224, 'lps'),
	(499914, 130, '2014-01-15 00:26:17.000000', 'consum', 0.0225, 'lps'),
	(499915, 130, '2014-01-15 00:26:18.000000', 'consum', 0.0211, 'lps'),
	(499916, 130, '2014-01-15 00:26:19.000000', 'consum', 0.0221, 'lps'),
	(499917, 130, '2014-01-15 00:26:20.000000', 'consum', 0.0226, 'lps'),
	(499918, 130, '2014-01-15 00:26:21.000000', 'consum', 0.0225, 'lps'),
	(499919, 130, '2014-01-15 00:26:22.000000', 'consum', 0.0221, 'lps'),
	(499920, 130, '2014-01-15 00:26:23.000000', 'consum', 0.0219, 'lps'),
	(499921, 130, '2014-01-15 00:26:24.000000', 'consum', 0.0222, 'lps'),
	(499922, 130, '2014-01-15 00:26:25.000000', 'consum', 0.0226, 'lps'),
	(499923, 130, '2014-01-15 00:26:26.000000', 'consum', 0.0223, 'lps'),
	(499924, 130, '2014-01-15 00:26:27.000000', 'consum', 0.0226, 'lps'),
	(499925, 130, '2014-01-15 00:26:28.000000', 'consum', 0.0219, 'lps'),
	(499926, 130, '2014-01-15 00:26:29.000000', 'consum', 0.0222, 'lps'),
	(499927, 130, '2014-01-15 00:26:30.000000', 'consum', 0.0210, 'lps'),
	(499928, 130, '2014-01-15 00:26:31.000000', 'consum', 0.0225, 'lps'),
	(499929, 130, '2014-01-15 00:26:32.000000', 'consum', 0.0217, 'lps'),
	(499930, 130, '2014-01-15 00:26:33.000000', 'consum', 0.0216, 'lps'),
	(499931, 130, '2014-01-15 00:26:34.000000', 'consum', 0.0222, 'lps'),
	(499932, 130, '2014-01-15 00:26:35.000000', 'consum', 0.0220, 'lps'),
	(499933, 130, '2014-01-15 00:26:36.000000', 'consum', 0.0223, 'lps'),
	(499934, 130, '2014-01-15 00:26:37.000000', 'consum', 0.0212, 'lps'),
	(499935, 130, '2014-01-15 00:26:38.000000', 'consum', 0.0214, 'lps'),
	(499936, 130, '2014-01-15 00:26:39.000000', 'consum', 0.0225, 'lps'),
	(499937, 130, '2014-01-15 00:26:40.000000', 'consum', 0.0225, 'lps'),
	(499938, 130, '2014-01-15 00:26:41.000000', 'consum', 0.0220, 'lps'),
	(499939, 130, '2014-01-15 00:26:42.000000', 'consum', 0.0216, 'lps'),
	(499940, 130, '2014-01-15 00:26:43.000000', 'consum', 0.0210, 'lps'),
	(499941, 130, '2014-01-15 00:26:44.000000', 'consum', 0.0211, 'lps'),
	(499942, 130, '2014-01-15 00:26:45.000000', 'consum', 0.0216, 'lps'),
	(499943, 130, '2014-01-15 00:26:46.000000', 'consum', 0.0220, 'lps'),
	(499944, 130, '2014-01-15 00:26:47.000000', 'consum', 0.0225, 'lps'),
	(499945, 130, '2014-01-15 00:26:48.000000', 'consum', 0.0222, 'lps'),
	(499946, 130, '2014-01-15 00:26:49.000000', 'consum', 0.0223, 'lps'),
	(499947, 130, '2014-01-15 00:26:50.000000', 'consum', 0.0225, 'lps'),
	(499948, 130, '2014-01-15 00:26:51.000000', 'consum', 0.0211, 'lps'),
	(499949, 130, '2014-01-15 00:26:52.000000', 'consum', 0.0224, 'lps'),
	(499950, 130, '2014-01-15 00:26:53.000000', 'consum', 0.0224, 'lps'),
	(499951, 130, '2014-01-15 00:26:54.000000', 'consum', 0.0222, 'lps'),
	(499952, 130, '2014-01-15 00:26:55.000000', 'consum', 0.0211, 'lps'),
	(499953, 130, '2014-01-15 00:26:56.000000', 'consum', 0.0214, 'lps'),
	(499954, 130, '2014-01-15 00:26:57.000000', 'consum', 0.0225, 'lps'),
	(499955, 130, '2014-01-15 00:26:58.000000', 'consum', 0.0226, 'lps'),
	(499956, 130, '2014-01-15 00:26:59.000000', 'consum', 0.0211, 'lps'),
	(499957, 130, '2014-01-15 00:27:00.000000', 'consum', 0.0217, 'lps'),
	(499958, 130, '2014-01-15 00:27:01.000000', 'consum', 0.0210, 'lps'),
	(499959, 130, '2014-01-15 00:27:02.000000', 'consum', 0.0223, 'lps'),
	(499960, 130, '2014-01-15 00:27:03.000000', 'consum', 0.0223, 'lps'),
	(499961, 130, '2014-01-15 00:27:04.000000', 'consum', 0.0223, 'lps'),
	(499962, 130, '2014-01-15 00:27:05.000000', 'consum', 0.0216, 'lps'),
	(499963, 130, '2014-01-15 00:27:06.000000', 'consum', 0.0221, 'lps'),
	(499964, 130, '2014-01-15 00:27:07.000000', 'consum', 0.0211, 'lps'),
	(499965, 130, '2014-01-15 00:27:08.000000', 'consum', 0.0219, 'lps'),
	(499966, 130, '2014-01-15 00:27:09.000000', 'consum', 0.0219, 'lps'),
	(499967, 130, '2014-01-15 00:27:10.000000', 'consum', 0.0226, 'lps'),
	(499968, 130, '2014-01-15 00:27:11.000000', 'consum', 0.0216, 'lps'),
	(499969, 130, '2014-01-15 00:27:12.000000', 'consum', 0.0223, 'lps'),
	(499970, 130, '2014-01-15 00:27:13.000000', 'consum', 0.0225, 'lps'),
	(499971, 130, '2014-01-15 00:27:14.000000', 'consum', 0.0212, 'lps'),
	(499972, 130, '2014-01-15 00:27:15.000000', 'consum', 0.0211, 'lps'),
	(499973, 130, '2014-01-15 00:27:16.000000', 'consum', 0.0225, 'lps'),
	(499974, 130, '2014-01-15 00:27:17.000000', 'consum', 0.0214, 'lps'),
	(499975, 130, '2014-01-15 00:27:18.000000', 'consum', 0.0219, 'lps'),
	(499976, 130, '2014-01-15 00:27:19.000000', 'consum', 0.0226, 'lps'),
	(499977, 130, '2014-01-15 00:27:20.000000', 'consum', 0.0215, 'lps'),
	(499978, 130, '2014-01-15 00:27:21.000000', 'consum', 0.0222, 'lps'),
	(499979, 130, '2014-01-15 00:27:22.000000', 'consum', 0.0222, 'lps'),
	(499980, 130, '2014-01-15 00:27:23.000000', 'consum', 0.0215, 'lps'),
	(499981, 130, '2014-01-15 00:27:24.000000', 'consum', 0.0218, 'lps'),
	(499982, 130, '2014-01-15 00:27:25.000000', 'consum', 0.0217, 'lps'),
	(499983, 130, '2014-01-15 00:27:26.000000', 'consum', 0.0224, 'lps'),
	(499984, 130, '2014-01-15 00:27:27.000000', 'consum', 0.0224, 'lps'),
	(499985, 130, '2014-01-15 00:27:28.000000', 'consum', 0.0220, 'lps'),
	(499986, 130, '2014-01-15 00:27:29.000000', 'consum', 0.0219, 'lps'),
	(499987, 130, '2014-01-15 00:27:30.000000', 'consum', 0.0210, 'lps'),
	(499988, 130, '2014-01-15 00:27:31.000000', 'consum', 0.0216, 'lps'),
	(499989, 130, '2014-01-15 00:27:32.000000', 'consum', 0.0223, 'lps'),
	(499990, 130, '2014-01-15 00:27:33.000000', 'consum', 0.0224, 'lps'),
	(499991, 130, '2014-01-15 00:27:34.000000', 'consum', 0.0224, 'lps'),
	(499992, 130, '2014-01-15 00:27:35.000000', 'consum', 0.0224, 'lps'),
	(499993, 130, '2014-01-15 00:27:36.000000', 'consum', 0.0218, 'lps'),
	(499994, 130, '2014-01-15 00:27:37.000000', 'consum', 0.0212, 'lps'),
	(499995, 130, '2014-01-15 00:27:38.000000', 'consum', 0.0211, 'lps'),
	(499996, 130, '2014-01-15 00:27:39.000000', 'consum', 0.0225, 'lps'),
	(499997, 130, '2014-01-15 00:27:40.000000', 'consum', 0.0217, 'lps'),
	(499998, 130, '2014-01-15 00:27:41.000000', 'consum', 0.0218, 'lps'),
	(499999, 130, '2014-01-15 00:27:42.000000', 'consum', 0.0211, 'lps'),
	(500000, 130, '2014-01-15 00:27:43.000000', 'consum', 0.0210, 'lps'),
	(500001, 130, '2014-01-15 00:27:44.000000', 'consum', 0.0223, 'lps'),
	(500002, 130, '2014-01-15 00:27:45.000000', 'consum', 0.0210, 'lps'),
	(500003, 130, '2014-01-15 00:27:46.000000', 'consum', 0.0220, 'lps'),
	(500004, 130, '2014-01-15 00:27:47.000000', 'consum', 0.0212, 'lps'),
	(500005, 130, '2014-01-15 00:27:48.000000', 'consum', 0.0222, 'lps'),
	(500006, 130, '2014-01-15 00:27:49.000000', 'consum', 0.0216, 'lps'),
	(500007, 130, '2014-01-15 00:27:50.000000', 'consum', 0.0221, 'lps'),
	(500008, 130, '2014-01-15 00:27:51.000000', 'consum', 0.0214, 'lps'),
	(500009, 130, '2014-01-15 00:27:52.000000', 'consum', 0.0215, 'lps'),
	(500010, 130, '2014-01-15 00:27:53.000000', 'consum', 0.0223, 'lps'),
	(500011, 130, '2014-01-15 00:27:54.000000', 'consum', 0.0226, 'lps'),
	(500012, 130, '2014-01-15 00:27:55.000000', 'consum', 0.0217, 'lps'),
	(500013, 130, '2014-01-15 00:27:56.000000', 'consum', 0.0215, 'lps'),
	(500014, 130, '2014-01-15 00:27:57.000000', 'consum', 0.0214, 'lps'),
	(500015, 130, '2014-01-15 00:27:58.000000', 'consum', 0.0215, 'lps'),
	(500016, 130, '2014-01-15 00:27:59.000000', 'consum', 0.0226, 'lps'),
	(500017, 130, '2014-01-15 00:28:00.000000', 'consum', 0.0223, 'lps'),
	(500018, 130, '2014-01-15 00:28:01.000000', 'consum', 0.0211, 'lps'),
	(500019, 130, '2014-01-15 00:28:02.000000', 'consum', 0.0212, 'lps'),
	(500020, 130, '2014-01-15 00:28:03.000000', 'consum', 0.0216, 'lps'),
	(500021, 130, '2014-01-15 00:28:04.000000', 'consum', 0.0218, 'lps'),
	(500022, 130, '2014-01-15 00:28:05.000000', 'consum', 0.0213, 'lps'),
	(500023, 130, '2014-01-15 00:28:06.000000', 'consum', 0.0222, 'lps'),
	(500024, 130, '2014-01-15 00:28:07.000000', 'consum', 0.0210, 'lps'),
	(500025, 130, '2014-01-15 00:28:08.000000', 'consum', 0.0225, 'lps'),
	(500026, 130, '2014-01-15 00:28:09.000000', 'consum', 0.0216, 'lps'),
	(500027, 130, '2014-01-15 00:28:10.000000', 'consum', 0.0212, 'lps'),
	(500028, 130, '2014-01-15 00:28:11.000000', 'consum', 0.0220, 'lps'),
	(500029, 130, '2014-01-15 00:28:12.000000', 'consum', 0.0219, 'lps'),
	(500030, 130, '2014-01-15 00:28:13.000000', 'consum', 0.0226, 'lps'),
	(500031, 130, '2014-01-15 00:28:14.000000', 'consum', 0.0213, 'lps'),
	(500032, 130, '2014-01-15 00:28:15.000000', 'consum', 0.0226, 'lps'),
	(500033, 130, '2014-01-15 00:28:16.000000', 'consum', 0.0217, 'lps'),
	(500034, 130, '2014-01-15 00:28:17.000000', 'consum', 0.0214, 'lps'),
	(500035, 130, '2014-01-15 00:28:18.000000', 'consum', 0.0225, 'lps'),
	(500036, 130, '2014-01-15 00:28:19.000000', 'consum', 0.0222, 'lps'),
	(500037, 130, '2014-01-15 00:28:20.000000', 'consum', 0.0226, 'lps'),
	(500038, 130, '2014-01-15 00:28:21.000000', 'consum', 0.0222, 'lps'),
	(500039, 130, '2014-01-15 00:28:22.000000', 'consum', 0.0220, 'lps'),
	(500040, 130, '2014-01-15 00:28:23.000000', 'consum', 0.0226, 'lps'),
	(500041, 130, '2014-01-15 00:28:24.000000', 'consum', 0.0210, 'lps'),
	(500042, 130, '2014-01-15 00:28:25.000000', 'consum', 0.0214, 'lps'),
	(500043, 130, '2014-01-15 00:28:26.000000', 'consum', 0.0214, 'lps'),
	(500044, 130, '2014-01-15 00:28:27.000000', 'consum', 0.0219, 'lps'),
	(500045, 130, '2014-01-15 00:28:28.000000', 'consum', 0.0210, 'lps'),
	(500046, 130, '2014-01-15 00:28:29.000000', 'consum', 0.0217, 'lps'),
	(500047, 130, '2014-01-15 00:28:30.000000', 'consum', 0.0213, 'lps'),
	(500048, 130, '2014-01-15 00:28:31.000000', 'consum', 0.0218, 'lps'),
	(500049, 130, '2014-01-15 00:28:32.000000', 'consum', 0.0210, 'lps'),
	(500050, 130, '2014-01-15 00:28:33.000000', 'consum', 0.0218, 'lps'),
	(500051, 130, '2014-01-15 00:28:34.000000', 'consum', 0.0220, 'lps'),
	(500052, 130, '2014-01-15 00:28:35.000000', 'consum', 0.0216, 'lps'),
	(500053, 130, '2014-01-15 00:28:36.000000', 'consum', 0.0212, 'lps'),
	(500054, 130, '2014-01-15 00:28:37.000000', 'consum', 0.0218, 'lps'),
	(500055, 130, '2014-01-15 00:28:38.000000', 'consum', 0.0212, 'lps'),
	(500056, 130, '2014-01-15 00:28:39.000000', 'consum', 0.0211, 'lps'),
	(500057, 130, '2014-01-15 00:28:40.000000', 'consum', 0.0213, 'lps'),
	(500058, 130, '2014-01-15 00:28:41.000000', 'consum', 0.0221, 'lps'),
	(500059, 130, '2014-01-15 00:28:42.000000', 'consum', 0.0224, 'lps'),
	(500060, 130, '2014-01-15 00:28:43.000000', 'consum', 0.0211, 'lps'),
	(500061, 130, '2014-01-15 00:28:44.000000', 'consum', 0.0224, 'lps'),
	(500062, 130, '2014-01-15 00:28:45.000000', 'consum', 0.0210, 'lps'),
	(500063, 130, '2014-01-15 00:28:46.000000', 'consum', 0.0219, 'lps'),
	(500064, 130, '2014-01-15 00:28:47.000000', 'consum', 0.0223, 'lps'),
	(500065, 130, '2014-01-15 00:28:48.000000', 'consum', 0.0214, 'lps'),
	(500066, 130, '2014-01-15 00:28:49.000000', 'consum', 0.0226, 'lps'),
	(500067, 130, '2014-01-15 00:28:50.000000', 'consum', 0.0210, 'lps'),
	(500068, 130, '2014-01-15 00:28:51.000000', 'consum', 0.0215, 'lps'),
	(500069, 130, '2014-01-15 00:28:52.000000', 'consum', 0.0218, 'lps'),
	(500070, 130, '2014-01-15 00:28:53.000000', 'consum', 0.0218, 'lps'),
	(500071, 130, '2014-01-15 00:28:54.000000', 'consum', 0.0210, 'lps'),
	(500072, 130, '2014-01-15 00:28:55.000000', 'consum', 0.0222, 'lps'),
	(500073, 130, '2014-01-15 00:28:56.000000', 'consum', 0.0216, 'lps'),
	(500074, 130, '2014-01-15 00:28:57.000000', 'consum', 0.0224, 'lps'),
	(500075, 130, '2014-01-15 00:28:58.000000', 'consum', 0.0211, 'lps'),
	(500076, 130, '2014-01-15 00:28:59.000000', 'consum', 0.0222, 'lps'),
	(500077, 130, '2014-01-15 00:29:00.000000', 'consum', 0.0219, 'lps'),
	(500078, 130, '2014-01-15 00:29:01.000000', 'consum', 0.0220, 'lps'),
	(500079, 130, '2014-01-15 00:29:02.000000', 'consum', 0.0217, 'lps'),
	(500080, 130, '2014-01-15 00:29:03.000000', 'consum', 0.0213, 'lps'),
	(500081, 130, '2014-01-15 00:29:04.000000', 'consum', 0.0223, 'lps'),
	(500082, 130, '2014-01-15 00:29:05.000000', 'consum', 0.0213, 'lps'),
	(500083, 130, '2014-01-15 00:29:06.000000', 'consum', 0.0223, 'lps'),
	(500084, 130, '2014-01-15 00:29:07.000000', 'consum', 0.0213, 'lps'),
	(500085, 130, '2014-01-15 00:29:08.000000', 'consum', 0.0223, 'lps'),
	(500086, 130, '2014-01-15 00:29:09.000000', 'consum', 0.0214, 'lps'),
	(500087, 130, '2014-01-15 00:29:10.000000', 'consum', 0.0211, 'lps'),
	(500088, 130, '2014-01-15 00:29:11.000000', 'consum', 0.0219, 'lps'),
	(500089, 130, '2014-01-15 00:29:12.000000', 'consum', 0.0221, 'lps'),
	(500090, 130, '2014-01-15 00:29:13.000000', 'consum', 0.0218, 'lps'),
	(500091, 130, '2014-01-15 00:29:14.000000', 'consum', 0.0219, 'lps'),
	(500092, 130, '2014-01-15 00:29:15.000000', 'consum', 0.0215, 'lps'),
	(500093, 130, '2014-01-15 00:29:16.000000', 'consum', 0.0224, 'lps'),
	(500094, 130, '2014-01-15 00:29:17.000000', 'consum', 0.0217, 'lps'),
	(500095, 130, '2014-01-15 00:29:18.000000', 'consum', 0.0219, 'lps'),
	(500096, 130, '2014-01-15 00:29:19.000000', 'consum', 0.0217, 'lps'),
	(500097, 130, '2014-01-15 00:29:20.000000', 'consum', 0.0221, 'lps'),
	(500098, 130, '2014-01-15 00:29:21.000000', 'consum', 0.0210, 'lps'),
	(500099, 130, '2014-01-15 00:29:22.000000', 'consum', 0.0226, 'lps'),
	(500100, 130, '2014-01-15 00:29:23.000000', 'consum', 0.0223, 'lps'),
	(500101, 130, '2014-01-15 00:29:24.000000', 'consum', 0.0213, 'lps'),
	(500102, 130, '2014-01-15 00:29:25.000000', 'consum', 0.0218, 'lps'),
	(500103, 130, '2014-01-15 00:29:26.000000', 'consum', 0.0225, 'lps'),
	(500104, 130, '2014-01-15 00:29:27.000000', 'consum', 0.0211, 'lps'),
	(500105, 130, '2014-01-15 00:29:28.000000', 'consum', 0.0223, 'lps'),
	(500106, 130, '2014-01-15 00:29:29.000000', 'consum', 0.0219, 'lps'),
	(500107, 130, '2014-01-15 00:29:30.000000', 'consum', 0.0219, 'lps'),
	(500108, 130, '2014-01-15 00:29:31.000000', 'consum', 0.0225, 'lps'),
	(500109, 130, '2014-01-15 00:29:32.000000', 'consum', 0.0211, 'lps'),
	(500110, 130, '2014-01-15 00:29:33.000000', 'consum', 0.0219, 'lps'),
	(500111, 130, '2014-01-15 00:29:34.000000', 'consum', 0.0218, 'lps'),
	(500112, 130, '2014-01-15 00:29:35.000000', 'consum', 0.0224, 'lps'),
	(500113, 130, '2014-01-15 00:29:36.000000', 'consum', 0.0225, 'lps'),
	(500114, 130, '2014-01-15 00:29:37.000000', 'consum', 0.0223, 'lps'),
	(500115, 130, '2014-01-15 00:29:38.000000', 'consum', 0.0214, 'lps'),
	(500116, 130, '2014-01-15 00:29:39.000000', 'consum', 0.0211, 'lps'),
	(500117, 130, '2014-01-15 00:29:40.000000', 'consum', 0.0220, 'lps'),
	(500118, 130, '2014-01-15 00:29:41.000000', 'consum', 0.0224, 'lps'),
	(500119, 130, '2014-01-15 00:29:42.000000', 'consum', 0.0214, 'lps'),
	(500120, 130, '2014-01-15 00:29:43.000000', 'consum', 0.0225, 'lps'),
	(500121, 130, '2014-01-15 00:29:44.000000', 'consum', 0.0221, 'lps'),
	(500122, 130, '2014-01-15 00:29:45.000000', 'consum', 0.0222, 'lps'),
	(500123, 130, '2014-01-15 00:29:46.000000', 'consum', 0.0222, 'lps'),
	(500124, 130, '2014-01-15 00:29:47.000000', 'consum', 0.0214, 'lps'),
	(500125, 130, '2014-01-15 00:29:48.000000', 'consum', 0.0214, 'lps'),
	(500126, 130, '2014-01-15 00:29:49.000000', 'consum', 0.0216, 'lps'),
	(500127, 130, '2014-01-15 00:29:50.000000', 'consum', 0.0212, 'lps'),
	(500128, 130, '2014-01-15 00:29:51.000000', 'consum', 0.0222, 'lps'),
	(500129, 130, '2014-01-15 00:29:52.000000', 'consum', 0.0213, 'lps'),
	(500130, 130, '2014-01-15 00:29:53.000000', 'consum', 0.0221, 'lps'),
	(500131, 130, '2014-01-15 00:29:54.000000', 'consum', 0.0223, 'lps'),
	(500132, 130, '2014-01-15 00:29:55.000000', 'consum', 0.0210, 'lps'),
	(500133, 130, '2014-01-15 00:29:56.000000', 'consum', 0.0221, 'lps'),
	(500134, 130, '2014-01-15 00:29:57.000000', 'consum', 0.0217, 'lps'),
	(500135, 130, '2014-01-15 00:29:58.000000', 'consum', 0.0211, 'lps'),
	(500136, 130, '2014-01-15 00:29:59.000000', 'consum', 0.0213, 'lps'),
	(500137, 130, '2014-01-15 00:30:00.000000', 'consum', 0.0223, 'lps'),
	(500138, 130, '2014-01-15 00:30:01.000000', 'consum', 0.0212, 'lps'),
	(500139, 130, '2014-01-15 00:30:02.000000', 'consum', 0.0219, 'lps'),
	(500140, 130, '2014-01-15 00:30:03.000000', 'consum', 0.0214, 'lps'),
	(500141, 130, '2014-01-15 00:30:04.000000', 'consum', 0.0221, 'lps'),
	(500142, 130, '2014-01-15 00:30:05.000000', 'consum', 0.0219, 'lps'),
	(500143, 130, '2014-01-15 00:30:06.000000', 'consum', 0.0223, 'lps'),
	(500144, 130, '2014-01-15 00:30:07.000000', 'consum', 0.0214, 'lps'),
	(500145, 130, '2014-01-15 00:30:08.000000', 'consum', 0.0226, 'lps'),
	(500146, 130, '2014-01-15 00:30:09.000000', 'consum', 0.0210, 'lps'),
	(500147, 130, '2014-01-15 00:30:10.000000', 'consum', 0.0212, 'lps'),
	(500148, 130, '2014-01-15 00:30:11.000000', 'consum', 0.0221, 'lps'),
	(500149, 130, '2014-01-15 00:30:12.000000', 'consum', 0.0224, 'lps'),
	(500150, 130, '2014-01-15 00:30:13.000000', 'consum', 0.0216, 'lps'),
	(500151, 130, '2014-01-15 00:30:14.000000', 'consum', 0.0215, 'lps'),
	(500152, 130, '2014-01-15 00:30:15.000000', 'consum', 0.0218, 'lps'),
	(500153, 130, '2014-01-15 00:30:16.000000', 'consum', 0.0218, 'lps'),
	(500154, 130, '2014-01-15 00:30:17.000000', 'consum', 0.0226, 'lps'),
	(500155, 130, '2014-01-15 00:30:18.000000', 'consum', 0.0216, 'lps'),
	(500156, 130, '2014-01-15 00:30:19.000000', 'consum', 0.0210, 'lps'),
	(500157, 130, '2014-01-15 00:30:20.000000', 'consum', 0.0225, 'lps'),
	(500158, 130, '2014-01-15 00:30:21.000000', 'consum', 0.0217, 'lps'),
	(500159, 130, '2014-01-15 00:30:22.000000', 'consum', 0.0218, 'lps'),
	(500160, 130, '2014-01-15 00:30:23.000000', 'consum', 0.0211, 'lps'),
	(500161, 130, '2014-01-15 00:30:24.000000', 'consum', 0.0211, 'lps'),
	(500162, 130, '2014-01-15 00:30:25.000000', 'consum', 0.0210, 'lps'),
	(500163, 130, '2014-01-15 00:30:26.000000', 'consum', 0.0210, 'lps'),
	(500164, 130, '2014-01-15 00:30:27.000000', 'consum', 0.0211, 'lps'),
	(500165, 130, '2014-01-15 00:30:28.000000', 'consum', 0.0217, 'lps'),
	(500166, 130, '2014-01-15 00:30:29.000000', 'consum', 0.0222, 'lps'),
	(500167, 130, '2014-01-15 00:30:30.000000', 'consum', 0.0215, 'lps'),
	(500168, 130, '2014-01-15 00:30:31.000000', 'consum', 0.0219, 'lps'),
	(500169, 130, '2014-01-15 00:30:32.000000', 'consum', 0.0222, 'lps'),
	(500170, 130, '2014-01-15 00:30:33.000000', 'consum', 0.0211, 'lps'),
	(500171, 130, '2014-01-15 00:30:34.000000', 'consum', 0.0211, 'lps'),
	(500172, 130, '2014-01-15 00:30:35.000000', 'consum', 0.0214, 'lps'),
	(500173, 130, '2014-01-15 00:30:36.000000', 'consum', 0.0226, 'lps'),
	(500174, 130, '2014-01-15 00:30:37.000000', 'consum', 0.0213, 'lps'),
	(500175, 130, '2014-01-15 00:30:38.000000', 'consum', 0.0212, 'lps'),
	(500176, 130, '2014-01-15 00:30:39.000000', 'consum', 0.0211, 'lps'),
	(500177, 130, '2014-01-15 00:30:40.000000', 'consum', 0.0224, 'lps'),
	(500178, 130, '2014-01-15 00:30:41.000000', 'consum', 0.0211, 'lps'),
	(500179, 130, '2014-01-15 00:30:42.000000', 'consum', 0.0225, 'lps'),
	(500180, 130, '2014-01-15 00:30:43.000000', 'consum', 0.0213, 'lps'),
	(500181, 130, '2014-01-15 00:30:44.000000', 'consum', 0.0213, 'lps'),
	(500182, 130, '2014-01-15 00:30:45.000000', 'consum', 0.0220, 'lps'),
	(500183, 130, '2014-01-15 00:30:46.000000', 'consum', 0.0216, 'lps'),
	(500184, 130, '2014-01-15 00:30:47.000000', 'consum', 0.0213, 'lps'),
	(500185, 130, '2014-01-15 00:30:48.000000', 'consum', 0.0221, 'lps'),
	(500186, 130, '2014-01-15 00:30:49.000000', 'consum', 0.0225, 'lps'),
	(500187, 130, '2014-01-15 00:30:50.000000', 'consum', 0.0218, 'lps'),
	(500188, 130, '2014-01-15 00:30:51.000000', 'consum', 0.0222, 'lps'),
	(500189, 130, '2014-01-15 00:30:52.000000', 'consum', 0.0214, 'lps'),
	(500190, 130, '2014-01-15 00:30:53.000000', 'consum', 0.0210, 'lps'),
	(500191, 130, '2014-01-15 00:30:54.000000', 'consum', 0.0217, 'lps'),
	(500192, 130, '2014-01-15 00:30:55.000000', 'consum', 0.0226, 'lps'),
	(500193, 130, '2014-01-15 00:30:56.000000', 'consum', 0.0222, 'lps'),
	(500194, 130, '2014-01-15 00:30:57.000000', 'consum', 0.0220, 'lps'),
	(500195, 130, '2014-01-15 00:30:58.000000', 'consum', 0.0224, 'lps'),
	(500196, 130, '2014-01-15 00:30:59.000000', 'consum', 0.0217, 'lps'),
	(500197, 130, '2014-01-15 00:31:00.000000', 'consum', 0.0221, 'lps'),
	(500198, 130, '2014-01-15 00:31:01.000000', 'consum', 0.0225, 'lps'),
	(500199, 130, '2014-01-15 00:31:02.000000', 'consum', 0.0221, 'lps'),
	(500200, 130, '2014-01-15 00:31:03.000000', 'consum', 0.0220, 'lps'),
	(500201, 130, '2014-01-15 00:31:04.000000', 'consum', 0.0226, 'lps'),
	(500202, 130, '2014-01-15 00:31:05.000000', 'consum', 0.0212, 'lps'),
	(500203, 130, '2014-01-15 00:31:06.000000', 'consum', 0.0223, 'lps'),
	(500204, 130, '2014-01-15 00:31:07.000000', 'consum', 0.0216, 'lps'),
	(500205, 130, '2014-01-15 00:31:08.000000', 'consum', 0.0221, 'lps'),
	(500206, 130, '2014-01-15 00:31:09.000000', 'consum', 0.0211, 'lps'),
	(500207, 130, '2014-01-15 00:31:10.000000', 'consum', 0.0217, 'lps'),
	(500208, 130, '2014-01-15 00:31:11.000000', 'consum', 0.0224, 'lps'),
	(500209, 130, '2014-01-15 00:31:12.000000', 'consum', 0.0212, 'lps'),
	(500210, 130, '2014-01-15 00:31:13.000000', 'consum', 0.0210, 'lps'),
	(500211, 130, '2014-01-15 00:31:14.000000', 'consum', 0.0224, 'lps'),
	(500212, 130, '2014-01-15 00:31:15.000000', 'consum', 0.0211, 'lps'),
	(500213, 130, '2014-01-15 00:31:16.000000', 'consum', 0.0226, 'lps'),
	(500214, 130, '2014-01-15 00:31:17.000000', 'consum', 0.0220, 'lps'),
	(500215, 130, '2014-01-15 00:31:18.000000', 'consum', 0.0211, 'lps'),
	(500216, 130, '2014-01-15 00:31:19.000000', 'consum', 0.0220, 'lps'),
	(500217, 130, '2014-01-15 00:31:20.000000', 'consum', 0.0225, 'lps'),
	(500218, 130, '2014-01-15 00:31:21.000000', 'consum', 0.0220, 'lps'),
	(500219, 130, '2014-01-15 00:31:22.000000', 'consum', 0.0215, 'lps'),
	(500220, 130, '2014-01-15 00:31:23.000000', 'consum', 0.0221, 'lps'),
	(500221, 130, '2014-01-15 00:31:24.000000', 'consum', 0.0218, 'lps'),
	(500222, 130, '2014-01-15 00:31:25.000000', 'consum', 0.0218, 'lps'),
	(500223, 130, '2014-01-15 00:31:26.000000', 'consum', 0.0225, 'lps'),
	(500224, 130, '2014-01-15 00:31:27.000000', 'consum', 0.0212, 'lps'),
	(500225, 130, '2014-01-15 00:31:28.000000', 'consum', 0.0226, 'lps'),
	(500226, 130, '2014-01-15 00:31:29.000000', 'consum', 0.0216, 'lps'),
	(500227, 130, '2014-01-15 00:31:30.000000', 'consum', 0.0212, 'lps'),
	(500228, 130, '2014-01-15 00:31:31.000000', 'consum', 0.0216, 'lps'),
	(500229, 130, '2014-01-15 00:31:32.000000', 'consum', 0.0220, 'lps'),
	(500230, 130, '2014-01-15 00:31:33.000000', 'consum', 0.0210, 'lps'),
	(500231, 130, '2014-01-15 00:31:34.000000', 'consum', 0.0211, 'lps'),
	(500232, 130, '2014-01-15 00:31:35.000000', 'consum', 0.0216, 'lps'),
	(500233, 130, '2014-01-15 00:31:36.000000', 'consum', 0.0223, 'lps'),
	(500234, 130, '2014-01-15 00:31:37.000000', 'consum', 0.0223, 'lps'),
	(500235, 130, '2014-01-15 00:31:38.000000', 'consum', 0.0219, 'lps'),
	(500236, 130, '2014-01-15 00:31:39.000000', 'consum', 0.0217, 'lps'),
	(500237, 130, '2014-01-15 00:31:40.000000', 'consum', 0.0217, 'lps'),
	(500238, 130, '2014-01-15 00:31:41.000000', 'consum', 0.0223, 'lps'),
	(500239, 130, '2014-01-15 00:31:42.000000', 'consum', 0.0224, 'lps'),
	(500240, 130, '2014-01-15 00:31:43.000000', 'consum', 0.0222, 'lps'),
	(500241, 130, '2014-01-15 00:31:44.000000', 'consum', 0.0214, 'lps'),
	(500242, 130, '2014-01-15 00:31:45.000000', 'consum', 0.0226, 'lps'),
	(500243, 130, '2014-01-15 00:31:46.000000', 'consum', 0.0211, 'lps'),
	(500244, 130, '2014-01-15 00:31:47.000000', 'consum', 0.0220, 'lps'),
	(500245, 130, '2014-01-15 00:31:48.000000', 'consum', 0.0222, 'lps'),
	(500246, 130, '2014-01-15 00:31:49.000000', 'consum', 0.0226, 'lps'),
	(500247, 130, '2014-01-15 00:31:50.000000', 'consum', 0.0218, 'lps'),
	(500248, 130, '2014-01-15 00:31:51.000000', 'consum', 0.0221, 'lps'),
	(500249, 130, '2014-01-15 00:31:52.000000', 'consum', 0.0224, 'lps'),
	(500250, 130, '2014-01-15 00:31:53.000000', 'consum', 0.0212, 'lps'),
	(500251, 130, '2014-01-15 00:31:54.000000', 'consum', 0.0212, 'lps'),
	(500252, 130, '2014-01-15 00:31:55.000000', 'consum', 0.0214, 'lps'),
	(500253, 130, '2014-01-15 00:31:56.000000', 'consum', 0.0226, 'lps'),
	(500254, 130, '2014-01-15 00:31:57.000000', 'consum', 0.0212, 'lps'),
	(500255, 130, '2014-01-15 00:31:58.000000', 'consum', 0.0223, 'lps'),
	(500256, 130, '2014-01-15 00:31:59.000000', 'consum', 0.0219, 'lps'),
	(500257, 130, '2014-01-15 00:32:00.000000', 'consum', 0.0217, 'lps'),
	(500258, 130, '2014-01-15 00:32:01.000000', 'consum', 0.0216, 'lps'),
	(500259, 130, '2014-01-15 00:32:02.000000', 'consum', 0.0222, 'lps'),
	(500260, 130, '2014-01-15 00:32:03.000000', 'consum', 0.0217, 'lps'),
	(500261, 130, '2014-01-15 00:32:04.000000', 'consum', 0.0226, 'lps'),
	(500262, 130, '2014-01-15 00:32:05.000000', 'consum', 0.0220, 'lps'),
	(500263, 130, '2014-01-15 00:32:06.000000', 'consum', 0.0213, 'lps'),
	(500264, 130, '2014-01-15 00:32:07.000000', 'consum', 0.0210, 'lps'),
	(500265, 130, '2014-01-15 00:32:08.000000', 'consum', 0.0220, 'lps'),
	(500266, 130, '2014-01-15 00:32:09.000000', 'consum', 0.0211, 'lps'),
	(500267, 130, '2014-01-15 00:32:10.000000', 'consum', 0.0217, 'lps'),
	(500268, 130, '2014-01-15 00:32:11.000000', 'consum', 0.0211, 'lps'),
	(500269, 130, '2014-01-15 00:32:12.000000', 'consum', 0.0225, 'lps'),
	(500270, 130, '2014-01-15 00:32:13.000000', 'consum', 0.0218, 'lps'),
	(500271, 130, '2014-01-15 00:32:14.000000', 'consum', 0.0221, 'lps'),
	(500272, 130, '2014-01-15 00:32:15.000000', 'consum', 0.0224, 'lps'),
	(500273, 130, '2014-01-15 00:32:16.000000', 'consum', 0.0214, 'lps'),
	(500274, 130, '2014-01-15 00:32:17.000000', 'consum', 0.0221, 'lps'),
	(500275, 130, '2014-01-15 00:32:18.000000', 'consum', 0.0222, 'lps'),
	(500276, 130, '2014-01-15 00:32:19.000000', 'consum', 0.0218, 'lps'),
	(500277, 130, '2014-01-15 00:32:20.000000', 'consum', 0.0216, 'lps'),
	(500278, 130, '2014-01-15 00:32:21.000000', 'consum', 0.0215, 'lps'),
	(500279, 130, '2014-01-15 00:32:22.000000', 'consum', 0.0216, 'lps'),
	(500280, 130, '2014-01-15 00:32:23.000000', 'consum', 0.0211, 'lps'),
	(500281, 130, '2014-01-15 00:32:24.000000', 'consum', 0.0213, 'lps'),
	(500282, 130, '2014-01-15 00:32:25.000000', 'consum', 0.0224, 'lps'),
	(500283, 130, '2014-01-15 00:32:26.000000', 'consum', 0.0220, 'lps'),
	(500284, 130, '2014-01-15 00:32:27.000000', 'consum', 0.0218, 'lps'),
	(500285, 130, '2014-01-15 00:32:28.000000', 'consum', 0.0220, 'lps'),
	(500286, 130, '2014-01-15 00:32:29.000000', 'consum', 0.0220, 'lps'),
	(500287, 130, '2014-01-15 00:32:30.000000', 'consum', 0.0214, 'lps'),
	(500288, 130, '2014-01-15 00:32:31.000000', 'consum', 0.0218, 'lps'),
	(500289, 130, '2014-01-15 00:32:32.000000', 'consum', 0.0222, 'lps'),
	(500290, 130, '2014-01-15 00:32:33.000000', 'consum', 0.0210, 'lps'),
	(500291, 130, '2014-01-15 00:32:34.000000', 'consum', 0.0225, 'lps'),
	(500292, 130, '2014-01-15 00:32:35.000000', 'consum', 0.0220, 'lps'),
	(500293, 130, '2014-01-15 00:32:36.000000', 'consum', 0.0217, 'lps'),
	(500294, 130, '2014-01-15 00:32:37.000000', 'consum', 0.0212, 'lps'),
	(500295, 130, '2014-01-15 00:32:38.000000', 'consum', 0.0217, 'lps'),
	(500296, 130, '2014-01-15 00:32:39.000000', 'consum', 0.0222, 'lps'),
	(500297, 130, '2014-01-15 00:32:40.000000', 'consum', 0.0214, 'lps'),
	(500298, 130, '2014-01-15 00:32:41.000000', 'consum', 0.0215, 'lps'),
	(500299, 130, '2014-01-15 00:32:42.000000', 'consum', 0.0221, 'lps'),
	(500300, 130, '2014-01-15 00:32:43.000000', 'consum', 0.0217, 'lps'),
	(500301, 130, '2014-01-15 00:32:44.000000', 'consum', 0.0211, 'lps'),
	(500302, 130, '2014-01-15 00:32:45.000000', 'consum', 0.0213, 'lps'),
	(500303, 130, '2014-01-15 00:32:46.000000', 'consum', 0.0223, 'lps'),
	(500304, 130, '2014-01-15 00:32:47.000000', 'consum', 0.0213, 'lps'),
	(500305, 130, '2014-01-15 00:32:48.000000', 'consum', 0.0224, 'lps'),
	(500306, 130, '2014-01-15 00:32:49.000000', 'consum', 0.0217, 'lps'),
	(500307, 130, '2014-01-15 00:32:50.000000', 'consum', 0.0223, 'lps'),
	(500308, 130, '2014-01-15 00:32:51.000000', 'consum', 0.0222, 'lps'),
	(500309, 130, '2014-01-15 00:32:52.000000', 'consum', 0.0212, 'lps'),
	(500310, 130, '2014-01-15 00:32:53.000000', 'consum', 0.0221, 'lps'),
	(500311, 130, '2014-01-15 00:32:54.000000', 'consum', 0.0222, 'lps'),
	(500312, 130, '2014-01-15 00:32:55.000000', 'consum', 0.0224, 'lps'),
	(500313, 130, '2014-01-15 00:32:56.000000', 'consum', 0.0226, 'lps'),
	(500314, 130, '2014-01-15 00:32:57.000000', 'consum', 0.0215, 'lps'),
	(500315, 130, '2014-01-15 00:32:58.000000', 'consum', 0.0223, 'lps'),
	(500316, 130, '2014-01-15 00:32:59.000000', 'consum', 0.0225, 'lps'),
	(500317, 130, '2014-01-15 00:33:00.000000', 'consum', 0.0213, 'lps'),
	(500318, 130, '2014-01-15 00:33:01.000000', 'consum', 0.0214, 'lps'),
	(500319, 130, '2014-01-15 00:33:02.000000', 'consum', 0.0220, 'lps'),
	(500320, 130, '2014-01-15 00:33:03.000000', 'consum', 0.0214, 'lps'),
	(500321, 130, '2014-01-15 00:33:04.000000', 'consum', 0.0219, 'lps'),
	(500322, 130, '2014-01-15 00:33:05.000000', 'consum', 0.0226, 'lps'),
	(500323, 130, '2014-01-15 00:33:06.000000', 'consum', 0.0213, 'lps'),
	(500324, 130, '2014-01-15 00:33:07.000000', 'consum', 0.0210, 'lps'),
	(500325, 130, '2014-01-15 00:33:08.000000', 'consum', 0.0221, 'lps'),
	(500326, 130, '2014-01-15 00:33:09.000000', 'consum', 0.0215, 'lps'),
	(500327, 130, '2014-01-15 00:33:10.000000', 'consum', 0.0218, 'lps'),
	(500328, 130, '2014-01-15 00:33:11.000000', 'consum', 0.0221, 'lps'),
	(500329, 130, '2014-01-15 00:33:12.000000', 'consum', 0.0221, 'lps'),
	(500330, 130, '2014-01-15 00:33:13.000000', 'consum', 0.0216, 'lps'),
	(500331, 130, '2014-01-15 00:33:14.000000', 'consum', 0.0210, 'lps'),
	(500332, 130, '2014-01-15 00:33:15.000000', 'consum', 0.0223, 'lps'),
	(500333, 130, '2014-01-15 00:33:16.000000', 'consum', 0.0210, 'lps'),
	(500334, 130, '2014-01-15 00:33:17.000000', 'consum', 0.0222, 'lps'),
	(500335, 130, '2014-01-15 00:33:18.000000', 'consum', 0.0220, 'lps'),
	(500336, 130, '2014-01-15 00:33:19.000000', 'consum', 0.0223, 'lps'),
	(500337, 130, '2014-01-15 00:33:20.000000', 'consum', 0.0210, 'lps'),
	(500338, 130, '2014-01-15 00:33:21.000000', 'consum', 0.0225, 'lps'),
	(500339, 130, '2014-01-15 00:33:22.000000', 'consum', 0.0216, 'lps'),
	(500340, 130, '2014-01-15 00:33:23.000000', 'consum', 0.0215, 'lps'),
	(500341, 130, '2014-01-15 00:33:24.000000', 'consum', 0.0216, 'lps'),
	(500342, 130, '2014-01-15 00:33:25.000000', 'consum', 0.0225, 'lps'),
	(500343, 130, '2014-01-15 00:33:26.000000', 'consum', 0.0218, 'lps'),
	(500344, 130, '2014-01-15 00:33:27.000000', 'consum', 0.0221, 'lps'),
	(500345, 130, '2014-01-15 00:33:28.000000', 'consum', 0.0226, 'lps'),
	(500346, 130, '2014-01-15 00:33:29.000000', 'consum', 0.0224, 'lps'),
	(500347, 130, '2014-01-15 00:33:30.000000', 'consum', 0.0214, 'lps'),
	(500348, 130, '2014-01-15 00:33:31.000000', 'consum', 0.0223, 'lps'),
	(500349, 130, '2014-01-15 00:33:32.000000', 'consum', 0.0214, 'lps'),
	(500350, 130, '2014-01-15 00:33:33.000000', 'consum', 0.0210, 'lps'),
	(500351, 130, '2014-01-15 00:33:34.000000', 'consum', 0.0212, 'lps'),
	(500352, 130, '2014-01-15 00:33:35.000000', 'consum', 0.0220, 'lps'),
	(500353, 130, '2014-01-15 00:33:36.000000', 'consum', 0.0224, 'lps'),
	(500354, 130, '2014-01-15 00:33:37.000000', 'consum', 0.0213, 'lps'),
	(500355, 130, '2014-01-15 00:33:38.000000', 'consum', 0.0219, 'lps'),
	(500356, 130, '2014-01-15 00:33:39.000000', 'consum', 0.0212, 'lps'),
	(500357, 130, '2014-01-15 00:33:40.000000', 'consum', 0.0226, 'lps'),
	(500358, 130, '2014-01-15 00:33:41.000000', 'consum', 0.0217, 'lps'),
	(500359, 130, '2014-01-15 00:33:42.000000', 'consum', 0.0216, 'lps'),
	(500360, 130, '2014-01-15 00:33:43.000000', 'consum', 0.0220, 'lps'),
	(500361, 130, '2014-01-15 00:33:44.000000', 'consum', 0.0210, 'lps'),
	(500362, 130, '2014-01-15 00:33:45.000000', 'consum', 0.0212, 'lps'),
	(500363, 130, '2014-01-15 00:33:46.000000', 'consum', 0.0221, 'lps'),
	(500364, 130, '2014-01-15 00:33:47.000000', 'consum', 0.0224, 'lps'),
	(500365, 130, '2014-01-15 00:33:48.000000', 'consum', 0.0215, 'lps'),
	(500366, 130, '2014-01-15 00:33:49.000000', 'consum', 0.0212, 'lps'),
	(500367, 130, '2014-01-15 00:33:50.000000', 'consum', 0.0222, 'lps'),
	(500368, 130, '2014-01-15 00:33:51.000000', 'consum', 0.0213, 'lps'),
	(500369, 130, '2014-01-15 00:33:52.000000', 'consum', 0.0225, 'lps'),
	(500370, 130, '2014-01-15 00:33:53.000000', 'consum', 0.0223, 'lps'),
	(500371, 130, '2014-01-15 00:33:54.000000', 'consum', 0.0213, 'lps'),
	(500372, 130, '2014-01-15 00:33:55.000000', 'consum', 0.0221, 'lps'),
	(500373, 130, '2014-01-15 00:33:56.000000', 'consum', 0.0224, 'lps'),
	(500374, 130, '2014-01-15 00:33:57.000000', 'consum', 0.0213, 'lps'),
	(500375, 130, '2014-01-15 00:33:58.000000', 'consum', 0.0219, 'lps'),
	(500376, 130, '2014-01-15 00:33:59.000000', 'consum', 0.0212, 'lps'),
	(500377, 130, '2014-01-15 00:34:00.000000', 'consum', 0.0211, 'lps'),
	(500378, 130, '2014-01-15 00:34:01.000000', 'consum', 0.0226, 'lps'),
	(500379, 130, '2014-01-15 00:34:02.000000', 'consum', 0.0221, 'lps'),
	(500380, 130, '2014-01-15 00:34:03.000000', 'consum', 0.0216, 'lps'),
	(500381, 130, '2014-01-15 00:34:04.000000', 'consum', 0.0224, 'lps'),
	(500382, 130, '2014-01-15 00:34:05.000000', 'consum', 0.0210, 'lps'),
	(500383, 130, '2014-01-15 00:34:06.000000', 'consum', 0.0221, 'lps'),
	(500384, 130, '2014-01-15 00:34:07.000000', 'consum', 0.0214, 'lps'),
	(500385, 130, '2014-01-15 00:34:08.000000', 'consum', 0.0215, 'lps'),
	(500386, 130, '2014-01-15 00:34:09.000000', 'consum', 0.0224, 'lps'),
	(500387, 130, '2014-01-15 00:34:10.000000', 'consum', 0.0215, 'lps'),
	(500388, 130, '2014-01-15 00:34:11.000000', 'consum', 0.0225, 'lps'),
	(500389, 130, '2014-01-15 00:34:12.000000', 'consum', 0.0222, 'lps'),
	(500390, 130, '2014-01-15 00:34:13.000000', 'consum', 0.0225, 'lps'),
	(500391, 130, '2014-01-15 00:34:14.000000', 'consum', 0.0215, 'lps'),
	(500392, 130, '2014-01-15 00:34:15.000000', 'consum', 0.0225, 'lps'),
	(500393, 130, '2014-01-15 00:34:16.000000', 'consum', 0.0221, 'lps'),
	(500394, 130, '2014-01-15 00:34:17.000000', 'consum', 0.0220, 'lps'),
	(500395, 130, '2014-01-15 00:34:18.000000', 'consum', 0.0210, 'lps'),
	(500396, 130, '2014-01-15 00:34:19.000000', 'consum', 0.0214, 'lps'),
	(500397, 130, '2014-01-15 00:34:20.000000', 'consum', 0.0214, 'lps'),
	(500398, 130, '2014-01-15 00:34:21.000000', 'consum', 0.0217, 'lps'),
	(500399, 130, '2014-01-15 00:34:22.000000', 'consum', 0.0216, 'lps'),
	(500400, 130, '2014-01-15 00:34:23.000000', 'consum', 0.0222, 'lps'),
	(500401, 130, '2014-01-15 00:34:24.000000', 'consum', 0.0216, 'lps'),
	(500402, 130, '2014-01-15 00:34:25.000000', 'consum', 0.0222, 'lps'),
	(500403, 130, '2014-01-15 00:34:26.000000', 'consum', 0.0220, 'lps'),
	(500404, 130, '2014-01-15 00:34:27.000000', 'consum', 0.0225, 'lps'),
	(500405, 130, '2014-01-15 00:34:28.000000', 'consum', 0.0221, 'lps'),
	(500406, 130, '2014-01-15 00:34:29.000000', 'consum', 0.0221, 'lps'),
	(500407, 130, '2014-01-15 00:34:30.000000', 'consum', 0.0214, 'lps'),
	(500408, 130, '2014-01-15 00:34:31.000000', 'consum', 0.0215, 'lps'),
	(500409, 130, '2014-01-15 00:34:32.000000', 'consum', 0.0223, 'lps'),
	(500410, 130, '2014-01-15 00:34:33.000000', 'consum', 0.0211, 'lps'),
	(500411, 130, '2014-01-15 00:34:34.000000', 'consum', 0.0225, 'lps'),
	(500412, 130, '2014-01-15 00:34:35.000000', 'consum', 0.0217, 'lps'),
	(500413, 130, '2014-01-15 00:34:36.000000', 'consum', 0.0217, 'lps'),
	(500414, 130, '2014-01-15 00:34:37.000000', 'consum', 0.0226, 'lps'),
	(500415, 130, '2014-01-15 00:34:38.000000', 'consum', 0.0217, 'lps'),
	(500416, 130, '2014-01-15 00:34:39.000000', 'consum', 0.0215, 'lps'),
	(500417, 130, '2014-01-15 00:34:40.000000', 'consum', 0.0215, 'lps'),
	(500418, 130, '2014-01-15 00:34:41.000000', 'consum', 0.0219, 'lps'),
	(500419, 130, '2014-01-15 00:34:42.000000', 'consum', 0.0226, 'lps'),
	(500420, 130, '2014-01-15 00:34:43.000000', 'consum', 0.0211, 'lps'),
	(500421, 130, '2014-01-15 00:34:44.000000', 'consum', 0.0217, 'lps'),
	(500422, 130, '2014-01-15 00:34:45.000000', 'consum', 0.0212, 'lps'),
	(500423, 130, '2014-01-15 00:34:46.000000', 'consum', 0.0213, 'lps'),
	(500424, 130, '2014-01-15 00:34:47.000000', 'consum', 0.0221, 'lps'),
	(500425, 130, '2014-01-15 00:34:48.000000', 'consum', 0.0224, 'lps'),
	(500426, 130, '2014-01-15 00:34:49.000000', 'consum', 0.0211, 'lps'),
	(500427, 130, '2014-01-15 00:34:50.000000', 'consum', 0.0210, 'lps'),
	(500428, 130, '2014-01-15 00:34:51.000000', 'consum', 0.0223, 'lps'),
	(500429, 130, '2014-01-15 00:34:52.000000', 'consum', 0.0223, 'lps'),
	(500430, 130, '2014-01-15 00:34:53.000000', 'consum', 0.0220, 'lps'),
	(500431, 130, '2014-01-15 00:34:54.000000', 'consum', 0.0222, 'lps'),
	(500432, 130, '2014-01-15 00:34:55.000000', 'consum', 0.0222, 'lps'),
	(500433, 130, '2014-01-15 00:34:56.000000', 'consum', 0.0220, 'lps'),
	(500434, 130, '2014-01-15 00:34:57.000000', 'consum', 0.0224, 'lps'),
	(500435, 130, '2014-01-15 00:34:58.000000', 'consum', 0.0217, 'lps'),
	(500436, 130, '2014-01-15 00:34:59.000000', 'consum', 0.0219, 'lps'),
	(500437, 130, '2014-01-15 00:35:00.000000', 'consum', 0.0217, 'lps'),
	(500438, 130, '2014-01-15 00:35:01.000000', 'consum', 0.0220, 'lps'),
	(500439, 130, '2014-01-15 00:35:02.000000', 'consum', 0.0221, 'lps'),
	(500440, 130, '2014-01-15 00:35:03.000000', 'consum', 0.0220, 'lps'),
	(500441, 130, '2014-01-15 00:35:04.000000', 'consum', 0.0225, 'lps'),
	(500442, 130, '2014-01-15 00:35:05.000000', 'consum', 0.0224, 'lps'),
	(500443, 130, '2014-01-15 00:35:06.000000', 'consum', 0.0216, 'lps'),
	(500444, 130, '2014-01-15 00:35:07.000000', 'consum', 0.0216, 'lps'),
	(500445, 130, '2014-01-15 00:35:08.000000', 'consum', 0.0224, 'lps'),
	(500446, 130, '2014-01-15 00:35:09.000000', 'consum', 0.0212, 'lps'),
	(500447, 130, '2014-01-15 00:35:10.000000', 'consum', 0.0212, 'lps'),
	(500448, 130, '2014-01-15 00:35:11.000000', 'consum', 0.0214, 'lps'),
	(500449, 130, '2014-01-15 00:35:12.000000', 'consum', 0.0210, 'lps'),
	(500450, 130, '2014-01-15 00:35:13.000000', 'consum', 0.0213, 'lps'),
	(500451, 130, '2014-01-15 00:35:14.000000', 'consum', 0.0225, 'lps'),
	(500452, 130, '2014-01-15 00:35:15.000000', 'consum', 0.0210, 'lps'),
	(500453, 130, '2014-01-15 00:35:16.000000', 'consum', 0.0215, 'lps'),
	(500454, 130, '2014-01-15 00:35:17.000000', 'consum', 0.0220, 'lps'),
	(500455, 130, '2014-01-15 00:35:18.000000', 'consum', 0.0212, 'lps'),
	(500456, 130, '2014-01-15 00:35:19.000000', 'consum', 0.0222, 'lps'),
	(500457, 130, '2014-01-15 00:35:20.000000', 'consum', 0.0216, 'lps'),
	(500458, 130, '2014-01-15 00:35:21.000000', 'consum', 0.0219, 'lps'),
	(500459, 130, '2014-01-15 00:35:22.000000', 'consum', 0.0220, 'lps'),
	(500460, 130, '2014-01-15 00:35:23.000000', 'consum', 0.0216, 'lps'),
	(500461, 130, '2014-01-15 00:35:24.000000', 'consum', 0.0212, 'lps'),
	(500462, 130, '2014-01-15 00:35:25.000000', 'consum', 0.0218, 'lps'),
	(500463, 130, '2014-01-15 00:35:26.000000', 'consum', 0.0211, 'lps'),
	(500464, 130, '2014-01-15 00:35:27.000000', 'consum', 0.0210, 'lps'),
	(500465, 130, '2014-01-15 00:35:28.000000', 'consum', 0.0222, 'lps'),
	(500466, 130, '2014-01-15 00:35:29.000000', 'consum', 0.0219, 'lps'),
	(500467, 130, '2014-01-15 00:35:30.000000', 'consum', 0.0219, 'lps'),
	(500468, 130, '2014-01-15 00:35:31.000000', 'consum', 0.0213, 'lps'),
	(500469, 130, '2014-01-15 00:35:32.000000', 'consum', 0.0214, 'lps'),
	(500470, 130, '2014-01-15 00:35:33.000000', 'consum', 0.0224, 'lps'),
	(500471, 130, '2014-01-15 00:35:34.000000', 'consum', 0.0215, 'lps'),
	(500472, 130, '2014-01-15 00:35:35.000000', 'consum', 0.0213, 'lps'),
	(500473, 130, '2014-01-15 00:35:36.000000', 'consum', 0.0224, 'lps'),
	(500474, 130, '2014-01-15 00:35:37.000000', 'consum', 0.0223, 'lps'),
	(500475, 130, '2014-01-15 00:35:38.000000', 'consum', 0.0218, 'lps'),
	(500476, 130, '2014-01-15 00:35:39.000000', 'consum', 0.0210, 'lps'),
	(500477, 130, '2014-01-15 00:35:40.000000', 'consum', 0.0221, 'lps'),
	(500478, 130, '2014-01-15 00:35:41.000000', 'consum', 0.0213, 'lps'),
	(500479, 130, '2014-01-15 00:35:42.000000', 'consum', 0.0211, 'lps'),
	(500480, 130, '2014-01-15 00:35:43.000000', 'consum', 0.0223, 'lps'),
	(500481, 130, '2014-01-15 00:35:44.000000', 'consum', 0.0223, 'lps'),
	(500482, 130, '2014-01-15 00:35:45.000000', 'consum', 0.0219, 'lps'),
	(500483, 130, '2014-01-15 00:35:46.000000', 'consum', 0.0218, 'lps'),
	(500484, 130, '2014-01-15 00:35:47.000000', 'consum', 0.0222, 'lps'),
	(500485, 130, '2014-01-15 00:35:48.000000', 'consum', 0.0213, 'lps'),
	(500486, 130, '2014-01-15 00:35:49.000000', 'consum', 0.0224, 'lps'),
	(500487, 130, '2014-01-15 00:35:50.000000', 'consum', 0.0220, 'lps'),
	(500488, 130, '2014-01-15 00:35:51.000000', 'consum', 0.0219, 'lps'),
	(500489, 130, '2014-01-15 00:35:52.000000', 'consum', 0.0225, 'lps'),
	(500490, 130, '2014-01-15 00:35:53.000000', 'consum', 0.0210, 'lps'),
	(500491, 130, '2014-01-15 00:35:54.000000', 'consum', 0.0213, 'lps'),
	(500492, 130, '2014-01-15 00:35:55.000000', 'consum', 0.0210, 'lps'),
	(500493, 130, '2014-01-15 00:35:56.000000', 'consum', 0.0220, 'lps'),
	(500494, 130, '2014-01-15 00:35:57.000000', 'consum', 0.0226, 'lps'),
	(500495, 130, '2014-01-15 00:35:58.000000', 'consum', 0.0224, 'lps'),
	(500496, 130, '2014-01-15 00:35:59.000000', 'consum', 0.0218, 'lps'),
	(500497, 130, '2014-01-15 00:36:00.000000', 'consum', 0.0225, 'lps'),
	(500498, 130, '2014-01-15 00:36:01.000000', 'consum', 0.0211, 'lps'),
	(500499, 130, '2014-01-15 00:36:02.000000', 'consum', 0.0223, 'lps'),
	(500500, 130, '2014-01-15 00:36:03.000000', 'consum', 0.0219, 'lps'),
	(500501, 130, '2014-01-15 00:36:04.000000', 'consum', 0.0216, 'lps'),
	(500502, 130, '2014-01-15 00:36:05.000000', 'consum', 0.0216, 'lps'),
	(500503, 130, '2014-01-15 00:36:06.000000', 'consum', 0.0222, 'lps'),
	(500504, 130, '2014-01-15 00:36:07.000000', 'consum', 0.0218, 'lps'),
	(500505, 130, '2014-01-15 00:36:08.000000', 'consum', 0.0213, 'lps'),
	(500506, 130, '2014-01-15 00:36:09.000000', 'consum', 0.0219, 'lps'),
	(500507, 130, '2014-01-15 00:36:10.000000', 'consum', 0.0213, 'lps'),
	(500508, 130, '2014-01-15 00:36:11.000000', 'consum', 0.0217, 'lps'),
	(500509, 130, '2014-01-15 00:36:12.000000', 'consum', 0.0218, 'lps'),
	(500510, 130, '2014-01-15 00:36:13.000000', 'consum', 0.0214, 'lps'),
	(500511, 130, '2014-01-15 00:36:14.000000', 'consum', 0.0221, 'lps'),
	(500512, 130, '2014-01-15 00:36:15.000000', 'consum', 0.0219, 'lps'),
	(500513, 130, '2014-01-15 00:36:16.000000', 'consum', 0.0225, 'lps'),
	(500514, 130, '2014-01-15 00:36:17.000000', 'consum', 0.0224, 'lps'),
	(500515, 130, '2014-01-15 00:36:18.000000', 'consum', 0.0216, 'lps'),
	(500516, 130, '2014-01-15 00:36:19.000000', 'consum', 0.0217, 'lps'),
	(500517, 130, '2014-01-15 00:36:20.000000', 'consum', 0.0212, 'lps'),
	(500518, 130, '2014-01-15 00:36:21.000000', 'consum', 0.0215, 'lps'),
	(500519, 130, '2014-01-15 00:36:22.000000', 'consum', 0.0215, 'lps'),
	(500520, 130, '2014-01-15 00:36:23.000000', 'consum', 0.0219, 'lps'),
	(500521, 130, '2014-01-15 00:36:24.000000', 'consum', 0.0222, 'lps'),
	(500522, 130, '2014-01-15 00:36:25.000000', 'consum', 0.0211, 'lps'),
	(500523, 130, '2014-01-15 00:36:26.000000', 'consum', 0.0211, 'lps'),
	(500524, 130, '2014-01-15 00:36:27.000000', 'consum', 0.0215, 'lps'),
	(500525, 130, '2014-01-15 00:36:28.000000', 'consum', 0.0214, 'lps'),
	(500526, 130, '2014-01-15 00:36:29.000000', 'consum', 0.0214, 'lps'),
	(500527, 130, '2014-01-15 00:36:30.000000', 'consum', 0.0221, 'lps'),
	(500528, 130, '2014-01-15 00:36:31.000000', 'consum', 0.0217, 'lps'),
	(500529, 130, '2014-01-15 00:36:32.000000', 'consum', 0.0215, 'lps'),
	(500530, 130, '2014-01-15 00:36:33.000000', 'consum', 0.0215, 'lps'),
	(500531, 130, '2014-01-15 00:36:34.000000', 'consum', 0.0219, 'lps'),
	(500532, 130, '2014-01-15 00:36:35.000000', 'consum', 0.0223, 'lps'),
	(500533, 130, '2014-01-15 00:36:36.000000', 'consum', 0.0214, 'lps'),
	(500534, 130, '2014-01-15 00:36:37.000000', 'consum', 0.0210, 'lps'),
	(500535, 130, '2014-01-15 00:36:38.000000', 'consum', 0.0213, 'lps'),
	(500536, 130, '2014-01-15 00:36:39.000000', 'consum', 0.0226, 'lps'),
	(500537, 130, '2014-01-15 00:36:40.000000', 'consum', 0.0216, 'lps'),
	(500538, 130, '2014-01-15 00:36:41.000000', 'consum', 0.0225, 'lps'),
	(500539, 130, '2014-01-15 00:36:42.000000', 'consum', 0.0217, 'lps'),
	(500540, 130, '2014-01-15 00:36:43.000000', 'consum', 0.0217, 'lps'),
	(500541, 130, '2014-01-15 00:36:44.000000', 'consum', 0.0223, 'lps'),
	(500542, 130, '2014-01-15 00:36:45.000000', 'consum', 0.0222, 'lps'),
	(500543, 130, '2014-01-15 00:36:46.000000', 'consum', 0.0213, 'lps'),
	(500544, 130, '2014-01-15 00:36:47.000000', 'consum', 0.0226, 'lps'),
	(500545, 130, '2014-01-15 00:36:48.000000', 'consum', 0.0214, 'lps'),
	(500546, 130, '2014-01-15 00:36:49.000000', 'consum', 0.0214, 'lps'),
	(500547, 130, '2014-01-15 00:36:50.000000', 'consum', 0.0219, 'lps'),
	(500548, 130, '2014-01-15 00:36:51.000000', 'consum', 0.0210, 'lps'),
	(500549, 130, '2014-01-15 00:36:52.000000', 'consum', 0.0217, 'lps'),
	(500550, 130, '2014-01-15 00:36:53.000000', 'consum', 0.0214, 'lps'),
	(500551, 130, '2014-01-15 00:36:54.000000', 'consum', 0.0223, 'lps'),
	(500552, 130, '2014-01-15 00:36:55.000000', 'consum', 0.0215, 'lps'),
	(500553, 130, '2014-01-15 00:36:56.000000', 'consum', 0.0211, 'lps'),
	(500554, 130, '2014-01-15 00:36:57.000000', 'consum', 0.0217, 'lps'),
	(500555, 130, '2014-01-15 00:36:58.000000', 'consum', 0.0212, 'lps'),
	(500556, 130, '2014-01-15 00:36:59.000000', 'consum', 0.0213, 'lps'),
	(500557, 130, '2014-01-15 00:37:00.000000', 'consum', 0.0220, 'lps'),
	(500558, 130, '2014-01-15 00:37:01.000000', 'consum', 0.0217, 'lps'),
	(500559, 130, '2014-01-15 00:37:02.000000', 'consum', 0.0216, 'lps'),
	(500560, 130, '2014-01-15 00:37:03.000000', 'consum', 0.0218, 'lps'),
	(500561, 130, '2014-01-15 00:37:04.000000', 'consum', 0.0217, 'lps'),
	(500562, 130, '2014-01-15 00:37:05.000000', 'consum', 0.0220, 'lps'),
	(500563, 130, '2014-01-15 00:37:06.000000', 'consum', 0.0225, 'lps'),
	(500564, 130, '2014-01-15 00:37:07.000000', 'consum', 0.0222, 'lps'),
	(500565, 130, '2014-01-15 00:37:08.000000', 'consum', 0.0223, 'lps'),
	(500566, 130, '2014-01-15 00:37:09.000000', 'consum', 0.0222, 'lps'),
	(500567, 130, '2014-01-15 00:37:10.000000', 'consum', 0.0214, 'lps'),
	(500568, 130, '2014-01-15 00:37:11.000000', 'consum', 0.0211, 'lps'),
	(500569, 130, '2014-01-15 00:37:12.000000', 'consum', 0.0221, 'lps'),
	(500570, 130, '2014-01-15 00:37:13.000000', 'consum', 0.0212, 'lps'),
	(500571, 130, '2014-01-15 00:37:14.000000', 'consum', 0.0221, 'lps'),
	(500572, 130, '2014-01-15 00:37:15.000000', 'consum', 0.0225, 'lps'),
	(500573, 130, '2014-01-15 00:37:16.000000', 'consum', 0.0219, 'lps'),
	(500574, 130, '2014-01-15 00:37:17.000000', 'consum', 0.0211, 'lps'),
	(500575, 130, '2014-01-15 00:37:18.000000', 'consum', 0.0222, 'lps'),
	(500576, 130, '2014-01-15 00:37:19.000000', 'consum', 0.0218, 'lps'),
	(500577, 130, '2014-01-15 00:37:20.000000', 'consum', 0.0216, 'lps'),
	(500578, 130, '2014-01-15 00:37:21.000000', 'consum', 0.0213, 'lps'),
	(500579, 130, '2014-01-15 00:37:22.000000', 'consum', 0.0210, 'lps'),
	(500580, 130, '2014-01-15 00:37:23.000000', 'consum', 0.0218, 'lps'),
	(500581, 130, '2014-01-15 00:37:24.000000', 'consum', 0.0216, 'lps'),
	(500582, 130, '2014-01-15 00:37:25.000000', 'consum', 0.0216, 'lps'),
	(500583, 130, '2014-01-15 00:37:26.000000', 'consum', 0.0224, 'lps'),
	(500584, 130, '2014-01-15 00:37:27.000000', 'consum', 0.0212, 'lps'),
	(500585, 130, '2014-01-15 00:37:28.000000', 'consum', 0.0213, 'lps'),
	(500586, 130, '2014-01-15 00:37:29.000000', 'consum', 0.0220, 'lps'),
	(500587, 130, '2014-01-15 00:37:30.000000', 'consum', 0.0217, 'lps'),
	(500588, 130, '2014-01-15 00:37:31.000000', 'consum', 0.0213, 'lps'),
	(500589, 130, '2014-01-15 00:37:32.000000', 'consum', 0.0225, 'lps'),
	(500590, 130, '2014-01-15 00:37:33.000000', 'consum', 0.0224, 'lps'),
	(500591, 130, '2014-01-15 00:37:34.000000', 'consum', 0.0218, 'lps'),
	(500592, 130, '2014-01-15 00:37:35.000000', 'consum', 0.0226, 'lps'),
	(500593, 130, '2014-01-15 00:37:36.000000', 'consum', 0.0214, 'lps'),
	(500594, 130, '2014-01-15 00:37:37.000000', 'consum', 0.0216, 'lps'),
	(500595, 130, '2014-01-15 00:37:38.000000', 'consum', 0.0214, 'lps'),
	(500596, 130, '2014-01-15 00:37:39.000000', 'consum', 0.0211, 'lps'),
	(500597, 130, '2014-01-15 00:37:40.000000', 'consum', 0.0221, 'lps'),
	(500598, 130, '2014-01-15 00:37:41.000000', 'consum', 0.0211, 'lps'),
	(500599, 130, '2014-01-15 00:37:42.000000', 'consum', 0.0219, 'lps'),
	(500600, 130, '2014-01-15 00:37:43.000000', 'consum', 0.0215, 'lps'),
	(500601, 130, '2014-01-15 00:37:44.000000', 'consum', 0.0226, 'lps'),
	(500602, 130, '2014-01-15 00:37:45.000000', 'consum', 0.0225, 'lps'),
	(500603, 130, '2014-01-15 00:37:46.000000', 'consum', 0.0222, 'lps'),
	(500604, 130, '2014-01-15 00:37:47.000000', 'consum', 0.0224, 'lps'),
	(500605, 130, '2014-01-15 00:37:48.000000', 'consum', 0.0226, 'lps'),
	(500606, 130, '2014-01-15 00:37:49.000000', 'consum', 0.0215, 'lps'),
	(500607, 130, '2014-01-15 00:37:50.000000', 'consum', 0.0224, 'lps'),
	(500608, 130, '2014-01-15 00:37:51.000000', 'consum', 0.0214, 'lps'),
	(500609, 130, '2014-01-15 00:37:52.000000', 'consum', 0.0222, 'lps'),
	(500610, 130, '2014-01-15 00:37:53.000000', 'consum', 0.0224, 'lps'),
	(500611, 130, '2014-01-15 00:37:54.000000', 'consum', 0.0226, 'lps'),
	(500612, 130, '2014-01-15 00:37:55.000000', 'consum', 0.0216, 'lps'),
	(500613, 130, '2014-01-15 00:37:56.000000', 'consum', 0.0226, 'lps'),
	(500614, 130, '2014-01-15 00:37:57.000000', 'consum', 0.0224, 'lps'),
	(500615, 130, '2014-01-15 00:37:58.000000', 'consum', 0.0213, 'lps'),
	(500616, 130, '2014-01-15 00:37:59.000000', 'consum', 0.0219, 'lps'),
	(500617, 130, '2014-01-15 00:38:00.000000', 'consum', 0.0213, 'lps'),
	(500618, 130, '2014-01-15 00:38:01.000000', 'consum', 0.0216, 'lps'),
	(500619, 130, '2014-01-15 00:38:02.000000', 'consum', 0.0214, 'lps'),
	(500620, 130, '2014-01-15 00:38:03.000000', 'consum', 0.0212, 'lps'),
	(500621, 130, '2014-01-15 00:38:04.000000', 'consum', 0.0224, 'lps'),
	(500622, 130, '2014-01-15 00:38:05.000000', 'consum', 0.0226, 'lps'),
	(500623, 130, '2014-01-15 00:38:06.000000', 'consum', 0.0214, 'lps'),
	(500624, 130, '2014-01-15 00:38:07.000000', 'consum', 0.0217, 'lps'),
	(500625, 130, '2014-01-15 00:38:08.000000', 'consum', 0.0215, 'lps'),
	(500626, 130, '2014-01-15 00:38:09.000000', 'consum', 0.0214, 'lps'),
	(500627, 130, '2014-01-15 00:38:10.000000', 'consum', 0.0217, 'lps'),
	(500628, 130, '2014-01-15 00:38:11.000000', 'consum', 0.0215, 'lps'),
	(500629, 130, '2014-01-15 00:38:12.000000', 'consum', 0.0216, 'lps'),
	(500630, 130, '2014-01-15 00:38:13.000000', 'consum', 0.0224, 'lps'),
	(500631, 130, '2014-01-15 00:38:14.000000', 'consum', 0.0211, 'lps'),
	(500632, 130, '2014-01-15 00:38:15.000000', 'consum', 0.0225, 'lps'),
	(500633, 130, '2014-01-15 00:38:16.000000', 'consum', 0.0216, 'lps'),
	(500634, 130, '2014-01-15 00:38:17.000000', 'consum', 0.0213, 'lps'),
	(500635, 130, '2014-01-15 00:38:18.000000', 'consum', 0.0225, 'lps'),
	(500636, 130, '2014-01-15 00:38:19.000000', 'consum', 0.0223, 'lps'),
	(500637, 130, '2014-01-15 00:38:20.000000', 'consum', 0.0213, 'lps'),
	(500638, 130, '2014-01-15 00:38:21.000000', 'consum', 0.0220, 'lps'),
	(500639, 130, '2014-01-15 00:38:22.000000', 'consum', 0.0218, 'lps'),
	(500640, 130, '2014-01-15 00:38:23.000000', 'consum', 0.0221, 'lps'),
	(500641, 130, '2014-01-15 00:38:24.000000', 'consum', 0.0222, 'lps'),
	(500642, 130, '2014-01-15 00:38:25.000000', 'consum', 0.0224, 'lps'),
	(500643, 130, '2014-01-15 00:38:26.000000', 'consum', 0.0225, 'lps'),
	(500644, 130, '2014-01-15 00:38:27.000000', 'consum', 0.0226, 'lps'),
	(500645, 130, '2014-01-15 00:38:28.000000', 'consum', 0.0212, 'lps'),
	(500646, 130, '2014-01-15 00:38:29.000000', 'consum', 0.0224, 'lps'),
	(500647, 130, '2014-01-15 00:38:30.000000', 'consum', 0.0225, 'lps'),
	(500648, 130, '2014-01-15 00:38:31.000000', 'consum', 0.0226, 'lps'),
	(500649, 130, '2014-01-15 00:38:32.000000', 'consum', 0.0212, 'lps'),
	(500650, 130, '2014-01-15 00:38:33.000000', 'consum', 0.0221, 'lps'),
	(500651, 130, '2014-01-15 00:38:34.000000', 'consum', 0.0211, 'lps'),
	(500652, 130, '2014-01-15 00:38:35.000000', 'consum', 0.0217, 'lps'),
	(500653, 130, '2014-01-15 00:38:36.000000', 'consum', 0.0224, 'lps'),
	(500654, 130, '2014-01-15 00:38:37.000000', 'consum', 0.0210, 'lps'),
	(500655, 130, '2014-01-15 00:38:38.000000', 'consum', 0.0217, 'lps'),
	(500656, 130, '2014-01-15 00:38:39.000000', 'consum', 0.0214, 'lps'),
	(500657, 130, '2014-01-15 00:38:40.000000', 'consum', 0.0224, 'lps'),
	(500658, 130, '2014-01-15 00:38:41.000000', 'consum', 0.0219, 'lps'),
	(500659, 130, '2014-01-15 00:38:42.000000', 'consum', 0.0211, 'lps'),
	(500660, 130, '2014-01-15 00:38:43.000000', 'consum', 0.0225, 'lps'),
	(500661, 130, '2014-01-15 00:38:44.000000', 'consum', 0.0214, 'lps'),
	(500662, 130, '2014-01-15 00:38:45.000000', 'consum', 0.0220, 'lps'),
	(500663, 130, '2014-01-15 00:38:46.000000', 'consum', 0.0212, 'lps'),
	(500664, 130, '2014-01-15 00:38:47.000000', 'consum', 0.0211, 'lps'),
	(500665, 130, '2014-01-15 00:38:48.000000', 'consum', 0.0225, 'lps'),
	(500666, 130, '2014-01-15 00:38:49.000000', 'consum', 0.0214, 'lps'),
	(500667, 130, '2014-01-15 00:38:50.000000', 'consum', 0.0218, 'lps'),
	(500668, 130, '2014-01-15 00:38:51.000000', 'consum', 0.0222, 'lps'),
	(500669, 130, '2014-01-15 00:38:52.000000', 'consum', 0.0212, 'lps'),
	(500670, 130, '2014-01-15 00:38:53.000000', 'consum', 0.0221, 'lps'),
	(500671, 130, '2014-01-15 00:38:54.000000', 'consum', 0.0222, 'lps'),
	(500672, 130, '2014-01-15 00:38:55.000000', 'consum', 0.0224, 'lps'),
	(500673, 130, '2014-01-15 00:38:56.000000', 'consum', 0.0225, 'lps'),
	(500674, 130, '2014-01-15 00:38:57.000000', 'consum', 0.0226, 'lps'),
	(500675, 130, '2014-01-15 00:38:58.000000', 'consum', 0.0211, 'lps'),
	(500676, 130, '2014-01-15 00:38:59.000000', 'consum', 0.0219, 'lps'),
	(500677, 130, '2014-01-15 00:39:00.000000', 'consum', 0.0219, 'lps'),
	(500678, 130, '2014-01-15 00:39:01.000000', 'consum', 0.0213, 'lps'),
	(500679, 130, '2014-01-15 00:39:02.000000', 'consum', 0.0214, 'lps'),
	(500680, 130, '2014-01-15 00:39:03.000000', 'consum', 0.0220, 'lps'),
	(500681, 130, '2014-01-15 00:39:04.000000', 'consum', 0.0215, 'lps'),
	(500682, 130, '2014-01-15 00:39:05.000000', 'consum', 0.0225, 'lps'),
	(500683, 130, '2014-01-15 00:39:06.000000', 'consum', 0.0216, 'lps'),
	(500684, 130, '2014-01-15 00:39:07.000000', 'consum', 0.0215, 'lps'),
	(500685, 130, '2014-01-15 00:39:08.000000', 'consum', 0.0218, 'lps'),
	(500686, 130, '2014-01-15 00:39:09.000000', 'consum', 0.0220, 'lps'),
	(500687, 130, '2014-01-15 00:39:10.000000', 'consum', 0.0216, 'lps'),
	(500688, 130, '2014-01-15 00:39:11.000000', 'consum', 0.0212, 'lps'),
	(500689, 130, '2014-01-15 00:39:12.000000', 'consum', 0.0217, 'lps'),
	(500690, 130, '2014-01-15 00:39:13.000000', 'consum', 0.0225, 'lps'),
	(500691, 130, '2014-01-15 00:39:14.000000', 'consum', 0.0214, 'lps'),
	(500692, 130, '2014-01-15 00:39:15.000000', 'consum', 0.0218, 'lps'),
	(500693, 130, '2014-01-15 00:39:16.000000', 'consum', 0.0221, 'lps'),
	(500694, 130, '2014-01-15 00:39:17.000000', 'consum', 0.0224, 'lps'),
	(500695, 130, '2014-01-15 00:39:18.000000', 'consum', 0.0212, 'lps'),
	(500696, 130, '2014-01-15 00:39:19.000000', 'consum', 0.0216, 'lps'),
	(500697, 130, '2014-01-15 00:39:20.000000', 'consum', 0.0216, 'lps'),
	(500698, 130, '2014-01-15 00:39:21.000000', 'consum', 0.0224, 'lps'),
	(500699, 130, '2014-01-15 00:39:22.000000', 'consum', 0.0212, 'lps'),
	(500700, 130, '2014-01-15 00:39:23.000000', 'consum', 0.0210, 'lps'),
	(500701, 130, '2014-01-15 00:39:24.000000', 'consum', 0.0221, 'lps'),
	(500702, 130, '2014-01-15 00:39:25.000000', 'consum', 0.0217, 'lps'),
	(500703, 130, '2014-01-15 00:39:26.000000', 'consum', 0.0211, 'lps'),
	(500704, 130, '2014-01-15 00:39:27.000000', 'consum', 0.0211, 'lps'),
	(500705, 130, '2014-01-15 00:39:28.000000', 'consum', 0.0213, 'lps'),
	(500706, 130, '2014-01-15 00:39:29.000000', 'consum', 0.0224, 'lps'),
	(500707, 130, '2014-01-15 00:39:30.000000', 'consum', 0.0219, 'lps'),
	(500708, 130, '2014-01-15 00:39:31.000000', 'consum', 0.0212, 'lps'),
	(500709, 130, '2014-01-15 00:39:32.000000', 'consum', 0.0214, 'lps'),
	(500710, 130, '2014-01-15 00:39:33.000000', 'consum', 0.0223, 'lps'),
	(500711, 130, '2014-01-15 00:39:34.000000', 'consum', 0.0211, 'lps'),
	(500712, 130, '2014-01-15 00:39:35.000000', 'consum', 0.0211, 'lps'),
	(500713, 130, '2014-01-15 00:39:36.000000', 'consum', 0.0211, 'lps'),
	(500714, 130, '2014-01-15 00:39:37.000000', 'consum', 0.0216, 'lps'),
	(500715, 130, '2014-01-15 00:39:38.000000', 'consum', 0.0219, 'lps'),
	(500716, 130, '2014-01-15 00:39:39.000000', 'consum', 0.0219, 'lps'),
	(500717, 130, '2014-01-15 00:39:40.000000', 'consum', 0.0212, 'lps'),
	(500718, 130, '2014-01-15 00:39:41.000000', 'consum', 0.0226, 'lps'),
	(500719, 130, '2014-01-15 00:39:42.000000', 'consum', 0.0219, 'lps'),
	(500720, 130, '2014-01-15 00:39:43.000000', 'consum', 0.0223, 'lps'),
	(500721, 130, '2014-01-15 00:39:44.000000', 'consum', 0.0213, 'lps'),
	(500722, 130, '2014-01-15 00:39:45.000000', 'consum', 0.0223, 'lps'),
	(500723, 130, '2014-01-15 00:39:46.000000', 'consum', 0.0213, 'lps'),
	(500724, 130, '2014-01-15 00:39:47.000000', 'consum', 0.0220, 'lps'),
	(500725, 130, '2014-01-15 00:39:48.000000', 'consum', 0.0218, 'lps'),
	(500726, 130, '2014-01-15 00:39:49.000000', 'consum', 0.0222, 'lps'),
	(500727, 130, '2014-01-15 00:39:50.000000', 'consum', 0.0210, 'lps'),
	(500728, 130, '2014-01-15 00:39:51.000000', 'consum', 0.0226, 'lps'),
	(500729, 130, '2014-01-15 00:39:52.000000', 'consum', 0.0225, 'lps'),
	(500730, 130, '2014-01-15 00:39:53.000000', 'consum', 0.0219, 'lps'),
	(500731, 130, '2014-01-15 00:39:54.000000', 'consum', 0.0212, 'lps'),
	(500732, 130, '2014-01-15 00:39:55.000000', 'consum', 0.0210, 'lps'),
	(500733, 130, '2014-01-15 00:39:56.000000', 'consum', 0.0220, 'lps'),
	(500734, 130, '2014-01-15 00:39:57.000000', 'consum', 0.0225, 'lps'),
	(500735, 130, '2014-01-15 00:39:58.000000', 'consum', 0.0224, 'lps'),
	(500736, 130, '2014-01-15 00:39:59.000000', 'consum', 0.0218, 'lps'),
	(500737, 130, '2014-01-15 00:40:00.000000', 'consum', 0.0210, 'lps'),
	(500738, 130, '2014-01-15 00:40:01.000000', 'consum', 0.0219, 'lps'),
	(500739, 130, '2014-01-15 00:40:02.000000', 'consum', 0.0223, 'lps'),
	(500740, 130, '2014-01-15 00:40:03.000000', 'consum', 0.0214, 'lps'),
	(500741, 130, '2014-01-15 00:40:04.000000', 'consum', 0.0224, 'lps'),
	(500742, 130, '2014-01-15 00:40:05.000000', 'consum', 0.0220, 'lps'),
	(500743, 130, '2014-01-15 00:40:06.000000', 'consum', 0.0216, 'lps'),
	(500744, 130, '2014-01-15 00:40:07.000000', 'consum', 0.0213, 'lps'),
	(500745, 130, '2014-01-15 00:40:08.000000', 'consum', 0.0223, 'lps'),
	(500746, 130, '2014-01-15 00:40:09.000000', 'consum', 0.0216, 'lps'),
	(500747, 130, '2014-01-15 00:40:10.000000', 'consum', 0.0218, 'lps'),
	(500748, 130, '2014-01-15 00:40:11.000000', 'consum', 0.0216, 'lps'),
	(500749, 130, '2014-01-15 00:40:12.000000', 'consum', 0.0215, 'lps'),
	(500750, 130, '2014-01-15 00:40:13.000000', 'consum', 0.0217, 'lps'),
	(500751, 130, '2014-01-15 00:40:14.000000', 'consum', 0.0213, 'lps'),
	(500752, 130, '2014-01-15 00:40:15.000000', 'consum', 0.0223, 'lps'),
	(500753, 130, '2014-01-15 00:40:16.000000', 'consum', 0.0214, 'lps'),
	(500754, 130, '2014-01-15 00:40:17.000000', 'consum', 0.0224, 'lps'),
	(500755, 130, '2014-01-15 00:40:18.000000', 'consum', 0.0220, 'lps'),
	(500756, 130, '2014-01-15 00:40:19.000000', 'consum', 0.0220, 'lps'),
	(500757, 130, '2014-01-15 00:40:20.000000', 'consum', 0.0212, 'lps'),
	(500758, 130, '2014-01-15 00:40:21.000000', 'consum', 0.0222, 'lps'),
	(500759, 130, '2014-01-15 00:40:22.000000', 'consum', 0.0217, 'lps'),
	(500760, 130, '2014-01-15 00:40:23.000000', 'consum', 0.0225, 'lps'),
	(500761, 130, '2014-01-15 00:40:24.000000', 'consum', 0.0215, 'lps'),
	(500762, 130, '2014-01-15 00:40:25.000000', 'consum', 0.0224, 'lps'),
	(500763, 130, '2014-01-15 00:40:26.000000', 'consum', 0.0215, 'lps'),
	(500764, 130, '2014-01-15 00:40:27.000000', 'consum', 0.0211, 'lps'),
	(500765, 130, '2014-01-15 00:40:28.000000', 'consum', 0.0218, 'lps'),
	(500766, 130, '2014-01-15 00:40:29.000000', 'consum', 0.0212, 'lps'),
	(500767, 130, '2014-01-15 00:40:30.000000', 'consum', 0.0214, 'lps'),
	(500768, 130, '2014-01-15 00:40:31.000000', 'consum', 0.0226, 'lps'),
	(500769, 130, '2014-01-15 00:40:32.000000', 'consum', 0.0210, 'lps'),
	(500770, 130, '2014-01-15 00:40:33.000000', 'consum', 0.0215, 'lps'),
	(500771, 130, '2014-01-15 00:40:34.000000', 'consum', 0.0215, 'lps'),
	(500772, 130, '2014-01-15 00:40:35.000000', 'consum', 0.0223, 'lps'),
	(500773, 130, '2014-01-15 00:40:36.000000', 'consum', 0.0225, 'lps'),
	(500774, 130, '2014-01-15 00:40:37.000000', 'consum', 0.0214, 'lps'),
	(500775, 130, '2014-01-15 00:40:38.000000', 'consum', 0.0220, 'lps'),
	(500776, 130, '2014-01-15 00:40:39.000000', 'consum', 0.0212, 'lps'),
	(500777, 130, '2014-01-15 00:40:40.000000', 'consum', 0.0226, 'lps'),
	(500778, 130, '2014-01-15 00:40:41.000000', 'consum', 0.0216, 'lps'),
	(500779, 130, '2014-01-15 00:40:42.000000', 'consum', 0.0225, 'lps'),
	(500780, 130, '2014-01-15 00:40:43.000000', 'consum', 0.0218, 'lps'),
	(500781, 130, '2014-01-15 00:40:44.000000', 'consum', 0.0221, 'lps'),
	(500782, 130, '2014-01-15 00:40:45.000000', 'consum', 0.0226, 'lps'),
	(500783, 130, '2014-01-15 00:40:46.000000', 'consum', 0.0222, 'lps'),
	(500784, 130, '2014-01-15 00:40:47.000000', 'consum', 0.0224, 'lps'),
	(500785, 130, '2014-01-15 00:40:48.000000', 'consum', 0.0226, 'lps'),
	(500786, 130, '2014-01-15 00:40:49.000000', 'consum', 0.0215, 'lps'),
	(500787, 130, '2014-01-15 00:40:50.000000', 'consum', 0.0220, 'lps'),
	(500788, 130, '2014-01-15 00:40:51.000000', 'consum', 0.0214, 'lps'),
	(500789, 130, '2014-01-15 00:40:52.000000', 'consum', 0.0215, 'lps'),
	(500790, 130, '2014-01-15 00:40:53.000000', 'consum', 0.0226, 'lps'),
	(500791, 130, '2014-01-15 00:40:54.000000', 'consum', 0.0223, 'lps'),
	(500792, 130, '2014-01-15 00:40:55.000000', 'consum', 0.0210, 'lps'),
	(500793, 130, '2014-01-15 00:40:56.000000', 'consum', 0.0223, 'lps'),
	(500794, 130, '2014-01-15 00:40:57.000000', 'consum', 0.0224, 'lps'),
	(500795, 130, '2014-01-15 00:40:58.000000', 'consum', 0.0223, 'lps'),
	(500796, 130, '2014-01-15 00:40:59.000000', 'consum', 0.0217, 'lps'),
	(500797, 130, '2014-01-15 00:41:00.000000', 'consum', 0.0224, 'lps'),
	(500798, 130, '2014-01-15 00:41:01.000000', 'consum', 0.0210, 'lps'),
	(500799, 130, '2014-01-15 00:41:02.000000', 'consum', 0.0219, 'lps'),
	(500800, 130, '2014-01-15 00:41:03.000000', 'consum', 0.0223, 'lps'),
	(500801, 130, '2014-01-15 00:41:04.000000', 'consum', 0.0212, 'lps'),
	(500802, 130, '2014-01-15 00:41:05.000000', 'consum', 0.0215, 'lps'),
	(500803, 130, '2014-01-15 00:41:06.000000', 'consum', 0.0215, 'lps'),
	(500804, 130, '2014-01-15 00:41:07.000000', 'consum', 0.0220, 'lps'),
	(500805, 130, '2014-01-15 00:41:08.000000', 'consum', 0.0210, 'lps'),
	(500806, 130, '2014-01-15 00:41:09.000000', 'consum', 0.0216, 'lps'),
	(500807, 130, '2014-01-15 00:41:10.000000', 'consum', 0.0225, 'lps'),
	(500808, 130, '2014-01-15 00:41:11.000000', 'consum', 0.0214, 'lps'),
	(500809, 130, '2014-01-15 00:41:12.000000', 'consum', 0.0218, 'lps'),
	(500810, 130, '2014-01-15 00:41:13.000000', 'consum', 0.0224, 'lps'),
	(500811, 130, '2014-01-15 00:41:14.000000', 'consum', 0.0221, 'lps'),
	(500812, 130, '2014-01-15 00:41:15.000000', 'consum', 0.0226, 'lps'),
	(500813, 130, '2014-01-15 00:41:16.000000', 'consum', 0.0223, 'lps'),
	(500814, 130, '2014-01-15 00:41:17.000000', 'consum', 0.0210, 'lps'),
	(500815, 130, '2014-01-15 00:41:18.000000', 'consum', 0.0222, 'lps'),
	(500816, 130, '2014-01-15 00:41:19.000000', 'consum', 0.0220, 'lps'),
	(500817, 130, '2014-01-15 00:41:20.000000', 'consum', 0.0223, 'lps'),
	(500818, 130, '2014-01-15 00:41:21.000000', 'consum', 0.0215, 'lps'),
	(500819, 130, '2014-01-15 00:41:22.000000', 'consum', 0.0210, 'lps'),
	(500820, 130, '2014-01-15 00:41:23.000000', 'consum', 0.0212, 'lps'),
	(500821, 130, '2014-01-15 00:41:24.000000', 'consum', 0.0223, 'lps'),
	(500822, 130, '2014-01-15 00:41:25.000000', 'consum', 0.0216, 'lps'),
	(500823, 130, '2014-01-15 00:41:26.000000', 'consum', 0.0218, 'lps'),
	(500824, 130, '2014-01-15 00:41:27.000000', 'consum', 0.0216, 'lps'),
	(500825, 130, '2014-01-15 00:41:28.000000', 'consum', 0.0215, 'lps'),
	(500826, 130, '2014-01-15 00:41:29.000000', 'consum', 0.0219, 'lps'),
	(500827, 130, '2014-01-15 00:41:30.000000', 'consum', 0.0224, 'lps'),
	(500828, 130, '2014-01-15 00:41:31.000000', 'consum', 0.0217, 'lps'),
	(500829, 130, '2014-01-15 00:41:32.000000', 'consum', 0.0223, 'lps'),
	(500830, 130, '2014-01-15 00:41:33.000000', 'consum', 0.0218, 'lps'),
	(500831, 130, '2014-01-15 00:41:34.000000', 'consum', 0.0213, 'lps'),
	(500832, 130, '2014-01-15 00:41:35.000000', 'consum', 0.0218, 'lps'),
	(500833, 130, '2014-01-15 00:41:36.000000', 'consum', 0.0225, 'lps'),
	(500834, 130, '2014-01-15 00:41:37.000000', 'consum', 0.0210, 'lps'),
	(500835, 130, '2014-01-15 00:41:38.000000', 'consum', 0.0217, 'lps'),
	(500836, 130, '2014-01-15 00:41:39.000000', 'consum', 0.0210, 'lps'),
	(500837, 130, '2014-01-15 00:41:40.000000', 'consum', 0.0224, 'lps'),
	(500838, 130, '2014-01-15 00:41:41.000000', 'consum', 0.0211, 'lps'),
	(500839, 130, '2014-01-15 00:41:42.000000', 'consum', 0.0211, 'lps'),
	(500840, 130, '2014-01-15 00:41:43.000000', 'consum', 0.0210, 'lps'),
	(500841, 130, '2014-01-15 00:41:44.000000', 'consum', 0.0225, 'lps'),
	(500842, 130, '2014-01-15 00:41:45.000000', 'consum', 0.0218, 'lps'),
	(500843, 130, '2014-01-15 00:41:46.000000', 'consum', 0.0223, 'lps'),
	(500844, 130, '2014-01-15 00:41:47.000000', 'consum', 0.0217, 'lps'),
	(500845, 130, '2014-01-15 00:41:48.000000', 'consum', 0.0225, 'lps'),
	(500846, 130, '2014-01-15 00:41:49.000000', 'consum', 0.0212, 'lps'),
	(500847, 130, '2014-01-15 00:41:50.000000', 'consum', 0.0210, 'lps'),
	(500848, 130, '2014-01-15 00:41:51.000000', 'consum', 0.0221, 'lps'),
	(500849, 130, '2014-01-15 00:41:52.000000', 'consum', 0.0213, 'lps'),
	(500850, 130, '2014-01-15 00:41:53.000000', 'consum', 0.0212, 'lps'),
	(500851, 130, '2014-01-15 00:41:54.000000', 'consum', 0.0210, 'lps'),
	(500852, 130, '2014-01-15 00:41:55.000000', 'consum', 0.0221, 'lps'),
	(500853, 130, '2014-01-15 00:41:56.000000', 'consum', 0.0214, 'lps'),
	(500854, 130, '2014-01-15 00:41:57.000000', 'consum', 0.0215, 'lps'),
	(500855, 130, '2014-01-15 00:41:58.000000', 'consum', 0.0222, 'lps'),
	(500856, 130, '2014-01-15 00:41:59.000000', 'consum', 0.0222, 'lps'),
	(500857, 130, '2014-01-15 00:42:00.000000', 'consum', 0.0219, 'lps'),
	(500858, 130, '2014-01-15 00:42:01.000000', 'consum', 0.0220, 'lps'),
	(500859, 130, '2014-01-15 00:42:02.000000', 'consum', 0.0217, 'lps'),
	(500860, 130, '2014-01-15 00:42:03.000000', 'consum', 0.0215, 'lps'),
	(500861, 130, '2014-01-15 00:42:04.000000', 'consum', 0.0212, 'lps'),
	(500862, 130, '2014-01-15 00:42:05.000000', 'consum', 0.0225, 'lps'),
	(500863, 130, '2014-01-15 00:42:06.000000', 'consum', 0.0226, 'lps'),
	(500864, 130, '2014-01-15 00:42:07.000000', 'consum', 0.0212, 'lps'),
	(500865, 130, '2014-01-15 00:42:08.000000', 'consum', 0.0222, 'lps'),
	(500866, 130, '2014-01-15 00:42:09.000000', 'consum', 0.0215, 'lps'),
	(500867, 130, '2014-01-15 00:42:10.000000', 'consum', 0.0215, 'lps'),
	(500868, 130, '2014-01-15 00:42:11.000000', 'consum', 0.0222, 'lps'),
	(500869, 130, '2014-01-15 00:42:12.000000', 'consum', 0.0221, 'lps'),
	(500870, 130, '2014-01-15 00:42:13.000000', 'consum', 0.0212, 'lps'),
	(500871, 130, '2014-01-15 00:42:14.000000', 'consum', 0.0222, 'lps'),
	(500872, 130, '2014-01-15 00:42:15.000000', 'consum', 0.0212, 'lps'),
	(500873, 130, '2014-01-15 00:42:16.000000', 'consum', 0.0222, 'lps'),
	(500874, 130, '2014-01-15 00:42:17.000000', 'consum', 0.0210, 'lps'),
	(500875, 130, '2014-01-15 00:42:18.000000', 'consum', 0.0226, 'lps'),
	(500876, 130, '2014-01-15 00:42:19.000000', 'consum', 0.0224, 'lps'),
	(500877, 130, '2014-01-15 00:42:20.000000', 'consum', 0.0213, 'lps'),
	(500878, 130, '2014-01-15 00:42:21.000000', 'consum', 0.0217, 'lps'),
	(500879, 130, '2014-01-15 00:42:22.000000', 'consum', 0.0222, 'lps'),
	(500880, 130, '2014-01-15 00:42:23.000000', 'consum', 0.0215, 'lps'),
	(500881, 130, '2014-01-15 00:42:24.000000', 'consum', 0.0215, 'lps'),
	(500882, 130, '2014-01-15 00:42:25.000000', 'consum', 0.0222, 'lps'),
	(500883, 130, '2014-01-15 00:42:26.000000', 'consum', 0.0223, 'lps'),
	(500884, 130, '2014-01-15 00:42:27.000000', 'consum', 0.0220, 'lps'),
	(500885, 130, '2014-01-15 00:42:28.000000', 'consum', 0.0222, 'lps'),
	(500886, 130, '2014-01-15 00:42:29.000000', 'consum', 0.0223, 'lps'),
	(500887, 130, '2014-01-15 00:42:30.000000', 'consum', 0.0221, 'lps'),
	(500888, 130, '2014-01-15 00:42:31.000000', 'consum', 0.0211, 'lps'),
	(500889, 130, '2014-01-15 00:42:32.000000', 'consum', 0.0216, 'lps'),
	(500890, 130, '2014-01-15 00:42:33.000000', 'consum', 0.0220, 'lps'),
	(500891, 130, '2014-01-15 00:42:34.000000', 'consum', 0.0226, 'lps'),
	(500892, 130, '2014-01-15 00:42:35.000000', 'consum', 0.0225, 'lps'),
	(500893, 130, '2014-01-15 00:42:36.000000', 'consum', 0.0220, 'lps'),
	(500894, 130, '2014-01-15 00:42:37.000000', 'consum', 0.0216, 'lps'),
	(500895, 130, '2014-01-15 00:42:38.000000', 'consum', 0.0210, 'lps'),
	(500896, 130, '2014-01-15 00:42:39.000000', 'consum', 0.0210, 'lps'),
	(500897, 130, '2014-01-15 00:42:40.000000', 'consum', 0.0211, 'lps'),
	(500898, 130, '2014-01-15 00:42:41.000000', 'consum', 0.0216, 'lps'),
	(500899, 130, '2014-01-15 00:42:42.000000', 'consum', 0.0219, 'lps'),
	(500900, 130, '2014-01-15 00:42:43.000000', 'consum', 0.0220, 'lps'),
	(500901, 130, '2014-01-15 00:42:44.000000', 'consum', 0.0218, 'lps'),
	(500902, 130, '2014-01-15 00:42:45.000000', 'consum', 0.0220, 'lps'),
	(500903, 130, '2014-01-15 00:42:46.000000', 'consum', 0.0221, 'lps'),
	(500904, 130, '2014-01-15 00:42:47.000000', 'consum', 0.0219, 'lps'),
	(500905, 130, '2014-01-15 00:42:48.000000', 'consum', 0.0223, 'lps'),
	(500906, 130, '2014-01-15 00:42:49.000000', 'consum', 0.0213, 'lps'),
	(500907, 130, '2014-01-15 00:42:50.000000', 'consum', 0.0219, 'lps'),
	(500908, 130, '2014-01-15 00:42:51.000000', 'consum', 0.0214, 'lps'),
	(500909, 130, '2014-01-15 00:42:52.000000', 'consum', 0.0219, 'lps'),
	(500910, 130, '2014-01-15 00:42:53.000000', 'consum', 0.0212, 'lps'),
	(500911, 130, '2014-01-15 00:42:54.000000', 'consum', 0.0226, 'lps'),
	(500912, 130, '2014-01-15 00:42:55.000000', 'consum', 0.0219, 'lps'),
	(500913, 130, '2014-01-15 00:42:56.000000', 'consum', 0.0221, 'lps'),
	(500914, 130, '2014-01-15 00:42:57.000000', 'consum', 0.0223, 'lps'),
	(500915, 130, '2014-01-15 00:42:58.000000', 'consum', 0.0226, 'lps'),
	(500916, 130, '2014-01-15 00:42:59.000000', 'consum', 0.0217, 'lps'),
	(500917, 130, '2014-01-15 00:43:00.000000', 'consum', 0.0216, 'lps'),
	(500918, 130, '2014-01-15 00:43:01.000000', 'consum', 0.0218, 'lps'),
	(500919, 130, '2014-01-15 00:43:02.000000', 'consum', 0.0218, 'lps'),
	(500920, 130, '2014-01-15 00:43:03.000000', 'consum', 0.0223, 'lps'),
	(500921, 130, '2014-01-15 00:43:04.000000', 'consum', 0.0220, 'lps'),
	(500922, 130, '2014-01-15 00:43:05.000000', 'consum', 0.0219, 'lps'),
	(500923, 130, '2014-01-15 00:43:06.000000', 'consum', 0.0212, 'lps'),
	(500924, 130, '2014-01-15 00:43:07.000000', 'consum', 0.0225, 'lps'),
	(500925, 130, '2014-01-15 00:43:08.000000', 'consum', 0.0212, 'lps'),
	(500926, 130, '2014-01-15 00:43:09.000000', 'consum', 0.0211, 'lps'),
	(500927, 130, '2014-01-15 00:43:10.000000', 'consum', 0.0210, 'lps'),
	(500928, 130, '2014-01-15 00:43:11.000000', 'consum', 0.0222, 'lps'),
	(500929, 130, '2014-01-15 00:43:12.000000', 'consum', 0.0221, 'lps'),
	(500930, 130, '2014-01-15 00:43:13.000000', 'consum', 0.0213, 'lps'),
	(500931, 130, '2014-01-15 00:43:14.000000', 'consum', 0.0226, 'lps'),
	(500932, 130, '2014-01-15 00:43:15.000000', 'consum', 0.0214, 'lps'),
	(500933, 130, '2014-01-15 00:43:16.000000', 'consum', 0.0215, 'lps'),
	(500934, 130, '2014-01-15 00:43:17.000000', 'consum', 0.0223, 'lps'),
	(500935, 130, '2014-01-15 00:43:18.000000', 'consum', 0.0226, 'lps'),
	(500936, 130, '2014-01-15 00:43:19.000000', 'consum', 0.0218, 'lps'),
	(500937, 130, '2014-01-15 00:43:20.000000', 'consum', 0.0219, 'lps'),
	(500938, 130, '2014-01-15 00:43:21.000000', 'consum', 0.0213, 'lps'),
	(500939, 130, '2014-01-15 00:43:22.000000', 'consum', 0.0219, 'lps'),
	(500940, 130, '2014-01-15 00:43:23.000000', 'consum', 0.0226, 'lps'),
	(500941, 130, '2014-01-15 00:43:24.000000', 'consum', 0.0214, 'lps'),
	(500942, 130, '2014-01-15 00:43:25.000000', 'consum', 0.0218, 'lps'),
	(500943, 130, '2014-01-15 00:43:26.000000', 'consum', 0.0219, 'lps'),
	(500944, 130, '2014-01-15 00:43:27.000000', 'consum', 0.0216, 'lps'),
	(500945, 130, '2014-01-15 00:43:28.000000', 'consum', 0.0214, 'lps'),
	(500946, 130, '2014-01-15 00:43:29.000000', 'consum', 0.0212, 'lps'),
	(500947, 130, '2014-01-15 00:43:30.000000', 'consum', 0.0225, 'lps'),
	(500948, 130, '2014-01-15 00:43:31.000000', 'consum', 0.0213, 'lps'),
	(500949, 130, '2014-01-15 00:43:32.000000', 'consum', 0.0214, 'lps'),
	(500950, 130, '2014-01-15 00:43:33.000000', 'consum', 0.0222, 'lps'),
	(500951, 130, '2014-01-15 00:43:34.000000', 'consum', 0.0224, 'lps'),
	(500952, 130, '2014-01-15 00:43:35.000000', 'consum', 0.0212, 'lps'),
	(500953, 130, '2014-01-15 00:43:36.000000', 'consum', 0.0210, 'lps'),
	(500954, 130, '2014-01-15 00:43:37.000000', 'consum', 0.0224, 'lps'),
	(500955, 130, '2014-01-15 00:43:38.000000', 'consum', 0.0213, 'lps'),
	(500956, 130, '2014-01-15 00:43:39.000000', 'consum', 0.0217, 'lps'),
	(500957, 130, '2014-01-15 00:43:40.000000', 'consum', 0.0220, 'lps'),
	(500958, 130, '2014-01-15 00:43:41.000000', 'consum', 0.0222, 'lps'),
	(500959, 130, '2014-01-15 00:43:42.000000', 'consum', 0.0224, 'lps'),
	(500960, 130, '2014-01-15 00:43:43.000000', 'consum', 0.0226, 'lps'),
	(500961, 130, '2014-01-15 00:43:44.000000', 'consum', 0.0217, 'lps'),
	(500962, 130, '2014-01-15 00:43:45.000000', 'consum', 0.0213, 'lps'),
	(500963, 130, '2014-01-15 00:43:46.000000', 'consum', 0.0222, 'lps'),
	(500964, 130, '2014-01-15 00:43:47.000000', 'consum', 0.0211, 'lps'),
	(500965, 130, '2014-01-15 00:43:48.000000', 'consum', 0.0215, 'lps'),
	(500966, 130, '2014-01-15 00:43:49.000000', 'consum', 0.0212, 'lps'),
	(500967, 130, '2014-01-15 00:43:50.000000', 'consum', 0.0225, 'lps'),
	(500968, 130, '2014-01-15 00:43:51.000000', 'consum', 0.0211, 'lps'),
	(500969, 130, '2014-01-15 00:43:52.000000', 'consum', 0.0223, 'lps'),
	(500970, 130, '2014-01-15 00:43:53.000000', 'consum', 0.0220, 'lps'),
	(500971, 130, '2014-01-15 00:43:54.000000', 'consum', 0.0220, 'lps'),
	(500972, 130, '2014-01-15 00:43:55.000000', 'consum', 0.0214, 'lps'),
	(500973, 130, '2014-01-15 00:43:56.000000', 'consum', 0.0217, 'lps'),
	(500974, 130, '2014-01-15 00:43:57.000000', 'consum', 0.0215, 'lps'),
	(500975, 130, '2014-01-15 00:43:58.000000', 'consum', 0.0218, 'lps'),
	(500976, 130, '2014-01-15 00:43:59.000000', 'consum', 0.0216, 'lps'),
	(500977, 130, '2014-01-15 00:44:00.000000', 'consum', 0.0218, 'lps'),
	(500978, 130, '2014-01-15 00:44:01.000000', 'consum', 0.0217, 'lps'),
	(500979, 130, '2014-01-15 00:44:02.000000', 'consum', 0.0219, 'lps'),
	(500980, 130, '2014-01-15 00:44:03.000000', 'consum', 0.0220, 'lps'),
	(500981, 130, '2014-01-15 00:44:04.000000', 'consum', 0.0214, 'lps'),
	(500982, 130, '2014-01-15 00:44:05.000000', 'consum', 0.0217, 'lps'),
	(500983, 130, '2014-01-15 00:44:06.000000', 'consum', 0.0217, 'lps'),
	(500984, 130, '2014-01-15 00:44:07.000000', 'consum', 0.0226, 'lps'),
	(500985, 130, '2014-01-15 00:44:08.000000', 'consum', 0.0219, 'lps'),
	(500986, 130, '2014-01-15 00:44:09.000000', 'consum', 0.0222, 'lps'),
	(500987, 130, '2014-01-15 00:44:10.000000', 'consum', 0.0210, 'lps'),
	(500988, 130, '2014-01-15 00:44:11.000000', 'consum', 0.0224, 'lps'),
	(500989, 130, '2014-01-15 00:44:12.000000', 'consum', 0.0215, 'lps'),
	(500990, 130, '2014-01-15 00:44:13.000000', 'consum', 0.0225, 'lps'),
	(500991, 130, '2014-01-15 00:44:14.000000', 'consum', 0.0219, 'lps'),
	(500992, 130, '2014-01-15 00:44:15.000000', 'consum', 0.0214, 'lps'),
	(500993, 130, '2014-01-15 00:44:16.000000', 'consum', 0.0218, 'lps'),
	(500994, 130, '2014-01-15 00:44:17.000000', 'consum', 0.0222, 'lps'),
	(500995, 130, '2014-01-15 00:44:18.000000', 'consum', 0.0213, 'lps'),
	(500996, 130, '2014-01-15 00:44:19.000000', 'consum', 0.0222, 'lps'),
	(500997, 130, '2014-01-15 00:44:20.000000', 'consum', 0.0212, 'lps'),
	(500998, 130, '2014-01-15 00:44:21.000000', 'consum', 0.0218, 'lps'),
	(500999, 130, '2014-01-15 00:44:22.000000', 'consum', 0.0211, 'lps'),
	(501000, 130, '2014-01-15 00:44:23.000000', 'consum', 0.0225, 'lps'),
	(501001, 130, '2014-01-15 00:44:24.000000', 'consum', 0.0213, 'lps'),
	(501002, 130, '2014-01-15 00:44:25.000000', 'consum', 0.0215, 'lps'),
	(501003, 130, '2014-01-15 00:44:26.000000', 'consum', 0.0211, 'lps'),
	(501004, 130, '2014-01-15 00:44:27.000000', 'consum', 0.0217, 'lps'),
	(501005, 130, '2014-01-15 00:44:28.000000', 'consum', 0.0210, 'lps'),
	(501006, 130, '2014-01-15 00:44:29.000000', 'consum', 0.0223, 'lps'),
	(501007, 130, '2014-01-15 00:44:30.000000', 'consum', 0.0223, 'lps'),
	(501008, 130, '2014-01-15 00:44:31.000000', 'consum', 0.0221, 'lps'),
	(501009, 130, '2014-01-15 00:44:32.000000', 'consum', 0.0211, 'lps'),
	(501010, 130, '2014-01-15 00:44:33.000000', 'consum', 0.0215, 'lps'),
	(501011, 130, '2014-01-15 00:44:34.000000', 'consum', 0.0217, 'lps'),
	(501012, 130, '2014-01-15 00:44:35.000000', 'consum', 0.0212, 'lps'),
	(501013, 130, '2014-01-15 00:44:36.000000', 'consum', 0.0216, 'lps'),
	(501014, 130, '2014-01-15 00:44:37.000000', 'consum', 0.0220, 'lps'),
	(501015, 130, '2014-01-15 00:44:38.000000', 'consum', 0.0224, 'lps'),
	(501016, 130, '2014-01-15 00:44:39.000000', 'consum', 0.0217, 'lps'),
	(501017, 130, '2014-01-15 00:44:40.000000', 'consum', 0.0219, 'lps'),
	(501018, 130, '2014-01-15 00:44:41.000000', 'consum', 0.0219, 'lps'),
	(501019, 130, '2014-01-15 00:44:42.000000', 'consum', 0.0210, 'lps'),
	(501020, 130, '2014-01-15 00:44:43.000000', 'consum', 0.0216, 'lps'),
	(501021, 130, '2014-01-15 00:44:44.000000', 'consum', 0.0226, 'lps'),
	(501022, 130, '2014-01-15 00:44:45.000000', 'consum', 0.0221, 'lps'),
	(501023, 130, '2014-01-15 00:44:46.000000', 'consum', 0.0218, 'lps'),
	(501024, 130, '2014-01-15 00:44:47.000000', 'consum', 0.0218, 'lps'),
	(501025, 130, '2014-01-15 00:44:48.000000', 'consum', 0.0211, 'lps'),
	(501026, 130, '2014-01-15 00:44:49.000000', 'consum', 0.0224, 'lps'),
	(501027, 130, '2014-01-15 00:44:50.000000', 'consum', 0.0226, 'lps'),
	(501028, 130, '2014-01-15 00:44:51.000000', 'consum', 0.0215, 'lps'),
	(501029, 130, '2014-01-15 00:44:52.000000', 'consum', 0.0223, 'lps'),
	(501030, 130, '2014-01-15 00:44:53.000000', 'consum', 0.0224, 'lps'),
	(501031, 130, '2014-01-15 00:44:54.000000', 'consum', 0.0224, 'lps'),
	(501032, 130, '2014-01-15 00:44:55.000000', 'consum', 0.0223, 'lps'),
	(501033, 130, '2014-01-15 00:44:56.000000', 'consum', 0.0218, 'lps'),
	(501034, 130, '2014-01-15 00:44:57.000000', 'consum', 0.0210, 'lps'),
	(501035, 130, '2014-01-15 00:44:58.000000', 'consum', 0.0220, 'lps'),
	(501036, 130, '2014-01-15 00:44:59.000000', 'consum', 0.0210, 'lps'),
	(501037, 130, '2014-01-15 00:45:00.000000', 'consum', 0.0214, 'lps'),
	(501038, 130, '2014-01-15 00:45:01.000000', 'consum', 0.0212, 'lps'),
	(501039, 130, '2014-01-15 00:45:02.000000', 'consum', 0.0211, 'lps'),
	(501040, 130, '2014-01-15 00:45:03.000000', 'consum', 0.0226, 'lps'),
	(501041, 130, '2014-01-15 00:45:04.000000', 'consum', 0.0220, 'lps'),
	(501042, 130, '2014-01-15 00:45:05.000000', 'consum', 0.0213, 'lps'),
	(501043, 130, '2014-01-15 00:45:06.000000', 'consum', 0.0210, 'lps'),
	(501044, 130, '2014-01-15 00:45:07.000000', 'consum', 0.0221, 'lps'),
	(501045, 130, '2014-01-15 00:45:08.000000', 'consum', 0.0215, 'lps'),
	(501046, 130, '2014-01-15 00:45:09.000000', 'consum', 0.0220, 'lps'),
	(501047, 130, '2014-01-15 00:45:10.000000', 'consum', 0.0226, 'lps'),
	(501048, 130, '2014-01-15 00:45:11.000000', 'consum', 0.0210, 'lps'),
	(501049, 130, '2014-01-15 00:45:12.000000', 'consum', 0.0213, 'lps'),
	(501050, 130, '2014-01-15 00:45:13.000000', 'consum', 0.0225, 'lps'),
	(501051, 130, '2014-01-15 00:45:14.000000', 'consum', 0.0211, 'lps'),
	(501052, 130, '2014-01-15 00:45:15.000000', 'consum', 0.0218, 'lps'),
	(501053, 130, '2014-01-15 00:45:16.000000', 'consum', 0.0216, 'lps'),
	(501054, 130, '2014-01-15 00:45:17.000000', 'consum', 0.0216, 'lps'),
	(501055, 130, '2014-01-15 00:45:18.000000', 'consum', 0.0222, 'lps'),
	(501056, 130, '2014-01-15 00:45:19.000000', 'consum', 0.0218, 'lps'),
	(501057, 130, '2014-01-15 00:45:20.000000', 'consum', 0.0215, 'lps'),
	(501058, 130, '2014-01-15 00:45:21.000000', 'consum', 0.0210, 'lps'),
	(501059, 130, '2014-01-15 00:45:22.000000', 'consum', 0.0212, 'lps'),
	(501060, 130, '2014-01-15 00:45:23.000000', 'consum', 0.0221, 'lps'),
	(501061, 130, '2014-01-15 00:45:24.000000', 'consum', 0.0210, 'lps'),
	(501062, 130, '2014-01-15 00:45:25.000000', 'consum', 0.0212, 'lps'),
	(501063, 130, '2014-01-15 00:45:26.000000', 'consum', 0.0220, 'lps'),
	(501064, 130, '2014-01-15 00:45:27.000000', 'consum', 0.0221, 'lps'),
	(501065, 130, '2014-01-15 00:45:28.000000', 'consum', 0.0218, 'lps'),
	(501066, 130, '2014-01-15 00:45:29.000000', 'consum', 0.0218, 'lps'),
	(501067, 130, '2014-01-15 00:45:30.000000', 'consum', 0.0224, 'lps'),
	(501068, 130, '2014-01-15 00:45:31.000000', 'consum', 0.0226, 'lps'),
	(501069, 130, '2014-01-15 00:45:32.000000', 'consum', 0.0212, 'lps'),
	(501070, 130, '2014-01-15 00:45:33.000000', 'consum', 0.0222, 'lps'),
	(501071, 130, '2014-01-15 00:45:34.000000', 'consum', 0.0217, 'lps'),
	(501072, 130, '2014-01-15 00:45:35.000000', 'consum', 0.0224, 'lps'),
	(501073, 130, '2014-01-15 00:45:36.000000', 'consum', 0.0226, 'lps'),
	(501074, 130, '2014-01-15 00:45:37.000000', 'consum', 0.0216, 'lps'),
	(501075, 130, '2014-01-15 00:45:38.000000', 'consum', 0.0226, 'lps'),
	(501076, 130, '2014-01-15 00:45:39.000000', 'consum', 0.0220, 'lps'),
	(501077, 130, '2014-01-15 00:45:40.000000', 'consum', 0.0215, 'lps'),
	(501078, 130, '2014-01-15 00:45:41.000000', 'consum', 0.0223, 'lps'),
	(501079, 130, '2014-01-15 00:45:42.000000', 'consum', 0.0225, 'lps'),
	(501080, 130, '2014-01-15 00:45:43.000000', 'consum', 0.0213, 'lps'),
	(501081, 130, '2014-01-15 00:45:44.000000', 'consum', 0.0212, 'lps'),
	(501082, 130, '2014-01-15 00:45:45.000000', 'consum', 0.0214, 'lps'),
	(501083, 130, '2014-01-15 00:45:46.000000', 'consum', 0.0225, 'lps'),
	(501084, 130, '2014-01-15 00:45:47.000000', 'consum', 0.0220, 'lps'),
	(501085, 130, '2014-01-15 00:45:48.000000', 'consum', 0.0215, 'lps'),
	(501086, 130, '2014-01-15 00:45:49.000000', 'consum', 0.0225, 'lps'),
	(501087, 130, '2014-01-15 00:45:50.000000', 'consum', 0.0219, 'lps'),
	(501088, 130, '2014-01-15 00:45:51.000000', 'consum', 0.0226, 'lps'),
	(501089, 130, '2014-01-15 00:45:52.000000', 'consum', 0.0213, 'lps'),
	(501090, 130, '2014-01-15 00:45:53.000000', 'consum', 0.0212, 'lps'),
	(501091, 130, '2014-01-15 00:45:54.000000', 'consum', 0.0211, 'lps'),
	(501092, 130, '2014-01-15 00:45:55.000000', 'consum', 0.0225, 'lps'),
	(501093, 130, '2014-01-15 00:45:56.000000', 'consum', 0.0214, 'lps'),
	(501094, 130, '2014-01-15 00:45:57.000000', 'consum', 0.0222, 'lps'),
	(501095, 130, '2014-01-15 00:45:58.000000', 'consum', 0.0222, 'lps'),
	(501096, 130, '2014-01-15 00:45:59.000000', 'consum', 0.0220, 'lps'),
	(501097, 130, '2014-01-15 00:46:00.000000', 'consum', 0.0226, 'lps'),
	(501098, 130, '2014-01-15 00:46:01.000000', 'consum', 0.0223, 'lps'),
	(501099, 130, '2014-01-15 00:46:02.000000', 'consum', 0.0212, 'lps'),
	(501100, 130, '2014-01-15 00:46:03.000000', 'consum', 0.0217, 'lps'),
	(501101, 130, '2014-01-15 00:46:04.000000', 'consum', 0.0220, 'lps'),
	(501102, 130, '2014-01-15 00:46:05.000000', 'consum', 0.0221, 'lps'),
	(501103, 130, '2014-01-15 00:46:06.000000', 'consum', 0.0222, 'lps'),
	(501104, 130, '2014-01-15 00:46:07.000000', 'consum', 0.0218, 'lps'),
	(501105, 130, '2014-01-15 00:46:08.000000', 'consum', 0.0217, 'lps'),
	(501106, 130, '2014-01-15 00:46:09.000000', 'consum', 0.0221, 'lps'),
	(501107, 130, '2014-01-15 00:46:10.000000', 'consum', 0.0226, 'lps'),
	(501108, 130, '2014-01-15 00:46:11.000000', 'consum', 0.0226, 'lps'),
	(501109, 130, '2014-01-15 00:46:12.000000', 'consum', 0.0224, 'lps'),
	(501110, 130, '2014-01-15 00:46:13.000000', 'consum', 0.0217, 'lps'),
	(501111, 130, '2014-01-15 00:46:14.000000', 'consum', 0.0217, 'lps'),
	(501112, 130, '2014-01-15 00:46:15.000000', 'consum', 0.0211, 'lps'),
	(501113, 130, '2014-01-15 00:46:16.000000', 'consum', 0.0212, 'lps'),
	(501114, 130, '2014-01-15 00:46:17.000000', 'consum', 0.0216, 'lps'),
	(501115, 130, '2014-01-15 00:46:18.000000', 'consum', 0.0219, 'lps'),
	(501116, 130, '2014-01-15 00:46:19.000000', 'consum', 0.0221, 'lps'),
	(501117, 130, '2014-01-15 00:46:20.000000', 'consum', 0.0220, 'lps'),
	(501118, 130, '2014-01-15 00:46:21.000000', 'consum', 0.0212, 'lps'),
	(501119, 130, '2014-01-15 00:46:22.000000', 'consum', 0.0222, 'lps'),
	(501120, 130, '2014-01-15 00:46:23.000000', 'consum', 0.0216, 'lps'),
	(501121, 130, '2014-01-15 00:46:24.000000', 'consum', 0.0223, 'lps'),
	(501122, 130, '2014-01-15 00:46:25.000000', 'consum', 0.0221, 'lps'),
	(501123, 130, '2014-01-15 00:46:26.000000', 'consum', 0.0226, 'lps'),
	(501124, 130, '2014-01-15 00:46:27.000000', 'consum', 0.0222, 'lps'),
	(501125, 130, '2014-01-15 00:46:28.000000', 'consum', 0.0226, 'lps'),
	(501126, 130, '2014-01-15 00:46:29.000000', 'consum', 0.0218, 'lps'),
	(501127, 130, '2014-01-15 00:46:30.000000', 'consum', 0.0219, 'lps'),
	(501128, 130, '2014-01-15 00:46:31.000000', 'consum', 0.0217, 'lps'),
	(501129, 130, '2014-01-15 00:46:32.000000', 'consum', 0.0219, 'lps'),
	(501130, 130, '2014-01-15 00:46:33.000000', 'consum', 0.0217, 'lps'),
	(501131, 130, '2014-01-15 00:46:34.000000', 'consum', 0.0219, 'lps'),
	(501132, 130, '2014-01-15 00:46:35.000000', 'consum', 0.0216, 'lps'),
	(501133, 130, '2014-01-15 00:46:36.000000', 'consum', 0.0213, 'lps'),
	(501134, 130, '2014-01-15 00:46:37.000000', 'consum', 0.0224, 'lps'),
	(501135, 130, '2014-01-15 00:46:38.000000', 'consum', 0.0223, 'lps'),
	(501136, 130, '2014-01-15 00:46:39.000000', 'consum', 0.0216, 'lps'),
	(501137, 130, '2014-01-15 00:46:40.000000', 'consum', 0.0220, 'lps'),
	(501138, 130, '2014-01-15 00:46:41.000000', 'consum', 0.0224, 'lps'),
	(501139, 130, '2014-01-15 00:46:42.000000', 'consum', 0.0218, 'lps'),
	(501140, 130, '2014-01-15 00:46:43.000000', 'consum', 0.0222, 'lps'),
	(501141, 130, '2014-01-15 00:46:44.000000', 'consum', 0.0216, 'lps'),
	(501142, 130, '2014-01-15 00:46:45.000000', 'consum', 0.0222, 'lps'),
	(501143, 130, '2014-01-15 00:46:46.000000', 'consum', 0.0216, 'lps'),
	(501144, 130, '2014-01-15 00:46:47.000000', 'consum', 0.0221, 'lps'),
	(501145, 130, '2014-01-15 00:46:48.000000', 'consum', 0.0214, 'lps'),
	(501146, 130, '2014-01-15 00:46:49.000000', 'consum', 0.0216, 'lps'),
	(501147, 130, '2014-01-15 00:46:50.000000', 'consum', 0.0226, 'lps'),
	(501148, 130, '2014-01-15 00:46:51.000000', 'consum', 0.0222, 'lps'),
	(501149, 130, '2014-01-15 00:46:52.000000', 'consum', 0.0221, 'lps'),
	(501150, 130, '2014-01-15 00:46:53.000000', 'consum', 0.0214, 'lps'),
	(501151, 130, '2014-01-15 00:46:54.000000', 'consum', 0.0215, 'lps'),
	(501152, 130, '2014-01-15 00:46:55.000000', 'consum', 0.0223, 'lps'),
	(501153, 130, '2014-01-15 00:46:56.000000', 'consum', 0.0210, 'lps'),
	(501154, 130, '2014-01-15 00:46:57.000000', 'consum', 0.0223, 'lps'),
	(501155, 130, '2014-01-15 00:46:58.000000', 'consum', 0.0226, 'lps'),
	(501156, 130, '2014-01-15 00:46:59.000000', 'consum', 0.0216, 'lps'),
	(501157, 130, '2014-01-15 00:47:00.000000', 'consum', 0.0226, 'lps'),
	(501158, 130, '2014-01-15 00:47:01.000000', 'consum', 0.0220, 'lps'),
	(501159, 130, '2014-01-15 00:47:02.000000', 'consum', 0.0215, 'lps'),
	(501160, 130, '2014-01-15 00:47:03.000000', 'consum', 0.0221, 'lps'),
	(501161, 130, '2014-01-15 00:47:04.000000', 'consum', 0.0218, 'lps'),
	(501162, 130, '2014-01-15 00:47:05.000000', 'consum', 0.0219, 'lps'),
	(501163, 130, '2014-01-15 00:47:06.000000', 'consum', 0.0212, 'lps'),
	(501164, 130, '2014-01-15 00:47:07.000000', 'consum', 0.0213, 'lps'),
	(501165, 130, '2014-01-15 00:47:08.000000', 'consum', 0.0219, 'lps'),
	(501166, 130, '2014-01-15 00:47:09.000000', 'consum', 0.0212, 'lps'),
	(501167, 130, '2014-01-15 00:47:10.000000', 'consum', 0.0226, 'lps'),
	(501168, 130, '2014-01-15 00:47:11.000000', 'consum', 0.0217, 'lps'),
	(501169, 130, '2014-01-15 00:47:12.000000', 'consum', 0.0214, 'lps'),
	(501170, 130, '2014-01-15 00:47:13.000000', 'consum', 0.0210, 'lps'),
	(501171, 130, '2014-01-15 00:47:14.000000', 'consum', 0.0216, 'lps'),
	(501172, 130, '2014-01-15 00:47:15.000000', 'consum', 0.0223, 'lps'),
	(501173, 130, '2014-01-15 00:47:16.000000', 'consum', 0.0222, 'lps'),
	(501174, 130, '2014-01-15 00:47:17.000000', 'consum', 0.0215, 'lps'),
	(501175, 130, '2014-01-15 00:47:18.000000', 'consum', 0.0218, 'lps'),
	(501176, 130, '2014-01-15 00:47:19.000000', 'consum', 0.0216, 'lps'),
	(501177, 130, '2014-01-15 00:47:20.000000', 'consum', 0.0219, 'lps'),
	(501178, 130, '2014-01-15 00:47:21.000000', 'consum', 0.0219, 'lps'),
	(501179, 130, '2014-01-15 00:47:22.000000', 'consum', 0.0210, 'lps'),
	(501180, 130, '2014-01-15 00:47:23.000000', 'consum', 0.0221, 'lps'),
	(501181, 130, '2014-01-15 00:47:24.000000', 'consum', 0.0211, 'lps'),
	(501182, 130, '2014-01-15 00:47:25.000000', 'consum', 0.0218, 'lps'),
	(501183, 130, '2014-01-15 00:47:26.000000', 'consum', 0.0215, 'lps'),
	(501184, 130, '2014-01-15 00:47:27.000000', 'consum', 0.0210, 'lps'),
	(501185, 130, '2014-01-15 00:47:28.000000', 'consum', 0.0213, 'lps'),
	(501186, 130, '2014-01-15 00:47:29.000000', 'consum', 0.0224, 'lps'),
	(501187, 130, '2014-01-15 00:47:30.000000', 'consum', 0.0223, 'lps'),
	(501188, 130, '2014-01-15 00:47:31.000000', 'consum', 0.0217, 'lps'),
	(501189, 130, '2014-01-15 00:47:32.000000', 'consum', 0.0223, 'lps'),
	(501190, 130, '2014-01-15 00:47:33.000000', 'consum', 0.0221, 'lps'),
	(501191, 130, '2014-01-15 00:47:34.000000', 'consum', 0.0210, 'lps'),
	(501192, 130, '2014-01-15 00:47:35.000000', 'consum', 0.0213, 'lps'),
	(501193, 130, '2014-01-15 00:47:36.000000', 'consum', 0.0222, 'lps'),
	(501194, 130, '2014-01-15 00:47:37.000000', 'consum', 0.0213, 'lps'),
	(501195, 130, '2014-01-15 00:47:38.000000', 'consum', 0.0222, 'lps'),
	(501196, 130, '2014-01-15 00:47:39.000000', 'consum', 0.0210, 'lps'),
	(501197, 130, '2014-01-15 00:47:40.000000', 'consum', 0.0224, 'lps'),
	(501198, 130, '2014-01-15 00:47:41.000000', 'consum', 0.0215, 'lps'),
	(501199, 130, '2014-01-15 00:47:42.000000', 'consum', 0.0212, 'lps'),
	(501200, 130, '2014-01-15 00:47:43.000000', 'consum', 0.0221, 'lps'),
	(501201, 130, '2014-01-15 00:47:44.000000', 'consum', 0.0223, 'lps'),
	(501202, 130, '2014-01-15 00:47:45.000000', 'consum', 0.0212, 'lps'),
	(501203, 130, '2014-01-15 00:47:46.000000', 'consum', 0.0215, 'lps'),
	(501204, 130, '2014-01-15 00:47:47.000000', 'consum', 0.0210, 'lps'),
	(501205, 130, '2014-01-15 00:47:48.000000', 'consum', 0.0215, 'lps'),
	(501206, 130, '2014-01-15 00:47:49.000000', 'consum', 0.0219, 'lps'),
	(501207, 130, '2014-01-15 00:47:50.000000', 'consum', 0.0224, 'lps'),
	(501208, 130, '2014-01-15 00:47:51.000000', 'consum', 0.0217, 'lps'),
	(501209, 130, '2014-01-15 00:47:52.000000', 'consum', 0.0220, 'lps'),
	(501210, 130, '2014-01-15 00:47:53.000000', 'consum', 0.0224, 'lps'),
	(501211, 130, '2014-01-15 00:47:54.000000', 'consum', 0.0218, 'lps'),
	(501212, 130, '2014-01-15 00:47:55.000000', 'consum', 0.0224, 'lps'),
	(501213, 130, '2014-01-15 00:47:56.000000', 'consum', 0.0221, 'lps'),
	(501214, 130, '2014-01-15 00:47:57.000000', 'consum', 0.0225, 'lps'),
	(501215, 130, '2014-01-15 00:47:58.000000', 'consum', 0.0219, 'lps'),
	(501216, 130, '2014-01-15 00:47:59.000000', 'consum', 0.0226, 'lps'),
	(501217, 130, '2014-01-15 00:48:00.000000', 'consum', 0.0215, 'lps'),
	(501218, 130, '2014-01-15 00:48:01.000000', 'consum', 0.0220, 'lps'),
	(501219, 130, '2014-01-15 00:48:02.000000', 'consum', 0.0211, 'lps'),
	(501220, 130, '2014-01-15 00:48:03.000000', 'consum', 0.0221, 'lps'),
	(501221, 130, '2014-01-15 00:48:04.000000', 'consum', 0.0211, 'lps'),
	(501222, 130, '2014-01-15 00:48:05.000000', 'consum', 0.0218, 'lps'),
	(501223, 130, '2014-01-15 00:48:06.000000', 'consum', 0.0212, 'lps'),
	(501224, 130, '2014-01-15 00:48:07.000000', 'consum', 0.0216, 'lps'),
	(501225, 130, '2014-01-15 00:48:08.000000', 'consum', 0.0215, 'lps'),
	(501226, 130, '2014-01-15 00:48:09.000000', 'consum', 0.0216, 'lps'),
	(501227, 130, '2014-01-15 00:48:10.000000', 'consum', 0.0211, 'lps'),
	(501228, 130, '2014-01-15 00:48:11.000000', 'consum', 0.0214, 'lps'),
	(501229, 130, '2014-01-15 00:48:12.000000', 'consum', 0.0212, 'lps'),
	(501230, 130, '2014-01-15 00:48:13.000000', 'consum', 0.0225, 'lps'),
	(501231, 130, '2014-01-15 00:48:14.000000', 'consum', 0.0211, 'lps'),
	(501232, 130, '2014-01-15 00:48:15.000000', 'consum', 0.0223, 'lps'),
	(501233, 130, '2014-01-15 00:48:16.000000', 'consum', 0.0219, 'lps'),
	(501234, 130, '2014-01-15 00:48:17.000000', 'consum', 0.0219, 'lps'),
	(501235, 130, '2014-01-15 00:48:18.000000', 'consum', 0.0210, 'lps'),
	(501236, 130, '2014-01-15 00:48:19.000000', 'consum', 0.0217, 'lps'),
	(501237, 130, '2014-01-15 00:48:20.000000', 'consum', 0.0214, 'lps'),
	(501238, 130, '2014-01-15 00:48:21.000000', 'consum', 0.0226, 'lps'),
	(501239, 130, '2014-01-15 00:48:22.000000', 'consum', 0.0226, 'lps'),
	(501240, 130, '2014-01-15 00:48:23.000000', 'consum', 0.0225, 'lps'),
	(501241, 130, '2014-01-15 00:48:24.000000', 'consum', 0.0223, 'lps'),
	(501242, 130, '2014-01-15 00:48:25.000000', 'consum', 0.0210, 'lps'),
	(501243, 130, '2014-01-15 00:48:26.000000', 'consum', 0.0225, 'lps'),
	(501244, 130, '2014-01-15 00:48:27.000000', 'consum', 0.0217, 'lps'),
	(501245, 130, '2014-01-15 00:48:28.000000', 'consum', 0.0217, 'lps'),
	(501246, 130, '2014-01-15 00:48:29.000000', 'consum', 0.0226, 'lps'),
	(501247, 130, '2014-01-15 00:48:30.000000', 'consum', 0.0219, 'lps'),
	(501248, 130, '2014-01-15 00:48:31.000000', 'consum', 0.0223, 'lps'),
	(501249, 130, '2014-01-15 00:48:32.000000', 'consum', 0.0213, 'lps'),
	(501250, 130, '2014-01-15 00:48:33.000000', 'consum', 0.0221, 'lps'),
	(501251, 130, '2014-01-15 00:48:34.000000', 'consum', 0.0222, 'lps'),
	(501252, 130, '2014-01-15 00:48:35.000000', 'consum', 0.0221, 'lps'),
	(501253, 130, '2014-01-15 00:48:36.000000', 'consum', 0.0211, 'lps'),
	(501254, 130, '2014-01-15 00:48:37.000000', 'consum', 0.0219, 'lps'),
	(501255, 130, '2014-01-15 00:48:38.000000', 'consum', 0.0216, 'lps'),
	(501256, 130, '2014-01-15 00:48:39.000000', 'consum', 0.0214, 'lps'),
	(501257, 130, '2014-01-15 00:48:40.000000', 'consum', 0.0212, 'lps'),
	(501258, 130, '2014-01-15 00:48:41.000000', 'consum', 0.0210, 'lps'),
	(501259, 130, '2014-01-15 00:48:42.000000', 'consum', 0.0222, 'lps'),
	(501260, 130, '2014-01-15 00:48:43.000000', 'consum', 0.0220, 'lps'),
	(501261, 130, '2014-01-15 00:48:44.000000', 'consum', 0.0225, 'lps'),
	(501262, 130, '2014-01-15 00:48:45.000000', 'consum', 0.0222, 'lps'),
	(501263, 130, '2014-01-15 00:48:46.000000', 'consum', 0.0210, 'lps'),
	(501264, 130, '2014-01-15 00:48:47.000000', 'consum', 0.0222, 'lps'),
	(501265, 130, '2014-01-15 00:48:48.000000', 'consum', 0.0220, 'lps'),
	(501266, 130, '2014-01-15 00:48:49.000000', 'consum', 0.0224, 'lps'),
	(501267, 130, '2014-01-15 00:48:50.000000', 'consum', 0.0215, 'lps'),
	(501268, 130, '2014-01-15 00:48:51.000000', 'consum', 0.0214, 'lps'),
	(501269, 130, '2014-01-15 00:48:52.000000', 'consum', 0.0215, 'lps'),
	(501270, 130, '2014-01-15 00:48:53.000000', 'consum', 0.0222, 'lps'),
	(501271, 130, '2014-01-15 00:48:54.000000', 'consum', 0.0223, 'lps'),
	(501272, 130, '2014-01-15 00:48:55.000000', 'consum', 0.0221, 'lps'),
	(501273, 130, '2014-01-15 00:48:56.000000', 'consum', 0.0210, 'lps'),
	(501274, 130, '2014-01-15 00:48:57.000000', 'consum', 0.0226, 'lps'),
	(501275, 130, '2014-01-15 00:48:58.000000', 'consum', 0.0226, 'lps'),
	(501276, 130, '2014-01-15 00:48:59.000000', 'consum', 0.0226, 'lps'),
	(501277, 130, '2014-01-15 00:49:00.000000', 'consum', 0.0222, 'lps'),
	(501278, 130, '2014-01-15 00:49:01.000000', 'consum', 0.0226, 'lps'),
	(501279, 130, '2014-01-15 00:49:02.000000', 'consum', 0.0218, 'lps'),
	(501280, 130, '2014-01-15 00:49:03.000000', 'consum', 0.0219, 'lps'),
	(501281, 130, '2014-01-15 00:49:04.000000', 'consum', 0.0217, 'lps'),
	(501282, 130, '2014-01-15 00:49:05.000000', 'consum', 0.0216, 'lps'),
	(501283, 130, '2014-01-15 00:49:06.000000', 'consum', 0.0219, 'lps'),
	(501284, 130, '2014-01-15 00:49:07.000000', 'consum', 0.0220, 'lps'),
	(501285, 130, '2014-01-15 00:49:08.000000', 'consum', 0.0219, 'lps'),
	(501286, 130, '2014-01-15 00:49:09.000000', 'consum', 0.0226, 'lps'),
	(501287, 130, '2014-01-15 00:49:10.000000', 'consum', 0.0212, 'lps'),
	(501288, 130, '2014-01-15 00:49:11.000000', 'consum', 0.0221, 'lps'),
	(501289, 130, '2014-01-15 00:49:12.000000', 'consum', 0.0212, 'lps'),
	(501290, 130, '2014-01-15 00:49:13.000000', 'consum', 0.0218, 'lps'),
	(501291, 130, '2014-01-15 00:49:14.000000', 'consum', 0.0212, 'lps'),
	(501292, 130, '2014-01-15 00:49:15.000000', 'consum', 0.0214, 'lps'),
	(501293, 130, '2014-01-15 00:49:16.000000', 'consum', 0.0225, 'lps'),
	(501294, 130, '2014-01-15 00:49:17.000000', 'consum', 0.0223, 'lps'),
	(501295, 130, '2014-01-15 00:49:18.000000', 'consum', 0.0213, 'lps'),
	(501296, 130, '2014-01-15 00:49:19.000000', 'consum', 0.0221, 'lps'),
	(501297, 130, '2014-01-15 00:49:20.000000', 'consum', 0.0223, 'lps'),
	(501298, 130, '2014-01-15 00:49:21.000000', 'consum', 0.0223, 'lps'),
	(501299, 130, '2014-01-15 00:49:22.000000', 'consum', 0.0221, 'lps'),
	(501300, 130, '2014-01-15 00:49:23.000000', 'consum', 0.0225, 'lps'),
	(501301, 130, '2014-01-15 00:49:24.000000', 'consum', 0.0221, 'lps'),
	(501302, 130, '2014-01-15 00:49:25.000000', 'consum', 0.0220, 'lps'),
	(501303, 130, '2014-01-15 00:49:26.000000', 'consum', 0.0226, 'lps'),
	(501304, 130, '2014-01-15 00:49:27.000000', 'consum', 0.0211, 'lps'),
	(501305, 130, '2014-01-15 00:49:28.000000', 'consum', 0.0217, 'lps'),
	(501306, 130, '2014-01-15 00:49:29.000000', 'consum', 0.0210, 'lps'),
	(501307, 130, '2014-01-15 00:49:30.000000', 'consum', 0.0224, 'lps'),
	(501308, 130, '2014-01-15 00:49:31.000000', 'consum', 0.0210, 'lps'),
	(501309, 130, '2014-01-15 00:49:32.000000', 'consum', 0.0220, 'lps'),
	(501310, 130, '2014-01-15 00:49:33.000000', 'consum', 0.0226, 'lps'),
	(501311, 130, '2014-01-15 00:49:34.000000', 'consum', 0.0211, 'lps'),
	(501312, 130, '2014-01-15 00:49:35.000000', 'consum', 0.0217, 'lps'),
	(501313, 130, '2014-01-15 00:49:36.000000', 'consum', 0.0226, 'lps'),
	(501314, 130, '2014-01-15 00:49:37.000000', 'consum', 0.0219, 'lps'),
	(501315, 130, '2014-01-15 00:49:38.000000', 'consum', 0.0222, 'lps'),
	(501316, 130, '2014-01-15 00:49:39.000000', 'consum', 0.0213, 'lps'),
	(501317, 130, '2014-01-15 00:49:40.000000', 'consum', 0.0223, 'lps'),
	(501318, 130, '2014-01-15 00:49:41.000000', 'consum', 0.0214, 'lps'),
	(501319, 130, '2014-01-15 00:49:42.000000', 'consum', 0.0226, 'lps'),
	(501320, 130, '2014-01-15 00:49:43.000000', 'consum', 0.0211, 'lps'),
	(501321, 130, '2014-01-15 00:49:44.000000', 'consum', 0.0218, 'lps'),
	(501322, 130, '2014-01-15 00:49:45.000000', 'consum', 0.0215, 'lps'),
	(501323, 130, '2014-01-15 00:49:46.000000', 'consum', 0.0211, 'lps'),
	(501324, 130, '2014-01-15 00:49:47.000000', 'consum', 0.0217, 'lps'),
	(501325, 130, '2014-01-15 00:49:48.000000', 'consum', 0.0210, 'lps'),
	(501326, 130, '2014-01-15 00:49:49.000000', 'consum', 0.0222, 'lps'),
	(501327, 130, '2014-01-15 00:49:50.000000', 'consum', 0.0219, 'lps'),
	(501328, 130, '2014-01-15 00:49:51.000000', 'consum', 0.0218, 'lps'),
	(501329, 130, '2014-01-15 00:49:52.000000', 'consum', 0.0225, 'lps'),
	(501330, 130, '2014-01-15 00:49:53.000000', 'consum', 0.0210, 'lps'),
	(501331, 130, '2014-01-15 00:49:54.000000', 'consum', 0.0216, 'lps'),
	(501332, 130, '2014-01-15 00:49:55.000000', 'consum', 0.0225, 'lps'),
	(501333, 130, '2014-01-15 00:49:56.000000', 'consum', 0.0217, 'lps'),
	(501334, 130, '2014-01-15 00:49:57.000000', 'consum', 0.0219, 'lps'),
	(501335, 130, '2014-01-15 00:49:58.000000', 'consum', 0.0214, 'lps'),
	(501336, 130, '2014-01-15 00:49:59.000000', 'consum', 0.0221, 'lps'),
	(501337, 130, '2014-01-15 00:50:00.000000', 'consum', 0.0221, 'lps'),
	(501338, 130, '2014-01-15 00:50:01.000000', 'consum', 0.0215, 'lps'),
	(501339, 130, '2014-01-15 00:50:02.000000', 'consum', 0.0219, 'lps'),
	(501340, 130, '2014-01-15 00:50:03.000000', 'consum', 0.0224, 'lps'),
	(501341, 130, '2014-01-15 00:50:04.000000', 'consum', 0.0221, 'lps'),
	(501342, 130, '2014-01-15 00:50:05.000000', 'consum', 0.0224, 'lps'),
	(501343, 130, '2014-01-15 00:50:06.000000', 'consum', 0.0214, 'lps'),
	(501344, 130, '2014-01-15 00:50:07.000000', 'consum', 0.0222, 'lps'),
	(501345, 130, '2014-01-15 00:50:08.000000', 'consum', 0.0226, 'lps'),
	(501346, 130, '2014-01-15 00:50:09.000000', 'consum', 0.0218, 'lps'),
	(501347, 130, '2014-01-15 00:50:10.000000', 'consum', 0.0222, 'lps'),
	(501348, 130, '2014-01-15 00:50:11.000000', 'consum', 0.0212, 'lps'),
	(501349, 130, '2014-01-15 00:50:12.000000', 'consum', 0.0220, 'lps'),
	(501350, 130, '2014-01-15 00:50:13.000000', 'consum', 0.0219, 'lps'),
	(501351, 130, '2014-01-15 00:50:14.000000', 'consum', 0.0210, 'lps'),
	(501352, 130, '2014-01-15 00:50:15.000000', 'consum', 0.0215, 'lps'),
	(501353, 130, '2014-01-15 00:50:16.000000', 'consum', 0.0221, 'lps'),
	(501354, 130, '2014-01-15 00:50:17.000000', 'consum', 0.0213, 'lps'),
	(501355, 130, '2014-01-15 00:50:18.000000', 'consum', 0.0213, 'lps'),
	(501356, 130, '2014-01-15 00:50:19.000000', 'consum', 0.0214, 'lps'),
	(501357, 130, '2014-01-15 00:50:20.000000', 'consum', 0.0223, 'lps'),
	(501358, 130, '2014-01-15 00:50:21.000000', 'consum', 0.0211, 'lps'),
	(501359, 130, '2014-01-15 00:50:22.000000', 'consum', 0.0212, 'lps'),
	(501360, 130, '2014-01-15 00:50:23.000000', 'consum', 0.0217, 'lps'),
	(501361, 130, '2014-01-15 00:50:24.000000', 'consum', 0.0221, 'lps'),
	(501362, 130, '2014-01-15 00:50:25.000000', 'consum', 0.0211, 'lps'),
	(501363, 130, '2014-01-15 00:50:26.000000', 'consum', 0.0217, 'lps'),
	(501364, 130, '2014-01-15 00:50:27.000000', 'consum', 0.0226, 'lps'),
	(501365, 130, '2014-01-15 00:50:28.000000', 'consum', 0.0218, 'lps'),
	(501366, 130, '2014-01-15 00:50:29.000000', 'consum', 0.0219, 'lps'),
	(501367, 130, '2014-01-15 00:50:30.000000', 'consum', 0.0214, 'lps'),
	(501368, 130, '2014-01-15 00:50:31.000000', 'consum', 0.0222, 'lps'),
	(501369, 130, '2014-01-15 00:50:32.000000', 'consum', 0.0223, 'lps'),
	(501370, 130, '2014-01-15 00:50:33.000000', 'consum', 0.0225, 'lps'),
	(501371, 130, '2014-01-15 00:50:34.000000', 'consum', 0.0211, 'lps'),
	(501372, 130, '2014-01-15 00:50:35.000000', 'consum', 0.0224, 'lps'),
	(501373, 130, '2014-01-15 00:50:36.000000', 'consum', 0.0224, 'lps'),
	(501374, 130, '2014-01-15 00:50:37.000000', 'consum', 0.0220, 'lps'),
	(501375, 130, '2014-01-15 00:50:38.000000', 'consum', 0.0220, 'lps'),
	(501376, 130, '2014-01-15 00:50:39.000000', 'consum', 0.0215, 'lps'),
	(501377, 130, '2014-01-15 00:50:40.000000', 'consum', 0.0221, 'lps'),
	(501378, 130, '2014-01-15 00:50:41.000000', 'consum', 0.0215, 'lps'),
	(501379, 130, '2014-01-15 00:50:42.000000', 'consum', 0.0220, 'lps'),
	(501380, 130, '2014-01-15 00:50:43.000000', 'consum', 0.0212, 'lps'),
	(501381, 130, '2014-01-15 00:50:44.000000', 'consum', 0.0224, 'lps'),
	(501382, 130, '2014-01-15 00:50:45.000000', 'consum', 0.0223, 'lps'),
	(501383, 130, '2014-01-15 00:50:46.000000', 'consum', 0.0217, 'lps'),
	(501384, 130, '2014-01-15 00:50:47.000000', 'consum', 0.0223, 'lps'),
	(501385, 130, '2014-01-15 00:50:48.000000', 'consum', 0.0222, 'lps'),
	(501386, 130, '2014-01-15 00:50:49.000000', 'consum', 0.0212, 'lps'),
	(501387, 130, '2014-01-15 00:50:50.000000', 'consum', 0.0220, 'lps'),
	(501388, 130, '2014-01-15 00:50:51.000000', 'consum', 0.0222, 'lps'),
	(501389, 130, '2014-01-15 00:50:52.000000', 'consum', 0.0221, 'lps'),
	(501390, 130, '2014-01-15 00:50:53.000000', 'consum', 0.0213, 'lps'),
	(501391, 130, '2014-01-15 00:50:54.000000', 'consum', 0.0211, 'lps'),
	(501392, 130, '2014-01-15 00:50:55.000000', 'consum', 0.0221, 'lps'),
	(501393, 130, '2014-01-15 00:50:56.000000', 'consum', 0.0212, 'lps'),
	(501394, 130, '2014-01-15 00:50:57.000000', 'consum', 0.0221, 'lps'),
	(501395, 130, '2014-01-15 00:50:58.000000', 'consum', 0.0210, 'lps'),
	(501396, 130, '2014-01-15 00:50:59.000000', 'consum', 0.0210, 'lps'),
	(501397, 130, '2014-01-15 00:51:00.000000', 'consum', 0.0212, 'lps'),
	(501398, 130, '2014-01-15 00:51:01.000000', 'consum', 0.0220, 'lps'),
	(501399, 130, '2014-01-15 00:51:02.000000', 'consum', 0.0219, 'lps'),
	(501400, 130, '2014-01-15 00:51:03.000000', 'consum', 0.0226, 'lps'),
	(501401, 130, '2014-01-15 00:51:04.000000', 'consum', 0.0212, 'lps'),
	(501402, 130, '2014-01-15 00:51:05.000000', 'consum', 0.0226, 'lps'),
	(501403, 130, '2014-01-15 00:51:06.000000', 'consum', 0.0214, 'lps'),
	(501404, 130, '2014-01-15 00:51:07.000000', 'consum', 0.0218, 'lps'),
	(501405, 130, '2014-01-15 00:51:08.000000', 'consum', 0.0223, 'lps'),
	(501406, 130, '2014-01-15 00:51:09.000000', 'consum', 0.0217, 'lps'),
	(501407, 130, '2014-01-15 00:51:10.000000', 'consum', 0.0222, 'lps'),
	(501408, 130, '2014-01-15 00:51:11.000000', 'consum', 0.0215, 'lps'),
	(501409, 130, '2014-01-15 00:51:12.000000', 'consum', 0.0217, 'lps'),
	(501410, 130, '2014-01-15 00:51:13.000000', 'consum', 0.0214, 'lps'),
	(501411, 130, '2014-01-15 00:51:14.000000', 'consum', 0.0226, 'lps'),
	(501412, 130, '2014-01-15 00:51:15.000000', 'consum', 0.0210, 'lps'),
	(501413, 130, '2014-01-15 00:51:16.000000', 'consum', 0.0214, 'lps'),
	(501414, 130, '2014-01-15 00:51:17.000000', 'consum', 0.0212, 'lps'),
	(501415, 130, '2014-01-15 00:51:18.000000', 'consum', 0.0210, 'lps'),
	(501416, 130, '2014-01-15 00:51:19.000000', 'consum', 0.0221, 'lps'),
	(501417, 130, '2014-01-15 00:51:20.000000', 'consum', 0.0215, 'lps'),
	(501418, 130, '2014-01-15 00:51:21.000000', 'consum', 0.0218, 'lps'),
	(501419, 130, '2014-01-15 00:51:22.000000', 'consum', 0.0219, 'lps'),
	(501420, 130, '2014-01-15 00:51:23.000000', 'consum', 0.0215, 'lps'),
	(501421, 130, '2014-01-15 00:51:24.000000', 'consum', 0.0226, 'lps'),
	(501422, 130, '2014-01-15 00:51:25.000000', 'consum', 0.0225, 'lps'),
	(501423, 130, '2014-01-15 00:51:26.000000', 'consum', 0.0220, 'lps'),
	(501424, 130, '2014-01-15 00:51:27.000000', 'consum', 0.0213, 'lps'),
	(501425, 130, '2014-01-15 00:51:28.000000', 'consum', 0.0216, 'lps'),
	(501426, 130, '2014-01-15 00:51:29.000000', 'consum', 0.0212, 'lps'),
	(501427, 130, '2014-01-15 00:51:30.000000', 'consum', 0.0219, 'lps'),
	(501428, 130, '2014-01-15 00:51:31.000000', 'consum', 0.0217, 'lps'),
	(501429, 130, '2014-01-15 00:51:32.000000', 'consum', 0.0220, 'lps'),
	(501430, 130, '2014-01-15 00:51:33.000000', 'consum', 0.0221, 'lps'),
	(501431, 130, '2014-01-15 00:51:34.000000', 'consum', 0.0220, 'lps'),
	(501432, 130, '2014-01-15 00:51:35.000000', 'consum', 0.0225, 'lps'),
	(501433, 130, '2014-01-15 00:51:36.000000', 'consum', 0.0224, 'lps'),
	(501434, 130, '2014-01-15 00:51:37.000000', 'consum', 0.0216, 'lps'),
	(501435, 130, '2014-01-15 00:51:38.000000', 'consum', 0.0216, 'lps'),
	(501436, 130, '2014-01-15 00:51:39.000000', 'consum', 0.0224, 'lps'),
	(501437, 130, '2014-01-15 00:51:40.000000', 'consum', 0.0226, 'lps'),
	(501438, 130, '2014-01-15 00:51:41.000000', 'consum', 0.0216, 'lps'),
	(501439, 130, '2014-01-15 00:51:42.000000', 'consum', 0.0211, 'lps'),
	(501440, 130, '2014-01-15 00:51:43.000000', 'consum', 0.0213, 'lps'),
	(501441, 130, '2014-01-15 00:51:44.000000', 'consum', 0.0221, 'lps'),
	(501442, 130, '2014-01-15 00:51:45.000000', 'consum', 0.0222, 'lps'),
	(501443, 130, '2014-01-15 00:51:46.000000', 'consum', 0.0221, 'lps'),
	(501444, 130, '2014-01-15 00:51:47.000000', 'consum', 0.0214, 'lps'),
	(501445, 130, '2014-01-15 00:51:48.000000', 'consum', 0.0214, 'lps'),
	(501446, 130, '2014-01-15 00:51:49.000000', 'consum', 0.0219, 'lps'),
	(501447, 130, '2014-01-15 00:51:50.000000', 'consum', 0.0210, 'lps'),
	(501448, 130, '2014-01-15 00:51:51.000000', 'consum', 0.0218, 'lps'),
	(501449, 130, '2014-01-15 00:51:52.000000', 'consum', 0.0218, 'lps'),
	(501450, 130, '2014-01-15 00:51:53.000000', 'consum', 0.0224, 'lps'),
	(501451, 130, '2014-01-15 00:51:54.000000', 'consum', 0.0223, 'lps'),
	(501452, 130, '2014-01-15 00:51:55.000000', 'consum', 0.0216, 'lps'),
	(501453, 130, '2014-01-15 00:51:56.000000', 'consum', 0.0219, 'lps'),
	(501454, 130, '2014-01-15 00:51:57.000000', 'consum', 0.0219, 'lps'),
	(501455, 130, '2014-01-15 00:51:58.000000', 'consum', 0.0213, 'lps'),
	(501456, 130, '2014-01-15 00:51:59.000000', 'consum', 0.0215, 'lps'),
	(501457, 130, '2014-01-15 00:52:00.000000', 'consum', 0.0210, 'lps'),
	(501458, 130, '2014-01-15 00:52:01.000000', 'consum', 0.0213, 'lps'),
	(501459, 130, '2014-01-15 00:52:02.000000', 'consum', 0.0225, 'lps'),
	(501460, 130, '2014-01-15 00:52:03.000000', 'consum', 0.0210, 'lps'),
	(501461, 130, '2014-01-15 00:52:04.000000', 'consum', 0.0215, 'lps'),
	(501462, 130, '2014-01-15 00:52:05.000000', 'consum', 0.0220, 'lps'),
	(501463, 130, '2014-01-15 00:52:06.000000', 'consum', 0.0210, 'lps'),
	(501464, 130, '2014-01-15 00:52:07.000000', 'consum', 0.0214, 'lps'),
	(501465, 130, '2014-01-15 00:52:08.000000', 'consum', 0.0214, 'lps'),
	(501466, 130, '2014-01-15 00:52:09.000000', 'consum', 0.0221, 'lps'),
	(501467, 130, '2014-01-15 00:52:10.000000', 'consum', 0.0217, 'lps'),
	(501468, 130, '2014-01-15 00:52:11.000000', 'consum', 0.0212, 'lps'),
	(501469, 130, '2014-01-15 00:52:12.000000', 'consum', 0.0217, 'lps'),
	(501470, 130, '2014-01-15 00:52:13.000000', 'consum', 0.0222, 'lps'),
	(501471, 130, '2014-01-15 00:52:14.000000', 'consum', 0.0214, 'lps'),
	(501472, 130, '2014-01-15 00:52:15.000000', 'consum', 0.0213, 'lps'),
	(501473, 130, '2014-01-15 00:52:16.000000', 'consum', 0.0212, 'lps'),
	(501474, 130, '2014-01-15 00:52:17.000000', 'consum', 0.0214, 'lps'),
	(501475, 130, '2014-01-15 00:52:18.000000', 'consum', 0.0224, 'lps'),
	(501476, 130, '2014-01-15 00:52:19.000000', 'consum', 0.0216, 'lps'),
	(501477, 130, '2014-01-15 00:52:20.000000', 'consum', 0.0217, 'lps'),
	(501478, 130, '2014-01-15 00:52:21.000000', 'consum', 0.0225, 'lps'),
	(501479, 130, '2014-01-15 00:52:22.000000', 'consum', 0.0216, 'lps'),
	(501480, 130, '2014-01-15 00:52:23.000000', 'consum', 0.0212, 'lps'),
	(501481, 130, '2014-01-15 00:52:24.000000', 'consum', 0.0219, 'lps'),
	(501482, 130, '2014-01-15 00:52:25.000000', 'consum', 0.0216, 'lps'),
	(501483, 130, '2014-01-15 00:52:26.000000', 'consum', 0.0215, 'lps'),
	(501484, 130, '2014-01-15 00:52:27.000000', 'consum', 0.0215, 'lps'),
	(501485, 130, '2014-01-15 00:52:28.000000', 'consum', 0.0221, 'lps'),
	(501486, 130, '2014-01-15 00:52:29.000000', 'consum', 0.0215, 'lps'),
	(501487, 130, '2014-01-15 00:52:30.000000', 'consum', 0.0223, 'lps'),
	(501488, 130, '2014-01-15 00:52:31.000000', 'consum', 0.0224, 'lps'),
	(501489, 130, '2014-01-15 00:52:32.000000', 'consum', 0.0210, 'lps'),
	(501490, 130, '2014-01-15 00:52:33.000000', 'consum', 0.0218, 'lps'),
	(501491, 130, '2014-01-15 00:52:34.000000', 'consum', 0.0218, 'lps'),
	(501492, 130, '2014-01-15 00:52:35.000000', 'consum', 0.0224, 'lps'),
	(501493, 130, '2014-01-15 00:52:36.000000', 'consum', 0.0223, 'lps'),
	(501494, 130, '2014-01-15 00:52:37.000000', 'consum', 0.0216, 'lps'),
	(501495, 130, '2014-01-15 00:52:38.000000', 'consum', 0.0221, 'lps'),
	(501496, 130, '2014-01-15 00:52:39.000000', 'consum', 0.0211, 'lps'),
	(501497, 130, '2014-01-15 00:52:40.000000', 'consum', 0.0217, 'lps'),
	(501498, 130, '2014-01-15 00:52:41.000000', 'consum', 0.0210, 'lps'),
	(501499, 130, '2014-01-15 00:52:42.000000', 'consum', 0.0224, 'lps'),
	(501500, 130, '2014-01-15 00:52:43.000000', 'consum', 0.0210, 'lps'),
	(501501, 130, '2014-01-15 00:52:44.000000', 'consum', 0.0220, 'lps'),
	(501502, 130, '2014-01-15 00:52:45.000000', 'consum', 0.0210, 'lps'),
	(501503, 130, '2014-01-15 00:52:46.000000', 'consum', 0.0214, 'lps'),
	(501504, 130, '2014-01-15 00:52:47.000000', 'consum', 0.0213, 'lps'),
	(501505, 130, '2014-01-15 00:52:48.000000', 'consum', 0.0212, 'lps'),
	(501506, 130, '2014-01-15 00:52:49.000000', 'consum', 0.0213, 'lps'),
	(501507, 130, '2014-01-15 00:52:50.000000', 'consum', 0.0221, 'lps'),
	(501508, 130, '2014-01-15 00:52:51.000000', 'consum', 0.0222, 'lps'),
	(501509, 130, '2014-01-15 00:52:52.000000', 'consum', 0.0221, 'lps'),
	(501510, 130, '2014-01-15 00:52:53.000000', 'consum', 0.0213, 'lps'),
	(501511, 130, '2014-01-15 00:52:54.000000', 'consum', 0.0226, 'lps'),
	(501512, 130, '2014-01-15 00:52:55.000000', 'consum', 0.0214, 'lps'),
	(501513, 130, '2014-01-15 00:52:56.000000', 'consum', 0.0214, 'lps'),
	(501514, 130, '2014-01-15 00:52:57.000000', 'consum', 0.0220, 'lps'),
	(501515, 130, '2014-01-15 00:52:58.000000', 'consum', 0.0216, 'lps'),
	(501516, 130, '2014-01-15 00:52:59.000000', 'consum', 0.0226, 'lps'),
	(501517, 130, '2014-01-15 00:53:00.000000', 'consum', 0.0223, 'lps'),
	(501518, 130, '2014-01-15 00:53:01.000000', 'consum', 0.0226, 'lps'),
	(501519, 130, '2014-01-15 00:53:02.000000', 'consum', 0.0218, 'lps'),
	(501520, 130, '2014-01-15 00:53:03.000000', 'consum', 0.0218, 'lps'),
	(501521, 130, '2014-01-15 00:53:04.000000', 'consum', 0.0226, 'lps'),
	(501522, 130, '2014-01-15 00:53:05.000000', 'consum', 0.0217, 'lps'),
	(501523, 130, '2014-01-15 00:53:06.000000', 'consum', 0.0215, 'lps'),
	(501524, 130, '2014-01-15 00:53:07.000000', 'consum', 0.0212, 'lps'),
	(501525, 130, '2014-01-15 00:53:08.000000', 'consum', 0.0225, 'lps'),
	(501526, 130, '2014-01-15 00:53:09.000000', 'consum', 0.0211, 'lps'),
	(501527, 130, '2014-01-15 00:53:10.000000', 'consum', 0.0222, 'lps'),
	(501528, 130, '2014-01-15 00:53:11.000000', 'consum', 0.0218, 'lps'),
	(501529, 130, '2014-01-15 00:53:12.000000', 'consum', 0.0212, 'lps'),
	(501530, 130, '2014-01-15 00:53:13.000000', 'consum', 0.0213, 'lps'),
	(501531, 130, '2014-01-15 00:53:14.000000', 'consum', 0.0222, 'lps'),
	(501532, 130, '2014-01-15 00:53:15.000000', 'consum', 0.0225, 'lps'),
	(501533, 130, '2014-01-15 00:53:16.000000', 'consum', 0.0219, 'lps'),
	(501534, 130, '2014-01-15 00:53:17.000000', 'consum', 0.0224, 'lps'),
	(501535, 130, '2014-01-15 00:53:18.000000', 'consum', 0.0219, 'lps'),
	(501536, 130, '2014-01-15 00:53:19.000000', 'consum', 0.0216, 'lps'),
	(501537, 130, '2014-01-15 00:53:20.000000', 'consum', 0.0213, 'lps'),
	(501538, 130, '2014-01-15 00:53:21.000000', 'consum', 0.0223, 'lps'),
	(501539, 130, '2014-01-15 00:53:22.000000', 'consum', 0.0215, 'lps'),
	(501540, 130, '2014-01-15 00:53:23.000000', 'consum', 0.0216, 'lps'),
	(501541, 130, '2014-01-15 00:53:24.000000', 'consum', 0.0225, 'lps'),
	(501542, 130, '2014-01-15 00:53:25.000000', 'consum', 0.0217, 'lps'),
	(501543, 130, '2014-01-15 00:53:26.000000', 'consum', 0.0216, 'lps'),
	(501544, 130, '2014-01-15 00:53:27.000000', 'consum', 0.0221, 'lps'),
	(501545, 130, '2014-01-15 00:53:28.000000', 'consum', 0.0211, 'lps'),
	(501546, 130, '2014-01-15 00:53:29.000000', 'consum', 0.0217, 'lps'),
	(501547, 130, '2014-01-15 00:53:30.000000', 'consum', 0.0210, 'lps'),
	(501548, 130, '2014-01-15 00:53:31.000000', 'consum', 0.0224, 'lps'),
	(501549, 130, '2014-01-15 00:53:32.000000', 'consum', 0.0213, 'lps'),
	(501550, 130, '2014-01-15 00:53:33.000000', 'consum', 0.0215, 'lps'),
	(501551, 130, '2014-01-15 00:53:34.000000', 'consum', 0.0212, 'lps'),
	(501552, 130, '2014-01-15 00:53:35.000000', 'consum', 0.0221, 'lps'),
	(501553, 130, '2014-01-15 00:53:36.000000', 'consum', 0.0225, 'lps'),
	(501554, 130, '2014-01-15 00:53:37.000000', 'consum', 0.0217, 'lps'),
	(501555, 130, '2014-01-15 00:53:38.000000', 'consum', 0.0220, 'lps'),
	(501556, 130, '2014-01-15 00:53:39.000000', 'consum', 0.0221, 'lps'),
	(501557, 130, '2014-01-15 00:53:40.000000', 'consum', 0.0218, 'lps'),
	(501558, 130, '2014-01-15 00:53:41.000000', 'consum', 0.0219, 'lps'),
	(501559, 130, '2014-01-15 00:53:42.000000', 'consum', 0.0212, 'lps'),
	(501560, 130, '2014-01-15 00:53:43.000000', 'consum', 0.0213, 'lps'),
	(501561, 130, '2014-01-15 00:53:44.000000', 'consum', 0.0217, 'lps'),
	(501562, 130, '2014-01-15 00:53:45.000000', 'consum', 0.0223, 'lps'),
	(501563, 130, '2014-01-15 00:53:46.000000', 'consum', 0.0218, 'lps'),
	(501564, 130, '2014-01-15 00:53:47.000000', 'consum', 0.0213, 'lps'),
	(501565, 130, '2014-01-15 00:53:48.000000', 'consum', 0.0218, 'lps'),
	(501566, 130, '2014-01-15 00:53:49.000000', 'consum', 0.0225, 'lps'),
	(501567, 130, '2014-01-15 00:53:50.000000', 'consum', 0.0226, 'lps'),
	(501568, 130, '2014-01-15 00:53:51.000000', 'consum', 0.0210, 'lps'),
	(501569, 130, '2014-01-15 00:53:52.000000', 'consum', 0.0216, 'lps'),
	(501570, 130, '2014-01-15 00:53:53.000000', 'consum', 0.0225, 'lps'),
	(501571, 130, '2014-01-15 00:53:54.000000', 'consum', 0.0215, 'lps'),
	(501572, 130, '2014-01-15 00:53:55.000000', 'consum', 0.0223, 'lps'),
	(501573, 130, '2014-01-15 00:53:56.000000', 'consum', 0.0226, 'lps'),
	(501574, 130, '2014-01-15 00:53:57.000000', 'consum', 0.0217, 'lps'),
	(501575, 130, '2014-01-15 00:53:58.000000', 'consum', 0.0215, 'lps'),
	(501576, 130, '2014-01-15 00:53:59.000000', 'consum', 0.0215, 'lps'),
	(501577, 130, '2014-01-15 00:54:00.000000', 'consum', 0.0219, 'lps'),
	(501578, 130, '2014-01-15 00:54:01.000000', 'consum', 0.0223, 'lps'),
	(501579, 130, '2014-01-15 00:54:02.000000', 'consum', 0.0214, 'lps'),
	(501580, 130, '2014-01-15 00:54:03.000000', 'consum', 0.0224, 'lps'),
	(501581, 130, '2014-01-15 00:54:04.000000', 'consum', 0.0221, 'lps'),
	(501582, 130, '2014-01-15 00:54:05.000000', 'consum', 0.0223, 'lps'),
	(501583, 130, '2014-01-15 00:54:06.000000', 'consum', 0.0226, 'lps'),
	(501584, 130, '2014-01-15 00:54:07.000000', 'consum', 0.0216, 'lps'),
	(501585, 130, '2014-01-15 00:54:08.000000', 'consum', 0.0210, 'lps'),
	(501586, 130, '2014-01-15 00:54:09.000000', 'consum', 0.0225, 'lps'),
	(501587, 130, '2014-01-15 00:54:10.000000', 'consum', 0.0219, 'lps'),
	(501588, 130, '2014-01-15 00:54:11.000000', 'consum', 0.0210, 'lps'),
	(501589, 130, '2014-01-15 00:54:12.000000', 'consum', 0.0219, 'lps'),
	(501590, 130, '2014-01-15 00:54:13.000000', 'consum', 0.0220, 'lps'),
	(501591, 130, '2014-01-15 00:54:14.000000', 'consum', 0.0219, 'lps'),
	(501592, 130, '2014-01-15 00:54:15.000000', 'consum', 0.0224, 'lps'),
	(501593, 130, '2014-01-15 00:54:16.000000', 'consum', 0.0218, 'lps'),
	(501594, 130, '2014-01-15 00:54:17.000000', 'consum', 0.0211, 'lps'),
	(501595, 130, '2014-01-15 00:54:18.000000', 'consum', 0.0225, 'lps'),
	(501596, 130, '2014-01-15 00:54:19.000000', 'consum', 0.0215, 'lps'),
	(501597, 130, '2014-01-15 00:54:20.000000', 'consum', 0.0223, 'lps'),
	(501598, 130, '2014-01-15 00:54:21.000000', 'consum', 0.0210, 'lps'),
	(501599, 130, '2014-01-15 00:54:22.000000', 'consum', 0.0220, 'lps'),
	(501600, 130, '2014-01-15 00:54:23.000000', 'consum', 0.0213, 'lps'),
	(501601, 130, '2014-01-15 00:54:24.000000', 'consum', 0.0213, 'lps'),
	(501602, 130, '2014-01-15 00:54:25.000000', 'consum', 0.0215, 'lps'),
	(501603, 130, '2014-01-15 00:54:26.000000', 'consum', 0.0212, 'lps'),
	(501604, 130, '2014-01-15 00:54:27.000000', 'consum', 0.0220, 'lps'),
	(501605, 130, '2014-01-15 00:54:28.000000', 'consum', 0.0220, 'lps'),
	(501606, 130, '2014-01-15 00:54:29.000000', 'consum', 0.0214, 'lps'),
	(501607, 130, '2014-01-15 00:54:30.000000', 'consum', 0.0218, 'lps'),
	(501608, 130, '2014-01-15 00:54:31.000000', 'consum', 0.0223, 'lps'),
	(501609, 130, '2014-01-15 00:54:32.000000', 'consum', 0.0215, 'lps'),
	(501610, 130, '2014-01-15 00:54:33.000000', 'consum', 0.0213, 'lps'),
	(501611, 130, '2014-01-15 00:54:34.000000', 'consum', 0.0210, 'lps'),
	(501612, 130, '2014-01-15 00:54:35.000000', 'consum', 0.0219, 'lps'),
	(501613, 130, '2014-01-15 00:54:36.000000', 'consum', 0.0223, 'lps'),
	(501614, 130, '2014-01-15 00:54:37.000000', 'consum', 0.0215, 'lps'),
	(501615, 130, '2014-01-15 00:54:38.000000', 'consum', 0.0214, 'lps'),
	(501616, 130, '2014-01-15 00:54:39.000000', 'consum', 0.0216, 'lps'),
	(501617, 130, '2014-01-15 00:54:40.000000', 'consum', 0.0210, 'lps'),
	(501618, 130, '2014-01-15 00:54:41.000000', 'consum', 0.0225, 'lps'),
	(501619, 130, '2014-01-15 00:54:42.000000', 'consum', 0.0219, 'lps'),
	(501620, 130, '2014-01-15 00:54:43.000000', 'consum', 0.0210, 'lps'),
	(501621, 130, '2014-01-15 00:54:44.000000', 'consum', 0.0218, 'lps'),
	(501622, 130, '2014-01-15 00:54:45.000000', 'consum', 0.0215, 'lps'),
	(501623, 130, '2014-01-15 00:54:46.000000', 'consum', 0.0213, 'lps'),
	(501624, 130, '2014-01-15 00:54:47.000000', 'consum', 0.0211, 'lps'),
	(501625, 130, '2014-01-15 00:54:48.000000', 'consum', 0.0224, 'lps'),
	(501626, 130, '2014-01-15 00:54:49.000000', 'consum', 0.0225, 'lps'),
	(501627, 130, '2014-01-15 00:54:50.000000', 'consum', 0.0212, 'lps'),
	(501628, 130, '2014-01-15 00:54:51.000000', 'consum', 0.0224, 'lps'),
	(501629, 130, '2014-01-15 00:54:52.000000', 'consum', 0.0225, 'lps'),
	(501630, 130, '2014-01-15 00:54:53.000000', 'consum', 0.0211, 'lps'),
	(501631, 130, '2014-01-15 00:54:54.000000', 'consum', 0.0220, 'lps'),
	(501632, 130, '2014-01-15 00:54:55.000000', 'consum', 0.0224, 'lps'),
	(501633, 130, '2014-01-15 00:54:56.000000', 'consum', 0.0218, 'lps'),
	(501634, 130, '2014-01-15 00:54:57.000000', 'consum', 0.0225, 'lps'),
	(501635, 130, '2014-01-15 00:54:58.000000', 'consum', 0.0210, 'lps'),
	(501636, 130, '2014-01-15 00:54:59.000000', 'consum', 0.0218, 'lps'),
	(501637, 130, '2014-01-15 00:55:00.000000', 'consum', 0.0215, 'lps'),
	(501638, 130, '2014-01-15 00:55:01.000000', 'consum', 0.0210, 'lps'),
	(501639, 130, '2014-01-15 00:55:02.000000', 'consum', 0.0213, 'lps'),
	(501640, 130, '2014-01-15 00:55:03.000000', 'consum', 0.0211, 'lps'),
	(501641, 130, '2014-01-15 00:55:04.000000', 'consum', 0.0220, 'lps'),
	(501642, 130, '2014-01-15 00:55:05.000000', 'consum', 0.0210, 'lps'),
	(501643, 130, '2014-01-15 00:55:06.000000', 'consum', 0.0214, 'lps'),
	(501644, 130, '2014-01-15 00:55:07.000000', 'consum', 0.0211, 'lps'),
	(501645, 130, '2014-01-15 00:55:08.000000', 'consum', 0.0221, 'lps'),
	(501646, 130, '2014-01-15 00:55:09.000000', 'consum', 0.0212, 'lps'),
	(501647, 130, '2014-01-15 00:55:10.000000', 'consum', 0.0222, 'lps'),
	(501648, 130, '2014-01-15 00:55:11.000000', 'consum', 0.0214, 'lps'),
	(501649, 130, '2014-01-15 00:55:12.000000', 'consum', 0.0226, 'lps'),
	(501650, 130, '2014-01-15 00:55:13.000000', 'consum', 0.0214, 'lps'),
	(501651, 130, '2014-01-15 00:55:14.000000', 'consum', 0.0214, 'lps'),
	(501652, 130, '2014-01-15 00:55:15.000000', 'consum', 0.0221, 'lps'),
	(501653, 130, '2014-01-15 00:55:16.000000', 'consum', 0.0218, 'lps'),
	(501654, 130, '2014-01-15 00:55:17.000000', 'consum', 0.0217, 'lps'),
	(501655, 130, '2014-01-15 00:55:18.000000', 'consum', 0.0224, 'lps'),
	(501656, 130, '2014-01-15 00:55:19.000000', 'consum', 0.0223, 'lps'),
	(501657, 130, '2014-01-15 00:55:20.000000', 'consum', 0.0218, 'lps'),
	(501658, 130, '2014-01-15 00:55:21.000000', 'consum', 0.0226, 'lps'),
	(501659, 130, '2014-01-15 00:55:22.000000', 'consum', 0.0217, 'lps'),
	(501660, 130, '2014-01-15 00:55:23.000000', 'consum', 0.0212, 'lps'),
	(501661, 130, '2014-01-15 00:55:24.000000', 'consum', 0.0220, 'lps'),
	(501662, 130, '2014-01-15 00:55:25.000000', 'consum', 0.0221, 'lps'),
	(501663, 130, '2014-01-15 00:55:26.000000', 'consum', 0.0216, 'lps'),
	(501664, 130, '2014-01-15 00:55:27.000000', 'consum', 0.0225, 'lps'),
	(501665, 130, '2014-01-15 00:55:28.000000', 'consum', 0.0215, 'lps'),
	(501666, 130, '2014-01-15 00:55:29.000000', 'consum', 0.0226, 'lps'),
	(501667, 130, '2014-01-15 00:55:30.000000', 'consum', 0.0223, 'lps'),
	(501668, 130, '2014-01-15 00:55:31.000000', 'consum', 0.0213, 'lps'),
	(501669, 130, '2014-01-15 00:55:32.000000', 'consum', 0.0219, 'lps'),
	(501670, 130, '2014-01-15 00:55:33.000000', 'consum', 0.0211, 'lps'),
	(501671, 130, '2014-01-15 00:55:34.000000', 'consum', 0.0224, 'lps'),
	(501672, 130, '2014-01-15 00:55:35.000000', 'consum', 0.0211, 'lps'),
	(501673, 130, '2014-01-15 00:55:36.000000', 'consum', 0.0224, 'lps'),
	(501674, 130, '2014-01-15 00:55:37.000000', 'consum', 0.0211, 'lps'),
	(501675, 130, '2014-01-15 00:55:38.000000', 'consum', 0.0222, 'lps'),
	(501676, 130, '2014-01-15 00:55:39.000000', 'consum', 0.0217, 'lps'),
	(501677, 130, '2014-01-15 00:55:40.000000', 'consum', 0.0226, 'lps'),
	(501678, 130, '2014-01-15 00:55:41.000000', 'consum', 0.0220, 'lps'),
	(501679, 130, '2014-01-15 00:55:42.000000', 'consum', 0.0210, 'lps'),
	(501680, 130, '2014-01-15 00:55:43.000000', 'consum', 0.0217, 'lps'),
	(501681, 130, '2014-01-15 00:55:44.000000', 'consum', 0.0211, 'lps'),
	(501682, 130, '2014-01-15 00:55:45.000000', 'consum', 0.0213, 'lps'),
	(501683, 130, '2014-01-15 00:55:46.000000', 'consum', 0.0221, 'lps'),
	(501684, 130, '2014-01-15 00:55:47.000000', 'consum', 0.0224, 'lps'),
	(501685, 130, '2014-01-15 00:55:48.000000', 'consum', 0.0212, 'lps'),
	(501686, 130, '2014-01-15 00:55:49.000000', 'consum', 0.0212, 'lps'),
	(501687, 130, '2014-01-15 00:55:50.000000', 'consum', 0.0213, 'lps'),
	(501688, 130, '2014-01-15 00:55:51.000000', 'consum', 0.0221, 'lps'),
	(501689, 130, '2014-01-15 00:55:52.000000', 'consum', 0.0222, 'lps'),
	(501690, 130, '2014-01-15 00:55:53.000000', 'consum', 0.0222, 'lps'),
	(501691, 130, '2014-01-15 00:55:54.000000', 'consum', 0.0217, 'lps'),
	(501692, 130, '2014-01-15 00:55:55.000000', 'consum', 0.0210, 'lps'),
	(501693, 130, '2014-01-15 00:55:56.000000', 'consum', 0.0224, 'lps'),
	(501694, 130, '2014-01-15 00:55:57.000000', 'consum', 0.0214, 'lps'),
	(501695, 130, '2014-01-15 00:55:58.000000', 'consum', 0.0219, 'lps'),
	(501696, 130, '2014-01-15 00:55:59.000000', 'consum', 0.0211, 'lps'),
	(501697, 130, '2014-01-15 00:56:00.000000', 'consum', 0.0224, 'lps'),
	(501698, 130, '2014-01-15 00:56:01.000000', 'consum', 0.0225, 'lps'),
	(501699, 130, '2014-01-15 00:56:02.000000', 'consum', 0.0211, 'lps'),
	(501700, 130, '2014-01-15 00:56:03.000000', 'consum', 0.0219, 'lps'),
	(501701, 130, '2014-01-15 00:56:04.000000', 'consum', 0.0221, 'lps'),
	(501702, 130, '2014-01-15 00:56:05.000000', 'consum', 0.0222, 'lps'),
	(501703, 130, '2014-01-15 00:56:06.000000', 'consum', 0.0217, 'lps'),
	(501704, 130, '2014-01-15 00:56:07.000000', 'consum', 0.0213, 'lps'),
	(501705, 130, '2014-01-15 00:56:08.000000', 'consum', 0.0221, 'lps'),
	(501706, 130, '2014-01-15 00:56:09.000000', 'consum', 0.0220, 'lps'),
	(501707, 130, '2014-01-15 00:56:10.000000', 'consum', 0.0213, 'lps'),
	(501708, 130, '2014-01-15 00:56:11.000000', 'consum', 0.0211, 'lps'),
	(501709, 130, '2014-01-15 00:56:12.000000', 'consum', 0.0224, 'lps'),
	(501710, 130, '2014-01-15 00:56:13.000000', 'consum', 0.0226, 'lps'),
	(501711, 130, '2014-01-15 00:56:14.000000', 'consum', 0.0214, 'lps'),
	(501712, 130, '2014-01-15 00:56:15.000000', 'consum', 0.0219, 'lps'),
	(501713, 130, '2014-01-15 00:56:16.000000', 'consum', 0.0224, 'lps'),
	(501714, 130, '2014-01-15 00:56:17.000000', 'consum', 0.0221, 'lps'),
	(501715, 130, '2014-01-15 00:56:18.000000', 'consum', 0.0222, 'lps'),
	(501716, 130, '2014-01-15 00:56:19.000000', 'consum', 0.0222, 'lps'),
	(501717, 130, '2014-01-15 00:56:20.000000', 'consum', 0.0216, 'lps'),
	(501718, 130, '2014-01-15 00:56:21.000000', 'consum', 0.0223, 'lps'),
	(501719, 130, '2014-01-15 00:56:22.000000', 'consum', 0.0222, 'lps'),
	(501720, 130, '2014-01-15 00:56:23.000000', 'consum', 0.0217, 'lps'),
	(501721, 130, '2014-01-15 00:56:24.000000', 'consum', 0.0224, 'lps'),
	(501722, 130, '2014-01-15 00:56:25.000000', 'consum', 0.0226, 'lps'),
	(501723, 130, '2014-01-15 00:56:26.000000', 'consum', 0.0214, 'lps'),
	(501724, 130, '2014-01-15 00:56:27.000000', 'consum', 0.0215, 'lps'),
	(501725, 130, '2014-01-15 00:56:28.000000', 'consum', 0.0225, 'lps'),
	(501726, 130, '2014-01-15 00:56:29.000000', 'consum', 0.0221, 'lps'),
	(501727, 130, '2014-01-15 00:56:30.000000', 'consum', 0.0220, 'lps'),
	(501728, 130, '2014-01-15 00:56:31.000000', 'consum', 0.0211, 'lps'),
	(501729, 130, '2014-01-15 00:56:32.000000', 'consum', 0.0218, 'lps'),
	(501730, 130, '2014-01-15 00:56:33.000000', 'consum', 0.0213, 'lps'),
	(501731, 130, '2014-01-15 00:56:34.000000', 'consum', 0.0218, 'lps'),
	(501732, 130, '2014-01-15 00:56:35.000000', 'consum', 0.0224, 'lps'),
	(501733, 130, '2014-01-15 00:56:36.000000', 'consum', 0.0223, 'lps'),
	(501734, 130, '2014-01-15 00:56:37.000000', 'consum', 0.0215, 'lps'),
	(501735, 130, '2014-01-15 00:56:38.000000', 'consum', 0.0214, 'lps'),
	(501736, 130, '2014-01-15 00:56:39.000000', 'consum', 0.0214, 'lps'),
	(501737, 130, '2014-01-15 00:56:40.000000', 'consum', 0.0221, 'lps'),
	(501738, 130, '2014-01-15 00:56:41.000000', 'consum', 0.0218, 'lps'),
	(501739, 130, '2014-01-15 00:56:42.000000', 'consum', 0.0217, 'lps'),
	(501740, 130, '2014-01-15 00:56:43.000000', 'consum', 0.0223, 'lps'),
	(501741, 130, '2014-01-15 00:56:44.000000', 'consum', 0.0221, 'lps'),
	(501742, 130, '2014-01-15 00:56:45.000000', 'consum', 0.0225, 'lps'),
	(501743, 130, '2014-01-15 00:56:46.000000', 'consum', 0.0217, 'lps'),
	(501744, 130, '2014-01-15 00:56:47.000000', 'consum', 0.0219, 'lps'),
	(501745, 130, '2014-01-15 00:56:48.000000', 'consum', 0.0217, 'lps'),
	(501746, 130, '2014-01-15 00:56:49.000000', 'consum', 0.0219, 'lps'),
	(501747, 130, '2014-01-15 00:56:50.000000', 'consum', 0.0216, 'lps'),
	(501748, 130, '2014-01-15 00:56:51.000000', 'consum', 0.0214, 'lps'),
	(501749, 130, '2014-01-15 00:56:52.000000', 'consum', 0.0211, 'lps'),
	(501750, 130, '2014-01-15 00:56:53.000000', 'consum', 0.0222, 'lps'),
	(501751, 130, '2014-01-15 00:56:54.000000', 'consum', 0.0216, 'lps'),
	(501752, 130, '2014-01-15 00:56:55.000000', 'consum', 0.0221, 'lps'),
	(501753, 130, '2014-01-15 00:56:56.000000', 'consum', 0.0216, 'lps'),
	(501754, 130, '2014-01-15 00:56:57.000000', 'consum', 0.0223, 'lps'),
	(501755, 130, '2014-01-15 00:56:58.000000', 'consum', 0.0223, 'lps'),
	(501756, 130, '2014-01-15 00:56:59.000000', 'consum', 0.0221, 'lps'),
	(501757, 130, '2014-01-15 00:57:00.000000', 'consum', 0.0210, 'lps'),
	(501758, 130, '2014-01-15 00:57:01.000000', 'consum', 0.0212, 'lps'),
	(501759, 130, '2014-01-15 00:57:02.000000', 'consum', 0.0220, 'lps'),
	(501760, 130, '2014-01-15 00:57:03.000000', 'consum', 0.0221, 'lps'),
	(501761, 130, '2014-01-15 00:57:04.000000', 'consum', 0.0220, 'lps'),
	(501762, 130, '2014-01-15 00:57:05.000000', 'consum', 0.0225, 'lps'),
	(501763, 130, '2014-01-15 00:57:06.000000', 'consum', 0.0224, 'lps'),
	(501764, 130, '2014-01-15 00:57:07.000000', 'consum', 0.0219, 'lps'),
	(501765, 130, '2014-01-15 00:57:08.000000', 'consum', 0.0210, 'lps'),
	(501766, 130, '2014-01-15 00:57:09.000000', 'consum', 0.0220, 'lps'),
	(501767, 130, '2014-01-15 00:57:10.000000', 'consum', 0.0225, 'lps'),
	(501768, 130, '2014-01-15 00:57:11.000000', 'consum', 0.0222, 'lps'),
	(501769, 130, '2014-01-15 00:57:12.000000', 'consum', 0.0226, 'lps'),
	(501770, 130, '2014-01-15 00:57:13.000000', 'consum', 0.0222, 'lps'),
	(501771, 130, '2014-01-15 00:57:14.000000', 'consum', 0.0220, 'lps'),
	(501772, 130, '2014-01-15 00:57:15.000000', 'consum', 0.0226, 'lps'),
	(501773, 130, '2014-01-15 00:57:16.000000', 'consum', 0.0225, 'lps'),
	(501774, 130, '2014-01-15 00:57:17.000000', 'consum', 0.0223, 'lps'),
	(501775, 130, '2014-01-15 00:57:18.000000', 'consum', 0.0211, 'lps'),
	(501776, 130, '2014-01-15 00:57:19.000000', 'consum', 0.0226, 'lps'),
	(501777, 130, '2014-01-15 00:57:20.000000', 'consum', 0.0223, 'lps'),
	(501778, 130, '2014-01-15 00:57:21.000000', 'consum', 0.0210, 'lps'),
	(501779, 130, '2014-01-15 00:57:22.000000', 'consum', 0.0221, 'lps'),
	(501780, 130, '2014-01-15 00:57:23.000000', 'consum', 0.0213, 'lps'),
	(501781, 130, '2014-01-15 00:57:24.000000', 'consum', 0.0213, 'lps'),
	(501782, 130, '2014-01-15 00:57:25.000000', 'consum', 0.0213, 'lps'),
	(501783, 130, '2014-01-15 00:57:26.000000', 'consum', 0.0218, 'lps'),
	(501784, 130, '2014-01-15 00:57:27.000000', 'consum', 0.0226, 'lps'),
	(501785, 130, '2014-01-15 00:57:28.000000', 'consum', 0.0213, 'lps'),
	(501786, 130, '2014-01-15 00:57:29.000000', 'consum', 0.0213, 'lps'),
	(501787, 130, '2014-01-15 00:57:30.000000', 'consum', 0.0216, 'lps'),
	(501788, 130, '2014-01-15 00:57:31.000000', 'consum', 0.0213, 'lps'),
	(501789, 130, '2014-01-15 00:57:32.000000', 'consum', 0.0210, 'lps'),
	(501790, 130, '2014-01-15 00:57:33.000000', 'consum', 0.0219, 'lps'),
	(501791, 130, '2014-01-15 00:57:34.000000', 'consum', 0.0220, 'lps'),
	(501792, 130, '2014-01-15 00:57:35.000000', 'consum', 0.0219, 'lps'),
	(501793, 130, '2014-01-15 00:57:36.000000', 'consum', 0.0223, 'lps'),
	(501794, 130, '2014-01-15 00:57:37.000000', 'consum', 0.0215, 'lps'),
	(501795, 130, '2014-01-15 00:57:38.000000', 'consum', 0.0214, 'lps'),
	(501796, 130, '2014-01-15 00:57:39.000000', 'consum', 0.0217, 'lps'),
	(501797, 130, '2014-01-15 00:57:40.000000', 'consum', 0.0214, 'lps'),
	(501798, 130, '2014-01-15 00:57:41.000000', 'consum', 0.0212, 'lps'),
	(501799, 130, '2014-01-15 00:57:42.000000', 'consum', 0.0223, 'lps'),
	(501800, 130, '2014-01-15 00:57:43.000000', 'consum', 0.0221, 'lps'),
	(501801, 130, '2014-01-15 00:57:44.000000', 'consum', 0.0226, 'lps'),
	(501802, 130, '2014-01-15 00:57:45.000000', 'consum', 0.0221, 'lps'),
	(501803, 130, '2014-01-15 00:57:46.000000', 'consum', 0.0219, 'lps'),
	(501804, 130, '2014-01-15 00:57:47.000000', 'consum', 0.0225, 'lps'),
	(501805, 130, '2014-01-15 00:57:48.000000', 'consum', 0.0221, 'lps'),
	(501806, 130, '2014-01-15 00:57:49.000000', 'consum', 0.0221, 'lps'),
	(501807, 130, '2014-01-15 00:57:50.000000', 'consum', 0.0218, 'lps'),
	(501808, 130, '2014-01-15 00:57:51.000000', 'consum', 0.0215, 'lps'),
	(501809, 130, '2014-01-15 00:57:52.000000', 'consum', 0.0213, 'lps'),
	(501810, 130, '2014-01-15 00:57:53.000000', 'consum', 0.0212, 'lps'),
	(501811, 130, '2014-01-15 00:57:54.000000', 'consum', 0.0226, 'lps'),
	(501812, 130, '2014-01-15 00:57:55.000000', 'consum', 0.0218, 'lps'),
	(501813, 130, '2014-01-15 00:57:56.000000', 'consum', 0.0217, 'lps'),
	(501814, 130, '2014-01-15 00:57:57.000000', 'consum', 0.0222, 'lps'),
	(501815, 130, '2014-01-15 00:57:58.000000', 'consum', 0.0217, 'lps'),
	(501816, 130, '2014-01-15 00:57:59.000000', 'consum', 0.0210, 'lps'),
	(501817, 130, '2014-01-15 00:58:00.000000', 'consum', 0.0222, 'lps'),
	(501818, 130, '2014-01-15 00:58:01.000000', 'consum', 0.0218, 'lps'),
	(501819, 130, '2014-01-15 00:58:02.000000', 'consum', 0.0218, 'lps'),
	(501820, 130, '2014-01-15 00:58:03.000000', 'consum', 0.0224, 'lps'),
	(501821, 130, '2014-01-15 00:58:04.000000', 'consum', 0.0223, 'lps'),
	(501822, 130, '2014-01-15 00:58:05.000000', 'consum', 0.0218, 'lps'),
	(501823, 130, '2014-01-15 00:58:06.000000', 'consum', 0.0210, 'lps'),
	(501824, 130, '2014-01-15 00:58:07.000000', 'consum', 0.0222, 'lps'),
	(501825, 130, '2014-01-15 00:58:08.000000', 'consum', 0.0220, 'lps'),
	(501826, 130, '2014-01-15 00:58:09.000000', 'consum', 0.0226, 'lps'),
	(501827, 130, '2014-01-15 00:58:10.000000', 'consum', 0.0223, 'lps'),
	(501828, 130, '2014-01-15 00:58:11.000000', 'consum', 0.0214, 'lps'),
	(501829, 130, '2014-01-15 00:58:12.000000', 'consum', 0.0224, 'lps'),
	(501830, 130, '2014-01-15 00:58:13.000000', 'consum', 0.0216, 'lps'),
	(501831, 130, '2014-01-15 00:58:14.000000', 'consum', 0.0216, 'lps'),
	(501832, 130, '2014-01-15 00:58:15.000000', 'consum', 0.0224, 'lps'),
	(501833, 130, '2014-01-15 00:58:16.000000', 'consum', 0.0226, 'lps'),
	(501834, 130, '2014-01-15 00:58:17.000000', 'consum', 0.0214, 'lps'),
	(501835, 130, '2014-01-15 00:58:18.000000', 'consum', 0.0217, 'lps'),
	(501836, 130, '2014-01-15 00:58:19.000000', 'consum', 0.0218, 'lps'),
	(501837, 130, '2014-01-15 00:58:20.000000', 'consum', 0.0211, 'lps'),
	(501838, 130, '2014-01-15 00:58:21.000000', 'consum', 0.0211, 'lps'),
	(501839, 130, '2014-01-15 00:58:22.000000', 'consum', 0.0212, 'lps'),
	(501840, 130, '2014-01-15 00:58:23.000000', 'consum', 0.0217, 'lps'),
	(501841, 130, '2014-01-15 00:58:24.000000', 'consum', 0.0221, 'lps'),
	(501842, 130, '2014-01-15 00:58:25.000000', 'consum', 0.0211, 'lps'),
	(501843, 130, '2014-01-15 00:58:26.000000', 'consum', 0.0218, 'lps'),
	(501844, 130, '2014-01-15 00:58:27.000000', 'consum', 0.0213, 'lps'),
	(501845, 130, '2014-01-15 00:58:28.000000', 'consum', 0.0219, 'lps'),
	(501846, 130, '2014-01-15 00:58:29.000000', 'consum', 0.0213, 'lps'),
	(501847, 130, '2014-01-15 00:58:30.000000', 'consum', 0.0214, 'lps'),
	(501848, 130, '2014-01-15 00:58:31.000000', 'consum', 0.0223, 'lps'),
	(501849, 130, '2014-01-15 00:58:32.000000', 'consum', 0.0212, 'lps'),
	(501850, 130, '2014-01-15 00:58:33.000000', 'consum', 0.0214, 'lps'),
	(501851, 130, '2014-01-15 00:58:34.000000', 'consum', 0.0226, 'lps'),
	(501852, 130, '2014-01-15 00:58:35.000000', 'consum', 0.0211, 'lps'),
	(501853, 130, '2014-01-15 00:58:36.000000', 'consum', 0.0219, 'lps'),
	(501854, 130, '2014-01-15 00:58:37.000000', 'consum', 0.0217, 'lps'),
	(501855, 130, '2014-01-15 00:58:38.000000', 'consum', 0.0221, 'lps'),
	(501856, 130, '2014-01-15 00:58:39.000000', 'consum', 0.0226, 'lps'),
	(501857, 130, '2014-01-15 00:58:40.000000', 'consum', 0.0224, 'lps'),
	(501858, 130, '2014-01-15 00:58:41.000000', 'consum', 0.0217, 'lps'),
	(501859, 130, '2014-01-15 00:58:42.000000', 'consum', 0.0218, 'lps'),
	(501860, 130, '2014-01-15 00:58:43.000000', 'consum', 0.0213, 'lps'),
	(501861, 130, '2014-01-15 00:58:44.000000', 'consum', 0.0218, 'lps'),
	(501862, 130, '2014-01-15 00:58:45.000000', 'consum', 0.0226, 'lps'),
	(501863, 130, '2014-01-15 00:58:46.000000', 'consum', 0.0214, 'lps'),
	(501864, 130, '2014-01-15 00:58:47.000000', 'consum', 0.0216, 'lps'),
	(501865, 130, '2014-01-15 00:58:48.000000', 'consum', 0.0213, 'lps'),
	(501866, 130, '2014-01-15 00:58:49.000000', 'consum', 0.0223, 'lps'),
	(501867, 130, '2014-01-15 00:58:50.000000', 'consum', 0.0215, 'lps'),
	(501868, 130, '2014-01-15 00:58:51.000000', 'consum', 0.0213, 'lps'),
	(501869, 130, '2014-01-15 00:58:52.000000', 'consum', 0.0210, 'lps'),
	(501870, 130, '2014-01-15 00:58:53.000000', 'consum', 0.0217, 'lps'),
	(501871, 130, '2014-01-15 00:58:54.000000', 'consum', 0.0215, 'lps'),
	(501872, 130, '2014-01-15 00:58:55.000000', 'consum', 0.0212, 'lps'),
	(501873, 130, '2014-01-15 00:58:56.000000', 'consum', 0.0224, 'lps'),
	(501874, 130, '2014-01-15 00:58:57.000000', 'consum', 0.0222, 'lps'),
	(501875, 130, '2014-01-15 00:58:58.000000', 'consum', 0.0211, 'lps'),
	(501876, 130, '2014-01-15 00:58:59.000000', 'consum', 0.0216, 'lps'),
	(501877, 130, '2014-01-15 00:59:00.000000', 'consum', 0.0221, 'lps'),
	(501878, 130, '2014-01-15 00:59:01.000000', 'consum', 0.0213, 'lps'),
	(501879, 130, '2014-01-15 00:59:02.000000', 'consum', 0.0210, 'lps'),
	(501880, 130, '2014-01-15 00:59:03.000000', 'consum', 0.0218, 'lps'),
	(501881, 130, '2014-01-15 00:59:04.000000', 'consum', 0.0218, 'lps'),
	(501882, 130, '2014-01-15 00:59:05.000000', 'consum', 0.0223, 'lps'),
	(501883, 130, '2014-01-15 00:59:06.000000', 'consum', 0.0221, 'lps'),
	(501884, 130, '2014-01-15 00:59:07.000000', 'consum', 0.0224, 'lps'),
	(501885, 130, '2014-01-15 00:59:08.000000', 'consum', 0.0216, 'lps'),
	(501886, 130, '2014-01-15 00:59:09.000000', 'consum', 0.0213, 'lps'),
	(501887, 130, '2014-01-15 00:59:10.000000', 'consum', 0.0224, 'lps'),
	(501888, 130, '2014-01-15 00:59:11.000000', 'consum', 0.0221, 'lps'),
	(501889, 130, '2014-01-15 00:59:12.000000', 'consum', 0.0225, 'lps'),
	(501890, 130, '2014-01-15 00:59:13.000000', 'consum', 0.0216, 'lps'),
	(501891, 130, '2014-01-15 00:59:14.000000', 'consum', 0.0216, 'lps'),
	(501892, 130, '2014-01-15 00:59:15.000000', 'consum', 0.0220, 'lps'),
	(501893, 130, '2014-01-15 00:59:16.000000', 'consum', 0.0224, 'lps'),
	(501894, 130, '2014-01-15 00:59:17.000000', 'consum', 0.0218, 'lps'),
	(501895, 130, '2014-01-15 00:59:18.000000', 'consum', 0.0211, 'lps'),
	(501896, 130, '2014-01-15 00:59:19.000000', 'consum', 0.0222, 'lps'),
	(501897, 130, '2014-01-15 00:59:20.000000', 'consum', 0.0216, 'lps'),
	(501898, 130, '2014-01-15 00:59:21.000000', 'consum', 0.0223, 'lps'),
	(501899, 130, '2014-01-15 00:59:22.000000', 'consum', 0.0224, 'lps'),
	(501900, 130, '2014-01-15 00:59:23.000000', 'consum', 0.0225, 'lps'),
	(501901, 130, '2014-01-15 00:59:24.000000', 'consum', 0.0210, 'lps'),
	(501902, 130, '2014-01-15 00:59:25.000000', 'consum', 0.0215, 'lps'),
	(501903, 130, '2014-01-15 00:59:26.000000', 'consum', 0.0220, 'lps'),
	(501904, 130, '2014-01-15 00:59:27.000000', 'consum', 0.0210, 'lps'),
	(501905, 130, '2014-01-15 00:59:28.000000', 'consum', 0.0213, 'lps'),
	(501906, 130, '2014-01-15 00:59:29.000000', 'consum', 0.0211, 'lps'),
	(501907, 130, '2014-01-15 00:59:30.000000', 'consum', 0.0225, 'lps'),
	(501908, 130, '2014-01-15 00:59:31.000000', 'consum', 0.0211, 'lps'),
	(501909, 130, '2014-01-15 00:59:32.000000', 'consum', 0.0224, 'lps'),
	(501910, 130, '2014-01-15 00:59:33.000000', 'consum', 0.0224, 'lps'),
	(501911, 130, '2014-01-15 00:59:34.000000', 'consum', 0.0224, 'lps'),
	(501912, 130, '2014-01-15 00:59:35.000000', 'consum', 0.0221, 'lps'),
	(501913, 130, '2014-01-15 00:59:36.000000', 'consum', 0.0225, 'lps'),
	(501914, 130, '2014-01-15 00:59:37.000000', 'consum', 0.0217, 'lps'),
	(501915, 130, '2014-01-15 00:59:38.000000', 'consum', 0.0219, 'lps'),
	(501916, 130, '2014-01-15 00:59:39.000000', 'consum', 0.0215, 'lps'),
	(501917, 130, '2014-01-15 00:59:40.000000', 'consum', 0.0211, 'lps'),
	(501918, 130, '2014-01-15 00:59:41.000000', 'consum', 0.0214, 'lps'),
	(501919, 130, '2014-01-15 00:59:42.000000', 'consum', 0.0214, 'lps'),
	(501920, 130, '2014-01-15 00:59:43.000000', 'consum', 0.0218, 'lps'),
	(501921, 130, '2014-01-15 00:59:44.000000', 'consum', 0.0220, 'lps'),
	(501922, 130, '2014-01-15 00:59:45.000000', 'consum', 0.0219, 'lps'),
	(501923, 130, '2014-01-15 00:59:46.000000', 'consum', 0.0210, 'lps'),
	(501924, 130, '2014-01-15 00:59:47.000000', 'consum', 0.0218, 'lps'),
	(501925, 130, '2014-01-15 00:59:48.000000', 'consum', 0.0217, 'lps'),
	(501926, 130, '2014-01-15 00:59:49.000000', 'consum', 0.0222, 'lps'),
	(501927, 130, '2014-01-15 00:59:50.000000', 'consum', 0.0214, 'lps'),
	(501928, 130, '2014-01-15 00:59:51.000000', 'consum', 0.0212, 'lps'),
	(501929, 130, '2014-01-15 00:59:52.000000', 'consum', 0.0226, 'lps'),
	(501930, 130, '2014-01-15 00:59:53.000000', 'consum', 0.0217, 'lps'),
	(501931, 130, '2014-01-15 00:59:54.000000', 'consum', 0.0212, 'lps'),
	(501932, 130, '2014-01-15 00:59:55.000000', 'consum', 0.0218, 'lps'),
	(501933, 130, '2014-01-15 00:59:56.000000', 'consum', 0.0211, 'lps'),
	(501934, 130, '2014-01-15 00:59:57.000000', 'consum', 0.0224, 'lps'),
	(501935, 130, '2014-01-15 00:59:58.000000', 'consum', 0.0212, 'lps'),
	(501936, 130, '2014-01-15 00:59:59.000000', 'consum', 0.0212, 'lps'),
	(501937, 130, '2014-01-15 01:00:00.000000', 'consum', 0.0214, 'lps'),
	(501938, 130, '2014-01-15 01:00:01.000000', 'consum', 0.0226, 'lps'),
	(501939, 130, '2014-01-15 01:00:02.000000', 'consum', 0.0226, 'lps'),
	(501940, 130, '2014-01-15 01:00:03.000000', 'consum', 0.0225, 'lps'),
	(501941, 130, '2014-01-15 01:00:04.000000', 'consum', 0.0219, 'lps'),
	(501942, 130, '2014-01-15 01:00:05.000000', 'consum', 0.0212, 'lps'),
	(501943, 130, '2014-01-15 01:00:06.000000', 'consum', 0.0212, 'lps'),
	(501944, 130, '2014-01-15 01:00:07.000000', 'consum', 0.0213, 'lps'),
	(501945, 130, '2014-01-15 01:00:08.000000', 'consum', 0.0221, 'lps'),
	(501946, 130, '2014-01-15 01:00:09.000000', 'consum', 0.0221, 'lps'),
	(501947, 130, '2014-01-15 01:00:10.000000', 'consum', 0.0218, 'lps'),
	(501948, 130, '2014-01-15 01:00:11.000000', 'consum', 0.0215, 'lps'),
	(501949, 130, '2014-01-15 01:00:12.000000', 'consum', 0.0214, 'lps'),
	(501950, 130, '2014-01-15 01:00:13.000000', 'consum', 0.0213, 'lps'),
	(501951, 130, '2014-01-15 01:00:14.000000', 'consum', 0.0216, 'lps'),
	(501952, 130, '2014-01-15 01:00:15.000000', 'consum', 0.0213, 'lps'),
	(501953, 130, '2014-01-15 01:00:16.000000', 'consum', 0.0226, 'lps'),
	(501954, 130, '2014-01-15 01:00:17.000000', 'consum', 0.0214, 'lps'),
	(501955, 130, '2014-01-15 01:00:18.000000', 'consum', 0.0214, 'lps'),
	(501956, 130, '2014-01-15 01:00:19.000000', 'consum', 0.0219, 'lps'),
	(501957, 130, '2014-01-15 01:00:20.000000', 'consum', 0.0226, 'lps'),
	(501958, 130, '2014-01-15 01:00:21.000000', 'consum', 0.0214, 'lps'),
	(501959, 130, '2014-01-15 01:00:22.000000', 'consum', 0.0216, 'lps'),
	(501960, 130, '2014-01-15 01:00:23.000000', 'consum', 0.0210, 'lps'),
	(501961, 130, '2014-01-15 01:00:24.000000', 'consum', 0.0212, 'lps'),
	(501962, 130, '2014-01-15 01:00:25.000000', 'consum', 0.0218, 'lps'),
	(501963, 130, '2014-01-15 01:00:26.000000', 'consum', 0.0210, 'lps'),
	(501964, 130, '2014-01-15 01:00:27.000000', 'consum', 0.0220, 'lps'),
	(501965, 130, '2014-01-15 01:00:28.000000', 'consum', 0.0226, 'lps'),
	(501966, 130, '2014-01-15 01:00:29.000000', 'consum', 0.0226, 'lps'),
	(501967, 130, '2014-01-15 01:00:30.000000', 'consum', 0.0210, 'lps'),
	(501968, 130, '2014-01-15 01:00:31.000000', 'consum', 0.0213, 'lps'),
	(501969, 130, '2014-01-15 01:00:32.000000', 'consum', 0.0224, 'lps'),
	(501970, 130, '2014-01-15 01:00:33.000000', 'consum', 0.0223, 'lps'),
	(501971, 130, '2014-01-15 01:00:34.000000', 'consum', 0.0216, 'lps'),
	(501972, 130, '2014-01-15 01:00:35.000000', 'consum', 0.0217, 'lps'),
	(501973, 130, '2014-01-15 01:00:36.000000', 'consum', 0.0211, 'lps'),
	(501974, 130, '2014-01-15 01:00:37.000000', 'consum', 0.0211, 'lps'),
	(501975, 130, '2014-01-15 01:00:38.000000', 'consum', 0.0214, 'lps'),
	(501976, 130, '2014-01-15 01:00:39.000000', 'consum', 0.0226, 'lps'),
	(501977, 130, '2014-01-15 01:00:40.000000', 'consum', 0.0211, 'lps'),
	(501978, 130, '2014-01-15 01:00:41.000000', 'consum', 0.0219, 'lps'),
	(501979, 130, '2014-01-15 01:00:42.000000', 'consum', 0.0217, 'lps'),
	(501980, 130, '2014-01-15 01:00:43.000000', 'consum', 0.0219, 'lps'),
	(501981, 130, '2014-01-15 01:00:44.000000', 'consum', 0.0216, 'lps'),
	(501982, 130, '2014-01-15 01:00:45.000000', 'consum', 0.0213, 'lps'),
	(501983, 130, '2014-01-15 01:00:46.000000', 'consum', 0.0211, 'lps'),
	(501984, 130, '2014-01-15 01:00:47.000000', 'consum', 0.0220, 'lps'),
	(501985, 130, '2014-01-15 01:00:48.000000', 'consum', 0.0225, 'lps'),
	(501986, 130, '2014-01-15 01:00:49.000000', 'consum', 0.0223, 'lps'),
	(501987, 130, '2014-01-15 01:00:50.000000', 'consum', 0.0214, 'lps'),
	(501988, 130, '2014-01-15 01:00:51.000000', 'consum', 0.0224, 'lps'),
	(501989, 130, '2014-01-15 01:00:52.000000', 'consum', 0.0220, 'lps'),
	(501990, 130, '2014-01-15 01:00:53.000000', 'consum', 0.0215, 'lps'),
	(501991, 130, '2014-01-15 01:00:54.000000', 'consum', 0.0223, 'lps'),
	(501992, 130, '2014-01-15 01:00:55.000000', 'consum', 0.0212, 'lps'),
	(501993, 130, '2014-01-15 01:00:56.000000', 'consum', 0.0214, 'lps'),
	(501994, 130, '2014-01-15 01:00:57.000000', 'consum', 0.0210, 'lps'),
	(501995, 130, '2014-01-15 01:00:58.000000', 'consum', 0.0212, 'lps'),
	(501996, 130, '2014-01-15 01:00:59.000000', 'consum', 0.0222, 'lps'),
	(501997, 130, '2014-01-15 01:01:00.000000', 'consum', 0.0215, 'lps'),
	(501998, 130, '2014-01-15 01:01:01.000000', 'consum', 0.0214, 'lps'),
	(501999, 130, '2014-01-15 01:01:02.000000', 'consum', 0.0216, 'lps'),
	(502000, 130, '2014-01-15 01:01:03.000000', 'consum', 0.0210, 'lps'),
	(502001, 130, '2014-01-15 01:01:04.000000', 'consum', 0.0211, 'lps'),
	(502002, 130, '2014-01-15 01:01:05.000000', 'consum', 0.0216, 'lps'),
	(502003, 130, '2014-01-15 01:01:06.000000', 'consum', 0.0219, 'lps'),
	(502004, 130, '2014-01-15 01:01:07.000000', 'consum', 0.0220, 'lps'),
	(502005, 130, '2014-01-15 01:01:08.000000', 'consum', 0.0218, 'lps'),
	(502006, 130, '2014-01-15 01:01:09.000000', 'consum', 0.0222, 'lps'),
	(502007, 130, '2014-01-15 01:01:10.000000', 'consum', 0.0212, 'lps'),
	(502008, 130, '2014-01-15 01:01:11.000000', 'consum', 0.0217, 'lps'),
	(502009, 130, '2014-01-15 01:01:12.000000', 'consum', 0.0222, 'lps'),
	(502010, 130, '2014-01-15 01:01:13.000000', 'consum', 0.0216, 'lps'),
	(502011, 130, '2014-01-15 01:01:14.000000', 'consum', 0.0223, 'lps'),
	(502012, 130, '2014-01-15 01:01:15.000000', 'consum', 0.0221, 'lps'),
	(502013, 130, '2014-01-15 01:01:16.000000', 'consum', 0.0226, 'lps'),
	(502014, 130, '2014-01-15 01:01:17.000000', 'consum', 0.0224, 'lps'),
	(502015, 130, '2014-01-15 01:01:18.000000', 'consum', 0.0216, 'lps'),
	(502016, 130, '2014-01-15 01:01:19.000000', 'consum', 0.0216, 'lps'),
	(502017, 130, '2014-01-15 01:01:20.000000', 'consum', 0.0221, 'lps'),
	(502018, 130, '2014-01-15 01:01:21.000000', 'consum', 0.0215, 'lps'),
	(502019, 130, '2014-01-15 01:01:22.000000', 'consum', 0.0219, 'lps'),
	(502020, 130, '2014-01-15 01:01:23.000000', 'consum', 0.0223, 'lps'),
	(502021, 130, '2014-01-15 01:01:24.000000', 'consum', 0.0216, 'lps'),
	(502022, 130, '2014-01-15 01:01:25.000000', 'consum', 0.0219, 'lps'),
	(502023, 130, '2014-01-15 01:01:26.000000', 'consum', 0.0221, 'lps'),
	(502024, 130, '2014-01-15 01:01:27.000000', 'consum', 0.0219, 'lps'),
	(502025, 130, '2014-01-15 01:01:28.000000', 'consum', 0.0225, 'lps'),
	(502026, 130, '2014-01-15 01:01:29.000000', 'consum', 0.0225, 'lps'),
	(502027, 130, '2014-01-15 01:01:30.000000', 'consum', 0.0223, 'lps'),
	(502028, 130, '2014-01-15 01:01:31.000000', 'consum', 0.0214, 'lps'),
	(502029, 130, '2014-01-15 01:01:32.000000', 'consum', 0.0223, 'lps'),
	(502030, 130, '2014-01-15 01:01:33.000000', 'consum', 0.0215, 'lps'),
	(502031, 130, '2014-01-15 01:01:34.000000', 'consum', 0.0214, 'lps'),
	(502032, 130, '2014-01-15 01:01:35.000000', 'consum', 0.0214, 'lps'),
	(502033, 130, '2014-01-15 01:01:36.000000', 'consum', 0.0219, 'lps'),
	(502034, 130, '2014-01-15 01:01:37.000000', 'consum', 0.0225, 'lps'),
	(502035, 130, '2014-01-15 01:01:38.000000', 'consum', 0.0226, 'lps'),
	(502036, 130, '2014-01-15 01:01:39.000000', 'consum', 0.0212, 'lps'),
	(502037, 130, '2014-01-15 01:01:40.000000', 'consum', 0.0222, 'lps'),
	(502038, 130, '2014-01-15 01:01:41.000000', 'consum', 0.0215, 'lps'),
	(502039, 130, '2014-01-15 01:01:42.000000', 'consum', 0.0216, 'lps'),
	(502040, 130, '2014-01-15 01:01:43.000000', 'consum', 0.0210, 'lps'),
	(502041, 130, '2014-01-15 01:01:44.000000', 'consum', 0.0226, 'lps'),
	(502042, 130, '2014-01-15 01:01:45.000000', 'consum', 0.0221, 'lps'),
	(502043, 130, '2014-01-15 01:01:46.000000', 'consum', 0.0220, 'lps'),
	(502044, 130, '2014-01-15 01:01:47.000000', 'consum', 0.0211, 'lps'),
	(502045, 130, '2014-01-15 01:01:48.000000', 'consum', 0.0216, 'lps'),
	(502046, 130, '2014-01-15 01:01:49.000000', 'consum', 0.0224, 'lps'),
	(502047, 130, '2014-01-15 01:01:50.000000', 'consum', 0.0210, 'lps'),
	(502048, 130, '2014-01-15 01:01:51.000000', 'consum', 0.0219, 'lps'),
	(502049, 130, '2014-01-15 01:01:52.000000', 'consum', 0.0222, 'lps'),
	(502050, 130, '2014-01-15 01:01:53.000000', 'consum', 0.0212, 'lps'),
	(502051, 130, '2014-01-15 01:01:54.000000', 'consum', 0.0215, 'lps'),
	(502052, 130, '2014-01-15 01:01:55.000000', 'consum', 0.0212, 'lps'),
	(502053, 130, '2014-01-15 01:01:56.000000', 'consum', 0.0224, 'lps'),
	(502054, 130, '2014-01-15 01:01:57.000000', 'consum', 0.0224, 'lps'),
	(502055, 130, '2014-01-15 01:01:58.000000', 'consum', 0.0221, 'lps'),
	(502056, 130, '2014-01-15 01:01:59.000000', 'consum', 0.0222, 'lps'),
	(502057, 130, '2014-01-15 01:02:00.000000', 'consum', 0.0220, 'lps'),
	(502058, 130, '2014-01-15 01:02:01.000000', 'consum', 0.0210, 'lps'),
	(502059, 130, '2014-01-15 01:02:02.000000', 'consum', 0.0213, 'lps'),
	(502060, 130, '2014-01-15 01:02:03.000000', 'consum', 0.0224, 'lps'),
	(502061, 130, '2014-01-15 01:02:04.000000', 'consum', 0.0223, 'lps'),
	(502062, 130, '2014-01-15 01:02:05.000000', 'consum', 0.0215, 'lps'),
	(502063, 130, '2014-01-15 01:02:06.000000', 'consum', 0.0215, 'lps'),
	(502064, 130, '2014-01-15 01:02:07.000000', 'consum', 0.0220, 'lps'),
	(502065, 130, '2014-01-15 01:02:08.000000', 'consum', 0.0213, 'lps'),
	(502066, 130, '2014-01-15 01:02:09.000000', 'consum', 0.0211, 'lps'),
	(502067, 130, '2014-01-15 01:02:10.000000', 'consum', 0.0222, 'lps'),
	(502068, 130, '2014-01-15 01:02:11.000000', 'consum', 0.0217, 'lps'),
	(502069, 130, '2014-01-15 01:02:12.000000', 'consum', 0.0226, 'lps'),
	(502070, 130, '2014-01-15 01:02:13.000000', 'consum', 0.0220, 'lps'),
	(502071, 130, '2014-01-15 01:02:14.000000', 'consum', 0.0213, 'lps'),
	(502072, 130, '2014-01-15 01:02:15.000000', 'consum', 0.0211, 'lps'),
	(502073, 130, '2014-01-15 01:02:16.000000', 'consum', 0.0224, 'lps'),
	(502074, 130, '2014-01-15 01:02:17.000000', 'consum', 0.0226, 'lps'),
	(502075, 130, '2014-01-15 01:02:18.000000', 'consum', 0.0216, 'lps'),
	(502076, 130, '2014-01-15 01:02:19.000000', 'consum', 0.0225, 'lps'),
	(502077, 130, '2014-01-15 01:02:20.000000', 'consum', 0.0218, 'lps'),
	(502078, 130, '2014-01-15 01:02:21.000000', 'consum', 0.0220, 'lps'),
	(502079, 130, '2014-01-15 01:02:22.000000', 'consum', 0.0222, 'lps'),
	(502080, 130, '2014-01-15 01:02:23.000000', 'consum', 0.0221, 'lps'),
	(502081, 130, '2014-01-15 01:02:24.000000', 'consum', 0.0213, 'lps'),
	(502082, 130, '2014-01-15 01:02:25.000000', 'consum', 0.0225, 'lps'),
	(502083, 130, '2014-01-15 01:02:26.000000', 'consum', 0.0210, 'lps'),
	(502084, 130, '2014-01-15 01:02:27.000000', 'consum', 0.0215, 'lps'),
	(502085, 130, '2014-01-15 01:02:28.000000', 'consum', 0.0221, 'lps'),
	(502086, 130, '2014-01-15 01:02:29.000000', 'consum', 0.0215, 'lps'),
	(502087, 130, '2014-01-15 01:02:30.000000', 'consum', 0.0219, 'lps'),
	(502088, 130, '2014-01-15 01:02:31.000000', 'consum', 0.0223, 'lps'),
	(502089, 130, '2014-01-15 01:02:32.000000', 'consum', 0.0213, 'lps'),
	(502090, 130, '2014-01-15 01:02:33.000000', 'consum', 0.0224, 'lps'),
	(502091, 130, '2014-01-15 01:02:34.000000', 'consum', 0.0218, 'lps'),
	(502092, 130, '2014-01-15 01:02:35.000000', 'consum', 0.0225, 'lps'),
	(502093, 130, '2014-01-15 01:02:36.000000', 'consum', 0.0210, 'lps'),
	(502094, 130, '2014-01-15 01:02:37.000000', 'consum', 0.0217, 'lps'),
	(502095, 130, '2014-01-15 01:02:38.000000', 'consum', 0.0213, 'lps'),
	(502096, 130, '2014-01-15 01:02:39.000000', 'consum', 0.0220, 'lps'),
	(502097, 130, '2014-01-15 01:02:40.000000', 'consum', 0.0217, 'lps'),
	(502098, 130, '2014-01-15 01:02:41.000000', 'consum', 0.0216, 'lps'),
	(502099, 130, '2014-01-15 01:02:42.000000', 'consum', 0.0219, 'lps'),
	(502100, 130, '2014-01-15 01:02:43.000000', 'consum', 0.0220, 'lps'),
	(502101, 130, '2014-01-15 01:02:44.000000', 'consum', 0.0215, 'lps'),
	(502102, 130, '2014-01-15 01:02:45.000000', 'consum', 0.0225, 'lps'),
	(502103, 130, '2014-01-15 01:02:46.000000', 'consum', 0.0217, 'lps'),
	(502104, 130, '2014-01-15 01:02:47.000000', 'consum', 0.0218, 'lps'),
	(502105, 130, '2014-01-15 01:02:48.000000', 'consum', 0.0213, 'lps'),
	(502106, 130, '2014-01-15 01:02:49.000000', 'consum', 0.0217, 'lps'),
	(502107, 130, '2014-01-15 01:02:50.000000', 'consum', 0.0221, 'lps'),
	(502108, 130, '2014-01-15 01:02:51.000000', 'consum', 0.0212, 'lps'),
	(502109, 130, '2014-01-15 01:02:52.000000', 'consum', 0.0219, 'lps'),
	(502110, 130, '2014-01-15 01:02:53.000000', 'consum', 0.0216, 'lps'),
	(502111, 130, '2014-01-15 01:02:54.000000', 'consum', 0.0214, 'lps'),
	(502112, 130, '2014-01-15 01:02:55.000000', 'consum', 0.0212, 'lps'),
	(502113, 130, '2014-01-15 01:02:56.000000', 'consum', 0.0211, 'lps'),
	(502114, 130, '2014-01-15 01:02:57.000000', 'consum', 0.0224, 'lps'),
	(502115, 130, '2014-01-15 01:02:58.000000', 'consum', 0.0225, 'lps'),
	(502116, 130, '2014-01-15 01:02:59.000000', 'consum', 0.0211, 'lps'),
	(502117, 130, '2014-01-15 01:03:00.000000', 'consum', 0.0222, 'lps'),
	(502118, 130, '2014-01-15 01:03:01.000000', 'consum', 0.0217, 'lps'),
	(502119, 130, '2014-01-15 01:03:02.000000', 'consum', 0.0225, 'lps'),
	(502120, 130, '2014-01-15 01:03:03.000000', 'consum', 0.0213, 'lps'),
	(502121, 130, '2014-01-15 01:03:04.000000', 'consum', 0.0213, 'lps'),
	(502122, 130, '2014-01-15 01:03:05.000000', 'consum', 0.0220, 'lps'),
	(502123, 130, '2014-01-15 01:03:06.000000', 'consum', 0.0216, 'lps'),
	(502124, 130, '2014-01-15 01:03:07.000000', 'consum', 0.0212, 'lps'),
	(502125, 130, '2014-01-15 01:03:08.000000', 'consum', 0.0218, 'lps'),
	(502126, 130, '2014-01-15 01:03:09.000000', 'consum', 0.0212, 'lps'),
	(502127, 130, '2014-01-15 01:03:10.000000', 'consum', 0.0214, 'lps'),
	(502128, 130, '2014-01-15 01:03:11.000000', 'consum', 0.0222, 'lps'),
	(502129, 130, '2014-01-15 01:03:12.000000', 'consum', 0.0224, 'lps'),
	(502130, 130, '2014-01-15 01:03:13.000000', 'consum', 0.0210, 'lps'),
	(502131, 130, '2014-01-15 01:03:14.000000', 'consum', 0.0220, 'lps'),
	(502132, 130, '2014-01-15 01:03:15.000000', 'consum', 0.0226, 'lps'),
	(502133, 130, '2014-01-15 01:03:16.000000', 'consum', 0.0211, 'lps'),
	(502134, 130, '2014-01-15 01:03:17.000000', 'consum', 0.0218, 'lps'),
	(502135, 130, '2014-01-15 01:03:18.000000', 'consum', 0.0212, 'lps'),
	(502136, 130, '2014-01-15 01:03:19.000000', 'consum', 0.0214, 'lps'),
	(502137, 130, '2014-01-15 01:03:20.000000', 'consum', 0.0223, 'lps'),
	(502138, 130, '2014-01-15 01:03:21.000000', 'consum', 0.0216, 'lps'),
	(502139, 130, '2014-01-15 01:03:22.000000', 'consum', 0.0215, 'lps'),
	(502140, 130, '2014-01-15 01:03:23.000000', 'consum', 0.0220, 'lps'),
	(502141, 130, '2014-01-15 01:03:24.000000', 'consum', 0.0226, 'lps'),
	(502142, 130, '2014-01-15 01:03:25.000000', 'consum', 0.0211, 'lps'),
	(502143, 130, '2014-01-15 01:03:26.000000', 'consum', 0.0217, 'lps'),
	(502144, 130, '2014-01-15 01:03:27.000000', 'consum', 0.0226, 'lps'),
	(502145, 130, '2014-01-15 01:03:28.000000', 'consum', 0.0220, 'lps'),
	(502146, 130, '2014-01-15 01:03:29.000000', 'consum', 0.0212, 'lps'),
	(502147, 130, '2014-01-15 01:03:30.000000', 'consum', 0.0226, 'lps'),
	(502148, 130, '2014-01-15 01:03:31.000000', 'consum', 0.0214, 'lps'),
	(502149, 130, '2014-01-15 01:03:32.000000', 'consum', 0.0218, 'lps'),
	(502150, 130, '2014-01-15 01:03:33.000000', 'consum', 0.0220, 'lps'),
	(502151, 130, '2014-01-15 01:03:34.000000', 'consum', 0.0218, 'lps'),
	(502152, 130, '2014-01-15 01:03:35.000000', 'consum', 0.0224, 'lps'),
	(502153, 130, '2014-01-15 01:03:36.000000', 'consum', 0.0220, 'lps'),
	(502154, 130, '2014-01-15 01:03:37.000000', 'consum', 0.0220, 'lps'),
	(502155, 130, '2014-01-15 01:03:38.000000', 'consum', 0.0214, 'lps'),
	(502156, 130, '2014-01-15 01:03:39.000000', 'consum', 0.0217, 'lps'),
	(502157, 130, '2014-01-15 01:03:40.000000', 'consum', 0.0216, 'lps'),
	(502158, 130, '2014-01-15 01:03:41.000000', 'consum', 0.0218, 'lps'),
	(502159, 130, '2014-01-15 01:03:42.000000', 'consum', 0.0216, 'lps'),
	(502160, 130, '2014-01-15 01:03:43.000000', 'consum', 0.0218, 'lps'),
	(502161, 130, '2014-01-15 01:03:44.000000', 'consum', 0.0213, 'lps'),
	(502162, 130, '2014-01-15 01:03:45.000000', 'consum', 0.0222, 'lps'),
	(502163, 130, '2014-01-15 01:03:46.000000', 'consum', 0.0225, 'lps'),
	(502164, 130, '2014-01-15 01:03:47.000000', 'consum', 0.0214, 'lps'),
	(502165, 130, '2014-01-15 01:03:48.000000', 'consum', 0.0222, 'lps'),
	(502166, 130, '2014-01-15 01:03:49.000000', 'consum', 0.0222, 'lps'),
	(502167, 130, '2014-01-15 01:03:50.000000', 'consum', 0.0221, 'lps'),
	(502168, 130, '2014-01-15 01:03:51.000000', 'consum', 0.0226, 'lps'),
	(502169, 130, '2014-01-15 01:03:52.000000', 'consum', 0.0210, 'lps'),
	(502170, 130, '2014-01-15 01:03:53.000000', 'consum', 0.0211, 'lps'),
	(502171, 130, '2014-01-15 01:03:54.000000', 'consum', 0.0215, 'lps'),
	(502172, 130, '2014-01-15 01:03:55.000000', 'consum', 0.0217, 'lps'),
	(502173, 130, '2014-01-15 01:03:56.000000', 'consum', 0.0213, 'lps'),
	(502174, 130, '2014-01-15 01:03:57.000000', 'consum', 0.0222, 'lps'),
	(502175, 130, '2014-01-15 01:03:58.000000', 'consum', 0.0211, 'lps'),
	(502176, 130, '2014-01-15 01:03:59.000000', 'consum', 0.0212, 'lps'),
	(502177, 130, '2014-01-15 01:04:00.000000', 'consum', 0.0219, 'lps'),
	(502178, 130, '2014-01-15 01:04:01.000000', 'consum', 0.0217, 'lps'),
	(502179, 130, '2014-01-15 01:04:02.000000', 'consum', 0.0215, 'lps'),
	(502180, 130, '2014-01-15 01:04:03.000000', 'consum', 0.0217, 'lps'),
	(502181, 130, '2014-01-15 01:04:04.000000', 'consum', 0.0211, 'lps'),
	(502182, 130, '2014-01-15 01:04:05.000000', 'consum', 0.0211, 'lps'),
	(502183, 130, '2014-01-15 01:04:06.000000', 'consum', 0.0215, 'lps'),
	(502184, 130, '2014-01-15 01:04:07.000000', 'consum', 0.0214, 'lps'),
	(502185, 130, '2014-01-15 01:04:08.000000', 'consum', 0.0217, 'lps'),
	(502186, 130, '2014-01-15 01:04:09.000000', 'consum', 0.0216, 'lps'),
	(502187, 130, '2014-01-15 01:04:10.000000', 'consum', 0.0218, 'lps'),
	(502188, 130, '2014-01-15 01:04:11.000000', 'consum', 0.0218, 'lps'),
	(502189, 130, '2014-01-15 01:04:12.000000', 'consum', 0.0226, 'lps'),
	(502190, 130, '2014-01-15 01:04:13.000000', 'consum', 0.0217, 'lps'),
	(502191, 130, '2014-01-15 01:04:14.000000', 'consum', 0.0212, 'lps'),
	(502192, 130, '2014-01-15 01:04:15.000000', 'consum', 0.0218, 'lps'),
	(502193, 130, '2014-01-15 01:04:16.000000', 'consum', 0.0211, 'lps'),
	(502194, 130, '2014-01-15 01:04:17.000000', 'consum', 0.0225, 'lps'),
	(502195, 130, '2014-01-15 01:04:18.000000', 'consum', 0.0213, 'lps'),
	(502196, 130, '2014-01-15 01:04:19.000000', 'consum', 0.0215, 'lps'),
	(502197, 130, '2014-01-15 01:04:20.000000', 'consum', 0.0211, 'lps'),
	(502198, 130, '2014-01-15 01:04:21.000000', 'consum', 0.0216, 'lps'),
	(502199, 130, '2014-01-15 01:04:22.000000', 'consum', 0.0222, 'lps'),
	(502200, 130, '2014-01-15 01:04:23.000000', 'consum', 0.0218, 'lps'),
	(502201, 130, '2014-01-15 01:04:24.000000', 'consum', 0.0213, 'lps'),
	(502202, 130, '2014-01-15 01:04:25.000000', 'consum', 0.0221, 'lps'),
	(502203, 130, '2014-01-15 01:04:26.000000', 'consum', 0.0222, 'lps'),
	(502204, 130, '2014-01-15 01:04:27.000000', 'consum', 0.0221, 'lps'),
	(502205, 130, '2014-01-15 01:04:28.000000', 'consum', 0.0211, 'lps'),
	(502206, 130, '2014-01-15 01:04:29.000000', 'consum', 0.0216, 'lps'),
	(502207, 130, '2014-01-15 01:04:30.000000', 'consum', 0.0219, 'lps'),
	(502208, 130, '2014-01-15 01:04:31.000000', 'consum', 0.0223, 'lps'),
	(502209, 130, '2014-01-15 01:04:32.000000', 'consum', 0.0213, 'lps'),
	(502210, 130, '2014-01-15 01:04:33.000000', 'consum', 0.0220, 'lps'),
	(502211, 130, '2014-01-15 01:04:34.000000', 'consum', 0.0217, 'lps'),
	(502212, 130, '2014-01-15 01:04:35.000000', 'consum', 0.0215, 'lps'),
	(502213, 130, '2014-01-15 01:04:36.000000', 'consum', 0.0217, 'lps'),
	(502214, 130, '2014-01-15 01:04:37.000000', 'consum', 0.0212, 'lps'),
	(502215, 130, '2014-01-15 01:04:38.000000', 'consum', 0.0218, 'lps'),
	(502216, 130, '2014-01-15 01:04:39.000000', 'consum', 0.0226, 'lps'),
	(502217, 130, '2014-01-15 01:04:40.000000', 'consum', 0.0217, 'lps'),
	(502218, 130, '2014-01-15 01:04:41.000000', 'consum', 0.0213, 'lps'),
	(502219, 130, '2014-01-15 01:04:42.000000', 'consum', 0.0221, 'lps'),
	(502220, 130, '2014-01-15 01:04:43.000000', 'consum', 0.0222, 'lps'),
	(502221, 130, '2014-01-15 01:04:44.000000', 'consum', 0.0220, 'lps'),
	(502222, 130, '2014-01-15 01:04:45.000000', 'consum', 0.0224, 'lps'),
	(502223, 130, '2014-01-15 01:04:46.000000', 'consum', 0.0218, 'lps'),
	(502224, 130, '2014-01-15 01:04:47.000000', 'consum', 0.0223, 'lps'),
	(502225, 130, '2014-01-15 01:04:48.000000', 'consum', 0.0219, 'lps'),
	(502226, 130, '2014-01-15 01:04:49.000000', 'consum', 0.0218, 'lps'),
	(502227, 130, '2014-01-15 01:04:50.000000', 'consum', 0.0222, 'lps'),
	(502228, 130, '2014-01-15 01:04:51.000000', 'consum', 0.0214, 'lps'),
	(502229, 130, '2014-01-15 01:04:52.000000', 'consum', 0.0212, 'lps'),
	(502230, 130, '2014-01-15 01:04:53.000000', 'consum', 0.0225, 'lps'),
	(502231, 130, '2014-01-15 01:04:54.000000', 'consum', 0.0210, 'lps'),
	(502232, 130, '2014-01-15 01:04:55.000000', 'consum', 0.0215, 'lps'),
	(502233, 130, '2014-01-15 01:04:56.000000', 'consum', 0.0221, 'lps'),
	(502234, 130, '2014-01-15 01:04:57.000000', 'consum', 0.0216, 'lps'),
	(502235, 130, '2014-01-15 01:04:58.000000', 'consum', 0.0225, 'lps'),
	(502236, 130, '2014-01-15 01:04:59.000000', 'consum', 0.0217, 'lps'),
	(502237, 130, '2014-01-15 01:05:00.000000', 'consum', 0.0216, 'lps'),
	(502238, 130, '2014-01-15 01:05:01.000000', 'consum', 0.0220, 'lps'),
	(502239, 130, '2014-01-15 01:05:02.000000', 'consum', 0.0226, 'lps'),
	(502240, 130, '2014-01-15 01:05:03.000000', 'consum', 0.0224, 'lps'),
	(502241, 130, '2014-01-15 01:05:04.000000', 'consum', 0.0218, 'lps'),
	(502242, 130, '2014-01-15 01:05:05.000000', 'consum', 0.0224, 'lps'),
	(502243, 130, '2014-01-15 01:05:06.000000', 'consum', 0.0224, 'lps'),
	(502244, 130, '2014-01-15 01:05:07.000000', 'consum', 0.0219, 'lps'),
	(502245, 130, '2014-01-15 01:05:08.000000', 'consum', 0.0216, 'lps'),
	(502246, 130, '2014-01-15 01:05:09.000000', 'consum', 0.0211, 'lps'),
	(502247, 130, '2014-01-15 01:05:10.000000', 'consum', 0.0216, 'lps'),
	(502248, 130, '2014-01-15 01:05:11.000000', 'consum', 0.0220, 'lps'),
	(502249, 130, '2014-01-15 01:05:12.000000', 'consum', 0.0225, 'lps'),
	(502250, 130, '2014-01-15 01:05:13.000000', 'consum', 0.0224, 'lps'),
	(502251, 130, '2014-01-15 01:05:14.000000', 'consum', 0.0217, 'lps'),
	(502252, 130, '2014-01-15 01:05:15.000000', 'consum', 0.0220, 'lps'),
	(502253, 130, '2014-01-15 01:05:16.000000', 'consum', 0.0225, 'lps'),
	(502254, 130, '2014-01-15 01:05:17.000000', 'consum', 0.0219, 'lps'),
	(502255, 130, '2014-01-15 01:05:18.000000', 'consum', 0.0210, 'lps'),
	(502256, 130, '2014-01-15 01:05:19.000000', 'consum', 0.0219, 'lps'),
	(502257, 130, '2014-01-15 01:05:20.000000', 'consum', 0.0222, 'lps'),
	(502258, 130, '2014-01-15 01:05:21.000000', 'consum', 0.0210, 'lps'),
	(502259, 130, '2014-01-15 01:05:22.000000', 'consum', 0.0226, 'lps'),
	(502260, 130, '2014-01-15 01:05:23.000000', 'consum', 0.0223, 'lps'),
	(502261, 130, '2014-01-15 01:05:24.000000', 'consum', 0.0211, 'lps'),
	(502262, 130, '2014-01-15 01:05:25.000000', 'consum', 0.0226, 'lps'),
	(502263, 130, '2014-01-15 01:05:26.000000', 'consum', 0.0221, 'lps'),
	(502264, 130, '2014-01-15 01:05:27.000000', 'consum', 0.0216, 'lps'),
	(502265, 130, '2014-01-15 01:05:28.000000', 'consum', 0.0223, 'lps'),
	(502266, 130, '2014-01-15 01:05:29.000000', 'consum', 0.0226, 'lps'),
	(502267, 130, '2014-01-15 01:05:30.000000', 'consum', 0.0216, 'lps'),
	(502268, 130, '2014-01-15 01:05:31.000000', 'consum', 0.0211, 'lps'),
	(502269, 130, '2014-01-15 01:05:32.000000', 'consum', 0.0215, 'lps'),
	(502270, 130, '2014-01-15 01:05:33.000000', 'consum', 0.0213, 'lps'),
	(502271, 130, '2014-01-15 01:05:34.000000', 'consum', 0.0211, 'lps'),
	(502272, 130, '2014-01-15 01:05:35.000000', 'consum', 0.0222, 'lps'),
	(502273, 130, '2014-01-15 01:05:36.000000', 'consum', 0.0219, 'lps'),
	(502274, 130, '2014-01-15 01:05:37.000000', 'consum', 0.0217, 'lps'),
	(502275, 130, '2014-01-15 01:05:38.000000', 'consum', 0.0218, 'lps'),
	(502276, 130, '2014-01-15 01:05:39.000000', 'consum', 0.0215, 'lps'),
	(502277, 130, '2014-01-15 01:05:40.000000', 'consum', 0.0211, 'lps'),
	(502278, 130, '2014-01-15 01:05:41.000000', 'consum', 0.0219, 'lps'),
	(502279, 130, '2014-01-15 01:05:42.000000', 'consum', 0.0218, 'lps'),
	(502280, 130, '2014-01-15 01:05:43.000000', 'consum', 0.0221, 'lps'),
	(502281, 130, '2014-01-15 01:05:44.000000', 'consum', 0.0210, 'lps'),
	(502282, 130, '2014-01-15 01:05:45.000000', 'consum', 0.0212, 'lps'),
	(502283, 130, '2014-01-15 01:05:46.000000', 'consum', 0.0218, 'lps'),
	(502284, 130, '2014-01-15 01:05:47.000000', 'consum', 0.0212, 'lps'),
	(502285, 130, '2014-01-15 01:05:48.000000', 'consum', 0.0215, 'lps'),
	(502286, 130, '2014-01-15 01:05:49.000000', 'consum', 0.0211, 'lps'),
	(502287, 130, '2014-01-15 01:05:50.000000', 'consum', 0.0220, 'lps'),
	(502288, 130, '2014-01-15 01:05:51.000000', 'consum', 0.0220, 'lps'),
	(502289, 130, '2014-01-15 01:05:52.000000', 'consum', 0.0215, 'lps'),
	(502290, 130, '2014-01-15 01:05:53.000000', 'consum', 0.0223, 'lps'),
	(502291, 130, '2014-01-15 01:05:54.000000', 'consum', 0.0224, 'lps'),
	(502292, 130, '2014-01-15 01:05:55.000000', 'consum', 0.0211, 'lps'),
	(502293, 130, '2014-01-15 01:05:56.000000', 'consum', 0.0223, 'lps'),
	(502294, 130, '2014-01-15 01:05:57.000000', 'consum', 0.0220, 'lps'),
	(502295, 130, '2014-01-15 01:05:58.000000', 'consum', 0.0221, 'lps'),
	(502296, 130, '2014-01-15 01:05:59.000000', 'consum', 0.0220, 'lps'),
	(502297, 130, '2014-01-15 01:06:00.000000', 'consum', 0.0212, 'lps'),
	(502298, 130, '2014-01-15 01:06:01.000000', 'consum', 0.0221, 'lps'),
	(502299, 130, '2014-01-15 01:06:02.000000', 'consum', 0.0211, 'lps'),
	(502300, 130, '2014-01-15 01:06:03.000000', 'consum', 0.0217, 'lps'),
	(502301, 130, '2014-01-15 01:06:04.000000', 'consum', 0.0224, 'lps'),
	(502302, 130, '2014-01-15 01:06:05.000000', 'consum', 0.0225, 'lps'),
	(502303, 130, '2014-01-15 01:06:06.000000', 'consum', 0.0211, 'lps'),
	(502304, 130, '2014-01-15 01:06:07.000000', 'consum', 0.0219, 'lps'),
	(502305, 130, '2014-01-15 01:06:08.000000', 'consum', 0.0221, 'lps'),
	(502306, 130, '2014-01-15 01:06:09.000000', 'consum', 0.0223, 'lps'),
	(502307, 130, '2014-01-15 01:06:10.000000', 'consum', 0.0222, 'lps'),
	(502308, 130, '2014-01-15 01:06:11.000000', 'consum', 0.0215, 'lps'),
	(502309, 130, '2014-01-15 01:06:12.000000', 'consum', 0.0217, 'lps'),
	(502310, 130, '2014-01-15 01:06:13.000000', 'consum', 0.0212, 'lps'),
	(502311, 130, '2014-01-15 01:06:14.000000', 'consum', 0.0220, 'lps'),
	(502312, 130, '2014-01-15 01:06:15.000000', 'consum', 0.0218, 'lps'),
	(502313, 130, '2014-01-15 01:06:16.000000', 'consum', 0.0219, 'lps'),
	(502314, 130, '2014-01-15 01:06:17.000000', 'consum', 0.0217, 'lps'),
	(502315, 130, '2014-01-15 01:06:18.000000', 'consum', 0.0219, 'lps'),
	(502316, 130, '2014-01-15 01:06:19.000000', 'consum', 0.0216, 'lps'),
	(502317, 130, '2014-01-15 01:06:20.000000', 'consum', 0.0215, 'lps'),
	(502318, 130, '2014-01-15 01:06:21.000000', 'consum', 0.0217, 'lps'),
	(502319, 130, '2014-01-15 01:06:22.000000', 'consum', 0.0213, 'lps'),
	(502320, 130, '2014-01-15 01:06:23.000000', 'consum', 0.0221, 'lps'),
	(502321, 130, '2014-01-15 01:06:24.000000', 'consum', 0.0225, 'lps'),
	(502322, 130, '2014-01-15 01:06:25.000000', 'consum', 0.0216, 'lps'),
	(502323, 130, '2014-01-15 01:06:26.000000', 'consum', 0.0213, 'lps'),
	(502324, 130, '2014-01-15 01:06:27.000000', 'consum', 0.0223, 'lps'),
	(502325, 130, '2014-01-15 01:06:28.000000', 'consum', 0.0217, 'lps'),
	(502326, 130, '2014-01-15 01:06:29.000000', 'consum', 0.0224, 'lps'),
	(502327, 130, '2014-01-15 01:06:30.000000', 'consum', 0.0225, 'lps'),
	(502328, 130, '2014-01-15 01:06:31.000000', 'consum', 0.0226, 'lps'),
	(502329, 130, '2014-01-15 01:06:32.000000', 'consum', 0.0212, 'lps'),
	(502330, 130, '2014-01-15 01:06:33.000000', 'consum', 0.0222, 'lps'),
	(502331, 130, '2014-01-15 01:06:34.000000', 'consum', 0.0212, 'lps'),
	(502332, 130, '2014-01-15 01:06:35.000000', 'consum', 0.0222, 'lps'),
	(502333, 130, '2014-01-15 01:06:36.000000', 'consum', 0.0214, 'lps'),
	(502334, 130, '2014-01-15 01:06:37.000000', 'consum', 0.0226, 'lps'),
	(502335, 130, '2014-01-15 01:06:38.000000', 'consum', 0.0213, 'lps'),
	(502336, 130, '2014-01-15 01:06:39.000000', 'consum', 0.0225, 'lps'),
	(502337, 130, '2014-01-15 01:06:40.000000', 'consum', 0.0211, 'lps'),
	(502338, 130, '2014-01-15 01:06:41.000000', 'consum', 0.0223, 'lps'),
	(502339, 130, '2014-01-15 01:06:42.000000', 'consum', 0.0219, 'lps'),
	(502340, 130, '2014-01-15 01:06:43.000000', 'consum', 0.0219, 'lps'),
	(502341, 130, '2014-01-15 01:06:44.000000', 'consum', 0.0226, 'lps'),
	(502342, 130, '2014-01-15 01:06:45.000000', 'consum', 0.0213, 'lps'),
	(502343, 130, '2014-01-15 01:06:46.000000', 'consum', 0.0213, 'lps'),
	(502344, 130, '2014-01-15 01:06:47.000000', 'consum', 0.0215, 'lps'),
	(502345, 130, '2014-01-15 01:06:48.000000', 'consum', 0.0226, 'lps'),
	(502346, 130, '2014-01-15 01:06:49.000000', 'consum', 0.0223, 'lps'),
	(502347, 130, '2014-01-15 01:06:50.000000', 'consum', 0.0213, 'lps'),
	(502348, 130, '2014-01-15 01:06:51.000000', 'consum', 0.0221, 'lps'),
	(502349, 130, '2014-01-15 01:06:52.000000', 'consum', 0.0220, 'lps'),
	(502350, 130, '2014-01-15 01:06:53.000000', 'consum', 0.0212, 'lps'),
	(502351, 130, '2014-01-15 01:06:54.000000', 'consum', 0.0226, 'lps'),
	(502352, 130, '2014-01-15 01:06:55.000000', 'consum', 0.0215, 'lps'),
	(502353, 130, '2014-01-15 01:06:56.000000', 'consum', 0.0223, 'lps'),
	(502354, 130, '2014-01-15 01:06:57.000000', 'consum', 0.0210, 'lps'),
	(502355, 130, '2014-01-15 01:06:58.000000', 'consum', 0.0223, 'lps'),
	(502356, 130, '2014-01-15 01:06:59.000000', 'consum', 0.0224, 'lps'),
	(502357, 130, '2014-01-15 01:07:00.000000', 'consum', 0.0224, 'lps'),
	(502358, 130, '2014-01-15 01:07:01.000000', 'consum', 0.0222, 'lps'),
	(502359, 130, '2014-01-15 01:07:02.000000', 'consum', 0.0211, 'lps'),
	(502360, 130, '2014-01-15 01:07:03.000000', 'consum', 0.0216, 'lps'),
	(502361, 130, '2014-01-15 01:07:04.000000', 'consum', 0.0217, 'lps'),
	(502362, 130, '2014-01-15 01:07:05.000000', 'consum', 0.0214, 'lps'),
	(502363, 130, '2014-01-15 01:07:06.000000', 'consum', 0.0224, 'lps'),
	(502364, 130, '2014-01-15 01:07:07.000000', 'consum', 0.0217, 'lps'),
	(502365, 130, '2014-01-15 01:07:08.000000', 'consum', 0.0220, 'lps'),
	(502366, 130, '2014-01-15 01:07:09.000000', 'consum', 0.0224, 'lps'),
	(502367, 130, '2014-01-15 01:07:10.000000', 'consum', 0.0216, 'lps'),
	(502368, 130, '2014-01-15 01:07:11.000000', 'consum', 0.0216, 'lps'),
	(502369, 130, '2014-01-15 01:07:12.000000', 'consum', 0.0222, 'lps'),
	(502370, 130, '2014-01-15 01:07:13.000000', 'consum', 0.0219, 'lps'),
	(502371, 130, '2014-01-15 01:07:14.000000', 'consum', 0.0220, 'lps'),
	(502372, 130, '2014-01-15 01:07:15.000000', 'consum', 0.0215, 'lps'),
	(502373, 130, '2014-01-15 01:07:16.000000', 'consum', 0.0223, 'lps'),
	(502374, 130, '2014-01-15 01:07:17.000000', 'consum', 0.0225, 'lps'),
	(502375, 130, '2014-01-15 01:07:18.000000', 'consum', 0.0212, 'lps'),
	(502376, 130, '2014-01-15 01:07:19.000000', 'consum', 0.0213, 'lps'),
	(502377, 130, '2014-01-15 01:07:20.000000', 'consum', 0.0217, 'lps'),
	(502378, 130, '2014-01-15 01:07:21.000000', 'consum', 0.0218, 'lps'),
	(502379, 130, '2014-01-15 01:07:22.000000', 'consum', 0.0215, 'lps'),
	(502380, 130, '2014-01-15 01:07:23.000000', 'consum', 0.0211, 'lps'),
	(502381, 130, '2014-01-15 01:07:24.000000', 'consum', 0.0217, 'lps'),
	(502382, 130, '2014-01-15 01:07:25.000000', 'consum', 0.0211, 'lps'),
	(502383, 130, '2014-01-15 01:07:26.000000', 'consum', 0.0225, 'lps'),
	(502384, 130, '2014-01-15 01:07:27.000000', 'consum', 0.0217, 'lps'),
	(502385, 130, '2014-01-15 01:07:28.000000', 'consum', 0.0218, 'lps'),
	(502386, 130, '2014-01-15 01:07:29.000000', 'consum', 0.0210, 'lps'),
	(502387, 130, '2014-01-15 01:07:30.000000', 'consum', 0.0222, 'lps'),
	(502388, 130, '2014-01-15 01:07:31.000000', 'consum', 0.0220, 'lps'),
	(502389, 130, '2014-01-15 01:07:32.000000', 'consum', 0.0225, 'lps'),
	(502390, 130, '2014-01-15 01:07:33.000000', 'consum', 0.0220, 'lps'),
	(502391, 130, '2014-01-15 01:07:34.000000', 'consum', 0.0216, 'lps'),
	(502392, 130, '2014-01-15 01:07:35.000000', 'consum', 0.0212, 'lps'),
	(502393, 130, '2014-01-15 01:07:36.000000', 'consum', 0.0220, 'lps'),
	(502394, 130, '2014-01-15 01:07:37.000000', 'consum', 0.0220, 'lps'),
	(502395, 130, '2014-01-15 01:07:38.000000', 'consum', 0.0212, 'lps'),
	(502396, 130, '2014-01-15 01:07:39.000000', 'consum', 0.0224, 'lps'),
	(502397, 130, '2014-01-15 01:07:40.000000', 'consum', 0.0224, 'lps'),
	(502398, 130, '2014-01-15 01:07:41.000000', 'consum', 0.0222, 'lps'),
	(502399, 130, '2014-01-15 01:07:42.000000', 'consum', 0.0211, 'lps'),
	(502400, 130, '2014-01-15 01:07:43.000000', 'consum', 0.0216, 'lps'),
	(502401, 130, '2014-01-15 01:07:44.000000', 'consum', 0.0218, 'lps'),
	(502402, 130, '2014-01-15 01:07:45.000000', 'consum', 0.0218, 'lps'),
	(502403, 130, '2014-01-15 01:07:46.000000', 'consum', 0.0224, 'lps'),
	(502404, 130, '2014-01-15 01:07:47.000000', 'consum', 0.0224, 'lps'),
	(502405, 130, '2014-01-15 01:07:48.000000', 'consum', 0.0223, 'lps'),
	(502406, 130, '2014-01-15 01:07:49.000000', 'consum', 0.0215, 'lps'),
	(502407, 130, '2014-01-15 01:07:50.000000', 'consum', 0.0214, 'lps'),
	(502408, 130, '2014-01-15 01:07:51.000000', 'consum', 0.0214, 'lps'),
	(502409, 130, '2014-01-15 01:07:52.000000', 'consum', 0.0219, 'lps'),
	(502410, 130, '2014-01-15 01:07:53.000000', 'consum', 0.0210, 'lps'),
	(502411, 130, '2014-01-15 01:07:54.000000', 'consum', 0.0218, 'lps'),
	(502412, 130, '2014-01-15 01:07:55.000000', 'consum', 0.0215, 'lps'),
	(502413, 130, '2014-01-15 01:07:56.000000', 'consum', 0.0213, 'lps'),
	(502414, 130, '2014-01-15 01:07:57.000000', 'consum', 0.0210, 'lps'),
	(502415, 130, '2014-01-15 01:07:58.000000', 'consum', 0.0219, 'lps'),
	(502416, 130, '2014-01-15 01:07:59.000000', 'consum', 0.0219, 'lps'),
	(502417, 130, '2014-01-15 01:08:00.000000', 'consum', 0.0214, 'lps'),
	(502418, 130, '2014-01-15 01:08:01.000000', 'consum', 0.0221, 'lps'),
	(502419, 130, '2014-01-15 01:08:02.000000', 'consum', 0.0218, 'lps'),
	(502420, 130, '2014-01-15 01:08:03.000000', 'consum', 0.0216, 'lps'),
	(502421, 130, '2014-01-15 01:08:04.000000', 'consum', 0.0219, 'lps'),
	(502422, 130, '2014-01-15 01:08:05.000000', 'consum', 0.0220, 'lps'),
	(502423, 130, '2014-01-15 01:08:06.000000', 'consum', 0.0216, 'lps'),
	(502424, 130, '2014-01-15 01:08:07.000000', 'consum', 0.0212, 'lps'),
	(502425, 130, '2014-01-15 01:08:08.000000', 'consum', 0.0220, 'lps'),
	(502426, 130, '2014-01-15 01:08:09.000000', 'consum', 0.0218, 'lps'),
	(502427, 130, '2014-01-15 01:08:10.000000', 'consum', 0.0221, 'lps'),
	(502428, 130, '2014-01-15 01:08:11.000000', 'consum', 0.0225, 'lps'),
	(502429, 130, '2014-01-15 01:08:12.000000', 'consum', 0.0220, 'lps'),
	(502430, 130, '2014-01-15 01:08:13.000000', 'consum', 0.0214, 'lps'),
	(502431, 130, '2014-01-15 01:08:14.000000', 'consum', 0.0220, 'lps'),
	(502432, 130, '2014-01-15 01:08:15.000000', 'consum', 0.0212, 'lps'),
	(502433, 130, '2014-01-15 01:08:16.000000', 'consum', 0.0225, 'lps'),
	(502434, 130, '2014-01-15 01:08:17.000000', 'consum', 0.0213, 'lps'),
	(502435, 130, '2014-01-15 01:08:18.000000', 'consum', 0.0212, 'lps'),
	(502436, 130, '2014-01-15 01:08:19.000000', 'consum', 0.0214, 'lps'),
	(502437, 130, '2014-01-15 01:08:20.000000', 'consum', 0.0222, 'lps'),
	(502438, 130, '2014-01-15 01:08:21.000000', 'consum', 0.0224, 'lps'),
	(502439, 130, '2014-01-15 01:08:22.000000', 'consum', 0.0213, 'lps'),
	(502440, 130, '2014-01-15 01:08:23.000000', 'consum', 0.0219, 'lps'),
	(502441, 130, '2014-01-15 01:08:24.000000', 'consum', 0.0226, 'lps'),
	(502442, 130, '2014-01-15 01:08:25.000000', 'consum', 0.0212, 'lps'),
	(502443, 130, '2014-01-15 01:08:26.000000', 'consum', 0.0226, 'lps'),
	(502444, 130, '2014-01-15 01:08:27.000000', 'consum', 0.0217, 'lps'),
	(502445, 130, '2014-01-15 01:08:28.000000', 'consum', 0.0216, 'lps'),
	(502446, 130, '2014-01-15 01:08:29.000000', 'consum', 0.0216, 'lps'),
	(502447, 130, '2014-01-15 01:08:30.000000', 'consum', 0.0223, 'lps'),
	(502448, 130, '2014-01-15 01:08:31.000000', 'consum', 0.0223, 'lps'),
	(502449, 130, '2014-01-15 01:08:32.000000', 'consum', 0.0218, 'lps'),
	(502450, 130, '2014-01-15 01:08:33.000000', 'consum', 0.0214, 'lps'),
	(502451, 130, '2014-01-15 01:08:34.000000', 'consum', 0.0225, 'lps'),
	(502452, 130, '2014-01-15 01:08:35.000000', 'consum', 0.0220, 'lps'),
	(502453, 130, '2014-01-15 01:08:36.000000', 'consum', 0.0214, 'lps'),
	(502454, 130, '2014-01-15 01:08:37.000000', 'consum', 0.0220, 'lps'),
	(502455, 130, '2014-01-15 01:08:38.000000', 'consum', 0.0215, 'lps'),
	(502456, 130, '2014-01-15 01:08:39.000000', 'consum', 0.0221, 'lps'),
	(502457, 130, '2014-01-15 01:08:40.000000', 'consum', 0.0218, 'lps'),
	(502458, 130, '2014-01-15 01:08:41.000000', 'consum', 0.0218, 'lps'),
	(502459, 130, '2014-01-15 01:08:42.000000', 'consum', 0.0226, 'lps'),
	(502460, 130, '2014-01-15 01:08:43.000000', 'consum', 0.0216, 'lps'),
	(502461, 130, '2014-01-15 01:08:44.000000', 'consum', 0.0226, 'lps'),
	(502462, 130, '2014-01-15 01:08:45.000000', 'consum', 0.0222, 'lps'),
	(502463, 130, '2014-01-15 01:08:46.000000', 'consum', 0.0224, 'lps'),
	(502464, 130, '2014-01-15 01:08:47.000000', 'consum', 0.0210, 'lps'),
	(502465, 130, '2014-01-15 01:08:48.000000', 'consum', 0.0218, 'lps'),
	(502466, 130, '2014-01-15 01:08:49.000000', 'consum', 0.0218, 'lps'),
	(502467, 130, '2014-01-15 01:08:50.000000', 'consum', 0.0224, 'lps'),
	(502468, 130, '2014-01-15 01:08:51.000000', 'consum', 0.0223, 'lps'),
	(502469, 130, '2014-01-15 01:08:52.000000', 'consum', 0.0218, 'lps'),
	(502470, 130, '2014-01-15 01:08:53.000000', 'consum', 0.0226, 'lps'),
	(502471, 130, '2014-01-15 01:08:54.000000', 'consum', 0.0216, 'lps'),
	(502472, 130, '2014-01-15 01:08:55.000000', 'consum', 0.0211, 'lps'),
	(502473, 130, '2014-01-15 01:08:56.000000', 'consum', 0.0213, 'lps'),
	(502474, 130, '2014-01-15 01:08:57.000000', 'consum', 0.0223, 'lps'),
	(502475, 130, '2014-01-15 01:08:58.000000', 'consum', 0.0215, 'lps'),
	(502476, 130, '2014-01-15 01:08:59.000000', 'consum', 0.0216, 'lps'),
	(502477, 130, '2014-01-15 01:09:00.000000', 'consum', 0.0223, 'lps'),
	(502478, 130, '2014-01-15 01:09:01.000000', 'consum', 0.0224, 'lps'),
	(502479, 130, '2014-01-15 01:09:02.000000', 'consum', 0.0225, 'lps'),
	(502480, 130, '2014-01-15 01:09:03.000000', 'consum', 0.0210, 'lps'),
	(502481, 130, '2014-01-15 01:09:04.000000', 'consum', 0.0216, 'lps'),
	(502482, 130, '2014-01-15 01:09:05.000000', 'consum', 0.0222, 'lps'),
	(502483, 130, '2014-01-15 01:09:06.000000', 'consum', 0.0218, 'lps'),
	(502484, 130, '2014-01-15 01:09:07.000000', 'consum', 0.0217, 'lps'),
	(502485, 130, '2014-01-15 01:09:08.000000', 'consum', 0.0220, 'lps'),
	(502486, 130, '2014-01-15 01:09:09.000000', 'consum', 0.0225, 'lps'),
	(502487, 130, '2014-01-15 01:09:10.000000', 'consum', 0.0219, 'lps'),
	(502488, 130, '2014-01-15 01:09:11.000000', 'consum', 0.0213, 'lps'),
	(502489, 130, '2014-01-15 01:09:12.000000', 'consum', 0.0214, 'lps'),
	(502490, 130, '2014-01-15 01:09:13.000000', 'consum', 0.0222, 'lps'),
	(502491, 130, '2014-01-15 01:09:14.000000', 'consum', 0.0224, 'lps'),
	(502492, 130, '2014-01-15 01:09:15.000000', 'consum', 0.0226, 'lps'),
	(502493, 130, '2014-01-15 01:09:16.000000', 'consum', 0.0215, 'lps'),
	(502494, 130, '2014-01-15 01:09:17.000000', 'consum', 0.0220, 'lps'),
	(502495, 130, '2014-01-15 01:09:18.000000', 'consum', 0.0213, 'lps'),
	(502496, 130, '2014-01-15 01:09:19.000000', 'consum', 0.0215, 'lps'),
	(502497, 130, '2014-01-15 01:09:20.000000', 'consum', 0.0223, 'lps'),
	(502498, 130, '2014-01-15 01:09:21.000000', 'consum', 0.0226, 'lps'),
	(502499, 130, '2014-01-15 01:09:22.000000', 'consum', 0.0220, 'lps'),
	(502500, 130, '2014-01-15 01:09:23.000000', 'consum', 0.0210, 'lps'),
	(502501, 130, '2014-01-15 01:09:24.000000', 'consum', 0.0217, 'lps'),
	(502502, 130, '2014-01-15 01:09:25.000000', 'consum', 0.0210, 'lps'),
	(502503, 130, '2014-01-15 01:09:26.000000', 'consum', 0.0225, 'lps'),
	(502504, 130, '2014-01-15 01:09:27.000000', 'consum', 0.0217, 'lps'),
	(502505, 130, '2014-01-15 01:09:28.000000', 'consum', 0.0218, 'lps'),
	(502506, 130, '2014-01-15 01:09:29.000000', 'consum', 0.0214, 'lps'),
	(502507, 130, '2014-01-15 01:09:30.000000', 'consum', 0.0221, 'lps'),
	(502508, 130, '2014-01-15 01:09:31.000000', 'consum', 0.0221, 'lps'),
	(502509, 130, '2014-01-15 01:09:32.000000', 'consum', 0.0213, 'lps'),
	(502510, 130, '2014-01-15 01:09:33.000000', 'consum', 0.0212, 'lps'),
	(502511, 130, '2014-01-15 01:09:34.000000', 'consum', 0.0213, 'lps'),
	(502512, 130, '2014-01-15 01:09:35.000000', 'consum', 0.0216, 'lps'),
	(502513, 130, '2014-01-15 01:09:36.000000', 'consum', 0.0217, 'lps'),
	(502514, 130, '2014-01-15 01:09:37.000000', 'consum', 0.0225, 'lps'),
	(502515, 130, '2014-01-15 01:09:38.000000', 'consum', 0.0213, 'lps'),
	(502516, 130, '2014-01-15 01:09:39.000000', 'consum', 0.0217, 'lps'),
	(502517, 130, '2014-01-15 01:09:40.000000', 'consum', 0.0217, 'lps'),
	(502518, 130, '2014-01-15 01:09:41.000000', 'consum', 0.0225, 'lps'),
	(502519, 130, '2014-01-15 01:09:42.000000', 'consum', 0.0214, 'lps'),
	(502520, 130, '2014-01-15 01:09:43.000000', 'consum', 0.0220, 'lps'),
	(502521, 130, '2014-01-15 01:09:44.000000', 'consum', 0.0214, 'lps'),
	(502522, 130, '2014-01-15 01:09:45.000000', 'consum', 0.0216, 'lps'),
	(502523, 130, '2014-01-15 01:09:46.000000', 'consum', 0.0212, 'lps'),
	(502524, 130, '2014-01-15 01:09:47.000000', 'consum', 0.0219, 'lps'),
	(502525, 130, '2014-01-15 01:09:48.000000', 'consum', 0.0216, 'lps'),
	(502526, 130, '2014-01-15 01:09:49.000000', 'consum', 0.0214, 'lps'),
	(502527, 130, '2014-01-15 01:09:50.000000', 'consum', 0.0212, 'lps'),
	(502528, 130, '2014-01-15 01:09:51.000000', 'consum', 0.0210, 'lps'),
	(502529, 130, '2014-01-15 01:09:52.000000', 'consum', 0.0219, 'lps'),
	(502530, 130, '2014-01-15 01:09:53.000000', 'consum', 0.0224, 'lps'),
	(502531, 130, '2014-01-15 01:09:54.000000', 'consum', 0.0219, 'lps'),
	(502532, 130, '2014-01-15 01:09:55.000000', 'consum', 0.0215, 'lps'),
	(502533, 130, '2014-01-15 01:09:56.000000', 'consum', 0.0223, 'lps'),
	(502534, 130, '2014-01-15 01:09:57.000000', 'consum', 0.0210, 'lps'),
	(502535, 130, '2014-01-15 01:09:58.000000', 'consum', 0.0221, 'lps'),
	(502536, 130, '2014-01-15 01:09:59.000000', 'consum', 0.0214, 'lps'),
	(502537, 130, '2014-01-15 01:10:00.000000', 'consum', 0.0217, 'lps'),
	(502538, 130, '2014-01-15 01:10:01.000000', 'consum', 0.0217, 'lps'),
	(502539, 130, '2014-01-15 01:10:02.000000', 'consum', 0.0223, 'lps'),
	(502540, 130, '2014-01-15 01:10:03.000000', 'consum', 0.0222, 'lps'),
	(502541, 130, '2014-01-15 01:10:04.000000', 'consum', 0.0215, 'lps'),
	(502542, 130, '2014-01-15 01:10:05.000000', 'consum', 0.0217, 'lps'),
	(502543, 130, '2014-01-15 01:10:06.000000', 'consum', 0.0215, 'lps'),
	(502544, 130, '2014-01-15 01:10:07.000000', 'consum', 0.0211, 'lps'),
	(502545, 130, '2014-01-15 01:10:08.000000', 'consum', 0.0220, 'lps'),
	(502546, 130, '2014-01-15 01:10:09.000000', 'consum', 0.0221, 'lps'),
	(502547, 130, '2014-01-15 01:10:10.000000', 'consum', 0.0221, 'lps'),
	(502548, 130, '2014-01-15 01:10:11.000000', 'consum', 0.0214, 'lps'),
	(502549, 130, '2014-01-15 01:10:12.000000', 'consum', 0.0214, 'lps'),
	(502550, 130, '2014-01-15 01:10:13.000000', 'consum', 0.0218, 'lps'),
	(502551, 130, '2014-01-15 01:10:14.000000', 'consum', 0.0223, 'lps'),
	(502552, 130, '2014-01-15 01:10:15.000000', 'consum', 0.0218, 'lps'),
	(502553, 130, '2014-01-15 01:10:16.000000', 'consum', 0.0210, 'lps'),
	(502554, 130, '2014-01-15 01:10:17.000000', 'consum', 0.0221, 'lps'),
	(502555, 130, '2014-01-15 01:10:18.000000', 'consum', 0.0215, 'lps'),
	(502556, 130, '2014-01-15 01:10:19.000000', 'consum', 0.0220, 'lps'),
	(502557, 130, '2014-01-15 01:10:20.000000', 'consum', 0.0226, 'lps'),
	(502558, 130, '2014-01-15 01:10:21.000000', 'consum', 0.0210, 'lps'),
	(502559, 130, '2014-01-15 01:10:22.000000', 'consum', 0.0214, 'lps'),
	(502560, 130, '2014-01-15 01:10:23.000000', 'consum', 0.0213, 'lps'),
	(502561, 130, '2014-01-15 01:10:24.000000', 'consum', 0.0215, 'lps'),
	(502562, 130, '2014-01-15 01:10:25.000000', 'consum', 0.0224, 'lps'),
	(502563, 130, '2014-01-15 01:10:26.000000', 'consum', 0.0216, 'lps'),
	(502564, 130, '2014-01-15 01:10:27.000000', 'consum', 0.0213, 'lps'),
	(502565, 130, '2014-01-15 01:10:28.000000', 'consum', 0.0210, 'lps'),
	(502566, 130, '2014-01-15 01:10:29.000000', 'consum', 0.0219, 'lps'),
	(502567, 130, '2014-01-15 01:10:30.000000', 'consum', 0.0221, 'lps'),
	(502568, 130, '2014-01-15 01:10:31.000000', 'consum', 0.0221, 'lps'),
	(502569, 130, '2014-01-15 01:10:32.000000', 'consum', 0.0217, 'lps'),
	(502570, 130, '2014-01-15 01:10:33.000000', 'consum', 0.0212, 'lps'),
	(502571, 130, '2014-01-15 01:10:34.000000', 'consum', 0.0217, 'lps'),
	(502572, 130, '2014-01-15 01:10:35.000000', 'consum', 0.0224, 'lps'),
	(502573, 130, '2014-01-15 01:10:36.000000', 'consum', 0.0223, 'lps'),
	(502574, 130, '2014-01-15 01:10:37.000000', 'consum', 0.0217, 'lps'),
	(502575, 130, '2014-01-15 01:10:38.000000', 'consum', 0.0225, 'lps'),
	(502576, 130, '2014-01-15 01:10:39.000000', 'consum', 0.0211, 'lps'),
	(502577, 130, '2014-01-15 01:10:40.000000', 'consum', 0.0223, 'lps'),
	(502578, 130, '2014-01-15 01:10:41.000000', 'consum', 0.0220, 'lps'),
	(502579, 130, '2014-01-15 01:10:42.000000', 'consum', 0.0220, 'lps'),
	(502580, 130, '2014-01-15 01:10:43.000000', 'consum', 0.0217, 'lps'),
	(502581, 130, '2014-01-15 01:10:44.000000', 'consum', 0.0212, 'lps'),
	(502582, 130, '2014-01-15 01:10:45.000000', 'consum', 0.0220, 'lps'),
	(502583, 130, '2014-01-15 01:10:46.000000', 'consum', 0.0218, 'lps'),
	(502584, 130, '2014-01-15 01:10:47.000000', 'consum', 0.0220, 'lps'),
	(502585, 130, '2014-01-15 01:10:48.000000', 'consum', 0.0221, 'lps'),
	(502586, 130, '2014-01-15 01:10:49.000000', 'consum', 0.0216, 'lps'),
	(502587, 130, '2014-01-15 01:10:50.000000', 'consum', 0.0226, 'lps'),
	(502588, 130, '2014-01-15 01:10:51.000000', 'consum', 0.0221, 'lps'),
	(502589, 130, '2014-01-15 01:10:52.000000', 'consum', 0.0220, 'lps'),
	(502590, 130, '2014-01-15 01:10:53.000000', 'consum', 0.0224, 'lps'),
	(502591, 130, '2014-01-15 01:10:54.000000', 'consum', 0.0218, 'lps'),
	(502592, 130, '2014-01-15 01:10:55.000000', 'consum', 0.0225, 'lps'),
	(502593, 130, '2014-01-15 01:10:56.000000', 'consum', 0.0210, 'lps'),
	(502594, 130, '2014-01-15 01:10:57.000000', 'consum', 0.0215, 'lps'),
	(502595, 130, '2014-01-15 01:10:58.000000', 'consum', 0.0221, 'lps'),
	(502596, 130, '2014-01-15 01:10:59.000000', 'consum', 0.0217, 'lps'),
	(502597, 130, '2014-01-15 01:11:00.000000', 'consum', 0.0214, 'lps'),
	(502598, 130, '2014-01-15 01:11:01.000000', 'consum', 0.0224, 'lps'),
	(502599, 130, '2014-01-15 01:11:02.000000', 'consum', 0.0216, 'lps'),
	(502600, 130, '2014-01-15 01:11:03.000000', 'consum', 0.0217, 'lps'),
	(502601, 130, '2014-01-15 01:11:04.000000', 'consum', 0.0210, 'lps'),
	(502602, 130, '2014-01-15 01:11:05.000000', 'consum', 0.0225, 'lps'),
	(502603, 130, '2014-01-15 01:11:06.000000', 'consum', 0.0215, 'lps'),
	(502604, 130, '2014-01-15 01:11:07.000000', 'consum', 0.0225, 'lps'),
	(502605, 130, '2014-01-15 01:11:08.000000', 'consum', 0.0218, 'lps'),
	(502606, 130, '2014-01-15 01:11:09.000000', 'consum', 0.0225, 'lps'),
	(502607, 130, '2014-01-15 01:11:10.000000', 'consum', 0.0226, 'lps'),
	(502608, 130, '2014-01-15 01:11:11.000000', 'consum', 0.0211, 'lps'),
	(502609, 130, '2014-01-15 01:11:12.000000', 'consum', 0.0218, 'lps'),
	(502610, 130, '2014-01-15 01:11:13.000000', 'consum', 0.0214, 'lps'),
	(502611, 130, '2014-01-15 01:11:14.000000', 'consum', 0.0222, 'lps'),
	(502612, 130, '2014-01-15 01:11:15.000000', 'consum', 0.0211, 'lps'),
	(502613, 130, '2014-01-15 01:11:16.000000', 'consum', 0.0211, 'lps'),
	(502614, 130, '2014-01-15 01:11:17.000000', 'consum', 0.0213, 'lps'),
	(502615, 130, '2014-01-15 01:11:18.000000', 'consum', 0.0224, 'lps'),
	(502616, 130, '2014-01-15 01:11:19.000000', 'consum', 0.0219, 'lps'),
	(502617, 130, '2014-01-15 01:11:20.000000', 'consum', 0.0214, 'lps'),
	(502618, 130, '2014-01-15 01:11:21.000000', 'consum', 0.0219, 'lps'),
	(502619, 130, '2014-01-15 01:11:22.000000', 'consum', 0.0212, 'lps'),
	(502620, 130, '2014-01-15 01:11:23.000000', 'consum', 0.0210, 'lps'),
	(502621, 130, '2014-01-15 01:11:24.000000', 'consum', 0.0223, 'lps'),
	(502622, 130, '2014-01-15 01:11:25.000000', 'consum', 0.0223, 'lps'),
	(502623, 130, '2014-01-15 01:11:26.000000', 'consum', 0.0219, 'lps'),
	(502624, 130, '2014-01-15 01:11:27.000000', 'consum', 0.0215, 'lps'),
	(502625, 130, '2014-01-15 01:11:28.000000', 'consum', 0.0212, 'lps'),
	(502626, 130, '2014-01-15 01:11:29.000000', 'consum', 0.0221, 'lps'),
	(502627, 130, '2014-01-15 01:11:30.000000', 'consum', 0.0225, 'lps'),
	(502628, 130, '2014-01-15 01:11:31.000000', 'consum', 0.0219, 'lps'),
	(502629, 130, '2014-01-15 01:11:32.000000', 'consum', 0.0226, 'lps'),
	(502630, 130, '2014-01-15 01:11:33.000000', 'consum', 0.0215, 'lps'),
	(502631, 130, '2014-01-15 01:11:34.000000', 'consum', 0.0220, 'lps'),
	(502632, 130, '2014-01-15 01:11:35.000000', 'consum', 0.0210, 'lps'),
	(502633, 130, '2014-01-15 01:11:36.000000', 'consum', 0.0217, 'lps'),
	(502634, 130, '2014-01-15 01:11:37.000000', 'consum', 0.0226, 'lps'),
	(502635, 130, '2014-01-15 01:11:38.000000', 'consum', 0.0219, 'lps'),
	(502636, 130, '2014-01-15 01:11:39.000000', 'consum', 0.0223, 'lps'),
	(502637, 130, '2014-01-15 01:11:40.000000', 'consum', 0.0217, 'lps'),
	(502638, 130, '2014-01-15 01:11:41.000000', 'consum', 0.0222, 'lps'),
	(502639, 130, '2014-01-15 01:11:42.000000', 'consum', 0.0218, 'lps'),
	(502640, 130, '2014-01-15 01:11:43.000000', 'consum', 0.0213, 'lps'),
	(502641, 130, '2014-01-15 01:11:44.000000', 'consum', 0.0219, 'lps'),
	(502642, 130, '2014-01-15 01:11:45.000000', 'consum', 0.0214, 'lps'),
	(502643, 130, '2014-01-15 01:11:46.000000', 'consum', 0.0218, 'lps'),
	(502644, 130, '2014-01-15 01:11:47.000000', 'consum', 0.0223, 'lps'),
	(502645, 130, '2014-01-15 01:11:48.000000', 'consum', 0.0218, 'lps'),
	(502646, 130, '2014-01-15 01:11:49.000000', 'consum', 0.0211, 'lps'),
	(502647, 130, '2014-01-15 01:11:50.000000', 'consum', 0.0210, 'lps'),
	(502648, 130, '2014-01-15 01:11:51.000000', 'consum', 0.0223, 'lps'),
	(502649, 130, '2014-01-15 01:11:52.000000', 'consum', 0.0223, 'lps'),
	(502650, 130, '2014-01-15 01:11:53.000000', 'consum', 0.0221, 'lps'),
	(502651, 130, '2014-01-15 01:11:54.000000', 'consum', 0.0225, 'lps'),
	(502652, 130, '2014-01-15 01:11:55.000000', 'consum', 0.0221, 'lps'),
	(502653, 130, '2014-01-15 01:11:56.000000', 'consum', 0.0220, 'lps'),
	(502654, 130, '2014-01-15 01:11:57.000000', 'consum', 0.0212, 'lps'),
	(502655, 130, '2014-01-15 01:11:58.000000', 'consum', 0.0223, 'lps'),
	(502656, 130, '2014-01-15 01:11:59.000000', 'consum', 0.0219, 'lps'),
	(502657, 130, '2014-01-15 01:12:00.000000', 'consum', 0.0214, 'lps'),
	(502658, 130, '2014-01-15 01:12:01.000000', 'consum', 0.0223, 'lps'),
	(502659, 130, '2014-01-15 01:12:02.000000', 'consum', 0.0211, 'lps'),
	(502660, 130, '2014-01-15 01:12:03.000000', 'consum', 0.0212, 'lps'),
	(502661, 130, '2014-01-15 01:12:04.000000', 'consum', 0.0215, 'lps'),
	(502662, 130, '2014-01-15 01:12:05.000000', 'consum', 0.0216, 'lps'),
	(502663, 130, '2014-01-15 01:12:06.000000', 'consum', 0.0222, 'lps'),
	(502664, 130, '2014-01-15 01:12:07.000000', 'consum', 0.0220, 'lps'),
	(502665, 130, '2014-01-15 01:12:08.000000', 'consum', 0.0225, 'lps'),
	(502666, 130, '2014-01-15 01:12:09.000000', 'consum', 0.0220, 'lps'),
	(502667, 130, '2014-01-15 01:12:10.000000', 'consum', 0.0216, 'lps'),
	(502668, 130, '2014-01-15 01:12:11.000000', 'consum', 0.0226, 'lps'),
	(502669, 130, '2014-01-15 01:12:12.000000', 'consum', 0.0222, 'lps'),
	(502670, 130, '2014-01-15 01:12:13.000000', 'consum', 0.0223, 'lps'),
	(502671, 130, '2014-01-15 01:12:14.000000', 'consum', 0.0221, 'lps'),
	(502672, 130, '2014-01-15 01:12:15.000000', 'consum', 0.0210, 'lps'),
	(502673, 130, '2014-01-15 01:12:16.000000', 'consum', 0.0210, 'lps'),
	(502674, 130, '2014-01-15 01:12:17.000000', 'consum', 0.0211, 'lps'),
	(502675, 130, '2014-01-15 01:12:18.000000', 'consum', 0.0216, 'lps'),
	(502676, 130, '2014-01-15 01:12:19.000000', 'consum', 0.0221, 'lps'),
	(502677, 130, '2014-01-15 01:12:20.000000', 'consum', 0.0212, 'lps'),
	(502678, 130, '2014-01-15 01:12:21.000000', 'consum', 0.0223, 'lps'),
	(502679, 130, '2014-01-15 01:12:22.000000', 'consum', 0.0219, 'lps'),
	(502680, 130, '2014-01-15 01:12:23.000000', 'consum', 0.0215, 'lps'),
	(502681, 130, '2014-01-15 01:12:24.000000', 'consum', 0.0225, 'lps'),
	(502682, 130, '2014-01-15 01:12:25.000000', 'consum', 0.0222, 'lps'),
	(502683, 130, '2014-01-15 01:12:26.000000', 'consum', 0.0224, 'lps'),
	(502684, 130, '2014-01-15 01:12:27.000000', 'consum', 0.0226, 'lps'),
	(502685, 130, '2014-01-15 01:12:28.000000', 'consum', 0.0215, 'lps'),
	(502686, 130, '2014-01-15 01:12:29.000000', 'consum', 0.0221, 'lps'),
	(502687, 130, '2014-01-15 01:12:30.000000', 'consum', 0.0218, 'lps'),
	(502688, 130, '2014-01-15 01:12:31.000000', 'consum', 0.0218, 'lps'),
	(502689, 130, '2014-01-15 01:12:32.000000', 'consum', 0.0226, 'lps'),
	(502690, 130, '2014-01-15 01:12:33.000000', 'consum', 0.0215, 'lps'),
	(502691, 130, '2014-01-15 01:12:34.000000', 'consum', 0.0221, 'lps'),
	(502692, 130, '2014-01-15 01:12:35.000000', 'consum', 0.0219, 'lps'),
	(502693, 130, '2014-01-15 01:12:36.000000', 'consum', 0.0221, 'lps'),
	(502694, 130, '2014-01-15 01:12:37.000000', 'consum', 0.0222, 'lps'),
	(502695, 130, '2014-01-15 01:12:38.000000', 'consum', 0.0220, 'lps'),
	(502696, 130, '2014-01-15 01:12:39.000000', 'consum', 0.0226, 'lps'),
	(502697, 130, '2014-01-15 01:12:40.000000', 'consum', 0.0224, 'lps'),
	(502698, 130, '2014-01-15 01:12:41.000000', 'consum', 0.0217, 'lps'),
	(502699, 130, '2014-01-15 01:12:42.000000', 'consum', 0.0221, 'lps'),
	(502700, 130, '2014-01-15 01:12:43.000000', 'consum', 0.0211, 'lps'),
	(502701, 130, '2014-01-15 01:12:44.000000', 'consum', 0.0214, 'lps'),
	(502702, 130, '2014-01-15 01:12:45.000000', 'consum', 0.0212, 'lps'),
	(502703, 130, '2014-01-15 01:12:46.000000', 'consum', 0.0210, 'lps'),
	(502704, 130, '2014-01-15 01:12:47.000000', 'consum', 0.0222, 'lps'),
	(502705, 130, '2014-01-15 01:12:48.000000', 'consum', 0.0220, 'lps'),
	(502706, 130, '2014-01-15 01:12:49.000000', 'consum', 0.0222, 'lps'),
	(502707, 130, '2014-01-15 01:12:50.000000', 'consum', 0.0223, 'lps'),
	(502708, 130, '2014-01-15 01:12:51.000000', 'consum', 0.0225, 'lps'),
	(502709, 130, '2014-01-15 01:12:52.000000', 'consum', 0.0211, 'lps'),
	(502710, 130, '2014-01-15 01:12:53.000000', 'consum', 0.0224, 'lps'),
	(502711, 130, '2014-01-15 01:12:54.000000', 'consum', 0.0224, 'lps'),
	(502712, 130, '2014-01-15 01:12:55.000000', 'consum', 0.0224, 'lps'),
	(502713, 130, '2014-01-15 01:12:56.000000', 'consum', 0.0220, 'lps'),
	(502714, 130, '2014-01-15 01:12:57.000000', 'consum', 0.0217, 'lps'),
	(502715, 130, '2014-01-15 01:12:58.000000', 'consum', 0.0218, 'lps'),
	(502716, 130, '2014-01-15 01:12:59.000000', 'consum', 0.0213, 'lps'),
	(502717, 130, '2014-01-15 01:13:00.000000', 'consum', 0.0219, 'lps'),
	(502718, 130, '2014-01-15 01:13:01.000000', 'consum', 0.0213, 'lps'),
	(502719, 130, '2014-01-15 01:13:02.000000', 'consum', 0.0214, 'lps'),
	(502720, 130, '2014-01-15 01:13:03.000000', 'consum', 0.0220, 'lps'),
	(502721, 130, '2014-01-15 01:13:04.000000', 'consum', 0.0215, 'lps'),
	(502722, 130, '2014-01-15 01:13:05.000000', 'consum', 0.0221, 'lps'),
	(502723, 130, '2014-01-15 01:13:06.000000', 'consum', 0.0218, 'lps'),
	(502724, 130, '2014-01-15 01:13:07.000000', 'consum', 0.0217, 'lps'),
	(502725, 130, '2014-01-15 01:13:08.000000', 'consum', 0.0221, 'lps'),
	(502726, 130, '2014-01-15 01:13:09.000000', 'consum', 0.0211, 'lps'),
	(502727, 130, '2014-01-15 01:13:10.000000', 'consum', 0.0216, 'lps'),
	(502728, 130, '2014-01-15 01:13:11.000000', 'consum', 0.0220, 'lps'),
	(502729, 130, '2014-01-15 01:13:12.000000', 'consum', 0.0225, 'lps'),
	(502730, 130, '2014-01-15 01:13:13.000000', 'consum', 0.0221, 'lps'),
	(502731, 130, '2014-01-15 01:13:14.000000', 'consum', 0.0221, 'lps'),
	(502732, 130, '2014-01-15 01:13:15.000000', 'consum', 0.0217, 'lps'),
	(502733, 130, '2014-01-15 01:13:16.000000', 'consum', 0.0213, 'lps'),
	(502734, 130, '2014-01-15 01:13:17.000000', 'consum', 0.0221, 'lps'),
	(502735, 130, '2014-01-15 01:13:18.000000', 'consum', 0.0224, 'lps'),
	(502736, 130, '2014-01-15 01:13:19.000000', 'consum', 0.0211, 'lps'),
	(502737, 130, '2014-01-15 01:13:20.000000', 'consum', 0.0210, 'lps'),
	(502738, 130, '2014-01-15 01:13:21.000000', 'consum', 0.0225, 'lps'),
	(502739, 130, '2014-01-15 01:13:22.000000', 'consum', 0.0215, 'lps'),
	(502740, 130, '2014-01-15 01:13:23.000000', 'consum', 0.0224, 'lps'),
	(502741, 130, '2014-01-15 01:13:24.000000', 'consum', 0.0218, 'lps'),
	(502742, 130, '2014-01-15 01:13:25.000000', 'consum', 0.0222, 'lps'),
	(502743, 130, '2014-01-15 01:13:26.000000', 'consum', 0.0213, 'lps'),
	(502744, 130, '2014-01-15 01:13:27.000000', 'consum', 0.0226, 'lps'),
	(502745, 130, '2014-01-15 01:13:28.000000', 'consum', 0.0211, 'lps'),
	(502746, 130, '2014-01-15 01:13:29.000000', 'consum', 0.0217, 'lps'),
	(502747, 130, '2014-01-15 01:13:30.000000', 'consum', 0.0212, 'lps'),
	(502748, 130, '2014-01-15 01:13:31.000000', 'consum', 0.0216, 'lps'),
	(502749, 130, '2014-01-15 01:13:32.000000', 'consum', 0.0217, 'lps'),
	(502750, 130, '2014-01-15 01:13:33.000000', 'consum', 0.0226, 'lps'),
	(502751, 130, '2014-01-15 01:13:34.000000', 'consum', 0.0220, 'lps'),
	(502752, 130, '2014-01-15 01:13:35.000000', 'consum', 0.0210, 'lps'),
	(502753, 130, '2014-01-15 01:13:36.000000', 'consum', 0.0217, 'lps'),
	(502754, 130, '2014-01-15 01:13:37.000000', 'consum', 0.0210, 'lps'),
	(502755, 130, '2014-01-15 01:13:38.000000', 'consum', 0.0222, 'lps'),
	(502756, 130, '2014-01-15 01:13:39.000000', 'consum', 0.0223, 'lps'),
	(502757, 130, '2014-01-15 01:13:40.000000', 'consum', 0.0220, 'lps'),
	(502758, 130, '2014-01-15 01:13:41.000000', 'consum', 0.0224, 'lps'),
	(502759, 130, '2014-01-15 01:13:42.000000', 'consum', 0.0216, 'lps'),
	(502760, 130, '2014-01-15 01:13:43.000000', 'consum', 0.0217, 'lps'),
	(502761, 130, '2014-01-15 01:13:44.000000', 'consum', 0.0210, 'lps'),
	(502762, 130, '2014-01-15 01:13:45.000000', 'consum', 0.0222, 'lps'),
	(502763, 130, '2014-01-15 01:13:46.000000', 'consum', 0.0219, 'lps'),
	(502764, 130, '2014-01-15 01:13:47.000000', 'consum', 0.0218, 'lps'),
	(502765, 130, '2014-01-15 01:13:48.000000', 'consum', 0.0210, 'lps'),
	(502766, 130, '2014-01-15 01:13:49.000000', 'consum', 0.0219, 'lps'),
	(502767, 130, '2014-01-15 01:13:50.000000', 'consum', 0.0221, 'lps'),
	(502768, 130, '2014-01-15 01:13:51.000000', 'consum', 0.0222, 'lps'),
	(502769, 130, '2014-01-15 01:13:52.000000', 'consum', 0.0221, 'lps'),
	(502770, 130, '2014-01-15 01:13:53.000000', 'consum', 0.0214, 'lps'),
	(502771, 130, '2014-01-15 01:13:54.000000', 'consum', 0.0213, 'lps'),
	(502772, 130, '2014-01-15 01:13:55.000000', 'consum', 0.0212, 'lps'),
	(502773, 130, '2014-01-15 01:13:56.000000', 'consum', 0.0213, 'lps'),
	(502774, 130, '2014-01-15 01:13:57.000000', 'consum', 0.0221, 'lps'),
	(502775, 130, '2014-01-15 01:13:58.000000', 'consum', 0.0222, 'lps'),
	(502776, 130, '2014-01-15 01:13:59.000000', 'consum', 0.0219, 'lps'),
	(502777, 130, '2014-01-15 01:14:00.000000', 'consum', 0.0219, 'lps'),
	(502778, 130, '2014-01-15 01:14:01.000000', 'consum', 0.0211, 'lps'),
	(502779, 130, '2014-01-15 01:14:02.000000', 'consum', 0.0224, 'lps'),
	(502780, 130, '2014-01-15 01:14:03.000000', 'consum', 0.0210, 'lps'),
	(502781, 130, '2014-01-15 01:14:04.000000', 'consum', 0.0221, 'lps'),
	(502782, 130, '2014-01-15 01:14:05.000000', 'consum', 0.0212, 'lps'),
	(502783, 130, '2014-01-15 01:14:06.000000', 'consum', 0.0221, 'lps'),
	(502784, 130, '2014-01-15 01:14:07.000000', 'consum', 0.0225, 'lps'),
	(502785, 130, '2014-01-15 01:14:08.000000', 'consum', 0.0218, 'lps'),
	(502786, 130, '2014-01-15 01:14:09.000000', 'consum', 0.0226, 'lps'),
	(502787, 130, '2014-01-15 01:14:10.000000', 'consum', 0.0212, 'lps'),
	(502788, 130, '2014-01-15 01:14:11.000000', 'consum', 0.0223, 'lps'),
	(502789, 130, '2014-01-15 01:14:12.000000', 'consum', 0.0222, 'lps'),
	(502790, 130, '2014-01-15 01:14:13.000000', 'consum', 0.0212, 'lps'),
	(502791, 130, '2014-01-15 01:14:14.000000', 'consum', 0.0217, 'lps'),
	(502792, 130, '2014-01-15 01:14:15.000000', 'consum', 0.0225, 'lps'),
	(502793, 130, '2014-01-15 01:14:16.000000', 'consum', 0.0213, 'lps'),
	(502794, 130, '2014-01-15 01:14:17.000000', 'consum', 0.0213, 'lps'),
	(502795, 130, '2014-01-15 01:14:18.000000', 'consum', 0.0217, 'lps'),
	(502796, 130, '2014-01-15 01:14:19.000000', 'consum', 0.0221, 'lps'),
	(502797, 130, '2014-01-15 01:14:20.000000', 'consum', 0.0225, 'lps'),
	(502798, 130, '2014-01-15 01:14:21.000000', 'consum', 0.0222, 'lps'),
	(502799, 130, '2014-01-15 01:14:22.000000', 'consum', 0.0223, 'lps'),
	(502800, 130, '2014-01-15 01:14:23.000000', 'consum', 0.0222, 'lps'),
	(502801, 130, '2014-01-15 01:14:24.000000', 'consum', 0.0214, 'lps'),
	(502802, 130, '2014-01-15 01:14:25.000000', 'consum', 0.0211, 'lps'),
	(502803, 130, '2014-01-15 01:14:26.000000', 'consum', 0.0221, 'lps'),
	(502804, 130, '2014-01-15 01:14:27.000000', 'consum', 0.0212, 'lps'),
	(502805, 130, '2014-01-15 01:14:28.000000', 'consum', 0.0221, 'lps'),
	(502806, 130, '2014-01-15 01:14:29.000000', 'consum', 0.0224, 'lps'),
	(502807, 130, '2014-01-15 01:14:30.000000', 'consum', 0.0214, 'lps'),
	(502808, 130, '2014-01-15 01:14:31.000000', 'consum', 0.0221, 'lps'),
	(502809, 130, '2014-01-15 01:14:32.000000', 'consum', 0.0223, 'lps'),
	(502810, 130, '2014-01-15 01:14:33.000000', 'consum', 0.0223, 'lps'),
	(502811, 130, '2014-01-15 01:14:34.000000', 'consum', 0.0222, 'lps'),
	(502812, 130, '2014-01-15 01:14:35.000000', 'consum', 0.0214, 'lps'),
	(502813, 130, '2014-01-15 01:14:36.000000', 'consum', 0.0226, 'lps'),
	(502814, 130, '2014-01-15 01:14:37.000000', 'consum', 0.0211, 'lps'),
	(502815, 130, '2014-01-15 01:14:38.000000', 'consum', 0.0220, 'lps'),
	(502816, 130, '2014-01-15 01:14:39.000000', 'consum', 0.0222, 'lps'),
	(502817, 130, '2014-01-15 01:14:40.000000', 'consum', 0.0226, 'lps'),
	(502818, 130, '2014-01-15 01:14:41.000000', 'consum', 0.0218, 'lps'),
	(502819, 130, '2014-01-15 01:14:42.000000', 'consum', 0.0219, 'lps'),
	(502820, 130, '2014-01-15 01:14:43.000000', 'consum', 0.0217, 'lps'),
	(502821, 130, '2014-01-15 01:14:44.000000', 'consum', 0.0216, 'lps'),
	(502822, 130, '2014-01-15 01:14:45.000000', 'consum', 0.0220, 'lps'),
	(502823, 130, '2014-01-15 01:14:46.000000', 'consum', 0.0210, 'lps'),
	(502824, 130, '2014-01-15 01:14:47.000000', 'consum', 0.0212, 'lps'),
	(502825, 130, '2014-01-15 01:14:48.000000', 'consum', 0.0223, 'lps'),
	(502826, 130, '2014-01-15 01:14:49.000000', 'consum', 0.0219, 'lps'),
	(502827, 130, '2014-01-15 01:14:50.000000', 'consum', 0.0216, 'lps'),
	(502828, 130, '2014-01-15 01:14:51.000000', 'consum', 0.0213, 'lps'),
	(502829, 130, '2014-01-15 01:14:52.000000', 'consum', 0.0226, 'lps'),
	(502830, 130, '2014-01-15 01:14:53.000000', 'consum', 0.0213, 'lps'),
	(502831, 130, '2014-01-15 01:14:54.000000', 'consum', 0.0213, 'lps'),
	(502832, 130, '2014-01-15 01:14:55.000000', 'consum', 0.0215, 'lps'),
	(502833, 130, '2014-01-15 01:14:56.000000', 'consum', 0.0211, 'lps'),
	(502834, 130, '2014-01-15 01:14:57.000000', 'consum', 0.0215, 'lps'),
	(502835, 130, '2014-01-15 01:14:58.000000', 'consum', 0.0214, 'lps'),
	(502836, 130, '2014-01-15 01:14:59.000000', 'consum', 0.0219, 'lps'),
	(502837, 130, '2014-01-15 01:15:00.000000', 'consum', 0.0210, 'lps'),
	(502838, 130, '2014-01-15 01:15:01.000000', 'consum', 0.0215, 'lps'),
	(502839, 130, '2014-01-15 01:15:02.000000', 'consum', 0.0219, 'lps'),
	(502840, 130, '2014-01-15 01:15:03.000000', 'consum', 0.0224, 'lps'),
	(502841, 130, '2014-01-15 01:15:04.000000', 'consum', 0.0220, 'lps'),
	(502842, 130, '2014-01-15 01:15:05.000000', 'consum', 0.0217, 'lps'),
	(502843, 130, '2014-01-15 01:15:06.000000', 'consum', 0.0216, 'lps'),
	(502844, 130, '2014-01-15 01:15:07.000000', 'consum', 0.0220, 'lps'),
	(502845, 130, '2014-01-15 01:15:08.000000', 'consum', 0.0210, 'lps'),
	(502846, 130, '2014-01-15 01:15:09.000000', 'consum', 0.0213, 'lps'),
	(502847, 130, '2014-01-15 01:15:10.000000', 'consum', 0.0225, 'lps'),
	(502848, 130, '2014-01-15 01:15:11.000000', 'consum', 0.0225, 'lps'),
	(502849, 130, '2014-01-15 01:15:12.000000', 'consum', 0.0224, 'lps'),
	(502850, 130, '2014-01-15 01:15:13.000000', 'consum', 0.0220, 'lps'),
	(502851, 130, '2014-01-15 01:15:14.000000', 'consum', 0.0216, 'lps'),
	(502852, 130, '2014-01-15 01:15:15.000000', 'consum', 0.0211, 'lps'),
	(502853, 130, '2014-01-15 01:15:16.000000', 'consum', 0.0215, 'lps'),
	(502854, 130, '2014-01-15 01:15:17.000000', 'consum', 0.0216, 'lps'),
	(502855, 130, '2014-01-15 01:15:18.000000', 'consum', 0.0226, 'lps'),
	(502856, 130, '2014-01-15 01:15:19.000000', 'consum', 0.0222, 'lps'),
	(502857, 130, '2014-01-15 01:15:20.000000', 'consum', 0.0223, 'lps'),
	(502858, 130, '2014-01-15 01:15:21.000000', 'consum', 0.0223, 'lps'),
	(502859, 130, '2014-01-15 01:15:22.000000', 'consum', 0.0218, 'lps'),
	(502860, 130, '2014-01-15 01:15:23.000000', 'consum', 0.0214, 'lps'),
	(502861, 130, '2014-01-15 01:15:24.000000', 'consum', 0.0220, 'lps'),
	(502862, 130, '2014-01-15 01:15:25.000000', 'consum', 0.0216, 'lps'),
	(502863, 130, '2014-01-15 01:15:26.000000', 'consum', 0.0211, 'lps'),
	(502864, 130, '2014-01-15 01:15:27.000000', 'consum', 0.0214, 'lps'),
	(502865, 130, '2014-01-15 01:15:28.000000', 'consum', 0.0210, 'lps'),
	(502866, 130, '2014-01-15 01:15:29.000000', 'consum', 0.0217, 'lps'),
	(502867, 130, '2014-01-15 01:15:30.000000', 'consum', 0.0226, 'lps'),
	(502868, 130, '2014-01-15 01:15:31.000000', 'consum', 0.0220, 'lps'),
	(502869, 130, '2014-01-15 01:15:32.000000', 'consum', 0.0212, 'lps'),
	(502870, 130, '2014-01-15 01:15:33.000000', 'consum', 0.0224, 'lps'),
	(502871, 130, '2014-01-15 01:15:34.000000', 'consum', 0.0223, 'lps'),
	(502872, 130, '2014-01-15 01:15:35.000000', 'consum', 0.0219, 'lps'),
	(502873, 130, '2014-01-15 01:15:36.000000', 'consum', 0.0216, 'lps'),
	(502874, 130, '2014-01-15 01:15:37.000000', 'consum', 0.0214, 'lps'),
	(502875, 130, '2014-01-15 01:15:38.000000', 'consum', 0.0212, 'lps'),
	(502876, 130, '2014-01-15 01:15:39.000000', 'consum', 0.0210, 'lps'),
	(502877, 130, '2014-01-15 01:15:40.000000', 'consum', 0.0220, 'lps'),
	(502878, 130, '2014-01-15 01:15:41.000000', 'consum', 0.0210, 'lps'),
	(502879, 130, '2014-01-15 01:15:42.000000', 'consum', 0.0215, 'lps'),
	(502880, 130, '2014-01-15 01:15:43.000000', 'consum', 0.0218, 'lps'),
	(502881, 130, '2014-01-15 01:15:44.000000', 'consum', 0.0218, 'lps'),
	(502882, 130, '2014-01-15 01:15:45.000000', 'consum', 0.0210, 'lps'),
	(502883, 130, '2014-01-15 01:15:46.000000', 'consum', 0.0221, 'lps'),
	(502884, 130, '2014-01-15 01:15:47.000000', 'consum', 0.0213, 'lps'),
	(502885, 130, '2014-01-15 01:15:48.000000', 'consum', 0.0210, 'lps'),
	(502886, 130, '2014-01-15 01:15:49.000000', 'consum', 0.0217, 'lps'),
	(502887, 130, '2014-01-15 01:15:50.000000', 'consum', 0.0214, 'lps'),
	(502888, 130, '2014-01-15 01:15:51.000000', 'consum', 0.0224, 'lps'),
	(502889, 130, '2014-01-15 01:15:52.000000', 'consum', 0.0220, 'lps'),
	(502890, 130, '2014-01-15 01:15:53.000000', 'consum', 0.0216, 'lps'),
	(502891, 130, '2014-01-15 01:15:54.000000', 'consum', 0.0213, 'lps'),
	(502892, 130, '2014-01-15 01:15:55.000000', 'consum', 0.0224, 'lps'),
	(502893, 130, '2014-01-15 01:15:56.000000', 'consum', 0.0219, 'lps'),
	(502894, 130, '2014-01-15 01:15:57.000000', 'consum', 0.0214, 'lps'),
	(502895, 130, '2014-01-15 01:15:58.000000', 'consum', 0.0220, 'lps'),
	(502896, 130, '2014-01-15 01:15:59.000000', 'consum', 0.0216, 'lps'),
	(502897, 130, '2014-01-15 01:16:00.000000', 'consum', 0.0212, 'lps'),
	(502898, 130, '2014-01-15 01:16:01.000000', 'consum', 0.0217, 'lps'),
	(502899, 130, '2014-01-15 01:16:02.000000', 'consum', 0.0224, 'lps'),
	(502900, 130, '2014-01-15 01:16:03.000000', 'consum', 0.0225, 'lps'),
	(502901, 130, '2014-01-15 01:16:04.000000', 'consum', 0.0210, 'lps'),
	(502902, 130, '2014-01-15 01:16:05.000000', 'consum', 0.0214, 'lps'),
	(502903, 130, '2014-01-15 01:16:06.000000', 'consum', 0.0216, 'lps'),
	(502904, 130, '2014-01-15 01:16:07.000000', 'consum', 0.0212, 'lps'),
	(502905, 130, '2014-01-15 01:16:08.000000', 'consum', 0.0217, 'lps'),
	(502906, 130, '2014-01-15 01:16:09.000000', 'consum', 0.0225, 'lps'),
	(502907, 130, '2014-01-15 01:16:10.000000', 'consum', 0.0214, 'lps'),
	(502908, 130, '2014-01-15 01:16:11.000000', 'consum', 0.0219, 'lps'),
	(502909, 130, '2014-01-15 01:16:12.000000', 'consum', 0.0225, 'lps'),
	(502910, 130, '2014-01-15 01:16:13.000000', 'consum', 0.0226, 'lps'),
	(502911, 130, '2014-01-15 01:16:14.000000', 'consum', 0.0211, 'lps'),
	(502912, 130, '2014-01-15 01:16:15.000000', 'consum', 0.0219, 'lps'),
	(502913, 130, '2014-01-15 01:16:16.000000', 'consum', 0.0218, 'lps'),
	(502914, 130, '2014-01-15 01:16:17.000000', 'consum', 0.0224, 'lps'),
	(502915, 130, '2014-01-15 01:16:18.000000', 'consum', 0.0223, 'lps'),
	(502916, 130, '2014-01-15 01:16:19.000000', 'consum', 0.0216, 'lps'),
	(502917, 130, '2014-01-15 01:16:20.000000', 'consum', 0.0220, 'lps'),
	(502918, 130, '2014-01-15 01:16:21.000000', 'consum', 0.0224, 'lps'),
	(502919, 130, '2014-01-15 01:16:22.000000', 'consum', 0.0219, 'lps'),
	(502920, 130, '2014-01-15 01:16:23.000000', 'consum', 0.0211, 'lps'),
	(502921, 130, '2014-01-15 01:16:24.000000', 'consum', 0.0222, 'lps'),
	(502922, 130, '2014-01-15 01:16:25.000000', 'consum', 0.0219, 'lps'),
	(502923, 130, '2014-01-15 01:16:26.000000', 'consum', 0.0220, 'lps'),
	(502924, 130, '2014-01-15 01:16:27.000000', 'consum', 0.0213, 'lps'),
	(502925, 130, '2014-01-15 01:16:28.000000', 'consum', 0.0216, 'lps'),
	(502926, 130, '2014-01-15 01:16:29.000000', 'consum', 0.0212, 'lps'),
	(502927, 130, '2014-01-15 01:16:30.000000', 'consum', 0.0219, 'lps'),
	(502928, 130, '2014-01-15 01:16:31.000000', 'consum', 0.0215, 'lps'),
	(502929, 130, '2014-01-15 01:16:32.000000', 'consum', 0.0226, 'lps'),
	(502930, 130, '2014-01-15 01:16:33.000000', 'consum', 0.0223, 'lps'),
	(502931, 130, '2014-01-15 01:16:34.000000', 'consum', 0.0211, 'lps'),
	(502932, 130, '2014-01-15 01:16:35.000000', 'consum', 0.0212, 'lps'),
	(502933, 130, '2014-01-15 01:16:36.000000', 'consum', 0.0216, 'lps'),
	(502934, 130, '2014-01-15 01:16:37.000000', 'consum', 0.0219, 'lps'),
	(502935, 130, '2014-01-15 01:16:38.000000', 'consum', 0.0219, 'lps'),
	(502936, 130, '2014-01-15 01:16:39.000000', 'consum', 0.0211, 'lps'),
	(502937, 130, '2014-01-15 01:16:40.000000', 'consum', 0.0223, 'lps'),
	(502938, 130, '2014-01-15 01:16:41.000000', 'consum', 0.0221, 'lps'),
	(502939, 130, '2014-01-15 01:16:42.000000', 'consum', 0.0210, 'lps'),
	(502940, 130, '2014-01-15 01:16:43.000000', 'consum', 0.0213, 'lps'),
	(502941, 130, '2014-01-15 01:16:44.000000', 'consum', 0.0226, 'lps'),
	(502942, 130, '2014-01-15 01:16:45.000000', 'consum', 0.0214, 'lps'),
	(502943, 130, '2014-01-15 01:16:46.000000', 'consum', 0.0215, 'lps'),
	(502944, 130, '2014-01-15 01:16:47.000000', 'consum', 0.0223, 'lps'),
	(502945, 130, '2014-01-15 01:16:48.000000', 'consum', 0.0212, 'lps'),
	(502946, 130, '2014-01-15 01:16:49.000000', 'consum', 0.0214, 'lps'),
	(502947, 130, '2014-01-15 01:16:50.000000', 'consum', 0.0222, 'lps'),
	(502948, 130, '2014-01-15 01:16:51.000000', 'consum', 0.0211, 'lps'),
	(502949, 130, '2014-01-15 01:16:52.000000', 'consum', 0.0213, 'lps'),
	(502950, 130, '2014-01-15 01:16:53.000000', 'consum', 0.0224, 'lps'),
	(502951, 130, '2014-01-15 01:16:54.000000', 'consum', 0.0219, 'lps'),
	(502952, 130, '2014-01-15 01:16:55.000000', 'consum', 0.0213, 'lps'),
	(502953, 130, '2014-01-15 01:16:56.000000', 'consum', 0.0217, 'lps'),
	(502954, 130, '2014-01-15 01:16:57.000000', 'consum', 0.0219, 'lps'),
	(502955, 130, '2014-01-15 01:16:58.000000', 'consum', 0.0216, 'lps'),
	(502956, 130, '2014-01-15 01:16:59.000000', 'consum', 0.0216, 'lps'),
	(502957, 130, '2014-01-15 01:17:00.000000', 'consum', 0.0220, 'lps'),
	(502958, 130, '2014-01-15 01:17:01.000000', 'consum', 0.0225, 'lps'),
	(502959, 130, '2014-01-15 01:17:02.000000', 'consum', 0.0224, 'lps'),
	(502960, 130, '2014-01-15 01:17:03.000000', 'consum', 0.0216, 'lps'),
	(502961, 130, '2014-01-15 01:17:04.000000', 'consum', 0.0215, 'lps'),
	(502962, 130, '2014-01-15 01:17:05.000000', 'consum', 0.0220, 'lps'),
	(502963, 130, '2014-01-15 01:17:06.000000', 'consum', 0.0226, 'lps'),
	(502964, 130, '2014-01-15 01:17:07.000000', 'consum', 0.0226, 'lps'),
	(502965, 130, '2014-01-15 01:17:08.000000', 'consum', 0.0226, 'lps'),
	(502966, 130, '2014-01-15 01:17:09.000000', 'consum', 0.0224, 'lps'),
	(502967, 130, '2014-01-15 01:17:10.000000', 'consum', 0.0216, 'lps'),
	(502968, 130, '2014-01-15 01:17:11.000000', 'consum', 0.0216, 'lps'),
	(502969, 130, '2014-01-15 01:17:12.000000', 'consum', 0.0223, 'lps'),
	(502970, 130, '2014-01-15 01:17:13.000000', 'consum', 0.0224, 'lps'),
	(502971, 130, '2014-01-15 01:17:14.000000', 'consum', 0.0226, 'lps'),
	(502972, 130, '2014-01-15 01:17:15.000000', 'consum', 0.0212, 'lps'),
	(502973, 130, '2014-01-15 01:17:16.000000', 'consum', 0.0223, 'lps'),
	(502974, 130, '2014-01-15 01:17:17.000000', 'consum', 0.0218, 'lps'),
	(502975, 130, '2014-01-15 01:17:18.000000', 'consum', 0.0213, 'lps'),
	(502976, 130, '2014-01-15 01:17:19.000000', 'consum', 0.0218, 'lps'),
	(502977, 130, '2014-01-15 01:17:20.000000', 'consum', 0.0223, 'lps'),
	(502978, 130, '2014-01-15 01:17:21.000000', 'consum', 0.0219, 'lps'),
	(502979, 130, '2014-01-15 01:17:22.000000', 'consum', 0.0215, 'lps'),
	(502980, 130, '2014-01-15 01:17:23.000000', 'consum', 0.0210, 'lps'),
	(502981, 130, '2014-01-15 01:17:24.000000', 'consum', 0.0213, 'lps'),
	(502982, 130, '2014-01-15 01:17:25.000000', 'consum', 0.0223, 'lps'),
	(502983, 130, '2014-01-15 01:17:26.000000', 'consum', 0.0218, 'lps'),
	(502984, 130, '2014-01-15 01:17:27.000000', 'consum', 0.0212, 'lps'),
	(502985, 130, '2014-01-15 01:17:28.000000', 'consum', 0.0214, 'lps'),
	(502986, 130, '2014-01-15 01:17:29.000000', 'consum', 0.0223, 'lps'),
	(502987, 130, '2014-01-15 01:17:30.000000', 'consum', 0.0213, 'lps'),
	(502988, 130, '2014-01-15 01:17:31.000000', 'consum', 0.0222, 'lps'),
	(502989, 130, '2014-01-15 01:17:32.000000', 'consum', 0.0211, 'lps'),
	(502990, 130, '2014-01-15 01:17:33.000000', 'consum', 0.0211, 'lps'),
	(502991, 130, '2014-01-15 01:17:34.000000', 'consum', 0.0213, 'lps'),
	(502992, 130, '2014-01-15 01:17:35.000000', 'consum', 0.0224, 'lps'),
	(502993, 130, '2014-01-15 01:17:36.000000', 'consum', 0.0219, 'lps'),
	(502994, 130, '2014-01-15 01:17:37.000000', 'consum', 0.0214, 'lps'),
	(502995, 130, '2014-01-15 01:17:38.000000', 'consum', 0.0219, 'lps'),
	(502996, 130, '2014-01-15 01:17:39.000000', 'consum', 0.0211, 'lps'),
	(502997, 130, '2014-01-15 01:17:40.000000', 'consum', 0.0222, 'lps'),
	(502998, 130, '2014-01-15 01:17:41.000000', 'consum', 0.0215, 'lps'),
	(502999, 130, '2014-01-15 01:17:42.000000', 'consum', 0.0218, 'lps'),
	(503000, 130, '2014-01-15 01:17:43.000000', 'consum', 0.0219, 'lps'),
	(503001, 130, '2014-01-15 01:17:44.000000', 'consum', 0.0212, 'lps'),
	(503002, 130, '2014-01-15 01:17:45.000000', 'consum', 0.0214, 'lps'),
	(503003, 130, '2014-01-15 01:17:46.000000', 'consum', 0.0223, 'lps'),
	(503004, 130, '2014-01-15 01:17:47.000000', 'consum', 0.0212, 'lps'),
	(503005, 130, '2014-01-15 01:17:48.000000', 'consum', 0.0216, 'lps'),
	(503006, 130, '2014-01-15 01:17:49.000000', 'consum', 0.0217, 'lps'),
	(503007, 130, '2014-01-15 01:17:50.000000', 'consum', 0.0212, 'lps'),
	(503008, 130, '2014-01-15 01:17:51.000000', 'consum', 0.0216, 'lps'),
	(503009, 130, '2014-01-15 01:17:52.000000', 'consum', 0.0216, 'lps'),
	(503010, 130, '2014-01-15 01:17:53.000000', 'consum', 0.0222, 'lps'),
	(503011, 130, '2014-01-15 01:17:54.000000', 'consum', 0.0221, 'lps'),
	(503012, 130, '2014-01-15 01:17:55.000000', 'consum', 0.0211, 'lps'),
	(503013, 130, '2014-01-15 01:17:56.000000', 'consum', 0.0216, 'lps'),
	(503014, 130, '2014-01-15 01:17:57.000000', 'consum', 0.0221, 'lps'),
	(503015, 130, '2014-01-15 01:17:58.000000', 'consum', 0.0215, 'lps'),
	(503016, 130, '2014-01-15 01:17:59.000000', 'consum', 0.0219, 'lps'),
	(503017, 130, '2014-01-15 01:18:00.000000', 'consum', 0.0221, 'lps'),
	(503018, 130, '2014-01-15 01:18:01.000000', 'consum', 0.0223, 'lps'),
	(503019, 130, '2014-01-15 01:18:02.000000', 'consum', 0.0210, 'lps'),
	(503020, 130, '2014-01-15 01:18:03.000000', 'consum', 0.0223, 'lps'),
	(503021, 130, '2014-01-15 01:18:04.000000', 'consum', 0.0223, 'lps'),
	(503022, 130, '2014-01-15 01:18:05.000000', 'consum', 0.0220, 'lps'),
	(503023, 130, '2014-01-15 01:18:06.000000', 'consum', 0.0221, 'lps'),
	(503024, 130, '2014-01-15 01:18:07.000000', 'consum', 0.0218, 'lps'),
	(503025, 130, '2014-01-15 01:18:08.000000', 'consum', 0.0217, 'lps'),
	(503026, 130, '2014-01-15 01:18:09.000000', 'consum', 0.0223, 'lps'),
	(503027, 130, '2014-01-15 01:18:10.000000', 'consum', 0.0221, 'lps'),
	(503028, 130, '2014-01-15 01:18:11.000000', 'consum', 0.0210, 'lps'),
	(503029, 130, '2014-01-15 01:18:12.000000', 'consum', 0.0226, 'lps'),
	(503030, 130, '2014-01-15 01:18:13.000000', 'consum', 0.0223, 'lps'),
	(503031, 130, '2014-01-15 01:18:14.000000', 'consum', 0.0211, 'lps'),
	(503032, 130, '2014-01-15 01:18:15.000000', 'consum', 0.0211, 'lps'),
	(503033, 130, '2014-01-15 01:18:16.000000', 'consum', 0.0212, 'lps'),
	(503034, 130, '2014-01-15 01:18:17.000000', 'consum', 0.0217, 'lps'),
	(503035, 130, '2014-01-15 01:18:18.000000', 'consum', 0.0223, 'lps'),
	(503036, 130, '2014-01-15 01:18:19.000000', 'consum', 0.0221, 'lps'),
	(503037, 130, '2014-01-15 01:18:20.000000', 'consum', 0.0210, 'lps'),
	(503038, 130, '2014-01-15 01:18:21.000000', 'consum', 0.0211, 'lps'),
	(503039, 130, '2014-01-15 01:18:22.000000', 'consum', 0.0215, 'lps'),
	(503040, 130, '2014-01-15 01:18:23.000000', 'consum', 0.0215, 'lps'),
	(503041, 130, '2014-01-15 01:18:24.000000', 'consum', 0.0219, 'lps'),
	(503042, 130, '2014-01-15 01:18:25.000000', 'consum', 0.0226, 'lps'),
	(503043, 130, '2014-01-15 01:18:26.000000', 'consum', 0.0212, 'lps'),
	(503044, 130, '2014-01-15 01:18:27.000000', 'consum', 0.0225, 'lps'),
	(503045, 130, '2014-01-15 01:18:28.000000', 'consum', 0.0225, 'lps'),
	(503046, 130, '2014-01-15 01:18:29.000000', 'consum', 0.0226, 'lps'),
	(503047, 130, '2014-01-15 01:18:30.000000', 'consum', 0.0211, 'lps'),
	(503048, 130, '2014-01-15 01:18:31.000000', 'consum', 0.0219, 'lps'),
	(503049, 130, '2014-01-15 01:18:32.000000', 'consum', 0.0218, 'lps'),
	(503050, 130, '2014-01-15 01:18:33.000000', 'consum', 0.0223, 'lps'),
	(503051, 130, '2014-01-15 01:18:34.000000', 'consum', 0.0219, 'lps'),
	(503052, 130, '2014-01-15 01:18:35.000000', 'consum', 0.0215, 'lps'),
	(503053, 130, '2014-01-15 01:18:36.000000', 'consum', 0.0210, 'lps'),
	(503054, 130, '2014-01-15 01:18:37.000000', 'consum', 0.0213, 'lps'),
	(503055, 130, '2014-01-15 01:18:38.000000', 'consum', 0.0224, 'lps'),
	(503056, 130, '2014-01-15 01:18:39.000000', 'consum', 0.0221, 'lps'),
	(503057, 130, '2014-01-15 01:18:40.000000', 'consum', 0.0225, 'lps'),
	(503058, 130, '2014-01-15 01:18:41.000000', 'consum', 0.0218, 'lps'),
	(503059, 130, '2014-01-15 01:18:42.000000', 'consum', 0.0222, 'lps'),
	(503060, 130, '2014-01-15 01:18:43.000000', 'consum', 0.0214, 'lps'),
	(503061, 130, '2014-01-15 01:18:44.000000', 'consum', 0.0212, 'lps'),
	(503062, 130, '2014-01-15 01:18:45.000000', 'consum', 0.0225, 'lps'),
	(503063, 130, '2014-01-15 01:18:46.000000', 'consum', 0.0210, 'lps'),
	(503064, 130, '2014-01-15 01:18:47.000000', 'consum', 0.0218, 'lps'),
	(503065, 130, '2014-01-15 01:18:48.000000', 'consum', 0.0217, 'lps'),
	(503066, 130, '2014-01-15 01:18:49.000000', 'consum', 0.0222, 'lps'),
	(503067, 130, '2014-01-15 01:18:50.000000', 'consum', 0.0215, 'lps'),
	(503068, 130, '2014-01-15 01:18:51.000000', 'consum', 0.0216, 'lps'),
	(503069, 130, '2014-01-15 01:18:52.000000', 'consum', 0.0210, 'lps'),
	(503070, 130, '2014-01-15 01:18:53.000000', 'consum', 0.0224, 'lps'),
	(503071, 130, '2014-01-15 01:18:54.000000', 'consum', 0.0214, 'lps'),
	(503072, 130, '2014-01-15 01:18:55.000000', 'consum', 0.0223, 'lps'),
	(503073, 130, '2014-01-15 01:18:56.000000', 'consum', 0.0210, 'lps'),
	(503074, 130, '2014-01-15 01:18:57.000000', 'consum', 0.0224, 'lps'),
	(503075, 130, '2014-01-15 01:18:58.000000', 'consum', 0.0211, 'lps'),
	(503076, 130, '2014-01-15 01:18:59.000000', 'consum', 0.0224, 'lps'),
	(503077, 130, '2014-01-15 01:19:00.000000', 'consum', 0.0211, 'lps'),
	(503078, 130, '2014-01-15 01:19:01.000000', 'consum', 0.0224, 'lps'),
	(503079, 130, '2014-01-15 01:19:02.000000', 'consum', 0.0225, 'lps'),
	(503080, 130, '2014-01-15 01:19:03.000000', 'consum', 0.0212, 'lps'),
	(503081, 130, '2014-01-15 01:19:04.000000', 'consum', 0.0210, 'lps'),
	(503082, 130, '2014-01-15 01:19:05.000000', 'consum', 0.0220, 'lps'),
	(503083, 130, '2014-01-15 01:19:06.000000', 'consum', 0.0210, 'lps'),
	(503084, 130, '2014-01-15 01:19:07.000000', 'consum', 0.0216, 'lps'),
	(503085, 130, '2014-01-15 01:19:08.000000', 'consum', 0.0223, 'lps'),
	(503086, 130, '2014-01-15 01:19:09.000000', 'consum', 0.0224, 'lps'),
	(503087, 130, '2014-01-15 01:19:10.000000', 'consum', 0.0225, 'lps'),
	(503088, 130, '2014-01-15 01:19:11.000000', 'consum', 0.0224, 'lps'),
	(503089, 130, '2014-01-15 01:19:12.000000', 'consum', 0.0218, 'lps'),
	(503090, 130, '2014-01-15 01:19:13.000000', 'consum', 0.0226, 'lps'),
	(503091, 130, '2014-01-15 01:19:14.000000', 'consum', 0.0216, 'lps'),
	(503092, 130, '2014-01-15 01:19:15.000000', 'consum', 0.0226, 'lps'),
	(503093, 130, '2014-01-15 01:19:16.000000', 'consum', 0.0222, 'lps'),
	(503094, 130, '2014-01-15 01:19:17.000000', 'consum', 0.0222, 'lps'),
	(503095, 130, '2014-01-15 01:19:18.000000', 'consum', 0.0217, 'lps'),
	(503096, 130, '2014-01-15 01:19:19.000000', 'consum', 0.0211, 'lps'),
	(503097, 130, '2014-01-15 01:19:20.000000', 'consum', 0.0212, 'lps'),
	(503098, 130, '2014-01-15 01:19:21.000000', 'consum', 0.0215, 'lps'),
	(503099, 130, '2014-01-15 01:19:22.000000', 'consum', 0.0215, 'lps'),
	(503100, 130, '2014-01-15 01:19:23.000000', 'consum', 0.0221, 'lps'),
	(503101, 130, '2014-01-15 01:19:24.000000', 'consum', 0.0215, 'lps'),
	(503102, 130, '2014-01-15 01:19:25.000000', 'consum', 0.0218, 'lps'),
	(503103, 130, '2014-01-15 01:19:26.000000', 'consum', 0.0219, 'lps'),
	(503104, 130, '2014-01-15 01:19:27.000000', 'consum', 0.0216, 'lps'),
	(503105, 130, '2014-01-15 01:19:28.000000', 'consum', 0.0211, 'lps'),
	(503106, 130, '2014-01-15 01:19:29.000000', 'consum', 0.0217, 'lps'),
	(503107, 130, '2014-01-15 01:19:30.000000', 'consum', 0.0226, 'lps'),
	(503108, 130, '2014-01-15 01:19:31.000000', 'consum', 0.0218, 'lps'),
	(503109, 130, '2014-01-15 01:19:32.000000', 'consum', 0.0218, 'lps'),
	(503110, 130, '2014-01-15 01:19:33.000000', 'consum', 0.0225, 'lps'),
	(503111, 130, '2014-01-15 01:19:34.000000', 'consum', 0.0213, 'lps'),
	(503112, 130, '2014-01-15 01:19:35.000000', 'consum', 0.0215, 'lps'),
	(503113, 130, '2014-01-15 01:19:36.000000', 'consum', 0.0224, 'lps'),
	(503114, 130, '2014-01-15 01:19:37.000000', 'consum', 0.0214, 'lps'),
	(503115, 130, '2014-01-15 01:19:38.000000', 'consum', 0.0224, 'lps'),
	(503116, 130, '2014-01-15 01:19:39.000000', 'consum', 0.0216, 'lps'),
	(503117, 130, '2014-01-15 01:19:40.000000', 'consum', 0.0216, 'lps'),
	(503118, 130, '2014-01-15 01:19:41.000000', 'consum', 0.0223, 'lps'),
	(503119, 130, '2014-01-15 01:19:42.000000', 'consum', 0.0223, 'lps'),
	(503120, 130, '2014-01-15 01:19:43.000000', 'consum', 0.0221, 'lps'),
	(503121, 130, '2014-01-15 01:19:44.000000', 'consum', 0.0226, 'lps'),
	(503122, 130, '2014-01-15 01:19:45.000000', 'consum', 0.0225, 'lps'),
	(503123, 130, '2014-01-15 01:19:46.000000', 'consum', 0.0219, 'lps'),
	(503124, 130, '2014-01-15 01:19:47.000000', 'consum', 0.0211, 'lps'),
	(503125, 130, '2014-01-15 01:19:48.000000', 'consum', 0.0221, 'lps'),
	(503126, 130, '2014-01-15 01:19:49.000000', 'consum', 0.0212, 'lps'),
	(503127, 130, '2014-01-15 01:19:50.000000', 'consum', 0.0222, 'lps'),
	(503128, 130, '2014-01-15 01:19:51.000000', 'consum', 0.0211, 'lps'),
	(503129, 130, '2014-01-15 01:19:52.000000', 'consum', 0.0216, 'lps'),
	(503130, 130, '2014-01-15 01:19:53.000000', 'consum', 0.0221, 'lps'),
	(503131, 130, '2014-01-15 01:19:54.000000', 'consum', 0.0214, 'lps'),
	(503132, 130, '2014-01-15 01:19:55.000000', 'consum', 0.0212, 'lps'),
	(503133, 130, '2014-01-15 01:19:56.000000', 'consum', 0.0225, 'lps'),
	(503134, 130, '2014-01-15 01:19:57.000000', 'consum', 0.0211, 'lps'),
	(503135, 130, '2014-01-15 01:19:58.000000', 'consum', 0.0224, 'lps'),
	(503136, 130, '2014-01-15 01:19:59.000000', 'consum', 0.0224, 'lps'),
	(503137, 130, '2014-01-15 01:20:00.000000', 'consum', 0.0225, 'lps'),
	(503138, 130, '2014-01-15 01:20:01.000000', 'consum', 0.0224, 'lps'),
	(503139, 130, '2014-01-15 01:20:02.000000', 'consum', 0.0218, 'lps'),
	(503140, 130, '2014-01-15 01:20:03.000000', 'consum', 0.0224, 'lps'),
	(503141, 130, '2014-01-15 01:20:04.000000', 'consum', 0.0226, 'lps'),
	(503142, 130, '2014-01-15 01:20:05.000000', 'consum', 0.0213, 'lps'),
	(503143, 130, '2014-01-15 01:20:06.000000', 'consum', 0.0214, 'lps'),
	(503144, 130, '2014-01-15 01:20:07.000000', 'consum', 0.0218, 'lps'),
	(503145, 130, '2014-01-15 01:20:08.000000', 'consum', 0.0223, 'lps'),
	(503146, 130, '2014-01-15 01:20:09.000000', 'consum', 0.0216, 'lps'),
	(503147, 130, '2014-01-15 01:20:10.000000', 'consum', 0.0220, 'lps'),
	(503148, 130, '2014-01-15 01:20:11.000000', 'consum', 0.0226, 'lps'),
	(503149, 130, '2014-01-15 01:20:12.000000', 'consum', 0.0226, 'lps'),
	(503150, 130, '2014-01-15 01:20:13.000000', 'consum', 0.0223, 'lps'),
	(503151, 130, '2014-01-15 01:20:14.000000', 'consum', 0.0214, 'lps'),
	(503152, 130, '2014-01-15 01:20:15.000000', 'consum', 0.0224, 'lps'),
	(503153, 130, '2014-01-15 01:20:16.000000', 'consum', 0.0216, 'lps'),
	(503154, 130, '2014-01-15 01:20:17.000000', 'consum', 0.0215, 'lps'),
	(503155, 130, '2014-01-15 01:20:18.000000', 'consum', 0.0219, 'lps'),
	(503156, 130, '2014-01-15 01:20:19.000000', 'consum', 0.0224, 'lps'),
	(503157, 130, '2014-01-15 01:20:20.000000', 'consum', 0.0217, 'lps'),
	(503158, 130, '2014-01-15 01:20:21.000000', 'consum', 0.0223, 'lps'),
	(503159, 130, '2014-01-15 01:20:22.000000', 'consum', 0.0220, 'lps'),
	(503160, 130, '2014-01-15 01:20:23.000000', 'consum', 0.0219, 'lps'),
	(503161, 130, '2014-01-15 01:20:24.000000', 'consum', 0.0211, 'lps'),
	(503162, 130, '2014-01-15 01:20:25.000000', 'consum', 0.0222, 'lps'),
	(503163, 130, '2014-01-15 01:20:26.000000', 'consum', 0.0217, 'lps'),
	(503164, 130, '2014-01-15 01:20:27.000000', 'consum', 0.0226, 'lps'),
	(503165, 130, '2014-01-15 01:20:28.000000', 'consum', 0.0218, 'lps'),
	(503166, 130, '2014-01-15 01:20:29.000000', 'consum', 0.0221, 'lps'),
	(503167, 130, '2014-01-15 01:20:30.000000', 'consum', 0.0223, 'lps'),
	(503168, 130, '2014-01-15 01:20:31.000000', 'consum', 0.0211, 'lps'),
	(503169, 130, '2014-01-15 01:20:32.000000', 'consum', 0.0225, 'lps'),
	(503170, 130, '2014-01-15 01:20:33.000000', 'consum', 0.0214, 'lps'),
	(503171, 130, '2014-01-15 01:20:34.000000', 'consum', 0.0220, 'lps'),
	(503172, 130, '2014-01-15 01:20:35.000000', 'consum', 0.0214, 'lps'),
	(503173, 130, '2014-01-15 01:20:36.000000', 'consum', 0.0218, 'lps'),
	(503174, 130, '2014-01-15 01:20:37.000000', 'consum', 0.0220, 'lps'),
	(503175, 130, '2014-01-15 01:20:38.000000', 'consum', 0.0220, 'lps'),
	(503176, 130, '2014-01-15 01:20:39.000000', 'consum', 0.0216, 'lps'),
	(503177, 130, '2014-01-15 01:20:40.000000', 'consum', 0.0226, 'lps'),
	(503178, 130, '2014-01-15 01:20:41.000000', 'consum', 0.0220, 'lps'),
	(503179, 130, '2014-01-15 01:20:42.000000', 'consum', 0.0212, 'lps'),
	(503180, 130, '2014-01-15 01:20:43.000000', 'consum', 0.0210, 'lps'),
	(503181, 130, '2014-01-15 01:20:44.000000', 'consum', 0.0221, 'lps'),
	(503182, 130, '2014-01-15 01:20:45.000000', 'consum', 0.0213, 'lps'),
	(503183, 130, '2014-01-15 01:20:46.000000', 'consum', 0.0212, 'lps'),
	(503184, 130, '2014-01-15 01:20:47.000000', 'consum', 0.0225, 'lps'),
	(503185, 130, '2014-01-15 01:20:48.000000', 'consum', 0.0215, 'lps'),
	(503186, 130, '2014-01-15 01:20:49.000000', 'consum', 0.0224, 'lps'),
	(503187, 130, '2014-01-15 01:20:50.000000', 'consum', 0.0215, 'lps'),
	(503188, 130, '2014-01-15 01:20:51.000000', 'consum', 0.0225, 'lps'),
	(503189, 130, '2014-01-15 01:20:52.000000', 'consum', 0.0221, 'lps'),
	(503190, 130, '2014-01-15 01:20:53.000000', 'consum', 0.0219, 'lps'),
	(503191, 130, '2014-01-15 01:20:54.000000', 'consum', 0.0222, 'lps'),
	(503192, 130, '2014-01-15 01:20:55.000000', 'consum', 0.0212, 'lps'),
	(503193, 130, '2014-01-15 01:20:56.000000', 'consum', 0.0217, 'lps'),
	(503194, 130, '2014-01-15 01:20:57.000000', 'consum', 0.0222, 'lps'),
	(503195, 130, '2014-01-15 01:20:58.000000', 'consum', 0.0215, 'lps'),
	(503196, 130, '2014-01-15 01:20:59.000000', 'consum', 0.0218, 'lps'),
	(503197, 130, '2014-01-15 01:21:00.000000', 'consum', 0.0220, 'lps'),
	(503198, 130, '2014-01-15 01:21:01.000000', 'consum', 0.0217, 'lps'),
	(503199, 130, '2014-01-15 01:21:02.000000', 'consum', 0.0217, 'lps'),
	(503200, 130, '2014-01-15 01:21:03.000000', 'consum', 0.0226, 'lps'),
	(503201, 130, '2014-01-15 01:21:04.000000', 'consum', 0.0217, 'lps'),
	(503202, 130, '2014-01-15 01:21:05.000000', 'consum', 0.0216, 'lps'),
	(503203, 130, '2014-01-15 01:21:06.000000', 'consum', 0.0218, 'lps'),
	(503204, 130, '2014-01-15 01:21:07.000000', 'consum', 0.0217, 'lps'),
	(503205, 130, '2014-01-15 01:21:08.000000', 'consum', 0.0221, 'lps'),
	(503206, 130, '2014-01-15 01:21:09.000000', 'consum', 0.0212, 'lps'),
	(503207, 130, '2014-01-15 01:21:10.000000', 'consum', 0.0221, 'lps'),
	(503208, 130, '2014-01-15 01:21:11.000000', 'consum', 0.0224, 'lps'),
	(503209, 130, '2014-01-15 01:21:12.000000', 'consum', 0.0216, 'lps'),
	(503210, 130, '2014-01-15 01:21:13.000000', 'consum', 0.0214, 'lps'),
	(503211, 130, '2014-01-15 01:21:14.000000', 'consum', 0.0212, 'lps'),
	(503212, 130, '2014-01-15 01:21:15.000000', 'consum', 0.0211, 'lps'),
	(503213, 130, '2014-01-15 01:21:16.000000', 'consum', 0.0225, 'lps'),
	(503214, 130, '2014-01-15 01:21:17.000000', 'consum', 0.0216, 'lps'),
	(503215, 130, '2014-01-15 01:21:18.000000', 'consum', 0.0210, 'lps'),
	(503216, 130, '2014-01-15 01:21:19.000000', 'consum', 0.0212, 'lps'),
	(503217, 130, '2014-01-15 01:21:20.000000', 'consum', 0.0220, 'lps'),
	(503218, 130, '2014-01-15 01:21:21.000000', 'consum', 0.0222, 'lps'),
	(503219, 130, '2014-01-15 01:21:22.000000', 'consum', 0.0223, 'lps'),
	(503220, 130, '2014-01-15 01:21:23.000000', 'consum', 0.0221, 'lps'),
	(503221, 130, '2014-01-15 01:21:24.000000', 'consum', 0.0211, 'lps'),
	(503222, 130, '2014-01-15 01:21:25.000000', 'consum', 0.0217, 'lps'),
	(503223, 130, '2014-01-15 01:21:26.000000', 'consum', 0.0225, 'lps'),
	(503224, 130, '2014-01-15 01:21:27.000000', 'consum', 0.0213, 'lps'),
	(503225, 130, '2014-01-15 01:21:28.000000', 'consum', 0.0217, 'lps'),
	(503226, 130, '2014-01-15 01:21:29.000000', 'consum', 0.0217, 'lps'),
	(503227, 130, '2014-01-15 01:21:30.000000', 'consum', 0.0225, 'lps'),
	(503228, 130, '2014-01-15 01:21:31.000000', 'consum', 0.0213, 'lps'),
	(503229, 130, '2014-01-15 01:21:32.000000', 'consum', 0.0213, 'lps'),
	(503230, 130, '2014-01-15 01:21:33.000000', 'consum', 0.0218, 'lps'),
	(503231, 130, '2014-01-15 01:21:34.000000', 'consum', 0.0223, 'lps'),
	(503232, 130, '2014-01-15 01:21:35.000000', 'consum', 0.0217, 'lps'),
	(503233, 130, '2014-01-15 01:21:36.000000', 'consum', 0.0224, 'lps'),
	(503234, 130, '2014-01-15 01:21:37.000000', 'consum', 0.0211, 'lps'),
	(503235, 130, '2014-01-15 01:21:38.000000', 'consum', 0.0222, 'lps'),
	(503236, 130, '2014-01-15 01:21:39.000000', 'consum', 0.0216, 'lps'),
	(503237, 130, '2014-01-15 01:21:40.000000', 'consum', 0.0221, 'lps'),
	(503238, 130, '2014-01-15 01:21:41.000000', 'consum', 0.0215, 'lps'),
	(503239, 130, '2014-01-15 01:21:42.000000', 'consum', 0.0217, 'lps'),
	(503240, 130, '2014-01-15 01:21:43.000000', 'consum', 0.0217, 'lps'),
	(503241, 130, '2014-01-15 01:21:44.000000', 'consum', 0.0223, 'lps'),
	(503242, 130, '2014-01-15 01:21:45.000000', 'consum', 0.0219, 'lps'),
	(503243, 130, '2014-01-15 01:21:46.000000', 'consum', 0.0220, 'lps'),
	(503244, 130, '2014-01-15 01:21:47.000000', 'consum', 0.0213, 'lps'),
	(503245, 130, '2014-01-15 01:21:48.000000', 'consum', 0.0213, 'lps'),
	(503246, 130, '2014-01-15 01:21:49.000000', 'consum', 0.0217, 'lps'),
	(503247, 130, '2014-01-15 01:21:50.000000', 'consum', 0.0221, 'lps'),
	(503248, 130, '2014-01-15 01:21:51.000000', 'consum', 0.0210, 'lps'),
	(503249, 130, '2014-01-15 01:21:52.000000', 'consum', 0.0226, 'lps'),
	(503250, 130, '2014-01-15 01:21:53.000000', 'consum', 0.0225, 'lps'),
	(503251, 130, '2014-01-15 01:21:54.000000', 'consum', 0.0221, 'lps'),
	(503252, 130, '2014-01-15 01:21:55.000000', 'consum', 0.0222, 'lps'),
	(503253, 130, '2014-01-15 01:21:56.000000', 'consum', 0.0217, 'lps'),
	(503254, 130, '2014-01-15 01:21:57.000000', 'consum', 0.0210, 'lps'),
	(503255, 130, '2014-01-15 01:21:58.000000', 'consum', 0.0225, 'lps'),
	(503256, 130, '2014-01-15 01:21:59.000000', 'consum', 0.0218, 'lps'),
	(503257, 130, '2014-01-15 01:22:00.000000', 'consum', 0.0220, 'lps'),
	(503258, 130, '2014-01-15 01:22:01.000000', 'consum', 0.0220, 'lps'),
	(503259, 130, '2014-01-15 01:22:02.000000', 'consum', 0.0215, 'lps'),
	(503260, 130, '2014-01-15 01:22:03.000000', 'consum', 0.0221, 'lps'),
	(503261, 130, '2014-01-15 01:22:04.000000', 'consum', 0.0219, 'lps'),
	(503262, 130, '2014-01-15 01:22:05.000000', 'consum', 0.0222, 'lps'),
	(503263, 130, '2014-01-15 01:22:06.000000', 'consum', 0.0224, 'lps'),
	(503264, 130, '2014-01-15 01:22:07.000000', 'consum', 0.0214, 'lps'),
	(503265, 130, '2014-01-15 01:22:08.000000', 'consum', 0.0220, 'lps'),
	(503266, 130, '2014-01-15 01:22:09.000000', 'consum', 0.0215, 'lps'),
	(503267, 130, '2014-01-15 01:22:10.000000', 'consum', 0.0224, 'lps'),
	(503268, 130, '2014-01-15 01:22:11.000000', 'consum', 0.0214, 'lps'),
	(503269, 130, '2014-01-15 01:22:12.000000', 'consum', 0.0221, 'lps'),
	(503270, 130, '2014-01-15 01:22:13.000000', 'consum', 0.0220, 'lps'),
	(503271, 130, '2014-01-15 01:22:14.000000', 'consum', 0.0226, 'lps'),
	(503272, 130, '2014-01-15 01:22:15.000000', 'consum', 0.0212, 'lps'),
	(503273, 130, '2014-01-15 01:22:16.000000', 'consum', 0.0223, 'lps'),
	(503274, 130, '2014-01-15 01:22:17.000000', 'consum', 0.0217, 'lps'),
	(503275, 130, '2014-01-15 01:22:18.000000', 'consum', 0.0223, 'lps'),
	(503276, 130, '2014-01-15 01:22:19.000000', 'consum', 0.0219, 'lps'),
	(503277, 130, '2014-01-15 01:22:20.000000', 'consum', 0.0220, 'lps'),
	(503278, 130, '2014-01-15 01:22:21.000000', 'consum', 0.0215, 'lps'),
	(503279, 130, '2014-01-15 01:22:22.000000', 'consum', 0.0224, 'lps'),
	(503280, 130, '2014-01-15 01:22:23.000000', 'consum', 0.0213, 'lps'),
	(503281, 130, '2014-01-15 01:22:24.000000', 'consum', 0.0219, 'lps'),
	(503282, 130, '2014-01-15 01:22:25.000000', 'consum', 0.0213, 'lps'),
	(503283, 130, '2014-01-15 01:22:26.000000', 'consum', 0.0217, 'lps'),
	(503284, 130, '2014-01-15 01:22:27.000000', 'consum', 0.0217, 'lps'),
	(503285, 130, '2014-01-15 01:22:28.000000', 'consum', 0.0223, 'lps'),
	(503286, 130, '2014-01-15 01:22:29.000000', 'consum', 0.0222, 'lps'),
	(503287, 130, '2014-01-15 01:22:30.000000', 'consum', 0.0216, 'lps'),
	(503288, 130, '2014-01-15 01:22:31.000000', 'consum', 0.0221, 'lps'),
	(503289, 130, '2014-01-15 01:22:32.000000', 'consum', 0.0214, 'lps'),
	(503290, 130, '2014-01-15 01:22:33.000000', 'consum', 0.0213, 'lps'),
	(503291, 130, '2014-01-15 01:22:34.000000', 'consum', 0.0215, 'lps'),
	(503292, 130, '2014-01-15 01:22:35.000000', 'consum', 0.0226, 'lps'),
	(503293, 130, '2014-01-15 01:22:36.000000', 'consum', 0.0223, 'lps'),
	(503294, 130, '2014-01-15 01:22:37.000000', 'consum', 0.0212, 'lps'),
	(503295, 130, '2014-01-15 01:22:38.000000', 'consum', 0.0216, 'lps'),
	(503296, 130, '2014-01-15 01:22:39.000000', 'consum', 0.0216, 'lps'),
	(503297, 130, '2014-01-15 01:22:40.000000', 'consum', 0.0222, 'lps'),
	(503298, 130, '2014-01-15 01:22:41.000000', 'consum', 0.0218, 'lps'),
	(503299, 130, '2014-01-15 01:22:42.000000', 'consum', 0.0214, 'lps'),
	(503300, 130, '2014-01-15 01:22:43.000000', 'consum', 0.0223, 'lps'),
	(503301, 130, '2014-01-15 01:22:44.000000', 'consum', 0.0215, 'lps'),
	(503302, 130, '2014-01-15 01:22:45.000000', 'consum', 0.0214, 'lps'),
	(503303, 130, '2014-01-15 01:22:46.000000', 'consum', 0.0214, 'lps'),
	(503304, 130, '2014-01-15 01:22:47.000000', 'consum', 0.0221, 'lps'),
	(503305, 130, '2014-01-15 01:22:48.000000', 'consum', 0.0216, 'lps'),
	(503306, 130, '2014-01-15 01:22:49.000000', 'consum', 0.0210, 'lps'),
	(503307, 130, '2014-01-15 01:22:50.000000', 'consum', 0.0225, 'lps'),
	(503308, 130, '2014-01-15 01:22:51.000000', 'consum', 0.0217, 'lps'),
	(503309, 130, '2014-01-15 01:22:52.000000', 'consum', 0.0217, 'lps'),
	(503310, 130, '2014-01-15 01:22:53.000000', 'consum', 0.0224, 'lps'),
	(503311, 130, '2014-01-15 01:22:54.000000', 'consum', 0.0211, 'lps'),
	(503312, 130, '2014-01-15 01:22:55.000000', 'consum', 0.0224, 'lps'),
	(503313, 130, '2014-01-15 01:22:56.000000', 'consum', 0.0225, 'lps'),
	(503314, 130, '2014-01-15 01:22:57.000000', 'consum', 0.0210, 'lps'),
	(503315, 130, '2014-01-15 01:22:58.000000', 'consum', 0.0216, 'lps'),
	(503316, 130, '2014-01-15 01:22:59.000000', 'consum', 0.0224, 'lps'),
	(503317, 130, '2014-01-15 01:23:00.000000', 'consum', 0.0212, 'lps'),
	(503318, 130, '2014-01-15 01:23:01.000000', 'consum', 0.0213, 'lps'),
	(503319, 130, '2014-01-15 01:23:02.000000', 'consum', 0.0219, 'lps'),
	(503320, 130, '2014-01-15 01:23:03.000000', 'consum', 0.0214, 'lps'),
	(503321, 130, '2014-01-15 01:23:04.000000', 'consum', 0.0217, 'lps'),
	(503322, 130, '2014-01-15 01:23:05.000000', 'consum', 0.0219, 'lps'),
	(503323, 130, '2014-01-15 01:23:06.000000', 'consum', 0.0218, 'lps'),
	(503324, 130, '2014-01-15 01:23:07.000000', 'consum', 0.0224, 'lps'),
	(503325, 130, '2014-01-15 01:23:08.000000', 'consum', 0.0220, 'lps'),
	(503326, 130, '2014-01-15 01:23:09.000000', 'consum', 0.0219, 'lps'),
	(503327, 130, '2014-01-15 01:23:10.000000', 'consum', 0.0210, 'lps'),
	(503328, 130, '2014-01-15 01:23:11.000000', 'consum', 0.0217, 'lps'),
	(503329, 130, '2014-01-15 01:23:12.000000', 'consum', 0.0213, 'lps'),
	(503330, 130, '2014-01-15 01:23:13.000000', 'consum', 0.0222, 'lps'),
	(503331, 130, '2014-01-15 01:23:14.000000', 'consum', 0.0226, 'lps'),
	(503332, 130, '2014-01-15 01:23:15.000000', 'consum', 0.0223, 'lps'),
	(503333, 130, '2014-01-15 01:23:16.000000', 'consum', 0.0224, 'lps'),
	(503334, 130, '2014-01-15 01:23:17.000000', 'consum', 0.0210, 'lps'),
	(503335, 130, '2014-01-15 01:23:18.000000', 'consum', 0.0218, 'lps'),
	(503336, 130, '2014-01-15 01:23:19.000000', 'consum', 0.0216, 'lps'),
	(503337, 130, '2014-01-15 01:23:20.000000', 'consum', 0.0215, 'lps'),
	(503338, 130, '2014-01-15 01:23:21.000000', 'consum', 0.0219, 'lps'),
	(503339, 130, '2014-01-15 01:23:22.000000', 'consum', 0.0226, 'lps'),
	(503340, 130, '2014-01-15 01:23:23.000000', 'consum', 0.0226, 'lps'),
	(503341, 130, '2014-01-15 01:23:24.000000', 'consum', 0.0226, 'lps'),
	(503342, 130, '2014-01-15 01:23:25.000000', 'consum', 0.0211, 'lps'),
	(503343, 130, '2014-01-15 01:23:26.000000', 'consum', 0.0217, 'lps'),
	(503344, 130, '2014-01-15 01:23:27.000000', 'consum', 0.0224, 'lps'),
	(503345, 130, '2014-01-15 01:23:28.000000', 'consum', 0.0225, 'lps'),
	(503346, 130, '2014-01-15 01:23:29.000000', 'consum', 0.0211, 'lps'),
	(503347, 130, '2014-01-15 01:23:30.000000', 'consum', 0.0221, 'lps'),
	(503348, 130, '2014-01-15 01:23:31.000000', 'consum', 0.0211, 'lps'),
	(503349, 130, '2014-01-15 01:23:32.000000', 'consum', 0.0216, 'lps'),
	(503350, 130, '2014-01-15 01:23:33.000000', 'consum', 0.0223, 'lps'),
	(503351, 130, '2014-01-15 01:23:34.000000', 'consum', 0.0223, 'lps'),
	(503352, 130, '2014-01-15 01:23:35.000000', 'consum', 0.0221, 'lps'),
	(503353, 130, '2014-01-15 01:23:36.000000', 'consum', 0.0224, 'lps'),
	(503354, 130, '2014-01-15 01:23:37.000000', 'consum', 0.0213, 'lps'),
	(503355, 130, '2014-01-15 01:23:38.000000', 'consum', 0.0219, 'lps'),
	(503356, 130, '2014-01-15 01:23:39.000000', 'consum', 0.0213, 'lps'),
	(503357, 130, '2014-01-15 01:23:40.000000', 'consum', 0.0214, 'lps'),
	(503358, 130, '2014-01-15 01:23:41.000000', 'consum', 0.0223, 'lps'),
	(503359, 130, '2014-01-15 01:23:42.000000', 'consum', 0.0213, 'lps'),
	(503360, 130, '2014-01-15 01:23:43.000000', 'consum', 0.0221, 'lps'),
	(503361, 130, '2014-01-15 01:23:44.000000', 'consum', 0.0221, 'lps'),
	(503362, 130, '2014-01-15 01:23:45.000000', 'consum', 0.0218, 'lps'),
	(503363, 130, '2014-01-15 01:23:46.000000', 'consum', 0.0215, 'lps'),
	(503364, 130, '2014-01-15 01:23:47.000000', 'consum', 0.0212, 'lps'),
	(503365, 130, '2014-01-15 01:23:48.000000', 'consum', 0.0221, 'lps'),
	(503366, 130, '2014-01-15 01:23:49.000000', 'consum', 0.0210, 'lps'),
	(503367, 130, '2014-01-15 01:23:50.000000', 'consum', 0.0210, 'lps'),
	(503368, 130, '2014-01-15 01:23:51.000000', 'consum', 0.0213, 'lps'),
	(503369, 130, '2014-01-15 01:23:52.000000', 'consum', 0.0225, 'lps'),
	(503370, 130, '2014-01-15 01:23:53.000000', 'consum', 0.0225, 'lps'),
	(503371, 130, '2014-01-15 01:23:54.000000', 'consum', 0.0224, 'lps'),
	(503372, 130, '2014-01-15 01:23:55.000000', 'consum', 0.0218, 'lps'),
	(503373, 130, '2014-01-15 01:23:56.000000', 'consum', 0.0224, 'lps'),
	(503374, 130, '2014-01-15 01:23:57.000000', 'consum', 0.0222, 'lps'),
	(503375, 130, '2014-01-15 01:23:58.000000', 'consum', 0.0213, 'lps'),
	(503376, 130, '2014-01-15 01:23:59.000000', 'consum', 0.0224, 'lps'),
	(503377, 130, '2014-01-15 01:24:00.000000', 'consum', 0.0220, 'lps'),
	(503378, 130, '2014-01-15 01:24:01.000000', 'consum', 0.0221, 'lps'),
	(503379, 130, '2014-01-15 01:24:02.000000', 'consum', 0.0215, 'lps'),
	(503380, 130, '2014-01-15 01:24:03.000000', 'consum', 0.0221, 'lps'),
	(503381, 130, '2014-01-15 01:24:04.000000', 'consum', 0.0216, 'lps'),
	(503382, 130, '2014-01-15 01:24:05.000000', 'consum', 0.0226, 'lps'),
	(503383, 130, '2014-01-15 01:24:06.000000', 'consum', 0.0221, 'lps'),
	(503384, 130, '2014-01-15 01:24:07.000000', 'consum', 0.0215, 'lps'),
	(503385, 130, '2014-01-15 01:24:08.000000', 'consum', 0.0222, 'lps'),
	(503386, 130, '2014-01-15 01:24:09.000000', 'consum', 0.0220, 'lps'),
	(503387, 130, '2014-01-15 01:24:10.000000', 'consum', 0.0210, 'lps'),
	(503388, 130, '2014-01-15 01:24:11.000000', 'consum', 0.0212, 'lps'),
	(503389, 130, '2014-01-15 01:24:12.000000', 'consum', 0.0221, 'lps'),
	(503390, 130, '2014-01-15 01:24:13.000000', 'consum', 0.0224, 'lps'),
	(503391, 130, '2014-01-15 01:24:14.000000', 'consum', 0.0213, 'lps'),
	(503392, 130, '2014-01-15 01:24:15.000000', 'consum', 0.0221, 'lps'),
	(503393, 130, '2014-01-15 01:24:16.000000', 'consum', 0.0219, 'lps'),
	(503394, 130, '2014-01-15 01:24:17.000000', 'consum', 0.0225, 'lps'),
	(503395, 130, '2014-01-15 01:24:18.000000', 'consum', 0.0223, 'lps'),
	(503396, 130, '2014-01-15 01:24:19.000000', 'consum', 0.0216, 'lps'),
	(503397, 130, '2014-01-15 01:24:20.000000', 'consum', 0.0217, 'lps'),
	(503398, 130, '2014-01-15 01:24:21.000000', 'consum', 0.0212, 'lps'),
	(503399, 130, '2014-01-15 01:24:22.000000', 'consum', 0.0217, 'lps'),
	(503400, 130, '2014-01-15 01:24:23.000000', 'consum', 0.0223, 'lps'),
	(503401, 130, '2014-01-15 01:24:24.000000', 'consum', 0.0219, 'lps'),
	(503402, 130, '2014-01-15 01:24:25.000000', 'consum', 0.0218, 'lps'),
	(503403, 130, '2014-01-15 01:24:26.000000', 'consum', 0.0224, 'lps'),
	(503404, 130, '2014-01-15 01:24:27.000000', 'consum', 0.0223, 'lps'),
	(503405, 130, '2014-01-15 01:24:28.000000', 'consum', 0.0217, 'lps'),
	(503406, 130, '2014-01-15 01:24:29.000000', 'consum', 0.0223, 'lps'),
	(503407, 130, '2014-01-15 01:24:30.000000', 'consum', 0.0221, 'lps'),
	(503408, 130, '2014-01-15 01:24:31.000000', 'consum', 0.0224, 'lps'),
	(503409, 130, '2014-01-15 01:24:32.000000', 'consum', 0.0215, 'lps'),
	(503410, 130, '2014-01-15 01:24:33.000000', 'consum', 0.0226, 'lps'),
	(503411, 130, '2014-01-15 01:24:34.000000', 'consum', 0.0210, 'lps'),
	(503412, 130, '2014-01-15 01:24:35.000000', 'consum', 0.0214, 'lps'),
	(503413, 130, '2014-01-15 01:24:36.000000', 'consum', 0.0213, 'lps'),
	(503414, 130, '2014-01-15 01:24:37.000000', 'consum', 0.0212, 'lps'),
	(503415, 130, '2014-01-15 01:24:38.000000', 'consum', 0.0211, 'lps'),
	(503416, 130, '2014-01-15 01:24:39.000000', 'consum', 0.0212, 'lps'),
	(503417, 130, '2014-01-15 01:24:40.000000', 'consum', 0.0215, 'lps'),
	(503418, 130, '2014-01-15 01:24:41.000000', 'consum', 0.0216, 'lps'),
	(503419, 130, '2014-01-15 01:24:42.000000', 'consum', 0.0222, 'lps'),
	(503420, 130, '2014-01-15 01:24:43.000000', 'consum', 0.0218, 'lps'),
	(503421, 130, '2014-01-15 01:24:44.000000', 'consum', 0.0217, 'lps'),
	(503422, 130, '2014-01-15 01:24:45.000000', 'consum', 0.0220, 'lps'),
	(503423, 130, '2014-01-15 01:24:46.000000', 'consum', 0.0221, 'lps'),
	(503424, 130, '2014-01-15 01:24:47.000000', 'consum', 0.0221, 'lps'),
	(503425, 130, '2014-01-15 01:24:48.000000', 'consum', 0.0216, 'lps'),
	(503426, 130, '2014-01-15 01:24:49.000000', 'consum', 0.0224, 'lps'),
	(503427, 130, '2014-01-15 01:24:50.000000', 'consum', 0.0212, 'lps'),
	(503428, 130, '2014-01-15 01:24:51.000000', 'consum', 0.0213, 'lps'),
	(503429, 130, '2014-01-15 01:24:52.000000', 'consum', 0.0218, 'lps'),
	(503430, 130, '2014-01-15 01:24:53.000000', 'consum', 0.0224, 'lps'),
	(503431, 130, '2014-01-15 01:24:54.000000', 'consum', 0.0225, 'lps'),
	(503432, 130, '2014-01-15 01:24:55.000000', 'consum', 0.0224, 'lps'),
	(503433, 130, '2014-01-15 01:24:56.000000', 'consum', 0.0217, 'lps'),
	(503434, 130, '2014-01-15 01:24:57.000000', 'consum', 0.0224, 'lps'),
	(503435, 130, '2014-01-15 01:24:58.000000', 'consum', 0.0224, 'lps'),
	(503436, 130, '2014-01-15 01:24:59.000000', 'consum', 0.0221, 'lps'),
	(503437, 130, '2014-01-15 01:25:00.000000', 'consum', 0.0225, 'lps'),
	(503438, 130, '2014-01-15 01:25:01.000000', 'consum', 0.0220, 'lps'),
	(503439, 130, '2014-01-15 01:25:02.000000', 'consum', 0.0214, 'lps'),
	(503440, 130, '2014-01-15 01:25:03.000000', 'consum', 0.0215, 'lps'),
	(503441, 130, '2014-01-15 01:25:04.000000', 'consum', 0.0210, 'lps'),
	(503442, 130, '2014-01-15 01:25:05.000000', 'consum', 0.0213, 'lps'),
	(503443, 130, '2014-01-15 01:25:06.000000', 'consum', 0.0223, 'lps'),
	(503444, 130, '2014-01-15 01:25:07.000000', 'consum', 0.0217, 'lps'),
	(503445, 130, '2014-01-15 01:25:08.000000', 'consum', 0.0222, 'lps'),
	(503446, 130, '2014-01-15 01:25:09.000000', 'consum', 0.0214, 'lps'),
	(503447, 130, '2014-01-15 01:25:10.000000', 'consum', 0.0214, 'lps'),
	(503448, 130, '2014-01-15 01:25:11.000000', 'consum', 0.0217, 'lps'),
	(503449, 130, '2014-01-15 01:25:12.000000', 'consum', 0.0217, 'lps'),
	(503450, 130, '2014-01-15 01:25:13.000000', 'consum', 0.0223, 'lps'),
	(503451, 130, '2014-01-15 01:25:14.000000', 'consum', 0.0224, 'lps'),
	(503452, 130, '2014-01-15 01:25:15.000000', 'consum', 0.0221, 'lps'),
	(503453, 130, '2014-01-15 01:25:16.000000', 'consum', 0.0210, 'lps'),
	(503454, 130, '2014-01-15 01:25:17.000000', 'consum', 0.0226, 'lps'),
	(503455, 130, '2014-01-15 01:25:18.000000', 'consum', 0.0225, 'lps'),
	(503456, 130, '2014-01-15 01:25:19.000000', 'consum', 0.0217, 'lps'),
	(503457, 130, '2014-01-15 01:25:20.000000', 'consum', 0.0221, 'lps'),
	(503458, 130, '2014-01-15 01:25:21.000000', 'consum', 0.0225, 'lps'),
	(503459, 130, '2014-01-15 01:25:22.000000', 'consum', 0.0217, 'lps'),
	(503460, 130, '2014-01-15 01:25:23.000000', 'consum', 0.0221, 'lps'),
	(503461, 130, '2014-01-15 01:25:24.000000', 'consum', 0.0210, 'lps'),
	(503462, 130, '2014-01-15 01:25:25.000000', 'consum', 0.0210, 'lps'),
	(503463, 130, '2014-01-15 01:25:26.000000', 'consum', 0.0226, 'lps'),
	(503464, 130, '2014-01-15 01:25:27.000000', 'consum', 0.0226, 'lps'),
	(503465, 130, '2014-01-15 01:25:28.000000', 'consum', 0.0223, 'lps'),
	(503466, 130, '2014-01-15 01:25:29.000000', 'consum', 0.0211, 'lps'),
	(503467, 130, '2014-01-15 01:25:30.000000', 'consum', 0.0226, 'lps'),
	(503468, 130, '2014-01-15 01:25:31.000000', 'consum', 0.0220, 'lps'),
	(503469, 130, '2014-01-15 01:25:32.000000', 'consum', 0.0212, 'lps'),
	(503470, 130, '2014-01-15 01:25:33.000000', 'consum', 0.0225, 'lps'),
	(503471, 130, '2014-01-15 01:25:34.000000', 'consum', 0.0211, 'lps'),
	(503472, 130, '2014-01-15 01:25:35.000000', 'consum', 0.0224, 'lps'),
	(503473, 130, '2014-01-15 01:25:36.000000', 'consum', 0.0223, 'lps'),
	(503474, 130, '2014-01-15 01:25:37.000000', 'consum', 0.0219, 'lps'),
	(503475, 130, '2014-01-15 01:25:38.000000', 'consum', 0.0215, 'lps'),
	(503476, 130, '2014-01-15 01:25:39.000000', 'consum', 0.0211, 'lps'),
	(503477, 130, '2014-01-15 01:25:40.000000', 'consum', 0.0214, 'lps'),
	(503478, 130, '2014-01-15 01:25:41.000000', 'consum', 0.0213, 'lps'),
	(503479, 130, '2014-01-15 01:25:42.000000', 'consum', 0.0214, 'lps'),
	(503480, 130, '2014-01-15 01:25:43.000000', 'consum', 0.0222, 'lps'),
	(503481, 130, '2014-01-15 01:25:44.000000', 'consum', 0.0224, 'lps'),
	(503482, 130, '2014-01-15 01:25:45.000000', 'consum', 0.0210, 'lps'),
	(503483, 130, '2014-01-15 01:25:46.000000', 'consum', 0.0221, 'lps'),
	(503484, 130, '2014-01-15 01:25:47.000000', 'consum', 0.0215, 'lps'),
	(503485, 130, '2014-01-15 01:25:48.000000', 'consum', 0.0219, 'lps'),
	(503486, 130, '2014-01-15 01:25:49.000000', 'consum', 0.0225, 'lps'),
	(503487, 130, '2014-01-15 01:25:50.000000', 'consum', 0.0223, 'lps'),
	(503488, 130, '2014-01-15 01:25:51.000000', 'consum', 0.0213, 'lps'),
	(503489, 130, '2014-01-15 01:25:52.000000', 'consum', 0.0221, 'lps'),
	(503490, 130, '2014-01-15 01:25:53.000000', 'consum', 0.0223, 'lps'),
	(503491, 130, '2014-01-15 01:25:54.000000', 'consum', 0.0224, 'lps'),
	(503492, 130, '2014-01-15 01:25:55.000000', 'consum', 0.0210, 'lps'),
	(503493, 130, '2014-01-15 01:25:56.000000', 'consum', 0.0218, 'lps'),
	(503494, 130, '2014-01-15 01:25:57.000000', 'consum', 0.0218, 'lps'),
	(503495, 130, '2014-01-15 01:25:58.000000', 'consum', 0.0225, 'lps'),
	(503496, 130, '2014-01-15 01:25:59.000000', 'consum', 0.0210, 'lps'),
	(503497, 130, '2014-01-15 01:26:00.000000', 'consum', 0.0216, 'lps'),
	(503498, 130, '2014-01-15 01:26:01.000000', 'consum', 0.0225, 'lps'),
	(503499, 130, '2014-01-15 01:26:02.000000', 'consum', 0.0214, 'lps'),
	(503500, 130, '2014-01-15 01:26:03.000000', 'consum', 0.0221, 'lps'),
	(503501, 130, '2014-01-15 01:26:04.000000', 'consum', 0.0219, 'lps'),
	(503502, 130, '2014-01-15 01:26:05.000000', 'consum', 0.0223, 'lps'),
	(503503, 130, '2014-01-15 01:26:06.000000', 'consum', 0.0214, 'lps'),
	(503504, 130, '2014-01-15 01:26:07.000000', 'consum', 0.0210, 'lps'),
	(503505, 130, '2014-01-15 01:26:08.000000', 'consum', 0.0215, 'lps'),
	(503506, 130, '2014-01-15 01:26:09.000000', 'consum', 0.0218, 'lps'),
	(503507, 130, '2014-01-15 01:26:10.000000', 'consum', 0.0217, 'lps'),
	(503508, 130, '2014-01-15 01:26:11.000000', 'consum', 0.0223, 'lps'),
	(503509, 130, '2014-01-15 01:26:12.000000', 'consum', 0.0222, 'lps'),
	(503510, 130, '2014-01-15 01:26:13.000000', 'consum', 0.0214, 'lps'),
	(503511, 130, '2014-01-15 01:26:14.000000', 'consum', 0.0226, 'lps'),
	(503512, 130, '2014-01-15 01:26:15.000000', 'consum', 0.0213, 'lps'),
	(503513, 130, '2014-01-15 01:26:16.000000', 'consum', 0.0226, 'lps'),
	(503514, 130, '2014-01-15 01:26:17.000000', 'consum', 0.0214, 'lps'),
	(503515, 130, '2014-01-15 01:26:18.000000', 'consum', 0.0218, 'lps'),
	(503516, 130, '2014-01-15 01:26:19.000000', 'consum', 0.0223, 'lps'),
	(503517, 130, '2014-01-15 01:26:20.000000', 'consum', 0.0214, 'lps'),
	(503518, 130, '2014-01-15 01:26:21.000000', 'consum', 0.0210, 'lps'),
	(503519, 130, '2014-01-15 01:26:22.000000', 'consum', 0.0217, 'lps'),
	(503520, 130, '2014-01-15 01:26:23.000000', 'consum', 0.0210, 'lps'),
	(503521, 130, '2014-01-15 01:26:24.000000', 'consum', 0.0225, 'lps'),
	(503522, 130, '2014-01-15 01:26:25.000000', 'consum', 0.0216, 'lps'),
	(503523, 130, '2014-01-15 01:26:26.000000', 'consum', 0.0215, 'lps'),
	(503524, 130, '2014-01-15 01:26:27.000000', 'consum', 0.0215, 'lps'),
	(503525, 130, '2014-01-15 01:26:28.000000', 'consum', 0.0220, 'lps'),
	(503526, 130, '2014-01-15 01:26:29.000000', 'consum', 0.0211, 'lps'),
	(503527, 130, '2014-01-15 01:26:30.000000', 'consum', 0.0221, 'lps'),
	(503528, 130, '2014-01-15 01:26:31.000000', 'consum', 0.0226, 'lps'),
	(503529, 130, '2014-01-15 01:26:32.000000', 'consum', 0.0225, 'lps'),
	(503530, 130, '2014-01-15 01:26:33.000000', 'consum', 0.0221, 'lps'),
	(503531, 130, '2014-01-15 01:26:34.000000', 'consum', 0.0219, 'lps'),
	(503532, 130, '2014-01-15 01:26:35.000000', 'consum', 0.0225, 'lps'),
	(503533, 130, '2014-01-15 01:26:36.000000', 'consum', 0.0223, 'lps'),
	(503534, 130, '2014-01-15 01:26:37.000000', 'consum', 0.0214, 'lps'),
	(503535, 130, '2014-01-15 01:26:38.000000', 'consum', 0.0210, 'lps'),
	(503536, 130, '2014-01-15 01:26:39.000000', 'consum', 0.0213, 'lps'),
	(503537, 130, '2014-01-15 01:26:40.000000', 'consum', 0.0210, 'lps'),
	(503538, 130, '2014-01-15 01:26:41.000000', 'consum', 0.0218, 'lps'),
	(503539, 130, '2014-01-15 01:26:42.000000', 'consum', 0.0218, 'lps'),
	(503540, 130, '2014-01-15 01:26:43.000000', 'consum', 0.0226, 'lps'),
	(503541, 130, '2014-01-15 01:26:44.000000', 'consum', 0.0213, 'lps'),
	(503542, 130, '2014-01-15 01:26:45.000000', 'consum', 0.0214, 'lps'),
	(503543, 130, '2014-01-15 01:26:46.000000', 'consum', 0.0220, 'lps'),
	(503544, 130, '2014-01-15 01:26:47.000000', 'consum', 0.0213, 'lps'),
	(503545, 130, '2014-01-15 01:26:48.000000', 'consum', 0.0215, 'lps'),
	(503546, 130, '2014-01-15 01:26:49.000000', 'consum', 0.0224, 'lps'),
	(503547, 130, '2014-01-15 01:26:50.000000', 'consum', 0.0217, 'lps'),
	(503548, 130, '2014-01-15 01:26:51.000000', 'consum', 0.0221, 'lps'),
	(503549, 130, '2014-01-15 01:26:52.000000', 'consum', 0.0210, 'lps'),
	(503550, 130, '2014-01-15 01:26:53.000000', 'consum', 0.0213, 'lps'),
	(503551, 130, '2014-01-15 01:26:54.000000', 'consum', 0.0225, 'lps'),
	(503552, 130, '2014-01-15 01:26:55.000000', 'consum', 0.0225, 'lps'),
	(503553, 130, '2014-01-15 01:26:56.000000', 'consum', 0.0224, 'lps'),
	(503554, 130, '2014-01-15 01:26:57.000000', 'consum', 0.0219, 'lps'),
	(503555, 130, '2014-01-15 01:26:58.000000', 'consum', 0.0211, 'lps'),
	(503556, 130, '2014-01-15 01:26:59.000000', 'consum', 0.0223, 'lps'),
	(503557, 130, '2014-01-15 01:27:00.000000', 'consum', 0.0223, 'lps'),
	(503558, 130, '2014-01-15 01:27:01.000000', 'consum', 0.0218, 'lps'),
	(503559, 130, '2014-01-15 01:27:02.000000', 'consum', 0.0211, 'lps'),
	(503560, 130, '2014-01-15 01:27:03.000000', 'consum', 0.0211, 'lps'),
	(503561, 130, '2014-01-15 01:27:04.000000', 'consum', 0.0211, 'lps'),
	(503562, 130, '2014-01-15 01:27:05.000000', 'consum', 0.0212, 'lps'),
	(503563, 130, '2014-01-15 01:27:06.000000', 'consum', 0.0218, 'lps'),
	(503564, 130, '2014-01-15 01:27:07.000000', 'consum', 0.0212, 'lps'),
	(503565, 130, '2014-01-15 01:27:08.000000', 'consum', 0.0212, 'lps'),
	(503566, 130, '2014-01-15 01:27:09.000000', 'consum', 0.0214, 'lps'),
	(503567, 130, '2014-01-15 01:27:10.000000', 'consum', 0.0210, 'lps'),
	(503568, 130, '2014-01-15 01:27:11.000000', 'consum', 0.0213, 'lps'),
	(503569, 130, '2014-01-15 01:27:12.000000', 'consum', 0.0211, 'lps'),
	(503570, 130, '2014-01-15 01:27:13.000000', 'consum', 0.0221, 'lps'),
	(503571, 130, '2014-01-15 01:27:14.000000', 'consum', 0.0212, 'lps'),
	(503572, 130, '2014-01-15 01:27:15.000000', 'consum', 0.0220, 'lps'),
	(503573, 130, '2014-01-15 01:27:16.000000', 'consum', 0.0221, 'lps'),
	(503574, 130, '2014-01-15 01:27:17.000000', 'consum', 0.0219, 'lps'),
	(503575, 130, '2014-01-15 01:27:18.000000', 'consum', 0.0221, 'lps'),
	(503576, 130, '2014-01-15 01:27:19.000000', 'consum', 0.0222, 'lps'),
	(503577, 130, '2014-01-15 01:27:20.000000', 'consum', 0.0223, 'lps'),
	(503578, 130, '2014-01-15 01:27:21.000000', 'consum', 0.0219, 'lps'),
	(503579, 130, '2014-01-15 01:27:22.000000', 'consum', 0.0217, 'lps'),
	(503580, 130, '2014-01-15 01:27:23.000000', 'consum', 0.0221, 'lps'),
	(503581, 130, '2014-01-15 01:27:24.000000', 'consum', 0.0210, 'lps'),
	(503582, 130, '2014-01-15 01:27:25.000000', 'consum', 0.0211, 'lps'),
	(503583, 130, '2014-01-15 01:27:26.000000', 'consum', 0.0217, 'lps'),
	(503584, 130, '2014-01-15 01:27:27.000000', 'consum', 0.0224, 'lps'),
	(503585, 130, '2014-01-15 01:27:28.000000', 'consum', 0.0226, 'lps'),
	(503586, 130, '2014-01-15 01:27:29.000000', 'consum', 0.0216, 'lps'),
	(503587, 130, '2014-01-15 01:27:30.000000', 'consum', 0.0226, 'lps'),
	(503588, 130, '2014-01-15 01:27:31.000000', 'consum', 0.0221, 'lps'),
	(503589, 130, '2014-01-15 01:27:32.000000', 'consum', 0.0219, 'lps'),
	(503590, 130, '2014-01-15 01:27:33.000000', 'consum', 0.0222, 'lps'),
	(503591, 130, '2014-01-15 01:27:34.000000', 'consum', 0.0210, 'lps'),
	(503592, 130, '2014-01-15 01:27:35.000000', 'consum', 0.0226, 'lps'),
	(503593, 130, '2014-01-15 01:27:36.000000', 'consum', 0.0222, 'lps'),
	(503594, 130, '2014-01-15 01:27:37.000000', 'consum', 0.0222, 'lps'),
	(503595, 130, '2014-01-15 01:27:38.000000', 'consum', 0.0220, 'lps'),
	(503596, 130, '2014-01-15 01:27:39.000000', 'consum', 0.0221, 'lps'),
	(503597, 130, '2014-01-15 01:27:40.000000', 'consum', 0.0219, 'lps'),
	(503598, 130, '2014-01-15 01:27:41.000000', 'consum', 0.0225, 'lps'),
	(503599, 130, '2014-01-15 01:27:42.000000', 'consum', 0.0223, 'lps'),
	(503600, 130, '2014-01-15 01:27:43.000000', 'consum', 0.0212, 'lps'),
	(503601, 130, '2014-01-15 01:27:44.000000', 'consum', 0.0218, 'lps'),
	(503602, 130, '2014-01-15 01:27:45.000000', 'consum', 0.0211, 'lps'),
	(503603, 130, '2014-01-15 01:27:46.000000', 'consum', 0.0225, 'lps'),
	(503604, 130, '2014-01-15 01:27:47.000000', 'consum', 0.0213, 'lps'),
	(503605, 130, '2014-01-15 01:27:48.000000', 'consum', 0.0216, 'lps'),
	(503606, 130, '2014-01-15 01:27:49.000000', 'consum', 0.0215, 'lps'),
	(503607, 130, '2014-01-15 01:27:50.000000', 'consum', 0.0219, 'lps'),
	(503608, 130, '2014-01-15 01:27:51.000000', 'consum', 0.0221, 'lps'),
	(503609, 130, '2014-01-15 01:27:52.000000', 'consum', 0.0222, 'lps'),
	(503610, 130, '2014-01-15 01:27:53.000000', 'consum', 0.0220, 'lps'),
	(503611, 130, '2014-01-15 01:27:54.000000', 'consum', 0.0210, 'lps'),
	(503612, 130, '2014-01-15 01:27:55.000000', 'consum', 0.0213, 'lps'),
	(503613, 130, '2014-01-15 01:27:56.000000', 'consum', 0.0225, 'lps'),
	(503614, 130, '2014-01-15 01:27:57.000000', 'consum', 0.0211, 'lps'),
	(503615, 130, '2014-01-15 01:27:58.000000', 'consum', 0.0220, 'lps'),
	(503616, 130, '2014-01-15 01:27:59.000000', 'consum', 0.0222, 'lps'),
	(503617, 130, '2014-01-15 01:28:00.000000', 'consum', 0.0226, 'lps'),
	(503618, 130, '2014-01-15 01:28:01.000000', 'consum', 0.0222, 'lps'),
	(503619, 130, '2014-01-15 01:28:02.000000', 'consum', 0.0219, 'lps'),
	(503620, 130, '2014-01-15 01:28:03.000000', 'consum', 0.0221, 'lps'),
	(503621, 130, '2014-01-15 01:28:04.000000', 'consum', 0.0221, 'lps'),
	(503622, 130, '2014-01-15 01:28:05.000000', 'consum', 0.0215, 'lps'),
	(503623, 130, '2014-01-15 01:28:06.000000', 'consum', 0.0221, 'lps'),
	(503624, 130, '2014-01-15 01:28:07.000000', 'consum', 0.0215, 'lps'),
	(503625, 130, '2014-01-15 01:28:08.000000', 'consum', 0.0219, 'lps'),
	(503626, 130, '2014-01-15 01:28:09.000000', 'consum', 0.0226, 'lps'),
	(503627, 130, '2014-01-15 01:28:10.000000', 'consum', 0.0210, 'lps'),
	(503628, 130, '2014-01-15 01:28:11.000000', 'consum', 0.0213, 'lps'),
	(503629, 130, '2014-01-15 01:28:12.000000', 'consum', 0.0210, 'lps'),
	(503630, 130, '2014-01-15 01:28:13.000000', 'consum', 0.0219, 'lps'),
	(503631, 130, '2014-01-15 01:28:14.000000', 'consum', 0.0223, 'lps'),
	(503632, 130, '2014-01-15 01:28:15.000000', 'consum', 0.0212, 'lps'),
	(503633, 130, '2014-01-15 01:28:16.000000', 'consum', 0.0217, 'lps'),
	(503634, 130, '2014-01-15 01:28:17.000000', 'consum', 0.0223, 'lps'),
	(503635, 130, '2014-01-15 01:28:18.000000', 'consum', 0.0218, 'lps'),
	(503636, 130, '2014-01-15 01:28:19.000000', 'consum', 0.0213, 'lps'),
	(503637, 130, '2014-01-15 01:28:20.000000', 'consum', 0.0220, 'lps'),
	(503638, 130, '2014-01-15 01:28:21.000000', 'consum', 0.0217, 'lps'),
	(503639, 130, '2014-01-15 01:28:22.000000', 'consum', 0.0213, 'lps'),
	(503640, 130, '2014-01-15 01:28:23.000000', 'consum', 0.0223, 'lps'),
	(503641, 130, '2014-01-15 01:28:24.000000', 'consum', 0.0214, 'lps'),
	(503642, 130, '2014-01-15 01:28:25.000000', 'consum', 0.0210, 'lps'),
	(503643, 130, '2014-01-15 01:28:26.000000', 'consum', 0.0216, 'lps'),
	(503644, 130, '2014-01-15 01:28:27.000000', 'consum', 0.0224, 'lps'),
	(503645, 130, '2014-01-15 01:28:28.000000', 'consum', 0.0210, 'lps'),
	(503646, 130, '2014-01-15 01:28:29.000000', 'consum', 0.0219, 'lps'),
	(503647, 130, '2014-01-15 01:28:30.000000', 'consum', 0.0222, 'lps'),
	(503648, 130, '2014-01-15 01:28:31.000000', 'consum', 0.0226, 'lps'),
	(503649, 130, '2014-01-15 01:28:32.000000', 'consum', 0.0220, 'lps'),
	(503650, 130, '2014-01-15 01:28:33.000000', 'consum', 0.0213, 'lps'),
	(503651, 130, '2014-01-15 01:28:34.000000', 'consum', 0.0213, 'lps'),
	(503652, 130, '2014-01-15 01:28:35.000000', 'consum', 0.0215, 'lps'),
	(503653, 130, '2014-01-15 01:28:36.000000', 'consum', 0.0225, 'lps'),
	(503654, 130, '2014-01-15 01:28:37.000000', 'consum', 0.0222, 'lps'),
	(503655, 130, '2014-01-15 01:28:38.000000', 'consum', 0.0226, 'lps'),
	(503656, 130, '2014-01-15 01:28:39.000000', 'consum', 0.0222, 'lps'),
	(503657, 130, '2014-01-15 01:28:40.000000', 'consum', 0.0220, 'lps'),
	(503658, 130, '2014-01-15 01:28:41.000000', 'consum', 0.0225, 'lps'),
	(503659, 130, '2014-01-15 01:28:42.000000', 'consum', 0.0220, 'lps'),
	(503660, 130, '2014-01-15 01:28:43.000000', 'consum', 0.0218, 'lps'),
	(503661, 130, '2014-01-15 01:28:44.000000', 'consum', 0.0218, 'lps'),
	(503662, 130, '2014-01-15 01:28:45.000000', 'consum', 0.0212, 'lps'),
	(503663, 130, '2014-01-15 01:28:46.000000', 'consum', 0.0212, 'lps'),
	(503664, 130, '2014-01-15 01:28:47.000000', 'consum', 0.0215, 'lps'),
	(503665, 130, '2014-01-15 01:28:48.000000', 'consum', 0.0211, 'lps'),
	(503666, 130, '2014-01-15 01:28:49.000000', 'consum', 0.0219, 'lps'),
	(503667, 130, '2014-01-15 01:28:50.000000', 'consum', 0.0217, 'lps'),
	(503668, 130, '2014-01-15 01:28:51.000000', 'consum', 0.0221, 'lps'),
	(503669, 130, '2014-01-15 01:28:52.000000', 'consum', 0.0226, 'lps'),
	(503670, 130, '2014-01-15 01:28:53.000000', 'consum', 0.0224, 'lps'),
	(503671, 130, '2014-01-15 01:28:54.000000', 'consum', 0.0216, 'lps'),
	(503672, 130, '2014-01-15 01:28:55.000000', 'consum', 0.0215, 'lps'),
	(503673, 130, '2014-01-15 01:28:56.000000', 'consum', 0.0217, 'lps'),
	(503674, 130, '2014-01-15 01:28:57.000000', 'consum', 0.0214, 'lps'),
	(503675, 130, '2014-01-15 01:28:58.000000', 'consum', 0.0210, 'lps'),
	(503676, 130, '2014-01-15 01:28:59.000000', 'consum', 0.0216, 'lps'),
	(503677, 130, '2014-01-15 01:29:00.000000', 'consum', 0.0223, 'lps'),
	(503678, 130, '2014-01-15 01:29:01.000000', 'consum', 0.0225, 'lps'),
	(503679, 130, '2014-01-15 01:29:02.000000', 'consum', 0.0212, 'lps'),
	(503680, 130, '2014-01-15 01:29:03.000000', 'consum', 0.0225, 'lps'),
	(503681, 130, '2014-01-15 01:29:04.000000', 'consum', 0.0213, 'lps'),
	(503682, 130, '2014-01-15 01:29:05.000000', 'consum', 0.0213, 'lps'),
	(503683, 130, '2014-01-15 01:29:06.000000', 'consum', 0.0215, 'lps'),
	(503684, 130, '2014-01-15 01:29:07.000000', 'consum', 0.0212, 'lps'),
	(503685, 130, '2014-01-15 01:29:08.000000', 'consum', 0.0220, 'lps'),
	(503686, 130, '2014-01-15 01:29:09.000000', 'consum', 0.0222, 'lps'),
	(503687, 130, '2014-01-15 01:29:10.000000', 'consum', 0.0224, 'lps'),
	(503688, 130, '2014-01-15 01:29:11.000000', 'consum', 0.0211, 'lps'),
	(503689, 130, '2014-01-15 01:29:12.000000', 'consum', 0.0225, 'lps'),
	(503690, 130, '2014-01-15 01:29:13.000000', 'consum', 0.0212, 'lps'),
	(503691, 130, '2014-01-15 01:29:14.000000', 'consum', 0.0226, 'lps'),
	(503692, 130, '2014-01-15 01:29:15.000000', 'consum', 0.0219, 'lps'),
	(503693, 130, '2014-01-15 01:29:16.000000', 'consum', 0.0225, 'lps'),
	(503694, 130, '2014-01-15 01:29:17.000000', 'consum', 0.0225, 'lps'),
	(503695, 130, '2014-01-15 01:29:18.000000', 'consum', 0.0225, 'lps'),
	(503696, 130, '2014-01-15 01:29:19.000000', 'consum', 0.0220, 'lps'),
	(503697, 130, '2014-01-15 01:29:20.000000', 'consum', 0.0216, 'lps'),
	(503698, 130, '2014-01-15 01:29:21.000000', 'consum', 0.0210, 'lps'),
	(503699, 130, '2014-01-15 01:29:22.000000', 'consum', 0.0212, 'lps'),
	(503700, 130, '2014-01-15 01:29:23.000000', 'consum', 0.0217, 'lps'),
	(503701, 130, '2014-01-15 01:29:24.000000', 'consum', 0.0225, 'lps'),
	(503702, 130, '2014-01-15 01:29:25.000000', 'consum', 0.0214, 'lps'),
	(503703, 130, '2014-01-15 01:29:26.000000', 'consum', 0.0217, 'lps'),
	(503704, 130, '2014-01-15 01:29:27.000000', 'consum', 0.0219, 'lps'),
	(503705, 130, '2014-01-15 01:29:28.000000', 'consum', 0.0215, 'lps'),
	(503706, 130, '2014-01-15 01:29:29.000000', 'consum', 0.0210, 'lps'),
	(503707, 130, '2014-01-15 01:29:30.000000', 'consum', 0.0211, 'lps'),
	(503708, 130, '2014-01-15 01:29:31.000000', 'consum', 0.0216, 'lps'),
	(503709, 130, '2014-01-15 01:29:32.000000', 'consum', 0.0219, 'lps'),
	(503710, 130, '2014-01-15 01:29:33.000000', 'consum', 0.0221, 'lps'),
	(503711, 130, '2014-01-15 01:29:34.000000', 'consum', 0.0224, 'lps'),
	(503712, 130, '2014-01-15 01:29:35.000000', 'consum', 0.0211, 'lps'),
	(503713, 130, '2014-01-15 01:29:36.000000', 'consum', 0.0225, 'lps'),
	(503714, 130, '2014-01-15 01:29:37.000000', 'consum', 0.0214, 'lps'),
	(503715, 130, '2014-01-15 01:29:38.000000', 'consum', 0.0222, 'lps'),
	(503716, 130, '2014-01-15 01:29:39.000000', 'consum', 0.0223, 'lps'),
	(503717, 130, '2014-01-15 01:29:40.000000', 'consum', 0.0223, 'lps'),
	(503718, 130, '2014-01-15 01:29:41.000000', 'consum', 0.0221, 'lps'),
	(503719, 130, '2014-01-15 01:29:42.000000', 'consum', 0.0224, 'lps'),
	(503720, 130, '2014-01-15 01:29:43.000000', 'consum', 0.0214, 'lps'),
	(503721, 130, '2014-01-15 01:29:44.000000', 'consum', 0.0222, 'lps'),
	(503722, 130, '2014-01-15 01:29:45.000000', 'consum', 0.0226, 'lps'),
	(503723, 130, '2014-01-15 01:29:46.000000', 'consum', 0.0219, 'lps'),
	(503724, 130, '2014-01-15 01:29:47.000000', 'consum', 0.0226, 'lps'),
	(503725, 130, '2014-01-15 01:29:48.000000', 'consum', 0.0211, 'lps'),
	(503726, 130, '2014-01-15 01:29:49.000000', 'consum', 0.0219, 'lps'),
	(503727, 130, '2014-01-15 01:29:50.000000', 'consum', 0.0217, 'lps'),
	(503728, 130, '2014-01-15 01:29:51.000000', 'consum', 0.0219, 'lps'),
	(503729, 130, '2014-01-15 01:29:52.000000', 'consum', 0.0218, 'lps'),
	(503730, 130, '2014-01-15 01:29:53.000000', 'consum', 0.0225, 'lps'),
	(503731, 130, '2014-01-15 01:29:54.000000', 'consum', 0.0210, 'lps'),
	(503732, 130, '2014-01-15 01:29:55.000000', 'consum', 0.0216, 'lps'),
	(503733, 130, '2014-01-15 01:29:56.000000', 'consum', 0.0225, 'lps'),
	(503734, 130, '2014-01-15 01:29:57.000000', 'consum', 0.0214, 'lps'),
	(503735, 130, '2014-01-15 01:29:58.000000', 'consum', 0.0221, 'lps'),
	(503736, 130, '2014-01-15 01:29:59.000000', 'consum', 0.0217, 'lps'),
	(503737, 130, '2014-01-15 01:30:00.000000', 'consum', 0.0216, 'lps'),
	(503738, 130, '2014-01-15 01:30:01.000000', 'consum', 0.0219, 'lps'),
	(503739, 130, '2014-01-15 01:30:02.000000', 'consum', 0.0219, 'lps'),
	(503740, 130, '2014-01-15 01:30:03.000000', 'consum', 0.0213, 'lps'),
	(503741, 130, '2014-01-15 01:30:04.000000', 'consum', 0.0215, 'lps'),
	(503742, 130, '2014-01-15 01:30:05.000000', 'consum', 0.0211, 'lps'),
	(503743, 130, '2014-01-15 01:30:06.000000', 'consum', 0.0218, 'lps'),
	(503744, 130, '2014-01-15 01:30:07.000000', 'consum', 0.0214, 'lps'),
	(503745, 130, '2014-01-15 01:30:08.000000', 'consum', 0.0221, 'lps'),
	(503746, 130, '2014-01-15 01:30:09.000000', 'consum', 0.0221, 'lps'),
	(503747, 130, '2014-01-15 01:30:10.000000', 'consum', 0.0215, 'lps'),
	(503748, 130, '2014-01-15 01:30:11.000000', 'consum', 0.0221, 'lps'),
	(503749, 130, '2014-01-15 01:30:12.000000', 'consum', 0.0216, 'lps'),
	(503750, 130, '2014-01-15 01:30:13.000000', 'consum', 0.0225, 'lps'),
	(503751, 130, '2014-01-15 01:30:14.000000', 'consum', 0.0215, 'lps'),
	(503752, 130, '2014-01-15 01:30:15.000000', 'consum', 0.0223, 'lps'),
	(503753, 130, '2014-01-15 01:30:16.000000', 'consum', 0.0212, 'lps'),
	(503754, 130, '2014-01-15 01:30:17.000000', 'consum', 0.0217, 'lps'),
	(503755, 130, '2014-01-15 01:30:18.000000', 'consum', 0.0220, 'lps'),
	(503756, 130, '2014-01-15 01:30:19.000000', 'consum', 0.0225, 'lps'),
	(503757, 130, '2014-01-15 01:30:20.000000', 'consum', 0.0219, 'lps'),
	(503758, 130, '2014-01-15 01:30:21.000000', 'consum', 0.0226, 'lps'),
	(503759, 130, '2014-01-15 01:30:22.000000', 'consum', 0.0216, 'lps'),
	(503760, 130, '2014-01-15 01:30:23.000000', 'consum', 0.0225, 'lps'),
	(503761, 130, '2014-01-15 01:30:24.000000', 'consum', 0.0218, 'lps'),
	(503762, 130, '2014-01-15 01:30:25.000000', 'consum', 0.0220, 'lps'),
	(503763, 130, '2014-01-15 01:30:26.000000', 'consum', 0.0220, 'lps'),
	(503764, 130, '2014-01-15 01:30:27.000000', 'consum', 0.0213, 'lps'),
	(503765, 130, '2014-01-15 01:30:28.000000', 'consum', 0.0212, 'lps'),
	(503766, 130, '2014-01-15 01:30:29.000000', 'consum', 0.0211, 'lps'),
	(503767, 130, '2014-01-15 01:30:30.000000', 'consum', 0.0210, 'lps'),
	(503768, 130, '2014-01-15 01:30:31.000000', 'consum', 0.0224, 'lps'),
	(503769, 130, '2014-01-15 01:30:32.000000', 'consum', 0.0214, 'lps'),
	(503770, 130, '2014-01-15 01:30:33.000000', 'consum', 0.0221, 'lps'),
	(503771, 130, '2014-01-15 01:30:34.000000', 'consum', 0.0221, 'lps'),
	(503772, 130, '2014-01-15 01:30:35.000000', 'consum', 0.0216, 'lps'),
	(503773, 130, '2014-01-15 01:30:36.000000', 'consum', 0.0223, 'lps'),
	(503774, 130, '2014-01-15 01:30:37.000000', 'consum', 0.0224, 'lps'),
	(503775, 130, '2014-01-15 01:30:38.000000', 'consum', 0.0225, 'lps'),
	(503776, 130, '2014-01-15 01:30:39.000000', 'consum', 0.0226, 'lps'),
	(503777, 130, '2014-01-15 01:30:40.000000', 'consum', 0.0213, 'lps'),
	(503778, 130, '2014-01-15 01:30:41.000000', 'consum', 0.0211, 'lps'),
	(503779, 130, '2014-01-15 01:30:42.000000', 'consum', 0.0224, 'lps'),
	(503780, 130, '2014-01-15 01:30:43.000000', 'consum', 0.0210, 'lps'),
	(503781, 130, '2014-01-15 01:30:44.000000', 'consum', 0.0217, 'lps'),
	(503782, 130, '2014-01-15 01:30:45.000000', 'consum', 0.0212, 'lps'),
	(503783, 130, '2014-01-15 01:30:46.000000', 'consum', 0.0216, 'lps'),
	(503784, 130, '2014-01-15 01:30:47.000000', 'consum', 0.0216, 'lps'),
	(503785, 130, '2014-01-15 01:30:48.000000', 'consum', 0.0225, 'lps'),
	(503786, 130, '2014-01-15 01:30:49.000000', 'consum', 0.0215, 'lps'),
	(503787, 130, '2014-01-15 01:30:50.000000', 'consum', 0.0224, 'lps'),
	(503788, 130, '2014-01-15 01:30:51.000000', 'consum', 0.0215, 'lps'),
	(503789, 130, '2014-01-15 01:30:52.000000', 'consum', 0.0226, 'lps'),
	(503790, 130, '2014-01-15 01:30:53.000000', 'consum', 0.0225, 'lps'),
	(503791, 130, '2014-01-15 01:30:54.000000', 'consum', 0.0221, 'lps'),
	(503792, 130, '2014-01-15 01:30:55.000000', 'consum', 0.0222, 'lps'),
	(503793, 130, '2014-01-15 01:30:56.000000', 'consum', 0.0220, 'lps'),
	(503794, 130, '2014-01-15 01:30:57.000000', 'consum', 0.0223, 'lps'),
	(503795, 130, '2014-01-15 01:30:58.000000', 'consum', 0.0212, 'lps'),
	(503796, 130, '2014-01-15 01:30:59.000000', 'consum', 0.0215, 'lps'),
	(503797, 130, '2014-01-15 01:31:00.000000', 'consum', 0.0211, 'lps'),
	(503798, 130, '2014-01-15 01:31:01.000000', 'consum', 0.0220, 'lps'),
	(503799, 130, '2014-01-15 01:31:02.000000', 'consum', 0.0222, 'lps'),
	(503800, 130, '2014-01-15 01:31:03.000000', 'consum', 0.0226, 'lps'),
	(503801, 130, '2014-01-15 01:31:04.000000', 'consum', 0.0220, 'lps'),
	(503802, 130, '2014-01-15 01:31:05.000000', 'consum', 0.0210, 'lps'),
	(503803, 130, '2014-01-15 01:31:06.000000', 'consum', 0.0218, 'lps'),
	(503804, 130, '2014-01-15 01:31:07.000000', 'consum', 0.0215, 'lps'),
	(503805, 130, '2014-01-15 01:31:08.000000', 'consum', 0.0210, 'lps'),
	(503806, 130, '2014-01-15 01:31:09.000000', 'consum', 0.0214, 'lps'),
	(503807, 130, '2014-01-15 01:31:10.000000', 'consum', 0.0214, 'lps'),
	(503808, 130, '2014-01-15 01:31:11.000000', 'consum', 0.0218, 'lps'),
	(503809, 130, '2014-01-15 01:31:12.000000', 'consum', 0.0223, 'lps'),
	(503810, 130, '2014-01-15 01:31:13.000000', 'consum', 0.0215, 'lps'),
	(503811, 130, '2014-01-15 01:31:14.000000', 'consum', 0.0216, 'lps'),
	(503812, 130, '2014-01-15 01:31:15.000000', 'consum', 0.0226, 'lps'),
	(503813, 130, '2014-01-15 01:31:16.000000', 'consum', 0.0218, 'lps'),
	(503814, 130, '2014-01-15 01:31:17.000000', 'consum', 0.0223, 'lps'),
	(503815, 130, '2014-01-15 01:31:18.000000', 'consum', 0.0216, 'lps'),
	(503816, 130, '2014-01-15 01:31:19.000000', 'consum', 0.0221, 'lps'),
	(503817, 130, '2014-01-15 01:31:20.000000', 'consum', 0.0210, 'lps'),
	(503818, 130, '2014-01-15 01:31:21.000000', 'consum', 0.0212, 'lps'),
	(503819, 130, '2014-01-15 01:31:22.000000', 'consum', 0.0220, 'lps'),
	(503820, 130, '2014-01-15 01:31:23.000000', 'consum', 0.0220, 'lps'),
	(503821, 130, '2014-01-15 01:31:24.000000', 'consum', 0.0214, 'lps'),
	(503822, 130, '2014-01-15 01:31:25.000000', 'consum', 0.0219, 'lps'),
	(503823, 130, '2014-01-15 01:31:26.000000', 'consum', 0.0225, 'lps'),
	(503824, 130, '2014-01-15 01:31:27.000000', 'consum', 0.0226, 'lps'),
	(503825, 130, '2014-01-15 01:31:28.000000', 'consum', 0.0210, 'lps'),
	(503826, 130, '2014-01-15 01:31:29.000000', 'consum', 0.0213, 'lps'),
	(503827, 130, '2014-01-15 01:31:30.000000', 'consum', 0.0225, 'lps'),
	(503828, 130, '2014-01-15 01:31:31.000000', 'consum', 0.0224, 'lps'),
	(503829, 130, '2014-01-15 01:31:32.000000', 'consum', 0.0222, 'lps'),
	(503830, 130, '2014-01-15 01:31:33.000000', 'consum', 0.0226, 'lps'),
	(503831, 130, '2014-01-15 01:31:34.000000', 'consum', 0.0220, 'lps'),
	(503832, 130, '2014-01-15 01:31:35.000000', 'consum', 0.0213, 'lps'),
	(503833, 130, '2014-01-15 01:31:36.000000', 'consum', 0.0212, 'lps'),
	(503834, 130, '2014-01-15 01:31:37.000000', 'consum', 0.0211, 'lps'),
	(503835, 130, '2014-01-15 01:31:38.000000', 'consum', 0.0225, 'lps'),
	(503836, 130, '2014-01-15 01:31:39.000000', 'consum', 0.0218, 'lps'),
	(503837, 130, '2014-01-15 01:31:40.000000', 'consum', 0.0221, 'lps'),
	(503838, 130, '2014-01-15 01:31:41.000000', 'consum', 0.0224, 'lps'),
	(503839, 130, '2014-01-15 01:31:42.000000', 'consum', 0.0213, 'lps'),
	(503840, 130, '2014-01-15 01:31:43.000000', 'consum', 0.0219, 'lps'),
	(503841, 130, '2014-01-15 01:31:44.000000', 'consum', 0.0211, 'lps'),
	(503842, 130, '2014-01-15 01:31:45.000000', 'consum', 0.0225, 'lps'),
	(503843, 130, '2014-01-15 01:31:46.000000', 'consum', 0.0212, 'lps'),
	(503844, 130, '2014-01-15 01:31:47.000000', 'consum', 0.0226, 'lps'),
	(503845, 130, '2014-01-15 01:31:48.000000', 'consum', 0.0216, 'lps'),
	(503846, 130, '2014-01-15 01:31:49.000000', 'consum', 0.0210, 'lps'),
	(503847, 130, '2014-01-15 01:31:50.000000', 'consum', 0.0226, 'lps'),
	(503848, 130, '2014-01-15 01:31:51.000000', 'consum', 0.0221, 'lps'),
	(503849, 130, '2014-01-15 01:31:52.000000', 'consum', 0.0219, 'lps'),
	(503850, 130, '2014-01-15 01:31:53.000000', 'consum', 0.0222, 'lps'),
	(503851, 130, '2014-01-15 01:31:54.000000', 'consum', 0.0225, 'lps'),
	(503852, 130, '2014-01-15 01:31:55.000000', 'consum', 0.0218, 'lps'),
	(503853, 130, '2014-01-15 01:31:56.000000', 'consum', 0.0220, 'lps'),
	(503854, 130, '2014-01-15 01:31:57.000000', 'consum', 0.0219, 'lps'),
	(503855, 130, '2014-01-15 01:31:58.000000', 'consum', 0.0226, 'lps'),
	(503856, 130, '2014-01-15 01:31:59.000000', 'consum', 0.0212, 'lps'),
	(503857, 130, '2014-01-15 01:32:00.000000', 'consum', 0.0226, 'lps'),
	(503858, 130, '2014-01-15 01:32:01.000000', 'consum', 0.0214, 'lps'),
	(503859, 130, '2014-01-15 01:32:02.000000', 'consum', 0.0216, 'lps'),
	(503860, 130, '2014-01-15 01:32:03.000000', 'consum', 0.0212, 'lps'),
	(503861, 130, '2014-01-15 01:32:04.000000', 'consum', 0.0218, 'lps'),
	(503862, 130, '2014-01-15 01:32:05.000000', 'consum', 0.0210, 'lps'),
	(503863, 130, '2014-01-15 01:32:06.000000', 'consum', 0.0224, 'lps'),
	(503864, 130, '2014-01-15 01:32:07.000000', 'consum', 0.0226, 'lps'),
	(503865, 130, '2014-01-15 01:32:08.000000', 'consum', 0.0216, 'lps'),
	(503866, 130, '2014-01-15 01:32:09.000000', 'consum', 0.0211, 'lps'),
	(503867, 130, '2014-01-15 01:32:10.000000', 'consum', 0.0216, 'lps'),
	(503868, 130, '2014-01-15 01:32:11.000000', 'consum', 0.0217, 'lps'),
	(503869, 130, '2014-01-15 01:32:12.000000', 'consum', 0.0210, 'lps'),
	(503870, 130, '2014-01-15 01:32:13.000000', 'consum', 0.0223, 'lps'),
	(503871, 130, '2014-01-15 01:32:14.000000', 'consum', 0.0210, 'lps'),
	(503872, 130, '2014-01-15 01:32:15.000000', 'consum', 0.0222, 'lps'),
	(503873, 130, '2014-01-15 01:32:16.000000', 'consum', 0.0219, 'lps'),
	(503874, 130, '2014-01-15 01:32:17.000000', 'consum', 0.0221, 'lps'),
	(503875, 130, '2014-01-15 01:32:18.000000', 'consum', 0.0219, 'lps'),
	(503876, 130, '2014-01-15 01:32:19.000000', 'consum', 0.0225, 'lps'),
	(503877, 130, '2014-01-15 01:32:20.000000', 'consum', 0.0225, 'lps'),
	(503878, 130, '2014-01-15 01:32:21.000000', 'consum', 0.0223, 'lps'),
	(503879, 130, '2014-01-15 01:32:22.000000', 'consum', 0.0215, 'lps'),
	(503880, 130, '2014-01-15 01:32:23.000000', 'consum', 0.0213, 'lps'),
	(503881, 130, '2014-01-15 01:32:24.000000', 'consum', 0.0225, 'lps'),
	(503882, 130, '2014-01-15 01:32:25.000000', 'consum', 0.0210, 'lps'),
	(503883, 130, '2014-01-15 01:32:26.000000', 'consum', 0.0215, 'lps'),
	(503884, 130, '2014-01-15 01:32:27.000000', 'consum', 0.0221, 'lps'),
	(503885, 130, '2014-01-15 01:32:28.000000', 'consum', 0.0214, 'lps'),
	(503886, 130, '2014-01-15 01:32:29.000000', 'consum', 0.0214, 'lps'),
	(503887, 130, '2014-01-15 01:32:30.000000', 'consum', 0.0219, 'lps'),
	(503888, 130, '2014-01-15 01:32:31.000000', 'consum', 0.0226, 'lps'),
	(503889, 130, '2014-01-15 01:32:32.000000', 'consum', 0.0213, 'lps'),
	(503890, 130, '2014-01-15 01:32:33.000000', 'consum', 0.0214, 'lps'),
	(503891, 130, '2014-01-15 01:32:34.000000', 'consum', 0.0218, 'lps'),
	(503892, 130, '2014-01-15 01:32:35.000000', 'consum', 0.0223, 'lps'),
	(503893, 130, '2014-01-15 01:32:36.000000', 'consum', 0.0217, 'lps'),
	(503894, 130, '2014-01-15 01:32:37.000000', 'consum', 0.0226, 'lps'),
	(503895, 130, '2014-01-15 01:32:38.000000', 'consum', 0.0215, 'lps'),
	(503896, 130, '2014-01-15 01:32:39.000000', 'consum', 0.0223, 'lps'),
	(503897, 130, '2014-01-15 01:32:40.000000', 'consum', 0.0226, 'lps'),
	(503898, 130, '2014-01-15 01:32:41.000000', 'consum', 0.0219, 'lps'),
	(503899, 130, '2014-01-15 01:32:42.000000', 'consum', 0.0223, 'lps'),
	(503900, 130, '2014-01-15 01:32:43.000000', 'consum', 0.0215, 'lps'),
	(503901, 130, '2014-01-15 01:32:44.000000', 'consum', 0.0213, 'lps'),
	(503902, 130, '2014-01-15 01:32:45.000000', 'consum', 0.0213, 'lps'),
	(503903, 130, '2014-01-15 01:32:46.000000', 'consum', 0.0215, 'lps'),
	(503904, 130, '2014-01-15 01:32:47.000000', 'consum', 0.0226, 'lps'),
	(503905, 130, '2014-01-15 01:32:48.000000', 'consum', 0.0224, 'lps'),
	(503906, 130, '2014-01-15 01:32:49.000000', 'consum', 0.0216, 'lps'),
	(503907, 130, '2014-01-15 01:32:50.000000', 'consum', 0.0214, 'lps'),
	(503908, 130, '2014-01-15 01:32:51.000000', 'consum', 0.0214, 'lps'),
	(503909, 130, '2014-01-15 01:32:52.000000', 'consum', 0.0219, 'lps'),
	(503910, 130, '2014-01-15 01:32:53.000000', 'consum', 0.0210, 'lps'),
	(503911, 130, '2014-01-15 01:32:54.000000', 'consum', 0.0217, 'lps'),
	(503912, 130, '2014-01-15 01:32:55.000000', 'consum', 0.0213, 'lps'),
	(503913, 130, '2014-01-15 01:32:56.000000', 'consum', 0.0222, 'lps'),
	(503914, 130, '2014-01-15 01:32:57.000000', 'consum', 0.0225, 'lps'),
	(503915, 130, '2014-01-15 01:32:58.000000', 'consum', 0.0216, 'lps'),
	(503916, 130, '2014-01-15 01:32:59.000000', 'consum', 0.0214, 'lps'),
	(503917, 130, '2014-01-15 01:33:00.000000', 'consum', 0.0214, 'lps'),
	(503918, 130, '2014-01-15 01:33:01.000000', 'consum', 0.0215, 'lps'),
	(503919, 130, '2014-01-15 01:33:02.000000', 'consum', 0.0224, 'lps'),
	(503920, 130, '2014-01-15 01:33:03.000000', 'consum', 0.0215, 'lps'),
	(503921, 130, '2014-01-15 01:33:04.000000', 'consum', 0.0212, 'lps'),
	(503922, 130, '2014-01-15 01:33:05.000000', 'consum', 0.0222, 'lps'),
	(503923, 130, '2014-01-15 01:33:06.000000', 'consum', 0.0215, 'lps'),
	(503924, 130, '2014-01-15 01:33:07.000000', 'consum', 0.0213, 'lps'),
	(503925, 130, '2014-01-15 01:33:08.000000', 'consum', 0.0213, 'lps'),
	(503926, 130, '2014-01-15 01:33:09.000000', 'consum', 0.0215, 'lps'),
	(503927, 130, '2014-01-15 01:33:10.000000', 'consum', 0.0226, 'lps'),
	(503928, 130, '2014-01-15 01:33:11.000000', 'consum', 0.0224, 'lps'),
	(503929, 130, '2014-01-15 01:33:12.000000', 'consum', 0.0218, 'lps'),
	(503930, 130, '2014-01-15 01:33:13.000000', 'consum', 0.0223, 'lps'),
	(503931, 130, '2014-01-15 01:33:14.000000', 'consum', 0.0220, 'lps'),
	(503932, 130, '2014-01-15 01:33:15.000000', 'consum', 0.0220, 'lps'),
	(503933, 130, '2014-01-15 01:33:16.000000', 'consum', 0.0215, 'lps'),
	(503934, 130, '2014-01-15 01:33:17.000000', 'consum', 0.0221, 'lps'),
	(503935, 130, '2014-01-15 01:33:18.000000', 'consum', 0.0215, 'lps'),
	(503936, 130, '2014-01-15 01:33:19.000000', 'consum', 0.0220, 'lps'),
	(503937, 130, '2014-01-15 01:33:20.000000', 'consum', 0.0213, 'lps'),
	(503938, 130, '2014-01-15 01:33:21.000000', 'consum', 0.0213, 'lps'),
	(503939, 130, '2014-01-15 01:33:22.000000', 'consum', 0.0217, 'lps'),
	(503940, 130, '2014-01-15 01:33:23.000000', 'consum', 0.0217, 'lps'),
	(503941, 130, '2014-01-15 01:33:24.000000', 'consum', 0.0210, 'lps'),
	(503942, 130, '2014-01-15 01:33:25.000000', 'consum', 0.0221, 'lps'),
	(503943, 130, '2014-01-15 01:33:26.000000', 'consum', 0.0217, 'lps'),
	(503944, 130, '2014-01-15 01:33:27.000000', 'consum', 0.0213, 'lps'),
	(503945, 130, '2014-01-15 01:33:28.000000', 'consum', 0.0220, 'lps'),
	(503946, 130, '2014-01-15 01:33:29.000000', 'consum', 0.0217, 'lps'),
	(503947, 130, '2014-01-15 01:33:30.000000', 'consum', 0.0218, 'lps'),
	(503948, 130, '2014-01-15 01:33:31.000000', 'consum', 0.0212, 'lps'),
	(503949, 130, '2014-01-15 01:33:32.000000', 'consum', 0.0212, 'lps'),
	(503950, 130, '2014-01-15 01:33:33.000000', 'consum', 0.0217, 'lps'),
	(503951, 130, '2014-01-15 01:33:34.000000', 'consum', 0.0222, 'lps'),
	(503952, 130, '2014-01-15 01:33:35.000000', 'consum', 0.0214, 'lps'),
	(503953, 130, '2014-01-15 01:33:36.000000', 'consum', 0.0214, 'lps'),
	(503954, 130, '2014-01-15 01:33:37.000000', 'consum', 0.0216, 'lps'),
	(503955, 130, '2014-01-15 01:33:38.000000', 'consum', 0.0214, 'lps'),
	(503956, 130, '2014-01-15 01:33:39.000000', 'consum', 0.0213, 'lps'),
	(503957, 130, '2014-01-15 01:33:40.000000', 'consum', 0.0214, 'lps'),
	(503958, 130, '2014-01-15 01:33:41.000000', 'consum', 0.0221, 'lps'),
	(503959, 130, '2014-01-15 01:33:42.000000', 'consum', 0.0217, 'lps'),
	(503960, 130, '2014-01-15 01:33:43.000000', 'consum', 0.0215, 'lps'),
	(503961, 130, '2014-01-15 01:33:44.000000', 'consum', 0.0213, 'lps'),
	(503962, 130, '2014-01-15 01:33:45.000000', 'consum', 0.0212, 'lps'),
	(503963, 130, '2014-01-15 01:33:46.000000', 'consum', 0.0211, 'lps'),
	(503964, 130, '2014-01-15 01:33:47.000000', 'consum', 0.0226, 'lps'),
	(503965, 130, '2014-01-15 01:33:48.000000', 'consum', 0.0222, 'lps'),
	(503966, 130, '2014-01-15 01:33:49.000000', 'consum', 0.0219, 'lps'),
	(503967, 130, '2014-01-15 01:33:50.000000', 'consum', 0.0221, 'lps'),
	(503968, 130, '2014-01-15 01:33:51.000000', 'consum', 0.0222, 'lps'),
	(503969, 130, '2014-01-15 01:33:52.000000', 'consum', 0.0220, 'lps'),
	(503970, 130, '2014-01-15 01:33:53.000000', 'consum', 0.0223, 'lps'),
	(503971, 130, '2014-01-15 01:33:54.000000', 'consum', 0.0214, 'lps'),
	(503972, 130, '2014-01-15 01:33:55.000000', 'consum', 0.0224, 'lps'),
	(503973, 130, '2014-01-15 01:33:56.000000', 'consum', 0.0218, 'lps'),
	(503974, 130, '2014-01-15 01:33:57.000000', 'consum', 0.0224, 'lps'),
	(503975, 130, '2014-01-15 01:33:58.000000', 'consum', 0.0224, 'lps'),
	(503976, 130, '2014-01-15 01:33:59.000000', 'consum', 0.0222, 'lps'),
	(503977, 130, '2014-01-15 01:34:00.000000', 'consum', 0.0211, 'lps'),
	(503978, 130, '2014-01-15 01:34:01.000000', 'consum', 0.0215, 'lps'),
	(503979, 130, '2014-01-15 01:34:02.000000', 'consum', 0.0214, 'lps'),
	(503980, 130, '2014-01-15 01:34:03.000000', 'consum', 0.0216, 'lps'),
	(503981, 130, '2014-01-15 01:34:04.000000', 'consum', 0.0212, 'lps'),
	(503982, 130, '2014-01-15 01:34:05.000000', 'consum', 0.0219, 'lps'),
	(503983, 130, '2014-01-15 01:34:06.000000', 'consum', 0.0216, 'lps'),
	(503984, 130, '2014-01-15 01:34:07.000000', 'consum', 0.0215, 'lps'),
	(503985, 130, '2014-01-15 01:34:08.000000', 'consum', 0.0218, 'lps'),
	(503986, 130, '2014-01-15 01:34:09.000000', 'consum', 0.0215, 'lps'),
	(503987, 130, '2014-01-15 01:34:10.000000', 'consum', 0.0214, 'lps'),
	(503988, 130, '2014-01-15 01:34:11.000000', 'consum', 0.0215, 'lps'),
	(503989, 130, '2014-01-15 01:34:12.000000', 'consum', 0.0225, 'lps'),
	(503990, 130, '2014-01-15 01:34:13.000000', 'consum', 0.0217, 'lps'),
	(503991, 130, '2014-01-15 01:34:14.000000', 'consum', 0.0219, 'lps'),
	(503992, 130, '2014-01-15 01:34:15.000000', 'consum', 0.0216, 'lps'),
	(503993, 130, '2014-01-15 01:34:16.000000', 'consum', 0.0215, 'lps'),
	(503994, 130, '2014-01-15 01:34:17.000000', 'consum', 0.0216, 'lps'),
	(503995, 130, '2014-01-15 01:34:18.000000', 'consum', 0.0225, 'lps'),
	(503996, 130, '2014-01-15 01:34:19.000000', 'consum', 0.0216, 'lps'),
	(503997, 130, '2014-01-15 01:34:20.000000', 'consum', 0.0213, 'lps'),
	(503998, 130, '2014-01-15 01:34:21.000000', 'consum', 0.0224, 'lps'),
	(503999, 130, '2014-01-15 01:34:22.000000', 'consum', 0.0219, 'lps'),
	(504000, 130, '2014-01-15 01:34:23.000000', 'consum', 0.0216, 'lps'),
	(504001, 130, '2014-01-15 01:34:24.000000', 'consum', 0.0212, 'lps'),
	(504002, 130, '2014-01-15 01:34:25.000000', 'consum', 0.0222, 'lps'),
	(504003, 130, '2014-01-15 01:34:26.000000', 'consum', 0.0213, 'lps'),
	(504004, 130, '2014-01-15 01:34:27.000000', 'consum', 0.0222, 'lps'),
	(504005, 130, '2014-01-15 01:34:28.000000', 'consum', 0.0211, 'lps'),
	(504006, 130, '2014-01-15 01:34:29.000000', 'consum', 0.0214, 'lps'),
	(504007, 130, '2014-01-15 01:34:30.000000', 'consum', 0.0211, 'lps'),
	(504008, 130, '2014-01-15 01:34:31.000000', 'consum', 0.0219, 'lps'),
	(504009, 130, '2014-01-15 01:34:32.000000', 'consum', 0.0221, 'lps'),
	(504010, 130, '2014-01-15 01:34:33.000000', 'consum', 0.0220, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(504011, 130, '2014-01-15 01:34:34.000000', 'consum', 0.0210, 'lps'),
	(504012, 130, '2014-01-15 01:34:35.000000', 'consum', 0.0217, 'lps'),
	(504013, 130, '2014-01-15 01:34:36.000000', 'consum', 0.0226, 'lps'),
	(504014, 130, '2014-01-15 01:34:37.000000', 'consum', 0.0218, 'lps'),
	(504015, 130, '2014-01-15 01:34:38.000000', 'consum', 0.0220, 'lps'),
	(504016, 130, '2014-01-15 01:34:39.000000', 'consum', 0.0221, 'lps'),
	(504017, 130, '2014-01-15 01:34:40.000000', 'consum', 0.0219, 'lps'),
	(504018, 130, '2014-01-15 01:34:41.000000', 'consum', 0.0220, 'lps'),
	(504019, 130, '2014-01-15 01:34:42.000000', 'consum', 0.0217, 'lps'),
	(504020, 130, '2014-01-15 01:34:43.000000', 'consum', 0.0214, 'lps'),
	(504021, 130, '2014-01-15 01:34:44.000000', 'consum', 0.0210, 'lps'),
	(504022, 130, '2014-01-15 01:34:45.000000', 'consum', 0.0217, 'lps'),
	(504023, 130, '2014-01-15 01:34:46.000000', 'consum', 0.0226, 'lps'),
	(504024, 130, '2014-01-15 01:34:47.000000', 'consum', 0.0221, 'lps'),
	(504025, 130, '2014-01-15 01:34:48.000000', 'consum', 0.0216, 'lps'),
	(504026, 130, '2014-01-15 01:34:49.000000', 'consum', 0.0210, 'lps'),
	(504027, 130, '2014-01-15 01:34:50.000000', 'consum', 0.0224, 'lps'),
	(504028, 130, '2014-01-15 01:34:51.000000', 'consum', 0.0211, 'lps'),
	(504029, 130, '2014-01-15 01:34:52.000000', 'consum', 0.0210, 'lps'),
	(504030, 130, '2014-01-15 01:34:53.000000', 'consum', 0.0222, 'lps'),
	(504031, 130, '2014-01-15 01:34:54.000000', 'consum', 0.0220, 'lps'),
	(504032, 130, '2014-01-15 01:34:55.000000', 'consum', 0.0225, 'lps'),
	(504033, 130, '2014-01-15 01:34:56.000000', 'consum', 0.0220, 'lps'),
	(504034, 130, '2014-01-15 01:34:57.000000', 'consum', 0.0216, 'lps'),
	(504035, 130, '2014-01-15 01:34:58.000000', 'consum', 0.0213, 'lps'),
	(504036, 130, '2014-01-15 01:34:59.000000', 'consum', 0.0221, 'lps'),
	(504037, 130, '2014-01-15 01:35:00.000000', 'consum', 0.0224, 'lps'),
	(504038, 130, '2014-01-15 01:35:01.000000', 'consum', 0.0212, 'lps'),
	(504039, 130, '2014-01-15 01:35:02.000000', 'consum', 0.0215, 'lps'),
	(504040, 130, '2014-01-15 01:35:03.000000', 'consum', 0.0211, 'lps'),
	(504041, 130, '2014-01-15 01:35:04.000000', 'consum', 0.0218, 'lps'),
	(504042, 130, '2014-01-15 01:35:05.000000', 'consum', 0.0213, 'lps'),
	(504043, 130, '2014-01-15 01:35:06.000000', 'consum', 0.0217, 'lps'),
	(504044, 130, '2014-01-15 01:35:07.000000', 'consum', 0.0221, 'lps'),
	(504045, 130, '2014-01-15 01:35:08.000000', 'consum', 0.0212, 'lps'),
	(504046, 130, '2014-01-15 01:35:09.000000', 'consum', 0.0218, 'lps'),
	(504047, 130, '2014-01-15 01:35:10.000000', 'consum', 0.0214, 'lps'),
	(504048, 130, '2014-01-15 01:35:11.000000', 'consum', 0.0222, 'lps'),
	(504049, 130, '2014-01-15 01:35:12.000000', 'consum', 0.0225, 'lps'),
	(504050, 130, '2014-01-15 01:35:13.000000', 'consum', 0.0217, 'lps'),
	(504051, 130, '2014-01-15 01:35:14.000000', 'consum', 0.0215, 'lps'),
	(504052, 130, '2014-01-15 01:35:15.000000', 'consum', 0.0214, 'lps'),
	(504053, 130, '2014-01-15 01:35:16.000000', 'consum', 0.0218, 'lps'),
	(504054, 130, '2014-01-15 01:35:17.000000', 'consum', 0.0219, 'lps'),
	(504055, 130, '2014-01-15 01:35:18.000000', 'consum', 0.0215, 'lps'),
	(504056, 130, '2014-01-15 01:35:19.000000', 'consum', 0.0210, 'lps'),
	(504057, 130, '2014-01-15 01:35:20.000000', 'consum', 0.0213, 'lps'),
	(504058, 130, '2014-01-15 01:35:21.000000', 'consum', 0.0224, 'lps'),
	(504059, 130, '2014-01-15 01:35:22.000000', 'consum', 0.0221, 'lps'),
	(504060, 130, '2014-01-15 01:35:23.000000', 'consum', 0.0224, 'lps'),
	(504061, 130, '2014-01-15 01:35:24.000000', 'consum', 0.0212, 'lps'),
	(504062, 130, '2014-01-15 01:35:25.000000', 'consum', 0.0215, 'lps'),
	(504063, 130, '2014-01-15 01:35:26.000000', 'consum', 0.0211, 'lps'),
	(504064, 130, '2014-01-15 01:35:27.000000', 'consum', 0.0216, 'lps'),
	(504065, 130, '2014-01-15 01:35:28.000000', 'consum', 0.0221, 'lps'),
	(504066, 130, '2014-01-15 01:35:29.000000', 'consum', 0.0216, 'lps'),
	(504067, 130, '2014-01-15 01:35:30.000000', 'consum', 0.0222, 'lps'),
	(504068, 130, '2014-01-15 01:35:31.000000', 'consum', 0.0218, 'lps'),
	(504069, 130, '2014-01-15 01:35:32.000000', 'consum', 0.0214, 'lps'),
	(504070, 130, '2014-01-15 01:35:33.000000', 'consum', 0.0225, 'lps'),
	(504071, 130, '2014-01-15 01:35:34.000000', 'consum', 0.0223, 'lps'),
	(504072, 130, '2014-01-15 01:35:35.000000', 'consum', 0.0215, 'lps'),
	(504073, 130, '2014-01-15 01:35:36.000000', 'consum', 0.0212, 'lps'),
	(504074, 130, '2014-01-15 01:35:37.000000', 'consum', 0.0223, 'lps'),
	(504075, 130, '2014-01-15 01:35:38.000000', 'consum', 0.0217, 'lps'),
	(504076, 130, '2014-01-15 01:35:39.000000', 'consum', 0.0223, 'lps'),
	(504077, 130, '2014-01-15 01:35:40.000000', 'consum', 0.0222, 'lps'),
	(504078, 130, '2014-01-15 01:35:41.000000', 'consum', 0.0212, 'lps'),
	(504079, 130, '2014-01-15 01:35:42.000000', 'consum', 0.0221, 'lps'),
	(504080, 130, '2014-01-15 01:35:43.000000', 'consum', 0.0226, 'lps'),
	(504081, 130, '2014-01-15 01:35:44.000000', 'consum', 0.0222, 'lps'),
	(504082, 130, '2014-01-15 01:35:45.000000', 'consum', 0.0222, 'lps'),
	(504083, 130, '2014-01-15 01:35:46.000000', 'consum', 0.0220, 'lps'),
	(504084, 130, '2014-01-15 01:35:47.000000', 'consum', 0.0222, 'lps'),
	(504085, 130, '2014-01-15 01:35:48.000000', 'consum', 0.0222, 'lps'),
	(504086, 130, '2014-01-15 01:35:49.000000', 'consum', 0.0221, 'lps'),
	(504087, 130, '2014-01-15 01:35:50.000000', 'consum', 0.0212, 'lps'),
	(504088, 130, '2014-01-15 01:35:51.000000', 'consum', 0.0219, 'lps'),
	(504089, 130, '2014-01-15 01:35:52.000000', 'consum', 0.0216, 'lps'),
	(504090, 130, '2014-01-15 01:35:53.000000', 'consum', 0.0216, 'lps'),
	(504091, 130, '2014-01-15 01:35:54.000000', 'consum', 0.0220, 'lps'),
	(504092, 130, '2014-01-15 01:35:55.000000', 'consum', 0.0224, 'lps'),
	(504093, 130, '2014-01-15 01:35:56.000000', 'consum', 0.0220, 'lps'),
	(504094, 130, '2014-01-15 01:35:57.000000', 'consum', 0.0218, 'lps'),
	(504095, 130, '2014-01-15 01:35:58.000000', 'consum', 0.0220, 'lps'),
	(504096, 130, '2014-01-15 01:35:59.000000', 'consum', 0.0218, 'lps'),
	(504097, 130, '2014-01-15 01:36:00.000000', 'consum', 0.0222, 'lps'),
	(504098, 130, '2014-01-15 01:36:01.000000', 'consum', 0.0211, 'lps'),
	(504099, 130, '2014-01-15 01:36:02.000000', 'consum', 0.0215, 'lps'),
	(504100, 130, '2014-01-15 01:36:03.000000', 'consum', 0.0217, 'lps'),
	(504101, 130, '2014-01-15 01:36:04.000000', 'consum', 0.0213, 'lps'),
	(504102, 130, '2014-01-15 01:36:05.000000', 'consum', 0.0220, 'lps'),
	(504103, 130, '2014-01-15 01:36:06.000000', 'consum', 0.0217, 'lps'),
	(504104, 130, '2014-01-15 01:36:07.000000', 'consum', 0.0216, 'lps'),
	(504105, 130, '2014-01-15 01:36:08.000000', 'consum', 0.0218, 'lps'),
	(504106, 130, '2014-01-15 01:36:09.000000', 'consum', 0.0216, 'lps'),
	(504107, 130, '2014-01-15 01:36:10.000000', 'consum', 0.0216, 'lps'),
	(504108, 130, '2014-01-15 01:36:11.000000', 'consum', 0.0225, 'lps'),
	(504109, 130, '2014-01-15 01:36:12.000000', 'consum', 0.0214, 'lps'),
	(504110, 130, '2014-01-15 01:36:13.000000', 'consum', 0.0219, 'lps'),
	(504111, 130, '2014-01-15 01:36:14.000000', 'consum', 0.0210, 'lps'),
	(504112, 130, '2014-01-15 01:36:15.000000', 'consum', 0.0219, 'lps'),
	(504113, 130, '2014-01-15 01:36:16.000000', 'consum', 0.0223, 'lps'),
	(504114, 130, '2014-01-15 01:36:17.000000', 'consum', 0.0212, 'lps'),
	(504115, 130, '2014-01-15 01:36:18.000000', 'consum', 0.0217, 'lps'),
	(504116, 130, '2014-01-15 01:36:19.000000', 'consum', 0.0220, 'lps'),
	(504117, 130, '2014-01-15 01:36:20.000000', 'consum', 0.0223, 'lps'),
	(504118, 130, '2014-01-15 01:36:21.000000', 'consum', 0.0212, 'lps'),
	(504119, 130, '2014-01-15 01:36:22.000000', 'consum', 0.0217, 'lps'),
	(504120, 130, '2014-01-15 01:36:23.000000', 'consum', 0.0223, 'lps'),
	(504121, 130, '2014-01-15 01:36:24.000000', 'consum', 0.0219, 'lps'),
	(504122, 130, '2014-01-15 01:36:25.000000', 'consum', 0.0218, 'lps'),
	(504123, 130, '2014-01-15 01:36:26.000000', 'consum', 0.0222, 'lps'),
	(504124, 130, '2014-01-15 01:36:27.000000', 'consum', 0.0215, 'lps'),
	(504125, 130, '2014-01-15 01:36:28.000000', 'consum', 0.0216, 'lps'),
	(504126, 130, '2014-01-15 01:36:29.000000', 'consum', 0.0223, 'lps'),
	(504127, 130, '2014-01-15 01:36:30.000000', 'consum', 0.0224, 'lps'),
	(504128, 130, '2014-01-15 01:36:31.000000', 'consum', 0.0226, 'lps'),
	(504129, 130, '2014-01-15 01:36:32.000000', 'consum', 0.0212, 'lps'),
	(504130, 130, '2014-01-15 01:36:33.000000', 'consum', 0.0225, 'lps'),
	(504131, 130, '2014-01-15 01:36:34.000000', 'consum', 0.0226, 'lps'),
	(504132, 130, '2014-01-15 01:36:35.000000', 'consum', 0.0215, 'lps'),
	(504133, 130, '2014-01-15 01:36:36.000000', 'consum', 0.0221, 'lps'),
	(504134, 130, '2014-01-15 01:36:37.000000', 'consum', 0.0216, 'lps'),
	(504135, 130, '2014-01-15 01:36:38.000000', 'consum', 0.0225, 'lps'),
	(504136, 130, '2014-01-15 01:36:39.000000', 'consum', 0.0215, 'lps'),
	(504137, 130, '2014-01-15 01:36:40.000000', 'consum', 0.0224, 'lps'),
	(504138, 130, '2014-01-15 01:36:41.000000', 'consum', 0.0214, 'lps'),
	(504139, 130, '2014-01-15 01:36:42.000000', 'consum', 0.0222, 'lps'),
	(504140, 130, '2014-01-15 01:36:43.000000', 'consum', 0.0225, 'lps'),
	(504141, 130, '2014-01-15 01:36:44.000000', 'consum', 0.0217, 'lps'),
	(504142, 130, '2014-01-15 01:36:45.000000', 'consum', 0.0218, 'lps'),
	(504143, 130, '2014-01-15 01:36:46.000000', 'consum', 0.0210, 'lps'),
	(504144, 130, '2014-01-15 01:36:47.000000', 'consum', 0.0221, 'lps'),
	(504145, 130, '2014-01-15 01:36:48.000000', 'consum', 0.0213, 'lps'),
	(504146, 130, '2014-01-15 01:36:49.000000', 'consum', 0.0212, 'lps'),
	(504147, 130, '2014-01-15 01:36:50.000000', 'consum', 0.0210, 'lps'),
	(504148, 130, '2014-01-15 01:36:51.000000', 'consum', 0.0221, 'lps'),
	(504149, 130, '2014-01-15 01:36:52.000000', 'consum', 0.0214, 'lps'),
	(504150, 130, '2014-01-15 01:36:53.000000', 'consum', 0.0215, 'lps'),
	(504151, 130, '2014-01-15 01:36:54.000000', 'consum', 0.0225, 'lps'),
	(504152, 130, '2014-01-15 01:36:55.000000', 'consum', 0.0221, 'lps'),
	(504153, 130, '2014-01-15 01:36:56.000000', 'consum', 0.0217, 'lps'),
	(504154, 130, '2014-01-15 01:36:57.000000', 'consum', 0.0216, 'lps'),
	(504155, 130, '2014-01-15 01:36:58.000000', 'consum', 0.0216, 'lps'),
	(504156, 130, '2014-01-15 01:36:59.000000', 'consum', 0.0225, 'lps'),
	(504157, 130, '2014-01-15 01:37:00.000000', 'consum', 0.0217, 'lps'),
	(504158, 130, '2014-01-15 01:37:01.000000', 'consum', 0.0216, 'lps'),
	(504159, 130, '2014-01-15 01:37:02.000000', 'consum', 0.0218, 'lps'),
	(504160, 130, '2014-01-15 01:37:03.000000', 'consum', 0.0216, 'lps'),
	(504161, 130, '2014-01-15 01:37:04.000000', 'consum', 0.0219, 'lps'),
	(504162, 130, '2014-01-15 01:37:05.000000', 'consum', 0.0220, 'lps'),
	(504163, 130, '2014-01-15 01:37:06.000000', 'consum', 0.0215, 'lps'),
	(504164, 130, '2014-01-15 01:37:07.000000', 'consum', 0.0221, 'lps'),
	(504165, 130, '2014-01-15 01:37:08.000000', 'consum', 0.0220, 'lps'),
	(504166, 130, '2014-01-15 01:37:09.000000', 'consum', 0.0225, 'lps'),
	(504167, 130, '2014-01-15 01:37:10.000000', 'consum', 0.0222, 'lps'),
	(504168, 130, '2014-01-15 01:37:11.000000', 'consum', 0.0210, 'lps'),
	(504169, 130, '2014-01-15 01:37:12.000000', 'consum', 0.0223, 'lps'),
	(504170, 130, '2014-01-15 01:37:13.000000', 'consum', 0.0225, 'lps'),
	(504171, 130, '2014-01-15 01:37:14.000000', 'consum', 0.0215, 'lps'),
	(504172, 130, '2014-01-15 01:37:15.000000', 'consum', 0.0221, 'lps'),
	(504173, 130, '2014-01-15 01:37:16.000000', 'consum', 0.0218, 'lps'),
	(504174, 130, '2014-01-15 01:37:17.000000', 'consum', 0.0217, 'lps'),
	(504175, 130, '2014-01-15 01:37:18.000000', 'consum', 0.0220, 'lps'),
	(504176, 130, '2014-01-15 01:37:19.000000', 'consum', 0.0223, 'lps'),
	(504177, 130, '2014-01-15 01:37:20.000000', 'consum', 0.0211, 'lps'),
	(504178, 130, '2014-01-15 01:37:21.000000', 'consum', 0.0210, 'lps'),
	(504179, 130, '2014-01-15 01:37:22.000000', 'consum', 0.0226, 'lps'),
	(504180, 130, '2014-01-15 01:37:23.000000', 'consum', 0.0223, 'lps'),
	(504181, 130, '2014-01-15 01:37:24.000000', 'consum', 0.0226, 'lps'),
	(504182, 130, '2014-01-15 01:37:25.000000', 'consum', 0.0219, 'lps'),
	(504183, 130, '2014-01-15 01:37:26.000000', 'consum', 0.0223, 'lps'),
	(504184, 130, '2014-01-15 01:37:27.000000', 'consum', 0.0215, 'lps'),
	(504185, 130, '2014-01-15 01:37:28.000000', 'consum', 0.0214, 'lps'),
	(504186, 130, '2014-01-15 01:37:29.000000', 'consum', 0.0216, 'lps'),
	(504187, 130, '2014-01-15 01:37:30.000000', 'consum', 0.0212, 'lps'),
	(504188, 130, '2014-01-15 01:37:31.000000', 'consum', 0.0220, 'lps'),
	(504189, 130, '2014-01-15 01:37:32.000000', 'consum', 0.0219, 'lps'),
	(504190, 130, '2014-01-15 01:37:33.000000', 'consum', 0.0226, 'lps'),
	(504191, 130, '2014-01-15 01:37:34.000000', 'consum', 0.0213, 'lps'),
	(504192, 130, '2014-01-15 01:37:35.000000', 'consum', 0.0210, 'lps'),
	(504193, 130, '2014-01-15 01:37:36.000000', 'consum', 0.0218, 'lps'),
	(504194, 130, '2014-01-15 01:37:37.000000', 'consum', 0.0218, 'lps'),
	(504195, 130, '2014-01-15 01:37:38.000000', 'consum', 0.0226, 'lps'),
	(504196, 130, '2014-01-15 01:37:39.000000', 'consum', 0.0216, 'lps'),
	(504197, 130, '2014-01-15 01:37:40.000000', 'consum', 0.0211, 'lps'),
	(504198, 130, '2014-01-15 01:37:41.000000', 'consum', 0.0214, 'lps'),
	(504199, 130, '2014-01-15 01:37:42.000000', 'consum', 0.0211, 'lps'),
	(504200, 130, '2014-01-15 01:37:43.000000', 'consum', 0.0220, 'lps'),
	(504201, 130, '2014-01-15 01:37:44.000000', 'consum', 0.0224, 'lps'),
	(504202, 130, '2014-01-15 01:37:45.000000', 'consum', 0.0216, 'lps'),
	(504203, 130, '2014-01-15 01:37:46.000000', 'consum', 0.0215, 'lps'),
	(504204, 130, '2014-01-15 01:37:47.000000', 'consum', 0.0216, 'lps'),
	(504205, 130, '2014-01-15 01:37:48.000000', 'consum', 0.0210, 'lps'),
	(504206, 130, '2014-01-15 01:37:49.000000', 'consum', 0.0211, 'lps'),
	(504207, 130, '2014-01-15 01:37:50.000000', 'consum', 0.0216, 'lps'),
	(504208, 130, '2014-01-15 01:37:51.000000', 'consum', 0.0219, 'lps'),
	(504209, 131, '2014-01-15 00:00:00.000000', 'consum', 0.0216, 'lps'),
	(504210, 131, '2014-01-15 00:00:01.000000', 'consum', 0.0214, 'lps'),
	(504211, 131, '2014-01-15 00:00:02.000000', 'consum', 0.0211, 'lps'),
	(504212, 131, '2014-01-15 00:00:03.000000', 'consum', 0.0228, 'lps'),
	(504213, 131, '2014-01-15 00:00:04.000000', 'consum', 0.0211, 'lps'),
	(504214, 131, '2014-01-15 00:00:05.000000', 'consum', 0.0224, 'lps'),
	(504215, 131, '2014-01-15 00:00:06.000000', 'consum', 0.0211, 'lps'),
	(504216, 131, '2014-01-15 00:00:07.000000', 'consum', 0.0220, 'lps'),
	(504217, 131, '2014-01-15 00:00:08.000000', 'consum', 0.0213, 'lps'),
	(504218, 131, '2014-01-15 00:00:09.000000', 'consum', 0.0217, 'lps'),
	(504219, 131, '2014-01-15 00:00:10.000000', 'consum', 0.0214, 'lps'),
	(504220, 131, '2014-01-15 00:00:11.000000', 'consum', 0.0211, 'lps'),
	(504221, 131, '2014-01-15 00:00:12.000000', 'consum', 0.0223, 'lps'),
	(504222, 131, '2014-01-15 00:00:13.000000', 'consum', 0.0229, 'lps'),
	(504223, 131, '2014-01-15 00:00:14.000000', 'consum', 0.0222, 'lps'),
	(504224, 131, '2014-01-15 00:00:15.000000', 'consum', 0.0213, 'lps'),
	(504225, 131, '2014-01-15 00:00:16.000000', 'consum', 0.0214, 'lps'),
	(504226, 131, '2014-01-15 00:00:17.000000', 'consum', 0.0220, 'lps'),
	(504227, 131, '2014-01-15 00:00:18.000000', 'consum', 0.0228, 'lps'),
	(504228, 131, '2014-01-15 00:00:19.000000', 'consum', 0.0224, 'lps'),
	(504229, 131, '2014-01-15 00:00:20.000000', 'consum', 0.0229, 'lps'),
	(504230, 131, '2014-01-15 00:00:21.000000', 'consum', 0.0220, 'lps'),
	(504231, 131, '2014-01-15 00:00:22.000000', 'consum', 0.0224, 'lps'),
	(504232, 131, '2014-01-15 00:00:23.000000', 'consum', 0.0228, 'lps'),
	(504233, 131, '2014-01-15 00:00:24.000000', 'consum', 0.0215, 'lps'),
	(504234, 131, '2014-01-15 00:00:25.000000', 'consum', 0.0227, 'lps'),
	(504235, 131, '2014-01-15 00:00:26.000000', 'consum', 0.0212, 'lps'),
	(504236, 131, '2014-01-15 00:00:27.000000', 'consum', 0.0215, 'lps'),
	(504237, 131, '2014-01-15 00:00:28.000000', 'consum', 0.0231, 'lps'),
	(504238, 131, '2014-01-15 00:00:29.000000', 'consum', 0.0210, 'lps'),
	(504239, 131, '2014-01-15 00:00:30.000000', 'consum', 0.0216, 'lps'),
	(504240, 131, '2014-01-15 00:00:31.000000', 'consum', 0.0217, 'lps'),
	(504241, 131, '2014-01-15 00:00:32.000000', 'consum', 0.0226, 'lps'),
	(504242, 131, '2014-01-15 00:00:33.000000', 'consum', 0.0227, 'lps'),
	(504243, 131, '2014-01-15 00:00:34.000000', 'consum', 0.0226, 'lps'),
	(504244, 131, '2014-01-15 00:00:35.000000', 'consum', 0.0217, 'lps'),
	(504245, 131, '2014-01-15 00:00:36.000000', 'consum', 0.0218, 'lps'),
	(504246, 131, '2014-01-15 00:00:37.000000', 'consum', 0.0229, 'lps'),
	(504247, 131, '2014-01-15 00:00:38.000000', 'consum', 0.0217, 'lps'),
	(504248, 131, '2014-01-15 00:00:39.000000', 'consum', 0.0210, 'lps'),
	(504249, 131, '2014-01-15 00:00:40.000000', 'consum', 0.0210, 'lps'),
	(504250, 131, '2014-01-15 00:00:41.000000', 'consum', 0.0213, 'lps'),
	(504251, 131, '2014-01-15 00:00:42.000000', 'consum', 0.0224, 'lps'),
	(504252, 131, '2014-01-15 00:00:43.000000', 'consum', 0.0229, 'lps'),
	(504253, 131, '2014-01-15 00:00:44.000000', 'consum', 0.0219, 'lps'),
	(504254, 131, '2014-01-15 00:00:45.000000', 'consum', 0.0220, 'lps'),
	(504255, 131, '2014-01-15 00:00:46.000000', 'consum', 0.0211, 'lps'),
	(504256, 131, '2014-01-15 00:00:47.000000', 'consum', 0.0231, 'lps'),
	(504257, 131, '2014-01-15 00:00:48.000000', 'consum', 0.0222, 'lps'),
	(504258, 131, '2014-01-15 00:00:49.000000', 'consum', 0.0230, 'lps'),
	(504259, 131, '2014-01-15 00:00:50.000000', 'consum', 0.0229, 'lps'),
	(504260, 131, '2014-01-15 00:00:51.000000', 'consum', 0.0226, 'lps'),
	(504261, 131, '2014-01-15 00:00:52.000000', 'consum', 0.0212, 'lps'),
	(504262, 131, '2014-01-15 00:00:53.000000', 'consum', 0.0214, 'lps'),
	(504263, 131, '2014-01-15 00:00:54.000000', 'consum', 0.0228, 'lps'),
	(504264, 131, '2014-01-15 00:00:55.000000', 'consum', 0.0219, 'lps'),
	(504265, 131, '2014-01-15 00:00:56.000000', 'consum', 0.0225, 'lps'),
	(504266, 131, '2014-01-15 00:00:57.000000', 'consum', 0.0214, 'lps'),
	(504267, 131, '2014-01-15 00:00:58.000000', 'consum', 0.0210, 'lps'),
	(504268, 131, '2014-01-15 00:00:59.000000', 'consum', 0.0218, 'lps'),
	(504269, 131, '2014-01-15 00:01:00.000000', 'consum', 0.0228, 'lps'),
	(504270, 131, '2014-01-15 00:01:01.000000', 'consum', 0.0212, 'lps'),
	(504271, 131, '2014-01-15 00:01:02.000000', 'consum', 0.0210, 'lps'),
	(504272, 131, '2014-01-15 00:01:03.000000', 'consum', 0.0226, 'lps'),
	(504273, 131, '2014-01-15 00:01:04.000000', 'consum', 0.0226, 'lps'),
	(504274, 131, '2014-01-15 00:01:05.000000', 'consum', 0.0219, 'lps'),
	(504275, 131, '2014-01-15 00:01:06.000000', 'consum', 0.0229, 'lps'),
	(504276, 131, '2014-01-15 00:01:07.000000', 'consum', 0.0212, 'lps'),
	(504277, 131, '2014-01-15 00:01:08.000000', 'consum', 0.0231, 'lps'),
	(504278, 131, '2014-01-15 00:01:09.000000', 'consum', 0.0221, 'lps'),
	(504279, 131, '2014-01-15 00:01:10.000000', 'consum', 0.0225, 'lps'),
	(504280, 131, '2014-01-15 00:01:11.000000', 'consum', 0.0229, 'lps'),
	(504281, 131, '2014-01-15 00:01:12.000000', 'consum', 0.0218, 'lps'),
	(504282, 131, '2014-01-15 00:01:13.000000', 'consum', 0.0216, 'lps'),
	(504283, 131, '2014-01-15 00:01:14.000000', 'consum', 0.0217, 'lps'),
	(504284, 131, '2014-01-15 00:01:15.000000', 'consum', 0.0227, 'lps'),
	(504285, 131, '2014-01-15 00:01:16.000000', 'consum', 0.0210, 'lps'),
	(504286, 131, '2014-01-15 00:01:17.000000', 'consum', 0.0225, 'lps'),
	(504287, 131, '2014-01-15 00:01:18.000000', 'consum', 0.0218, 'lps'),
	(504288, 131, '2014-01-15 00:01:19.000000', 'consum', 0.0229, 'lps'),
	(504289, 131, '2014-01-15 00:01:20.000000', 'consum', 0.0214, 'lps'),
	(504290, 131, '2014-01-15 00:01:21.000000', 'consum', 0.0217, 'lps'),
	(504291, 131, '2014-01-15 00:01:22.000000', 'consum', 0.0213, 'lps'),
	(504292, 131, '2014-01-15 00:01:23.000000', 'consum', 0.0224, 'lps'),
	(504293, 131, '2014-01-15 00:01:24.000000', 'consum', 0.0229, 'lps'),
	(504294, 131, '2014-01-15 00:01:25.000000', 'consum', 0.0218, 'lps'),
	(504295, 131, '2014-01-15 00:01:26.000000', 'consum', 0.0215, 'lps'),
	(504296, 131, '2014-01-15 00:01:27.000000', 'consum', 0.0213, 'lps'),
	(504297, 131, '2014-01-15 00:01:28.000000', 'consum', 0.0230, 'lps'),
	(504298, 131, '2014-01-15 00:01:29.000000', 'consum', 0.0216, 'lps'),
	(504299, 131, '2014-01-15 00:01:30.000000', 'consum', 0.0225, 'lps'),
	(504300, 131, '2014-01-15 00:01:31.000000', 'consum', 0.0224, 'lps'),
	(504301, 131, '2014-01-15 00:01:32.000000', 'consum', 0.0210, 'lps'),
	(504302, 131, '2014-01-15 00:01:33.000000', 'consum', 0.0216, 'lps'),
	(504303, 131, '2014-01-15 00:01:34.000000', 'consum', 0.0218, 'lps'),
	(504304, 131, '2014-01-15 00:01:35.000000', 'consum', 0.0210, 'lps'),
	(504305, 131, '2014-01-15 00:01:36.000000', 'consum', 0.0230, 'lps'),
	(504306, 131, '2014-01-15 00:01:37.000000', 'consum', 0.0224, 'lps'),
	(504307, 131, '2014-01-15 00:01:38.000000', 'consum', 0.0219, 'lps'),
	(504308, 131, '2014-01-15 00:01:39.000000', 'consum', 0.0212, 'lps'),
	(504309, 131, '2014-01-15 00:01:40.000000', 'consum', 0.0217, 'lps'),
	(504310, 131, '2014-01-15 00:01:41.000000', 'consum', 0.0219, 'lps'),
	(504311, 131, '2014-01-15 00:01:42.000000', 'consum', 0.0210, 'lps'),
	(504312, 131, '2014-01-15 00:01:43.000000', 'consum', 0.0228, 'lps'),
	(504313, 131, '2014-01-15 00:01:44.000000', 'consum', 0.0211, 'lps'),
	(504314, 131, '2014-01-15 00:01:45.000000', 'consum', 0.0230, 'lps'),
	(504315, 131, '2014-01-15 00:01:46.000000', 'consum', 0.0220, 'lps'),
	(504316, 131, '2014-01-15 00:01:47.000000', 'consum', 0.0221, 'lps'),
	(504317, 131, '2014-01-15 00:01:48.000000', 'consum', 0.0216, 'lps'),
	(504318, 131, '2014-01-15 00:01:49.000000', 'consum', 0.0228, 'lps'),
	(504319, 131, '2014-01-15 00:01:50.000000', 'consum', 0.0217, 'lps'),
	(504320, 131, '2014-01-15 00:01:51.000000', 'consum', 0.0214, 'lps'),
	(504321, 131, '2014-01-15 00:01:52.000000', 'consum', 0.0231, 'lps'),
	(504322, 131, '2014-01-15 00:01:53.000000', 'consum', 0.0215, 'lps'),
	(504323, 131, '2014-01-15 00:01:54.000000', 'consum', 0.0218, 'lps'),
	(504324, 131, '2014-01-15 00:01:55.000000', 'consum', 0.0214, 'lps'),
	(504325, 131, '2014-01-15 00:01:56.000000', 'consum', 0.0227, 'lps'),
	(504326, 131, '2014-01-15 00:01:57.000000', 'consum', 0.0217, 'lps'),
	(504327, 131, '2014-01-15 00:01:58.000000', 'consum', 0.0219, 'lps'),
	(504328, 131, '2014-01-15 00:01:59.000000', 'consum', 0.0211, 'lps'),
	(504329, 131, '2014-01-15 00:02:00.000000', 'consum', 0.0231, 'lps'),
	(504330, 131, '2014-01-15 00:02:01.000000', 'consum', 0.0226, 'lps'),
	(504331, 131, '2014-01-15 00:02:02.000000', 'consum', 0.0226, 'lps'),
	(504332, 131, '2014-01-15 00:02:03.000000', 'consum', 0.0222, 'lps'),
	(504333, 131, '2014-01-15 00:02:04.000000', 'consum', 0.0221, 'lps'),
	(504334, 131, '2014-01-15 00:02:05.000000', 'consum', 0.0231, 'lps'),
	(504335, 131, '2014-01-15 00:02:06.000000', 'consum', 0.0218, 'lps'),
	(504336, 131, '2014-01-15 00:02:07.000000', 'consum', 0.0228, 'lps'),
	(504337, 131, '2014-01-15 00:02:08.000000', 'consum', 0.0213, 'lps'),
	(504338, 131, '2014-01-15 00:02:09.000000', 'consum', 0.0215, 'lps'),
	(504339, 131, '2014-01-15 00:02:10.000000', 'consum', 0.0225, 'lps'),
	(504340, 131, '2014-01-15 00:02:11.000000', 'consum', 0.0226, 'lps'),
	(504341, 131, '2014-01-15 00:02:12.000000', 'consum', 0.0226, 'lps'),
	(504342, 131, '2014-01-15 00:02:13.000000', 'consum', 0.0220, 'lps'),
	(504343, 131, '2014-01-15 00:02:14.000000', 'consum', 0.0211, 'lps'),
	(504344, 131, '2014-01-15 00:02:15.000000', 'consum', 0.0229, 'lps'),
	(504345, 131, '2014-01-15 00:02:16.000000', 'consum', 0.0215, 'lps'),
	(504346, 131, '2014-01-15 00:02:17.000000', 'consum', 0.0223, 'lps'),
	(504347, 131, '2014-01-15 00:02:18.000000', 'consum', 0.0215, 'lps'),
	(504348, 131, '2014-01-15 00:02:19.000000', 'consum', 0.0218, 'lps'),
	(504349, 131, '2014-01-15 00:02:20.000000', 'consum', 0.0216, 'lps'),
	(504350, 131, '2014-01-15 00:02:21.000000', 'consum', 0.0216, 'lps'),
	(504351, 131, '2014-01-15 00:02:22.000000', 'consum', 0.0223, 'lps'),
	(504352, 131, '2014-01-15 00:02:23.000000', 'consum', 0.0215, 'lps'),
	(504353, 131, '2014-01-15 00:02:24.000000', 'consum', 0.0216, 'lps'),
	(504354, 131, '2014-01-15 00:02:25.000000', 'consum', 0.0228, 'lps'),
	(504355, 131, '2014-01-15 00:02:26.000000', 'consum', 0.0215, 'lps'),
	(504356, 131, '2014-01-15 00:02:27.000000', 'consum', 0.0226, 'lps'),
	(504357, 131, '2014-01-15 00:02:28.000000', 'consum', 0.0231, 'lps'),
	(504358, 131, '2014-01-15 00:02:29.000000', 'consum', 0.0226, 'lps'),
	(504359, 131, '2014-01-15 00:02:30.000000', 'consum', 0.0224, 'lps'),
	(504360, 131, '2014-01-15 00:02:31.000000', 'consum', 0.0212, 'lps'),
	(504361, 131, '2014-01-15 00:02:32.000000', 'consum', 0.0223, 'lps'),
	(504362, 131, '2014-01-15 00:02:33.000000', 'consum', 0.0226, 'lps'),
	(504363, 131, '2014-01-15 00:02:34.000000', 'consum', 0.0228, 'lps'),
	(504364, 131, '2014-01-15 00:02:35.000000', 'consum', 0.0210, 'lps'),
	(504365, 131, '2014-01-15 00:02:36.000000', 'consum', 0.0223, 'lps'),
	(504366, 131, '2014-01-15 00:02:37.000000', 'consum', 0.0231, 'lps'),
	(504367, 131, '2014-01-15 00:02:38.000000', 'consum', 0.0211, 'lps'),
	(504368, 131, '2014-01-15 00:02:39.000000', 'consum', 0.0217, 'lps'),
	(504369, 131, '2014-01-15 00:02:40.000000', 'consum', 0.0223, 'lps'),
	(504370, 131, '2014-01-15 00:02:41.000000', 'consum', 0.0230, 'lps'),
	(504371, 131, '2014-01-15 00:02:42.000000', 'consum', 0.0229, 'lps'),
	(504372, 131, '2014-01-15 00:02:43.000000', 'consum', 0.0225, 'lps'),
	(504373, 131, '2014-01-15 00:02:44.000000', 'consum', 0.0228, 'lps'),
	(504374, 131, '2014-01-15 00:02:45.000000', 'consum', 0.0231, 'lps'),
	(504375, 131, '2014-01-15 00:02:46.000000', 'consum', 0.0219, 'lps'),
	(504376, 131, '2014-01-15 00:02:47.000000', 'consum', 0.0215, 'lps'),
	(504377, 131, '2014-01-15 00:02:48.000000', 'consum', 0.0228, 'lps'),
	(504378, 131, '2014-01-15 00:02:49.000000', 'consum', 0.0223, 'lps'),
	(504379, 131, '2014-01-15 00:02:50.000000', 'consum', 0.0219, 'lps'),
	(504380, 131, '2014-01-15 00:02:51.000000', 'consum', 0.0218, 'lps'),
	(504381, 131, '2014-01-15 00:02:52.000000', 'consum', 0.0222, 'lps'),
	(504382, 131, '2014-01-15 00:02:53.000000', 'consum', 0.0226, 'lps'),
	(504383, 131, '2014-01-15 00:02:54.000000', 'consum', 0.0211, 'lps'),
	(504384, 131, '2014-01-15 00:02:55.000000', 'consum', 0.0212, 'lps'),
	(504385, 131, '2014-01-15 00:02:56.000000', 'consum', 0.0217, 'lps'),
	(504386, 131, '2014-01-15 00:02:57.000000', 'consum', 0.0218, 'lps'),
	(504387, 131, '2014-01-15 00:02:58.000000', 'consum', 0.0228, 'lps'),
	(504388, 131, '2014-01-15 00:02:59.000000', 'consum', 0.0210, 'lps'),
	(504389, 131, '2014-01-15 00:03:00.000000', 'consum', 0.0224, 'lps'),
	(504390, 131, '2014-01-15 00:03:01.000000', 'consum', 0.0214, 'lps'),
	(504391, 131, '2014-01-15 00:03:02.000000', 'consum', 0.0212, 'lps'),
	(504392, 131, '2014-01-15 00:03:03.000000', 'consum', 0.0229, 'lps'),
	(504393, 131, '2014-01-15 00:03:04.000000', 'consum', 0.0212, 'lps'),
	(504394, 131, '2014-01-15 00:03:05.000000', 'consum', 0.0229, 'lps'),
	(504395, 131, '2014-01-15 00:03:06.000000', 'consum', 0.0211, 'lps'),
	(504396, 131, '2014-01-15 00:03:07.000000', 'consum', 0.0225, 'lps'),
	(504397, 131, '2014-01-15 00:03:08.000000', 'consum', 0.0217, 'lps'),
	(504398, 131, '2014-01-15 00:03:09.000000', 'consum', 0.0223, 'lps'),
	(504399, 131, '2014-01-15 00:03:10.000000', 'consum', 0.0231, 'lps'),
	(504400, 131, '2014-01-15 00:03:11.000000', 'consum', 0.0211, 'lps'),
	(504401, 131, '2014-01-15 00:03:12.000000', 'consum', 0.0221, 'lps'),
	(504402, 131, '2014-01-15 00:03:13.000000', 'consum', 0.0216, 'lps'),
	(504403, 131, '2014-01-15 00:03:14.000000', 'consum', 0.0229, 'lps'),
	(504404, 131, '2014-01-15 00:03:15.000000', 'consum', 0.0221, 'lps'),
	(504405, 131, '2014-01-15 00:03:16.000000', 'consum', 0.0211, 'lps'),
	(504406, 131, '2014-01-15 00:03:17.000000', 'consum', 0.0225, 'lps'),
	(504407, 131, '2014-01-15 00:03:18.000000', 'consum', 0.0215, 'lps'),
	(504408, 131, '2014-01-15 00:03:19.000000', 'consum', 0.0214, 'lps'),
	(504409, 131, '2014-01-15 00:03:20.000000', 'consum', 0.0214, 'lps'),
	(504410, 131, '2014-01-15 00:03:21.000000', 'consum', 0.0220, 'lps'),
	(504411, 131, '2014-01-15 00:03:22.000000', 'consum', 0.0227, 'lps'),
	(504412, 131, '2014-01-15 00:03:23.000000', 'consum', 0.0222, 'lps'),
	(504413, 131, '2014-01-15 00:03:24.000000', 'consum', 0.0220, 'lps'),
	(504414, 131, '2014-01-15 00:03:25.000000', 'consum', 0.0222, 'lps'),
	(504415, 131, '2014-01-15 00:03:26.000000', 'consum', 0.0219, 'lps'),
	(504416, 131, '2014-01-15 00:03:27.000000', 'consum', 0.0220, 'lps'),
	(504417, 131, '2014-01-15 00:03:28.000000', 'consum', 0.0212, 'lps'),
	(504418, 131, '2014-01-15 00:03:29.000000', 'consum', 0.0210, 'lps'),
	(504419, 131, '2014-01-15 00:03:30.000000', 'consum', 0.0230, 'lps'),
	(504420, 131, '2014-01-15 00:03:31.000000', 'consum', 0.0220, 'lps'),
	(504421, 131, '2014-01-15 00:03:32.000000', 'consum', 0.0221, 'lps'),
	(504422, 131, '2014-01-15 00:03:33.000000', 'consum', 0.0216, 'lps'),
	(504423, 131, '2014-01-15 00:03:34.000000', 'consum', 0.0229, 'lps'),
	(504424, 131, '2014-01-15 00:03:35.000000', 'consum', 0.0220, 'lps'),
	(504425, 131, '2014-01-15 00:03:36.000000', 'consum', 0.0229, 'lps'),
	(504426, 131, '2014-01-15 00:03:37.000000', 'consum', 0.0228, 'lps'),
	(504427, 131, '2014-01-15 00:03:38.000000', 'consum', 0.0223, 'lps'),
	(504428, 131, '2014-01-15 00:03:39.000000', 'consum', 0.0219, 'lps'),
	(504429, 131, '2014-01-15 00:03:40.000000', 'consum', 0.0219, 'lps'),
	(504430, 131, '2014-01-15 00:03:41.000000', 'consum', 0.0230, 'lps'),
	(504431, 131, '2014-01-15 00:03:42.000000', 'consum', 0.0214, 'lps'),
	(504432, 131, '2014-01-15 00:03:43.000000', 'consum', 0.0217, 'lps'),
	(504433, 131, '2014-01-15 00:03:44.000000', 'consum', 0.0210, 'lps'),
	(504434, 131, '2014-01-15 00:03:45.000000', 'consum', 0.0211, 'lps'),
	(504435, 131, '2014-01-15 00:03:46.000000', 'consum', 0.0217, 'lps'),
	(504436, 131, '2014-01-15 00:03:47.000000', 'consum', 0.0218, 'lps'),
	(504437, 131, '2014-01-15 00:03:48.000000', 'consum', 0.0210, 'lps'),
	(504438, 131, '2014-01-15 00:03:49.000000', 'consum', 0.0228, 'lps'),
	(504439, 131, '2014-01-15 00:03:50.000000', 'consum', 0.0216, 'lps'),
	(504440, 131, '2014-01-15 00:03:51.000000', 'consum', 0.0227, 'lps'),
	(504441, 131, '2014-01-15 00:03:52.000000', 'consum', 0.0213, 'lps'),
	(504442, 131, '2014-01-15 00:03:53.000000', 'consum', 0.0217, 'lps'),
	(504443, 131, '2014-01-15 00:03:54.000000', 'consum', 0.0215, 'lps'),
	(504444, 131, '2014-01-15 00:03:55.000000', 'consum', 0.0216, 'lps'),
	(504445, 131, '2014-01-15 00:03:56.000000', 'consum', 0.0227, 'lps'),
	(504446, 131, '2014-01-15 00:03:57.000000', 'consum', 0.0231, 'lps'),
	(504447, 131, '2014-01-15 00:03:58.000000', 'consum', 0.0221, 'lps'),
	(504448, 131, '2014-01-15 00:03:59.000000', 'consum', 0.0224, 'lps'),
	(504449, 131, '2014-01-15 00:04:00.000000', 'consum', 0.0224, 'lps'),
	(504450, 131, '2014-01-15 00:04:01.000000', 'consum', 0.0218, 'lps'),
	(504451, 131, '2014-01-15 00:04:02.000000', 'consum', 0.0210, 'lps'),
	(504452, 131, '2014-01-15 00:04:03.000000', 'consum', 0.0229, 'lps'),
	(504453, 131, '2014-01-15 00:04:04.000000', 'consum', 0.0220, 'lps'),
	(504454, 131, '2014-01-15 00:04:05.000000', 'consum', 0.0222, 'lps'),
	(504455, 131, '2014-01-15 00:04:06.000000', 'consum', 0.0219, 'lps'),
	(504456, 131, '2014-01-15 00:04:07.000000', 'consum', 0.0221, 'lps'),
	(504457, 131, '2014-01-15 00:04:08.000000', 'consum', 0.0217, 'lps'),
	(504458, 131, '2014-01-15 00:04:09.000000', 'consum', 0.0212, 'lps'),
	(504459, 131, '2014-01-15 00:04:10.000000', 'consum', 0.0220, 'lps'),
	(504460, 131, '2014-01-15 00:04:11.000000', 'consum', 0.0212, 'lps'),
	(504461, 131, '2014-01-15 00:04:12.000000', 'consum', 0.0211, 'lps'),
	(504462, 131, '2014-01-15 00:04:13.000000', 'consum', 0.0212, 'lps'),
	(504463, 131, '2014-01-15 00:04:14.000000', 'consum', 0.0215, 'lps'),
	(504464, 131, '2014-01-15 00:04:15.000000', 'consum', 0.0230, 'lps'),
	(504465, 131, '2014-01-15 00:04:16.000000', 'consum', 0.0210, 'lps'),
	(504466, 131, '2014-01-15 00:04:17.000000', 'consum', 0.0213, 'lps'),
	(504467, 131, '2014-01-15 00:04:18.000000', 'consum', 0.0228, 'lps'),
	(504468, 131, '2014-01-15 00:04:19.000000', 'consum', 0.0223, 'lps'),
	(504469, 131, '2014-01-15 00:04:20.000000', 'consum', 0.0224, 'lps'),
	(504470, 131, '2014-01-15 00:04:21.000000', 'consum', 0.0218, 'lps'),
	(504471, 131, '2014-01-15 00:04:22.000000', 'consum', 0.0229, 'lps'),
	(504472, 131, '2014-01-15 00:04:23.000000', 'consum', 0.0218, 'lps'),
	(504473, 131, '2014-01-15 00:04:24.000000', 'consum', 0.0213, 'lps'),
	(504474, 131, '2014-01-15 00:04:25.000000', 'consum', 0.0223, 'lps'),
	(504475, 131, '2014-01-15 00:04:26.000000', 'consum', 0.0223, 'lps'),
	(504476, 131, '2014-01-15 00:04:27.000000', 'consum', 0.0213, 'lps'),
	(504477, 131, '2014-01-15 00:04:28.000000', 'consum', 0.0210, 'lps'),
	(504478, 131, '2014-01-15 00:04:29.000000', 'consum', 0.0222, 'lps'),
	(504479, 131, '2014-01-15 00:04:30.000000', 'consum', 0.0228, 'lps'),
	(504480, 131, '2014-01-15 00:04:31.000000', 'consum', 0.0220, 'lps'),
	(504481, 131, '2014-01-15 00:04:32.000000', 'consum', 0.0229, 'lps'),
	(504482, 131, '2014-01-15 00:04:33.000000', 'consum', 0.0230, 'lps'),
	(504483, 131, '2014-01-15 00:04:34.000000', 'consum', 0.0211, 'lps'),
	(504484, 131, '2014-01-15 00:04:35.000000', 'consum', 0.0221, 'lps'),
	(504485, 131, '2014-01-15 00:04:36.000000', 'consum', 0.0221, 'lps'),
	(504486, 131, '2014-01-15 00:04:37.000000', 'consum', 0.0229, 'lps'),
	(504487, 131, '2014-01-15 00:04:38.000000', 'consum', 0.0231, 'lps'),
	(504488, 131, '2014-01-15 00:04:39.000000', 'consum', 0.0215, 'lps'),
	(504489, 131, '2014-01-15 00:04:40.000000', 'consum', 0.0216, 'lps'),
	(504490, 131, '2014-01-15 00:04:41.000000', 'consum', 0.0224, 'lps'),
	(504491, 131, '2014-01-15 00:04:42.000000', 'consum', 0.0218, 'lps'),
	(504492, 131, '2014-01-15 00:04:43.000000', 'consum', 0.0211, 'lps'),
	(504493, 131, '2014-01-15 00:04:44.000000', 'consum', 0.0213, 'lps'),
	(504494, 131, '2014-01-15 00:04:45.000000', 'consum', 0.0223, 'lps'),
	(504495, 131, '2014-01-15 00:04:46.000000', 'consum', 0.0221, 'lps'),
	(504496, 131, '2014-01-15 00:04:47.000000', 'consum', 0.0227, 'lps'),
	(504497, 131, '2014-01-15 00:04:48.000000', 'consum', 0.0219, 'lps'),
	(504498, 131, '2014-01-15 00:04:49.000000', 'consum', 0.0227, 'lps'),
	(504499, 131, '2014-01-15 00:04:50.000000', 'consum', 0.0225, 'lps'),
	(504500, 131, '2014-01-15 00:04:51.000000', 'consum', 0.0211, 'lps'),
	(504501, 131, '2014-01-15 00:04:52.000000', 'consum', 0.0216, 'lps'),
	(504502, 131, '2014-01-15 00:04:53.000000', 'consum', 0.0214, 'lps'),
	(504503, 131, '2014-01-15 00:04:54.000000', 'consum', 0.0214, 'lps'),
	(504504, 131, '2014-01-15 00:04:55.000000', 'consum', 0.0217, 'lps'),
	(504505, 131, '2014-01-15 00:04:56.000000', 'consum', 0.0212, 'lps'),
	(504506, 131, '2014-01-15 00:04:57.000000', 'consum', 0.0220, 'lps'),
	(504507, 131, '2014-01-15 00:04:58.000000', 'consum', 0.0214, 'lps'),
	(504508, 131, '2014-01-15 00:04:59.000000', 'consum', 0.0219, 'lps'),
	(504509, 131, '2014-01-15 00:05:00.000000', 'consum', 0.0223, 'lps'),
	(504510, 131, '2014-01-15 00:05:01.000000', 'consum', 0.0225, 'lps'),
	(504511, 131, '2014-01-15 00:05:02.000000', 'consum', 0.0227, 'lps'),
	(504512, 131, '2014-01-15 00:05:03.000000', 'consum', 0.0228, 'lps'),
	(504513, 131, '2014-01-15 00:05:04.000000', 'consum', 0.0229, 'lps'),
	(504514, 131, '2014-01-15 00:05:05.000000', 'consum', 0.0226, 'lps'),
	(504515, 131, '2014-01-15 00:05:06.000000', 'consum', 0.0215, 'lps'),
	(504516, 131, '2014-01-15 00:05:07.000000', 'consum', 0.0230, 'lps'),
	(504517, 131, '2014-01-15 00:05:08.000000', 'consum', 0.0228, 'lps'),
	(504518, 131, '2014-01-15 00:05:09.000000', 'consum', 0.0219, 'lps'),
	(504519, 131, '2014-01-15 00:05:10.000000', 'consum', 0.0223, 'lps'),
	(504520, 131, '2014-01-15 00:05:11.000000', 'consum', 0.0226, 'lps'),
	(504521, 131, '2014-01-15 00:05:12.000000', 'consum', 0.0231, 'lps'),
	(504522, 131, '2014-01-15 00:05:13.000000', 'consum', 0.0222, 'lps'),
	(504523, 131, '2014-01-15 00:05:14.000000', 'consum', 0.0210, 'lps'),
	(504524, 131, '2014-01-15 00:05:15.000000', 'consum', 0.0216, 'lps'),
	(504525, 131, '2014-01-15 00:05:16.000000', 'consum', 0.0219, 'lps'),
	(504526, 131, '2014-01-15 00:05:17.000000', 'consum', 0.0214, 'lps'),
	(504527, 131, '2014-01-15 00:05:18.000000', 'consum', 0.0227, 'lps'),
	(504528, 131, '2014-01-15 00:05:19.000000', 'consum', 0.0215, 'lps'),
	(504529, 131, '2014-01-15 00:05:20.000000', 'consum', 0.0231, 'lps'),
	(504530, 131, '2014-01-15 00:05:21.000000', 'consum', 0.0214, 'lps'),
	(504531, 131, '2014-01-15 00:05:22.000000', 'consum', 0.0230, 'lps'),
	(504532, 131, '2014-01-15 00:05:23.000000', 'consum', 0.0213, 'lps'),
	(504533, 131, '2014-01-15 00:05:24.000000', 'consum', 0.0211, 'lps'),
	(504534, 131, '2014-01-15 00:05:25.000000', 'consum', 0.0226, 'lps'),
	(504535, 131, '2014-01-15 00:05:26.000000', 'consum', 0.0223, 'lps'),
	(504536, 131, '2014-01-15 00:05:27.000000', 'consum', 0.0227, 'lps'),
	(504537, 131, '2014-01-15 00:05:28.000000', 'consum', 0.0213, 'lps'),
	(504538, 131, '2014-01-15 00:05:29.000000', 'consum', 0.0217, 'lps'),
	(504539, 131, '2014-01-15 00:05:30.000000', 'consum', 0.0216, 'lps'),
	(504540, 131, '2014-01-15 00:05:31.000000', 'consum', 0.0220, 'lps'),
	(504541, 131, '2014-01-15 00:05:32.000000', 'consum', 0.0220, 'lps'),
	(504542, 131, '2014-01-15 00:05:33.000000', 'consum', 0.0229, 'lps'),
	(504543, 131, '2014-01-15 00:05:34.000000', 'consum', 0.0210, 'lps'),
	(504544, 131, '2014-01-15 00:05:35.000000', 'consum', 0.0222, 'lps'),
	(504545, 131, '2014-01-15 00:05:36.000000', 'consum', 0.0224, 'lps'),
	(504546, 131, '2014-01-15 00:05:37.000000', 'consum', 0.0223, 'lps'),
	(504547, 131, '2014-01-15 00:05:38.000000', 'consum', 0.0211, 'lps'),
	(504548, 131, '2014-01-15 00:05:39.000000', 'consum', 0.0220, 'lps'),
	(504549, 131, '2014-01-15 00:05:40.000000', 'consum', 0.0214, 'lps'),
	(504550, 131, '2014-01-15 00:05:41.000000', 'consum', 0.0222, 'lps'),
	(504551, 131, '2014-01-15 00:05:42.000000', 'consum', 0.0214, 'lps'),
	(504552, 131, '2014-01-15 00:05:43.000000', 'consum', 0.0219, 'lps'),
	(504553, 131, '2014-01-15 00:05:44.000000', 'consum', 0.0219, 'lps'),
	(504554, 131, '2014-01-15 00:05:45.000000', 'consum', 0.0228, 'lps'),
	(504555, 131, '2014-01-15 00:05:46.000000', 'consum', 0.0210, 'lps'),
	(504556, 131, '2014-01-15 00:05:47.000000', 'consum', 0.0223, 'lps'),
	(504557, 131, '2014-01-15 00:05:48.000000', 'consum', 0.0230, 'lps'),
	(504558, 131, '2014-01-15 00:05:49.000000', 'consum', 0.0229, 'lps'),
	(504559, 131, '2014-01-15 00:05:50.000000', 'consum', 0.0221, 'lps'),
	(504560, 131, '2014-01-15 00:05:51.000000', 'consum', 0.0212, 'lps'),
	(504561, 131, '2014-01-15 00:05:52.000000', 'consum', 0.0229, 'lps'),
	(504562, 131, '2014-01-15 00:05:53.000000', 'consum', 0.0211, 'lps'),
	(504563, 131, '2014-01-15 00:05:54.000000', 'consum', 0.0227, 'lps'),
	(504564, 131, '2014-01-15 00:05:55.000000', 'consum', 0.0226, 'lps'),
	(504565, 131, '2014-01-15 00:05:56.000000', 'consum', 0.0219, 'lps'),
	(504566, 131, '2014-01-15 00:05:57.000000', 'consum', 0.0227, 'lps'),
	(504567, 131, '2014-01-15 00:05:58.000000', 'consum', 0.0226, 'lps'),
	(504568, 131, '2014-01-15 00:05:59.000000', 'consum', 0.0218, 'lps'),
	(504569, 131, '2014-01-15 00:06:00.000000', 'consum', 0.0222, 'lps'),
	(504570, 131, '2014-01-15 00:06:01.000000', 'consum', 0.0224, 'lps'),
	(504571, 131, '2014-01-15 00:06:02.000000', 'consum', 0.0226, 'lps'),
	(504572, 131, '2014-01-15 00:06:03.000000', 'consum', 0.0224, 'lps'),
	(504573, 131, '2014-01-15 00:06:04.000000', 'consum', 0.0210, 'lps'),
	(504574, 131, '2014-01-15 00:06:05.000000', 'consum', 0.0212, 'lps'),
	(504575, 131, '2014-01-15 00:06:06.000000', 'consum', 0.0220, 'lps'),
	(504576, 131, '2014-01-15 00:06:07.000000', 'consum', 0.0213, 'lps'),
	(504577, 131, '2014-01-15 00:06:08.000000', 'consum', 0.0218, 'lps'),
	(504578, 131, '2014-01-15 00:06:09.000000', 'consum', 0.0218, 'lps'),
	(504579, 131, '2014-01-15 00:06:10.000000', 'consum', 0.0227, 'lps'),
	(504580, 131, '2014-01-15 00:06:11.000000', 'consum', 0.0229, 'lps'),
	(504581, 131, '2014-01-15 00:06:12.000000', 'consum', 0.0230, 'lps'),
	(504582, 131, '2014-01-15 00:06:13.000000', 'consum', 0.0211, 'lps'),
	(504583, 131, '2014-01-15 00:06:14.000000', 'consum', 0.0220, 'lps'),
	(504584, 131, '2014-01-15 00:06:15.000000', 'consum', 0.0213, 'lps'),
	(504585, 131, '2014-01-15 00:06:16.000000', 'consum', 0.0220, 'lps'),
	(504586, 131, '2014-01-15 00:06:17.000000', 'consum', 0.0228, 'lps'),
	(504587, 131, '2014-01-15 00:06:18.000000', 'consum', 0.0228, 'lps'),
	(504588, 131, '2014-01-15 00:06:19.000000', 'consum', 0.0225, 'lps'),
	(504589, 131, '2014-01-15 00:06:20.000000', 'consum', 0.0230, 'lps'),
	(504590, 131, '2014-01-15 00:06:21.000000', 'consum', 0.0220, 'lps'),
	(504591, 131, '2014-01-15 00:06:22.000000', 'consum', 0.0224, 'lps'),
	(504592, 131, '2014-01-15 00:06:23.000000', 'consum', 0.0227, 'lps'),
	(504593, 131, '2014-01-15 00:06:24.000000', 'consum', 0.0212, 'lps'),
	(504594, 131, '2014-01-15 00:06:25.000000', 'consum', 0.0212, 'lps'),
	(504595, 131, '2014-01-15 00:06:26.000000', 'consum', 0.0213, 'lps'),
	(504596, 131, '2014-01-15 00:06:27.000000', 'consum', 0.0220, 'lps'),
	(504597, 131, '2014-01-15 00:06:28.000000', 'consum', 0.0231, 'lps'),
	(504598, 131, '2014-01-15 00:06:29.000000', 'consum', 0.0220, 'lps'),
	(504599, 131, '2014-01-15 00:06:30.000000', 'consum', 0.0219, 'lps'),
	(504600, 131, '2014-01-15 00:06:31.000000', 'consum', 0.0225, 'lps'),
	(504601, 131, '2014-01-15 00:06:32.000000', 'consum', 0.0213, 'lps'),
	(504602, 131, '2014-01-15 00:06:33.000000', 'consum', 0.0227, 'lps'),
	(504603, 131, '2014-01-15 00:06:34.000000', 'consum', 0.0221, 'lps'),
	(504604, 131, '2014-01-15 00:06:35.000000', 'consum', 0.0214, 'lps'),
	(504605, 131, '2014-01-15 00:06:36.000000', 'consum', 0.0221, 'lps'),
	(504606, 131, '2014-01-15 00:06:37.000000', 'consum', 0.0231, 'lps'),
	(504607, 131, '2014-01-15 00:06:38.000000', 'consum', 0.0218, 'lps'),
	(504608, 131, '2014-01-15 00:06:39.000000', 'consum', 0.0229, 'lps'),
	(504609, 131, '2014-01-15 00:06:40.000000', 'consum', 0.0215, 'lps'),
	(504610, 131, '2014-01-15 00:06:41.000000', 'consum', 0.0222, 'lps'),
	(504611, 131, '2014-01-15 00:06:42.000000', 'consum', 0.0213, 'lps'),
	(504612, 131, '2014-01-15 00:06:43.000000', 'consum', 0.0231, 'lps'),
	(504613, 131, '2014-01-15 00:06:44.000000', 'consum', 0.0221, 'lps'),
	(504614, 131, '2014-01-15 00:06:45.000000', 'consum', 0.0225, 'lps'),
	(504615, 131, '2014-01-15 00:06:46.000000', 'consum', 0.0228, 'lps'),
	(504616, 131, '2014-01-15 00:06:47.000000', 'consum', 0.0212, 'lps'),
	(504617, 131, '2014-01-15 00:06:48.000000', 'consum', 0.0210, 'lps'),
	(504618, 131, '2014-01-15 00:06:49.000000', 'consum', 0.0229, 'lps'),
	(504619, 131, '2014-01-15 00:06:50.000000', 'consum', 0.0216, 'lps'),
	(504620, 131, '2014-01-15 00:06:51.000000', 'consum', 0.0230, 'lps'),
	(504621, 131, '2014-01-15 00:06:52.000000', 'consum', 0.0224, 'lps'),
	(504622, 131, '2014-01-15 00:06:53.000000', 'consum', 0.0221, 'lps'),
	(504623, 131, '2014-01-15 00:06:54.000000', 'consum', 0.0223, 'lps'),
	(504624, 131, '2014-01-15 00:06:55.000000', 'consum', 0.0219, 'lps'),
	(504625, 131, '2014-01-15 00:06:56.000000', 'consum', 0.0219, 'lps'),
	(504626, 131, '2014-01-15 00:06:57.000000', 'consum', 0.0227, 'lps'),
	(504627, 131, '2014-01-15 00:06:58.000000', 'consum', 0.0226, 'lps'),
	(504628, 131, '2014-01-15 00:06:59.000000', 'consum', 0.0218, 'lps'),
	(504629, 131, '2014-01-15 00:07:00.000000', 'consum', 0.0224, 'lps'),
	(504630, 131, '2014-01-15 00:07:01.000000', 'consum', 0.0214, 'lps'),
	(504631, 131, '2014-01-15 00:07:02.000000', 'consum', 0.0229, 'lps'),
	(504632, 131, '2014-01-15 00:07:03.000000', 'consum', 0.0230, 'lps'),
	(504633, 131, '2014-01-15 00:07:04.000000', 'consum', 0.0231, 'lps'),
	(504634, 131, '2014-01-15 00:07:05.000000', 'consum', 0.0210, 'lps'),
	(504635, 131, '2014-01-15 00:07:06.000000', 'consum', 0.0216, 'lps'),
	(504636, 131, '2014-01-15 00:07:07.000000', 'consum', 0.0218, 'lps'),
	(504637, 131, '2014-01-15 00:07:08.000000', 'consum', 0.0231, 'lps'),
	(504638, 131, '2014-01-15 00:07:09.000000', 'consum', 0.0227, 'lps'),
	(504639, 131, '2014-01-15 00:07:10.000000', 'consum', 0.0210, 'lps'),
	(504640, 131, '2014-01-15 00:07:11.000000', 'consum', 0.0227, 'lps'),
	(504641, 131, '2014-01-15 00:07:12.000000', 'consum', 0.0227, 'lps'),
	(504642, 131, '2014-01-15 00:07:13.000000', 'consum', 0.0225, 'lps'),
	(504643, 131, '2014-01-15 00:07:14.000000', 'consum', 0.0210, 'lps'),
	(504644, 131, '2014-01-15 00:07:15.000000', 'consum', 0.0231, 'lps'),
	(504645, 131, '2014-01-15 00:07:16.000000', 'consum', 0.0228, 'lps'),
	(504646, 131, '2014-01-15 00:07:17.000000', 'consum', 0.0215, 'lps'),
	(504647, 131, '2014-01-15 00:07:18.000000', 'consum', 0.0228, 'lps'),
	(504648, 131, '2014-01-15 00:07:19.000000', 'consum', 0.0218, 'lps'),
	(504649, 131, '2014-01-15 00:07:20.000000', 'consum', 0.0217, 'lps'),
	(504650, 131, '2014-01-15 00:07:21.000000', 'consum', 0.0221, 'lps'),
	(504651, 131, '2014-01-15 00:07:22.000000', 'consum', 0.0223, 'lps'),
	(504652, 131, '2014-01-15 00:07:23.000000', 'consum', 0.0222, 'lps'),
	(504653, 131, '2014-01-15 00:07:24.000000', 'consum', 0.0229, 'lps'),
	(504654, 131, '2014-01-15 00:07:25.000000', 'consum', 0.0226, 'lps'),
	(504655, 131, '2014-01-15 00:07:26.000000', 'consum', 0.0213, 'lps'),
	(504656, 131, '2014-01-15 00:07:27.000000', 'consum', 0.0222, 'lps'),
	(504657, 131, '2014-01-15 00:07:28.000000', 'consum', 0.0216, 'lps'),
	(504658, 131, '2014-01-15 00:07:29.000000', 'consum', 0.0226, 'lps'),
	(504659, 131, '2014-01-15 00:07:30.000000', 'consum', 0.0231, 'lps'),
	(504660, 131, '2014-01-15 00:07:31.000000', 'consum', 0.0223, 'lps'),
	(504661, 131, '2014-01-15 00:07:32.000000', 'consum', 0.0213, 'lps'),
	(504662, 131, '2014-01-15 00:07:33.000000', 'consum', 0.0229, 'lps'),
	(504663, 131, '2014-01-15 00:07:34.000000', 'consum', 0.0210, 'lps'),
	(504664, 131, '2014-01-15 00:07:35.000000', 'consum', 0.0221, 'lps'),
	(504665, 131, '2014-01-15 00:07:36.000000', 'consum', 0.0220, 'lps'),
	(504666, 131, '2014-01-15 00:07:37.000000', 'consum', 0.0226, 'lps'),
	(504667, 131, '2014-01-15 00:07:38.000000', 'consum', 0.0219, 'lps'),
	(504668, 131, '2014-01-15 00:07:39.000000', 'consum', 0.0229, 'lps'),
	(504669, 131, '2014-01-15 00:07:40.000000', 'consum', 0.0212, 'lps'),
	(504670, 131, '2014-01-15 00:07:41.000000', 'consum', 0.0229, 'lps'),
	(504671, 131, '2014-01-15 00:07:42.000000', 'consum', 0.0213, 'lps'),
	(504672, 131, '2014-01-15 00:07:43.000000', 'consum', 0.0210, 'lps'),
	(504673, 131, '2014-01-15 00:07:44.000000', 'consum', 0.0225, 'lps'),
	(504674, 131, '2014-01-15 00:07:45.000000', 'consum', 0.0217, 'lps'),
	(504675, 131, '2014-01-15 00:07:46.000000', 'consum', 0.0225, 'lps'),
	(504676, 131, '2014-01-15 00:07:47.000000', 'consum', 0.0220, 'lps'),
	(504677, 131, '2014-01-15 00:07:48.000000', 'consum', 0.0217, 'lps'),
	(504678, 131, '2014-01-15 00:07:49.000000', 'consum', 0.0213, 'lps'),
	(504679, 131, '2014-01-15 00:07:50.000000', 'consum', 0.0228, 'lps'),
	(504680, 131, '2014-01-15 00:07:51.000000', 'consum', 0.0224, 'lps'),
	(504681, 131, '2014-01-15 00:07:52.000000', 'consum', 0.0227, 'lps'),
	(504682, 131, '2014-01-15 00:07:53.000000', 'consum', 0.0231, 'lps'),
	(504683, 131, '2014-01-15 00:07:54.000000', 'consum', 0.0220, 'lps'),
	(504684, 131, '2014-01-15 00:07:55.000000', 'consum', 0.0219, 'lps'),
	(504685, 131, '2014-01-15 00:07:56.000000', 'consum', 0.0225, 'lps'),
	(504686, 131, '2014-01-15 00:07:57.000000', 'consum', 0.0213, 'lps'),
	(504687, 131, '2014-01-15 00:07:58.000000', 'consum', 0.0227, 'lps'),
	(504688, 131, '2014-01-15 00:07:59.000000', 'consum', 0.0222, 'lps'),
	(504689, 131, '2014-01-15 00:08:00.000000', 'consum', 0.0218, 'lps'),
	(504690, 131, '2014-01-15 00:08:01.000000', 'consum', 0.0216, 'lps'),
	(504691, 131, '2014-01-15 00:08:02.000000', 'consum', 0.0217, 'lps'),
	(504692, 131, '2014-01-15 00:08:03.000000', 'consum', 0.0225, 'lps'),
	(504693, 131, '2014-01-15 00:08:04.000000', 'consum', 0.0223, 'lps'),
	(504694, 131, '2014-01-15 00:08:05.000000', 'consum', 0.0230, 'lps'),
	(504695, 131, '2014-01-15 00:08:06.000000', 'consum', 0.0228, 'lps'),
	(504696, 131, '2014-01-15 00:08:07.000000', 'consum', 0.0218, 'lps'),
	(504697, 131, '2014-01-15 00:08:08.000000', 'consum', 0.0218, 'lps'),
	(504698, 131, '2014-01-15 00:08:09.000000', 'consum', 0.0227, 'lps'),
	(504699, 131, '2014-01-15 00:08:10.000000', 'consum', 0.0228, 'lps'),
	(504700, 131, '2014-01-15 00:08:11.000000', 'consum', 0.0225, 'lps'),
	(504701, 131, '2014-01-15 00:08:12.000000', 'consum', 0.0212, 'lps'),
	(504702, 131, '2014-01-15 00:08:13.000000', 'consum', 0.0217, 'lps'),
	(504703, 131, '2014-01-15 00:08:14.000000', 'consum', 0.0220, 'lps'),
	(504704, 131, '2014-01-15 00:08:15.000000', 'consum', 0.0218, 'lps'),
	(504705, 131, '2014-01-15 00:08:16.000000', 'consum', 0.0220, 'lps'),
	(504706, 131, '2014-01-15 00:08:17.000000', 'consum', 0.0214, 'lps'),
	(504707, 131, '2014-01-15 00:08:18.000000', 'consum', 0.0221, 'lps'),
	(504708, 131, '2014-01-15 00:08:19.000000', 'consum', 0.0213, 'lps'),
	(504709, 131, '2014-01-15 00:08:20.000000', 'consum', 0.0212, 'lps'),
	(504710, 131, '2014-01-15 00:08:21.000000', 'consum', 0.0210, 'lps'),
	(504711, 131, '2014-01-15 00:08:22.000000', 'consum', 0.0228, 'lps'),
	(504712, 131, '2014-01-15 00:08:23.000000', 'consum', 0.0212, 'lps'),
	(504713, 131, '2014-01-15 00:08:24.000000', 'consum', 0.0210, 'lps'),
	(504714, 131, '2014-01-15 00:08:25.000000', 'consum', 0.0227, 'lps'),
	(504715, 131, '2014-01-15 00:08:26.000000', 'consum', 0.0230, 'lps'),
	(504716, 131, '2014-01-15 00:08:27.000000', 'consum', 0.0213, 'lps'),
	(504717, 131, '2014-01-15 00:08:28.000000', 'consum', 0.0212, 'lps'),
	(504718, 131, '2014-01-15 00:08:29.000000', 'consum', 0.0211, 'lps'),
	(504719, 131, '2014-01-15 00:08:30.000000', 'consum', 0.0210, 'lps'),
	(504720, 131, '2014-01-15 00:08:31.000000', 'consum', 0.0229, 'lps'),
	(504721, 131, '2014-01-15 00:08:32.000000', 'consum', 0.0219, 'lps'),
	(504722, 131, '2014-01-15 00:08:33.000000', 'consum', 0.0220, 'lps'),
	(504723, 131, '2014-01-15 00:08:34.000000', 'consum', 0.0212, 'lps'),
	(504724, 131, '2014-01-15 00:08:35.000000', 'consum', 0.0211, 'lps'),
	(504725, 131, '2014-01-15 00:08:36.000000', 'consum', 0.0210, 'lps'),
	(504726, 131, '2014-01-15 00:08:37.000000', 'consum', 0.0230, 'lps'),
	(504727, 131, '2014-01-15 00:08:38.000000', 'consum', 0.0223, 'lps'),
	(504728, 131, '2014-01-15 00:08:39.000000', 'consum', 0.0216, 'lps'),
	(504729, 131, '2014-01-15 00:08:40.000000', 'consum', 0.0224, 'lps'),
	(504730, 131, '2014-01-15 00:08:41.000000', 'consum', 0.0220, 'lps'),
	(504731, 131, '2014-01-15 00:08:42.000000', 'consum', 0.0216, 'lps'),
	(504732, 131, '2014-01-15 00:08:43.000000', 'consum', 0.0211, 'lps'),
	(504733, 131, '2014-01-15 00:08:44.000000', 'consum', 0.0219, 'lps'),
	(504734, 131, '2014-01-15 00:08:45.000000', 'consum', 0.0231, 'lps'),
	(504735, 131, '2014-01-15 00:08:46.000000', 'consum', 0.0222, 'lps'),
	(504736, 131, '2014-01-15 00:08:47.000000', 'consum', 0.0231, 'lps'),
	(504737, 131, '2014-01-15 00:08:48.000000', 'consum', 0.0212, 'lps'),
	(504738, 131, '2014-01-15 00:08:49.000000', 'consum', 0.0225, 'lps'),
	(504739, 131, '2014-01-15 00:08:50.000000', 'consum', 0.0211, 'lps'),
	(504740, 131, '2014-01-15 00:08:51.000000', 'consum', 0.0215, 'lps'),
	(504741, 131, '2014-01-15 00:08:52.000000', 'consum', 0.0212, 'lps'),
	(504742, 131, '2014-01-15 00:08:53.000000', 'consum', 0.0228, 'lps'),
	(504743, 131, '2014-01-15 00:08:54.000000', 'consum', 0.0228, 'lps'),
	(504744, 131, '2014-01-15 00:08:55.000000', 'consum', 0.0225, 'lps'),
	(504745, 131, '2014-01-15 00:08:56.000000', 'consum', 0.0210, 'lps'),
	(504746, 131, '2014-01-15 00:08:57.000000', 'consum', 0.0210, 'lps'),
	(504747, 131, '2014-01-15 00:08:58.000000', 'consum', 0.0211, 'lps'),
	(504748, 131, '2014-01-15 00:08:59.000000', 'consum', 0.0213, 'lps'),
	(504749, 131, '2014-01-15 00:09:00.000000', 'consum', 0.0223, 'lps'),
	(504750, 131, '2014-01-15 00:09:01.000000', 'consum', 0.0225, 'lps'),
	(504751, 131, '2014-01-15 00:09:02.000000', 'consum', 0.0221, 'lps'),
	(504752, 131, '2014-01-15 00:09:03.000000', 'consum', 0.0222, 'lps'),
	(504753, 131, '2014-01-15 00:09:04.000000', 'consum', 0.0216, 'lps'),
	(504754, 131, '2014-01-15 00:09:05.000000', 'consum', 0.0226, 'lps'),
	(504755, 131, '2014-01-15 00:09:06.000000', 'consum', 0.0230, 'lps'),
	(504756, 131, '2014-01-15 00:09:07.000000', 'consum', 0.0216, 'lps'),
	(504757, 131, '2014-01-15 00:09:08.000000', 'consum', 0.0226, 'lps'),
	(504758, 131, '2014-01-15 00:09:09.000000', 'consum', 0.0227, 'lps'),
	(504759, 131, '2014-01-15 00:09:10.000000', 'consum', 0.0226, 'lps'),
	(504760, 131, '2014-01-15 00:09:11.000000', 'consum', 0.0220, 'lps'),
	(504761, 131, '2014-01-15 00:09:12.000000', 'consum', 0.0210, 'lps'),
	(504762, 131, '2014-01-15 00:09:13.000000', 'consum', 0.0226, 'lps'),
	(504763, 131, '2014-01-15 00:09:14.000000', 'consum', 0.0226, 'lps'),
	(504764, 131, '2014-01-15 00:09:15.000000', 'consum', 0.0219, 'lps'),
	(504765, 131, '2014-01-15 00:09:16.000000', 'consum', 0.0229, 'lps'),
	(504766, 131, '2014-01-15 00:09:17.000000', 'consum', 0.0212, 'lps'),
	(504767, 131, '2014-01-15 00:09:18.000000', 'consum', 0.0230, 'lps'),
	(504768, 131, '2014-01-15 00:09:19.000000', 'consum', 0.0217, 'lps'),
	(504769, 131, '2014-01-15 00:09:20.000000', 'consum', 0.0229, 'lps'),
	(504770, 131, '2014-01-15 00:09:21.000000', 'consum', 0.0220, 'lps'),
	(504771, 131, '2014-01-15 00:09:22.000000', 'consum', 0.0225, 'lps'),
	(504772, 131, '2014-01-15 00:09:23.000000', 'consum', 0.0212, 'lps'),
	(504773, 131, '2014-01-15 00:09:24.000000', 'consum', 0.0221, 'lps'),
	(504774, 131, '2014-01-15 00:09:25.000000', 'consum', 0.0212, 'lps'),
	(504775, 131, '2014-01-15 00:09:26.000000', 'consum', 0.0212, 'lps'),
	(504776, 131, '2014-01-15 00:09:27.000000', 'consum', 0.0216, 'lps'),
	(504777, 131, '2014-01-15 00:09:28.000000', 'consum', 0.0210, 'lps'),
	(504778, 131, '2014-01-15 00:09:29.000000', 'consum', 0.0213, 'lps'),
	(504779, 131, '2014-01-15 00:09:30.000000', 'consum', 0.0228, 'lps'),
	(504780, 131, '2014-01-15 00:09:31.000000', 'consum', 0.0226, 'lps'),
	(504781, 131, '2014-01-15 00:09:32.000000', 'consum', 0.0213, 'lps'),
	(504782, 131, '2014-01-15 00:09:33.000000', 'consum', 0.0222, 'lps'),
	(504783, 131, '2014-01-15 00:09:34.000000', 'consum', 0.0219, 'lps'),
	(504784, 131, '2014-01-15 00:09:35.000000', 'consum', 0.0218, 'lps'),
	(504785, 131, '2014-01-15 00:09:36.000000', 'consum', 0.0225, 'lps'),
	(504786, 131, '2014-01-15 00:09:37.000000', 'consum', 0.0215, 'lps'),
	(504787, 131, '2014-01-15 00:09:38.000000', 'consum', 0.0212, 'lps'),
	(504788, 131, '2014-01-15 00:09:39.000000', 'consum', 0.0228, 'lps'),
	(504789, 131, '2014-01-15 00:09:40.000000', 'consum', 0.0230, 'lps'),
	(504790, 131, '2014-01-15 00:09:41.000000', 'consum', 0.0210, 'lps'),
	(504791, 131, '2014-01-15 00:09:42.000000', 'consum', 0.0219, 'lps'),
	(504792, 131, '2014-01-15 00:09:43.000000', 'consum', 0.0211, 'lps'),
	(504793, 131, '2014-01-15 00:09:44.000000', 'consum', 0.0230, 'lps'),
	(504794, 131, '2014-01-15 00:09:45.000000', 'consum', 0.0222, 'lps'),
	(504795, 131, '2014-01-15 00:09:46.000000', 'consum', 0.0210, 'lps'),
	(504796, 131, '2014-01-15 00:09:47.000000', 'consum', 0.0219, 'lps'),
	(504797, 131, '2014-01-15 00:09:48.000000', 'consum', 0.0213, 'lps'),
	(504798, 131, '2014-01-15 00:09:49.000000', 'consum', 0.0218, 'lps'),
	(504799, 131, '2014-01-15 00:09:50.000000', 'consum', 0.0220, 'lps'),
	(504800, 131, '2014-01-15 00:09:51.000000', 'consum', 0.0213, 'lps'),
	(504801, 131, '2014-01-15 00:09:52.000000', 'consum', 0.0219, 'lps'),
	(504802, 131, '2014-01-15 00:09:53.000000', 'consum', 0.0226, 'lps'),
	(504803, 131, '2014-01-15 00:09:54.000000', 'consum', 0.0217, 'lps'),
	(504804, 131, '2014-01-15 00:09:55.000000', 'consum', 0.0222, 'lps'),
	(504805, 131, '2014-01-15 00:09:56.000000', 'consum', 0.0228, 'lps'),
	(504806, 131, '2014-01-15 00:09:57.000000', 'consum', 0.0218, 'lps'),
	(504807, 131, '2014-01-15 00:09:58.000000', 'consum', 0.0219, 'lps'),
	(504808, 131, '2014-01-15 00:09:59.000000', 'consum', 0.0230, 'lps'),
	(504809, 131, '2014-01-15 00:10:00.000000', 'consum', 0.0221, 'lps'),
	(504810, 131, '2014-01-15 00:10:01.000000', 'consum', 0.0225, 'lps'),
	(504811, 131, '2014-01-15 00:10:02.000000', 'consum', 0.0231, 'lps'),
	(504812, 131, '2014-01-15 00:10:03.000000', 'consum', 0.0225, 'lps'),
	(504813, 131, '2014-01-15 00:10:04.000000', 'consum', 0.0222, 'lps'),
	(504814, 131, '2014-01-15 00:10:05.000000', 'consum', 0.0227, 'lps'),
	(504815, 131, '2014-01-15 00:10:06.000000', 'consum', 0.0215, 'lps'),
	(504816, 131, '2014-01-15 00:10:07.000000', 'consum', 0.0227, 'lps'),
	(504817, 131, '2014-01-15 00:10:08.000000', 'consum', 0.0215, 'lps'),
	(504818, 131, '2014-01-15 00:10:09.000000', 'consum', 0.0230, 'lps'),
	(504819, 131, '2014-01-15 00:10:10.000000', 'consum', 0.0229, 'lps'),
	(504820, 131, '2014-01-15 00:10:11.000000', 'consum', 0.0222, 'lps'),
	(504821, 131, '2014-01-15 00:10:12.000000', 'consum', 0.0215, 'lps'),
	(504822, 131, '2014-01-15 00:10:13.000000', 'consum', 0.0223, 'lps'),
	(504823, 131, '2014-01-15 00:10:14.000000', 'consum', 0.0215, 'lps'),
	(504824, 131, '2014-01-15 00:10:15.000000', 'consum', 0.0221, 'lps'),
	(504825, 131, '2014-01-15 00:10:16.000000', 'consum', 0.0225, 'lps'),
	(504826, 131, '2014-01-15 00:10:17.000000', 'consum', 0.0211, 'lps'),
	(504827, 131, '2014-01-15 00:10:18.000000', 'consum', 0.0215, 'lps'),
	(504828, 131, '2014-01-15 00:10:19.000000', 'consum', 0.0231, 'lps'),
	(504829, 131, '2014-01-15 00:10:20.000000', 'consum', 0.0213, 'lps'),
	(504830, 131, '2014-01-15 00:10:21.000000', 'consum', 0.0229, 'lps'),
	(504831, 131, '2014-01-15 00:10:22.000000', 'consum', 0.0231, 'lps'),
	(504832, 131, '2014-01-15 00:10:23.000000', 'consum', 0.0212, 'lps'),
	(504833, 131, '2014-01-15 00:10:24.000000', 'consum', 0.0224, 'lps'),
	(504834, 131, '2014-01-15 00:10:25.000000', 'consum', 0.0210, 'lps'),
	(504835, 131, '2014-01-15 00:10:26.000000', 'consum', 0.0214, 'lps'),
	(504836, 131, '2014-01-15 00:10:27.000000', 'consum', 0.0228, 'lps'),
	(504837, 131, '2014-01-15 00:10:28.000000', 'consum', 0.0222, 'lps'),
	(504838, 131, '2014-01-15 00:10:29.000000', 'consum', 0.0217, 'lps'),
	(504839, 131, '2014-01-15 00:10:30.000000', 'consum', 0.0212, 'lps'),
	(504840, 131, '2014-01-15 00:10:31.000000', 'consum', 0.0218, 'lps'),
	(504841, 131, '2014-01-15 00:10:32.000000', 'consum', 0.0225, 'lps'),
	(504842, 131, '2014-01-15 00:10:33.000000', 'consum', 0.0217, 'lps'),
	(504843, 131, '2014-01-15 00:10:34.000000', 'consum', 0.0224, 'lps'),
	(504844, 131, '2014-01-15 00:10:35.000000', 'consum', 0.0214, 'lps'),
	(504845, 131, '2014-01-15 00:10:36.000000', 'consum', 0.0212, 'lps'),
	(504846, 131, '2014-01-15 00:10:37.000000', 'consum', 0.0230, 'lps'),
	(504847, 131, '2014-01-15 00:10:38.000000', 'consum', 0.0217, 'lps'),
	(504848, 131, '2014-01-15 00:10:39.000000', 'consum', 0.0229, 'lps'),
	(504849, 131, '2014-01-15 00:10:40.000000', 'consum', 0.0218, 'lps'),
	(504850, 131, '2014-01-15 00:10:41.000000', 'consum', 0.0218, 'lps'),
	(504851, 131, '2014-01-15 00:10:42.000000', 'consum', 0.0225, 'lps'),
	(504852, 131, '2014-01-15 00:10:43.000000', 'consum', 0.0216, 'lps'),
	(504853, 131, '2014-01-15 00:10:44.000000', 'consum', 0.0220, 'lps'),
	(504854, 131, '2014-01-15 00:10:45.000000', 'consum', 0.0218, 'lps'),
	(504855, 131, '2014-01-15 00:10:46.000000', 'consum', 0.0221, 'lps'),
	(504856, 131, '2014-01-15 00:10:47.000000', 'consum', 0.0221, 'lps'),
	(504857, 131, '2014-01-15 00:10:48.000000', 'consum', 0.0230, 'lps'),
	(504858, 131, '2014-01-15 00:10:49.000000', 'consum', 0.0213, 'lps'),
	(504859, 131, '2014-01-15 00:10:50.000000', 'consum', 0.0211, 'lps'),
	(504860, 131, '2014-01-15 00:10:51.000000', 'consum', 0.0228, 'lps'),
	(504861, 131, '2014-01-15 00:10:52.000000', 'consum', 0.0210, 'lps'),
	(504862, 131, '2014-01-15 00:10:53.000000', 'consum', 0.0221, 'lps'),
	(504863, 131, '2014-01-15 00:10:54.000000', 'consum', 0.0222, 'lps'),
	(504864, 131, '2014-01-15 00:10:55.000000', 'consum', 0.0215, 'lps'),
	(504865, 131, '2014-01-15 00:10:56.000000', 'consum', 0.0224, 'lps'),
	(504866, 131, '2014-01-15 00:10:57.000000', 'consum', 0.0218, 'lps'),
	(504867, 131, '2014-01-15 00:10:58.000000', 'consum', 0.0210, 'lps'),
	(504868, 131, '2014-01-15 00:10:59.000000', 'consum', 0.0210, 'lps'),
	(504869, 131, '2014-01-15 00:11:00.000000', 'consum', 0.0210, 'lps'),
	(504870, 131, '2014-01-15 00:11:01.000000', 'consum', 0.0210, 'lps'),
	(504871, 131, '2014-01-15 00:11:02.000000', 'consum', 0.0212, 'lps'),
	(504872, 131, '2014-01-15 00:11:03.000000', 'consum', 0.0220, 'lps'),
	(504873, 131, '2014-01-15 00:11:04.000000', 'consum', 0.0210, 'lps'),
	(504874, 131, '2014-01-15 00:11:05.000000', 'consum', 0.0225, 'lps'),
	(504875, 131, '2014-01-15 00:11:06.000000', 'consum', 0.0221, 'lps'),
	(504876, 131, '2014-01-15 00:11:07.000000', 'consum', 0.0219, 'lps'),
	(504877, 131, '2014-01-15 00:11:08.000000', 'consum', 0.0223, 'lps'),
	(504878, 131, '2014-01-15 00:11:09.000000', 'consum', 0.0224, 'lps'),
	(504879, 131, '2014-01-15 00:11:10.000000', 'consum', 0.0222, 'lps'),
	(504880, 131, '2014-01-15 00:11:11.000000', 'consum', 0.0229, 'lps'),
	(504881, 131, '2014-01-15 00:11:12.000000', 'consum', 0.0226, 'lps'),
	(504882, 131, '2014-01-15 00:11:13.000000', 'consum', 0.0231, 'lps'),
	(504883, 131, '2014-01-15 00:11:14.000000', 'consum', 0.0226, 'lps'),
	(504884, 131, '2014-01-15 00:11:15.000000', 'consum', 0.0226, 'lps'),
	(504885, 131, '2014-01-15 00:11:16.000000', 'consum', 0.0222, 'lps'),
	(504886, 131, '2014-01-15 00:11:17.000000', 'consum', 0.0223, 'lps'),
	(504887, 131, '2014-01-15 00:11:18.000000', 'consum', 0.0219, 'lps'),
	(504888, 131, '2014-01-15 00:11:19.000000', 'consum', 0.0213, 'lps'),
	(504889, 131, '2014-01-15 00:11:20.000000', 'consum', 0.0223, 'lps'),
	(504890, 131, '2014-01-15 00:11:21.000000', 'consum', 0.0221, 'lps'),
	(504891, 131, '2014-01-15 00:11:22.000000', 'consum', 0.0229, 'lps'),
	(504892, 131, '2014-01-15 00:11:23.000000', 'consum', 0.0226, 'lps'),
	(504893, 131, '2014-01-15 00:11:24.000000', 'consum', 0.0213, 'lps'),
	(504894, 131, '2014-01-15 00:11:25.000000', 'consum', 0.0221, 'lps'),
	(504895, 131, '2014-01-15 00:11:26.000000', 'consum', 0.0214, 'lps'),
	(504896, 131, '2014-01-15 00:11:27.000000', 'consum', 0.0219, 'lps'),
	(504897, 131, '2014-01-15 00:11:28.000000', 'consum', 0.0220, 'lps'),
	(504898, 131, '2014-01-15 00:11:29.000000', 'consum', 0.0213, 'lps'),
	(504899, 131, '2014-01-15 00:11:30.000000', 'consum', 0.0217, 'lps'),
	(504900, 131, '2014-01-15 00:11:31.000000', 'consum', 0.0215, 'lps'),
	(504901, 131, '2014-01-15 00:11:32.000000', 'consum', 0.0214, 'lps'),
	(504902, 131, '2014-01-15 00:11:33.000000', 'consum', 0.0215, 'lps'),
	(504903, 131, '2014-01-15 00:11:34.000000', 'consum', 0.0224, 'lps'),
	(504904, 131, '2014-01-15 00:11:35.000000', 'consum', 0.0220, 'lps'),
	(504905, 131, '2014-01-15 00:11:36.000000', 'consum', 0.0218, 'lps'),
	(504906, 131, '2014-01-15 00:11:37.000000', 'consum', 0.0220, 'lps'),
	(504907, 131, '2014-01-15 00:11:38.000000', 'consum', 0.0216, 'lps'),
	(504908, 131, '2014-01-15 00:11:39.000000', 'consum', 0.0230, 'lps'),
	(504909, 131, '2014-01-15 00:11:40.000000', 'consum', 0.0230, 'lps'),
	(504910, 131, '2014-01-15 00:11:41.000000', 'consum', 0.0227, 'lps'),
	(504911, 131, '2014-01-15 00:11:42.000000', 'consum', 0.0213, 'lps'),
	(504912, 131, '2014-01-15 00:11:43.000000', 'consum', 0.0219, 'lps'),
	(504913, 131, '2014-01-15 00:11:44.000000', 'consum', 0.0224, 'lps'),
	(504914, 131, '2014-01-15 00:11:45.000000', 'consum', 0.0211, 'lps'),
	(504915, 131, '2014-01-15 00:11:46.000000', 'consum', 0.0218, 'lps'),
	(504916, 131, '2014-01-15 00:11:47.000000', 'consum', 0.0227, 'lps'),
	(504917, 131, '2014-01-15 00:11:48.000000', 'consum', 0.0224, 'lps'),
	(504918, 131, '2014-01-15 00:11:49.000000', 'consum', 0.0230, 'lps'),
	(504919, 131, '2014-01-15 00:11:50.000000', 'consum', 0.0226, 'lps'),
	(504920, 131, '2014-01-15 00:11:51.000000', 'consum', 0.0230, 'lps'),
	(504921, 131, '2014-01-15 00:11:52.000000', 'consum', 0.0220, 'lps'),
	(504922, 131, '2014-01-15 00:11:53.000000', 'consum', 0.0221, 'lps'),
	(504923, 131, '2014-01-15 00:11:54.000000', 'consum', 0.0212, 'lps'),
	(504924, 131, '2014-01-15 00:11:55.000000', 'consum', 0.0210, 'lps'),
	(504925, 131, '2014-01-15 00:11:56.000000', 'consum', 0.0226, 'lps'),
	(504926, 131, '2014-01-15 00:11:57.000000', 'consum', 0.0226, 'lps'),
	(504927, 131, '2014-01-15 00:11:58.000000', 'consum', 0.0218, 'lps'),
	(504928, 131, '2014-01-15 00:11:59.000000', 'consum', 0.0227, 'lps'),
	(504929, 131, '2014-01-15 00:12:00.000000', 'consum', 0.0228, 'lps'),
	(504930, 131, '2014-01-15 00:12:01.000000', 'consum', 0.0226, 'lps'),
	(504931, 131, '2014-01-15 00:12:02.000000', 'consum', 0.0213, 'lps'),
	(504932, 131, '2014-01-15 00:12:03.000000', 'consum', 0.0224, 'lps'),
	(504933, 131, '2014-01-15 00:12:04.000000', 'consum', 0.0228, 'lps'),
	(504934, 131, '2014-01-15 00:12:05.000000', 'consum', 0.0213, 'lps'),
	(504935, 131, '2014-01-15 00:12:06.000000', 'consum', 0.0217, 'lps'),
	(504936, 131, '2014-01-15 00:12:07.000000', 'consum', 0.0214, 'lps'),
	(504937, 131, '2014-01-15 00:12:08.000000', 'consum', 0.0211, 'lps'),
	(504938, 131, '2014-01-15 00:12:09.000000', 'consum', 0.0224, 'lps'),
	(504939, 131, '2014-01-15 00:12:10.000000', 'consum', 0.0211, 'lps'),
	(504940, 131, '2014-01-15 00:12:11.000000', 'consum', 0.0218, 'lps'),
	(504941, 131, '2014-01-15 00:12:12.000000', 'consum', 0.0227, 'lps'),
	(504942, 131, '2014-01-15 00:12:13.000000', 'consum', 0.0228, 'lps'),
	(504943, 131, '2014-01-15 00:12:14.000000', 'consum', 0.0226, 'lps'),
	(504944, 131, '2014-01-15 00:12:15.000000', 'consum', 0.0213, 'lps'),
	(504945, 131, '2014-01-15 00:12:16.000000', 'consum', 0.0224, 'lps'),
	(504946, 131, '2014-01-15 00:12:17.000000', 'consum', 0.0228, 'lps'),
	(504947, 131, '2014-01-15 00:12:18.000000', 'consum', 0.0215, 'lps'),
	(504948, 131, '2014-01-15 00:12:19.000000', 'consum', 0.0224, 'lps'),
	(504949, 131, '2014-01-15 00:12:20.000000', 'consum', 0.0222, 'lps'),
	(504950, 131, '2014-01-15 00:12:21.000000', 'consum', 0.0230, 'lps'),
	(504951, 131, '2014-01-15 00:12:22.000000', 'consum', 0.0231, 'lps'),
	(504952, 131, '2014-01-15 00:12:23.000000', 'consum', 0.0211, 'lps'),
	(504953, 131, '2014-01-15 00:12:24.000000', 'consum', 0.0218, 'lps'),
	(504954, 131, '2014-01-15 00:12:25.000000', 'consum', 0.0225, 'lps'),
	(504955, 131, '2014-01-15 00:12:26.000000', 'consum', 0.0216, 'lps'),
	(504956, 131, '2014-01-15 00:12:27.000000', 'consum', 0.0221, 'lps'),
	(504957, 131, '2014-01-15 00:12:28.000000', 'consum', 0.0222, 'lps'),
	(504958, 131, '2014-01-15 00:12:29.000000', 'consum', 0.0218, 'lps'),
	(504959, 131, '2014-01-15 00:12:30.000000', 'consum', 0.0215, 'lps'),
	(504960, 131, '2014-01-15 00:12:31.000000', 'consum', 0.0212, 'lps'),
	(504961, 131, '2014-01-15 00:12:32.000000', 'consum', 0.0225, 'lps'),
	(504962, 131, '2014-01-15 00:12:33.000000', 'consum', 0.0215, 'lps'),
	(504963, 131, '2014-01-15 00:12:34.000000', 'consum', 0.0213, 'lps'),
	(504964, 131, '2014-01-15 00:12:35.000000', 'consum', 0.0231, 'lps'),
	(504965, 131, '2014-01-15 00:12:36.000000', 'consum', 0.0221, 'lps'),
	(504966, 131, '2014-01-15 00:12:37.000000', 'consum', 0.0224, 'lps'),
	(504967, 131, '2014-01-15 00:12:38.000000', 'consum', 0.0225, 'lps'),
	(504968, 131, '2014-01-15 00:12:39.000000', 'consum', 0.0221, 'lps'),
	(504969, 131, '2014-01-15 00:12:40.000000', 'consum', 0.0221, 'lps'),
	(504970, 131, '2014-01-15 00:12:41.000000', 'consum', 0.0212, 'lps'),
	(504971, 131, '2014-01-15 00:12:42.000000', 'consum', 0.0231, 'lps'),
	(504972, 131, '2014-01-15 00:12:43.000000', 'consum', 0.0223, 'lps'),
	(504973, 131, '2014-01-15 00:12:44.000000', 'consum', 0.0212, 'lps'),
	(504974, 131, '2014-01-15 00:12:45.000000', 'consum', 0.0223, 'lps'),
	(504975, 131, '2014-01-15 00:12:46.000000', 'consum', 0.0228, 'lps'),
	(504976, 131, '2014-01-15 00:12:47.000000', 'consum', 0.0216, 'lps'),
	(504977, 131, '2014-01-15 00:12:48.000000', 'consum', 0.0210, 'lps'),
	(504978, 131, '2014-01-15 00:12:49.000000', 'consum', 0.0215, 'lps'),
	(504979, 131, '2014-01-15 00:12:50.000000', 'consum', 0.0213, 'lps'),
	(504980, 131, '2014-01-15 00:12:51.000000', 'consum', 0.0211, 'lps'),
	(504981, 131, '2014-01-15 00:12:52.000000', 'consum', 0.0229, 'lps'),
	(504982, 131, '2014-01-15 00:12:53.000000', 'consum', 0.0213, 'lps'),
	(504983, 131, '2014-01-15 00:12:54.000000', 'consum', 0.0215, 'lps'),
	(504984, 131, '2014-01-15 00:12:55.000000', 'consum', 0.0225, 'lps'),
	(504985, 131, '2014-01-15 00:12:56.000000', 'consum', 0.0227, 'lps'),
	(504986, 131, '2014-01-15 00:12:57.000000', 'consum', 0.0230, 'lps'),
	(504987, 131, '2014-01-15 00:12:58.000000', 'consum', 0.0213, 'lps'),
	(504988, 131, '2014-01-15 00:12:59.000000', 'consum', 0.0212, 'lps'),
	(504989, 131, '2014-01-15 00:13:00.000000', 'consum', 0.0212, 'lps'),
	(504990, 131, '2014-01-15 00:13:01.000000', 'consum', 0.0212, 'lps'),
	(504991, 131, '2014-01-15 00:13:02.000000', 'consum', 0.0214, 'lps'),
	(504992, 131, '2014-01-15 00:13:03.000000', 'consum', 0.0226, 'lps'),
	(504993, 131, '2014-01-15 00:13:04.000000', 'consum', 0.0214, 'lps'),
	(504994, 131, '2014-01-15 00:13:05.000000', 'consum', 0.0224, 'lps'),
	(504995, 131, '2014-01-15 00:13:06.000000', 'consum', 0.0226, 'lps'),
	(504996, 131, '2014-01-15 00:13:07.000000', 'consum', 0.0224, 'lps'),
	(504997, 131, '2014-01-15 00:13:08.000000', 'consum', 0.0212, 'lps'),
	(504998, 131, '2014-01-15 00:13:09.000000', 'consum', 0.0221, 'lps'),
	(504999, 131, '2014-01-15 00:13:10.000000', 'consum', 0.0216, 'lps'),
	(505000, 131, '2014-01-15 00:13:11.000000', 'consum', 0.0229, 'lps'),
	(505001, 131, '2014-01-15 00:13:12.000000', 'consum', 0.0220, 'lps'),
	(505002, 131, '2014-01-15 00:13:13.000000', 'consum', 0.0228, 'lps'),
	(505003, 131, '2014-01-15 00:13:14.000000', 'consum', 0.0227, 'lps'),
	(505004, 131, '2014-01-15 00:13:15.000000', 'consum', 0.0217, 'lps'),
	(505005, 131, '2014-01-15 00:13:16.000000', 'consum', 0.0219, 'lps'),
	(505006, 131, '2014-01-15 00:13:17.000000', 'consum', 0.0213, 'lps'),
	(505007, 131, '2014-01-15 00:13:18.000000', 'consum', 0.0220, 'lps'),
	(505008, 131, '2014-01-15 00:13:19.000000', 'consum', 0.0227, 'lps'),
	(505009, 131, '2014-01-15 00:13:20.000000', 'consum', 0.0223, 'lps'),
	(505010, 131, '2014-01-15 00:13:21.000000', 'consum', 0.0226, 'lps'),
	(505011, 131, '2014-01-15 00:13:22.000000', 'consum', 0.0229, 'lps'),
	(505012, 131, '2014-01-15 00:13:23.000000', 'consum', 0.0213, 'lps'),
	(505013, 131, '2014-01-15 00:13:24.000000', 'consum', 0.0214, 'lps'),
	(505014, 131, '2014-01-15 00:13:25.000000', 'consum', 0.0221, 'lps'),
	(505015, 131, '2014-01-15 00:13:26.000000', 'consum', 0.0231, 'lps'),
	(505016, 131, '2014-01-15 00:13:27.000000', 'consum', 0.0218, 'lps'),
	(505017, 131, '2014-01-15 00:13:28.000000', 'consum', 0.0210, 'lps'),
	(505018, 131, '2014-01-15 00:13:29.000000', 'consum', 0.0231, 'lps'),
	(505019, 131, '2014-01-15 00:13:30.000000', 'consum', 0.0227, 'lps'),
	(505020, 131, '2014-01-15 00:13:31.000000', 'consum', 0.0210, 'lps'),
	(505021, 131, '2014-01-15 00:13:32.000000', 'consum', 0.0226, 'lps'),
	(505022, 131, '2014-01-15 00:13:33.000000', 'consum', 0.0223, 'lps'),
	(505023, 131, '2014-01-15 00:13:34.000000', 'consum', 0.0227, 'lps'),
	(505024, 131, '2014-01-15 00:13:35.000000', 'consum', 0.0212, 'lps'),
	(505025, 131, '2014-01-15 00:13:36.000000', 'consum', 0.0215, 'lps'),
	(505026, 131, '2014-01-15 00:13:37.000000', 'consum', 0.0231, 'lps'),
	(505027, 131, '2014-01-15 00:13:38.000000', 'consum', 0.0210, 'lps'),
	(505028, 131, '2014-01-15 00:13:39.000000', 'consum', 0.0216, 'lps'),
	(505029, 131, '2014-01-15 00:13:40.000000', 'consum', 0.0217, 'lps'),
	(505030, 131, '2014-01-15 00:13:41.000000', 'consum', 0.0229, 'lps'),
	(505031, 131, '2014-01-15 00:13:42.000000', 'consum', 0.0219, 'lps'),
	(505032, 131, '2014-01-15 00:13:43.000000', 'consum', 0.0220, 'lps'),
	(505033, 131, '2014-01-15 00:13:44.000000', 'consum', 0.0212, 'lps'),
	(505034, 131, '2014-01-15 00:13:45.000000', 'consum', 0.0213, 'lps'),
	(505035, 131, '2014-01-15 00:13:46.000000', 'consum', 0.0219, 'lps'),
	(505036, 131, '2014-01-15 00:13:47.000000', 'consum', 0.0226, 'lps'),
	(505037, 131, '2014-01-15 00:13:48.000000', 'consum', 0.0220, 'lps'),
	(505038, 131, '2014-01-15 00:13:49.000000', 'consum', 0.0211, 'lps'),
	(505039, 131, '2014-01-15 00:13:50.000000', 'consum', 0.0229, 'lps'),
	(505040, 131, '2014-01-15 00:13:51.000000', 'consum', 0.0214, 'lps'),
	(505041, 131, '2014-01-15 00:13:52.000000', 'consum', 0.0220, 'lps'),
	(505042, 131, '2014-01-15 00:13:53.000000', 'consum', 0.0226, 'lps'),
	(505043, 131, '2014-01-15 00:13:54.000000', 'consum', 0.0215, 'lps'),
	(505044, 131, '2014-01-15 00:13:55.000000', 'consum', 0.0230, 'lps'),
	(505045, 131, '2014-01-15 00:13:56.000000', 'consum', 0.0231, 'lps'),
	(505046, 131, '2014-01-15 00:13:57.000000', 'consum', 0.0213, 'lps'),
	(505047, 131, '2014-01-15 00:13:58.000000', 'consum', 0.0228, 'lps'),
	(505048, 131, '2014-01-15 00:13:59.000000', 'consum', 0.0225, 'lps'),
	(505049, 131, '2014-01-15 00:14:00.000000', 'consum', 0.0211, 'lps'),
	(505050, 131, '2014-01-15 00:14:01.000000', 'consum', 0.0215, 'lps'),
	(505051, 131, '2014-01-15 00:14:02.000000', 'consum', 0.0211, 'lps'),
	(505052, 131, '2014-01-15 00:14:03.000000', 'consum', 0.0222, 'lps'),
	(505053, 131, '2014-01-15 00:14:04.000000', 'consum', 0.0222, 'lps'),
	(505054, 131, '2014-01-15 00:14:05.000000', 'consum', 0.0215, 'lps'),
	(505055, 131, '2014-01-15 00:14:06.000000', 'consum', 0.0222, 'lps'),
	(505056, 131, '2014-01-15 00:14:07.000000', 'consum', 0.0210, 'lps'),
	(505057, 131, '2014-01-15 00:14:08.000000', 'consum', 0.0217, 'lps'),
	(505058, 131, '2014-01-15 00:14:09.000000', 'consum', 0.0223, 'lps'),
	(505059, 131, '2014-01-15 00:14:10.000000', 'consum', 0.0212, 'lps'),
	(505060, 131, '2014-01-15 00:14:11.000000', 'consum', 0.0227, 'lps'),
	(505061, 131, '2014-01-15 00:14:12.000000', 'consum', 0.0223, 'lps'),
	(505062, 131, '2014-01-15 00:14:13.000000', 'consum', 0.0224, 'lps'),
	(505063, 131, '2014-01-15 00:14:14.000000', 'consum', 0.0219, 'lps'),
	(505064, 131, '2014-01-15 00:14:15.000000', 'consum', 0.0214, 'lps'),
	(505065, 131, '2014-01-15 00:14:16.000000', 'consum', 0.0224, 'lps'),
	(505066, 131, '2014-01-15 00:14:17.000000', 'consum', 0.0226, 'lps'),
	(505067, 131, '2014-01-15 00:14:18.000000', 'consum', 0.0226, 'lps'),
	(505068, 131, '2014-01-15 00:14:19.000000', 'consum', 0.0220, 'lps'),
	(505069, 131, '2014-01-15 00:14:20.000000', 'consum', 0.0215, 'lps'),
	(505070, 131, '2014-01-15 00:14:21.000000', 'consum', 0.0226, 'lps'),
	(505071, 131, '2014-01-15 00:14:22.000000', 'consum', 0.0211, 'lps'),
	(505072, 131, '2014-01-15 00:14:23.000000', 'consum', 0.0231, 'lps'),
	(505073, 131, '2014-01-15 00:14:24.000000', 'consum', 0.0225, 'lps'),
	(505074, 131, '2014-01-15 00:14:25.000000', 'consum', 0.0224, 'lps'),
	(505075, 131, '2014-01-15 00:14:26.000000', 'consum', 0.0211, 'lps'),
	(505076, 131, '2014-01-15 00:14:27.000000', 'consum', 0.0219, 'lps'),
	(505077, 131, '2014-01-15 00:14:28.000000', 'consum', 0.0229, 'lps'),
	(505078, 131, '2014-01-15 00:14:29.000000', 'consum', 0.0214, 'lps'),
	(505079, 131, '2014-01-15 00:14:30.000000', 'consum', 0.0219, 'lps'),
	(505080, 131, '2014-01-15 00:14:31.000000', 'consum', 0.0221, 'lps'),
	(505081, 131, '2014-01-15 00:14:32.000000', 'consum', 0.0214, 'lps'),
	(505082, 131, '2014-01-15 00:14:33.000000', 'consum', 0.0220, 'lps'),
	(505083, 131, '2014-01-15 00:14:34.000000', 'consum', 0.0228, 'lps'),
	(505084, 131, '2014-01-15 00:14:35.000000', 'consum', 0.0226, 'lps'),
	(505085, 131, '2014-01-15 00:14:36.000000', 'consum', 0.0214, 'lps'),
	(505086, 131, '2014-01-15 00:14:37.000000', 'consum', 0.0228, 'lps'),
	(505087, 131, '2014-01-15 00:14:38.000000', 'consum', 0.0223, 'lps'),
	(505088, 131, '2014-01-15 00:14:39.000000', 'consum', 0.0222, 'lps'),
	(505089, 131, '2014-01-15 00:14:40.000000', 'consum', 0.0231, 'lps'),
	(505090, 131, '2014-01-15 00:14:41.000000', 'consum', 0.0215, 'lps'),
	(505091, 131, '2014-01-15 00:14:42.000000', 'consum', 0.0213, 'lps'),
	(505092, 131, '2014-01-15 00:14:43.000000', 'consum', 0.0213, 'lps'),
	(505093, 131, '2014-01-15 00:14:44.000000', 'consum', 0.0215, 'lps'),
	(505094, 131, '2014-01-15 00:14:45.000000', 'consum', 0.0225, 'lps'),
	(505095, 131, '2014-01-15 00:14:46.000000', 'consum', 0.0228, 'lps'),
	(505096, 131, '2014-01-15 00:14:47.000000', 'consum', 0.0212, 'lps'),
	(505097, 131, '2014-01-15 00:14:48.000000', 'consum', 0.0231, 'lps'),
	(505098, 131, '2014-01-15 00:14:49.000000', 'consum', 0.0222, 'lps'),
	(505099, 131, '2014-01-15 00:14:50.000000', 'consum', 0.0231, 'lps'),
	(505100, 131, '2014-01-15 00:14:51.000000', 'consum', 0.0214, 'lps'),
	(505101, 131, '2014-01-15 00:14:52.000000', 'consum', 0.0231, 'lps'),
	(505102, 131, '2014-01-15 00:14:53.000000', 'consum', 0.0216, 'lps'),
	(505103, 131, '2014-01-15 00:14:54.000000', 'consum', 0.0223, 'lps'),
	(505104, 131, '2014-01-15 00:14:55.000000', 'consum', 0.0214, 'lps'),
	(505105, 131, '2014-01-15 00:14:56.000000', 'consum', 0.0213, 'lps'),
	(505106, 131, '2014-01-15 00:14:57.000000', 'consum', 0.0214, 'lps'),
	(505107, 131, '2014-01-15 00:14:58.000000', 'consum', 0.0220, 'lps'),
	(505108, 131, '2014-01-15 00:14:59.000000', 'consum', 0.0227, 'lps'),
	(505109, 131, '2014-01-15 00:15:00.000000', 'consum', 0.0221, 'lps'),
	(505110, 131, '2014-01-15 00:15:01.000000', 'consum', 0.0213, 'lps'),
	(505111, 131, '2014-01-15 00:15:02.000000', 'consum', 0.0217, 'lps'),
	(505112, 131, '2014-01-15 00:15:03.000000', 'consum', 0.0214, 'lps'),
	(505113, 131, '2014-01-15 00:15:04.000000', 'consum', 0.0211, 'lps'),
	(505114, 131, '2014-01-15 00:15:05.000000', 'consum', 0.0223, 'lps'),
	(505115, 131, '2014-01-15 00:15:06.000000', 'consum', 0.0227, 'lps'),
	(505116, 131, '2014-01-15 00:15:07.000000', 'consum', 0.0216, 'lps'),
	(505117, 131, '2014-01-15 00:15:08.000000', 'consum', 0.0230, 'lps'),
	(505118, 131, '2014-01-15 00:15:09.000000', 'consum', 0.0228, 'lps'),
	(505119, 131, '2014-01-15 00:15:10.000000', 'consum', 0.0220, 'lps'),
	(505120, 131, '2014-01-15 00:15:11.000000', 'consum', 0.0229, 'lps'),
	(505121, 131, '2014-01-15 00:15:12.000000', 'consum', 0.0210, 'lps'),
	(505122, 131, '2014-01-15 00:15:13.000000', 'consum', 0.0219, 'lps'),
	(505123, 131, '2014-01-15 00:15:14.000000', 'consum', 0.0210, 'lps'),
	(505124, 131, '2014-01-15 00:15:15.000000', 'consum', 0.0227, 'lps'),
	(505125, 131, '2014-01-15 00:15:16.000000', 'consum', 0.0229, 'lps'),
	(505126, 131, '2014-01-15 00:15:17.000000', 'consum', 0.0231, 'lps'),
	(505127, 131, '2014-01-15 00:15:18.000000', 'consum', 0.0218, 'lps'),
	(505128, 131, '2014-01-15 00:15:19.000000', 'consum', 0.0229, 'lps'),
	(505129, 131, '2014-01-15 00:15:20.000000', 'consum', 0.0215, 'lps'),
	(505130, 131, '2014-01-15 00:15:21.000000', 'consum', 0.0223, 'lps'),
	(505131, 131, '2014-01-15 00:15:22.000000', 'consum', 0.0218, 'lps'),
	(505132, 131, '2014-01-15 00:15:23.000000', 'consum', 0.0212, 'lps'),
	(505133, 131, '2014-01-15 00:15:24.000000', 'consum', 0.0216, 'lps'),
	(505134, 131, '2014-01-15 00:15:25.000000', 'consum', 0.0216, 'lps'),
	(505135, 131, '2014-01-15 00:15:26.000000', 'consum', 0.0219, 'lps'),
	(505136, 131, '2014-01-15 00:15:27.000000', 'consum', 0.0218, 'lps'),
	(505137, 131, '2014-01-15 00:15:28.000000', 'consum', 0.0223, 'lps'),
	(505138, 131, '2014-01-15 00:15:29.000000', 'consum', 0.0231, 'lps'),
	(505139, 131, '2014-01-15 00:15:30.000000', 'consum', 0.0231, 'lps'),
	(505140, 131, '2014-01-15 00:15:31.000000', 'consum', 0.0229, 'lps'),
	(505141, 131, '2014-01-15 00:15:32.000000', 'consum', 0.0220, 'lps'),
	(505142, 131, '2014-01-15 00:15:33.000000', 'consum', 0.0227, 'lps'),
	(505143, 131, '2014-01-15 00:15:34.000000', 'consum', 0.0222, 'lps'),
	(505144, 131, '2014-01-15 00:15:35.000000', 'consum', 0.0220, 'lps'),
	(505145, 131, '2014-01-15 00:15:36.000000', 'consum', 0.0226, 'lps'),
	(505146, 131, '2014-01-15 00:15:37.000000', 'consum', 0.0213, 'lps'),
	(505147, 131, '2014-01-15 00:15:38.000000', 'consum', 0.0223, 'lps'),
	(505148, 131, '2014-01-15 00:15:39.000000', 'consum', 0.0220, 'lps'),
	(505149, 131, '2014-01-15 00:15:40.000000', 'consum', 0.0225, 'lps'),
	(505150, 131, '2014-01-15 00:15:41.000000', 'consum', 0.0211, 'lps'),
	(505151, 131, '2014-01-15 00:15:42.000000', 'consum', 0.0212, 'lps'),
	(505152, 131, '2014-01-15 00:15:43.000000', 'consum', 0.0220, 'lps'),
	(505153, 131, '2014-01-15 00:15:44.000000', 'consum', 0.0231, 'lps'),
	(505154, 131, '2014-01-15 00:15:45.000000', 'consum', 0.0221, 'lps'),
	(505155, 131, '2014-01-15 00:15:46.000000', 'consum', 0.0222, 'lps'),
	(505156, 131, '2014-01-15 00:15:47.000000', 'consum', 0.0218, 'lps'),
	(505157, 131, '2014-01-15 00:15:48.000000', 'consum', 0.0215, 'lps'),
	(505158, 131, '2014-01-15 00:15:49.000000', 'consum', 0.0230, 'lps'),
	(505159, 131, '2014-01-15 00:15:50.000000', 'consum', 0.0211, 'lps'),
	(505160, 131, '2014-01-15 00:15:51.000000', 'consum', 0.0221, 'lps'),
	(505161, 131, '2014-01-15 00:15:52.000000', 'consum', 0.0217, 'lps'),
	(505162, 131, '2014-01-15 00:15:53.000000', 'consum', 0.0213, 'lps'),
	(505163, 131, '2014-01-15 00:15:54.000000', 'consum', 0.0225, 'lps'),
	(505164, 131, '2014-01-15 00:15:55.000000', 'consum', 0.0211, 'lps'),
	(505165, 131, '2014-01-15 00:15:56.000000', 'consum', 0.0216, 'lps'),
	(505166, 131, '2014-01-15 00:15:57.000000', 'consum', 0.0215, 'lps'),
	(505167, 131, '2014-01-15 00:15:58.000000', 'consum', 0.0218, 'lps'),
	(505168, 131, '2014-01-15 00:15:59.000000', 'consum', 0.0214, 'lps'),
	(505169, 131, '2014-01-15 00:16:00.000000', 'consum', 0.0229, 'lps'),
	(505170, 131, '2014-01-15 00:16:01.000000', 'consum', 0.0225, 'lps'),
	(505171, 131, '2014-01-15 00:16:02.000000', 'consum', 0.0229, 'lps'),
	(505172, 131, '2014-01-15 00:16:03.000000', 'consum', 0.0216, 'lps'),
	(505173, 131, '2014-01-15 00:16:04.000000', 'consum', 0.0227, 'lps'),
	(505174, 131, '2014-01-15 00:16:05.000000', 'consum', 0.0214, 'lps'),
	(505175, 131, '2014-01-15 00:16:06.000000', 'consum', 0.0224, 'lps'),
	(505176, 131, '2014-01-15 00:16:07.000000', 'consum', 0.0222, 'lps'),
	(505177, 131, '2014-01-15 00:16:08.000000', 'consum', 0.0228, 'lps'),
	(505178, 131, '2014-01-15 00:16:09.000000', 'consum', 0.0219, 'lps'),
	(505179, 131, '2014-01-15 00:16:10.000000', 'consum', 0.0227, 'lps'),
	(505180, 131, '2014-01-15 00:16:11.000000', 'consum', 0.0222, 'lps'),
	(505181, 131, '2014-01-15 00:16:12.000000', 'consum', 0.0222, 'lps'),
	(505182, 131, '2014-01-15 00:16:13.000000', 'consum', 0.0212, 'lps'),
	(505183, 131, '2014-01-15 00:16:14.000000', 'consum', 0.0229, 'lps'),
	(505184, 131, '2014-01-15 00:16:15.000000', 'consum', 0.0210, 'lps'),
	(505185, 131, '2014-01-15 00:16:16.000000', 'consum', 0.0220, 'lps'),
	(505186, 131, '2014-01-15 00:16:17.000000', 'consum', 0.0218, 'lps'),
	(505187, 131, '2014-01-15 00:16:18.000000', 'consum', 0.0219, 'lps'),
	(505188, 131, '2014-01-15 00:16:19.000000', 'consum', 0.0231, 'lps'),
	(505189, 131, '2014-01-15 00:16:20.000000', 'consum', 0.0221, 'lps'),
	(505190, 131, '2014-01-15 00:16:21.000000', 'consum', 0.0226, 'lps'),
	(505191, 131, '2014-01-15 00:16:22.000000', 'consum', 0.0215, 'lps'),
	(505192, 131, '2014-01-15 00:16:23.000000', 'consum', 0.0230, 'lps'),
	(505193, 131, '2014-01-15 00:16:24.000000', 'consum', 0.0229, 'lps'),
	(505194, 131, '2014-01-15 00:16:25.000000', 'consum', 0.0225, 'lps'),
	(505195, 131, '2014-01-15 00:16:26.000000', 'consum', 0.0226, 'lps'),
	(505196, 131, '2014-01-15 00:16:27.000000', 'consum', 0.0225, 'lps'),
	(505197, 131, '2014-01-15 00:16:28.000000', 'consum', 0.0215, 'lps'),
	(505198, 131, '2014-01-15 00:16:29.000000', 'consum', 0.0211, 'lps'),
	(505199, 131, '2014-01-15 00:16:30.000000', 'consum', 0.0223, 'lps'),
	(505200, 131, '2014-01-15 00:16:31.000000', 'consum', 0.0228, 'lps'),
	(505201, 131, '2014-01-15 00:16:32.000000', 'consum', 0.0216, 'lps'),
	(505202, 131, '2014-01-15 00:16:33.000000', 'consum', 0.0211, 'lps'),
	(505203, 131, '2014-01-15 00:16:34.000000', 'consum', 0.0217, 'lps'),
	(505204, 131, '2014-01-15 00:16:35.000000', 'consum', 0.0221, 'lps'),
	(505205, 131, '2014-01-15 00:16:36.000000', 'consum', 0.0224, 'lps'),
	(505206, 131, '2014-01-15 00:16:37.000000', 'consum', 0.0227, 'lps'),
	(505207, 131, '2014-01-15 00:16:38.000000', 'consum', 0.0229, 'lps'),
	(505208, 131, '2014-01-15 00:16:39.000000', 'consum', 0.0213, 'lps'),
	(505209, 131, '2014-01-15 00:16:40.000000', 'consum', 0.0211, 'lps'),
	(505210, 131, '2014-01-15 00:16:41.000000', 'consum', 0.0230, 'lps'),
	(505211, 131, '2014-01-15 00:16:42.000000', 'consum', 0.0219, 'lps'),
	(505212, 131, '2014-01-15 00:16:43.000000', 'consum', 0.0217, 'lps'),
	(505213, 131, '2014-01-15 00:16:44.000000', 'consum', 0.0218, 'lps'),
	(505214, 131, '2014-01-15 00:16:45.000000', 'consum', 0.0228, 'lps'),
	(505215, 131, '2014-01-15 00:16:46.000000', 'consum', 0.0212, 'lps'),
	(505216, 131, '2014-01-15 00:16:47.000000', 'consum', 0.0231, 'lps'),
	(505217, 131, '2014-01-15 00:16:48.000000', 'consum', 0.0222, 'lps'),
	(505218, 131, '2014-01-15 00:16:49.000000', 'consum', 0.0230, 'lps'),
	(505219, 131, '2014-01-15 00:16:50.000000', 'consum', 0.0230, 'lps'),
	(505220, 131, '2014-01-15 00:16:51.000000', 'consum', 0.0228, 'lps'),
	(505221, 131, '2014-01-15 00:16:52.000000', 'consum', 0.0217, 'lps'),
	(505222, 131, '2014-01-15 00:16:53.000000', 'consum', 0.0217, 'lps'),
	(505223, 131, '2014-01-15 00:16:54.000000', 'consum', 0.0223, 'lps'),
	(505224, 131, '2014-01-15 00:16:55.000000', 'consum', 0.0231, 'lps'),
	(505225, 131, '2014-01-15 00:16:56.000000', 'consum', 0.0214, 'lps'),
	(505226, 131, '2014-01-15 00:16:57.000000', 'consum', 0.0230, 'lps'),
	(505227, 131, '2014-01-15 00:16:58.000000', 'consum', 0.0213, 'lps'),
	(505228, 131, '2014-01-15 00:16:59.000000', 'consum', 0.0210, 'lps'),
	(505229, 131, '2014-01-15 00:17:00.000000', 'consum', 0.0223, 'lps'),
	(505230, 131, '2014-01-15 00:17:01.000000', 'consum', 0.0230, 'lps'),
	(505231, 131, '2014-01-15 00:17:02.000000', 'consum', 0.0227, 'lps'),
	(505232, 131, '2014-01-15 00:17:03.000000', 'consum', 0.0215, 'lps'),
	(505233, 131, '2014-01-15 00:17:04.000000', 'consum', 0.0228, 'lps'),
	(505234, 131, '2014-01-15 00:17:05.000000', 'consum', 0.0221, 'lps'),
	(505235, 131, '2014-01-15 00:17:06.000000', 'consum', 0.0212, 'lps'),
	(505236, 131, '2014-01-15 00:17:07.000000', 'consum', 0.0229, 'lps'),
	(505237, 131, '2014-01-15 00:17:08.000000', 'consum', 0.0213, 'lps'),
	(505238, 131, '2014-01-15 00:17:09.000000', 'consum', 0.0212, 'lps'),
	(505239, 131, '2014-01-15 00:17:10.000000', 'consum', 0.0213, 'lps'),
	(505240, 131, '2014-01-15 00:17:11.000000', 'consum', 0.0217, 'lps'),
	(505241, 131, '2014-01-15 00:17:12.000000', 'consum', 0.0214, 'lps'),
	(505242, 131, '2014-01-15 00:17:13.000000', 'consum', 0.0212, 'lps'),
	(505243, 131, '2014-01-15 00:17:14.000000', 'consum', 0.0231, 'lps'),
	(505244, 131, '2014-01-15 00:17:15.000000', 'consum', 0.0219, 'lps'),
	(505245, 131, '2014-01-15 00:17:16.000000', 'consum', 0.0217, 'lps'),
	(505246, 131, '2014-01-15 00:17:17.000000', 'consum', 0.0216, 'lps'),
	(505247, 131, '2014-01-15 00:17:18.000000', 'consum', 0.0220, 'lps'),
	(505248, 131, '2014-01-15 00:17:19.000000', 'consum', 0.0220, 'lps'),
	(505249, 131, '2014-01-15 00:17:20.000000', 'consum', 0.0211, 'lps'),
	(505250, 131, '2014-01-15 00:17:21.000000', 'consum', 0.0228, 'lps'),
	(505251, 131, '2014-01-15 00:17:22.000000', 'consum', 0.0230, 'lps'),
	(505252, 131, '2014-01-15 00:17:23.000000', 'consum', 0.0215, 'lps'),
	(505253, 131, '2014-01-15 00:17:24.000000', 'consum', 0.0217, 'lps'),
	(505254, 131, '2014-01-15 00:17:25.000000', 'consum', 0.0231, 'lps'),
	(505255, 131, '2014-01-15 00:17:26.000000', 'consum', 0.0230, 'lps'),
	(505256, 131, '2014-01-15 00:17:27.000000', 'consum', 0.0225, 'lps'),
	(505257, 131, '2014-01-15 00:17:28.000000', 'consum', 0.0226, 'lps'),
	(505258, 131, '2014-01-15 00:17:29.000000', 'consum', 0.0222, 'lps'),
	(505259, 131, '2014-01-15 00:17:30.000000', 'consum', 0.0224, 'lps'),
	(505260, 131, '2014-01-15 00:17:31.000000', 'consum', 0.0222, 'lps'),
	(505261, 131, '2014-01-15 00:17:32.000000', 'consum', 0.0228, 'lps'),
	(505262, 131, '2014-01-15 00:17:33.000000', 'consum', 0.0220, 'lps'),
	(505263, 131, '2014-01-15 00:17:34.000000', 'consum', 0.0231, 'lps'),
	(505264, 131, '2014-01-15 00:17:35.000000', 'consum', 0.0216, 'lps'),
	(505265, 131, '2014-01-15 00:17:36.000000', 'consum', 0.0224, 'lps'),
	(505266, 131, '2014-01-15 00:17:37.000000', 'consum', 0.0216, 'lps'),
	(505267, 131, '2014-01-15 00:17:38.000000', 'consum', 0.0221, 'lps'),
	(505268, 131, '2014-01-15 00:17:39.000000', 'consum', 0.0224, 'lps'),
	(505269, 131, '2014-01-15 00:17:40.000000', 'consum', 0.0229, 'lps'),
	(505270, 131, '2014-01-15 00:17:41.000000', 'consum', 0.0217, 'lps'),
	(505271, 131, '2014-01-15 00:17:42.000000', 'consum', 0.0210, 'lps'),
	(505272, 131, '2014-01-15 00:17:43.000000', 'consum', 0.0213, 'lps'),
	(505273, 131, '2014-01-15 00:17:44.000000', 'consum', 0.0225, 'lps'),
	(505274, 131, '2014-01-15 00:17:45.000000', 'consum', 0.0231, 'lps'),
	(505275, 131, '2014-01-15 00:17:46.000000', 'consum', 0.0226, 'lps'),
	(505276, 131, '2014-01-15 00:17:47.000000', 'consum', 0.0227, 'lps'),
	(505277, 131, '2014-01-15 00:17:48.000000', 'consum', 0.0227, 'lps'),
	(505278, 131, '2014-01-15 00:17:49.000000', 'consum', 0.0224, 'lps'),
	(505279, 131, '2014-01-15 00:17:50.000000', 'consum', 0.0228, 'lps'),
	(505280, 131, '2014-01-15 00:17:51.000000', 'consum', 0.0214, 'lps'),
	(505281, 131, '2014-01-15 00:17:52.000000', 'consum', 0.0223, 'lps'),
	(505282, 131, '2014-01-15 00:17:53.000000', 'consum', 0.0218, 'lps'),
	(505283, 131, '2014-01-15 00:17:54.000000', 'consum', 0.0231, 'lps'),
	(505284, 131, '2014-01-15 00:17:55.000000', 'consum', 0.0229, 'lps'),
	(505285, 131, '2014-01-15 00:17:56.000000', 'consum', 0.0220, 'lps'),
	(505286, 131, '2014-01-15 00:17:57.000000', 'consum', 0.0225, 'lps'),
	(505287, 131, '2014-01-15 00:17:58.000000', 'consum', 0.0210, 'lps'),
	(505288, 131, '2014-01-15 00:17:59.000000', 'consum', 0.0210, 'lps'),
	(505289, 131, '2014-01-15 00:18:00.000000', 'consum', 0.0210, 'lps'),
	(505290, 131, '2014-01-15 00:18:01.000000', 'consum', 0.0210, 'lps'),
	(505291, 131, '2014-01-15 00:18:02.000000', 'consum', 0.0212, 'lps'),
	(505292, 131, '2014-01-15 00:18:03.000000', 'consum', 0.0219, 'lps'),
	(505293, 131, '2014-01-15 00:18:04.000000', 'consum', 0.0228, 'lps'),
	(505294, 131, '2014-01-15 00:18:05.000000', 'consum', 0.0230, 'lps'),
	(505295, 131, '2014-01-15 00:18:06.000000', 'consum', 0.0213, 'lps'),
	(505296, 131, '2014-01-15 00:18:07.000000', 'consum', 0.0211, 'lps'),
	(505297, 131, '2014-01-15 00:18:08.000000', 'consum', 0.0226, 'lps'),
	(505298, 131, '2014-01-15 00:18:09.000000', 'consum', 0.0221, 'lps'),
	(505299, 131, '2014-01-15 00:18:10.000000', 'consum', 0.0217, 'lps'),
	(505300, 131, '2014-01-15 00:18:11.000000', 'consum', 0.0213, 'lps'),
	(505301, 131, '2014-01-15 00:18:12.000000', 'consum', 0.0226, 'lps'),
	(505302, 131, '2014-01-15 00:18:13.000000', 'consum', 0.0217, 'lps'),
	(505303, 131, '2014-01-15 00:18:14.000000', 'consum', 0.0221, 'lps'),
	(505304, 131, '2014-01-15 00:18:15.000000', 'consum', 0.0219, 'lps'),
	(505305, 131, '2014-01-15 00:18:16.000000', 'consum', 0.0224, 'lps'),
	(505306, 131, '2014-01-15 00:18:17.000000', 'consum', 0.0231, 'lps'),
	(505307, 131, '2014-01-15 00:18:18.000000', 'consum', 0.0228, 'lps'),
	(505308, 131, '2014-01-15 00:18:19.000000', 'consum', 0.0218, 'lps'),
	(505309, 131, '2014-01-15 00:18:20.000000', 'consum', 0.0216, 'lps'),
	(505310, 131, '2014-01-15 00:18:21.000000', 'consum', 0.0216, 'lps'),
	(505311, 131, '2014-01-15 00:18:22.000000', 'consum', 0.0223, 'lps'),
	(505312, 131, '2014-01-15 00:18:23.000000', 'consum', 0.0213, 'lps'),
	(505313, 131, '2014-01-15 00:18:24.000000', 'consum', 0.0230, 'lps'),
	(505314, 131, '2014-01-15 00:18:25.000000', 'consum', 0.0214, 'lps'),
	(505315, 131, '2014-01-15 00:18:26.000000', 'consum', 0.0216, 'lps'),
	(505316, 131, '2014-01-15 00:18:27.000000', 'consum', 0.0226, 'lps'),
	(505317, 131, '2014-01-15 00:18:28.000000', 'consum', 0.0230, 'lps'),
	(505318, 131, '2014-01-15 00:18:29.000000', 'consum', 0.0218, 'lps'),
	(505319, 131, '2014-01-15 00:18:30.000000', 'consum', 0.0213, 'lps'),
	(505320, 131, '2014-01-15 00:18:31.000000', 'consum', 0.0223, 'lps'),
	(505321, 131, '2014-01-15 00:18:32.000000', 'consum', 0.0223, 'lps'),
	(505322, 131, '2014-01-15 00:18:33.000000', 'consum', 0.0215, 'lps'),
	(505323, 131, '2014-01-15 00:18:34.000000', 'consum', 0.0217, 'lps'),
	(505324, 131, '2014-01-15 00:18:35.000000', 'consum', 0.0230, 'lps'),
	(505325, 131, '2014-01-15 00:18:36.000000', 'consum', 0.0223, 'lps'),
	(505326, 131, '2014-01-15 00:18:37.000000', 'consum', 0.0216, 'lps'),
	(505327, 131, '2014-01-15 00:18:38.000000', 'consum', 0.0224, 'lps'),
	(505328, 131, '2014-01-15 00:18:39.000000', 'consum', 0.0217, 'lps'),
	(505329, 131, '2014-01-15 00:18:40.000000', 'consum', 0.0227, 'lps'),
	(505330, 131, '2014-01-15 00:18:41.000000', 'consum', 0.0229, 'lps'),
	(505331, 131, '2014-01-15 00:18:42.000000', 'consum', 0.0210, 'lps'),
	(505332, 131, '2014-01-15 00:18:43.000000', 'consum', 0.0222, 'lps'),
	(505333, 131, '2014-01-15 00:18:44.000000', 'consum', 0.0225, 'lps'),
	(505334, 131, '2014-01-15 00:18:45.000000', 'consum', 0.0229, 'lps'),
	(505335, 131, '2014-01-15 00:18:46.000000', 'consum', 0.0217, 'lps'),
	(505336, 131, '2014-01-15 00:18:47.000000', 'consum', 0.0210, 'lps'),
	(505337, 131, '2014-01-15 00:18:48.000000', 'consum', 0.0211, 'lps'),
	(505338, 131, '2014-01-15 00:18:49.000000', 'consum', 0.0214, 'lps'),
	(505339, 131, '2014-01-15 00:18:50.000000', 'consum', 0.0229, 'lps'),
	(505340, 131, '2014-01-15 00:18:51.000000', 'consum', 0.0226, 'lps'),
	(505341, 131, '2014-01-15 00:18:52.000000', 'consum', 0.0212, 'lps'),
	(505342, 131, '2014-01-15 00:18:53.000000', 'consum', 0.0218, 'lps'),
	(505343, 131, '2014-01-15 00:18:54.000000', 'consum', 0.0221, 'lps'),
	(505344, 131, '2014-01-15 00:18:55.000000', 'consum', 0.0219, 'lps'),
	(505345, 131, '2014-01-15 00:18:56.000000', 'consum', 0.0221, 'lps'),
	(505346, 131, '2014-01-15 00:18:57.000000', 'consum', 0.0219, 'lps'),
	(505347, 131, '2014-01-15 00:18:58.000000', 'consum', 0.0223, 'lps'),
	(505348, 131, '2014-01-15 00:18:59.000000', 'consum', 0.0228, 'lps'),
	(505349, 131, '2014-01-15 00:19:00.000000', 'consum', 0.0215, 'lps'),
	(505350, 131, '2014-01-15 00:19:01.000000', 'consum', 0.0225, 'lps'),
	(505351, 131, '2014-01-15 00:19:02.000000', 'consum', 0.0226, 'lps'),
	(505352, 131, '2014-01-15 00:19:03.000000', 'consum', 0.0222, 'lps'),
	(505353, 131, '2014-01-15 00:19:04.000000', 'consum', 0.0226, 'lps'),
	(505354, 131, '2014-01-15 00:19:05.000000', 'consum', 0.0230, 'lps'),
	(505355, 131, '2014-01-15 00:19:06.000000', 'consum', 0.0220, 'lps'),
	(505356, 131, '2014-01-15 00:19:07.000000', 'consum', 0.0221, 'lps'),
	(505357, 131, '2014-01-15 00:19:08.000000', 'consum', 0.0216, 'lps'),
	(505358, 131, '2014-01-15 00:19:09.000000', 'consum', 0.0229, 'lps'),
	(505359, 131, '2014-01-15 00:19:10.000000', 'consum', 0.0219, 'lps'),
	(505360, 131, '2014-01-15 00:19:11.000000', 'consum', 0.0222, 'lps'),
	(505361, 131, '2014-01-15 00:19:12.000000', 'consum', 0.0224, 'lps'),
	(505362, 131, '2014-01-15 00:19:13.000000', 'consum', 0.0219, 'lps'),
	(505363, 131, '2014-01-15 00:19:14.000000', 'consum', 0.0214, 'lps'),
	(505364, 131, '2014-01-15 00:19:15.000000', 'consum', 0.0225, 'lps'),
	(505365, 131, '2014-01-15 00:19:16.000000', 'consum', 0.0210, 'lps'),
	(505366, 131, '2014-01-15 00:19:17.000000', 'consum', 0.0230, 'lps'),
	(505367, 131, '2014-01-15 00:19:18.000000', 'consum', 0.0221, 'lps'),
	(505368, 131, '2014-01-15 00:19:19.000000', 'consum', 0.0229, 'lps'),
	(505369, 131, '2014-01-15 00:19:20.000000', 'consum', 0.0230, 'lps'),
	(505370, 131, '2014-01-15 00:19:21.000000', 'consum', 0.0230, 'lps'),
	(505371, 131, '2014-01-15 00:19:22.000000', 'consum', 0.0231, 'lps'),
	(505372, 131, '2014-01-15 00:19:23.000000', 'consum', 0.0231, 'lps'),
	(505373, 131, '2014-01-15 00:19:24.000000', 'consum', 0.0230, 'lps'),
	(505374, 131, '2014-01-15 00:19:25.000000', 'consum', 0.0226, 'lps'),
	(505375, 131, '2014-01-15 00:19:26.000000', 'consum', 0.0211, 'lps'),
	(505376, 131, '2014-01-15 00:19:27.000000', 'consum', 0.0230, 'lps'),
	(505377, 131, '2014-01-15 00:19:28.000000', 'consum', 0.0221, 'lps'),
	(505378, 131, '2014-01-15 00:19:29.000000', 'consum', 0.0229, 'lps'),
	(505379, 131, '2014-01-15 00:19:30.000000', 'consum', 0.0229, 'lps'),
	(505380, 131, '2014-01-15 00:19:31.000000', 'consum', 0.0224, 'lps'),
	(505381, 131, '2014-01-15 00:19:32.000000', 'consum', 0.0225, 'lps'),
	(505382, 131, '2014-01-15 00:19:33.000000', 'consum', 0.0221, 'lps'),
	(505383, 131, '2014-01-15 00:19:34.000000', 'consum', 0.0222, 'lps'),
	(505384, 131, '2014-01-15 00:19:35.000000', 'consum', 0.0215, 'lps'),
	(505385, 131, '2014-01-15 00:19:36.000000', 'consum', 0.0222, 'lps'),
	(505386, 131, '2014-01-15 00:19:37.000000', 'consum', 0.0211, 'lps'),
	(505387, 131, '2014-01-15 00:19:38.000000', 'consum', 0.0221, 'lps'),
	(505388, 131, '2014-01-15 00:19:39.000000', 'consum', 0.0222, 'lps'),
	(505389, 131, '2014-01-15 00:19:40.000000', 'consum', 0.0213, 'lps'),
	(505390, 131, '2014-01-15 00:19:41.000000', 'consum', 0.0214, 'lps'),
	(505391, 131, '2014-01-15 00:19:42.000000', 'consum', 0.0220, 'lps'),
	(505392, 131, '2014-01-15 00:19:43.000000', 'consum', 0.0225, 'lps'),
	(505393, 131, '2014-01-15 00:19:44.000000', 'consum', 0.0214, 'lps'),
	(505394, 131, '2014-01-15 00:19:45.000000', 'consum', 0.0229, 'lps'),
	(505395, 131, '2014-01-15 00:19:46.000000', 'consum', 0.0228, 'lps'),
	(505396, 131, '2014-01-15 00:19:47.000000', 'consum', 0.0222, 'lps'),
	(505397, 131, '2014-01-15 00:19:48.000000', 'consum', 0.0215, 'lps'),
	(505398, 131, '2014-01-15 00:19:49.000000', 'consum', 0.0220, 'lps'),
	(505399, 131, '2014-01-15 00:19:50.000000', 'consum', 0.0226, 'lps'),
	(505400, 131, '2014-01-15 00:19:51.000000', 'consum', 0.0218, 'lps'),
	(505401, 131, '2014-01-15 00:19:52.000000', 'consum', 0.0222, 'lps'),
	(505402, 131, '2014-01-15 00:19:53.000000', 'consum', 0.0224, 'lps'),
	(505403, 131, '2014-01-15 00:19:54.000000', 'consum', 0.0224, 'lps'),
	(505404, 131, '2014-01-15 00:19:55.000000', 'consum', 0.0217, 'lps'),
	(505405, 131, '2014-01-15 00:19:56.000000', 'consum', 0.0224, 'lps'),
	(505406, 131, '2014-01-15 00:19:57.000000', 'consum', 0.0218, 'lps'),
	(505407, 131, '2014-01-15 00:19:58.000000', 'consum', 0.0228, 'lps'),
	(505408, 131, '2014-01-15 00:19:59.000000', 'consum', 0.0210, 'lps'),
	(505409, 131, '2014-01-15 00:20:00.000000', 'consum', 0.0225, 'lps'),
	(505410, 131, '2014-01-15 00:20:01.000000', 'consum', 0.0220, 'lps'),
	(505411, 131, '2014-01-15 00:20:02.000000', 'consum', 0.0215, 'lps'),
	(505412, 131, '2014-01-15 00:20:03.000000', 'consum', 0.0226, 'lps'),
	(505413, 131, '2014-01-15 00:20:04.000000', 'consum', 0.0231, 'lps'),
	(505414, 131, '2014-01-15 00:20:05.000000', 'consum', 0.0224, 'lps'),
	(505415, 131, '2014-01-15 00:20:06.000000', 'consum', 0.0218, 'lps'),
	(505416, 131, '2014-01-15 00:20:07.000000', 'consum', 0.0231, 'lps'),
	(505417, 131, '2014-01-15 00:20:08.000000', 'consum', 0.0226, 'lps'),
	(505418, 131, '2014-01-15 00:20:09.000000', 'consum', 0.0229, 'lps'),
	(505419, 131, '2014-01-15 00:20:10.000000', 'consum', 0.0211, 'lps'),
	(505420, 131, '2014-01-15 00:20:11.000000', 'consum', 0.0226, 'lps'),
	(505421, 131, '2014-01-15 00:20:12.000000', 'consum', 0.0220, 'lps'),
	(505422, 131, '2014-01-15 00:20:13.000000', 'consum', 0.0213, 'lps'),
	(505423, 131, '2014-01-15 00:20:14.000000', 'consum', 0.0219, 'lps'),
	(505424, 131, '2014-01-15 00:20:15.000000', 'consum', 0.0225, 'lps'),
	(505425, 131, '2014-01-15 00:20:16.000000', 'consum', 0.0215, 'lps'),
	(505426, 131, '2014-01-15 00:20:17.000000', 'consum', 0.0231, 'lps'),
	(505427, 131, '2014-01-15 00:20:18.000000', 'consum', 0.0216, 'lps'),
	(505428, 131, '2014-01-15 00:20:19.000000', 'consum', 0.0219, 'lps'),
	(505429, 131, '2014-01-15 00:20:20.000000', 'consum', 0.0216, 'lps'),
	(505430, 131, '2014-01-15 00:20:21.000000', 'consum', 0.0212, 'lps'),
	(505431, 131, '2014-01-15 00:20:22.000000', 'consum', 0.0227, 'lps'),
	(505432, 131, '2014-01-15 00:20:23.000000', 'consum', 0.0222, 'lps'),
	(505433, 131, '2014-01-15 00:20:24.000000', 'consum', 0.0221, 'lps'),
	(505434, 131, '2014-01-15 00:20:25.000000', 'consum', 0.0227, 'lps'),
	(505435, 131, '2014-01-15 00:20:26.000000', 'consum', 0.0221, 'lps'),
	(505436, 131, '2014-01-15 00:20:27.000000', 'consum', 0.0212, 'lps'),
	(505437, 131, '2014-01-15 00:20:28.000000', 'consum', 0.0213, 'lps'),
	(505438, 131, '2014-01-15 00:20:29.000000', 'consum', 0.0216, 'lps'),
	(505439, 131, '2014-01-15 00:20:30.000000', 'consum', 0.0212, 'lps'),
	(505440, 131, '2014-01-15 00:20:31.000000', 'consum', 0.0222, 'lps'),
	(505441, 131, '2014-01-15 00:20:32.000000', 'consum', 0.0222, 'lps'),
	(505442, 131, '2014-01-15 00:20:33.000000', 'consum', 0.0213, 'lps'),
	(505443, 131, '2014-01-15 00:20:34.000000', 'consum', 0.0231, 'lps'),
	(505444, 131, '2014-01-15 00:20:35.000000', 'consum', 0.0221, 'lps'),
	(505445, 131, '2014-01-15 00:20:36.000000', 'consum', 0.0226, 'lps'),
	(505446, 131, '2014-01-15 00:20:37.000000', 'consum', 0.0211, 'lps'),
	(505447, 131, '2014-01-15 00:20:38.000000', 'consum', 0.0211, 'lps'),
	(505448, 131, '2014-01-15 00:20:39.000000', 'consum', 0.0211, 'lps'),
	(505449, 131, '2014-01-15 00:20:40.000000', 'consum', 0.0216, 'lps'),
	(505450, 131, '2014-01-15 00:20:41.000000', 'consum', 0.0213, 'lps'),
	(505451, 131, '2014-01-15 00:20:42.000000', 'consum', 0.0229, 'lps'),
	(505452, 131, '2014-01-15 00:20:43.000000', 'consum', 0.0230, 'lps'),
	(505453, 131, '2014-01-15 00:20:44.000000', 'consum', 0.0231, 'lps'),
	(505454, 131, '2014-01-15 00:20:45.000000', 'consum', 0.0212, 'lps'),
	(505455, 131, '2014-01-15 00:20:46.000000', 'consum', 0.0224, 'lps'),
	(505456, 131, '2014-01-15 00:20:47.000000', 'consum', 0.0231, 'lps'),
	(505457, 131, '2014-01-15 00:20:48.000000', 'consum', 0.0229, 'lps'),
	(505458, 131, '2014-01-15 00:20:49.000000', 'consum', 0.0219, 'lps'),
	(505459, 131, '2014-01-15 00:20:50.000000', 'consum', 0.0221, 'lps'),
	(505460, 131, '2014-01-15 00:20:51.000000', 'consum', 0.0219, 'lps'),
	(505461, 131, '2014-01-15 00:20:52.000000', 'consum', 0.0219, 'lps'),
	(505462, 131, '2014-01-15 00:20:53.000000', 'consum', 0.0231, 'lps'),
	(505463, 131, '2014-01-15 00:20:54.000000', 'consum', 0.0223, 'lps'),
	(505464, 131, '2014-01-15 00:20:55.000000', 'consum', 0.0214, 'lps'),
	(505465, 131, '2014-01-15 00:20:56.000000', 'consum', 0.0210, 'lps'),
	(505466, 131, '2014-01-15 00:20:57.000000', 'consum', 0.0222, 'lps'),
	(505467, 131, '2014-01-15 00:20:58.000000', 'consum', 0.0226, 'lps'),
	(505468, 131, '2014-01-15 00:20:59.000000', 'consum', 0.0213, 'lps'),
	(505469, 131, '2014-01-15 00:21:00.000000', 'consum', 0.0219, 'lps'),
	(505470, 131, '2014-01-15 00:21:01.000000', 'consum', 0.0227, 'lps'),
	(505471, 131, '2014-01-15 00:21:02.000000', 'consum', 0.0223, 'lps'),
	(505472, 131, '2014-01-15 00:21:03.000000', 'consum', 0.0224, 'lps'),
	(505473, 131, '2014-01-15 00:21:04.000000', 'consum', 0.0222, 'lps'),
	(505474, 131, '2014-01-15 00:21:05.000000', 'consum', 0.0227, 'lps'),
	(505475, 131, '2014-01-15 00:21:06.000000', 'consum', 0.0213, 'lps'),
	(505476, 131, '2014-01-15 00:21:07.000000', 'consum', 0.0222, 'lps'),
	(505477, 131, '2014-01-15 00:21:08.000000', 'consum', 0.0218, 'lps'),
	(505478, 131, '2014-01-15 00:21:09.000000', 'consum', 0.0212, 'lps'),
	(505479, 131, '2014-01-15 00:21:10.000000', 'consum', 0.0219, 'lps'),
	(505480, 131, '2014-01-15 00:21:11.000000', 'consum', 0.0229, 'lps'),
	(505481, 131, '2014-01-15 00:21:12.000000', 'consum', 0.0211, 'lps'),
	(505482, 131, '2014-01-15 00:21:13.000000', 'consum', 0.0224, 'lps'),
	(505483, 131, '2014-01-15 00:21:14.000000', 'consum', 0.0212, 'lps'),
	(505484, 131, '2014-01-15 00:21:15.000000', 'consum', 0.0223, 'lps'),
	(505485, 131, '2014-01-15 00:21:16.000000', 'consum', 0.0226, 'lps'),
	(505486, 131, '2014-01-15 00:21:17.000000', 'consum', 0.0228, 'lps'),
	(505487, 131, '2014-01-15 00:21:18.000000', 'consum', 0.0231, 'lps'),
	(505488, 131, '2014-01-15 00:21:19.000000', 'consum', 0.0220, 'lps'),
	(505489, 131, '2014-01-15 00:21:20.000000', 'consum', 0.0217, 'lps'),
	(505490, 131, '2014-01-15 00:21:21.000000', 'consum', 0.0215, 'lps'),
	(505491, 131, '2014-01-15 00:21:22.000000', 'consum', 0.0214, 'lps'),
	(505492, 131, '2014-01-15 00:21:23.000000', 'consum', 0.0216, 'lps'),
	(505493, 131, '2014-01-15 00:21:24.000000', 'consum', 0.0229, 'lps'),
	(505494, 131, '2014-01-15 00:21:25.000000', 'consum', 0.0222, 'lps'),
	(505495, 131, '2014-01-15 00:21:26.000000', 'consum', 0.0213, 'lps'),
	(505496, 131, '2014-01-15 00:21:27.000000', 'consum', 0.0210, 'lps'),
	(505497, 131, '2014-01-15 00:21:28.000000', 'consum', 0.0225, 'lps'),
	(505498, 131, '2014-01-15 00:21:29.000000', 'consum', 0.0218, 'lps'),
	(505499, 131, '2014-01-15 00:21:30.000000', 'consum', 0.0229, 'lps'),
	(505500, 131, '2014-01-15 00:21:31.000000', 'consum', 0.0215, 'lps'),
	(505501, 131, '2014-01-15 00:21:32.000000', 'consum', 0.0224, 'lps'),
	(505502, 131, '2014-01-15 00:21:33.000000', 'consum', 0.0221, 'lps'),
	(505503, 131, '2014-01-15 00:21:34.000000', 'consum', 0.0223, 'lps'),
	(505504, 131, '2014-01-15 00:21:35.000000', 'consum', 0.0221, 'lps'),
	(505505, 131, '2014-01-15 00:21:36.000000', 'consum', 0.0228, 'lps'),
	(505506, 131, '2014-01-15 00:21:37.000000', 'consum', 0.0221, 'lps'),
	(505507, 131, '2014-01-15 00:21:38.000000', 'consum', 0.0214, 'lps'),
	(505508, 131, '2014-01-15 00:21:39.000000', 'consum', 0.0217, 'lps'),
	(505509, 131, '2014-01-15 00:21:40.000000', 'consum', 0.0211, 'lps'),
	(505510, 131, '2014-01-15 00:21:41.000000', 'consum', 0.0217, 'lps'),
	(505511, 131, '2014-01-15 00:21:42.000000', 'consum', 0.0219, 'lps'),
	(505512, 131, '2014-01-15 00:21:43.000000', 'consum', 0.0215, 'lps'),
	(505513, 131, '2014-01-15 00:21:44.000000', 'consum', 0.0230, 'lps'),
	(505514, 131, '2014-01-15 00:21:45.000000', 'consum', 0.0227, 'lps'),
	(505515, 131, '2014-01-15 00:21:46.000000', 'consum', 0.0217, 'lps'),
	(505516, 131, '2014-01-15 00:21:47.000000', 'consum', 0.0216, 'lps'),
	(505517, 131, '2014-01-15 00:21:48.000000', 'consum', 0.0217, 'lps'),
	(505518, 131, '2014-01-15 00:21:49.000000', 'consum', 0.0229, 'lps'),
	(505519, 131, '2014-01-15 00:21:50.000000', 'consum', 0.0220, 'lps'),
	(505520, 131, '2014-01-15 00:21:51.000000', 'consum', 0.0224, 'lps'),
	(505521, 131, '2014-01-15 00:21:52.000000', 'consum', 0.0229, 'lps'),
	(505522, 131, '2014-01-15 00:21:53.000000', 'consum', 0.0220, 'lps'),
	(505523, 131, '2014-01-15 00:21:54.000000', 'consum', 0.0224, 'lps'),
	(505524, 131, '2014-01-15 00:21:55.000000', 'consum', 0.0231, 'lps'),
	(505525, 131, '2014-01-15 00:21:56.000000', 'consum', 0.0226, 'lps'),
	(505526, 131, '2014-01-15 00:21:57.000000', 'consum', 0.0230, 'lps'),
	(505527, 131, '2014-01-15 00:21:58.000000', 'consum', 0.0216, 'lps'),
	(505528, 131, '2014-01-15 00:21:59.000000', 'consum', 0.0226, 'lps'),
	(505529, 131, '2014-01-15 00:22:00.000000', 'consum', 0.0227, 'lps'),
	(505530, 131, '2014-01-15 00:22:01.000000', 'consum', 0.0227, 'lps'),
	(505531, 131, '2014-01-15 00:22:02.000000', 'consum', 0.0222, 'lps'),
	(505532, 131, '2014-01-15 00:22:03.000000', 'consum', 0.0220, 'lps'),
	(505533, 131, '2014-01-15 00:22:04.000000', 'consum', 0.0225, 'lps'),
	(505534, 131, '2014-01-15 00:22:05.000000', 'consum', 0.0212, 'lps'),
	(505535, 131, '2014-01-15 00:22:06.000000', 'consum', 0.0217, 'lps'),
	(505536, 131, '2014-01-15 00:22:07.000000', 'consum', 0.0221, 'lps'),
	(505537, 131, '2014-01-15 00:22:08.000000', 'consum', 0.0220, 'lps'),
	(505538, 131, '2014-01-15 00:22:09.000000', 'consum', 0.0228, 'lps'),
	(505539, 131, '2014-01-15 00:22:10.000000', 'consum', 0.0228, 'lps'),
	(505540, 131, '2014-01-15 00:22:11.000000', 'consum', 0.0223, 'lps'),
	(505541, 131, '2014-01-15 00:22:12.000000', 'consum', 0.0220, 'lps'),
	(505542, 131, '2014-01-15 00:22:13.000000', 'consum', 0.0225, 'lps'),
	(505543, 131, '2014-01-15 00:22:14.000000', 'consum', 0.0231, 'lps'),
	(505544, 131, '2014-01-15 00:22:15.000000', 'consum', 0.0228, 'lps'),
	(505545, 131, '2014-01-15 00:22:16.000000', 'consum', 0.0215, 'lps'),
	(505546, 131, '2014-01-15 00:22:17.000000', 'consum', 0.0226, 'lps'),
	(505547, 131, '2014-01-15 00:22:18.000000', 'consum', 0.0210, 'lps'),
	(505548, 131, '2014-01-15 00:22:19.000000', 'consum', 0.0229, 'lps'),
	(505549, 131, '2014-01-15 00:22:20.000000', 'consum', 0.0215, 'lps'),
	(505550, 131, '2014-01-15 00:22:21.000000', 'consum', 0.0225, 'lps'),
	(505551, 131, '2014-01-15 00:22:22.000000', 'consum', 0.0224, 'lps'),
	(505552, 131, '2014-01-15 00:22:23.000000', 'consum', 0.0215, 'lps'),
	(505553, 131, '2014-01-15 00:22:24.000000', 'consum', 0.0217, 'lps'),
	(505554, 131, '2014-01-15 00:22:25.000000', 'consum', 0.0228, 'lps'),
	(505555, 131, '2014-01-15 00:22:26.000000', 'consum', 0.0216, 'lps'),
	(505556, 131, '2014-01-15 00:22:27.000000', 'consum', 0.0228, 'lps'),
	(505557, 131, '2014-01-15 00:22:28.000000', 'consum', 0.0219, 'lps'),
	(505558, 131, '2014-01-15 00:22:29.000000', 'consum', 0.0221, 'lps'),
	(505559, 131, '2014-01-15 00:22:30.000000', 'consum', 0.0219, 'lps'),
	(505560, 131, '2014-01-15 00:22:31.000000', 'consum', 0.0223, 'lps'),
	(505561, 131, '2014-01-15 00:22:32.000000', 'consum', 0.0224, 'lps'),
	(505562, 131, '2014-01-15 00:22:33.000000', 'consum', 0.0222, 'lps'),
	(505563, 131, '2014-01-15 00:22:34.000000', 'consum', 0.0226, 'lps'),
	(505564, 131, '2014-01-15 00:22:35.000000', 'consum', 0.0213, 'lps'),
	(505565, 131, '2014-01-15 00:22:36.000000', 'consum', 0.0222, 'lps'),
	(505566, 131, '2014-01-15 00:22:37.000000', 'consum', 0.0215, 'lps'),
	(505567, 131, '2014-01-15 00:22:38.000000', 'consum', 0.0221, 'lps'),
	(505568, 131, '2014-01-15 00:22:39.000000', 'consum', 0.0229, 'lps'),
	(505569, 131, '2014-01-15 00:22:40.000000', 'consum', 0.0227, 'lps'),
	(505570, 131, '2014-01-15 00:22:41.000000', 'consum', 0.0220, 'lps'),
	(505571, 131, '2014-01-15 00:22:42.000000', 'consum', 0.0229, 'lps'),
	(505572, 131, '2014-01-15 00:22:43.000000', 'consum', 0.0231, 'lps'),
	(505573, 131, '2014-01-15 00:22:44.000000', 'consum', 0.0215, 'lps'),
	(505574, 131, '2014-01-15 00:22:45.000000', 'consum', 0.0217, 'lps'),
	(505575, 131, '2014-01-15 00:22:46.000000', 'consum', 0.0229, 'lps'),
	(505576, 131, '2014-01-15 00:22:47.000000', 'consum', 0.0219, 'lps'),
	(505577, 131, '2014-01-15 00:22:48.000000', 'consum', 0.0222, 'lps'),
	(505578, 131, '2014-01-15 00:22:49.000000', 'consum', 0.0220, 'lps'),
	(505579, 131, '2014-01-15 00:22:50.000000', 'consum', 0.0227, 'lps'),
	(505580, 131, '2014-01-15 00:22:51.000000', 'consum', 0.0220, 'lps'),
	(505581, 131, '2014-01-15 00:22:52.000000', 'consum', 0.0230, 'lps'),
	(505582, 131, '2014-01-15 00:22:53.000000', 'consum', 0.0217, 'lps'),
	(505583, 131, '2014-01-15 00:22:54.000000', 'consum', 0.0229, 'lps'),
	(505584, 131, '2014-01-15 00:22:55.000000', 'consum', 0.0218, 'lps'),
	(505585, 131, '2014-01-15 00:22:56.000000', 'consum', 0.0216, 'lps'),
	(505586, 131, '2014-01-15 00:22:57.000000', 'consum', 0.0217, 'lps'),
	(505587, 131, '2014-01-15 00:22:58.000000', 'consum', 0.0229, 'lps'),
	(505588, 131, '2014-01-15 00:22:59.000000', 'consum', 0.0217, 'lps'),
	(505589, 131, '2014-01-15 00:23:00.000000', 'consum', 0.0211, 'lps'),
	(505590, 131, '2014-01-15 00:23:01.000000', 'consum', 0.0218, 'lps'),
	(505591, 131, '2014-01-15 00:23:02.000000', 'consum', 0.0224, 'lps'),
	(505592, 131, '2014-01-15 00:23:03.000000', 'consum', 0.0211, 'lps'),
	(505593, 131, '2014-01-15 00:23:04.000000', 'consum', 0.0217, 'lps'),
	(505594, 131, '2014-01-15 00:23:05.000000', 'consum', 0.0222, 'lps'),
	(505595, 131, '2014-01-15 00:23:06.000000', 'consum', 0.0228, 'lps'),
	(505596, 131, '2014-01-15 00:23:07.000000', 'consum', 0.0220, 'lps'),
	(505597, 131, '2014-01-15 00:23:08.000000', 'consum', 0.0230, 'lps'),
	(505598, 131, '2014-01-15 00:23:09.000000', 'consum', 0.0213, 'lps'),
	(505599, 131, '2014-01-15 00:23:10.000000', 'consum', 0.0210, 'lps'),
	(505600, 131, '2014-01-15 00:23:11.000000', 'consum', 0.0225, 'lps'),
	(505601, 131, '2014-01-15 00:23:12.000000', 'consum', 0.0218, 'lps'),
	(505602, 131, '2014-01-15 00:23:13.000000', 'consum', 0.0228, 'lps'),
	(505603, 131, '2014-01-15 00:23:14.000000', 'consum', 0.0211, 'lps'),
	(505604, 131, '2014-01-15 00:23:15.000000', 'consum', 0.0226, 'lps'),
	(505605, 131, '2014-01-15 00:23:16.000000', 'consum', 0.0221, 'lps'),
	(505606, 131, '2014-01-15 00:23:17.000000', 'consum', 0.0218, 'lps'),
	(505607, 131, '2014-01-15 00:23:18.000000', 'consum', 0.0219, 'lps'),
	(505608, 131, '2014-01-15 00:23:19.000000', 'consum', 0.0229, 'lps'),
	(505609, 131, '2014-01-15 00:23:20.000000', 'consum', 0.0212, 'lps'),
	(505610, 131, '2014-01-15 00:23:21.000000', 'consum', 0.0230, 'lps'),
	(505611, 131, '2014-01-15 00:23:22.000000', 'consum', 0.0218, 'lps'),
	(505612, 131, '2014-01-15 00:23:23.000000', 'consum', 0.0213, 'lps'),
	(505613, 131, '2014-01-15 00:23:24.000000', 'consum', 0.0224, 'lps'),
	(505614, 131, '2014-01-15 00:23:25.000000', 'consum', 0.0228, 'lps'),
	(505615, 131, '2014-01-15 00:23:26.000000', 'consum', 0.0211, 'lps'),
	(505616, 131, '2014-01-15 00:23:27.000000', 'consum', 0.0231, 'lps'),
	(505617, 131, '2014-01-15 00:23:28.000000', 'consum', 0.0225, 'lps'),
	(505618, 131, '2014-01-15 00:23:29.000000', 'consum', 0.0219, 'lps'),
	(505619, 131, '2014-01-15 00:23:30.000000', 'consum', 0.0213, 'lps'),
	(505620, 131, '2014-01-15 00:23:31.000000', 'consum', 0.0220, 'lps'),
	(505621, 131, '2014-01-15 00:23:32.000000', 'consum', 0.0231, 'lps'),
	(505622, 131, '2014-01-15 00:23:33.000000', 'consum', 0.0217, 'lps'),
	(505623, 131, '2014-01-15 00:23:34.000000', 'consum', 0.0226, 'lps'),
	(505624, 131, '2014-01-15 00:23:35.000000', 'consum', 0.0225, 'lps'),
	(505625, 131, '2014-01-15 00:23:36.000000', 'consum', 0.0216, 'lps'),
	(505626, 131, '2014-01-15 00:23:37.000000', 'consum', 0.0218, 'lps'),
	(505627, 131, '2014-01-15 00:23:38.000000', 'consum', 0.0230, 'lps'),
	(505628, 131, '2014-01-15 00:23:39.000000', 'consum', 0.0224, 'lps'),
	(505629, 131, '2014-01-15 00:23:40.000000', 'consum', 0.0217, 'lps'),
	(505630, 131, '2014-01-15 00:23:41.000000', 'consum', 0.0229, 'lps'),
	(505631, 131, '2014-01-15 00:23:42.000000', 'consum', 0.0216, 'lps'),
	(505632, 131, '2014-01-15 00:23:43.000000', 'consum', 0.0228, 'lps'),
	(505633, 131, '2014-01-15 00:23:44.000000', 'consum', 0.0216, 'lps'),
	(505634, 131, '2014-01-15 00:23:45.000000', 'consum', 0.0230, 'lps'),
	(505635, 131, '2014-01-15 00:23:46.000000', 'consum', 0.0228, 'lps'),
	(505636, 131, '2014-01-15 00:23:47.000000', 'consum', 0.0219, 'lps'),
	(505637, 131, '2014-01-15 00:23:48.000000', 'consum', 0.0221, 'lps'),
	(505638, 131, '2014-01-15 00:23:49.000000', 'consum', 0.0216, 'lps'),
	(505639, 131, '2014-01-15 00:23:50.000000', 'consum', 0.0210, 'lps'),
	(505640, 131, '2014-01-15 00:23:51.000000', 'consum', 0.0212, 'lps'),
	(505641, 131, '2014-01-15 00:23:52.000000', 'consum', 0.0220, 'lps'),
	(505642, 131, '2014-01-15 00:23:53.000000', 'consum', 0.0212, 'lps'),
	(505643, 131, '2014-01-15 00:23:54.000000', 'consum', 0.0212, 'lps'),
	(505644, 131, '2014-01-15 00:23:55.000000', 'consum', 0.0214, 'lps'),
	(505645, 131, '2014-01-15 00:23:56.000000', 'consum', 0.0225, 'lps'),
	(505646, 131, '2014-01-15 00:23:57.000000', 'consum', 0.0231, 'lps'),
	(505647, 131, '2014-01-15 00:23:58.000000', 'consum', 0.0225, 'lps'),
	(505648, 131, '2014-01-15 00:23:59.000000', 'consum', 0.0221, 'lps'),
	(505649, 131, '2014-01-15 00:24:00.000000', 'consum', 0.0221, 'lps'),
	(505650, 131, '2014-01-15 00:24:01.000000', 'consum', 0.0210, 'lps'),
	(505651, 131, '2014-01-15 00:24:02.000000', 'consum', 0.0221, 'lps'),
	(505652, 131, '2014-01-15 00:24:03.000000', 'consum', 0.0221, 'lps'),
	(505653, 131, '2014-01-15 00:24:04.000000', 'consum', 0.0211, 'lps'),
	(505654, 131, '2014-01-15 00:24:05.000000', 'consum', 0.0228, 'lps'),
	(505655, 131, '2014-01-15 00:24:06.000000', 'consum', 0.0230, 'lps'),
	(505656, 131, '2014-01-15 00:24:07.000000', 'consum', 0.0213, 'lps'),
	(505657, 131, '2014-01-15 00:24:08.000000', 'consum', 0.0231, 'lps'),
	(505658, 131, '2014-01-15 00:24:09.000000', 'consum', 0.0218, 'lps'),
	(505659, 131, '2014-01-15 00:24:10.000000', 'consum', 0.0230, 'lps'),
	(505660, 131, '2014-01-15 00:24:11.000000', 'consum', 0.0223, 'lps'),
	(505661, 131, '2014-01-15 00:24:12.000000', 'consum', 0.0215, 'lps'),
	(505662, 131, '2014-01-15 00:24:13.000000', 'consum', 0.0219, 'lps'),
	(505663, 131, '2014-01-15 00:24:14.000000', 'consum', 0.0218, 'lps'),
	(505664, 131, '2014-01-15 00:24:15.000000', 'consum', 0.0223, 'lps'),
	(505665, 131, '2014-01-15 00:24:16.000000', 'consum', 0.0229, 'lps'),
	(505666, 131, '2014-01-15 00:24:17.000000', 'consum', 0.0223, 'lps'),
	(505667, 131, '2014-01-15 00:24:18.000000', 'consum', 0.0217, 'lps'),
	(505668, 131, '2014-01-15 00:24:19.000000', 'consum', 0.0228, 'lps'),
	(505669, 131, '2014-01-15 00:24:20.000000', 'consum', 0.0216, 'lps'),
	(505670, 131, '2014-01-15 00:24:21.000000', 'consum', 0.0229, 'lps'),
	(505671, 131, '2014-01-15 00:24:22.000000', 'consum', 0.0223, 'lps'),
	(505672, 131, '2014-01-15 00:24:23.000000', 'consum', 0.0218, 'lps'),
	(505673, 131, '2014-01-15 00:24:24.000000', 'consum', 0.0211, 'lps'),
	(505674, 131, '2014-01-15 00:24:25.000000', 'consum', 0.0212, 'lps'),
	(505675, 131, '2014-01-15 00:24:26.000000', 'consum', 0.0219, 'lps'),
	(505676, 131, '2014-01-15 00:24:27.000000', 'consum', 0.0229, 'lps'),
	(505677, 131, '2014-01-15 00:24:28.000000', 'consum', 0.0210, 'lps'),
	(505678, 131, '2014-01-15 00:24:29.000000', 'consum', 0.0220, 'lps'),
	(505679, 131, '2014-01-15 00:24:30.000000', 'consum', 0.0218, 'lps'),
	(505680, 131, '2014-01-15 00:24:31.000000', 'consum', 0.0222, 'lps'),
	(505681, 131, '2014-01-15 00:24:32.000000', 'consum', 0.0221, 'lps'),
	(505682, 131, '2014-01-15 00:24:33.000000', 'consum', 0.0211, 'lps'),
	(505683, 131, '2014-01-15 00:24:34.000000', 'consum', 0.0225, 'lps'),
	(505684, 131, '2014-01-15 00:24:35.000000', 'consum', 0.0215, 'lps'),
	(505685, 131, '2014-01-15 00:24:36.000000', 'consum', 0.0212, 'lps'),
	(505686, 131, '2014-01-15 00:24:37.000000', 'consum', 0.0229, 'lps'),
	(505687, 131, '2014-01-15 00:24:38.000000', 'consum', 0.0212, 'lps'),
	(505688, 131, '2014-01-15 00:24:39.000000', 'consum', 0.0229, 'lps'),
	(505689, 131, '2014-01-15 00:24:40.000000', 'consum', 0.0210, 'lps'),
	(505690, 131, '2014-01-15 00:24:41.000000', 'consum', 0.0221, 'lps'),
	(505691, 131, '2014-01-15 00:24:42.000000', 'consum', 0.0223, 'lps'),
	(505692, 131, '2014-01-15 00:24:43.000000', 'consum', 0.0218, 'lps'),
	(505693, 131, '2014-01-15 00:24:44.000000', 'consum', 0.0211, 'lps'),
	(505694, 131, '2014-01-15 00:24:45.000000', 'consum', 0.0216, 'lps'),
	(505695, 131, '2014-01-15 00:24:46.000000', 'consum', 0.0216, 'lps'),
	(505696, 131, '2014-01-15 00:24:47.000000', 'consum', 0.0222, 'lps'),
	(505697, 131, '2014-01-15 00:24:48.000000', 'consum', 0.0229, 'lps'),
	(505698, 131, '2014-01-15 00:24:49.000000', 'consum', 0.0227, 'lps'),
	(505699, 131, '2014-01-15 00:24:50.000000', 'consum', 0.0214, 'lps'),
	(505700, 131, '2014-01-15 00:24:51.000000', 'consum', 0.0227, 'lps'),
	(505701, 131, '2014-01-15 00:24:52.000000', 'consum', 0.0214, 'lps'),
	(505702, 131, '2014-01-15 00:24:53.000000', 'consum', 0.0226, 'lps'),
	(505703, 131, '2014-01-15 00:24:54.000000', 'consum', 0.0214, 'lps'),
	(505704, 131, '2014-01-15 00:24:55.000000', 'consum', 0.0224, 'lps'),
	(505705, 131, '2014-01-15 00:24:56.000000', 'consum', 0.0227, 'lps'),
	(505706, 131, '2014-01-15 00:24:57.000000', 'consum', 0.0230, 'lps'),
	(505707, 131, '2014-01-15 00:24:58.000000', 'consum', 0.0215, 'lps'),
	(505708, 131, '2014-01-15 00:24:59.000000', 'consum', 0.0221, 'lps'),
	(505709, 131, '2014-01-15 00:25:00.000000', 'consum', 0.0230, 'lps'),
	(505710, 131, '2014-01-15 00:25:01.000000', 'consum', 0.0230, 'lps'),
	(505711, 131, '2014-01-15 00:25:02.000000', 'consum', 0.0231, 'lps'),
	(505712, 131, '2014-01-15 00:25:03.000000', 'consum', 0.0212, 'lps'),
	(505713, 131, '2014-01-15 00:25:04.000000', 'consum', 0.0222, 'lps'),
	(505714, 131, '2014-01-15 00:25:05.000000', 'consum', 0.0220, 'lps'),
	(505715, 131, '2014-01-15 00:25:06.000000', 'consum', 0.0224, 'lps'),
	(505716, 131, '2014-01-15 00:25:07.000000', 'consum', 0.0231, 'lps'),
	(505717, 131, '2014-01-15 00:25:08.000000', 'consum', 0.0227, 'lps'),
	(505718, 131, '2014-01-15 00:25:09.000000', 'consum', 0.0211, 'lps'),
	(505719, 131, '2014-01-15 00:25:10.000000', 'consum', 0.0210, 'lps'),
	(505720, 131, '2014-01-15 00:25:11.000000', 'consum', 0.0229, 'lps'),
	(505721, 131, '2014-01-15 00:25:12.000000', 'consum', 0.0216, 'lps'),
	(505722, 131, '2014-01-15 00:25:13.000000', 'consum', 0.0230, 'lps'),
	(505723, 131, '2014-01-15 00:25:14.000000', 'consum', 0.0225, 'lps'),
	(505724, 131, '2014-01-15 00:25:15.000000', 'consum', 0.0224, 'lps'),
	(505725, 131, '2014-01-15 00:25:16.000000', 'consum', 0.0214, 'lps'),
	(505726, 131, '2014-01-15 00:25:17.000000', 'consum', 0.0213, 'lps'),
	(505727, 131, '2014-01-15 00:25:18.000000', 'consum', 0.0212, 'lps'),
	(505728, 131, '2014-01-15 00:25:19.000000', 'consum', 0.0213, 'lps'),
	(505729, 131, '2014-01-15 00:25:20.000000', 'consum', 0.0220, 'lps'),
	(505730, 131, '2014-01-15 00:25:21.000000', 'consum', 0.0229, 'lps'),
	(505731, 131, '2014-01-15 00:25:22.000000', 'consum', 0.0229, 'lps'),
	(505732, 131, '2014-01-15 00:25:23.000000', 'consum', 0.0229, 'lps'),
	(505733, 131, '2014-01-15 00:25:24.000000', 'consum', 0.0227, 'lps'),
	(505734, 131, '2014-01-15 00:25:25.000000', 'consum', 0.0215, 'lps'),
	(505735, 131, '2014-01-15 00:25:26.000000', 'consum', 0.0231, 'lps'),
	(505736, 131, '2014-01-15 00:25:27.000000', 'consum', 0.0231, 'lps'),
	(505737, 131, '2014-01-15 00:25:28.000000', 'consum', 0.0211, 'lps'),
	(505738, 131, '2014-01-15 00:25:29.000000', 'consum', 0.0219, 'lps'),
	(505739, 131, '2014-01-15 00:25:30.000000', 'consum', 0.0210, 'lps'),
	(505740, 131, '2014-01-15 00:25:31.000000', 'consum', 0.0225, 'lps'),
	(505741, 131, '2014-01-15 00:25:32.000000', 'consum', 0.0219, 'lps'),
	(505742, 131, '2014-01-15 00:25:33.000000', 'consum', 0.0210, 'lps'),
	(505743, 131, '2014-01-15 00:25:34.000000', 'consum', 0.0227, 'lps'),
	(505744, 131, '2014-01-15 00:25:35.000000', 'consum', 0.0230, 'lps'),
	(505745, 131, '2014-01-15 00:25:36.000000', 'consum', 0.0215, 'lps'),
	(505746, 131, '2014-01-15 00:25:37.000000', 'consum', 0.0219, 'lps'),
	(505747, 131, '2014-01-15 00:25:38.000000', 'consum', 0.0220, 'lps'),
	(505748, 131, '2014-01-15 00:25:39.000000', 'consum', 0.0210, 'lps'),
	(505749, 131, '2014-01-15 00:25:40.000000', 'consum', 0.0226, 'lps'),
	(505750, 131, '2014-01-15 00:25:41.000000', 'consum', 0.0226, 'lps'),
	(505751, 131, '2014-01-15 00:25:42.000000', 'consum', 0.0218, 'lps'),
	(505752, 131, '2014-01-15 00:25:43.000000', 'consum', 0.0224, 'lps'),
	(505753, 131, '2014-01-15 00:25:44.000000', 'consum', 0.0214, 'lps'),
	(505754, 131, '2014-01-15 00:25:45.000000', 'consum', 0.0211, 'lps'),
	(505755, 131, '2014-01-15 00:25:46.000000', 'consum', 0.0224, 'lps'),
	(505756, 131, '2014-01-15 00:25:47.000000', 'consum', 0.0211, 'lps'),
	(505757, 131, '2014-01-15 00:25:48.000000', 'consum', 0.0220, 'lps'),
	(505758, 131, '2014-01-15 00:25:49.000000', 'consum', 0.0212, 'lps'),
	(505759, 131, '2014-01-15 00:25:50.000000', 'consum', 0.0215, 'lps'),
	(505760, 131, '2014-01-15 00:25:51.000000', 'consum', 0.0226, 'lps'),
	(505761, 131, '2014-01-15 00:25:52.000000', 'consum', 0.0211, 'lps'),
	(505762, 131, '2014-01-15 00:25:53.000000', 'consum', 0.0210, 'lps'),
	(505763, 131, '2014-01-15 00:25:54.000000', 'consum', 0.0210, 'lps'),
	(505764, 131, '2014-01-15 00:25:55.000000', 'consum', 0.0230, 'lps'),
	(505765, 131, '2014-01-15 00:25:56.000000', 'consum', 0.0223, 'lps'),
	(505766, 131, '2014-01-15 00:25:57.000000', 'consum', 0.0216, 'lps'),
	(505767, 131, '2014-01-15 00:25:58.000000', 'consum', 0.0222, 'lps'),
	(505768, 131, '2014-01-15 00:25:59.000000', 'consum', 0.0230, 'lps'),
	(505769, 131, '2014-01-15 00:26:00.000000', 'consum', 0.0230, 'lps'),
	(505770, 131, '2014-01-15 00:26:01.000000', 'consum', 0.0231, 'lps'),
	(505771, 131, '2014-01-15 00:26:02.000000', 'consum', 0.0231, 'lps'),
	(505772, 131, '2014-01-15 00:26:03.000000', 'consum', 0.0230, 'lps'),
	(505773, 131, '2014-01-15 00:26:04.000000', 'consum', 0.0226, 'lps'),
	(505774, 131, '2014-01-15 00:26:05.000000', 'consum', 0.0210, 'lps'),
	(505775, 131, '2014-01-15 00:26:06.000000', 'consum', 0.0230, 'lps'),
	(505776, 131, '2014-01-15 00:26:07.000000', 'consum', 0.0220, 'lps'),
	(505777, 131, '2014-01-15 00:26:08.000000', 'consum', 0.0223, 'lps'),
	(505778, 131, '2014-01-15 00:26:09.000000', 'consum', 0.0223, 'lps'),
	(505779, 131, '2014-01-15 00:26:10.000000', 'consum', 0.0216, 'lps'),
	(505780, 131, '2014-01-15 00:26:11.000000', 'consum', 0.0221, 'lps'),
	(505781, 131, '2014-01-15 00:26:12.000000', 'consum', 0.0228, 'lps'),
	(505782, 131, '2014-01-15 00:26:13.000000', 'consum', 0.0222, 'lps'),
	(505783, 131, '2014-01-15 00:26:14.000000', 'consum', 0.0217, 'lps'),
	(505784, 131, '2014-01-15 00:26:15.000000', 'consum', 0.0231, 'lps'),
	(505785, 131, '2014-01-15 00:26:16.000000', 'consum', 0.0228, 'lps'),
	(505786, 131, '2014-01-15 00:26:17.000000', 'consum', 0.0216, 'lps'),
	(505787, 131, '2014-01-15 00:26:18.000000', 'consum', 0.0211, 'lps'),
	(505788, 131, '2014-01-15 00:26:19.000000', 'consum', 0.0216, 'lps'),
	(505789, 131, '2014-01-15 00:26:20.000000', 'consum', 0.0218, 'lps'),
	(505790, 131, '2014-01-15 00:26:21.000000', 'consum', 0.0230, 'lps'),
	(505791, 131, '2014-01-15 00:26:22.000000', 'consum', 0.0221, 'lps'),
	(505792, 131, '2014-01-15 00:26:23.000000', 'consum', 0.0227, 'lps'),
	(505793, 131, '2014-01-15 00:26:24.000000', 'consum', 0.0220, 'lps'),
	(505794, 131, '2014-01-15 00:26:25.000000', 'consum', 0.0211, 'lps'),
	(505795, 131, '2014-01-15 00:26:26.000000', 'consum', 0.0226, 'lps'),
	(505796, 131, '2014-01-15 00:26:27.000000', 'consum', 0.0223, 'lps'),
	(505797, 131, '2014-01-15 00:26:28.000000', 'consum', 0.0229, 'lps'),
	(505798, 131, '2014-01-15 00:26:29.000000', 'consum', 0.0222, 'lps'),
	(505799, 131, '2014-01-15 00:26:30.000000', 'consum', 0.0214, 'lps'),
	(505800, 131, '2014-01-15 00:26:31.000000', 'consum', 0.0218, 'lps'),
	(505801, 131, '2014-01-15 00:26:32.000000', 'consum', 0.0213, 'lps'),
	(505802, 131, '2014-01-15 00:26:33.000000', 'consum', 0.0226, 'lps'),
	(505803, 131, '2014-01-15 00:26:34.000000', 'consum', 0.0213, 'lps'),
	(505804, 131, '2014-01-15 00:26:35.000000', 'consum', 0.0223, 'lps'),
	(505805, 131, '2014-01-15 00:26:36.000000', 'consum', 0.0223, 'lps'),
	(505806, 131, '2014-01-15 00:26:37.000000', 'consum', 0.0214, 'lps'),
	(505807, 131, '2014-01-15 00:26:38.000000', 'consum', 0.0213, 'lps'),
	(505808, 131, '2014-01-15 00:26:39.000000', 'consum', 0.0216, 'lps'),
	(505809, 131, '2014-01-15 00:26:40.000000', 'consum', 0.0228, 'lps'),
	(505810, 131, '2014-01-15 00:26:41.000000', 'consum', 0.0218, 'lps'),
	(505811, 131, '2014-01-15 00:26:42.000000', 'consum', 0.0217, 'lps'),
	(505812, 131, '2014-01-15 00:26:43.000000', 'consum', 0.0221, 'lps'),
	(505813, 131, '2014-01-15 00:26:44.000000', 'consum', 0.0223, 'lps'),
	(505814, 131, '2014-01-15 00:26:45.000000', 'consum', 0.0219, 'lps'),
	(505815, 131, '2014-01-15 00:26:46.000000', 'consum', 0.0217, 'lps'),
	(505816, 131, '2014-01-15 00:26:47.000000', 'consum', 0.0219, 'lps'),
	(505817, 131, '2014-01-15 00:26:48.000000', 'consum', 0.0211, 'lps'),
	(505818, 131, '2014-01-15 00:26:49.000000', 'consum', 0.0210, 'lps'),
	(505819, 131, '2014-01-15 00:26:50.000000', 'consum', 0.0230, 'lps'),
	(505820, 131, '2014-01-15 00:26:51.000000', 'consum', 0.0221, 'lps'),
	(505821, 131, '2014-01-15 00:26:52.000000', 'consum', 0.0229, 'lps'),
	(505822, 131, '2014-01-15 00:26:53.000000', 'consum', 0.0229, 'lps'),
	(505823, 131, '2014-01-15 00:26:54.000000', 'consum', 0.0226, 'lps'),
	(505824, 131, '2014-01-15 00:26:55.000000', 'consum', 0.0212, 'lps'),
	(505825, 131, '2014-01-15 00:26:56.000000', 'consum', 0.0217, 'lps'),
	(505826, 131, '2014-01-15 00:26:57.000000', 'consum', 0.0216, 'lps'),
	(505827, 131, '2014-01-15 00:26:58.000000', 'consum', 0.0218, 'lps'),
	(505828, 131, '2014-01-15 00:26:59.000000', 'consum', 0.0213, 'lps'),
	(505829, 131, '2014-01-15 00:27:00.000000', 'consum', 0.0224, 'lps'),
	(505830, 131, '2014-01-15 00:27:01.000000', 'consum', 0.0226, 'lps'),
	(505831, 131, '2014-01-15 00:27:02.000000', 'consum', 0.0226, 'lps'),
	(505832, 131, '2014-01-15 00:27:03.000000', 'consum', 0.0223, 'lps'),
	(505833, 131, '2014-01-15 00:27:04.000000', 'consum', 0.0227, 'lps'),
	(505834, 131, '2014-01-15 00:27:05.000000', 'consum', 0.0213, 'lps'),
	(505835, 131, '2014-01-15 00:27:06.000000', 'consum', 0.0219, 'lps'),
	(505836, 131, '2014-01-15 00:27:07.000000', 'consum', 0.0223, 'lps'),
	(505837, 131, '2014-01-15 00:27:08.000000', 'consum', 0.0225, 'lps'),
	(505838, 131, '2014-01-15 00:27:09.000000', 'consum', 0.0227, 'lps'),
	(505839, 131, '2014-01-15 00:27:10.000000', 'consum', 0.0227, 'lps'),
	(505840, 131, '2014-01-15 00:27:11.000000', 'consum', 0.0224, 'lps'),
	(505841, 131, '2014-01-15 00:27:12.000000', 'consum', 0.0227, 'lps'),
	(505842, 131, '2014-01-15 00:27:13.000000', 'consum', 0.0212, 'lps'),
	(505843, 131, '2014-01-15 00:27:14.000000', 'consum', 0.0214, 'lps'),
	(505844, 131, '2014-01-15 00:27:15.000000', 'consum', 0.0225, 'lps'),
	(505845, 131, '2014-01-15 00:27:16.000000', 'consum', 0.0229, 'lps'),
	(505846, 131, '2014-01-15 00:27:17.000000', 'consum', 0.0215, 'lps'),
	(505847, 131, '2014-01-15 00:27:18.000000', 'consum', 0.0223, 'lps'),
	(505848, 131, '2014-01-15 00:27:19.000000', 'consum', 0.0215, 'lps'),
	(505849, 131, '2014-01-15 00:27:20.000000', 'consum', 0.0221, 'lps'),
	(505850, 131, '2014-01-15 00:27:21.000000', 'consum', 0.0228, 'lps'),
	(505851, 131, '2014-01-15 00:27:22.000000', 'consum', 0.0223, 'lps'),
	(505852, 131, '2014-01-15 00:27:23.000000', 'consum', 0.0222, 'lps'),
	(505853, 131, '2014-01-15 00:27:24.000000', 'consum', 0.0210, 'lps'),
	(505854, 131, '2014-01-15 00:27:25.000000', 'consum', 0.0216, 'lps'),
	(505855, 131, '2014-01-15 00:27:26.000000', 'consum', 0.0219, 'lps'),
	(505856, 131, '2014-01-15 00:27:27.000000', 'consum', 0.0217, 'lps'),
	(505857, 131, '2014-01-15 00:27:28.000000', 'consum', 0.0220, 'lps'),
	(505858, 131, '2014-01-15 00:27:29.000000', 'consum', 0.0216, 'lps'),
	(505859, 131, '2014-01-15 00:27:30.000000', 'consum', 0.0211, 'lps'),
	(505860, 131, '2014-01-15 00:27:31.000000', 'consum', 0.0218, 'lps'),
	(505861, 131, '2014-01-15 00:27:32.000000', 'consum', 0.0226, 'lps'),
	(505862, 131, '2014-01-15 00:27:33.000000', 'consum', 0.0224, 'lps'),
	(505863, 131, '2014-01-15 00:27:34.000000', 'consum', 0.0230, 'lps'),
	(505864, 131, '2014-01-15 00:27:35.000000', 'consum', 0.0225, 'lps'),
	(505865, 131, '2014-01-15 00:27:36.000000', 'consum', 0.0225, 'lps'),
	(505866, 131, '2014-01-15 00:27:37.000000', 'consum', 0.0218, 'lps'),
	(505867, 131, '2014-01-15 00:27:38.000000', 'consum', 0.0228, 'lps'),
	(505868, 131, '2014-01-15 00:27:39.000000', 'consum', 0.0213, 'lps'),
	(505869, 131, '2014-01-15 00:27:40.000000', 'consum', 0.0212, 'lps'),
	(505870, 131, '2014-01-15 00:27:41.000000', 'consum', 0.0213, 'lps'),
	(505871, 131, '2014-01-15 00:27:42.000000', 'consum', 0.0220, 'lps'),
	(505872, 131, '2014-01-15 00:27:43.000000', 'consum', 0.0227, 'lps'),
	(505873, 131, '2014-01-15 00:27:44.000000', 'consum', 0.0224, 'lps'),
	(505874, 131, '2014-01-15 00:27:45.000000', 'consum', 0.0229, 'lps'),
	(505875, 131, '2014-01-15 00:27:46.000000', 'consum', 0.0221, 'lps'),
	(505876, 131, '2014-01-15 00:27:47.000000', 'consum', 0.0231, 'lps'),
	(505877, 131, '2014-01-15 00:27:48.000000', 'consum', 0.0215, 'lps'),
	(505878, 131, '2014-01-15 00:27:49.000000', 'consum', 0.0218, 'lps'),
	(505879, 131, '2014-01-15 00:27:50.000000', 'consum', 0.0213, 'lps'),
	(505880, 131, '2014-01-15 00:27:51.000000', 'consum', 0.0221, 'lps'),
	(505881, 131, '2014-01-15 00:27:52.000000', 'consum', 0.0215, 'lps'),
	(505882, 131, '2014-01-15 00:27:53.000000', 'consum', 0.0222, 'lps'),
	(505883, 131, '2014-01-15 00:27:54.000000', 'consum', 0.0215, 'lps'),
	(505884, 131, '2014-01-15 00:27:55.000000', 'consum', 0.0220, 'lps'),
	(505885, 131, '2014-01-15 00:27:56.000000', 'consum', 0.0222, 'lps'),
	(505886, 131, '2014-01-15 00:27:57.000000', 'consum', 0.0220, 'lps'),
	(505887, 131, '2014-01-15 00:27:58.000000', 'consum', 0.0224, 'lps'),
	(505888, 131, '2014-01-15 00:27:59.000000', 'consum', 0.0229, 'lps'),
	(505889, 131, '2014-01-15 00:28:00.000000', 'consum', 0.0217, 'lps'),
	(505890, 131, '2014-01-15 00:28:01.000000', 'consum', 0.0213, 'lps'),
	(505891, 131, '2014-01-15 00:28:02.000000', 'consum', 0.0228, 'lps'),
	(505892, 131, '2014-01-15 00:28:03.000000', 'consum', 0.0223, 'lps'),
	(505893, 131, '2014-01-15 00:28:04.000000', 'consum', 0.0222, 'lps'),
	(505894, 131, '2014-01-15 00:28:05.000000', 'consum', 0.0231, 'lps'),
	(505895, 131, '2014-01-15 00:28:06.000000', 'consum', 0.0214, 'lps'),
	(505896, 131, '2014-01-15 00:28:07.000000', 'consum', 0.0213, 'lps'),
	(505897, 131, '2014-01-15 00:28:08.000000', 'consum', 0.0212, 'lps'),
	(505898, 131, '2014-01-15 00:28:09.000000', 'consum', 0.0211, 'lps'),
	(505899, 131, '2014-01-15 00:28:10.000000', 'consum', 0.0210, 'lps'),
	(505900, 131, '2014-01-15 00:28:11.000000', 'consum', 0.0228, 'lps'),
	(505901, 131, '2014-01-15 00:28:12.000000', 'consum', 0.0215, 'lps'),
	(505902, 131, '2014-01-15 00:28:13.000000', 'consum', 0.0223, 'lps'),
	(505903, 131, '2014-01-15 00:28:14.000000', 'consum', 0.0219, 'lps'),
	(505904, 131, '2014-01-15 00:28:15.000000', 'consum', 0.0216, 'lps'),
	(505905, 131, '2014-01-15 00:28:16.000000', 'consum', 0.0211, 'lps'),
	(505906, 131, '2014-01-15 00:28:17.000000', 'consum', 0.0221, 'lps'),
	(505907, 131, '2014-01-15 00:28:18.000000', 'consum', 0.0220, 'lps'),
	(505908, 131, '2014-01-15 00:28:19.000000', 'consum', 0.0225, 'lps'),
	(505909, 131, '2014-01-15 00:28:20.000000', 'consum', 0.0213, 'lps'),
	(505910, 131, '2014-01-15 00:28:21.000000', 'consum', 0.0223, 'lps'),
	(505911, 131, '2014-01-15 00:28:22.000000', 'consum', 0.0223, 'lps'),
	(505912, 131, '2014-01-15 00:28:23.000000', 'consum', 0.0215, 'lps'),
	(505913, 131, '2014-01-15 00:28:24.000000', 'consum', 0.0218, 'lps'),
	(505914, 131, '2014-01-15 00:28:25.000000', 'consum', 0.0215, 'lps'),
	(505915, 131, '2014-01-15 00:28:26.000000', 'consum', 0.0211, 'lps'),
	(505916, 131, '2014-01-15 00:28:27.000000', 'consum', 0.0220, 'lps'),
	(505917, 131, '2014-01-15 00:28:28.000000', 'consum', 0.0215, 'lps'),
	(505918, 131, '2014-01-15 00:28:29.000000', 'consum', 0.0230, 'lps'),
	(505919, 131, '2014-01-15 00:28:30.000000', 'consum', 0.0226, 'lps'),
	(505920, 131, '2014-01-15 00:28:31.000000', 'consum', 0.0211, 'lps'),
	(505921, 131, '2014-01-15 00:28:32.000000', 'consum', 0.0211, 'lps'),
	(505922, 131, '2014-01-15 00:28:33.000000', 'consum', 0.0210, 'lps'),
	(505923, 131, '2014-01-15 00:28:34.000000', 'consum', 0.0211, 'lps'),
	(505924, 131, '2014-01-15 00:28:35.000000', 'consum', 0.0215, 'lps'),
	(505925, 131, '2014-01-15 00:28:36.000000', 'consum', 0.0231, 'lps'),
	(505926, 131, '2014-01-15 00:28:37.000000', 'consum', 0.0214, 'lps'),
	(505927, 131, '2014-01-15 00:28:38.000000', 'consum', 0.0212, 'lps'),
	(505928, 131, '2014-01-15 00:28:39.000000', 'consum', 0.0230, 'lps'),
	(505929, 131, '2014-01-15 00:28:40.000000', 'consum', 0.0217, 'lps'),
	(505930, 131, '2014-01-15 00:28:41.000000', 'consum', 0.0231, 'lps'),
	(505931, 131, '2014-01-15 00:28:42.000000', 'consum', 0.0225, 'lps'),
	(505932, 131, '2014-01-15 00:28:43.000000', 'consum', 0.0226, 'lps'),
	(505933, 131, '2014-01-15 00:28:44.000000', 'consum', 0.0222, 'lps'),
	(505934, 131, '2014-01-15 00:28:45.000000', 'consum', 0.0221, 'lps'),
	(505935, 131, '2014-01-15 00:28:46.000000', 'consum', 0.0210, 'lps'),
	(505936, 131, '2014-01-15 00:28:47.000000', 'consum', 0.0219, 'lps'),
	(505937, 131, '2014-01-15 00:28:48.000000', 'consum', 0.0214, 'lps'),
	(505938, 131, '2014-01-15 00:28:49.000000', 'consum', 0.0226, 'lps'),
	(505939, 131, '2014-01-15 00:28:50.000000', 'consum', 0.0211, 'lps'),
	(505940, 131, '2014-01-15 00:28:51.000000', 'consum', 0.0210, 'lps'),
	(505941, 131, '2014-01-15 00:28:52.000000', 'consum', 0.0210, 'lps'),
	(505942, 131, '2014-01-15 00:28:53.000000', 'consum', 0.0230, 'lps'),
	(505943, 131, '2014-01-15 00:28:54.000000', 'consum', 0.0225, 'lps'),
	(505944, 131, '2014-01-15 00:28:55.000000', 'consum', 0.0224, 'lps'),
	(505945, 131, '2014-01-15 00:28:56.000000', 'consum', 0.0214, 'lps'),
	(505946, 131, '2014-01-15 00:28:57.000000', 'consum', 0.0211, 'lps'),
	(505947, 131, '2014-01-15 00:28:58.000000', 'consum', 0.0224, 'lps'),
	(505948, 131, '2014-01-15 00:28:59.000000', 'consum', 0.0214, 'lps'),
	(505949, 131, '2014-01-15 00:29:00.000000', 'consum', 0.0230, 'lps'),
	(505950, 131, '2014-01-15 00:29:01.000000', 'consum', 0.0212, 'lps'),
	(505951, 131, '2014-01-15 00:29:02.000000', 'consum', 0.0228, 'lps'),
	(505952, 131, '2014-01-15 00:29:03.000000', 'consum', 0.0226, 'lps'),
	(505953, 131, '2014-01-15 00:29:04.000000', 'consum', 0.0217, 'lps'),
	(505954, 131, '2014-01-15 00:29:05.000000', 'consum', 0.0219, 'lps'),
	(505955, 131, '2014-01-15 00:29:06.000000', 'consum', 0.0211, 'lps'),
	(505956, 131, '2014-01-15 00:29:07.000000', 'consum', 0.0231, 'lps'),
	(505957, 131, '2014-01-15 00:29:08.000000', 'consum', 0.0227, 'lps'),
	(505958, 131, '2014-01-15 00:29:09.000000', 'consum', 0.0211, 'lps'),
	(505959, 131, '2014-01-15 00:29:10.000000', 'consum', 0.0229, 'lps'),
	(505960, 131, '2014-01-15 00:29:11.000000', 'consum', 0.0215, 'lps'),
	(505961, 131, '2014-01-15 00:29:12.000000', 'consum', 0.0224, 'lps'),
	(505962, 131, '2014-01-15 00:29:13.000000', 'consum', 0.0221, 'lps'),
	(505963, 131, '2014-01-15 00:29:14.000000', 'consum', 0.0222, 'lps'),
	(505964, 131, '2014-01-15 00:29:15.000000', 'consum', 0.0216, 'lps'),
	(505965, 131, '2014-01-15 00:29:16.000000', 'consum', 0.0228, 'lps'),
	(505966, 131, '2014-01-15 00:29:17.000000', 'consum', 0.0218, 'lps'),
	(505967, 131, '2014-01-15 00:29:18.000000', 'consum', 0.0216, 'lps'),
	(505968, 131, '2014-01-15 00:29:19.000000', 'consum', 0.0216, 'lps'),
	(505969, 131, '2014-01-15 00:29:20.000000', 'consum', 0.0222, 'lps'),
	(505970, 131, '2014-01-15 00:29:21.000000', 'consum', 0.0229, 'lps'),
	(505971, 131, '2014-01-15 00:29:22.000000', 'consum', 0.0229, 'lps'),
	(505972, 131, '2014-01-15 00:29:23.000000', 'consum', 0.0225, 'lps'),
	(505973, 131, '2014-01-15 00:29:24.000000', 'consum', 0.0231, 'lps'),
	(505974, 131, '2014-01-15 00:29:25.000000', 'consum', 0.0223, 'lps'),
	(505975, 131, '2014-01-15 00:29:26.000000', 'consum', 0.0215, 'lps'),
	(505976, 131, '2014-01-15 00:29:27.000000', 'consum', 0.0216, 'lps'),
	(505977, 131, '2014-01-15 00:29:28.000000', 'consum', 0.0225, 'lps'),
	(505978, 131, '2014-01-15 00:29:29.000000', 'consum', 0.0227, 'lps'),
	(505979, 131, '2014-01-15 00:29:30.000000', 'consum', 0.0225, 'lps'),
	(505980, 131, '2014-01-15 00:29:31.000000', 'consum', 0.0215, 'lps'),
	(505981, 131, '2014-01-15 00:29:32.000000', 'consum', 0.0210, 'lps'),
	(505982, 131, '2014-01-15 00:29:33.000000', 'consum', 0.0219, 'lps'),
	(505983, 131, '2014-01-15 00:29:34.000000', 'consum', 0.0210, 'lps'),
	(505984, 131, '2014-01-15 00:29:35.000000', 'consum', 0.0228, 'lps'),
	(505985, 131, '2014-01-15 00:29:36.000000', 'consum', 0.0213, 'lps'),
	(505986, 131, '2014-01-15 00:29:37.000000', 'consum', 0.0215, 'lps'),
	(505987, 131, '2014-01-15 00:29:38.000000', 'consum', 0.0227, 'lps'),
	(505988, 131, '2014-01-15 00:29:39.000000', 'consum', 0.0215, 'lps'),
	(505989, 131, '2014-01-15 00:29:40.000000', 'consum', 0.0229, 'lps'),
	(505990, 131, '2014-01-15 00:29:41.000000', 'consum', 0.0222, 'lps'),
	(505991, 131, '2014-01-15 00:29:42.000000', 'consum', 0.0216, 'lps'),
	(505992, 131, '2014-01-15 00:29:43.000000', 'consum', 0.0227, 'lps'),
	(505993, 131, '2014-01-15 00:29:44.000000', 'consum', 0.0211, 'lps'),
	(505994, 131, '2014-01-15 00:29:45.000000', 'consum', 0.0230, 'lps'),
	(505995, 131, '2014-01-15 00:29:46.000000', 'consum', 0.0221, 'lps'),
	(505996, 131, '2014-01-15 00:29:47.000000', 'consum', 0.0226, 'lps'),
	(505997, 131, '2014-01-15 00:29:48.000000', 'consum', 0.0213, 'lps'),
	(505998, 131, '2014-01-15 00:29:49.000000', 'consum', 0.0220, 'lps'),
	(505999, 131, '2014-01-15 00:29:50.000000', 'consum', 0.0210, 'lps'),
	(506000, 131, '2014-01-15 00:29:51.000000', 'consum', 0.0224, 'lps'),
	(506001, 131, '2014-01-15 00:29:52.000000', 'consum', 0.0214, 'lps'),
	(506002, 131, '2014-01-15 00:29:53.000000', 'consum', 0.0210, 'lps'),
	(506003, 131, '2014-01-15 00:29:54.000000', 'consum', 0.0219, 'lps'),
	(506004, 131, '2014-01-15 00:29:55.000000', 'consum', 0.0213, 'lps'),
	(506005, 131, '2014-01-15 00:29:56.000000', 'consum', 0.0220, 'lps'),
	(506006, 131, '2014-01-15 00:29:57.000000', 'consum', 0.0231, 'lps'),
	(506007, 131, '2014-01-15 00:29:58.000000', 'consum', 0.0218, 'lps'),
	(506008, 131, '2014-01-15 00:29:59.000000', 'consum', 0.0231, 'lps'),
	(506009, 131, '2014-01-15 00:30:00.000000', 'consum', 0.0227, 'lps'),
	(506010, 131, '2014-01-15 00:30:01.000000', 'consum', 0.0231, 'lps'),
	(506011, 131, '2014-01-15 00:30:02.000000', 'consum', 0.0220, 'lps'),
	(506012, 131, '2014-01-15 00:30:03.000000', 'consum', 0.0222, 'lps'),
	(506013, 131, '2014-01-15 00:30:04.000000', 'consum', 0.0218, 'lps'),
	(506014, 131, '2014-01-15 00:30:05.000000', 'consum', 0.0213, 'lps'),
	(506015, 131, '2014-01-15 00:30:06.000000', 'consum', 0.0223, 'lps'),
	(506016, 131, '2014-01-15 00:30:07.000000', 'consum', 0.0223, 'lps'),
	(506017, 131, '2014-01-15 00:30:08.000000', 'consum', 0.0214, 'lps'),
	(506018, 131, '2014-01-15 00:30:09.000000', 'consum', 0.0215, 'lps'),
	(506019, 131, '2014-01-15 00:30:10.000000', 'consum', 0.0221, 'lps'),
	(506020, 131, '2014-01-15 00:30:11.000000', 'consum', 0.0231, 'lps'),
	(506021, 131, '2014-01-15 00:30:12.000000', 'consum', 0.0217, 'lps'),
	(506022, 131, '2014-01-15 00:30:13.000000', 'consum', 0.0228, 'lps'),
	(506023, 131, '2014-01-15 00:30:14.000000', 'consum', 0.0210, 'lps'),
	(506024, 131, '2014-01-15 00:30:15.000000', 'consum', 0.0226, 'lps'),
	(506025, 131, '2014-01-15 00:30:16.000000', 'consum', 0.0221, 'lps'),
	(506026, 131, '2014-01-15 00:30:17.000000', 'consum', 0.0219, 'lps'),
	(506027, 131, '2014-01-15 00:30:18.000000', 'consum', 0.0224, 'lps'),
	(506028, 131, '2014-01-15 00:30:19.000000', 'consum', 0.0228, 'lps'),
	(506029, 131, '2014-01-15 00:30:20.000000', 'consum', 0.0217, 'lps'),
	(506030, 131, '2014-01-15 00:30:21.000000', 'consum', 0.0215, 'lps'),
	(506031, 131, '2014-01-15 00:30:22.000000', 'consum', 0.0211, 'lps'),
	(506032, 131, '2014-01-15 00:30:23.000000', 'consum', 0.0224, 'lps'),
	(506033, 131, '2014-01-15 00:30:24.000000', 'consum', 0.0213, 'lps'),
	(506034, 131, '2014-01-15 00:30:25.000000', 'consum', 0.0226, 'lps'),
	(506035, 131, '2014-01-15 00:30:26.000000', 'consum', 0.0218, 'lps'),
	(506036, 131, '2014-01-15 00:30:27.000000', 'consum', 0.0221, 'lps'),
	(506037, 131, '2014-01-15 00:30:28.000000', 'consum', 0.0222, 'lps'),
	(506038, 131, '2014-01-15 00:30:29.000000', 'consum', 0.0216, 'lps'),
	(506039, 131, '2014-01-15 00:30:30.000000', 'consum', 0.0225, 'lps'),
	(506040, 131, '2014-01-15 00:30:31.000000', 'consum', 0.0222, 'lps'),
	(506041, 131, '2014-01-15 00:30:32.000000', 'consum', 0.0226, 'lps'),
	(506042, 131, '2014-01-15 00:30:33.000000', 'consum', 0.0211, 'lps'),
	(506043, 131, '2014-01-15 00:30:34.000000', 'consum', 0.0210, 'lps'),
	(506044, 131, '2014-01-15 00:30:35.000000', 'consum', 0.0231, 'lps'),
	(506045, 131, '2014-01-15 00:30:36.000000', 'consum', 0.0225, 'lps'),
	(506046, 131, '2014-01-15 00:30:37.000000', 'consum', 0.0225, 'lps'),
	(506047, 131, '2014-01-15 00:30:38.000000', 'consum', 0.0218, 'lps'),
	(506048, 131, '2014-01-15 00:30:39.000000', 'consum', 0.0229, 'lps'),
	(506049, 131, '2014-01-15 00:30:40.000000', 'consum', 0.0213, 'lps'),
	(506050, 131, '2014-01-15 00:30:41.000000', 'consum', 0.0214, 'lps'),
	(506051, 131, '2014-01-15 00:30:42.000000', 'consum', 0.0219, 'lps'),
	(506052, 131, '2014-01-15 00:30:43.000000', 'consum', 0.0225, 'lps'),
	(506053, 131, '2014-01-15 00:30:44.000000', 'consum', 0.0212, 'lps'),
	(506054, 131, '2014-01-15 00:30:45.000000', 'consum', 0.0220, 'lps'),
	(506055, 131, '2014-01-15 00:30:46.000000', 'consum', 0.0213, 'lps'),
	(506056, 131, '2014-01-15 00:30:47.000000', 'consum', 0.0215, 'lps'),
	(506057, 131, '2014-01-15 00:30:48.000000', 'consum', 0.0226, 'lps'),
	(506058, 131, '2014-01-15 00:30:49.000000', 'consum', 0.0231, 'lps'),
	(506059, 131, '2014-01-15 00:30:50.000000', 'consum', 0.0226, 'lps'),
	(506060, 131, '2014-01-15 00:30:51.000000', 'consum', 0.0227, 'lps'),
	(506061, 131, '2014-01-15 00:30:52.000000', 'consum', 0.0224, 'lps'),
	(506062, 131, '2014-01-15 00:30:53.000000', 'consum', 0.0231, 'lps'),
	(506063, 131, '2014-01-15 00:30:54.000000', 'consum', 0.0227, 'lps'),
	(506064, 131, '2014-01-15 00:30:55.000000', 'consum', 0.0213, 'lps'),
	(506065, 131, '2014-01-15 00:30:56.000000', 'consum', 0.0220, 'lps'),
	(506066, 131, '2014-01-15 00:30:57.000000', 'consum', 0.0227, 'lps'),
	(506067, 131, '2014-01-15 00:30:58.000000', 'consum', 0.0221, 'lps'),
	(506068, 131, '2014-01-15 00:30:59.000000', 'consum', 0.0216, 'lps'),
	(506069, 131, '2014-01-15 00:31:00.000000', 'consum', 0.0229, 'lps'),
	(506070, 131, '2014-01-15 00:31:01.000000', 'consum', 0.0222, 'lps'),
	(506071, 131, '2014-01-15 00:31:02.000000', 'consum', 0.0214, 'lps'),
	(506072, 131, '2014-01-15 00:31:03.000000', 'consum', 0.0217, 'lps'),
	(506073, 131, '2014-01-15 00:31:04.000000', 'consum', 0.0212, 'lps'),
	(506074, 131, '2014-01-15 00:31:05.000000', 'consum', 0.0220, 'lps'),
	(506075, 131, '2014-01-15 00:31:06.000000', 'consum', 0.0231, 'lps'),
	(506076, 131, '2014-01-15 00:31:07.000000', 'consum', 0.0220, 'lps'),
	(506077, 131, '2014-01-15 00:31:08.000000', 'consum', 0.0222, 'lps'),
	(506078, 131, '2014-01-15 00:31:09.000000', 'consum', 0.0217, 'lps'),
	(506079, 131, '2014-01-15 00:31:10.000000', 'consum', 0.0230, 'lps'),
	(506080, 131, '2014-01-15 00:31:11.000000', 'consum', 0.0224, 'lps'),
	(506081, 131, '2014-01-15 00:31:12.000000', 'consum', 0.0221, 'lps'),
	(506082, 131, '2014-01-15 00:31:13.000000', 'consum', 0.0225, 'lps'),
	(506083, 131, '2014-01-15 00:31:14.000000', 'consum', 0.0231, 'lps'),
	(506084, 131, '2014-01-15 00:31:15.000000', 'consum', 0.0226, 'lps'),
	(506085, 131, '2014-01-15 00:31:16.000000', 'consum', 0.0227, 'lps'),
	(506086, 131, '2014-01-15 00:31:17.000000', 'consum', 0.0226, 'lps'),
	(506087, 131, '2014-01-15 00:31:18.000000', 'consum', 0.0216, 'lps'),
	(506088, 131, '2014-01-15 00:31:19.000000', 'consum', 0.0216, 'lps'),
	(506089, 131, '2014-01-15 00:31:20.000000', 'consum', 0.0223, 'lps'),
	(506090, 131, '2014-01-15 00:31:21.000000', 'consum', 0.0214, 'lps'),
	(506091, 131, '2014-01-15 00:31:22.000000', 'consum', 0.0213, 'lps'),
	(506092, 131, '2014-01-15 00:31:23.000000', 'consum', 0.0214, 'lps'),
	(506093, 131, '2014-01-15 00:31:24.000000', 'consum', 0.0219, 'lps'),
	(506094, 131, '2014-01-15 00:31:25.000000', 'consum', 0.0223, 'lps'),
	(506095, 131, '2014-01-15 00:31:26.000000', 'consum', 0.0224, 'lps'),
	(506096, 131, '2014-01-15 00:31:27.000000', 'consum', 0.0223, 'lps'),
	(506097, 131, '2014-01-15 00:31:28.000000', 'consum', 0.0211, 'lps'),
	(506098, 131, '2014-01-15 00:31:29.000000', 'consum', 0.0222, 'lps'),
	(506099, 131, '2014-01-15 00:31:30.000000', 'consum', 0.0222, 'lps'),
	(506100, 131, '2014-01-15 00:31:31.000000', 'consum', 0.0211, 'lps'),
	(506101, 131, '2014-01-15 00:31:32.000000', 'consum', 0.0227, 'lps'),
	(506102, 131, '2014-01-15 00:31:33.000000', 'consum', 0.0224, 'lps'),
	(506103, 131, '2014-01-15 00:31:34.000000', 'consum', 0.0229, 'lps'),
	(506104, 131, '2014-01-15 00:31:35.000000', 'consum', 0.0219, 'lps'),
	(506105, 131, '2014-01-15 00:31:36.000000', 'consum', 0.0221, 'lps'),
	(506106, 131, '2014-01-15 00:31:37.000000', 'consum', 0.0219, 'lps'),
	(506107, 131, '2014-01-15 00:31:38.000000', 'consum', 0.0219, 'lps'),
	(506108, 131, '2014-01-15 00:31:39.000000', 'consum', 0.0230, 'lps'),
	(506109, 131, '2014-01-15 00:31:40.000000', 'consum', 0.0219, 'lps'),
	(506110, 131, '2014-01-15 00:31:41.000000', 'consum', 0.0218, 'lps'),
	(506111, 131, '2014-01-15 00:31:42.000000', 'consum', 0.0222, 'lps'),
	(506112, 131, '2014-01-15 00:31:43.000000', 'consum', 0.0226, 'lps'),
	(506113, 131, '2014-01-15 00:31:44.000000', 'consum', 0.0230, 'lps'),
	(506114, 131, '2014-01-15 00:31:45.000000', 'consum', 0.0221, 'lps'),
	(506115, 131, '2014-01-15 00:31:46.000000', 'consum', 0.0227, 'lps'),
	(506116, 131, '2014-01-15 00:31:47.000000', 'consum', 0.0217, 'lps'),
	(506117, 131, '2014-01-15 00:31:48.000000', 'consum', 0.0219, 'lps'),
	(506118, 131, '2014-01-15 00:31:49.000000', 'consum', 0.0231, 'lps'),
	(506119, 131, '2014-01-15 00:31:50.000000', 'consum', 0.0225, 'lps'),
	(506120, 131, '2014-01-15 00:31:51.000000', 'consum', 0.0224, 'lps'),
	(506121, 131, '2014-01-15 00:31:52.000000', 'consum', 0.0211, 'lps'),
	(506122, 131, '2014-01-15 00:31:53.000000', 'consum', 0.0218, 'lps'),
	(506123, 131, '2014-01-15 00:31:54.000000', 'consum', 0.0227, 'lps'),
	(506124, 131, '2014-01-15 00:31:55.000000', 'consum', 0.0228, 'lps'),
	(506125, 131, '2014-01-15 00:31:56.000000', 'consum', 0.0226, 'lps'),
	(506126, 131, '2014-01-15 00:31:57.000000', 'consum', 0.0215, 'lps'),
	(506127, 131, '2014-01-15 00:31:58.000000', 'consum', 0.0231, 'lps'),
	(506128, 131, '2014-01-15 00:31:59.000000', 'consum', 0.0212, 'lps'),
	(506129, 131, '2014-01-15 00:32:00.000000', 'consum', 0.0222, 'lps'),
	(506130, 131, '2014-01-15 00:32:01.000000', 'consum', 0.0222, 'lps'),
	(506131, 131, '2014-01-15 00:32:02.000000', 'consum', 0.0214, 'lps'),
	(506132, 131, '2014-01-15 00:32:03.000000', 'consum', 0.0217, 'lps'),
	(506133, 131, '2014-01-15 00:32:04.000000', 'consum', 0.0212, 'lps'),
	(506134, 131, '2014-01-15 00:32:05.000000', 'consum', 0.0221, 'lps'),
	(506135, 131, '2014-01-15 00:32:06.000000', 'consum', 0.0215, 'lps'),
	(506136, 131, '2014-01-15 00:32:07.000000', 'consum', 0.0225, 'lps'),
	(506137, 131, '2014-01-15 00:32:08.000000', 'consum', 0.0228, 'lps'),
	(506138, 131, '2014-01-15 00:32:09.000000', 'consum', 0.0211, 'lps'),
	(506139, 131, '2014-01-15 00:32:10.000000', 'consum', 0.0227, 'lps'),
	(506140, 131, '2014-01-15 00:32:11.000000', 'consum', 0.0225, 'lps'),
	(506141, 131, '2014-01-15 00:32:12.000000', 'consum', 0.0215, 'lps'),
	(506142, 131, '2014-01-15 00:32:13.000000', 'consum', 0.0231, 'lps'),
	(506143, 131, '2014-01-15 00:32:14.000000', 'consum', 0.0216, 'lps'),
	(506144, 131, '2014-01-15 00:32:15.000000', 'consum', 0.0219, 'lps'),
	(506145, 131, '2014-01-15 00:32:16.000000', 'consum', 0.0216, 'lps'),
	(506146, 131, '2014-01-15 00:32:17.000000', 'consum', 0.0214, 'lps'),
	(506147, 131, '2014-01-15 00:32:18.000000', 'consum', 0.0210, 'lps'),
	(506148, 131, '2014-01-15 00:32:19.000000', 'consum', 0.0224, 'lps'),
	(506149, 131, '2014-01-15 00:32:20.000000', 'consum', 0.0214, 'lps'),
	(506150, 131, '2014-01-15 00:32:21.000000', 'consum', 0.0230, 'lps'),
	(506151, 131, '2014-01-15 00:32:22.000000', 'consum', 0.0212, 'lps'),
	(506152, 131, '2014-01-15 00:32:23.000000', 'consum', 0.0228, 'lps'),
	(506153, 131, '2014-01-15 00:32:24.000000', 'consum', 0.0228, 'lps'),
	(506154, 131, '2014-01-15 00:32:25.000000', 'consum', 0.0225, 'lps'),
	(506155, 131, '2014-01-15 00:32:26.000000', 'consum', 0.0229, 'lps'),
	(506156, 131, '2014-01-15 00:32:27.000000', 'consum', 0.0219, 'lps'),
	(506157, 131, '2014-01-15 00:32:28.000000', 'consum', 0.0221, 'lps'),
	(506158, 131, '2014-01-15 00:32:29.000000', 'consum', 0.0214, 'lps'),
	(506159, 131, '2014-01-15 00:32:30.000000', 'consum', 0.0220, 'lps'),
	(506160, 131, '2014-01-15 00:32:31.000000', 'consum', 0.0225, 'lps'),
	(506161, 131, '2014-01-15 00:32:32.000000', 'consum', 0.0212, 'lps'),
	(506162, 131, '2014-01-15 00:32:33.000000', 'consum', 0.0220, 'lps'),
	(506163, 131, '2014-01-15 00:32:34.000000', 'consum', 0.0212, 'lps'),
	(506164, 131, '2014-01-15 00:32:35.000000', 'consum', 0.0213, 'lps'),
	(506165, 131, '2014-01-15 00:32:36.000000', 'consum', 0.0218, 'lps'),
	(506166, 131, '2014-01-15 00:32:37.000000', 'consum', 0.0222, 'lps'),
	(506167, 131, '2014-01-15 00:32:38.000000', 'consum', 0.0221, 'lps'),
	(506168, 131, '2014-01-15 00:32:39.000000', 'consum', 0.0231, 'lps'),
	(506169, 131, '2014-01-15 00:32:40.000000', 'consum', 0.0216, 'lps'),
	(506170, 131, '2014-01-15 00:32:41.000000', 'consum', 0.0222, 'lps'),
	(506171, 131, '2014-01-15 00:32:42.000000', 'consum', 0.0231, 'lps'),
	(506172, 131, '2014-01-15 00:32:43.000000', 'consum', 0.0212, 'lps'),
	(506173, 131, '2014-01-15 00:32:44.000000', 'consum', 0.0225, 'lps'),
	(506174, 131, '2014-01-15 00:32:45.000000', 'consum', 0.0213, 'lps'),
	(506175, 131, '2014-01-15 00:32:46.000000', 'consum', 0.0223, 'lps'),
	(506176, 131, '2014-01-15 00:32:47.000000', 'consum', 0.0222, 'lps'),
	(506177, 131, '2014-01-15 00:32:48.000000', 'consum', 0.0212, 'lps'),
	(506178, 131, '2014-01-15 00:32:49.000000', 'consum', 0.0227, 'lps'),
	(506179, 131, '2014-01-15 00:32:50.000000', 'consum', 0.0224, 'lps'),
	(506180, 131, '2014-01-15 00:32:51.000000', 'consum', 0.0229, 'lps'),
	(506181, 131, '2014-01-15 00:32:52.000000', 'consum', 0.0220, 'lps'),
	(506182, 131, '2014-01-15 00:32:53.000000', 'consum', 0.0227, 'lps'),
	(506183, 131, '2014-01-15 00:32:54.000000', 'consum', 0.0219, 'lps'),
	(506184, 131, '2014-01-15 00:32:55.000000', 'consum', 0.0230, 'lps'),
	(506185, 131, '2014-01-15 00:32:56.000000', 'consum', 0.0214, 'lps'),
	(506186, 131, '2014-01-15 00:32:57.000000', 'consum', 0.0215, 'lps'),
	(506187, 131, '2014-01-15 00:32:58.000000', 'consum', 0.0224, 'lps'),
	(506188, 131, '2014-01-15 00:32:59.000000', 'consum', 0.0222, 'lps'),
	(506189, 131, '2014-01-15 00:33:00.000000', 'consum', 0.0228, 'lps'),
	(506190, 131, '2014-01-15 00:33:01.000000', 'consum', 0.0219, 'lps'),
	(506191, 131, '2014-01-15 00:33:02.000000', 'consum', 0.0226, 'lps'),
	(506192, 131, '2014-01-15 00:33:03.000000', 'consum', 0.0218, 'lps'),
	(506193, 131, '2014-01-15 00:33:04.000000', 'consum', 0.0223, 'lps'),
	(506194, 131, '2014-01-15 00:33:05.000000', 'consum', 0.0210, 'lps'),
	(506195, 131, '2014-01-15 00:33:06.000000', 'consum', 0.0216, 'lps'),
	(506196, 131, '2014-01-15 00:33:07.000000', 'consum', 0.0219, 'lps'),
	(506197, 131, '2014-01-15 00:33:08.000000', 'consum', 0.0216, 'lps'),
	(506198, 131, '2014-01-15 00:33:09.000000', 'consum', 0.0210, 'lps'),
	(506199, 131, '2014-01-15 00:33:10.000000', 'consum', 0.0218, 'lps'),
	(506200, 131, '2014-01-15 00:33:11.000000', 'consum', 0.0227, 'lps'),
	(506201, 131, '2014-01-15 00:33:12.000000', 'consum', 0.0227, 'lps'),
	(506202, 131, '2014-01-15 00:33:13.000000', 'consum', 0.0222, 'lps'),
	(506203, 131, '2014-01-15 00:33:14.000000', 'consum', 0.0219, 'lps'),
	(506204, 131, '2014-01-15 00:33:15.000000', 'consum', 0.0222, 'lps'),
	(506205, 131, '2014-01-15 00:33:16.000000', 'consum', 0.0220, 'lps'),
	(506206, 131, '2014-01-15 00:33:17.000000', 'consum', 0.0226, 'lps'),
	(506207, 131, '2014-01-15 00:33:18.000000', 'consum', 0.0217, 'lps'),
	(506208, 131, '2014-01-15 00:33:19.000000', 'consum', 0.0219, 'lps'),
	(506209, 131, '2014-01-15 00:33:20.000000', 'consum', 0.0210, 'lps'),
	(506210, 131, '2014-01-15 00:33:21.000000', 'consum', 0.0230, 'lps'),
	(506211, 131, '2014-01-15 00:33:22.000000', 'consum', 0.0223, 'lps'),
	(506212, 131, '2014-01-15 00:33:23.000000', 'consum', 0.0216, 'lps'),
	(506213, 131, '2014-01-15 00:33:24.000000', 'consum', 0.0221, 'lps'),
	(506214, 131, '2014-01-15 00:33:25.000000', 'consum', 0.0226, 'lps'),
	(506215, 131, '2014-01-15 00:33:26.000000', 'consum', 0.0216, 'lps'),
	(506216, 131, '2014-01-15 00:33:27.000000', 'consum', 0.0211, 'lps'),
	(506217, 131, '2014-01-15 00:33:28.000000', 'consum', 0.0221, 'lps'),
	(506218, 131, '2014-01-15 00:33:29.000000', 'consum', 0.0217, 'lps'),
	(506219, 131, '2014-01-15 00:33:30.000000', 'consum', 0.0213, 'lps'),
	(506220, 131, '2014-01-15 00:33:31.000000', 'consum', 0.0229, 'lps'),
	(506221, 131, '2014-01-15 00:33:32.000000', 'consum', 0.0228, 'lps'),
	(506222, 131, '2014-01-15 00:33:33.000000', 'consum', 0.0221, 'lps'),
	(506223, 131, '2014-01-15 00:33:34.000000', 'consum', 0.0212, 'lps'),
	(506224, 131, '2014-01-15 00:33:35.000000', 'consum', 0.0210, 'lps'),
	(506225, 131, '2014-01-15 00:33:36.000000', 'consum', 0.0225, 'lps'),
	(506226, 131, '2014-01-15 00:33:37.000000', 'consum', 0.0220, 'lps'),
	(506227, 131, '2014-01-15 00:33:38.000000', 'consum', 0.0218, 'lps'),
	(506228, 131, '2014-01-15 00:33:39.000000', 'consum', 0.0218, 'lps'),
	(506229, 131, '2014-01-15 00:33:40.000000', 'consum', 0.0228, 'lps'),
	(506230, 131, '2014-01-15 00:33:41.000000', 'consum', 0.0211, 'lps'),
	(506231, 131, '2014-01-15 00:33:42.000000', 'consum', 0.0229, 'lps'),
	(506232, 131, '2014-01-15 00:33:43.000000', 'consum', 0.0212, 'lps'),
	(506233, 131, '2014-01-15 00:33:44.000000', 'consum', 0.0228, 'lps'),
	(506234, 131, '2014-01-15 00:33:45.000000', 'consum', 0.0231, 'lps'),
	(506235, 131, '2014-01-15 00:33:46.000000', 'consum', 0.0215, 'lps'),
	(506236, 131, '2014-01-15 00:33:47.000000', 'consum', 0.0219, 'lps'),
	(506237, 131, '2014-01-15 00:33:48.000000', 'consum', 0.0218, 'lps'),
	(506238, 131, '2014-01-15 00:33:49.000000', 'consum', 0.0222, 'lps'),
	(506239, 131, '2014-01-15 00:33:50.000000', 'consum', 0.0225, 'lps'),
	(506240, 131, '2014-01-15 00:33:51.000000', 'consum', 0.0230, 'lps'),
	(506241, 131, '2014-01-15 00:33:52.000000', 'consum', 0.0219, 'lps'),
	(506242, 131, '2014-01-15 00:33:53.000000', 'consum', 0.0216, 'lps'),
	(506243, 131, '2014-01-15 00:33:54.000000', 'consum', 0.0215, 'lps'),
	(506244, 131, '2014-01-15 00:33:55.000000', 'consum', 0.0219, 'lps'),
	(506245, 131, '2014-01-15 00:33:56.000000', 'consum', 0.0218, 'lps'),
	(506246, 131, '2014-01-15 00:33:57.000000', 'consum', 0.0224, 'lps'),
	(506247, 131, '2014-01-15 00:33:58.000000', 'consum', 0.0212, 'lps'),
	(506248, 131, '2014-01-15 00:33:59.000000', 'consum', 0.0221, 'lps'),
	(506249, 131, '2014-01-15 00:34:00.000000', 'consum', 0.0218, 'lps'),
	(506250, 131, '2014-01-15 00:34:01.000000', 'consum', 0.0215, 'lps'),
	(506251, 131, '2014-01-15 00:34:02.000000', 'consum', 0.0214, 'lps'),
	(506252, 131, '2014-01-15 00:34:03.000000', 'consum', 0.0216, 'lps'),
	(506253, 131, '2014-01-15 00:34:04.000000', 'consum', 0.0229, 'lps'),
	(506254, 131, '2014-01-15 00:34:05.000000', 'consum', 0.0220, 'lps'),
	(506255, 131, '2014-01-15 00:34:06.000000', 'consum', 0.0227, 'lps'),
	(506256, 131, '2014-01-15 00:34:07.000000', 'consum', 0.0219, 'lps'),
	(506257, 131, '2014-01-15 00:34:08.000000', 'consum', 0.0227, 'lps'),
	(506258, 131, '2014-01-15 00:34:09.000000', 'consum', 0.0224, 'lps'),
	(506259, 131, '2014-01-15 00:34:10.000000', 'consum', 0.0230, 'lps'),
	(506260, 131, '2014-01-15 00:34:11.000000', 'consum', 0.0223, 'lps'),
	(506261, 131, '2014-01-15 00:34:12.000000', 'consum', 0.0216, 'lps'),
	(506262, 131, '2014-01-15 00:34:13.000000', 'consum', 0.0224, 'lps'),
	(506263, 131, '2014-01-15 00:34:14.000000', 'consum', 0.0218, 'lps'),
	(506264, 131, '2014-01-15 00:34:15.000000', 'consum', 0.0210, 'lps'),
	(506265, 131, '2014-01-15 00:34:16.000000', 'consum', 0.0228, 'lps'),
	(506266, 131, '2014-01-15 00:34:17.000000', 'consum', 0.0214, 'lps'),
	(506267, 131, '2014-01-15 00:34:18.000000', 'consum', 0.0219, 'lps'),
	(506268, 131, '2014-01-15 00:34:19.000000', 'consum', 0.0220, 'lps'),
	(506269, 131, '2014-01-15 00:34:20.000000', 'consum', 0.0215, 'lps'),
	(506270, 131, '2014-01-15 00:34:21.000000', 'consum', 0.0226, 'lps'),
	(506271, 131, '2014-01-15 00:34:22.000000', 'consum', 0.0230, 'lps'),
	(506272, 131, '2014-01-15 00:34:23.000000', 'consum', 0.0221, 'lps'),
	(506273, 131, '2014-01-15 00:34:24.000000', 'consum', 0.0225, 'lps'),
	(506274, 131, '2014-01-15 00:34:25.000000', 'consum', 0.0210, 'lps'),
	(506275, 131, '2014-01-15 00:34:26.000000', 'consum', 0.0230, 'lps'),
	(506276, 131, '2014-01-15 00:34:27.000000', 'consum', 0.0222, 'lps'),
	(506277, 131, '2014-01-15 00:34:28.000000', 'consum', 0.0211, 'lps'),
	(506278, 131, '2014-01-15 00:34:29.000000', 'consum', 0.0225, 'lps'),
	(506279, 131, '2014-01-15 00:34:30.000000', 'consum', 0.0215, 'lps'),
	(506280, 131, '2014-01-15 00:34:31.000000', 'consum', 0.0215, 'lps'),
	(506281, 131, '2014-01-15 00:34:32.000000', 'consum', 0.0217, 'lps'),
	(506282, 131, '2014-01-15 00:34:33.000000', 'consum', 0.0210, 'lps'),
	(506283, 131, '2014-01-15 00:34:34.000000', 'consum', 0.0212, 'lps'),
	(506284, 131, '2014-01-15 00:34:35.000000', 'consum', 0.0219, 'lps'),
	(506285, 131, '2014-01-15 00:34:36.000000', 'consum', 0.0229, 'lps'),
	(506286, 131, '2014-01-15 00:34:37.000000', 'consum', 0.0212, 'lps'),
	(506287, 131, '2014-01-15 00:34:38.000000', 'consum', 0.0230, 'lps'),
	(506288, 131, '2014-01-15 00:34:39.000000', 'consum', 0.0215, 'lps'),
	(506289, 131, '2014-01-15 00:34:40.000000', 'consum', 0.0222, 'lps'),
	(506290, 131, '2014-01-15 00:34:41.000000', 'consum', 0.0210, 'lps'),
	(506291, 131, '2014-01-15 00:34:42.000000', 'consum', 0.0217, 'lps'),
	(506292, 131, '2014-01-15 00:34:43.000000', 'consum', 0.0224, 'lps'),
	(506293, 131, '2014-01-15 00:34:44.000000', 'consum', 0.0217, 'lps'),
	(506294, 131, '2014-01-15 00:34:45.000000', 'consum', 0.0224, 'lps'),
	(506295, 131, '2014-01-15 00:34:46.000000', 'consum', 0.0215, 'lps'),
	(506296, 131, '2014-01-15 00:34:47.000000', 'consum', 0.0215, 'lps'),
	(506297, 131, '2014-01-15 00:34:48.000000', 'consum', 0.0221, 'lps'),
	(506298, 131, '2014-01-15 00:34:49.000000', 'consum', 0.0230, 'lps'),
	(506299, 131, '2014-01-15 00:34:50.000000', 'consum', 0.0231, 'lps'),
	(506300, 131, '2014-01-15 00:34:51.000000', 'consum', 0.0213, 'lps'),
	(506301, 131, '2014-01-15 00:34:52.000000', 'consum', 0.0229, 'lps'),
	(506302, 131, '2014-01-15 00:34:53.000000', 'consum', 0.0228, 'lps'),
	(506303, 131, '2014-01-15 00:34:54.000000', 'consum', 0.0224, 'lps'),
	(506304, 131, '2014-01-15 00:34:55.000000', 'consum', 0.0226, 'lps'),
	(506305, 131, '2014-01-15 00:34:56.000000', 'consum', 0.0226, 'lps'),
	(506306, 131, '2014-01-15 00:34:57.000000', 'consum', 0.0220, 'lps'),
	(506307, 131, '2014-01-15 00:34:58.000000', 'consum', 0.0211, 'lps'),
	(506308, 131, '2014-01-15 00:34:59.000000', 'consum', 0.0210, 'lps'),
	(506309, 131, '2014-01-15 00:35:00.000000', 'consum', 0.0230, 'lps'),
	(506310, 131, '2014-01-15 00:35:01.000000', 'consum', 0.0221, 'lps'),
	(506311, 131, '2014-01-15 00:35:02.000000', 'consum', 0.0228, 'lps'),
	(506312, 131, '2014-01-15 00:35:03.000000', 'consum', 0.0222, 'lps'),
	(506313, 131, '2014-01-15 00:35:04.000000', 'consum', 0.0219, 'lps'),
	(506314, 131, '2014-01-15 00:35:05.000000', 'consum', 0.0218, 'lps'),
	(506315, 131, '2014-01-15 00:35:06.000000', 'consum', 0.0225, 'lps'),
	(506316, 131, '2014-01-15 00:35:07.000000', 'consum', 0.0215, 'lps'),
	(506317, 131, '2014-01-15 00:35:08.000000', 'consum', 0.0213, 'lps'),
	(506318, 131, '2014-01-15 00:35:09.000000', 'consum', 0.0231, 'lps'),
	(506319, 131, '2014-01-15 00:35:10.000000', 'consum', 0.0220, 'lps'),
	(506320, 131, '2014-01-15 00:35:11.000000', 'consum', 0.0219, 'lps'),
	(506321, 131, '2014-01-15 00:35:12.000000', 'consum', 0.0225, 'lps'),
	(506322, 131, '2014-01-15 00:35:13.000000', 'consum', 0.0217, 'lps'),
	(506323, 131, '2014-01-15 00:35:14.000000', 'consum', 0.0220, 'lps'),
	(506324, 131, '2014-01-15 00:35:15.000000', 'consum', 0.0216, 'lps'),
	(506325, 131, '2014-01-15 00:35:16.000000', 'consum', 0.0213, 'lps'),
	(506326, 131, '2014-01-15 00:35:17.000000', 'consum', 0.0229, 'lps'),
	(506327, 131, '2014-01-15 00:35:18.000000', 'consum', 0.0231, 'lps'),
	(506328, 131, '2014-01-15 00:35:19.000000', 'consum', 0.0213, 'lps'),
	(506329, 131, '2014-01-15 00:35:20.000000', 'consum', 0.0231, 'lps'),
	(506330, 131, '2014-01-15 00:35:21.000000', 'consum', 0.0218, 'lps'),
	(506331, 131, '2014-01-15 00:35:22.000000', 'consum', 0.0230, 'lps'),
	(506332, 131, '2014-01-15 00:35:23.000000', 'consum', 0.0223, 'lps'),
	(506333, 131, '2014-01-15 00:35:24.000000', 'consum', 0.0214, 'lps'),
	(506334, 131, '2014-01-15 00:35:25.000000', 'consum', 0.0215, 'lps'),
	(506335, 131, '2014-01-15 00:35:26.000000', 'consum', 0.0222, 'lps'),
	(506336, 131, '2014-01-15 00:35:27.000000', 'consum', 0.0210, 'lps'),
	(506337, 131, '2014-01-15 00:35:28.000000', 'consum', 0.0221, 'lps'),
	(506338, 131, '2014-01-15 00:35:29.000000', 'consum', 0.0220, 'lps'),
	(506339, 131, '2014-01-15 00:35:30.000000', 'consum', 0.0227, 'lps'),
	(506340, 131, '2014-01-15 00:35:31.000000', 'consum', 0.0222, 'lps'),
	(506341, 131, '2014-01-15 00:35:32.000000', 'consum', 0.0222, 'lps'),
	(506342, 131, '2014-01-15 00:35:33.000000', 'consum', 0.0231, 'lps'),
	(506343, 131, '2014-01-15 00:35:34.000000', 'consum', 0.0215, 'lps'),
	(506344, 131, '2014-01-15 00:35:35.000000', 'consum', 0.0218, 'lps'),
	(506345, 131, '2014-01-15 00:35:36.000000', 'consum', 0.0213, 'lps'),
	(506346, 131, '2014-01-15 00:35:37.000000', 'consum', 0.0224, 'lps'),
	(506347, 131, '2014-01-15 00:35:38.000000', 'consum', 0.0227, 'lps'),
	(506348, 131, '2014-01-15 00:35:39.000000', 'consum', 0.0230, 'lps'),
	(506349, 131, '2014-01-15 00:35:40.000000', 'consum', 0.0215, 'lps'),
	(506350, 131, '2014-01-15 00:35:41.000000', 'consum', 0.0223, 'lps'),
	(506351, 131, '2014-01-15 00:35:42.000000', 'consum', 0.0213, 'lps'),
	(506352, 131, '2014-01-15 00:35:43.000000', 'consum', 0.0231, 'lps'),
	(506353, 131, '2014-01-15 00:35:44.000000', 'consum', 0.0220, 'lps'),
	(506354, 131, '2014-01-15 00:35:45.000000', 'consum', 0.0218, 'lps'),
	(506355, 131, '2014-01-15 00:35:46.000000', 'consum', 0.0219, 'lps'),
	(506356, 131, '2014-01-15 00:35:47.000000', 'consum', 0.0213, 'lps'),
	(506357, 131, '2014-01-15 00:35:48.000000', 'consum', 0.0219, 'lps'),
	(506358, 131, '2014-01-15 00:35:49.000000', 'consum', 0.0223, 'lps'),
	(506359, 131, '2014-01-15 00:35:50.000000', 'consum', 0.0228, 'lps'),
	(506360, 131, '2014-01-15 00:35:51.000000', 'consum', 0.0218, 'lps'),
	(506361, 131, '2014-01-15 00:35:52.000000', 'consum', 0.0216, 'lps'),
	(506362, 131, '2014-01-15 00:35:53.000000', 'consum', 0.0220, 'lps'),
	(506363, 131, '2014-01-15 00:35:54.000000', 'consum', 0.0217, 'lps'),
	(506364, 131, '2014-01-15 00:35:55.000000', 'consum', 0.0217, 'lps'),
	(506365, 131, '2014-01-15 00:35:56.000000', 'consum', 0.0224, 'lps'),
	(506366, 131, '2014-01-15 00:35:57.000000', 'consum', 0.0216, 'lps'),
	(506367, 131, '2014-01-15 00:35:58.000000', 'consum', 0.0219, 'lps'),
	(506368, 131, '2014-01-15 00:35:59.000000', 'consum', 0.0219, 'lps'),
	(506369, 131, '2014-01-15 00:36:00.000000', 'consum', 0.0225, 'lps'),
	(506370, 131, '2014-01-15 00:36:01.000000', 'consum', 0.0215, 'lps'),
	(506371, 131, '2014-01-15 00:36:02.000000', 'consum', 0.0214, 'lps'),
	(506372, 131, '2014-01-15 00:36:03.000000', 'consum', 0.0216, 'lps'),
	(506373, 131, '2014-01-15 00:36:04.000000', 'consum', 0.0229, 'lps'),
	(506374, 131, '2014-01-15 00:36:05.000000', 'consum', 0.0219, 'lps'),
	(506375, 131, '2014-01-15 00:36:06.000000', 'consum', 0.0221, 'lps'),
	(506376, 131, '2014-01-15 00:36:07.000000', 'consum', 0.0216, 'lps'),
	(506377, 131, '2014-01-15 00:36:08.000000', 'consum', 0.0230, 'lps'),
	(506378, 131, '2014-01-15 00:36:09.000000', 'consum', 0.0227, 'lps'),
	(506379, 131, '2014-01-15 00:36:10.000000', 'consum', 0.0213, 'lps'),
	(506380, 131, '2014-01-15 00:36:11.000000', 'consum', 0.0218, 'lps'),
	(506381, 131, '2014-01-15 00:36:12.000000', 'consum', 0.0222, 'lps'),
	(506382, 131, '2014-01-15 00:36:13.000000', 'consum', 0.0223, 'lps'),
	(506383, 131, '2014-01-15 00:36:14.000000', 'consum', 0.0218, 'lps'),
	(506384, 131, '2014-01-15 00:36:15.000000', 'consum', 0.0213, 'lps'),
	(506385, 131, '2014-01-15 00:36:16.000000', 'consum', 0.0221, 'lps'),
	(506386, 131, '2014-01-15 00:36:17.000000', 'consum', 0.0214, 'lps'),
	(506387, 131, '2014-01-15 00:36:18.000000', 'consum', 0.0220, 'lps'),
	(506388, 131, '2014-01-15 00:36:19.000000', 'consum', 0.0228, 'lps'),
	(506389, 131, '2014-01-15 00:36:20.000000', 'consum', 0.0225, 'lps'),
	(506390, 131, '2014-01-15 00:36:21.000000', 'consum', 0.0231, 'lps'),
	(506391, 131, '2014-01-15 00:36:22.000000', 'consum', 0.0227, 'lps'),
	(506392, 131, '2014-01-15 00:36:23.000000', 'consum', 0.0211, 'lps'),
	(506393, 131, '2014-01-15 00:36:24.000000', 'consum', 0.0231, 'lps'),
	(506394, 131, '2014-01-15 00:36:25.000000', 'consum', 0.0223, 'lps'),
	(506395, 131, '2014-01-15 00:36:26.000000', 'consum', 0.0213, 'lps'),
	(506396, 131, '2014-01-15 00:36:27.000000', 'consum', 0.0210, 'lps'),
	(506397, 131, '2014-01-15 00:36:28.000000', 'consum', 0.0223, 'lps'),
	(506398, 131, '2014-01-15 00:36:29.000000', 'consum', 0.0230, 'lps'),
	(506399, 131, '2014-01-15 00:36:30.000000', 'consum', 0.0230, 'lps'),
	(506400, 131, '2014-01-15 00:36:31.000000', 'consum', 0.0229, 'lps'),
	(506401, 131, '2014-01-15 00:36:32.000000', 'consum', 0.0223, 'lps'),
	(506402, 131, '2014-01-15 00:36:33.000000', 'consum', 0.0220, 'lps'),
	(506403, 131, '2014-01-15 00:36:34.000000', 'consum', 0.0220, 'lps'),
	(506404, 131, '2014-01-15 00:36:35.000000', 'consum', 0.0229, 'lps'),
	(506405, 131, '2014-01-15 00:36:36.000000', 'consum', 0.0231, 'lps'),
	(506406, 131, '2014-01-15 00:36:37.000000', 'consum', 0.0213, 'lps'),
	(506407, 131, '2014-01-15 00:36:38.000000', 'consum', 0.0210, 'lps'),
	(506408, 131, '2014-01-15 00:36:39.000000', 'consum', 0.0224, 'lps'),
	(506409, 131, '2014-01-15 00:36:40.000000', 'consum', 0.0214, 'lps'),
	(506410, 131, '2014-01-15 00:36:41.000000', 'consum', 0.0230, 'lps'),
	(506411, 131, '2014-01-15 00:36:42.000000', 'consum', 0.0212, 'lps'),
	(506412, 131, '2014-01-15 00:36:43.000000', 'consum', 0.0228, 'lps'),
	(506413, 131, '2014-01-15 00:36:44.000000', 'consum', 0.0227, 'lps'),
	(506414, 131, '2014-01-15 00:36:45.000000', 'consum', 0.0219, 'lps'),
	(506415, 131, '2014-01-15 00:36:46.000000', 'consum', 0.0226, 'lps'),
	(506416, 131, '2014-01-15 00:36:47.000000', 'consum', 0.0220, 'lps'),
	(506417, 131, '2014-01-15 00:36:48.000000', 'consum', 0.0212, 'lps'),
	(506418, 131, '2014-01-15 00:36:49.000000', 'consum', 0.0213, 'lps'),
	(506419, 131, '2014-01-15 00:36:50.000000', 'consum', 0.0220, 'lps'),
	(506420, 131, '2014-01-15 00:36:51.000000', 'consum', 0.0228, 'lps'),
	(506421, 131, '2014-01-15 00:36:52.000000', 'consum', 0.0228, 'lps'),
	(506422, 131, '2014-01-15 00:36:53.000000', 'consum', 0.0225, 'lps'),
	(506423, 131, '2014-01-15 00:36:54.000000', 'consum', 0.0210, 'lps'),
	(506424, 131, '2014-01-15 00:36:55.000000', 'consum', 0.0230, 'lps'),
	(506425, 131, '2014-01-15 00:36:56.000000', 'consum', 0.0222, 'lps'),
	(506426, 131, '2014-01-15 00:36:57.000000', 'consum', 0.0210, 'lps'),
	(506427, 131, '2014-01-15 00:36:58.000000', 'consum', 0.0217, 'lps'),
	(506428, 131, '2014-01-15 00:36:59.000000', 'consum', 0.0226, 'lps'),
	(506429, 131, '2014-01-15 00:37:00.000000', 'consum', 0.0225, 'lps'),
	(506430, 131, '2014-01-15 00:37:01.000000', 'consum', 0.0216, 'lps'),
	(506431, 131, '2014-01-15 00:37:02.000000', 'consum', 0.0216, 'lps'),
	(506432, 131, '2014-01-15 00:37:03.000000', 'consum', 0.0222, 'lps'),
	(506433, 131, '2014-01-15 00:37:04.000000', 'consum', 0.0210, 'lps'),
	(506434, 131, '2014-01-15 00:37:05.000000', 'consum', 0.0218, 'lps'),
	(506435, 131, '2014-01-15 00:37:06.000000', 'consum', 0.0227, 'lps'),
	(506436, 131, '2014-01-15 00:37:07.000000', 'consum', 0.0230, 'lps'),
	(506437, 131, '2014-01-15 00:37:08.000000', 'consum', 0.0216, 'lps'),
	(506438, 131, '2014-01-15 00:37:09.000000', 'consum', 0.0222, 'lps'),
	(506439, 131, '2014-01-15 00:37:10.000000', 'consum', 0.0230, 'lps'),
	(506440, 131, '2014-01-15 00:37:11.000000', 'consum', 0.0210, 'lps'),
	(506441, 131, '2014-01-15 00:37:12.000000', 'consum', 0.0214, 'lps'),
	(506442, 131, '2014-01-15 00:37:13.000000', 'consum', 0.0212, 'lps'),
	(506443, 131, '2014-01-15 00:37:14.000000', 'consum', 0.0229, 'lps'),
	(506444, 131, '2014-01-15 00:37:15.000000', 'consum', 0.0212, 'lps'),
	(506445, 131, '2014-01-15 00:37:16.000000', 'consum', 0.0229, 'lps'),
	(506446, 131, '2014-01-15 00:37:17.000000', 'consum', 0.0214, 'lps'),
	(506447, 131, '2014-01-15 00:37:18.000000', 'consum', 0.0214, 'lps'),
	(506448, 131, '2014-01-15 00:37:19.000000', 'consum', 0.0219, 'lps'),
	(506449, 131, '2014-01-15 00:37:20.000000', 'consum', 0.0222, 'lps'),
	(506450, 131, '2014-01-15 00:37:21.000000', 'consum', 0.0222, 'lps'),
	(506451, 131, '2014-01-15 00:37:22.000000', 'consum', 0.0211, 'lps'),
	(506452, 131, '2014-01-15 00:37:23.000000', 'consum', 0.0224, 'lps'),
	(506453, 131, '2014-01-15 00:37:24.000000', 'consum', 0.0211, 'lps'),
	(506454, 131, '2014-01-15 00:37:25.000000', 'consum', 0.0219, 'lps'),
	(506455, 131, '2014-01-15 00:37:26.000000', 'consum', 0.0230, 'lps'),
	(506456, 131, '2014-01-15 00:37:27.000000', 'consum', 0.0217, 'lps'),
	(506457, 131, '2014-01-15 00:37:28.000000', 'consum', 0.0229, 'lps'),
	(506458, 131, '2014-01-15 00:37:29.000000', 'consum', 0.0221, 'lps'),
	(506459, 131, '2014-01-15 00:37:30.000000', 'consum', 0.0228, 'lps'),
	(506460, 131, '2014-01-15 00:37:31.000000', 'consum', 0.0224, 'lps'),
	(506461, 131, '2014-01-15 00:37:32.000000', 'consum', 0.0225, 'lps'),
	(506462, 131, '2014-01-15 00:37:33.000000', 'consum', 0.0222, 'lps'),
	(506463, 131, '2014-01-15 00:37:34.000000', 'consum', 0.0225, 'lps'),
	(506464, 131, '2014-01-15 00:37:35.000000', 'consum', 0.0229, 'lps'),
	(506465, 131, '2014-01-15 00:37:36.000000', 'consum', 0.0214, 'lps'),
	(506466, 131, '2014-01-15 00:37:37.000000', 'consum', 0.0219, 'lps'),
	(506467, 131, '2014-01-15 00:37:38.000000', 'consum', 0.0222, 'lps'),
	(506468, 131, '2014-01-15 00:37:39.000000', 'consum', 0.0220, 'lps'),
	(506469, 131, '2014-01-15 00:37:40.000000', 'consum', 0.0224, 'lps'),
	(506470, 131, '2014-01-15 00:37:41.000000', 'consum', 0.0230, 'lps'),
	(506471, 131, '2014-01-15 00:37:42.000000', 'consum', 0.0224, 'lps'),
	(506472, 131, '2014-01-15 00:37:43.000000', 'consum', 0.0220, 'lps'),
	(506473, 131, '2014-01-15 00:37:44.000000', 'consum', 0.0220, 'lps'),
	(506474, 131, '2014-01-15 00:37:45.000000', 'consum', 0.0231, 'lps'),
	(506475, 131, '2014-01-15 00:37:46.000000', 'consum', 0.0220, 'lps'),
	(506476, 131, '2014-01-15 00:37:47.000000', 'consum', 0.0219, 'lps'),
	(506477, 131, '2014-01-15 00:37:48.000000', 'consum', 0.0225, 'lps'),
	(506478, 131, '2014-01-15 00:37:49.000000', 'consum', 0.0215, 'lps'),
	(506479, 131, '2014-01-15 00:37:50.000000', 'consum', 0.0212, 'lps'),
	(506480, 131, '2014-01-15 00:37:51.000000', 'consum', 0.0229, 'lps'),
	(506481, 131, '2014-01-15 00:37:52.000000', 'consum', 0.0210, 'lps'),
	(506482, 131, '2014-01-15 00:37:53.000000', 'consum', 0.0218, 'lps'),
	(506483, 131, '2014-01-15 00:37:54.000000', 'consum', 0.0210, 'lps'),
	(506484, 131, '2014-01-15 00:37:55.000000', 'consum', 0.0228, 'lps'),
	(506485, 131, '2014-01-15 00:37:56.000000', 'consum', 0.0211, 'lps'),
	(506486, 131, '2014-01-15 00:37:57.000000', 'consum', 0.0230, 'lps'),
	(506487, 131, '2014-01-15 00:37:58.000000', 'consum', 0.0219, 'lps'),
	(506488, 131, '2014-01-15 00:37:59.000000', 'consum', 0.0215, 'lps'),
	(506489, 131, '2014-01-15 00:38:00.000000', 'consum', 0.0212, 'lps'),
	(506490, 131, '2014-01-15 00:38:01.000000', 'consum', 0.0224, 'lps'),
	(506491, 131, '2014-01-15 00:38:02.000000', 'consum', 0.0212, 'lps'),
	(506492, 131, '2014-01-15 00:38:03.000000', 'consum', 0.0222, 'lps'),
	(506493, 131, '2014-01-15 00:38:04.000000', 'consum', 0.0219, 'lps'),
	(506494, 131, '2014-01-15 00:38:05.000000', 'consum', 0.0220, 'lps'),
	(506495, 131, '2014-01-15 00:38:06.000000', 'consum', 0.0210, 'lps'),
	(506496, 131, '2014-01-15 00:38:07.000000', 'consum', 0.0225, 'lps'),
	(506497, 131, '2014-01-15 00:38:08.000000', 'consum', 0.0219, 'lps'),
	(506498, 131, '2014-01-15 00:38:09.000000', 'consum', 0.0211, 'lps'),
	(506499, 131, '2014-01-15 00:38:10.000000', 'consum', 0.0231, 'lps'),
	(506500, 131, '2014-01-15 00:38:11.000000', 'consum', 0.0224, 'lps'),
	(506501, 131, '2014-01-15 00:38:12.000000', 'consum', 0.0220, 'lps'),
	(506502, 131, '2014-01-15 00:38:13.000000', 'consum', 0.0216, 'lps'),
	(506503, 131, '2014-01-15 00:38:14.000000', 'consum', 0.0210, 'lps'),
	(506504, 131, '2014-01-15 00:38:15.000000', 'consum', 0.0215, 'lps'),
	(506505, 131, '2014-01-15 00:38:16.000000', 'consum', 0.0215, 'lps'),
	(506506, 131, '2014-01-15 00:38:17.000000', 'consum', 0.0221, 'lps'),
	(506507, 131, '2014-01-15 00:38:18.000000', 'consum', 0.0228, 'lps'),
	(506508, 131, '2014-01-15 00:38:19.000000', 'consum', 0.0224, 'lps'),
	(506509, 131, '2014-01-15 00:38:20.000000', 'consum', 0.0224, 'lps'),
	(506510, 131, '2014-01-15 00:38:21.000000', 'consum', 0.0219, 'lps'),
	(506511, 131, '2014-01-15 00:38:22.000000', 'consum', 0.0212, 'lps'),
	(506512, 131, '2014-01-15 00:38:23.000000', 'consum', 0.0215, 'lps'),
	(506513, 131, '2014-01-15 00:38:24.000000', 'consum', 0.0210, 'lps'),
	(506514, 131, '2014-01-15 00:38:25.000000', 'consum', 0.0217, 'lps'),
	(506515, 131, '2014-01-15 00:38:26.000000', 'consum', 0.0224, 'lps'),
	(506516, 131, '2014-01-15 00:38:27.000000', 'consum', 0.0216, 'lps'),
	(506517, 131, '2014-01-15 00:38:28.000000', 'consum', 0.0218, 'lps'),
	(506518, 131, '2014-01-15 00:38:29.000000', 'consum', 0.0210, 'lps'),
	(506519, 131, '2014-01-15 00:38:30.000000', 'consum', 0.0211, 'lps'),
	(506520, 131, '2014-01-15 00:38:31.000000', 'consum', 0.0216, 'lps'),
	(506521, 131, '2014-01-15 00:38:32.000000', 'consum', 0.0213, 'lps'),
	(506522, 131, '2014-01-15 00:38:33.000000', 'consum', 0.0231, 'lps'),
	(506523, 131, '2014-01-15 00:38:34.000000', 'consum', 0.0217, 'lps'),
	(506524, 131, '2014-01-15 00:38:35.000000', 'consum', 0.0225, 'lps'),
	(506525, 131, '2014-01-15 00:38:36.000000', 'consum', 0.0223, 'lps'),
	(506526, 131, '2014-01-15 00:38:37.000000', 'consum', 0.0230, 'lps'),
	(506527, 131, '2014-01-15 00:38:38.000000', 'consum', 0.0229, 'lps'),
	(506528, 131, '2014-01-15 00:38:39.000000', 'consum', 0.0222, 'lps'),
	(506529, 131, '2014-01-15 00:38:40.000000', 'consum', 0.0214, 'lps'),
	(506530, 131, '2014-01-15 00:38:41.000000', 'consum', 0.0216, 'lps'),
	(506531, 131, '2014-01-15 00:38:42.000000', 'consum', 0.0230, 'lps'),
	(506532, 131, '2014-01-15 00:38:43.000000', 'consum', 0.0225, 'lps'),
	(506533, 131, '2014-01-15 00:38:44.000000', 'consum', 0.0224, 'lps'),
	(506534, 131, '2014-01-15 00:38:45.000000', 'consum', 0.0217, 'lps'),
	(506535, 131, '2014-01-15 00:38:46.000000', 'consum', 0.0224, 'lps'),
	(506536, 131, '2014-01-15 00:38:47.000000', 'consum', 0.0214, 'lps'),
	(506537, 131, '2014-01-15 00:38:48.000000', 'consum', 0.0210, 'lps'),
	(506538, 131, '2014-01-15 00:38:49.000000', 'consum', 0.0220, 'lps'),
	(506539, 131, '2014-01-15 00:38:50.000000', 'consum', 0.0217, 'lps'),
	(506540, 131, '2014-01-15 00:38:51.000000', 'consum', 0.0215, 'lps'),
	(506541, 131, '2014-01-15 00:38:52.000000', 'consum', 0.0215, 'lps'),
	(506542, 131, '2014-01-15 00:38:53.000000', 'consum', 0.0222, 'lps'),
	(506543, 131, '2014-01-15 00:38:54.000000', 'consum', 0.0211, 'lps'),
	(506544, 131, '2014-01-15 00:38:55.000000', 'consum', 0.0224, 'lps'),
	(506545, 131, '2014-01-15 00:38:56.000000', 'consum', 0.0211, 'lps'),
	(506546, 131, '2014-01-15 00:38:57.000000', 'consum', 0.0216, 'lps'),
	(506547, 131, '2014-01-15 00:38:58.000000', 'consum', 0.0215, 'lps'),
	(506548, 131, '2014-01-15 00:38:59.000000', 'consum', 0.0217, 'lps'),
	(506549, 131, '2014-01-15 00:39:00.000000', 'consum', 0.0211, 'lps'),
	(506550, 131, '2014-01-15 00:39:01.000000', 'consum', 0.0216, 'lps'),
	(506551, 131, '2014-01-15 00:39:02.000000', 'consum', 0.0215, 'lps'),
	(506552, 131, '2014-01-15 00:39:03.000000', 'consum', 0.0217, 'lps'),
	(506553, 131, '2014-01-15 00:39:04.000000', 'consum', 0.0210, 'lps'),
	(506554, 131, '2014-01-15 00:39:05.000000', 'consum', 0.0231, 'lps'),
	(506555, 131, '2014-01-15 00:39:06.000000', 'consum', 0.0228, 'lps'),
	(506556, 131, '2014-01-15 00:39:07.000000', 'consum', 0.0218, 'lps'),
	(506557, 131, '2014-01-15 00:39:08.000000', 'consum', 0.0216, 'lps'),
	(506558, 131, '2014-01-15 00:39:09.000000', 'consum', 0.0219, 'lps'),
	(506559, 131, '2014-01-15 00:39:10.000000', 'consum', 0.0213, 'lps'),
	(506560, 131, '2014-01-15 00:39:11.000000', 'consum', 0.0222, 'lps'),
	(506561, 131, '2014-01-15 00:39:12.000000', 'consum', 0.0219, 'lps'),
	(506562, 131, '2014-01-15 00:39:13.000000', 'consum', 0.0217, 'lps'),
	(506563, 131, '2014-01-15 00:39:14.000000', 'consum', 0.0221, 'lps'),
	(506564, 131, '2014-01-15 00:39:15.000000', 'consum', 0.0220, 'lps'),
	(506565, 131, '2014-01-15 00:39:16.000000', 'consum', 0.0227, 'lps'),
	(506566, 131, '2014-01-15 00:39:17.000000', 'consum', 0.0222, 'lps'),
	(506567, 131, '2014-01-15 00:39:18.000000', 'consum', 0.0219, 'lps'),
	(506568, 131, '2014-01-15 00:39:19.000000', 'consum', 0.0220, 'lps'),
	(506569, 131, '2014-01-15 00:39:20.000000', 'consum', 0.0212, 'lps'),
	(506570, 131, '2014-01-15 00:39:21.000000', 'consum', 0.0213, 'lps'),
	(506571, 131, '2014-01-15 00:39:22.000000', 'consum', 0.0219, 'lps'),
	(506572, 131, '2014-01-15 00:39:23.000000', 'consum', 0.0223, 'lps'),
	(506573, 131, '2014-01-15 00:39:24.000000', 'consum', 0.0229, 'lps'),
	(506574, 131, '2014-01-15 00:39:25.000000', 'consum', 0.0222, 'lps'),
	(506575, 131, '2014-01-15 00:39:26.000000', 'consum', 0.0213, 'lps'),
	(506576, 131, '2014-01-15 00:39:27.000000', 'consum', 0.0212, 'lps'),
	(506577, 131, '2014-01-15 00:39:28.000000', 'consum', 0.0210, 'lps'),
	(506578, 131, '2014-01-15 00:39:29.000000', 'consum', 0.0228, 'lps'),
	(506579, 131, '2014-01-15 00:39:30.000000', 'consum', 0.0211, 'lps'),
	(506580, 131, '2014-01-15 00:39:31.000000', 'consum', 0.0226, 'lps'),
	(506581, 131, '2014-01-15 00:39:32.000000', 'consum', 0.0225, 'lps'),
	(506582, 131, '2014-01-15 00:39:33.000000', 'consum', 0.0213, 'lps'),
	(506583, 131, '2014-01-15 00:39:34.000000', 'consum', 0.0225, 'lps'),
	(506584, 131, '2014-01-15 00:39:35.000000', 'consum', 0.0210, 'lps'),
	(506585, 131, '2014-01-15 00:39:36.000000', 'consum', 0.0211, 'lps'),
	(506586, 131, '2014-01-15 00:39:37.000000', 'consum', 0.0215, 'lps'),
	(506587, 131, '2014-01-15 00:39:38.000000', 'consum', 0.0210, 'lps'),
	(506588, 131, '2014-01-15 00:39:39.000000', 'consum', 0.0218, 'lps'),
	(506589, 131, '2014-01-15 00:39:40.000000', 'consum', 0.0229, 'lps'),
	(506590, 131, '2014-01-15 00:39:41.000000', 'consum', 0.0217, 'lps'),
	(506591, 131, '2014-01-15 00:39:42.000000', 'consum', 0.0229, 'lps'),
	(506592, 131, '2014-01-15 00:39:43.000000', 'consum', 0.0220, 'lps'),
	(506593, 131, '2014-01-15 00:39:44.000000', 'consum', 0.0225, 'lps'),
	(506594, 131, '2014-01-15 00:39:45.000000', 'consum', 0.0214, 'lps'),
	(506595, 131, '2014-01-15 00:39:46.000000', 'consum', 0.0226, 'lps'),
	(506596, 131, '2014-01-15 00:39:47.000000', 'consum', 0.0215, 'lps'),
	(506597, 131, '2014-01-15 00:39:48.000000', 'consum', 0.0230, 'lps'),
	(506598, 131, '2014-01-15 00:39:49.000000', 'consum', 0.0228, 'lps'),
	(506599, 131, '2014-01-15 00:39:50.000000', 'consum', 0.0220, 'lps'),
	(506600, 131, '2014-01-15 00:39:51.000000', 'consum', 0.0226, 'lps'),
	(506601, 131, '2014-01-15 00:39:52.000000', 'consum', 0.0220, 'lps'),
	(506602, 131, '2014-01-15 00:39:53.000000', 'consum', 0.0211, 'lps'),
	(506603, 131, '2014-01-15 00:39:54.000000', 'consum', 0.0228, 'lps'),
	(506604, 131, '2014-01-15 00:39:55.000000', 'consum', 0.0212, 'lps'),
	(506605, 131, '2014-01-15 00:39:56.000000', 'consum', 0.0231, 'lps'),
	(506606, 131, '2014-01-15 00:39:57.000000', 'consum', 0.0222, 'lps'),
	(506607, 131, '2014-01-15 00:39:58.000000', 'consum', 0.0231, 'lps'),
	(506608, 131, '2014-01-15 00:39:59.000000', 'consum', 0.0211, 'lps'),
	(506609, 131, '2014-01-15 00:40:00.000000', 'consum', 0.0221, 'lps'),
	(506610, 131, '2014-01-15 00:40:01.000000', 'consum', 0.0219, 'lps'),
	(506611, 131, '2014-01-15 00:40:02.000000', 'consum', 0.0222, 'lps'),
	(506612, 131, '2014-01-15 00:40:03.000000', 'consum', 0.0221, 'lps'),
	(506613, 131, '2014-01-15 00:40:04.000000', 'consum', 0.0231, 'lps'),
	(506614, 131, '2014-01-15 00:40:05.000000', 'consum', 0.0215, 'lps'),
	(506615, 131, '2014-01-15 00:40:06.000000', 'consum', 0.0218, 'lps'),
	(506616, 131, '2014-01-15 00:40:07.000000', 'consum', 0.0211, 'lps'),
	(506617, 131, '2014-01-15 00:40:08.000000', 'consum', 0.0214, 'lps'),
	(506618, 131, '2014-01-15 00:40:09.000000', 'consum', 0.0227, 'lps'),
	(506619, 131, '2014-01-15 00:40:10.000000', 'consum', 0.0216, 'lps'),
	(506620, 131, '2014-01-15 00:40:11.000000', 'consum', 0.0214, 'lps'),
	(506621, 131, '2014-01-15 00:40:12.000000', 'consum', 0.0213, 'lps'),
	(506622, 131, '2014-01-15 00:40:13.000000', 'consum', 0.0211, 'lps'),
	(506623, 131, '2014-01-15 00:40:14.000000', 'consum', 0.0230, 'lps'),
	(506624, 131, '2014-01-15 00:40:15.000000', 'consum', 0.0220, 'lps'),
	(506625, 131, '2014-01-15 00:40:16.000000', 'consum', 0.0223, 'lps'),
	(506626, 131, '2014-01-15 00:40:17.000000', 'consum', 0.0221, 'lps'),
	(506627, 131, '2014-01-15 00:40:18.000000', 'consum', 0.0227, 'lps'),
	(506628, 131, '2014-01-15 00:40:19.000000', 'consum', 0.0218, 'lps'),
	(506629, 131, '2014-01-15 00:40:20.000000', 'consum', 0.0223, 'lps'),
	(506630, 131, '2014-01-15 00:40:21.000000', 'consum', 0.0227, 'lps'),
	(506631, 131, '2014-01-15 00:40:22.000000', 'consum', 0.0215, 'lps'),
	(506632, 131, '2014-01-15 00:40:23.000000', 'consum', 0.0229, 'lps'),
	(506633, 131, '2014-01-15 00:40:24.000000', 'consum', 0.0225, 'lps'),
	(506634, 131, '2014-01-15 00:40:25.000000', 'consum', 0.0227, 'lps'),
	(506635, 131, '2014-01-15 00:40:26.000000', 'consum', 0.0230, 'lps'),
	(506636, 131, '2014-01-15 00:40:27.000000', 'consum', 0.0213, 'lps'),
	(506637, 131, '2014-01-15 00:40:28.000000', 'consum', 0.0231, 'lps'),
	(506638, 131, '2014-01-15 00:40:29.000000', 'consum', 0.0221, 'lps'),
	(506639, 131, '2014-01-15 00:40:30.000000', 'consum', 0.0226, 'lps'),
	(506640, 131, '2014-01-15 00:40:31.000000', 'consum', 0.0211, 'lps'),
	(506641, 131, '2014-01-15 00:40:32.000000', 'consum', 0.0210, 'lps'),
	(506642, 131, '2014-01-15 00:40:33.000000', 'consum', 0.0231, 'lps'),
	(506643, 131, '2014-01-15 00:40:34.000000', 'consum', 0.0229, 'lps'),
	(506644, 131, '2014-01-15 00:40:35.000000', 'consum', 0.0221, 'lps'),
	(506645, 131, '2014-01-15 00:40:36.000000', 'consum', 0.0231, 'lps'),
	(506646, 131, '2014-01-15 00:40:37.000000', 'consum', 0.0216, 'lps'),
	(506647, 131, '2014-01-15 00:40:38.000000', 'consum', 0.0222, 'lps'),
	(506648, 131, '2014-01-15 00:40:39.000000', 'consum', 0.0230, 'lps'),
	(506649, 131, '2014-01-15 00:40:40.000000', 'consum', 0.0229, 'lps'),
	(506650, 131, '2014-01-15 00:40:41.000000', 'consum', 0.0223, 'lps'),
	(506651, 131, '2014-01-15 00:40:42.000000', 'consum', 0.0221, 'lps'),
	(506652, 131, '2014-01-15 00:40:43.000000', 'consum', 0.0227, 'lps'),
	(506653, 131, '2014-01-15 00:40:44.000000', 'consum', 0.0215, 'lps'),
	(506654, 131, '2014-01-15 00:40:45.000000', 'consum', 0.0210, 'lps'),
	(506655, 131, '2014-01-15 00:40:46.000000', 'consum', 0.0216, 'lps'),
	(506656, 131, '2014-01-15 00:40:47.000000', 'consum', 0.0219, 'lps'),
	(506657, 131, '2014-01-15 00:40:48.000000', 'consum', 0.0217, 'lps'),
	(506658, 131, '2014-01-15 00:40:49.000000', 'consum', 0.0216, 'lps'),
	(506659, 131, '2014-01-15 00:40:50.000000', 'consum', 0.0220, 'lps'),
	(506660, 131, '2014-01-15 00:40:51.000000', 'consum', 0.0219, 'lps'),
	(506661, 131, '2014-01-15 00:40:52.000000', 'consum', 0.0226, 'lps'),
	(506662, 131, '2014-01-15 00:40:53.000000', 'consum', 0.0219, 'lps'),
	(506663, 131, '2014-01-15 00:40:54.000000', 'consum', 0.0228, 'lps'),
	(506664, 131, '2014-01-15 00:40:55.000000', 'consum', 0.0210, 'lps'),
	(506665, 131, '2014-01-15 00:40:56.000000', 'consum', 0.0222, 'lps'),
	(506666, 131, '2014-01-15 00:40:57.000000', 'consum', 0.0227, 'lps'),
	(506667, 131, '2014-01-15 00:40:58.000000', 'consum', 0.0215, 'lps'),
	(506668, 131, '2014-01-15 00:40:59.000000', 'consum', 0.0229, 'lps'),
	(506669, 131, '2014-01-15 00:41:00.000000', 'consum', 0.0223, 'lps'),
	(506670, 131, '2014-01-15 00:41:01.000000', 'consum', 0.0219, 'lps'),
	(506671, 131, '2014-01-15 00:41:02.000000', 'consum', 0.0215, 'lps'),
	(506672, 131, '2014-01-15 00:41:03.000000', 'consum', 0.0211, 'lps'),
	(506673, 131, '2014-01-15 00:41:04.000000', 'consum', 0.0220, 'lps'),
	(506674, 131, '2014-01-15 00:41:05.000000', 'consum', 0.0216, 'lps'),
	(506675, 131, '2014-01-15 00:41:06.000000', 'consum', 0.0231, 'lps'),
	(506676, 131, '2014-01-15 00:41:07.000000', 'consum', 0.0230, 'lps'),
	(506677, 131, '2014-01-15 00:41:08.000000', 'consum', 0.0229, 'lps'),
	(506678, 131, '2014-01-15 00:41:09.000000', 'consum', 0.0221, 'lps'),
	(506679, 131, '2014-01-15 00:41:10.000000', 'consum', 0.0230, 'lps'),
	(506680, 131, '2014-01-15 00:41:11.000000', 'consum', 0.0212, 'lps'),
	(506681, 131, '2014-01-15 00:41:12.000000', 'consum', 0.0226, 'lps'),
	(506682, 131, '2014-01-15 00:41:13.000000', 'consum', 0.0218, 'lps'),
	(506683, 131, '2014-01-15 00:41:14.000000', 'consum', 0.0226, 'lps'),
	(506684, 131, '2014-01-15 00:41:15.000000', 'consum', 0.0220, 'lps'),
	(506685, 131, '2014-01-15 00:41:16.000000', 'consum', 0.0215, 'lps'),
	(506686, 131, '2014-01-15 00:41:17.000000', 'consum', 0.0225, 'lps'),
	(506687, 131, '2014-01-15 00:41:18.000000', 'consum', 0.0228, 'lps'),
	(506688, 131, '2014-01-15 00:41:19.000000', 'consum', 0.0211, 'lps'),
	(506689, 131, '2014-01-15 00:41:20.000000', 'consum', 0.0227, 'lps'),
	(506690, 131, '2014-01-15 00:41:21.000000', 'consum', 0.0229, 'lps'),
	(506691, 131, '2014-01-15 00:41:22.000000', 'consum', 0.0230, 'lps'),
	(506692, 131, '2014-01-15 00:41:23.000000', 'consum', 0.0210, 'lps'),
	(506693, 131, '2014-01-15 00:41:24.000000', 'consum', 0.0215, 'lps'),
	(506694, 131, '2014-01-15 00:41:25.000000', 'consum', 0.0215, 'lps'),
	(506695, 131, '2014-01-15 00:41:26.000000', 'consum', 0.0219, 'lps'),
	(506696, 131, '2014-01-15 00:41:27.000000', 'consum', 0.0218, 'lps'),
	(506697, 131, '2014-01-15 00:41:28.000000', 'consum', 0.0223, 'lps'),
	(506698, 131, '2014-01-15 00:41:29.000000', 'consum', 0.0230, 'lps'),
	(506699, 131, '2014-01-15 00:41:30.000000', 'consum', 0.0229, 'lps'),
	(506700, 131, '2014-01-15 00:41:31.000000', 'consum', 0.0223, 'lps'),
	(506701, 131, '2014-01-15 00:41:32.000000', 'consum', 0.0219, 'lps'),
	(506702, 131, '2014-01-15 00:41:33.000000', 'consum', 0.0214, 'lps'),
	(506703, 131, '2014-01-15 00:41:34.000000', 'consum', 0.0229, 'lps'),
	(506704, 131, '2014-01-15 00:41:35.000000', 'consum', 0.0225, 'lps'),
	(506705, 131, '2014-01-15 00:41:36.000000', 'consum', 0.0231, 'lps'),
	(506706, 131, '2014-01-15 00:41:37.000000', 'consum', 0.0224, 'lps'),
	(506707, 131, '2014-01-15 00:41:38.000000', 'consum', 0.0219, 'lps'),
	(506708, 131, '2014-01-15 00:41:39.000000', 'consum', 0.0215, 'lps'),
	(506709, 131, '2014-01-15 00:41:40.000000', 'consum', 0.0227, 'lps'),
	(506710, 131, '2014-01-15 00:41:41.000000', 'consum', 0.0216, 'lps'),
	(506711, 131, '2014-01-15 00:41:42.000000', 'consum', 0.0213, 'lps'),
	(506712, 131, '2014-01-15 00:41:43.000000', 'consum', 0.0228, 'lps'),
	(506713, 131, '2014-01-15 00:41:44.000000', 'consum', 0.0225, 'lps'),
	(506714, 131, '2014-01-15 00:41:45.000000', 'consum', 0.0211, 'lps'),
	(506715, 131, '2014-01-15 00:41:46.000000', 'consum', 0.0216, 'lps'),
	(506716, 131, '2014-01-15 00:41:47.000000', 'consum', 0.0212, 'lps'),
	(506717, 131, '2014-01-15 00:41:48.000000', 'consum', 0.0225, 'lps'),
	(506718, 131, '2014-01-15 00:41:49.000000', 'consum', 0.0215, 'lps'),
	(506719, 131, '2014-01-15 00:41:50.000000', 'consum', 0.0214, 'lps'),
	(506720, 131, '2014-01-15 00:41:51.000000', 'consum', 0.0213, 'lps'),
	(506721, 131, '2014-01-15 00:41:52.000000', 'consum', 0.0216, 'lps'),
	(506722, 131, '2014-01-15 00:41:53.000000', 'consum', 0.0210, 'lps'),
	(506723, 131, '2014-01-15 00:41:54.000000', 'consum', 0.0212, 'lps'),
	(506724, 131, '2014-01-15 00:41:55.000000', 'consum', 0.0222, 'lps'),
	(506725, 131, '2014-01-15 00:41:56.000000', 'consum', 0.0219, 'lps'),
	(506726, 131, '2014-01-15 00:41:57.000000', 'consum', 0.0221, 'lps'),
	(506727, 131, '2014-01-15 00:41:58.000000', 'consum', 0.0216, 'lps'),
	(506728, 131, '2014-01-15 00:41:59.000000', 'consum', 0.0210, 'lps'),
	(506729, 131, '2014-01-15 00:42:00.000000', 'consum', 0.0211, 'lps'),
	(506730, 131, '2014-01-15 00:42:01.000000', 'consum', 0.0216, 'lps'),
	(506731, 131, '2014-01-15 00:42:02.000000', 'consum', 0.0218, 'lps'),
	(506732, 131, '2014-01-15 00:42:03.000000', 'consum', 0.0210, 'lps'),
	(506733, 131, '2014-01-15 00:42:04.000000', 'consum', 0.0229, 'lps'),
	(506734, 131, '2014-01-15 00:42:05.000000', 'consum', 0.0217, 'lps'),
	(506735, 131, '2014-01-15 00:42:06.000000', 'consum', 0.0212, 'lps'),
	(506736, 131, '2014-01-15 00:42:07.000000', 'consum', 0.0221, 'lps'),
	(506737, 131, '2014-01-15 00:42:08.000000', 'consum', 0.0215, 'lps'),
	(506738, 131, '2014-01-15 00:42:09.000000', 'consum', 0.0227, 'lps'),
	(506739, 131, '2014-01-15 00:42:10.000000', 'consum', 0.0212, 'lps'),
	(506740, 131, '2014-01-15 00:42:11.000000', 'consum', 0.0214, 'lps'),
	(506741, 131, '2014-01-15 00:42:12.000000', 'consum', 0.0225, 'lps'),
	(506742, 131, '2014-01-15 00:42:13.000000', 'consum', 0.0231, 'lps'),
	(506743, 131, '2014-01-15 00:42:14.000000', 'consum', 0.0225, 'lps'),
	(506744, 131, '2014-01-15 00:42:15.000000', 'consum', 0.0222, 'lps'),
	(506745, 131, '2014-01-15 00:42:16.000000', 'consum', 0.0227, 'lps'),
	(506746, 131, '2014-01-15 00:42:17.000000', 'consum', 0.0216, 'lps'),
	(506747, 131, '2014-01-15 00:42:18.000000', 'consum', 0.0231, 'lps'),
	(506748, 131, '2014-01-15 00:42:19.000000', 'consum', 0.0212, 'lps'),
	(506749, 131, '2014-01-15 00:42:20.000000', 'consum', 0.0223, 'lps'),
	(506750, 131, '2014-01-15 00:42:21.000000', 'consum', 0.0225, 'lps'),
	(506751, 131, '2014-01-15 00:42:22.000000', 'consum', 0.0223, 'lps'),
	(506752, 131, '2014-01-15 00:42:23.000000', 'consum', 0.0231, 'lps'),
	(506753, 131, '2014-01-15 00:42:24.000000', 'consum', 0.0231, 'lps'),
	(506754, 131, '2014-01-15 00:42:25.000000', 'consum', 0.0231, 'lps'),
	(506755, 131, '2014-01-15 00:42:26.000000', 'consum', 0.0211, 'lps'),
	(506756, 131, '2014-01-15 00:42:27.000000', 'consum', 0.0216, 'lps'),
	(506757, 131, '2014-01-15 00:42:28.000000', 'consum', 0.0216, 'lps'),
	(506758, 131, '2014-01-15 00:42:29.000000', 'consum', 0.0222, 'lps'),
	(506759, 131, '2014-01-15 00:42:30.000000', 'consum', 0.0211, 'lps'),
	(506760, 131, '2014-01-15 00:42:31.000000', 'consum', 0.0222, 'lps'),
	(506761, 131, '2014-01-15 00:42:32.000000', 'consum', 0.0225, 'lps'),
	(506762, 131, '2014-01-15 00:42:33.000000', 'consum', 0.0225, 'lps'),
	(506763, 131, '2014-01-15 00:42:34.000000', 'consum', 0.0218, 'lps'),
	(506764, 131, '2014-01-15 00:42:35.000000', 'consum', 0.0228, 'lps'),
	(506765, 131, '2014-01-15 00:42:36.000000', 'consum', 0.0213, 'lps'),
	(506766, 131, '2014-01-15 00:42:37.000000', 'consum', 0.0213, 'lps'),
	(506767, 131, '2014-01-15 00:42:38.000000', 'consum', 0.0218, 'lps'),
	(506768, 131, '2014-01-15 00:42:39.000000', 'consum', 0.0218, 'lps'),
	(506769, 131, '2014-01-15 00:42:40.000000', 'consum', 0.0225, 'lps'),
	(506770, 131, '2014-01-15 00:42:41.000000', 'consum', 0.0221, 'lps'),
	(506771, 131, '2014-01-15 00:42:42.000000', 'consum', 0.0218, 'lps'),
	(506772, 131, '2014-01-15 00:42:43.000000', 'consum', 0.0218, 'lps'),
	(506773, 131, '2014-01-15 00:42:44.000000', 'consum', 0.0226, 'lps'),
	(506774, 131, '2014-01-15 00:42:45.000000', 'consum', 0.0222, 'lps'),
	(506775, 131, '2014-01-15 00:42:46.000000', 'consum', 0.0224, 'lps'),
	(506776, 131, '2014-01-15 00:42:47.000000', 'consum', 0.0224, 'lps'),
	(506777, 131, '2014-01-15 00:42:48.000000', 'consum', 0.0214, 'lps'),
	(506778, 131, '2014-01-15 00:42:49.000000', 'consum', 0.0212, 'lps'),
	(506779, 131, '2014-01-15 00:42:50.000000', 'consum', 0.0228, 'lps'),
	(506780, 131, '2014-01-15 00:42:51.000000', 'consum', 0.0230, 'lps'),
	(506781, 131, '2014-01-15 00:42:52.000000', 'consum', 0.0214, 'lps'),
	(506782, 131, '2014-01-15 00:42:53.000000', 'consum', 0.0214, 'lps'),
	(506783, 131, '2014-01-15 00:42:54.000000', 'consum', 0.0216, 'lps'),
	(506784, 131, '2014-01-15 00:42:55.000000', 'consum', 0.0210, 'lps'),
	(506785, 131, '2014-01-15 00:42:56.000000', 'consum', 0.0213, 'lps'),
	(506786, 131, '2014-01-15 00:42:57.000000', 'consum', 0.0224, 'lps'),
	(506787, 131, '2014-01-15 00:42:58.000000', 'consum', 0.0226, 'lps'),
	(506788, 131, '2014-01-15 00:42:59.000000', 'consum', 0.0230, 'lps'),
	(506789, 131, '2014-01-15 00:43:00.000000', 'consum', 0.0218, 'lps'),
	(506790, 131, '2014-01-15 00:43:01.000000', 'consum', 0.0213, 'lps'),
	(506791, 131, '2014-01-15 00:43:02.000000', 'consum', 0.0222, 'lps'),
	(506792, 131, '2014-01-15 00:43:03.000000', 'consum', 0.0217, 'lps'),
	(506793, 131, '2014-01-15 00:43:04.000000', 'consum', 0.0212, 'lps'),
	(506794, 131, '2014-01-15 00:43:05.000000', 'consum', 0.0222, 'lps'),
	(506795, 131, '2014-01-15 00:43:06.000000', 'consum', 0.0219, 'lps'),
	(506796, 131, '2014-01-15 00:43:07.000000', 'consum', 0.0221, 'lps'),
	(506797, 131, '2014-01-15 00:43:08.000000', 'consum', 0.0215, 'lps'),
	(506798, 131, '2014-01-15 00:43:09.000000', 'consum', 0.0223, 'lps'),
	(506799, 131, '2014-01-15 00:43:10.000000', 'consum', 0.0217, 'lps'),
	(506800, 131, '2014-01-15 00:43:11.000000', 'consum', 0.0230, 'lps'),
	(506801, 131, '2014-01-15 00:43:12.000000', 'consum', 0.0223, 'lps'),
	(506802, 131, '2014-01-15 00:43:13.000000', 'consum', 0.0215, 'lps'),
	(506803, 131, '2014-01-15 00:43:14.000000', 'consum', 0.0217, 'lps'),
	(506804, 131, '2014-01-15 00:43:15.000000', 'consum', 0.0212, 'lps'),
	(506805, 131, '2014-01-15 00:43:16.000000', 'consum', 0.0219, 'lps'),
	(506806, 131, '2014-01-15 00:43:17.000000', 'consum', 0.0227, 'lps'),
	(506807, 131, '2014-01-15 00:43:18.000000', 'consum', 0.0225, 'lps'),
	(506808, 131, '2014-01-15 00:43:19.000000', 'consum', 0.0213, 'lps'),
	(506809, 131, '2014-01-15 00:43:20.000000', 'consum', 0.0223, 'lps'),
	(506810, 131, '2014-01-15 00:43:21.000000', 'consum', 0.0223, 'lps'),
	(506811, 131, '2014-01-15 00:43:22.000000', 'consum', 0.0216, 'lps'),
	(506812, 131, '2014-01-15 00:43:23.000000', 'consum', 0.0224, 'lps'),
	(506813, 131, '2014-01-15 00:43:24.000000', 'consum', 0.0219, 'lps'),
	(506814, 131, '2014-01-15 00:43:25.000000', 'consum', 0.0213, 'lps'),
	(506815, 131, '2014-01-15 00:43:26.000000', 'consum', 0.0221, 'lps'),
	(506816, 131, '2014-01-15 00:43:27.000000', 'consum', 0.0213, 'lps'),
	(506817, 131, '2014-01-15 00:43:28.000000', 'consum', 0.0215, 'lps'),
	(506818, 131, '2014-01-15 00:43:29.000000', 'consum', 0.0225, 'lps'),
	(506819, 131, '2014-01-15 00:43:30.000000', 'consum', 0.0228, 'lps'),
	(506820, 131, '2014-01-15 00:43:31.000000', 'consum', 0.0212, 'lps'),
	(506821, 131, '2014-01-15 00:43:32.000000', 'consum', 0.0231, 'lps'),
	(506822, 131, '2014-01-15 00:43:33.000000', 'consum', 0.0223, 'lps'),
	(506823, 131, '2014-01-15 00:43:34.000000', 'consum', 0.0211, 'lps'),
	(506824, 131, '2014-01-15 00:43:35.000000', 'consum', 0.0219, 'lps'),
	(506825, 131, '2014-01-15 00:43:36.000000', 'consum', 0.0210, 'lps'),
	(506826, 131, '2014-01-15 00:43:37.000000', 'consum', 0.0230, 'lps'),
	(506827, 131, '2014-01-15 00:43:38.000000', 'consum', 0.0219, 'lps'),
	(506828, 131, '2014-01-15 00:43:39.000000', 'consum', 0.0218, 'lps'),
	(506829, 131, '2014-01-15 00:43:40.000000', 'consum', 0.0226, 'lps'),
	(506830, 131, '2014-01-15 00:43:41.000000', 'consum', 0.0221, 'lps'),
	(506831, 131, '2014-01-15 00:43:42.000000', 'consum', 0.0218, 'lps'),
	(506832, 131, '2014-01-15 00:43:43.000000', 'consum', 0.0219, 'lps'),
	(506833, 131, '2014-01-15 00:43:44.000000', 'consum', 0.0231, 'lps'),
	(506834, 131, '2014-01-15 00:43:45.000000', 'consum', 0.0220, 'lps'),
	(506835, 131, '2014-01-15 00:43:46.000000', 'consum', 0.0222, 'lps'),
	(506836, 131, '2014-01-15 00:43:47.000000', 'consum', 0.0217, 'lps'),
	(506837, 131, '2014-01-15 00:43:48.000000', 'consum', 0.0210, 'lps'),
	(506838, 131, '2014-01-15 00:43:49.000000', 'consum', 0.0211, 'lps'),
	(506839, 131, '2014-01-15 00:43:50.000000', 'consum', 0.0215, 'lps'),
	(506840, 131, '2014-01-15 00:43:51.000000', 'consum', 0.0212, 'lps'),
	(506841, 131, '2014-01-15 00:43:52.000000', 'consum', 0.0227, 'lps'),
	(506842, 131, '2014-01-15 00:43:53.000000', 'consum', 0.0224, 'lps'),
	(506843, 131, '2014-01-15 00:43:54.000000', 'consum', 0.0231, 'lps'),
	(506844, 131, '2014-01-15 00:43:55.000000', 'consum', 0.0228, 'lps'),
	(506845, 131, '2014-01-15 00:43:56.000000', 'consum', 0.0215, 'lps'),
	(506846, 131, '2014-01-15 00:43:57.000000', 'consum', 0.0227, 'lps'),
	(506847, 131, '2014-01-15 00:43:58.000000', 'consum', 0.0212, 'lps'),
	(506848, 131, '2014-01-15 00:43:59.000000', 'consum', 0.0215, 'lps'),
	(506849, 131, '2014-01-15 00:44:00.000000', 'consum', 0.0230, 'lps'),
	(506850, 131, '2014-01-15 00:44:01.000000', 'consum', 0.0230, 'lps'),
	(506851, 131, '2014-01-15 00:44:02.000000', 'consum', 0.0226, 'lps'),
	(506852, 131, '2014-01-15 00:44:03.000000', 'consum', 0.0212, 'lps'),
	(506853, 131, '2014-01-15 00:44:04.000000', 'consum', 0.0214, 'lps'),
	(506854, 131, '2014-01-15 00:44:05.000000', 'consum', 0.0227, 'lps'),
	(506855, 131, '2014-01-15 00:44:06.000000', 'consum', 0.0216, 'lps'),
	(506856, 131, '2014-01-15 00:44:07.000000', 'consum', 0.0211, 'lps'),
	(506857, 131, '2014-01-15 00:44:08.000000', 'consum', 0.0219, 'lps'),
	(506858, 131, '2014-01-15 00:44:09.000000', 'consum', 0.0211, 'lps'),
	(506859, 131, '2014-01-15 00:44:10.000000', 'consum', 0.0210, 'lps'),
	(506860, 131, '2014-01-15 00:44:11.000000', 'consum', 0.0227, 'lps'),
	(506861, 131, '2014-01-15 00:44:12.000000', 'consum', 0.0210, 'lps'),
	(506862, 131, '2014-01-15 00:44:13.000000', 'consum', 0.0224, 'lps'),
	(506863, 131, '2014-01-15 00:44:14.000000', 'consum', 0.0213, 'lps'),
	(506864, 131, '2014-01-15 00:44:15.000000', 'consum', 0.0230, 'lps'),
	(506865, 131, '2014-01-15 00:44:16.000000', 'consum', 0.0211, 'lps'),
	(506866, 131, '2014-01-15 00:44:17.000000', 'consum', 0.0224, 'lps'),
	(506867, 131, '2014-01-15 00:44:18.000000', 'consum', 0.0210, 'lps'),
	(506868, 131, '2014-01-15 00:44:19.000000', 'consum', 0.0212, 'lps'),
	(506869, 131, '2014-01-15 00:44:20.000000', 'consum', 0.0219, 'lps'),
	(506870, 131, '2014-01-15 00:44:21.000000', 'consum', 0.0229, 'lps'),
	(506871, 131, '2014-01-15 00:44:22.000000', 'consum', 0.0213, 'lps'),
	(506872, 131, '2014-01-15 00:44:23.000000', 'consum', 0.0213, 'lps'),
	(506873, 131, '2014-01-15 00:44:24.000000', 'consum', 0.0217, 'lps'),
	(506874, 131, '2014-01-15 00:44:25.000000', 'consum', 0.0213, 'lps'),
	(506875, 131, '2014-01-15 00:44:26.000000', 'consum', 0.0228, 'lps'),
	(506876, 131, '2014-01-15 00:44:27.000000', 'consum', 0.0224, 'lps'),
	(506877, 131, '2014-01-15 00:44:28.000000', 'consum', 0.0228, 'lps'),
	(506878, 131, '2014-01-15 00:44:29.000000', 'consum', 0.0212, 'lps'),
	(506879, 131, '2014-01-15 00:44:30.000000', 'consum', 0.0213, 'lps'),
	(506880, 131, '2014-01-15 00:44:31.000000', 'consum', 0.0217, 'lps'),
	(506881, 131, '2014-01-15 00:44:32.000000', 'consum', 0.0214, 'lps'),
	(506882, 131, '2014-01-15 00:44:33.000000', 'consum', 0.0210, 'lps'),
	(506883, 131, '2014-01-15 00:44:34.000000', 'consum', 0.0221, 'lps'),
	(506884, 131, '2014-01-15 00:44:35.000000', 'consum', 0.0219, 'lps'),
	(506885, 131, '2014-01-15 00:44:36.000000', 'consum', 0.0226, 'lps'),
	(506886, 131, '2014-01-15 00:44:37.000000', 'consum', 0.0217, 'lps'),
	(506887, 131, '2014-01-15 00:44:38.000000', 'consum', 0.0222, 'lps'),
	(506888, 131, '2014-01-15 00:44:39.000000', 'consum', 0.0228, 'lps'),
	(506889, 131, '2014-01-15 00:44:40.000000', 'consum', 0.0221, 'lps'),
	(506890, 131, '2014-01-15 00:44:41.000000', 'consum', 0.0211, 'lps'),
	(506891, 131, '2014-01-15 00:44:42.000000', 'consum', 0.0224, 'lps'),
	(506892, 131, '2014-01-15 00:44:43.000000', 'consum', 0.0215, 'lps'),
	(506893, 131, '2014-01-15 00:44:44.000000', 'consum', 0.0213, 'lps'),
	(506894, 131, '2014-01-15 00:44:45.000000', 'consum', 0.0212, 'lps'),
	(506895, 131, '2014-01-15 00:44:46.000000', 'consum', 0.0212, 'lps'),
	(506896, 131, '2014-01-15 00:44:47.000000', 'consum', 0.0214, 'lps'),
	(506897, 131, '2014-01-15 00:44:48.000000', 'consum', 0.0222, 'lps'),
	(506898, 131, '2014-01-15 00:44:49.000000', 'consum', 0.0218, 'lps'),
	(506899, 131, '2014-01-15 00:44:50.000000', 'consum', 0.0214, 'lps'),
	(506900, 131, '2014-01-15 00:44:51.000000', 'consum', 0.0228, 'lps'),
	(506901, 131, '2014-01-15 00:44:52.000000', 'consum', 0.0222, 'lps'),
	(506902, 131, '2014-01-15 00:44:53.000000', 'consum', 0.0215, 'lps'),
	(506903, 131, '2014-01-15 00:44:54.000000', 'consum', 0.0224, 'lps'),
	(506904, 131, '2014-01-15 00:44:55.000000', 'consum', 0.0221, 'lps'),
	(506905, 131, '2014-01-15 00:44:56.000000', 'consum', 0.0224, 'lps'),
	(506906, 131, '2014-01-15 00:44:57.000000', 'consum', 0.0224, 'lps'),
	(506907, 131, '2014-01-15 00:44:58.000000', 'consum', 0.0218, 'lps'),
	(506908, 131, '2014-01-15 00:44:59.000000', 'consum', 0.0230, 'lps'),
	(506909, 131, '2014-01-15 00:45:00.000000', 'consum', 0.0219, 'lps'),
	(506910, 131, '2014-01-15 00:45:01.000000', 'consum', 0.0219, 'lps'),
	(506911, 131, '2014-01-15 00:45:02.000000', 'consum', 0.0228, 'lps'),
	(506912, 131, '2014-01-15 00:45:03.000000', 'consum', 0.0228, 'lps'),
	(506913, 131, '2014-01-15 00:45:04.000000', 'consum', 0.0227, 'lps'),
	(506914, 131, '2014-01-15 00:45:05.000000', 'consum', 0.0218, 'lps'),
	(506915, 131, '2014-01-15 00:45:06.000000', 'consum', 0.0222, 'lps'),
	(506916, 131, '2014-01-15 00:45:07.000000', 'consum', 0.0224, 'lps'),
	(506917, 131, '2014-01-15 00:45:08.000000', 'consum', 0.0224, 'lps'),
	(506918, 131, '2014-01-15 00:45:09.000000', 'consum', 0.0214, 'lps'),
	(506919, 131, '2014-01-15 00:45:10.000000', 'consum', 0.0210, 'lps'),
	(506920, 131, '2014-01-15 00:45:11.000000', 'consum', 0.0222, 'lps'),
	(506921, 131, '2014-01-15 00:45:12.000000', 'consum', 0.0227, 'lps'),
	(506922, 131, '2014-01-15 00:45:13.000000', 'consum', 0.0216, 'lps'),
	(506923, 131, '2014-01-15 00:45:14.000000', 'consum', 0.0212, 'lps'),
	(506924, 131, '2014-01-15 00:45:15.000000', 'consum', 0.0225, 'lps'),
	(506925, 131, '2014-01-15 00:45:16.000000', 'consum', 0.0212, 'lps'),
	(506926, 131, '2014-01-15 00:45:17.000000', 'consum', 0.0220, 'lps'),
	(506927, 131, '2014-01-15 00:45:18.000000', 'consum', 0.0212, 'lps'),
	(506928, 131, '2014-01-15 00:45:19.000000', 'consum', 0.0210, 'lps'),
	(506929, 131, '2014-01-15 00:45:20.000000', 'consum', 0.0226, 'lps'),
	(506930, 131, '2014-01-15 00:45:21.000000', 'consum', 0.0225, 'lps'),
	(506931, 131, '2014-01-15 00:45:22.000000', 'consum', 0.0216, 'lps'),
	(506932, 131, '2014-01-15 00:45:23.000000', 'consum', 0.0216, 'lps'),
	(506933, 131, '2014-01-15 00:45:24.000000', 'consum', 0.0224, 'lps'),
	(506934, 131, '2014-01-15 00:45:25.000000', 'consum', 0.0220, 'lps'),
	(506935, 131, '2014-01-15 00:45:26.000000', 'consum', 0.0218, 'lps'),
	(506936, 131, '2014-01-15 00:45:27.000000', 'consum', 0.0220, 'lps'),
	(506937, 131, '2014-01-15 00:45:28.000000', 'consum', 0.0215, 'lps'),
	(506938, 131, '2014-01-15 00:45:29.000000', 'consum', 0.0229, 'lps'),
	(506939, 131, '2014-01-15 00:45:30.000000', 'consum', 0.0223, 'lps'),
	(506940, 131, '2014-01-15 00:45:31.000000', 'consum', 0.0220, 'lps'),
	(506941, 131, '2014-01-15 00:45:32.000000', 'consum', 0.0220, 'lps'),
	(506942, 131, '2014-01-15 00:45:33.000000', 'consum', 0.0229, 'lps'),
	(506943, 131, '2014-01-15 00:45:34.000000', 'consum', 0.0211, 'lps'),
	(506944, 131, '2014-01-15 00:45:35.000000', 'consum', 0.0226, 'lps'),
	(506945, 131, '2014-01-15 00:45:36.000000', 'consum', 0.0221, 'lps'),
	(506946, 131, '2014-01-15 00:45:37.000000', 'consum', 0.0218, 'lps'),
	(506947, 131, '2014-01-15 00:45:38.000000', 'consum', 0.0218, 'lps'),
	(506948, 131, '2014-01-15 00:45:39.000000', 'consum', 0.0227, 'lps'),
	(506949, 131, '2014-01-15 00:45:40.000000', 'consum', 0.0225, 'lps'),
	(506950, 131, '2014-01-15 00:45:41.000000', 'consum', 0.0213, 'lps'),
	(506951, 131, '2014-01-15 00:45:42.000000', 'consum', 0.0226, 'lps'),
	(506952, 131, '2014-01-15 00:45:43.000000', 'consum', 0.0213, 'lps'),
	(506953, 131, '2014-01-15 00:45:44.000000', 'consum', 0.0224, 'lps'),
	(506954, 131, '2014-01-15 00:45:45.000000', 'consum', 0.0226, 'lps'),
	(506955, 131, '2014-01-15 00:45:46.000000', 'consum', 0.0225, 'lps'),
	(506956, 131, '2014-01-15 00:45:47.000000', 'consum', 0.0217, 'lps'),
	(506957, 131, '2014-01-15 00:45:48.000000', 'consum', 0.0224, 'lps'),
	(506958, 131, '2014-01-15 00:45:49.000000', 'consum', 0.0216, 'lps'),
	(506959, 131, '2014-01-15 00:45:50.000000', 'consum', 0.0220, 'lps'),
	(506960, 131, '2014-01-15 00:45:51.000000', 'consum', 0.0221, 'lps'),
	(506961, 131, '2014-01-15 00:45:52.000000', 'consum', 0.0212, 'lps'),
	(506962, 131, '2014-01-15 00:45:53.000000', 'consum', 0.0231, 'lps'),
	(506963, 131, '2014-01-15 00:45:54.000000', 'consum', 0.0223, 'lps'),
	(506964, 131, '2014-01-15 00:45:55.000000', 'consum', 0.0212, 'lps'),
	(506965, 131, '2014-01-15 00:45:56.000000', 'consum', 0.0225, 'lps'),
	(506966, 131, '2014-01-15 00:45:57.000000', 'consum', 0.0215, 'lps'),
	(506967, 131, '2014-01-15 00:45:58.000000', 'consum', 0.0210, 'lps'),
	(506968, 131, '2014-01-15 00:45:59.000000', 'consum', 0.0219, 'lps'),
	(506969, 131, '2014-01-15 00:46:00.000000', 'consum', 0.0212, 'lps'),
	(506970, 131, '2014-01-15 00:46:01.000000', 'consum', 0.0215, 'lps'),
	(506971, 131, '2014-01-15 00:46:02.000000', 'consum', 0.0228, 'lps'),
	(506972, 131, '2014-01-15 00:46:03.000000', 'consum', 0.0220, 'lps'),
	(506973, 131, '2014-01-15 00:46:04.000000', 'consum', 0.0228, 'lps'),
	(506974, 131, '2014-01-15 00:46:05.000000', 'consum', 0.0228, 'lps'),
	(506975, 131, '2014-01-15 00:46:06.000000', 'consum', 0.0226, 'lps'),
	(506976, 131, '2014-01-15 00:46:07.000000', 'consum', 0.0212, 'lps'),
	(506977, 131, '2014-01-15 00:46:08.000000', 'consum', 0.0219, 'lps'),
	(506978, 131, '2014-01-15 00:46:09.000000', 'consum', 0.0227, 'lps'),
	(506979, 131, '2014-01-15 00:46:10.000000', 'consum', 0.0226, 'lps'),
	(506980, 131, '2014-01-15 00:46:11.000000', 'consum', 0.0216, 'lps'),
	(506981, 131, '2014-01-15 00:46:12.000000', 'consum', 0.0216, 'lps'),
	(506982, 131, '2014-01-15 00:46:13.000000', 'consum', 0.0220, 'lps'),
	(506983, 131, '2014-01-15 00:46:14.000000', 'consum', 0.0221, 'lps'),
	(506984, 131, '2014-01-15 00:46:15.000000', 'consum', 0.0213, 'lps'),
	(506985, 131, '2014-01-15 00:46:16.000000', 'consum', 0.0217, 'lps'),
	(506986, 131, '2014-01-15 00:46:17.000000', 'consum', 0.0211, 'lps'),
	(506987, 131, '2014-01-15 00:46:18.000000', 'consum', 0.0218, 'lps'),
	(506988, 131, '2014-01-15 00:46:19.000000', 'consum', 0.0227, 'lps'),
	(506989, 131, '2014-01-15 00:46:20.000000', 'consum', 0.0229, 'lps'),
	(506990, 131, '2014-01-15 00:46:21.000000', 'consum', 0.0229, 'lps'),
	(506991, 131, '2014-01-15 00:46:22.000000', 'consum', 0.0227, 'lps'),
	(506992, 131, '2014-01-15 00:46:23.000000', 'consum', 0.0219, 'lps'),
	(506993, 131, '2014-01-15 00:46:24.000000', 'consum', 0.0226, 'lps'),
	(506994, 131, '2014-01-15 00:46:25.000000', 'consum', 0.0217, 'lps'),
	(506995, 131, '2014-01-15 00:46:26.000000', 'consum', 0.0221, 'lps'),
	(506996, 131, '2014-01-15 00:46:27.000000', 'consum', 0.0224, 'lps'),
	(506997, 131, '2014-01-15 00:46:28.000000', 'consum', 0.0224, 'lps'),
	(506998, 131, '2014-01-15 00:46:29.000000', 'consum', 0.0216, 'lps'),
	(506999, 131, '2014-01-15 00:46:30.000000', 'consum', 0.0222, 'lps'),
	(507000, 131, '2014-01-15 00:46:31.000000', 'consum', 0.0230, 'lps'),
	(507001, 131, '2014-01-15 00:46:32.000000', 'consum', 0.0210, 'lps'),
	(507002, 131, '2014-01-15 00:46:33.000000', 'consum', 0.0214, 'lps'),
	(507003, 131, '2014-01-15 00:46:34.000000', 'consum', 0.0231, 'lps'),
	(507004, 131, '2014-01-15 00:46:35.000000', 'consum', 0.0214, 'lps'),
	(507005, 131, '2014-01-15 00:46:36.000000', 'consum', 0.0212, 'lps'),
	(507006, 131, '2014-01-15 00:46:37.000000', 'consum', 0.0231, 'lps'),
	(507007, 131, '2014-01-15 00:46:38.000000', 'consum', 0.0221, 'lps'),
	(507008, 131, '2014-01-15 00:46:39.000000', 'consum', 0.0224, 'lps'),
	(507009, 131, '2014-01-15 00:46:40.000000', 'consum', 0.0227, 'lps'),
	(507010, 131, '2014-01-15 00:46:41.000000', 'consum', 0.0211, 'lps'),
	(507011, 131, '2014-01-15 00:46:42.000000', 'consum', 0.0228, 'lps'),
	(507012, 131, '2014-01-15 00:46:43.000000', 'consum', 0.0230, 'lps'),
	(507013, 131, '2014-01-15 00:46:44.000000', 'consum', 0.0215, 'lps'),
	(507014, 131, '2014-01-15 00:46:45.000000', 'consum', 0.0217, 'lps'),
	(507015, 131, '2014-01-15 00:46:46.000000', 'consum', 0.0211, 'lps'),
	(507016, 131, '2014-01-15 00:46:47.000000', 'consum', 0.0214, 'lps'),
	(507017, 131, '2014-01-15 00:46:48.000000', 'consum', 0.0229, 'lps'),
	(507018, 131, '2014-01-15 00:46:49.000000', 'consum', 0.0229, 'lps'),
	(507019, 131, '2014-01-15 00:46:50.000000', 'consum', 0.0225, 'lps'),
	(507020, 131, '2014-01-15 00:46:51.000000', 'consum', 0.0230, 'lps'),
	(507021, 131, '2014-01-15 00:46:52.000000', 'consum', 0.0222, 'lps'),
	(507022, 131, '2014-01-15 00:46:53.000000', 'consum', 0.0212, 'lps'),
	(507023, 131, '2014-01-15 00:46:54.000000', 'consum', 0.0225, 'lps'),
	(507024, 131, '2014-01-15 00:46:55.000000', 'consum', 0.0213, 'lps'),
	(507025, 131, '2014-01-15 00:46:56.000000', 'consum', 0.0227, 'lps'),
	(507026, 131, '2014-01-15 00:46:57.000000', 'consum', 0.0218, 'lps'),
	(507027, 131, '2014-01-15 00:46:58.000000', 'consum', 0.0222, 'lps'),
	(507028, 131, '2014-01-15 00:46:59.000000', 'consum', 0.0223, 'lps'),
	(507029, 131, '2014-01-15 00:47:00.000000', 'consum', 0.0220, 'lps'),
	(507030, 131, '2014-01-15 00:47:01.000000', 'consum', 0.0219, 'lps'),
	(507031, 131, '2014-01-15 00:47:02.000000', 'consum', 0.0228, 'lps'),
	(507032, 131, '2014-01-15 00:47:03.000000', 'consum', 0.0228, 'lps'),
	(507033, 131, '2014-01-15 00:47:04.000000', 'consum', 0.0224, 'lps'),
	(507034, 131, '2014-01-15 00:47:05.000000', 'consum', 0.0227, 'lps'),
	(507035, 131, '2014-01-15 00:47:06.000000', 'consum', 0.0211, 'lps'),
	(507036, 131, '2014-01-15 00:47:07.000000', 'consum', 0.0228, 'lps'),
	(507037, 131, '2014-01-15 00:47:08.000000', 'consum', 0.0211, 'lps'),
	(507038, 131, '2014-01-15 00:47:09.000000', 'consum', 0.0229, 'lps'),
	(507039, 131, '2014-01-15 00:47:10.000000', 'consum', 0.0212, 'lps'),
	(507040, 131, '2014-01-15 00:47:11.000000', 'consum', 0.0210, 'lps'),
	(507041, 131, '2014-01-15 00:47:12.000000', 'consum', 0.0225, 'lps'),
	(507042, 131, '2014-01-15 00:47:13.000000', 'consum', 0.0219, 'lps'),
	(507043, 131, '2014-01-15 00:47:14.000000', 'consum', 0.0210, 'lps'),
	(507044, 131, '2014-01-15 00:47:15.000000', 'consum', 0.0227, 'lps'),
	(507045, 131, '2014-01-15 00:47:16.000000', 'consum', 0.0229, 'lps'),
	(507046, 131, '2014-01-15 00:47:17.000000', 'consum', 0.0210, 'lps'),
	(507047, 131, '2014-01-15 00:47:18.000000', 'consum', 0.0219, 'lps'),
	(507048, 131, '2014-01-15 00:47:19.000000', 'consum', 0.0211, 'lps'),
	(507049, 131, '2014-01-15 00:47:20.000000', 'consum', 0.0211, 'lps'),
	(507050, 131, '2014-01-15 00:47:21.000000', 'consum', 0.0212, 'lps'),
	(507051, 131, '2014-01-15 00:47:22.000000', 'consum', 0.0217, 'lps'),
	(507052, 131, '2014-01-15 00:47:23.000000', 'consum', 0.0217, 'lps'),
	(507053, 131, '2014-01-15 00:47:24.000000', 'consum', 0.0225, 'lps'),
	(507054, 131, '2014-01-15 00:47:25.000000', 'consum', 0.0222, 'lps'),
	(507055, 131, '2014-01-15 00:47:26.000000', 'consum', 0.0226, 'lps'),
	(507056, 131, '2014-01-15 00:47:27.000000', 'consum', 0.0210, 'lps'),
	(507057, 131, '2014-01-15 00:47:28.000000', 'consum', 0.0229, 'lps'),
	(507058, 131, '2014-01-15 00:47:29.000000', 'consum', 0.0219, 'lps'),
	(507059, 131, '2014-01-15 00:47:30.000000', 'consum', 0.0217, 'lps'),
	(507060, 131, '2014-01-15 00:47:31.000000', 'consum', 0.0221, 'lps'),
	(507061, 131, '2014-01-15 00:47:32.000000', 'consum', 0.0221, 'lps'),
	(507062, 131, '2014-01-15 00:47:33.000000', 'consum', 0.0213, 'lps'),
	(507063, 131, '2014-01-15 00:47:34.000000', 'consum', 0.0214, 'lps'),
	(507064, 131, '2014-01-15 00:47:35.000000', 'consum', 0.0219, 'lps'),
	(507065, 131, '2014-01-15 00:47:36.000000', 'consum', 0.0223, 'lps'),
	(507066, 131, '2014-01-15 00:47:37.000000', 'consum', 0.0226, 'lps'),
	(507067, 131, '2014-01-15 00:47:38.000000', 'consum', 0.0228, 'lps'),
	(507068, 131, '2014-01-15 00:47:39.000000', 'consum', 0.0212, 'lps'),
	(507069, 131, '2014-01-15 00:47:40.000000', 'consum', 0.0230, 'lps'),
	(507070, 131, '2014-01-15 00:47:41.000000', 'consum', 0.0216, 'lps'),
	(507071, 131, '2014-01-15 00:47:42.000000', 'consum', 0.0226, 'lps'),
	(507072, 131, '2014-01-15 00:47:43.000000', 'consum', 0.0229, 'lps'),
	(507073, 131, '2014-01-15 00:47:44.000000', 'consum', 0.0213, 'lps'),
	(507074, 131, '2014-01-15 00:47:45.000000', 'consum', 0.0212, 'lps'),
	(507075, 131, '2014-01-15 00:47:46.000000', 'consum', 0.0214, 'lps'),
	(507076, 131, '2014-01-15 00:47:47.000000', 'consum', 0.0221, 'lps'),
	(507077, 131, '2014-01-15 00:47:48.000000', 'consum', 0.0212, 'lps'),
	(507078, 131, '2014-01-15 00:47:49.000000', 'consum', 0.0210, 'lps'),
	(507079, 131, '2014-01-15 00:47:50.000000', 'consum', 0.0227, 'lps'),
	(507080, 131, '2014-01-15 00:47:51.000000', 'consum', 0.0228, 'lps'),
	(507081, 131, '2014-01-15 00:47:52.000000', 'consum', 0.0226, 'lps'),
	(507082, 131, '2014-01-15 00:47:53.000000', 'consum', 0.0216, 'lps'),
	(507083, 131, '2014-01-15 00:47:54.000000', 'consum', 0.0213, 'lps'),
	(507084, 131, '2014-01-15 00:47:55.000000', 'consum', 0.0231, 'lps'),
	(507085, 131, '2014-01-15 00:47:56.000000', 'consum', 0.0219, 'lps'),
	(507086, 131, '2014-01-15 00:47:57.000000', 'consum', 0.0213, 'lps'),
	(507087, 131, '2014-01-15 00:47:58.000000', 'consum', 0.0223, 'lps'),
	(507088, 131, '2014-01-15 00:47:59.000000', 'consum', 0.0222, 'lps'),
	(507089, 131, '2014-01-15 00:48:00.000000', 'consum', 0.0210, 'lps'),
	(507090, 131, '2014-01-15 00:48:01.000000', 'consum', 0.0218, 'lps'),
	(507091, 131, '2014-01-15 00:48:02.000000', 'consum', 0.0230, 'lps'),
	(507092, 131, '2014-01-15 00:48:03.000000', 'consum', 0.0221, 'lps'),
	(507093, 131, '2014-01-15 00:48:04.000000', 'consum', 0.0225, 'lps'),
	(507094, 131, '2014-01-15 00:48:05.000000', 'consum', 0.0230, 'lps'),
	(507095, 131, '2014-01-15 00:48:06.000000', 'consum', 0.0222, 'lps'),
	(507096, 131, '2014-01-15 00:48:07.000000', 'consum', 0.0211, 'lps'),
	(507097, 131, '2014-01-15 00:48:08.000000', 'consum', 0.0221, 'lps'),
	(507098, 131, '2014-01-15 00:48:09.000000', 'consum', 0.0222, 'lps'),
	(507099, 131, '2014-01-15 00:48:10.000000', 'consum', 0.0214, 'lps'),
	(507100, 131, '2014-01-15 00:48:11.000000', 'consum', 0.0218, 'lps'),
	(507101, 131, '2014-01-15 00:48:12.000000', 'consum', 0.0217, 'lps'),
	(507102, 131, '2014-01-15 00:48:13.000000', 'consum', 0.0220, 'lps'),
	(507103, 131, '2014-01-15 00:48:14.000000', 'consum', 0.0219, 'lps'),
	(507104, 131, '2014-01-15 00:48:15.000000', 'consum', 0.0226, 'lps'),
	(507105, 131, '2014-01-15 00:48:16.000000', 'consum', 0.0221, 'lps'),
	(507106, 131, '2014-01-15 00:48:17.000000', 'consum', 0.0214, 'lps'),
	(507107, 131, '2014-01-15 00:48:18.000000', 'consum', 0.0223, 'lps'),
	(507108, 131, '2014-01-15 00:48:19.000000', 'consum', 0.0217, 'lps'),
	(507109, 131, '2014-01-15 00:48:20.000000', 'consum', 0.0229, 'lps'),
	(507110, 131, '2014-01-15 00:48:21.000000', 'consum', 0.0217, 'lps'),
	(507111, 131, '2014-01-15 00:48:22.000000', 'consum', 0.0214, 'lps'),
	(507112, 131, '2014-01-15 00:48:23.000000', 'consum', 0.0229, 'lps'),
	(507113, 131, '2014-01-15 00:48:24.000000', 'consum', 0.0227, 'lps'),
	(507114, 131, '2014-01-15 00:48:25.000000', 'consum', 0.0217, 'lps'),
	(507115, 131, '2014-01-15 00:48:26.000000', 'consum', 0.0215, 'lps'),
	(507116, 131, '2014-01-15 00:48:27.000000', 'consum', 0.0216, 'lps'),
	(507117, 131, '2014-01-15 00:48:28.000000', 'consum', 0.0226, 'lps'),
	(507118, 131, '2014-01-15 00:48:29.000000', 'consum', 0.0230, 'lps'),
	(507119, 131, '2014-01-15 00:48:30.000000', 'consum', 0.0217, 'lps'),
	(507120, 131, '2014-01-15 00:48:31.000000', 'consum', 0.0230, 'lps'),
	(507121, 131, '2014-01-15 00:48:32.000000', 'consum', 0.0222, 'lps'),
	(507122, 131, '2014-01-15 00:48:33.000000', 'consum', 0.0211, 'lps'),
	(507123, 131, '2014-01-15 00:48:34.000000', 'consum', 0.0222, 'lps'),
	(507124, 131, '2014-01-15 00:48:35.000000', 'consum', 0.0223, 'lps'),
	(507125, 131, '2014-01-15 00:48:36.000000', 'consum', 0.0220, 'lps'),
	(507126, 131, '2014-01-15 00:48:37.000000', 'consum', 0.0220, 'lps'),
	(507127, 131, '2014-01-15 00:48:38.000000', 'consum', 0.0231, 'lps'),
	(507128, 131, '2014-01-15 00:48:39.000000', 'consum', 0.0222, 'lps'),
	(507129, 131, '2014-01-15 00:48:40.000000', 'consum', 0.0226, 'lps'),
	(507130, 131, '2014-01-15 00:48:41.000000', 'consum', 0.0211, 'lps'),
	(507131, 131, '2014-01-15 00:48:42.000000', 'consum', 0.0213, 'lps'),
	(507132, 131, '2014-01-15 00:48:43.000000', 'consum', 0.0221, 'lps'),
	(507133, 131, '2014-01-15 00:48:44.000000', 'consum', 0.0215, 'lps'),
	(507134, 131, '2014-01-15 00:48:45.000000', 'consum', 0.0222, 'lps'),
	(507135, 131, '2014-01-15 00:48:46.000000', 'consum', 0.0210, 'lps'),
	(507136, 131, '2014-01-15 00:48:47.000000', 'consum', 0.0221, 'lps'),
	(507137, 131, '2014-01-15 00:48:48.000000', 'consum', 0.0221, 'lps'),
	(507138, 131, '2014-01-15 00:48:49.000000', 'consum', 0.0230, 'lps'),
	(507139, 131, '2014-01-15 00:48:50.000000', 'consum', 0.0215, 'lps'),
	(507140, 131, '2014-01-15 00:48:51.000000', 'consum', 0.0219, 'lps'),
	(507141, 131, '2014-01-15 00:48:52.000000', 'consum', 0.0218, 'lps'),
	(507142, 131, '2014-01-15 00:48:53.000000', 'consum', 0.0222, 'lps'),
	(507143, 131, '2014-01-15 00:48:54.000000', 'consum', 0.0224, 'lps'),
	(507144, 131, '2014-01-15 00:48:55.000000', 'consum', 0.0226, 'lps'),
	(507145, 131, '2014-01-15 00:48:56.000000', 'consum', 0.0223, 'lps'),
	(507146, 131, '2014-01-15 00:48:57.000000', 'consum', 0.0229, 'lps'),
	(507147, 131, '2014-01-15 00:48:58.000000', 'consum', 0.0222, 'lps'),
	(507148, 131, '2014-01-15 00:48:59.000000', 'consum', 0.0214, 'lps'),
	(507149, 131, '2014-01-15 00:49:00.000000', 'consum', 0.0217, 'lps'),
	(507150, 131, '2014-01-15 00:49:01.000000', 'consum', 0.0231, 'lps'),
	(507151, 131, '2014-01-15 00:49:02.000000', 'consum', 0.0230, 'lps'),
	(507152, 131, '2014-01-15 00:49:03.000000', 'consum', 0.0226, 'lps'),
	(507153, 131, '2014-01-15 00:49:04.000000', 'consum', 0.0229, 'lps'),
	(507154, 131, '2014-01-15 00:49:05.000000', 'consum', 0.0212, 'lps'),
	(507155, 131, '2014-01-15 00:49:06.000000', 'consum', 0.0211, 'lps'),
	(507156, 131, '2014-01-15 00:49:07.000000', 'consum', 0.0228, 'lps'),
	(507157, 131, '2014-01-15 00:49:08.000000', 'consum', 0.0212, 'lps'),
	(507158, 131, '2014-01-15 00:49:09.000000', 'consum', 0.0210, 'lps'),
	(507159, 131, '2014-01-15 00:49:10.000000', 'consum', 0.0228, 'lps'),
	(507160, 131, '2014-01-15 00:49:11.000000', 'consum', 0.0212, 'lps'),
	(507161, 131, '2014-01-15 00:49:12.000000', 'consum', 0.0230, 'lps'),
	(507162, 131, '2014-01-15 00:49:13.000000', 'consum', 0.0219, 'lps'),
	(507163, 131, '2014-01-15 00:49:14.000000', 'consum', 0.0216, 'lps'),
	(507164, 131, '2014-01-15 00:49:15.000000', 'consum', 0.0213, 'lps'),
	(507165, 131, '2014-01-15 00:49:16.000000', 'consum', 0.0228, 'lps'),
	(507166, 131, '2014-01-15 00:49:17.000000', 'consum', 0.0228, 'lps'),
	(507167, 131, '2014-01-15 00:49:18.000000', 'consum', 0.0225, 'lps'),
	(507168, 131, '2014-01-15 00:49:19.000000', 'consum', 0.0231, 'lps'),
	(507169, 131, '2014-01-15 00:49:20.000000', 'consum', 0.0226, 'lps'),
	(507170, 131, '2014-01-15 00:49:21.000000', 'consum', 0.0226, 'lps'),
	(507171, 131, '2014-01-15 00:49:22.000000', 'consum', 0.0222, 'lps'),
	(507172, 131, '2014-01-15 00:49:23.000000', 'consum', 0.0221, 'lps'),
	(507173, 131, '2014-01-15 00:49:24.000000', 'consum', 0.0231, 'lps'),
	(507174, 131, '2014-01-15 00:49:25.000000', 'consum', 0.0218, 'lps'),
	(507175, 131, '2014-01-15 00:49:26.000000', 'consum', 0.0228, 'lps'),
	(507176, 131, '2014-01-15 00:49:27.000000', 'consum', 0.0214, 'lps'),
	(507177, 131, '2014-01-15 00:49:28.000000', 'consum', 0.0218, 'lps'),
	(507178, 131, '2014-01-15 00:49:29.000000', 'consum', 0.0217, 'lps'),
	(507179, 131, '2014-01-15 00:49:30.000000', 'consum', 0.0221, 'lps'),
	(507180, 131, '2014-01-15 00:49:31.000000', 'consum', 0.0223, 'lps'),
	(507181, 131, '2014-01-15 00:49:32.000000', 'consum', 0.0222, 'lps'),
	(507182, 131, '2014-01-15 00:49:33.000000', 'consum', 0.0229, 'lps'),
	(507183, 131, '2014-01-15 00:49:34.000000', 'consum', 0.0228, 'lps'),
	(507184, 131, '2014-01-15 00:49:35.000000', 'consum', 0.0222, 'lps'),
	(507185, 131, '2014-01-15 00:49:36.000000', 'consum', 0.0217, 'lps'),
	(507186, 131, '2014-01-15 00:49:37.000000', 'consum', 0.0210, 'lps'),
	(507187, 131, '2014-01-15 00:49:38.000000', 'consum', 0.0210, 'lps'),
	(507188, 131, '2014-01-15 00:49:39.000000', 'consum', 0.0231, 'lps'),
	(507189, 131, '2014-01-15 00:49:40.000000', 'consum', 0.0230, 'lps'),
	(507190, 131, '2014-01-15 00:49:41.000000', 'consum', 0.0225, 'lps'),
	(507191, 131, '2014-01-15 00:49:42.000000', 'consum', 0.0224, 'lps'),
	(507192, 131, '2014-01-15 00:49:43.000000', 'consum', 0.0215, 'lps'),
	(507193, 131, '2014-01-15 00:49:44.000000', 'consum', 0.0217, 'lps'),
	(507194, 131, '2014-01-15 00:49:45.000000', 'consum', 0.0230, 'lps'),
	(507195, 131, '2014-01-15 00:49:46.000000', 'consum', 0.0221, 'lps'),
	(507196, 131, '2014-01-15 00:49:47.000000', 'consum', 0.0230, 'lps'),
	(507197, 131, '2014-01-15 00:49:48.000000', 'consum', 0.0211, 'lps'),
	(507198, 131, '2014-01-15 00:49:49.000000', 'consum', 0.0219, 'lps'),
	(507199, 131, '2014-01-15 00:49:50.000000', 'consum', 0.0212, 'lps'),
	(507200, 131, '2014-01-15 00:49:51.000000', 'consum', 0.0213, 'lps'),
	(507201, 131, '2014-01-15 00:49:52.000000', 'consum', 0.0218, 'lps'),
	(507202, 131, '2014-01-15 00:49:53.000000', 'consum', 0.0222, 'lps'),
	(507203, 131, '2014-01-15 00:49:54.000000', 'consum', 0.0225, 'lps'),
	(507204, 131, '2014-01-15 00:49:55.000000', 'consum', 0.0227, 'lps'),
	(507205, 131, '2014-01-15 00:49:56.000000', 'consum', 0.0227, 'lps'),
	(507206, 131, '2014-01-15 00:49:57.000000', 'consum', 0.0223, 'lps'),
	(507207, 131, '2014-01-15 00:49:58.000000', 'consum', 0.0225, 'lps'),
	(507208, 131, '2014-01-15 00:49:59.000000', 'consum', 0.0223, 'lps'),
	(507209, 131, '2014-01-15 00:50:00.000000', 'consum', 0.0210, 'lps'),
	(507210, 131, '2014-01-15 00:50:01.000000', 'consum', 0.0213, 'lps'),
	(507211, 131, '2014-01-15 00:50:02.000000', 'consum', 0.0227, 'lps'),
	(507212, 131, '2014-01-15 00:50:03.000000', 'consum', 0.0222, 'lps'),
	(507213, 131, '2014-01-15 00:50:04.000000', 'consum', 0.0220, 'lps'),
	(507214, 131, '2014-01-15 00:50:05.000000', 'consum', 0.0225, 'lps'),
	(507215, 131, '2014-01-15 00:50:06.000000', 'consum', 0.0211, 'lps'),
	(507216, 131, '2014-01-15 00:50:07.000000', 'consum', 0.0216, 'lps'),
	(507217, 131, '2014-01-15 00:50:08.000000', 'consum', 0.0215, 'lps'),
	(507218, 131, '2014-01-15 00:50:09.000000', 'consum', 0.0217, 'lps'),
	(507219, 131, '2014-01-15 00:50:10.000000', 'consum', 0.0229, 'lps'),
	(507220, 131, '2014-01-15 00:50:11.000000', 'consum', 0.0218, 'lps'),
	(507221, 131, '2014-01-15 00:50:12.000000', 'consum', 0.0215, 'lps'),
	(507222, 131, '2014-01-15 00:50:13.000000', 'consum', 0.0214, 'lps'),
	(507223, 131, '2014-01-15 00:50:14.000000', 'consum', 0.0216, 'lps'),
	(507224, 131, '2014-01-15 00:50:15.000000', 'consum', 0.0228, 'lps'),
	(507225, 131, '2014-01-15 00:50:16.000000', 'consum', 0.0217, 'lps'),
	(507226, 131, '2014-01-15 00:50:17.000000', 'consum', 0.0212, 'lps'),
	(507227, 131, '2014-01-15 00:50:18.000000', 'consum', 0.0223, 'lps'),
	(507228, 131, '2014-01-15 00:50:19.000000', 'consum', 0.0226, 'lps'),
	(507229, 131, '2014-01-15 00:50:20.000000', 'consum', 0.0229, 'lps'),
	(507230, 131, '2014-01-15 00:50:21.000000', 'consum', 0.0213, 'lps'),
	(507231, 131, '2014-01-15 00:50:22.000000', 'consum', 0.0212, 'lps'),
	(507232, 131, '2014-01-15 00:50:23.000000', 'consum', 0.0212, 'lps'),
	(507233, 131, '2014-01-15 00:50:24.000000', 'consum', 0.0214, 'lps'),
	(507234, 131, '2014-01-15 00:50:25.000000', 'consum', 0.0226, 'lps'),
	(507235, 131, '2014-01-15 00:50:26.000000', 'consum', 0.0212, 'lps'),
	(507236, 131, '2014-01-15 00:50:27.000000', 'consum', 0.0216, 'lps'),
	(507237, 131, '2014-01-15 00:50:28.000000', 'consum', 0.0213, 'lps'),
	(507238, 131, '2014-01-15 00:50:29.000000', 'consum', 0.0228, 'lps'),
	(507239, 131, '2014-01-15 00:50:30.000000', 'consum', 0.0224, 'lps'),
	(507240, 131, '2014-01-15 00:50:31.000000', 'consum', 0.0230, 'lps'),
	(507241, 131, '2014-01-15 00:50:32.000000', 'consum', 0.0223, 'lps'),
	(507242, 131, '2014-01-15 00:50:33.000000', 'consum', 0.0216, 'lps'),
	(507243, 131, '2014-01-15 00:50:34.000000', 'consum', 0.0223, 'lps'),
	(507244, 131, '2014-01-15 00:50:35.000000', 'consum', 0.0214, 'lps'),
	(507245, 131, '2014-01-15 00:50:36.000000', 'consum', 0.0215, 'lps'),
	(507246, 131, '2014-01-15 00:50:37.000000', 'consum', 0.0224, 'lps'),
	(507247, 131, '2014-01-15 00:50:38.000000', 'consum', 0.0218, 'lps'),
	(507248, 131, '2014-01-15 00:50:39.000000', 'consum', 0.0212, 'lps'),
	(507249, 131, '2014-01-15 00:50:40.000000', 'consum', 0.0216, 'lps'),
	(507250, 131, '2014-01-15 00:50:41.000000', 'consum', 0.0215, 'lps'),
	(507251, 131, '2014-01-15 00:50:42.000000', 'consum', 0.0216, 'lps'),
	(507252, 131, '2014-01-15 00:50:43.000000', 'consum', 0.0227, 'lps'),
	(507253, 131, '2014-01-15 00:50:44.000000', 'consum', 0.0213, 'lps'),
	(507254, 131, '2014-01-15 00:50:45.000000', 'consum', 0.0215, 'lps'),
	(507255, 131, '2014-01-15 00:50:46.000000', 'consum', 0.0229, 'lps'),
	(507256, 131, '2014-01-15 00:50:47.000000', 'consum', 0.0224, 'lps'),
	(507257, 131, '2014-01-15 00:50:48.000000', 'consum', 0.0222, 'lps'),
	(507258, 131, '2014-01-15 00:50:49.000000', 'consum', 0.0230, 'lps'),
	(507259, 131, '2014-01-15 00:50:50.000000', 'consum', 0.0210, 'lps'),
	(507260, 131, '2014-01-15 00:50:51.000000', 'consum', 0.0215, 'lps'),
	(507261, 131, '2014-01-15 00:50:52.000000', 'consum', 0.0212, 'lps'),
	(507262, 131, '2014-01-15 00:50:53.000000', 'consum', 0.0227, 'lps'),
	(507263, 131, '2014-01-15 00:50:54.000000', 'consum', 0.0223, 'lps'),
	(507264, 131, '2014-01-15 00:50:55.000000', 'consum', 0.0226, 'lps'),
	(507265, 131, '2014-01-15 00:50:56.000000', 'consum', 0.0229, 'lps'),
	(507266, 131, '2014-01-15 00:50:57.000000', 'consum', 0.0215, 'lps'),
	(507267, 131, '2014-01-15 00:50:58.000000', 'consum', 0.0222, 'lps'),
	(507268, 131, '2014-01-15 00:50:59.000000', 'consum', 0.0213, 'lps'),
	(507269, 131, '2014-01-15 00:51:00.000000', 'consum', 0.0211, 'lps'),
	(507270, 131, '2014-01-15 00:51:01.000000', 'consum', 0.0227, 'lps'),
	(507271, 131, '2014-01-15 00:51:02.000000', 'consum', 0.0229, 'lps'),
	(507272, 131, '2014-01-15 00:51:03.000000', 'consum', 0.0210, 'lps'),
	(507273, 131, '2014-01-15 00:51:04.000000', 'consum', 0.0218, 'lps'),
	(507274, 131, '2014-01-15 00:51:05.000000', 'consum', 0.0228, 'lps'),
	(507275, 131, '2014-01-15 00:51:06.000000', 'consum', 0.0211, 'lps'),
	(507276, 131, '2014-01-15 00:51:07.000000', 'consum', 0.0226, 'lps'),
	(507277, 131, '2014-01-15 00:51:08.000000', 'consum', 0.0222, 'lps'),
	(507278, 131, '2014-01-15 00:51:09.000000', 'consum', 0.0224, 'lps'),
	(507279, 131, '2014-01-15 00:51:10.000000', 'consum', 0.0220, 'lps'),
	(507280, 131, '2014-01-15 00:51:11.000000', 'consum', 0.0220, 'lps'),
	(507281, 131, '2014-01-15 00:51:12.000000', 'consum', 0.0230, 'lps'),
	(507282, 131, '2014-01-15 00:51:13.000000', 'consum', 0.0215, 'lps'),
	(507283, 131, '2014-01-15 00:51:14.000000', 'consum', 0.0217, 'lps'),
	(507284, 131, '2014-01-15 00:51:15.000000', 'consum', 0.0211, 'lps'),
	(507285, 131, '2014-01-15 00:51:16.000000', 'consum', 0.0217, 'lps'),
	(507286, 131, '2014-01-15 00:51:17.000000', 'consum', 0.0221, 'lps'),
	(507287, 131, '2014-01-15 00:51:18.000000', 'consum', 0.0222, 'lps'),
	(507288, 131, '2014-01-15 00:51:19.000000', 'consum', 0.0217, 'lps'),
	(507289, 131, '2014-01-15 00:51:20.000000', 'consum', 0.0229, 'lps'),
	(507290, 131, '2014-01-15 00:51:21.000000', 'consum', 0.0217, 'lps'),
	(507291, 131, '2014-01-15 00:51:22.000000', 'consum', 0.0214, 'lps'),
	(507292, 131, '2014-01-15 00:51:23.000000', 'consum', 0.0229, 'lps'),
	(507293, 131, '2014-01-15 00:51:24.000000', 'consum', 0.0227, 'lps'),
	(507294, 131, '2014-01-15 00:51:25.000000', 'consum', 0.0218, 'lps'),
	(507295, 131, '2014-01-15 00:51:26.000000', 'consum', 0.0221, 'lps'),
	(507296, 131, '2014-01-15 00:51:27.000000', 'consum', 0.0218, 'lps'),
	(507297, 131, '2014-01-15 00:51:28.000000', 'consum', 0.0220, 'lps'),
	(507298, 131, '2014-01-15 00:51:29.000000', 'consum', 0.0214, 'lps'),
	(507299, 131, '2014-01-15 00:51:30.000000', 'consum', 0.0224, 'lps'),
	(507300, 131, '2014-01-15 00:51:31.000000', 'consum', 0.0223, 'lps'),
	(507301, 131, '2014-01-15 00:51:32.000000', 'consum', 0.0211, 'lps'),
	(507302, 131, '2014-01-15 00:51:33.000000', 'consum', 0.0222, 'lps'),
	(507303, 131, '2014-01-15 00:51:34.000000', 'consum', 0.0225, 'lps'),
	(507304, 131, '2014-01-15 00:51:35.000000', 'consum', 0.0224, 'lps'),
	(507305, 131, '2014-01-15 00:51:36.000000', 'consum', 0.0216, 'lps'),
	(507306, 131, '2014-01-15 00:51:37.000000', 'consum', 0.0219, 'lps'),
	(507307, 131, '2014-01-15 00:51:38.000000', 'consum', 0.0215, 'lps'),
	(507308, 131, '2014-01-15 00:51:39.000000', 'consum', 0.0210, 'lps'),
	(507309, 131, '2014-01-15 00:51:40.000000', 'consum', 0.0217, 'lps'),
	(507310, 131, '2014-01-15 00:51:41.000000', 'consum', 0.0223, 'lps'),
	(507311, 131, '2014-01-15 00:51:42.000000', 'consum', 0.0211, 'lps'),
	(507312, 131, '2014-01-15 00:51:43.000000', 'consum', 0.0219, 'lps'),
	(507313, 131, '2014-01-15 00:51:44.000000', 'consum', 0.0231, 'lps'),
	(507314, 131, '2014-01-15 00:51:45.000000', 'consum', 0.0222, 'lps'),
	(507315, 131, '2014-01-15 00:51:46.000000', 'consum', 0.0228, 'lps'),
	(507316, 131, '2014-01-15 00:51:47.000000', 'consum', 0.0222, 'lps'),
	(507317, 131, '2014-01-15 00:51:48.000000', 'consum', 0.0215, 'lps'),
	(507318, 131, '2014-01-15 00:51:49.000000', 'consum', 0.0222, 'lps'),
	(507319, 131, '2014-01-15 00:51:50.000000', 'consum', 0.0211, 'lps'),
	(507320, 131, '2014-01-15 00:51:51.000000', 'consum', 0.0224, 'lps'),
	(507321, 131, '2014-01-15 00:51:52.000000', 'consum', 0.0213, 'lps'),
	(507322, 131, '2014-01-15 00:51:53.000000', 'consum', 0.0226, 'lps'),
	(507323, 131, '2014-01-15 00:51:54.000000', 'consum', 0.0215, 'lps'),
	(507324, 131, '2014-01-15 00:51:55.000000', 'consum', 0.0212, 'lps'),
	(507325, 131, '2014-01-15 00:51:56.000000', 'consum', 0.0224, 'lps'),
	(507326, 131, '2014-01-15 00:51:57.000000', 'consum', 0.0210, 'lps'),
	(507327, 131, '2014-01-15 00:51:58.000000', 'consum', 0.0213, 'lps'),
	(507328, 131, '2014-01-15 00:51:59.000000', 'consum', 0.0227, 'lps'),
	(507329, 131, '2014-01-15 00:52:00.000000', 'consum', 0.0218, 'lps'),
	(507330, 131, '2014-01-15 00:52:01.000000', 'consum', 0.0223, 'lps'),
	(507331, 131, '2014-01-15 00:52:02.000000', 'consum', 0.0227, 'lps'),
	(507332, 131, '2014-01-15 00:52:03.000000', 'consum', 0.0214, 'lps'),
	(507333, 131, '2014-01-15 00:52:04.000000', 'consum', 0.0222, 'lps'),
	(507334, 131, '2014-01-15 00:52:05.000000', 'consum', 0.0218, 'lps'),
	(507335, 131, '2014-01-15 00:52:06.000000', 'consum', 0.0211, 'lps'),
	(507336, 131, '2014-01-15 00:52:07.000000', 'consum', 0.0215, 'lps'),
	(507337, 131, '2014-01-15 00:52:08.000000', 'consum', 0.0212, 'lps'),
	(507338, 131, '2014-01-15 00:52:09.000000', 'consum', 0.0228, 'lps'),
	(507339, 131, '2014-01-15 00:52:10.000000', 'consum', 0.0227, 'lps'),
	(507340, 131, '2014-01-15 00:52:11.000000', 'consum', 0.0218, 'lps'),
	(507341, 131, '2014-01-15 00:52:12.000000', 'consum', 0.0223, 'lps'),
	(507342, 131, '2014-01-15 00:52:13.000000', 'consum', 0.0231, 'lps'),
	(507343, 131, '2014-01-15 00:52:14.000000', 'consum', 0.0230, 'lps'),
	(507344, 131, '2014-01-15 00:52:15.000000', 'consum', 0.0228, 'lps'),
	(507345, 131, '2014-01-15 00:52:16.000000', 'consum', 0.0219, 'lps'),
	(507346, 131, '2014-01-15 00:52:17.000000', 'consum', 0.0221, 'lps'),
	(507347, 131, '2014-01-15 00:52:18.000000', 'consum', 0.0219, 'lps'),
	(507348, 131, '2014-01-15 00:52:19.000000', 'consum', 0.0220, 'lps'),
	(507349, 131, '2014-01-15 00:52:20.000000', 'consum', 0.0213, 'lps'),
	(507350, 131, '2014-01-15 00:52:21.000000', 'consum', 0.0215, 'lps'),
	(507351, 131, '2014-01-15 00:52:22.000000', 'consum', 0.0230, 'lps'),
	(507352, 131, '2014-01-15 00:52:23.000000', 'consum', 0.0227, 'lps'),
	(507353, 131, '2014-01-15 00:52:24.000000', 'consum', 0.0212, 'lps'),
	(507354, 131, '2014-01-15 00:52:25.000000', 'consum', 0.0216, 'lps'),
	(507355, 131, '2014-01-15 00:52:26.000000', 'consum', 0.0212, 'lps'),
	(507356, 131, '2014-01-15 00:52:27.000000', 'consum', 0.0226, 'lps'),
	(507357, 131, '2014-01-15 00:52:28.000000', 'consum', 0.0216, 'lps'),
	(507358, 131, '2014-01-15 00:52:29.000000', 'consum', 0.0217, 'lps'),
	(507359, 131, '2014-01-15 00:52:30.000000', 'consum', 0.0225, 'lps'),
	(507360, 131, '2014-01-15 00:52:31.000000', 'consum', 0.0220, 'lps'),
	(507361, 131, '2014-01-15 00:52:32.000000', 'consum', 0.0215, 'lps'),
	(507362, 131, '2014-01-15 00:52:33.000000', 'consum', 0.0229, 'lps'),
	(507363, 131, '2014-01-15 00:52:34.000000', 'consum', 0.0225, 'lps'),
	(507364, 131, '2014-01-15 00:52:35.000000', 'consum', 0.0228, 'lps'),
	(507365, 131, '2014-01-15 00:52:36.000000', 'consum', 0.0213, 'lps'),
	(507366, 131, '2014-01-15 00:52:37.000000', 'consum', 0.0213, 'lps'),
	(507367, 131, '2014-01-15 00:52:38.000000', 'consum', 0.0218, 'lps'),
	(507368, 131, '2014-01-15 00:52:39.000000', 'consum', 0.0221, 'lps'),
	(507369, 131, '2014-01-15 00:52:40.000000', 'consum', 0.0218, 'lps'),
	(507370, 131, '2014-01-15 00:52:41.000000', 'consum', 0.0216, 'lps'),
	(507371, 131, '2014-01-15 00:52:42.000000', 'consum', 0.0218, 'lps'),
	(507372, 131, '2014-01-15 00:52:43.000000', 'consum', 0.0230, 'lps'),
	(507373, 131, '2014-01-15 00:52:44.000000', 'consum', 0.0224, 'lps'),
	(507374, 131, '2014-01-15 00:52:45.000000', 'consum', 0.0218, 'lps'),
	(507375, 131, '2014-01-15 00:52:46.000000', 'consum', 0.0230, 'lps'),
	(507376, 131, '2014-01-15 00:52:47.000000', 'consum', 0.0223, 'lps'),
	(507377, 131, '2014-01-15 00:52:48.000000', 'consum', 0.0215, 'lps'),
	(507378, 131, '2014-01-15 00:52:49.000000', 'consum', 0.0220, 'lps'),
	(507379, 131, '2014-01-15 00:52:50.000000', 'consum', 0.0221, 'lps'),
	(507380, 131, '2014-01-15 00:52:51.000000', 'consum', 0.0215, 'lps'),
	(507381, 131, '2014-01-15 00:52:52.000000', 'consum', 0.0225, 'lps'),
	(507382, 131, '2014-01-15 00:52:53.000000', 'consum', 0.0226, 'lps'),
	(507383, 131, '2014-01-15 00:52:54.000000', 'consum', 0.0224, 'lps'),
	(507384, 131, '2014-01-15 00:52:55.000000', 'consum', 0.0210, 'lps'),
	(507385, 131, '2014-01-15 00:52:56.000000', 'consum', 0.0211, 'lps'),
	(507386, 131, '2014-01-15 00:52:57.000000', 'consum', 0.0217, 'lps'),
	(507387, 131, '2014-01-15 00:52:58.000000', 'consum', 0.0220, 'lps'),
	(507388, 131, '2014-01-15 00:52:59.000000', 'consum', 0.0217, 'lps'),
	(507389, 131, '2014-01-15 00:53:00.000000', 'consum', 0.0217, 'lps'),
	(507390, 131, '2014-01-15 00:53:01.000000', 'consum', 0.0225, 'lps'),
	(507391, 131, '2014-01-15 00:53:02.000000', 'consum', 0.0221, 'lps'),
	(507392, 131, '2014-01-15 00:53:03.000000', 'consum', 0.0219, 'lps'),
	(507393, 131, '2014-01-15 00:53:04.000000', 'consum', 0.0225, 'lps'),
	(507394, 131, '2014-01-15 00:53:05.000000', 'consum', 0.0211, 'lps'),
	(507395, 131, '2014-01-15 00:53:06.000000', 'consum', 0.0217, 'lps'),
	(507396, 131, '2014-01-15 00:53:07.000000', 'consum', 0.0221, 'lps'),
	(507397, 131, '2014-01-15 00:53:08.000000', 'consum', 0.0222, 'lps'),
	(507398, 131, '2014-01-15 00:53:09.000000', 'consum', 0.0217, 'lps'),
	(507399, 131, '2014-01-15 00:53:10.000000', 'consum', 0.0231, 'lps'),
	(507400, 131, '2014-01-15 00:53:11.000000', 'consum', 0.0229, 'lps'),
	(507401, 131, '2014-01-15 00:53:12.000000', 'consum', 0.0219, 'lps'),
	(507402, 131, '2014-01-15 00:53:13.000000', 'consum', 0.0220, 'lps'),
	(507403, 131, '2014-01-15 00:53:14.000000', 'consum', 0.0212, 'lps'),
	(507404, 131, '2014-01-15 00:53:15.000000', 'consum', 0.0214, 'lps'),
	(507405, 131, '2014-01-15 00:53:16.000000', 'consum', 0.0224, 'lps'),
	(507406, 131, '2014-01-15 00:53:17.000000', 'consum', 0.0224, 'lps'),
	(507407, 131, '2014-01-15 00:53:18.000000', 'consum', 0.0217, 'lps'),
	(507408, 131, '2014-01-15 00:53:19.000000', 'consum', 0.0225, 'lps'),
	(507409, 131, '2014-01-15 00:53:20.000000', 'consum', 0.0222, 'lps'),
	(507410, 131, '2014-01-15 00:53:21.000000', 'consum', 0.0226, 'lps'),
	(507411, 131, '2014-01-15 00:53:22.000000', 'consum', 0.0210, 'lps'),
	(507412, 131, '2014-01-15 00:53:23.000000', 'consum', 0.0227, 'lps'),
	(507413, 131, '2014-01-15 00:53:24.000000', 'consum', 0.0210, 'lps'),
	(507414, 131, '2014-01-15 00:53:25.000000', 'consum', 0.0224, 'lps'),
	(507415, 131, '2014-01-15 00:53:26.000000', 'consum', 0.0217, 'lps'),
	(507416, 131, '2014-01-15 00:53:27.000000', 'consum', 0.0222, 'lps'),
	(507417, 131, '2014-01-15 00:53:28.000000', 'consum', 0.0230, 'lps'),
	(507418, 131, '2014-01-15 00:53:29.000000', 'consum', 0.0230, 'lps'),
	(507419, 131, '2014-01-15 00:53:30.000000', 'consum', 0.0229, 'lps'),
	(507420, 131, '2014-01-15 00:53:31.000000', 'consum', 0.0224, 'lps'),
	(507421, 131, '2014-01-15 00:53:32.000000', 'consum', 0.0222, 'lps'),
	(507422, 131, '2014-01-15 00:53:33.000000', 'consum', 0.0230, 'lps'),
	(507423, 131, '2014-01-15 00:53:34.000000', 'consum', 0.0228, 'lps'),
	(507424, 131, '2014-01-15 00:53:35.000000', 'consum', 0.0220, 'lps'),
	(507425, 131, '2014-01-15 00:53:36.000000', 'consum', 0.0227, 'lps'),
	(507426, 131, '2014-01-15 00:53:37.000000', 'consum', 0.0224, 'lps'),
	(507427, 131, '2014-01-15 00:53:38.000000', 'consum', 0.0230, 'lps'),
	(507428, 131, '2014-01-15 00:53:39.000000', 'consum', 0.0225, 'lps'),
	(507429, 131, '2014-01-15 00:53:40.000000', 'consum', 0.0224, 'lps'),
	(507430, 131, '2014-01-15 00:53:41.000000', 'consum', 0.0212, 'lps'),
	(507431, 131, '2014-01-15 00:53:42.000000', 'consum', 0.0224, 'lps'),
	(507432, 131, '2014-01-15 00:53:43.000000', 'consum', 0.0210, 'lps'),
	(507433, 131, '2014-01-15 00:53:44.000000', 'consum', 0.0231, 'lps'),
	(507434, 131, '2014-01-15 00:53:45.000000', 'consum', 0.0231, 'lps'),
	(507435, 131, '2014-01-15 00:53:46.000000', 'consum', 0.0229, 'lps'),
	(507436, 131, '2014-01-15 00:53:47.000000', 'consum', 0.0220, 'lps'),
	(507437, 131, '2014-01-15 00:53:48.000000', 'consum', 0.0225, 'lps'),
	(507438, 131, '2014-01-15 00:53:49.000000', 'consum', 0.0214, 'lps'),
	(507439, 131, '2014-01-15 00:53:50.000000', 'consum', 0.0228, 'lps'),
	(507440, 131, '2014-01-15 00:53:51.000000', 'consum', 0.0225, 'lps'),
	(507441, 131, '2014-01-15 00:53:52.000000', 'consum', 0.0229, 'lps'),
	(507442, 131, '2014-01-15 00:53:53.000000', 'consum', 0.0215, 'lps'),
	(507443, 131, '2014-01-15 00:53:54.000000', 'consum', 0.0226, 'lps'),
	(507444, 131, '2014-01-15 00:53:55.000000', 'consum', 0.0230, 'lps'),
	(507445, 131, '2014-01-15 00:53:56.000000', 'consum', 0.0219, 'lps'),
	(507446, 131, '2014-01-15 00:53:57.000000', 'consum', 0.0219, 'lps'),
	(507447, 131, '2014-01-15 00:53:58.000000', 'consum', 0.0225, 'lps'),
	(507448, 131, '2014-01-15 00:53:59.000000', 'consum', 0.0218, 'lps'),
	(507449, 131, '2014-01-15 00:54:00.000000', 'consum', 0.0227, 'lps'),
	(507450, 131, '2014-01-15 00:54:01.000000', 'consum', 0.0227, 'lps'),
	(507451, 131, '2014-01-15 00:54:02.000000', 'consum', 0.0221, 'lps'),
	(507452, 131, '2014-01-15 00:54:03.000000', 'consum', 0.0214, 'lps'),
	(507453, 131, '2014-01-15 00:54:04.000000', 'consum', 0.0219, 'lps'),
	(507454, 131, '2014-01-15 00:54:05.000000', 'consum', 0.0222, 'lps'),
	(507455, 131, '2014-01-15 00:54:06.000000', 'consum', 0.0220, 'lps'),
	(507456, 131, '2014-01-15 00:54:07.000000', 'consum', 0.0228, 'lps'),
	(507457, 131, '2014-01-15 00:54:08.000000', 'consum', 0.0223, 'lps'),
	(507458, 131, '2014-01-15 00:54:09.000000', 'consum', 0.0225, 'lps'),
	(507459, 131, '2014-01-15 00:54:10.000000', 'consum', 0.0223, 'lps'),
	(507460, 131, '2014-01-15 00:54:11.000000', 'consum', 0.0230, 'lps'),
	(507461, 131, '2014-01-15 00:54:12.000000', 'consum', 0.0229, 'lps'),
	(507462, 131, '2014-01-15 00:54:13.000000', 'consum', 0.0223, 'lps'),
	(507463, 131, '2014-01-15 00:54:14.000000', 'consum', 0.0218, 'lps'),
	(507464, 131, '2014-01-15 00:54:15.000000', 'consum', 0.0211, 'lps'),
	(507465, 131, '2014-01-15 00:54:16.000000', 'consum', 0.0212, 'lps'),
	(507466, 131, '2014-01-15 00:54:17.000000', 'consum', 0.0220, 'lps'),
	(507467, 131, '2014-01-15 00:54:18.000000', 'consum', 0.0210, 'lps'),
	(507468, 131, '2014-01-15 00:54:19.000000', 'consum', 0.0224, 'lps'),
	(507469, 131, '2014-01-15 00:54:20.000000', 'consum', 0.0214, 'lps'),
	(507470, 131, '2014-01-15 00:54:21.000000', 'consum', 0.0211, 'lps'),
	(507471, 131, '2014-01-15 00:54:22.000000', 'consum', 0.0224, 'lps'),
	(507472, 131, '2014-01-15 00:54:23.000000', 'consum', 0.0212, 'lps'),
	(507473, 131, '2014-01-15 00:54:24.000000', 'consum', 0.0223, 'lps'),
	(507474, 131, '2014-01-15 00:54:25.000000', 'consum', 0.0224, 'lps'),
	(507475, 131, '2014-01-15 00:54:26.000000', 'consum', 0.0219, 'lps'),
	(507476, 131, '2014-01-15 00:54:27.000000', 'consum', 0.0213, 'lps'),
	(507477, 131, '2014-01-15 00:54:28.000000', 'consum', 0.0220, 'lps'),
	(507478, 131, '2014-01-15 00:54:29.000000', 'consum', 0.0231, 'lps'),
	(507479, 131, '2014-01-15 00:54:30.000000', 'consum', 0.0219, 'lps'),
	(507480, 131, '2014-01-15 00:54:31.000000', 'consum', 0.0215, 'lps'),
	(507481, 131, '2014-01-15 00:54:32.000000', 'consum', 0.0210, 'lps'),
	(507482, 131, '2014-01-15 00:54:33.000000', 'consum', 0.0217, 'lps'),
	(507483, 131, '2014-01-15 00:54:34.000000', 'consum', 0.0223, 'lps'),
	(507484, 131, '2014-01-15 00:54:35.000000', 'consum', 0.0231, 'lps'),
	(507485, 131, '2014-01-15 00:54:36.000000', 'consum', 0.0213, 'lps'),
	(507486, 131, '2014-01-15 00:54:37.000000', 'consum', 0.0226, 'lps'),
	(507487, 131, '2014-01-15 00:54:38.000000', 'consum', 0.0218, 'lps'),
	(507488, 131, '2014-01-15 00:54:39.000000', 'consum', 0.0222, 'lps'),
	(507489, 131, '2014-01-15 00:54:40.000000', 'consum', 0.0226, 'lps'),
	(507490, 131, '2014-01-15 00:54:41.000000', 'consum', 0.0211, 'lps'),
	(507491, 131, '2014-01-15 00:54:42.000000', 'consum', 0.0212, 'lps'),
	(507492, 131, '2014-01-15 00:54:43.000000', 'consum', 0.0217, 'lps'),
	(507493, 131, '2014-01-15 00:54:44.000000', 'consum', 0.0219, 'lps'),
	(507494, 131, '2014-01-15 00:54:45.000000', 'consum', 0.0213, 'lps'),
	(507495, 131, '2014-01-15 00:54:46.000000', 'consum', 0.0220, 'lps'),
	(507496, 131, '2014-01-15 00:54:47.000000', 'consum', 0.0227, 'lps'),
	(507497, 131, '2014-01-15 00:54:48.000000', 'consum', 0.0225, 'lps'),
	(507498, 131, '2014-01-15 00:54:49.000000', 'consum', 0.0210, 'lps'),
	(507499, 131, '2014-01-15 00:54:50.000000', 'consum', 0.0210, 'lps'),
	(507500, 131, '2014-01-15 00:54:51.000000', 'consum', 0.0211, 'lps'),
	(507501, 131, '2014-01-15 00:54:52.000000', 'consum', 0.0214, 'lps'),
	(507502, 131, '2014-01-15 00:54:53.000000', 'consum', 0.0227, 'lps'),
	(507503, 131, '2014-01-15 00:54:54.000000', 'consum', 0.0220, 'lps'),
	(507504, 131, '2014-01-15 00:54:55.000000', 'consum', 0.0210, 'lps'),
	(507505, 131, '2014-01-15 00:54:56.000000', 'consum', 0.0223, 'lps'),
	(507506, 131, '2014-01-15 00:54:57.000000', 'consum', 0.0230, 'lps'),
	(507507, 131, '2014-01-15 00:54:58.000000', 'consum', 0.0231, 'lps'),
	(507508, 131, '2014-01-15 00:54:59.000000', 'consum', 0.0231, 'lps'),
	(507509, 131, '2014-01-15 00:55:00.000000', 'consum', 0.0210, 'lps'),
	(507510, 131, '2014-01-15 00:55:01.000000', 'consum', 0.0211, 'lps'),
	(507511, 131, '2014-01-15 00:55:02.000000', 'consum', 0.0216, 'lps'),
	(507512, 131, '2014-01-15 00:55:03.000000', 'consum', 0.0218, 'lps'),
	(507513, 131, '2014-01-15 00:55:04.000000', 'consum', 0.0231, 'lps'),
	(507514, 131, '2014-01-15 00:55:05.000000', 'consum', 0.0224, 'lps'),
	(507515, 131, '2014-01-15 00:55:06.000000', 'consum', 0.0217, 'lps'),
	(507516, 131, '2014-01-15 00:55:07.000000', 'consum', 0.0226, 'lps'),
	(507517, 131, '2014-01-15 00:55:08.000000', 'consum', 0.0227, 'lps'),
	(507518, 131, '2014-01-15 00:55:09.000000', 'consum', 0.0226, 'lps'),
	(507519, 131, '2014-01-15 00:55:10.000000', 'consum', 0.0219, 'lps'),
	(507520, 131, '2014-01-15 00:55:11.000000', 'consum', 0.0226, 'lps'),
	(507521, 131, '2014-01-15 00:55:12.000000', 'consum', 0.0220, 'lps'),
	(507522, 131, '2014-01-15 00:55:13.000000', 'consum', 0.0215, 'lps'),
	(507523, 131, '2014-01-15 00:55:14.000000', 'consum', 0.0227, 'lps'),
	(507524, 131, '2014-01-15 00:55:15.000000', 'consum', 0.0213, 'lps'),
	(507525, 131, '2014-01-15 00:55:16.000000', 'consum', 0.0221, 'lps'),
	(507526, 131, '2014-01-15 00:55:17.000000', 'consum', 0.0210, 'lps'),
	(507527, 131, '2014-01-15 00:55:18.000000', 'consum', 0.0224, 'lps'),
	(507528, 131, '2014-01-15 00:55:19.000000', 'consum', 0.0214, 'lps'),
	(507529, 131, '2014-01-15 00:55:20.000000', 'consum', 0.0231, 'lps'),
	(507530, 131, '2014-01-15 00:55:21.000000', 'consum', 0.0217, 'lps'),
	(507531, 131, '2014-01-15 00:55:22.000000', 'consum', 0.0226, 'lps'),
	(507532, 131, '2014-01-15 00:55:23.000000', 'consum', 0.0226, 'lps'),
	(507533, 131, '2014-01-15 00:55:24.000000', 'consum', 0.0222, 'lps'),
	(507534, 131, '2014-01-15 00:55:25.000000', 'consum', 0.0221, 'lps'),
	(507535, 131, '2014-01-15 00:55:26.000000', 'consum', 0.0229, 'lps'),
	(507536, 131, '2014-01-15 00:55:27.000000', 'consum', 0.0231, 'lps'),
	(507537, 131, '2014-01-15 00:55:28.000000', 'consum', 0.0213, 'lps'),
	(507538, 131, '2014-01-15 00:55:29.000000', 'consum', 0.0227, 'lps'),
	(507539, 131, '2014-01-15 00:55:30.000000', 'consum', 0.0220, 'lps'),
	(507540, 131, '2014-01-15 00:55:31.000000', 'consum', 0.0212, 'lps'),
	(507541, 131, '2014-01-15 00:55:32.000000', 'consum', 0.0214, 'lps'),
	(507542, 131, '2014-01-15 00:55:33.000000', 'consum', 0.0221, 'lps'),
	(507543, 131, '2014-01-15 00:55:34.000000', 'consum', 0.0210, 'lps'),
	(507544, 131, '2014-01-15 00:55:35.000000', 'consum', 0.0223, 'lps'),
	(507545, 131, '2014-01-15 00:55:36.000000', 'consum', 0.0211, 'lps'),
	(507546, 131, '2014-01-15 00:55:37.000000', 'consum', 0.0218, 'lps'),
	(507547, 131, '2014-01-15 00:55:38.000000', 'consum', 0.0227, 'lps'),
	(507548, 131, '2014-01-15 00:55:39.000000', 'consum', 0.0227, 'lps'),
	(507549, 131, '2014-01-15 00:55:40.000000', 'consum', 0.0224, 'lps'),
	(507550, 131, '2014-01-15 00:55:41.000000', 'consum', 0.0227, 'lps'),
	(507551, 131, '2014-01-15 00:55:42.000000', 'consum', 0.0212, 'lps'),
	(507552, 131, '2014-01-15 00:55:43.000000', 'consum', 0.0211, 'lps'),
	(507553, 131, '2014-01-15 00:55:44.000000', 'consum', 0.0231, 'lps'),
	(507554, 131, '2014-01-15 00:55:45.000000', 'consum', 0.0225, 'lps'),
	(507555, 131, '2014-01-15 00:55:46.000000', 'consum', 0.0222, 'lps'),
	(507556, 131, '2014-01-15 00:55:47.000000', 'consum', 0.0224, 'lps'),
	(507557, 131, '2014-01-15 00:55:48.000000', 'consum', 0.0226, 'lps'),
	(507558, 131, '2014-01-15 00:55:49.000000', 'consum', 0.0223, 'lps'),
	(507559, 131, '2014-01-15 00:55:50.000000', 'consum', 0.0230, 'lps'),
	(507560, 131, '2014-01-15 00:55:51.000000', 'consum', 0.0226, 'lps'),
	(507561, 131, '2014-01-15 00:55:52.000000', 'consum', 0.0230, 'lps'),
	(507562, 131, '2014-01-15 00:55:53.000000', 'consum', 0.0221, 'lps'),
	(507563, 131, '2014-01-15 00:55:54.000000', 'consum', 0.0224, 'lps'),
	(507564, 131, '2014-01-15 00:55:55.000000', 'consum', 0.0228, 'lps'),
	(507565, 131, '2014-01-15 00:55:56.000000', 'consum', 0.0215, 'lps'),
	(507566, 131, '2014-01-15 00:55:57.000000', 'consum', 0.0224, 'lps'),
	(507567, 131, '2014-01-15 00:55:58.000000', 'consum', 0.0221, 'lps'),
	(507568, 131, '2014-01-15 00:55:59.000000', 'consum', 0.0224, 'lps'),
	(507569, 131, '2014-01-15 00:56:00.000000', 'consum', 0.0225, 'lps'),
	(507570, 131, '2014-01-15 00:56:01.000000', 'consum', 0.0224, 'lps'),
	(507571, 131, '2014-01-15 00:56:02.000000', 'consum', 0.0210, 'lps'),
	(507572, 131, '2014-01-15 00:56:03.000000', 'consum', 0.0216, 'lps'),
	(507573, 131, '2014-01-15 00:56:04.000000', 'consum', 0.0217, 'lps'),
	(507574, 131, '2014-01-15 00:56:05.000000', 'consum', 0.0226, 'lps'),
	(507575, 131, '2014-01-15 00:56:06.000000', 'consum', 0.0228, 'lps'),
	(507576, 131, '2014-01-15 00:56:07.000000', 'consum', 0.0230, 'lps'),
	(507577, 131, '2014-01-15 00:56:08.000000', 'consum', 0.0210, 'lps'),
	(507578, 131, '2014-01-15 00:56:09.000000', 'consum', 0.0220, 'lps'),
	(507579, 131, '2014-01-15 00:56:10.000000', 'consum', 0.0213, 'lps'),
	(507580, 131, '2014-01-15 00:56:11.000000', 'consum', 0.0221, 'lps'),
	(507581, 131, '2014-01-15 00:56:12.000000', 'consum', 0.0211, 'lps'),
	(507582, 131, '2014-01-15 00:56:13.000000', 'consum', 0.0228, 'lps'),
	(507583, 131, '2014-01-15 00:56:14.000000', 'consum', 0.0231, 'lps'),
	(507584, 131, '2014-01-15 00:56:15.000000', 'consum', 0.0216, 'lps'),
	(507585, 131, '2014-01-15 00:56:16.000000', 'consum', 0.0221, 'lps'),
	(507586, 131, '2014-01-15 00:56:17.000000', 'consum', 0.0227, 'lps'),
	(507587, 131, '2014-01-15 00:56:18.000000', 'consum', 0.0218, 'lps'),
	(507588, 131, '2014-01-15 00:56:19.000000', 'consum', 0.0223, 'lps'),
	(507589, 131, '2014-01-15 00:56:20.000000', 'consum', 0.0228, 'lps'),
	(507590, 131, '2014-01-15 00:56:21.000000', 'consum', 0.0219, 'lps'),
	(507591, 131, '2014-01-15 00:56:22.000000', 'consum', 0.0222, 'lps'),
	(507592, 131, '2014-01-15 00:56:23.000000', 'consum', 0.0220, 'lps'),
	(507593, 131, '2014-01-15 00:56:24.000000', 'consum', 0.0226, 'lps'),
	(507594, 131, '2014-01-15 00:56:25.000000', 'consum', 0.0217, 'lps'),
	(507595, 131, '2014-01-15 00:56:26.000000', 'consum', 0.0220, 'lps'),
	(507596, 131, '2014-01-15 00:56:27.000000', 'consum', 0.0216, 'lps'),
	(507597, 131, '2014-01-15 00:56:28.000000', 'consum', 0.0212, 'lps'),
	(507598, 131, '2014-01-15 00:56:29.000000', 'consum', 0.0224, 'lps'),
	(507599, 131, '2014-01-15 00:56:30.000000', 'consum', 0.0210, 'lps'),
	(507600, 131, '2014-01-15 00:56:31.000000', 'consum', 0.0210, 'lps'),
	(507601, 131, '2014-01-15 00:56:32.000000', 'consum', 0.0212, 'lps'),
	(507602, 131, '2014-01-15 00:56:33.000000', 'consum', 0.0221, 'lps'),
	(507603, 131, '2014-01-15 00:56:34.000000', 'consum', 0.0215, 'lps'),
	(507604, 131, '2014-01-15 00:56:35.000000', 'consum', 0.0225, 'lps'),
	(507605, 131, '2014-01-15 00:56:36.000000', 'consum', 0.0228, 'lps'),
	(507606, 131, '2014-01-15 00:56:37.000000', 'consum', 0.0230, 'lps'),
	(507607, 131, '2014-01-15 00:56:38.000000', 'consum', 0.0216, 'lps'),
	(507608, 131, '2014-01-15 00:56:39.000000', 'consum', 0.0223, 'lps'),
	(507609, 131, '2014-01-15 00:56:40.000000', 'consum', 0.0214, 'lps'),
	(507610, 131, '2014-01-15 00:56:41.000000', 'consum', 0.0213, 'lps'),
	(507611, 131, '2014-01-15 00:56:42.000000', 'consum', 0.0214, 'lps'),
	(507612, 131, '2014-01-15 00:56:43.000000', 'consum', 0.0222, 'lps'),
	(507613, 131, '2014-01-15 00:56:44.000000', 'consum', 0.0213, 'lps'),
	(507614, 131, '2014-01-15 00:56:45.000000', 'consum', 0.0213, 'lps'),
	(507615, 131, '2014-01-15 00:56:46.000000', 'consum', 0.0218, 'lps'),
	(507616, 131, '2014-01-15 00:56:47.000000', 'consum', 0.0218, 'lps'),
	(507617, 131, '2014-01-15 00:56:48.000000', 'consum', 0.0225, 'lps'),
	(507618, 131, '2014-01-15 00:56:49.000000', 'consum', 0.0219, 'lps'),
	(507619, 131, '2014-01-15 00:56:50.000000', 'consum', 0.0230, 'lps'),
	(507620, 131, '2014-01-15 00:56:51.000000', 'consum', 0.0219, 'lps'),
	(507621, 131, '2014-01-15 00:56:52.000000', 'consum', 0.0219, 'lps'),
	(507622, 131, '2014-01-15 00:56:53.000000', 'consum', 0.0227, 'lps'),
	(507623, 131, '2014-01-15 00:56:54.000000', 'consum', 0.0227, 'lps'),
	(507624, 131, '2014-01-15 00:56:55.000000', 'consum', 0.0220, 'lps'),
	(507625, 131, '2014-01-15 00:56:56.000000', 'consum', 0.0212, 'lps'),
	(507626, 131, '2014-01-15 00:56:57.000000', 'consum', 0.0213, 'lps'),
	(507627, 131, '2014-01-15 00:56:58.000000', 'consum', 0.0217, 'lps'),
	(507628, 131, '2014-01-15 00:56:59.000000', 'consum', 0.0214, 'lps'),
	(507629, 131, '2014-01-15 00:57:00.000000', 'consum', 0.0211, 'lps'),
	(507630, 131, '2014-01-15 00:57:01.000000', 'consum', 0.0227, 'lps'),
	(507631, 131, '2014-01-15 00:57:02.000000', 'consum', 0.0226, 'lps'),
	(507632, 131, '2014-01-15 00:57:03.000000', 'consum', 0.0216, 'lps'),
	(507633, 131, '2014-01-15 00:57:04.000000', 'consum', 0.0215, 'lps'),
	(507634, 131, '2014-01-15 00:57:05.000000', 'consum', 0.0219, 'lps'),
	(507635, 131, '2014-01-15 00:57:06.000000', 'consum', 0.0217, 'lps'),
	(507636, 131, '2014-01-15 00:57:07.000000', 'consum', 0.0217, 'lps'),
	(507637, 131, '2014-01-15 00:57:08.000000', 'consum', 0.0225, 'lps'),
	(507638, 131, '2014-01-15 00:57:09.000000', 'consum', 0.0220, 'lps'),
	(507639, 131, '2014-01-15 00:57:10.000000', 'consum', 0.0214, 'lps'),
	(507640, 131, '2014-01-15 00:57:11.000000', 'consum', 0.0226, 'lps'),
	(507641, 131, '2014-01-15 00:57:12.000000', 'consum', 0.0231, 'lps'),
	(507642, 131, '2014-01-15 00:57:13.000000', 'consum', 0.0226, 'lps'),
	(507643, 131, '2014-01-15 00:57:14.000000', 'consum', 0.0229, 'lps'),
	(507644, 131, '2014-01-15 00:57:15.000000', 'consum', 0.0211, 'lps'),
	(507645, 131, '2014-01-15 00:57:16.000000', 'consum', 0.0223, 'lps'),
	(507646, 131, '2014-01-15 00:57:17.000000', 'consum', 0.0231, 'lps'),
	(507647, 131, '2014-01-15 00:57:18.000000', 'consum', 0.0231, 'lps'),
	(507648, 131, '2014-01-15 00:57:19.000000', 'consum', 0.0210, 'lps'),
	(507649, 131, '2014-01-15 00:57:20.000000', 'consum', 0.0212, 'lps'),
	(507650, 131, '2014-01-15 00:57:21.000000', 'consum', 0.0222, 'lps'),
	(507651, 131, '2014-01-15 00:57:22.000000', 'consum', 0.0218, 'lps'),
	(507652, 131, '2014-01-15 00:57:23.000000', 'consum', 0.0216, 'lps'),
	(507653, 131, '2014-01-15 00:57:24.000000', 'consum', 0.0216, 'lps'),
	(507654, 131, '2014-01-15 00:57:25.000000', 'consum', 0.0222, 'lps'),
	(507655, 131, '2014-01-15 00:57:26.000000', 'consum', 0.0210, 'lps'),
	(507656, 131, '2014-01-15 00:57:27.000000', 'consum', 0.0219, 'lps'),
	(507657, 131, '2014-01-15 00:57:28.000000', 'consum', 0.0210, 'lps'),
	(507658, 131, '2014-01-15 00:57:29.000000', 'consum', 0.0227, 'lps'),
	(507659, 131, '2014-01-15 00:57:30.000000', 'consum', 0.0231, 'lps'),
	(507660, 131, '2014-01-15 00:57:31.000000', 'consum', 0.0220, 'lps'),
	(507661, 131, '2014-01-15 00:57:32.000000', 'consum', 0.0218, 'lps'),
	(507662, 131, '2014-01-15 00:57:33.000000', 'consum', 0.0222, 'lps'),
	(507663, 131, '2014-01-15 00:57:34.000000', 'consum', 0.0224, 'lps'),
	(507664, 131, '2014-01-15 00:57:35.000000', 'consum', 0.0225, 'lps'),
	(507665, 131, '2014-01-15 00:57:36.000000', 'consum', 0.0219, 'lps'),
	(507666, 131, '2014-01-15 00:57:37.000000', 'consum', 0.0210, 'lps'),
	(507667, 131, '2014-01-15 00:57:38.000000', 'consum', 0.0228, 'lps'),
	(507668, 131, '2014-01-15 00:57:39.000000', 'consum', 0.0212, 'lps'),
	(507669, 131, '2014-01-15 00:57:40.000000', 'consum', 0.0210, 'lps'),
	(507670, 131, '2014-01-15 00:57:41.000000', 'consum', 0.0228, 'lps'),
	(507671, 131, '2014-01-15 00:57:42.000000', 'consum', 0.0211, 'lps'),
	(507672, 131, '2014-01-15 00:57:43.000000', 'consum', 0.0230, 'lps'),
	(507673, 131, '2014-01-15 00:57:44.000000', 'consum', 0.0219, 'lps'),
	(507674, 131, '2014-01-15 00:57:45.000000', 'consum', 0.0218, 'lps'),
	(507675, 131, '2014-01-15 00:57:46.000000', 'consum', 0.0222, 'lps'),
	(507676, 131, '2014-01-15 00:57:47.000000', 'consum', 0.0226, 'lps'),
	(507677, 131, '2014-01-15 00:57:48.000000', 'consum', 0.0211, 'lps'),
	(507678, 131, '2014-01-15 00:57:49.000000', 'consum', 0.0211, 'lps'),
	(507679, 131, '2014-01-15 00:57:50.000000', 'consum', 0.0214, 'lps'),
	(507680, 131, '2014-01-15 00:57:51.000000', 'consum', 0.0226, 'lps'),
	(507681, 131, '2014-01-15 00:57:52.000000', 'consum', 0.0213, 'lps'),
	(507682, 131, '2014-01-15 00:57:53.000000', 'consum', 0.0221, 'lps'),
	(507683, 131, '2014-01-15 00:57:54.000000', 'consum', 0.0212, 'lps'),
	(507684, 131, '2014-01-15 00:57:55.000000', 'consum', 0.0211, 'lps'),
	(507685, 131, '2014-01-15 00:57:56.000000', 'consum', 0.0210, 'lps'),
	(507686, 131, '2014-01-15 00:57:57.000000', 'consum', 0.0230, 'lps'),
	(507687, 131, '2014-01-15 00:57:58.000000', 'consum', 0.0220, 'lps'),
	(507688, 131, '2014-01-15 00:57:59.000000', 'consum', 0.0224, 'lps'),
	(507689, 131, '2014-01-15 00:58:00.000000', 'consum', 0.0230, 'lps'),
	(507690, 131, '2014-01-15 00:58:01.000000', 'consum', 0.0225, 'lps'),
	(507691, 131, '2014-01-15 00:58:02.000000', 'consum', 0.0224, 'lps'),
	(507692, 131, '2014-01-15 00:58:03.000000', 'consum', 0.0212, 'lps'),
	(507693, 131, '2014-01-15 00:58:04.000000', 'consum', 0.0223, 'lps'),
	(507694, 131, '2014-01-15 00:58:05.000000', 'consum', 0.0224, 'lps'),
	(507695, 131, '2014-01-15 00:58:06.000000', 'consum', 0.0222, 'lps'),
	(507696, 131, '2014-01-15 00:58:07.000000', 'consum', 0.0227, 'lps'),
	(507697, 131, '2014-01-15 00:58:08.000000', 'consum', 0.0216, 'lps'),
	(507698, 131, '2014-01-15 00:58:09.000000', 'consum', 0.0212, 'lps'),
	(507699, 131, '2014-01-15 00:58:10.000000', 'consum', 0.0225, 'lps'),
	(507700, 131, '2014-01-15 00:58:11.000000', 'consum', 0.0211, 'lps'),
	(507701, 131, '2014-01-15 00:58:12.000000', 'consum', 0.0217, 'lps'),
	(507702, 131, '2014-01-15 00:58:13.000000', 'consum', 0.0220, 'lps'),
	(507703, 131, '2014-01-15 00:58:14.000000', 'consum', 0.0219, 'lps'),
	(507704, 131, '2014-01-15 00:58:15.000000', 'consum', 0.0226, 'lps'),
	(507705, 131, '2014-01-15 00:58:16.000000', 'consum', 0.0217, 'lps'),
	(507706, 131, '2014-01-15 00:58:17.000000', 'consum', 0.0222, 'lps'),
	(507707, 131, '2014-01-15 00:58:18.000000', 'consum', 0.0227, 'lps'),
	(507708, 131, '2014-01-15 00:58:19.000000', 'consum', 0.0216, 'lps'),
	(507709, 131, '2014-01-15 00:58:20.000000', 'consum', 0.0211, 'lps'),
	(507710, 131, '2014-01-15 00:58:21.000000', 'consum', 0.0220, 'lps'),
	(507711, 131, '2014-01-15 00:58:22.000000', 'consum', 0.0215, 'lps'),
	(507712, 131, '2014-01-15 00:58:23.000000', 'consum', 0.0227, 'lps'),
	(507713, 131, '2014-01-15 00:58:24.000000', 'consum', 0.0214, 'lps'),
	(507714, 131, '2014-01-15 00:58:25.000000', 'consum', 0.0225, 'lps'),
	(507715, 131, '2014-01-15 00:58:26.000000', 'consum', 0.0229, 'lps'),
	(507716, 131, '2014-01-15 00:58:27.000000', 'consum', 0.0217, 'lps'),
	(507717, 131, '2014-01-15 00:58:28.000000', 'consum', 0.0210, 'lps'),
	(507718, 131, '2014-01-15 00:58:29.000000', 'consum', 0.0211, 'lps'),
	(507719, 131, '2014-01-15 00:58:30.000000', 'consum', 0.0217, 'lps'),
	(507720, 131, '2014-01-15 00:58:31.000000', 'consum', 0.0221, 'lps'),
	(507721, 131, '2014-01-15 00:58:32.000000', 'consum', 0.0223, 'lps'),
	(507722, 131, '2014-01-15 00:58:33.000000', 'consum', 0.0221, 'lps'),
	(507723, 131, '2014-01-15 00:58:34.000000', 'consum', 0.0227, 'lps'),
	(507724, 131, '2014-01-15 00:58:35.000000', 'consum', 0.0219, 'lps'),
	(507725, 131, '2014-01-15 00:58:36.000000', 'consum', 0.0226, 'lps'),
	(507726, 131, '2014-01-15 00:58:37.000000', 'consum', 0.0218, 'lps'),
	(507727, 131, '2014-01-15 00:58:38.000000', 'consum', 0.0226, 'lps'),
	(507728, 131, '2014-01-15 00:58:39.000000', 'consum', 0.0223, 'lps'),
	(507729, 131, '2014-01-15 00:58:40.000000', 'consum', 0.0228, 'lps'),
	(507730, 131, '2014-01-15 00:58:41.000000', 'consum', 0.0215, 'lps'),
	(507731, 131, '2014-01-15 00:58:42.000000', 'consum', 0.0228, 'lps'),
	(507732, 131, '2014-01-15 00:58:43.000000', 'consum', 0.0218, 'lps'),
	(507733, 131, '2014-01-15 00:58:44.000000', 'consum', 0.0218, 'lps'),
	(507734, 131, '2014-01-15 00:58:45.000000', 'consum', 0.0226, 'lps'),
	(507735, 131, '2014-01-15 00:58:46.000000', 'consum', 0.0224, 'lps'),
	(507736, 131, '2014-01-15 00:58:47.000000', 'consum', 0.0231, 'lps'),
	(507737, 131, '2014-01-15 00:58:48.000000', 'consum', 0.0230, 'lps'),
	(507738, 131, '2014-01-15 00:58:49.000000', 'consum', 0.0228, 'lps'),
	(507739, 131, '2014-01-15 00:58:50.000000', 'consum', 0.0215, 'lps'),
	(507740, 131, '2014-01-15 00:58:51.000000', 'consum', 0.0229, 'lps'),
	(507741, 131, '2014-01-15 00:58:52.000000', 'consum', 0.0222, 'lps'),
	(507742, 131, '2014-01-15 00:58:53.000000', 'consum', 0.0216, 'lps'),
	(507743, 131, '2014-01-15 00:58:54.000000', 'consum', 0.0225, 'lps'),
	(507744, 131, '2014-01-15 00:58:55.000000', 'consum', 0.0224, 'lps'),
	(507745, 131, '2014-01-15 00:58:56.000000', 'consum', 0.0212, 'lps'),
	(507746, 131, '2014-01-15 00:58:57.000000', 'consum', 0.0224, 'lps'),
	(507747, 131, '2014-01-15 00:58:58.000000', 'consum', 0.0210, 'lps'),
	(507748, 131, '2014-01-15 00:58:59.000000', 'consum', 0.0212, 'lps'),
	(507749, 131, '2014-01-15 00:59:00.000000', 'consum', 0.0218, 'lps'),
	(507750, 131, '2014-01-15 00:59:01.000000', 'consum', 0.0223, 'lps'),
	(507751, 131, '2014-01-15 00:59:02.000000', 'consum', 0.0210, 'lps'),
	(507752, 131, '2014-01-15 00:59:03.000000', 'consum', 0.0213, 'lps'),
	(507753, 131, '2014-01-15 00:59:04.000000', 'consum', 0.0227, 'lps'),
	(507754, 131, '2014-01-15 00:59:05.000000', 'consum', 0.0222, 'lps'),
	(507755, 131, '2014-01-15 00:59:06.000000', 'consum', 0.0217, 'lps'),
	(507756, 131, '2014-01-15 00:59:07.000000', 'consum', 0.0210, 'lps'),
	(507757, 131, '2014-01-15 00:59:08.000000', 'consum', 0.0211, 'lps'),
	(507758, 131, '2014-01-15 00:59:09.000000', 'consum', 0.0217, 'lps'),
	(507759, 131, '2014-01-15 00:59:10.000000', 'consum', 0.0219, 'lps'),
	(507760, 131, '2014-01-15 00:59:11.000000', 'consum', 0.0213, 'lps'),
	(507761, 131, '2014-01-15 00:59:12.000000', 'consum', 0.0223, 'lps'),
	(507762, 131, '2014-01-15 00:59:13.000000', 'consum', 0.0219, 'lps'),
	(507763, 131, '2014-01-15 00:59:14.000000', 'consum', 0.0218, 'lps'),
	(507764, 131, '2014-01-15 00:59:15.000000', 'consum', 0.0222, 'lps'),
	(507765, 131, '2014-01-15 00:59:16.000000', 'consum', 0.0226, 'lps'),
	(507766, 131, '2014-01-15 00:59:17.000000', 'consum', 0.0211, 'lps'),
	(507767, 131, '2014-01-15 00:59:18.000000', 'consum', 0.0211, 'lps'),
	(507768, 131, '2014-01-15 00:59:19.000000', 'consum', 0.0210, 'lps'),
	(507769, 131, '2014-01-15 00:59:20.000000', 'consum', 0.0211, 'lps'),
	(507770, 131, '2014-01-15 00:59:21.000000', 'consum', 0.0212, 'lps'),
	(507771, 131, '2014-01-15 00:59:22.000000', 'consum', 0.0219, 'lps'),
	(507772, 131, '2014-01-15 00:59:23.000000', 'consum', 0.0229, 'lps'),
	(507773, 131, '2014-01-15 00:59:24.000000', 'consum', 0.0214, 'lps'),
	(507774, 131, '2014-01-15 00:59:25.000000', 'consum', 0.0214, 'lps'),
	(507775, 131, '2014-01-15 00:59:26.000000', 'consum', 0.0219, 'lps'),
	(507776, 131, '2014-01-15 00:59:27.000000', 'consum', 0.0223, 'lps'),
	(507777, 131, '2014-01-15 00:59:28.000000', 'consum', 0.0226, 'lps'),
	(507778, 131, '2014-01-15 00:59:29.000000', 'consum', 0.0230, 'lps'),
	(507779, 131, '2014-01-15 00:59:30.000000', 'consum', 0.0218, 'lps'),
	(507780, 131, '2014-01-15 00:59:31.000000', 'consum', 0.0214, 'lps'),
	(507781, 131, '2014-01-15 00:59:32.000000', 'consum', 0.0226, 'lps'),
	(507782, 131, '2014-01-15 00:59:33.000000', 'consum', 0.0215, 'lps'),
	(507783, 131, '2014-01-15 00:59:34.000000', 'consum', 0.0230, 'lps'),
	(507784, 131, '2014-01-15 00:59:35.000000', 'consum', 0.0228, 'lps'),
	(507785, 131, '2014-01-15 00:59:36.000000', 'consum', 0.0222, 'lps'),
	(507786, 131, '2014-01-15 00:59:37.000000', 'consum', 0.0213, 'lps'),
	(507787, 131, '2014-01-15 00:59:38.000000', 'consum', 0.0214, 'lps'),
	(507788, 131, '2014-01-15 00:59:39.000000', 'consum', 0.0220, 'lps'),
	(507789, 131, '2014-01-15 00:59:40.000000', 'consum', 0.0226, 'lps'),
	(507790, 131, '2014-01-15 00:59:41.000000', 'consum', 0.0219, 'lps'),
	(507791, 131, '2014-01-15 00:59:42.000000', 'consum', 0.0230, 'lps'),
	(507792, 131, '2014-01-15 00:59:43.000000', 'consum', 0.0215, 'lps'),
	(507793, 131, '2014-01-15 00:59:44.000000', 'consum', 0.0219, 'lps'),
	(507794, 131, '2014-01-15 00:59:45.000000', 'consum', 0.0219, 'lps'),
	(507795, 131, '2014-01-15 00:59:46.000000', 'consum', 0.0231, 'lps'),
	(507796, 131, '2014-01-15 00:59:47.000000', 'consum', 0.0219, 'lps'),
	(507797, 131, '2014-01-15 00:59:48.000000', 'consum', 0.0216, 'lps'),
	(507798, 131, '2014-01-15 00:59:49.000000', 'consum', 0.0212, 'lps'),
	(507799, 131, '2014-01-15 00:59:50.000000', 'consum', 0.0226, 'lps'),
	(507800, 131, '2014-01-15 00:59:51.000000', 'consum', 0.0219, 'lps'),
	(507801, 131, '2014-01-15 00:59:52.000000', 'consum', 0.0229, 'lps'),
	(507802, 131, '2014-01-15 00:59:53.000000', 'consum', 0.0212, 'lps'),
	(507803, 131, '2014-01-15 00:59:54.000000', 'consum', 0.0231, 'lps'),
	(507804, 131, '2014-01-15 00:59:55.000000', 'consum', 0.0220, 'lps'),
	(507805, 131, '2014-01-15 00:59:56.000000', 'consum', 0.0221, 'lps'),
	(507806, 131, '2014-01-15 00:59:57.000000', 'consum', 0.0211, 'lps'),
	(507807, 131, '2014-01-15 00:59:58.000000', 'consum', 0.0229, 'lps'),
	(507808, 131, '2014-01-15 00:59:59.000000', 'consum', 0.0215, 'lps'),
	(507809, 131, '2014-01-15 01:00:00.000000', 'consum', 0.0220, 'lps'),
	(507810, 131, '2014-01-15 01:00:01.000000', 'consum', 0.0223, 'lps'),
	(507811, 131, '2014-01-15 01:00:02.000000', 'consum', 0.0223, 'lps'),
	(507812, 131, '2014-01-15 01:00:03.000000', 'consum', 0.0216, 'lps'),
	(507813, 131, '2014-01-15 01:00:04.000000', 'consum', 0.0222, 'lps'),
	(507814, 131, '2014-01-15 01:00:05.000000', 'consum', 0.0210, 'lps'),
	(507815, 131, '2014-01-15 01:00:06.000000', 'consum', 0.0218, 'lps'),
	(507816, 131, '2014-01-15 01:00:07.000000', 'consum', 0.0227, 'lps'),
	(507817, 131, '2014-01-15 01:00:08.000000', 'consum', 0.0229, 'lps'),
	(507818, 131, '2014-01-15 01:00:09.000000', 'consum', 0.0211, 'lps'),
	(507819, 131, '2014-01-15 01:00:10.000000', 'consum', 0.0222, 'lps'),
	(507820, 131, '2014-01-15 01:00:11.000000', 'consum', 0.0224, 'lps'),
	(507821, 131, '2014-01-15 01:00:12.000000', 'consum', 0.0223, 'lps'),
	(507822, 131, '2014-01-15 01:00:13.000000', 'consum', 0.0213, 'lps'),
	(507823, 131, '2014-01-15 01:00:14.000000', 'consum', 0.0231, 'lps'),
	(507824, 131, '2014-01-15 01:00:15.000000', 'consum', 0.0218, 'lps'),
	(507825, 131, '2014-01-15 01:00:16.000000', 'consum', 0.0210, 'lps'),
	(507826, 131, '2014-01-15 01:00:17.000000', 'consum', 0.0229, 'lps'),
	(507827, 131, '2014-01-15 01:00:18.000000', 'consum', 0.0220, 'lps'),
	(507828, 131, '2014-01-15 01:00:19.000000', 'consum', 0.0223, 'lps'),
	(507829, 131, '2014-01-15 01:00:20.000000', 'consum', 0.0222, 'lps'),
	(507830, 131, '2014-01-15 01:00:21.000000', 'consum', 0.0213, 'lps'),
	(507831, 131, '2014-01-15 01:00:22.000000', 'consum', 0.0231, 'lps'),
	(507832, 131, '2014-01-15 01:00:23.000000', 'consum', 0.0221, 'lps'),
	(507833, 131, '2014-01-15 01:00:24.000000', 'consum', 0.0225, 'lps'),
	(507834, 131, '2014-01-15 01:00:25.000000', 'consum', 0.0228, 'lps'),
	(507835, 131, '2014-01-15 01:00:26.000000', 'consum', 0.0212, 'lps'),
	(507836, 131, '2014-01-15 01:00:27.000000', 'consum', 0.0210, 'lps'),
	(507837, 131, '2014-01-15 01:00:28.000000', 'consum', 0.0228, 'lps'),
	(507838, 131, '2014-01-15 01:00:29.000000', 'consum', 0.0213, 'lps'),
	(507839, 131, '2014-01-15 01:00:30.000000', 'consum', 0.0215, 'lps'),
	(507840, 131, '2014-01-15 01:00:31.000000', 'consum', 0.0228, 'lps'),
	(507841, 131, '2014-01-15 01:00:32.000000', 'consum', 0.0217, 'lps'),
	(507842, 131, '2014-01-15 01:00:33.000000', 'consum', 0.0213, 'lps'),
	(507843, 131, '2014-01-15 01:00:34.000000', 'consum', 0.0228, 'lps'),
	(507844, 131, '2014-01-15 01:00:35.000000', 'consum', 0.0226, 'lps'),
	(507845, 131, '2014-01-15 01:00:36.000000', 'consum', 0.0213, 'lps'),
	(507846, 131, '2014-01-15 01:00:37.000000', 'consum', 0.0221, 'lps'),
	(507847, 131, '2014-01-15 01:00:38.000000', 'consum', 0.0211, 'lps'),
	(507848, 131, '2014-01-15 01:00:39.000000', 'consum', 0.0230, 'lps'),
	(507849, 131, '2014-01-15 01:00:40.000000', 'consum', 0.0218, 'lps'),
	(507850, 131, '2014-01-15 01:00:41.000000', 'consum', 0.0214, 'lps'),
	(507851, 131, '2014-01-15 01:00:42.000000', 'consum', 0.0228, 'lps'),
	(507852, 131, '2014-01-15 01:00:43.000000', 'consum', 0.0224, 'lps'),
	(507853, 131, '2014-01-15 01:00:44.000000', 'consum', 0.0223, 'lps'),
	(507854, 131, '2014-01-15 01:00:45.000000', 'consum', 0.0214, 'lps'),
	(507855, 131, '2014-01-15 01:00:46.000000', 'consum', 0.0211, 'lps'),
	(507856, 131, '2014-01-15 01:00:47.000000', 'consum', 0.0227, 'lps'),
	(507857, 131, '2014-01-15 01:00:48.000000', 'consum', 0.0225, 'lps'),
	(507858, 131, '2014-01-15 01:00:49.000000', 'consum', 0.0212, 'lps'),
	(507859, 131, '2014-01-15 01:00:50.000000', 'consum', 0.0220, 'lps'),
	(507860, 131, '2014-01-15 01:00:51.000000', 'consum', 0.0212, 'lps'),
	(507861, 131, '2014-01-15 01:00:52.000000', 'consum', 0.0214, 'lps'),
	(507862, 131, '2014-01-15 01:00:53.000000', 'consum', 0.0221, 'lps'),
	(507863, 131, '2014-01-15 01:00:54.000000', 'consum', 0.0211, 'lps'),
	(507864, 131, '2014-01-15 01:00:55.000000', 'consum', 0.0227, 'lps'),
	(507865, 131, '2014-01-15 01:00:56.000000', 'consum', 0.0226, 'lps'),
	(507866, 131, '2014-01-15 01:00:57.000000', 'consum', 0.0216, 'lps'),
	(507867, 131, '2014-01-15 01:00:58.000000', 'consum', 0.0218, 'lps'),
	(507868, 131, '2014-01-15 01:00:59.000000', 'consum', 0.0229, 'lps'),
	(507869, 131, '2014-01-15 01:01:00.000000', 'consum', 0.0216, 'lps'),
	(507870, 131, '2014-01-15 01:01:01.000000', 'consum', 0.0226, 'lps'),
	(507871, 131, '2014-01-15 01:01:02.000000', 'consum', 0.0230, 'lps'),
	(507872, 131, '2014-01-15 01:01:03.000000', 'consum', 0.0219, 'lps'),
	(507873, 131, '2014-01-15 01:01:04.000000', 'consum', 0.0215, 'lps'),
	(507874, 131, '2014-01-15 01:01:05.000000', 'consum', 0.0212, 'lps'),
	(507875, 131, '2014-01-15 01:01:06.000000', 'consum', 0.0225, 'lps'),
	(507876, 131, '2014-01-15 01:01:07.000000', 'consum', 0.0216, 'lps'),
	(507877, 131, '2014-01-15 01:01:08.000000', 'consum', 0.0218, 'lps'),
	(507878, 131, '2014-01-15 01:01:09.000000', 'consum', 0.0230, 'lps'),
	(507879, 131, '2014-01-15 01:01:10.000000', 'consum', 0.0223, 'lps'),
	(507880, 131, '2014-01-15 01:01:11.000000', 'consum', 0.0216, 'lps'),
	(507881, 131, '2014-01-15 01:01:12.000000', 'consum', 0.0221, 'lps'),
	(507882, 131, '2014-01-15 01:01:13.000000', 'consum', 0.0228, 'lps'),
	(507883, 131, '2014-01-15 01:01:14.000000', 'consum', 0.0223, 'lps'),
	(507884, 131, '2014-01-15 01:01:15.000000', 'consum', 0.0222, 'lps'),
	(507885, 131, '2014-01-15 01:01:16.000000', 'consum', 0.0231, 'lps'),
	(507886, 131, '2014-01-15 01:01:17.000000', 'consum', 0.0215, 'lps'),
	(507887, 131, '2014-01-15 01:01:18.000000', 'consum', 0.0215, 'lps'),
	(507888, 131, '2014-01-15 01:01:19.000000', 'consum', 0.0220, 'lps'),
	(507889, 131, '2014-01-15 01:01:20.000000', 'consum', 0.0224, 'lps'),
	(507890, 131, '2014-01-15 01:01:21.000000', 'consum', 0.0230, 'lps'),
	(507891, 131, '2014-01-15 01:01:22.000000', 'consum', 0.0224, 'lps'),
	(507892, 131, '2014-01-15 01:01:23.000000', 'consum', 0.0218, 'lps'),
	(507893, 131, '2014-01-15 01:01:24.000000', 'consum', 0.0212, 'lps'),
	(507894, 131, '2014-01-15 01:01:25.000000', 'consum', 0.0217, 'lps'),
	(507895, 131, '2014-01-15 01:01:26.000000', 'consum', 0.0219, 'lps'),
	(507896, 131, '2014-01-15 01:01:27.000000', 'consum', 0.0213, 'lps'),
	(507897, 131, '2014-01-15 01:01:28.000000', 'consum', 0.0221, 'lps'),
	(507898, 131, '2014-01-15 01:01:29.000000', 'consum', 0.0231, 'lps'),
	(507899, 131, '2014-01-15 01:01:30.000000', 'consum', 0.0220, 'lps'),
	(507900, 131, '2014-01-15 01:01:31.000000', 'consum', 0.0219, 'lps'),
	(507901, 131, '2014-01-15 01:01:32.000000', 'consum', 0.0224, 'lps'),
	(507902, 131, '2014-01-15 01:01:33.000000', 'consum', 0.0211, 'lps'),
	(507903, 131, '2014-01-15 01:01:34.000000', 'consum', 0.0216, 'lps'),
	(507904, 131, '2014-01-15 01:01:35.000000', 'consum', 0.0217, 'lps'),
	(507905, 131, '2014-01-15 01:01:36.000000', 'consum', 0.0226, 'lps'),
	(507906, 131, '2014-01-15 01:01:37.000000', 'consum', 0.0225, 'lps'),
	(507907, 131, '2014-01-15 01:01:38.000000', 'consum', 0.0216, 'lps'),
	(507908, 131, '2014-01-15 01:01:39.000000', 'consum', 0.0219, 'lps'),
	(507909, 131, '2014-01-15 01:01:40.000000', 'consum', 0.0216, 'lps'),
	(507910, 131, '2014-01-15 01:01:41.000000', 'consum', 0.0214, 'lps'),
	(507911, 131, '2014-01-15 01:01:42.000000', 'consum', 0.0211, 'lps'),
	(507912, 131, '2014-01-15 01:01:43.000000', 'consum', 0.0227, 'lps'),
	(507913, 131, '2014-01-15 01:01:44.000000', 'consum', 0.0224, 'lps'),
	(507914, 131, '2014-01-15 01:01:45.000000', 'consum', 0.0230, 'lps'),
	(507915, 131, '2014-01-15 01:01:46.000000', 'consum', 0.0224, 'lps'),
	(507916, 131, '2014-01-15 01:01:47.000000', 'consum', 0.0223, 'lps'),
	(507917, 131, '2014-01-15 01:01:48.000000', 'consum', 0.0231, 'lps'),
	(507918, 131, '2014-01-15 01:01:49.000000', 'consum', 0.0213, 'lps'),
	(507919, 131, '2014-01-15 01:01:50.000000', 'consum', 0.0227, 'lps'),
	(507920, 131, '2014-01-15 01:01:51.000000', 'consum', 0.0220, 'lps'),
	(507921, 131, '2014-01-15 01:01:52.000000', 'consum', 0.0210, 'lps'),
	(507922, 131, '2014-01-15 01:01:53.000000', 'consum', 0.0224, 'lps'),
	(507923, 131, '2014-01-15 01:01:54.000000', 'consum', 0.0215, 'lps'),
	(507924, 131, '2014-01-15 01:01:55.000000', 'consum', 0.0214, 'lps'),
	(507925, 131, '2014-01-15 01:01:56.000000', 'consum', 0.0217, 'lps'),
	(507926, 131, '2014-01-15 01:01:57.000000', 'consum', 0.0213, 'lps'),
	(507927, 131, '2014-01-15 01:01:58.000000', 'consum', 0.0226, 'lps'),
	(507928, 131, '2014-01-15 01:01:59.000000', 'consum', 0.0213, 'lps'),
	(507929, 131, '2014-01-15 01:02:00.000000', 'consum', 0.0225, 'lps'),
	(507930, 131, '2014-01-15 01:02:01.000000', 'consum', 0.0229, 'lps'),
	(507931, 131, '2014-01-15 01:02:02.000000', 'consum', 0.0219, 'lps'),
	(507932, 131, '2014-01-15 01:02:03.000000', 'consum', 0.0221, 'lps'),
	(507933, 131, '2014-01-15 01:02:04.000000', 'consum', 0.0214, 'lps'),
	(507934, 131, '2014-01-15 01:02:05.000000', 'consum', 0.0221, 'lps'),
	(507935, 131, '2014-01-15 01:02:06.000000', 'consum', 0.0231, 'lps'),
	(507936, 131, '2014-01-15 01:02:07.000000', 'consum', 0.0216, 'lps'),
	(507937, 131, '2014-01-15 01:02:08.000000', 'consum', 0.0221, 'lps'),
	(507938, 131, '2014-01-15 01:02:09.000000', 'consum', 0.0224, 'lps'),
	(507939, 131, '2014-01-15 01:02:10.000000', 'consum', 0.0229, 'lps'),
	(507940, 131, '2014-01-15 01:02:11.000000', 'consum', 0.0219, 'lps'),
	(507941, 131, '2014-01-15 01:02:12.000000', 'consum', 0.0219, 'lps'),
	(507942, 131, '2014-01-15 01:02:13.000000', 'consum', 0.0229, 'lps'),
	(507943, 131, '2014-01-15 01:02:14.000000', 'consum', 0.0215, 'lps'),
	(507944, 131, '2014-01-15 01:02:15.000000', 'consum', 0.0220, 'lps'),
	(507945, 131, '2014-01-15 01:02:16.000000', 'consum', 0.0222, 'lps'),
	(507946, 131, '2014-01-15 01:02:17.000000', 'consum', 0.0220, 'lps'),
	(507947, 131, '2014-01-15 01:02:18.000000', 'consum', 0.0224, 'lps'),
	(507948, 131, '2014-01-15 01:02:19.000000', 'consum', 0.0227, 'lps'),
	(507949, 131, '2014-01-15 01:02:20.000000', 'consum', 0.0211, 'lps'),
	(507950, 131, '2014-01-15 01:02:21.000000', 'consum', 0.0229, 'lps'),
	(507951, 131, '2014-01-15 01:02:22.000000', 'consum', 0.0214, 'lps'),
	(507952, 131, '2014-01-15 01:02:23.000000', 'consum', 0.0218, 'lps'),
	(507953, 131, '2014-01-15 01:02:24.000000', 'consum', 0.0216, 'lps'),
	(507954, 131, '2014-01-15 01:02:25.000000', 'consum', 0.0215, 'lps'),
	(507955, 131, '2014-01-15 01:02:26.000000', 'consum', 0.0219, 'lps'),
	(507956, 131, '2014-01-15 01:02:27.000000', 'consum', 0.0220, 'lps'),
	(507957, 131, '2014-01-15 01:02:28.000000', 'consum', 0.0210, 'lps'),
	(507958, 131, '2014-01-15 01:02:29.000000', 'consum', 0.0225, 'lps'),
	(507959, 131, '2014-01-15 01:02:30.000000', 'consum', 0.0219, 'lps'),
	(507960, 131, '2014-01-15 01:02:31.000000', 'consum', 0.0211, 'lps'),
	(507961, 131, '2014-01-15 01:02:32.000000', 'consum', 0.0210, 'lps'),
	(507962, 131, '2014-01-15 01:02:33.000000', 'consum', 0.0231, 'lps'),
	(507963, 131, '2014-01-15 01:02:34.000000', 'consum', 0.0224, 'lps'),
	(507964, 131, '2014-01-15 01:02:35.000000', 'consum', 0.0221, 'lps'),
	(507965, 131, '2014-01-15 01:02:36.000000', 'consum', 0.0224, 'lps'),
	(507966, 131, '2014-01-15 01:02:37.000000', 'consum', 0.0224, 'lps'),
	(507967, 131, '2014-01-15 01:02:38.000000', 'consum', 0.0216, 'lps'),
	(507968, 131, '2014-01-15 01:02:39.000000', 'consum', 0.0221, 'lps'),
	(507969, 131, '2014-01-15 01:02:40.000000', 'consum', 0.0228, 'lps'),
	(507970, 131, '2014-01-15 01:02:41.000000', 'consum', 0.0220, 'lps'),
	(507971, 131, '2014-01-15 01:02:42.000000', 'consum', 0.0231, 'lps'),
	(507972, 131, '2014-01-15 01:02:43.000000', 'consum', 0.0217, 'lps'),
	(507973, 131, '2014-01-15 01:02:44.000000', 'consum', 0.0228, 'lps'),
	(507974, 131, '2014-01-15 01:02:45.000000', 'consum', 0.0212, 'lps'),
	(507975, 131, '2014-01-15 01:02:46.000000', 'consum', 0.0212, 'lps'),
	(507976, 131, '2014-01-15 01:02:47.000000', 'consum', 0.0215, 'lps'),
	(507977, 131, '2014-01-15 01:02:48.000000', 'consum', 0.0231, 'lps'),
	(507978, 131, '2014-01-15 01:02:49.000000', 'consum', 0.0210, 'lps'),
	(507979, 131, '2014-01-15 01:02:50.000000', 'consum', 0.0212, 'lps'),
	(507980, 131, '2014-01-15 01:02:51.000000', 'consum', 0.0223, 'lps'),
	(507981, 131, '2014-01-15 01:02:52.000000', 'consum', 0.0226, 'lps'),
	(507982, 131, '2014-01-15 01:02:53.000000', 'consum', 0.0230, 'lps'),
	(507983, 131, '2014-01-15 01:02:54.000000', 'consum', 0.0217, 'lps'),
	(507984, 131, '2014-01-15 01:02:55.000000', 'consum', 0.0230, 'lps'),
	(507985, 131, '2014-01-15 01:02:56.000000', 'consum', 0.0223, 'lps'),
	(507986, 131, '2014-01-15 01:02:57.000000', 'consum', 0.0215, 'lps'),
	(507987, 131, '2014-01-15 01:02:58.000000', 'consum', 0.0220, 'lps'),
	(507988, 131, '2014-01-15 01:02:59.000000', 'consum', 0.0224, 'lps'),
	(507989, 131, '2014-01-15 01:03:00.000000', 'consum', 0.0227, 'lps'),
	(507990, 131, '2014-01-15 01:03:01.000000', 'consum', 0.0211, 'lps'),
	(507991, 131, '2014-01-15 01:03:02.000000', 'consum', 0.0229, 'lps'),
	(507992, 131, '2014-01-15 01:03:03.000000', 'consum', 0.0215, 'lps'),
	(507993, 131, '2014-01-15 01:03:04.000000', 'consum', 0.0223, 'lps'),
	(507994, 131, '2014-01-15 01:03:05.000000', 'consum', 0.0217, 'lps'),
	(507995, 131, '2014-01-15 01:03:06.000000', 'consum', 0.0229, 'lps'),
	(507996, 131, '2014-01-15 01:03:07.000000', 'consum', 0.0217, 'lps'),
	(507997, 131, '2014-01-15 01:03:08.000000', 'consum', 0.0211, 'lps'),
	(507998, 131, '2014-01-15 01:03:09.000000', 'consum', 0.0217, 'lps'),
	(507999, 131, '2014-01-15 01:03:10.000000', 'consum', 0.0220, 'lps'),
	(508000, 131, '2014-01-15 01:03:11.000000', 'consum', 0.0218, 'lps'),
	(508001, 131, '2014-01-15 01:03:12.000000', 'consum', 0.0221, 'lps'),
	(508002, 131, '2014-01-15 01:03:13.000000', 'consum', 0.0217, 'lps'),
	(508003, 131, '2014-01-15 01:03:14.000000', 'consum', 0.0213, 'lps'),
	(508004, 131, '2014-01-15 01:03:15.000000', 'consum', 0.0228, 'lps'),
	(508005, 131, '2014-01-15 01:03:16.000000', 'consum', 0.0225, 'lps'),
	(508006, 131, '2014-01-15 01:03:17.000000', 'consum', 0.0230, 'lps'),
	(508007, 131, '2014-01-15 01:03:18.000000', 'consum', 0.0224, 'lps'),
	(508008, 131, '2014-01-15 01:03:19.000000', 'consum', 0.0217, 'lps'),
	(508009, 131, '2014-01-15 01:03:20.000000', 'consum', 0.0229, 'lps'),
	(508010, 131, '2014-01-15 01:03:21.000000', 'consum', 0.0217, 'lps'),
	(508011, 131, '2014-01-15 01:03:22.000000', 'consum', 0.0212, 'lps'),
	(508012, 131, '2014-01-15 01:03:23.000000', 'consum', 0.0222, 'lps'),
	(508013, 131, '2014-01-15 01:03:24.000000', 'consum', 0.0218, 'lps'),
	(508014, 131, '2014-01-15 01:03:25.000000', 'consum', 0.0214, 'lps'),
	(508015, 131, '2014-01-15 01:03:26.000000', 'consum', 0.0231, 'lps'),
	(508016, 131, '2014-01-15 01:03:27.000000', 'consum', 0.0213, 'lps'),
	(508017, 131, '2014-01-15 01:03:28.000000', 'consum', 0.0229, 'lps'),
	(508018, 131, '2014-01-15 01:03:29.000000', 'consum', 0.0230, 'lps'),
	(508019, 131, '2014-01-15 01:03:30.000000', 'consum', 0.0211, 'lps'),
	(508020, 131, '2014-01-15 01:03:31.000000', 'consum', 0.0222, 'lps'),
	(508021, 131, '2014-01-15 01:03:32.000000', 'consum', 0.0225, 'lps'),
	(508022, 131, '2014-01-15 01:03:33.000000', 'consum', 0.0224, 'lps'),
	(508023, 131, '2014-01-15 01:03:34.000000', 'consum', 0.0214, 'lps'),
	(508024, 131, '2014-01-15 01:03:35.000000', 'consum', 0.0211, 'lps'),
	(508025, 131, '2014-01-15 01:03:36.000000', 'consum', 0.0226, 'lps'),
	(508026, 131, '2014-01-15 01:03:37.000000', 'consum', 0.0222, 'lps'),
	(508027, 131, '2014-01-15 01:03:38.000000', 'consum', 0.0224, 'lps'),
	(508028, 131, '2014-01-15 01:03:39.000000', 'consum', 0.0219, 'lps'),
	(508029, 131, '2014-01-15 01:03:40.000000', 'consum', 0.0217, 'lps'),
	(508030, 131, '2014-01-15 01:03:41.000000', 'consum', 0.0215, 'lps'),
	(508031, 131, '2014-01-15 01:03:42.000000', 'consum', 0.0217, 'lps'),
	(508032, 131, '2014-01-15 01:03:43.000000', 'consum', 0.0230, 'lps'),
	(508033, 131, '2014-01-15 01:03:44.000000', 'consum', 0.0221, 'lps'),
	(508034, 131, '2014-01-15 01:03:45.000000', 'consum', 0.0230, 'lps'),
	(508035, 131, '2014-01-15 01:03:46.000000', 'consum', 0.0211, 'lps'),
	(508036, 131, '2014-01-15 01:03:47.000000', 'consum', 0.0220, 'lps'),
	(508037, 131, '2014-01-15 01:03:48.000000', 'consum', 0.0214, 'lps'),
	(508038, 131, '2014-01-15 01:03:49.000000', 'consum', 0.0224, 'lps'),
	(508039, 131, '2014-01-15 01:03:50.000000', 'consum', 0.0222, 'lps'),
	(508040, 131, '2014-01-15 01:03:51.000000', 'consum', 0.0228, 'lps'),
	(508041, 131, '2014-01-15 01:03:52.000000', 'consum', 0.0222, 'lps'),
	(508042, 131, '2014-01-15 01:03:53.000000', 'consum', 0.0217, 'lps'),
	(508043, 131, '2014-01-15 01:03:54.000000', 'consum', 0.0210, 'lps'),
	(508044, 131, '2014-01-15 01:03:55.000000', 'consum', 0.0211, 'lps'),
	(508045, 131, '2014-01-15 01:03:56.000000', 'consum', 0.0214, 'lps'),
	(508046, 131, '2014-01-15 01:03:57.000000', 'consum', 0.0230, 'lps'),
	(508047, 131, '2014-01-15 01:03:58.000000', 'consum', 0.0231, 'lps'),
	(508048, 131, '2014-01-15 01:03:59.000000', 'consum', 0.0212, 'lps'),
	(508049, 131, '2014-01-15 01:04:00.000000', 'consum', 0.0222, 'lps'),
	(508050, 131, '2014-01-15 01:04:01.000000', 'consum', 0.0224, 'lps'),
	(508051, 131, '2014-01-15 01:04:02.000000', 'consum', 0.0219, 'lps'),
	(508052, 131, '2014-01-15 01:04:03.000000', 'consum', 0.0213, 'lps'),
	(508053, 131, '2014-01-15 01:04:04.000000', 'consum', 0.0221, 'lps'),
	(508054, 131, '2014-01-15 01:04:05.000000', 'consum', 0.0213, 'lps'),
	(508055, 131, '2014-01-15 01:04:06.000000', 'consum', 0.0215, 'lps'),
	(508056, 131, '2014-01-15 01:04:07.000000', 'consum', 0.0225, 'lps'),
	(508057, 131, '2014-01-15 01:04:08.000000', 'consum', 0.0226, 'lps'),
	(508058, 131, '2014-01-15 01:04:09.000000', 'consum', 0.0223, 'lps'),
	(508059, 131, '2014-01-15 01:04:10.000000', 'consum', 0.0229, 'lps'),
	(508060, 131, '2014-01-15 01:04:11.000000', 'consum', 0.0220, 'lps'),
	(508061, 131, '2014-01-15 01:04:12.000000', 'consum', 0.0228, 'lps'),
	(508062, 131, '2014-01-15 01:04:13.000000', 'consum', 0.0225, 'lps'),
	(508063, 131, '2014-01-15 01:04:14.000000', 'consum', 0.0231, 'lps'),
	(508064, 131, '2014-01-15 01:04:15.000000', 'consum', 0.0226, 'lps'),
	(508065, 131, '2014-01-15 01:04:16.000000', 'consum', 0.0230, 'lps'),
	(508066, 131, '2014-01-15 01:04:17.000000', 'consum', 0.0219, 'lps'),
	(508067, 131, '2014-01-15 01:04:18.000000', 'consum', 0.0214, 'lps'),
	(508068, 131, '2014-01-15 01:04:19.000000', 'consum', 0.0228, 'lps'),
	(508069, 131, '2014-01-15 01:04:20.000000', 'consum', 0.0223, 'lps'),
	(508070, 131, '2014-01-15 01:04:21.000000', 'consum', 0.0221, 'lps'),
	(508071, 131, '2014-01-15 01:04:22.000000', 'consum', 0.0228, 'lps'),
	(508072, 131, '2014-01-15 01:04:23.000000', 'consum', 0.0222, 'lps'),
	(508073, 131, '2014-01-15 01:04:24.000000', 'consum', 0.0218, 'lps'),
	(508074, 131, '2014-01-15 01:04:25.000000', 'consum', 0.0214, 'lps'),
	(508075, 131, '2014-01-15 01:04:26.000000', 'consum', 0.0226, 'lps'),
	(508076, 131, '2014-01-15 01:04:27.000000', 'consum', 0.0216, 'lps'),
	(508077, 131, '2014-01-15 01:04:28.000000', 'consum', 0.0213, 'lps'),
	(508078, 131, '2014-01-15 01:04:29.000000', 'consum', 0.0230, 'lps'),
	(508079, 131, '2014-01-15 01:04:30.000000', 'consum', 0.0214, 'lps'),
	(508080, 131, '2014-01-15 01:04:31.000000', 'consum', 0.0213, 'lps'),
	(508081, 131, '2014-01-15 01:04:32.000000', 'consum', 0.0213, 'lps'),
	(508082, 131, '2014-01-15 01:04:33.000000', 'consum', 0.0217, 'lps'),
	(508083, 131, '2014-01-15 01:04:34.000000', 'consum', 0.0215, 'lps'),
	(508084, 131, '2014-01-15 01:04:35.000000', 'consum', 0.0216, 'lps'),
	(508085, 131, '2014-01-15 01:04:36.000000', 'consum', 0.0225, 'lps'),
	(508086, 131, '2014-01-15 01:04:37.000000', 'consum', 0.0224, 'lps'),
	(508087, 131, '2014-01-15 01:04:38.000000', 'consum', 0.0213, 'lps'),
	(508088, 131, '2014-01-15 01:04:39.000000', 'consum', 0.0229, 'lps'),
	(508089, 131, '2014-01-15 01:04:40.000000', 'consum', 0.0230, 'lps'),
	(508090, 131, '2014-01-15 01:04:41.000000', 'consum', 0.0210, 'lps'),
	(508091, 131, '2014-01-15 01:04:42.000000', 'consum', 0.0216, 'lps'),
	(508092, 131, '2014-01-15 01:04:43.000000', 'consum', 0.0216, 'lps'),
	(508093, 131, '2014-01-15 01:04:44.000000', 'consum', 0.0225, 'lps'),
	(508094, 131, '2014-01-15 01:04:45.000000', 'consum', 0.0224, 'lps'),
	(508095, 131, '2014-01-15 01:04:46.000000', 'consum', 0.0212, 'lps'),
	(508096, 131, '2014-01-15 01:04:47.000000', 'consum', 0.0225, 'lps'),
	(508097, 131, '2014-01-15 01:04:48.000000', 'consum', 0.0212, 'lps'),
	(508098, 131, '2014-01-15 01:04:49.000000', 'consum', 0.0221, 'lps'),
	(508099, 131, '2014-01-15 01:04:50.000000', 'consum', 0.0215, 'lps'),
	(508100, 131, '2014-01-15 01:04:51.000000', 'consum', 0.0225, 'lps'),
	(508101, 131, '2014-01-15 01:04:52.000000', 'consum', 0.0227, 'lps'),
	(508102, 131, '2014-01-15 01:04:53.000000', 'consum', 0.0229, 'lps'),
	(508103, 131, '2014-01-15 01:04:54.000000', 'consum', 0.0230, 'lps'),
	(508104, 131, '2014-01-15 01:04:55.000000', 'consum', 0.0231, 'lps'),
	(508105, 131, '2014-01-15 01:04:56.000000', 'consum', 0.0214, 'lps'),
	(508106, 131, '2014-01-15 01:04:57.000000', 'consum', 0.0210, 'lps'),
	(508107, 131, '2014-01-15 01:04:58.000000', 'consum', 0.0222, 'lps'),
	(508108, 131, '2014-01-15 01:04:59.000000', 'consum', 0.0226, 'lps'),
	(508109, 131, '2014-01-15 01:05:00.000000', 'consum', 0.0231, 'lps'),
	(508110, 131, '2014-01-15 01:05:01.000000', 'consum', 0.0224, 'lps'),
	(508111, 131, '2014-01-15 01:05:02.000000', 'consum', 0.0220, 'lps'),
	(508112, 131, '2014-01-15 01:05:03.000000', 'consum', 0.0215, 'lps'),
	(508113, 131, '2014-01-15 01:05:04.000000', 'consum', 0.0230, 'lps'),
	(508114, 131, '2014-01-15 01:05:05.000000', 'consum', 0.0228, 'lps'),
	(508115, 131, '2014-01-15 01:05:06.000000', 'consum', 0.0221, 'lps'),
	(508116, 131, '2014-01-15 01:05:07.000000', 'consum', 0.0231, 'lps'),
	(508117, 131, '2014-01-15 01:05:08.000000', 'consum', 0.0216, 'lps'),
	(508118, 131, '2014-01-15 01:05:09.000000', 'consum', 0.0224, 'lps'),
	(508119, 131, '2014-01-15 01:05:10.000000', 'consum', 0.0216, 'lps'),
	(508120, 131, '2014-01-15 01:05:11.000000', 'consum', 0.0221, 'lps'),
	(508121, 131, '2014-01-15 01:05:12.000000', 'consum', 0.0225, 'lps'),
	(508122, 131, '2014-01-15 01:05:13.000000', 'consum', 0.0230, 'lps'),
	(508123, 131, '2014-01-15 01:05:14.000000', 'consum', 0.0222, 'lps'),
	(508124, 131, '2014-01-15 01:05:15.000000', 'consum', 0.0212, 'lps'),
	(508125, 131, '2014-01-15 01:05:16.000000', 'consum', 0.0227, 'lps'),
	(508126, 131, '2014-01-15 01:05:17.000000', 'consum', 0.0224, 'lps'),
	(508127, 131, '2014-01-15 01:05:18.000000', 'consum', 0.0228, 'lps'),
	(508128, 131, '2014-01-15 01:05:19.000000', 'consum', 0.0217, 'lps'),
	(508129, 131, '2014-01-15 01:05:20.000000', 'consum', 0.0214, 'lps'),
	(508130, 131, '2014-01-15 01:05:21.000000', 'consum', 0.0229, 'lps'),
	(508131, 131, '2014-01-15 01:05:22.000000', 'consum', 0.0230, 'lps'),
	(508132, 131, '2014-01-15 01:05:23.000000', 'consum', 0.0231, 'lps'),
	(508133, 131, '2014-01-15 01:05:24.000000', 'consum', 0.0210, 'lps'),
	(508134, 131, '2014-01-15 01:05:25.000000', 'consum', 0.0212, 'lps'),
	(508135, 131, '2014-01-15 01:05:26.000000', 'consum', 0.0224, 'lps'),
	(508136, 131, '2014-01-15 01:05:27.000000', 'consum', 0.0228, 'lps'),
	(508137, 131, '2014-01-15 01:05:28.000000', 'consum', 0.0215, 'lps'),
	(508138, 131, '2014-01-15 01:05:29.000000', 'consum', 0.0227, 'lps'),
	(508139, 131, '2014-01-15 01:05:30.000000', 'consum', 0.0212, 'lps'),
	(508140, 131, '2014-01-15 01:05:31.000000', 'consum', 0.0213, 'lps'),
	(508141, 131, '2014-01-15 01:05:32.000000', 'consum', 0.0221, 'lps'),
	(508142, 131, '2014-01-15 01:05:33.000000', 'consum', 0.0211, 'lps'),
	(508143, 131, '2014-01-15 01:05:34.000000', 'consum', 0.0227, 'lps'),
	(508144, 131, '2014-01-15 01:05:35.000000', 'consum', 0.0227, 'lps'),
	(508145, 131, '2014-01-15 01:05:36.000000', 'consum', 0.0221, 'lps'),
	(508146, 131, '2014-01-15 01:05:37.000000', 'consum', 0.0214, 'lps'),
	(508147, 131, '2014-01-15 01:05:38.000000', 'consum', 0.0221, 'lps'),
	(508148, 131, '2014-01-15 01:05:39.000000', 'consum', 0.0230, 'lps'),
	(508149, 131, '2014-01-15 01:05:40.000000', 'consum', 0.0212, 'lps'),
	(508150, 131, '2014-01-15 01:05:41.000000', 'consum', 0.0229, 'lps'),
	(508151, 131, '2014-01-15 01:05:42.000000', 'consum', 0.0230, 'lps'),
	(508152, 131, '2014-01-15 01:05:43.000000', 'consum', 0.0211, 'lps'),
	(508153, 131, '2014-01-15 01:05:44.000000', 'consum', 0.0222, 'lps'),
	(508154, 131, '2014-01-15 01:05:45.000000', 'consum', 0.0221, 'lps'),
	(508155, 131, '2014-01-15 01:05:46.000000', 'consum', 0.0210, 'lps'),
	(508156, 131, '2014-01-15 01:05:47.000000', 'consum', 0.0222, 'lps'),
	(508157, 131, '2014-01-15 01:05:48.000000', 'consum', 0.0228, 'lps'),
	(508158, 131, '2014-01-15 01:05:49.000000', 'consum', 0.0218, 'lps'),
	(508159, 131, '2014-01-15 01:05:50.000000', 'consum', 0.0217, 'lps'),
	(508160, 131, '2014-01-15 01:05:51.000000', 'consum', 0.0223, 'lps'),
	(508161, 131, '2014-01-15 01:05:52.000000', 'consum', 0.0213, 'lps'),
	(508162, 131, '2014-01-15 01:05:53.000000', 'consum', 0.0227, 'lps'),
	(508163, 131, '2014-01-15 01:05:54.000000', 'consum', 0.0222, 'lps'),
	(508164, 131, '2014-01-15 01:05:55.000000', 'consum', 0.0218, 'lps'),
	(508165, 131, '2014-01-15 01:05:56.000000', 'consum', 0.0214, 'lps'),
	(508166, 131, '2014-01-15 01:05:57.000000', 'consum', 0.0230, 'lps'),
	(508167, 131, '2014-01-15 01:05:58.000000', 'consum', 0.0210, 'lps'),
	(508168, 131, '2014-01-15 01:05:59.000000', 'consum', 0.0217, 'lps'),
	(508169, 131, '2014-01-15 01:06:00.000000', 'consum', 0.0225, 'lps'),
	(508170, 131, '2014-01-15 01:06:01.000000', 'consum', 0.0218, 'lps'),
	(508171, 131, '2014-01-15 01:06:02.000000', 'consum', 0.0229, 'lps'),
	(508172, 131, '2014-01-15 01:06:03.000000', 'consum', 0.0214, 'lps'),
	(508173, 131, '2014-01-15 01:06:04.000000', 'consum', 0.0217, 'lps'),
	(508174, 131, '2014-01-15 01:06:05.000000', 'consum', 0.0214, 'lps'),
	(508175, 131, '2014-01-15 01:06:06.000000', 'consum', 0.0231, 'lps'),
	(508176, 131, '2014-01-15 01:06:07.000000', 'consum', 0.0216, 'lps'),
	(508177, 131, '2014-01-15 01:06:08.000000', 'consum', 0.0219, 'lps'),
	(508178, 131, '2014-01-15 01:06:09.000000', 'consum', 0.0218, 'lps'),
	(508179, 131, '2014-01-15 01:06:10.000000', 'consum', 0.0224, 'lps'),
	(508180, 131, '2014-01-15 01:06:11.000000', 'consum', 0.0213, 'lps'),
	(508181, 131, '2014-01-15 01:06:12.000000', 'consum', 0.0227, 'lps'),
	(508182, 131, '2014-01-15 01:06:13.000000', 'consum', 0.0222, 'lps'),
	(508183, 131, '2014-01-15 01:06:14.000000', 'consum', 0.0218, 'lps'),
	(508184, 131, '2014-01-15 01:06:15.000000', 'consum', 0.0215, 'lps'),
	(508185, 131, '2014-01-15 01:06:16.000000', 'consum', 0.0213, 'lps'),
	(508186, 131, '2014-01-15 01:06:17.000000', 'consum', 0.0231, 'lps'),
	(508187, 131, '2014-01-15 01:06:18.000000', 'consum', 0.0217, 'lps'),
	(508188, 131, '2014-01-15 01:06:19.000000', 'consum', 0.0229, 'lps'),
	(508189, 131, '2014-01-15 01:06:20.000000', 'consum', 0.0219, 'lps'),
	(508190, 131, '2014-01-15 01:06:21.000000', 'consum', 0.0219, 'lps'),
	(508191, 131, '2014-01-15 01:06:22.000000', 'consum', 0.0231, 'lps'),
	(508192, 131, '2014-01-15 01:06:23.000000', 'consum', 0.0219, 'lps'),
	(508193, 131, '2014-01-15 01:06:24.000000', 'consum', 0.0217, 'lps'),
	(508194, 131, '2014-01-15 01:06:25.000000', 'consum', 0.0218, 'lps'),
	(508195, 131, '2014-01-15 01:06:26.000000', 'consum', 0.0231, 'lps'),
	(508196, 131, '2014-01-15 01:06:27.000000', 'consum', 0.0225, 'lps'),
	(508197, 131, '2014-01-15 01:06:28.000000', 'consum', 0.0221, 'lps'),
	(508198, 131, '2014-01-15 01:06:29.000000', 'consum', 0.0221, 'lps'),
	(508199, 131, '2014-01-15 01:06:30.000000', 'consum', 0.0212, 'lps'),
	(508200, 131, '2014-01-15 01:06:31.000000', 'consum', 0.0230, 'lps'),
	(508201, 131, '2014-01-15 01:06:32.000000', 'consum', 0.0215, 'lps'),
	(508202, 131, '2014-01-15 01:06:33.000000', 'consum', 0.0220, 'lps'),
	(508203, 131, '2014-01-15 01:06:34.000000', 'consum', 0.0226, 'lps'),
	(508204, 131, '2014-01-15 01:06:35.000000', 'consum', 0.0213, 'lps'),
	(508205, 131, '2014-01-15 01:06:36.000000', 'consum', 0.0224, 'lps'),
	(508206, 131, '2014-01-15 01:06:37.000000', 'consum', 0.0227, 'lps'),
	(508207, 131, '2014-01-15 01:06:38.000000', 'consum', 0.0210, 'lps'),
	(508208, 131, '2014-01-15 01:06:39.000000', 'consum', 0.0227, 'lps'),
	(508209, 131, '2014-01-15 01:06:40.000000', 'consum', 0.0227, 'lps'),
	(508210, 131, '2014-01-15 01:06:41.000000', 'consum', 0.0222, 'lps'),
	(508211, 131, '2014-01-15 01:06:42.000000', 'consum', 0.0221, 'lps'),
	(508212, 131, '2014-01-15 01:06:43.000000', 'consum', 0.0229, 'lps'),
	(508213, 131, '2014-01-15 01:06:44.000000', 'consum', 0.0229, 'lps'),
	(508214, 131, '2014-01-15 01:06:45.000000', 'consum', 0.0225, 'lps'),
	(508215, 131, '2014-01-15 01:06:46.000000', 'consum', 0.0229, 'lps'),
	(508216, 131, '2014-01-15 01:06:47.000000', 'consum', 0.0216, 'lps'),
	(508217, 131, '2014-01-15 01:06:48.000000', 'consum', 0.0227, 'lps'),
	(508218, 131, '2014-01-15 01:06:49.000000', 'consum', 0.0214, 'lps'),
	(508219, 131, '2014-01-15 01:06:50.000000', 'consum', 0.0222, 'lps'),
	(508220, 131, '2014-01-15 01:06:51.000000', 'consum', 0.0214, 'lps'),
	(508221, 131, '2014-01-15 01:06:52.000000', 'consum', 0.0219, 'lps'),
	(508222, 131, '2014-01-15 01:06:53.000000', 'consum', 0.0219, 'lps'),
	(508223, 131, '2014-01-15 01:06:54.000000', 'consum', 0.0227, 'lps'),
	(508224, 131, '2014-01-15 01:06:55.000000', 'consum', 0.0227, 'lps'),
	(508225, 131, '2014-01-15 01:06:56.000000', 'consum', 0.0222, 'lps'),
	(508226, 131, '2014-01-15 01:06:57.000000', 'consum', 0.0221, 'lps'),
	(508227, 131, '2014-01-15 01:06:58.000000', 'consum', 0.0227, 'lps'),
	(508228, 131, '2014-01-15 01:06:59.000000', 'consum', 0.0220, 'lps'),
	(508229, 131, '2014-01-15 01:07:00.000000', 'consum', 0.0211, 'lps'),
	(508230, 131, '2014-01-15 01:07:01.000000', 'consum', 0.0226, 'lps'),
	(508231, 131, '2014-01-15 01:07:02.000000', 'consum', 0.0225, 'lps'),
	(508232, 131, '2014-01-15 01:07:03.000000', 'consum', 0.0214, 'lps'),
	(508233, 131, '2014-01-15 01:07:04.000000', 'consum', 0.0229, 'lps'),
	(508234, 131, '2014-01-15 01:07:05.000000', 'consum', 0.0229, 'lps'),
	(508235, 131, '2014-01-15 01:07:06.000000', 'consum', 0.0227, 'lps'),
	(508236, 131, '2014-01-15 01:07:07.000000', 'consum', 0.0214, 'lps'),
	(508237, 131, '2014-01-15 01:07:08.000000', 'consum', 0.0227, 'lps'),
	(508238, 131, '2014-01-15 01:07:09.000000', 'consum', 0.0214, 'lps'),
	(508239, 131, '2014-01-15 01:07:10.000000', 'consum', 0.0225, 'lps'),
	(508240, 131, '2014-01-15 01:07:11.000000', 'consum', 0.0231, 'lps'),
	(508241, 131, '2014-01-15 01:07:12.000000', 'consum', 0.0225, 'lps'),
	(508242, 131, '2014-01-15 01:07:13.000000', 'consum', 0.0223, 'lps'),
	(508243, 131, '2014-01-15 01:07:14.000000', 'consum', 0.0231, 'lps'),
	(508244, 131, '2014-01-15 01:07:15.000000', 'consum', 0.0231, 'lps'),
	(508245, 131, '2014-01-15 01:07:16.000000', 'consum', 0.0230, 'lps'),
	(508246, 131, '2014-01-15 01:07:17.000000', 'consum', 0.0225, 'lps'),
	(508247, 131, '2014-01-15 01:07:18.000000', 'consum', 0.0224, 'lps'),
	(508248, 131, '2014-01-15 01:07:19.000000', 'consum', 0.0217, 'lps'),
	(508249, 131, '2014-01-15 01:07:20.000000', 'consum', 0.0224, 'lps'),
	(508250, 131, '2014-01-15 01:07:21.000000', 'consum', 0.0214, 'lps'),
	(508251, 131, '2014-01-15 01:07:22.000000', 'consum', 0.0210, 'lps'),
	(508252, 131, '2014-01-15 01:07:23.000000', 'consum', 0.0223, 'lps'),
	(508253, 131, '2014-01-15 01:07:24.000000', 'consum', 0.0231, 'lps'),
	(508254, 131, '2014-01-15 01:07:25.000000', 'consum', 0.0230, 'lps'),
	(508255, 131, '2014-01-15 01:07:26.000000', 'consum', 0.0228, 'lps'),
	(508256, 131, '2014-01-15 01:07:27.000000', 'consum', 0.0218, 'lps'),
	(508257, 131, '2014-01-15 01:07:28.000000', 'consum', 0.0220, 'lps'),
	(508258, 131, '2014-01-15 01:07:29.000000', 'consum', 0.0214, 'lps'),
	(508259, 131, '2014-01-15 01:07:30.000000', 'consum', 0.0223, 'lps'),
	(508260, 131, '2014-01-15 01:07:31.000000', 'consum', 0.0218, 'lps'),
	(508261, 131, '2014-01-15 01:07:32.000000', 'consum', 0.0214, 'lps'),
	(508262, 131, '2014-01-15 01:07:33.000000', 'consum', 0.0226, 'lps'),
	(508263, 131, '2014-01-15 01:07:34.000000', 'consum', 0.0213, 'lps'),
	(508264, 131, '2014-01-15 01:07:35.000000', 'consum', 0.0223, 'lps'),
	(508265, 131, '2014-01-15 01:07:36.000000', 'consum', 0.0221, 'lps'),
	(508266, 131, '2014-01-15 01:07:37.000000', 'consum', 0.0227, 'lps'),
	(508267, 131, '2014-01-15 01:07:38.000000', 'consum', 0.0220, 'lps'),
	(508268, 131, '2014-01-15 01:07:39.000000', 'consum', 0.0210, 'lps'),
	(508269, 131, '2014-01-15 01:07:40.000000', 'consum', 0.0221, 'lps'),
	(508270, 131, '2014-01-15 01:07:41.000000', 'consum', 0.0225, 'lps'),
	(508271, 131, '2014-01-15 01:07:42.000000', 'consum', 0.0230, 'lps'),
	(508272, 131, '2014-01-15 01:07:43.000000', 'consum', 0.0219, 'lps'),
	(508273, 131, '2014-01-15 01:07:44.000000', 'consum', 0.0221, 'lps'),
	(508274, 131, '2014-01-15 01:07:45.000000', 'consum', 0.0213, 'lps'),
	(508275, 131, '2014-01-15 01:07:46.000000', 'consum', 0.0217, 'lps'),
	(508276, 131, '2014-01-15 01:07:47.000000', 'consum', 0.0212, 'lps'),
	(508277, 131, '2014-01-15 01:07:48.000000', 'consum', 0.0222, 'lps'),
	(508278, 131, '2014-01-15 01:07:49.000000', 'consum', 0.0220, 'lps'),
	(508279, 131, '2014-01-15 01:07:50.000000', 'consum', 0.0224, 'lps'),
	(508280, 131, '2014-01-15 01:07:51.000000', 'consum', 0.0230, 'lps'),
	(508281, 131, '2014-01-15 01:07:52.000000', 'consum', 0.0225, 'lps'),
	(508282, 131, '2014-01-15 01:07:53.000000', 'consum', 0.0223, 'lps'),
	(508283, 131, '2014-01-15 01:07:54.000000', 'consum', 0.0210, 'lps'),
	(508284, 131, '2014-01-15 01:07:55.000000', 'consum', 0.0217, 'lps'),
	(508285, 131, '2014-01-15 01:07:56.000000', 'consum', 0.0223, 'lps'),
	(508286, 131, '2014-01-15 01:07:57.000000', 'consum', 0.0210, 'lps'),
	(508287, 131, '2014-01-15 01:07:58.000000', 'consum', 0.0216, 'lps'),
	(508288, 131, '2014-01-15 01:07:59.000000', 'consum', 0.0217, 'lps'),
	(508289, 131, '2014-01-15 01:08:00.000000', 'consum', 0.0229, 'lps'),
	(508290, 131, '2014-01-15 01:08:01.000000', 'consum', 0.0217, 'lps'),
	(508291, 131, '2014-01-15 01:08:02.000000', 'consum', 0.0212, 'lps'),
	(508292, 131, '2014-01-15 01:08:03.000000', 'consum', 0.0219, 'lps'),
	(508293, 131, '2014-01-15 01:08:04.000000', 'consum', 0.0228, 'lps'),
	(508294, 131, '2014-01-15 01:08:05.000000', 'consum', 0.0210, 'lps'),
	(508295, 131, '2014-01-15 01:08:06.000000', 'consum', 0.0220, 'lps'),
	(508296, 131, '2014-01-15 01:08:07.000000', 'consum', 0.0216, 'lps'),
	(508297, 131, '2014-01-15 01:08:08.000000', 'consum', 0.0211, 'lps'),
	(508298, 131, '2014-01-15 01:08:09.000000', 'consum', 0.0219, 'lps'),
	(508299, 131, '2014-01-15 01:08:10.000000', 'consum', 0.0229, 'lps'),
	(508300, 131, '2014-01-15 01:08:11.000000', 'consum', 0.0214, 'lps'),
	(508301, 131, '2014-01-15 01:08:12.000000', 'consum', 0.0217, 'lps'),
	(508302, 131, '2014-01-15 01:08:13.000000', 'consum', 0.0210, 'lps'),
	(508303, 131, '2014-01-15 01:08:14.000000', 'consum', 0.0213, 'lps'),
	(508304, 131, '2014-01-15 01:08:15.000000', 'consum', 0.0226, 'lps'),
	(508305, 131, '2014-01-15 01:08:16.000000', 'consum', 0.0214, 'lps'),
	(508306, 131, '2014-01-15 01:08:17.000000', 'consum', 0.0229, 'lps'),
	(508307, 131, '2014-01-15 01:08:18.000000', 'consum', 0.0227, 'lps'),
	(508308, 131, '2014-01-15 01:08:19.000000', 'consum', 0.0217, 'lps'),
	(508309, 131, '2014-01-15 01:08:20.000000', 'consum', 0.0214, 'lps'),
	(508310, 131, '2014-01-15 01:08:21.000000', 'consum', 0.0211, 'lps'),
	(508311, 131, '2014-01-15 01:08:22.000000', 'consum', 0.0227, 'lps'),
	(508312, 131, '2014-01-15 01:08:23.000000', 'consum', 0.0227, 'lps'),
	(508313, 131, '2014-01-15 01:08:24.000000', 'consum', 0.0220, 'lps'),
	(508314, 131, '2014-01-15 01:08:25.000000', 'consum', 0.0212, 'lps'),
	(508315, 131, '2014-01-15 01:08:26.000000', 'consum', 0.0213, 'lps'),
	(508316, 131, '2014-01-15 01:08:27.000000', 'consum', 0.0220, 'lps'),
	(508317, 131, '2014-01-15 01:08:28.000000', 'consum', 0.0229, 'lps'),
	(508318, 131, '2014-01-15 01:08:29.000000', 'consum', 0.0230, 'lps'),
	(508319, 131, '2014-01-15 01:08:30.000000', 'consum', 0.0211, 'lps'),
	(508320, 131, '2014-01-15 01:08:31.000000', 'consum', 0.0219, 'lps'),
	(508321, 131, '2014-01-15 01:08:32.000000', 'consum', 0.0211, 'lps'),
	(508322, 131, '2014-01-15 01:08:33.000000', 'consum', 0.0210, 'lps'),
	(508323, 131, '2014-01-15 01:08:34.000000', 'consum', 0.0229, 'lps'),
	(508324, 131, '2014-01-15 01:08:35.000000', 'consum', 0.0219, 'lps'),
	(508325, 131, '2014-01-15 01:08:36.000000', 'consum', 0.0219, 'lps'),
	(508326, 131, '2014-01-15 01:08:37.000000', 'consum', 0.0231, 'lps'),
	(508327, 131, '2014-01-15 01:08:38.000000', 'consum', 0.0219, 'lps'),
	(508328, 131, '2014-01-15 01:08:39.000000', 'consum', 0.0217, 'lps'),
	(508329, 131, '2014-01-15 01:08:40.000000', 'consum', 0.0217, 'lps'),
	(508330, 131, '2014-01-15 01:08:41.000000', 'consum', 0.0224, 'lps'),
	(508331, 131, '2014-01-15 01:08:42.000000', 'consum', 0.0217, 'lps'),
	(508332, 131, '2014-01-15 01:08:43.000000', 'consum', 0.0227, 'lps'),
	(508333, 131, '2014-01-15 01:08:44.000000', 'consum', 0.0227, 'lps'),
	(508334, 131, '2014-01-15 01:08:45.000000', 'consum', 0.0225, 'lps'),
	(508335, 131, '2014-01-15 01:08:46.000000', 'consum', 0.0212, 'lps'),
	(508336, 131, '2014-01-15 01:08:47.000000', 'consum', 0.0221, 'lps'),
	(508337, 131, '2014-01-15 01:08:48.000000', 'consum', 0.0213, 'lps'),
	(508338, 131, '2014-01-15 01:08:49.000000', 'consum', 0.0215, 'lps'),
	(508339, 131, '2014-01-15 01:08:50.000000', 'consum', 0.0227, 'lps'),
	(508340, 131, '2014-01-15 01:08:51.000000', 'consum', 0.0216, 'lps'),
	(508341, 131, '2014-01-15 01:08:52.000000', 'consum', 0.0231, 'lps'),
	(508342, 131, '2014-01-15 01:08:53.000000', 'consum', 0.0231, 'lps'),
	(508343, 131, '2014-01-15 01:08:54.000000', 'consum', 0.0231, 'lps'),
	(508344, 131, '2014-01-15 01:08:55.000000', 'consum', 0.0230, 'lps'),
	(508345, 131, '2014-01-15 01:08:56.000000', 'consum', 0.0225, 'lps'),
	(508346, 131, '2014-01-15 01:08:57.000000', 'consum', 0.0228, 'lps'),
	(508347, 131, '2014-01-15 01:08:58.000000', 'consum', 0.0210, 'lps'),
	(508348, 131, '2014-01-15 01:08:59.000000', 'consum', 0.0221, 'lps'),
	(508349, 131, '2014-01-15 01:09:00.000000', 'consum', 0.0224, 'lps'),
	(508350, 131, '2014-01-15 01:09:01.000000', 'consum', 0.0223, 'lps'),
	(508351, 131, '2014-01-15 01:09:02.000000', 'consum', 0.0213, 'lps'),
	(508352, 131, '2014-01-15 01:09:03.000000', 'consum', 0.0231, 'lps'),
	(508353, 131, '2014-01-15 01:09:04.000000', 'consum', 0.0219, 'lps'),
	(508354, 131, '2014-01-15 01:09:05.000000', 'consum', 0.0214, 'lps'),
	(508355, 131, '2014-01-15 01:09:06.000000', 'consum', 0.0227, 'lps'),
	(508356, 131, '2014-01-15 01:09:07.000000', 'consum', 0.0215, 'lps'),
	(508357, 131, '2014-01-15 01:09:08.000000', 'consum', 0.0230, 'lps'),
	(508358, 131, '2014-01-15 01:09:09.000000', 'consum', 0.0230, 'lps'),
	(508359, 131, '2014-01-15 01:09:10.000000', 'consum', 0.0227, 'lps'),
	(508360, 131, '2014-01-15 01:09:11.000000', 'consum', 0.0213, 'lps'),
	(508361, 131, '2014-01-15 01:09:12.000000', 'consum', 0.0218, 'lps'),
	(508362, 131, '2014-01-15 01:09:13.000000', 'consum', 0.0219, 'lps'),
	(508363, 131, '2014-01-15 01:09:14.000000', 'consum', 0.0212, 'lps'),
	(508364, 131, '2014-01-15 01:09:15.000000', 'consum', 0.0212, 'lps'),
	(508365, 131, '2014-01-15 01:09:16.000000', 'consum', 0.0218, 'lps'),
	(508366, 131, '2014-01-15 01:09:17.000000', 'consum', 0.0221, 'lps'),
	(508367, 131, '2014-01-15 01:09:18.000000', 'consum', 0.0219, 'lps'),
	(508368, 131, '2014-01-15 01:09:19.000000', 'consum', 0.0222, 'lps'),
	(508369, 131, '2014-01-15 01:09:20.000000', 'consum', 0.0224, 'lps'),
	(508370, 131, '2014-01-15 01:09:21.000000', 'consum', 0.0221, 'lps'),
	(508371, 131, '2014-01-15 01:09:22.000000', 'consum', 0.0223, 'lps'),
	(508372, 131, '2014-01-15 01:09:23.000000', 'consum', 0.0223, 'lps'),
	(508373, 131, '2014-01-15 01:09:24.000000', 'consum', 0.0212, 'lps'),
	(508374, 131, '2014-01-15 01:09:25.000000', 'consum', 0.0225, 'lps'),
	(508375, 131, '2014-01-15 01:09:26.000000', 'consum', 0.0215, 'lps'),
	(508376, 131, '2014-01-15 01:09:27.000000', 'consum', 0.0210, 'lps'),
	(508377, 131, '2014-01-15 01:09:28.000000', 'consum', 0.0219, 'lps'),
	(508378, 131, '2014-01-15 01:09:29.000000', 'consum', 0.0211, 'lps'),
	(508379, 131, '2014-01-15 01:09:30.000000', 'consum', 0.0211, 'lps'),
	(508380, 131, '2014-01-15 01:09:31.000000', 'consum', 0.0211, 'lps'),
	(508381, 131, '2014-01-15 01:09:32.000000', 'consum', 0.0212, 'lps'),
	(508382, 131, '2014-01-15 01:09:33.000000', 'consum', 0.0220, 'lps'),
	(508383, 131, '2014-01-15 01:09:34.000000', 'consum', 0.0231, 'lps'),
	(508384, 131, '2014-01-15 01:09:35.000000', 'consum', 0.0218, 'lps'),
	(508385, 131, '2014-01-15 01:09:36.000000', 'consum', 0.0210, 'lps'),
	(508386, 131, '2014-01-15 01:09:37.000000', 'consum', 0.0211, 'lps'),
	(508387, 131, '2014-01-15 01:09:38.000000', 'consum', 0.0215, 'lps'),
	(508388, 131, '2014-01-15 01:09:39.000000', 'consum', 0.0230, 'lps'),
	(508389, 131, '2014-01-15 01:09:40.000000', 'consum', 0.0210, 'lps'),
	(508390, 131, '2014-01-15 01:09:41.000000', 'consum', 0.0214, 'lps'),
	(508391, 131, '2014-01-15 01:09:42.000000', 'consum', 0.0211, 'lps'),
	(508392, 131, '2014-01-15 01:09:43.000000', 'consum', 0.0225, 'lps'),
	(508393, 131, '2014-01-15 01:09:44.000000', 'consum', 0.0216, 'lps'),
	(508394, 131, '2014-01-15 01:09:45.000000', 'consum', 0.0219, 'lps'),
	(508395, 131, '2014-01-15 01:09:46.000000', 'consum', 0.0213, 'lps'),
	(508396, 131, '2014-01-15 01:09:47.000000', 'consum', 0.0224, 'lps'),
	(508397, 131, '2014-01-15 01:09:48.000000', 'consum', 0.0224, 'lps'),
	(508398, 131, '2014-01-15 01:09:49.000000', 'consum', 0.0220, 'lps'),
	(508399, 131, '2014-01-15 01:09:50.000000', 'consum', 0.0216, 'lps'),
	(508400, 131, '2014-01-15 01:09:51.000000', 'consum', 0.0212, 'lps'),
	(508401, 131, '2014-01-15 01:09:52.000000', 'consum', 0.0222, 'lps'),
	(508402, 131, '2014-01-15 01:09:53.000000', 'consum', 0.0224, 'lps'),
	(508403, 131, '2014-01-15 01:09:54.000000', 'consum', 0.0221, 'lps'),
	(508404, 131, '2014-01-15 01:09:55.000000', 'consum', 0.0223, 'lps'),
	(508405, 131, '2014-01-15 01:09:56.000000', 'consum', 0.0220, 'lps'),
	(508406, 131, '2014-01-15 01:09:57.000000', 'consum', 0.0223, 'lps'),
	(508407, 131, '2014-01-15 01:09:58.000000', 'consum', 0.0224, 'lps'),
	(508408, 131, '2014-01-15 01:09:59.000000', 'consum', 0.0219, 'lps'),
	(508409, 131, '2014-01-15 01:10:00.000000', 'consum', 0.0212, 'lps'),
	(508410, 131, '2014-01-15 01:10:01.000000', 'consum', 0.0218, 'lps'),
	(508411, 131, '2014-01-15 01:10:02.000000', 'consum', 0.0222, 'lps'),
	(508412, 131, '2014-01-15 01:10:03.000000', 'consum', 0.0223, 'lps'),
	(508413, 131, '2014-01-15 01:10:04.000000', 'consum', 0.0217, 'lps'),
	(508414, 131, '2014-01-15 01:10:05.000000', 'consum', 0.0230, 'lps'),
	(508415, 131, '2014-01-15 01:10:06.000000', 'consum', 0.0223, 'lps'),
	(508416, 131, '2014-01-15 01:10:07.000000', 'consum', 0.0218, 'lps'),
	(508417, 131, '2014-01-15 01:10:08.000000', 'consum', 0.0230, 'lps'),
	(508418, 131, '2014-01-15 01:10:09.000000', 'consum', 0.0221, 'lps'),
	(508419, 131, '2014-01-15 01:10:10.000000', 'consum', 0.0228, 'lps'),
	(508420, 131, '2014-01-15 01:10:11.000000', 'consum', 0.0223, 'lps'),
	(508421, 131, '2014-01-15 01:10:12.000000', 'consum', 0.0222, 'lps'),
	(508422, 131, '2014-01-15 01:10:13.000000', 'consum', 0.0230, 'lps'),
	(508423, 131, '2014-01-15 01:10:14.000000', 'consum', 0.0210, 'lps'),
	(508424, 131, '2014-01-15 01:10:15.000000', 'consum', 0.0218, 'lps'),
	(508425, 131, '2014-01-15 01:10:16.000000', 'consum', 0.0226, 'lps'),
	(508426, 131, '2014-01-15 01:10:17.000000', 'consum', 0.0225, 'lps'),
	(508427, 131, '2014-01-15 01:10:18.000000', 'consum', 0.0216, 'lps'),
	(508428, 131, '2014-01-15 01:10:19.000000', 'consum', 0.0217, 'lps'),
	(508429, 131, '2014-01-15 01:10:20.000000', 'consum', 0.0227, 'lps'),
	(508430, 131, '2014-01-15 01:10:21.000000', 'consum', 0.0230, 'lps'),
	(508431, 131, '2014-01-15 01:10:22.000000', 'consum', 0.0218, 'lps'),
	(508432, 131, '2014-01-15 01:10:23.000000', 'consum', 0.0231, 'lps'),
	(508433, 131, '2014-01-15 01:10:24.000000', 'consum', 0.0228, 'lps'),
	(508434, 131, '2014-01-15 01:10:25.000000', 'consum', 0.0217, 'lps'),
	(508435, 131, '2014-01-15 01:10:26.000000', 'consum', 0.0211, 'lps'),
	(508436, 131, '2014-01-15 01:10:27.000000', 'consum', 0.0216, 'lps'),
	(508437, 131, '2014-01-15 01:10:28.000000', 'consum', 0.0214, 'lps'),
	(508438, 131, '2014-01-15 01:10:29.000000', 'consum', 0.0215, 'lps'),
	(508439, 131, '2014-01-15 01:10:30.000000', 'consum', 0.0222, 'lps'),
	(508440, 131, '2014-01-15 01:10:31.000000', 'consum', 0.0213, 'lps'),
	(508441, 131, '2014-01-15 01:10:32.000000', 'consum', 0.0212, 'lps'),
	(508442, 131, '2014-01-15 01:10:33.000000', 'consum', 0.0213, 'lps'),
	(508443, 131, '2014-01-15 01:10:34.000000', 'consum', 0.0217, 'lps'),
	(508444, 131, '2014-01-15 01:10:35.000000', 'consum', 0.0213, 'lps'),
	(508445, 131, '2014-01-15 01:10:36.000000', 'consum', 0.0230, 'lps'),
	(508446, 131, '2014-01-15 01:10:37.000000', 'consum', 0.0210, 'lps'),
	(508447, 131, '2014-01-15 01:10:38.000000', 'consum', 0.0218, 'lps'),
	(508448, 131, '2014-01-15 01:10:39.000000', 'consum', 0.0229, 'lps'),
	(508449, 131, '2014-01-15 01:10:40.000000', 'consum', 0.0214, 'lps'),
	(508450, 131, '2014-01-15 01:10:41.000000', 'consum', 0.0220, 'lps'),
	(508451, 131, '2014-01-15 01:10:42.000000', 'consum', 0.0225, 'lps'),
	(508452, 131, '2014-01-15 01:10:43.000000', 'consum', 0.0213, 'lps'),
	(508453, 131, '2014-01-15 01:10:44.000000', 'consum', 0.0225, 'lps'),
	(508454, 131, '2014-01-15 01:10:45.000000', 'consum', 0.0231, 'lps'),
	(508455, 131, '2014-01-15 01:10:46.000000', 'consum', 0.0225, 'lps'),
	(508456, 131, '2014-01-15 01:10:47.000000', 'consum', 0.0226, 'lps'),
	(508457, 131, '2014-01-15 01:10:48.000000', 'consum', 0.0222, 'lps'),
	(508458, 131, '2014-01-15 01:10:49.000000', 'consum', 0.0221, 'lps'),
	(508459, 131, '2014-01-15 01:10:50.000000', 'consum', 0.0231, 'lps'),
	(508460, 131, '2014-01-15 01:10:51.000000', 'consum', 0.0215, 'lps'),
	(508461, 131, '2014-01-15 01:10:52.000000', 'consum', 0.0216, 'lps'),
	(508462, 131, '2014-01-15 01:10:53.000000', 'consum', 0.0225, 'lps'),
	(508463, 131, '2014-01-15 01:10:54.000000', 'consum', 0.0224, 'lps'),
	(508464, 131, '2014-01-15 01:10:55.000000', 'consum', 0.0215, 'lps'),
	(508465, 131, '2014-01-15 01:10:56.000000', 'consum', 0.0214, 'lps'),
	(508466, 131, '2014-01-15 01:10:57.000000', 'consum', 0.0215, 'lps'),
	(508467, 131, '2014-01-15 01:10:58.000000', 'consum', 0.0223, 'lps'),
	(508468, 131, '2014-01-15 01:10:59.000000', 'consum', 0.0217, 'lps'),
	(508469, 131, '2014-01-15 01:11:00.000000', 'consum', 0.0228, 'lps'),
	(508470, 131, '2014-01-15 01:11:01.000000', 'consum', 0.0215, 'lps'),
	(508471, 131, '2014-01-15 01:11:02.000000', 'consum', 0.0224, 'lps'),
	(508472, 131, '2014-01-15 01:11:03.000000', 'consum', 0.0224, 'lps'),
	(508473, 131, '2014-01-15 01:11:04.000000', 'consum', 0.0213, 'lps'),
	(508474, 131, '2014-01-15 01:11:05.000000', 'consum', 0.0230, 'lps'),
	(508475, 131, '2014-01-15 01:11:06.000000', 'consum', 0.0214, 'lps'),
	(508476, 131, '2014-01-15 01:11:07.000000', 'consum', 0.0215, 'lps'),
	(508477, 131, '2014-01-15 01:11:08.000000', 'consum', 0.0221, 'lps'),
	(508478, 131, '2014-01-15 01:11:09.000000', 'consum', 0.0228, 'lps'),
	(508479, 131, '2014-01-15 01:11:10.000000', 'consum', 0.0223, 'lps'),
	(508480, 131, '2014-01-15 01:11:11.000000', 'consum', 0.0222, 'lps'),
	(508481, 131, '2014-01-15 01:11:12.000000', 'consum', 0.0212, 'lps'),
	(508482, 131, '2014-01-15 01:11:13.000000', 'consum', 0.0226, 'lps'),
	(508483, 131, '2014-01-15 01:11:14.000000', 'consum', 0.0218, 'lps'),
	(508484, 131, '2014-01-15 01:11:15.000000', 'consum', 0.0225, 'lps'),
	(508485, 131, '2014-01-15 01:11:16.000000', 'consum', 0.0217, 'lps'),
	(508486, 131, '2014-01-15 01:11:17.000000', 'consum', 0.0224, 'lps'),
	(508487, 131, '2014-01-15 01:11:18.000000', 'consum', 0.0215, 'lps'),
	(508488, 131, '2014-01-15 01:11:19.000000', 'consum', 0.0215, 'lps'),
	(508489, 131, '2014-01-15 01:11:20.000000', 'consum', 0.0222, 'lps'),
	(508490, 131, '2014-01-15 01:11:21.000000', 'consum', 0.0231, 'lps'),
	(508491, 127, '2014-02-01 00:00:00.000000', 'consum', 0.0210, 'lps'),
	(508492, 127, '2014-02-01 00:00:01.000000', 'consum', 0.0217, 'lps'),
	(508493, 127, '2014-02-01 00:00:02.000000', 'consum', 0.0213, 'lps'),
	(508494, 127, '2014-02-01 00:00:03.000000', 'consum', 0.0219, 'lps'),
	(508495, 127, '2014-02-01 00:00:04.000000', 'consum', 0.0217, 'lps'),
	(508496, 127, '2014-02-01 00:00:05.000000', 'consum', 0.0218, 'lps'),
	(508497, 127, '2014-02-01 00:00:06.000000', 'consum', 0.0214, 'lps'),
	(508498, 127, '2014-02-01 00:00:07.000000', 'consum', 0.0223, 'lps'),
	(508499, 127, '2014-02-01 00:00:08.000000', 'consum', 0.0215, 'lps'),
	(508500, 127, '2014-02-01 00:00:09.000000', 'consum', 0.0211, 'lps'),
	(508501, 127, '2014-02-01 00:00:10.000000', 'consum', 0.0218, 'lps'),
	(508502, 127, '2014-02-01 00:00:11.000000', 'consum', 0.0217, 'lps'),
	(508503, 127, '2014-02-01 00:00:12.000000', 'consum', 0.0220, 'lps'),
	(508504, 127, '2014-02-01 00:00:13.000000', 'consum', 0.0224, 'lps'),
	(508505, 127, '2014-02-01 00:00:14.000000', 'consum', 0.0219, 'lps'),
	(508506, 127, '2014-02-01 00:00:15.000000', 'consum', 0.0211, 'lps'),
	(508507, 127, '2014-02-01 00:00:16.000000', 'consum', 0.0224, 'lps'),
	(508508, 127, '2014-02-01 00:00:17.000000', 'consum', 0.0211, 'lps'),
	(508509, 127, '2014-02-01 00:00:18.000000', 'consum', 0.0224, 'lps'),
	(508510, 127, '2014-02-01 00:00:19.000000', 'consum', 0.0211, 'lps'),
	(508511, 127, '2014-02-01 00:00:20.000000', 'consum', 0.0223, 'lps'),
	(508512, 127, '2014-02-01 00:00:21.000000', 'consum', 0.0210, 'lps'),
	(508513, 127, '2014-02-01 00:00:22.000000', 'consum', 0.0218, 'lps'),
	(508514, 127, '2014-02-01 00:00:23.000000', 'consum', 0.0218, 'lps'),
	(508515, 127, '2014-02-01 00:00:24.000000', 'consum', 0.0210, 'lps'),
	(508516, 127, '2014-02-01 00:00:25.000000', 'consum', 0.0218, 'lps'),
	(508517, 127, '2014-02-01 00:00:26.000000', 'consum', 0.0219, 'lps'),
	(508518, 127, '2014-02-01 00:00:27.000000', 'consum', 0.0215, 'lps'),
	(508519, 127, '2014-02-01 00:00:28.000000', 'consum', 0.0211, 'lps'),
	(508520, 127, '2014-02-01 00:00:29.000000', 'consum', 0.0214, 'lps'),
	(508521, 127, '2014-02-01 00:00:30.000000', 'consum', 0.0212, 'lps'),
	(508522, 127, '2014-02-01 00:00:31.000000', 'consum', 0.0225, 'lps'),
	(508523, 127, '2014-02-01 00:00:32.000000', 'consum', 0.0216, 'lps'),
	(508524, 127, '2014-02-01 00:00:33.000000', 'consum', 0.0211, 'lps'),
	(508525, 127, '2014-02-01 00:00:34.000000', 'consum', 0.0212, 'lps'),
	(508526, 127, '2014-02-01 00:00:35.000000', 'consum', 0.0218, 'lps'),
	(508527, 127, '2014-02-01 00:00:36.000000', 'consum', 0.0213, 'lps'),
	(508528, 127, '2014-02-01 00:00:37.000000', 'consum', 0.0217, 'lps'),
	(508529, 127, '2014-02-01 00:00:38.000000', 'consum', 0.0219, 'lps'),
	(508530, 127, '2014-02-01 00:00:39.000000', 'consum', 0.0221, 'lps'),
	(508531, 127, '2014-02-01 00:00:40.000000', 'consum', 0.0223, 'lps'),
	(508532, 127, '2014-02-01 00:00:41.000000', 'consum', 0.0225, 'lps'),
	(508533, 127, '2014-02-01 00:00:42.000000', 'consum', 0.0214, 'lps'),
	(508534, 127, '2014-02-01 00:00:43.000000', 'consum', 0.0220, 'lps'),
	(508535, 127, '2014-02-01 00:00:44.000000', 'consum', 0.0216, 'lps'),
	(508536, 127, '2014-02-01 00:00:45.000000', 'consum', 0.0210, 'lps'),
	(508537, 127, '2014-02-01 00:00:46.000000', 'consum', 0.0224, 'lps'),
	(508538, 127, '2014-02-01 00:00:47.000000', 'consum', 0.0218, 'lps'),
	(508539, 127, '2014-02-01 00:00:48.000000', 'consum', 0.0223, 'lps'),
	(508540, 127, '2014-02-01 00:00:49.000000', 'consum', 0.0221, 'lps'),
	(508541, 127, '2014-02-01 00:00:50.000000', 'consum', 0.0225, 'lps'),
	(508542, 127, '2014-02-01 00:00:51.000000', 'consum', 0.0223, 'lps'),
	(508543, 127, '2014-02-01 00:00:52.000000', 'consum', 0.0213, 'lps'),
	(508544, 127, '2014-02-01 00:00:53.000000', 'consum', 0.0220, 'lps'),
	(508545, 127, '2014-02-01 00:00:54.000000', 'consum', 0.0219, 'lps'),
	(508546, 127, '2014-02-01 00:00:55.000000', 'consum', 0.0211, 'lps'),
	(508547, 127, '2014-02-01 00:00:56.000000', 'consum', 0.0218, 'lps'),
	(508548, 127, '2014-02-01 00:00:57.000000', 'consum', 0.0214, 'lps'),
	(508549, 127, '2014-02-01 00:00:58.000000', 'consum', 0.0225, 'lps'),
	(508550, 127, '2014-02-01 00:00:59.000000', 'consum', 0.0210, 'lps'),
	(508551, 127, '2014-02-01 00:01:00.000000', 'consum', 0.0212, 'lps'),
	(508552, 127, '2014-02-01 00:01:01.000000', 'consum', 0.0222, 'lps'),
	(508553, 127, '2014-02-01 00:01:02.000000', 'consum', 0.0217, 'lps'),
	(508554, 127, '2014-02-01 00:01:03.000000', 'consum', 0.0211, 'lps'),
	(508555, 127, '2014-02-01 00:01:04.000000', 'consum', 0.0224, 'lps'),
	(508556, 127, '2014-02-01 00:01:05.000000', 'consum', 0.0215, 'lps'),
	(508557, 127, '2014-02-01 00:01:06.000000', 'consum', 0.0223, 'lps'),
	(508558, 127, '2014-02-01 00:01:07.000000', 'consum', 0.0213, 'lps'),
	(508559, 127, '2014-02-01 00:01:08.000000', 'consum', 0.0218, 'lps'),
	(508560, 127, '2014-02-01 00:01:09.000000', 'consum', 0.0212, 'lps'),
	(508561, 127, '2014-02-01 00:01:10.000000', 'consum', 0.0213, 'lps'),
	(508562, 127, '2014-02-01 00:01:11.000000', 'consum', 0.0217, 'lps'),
	(508563, 127, '2014-02-01 00:01:12.000000', 'consum', 0.0222, 'lps'),
	(508564, 127, '2014-02-01 00:01:13.000000', 'consum', 0.0219, 'lps'),
	(508565, 127, '2014-02-01 00:01:14.000000', 'consum', 0.0217, 'lps'),
	(508566, 127, '2014-02-01 00:01:15.000000', 'consum', 0.0219, 'lps'),
	(508567, 127, '2014-02-01 00:01:16.000000', 'consum', 0.0217, 'lps'),
	(508568, 127, '2014-02-01 00:01:17.000000', 'consum', 0.0221, 'lps'),
	(508569, 127, '2014-02-01 00:01:18.000000', 'consum', 0.0210, 'lps'),
	(508570, 127, '2014-02-01 00:01:19.000000', 'consum', 0.0225, 'lps'),
	(508571, 127, '2014-02-01 00:01:20.000000', 'consum', 0.0221, 'lps'),
	(508572, 127, '2014-02-01 00:01:21.000000', 'consum', 0.0224, 'lps'),
	(508573, 127, '2014-02-01 00:01:22.000000', 'consum', 0.0212, 'lps'),
	(508574, 127, '2014-02-01 00:01:23.000000', 'consum', 0.0211, 'lps'),
	(508575, 127, '2014-02-01 00:01:24.000000', 'consum', 0.0225, 'lps'),
	(508576, 127, '2014-02-01 00:01:25.000000', 'consum', 0.0219, 'lps'),
	(508577, 127, '2014-02-01 00:01:26.000000', 'consum', 0.0212, 'lps'),
	(508578, 127, '2014-02-01 00:01:27.000000', 'consum', 0.0223, 'lps'),
	(508579, 127, '2014-02-01 00:01:28.000000', 'consum', 0.0224, 'lps'),
	(508580, 127, '2014-02-01 00:01:29.000000', 'consum', 0.0223, 'lps'),
	(508581, 127, '2014-02-01 00:01:30.000000', 'consum', 0.0217, 'lps'),
	(508582, 127, '2014-02-01 00:01:31.000000', 'consum', 0.0222, 'lps'),
	(508583, 127, '2014-02-01 00:01:32.000000', 'consum', 0.0217, 'lps'),
	(508584, 127, '2014-02-01 00:01:33.000000', 'consum', 0.0211, 'lps'),
	(508585, 127, '2014-02-01 00:01:34.000000', 'consum', 0.0211, 'lps'),
	(508586, 127, '2014-02-01 00:01:35.000000', 'consum', 0.0214, 'lps'),
	(508587, 127, '2014-02-01 00:01:36.000000', 'consum', 0.0210, 'lps'),
	(508588, 127, '2014-02-01 00:01:37.000000', 'consum', 0.0213, 'lps'),
	(508589, 127, '2014-02-01 00:01:38.000000', 'consum', 0.0210, 'lps'),
	(508590, 127, '2014-02-01 00:01:39.000000', 'consum', 0.0220, 'lps'),
	(508591, 127, '2014-02-01 00:01:40.000000', 'consum', 0.0225, 'lps'),
	(508592, 127, '2014-02-01 00:01:41.000000', 'consum', 0.0210, 'lps'),
	(508593, 127, '2014-02-01 00:01:42.000000', 'consum', 0.0213, 'lps'),
	(508594, 127, '2014-02-01 00:01:43.000000', 'consum', 0.0225, 'lps'),
	(508595, 127, '2014-02-01 00:01:44.000000', 'consum', 0.0212, 'lps'),
	(508596, 127, '2014-02-01 00:01:45.000000', 'consum', 0.0223, 'lps'),
	(508597, 127, '2014-02-01 00:01:46.000000', 'consum', 0.0223, 'lps'),
	(508598, 127, '2014-02-01 00:01:47.000000', 'consum', 0.0218, 'lps'),
	(508599, 127, '2014-02-01 00:01:48.000000', 'consum', 0.0214, 'lps'),
	(508600, 127, '2014-02-01 00:01:49.000000', 'consum', 0.0223, 'lps'),
	(508601, 127, '2014-02-01 00:01:50.000000', 'consum', 0.0214, 'lps'),
	(508602, 127, '2014-02-01 00:01:51.000000', 'consum', 0.0222, 'lps'),
	(508603, 127, '2014-02-01 00:01:52.000000', 'consum', 0.0213, 'lps'),
	(508604, 127, '2014-02-01 00:01:53.000000', 'consum', 0.0220, 'lps'),
	(508605, 127, '2014-02-01 00:01:54.000000', 'consum', 0.0218, 'lps'),
	(508606, 127, '2014-02-01 00:01:55.000000', 'consum', 0.0222, 'lps'),
	(508607, 127, '2014-02-01 00:01:56.000000', 'consum', 0.0212, 'lps'),
	(508608, 127, '2014-02-01 00:01:57.000000', 'consum', 0.0220, 'lps'),
	(508609, 127, '2014-02-01 00:01:58.000000', 'consum', 0.0219, 'lps'),
	(508610, 127, '2014-02-01 00:01:59.000000', 'consum', 0.0212, 'lps'),
	(508611, 127, '2014-02-01 00:02:00.000000', 'consum', 0.0225, 'lps'),
	(508612, 127, '2014-02-01 00:02:01.000000', 'consum', 0.0218, 'lps'),
	(508613, 127, '2014-02-01 00:02:02.000000', 'consum', 0.0218, 'lps'),
	(508614, 127, '2014-02-01 00:02:03.000000', 'consum', 0.0210, 'lps'),
	(508615, 127, '2014-02-01 00:02:04.000000', 'consum', 0.0218, 'lps'),
	(508616, 127, '2014-02-01 00:02:05.000000', 'consum', 0.0222, 'lps'),
	(508617, 127, '2014-02-01 00:02:06.000000', 'consum', 0.0212, 'lps'),
	(508618, 127, '2014-02-01 00:02:07.000000', 'consum', 0.0216, 'lps'),
	(508619, 127, '2014-02-01 00:02:08.000000', 'consum', 0.0218, 'lps'),
	(508620, 127, '2014-02-01 00:02:09.000000', 'consum', 0.0216, 'lps'),
	(508621, 127, '2014-02-01 00:02:10.000000', 'consum', 0.0218, 'lps'),
	(508622, 127, '2014-02-01 00:02:11.000000', 'consum', 0.0216, 'lps'),
	(508623, 127, '2014-02-01 00:02:12.000000', 'consum', 0.0214, 'lps'),
	(508624, 127, '2014-02-01 00:02:13.000000', 'consum', 0.0216, 'lps'),
	(508625, 127, '2014-02-01 00:02:14.000000', 'consum', 0.0213, 'lps'),
	(508626, 127, '2014-02-01 00:02:15.000000', 'consum', 0.0223, 'lps'),
	(508627, 127, '2014-02-01 00:02:16.000000', 'consum', 0.0218, 'lps'),
	(508628, 127, '2014-02-01 00:02:17.000000', 'consum', 0.0225, 'lps'),
	(508629, 127, '2014-02-01 00:02:18.000000', 'consum', 0.0217, 'lps'),
	(508630, 127, '2014-02-01 00:02:19.000000', 'consum', 0.0216, 'lps'),
	(508631, 127, '2014-02-01 00:02:20.000000', 'consum', 0.0218, 'lps'),
	(508632, 127, '2014-02-01 00:02:21.000000', 'consum', 0.0216, 'lps'),
	(508633, 127, '2014-02-01 00:02:22.000000', 'consum', 0.0219, 'lps'),
	(508634, 127, '2014-02-01 00:02:23.000000', 'consum', 0.0222, 'lps'),
	(508635, 127, '2014-02-01 00:02:24.000000', 'consum', 0.0212, 'lps'),
	(508636, 127, '2014-02-01 00:02:25.000000', 'consum', 0.0216, 'lps'),
	(508637, 127, '2014-02-01 00:02:26.000000', 'consum', 0.0218, 'lps'),
	(508638, 127, '2014-02-01 00:02:27.000000', 'consum', 0.0218, 'lps'),
	(508639, 127, '2014-02-01 00:02:28.000000', 'consum', 0.0211, 'lps'),
	(508640, 127, '2014-02-01 00:02:29.000000', 'consum', 0.0220, 'lps'),
	(508641, 127, '2014-02-01 00:02:30.000000', 'consum', 0.0213, 'lps'),
	(508642, 127, '2014-02-01 00:02:31.000000', 'consum', 0.0212, 'lps'),
	(508643, 127, '2014-02-01 00:02:32.000000', 'consum', 0.0225, 'lps'),
	(508644, 127, '2014-02-01 00:02:33.000000', 'consum', 0.0215, 'lps'),
	(508645, 127, '2014-02-01 00:02:34.000000', 'consum', 0.0224, 'lps'),
	(508646, 127, '2014-02-01 00:02:35.000000', 'consum', 0.0218, 'lps'),
	(508647, 127, '2014-02-01 00:02:36.000000', 'consum', 0.0224, 'lps'),
	(508648, 127, '2014-02-01 00:02:37.000000', 'consum', 0.0225, 'lps'),
	(508649, 127, '2014-02-01 00:02:38.000000', 'consum', 0.0211, 'lps'),
	(508650, 127, '2014-02-01 00:02:39.000000', 'consum', 0.0217, 'lps'),
	(508651, 127, '2014-02-01 00:02:40.000000', 'consum', 0.0214, 'lps'),
	(508652, 127, '2014-02-01 00:02:41.000000', 'consum', 0.0222, 'lps'),
	(508653, 127, '2014-02-01 00:02:42.000000', 'consum', 0.0213, 'lps'),
	(508654, 127, '2014-02-01 00:02:43.000000', 'consum', 0.0219, 'lps'),
	(508655, 127, '2014-02-01 00:02:44.000000', 'consum', 0.0214, 'lps'),
	(508656, 127, '2014-02-01 00:02:45.000000', 'consum', 0.0219, 'lps'),
	(508657, 127, '2014-02-01 00:02:46.000000', 'consum', 0.0211, 'lps'),
	(508658, 127, '2014-02-01 00:02:47.000000', 'consum', 0.0220, 'lps'),
	(508659, 127, '2014-02-01 00:02:48.000000', 'consum', 0.0212, 'lps'),
	(508660, 127, '2014-02-01 00:02:49.000000', 'consum', 0.0222, 'lps'),
	(508661, 127, '2014-02-01 00:02:50.000000', 'consum', 0.0218, 'lps'),
	(508662, 127, '2014-02-01 00:02:51.000000', 'consum', 0.0213, 'lps'),
	(508663, 127, '2014-02-01 00:02:52.000000', 'consum', 0.0220, 'lps'),
	(508664, 127, '2014-02-01 00:02:53.000000', 'consum', 0.0217, 'lps'),
	(508665, 127, '2014-02-01 00:02:54.000000', 'consum', 0.0216, 'lps'),
	(508666, 127, '2014-02-01 00:02:55.000000', 'consum', 0.0221, 'lps'),
	(508667, 127, '2014-02-01 00:02:56.000000', 'consum', 0.0213, 'lps'),
	(508668, 127, '2014-02-01 00:02:57.000000', 'consum', 0.0210, 'lps'),
	(508669, 127, '2014-02-01 00:02:58.000000', 'consum', 0.0217, 'lps'),
	(508670, 127, '2014-02-01 00:02:59.000000', 'consum', 0.0216, 'lps'),
	(508671, 127, '2014-02-01 00:03:00.000000', 'consum', 0.0216, 'lps'),
	(508672, 127, '2014-02-01 00:03:01.000000', 'consum', 0.0225, 'lps'),
	(508673, 127, '2014-02-01 00:03:02.000000', 'consum', 0.0221, 'lps'),
	(508674, 127, '2014-02-01 00:03:03.000000', 'consum', 0.0217, 'lps'),
	(508675, 127, '2014-02-01 00:03:04.000000', 'consum', 0.0214, 'lps'),
	(508676, 127, '2014-02-01 00:03:05.000000', 'consum', 0.0225, 'lps'),
	(508677, 127, '2014-02-01 00:03:06.000000', 'consum', 0.0225, 'lps'),
	(508678, 127, '2014-02-01 00:03:07.000000', 'consum', 0.0211, 'lps'),
	(508679, 127, '2014-02-01 00:03:08.000000', 'consum', 0.0218, 'lps'),
	(508680, 127, '2014-02-01 00:03:09.000000', 'consum', 0.0213, 'lps'),
	(508681, 127, '2014-02-01 00:03:10.000000', 'consum', 0.0220, 'lps'),
	(508682, 127, '2014-02-01 00:03:11.000000', 'consum', 0.0219, 'lps'),
	(508683, 127, '2014-02-01 00:03:12.000000', 'consum', 0.0223, 'lps'),
	(508684, 127, '2014-02-01 00:03:13.000000', 'consum', 0.0219, 'lps'),
	(508685, 127, '2014-02-01 00:03:14.000000', 'consum', 0.0217, 'lps'),
	(508686, 127, '2014-02-01 00:03:15.000000', 'consum', 0.0218, 'lps'),
	(508687, 127, '2014-02-01 00:03:16.000000', 'consum', 0.0215, 'lps'),
	(508688, 127, '2014-02-01 00:03:17.000000', 'consum', 0.0212, 'lps'),
	(508689, 127, '2014-02-01 00:03:18.000000', 'consum', 0.0221, 'lps'),
	(508690, 127, '2014-02-01 00:03:19.000000', 'consum', 0.0211, 'lps'),
	(508691, 127, '2014-02-01 00:03:20.000000', 'consum', 0.0215, 'lps'),
	(508692, 127, '2014-02-01 00:03:21.000000', 'consum', 0.0215, 'lps'),
	(508693, 127, '2014-02-01 00:03:22.000000', 'consum', 0.0222, 'lps'),
	(508694, 127, '2014-02-01 00:03:23.000000', 'consum', 0.0222, 'lps'),
	(508695, 127, '2014-02-01 00:03:24.000000', 'consum', 0.0221, 'lps'),
	(508696, 127, '2014-02-01 00:03:25.000000', 'consum', 0.0211, 'lps'),
	(508697, 127, '2014-02-01 00:03:26.000000', 'consum', 0.0214, 'lps'),
	(508698, 127, '2014-02-01 00:03:27.000000', 'consum', 0.0211, 'lps'),
	(508699, 127, '2014-02-01 00:03:28.000000', 'consum', 0.0220, 'lps'),
	(508700, 127, '2014-02-01 00:03:29.000000', 'consum', 0.0225, 'lps'),
	(508701, 127, '2014-02-01 00:03:30.000000', 'consum', 0.0224, 'lps'),
	(508702, 127, '2014-02-01 00:03:31.000000', 'consum', 0.0221, 'lps'),
	(508703, 127, '2014-02-01 00:03:32.000000', 'consum', 0.0221, 'lps'),
	(508704, 127, '2014-02-01 00:03:33.000000', 'consum', 0.0217, 'lps'),
	(508705, 127, '2014-02-01 00:03:34.000000', 'consum', 0.0212, 'lps'),
	(508706, 127, '2014-02-01 00:03:35.000000', 'consum', 0.0214, 'lps'),
	(508707, 127, '2014-02-01 00:03:36.000000', 'consum', 0.0211, 'lps'),
	(508708, 127, '2014-02-01 00:03:37.000000', 'consum', 0.0220, 'lps'),
	(508709, 127, '2014-02-01 00:03:38.000000', 'consum', 0.0225, 'lps'),
	(508710, 127, '2014-02-01 00:03:39.000000', 'consum', 0.0225, 'lps'),
	(508711, 127, '2014-02-01 00:03:40.000000', 'consum', 0.0224, 'lps'),
	(508712, 127, '2014-02-01 00:03:41.000000', 'consum', 0.0219, 'lps'),
	(508713, 127, '2014-02-01 00:03:42.000000', 'consum', 0.0213, 'lps'),
	(508714, 127, '2014-02-01 00:03:43.000000', 'consum', 0.0215, 'lps'),
	(508715, 127, '2014-02-01 00:03:44.000000', 'consum', 0.0225, 'lps'),
	(508716, 127, '2014-02-01 00:03:45.000000', 'consum', 0.0222, 'lps'),
	(508717, 127, '2014-02-01 00:03:46.000000', 'consum', 0.0212, 'lps'),
	(508718, 127, '2014-02-01 00:03:47.000000', 'consum', 0.0217, 'lps'),
	(508719, 127, '2014-02-01 00:03:48.000000', 'consum', 0.0221, 'lps'),
	(508720, 127, '2014-02-01 00:03:49.000000', 'consum', 0.0212, 'lps'),
	(508721, 127, '2014-02-01 00:03:50.000000', 'consum', 0.0222, 'lps'),
	(508722, 127, '2014-02-01 00:03:51.000000', 'consum', 0.0215, 'lps'),
	(508723, 127, '2014-02-01 00:03:52.000000', 'consum', 0.0216, 'lps'),
	(508724, 127, '2014-02-01 00:03:53.000000', 'consum', 0.0225, 'lps'),
	(508725, 127, '2014-02-01 00:03:54.000000', 'consum', 0.0222, 'lps'),
	(508726, 127, '2014-02-01 00:03:55.000000', 'consum', 0.0222, 'lps'),
	(508727, 127, '2014-02-01 00:03:56.000000', 'consum', 0.0221, 'lps'),
	(508728, 127, '2014-02-01 00:03:57.000000', 'consum', 0.0212, 'lps'),
	(508729, 127, '2014-02-01 00:03:58.000000', 'consum', 0.0218, 'lps'),
	(508730, 127, '2014-02-01 00:03:59.000000', 'consum', 0.0214, 'lps'),
	(508731, 127, '2014-02-01 00:04:00.000000', 'consum', 0.0221, 'lps'),
	(508732, 127, '2014-02-01 00:04:01.000000', 'consum', 0.0223, 'lps'),
	(508733, 127, '2014-02-01 00:04:02.000000', 'consum', 0.0210, 'lps'),
	(508734, 127, '2014-02-01 00:04:03.000000', 'consum', 0.0221, 'lps'),
	(508735, 127, '2014-02-01 00:04:04.000000', 'consum', 0.0218, 'lps'),
	(508736, 127, '2014-02-01 00:04:05.000000', 'consum', 0.0216, 'lps'),
	(508737, 127, '2014-02-01 00:04:06.000000', 'consum', 0.0218, 'lps'),
	(508738, 127, '2014-02-01 00:04:07.000000', 'consum', 0.0216, 'lps'),
	(508739, 127, '2014-02-01 00:04:08.000000', 'consum', 0.0218, 'lps'),
	(508740, 127, '2014-02-01 00:04:09.000000', 'consum', 0.0216, 'lps'),
	(508741, 127, '2014-02-01 00:04:10.000000', 'consum', 0.0217, 'lps'),
	(508742, 127, '2014-02-01 00:04:11.000000', 'consum', 0.0225, 'lps'),
	(508743, 127, '2014-02-01 00:04:12.000000', 'consum', 0.0218, 'lps'),
	(508744, 127, '2014-02-01 00:04:13.000000', 'consum', 0.0221, 'lps'),
	(508745, 127, '2014-02-01 00:04:14.000000', 'consum', 0.0224, 'lps'),
	(508746, 127, '2014-02-01 00:04:15.000000', 'consum', 0.0218, 'lps'),
	(508747, 127, '2014-02-01 00:04:16.000000', 'consum', 0.0223, 'lps'),
	(508748, 127, '2014-02-01 00:04:17.000000', 'consum', 0.0218, 'lps'),
	(508749, 127, '2014-02-01 00:04:18.000000', 'consum', 0.0214, 'lps'),
	(508750, 127, '2014-02-01 00:04:19.000000', 'consum', 0.0224, 'lps'),
	(508751, 127, '2014-02-01 00:04:20.000000', 'consum', 0.0217, 'lps'),
	(508752, 127, '2014-02-01 00:04:21.000000', 'consum', 0.0222, 'lps'),
	(508753, 127, '2014-02-01 00:04:22.000000', 'consum', 0.0215, 'lps'),
	(508754, 127, '2014-02-01 00:04:23.000000', 'consum', 0.0216, 'lps'),
	(508755, 127, '2014-02-01 00:04:24.000000', 'consum', 0.0211, 'lps'),
	(508756, 127, '2014-02-01 00:04:25.000000', 'consum', 0.0213, 'lps'),
	(508757, 127, '2014-02-01 00:04:26.000000', 'consum', 0.0224, 'lps'),
	(508758, 127, '2014-02-01 00:04:27.000000', 'consum', 0.0221, 'lps'),
	(508759, 127, '2014-02-01 00:04:28.000000', 'consum', 0.0210, 'lps'),
	(508760, 127, '2014-02-01 00:04:29.000000', 'consum', 0.0224, 'lps'),
	(508761, 127, '2014-02-01 00:04:30.000000', 'consum', 0.0216, 'lps'),
	(508762, 127, '2014-02-01 00:04:31.000000', 'consum', 0.0215, 'lps'),
	(508763, 127, '2014-02-01 00:04:32.000000', 'consum', 0.0220, 'lps'),
	(508764, 127, '2014-02-01 00:04:33.000000', 'consum', 0.0210, 'lps'),
	(508765, 127, '2014-02-01 00:04:34.000000', 'consum', 0.0213, 'lps'),
	(508766, 127, '2014-02-01 00:04:35.000000', 'consum', 0.0211, 'lps'),
	(508767, 127, '2014-02-01 00:04:36.000000', 'consum', 0.0221, 'lps'),
	(508768, 127, '2014-02-01 00:04:37.000000', 'consum', 0.0215, 'lps'),
	(508769, 127, '2014-02-01 00:04:38.000000', 'consum', 0.0218, 'lps'),
	(508770, 127, '2014-02-01 00:04:39.000000', 'consum', 0.0221, 'lps'),
	(508771, 127, '2014-02-01 00:04:40.000000', 'consum', 0.0223, 'lps'),
	(508772, 127, '2014-02-01 00:04:41.000000', 'consum', 0.0213, 'lps'),
	(508773, 127, '2014-02-01 00:04:42.000000', 'consum', 0.0216, 'lps'),
	(508774, 127, '2014-02-01 00:04:43.000000', 'consum', 0.0215, 'lps'),
	(508775, 127, '2014-02-01 00:04:44.000000', 'consum', 0.0217, 'lps'),
	(508776, 127, '2014-02-01 00:04:45.000000', 'consum', 0.0215, 'lps'),
	(508777, 127, '2014-02-01 00:04:46.000000', 'consum', 0.0215, 'lps'),
	(508778, 127, '2014-02-01 00:04:47.000000', 'consum', 0.0219, 'lps'),
	(508779, 127, '2014-02-01 00:04:48.000000', 'consum', 0.0211, 'lps'),
	(508780, 127, '2014-02-01 00:04:49.000000', 'consum', 0.0220, 'lps'),
	(508781, 127, '2014-02-01 00:04:50.000000', 'consum', 0.0225, 'lps'),
	(508782, 127, '2014-02-01 00:04:51.000000', 'consum', 0.0225, 'lps'),
	(508783, 127, '2014-02-01 00:04:52.000000', 'consum', 0.0222, 'lps'),
	(508784, 127, '2014-02-01 00:04:53.000000', 'consum', 0.0225, 'lps'),
	(508785, 127, '2014-02-01 00:04:54.000000', 'consum', 0.0217, 'lps'),
	(508786, 127, '2014-02-01 00:04:55.000000', 'consum', 0.0218, 'lps'),
	(508787, 127, '2014-02-01 00:04:56.000000', 'consum', 0.0213, 'lps'),
	(508788, 127, '2014-02-01 00:04:57.000000', 'consum', 0.0216, 'lps'),
	(508789, 127, '2014-02-01 00:04:58.000000', 'consum', 0.0216, 'lps'),
	(508790, 127, '2014-02-01 00:04:59.000000', 'consum', 0.0223, 'lps'),
	(508791, 127, '2014-02-01 00:05:00.000000', 'consum', 0.0210, 'lps'),
	(508792, 127, '2014-02-01 00:05:01.000000', 'consum', 0.0219, 'lps'),
	(508793, 127, '2014-02-01 00:05:02.000000', 'consum', 0.0224, 'lps'),
	(508794, 127, '2014-02-01 00:05:03.000000', 'consum', 0.0221, 'lps'),
	(508795, 127, '2014-02-01 00:05:04.000000', 'consum', 0.0210, 'lps'),
	(508796, 127, '2014-02-01 00:05:05.000000', 'consum', 0.0223, 'lps'),
	(508797, 127, '2014-02-01 00:05:06.000000', 'consum', 0.0210, 'lps'),
	(508798, 127, '2014-02-01 00:05:07.000000', 'consum', 0.0222, 'lps'),
	(508799, 127, '2014-02-01 00:05:08.000000', 'consum', 0.0220, 'lps'),
	(508800, 127, '2014-02-01 00:05:09.000000', 'consum', 0.0225, 'lps'),
	(508801, 127, '2014-02-01 00:05:10.000000', 'consum', 0.0225, 'lps'),
	(508802, 127, '2014-02-01 00:05:11.000000', 'consum', 0.0223, 'lps'),
	(508803, 127, '2014-02-01 00:05:12.000000', 'consum', 0.0217, 'lps'),
	(508804, 127, '2014-02-01 00:05:13.000000', 'consum', 0.0220, 'lps'),
	(508805, 127, '2014-02-01 00:05:14.000000', 'consum', 0.0224, 'lps'),
	(508806, 127, '2014-02-01 00:05:15.000000', 'consum', 0.0217, 'lps'),
	(508807, 127, '2014-02-01 00:05:16.000000', 'consum', 0.0219, 'lps'),
	(508808, 127, '2014-02-01 00:05:17.000000', 'consum', 0.0219, 'lps'),
	(508809, 127, '2014-02-01 00:05:18.000000', 'consum', 0.0214, 'lps'),
	(508810, 127, '2014-02-01 00:05:19.000000', 'consum', 0.0219, 'lps'),
	(508811, 127, '2014-02-01 00:05:20.000000', 'consum', 0.0213, 'lps'),
	(508812, 127, '2014-02-01 00:05:21.000000', 'consum', 0.0212, 'lps'),
	(508813, 127, '2014-02-01 00:05:22.000000', 'consum', 0.0212, 'lps'),
	(508814, 127, '2014-02-01 00:05:23.000000', 'consum', 0.0216, 'lps'),
	(508815, 127, '2014-02-01 00:05:24.000000', 'consum', 0.0219, 'lps'),
	(508816, 127, '2014-02-01 00:05:25.000000', 'consum', 0.0220, 'lps'),
	(508817, 127, '2014-02-01 00:05:26.000000', 'consum', 0.0218, 'lps'),
	(508818, 127, '2014-02-01 00:05:27.000000', 'consum', 0.0219, 'lps'),
	(508819, 127, '2014-02-01 00:05:28.000000', 'consum', 0.0215, 'lps'),
	(508820, 127, '2014-02-01 00:05:29.000000', 'consum', 0.0210, 'lps'),
	(508821, 127, '2014-02-01 00:05:30.000000', 'consum', 0.0225, 'lps'),
	(508822, 127, '2014-02-01 00:05:31.000000', 'consum', 0.0224, 'lps'),
	(508823, 127, '2014-02-01 00:05:32.000000', 'consum', 0.0219, 'lps'),
	(508824, 127, '2014-02-01 00:05:33.000000', 'consum', 0.0211, 'lps'),
	(508825, 127, '2014-02-01 00:05:34.000000', 'consum', 0.0223, 'lps'),
	(508826, 127, '2014-02-01 00:05:35.000000', 'consum', 0.0225, 'lps'),
	(508827, 127, '2014-02-01 00:05:36.000000', 'consum', 0.0213, 'lps'),
	(508828, 127, '2014-02-01 00:05:37.000000', 'consum', 0.0213, 'lps'),
	(508829, 127, '2014-02-01 00:05:38.000000', 'consum', 0.0217, 'lps'),
	(508830, 127, '2014-02-01 00:05:39.000000', 'consum', 0.0219, 'lps'),
	(508831, 127, '2014-02-01 00:05:40.000000', 'consum', 0.0221, 'lps'),
	(508832, 127, '2014-02-01 00:05:41.000000', 'consum', 0.0223, 'lps'),
	(508833, 127, '2014-02-01 00:05:42.000000', 'consum', 0.0225, 'lps'),
	(508834, 127, '2014-02-01 00:05:43.000000', 'consum', 0.0215, 'lps'),
	(508835, 127, '2014-02-01 00:05:44.000000', 'consum', 0.0222, 'lps'),
	(508836, 127, '2014-02-01 00:05:45.000000', 'consum', 0.0224, 'lps'),
	(508837, 127, '2014-02-01 00:05:46.000000', 'consum', 0.0214, 'lps'),
	(508838, 127, '2014-02-01 00:05:47.000000', 'consum', 0.0218, 'lps'),
	(508839, 127, '2014-02-01 00:05:48.000000', 'consum', 0.0222, 'lps'),
	(508840, 127, '2014-02-01 00:05:49.000000', 'consum', 0.0215, 'lps'),
	(508841, 127, '2014-02-01 00:05:50.000000', 'consum', 0.0218, 'lps'),
	(508842, 127, '2014-02-01 00:05:51.000000', 'consum', 0.0218, 'lps'),
	(508843, 127, '2014-02-01 00:05:52.000000', 'consum', 0.0225, 'lps'),
	(508844, 127, '2014-02-01 00:05:53.000000', 'consum', 0.0215, 'lps'),
	(508845, 127, '2014-02-01 00:05:54.000000', 'consum', 0.0223, 'lps'),
	(508846, 127, '2014-02-01 00:05:55.000000', 'consum', 0.0212, 'lps'),
	(508847, 127, '2014-02-01 00:05:56.000000', 'consum', 0.0213, 'lps'),
	(508848, 127, '2014-02-01 00:05:57.000000', 'consum', 0.0221, 'lps'),
	(508849, 127, '2014-02-01 00:05:58.000000', 'consum', 0.0223, 'lps'),
	(508850, 127, '2014-02-01 00:05:59.000000', 'consum', 0.0211, 'lps'),
	(508851, 127, '2014-02-01 00:06:00.000000', 'consum', 0.0210, 'lps'),
	(508852, 127, '2014-02-01 00:06:01.000000', 'consum', 0.0223, 'lps'),
	(508853, 127, '2014-02-01 00:06:02.000000', 'consum', 0.0210, 'lps'),
	(508854, 127, '2014-02-01 00:06:03.000000', 'consum', 0.0219, 'lps'),
	(508855, 127, '2014-02-01 00:06:04.000000', 'consum', 0.0210, 'lps'),
	(508856, 127, '2014-02-01 00:06:05.000000', 'consum', 0.0215, 'lps'),
	(508857, 127, '2014-02-01 00:06:06.000000', 'consum', 0.0218, 'lps'),
	(508858, 127, '2014-02-01 00:06:07.000000', 'consum', 0.0221, 'lps'),
	(508859, 127, '2014-02-01 00:06:08.000000', 'consum', 0.0224, 'lps'),
	(508860, 127, '2014-02-01 00:06:09.000000', 'consum', 0.0217, 'lps'),
	(508861, 127, '2014-02-01 00:06:10.000000', 'consum', 0.0219, 'lps'),
	(508862, 127, '2014-02-01 00:06:11.000000', 'consum', 0.0217, 'lps'),
	(508863, 127, '2014-02-01 00:06:12.000000', 'consum', 0.0218, 'lps'),
	(508864, 127, '2014-02-01 00:06:13.000000', 'consum', 0.0216, 'lps'),
	(508865, 127, '2014-02-01 00:06:14.000000', 'consum', 0.0214, 'lps'),
	(508866, 127, '2014-02-01 00:06:15.000000', 'consum', 0.0216, 'lps'),
	(508867, 127, '2014-02-01 00:06:16.000000', 'consum', 0.0225, 'lps'),
	(508868, 127, '2014-02-01 00:06:17.000000', 'consum', 0.0222, 'lps'),
	(508869, 127, '2014-02-01 00:06:18.000000', 'consum', 0.0225, 'lps'),
	(508870, 127, '2014-02-01 00:06:19.000000', 'consum', 0.0215, 'lps'),
	(508871, 127, '2014-02-01 00:06:20.000000', 'consum', 0.0225, 'lps'),
	(508872, 127, '2014-02-01 00:06:21.000000', 'consum', 0.0223, 'lps'),
	(508873, 127, '2014-02-01 00:06:22.000000', 'consum', 0.0216, 'lps'),
	(508874, 127, '2014-02-01 00:06:23.000000', 'consum', 0.0214, 'lps'),
	(508875, 127, '2014-02-01 00:06:24.000000', 'consum', 0.0214, 'lps'),
	(508876, 127, '2014-02-01 00:06:25.000000', 'consum', 0.0218, 'lps'),
	(508877, 127, '2014-02-01 00:06:26.000000', 'consum', 0.0223, 'lps'),
	(508878, 127, '2014-02-01 00:06:27.000000', 'consum', 0.0219, 'lps'),
	(508879, 127, '2014-02-01 00:06:28.000000', 'consum', 0.0215, 'lps'),
	(508880, 127, '2014-02-01 00:06:29.000000', 'consum', 0.0225, 'lps'),
	(508881, 127, '2014-02-01 00:06:30.000000', 'consum', 0.0223, 'lps'),
	(508882, 127, '2014-02-01 00:06:31.000000', 'consum', 0.0213, 'lps'),
	(508883, 127, '2014-02-01 00:06:32.000000', 'consum', 0.0221, 'lps'),
	(508884, 127, '2014-02-01 00:06:33.000000', 'consum', 0.0210, 'lps'),
	(508885, 127, '2014-02-01 00:06:34.000000', 'consum', 0.0222, 'lps'),
	(508886, 127, '2014-02-01 00:06:35.000000', 'consum', 0.0223, 'lps'),
	(508887, 127, '2014-02-01 00:06:36.000000', 'consum', 0.0225, 'lps'),
	(508888, 127, '2014-02-01 00:06:37.000000', 'consum', 0.0216, 'lps'),
	(508889, 127, '2014-02-01 00:06:38.000000', 'consum', 0.0224, 'lps'),
	(508890, 127, '2014-02-01 00:06:39.000000', 'consum', 0.0218, 'lps'),
	(508891, 127, '2014-02-01 00:06:40.000000', 'consum', 0.0222, 'lps'),
	(508892, 127, '2014-02-01 00:06:41.000000', 'consum', 0.0217, 'lps'),
	(508893, 127, '2014-02-01 00:06:42.000000', 'consum', 0.0224, 'lps'),
	(508894, 127, '2014-02-01 00:06:43.000000', 'consum', 0.0212, 'lps'),
	(508895, 127, '2014-02-01 00:06:44.000000', 'consum', 0.0210, 'lps'),
	(508896, 127, '2014-02-01 00:06:45.000000', 'consum', 0.0220, 'lps'),
	(508897, 127, '2014-02-01 00:06:46.000000', 'consum', 0.0215, 'lps'),
	(508898, 127, '2014-02-01 00:06:47.000000', 'consum', 0.0218, 'lps'),
	(508899, 127, '2014-02-01 00:06:48.000000', 'consum', 0.0223, 'lps'),
	(508900, 127, '2014-02-01 00:06:49.000000', 'consum', 0.0217, 'lps'),
	(508901, 127, '2014-02-01 00:06:50.000000', 'consum', 0.0222, 'lps'),
	(508902, 127, '2014-02-01 00:06:51.000000', 'consum', 0.0218, 'lps'),
	(508903, 127, '2014-02-01 00:06:52.000000', 'consum', 0.0216, 'lps'),
	(508904, 127, '2014-02-01 00:06:53.000000', 'consum', 0.0217, 'lps'),
	(508905, 127, '2014-02-01 00:06:54.000000', 'consum', 0.0211, 'lps'),
	(508906, 127, '2014-02-01 00:06:55.000000', 'consum', 0.0225, 'lps'),
	(508907, 127, '2014-02-01 00:06:56.000000', 'consum', 0.0217, 'lps'),
	(508908, 127, '2014-02-01 00:06:57.000000', 'consum', 0.0219, 'lps'),
	(508909, 127, '2014-02-01 00:06:58.000000', 'consum', 0.0220, 'lps'),
	(508910, 127, '2014-02-01 00:06:59.000000', 'consum', 0.0215, 'lps'),
	(508911, 127, '2014-02-01 00:07:00.000000', 'consum', 0.0220, 'lps'),
	(508912, 127, '2014-02-01 00:07:01.000000', 'consum', 0.0217, 'lps'),
	(508913, 127, '2014-02-01 00:07:02.000000', 'consum', 0.0214, 'lps'),
	(508914, 127, '2014-02-01 00:07:03.000000', 'consum', 0.0225, 'lps'),
	(508915, 127, '2014-02-01 00:07:04.000000', 'consum', 0.0210, 'lps'),
	(508916, 127, '2014-02-01 00:07:05.000000', 'consum', 0.0213, 'lps'),
	(508917, 127, '2014-02-01 00:07:06.000000', 'consum', 0.0211, 'lps'),
	(508918, 127, '2014-02-01 00:07:07.000000', 'consum', 0.0220, 'lps'),
	(508919, 127, '2014-02-01 00:07:08.000000', 'consum', 0.0225, 'lps'),
	(508920, 127, '2014-02-01 00:07:09.000000', 'consum', 0.0210, 'lps'),
	(508921, 127, '2014-02-01 00:07:10.000000', 'consum', 0.0212, 'lps'),
	(508922, 127, '2014-02-01 00:07:11.000000', 'consum', 0.0220, 'lps'),
	(508923, 127, '2014-02-01 00:07:12.000000', 'consum', 0.0221, 'lps'),
	(508924, 127, '2014-02-01 00:07:13.000000', 'consum', 0.0221, 'lps'),
	(508925, 127, '2014-02-01 00:07:14.000000', 'consum', 0.0218, 'lps'),
	(508926, 127, '2014-02-01 00:07:15.000000', 'consum', 0.0214, 'lps'),
	(508927, 127, '2014-02-01 00:07:16.000000', 'consum', 0.0210, 'lps'),
	(508928, 127, '2014-02-01 00:07:17.000000', 'consum', 0.0213, 'lps'),
	(508929, 127, '2014-02-01 00:07:18.000000', 'consum', 0.0224, 'lps'),
	(508930, 127, '2014-02-01 00:07:19.000000', 'consum', 0.0225, 'lps'),
	(508931, 127, '2014-02-01 00:07:20.000000', 'consum', 0.0210, 'lps'),
	(508932, 127, '2014-02-01 00:07:21.000000', 'consum', 0.0212, 'lps'),
	(508933, 127, '2014-02-01 00:07:22.000000', 'consum', 0.0224, 'lps'),
	(508934, 127, '2014-02-01 00:07:23.000000', 'consum', 0.0223, 'lps'),
	(508935, 127, '2014-02-01 00:07:24.000000', 'consum', 0.0221, 'lps'),
	(508936, 127, '2014-02-01 00:07:25.000000', 'consum', 0.0224, 'lps'),
	(508937, 127, '2014-02-01 00:07:26.000000', 'consum', 0.0216, 'lps'),
	(508938, 127, '2014-02-01 00:07:27.000000', 'consum', 0.0213, 'lps'),
	(508939, 127, '2014-02-01 00:07:28.000000', 'consum', 0.0210, 'lps'),
	(508940, 127, '2014-02-01 00:07:29.000000', 'consum', 0.0215, 'lps'),
	(508941, 127, '2014-02-01 00:07:30.000000', 'consum', 0.0222, 'lps'),
	(508942, 127, '2014-02-01 00:07:31.000000', 'consum', 0.0224, 'lps'),
	(508943, 127, '2014-02-01 00:07:32.000000', 'consum', 0.0225, 'lps'),
	(508944, 127, '2014-02-01 00:07:33.000000', 'consum', 0.0215, 'lps'),
	(508945, 127, '2014-02-01 00:07:34.000000', 'consum', 0.0221, 'lps'),
	(508946, 127, '2014-02-01 00:07:35.000000', 'consum', 0.0218, 'lps'),
	(508947, 127, '2014-02-01 00:07:36.000000', 'consum', 0.0219, 'lps'),
	(508948, 127, '2014-02-01 00:07:37.000000', 'consum', 0.0215, 'lps'),
	(508949, 127, '2014-02-01 00:07:38.000000', 'consum', 0.0224, 'lps'),
	(508950, 127, '2014-02-01 00:07:39.000000', 'consum', 0.0219, 'lps'),
	(508951, 127, '2014-02-01 00:07:40.000000', 'consum', 0.0214, 'lps'),
	(508952, 127, '2014-02-01 00:07:41.000000', 'consum', 0.0220, 'lps'),
	(508953, 127, '2014-02-01 00:07:42.000000', 'consum', 0.0218, 'lps'),
	(508954, 127, '2014-02-01 00:07:43.000000', 'consum', 0.0217, 'lps'),
	(508955, 127, '2014-02-01 00:07:44.000000', 'consum', 0.0221, 'lps'),
	(508956, 127, '2014-02-01 00:07:45.000000', 'consum', 0.0214, 'lps'),
	(508957, 127, '2014-02-01 00:07:46.000000', 'consum', 0.0212, 'lps'),
	(508958, 127, '2014-02-01 00:07:47.000000', 'consum', 0.0225, 'lps'),
	(508959, 127, '2014-02-01 00:07:48.000000', 'consum', 0.0214, 'lps'),
	(508960, 127, '2014-02-01 00:07:49.000000', 'consum', 0.0218, 'lps'),
	(508961, 127, '2014-02-01 00:07:50.000000', 'consum', 0.0223, 'lps'),
	(508962, 127, '2014-02-01 00:07:51.000000', 'consum', 0.0218, 'lps'),
	(508963, 127, '2014-02-01 00:07:52.000000', 'consum', 0.0214, 'lps'),
	(508964, 127, '2014-02-01 00:07:53.000000', 'consum', 0.0221, 'lps'),
	(508965, 127, '2014-02-01 00:07:54.000000', 'consum', 0.0222, 'lps'),
	(508966, 127, '2014-02-01 00:07:55.000000', 'consum', 0.0221, 'lps'),
	(508967, 127, '2014-02-01 00:07:56.000000', 'consum', 0.0215, 'lps'),
	(508968, 127, '2014-02-01 00:07:57.000000', 'consum', 0.0216, 'lps'),
	(508969, 127, '2014-02-01 00:07:58.000000', 'consum', 0.0225, 'lps'),
	(508970, 127, '2014-02-01 00:07:59.000000', 'consum', 0.0220, 'lps'),
	(508971, 127, '2014-02-01 00:08:00.000000', 'consum', 0.0217, 'lps'),
	(508972, 127, '2014-02-01 00:08:01.000000', 'consum', 0.0214, 'lps'),
	(508973, 127, '2014-02-01 00:08:02.000000', 'consum', 0.0225, 'lps'),
	(508974, 127, '2014-02-01 00:08:03.000000', 'consum', 0.0212, 'lps'),
	(508975, 127, '2014-02-01 00:08:04.000000', 'consum', 0.0220, 'lps'),
	(508976, 127, '2014-02-01 00:08:05.000000', 'consum', 0.0210, 'lps'),
	(508977, 127, '2014-02-01 00:08:06.000000', 'consum', 0.0212, 'lps'),
	(508978, 127, '2014-02-01 00:08:07.000000', 'consum', 0.0218, 'lps'),
	(508979, 127, '2014-02-01 00:08:08.000000', 'consum', 0.0215, 'lps'),
	(508980, 127, '2014-02-01 00:08:09.000000', 'consum', 0.0225, 'lps'),
	(508981, 127, '2014-02-01 00:08:10.000000', 'consum', 0.0224, 'lps'),
	(508982, 127, '2014-02-01 00:08:11.000000', 'consum', 0.0218, 'lps'),
	(508983, 127, '2014-02-01 00:08:12.000000', 'consum', 0.0223, 'lps'),
	(508984, 127, '2014-02-01 00:08:13.000000', 'consum', 0.0223, 'lps'),
	(508985, 127, '2014-02-01 00:08:14.000000', 'consum', 0.0219, 'lps'),
	(508986, 127, '2014-02-01 00:08:15.000000', 'consum', 0.0215, 'lps'),
	(508987, 127, '2014-02-01 00:08:16.000000', 'consum', 0.0225, 'lps'),
	(508988, 127, '2014-02-01 00:08:17.000000', 'consum', 0.0223, 'lps'),
	(508989, 127, '2014-02-01 00:08:18.000000', 'consum', 0.0216, 'lps'),
	(508990, 127, '2014-02-01 00:08:19.000000', 'consum', 0.0218, 'lps'),
	(508991, 127, '2014-02-01 00:08:20.000000', 'consum', 0.0217, 'lps'),
	(508992, 127, '2014-02-01 00:08:21.000000', 'consum', 0.0220, 'lps'),
	(508993, 127, '2014-02-01 00:08:22.000000', 'consum', 0.0223, 'lps'),
	(508994, 127, '2014-02-01 00:08:23.000000', 'consum', 0.0214, 'lps'),
	(508995, 127, '2014-02-01 00:08:24.000000', 'consum', 0.0224, 'lps'),
	(508996, 127, '2014-02-01 00:08:25.000000', 'consum', 0.0220, 'lps'),
	(508997, 127, '2014-02-01 00:08:26.000000', 'consum', 0.0217, 'lps'),
	(508998, 127, '2014-02-01 00:08:27.000000', 'consum', 0.0218, 'lps'),
	(508999, 127, '2014-02-01 00:08:28.000000', 'consum', 0.0212, 'lps'),
	(509000, 127, '2014-02-01 00:08:29.000000', 'consum', 0.0212, 'lps'),
	(509001, 127, '2014-02-01 00:08:30.000000', 'consum', 0.0215, 'lps'),
	(509002, 127, '2014-02-01 00:08:31.000000', 'consum', 0.0214, 'lps'),
	(509003, 127, '2014-02-01 00:08:32.000000', 'consum', 0.0216, 'lps'),
	(509004, 127, '2014-02-01 00:08:33.000000', 'consum', 0.0212, 'lps'),
	(509005, 127, '2014-02-01 00:08:34.000000', 'consum', 0.0220, 'lps'),
	(509006, 127, '2014-02-01 00:08:35.000000', 'consum', 0.0220, 'lps'),
	(509007, 127, '2014-02-01 00:08:36.000000', 'consum', 0.0218, 'lps'),
	(509008, 127, '2014-02-01 00:08:37.000000', 'consum', 0.0217, 'lps'),
	(509009, 127, '2014-02-01 00:08:38.000000', 'consum', 0.0223, 'lps'),
	(509010, 127, '2014-02-01 00:08:39.000000', 'consum', 0.0223, 'lps'),
	(509011, 127, '2014-02-01 00:08:40.000000', 'consum', 0.0218, 'lps'),
	(509012, 127, '2014-02-01 00:08:41.000000', 'consum', 0.0213, 'lps'),
	(509013, 127, '2014-02-01 00:08:42.000000', 'consum', 0.0216, 'lps'),
	(509014, 127, '2014-02-01 00:08:43.000000', 'consum', 0.0217, 'lps'),
	(509015, 127, '2014-02-01 00:08:44.000000', 'consum', 0.0225, 'lps'),
	(509016, 127, '2014-02-01 00:08:45.000000', 'consum', 0.0218, 'lps'),
	(509017, 127, '2014-02-01 00:08:46.000000', 'consum', 0.0222, 'lps'),
	(509018, 127, '2014-02-01 00:08:47.000000', 'consum', 0.0214, 'lps'),
	(509019, 127, '2014-02-01 00:08:48.000000', 'consum', 0.0213, 'lps'),
	(509020, 127, '2014-02-01 00:08:49.000000', 'consum', 0.0210, 'lps'),
	(509021, 127, '2014-02-01 00:08:50.000000', 'consum', 0.0218, 'lps'),
	(509022, 127, '2014-02-01 00:08:51.000000', 'consum', 0.0221, 'lps'),
	(509023, 127, '2014-02-01 00:08:52.000000', 'consum', 0.0223, 'lps'),
	(509024, 127, '2014-02-01 00:08:53.000000', 'consum', 0.0213, 'lps'),
	(509025, 127, '2014-02-01 00:08:54.000000', 'consum', 0.0215, 'lps'),
	(509026, 127, '2014-02-01 00:08:55.000000', 'consum', 0.0214, 'lps'),
	(509027, 127, '2014-02-01 00:08:56.000000', 'consum', 0.0214, 'lps'),
	(509028, 127, '2014-02-01 00:08:57.000000', 'consum', 0.0219, 'lps'),
	(509029, 127, '2014-02-01 00:08:58.000000', 'consum', 0.0210, 'lps'),
	(509030, 127, '2014-02-01 00:08:59.000000', 'consum', 0.0215, 'lps'),
	(509031, 127, '2014-02-01 00:09:00.000000', 'consum', 0.0220, 'lps'),
	(509032, 127, '2014-02-01 00:09:01.000000', 'consum', 0.0213, 'lps'),
	(509033, 127, '2014-02-01 00:09:02.000000', 'consum', 0.0214, 'lps'),
	(509034, 127, '2014-02-01 00:09:03.000000', 'consum', 0.0219, 'lps'),
	(509035, 127, '2014-02-01 00:09:04.000000', 'consum', 0.0214, 'lps'),
	(509036, 127, '2014-02-01 00:09:05.000000', 'consum', 0.0220, 'lps'),
	(509037, 127, '2014-02-01 00:09:06.000000', 'consum', 0.0215, 'lps'),
	(509038, 127, '2014-02-01 00:09:07.000000', 'consum', 0.0223, 'lps'),
	(509039, 127, '2014-02-01 00:09:08.000000', 'consum', 0.0212, 'lps'),
	(509040, 127, '2014-02-01 00:09:09.000000', 'consum', 0.0212, 'lps'),
	(509041, 127, '2014-02-01 00:09:10.000000', 'consum', 0.0215, 'lps'),
	(509042, 127, '2014-02-01 00:09:11.000000', 'consum', 0.0212, 'lps'),
	(509043, 127, '2014-02-01 00:09:12.000000', 'consum', 0.0223, 'lps'),
	(509044, 127, '2014-02-01 00:09:13.000000', 'consum', 0.0221, 'lps'),
	(509045, 127, '2014-02-01 00:09:14.000000', 'consum', 0.0212, 'lps'),
	(509046, 127, '2014-02-01 00:09:15.000000', 'consum', 0.0218, 'lps'),
	(509047, 127, '2014-02-01 00:09:16.000000', 'consum', 0.0214, 'lps'),
	(509048, 127, '2014-02-01 00:09:17.000000', 'consum', 0.0223, 'lps'),
	(509049, 127, '2014-02-01 00:09:18.000000', 'consum', 0.0214, 'lps'),
	(509050, 127, '2014-02-01 00:09:19.000000', 'consum', 0.0224, 'lps'),
	(509051, 127, '2014-02-01 00:09:20.000000', 'consum', 0.0221, 'lps'),
	(509052, 127, '2014-02-01 00:09:21.000000', 'consum', 0.0222, 'lps'),
	(509053, 127, '2014-02-01 00:09:22.000000', 'consum', 0.0223, 'lps'),
	(509054, 127, '2014-02-01 00:09:23.000000', 'consum', 0.0222, 'lps'),
	(509055, 127, '2014-02-01 00:09:24.000000', 'consum', 0.0217, 'lps'),
	(509056, 127, '2014-02-01 00:09:25.000000', 'consum', 0.0211, 'lps'),
	(509057, 127, '2014-02-01 00:09:26.000000', 'consum', 0.0223, 'lps'),
	(509058, 127, '2014-02-01 00:09:27.000000', 'consum', 0.0210, 'lps'),
	(509059, 127, '2014-02-01 00:09:28.000000', 'consum', 0.0221, 'lps'),
	(509060, 127, '2014-02-01 00:09:29.000000', 'consum', 0.0215, 'lps'),
	(509061, 127, '2014-02-01 00:09:30.000000', 'consum', 0.0220, 'lps'),
	(509062, 127, '2014-02-01 00:09:31.000000', 'consum', 0.0213, 'lps'),
	(509063, 127, '2014-02-01 00:09:32.000000', 'consum', 0.0210, 'lps'),
	(509064, 127, '2014-02-01 00:09:33.000000', 'consum', 0.0220, 'lps'),
	(509065, 127, '2014-02-01 00:09:34.000000', 'consum', 0.0210, 'lps'),
	(509066, 127, '2014-02-01 00:09:35.000000', 'consum', 0.0213, 'lps'),
	(509067, 127, '2014-02-01 00:09:36.000000', 'consum', 0.0212, 'lps'),
	(509068, 127, '2014-02-01 00:09:37.000000', 'consum', 0.0210, 'lps'),
	(509069, 127, '2014-02-01 00:09:38.000000', 'consum', 0.0220, 'lps'),
	(509070, 127, '2014-02-01 00:09:39.000000', 'consum', 0.0212, 'lps'),
	(509071, 127, '2014-02-01 00:09:40.000000', 'consum', 0.0223, 'lps'),
	(509072, 127, '2014-02-01 00:09:41.000000', 'consum', 0.0223, 'lps'),
	(509073, 127, '2014-02-01 00:09:42.000000', 'consum', 0.0219, 'lps'),
	(509074, 127, '2014-02-01 00:09:43.000000', 'consum', 0.0218, 'lps'),
	(509075, 127, '2014-02-01 00:09:44.000000', 'consum', 0.0224, 'lps'),
	(509076, 127, '2014-02-01 00:09:45.000000', 'consum', 0.0225, 'lps'),
	(509077, 127, '2014-02-01 00:09:46.000000', 'consum', 0.0210, 'lps'),
	(509078, 127, '2014-02-01 00:09:47.000000', 'consum', 0.0214, 'lps'),
	(509079, 127, '2014-02-01 00:09:48.000000', 'consum', 0.0215, 'lps'),
	(509080, 127, '2014-02-01 00:09:49.000000', 'consum', 0.0223, 'lps'),
	(509081, 127, '2014-02-01 00:09:50.000000', 'consum', 0.0213, 'lps'),
	(509082, 127, '2014-02-01 00:09:51.000000', 'consum', 0.0217, 'lps'),
	(509083, 127, '2014-02-01 00:09:52.000000', 'consum', 0.0221, 'lps'),
	(509084, 127, '2014-02-01 00:09:53.000000', 'consum', 0.0213, 'lps'),
	(509085, 127, '2014-02-01 00:09:54.000000', 'consum', 0.0222, 'lps'),
	(509086, 127, '2014-02-01 00:09:55.000000', 'consum', 0.0216, 'lps'),
	(509087, 127, '2014-02-01 00:09:56.000000', 'consum', 0.0220, 'lps'),
	(509088, 127, '2014-02-01 00:09:57.000000', 'consum', 0.0210, 'lps'),
	(509089, 127, '2014-02-01 00:09:58.000000', 'consum', 0.0213, 'lps'),
	(509090, 127, '2014-02-01 00:09:59.000000', 'consum', 0.0211, 'lps'),
	(509091, 127, '2014-02-01 00:10:00.000000', 'consum', 0.0220, 'lps'),
	(509092, 127, '2014-02-01 00:10:01.000000', 'consum', 0.0210, 'lps'),
	(509093, 127, '2014-02-01 00:10:02.000000', 'consum', 0.0215, 'lps'),
	(509094, 127, '2014-02-01 00:10:03.000000', 'consum', 0.0217, 'lps'),
	(509095, 127, '2014-02-01 00:10:04.000000', 'consum', 0.0216, 'lps'),
	(509096, 127, '2014-02-01 00:10:05.000000', 'consum', 0.0218, 'lps'),
	(509097, 127, '2014-02-01 00:10:06.000000', 'consum', 0.0218, 'lps'),
	(509098, 127, '2014-02-01 00:10:07.000000', 'consum', 0.0211, 'lps'),
	(509099, 127, '2014-02-01 00:10:08.000000', 'consum', 0.0221, 'lps'),
	(509100, 127, '2014-02-01 00:10:09.000000', 'consum', 0.0217, 'lps'),
	(509101, 127, '2014-02-01 00:10:10.000000', 'consum', 0.0214, 'lps'),
	(509102, 127, '2014-02-01 00:10:11.000000', 'consum', 0.0223, 'lps'),
	(509103, 127, '2014-02-01 00:10:12.000000', 'consum', 0.0215, 'lps'),
	(509104, 127, '2014-02-01 00:10:13.000000', 'consum', 0.0212, 'lps'),
	(509105, 127, '2014-02-01 00:10:14.000000', 'consum', 0.0223, 'lps'),
	(509106, 127, '2014-02-01 00:10:15.000000', 'consum', 0.0220, 'lps'),
	(509107, 127, '2014-02-01 00:10:16.000000', 'consum', 0.0221, 'lps'),
	(509108, 127, '2014-02-01 00:10:17.000000', 'consum', 0.0222, 'lps'),
	(509109, 127, '2014-02-01 00:10:18.000000', 'consum', 0.0220, 'lps'),
	(509110, 127, '2014-02-01 00:10:19.000000', 'consum', 0.0210, 'lps'),
	(509111, 127, '2014-02-01 00:10:20.000000', 'consum', 0.0210, 'lps'),
	(509112, 127, '2014-02-01 00:10:21.000000', 'consum', 0.0212, 'lps'),
	(509113, 127, '2014-02-01 00:10:22.000000', 'consum', 0.0218, 'lps'),
	(509114, 127, '2014-02-01 00:10:23.000000', 'consum', 0.0215, 'lps'),
	(509115, 127, '2014-02-01 00:10:24.000000', 'consum', 0.0211, 'lps'),
	(509116, 127, '2014-02-01 00:10:25.000000', 'consum', 0.0215, 'lps'),
	(509117, 127, '2014-02-01 00:10:26.000000', 'consum', 0.0216, 'lps'),
	(509118, 127, '2014-02-01 00:10:27.000000', 'consum', 0.0212, 'lps'),
	(509119, 127, '2014-02-01 00:10:28.000000', 'consum', 0.0216, 'lps'),
	(509120, 127, '2014-02-01 00:10:29.000000', 'consum', 0.0220, 'lps'),
	(509121, 127, '2014-02-01 00:10:30.000000', 'consum', 0.0211, 'lps'),
	(509122, 127, '2014-02-01 00:10:31.000000', 'consum', 0.0218, 'lps'),
	(509123, 127, '2014-02-01 00:10:32.000000', 'consum', 0.0214, 'lps'),
	(509124, 127, '2014-02-01 00:10:33.000000', 'consum', 0.0224, 'lps'),
	(509125, 127, '2014-02-01 00:10:34.000000', 'consum', 0.0218, 'lps'),
	(509126, 127, '2014-02-01 00:10:35.000000', 'consum', 0.0225, 'lps'),
	(509127, 127, '2014-02-01 00:10:36.000000', 'consum', 0.0215, 'lps'),
	(509128, 127, '2014-02-01 00:10:37.000000', 'consum', 0.0220, 'lps'),
	(509129, 127, '2014-02-01 00:10:38.000000', 'consum', 0.0217, 'lps'),
	(509130, 127, '2014-02-01 00:10:39.000000', 'consum', 0.0212, 'lps'),
	(509131, 127, '2014-02-01 00:10:40.000000', 'consum', 0.0218, 'lps'),
	(509132, 127, '2014-02-01 00:10:41.000000', 'consum', 0.0213, 'lps'),
	(509133, 127, '2014-02-01 00:10:42.000000', 'consum', 0.0216, 'lps'),
	(509134, 127, '2014-02-01 00:10:43.000000', 'consum', 0.0216, 'lps'),
	(509135, 127, '2014-02-01 00:10:44.000000', 'consum', 0.0221, 'lps'),
	(509136, 127, '2014-02-01 00:10:45.000000', 'consum', 0.0217, 'lps'),
	(509137, 127, '2014-02-01 00:10:46.000000', 'consum', 0.0212, 'lps'),
	(509138, 127, '2014-02-01 00:10:47.000000', 'consum', 0.0217, 'lps'),
	(509139, 127, '2014-02-01 00:10:48.000000', 'consum', 0.0222, 'lps'),
	(509140, 127, '2014-02-01 00:10:49.000000', 'consum', 0.0219, 'lps'),
	(509141, 127, '2014-02-01 00:10:50.000000', 'consum', 0.0217, 'lps'),
	(509142, 127, '2014-02-01 00:10:51.000000', 'consum', 0.0222, 'lps'),
	(509143, 127, '2014-02-01 00:10:52.000000', 'consum', 0.0214, 'lps'),
	(509144, 127, '2014-02-01 00:10:53.000000', 'consum', 0.0213, 'lps'),
	(509145, 127, '2014-02-01 00:10:54.000000', 'consum', 0.0214, 'lps'),
	(509146, 127, '2014-02-01 00:10:55.000000', 'consum', 0.0221, 'lps'),
	(509147, 127, '2014-02-01 00:10:56.000000', 'consum', 0.0219, 'lps'),
	(509148, 127, '2014-02-01 00:10:57.000000', 'consum', 0.0210, 'lps'),
	(509149, 127, '2014-02-01 00:10:58.000000', 'consum', 0.0214, 'lps'),
	(509150, 127, '2014-02-01 00:10:59.000000', 'consum', 0.0213, 'lps'),
	(509151, 127, '2014-02-01 00:11:00.000000', 'consum', 0.0213, 'lps'),
	(509152, 127, '2014-02-01 00:11:01.000000', 'consum', 0.0216, 'lps'),
	(509153, 127, '2014-02-01 00:11:02.000000', 'consum', 0.0218, 'lps'),
	(509154, 127, '2014-02-01 00:11:03.000000', 'consum', 0.0217, 'lps'),
	(509155, 127, '2014-02-01 00:11:04.000000', 'consum', 0.0221, 'lps'),
	(509156, 127, '2014-02-01 00:11:05.000000', 'consum', 0.0211, 'lps'),
	(509157, 127, '2014-02-01 00:11:06.000000', 'consum', 0.0216, 'lps'),
	(509158, 127, '2014-02-01 00:11:07.000000', 'consum', 0.0222, 'lps'),
	(509159, 127, '2014-02-01 00:11:08.000000', 'consum', 0.0218, 'lps'),
	(509160, 127, '2014-02-01 00:11:09.000000', 'consum', 0.0218, 'lps'),
	(509161, 127, '2014-02-01 00:11:10.000000', 'consum', 0.0223, 'lps'),
	(509162, 127, '2014-02-01 00:11:11.000000', 'consum', 0.0222, 'lps'),
	(509163, 127, '2014-02-01 00:11:12.000000', 'consum', 0.0213, 'lps'),
	(509164, 127, '2014-02-01 00:11:13.000000', 'consum', 0.0224, 'lps'),
	(509165, 127, '2014-02-01 00:11:14.000000', 'consum', 0.0221, 'lps'),
	(509166, 127, '2014-02-01 00:11:15.000000', 'consum', 0.0225, 'lps'),
	(509167, 127, '2014-02-01 00:11:16.000000', 'consum', 0.0220, 'lps'),
	(509168, 127, '2014-02-01 00:11:17.000000', 'consum', 0.0215, 'lps'),
	(509169, 127, '2014-02-01 00:11:18.000000', 'consum', 0.0221, 'lps'),
	(509170, 127, '2014-02-01 00:11:19.000000', 'consum', 0.0219, 'lps'),
	(509171, 127, '2014-02-01 00:11:20.000000', 'consum', 0.0222, 'lps'),
	(509172, 127, '2014-02-01 00:11:21.000000', 'consum', 0.0212, 'lps'),
	(509173, 127, '2014-02-01 00:11:22.000000', 'consum', 0.0215, 'lps'),
	(509174, 127, '2014-02-01 00:11:23.000000', 'consum', 0.0216, 'lps'),
	(509175, 127, '2014-02-01 00:11:24.000000', 'consum', 0.0225, 'lps'),
	(509176, 127, '2014-02-01 00:11:25.000000', 'consum', 0.0218, 'lps'),
	(509177, 127, '2014-02-01 00:11:26.000000', 'consum', 0.0221, 'lps'),
	(509178, 127, '2014-02-01 00:11:27.000000', 'consum', 0.0211, 'lps'),
	(509179, 127, '2014-02-01 00:11:28.000000', 'consum', 0.0216, 'lps'),
	(509180, 127, '2014-02-01 00:11:29.000000', 'consum', 0.0220, 'lps'),
	(509181, 127, '2014-02-01 00:11:30.000000', 'consum', 0.0211, 'lps'),
	(509182, 127, '2014-02-01 00:11:31.000000', 'consum', 0.0215, 'lps'),
	(509183, 127, '2014-02-01 00:11:32.000000', 'consum', 0.0219, 'lps'),
	(509184, 127, '2014-02-01 00:11:33.000000', 'consum', 0.0225, 'lps'),
	(509185, 127, '2014-02-01 00:11:34.000000', 'consum', 0.0211, 'lps'),
	(509186, 127, '2014-02-01 00:11:35.000000', 'consum', 0.0216, 'lps'),
	(509187, 127, '2014-02-01 00:11:36.000000', 'consum', 0.0223, 'lps'),
	(509188, 127, '2014-02-01 00:11:37.000000', 'consum', 0.0225, 'lps'),
	(509189, 127, '2014-02-01 00:11:38.000000', 'consum', 0.0217, 'lps'),
	(509190, 127, '2014-02-01 00:11:39.000000', 'consum', 0.0214, 'lps'),
	(509191, 127, '2014-02-01 00:11:40.000000', 'consum', 0.0225, 'lps'),
	(509192, 127, '2014-02-01 00:11:41.000000', 'consum', 0.0212, 'lps'),
	(509193, 127, '2014-02-01 00:11:42.000000', 'consum', 0.0224, 'lps'),
	(509194, 127, '2014-02-01 00:11:43.000000', 'consum', 0.0224, 'lps'),
	(509195, 127, '2014-02-01 00:11:44.000000', 'consum', 0.0222, 'lps'),
	(509196, 127, '2014-02-01 00:11:45.000000', 'consum', 0.0213, 'lps'),
	(509197, 127, '2014-02-01 00:11:46.000000', 'consum', 0.0221, 'lps'),
	(509198, 127, '2014-02-01 00:11:47.000000', 'consum', 0.0210, 'lps'),
	(509199, 127, '2014-02-01 00:11:48.000000', 'consum', 0.0224, 'lps'),
	(509200, 127, '2014-02-01 00:11:49.000000', 'consum', 0.0218, 'lps'),
	(509201, 127, '2014-02-01 00:11:50.000000', 'consum', 0.0225, 'lps'),
	(509202, 127, '2014-02-01 00:11:51.000000', 'consum', 0.0212, 'lps'),
	(509203, 127, '2014-02-01 00:11:52.000000', 'consum', 0.0225, 'lps'),
	(509204, 127, '2014-02-01 00:11:53.000000', 'consum', 0.0213, 'lps'),
	(509205, 127, '2014-02-01 00:11:54.000000', 'consum', 0.0214, 'lps'),
	(509206, 127, '2014-02-01 00:11:55.000000', 'consum', 0.0221, 'lps'),
	(509207, 127, '2014-02-01 00:11:56.000000', 'consum', 0.0221, 'lps'),
	(509208, 127, '2014-02-01 00:11:57.000000', 'consum', 0.0218, 'lps'),
	(509209, 127, '2014-02-01 00:11:58.000000', 'consum', 0.0218, 'lps'),
	(509210, 127, '2014-02-01 00:11:59.000000', 'consum', 0.0211, 'lps'),
	(509211, 127, '2014-02-01 00:12:00.000000', 'consum', 0.0220, 'lps'),
	(509212, 127, '2014-02-01 00:12:01.000000', 'consum', 0.0213, 'lps'),
	(509213, 127, '2014-02-01 00:12:02.000000', 'consum', 0.0212, 'lps'),
	(509214, 127, '2014-02-01 00:12:03.000000', 'consum', 0.0225, 'lps'),
	(509215, 127, '2014-02-01 00:12:04.000000', 'consum', 0.0214, 'lps'),
	(509216, 127, '2014-02-01 00:12:05.000000', 'consum', 0.0221, 'lps'),
	(509217, 127, '2014-02-01 00:12:06.000000', 'consum', 0.0219, 'lps'),
	(509218, 127, '2014-02-01 00:12:07.000000', 'consum', 0.0224, 'lps'),
	(509219, 127, '2014-02-01 00:12:08.000000', 'consum', 0.0221, 'lps'),
	(509220, 127, '2014-02-01 00:12:09.000000', 'consum', 0.0222, 'lps'),
	(509221, 127, '2014-02-01 00:12:10.000000', 'consum', 0.0224, 'lps'),
	(509222, 127, '2014-02-01 00:12:11.000000', 'consum', 0.0212, 'lps'),
	(509223, 127, '2014-02-01 00:12:12.000000', 'consum', 0.0211, 'lps'),
	(509224, 127, '2014-02-01 00:12:13.000000', 'consum', 0.0210, 'lps'),
	(509225, 127, '2014-02-01 00:12:14.000000', 'consum', 0.0224, 'lps'),
	(509226, 127, '2014-02-01 00:12:15.000000', 'consum', 0.0216, 'lps'),
	(509227, 127, '2014-02-01 00:12:16.000000', 'consum', 0.0213, 'lps'),
	(509228, 127, '2014-02-01 00:12:17.000000', 'consum', 0.0224, 'lps'),
	(509229, 127, '2014-02-01 00:12:18.000000', 'consum', 0.0224, 'lps'),
	(509230, 127, '2014-02-01 00:12:19.000000', 'consum', 0.0222, 'lps'),
	(509231, 127, '2014-02-01 00:12:20.000000', 'consum', 0.0212, 'lps'),
	(509232, 127, '2014-02-01 00:12:21.000000', 'consum', 0.0218, 'lps'),
	(509233, 127, '2014-02-01 00:12:22.000000', 'consum', 0.0214, 'lps'),
	(509234, 127, '2014-02-01 00:12:23.000000', 'consum', 0.0220, 'lps'),
	(509235, 127, '2014-02-01 00:12:24.000000', 'consum', 0.0217, 'lps'),
	(509236, 127, '2014-02-01 00:12:25.000000', 'consum', 0.0215, 'lps'),
	(509237, 127, '2014-02-01 00:12:26.000000', 'consum', 0.0215, 'lps'),
	(509238, 127, '2014-02-01 00:12:27.000000', 'consum', 0.0219, 'lps'),
	(509239, 127, '2014-02-01 00:12:28.000000', 'consum', 0.0225, 'lps'),
	(509240, 127, '2014-02-01 00:12:29.000000', 'consum', 0.0213, 'lps'),
	(509241, 127, '2014-02-01 00:12:30.000000', 'consum', 0.0211, 'lps'),
	(509242, 127, '2014-02-01 00:12:31.000000', 'consum', 0.0222, 'lps'),
	(509243, 127, '2014-02-01 00:12:32.000000', 'consum', 0.0218, 'lps'),
	(509244, 127, '2014-02-01 00:12:33.000000', 'consum', 0.0218, 'lps'),
	(509245, 127, '2014-02-01 00:12:34.000000', 'consum', 0.0223, 'lps'),
	(509246, 127, '2014-02-01 00:12:35.000000', 'consum', 0.0222, 'lps'),
	(509247, 127, '2014-02-01 00:12:36.000000', 'consum', 0.0213, 'lps'),
	(509248, 127, '2014-02-01 00:12:37.000000', 'consum', 0.0222, 'lps'),
	(509249, 127, '2014-02-01 00:12:38.000000', 'consum', 0.0215, 'lps'),
	(509250, 127, '2014-02-01 00:12:39.000000', 'consum', 0.0213, 'lps'),
	(509251, 127, '2014-02-01 00:12:40.000000', 'consum', 0.0211, 'lps'),
	(509252, 127, '2014-02-01 00:12:41.000000', 'consum', 0.0223, 'lps'),
	(509253, 127, '2014-02-01 00:12:42.000000', 'consum', 0.0224, 'lps'),
	(509254, 127, '2014-02-01 00:12:43.000000', 'consum', 0.0225, 'lps'),
	(509255, 127, '2014-02-01 00:12:44.000000', 'consum', 0.0212, 'lps'),
	(509256, 127, '2014-02-01 00:12:45.000000', 'consum', 0.0225, 'lps'),
	(509257, 127, '2014-02-01 00:12:46.000000', 'consum', 0.0216, 'lps'),
	(509258, 127, '2014-02-01 00:12:47.000000', 'consum', 0.0225, 'lps'),
	(509259, 127, '2014-02-01 00:12:48.000000', 'consum', 0.0219, 'lps'),
	(509260, 127, '2014-02-01 00:12:49.000000', 'consum', 0.0213, 'lps'),
	(509261, 127, '2014-02-01 00:12:50.000000', 'consum', 0.0214, 'lps'),
	(509262, 127, '2014-02-01 00:12:51.000000', 'consum', 0.0222, 'lps'),
	(509263, 127, '2014-02-01 00:12:52.000000', 'consum', 0.0225, 'lps'),
	(509264, 127, '2014-02-01 00:12:53.000000', 'consum', 0.0217, 'lps'),
	(509265, 127, '2014-02-01 00:12:54.000000', 'consum', 0.0219, 'lps'),
	(509266, 127, '2014-02-01 00:12:55.000000', 'consum', 0.0217, 'lps'),
	(509267, 127, '2014-02-01 00:12:56.000000', 'consum', 0.0218, 'lps'),
	(509268, 127, '2014-02-01 00:12:57.000000', 'consum', 0.0214, 'lps'),
	(509269, 127, '2014-02-01 00:12:58.000000', 'consum', 0.0221, 'lps'),
	(509270, 127, '2014-02-01 00:12:59.000000', 'consum', 0.0221, 'lps'),
	(509271, 127, '2014-02-01 00:13:00.000000', 'consum', 0.0219, 'lps'),
	(509272, 127, '2014-02-01 00:13:01.000000', 'consum', 0.0224, 'lps'),
	(509273, 127, '2014-02-01 00:13:02.000000', 'consum', 0.0218, 'lps'),
	(509274, 127, '2014-02-01 00:13:03.000000', 'consum', 0.0225, 'lps'),
	(509275, 127, '2014-02-01 00:13:04.000000', 'consum', 0.0213, 'lps'),
	(509276, 127, '2014-02-01 00:13:05.000000', 'consum', 0.0211, 'lps'),
	(509277, 127, '2014-02-01 00:13:06.000000', 'consum', 0.0225, 'lps'),
	(509278, 127, '2014-02-01 00:13:07.000000', 'consum', 0.0219, 'lps'),
	(509279, 127, '2014-02-01 00:13:08.000000', 'consum', 0.0224, 'lps'),
	(509280, 127, '2014-02-01 00:13:09.000000', 'consum', 0.0224, 'lps'),
	(509281, 127, '2014-02-01 00:13:10.000000', 'consum', 0.0222, 'lps'),
	(509282, 127, '2014-02-01 00:13:11.000000', 'consum', 0.0211, 'lps'),
	(509283, 127, '2014-02-01 00:13:12.000000', 'consum', 0.0212, 'lps'),
	(509284, 127, '2014-02-01 00:13:13.000000', 'consum', 0.0219, 'lps'),
	(509285, 127, '2014-02-01 00:13:14.000000', 'consum', 0.0218, 'lps'),
	(509286, 127, '2014-02-01 00:13:15.000000', 'consum', 0.0222, 'lps'),
	(509287, 127, '2014-02-01 00:13:16.000000', 'consum', 0.0215, 'lps'),
	(509288, 127, '2014-02-01 00:13:17.000000', 'consum', 0.0215, 'lps'),
	(509289, 127, '2014-02-01 00:13:18.000000', 'consum', 0.0222, 'lps'),
	(509290, 127, '2014-02-01 00:13:19.000000', 'consum', 0.0221, 'lps'),
	(509291, 127, '2014-02-01 00:13:20.000000', 'consum', 0.0216, 'lps'),
	(509292, 127, '2014-02-01 00:13:21.000000', 'consum', 0.0221, 'lps'),
	(509293, 127, '2014-02-01 00:13:22.000000', 'consum', 0.0218, 'lps'),
	(509294, 127, '2014-02-01 00:13:23.000000', 'consum', 0.0215, 'lps'),
	(509295, 127, '2014-02-01 00:13:24.000000', 'consum', 0.0212, 'lps'),
	(509296, 127, '2014-02-01 00:13:25.000000', 'consum', 0.0220, 'lps'),
	(509297, 127, '2014-02-01 00:13:26.000000', 'consum', 0.0225, 'lps'),
	(509298, 127, '2014-02-01 00:13:27.000000', 'consum', 0.0225, 'lps'),
	(509299, 127, '2014-02-01 00:13:28.000000', 'consum', 0.0221, 'lps'),
	(509300, 127, '2014-02-01 00:13:29.000000', 'consum', 0.0224, 'lps'),
	(509301, 127, '2014-02-01 00:13:30.000000', 'consum', 0.0214, 'lps'),
	(509302, 127, '2014-02-01 00:13:31.000000', 'consum', 0.0219, 'lps'),
	(509303, 127, '2014-02-01 00:13:32.000000', 'consum', 0.0211, 'lps'),
	(509304, 127, '2014-02-01 00:13:33.000000', 'consum', 0.0222, 'lps'),
	(509305, 127, '2014-02-01 00:13:34.000000', 'consum', 0.0220, 'lps'),
	(509306, 127, '2014-02-01 00:13:35.000000', 'consum', 0.0223, 'lps'),
	(509307, 127, '2014-02-01 00:13:36.000000', 'consum', 0.0212, 'lps'),
	(509308, 127, '2014-02-01 00:13:37.000000', 'consum', 0.0217, 'lps'),
	(509309, 127, '2014-02-01 00:13:38.000000', 'consum', 0.0223, 'lps'),
	(509310, 127, '2014-02-01 00:13:39.000000', 'consum', 0.0220, 'lps'),
	(509311, 127, '2014-02-01 00:13:40.000000', 'consum', 0.0222, 'lps'),
	(509312, 127, '2014-02-01 00:13:41.000000', 'consum', 0.0225, 'lps'),
	(509313, 127, '2014-02-01 00:13:42.000000', 'consum', 0.0217, 'lps'),
	(509314, 127, '2014-02-01 00:13:43.000000', 'consum', 0.0216, 'lps'),
	(509315, 127, '2014-02-01 00:13:44.000000', 'consum', 0.0221, 'lps'),
	(509316, 127, '2014-02-01 00:13:45.000000', 'consum', 0.0214, 'lps'),
	(509317, 127, '2014-02-01 00:13:46.000000', 'consum', 0.0216, 'lps'),
	(509318, 127, '2014-02-01 00:13:47.000000', 'consum', 0.0211, 'lps'),
	(509319, 127, '2014-02-01 00:13:48.000000', 'consum', 0.0213, 'lps'),
	(509320, 127, '2014-02-01 00:13:49.000000', 'consum', 0.0222, 'lps'),
	(509321, 127, '2014-02-01 00:13:50.000000', 'consum', 0.0214, 'lps'),
	(509322, 127, '2014-02-01 00:13:51.000000', 'consum', 0.0211, 'lps'),
	(509323, 127, '2014-02-01 00:13:52.000000', 'consum', 0.0221, 'lps'),
	(509324, 127, '2014-02-01 00:13:53.000000', 'consum', 0.0214, 'lps'),
	(509325, 127, '2014-02-01 00:13:54.000000', 'consum', 0.0212, 'lps'),
	(509326, 127, '2014-02-01 00:13:55.000000', 'consum', 0.0225, 'lps'),
	(509327, 127, '2014-02-01 00:13:56.000000', 'consum', 0.0214, 'lps'),
	(509328, 127, '2014-02-01 00:13:57.000000', 'consum', 0.0217, 'lps'),
	(509329, 127, '2014-02-01 00:13:58.000000', 'consum', 0.0218, 'lps'),
	(509330, 127, '2014-02-01 00:13:59.000000', 'consum', 0.0214, 'lps'),
	(509331, 127, '2014-02-01 00:14:00.000000', 'consum', 0.0221, 'lps'),
	(509332, 127, '2014-02-01 00:14:01.000000', 'consum', 0.0223, 'lps'),
	(509333, 127, '2014-02-01 00:14:02.000000', 'consum', 0.0212, 'lps'),
	(509334, 127, '2014-02-01 00:14:03.000000', 'consum', 0.0210, 'lps'),
	(509335, 127, '2014-02-01 00:14:04.000000', 'consum', 0.0223, 'lps'),
	(509336, 127, '2014-02-01 00:14:05.000000', 'consum', 0.0210, 'lps'),
	(509337, 127, '2014-02-01 00:14:06.000000', 'consum', 0.0221, 'lps'),
	(509338, 127, '2014-02-01 00:14:07.000000', 'consum', 0.0218, 'lps'),
	(509339, 127, '2014-02-01 00:14:08.000000', 'consum', 0.0217, 'lps'),
	(509340, 127, '2014-02-01 00:14:09.000000', 'consum', 0.0220, 'lps'),
	(509341, 127, '2014-02-01 00:14:10.000000', 'consum', 0.0210, 'lps'),
	(509342, 127, '2014-02-01 00:14:11.000000', 'consum', 0.0210, 'lps'),
	(509343, 127, '2014-02-01 00:14:12.000000', 'consum', 0.0211, 'lps'),
	(509344, 127, '2014-02-01 00:14:13.000000', 'consum', 0.0216, 'lps'),
	(509345, 127, '2014-02-01 00:14:14.000000', 'consum', 0.0220, 'lps'),
	(509346, 127, '2014-02-01 00:14:15.000000', 'consum', 0.0211, 'lps'),
	(509347, 127, '2014-02-01 00:14:16.000000', 'consum', 0.0216, 'lps'),
	(509348, 127, '2014-02-01 00:14:17.000000', 'consum', 0.0223, 'lps'),
	(509349, 127, '2014-02-01 00:14:18.000000', 'consum', 0.0223, 'lps'),
	(509350, 127, '2014-02-01 00:14:19.000000', 'consum', 0.0224, 'lps'),
	(509351, 127, '2014-02-01 00:14:20.000000', 'consum', 0.0225, 'lps'),
	(509352, 127, '2014-02-01 00:14:21.000000', 'consum', 0.0210, 'lps'),
	(509353, 127, '2014-02-01 00:14:22.000000', 'consum', 0.0212, 'lps'),
	(509354, 127, '2014-02-01 00:14:23.000000', 'consum', 0.0222, 'lps'),
	(509355, 127, '2014-02-01 00:14:24.000000', 'consum', 0.0217, 'lps'),
	(509356, 127, '2014-02-01 00:14:25.000000', 'consum', 0.0224, 'lps'),
	(509357, 127, '2014-02-01 00:14:26.000000', 'consum', 0.0213, 'lps'),
	(509358, 127, '2014-02-01 00:14:27.000000', 'consum', 0.0216, 'lps'),
	(509359, 127, '2014-02-01 00:14:28.000000', 'consum', 0.0215, 'lps'),
	(509360, 127, '2014-02-01 00:14:29.000000', 'consum', 0.0216, 'lps'),
	(509361, 127, '2014-02-01 00:14:30.000000', 'consum', 0.0212, 'lps'),
	(509362, 127, '2014-02-01 00:14:31.000000', 'consum', 0.0216, 'lps'),
	(509363, 127, '2014-02-01 00:14:32.000000', 'consum', 0.0220, 'lps'),
	(509364, 127, '2014-02-01 00:14:33.000000', 'consum', 0.0224, 'lps'),
	(509365, 127, '2014-02-01 00:14:34.000000', 'consum', 0.0221, 'lps'),
	(509366, 127, '2014-02-01 00:14:35.000000', 'consum', 0.0221, 'lps'),
	(509367, 127, '2014-02-01 00:14:36.000000', 'consum', 0.0218, 'lps'),
	(509368, 127, '2014-02-01 00:14:37.000000', 'consum', 0.0217, 'lps'),
	(509369, 127, '2014-02-01 00:14:38.000000', 'consum', 0.0220, 'lps'),
	(509370, 127, '2014-02-01 00:14:39.000000', 'consum', 0.0210, 'lps'),
	(509371, 127, '2014-02-01 00:14:40.000000', 'consum', 0.0210, 'lps'),
	(509372, 127, '2014-02-01 00:14:41.000000', 'consum', 0.0212, 'lps'),
	(509373, 127, '2014-02-01 00:14:42.000000', 'consum', 0.0219, 'lps'),
	(509374, 127, '2014-02-01 00:14:43.000000', 'consum', 0.0217, 'lps'),
	(509375, 127, '2014-02-01 00:14:44.000000', 'consum', 0.0220, 'lps'),
	(509376, 127, '2014-02-01 00:14:45.000000', 'consum', 0.0224, 'lps'),
	(509377, 127, '2014-02-01 00:14:46.000000', 'consum', 0.0218, 'lps'),
	(509378, 127, '2014-02-01 00:14:47.000000', 'consum', 0.0224, 'lps'),
	(509379, 127, '2014-02-01 00:14:48.000000', 'consum', 0.0225, 'lps'),
	(509380, 127, '2014-02-01 00:14:49.000000', 'consum', 0.0210, 'lps'),
	(509381, 127, '2014-02-01 00:14:50.000000', 'consum', 0.0213, 'lps'),
	(509382, 127, '2014-02-01 00:14:51.000000', 'consum', 0.0225, 'lps'),
	(509383, 127, '2014-02-01 00:14:52.000000', 'consum', 0.0214, 'lps'),
	(509384, 127, '2014-02-01 00:14:53.000000', 'consum', 0.0216, 'lps'),
	(509385, 127, '2014-02-01 00:14:54.000000', 'consum', 0.0215, 'lps'),
	(509386, 127, '2014-02-01 00:14:55.000000', 'consum', 0.0215, 'lps'),
	(509387, 127, '2014-02-01 00:14:56.000000', 'consum', 0.0223, 'lps'),
	(509388, 127, '2014-02-01 00:14:57.000000', 'consum', 0.0212, 'lps'),
	(509389, 127, '2014-02-01 00:14:58.000000', 'consum', 0.0213, 'lps'),
	(509390, 127, '2014-02-01 00:14:59.000000', 'consum', 0.0220, 'lps'),
	(509391, 127, '2014-02-01 00:15:00.000000', 'consum', 0.0218, 'lps'),
	(509392, 127, '2014-02-01 00:15:01.000000', 'consum', 0.0222, 'lps'),
	(509393, 127, '2014-02-01 00:15:02.000000', 'consum', 0.0216, 'lps'),
	(509394, 127, '2014-02-01 00:15:03.000000', 'consum', 0.0220, 'lps'),
	(509395, 127, '2014-02-01 00:15:04.000000', 'consum', 0.0224, 'lps'),
	(509396, 127, '2014-02-01 00:15:05.000000', 'consum', 0.0219, 'lps'),
	(509397, 127, '2014-02-01 00:15:06.000000', 'consum', 0.0213, 'lps'),
	(509398, 127, '2014-02-01 00:15:07.000000', 'consum', 0.0217, 'lps'),
	(509399, 127, '2014-02-01 00:15:08.000000', 'consum', 0.0220, 'lps'),
	(509400, 127, '2014-02-01 00:15:09.000000', 'consum', 0.0222, 'lps'),
	(509401, 127, '2014-02-01 00:15:10.000000', 'consum', 0.0223, 'lps'),
	(509402, 127, '2014-02-01 00:15:11.000000', 'consum', 0.0211, 'lps'),
	(509403, 127, '2014-02-01 00:15:12.000000', 'consum', 0.0223, 'lps'),
	(509404, 127, '2014-02-01 00:15:13.000000', 'consum', 0.0224, 'lps'),
	(509405, 127, '2014-02-01 00:15:14.000000', 'consum', 0.0224, 'lps'),
	(509406, 127, '2014-02-01 00:15:15.000000', 'consum', 0.0224, 'lps'),
	(509407, 127, '2014-02-01 00:15:16.000000', 'consum', 0.0223, 'lps'),
	(509408, 127, '2014-02-01 00:15:17.000000', 'consum', 0.0216, 'lps'),
	(509409, 127, '2014-02-01 00:15:18.000000', 'consum', 0.0220, 'lps'),
	(509410, 127, '2014-02-01 00:15:19.000000', 'consum', 0.0224, 'lps'),
	(509411, 127, '2014-02-01 00:15:20.000000', 'consum', 0.0222, 'lps'),
	(509412, 127, '2014-02-01 00:15:21.000000', 'consum', 0.0225, 'lps'),
	(509413, 127, '2014-02-01 00:15:22.000000', 'consum', 0.0217, 'lps'),
	(509414, 127, '2014-02-01 00:15:23.000000', 'consum', 0.0217, 'lps'),
	(509415, 127, '2014-02-01 00:15:24.000000', 'consum', 0.0225, 'lps'),
	(509416, 127, '2014-02-01 00:15:25.000000', 'consum', 0.0217, 'lps'),
	(509417, 127, '2014-02-01 00:15:26.000000', 'consum', 0.0215, 'lps'),
	(509418, 127, '2014-02-01 00:15:27.000000', 'consum', 0.0216, 'lps'),
	(509419, 127, '2014-02-01 00:15:28.000000', 'consum', 0.0225, 'lps'),
	(509420, 127, '2014-02-01 00:15:29.000000', 'consum', 0.0218, 'lps'),
	(509421, 127, '2014-02-01 00:15:30.000000', 'consum', 0.0225, 'lps'),
	(509422, 127, '2014-02-01 00:15:31.000000', 'consum', 0.0210, 'lps'),
	(509423, 127, '2014-02-01 00:15:32.000000', 'consum', 0.0214, 'lps'),
	(509424, 127, '2014-02-01 00:15:33.000000', 'consum', 0.0214, 'lps'),
	(509425, 127, '2014-02-01 00:15:34.000000', 'consum', 0.0219, 'lps'),
	(509426, 127, '2014-02-01 00:15:35.000000', 'consum', 0.0211, 'lps'),
	(509427, 127, '2014-02-01 00:15:36.000000', 'consum', 0.0221, 'lps'),
	(509428, 127, '2014-02-01 00:15:37.000000', 'consum', 0.0216, 'lps'),
	(509429, 127, '2014-02-01 00:15:38.000000', 'consum', 0.0222, 'lps'),
	(509430, 127, '2014-02-01 00:15:39.000000', 'consum', 0.0221, 'lps'),
	(509431, 127, '2014-02-01 00:15:40.000000', 'consum', 0.0214, 'lps'),
	(509432, 127, '2014-02-01 00:15:41.000000', 'consum', 0.0215, 'lps'),
	(509433, 127, '2014-02-01 00:15:42.000000', 'consum', 0.0223, 'lps'),
	(509434, 127, '2014-02-01 00:15:43.000000', 'consum', 0.0211, 'lps'),
	(509435, 127, '2014-02-01 00:15:44.000000', 'consum', 0.0225, 'lps'),
	(509436, 127, '2014-02-01 00:15:45.000000', 'consum', 0.0220, 'lps'),
	(509437, 127, '2014-02-01 00:15:46.000000', 'consum', 0.0213, 'lps'),
	(509438, 127, '2014-02-01 00:15:47.000000', 'consum', 0.0212, 'lps'),
	(509439, 127, '2014-02-01 00:15:48.000000', 'consum', 0.0212, 'lps'),
	(509440, 127, '2014-02-01 00:15:49.000000', 'consum', 0.0214, 'lps'),
	(509441, 127, '2014-02-01 00:15:50.000000', 'consum', 0.0223, 'lps'),
	(509442, 127, '2014-02-01 00:15:51.000000', 'consum', 0.0216, 'lps'),
	(509443, 127, '2014-02-01 00:15:52.000000', 'consum', 0.0219, 'lps'),
	(509444, 127, '2014-02-01 00:15:53.000000', 'consum', 0.0222, 'lps'),
	(509445, 127, '2014-02-01 00:15:54.000000', 'consum', 0.0225, 'lps'),
	(509446, 127, '2014-02-01 00:15:55.000000', 'consum', 0.0219, 'lps'),
	(509447, 127, '2014-02-01 00:15:56.000000', 'consum', 0.0225, 'lps'),
	(509448, 127, '2014-02-01 00:15:57.000000', 'consum', 0.0212, 'lps'),
	(509449, 127, '2014-02-01 00:15:58.000000', 'consum', 0.0223, 'lps'),
	(509450, 127, '2014-02-01 00:15:59.000000', 'consum', 0.0222, 'lps'),
	(509451, 127, '2014-02-01 00:16:00.000000', 'consum', 0.0216, 'lps'),
	(509452, 127, '2014-02-01 00:16:01.000000', 'consum', 0.0221, 'lps'),
	(509453, 127, '2014-02-01 00:16:02.000000', 'consum', 0.0213, 'lps'),
	(509454, 127, '2014-02-01 00:16:03.000000', 'consum', 0.0225, 'lps'),
	(509455, 127, '2014-02-01 00:16:04.000000', 'consum', 0.0211, 'lps'),
	(509456, 127, '2014-02-01 00:16:05.000000', 'consum', 0.0222, 'lps'),
	(509457, 127, '2014-02-01 00:16:06.000000', 'consum', 0.0216, 'lps'),
	(509458, 127, '2014-02-01 00:16:07.000000', 'consum', 0.0222, 'lps'),
	(509459, 127, '2014-02-01 00:16:08.000000', 'consum', 0.0219, 'lps'),
	(509460, 127, '2014-02-01 00:16:09.000000', 'consum', 0.0221, 'lps'),
	(509461, 127, '2014-02-01 00:16:10.000000', 'consum', 0.0222, 'lps'),
	(509462, 127, '2014-02-01 00:16:11.000000', 'consum', 0.0222, 'lps'),
	(509463, 127, '2014-02-01 00:16:12.000000', 'consum', 0.0218, 'lps'),
	(509464, 127, '2014-02-01 00:16:13.000000', 'consum', 0.0214, 'lps'),
	(509465, 127, '2014-02-01 00:16:14.000000', 'consum', 0.0222, 'lps'),
	(509466, 127, '2014-02-01 00:16:15.000000', 'consum', 0.0211, 'lps'),
	(509467, 127, '2014-02-01 00:16:16.000000', 'consum', 0.0211, 'lps'),
	(509468, 127, '2014-02-01 00:16:17.000000', 'consum', 0.0213, 'lps'),
	(509469, 127, '2014-02-01 00:16:18.000000', 'consum', 0.0224, 'lps'),
	(509470, 127, '2014-02-01 00:16:19.000000', 'consum', 0.0223, 'lps'),
	(509471, 127, '2014-02-01 00:16:20.000000', 'consum', 0.0216, 'lps'),
	(509472, 127, '2014-02-01 00:16:21.000000', 'consum', 0.0218, 'lps'),
	(509473, 127, '2014-02-01 00:16:22.000000', 'consum', 0.0219, 'lps'),
	(509474, 127, '2014-02-01 00:16:23.000000', 'consum', 0.0212, 'lps'),
	(509475, 127, '2014-02-01 00:16:24.000000', 'consum', 0.0212, 'lps'),
	(509476, 127, '2014-02-01 00:16:25.000000', 'consum', 0.0212, 'lps'),
	(509477, 127, '2014-02-01 00:16:26.000000', 'consum', 0.0216, 'lps'),
	(509478, 127, '2014-02-01 00:16:27.000000', 'consum', 0.0217, 'lps'),
	(509479, 127, '2014-02-01 00:16:28.000000', 'consum', 0.0214, 'lps'),
	(509480, 127, '2014-02-01 00:16:29.000000', 'consum', 0.0223, 'lps'),
	(509481, 127, '2014-02-01 00:16:30.000000', 'consum', 0.0215, 'lps'),
	(509482, 127, '2014-02-01 00:16:31.000000', 'consum', 0.0212, 'lps'),
	(509483, 127, '2014-02-01 00:16:32.000000', 'consum', 0.0222, 'lps'),
	(509484, 127, '2014-02-01 00:16:33.000000', 'consum', 0.0215, 'lps'),
	(509485, 127, '2014-02-01 00:16:34.000000', 'consum', 0.0219, 'lps'),
	(509486, 127, '2014-02-01 00:16:35.000000', 'consum', 0.0222, 'lps'),
	(509487, 127, '2014-02-01 00:16:36.000000', 'consum', 0.0214, 'lps'),
	(509488, 127, '2014-02-01 00:16:37.000000', 'consum', 0.0224, 'lps'),
	(509489, 127, '2014-02-01 00:16:38.000000', 'consum', 0.0219, 'lps'),
	(509490, 127, '2014-02-01 00:16:39.000000', 'consum', 0.0217, 'lps'),
	(509491, 127, '2014-02-01 00:16:40.000000', 'consum', 0.0218, 'lps'),
	(509492, 127, '2014-02-01 00:16:41.000000', 'consum', 0.0211, 'lps'),
	(509493, 127, '2014-02-01 00:16:42.000000', 'consum', 0.0224, 'lps'),
	(509494, 127, '2014-02-01 00:16:43.000000', 'consum', 0.0216, 'lps'),
	(509495, 127, '2014-02-01 00:16:44.000000', 'consum', 0.0213, 'lps'),
	(509496, 127, '2014-02-01 00:16:45.000000', 'consum', 0.0223, 'lps'),
	(509497, 127, '2014-02-01 00:16:46.000000', 'consum', 0.0220, 'lps'),
	(509498, 127, '2014-02-01 00:16:47.000000', 'consum', 0.0221, 'lps'),
	(509499, 127, '2014-02-01 00:16:48.000000', 'consum', 0.0218, 'lps'),
	(509500, 127, '2014-02-01 00:16:49.000000', 'consum', 0.0217, 'lps'),
	(509501, 127, '2014-02-01 00:16:50.000000', 'consum', 0.0221, 'lps'),
	(509502, 127, '2014-02-01 00:16:51.000000', 'consum', 0.0212, 'lps'),
	(509503, 127, '2014-02-01 00:16:52.000000', 'consum', 0.0220, 'lps'),
	(509504, 127, '2014-02-01 00:16:53.000000', 'consum', 0.0221, 'lps'),
	(509505, 127, '2014-02-01 00:16:54.000000', 'consum', 0.0221, 'lps'),
	(509506, 127, '2014-02-01 00:16:55.000000', 'consum', 0.0216, 'lps'),
	(509507, 127, '2014-02-01 00:16:56.000000', 'consum', 0.0225, 'lps'),
	(509508, 127, '2014-02-01 00:16:57.000000', 'consum', 0.0218, 'lps'),
	(509509, 127, '2014-02-01 00:16:58.000000', 'consum', 0.0224, 'lps'),
	(509510, 127, '2014-02-01 00:16:59.000000', 'consum', 0.0223, 'lps'),
	(509511, 127, '2014-02-01 00:17:00.000000', 'consum', 0.0216, 'lps'),
	(509512, 127, '2014-02-01 00:17:01.000000', 'consum', 0.0219, 'lps'),
	(509513, 127, '2014-02-01 00:17:02.000000', 'consum', 0.0219, 'lps'),
	(509514, 127, '2014-02-01 00:17:03.000000', 'consum', 0.0216, 'lps'),
	(509515, 127, '2014-02-01 00:17:04.000000', 'consum', 0.0210, 'lps'),
	(509516, 127, '2014-02-01 00:17:05.000000', 'consum', 0.0211, 'lps'),
	(509517, 127, '2014-02-01 00:17:06.000000', 'consum', 0.0213, 'lps'),
	(509518, 127, '2014-02-01 00:17:07.000000', 'consum', 0.0224, 'lps'),
	(509519, 127, '2014-02-01 00:17:08.000000', 'consum', 0.0223, 'lps'),
	(509520, 127, '2014-02-01 00:17:09.000000', 'consum', 0.0219, 'lps'),
	(509521, 127, '2014-02-01 00:17:10.000000', 'consum', 0.0214, 'lps'),
	(509522, 127, '2014-02-01 00:17:11.000000', 'consum', 0.0220, 'lps'),
	(509523, 127, '2014-02-01 00:17:12.000000', 'consum', 0.0215, 'lps'),
	(509524, 127, '2014-02-01 00:17:13.000000', 'consum', 0.0223, 'lps'),
	(509525, 127, '2014-02-01 00:17:14.000000', 'consum', 0.0212, 'lps'),
	(509526, 127, '2014-02-01 00:17:15.000000', 'consum', 0.0213, 'lps'),
	(509527, 127, '2014-02-01 00:17:16.000000', 'consum', 0.0218, 'lps'),
	(509528, 127, '2014-02-01 00:17:17.000000', 'consum', 0.0213, 'lps'),
	(509529, 127, '2014-02-01 00:17:18.000000', 'consum', 0.0215, 'lps'),
	(509530, 127, '2014-02-01 00:17:19.000000', 'consum', 0.0211, 'lps'),
	(509531, 127, '2014-02-01 00:17:20.000000', 'consum', 0.0215, 'lps'),
	(509532, 127, '2014-02-01 00:17:21.000000', 'consum', 0.0218, 'lps'),
	(509533, 127, '2014-02-01 00:17:22.000000', 'consum', 0.0218, 'lps'),
	(509534, 127, '2014-02-01 00:17:23.000000', 'consum', 0.0210, 'lps'),
	(509535, 127, '2014-02-01 00:17:24.000000', 'consum', 0.0220, 'lps'),
	(509536, 127, '2014-02-01 00:17:25.000000', 'consum', 0.0212, 'lps'),
	(509537, 127, '2014-02-01 00:17:26.000000', 'consum', 0.0221, 'lps'),
	(509538, 127, '2014-02-01 00:17:27.000000', 'consum', 0.0214, 'lps'),
	(509539, 127, '2014-02-01 00:17:28.000000', 'consum', 0.0211, 'lps'),
	(509540, 127, '2014-02-01 00:17:29.000000', 'consum', 0.0221, 'lps'),
	(509541, 127, '2014-02-01 00:17:30.000000', 'consum', 0.0213, 'lps'),
	(509542, 127, '2014-02-01 00:17:31.000000', 'consum', 0.0211, 'lps'),
	(509543, 127, '2014-02-01 00:17:32.000000', 'consum', 0.0220, 'lps'),
	(509544, 127, '2014-02-01 00:17:33.000000', 'consum', 0.0211, 'lps'),
	(509545, 127, '2014-02-01 00:17:34.000000', 'consum', 0.0217, 'lps'),
	(509546, 127, '2014-02-01 00:17:35.000000', 'consum', 0.0210, 'lps'),
	(509547, 127, '2014-02-01 00:17:36.000000', 'consum', 0.0224, 'lps'),
	(509548, 127, '2014-02-01 00:17:37.000000', 'consum', 0.0215, 'lps'),
	(509549, 127, '2014-02-01 00:17:38.000000', 'consum', 0.0223, 'lps'),
	(509550, 127, '2014-02-01 00:17:39.000000', 'consum', 0.0216, 'lps'),
	(509551, 127, '2014-02-01 00:17:40.000000', 'consum', 0.0216, 'lps'),
	(509552, 127, '2014-02-01 00:17:41.000000', 'consum', 0.0225, 'lps'),
	(509553, 127, '2014-02-01 00:17:42.000000', 'consum', 0.0216, 'lps'),
	(509554, 127, '2014-02-01 00:17:43.000000', 'consum', 0.0214, 'lps'),
	(509555, 127, '2014-02-01 00:17:44.000000', 'consum', 0.0213, 'lps'),
	(509556, 127, '2014-02-01 00:17:45.000000', 'consum', 0.0214, 'lps'),
	(509557, 127, '2014-02-01 00:17:46.000000', 'consum', 0.0220, 'lps'),
	(509558, 127, '2014-02-01 00:17:47.000000', 'consum', 0.0218, 'lps'),
	(509559, 127, '2014-02-01 00:17:48.000000', 'consum', 0.0219, 'lps'),
	(509560, 127, '2014-02-01 00:17:49.000000', 'consum', 0.0216, 'lps'),
	(509561, 127, '2014-02-01 00:17:50.000000', 'consum', 0.0214, 'lps'),
	(509562, 127, '2014-02-01 00:17:51.000000', 'consum', 0.0211, 'lps'),
	(509563, 127, '2014-02-01 00:17:52.000000', 'consum', 0.0218, 'lps'),
	(509564, 127, '2014-02-01 00:17:53.000000', 'consum', 0.0218, 'lps'),
	(509565, 127, '2014-02-01 00:17:54.000000', 'consum', 0.0225, 'lps'),
	(509566, 127, '2014-02-01 00:17:55.000000', 'consum', 0.0215, 'lps'),
	(509567, 127, '2014-02-01 00:17:56.000000', 'consum', 0.0223, 'lps'),
	(509568, 127, '2014-02-01 00:17:57.000000', 'consum', 0.0212, 'lps'),
	(509569, 127, '2014-02-01 00:17:58.000000', 'consum', 0.0215, 'lps'),
	(509570, 127, '2014-02-01 00:17:59.000000', 'consum', 0.0212, 'lps'),
	(509571, 127, '2014-02-01 00:18:00.000000', 'consum', 0.0223, 'lps'),
	(509572, 127, '2014-02-01 00:18:01.000000', 'consum', 0.0220, 'lps'),
	(509573, 127, '2014-02-01 00:18:02.000000', 'consum', 0.0221, 'lps'),
	(509574, 127, '2014-02-01 00:18:03.000000', 'consum', 0.0219, 'lps'),
	(509575, 127, '2014-02-01 00:18:04.000000', 'consum', 0.0221, 'lps'),
	(509576, 127, '2014-02-01 00:18:05.000000', 'consum', 0.0225, 'lps'),
	(509577, 127, '2014-02-01 00:18:06.000000', 'consum', 0.0219, 'lps'),
	(509578, 127, '2014-02-01 00:18:07.000000', 'consum', 0.0212, 'lps'),
	(509579, 127, '2014-02-01 00:18:08.000000', 'consum', 0.0225, 'lps'),
	(509580, 127, '2014-02-01 00:18:09.000000', 'consum', 0.0214, 'lps'),
	(509581, 127, '2014-02-01 00:18:10.000000', 'consum', 0.0218, 'lps'),
	(509582, 127, '2014-02-01 00:18:11.000000', 'consum', 0.0222, 'lps'),
	(509583, 127, '2014-02-01 00:18:12.000000', 'consum', 0.0214, 'lps'),
	(509584, 127, '2014-02-01 00:18:13.000000', 'consum', 0.0213, 'lps'),
	(509585, 127, '2014-02-01 00:18:14.000000', 'consum', 0.0212, 'lps'),
	(509586, 127, '2014-02-01 00:18:15.000000', 'consum', 0.0211, 'lps'),
	(509587, 127, '2014-02-01 00:18:16.000000', 'consum', 0.0225, 'lps'),
	(509588, 127, '2014-02-01 00:18:17.000000', 'consum', 0.0218, 'lps'),
	(509589, 127, '2014-02-01 00:18:18.000000', 'consum', 0.0224, 'lps'),
	(509590, 127, '2014-02-01 00:18:19.000000', 'consum', 0.0225, 'lps'),
	(509591, 127, '2014-02-01 00:18:20.000000', 'consum', 0.0210, 'lps'),
	(509592, 127, '2014-02-01 00:18:21.000000', 'consum', 0.0216, 'lps'),
	(509593, 127, '2014-02-01 00:18:22.000000', 'consum', 0.0222, 'lps'),
	(509594, 127, '2014-02-01 00:18:23.000000', 'consum', 0.0219, 'lps'),
	(509595, 127, '2014-02-01 00:18:24.000000', 'consum', 0.0222, 'lps'),
	(509596, 127, '2014-02-01 00:18:25.000000', 'consum', 0.0213, 'lps'),
	(509597, 127, '2014-02-01 00:18:26.000000', 'consum', 0.0218, 'lps'),
	(509598, 127, '2014-02-01 00:18:27.000000', 'consum', 0.0212, 'lps'),
	(509599, 127, '2014-02-01 00:18:28.000000', 'consum', 0.0211, 'lps'),
	(509600, 127, '2014-02-01 00:18:29.000000', 'consum', 0.0210, 'lps'),
	(509601, 127, '2014-02-01 00:18:30.000000', 'consum', 0.0223, 'lps'),
	(509602, 127, '2014-02-01 00:18:31.000000', 'consum', 0.0211, 'lps'),
	(509603, 127, '2014-02-01 00:18:32.000000', 'consum', 0.0224, 'lps'),
	(509604, 127, '2014-02-01 00:18:33.000000', 'consum', 0.0215, 'lps'),
	(509605, 127, '2014-02-01 00:18:34.000000', 'consum', 0.0224, 'lps'),
	(509606, 127, '2014-02-01 00:18:35.000000', 'consum', 0.0218, 'lps'),
	(509607, 127, '2014-02-01 00:18:36.000000', 'consum', 0.0210, 'lps'),
	(509608, 127, '2014-02-01 00:18:37.000000', 'consum', 0.0219, 'lps'),
	(509609, 127, '2014-02-01 00:18:38.000000', 'consum', 0.0222, 'lps'),
	(509610, 127, '2014-02-01 00:18:39.000000', 'consum', 0.0210, 'lps'),
	(509611, 127, '2014-02-01 00:18:40.000000', 'consum', 0.0225, 'lps'),
	(509612, 127, '2014-02-01 00:18:41.000000', 'consum', 0.0220, 'lps'),
	(509613, 127, '2014-02-01 00:18:42.000000', 'consum', 0.0214, 'lps'),
	(509614, 127, '2014-02-01 00:18:43.000000', 'consum', 0.0220, 'lps'),
	(509615, 127, '2014-02-01 00:18:44.000000', 'consum', 0.0215, 'lps'),
	(509616, 127, '2014-02-01 00:18:45.000000', 'consum', 0.0219, 'lps'),
	(509617, 127, '2014-02-01 00:18:46.000000', 'consum', 0.0212, 'lps'),
	(509618, 127, '2014-02-01 00:18:47.000000', 'consum', 0.0225, 'lps'),
	(509619, 127, '2014-02-01 00:18:48.000000', 'consum', 0.0214, 'lps'),
	(509620, 127, '2014-02-01 00:18:49.000000', 'consum', 0.0220, 'lps'),
	(509621, 127, '2014-02-01 00:18:50.000000', 'consum', 0.0214, 'lps'),
	(509622, 127, '2014-02-01 00:18:51.000000', 'consum', 0.0220, 'lps'),
	(509623, 127, '2014-02-01 00:18:52.000000', 'consum', 0.0213, 'lps'),
	(509624, 127, '2014-02-01 00:18:53.000000', 'consum', 0.0211, 'lps'),
	(509625, 127, '2014-02-01 00:18:54.000000', 'consum', 0.0222, 'lps'),
	(509626, 127, '2014-02-01 00:18:55.000000', 'consum', 0.0221, 'lps'),
	(509627, 127, '2014-02-01 00:18:56.000000', 'consum', 0.0212, 'lps'),
	(509628, 127, '2014-02-01 00:18:57.000000', 'consum', 0.0221, 'lps'),
	(509629, 127, '2014-02-01 00:18:58.000000', 'consum', 0.0212, 'lps'),
	(509630, 127, '2014-02-01 00:18:59.000000', 'consum', 0.0219, 'lps'),
	(509631, 127, '2014-02-01 00:19:00.000000', 'consum', 0.0220, 'lps'),
	(509632, 127, '2014-02-01 00:19:01.000000', 'consum', 0.0214, 'lps'),
	(509633, 127, '2014-02-01 00:19:02.000000', 'consum', 0.0216, 'lps'),
	(509634, 127, '2014-02-01 00:19:03.000000', 'consum', 0.0213, 'lps'),
	(509635, 127, '2014-02-01 00:19:04.000000', 'consum', 0.0223, 'lps'),
	(509636, 127, '2014-02-01 00:19:05.000000', 'consum', 0.0218, 'lps'),
	(509637, 127, '2014-02-01 00:19:06.000000', 'consum', 0.0210, 'lps'),
	(509638, 127, '2014-02-01 00:19:07.000000', 'consum', 0.0222, 'lps'),
	(509639, 127, '2014-02-01 00:19:08.000000', 'consum', 0.0220, 'lps'),
	(509640, 127, '2014-02-01 00:19:09.000000', 'consum', 0.0225, 'lps'),
	(509641, 127, '2014-02-01 00:19:10.000000', 'consum', 0.0222, 'lps'),
	(509642, 127, '2014-02-01 00:19:11.000000', 'consum', 0.0211, 'lps'),
	(509643, 127, '2014-02-01 00:19:12.000000', 'consum', 0.0211, 'lps'),
	(509644, 127, '2014-02-01 00:19:13.000000', 'consum', 0.0211, 'lps'),
	(509645, 127, '2014-02-01 00:19:14.000000', 'consum', 0.0213, 'lps'),
	(509646, 127, '2014-02-01 00:19:15.000000', 'consum', 0.0225, 'lps'),
	(509647, 127, '2014-02-01 00:19:16.000000', 'consum', 0.0225, 'lps'),
	(509648, 127, '2014-02-01 00:19:17.000000', 'consum', 0.0211, 'lps'),
	(509649, 127, '2014-02-01 00:19:18.000000', 'consum', 0.0220, 'lps'),
	(509650, 127, '2014-02-01 00:19:19.000000', 'consum', 0.0222, 'lps'),
	(509651, 127, '2014-02-01 00:19:20.000000', 'consum', 0.0210, 'lps'),
	(509652, 127, '2014-02-01 00:19:21.000000', 'consum', 0.0222, 'lps'),
	(509653, 127, '2014-02-01 00:19:22.000000', 'consum', 0.0221, 'lps'),
	(509654, 127, '2014-02-01 00:19:23.000000', 'consum', 0.0216, 'lps'),
	(509655, 127, '2014-02-01 00:19:24.000000', 'consum', 0.0221, 'lps'),
	(509656, 127, '2014-02-01 00:19:25.000000', 'consum', 0.0218, 'lps'),
	(509657, 127, '2014-02-01 00:19:26.000000', 'consum', 0.0215, 'lps'),
	(509658, 127, '2014-02-01 00:19:27.000000', 'consum', 0.0211, 'lps'),
	(509659, 127, '2014-02-01 00:19:28.000000', 'consum', 0.0219, 'lps'),
	(509660, 127, '2014-02-01 00:19:29.000000', 'consum', 0.0221, 'lps'),
	(509661, 127, '2014-02-01 00:19:30.000000', 'consum', 0.0223, 'lps'),
	(509662, 127, '2014-02-01 00:19:31.000000', 'consum', 0.0225, 'lps'),
	(509663, 127, '2014-02-01 00:19:32.000000', 'consum', 0.0216, 'lps'),
	(509664, 127, '2014-02-01 00:19:33.000000', 'consum', 0.0210, 'lps'),
	(509665, 127, '2014-02-01 00:19:34.000000', 'consum', 0.0223, 'lps'),
	(509666, 127, '2014-02-01 00:19:35.000000', 'consum', 0.0213, 'lps'),
	(509667, 127, '2014-02-01 00:19:36.000000', 'consum', 0.0217, 'lps'),
	(509668, 127, '2014-02-01 00:19:37.000000', 'consum', 0.0220, 'lps'),
	(509669, 127, '2014-02-01 00:19:38.000000', 'consum', 0.0223, 'lps'),
	(509670, 127, '2014-02-01 00:19:39.000000', 'consum', 0.0213, 'lps'),
	(509671, 127, '2014-02-01 00:19:40.000000', 'consum', 0.0219, 'lps'),
	(509672, 127, '2014-02-01 00:19:41.000000', 'consum', 0.0214, 'lps'),
	(509673, 127, '2014-02-01 00:19:42.000000', 'consum', 0.0222, 'lps'),
	(509674, 127, '2014-02-01 00:19:43.000000', 'consum', 0.0210, 'lps'),
	(509675, 127, '2014-02-01 00:19:44.000000', 'consum', 0.0223, 'lps'),
	(509676, 127, '2014-02-01 00:19:45.000000', 'consum', 0.0210, 'lps'),
	(509677, 127, '2014-02-01 00:19:46.000000', 'consum', 0.0218, 'lps'),
	(509678, 127, '2014-02-01 00:19:47.000000', 'consum', 0.0222, 'lps'),
	(509679, 127, '2014-02-01 00:19:48.000000', 'consum', 0.0212, 'lps'),
	(509680, 127, '2014-02-01 00:19:49.000000', 'consum', 0.0218, 'lps'),
	(509681, 127, '2014-02-01 00:19:50.000000', 'consum', 0.0211, 'lps'),
	(509682, 127, '2014-02-01 00:19:51.000000', 'consum', 0.0224, 'lps'),
	(509683, 127, '2014-02-01 00:19:52.000000', 'consum', 0.0213, 'lps'),
	(509684, 127, '2014-02-01 00:19:53.000000', 'consum', 0.0214, 'lps'),
	(509685, 127, '2014-02-01 00:19:54.000000', 'consum', 0.0223, 'lps'),
	(509686, 127, '2014-02-01 00:19:55.000000', 'consum', 0.0213, 'lps'),
	(509687, 127, '2014-02-01 00:19:56.000000', 'consum', 0.0222, 'lps'),
	(509688, 127, '2014-02-01 00:19:57.000000', 'consum', 0.0213, 'lps'),
	(509689, 127, '2014-02-01 00:19:58.000000', 'consum', 0.0221, 'lps'),
	(509690, 127, '2014-02-01 00:19:59.000000', 'consum', 0.0225, 'lps'),
	(509691, 127, '2014-02-01 00:20:00.000000', 'consum', 0.0221, 'lps'),
	(509692, 127, '2014-02-01 00:20:01.000000', 'consum', 0.0219, 'lps'),
	(509693, 127, '2014-02-01 00:20:02.000000', 'consum', 0.0221, 'lps'),
	(509694, 127, '2014-02-01 00:20:03.000000', 'consum', 0.0210, 'lps'),
	(509695, 127, '2014-02-01 00:20:04.000000', 'consum', 0.0225, 'lps'),
	(509696, 127, '2014-02-01 00:20:05.000000', 'consum', 0.0219, 'lps'),
	(509697, 127, '2014-02-01 00:20:06.000000', 'consum', 0.0212, 'lps'),
	(509698, 127, '2014-02-01 00:20:07.000000', 'consum', 0.0224, 'lps'),
	(509699, 127, '2014-02-01 00:20:08.000000', 'consum', 0.0210, 'lps'),
	(509700, 127, '2014-02-01 00:20:09.000000', 'consum', 0.0217, 'lps'),
	(509701, 127, '2014-02-01 00:20:10.000000', 'consum', 0.0214, 'lps'),
	(509702, 127, '2014-02-01 00:20:11.000000', 'consum', 0.0210, 'lps'),
	(509703, 127, '2014-02-01 00:20:12.000000', 'consum', 0.0215, 'lps'),
	(509704, 127, '2014-02-01 00:20:13.000000', 'consum', 0.0218, 'lps'),
	(509705, 127, '2014-02-01 00:20:14.000000', 'consum', 0.0221, 'lps'),
	(509706, 127, '2014-02-01 00:20:15.000000', 'consum', 0.0223, 'lps'),
	(509707, 127, '2014-02-01 00:20:16.000000', 'consum', 0.0211, 'lps'),
	(509708, 127, '2014-02-01 00:20:17.000000', 'consum', 0.0224, 'lps'),
	(509709, 127, '2014-02-01 00:20:18.000000', 'consum', 0.0212, 'lps'),
	(509710, 127, '2014-02-01 00:20:19.000000', 'consum', 0.0213, 'lps'),
	(509711, 127, '2014-02-01 00:20:20.000000', 'consum', 0.0217, 'lps'),
	(509712, 127, '2014-02-01 00:20:21.000000', 'consum', 0.0224, 'lps'),
	(509713, 127, '2014-02-01 00:20:22.000000', 'consum', 0.0225, 'lps'),
	(509714, 127, '2014-02-01 00:20:23.000000', 'consum', 0.0211, 'lps'),
	(509715, 127, '2014-02-01 00:20:24.000000', 'consum', 0.0218, 'lps'),
	(509716, 127, '2014-02-01 00:20:25.000000', 'consum', 0.0217, 'lps'),
	(509717, 127, '2014-02-01 00:20:26.000000', 'consum', 0.0223, 'lps'),
	(509718, 127, '2014-02-01 00:20:27.000000', 'consum', 0.0221, 'lps'),
	(509719, 127, '2014-02-01 00:20:28.000000', 'consum', 0.0211, 'lps'),
	(509720, 127, '2014-02-01 00:20:29.000000', 'consum', 0.0215, 'lps'),
	(509721, 127, '2014-02-01 00:20:30.000000', 'consum', 0.0214, 'lps'),
	(509722, 127, '2014-02-01 00:20:31.000000', 'consum', 0.0217, 'lps'),
	(509723, 127, '2014-02-01 00:20:32.000000', 'consum', 0.0215, 'lps'),
	(509724, 127, '2014-02-01 00:20:33.000000', 'consum', 0.0218, 'lps'),
	(509725, 127, '2014-02-01 00:20:34.000000', 'consum', 0.0218, 'lps'),
	(509726, 127, '2014-02-01 00:20:35.000000', 'consum', 0.0211, 'lps'),
	(509727, 127, '2014-02-01 00:20:36.000000', 'consum', 0.0222, 'lps'),
	(509728, 127, '2014-02-01 00:20:37.000000', 'consum', 0.0219, 'lps'),
	(509729, 127, '2014-02-01 00:20:38.000000', 'consum', 0.0223, 'lps'),
	(509730, 127, '2014-02-01 00:20:39.000000', 'consum', 0.0213, 'lps'),
	(509731, 127, '2014-02-01 00:20:40.000000', 'consum', 0.0220, 'lps'),
	(509732, 127, '2014-02-01 00:20:41.000000', 'consum', 0.0219, 'lps'),
	(509733, 127, '2014-02-01 00:20:42.000000', 'consum', 0.0225, 'lps'),
	(509734, 127, '2014-02-01 00:20:43.000000', 'consum', 0.0213, 'lps'),
	(509735, 127, '2014-02-01 00:20:44.000000', 'consum', 0.0211, 'lps'),
	(509736, 127, '2014-02-01 00:20:45.000000', 'consum', 0.0222, 'lps'),
	(509737, 127, '2014-02-01 00:20:46.000000', 'consum', 0.0221, 'lps'),
	(509738, 127, '2014-02-01 00:20:47.000000', 'consum', 0.0214, 'lps'),
	(509739, 127, '2014-02-01 00:20:48.000000', 'consum', 0.0212, 'lps'),
	(509740, 127, '2014-02-01 00:20:49.000000', 'consum', 0.0210, 'lps'),
	(509741, 127, '2014-02-01 00:20:50.000000', 'consum', 0.0220, 'lps'),
	(509742, 127, '2014-02-01 00:20:51.000000', 'consum', 0.0212, 'lps'),
	(509743, 127, '2014-02-01 00:20:52.000000', 'consum', 0.0224, 'lps'),
	(509744, 127, '2014-02-01 00:20:53.000000', 'consum', 0.0224, 'lps'),
	(509745, 127, '2014-02-01 00:20:54.000000', 'consum', 0.0224, 'lps'),
	(509746, 127, '2014-02-01 00:20:55.000000', 'consum', 0.0224, 'lps'),
	(509747, 127, '2014-02-01 00:20:56.000000', 'consum', 0.0222, 'lps'),
	(509748, 127, '2014-02-01 00:20:57.000000', 'consum', 0.0212, 'lps'),
	(509749, 127, '2014-02-01 00:20:58.000000', 'consum', 0.0217, 'lps'),
	(509750, 127, '2014-02-01 00:20:59.000000', 'consum', 0.0225, 'lps'),
	(509751, 127, '2014-02-01 00:21:00.000000', 'consum', 0.0214, 'lps'),
	(509752, 127, '2014-02-01 00:21:01.000000', 'consum', 0.0220, 'lps'),
	(509753, 127, '2014-02-01 00:21:02.000000', 'consum', 0.0217, 'lps'),
	(509754, 127, '2014-02-01 00:21:03.000000', 'consum', 0.0214, 'lps'),
	(509755, 127, '2014-02-01 00:21:04.000000', 'consum', 0.0210, 'lps'),
	(509756, 127, '2014-02-01 00:21:05.000000', 'consum', 0.0212, 'lps'),
	(509757, 127, '2014-02-01 00:21:06.000000', 'consum', 0.0224, 'lps'),
	(509758, 127, '2014-02-01 00:21:07.000000', 'consum', 0.0224, 'lps'),
	(509759, 127, '2014-02-01 00:21:08.000000', 'consum', 0.0224, 'lps'),
	(509760, 127, '2014-02-01 00:21:09.000000', 'consum', 0.0221, 'lps'),
	(509761, 127, '2014-02-01 00:21:10.000000', 'consum', 0.0225, 'lps'),
	(509762, 127, '2014-02-01 00:21:11.000000', 'consum', 0.0220, 'lps'),
	(509763, 127, '2014-02-01 00:21:12.000000', 'consum', 0.0214, 'lps'),
	(509764, 127, '2014-02-01 00:21:13.000000', 'consum', 0.0216, 'lps'),
	(509765, 127, '2014-02-01 00:21:14.000000', 'consum', 0.0215, 'lps'),
	(509766, 127, '2014-02-01 00:21:15.000000', 'consum', 0.0215, 'lps'),
	(509767, 127, '2014-02-01 00:21:16.000000', 'consum', 0.0220, 'lps'),
	(509768, 127, '2014-02-01 00:21:17.000000', 'consum', 0.0215, 'lps'),
	(509769, 127, '2014-02-01 00:21:18.000000', 'consum', 0.0219, 'lps'),
	(509770, 127, '2014-02-01 00:21:19.000000', 'consum', 0.0211, 'lps'),
	(509771, 127, '2014-02-01 00:21:20.000000', 'consum', 0.0220, 'lps'),
	(509772, 127, '2014-02-01 00:21:21.000000', 'consum', 0.0210, 'lps'),
	(509773, 127, '2014-02-01 00:21:22.000000', 'consum', 0.0214, 'lps'),
	(509774, 127, '2014-02-01 00:21:23.000000', 'consum', 0.0211, 'lps'),
	(509775, 127, '2014-02-01 00:21:24.000000', 'consum', 0.0222, 'lps'),
	(509776, 127, '2014-02-01 00:21:25.000000', 'consum', 0.0218, 'lps'),
	(509777, 127, '2014-02-01 00:21:26.000000', 'consum', 0.0215, 'lps'),
	(509778, 127, '2014-02-01 00:21:27.000000', 'consum', 0.0212, 'lps'),
	(509779, 127, '2014-02-01 00:21:28.000000', 'consum', 0.0220, 'lps'),
	(509780, 127, '2014-02-01 00:21:29.000000', 'consum', 0.0222, 'lps'),
	(509781, 127, '2014-02-01 00:21:30.000000', 'consum', 0.0224, 'lps'),
	(509782, 127, '2014-02-01 00:21:31.000000', 'consum', 0.0212, 'lps'),
	(509783, 127, '2014-02-01 00:21:32.000000', 'consum', 0.0211, 'lps'),
	(509784, 127, '2014-02-01 00:21:33.000000', 'consum', 0.0212, 'lps'),
	(509785, 127, '2014-02-01 00:21:34.000000', 'consum', 0.0215, 'lps'),
	(509786, 127, '2014-02-01 00:21:35.000000', 'consum', 0.0214, 'lps'),
	(509787, 127, '2014-02-01 00:21:36.000000', 'consum', 0.0215, 'lps'),
	(509788, 127, '2014-02-01 00:21:37.000000', 'consum', 0.0223, 'lps'),
	(509789, 127, '2014-02-01 00:21:38.000000', 'consum', 0.0214, 'lps'),
	(509790, 127, '2014-02-01 00:21:39.000000', 'consum', 0.0222, 'lps'),
	(509791, 127, '2014-02-01 00:21:40.000000', 'consum', 0.0211, 'lps'),
	(509792, 127, '2014-02-01 00:21:41.000000', 'consum', 0.0211, 'lps'),
	(509793, 127, '2014-02-01 00:21:42.000000', 'consum', 0.0213, 'lps'),
	(509794, 127, '2014-02-01 00:21:43.000000', 'consum', 0.0224, 'lps'),
	(509795, 127, '2014-02-01 00:21:44.000000', 'consum', 0.0224, 'lps'),
	(509796, 127, '2014-02-01 00:21:45.000000', 'consum', 0.0222, 'lps'),
	(509797, 127, '2014-02-01 00:21:46.000000', 'consum', 0.0211, 'lps'),
	(509798, 127, '2014-02-01 00:21:47.000000', 'consum', 0.0211, 'lps'),
	(509799, 127, '2014-02-01 00:21:48.000000', 'consum', 0.0214, 'lps'),
	(509800, 127, '2014-02-01 00:21:49.000000', 'consum', 0.0211, 'lps'),
	(509801, 127, '2014-02-01 00:21:50.000000', 'consum', 0.0221, 'lps'),
	(509802, 127, '2014-02-01 00:21:51.000000', 'consum', 0.0214, 'lps'),
	(509803, 127, '2014-02-01 00:21:52.000000', 'consum', 0.0213, 'lps'),
	(509804, 127, '2014-02-01 00:21:53.000000', 'consum', 0.0212, 'lps'),
	(509805, 127, '2014-02-01 00:21:54.000000', 'consum', 0.0211, 'lps'),
	(509806, 127, '2014-02-01 00:21:55.000000', 'consum', 0.0225, 'lps'),
	(509807, 127, '2014-02-01 00:21:56.000000', 'consum', 0.0219, 'lps'),
	(509808, 127, '2014-02-01 00:21:57.000000', 'consum', 0.0212, 'lps'),
	(509809, 127, '2014-02-01 00:21:58.000000', 'consum', 0.0225, 'lps'),
	(509810, 127, '2014-02-01 00:21:59.000000', 'consum', 0.0216, 'lps'),
	(509811, 127, '2014-02-01 00:22:00.000000', 'consum', 0.0211, 'lps'),
	(509812, 127, '2014-02-01 00:22:01.000000', 'consum', 0.0214, 'lps'),
	(509813, 127, '2014-02-01 00:22:02.000000', 'consum', 0.0212, 'lps'),
	(509814, 127, '2014-02-01 00:22:03.000000', 'consum', 0.0210, 'lps'),
	(509815, 127, '2014-02-01 00:22:04.000000', 'consum', 0.0218, 'lps'),
	(509816, 127, '2014-02-01 00:22:05.000000', 'consum', 0.0217, 'lps'),
	(509817, 127, '2014-02-01 00:22:06.000000', 'consum', 0.0224, 'lps'),
	(509818, 127, '2014-02-01 00:22:07.000000', 'consum', 0.0210, 'lps'),
	(509819, 127, '2014-02-01 00:22:08.000000', 'consum', 0.0215, 'lps'),
	(509820, 127, '2014-02-01 00:22:09.000000', 'consum', 0.0222, 'lps'),
	(509821, 127, '2014-02-01 00:22:10.000000', 'consum', 0.0224, 'lps'),
	(509822, 127, '2014-02-01 00:22:11.000000', 'consum', 0.0211, 'lps'),
	(509823, 127, '2014-02-01 00:22:12.000000', 'consum', 0.0220, 'lps'),
	(509824, 127, '2014-02-01 00:22:13.000000', 'consum', 0.0211, 'lps'),
	(509825, 127, '2014-02-01 00:22:14.000000', 'consum', 0.0217, 'lps'),
	(509826, 127, '2014-02-01 00:22:15.000000', 'consum', 0.0225, 'lps'),
	(509827, 127, '2014-02-01 00:22:16.000000', 'consum', 0.0219, 'lps'),
	(509828, 127, '2014-02-01 00:22:17.000000', 'consum', 0.0211, 'lps'),
	(509829, 127, '2014-02-01 00:22:18.000000', 'consum', 0.0219, 'lps'),
	(509830, 127, '2014-02-01 00:22:19.000000', 'consum', 0.0221, 'lps'),
	(509831, 127, '2014-02-01 00:22:20.000000', 'consum', 0.0222, 'lps'),
	(509832, 127, '2014-02-01 00:22:21.000000', 'consum', 0.0221, 'lps'),
	(509833, 127, '2014-02-01 00:22:22.000000', 'consum', 0.0213, 'lps'),
	(509834, 127, '2014-02-01 00:22:23.000000', 'consum', 0.0224, 'lps'),
	(509835, 127, '2014-02-01 00:22:24.000000', 'consum', 0.0210, 'lps'),
	(509836, 127, '2014-02-01 00:22:25.000000', 'consum', 0.0215, 'lps'),
	(509837, 127, '2014-02-01 00:22:26.000000', 'consum', 0.0218, 'lps'),
	(509838, 127, '2014-02-01 00:22:27.000000', 'consum', 0.0221, 'lps'),
	(509839, 127, '2014-02-01 00:22:28.000000', 'consum', 0.0210, 'lps'),
	(509840, 127, '2014-02-01 00:22:29.000000', 'consum', 0.0225, 'lps'),
	(509841, 127, '2014-02-01 00:22:30.000000', 'consum', 0.0222, 'lps'),
	(509842, 127, '2014-02-01 00:22:31.000000', 'consum', 0.0210, 'lps'),
	(509843, 127, '2014-02-01 00:22:32.000000', 'consum', 0.0221, 'lps'),
	(509844, 127, '2014-02-01 00:22:33.000000', 'consum', 0.0218, 'lps'),
	(509845, 127, '2014-02-01 00:22:34.000000', 'consum', 0.0220, 'lps'),
	(509846, 127, '2014-02-01 00:22:35.000000', 'consum', 0.0217, 'lps'),
	(509847, 127, '2014-02-01 00:22:36.000000', 'consum', 0.0216, 'lps'),
	(509848, 127, '2014-02-01 00:22:37.000000', 'consum', 0.0218, 'lps'),
	(509849, 127, '2014-02-01 00:22:38.000000', 'consum', 0.0219, 'lps'),
	(509850, 127, '2014-02-01 00:22:39.000000', 'consum', 0.0214, 'lps'),
	(509851, 127, '2014-02-01 00:22:40.000000', 'consum', 0.0219, 'lps'),
	(509852, 127, '2014-02-01 00:22:41.000000', 'consum', 0.0214, 'lps'),
	(509853, 127, '2014-02-01 00:22:42.000000', 'consum', 0.0219, 'lps'),
	(509854, 127, '2014-02-01 00:22:43.000000', 'consum', 0.0212, 'lps'),
	(509855, 127, '2014-02-01 00:22:44.000000', 'consum', 0.0224, 'lps'),
	(509856, 127, '2014-02-01 00:22:45.000000', 'consum', 0.0213, 'lps'),
	(509857, 127, '2014-02-01 00:22:46.000000', 'consum', 0.0212, 'lps'),
	(509858, 127, '2014-02-01 00:22:47.000000', 'consum', 0.0215, 'lps'),
	(509859, 127, '2014-02-01 00:22:48.000000', 'consum', 0.0211, 'lps'),
	(509860, 127, '2014-02-01 00:22:49.000000', 'consum', 0.0217, 'lps'),
	(509861, 127, '2014-02-01 00:22:50.000000', 'consum', 0.0212, 'lps'),
	(509862, 127, '2014-02-01 00:22:51.000000', 'consum', 0.0213, 'lps'),
	(509863, 127, '2014-02-01 00:22:52.000000', 'consum', 0.0222, 'lps'),
	(509864, 127, '2014-02-01 00:22:53.000000', 'consum', 0.0213, 'lps'),
	(509865, 127, '2014-02-01 00:22:54.000000', 'consum', 0.0219, 'lps'),
	(509866, 127, '2014-02-01 00:22:55.000000', 'consum', 0.0217, 'lps'),
	(509867, 127, '2014-02-01 00:22:56.000000', 'consum', 0.0216, 'lps'),
	(509868, 127, '2014-02-01 00:22:57.000000', 'consum', 0.0220, 'lps'),
	(509869, 127, '2014-02-01 00:22:58.000000', 'consum', 0.0210, 'lps'),
	(509870, 127, '2014-02-01 00:22:59.000000', 'consum', 0.0213, 'lps'),
	(509871, 127, '2014-02-01 00:23:00.000000', 'consum', 0.0210, 'lps'),
	(509872, 127, '2014-02-01 00:23:01.000000', 'consum', 0.0218, 'lps'),
	(509873, 127, '2014-02-01 00:23:02.000000', 'consum', 0.0219, 'lps'),
	(509874, 127, '2014-02-01 00:23:03.000000', 'consum', 0.0214, 'lps'),
	(509875, 127, '2014-02-01 00:23:04.000000', 'consum', 0.0220, 'lps'),
	(509876, 127, '2014-02-01 00:23:05.000000', 'consum', 0.0215, 'lps'),
	(509877, 127, '2014-02-01 00:23:06.000000', 'consum', 0.0222, 'lps'),
	(509878, 127, '2014-02-01 00:23:07.000000', 'consum', 0.0222, 'lps'),
	(509879, 127, '2014-02-01 00:23:08.000000', 'consum', 0.0221, 'lps'),
	(509880, 127, '2014-02-01 00:23:09.000000', 'consum', 0.0211, 'lps'),
	(509881, 127, '2014-02-01 00:23:10.000000', 'consum', 0.0216, 'lps'),
	(509882, 127, '2014-02-01 00:23:11.000000', 'consum', 0.0223, 'lps'),
	(509883, 127, '2014-02-01 00:23:12.000000', 'consum', 0.0225, 'lps'),
	(509884, 127, '2014-02-01 00:23:13.000000', 'consum', 0.0212, 'lps'),
	(509885, 127, '2014-02-01 00:23:14.000000', 'consum', 0.0211, 'lps'),
	(509886, 127, '2014-02-01 00:23:15.000000', 'consum', 0.0223, 'lps'),
	(509887, 127, '2014-02-01 00:23:16.000000', 'consum', 0.0224, 'lps'),
	(509888, 127, '2014-02-01 00:23:17.000000', 'consum', 0.0212, 'lps'),
	(509889, 127, '2014-02-01 00:23:18.000000', 'consum', 0.0225, 'lps'),
	(509890, 127, '2014-02-01 00:23:19.000000', 'consum', 0.0218, 'lps'),
	(509891, 127, '2014-02-01 00:23:20.000000', 'consum', 0.0219, 'lps'),
	(509892, 127, '2014-02-01 00:23:21.000000', 'consum', 0.0217, 'lps'),
	(509893, 127, '2014-02-01 00:23:22.000000', 'consum', 0.0219, 'lps'),
	(509894, 127, '2014-02-01 00:23:23.000000', 'consum', 0.0217, 'lps'),
	(509895, 127, '2014-02-01 00:23:24.000000', 'consum', 0.0219, 'lps'),
	(509896, 127, '2014-02-01 00:23:25.000000', 'consum', 0.0220, 'lps'),
	(509897, 127, '2014-02-01 00:23:26.000000', 'consum', 0.0218, 'lps'),
	(509898, 127, '2014-02-01 00:23:27.000000', 'consum', 0.0221, 'lps'),
	(509899, 127, '2014-02-01 00:23:28.000000', 'consum', 0.0210, 'lps'),
	(509900, 127, '2014-02-01 00:23:29.000000', 'consum', 0.0225, 'lps'),
	(509901, 127, '2014-02-01 00:23:30.000000', 'consum', 0.0221, 'lps'),
	(509902, 127, '2014-02-01 00:23:31.000000', 'consum', 0.0220, 'lps'),
	(509903, 127, '2014-02-01 00:23:32.000000', 'consum', 0.0214, 'lps'),
	(509904, 127, '2014-02-01 00:23:33.000000', 'consum', 0.0214, 'lps'),
	(509905, 127, '2014-02-01 00:23:34.000000', 'consum', 0.0218, 'lps'),
	(509906, 127, '2014-02-01 00:23:35.000000', 'consum', 0.0222, 'lps'),
	(509907, 127, '2014-02-01 00:23:36.000000', 'consum', 0.0216, 'lps'),
	(509908, 127, '2014-02-01 00:23:37.000000', 'consum', 0.0220, 'lps'),
	(509909, 127, '2014-02-01 00:23:38.000000', 'consum', 0.0211, 'lps'),
	(509910, 127, '2014-02-01 00:23:39.000000', 'consum', 0.0218, 'lps'),
	(509911, 127, '2014-02-01 00:23:40.000000', 'consum', 0.0215, 'lps'),
	(509912, 127, '2014-02-01 00:23:41.000000', 'consum', 0.0211, 'lps'),
	(509913, 127, '2014-02-01 00:23:42.000000', 'consum', 0.0217, 'lps'),
	(509914, 127, '2014-02-01 00:23:43.000000', 'consum', 0.0210, 'lps'),
	(509915, 127, '2014-02-01 00:23:44.000000', 'consum', 0.0224, 'lps'),
	(509916, 127, '2014-02-01 00:23:45.000000', 'consum', 0.0214, 'lps'),
	(509917, 127, '2014-02-01 00:23:46.000000', 'consum', 0.0220, 'lps'),
	(509918, 127, '2014-02-01 00:23:47.000000', 'consum', 0.0217, 'lps'),
	(509919, 127, '2014-02-01 00:23:48.000000', 'consum', 0.0218, 'lps'),
	(509920, 127, '2014-02-01 00:23:49.000000', 'consum', 0.0210, 'lps'),
	(509921, 127, '2014-02-01 00:23:50.000000', 'consum', 0.0222, 'lps'),
	(509922, 127, '2014-02-01 00:23:51.000000', 'consum', 0.0220, 'lps'),
	(509923, 127, '2014-02-01 00:23:52.000000', 'consum', 0.0224, 'lps'),
	(509924, 127, '2014-02-01 00:23:53.000000', 'consum', 0.0219, 'lps'),
	(509925, 127, '2014-02-01 00:23:54.000000', 'consum', 0.0214, 'lps'),
	(509926, 127, '2014-02-01 00:23:55.000000', 'consum', 0.0220, 'lps'),
	(509927, 127, '2014-02-01 00:23:56.000000', 'consum', 0.0218, 'lps'),
	(509928, 127, '2014-02-01 00:23:57.000000', 'consum', 0.0217, 'lps'),
	(509929, 127, '2014-02-01 00:23:58.000000', 'consum', 0.0225, 'lps'),
	(509930, 127, '2014-02-01 00:23:59.000000', 'consum', 0.0214, 'lps'),
	(509931, 127, '2014-02-01 00:24:00.000000', 'consum', 0.0219, 'lps'),
	(509932, 127, '2014-02-01 00:24:01.000000', 'consum', 0.0211, 'lps'),
	(509933, 127, '2014-02-01 00:24:02.000000', 'consum', 0.0220, 'lps'),
	(509934, 127, '2014-02-01 00:24:03.000000', 'consum', 0.0225, 'lps'),
	(509935, 127, '2014-02-01 00:24:04.000000', 'consum', 0.0210, 'lps'),
	(509936, 127, '2014-02-01 00:24:05.000000', 'consum', 0.0212, 'lps'),
	(509937, 127, '2014-02-01 00:24:06.000000', 'consum', 0.0219, 'lps'),
	(509938, 127, '2014-02-01 00:24:07.000000', 'consum', 0.0220, 'lps'),
	(509939, 127, '2014-02-01 00:24:08.000000', 'consum', 0.0215, 'lps'),
	(509940, 127, '2014-02-01 00:24:09.000000', 'consum', 0.0224, 'lps'),
	(509941, 127, '2014-02-01 00:24:10.000000', 'consum', 0.0216, 'lps'),
	(509942, 127, '2014-02-01 00:24:11.000000', 'consum', 0.0215, 'lps'),
	(509943, 127, '2014-02-01 00:24:12.000000', 'consum', 0.0218, 'lps'),
	(509944, 127, '2014-02-01 00:24:13.000000', 'consum', 0.0220, 'lps'),
	(509945, 127, '2014-02-01 00:24:14.000000', 'consum', 0.0221, 'lps'),
	(509946, 127, '2014-02-01 00:24:15.000000', 'consum', 0.0219, 'lps'),
	(509947, 127, '2014-02-01 00:24:16.000000', 'consum', 0.0223, 'lps'),
	(509948, 127, '2014-02-01 00:24:17.000000', 'consum', 0.0215, 'lps'),
	(509949, 127, '2014-02-01 00:24:18.000000', 'consum', 0.0215, 'lps'),
	(509950, 127, '2014-02-01 00:24:19.000000', 'consum', 0.0218, 'lps'),
	(509951, 127, '2014-02-01 00:24:20.000000', 'consum', 0.0218, 'lps'),
	(509952, 127, '2014-02-01 00:24:21.000000', 'consum', 0.0213, 'lps'),
	(509953, 127, '2014-02-01 00:24:22.000000', 'consum', 0.0219, 'lps'),
	(509954, 127, '2014-02-01 00:24:23.000000', 'consum', 0.0213, 'lps'),
	(509955, 127, '2014-02-01 00:24:24.000000', 'consum', 0.0215, 'lps'),
	(509956, 127, '2014-02-01 00:24:25.000000', 'consum', 0.0225, 'lps'),
	(509957, 127, '2014-02-01 00:24:26.000000', 'consum', 0.0222, 'lps'),
	(509958, 127, '2014-02-01 00:24:27.000000', 'consum', 0.0211, 'lps'),
	(509959, 127, '2014-02-01 00:24:28.000000', 'consum', 0.0210, 'lps'),
	(509960, 127, '2014-02-01 00:24:29.000000', 'consum', 0.0224, 'lps'),
	(509961, 127, '2014-02-01 00:24:30.000000', 'consum', 0.0218, 'lps'),
	(509962, 127, '2014-02-01 00:24:31.000000', 'consum', 0.0223, 'lps'),
	(509963, 127, '2014-02-01 00:24:32.000000', 'consum', 0.0219, 'lps'),
	(509964, 127, '2014-02-01 00:24:33.000000', 'consum', 0.0218, 'lps'),
	(509965, 127, '2014-02-01 00:24:34.000000', 'consum', 0.0223, 'lps'),
	(509966, 127, '2014-02-01 00:24:35.000000', 'consum', 0.0218, 'lps'),
	(509967, 127, '2014-02-01 00:24:36.000000', 'consum', 0.0214, 'lps'),
	(509968, 127, '2014-02-01 00:24:37.000000', 'consum', 0.0222, 'lps'),
	(509969, 127, '2014-02-01 00:24:38.000000', 'consum', 0.0212, 'lps'),
	(509970, 127, '2014-02-01 00:24:39.000000', 'consum', 0.0213, 'lps'),
	(509971, 127, '2014-02-01 00:24:40.000000', 'consum', 0.0223, 'lps'),
	(509972, 127, '2014-02-01 00:24:41.000000', 'consum', 0.0217, 'lps'),
	(509973, 127, '2014-02-01 00:24:42.000000', 'consum', 0.0221, 'lps'),
	(509974, 127, '2014-02-01 00:24:43.000000', 'consum', 0.0213, 'lps'),
	(509975, 127, '2014-02-01 00:24:44.000000', 'consum', 0.0224, 'lps'),
	(509976, 127, '2014-02-01 00:24:45.000000', 'consum', 0.0224, 'lps'),
	(509977, 127, '2014-02-01 00:24:46.000000', 'consum', 0.0224, 'lps'),
	(509978, 127, '2014-02-01 00:24:47.000000', 'consum', 0.0220, 'lps'),
	(509979, 127, '2014-02-01 00:24:48.000000', 'consum', 0.0220, 'lps'),
	(509980, 127, '2014-02-01 00:24:49.000000', 'consum', 0.0215, 'lps'),
	(509981, 127, '2014-02-01 00:24:50.000000', 'consum', 0.0220, 'lps'),
	(509982, 127, '2014-02-01 00:24:51.000000', 'consum', 0.0214, 'lps'),
	(509983, 127, '2014-02-01 00:24:52.000000', 'consum', 0.0217, 'lps'),
	(509984, 127, '2014-02-01 00:24:53.000000', 'consum', 0.0215, 'lps'),
	(509985, 127, '2014-02-01 00:24:54.000000', 'consum', 0.0217, 'lps'),
	(509986, 127, '2014-02-01 00:24:55.000000', 'consum', 0.0215, 'lps'),
	(509987, 127, '2014-02-01 00:24:56.000000', 'consum', 0.0212, 'lps'),
	(509988, 127, '2014-02-01 00:24:57.000000', 'consum', 0.0222, 'lps'),
	(509989, 127, '2014-02-01 00:24:58.000000', 'consum', 0.0216, 'lps'),
	(509990, 127, '2014-02-01 00:24:59.000000', 'consum', 0.0221, 'lps'),
	(509991, 127, '2014-02-01 00:25:00.000000', 'consum', 0.0217, 'lps'),
	(509992, 127, '2014-02-01 00:25:01.000000', 'consum', 0.0213, 'lps'),
	(509993, 127, '2014-02-01 00:25:02.000000', 'consum', 0.0220, 'lps'),
	(509994, 127, '2014-02-01 00:25:03.000000', 'consum', 0.0220, 'lps'),
	(509995, 127, '2014-02-01 00:25:04.000000', 'consum', 0.0213, 'lps'),
	(509996, 127, '2014-02-01 00:25:05.000000', 'consum', 0.0212, 'lps'),
	(509997, 127, '2014-02-01 00:25:06.000000', 'consum', 0.0210, 'lps'),
	(509998, 127, '2014-02-01 00:25:07.000000', 'consum', 0.0219, 'lps'),
	(509999, 127, '2014-02-01 00:25:08.000000', 'consum', 0.0211, 'lps'),
	(510000, 127, '2014-02-01 00:25:09.000000', 'consum', 0.0221, 'lps'),
	(510001, 127, '2014-02-01 00:25:10.000000', 'consum', 0.0213, 'lps'),
	(510002, 127, '2014-02-01 00:25:11.000000', 'consum', 0.0223, 'lps'),
	(510003, 127, '2014-02-01 00:25:12.000000', 'consum', 0.0221, 'lps'),
	(510004, 127, '2014-02-01 00:25:13.000000', 'consum', 0.0224, 'lps'),
	(510005, 127, '2014-02-01 00:25:14.000000', 'consum', 0.0216, 'lps'),
	(510006, 127, '2014-02-01 00:25:15.000000', 'consum', 0.0216, 'lps'),
	(510007, 127, '2014-02-01 00:25:16.000000', 'consum', 0.0222, 'lps'),
	(510008, 127, '2014-02-01 00:25:17.000000', 'consum', 0.0220, 'lps'),
	(510009, 127, '2014-02-01 00:25:18.000000', 'consum', 0.0224, 'lps'),
	(510010, 127, '2014-02-01 00:25:19.000000', 'consum', 0.0219, 'lps'),
	(510011, 127, '2014-02-01 00:25:20.000000', 'consum', 0.0213, 'lps'),
	(510012, 127, '2014-02-01 00:25:21.000000', 'consum', 0.0214, 'lps'),
	(510013, 127, '2014-02-01 00:25:22.000000', 'consum', 0.0223, 'lps'),
	(510014, 127, '2014-02-01 00:25:23.000000', 'consum', 0.0216, 'lps'),
	(510015, 127, '2014-02-01 00:25:24.000000', 'consum', 0.0218, 'lps'),
	(510016, 127, '2014-02-01 00:25:25.000000', 'consum', 0.0215, 'lps'),
	(510017, 127, '2014-02-01 00:25:26.000000', 'consum', 0.0214, 'lps'),
	(510018, 127, '2014-02-01 00:25:27.000000', 'consum', 0.0214, 'lps'),
	(510019, 127, '2014-02-01 00:25:28.000000', 'consum', 0.0218, 'lps'),
	(510020, 127, '2014-02-01 00:25:29.000000', 'consum', 0.0225, 'lps'),
	(510021, 127, '2014-02-01 00:25:30.000000', 'consum', 0.0210, 'lps'),
	(510022, 127, '2014-02-01 00:25:31.000000', 'consum', 0.0217, 'lps'),
	(510023, 127, '2014-02-01 00:25:32.000000', 'consum', 0.0211, 'lps'),
	(510024, 127, '2014-02-01 00:25:33.000000', 'consum', 0.0210, 'lps'),
	(510025, 127, '2014-02-01 00:25:34.000000', 'consum', 0.0223, 'lps'),
	(510026, 127, '2014-02-01 00:25:35.000000', 'consum', 0.0213, 'lps'),
	(510027, 127, '2014-02-01 00:25:36.000000', 'consum', 0.0218, 'lps'),
	(510028, 127, '2014-02-01 00:25:37.000000', 'consum', 0.0225, 'lps'),
	(510029, 127, '2014-02-01 00:25:38.000000', 'consum', 0.0216, 'lps'),
	(510030, 127, '2014-02-01 00:25:39.000000', 'consum', 0.0224, 'lps'),
	(510031, 127, '2014-02-01 00:25:40.000000', 'consum', 0.0216, 'lps'),
	(510032, 127, '2014-02-01 00:25:41.000000', 'consum', 0.0216, 'lps'),
	(510033, 127, '2014-02-01 00:25:42.000000', 'consum', 0.0221, 'lps'),
	(510034, 127, '2014-02-01 00:25:43.000000', 'consum', 0.0216, 'lps'),
	(510035, 127, '2014-02-01 00:25:44.000000', 'consum', 0.0225, 'lps'),
	(510036, 127, '2014-02-01 00:25:45.000000', 'consum', 0.0219, 'lps'),
	(510037, 127, '2014-02-01 00:25:46.000000', 'consum', 0.0211, 'lps'),
	(510038, 127, '2014-02-01 00:25:47.000000', 'consum', 0.0220, 'lps'),
	(510039, 127, '2014-02-01 00:25:48.000000', 'consum', 0.0225, 'lps'),
	(510040, 127, '2014-02-01 00:25:49.000000', 'consum', 0.0223, 'lps'),
	(510041, 127, '2014-02-01 00:25:50.000000', 'consum', 0.0216, 'lps'),
	(510042, 127, '2014-02-01 00:25:51.000000', 'consum', 0.0216, 'lps'),
	(510043, 127, '2014-02-01 00:25:52.000000', 'consum', 0.0224, 'lps'),
	(510044, 127, '2014-02-01 00:25:53.000000', 'consum', 0.0214, 'lps'),
	(510045, 127, '2014-02-01 00:25:54.000000', 'consum', 0.0221, 'lps'),
	(510046, 127, '2014-02-01 00:25:55.000000', 'consum', 0.0222, 'lps'),
	(510047, 127, '2014-02-01 00:25:56.000000', 'consum', 0.0220, 'lps'),
	(510048, 127, '2014-02-01 00:25:57.000000', 'consum', 0.0211, 'lps'),
	(510049, 127, '2014-02-01 00:25:58.000000', 'consum', 0.0217, 'lps'),
	(510050, 127, '2014-02-01 00:25:59.000000', 'consum', 0.0210, 'lps'),
	(510051, 127, '2014-02-01 00:26:00.000000', 'consum', 0.0223, 'lps'),
	(510052, 127, '2014-02-01 00:26:01.000000', 'consum', 0.0212, 'lps'),
	(510053, 127, '2014-02-01 00:26:02.000000', 'consum', 0.0211, 'lps'),
	(510054, 127, '2014-02-01 00:26:03.000000', 'consum', 0.0210, 'lps'),
	(510055, 127, '2014-02-01 00:26:04.000000', 'consum', 0.0225, 'lps'),
	(510056, 127, '2014-02-01 00:26:05.000000', 'consum', 0.0219, 'lps'),
	(510057, 127, '2014-02-01 00:26:06.000000', 'consum', 0.0211, 'lps'),
	(510058, 127, '2014-02-01 00:26:07.000000', 'consum', 0.0223, 'lps'),
	(510059, 127, '2014-02-01 00:26:08.000000', 'consum', 0.0223, 'lps'),
	(510060, 127, '2014-02-01 00:26:09.000000', 'consum', 0.0219, 'lps'),
	(510061, 127, '2014-02-01 00:26:10.000000', 'consum', 0.0216, 'lps'),
	(510062, 127, '2014-02-01 00:26:11.000000', 'consum', 0.0213, 'lps'),
	(510063, 127, '2014-02-01 00:26:12.000000', 'consum', 0.0224, 'lps'),
	(510064, 127, '2014-02-01 00:26:13.000000', 'consum', 0.0223, 'lps'),
	(510065, 127, '2014-02-01 00:26:14.000000', 'consum', 0.0220, 'lps'),
	(510066, 127, '2014-02-01 00:26:15.000000', 'consum', 0.0220, 'lps'),
	(510067, 127, '2014-02-01 00:26:16.000000', 'consum', 0.0213, 'lps'),
	(510068, 127, '2014-02-01 00:26:17.000000', 'consum', 0.0212, 'lps'),
	(510069, 127, '2014-02-01 00:26:18.000000', 'consum', 0.0213, 'lps'),
	(510070, 127, '2014-02-01 00:26:19.000000', 'consum', 0.0217, 'lps'),
	(510071, 127, '2014-02-01 00:26:20.000000', 'consum', 0.0223, 'lps'),
	(510072, 127, '2014-02-01 00:26:21.000000', 'consum', 0.0222, 'lps'),
	(510073, 127, '2014-02-01 00:26:22.000000', 'consum', 0.0214, 'lps'),
	(510074, 127, '2014-02-01 00:26:23.000000', 'consum', 0.0210, 'lps'),
	(510075, 127, '2014-02-01 00:26:24.000000', 'consum', 0.0218, 'lps'),
	(510076, 127, '2014-02-01 00:26:25.000000', 'consum', 0.0215, 'lps'),
	(510077, 127, '2014-02-01 00:26:26.000000', 'consum', 0.0212, 'lps'),
	(510078, 127, '2014-02-01 00:26:27.000000', 'consum', 0.0224, 'lps'),
	(510079, 127, '2014-02-01 00:26:28.000000', 'consum', 0.0210, 'lps'),
	(510080, 127, '2014-02-01 00:26:29.000000', 'consum', 0.0214, 'lps'),
	(510081, 127, '2014-02-01 00:26:30.000000', 'consum', 0.0217, 'lps'),
	(510082, 127, '2014-02-01 00:26:31.000000', 'consum', 0.0215, 'lps'),
	(510083, 127, '2014-02-01 00:26:32.000000', 'consum', 0.0214, 'lps'),
	(510084, 127, '2014-02-01 00:26:33.000000', 'consum', 0.0218, 'lps'),
	(510085, 127, '2014-02-01 00:26:34.000000', 'consum', 0.0223, 'lps'),
	(510086, 127, '2014-02-01 00:26:35.000000', 'consum', 0.0220, 'lps'),
	(510087, 127, '2014-02-01 00:26:36.000000', 'consum', 0.0220, 'lps'),
	(510088, 127, '2014-02-01 00:26:37.000000', 'consum', 0.0214, 'lps'),
	(510089, 127, '2014-02-01 00:26:38.000000', 'consum', 0.0218, 'lps'),
	(510090, 127, '2014-02-01 00:26:39.000000', 'consum', 0.0222, 'lps'),
	(510091, 127, '2014-02-01 00:26:40.000000', 'consum', 0.0213, 'lps'),
	(510092, 127, '2014-02-01 00:26:41.000000', 'consum', 0.0221, 'lps'),
	(510093, 127, '2014-02-01 00:26:42.000000', 'consum', 0.0224, 'lps'),
	(510094, 127, '2014-02-01 00:26:43.000000', 'consum', 0.0215, 'lps'),
	(510095, 127, '2014-02-01 00:26:44.000000', 'consum', 0.0224, 'lps'),
	(510096, 127, '2014-02-01 00:26:45.000000', 'consum', 0.0221, 'lps'),
	(510097, 127, '2014-02-01 00:26:46.000000', 'consum', 0.0223, 'lps'),
	(510098, 127, '2014-02-01 00:26:47.000000', 'consum', 0.0211, 'lps'),
	(510099, 127, '2014-02-01 00:26:48.000000', 'consum', 0.0210, 'lps'),
	(510100, 127, '2014-02-01 00:26:49.000000', 'consum', 0.0220, 'lps'),
	(510101, 127, '2014-02-01 00:26:50.000000', 'consum', 0.0214, 'lps'),
	(510102, 127, '2014-02-01 00:26:51.000000', 'consum', 0.0218, 'lps'),
	(510103, 127, '2014-02-01 00:26:52.000000', 'consum', 0.0222, 'lps'),
	(510104, 127, '2014-02-01 00:26:53.000000', 'consum', 0.0213, 'lps'),
	(510105, 127, '2014-02-01 00:26:54.000000', 'consum', 0.0222, 'lps'),
	(510106, 127, '2014-02-01 00:26:55.000000', 'consum', 0.0212, 'lps'),
	(510107, 127, '2014-02-01 00:26:56.000000', 'consum', 0.0218, 'lps'),
	(510108, 127, '2014-02-01 00:26:57.000000', 'consum', 0.0213, 'lps'),
	(510109, 127, '2014-02-01 00:26:58.000000', 'consum', 0.0216, 'lps'),
	(510110, 127, '2014-02-01 00:26:59.000000', 'consum', 0.0218, 'lps'),
	(510111, 127, '2014-02-01 00:27:00.000000', 'consum', 0.0213, 'lps'),
	(510112, 127, '2014-02-01 00:27:01.000000', 'consum', 0.0221, 'lps'),
	(510113, 127, '2014-02-01 00:27:02.000000', 'consum', 0.0222, 'lps'),
	(510114, 127, '2014-02-01 00:27:03.000000', 'consum', 0.0221, 'lps'),
	(510115, 127, '2014-02-01 00:27:04.000000', 'consum', 0.0213, 'lps'),
	(510116, 127, '2014-02-01 00:27:05.000000', 'consum', 0.0225, 'lps'),
	(510117, 127, '2014-02-01 00:27:06.000000', 'consum', 0.0211, 'lps'),
	(510118, 127, '2014-02-01 00:27:07.000000', 'consum', 0.0221, 'lps'),
	(510119, 127, '2014-02-01 00:27:08.000000', 'consum', 0.0215, 'lps'),
	(510120, 127, '2014-02-01 00:27:09.000000', 'consum', 0.0218, 'lps'),
	(510121, 127, '2014-02-01 00:27:10.000000', 'consum', 0.0220, 'lps'),
	(510122, 127, '2014-02-01 00:27:11.000000', 'consum', 0.0219, 'lps'),
	(510123, 127, '2014-02-01 00:27:12.000000', 'consum', 0.0225, 'lps'),
	(510124, 127, '2014-02-01 00:27:13.000000', 'consum', 0.0210, 'lps'),
	(510125, 127, '2014-02-01 00:27:14.000000', 'consum', 0.0214, 'lps'),
	(510126, 127, '2014-02-01 00:27:15.000000', 'consum', 0.0215, 'lps'),
	(510127, 127, '2014-02-01 00:27:16.000000', 'consum', 0.0225, 'lps'),
	(510128, 127, '2014-02-01 00:27:17.000000', 'consum', 0.0221, 'lps'),
	(510129, 127, '2014-02-01 00:27:18.000000', 'consum', 0.0219, 'lps'),
	(510130, 127, '2014-02-01 00:27:19.000000', 'consum', 0.0225, 'lps'),
	(510131, 127, '2014-02-01 00:27:20.000000', 'consum', 0.0212, 'lps'),
	(510132, 127, '2014-02-01 00:27:21.000000', 'consum', 0.0221, 'lps'),
	(510133, 127, '2014-02-01 00:27:22.000000', 'consum', 0.0211, 'lps'),
	(510134, 127, '2014-02-01 00:27:23.000000', 'consum', 0.0214, 'lps'),
	(510135, 127, '2014-02-01 00:27:24.000000', 'consum', 0.0211, 'lps'),
	(510136, 127, '2014-02-01 00:27:25.000000', 'consum', 0.0220, 'lps'),
	(510137, 127, '2014-02-01 00:27:26.000000', 'consum', 0.0211, 'lps'),
	(510138, 127, '2014-02-01 00:27:27.000000', 'consum', 0.0216, 'lps'),
	(510139, 127, '2014-02-01 00:27:28.000000', 'consum', 0.0222, 'lps'),
	(510140, 127, '2014-02-01 00:27:29.000000', 'consum', 0.0220, 'lps'),
	(510141, 127, '2014-02-01 00:27:30.000000', 'consum', 0.0210, 'lps'),
	(510142, 127, '2014-02-01 00:27:31.000000', 'consum', 0.0212, 'lps'),
	(510143, 127, '2014-02-01 00:27:32.000000', 'consum', 0.0219, 'lps'),
	(510144, 127, '2014-02-01 00:27:33.000000', 'consum', 0.0216, 'lps'),
	(510145, 127, '2014-02-01 00:27:34.000000', 'consum', 0.0217, 'lps'),
	(510146, 127, '2014-02-01 00:27:35.000000', 'consum', 0.0210, 'lps'),
	(510147, 127, '2014-02-01 00:27:36.000000', 'consum', 0.0222, 'lps'),
	(510148, 127, '2014-02-01 00:27:37.000000', 'consum', 0.0224, 'lps'),
	(510149, 127, '2014-02-01 00:27:38.000000', 'consum', 0.0210, 'lps'),
	(510150, 127, '2014-02-01 00:27:39.000000', 'consum', 0.0217, 'lps'),
	(510151, 127, '2014-02-01 00:27:40.000000', 'consum', 0.0215, 'lps'),
	(510152, 127, '2014-02-01 00:27:41.000000', 'consum', 0.0213, 'lps'),
	(510153, 127, '2014-02-01 00:27:42.000000', 'consum', 0.0211, 'lps'),
	(510154, 127, '2014-02-01 00:27:43.000000', 'consum', 0.0221, 'lps'),
	(510155, 127, '2014-02-01 00:27:44.000000', 'consum', 0.0217, 'lps'),
	(510156, 127, '2014-02-01 00:27:45.000000', 'consum', 0.0213, 'lps'),
	(510157, 127, '2014-02-01 00:27:46.000000', 'consum', 0.0221, 'lps'),
	(510158, 127, '2014-02-01 00:27:47.000000', 'consum', 0.0224, 'lps'),
	(510159, 127, '2014-02-01 00:27:48.000000', 'consum', 0.0215, 'lps'),
	(510160, 127, '2014-02-01 00:27:49.000000', 'consum', 0.0211, 'lps'),
	(510161, 127, '2014-02-01 00:27:50.000000', 'consum', 0.0214, 'lps'),
	(510162, 127, '2014-02-01 00:27:51.000000', 'consum', 0.0214, 'lps'),
	(510163, 127, '2014-02-01 00:27:52.000000', 'consum', 0.0219, 'lps'),
	(510164, 127, '2014-02-01 00:27:53.000000', 'consum', 0.0212, 'lps'),
	(510165, 127, '2014-02-01 00:27:54.000000', 'consum', 0.0210, 'lps'),
	(510166, 127, '2014-02-01 00:27:55.000000', 'consum', 0.0220, 'lps'),
	(510167, 127, '2014-02-01 00:27:56.000000', 'consum', 0.0210, 'lps'),
	(510168, 127, '2014-02-01 00:27:57.000000', 'consum', 0.0214, 'lps'),
	(510169, 127, '2014-02-01 00:27:58.000000', 'consum', 0.0216, 'lps'),
	(510170, 127, '2014-02-01 00:27:59.000000', 'consum', 0.0212, 'lps'),
	(510171, 127, '2014-02-01 00:28:00.000000', 'consum', 0.0218, 'lps'),
	(510172, 127, '2014-02-01 00:28:01.000000', 'consum', 0.0213, 'lps'),
	(510173, 127, '2014-02-01 00:28:02.000000', 'consum', 0.0217, 'lps'),
	(510174, 127, '2014-02-01 00:28:03.000000', 'consum', 0.0219, 'lps'),
	(510175, 127, '2014-02-01 00:28:04.000000', 'consum', 0.0218, 'lps'),
	(510176, 127, '2014-02-01 00:28:05.000000', 'consum', 0.0210, 'lps'),
	(510177, 127, '2014-02-01 00:28:06.000000', 'consum', 0.0216, 'lps'),
	(510178, 127, '2014-02-01 00:28:07.000000', 'consum', 0.0224, 'lps'),
	(510179, 127, '2014-02-01 00:28:08.000000', 'consum', 0.0214, 'lps'),
	(510180, 127, '2014-02-01 00:28:09.000000', 'consum', 0.0221, 'lps'),
	(510181, 127, '2014-02-01 00:28:10.000000', 'consum', 0.0222, 'lps'),
	(510182, 127, '2014-02-01 00:28:11.000000', 'consum', 0.0220, 'lps'),
	(510183, 127, '2014-02-01 00:28:12.000000', 'consum', 0.0224, 'lps'),
	(510184, 127, '2014-02-01 00:28:13.000000', 'consum', 0.0221, 'lps'),
	(510185, 127, '2014-02-01 00:28:14.000000', 'consum', 0.0221, 'lps'),
	(510186, 127, '2014-02-01 00:28:15.000000', 'consum', 0.0215, 'lps'),
	(510187, 127, '2014-02-01 00:28:16.000000', 'consum', 0.0222, 'lps'),
	(510188, 127, '2014-02-01 00:28:17.000000', 'consum', 0.0223, 'lps'),
	(510189, 127, '2014-02-01 00:28:18.000000', 'consum', 0.0222, 'lps'),
	(510190, 127, '2014-02-01 00:28:19.000000', 'consum', 0.0216, 'lps'),
	(510191, 127, '2014-02-01 00:28:20.000000', 'consum', 0.0219, 'lps'),
	(510192, 127, '2014-02-01 00:28:21.000000', 'consum', 0.0222, 'lps'),
	(510193, 127, '2014-02-01 00:28:22.000000', 'consum', 0.0213, 'lps'),
	(510194, 127, '2014-02-01 00:28:23.000000', 'consum', 0.0221, 'lps'),
	(510195, 127, '2014-02-01 00:28:24.000000', 'consum', 0.0225, 'lps'),
	(510196, 127, '2014-02-01 00:28:25.000000', 'consum', 0.0219, 'lps'),
	(510197, 127, '2014-02-01 00:28:26.000000', 'consum', 0.0213, 'lps'),
	(510198, 127, '2014-02-01 00:28:27.000000', 'consum', 0.0214, 'lps'),
	(510199, 127, '2014-02-01 00:28:28.000000', 'consum', 0.0223, 'lps'),
	(510200, 127, '2014-02-01 00:28:29.000000', 'consum', 0.0212, 'lps'),
	(510201, 127, '2014-02-01 00:28:30.000000', 'consum', 0.0216, 'lps'),
	(510202, 127, '2014-02-01 00:28:31.000000', 'consum', 0.0219, 'lps'),
	(510203, 127, '2014-02-01 00:28:32.000000', 'consum', 0.0219, 'lps'),
	(510204, 127, '2014-02-01 00:28:33.000000', 'consum', 0.0213, 'lps'),
	(510205, 127, '2014-02-01 00:28:34.000000', 'consum', 0.0214, 'lps'),
	(510206, 127, '2014-02-01 00:28:35.000000', 'consum', 0.0222, 'lps'),
	(510207, 127, '2014-02-01 00:28:36.000000', 'consum', 0.0225, 'lps'),
	(510208, 127, '2014-02-01 00:28:37.000000', 'consum', 0.0220, 'lps'),
	(510209, 127, '2014-02-01 00:28:38.000000', 'consum', 0.0216, 'lps'),
	(510210, 127, '2014-02-01 00:28:39.000000', 'consum', 0.0210, 'lps'),
	(510211, 127, '2014-02-01 00:28:40.000000', 'consum', 0.0225, 'lps'),
	(510212, 127, '2014-02-01 00:28:41.000000', 'consum', 0.0221, 'lps'),
	(510213, 127, '2014-02-01 00:28:42.000000', 'consum', 0.0220, 'lps'),
	(510214, 127, '2014-02-01 00:28:43.000000', 'consum', 0.0211, 'lps'),
	(510215, 127, '2014-02-01 00:28:44.000000', 'consum', 0.0216, 'lps'),
	(510216, 127, '2014-02-01 00:28:45.000000', 'consum', 0.0223, 'lps'),
	(510217, 127, '2014-02-01 00:28:46.000000', 'consum', 0.0225, 'lps'),
	(510218, 127, '2014-02-01 00:28:47.000000', 'consum', 0.0216, 'lps'),
	(510219, 127, '2014-02-01 00:28:48.000000', 'consum', 0.0211, 'lps'),
	(510220, 127, '2014-02-01 00:28:49.000000', 'consum', 0.0212, 'lps'),
	(510221, 127, '2014-02-01 00:28:50.000000', 'consum', 0.0217, 'lps'),
	(510222, 127, '2014-02-01 00:28:51.000000', 'consum', 0.0210, 'lps'),
	(510223, 127, '2014-02-01 00:28:52.000000', 'consum', 0.0219, 'lps'),
	(510224, 127, '2014-02-01 00:28:53.000000', 'consum', 0.0224, 'lps'),
	(510225, 127, '2014-02-01 00:28:54.000000', 'consum', 0.0223, 'lps'),
	(510226, 127, '2014-02-01 00:28:55.000000', 'consum', 0.0216, 'lps'),
	(510227, 127, '2014-02-01 00:28:56.000000', 'consum', 0.0216, 'lps'),
	(510228, 127, '2014-02-01 00:28:57.000000', 'consum', 0.0224, 'lps'),
	(510229, 127, '2014-02-01 00:28:58.000000', 'consum', 0.0215, 'lps'),
	(510230, 127, '2014-02-01 00:28:59.000000', 'consum', 0.0210, 'lps'),
	(510231, 127, '2014-02-01 00:29:00.000000', 'consum', 0.0212, 'lps'),
	(510232, 127, '2014-02-01 00:29:01.000000', 'consum', 0.0219, 'lps'),
	(510233, 127, '2014-02-01 00:29:02.000000', 'consum', 0.0218, 'lps'),
	(510234, 127, '2014-02-01 00:29:03.000000', 'consum', 0.0223, 'lps'),
	(510235, 127, '2014-02-01 00:29:04.000000', 'consum', 0.0218, 'lps'),
	(510236, 127, '2014-02-01 00:29:05.000000', 'consum', 0.0213, 'lps'),
	(510237, 127, '2014-02-01 00:29:06.000000', 'consum', 0.0216, 'lps'),
	(510238, 127, '2014-02-01 00:29:07.000000', 'consum', 0.0218, 'lps'),
	(510239, 127, '2014-02-01 00:29:08.000000', 'consum', 0.0216, 'lps'),
	(510240, 127, '2014-02-01 00:29:09.000000', 'consum', 0.0216, 'lps'),
	(510241, 127, '2014-02-01 00:29:10.000000', 'consum', 0.0224, 'lps'),
	(510242, 127, '2014-02-01 00:29:11.000000', 'consum', 0.0211, 'lps'),
	(510243, 127, '2014-02-01 00:29:12.000000', 'consum', 0.0225, 'lps'),
	(510244, 127, '2014-02-01 00:29:13.000000', 'consum', 0.0218, 'lps'),
	(510245, 127, '2014-02-01 00:29:14.000000', 'consum', 0.0223, 'lps'),
	(510246, 127, '2014-02-01 00:29:15.000000', 'consum', 0.0218, 'lps'),
	(510247, 127, '2014-02-01 00:29:16.000000', 'consum', 0.0212, 'lps'),
	(510248, 127, '2014-02-01 00:29:17.000000', 'consum', 0.0212, 'lps'),
	(510249, 127, '2014-02-01 00:29:18.000000', 'consum', 0.0216, 'lps'),
	(510250, 127, '2014-02-01 00:29:19.000000', 'consum', 0.0217, 'lps'),
	(510251, 127, '2014-02-01 00:29:20.000000', 'consum', 0.0212, 'lps'),
	(510252, 127, '2014-02-01 00:29:21.000000', 'consum', 0.0213, 'lps'),
	(510253, 127, '2014-02-01 00:29:22.000000', 'consum', 0.0223, 'lps'),
	(510254, 127, '2014-02-01 00:29:23.000000', 'consum', 0.0218, 'lps'),
	(510255, 127, '2014-02-01 00:29:24.000000', 'consum', 0.0212, 'lps'),
	(510256, 127, '2014-02-01 00:29:25.000000', 'consum', 0.0212, 'lps'),
	(510257, 127, '2014-02-01 00:29:26.000000', 'consum', 0.0214, 'lps'),
	(510258, 127, '2014-02-01 00:29:27.000000', 'consum', 0.0211, 'lps'),
	(510259, 127, '2014-02-01 00:29:28.000000', 'consum', 0.0216, 'lps'),
	(510260, 127, '2014-02-01 00:29:29.000000', 'consum', 0.0224, 'lps'),
	(510261, 127, '2014-02-01 00:29:30.000000', 'consum', 0.0213, 'lps'),
	(510262, 127, '2014-02-01 00:29:31.000000', 'consum', 0.0215, 'lps'),
	(510263, 127, '2014-02-01 00:29:32.000000', 'consum', 0.0210, 'lps'),
	(510264, 127, '2014-02-01 00:29:33.000000', 'consum', 0.0214, 'lps'),
	(510265, 127, '2014-02-01 00:29:34.000000', 'consum', 0.0211, 'lps'),
	(510266, 127, '2014-02-01 00:29:35.000000', 'consum', 0.0222, 'lps'),
	(510267, 127, '2014-02-01 00:29:36.000000', 'consum', 0.0220, 'lps'),
	(510268, 127, '2014-02-01 00:29:37.000000', 'consum', 0.0210, 'lps'),
	(510269, 127, '2014-02-01 00:29:38.000000', 'consum', 0.0210, 'lps'),
	(510270, 127, '2014-02-01 00:29:39.000000', 'consum', 0.0211, 'lps'),
	(510271, 127, '2014-02-01 00:29:40.000000', 'consum', 0.0214, 'lps'),
	(510272, 127, '2014-02-01 00:29:41.000000', 'consum', 0.0213, 'lps'),
	(510273, 127, '2014-02-01 00:29:42.000000', 'consum', 0.0211, 'lps'),
	(510274, 127, '2014-02-01 00:29:43.000000', 'consum', 0.0210, 'lps'),
	(510275, 127, '2014-02-01 00:29:44.000000', 'consum', 0.0222, 'lps'),
	(510276, 127, '2014-02-01 00:29:45.000000', 'consum', 0.0224, 'lps'),
	(510277, 127, '2014-02-01 00:29:46.000000', 'consum', 0.0211, 'lps'),
	(510278, 127, '2014-02-01 00:29:47.000000', 'consum', 0.0222, 'lps'),
	(510279, 127, '2014-02-01 00:29:48.000000', 'consum', 0.0220, 'lps'),
	(510280, 127, '2014-02-01 00:29:49.000000', 'consum', 0.0223, 'lps'),
	(510281, 127, '2014-02-01 00:29:50.000000', 'consum', 0.0214, 'lps'),
	(510282, 127, '2014-02-01 00:29:51.000000', 'consum', 0.0223, 'lps'),
	(510283, 127, '2014-02-01 00:29:52.000000', 'consum', 0.0218, 'lps'),
	(510284, 127, '2014-02-01 00:29:53.000000', 'consum', 0.0211, 'lps'),
	(510285, 127, '2014-02-01 00:29:54.000000', 'consum', 0.0221, 'lps'),
	(510286, 127, '2014-02-01 00:29:55.000000', 'consum', 0.0217, 'lps'),
	(510287, 127, '2014-02-01 00:29:56.000000', 'consum', 0.0210, 'lps'),
	(510288, 127, '2014-02-01 00:29:57.000000', 'consum', 0.0224, 'lps'),
	(510289, 127, '2014-02-01 00:29:58.000000', 'consum', 0.0217, 'lps'),
	(510290, 127, '2014-02-01 00:29:59.000000', 'consum', 0.0217, 'lps'),
	(510291, 127, '2014-02-01 00:30:00.000000', 'consum', 0.0212, 'lps'),
	(510292, 127, '2014-02-01 00:30:01.000000', 'consum', 0.0212, 'lps'),
	(510293, 127, '2014-02-01 00:30:02.000000', 'consum', 0.0215, 'lps'),
	(510294, 127, '2014-02-01 00:30:03.000000', 'consum', 0.0215, 'lps'),
	(510295, 127, '2014-02-01 00:30:04.000000', 'consum', 0.0220, 'lps'),
	(510296, 127, '2014-02-01 00:30:05.000000', 'consum', 0.0213, 'lps'),
	(510297, 127, '2014-02-01 00:30:06.000000', 'consum', 0.0210, 'lps'),
	(510298, 127, '2014-02-01 00:30:07.000000', 'consum', 0.0218, 'lps'),
	(510299, 127, '2014-02-01 00:30:08.000000', 'consum', 0.0218, 'lps'),
	(510300, 127, '2014-02-01 00:30:09.000000', 'consum', 0.0225, 'lps'),
	(510301, 127, '2014-02-01 00:30:10.000000', 'consum', 0.0217, 'lps'),
	(510302, 127, '2014-02-01 00:30:11.000000', 'consum', 0.0214, 'lps'),
	(510303, 127, '2014-02-01 00:30:12.000000', 'consum', 0.0210, 'lps'),
	(510304, 127, '2014-02-01 00:30:13.000000', 'consum', 0.0214, 'lps'),
	(510305, 127, '2014-02-01 00:30:14.000000', 'consum', 0.0213, 'lps'),
	(510306, 127, '2014-02-01 00:30:15.000000', 'consum', 0.0216, 'lps'),
	(510307, 127, '2014-02-01 00:30:16.000000', 'consum', 0.0216, 'lps'),
	(510308, 127, '2014-02-01 00:30:17.000000', 'consum', 0.0223, 'lps'),
	(510309, 127, '2014-02-01 00:30:18.000000', 'consum', 0.0225, 'lps'),
	(510310, 127, '2014-02-01 00:30:19.000000', 'consum', 0.0212, 'lps'),
	(510311, 127, '2014-02-01 00:30:20.000000', 'consum', 0.0210, 'lps'),
	(510312, 127, '2014-02-01 00:30:21.000000', 'consum', 0.0222, 'lps'),
	(510313, 127, '2014-02-01 00:30:22.000000', 'consum', 0.0219, 'lps'),
	(510314, 127, '2014-02-01 00:30:23.000000', 'consum', 0.0223, 'lps'),
	(510315, 127, '2014-02-01 00:30:24.000000', 'consum', 0.0214, 'lps'),
	(510316, 127, '2014-02-01 00:30:25.000000', 'consum', 0.0223, 'lps'),
	(510317, 127, '2014-02-01 00:30:26.000000', 'consum', 0.0216, 'lps'),
	(510318, 127, '2014-02-01 00:30:27.000000', 'consum', 0.0217, 'lps'),
	(510319, 127, '2014-02-01 00:30:28.000000', 'consum', 0.0211, 'lps'),
	(510320, 127, '2014-02-01 00:30:29.000000', 'consum', 0.0213, 'lps'),
	(510321, 127, '2014-02-01 00:30:30.000000', 'consum', 0.0219, 'lps'),
	(510322, 127, '2014-02-01 00:30:31.000000', 'consum', 0.0217, 'lps'),
	(510323, 127, '2014-02-01 00:30:32.000000', 'consum', 0.0216, 'lps'),
	(510324, 127, '2014-02-01 00:30:33.000000', 'consum', 0.0220, 'lps'),
	(510325, 127, '2014-02-01 00:30:34.000000', 'consum', 0.0212, 'lps'),
	(510326, 127, '2014-02-01 00:30:35.000000', 'consum', 0.0221, 'lps'),
	(510327, 127, '2014-02-01 00:30:36.000000', 'consum', 0.0213, 'lps'),
	(510328, 127, '2014-02-01 00:30:37.000000', 'consum', 0.0222, 'lps'),
	(510329, 127, '2014-02-01 00:30:38.000000', 'consum', 0.0214, 'lps'),
	(510330, 127, '2014-02-01 00:30:39.000000', 'consum', 0.0225, 'lps'),
	(510331, 127, '2014-02-01 00:30:40.000000', 'consum', 0.0213, 'lps'),
	(510332, 127, '2014-02-01 00:30:41.000000', 'consum', 0.0211, 'lps'),
	(510333, 127, '2014-02-01 00:30:42.000000', 'consum', 0.0224, 'lps'),
	(510334, 127, '2014-02-01 00:30:43.000000', 'consum', 0.0213, 'lps'),
	(510335, 127, '2014-02-01 00:30:44.000000', 'consum', 0.0214, 'lps'),
	(510336, 127, '2014-02-01 00:30:45.000000', 'consum', 0.0223, 'lps'),
	(510337, 127, '2014-02-01 00:30:46.000000', 'consum', 0.0216, 'lps'),
	(510338, 127, '2014-02-01 00:30:47.000000', 'consum', 0.0216, 'lps'),
	(510339, 127, '2014-02-01 00:30:48.000000', 'consum', 0.0225, 'lps'),
	(510340, 127, '2014-02-01 00:30:49.000000', 'consum', 0.0219, 'lps'),
	(510341, 127, '2014-02-01 00:30:50.000000', 'consum', 0.0224, 'lps'),
	(510342, 127, '2014-02-01 00:30:51.000000', 'consum', 0.0223, 'lps'),
	(510343, 127, '2014-02-01 00:30:52.000000', 'consum', 0.0219, 'lps'),
	(510344, 127, '2014-02-01 00:30:53.000000', 'consum', 0.0215, 'lps'),
	(510345, 127, '2014-02-01 00:30:54.000000', 'consum', 0.0211, 'lps'),
	(510346, 127, '2014-02-01 00:30:55.000000', 'consum', 0.0214, 'lps'),
	(510347, 127, '2014-02-01 00:30:56.000000', 'consum', 0.0214, 'lps'),
	(510348, 127, '2014-02-01 00:30:57.000000', 'consum', 0.0217, 'lps'),
	(510349, 127, '2014-02-01 00:30:58.000000', 'consum', 0.0217, 'lps'),
	(510350, 127, '2014-02-01 00:30:59.000000', 'consum', 0.0225, 'lps'),
	(510351, 127, '2014-02-01 00:31:00.000000', 'consum', 0.0217, 'lps'),
	(510352, 127, '2014-02-01 00:31:01.000000', 'consum', 0.0214, 'lps'),
	(510353, 127, '2014-02-01 00:31:02.000000', 'consum', 0.0211, 'lps'),
	(510354, 127, '2014-02-01 00:31:03.000000', 'consum', 0.0219, 'lps'),
	(510355, 127, '2014-02-01 00:31:04.000000', 'consum', 0.0222, 'lps'),
	(510356, 127, '2014-02-01 00:31:05.000000', 'consum', 0.0211, 'lps'),
	(510357, 127, '2014-02-01 00:31:06.000000', 'consum', 0.0213, 'lps'),
	(510358, 127, '2014-02-01 00:31:07.000000', 'consum', 0.0220, 'lps'),
	(510359, 127, '2014-02-01 00:31:08.000000', 'consum', 0.0220, 'lps'),
	(510360, 127, '2014-02-01 00:31:09.000000', 'consum', 0.0217, 'lps'),
	(510361, 127, '2014-02-01 00:31:10.000000', 'consum', 0.0212, 'lps'),
	(510362, 127, '2014-02-01 00:31:11.000000', 'consum', 0.0217, 'lps'),
	(510363, 127, '2014-02-01 00:31:12.000000', 'consum', 0.0221, 'lps'),
	(510364, 127, '2014-02-01 00:31:13.000000', 'consum', 0.0216, 'lps'),
	(510365, 127, '2014-02-01 00:31:14.000000', 'consum', 0.0222, 'lps'),
	(510366, 127, '2014-02-01 00:31:15.000000', 'consum', 0.0223, 'lps'),
	(510367, 127, '2014-02-01 00:31:16.000000', 'consum', 0.0220, 'lps'),
	(510368, 127, '2014-02-01 00:31:17.000000', 'consum', 0.0224, 'lps'),
	(510369, 127, '2014-02-01 00:31:18.000000', 'consum', 0.0217, 'lps'),
	(510370, 127, '2014-02-01 00:31:19.000000', 'consum', 0.0220, 'lps'),
	(510371, 127, '2014-02-01 00:31:20.000000', 'consum', 0.0222, 'lps'),
	(510372, 127, '2014-02-01 00:31:21.000000', 'consum', 0.0210, 'lps'),
	(510373, 127, '2014-02-01 00:31:22.000000', 'consum', 0.0222, 'lps'),
	(510374, 127, '2014-02-01 00:31:23.000000', 'consum', 0.0223, 'lps'),
	(510375, 127, '2014-02-01 00:31:24.000000', 'consum', 0.0225, 'lps'),
	(510376, 127, '2014-02-01 00:31:25.000000', 'consum', 0.0214, 'lps'),
	(510377, 127, '2014-02-01 00:31:26.000000', 'consum', 0.0218, 'lps'),
	(510378, 127, '2014-02-01 00:31:27.000000', 'consum', 0.0222, 'lps'),
	(510379, 127, '2014-02-01 00:31:28.000000', 'consum', 0.0216, 'lps'),
	(510380, 127, '2014-02-01 00:31:29.000000', 'consum', 0.0220, 'lps'),
	(510381, 127, '2014-02-01 00:31:30.000000', 'consum', 0.0210, 'lps'),
	(510382, 127, '2014-02-01 00:31:31.000000', 'consum', 0.0214, 'lps'),
	(510383, 127, '2014-02-01 00:31:32.000000', 'consum', 0.0213, 'lps'),
	(510384, 127, '2014-02-01 00:31:33.000000', 'consum', 0.0213, 'lps'),
	(510385, 127, '2014-02-01 00:31:34.000000', 'consum', 0.0219, 'lps'),
	(510386, 127, '2014-02-01 00:31:35.000000', 'consum', 0.0212, 'lps'),
	(510387, 127, '2014-02-01 00:31:36.000000', 'consum', 0.0225, 'lps'),
	(510388, 127, '2014-02-01 00:31:37.000000', 'consum', 0.0218, 'lps'),
	(510389, 127, '2014-02-01 00:31:38.000000', 'consum', 0.0220, 'lps'),
	(510390, 127, '2014-02-01 00:31:39.000000', 'consum', 0.0221, 'lps'),
	(510391, 127, '2014-02-01 00:31:40.000000', 'consum', 0.0220, 'lps'),
	(510392, 127, '2014-02-01 00:31:41.000000', 'consum', 0.0213, 'lps'),
	(510393, 127, '2014-02-01 00:31:42.000000', 'consum', 0.0225, 'lps'),
	(510394, 127, '2014-02-01 00:31:43.000000', 'consum', 0.0212, 'lps'),
	(510395, 127, '2014-02-01 00:31:44.000000', 'consum', 0.0223, 'lps'),
	(510396, 127, '2014-02-01 00:31:45.000000', 'consum', 0.0224, 'lps'),
	(510397, 127, '2014-02-01 00:31:46.000000', 'consum', 0.0224, 'lps'),
	(510398, 127, '2014-02-01 00:31:47.000000', 'consum', 0.0223, 'lps'),
	(510399, 127, '2014-02-01 00:31:48.000000', 'consum', 0.0217, 'lps'),
	(510400, 127, '2014-02-01 00:31:49.000000', 'consum', 0.0223, 'lps'),
	(510401, 127, '2014-02-01 00:31:50.000000', 'consum', 0.0221, 'lps'),
	(510402, 127, '2014-02-01 00:31:51.000000', 'consum', 0.0210, 'lps'),
	(510403, 127, '2014-02-01 00:31:52.000000', 'consum', 0.0211, 'lps'),
	(510404, 127, '2014-02-01 00:31:53.000000', 'consum', 0.0216, 'lps'),
	(510405, 127, '2014-02-01 00:31:54.000000', 'consum', 0.0222, 'lps'),
	(510406, 127, '2014-02-01 00:31:55.000000', 'consum', 0.0219, 'lps'),
	(510407, 127, '2014-02-01 00:31:56.000000', 'consum', 0.0221, 'lps'),
	(510408, 127, '2014-02-01 00:31:57.000000', 'consum', 0.0221, 'lps'),
	(510409, 127, '2014-02-01 00:31:58.000000', 'consum', 0.0216, 'lps'),
	(510410, 127, '2014-02-01 00:31:59.000000', 'consum', 0.0225, 'lps'),
	(510411, 127, '2014-02-01 00:32:00.000000', 'consum', 0.0217, 'lps'),
	(510412, 127, '2014-02-01 00:32:01.000000', 'consum', 0.0217, 'lps'),
	(510413, 127, '2014-02-01 00:32:02.000000', 'consum', 0.0211, 'lps'),
	(510414, 127, '2014-02-01 00:32:03.000000', 'consum', 0.0210, 'lps'),
	(510415, 127, '2014-02-01 00:32:04.000000', 'consum', 0.0222, 'lps'),
	(510416, 127, '2014-02-01 00:32:05.000000', 'consum', 0.0223, 'lps'),
	(510417, 127, '2014-02-01 00:32:06.000000', 'consum', 0.0224, 'lps'),
	(510418, 127, '2014-02-01 00:32:07.000000', 'consum', 0.0225, 'lps'),
	(510419, 127, '2014-02-01 00:32:08.000000', 'consum', 0.0210, 'lps'),
	(510420, 127, '2014-02-01 00:32:09.000000', 'consum', 0.0214, 'lps'),
	(510421, 127, '2014-02-01 00:32:10.000000', 'consum', 0.0215, 'lps'),
	(510422, 127, '2014-02-01 00:32:11.000000', 'consum', 0.0224, 'lps'),
	(510423, 127, '2014-02-01 00:32:12.000000', 'consum', 0.0218, 'lps'),
	(510424, 127, '2014-02-01 00:32:13.000000', 'consum', 0.0210, 'lps'),
	(510425, 127, '2014-02-01 00:32:14.000000', 'consum', 0.0216, 'lps'),
	(510426, 127, '2014-02-01 00:32:15.000000', 'consum', 0.0210, 'lps'),
	(510427, 127, '2014-02-01 00:32:16.000000', 'consum', 0.0223, 'lps'),
	(510428, 127, '2014-02-01 00:32:17.000000', 'consum', 0.0213, 'lps'),
	(510429, 127, '2014-02-01 00:32:18.000000', 'consum', 0.0220, 'lps'),
	(510430, 127, '2014-02-01 00:32:19.000000', 'consum', 0.0218, 'lps'),
	(510431, 127, '2014-02-01 00:32:20.000000', 'consum', 0.0219, 'lps'),
	(510432, 127, '2014-02-01 00:32:21.000000', 'consum', 0.0219, 'lps'),
	(510433, 127, '2014-02-01 00:32:22.000000', 'consum', 0.0225, 'lps'),
	(510434, 127, '2014-02-01 00:32:23.000000', 'consum', 0.0213, 'lps'),
	(510435, 127, '2014-02-01 00:32:24.000000', 'consum', 0.0212, 'lps'),
	(510436, 127, '2014-02-01 00:32:25.000000', 'consum', 0.0210, 'lps'),
	(510437, 127, '2014-02-01 00:32:26.000000', 'consum', 0.0223, 'lps'),
	(510438, 127, '2014-02-01 00:32:27.000000', 'consum', 0.0210, 'lps'),
	(510439, 127, '2014-02-01 00:32:28.000000', 'consum', 0.0219, 'lps'),
	(510440, 127, '2014-02-01 00:32:29.000000', 'consum', 0.0225, 'lps'),
	(510441, 127, '2014-02-01 00:32:30.000000', 'consum', 0.0224, 'lps'),
	(510442, 127, '2014-02-01 00:32:31.000000', 'consum', 0.0222, 'lps'),
	(510443, 127, '2014-02-01 00:32:32.000000', 'consum', 0.0211, 'lps'),
	(510444, 127, '2014-02-01 00:32:33.000000', 'consum', 0.0212, 'lps'),
	(510445, 127, '2014-02-01 00:32:34.000000', 'consum', 0.0216, 'lps'),
	(510446, 127, '2014-02-01 00:32:35.000000', 'consum', 0.0218, 'lps'),
	(510447, 127, '2014-02-01 00:32:36.000000', 'consum', 0.0217, 'lps'),
	(510448, 127, '2014-02-01 00:32:37.000000', 'consum', 0.0220, 'lps'),
	(510449, 127, '2014-02-01 00:32:38.000000', 'consum', 0.0224, 'lps'),
	(510450, 127, '2014-02-01 00:32:39.000000', 'consum', 0.0218, 'lps'),
	(510451, 127, '2014-02-01 00:32:40.000000', 'consum', 0.0225, 'lps'),
	(510452, 127, '2014-02-01 00:32:41.000000', 'consum', 0.0212, 'lps'),
	(510453, 127, '2014-02-01 00:32:42.000000', 'consum', 0.0210, 'lps'),
	(510454, 127, '2014-02-01 00:32:43.000000', 'consum', 0.0221, 'lps'),
	(510455, 127, '2014-02-01 00:32:44.000000', 'consum', 0.0215, 'lps'),
	(510456, 127, '2014-02-01 00:32:45.000000', 'consum', 0.0221, 'lps'),
	(510457, 127, '2014-02-01 00:32:46.000000', 'consum', 0.0217, 'lps'),
	(510458, 127, '2014-02-01 00:32:47.000000', 'consum', 0.0211, 'lps'),
	(510459, 127, '2014-02-01 00:32:48.000000', 'consum', 0.0211, 'lps'),
	(510460, 127, '2014-02-01 00:32:49.000000', 'consum', 0.0213, 'lps'),
	(510461, 127, '2014-02-01 00:32:50.000000', 'consum', 0.0221, 'lps'),
	(510462, 127, '2014-02-01 00:32:51.000000', 'consum', 0.0225, 'lps'),
	(510463, 127, '2014-02-01 00:32:52.000000', 'consum', 0.0222, 'lps'),
	(510464, 127, '2014-02-01 00:32:53.000000', 'consum', 0.0224, 'lps'),
	(510465, 127, '2014-02-01 00:32:54.000000', 'consum', 0.0215, 'lps'),
	(510466, 127, '2014-02-01 00:32:55.000000', 'consum', 0.0224, 'lps'),
	(510467, 127, '2014-02-01 00:32:56.000000', 'consum', 0.0219, 'lps'),
	(510468, 127, '2014-02-01 00:32:57.000000', 'consum', 0.0214, 'lps'),
	(510469, 127, '2014-02-01 00:32:58.000000', 'consum', 0.0217, 'lps'),
	(510470, 127, '2014-02-01 00:32:59.000000', 'consum', 0.0217, 'lps'),
	(510471, 127, '2014-02-01 00:33:00.000000', 'consum', 0.0212, 'lps'),
	(510472, 127, '2014-02-01 00:33:01.000000', 'consum', 0.0212, 'lps'),
	(510473, 127, '2014-02-01 00:33:02.000000', 'consum', 0.0214, 'lps'),
	(510474, 127, '2014-02-01 00:33:03.000000', 'consum', 0.0211, 'lps'),
	(510475, 127, '2014-02-01 00:33:04.000000', 'consum', 0.0220, 'lps'),
	(510476, 127, '2014-02-01 00:33:05.000000', 'consum', 0.0223, 'lps'),
	(510477, 127, '2014-02-01 00:33:06.000000', 'consum', 0.0213, 'lps'),
	(510478, 127, '2014-02-01 00:33:07.000000', 'consum', 0.0220, 'lps'),
	(510479, 127, '2014-02-01 00:33:08.000000', 'consum', 0.0219, 'lps'),
	(510480, 127, '2014-02-01 00:33:09.000000', 'consum', 0.0225, 'lps'),
	(510481, 127, '2014-02-01 00:33:10.000000', 'consum', 0.0210, 'lps'),
	(510482, 127, '2014-02-01 00:33:11.000000', 'consum', 0.0213, 'lps'),
	(510483, 127, '2014-02-01 00:33:12.000000', 'consum', 0.0211, 'lps'),
	(510484, 127, '2014-02-01 00:33:13.000000', 'consum', 0.0223, 'lps'),
	(510485, 127, '2014-02-01 00:33:14.000000', 'consum', 0.0223, 'lps'),
	(510486, 127, '2014-02-01 00:33:15.000000', 'consum', 0.0221, 'lps'),
	(510487, 127, '2014-02-01 00:33:16.000000', 'consum', 0.0225, 'lps'),
	(510488, 127, '2014-02-01 00:33:17.000000', 'consum', 0.0220, 'lps'),
	(510489, 127, '2014-02-01 00:33:18.000000', 'consum', 0.0218, 'lps'),
	(510490, 127, '2014-02-01 00:33:19.000000', 'consum', 0.0219, 'lps'),
	(510491, 127, '2014-02-01 00:33:20.000000', 'consum', 0.0217, 'lps'),
	(510492, 127, '2014-02-01 00:33:21.000000', 'consum', 0.0218, 'lps'),
	(510493, 127, '2014-02-01 00:33:22.000000', 'consum', 0.0211, 'lps'),
	(510494, 127, '2014-02-01 00:33:23.000000', 'consum', 0.0211, 'lps'),
	(510495, 127, '2014-02-01 00:33:24.000000', 'consum', 0.0211, 'lps'),
	(510496, 127, '2014-02-01 00:33:25.000000', 'consum', 0.0214, 'lps'),
	(510497, 127, '2014-02-01 00:33:26.000000', 'consum', 0.0225, 'lps'),
	(510498, 127, '2014-02-01 00:33:27.000000', 'consum', 0.0212, 'lps'),
	(510499, 127, '2014-02-01 00:33:28.000000', 'consum', 0.0224, 'lps'),
	(510500, 127, '2014-02-01 00:33:29.000000', 'consum', 0.0211, 'lps'),
	(510501, 127, '2014-02-01 00:33:30.000000', 'consum', 0.0221, 'lps'),
	(510502, 127, '2014-02-01 00:33:31.000000', 'consum', 0.0214, 'lps'),
	(510503, 127, '2014-02-01 00:33:32.000000', 'consum', 0.0212, 'lps'),
	(510504, 127, '2014-02-01 00:33:33.000000', 'consum', 0.0210, 'lps'),
	(510505, 127, '2014-02-01 00:33:34.000000', 'consum', 0.0222, 'lps'),
	(510506, 127, '2014-02-01 00:33:35.000000', 'consum', 0.0220, 'lps'),
	(510507, 127, '2014-02-01 00:33:36.000000', 'consum', 0.0211, 'lps'),
	(510508, 127, '2014-02-01 00:33:37.000000', 'consum', 0.0216, 'lps'),
	(510509, 127, '2014-02-01 00:33:38.000000', 'consum', 0.0220, 'lps'),
	(510510, 127, '2014-02-01 00:33:39.000000', 'consum', 0.0212, 'lps'),
	(510511, 127, '2014-02-01 00:33:40.000000', 'consum', 0.0224, 'lps'),
	(510512, 127, '2014-02-01 00:33:41.000000', 'consum', 0.0225, 'lps'),
	(510513, 127, '2014-02-01 00:33:42.000000', 'consum', 0.0212, 'lps'),
	(510514, 127, '2014-02-01 00:33:43.000000', 'consum', 0.0225, 'lps'),
	(510515, 127, '2014-02-01 00:33:44.000000', 'consum', 0.0215, 'lps'),
	(510516, 127, '2014-02-01 00:33:45.000000', 'consum', 0.0221, 'lps'),
	(510517, 127, '2014-02-01 00:33:46.000000', 'consum', 0.0221, 'lps'),
	(510518, 127, '2014-02-01 00:33:47.000000', 'consum', 0.0214, 'lps'),
	(510519, 127, '2014-02-01 00:33:48.000000', 'consum', 0.0215, 'lps'),
	(510520, 127, '2014-02-01 00:33:49.000000', 'consum', 0.0222, 'lps'),
	(510521, 127, '2014-02-01 00:33:50.000000', 'consum', 0.0222, 'lps'),
	(510522, 127, '2014-02-01 00:33:51.000000', 'consum', 0.0221, 'lps'),
	(510523, 127, '2014-02-01 00:33:52.000000', 'consum', 0.0215, 'lps'),
	(510524, 127, '2014-02-01 00:33:53.000000', 'consum', 0.0216, 'lps'),
	(510525, 127, '2014-02-01 00:33:54.000000', 'consum', 0.0211, 'lps'),
	(510526, 127, '2014-02-01 00:33:55.000000', 'consum', 0.0212, 'lps'),
	(510527, 127, '2014-02-01 00:33:56.000000', 'consum', 0.0220, 'lps'),
	(510528, 127, '2014-02-01 00:33:57.000000', 'consum', 0.0219, 'lps'),
	(510529, 127, '2014-02-01 00:33:58.000000', 'consum', 0.0213, 'lps'),
	(510530, 127, '2014-02-01 00:33:59.000000', 'consum', 0.0213, 'lps'),
	(510531, 127, '2014-02-01 00:34:00.000000', 'consum', 0.0215, 'lps'),
	(510532, 127, '2014-02-01 00:34:01.000000', 'consum', 0.0213, 'lps'),
	(510533, 127, '2014-02-01 00:34:02.000000', 'consum', 0.0224, 'lps'),
	(510534, 127, '2014-02-01 00:34:03.000000', 'consum', 0.0224, 'lps'),
	(510535, 127, '2014-02-01 00:34:04.000000', 'consum', 0.0222, 'lps'),
	(510536, 127, '2014-02-01 00:34:05.000000', 'consum', 0.0214, 'lps'),
	(510537, 127, '2014-02-01 00:34:06.000000', 'consum', 0.0210, 'lps'),
	(510538, 127, '2014-02-01 00:34:07.000000', 'consum', 0.0213, 'lps'),
	(510539, 127, '2014-02-01 00:34:08.000000', 'consum', 0.0211, 'lps'),
	(510540, 127, '2014-02-01 00:34:09.000000', 'consum', 0.0224, 'lps'),
	(510541, 127, '2014-02-01 00:34:10.000000', 'consum', 0.0213, 'lps'),
	(510542, 127, '2014-02-01 00:34:11.000000', 'consum', 0.0216, 'lps'),
	(510543, 127, '2014-02-01 00:34:12.000000', 'consum', 0.0216, 'lps'),
	(510544, 127, '2014-02-01 00:34:13.000000', 'consum', 0.0222, 'lps'),
	(510545, 127, '2014-02-01 00:34:14.000000', 'consum', 0.0220, 'lps'),
	(510546, 127, '2014-02-01 00:34:15.000000', 'consum', 0.0210, 'lps'),
	(510547, 127, '2014-02-01 00:34:16.000000', 'consum', 0.0212, 'lps'),
	(510548, 127, '2014-02-01 00:34:17.000000', 'consum', 0.0219, 'lps'),
	(510549, 127, '2014-02-01 00:34:18.000000', 'consum', 0.0217, 'lps'),
	(510550, 127, '2014-02-01 00:34:19.000000', 'consum', 0.0217, 'lps'),
	(510551, 127, '2014-02-01 00:34:20.000000', 'consum', 0.0212, 'lps'),
	(510552, 127, '2014-02-01 00:34:21.000000', 'consum', 0.0215, 'lps'),
	(510553, 127, '2014-02-01 00:34:22.000000', 'consum', 0.0212, 'lps'),
	(510554, 127, '2014-02-01 00:34:23.000000', 'consum', 0.0224, 'lps'),
	(510555, 127, '2014-02-01 00:34:24.000000', 'consum', 0.0224, 'lps'),
	(510556, 127, '2014-02-01 00:34:25.000000', 'consum', 0.0222, 'lps'),
	(510557, 127, '2014-02-01 00:34:26.000000', 'consum', 0.0212, 'lps'),
	(510558, 127, '2014-02-01 00:34:27.000000', 'consum', 0.0217, 'lps'),
	(510559, 127, '2014-02-01 00:34:28.000000', 'consum', 0.0225, 'lps'),
	(510560, 127, '2014-02-01 00:34:29.000000', 'consum', 0.0218, 'lps'),
	(510561, 127, '2014-02-01 00:34:30.000000', 'consum', 0.0219, 'lps'),
	(510562, 127, '2014-02-01 00:34:31.000000', 'consum', 0.0216, 'lps'),
	(510563, 127, '2014-02-01 00:34:32.000000', 'consum', 0.0215, 'lps'),
	(510564, 127, '2014-02-01 00:34:33.000000', 'consum', 0.0214, 'lps'),
	(510565, 127, '2014-02-01 00:34:34.000000', 'consum', 0.0219, 'lps'),
	(510566, 127, '2014-02-01 00:34:35.000000', 'consum', 0.0212, 'lps'),
	(510567, 127, '2014-02-01 00:34:36.000000', 'consum', 0.0224, 'lps'),
	(510568, 127, '2014-02-01 00:34:37.000000', 'consum', 0.0210, 'lps'),
	(510569, 127, '2014-02-01 00:34:38.000000', 'consum', 0.0218, 'lps'),
	(510570, 127, '2014-02-01 00:34:39.000000', 'consum', 0.0217, 'lps'),
	(510571, 127, '2014-02-01 00:34:40.000000', 'consum', 0.0222, 'lps'),
	(510572, 127, '2014-02-01 00:34:41.000000', 'consum', 0.0216, 'lps'),
	(510573, 127, '2014-02-01 00:34:42.000000', 'consum', 0.0219, 'lps'),
	(510574, 127, '2014-02-01 00:34:43.000000', 'consum', 0.0225, 'lps'),
	(510575, 127, '2014-02-01 00:34:44.000000', 'consum', 0.0211, 'lps'),
	(510576, 127, '2014-02-01 00:34:45.000000', 'consum', 0.0216, 'lps'),
	(510577, 127, '2014-02-01 00:34:46.000000', 'consum', 0.0222, 'lps'),
	(510578, 127, '2014-02-01 00:34:47.000000', 'consum', 0.0221, 'lps'),
	(510579, 127, '2014-02-01 00:34:48.000000', 'consum', 0.0212, 'lps'),
	(510580, 127, '2014-02-01 00:34:49.000000', 'consum', 0.0222, 'lps'),
	(510581, 127, '2014-02-01 00:34:50.000000', 'consum', 0.0213, 'lps'),
	(510582, 127, '2014-02-01 00:34:51.000000', 'consum', 0.0225, 'lps'),
	(510583, 127, '2014-02-01 00:34:52.000000', 'consum', 0.0212, 'lps'),
	(510584, 127, '2014-02-01 00:34:53.000000', 'consum', 0.0223, 'lps'),
	(510585, 127, '2014-02-01 00:34:54.000000', 'consum', 0.0223, 'lps'),
	(510586, 127, '2014-02-01 00:34:55.000000', 'consum', 0.0218, 'lps'),
	(510587, 127, '2014-02-01 00:34:56.000000', 'consum', 0.0212, 'lps'),
	(510588, 127, '2014-02-01 00:34:57.000000', 'consum', 0.0211, 'lps'),
	(510589, 127, '2014-02-01 00:34:58.000000', 'consum', 0.0212, 'lps'),
	(510590, 127, '2014-02-01 00:34:59.000000', 'consum', 0.0215, 'lps'),
	(510591, 127, '2014-02-01 00:35:00.000000', 'consum', 0.0216, 'lps'),
	(510592, 127, '2014-02-01 00:35:01.000000', 'consum', 0.0224, 'lps'),
	(510593, 127, '2014-02-01 00:35:02.000000', 'consum', 0.0217, 'lps'),
	(510594, 127, '2014-02-01 00:35:03.000000', 'consum', 0.0218, 'lps'),
	(510595, 127, '2014-02-01 00:35:04.000000', 'consum', 0.0214, 'lps'),
	(510596, 127, '2014-02-01 00:35:05.000000', 'consum', 0.0222, 'lps'),
	(510597, 127, '2014-02-01 00:35:06.000000', 'consum', 0.0210, 'lps'),
	(510598, 127, '2014-02-01 00:35:07.000000', 'consum', 0.0223, 'lps'),
	(510599, 127, '2014-02-01 00:35:08.000000', 'consum', 0.0212, 'lps'),
	(510600, 127, '2014-02-01 00:35:09.000000', 'consum', 0.0214, 'lps'),
	(510601, 127, '2014-02-01 00:35:10.000000', 'consum', 0.0224, 'lps'),
	(510602, 127, '2014-02-01 00:35:11.000000', 'consum', 0.0221, 'lps'),
	(510603, 127, '2014-02-01 00:35:12.000000', 'consum', 0.0222, 'lps'),
	(510604, 127, '2014-02-01 00:35:13.000000', 'consum', 0.0222, 'lps'),
	(510605, 127, '2014-02-01 00:35:14.000000', 'consum', 0.0218, 'lps'),
	(510606, 127, '2014-02-01 00:35:15.000000', 'consum', 0.0215, 'lps'),
	(510607, 127, '2014-02-01 00:35:16.000000', 'consum', 0.0214, 'lps'),
	(510608, 127, '2014-02-01 00:35:17.000000', 'consum', 0.0212, 'lps'),
	(510609, 127, '2014-02-01 00:35:18.000000', 'consum', 0.0225, 'lps'),
	(510610, 127, '2014-02-01 00:35:19.000000', 'consum', 0.0216, 'lps'),
	(510611, 127, '2014-02-01 00:35:20.000000', 'consum', 0.0213, 'lps'),
	(510612, 127, '2014-02-01 00:35:21.000000', 'consum', 0.0223, 'lps'),
	(510613, 127, '2014-02-01 00:35:22.000000', 'consum', 0.0219, 'lps'),
	(510614, 127, '2014-02-01 00:35:23.000000', 'consum', 0.0216, 'lps'),
	(510615, 127, '2014-02-01 00:35:24.000000', 'consum', 0.0215, 'lps'),
	(510616, 127, '2014-02-01 00:35:25.000000', 'consum', 0.0218, 'lps'),
	(510617, 127, '2014-02-01 00:35:26.000000', 'consum', 0.0220, 'lps'),
	(510618, 127, '2014-02-01 00:35:27.000000', 'consum', 0.0218, 'lps'),
	(510619, 127, '2014-02-01 00:35:28.000000', 'consum', 0.0220, 'lps'),
	(510620, 127, '2014-02-01 00:35:29.000000', 'consum', 0.0223, 'lps'),
	(510621, 127, '2014-02-01 00:35:30.000000', 'consum', 0.0212, 'lps'),
	(510622, 127, '2014-02-01 00:35:31.000000', 'consum', 0.0212, 'lps'),
	(510623, 127, '2014-02-01 00:35:32.000000', 'consum', 0.0215, 'lps'),
	(510624, 127, '2014-02-01 00:35:33.000000', 'consum', 0.0216, 'lps'),
	(510625, 127, '2014-02-01 00:35:34.000000', 'consum', 0.0224, 'lps'),
	(510626, 127, '2014-02-01 00:35:35.000000', 'consum', 0.0215, 'lps'),
	(510627, 127, '2014-02-01 00:35:36.000000', 'consum', 0.0211, 'lps'),
	(510628, 127, '2014-02-01 00:35:37.000000', 'consum', 0.0214, 'lps'),
	(510629, 127, '2014-02-01 00:35:38.000000', 'consum', 0.0211, 'lps'),
	(510630, 127, '2014-02-01 00:35:39.000000', 'consum', 0.0221, 'lps'),
	(510631, 127, '2014-02-01 00:35:40.000000', 'consum', 0.0215, 'lps'),
	(510632, 127, '2014-02-01 00:35:41.000000', 'consum', 0.0216, 'lps'),
	(510633, 127, '2014-02-01 00:35:42.000000', 'consum', 0.0213, 'lps'),
	(510634, 127, '2014-02-01 00:35:43.000000', 'consum', 0.0221, 'lps'),
	(510635, 127, '2014-02-01 00:35:44.000000', 'consum', 0.0223, 'lps'),
	(510636, 127, '2014-02-01 00:35:45.000000', 'consum', 0.0214, 'lps'),
	(510637, 127, '2014-02-01 00:35:46.000000', 'consum', 0.0220, 'lps'),
	(510638, 127, '2014-02-01 00:35:47.000000', 'consum', 0.0219, 'lps'),
	(510639, 127, '2014-02-01 00:35:48.000000', 'consum', 0.0224, 'lps'),
	(510640, 127, '2014-02-01 00:35:49.000000', 'consum', 0.0221, 'lps'),
	(510641, 127, '2014-02-01 00:35:50.000000', 'consum', 0.0224, 'lps'),
	(510642, 127, '2014-02-01 00:35:51.000000', 'consum', 0.0215, 'lps'),
	(510643, 127, '2014-02-01 00:35:52.000000', 'consum', 0.0225, 'lps'),
	(510644, 127, '2014-02-01 00:35:53.000000', 'consum', 0.0221, 'lps'),
	(510645, 127, '2014-02-01 00:35:54.000000', 'consum', 0.0224, 'lps'),
	(510646, 127, '2014-02-01 00:35:55.000000', 'consum', 0.0213, 'lps'),
	(510647, 127, '2014-02-01 00:35:56.000000', 'consum', 0.0217, 'lps'),
	(510648, 127, '2014-02-01 00:35:57.000000', 'consum', 0.0221, 'lps'),
	(510649, 127, '2014-02-01 00:35:58.000000', 'consum', 0.0212, 'lps'),
	(510650, 127, '2014-02-01 00:35:59.000000', 'consum', 0.0220, 'lps'),
	(510651, 127, '2014-02-01 00:36:00.000000', 'consum', 0.0223, 'lps'),
	(510652, 127, '2014-02-01 00:36:01.000000', 'consum', 0.0214, 'lps'),
	(510653, 127, '2014-02-01 00:36:02.000000', 'consum', 0.0221, 'lps'),
	(510654, 127, '2014-02-01 00:36:03.000000', 'consum', 0.0223, 'lps'),
	(510655, 127, '2014-02-01 00:36:04.000000', 'consum', 0.0211, 'lps'),
	(510656, 127, '2014-02-01 00:36:05.000000', 'consum', 0.0225, 'lps'),
	(510657, 127, '2014-02-01 00:36:06.000000', 'consum', 0.0219, 'lps'),
	(510658, 127, '2014-02-01 00:36:07.000000', 'consum', 0.0210, 'lps'),
	(510659, 127, '2014-02-01 00:36:08.000000', 'consum', 0.0216, 'lps'),
	(510660, 127, '2014-02-01 00:36:09.000000', 'consum', 0.0225, 'lps'),
	(510661, 127, '2014-02-01 00:36:10.000000', 'consum', 0.0217, 'lps'),
	(510662, 127, '2014-02-01 00:36:11.000000', 'consum', 0.0218, 'lps'),
	(510663, 127, '2014-02-01 00:36:12.000000', 'consum', 0.0213, 'lps'),
	(510664, 127, '2014-02-01 00:36:13.000000', 'consum', 0.0216, 'lps'),
	(510665, 127, '2014-02-01 00:36:14.000000', 'consum', 0.0216, 'lps'),
	(510666, 127, '2014-02-01 00:36:15.000000', 'consum', 0.0223, 'lps'),
	(510667, 127, '2014-02-01 00:36:16.000000', 'consum', 0.0225, 'lps'),
	(510668, 127, '2014-02-01 00:36:17.000000', 'consum', 0.0215, 'lps'),
	(510669, 127, '2014-02-01 00:36:18.000000', 'consum', 0.0223, 'lps'),
	(510670, 127, '2014-02-01 00:36:19.000000', 'consum', 0.0213, 'lps'),
	(510671, 127, '2014-02-01 00:36:20.000000', 'consum', 0.0219, 'lps'),
	(510672, 127, '2014-02-01 00:36:21.000000', 'consum', 0.0215, 'lps'),
	(510673, 127, '2014-02-01 00:36:22.000000', 'consum', 0.0224, 'lps'),
	(510674, 127, '2014-02-01 00:36:23.000000', 'consum', 0.0215, 'lps'),
	(510675, 127, '2014-02-01 00:36:24.000000', 'consum', 0.0213, 'lps'),
	(510676, 127, '2014-02-01 00:36:25.000000', 'consum', 0.0223, 'lps'),
	(510677, 127, '2014-02-01 00:36:26.000000', 'consum', 0.0222, 'lps'),
	(510678, 127, '2014-02-01 00:36:27.000000', 'consum', 0.0214, 'lps'),
	(510679, 127, '2014-02-01 00:36:28.000000', 'consum', 0.0212, 'lps'),
	(510680, 127, '2014-02-01 00:36:29.000000', 'consum', 0.0225, 'lps'),
	(510681, 127, '2014-02-01 00:36:30.000000', 'consum', 0.0216, 'lps'),
	(510682, 127, '2014-02-01 00:36:31.000000', 'consum', 0.0211, 'lps'),
	(510683, 127, '2014-02-01 00:36:32.000000', 'consum', 0.0214, 'lps'),
	(510684, 127, '2014-02-01 00:36:33.000000', 'consum', 0.0225, 'lps'),
	(510685, 127, '2014-02-01 00:36:34.000000', 'consum', 0.0212, 'lps'),
	(510686, 127, '2014-02-01 00:36:35.000000', 'consum', 0.0222, 'lps'),
	(510687, 127, '2014-02-01 00:36:36.000000', 'consum', 0.0217, 'lps'),
	(510688, 127, '2014-02-01 00:36:37.000000', 'consum', 0.0224, 'lps'),
	(510689, 127, '2014-02-01 00:36:38.000000', 'consum', 0.0211, 'lps'),
	(510690, 127, '2014-02-01 00:36:39.000000', 'consum', 0.0224, 'lps'),
	(510691, 127, '2014-02-01 00:36:40.000000', 'consum', 0.0214, 'lps'),
	(510692, 127, '2014-02-01 00:36:41.000000', 'consum', 0.0219, 'lps'),
	(510693, 127, '2014-02-01 00:36:42.000000', 'consum', 0.0211, 'lps'),
	(510694, 127, '2014-02-01 00:36:43.000000', 'consum', 0.0221, 'lps'),
	(510695, 127, '2014-02-01 00:36:44.000000', 'consum', 0.0214, 'lps'),
	(510696, 127, '2014-02-01 00:36:45.000000', 'consum', 0.0213, 'lps'),
	(510697, 127, '2014-02-01 00:36:46.000000', 'consum', 0.0215, 'lps'),
	(510698, 127, '2014-02-01 00:36:47.000000', 'consum', 0.0210, 'lps'),
	(510699, 127, '2014-02-01 00:36:48.000000', 'consum', 0.0212, 'lps'),
	(510700, 127, '2014-02-01 00:36:49.000000', 'consum', 0.0221, 'lps'),
	(510701, 127, '2014-02-01 00:36:50.000000', 'consum', 0.0213, 'lps'),
	(510702, 127, '2014-02-01 00:36:51.000000', 'consum', 0.0222, 'lps'),
	(510703, 127, '2014-02-01 00:36:52.000000', 'consum', 0.0213, 'lps'),
	(510704, 127, '2014-02-01 00:36:53.000000', 'consum', 0.0223, 'lps'),
	(510705, 127, '2014-02-01 00:36:54.000000', 'consum', 0.0217, 'lps'),
	(510706, 127, '2014-02-01 00:36:55.000000', 'consum', 0.0221, 'lps'),
	(510707, 127, '2014-02-01 00:36:56.000000', 'consum', 0.0215, 'lps'),
	(510708, 127, '2014-02-01 00:36:57.000000', 'consum', 0.0218, 'lps'),
	(510709, 127, '2014-02-01 00:36:58.000000', 'consum', 0.0221, 'lps'),
	(510710, 127, '2014-02-01 00:36:59.000000', 'consum', 0.0224, 'lps'),
	(510711, 127, '2014-02-01 00:37:00.000000', 'consum', 0.0217, 'lps'),
	(510712, 127, '2014-02-01 00:37:01.000000', 'consum', 0.0218, 'lps'),
	(510713, 127, '2014-02-01 00:37:02.000000', 'consum', 0.0212, 'lps'),
	(510714, 127, '2014-02-01 00:37:03.000000', 'consum', 0.0216, 'lps'),
	(510715, 127, '2014-02-01 00:37:04.000000', 'consum', 0.0215, 'lps'),
	(510716, 127, '2014-02-01 00:37:05.000000', 'consum', 0.0219, 'lps'),
	(510717, 127, '2014-02-01 00:37:06.000000', 'consum', 0.0225, 'lps'),
	(510718, 127, '2014-02-01 00:37:07.000000', 'consum', 0.0210, 'lps'),
	(510719, 127, '2014-02-01 00:37:08.000000', 'consum', 0.0212, 'lps'),
	(510720, 127, '2014-02-01 00:37:09.000000', 'consum', 0.0220, 'lps'),
	(510721, 127, '2014-02-01 00:37:10.000000', 'consum', 0.0223, 'lps'),
	(510722, 127, '2014-02-01 00:37:11.000000', 'consum', 0.0212, 'lps'),
	(510723, 127, '2014-02-01 00:37:12.000000', 'consum', 0.0216, 'lps'),
	(510724, 127, '2014-02-01 00:37:13.000000', 'consum', 0.0219, 'lps'),
	(510725, 127, '2014-02-01 00:37:14.000000', 'consum', 0.0219, 'lps'),
	(510726, 127, '2014-02-01 00:37:15.000000', 'consum', 0.0213, 'lps'),
	(510727, 127, '2014-02-01 00:37:16.000000', 'consum', 0.0214, 'lps'),
	(510728, 127, '2014-02-01 00:37:17.000000', 'consum', 0.0224, 'lps'),
	(510729, 127, '2014-02-01 00:37:18.000000', 'consum', 0.0220, 'lps'),
	(510730, 127, '2014-02-01 00:37:19.000000', 'consum', 0.0219, 'lps'),
	(510731, 127, '2014-02-01 00:37:20.000000', 'consum', 0.0224, 'lps'),
	(510732, 127, '2014-02-01 00:37:21.000000', 'consum', 0.0221, 'lps'),
	(510733, 127, '2014-02-01 00:37:22.000000', 'consum', 0.0224, 'lps'),
	(510734, 127, '2014-02-01 00:37:23.000000', 'consum', 0.0217, 'lps'),
	(510735, 127, '2014-02-01 00:37:24.000000', 'consum', 0.0218, 'lps'),
	(510736, 127, '2014-02-01 00:37:25.000000', 'consum', 0.0214, 'lps'),
	(510737, 127, '2014-02-01 00:37:26.000000', 'consum', 0.0221, 'lps'),
	(510738, 127, '2014-02-01 00:37:27.000000', 'consum', 0.0221, 'lps'),
	(510739, 127, '2014-02-01 00:37:28.000000', 'consum', 0.0217, 'lps'),
	(510740, 127, '2014-02-01 00:37:29.000000', 'consum', 0.0213, 'lps'),
	(510741, 127, '2014-02-01 00:37:30.000000', 'consum', 0.0220, 'lps'),
	(510742, 127, '2014-02-01 00:37:31.000000', 'consum', 0.0221, 'lps'),
	(510743, 127, '2014-02-01 00:37:32.000000', 'consum', 0.0219, 'lps'),
	(510744, 127, '2014-02-01 00:37:33.000000', 'consum', 0.0221, 'lps'),
	(510745, 127, '2014-02-01 00:37:34.000000', 'consum', 0.0222, 'lps'),
	(510746, 127, '2014-02-01 00:37:35.000000', 'consum', 0.0220, 'lps'),
	(510747, 127, '2014-02-01 00:37:36.000000', 'consum', 0.0212, 'lps'),
	(510748, 127, '2014-02-01 00:37:37.000000', 'consum', 0.0222, 'lps'),
	(510749, 127, '2014-02-01 00:37:38.000000', 'consum', 0.0216, 'lps'),
	(510750, 127, '2014-02-01 00:37:39.000000', 'consum', 0.0221, 'lps'),
	(510751, 127, '2014-02-01 00:37:40.000000', 'consum', 0.0216, 'lps'),
	(510752, 127, '2014-02-01 00:37:41.000000', 'consum', 0.0225, 'lps'),
	(510753, 127, '2014-02-01 00:37:42.000000', 'consum', 0.0217, 'lps'),
	(510754, 127, '2014-02-01 00:37:43.000000', 'consum', 0.0216, 'lps'),
	(510755, 127, '2014-02-01 00:37:44.000000', 'consum', 0.0220, 'lps'),
	(510756, 127, '2014-02-01 00:37:45.000000', 'consum', 0.0225, 'lps'),
	(510757, 127, '2014-02-01 00:37:46.000000', 'consum', 0.0224, 'lps'),
	(510758, 127, '2014-02-01 00:37:47.000000', 'consum', 0.0220, 'lps'),
	(510759, 127, '2014-02-01 00:37:48.000000', 'consum', 0.0219, 'lps'),
	(510760, 127, '2014-02-01 00:37:49.000000', 'consum', 0.0224, 'lps'),
	(510761, 127, '2014-02-01 00:37:50.000000', 'consum', 0.0221, 'lps'),
	(510762, 127, '2014-02-01 00:37:51.000000', 'consum', 0.0225, 'lps'),
	(510763, 127, '2014-02-01 00:37:52.000000', 'consum', 0.0218, 'lps'),
	(510764, 127, '2014-02-01 00:37:53.000000', 'consum', 0.0225, 'lps'),
	(510765, 127, '2014-02-01 00:37:54.000000', 'consum', 0.0211, 'lps'),
	(510766, 127, '2014-02-01 00:37:55.000000', 'consum', 0.0217, 'lps'),
	(510767, 127, '2014-02-01 00:37:56.000000', 'consum', 0.0213, 'lps'),
	(510768, 127, '2014-02-01 00:37:57.000000', 'consum', 0.0221, 'lps'),
	(510769, 127, '2014-02-01 00:37:58.000000', 'consum', 0.0225, 'lps'),
	(510770, 127, '2014-02-01 00:37:59.000000', 'consum', 0.0219, 'lps'),
	(510771, 127, '2014-02-01 00:38:00.000000', 'consum', 0.0211, 'lps'),
	(510772, 127, '2014-02-01 00:38:01.000000', 'consum', 0.0222, 'lps'),
	(510773, 127, '2014-02-01 00:38:02.000000', 'consum', 0.0218, 'lps'),
	(510774, 127, '2014-02-01 00:38:03.000000', 'consum', 0.0214, 'lps'),
	(510775, 127, '2014-02-01 00:38:04.000000', 'consum', 0.0223, 'lps'),
	(510776, 127, '2014-02-01 00:38:05.000000', 'consum', 0.0216, 'lps'),
	(510777, 127, '2014-02-01 00:38:06.000000', 'consum', 0.0216, 'lps'),
	(510778, 127, '2014-02-01 00:38:07.000000', 'consum', 0.0225, 'lps'),
	(510779, 127, '2014-02-01 00:38:08.000000', 'consum', 0.0218, 'lps'),
	(510780, 127, '2014-02-01 00:38:09.000000', 'consum', 0.0221, 'lps'),
	(510781, 127, '2014-02-01 00:38:10.000000', 'consum', 0.0210, 'lps'),
	(510782, 127, '2014-02-01 00:38:11.000000', 'consum', 0.0225, 'lps'),
	(510783, 127, '2014-02-01 00:38:12.000000', 'consum', 0.0221, 'lps'),
	(510784, 127, '2014-02-01 00:38:13.000000', 'consum', 0.0223, 'lps'),
	(510785, 127, '2014-02-01 00:38:14.000000', 'consum', 0.0210, 'lps'),
	(510786, 127, '2014-02-01 00:38:15.000000', 'consum', 0.0219, 'lps'),
	(510787, 127, '2014-02-01 00:38:16.000000', 'consum', 0.0223, 'lps'),
	(510788, 127, '2014-02-01 00:38:17.000000', 'consum', 0.0217, 'lps'),
	(510789, 127, '2014-02-01 00:38:18.000000', 'consum', 0.0224, 'lps'),
	(510790, 127, '2014-02-01 00:38:19.000000', 'consum', 0.0210, 'lps'),
	(510791, 127, '2014-02-01 00:38:20.000000', 'consum', 0.0217, 'lps'),
	(510792, 127, '2014-02-01 00:38:21.000000', 'consum', 0.0214, 'lps'),
	(510793, 127, '2014-02-01 00:38:22.000000', 'consum', 0.0210, 'lps'),
	(510794, 127, '2014-02-01 00:38:23.000000', 'consum', 0.0216, 'lps'),
	(510795, 127, '2014-02-01 00:38:24.000000', 'consum', 0.0221, 'lps'),
	(510796, 127, '2014-02-01 00:38:25.000000', 'consum', 0.0218, 'lps'),
	(510797, 127, '2014-02-01 00:38:26.000000', 'consum', 0.0217, 'lps'),
	(510798, 127, '2014-02-01 00:38:27.000000', 'consum', 0.0223, 'lps'),
	(510799, 127, '2014-02-01 00:38:28.000000', 'consum', 0.0222, 'lps'),
	(510800, 127, '2014-02-01 00:38:29.000000', 'consum', 0.0215, 'lps'),
	(510801, 127, '2014-02-01 00:38:30.000000', 'consum', 0.0215, 'lps'),
	(510802, 127, '2014-02-01 00:38:31.000000', 'consum', 0.0220, 'lps'),
	(510803, 127, '2014-02-01 00:38:32.000000', 'consum', 0.0214, 'lps'),
	(510804, 127, '2014-02-01 00:38:33.000000', 'consum', 0.0217, 'lps'),
	(510805, 127, '2014-02-01 00:38:34.000000', 'consum', 0.0216, 'lps'),
	(510806, 127, '2014-02-01 00:38:35.000000', 'consum', 0.0222, 'lps'),
	(510807, 127, '2014-02-01 00:38:36.000000', 'consum', 0.0221, 'lps'),
	(510808, 127, '2014-02-01 00:38:37.000000', 'consum', 0.0213, 'lps'),
	(510809, 127, '2014-02-01 00:38:38.000000', 'consum', 0.0224, 'lps'),
	(510810, 127, '2014-02-01 00:38:39.000000', 'consum', 0.0225, 'lps'),
	(510811, 127, '2014-02-01 00:38:40.000000', 'consum', 0.0225, 'lps'),
	(510812, 127, '2014-02-01 00:38:41.000000', 'consum', 0.0225, 'lps'),
	(510813, 127, '2014-02-01 00:38:42.000000', 'consum', 0.0211, 'lps'),
	(510814, 127, '2014-02-01 00:38:43.000000', 'consum', 0.0217, 'lps'),
	(510815, 127, '2014-02-01 00:38:44.000000', 'consum', 0.0211, 'lps'),
	(510816, 127, '2014-02-01 00:38:45.000000', 'consum', 0.0224, 'lps'),
	(510817, 127, '2014-02-01 00:38:46.000000', 'consum', 0.0216, 'lps'),
	(510818, 127, '2014-02-01 00:38:47.000000', 'consum', 0.0215, 'lps'),
	(510819, 127, '2014-02-01 00:38:48.000000', 'consum', 0.0215, 'lps'),
	(510820, 127, '2014-02-01 00:38:49.000000', 'consum', 0.0222, 'lps'),
	(510821, 127, '2014-02-01 00:38:50.000000', 'consum', 0.0224, 'lps'),
	(510822, 127, '2014-02-01 00:38:51.000000', 'consum', 0.0213, 'lps'),
	(510823, 127, '2014-02-01 00:38:52.000000', 'consum', 0.0213, 'lps'),
	(510824, 127, '2014-02-01 00:38:53.000000', 'consum', 0.0217, 'lps'),
	(510825, 127, '2014-02-01 00:38:54.000000', 'consum', 0.0222, 'lps'),
	(510826, 127, '2014-02-01 00:38:55.000000', 'consum', 0.0216, 'lps'),
	(510827, 127, '2014-02-01 00:38:56.000000', 'consum', 0.0222, 'lps'),
	(510828, 127, '2014-02-01 00:38:57.000000', 'consum', 0.0220, 'lps'),
	(510829, 127, '2014-02-01 00:38:58.000000', 'consum', 0.0223, 'lps'),
	(510830, 127, '2014-02-01 00:38:59.000000', 'consum', 0.0214, 'lps'),
	(510831, 127, '2014-02-01 00:39:00.000000', 'consum', 0.0225, 'lps'),
	(510832, 127, '2014-02-01 00:39:01.000000', 'consum', 0.0210, 'lps'),
	(510833, 127, '2014-02-01 00:39:02.000000', 'consum', 0.0213, 'lps'),
	(510834, 127, '2014-02-01 00:39:03.000000', 'consum', 0.0224, 'lps'),
	(510835, 127, '2014-02-01 00:39:04.000000', 'consum', 0.0222, 'lps'),
	(510836, 127, '2014-02-01 00:39:05.000000', 'consum', 0.0215, 'lps'),
	(510837, 127, '2014-02-01 00:39:06.000000', 'consum', 0.0216, 'lps'),
	(510838, 127, '2014-02-01 00:39:07.000000', 'consum', 0.0223, 'lps'),
	(510839, 127, '2014-02-01 00:39:08.000000', 'consum', 0.0213, 'lps'),
	(510840, 127, '2014-02-01 00:39:09.000000', 'consum', 0.0215, 'lps'),
	(510841, 127, '2014-02-01 00:39:10.000000', 'consum', 0.0212, 'lps'),
	(510842, 127, '2014-02-01 00:39:11.000000', 'consum', 0.0220, 'lps'),
	(510843, 127, '2014-02-01 00:39:12.000000', 'consum', 0.0222, 'lps'),
	(510844, 127, '2014-02-01 00:39:13.000000', 'consum', 0.0211, 'lps'),
	(510845, 127, '2014-02-01 00:39:14.000000', 'consum', 0.0211, 'lps'),
	(510846, 127, '2014-02-01 00:39:15.000000', 'consum', 0.0212, 'lps'),
	(510847, 127, '2014-02-01 00:39:16.000000', 'consum', 0.0218, 'lps'),
	(510848, 127, '2014-02-01 00:39:17.000000', 'consum', 0.0211, 'lps'),
	(510849, 127, '2014-02-01 00:39:18.000000', 'consum', 0.0223, 'lps'),
	(510850, 127, '2014-02-01 00:39:19.000000', 'consum', 0.0225, 'lps'),
	(510851, 127, '2014-02-01 00:39:20.000000', 'consum', 0.0214, 'lps'),
	(510852, 127, '2014-02-01 00:39:21.000000', 'consum', 0.0217, 'lps'),
	(510853, 127, '2014-02-01 00:39:22.000000', 'consum', 0.0217, 'lps'),
	(510854, 127, '2014-02-01 00:39:23.000000', 'consum', 0.0210, 'lps'),
	(510855, 127, '2014-02-01 00:39:24.000000', 'consum', 0.0220, 'lps'),
	(510856, 127, '2014-02-01 00:39:25.000000', 'consum', 0.0214, 'lps'),
	(510857, 127, '2014-02-01 00:39:26.000000', 'consum', 0.0215, 'lps'),
	(510858, 127, '2014-02-01 00:39:27.000000', 'consum', 0.0210, 'lps'),
	(510859, 127, '2014-02-01 00:39:28.000000', 'consum', 0.0225, 'lps'),
	(510860, 127, '2014-02-01 00:39:29.000000', 'consum', 0.0223, 'lps'),
	(510861, 127, '2014-02-01 00:39:30.000000', 'consum', 0.0214, 'lps'),
	(510862, 127, '2014-02-01 00:39:31.000000', 'consum', 0.0210, 'lps'),
	(510863, 127, '2014-02-01 00:39:32.000000', 'consum', 0.0211, 'lps'),
	(510864, 127, '2014-02-01 00:39:33.000000', 'consum', 0.0218, 'lps'),
	(510865, 127, '2014-02-01 00:39:34.000000', 'consum', 0.0214, 'lps'),
	(510866, 127, '2014-02-01 00:39:35.000000', 'consum', 0.0222, 'lps'),
	(510867, 127, '2014-02-01 00:39:36.000000', 'consum', 0.0211, 'lps'),
	(510868, 127, '2014-02-01 00:39:37.000000', 'consum', 0.0213, 'lps'),
	(510869, 127, '2014-02-01 00:39:38.000000', 'consum', 0.0220, 'lps'),
	(510870, 127, '2014-02-01 00:39:39.000000', 'consum', 0.0220, 'lps'),
	(510871, 127, '2014-02-01 00:39:40.000000', 'consum', 0.0215, 'lps'),
	(510872, 127, '2014-02-01 00:39:41.000000', 'consum', 0.0220, 'lps'),
	(510873, 127, '2014-02-01 00:39:42.000000', 'consum', 0.0215, 'lps'),
	(510874, 127, '2014-02-01 00:39:43.000000', 'consum', 0.0220, 'lps'),
	(510875, 127, '2014-02-01 00:39:44.000000', 'consum', 0.0215, 'lps'),
	(510876, 127, '2014-02-01 00:39:45.000000', 'consum', 0.0223, 'lps'),
	(510877, 127, '2014-02-01 00:39:46.000000', 'consum', 0.0210, 'lps'),
	(510878, 127, '2014-02-01 00:39:47.000000', 'consum', 0.0220, 'lps'),
	(510879, 127, '2014-02-01 00:39:48.000000', 'consum', 0.0211, 'lps'),
	(510880, 127, '2014-02-01 00:39:49.000000', 'consum', 0.0217, 'lps'),
	(510881, 127, '2014-02-01 00:39:50.000000', 'consum', 0.0213, 'lps'),
	(510882, 127, '2014-02-01 00:39:51.000000', 'consum', 0.0218, 'lps'),
	(510883, 127, '2014-02-01 00:39:52.000000', 'consum', 0.0225, 'lps'),
	(510884, 127, '2014-02-01 00:39:53.000000', 'consum', 0.0215, 'lps'),
	(510885, 127, '2014-02-01 00:39:54.000000', 'consum', 0.0222, 'lps'),
	(510886, 127, '2014-02-01 00:39:55.000000', 'consum', 0.0225, 'lps'),
	(510887, 127, '2014-02-01 00:39:56.000000', 'consum', 0.0217, 'lps'),
	(510888, 127, '2014-02-01 00:39:57.000000', 'consum', 0.0216, 'lps'),
	(510889, 127, '2014-02-01 00:39:58.000000', 'consum', 0.0219, 'lps'),
	(510890, 127, '2014-02-01 00:39:59.000000', 'consum', 0.0223, 'lps'),
	(510891, 127, '2014-02-01 00:40:00.000000', 'consum', 0.0214, 'lps'),
	(510892, 127, '2014-02-01 00:40:01.000000', 'consum', 0.0210, 'lps'),
	(510893, 127, '2014-02-01 00:40:02.000000', 'consum', 0.0214, 'lps'),
	(510894, 127, '2014-02-01 00:40:03.000000', 'consum', 0.0216, 'lps'),
	(510895, 127, '2014-02-01 00:40:04.000000', 'consum', 0.0212, 'lps'),
	(510896, 127, '2014-02-01 00:40:05.000000', 'consum', 0.0217, 'lps'),
	(510897, 127, '2014-02-01 00:40:06.000000', 'consum', 0.0224, 'lps'),
	(510898, 127, '2014-02-01 00:40:07.000000', 'consum', 0.0210, 'lps'),
	(510899, 127, '2014-02-01 00:40:08.000000', 'consum', 0.0217, 'lps'),
	(510900, 127, '2014-02-01 00:40:09.000000', 'consum', 0.0213, 'lps'),
	(510901, 127, '2014-02-01 00:40:10.000000', 'consum', 0.0221, 'lps'),
	(510902, 127, '2014-02-01 00:40:11.000000', 'consum', 0.0223, 'lps'),
	(510903, 127, '2014-02-01 00:40:12.000000', 'consum', 0.0212, 'lps'),
	(510904, 127, '2014-02-01 00:40:13.000000', 'consum', 0.0215, 'lps'),
	(510905, 127, '2014-02-01 00:40:14.000000', 'consum', 0.0212, 'lps'),
	(510906, 127, '2014-02-01 00:40:15.000000', 'consum', 0.0220, 'lps'),
	(510907, 127, '2014-02-01 00:40:16.000000', 'consum', 0.0224, 'lps'),
	(510908, 127, '2014-02-01 00:40:17.000000', 'consum', 0.0218, 'lps'),
	(510909, 127, '2014-02-01 00:40:18.000000', 'consum', 0.0224, 'lps'),
	(510910, 127, '2014-02-01 00:40:19.000000', 'consum', 0.0225, 'lps'),
	(510911, 127, '2014-02-01 00:40:20.000000', 'consum', 0.0212, 'lps'),
	(510912, 127, '2014-02-01 00:40:21.000000', 'consum', 0.0223, 'lps'),
	(510913, 127, '2014-02-01 00:40:22.000000', 'consum', 0.0221, 'lps'),
	(510914, 127, '2014-02-01 00:40:23.000000', 'consum', 0.0211, 'lps'),
	(510915, 127, '2014-02-01 00:40:24.000000', 'consum', 0.0216, 'lps'),
	(510916, 127, '2014-02-01 00:40:25.000000', 'consum', 0.0220, 'lps'),
	(510917, 127, '2014-02-01 00:40:26.000000', 'consum', 0.0211, 'lps'),
	(510918, 127, '2014-02-01 00:40:27.000000', 'consum', 0.0219, 'lps'),
	(510919, 127, '2014-02-01 00:40:28.000000', 'consum', 0.0221, 'lps'),
	(510920, 127, '2014-02-01 00:40:29.000000', 'consum', 0.0221, 'lps'),
	(510921, 127, '2014-02-01 00:40:30.000000', 'consum', 0.0216, 'lps'),
	(510922, 127, '2014-02-01 00:40:31.000000', 'consum', 0.0222, 'lps'),
	(510923, 127, '2014-02-01 00:40:32.000000', 'consum', 0.0223, 'lps'),
	(510924, 127, '2014-02-01 00:40:33.000000', 'consum', 0.0223, 'lps'),
	(510925, 127, '2014-02-01 00:40:34.000000', 'consum', 0.0220, 'lps'),
	(510926, 127, '2014-02-01 00:40:35.000000', 'consum', 0.0221, 'lps'),
	(510927, 127, '2014-02-01 00:40:36.000000', 'consum', 0.0222, 'lps'),
	(510928, 127, '2014-02-01 00:40:37.000000', 'consum', 0.0218, 'lps'),
	(510929, 127, '2014-02-01 00:40:38.000000', 'consum', 0.0218, 'lps'),
	(510930, 127, '2014-02-01 00:40:39.000000', 'consum', 0.0225, 'lps'),
	(510931, 127, '2014-02-01 00:40:40.000000', 'consum', 0.0214, 'lps'),
	(510932, 127, '2014-02-01 00:40:41.000000', 'consum', 0.0215, 'lps'),
	(510933, 127, '2014-02-01 00:40:42.000000', 'consum', 0.0211, 'lps'),
	(510934, 127, '2014-02-01 00:40:43.000000', 'consum', 0.0214, 'lps'),
	(510935, 127, '2014-02-01 00:40:44.000000', 'consum', 0.0214, 'lps'),
	(510936, 127, '2014-02-01 00:40:45.000000', 'consum', 0.0217, 'lps'),
	(510937, 127, '2014-02-01 00:40:46.000000', 'consum', 0.0217, 'lps'),
	(510938, 127, '2014-02-01 00:40:47.000000', 'consum', 0.0210, 'lps'),
	(510939, 127, '2014-02-01 00:40:48.000000', 'consum', 0.0223, 'lps'),
	(510940, 127, '2014-02-01 00:40:49.000000', 'consum', 0.0210, 'lps'),
	(510941, 127, '2014-02-01 00:40:50.000000', 'consum', 0.0218, 'lps'),
	(510942, 127, '2014-02-01 00:40:51.000000', 'consum', 0.0221, 'lps'),
	(510943, 127, '2014-02-01 00:40:52.000000', 'consum', 0.0225, 'lps'),
	(510944, 127, '2014-02-01 00:40:53.000000', 'consum', 0.0220, 'lps'),
	(510945, 127, '2014-02-01 00:40:54.000000', 'consum', 0.0217, 'lps'),
	(510946, 127, '2014-02-01 00:40:55.000000', 'consum', 0.0213, 'lps'),
	(510947, 127, '2014-02-01 00:40:56.000000', 'consum', 0.0223, 'lps'),
	(510948, 127, '2014-02-01 00:40:57.000000', 'consum', 0.0220, 'lps'),
	(510949, 127, '2014-02-01 00:40:58.000000', 'consum', 0.0218, 'lps'),
	(510950, 127, '2014-02-01 00:40:59.000000', 'consum', 0.0221, 'lps'),
	(510951, 127, '2014-02-01 00:41:00.000000', 'consum', 0.0211, 'lps'),
	(510952, 127, '2014-02-01 00:41:01.000000', 'consum', 0.0214, 'lps'),
	(510953, 127, '2014-02-01 00:41:02.000000', 'consum', 0.0212, 'lps'),
	(510954, 127, '2014-02-01 00:41:03.000000', 'consum', 0.0225, 'lps'),
	(510955, 127, '2014-02-01 00:41:04.000000', 'consum', 0.0215, 'lps'),
	(510956, 127, '2014-02-01 00:41:05.000000', 'consum', 0.0224, 'lps'),
	(510957, 127, '2014-02-01 00:41:06.000000', 'consum', 0.0217, 'lps'),
	(510958, 127, '2014-02-01 00:41:07.000000', 'consum', 0.0220, 'lps'),
	(510959, 127, '2014-02-01 00:41:08.000000', 'consum', 0.0222, 'lps'),
	(510960, 127, '2014-02-01 00:41:09.000000', 'consum', 0.0223, 'lps'),
	(510961, 127, '2014-02-01 00:41:10.000000', 'consum', 0.0211, 'lps'),
	(510962, 127, '2014-02-01 00:41:11.000000', 'consum', 0.0221, 'lps'),
	(510963, 127, '2014-02-01 00:41:12.000000', 'consum', 0.0216, 'lps'),
	(510964, 127, '2014-02-01 00:41:13.000000', 'consum', 0.0224, 'lps'),
	(510965, 127, '2014-02-01 00:41:14.000000', 'consum', 0.0215, 'lps'),
	(510966, 127, '2014-02-01 00:41:15.000000', 'consum', 0.0224, 'lps'),
	(510967, 127, '2014-02-01 00:41:16.000000', 'consum', 0.0217, 'lps'),
	(510968, 127, '2014-02-01 00:41:17.000000', 'consum', 0.0219, 'lps'),
	(510969, 127, '2014-02-01 00:41:18.000000', 'consum', 0.0220, 'lps'),
	(510970, 127, '2014-02-01 00:41:19.000000', 'consum', 0.0218, 'lps'),
	(510971, 127, '2014-02-01 00:41:20.000000', 'consum', 0.0220, 'lps'),
	(510972, 127, '2014-02-01 00:41:21.000000', 'consum', 0.0218, 'lps'),
	(510973, 127, '2014-02-01 00:41:22.000000', 'consum', 0.0223, 'lps'),
	(510974, 127, '2014-02-01 00:41:23.000000', 'consum', 0.0221, 'lps'),
	(510975, 127, '2014-02-01 00:41:24.000000', 'consum', 0.0225, 'lps'),
	(510976, 127, '2014-02-01 00:41:25.000000', 'consum', 0.0221, 'lps'),
	(510977, 127, '2014-02-01 00:41:26.000000', 'consum', 0.0218, 'lps'),
	(510978, 127, '2014-02-01 00:41:27.000000', 'consum', 0.0220, 'lps'),
	(510979, 127, '2014-02-01 00:41:28.000000', 'consum', 0.0220, 'lps'),
	(510980, 127, '2014-02-01 00:41:29.000000', 'consum', 0.0214, 'lps'),
	(510981, 127, '2014-02-01 00:41:30.000000', 'consum', 0.0217, 'lps'),
	(510982, 127, '2014-02-01 00:41:31.000000', 'consum', 0.0217, 'lps'),
	(510983, 127, '2014-02-01 00:41:32.000000', 'consum', 0.0223, 'lps'),
	(510984, 127, '2014-02-01 00:41:33.000000', 'consum', 0.0225, 'lps'),
	(510985, 127, '2014-02-01 00:41:34.000000', 'consum', 0.0215, 'lps'),
	(510986, 127, '2014-02-01 00:41:35.000000', 'consum', 0.0223, 'lps'),
	(510987, 127, '2014-02-01 00:41:36.000000', 'consum', 0.0210, 'lps'),
	(510988, 127, '2014-02-01 00:41:37.000000', 'consum', 0.0219, 'lps'),
	(510989, 127, '2014-02-01 00:41:38.000000', 'consum', 0.0225, 'lps'),
	(510990, 127, '2014-02-01 00:41:39.000000', 'consum', 0.0211, 'lps'),
	(510991, 127, '2014-02-01 00:41:40.000000', 'consum', 0.0216, 'lps'),
	(510992, 127, '2014-02-01 00:41:41.000000', 'consum', 0.0224, 'lps'),
	(510993, 127, '2014-02-01 00:41:42.000000', 'consum', 0.0213, 'lps'),
	(510994, 127, '2014-02-01 00:41:43.000000', 'consum', 0.0214, 'lps'),
	(510995, 127, '2014-02-01 00:41:44.000000', 'consum', 0.0224, 'lps'),
	(510996, 127, '2014-02-01 00:41:45.000000', 'consum', 0.0220, 'lps'),
	(510997, 127, '2014-02-01 00:41:46.000000', 'consum', 0.0218, 'lps'),
	(510998, 127, '2014-02-01 00:41:47.000000', 'consum', 0.0219, 'lps'),
	(510999, 127, '2014-02-01 00:41:48.000000', 'consum', 0.0218, 'lps'),
	(511000, 127, '2014-02-01 00:41:49.000000', 'consum', 0.0223, 'lps'),
	(511001, 127, '2014-02-01 00:41:50.000000', 'consum', 0.0221, 'lps'),
	(511002, 127, '2014-02-01 00:41:51.000000', 'consum', 0.0225, 'lps'),
	(511003, 127, '2014-02-01 00:41:52.000000', 'consum', 0.0220, 'lps'),
	(511004, 127, '2014-02-01 00:41:53.000000', 'consum', 0.0217, 'lps'),
	(511005, 127, '2014-02-01 00:41:54.000000', 'consum', 0.0214, 'lps'),
	(511006, 127, '2014-02-01 00:41:55.000000', 'consum', 0.0211, 'lps'),
	(511007, 127, '2014-02-01 00:41:56.000000', 'consum', 0.0220, 'lps'),
	(511008, 127, '2014-02-01 00:41:57.000000', 'consum', 0.0225, 'lps'),
	(511009, 127, '2014-02-01 00:41:58.000000', 'consum', 0.0223, 'lps'),
	(511010, 127, '2014-02-01 00:41:59.000000', 'consum', 0.0214, 'lps'),
	(511011, 127, '2014-02-01 00:42:00.000000', 'consum', 0.0225, 'lps'),
	(511012, 127, '2014-02-01 00:42:01.000000', 'consum', 0.0223, 'lps'),
	(511013, 127, '2014-02-01 00:42:02.000000', 'consum', 0.0217, 'lps'),
	(511014, 127, '2014-02-01 00:42:03.000000', 'consum', 0.0222, 'lps'),
	(511015, 127, '2014-02-01 00:42:04.000000', 'consum', 0.0216, 'lps'),
	(511016, 127, '2014-02-01 00:42:05.000000', 'consum', 0.0221, 'lps'),
	(511017, 127, '2014-02-01 00:42:06.000000', 'consum', 0.0216, 'lps'),
	(511018, 127, '2014-02-01 00:42:07.000000', 'consum', 0.0224, 'lps'),
	(511019, 127, '2014-02-01 00:42:08.000000', 'consum', 0.0215, 'lps'),
	(511020, 127, '2014-02-01 00:42:09.000000', 'consum', 0.0211, 'lps'),
	(511021, 127, '2014-02-01 00:42:10.000000', 'consum', 0.0213, 'lps'),
	(511022, 127, '2014-02-01 00:42:11.000000', 'consum', 0.0225, 'lps'),
	(511023, 127, '2014-02-01 00:42:12.000000', 'consum', 0.0211, 'lps'),
	(511024, 127, '2014-02-01 00:42:13.000000', 'consum', 0.0220, 'lps'),
	(511025, 127, '2014-02-01 00:42:14.000000', 'consum', 0.0210, 'lps'),
	(511026, 127, '2014-02-01 00:42:15.000000', 'consum', 0.0210, 'lps'),
	(511027, 127, '2014-02-01 00:42:16.000000', 'consum', 0.0213, 'lps'),
	(511028, 127, '2014-02-01 00:42:17.000000', 'consum', 0.0210, 'lps'),
	(511029, 127, '2014-02-01 00:42:18.000000', 'consum', 0.0215, 'lps'),
	(511030, 127, '2014-02-01 00:42:19.000000', 'consum', 0.0219, 'lps'),
	(511031, 127, '2014-02-01 00:42:20.000000', 'consum', 0.0225, 'lps'),
	(511032, 127, '2014-02-01 00:42:21.000000', 'consum', 0.0211, 'lps'),
	(511033, 127, '2014-02-01 00:42:22.000000', 'consum', 0.0219, 'lps'),
	(511034, 127, '2014-02-01 00:42:23.000000', 'consum', 0.0221, 'lps'),
	(511035, 127, '2014-02-01 00:42:24.000000', 'consum', 0.0222, 'lps'),
	(511036, 127, '2014-02-01 00:42:25.000000', 'consum', 0.0222, 'lps'),
	(511037, 127, '2014-02-01 00:42:26.000000', 'consum', 0.0216, 'lps'),
	(511038, 127, '2014-02-01 00:42:27.000000', 'consum', 0.0223, 'lps'),
	(511039, 127, '2014-02-01 00:42:28.000000', 'consum', 0.0224, 'lps'),
	(511040, 127, '2014-02-01 00:42:29.000000', 'consum', 0.0211, 'lps'),
	(511041, 127, '2014-02-01 00:42:30.000000', 'consum', 0.0219, 'lps'),
	(511042, 127, '2014-02-01 00:42:31.000000', 'consum', 0.0220, 'lps'),
	(511043, 127, '2014-02-01 00:42:32.000000', 'consum', 0.0221, 'lps'),
	(511044, 127, '2014-02-01 00:42:33.000000', 'consum', 0.0216, 'lps'),
	(511045, 127, '2014-02-01 00:42:34.000000', 'consum', 0.0211, 'lps'),
	(511046, 127, '2014-02-01 00:42:35.000000', 'consum', 0.0212, 'lps'),
	(511047, 127, '2014-02-01 00:42:36.000000', 'consum', 0.0216, 'lps'),
	(511048, 127, '2014-02-01 00:42:37.000000', 'consum', 0.0220, 'lps'),
	(511049, 127, '2014-02-01 00:42:38.000000', 'consum', 0.0212, 'lps'),
	(511050, 127, '2014-02-01 00:42:39.000000', 'consum', 0.0222, 'lps'),
	(511051, 127, '2014-02-01 00:42:40.000000', 'consum', 0.0218, 'lps'),
	(511052, 127, '2014-02-01 00:42:41.000000', 'consum', 0.0213, 'lps'),
	(511053, 127, '2014-02-01 00:42:42.000000', 'consum', 0.0217, 'lps'),
	(511054, 127, '2014-02-01 00:42:43.000000', 'consum', 0.0221, 'lps'),
	(511055, 127, '2014-02-01 00:42:44.000000', 'consum', 0.0211, 'lps'),
	(511056, 127, '2014-02-01 00:42:45.000000', 'consum', 0.0217, 'lps'),
	(511057, 127, '2014-02-01 00:42:46.000000', 'consum', 0.0211, 'lps'),
	(511058, 127, '2014-02-01 00:42:47.000000', 'consum', 0.0224, 'lps'),
	(511059, 127, '2014-02-01 00:42:48.000000', 'consum', 0.0215, 'lps'),
	(511060, 127, '2014-02-01 00:42:49.000000', 'consum', 0.0225, 'lps'),
	(511061, 127, '2014-02-01 00:42:50.000000', 'consum', 0.0221, 'lps'),
	(511062, 127, '2014-02-01 00:42:51.000000', 'consum', 0.0221, 'lps'),
	(511063, 127, '2014-02-01 00:42:52.000000', 'consum', 0.0216, 'lps'),
	(511064, 127, '2014-02-01 00:42:53.000000', 'consum', 0.0210, 'lps'),
	(511065, 127, '2014-02-01 00:42:54.000000', 'consum', 0.0221, 'lps'),
	(511066, 127, '2014-02-01 00:42:55.000000', 'consum', 0.0221, 'lps'),
	(511067, 127, '2014-02-01 00:42:56.000000', 'consum', 0.0214, 'lps'),
	(511068, 127, '2014-02-01 00:42:57.000000', 'consum', 0.0216, 'lps'),
	(511069, 127, '2014-02-01 00:42:58.000000', 'consum', 0.0212, 'lps'),
	(511070, 127, '2014-02-01 00:42:59.000000', 'consum', 0.0218, 'lps'),
	(511071, 127, '2014-02-01 00:43:00.000000', 'consum', 0.0211, 'lps'),
	(511072, 127, '2014-02-01 00:43:01.000000', 'consum', 0.0211, 'lps'),
	(511073, 127, '2014-02-01 00:43:02.000000', 'consum', 0.0225, 'lps'),
	(511074, 127, '2014-02-01 00:43:03.000000', 'consum', 0.0220, 'lps'),
	(511075, 127, '2014-02-01 00:43:04.000000', 'consum', 0.0214, 'lps'),
	(511076, 127, '2014-02-01 00:43:05.000000', 'consum', 0.0216, 'lps'),
	(511077, 127, '2014-02-01 00:43:06.000000', 'consum', 0.0212, 'lps'),
	(511078, 127, '2014-02-01 00:43:07.000000', 'consum', 0.0218, 'lps'),
	(511079, 127, '2014-02-01 00:43:08.000000', 'consum', 0.0212, 'lps'),
	(511080, 127, '2014-02-01 00:43:09.000000', 'consum', 0.0212, 'lps'),
	(511081, 127, '2014-02-01 00:43:10.000000', 'consum', 0.0217, 'lps'),
	(511082, 127, '2014-02-01 00:43:11.000000', 'consum', 0.0222, 'lps'),
	(511083, 127, '2014-02-01 00:43:12.000000', 'consum', 0.0218, 'lps'),
	(511084, 127, '2014-02-01 00:43:13.000000', 'consum', 0.0214, 'lps'),
	(511085, 127, '2014-02-01 00:43:14.000000', 'consum', 0.0223, 'lps'),
	(511086, 127, '2014-02-01 00:43:15.000000', 'consum', 0.0217, 'lps'),
	(511087, 127, '2014-02-01 00:43:16.000000', 'consum', 0.0223, 'lps'),
	(511088, 127, '2014-02-01 00:43:17.000000', 'consum', 0.0222, 'lps'),
	(511089, 127, '2014-02-01 00:43:18.000000', 'consum', 0.0214, 'lps'),
	(511090, 127, '2014-02-01 00:43:19.000000', 'consum', 0.0225, 'lps'),
	(511091, 127, '2014-02-01 00:43:20.000000', 'consum', 0.0212, 'lps'),
	(511092, 127, '2014-02-01 00:43:21.000000', 'consum', 0.0223, 'lps'),
	(511093, 127, '2014-02-01 00:43:22.000000', 'consum', 0.0220, 'lps'),
	(511094, 127, '2014-02-01 00:43:23.000000', 'consum', 0.0222, 'lps'),
	(511095, 127, '2014-02-01 00:43:24.000000', 'consum', 0.0224, 'lps'),
	(511096, 127, '2014-02-01 00:43:25.000000', 'consum', 0.0212, 'lps'),
	(511097, 127, '2014-02-01 00:43:26.000000', 'consum', 0.0212, 'lps'),
	(511098, 127, '2014-02-01 00:43:27.000000', 'consum', 0.0215, 'lps'),
	(511099, 127, '2014-02-01 00:43:28.000000', 'consum', 0.0211, 'lps'),
	(511100, 127, '2014-02-01 00:43:29.000000', 'consum', 0.0219, 'lps'),
	(511101, 127, '2014-02-01 00:43:30.000000', 'consum', 0.0219, 'lps'),
	(511102, 127, '2014-02-01 00:43:31.000000', 'consum', 0.0212, 'lps'),
	(511103, 127, '2014-02-01 00:43:32.000000', 'consum', 0.0224, 'lps'),
	(511104, 127, '2014-02-01 00:43:33.000000', 'consum', 0.0213, 'lps'),
	(511105, 127, '2014-02-01 00:43:34.000000', 'consum', 0.0216, 'lps'),
	(511106, 127, '2014-02-01 00:43:35.000000', 'consum', 0.0215, 'lps'),
	(511107, 127, '2014-02-01 00:43:36.000000', 'consum', 0.0217, 'lps'),
	(511108, 127, '2014-02-01 00:43:37.000000', 'consum', 0.0215, 'lps'),
	(511109, 127, '2014-02-01 00:43:38.000000', 'consum', 0.0216, 'lps'),
	(511110, 127, '2014-02-01 00:43:39.000000', 'consum', 0.0223, 'lps'),
	(511111, 127, '2014-02-01 00:43:40.000000', 'consum', 0.0210, 'lps'),
	(511112, 127, '2014-02-01 00:43:41.000000', 'consum', 0.0221, 'lps'),
	(511113, 127, '2014-02-01 00:43:42.000000', 'consum', 0.0218, 'lps'),
	(511114, 127, '2014-02-01 00:43:43.000000', 'consum', 0.0215, 'lps'),
	(511115, 127, '2014-02-01 00:43:44.000000', 'consum', 0.0215, 'lps'),
	(511116, 127, '2014-02-01 00:43:45.000000', 'consum', 0.0218, 'lps'),
	(511117, 127, '2014-02-01 00:43:46.000000', 'consum', 0.0219, 'lps'),
	(511118, 127, '2014-02-01 00:43:47.000000', 'consum', 0.0214, 'lps'),
	(511119, 127, '2014-02-01 00:43:48.000000', 'consum', 0.0222, 'lps'),
	(511120, 127, '2014-02-01 00:43:49.000000', 'consum', 0.0225, 'lps'),
	(511121, 127, '2014-02-01 00:43:50.000000', 'consum', 0.0218, 'lps'),
	(511122, 127, '2014-02-01 00:43:51.000000', 'consum', 0.0223, 'lps'),
	(511123, 127, '2014-02-01 00:43:52.000000', 'consum', 0.0217, 'lps'),
	(511124, 127, '2014-02-01 00:43:53.000000', 'consum', 0.0225, 'lps'),
	(511125, 127, '2014-02-01 00:43:54.000000', 'consum', 0.0216, 'lps'),
	(511126, 127, '2014-02-01 00:43:55.000000', 'consum', 0.0225, 'lps'),
	(511127, 127, '2014-02-01 00:43:56.000000', 'consum', 0.0221, 'lps'),
	(511128, 127, '2014-02-01 00:43:57.000000', 'consum', 0.0221, 'lps'),
	(511129, 127, '2014-02-01 00:43:58.000000', 'consum', 0.0216, 'lps'),
	(511130, 127, '2014-02-01 00:43:59.000000', 'consum', 0.0222, 'lps'),
	(511131, 127, '2014-02-01 00:44:00.000000', 'consum', 0.0223, 'lps'),
	(511132, 127, '2014-02-01 00:44:01.000000', 'consum', 0.0222, 'lps'),
	(511133, 127, '2014-02-01 00:44:02.000000', 'consum', 0.0214, 'lps'),
	(511134, 127, '2014-02-01 00:44:03.000000', 'consum', 0.0213, 'lps'),
	(511135, 127, '2014-02-01 00:44:04.000000', 'consum', 0.0213, 'lps'),
	(511136, 127, '2014-02-01 00:44:05.000000', 'consum', 0.0217, 'lps'),
	(511137, 127, '2014-02-01 00:44:06.000000', 'consum', 0.0218, 'lps'),
	(511138, 127, '2014-02-01 00:44:07.000000', 'consum', 0.0215, 'lps'),
	(511139, 127, '2014-02-01 00:44:08.000000', 'consum', 0.0213, 'lps'),
	(511140, 127, '2014-02-01 00:44:09.000000', 'consum', 0.0225, 'lps'),
	(511141, 127, '2014-02-01 00:44:10.000000', 'consum', 0.0215, 'lps'),
	(511142, 127, '2014-02-01 00:44:11.000000', 'consum', 0.0220, 'lps'),
	(511143, 127, '2014-02-01 00:44:12.000000', 'consum', 0.0216, 'lps'),
	(511144, 127, '2014-02-01 00:44:13.000000', 'consum', 0.0210, 'lps'),
	(511145, 127, '2014-02-01 00:44:14.000000', 'consum', 0.0225, 'lps'),
	(511146, 127, '2014-02-01 00:44:15.000000', 'consum', 0.0219, 'lps'),
	(511147, 127, '2014-02-01 00:44:16.000000', 'consum', 0.0214, 'lps'),
	(511148, 127, '2014-02-01 00:44:17.000000', 'consum', 0.0216, 'lps'),
	(511149, 127, '2014-02-01 00:44:18.000000', 'consum', 0.0214, 'lps'),
	(511150, 127, '2014-02-01 00:44:19.000000', 'consum', 0.0212, 'lps'),
	(511151, 127, '2014-02-01 00:44:20.000000', 'consum', 0.0225, 'lps'),
	(511152, 127, '2014-02-01 00:44:21.000000', 'consum', 0.0216, 'lps'),
	(511153, 127, '2014-02-01 00:44:22.000000', 'consum', 0.0213, 'lps'),
	(511154, 127, '2014-02-01 00:44:23.000000', 'consum', 0.0223, 'lps'),
	(511155, 127, '2014-02-01 00:44:24.000000', 'consum', 0.0217, 'lps'),
	(511156, 127, '2014-02-01 00:44:25.000000', 'consum', 0.0224, 'lps'),
	(511157, 127, '2014-02-01 00:44:26.000000', 'consum', 0.0211, 'lps'),
	(511158, 127, '2014-02-01 00:44:27.000000', 'consum', 0.0220, 'lps'),
	(511159, 127, '2014-02-01 00:44:28.000000', 'consum', 0.0210, 'lps'),
	(511160, 127, '2014-02-01 00:44:29.000000', 'consum', 0.0215, 'lps'),
	(511161, 127, '2014-02-01 00:44:30.000000', 'consum', 0.0217, 'lps'),
	(511162, 127, '2014-02-01 00:44:31.000000', 'consum', 0.0213, 'lps'),
	(511163, 127, '2014-02-01 00:44:32.000000', 'consum', 0.0224, 'lps'),
	(511164, 127, '2014-02-01 00:44:33.000000', 'consum', 0.0221, 'lps'),
	(511165, 127, '2014-02-01 00:44:34.000000', 'consum', 0.0225, 'lps'),
	(511166, 127, '2014-02-01 00:44:35.000000', 'consum', 0.0222, 'lps'),
	(511167, 127, '2014-02-01 00:44:36.000000', 'consum', 0.0224, 'lps'),
	(511168, 127, '2014-02-01 00:44:37.000000', 'consum', 0.0210, 'lps'),
	(511169, 127, '2014-02-01 00:44:38.000000', 'consum', 0.0220, 'lps'),
	(511170, 127, '2014-02-01 00:44:39.000000', 'consum', 0.0213, 'lps'),
	(511171, 127, '2014-02-01 00:44:40.000000', 'consum', 0.0210, 'lps'),
	(511172, 127, '2014-02-01 00:44:41.000000', 'consum', 0.0218, 'lps'),
	(511173, 127, '2014-02-01 00:44:42.000000', 'consum', 0.0219, 'lps'),
	(511174, 127, '2014-02-01 00:44:43.000000', 'consum', 0.0215, 'lps'),
	(511175, 127, '2014-02-01 00:44:44.000000', 'consum', 0.0210, 'lps'),
	(511176, 127, '2014-02-01 00:44:45.000000', 'consum', 0.0211, 'lps'),
	(511177, 127, '2014-02-01 00:44:46.000000', 'consum', 0.0214, 'lps'),
	(511178, 127, '2014-02-01 00:44:47.000000', 'consum', 0.0213, 'lps'),
	(511179, 127, '2014-02-01 00:44:48.000000', 'consum', 0.0213, 'lps'),
	(511180, 127, '2014-02-01 00:44:49.000000', 'consum', 0.0218, 'lps'),
	(511181, 127, '2014-02-01 00:44:50.000000', 'consum', 0.0223, 'lps'),
	(511182, 127, '2014-02-01 00:44:51.000000', 'consum', 0.0220, 'lps'),
	(511183, 127, '2014-02-01 00:44:52.000000', 'consum', 0.0224, 'lps'),
	(511184, 127, '2014-02-01 00:44:53.000000', 'consum', 0.0217, 'lps'),
	(511185, 127, '2014-02-01 00:44:54.000000', 'consum', 0.0219, 'lps'),
	(511186, 127, '2014-02-01 00:44:55.000000', 'consum', 0.0220, 'lps'),
	(511187, 127, '2014-02-01 00:44:56.000000', 'consum', 0.0215, 'lps'),
	(511188, 127, '2014-02-01 00:44:57.000000', 'consum', 0.0222, 'lps'),
	(511189, 127, '2014-02-01 00:44:58.000000', 'consum', 0.0224, 'lps'),
	(511190, 127, '2014-02-01 00:44:59.000000', 'consum', 0.0214, 'lps'),
	(511191, 127, '2014-02-01 00:45:00.000000', 'consum', 0.0219, 'lps'),
	(511192, 127, '2014-02-01 00:45:01.000000', 'consum', 0.0211, 'lps'),
	(511193, 127, '2014-02-01 00:45:02.000000', 'consum', 0.0221, 'lps'),
	(511194, 127, '2014-02-01 00:45:03.000000', 'consum', 0.0213, 'lps'),
	(511195, 127, '2014-02-01 00:45:04.000000', 'consum', 0.0225, 'lps'),
	(511196, 127, '2014-02-01 00:45:05.000000', 'consum', 0.0212, 'lps'),
	(511197, 127, '2014-02-01 00:45:06.000000', 'consum', 0.0224, 'lps'),
	(511198, 127, '2014-02-01 00:45:07.000000', 'consum', 0.0211, 'lps'),
	(511199, 127, '2014-02-01 00:45:08.000000', 'consum', 0.0221, 'lps'),
	(511200, 127, '2014-02-01 00:45:09.000000', 'consum', 0.0216, 'lps'),
	(511201, 127, '2014-02-01 00:45:10.000000', 'consum', 0.0223, 'lps'),
	(511202, 127, '2014-02-01 00:45:11.000000', 'consum', 0.0223, 'lps'),
	(511203, 127, '2014-02-01 00:45:12.000000', 'consum', 0.0223, 'lps'),
	(511204, 127, '2014-02-01 00:45:13.000000', 'consum', 0.0219, 'lps'),
	(511205, 127, '2014-02-01 00:45:14.000000', 'consum', 0.0217, 'lps'),
	(511206, 127, '2014-02-01 00:45:15.000000', 'consum', 0.0220, 'lps'),
	(511207, 127, '2014-02-01 00:45:16.000000', 'consum', 0.0221, 'lps'),
	(511208, 127, '2014-02-01 00:45:17.000000', 'consum', 0.0222, 'lps'),
	(511209, 127, '2014-02-01 00:45:18.000000', 'consum', 0.0221, 'lps'),
	(511210, 127, '2014-02-01 00:45:19.000000', 'consum', 0.0213, 'lps'),
	(511211, 127, '2014-02-01 00:45:20.000000', 'consum', 0.0224, 'lps'),
	(511212, 127, '2014-02-01 00:45:21.000000', 'consum', 0.0224, 'lps'),
	(511213, 127, '2014-02-01 00:45:22.000000', 'consum', 0.0223, 'lps'),
	(511214, 127, '2014-02-01 00:45:23.000000', 'consum', 0.0215, 'lps'),
	(511215, 127, '2014-02-01 00:45:24.000000', 'consum', 0.0215, 'lps'),
	(511216, 127, '2014-02-01 00:45:25.000000', 'consum', 0.0222, 'lps'),
	(511217, 127, '2014-02-01 00:45:26.000000', 'consum', 0.0221, 'lps'),
	(511218, 127, '2014-02-01 00:45:27.000000', 'consum', 0.0216, 'lps'),
	(511219, 127, '2014-02-01 00:45:28.000000', 'consum', 0.0222, 'lps'),
	(511220, 127, '2014-02-01 00:45:29.000000', 'consum', 0.0221, 'lps'),
	(511221, 127, '2014-02-01 00:45:30.000000', 'consum', 0.0212, 'lps'),
	(511222, 127, '2014-02-01 00:45:31.000000', 'consum', 0.0222, 'lps'),
	(511223, 127, '2014-02-01 00:45:32.000000', 'consum', 0.0214, 'lps'),
	(511224, 127, '2014-02-01 00:45:33.000000', 'consum', 0.0211, 'lps'),
	(511225, 127, '2014-02-01 00:45:34.000000', 'consum', 0.0219, 'lps'),
	(511226, 127, '2014-02-01 00:45:35.000000', 'consum', 0.0222, 'lps'),
	(511227, 127, '2014-02-01 00:45:36.000000', 'consum', 0.0212, 'lps'),
	(511228, 127, '2014-02-01 00:45:37.000000', 'consum', 0.0214, 'lps'),
	(511229, 127, '2014-02-01 00:45:38.000000', 'consum', 0.0212, 'lps'),
	(511230, 127, '2014-02-01 00:45:39.000000', 'consum', 0.0222, 'lps'),
	(511231, 127, '2014-02-01 00:45:40.000000', 'consum', 0.0216, 'lps'),
	(511232, 127, '2014-02-01 00:45:41.000000', 'consum', 0.0220, 'lps'),
	(511233, 127, '2014-02-01 00:45:42.000000', 'consum', 0.0211, 'lps'),
	(511234, 127, '2014-02-01 00:45:43.000000', 'consum', 0.0218, 'lps'),
	(511235, 127, '2014-02-01 00:45:44.000000', 'consum', 0.0215, 'lps'),
	(511236, 127, '2014-02-01 00:45:45.000000', 'consum', 0.0210, 'lps'),
	(511237, 127, '2014-02-01 00:45:46.000000', 'consum', 0.0214, 'lps'),
	(511238, 127, '2014-02-01 00:45:47.000000', 'consum', 0.0212, 'lps'),
	(511239, 127, '2014-02-01 00:45:48.000000', 'consum', 0.0210, 'lps'),
	(511240, 127, '2014-02-01 00:45:49.000000', 'consum', 0.0221, 'lps'),
	(511241, 127, '2014-02-01 00:45:50.000000', 'consum', 0.0217, 'lps'),
	(511242, 127, '2014-02-01 00:45:51.000000', 'consum', 0.0214, 'lps'),
	(511243, 127, '2014-02-01 00:45:52.000000', 'consum', 0.0222, 'lps'),
	(511244, 127, '2014-02-01 00:45:53.000000', 'consum', 0.0214, 'lps'),
	(511245, 127, '2014-02-01 00:45:54.000000', 'consum', 0.0223, 'lps'),
	(511246, 127, '2014-02-01 00:45:55.000000', 'consum', 0.0219, 'lps'),
	(511247, 127, '2014-02-01 00:45:56.000000', 'consum', 0.0216, 'lps'),
	(511248, 127, '2014-02-01 00:45:57.000000', 'consum', 0.0213, 'lps'),
	(511249, 127, '2014-02-01 00:45:58.000000', 'consum', 0.0221, 'lps'),
	(511250, 127, '2014-02-01 00:45:59.000000', 'consum', 0.0212, 'lps'),
	(511251, 127, '2014-02-01 00:46:00.000000', 'consum', 0.0217, 'lps'),
	(511252, 127, '2014-02-01 00:46:01.000000', 'consum', 0.0210, 'lps'),
	(511253, 127, '2014-02-01 00:46:02.000000', 'consum', 0.0221, 'lps'),
	(511254, 127, '2014-02-01 00:46:03.000000', 'consum', 0.0218, 'lps'),
	(511255, 127, '2014-02-01 00:46:04.000000', 'consum', 0.0215, 'lps'),
	(511256, 127, '2014-02-01 00:46:05.000000', 'consum', 0.0214, 'lps'),
	(511257, 127, '2014-02-01 00:46:06.000000', 'consum', 0.0214, 'lps'),
	(511258, 127, '2014-02-01 00:46:07.000000', 'consum', 0.0218, 'lps'),
	(511259, 127, '2014-02-01 00:46:08.000000', 'consum', 0.0222, 'lps'),
	(511260, 127, '2014-02-01 00:46:09.000000', 'consum', 0.0217, 'lps'),
	(511261, 127, '2014-02-01 00:46:10.000000', 'consum', 0.0223, 'lps'),
	(511262, 127, '2014-02-01 00:46:11.000000', 'consum', 0.0224, 'lps'),
	(511263, 127, '2014-02-01 00:46:12.000000', 'consum', 0.0210, 'lps'),
	(511264, 127, '2014-02-01 00:46:13.000000', 'consum', 0.0214, 'lps'),
	(511265, 127, '2014-02-01 00:46:14.000000', 'consum', 0.0217, 'lps'),
	(511266, 127, '2014-02-01 00:46:15.000000', 'consum', 0.0218, 'lps'),
	(511267, 127, '2014-02-01 00:46:16.000000', 'consum', 0.0212, 'lps'),
	(511268, 127, '2014-02-01 00:46:17.000000', 'consum', 0.0214, 'lps'),
	(511269, 127, '2014-02-01 00:46:18.000000', 'consum', 0.0210, 'lps'),
	(511270, 127, '2014-02-01 00:46:19.000000', 'consum', 0.0212, 'lps'),
	(511271, 127, '2014-02-01 00:46:20.000000', 'consum', 0.0220, 'lps'),
	(511272, 127, '2014-02-01 00:46:21.000000', 'consum', 0.0223, 'lps'),
	(511273, 127, '2014-02-01 00:46:22.000000', 'consum', 0.0214, 'lps'),
	(511274, 127, '2014-02-01 00:46:23.000000', 'consum', 0.0222, 'lps'),
	(511275, 127, '2014-02-01 00:46:24.000000', 'consum', 0.0225, 'lps'),
	(511276, 127, '2014-02-01 00:46:25.000000', 'consum', 0.0221, 'lps'),
	(511277, 127, '2014-02-01 00:46:26.000000', 'consum', 0.0220, 'lps'),
	(511278, 127, '2014-02-01 00:46:27.000000', 'consum', 0.0213, 'lps'),
	(511279, 127, '2014-02-01 00:46:28.000000', 'consum', 0.0224, 'lps'),
	(511280, 127, '2014-02-01 00:46:29.000000', 'consum', 0.0225, 'lps'),
	(511281, 127, '2014-02-01 00:46:30.000000', 'consum', 0.0213, 'lps'),
	(511282, 127, '2014-02-01 00:46:31.000000', 'consum', 0.0213, 'lps'),
	(511283, 127, '2014-02-01 00:46:32.000000', 'consum', 0.0216, 'lps'),
	(511284, 127, '2014-02-01 00:46:33.000000', 'consum', 0.0215, 'lps'),
	(511285, 127, '2014-02-01 00:46:34.000000', 'consum', 0.0216, 'lps'),
	(511286, 127, '2014-02-01 00:46:35.000000', 'consum', 0.0225, 'lps'),
	(511287, 127, '2014-02-01 00:46:36.000000', 'consum', 0.0220, 'lps'),
	(511288, 127, '2014-02-01 00:46:37.000000', 'consum', 0.0215, 'lps'),
	(511289, 127, '2014-02-01 00:46:38.000000', 'consum', 0.0224, 'lps'),
	(511290, 127, '2014-02-01 00:46:39.000000', 'consum', 0.0214, 'lps'),
	(511291, 127, '2014-02-01 00:46:40.000000', 'consum', 0.0223, 'lps'),
	(511292, 127, '2014-02-01 00:46:41.000000', 'consum', 0.0215, 'lps'),
	(511293, 127, '2014-02-01 00:46:42.000000', 'consum', 0.0212, 'lps'),
	(511294, 127, '2014-02-01 00:46:43.000000', 'consum', 0.0224, 'lps'),
	(511295, 127, '2014-02-01 00:46:44.000000', 'consum', 0.0223, 'lps'),
	(511296, 127, '2014-02-01 00:46:45.000000', 'consum', 0.0219, 'lps'),
	(511297, 127, '2014-02-01 00:46:46.000000', 'consum', 0.0218, 'lps'),
	(511298, 127, '2014-02-01 00:46:47.000000', 'consum', 0.0221, 'lps'),
	(511299, 127, '2014-02-01 00:46:48.000000', 'consum', 0.0212, 'lps'),
	(511300, 127, '2014-02-01 00:46:49.000000', 'consum', 0.0219, 'lps'),
	(511301, 127, '2014-02-01 00:46:50.000000', 'consum', 0.0219, 'lps'),
	(511302, 127, '2014-02-01 00:46:51.000000', 'consum', 0.0211, 'lps'),
	(511303, 127, '2014-02-01 00:46:52.000000', 'consum', 0.0221, 'lps'),
	(511304, 127, '2014-02-01 00:46:53.000000', 'consum', 0.0214, 'lps'),
	(511305, 127, '2014-02-01 00:46:54.000000', 'consum', 0.0212, 'lps'),
	(511306, 127, '2014-02-01 00:46:55.000000', 'consum', 0.0225, 'lps'),
	(511307, 127, '2014-02-01 00:46:56.000000', 'consum', 0.0214, 'lps'),
	(511308, 127, '2014-02-01 00:46:57.000000', 'consum', 0.0219, 'lps'),
	(511309, 127, '2014-02-01 00:46:58.000000', 'consum', 0.0213, 'lps'),
	(511310, 127, '2014-02-01 00:46:59.000000', 'consum', 0.0215, 'lps'),
	(511311, 127, '2014-02-01 00:47:00.000000', 'consum', 0.0225, 'lps'),
	(511312, 127, '2014-02-01 00:47:01.000000', 'consum', 0.0222, 'lps'),
	(511313, 127, '2014-02-01 00:47:02.000000', 'consum', 0.0211, 'lps'),
	(511314, 127, '2014-02-01 00:47:03.000000', 'consum', 0.0225, 'lps'),
	(511315, 127, '2014-02-01 00:47:04.000000', 'consum', 0.0220, 'lps'),
	(511316, 127, '2014-02-01 00:47:05.000000', 'consum', 0.0214, 'lps'),
	(511317, 127, '2014-02-01 00:47:06.000000', 'consum', 0.0215, 'lps'),
	(511318, 127, '2014-02-01 00:47:07.000000', 'consum', 0.0211, 'lps'),
	(511319, 127, '2014-02-01 00:47:08.000000', 'consum', 0.0214, 'lps'),
	(511320, 127, '2014-02-01 00:47:09.000000', 'consum', 0.0212, 'lps'),
	(511321, 127, '2014-02-01 00:47:10.000000', 'consum', 0.0210, 'lps'),
	(511322, 127, '2014-02-01 00:47:11.000000', 'consum', 0.0221, 'lps'),
	(511323, 127, '2014-02-01 00:47:12.000000', 'consum', 0.0217, 'lps'),
	(511324, 127, '2014-02-01 00:47:13.000000', 'consum', 0.0214, 'lps'),
	(511325, 127, '2014-02-01 00:47:14.000000', 'consum', 0.0222, 'lps'),
	(511326, 127, '2014-02-01 00:47:15.000000', 'consum', 0.0213, 'lps'),
	(511327, 127, '2014-02-01 00:47:16.000000', 'consum', 0.0219, 'lps'),
	(511328, 127, '2014-02-01 00:47:17.000000', 'consum', 0.0217, 'lps'),
	(511329, 127, '2014-02-01 00:47:18.000000', 'consum', 0.0217, 'lps'),
	(511330, 127, '2014-02-01 00:47:19.000000', 'consum', 0.0210, 'lps'),
	(511331, 127, '2014-02-01 00:47:20.000000', 'consum', 0.0223, 'lps'),
	(511332, 127, '2014-02-01 00:47:21.000000', 'consum', 0.0225, 'lps'),
	(511333, 127, '2014-02-01 00:47:22.000000', 'consum', 0.0214, 'lps'),
	(511334, 127, '2014-02-01 00:47:23.000000', 'consum', 0.0220, 'lps'),
	(511335, 127, '2014-02-01 00:47:24.000000', 'consum', 0.0215, 'lps'),
	(511336, 127, '2014-02-01 00:47:25.000000', 'consum', 0.0221, 'lps'),
	(511337, 127, '2014-02-01 00:47:26.000000', 'consum', 0.0219, 'lps'),
	(511338, 127, '2014-02-01 00:47:27.000000', 'consum', 0.0220, 'lps'),
	(511339, 127, '2014-02-01 00:47:28.000000', 'consum', 0.0221, 'lps'),
	(511340, 127, '2014-02-01 00:47:29.000000', 'consum', 0.0218, 'lps'),
	(511341, 127, '2014-02-01 00:47:30.000000', 'consum', 0.0219, 'lps'),
	(511342, 127, '2014-02-01 00:47:31.000000', 'consum', 0.0213, 'lps'),
	(511343, 127, '2014-02-01 00:47:32.000000', 'consum', 0.0215, 'lps'),
	(511344, 127, '2014-02-01 00:47:33.000000', 'consum', 0.0225, 'lps'),
	(511345, 127, '2014-02-01 00:47:34.000000', 'consum', 0.0224, 'lps'),
	(511346, 127, '2014-02-01 00:47:35.000000', 'consum', 0.0218, 'lps'),
	(511347, 127, '2014-02-01 00:47:36.000000', 'consum', 0.0210, 'lps'),
	(511348, 127, '2014-02-01 00:47:37.000000', 'consum', 0.0217, 'lps'),
	(511349, 127, '2014-02-01 00:47:38.000000', 'consum', 0.0213, 'lps'),
	(511350, 127, '2014-02-01 00:47:39.000000', 'consum', 0.0221, 'lps'),
	(511351, 127, '2014-02-01 00:47:40.000000', 'consum', 0.0210, 'lps'),
	(511352, 127, '2014-02-01 00:47:41.000000', 'consum', 0.0224, 'lps'),
	(511353, 127, '2014-02-01 00:47:42.000000', 'consum', 0.0217, 'lps'),
	(511354, 127, '2014-02-01 00:47:43.000000', 'consum', 0.0217, 'lps'),
	(511355, 127, '2014-02-01 00:47:44.000000', 'consum', 0.0212, 'lps'),
	(511356, 127, '2014-02-01 00:47:45.000000', 'consum', 0.0215, 'lps'),
	(511357, 127, '2014-02-01 00:47:46.000000', 'consum', 0.0212, 'lps'),
	(511358, 127, '2014-02-01 00:47:47.000000', 'consum', 0.0224, 'lps'),
	(511359, 127, '2014-02-01 00:47:48.000000', 'consum', 0.0225, 'lps'),
	(511360, 127, '2014-02-01 00:47:49.000000', 'consum', 0.0212, 'lps'),
	(511361, 127, '2014-02-01 00:47:50.000000', 'consum', 0.0222, 'lps'),
	(511362, 127, '2014-02-01 00:47:51.000000', 'consum', 0.0216, 'lps'),
	(511363, 127, '2014-02-01 00:47:52.000000', 'consum', 0.0222, 'lps'),
	(511364, 127, '2014-02-01 00:47:53.000000', 'consum', 0.0220, 'lps'),
	(511365, 127, '2014-02-01 00:47:54.000000', 'consum', 0.0223, 'lps'),
	(511366, 127, '2014-02-01 00:47:55.000000', 'consum', 0.0213, 'lps'),
	(511367, 127, '2014-02-01 00:47:56.000000', 'consum', 0.0218, 'lps'),
	(511368, 127, '2014-02-01 00:47:57.000000', 'consum', 0.0211, 'lps'),
	(511369, 127, '2014-02-01 00:47:58.000000', 'consum', 0.0223, 'lps'),
	(511370, 127, '2014-02-01 00:47:59.000000', 'consum', 0.0210, 'lps'),
	(511371, 127, '2014-02-01 00:48:00.000000', 'consum', 0.0220, 'lps'),
	(511372, 127, '2014-02-01 00:48:01.000000', 'consum', 0.0211, 'lps'),
	(511373, 127, '2014-02-01 00:48:02.000000', 'consum', 0.0219, 'lps'),
	(511374, 127, '2014-02-01 00:48:03.000000', 'consum', 0.0219, 'lps'),
	(511375, 127, '2014-02-01 00:48:04.000000', 'consum', 0.0213, 'lps'),
	(511376, 127, '2014-02-01 00:48:05.000000', 'consum', 0.0215, 'lps'),
	(511377, 127, '2014-02-01 00:48:06.000000', 'consum', 0.0212, 'lps'),
	(511378, 127, '2014-02-01 00:48:07.000000', 'consum', 0.0219, 'lps'),
	(511379, 127, '2014-02-01 00:48:08.000000', 'consum', 0.0220, 'lps'),
	(511380, 127, '2014-02-01 00:48:09.000000', 'consum', 0.0216, 'lps'),
	(511381, 127, '2014-02-01 00:48:10.000000', 'consum', 0.0213, 'lps'),
	(511382, 127, '2014-02-01 00:48:11.000000', 'consum', 0.0221, 'lps'),
	(511383, 127, '2014-02-01 00:48:12.000000', 'consum', 0.0211, 'lps'),
	(511384, 127, '2014-02-01 00:48:13.000000', 'consum', 0.0212, 'lps'),
	(511385, 127, '2014-02-01 00:48:14.000000', 'consum', 0.0218, 'lps'),
	(511386, 127, '2014-02-01 00:48:15.000000', 'consum', 0.0212, 'lps'),
	(511387, 127, '2014-02-01 00:48:16.000000', 'consum', 0.0214, 'lps'),
	(511388, 127, '2014-02-01 00:48:17.000000', 'consum', 0.0210, 'lps'),
	(511389, 127, '2014-02-01 00:48:18.000000', 'consum', 0.0211, 'lps'),
	(511390, 127, '2014-02-01 00:48:19.000000', 'consum', 0.0218, 'lps'),
	(511391, 127, '2014-02-01 00:48:20.000000', 'consum', 0.0213, 'lps'),
	(511392, 127, '2014-02-01 00:48:21.000000', 'consum', 0.0220, 'lps'),
	(511393, 127, '2014-02-01 00:48:22.000000', 'consum', 0.0218, 'lps'),
	(511394, 127, '2014-02-01 00:48:23.000000', 'consum', 0.0219, 'lps'),
	(511395, 127, '2014-02-01 00:48:24.000000', 'consum', 0.0218, 'lps'),
	(511396, 127, '2014-02-01 00:48:25.000000', 'consum', 0.0221, 'lps'),
	(511397, 127, '2014-02-01 00:48:26.000000', 'consum', 0.0210, 'lps'),
	(511398, 127, '2014-02-01 00:48:27.000000', 'consum', 0.0211, 'lps'),
	(511399, 127, '2014-02-01 00:48:28.000000', 'consum', 0.0213, 'lps'),
	(511400, 127, '2014-02-01 00:48:29.000000', 'consum', 0.0224, 'lps'),
	(511401, 127, '2014-02-01 00:48:30.000000', 'consum', 0.0224, 'lps'),
	(511402, 127, '2014-02-01 00:48:31.000000', 'consum', 0.0224, 'lps'),
	(511403, 127, '2014-02-01 00:48:32.000000', 'consum', 0.0221, 'lps'),
	(511404, 127, '2014-02-01 00:48:33.000000', 'consum', 0.0224, 'lps'),
	(511405, 127, '2014-02-01 00:48:34.000000', 'consum', 0.0215, 'lps'),
	(511406, 127, '2014-02-01 00:48:35.000000', 'consum', 0.0212, 'lps'),
	(511407, 127, '2014-02-01 00:48:36.000000', 'consum', 0.0218, 'lps'),
	(511408, 127, '2014-02-01 00:48:37.000000', 'consum', 0.0216, 'lps'),
	(511409, 127, '2014-02-01 00:48:38.000000', 'consum', 0.0214, 'lps'),
	(511410, 127, '2014-02-01 00:48:39.000000', 'consum', 0.0212, 'lps'),
	(511411, 127, '2014-02-01 00:48:40.000000', 'consum', 0.0210, 'lps'),
	(511412, 127, '2014-02-01 00:48:41.000000', 'consum', 0.0220, 'lps'),
	(511413, 127, '2014-02-01 00:48:42.000000', 'consum', 0.0212, 'lps'),
	(511414, 127, '2014-02-01 00:48:43.000000', 'consum', 0.0221, 'lps'),
	(511415, 127, '2014-02-01 00:48:44.000000', 'consum', 0.0214, 'lps'),
	(511416, 127, '2014-02-01 00:48:45.000000', 'consum', 0.0214, 'lps'),
	(511417, 127, '2014-02-01 00:48:46.000000', 'consum', 0.0218, 'lps'),
	(511418, 127, '2014-02-01 00:48:47.000000', 'consum', 0.0223, 'lps'),
	(511419, 127, '2014-02-01 00:48:48.000000', 'consum', 0.0221, 'lps'),
	(511420, 127, '2014-02-01 00:48:49.000000', 'consum', 0.0224, 'lps'),
	(511421, 127, '2014-02-01 00:48:50.000000', 'consum', 0.0216, 'lps'),
	(511422, 127, '2014-02-01 00:48:51.000000', 'consum', 0.0213, 'lps'),
	(511423, 127, '2014-02-01 00:48:52.000000', 'consum', 0.0210, 'lps'),
	(511424, 127, '2014-02-01 00:48:53.000000', 'consum', 0.0216, 'lps'),
	(511425, 127, '2014-02-01 00:48:54.000000', 'consum', 0.0223, 'lps'),
	(511426, 127, '2014-02-01 00:48:55.000000', 'consum', 0.0213, 'lps'),
	(511427, 127, '2014-02-01 00:48:56.000000', 'consum', 0.0217, 'lps'),
	(511428, 127, '2014-02-01 00:48:57.000000', 'consum', 0.0220, 'lps'),
	(511429, 127, '2014-02-01 00:48:58.000000', 'consum', 0.0222, 'lps'),
	(511430, 127, '2014-02-01 00:48:59.000000', 'consum', 0.0211, 'lps'),
	(511431, 127, '2014-02-01 00:49:00.000000', 'consum', 0.0225, 'lps'),
	(511432, 127, '2014-02-01 00:49:01.000000', 'consum', 0.0218, 'lps'),
	(511433, 127, '2014-02-01 00:49:02.000000', 'consum', 0.0223, 'lps'),
	(511434, 127, '2014-02-01 00:49:03.000000', 'consum', 0.0218, 'lps'),
	(511435, 127, '2014-02-01 00:49:04.000000', 'consum', 0.0213, 'lps'),
	(511436, 127, '2014-02-01 00:49:05.000000', 'consum', 0.0219, 'lps'),
	(511437, 127, '2014-02-01 00:49:06.000000', 'consum', 0.0213, 'lps'),
	(511438, 127, '2014-02-01 00:49:07.000000', 'consum', 0.0213, 'lps'),
	(511439, 127, '2014-02-01 00:49:08.000000', 'consum', 0.0218, 'lps'),
	(511440, 127, '2014-02-01 00:49:09.000000', 'consum', 0.0210, 'lps'),
	(511441, 127, '2014-02-01 00:49:10.000000', 'consum', 0.0220, 'lps'),
	(511442, 127, '2014-02-01 00:49:11.000000', 'consum', 0.0210, 'lps'),
	(511443, 127, '2014-02-01 00:49:12.000000', 'consum', 0.0215, 'lps'),
	(511444, 127, '2014-02-01 00:49:13.000000', 'consum', 0.0220, 'lps'),
	(511445, 127, '2014-02-01 00:49:14.000000', 'consum', 0.0212, 'lps'),
	(511446, 127, '2014-02-01 00:49:15.000000', 'consum', 0.0223, 'lps'),
	(511447, 127, '2014-02-01 00:49:16.000000', 'consum', 0.0219, 'lps'),
	(511448, 127, '2014-02-01 00:49:17.000000', 'consum', 0.0219, 'lps'),
	(511449, 127, '2014-02-01 00:49:18.000000', 'consum', 0.0213, 'lps'),
	(511450, 127, '2014-02-01 00:49:19.000000', 'consum', 0.0216, 'lps'),
	(511451, 127, '2014-02-01 00:49:20.000000', 'consum', 0.0212, 'lps'),
	(511452, 127, '2014-02-01 00:49:21.000000', 'consum', 0.0221, 'lps'),
	(511453, 127, '2014-02-01 00:49:22.000000', 'consum', 0.0225, 'lps'),
	(511454, 127, '2014-02-01 00:49:23.000000', 'consum', 0.0223, 'lps'),
	(511455, 127, '2014-02-01 00:49:24.000000', 'consum', 0.0215, 'lps'),
	(511456, 127, '2014-02-01 00:49:25.000000', 'consum', 0.0210, 'lps'),
	(511457, 127, '2014-02-01 00:49:26.000000', 'consum', 0.0211, 'lps'),
	(511458, 127, '2014-02-01 00:49:27.000000', 'consum', 0.0217, 'lps'),
	(511459, 127, '2014-02-01 00:49:28.000000', 'consum', 0.0211, 'lps'),
	(511460, 127, '2014-02-01 00:49:29.000000', 'consum', 0.0225, 'lps'),
	(511461, 127, '2014-02-01 00:49:30.000000', 'consum', 0.0218, 'lps'),
	(511462, 127, '2014-02-01 00:49:31.000000', 'consum', 0.0224, 'lps'),
	(511463, 127, '2014-02-01 00:49:32.000000', 'consum', 0.0222, 'lps'),
	(511464, 127, '2014-02-01 00:49:33.000000', 'consum', 0.0213, 'lps'),
	(511465, 127, '2014-02-01 00:49:34.000000', 'consum', 0.0220, 'lps'),
	(511466, 127, '2014-02-01 00:49:35.000000', 'consum', 0.0220, 'lps'),
	(511467, 127, '2014-02-01 00:49:36.000000', 'consum', 0.0217, 'lps'),
	(511468, 127, '2014-02-01 00:49:37.000000', 'consum', 0.0214, 'lps'),
	(511469, 127, '2014-02-01 00:49:38.000000', 'consum', 0.0211, 'lps'),
	(511470, 127, '2014-02-01 00:49:39.000000', 'consum', 0.0217, 'lps'),
	(511471, 127, '2014-02-01 00:49:40.000000', 'consum', 0.0213, 'lps'),
	(511472, 127, '2014-02-01 00:49:41.000000', 'consum', 0.0219, 'lps'),
	(511473, 127, '2014-02-01 00:49:42.000000', 'consum', 0.0214, 'lps'),
	(511474, 127, '2014-02-01 00:49:43.000000', 'consum', 0.0219, 'lps'),
	(511475, 127, '2014-02-01 00:49:44.000000', 'consum', 0.0212, 'lps'),
	(511476, 127, '2014-02-01 00:49:45.000000', 'consum', 0.0224, 'lps'),
	(511477, 127, '2014-02-01 00:49:46.000000', 'consum', 0.0213, 'lps'),
	(511478, 127, '2014-02-01 00:49:47.000000', 'consum', 0.0216, 'lps'),
	(511479, 127, '2014-02-01 00:49:48.000000', 'consum', 0.0213, 'lps'),
	(511480, 127, '2014-02-01 00:49:49.000000', 'consum', 0.0223, 'lps'),
	(511481, 127, '2014-02-01 00:49:50.000000', 'consum', 0.0220, 'lps'),
	(511482, 127, '2014-02-01 00:49:51.000000', 'consum', 0.0220, 'lps'),
	(511483, 127, '2014-02-01 00:49:52.000000', 'consum', 0.0216, 'lps'),
	(511484, 127, '2014-02-01 00:49:53.000000', 'consum', 0.0225, 'lps'),
	(511485, 127, '2014-02-01 00:49:54.000000', 'consum', 0.0222, 'lps'),
	(511486, 127, '2014-02-01 00:49:55.000000', 'consum', 0.0225, 'lps'),
	(511487, 127, '2014-02-01 00:49:56.000000', 'consum', 0.0216, 'lps'),
	(511488, 127, '2014-02-01 00:49:57.000000', 'consum', 0.0212, 'lps'),
	(511489, 127, '2014-02-01 00:49:58.000000', 'consum', 0.0220, 'lps'),
	(511490, 127, '2014-02-01 00:49:59.000000', 'consum', 0.0223, 'lps'),
	(511491, 127, '2014-02-01 00:50:00.000000', 'consum', 0.0213, 'lps'),
	(511492, 127, '2014-02-01 00:50:01.000000', 'consum', 0.0219, 'lps'),
	(511493, 127, '2014-02-01 00:50:02.000000', 'consum', 0.0214, 'lps'),
	(511494, 127, '2014-02-01 00:50:03.000000', 'consum', 0.0219, 'lps'),
	(511495, 127, '2014-02-01 00:50:04.000000', 'consum', 0.0214, 'lps'),
	(511496, 127, '2014-02-01 00:50:05.000000', 'consum', 0.0218, 'lps'),
	(511497, 127, '2014-02-01 00:50:06.000000', 'consum', 0.0221, 'lps'),
	(511498, 127, '2014-02-01 00:50:07.000000', 'consum', 0.0225, 'lps'),
	(511499, 127, '2014-02-01 00:50:08.000000', 'consum', 0.0221, 'lps'),
	(511500, 127, '2014-02-01 00:50:09.000000', 'consum', 0.0219, 'lps'),
	(511501, 127, '2014-02-01 00:50:10.000000', 'consum', 0.0225, 'lps'),
	(511502, 127, '2014-02-01 00:50:11.000000', 'consum', 0.0212, 'lps'),
	(511503, 127, '2014-02-01 00:50:12.000000', 'consum', 0.0220, 'lps'),
	(511504, 127, '2014-02-01 00:50:13.000000', 'consum', 0.0223, 'lps'),
	(511505, 127, '2014-02-01 00:50:14.000000', 'consum', 0.0215, 'lps'),
	(511506, 127, '2014-02-01 00:50:15.000000', 'consum', 0.0213, 'lps'),
	(511507, 127, '2014-02-01 00:50:16.000000', 'consum', 0.0210, 'lps'),
	(511508, 127, '2014-02-01 00:50:17.000000', 'consum', 0.0216, 'lps'),
	(511509, 127, '2014-02-01 00:50:18.000000', 'consum', 0.0224, 'lps'),
	(511510, 127, '2014-02-01 00:50:19.000000', 'consum', 0.0215, 'lps'),
	(511511, 127, '2014-02-01 00:50:20.000000', 'consum', 0.0225, 'lps'),
	(511512, 127, '2014-02-01 00:50:21.000000', 'consum', 0.0223, 'lps'),
	(511513, 127, '2014-02-01 00:50:22.000000', 'consum', 0.0215, 'lps'),
	(511514, 127, '2014-02-01 00:50:23.000000', 'consum', 0.0212, 'lps'),
	(511515, 127, '2014-02-01 00:50:24.000000', 'consum', 0.0220, 'lps'),
	(511516, 127, '2014-02-01 00:50:25.000000', 'consum', 0.0224, 'lps'),
	(511517, 127, '2014-02-01 00:50:26.000000', 'consum', 0.0219, 'lps'),
	(511518, 127, '2014-02-01 00:50:27.000000', 'consum', 0.0211, 'lps'),
	(511519, 127, '2014-02-01 00:50:28.000000', 'consum', 0.0222, 'lps'),
	(511520, 127, '2014-02-01 00:50:29.000000', 'consum', 0.0219, 'lps'),
	(511521, 127, '2014-02-01 00:50:30.000000', 'consum', 0.0219, 'lps'),
	(511522, 127, '2014-02-01 00:50:31.000000', 'consum', 0.0212, 'lps'),
	(511523, 127, '2014-02-01 00:50:32.000000', 'consum', 0.0210, 'lps'),
	(511524, 127, '2014-02-01 00:50:33.000000', 'consum', 0.0221, 'lps'),
	(511525, 127, '2014-02-01 00:50:34.000000', 'consum', 0.0216, 'lps'),
	(511526, 127, '2014-02-01 00:50:35.000000', 'consum', 0.0223, 'lps'),
	(511527, 127, '2014-02-01 00:50:36.000000', 'consum', 0.0210, 'lps'),
	(511528, 127, '2014-02-01 00:50:37.000000', 'consum', 0.0218, 'lps'),
	(511529, 127, '2014-02-01 00:50:38.000000', 'consum', 0.0220, 'lps'),
	(511530, 127, '2014-02-01 00:50:39.000000', 'consum', 0.0221, 'lps'),
	(511531, 127, '2014-02-01 00:50:40.000000', 'consum', 0.0221, 'lps'),
	(511532, 127, '2014-02-01 00:50:41.000000', 'consum', 0.0214, 'lps'),
	(511533, 127, '2014-02-01 00:50:42.000000', 'consum', 0.0212, 'lps'),
	(511534, 127, '2014-02-01 00:50:43.000000', 'consum', 0.0212, 'lps'),
	(511535, 127, '2014-02-01 00:50:44.000000', 'consum', 0.0211, 'lps'),
	(511536, 127, '2014-02-01 00:50:45.000000', 'consum', 0.0213, 'lps'),
	(511537, 127, '2014-02-01 00:50:46.000000', 'consum', 0.0221, 'lps'),
	(511538, 127, '2014-02-01 00:50:47.000000', 'consum', 0.0225, 'lps'),
	(511539, 127, '2014-02-01 00:50:48.000000', 'consum', 0.0219, 'lps'),
	(511540, 127, '2014-02-01 00:50:49.000000', 'consum', 0.0211, 'lps'),
	(511541, 127, '2014-02-01 00:50:50.000000', 'consum', 0.0220, 'lps'),
	(511542, 127, '2014-02-01 00:50:51.000000', 'consum', 0.0211, 'lps'),
	(511543, 127, '2014-02-01 00:50:52.000000', 'consum', 0.0215, 'lps'),
	(511544, 127, '2014-02-01 00:50:53.000000', 'consum', 0.0218, 'lps'),
	(511545, 127, '2014-02-01 00:50:54.000000', 'consum', 0.0220, 'lps'),
	(511546, 127, '2014-02-01 00:50:55.000000', 'consum', 0.0218, 'lps'),
	(511547, 127, '2014-02-01 00:50:56.000000', 'consum', 0.0224, 'lps'),
	(511548, 127, '2014-02-01 00:50:57.000000', 'consum', 0.0222, 'lps'),
	(511549, 127, '2014-02-01 00:50:58.000000', 'consum', 0.0212, 'lps'),
	(511550, 127, '2014-02-01 00:50:59.000000', 'consum', 0.0219, 'lps'),
	(511551, 127, '2014-02-01 00:51:00.000000', 'consum', 0.0217, 'lps'),
	(511552, 127, '2014-02-01 00:51:01.000000', 'consum', 0.0217, 'lps'),
	(511553, 127, '2014-02-01 00:51:02.000000', 'consum', 0.0224, 'lps'),
	(511554, 127, '2014-02-01 00:51:03.000000', 'consum', 0.0211, 'lps'),
	(511555, 127, '2014-02-01 00:51:04.000000', 'consum', 0.0224, 'lps'),
	(511556, 127, '2014-02-01 00:51:05.000000', 'consum', 0.0214, 'lps'),
	(511557, 127, '2014-02-01 00:51:06.000000', 'consum', 0.0219, 'lps'),
	(511558, 127, '2014-02-01 00:51:07.000000', 'consum', 0.0214, 'lps'),
	(511559, 127, '2014-02-01 00:51:08.000000', 'consum', 0.0217, 'lps'),
	(511560, 127, '2014-02-01 00:51:09.000000', 'consum', 0.0218, 'lps'),
	(511561, 127, '2014-02-01 00:51:10.000000', 'consum', 0.0214, 'lps'),
	(511562, 127, '2014-02-01 00:51:11.000000', 'consum', 0.0223, 'lps'),
	(511563, 127, '2014-02-01 00:51:12.000000', 'consum', 0.0214, 'lps'),
	(511564, 127, '2014-02-01 00:51:13.000000', 'consum', 0.0223, 'lps'),
	(511565, 127, '2014-02-01 00:51:14.000000', 'consum', 0.0214, 'lps'),
	(511566, 127, '2014-02-01 00:51:15.000000', 'consum', 0.0211, 'lps'),
	(511567, 127, '2014-02-01 00:51:16.000000', 'consum', 0.0216, 'lps'),
	(511568, 127, '2014-02-01 00:51:17.000000', 'consum', 0.0225, 'lps'),
	(511569, 127, '2014-02-01 00:51:18.000000', 'consum', 0.0218, 'lps'),
	(511570, 127, '2014-02-01 00:51:19.000000', 'consum', 0.0222, 'lps'),
	(511571, 127, '2014-02-01 00:51:20.000000', 'consum', 0.0214, 'lps'),
	(511572, 127, '2014-02-01 00:51:21.000000', 'consum', 0.0211, 'lps'),
	(511573, 127, '2014-02-01 00:51:22.000000', 'consum', 0.0218, 'lps'),
	(511574, 127, '2014-02-01 00:51:23.000000', 'consum', 0.0217, 'lps'),
	(511575, 127, '2014-02-01 00:51:24.000000', 'consum', 0.0222, 'lps'),
	(511576, 127, '2014-02-01 00:51:25.000000', 'consum', 0.0215, 'lps'),
	(511577, 127, '2014-02-01 00:51:26.000000', 'consum', 0.0217, 'lps'),
	(511578, 127, '2014-02-01 00:51:27.000000', 'consum', 0.0214, 'lps'),
	(511579, 127, '2014-02-01 00:51:28.000000', 'consum', 0.0210, 'lps'),
	(511580, 127, '2014-02-01 00:51:29.000000', 'consum', 0.0214, 'lps'),
	(511581, 127, '2014-02-01 00:51:30.000000', 'consum', 0.0214, 'lps'),
	(511582, 127, '2014-02-01 00:51:31.000000', 'consum', 0.0218, 'lps'),
	(511583, 127, '2014-02-01 00:51:32.000000', 'consum', 0.0225, 'lps'),
	(511584, 127, '2014-02-01 00:51:33.000000', 'consum', 0.0211, 'lps'),
	(511585, 127, '2014-02-01 00:51:34.000000', 'consum', 0.0221, 'lps'),
	(511586, 127, '2014-02-01 00:51:35.000000', 'consum', 0.0213, 'lps'),
	(511587, 127, '2014-02-01 00:51:36.000000', 'consum', 0.0223, 'lps'),
	(511588, 127, '2014-02-01 00:51:37.000000', 'consum', 0.0218, 'lps'),
	(511589, 127, '2014-02-01 00:51:38.000000', 'consum', 0.0214, 'lps'),
	(511590, 127, '2014-02-01 00:51:39.000000', 'consum', 0.0222, 'lps'),
	(511591, 127, '2014-02-01 00:51:40.000000', 'consum', 0.0210, 'lps'),
	(511592, 127, '2014-02-01 00:51:41.000000', 'consum', 0.0223, 'lps'),
	(511593, 127, '2014-02-01 00:51:42.000000', 'consum', 0.0211, 'lps'),
	(511594, 127, '2014-02-01 00:51:43.000000', 'consum', 0.0224, 'lps'),
	(511595, 127, '2014-02-01 00:51:44.000000', 'consum', 0.0212, 'lps'),
	(511596, 127, '2014-02-01 00:51:45.000000', 'consum', 0.0212, 'lps'),
	(511597, 127, '2014-02-01 00:51:46.000000', 'consum', 0.0216, 'lps'),
	(511598, 127, '2014-02-01 00:51:47.000000', 'consum', 0.0219, 'lps'),
	(511599, 127, '2014-02-01 00:51:48.000000', 'consum', 0.0220, 'lps'),
	(511600, 127, '2014-02-01 00:51:49.000000', 'consum', 0.0218, 'lps'),
	(511601, 127, '2014-02-01 00:51:50.000000', 'consum', 0.0221, 'lps'),
	(511602, 127, '2014-02-01 00:51:51.000000', 'consum', 0.0211, 'lps'),
	(511603, 127, '2014-02-01 00:51:52.000000', 'consum', 0.0212, 'lps'),
	(511604, 127, '2014-02-01 00:51:53.000000', 'consum', 0.0218, 'lps'),
	(511605, 127, '2014-02-01 00:51:54.000000', 'consum', 0.0214, 'lps'),
	(511606, 127, '2014-02-01 00:51:55.000000', 'consum', 0.0220, 'lps'),
	(511607, 127, '2014-02-01 00:51:56.000000', 'consum', 0.0218, 'lps'),
	(511608, 127, '2014-02-01 00:51:57.000000', 'consum', 0.0218, 'lps'),
	(511609, 127, '2014-02-01 00:51:58.000000', 'consum', 0.0214, 'lps'),
	(511610, 127, '2014-02-01 00:51:59.000000', 'consum', 0.0220, 'lps'),
	(511611, 127, '2014-02-01 00:52:00.000000', 'consum', 0.0218, 'lps'),
	(511612, 127, '2014-02-01 00:52:01.000000', 'consum', 0.0219, 'lps'),
	(511613, 127, '2014-02-01 00:52:02.000000', 'consum', 0.0216, 'lps'),
	(511614, 127, '2014-02-01 00:52:03.000000', 'consum', 0.0214, 'lps'),
	(511615, 127, '2014-02-01 00:52:04.000000', 'consum', 0.0214, 'lps'),
	(511616, 127, '2014-02-01 00:52:05.000000', 'consum', 0.0216, 'lps'),
	(511617, 127, '2014-02-01 00:52:06.000000', 'consum', 0.0213, 'lps'),
	(511618, 127, '2014-02-01 00:52:07.000000', 'consum', 0.0224, 'lps'),
	(511619, 127, '2014-02-01 00:52:08.000000', 'consum', 0.0223, 'lps'),
	(511620, 127, '2014-02-01 00:52:09.000000', 'consum', 0.0218, 'lps'),
	(511621, 127, '2014-02-01 00:52:10.000000', 'consum', 0.0211, 'lps'),
	(511622, 127, '2014-02-01 00:52:11.000000', 'consum', 0.0225, 'lps'),
	(511623, 127, '2014-02-01 00:52:12.000000', 'consum', 0.0216, 'lps'),
	(511624, 127, '2014-02-01 00:52:13.000000', 'consum', 0.0214, 'lps'),
	(511625, 127, '2014-02-01 00:52:14.000000', 'consum', 0.0213, 'lps'),
	(511626, 127, '2014-02-01 00:52:15.000000', 'consum', 0.0214, 'lps'),
	(511627, 127, '2014-02-01 00:52:16.000000', 'consum', 0.0218, 'lps'),
	(511628, 127, '2014-02-01 00:52:17.000000', 'consum', 0.0210, 'lps'),
	(511629, 127, '2014-02-01 00:52:18.000000', 'consum', 0.0217, 'lps'),
	(511630, 127, '2014-02-01 00:52:19.000000', 'consum', 0.0213, 'lps'),
	(511631, 127, '2014-02-01 00:52:20.000000', 'consum', 0.0220, 'lps'),
	(511632, 127, '2014-02-01 00:52:21.000000', 'consum', 0.0218, 'lps'),
	(511633, 127, '2014-02-01 00:52:22.000000', 'consum', 0.0224, 'lps'),
	(511634, 127, '2014-02-01 00:52:23.000000', 'consum', 0.0222, 'lps'),
	(511635, 127, '2014-02-01 00:52:24.000000', 'consum', 0.0212, 'lps'),
	(511636, 127, '2014-02-01 00:52:25.000000', 'consum', 0.0217, 'lps'),
	(511637, 127, '2014-02-01 00:52:26.000000', 'consum', 0.0210, 'lps'),
	(511638, 127, '2014-02-01 00:52:27.000000', 'consum', 0.0219, 'lps'),
	(511639, 127, '2014-02-01 00:52:28.000000', 'consum', 0.0224, 'lps'),
	(511640, 127, '2014-02-01 00:52:29.000000', 'consum', 0.0220, 'lps'),
	(511641, 127, '2014-02-01 00:52:30.000000', 'consum', 0.0219, 'lps'),
	(511642, 127, '2014-02-01 00:52:31.000000', 'consum', 0.0210, 'lps'),
	(511643, 127, '2014-02-01 00:52:32.000000', 'consum', 0.0214, 'lps'),
	(511644, 127, '2014-02-01 00:52:33.000000', 'consum', 0.0215, 'lps'),
	(511645, 127, '2014-02-01 00:52:34.000000', 'consum', 0.0210, 'lps'),
	(511646, 127, '2014-02-01 00:52:35.000000', 'consum', 0.0224, 'lps'),
	(511647, 127, '2014-02-01 00:52:36.000000', 'consum', 0.0219, 'lps'),
	(511648, 127, '2014-02-01 00:52:37.000000', 'consum', 0.0213, 'lps'),
	(511649, 127, '2014-02-01 00:52:38.000000', 'consum', 0.0212, 'lps'),
	(511650, 127, '2014-02-01 00:52:39.000000', 'consum', 0.0214, 'lps'),
	(511651, 127, '2014-02-01 00:52:40.000000', 'consum', 0.0223, 'lps'),
	(511652, 127, '2014-02-01 00:52:41.000000', 'consum', 0.0217, 'lps'),
	(511653, 127, '2014-02-01 00:52:42.000000', 'consum', 0.0221, 'lps'),
	(511654, 127, '2014-02-01 00:52:43.000000', 'consum', 0.0212, 'lps'),
	(511655, 127, '2014-02-01 00:52:44.000000', 'consum', 0.0219, 'lps'),
	(511656, 127, '2014-02-01 00:52:45.000000', 'consum', 0.0217, 'lps'),
	(511657, 127, '2014-02-01 00:52:46.000000', 'consum', 0.0221, 'lps'),
	(511658, 127, '2014-02-01 00:52:47.000000', 'consum', 0.0210, 'lps'),
	(511659, 127, '2014-02-01 00:52:48.000000', 'consum', 0.0225, 'lps'),
	(511660, 127, '2014-02-01 00:52:49.000000', 'consum', 0.0221, 'lps'),
	(511661, 127, '2014-02-01 00:52:50.000000', 'consum', 0.0224, 'lps'),
	(511662, 127, '2014-02-01 00:52:51.000000', 'consum', 0.0212, 'lps'),
	(511663, 127, '2014-02-01 00:52:52.000000', 'consum', 0.0214, 'lps'),
	(511664, 127, '2014-02-01 00:52:53.000000', 'consum', 0.0222, 'lps'),
	(511665, 127, '2014-02-01 00:52:54.000000', 'consum', 0.0213, 'lps'),
	(511666, 127, '2014-02-01 00:52:55.000000', 'consum', 0.0221, 'lps'),
	(511667, 127, '2014-02-01 00:52:56.000000', 'consum', 0.0224, 'lps'),
	(511668, 127, '2014-02-01 00:52:57.000000', 'consum', 0.0215, 'lps'),
	(511669, 127, '2014-02-01 00:52:58.000000', 'consum', 0.0210, 'lps'),
	(511670, 127, '2014-02-01 00:52:59.000000', 'consum', 0.0211, 'lps'),
	(511671, 127, '2014-02-01 00:53:00.000000', 'consum', 0.0215, 'lps'),
	(511672, 127, '2014-02-01 00:53:01.000000', 'consum', 0.0218, 'lps'),
	(511673, 127, '2014-02-01 00:53:02.000000', 'consum', 0.0219, 'lps'),
	(511674, 127, '2014-02-01 00:53:03.000000', 'consum', 0.0215, 'lps'),
	(511675, 127, '2014-02-01 00:53:04.000000', 'consum', 0.0224, 'lps'),
	(511676, 127, '2014-02-01 00:53:05.000000', 'consum', 0.0217, 'lps'),
	(511677, 127, '2014-02-01 00:53:06.000000', 'consum', 0.0219, 'lps'),
	(511678, 127, '2014-02-01 00:53:07.000000', 'consum', 0.0221, 'lps'),
	(511679, 127, '2014-02-01 00:53:08.000000', 'consum', 0.0221, 'lps'),
	(511680, 127, '2014-02-01 00:53:09.000000', 'consum', 0.0215, 'lps'),
	(511681, 127, '2014-02-01 00:53:10.000000', 'consum', 0.0219, 'lps'),
	(511682, 127, '2014-02-01 00:53:11.000000', 'consum', 0.0210, 'lps'),
	(511683, 127, '2014-02-01 00:53:12.000000', 'consum', 0.0214, 'lps'),
	(511684, 127, '2014-02-01 00:53:13.000000', 'consum', 0.0217, 'lps'),
	(511685, 127, '2014-02-01 00:53:14.000000', 'consum', 0.0214, 'lps'),
	(511686, 127, '2014-02-01 00:53:15.000000', 'consum', 0.0211, 'lps'),
	(511687, 127, '2014-02-01 00:53:16.000000', 'consum', 0.0221, 'lps'),
	(511688, 127, '2014-02-01 00:53:17.000000', 'consum', 0.0215, 'lps'),
	(511689, 127, '2014-02-01 00:53:18.000000', 'consum', 0.0218, 'lps'),
	(511690, 127, '2014-02-01 00:53:19.000000', 'consum', 0.0219, 'lps'),
	(511691, 127, '2014-02-01 00:53:20.000000', 'consum', 0.0216, 'lps'),
	(511692, 127, '2014-02-01 00:53:21.000000', 'consum', 0.0212, 'lps'),
	(511693, 127, '2014-02-01 00:53:22.000000', 'consum', 0.0218, 'lps'),
	(511694, 127, '2014-02-01 00:53:23.000000', 'consum', 0.0211, 'lps'),
	(511695, 127, '2014-02-01 00:53:24.000000', 'consum', 0.0210, 'lps'),
	(511696, 127, '2014-02-01 00:53:25.000000', 'consum', 0.0225, 'lps'),
	(511697, 127, '2014-02-01 00:53:26.000000', 'consum', 0.0219, 'lps'),
	(511698, 127, '2014-02-01 00:53:27.000000', 'consum', 0.0213, 'lps'),
	(511699, 127, '2014-02-01 00:53:28.000000', 'consum', 0.0214, 'lps'),
	(511700, 127, '2014-02-01 00:53:29.000000', 'consum', 0.0223, 'lps'),
	(511701, 127, '2014-02-01 00:53:30.000000', 'consum', 0.0214, 'lps'),
	(511702, 127, '2014-02-01 00:53:31.000000', 'consum', 0.0222, 'lps'),
	(511703, 127, '2014-02-01 00:53:32.000000', 'consum', 0.0225, 'lps'),
	(511704, 127, '2014-02-01 00:53:33.000000', 'consum', 0.0221, 'lps'),
	(511705, 127, '2014-02-01 00:53:34.000000', 'consum', 0.0221, 'lps'),
	(511706, 127, '2014-02-01 00:53:35.000000', 'consum', 0.0215, 'lps'),
	(511707, 127, '2014-02-01 00:53:36.000000', 'consum', 0.0217, 'lps'),
	(511708, 127, '2014-02-01 00:53:37.000000', 'consum', 0.0215, 'lps'),
	(511709, 127, '2014-02-01 00:53:38.000000', 'consum', 0.0217, 'lps'),
	(511710, 127, '2014-02-01 00:53:39.000000', 'consum', 0.0211, 'lps'),
	(511711, 127, '2014-02-01 00:53:40.000000', 'consum', 0.0212, 'lps'),
	(511712, 127, '2014-02-01 00:53:41.000000', 'consum', 0.0218, 'lps'),
	(511713, 127, '2014-02-01 00:53:42.000000', 'consum', 0.0211, 'lps'),
	(511714, 127, '2014-02-01 00:53:43.000000', 'consum', 0.0210, 'lps'),
	(511715, 127, '2014-02-01 00:53:44.000000', 'consum', 0.0220, 'lps'),
	(511716, 127, '2014-02-01 00:53:45.000000', 'consum', 0.0215, 'lps'),
	(511717, 127, '2014-02-01 00:53:46.000000', 'consum', 0.0222, 'lps'),
	(511718, 127, '2014-02-01 00:53:47.000000', 'consum', 0.0223, 'lps'),
	(511719, 127, '2014-02-01 00:53:48.000000', 'consum', 0.0222, 'lps'),
	(511720, 127, '2014-02-01 00:53:49.000000', 'consum', 0.0214, 'lps'),
	(511721, 127, '2014-02-01 00:53:50.000000', 'consum', 0.0214, 'lps'),
	(511722, 127, '2014-02-01 00:53:51.000000', 'consum', 0.0218, 'lps'),
	(511723, 127, '2014-02-01 00:53:52.000000', 'consum', 0.0224, 'lps'),
	(511724, 127, '2014-02-01 00:53:53.000000', 'consum', 0.0223, 'lps'),
	(511725, 127, '2014-02-01 00:53:54.000000', 'consum', 0.0219, 'lps'),
	(511726, 127, '2014-02-01 00:53:55.000000', 'consum', 0.0216, 'lps'),
	(511727, 127, '2014-02-01 00:53:56.000000', 'consum', 0.0211, 'lps'),
	(511728, 127, '2014-02-01 00:53:57.000000', 'consum', 0.0216, 'lps'),
	(511729, 127, '2014-02-01 00:53:58.000000', 'consum', 0.0222, 'lps'),
	(511730, 127, '2014-02-01 00:53:59.000000', 'consum', 0.0220, 'lps'),
	(511731, 127, '2014-02-01 00:54:00.000000', 'consum', 0.0224, 'lps'),
	(511732, 127, '2014-02-01 00:54:01.000000', 'consum', 0.0220, 'lps'),
	(511733, 127, '2014-02-01 00:54:02.000000', 'consum', 0.0216, 'lps'),
	(511734, 127, '2014-02-01 00:54:03.000000', 'consum', 0.0211, 'lps'),
	(511735, 127, '2014-02-01 00:54:04.000000', 'consum', 0.0213, 'lps'),
	(511736, 127, '2014-02-01 00:54:05.000000', 'consum', 0.0223, 'lps'),
	(511737, 127, '2014-02-01 00:54:06.000000', 'consum', 0.0217, 'lps'),
	(511738, 127, '2014-02-01 00:54:07.000000', 'consum', 0.0223, 'lps'),
	(511739, 127, '2014-02-01 00:54:08.000000', 'consum', 0.0221, 'lps'),
	(511740, 127, '2014-02-01 00:54:09.000000', 'consum', 0.0211, 'lps'),
	(511741, 127, '2014-02-01 00:54:10.000000', 'consum', 0.0217, 'lps'),
	(511742, 127, '2014-02-01 00:54:11.000000', 'consum', 0.0225, 'lps'),
	(511743, 127, '2014-02-01 00:54:12.000000', 'consum', 0.0217, 'lps'),
	(511744, 127, '2014-02-01 00:54:13.000000', 'consum', 0.0215, 'lps'),
	(511745, 127, '2014-02-01 00:54:14.000000', 'consum', 0.0214, 'lps'),
	(511746, 127, '2014-02-01 00:54:15.000000', 'consum', 0.0218, 'lps'),
	(511747, 127, '2014-02-01 00:54:16.000000', 'consum', 0.0220, 'lps'),
	(511748, 127, '2014-02-01 00:54:17.000000', 'consum', 0.0220, 'lps'),
	(511749, 127, '2014-02-01 00:54:18.000000', 'consum', 0.0214, 'lps'),
	(511750, 127, '2014-02-01 00:54:19.000000', 'consum', 0.0218, 'lps'),
	(511751, 127, '2014-02-01 00:54:20.000000', 'consum', 0.0223, 'lps'),
	(511752, 127, '2014-02-01 00:54:21.000000', 'consum', 0.0221, 'lps'),
	(511753, 127, '2014-02-01 00:54:22.000000', 'consum', 0.0225, 'lps'),
	(511754, 127, '2014-02-01 00:54:23.000000', 'consum', 0.0221, 'lps'),
	(511755, 127, '2014-02-01 00:54:24.000000', 'consum', 0.0222, 'lps'),
	(511756, 127, '2014-02-01 00:54:25.000000', 'consum', 0.0218, 'lps'),
	(511757, 127, '2014-02-01 00:54:26.000000', 'consum', 0.0217, 'lps'),
	(511758, 127, '2014-02-01 00:54:27.000000', 'consum', 0.0219, 'lps'),
	(511759, 127, '2014-02-01 00:54:28.000000', 'consum', 0.0221, 'lps'),
	(511760, 127, '2014-02-01 00:54:29.000000', 'consum', 0.0223, 'lps'),
	(511761, 127, '2014-02-01 00:54:30.000000', 'consum', 0.0211, 'lps'),
	(511762, 127, '2014-02-01 00:54:31.000000', 'consum', 0.0221, 'lps'),
	(511763, 127, '2014-02-01 00:54:32.000000', 'consum', 0.0218, 'lps'),
	(511764, 127, '2014-02-01 00:54:33.000000', 'consum', 0.0215, 'lps'),
	(511765, 127, '2014-02-01 00:54:34.000000', 'consum', 0.0214, 'lps'),
	(511766, 127, '2014-02-01 00:54:35.000000', 'consum', 0.0216, 'lps'),
	(511767, 127, '2014-02-01 00:54:36.000000', 'consum', 0.0210, 'lps'),
	(511768, 127, '2014-02-01 00:54:37.000000', 'consum', 0.0224, 'lps'),
	(511769, 127, '2014-02-01 00:54:38.000000', 'consum', 0.0219, 'lps'),
	(511770, 127, '2014-02-01 00:54:39.000000', 'consum', 0.0212, 'lps'),
	(511771, 127, '2014-02-01 00:54:40.000000', 'consum', 0.0210, 'lps'),
	(511772, 127, '2014-02-01 00:54:41.000000', 'consum', 0.0220, 'lps'),
	(511773, 127, '2014-02-01 00:54:42.000000', 'consum', 0.0215, 'lps'),
	(511774, 127, '2014-02-01 00:54:43.000000', 'consum', 0.0219, 'lps'),
	(511775, 127, '2014-02-01 00:54:44.000000', 'consum', 0.0225, 'lps'),
	(511776, 127, '2014-02-01 00:54:45.000000', 'consum', 0.0210, 'lps'),
	(511777, 127, '2014-02-01 00:54:46.000000', 'consum', 0.0216, 'lps'),
	(511778, 127, '2014-02-01 00:54:47.000000', 'consum', 0.0223, 'lps'),
	(511779, 127, '2014-02-01 00:54:48.000000', 'consum', 0.0211, 'lps'),
	(511780, 127, '2014-02-01 00:54:49.000000', 'consum', 0.0222, 'lps'),
	(511781, 127, '2014-02-01 00:54:50.000000', 'consum', 0.0222, 'lps'),
	(511782, 127, '2014-02-01 00:54:51.000000', 'consum', 0.0219, 'lps'),
	(511783, 127, '2014-02-01 00:54:52.000000', 'consum', 0.0219, 'lps'),
	(511784, 127, '2014-02-01 00:54:53.000000', 'consum', 0.0213, 'lps'),
	(511785, 127, '2014-02-01 00:54:54.000000', 'consum', 0.0214, 'lps'),
	(511786, 127, '2014-02-01 00:54:55.000000', 'consum', 0.0223, 'lps'),
	(511787, 127, '2014-02-01 00:54:56.000000', 'consum', 0.0214, 'lps'),
	(511788, 127, '2014-02-01 00:54:57.000000', 'consum', 0.0223, 'lps'),
	(511789, 127, '2014-02-01 00:54:58.000000', 'consum', 0.0215, 'lps'),
	(511790, 127, '2014-02-01 00:54:59.000000', 'consum', 0.0214, 'lps'),
	(511791, 127, '2014-02-01 00:55:00.000000', 'consum', 0.0216, 'lps'),
	(511792, 127, '2014-02-01 00:55:01.000000', 'consum', 0.0211, 'lps'),
	(511793, 127, '2014-02-01 00:55:02.000000', 'consum', 0.0214, 'lps'),
	(511794, 127, '2014-02-01 00:55:03.000000', 'consum', 0.0212, 'lps'),
	(511795, 127, '2014-02-01 00:55:04.000000', 'consum', 0.0225, 'lps'),
	(511796, 127, '2014-02-01 00:55:05.000000', 'consum', 0.0215, 'lps'),
	(511797, 127, '2014-02-01 00:55:06.000000', 'consum', 0.0223, 'lps'),
	(511798, 127, '2014-02-01 00:55:07.000000', 'consum', 0.0212, 'lps'),
	(511799, 127, '2014-02-01 00:55:08.000000', 'consum', 0.0213, 'lps'),
	(511800, 127, '2014-02-01 00:55:09.000000', 'consum', 0.0221, 'lps'),
	(511801, 127, '2014-02-01 00:55:10.000000', 'consum', 0.0210, 'lps'),
	(511802, 127, '2014-02-01 00:55:11.000000', 'consum', 0.0223, 'lps'),
	(511803, 127, '2014-02-01 00:55:12.000000', 'consum', 0.0210, 'lps'),
	(511804, 127, '2014-02-01 00:55:13.000000', 'consum', 0.0223, 'lps'),
	(511805, 127, '2014-02-01 00:55:14.000000', 'consum', 0.0210, 'lps'),
	(511806, 127, '2014-02-01 00:55:15.000000', 'consum', 0.0220, 'lps'),
	(511807, 127, '2014-02-01 00:55:16.000000', 'consum', 0.0212, 'lps'),
	(511808, 127, '2014-02-01 00:55:17.000000', 'consum', 0.0223, 'lps'),
	(511809, 127, '2014-02-01 00:55:18.000000', 'consum', 0.0220, 'lps'),
	(511810, 127, '2014-02-01 00:55:19.000000', 'consum', 0.0221, 'lps'),
	(511811, 127, '2014-02-01 00:55:20.000000', 'consum', 0.0222, 'lps'),
	(511812, 127, '2014-02-01 00:55:21.000000', 'consum', 0.0219, 'lps'),
	(511813, 127, '2014-02-01 00:55:22.000000', 'consum', 0.0223, 'lps'),
	(511814, 127, '2014-02-01 00:55:23.000000', 'consum', 0.0213, 'lps'),
	(511815, 127, '2014-02-01 00:55:24.000000', 'consum', 0.0220, 'lps'),
	(511816, 127, '2014-02-01 00:55:25.000000', 'consum', 0.0220, 'lps'),
	(511817, 127, '2014-02-01 00:55:26.000000', 'consum', 0.0214, 'lps'),
	(511818, 127, '2014-02-01 00:55:27.000000', 'consum', 0.0215, 'lps'),
	(511819, 127, '2014-02-01 00:55:28.000000', 'consum', 0.0223, 'lps'),
	(511820, 127, '2014-02-01 00:55:29.000000', 'consum', 0.0212, 'lps'),
	(511821, 127, '2014-02-01 00:55:30.000000', 'consum', 0.0216, 'lps'),
	(511822, 127, '2014-02-01 00:55:31.000000', 'consum', 0.0219, 'lps'),
	(511823, 127, '2014-02-01 00:55:32.000000', 'consum', 0.0221, 'lps'),
	(511824, 127, '2014-02-01 00:55:33.000000', 'consum', 0.0223, 'lps'),
	(511825, 127, '2014-02-01 00:55:34.000000', 'consum', 0.0225, 'lps'),
	(511826, 127, '2014-02-01 00:55:35.000000', 'consum', 0.0217, 'lps'),
	(511827, 127, '2014-02-01 00:55:36.000000', 'consum', 0.0213, 'lps'),
	(511828, 127, '2014-02-01 00:55:37.000000', 'consum', 0.0224, 'lps'),
	(511829, 127, '2014-02-01 00:55:38.000000', 'consum', 0.0223, 'lps'),
	(511830, 127, '2014-02-01 00:55:39.000000', 'consum', 0.0216, 'lps'),
	(511831, 127, '2014-02-01 00:55:40.000000', 'consum', 0.0218, 'lps'),
	(511832, 127, '2014-02-01 00:55:41.000000', 'consum', 0.0218, 'lps'),
	(511833, 127, '2014-02-01 00:55:42.000000', 'consum', 0.0225, 'lps'),
	(511834, 127, '2014-02-01 00:55:43.000000', 'consum', 0.0215, 'lps'),
	(511835, 127, '2014-02-01 00:55:44.000000', 'consum', 0.0220, 'lps'),
	(511836, 127, '2014-02-01 00:55:45.000000', 'consum', 0.0215, 'lps'),
	(511837, 127, '2014-02-01 00:55:46.000000', 'consum', 0.0221, 'lps'),
	(511838, 127, '2014-02-01 00:55:47.000000', 'consum', 0.0221, 'lps'),
	(511839, 127, '2014-02-01 00:55:48.000000', 'consum', 0.0214, 'lps'),
	(511840, 127, '2014-02-01 00:55:49.000000', 'consum', 0.0214, 'lps'),
	(511841, 127, '2014-02-01 00:55:50.000000', 'consum', 0.0220, 'lps'),
	(511842, 127, '2014-02-01 00:55:51.000000', 'consum', 0.0217, 'lps'),
	(511843, 127, '2014-02-01 00:55:52.000000', 'consum', 0.0215, 'lps'),
	(511844, 127, '2014-02-01 00:55:53.000000', 'consum', 0.0214, 'lps'),
	(511845, 127, '2014-02-01 00:55:54.000000', 'consum', 0.0217, 'lps'),
	(511846, 127, '2014-02-01 00:55:55.000000', 'consum', 0.0215, 'lps'),
	(511847, 127, '2014-02-01 00:55:56.000000', 'consum', 0.0216, 'lps'),
	(511848, 127, '2014-02-01 00:55:57.000000', 'consum', 0.0211, 'lps'),
	(511849, 127, '2014-02-01 00:55:58.000000', 'consum', 0.0213, 'lps'),
	(511850, 127, '2014-02-01 00:55:59.000000', 'consum', 0.0223, 'lps'),
	(511851, 127, '2014-02-01 00:56:00.000000', 'consum', 0.0220, 'lps'),
	(511852, 127, '2014-02-01 00:56:01.000000', 'consum', 0.0218, 'lps'),
	(511853, 127, '2014-02-01 00:56:02.000000', 'consum', 0.0223, 'lps'),
	(511854, 127, '2014-02-01 00:56:03.000000', 'consum', 0.0221, 'lps'),
	(511855, 127, '2014-02-01 00:56:04.000000', 'consum', 0.0223, 'lps'),
	(511856, 127, '2014-02-01 00:56:05.000000', 'consum', 0.0214, 'lps'),
	(511857, 127, '2014-02-01 00:56:06.000000', 'consum', 0.0221, 'lps'),
	(511858, 127, '2014-02-01 00:56:07.000000', 'consum', 0.0221, 'lps'),
	(511859, 127, '2014-02-01 00:56:08.000000', 'consum', 0.0219, 'lps'),
	(511860, 127, '2014-02-01 00:56:09.000000', 'consum', 0.0222, 'lps'),
	(511861, 127, '2014-02-01 00:56:10.000000', 'consum', 0.0225, 'lps'),
	(511862, 127, '2014-02-01 00:56:11.000000', 'consum', 0.0221, 'lps'),
	(511863, 127, '2014-02-01 00:56:12.000000', 'consum', 0.0217, 'lps'),
	(511864, 127, '2014-02-01 00:56:13.000000', 'consum', 0.0214, 'lps'),
	(511865, 127, '2014-02-01 00:56:14.000000', 'consum', 0.0211, 'lps'),
	(511866, 127, '2014-02-01 00:56:15.000000', 'consum', 0.0219, 'lps'),
	(511867, 127, '2014-02-01 00:56:16.000000', 'consum', 0.0218, 'lps'),
	(511868, 127, '2014-02-01 00:56:17.000000', 'consum', 0.0225, 'lps'),
	(511869, 127, '2014-02-01 00:56:18.000000', 'consum', 0.0215, 'lps'),
	(511870, 127, '2014-02-01 00:56:19.000000', 'consum', 0.0222, 'lps'),
	(511871, 127, '2014-02-01 00:56:20.000000', 'consum', 0.0225, 'lps'),
	(511872, 127, '2014-02-01 00:56:21.000000', 'consum', 0.0214, 'lps'),
	(511873, 127, '2014-02-01 00:56:22.000000', 'consum', 0.0220, 'lps'),
	(511874, 127, '2014-02-01 00:56:23.000000', 'consum', 0.0214, 'lps'),
	(511875, 127, '2014-02-01 00:56:24.000000', 'consum', 0.0218, 'lps'),
	(511876, 127, '2014-02-01 00:56:25.000000', 'consum', 0.0223, 'lps'),
	(511877, 127, '2014-02-01 00:56:26.000000', 'consum', 0.0217, 'lps'),
	(511878, 127, '2014-02-01 00:56:27.000000', 'consum', 0.0225, 'lps'),
	(511879, 127, '2014-02-01 00:56:28.000000', 'consum', 0.0215, 'lps'),
	(511880, 127, '2014-02-01 00:56:29.000000', 'consum', 0.0223, 'lps'),
	(511881, 127, '2014-02-01 00:56:30.000000', 'consum', 0.0212, 'lps'),
	(511882, 127, '2014-02-01 00:56:31.000000', 'consum', 0.0213, 'lps'),
	(511883, 127, '2014-02-01 00:56:32.000000', 'consum', 0.0222, 'lps'),
	(511884, 127, '2014-02-01 00:56:33.000000', 'consum', 0.0212, 'lps'),
	(511885, 127, '2014-02-01 00:56:34.000000', 'consum', 0.0216, 'lps'),
	(511886, 127, '2014-02-01 00:56:35.000000', 'consum', 0.0220, 'lps'),
	(511887, 127, '2014-02-01 00:56:36.000000', 'consum', 0.0211, 'lps'),
	(511888, 127, '2014-02-01 00:56:37.000000', 'consum', 0.0215, 'lps'),
	(511889, 127, '2014-02-01 00:56:38.000000', 'consum', 0.0216, 'lps'),
	(511890, 127, '2014-02-01 00:56:39.000000', 'consum', 0.0212, 'lps'),
	(511891, 127, '2014-02-01 00:56:40.000000', 'consum', 0.0220, 'lps'),
	(511892, 127, '2014-02-01 00:56:41.000000', 'consum', 0.0219, 'lps'),
	(511893, 127, '2014-02-01 00:56:42.000000', 'consum', 0.0212, 'lps'),
	(511894, 127, '2014-02-01 00:56:43.000000', 'consum', 0.0224, 'lps'),
	(511895, 127, '2014-02-01 00:56:44.000000', 'consum', 0.0211, 'lps'),
	(511896, 127, '2014-02-01 00:56:45.000000', 'consum', 0.0223, 'lps'),
	(511897, 127, '2014-02-01 00:56:46.000000', 'consum', 0.0222, 'lps'),
	(511898, 127, '2014-02-01 00:56:47.000000', 'consum', 0.0218, 'lps'),
	(511899, 127, '2014-02-01 00:56:48.000000', 'consum', 0.0213, 'lps'),
	(511900, 127, '2014-02-01 00:56:49.000000', 'consum', 0.0220, 'lps'),
	(511901, 127, '2014-02-01 00:56:50.000000', 'consum', 0.0216, 'lps'),
	(511902, 127, '2014-02-01 00:56:51.000000', 'consum', 0.0213, 'lps'),
	(511903, 127, '2014-02-01 00:56:52.000000', 'consum', 0.0222, 'lps'),
	(511904, 127, '2014-02-01 00:56:53.000000', 'consum', 0.0214, 'lps'),
	(511905, 127, '2014-02-01 00:56:54.000000', 'consum', 0.0225, 'lps'),
	(511906, 127, '2014-02-01 00:56:55.000000', 'consum', 0.0212, 'lps'),
	(511907, 127, '2014-02-01 00:56:56.000000', 'consum', 0.0224, 'lps'),
	(511908, 127, '2014-02-01 00:56:57.000000', 'consum', 0.0225, 'lps'),
	(511909, 127, '2014-02-01 00:56:58.000000', 'consum', 0.0212, 'lps'),
	(511910, 127, '2014-02-01 00:56:59.000000', 'consum', 0.0222, 'lps'),
	(511911, 127, '2014-02-01 00:57:00.000000', 'consum', 0.0216, 'lps'),
	(511912, 127, '2014-02-01 00:57:01.000000', 'consum', 0.0222, 'lps'),
	(511913, 127, '2014-02-01 00:57:02.000000', 'consum', 0.0221, 'lps'),
	(511914, 127, '2014-02-01 00:57:03.000000', 'consum', 0.0215, 'lps'),
	(511915, 127, '2014-02-01 00:57:04.000000', 'consum', 0.0217, 'lps'),
	(511916, 127, '2014-02-01 00:57:05.000000', 'consum', 0.0213, 'lps'),
	(511917, 127, '2014-02-01 00:57:06.000000', 'consum', 0.0221, 'lps'),
	(511918, 127, '2014-02-01 00:57:07.000000', 'consum', 0.0224, 'lps'),
	(511919, 127, '2014-02-01 00:57:08.000000', 'consum', 0.0215, 'lps'),
	(511920, 127, '2014-02-01 00:57:09.000000', 'consum', 0.0225, 'lps'),
	(511921, 127, '2014-02-01 00:57:10.000000', 'consum', 0.0223, 'lps'),
	(511922, 127, '2014-02-01 00:57:11.000000', 'consum', 0.0214, 'lps'),
	(511923, 127, '2014-02-01 00:57:12.000000', 'consum', 0.0210, 'lps'),
	(511924, 127, '2014-02-01 00:57:13.000000', 'consum', 0.0213, 'lps'),
	(511925, 127, '2014-02-01 00:57:14.000000', 'consum', 0.0225, 'lps'),
	(511926, 127, '2014-02-01 00:57:15.000000', 'consum', 0.0215, 'lps'),
	(511927, 127, '2014-02-01 00:57:16.000000', 'consum', 0.0220, 'lps'),
	(511928, 127, '2014-02-01 00:57:17.000000', 'consum', 0.0216, 'lps'),
	(511929, 127, '2014-02-01 00:57:18.000000', 'consum', 0.0211, 'lps'),
	(511930, 127, '2014-02-01 00:57:19.000000', 'consum', 0.0211, 'lps'),
	(511931, 127, '2014-02-01 00:57:20.000000', 'consum', 0.0212, 'lps'),
	(511932, 127, '2014-02-01 00:57:21.000000', 'consum', 0.0220, 'lps'),
	(511933, 127, '2014-02-01 00:57:22.000000', 'consum', 0.0220, 'lps'),
	(511934, 127, '2014-02-01 00:57:23.000000', 'consum', 0.0214, 'lps'),
	(511935, 127, '2014-02-01 00:57:24.000000', 'consum', 0.0217, 'lps'),
	(511936, 127, '2014-02-01 00:57:25.000000', 'consum', 0.0219, 'lps'),
	(511937, 127, '2014-02-01 00:57:26.000000', 'consum', 0.0216, 'lps'),
	(511938, 127, '2014-02-01 00:57:27.000000', 'consum', 0.0214, 'lps'),
	(511939, 127, '2014-02-01 00:57:28.000000', 'consum', 0.0215, 'lps'),
	(511940, 127, '2014-02-01 00:57:29.000000', 'consum', 0.0220, 'lps'),
	(511941, 127, '2014-02-01 00:57:30.000000', 'consum', 0.0215, 'lps'),
	(511942, 127, '2014-02-01 00:57:31.000000', 'consum', 0.0222, 'lps'),
	(511943, 127, '2014-02-01 00:57:32.000000', 'consum', 0.0222, 'lps'),
	(511944, 127, '2014-02-01 00:57:33.000000', 'consum', 0.0217, 'lps'),
	(511945, 127, '2014-02-01 00:57:34.000000', 'consum', 0.0212, 'lps'),
	(511946, 127, '2014-02-01 00:57:35.000000', 'consum', 0.0216, 'lps'),
	(511947, 127, '2014-02-01 00:57:36.000000', 'consum', 0.0219, 'lps'),
	(511948, 127, '2014-02-01 00:57:37.000000', 'consum', 0.0219, 'lps'),
	(511949, 127, '2014-02-01 00:57:38.000000', 'consum', 0.0213, 'lps'),
	(511950, 127, '2014-02-01 00:57:39.000000', 'consum', 0.0216, 'lps'),
	(511951, 127, '2014-02-01 00:57:40.000000', 'consum', 0.0216, 'lps'),
	(511952, 127, '2014-02-01 00:57:41.000000', 'consum', 0.0220, 'lps'),
	(511953, 127, '2014-02-01 00:57:42.000000', 'consum', 0.0210, 'lps'),
	(511954, 127, '2014-02-01 00:57:43.000000', 'consum', 0.0215, 'lps'),
	(511955, 127, '2014-02-01 00:57:44.000000', 'consum', 0.0220, 'lps'),
	(511956, 127, '2014-02-01 00:57:45.000000', 'consum', 0.0213, 'lps'),
	(511957, 127, '2014-02-01 00:57:46.000000', 'consum', 0.0211, 'lps'),
	(511958, 127, '2014-02-01 00:57:47.000000', 'consum', 0.0223, 'lps'),
	(511959, 127, '2014-02-01 00:57:48.000000', 'consum', 0.0210, 'lps'),
	(511960, 127, '2014-02-01 00:57:49.000000', 'consum', 0.0216, 'lps'),
	(511961, 127, '2014-02-01 00:57:50.000000', 'consum', 0.0212, 'lps'),
	(511962, 127, '2014-02-01 00:57:51.000000', 'consum', 0.0215, 'lps'),
	(511963, 127, '2014-02-01 00:57:52.000000', 'consum', 0.0215, 'lps'),
	(511964, 127, '2014-02-01 00:57:53.000000', 'consum', 0.0222, 'lps'),
	(511965, 127, '2014-02-01 00:57:54.000000', 'consum', 0.0222, 'lps'),
	(511966, 127, '2014-02-01 00:57:55.000000', 'consum', 0.0220, 'lps'),
	(511967, 127, '2014-02-01 00:57:56.000000', 'consum', 0.0225, 'lps'),
	(511968, 127, '2014-02-01 00:57:57.000000', 'consum', 0.0221, 'lps'),
	(511969, 127, '2014-02-01 00:57:58.000000', 'consum', 0.0223, 'lps'),
	(511970, 127, '2014-02-01 00:57:59.000000', 'consum', 0.0210, 'lps'),
	(511971, 127, '2014-02-01 00:58:00.000000', 'consum', 0.0219, 'lps'),
	(511972, 127, '2014-02-01 00:58:01.000000', 'consum', 0.0222, 'lps'),
	(511973, 127, '2014-02-01 00:58:02.000000', 'consum', 0.0212, 'lps'),
	(511974, 127, '2014-02-01 00:58:03.000000', 'consum', 0.0215, 'lps'),
	(511975, 127, '2014-02-01 00:58:04.000000', 'consum', 0.0217, 'lps'),
	(511976, 127, '2014-02-01 00:58:05.000000', 'consum', 0.0213, 'lps'),
	(511977, 127, '2014-02-01 00:58:06.000000', 'consum', 0.0221, 'lps'),
	(511978, 127, '2014-02-01 00:58:07.000000', 'consum', 0.0222, 'lps'),
	(511979, 127, '2014-02-01 00:58:08.000000', 'consum', 0.0224, 'lps'),
	(511980, 127, '2014-02-01 00:58:09.000000', 'consum', 0.0211, 'lps'),
	(511981, 127, '2014-02-01 00:58:10.000000', 'consum', 0.0223, 'lps'),
	(511982, 127, '2014-02-01 00:58:11.000000', 'consum', 0.0222, 'lps'),
	(511983, 127, '2014-02-01 00:58:12.000000', 'consum', 0.0216, 'lps'),
	(511984, 127, '2014-02-01 00:58:13.000000', 'consum', 0.0219, 'lps'),
	(511985, 127, '2014-02-01 00:58:14.000000', 'consum', 0.0225, 'lps'),
	(511986, 127, '2014-02-01 00:58:15.000000', 'consum', 0.0225, 'lps'),
	(511987, 127, '2014-02-01 00:58:16.000000', 'consum', 0.0224, 'lps'),
	(511988, 127, '2014-02-01 00:58:17.000000', 'consum', 0.0219, 'lps'),
	(511989, 127, '2014-02-01 00:58:18.000000', 'consum', 0.0216, 'lps'),
	(511990, 127, '2014-02-01 00:58:19.000000', 'consum', 0.0210, 'lps'),
	(511991, 127, '2014-02-01 00:58:20.000000', 'consum', 0.0211, 'lps'),
	(511992, 127, '2014-02-01 00:58:21.000000', 'consum', 0.0213, 'lps'),
	(511993, 127, '2014-02-01 00:58:22.000000', 'consum', 0.0210, 'lps'),
	(511994, 127, '2014-02-01 00:58:23.000000', 'consum', 0.0216, 'lps'),
	(511995, 127, '2014-02-01 00:58:24.000000', 'consum', 0.0223, 'lps'),
	(511996, 127, '2014-02-01 00:58:25.000000', 'consum', 0.0225, 'lps'),
	(511997, 127, '2014-02-01 00:58:26.000000', 'consum', 0.0214, 'lps'),
	(511998, 127, '2014-02-01 00:58:27.000000', 'consum', 0.0220, 'lps'),
	(511999, 127, '2014-02-01 00:58:28.000000', 'consum', 0.0217, 'lps'),
	(512000, 127, '2014-02-01 00:58:29.000000', 'consum', 0.0213, 'lps'),
	(512001, 127, '2014-02-01 00:58:30.000000', 'consum', 0.0221, 'lps'),
	(512002, 127, '2014-02-01 00:58:31.000000', 'consum', 0.0224, 'lps'),
	(512003, 127, '2014-02-01 00:58:32.000000', 'consum', 0.0217, 'lps'),
	(512004, 127, '2014-02-01 00:58:33.000000', 'consum', 0.0217, 'lps'),
	(512005, 127, '2014-02-01 00:58:34.000000', 'consum', 0.0212, 'lps'),
	(512006, 127, '2014-02-01 00:58:35.000000', 'consum', 0.0213, 'lps'),
	(512007, 127, '2014-02-01 00:58:36.000000', 'consum', 0.0222, 'lps'),
	(512008, 127, '2014-02-01 00:58:37.000000', 'consum', 0.0213, 'lps'),
	(512009, 127, '2014-02-01 00:58:38.000000', 'consum', 0.0221, 'lps'),
	(512010, 127, '2014-02-01 00:58:39.000000', 'consum', 0.0225, 'lps'),
	(512011, 127, '2014-02-01 00:58:40.000000', 'consum', 0.0220, 'lps'),
	(512012, 127, '2014-02-01 00:58:41.000000', 'consum', 0.0217, 'lps'),
	(512013, 127, '2014-02-01 00:58:42.000000', 'consum', 0.0215, 'lps'),
	(512014, 127, '2014-02-01 00:58:43.000000', 'consum', 0.0213, 'lps'),
	(512015, 127, '2014-02-01 00:58:44.000000', 'consum', 0.0212, 'lps'),
	(512016, 127, '2014-02-01 00:58:45.000000', 'consum', 0.0211, 'lps'),
	(512017, 127, '2014-02-01 00:58:46.000000', 'consum', 0.0211, 'lps'),
	(512018, 127, '2014-02-01 00:58:47.000000', 'consum', 0.0211, 'lps'),
	(512019, 127, '2014-02-01 00:58:48.000000', 'consum', 0.0211, 'lps'),
	(512020, 127, '2014-02-01 00:58:49.000000', 'consum', 0.0214, 'lps'),
	(512021, 127, '2014-02-01 00:58:50.000000', 'consum', 0.0212, 'lps'),
	(512022, 127, '2014-02-01 00:58:51.000000', 'consum', 0.0210, 'lps'),
	(512023, 127, '2014-02-01 00:58:52.000000', 'consum', 0.0218, 'lps'),
	(512024, 127, '2014-02-01 00:58:53.000000', 'consum', 0.0219, 'lps'),
	(512025, 127, '2014-02-01 00:58:54.000000', 'consum', 0.0217, 'lps'),
	(512026, 127, '2014-02-01 00:58:55.000000', 'consum', 0.0216, 'lps'),
	(512027, 127, '2014-02-01 00:58:56.000000', 'consum', 0.0219, 'lps'),
	(512028, 127, '2014-02-01 00:58:57.000000', 'consum', 0.0224, 'lps'),
	(512029, 127, '2014-02-01 00:58:58.000000', 'consum', 0.0221, 'lps'),
	(512030, 127, '2014-02-01 00:58:59.000000', 'consum', 0.0222, 'lps'),
	(512031, 127, '2014-02-01 00:59:00.000000', 'consum', 0.0221, 'lps'),
	(512032, 127, '2014-02-01 00:59:01.000000', 'consum', 0.0215, 'lps'),
	(512033, 127, '2014-02-01 00:59:02.000000', 'consum', 0.0219, 'lps'),
	(512034, 127, '2014-02-01 00:59:03.000000', 'consum', 0.0225, 'lps'),
	(512035, 127, '2014-02-01 00:59:04.000000', 'consum', 0.0225, 'lps'),
	(512036, 127, '2014-02-01 00:59:05.000000', 'consum', 0.0223, 'lps'),
	(512037, 127, '2014-02-01 00:59:06.000000', 'consum', 0.0218, 'lps'),
	(512038, 127, '2014-02-01 00:59:07.000000', 'consum', 0.0224, 'lps'),
	(512039, 127, '2014-02-01 00:59:08.000000', 'consum', 0.0211, 'lps'),
	(512040, 127, '2014-02-01 00:59:09.000000', 'consum', 0.0220, 'lps'),
	(512041, 127, '2014-02-01 00:59:10.000000', 'consum', 0.0225, 'lps'),
	(512042, 127, '2014-02-01 00:59:11.000000', 'consum', 0.0222, 'lps'),
	(512043, 127, '2014-02-01 00:59:12.000000', 'consum', 0.0212, 'lps'),
	(512044, 127, '2014-02-01 00:59:13.000000', 'consum', 0.0216, 'lps'),
	(512045, 127, '2014-02-01 00:59:14.000000', 'consum', 0.0220, 'lps'),
	(512046, 127, '2014-02-01 00:59:15.000000', 'consum', 0.0210, 'lps'),
	(512047, 127, '2014-02-01 00:59:16.000000', 'consum', 0.0212, 'lps'),
	(512048, 127, '2014-02-01 00:59:17.000000', 'consum', 0.0220, 'lps'),
	(512049, 127, '2014-02-01 00:59:18.000000', 'consum', 0.0224, 'lps'),
	(512050, 127, '2014-02-01 00:59:19.000000', 'consum', 0.0219, 'lps'),
	(512051, 127, '2014-02-01 00:59:20.000000', 'consum', 0.0214, 'lps'),
	(512052, 127, '2014-02-01 00:59:21.000000', 'consum', 0.0218, 'lps'),
	(512053, 127, '2014-02-01 00:59:22.000000', 'consum', 0.0224, 'lps'),
	(512054, 127, '2014-02-01 00:59:23.000000', 'consum', 0.0224, 'lps'),
	(512055, 127, '2014-02-01 00:59:24.000000', 'consum', 0.0224, 'lps'),
	(512056, 127, '2014-02-01 00:59:25.000000', 'consum', 0.0221, 'lps'),
	(512057, 127, '2014-02-01 00:59:26.000000', 'consum', 0.0224, 'lps'),
	(512058, 127, '2014-02-01 00:59:27.000000', 'consum', 0.0216, 'lps'),
	(512059, 127, '2014-02-01 00:59:28.000000', 'consum', 0.0215, 'lps'),
	(512060, 127, '2014-02-01 00:59:29.000000', 'consum', 0.0217, 'lps'),
	(512061, 127, '2014-02-01 00:59:30.000000', 'consum', 0.0216, 'lps'),
	(512062, 127, '2014-02-01 00:59:31.000000', 'consum', 0.0217, 'lps'),
	(512063, 127, '2014-02-01 00:59:32.000000', 'consum', 0.0212, 'lps'),
	(512064, 127, '2014-02-01 00:59:33.000000', 'consum', 0.0216, 'lps'),
	(512065, 127, '2014-02-01 00:59:34.000000', 'consum', 0.0217, 'lps'),
	(512066, 127, '2014-02-01 00:59:35.000000', 'consum', 0.0213, 'lps'),
	(512067, 127, '2014-02-01 00:59:36.000000', 'consum', 0.0218, 'lps'),
	(512068, 127, '2014-02-01 00:59:37.000000', 'consum', 0.0212, 'lps'),
	(512069, 127, '2014-02-01 00:59:38.000000', 'consum', 0.0210, 'lps'),
	(512070, 127, '2014-02-01 00:59:39.000000', 'consum', 0.0221, 'lps'),
	(512071, 127, '2014-02-01 00:59:40.000000', 'consum', 0.0219, 'lps'),
	(512072, 127, '2014-02-01 00:59:41.000000', 'consum', 0.0220, 'lps'),
	(512073, 127, '2014-02-01 00:59:42.000000', 'consum', 0.0218, 'lps'),
	(512074, 127, '2014-02-01 00:59:43.000000', 'consum', 0.0220, 'lps'),
	(512075, 127, '2014-02-01 00:59:44.000000', 'consum', 0.0223, 'lps'),
	(512076, 127, '2014-02-01 00:59:45.000000', 'consum', 0.0213, 'lps'),
	(512077, 127, '2014-02-01 00:59:46.000000', 'consum', 0.0217, 'lps'),
	(512078, 127, '2014-02-01 00:59:47.000000', 'consum', 0.0221, 'lps'),
	(512079, 127, '2014-02-01 00:59:48.000000', 'consum', 0.0211, 'lps'),
	(512080, 127, '2014-02-01 00:59:49.000000', 'consum', 0.0217, 'lps'),
	(512081, 127, '2014-02-01 00:59:50.000000', 'consum', 0.0211, 'lps'),
	(512082, 127, '2014-02-01 00:59:51.000000', 'consum', 0.0224, 'lps'),
	(512083, 127, '2014-02-01 00:59:52.000000', 'consum', 0.0215, 'lps'),
	(512084, 127, '2014-02-01 00:59:53.000000', 'consum', 0.0225, 'lps'),
	(512085, 127, '2014-02-01 00:59:54.000000', 'consum', 0.0222, 'lps'),
	(512086, 127, '2014-02-01 00:59:55.000000', 'consum', 0.0224, 'lps'),
	(512087, 127, '2014-02-01 00:59:56.000000', 'consum', 0.0216, 'lps'),
	(512088, 127, '2014-02-01 00:59:57.000000', 'consum', 0.0212, 'lps'),
	(512089, 127, '2014-02-01 00:59:58.000000', 'consum', 0.0218, 'lps'),
	(512090, 127, '2014-02-01 00:59:59.000000', 'consum', 0.0213, 'lps'),
	(512091, 127, '2014-02-01 01:00:00.000000', 'consum', 0.0218, 'lps'),
	(512092, 127, '2014-02-01 01:00:01.000000', 'consum', 0.0225, 'lps'),
	(512093, 127, '2014-02-01 01:00:02.000000', 'consum', 0.0214, 'lps'),
	(512094, 127, '2014-02-01 01:00:03.000000', 'consum', 0.0217, 'lps'),
	(512095, 127, '2014-02-01 01:00:04.000000', 'consum', 0.0220, 'lps'),
	(512096, 127, '2014-02-01 01:00:05.000000', 'consum', 0.0220, 'lps'),
	(512097, 127, '2014-02-01 01:00:06.000000', 'consum', 0.0215, 'lps'),
	(512098, 127, '2014-02-01 01:00:07.000000', 'consum', 0.0224, 'lps'),
	(512099, 127, '2014-02-01 01:00:08.000000', 'consum', 0.0216, 'lps'),
	(512100, 127, '2014-02-01 01:00:09.000000', 'consum', 0.0215, 'lps'),
	(512101, 127, '2014-02-01 01:00:10.000000', 'consum', 0.0218, 'lps'),
	(512102, 127, '2014-02-01 01:00:11.000000', 'consum', 0.0220, 'lps'),
	(512103, 127, '2014-02-01 01:00:12.000000', 'consum', 0.0219, 'lps'),
	(512104, 127, '2014-02-01 01:00:13.000000', 'consum', 0.0210, 'lps'),
	(512105, 127, '2014-02-01 01:00:14.000000', 'consum', 0.0217, 'lps'),
	(512106, 127, '2014-02-01 01:00:15.000000', 'consum', 0.0214, 'lps'),
	(512107, 127, '2014-02-01 01:00:16.000000', 'consum', 0.0210, 'lps'),
	(512108, 127, '2014-02-01 01:00:17.000000', 'consum', 0.0215, 'lps'),
	(512109, 127, '2014-02-01 01:00:18.000000', 'consum', 0.0219, 'lps'),
	(512110, 127, '2014-02-01 01:00:19.000000', 'consum', 0.0222, 'lps'),
	(512111, 127, '2014-02-01 01:00:20.000000', 'consum', 0.0214, 'lps'),
	(512112, 127, '2014-02-01 01:00:21.000000', 'consum', 0.0212, 'lps'),
	(512113, 127, '2014-02-01 01:00:22.000000', 'consum', 0.0222, 'lps'),
	(512114, 127, '2014-02-01 01:00:23.000000', 'consum', 0.0219, 'lps'),
	(512115, 127, '2014-02-01 01:00:24.000000', 'consum', 0.0219, 'lps'),
	(512116, 127, '2014-02-01 01:00:25.000000', 'consum', 0.0212, 'lps'),
	(512117, 127, '2014-02-01 01:00:26.000000', 'consum', 0.0211, 'lps'),
	(512118, 127, '2014-02-01 01:00:27.000000', 'consum', 0.0210, 'lps'),
	(512119, 127, '2014-02-01 01:00:28.000000', 'consum', 0.0221, 'lps'),
	(512120, 127, '2014-02-01 01:00:29.000000', 'consum', 0.0220, 'lps'),
	(512121, 127, '2014-02-01 01:00:30.000000', 'consum', 0.0225, 'lps'),
	(512122, 127, '2014-02-01 01:00:31.000000', 'consum', 0.0224, 'lps'),
	(512123, 127, '2014-02-01 01:00:32.000000', 'consum', 0.0221, 'lps'),
	(512124, 127, '2014-02-01 01:00:33.000000', 'consum', 0.0222, 'lps'),
	(512125, 127, '2014-02-01 01:00:34.000000', 'consum', 0.0221, 'lps'),
	(512126, 127, '2014-02-01 01:00:35.000000', 'consum', 0.0215, 'lps'),
	(512127, 127, '2014-02-01 01:00:36.000000', 'consum', 0.0216, 'lps'),
	(512128, 127, '2014-02-01 01:00:37.000000', 'consum', 0.0210, 'lps'),
	(512129, 127, '2014-02-01 01:00:38.000000', 'consum', 0.0211, 'lps'),
	(512130, 127, '2014-02-01 01:00:39.000000', 'consum', 0.0215, 'lps'),
	(512131, 127, '2014-02-01 01:00:40.000000', 'consum', 0.0217, 'lps'),
	(512132, 127, '2014-02-01 01:00:41.000000', 'consum', 0.0212, 'lps'),
	(512133, 127, '2014-02-01 01:00:42.000000', 'consum', 0.0218, 'lps'),
	(512134, 127, '2014-02-01 01:00:43.000000', 'consum', 0.0213, 'lps'),
	(512135, 127, '2014-02-01 01:00:44.000000', 'consum', 0.0216, 'lps'),
	(512136, 127, '2014-02-01 01:00:45.000000', 'consum', 0.0215, 'lps'),
	(512137, 127, '2014-02-01 01:00:46.000000', 'consum', 0.0218, 'lps'),
	(512138, 127, '2014-02-01 01:00:47.000000', 'consum', 0.0219, 'lps'),
	(512139, 127, '2014-02-01 01:00:48.000000', 'consum', 0.0216, 'lps'),
	(512140, 127, '2014-02-01 01:00:49.000000', 'consum', 0.0215, 'lps'),
	(512141, 127, '2014-02-01 01:00:50.000000', 'consum', 0.0215, 'lps'),
	(512142, 127, '2014-02-01 01:00:51.000000', 'consum', 0.0222, 'lps'),
	(512143, 127, '2014-02-01 01:00:52.000000', 'consum', 0.0221, 'lps'),
	(512144, 127, '2014-02-01 01:00:53.000000', 'consum', 0.0216, 'lps'),
	(512145, 127, '2014-02-01 01:00:54.000000', 'consum', 0.0221, 'lps'),
	(512146, 127, '2014-02-01 01:00:55.000000', 'consum', 0.0216, 'lps'),
	(512147, 127, '2014-02-01 01:00:56.000000', 'consum', 0.0225, 'lps'),
	(512148, 127, '2014-02-01 01:00:57.000000', 'consum', 0.0219, 'lps'),
	(512149, 127, '2014-02-01 01:00:58.000000', 'consum', 0.0212, 'lps'),
	(512150, 127, '2014-02-01 01:00:59.000000', 'consum', 0.0223, 'lps'),
	(512151, 127, '2014-02-01 01:01:00.000000', 'consum', 0.0222, 'lps'),
	(512152, 127, '2014-02-01 01:01:01.000000', 'consum', 0.0216, 'lps'),
	(512153, 127, '2014-02-01 01:01:02.000000', 'consum', 0.0220, 'lps'),
	(512154, 127, '2014-02-01 01:01:03.000000', 'consum', 0.0213, 'lps'),
	(512155, 127, '2014-02-01 01:01:04.000000', 'consum', 0.0224, 'lps'),
	(512156, 127, '2014-02-01 01:01:05.000000', 'consum', 0.0211, 'lps'),
	(512157, 127, '2014-02-01 01:01:06.000000', 'consum', 0.0219, 'lps'),
	(512158, 127, '2014-02-01 01:01:07.000000', 'consum', 0.0223, 'lps'),
	(512159, 127, '2014-02-01 01:01:08.000000', 'consum', 0.0216, 'lps'),
	(512160, 127, '2014-02-01 01:01:09.000000', 'consum', 0.0217, 'lps'),
	(512161, 127, '2014-02-01 01:01:10.000000', 'consum', 0.0212, 'lps'),
	(512162, 127, '2014-02-01 01:01:11.000000', 'consum', 0.0214, 'lps'),
	(512163, 127, '2014-02-01 01:01:12.000000', 'consum', 0.0224, 'lps'),
	(512164, 127, '2014-02-01 01:01:13.000000', 'consum', 0.0221, 'lps'),
	(512165, 127, '2014-02-01 01:01:14.000000', 'consum', 0.0225, 'lps'),
	(512166, 127, '2014-02-01 01:01:15.000000', 'consum', 0.0218, 'lps'),
	(512167, 127, '2014-02-01 01:01:16.000000', 'consum', 0.0222, 'lps'),
	(512168, 127, '2014-02-01 01:01:17.000000', 'consum', 0.0216, 'lps'),
	(512169, 127, '2014-02-01 01:01:18.000000', 'consum', 0.0219, 'lps'),
	(512170, 127, '2014-02-01 01:01:19.000000', 'consum', 0.0221, 'lps'),
	(512171, 127, '2014-02-01 01:01:20.000000', 'consum', 0.0225, 'lps'),
	(512172, 127, '2014-02-01 01:01:21.000000', 'consum', 0.0219, 'lps'),
	(512173, 127, '2014-02-01 01:01:22.000000', 'consum', 0.0225, 'lps'),
	(512174, 127, '2014-02-01 01:01:23.000000', 'consum', 0.0210, 'lps'),
	(512175, 127, '2014-02-01 01:01:24.000000', 'consum', 0.0215, 'lps'),
	(512176, 127, '2014-02-01 01:01:25.000000', 'consum', 0.0221, 'lps'),
	(512177, 127, '2014-02-01 01:01:26.000000', 'consum', 0.0219, 'lps'),
	(512178, 127, '2014-02-01 01:01:27.000000', 'consum', 0.0221, 'lps'),
	(512179, 127, '2014-02-01 01:01:28.000000', 'consum', 0.0223, 'lps'),
	(512180, 127, '2014-02-01 01:01:29.000000', 'consum', 0.0225, 'lps'),
	(512181, 127, '2014-02-01 01:01:30.000000', 'consum', 0.0215, 'lps'),
	(512182, 127, '2014-02-01 01:01:31.000000', 'consum', 0.0224, 'lps'),
	(512183, 127, '2014-02-01 01:01:32.000000', 'consum', 0.0218, 'lps'),
	(512184, 127, '2014-02-01 01:01:33.000000', 'consum', 0.0224, 'lps'),
	(512185, 127, '2014-02-01 01:01:34.000000', 'consum', 0.0210, 'lps'),
	(512186, 127, '2014-02-01 01:01:35.000000', 'consum', 0.0215, 'lps'),
	(512187, 127, '2014-02-01 01:01:36.000000', 'consum', 0.0218, 'lps'),
	(512188, 127, '2014-02-01 01:01:37.000000', 'consum', 0.0222, 'lps'),
	(512189, 127, '2014-02-01 01:01:38.000000', 'consum', 0.0212, 'lps'),
	(512190, 127, '2014-02-01 01:01:39.000000', 'consum', 0.0217, 'lps'),
	(512191, 127, '2014-02-01 01:01:40.000000', 'consum', 0.0225, 'lps'),
	(512192, 127, '2014-02-01 01:01:41.000000', 'consum', 0.0216, 'lps'),
	(512193, 127, '2014-02-01 01:01:42.000000', 'consum', 0.0213, 'lps'),
	(512194, 127, '2014-02-01 01:01:43.000000', 'consum', 0.0223, 'lps'),
	(512195, 127, '2014-02-01 01:01:44.000000', 'consum', 0.0218, 'lps'),
	(512196, 127, '2014-02-01 01:01:45.000000', 'consum', 0.0213, 'lps'),
	(512197, 127, '2014-02-01 01:01:46.000000', 'consum', 0.0218, 'lps'),
	(512198, 127, '2014-02-01 01:01:47.000000', 'consum', 0.0210, 'lps'),
	(512199, 127, '2014-02-01 01:01:48.000000', 'consum', 0.0217, 'lps'),
	(512200, 127, '2014-02-01 01:01:49.000000', 'consum', 0.0214, 'lps'),
	(512201, 127, '2014-02-01 01:01:50.000000', 'consum', 0.0210, 'lps'),
	(512202, 127, '2014-02-01 01:01:51.000000', 'consum', 0.0212, 'lps'),
	(512203, 127, '2014-02-01 01:01:52.000000', 'consum', 0.0224, 'lps'),
	(512204, 127, '2014-02-01 01:01:53.000000', 'consum', 0.0225, 'lps'),
	(512205, 127, '2014-02-01 01:01:54.000000', 'consum', 0.0213, 'lps'),
	(512206, 127, '2014-02-01 01:01:55.000000', 'consum', 0.0210, 'lps'),
	(512207, 127, '2014-02-01 01:01:56.000000', 'consum', 0.0220, 'lps'),
	(512208, 127, '2014-02-01 01:01:57.000000', 'consum', 0.0210, 'lps'),
	(512209, 127, '2014-02-01 01:01:58.000000', 'consum', 0.0215, 'lps'),
	(512210, 127, '2014-02-01 01:01:59.000000', 'consum', 0.0217, 'lps'),
	(512211, 127, '2014-02-01 01:02:00.000000', 'consum', 0.0214, 'lps'),
	(512212, 127, '2014-02-01 01:02:01.000000', 'consum', 0.0225, 'lps'),
	(512213, 127, '2014-02-01 01:02:02.000000', 'consum', 0.0210, 'lps'),
	(512214, 127, '2014-02-01 01:02:03.000000', 'consum', 0.0215, 'lps'),
	(512215, 127, '2014-02-01 01:02:04.000000', 'consum', 0.0219, 'lps'),
	(512216, 127, '2014-02-01 01:02:05.000000', 'consum', 0.0224, 'lps'),
	(512217, 127, '2014-02-01 01:02:06.000000', 'consum', 0.0224, 'lps'),
	(512218, 127, '2014-02-01 01:02:07.000000', 'consum', 0.0220, 'lps'),
	(512219, 127, '2014-02-01 01:02:08.000000', 'consum', 0.0220, 'lps'),
	(512220, 127, '2014-02-01 01:02:09.000000', 'consum', 0.0213, 'lps'),
	(512221, 127, '2014-02-01 01:02:10.000000', 'consum', 0.0214, 'lps'),
	(512222, 127, '2014-02-01 01:02:11.000000', 'consum', 0.0218, 'lps'),
	(512223, 127, '2014-02-01 01:02:12.000000', 'consum', 0.0225, 'lps'),
	(512224, 127, '2014-02-01 01:02:13.000000', 'consum', 0.0211, 'lps'),
	(512225, 127, '2014-02-01 01:02:14.000000', 'consum', 0.0221, 'lps'),
	(512226, 127, '2014-02-01 01:02:15.000000', 'consum', 0.0213, 'lps'),
	(512227, 127, '2014-02-01 01:02:16.000000', 'consum', 0.0225, 'lps'),
	(512228, 127, '2014-02-01 01:02:17.000000', 'consum', 0.0213, 'lps'),
	(512229, 127, '2014-02-01 01:02:18.000000', 'consum', 0.0213, 'lps'),
	(512230, 127, '2014-02-01 01:02:19.000000', 'consum', 0.0218, 'lps'),
	(512231, 127, '2014-02-01 01:02:20.000000', 'consum', 0.0224, 'lps'),
	(512232, 127, '2014-02-01 01:02:21.000000', 'consum', 0.0224, 'lps'),
	(512233, 127, '2014-02-01 01:02:22.000000', 'consum', 0.0224, 'lps'),
	(512234, 127, '2014-02-01 01:02:23.000000', 'consum', 0.0223, 'lps'),
	(512235, 127, '2014-02-01 01:02:24.000000', 'consum', 0.0217, 'lps'),
	(512236, 127, '2014-02-01 01:02:25.000000', 'consum', 0.0221, 'lps'),
	(512237, 127, '2014-02-01 01:02:26.000000', 'consum', 0.0212, 'lps'),
	(512238, 127, '2014-02-01 01:02:27.000000', 'consum', 0.0220, 'lps'),
	(512239, 127, '2014-02-01 01:02:28.000000', 'consum', 0.0223, 'lps'),
	(512240, 127, '2014-02-01 01:02:29.000000', 'consum', 0.0214, 'lps'),
	(512241, 127, '2014-02-01 01:02:30.000000', 'consum', 0.0224, 'lps'),
	(512242, 127, '2014-02-01 01:02:31.000000', 'consum', 0.0221, 'lps'),
	(512243, 127, '2014-02-01 01:02:32.000000', 'consum', 0.0222, 'lps'),
	(512244, 127, '2014-02-01 01:02:33.000000', 'consum', 0.0222, 'lps'),
	(512245, 127, '2014-02-01 01:02:34.000000', 'consum', 0.0217, 'lps'),
	(512246, 127, '2014-02-01 01:02:35.000000', 'consum', 0.0211, 'lps'),
	(512247, 127, '2014-02-01 01:02:36.000000', 'consum', 0.0225, 'lps'),
	(512248, 127, '2014-02-01 01:02:37.000000', 'consum', 0.0220, 'lps'),
	(512249, 127, '2014-02-01 01:02:38.000000', 'consum', 0.0214, 'lps'),
	(512250, 127, '2014-02-01 01:02:39.000000', 'consum', 0.0217, 'lps'),
	(512251, 127, '2014-02-01 01:02:40.000000', 'consum', 0.0218, 'lps'),
	(512252, 127, '2014-02-01 01:02:41.000000', 'consum', 0.0215, 'lps'),
	(512253, 127, '2014-02-01 01:02:42.000000', 'consum', 0.0212, 'lps'),
	(512254, 127, '2014-02-01 01:02:43.000000', 'consum', 0.0219, 'lps'),
	(512255, 127, '2014-02-01 01:02:44.000000', 'consum', 0.0220, 'lps'),
	(512256, 127, '2014-02-01 01:02:45.000000', 'consum', 0.0216, 'lps'),
	(512257, 127, '2014-02-01 01:02:46.000000', 'consum', 0.0210, 'lps'),
	(512258, 127, '2014-02-01 01:02:47.000000', 'consum', 0.0211, 'lps'),
	(512259, 127, '2014-02-01 01:02:48.000000', 'consum', 0.0212, 'lps'),
	(512260, 127, '2014-02-01 01:02:49.000000', 'consum', 0.0220, 'lps'),
	(512261, 127, '2014-02-01 01:02:50.000000', 'consum', 0.0222, 'lps'),
	(512262, 127, '2014-02-01 01:02:51.000000', 'consum', 0.0222, 'lps'),
	(512263, 127, '2014-02-01 01:02:52.000000', 'consum', 0.0222, 'lps'),
	(512264, 127, '2014-02-01 01:02:53.000000', 'consum', 0.0217, 'lps'),
	(512265, 127, '2014-02-01 01:02:54.000000', 'consum', 0.0212, 'lps'),
	(512266, 127, '2014-02-01 01:02:55.000000', 'consum', 0.0213, 'lps'),
	(512267, 127, '2014-02-01 01:02:56.000000', 'consum', 0.0219, 'lps'),
	(512268, 127, '2014-02-01 01:02:57.000000', 'consum', 0.0216, 'lps'),
	(512269, 127, '2014-02-01 01:02:58.000000', 'consum', 0.0212, 'lps'),
	(512270, 127, '2014-02-01 01:02:59.000000', 'consum', 0.0219, 'lps'),
	(512271, 127, '2014-02-01 01:03:00.000000', 'consum', 0.0219, 'lps'),
	(512272, 127, '2014-02-01 01:03:01.000000', 'consum', 0.0211, 'lps'),
	(512273, 127, '2014-02-01 01:03:02.000000', 'consum', 0.0220, 'lps'),
	(512274, 127, '2014-02-01 01:03:03.000000', 'consum', 0.0225, 'lps'),
	(512275, 127, '2014-02-01 01:03:04.000000', 'consum', 0.0210, 'lps'),
	(512276, 127, '2014-02-01 01:03:05.000000', 'consum', 0.0214, 'lps'),
	(512277, 127, '2014-02-01 01:03:06.000000', 'consum', 0.0212, 'lps'),
	(512278, 127, '2014-02-01 01:03:07.000000', 'consum', 0.0223, 'lps'),
	(512279, 127, '2014-02-01 01:03:08.000000', 'consum', 0.0225, 'lps'),
	(512280, 127, '2014-02-01 01:03:09.000000', 'consum', 0.0212, 'lps'),
	(512281, 127, '2014-02-01 01:03:10.000000', 'consum', 0.0210, 'lps'),
	(512282, 127, '2014-02-01 01:03:11.000000', 'consum', 0.0220, 'lps'),
	(512283, 127, '2014-02-01 01:03:12.000000', 'consum', 0.0212, 'lps'),
	(512284, 127, '2014-02-01 01:03:13.000000', 'consum', 0.0221, 'lps'),
	(512285, 127, '2014-02-01 01:03:14.000000', 'consum', 0.0214, 'lps'),
	(512286, 127, '2014-02-01 01:03:15.000000', 'consum', 0.0215, 'lps'),
	(512287, 127, '2014-02-01 01:03:16.000000', 'consum', 0.0220, 'lps'),
	(512288, 127, '2014-02-01 01:03:17.000000', 'consum', 0.0214, 'lps'),
	(512289, 127, '2014-02-01 01:03:18.000000', 'consum', 0.0217, 'lps'),
	(512290, 127, '2014-02-01 01:03:19.000000', 'consum', 0.0217, 'lps'),
	(512291, 127, '2014-02-01 01:03:20.000000', 'consum', 0.0225, 'lps'),
	(512292, 127, '2014-02-01 01:03:21.000000', 'consum', 0.0215, 'lps'),
	(512293, 127, '2014-02-01 01:03:22.000000', 'consum', 0.0222, 'lps'),
	(512294, 127, '2014-02-01 01:03:23.000000', 'consum', 0.0224, 'lps'),
	(512295, 127, '2014-02-01 01:03:24.000000', 'consum', 0.0215, 'lps'),
	(512296, 127, '2014-02-01 01:03:25.000000', 'consum', 0.0223, 'lps'),
	(512297, 127, '2014-02-01 01:03:26.000000', 'consum', 0.0214, 'lps'),
	(512298, 127, '2014-02-01 01:03:27.000000', 'consum', 0.0224, 'lps'),
	(512299, 127, '2014-02-01 01:03:28.000000', 'consum', 0.0218, 'lps'),
	(512300, 127, '2014-02-01 01:03:29.000000', 'consum', 0.0225, 'lps'),
	(512301, 127, '2014-02-01 01:03:30.000000', 'consum', 0.0214, 'lps'),
	(512302, 127, '2014-02-01 01:03:31.000000', 'consum', 0.0216, 'lps'),
	(512303, 127, '2014-02-01 01:03:32.000000', 'consum', 0.0212, 'lps'),
	(512304, 127, '2014-02-01 01:03:33.000000', 'consum', 0.0220, 'lps'),
	(512305, 127, '2014-02-01 01:03:34.000000', 'consum', 0.0222, 'lps'),
	(512306, 127, '2014-02-01 01:03:35.000000', 'consum', 0.0225, 'lps'),
	(512307, 127, '2014-02-01 01:03:36.000000', 'consum', 0.0219, 'lps'),
	(512308, 127, '2014-02-01 01:03:37.000000', 'consum', 0.0223, 'lps'),
	(512309, 127, '2014-02-01 01:03:38.000000', 'consum', 0.0220, 'lps'),
	(512310, 127, '2014-02-01 01:03:39.000000', 'consum', 0.0220, 'lps'),
	(512311, 127, '2014-02-01 01:03:40.000000', 'consum', 0.0215, 'lps'),
	(512312, 127, '2014-02-01 01:03:41.000000', 'consum', 0.0221, 'lps'),
	(512313, 127, '2014-02-01 01:03:42.000000', 'consum', 0.0217, 'lps'),
	(512314, 127, '2014-02-01 01:03:43.000000', 'consum', 0.0215, 'lps'),
	(512315, 127, '2014-02-01 01:03:44.000000', 'consum', 0.0212, 'lps'),
	(512316, 127, '2014-02-01 01:03:45.000000', 'consum', 0.0222, 'lps'),
	(512317, 127, '2014-02-01 01:03:46.000000', 'consum', 0.0219, 'lps'),
	(512318, 127, '2014-02-01 01:03:47.000000', 'consum', 0.0217, 'lps'),
	(512319, 127, '2014-02-01 01:03:48.000000', 'consum', 0.0217, 'lps'),
	(512320, 127, '2014-02-01 01:03:49.000000', 'consum', 0.0211, 'lps'),
	(512321, 127, '2014-02-01 01:03:50.000000', 'consum', 0.0225, 'lps'),
	(512322, 127, '2014-02-01 01:03:51.000000', 'consum', 0.0220, 'lps'),
	(512323, 127, '2014-02-01 01:03:52.000000', 'consum', 0.0214, 'lps'),
	(512324, 127, '2014-02-01 01:03:53.000000', 'consum', 0.0219, 'lps'),
	(512325, 127, '2014-02-01 01:03:54.000000', 'consum', 0.0210, 'lps'),
	(512326, 127, '2014-02-01 01:03:55.000000', 'consum', 0.0217, 'lps'),
	(512327, 127, '2014-02-01 01:03:56.000000', 'consum', 0.0214, 'lps'),
	(512328, 127, '2014-02-01 01:03:57.000000', 'consum', 0.0210, 'lps'),
	(512329, 127, '2014-02-01 01:03:58.000000', 'consum', 0.0213, 'lps'),
	(512330, 127, '2014-02-01 01:03:59.000000', 'consum', 0.0211, 'lps'),
	(512331, 127, '2014-02-01 01:04:00.000000', 'consum', 0.0220, 'lps'),
	(512332, 127, '2014-02-01 01:04:01.000000', 'consum', 0.0225, 'lps'),
	(512333, 127, '2014-02-01 01:04:02.000000', 'consum', 0.0223, 'lps'),
	(512334, 127, '2014-02-01 01:04:03.000000', 'consum', 0.0215, 'lps'),
	(512335, 127, '2014-02-01 01:04:04.000000', 'consum', 0.0215, 'lps'),
	(512336, 127, '2014-02-01 01:04:05.000000', 'consum', 0.0217, 'lps'),
	(512337, 127, '2014-02-01 01:04:06.000000', 'consum', 0.0217, 'lps'),
	(512338, 127, '2014-02-01 01:04:07.000000', 'consum', 0.0225, 'lps'),
	(512339, 127, '2014-02-01 01:04:08.000000', 'consum', 0.0216, 'lps'),
	(512340, 127, '2014-02-01 01:04:09.000000', 'consum', 0.0212, 'lps'),
	(512341, 127, '2014-02-01 01:04:10.000000', 'consum', 0.0217, 'lps'),
	(512342, 127, '2014-02-01 01:04:11.000000', 'consum', 0.0224, 'lps'),
	(512343, 127, '2014-02-01 01:04:12.000000', 'consum', 0.0225, 'lps'),
	(512344, 127, '2014-02-01 01:04:13.000000', 'consum', 0.0215, 'lps'),
	(512345, 127, '2014-02-01 01:04:14.000000', 'consum', 0.0223, 'lps'),
	(512346, 127, '2014-02-01 01:04:15.000000', 'consum', 0.0213, 'lps'),
	(512347, 127, '2014-02-01 01:04:16.000000', 'consum', 0.0217, 'lps'),
	(512348, 127, '2014-02-01 01:04:17.000000', 'consum', 0.0222, 'lps'),
	(512349, 127, '2014-02-01 01:04:18.000000', 'consum', 0.0215, 'lps'),
	(512350, 127, '2014-02-01 01:04:19.000000', 'consum', 0.0216, 'lps'),
	(512351, 127, '2014-02-01 01:04:20.000000', 'consum', 0.0211, 'lps'),
	(512352, 127, '2014-02-01 01:04:21.000000', 'consum', 0.0212, 'lps'),
	(512353, 127, '2014-02-01 01:04:22.000000', 'consum', 0.0217, 'lps'),
	(512354, 127, '2014-02-01 01:04:23.000000', 'consum', 0.0224, 'lps'),
	(512355, 127, '2014-02-01 01:04:24.000000', 'consum', 0.0210, 'lps'),
	(512356, 127, '2014-02-01 01:04:25.000000', 'consum', 0.0220, 'lps'),
	(512357, 127, '2014-02-01 01:04:26.000000', 'consum', 0.0225, 'lps'),
	(512358, 127, '2014-02-01 01:04:27.000000', 'consum', 0.0224, 'lps'),
	(512359, 127, '2014-02-01 01:04:28.000000', 'consum', 0.0220, 'lps'),
	(512360, 127, '2014-02-01 01:04:29.000000', 'consum', 0.0219, 'lps'),
	(512361, 127, '2014-02-01 01:04:30.000000', 'consum', 0.0210, 'lps'),
	(512362, 127, '2014-02-01 01:04:31.000000', 'consum', 0.0217, 'lps'),
	(512363, 127, '2014-02-01 01:04:32.000000', 'consum', 0.0212, 'lps'),
	(512364, 127, '2014-02-01 01:04:33.000000', 'consum', 0.0215, 'lps'),
	(512365, 127, '2014-02-01 01:04:34.000000', 'consum', 0.0215, 'lps'),
	(512366, 127, '2014-02-01 01:04:35.000000', 'consum', 0.0219, 'lps'),
	(512367, 127, '2014-02-01 01:04:36.000000', 'consum', 0.0225, 'lps'),
	(512368, 127, '2014-02-01 01:04:37.000000', 'consum', 0.0210, 'lps'),
	(512369, 127, '2014-02-01 01:04:38.000000', 'consum', 0.0215, 'lps'),
	(512370, 127, '2014-02-01 01:04:39.000000', 'consum', 0.0218, 'lps'),
	(512371, 127, '2014-02-01 01:04:40.000000', 'consum', 0.0219, 'lps'),
	(512372, 127, '2014-02-01 01:04:41.000000', 'consum', 0.0217, 'lps'),
	(512373, 127, '2014-02-01 01:04:42.000000', 'consum', 0.0220, 'lps'),
	(512374, 127, '2014-02-01 01:04:43.000000', 'consum', 0.0221, 'lps'),
	(512375, 127, '2014-02-01 01:04:44.000000', 'consum', 0.0219, 'lps'),
	(512376, 127, '2014-02-01 01:04:45.000000', 'consum', 0.0225, 'lps'),
	(512377, 127, '2014-02-01 01:04:46.000000', 'consum', 0.0210, 'lps'),
	(512378, 127, '2014-02-01 01:04:47.000000', 'consum', 0.0211, 'lps'),
	(512379, 127, '2014-02-01 01:04:48.000000', 'consum', 0.0217, 'lps'),
	(512380, 127, '2014-02-01 01:04:49.000000', 'consum', 0.0212, 'lps'),
	(512381, 127, '2014-02-01 01:04:50.000000', 'consum', 0.0214, 'lps'),
	(512382, 127, '2014-02-01 01:04:51.000000', 'consum', 0.0211, 'lps'),
	(512383, 127, '2014-02-01 01:04:52.000000', 'consum', 0.0218, 'lps'),
	(512384, 127, '2014-02-01 01:04:53.000000', 'consum', 0.0214, 'lps'),
	(512385, 127, '2014-02-01 01:04:54.000000', 'consum', 0.0224, 'lps'),
	(512386, 127, '2014-02-01 01:04:55.000000', 'consum', 0.0220, 'lps'),
	(512387, 127, '2014-02-01 01:04:56.000000', 'consum', 0.0219, 'lps'),
	(512388, 127, '2014-02-01 01:04:57.000000', 'consum', 0.0223, 'lps'),
	(512389, 127, '2014-02-01 01:04:58.000000', 'consum', 0.0219, 'lps'),
	(512390, 127, '2014-02-01 01:04:59.000000', 'consum', 0.0216, 'lps'),
	(512391, 127, '2014-02-01 01:05:00.000000', 'consum', 0.0214, 'lps'),
	(512392, 127, '2014-02-01 01:05:01.000000', 'consum', 0.0212, 'lps'),
	(512393, 127, '2014-02-01 01:05:02.000000', 'consum', 0.0223, 'lps'),
	(512394, 127, '2014-02-01 01:05:03.000000', 'consum', 0.0221, 'lps'),
	(512395, 127, '2014-02-01 01:05:04.000000', 'consum', 0.0213, 'lps'),
	(512396, 127, '2014-02-01 01:05:05.000000', 'consum', 0.0223, 'lps'),
	(512397, 127, '2014-02-01 01:05:06.000000', 'consum', 0.0217, 'lps'),
	(512398, 127, '2014-02-01 01:05:07.000000', 'consum', 0.0224, 'lps'),
	(512399, 127, '2014-02-01 01:05:08.000000', 'consum', 0.0210, 'lps'),
	(512400, 127, '2014-02-01 01:05:09.000000', 'consum', 0.0219, 'lps'),
	(512401, 127, '2014-02-01 01:05:10.000000', 'consum', 0.0222, 'lps'),
	(512402, 127, '2014-02-01 01:05:11.000000', 'consum', 0.0210, 'lps'),
	(512403, 127, '2014-02-01 01:05:12.000000', 'consum', 0.0225, 'lps'),
	(512404, 127, '2014-02-01 01:05:13.000000', 'consum', 0.0219, 'lps'),
	(512405, 127, '2014-02-01 01:05:14.000000', 'consum', 0.0211, 'lps'),
	(512406, 127, '2014-02-01 01:05:15.000000', 'consum', 0.0220, 'lps'),
	(512407, 127, '2014-02-01 01:05:16.000000', 'consum', 0.0211, 'lps'),
	(512408, 127, '2014-02-01 01:05:17.000000', 'consum', 0.0215, 'lps'),
	(512409, 127, '2014-02-01 01:05:18.000000', 'consum', 0.0218, 'lps'),
	(512410, 127, '2014-02-01 01:05:19.000000', 'consum', 0.0218, 'lps'),
	(512411, 127, '2014-02-01 01:05:20.000000', 'consum', 0.0211, 'lps'),
	(512412, 127, '2014-02-01 01:05:21.000000', 'consum', 0.0225, 'lps'),
	(512413, 127, '2014-02-01 01:05:22.000000', 'consum', 0.0216, 'lps'),
	(512414, 127, '2014-02-01 01:05:23.000000', 'consum', 0.0214, 'lps'),
	(512415, 127, '2014-02-01 01:05:24.000000', 'consum', 0.0212, 'lps'),
	(512416, 127, '2014-02-01 01:05:25.000000', 'consum', 0.0225, 'lps'),
	(512417, 127, '2014-02-01 01:05:26.000000', 'consum', 0.0216, 'lps'),
	(512418, 127, '2014-02-01 01:05:27.000000', 'consum', 0.0212, 'lps'),
	(512419, 127, '2014-02-01 01:05:28.000000', 'consum', 0.0216, 'lps'),
	(512420, 127, '2014-02-01 01:05:29.000000', 'consum', 0.0220, 'lps'),
	(512421, 127, '2014-02-01 01:05:30.000000', 'consum', 0.0210, 'lps'),
	(512422, 127, '2014-02-01 01:05:31.000000', 'consum', 0.0212, 'lps'),
	(512423, 127, '2014-02-01 01:05:32.000000', 'consum', 0.0222, 'lps'),
	(512424, 127, '2014-02-01 01:05:33.000000', 'consum', 0.0215, 'lps'),
	(512425, 127, '2014-02-01 01:05:34.000000', 'consum', 0.0215, 'lps'),
	(512426, 127, '2014-02-01 01:05:35.000000', 'consum', 0.0223, 'lps'),
	(512427, 127, '2014-02-01 01:05:36.000000', 'consum', 0.0225, 'lps'),
	(512428, 127, '2014-02-01 01:05:37.000000', 'consum', 0.0217, 'lps'),
	(512429, 127, '2014-02-01 01:05:38.000000', 'consum', 0.0218, 'lps'),
	(512430, 127, '2014-02-01 01:05:39.000000', 'consum', 0.0211, 'lps'),
	(512431, 127, '2014-02-01 01:05:40.000000', 'consum', 0.0222, 'lps'),
	(512432, 127, '2014-02-01 01:05:41.000000', 'consum', 0.0222, 'lps'),
	(512433, 127, '2014-02-01 01:05:42.000000', 'consum', 0.0217, 'lps'),
	(512434, 127, '2014-02-01 01:05:43.000000', 'consum', 0.0211, 'lps'),
	(512435, 127, '2014-02-01 01:05:44.000000', 'consum', 0.0210, 'lps'),
	(512436, 127, '2014-02-01 01:05:45.000000', 'consum', 0.0221, 'lps'),
	(512437, 127, '2014-02-01 01:05:46.000000', 'consum', 0.0220, 'lps'),
	(512438, 127, '2014-02-01 01:05:47.000000', 'consum', 0.0213, 'lps'),
	(512439, 127, '2014-02-01 01:05:48.000000', 'consum', 0.0224, 'lps'),
	(512440, 127, '2014-02-01 01:05:49.000000', 'consum', 0.0225, 'lps'),
	(512441, 127, '2014-02-01 01:05:50.000000', 'consum', 0.0211, 'lps'),
	(512442, 127, '2014-02-01 01:05:51.000000', 'consum', 0.0219, 'lps'),
	(512443, 127, '2014-02-01 01:05:52.000000', 'consum', 0.0219, 'lps'),
	(512444, 127, '2014-02-01 01:05:53.000000', 'consum', 0.0213, 'lps'),
	(512445, 127, '2014-02-01 01:05:54.000000', 'consum', 0.0214, 'lps'),
	(512446, 127, '2014-02-01 01:05:55.000000', 'consum', 0.0220, 'lps'),
	(512447, 127, '2014-02-01 01:05:56.000000', 'consum', 0.0218, 'lps'),
	(512448, 127, '2014-02-01 01:05:57.000000', 'consum', 0.0219, 'lps'),
	(512449, 127, '2014-02-01 01:05:58.000000', 'consum', 0.0217, 'lps'),
	(512450, 127, '2014-02-01 01:05:59.000000', 'consum', 0.0217, 'lps'),
	(512451, 127, '2014-02-01 01:06:00.000000', 'consum', 0.0210, 'lps'),
	(512452, 127, '2014-02-01 01:06:01.000000', 'consum', 0.0222, 'lps'),
	(512453, 127, '2014-02-01 01:06:02.000000', 'consum', 0.0222, 'lps'),
	(512454, 127, '2014-02-01 01:06:03.000000', 'consum', 0.0219, 'lps'),
	(512455, 127, '2014-02-01 01:06:04.000000', 'consum', 0.0220, 'lps'),
	(512456, 127, '2014-02-01 01:06:05.000000', 'consum', 0.0218, 'lps'),
	(512457, 127, '2014-02-01 01:06:06.000000', 'consum', 0.0219, 'lps'),
	(512458, 127, '2014-02-01 01:06:07.000000', 'consum', 0.0216, 'lps'),
	(512459, 127, '2014-02-01 01:06:08.000000', 'consum', 0.0215, 'lps'),
	(512460, 127, '2014-02-01 01:06:09.000000', 'consum', 0.0217, 'lps'),
	(512461, 127, '2014-02-01 01:06:10.000000', 'consum', 0.0212, 'lps'),
	(512462, 127, '2014-02-01 01:06:11.000000', 'consum', 0.0218, 'lps'),
	(512463, 127, '2014-02-01 01:06:12.000000', 'consum', 0.0211, 'lps'),
	(512464, 127, '2014-02-01 01:06:13.000000', 'consum', 0.0224, 'lps'),
	(512465, 127, '2014-02-01 01:06:14.000000', 'consum', 0.0211, 'lps'),
	(512466, 127, '2014-02-01 01:06:15.000000', 'consum', 0.0225, 'lps'),
	(512467, 127, '2014-02-01 01:06:16.000000', 'consum', 0.0219, 'lps'),
	(512468, 127, '2014-02-01 01:06:17.000000', 'consum', 0.0225, 'lps'),
	(512469, 127, '2014-02-01 01:06:18.000000', 'consum', 0.0212, 'lps'),
	(512470, 127, '2014-02-01 01:06:19.000000', 'consum', 0.0224, 'lps'),
	(512471, 127, '2014-02-01 01:06:20.000000', 'consum', 0.0211, 'lps'),
	(512472, 127, '2014-02-01 01:06:21.000000', 'consum', 0.0220, 'lps'),
	(512473, 127, '2014-02-01 01:06:22.000000', 'consum', 0.0225, 'lps'),
	(512474, 127, '2014-02-01 01:06:23.000000', 'consum', 0.0225, 'lps'),
	(512475, 127, '2014-02-01 01:06:24.000000', 'consum', 0.0223, 'lps'),
	(512476, 127, '2014-02-01 01:06:25.000000', 'consum', 0.0214, 'lps'),
	(512477, 127, '2014-02-01 01:06:26.000000', 'consum', 0.0223, 'lps'),
	(512478, 127, '2014-02-01 01:06:27.000000', 'consum', 0.0217, 'lps'),
	(512479, 127, '2014-02-01 01:06:28.000000', 'consum', 0.0220, 'lps'),
	(512480, 127, '2014-02-01 01:06:29.000000', 'consum', 0.0211, 'lps'),
	(512481, 127, '2014-02-01 01:06:30.000000', 'consum', 0.0214, 'lps'),
	(512482, 127, '2014-02-01 01:06:31.000000', 'consum', 0.0215, 'lps'),
	(512483, 127, '2014-02-01 01:06:32.000000', 'consum', 0.0222, 'lps'),
	(512484, 127, '2014-02-01 01:06:33.000000', 'consum', 0.0223, 'lps'),
	(512485, 127, '2014-02-01 01:06:34.000000', 'consum', 0.0224, 'lps'),
	(512486, 127, '2014-02-01 01:06:35.000000', 'consum', 0.0210, 'lps'),
	(512487, 127, '2014-02-01 01:06:36.000000', 'consum', 0.0217, 'lps'),
	(512488, 127, '2014-02-01 01:06:37.000000', 'consum', 0.0212, 'lps'),
	(512489, 127, '2014-02-01 01:06:38.000000', 'consum', 0.0214, 'lps'),
	(512490, 127, '2014-02-01 01:06:39.000000', 'consum', 0.0211, 'lps'),
	(512491, 127, '2014-02-01 01:06:40.000000', 'consum', 0.0219, 'lps'),
	(512492, 127, '2014-02-01 01:06:41.000000', 'consum', 0.0221, 'lps'),
	(512493, 127, '2014-02-01 01:06:42.000000', 'consum', 0.0224, 'lps'),
	(512494, 127, '2014-02-01 01:06:43.000000', 'consum', 0.0214, 'lps'),
	(512495, 127, '2014-02-01 01:06:44.000000', 'consum', 0.0222, 'lps'),
	(512496, 127, '2014-02-01 01:06:45.000000', 'consum', 0.0224, 'lps'),
	(512497, 127, '2014-02-01 01:06:46.000000', 'consum', 0.0215, 'lps'),
	(512498, 127, '2014-02-01 01:06:47.000000', 'consum', 0.0225, 'lps'),
	(512499, 127, '2014-02-01 01:06:48.000000', 'consum', 0.0224, 'lps'),
	(512500, 127, '2014-02-01 01:06:49.000000', 'consum', 0.0218, 'lps'),
	(512501, 127, '2014-02-01 01:06:50.000000', 'consum', 0.0224, 'lps'),
	(512502, 127, '2014-02-01 01:06:51.000000', 'consum', 0.0225, 'lps'),
	(512503, 127, '2014-02-01 01:06:52.000000', 'consum', 0.0212, 'lps'),
	(512504, 127, '2014-02-01 01:06:53.000000', 'consum', 0.0223, 'lps'),
	(512505, 127, '2014-02-01 01:06:54.000000', 'consum', 0.0220, 'lps'),
	(512506, 127, '2014-02-01 01:06:55.000000', 'consum', 0.0221, 'lps'),
	(512507, 127, '2014-02-01 01:06:56.000000', 'consum', 0.0219, 'lps'),
	(512508, 127, '2014-02-01 01:06:57.000000', 'consum', 0.0210, 'lps'),
	(512509, 127, '2014-02-01 01:06:58.000000', 'consum', 0.0213, 'lps'),
	(512510, 127, '2014-02-01 01:06:59.000000', 'consum', 0.0225, 'lps'),
	(512511, 127, '2014-02-01 01:07:00.000000', 'consum', 0.0212, 'lps'),
	(512512, 127, '2014-02-01 01:07:01.000000', 'consum', 0.0223, 'lps'),
	(512513, 127, '2014-02-01 01:07:02.000000', 'consum', 0.0225, 'lps'),
	(512514, 127, '2014-02-01 01:07:03.000000', 'consum', 0.0211, 'lps'),
	(512515, 127, '2014-02-01 01:07:04.000000', 'consum', 0.0218, 'lps'),
	(512516, 127, '2014-02-01 01:07:05.000000', 'consum', 0.0218, 'lps'),
	(512517, 127, '2014-02-01 01:07:06.000000', 'consum', 0.0225, 'lps'),
	(512518, 127, '2014-02-01 01:07:07.000000', 'consum', 0.0215, 'lps'),
	(512519, 127, '2014-02-01 01:07:08.000000', 'consum', 0.0220, 'lps'),
	(512520, 127, '2014-02-01 01:07:09.000000', 'consum', 0.0216, 'lps'),
	(512521, 127, '2014-02-01 01:07:10.000000', 'consum', 0.0212, 'lps'),
	(512522, 127, '2014-02-01 01:07:11.000000', 'consum', 0.0215, 'lps'),
	(512523, 127, '2014-02-01 01:07:12.000000', 'consum', 0.0215, 'lps'),
	(512524, 127, '2014-02-01 01:07:13.000000', 'consum', 0.0219, 'lps'),
	(512525, 127, '2014-02-01 01:07:14.000000', 'consum', 0.0224, 'lps'),
	(512526, 127, '2014-02-01 01:07:15.000000', 'consum', 0.0223, 'lps'),
	(512527, 127, '2014-02-01 01:07:16.000000', 'consum', 0.0215, 'lps'),
	(512528, 127, '2014-02-01 01:07:17.000000', 'consum', 0.0215, 'lps'),
	(512529, 127, '2014-02-01 01:07:18.000000', 'consum', 0.0220, 'lps'),
	(512530, 127, '2014-02-01 01:07:19.000000', 'consum', 0.0213, 'lps'),
	(512531, 127, '2014-02-01 01:07:20.000000', 'consum', 0.0213, 'lps'),
	(512532, 127, '2014-02-01 01:07:21.000000', 'consum', 0.0214, 'lps'),
	(512533, 127, '2014-02-01 01:07:22.000000', 'consum', 0.0222, 'lps'),
	(512534, 127, '2014-02-01 01:07:23.000000', 'consum', 0.0212, 'lps'),
	(512535, 127, '2014-02-01 01:07:24.000000', 'consum', 0.0216, 'lps'),
	(512536, 127, '2014-02-01 01:07:25.000000', 'consum', 0.0220, 'lps'),
	(512537, 127, '2014-02-01 01:07:26.000000', 'consum', 0.0211, 'lps'),
	(512538, 127, '2014-02-01 01:07:27.000000', 'consum', 0.0217, 'lps'),
	(512539, 127, '2014-02-01 01:07:28.000000', 'consum', 0.0225, 'lps'),
	(512540, 127, '2014-02-01 01:07:29.000000', 'consum', 0.0218, 'lps'),
	(512541, 127, '2014-02-01 01:07:30.000000', 'consum', 0.0219, 'lps'),
	(512542, 127, '2014-02-01 01:07:31.000000', 'consum', 0.0219, 'lps'),
	(512543, 127, '2014-02-01 01:07:32.000000', 'consum', 0.0210, 'lps'),
	(512544, 127, '2014-02-01 01:07:33.000000', 'consum', 0.0218, 'lps'),
	(512545, 127, '2014-02-01 01:07:34.000000', 'consum', 0.0215, 'lps'),
	(512546, 127, '2014-02-01 01:07:35.000000', 'consum', 0.0214, 'lps'),
	(512547, 127, '2014-02-01 01:07:36.000000', 'consum', 0.0215, 'lps'),
	(512548, 127, '2014-02-01 01:07:37.000000', 'consum', 0.0224, 'lps'),
	(512549, 127, '2014-02-01 01:07:38.000000', 'consum', 0.0217, 'lps'),
	(512550, 127, '2014-02-01 01:07:39.000000', 'consum', 0.0219, 'lps'),
	(512551, 127, '2014-02-01 01:07:40.000000', 'consum', 0.0218, 'lps'),
	(512552, 127, '2014-02-01 01:07:41.000000', 'consum', 0.0224, 'lps'),
	(512553, 127, '2014-02-01 01:07:42.000000', 'consum', 0.0224, 'lps'),
	(512554, 127, '2014-02-01 01:07:43.000000', 'consum', 0.0222, 'lps'),
	(512555, 127, '2014-02-01 01:07:44.000000', 'consum', 0.0211, 'lps'),
	(512556, 127, '2014-02-01 01:07:45.000000', 'consum', 0.0213, 'lps'),
	(512557, 127, '2014-02-01 01:07:46.000000', 'consum', 0.0223, 'lps'),
	(512558, 127, '2014-02-01 01:07:47.000000', 'consum', 0.0216, 'lps'),
	(512559, 127, '2014-02-01 01:07:48.000000', 'consum', 0.0221, 'lps'),
	(512560, 127, '2014-02-01 01:07:49.000000', 'consum', 0.0214, 'lps'),
	(512561, 127, '2014-02-01 01:07:50.000000', 'consum', 0.0212, 'lps'),
	(512562, 127, '2014-02-01 01:07:51.000000', 'consum', 0.0210, 'lps'),
	(512563, 127, '2014-02-01 01:07:52.000000', 'consum', 0.0219, 'lps'),
	(512564, 127, '2014-02-01 01:07:53.000000', 'consum', 0.0224, 'lps'),
	(512565, 127, '2014-02-01 01:07:54.000000', 'consum', 0.0223, 'lps'),
	(512566, 127, '2014-02-01 01:07:55.000000', 'consum', 0.0217, 'lps'),
	(512567, 127, '2014-02-01 01:07:56.000000', 'consum', 0.0222, 'lps'),
	(512568, 127, '2014-02-01 01:07:57.000000', 'consum', 0.0218, 'lps'),
	(512569, 127, '2014-02-01 01:07:58.000000', 'consum', 0.0212, 'lps'),
	(512570, 127, '2014-02-01 01:07:59.000000', 'consum', 0.0216, 'lps'),
	(512571, 127, '2014-02-01 01:08:00.000000', 'consum', 0.0216, 'lps'),
	(512572, 127, '2014-02-01 01:08:01.000000', 'consum', 0.0221, 'lps'),
	(512573, 127, '2014-02-01 01:08:02.000000', 'consum', 0.0219, 'lps'),
	(512574, 127, '2014-02-01 01:08:03.000000', 'consum', 0.0222, 'lps'),
	(512575, 127, '2014-02-01 01:08:04.000000', 'consum', 0.0211, 'lps'),
	(512576, 127, '2014-02-01 01:08:05.000000', 'consum', 0.0213, 'lps'),
	(512577, 127, '2014-02-01 01:08:06.000000', 'consum', 0.0222, 'lps'),
	(512578, 127, '2014-02-01 01:08:07.000000', 'consum', 0.0213, 'lps'),
	(512579, 127, '2014-02-01 01:08:08.000000', 'consum', 0.0221, 'lps'),
	(512580, 127, '2014-02-01 01:08:09.000000', 'consum', 0.0211, 'lps'),
	(512581, 127, '2014-02-01 01:08:10.000000', 'consum', 0.0211, 'lps'),
	(512582, 127, '2014-02-01 01:08:11.000000', 'consum', 0.0216, 'lps'),
	(512583, 127, '2014-02-01 01:08:12.000000', 'consum', 0.0219, 'lps'),
	(512584, 127, '2014-02-01 01:08:13.000000', 'consum', 0.0221, 'lps'),
	(512585, 127, '2014-02-01 01:08:14.000000', 'consum', 0.0224, 'lps'),
	(512586, 127, '2014-02-01 01:08:15.000000', 'consum', 0.0215, 'lps'),
	(512587, 127, '2014-02-01 01:08:16.000000', 'consum', 0.0224, 'lps'),
	(512588, 127, '2014-02-01 01:08:17.000000', 'consum', 0.0220, 'lps'),
	(512589, 127, '2014-02-01 01:08:18.000000', 'consum', 0.0217, 'lps'),
	(512590, 127, '2014-02-01 01:08:19.000000', 'consum', 0.0216, 'lps'),
	(512591, 127, '2014-02-01 01:08:20.000000', 'consum', 0.0218, 'lps'),
	(512592, 127, '2014-02-01 01:08:21.000000', 'consum', 0.0218, 'lps'),
	(512593, 127, '2014-02-01 01:08:22.000000', 'consum', 0.0211, 'lps'),
	(512594, 127, '2014-02-01 01:08:23.000000', 'consum', 0.0223, 'lps'),
	(512595, 127, '2014-02-01 01:08:24.000000', 'consum', 0.0210, 'lps'),
	(512596, 127, '2014-02-01 01:08:25.000000', 'consum', 0.0216, 'lps'),
	(512597, 127, '2014-02-01 01:08:26.000000', 'consum', 0.0212, 'lps'),
	(512598, 127, '2014-02-01 01:08:27.000000', 'consum', 0.0218, 'lps'),
	(512599, 127, '2014-02-01 01:08:28.000000', 'consum', 0.0210, 'lps'),
	(512600, 127, '2014-02-01 01:08:29.000000', 'consum', 0.0220, 'lps'),
	(512601, 127, '2014-02-01 01:08:30.000000', 'consum', 0.0214, 'lps'),
	(512602, 127, '2014-02-01 01:08:31.000000', 'consum', 0.0217, 'lps'),
	(512603, 127, '2014-02-01 01:08:32.000000', 'consum', 0.0217, 'lps'),
	(512604, 127, '2014-02-01 01:08:33.000000', 'consum', 0.0210, 'lps'),
	(512605, 127, '2014-02-01 01:08:34.000000', 'consum', 0.0219, 'lps'),
	(512606, 127, '2014-02-01 01:08:35.000000', 'consum', 0.0224, 'lps'),
	(512607, 127, '2014-02-01 01:08:36.000000', 'consum', 0.0221, 'lps'),
	(512608, 127, '2014-02-01 01:08:37.000000', 'consum', 0.0225, 'lps'),
	(512609, 127, '2014-02-01 01:08:38.000000', 'consum', 0.0219, 'lps'),
	(512610, 127, '2014-02-01 01:08:39.000000', 'consum', 0.0213, 'lps'),
	(512611, 127, '2014-02-01 01:08:40.000000', 'consum', 0.0211, 'lps'),
	(512612, 127, '2014-02-01 01:08:41.000000', 'consum', 0.0224, 'lps'),
	(512613, 127, '2014-02-01 01:08:42.000000', 'consum', 0.0215, 'lps'),
	(512614, 127, '2014-02-01 01:08:43.000000', 'consum', 0.0223, 'lps'),
	(512615, 127, '2014-02-01 01:08:44.000000', 'consum', 0.0212, 'lps'),
	(512616, 127, '2014-02-01 01:08:45.000000', 'consum', 0.0214, 'lps'),
	(512617, 127, '2014-02-01 01:08:46.000000', 'consum', 0.0225, 'lps'),
	(512618, 127, '2014-02-01 01:08:47.000000', 'consum', 0.0211, 'lps'),
	(512619, 127, '2014-02-01 01:08:48.000000', 'consum', 0.0219, 'lps'),
	(512620, 127, '2014-02-01 01:08:49.000000', 'consum', 0.0220, 'lps'),
	(512621, 127, '2014-02-01 01:08:50.000000', 'consum', 0.0219, 'lps'),
	(512622, 127, '2014-02-01 01:08:51.000000', 'consum', 0.0222, 'lps'),
	(512623, 127, '2014-02-01 01:08:52.000000', 'consum', 0.0214, 'lps'),
	(512624, 127, '2014-02-01 01:08:53.000000', 'consum', 0.0225, 'lps'),
	(512625, 127, '2014-02-01 01:08:54.000000', 'consum', 0.0211, 'lps'),
	(512626, 127, '2014-02-01 01:08:55.000000', 'consum', 0.0217, 'lps'),
	(512627, 127, '2014-02-01 01:08:56.000000', 'consum', 0.0225, 'lps'),
	(512628, 127, '2014-02-01 01:08:57.000000', 'consum', 0.0219, 'lps'),
	(512629, 127, '2014-02-01 01:08:58.000000', 'consum', 0.0211, 'lps'),
	(512630, 127, '2014-02-01 01:08:59.000000', 'consum', 0.0219, 'lps'),
	(512631, 127, '2014-02-01 01:09:00.000000', 'consum', 0.0221, 'lps'),
	(512632, 127, '2014-02-01 01:09:01.000000', 'consum', 0.0223, 'lps'),
	(512633, 127, '2014-02-01 01:09:02.000000', 'consum', 0.0225, 'lps'),
	(512634, 127, '2014-02-01 01:09:03.000000', 'consum', 0.0215, 'lps'),
	(512635, 127, '2014-02-01 01:09:04.000000', 'consum', 0.0223, 'lps'),
	(512636, 127, '2014-02-01 01:09:05.000000', 'consum', 0.0211, 'lps'),
	(512637, 127, '2014-02-01 01:09:06.000000', 'consum', 0.0210, 'lps'),
	(512638, 127, '2014-02-01 01:09:07.000000', 'consum', 0.0222, 'lps'),
	(512639, 127, '2014-02-01 01:09:08.000000', 'consum', 0.0223, 'lps'),
	(512640, 127, '2014-02-01 01:09:09.000000', 'consum', 0.0210, 'lps'),
	(512641, 127, '2014-02-01 01:09:10.000000', 'consum', 0.0216, 'lps'),
	(512642, 127, '2014-02-01 01:09:11.000000', 'consum', 0.0210, 'lps'),
	(512643, 127, '2014-02-01 01:09:12.000000', 'consum', 0.0225, 'lps'),
	(512644, 127, '2014-02-01 01:09:13.000000', 'consum', 0.0221, 'lps'),
	(512645, 127, '2014-02-01 01:09:14.000000', 'consum', 0.0221, 'lps'),
	(512646, 127, '2014-02-01 01:09:15.000000', 'consum', 0.0216, 'lps'),
	(512647, 127, '2014-02-01 01:09:16.000000', 'consum', 0.0225, 'lps'),
	(512648, 127, '2014-02-01 01:09:17.000000', 'consum', 0.0221, 'lps'),
	(512649, 127, '2014-02-01 01:09:18.000000', 'consum', 0.0217, 'lps'),
	(512650, 127, '2014-02-01 01:09:19.000000', 'consum', 0.0216, 'lps'),
	(512651, 127, '2014-02-01 01:09:20.000000', 'consum', 0.0216, 'lps'),
	(512652, 127, '2014-02-01 01:09:21.000000', 'consum', 0.0223, 'lps'),
	(512653, 127, '2014-02-01 01:09:22.000000', 'consum', 0.0210, 'lps'),
	(512654, 127, '2014-02-01 01:09:23.000000', 'consum', 0.0222, 'lps'),
	(512655, 127, '2014-02-01 01:09:24.000000', 'consum', 0.0219, 'lps'),
	(512656, 127, '2014-02-01 01:09:25.000000', 'consum', 0.0222, 'lps'),
	(512657, 127, '2014-02-01 01:09:26.000000', 'consum', 0.0212, 'lps'),
	(512658, 127, '2014-02-01 01:09:27.000000', 'consum', 0.0217, 'lps'),
	(512659, 127, '2014-02-01 01:09:28.000000', 'consum', 0.0222, 'lps'),
	(512660, 127, '2014-02-01 01:09:29.000000', 'consum', 0.0220, 'lps'),
	(512661, 127, '2014-02-01 01:09:30.000000', 'consum', 0.0222, 'lps'),
	(512662, 127, '2014-02-01 01:09:31.000000', 'consum', 0.0225, 'lps'),
	(512663, 127, '2014-02-01 01:09:32.000000', 'consum', 0.0220, 'lps'),
	(512664, 127, '2014-02-01 01:09:33.000000', 'consum', 0.0212, 'lps'),
	(512665, 127, '2014-02-01 01:09:34.000000', 'consum', 0.0224, 'lps'),
	(512666, 127, '2014-02-01 01:09:35.000000', 'consum', 0.0225, 'lps'),
	(512667, 127, '2014-02-01 01:09:36.000000', 'consum', 0.0212, 'lps'),
	(512668, 127, '2014-02-01 01:09:37.000000', 'consum', 0.0223, 'lps'),
	(512669, 127, '2014-02-01 01:09:38.000000', 'consum', 0.0223, 'lps'),
	(512670, 127, '2014-02-01 01:09:39.000000', 'consum', 0.0219, 'lps'),
	(512671, 127, '2014-02-01 01:09:40.000000', 'consum', 0.0216, 'lps'),
	(512672, 127, '2014-02-01 01:09:41.000000', 'consum', 0.0214, 'lps'),
	(512673, 127, '2014-02-01 01:09:42.000000', 'consum', 0.0214, 'lps'),
	(512674, 127, '2014-02-01 01:09:43.000000', 'consum', 0.0216, 'lps'),
	(512675, 127, '2014-02-01 01:09:44.000000', 'consum', 0.0214, 'lps'),
	(512676, 127, '2014-02-01 01:09:45.000000', 'consum', 0.0214, 'lps'),
	(512677, 127, '2014-02-01 01:09:46.000000', 'consum', 0.0216, 'lps'),
	(512678, 127, '2014-02-01 01:09:47.000000', 'consum', 0.0213, 'lps'),
	(512679, 127, '2014-02-01 01:09:48.000000', 'consum', 0.0224, 'lps'),
	(512680, 127, '2014-02-01 01:09:49.000000', 'consum', 0.0224, 'lps'),
	(512681, 127, '2014-02-01 01:09:50.000000', 'consum', 0.0221, 'lps'),
	(512682, 127, '2014-02-01 01:09:51.000000', 'consum', 0.0224, 'lps'),
	(512683, 127, '2014-02-01 01:09:52.000000', 'consum', 0.0214, 'lps'),
	(512684, 127, '2014-02-01 01:09:53.000000', 'consum', 0.0224, 'lps'),
	(512685, 127, '2014-02-01 01:09:54.000000', 'consum', 0.0218, 'lps'),
	(512686, 127, '2014-02-01 01:09:55.000000', 'consum', 0.0223, 'lps'),
	(512687, 127, '2014-02-01 01:09:56.000000', 'consum', 0.0223, 'lps'),
	(512688, 127, '2014-02-01 01:09:57.000000', 'consum', 0.0219, 'lps'),
	(512689, 127, '2014-02-01 01:09:58.000000', 'consum', 0.0218, 'lps'),
	(512690, 127, '2014-02-01 01:09:59.000000', 'consum', 0.0221, 'lps'),
	(512691, 127, '2014-02-01 01:10:00.000000', 'consum', 0.0225, 'lps'),
	(512692, 127, '2014-02-01 01:10:01.000000', 'consum', 0.0221, 'lps'),
	(512693, 127, '2014-02-01 01:10:02.000000', 'consum', 0.0220, 'lps'),
	(512694, 127, '2014-02-01 01:10:03.000000', 'consum', 0.0212, 'lps'),
	(512695, 127, '2014-02-01 01:10:04.000000', 'consum', 0.0224, 'lps'),
	(512696, 127, '2014-02-01 01:10:05.000000', 'consum', 0.0210, 'lps'),
	(512697, 127, '2014-02-01 01:10:06.000000', 'consum', 0.0216, 'lps'),
	(512698, 127, '2014-02-01 01:10:07.000000', 'consum', 0.0224, 'lps'),
	(512699, 127, '2014-02-01 01:10:08.000000', 'consum', 0.0215, 'lps'),
	(512700, 127, '2014-02-01 01:10:09.000000', 'consum', 0.0211, 'lps'),
	(512701, 127, '2014-02-01 01:10:10.000000', 'consum', 0.0217, 'lps'),
	(512702, 127, '2014-02-01 01:10:11.000000', 'consum', 0.0211, 'lps'),
	(512703, 127, '2014-02-01 01:10:12.000000', 'consum', 0.0210, 'lps'),
	(512704, 127, '2014-02-01 01:10:13.000000', 'consum', 0.0225, 'lps'),
	(512705, 127, '2014-02-01 01:10:14.000000', 'consum', 0.0220, 'lps'),
	(512706, 127, '2014-02-01 01:10:15.000000', 'consum', 0.0216, 'lps'),
	(512707, 127, '2014-02-01 01:10:16.000000', 'consum', 0.0224, 'lps'),
	(512708, 127, '2014-02-01 01:10:17.000000', 'consum', 0.0218, 'lps'),
	(512709, 127, '2014-02-01 01:10:18.000000', 'consum', 0.0223, 'lps'),
	(512710, 127, '2014-02-01 01:10:19.000000', 'consum', 0.0218, 'lps'),
	(512711, 127, '2014-02-01 01:10:20.000000', 'consum', 0.0212, 'lps'),
	(512712, 127, '2014-02-01 01:10:21.000000', 'consum', 0.0214, 'lps'),
	(512713, 127, '2014-02-01 01:10:22.000000', 'consum', 0.0224, 'lps'),
	(512714, 127, '2014-02-01 01:10:23.000000', 'consum', 0.0219, 'lps'),
	(512715, 127, '2014-02-01 01:10:24.000000', 'consum', 0.0214, 'lps'),
	(512716, 127, '2014-02-01 01:10:25.000000', 'consum', 0.0219, 'lps'),
	(512717, 127, '2014-02-01 01:10:26.000000', 'consum', 0.0214, 'lps'),
	(512718, 127, '2014-02-01 01:10:27.000000', 'consum', 0.0218, 'lps'),
	(512719, 127, '2014-02-01 01:10:28.000000', 'consum', 0.0223, 'lps'),
	(512720, 127, '2014-02-01 01:10:29.000000', 'consum', 0.0221, 'lps'),
	(512721, 127, '2014-02-01 01:10:30.000000', 'consum', 0.0225, 'lps'),
	(512722, 127, '2014-02-01 01:10:31.000000', 'consum', 0.0221, 'lps'),
	(512723, 127, '2014-02-01 01:10:32.000000', 'consum', 0.0219, 'lps'),
	(512724, 127, '2014-02-01 01:10:33.000000', 'consum', 0.0224, 'lps'),
	(512725, 127, '2014-02-01 01:10:34.000000', 'consum', 0.0222, 'lps'),
	(512726, 127, '2014-02-01 01:10:35.000000', 'consum', 0.0211, 'lps'),
	(512727, 127, '2014-02-01 01:10:36.000000', 'consum', 0.0210, 'lps'),
	(512728, 127, '2014-02-01 01:10:37.000000', 'consum', 0.0211, 'lps'),
	(512729, 127, '2014-02-01 01:10:38.000000', 'consum', 0.0214, 'lps'),
	(512730, 127, '2014-02-01 01:10:39.000000', 'consum', 0.0210, 'lps'),
	(512731, 127, '2014-02-01 01:10:40.000000', 'consum', 0.0214, 'lps'),
	(512732, 127, '2014-02-01 01:10:41.000000', 'consum', 0.0216, 'lps'),
	(512733, 127, '2014-02-01 01:10:42.000000', 'consum', 0.0211, 'lps'),
	(512734, 127, '2014-02-01 01:10:43.000000', 'consum', 0.0212, 'lps'),
	(512735, 127, '2014-02-01 01:10:44.000000', 'consum', 0.0221, 'lps'),
	(512736, 127, '2014-02-01 01:10:45.000000', 'consum', 0.0224, 'lps'),
	(512737, 127, '2014-02-01 01:10:46.000000', 'consum', 0.0218, 'lps'),
	(512738, 127, '2014-02-01 01:10:47.000000', 'consum', 0.0210, 'lps'),
	(512739, 127, '2014-02-01 01:10:48.000000', 'consum', 0.0215, 'lps'),
	(512740, 127, '2014-02-01 01:10:49.000000', 'consum', 0.0222, 'lps'),
	(512741, 127, '2014-02-01 01:10:50.000000', 'consum', 0.0222, 'lps'),
	(512742, 127, '2014-02-01 01:10:51.000000', 'consum', 0.0221, 'lps'),
	(512743, 127, '2014-02-01 01:10:52.000000', 'consum', 0.0212, 'lps'),
	(512744, 127, '2014-02-01 01:10:53.000000', 'consum', 0.0220, 'lps'),
	(512745, 127, '2014-02-01 01:10:54.000000', 'consum', 0.0222, 'lps'),
	(512746, 127, '2014-02-01 01:10:55.000000', 'consum', 0.0210, 'lps'),
	(512747, 127, '2014-02-01 01:10:56.000000', 'consum', 0.0220, 'lps'),
	(512748, 127, '2014-02-01 01:10:57.000000', 'consum', 0.0215, 'lps'),
	(512749, 127, '2014-02-01 01:10:58.000000', 'consum', 0.0221, 'lps'),
	(512750, 127, '2014-02-01 01:10:59.000000', 'consum', 0.0220, 'lps'),
	(512751, 127, '2014-02-01 01:11:00.000000', 'consum', 0.0211, 'lps'),
	(512752, 127, '2014-02-01 01:11:01.000000', 'consum', 0.0215, 'lps'),
	(512753, 127, '2014-02-01 01:11:02.000000', 'consum', 0.0219, 'lps'),
	(512754, 127, '2014-02-01 01:11:03.000000', 'consum', 0.0225, 'lps'),
	(512755, 127, '2014-02-01 01:11:04.000000', 'consum', 0.0210, 'lps'),
	(512756, 127, '2014-02-01 01:11:05.000000', 'consum', 0.0211, 'lps'),
	(512757, 127, '2014-02-01 01:11:06.000000', 'consum', 0.0217, 'lps'),
	(512758, 127, '2014-02-01 01:11:07.000000', 'consum', 0.0212, 'lps'),
	(512759, 127, '2014-02-01 01:11:08.000000', 'consum', 0.0216, 'lps'),
	(512760, 127, '2014-02-01 01:11:09.000000', 'consum', 0.0219, 'lps'),
	(512761, 127, '2014-02-01 01:11:10.000000', 'consum', 0.0222, 'lps'),
	(512762, 127, '2014-02-01 01:11:11.000000', 'consum', 0.0212, 'lps'),
	(512763, 127, '2014-02-01 01:11:12.000000', 'consum', 0.0217, 'lps'),
	(512764, 127, '2014-02-01 01:11:13.000000', 'consum', 0.0223, 'lps'),
	(512765, 127, '2014-02-01 01:11:14.000000', 'consum', 0.0220, 'lps'),
	(512766, 127, '2014-02-01 01:11:15.000000', 'consum', 0.0224, 'lps'),
	(512767, 127, '2014-02-01 01:11:16.000000', 'consum', 0.0219, 'lps'),
	(512768, 127, '2014-02-01 01:11:17.000000', 'consum', 0.0213, 'lps'),
	(512769, 127, '2014-02-01 01:11:18.000000', 'consum', 0.0213, 'lps'),
	(512770, 127, '2014-02-01 01:11:19.000000', 'consum', 0.0216, 'lps'),
	(512771, 127, '2014-02-01 01:11:20.000000', 'consum', 0.0218, 'lps'),
	(512772, 127, '2014-02-01 01:11:21.000000', 'consum', 0.0216, 'lps'),
	(512773, 127, '2014-02-01 01:11:22.000000', 'consum', 0.0217, 'lps'),
	(512774, 127, '2014-02-01 01:11:23.000000', 'consum', 0.0211, 'lps'),
	(512775, 127, '2014-02-01 01:11:24.000000', 'consum', 0.0212, 'lps'),
	(512776, 127, '2014-02-01 01:11:25.000000', 'consum', 0.0217, 'lps'),
	(512777, 127, '2014-02-01 01:11:26.000000', 'consum', 0.0224, 'lps'),
	(512778, 127, '2014-02-01 01:11:27.000000', 'consum', 0.0210, 'lps'),
	(512779, 127, '2014-02-01 01:11:28.000000', 'consum', 0.0216, 'lps'),
	(512780, 127, '2014-02-01 01:11:29.000000', 'consum', 0.0224, 'lps'),
	(512781, 127, '2014-02-01 01:11:30.000000', 'consum', 0.0216, 'lps'),
	(512782, 127, '2014-02-01 01:11:31.000000', 'consum', 0.0213, 'lps'),
	(512783, 127, '2014-02-01 01:11:32.000000', 'consum', 0.0210, 'lps'),
	(512784, 127, '2014-02-01 01:11:33.000000', 'consum', 0.0218, 'lps'),
	(512785, 127, '2014-02-01 01:11:34.000000', 'consum', 0.0217, 'lps'),
	(512786, 127, '2014-02-01 01:11:35.000000', 'consum', 0.0223, 'lps'),
	(512787, 127, '2014-02-01 01:11:36.000000', 'consum', 0.0220, 'lps'),
	(512788, 127, '2014-02-01 01:11:37.000000', 'consum', 0.0221, 'lps'),
	(512789, 127, '2014-02-01 01:11:38.000000', 'consum', 0.0219, 'lps'),
	(512790, 127, '2014-02-01 01:11:39.000000', 'consum', 0.0225, 'lps'),
	(512791, 127, '2014-02-01 01:11:40.000000', 'consum', 0.0210, 'lps'),
	(512792, 127, '2014-02-01 01:11:41.000000', 'consum', 0.0213, 'lps'),
	(512793, 127, '2014-02-01 01:11:42.000000', 'consum', 0.0225, 'lps'),
	(512794, 127, '2014-02-01 01:11:43.000000', 'consum', 0.0213, 'lps'),
	(512795, 127, '2014-02-01 01:11:44.000000', 'consum', 0.0212, 'lps'),
	(512796, 127, '2014-02-01 01:11:45.000000', 'consum', 0.0211, 'lps'),
	(512797, 127, '2014-02-01 01:11:46.000000', 'consum', 0.0225, 'lps'),
	(512798, 127, '2014-02-01 01:11:47.000000', 'consum', 0.0218, 'lps'),
	(512799, 127, '2014-02-01 01:11:48.000000', 'consum', 0.0224, 'lps'),
	(512800, 127, '2014-02-01 01:11:49.000000', 'consum', 0.0224, 'lps'),
	(512801, 127, '2014-02-01 01:11:50.000000', 'consum', 0.0224, 'lps'),
	(512802, 127, '2014-02-01 01:11:51.000000', 'consum', 0.0222, 'lps'),
	(512803, 127, '2014-02-01 01:11:52.000000', 'consum', 0.0211, 'lps'),
	(512804, 127, '2014-02-01 01:11:53.000000', 'consum', 0.0214, 'lps'),
	(512805, 127, '2014-02-01 01:11:54.000000', 'consum', 0.0211, 'lps'),
	(512806, 127, '2014-02-01 01:11:55.000000', 'consum', 0.0219, 'lps'),
	(512807, 127, '2014-02-01 01:11:56.000000', 'consum', 0.0222, 'lps'),
	(512808, 127, '2014-02-01 01:11:57.000000', 'consum', 0.0225, 'lps'),
	(512809, 127, '2014-02-01 01:11:58.000000', 'consum', 0.0219, 'lps'),
	(512810, 127, '2014-02-01 01:11:59.000000', 'consum', 0.0224, 'lps'),
	(512811, 127, '2014-02-01 01:12:00.000000', 'consum', 0.0225, 'lps'),
	(512812, 127, '2014-02-01 01:12:01.000000', 'consum', 0.0211, 'lps'),
	(512813, 127, '2014-02-01 01:12:02.000000', 'consum', 0.0216, 'lps'),
	(512814, 127, '2014-02-01 01:12:03.000000', 'consum', 0.0224, 'lps'),
	(512815, 127, '2014-02-01 01:12:04.000000', 'consum', 0.0213, 'lps'),
	(512816, 127, '2014-02-01 01:12:05.000000', 'consum', 0.0217, 'lps'),
	(512817, 127, '2014-02-01 01:12:06.000000', 'consum', 0.0218, 'lps'),
	(512818, 127, '2014-02-01 01:12:07.000000', 'consum', 0.0215, 'lps'),
	(512819, 127, '2014-02-01 01:12:08.000000', 'consum', 0.0213, 'lps'),
	(512820, 127, '2014-02-01 01:12:09.000000', 'consum', 0.0224, 'lps'),
	(512821, 127, '2014-02-01 01:12:10.000000', 'consum', 0.0225, 'lps'),
	(512822, 127, '2014-02-01 01:12:11.000000', 'consum', 0.0225, 'lps'),
	(512823, 127, '2014-02-01 01:12:12.000000', 'consum', 0.0212, 'lps'),
	(512824, 127, '2014-02-01 01:12:13.000000', 'consum', 0.0222, 'lps'),
	(512825, 127, '2014-02-01 01:12:14.000000', 'consum', 0.0217, 'lps'),
	(512826, 127, '2014-02-01 01:12:15.000000', 'consum', 0.0211, 'lps'),
	(512827, 127, '2014-02-01 01:12:16.000000', 'consum', 0.0210, 'lps'),
	(512828, 127, '2014-02-01 01:12:17.000000', 'consum', 0.0223, 'lps'),
	(512829, 127, '2014-02-01 01:12:18.000000', 'consum', 0.0210, 'lps'),
	(512830, 127, '2014-02-01 01:12:19.000000', 'consum', 0.0222, 'lps'),
	(512831, 127, '2014-02-01 01:12:20.000000', 'consum', 0.0222, 'lps'),
	(512832, 127, '2014-02-01 01:12:21.000000', 'consum', 0.0219, 'lps'),
	(512833, 127, '2014-02-01 01:12:22.000000', 'consum', 0.0218, 'lps'),
	(512834, 127, '2014-02-01 01:12:23.000000', 'consum', 0.0222, 'lps'),
	(512835, 127, '2014-02-01 01:12:24.000000', 'consum', 0.0218, 'lps'),
	(512836, 127, '2014-02-01 01:12:25.000000', 'consum', 0.0213, 'lps'),
	(512837, 127, '2014-02-01 01:12:26.000000', 'consum', 0.0219, 'lps'),
	(512838, 127, '2014-02-01 01:12:27.000000', 'consum', 0.0215, 'lps'),
	(512839, 127, '2014-02-01 01:12:28.000000', 'consum', 0.0222, 'lps'),
	(512840, 127, '2014-02-01 01:12:29.000000', 'consum', 0.0224, 'lps'),
	(512841, 127, '2014-02-01 01:12:30.000000', 'consum', 0.0211, 'lps'),
	(512842, 127, '2014-02-01 01:12:31.000000', 'consum', 0.0223, 'lps'),
	(512843, 127, '2014-02-01 01:12:32.000000', 'consum', 0.0210, 'lps'),
	(512844, 127, '2014-02-01 01:12:33.000000', 'consum', 0.0217, 'lps'),
	(512845, 127, '2014-02-01 01:12:34.000000', 'consum', 0.0213, 'lps'),
	(512846, 127, '2014-02-01 01:12:35.000000', 'consum', 0.0222, 'lps'),
	(512847, 127, '2014-02-01 01:12:36.000000', 'consum', 0.0213, 'lps'),
	(512848, 127, '2014-02-01 01:12:37.000000', 'consum', 0.0220, 'lps'),
	(512849, 127, '2014-02-01 01:12:38.000000', 'consum', 0.0221, 'lps'),
	(512850, 127, '2014-02-01 01:12:39.000000', 'consum', 0.0218, 'lps'),
	(512851, 127, '2014-02-01 01:12:40.000000', 'consum', 0.0219, 'lps'),
	(512852, 127, '2014-02-01 01:12:41.000000', 'consum', 0.0216, 'lps'),
	(512853, 127, '2014-02-01 01:12:42.000000', 'consum', 0.0212, 'lps'),
	(512854, 127, '2014-02-01 01:12:43.000000', 'consum', 0.0220, 'lps'),
	(512855, 127, '2014-02-01 01:12:44.000000', 'consum', 0.0224, 'lps'),
	(512856, 127, '2014-02-01 01:12:45.000000', 'consum', 0.0215, 'lps'),
	(512857, 127, '2014-02-01 01:12:46.000000', 'consum', 0.0212, 'lps'),
	(512858, 127, '2014-02-01 01:12:47.000000', 'consum', 0.0221, 'lps'),
	(512859, 127, '2014-02-01 01:12:48.000000', 'consum', 0.0211, 'lps'),
	(512860, 127, '2014-02-01 01:12:49.000000', 'consum', 0.0214, 'lps'),
	(512861, 127, '2014-02-01 01:12:50.000000', 'consum', 0.0214, 'lps'),
	(512862, 127, '2014-02-01 01:12:51.000000', 'consum', 0.0216, 'lps'),
	(512863, 127, '2014-02-01 01:12:52.000000', 'consum', 0.0214, 'lps'),
	(512864, 127, '2014-02-01 01:12:53.000000', 'consum', 0.0213, 'lps'),
	(512865, 127, '2014-02-01 01:12:54.000000', 'consum', 0.0212, 'lps'),
	(512866, 127, '2014-02-01 01:12:55.000000', 'consum', 0.0211, 'lps'),
	(512867, 127, '2014-02-01 01:12:56.000000', 'consum', 0.0211, 'lps'),
	(512868, 127, '2014-02-01 01:12:57.000000', 'consum', 0.0211, 'lps'),
	(512869, 127, '2014-02-01 01:12:58.000000', 'consum', 0.0214, 'lps'),
	(512870, 127, '2014-02-01 01:12:59.000000', 'consum', 0.0211, 'lps'),
	(512871, 127, '2014-02-01 01:13:00.000000', 'consum', 0.0220, 'lps'),
	(512872, 127, '2014-02-01 01:13:01.000000', 'consum', 0.0210, 'lps'),
	(512873, 127, '2014-02-01 01:13:02.000000', 'consum', 0.0214, 'lps'),
	(512874, 127, '2014-02-01 01:13:03.000000', 'consum', 0.0212, 'lps'),
	(512875, 127, '2014-02-01 01:13:04.000000', 'consum', 0.0210, 'lps'),
	(512876, 127, '2014-02-01 01:13:05.000000', 'consum', 0.0220, 'lps'),
	(512877, 127, '2014-02-01 01:13:06.000000', 'consum', 0.0211, 'lps'),
	(512878, 127, '2014-02-01 01:13:07.000000', 'consum', 0.0218, 'lps'),
	(512879, 127, '2014-02-01 01:13:08.000000', 'consum', 0.0216, 'lps'),
	(512880, 127, '2014-02-01 01:13:09.000000', 'consum', 0.0216, 'lps'),
	(512881, 127, '2014-02-01 01:13:10.000000', 'consum', 0.0224, 'lps'),
	(512882, 127, '2014-02-01 01:13:11.000000', 'consum', 0.0214, 'lps'),
	(512883, 127, '2014-02-01 01:13:12.000000', 'consum', 0.0221, 'lps'),
	(512884, 127, '2014-02-01 01:13:13.000000', 'consum', 0.0222, 'lps'),
	(512885, 127, '2014-02-01 01:13:14.000000', 'consum', 0.0220, 'lps'),
	(512886, 127, '2014-02-01 01:13:15.000000', 'consum', 0.0224, 'lps'),
	(512887, 127, '2014-02-01 01:13:16.000000', 'consum', 0.0217, 'lps'),
	(512888, 127, '2014-02-01 01:13:17.000000', 'consum', 0.0222, 'lps'),
	(512889, 127, '2014-02-01 01:13:18.000000', 'consum', 0.0215, 'lps'),
	(512890, 127, '2014-02-01 01:13:19.000000', 'consum', 0.0216, 'lps'),
	(512891, 127, '2014-02-01 01:13:20.000000', 'consum', 0.0211, 'lps'),
	(512892, 127, '2014-02-01 01:13:21.000000', 'consum', 0.0212, 'lps'),
	(512893, 127, '2014-02-01 01:13:22.000000', 'consum', 0.0218, 'lps'),
	(512894, 127, '2014-02-01 01:13:23.000000', 'consum', 0.0211, 'lps'),
	(512895, 127, '2014-02-01 01:13:24.000000', 'consum', 0.0210, 'lps'),
	(512896, 127, '2014-02-01 01:13:25.000000', 'consum', 0.0222, 'lps'),
	(512897, 127, '2014-02-01 01:13:26.000000', 'consum', 0.0221, 'lps'),
	(512898, 127, '2014-02-01 01:13:27.000000', 'consum', 0.0215, 'lps'),
	(512899, 127, '2014-02-01 01:13:28.000000', 'consum', 0.0220, 'lps'),
	(512900, 127, '2014-02-01 01:13:29.000000', 'consum', 0.0214, 'lps'),
	(512901, 127, '2014-02-01 01:13:30.000000', 'consum', 0.0216, 'lps'),
	(512902, 127, '2014-02-01 01:13:31.000000', 'consum', 0.0211, 'lps'),
	(512903, 127, '2014-02-01 01:13:32.000000', 'consum', 0.0215, 'lps'),
	(512904, 127, '2014-02-01 01:13:33.000000', 'consum', 0.0218, 'lps'),
	(512905, 127, '2014-02-01 01:13:34.000000', 'consum', 0.0217, 'lps'),
	(512906, 127, '2014-02-01 01:13:35.000000', 'consum', 0.0221, 'lps'),
	(512907, 127, '2014-02-01 01:13:36.000000', 'consum', 0.0213, 'lps'),
	(512908, 127, '2014-02-01 01:13:37.000000', 'consum', 0.0210, 'lps'),
	(512909, 127, '2014-02-01 01:13:38.000000', 'consum', 0.0217, 'lps'),
	(512910, 127, '2014-02-01 01:13:39.000000', 'consum', 0.0214, 'lps'),
	(512911, 127, '2014-02-01 01:13:40.000000', 'consum', 0.0225, 'lps'),
	(512912, 127, '2014-02-01 01:13:41.000000', 'consum', 0.0211, 'lps'),
	(512913, 127, '2014-02-01 01:13:42.000000', 'consum', 0.0219, 'lps'),
	(512914, 127, '2014-02-01 01:13:43.000000', 'consum', 0.0218, 'lps'),
	(512915, 127, '2014-02-01 01:13:44.000000', 'consum', 0.0211, 'lps'),
	(512916, 127, '2014-02-01 01:13:45.000000', 'consum', 0.0220, 'lps'),
	(512917, 127, '2014-02-01 01:13:46.000000', 'consum', 0.0211, 'lps'),
	(512918, 127, '2014-02-01 01:13:47.000000', 'consum', 0.0215, 'lps'),
	(512919, 127, '2014-02-01 01:13:48.000000', 'consum', 0.0220, 'lps'),
	(512920, 127, '2014-02-01 01:13:49.000000', 'consum', 0.0212, 'lps'),
	(512921, 127, '2014-02-01 01:13:50.000000', 'consum', 0.0223, 'lps'),
	(512922, 127, '2014-02-01 01:13:51.000000', 'consum', 0.0221, 'lps'),
	(512923, 127, '2014-02-01 01:13:52.000000', 'consum', 0.0210, 'lps'),
	(512924, 127, '2014-02-01 01:13:53.000000', 'consum', 0.0211, 'lps'),
	(512925, 127, '2014-02-01 01:13:54.000000', 'consum', 0.0215, 'lps'),
	(512926, 127, '2014-02-01 01:13:55.000000', 'consum', 0.0217, 'lps'),
	(512927, 127, '2014-02-01 01:13:56.000000', 'consum', 0.0215, 'lps'),
	(512928, 127, '2014-02-01 01:13:57.000000', 'consum', 0.0213, 'lps'),
	(512929, 127, '2014-02-01 01:13:58.000000', 'consum', 0.0210, 'lps'),
	(512930, 127, '2014-02-01 01:13:59.000000', 'consum', 0.0219, 'lps'),
	(512931, 127, '2014-02-01 01:14:00.000000', 'consum', 0.0223, 'lps'),
	(512932, 127, '2014-02-01 01:14:01.000000', 'consum', 0.0215, 'lps'),
	(512933, 127, '2014-02-01 01:14:02.000000', 'consum', 0.0213, 'lps'),
	(512934, 127, '2014-02-01 01:14:03.000000', 'consum', 0.0211, 'lps'),
	(512935, 127, '2014-02-01 01:14:04.000000', 'consum', 0.0222, 'lps'),
	(512936, 127, '2014-02-01 01:14:05.000000', 'consum', 0.0218, 'lps'),
	(512937, 127, '2014-02-01 01:14:06.000000', 'consum', 0.0214, 'lps'),
	(512938, 127, '2014-02-01 01:14:07.000000', 'consum', 0.0225, 'lps'),
	(512939, 127, '2014-02-01 01:14:08.000000', 'consum', 0.0224, 'lps'),
	(512940, 127, '2014-02-01 01:14:09.000000', 'consum', 0.0219, 'lps'),
	(512941, 127, '2014-02-01 01:14:10.000000', 'consum', 0.0215, 'lps'),
	(512942, 127, '2014-02-01 01:14:11.000000', 'consum', 0.0225, 'lps'),
	(512943, 127, '2014-02-01 01:14:12.000000', 'consum', 0.0221, 'lps'),
	(512944, 127, '2014-02-01 01:14:13.000000', 'consum', 0.0220, 'lps'),
	(512945, 127, '2014-02-01 01:14:14.000000', 'consum', 0.0213, 'lps'),
	(512946, 127, '2014-02-01 01:14:15.000000', 'consum', 0.0212, 'lps'),
	(512947, 127, '2014-02-01 01:14:16.000000', 'consum', 0.0211, 'lps'),
	(512948, 127, '2014-02-01 01:14:17.000000', 'consum', 0.0211, 'lps'),
	(512949, 127, '2014-02-01 01:14:18.000000', 'consum', 0.0210, 'lps'),
	(512950, 127, '2014-02-01 01:14:19.000000', 'consum', 0.0225, 'lps'),
	(512951, 127, '2014-02-01 01:14:20.000000', 'consum', 0.0220, 'lps'),
	(512952, 127, '2014-02-01 01:14:21.000000', 'consum', 0.0217, 'lps'),
	(512953, 127, '2014-02-01 01:14:22.000000', 'consum', 0.0213, 'lps'),
	(512954, 127, '2014-02-01 01:14:23.000000', 'consum', 0.0221, 'lps'),
	(512955, 127, '2014-02-01 01:14:24.000000', 'consum', 0.0211, 'lps'),
	(512956, 127, '2014-02-01 01:14:25.000000', 'consum', 0.0214, 'lps'),
	(512957, 127, '2014-02-01 01:14:26.000000', 'consum', 0.0210, 'lps'),
	(512958, 127, '2014-02-01 01:14:27.000000', 'consum', 0.0214, 'lps'),
	(512959, 127, '2014-02-01 01:14:28.000000', 'consum', 0.0213, 'lps'),
	(512960, 127, '2014-02-01 01:14:29.000000', 'consum', 0.0216, 'lps'),
	(512961, 127, '2014-02-01 01:14:30.000000', 'consum', 0.0215, 'lps'),
	(512962, 127, '2014-02-01 01:14:31.000000', 'consum', 0.0217, 'lps'),
	(512963, 127, '2014-02-01 01:14:32.000000', 'consum', 0.0216, 'lps'),
	(512964, 127, '2014-02-01 01:14:33.000000', 'consum', 0.0218, 'lps'),
	(512965, 127, '2014-02-01 01:14:34.000000', 'consum', 0.0215, 'lps'),
	(512966, 127, '2014-02-01 01:14:35.000000', 'consum', 0.0213, 'lps'),
	(512967, 127, '2014-02-01 01:14:36.000000', 'consum', 0.0225, 'lps'),
	(512968, 127, '2014-02-01 01:14:37.000000', 'consum', 0.0215, 'lps'),
	(512969, 127, '2014-02-01 01:14:38.000000', 'consum', 0.0220, 'lps'),
	(512970, 127, '2014-02-01 01:14:39.000000', 'consum', 0.0212, 'lps'),
	(512971, 127, '2014-02-01 01:14:40.000000', 'consum', 0.0210, 'lps'),
	(512972, 127, '2014-02-01 01:14:41.000000', 'consum', 0.0219, 'lps'),
	(512973, 127, '2014-02-01 01:14:42.000000', 'consum', 0.0225, 'lps'),
	(512974, 127, '2014-02-01 01:14:43.000000', 'consum', 0.0225, 'lps'),
	(512975, 127, '2014-02-01 01:14:44.000000', 'consum', 0.0225, 'lps'),
	(512976, 127, '2014-02-01 01:14:45.000000', 'consum', 0.0225, 'lps'),
	(512977, 127, '2014-02-01 01:14:46.000000', 'consum', 0.0210, 'lps'),
	(512978, 127, '2014-02-01 01:14:47.000000', 'consum', 0.0211, 'lps'),
	(512979, 127, '2014-02-01 01:14:48.000000', 'consum', 0.0218, 'lps'),
	(512980, 127, '2014-02-01 01:14:49.000000', 'consum', 0.0216, 'lps'),
	(512981, 127, '2014-02-01 01:14:50.000000', 'consum', 0.0217, 'lps'),
	(512982, 127, '2014-02-01 01:14:51.000000', 'consum', 0.0224, 'lps'),
	(512983, 127, '2014-02-01 01:14:52.000000', 'consum', 0.0214, 'lps'),
	(512984, 127, '2014-02-01 01:14:53.000000', 'consum', 0.0220, 'lps'),
	(512985, 127, '2014-02-01 01:14:54.000000', 'consum', 0.0219, 'lps'),
	(512986, 127, '2014-02-01 01:14:55.000000', 'consum', 0.0222, 'lps'),
	(512987, 127, '2014-02-01 01:14:56.000000', 'consum', 0.0211, 'lps'),
	(512988, 127, '2014-02-01 01:14:57.000000', 'consum', 0.0213, 'lps'),
	(512989, 127, '2014-02-01 01:14:58.000000', 'consum', 0.0222, 'lps'),
	(512990, 127, '2014-02-01 01:14:59.000000', 'consum', 0.0213, 'lps'),
	(512991, 127, '2014-02-01 01:15:00.000000', 'consum', 0.0224, 'lps'),
	(512992, 127, '2014-02-01 01:15:01.000000', 'consum', 0.0221, 'lps'),
	(512993, 127, '2014-02-01 01:15:02.000000', 'consum', 0.0224, 'lps'),
	(512994, 127, '2014-02-01 01:15:03.000000', 'consum', 0.0216, 'lps'),
	(512995, 127, '2014-02-01 01:15:04.000000', 'consum', 0.0214, 'lps'),
	(512996, 127, '2014-02-01 01:15:05.000000', 'consum', 0.0212, 'lps'),
	(512997, 127, '2014-02-01 01:15:06.000000', 'consum', 0.0210, 'lps'),
	(512998, 127, '2014-02-01 01:15:07.000000', 'consum', 0.0219, 'lps'),
	(512999, 127, '2014-02-01 01:15:08.000000', 'consum', 0.0225, 'lps'),
	(513000, 127, '2014-02-01 01:15:09.000000', 'consum', 0.0224, 'lps'),
	(513001, 127, '2014-02-01 01:15:10.000000', 'consum', 0.0221, 'lps'),
	(513002, 127, '2014-02-01 01:15:11.000000', 'consum', 0.0222, 'lps'),
	(513003, 127, '2014-02-01 01:15:12.000000', 'consum', 0.0224, 'lps'),
	(513004, 127, '2014-02-01 01:15:13.000000', 'consum', 0.0210, 'lps'),
	(513005, 127, '2014-02-01 01:15:14.000000', 'consum', 0.0219, 'lps'),
	(513006, 127, '2014-02-01 01:15:15.000000', 'consum', 0.0224, 'lps'),
	(513007, 127, '2014-02-01 01:15:16.000000', 'consum', 0.0222, 'lps'),
	(513008, 127, '2014-02-01 01:15:17.000000', 'consum', 0.0212, 'lps'),
	(513009, 127, '2014-02-01 01:15:18.000000', 'consum', 0.0216, 'lps'),
	(513010, 127, '2014-02-01 01:15:19.000000', 'consum', 0.0220, 'lps'),
	(513011, 127, '2014-02-01 01:15:20.000000', 'consum', 0.0225, 'lps'),
	(513012, 127, '2014-02-01 01:15:21.000000', 'consum', 0.0224, 'lps'),
	(513013, 127, '2014-02-01 01:15:22.000000', 'consum', 0.0220, 'lps'),
	(513014, 127, '2014-02-01 01:15:23.000000', 'consum', 0.0217, 'lps'),
	(513015, 127, '2014-02-01 01:15:24.000000', 'consum', 0.0217, 'lps'),
	(513016, 127, '2014-02-01 01:15:25.000000', 'consum', 0.0223, 'lps'),
	(513017, 127, '2014-02-01 01:15:26.000000', 'consum', 0.0222, 'lps'),
	(513018, 127, '2014-02-01 01:15:27.000000', 'consum', 0.0217, 'lps'),
	(513019, 127, '2014-02-01 01:15:28.000000', 'consum', 0.0225, 'lps'),
	(513020, 127, '2014-02-01 01:15:29.000000', 'consum', 0.0216, 'lps'),
	(513021, 127, '2014-02-01 01:15:30.000000', 'consum', 0.0214, 'lps'),
	(513022, 127, '2014-02-01 01:15:31.000000', 'consum', 0.0210, 'lps'),
	(513023, 127, '2014-02-01 01:15:32.000000', 'consum', 0.0217, 'lps'),
	(513024, 127, '2014-02-01 01:15:33.000000', 'consum', 0.0213, 'lps'),
	(513025, 127, '2014-02-01 01:15:34.000000', 'consum', 0.0220, 'lps'),
	(513026, 127, '2014-02-01 01:15:35.000000', 'consum', 0.0221, 'lps'),
	(513027, 127, '2014-02-01 01:15:36.000000', 'consum', 0.0218, 'lps'),
	(513028, 127, '2014-02-01 01:15:37.000000', 'consum', 0.0218, 'lps'),
	(513029, 127, '2014-02-01 01:15:38.000000', 'consum', 0.0212, 'lps'),
	(513030, 127, '2014-02-01 01:15:39.000000', 'consum', 0.0211, 'lps'),
	(513031, 127, '2014-02-01 01:15:40.000000', 'consum', 0.0210, 'lps'),
	(513032, 127, '2014-02-01 01:15:41.000000', 'consum', 0.0224, 'lps'),
	(513033, 127, '2014-02-01 01:15:42.000000', 'consum', 0.0214, 'lps'),
	(513034, 127, '2014-02-01 01:15:43.000000', 'consum', 0.0223, 'lps'),
	(513035, 127, '2014-02-01 01:15:44.000000', 'consum', 0.0215, 'lps'),
	(513036, 127, '2014-02-01 01:15:45.000000', 'consum', 0.0214, 'lps'),
	(513037, 127, '2014-02-01 01:15:46.000000', 'consum', 0.0212, 'lps'),
	(513038, 127, '2014-02-01 01:15:47.000000', 'consum', 0.0211, 'lps'),
	(513039, 127, '2014-02-01 01:15:48.000000', 'consum', 0.0210, 'lps'),
	(513040, 127, '2014-02-01 01:15:49.000000', 'consum', 0.0222, 'lps'),
	(513041, 127, '2014-02-01 01:15:50.000000', 'consum', 0.0224, 'lps'),
	(513042, 127, '2014-02-01 01:15:51.000000', 'consum', 0.0214, 'lps'),
	(513043, 127, '2014-02-01 01:15:52.000000', 'consum', 0.0218, 'lps'),
	(513044, 127, '2014-02-01 01:15:53.000000', 'consum', 0.0222, 'lps'),
	(513045, 127, '2014-02-01 01:15:54.000000', 'consum', 0.0216, 'lps'),
	(513046, 127, '2014-02-01 01:15:55.000000', 'consum', 0.0218, 'lps'),
	(513047, 127, '2014-02-01 01:15:56.000000', 'consum', 0.0220, 'lps'),
	(513048, 127, '2014-02-01 01:15:57.000000', 'consum', 0.0218, 'lps'),
	(513049, 127, '2014-02-01 01:15:58.000000', 'consum', 0.0221, 'lps'),
	(513050, 127, '2014-02-01 01:15:59.000000', 'consum', 0.0224, 'lps'),
	(513051, 127, '2014-02-01 01:16:00.000000', 'consum', 0.0218, 'lps'),
	(513052, 127, '2014-02-01 01:16:01.000000', 'consum', 0.0224, 'lps'),
	(513053, 127, '2014-02-01 01:16:02.000000', 'consum', 0.0224, 'lps'),
	(513054, 127, '2014-02-01 01:16:03.000000', 'consum', 0.0225, 'lps'),
	(513055, 127, '2014-02-01 01:16:04.000000', 'consum', 0.0225, 'lps'),
	(513056, 127, '2014-02-01 01:16:05.000000', 'consum', 0.0225, 'lps'),
	(513057, 127, '2014-02-01 01:16:06.000000', 'consum', 0.0223, 'lps'),
	(513058, 127, '2014-02-01 01:16:07.000000', 'consum', 0.0217, 'lps'),
	(513059, 127, '2014-02-01 01:16:08.000000', 'consum', 0.0223, 'lps'),
	(513060, 127, '2014-02-01 01:16:09.000000', 'consum', 0.0222, 'lps'),
	(513061, 127, '2014-02-01 01:16:10.000000', 'consum', 0.0213, 'lps'),
	(513062, 127, '2014-02-01 01:16:11.000000', 'consum', 0.0225, 'lps'),
	(513063, 127, '2014-02-01 01:16:12.000000', 'consum', 0.0212, 'lps'),
	(513064, 127, '2014-02-01 01:16:13.000000', 'consum', 0.0221, 'lps'),
	(513065, 127, '2014-02-01 01:16:14.000000', 'consum', 0.0212, 'lps'),
	(513066, 127, '2014-02-01 01:16:15.000000', 'consum', 0.0221, 'lps'),
	(513067, 127, '2014-02-01 01:16:16.000000', 'consum', 0.0212, 'lps'),
	(513068, 127, '2014-02-01 01:16:17.000000', 'consum', 0.0217, 'lps'),
	(513069, 127, '2014-02-01 01:16:18.000000', 'consum', 0.0224, 'lps'),
	(513070, 127, '2014-02-01 01:16:19.000000', 'consum', 0.0211, 'lps'),
	(513071, 127, '2014-02-01 01:16:20.000000', 'consum', 0.0222, 'lps'),
	(513072, 127, '2014-02-01 01:16:21.000000', 'consum', 0.0220, 'lps'),
	(513073, 127, '2014-02-01 01:16:22.000000', 'consum', 0.0223, 'lps'),
	(513074, 127, '2014-02-01 01:16:23.000000', 'consum', 0.0215, 'lps'),
	(513075, 127, '2014-02-01 01:16:24.000000', 'consum', 0.0211, 'lps'),
	(513076, 127, '2014-02-01 01:16:25.000000', 'consum', 0.0218, 'lps'),
	(513077, 127, '2014-02-01 01:16:26.000000', 'consum', 0.0215, 'lps'),
	(513078, 127, '2014-02-01 01:16:27.000000', 'consum', 0.0211, 'lps'),
	(513079, 127, '2014-02-01 01:16:28.000000', 'consum', 0.0217, 'lps'),
	(513080, 127, '2014-02-01 01:16:29.000000', 'consum', 0.0212, 'lps'),
	(513081, 127, '2014-02-01 01:16:30.000000', 'consum', 0.0216, 'lps'),
	(513082, 127, '2014-02-01 01:16:31.000000', 'consum', 0.0217, 'lps'),
	(513083, 127, '2014-02-01 01:16:32.000000', 'consum', 0.0210, 'lps'),
	(513084, 127, '2014-02-01 01:16:33.000000', 'consum', 0.0224, 'lps'),
	(513085, 127, '2014-02-01 01:16:34.000000', 'consum', 0.0217, 'lps'),
	(513086, 127, '2014-02-01 01:16:35.000000', 'consum', 0.0219, 'lps'),
	(513087, 127, '2014-02-01 01:16:36.000000', 'consum', 0.0216, 'lps'),
	(513088, 127, '2014-02-01 01:16:37.000000', 'consum', 0.0216, 'lps'),
	(513089, 127, '2014-02-01 01:16:38.000000', 'consum', 0.0220, 'lps'),
	(513090, 127, '2014-02-01 01:16:39.000000', 'consum', 0.0212, 'lps'),
	(513091, 127, '2014-02-01 01:16:40.000000', 'consum', 0.0222, 'lps'),
	(513092, 127, '2014-02-01 01:16:41.000000', 'consum', 0.0215, 'lps'),
	(513093, 127, '2014-02-01 01:16:42.000000', 'consum', 0.0218, 'lps'),
	(513094, 127, '2014-02-01 01:16:43.000000', 'consum', 0.0219, 'lps'),
	(513095, 127, '2014-02-01 01:16:44.000000', 'consum', 0.0216, 'lps'),
	(513096, 127, '2014-02-01 01:16:45.000000', 'consum', 0.0212, 'lps'),
	(513097, 127, '2014-02-01 01:16:46.000000', 'consum', 0.0220, 'lps'),
	(513098, 127, '2014-02-01 01:16:47.000000', 'consum', 0.0223, 'lps'),
	(513099, 127, '2014-02-01 01:16:48.000000', 'consum', 0.0213, 'lps'),
	(513100, 127, '2014-02-01 01:16:49.000000', 'consum', 0.0219, 'lps'),
	(513101, 127, '2014-02-01 01:16:50.000000', 'consum', 0.0214, 'lps'),
	(513102, 127, '2014-02-01 01:16:51.000000', 'consum', 0.0218, 'lps'),
	(513103, 127, '2014-02-01 01:16:52.000000', 'consum', 0.0224, 'lps'),
	(513104, 127, '2014-02-01 01:16:53.000000', 'consum', 0.0225, 'lps'),
	(513105, 127, '2014-02-01 01:16:54.000000', 'consum', 0.0212, 'lps'),
	(513106, 127, '2014-02-01 01:16:55.000000', 'consum', 0.0222, 'lps'),
	(513107, 127, '2014-02-01 01:16:56.000000', 'consum', 0.0215, 'lps'),
	(513108, 127, '2014-02-01 01:16:57.000000', 'consum', 0.0218, 'lps'),
	(513109, 127, '2014-02-01 01:16:58.000000', 'consum', 0.0218, 'lps'),
	(513110, 127, '2014-02-01 01:16:59.000000', 'consum', 0.0212, 'lps'),
	(513111, 127, '2014-02-01 01:17:00.000000', 'consum', 0.0210, 'lps'),
	(513112, 127, '2014-02-01 01:17:01.000000', 'consum', 0.0223, 'lps'),
	(513113, 127, '2014-02-01 01:17:02.000000', 'consum', 0.0225, 'lps'),
	(513114, 127, '2014-02-01 01:17:03.000000', 'consum', 0.0214, 'lps'),
	(513115, 127, '2014-02-01 01:17:04.000000', 'consum', 0.0217, 'lps'),
	(513116, 127, '2014-02-01 01:17:05.000000', 'consum', 0.0218, 'lps'),
	(513117, 127, '2014-02-01 01:17:06.000000', 'consum', 0.0214, 'lps'),
	(513118, 127, '2014-02-01 01:17:07.000000', 'consum', 0.0220, 'lps'),
	(513119, 127, '2014-02-01 01:17:08.000000', 'consum', 0.0220, 'lps'),
	(513120, 127, '2014-02-01 01:17:09.000000', 'consum', 0.0215, 'lps'),
	(513121, 127, '2014-02-01 01:17:10.000000', 'consum', 0.0219, 'lps'),
	(513122, 127, '2014-02-01 01:17:11.000000', 'consum', 0.0224, 'lps'),
	(513123, 127, '2014-02-01 01:17:12.000000', 'consum', 0.0222, 'lps'),
	(513124, 127, '2014-02-01 01:17:13.000000', 'consum', 0.0212, 'lps'),
	(513125, 127, '2014-02-01 01:17:14.000000', 'consum', 0.0218, 'lps'),
	(513126, 127, '2014-02-01 01:17:15.000000', 'consum', 0.0214, 'lps'),
	(513127, 127, '2014-02-01 01:17:16.000000', 'consum', 0.0221, 'lps'),
	(513128, 127, '2014-02-01 01:17:17.000000', 'consum', 0.0220, 'lps'),
	(513129, 127, '2014-02-01 01:17:18.000000', 'consum', 0.0211, 'lps'),
	(513130, 127, '2014-02-01 01:17:19.000000', 'consum', 0.0220, 'lps'),
	(513131, 127, '2014-02-01 01:17:20.000000', 'consum', 0.0224, 'lps'),
	(513132, 127, '2014-02-01 01:17:21.000000', 'consum', 0.0221, 'lps'),
	(513133, 127, '2014-02-01 01:17:22.000000', 'consum', 0.0222, 'lps'),
	(513134, 127, '2014-02-01 01:17:23.000000', 'consum', 0.0220, 'lps'),
	(513135, 127, '2014-02-01 01:17:24.000000', 'consum', 0.0223, 'lps'),
	(513136, 127, '2014-02-01 01:17:25.000000', 'consum', 0.0217, 'lps'),
	(513137, 127, '2014-02-01 01:17:26.000000', 'consum', 0.0223, 'lps'),
	(513138, 127, '2014-02-01 01:17:27.000000', 'consum', 0.0222, 'lps'),
	(513139, 127, '2014-02-01 01:17:28.000000', 'consum', 0.0213, 'lps'),
	(513140, 127, '2014-02-01 01:17:29.000000', 'consum', 0.0223, 'lps'),
	(513141, 127, '2014-02-01 01:17:30.000000', 'consum', 0.0219, 'lps'),
	(513142, 127, '2014-02-01 01:17:31.000000', 'consum', 0.0217, 'lps'),
	(513143, 127, '2014-02-01 01:17:32.000000', 'consum', 0.0218, 'lps'),
	(513144, 127, '2014-02-01 01:17:33.000000', 'consum', 0.0214, 'lps'),
	(513145, 127, '2014-02-01 01:17:34.000000', 'consum', 0.0222, 'lps'),
	(513146, 127, '2014-02-01 01:17:35.000000', 'consum', 0.0210, 'lps'),
	(513147, 127, '2014-02-01 01:17:36.000000', 'consum', 0.0224, 'lps'),
	(513148, 127, '2014-02-01 01:17:37.000000', 'consum', 0.0217, 'lps'),
	(513149, 127, '2014-02-01 01:17:38.000000', 'consum', 0.0219, 'lps'),
	(513150, 127, '2014-02-01 01:17:39.000000', 'consum', 0.0219, 'lps'),
	(513151, 127, '2014-02-01 01:17:40.000000', 'consum', 0.0213, 'lps'),
	(513152, 127, '2014-02-01 01:17:41.000000', 'consum', 0.0215, 'lps'),
	(513153, 127, '2014-02-01 01:17:42.000000', 'consum', 0.0224, 'lps'),
	(513154, 127, '2014-02-01 01:17:43.000000', 'consum', 0.0217, 'lps'),
	(513155, 127, '2014-02-01 01:17:44.000000', 'consum', 0.0219, 'lps'),
	(513156, 127, '2014-02-01 01:17:45.000000', 'consum', 0.0219, 'lps'),
	(513157, 127, '2014-02-01 01:17:46.000000', 'consum', 0.0214, 'lps'),
	(513158, 127, '2014-02-01 01:17:47.000000', 'consum', 0.0219, 'lps'),
	(513159, 127, '2014-02-01 01:17:48.000000', 'consum', 0.0213, 'lps'),
	(513160, 127, '2014-02-01 01:17:49.000000', 'consum', 0.0211, 'lps'),
	(513161, 127, '2014-02-01 01:17:50.000000', 'consum', 0.0225, 'lps'),
	(513162, 127, '2014-02-01 01:17:51.000000', 'consum', 0.0219, 'lps'),
	(513163, 127, '2014-02-01 01:17:52.000000', 'consum', 0.0211, 'lps'),
	(513164, 127, '2014-02-01 01:17:53.000000', 'consum', 0.0221, 'lps'),
	(513165, 127, '2014-02-01 01:17:54.000000', 'consum', 0.0214, 'lps'),
	(513166, 127, '2014-02-01 01:17:55.000000', 'consum', 0.0215, 'lps'),
	(513167, 127, '2014-02-01 01:17:56.000000', 'consum', 0.0220, 'lps'),
	(513168, 127, '2014-02-01 01:17:57.000000', 'consum', 0.0216, 'lps'),
	(513169, 127, '2014-02-01 01:17:58.000000', 'consum', 0.0211, 'lps'),
	(513170, 127, '2014-02-01 01:17:59.000000', 'consum', 0.0213, 'lps'),
	(513171, 127, '2014-02-01 01:18:00.000000', 'consum', 0.0222, 'lps'),
	(513172, 127, '2014-02-01 01:18:01.000000', 'consum', 0.0214, 'lps'),
	(513173, 127, '2014-02-01 01:18:02.000000', 'consum', 0.0211, 'lps'),
	(513174, 127, '2014-02-01 01:18:03.000000', 'consum', 0.0220, 'lps'),
	(513175, 127, '2014-02-01 01:18:04.000000', 'consum', 0.0224, 'lps'),
	(513176, 127, '2014-02-01 01:18:05.000000', 'consum', 0.0220, 'lps'),
	(513177, 127, '2014-02-01 01:18:06.000000', 'consum', 0.0218, 'lps'),
	(513178, 127, '2014-02-01 01:18:07.000000', 'consum', 0.0220, 'lps'),
	(513179, 127, '2014-02-01 01:18:08.000000', 'consum', 0.0221, 'lps'),
	(513180, 127, '2014-02-01 01:18:09.000000', 'consum', 0.0219, 'lps'),
	(513181, 127, '2014-02-01 01:18:10.000000', 'consum', 0.0224, 'lps'),
	(513182, 127, '2014-02-01 01:18:11.000000', 'consum', 0.0223, 'lps'),
	(513183, 127, '2014-02-01 01:18:12.000000', 'consum', 0.0215, 'lps'),
	(513184, 127, '2014-02-01 01:18:13.000000', 'consum', 0.0212, 'lps'),
	(513185, 127, '2014-02-01 01:18:14.000000', 'consum', 0.0223, 'lps'),
	(513186, 127, '2014-02-01 01:18:15.000000', 'consum', 0.0222, 'lps'),
	(513187, 127, '2014-02-01 01:18:16.000000', 'consum', 0.0215, 'lps'),
	(513188, 127, '2014-02-01 01:18:17.000000', 'consum', 0.0213, 'lps'),
	(513189, 127, '2014-02-01 01:18:18.000000', 'consum', 0.0213, 'lps'),
	(513190, 127, '2014-02-01 01:18:19.000000', 'consum', 0.0216, 'lps'),
	(513191, 127, '2014-02-01 01:18:20.000000', 'consum', 0.0217, 'lps'),
	(513192, 127, '2014-02-01 01:18:21.000000', 'consum', 0.0224, 'lps'),
	(513193, 127, '2014-02-01 01:18:22.000000', 'consum', 0.0214, 'lps'),
	(513194, 127, '2014-02-01 01:18:23.000000', 'consum', 0.0222, 'lps'),
	(513195, 127, '2014-02-01 01:18:24.000000', 'consum', 0.0223, 'lps'),
	(513196, 127, '2014-02-01 01:18:25.000000', 'consum', 0.0225, 'lps'),
	(513197, 127, '2014-02-01 01:18:26.000000', 'consum', 0.0215, 'lps'),
	(513198, 127, '2014-02-01 01:18:27.000000', 'consum', 0.0220, 'lps'),
	(513199, 127, '2014-02-01 01:18:28.000000', 'consum', 0.0216, 'lps'),
	(513200, 127, '2014-02-01 01:18:29.000000', 'consum', 0.0212, 'lps'),
	(513201, 127, '2014-02-01 01:18:30.000000', 'consum', 0.0216, 'lps'),
	(513202, 127, '2014-02-01 01:18:31.000000', 'consum', 0.0218, 'lps'),
	(513203, 127, '2014-02-01 01:18:32.000000', 'consum', 0.0217, 'lps'),
	(513204, 127, '2014-02-01 01:18:33.000000', 'consum', 0.0220, 'lps'),
	(513205, 127, '2014-02-01 01:18:34.000000', 'consum', 0.0223, 'lps'),
	(513206, 127, '2014-02-01 01:18:35.000000', 'consum', 0.0214, 'lps'),
	(513207, 127, '2014-02-01 01:18:36.000000', 'consum', 0.0225, 'lps'),
	(513208, 127, '2014-02-01 01:18:37.000000', 'consum', 0.0224, 'lps'),
	(513209, 127, '2014-02-01 01:18:38.000000', 'consum', 0.0222, 'lps'),
	(513210, 127, '2014-02-01 01:18:39.000000', 'consum', 0.0225, 'lps'),
	(513211, 127, '2014-02-01 01:18:40.000000', 'consum', 0.0221, 'lps'),
	(513212, 127, '2014-02-01 01:18:41.000000', 'consum', 0.0218, 'lps'),
	(513213, 127, '2014-02-01 01:18:42.000000', 'consum', 0.0217, 'lps'),
	(513214, 127, '2014-02-01 01:18:43.000000', 'consum', 0.0224, 'lps'),
	(513215, 127, '2014-02-01 01:18:44.000000', 'consum', 0.0211, 'lps'),
	(513216, 127, '2014-02-01 01:18:45.000000', 'consum', 0.0221, 'lps'),
	(513217, 127, '2014-02-01 01:18:46.000000', 'consum', 0.0215, 'lps'),
	(513218, 127, '2014-02-01 01:18:47.000000', 'consum', 0.0220, 'lps'),
	(513219, 127, '2014-02-01 01:18:48.000000', 'consum', 0.0213, 'lps'),
	(513220, 127, '2014-02-01 01:18:49.000000', 'consum', 0.0212, 'lps'),
	(513221, 127, '2014-02-01 01:18:50.000000', 'consum', 0.0212, 'lps'),
	(513222, 127, '2014-02-01 01:18:51.000000', 'consum', 0.0216, 'lps'),
	(513223, 127, '2014-02-01 01:18:52.000000', 'consum', 0.0216, 'lps'),
	(513224, 127, '2014-02-01 01:18:53.000000', 'consum', 0.0222, 'lps'),
	(513225, 127, '2014-02-01 01:18:54.000000', 'consum', 0.0223, 'lps'),
	(513226, 127, '2014-02-01 01:18:55.000000', 'consum', 0.0223, 'lps'),
	(513227, 127, '2014-02-01 01:18:56.000000', 'consum', 0.0221, 'lps'),
	(513228, 127, '2014-02-01 01:18:57.000000', 'consum', 0.0211, 'lps'),
	(513229, 127, '2014-02-01 01:18:58.000000', 'consum', 0.0215, 'lps'),
	(513230, 127, '2014-02-01 01:18:59.000000', 'consum', 0.0217, 'lps'),
	(513231, 127, '2014-02-01 01:19:00.000000', 'consum', 0.0214, 'lps'),
	(513232, 127, '2014-02-01 01:19:01.000000', 'consum', 0.0223, 'lps'),
	(513233, 127, '2014-02-01 01:19:02.000000', 'consum', 0.0219, 'lps'),
	(513234, 127, '2014-02-01 01:19:03.000000', 'consum', 0.0215, 'lps'),
	(513235, 127, '2014-02-01 01:19:04.000000', 'consum', 0.0223, 'lps'),
	(513236, 127, '2014-02-01 01:19:05.000000', 'consum', 0.0216, 'lps'),
	(513237, 127, '2014-02-01 01:19:06.000000', 'consum', 0.0214, 'lps'),
	(513238, 127, '2014-02-01 01:19:07.000000', 'consum', 0.0215, 'lps'),
	(513239, 127, '2014-02-01 01:19:08.000000', 'consum', 0.0221, 'lps'),
	(513240, 127, '2014-02-01 01:19:09.000000', 'consum', 0.0222, 'lps'),
	(513241, 127, '2014-02-01 01:19:10.000000', 'consum', 0.0218, 'lps'),
	(513242, 127, '2014-02-01 01:19:11.000000', 'consum', 0.0215, 'lps'),
	(513243, 127, '2014-02-01 01:19:12.000000', 'consum', 0.0212, 'lps'),
	(513244, 127, '2014-02-01 01:19:13.000000', 'consum', 0.0223, 'lps'),
	(513245, 127, '2014-02-01 01:19:14.000000', 'consum', 0.0220, 'lps'),
	(513246, 127, '2014-02-01 01:19:15.000000', 'consum', 0.0223, 'lps'),
	(513247, 127, '2014-02-01 01:19:16.000000', 'consum', 0.0212, 'lps'),
	(513248, 127, '2014-02-01 01:19:17.000000', 'consum', 0.0214, 'lps'),
	(513249, 127, '2014-02-01 01:19:18.000000', 'consum', 0.0210, 'lps'),
	(513250, 127, '2014-02-01 01:19:19.000000', 'consum', 0.0214, 'lps'),
	(513251, 127, '2014-02-01 01:19:20.000000', 'consum', 0.0215, 'lps'),
	(513252, 127, '2014-02-01 01:19:21.000000', 'consum', 0.0225, 'lps'),
	(513253, 127, '2014-02-01 01:19:22.000000', 'consum', 0.0219, 'lps'),
	(513254, 127, '2014-02-01 01:19:23.000000', 'consum', 0.0212, 'lps'),
	(513255, 127, '2014-02-01 01:19:24.000000', 'consum', 0.0225, 'lps'),
	(513256, 127, '2014-02-01 01:19:25.000000', 'consum', 0.0217, 'lps'),
	(513257, 127, '2014-02-01 01:19:26.000000', 'consum', 0.0215, 'lps'),
	(513258, 127, '2014-02-01 01:19:27.000000', 'consum', 0.0213, 'lps'),
	(513259, 127, '2014-02-01 01:19:28.000000', 'consum', 0.0214, 'lps'),
	(513260, 127, '2014-02-01 01:19:29.000000', 'consum', 0.0220, 'lps'),
	(513261, 127, '2014-02-01 01:19:30.000000', 'consum', 0.0215, 'lps'),
	(513262, 127, '2014-02-01 01:19:31.000000', 'consum', 0.0221, 'lps'),
	(513263, 127, '2014-02-01 01:19:32.000000', 'consum', 0.0220, 'lps'),
	(513264, 127, '2014-02-01 01:19:33.000000', 'consum', 0.0225, 'lps'),
	(513265, 127, '2014-02-01 01:19:34.000000', 'consum', 0.0211, 'lps'),
	(513266, 127, '2014-02-01 01:19:35.000000', 'consum', 0.0217, 'lps'),
	(513267, 127, '2014-02-01 01:19:36.000000', 'consum', 0.0210, 'lps'),
	(513268, 127, '2014-02-01 01:19:37.000000', 'consum', 0.0223, 'lps'),
	(513269, 127, '2014-02-01 01:19:38.000000', 'consum', 0.0225, 'lps'),
	(513270, 127, '2014-02-01 01:19:39.000000', 'consum', 0.0215, 'lps'),
	(513271, 127, '2014-02-01 01:19:40.000000', 'consum', 0.0221, 'lps'),
	(513272, 127, '2014-02-01 01:19:41.000000', 'consum', 0.0221, 'lps'),
	(513273, 127, '2014-02-01 01:19:42.000000', 'consum', 0.0215, 'lps'),
	(513274, 127, '2014-02-01 01:19:43.000000', 'consum', 0.0221, 'lps'),
	(513275, 127, '2014-02-01 01:19:44.000000', 'consum', 0.0217, 'lps'),
	(513276, 127, '2014-02-01 01:19:45.000000', 'consum', 0.0212, 'lps'),
	(513277, 127, '2014-02-01 01:19:46.000000', 'consum', 0.0215, 'lps'),
	(513278, 127, '2014-02-01 01:19:47.000000', 'consum', 0.0215, 'lps'),
	(513279, 127, '2014-02-01 01:19:48.000000', 'consum', 0.0218, 'lps'),
	(513280, 127, '2014-02-01 01:19:49.000000', 'consum', 0.0220, 'lps'),
	(513281, 127, '2014-02-01 01:19:50.000000', 'consum', 0.0220, 'lps'),
	(513282, 127, '2014-02-01 01:19:51.000000', 'consum', 0.0217, 'lps'),
	(513283, 127, '2014-02-01 01:19:52.000000', 'consum', 0.0214, 'lps'),
	(513284, 127, '2014-02-01 01:19:53.000000', 'consum', 0.0225, 'lps'),
	(513285, 127, '2014-02-01 01:19:54.000000', 'consum', 0.0224, 'lps'),
	(513286, 127, '2014-02-01 01:19:55.000000', 'consum', 0.0220, 'lps'),
	(513287, 127, '2014-02-01 01:19:56.000000', 'consum', 0.0220, 'lps'),
	(513288, 127, '2014-02-01 01:19:57.000000', 'consum', 0.0213, 'lps'),
	(513289, 127, '2014-02-01 01:19:58.000000', 'consum', 0.0214, 'lps'),
	(513290, 127, '2014-02-01 01:19:59.000000', 'consum', 0.0219, 'lps'),
	(513291, 127, '2014-02-01 01:20:00.000000', 'consum', 0.0214, 'lps'),
	(513292, 127, '2014-02-01 01:20:01.000000', 'consum', 0.0217, 'lps'),
	(513293, 127, '2014-02-01 01:20:02.000000', 'consum', 0.0217, 'lps'),
	(513294, 127, '2014-02-01 01:20:03.000000', 'consum', 0.0211, 'lps'),
	(513295, 127, '2014-02-01 01:20:04.000000', 'consum', 0.0210, 'lps'),
	(513296, 127, '2014-02-01 01:20:05.000000', 'consum', 0.0224, 'lps'),
	(513297, 127, '2014-02-01 01:20:06.000000', 'consum', 0.0216, 'lps'),
	(513298, 128, '2014-02-01 00:00:00.000000', 'consum', 0.0223, 'lps'),
	(513299, 128, '2014-02-01 00:00:01.000000', 'consum', 0.0210, 'lps'),
	(513300, 128, '2014-02-01 00:00:02.000000', 'consum', 0.0214, 'lps'),
	(513301, 128, '2014-02-01 00:00:03.000000', 'consum', 0.0215, 'lps'),
	(513302, 128, '2014-02-01 00:00:04.000000', 'consum', 0.0210, 'lps'),
	(513303, 128, '2014-02-01 00:00:05.000000', 'consum', 0.0211, 'lps'),
	(513304, 128, '2014-02-01 00:00:06.000000', 'consum', 0.0216, 'lps'),
	(513305, 128, '2014-02-01 00:00:07.000000', 'consum', 0.0222, 'lps'),
	(513306, 128, '2014-02-01 00:00:08.000000', 'consum', 0.0211, 'lps'),
	(513307, 128, '2014-02-01 00:00:09.000000', 'consum', 0.0220, 'lps'),
	(513308, 128, '2014-02-01 00:00:10.000000', 'consum', 0.0216, 'lps'),
	(513309, 128, '2014-02-01 00:00:11.000000', 'consum', 0.0212, 'lps'),
	(513310, 128, '2014-02-01 00:00:12.000000', 'consum', 0.0216, 'lps'),
	(513311, 128, '2014-02-01 00:00:13.000000', 'consum', 0.0222, 'lps'),
	(513312, 128, '2014-02-01 00:00:14.000000', 'consum', 0.0223, 'lps'),
	(513313, 128, '2014-02-01 00:00:15.000000', 'consum', 0.0214, 'lps'),
	(513314, 128, '2014-02-01 00:00:16.000000', 'consum', 0.0217, 'lps'),
	(513315, 128, '2014-02-01 00:00:17.000000', 'consum', 0.0220, 'lps'),
	(513316, 128, '2014-02-01 00:00:18.000000', 'consum', 0.0211, 'lps'),
	(513317, 128, '2014-02-01 00:00:19.000000', 'consum', 0.0213, 'lps'),
	(513318, 128, '2014-02-01 00:00:20.000000', 'consum', 0.0221, 'lps'),
	(513319, 128, '2014-02-01 00:00:21.000000', 'consum', 0.0216, 'lps'),
	(513320, 128, '2014-02-01 00:00:22.000000', 'consum', 0.0223, 'lps'),
	(513321, 128, '2014-02-01 00:00:23.000000', 'consum', 0.0215, 'lps'),
	(513322, 128, '2014-02-01 00:00:24.000000', 'consum', 0.0210, 'lps'),
	(513323, 128, '2014-02-01 00:00:25.000000', 'consum', 0.0222, 'lps'),
	(513324, 128, '2014-02-01 00:00:26.000000', 'consum', 0.0214, 'lps'),
	(513325, 128, '2014-02-01 00:00:27.000000', 'consum', 0.0222, 'lps'),
	(513326, 128, '2014-02-01 00:00:28.000000', 'consum', 0.0216, 'lps'),
	(513327, 128, '2014-02-01 00:00:29.000000', 'consum', 0.0218, 'lps'),
	(513328, 128, '2014-02-01 00:00:30.000000', 'consum', 0.0218, 'lps'),
	(513329, 128, '2014-02-01 00:00:31.000000', 'consum', 0.0213, 'lps'),
	(513330, 128, '2014-02-01 00:00:32.000000', 'consum', 0.0216, 'lps'),
	(513331, 128, '2014-02-01 00:00:33.000000', 'consum', 0.0217, 'lps'),
	(513332, 128, '2014-02-01 00:00:34.000000', 'consum', 0.0215, 'lps'),
	(513333, 128, '2014-02-01 00:00:35.000000', 'consum', 0.0212, 'lps'),
	(513334, 128, '2014-02-01 00:00:36.000000', 'consum', 0.0223, 'lps'),
	(513335, 128, '2014-02-01 00:00:37.000000', 'consum', 0.0211, 'lps'),
	(513336, 128, '2014-02-01 00:00:38.000000', 'consum', 0.0217, 'lps'),
	(513337, 128, '2014-02-01 00:00:39.000000', 'consum', 0.0216, 'lps'),
	(513338, 128, '2014-02-01 00:00:40.000000', 'consum', 0.0221, 'lps'),
	(513339, 128, '2014-02-01 00:00:41.000000', 'consum', 0.0217, 'lps'),
	(513340, 128, '2014-02-01 00:00:42.000000', 'consum', 0.0213, 'lps'),
	(513341, 128, '2014-02-01 00:00:43.000000', 'consum', 0.0218, 'lps'),
	(513342, 128, '2014-02-01 00:00:44.000000', 'consum', 0.0213, 'lps'),
	(513343, 128, '2014-02-01 00:00:45.000000', 'consum', 0.0218, 'lps'),
	(513344, 128, '2014-02-01 00:00:46.000000', 'consum', 0.0211, 'lps'),
	(513345, 128, '2014-02-01 00:00:47.000000', 'consum', 0.0220, 'lps'),
	(513346, 128, '2014-02-01 00:00:48.000000', 'consum', 0.0217, 'lps'),
	(513347, 128, '2014-02-01 00:00:49.000000', 'consum', 0.0215, 'lps'),
	(513348, 128, '2014-02-01 00:00:50.000000', 'consum', 0.0213, 'lps'),
	(513349, 128, '2014-02-01 00:00:51.000000', 'consum', 0.0212, 'lps'),
	(513350, 128, '2014-02-01 00:00:52.000000', 'consum', 0.0213, 'lps'),
	(513351, 128, '2014-02-01 00:00:53.000000', 'consum', 0.0217, 'lps'),
	(513352, 128, '2014-02-01 00:00:54.000000', 'consum', 0.0222, 'lps'),
	(513353, 128, '2014-02-01 00:00:55.000000', 'consum', 0.0221, 'lps'),
	(513354, 128, '2014-02-01 00:00:56.000000', 'consum', 0.0218, 'lps'),
	(513355, 128, '2014-02-01 00:00:57.000000', 'consum', 0.0216, 'lps'),
	(513356, 128, '2014-02-01 00:00:58.000000', 'consum', 0.0219, 'lps'),
	(513357, 128, '2014-02-01 00:00:59.000000', 'consum', 0.0220, 'lps'),
	(513358, 128, '2014-02-01 00:01:00.000000', 'consum', 0.0222, 'lps'),
	(513359, 128, '2014-02-01 00:01:01.000000', 'consum', 0.0211, 'lps'),
	(513360, 128, '2014-02-01 00:01:02.000000', 'consum', 0.0222, 'lps'),
	(513361, 128, '2014-02-01 00:01:03.000000', 'consum', 0.0210, 'lps'),
	(513362, 128, '2014-02-01 00:01:04.000000', 'consum', 0.0218, 'lps'),
	(513363, 128, '2014-02-01 00:01:05.000000', 'consum', 0.0221, 'lps'),
	(513364, 128, '2014-02-01 00:01:06.000000', 'consum', 0.0212, 'lps'),
	(513365, 128, '2014-02-01 00:01:07.000000', 'consum', 0.0218, 'lps'),
	(513366, 128, '2014-02-01 00:01:08.000000', 'consum', 0.0217, 'lps'),
	(513367, 128, '2014-02-01 00:01:09.000000', 'consum', 0.0222, 'lps'),
	(513368, 128, '2014-02-01 00:01:10.000000', 'consum', 0.0219, 'lps'),
	(513369, 128, '2014-02-01 00:01:11.000000', 'consum', 0.0223, 'lps'),
	(513370, 128, '2014-02-01 00:01:12.000000', 'consum', 0.0217, 'lps'),
	(513371, 128, '2014-02-01 00:01:13.000000', 'consum', 0.0223, 'lps'),
	(513372, 128, '2014-02-01 00:01:14.000000', 'consum', 0.0210, 'lps'),
	(513373, 128, '2014-02-01 00:01:15.000000', 'consum', 0.0215, 'lps'),
	(513374, 128, '2014-02-01 00:01:16.000000', 'consum', 0.0220, 'lps'),
	(513375, 128, '2014-02-01 00:01:17.000000', 'consum', 0.0217, 'lps'),
	(513376, 128, '2014-02-01 00:01:18.000000', 'consum', 0.0216, 'lps'),
	(513377, 128, '2014-02-01 00:01:19.000000', 'consum', 0.0220, 'lps'),
	(513378, 128, '2014-02-01 00:01:20.000000', 'consum', 0.0213, 'lps'),
	(513379, 128, '2014-02-01 00:01:21.000000', 'consum', 0.0213, 'lps'),
	(513380, 128, '2014-02-01 00:01:22.000000', 'consum', 0.0213, 'lps'),
	(513381, 128, '2014-02-01 00:01:23.000000', 'consum', 0.0217, 'lps'),
	(513382, 128, '2014-02-01 00:01:24.000000', 'consum', 0.0221, 'lps'),
	(513383, 128, '2014-02-01 00:01:25.000000', 'consum', 0.0219, 'lps'),
	(513384, 128, '2014-02-01 00:01:26.000000', 'consum', 0.0210, 'lps'),
	(513385, 128, '2014-02-01 00:01:27.000000', 'consum', 0.0222, 'lps'),
	(513386, 128, '2014-02-01 00:01:28.000000', 'consum', 0.0217, 'lps'),
	(513387, 128, '2014-02-01 00:01:29.000000', 'consum', 0.0210, 'lps'),
	(513388, 128, '2014-02-01 00:01:30.000000', 'consum', 0.0217, 'lps'),
	(513389, 128, '2014-02-01 00:01:31.000000', 'consum', 0.0216, 'lps'),
	(513390, 128, '2014-02-01 00:01:32.000000', 'consum', 0.0218, 'lps'),
	(513391, 128, '2014-02-01 00:01:33.000000', 'consum', 0.0221, 'lps'),
	(513392, 128, '2014-02-01 00:01:34.000000', 'consum', 0.0214, 'lps'),
	(513393, 128, '2014-02-01 00:01:35.000000', 'consum', 0.0211, 'lps'),
	(513394, 128, '2014-02-01 00:01:36.000000', 'consum', 0.0219, 'lps'),
	(513395, 128, '2014-02-01 00:01:37.000000', 'consum', 0.0210, 'lps'),
	(513396, 128, '2014-02-01 00:01:38.000000', 'consum', 0.0213, 'lps'),
	(513397, 128, '2014-02-01 00:01:39.000000', 'consum', 0.0210, 'lps'),
	(513398, 128, '2014-02-01 00:01:40.000000', 'consum', 0.0216, 'lps'),
	(513399, 128, '2014-02-01 00:01:41.000000', 'consum', 0.0212, 'lps'),
	(513400, 128, '2014-02-01 00:01:42.000000', 'consum', 0.0215, 'lps'),
	(513401, 128, '2014-02-01 00:01:43.000000', 'consum', 0.0215, 'lps'),
	(513402, 128, '2014-02-01 00:01:44.000000', 'consum', 0.0222, 'lps'),
	(513403, 128, '2014-02-01 00:01:45.000000', 'consum', 0.0215, 'lps'),
	(513404, 128, '2014-02-01 00:01:46.000000', 'consum', 0.0212, 'lps'),
	(513405, 128, '2014-02-01 00:01:47.000000', 'consum', 0.0221, 'lps'),
	(513406, 128, '2014-02-01 00:01:48.000000', 'consum', 0.0217, 'lps'),
	(513407, 128, '2014-02-01 00:01:49.000000', 'consum', 0.0213, 'lps'),
	(513408, 128, '2014-02-01 00:01:50.000000', 'consum', 0.0218, 'lps'),
	(513409, 128, '2014-02-01 00:01:51.000000', 'consum', 0.0212, 'lps'),
	(513410, 128, '2014-02-01 00:01:52.000000', 'consum', 0.0213, 'lps'),
	(513411, 128, '2014-02-01 00:01:53.000000', 'consum', 0.0217, 'lps'),
	(513412, 128, '2014-02-01 00:01:54.000000', 'consum', 0.0211, 'lps'),
	(513413, 128, '2014-02-01 00:01:55.000000', 'consum', 0.0221, 'lps'),
	(513414, 128, '2014-02-01 00:01:56.000000', 'consum', 0.0222, 'lps'),
	(513415, 128, '2014-02-01 00:01:57.000000', 'consum', 0.0223, 'lps'),
	(513416, 128, '2014-02-01 00:01:58.000000', 'consum', 0.0213, 'lps'),
	(513417, 128, '2014-02-01 00:01:59.000000', 'consum', 0.0213, 'lps'),
	(513418, 128, '2014-02-01 00:02:00.000000', 'consum', 0.0218, 'lps'),
	(513419, 128, '2014-02-01 00:02:01.000000', 'consum', 0.0213, 'lps'),
	(513420, 128, '2014-02-01 00:02:02.000000', 'consum', 0.0215, 'lps'),
	(513421, 128, '2014-02-01 00:02:03.000000', 'consum', 0.0213, 'lps'),
	(513422, 128, '2014-02-01 00:02:04.000000', 'consum', 0.0222, 'lps'),
	(513423, 128, '2014-02-01 00:02:05.000000', 'consum', 0.0222, 'lps'),
	(513424, 128, '2014-02-01 00:02:06.000000', 'consum', 0.0218, 'lps'),
	(513425, 128, '2014-02-01 00:02:07.000000', 'consum', 0.0218, 'lps'),
	(513426, 128, '2014-02-01 00:02:08.000000', 'consum', 0.0210, 'lps'),
	(513427, 128, '2014-02-01 00:02:09.000000', 'consum', 0.0217, 'lps'),
	(513428, 128, '2014-02-01 00:02:10.000000', 'consum', 0.0216, 'lps'),
	(513429, 128, '2014-02-01 00:02:11.000000', 'consum', 0.0219, 'lps'),
	(513430, 128, '2014-02-01 00:02:12.000000', 'consum', 0.0223, 'lps'),
	(513431, 128, '2014-02-01 00:02:13.000000', 'consum', 0.0222, 'lps'),
	(513432, 128, '2014-02-01 00:02:14.000000', 'consum', 0.0217, 'lps'),
	(513433, 128, '2014-02-01 00:02:15.000000', 'consum', 0.0210, 'lps'),
	(513434, 128, '2014-02-01 00:02:16.000000', 'consum', 0.0215, 'lps'),
	(513435, 128, '2014-02-01 00:02:17.000000', 'consum', 0.0223, 'lps'),
	(513436, 128, '2014-02-01 00:02:18.000000', 'consum', 0.0218, 'lps'),
	(513437, 128, '2014-02-01 00:02:19.000000', 'consum', 0.0214, 'lps'),
	(513438, 128, '2014-02-01 00:02:20.000000', 'consum', 0.0219, 'lps'),
	(513439, 128, '2014-02-01 00:02:21.000000', 'consum', 0.0214, 'lps'),
	(513440, 128, '2014-02-01 00:02:22.000000', 'consum', 0.0219, 'lps'),
	(513441, 128, '2014-02-01 00:02:23.000000', 'consum', 0.0215, 'lps'),
	(513442, 128, '2014-02-01 00:02:24.000000', 'consum', 0.0221, 'lps'),
	(513443, 128, '2014-02-01 00:02:25.000000', 'consum', 0.0223, 'lps'),
	(513444, 128, '2014-02-01 00:02:26.000000', 'consum', 0.0214, 'lps'),
	(513445, 128, '2014-02-01 00:02:27.000000', 'consum', 0.0220, 'lps'),
	(513446, 128, '2014-02-01 00:02:28.000000', 'consum', 0.0219, 'lps'),
	(513447, 128, '2014-02-01 00:02:29.000000', 'consum', 0.0211, 'lps'),
	(513448, 128, '2014-02-01 00:02:30.000000', 'consum', 0.0220, 'lps'),
	(513449, 128, '2014-02-01 00:02:31.000000', 'consum', 0.0213, 'lps'),
	(513450, 128, '2014-02-01 00:02:32.000000', 'consum', 0.0222, 'lps'),
	(513451, 128, '2014-02-01 00:02:33.000000', 'consum', 0.0222, 'lps'),
	(513452, 128, '2014-02-01 00:02:34.000000', 'consum', 0.0218, 'lps'),
	(513453, 128, '2014-02-01 00:02:35.000000', 'consum', 0.0215, 'lps'),
	(513454, 128, '2014-02-01 00:02:36.000000', 'consum', 0.0211, 'lps'),
	(513455, 128, '2014-02-01 00:02:37.000000', 'consum', 0.0214, 'lps'),
	(513456, 128, '2014-02-01 00:02:38.000000', 'consum', 0.0213, 'lps'),
	(513457, 128, '2014-02-01 00:02:39.000000', 'consum', 0.0215, 'lps'),
	(513458, 128, '2014-02-01 00:02:40.000000', 'consum', 0.0214, 'lps'),
	(513459, 128, '2014-02-01 00:02:41.000000', 'consum', 0.0213, 'lps'),
	(513460, 128, '2014-02-01 00:02:42.000000', 'consum', 0.0215, 'lps'),
	(513461, 128, '2014-02-01 00:02:43.000000', 'consum', 0.0214, 'lps'),
	(513462, 128, '2014-02-01 00:02:44.000000', 'consum', 0.0212, 'lps'),
	(513463, 128, '2014-02-01 00:02:45.000000', 'consum', 0.0210, 'lps'),
	(513464, 128, '2014-02-01 00:02:46.000000', 'consum', 0.0218, 'lps'),
	(513465, 128, '2014-02-01 00:02:47.000000', 'consum', 0.0210, 'lps'),
	(513466, 128, '2014-02-01 00:02:48.000000', 'consum', 0.0213, 'lps'),
	(513467, 128, '2014-02-01 00:02:49.000000', 'consum', 0.0212, 'lps'),
	(513468, 128, '2014-02-01 00:02:50.000000', 'consum', 0.0213, 'lps'),
	(513469, 128, '2014-02-01 00:02:51.000000', 'consum', 0.0218, 'lps'),
	(513470, 128, '2014-02-01 00:02:52.000000', 'consum', 0.0216, 'lps'),
	(513471, 128, '2014-02-01 00:02:53.000000', 'consum', 0.0213, 'lps'),
	(513472, 128, '2014-02-01 00:02:54.000000', 'consum', 0.0222, 'lps'),
	(513473, 128, '2014-02-01 00:02:55.000000', 'consum', 0.0221, 'lps'),
	(513474, 128, '2014-02-01 00:02:56.000000', 'consum', 0.0214, 'lps'),
	(513475, 128, '2014-02-01 00:02:57.000000', 'consum', 0.0211, 'lps'),
	(513476, 128, '2014-02-01 00:02:58.000000', 'consum', 0.0217, 'lps'),
	(513477, 128, '2014-02-01 00:02:59.000000', 'consum', 0.0217, 'lps'),
	(513478, 128, '2014-02-01 00:03:00.000000', 'consum', 0.0210, 'lps'),
	(513479, 128, '2014-02-01 00:03:01.000000', 'consum', 0.0218, 'lps'),
	(513480, 128, '2014-02-01 00:03:02.000000', 'consum', 0.0221, 'lps'),
	(513481, 128, '2014-02-01 00:03:03.000000', 'consum', 0.0212, 'lps'),
	(513482, 128, '2014-02-01 00:03:04.000000', 'consum', 0.0219, 'lps'),
	(513483, 128, '2014-02-01 00:03:05.000000', 'consum', 0.0219, 'lps'),
	(513484, 128, '2014-02-01 00:03:06.000000', 'consum', 0.0217, 'lps'),
	(513485, 128, '2014-02-01 00:03:07.000000', 'consum', 0.0219, 'lps'),
	(513486, 128, '2014-02-01 00:03:08.000000', 'consum', 0.0219, 'lps'),
	(513487, 128, '2014-02-01 00:03:09.000000', 'consum', 0.0216, 'lps'),
	(513488, 128, '2014-02-01 00:03:10.000000', 'consum', 0.0212, 'lps'),
	(513489, 128, '2014-02-01 00:03:11.000000', 'consum', 0.0218, 'lps'),
	(513490, 128, '2014-02-01 00:03:12.000000', 'consum', 0.0214, 'lps'),
	(513491, 128, '2014-02-01 00:03:13.000000', 'consum', 0.0222, 'lps'),
	(513492, 128, '2014-02-01 00:03:14.000000', 'consum', 0.0217, 'lps'),
	(513493, 128, '2014-02-01 00:03:15.000000', 'consum', 0.0210, 'lps'),
	(513494, 128, '2014-02-01 00:03:16.000000', 'consum', 0.0218, 'lps'),
	(513495, 128, '2014-02-01 00:03:17.000000', 'consum', 0.0222, 'lps'),
	(513496, 128, '2014-02-01 00:03:18.000000', 'consum', 0.0219, 'lps'),
	(513497, 128, '2014-02-01 00:03:19.000000', 'consum', 0.0220, 'lps'),
	(513498, 128, '2014-02-01 00:03:20.000000', 'consum', 0.0220, 'lps'),
	(513499, 128, '2014-02-01 00:03:21.000000', 'consum', 0.0216, 'lps'),
	(513500, 128, '2014-02-01 00:03:22.000000', 'consum', 0.0210, 'lps'),
	(513501, 128, '2014-02-01 00:03:23.000000', 'consum', 0.0222, 'lps'),
	(513502, 128, '2014-02-01 00:03:24.000000', 'consum', 0.0213, 'lps'),
	(513503, 128, '2014-02-01 00:03:25.000000', 'consum', 0.0218, 'lps'),
	(513504, 128, '2014-02-01 00:03:26.000000', 'consum', 0.0213, 'lps'),
	(513505, 128, '2014-02-01 00:03:27.000000', 'consum', 0.0214, 'lps'),
	(513506, 128, '2014-02-01 00:03:28.000000', 'consum', 0.0222, 'lps'),
	(513507, 128, '2014-02-01 00:03:29.000000', 'consum', 0.0217, 'lps'),
	(513508, 128, '2014-02-01 00:03:30.000000', 'consum', 0.0211, 'lps'),
	(513509, 128, '2014-02-01 00:03:31.000000', 'consum', 0.0222, 'lps'),
	(513510, 128, '2014-02-01 00:03:32.000000', 'consum', 0.0211, 'lps'),
	(513511, 128, '2014-02-01 00:03:33.000000', 'consum', 0.0221, 'lps'),
	(513512, 128, '2014-02-01 00:03:34.000000', 'consum', 0.0220, 'lps'),
	(513513, 128, '2014-02-01 00:03:35.000000', 'consum', 0.0214, 'lps'),
	(513514, 128, '2014-02-01 00:03:36.000000', 'consum', 0.0213, 'lps'),
	(513515, 128, '2014-02-01 00:03:37.000000', 'consum', 0.0215, 'lps'),
	(513516, 128, '2014-02-01 00:03:38.000000', 'consum', 0.0212, 'lps'),
	(513517, 128, '2014-02-01 00:03:39.000000', 'consum', 0.0221, 'lps'),
	(513518, 128, '2014-02-01 00:03:40.000000', 'consum', 0.0216, 'lps'),
	(513519, 128, '2014-02-01 00:03:41.000000', 'consum', 0.0220, 'lps'),
	(513520, 128, '2014-02-01 00:03:42.000000', 'consum', 0.0217, 'lps'),
	(513521, 128, '2014-02-01 00:03:43.000000', 'consum', 0.0217, 'lps'),
	(513522, 128, '2014-02-01 00:03:44.000000', 'consum', 0.0222, 'lps'),
	(513523, 128, '2014-02-01 00:03:45.000000', 'consum', 0.0220, 'lps'),
	(513524, 128, '2014-02-01 00:03:46.000000', 'consum', 0.0213, 'lps'),
	(513525, 128, '2014-02-01 00:03:47.000000', 'consum', 0.0223, 'lps'),
	(513526, 128, '2014-02-01 00:03:48.000000', 'consum', 0.0210, 'lps'),
	(513527, 128, '2014-02-01 00:03:49.000000', 'consum', 0.0215, 'lps'),
	(513528, 128, '2014-02-01 00:03:50.000000', 'consum', 0.0221, 'lps'),
	(513529, 128, '2014-02-01 00:03:51.000000', 'consum', 0.0221, 'lps'),
	(513530, 128, '2014-02-01 00:03:52.000000', 'consum', 0.0219, 'lps'),
	(513531, 128, '2014-02-01 00:03:53.000000', 'consum', 0.0210, 'lps'),
	(513532, 128, '2014-02-01 00:03:54.000000', 'consum', 0.0210, 'lps'),
	(513533, 128, '2014-02-01 00:03:55.000000', 'consum', 0.0213, 'lps'),
	(513534, 128, '2014-02-01 00:03:56.000000', 'consum', 0.0223, 'lps'),
	(513535, 128, '2014-02-01 00:03:57.000000', 'consum', 0.0210, 'lps'),
	(513536, 128, '2014-02-01 00:03:58.000000', 'consum', 0.0214, 'lps'),
	(513537, 128, '2014-02-01 00:03:59.000000', 'consum', 0.0216, 'lps'),
	(513538, 128, '2014-02-01 00:04:00.000000', 'consum', 0.0215, 'lps'),
	(513539, 128, '2014-02-01 00:04:01.000000', 'consum', 0.0219, 'lps'),
	(513540, 128, '2014-02-01 00:04:02.000000', 'consum', 0.0223, 'lps'),
	(513541, 128, '2014-02-01 00:04:03.000000', 'consum', 0.0210, 'lps'),
	(513542, 128, '2014-02-01 00:04:04.000000', 'consum', 0.0212, 'lps'),
	(513543, 128, '2014-02-01 00:04:05.000000', 'consum', 0.0219, 'lps'),
	(513544, 128, '2014-02-01 00:04:06.000000', 'consum', 0.0210, 'lps'),
	(513545, 128, '2014-02-01 00:04:07.000000', 'consum', 0.0223, 'lps'),
	(513546, 128, '2014-02-01 00:04:08.000000', 'consum', 0.0219, 'lps'),
	(513547, 128, '2014-02-01 00:04:09.000000', 'consum', 0.0217, 'lps'),
	(513548, 128, '2014-02-01 00:04:10.000000', 'consum', 0.0218, 'lps'),
	(513549, 128, '2014-02-01 00:04:11.000000', 'consum', 0.0216, 'lps'),
	(513550, 128, '2014-02-01 00:04:12.000000', 'consum', 0.0218, 'lps'),
	(513551, 128, '2014-02-01 00:04:13.000000', 'consum', 0.0219, 'lps'),
	(513552, 128, '2014-02-01 00:04:14.000000', 'consum', 0.0215, 'lps'),
	(513553, 128, '2014-02-01 00:04:15.000000', 'consum', 0.0210, 'lps'),
	(513554, 128, '2014-02-01 00:04:16.000000', 'consum', 0.0211, 'lps'),
	(513555, 128, '2014-02-01 00:04:17.000000', 'consum', 0.0215, 'lps'),
	(513556, 128, '2014-02-01 00:04:18.000000', 'consum', 0.0218, 'lps'),
	(513557, 128, '2014-02-01 00:04:19.000000', 'consum', 0.0222, 'lps'),
	(513558, 128, '2014-02-01 00:04:20.000000', 'consum', 0.0218, 'lps'),
	(513559, 128, '2014-02-01 00:04:21.000000', 'consum', 0.0213, 'lps'),
	(513560, 128, '2014-02-01 00:04:22.000000', 'consum', 0.0218, 'lps'),
	(513561, 128, '2014-02-01 00:04:23.000000', 'consum', 0.0211, 'lps'),
	(513562, 128, '2014-02-01 00:04:24.000000', 'consum', 0.0221, 'lps'),
	(513563, 128, '2014-02-01 00:04:25.000000', 'consum', 0.0221, 'lps'),
	(513564, 128, '2014-02-01 00:04:26.000000', 'consum', 0.0218, 'lps'),
	(513565, 128, '2014-02-01 00:04:27.000000', 'consum', 0.0218, 'lps'),
	(513566, 128, '2014-02-01 00:04:28.000000', 'consum', 0.0210, 'lps'),
	(513567, 128, '2014-02-01 00:04:29.000000', 'consum', 0.0218, 'lps'),
	(513568, 128, '2014-02-01 00:04:30.000000', 'consum', 0.0220, 'lps'),
	(513569, 128, '2014-02-01 00:04:31.000000', 'consum', 0.0211, 'lps'),
	(513570, 128, '2014-02-01 00:04:32.000000', 'consum', 0.0214, 'lps'),
	(513571, 128, '2014-02-01 00:04:33.000000', 'consum', 0.0210, 'lps'),
	(513572, 128, '2014-02-01 00:04:34.000000', 'consum', 0.0215, 'lps'),
	(513573, 128, '2014-02-01 00:04:35.000000', 'consum', 0.0221, 'lps'),
	(513574, 128, '2014-02-01 00:04:36.000000', 'consum', 0.0223, 'lps'),
	(513575, 128, '2014-02-01 00:04:37.000000', 'consum', 0.0215, 'lps'),
	(513576, 128, '2014-02-01 00:04:38.000000', 'consum', 0.0210, 'lps'),
	(513577, 128, '2014-02-01 00:04:39.000000', 'consum', 0.0211, 'lps'),
	(513578, 128, '2014-02-01 00:04:40.000000', 'consum', 0.0216, 'lps'),
	(513579, 128, '2014-02-01 00:04:41.000000', 'consum', 0.0210, 'lps'),
	(513580, 128, '2014-02-01 00:04:42.000000', 'consum', 0.0218, 'lps'),
	(513581, 128, '2014-02-01 00:04:43.000000', 'consum', 0.0210, 'lps'),
	(513582, 128, '2014-02-01 00:04:44.000000', 'consum', 0.0216, 'lps'),
	(513583, 128, '2014-02-01 00:04:45.000000', 'consum', 0.0210, 'lps'),
	(513584, 128, '2014-02-01 00:04:46.000000', 'consum', 0.0220, 'lps'),
	(513585, 128, '2014-02-01 00:04:47.000000', 'consum', 0.0220, 'lps'),
	(513586, 128, '2014-02-01 00:04:48.000000', 'consum', 0.0215, 'lps'),
	(513587, 128, '2014-02-01 00:04:49.000000', 'consum', 0.0219, 'lps'),
	(513588, 128, '2014-02-01 00:04:50.000000', 'consum', 0.0214, 'lps'),
	(513589, 128, '2014-02-01 00:04:51.000000', 'consum', 0.0216, 'lps'),
	(513590, 128, '2014-02-01 00:04:52.000000', 'consum', 0.0215, 'lps'),
	(513591, 128, '2014-02-01 00:04:53.000000', 'consum', 0.0217, 'lps'),
	(513592, 128, '2014-02-01 00:04:54.000000', 'consum', 0.0219, 'lps'),
	(513593, 128, '2014-02-01 00:04:55.000000', 'consum', 0.0219, 'lps'),
	(513594, 128, '2014-02-01 00:04:56.000000', 'consum', 0.0214, 'lps'),
	(513595, 128, '2014-02-01 00:04:57.000000', 'consum', 0.0219, 'lps'),
	(513596, 128, '2014-02-01 00:04:58.000000', 'consum', 0.0217, 'lps'),
	(513597, 128, '2014-02-01 00:04:59.000000', 'consum', 0.0215, 'lps'),
	(513598, 128, '2014-02-01 00:05:00.000000', 'consum', 0.0216, 'lps'),
	(513599, 128, '2014-02-01 00:05:01.000000', 'consum', 0.0212, 'lps'),
	(513600, 128, '2014-02-01 00:05:02.000000', 'consum', 0.0215, 'lps'),
	(513601, 128, '2014-02-01 00:05:03.000000', 'consum', 0.0217, 'lps'),
	(513602, 128, '2014-02-01 00:05:04.000000', 'consum', 0.0218, 'lps'),
	(513603, 128, '2014-02-01 00:05:05.000000', 'consum', 0.0214, 'lps'),
	(513604, 128, '2014-02-01 00:05:06.000000', 'consum', 0.0220, 'lps'),
	(513605, 128, '2014-02-01 00:05:07.000000', 'consum', 0.0222, 'lps'),
	(513606, 128, '2014-02-01 00:05:08.000000', 'consum', 0.0212, 'lps'),
	(513607, 128, '2014-02-01 00:05:09.000000', 'consum', 0.0211, 'lps'),
	(513608, 128, '2014-02-01 00:05:10.000000', 'consum', 0.0210, 'lps'),
	(513609, 128, '2014-02-01 00:05:11.000000', 'consum', 0.0223, 'lps'),
	(513610, 128, '2014-02-01 00:05:12.000000', 'consum', 0.0219, 'lps'),
	(513611, 128, '2014-02-01 00:05:13.000000', 'consum', 0.0216, 'lps'),
	(513612, 128, '2014-02-01 00:05:14.000000', 'consum', 0.0214, 'lps'),
	(513613, 128, '2014-02-01 00:05:15.000000', 'consum', 0.0211, 'lps'),
	(513614, 128, '2014-02-01 00:05:16.000000', 'consum', 0.0218, 'lps'),
	(513615, 128, '2014-02-01 00:05:17.000000', 'consum', 0.0219, 'lps'),
	(513616, 128, '2014-02-01 00:05:18.000000', 'consum', 0.0217, 'lps'),
	(513617, 128, '2014-02-01 00:05:19.000000', 'consum', 0.0217, 'lps'),
	(513618, 128, '2014-02-01 00:05:20.000000', 'consum', 0.0213, 'lps'),
	(513619, 128, '2014-02-01 00:05:21.000000', 'consum', 0.0218, 'lps'),
	(513620, 128, '2014-02-01 00:05:22.000000', 'consum', 0.0213, 'lps'),
	(513621, 128, '2014-02-01 00:05:23.000000', 'consum', 0.0215, 'lps'),
	(513622, 128, '2014-02-01 00:05:24.000000', 'consum', 0.0215, 'lps'),
	(513623, 128, '2014-02-01 00:05:25.000000', 'consum', 0.0218, 'lps'),
	(513624, 128, '2014-02-01 00:05:26.000000', 'consum', 0.0220, 'lps'),
	(513625, 128, '2014-02-01 00:05:27.000000', 'consum', 0.0211, 'lps'),
	(513626, 128, '2014-02-01 00:05:28.000000', 'consum', 0.0213, 'lps'),
	(513627, 128, '2014-02-01 00:05:29.000000', 'consum', 0.0210, 'lps'),
	(513628, 128, '2014-02-01 00:05:30.000000', 'consum', 0.0216, 'lps'),
	(513629, 128, '2014-02-01 00:05:31.000000', 'consum', 0.0211, 'lps'),
	(513630, 128, '2014-02-01 00:05:32.000000', 'consum', 0.0211, 'lps'),
	(513631, 128, '2014-02-01 00:05:33.000000', 'consum', 0.0213, 'lps'),
	(513632, 128, '2014-02-01 00:05:34.000000', 'consum', 0.0223, 'lps'),
	(513633, 128, '2014-02-01 00:05:35.000000', 'consum', 0.0222, 'lps'),
	(513634, 128, '2014-02-01 00:05:36.000000', 'consum', 0.0219, 'lps'),
	(513635, 128, '2014-02-01 00:05:37.000000', 'consum', 0.0220, 'lps'),
	(513636, 128, '2014-02-01 00:05:38.000000', 'consum', 0.0221, 'lps'),
	(513637, 128, '2014-02-01 00:05:39.000000', 'consum', 0.0221, 'lps'),
	(513638, 128, '2014-02-01 00:05:40.000000', 'consum', 0.0219, 'lps'),
	(513639, 128, '2014-02-01 00:05:41.000000', 'consum', 0.0220, 'lps'),
	(513640, 128, '2014-02-01 00:05:42.000000', 'consum', 0.0219, 'lps'),
	(513641, 128, '2014-02-01 00:05:43.000000', 'consum', 0.0215, 'lps'),
	(513642, 128, '2014-02-01 00:05:44.000000', 'consum', 0.0219, 'lps'),
	(513643, 128, '2014-02-01 00:05:45.000000', 'consum', 0.0214, 'lps'),
	(513644, 128, '2014-02-01 00:05:46.000000', 'consum', 0.0217, 'lps'),
	(513645, 128, '2014-02-01 00:05:47.000000', 'consum', 0.0218, 'lps'),
	(513646, 128, '2014-02-01 00:05:48.000000', 'consum', 0.0215, 'lps'),
	(513647, 128, '2014-02-01 00:05:49.000000', 'consum', 0.0215, 'lps'),
	(513648, 128, '2014-02-01 00:05:50.000000', 'consum', 0.0217, 'lps'),
	(513649, 128, '2014-02-01 00:05:51.000000', 'consum', 0.0219, 'lps'),
	(513650, 128, '2014-02-01 00:05:52.000000', 'consum', 0.0219, 'lps'),
	(513651, 128, '2014-02-01 00:05:53.000000', 'consum', 0.0216, 'lps'),
	(513652, 128, '2014-02-01 00:05:54.000000', 'consum', 0.0211, 'lps'),
	(513653, 128, '2014-02-01 00:05:55.000000', 'consum', 0.0214, 'lps'),
	(513654, 128, '2014-02-01 00:05:56.000000', 'consum', 0.0213, 'lps'),
	(513655, 128, '2014-02-01 00:05:57.000000', 'consum', 0.0212, 'lps'),
	(513656, 128, '2014-02-01 00:05:58.000000', 'consum', 0.0211, 'lps'),
	(513657, 128, '2014-02-01 00:05:59.000000', 'consum', 0.0210, 'lps'),
	(513658, 128, '2014-02-01 00:06:00.000000', 'consum', 0.0220, 'lps'),
	(513659, 128, '2014-02-01 00:06:01.000000', 'consum', 0.0222, 'lps'),
	(513660, 128, '2014-02-01 00:06:02.000000', 'consum', 0.0210, 'lps'),
	(513661, 128, '2014-02-01 00:06:03.000000', 'consum', 0.0215, 'lps'),
	(513662, 128, '2014-02-01 00:06:04.000000', 'consum', 0.0210, 'lps'),
	(513663, 128, '2014-02-01 00:06:05.000000', 'consum', 0.0223, 'lps'),
	(513664, 128, '2014-02-01 00:06:06.000000', 'consum', 0.0220, 'lps'),
	(513665, 128, '2014-02-01 00:06:07.000000', 'consum', 0.0221, 'lps'),
	(513666, 128, '2014-02-01 00:06:08.000000', 'consum', 0.0223, 'lps'),
	(513667, 128, '2014-02-01 00:06:09.000000', 'consum', 0.0215, 'lps'),
	(513668, 128, '2014-02-01 00:06:10.000000', 'consum', 0.0212, 'lps'),
	(513669, 128, '2014-02-01 00:06:11.000000', 'consum', 0.0216, 'lps'),
	(513670, 128, '2014-02-01 00:06:12.000000', 'consum', 0.0221, 'lps'),
	(513671, 128, '2014-02-01 00:06:13.000000', 'consum', 0.0218, 'lps'),
	(513672, 128, '2014-02-01 00:06:14.000000', 'consum', 0.0219, 'lps'),
	(513673, 128, '2014-02-01 00:06:15.000000', 'consum', 0.0216, 'lps'),
	(513674, 128, '2014-02-01 00:06:16.000000', 'consum', 0.0215, 'lps'),
	(513675, 128, '2014-02-01 00:06:17.000000', 'consum', 0.0219, 'lps'),
	(513676, 128, '2014-02-01 00:06:18.000000', 'consum', 0.0211, 'lps'),
	(513677, 128, '2014-02-01 00:06:19.000000', 'consum', 0.0216, 'lps'),
	(513678, 128, '2014-02-01 00:06:20.000000', 'consum', 0.0223, 'lps'),
	(513679, 128, '2014-02-01 00:06:21.000000', 'consum', 0.0216, 'lps'),
	(513680, 128, '2014-02-01 00:06:22.000000', 'consum', 0.0215, 'lps'),
	(513681, 128, '2014-02-01 00:06:23.000000', 'consum', 0.0217, 'lps'),
	(513682, 128, '2014-02-01 00:06:24.000000', 'consum', 0.0216, 'lps'),
	(513683, 128, '2014-02-01 00:06:25.000000', 'consum', 0.0222, 'lps'),
	(513684, 128, '2014-02-01 00:06:26.000000', 'consum', 0.0210, 'lps'),
	(513685, 128, '2014-02-01 00:06:27.000000', 'consum', 0.0215, 'lps'),
	(513686, 128, '2014-02-01 00:06:28.000000', 'consum', 0.0220, 'lps'),
	(513687, 128, '2014-02-01 00:06:29.000000', 'consum', 0.0221, 'lps'),
	(513688, 128, '2014-02-01 00:06:30.000000', 'consum', 0.0218, 'lps'),
	(513689, 128, '2014-02-01 00:06:31.000000', 'consum', 0.0219, 'lps'),
	(513690, 128, '2014-02-01 00:06:32.000000', 'consum', 0.0219, 'lps'),
	(513691, 128, '2014-02-01 00:06:33.000000', 'consum', 0.0215, 'lps'),
	(513692, 128, '2014-02-01 00:06:34.000000', 'consum', 0.0221, 'lps'),
	(513693, 128, '2014-02-01 00:06:35.000000', 'consum', 0.0211, 'lps'),
	(513694, 128, '2014-02-01 00:06:36.000000', 'consum', 0.0221, 'lps'),
	(513695, 128, '2014-02-01 00:06:37.000000', 'consum', 0.0222, 'lps'),
	(513696, 128, '2014-02-01 00:06:38.000000', 'consum', 0.0223, 'lps'),
	(513697, 128, '2014-02-01 00:06:39.000000', 'consum', 0.0210, 'lps'),
	(513698, 128, '2014-02-01 00:06:40.000000', 'consum', 0.0216, 'lps'),
	(513699, 128, '2014-02-01 00:06:41.000000', 'consum', 0.0212, 'lps'),
	(513700, 128, '2014-02-01 00:06:42.000000', 'consum', 0.0216, 'lps'),
	(513701, 128, '2014-02-01 00:06:43.000000', 'consum', 0.0222, 'lps'),
	(513702, 128, '2014-02-01 00:06:44.000000', 'consum', 0.0223, 'lps'),
	(513703, 128, '2014-02-01 00:06:45.000000', 'consum', 0.0211, 'lps'),
	(513704, 128, '2014-02-01 00:06:46.000000', 'consum', 0.0219, 'lps'),
	(513705, 128, '2014-02-01 00:06:47.000000', 'consum', 0.0223, 'lps'),
	(513706, 128, '2014-02-01 00:06:48.000000', 'consum', 0.0221, 'lps'),
	(513707, 128, '2014-02-01 00:06:49.000000', 'consum', 0.0214, 'lps'),
	(513708, 128, '2014-02-01 00:06:50.000000', 'consum', 0.0210, 'lps'),
	(513709, 128, '2014-02-01 00:06:51.000000', 'consum', 0.0214, 'lps'),
	(513710, 128, '2014-02-01 00:06:52.000000', 'consum', 0.0216, 'lps'),
	(513711, 128, '2014-02-01 00:06:53.000000', 'consum', 0.0212, 'lps'),
	(513712, 128, '2014-02-01 00:06:54.000000', 'consum', 0.0220, 'lps'),
	(513713, 128, '2014-02-01 00:06:55.000000', 'consum', 0.0210, 'lps'),
	(513714, 128, '2014-02-01 00:06:56.000000', 'consum', 0.0223, 'lps'),
	(513715, 128, '2014-02-01 00:06:57.000000', 'consum', 0.0220, 'lps'),
	(513716, 128, '2014-02-01 00:06:58.000000', 'consum', 0.0223, 'lps'),
	(513717, 128, '2014-02-01 00:06:59.000000', 'consum', 0.0214, 'lps'),
	(513718, 128, '2014-02-01 00:07:00.000000', 'consum', 0.0223, 'lps'),
	(513719, 128, '2014-02-01 00:07:01.000000', 'consum', 0.0221, 'lps'),
	(513720, 128, '2014-02-01 00:07:02.000000', 'consum', 0.0212, 'lps'),
	(513721, 128, '2014-02-01 00:07:03.000000', 'consum', 0.0215, 'lps'),
	(513722, 128, '2014-02-01 00:07:04.000000', 'consum', 0.0214, 'lps'),
	(513723, 128, '2014-02-01 00:07:05.000000', 'consum', 0.0218, 'lps'),
	(513724, 128, '2014-02-01 00:07:06.000000', 'consum', 0.0211, 'lps'),
	(513725, 128, '2014-02-01 00:07:07.000000', 'consum', 0.0220, 'lps'),
	(513726, 128, '2014-02-01 00:07:08.000000', 'consum', 0.0214, 'lps'),
	(513727, 128, '2014-02-01 00:07:09.000000', 'consum', 0.0214, 'lps'),
	(513728, 128, '2014-02-01 00:07:10.000000', 'consum', 0.0220, 'lps'),
	(513729, 128, '2014-02-01 00:07:11.000000', 'consum', 0.0222, 'lps'),
	(513730, 128, '2014-02-01 00:07:12.000000', 'consum', 0.0211, 'lps'),
	(513731, 128, '2014-02-01 00:07:13.000000', 'consum', 0.0220, 'lps'),
	(513732, 128, '2014-02-01 00:07:14.000000', 'consum', 0.0216, 'lps'),
	(513733, 128, '2014-02-01 00:07:15.000000', 'consum', 0.0212, 'lps'),
	(513734, 128, '2014-02-01 00:07:16.000000', 'consum', 0.0216, 'lps'),
	(513735, 128, '2014-02-01 00:07:17.000000', 'consum', 0.0221, 'lps'),
	(513736, 128, '2014-02-01 00:07:18.000000', 'consum', 0.0218, 'lps'),
	(513737, 128, '2014-02-01 00:07:19.000000', 'consum', 0.0219, 'lps'),
	(513738, 128, '2014-02-01 00:07:20.000000', 'consum', 0.0219, 'lps'),
	(513739, 128, '2014-02-01 00:07:21.000000', 'consum', 0.0213, 'lps'),
	(513740, 128, '2014-02-01 00:07:22.000000', 'consum', 0.0214, 'lps'),
	(513741, 128, '2014-02-01 00:07:23.000000', 'consum', 0.0222, 'lps'),
	(513742, 128, '2014-02-01 00:07:24.000000', 'consum', 0.0217, 'lps'),
	(513743, 128, '2014-02-01 00:07:25.000000', 'consum', 0.0223, 'lps'),
	(513744, 128, '2014-02-01 00:07:26.000000', 'consum', 0.0214, 'lps'),
	(513745, 128, '2014-02-01 00:07:27.000000', 'consum', 0.0216, 'lps'),
	(513746, 128, '2014-02-01 00:07:28.000000', 'consum', 0.0217, 'lps'),
	(513747, 128, '2014-02-01 00:07:29.000000', 'consum', 0.0212, 'lps'),
	(513748, 128, '2014-02-01 00:07:30.000000', 'consum', 0.0214, 'lps'),
	(513749, 128, '2014-02-01 00:07:31.000000', 'consum', 0.0211, 'lps'),
	(513750, 128, '2014-02-01 00:07:32.000000', 'consum', 0.0218, 'lps'),
	(513751, 128, '2014-02-01 00:07:33.000000', 'consum', 0.0220, 'lps'),
	(513752, 128, '2014-02-01 00:07:34.000000', 'consum', 0.0210, 'lps'),
	(513753, 128, '2014-02-01 00:07:35.000000', 'consum', 0.0220, 'lps'),
	(513754, 128, '2014-02-01 00:07:36.000000', 'consum', 0.0218, 'lps'),
	(513755, 128, '2014-02-01 00:07:37.000000', 'consum', 0.0223, 'lps'),
	(513756, 128, '2014-02-01 00:07:38.000000', 'consum', 0.0223, 'lps'),
	(513757, 128, '2014-02-01 00:07:39.000000', 'consum', 0.0222, 'lps'),
	(513758, 128, '2014-02-01 00:07:40.000000', 'consum', 0.0216, 'lps'),
	(513759, 128, '2014-02-01 00:07:41.000000', 'consum', 0.0221, 'lps'),
	(513760, 128, '2014-02-01 00:07:42.000000', 'consum', 0.0217, 'lps'),
	(513761, 128, '2014-02-01 00:07:43.000000', 'consum', 0.0213, 'lps'),
	(513762, 128, '2014-02-01 00:07:44.000000', 'consum', 0.0219, 'lps'),
	(513763, 128, '2014-02-01 00:07:45.000000', 'consum', 0.0220, 'lps'),
	(513764, 128, '2014-02-01 00:07:46.000000', 'consum', 0.0219, 'lps'),
	(513765, 128, '2014-02-01 00:07:47.000000', 'consum', 0.0211, 'lps'),
	(513766, 128, '2014-02-01 00:07:48.000000', 'consum', 0.0219, 'lps'),
	(513767, 128, '2014-02-01 00:07:49.000000', 'consum', 0.0221, 'lps'),
	(513768, 128, '2014-02-01 00:07:50.000000', 'consum', 0.0211, 'lps'),
	(513769, 128, '2014-02-01 00:07:51.000000', 'consum', 0.0223, 'lps'),
	(513770, 128, '2014-02-01 00:07:52.000000', 'consum', 0.0219, 'lps'),
	(513771, 128, '2014-02-01 00:07:53.000000', 'consum', 0.0217, 'lps'),
	(513772, 128, '2014-02-01 00:07:54.000000', 'consum', 0.0219, 'lps'),
	(513773, 128, '2014-02-01 00:07:55.000000', 'consum', 0.0219, 'lps'),
	(513774, 128, '2014-02-01 00:07:56.000000', 'consum', 0.0215, 'lps'),
	(513775, 128, '2014-02-01 00:07:57.000000', 'consum', 0.0221, 'lps'),
	(513776, 128, '2014-02-01 00:07:58.000000', 'consum', 0.0223, 'lps'),
	(513777, 128, '2014-02-01 00:07:59.000000', 'consum', 0.0215, 'lps'),
	(513778, 128, '2014-02-01 00:08:00.000000', 'consum', 0.0210, 'lps'),
	(513779, 128, '2014-02-01 00:08:01.000000', 'consum', 0.0211, 'lps'),
	(513780, 128, '2014-02-01 00:08:02.000000', 'consum', 0.0215, 'lps'),
	(513781, 128, '2014-02-01 00:08:03.000000', 'consum', 0.0216, 'lps'),
	(513782, 128, '2014-02-01 00:08:04.000000', 'consum', 0.0214, 'lps'),
	(513783, 128, '2014-02-01 00:08:05.000000', 'consum', 0.0211, 'lps'),
	(513784, 128, '2014-02-01 00:08:06.000000', 'consum', 0.0219, 'lps'),
	(513785, 128, '2014-02-01 00:08:07.000000', 'consum', 0.0211, 'lps'),
	(513786, 128, '2014-02-01 00:08:08.000000', 'consum', 0.0215, 'lps'),
	(513787, 128, '2014-02-01 00:08:09.000000', 'consum', 0.0219, 'lps'),
	(513788, 128, '2014-02-01 00:08:10.000000', 'consum', 0.0214, 'lps'),
	(513789, 128, '2014-02-01 00:08:11.000000', 'consum', 0.0216, 'lps'),
	(513790, 128, '2014-02-01 00:08:12.000000', 'consum', 0.0213, 'lps'),
	(513791, 128, '2014-02-01 00:08:13.000000', 'consum', 0.0223, 'lps'),
	(513792, 128, '2014-02-01 00:08:14.000000', 'consum', 0.0223, 'lps'),
	(513793, 128, '2014-02-01 00:08:15.000000', 'consum', 0.0211, 'lps'),
	(513794, 128, '2014-02-01 00:08:16.000000', 'consum', 0.0217, 'lps'),
	(513795, 128, '2014-02-01 00:08:17.000000', 'consum', 0.0214, 'lps'),
	(513796, 128, '2014-02-01 00:08:18.000000', 'consum', 0.0223, 'lps'),
	(513797, 128, '2014-02-01 00:08:19.000000', 'consum', 0.0223, 'lps'),
	(513798, 128, '2014-02-01 00:08:20.000000', 'consum', 0.0222, 'lps'),
	(513799, 128, '2014-02-01 00:08:21.000000', 'consum', 0.0219, 'lps'),
	(513800, 128, '2014-02-01 00:08:22.000000', 'consum', 0.0220, 'lps'),
	(513801, 128, '2014-02-01 00:08:23.000000', 'consum', 0.0219, 'lps'),
	(513802, 128, '2014-02-01 00:08:24.000000', 'consum', 0.0211, 'lps'),
	(513803, 128, '2014-02-01 00:08:25.000000', 'consum', 0.0218, 'lps'),
	(513804, 128, '2014-02-01 00:08:26.000000', 'consum', 0.0218, 'lps'),
	(513805, 128, '2014-02-01 00:08:27.000000', 'consum', 0.0211, 'lps'),
	(513806, 128, '2014-02-01 00:08:28.000000', 'consum', 0.0220, 'lps'),
	(513807, 128, '2014-02-01 00:08:29.000000', 'consum', 0.0218, 'lps'),
	(513808, 128, '2014-02-01 00:08:30.000000', 'consum', 0.0217, 'lps'),
	(513809, 128, '2014-02-01 00:08:31.000000', 'consum', 0.0211, 'lps'),
	(513810, 128, '2014-02-01 00:08:32.000000', 'consum', 0.0220, 'lps'),
	(513811, 128, '2014-02-01 00:08:33.000000', 'consum', 0.0216, 'lps'),
	(513812, 128, '2014-02-01 00:08:34.000000', 'consum', 0.0210, 'lps'),
	(513813, 128, '2014-02-01 00:08:35.000000', 'consum', 0.0222, 'lps'),
	(513814, 128, '2014-02-01 00:08:36.000000', 'consum', 0.0212, 'lps'),
	(513815, 128, '2014-02-01 00:08:37.000000', 'consum', 0.0214, 'lps'),
	(513816, 128, '2014-02-01 00:08:38.000000', 'consum', 0.0211, 'lps'),
	(513817, 128, '2014-02-01 00:08:39.000000', 'consum', 0.0216, 'lps'),
	(513818, 128, '2014-02-01 00:08:40.000000', 'consum', 0.0210, 'lps'),
	(513819, 128, '2014-02-01 00:08:41.000000', 'consum', 0.0222, 'lps'),
	(513820, 128, '2014-02-01 00:08:42.000000', 'consum', 0.0212, 'lps'),
	(513821, 128, '2014-02-01 00:08:43.000000', 'consum', 0.0214, 'lps'),
	(513822, 128, '2014-02-01 00:08:44.000000', 'consum', 0.0212, 'lps'),
	(513823, 128, '2014-02-01 00:08:45.000000', 'consum', 0.0220, 'lps'),
	(513824, 128, '2014-02-01 00:08:46.000000', 'consum', 0.0212, 'lps'),
	(513825, 128, '2014-02-01 00:08:47.000000', 'consum', 0.0221, 'lps'),
	(513826, 128, '2014-02-01 00:08:48.000000', 'consum', 0.0216, 'lps'),
	(513827, 128, '2014-02-01 00:08:49.000000', 'consum', 0.0220, 'lps'),
	(513828, 128, '2014-02-01 00:08:50.000000', 'consum', 0.0216, 'lps'),
	(513829, 128, '2014-02-01 00:08:51.000000', 'consum', 0.0223, 'lps'),
	(513830, 128, '2014-02-01 00:08:52.000000', 'consum', 0.0215, 'lps'),
	(513831, 128, '2014-02-01 00:08:53.000000', 'consum', 0.0213, 'lps'),
	(513832, 128, '2014-02-01 00:08:54.000000', 'consum', 0.0222, 'lps'),
	(513833, 128, '2014-02-01 00:08:55.000000', 'consum', 0.0222, 'lps'),
	(513834, 128, '2014-02-01 00:08:56.000000', 'consum', 0.0220, 'lps'),
	(513835, 128, '2014-02-01 00:08:57.000000', 'consum', 0.0210, 'lps'),
	(513836, 128, '2014-02-01 00:08:58.000000', 'consum', 0.0222, 'lps'),
	(513837, 128, '2014-02-01 00:08:59.000000', 'consum', 0.0215, 'lps'),
	(513838, 128, '2014-02-01 00:09:00.000000', 'consum', 0.0215, 'lps'),
	(513839, 128, '2014-02-01 00:09:01.000000', 'consum', 0.0218, 'lps'),
	(513840, 128, '2014-02-01 00:09:02.000000', 'consum', 0.0222, 'lps'),
	(513841, 128, '2014-02-01 00:09:03.000000', 'consum', 0.0219, 'lps'),
	(513842, 128, '2014-02-01 00:09:04.000000', 'consum', 0.0219, 'lps'),
	(513843, 128, '2014-02-01 00:09:05.000000', 'consum', 0.0213, 'lps'),
	(513844, 128, '2014-02-01 00:09:06.000000', 'consum', 0.0216, 'lps'),
	(513845, 128, '2014-02-01 00:09:07.000000', 'consum', 0.0215, 'lps'),
	(513846, 128, '2014-02-01 00:09:08.000000', 'consum', 0.0217, 'lps'),
	(513847, 128, '2014-02-01 00:09:09.000000', 'consum', 0.0219, 'lps'),
	(513848, 128, '2014-02-01 00:09:10.000000', 'consum', 0.0219, 'lps'),
	(513849, 128, '2014-02-01 00:09:11.000000', 'consum', 0.0215, 'lps'),
	(513850, 128, '2014-02-01 00:09:12.000000', 'consum', 0.0222, 'lps'),
	(513851, 128, '2014-02-01 00:09:13.000000', 'consum', 0.0212, 'lps'),
	(513852, 128, '2014-02-01 00:09:14.000000', 'consum', 0.0215, 'lps'),
	(513853, 128, '2014-02-01 00:09:15.000000', 'consum', 0.0216, 'lps'),
	(513854, 128, '2014-02-01 00:09:16.000000', 'consum', 0.0210, 'lps'),
	(513855, 128, '2014-02-01 00:09:17.000000', 'consum', 0.0221, 'lps'),
	(513856, 128, '2014-02-01 00:09:18.000000', 'consum', 0.0223, 'lps'),
	(513857, 128, '2014-02-01 00:09:19.000000', 'consum', 0.0214, 'lps'),
	(513858, 128, '2014-02-01 00:09:20.000000', 'consum', 0.0220, 'lps'),
	(513859, 128, '2014-02-01 00:09:21.000000', 'consum', 0.0220, 'lps'),
	(513860, 128, '2014-02-01 00:09:22.000000', 'consum', 0.0217, 'lps'),
	(513861, 128, '2014-02-01 00:09:23.000000', 'consum', 0.0217, 'lps'),
	(513862, 128, '2014-02-01 00:09:24.000000', 'consum', 0.0221, 'lps'),
	(513863, 128, '2014-02-01 00:09:25.000000', 'consum', 0.0220, 'lps'),
	(513864, 128, '2014-02-01 00:09:26.000000', 'consum', 0.0213, 'lps'),
	(513865, 128, '2014-02-01 00:09:27.000000', 'consum', 0.0223, 'lps'),
	(513866, 128, '2014-02-01 00:09:28.000000', 'consum', 0.0212, 'lps'),
	(513867, 128, '2014-02-01 00:09:29.000000', 'consum', 0.0222, 'lps'),
	(513868, 128, '2014-02-01 00:09:30.000000', 'consum', 0.0210, 'lps'),
	(513869, 128, '2014-02-01 00:09:31.000000', 'consum', 0.0217, 'lps'),
	(513870, 128, '2014-02-01 00:09:32.000000', 'consum', 0.0218, 'lps'),
	(513871, 128, '2014-02-01 00:09:33.000000', 'consum', 0.0216, 'lps'),
	(513872, 128, '2014-02-01 00:09:34.000000', 'consum', 0.0214, 'lps'),
	(513873, 128, '2014-02-01 00:09:35.000000', 'consum', 0.0215, 'lps'),
	(513874, 128, '2014-02-01 00:09:36.000000', 'consum', 0.0221, 'lps'),
	(513875, 128, '2014-02-01 00:09:37.000000', 'consum', 0.0210, 'lps'),
	(513876, 128, '2014-02-01 00:09:38.000000', 'consum', 0.0221, 'lps'),
	(513877, 128, '2014-02-01 00:09:39.000000', 'consum', 0.0222, 'lps'),
	(513878, 128, '2014-02-01 00:09:40.000000', 'consum', 0.0222, 'lps'),
	(513879, 128, '2014-02-01 00:09:41.000000', 'consum', 0.0222, 'lps'),
	(513880, 128, '2014-02-01 00:09:42.000000', 'consum', 0.0222, 'lps'),
	(513881, 128, '2014-02-01 00:09:43.000000', 'consum', 0.0220, 'lps'),
	(513882, 128, '2014-02-01 00:09:44.000000', 'consum', 0.0222, 'lps'),
	(513883, 128, '2014-02-01 00:09:45.000000', 'consum', 0.0214, 'lps'),
	(513884, 128, '2014-02-01 00:09:46.000000', 'consum', 0.0210, 'lps'),
	(513885, 128, '2014-02-01 00:09:47.000000', 'consum', 0.0212, 'lps'),
	(513886, 128, '2014-02-01 00:09:48.000000', 'consum', 0.0220, 'lps'),
	(513887, 128, '2014-02-01 00:09:49.000000', 'consum', 0.0212, 'lps'),
	(513888, 128, '2014-02-01 00:09:50.000000', 'consum', 0.0221, 'lps'),
	(513889, 128, '2014-02-01 00:09:51.000000', 'consum', 0.0216, 'lps'),
	(513890, 128, '2014-02-01 00:09:52.000000', 'consum', 0.0221, 'lps'),
	(513891, 128, '2014-02-01 00:09:53.000000', 'consum', 0.0218, 'lps'),
	(513892, 128, '2014-02-01 00:09:54.000000', 'consum', 0.0220, 'lps'),
	(513893, 128, '2014-02-01 00:09:55.000000', 'consum', 0.0221, 'lps'),
	(513894, 128, '2014-02-01 00:09:56.000000', 'consum', 0.0210, 'lps'),
	(513895, 128, '2014-02-01 00:09:57.000000', 'consum', 0.0218, 'lps'),
	(513896, 128, '2014-02-01 00:09:58.000000', 'consum', 0.0210, 'lps'),
	(513897, 128, '2014-02-01 00:09:59.000000', 'consum', 0.0216, 'lps'),
	(513898, 128, '2014-02-01 00:10:00.000000', 'consum', 0.0223, 'lps'),
	(513899, 128, '2014-02-01 00:10:01.000000', 'consum', 0.0216, 'lps'),
	(513900, 128, '2014-02-01 00:10:02.000000', 'consum', 0.0215, 'lps'),
	(513901, 128, '2014-02-01 00:10:03.000000', 'consum', 0.0220, 'lps'),
	(513902, 128, '2014-02-01 00:10:04.000000', 'consum', 0.0216, 'lps'),
	(513903, 128, '2014-02-01 00:10:05.000000', 'consum', 0.0212, 'lps'),
	(513904, 128, '2014-02-01 00:10:06.000000', 'consum', 0.0216, 'lps'),
	(513905, 128, '2014-02-01 00:10:07.000000', 'consum', 0.0221, 'lps'),
	(513906, 128, '2014-02-01 00:10:08.000000', 'consum', 0.0218, 'lps'),
	(513907, 128, '2014-02-01 00:10:09.000000', 'consum', 0.0218, 'lps'),
	(513908, 128, '2014-02-01 00:10:10.000000', 'consum', 0.0212, 'lps'),
	(513909, 128, '2014-02-01 00:10:11.000000', 'consum', 0.0211, 'lps'),
	(513910, 128, '2014-02-01 00:10:12.000000', 'consum', 0.0222, 'lps'),
	(513911, 128, '2014-02-01 00:10:13.000000', 'consum', 0.0210, 'lps'),
	(513912, 128, '2014-02-01 00:10:14.000000', 'consum', 0.0220, 'lps'),
	(513913, 128, '2014-02-01 00:10:15.000000', 'consum', 0.0218, 'lps'),
	(513914, 128, '2014-02-01 00:10:16.000000', 'consum', 0.0222, 'lps'),
	(513915, 128, '2014-02-01 00:10:17.000000', 'consum', 0.0217, 'lps'),
	(513916, 128, '2014-02-01 00:10:18.000000', 'consum', 0.0211, 'lps'),
	(513917, 128, '2014-02-01 00:10:19.000000', 'consum', 0.0223, 'lps'),
	(513918, 128, '2014-02-01 00:10:20.000000', 'consum', 0.0217, 'lps'),
	(513919, 128, '2014-02-01 00:10:21.000000', 'consum', 0.0220, 'lps'),
	(513920, 128, '2014-02-01 00:10:22.000000', 'consum', 0.0213, 'lps'),
	(513921, 128, '2014-02-01 00:10:23.000000', 'consum', 0.0222, 'lps'),
	(513922, 128, '2014-02-01 00:10:24.000000', 'consum', 0.0221, 'lps'),
	(513923, 128, '2014-02-01 00:10:25.000000', 'consum', 0.0215, 'lps'),
	(513924, 128, '2014-02-01 00:10:26.000000', 'consum', 0.0217, 'lps'),
	(513925, 128, '2014-02-01 00:10:27.000000', 'consum', 0.0218, 'lps'),
	(513926, 128, '2014-02-01 00:10:28.000000', 'consum', 0.0212, 'lps'),
	(513927, 128, '2014-02-01 00:10:29.000000', 'consum', 0.0213, 'lps'),
	(513928, 128, '2014-02-01 00:10:30.000000', 'consum', 0.0219, 'lps'),
	(513929, 128, '2014-02-01 00:10:31.000000', 'consum', 0.0220, 'lps'),
	(513930, 128, '2014-02-01 00:10:32.000000', 'consum', 0.0219, 'lps'),
	(513931, 128, '2014-02-01 00:10:33.000000', 'consum', 0.0211, 'lps'),
	(513932, 128, '2014-02-01 00:10:34.000000', 'consum', 0.0217, 'lps'),
	(513933, 128, '2014-02-01 00:10:35.000000', 'consum', 0.0213, 'lps'),
	(513934, 128, '2014-02-01 00:10:36.000000', 'consum', 0.0221, 'lps'),
	(513935, 128, '2014-02-01 00:10:37.000000', 'consum', 0.0211, 'lps'),
	(513936, 128, '2014-02-01 00:10:38.000000', 'consum', 0.0213, 'lps'),
	(513937, 128, '2014-02-01 00:10:39.000000', 'consum', 0.0223, 'lps'),
	(513938, 128, '2014-02-01 00:10:40.000000', 'consum', 0.0211, 'lps'),
	(513939, 128, '2014-02-01 00:10:41.000000', 'consum', 0.0219, 'lps'),
	(513940, 128, '2014-02-01 00:10:42.000000', 'consum', 0.0210, 'lps'),
	(513941, 128, '2014-02-01 00:10:43.000000', 'consum', 0.0213, 'lps'),
	(513942, 128, '2014-02-01 00:10:44.000000', 'consum', 0.0211, 'lps'),
	(513943, 128, '2014-02-01 00:10:45.000000', 'consum', 0.0222, 'lps'),
	(513944, 128, '2014-02-01 00:10:46.000000', 'consum', 0.0222, 'lps'),
	(513945, 128, '2014-02-01 00:10:47.000000', 'consum', 0.0223, 'lps'),
	(513946, 128, '2014-02-01 00:10:48.000000', 'consum', 0.0211, 'lps'),
	(513947, 128, '2014-02-01 00:10:49.000000', 'consum', 0.0219, 'lps'),
	(513948, 128, '2014-02-01 00:10:50.000000', 'consum', 0.0210, 'lps'),
	(513949, 128, '2014-02-01 00:10:51.000000', 'consum', 0.0211, 'lps'),
	(513950, 128, '2014-02-01 00:10:52.000000', 'consum', 0.0216, 'lps'),
	(513951, 128, '2014-02-01 00:10:53.000000', 'consum', 0.0211, 'lps'),
	(513952, 128, '2014-02-01 00:10:54.000000', 'consum', 0.0211, 'lps'),
	(513953, 128, '2014-02-01 00:10:55.000000', 'consum', 0.0213, 'lps'),
	(513954, 128, '2014-02-01 00:10:56.000000', 'consum', 0.0221, 'lps'),
	(513955, 128, '2014-02-01 00:10:57.000000', 'consum', 0.0216, 'lps'),
	(513956, 128, '2014-02-01 00:10:58.000000', 'consum', 0.0223, 'lps'),
	(513957, 128, '2014-02-01 00:10:59.000000', 'consum', 0.0214, 'lps'),
	(513958, 128, '2014-02-01 00:11:00.000000', 'consum', 0.0218, 'lps'),
	(513959, 128, '2014-02-01 00:11:01.000000', 'consum', 0.0210, 'lps'),
	(513960, 128, '2014-02-01 00:11:02.000000', 'consum', 0.0214, 'lps'),
	(513961, 128, '2014-02-01 00:11:03.000000', 'consum', 0.0218, 'lps'),
	(513962, 128, '2014-02-01 00:11:04.000000', 'consum', 0.0210, 'lps'),
	(513963, 128, '2014-02-01 00:11:05.000000', 'consum', 0.0214, 'lps'),
	(513964, 128, '2014-02-01 00:11:06.000000', 'consum', 0.0216, 'lps'),
	(513965, 128, '2014-02-01 00:11:07.000000', 'consum', 0.0217, 'lps'),
	(513966, 128, '2014-02-01 00:11:08.000000', 'consum', 0.0210, 'lps'),
	(513967, 128, '2014-02-01 00:11:09.000000', 'consum', 0.0221, 'lps'),
	(513968, 128, '2014-02-01 00:11:10.000000', 'consum', 0.0222, 'lps'),
	(513969, 128, '2014-02-01 00:11:11.000000', 'consum', 0.0223, 'lps'),
	(513970, 128, '2014-02-01 00:11:12.000000', 'consum', 0.0213, 'lps'),
	(513971, 128, '2014-02-01 00:11:13.000000', 'consum', 0.0213, 'lps'),
	(513972, 128, '2014-02-01 00:11:14.000000', 'consum', 0.0218, 'lps'),
	(513973, 128, '2014-02-01 00:11:15.000000', 'consum', 0.0213, 'lps'),
	(513974, 128, '2014-02-01 00:11:16.000000', 'consum', 0.0217, 'lps'),
	(513975, 128, '2014-02-01 00:11:17.000000', 'consum', 0.0223, 'lps'),
	(513976, 128, '2014-02-01 00:11:18.000000', 'consum', 0.0211, 'lps'),
	(513977, 128, '2014-02-01 00:11:19.000000', 'consum', 0.0220, 'lps'),
	(513978, 128, '2014-02-01 00:11:20.000000', 'consum', 0.0216, 'lps'),
	(513979, 128, '2014-02-01 00:11:21.000000', 'consum', 0.0223, 'lps'),
	(513980, 128, '2014-02-01 00:11:22.000000', 'consum', 0.0215, 'lps'),
	(513981, 128, '2014-02-01 00:11:23.000000', 'consum', 0.0213, 'lps'),
	(513982, 128, '2014-02-01 00:11:24.000000', 'consum', 0.0210, 'lps'),
	(513983, 128, '2014-02-01 00:11:25.000000', 'consum', 0.0214, 'lps'),
	(513984, 128, '2014-02-01 00:11:26.000000', 'consum', 0.0218, 'lps'),
	(513985, 128, '2014-02-01 00:11:27.000000', 'consum', 0.0222, 'lps'),
	(513986, 128, '2014-02-01 00:11:28.000000', 'consum', 0.0220, 'lps'),
	(513987, 128, '2014-02-01 00:11:29.000000', 'consum', 0.0211, 'lps'),
	(513988, 128, '2014-02-01 00:11:30.000000', 'consum', 0.0214, 'lps'),
	(513989, 128, '2014-02-01 00:11:31.000000', 'consum', 0.0214, 'lps'),
	(513990, 128, '2014-02-01 00:11:32.000000', 'consum', 0.0220, 'lps'),
	(513991, 128, '2014-02-01 00:11:33.000000', 'consum', 0.0217, 'lps'),
	(513992, 128, '2014-02-01 00:11:34.000000', 'consum', 0.0217, 'lps'),
	(513993, 128, '2014-02-01 00:11:35.000000', 'consum', 0.0223, 'lps'),
	(513994, 128, '2014-02-01 00:11:36.000000', 'consum', 0.0214, 'lps'),
	(513995, 128, '2014-02-01 00:11:37.000000', 'consum', 0.0221, 'lps'),
	(513996, 128, '2014-02-01 00:11:38.000000', 'consum', 0.0210, 'lps'),
	(513997, 128, '2014-02-01 00:11:39.000000', 'consum', 0.0219, 'lps'),
	(513998, 128, '2014-02-01 00:11:40.000000', 'consum', 0.0214, 'lps'),
	(513999, 128, '2014-02-01 00:11:41.000000', 'consum', 0.0218, 'lps'),
	(514000, 128, '2014-02-01 00:11:42.000000', 'consum', 0.0210, 'lps'),
	(514001, 128, '2014-02-01 00:11:43.000000', 'consum', 0.0215, 'lps'),
	(514002, 128, '2014-02-01 00:11:44.000000', 'consum', 0.0221, 'lps'),
	(514003, 128, '2014-02-01 00:11:45.000000', 'consum', 0.0210, 'lps'),
	(514004, 128, '2014-02-01 00:11:46.000000', 'consum', 0.0219, 'lps'),
	(514005, 128, '2014-02-01 00:11:47.000000', 'consum', 0.0213, 'lps'),
	(514006, 128, '2014-02-01 00:11:48.000000', 'consum', 0.0214, 'lps'),
	(514007, 128, '2014-02-01 00:11:49.000000', 'consum', 0.0221, 'lps'),
	(514008, 128, '2014-02-01 00:11:50.000000', 'consum', 0.0212, 'lps'),
	(514009, 128, '2014-02-01 00:11:51.000000', 'consum', 0.0217, 'lps'),
	(514010, 128, '2014-02-01 00:11:52.000000', 'consum', 0.0210, 'lps'),
	(514011, 128, '2014-02-01 00:11:53.000000', 'consum', 0.0217, 'lps'),
	(514012, 128, '2014-02-01 00:11:54.000000', 'consum', 0.0217, 'lps'),
	(514013, 128, '2014-02-01 00:11:55.000000', 'consum', 0.0212, 'lps'),
	(514014, 128, '2014-02-01 00:11:56.000000', 'consum', 0.0212, 'lps'),
	(514015, 128, '2014-02-01 00:11:57.000000', 'consum', 0.0215, 'lps'),
	(514016, 128, '2014-02-01 00:11:58.000000', 'consum', 0.0216, 'lps'),
	(514017, 128, '2014-02-01 00:11:59.000000', 'consum', 0.0210, 'lps'),
	(514018, 128, '2014-02-01 00:12:00.000000', 'consum', 0.0221, 'lps'),
	(514019, 128, '2014-02-01 00:12:01.000000', 'consum', 0.0223, 'lps'),
	(514020, 128, '2014-02-01 00:12:02.000000', 'consum', 0.0213, 'lps'),
	(514021, 128, '2014-02-01 00:12:03.000000', 'consum', 0.0218, 'lps'),
	(514022, 128, '2014-02-01 00:12:04.000000', 'consum', 0.0212, 'lps'),
	(514023, 128, '2014-02-01 00:12:05.000000', 'consum', 0.0210, 'lps'),
	(514024, 128, '2014-02-01 00:12:06.000000', 'consum', 0.0219, 'lps'),
	(514025, 128, '2014-02-01 00:12:07.000000', 'consum', 0.0212, 'lps'),
	(514026, 128, '2014-02-01 00:12:08.000000', 'consum', 0.0221, 'lps'),
	(514027, 128, '2014-02-01 00:12:09.000000', 'consum', 0.0220, 'lps'),
	(514028, 128, '2014-02-01 00:12:10.000000', 'consum', 0.0211, 'lps'),
	(514029, 128, '2014-02-01 00:12:11.000000', 'consum', 0.0216, 'lps'),
	(514030, 128, '2014-02-01 00:12:12.000000', 'consum', 0.0221, 'lps'),
	(514031, 128, '2014-02-01 00:12:13.000000', 'consum', 0.0220, 'lps'),
	(514032, 128, '2014-02-01 00:12:14.000000', 'consum', 0.0212, 'lps'),
	(514033, 128, '2014-02-01 00:12:15.000000', 'consum', 0.0220, 'lps'),
	(514034, 128, '2014-02-01 00:12:16.000000', 'consum', 0.0210, 'lps'),
	(514035, 128, '2014-02-01 00:12:17.000000', 'consum', 0.0212, 'lps'),
	(514036, 128, '2014-02-01 00:12:18.000000', 'consum', 0.0220, 'lps'),
	(514037, 128, '2014-02-01 00:12:19.000000', 'consum', 0.0213, 'lps'),
	(514038, 128, '2014-02-01 00:12:20.000000', 'consum', 0.0210, 'lps'),
	(514039, 128, '2014-02-01 00:12:21.000000', 'consum', 0.0217, 'lps'),
	(514040, 128, '2014-02-01 00:12:22.000000', 'consum', 0.0214, 'lps'),
	(514041, 128, '2014-02-01 00:12:23.000000', 'consum', 0.0211, 'lps'),
	(514042, 128, '2014-02-01 00:12:24.000000', 'consum', 0.0215, 'lps'),
	(514043, 128, '2014-02-01 00:12:25.000000', 'consum', 0.0221, 'lps'),
	(514044, 128, '2014-02-01 00:12:26.000000', 'consum', 0.0223, 'lps'),
	(514045, 128, '2014-02-01 00:12:27.000000', 'consum', 0.0212, 'lps'),
	(514046, 128, '2014-02-01 00:12:28.000000', 'consum', 0.0212, 'lps'),
	(514047, 128, '2014-02-01 00:12:29.000000', 'consum', 0.0215, 'lps'),
	(514048, 128, '2014-02-01 00:12:30.000000', 'consum', 0.0214, 'lps'),
	(514049, 128, '2014-02-01 00:12:31.000000', 'consum', 0.0217, 'lps'),
	(514050, 128, '2014-02-01 00:12:32.000000', 'consum', 0.0217, 'lps'),
	(514051, 128, '2014-02-01 00:12:33.000000', 'consum', 0.0210, 'lps'),
	(514052, 128, '2014-02-01 00:12:34.000000', 'consum', 0.0218, 'lps'),
	(514053, 128, '2014-02-01 00:12:35.000000', 'consum', 0.0223, 'lps'),
	(514054, 128, '2014-02-01 00:12:36.000000', 'consum', 0.0222, 'lps'),
	(514055, 128, '2014-02-01 00:12:37.000000', 'consum', 0.0221, 'lps'),
	(514056, 128, '2014-02-01 00:12:38.000000', 'consum', 0.0212, 'lps'),
	(514057, 128, '2014-02-01 00:12:39.000000', 'consum', 0.0218, 'lps'),
	(514058, 128, '2014-02-01 00:12:40.000000', 'consum', 0.0214, 'lps'),
	(514059, 128, '2014-02-01 00:12:41.000000', 'consum', 0.0219, 'lps'),
	(514060, 128, '2014-02-01 00:12:42.000000', 'consum', 0.0219, 'lps'),
	(514061, 128, '2014-02-01 00:12:43.000000', 'consum', 0.0215, 'lps'),
	(514062, 128, '2014-02-01 00:12:44.000000', 'consum', 0.0223, 'lps'),
	(514063, 128, '2014-02-01 00:12:45.000000', 'consum', 0.0216, 'lps'),
	(514064, 128, '2014-02-01 00:12:46.000000', 'consum', 0.0216, 'lps'),
	(514065, 128, '2014-02-01 00:12:47.000000', 'consum', 0.0222, 'lps'),
	(514066, 128, '2014-02-01 00:12:48.000000', 'consum', 0.0213, 'lps'),
	(514067, 128, '2014-02-01 00:12:49.000000', 'consum', 0.0217, 'lps'),
	(514068, 128, '2014-02-01 00:12:50.000000', 'consum', 0.0221, 'lps'),
	(514069, 128, '2014-02-01 00:12:51.000000', 'consum', 0.0219, 'lps'),
	(514070, 128, '2014-02-01 00:12:52.000000', 'consum', 0.0219, 'lps'),
	(514071, 128, '2014-02-01 00:12:53.000000', 'consum', 0.0217, 'lps'),
	(514072, 128, '2014-02-01 00:12:54.000000', 'consum', 0.0217, 'lps'),
	(514073, 128, '2014-02-01 00:12:55.000000', 'consum', 0.0210, 'lps'),
	(514074, 128, '2014-02-01 00:12:56.000000', 'consum', 0.0217, 'lps'),
	(514075, 128, '2014-02-01 00:12:57.000000', 'consum', 0.0217, 'lps'),
	(514076, 128, '2014-02-01 00:12:58.000000', 'consum', 0.0212, 'lps'),
	(514077, 128, '2014-02-01 00:12:59.000000', 'consum', 0.0215, 'lps'),
	(514078, 128, '2014-02-01 00:13:00.000000', 'consum', 0.0212, 'lps'),
	(514079, 128, '2014-02-01 00:13:01.000000', 'consum', 0.0223, 'lps'),
	(514080, 128, '2014-02-01 00:13:02.000000', 'consum', 0.0210, 'lps'),
	(514081, 128, '2014-02-01 00:13:03.000000', 'consum', 0.0217, 'lps'),
	(514082, 128, '2014-02-01 00:13:04.000000', 'consum', 0.0216, 'lps'),
	(514083, 128, '2014-02-01 00:13:05.000000', 'consum', 0.0219, 'lps'),
	(514084, 128, '2014-02-01 00:13:06.000000', 'consum', 0.0223, 'lps'),
	(514085, 128, '2014-02-01 00:13:07.000000', 'consum', 0.0223, 'lps'),
	(514086, 128, '2014-02-01 00:13:08.000000', 'consum', 0.0221, 'lps'),
	(514087, 128, '2014-02-01 00:13:09.000000', 'consum', 0.0211, 'lps'),
	(514088, 128, '2014-02-01 00:13:10.000000', 'consum', 0.0214, 'lps'),
	(514089, 128, '2014-02-01 00:13:11.000000', 'consum', 0.0210, 'lps'),
	(514090, 128, '2014-02-01 00:13:12.000000', 'consum', 0.0215, 'lps'),
	(514091, 128, '2014-02-01 00:13:13.000000', 'consum', 0.0219, 'lps'),
	(514092, 128, '2014-02-01 00:13:14.000000', 'consum', 0.0212, 'lps'),
	(514093, 128, '2014-02-01 00:13:15.000000', 'consum', 0.0210, 'lps'),
	(514094, 128, '2014-02-01 00:13:16.000000', 'consum', 0.0219, 'lps'),
	(514095, 128, '2014-02-01 00:13:17.000000', 'consum', 0.0211, 'lps'),
	(514096, 128, '2014-02-01 00:13:18.000000', 'consum', 0.0218, 'lps'),
	(514097, 128, '2014-02-01 00:13:19.000000', 'consum', 0.0219, 'lps'),
	(514098, 128, '2014-02-01 00:13:20.000000', 'consum', 0.0217, 'lps'),
	(514099, 128, '2014-02-01 00:13:21.000000', 'consum', 0.0220, 'lps'),
	(514100, 128, '2014-02-01 00:13:22.000000', 'consum', 0.0223, 'lps'),
	(514101, 128, '2014-02-01 00:13:23.000000', 'consum', 0.0218, 'lps'),
	(514102, 128, '2014-02-01 00:13:24.000000', 'consum', 0.0210, 'lps'),
	(514103, 128, '2014-02-01 00:13:25.000000', 'consum', 0.0216, 'lps'),
	(514104, 128, '2014-02-01 00:13:26.000000', 'consum', 0.0214, 'lps'),
	(514105, 128, '2014-02-01 00:13:27.000000', 'consum', 0.0210, 'lps'),
	(514106, 128, '2014-02-01 00:13:28.000000', 'consum', 0.0215, 'lps'),
	(514107, 128, '2014-02-01 00:13:29.000000', 'consum', 0.0219, 'lps'),
	(514108, 128, '2014-02-01 00:13:30.000000', 'consum', 0.0213, 'lps'),
	(514109, 128, '2014-02-01 00:13:31.000000', 'consum', 0.0211, 'lps'),
	(514110, 128, '2014-02-01 00:13:32.000000', 'consum', 0.0222, 'lps'),
	(514111, 128, '2014-02-01 00:13:33.000000', 'consum', 0.0212, 'lps'),
	(514112, 128, '2014-02-01 00:13:34.000000', 'consum', 0.0212, 'lps'),
	(514113, 128, '2014-02-01 00:13:35.000000', 'consum', 0.0216, 'lps'),
	(514114, 128, '2014-02-01 00:13:36.000000', 'consum', 0.0220, 'lps'),
	(514115, 128, '2014-02-01 00:13:37.000000', 'consum', 0.0214, 'lps'),
	(514116, 128, '2014-02-01 00:13:38.000000', 'consum', 0.0216, 'lps'),
	(514117, 128, '2014-02-01 00:13:39.000000', 'consum', 0.0212, 'lps'),
	(514118, 128, '2014-02-01 00:13:40.000000', 'consum', 0.0219, 'lps'),
	(514119, 128, '2014-02-01 00:13:41.000000', 'consum', 0.0219, 'lps'),
	(514120, 128, '2014-02-01 00:13:42.000000', 'consum', 0.0215, 'lps'),
	(514121, 128, '2014-02-01 00:13:43.000000', 'consum', 0.0221, 'lps'),
	(514122, 128, '2014-02-01 00:13:44.000000', 'consum', 0.0223, 'lps'),
	(514123, 128, '2014-02-01 00:13:45.000000', 'consum', 0.0214, 'lps'),
	(514124, 128, '2014-02-01 00:13:46.000000', 'consum', 0.0222, 'lps'),
	(514125, 128, '2014-02-01 00:13:47.000000', 'consum', 0.0215, 'lps'),
	(514126, 128, '2014-02-01 00:13:48.000000', 'consum', 0.0214, 'lps'),
	(514127, 128, '2014-02-01 00:13:49.000000', 'consum', 0.0217, 'lps'),
	(514128, 128, '2014-02-01 00:13:50.000000', 'consum', 0.0217, 'lps'),
	(514129, 128, '2014-02-01 00:13:51.000000', 'consum', 0.0212, 'lps'),
	(514130, 128, '2014-02-01 00:13:52.000000', 'consum', 0.0211, 'lps'),
	(514131, 128, '2014-02-01 00:13:53.000000', 'consum', 0.0213, 'lps'),
	(514132, 128, '2014-02-01 00:13:54.000000', 'consum', 0.0219, 'lps'),
	(514133, 128, '2014-02-01 00:13:55.000000', 'consum', 0.0222, 'lps'),
	(514134, 128, '2014-02-01 00:13:56.000000', 'consum', 0.0213, 'lps'),
	(514135, 128, '2014-02-01 00:13:57.000000', 'consum', 0.0217, 'lps'),
	(514136, 128, '2014-02-01 00:13:58.000000', 'consum', 0.0211, 'lps'),
	(514137, 128, '2014-02-01 00:13:59.000000', 'consum', 0.0221, 'lps'),
	(514138, 128, '2014-02-01 00:14:00.000000', 'consum', 0.0221, 'lps'),
	(514139, 128, '2014-02-01 00:14:01.000000', 'consum', 0.0219, 'lps'),
	(514140, 128, '2014-02-01 00:14:02.000000', 'consum', 0.0210, 'lps'),
	(514141, 128, '2014-02-01 00:14:03.000000', 'consum', 0.0223, 'lps'),
	(514142, 128, '2014-02-01 00:14:04.000000', 'consum', 0.0221, 'lps'),
	(514143, 128, '2014-02-01 00:14:05.000000', 'consum', 0.0210, 'lps'),
	(514144, 128, '2014-02-01 00:14:06.000000', 'consum', 0.0221, 'lps'),
	(514145, 128, '2014-02-01 00:14:07.000000', 'consum', 0.0223, 'lps'),
	(514146, 128, '2014-02-01 00:14:08.000000', 'consum', 0.0214, 'lps'),
	(514147, 128, '2014-02-01 00:14:09.000000', 'consum', 0.0220, 'lps'),
	(514148, 128, '2014-02-01 00:14:10.000000', 'consum', 0.0222, 'lps'),
	(514149, 128, '2014-02-01 00:14:11.000000', 'consum', 0.0213, 'lps'),
	(514150, 128, '2014-02-01 00:14:12.000000', 'consum', 0.0216, 'lps'),
	(514151, 128, '2014-02-01 00:14:13.000000', 'consum', 0.0219, 'lps'),
	(514152, 128, '2014-02-01 00:14:14.000000', 'consum', 0.0221, 'lps'),
	(514153, 128, '2014-02-01 00:14:15.000000', 'consum', 0.0212, 'lps'),
	(514154, 128, '2014-02-01 00:14:16.000000', 'consum', 0.0216, 'lps'),
	(514155, 128, '2014-02-01 00:14:17.000000', 'consum', 0.0218, 'lps'),
	(514156, 128, '2014-02-01 00:14:18.000000', 'consum', 0.0219, 'lps'),
	(514157, 128, '2014-02-01 00:14:19.000000', 'consum', 0.0219, 'lps'),
	(514158, 128, '2014-02-01 00:14:20.000000', 'consum', 0.0214, 'lps'),
	(514159, 128, '2014-02-01 00:14:21.000000', 'consum', 0.0219, 'lps'),
	(514160, 128, '2014-02-01 00:14:22.000000', 'consum', 0.0215, 'lps'),
	(514161, 128, '2014-02-01 00:14:23.000000', 'consum', 0.0210, 'lps'),
	(514162, 128, '2014-02-01 00:14:24.000000', 'consum', 0.0221, 'lps'),
	(514163, 128, '2014-02-01 00:14:25.000000', 'consum', 0.0212, 'lps'),
	(514164, 128, '2014-02-01 00:14:26.000000', 'consum', 0.0213, 'lps'),
	(514165, 128, '2014-02-01 00:14:27.000000', 'consum', 0.0222, 'lps'),
	(514166, 128, '2014-02-01 00:14:28.000000', 'consum', 0.0220, 'lps'),
	(514167, 128, '2014-02-01 00:14:29.000000', 'consum', 0.0223, 'lps'),
	(514168, 128, '2014-02-01 00:14:30.000000', 'consum', 0.0216, 'lps'),
	(514169, 128, '2014-02-01 00:14:31.000000', 'consum', 0.0217, 'lps'),
	(514170, 128, '2014-02-01 00:14:32.000000', 'consum', 0.0213, 'lps'),
	(514171, 128, '2014-02-01 00:14:33.000000', 'consum', 0.0221, 'lps'),
	(514172, 128, '2014-02-01 00:14:34.000000', 'consum', 0.0212, 'lps'),
	(514173, 128, '2014-02-01 00:14:35.000000', 'consum', 0.0216, 'lps'),
	(514174, 128, '2014-02-01 00:14:36.000000', 'consum', 0.0222, 'lps'),
	(514175, 128, '2014-02-01 00:14:37.000000', 'consum', 0.0223, 'lps'),
	(514176, 128, '2014-02-01 00:14:38.000000', 'consum', 0.0211, 'lps'),
	(514177, 128, '2014-02-01 00:14:39.000000', 'consum', 0.0218, 'lps'),
	(514178, 128, '2014-02-01 00:14:40.000000', 'consum', 0.0220, 'lps'),
	(514179, 128, '2014-02-01 00:14:41.000000', 'consum', 0.0221, 'lps'),
	(514180, 128, '2014-02-01 00:14:42.000000', 'consum', 0.0222, 'lps'),
	(514181, 128, '2014-02-01 00:14:43.000000', 'consum', 0.0223, 'lps'),
	(514182, 128, '2014-02-01 00:14:44.000000', 'consum', 0.0213, 'lps'),
	(514183, 128, '2014-02-01 00:14:45.000000', 'consum', 0.0213, 'lps'),
	(514184, 128, '2014-02-01 00:14:46.000000', 'consum', 0.0215, 'lps'),
	(514185, 128, '2014-02-01 00:14:47.000000', 'consum', 0.0216, 'lps'),
	(514186, 128, '2014-02-01 00:14:48.000000', 'consum', 0.0223, 'lps'),
	(514187, 128, '2014-02-01 00:14:49.000000', 'consum', 0.0216, 'lps'),
	(514188, 128, '2014-02-01 00:14:50.000000', 'consum', 0.0216, 'lps'),
	(514189, 128, '2014-02-01 00:14:51.000000', 'consum', 0.0210, 'lps'),
	(514190, 128, '2014-02-01 00:14:52.000000', 'consum', 0.0218, 'lps'),
	(514191, 128, '2014-02-01 00:14:53.000000', 'consum', 0.0222, 'lps'),
	(514192, 128, '2014-02-01 00:14:54.000000', 'consum', 0.0220, 'lps'),
	(514193, 128, '2014-02-01 00:14:55.000000', 'consum', 0.0211, 'lps'),
	(514194, 128, '2014-02-01 00:14:56.000000', 'consum', 0.0213, 'lps'),
	(514195, 128, '2014-02-01 00:14:57.000000', 'consum', 0.0210, 'lps'),
	(514196, 128, '2014-02-01 00:14:58.000000', 'consum', 0.0213, 'lps'),
	(514197, 128, '2014-02-01 00:14:59.000000', 'consum', 0.0211, 'lps'),
	(514198, 128, '2014-02-01 00:15:00.000000', 'consum', 0.0220, 'lps'),
	(514199, 128, '2014-02-01 00:15:01.000000', 'consum', 0.0217, 'lps'),
	(514200, 128, '2014-02-01 00:15:02.000000', 'consum', 0.0216, 'lps'),
	(514201, 128, '2014-02-01 00:15:03.000000', 'consum', 0.0221, 'lps'),
	(514202, 128, '2014-02-01 00:15:04.000000', 'consum', 0.0218, 'lps'),
	(514203, 128, '2014-02-01 00:15:05.000000', 'consum', 0.0218, 'lps'),
	(514204, 128, '2014-02-01 00:15:06.000000', 'consum', 0.0214, 'lps'),
	(514205, 128, '2014-02-01 00:15:07.000000', 'consum', 0.0219, 'lps'),
	(514206, 128, '2014-02-01 00:15:08.000000', 'consum', 0.0214, 'lps'),
	(514207, 128, '2014-02-01 00:15:09.000000', 'consum', 0.0220, 'lps'),
	(514208, 128, '2014-02-01 00:15:10.000000', 'consum', 0.0221, 'lps'),
	(514209, 128, '2014-02-01 00:15:11.000000', 'consum', 0.0220, 'lps'),
	(514210, 128, '2014-02-01 00:15:12.000000', 'consum', 0.0213, 'lps'),
	(514211, 128, '2014-02-01 00:15:13.000000', 'consum', 0.0223, 'lps'),
	(514212, 128, '2014-02-01 00:15:14.000000', 'consum', 0.0210, 'lps'),
	(514213, 128, '2014-02-01 00:15:15.000000', 'consum', 0.0215, 'lps'),
	(514214, 128, '2014-02-01 00:15:16.000000', 'consum', 0.0221, 'lps'),
	(514215, 128, '2014-02-01 00:15:17.000000', 'consum', 0.0221, 'lps'),
	(514216, 128, '2014-02-01 00:15:18.000000', 'consum', 0.0220, 'lps'),
	(514217, 128, '2014-02-01 00:15:19.000000', 'consum', 0.0215, 'lps'),
	(514218, 128, '2014-02-01 00:15:20.000000', 'consum', 0.0217, 'lps'),
	(514219, 128, '2014-02-01 00:15:21.000000', 'consum', 0.0217, 'lps'),
	(514220, 128, '2014-02-01 00:15:22.000000', 'consum', 0.0223, 'lps'),
	(514221, 128, '2014-02-01 00:15:23.000000', 'consum', 0.0215, 'lps'),
	(514222, 128, '2014-02-01 00:15:24.000000', 'consum', 0.0210, 'lps'),
	(514223, 128, '2014-02-01 00:15:25.000000', 'consum', 0.0211, 'lps'),
	(514224, 128, '2014-02-01 00:15:26.000000', 'consum', 0.0214, 'lps'),
	(514225, 128, '2014-02-01 00:15:27.000000', 'consum', 0.0213, 'lps'),
	(514226, 128, '2014-02-01 00:15:28.000000', 'consum', 0.0212, 'lps'),
	(514227, 128, '2014-02-01 00:15:29.000000', 'consum', 0.0214, 'lps'),
	(514228, 128, '2014-02-01 00:15:30.000000', 'consum', 0.0223, 'lps'),
	(514229, 128, '2014-02-01 00:15:31.000000', 'consum', 0.0220, 'lps'),
	(514230, 128, '2014-02-01 00:15:32.000000', 'consum', 0.0223, 'lps'),
	(514231, 128, '2014-02-01 00:15:33.000000', 'consum', 0.0219, 'lps'),
	(514232, 128, '2014-02-01 00:15:34.000000', 'consum', 0.0215, 'lps'),
	(514233, 128, '2014-02-01 00:15:35.000000', 'consum', 0.0223, 'lps'),
	(514234, 128, '2014-02-01 00:15:36.000000', 'consum', 0.0218, 'lps'),
	(514235, 128, '2014-02-01 00:15:37.000000', 'consum', 0.0212, 'lps'),
	(514236, 128, '2014-02-01 00:15:38.000000', 'consum', 0.0211, 'lps'),
	(514237, 128, '2014-02-01 00:15:39.000000', 'consum', 0.0210, 'lps'),
	(514238, 128, '2014-02-01 00:15:40.000000', 'consum', 0.0219, 'lps'),
	(514239, 128, '2014-02-01 00:15:41.000000', 'consum', 0.0213, 'lps'),
	(514240, 128, '2014-02-01 00:15:42.000000', 'consum', 0.0216, 'lps'),
	(514241, 128, '2014-02-01 00:15:43.000000', 'consum', 0.0214, 'lps'),
	(514242, 128, '2014-02-01 00:15:44.000000', 'consum', 0.0213, 'lps'),
	(514243, 128, '2014-02-01 00:15:45.000000', 'consum', 0.0213, 'lps'),
	(514244, 128, '2014-02-01 00:15:46.000000', 'consum', 0.0219, 'lps'),
	(514245, 128, '2014-02-01 00:15:47.000000', 'consum', 0.0218, 'lps'),
	(514246, 128, '2014-02-01 00:15:48.000000', 'consum', 0.0222, 'lps'),
	(514247, 128, '2014-02-01 00:15:49.000000', 'consum', 0.0220, 'lps'),
	(514248, 128, '2014-02-01 00:15:50.000000', 'consum', 0.0212, 'lps'),
	(514249, 128, '2014-02-01 00:15:51.000000', 'consum', 0.0216, 'lps'),
	(514250, 128, '2014-02-01 00:15:52.000000', 'consum', 0.0222, 'lps'),
	(514251, 128, '2014-02-01 00:15:53.000000', 'consum', 0.0210, 'lps'),
	(514252, 128, '2014-02-01 00:15:54.000000', 'consum', 0.0217, 'lps'),
	(514253, 128, '2014-02-01 00:15:55.000000', 'consum', 0.0218, 'lps'),
	(514254, 128, '2014-02-01 00:15:56.000000', 'consum', 0.0216, 'lps'),
	(514255, 128, '2014-02-01 00:15:57.000000', 'consum', 0.0217, 'lps'),
	(514256, 128, '2014-02-01 00:15:58.000000', 'consum', 0.0211, 'lps'),
	(514257, 128, '2014-02-01 00:15:59.000000', 'consum', 0.0210, 'lps'),
	(514258, 128, '2014-02-01 00:16:00.000000', 'consum', 0.0223, 'lps'),
	(514259, 128, '2014-02-01 00:16:01.000000', 'consum', 0.0218, 'lps'),
	(514260, 128, '2014-02-01 00:16:02.000000', 'consum', 0.0213, 'lps'),
	(514261, 128, '2014-02-01 00:16:03.000000', 'consum', 0.0217, 'lps'),
	(514262, 128, '2014-02-01 00:16:04.000000', 'consum', 0.0220, 'lps'),
	(514263, 128, '2014-02-01 00:16:05.000000', 'consum', 0.0210, 'lps'),
	(514264, 128, '2014-02-01 00:16:06.000000', 'consum', 0.0212, 'lps'),
	(514265, 128, '2014-02-01 00:16:07.000000', 'consum', 0.0217, 'lps'),
	(514266, 128, '2014-02-01 00:16:08.000000', 'consum', 0.0213, 'lps'),
	(514267, 128, '2014-02-01 00:16:09.000000', 'consum', 0.0217, 'lps'),
	(514268, 128, '2014-02-01 00:16:10.000000', 'consum', 0.0211, 'lps'),
	(514269, 128, '2014-02-01 00:16:11.000000', 'consum', 0.0222, 'lps'),
	(514270, 128, '2014-02-01 00:16:12.000000', 'consum', 0.0211, 'lps'),
	(514271, 128, '2014-02-01 00:16:13.000000', 'consum', 0.0222, 'lps'),
	(514272, 128, '2014-02-01 00:16:14.000000', 'consum', 0.0210, 'lps'),
	(514273, 128, '2014-02-01 00:16:15.000000', 'consum', 0.0217, 'lps'),
	(514274, 128, '2014-02-01 00:16:16.000000', 'consum', 0.0216, 'lps'),
	(514275, 128, '2014-02-01 00:16:17.000000', 'consum', 0.0221, 'lps'),
	(514276, 128, '2014-02-01 00:16:18.000000', 'consum', 0.0219, 'lps'),
	(514277, 128, '2014-02-01 00:16:19.000000', 'consum', 0.0223, 'lps'),
	(514278, 128, '2014-02-01 00:16:20.000000', 'consum', 0.0221, 'lps'),
	(514279, 128, '2014-02-01 00:16:21.000000', 'consum', 0.0212, 'lps'),
	(514280, 128, '2014-02-01 00:16:22.000000', 'consum', 0.0215, 'lps'),
	(514281, 128, '2014-02-01 00:16:23.000000', 'consum', 0.0214, 'lps'),
	(514282, 128, '2014-02-01 00:16:24.000000', 'consum', 0.0216, 'lps'),
	(514283, 128, '2014-02-01 00:16:25.000000', 'consum', 0.0215, 'lps'),
	(514284, 128, '2014-02-01 00:16:26.000000', 'consum', 0.0217, 'lps'),
	(514285, 128, '2014-02-01 00:16:27.000000', 'consum', 0.0217, 'lps'),
	(514286, 128, '2014-02-01 00:16:28.000000', 'consum', 0.0211, 'lps'),
	(514287, 128, '2014-02-01 00:16:29.000000', 'consum', 0.0221, 'lps'),
	(514288, 128, '2014-02-01 00:16:30.000000', 'consum', 0.0220, 'lps'),
	(514289, 128, '2014-02-01 00:16:31.000000', 'consum', 0.0216, 'lps'),
	(514290, 128, '2014-02-01 00:16:32.000000', 'consum', 0.0211, 'lps'),
	(514291, 128, '2014-02-01 00:16:33.000000', 'consum', 0.0222, 'lps'),
	(514292, 128, '2014-02-01 00:16:34.000000', 'consum', 0.0214, 'lps'),
	(514293, 128, '2014-02-01 00:16:35.000000', 'consum', 0.0222, 'lps'),
	(514294, 128, '2014-02-01 00:16:36.000000', 'consum', 0.0218, 'lps'),
	(514295, 128, '2014-02-01 00:16:37.000000', 'consum', 0.0212, 'lps'),
	(514296, 128, '2014-02-01 00:16:38.000000', 'consum', 0.0210, 'lps'),
	(514297, 128, '2014-02-01 00:16:39.000000', 'consum', 0.0219, 'lps'),
	(514298, 128, '2014-02-01 00:16:40.000000', 'consum', 0.0215, 'lps'),
	(514299, 128, '2014-02-01 00:16:41.000000', 'consum', 0.0221, 'lps'),
	(514300, 128, '2014-02-01 00:16:42.000000', 'consum', 0.0210, 'lps'),
	(514301, 128, '2014-02-01 00:16:43.000000', 'consum', 0.0219, 'lps'),
	(514302, 128, '2014-02-01 00:16:44.000000', 'consum', 0.0213, 'lps'),
	(514303, 128, '2014-02-01 00:16:45.000000', 'consum', 0.0211, 'lps'),
	(514304, 128, '2014-02-01 00:16:46.000000', 'consum', 0.0221, 'lps'),
	(514305, 128, '2014-02-01 00:16:47.000000', 'consum', 0.0221, 'lps'),
	(514306, 128, '2014-02-01 00:16:48.000000', 'consum', 0.0217, 'lps'),
	(514307, 128, '2014-02-01 00:16:49.000000', 'consum', 0.0215, 'lps'),
	(514308, 128, '2014-02-01 00:16:50.000000', 'consum', 0.0215, 'lps'),
	(514309, 128, '2014-02-01 00:16:51.000000', 'consum', 0.0221, 'lps'),
	(514310, 128, '2014-02-01 00:16:52.000000', 'consum', 0.0223, 'lps'),
	(514311, 128, '2014-02-01 00:16:53.000000', 'consum', 0.0214, 'lps'),
	(514312, 128, '2014-02-01 00:16:54.000000', 'consum', 0.0219, 'lps'),
	(514313, 128, '2014-02-01 00:16:55.000000', 'consum', 0.0217, 'lps'),
	(514314, 128, '2014-02-01 00:16:56.000000', 'consum', 0.0216, 'lps'),
	(514315, 128, '2014-02-01 00:16:57.000000', 'consum', 0.0220, 'lps'),
	(514316, 128, '2014-02-01 00:16:58.000000', 'consum', 0.0215, 'lps'),
	(514317, 128, '2014-02-01 00:16:59.000000', 'consum', 0.0221, 'lps'),
	(514318, 128, '2014-02-01 00:17:00.000000', 'consum', 0.0222, 'lps'),
	(514319, 128, '2014-02-01 00:17:01.000000', 'consum', 0.0211, 'lps'),
	(514320, 128, '2014-02-01 00:17:02.000000', 'consum', 0.0220, 'lps'),
	(514321, 128, '2014-02-01 00:17:03.000000', 'consum', 0.0216, 'lps'),
	(514322, 128, '2014-02-01 00:17:04.000000', 'consum', 0.0222, 'lps'),
	(514323, 128, '2014-02-01 00:17:05.000000', 'consum', 0.0213, 'lps'),
	(514324, 128, '2014-02-01 00:17:06.000000', 'consum', 0.0218, 'lps'),
	(514325, 128, '2014-02-01 00:17:07.000000', 'consum', 0.0213, 'lps'),
	(514326, 128, '2014-02-01 00:17:08.000000', 'consum', 0.0213, 'lps'),
	(514327, 128, '2014-02-01 00:17:09.000000', 'consum', 0.0219, 'lps'),
	(514328, 128, '2014-02-01 00:17:10.000000', 'consum', 0.0217, 'lps'),
	(514329, 128, '2014-02-01 00:17:11.000000', 'consum', 0.0221, 'lps'),
	(514330, 128, '2014-02-01 00:17:12.000000', 'consum', 0.0216, 'lps'),
	(514331, 128, '2014-02-01 00:17:13.000000', 'consum', 0.0220, 'lps'),
	(514332, 128, '2014-02-01 00:17:14.000000', 'consum', 0.0216, 'lps'),
	(514333, 128, '2014-02-01 00:17:15.000000', 'consum', 0.0210, 'lps'),
	(514334, 128, '2014-02-01 00:17:16.000000', 'consum', 0.0219, 'lps'),
	(514335, 128, '2014-02-01 00:17:17.000000', 'consum', 0.0215, 'lps'),
	(514336, 128, '2014-02-01 00:17:18.000000', 'consum', 0.0220, 'lps'),
	(514337, 128, '2014-02-01 00:17:19.000000', 'consum', 0.0221, 'lps'),
	(514338, 128, '2014-02-01 00:17:20.000000', 'consum', 0.0220, 'lps'),
	(514339, 128, '2014-02-01 00:17:21.000000', 'consum', 0.0213, 'lps'),
	(514340, 128, '2014-02-01 00:17:22.000000', 'consum', 0.0223, 'lps'),
	(514341, 128, '2014-02-01 00:17:23.000000', 'consum', 0.0210, 'lps'),
	(514342, 128, '2014-02-01 00:17:24.000000', 'consum', 0.0213, 'lps'),
	(514343, 128, '2014-02-01 00:17:25.000000', 'consum', 0.0212, 'lps'),
	(514344, 128, '2014-02-01 00:17:26.000000', 'consum', 0.0211, 'lps'),
	(514345, 128, '2014-02-01 00:17:27.000000', 'consum', 0.0210, 'lps'),
	(514346, 128, '2014-02-01 00:17:28.000000', 'consum', 0.0221, 'lps'),
	(514347, 128, '2014-02-01 00:17:29.000000', 'consum', 0.0222, 'lps'),
	(514348, 128, '2014-02-01 00:17:30.000000', 'consum', 0.0212, 'lps'),
	(514349, 128, '2014-02-01 00:17:31.000000', 'consum', 0.0213, 'lps'),
	(514350, 128, '2014-02-01 00:17:32.000000', 'consum', 0.0217, 'lps'),
	(514351, 128, '2014-02-01 00:17:33.000000', 'consum', 0.0211, 'lps'),
	(514352, 128, '2014-02-01 00:17:34.000000', 'consum', 0.0220, 'lps'),
	(514353, 128, '2014-02-01 00:17:35.000000', 'consum', 0.0215, 'lps'),
	(514354, 128, '2014-02-01 00:17:36.000000', 'consum', 0.0221, 'lps'),
	(514355, 128, '2014-02-01 00:17:37.000000', 'consum', 0.0220, 'lps'),
	(514356, 128, '2014-02-01 00:17:38.000000', 'consum', 0.0216, 'lps'),
	(514357, 128, '2014-02-01 00:17:39.000000', 'consum', 0.0222, 'lps'),
	(514358, 128, '2014-02-01 00:17:40.000000', 'consum', 0.0211, 'lps'),
	(514359, 128, '2014-02-01 00:17:41.000000', 'consum', 0.0222, 'lps'),
	(514360, 128, '2014-02-01 00:17:42.000000', 'consum', 0.0210, 'lps'),
	(514361, 128, '2014-02-01 00:17:43.000000', 'consum', 0.0217, 'lps'),
	(514362, 128, '2014-02-01 00:17:44.000000', 'consum', 0.0218, 'lps'),
	(514363, 128, '2014-02-01 00:17:45.000000', 'consum', 0.0214, 'lps'),
	(514364, 128, '2014-02-01 00:17:46.000000', 'consum', 0.0220, 'lps'),
	(514365, 128, '2014-02-01 00:17:47.000000', 'consum', 0.0221, 'lps'),
	(514366, 128, '2014-02-01 00:17:48.000000', 'consum', 0.0223, 'lps'),
	(514367, 128, '2014-02-01 00:17:49.000000', 'consum', 0.0215, 'lps'),
	(514368, 128, '2014-02-01 00:17:50.000000', 'consum', 0.0211, 'lps'),
	(514369, 128, '2014-02-01 00:17:51.000000', 'consum', 0.0212, 'lps'),
	(514370, 128, '2014-02-01 00:17:52.000000', 'consum', 0.0219, 'lps'),
	(514371, 128, '2014-02-01 00:17:53.000000', 'consum', 0.0222, 'lps'),
	(514372, 128, '2014-02-01 00:17:54.000000', 'consum', 0.0216, 'lps'),
	(514373, 128, '2014-02-01 00:17:55.000000', 'consum', 0.0217, 'lps'),
	(514374, 128, '2014-02-01 00:17:56.000000', 'consum', 0.0215, 'lps'),
	(514375, 128, '2014-02-01 00:17:57.000000', 'consum', 0.0216, 'lps'),
	(514376, 128, '2014-02-01 00:17:58.000000', 'consum', 0.0222, 'lps'),
	(514377, 128, '2014-02-01 00:17:59.000000', 'consum', 0.0213, 'lps'),
	(514378, 128, '2014-02-01 00:18:00.000000', 'consum', 0.0215, 'lps'),
	(514379, 128, '2014-02-01 00:18:01.000000', 'consum', 0.0215, 'lps'),
	(514380, 128, '2014-02-01 00:18:02.000000', 'consum', 0.0220, 'lps'),
	(514381, 128, '2014-02-01 00:18:03.000000', 'consum', 0.0219, 'lps'),
	(514382, 128, '2014-02-01 00:18:04.000000', 'consum', 0.0211, 'lps'),
	(514383, 128, '2014-02-01 00:18:05.000000', 'consum', 0.0214, 'lps'),
	(514384, 128, '2014-02-01 00:18:06.000000', 'consum', 0.0216, 'lps'),
	(514385, 128, '2014-02-01 00:18:07.000000', 'consum', 0.0215, 'lps'),
	(514386, 128, '2014-02-01 00:18:08.000000', 'consum', 0.0215, 'lps'),
	(514387, 128, '2014-02-01 00:18:09.000000', 'consum', 0.0221, 'lps'),
	(514388, 128, '2014-02-01 00:18:10.000000', 'consum', 0.0211, 'lps'),
	(514389, 128, '2014-02-01 00:18:11.000000', 'consum', 0.0223, 'lps'),
	(514390, 128, '2014-02-01 00:18:12.000000', 'consum', 0.0215, 'lps'),
	(514391, 128, '2014-02-01 00:18:13.000000', 'consum', 0.0210, 'lps'),
	(514392, 128, '2014-02-01 00:18:14.000000', 'consum', 0.0223, 'lps'),
	(514393, 128, '2014-02-01 00:18:15.000000', 'consum', 0.0222, 'lps'),
	(514394, 128, '2014-02-01 00:18:16.000000', 'consum', 0.0215, 'lps'),
	(514395, 128, '2014-02-01 00:18:17.000000', 'consum', 0.0215, 'lps'),
	(514396, 128, '2014-02-01 00:18:18.000000', 'consum', 0.0218, 'lps'),
	(514397, 128, '2014-02-01 00:18:19.000000', 'consum', 0.0210, 'lps'),
	(514398, 128, '2014-02-01 00:18:20.000000', 'consum', 0.0212, 'lps'),
	(514399, 128, '2014-02-01 00:18:21.000000', 'consum', 0.0221, 'lps'),
	(514400, 128, '2014-02-01 00:18:22.000000', 'consum', 0.0216, 'lps'),
	(514401, 128, '2014-02-01 00:18:23.000000', 'consum', 0.0223, 'lps'),
	(514402, 128, '2014-02-01 00:18:24.000000', 'consum', 0.0216, 'lps'),
	(514403, 128, '2014-02-01 00:18:25.000000', 'consum', 0.0215, 'lps'),
	(514404, 128, '2014-02-01 00:18:26.000000', 'consum', 0.0217, 'lps'),
	(514405, 128, '2014-02-01 00:18:27.000000', 'consum', 0.0215, 'lps'),
	(514406, 128, '2014-02-01 00:18:28.000000', 'consum', 0.0215, 'lps'),
	(514407, 128, '2014-02-01 00:18:29.000000', 'consum', 0.0220, 'lps'),
	(514408, 128, '2014-02-01 00:18:30.000000', 'consum', 0.0220, 'lps'),
	(514409, 128, '2014-02-01 00:18:31.000000', 'consum', 0.0215, 'lps'),
	(514410, 128, '2014-02-01 00:18:32.000000', 'consum', 0.0218, 'lps'),
	(514411, 128, '2014-02-01 00:18:33.000000', 'consum', 0.0210, 'lps'),
	(514412, 128, '2014-02-01 00:18:34.000000', 'consum', 0.0214, 'lps'),
	(514413, 128, '2014-02-01 00:18:35.000000', 'consum', 0.0216, 'lps'),
	(514414, 128, '2014-02-01 00:18:36.000000', 'consum', 0.0213, 'lps'),
	(514415, 128, '2014-02-01 00:18:37.000000', 'consum', 0.0211, 'lps'),
	(514416, 128, '2014-02-01 00:18:38.000000', 'consum', 0.0217, 'lps'),
	(514417, 128, '2014-02-01 00:18:39.000000', 'consum', 0.0217, 'lps'),
	(514418, 128, '2014-02-01 00:18:40.000000', 'consum', 0.0211, 'lps'),
	(514419, 128, '2014-02-01 00:18:41.000000', 'consum', 0.0221, 'lps'),
	(514420, 128, '2014-02-01 00:18:42.000000', 'consum', 0.0222, 'lps'),
	(514421, 128, '2014-02-01 00:18:43.000000', 'consum', 0.0221, 'lps'),
	(514422, 128, '2014-02-01 00:18:44.000000', 'consum', 0.0218, 'lps'),
	(514423, 128, '2014-02-01 00:18:45.000000', 'consum', 0.0215, 'lps'),
	(514424, 128, '2014-02-01 00:18:46.000000', 'consum', 0.0211, 'lps'),
	(514425, 128, '2014-02-01 00:18:47.000000', 'consum', 0.0215, 'lps'),
	(514426, 128, '2014-02-01 00:18:48.000000', 'consum', 0.0217, 'lps'),
	(514427, 128, '2014-02-01 00:18:49.000000', 'consum', 0.0217, 'lps'),
	(514428, 128, '2014-02-01 00:18:50.000000', 'consum', 0.0213, 'lps'),
	(514429, 128, '2014-02-01 00:18:51.000000', 'consum', 0.0215, 'lps'),
	(514430, 128, '2014-02-01 00:18:52.000000', 'consum', 0.0214, 'lps'),
	(514431, 128, '2014-02-01 00:18:53.000000', 'consum', 0.0216, 'lps'),
	(514432, 128, '2014-02-01 00:18:54.000000', 'consum', 0.0215, 'lps'),
	(514433, 128, '2014-02-01 00:18:55.000000', 'consum', 0.0219, 'lps'),
	(514434, 128, '2014-02-01 00:18:56.000000', 'consum', 0.0223, 'lps'),
	(514435, 128, '2014-02-01 00:18:57.000000', 'consum', 0.0222, 'lps'),
	(514436, 128, '2014-02-01 00:18:58.000000', 'consum', 0.0218, 'lps'),
	(514437, 128, '2014-02-01 00:18:59.000000', 'consum', 0.0213, 'lps'),
	(514438, 128, '2014-02-01 00:19:00.000000', 'consum', 0.0218, 'lps'),
	(514439, 128, '2014-02-01 00:19:01.000000', 'consum', 0.0212, 'lps'),
	(514440, 128, '2014-02-01 00:19:02.000000', 'consum', 0.0223, 'lps'),
	(514441, 128, '2014-02-01 00:19:03.000000', 'consum', 0.0216, 'lps'),
	(514442, 128, '2014-02-01 00:19:04.000000', 'consum', 0.0213, 'lps'),
	(514443, 128, '2014-02-01 00:19:05.000000', 'consum', 0.0223, 'lps'),
	(514444, 128, '2014-02-01 00:19:06.000000', 'consum', 0.0223, 'lps'),
	(514445, 128, '2014-02-01 00:19:07.000000', 'consum', 0.0210, 'lps'),
	(514446, 128, '2014-02-01 00:19:08.000000', 'consum', 0.0215, 'lps'),
	(514447, 128, '2014-02-01 00:19:09.000000', 'consum', 0.0219, 'lps'),
	(514448, 128, '2014-02-01 00:19:10.000000', 'consum', 0.0212, 'lps'),
	(514449, 128, '2014-02-01 00:19:11.000000', 'consum', 0.0221, 'lps'),
	(514450, 128, '2014-02-01 00:19:12.000000', 'consum', 0.0217, 'lps'),
	(514451, 128, '2014-02-01 00:19:13.000000', 'consum', 0.0214, 'lps'),
	(514452, 128, '2014-02-01 00:19:14.000000', 'consum', 0.0210, 'lps'),
	(514453, 128, '2014-02-01 00:19:15.000000', 'consum', 0.0213, 'lps'),
	(514454, 128, '2014-02-01 00:19:16.000000', 'consum', 0.0212, 'lps'),
	(514455, 128, '2014-02-01 00:19:17.000000', 'consum', 0.0223, 'lps'),
	(514456, 128, '2014-02-01 00:19:18.000000', 'consum', 0.0213, 'lps'),
	(514457, 128, '2014-02-01 00:19:19.000000', 'consum', 0.0217, 'lps'),
	(514458, 128, '2014-02-01 00:19:20.000000', 'consum', 0.0210, 'lps'),
	(514459, 128, '2014-02-01 00:19:21.000000', 'consum', 0.0214, 'lps'),
	(514460, 128, '2014-02-01 00:19:22.000000', 'consum', 0.0217, 'lps'),
	(514461, 128, '2014-02-01 00:19:23.000000', 'consum', 0.0219, 'lps'),
	(514462, 128, '2014-02-01 00:19:24.000000', 'consum', 0.0221, 'lps'),
	(514463, 128, '2014-02-01 00:19:25.000000', 'consum', 0.0213, 'lps'),
	(514464, 128, '2014-02-01 00:19:26.000000', 'consum', 0.0217, 'lps'),
	(514465, 128, '2014-02-01 00:19:27.000000', 'consum', 0.0211, 'lps'),
	(514466, 128, '2014-02-01 00:19:28.000000', 'consum', 0.0210, 'lps'),
	(514467, 128, '2014-02-01 00:19:29.000000', 'consum', 0.0218, 'lps'),
	(514468, 128, '2014-02-01 00:19:30.000000', 'consum', 0.0210, 'lps'),
	(514469, 128, '2014-02-01 00:19:31.000000', 'consum', 0.0212, 'lps'),
	(514470, 128, '2014-02-01 00:19:32.000000', 'consum', 0.0223, 'lps'),
	(514471, 128, '2014-02-01 00:19:33.000000', 'consum', 0.0214, 'lps'),
	(514472, 128, '2014-02-01 00:19:34.000000', 'consum', 0.0219, 'lps'),
	(514473, 128, '2014-02-01 00:19:35.000000', 'consum', 0.0217, 'lps'),
	(514474, 128, '2014-02-01 00:19:36.000000', 'consum', 0.0218, 'lps'),
	(514475, 128, '2014-02-01 00:19:37.000000', 'consum', 0.0213, 'lps'),
	(514476, 128, '2014-02-01 00:19:38.000000', 'consum', 0.0217, 'lps'),
	(514477, 128, '2014-02-01 00:19:39.000000', 'consum', 0.0222, 'lps'),
	(514478, 128, '2014-02-01 00:19:40.000000', 'consum', 0.0223, 'lps'),
	(514479, 128, '2014-02-01 00:19:41.000000', 'consum', 0.0210, 'lps'),
	(514480, 128, '2014-02-01 00:19:42.000000', 'consum', 0.0215, 'lps'),
	(514481, 128, '2014-02-01 00:19:43.000000', 'consum', 0.0220, 'lps'),
	(514482, 128, '2014-02-01 00:19:44.000000', 'consum', 0.0216, 'lps'),
	(514483, 128, '2014-02-01 00:19:45.000000', 'consum', 0.0213, 'lps'),
	(514484, 128, '2014-02-01 00:19:46.000000', 'consum', 0.0220, 'lps'),
	(514485, 128, '2014-02-01 00:19:47.000000', 'consum', 0.0223, 'lps'),
	(514486, 128, '2014-02-01 00:19:48.000000', 'consum', 0.0220, 'lps'),
	(514487, 128, '2014-02-01 00:19:49.000000', 'consum', 0.0221, 'lps'),
	(514488, 128, '2014-02-01 00:19:50.000000', 'consum', 0.0219, 'lps'),
	(514489, 128, '2014-02-01 00:19:51.000000', 'consum', 0.0211, 'lps'),
	(514490, 128, '2014-02-01 00:19:52.000000', 'consum', 0.0215, 'lps'),
	(514491, 128, '2014-02-01 00:19:53.000000', 'consum', 0.0219, 'lps'),
	(514492, 128, '2014-02-01 00:19:54.000000', 'consum', 0.0214, 'lps'),
	(514493, 128, '2014-02-01 00:19:55.000000', 'consum', 0.0217, 'lps'),
	(514494, 128, '2014-02-01 00:19:56.000000', 'consum', 0.0220, 'lps'),
	(514495, 128, '2014-02-01 00:19:57.000000', 'consum', 0.0211, 'lps'),
	(514496, 128, '2014-02-01 00:19:58.000000', 'consum', 0.0213, 'lps'),
	(514497, 128, '2014-02-01 00:19:59.000000', 'consum', 0.0221, 'lps'),
	(514498, 128, '2014-02-01 00:20:00.000000', 'consum', 0.0217, 'lps'),
	(514499, 128, '2014-02-01 00:20:01.000000', 'consum', 0.0211, 'lps'),
	(514500, 128, '2014-02-01 00:20:02.000000', 'consum', 0.0222, 'lps'),
	(514501, 128, '2014-02-01 00:20:03.000000', 'consum', 0.0214, 'lps'),
	(514502, 128, '2014-02-01 00:20:04.000000', 'consum', 0.0221, 'lps'),
	(514503, 128, '2014-02-01 00:20:05.000000', 'consum', 0.0211, 'lps'),
	(514504, 128, '2014-02-01 00:20:06.000000', 'consum', 0.0212, 'lps'),
	(514505, 128, '2014-02-01 00:20:07.000000', 'consum', 0.0217, 'lps'),
	(514506, 128, '2014-02-01 00:20:08.000000', 'consum', 0.0213, 'lps'),
	(514507, 128, '2014-02-01 00:20:09.000000', 'consum', 0.0218, 'lps'),
	(514508, 128, '2014-02-01 00:20:10.000000', 'consum', 0.0211, 'lps'),
	(514509, 128, '2014-02-01 00:20:11.000000', 'consum', 0.0221, 'lps'),
	(514510, 128, '2014-02-01 00:20:12.000000', 'consum', 0.0219, 'lps'),
	(514511, 128, '2014-02-01 00:20:13.000000', 'consum', 0.0211, 'lps'),
	(514512, 128, '2014-02-01 00:20:14.000000', 'consum', 0.0217, 'lps'),
	(514513, 128, '2014-02-01 00:20:15.000000', 'consum', 0.0214, 'lps'),
	(514514, 128, '2014-02-01 00:20:16.000000', 'consum', 0.0221, 'lps'),
	(514515, 128, '2014-02-01 00:20:17.000000', 'consum', 0.0215, 'lps'),
	(514516, 128, '2014-02-01 00:20:18.000000', 'consum', 0.0214, 'lps'),
	(514517, 128, '2014-02-01 00:20:19.000000', 'consum', 0.0217, 'lps'),
	(514518, 128, '2014-02-01 00:20:20.000000', 'consum', 0.0218, 'lps'),
	(514519, 128, '2014-02-01 00:20:21.000000', 'consum', 0.0215, 'lps'),
	(514520, 128, '2014-02-01 00:20:22.000000', 'consum', 0.0211, 'lps'),
	(514521, 128, '2014-02-01 00:20:23.000000', 'consum', 0.0214, 'lps'),
	(514522, 128, '2014-02-01 00:20:24.000000', 'consum', 0.0215, 'lps'),
	(514523, 128, '2014-02-01 00:20:25.000000', 'consum', 0.0221, 'lps'),
	(514524, 128, '2014-02-01 00:20:26.000000', 'consum', 0.0212, 'lps'),
	(514525, 128, '2014-02-01 00:20:27.000000', 'consum', 0.0214, 'lps'),
	(514526, 128, '2014-02-01 00:20:28.000000', 'consum', 0.0222, 'lps'),
	(514527, 128, '2014-02-01 00:20:29.000000', 'consum', 0.0220, 'lps'),
	(514528, 128, '2014-02-01 00:20:30.000000', 'consum', 0.0210, 'lps'),
	(514529, 128, '2014-02-01 00:20:31.000000', 'consum', 0.0222, 'lps'),
	(514530, 128, '2014-02-01 00:20:32.000000', 'consum', 0.0214, 'lps'),
	(514531, 128, '2014-02-01 00:20:33.000000', 'consum', 0.0211, 'lps'),
	(514532, 128, '2014-02-01 00:20:34.000000', 'consum', 0.0214, 'lps'),
	(514533, 128, '2014-02-01 00:20:35.000000', 'consum', 0.0217, 'lps'),
	(514534, 128, '2014-02-01 00:20:36.000000', 'consum', 0.0218, 'lps'),
	(514535, 128, '2014-02-01 00:20:37.000000', 'consum', 0.0214, 'lps'),
	(514536, 128, '2014-02-01 00:20:38.000000', 'consum', 0.0210, 'lps'),
	(514537, 128, '2014-02-01 00:20:39.000000', 'consum', 0.0223, 'lps'),
	(514538, 128, '2014-02-01 00:20:40.000000', 'consum', 0.0221, 'lps'),
	(514539, 128, '2014-02-01 00:20:41.000000', 'consum', 0.0211, 'lps'),
	(514540, 128, '2014-02-01 00:20:42.000000', 'consum', 0.0210, 'lps'),
	(514541, 128, '2014-02-01 00:20:43.000000', 'consum', 0.0221, 'lps'),
	(514542, 128, '2014-02-01 00:20:44.000000', 'consum', 0.0212, 'lps'),
	(514543, 128, '2014-02-01 00:20:45.000000', 'consum', 0.0214, 'lps'),
	(514544, 128, '2014-02-01 00:20:46.000000', 'consum', 0.0213, 'lps'),
	(514545, 128, '2014-02-01 00:20:47.000000', 'consum', 0.0211, 'lps'),
	(514546, 128, '2014-02-01 00:20:48.000000', 'consum', 0.0220, 'lps'),
	(514547, 128, '2014-02-01 00:20:49.000000', 'consum', 0.0217, 'lps'),
	(514548, 128, '2014-02-01 00:20:50.000000', 'consum', 0.0216, 'lps'),
	(514549, 128, '2014-02-01 00:20:51.000000', 'consum', 0.0219, 'lps'),
	(514550, 128, '2014-02-01 00:20:52.000000', 'consum', 0.0223, 'lps'),
	(514551, 128, '2014-02-01 00:20:53.000000', 'consum', 0.0219, 'lps'),
	(514552, 128, '2014-02-01 00:20:54.000000', 'consum', 0.0216, 'lps'),
	(514553, 128, '2014-02-01 00:20:55.000000', 'consum', 0.0215, 'lps'),
	(514554, 128, '2014-02-01 00:20:56.000000', 'consum', 0.0218, 'lps'),
	(514555, 128, '2014-02-01 00:20:57.000000', 'consum', 0.0221, 'lps'),
	(514556, 128, '2014-02-01 00:20:58.000000', 'consum', 0.0213, 'lps'),
	(514557, 128, '2014-02-01 00:20:59.000000', 'consum', 0.0223, 'lps'),
	(514558, 128, '2014-02-01 00:21:00.000000', 'consum', 0.0221, 'lps'),
	(514559, 128, '2014-02-01 00:21:01.000000', 'consum', 0.0216, 'lps'),
	(514560, 128, '2014-02-01 00:21:02.000000', 'consum', 0.0219, 'lps'),
	(514561, 128, '2014-02-01 00:21:03.000000', 'consum', 0.0222, 'lps'),
	(514562, 128, '2014-02-01 00:21:04.000000', 'consum', 0.0219, 'lps'),
	(514563, 128, '2014-02-01 00:21:05.000000', 'consum', 0.0216, 'lps'),
	(514564, 128, '2014-02-01 00:21:06.000000', 'consum', 0.0216, 'lps'),
	(514565, 128, '2014-02-01 00:21:07.000000', 'consum', 0.0221, 'lps'),
	(514566, 128, '2014-02-01 00:21:08.000000', 'consum', 0.0219, 'lps'),
	(514567, 128, '2014-02-01 00:21:09.000000', 'consum', 0.0223, 'lps'),
	(514568, 128, '2014-02-01 00:21:10.000000', 'consum', 0.0222, 'lps'),
	(514569, 128, '2014-02-01 00:21:11.000000', 'consum', 0.0216, 'lps'),
	(514570, 128, '2014-02-01 00:21:12.000000', 'consum', 0.0218, 'lps'),
	(514571, 128, '2014-02-01 00:21:13.000000', 'consum', 0.0220, 'lps'),
	(514572, 128, '2014-02-01 00:21:14.000000', 'consum', 0.0221, 'lps'),
	(514573, 128, '2014-02-01 00:21:15.000000', 'consum', 0.0221, 'lps'),
	(514574, 128, '2014-02-01 00:21:16.000000', 'consum', 0.0221, 'lps'),
	(514575, 128, '2014-02-01 00:21:17.000000', 'consum', 0.0219, 'lps'),
	(514576, 128, '2014-02-01 00:21:18.000000', 'consum', 0.0220, 'lps'),
	(514577, 128, '2014-02-01 00:21:19.000000', 'consum', 0.0220, 'lps'),
	(514578, 128, '2014-02-01 00:21:20.000000', 'consum', 0.0218, 'lps'),
	(514579, 128, '2014-02-01 00:21:21.000000', 'consum', 0.0221, 'lps'),
	(514580, 128, '2014-02-01 00:21:22.000000', 'consum', 0.0212, 'lps'),
	(514581, 128, '2014-02-01 00:21:23.000000', 'consum', 0.0214, 'lps'),
	(514582, 128, '2014-02-01 00:21:24.000000', 'consum', 0.0212, 'lps'),
	(514583, 128, '2014-02-01 00:21:25.000000', 'consum', 0.0210, 'lps'),
	(514584, 128, '2014-02-01 00:21:26.000000', 'consum', 0.0215, 'lps'),
	(514585, 128, '2014-02-01 00:21:27.000000', 'consum', 0.0211, 'lps'),
	(514586, 128, '2014-02-01 00:21:28.000000', 'consum', 0.0212, 'lps'),
	(514587, 128, '2014-02-01 00:21:29.000000', 'consum', 0.0216, 'lps'),
	(514588, 128, '2014-02-01 00:21:30.000000', 'consum', 0.0210, 'lps'),
	(514589, 128, '2014-02-01 00:21:31.000000', 'consum', 0.0217, 'lps'),
	(514590, 128, '2014-02-01 00:21:32.000000', 'consum', 0.0221, 'lps'),
	(514591, 128, '2014-02-01 00:21:33.000000', 'consum', 0.0213, 'lps'),
	(514592, 128, '2014-02-01 00:21:34.000000', 'consum', 0.0223, 'lps'),
	(514593, 128, '2014-02-01 00:21:35.000000', 'consum', 0.0223, 'lps'),
	(514594, 128, '2014-02-01 00:21:36.000000', 'consum', 0.0211, 'lps'),
	(514595, 128, '2014-02-01 00:21:37.000000', 'consum', 0.0217, 'lps'),
	(514596, 128, '2014-02-01 00:21:38.000000', 'consum', 0.0214, 'lps'),
	(514597, 128, '2014-02-01 00:21:39.000000', 'consum', 0.0223, 'lps'),
	(514598, 128, '2014-02-01 00:21:40.000000', 'consum', 0.0221, 'lps'),
	(514599, 128, '2014-02-01 00:21:41.000000', 'consum', 0.0214, 'lps'),
	(514600, 128, '2014-02-01 00:21:42.000000', 'consum', 0.0223, 'lps'),
	(514601, 128, '2014-02-01 00:21:43.000000', 'consum', 0.0210, 'lps'),
	(514602, 128, '2014-02-01 00:21:44.000000', 'consum', 0.0214, 'lps'),
	(514603, 128, '2014-02-01 00:21:45.000000', 'consum', 0.0216, 'lps'),
	(514604, 128, '2014-02-01 00:21:46.000000', 'consum', 0.0215, 'lps'),
	(514605, 128, '2014-02-01 00:21:47.000000', 'consum', 0.0218, 'lps'),
	(514606, 128, '2014-02-01 00:21:48.000000', 'consum', 0.0221, 'lps'),
	(514607, 128, '2014-02-01 00:21:49.000000', 'consum', 0.0213, 'lps'),
	(514608, 128, '2014-02-01 00:21:50.000000', 'consum', 0.0222, 'lps'),
	(514609, 128, '2014-02-01 00:21:51.000000', 'consum', 0.0220, 'lps'),
	(514610, 128, '2014-02-01 00:21:52.000000', 'consum', 0.0211, 'lps'),
	(514611, 128, '2014-02-01 00:21:53.000000', 'consum', 0.0213, 'lps'),
	(514612, 128, '2014-02-01 00:21:54.000000', 'consum', 0.0220, 'lps'),
	(514613, 128, '2014-02-01 00:21:55.000000', 'consum', 0.0213, 'lps'),
	(514614, 128, '2014-02-01 00:21:56.000000', 'consum', 0.0222, 'lps'),
	(514615, 128, '2014-02-01 00:21:57.000000', 'consum', 0.0218, 'lps'),
	(514616, 128, '2014-02-01 00:21:58.000000', 'consum', 0.0214, 'lps'),
	(514617, 128, '2014-02-01 00:21:59.000000', 'consum', 0.0223, 'lps'),
	(514618, 128, '2014-02-01 00:22:00.000000', 'consum', 0.0222, 'lps'),
	(514619, 128, '2014-02-01 00:22:01.000000', 'consum', 0.0215, 'lps'),
	(514620, 128, '2014-02-01 00:22:02.000000', 'consum', 0.0213, 'lps'),
	(514621, 128, '2014-02-01 00:22:03.000000', 'consum', 0.0210, 'lps'),
	(514622, 128, '2014-02-01 00:22:04.000000', 'consum', 0.0218, 'lps'),
	(514623, 128, '2014-02-01 00:22:05.000000', 'consum', 0.0219, 'lps'),
	(514624, 128, '2014-02-01 00:22:06.000000', 'consum', 0.0221, 'lps'),
	(514625, 128, '2014-02-01 00:22:07.000000', 'consum', 0.0223, 'lps'),
	(514626, 128, '2014-02-01 00:22:08.000000', 'consum', 0.0214, 'lps'),
	(514627, 128, '2014-02-01 00:22:09.000000', 'consum', 0.0218, 'lps'),
	(514628, 128, '2014-02-01 00:22:10.000000', 'consum', 0.0214, 'lps'),
	(514629, 128, '2014-02-01 00:22:11.000000', 'consum', 0.0218, 'lps'),
	(514630, 128, '2014-02-01 00:22:12.000000', 'consum', 0.0213, 'lps'),
	(514631, 128, '2014-02-01 00:22:13.000000', 'consum', 0.0214, 'lps'),
	(514632, 128, '2014-02-01 00:22:14.000000', 'consum', 0.0210, 'lps'),
	(514633, 128, '2014-02-01 00:22:15.000000', 'consum', 0.0210, 'lps'),
	(514634, 128, '2014-02-01 00:22:16.000000', 'consum', 0.0211, 'lps'),
	(514635, 128, '2014-02-01 00:22:17.000000', 'consum', 0.0216, 'lps'),
	(514636, 128, '2014-02-01 00:22:18.000000', 'consum', 0.0210, 'lps'),
	(514637, 128, '2014-02-01 00:22:19.000000', 'consum', 0.0218, 'lps'),
	(514638, 128, '2014-02-01 00:22:20.000000', 'consum', 0.0210, 'lps'),
	(514639, 128, '2014-02-01 00:22:21.000000', 'consum', 0.0214, 'lps'),
	(514640, 128, '2014-02-01 00:22:22.000000', 'consum', 0.0215, 'lps'),
	(514641, 128, '2014-02-01 00:22:23.000000', 'consum', 0.0210, 'lps'),
	(514642, 128, '2014-02-01 00:22:24.000000', 'consum', 0.0222, 'lps'),
	(514643, 128, '2014-02-01 00:22:25.000000', 'consum', 0.0218, 'lps'),
	(514644, 128, '2014-02-01 00:22:26.000000', 'consum', 0.0212, 'lps'),
	(514645, 128, '2014-02-01 00:22:27.000000', 'consum', 0.0210, 'lps'),
	(514646, 128, '2014-02-01 00:22:28.000000', 'consum', 0.0221, 'lps'),
	(514647, 128, '2014-02-01 00:22:29.000000', 'consum', 0.0221, 'lps'),
	(514648, 128, '2014-02-01 00:22:30.000000', 'consum', 0.0221, 'lps'),
	(514649, 128, '2014-02-01 00:22:31.000000', 'consum', 0.0216, 'lps'),
	(514650, 128, '2014-02-01 00:22:32.000000', 'consum', 0.0222, 'lps'),
	(514651, 128, '2014-02-01 00:22:33.000000', 'consum', 0.0211, 'lps'),
	(514652, 128, '2014-02-01 00:22:34.000000', 'consum', 0.0210, 'lps'),
	(514653, 128, '2014-02-01 00:22:35.000000', 'consum', 0.0218, 'lps'),
	(514654, 128, '2014-02-01 00:22:36.000000', 'consum', 0.0222, 'lps'),
	(514655, 128, '2014-02-01 00:22:37.000000', 'consum', 0.0221, 'lps'),
	(514656, 128, '2014-02-01 00:22:38.000000', 'consum', 0.0214, 'lps'),
	(514657, 128, '2014-02-01 00:22:39.000000', 'consum', 0.0212, 'lps'),
	(514658, 128, '2014-02-01 00:22:40.000000', 'consum', 0.0210, 'lps'),
	(514659, 128, '2014-02-01 00:22:41.000000', 'consum', 0.0218, 'lps'),
	(514660, 128, '2014-02-01 00:22:42.000000', 'consum', 0.0221, 'lps'),
	(514661, 128, '2014-02-01 00:22:43.000000', 'consum', 0.0214, 'lps'),
	(514662, 128, '2014-02-01 00:22:44.000000', 'consum', 0.0210, 'lps'),
	(514663, 128, '2014-02-01 00:22:45.000000', 'consum', 0.0215, 'lps'),
	(514664, 128, '2014-02-01 00:22:46.000000', 'consum', 0.0223, 'lps'),
	(514665, 128, '2014-02-01 00:22:47.000000', 'consum', 0.0215, 'lps'),
	(514666, 128, '2014-02-01 00:22:48.000000', 'consum', 0.0211, 'lps'),
	(514667, 128, '2014-02-01 00:22:49.000000', 'consum', 0.0217, 'lps'),
	(514668, 128, '2014-02-01 00:22:50.000000', 'consum', 0.0211, 'lps'),
	(514669, 128, '2014-02-01 00:22:51.000000', 'consum', 0.0211, 'lps'),
	(514670, 128, '2014-02-01 00:22:52.000000', 'consum', 0.0212, 'lps'),
	(514671, 128, '2014-02-01 00:22:53.000000', 'consum', 0.0217, 'lps'),
	(514672, 128, '2014-02-01 00:22:54.000000', 'consum', 0.0212, 'lps'),
	(514673, 128, '2014-02-01 00:22:55.000000', 'consum', 0.0215, 'lps'),
	(514674, 128, '2014-02-01 00:22:56.000000', 'consum', 0.0214, 'lps'),
	(514675, 128, '2014-02-01 00:22:57.000000', 'consum', 0.0215, 'lps'),
	(514676, 128, '2014-02-01 00:22:58.000000', 'consum', 0.0223, 'lps'),
	(514677, 128, '2014-02-01 00:22:59.000000', 'consum', 0.0218, 'lps'),
	(514678, 128, '2014-02-01 00:23:00.000000', 'consum', 0.0214, 'lps'),
	(514679, 128, '2014-02-01 00:23:01.000000', 'consum', 0.0217, 'lps'),
	(514680, 128, '2014-02-01 00:23:02.000000', 'consum', 0.0223, 'lps'),
	(514681, 128, '2014-02-01 00:23:03.000000', 'consum', 0.0210, 'lps'),
	(514682, 128, '2014-02-01 00:23:04.000000', 'consum', 0.0213, 'lps'),
	(514683, 128, '2014-02-01 00:23:05.000000', 'consum', 0.0211, 'lps'),
	(514684, 128, '2014-02-01 00:23:06.000000', 'consum', 0.0221, 'lps'),
	(514685, 128, '2014-02-01 00:23:07.000000', 'consum', 0.0220, 'lps'),
	(514686, 128, '2014-02-01 00:23:08.000000', 'consum', 0.0215, 'lps'),
	(514687, 128, '2014-02-01 00:23:09.000000', 'consum', 0.0218, 'lps'),
	(514688, 128, '2014-02-01 00:23:10.000000', 'consum', 0.0221, 'lps'),
	(514689, 128, '2014-02-01 00:23:11.000000', 'consum', 0.0215, 'lps'),
	(514690, 128, '2014-02-01 00:23:12.000000', 'consum', 0.0217, 'lps'),
	(514691, 128, '2014-02-01 00:23:13.000000', 'consum', 0.0217, 'lps'),
	(514692, 128, '2014-02-01 00:23:14.000000', 'consum', 0.0210, 'lps'),
	(514693, 128, '2014-02-01 00:23:15.000000', 'consum', 0.0219, 'lps'),
	(514694, 128, '2014-02-01 00:23:16.000000', 'consum', 0.0210, 'lps'),
	(514695, 128, '2014-02-01 00:23:17.000000', 'consum', 0.0215, 'lps'),
	(514696, 128, '2014-02-01 00:23:18.000000', 'consum', 0.0219, 'lps'),
	(514697, 128, '2014-02-01 00:23:19.000000', 'consum', 0.0213, 'lps'),
	(514698, 128, '2014-02-01 00:23:20.000000', 'consum', 0.0211, 'lps'),
	(514699, 128, '2014-02-01 00:23:21.000000', 'consum', 0.0220, 'lps'),
	(514700, 128, '2014-02-01 00:23:22.000000', 'consum', 0.0218, 'lps'),
	(514701, 128, '2014-02-01 00:23:23.000000', 'consum', 0.0219, 'lps'),
	(514702, 128, '2014-02-01 00:23:24.000000', 'consum', 0.0217, 'lps'),
	(514703, 128, '2014-02-01 00:23:25.000000', 'consum', 0.0217, 'lps'),
	(514704, 128, '2014-02-01 00:23:26.000000', 'consum', 0.0214, 'lps'),
	(514705, 128, '2014-02-01 00:23:27.000000', 'consum', 0.0221, 'lps'),
	(514706, 128, '2014-02-01 00:23:28.000000', 'consum', 0.0213, 'lps'),
	(514707, 128, '2014-02-01 00:23:29.000000', 'consum', 0.0220, 'lps'),
	(514708, 128, '2014-02-01 00:23:30.000000', 'consum', 0.0210, 'lps'),
	(514709, 128, '2014-02-01 00:23:31.000000', 'consum', 0.0223, 'lps'),
	(514710, 128, '2014-02-01 00:23:32.000000', 'consum', 0.0220, 'lps'),
	(514711, 128, '2014-02-01 00:23:33.000000', 'consum', 0.0223, 'lps'),
	(514712, 128, '2014-02-01 00:23:34.000000', 'consum', 0.0215, 'lps'),
	(514713, 128, '2014-02-01 00:23:35.000000', 'consum', 0.0223, 'lps'),
	(514714, 128, '2014-02-01 00:23:36.000000', 'consum', 0.0221, 'lps'),
	(514715, 128, '2014-02-01 00:23:37.000000', 'consum', 0.0212, 'lps'),
	(514716, 128, '2014-02-01 00:23:38.000000', 'consum', 0.0215, 'lps'),
	(514717, 128, '2014-02-01 00:23:39.000000', 'consum', 0.0215, 'lps'),
	(514718, 128, '2014-02-01 00:23:40.000000', 'consum', 0.0221, 'lps'),
	(514719, 128, '2014-02-01 00:23:41.000000', 'consum', 0.0221, 'lps'),
	(514720, 128, '2014-02-01 00:23:42.000000', 'consum', 0.0220, 'lps'),
	(514721, 128, '2014-02-01 00:23:43.000000', 'consum', 0.0212, 'lps'),
	(514722, 128, '2014-02-01 00:23:44.000000', 'consum', 0.0218, 'lps'),
	(514723, 128, '2014-02-01 00:23:45.000000', 'consum', 0.0217, 'lps'),
	(514724, 128, '2014-02-01 00:23:46.000000', 'consum', 0.0221, 'lps'),
	(514725, 128, '2014-02-01 00:23:47.000000', 'consum', 0.0219, 'lps'),
	(514726, 128, '2014-02-01 00:23:48.000000', 'consum', 0.0219, 'lps'),
	(514727, 128, '2014-02-01 00:23:49.000000', 'consum', 0.0217, 'lps'),
	(514728, 128, '2014-02-01 00:23:50.000000', 'consum', 0.0217, 'lps'),
	(514729, 128, '2014-02-01 00:23:51.000000', 'consum', 0.0212, 'lps'),
	(514730, 128, '2014-02-01 00:23:52.000000', 'consum', 0.0214, 'lps'),
	(514731, 128, '2014-02-01 00:23:53.000000', 'consum', 0.0223, 'lps'),
	(514732, 128, '2014-02-01 00:23:54.000000', 'consum', 0.0221, 'lps'),
	(514733, 128, '2014-02-01 00:23:55.000000', 'consum', 0.0213, 'lps'),
	(514734, 128, '2014-02-01 00:23:56.000000', 'consum', 0.0221, 'lps'),
	(514735, 128, '2014-02-01 00:23:57.000000', 'consum', 0.0215, 'lps'),
	(514736, 128, '2014-02-01 00:23:58.000000', 'consum', 0.0215, 'lps'),
	(514737, 128, '2014-02-01 00:23:59.000000', 'consum', 0.0223, 'lps'),
	(514738, 128, '2014-02-01 00:24:00.000000', 'consum', 0.0218, 'lps'),
	(514739, 128, '2014-02-01 00:24:01.000000', 'consum', 0.0212, 'lps'),
	(514740, 128, '2014-02-01 00:24:02.000000', 'consum', 0.0222, 'lps'),
	(514741, 128, '2014-02-01 00:24:03.000000', 'consum', 0.0210, 'lps'),
	(514742, 128, '2014-02-01 00:24:04.000000', 'consum', 0.0216, 'lps'),
	(514743, 128, '2014-02-01 00:24:05.000000', 'consum', 0.0214, 'lps'),
	(514744, 128, '2014-02-01 00:24:06.000000', 'consum', 0.0211, 'lps'),
	(514745, 128, '2014-02-01 00:24:07.000000', 'consum', 0.0217, 'lps'),
	(514746, 128, '2014-02-01 00:24:08.000000', 'consum', 0.0213, 'lps'),
	(514747, 128, '2014-02-01 00:24:09.000000', 'consum', 0.0221, 'lps'),
	(514748, 128, '2014-02-01 00:24:10.000000', 'consum', 0.0215, 'lps'),
	(514749, 128, '2014-02-01 00:24:11.000000', 'consum', 0.0215, 'lps'),
	(514750, 128, '2014-02-01 00:24:12.000000', 'consum', 0.0221, 'lps'),
	(514751, 128, '2014-02-01 00:24:13.000000', 'consum', 0.0210, 'lps'),
	(514752, 128, '2014-02-01 00:24:14.000000', 'consum', 0.0217, 'lps'),
	(514753, 128, '2014-02-01 00:24:15.000000', 'consum', 0.0217, 'lps'),
	(514754, 128, '2014-02-01 00:24:16.000000', 'consum', 0.0211, 'lps'),
	(514755, 128, '2014-02-01 00:24:17.000000', 'consum', 0.0210, 'lps'),
	(514756, 128, '2014-02-01 00:24:18.000000', 'consum', 0.0222, 'lps'),
	(514757, 128, '2014-02-01 00:24:19.000000', 'consum', 0.0213, 'lps'),
	(514758, 128, '2014-02-01 00:24:20.000000', 'consum', 0.0216, 'lps'),
	(514759, 128, '2014-02-01 00:24:21.000000', 'consum', 0.0220, 'lps'),
	(514760, 128, '2014-02-01 00:24:22.000000', 'consum', 0.0214, 'lps'),
	(514761, 128, '2014-02-01 00:24:23.000000', 'consum', 0.0216, 'lps'),
	(514762, 128, '2014-02-01 00:24:24.000000', 'consum', 0.0212, 'lps'),
	(514763, 128, '2014-02-01 00:24:25.000000', 'consum', 0.0218, 'lps'),
	(514764, 128, '2014-02-01 00:24:26.000000', 'consum', 0.0218, 'lps'),
	(514765, 128, '2014-02-01 00:24:27.000000', 'consum', 0.0210, 'lps'),
	(514766, 128, '2014-02-01 00:24:28.000000', 'consum', 0.0217, 'lps'),
	(514767, 128, '2014-02-01 00:24:29.000000', 'consum', 0.0217, 'lps'),
	(514768, 128, '2014-02-01 00:24:30.000000', 'consum', 0.0211, 'lps'),
	(514769, 128, '2014-02-01 00:24:31.000000', 'consum', 0.0210, 'lps'),
	(514770, 128, '2014-02-01 00:24:32.000000', 'consum', 0.0220, 'lps'),
	(514771, 128, '2014-02-01 00:24:33.000000', 'consum', 0.0217, 'lps'),
	(514772, 128, '2014-02-01 00:24:34.000000', 'consum', 0.0218, 'lps'),
	(514773, 128, '2014-02-01 00:24:35.000000', 'consum', 0.0215, 'lps'),
	(514774, 128, '2014-02-01 00:24:36.000000', 'consum', 0.0210, 'lps'),
	(514775, 128, '2014-02-01 00:24:37.000000', 'consum', 0.0223, 'lps'),
	(514776, 128, '2014-02-01 00:24:38.000000', 'consum', 0.0222, 'lps'),
	(514777, 128, '2014-02-01 00:24:39.000000', 'consum', 0.0218, 'lps'),
	(514778, 128, '2014-02-01 00:24:40.000000', 'consum', 0.0213, 'lps'),
	(514779, 128, '2014-02-01 00:24:41.000000', 'consum', 0.0215, 'lps'),
	(514780, 128, '2014-02-01 00:24:42.000000', 'consum', 0.0212, 'lps'),
	(514781, 128, '2014-02-01 00:24:43.000000', 'consum', 0.0219, 'lps'),
	(514782, 128, '2014-02-01 00:24:44.000000', 'consum', 0.0222, 'lps'),
	(514783, 128, '2014-02-01 00:24:45.000000', 'consum', 0.0216, 'lps'),
	(514784, 128, '2014-02-01 00:24:46.000000', 'consum', 0.0217, 'lps'),
	(514785, 128, '2014-02-01 00:24:47.000000', 'consum', 0.0216, 'lps'),
	(514786, 128, '2014-02-01 00:24:48.000000', 'consum', 0.0218, 'lps'),
	(514787, 128, '2014-02-01 00:24:49.000000', 'consum', 0.0219, 'lps'),
	(514788, 128, '2014-02-01 00:24:50.000000', 'consum', 0.0217, 'lps'),
	(514789, 128, '2014-02-01 00:24:51.000000', 'consum', 0.0217, 'lps'),
	(514790, 128, '2014-02-01 00:24:52.000000', 'consum', 0.0211, 'lps'),
	(514791, 128, '2014-02-01 00:24:53.000000', 'consum', 0.0221, 'lps'),
	(514792, 128, '2014-02-01 00:24:54.000000', 'consum', 0.0222, 'lps'),
	(514793, 128, '2014-02-01 00:24:55.000000', 'consum', 0.0223, 'lps'),
	(514794, 128, '2014-02-01 00:24:56.000000', 'consum', 0.0211, 'lps'),
	(514795, 128, '2014-02-01 00:24:57.000000', 'consum', 0.0219, 'lps'),
	(514796, 128, '2014-02-01 00:24:58.000000', 'consum', 0.0210, 'lps'),
	(514797, 128, '2014-02-01 00:24:59.000000', 'consum', 0.0210, 'lps'),
	(514798, 128, '2014-02-01 00:25:00.000000', 'consum', 0.0211, 'lps'),
	(514799, 128, '2014-02-01 00:25:01.000000', 'consum', 0.0216, 'lps'),
	(514800, 128, '2014-02-01 00:25:02.000000', 'consum', 0.0211, 'lps'),
	(514801, 128, '2014-02-01 00:25:03.000000', 'consum', 0.0212, 'lps'),
	(514802, 128, '2014-02-01 00:25:04.000000', 'consum', 0.0217, 'lps'),
	(514803, 128, '2014-02-01 00:25:05.000000', 'consum', 0.0211, 'lps'),
	(514804, 128, '2014-02-01 00:25:06.000000', 'consum', 0.0222, 'lps'),
	(514805, 128, '2014-02-01 00:25:07.000000', 'consum', 0.0211, 'lps'),
	(514806, 128, '2014-02-01 00:25:08.000000', 'consum', 0.0221, 'lps'),
	(514807, 128, '2014-02-01 00:25:09.000000', 'consum', 0.0220, 'lps'),
	(514808, 128, '2014-02-01 00:25:10.000000', 'consum', 0.0212, 'lps'),
	(514809, 128, '2014-02-01 00:25:11.000000', 'consum', 0.0222, 'lps'),
	(514810, 128, '2014-02-01 00:25:12.000000', 'consum', 0.0220, 'lps'),
	(514811, 128, '2014-02-01 00:25:13.000000', 'consum', 0.0210, 'lps'),
	(514812, 128, '2014-02-01 00:25:14.000000', 'consum', 0.0211, 'lps'),
	(514813, 128, '2014-02-01 00:25:15.000000', 'consum', 0.0213, 'lps'),
	(514814, 128, '2014-02-01 00:25:16.000000', 'consum', 0.0211, 'lps'),
	(514815, 128, '2014-02-01 00:25:17.000000', 'consum', 0.0220, 'lps'),
	(514816, 128, '2014-02-01 00:25:18.000000', 'consum', 0.0216, 'lps'),
	(514817, 128, '2014-02-01 00:25:19.000000', 'consum', 0.0222, 'lps'),
	(514818, 128, '2014-02-01 00:25:20.000000', 'consum', 0.0211, 'lps'),
	(514819, 128, '2014-02-01 00:25:21.000000', 'consum', 0.0223, 'lps'),
	(514820, 128, '2014-02-01 00:25:22.000000', 'consum', 0.0218, 'lps'),
	(514821, 128, '2014-02-01 00:25:23.000000', 'consum', 0.0223, 'lps'),
	(514822, 128, '2014-02-01 00:25:24.000000', 'consum', 0.0211, 'lps'),
	(514823, 128, '2014-02-01 00:25:25.000000', 'consum', 0.0219, 'lps'),
	(514824, 128, '2014-02-01 00:25:26.000000', 'consum', 0.0211, 'lps'),
	(514825, 128, '2014-02-01 00:25:27.000000', 'consum', 0.0216, 'lps'),
	(514826, 128, '2014-02-01 00:25:28.000000', 'consum', 0.0210, 'lps'),
	(514827, 128, '2014-02-01 00:25:29.000000', 'consum', 0.0221, 'lps'),
	(514828, 128, '2014-02-01 00:25:30.000000', 'consum', 0.0210, 'lps'),
	(514829, 128, '2014-02-01 00:25:31.000000', 'consum', 0.0217, 'lps'),
	(514830, 128, '2014-02-01 00:25:32.000000', 'consum', 0.0220, 'lps'),
	(514831, 128, '2014-02-01 00:25:33.000000', 'consum', 0.0211, 'lps'),
	(514832, 128, '2014-02-01 00:25:34.000000', 'consum', 0.0213, 'lps'),
	(514833, 128, '2014-02-01 00:25:35.000000', 'consum', 0.0223, 'lps'),
	(514834, 128, '2014-02-01 00:25:36.000000', 'consum', 0.0211, 'lps'),
	(514835, 128, '2014-02-01 00:25:37.000000', 'consum', 0.0219, 'lps'),
	(514836, 128, '2014-02-01 00:25:38.000000', 'consum', 0.0222, 'lps'),
	(514837, 128, '2014-02-01 00:25:39.000000', 'consum', 0.0217, 'lps'),
	(514838, 128, '2014-02-01 00:25:40.000000', 'consum', 0.0210, 'lps'),
	(514839, 128, '2014-02-01 00:25:41.000000', 'consum', 0.0218, 'lps'),
	(514840, 128, '2014-02-01 00:25:42.000000', 'consum', 0.0222, 'lps'),
	(514841, 128, '2014-02-01 00:25:43.000000', 'consum', 0.0219, 'lps'),
	(514842, 128, '2014-02-01 00:25:44.000000', 'consum', 0.0220, 'lps'),
	(514843, 128, '2014-02-01 00:25:45.000000', 'consum', 0.0219, 'lps'),
	(514844, 128, '2014-02-01 00:25:46.000000', 'consum', 0.0213, 'lps'),
	(514845, 128, '2014-02-01 00:25:47.000000', 'consum', 0.0211, 'lps'),
	(514846, 128, '2014-02-01 00:25:48.000000', 'consum', 0.0221, 'lps'),
	(514847, 128, '2014-02-01 00:25:49.000000', 'consum', 0.0220, 'lps'),
	(514848, 128, '2014-02-01 00:25:50.000000', 'consum', 0.0212, 'lps'),
	(514849, 128, '2014-02-01 00:25:51.000000', 'consum', 0.0219, 'lps'),
	(514850, 128, '2014-02-01 00:25:52.000000', 'consum', 0.0210, 'lps'),
	(514851, 128, '2014-02-01 00:25:53.000000', 'consum', 0.0222, 'lps'),
	(514852, 128, '2014-02-01 00:25:54.000000', 'consum', 0.0216, 'lps'),
	(514853, 128, '2014-02-01 00:25:55.000000', 'consum', 0.0220, 'lps'),
	(514854, 128, '2014-02-01 00:25:56.000000', 'consum', 0.0214, 'lps'),
	(514855, 128, '2014-02-01 00:25:57.000000', 'consum', 0.0214, 'lps'),
	(514856, 128, '2014-02-01 00:25:58.000000', 'consum', 0.0218, 'lps'),
	(514857, 128, '2014-02-01 00:25:59.000000', 'consum', 0.0212, 'lps'),
	(514858, 128, '2014-02-01 00:26:00.000000', 'consum', 0.0210, 'lps'),
	(514859, 128, '2014-02-01 00:26:01.000000', 'consum', 0.0220, 'lps'),
	(514860, 128, '2014-02-01 00:26:02.000000', 'consum', 0.0216, 'lps'),
	(514861, 128, '2014-02-01 00:26:03.000000', 'consum', 0.0210, 'lps'),
	(514862, 128, '2014-02-01 00:26:04.000000', 'consum', 0.0222, 'lps'),
	(514863, 128, '2014-02-01 00:26:05.000000', 'consum', 0.0214, 'lps'),
	(514864, 128, '2014-02-01 00:26:06.000000', 'consum', 0.0222, 'lps'),
	(514865, 128, '2014-02-01 00:26:07.000000', 'consum', 0.0215, 'lps'),
	(514866, 128, '2014-02-01 00:26:08.000000', 'consum', 0.0215, 'lps'),
	(514867, 128, '2014-02-01 00:26:09.000000', 'consum', 0.0220, 'lps'),
	(514868, 128, '2014-02-01 00:26:10.000000', 'consum', 0.0219, 'lps'),
	(514869, 128, '2014-02-01 00:26:11.000000', 'consum', 0.0212, 'lps'),
	(514870, 128, '2014-02-01 00:26:12.000000', 'consum', 0.0221, 'lps'),
	(514871, 128, '2014-02-01 00:26:13.000000', 'consum', 0.0215, 'lps'),
	(514872, 128, '2014-02-01 00:26:14.000000', 'consum', 0.0219, 'lps'),
	(514873, 128, '2014-02-01 00:26:15.000000', 'consum', 0.0214, 'lps'),
	(514874, 128, '2014-02-01 00:26:16.000000', 'consum', 0.0214, 'lps'),
	(514875, 128, '2014-02-01 00:26:17.000000', 'consum', 0.0221, 'lps'),
	(514876, 128, '2014-02-01 00:26:18.000000', 'consum', 0.0210, 'lps'),
	(514877, 128, '2014-02-01 00:26:19.000000', 'consum', 0.0221, 'lps'),
	(514878, 128, '2014-02-01 00:26:20.000000', 'consum', 0.0222, 'lps'),
	(514879, 128, '2014-02-01 00:26:21.000000', 'consum', 0.0210, 'lps'),
	(514880, 128, '2014-02-01 00:26:22.000000', 'consum', 0.0215, 'lps'),
	(514881, 128, '2014-02-01 00:26:23.000000', 'consum', 0.0223, 'lps'),
	(514882, 128, '2014-02-01 00:26:24.000000', 'consum', 0.0220, 'lps'),
	(514883, 128, '2014-02-01 00:26:25.000000', 'consum', 0.0219, 'lps'),
	(514884, 128, '2014-02-01 00:26:26.000000', 'consum', 0.0213, 'lps'),
	(514885, 128, '2014-02-01 00:26:27.000000', 'consum', 0.0210, 'lps'),
	(514886, 128, '2014-02-01 00:26:28.000000', 'consum', 0.0217, 'lps'),
	(514887, 128, '2014-02-01 00:26:29.000000', 'consum', 0.0216, 'lps'),
	(514888, 128, '2014-02-01 00:26:30.000000', 'consum', 0.0220, 'lps'),
	(514889, 128, '2014-02-01 00:26:31.000000', 'consum', 0.0213, 'lps'),
	(514890, 128, '2014-02-01 00:26:32.000000', 'consum', 0.0210, 'lps'),
	(514891, 128, '2014-02-01 00:26:33.000000', 'consum', 0.0214, 'lps'),
	(514892, 128, '2014-02-01 00:26:34.000000', 'consum', 0.0220, 'lps'),
	(514893, 128, '2014-02-01 00:26:35.000000', 'consum', 0.0218, 'lps'),
	(514894, 128, '2014-02-01 00:26:36.000000', 'consum', 0.0222, 'lps'),
	(514895, 128, '2014-02-01 00:26:37.000000', 'consum', 0.0217, 'lps'),
	(514896, 128, '2014-02-01 00:26:38.000000', 'consum', 0.0223, 'lps'),
	(514897, 128, '2014-02-01 00:26:39.000000', 'consum', 0.0213, 'lps'),
	(514898, 128, '2014-02-01 00:26:40.000000', 'consum', 0.0217, 'lps'),
	(514899, 128, '2014-02-01 00:26:41.000000', 'consum', 0.0220, 'lps'),
	(514900, 128, '2014-02-01 00:26:42.000000', 'consum', 0.0211, 'lps'),
	(514901, 128, '2014-02-01 00:26:43.000000', 'consum', 0.0215, 'lps'),
	(514902, 128, '2014-02-01 00:26:44.000000', 'consum', 0.0218, 'lps'),
	(514903, 128, '2014-02-01 00:26:45.000000', 'consum', 0.0220, 'lps'),
	(514904, 128, '2014-02-01 00:26:46.000000', 'consum', 0.0223, 'lps'),
	(514905, 128, '2014-02-01 00:26:47.000000', 'consum', 0.0218, 'lps'),
	(514906, 128, '2014-02-01 00:26:48.000000', 'consum', 0.0212, 'lps'),
	(514907, 128, '2014-02-01 00:26:49.000000', 'consum', 0.0223, 'lps'),
	(514908, 128, '2014-02-01 00:26:50.000000', 'consum', 0.0213, 'lps'),
	(514909, 128, '2014-02-01 00:26:51.000000', 'consum', 0.0217, 'lps'),
	(514910, 128, '2014-02-01 00:26:52.000000', 'consum', 0.0222, 'lps'),
	(514911, 128, '2014-02-01 00:26:53.000000', 'consum', 0.0219, 'lps'),
	(514912, 128, '2014-02-01 00:26:54.000000', 'consum', 0.0222, 'lps'),
	(514913, 128, '2014-02-01 00:26:55.000000', 'consum', 0.0215, 'lps'),
	(514914, 128, '2014-02-01 00:26:56.000000', 'consum', 0.0215, 'lps'),
	(514915, 128, '2014-02-01 00:26:57.000000', 'consum', 0.0219, 'lps'),
	(514916, 128, '2014-02-01 00:26:58.000000', 'consum', 0.0214, 'lps'),
	(514917, 128, '2014-02-01 00:26:59.000000', 'consum', 0.0216, 'lps'),
	(514918, 128, '2014-02-01 00:27:00.000000', 'consum', 0.0216, 'lps'),
	(514919, 128, '2014-02-01 00:27:01.000000', 'consum', 0.0223, 'lps'),
	(514920, 128, '2014-02-01 00:27:02.000000', 'consum', 0.0216, 'lps'),
	(514921, 128, '2014-02-01 00:27:03.000000', 'consum', 0.0213, 'lps'),
	(514922, 128, '2014-02-01 00:27:04.000000', 'consum', 0.0211, 'lps'),
	(514923, 128, '2014-02-01 00:27:05.000000', 'consum', 0.0217, 'lps'),
	(514924, 128, '2014-02-01 00:27:06.000000', 'consum', 0.0218, 'lps'),
	(514925, 128, '2014-02-01 00:27:07.000000', 'consum', 0.0213, 'lps'),
	(514926, 128, '2014-02-01 00:27:08.000000', 'consum', 0.0217, 'lps'),
	(514927, 128, '2014-02-01 00:27:09.000000', 'consum', 0.0223, 'lps'),
	(514928, 128, '2014-02-01 00:27:10.000000', 'consum', 0.0210, 'lps'),
	(514929, 128, '2014-02-01 00:27:11.000000', 'consum', 0.0213, 'lps'),
	(514930, 128, '2014-02-01 00:27:12.000000', 'consum', 0.0214, 'lps'),
	(514931, 128, '2014-02-01 00:27:13.000000', 'consum', 0.0220, 'lps'),
	(514932, 128, '2014-02-01 00:27:14.000000', 'consum', 0.0219, 'lps'),
	(514933, 128, '2014-02-01 00:27:15.000000', 'consum', 0.0215, 'lps'),
	(514934, 128, '2014-02-01 00:27:16.000000', 'consum', 0.0220, 'lps'),
	(514935, 128, '2014-02-01 00:27:17.000000', 'consum', 0.0220, 'lps'),
	(514936, 128, '2014-02-01 00:27:18.000000', 'consum', 0.0216, 'lps'),
	(514937, 128, '2014-02-01 00:27:19.000000', 'consum', 0.0223, 'lps'),
	(514938, 128, '2014-02-01 00:27:20.000000', 'consum', 0.0215, 'lps'),
	(514939, 128, '2014-02-01 00:27:21.000000', 'consum', 0.0211, 'lps'),
	(514940, 128, '2014-02-01 00:27:22.000000', 'consum', 0.0217, 'lps'),
	(514941, 128, '2014-02-01 00:27:23.000000', 'consum', 0.0211, 'lps'),
	(514942, 128, '2014-02-01 00:27:24.000000', 'consum', 0.0210, 'lps'),
	(514943, 128, '2014-02-01 00:27:25.000000', 'consum', 0.0222, 'lps'),
	(514944, 128, '2014-02-01 00:27:26.000000', 'consum', 0.0213, 'lps'),
	(514945, 128, '2014-02-01 00:27:27.000000', 'consum', 0.0218, 'lps'),
	(514946, 128, '2014-02-01 00:27:28.000000', 'consum', 0.0214, 'lps'),
	(514947, 128, '2014-02-01 00:27:29.000000', 'consum', 0.0218, 'lps'),
	(514948, 128, '2014-02-01 00:27:30.000000', 'consum', 0.0214, 'lps'),
	(514949, 128, '2014-02-01 00:27:31.000000', 'consum', 0.0218, 'lps'),
	(514950, 128, '2014-02-01 00:27:32.000000', 'consum', 0.0213, 'lps'),
	(514951, 128, '2014-02-01 00:27:33.000000', 'consum', 0.0214, 'lps'),
	(514952, 128, '2014-02-01 00:27:34.000000', 'consum', 0.0223, 'lps'),
	(514953, 128, '2014-02-01 00:27:35.000000', 'consum', 0.0219, 'lps'),
	(514954, 128, '2014-02-01 00:27:36.000000', 'consum', 0.0217, 'lps'),
	(514955, 128, '2014-02-01 00:27:37.000000', 'consum', 0.0219, 'lps'),
	(514956, 128, '2014-02-01 00:27:38.000000', 'consum', 0.0220, 'lps'),
	(514957, 128, '2014-02-01 00:27:39.000000', 'consum', 0.0222, 'lps'),
	(514958, 128, '2014-02-01 00:27:40.000000', 'consum', 0.0210, 'lps'),
	(514959, 128, '2014-02-01 00:27:41.000000', 'consum', 0.0219, 'lps'),
	(514960, 128, '2014-02-01 00:27:42.000000', 'consum', 0.0211, 'lps'),
	(514961, 128, '2014-02-01 00:27:43.000000', 'consum', 0.0216, 'lps'),
	(514962, 128, '2014-02-01 00:27:44.000000', 'consum', 0.0212, 'lps'),
	(514963, 128, '2014-02-01 00:27:45.000000', 'consum', 0.0215, 'lps'),
	(514964, 128, '2014-02-01 00:27:46.000000', 'consum', 0.0217, 'lps'),
	(514965, 128, '2014-02-01 00:27:47.000000', 'consum', 0.0217, 'lps'),
	(514966, 128, '2014-02-01 00:27:48.000000', 'consum', 0.0211, 'lps'),
	(514967, 128, '2014-02-01 00:27:49.000000', 'consum', 0.0222, 'lps'),
	(514968, 128, '2014-02-01 00:27:50.000000', 'consum', 0.0210, 'lps'),
	(514969, 128, '2014-02-01 00:27:51.000000', 'consum', 0.0215, 'lps'),
	(514970, 128, '2014-02-01 00:27:52.000000', 'consum', 0.0211, 'lps'),
	(514971, 128, '2014-02-01 00:27:53.000000', 'consum', 0.0212, 'lps'),
	(514972, 128, '2014-02-01 00:27:54.000000', 'consum', 0.0218, 'lps'),
	(514973, 128, '2014-02-01 00:27:55.000000', 'consum', 0.0217, 'lps'),
	(514974, 128, '2014-02-01 00:27:56.000000', 'consum', 0.0223, 'lps'),
	(514975, 128, '2014-02-01 00:27:57.000000', 'consum', 0.0212, 'lps'),
	(514976, 128, '2014-02-01 00:27:58.000000', 'consum', 0.0210, 'lps'),
	(514977, 128, '2014-02-01 00:27:59.000000', 'consum', 0.0219, 'lps'),
	(514978, 128, '2014-02-01 00:28:00.000000', 'consum', 0.0213, 'lps'),
	(514979, 128, '2014-02-01 00:28:01.000000', 'consum', 0.0213, 'lps'),
	(514980, 128, '2014-02-01 00:28:02.000000', 'consum', 0.0216, 'lps'),
	(514981, 128, '2014-02-01 00:28:03.000000', 'consum', 0.0216, 'lps'),
	(514982, 128, '2014-02-01 00:28:04.000000', 'consum', 0.0211, 'lps'),
	(514983, 128, '2014-02-01 00:28:05.000000', 'consum', 0.0212, 'lps'),
	(514984, 128, '2014-02-01 00:28:06.000000', 'consum', 0.0216, 'lps'),
	(514985, 128, '2014-02-01 00:28:07.000000', 'consum', 0.0222, 'lps'),
	(514986, 128, '2014-02-01 00:28:08.000000', 'consum', 0.0210, 'lps'),
	(514987, 128, '2014-02-01 00:28:09.000000', 'consum', 0.0215, 'lps'),
	(514988, 128, '2014-02-01 00:28:10.000000', 'consum', 0.0222, 'lps'),
	(514989, 128, '2014-02-01 00:28:11.000000', 'consum', 0.0213, 'lps'),
	(514990, 128, '2014-02-01 00:28:12.000000', 'consum', 0.0219, 'lps'),
	(514991, 128, '2014-02-01 00:28:13.000000', 'consum', 0.0217, 'lps'),
	(514992, 128, '2014-02-01 00:28:14.000000', 'consum', 0.0220, 'lps'),
	(514993, 128, '2014-02-01 00:28:15.000000', 'consum', 0.0211, 'lps'),
	(514994, 128, '2014-02-01 00:28:16.000000', 'consum', 0.0213, 'lps'),
	(514995, 128, '2014-02-01 00:28:17.000000', 'consum', 0.0223, 'lps'),
	(514996, 128, '2014-02-01 00:28:18.000000', 'consum', 0.0210, 'lps'),
	(514997, 128, '2014-02-01 00:28:19.000000', 'consum', 0.0214, 'lps'),
	(514998, 128, '2014-02-01 00:28:20.000000', 'consum', 0.0217, 'lps'),
	(514999, 128, '2014-02-01 00:28:21.000000', 'consum', 0.0220, 'lps'),
	(515000, 128, '2014-02-01 00:28:22.000000', 'consum', 0.0212, 'lps'),
	(515001, 128, '2014-02-01 00:28:23.000000', 'consum', 0.0217, 'lps'),
	(515002, 128, '2014-02-01 00:28:24.000000', 'consum', 0.0214, 'lps'),
	(515003, 128, '2014-02-01 00:28:25.000000', 'consum', 0.0221, 'lps'),
	(515004, 128, '2014-02-01 00:28:26.000000', 'consum', 0.0211, 'lps'),
	(515005, 128, '2014-02-01 00:28:27.000000', 'consum', 0.0211, 'lps'),
	(515006, 128, '2014-02-01 00:28:28.000000', 'consum', 0.0213, 'lps'),
	(515007, 128, '2014-02-01 00:28:29.000000', 'consum', 0.0223, 'lps'),
	(515008, 128, '2014-02-01 00:28:30.000000', 'consum', 0.0210, 'lps'),
	(515009, 128, '2014-02-01 00:28:31.000000', 'consum', 0.0213, 'lps'),
	(515010, 128, '2014-02-01 00:28:32.000000', 'consum', 0.0210, 'lps'),
	(515011, 128, '2014-02-01 00:28:33.000000', 'consum', 0.0218, 'lps'),
	(515012, 128, '2014-02-01 00:28:34.000000', 'consum', 0.0220, 'lps'),
	(515013, 128, '2014-02-01 00:28:35.000000', 'consum', 0.0222, 'lps'),
	(515014, 128, '2014-02-01 00:28:36.000000', 'consum', 0.0212, 'lps'),
	(515015, 128, '2014-02-01 00:28:37.000000', 'consum', 0.0213, 'lps'),
	(515016, 128, '2014-02-01 00:28:38.000000', 'consum', 0.0220, 'lps'),
	(515017, 128, '2014-02-01 00:28:39.000000', 'consum', 0.0212, 'lps'),
	(515018, 128, '2014-02-01 00:28:40.000000', 'consum', 0.0215, 'lps'),
	(515019, 128, '2014-02-01 00:28:41.000000', 'consum', 0.0216, 'lps'),
	(515020, 128, '2014-02-01 00:28:42.000000', 'consum', 0.0210, 'lps'),
	(515021, 128, '2014-02-01 00:28:43.000000', 'consum', 0.0222, 'lps'),
	(515022, 128, '2014-02-01 00:28:44.000000', 'consum', 0.0215, 'lps'),
	(515023, 128, '2014-02-01 00:28:45.000000', 'consum', 0.0214, 'lps'),
	(515024, 128, '2014-02-01 00:28:46.000000', 'consum', 0.0216, 'lps'),
	(515025, 128, '2014-02-01 00:28:47.000000', 'consum', 0.0212, 'lps'),
	(515026, 128, '2014-02-01 00:28:48.000000', 'consum', 0.0219, 'lps'),
	(515027, 128, '2014-02-01 00:28:49.000000', 'consum', 0.0222, 'lps'),
	(515028, 128, '2014-02-01 00:28:50.000000', 'consum', 0.0215, 'lps'),
	(515029, 128, '2014-02-01 00:28:51.000000', 'consum', 0.0214, 'lps'),
	(515030, 128, '2014-02-01 00:28:52.000000', 'consum', 0.0215, 'lps'),
	(515031, 128, '2014-02-01 00:28:53.000000', 'consum', 0.0222, 'lps'),
	(515032, 128, '2014-02-01 00:28:54.000000', 'consum', 0.0213, 'lps'),
	(515033, 128, '2014-02-01 00:28:55.000000', 'consum', 0.0218, 'lps'),
	(515034, 128, '2014-02-01 00:28:56.000000', 'consum', 0.0213, 'lps'),
	(515035, 128, '2014-02-01 00:28:57.000000', 'consum', 0.0214, 'lps'),
	(515036, 128, '2014-02-01 00:28:58.000000', 'consum', 0.0210, 'lps'),
	(515037, 128, '2014-02-01 00:28:59.000000', 'consum', 0.0213, 'lps'),
	(515038, 128, '2014-02-01 00:29:00.000000', 'consum', 0.0223, 'lps'),
	(515039, 128, '2014-02-01 00:29:01.000000', 'consum', 0.0213, 'lps'),
	(515040, 128, '2014-02-01 00:29:02.000000', 'consum', 0.0213, 'lps'),
	(515041, 128, '2014-02-01 00:29:03.000000', 'consum', 0.0219, 'lps'),
	(515042, 128, '2014-02-01 00:29:04.000000', 'consum', 0.0216, 'lps'),
	(515043, 128, '2014-02-01 00:29:05.000000', 'consum', 0.0215, 'lps'),
	(515044, 128, '2014-02-01 00:29:06.000000', 'consum', 0.0217, 'lps'),
	(515045, 128, '2014-02-01 00:29:07.000000', 'consum', 0.0218, 'lps'),
	(515046, 128, '2014-02-01 00:29:08.000000', 'consum', 0.0213, 'lps'),
	(515047, 128, '2014-02-01 00:29:09.000000', 'consum', 0.0216, 'lps'),
	(515048, 128, '2014-02-01 00:29:10.000000', 'consum', 0.0217, 'lps'),
	(515049, 128, '2014-02-01 00:29:11.000000', 'consum', 0.0213, 'lps'),
	(515050, 128, '2014-02-01 00:29:12.000000', 'consum', 0.0220, 'lps'),
	(515051, 128, '2014-02-01 00:29:13.000000', 'consum', 0.0223, 'lps'),
	(515052, 128, '2014-02-01 00:29:14.000000', 'consum', 0.0217, 'lps'),
	(515053, 128, '2014-02-01 00:29:15.000000', 'consum', 0.0220, 'lps'),
	(515054, 128, '2014-02-01 00:29:16.000000', 'consum', 0.0212, 'lps'),
	(515055, 128, '2014-02-01 00:29:17.000000', 'consum', 0.0218, 'lps'),
	(515056, 128, '2014-02-01 00:29:18.000000', 'consum', 0.0218, 'lps'),
	(515057, 128, '2014-02-01 00:29:19.000000', 'consum', 0.0213, 'lps'),
	(515058, 128, '2014-02-01 00:29:20.000000', 'consum', 0.0217, 'lps'),
	(515059, 128, '2014-02-01 00:29:21.000000', 'consum', 0.0219, 'lps'),
	(515060, 128, '2014-02-01 00:29:22.000000', 'consum', 0.0222, 'lps'),
	(515061, 128, '2014-02-01 00:29:23.000000', 'consum', 0.0216, 'lps'),
	(515062, 128, '2014-02-01 00:29:24.000000', 'consum', 0.0218, 'lps'),
	(515063, 128, '2014-02-01 00:29:25.000000', 'consum', 0.0217, 'lps'),
	(515064, 128, '2014-02-01 00:29:26.000000', 'consum', 0.0223, 'lps'),
	(515065, 128, '2014-02-01 00:29:27.000000', 'consum', 0.0212, 'lps'),
	(515066, 128, '2014-02-01 00:29:28.000000', 'consum', 0.0222, 'lps'),
	(515067, 128, '2014-02-01 00:29:29.000000', 'consum', 0.0211, 'lps'),
	(515068, 128, '2014-02-01 00:29:30.000000', 'consum', 0.0221, 'lps'),
	(515069, 128, '2014-02-01 00:29:31.000000', 'consum', 0.0221, 'lps'),
	(515070, 128, '2014-02-01 00:29:32.000000', 'consum', 0.0217, 'lps'),
	(515071, 128, '2014-02-01 00:29:33.000000', 'consum', 0.0215, 'lps'),
	(515072, 128, '2014-02-01 00:29:34.000000', 'consum', 0.0213, 'lps'),
	(515073, 128, '2014-02-01 00:29:35.000000', 'consum', 0.0223, 'lps'),
	(515074, 128, '2014-02-01 00:29:36.000000', 'consum', 0.0214, 'lps'),
	(515075, 128, '2014-02-01 00:29:37.000000', 'consum', 0.0217, 'lps'),
	(515076, 128, '2014-02-01 00:29:38.000000', 'consum', 0.0219, 'lps'),
	(515077, 128, '2014-02-01 00:29:39.000000', 'consum', 0.0221, 'lps'),
	(515078, 128, '2014-02-01 00:29:40.000000', 'consum', 0.0210, 'lps'),
	(515079, 128, '2014-02-01 00:29:41.000000', 'consum', 0.0220, 'lps'),
	(515080, 128, '2014-02-01 00:29:42.000000', 'consum', 0.0220, 'lps'),
	(515081, 128, '2014-02-01 00:29:43.000000', 'consum', 0.0217, 'lps'),
	(515082, 128, '2014-02-01 00:29:44.000000', 'consum', 0.0213, 'lps'),
	(515083, 128, '2014-02-01 00:29:45.000000', 'consum', 0.0221, 'lps'),
	(515084, 128, '2014-02-01 00:29:46.000000', 'consum', 0.0213, 'lps'),
	(515085, 128, '2014-02-01 00:29:47.000000', 'consum', 0.0220, 'lps'),
	(515086, 128, '2014-02-01 00:29:48.000000', 'consum', 0.0223, 'lps'),
	(515087, 128, '2014-02-01 00:29:49.000000', 'consum', 0.0217, 'lps'),
	(515088, 128, '2014-02-01 00:29:50.000000', 'consum', 0.0223, 'lps'),
	(515089, 128, '2014-02-01 00:29:51.000000', 'consum', 0.0212, 'lps'),
	(515090, 128, '2014-02-01 00:29:52.000000', 'consum', 0.0210, 'lps'),
	(515091, 128, '2014-02-01 00:29:53.000000', 'consum', 0.0220, 'lps'),
	(515092, 128, '2014-02-01 00:29:54.000000', 'consum', 0.0215, 'lps'),
	(515093, 128, '2014-02-01 00:29:55.000000', 'consum', 0.0220, 'lps'),
	(515094, 128, '2014-02-01 00:29:56.000000', 'consum', 0.0220, 'lps'),
	(515095, 128, '2014-02-01 00:29:57.000000', 'consum', 0.0214, 'lps'),
	(515096, 128, '2014-02-01 00:29:58.000000', 'consum', 0.0214, 'lps'),
	(515097, 128, '2014-02-01 00:29:59.000000', 'consum', 0.0218, 'lps'),
	(515098, 128, '2014-02-01 00:30:00.000000', 'consum', 0.0223, 'lps'),
	(515099, 128, '2014-02-01 00:30:01.000000', 'consum', 0.0213, 'lps'),
	(515100, 128, '2014-02-01 00:30:02.000000', 'consum', 0.0214, 'lps'),
	(515101, 128, '2014-02-01 00:30:03.000000', 'consum', 0.0223, 'lps'),
	(515102, 128, '2014-02-01 00:30:04.000000', 'consum', 0.0218, 'lps'),
	(515103, 128, '2014-02-01 00:30:05.000000', 'consum', 0.0214, 'lps'),
	(515104, 128, '2014-02-01 00:30:06.000000', 'consum', 0.0220, 'lps'),
	(515105, 128, '2014-02-01 00:30:07.000000', 'consum', 0.0220, 'lps'),
	(515106, 128, '2014-02-01 00:30:08.000000', 'consum', 0.0218, 'lps'),
	(515107, 128, '2014-02-01 00:30:09.000000', 'consum', 0.0221, 'lps'),
	(515108, 128, '2014-02-01 00:30:10.000000', 'consum', 0.0212, 'lps'),
	(515109, 128, '2014-02-01 00:30:11.000000', 'consum', 0.0215, 'lps'),
	(515110, 128, '2014-02-01 00:30:12.000000', 'consum', 0.0217, 'lps'),
	(515111, 128, '2014-02-01 00:30:13.000000', 'consum', 0.0215, 'lps'),
	(515112, 128, '2014-02-01 00:30:14.000000', 'consum', 0.0215, 'lps'),
	(515113, 128, '2014-02-01 00:30:15.000000', 'consum', 0.0220, 'lps'),
	(515114, 128, '2014-02-01 00:30:16.000000', 'consum', 0.0216, 'lps'),
	(515115, 128, '2014-02-01 00:30:17.000000', 'consum', 0.0211, 'lps'),
	(515116, 128, '2014-02-01 00:30:18.000000', 'consum', 0.0212, 'lps'),
	(515117, 128, '2014-02-01 00:30:19.000000', 'consum', 0.0216, 'lps'),
	(515118, 128, '2014-02-01 00:30:20.000000', 'consum', 0.0223, 'lps'),
	(515119, 128, '2014-02-01 00:30:21.000000', 'consum', 0.0214, 'lps'),
	(515120, 128, '2014-02-01 00:30:22.000000', 'consum', 0.0221, 'lps'),
	(515121, 128, '2014-02-01 00:30:23.000000', 'consum', 0.0223, 'lps'),
	(515122, 128, '2014-02-01 00:30:24.000000', 'consum', 0.0216, 'lps'),
	(515123, 128, '2014-02-01 00:30:25.000000', 'consum', 0.0214, 'lps'),
	(515124, 128, '2014-02-01 00:30:26.000000', 'consum', 0.0215, 'lps'),
	(515125, 128, '2014-02-01 00:30:27.000000', 'consum', 0.0222, 'lps'),
	(515126, 128, '2014-02-01 00:30:28.000000', 'consum', 0.0214, 'lps'),
	(515127, 128, '2014-02-01 00:30:29.000000', 'consum', 0.0210, 'lps'),
	(515128, 128, '2014-02-01 00:30:30.000000', 'consum', 0.0213, 'lps'),
	(515129, 128, '2014-02-01 00:30:31.000000', 'consum', 0.0211, 'lps'),
	(515130, 128, '2014-02-01 00:30:32.000000', 'consum', 0.0218, 'lps'),
	(515131, 128, '2014-02-01 00:30:33.000000', 'consum', 0.0223, 'lps'),
	(515132, 128, '2014-02-01 00:30:34.000000', 'consum', 0.0220, 'lps'),
	(515133, 128, '2014-02-01 00:30:35.000000', 'consum', 0.0223, 'lps'),
	(515134, 128, '2014-02-01 00:30:36.000000', 'consum', 0.0218, 'lps'),
	(515135, 128, '2014-02-01 00:30:37.000000', 'consum', 0.0210, 'lps'),
	(515136, 128, '2014-02-01 00:30:38.000000', 'consum', 0.0216, 'lps'),
	(515137, 128, '2014-02-01 00:30:39.000000', 'consum', 0.0214, 'lps'),
	(515138, 128, '2014-02-01 00:30:40.000000', 'consum', 0.0211, 'lps'),
	(515139, 128, '2014-02-01 00:30:41.000000', 'consum', 0.0216, 'lps'),
	(515140, 128, '2014-02-01 00:30:42.000000', 'consum', 0.0212, 'lps'),
	(515141, 128, '2014-02-01 00:30:43.000000', 'consum', 0.0218, 'lps'),
	(515142, 128, '2014-02-01 00:30:44.000000', 'consum', 0.0213, 'lps'),
	(515143, 128, '2014-02-01 00:30:45.000000', 'consum', 0.0218, 'lps'),
	(515144, 128, '2014-02-01 00:30:46.000000', 'consum', 0.0213, 'lps'),
	(515145, 128, '2014-02-01 00:30:47.000000', 'consum', 0.0213, 'lps'),
	(515146, 128, '2014-02-01 00:30:48.000000', 'consum', 0.0219, 'lps'),
	(515147, 128, '2014-02-01 00:30:49.000000', 'consum', 0.0219, 'lps'),
	(515148, 128, '2014-02-01 00:30:50.000000', 'consum', 0.0212, 'lps'),
	(515149, 128, '2014-02-01 00:30:51.000000', 'consum', 0.0210, 'lps'),
	(515150, 128, '2014-02-01 00:30:52.000000', 'consum', 0.0217, 'lps'),
	(515151, 128, '2014-02-01 00:30:53.000000', 'consum', 0.0219, 'lps'),
	(515152, 128, '2014-02-01 00:30:54.000000', 'consum', 0.0221, 'lps'),
	(515153, 128, '2014-02-01 00:30:55.000000', 'consum', 0.0222, 'lps'),
	(515154, 128, '2014-02-01 00:30:56.000000', 'consum', 0.0210, 'lps'),
	(515155, 128, '2014-02-01 00:30:57.000000', 'consum', 0.0218, 'lps'),
	(515156, 128, '2014-02-01 00:30:58.000000', 'consum', 0.0210, 'lps'),
	(515157, 128, '2014-02-01 00:30:59.000000', 'consum', 0.0211, 'lps'),
	(515158, 128, '2014-02-01 00:31:00.000000', 'consum', 0.0218, 'lps'),
	(515159, 128, '2014-02-01 00:31:01.000000', 'consum', 0.0218, 'lps'),
	(515160, 128, '2014-02-01 00:31:02.000000', 'consum', 0.0213, 'lps'),
	(515161, 128, '2014-02-01 00:31:03.000000', 'consum', 0.0217, 'lps'),
	(515162, 128, '2014-02-01 00:31:04.000000', 'consum', 0.0221, 'lps'),
	(515163, 128, '2014-02-01 00:31:05.000000', 'consum', 0.0218, 'lps'),
	(515164, 128, '2014-02-01 00:31:06.000000', 'consum', 0.0216, 'lps'),
	(515165, 128, '2014-02-01 00:31:07.000000', 'consum', 0.0216, 'lps'),
	(515166, 128, '2014-02-01 00:31:08.000000', 'consum', 0.0210, 'lps'),
	(515167, 128, '2014-02-01 00:31:09.000000', 'consum', 0.0220, 'lps'),
	(515168, 128, '2014-02-01 00:31:10.000000', 'consum', 0.0220, 'lps'),
	(515169, 128, '2014-02-01 00:31:11.000000', 'consum', 0.0214, 'lps'),
	(515170, 128, '2014-02-01 00:31:12.000000', 'consum', 0.0215, 'lps'),
	(515171, 128, '2014-02-01 00:31:13.000000', 'consum', 0.0223, 'lps'),
	(515172, 128, '2014-02-01 00:31:14.000000', 'consum', 0.0217, 'lps'),
	(515173, 128, '2014-02-01 00:31:15.000000', 'consum', 0.0210, 'lps'),
	(515174, 128, '2014-02-01 00:31:16.000000', 'consum', 0.0216, 'lps'),
	(515175, 128, '2014-02-01 00:31:17.000000', 'consum', 0.0214, 'lps'),
	(515176, 128, '2014-02-01 00:31:18.000000', 'consum', 0.0212, 'lps'),
	(515177, 128, '2014-02-01 00:31:19.000000', 'consum', 0.0221, 'lps'),
	(515178, 128, '2014-02-01 00:31:20.000000', 'consum', 0.0220, 'lps'),
	(515179, 128, '2014-02-01 00:31:21.000000', 'consum', 0.0211, 'lps'),
	(515180, 128, '2014-02-01 00:31:22.000000', 'consum', 0.0215, 'lps'),
	(515181, 128, '2014-02-01 00:31:23.000000', 'consum', 0.0219, 'lps'),
	(515182, 128, '2014-02-01 00:31:24.000000', 'consum', 0.0211, 'lps'),
	(515183, 128, '2014-02-01 00:31:25.000000', 'consum', 0.0218, 'lps'),
	(515184, 128, '2014-02-01 00:31:26.000000', 'consum', 0.0217, 'lps'),
	(515185, 128, '2014-02-01 00:31:27.000000', 'consum', 0.0210, 'lps'),
	(515186, 128, '2014-02-01 00:31:28.000000', 'consum', 0.0217, 'lps'),
	(515187, 128, '2014-02-01 00:31:29.000000', 'consum', 0.0217, 'lps'),
	(515188, 128, '2014-02-01 00:31:30.000000', 'consum', 0.0223, 'lps'),
	(515189, 128, '2014-02-01 00:31:31.000000', 'consum', 0.0215, 'lps'),
	(515190, 128, '2014-02-01 00:31:32.000000', 'consum', 0.0211, 'lps'),
	(515191, 128, '2014-02-01 00:31:33.000000', 'consum', 0.0212, 'lps'),
	(515192, 128, '2014-02-01 00:31:34.000000', 'consum', 0.0218, 'lps'),
	(515193, 128, '2014-02-01 00:31:35.000000', 'consum', 0.0216, 'lps'),
	(515194, 128, '2014-02-01 00:31:36.000000', 'consum', 0.0217, 'lps'),
	(515195, 128, '2014-02-01 00:31:37.000000', 'consum', 0.0214, 'lps'),
	(515196, 128, '2014-02-01 00:31:38.000000', 'consum', 0.0222, 'lps'),
	(515197, 128, '2014-02-01 00:31:39.000000', 'consum', 0.0216, 'lps'),
	(515198, 128, '2014-02-01 00:31:40.000000', 'consum', 0.0219, 'lps'),
	(515199, 128, '2014-02-01 00:31:41.000000', 'consum', 0.0223, 'lps'),
	(515200, 128, '2014-02-01 00:31:42.000000', 'consum', 0.0222, 'lps'),
	(515201, 128, '2014-02-01 00:31:43.000000', 'consum', 0.0218, 'lps'),
	(515202, 128, '2014-02-01 00:31:44.000000', 'consum', 0.0215, 'lps'),
	(515203, 128, '2014-02-01 00:31:45.000000', 'consum', 0.0223, 'lps'),
	(515204, 128, '2014-02-01 00:31:46.000000', 'consum', 0.0219, 'lps'),
	(515205, 128, '2014-02-01 00:31:47.000000', 'consum', 0.0217, 'lps'),
	(515206, 128, '2014-02-01 00:31:48.000000', 'consum', 0.0220, 'lps'),
	(515207, 128, '2014-02-01 00:31:49.000000', 'consum', 0.0212, 'lps'),
	(515208, 128, '2014-02-01 00:31:50.000000', 'consum', 0.0217, 'lps'),
	(515209, 128, '2014-02-01 00:31:51.000000', 'consum', 0.0212, 'lps'),
	(515210, 128, '2014-02-01 00:31:52.000000', 'consum', 0.0214, 'lps'),
	(515211, 128, '2014-02-01 00:31:53.000000', 'consum', 0.0211, 'lps'),
	(515212, 128, '2014-02-01 00:31:54.000000', 'consum', 0.0218, 'lps'),
	(515213, 128, '2014-02-01 00:31:55.000000', 'consum', 0.0218, 'lps'),
	(515214, 128, '2014-02-01 00:31:56.000000', 'consum', 0.0215, 'lps'),
	(515215, 128, '2014-02-01 00:31:57.000000', 'consum', 0.0223, 'lps'),
	(515216, 128, '2014-02-01 00:31:58.000000', 'consum', 0.0219, 'lps'),
	(515217, 128, '2014-02-01 00:31:59.000000', 'consum', 0.0216, 'lps'),
	(515218, 128, '2014-02-01 00:32:00.000000', 'consum', 0.0215, 'lps'),
	(515219, 128, '2014-02-01 00:32:01.000000', 'consum', 0.0215, 'lps'),
	(515220, 128, '2014-02-01 00:32:02.000000', 'consum', 0.0223, 'lps'),
	(515221, 128, '2014-02-01 00:32:03.000000', 'consum', 0.0220, 'lps'),
	(515222, 128, '2014-02-01 00:32:04.000000', 'consum', 0.0218, 'lps'),
	(515223, 128, '2014-02-01 00:32:05.000000', 'consum', 0.0223, 'lps'),
	(515224, 128, '2014-02-01 00:32:06.000000', 'consum', 0.0210, 'lps'),
	(515225, 128, '2014-02-01 00:32:07.000000', 'consum', 0.0211, 'lps'),
	(515226, 128, '2014-02-01 00:32:08.000000', 'consum', 0.0218, 'lps'),
	(515227, 128, '2014-02-01 00:32:09.000000', 'consum', 0.0218, 'lps'),
	(515228, 128, '2014-02-01 00:32:10.000000', 'consum', 0.0215, 'lps'),
	(515229, 128, '2014-02-01 00:32:11.000000', 'consum', 0.0223, 'lps'),
	(515230, 128, '2014-02-01 00:32:12.000000', 'consum', 0.0218, 'lps'),
	(515231, 128, '2014-02-01 00:32:13.000000', 'consum', 0.0211, 'lps'),
	(515232, 128, '2014-02-01 00:32:14.000000', 'consum', 0.0220, 'lps'),
	(515233, 128, '2014-02-01 00:32:15.000000', 'consum', 0.0214, 'lps'),
	(515234, 128, '2014-02-01 00:32:16.000000', 'consum', 0.0216, 'lps'),
	(515235, 128, '2014-02-01 00:32:17.000000', 'consum', 0.0214, 'lps'),
	(515236, 128, '2014-02-01 00:32:18.000000', 'consum', 0.0212, 'lps'),
	(515237, 128, '2014-02-01 00:32:19.000000', 'consum', 0.0223, 'lps'),
	(515238, 128, '2014-02-01 00:32:20.000000', 'consum', 0.0213, 'lps'),
	(515239, 128, '2014-02-01 00:32:21.000000', 'consum', 0.0215, 'lps'),
	(515240, 128, '2014-02-01 00:32:22.000000', 'consum', 0.0214, 'lps'),
	(515241, 128, '2014-02-01 00:32:23.000000', 'consum', 0.0216, 'lps'),
	(515242, 128, '2014-02-01 00:32:24.000000', 'consum', 0.0214, 'lps'),
	(515243, 128, '2014-02-01 00:32:25.000000', 'consum', 0.0211, 'lps'),
	(515244, 128, '2014-02-01 00:32:26.000000', 'consum', 0.0219, 'lps'),
	(515245, 128, '2014-02-01 00:32:27.000000', 'consum', 0.0222, 'lps'),
	(515246, 128, '2014-02-01 00:32:28.000000', 'consum', 0.0218, 'lps'),
	(515247, 128, '2014-02-01 00:32:29.000000', 'consum', 0.0212, 'lps'),
	(515248, 128, '2014-02-01 00:32:30.000000', 'consum', 0.0213, 'lps'),
	(515249, 128, '2014-02-01 00:32:31.000000', 'consum', 0.0218, 'lps'),
	(515250, 128, '2014-02-01 00:32:32.000000', 'consum', 0.0214, 'lps'),
	(515251, 128, '2014-02-01 00:32:33.000000', 'consum', 0.0219, 'lps'),
	(515252, 128, '2014-02-01 00:32:34.000000', 'consum', 0.0216, 'lps'),
	(515253, 128, '2014-02-01 00:32:35.000000', 'consum', 0.0215, 'lps'),
	(515254, 128, '2014-02-01 00:32:36.000000', 'consum', 0.0215, 'lps'),
	(515255, 128, '2014-02-01 00:32:37.000000', 'consum', 0.0221, 'lps'),
	(515256, 128, '2014-02-01 00:32:38.000000', 'consum', 0.0211, 'lps'),
	(515257, 128, '2014-02-01 00:32:39.000000', 'consum', 0.0222, 'lps'),
	(515258, 128, '2014-02-01 00:32:40.000000', 'consum', 0.0212, 'lps'),
	(515259, 128, '2014-02-01 00:32:41.000000', 'consum', 0.0213, 'lps'),
	(515260, 128, '2014-02-01 00:32:42.000000', 'consum', 0.0220, 'lps'),
	(515261, 128, '2014-02-01 00:32:43.000000', 'consum', 0.0221, 'lps'),
	(515262, 128, '2014-02-01 00:32:44.000000', 'consum', 0.0222, 'lps'),
	(515263, 128, '2014-02-01 00:32:45.000000', 'consum', 0.0212, 'lps'),
	(515264, 128, '2014-02-01 00:32:46.000000', 'consum', 0.0210, 'lps'),
	(515265, 128, '2014-02-01 00:32:47.000000', 'consum', 0.0220, 'lps'),
	(515266, 128, '2014-02-01 00:32:48.000000', 'consum', 0.0218, 'lps'),
	(515267, 128, '2014-02-01 00:32:49.000000', 'consum', 0.0222, 'lps'),
	(515268, 128, '2014-02-01 00:32:50.000000', 'consum', 0.0217, 'lps'),
	(515269, 128, '2014-02-01 00:32:51.000000', 'consum', 0.0222, 'lps'),
	(515270, 128, '2014-02-01 00:32:52.000000', 'consum', 0.0210, 'lps'),
	(515271, 128, '2014-02-01 00:32:53.000000', 'consum', 0.0217, 'lps'),
	(515272, 128, '2014-02-01 00:32:54.000000', 'consum', 0.0216, 'lps'),
	(515273, 128, '2014-02-01 00:32:55.000000', 'consum', 0.0220, 'lps'),
	(515274, 128, '2014-02-01 00:32:56.000000', 'consum', 0.0215, 'lps'),
	(515275, 128, '2014-02-01 00:32:57.000000', 'consum', 0.0219, 'lps'),
	(515276, 128, '2014-02-01 00:32:58.000000', 'consum', 0.0211, 'lps'),
	(515277, 128, '2014-02-01 00:32:59.000000', 'consum', 0.0216, 'lps'),
	(515278, 128, '2014-02-01 00:33:00.000000', 'consum', 0.0212, 'lps'),
	(515279, 128, '2014-02-01 00:33:01.000000', 'consum', 0.0214, 'lps'),
	(515280, 128, '2014-02-01 00:33:02.000000', 'consum', 0.0210, 'lps'),
	(515281, 128, '2014-02-01 00:33:03.000000', 'consum', 0.0215, 'lps'),
	(515282, 128, '2014-02-01 00:33:04.000000', 'consum', 0.0221, 'lps'),
	(515283, 128, '2014-02-01 00:33:05.000000', 'consum', 0.0223, 'lps'),
	(515284, 128, '2014-02-01 00:33:06.000000', 'consum', 0.0215, 'lps'),
	(515285, 128, '2014-02-01 00:33:07.000000', 'consum', 0.0210, 'lps'),
	(515286, 128, '2014-02-01 00:33:08.000000', 'consum', 0.0211, 'lps'),
	(515287, 128, '2014-02-01 00:33:09.000000', 'consum', 0.0214, 'lps'),
	(515288, 128, '2014-02-01 00:33:10.000000', 'consum', 0.0213, 'lps'),
	(515289, 128, '2014-02-01 00:33:11.000000', 'consum', 0.0213, 'lps'),
	(515290, 128, '2014-02-01 00:33:12.000000', 'consum', 0.0219, 'lps'),
	(515291, 128, '2014-02-01 00:33:13.000000', 'consum', 0.0218, 'lps'),
	(515292, 128, '2014-02-01 00:33:14.000000', 'consum', 0.0222, 'lps'),
	(515293, 128, '2014-02-01 00:33:15.000000', 'consum', 0.0220, 'lps'),
	(515294, 128, '2014-02-01 00:33:16.000000', 'consum', 0.0210, 'lps'),
	(515295, 128, '2014-02-01 00:33:17.000000', 'consum', 0.0223, 'lps'),
	(515296, 128, '2014-02-01 00:33:18.000000', 'consum', 0.0220, 'lps'),
	(515297, 128, '2014-02-01 00:33:19.000000', 'consum', 0.0220, 'lps'),
	(515298, 128, '2014-02-01 00:33:20.000000', 'consum', 0.0217, 'lps'),
	(515299, 128, '2014-02-01 00:33:21.000000', 'consum', 0.0214, 'lps'),
	(515300, 128, '2014-02-01 00:33:22.000000', 'consum', 0.0211, 'lps'),
	(515301, 128, '2014-02-01 00:33:23.000000', 'consum', 0.0219, 'lps'),
	(515302, 128, '2014-02-01 00:33:24.000000', 'consum', 0.0221, 'lps'),
	(515303, 128, '2014-02-01 00:33:25.000000', 'consum', 0.0214, 'lps'),
	(515304, 128, '2014-02-01 00:33:26.000000', 'consum', 0.0210, 'lps'),
	(515305, 128, '2014-02-01 00:33:27.000000', 'consum', 0.0213, 'lps'),
	(515306, 128, '2014-02-01 00:33:28.000000', 'consum', 0.0211, 'lps'),
	(515307, 128, '2014-02-01 00:33:29.000000', 'consum', 0.0221, 'lps'),
	(515308, 128, '2014-02-01 00:33:30.000000', 'consum', 0.0219, 'lps'),
	(515309, 128, '2014-02-01 00:33:31.000000', 'consum', 0.0222, 'lps'),
	(515310, 128, '2014-02-01 00:33:32.000000', 'consum', 0.0217, 'lps'),
	(515311, 128, '2014-02-01 00:33:33.000000', 'consum', 0.0222, 'lps'),
	(515312, 128, '2014-02-01 00:33:34.000000', 'consum', 0.0223, 'lps'),
	(515313, 128, '2014-02-01 00:33:35.000000', 'consum', 0.0213, 'lps'),
	(515314, 128, '2014-02-01 00:33:36.000000', 'consum', 0.0212, 'lps'),
	(515315, 128, '2014-02-01 00:33:37.000000', 'consum', 0.0211, 'lps'),
	(515316, 128, '2014-02-01 00:33:38.000000', 'consum', 0.0211, 'lps'),
	(515317, 128, '2014-02-01 00:33:39.000000', 'consum', 0.0211, 'lps'),
	(515318, 128, '2014-02-01 00:33:40.000000', 'consum', 0.0212, 'lps'),
	(515319, 128, '2014-02-01 00:33:41.000000', 'consum', 0.0217, 'lps'),
	(515320, 128, '2014-02-01 00:33:42.000000', 'consum', 0.0213, 'lps'),
	(515321, 128, '2014-02-01 00:33:43.000000', 'consum', 0.0218, 'lps'),
	(515322, 128, '2014-02-01 00:33:44.000000', 'consum', 0.0213, 'lps'),
	(515323, 128, '2014-02-01 00:33:45.000000', 'consum', 0.0217, 'lps'),
	(515324, 128, '2014-02-01 00:33:46.000000', 'consum', 0.0223, 'lps'),
	(515325, 128, '2014-02-01 00:33:47.000000', 'consum', 0.0212, 'lps'),
	(515326, 128, '2014-02-01 00:33:48.000000', 'consum', 0.0222, 'lps'),
	(515327, 128, '2014-02-01 00:33:49.000000', 'consum', 0.0223, 'lps'),
	(515328, 128, '2014-02-01 00:33:50.000000', 'consum', 0.0213, 'lps'),
	(515329, 128, '2014-02-01 00:33:51.000000', 'consum', 0.0215, 'lps'),
	(515330, 128, '2014-02-01 00:33:52.000000', 'consum', 0.0213, 'lps'),
	(515331, 128, '2014-02-01 00:33:53.000000', 'consum', 0.0223, 'lps'),
	(515332, 128, '2014-02-01 00:33:54.000000', 'consum', 0.0211, 'lps'),
	(515333, 128, '2014-02-01 00:33:55.000000', 'consum', 0.0217, 'lps'),
	(515334, 128, '2014-02-01 00:33:56.000000', 'consum', 0.0215, 'lps'),
	(515335, 128, '2014-02-01 00:33:57.000000', 'consum', 0.0214, 'lps'),
	(515336, 128, '2014-02-01 00:33:58.000000', 'consum', 0.0216, 'lps'),
	(515337, 128, '2014-02-01 00:33:59.000000', 'consum', 0.0214, 'lps'),
	(515338, 128, '2014-02-01 00:34:00.000000', 'consum', 0.0211, 'lps'),
	(515339, 128, '2014-02-01 00:34:01.000000', 'consum', 0.0219, 'lps'),
	(515340, 128, '2014-02-01 00:34:02.000000', 'consum', 0.0223, 'lps'),
	(515341, 128, '2014-02-01 00:34:03.000000', 'consum', 0.0210, 'lps'),
	(515342, 128, '2014-02-01 00:34:04.000000', 'consum', 0.0210, 'lps'),
	(515343, 128, '2014-02-01 00:34:05.000000', 'consum', 0.0210, 'lps'),
	(515344, 128, '2014-02-01 00:34:06.000000', 'consum', 0.0213, 'lps'),
	(515345, 128, '2014-02-01 00:34:07.000000', 'consum', 0.0223, 'lps'),
	(515346, 128, '2014-02-01 00:34:08.000000', 'consum', 0.0214, 'lps'),
	(515347, 128, '2014-02-01 00:34:09.000000', 'consum', 0.0217, 'lps'),
	(515348, 128, '2014-02-01 00:34:10.000000', 'consum', 0.0219, 'lps'),
	(515349, 128, '2014-02-01 00:34:11.000000', 'consum', 0.0219, 'lps'),
	(515350, 128, '2014-02-01 00:34:12.000000', 'consum', 0.0217, 'lps'),
	(515351, 128, '2014-02-01 00:34:13.000000', 'consum', 0.0219, 'lps'),
	(515352, 128, '2014-02-01 00:34:14.000000', 'consum', 0.0219, 'lps'),
	(515353, 128, '2014-02-01 00:34:15.000000', 'consum', 0.0215, 'lps'),
	(515354, 128, '2014-02-01 00:34:16.000000', 'consum', 0.0221, 'lps'),
	(515355, 128, '2014-02-01 00:34:17.000000', 'consum', 0.0222, 'lps'),
	(515356, 128, '2014-02-01 00:34:18.000000', 'consum', 0.0211, 'lps'),
	(515357, 128, '2014-02-01 00:34:19.000000', 'consum', 0.0222, 'lps'),
	(515358, 128, '2014-02-01 00:34:20.000000', 'consum', 0.0211, 'lps'),
	(515359, 128, '2014-02-01 00:34:21.000000', 'consum', 0.0222, 'lps'),
	(515360, 128, '2014-02-01 00:34:22.000000', 'consum', 0.0211, 'lps'),
	(515361, 128, '2014-02-01 00:34:23.000000', 'consum', 0.0221, 'lps'),
	(515362, 128, '2014-02-01 00:34:24.000000', 'consum', 0.0221, 'lps'),
	(515363, 128, '2014-02-01 00:34:25.000000', 'consum', 0.0218, 'lps'),
	(515364, 128, '2014-02-01 00:34:26.000000', 'consum', 0.0216, 'lps'),
	(515365, 128, '2014-02-01 00:34:27.000000', 'consum', 0.0216, 'lps'),
	(515366, 128, '2014-02-01 00:34:28.000000', 'consum', 0.0211, 'lps'),
	(515367, 128, '2014-02-01 00:34:29.000000', 'consum', 0.0211, 'lps'),
	(515368, 128, '2014-02-01 00:34:30.000000', 'consum', 0.0211, 'lps'),
	(515369, 128, '2014-02-01 00:34:31.000000', 'consum', 0.0211, 'lps'),
	(515370, 128, '2014-02-01 00:34:32.000000', 'consum', 0.0215, 'lps'),
	(515371, 128, '2014-02-01 00:34:33.000000', 'consum', 0.0219, 'lps'),
	(515372, 128, '2014-02-01 00:34:34.000000', 'consum', 0.0210, 'lps'),
	(515373, 128, '2014-02-01 00:34:35.000000', 'consum', 0.0213, 'lps'),
	(515374, 128, '2014-02-01 00:34:36.000000', 'consum', 0.0211, 'lps'),
	(515375, 128, '2014-02-01 00:34:37.000000', 'consum', 0.0222, 'lps'),
	(515376, 128, '2014-02-01 00:34:38.000000', 'consum', 0.0223, 'lps'),
	(515377, 128, '2014-02-01 00:34:39.000000', 'consum', 0.0211, 'lps'),
	(515378, 128, '2014-02-01 00:34:40.000000', 'consum', 0.0220, 'lps'),
	(515379, 128, '2014-02-01 00:34:41.000000', 'consum', 0.0216, 'lps'),
	(515380, 128, '2014-02-01 00:34:42.000000', 'consum', 0.0211, 'lps'),
	(515381, 128, '2014-02-01 00:34:43.000000', 'consum', 0.0223, 'lps'),
	(515382, 128, '2014-02-01 00:34:44.000000', 'consum', 0.0219, 'lps'),
	(515383, 128, '2014-02-01 00:34:45.000000', 'consum', 0.0217, 'lps'),
	(515384, 128, '2014-02-01 00:34:46.000000', 'consum', 0.0219, 'lps'),
	(515385, 128, '2014-02-01 00:34:47.000000', 'consum', 0.0221, 'lps'),
	(515386, 128, '2014-02-01 00:34:48.000000', 'consum', 0.0210, 'lps'),
	(515387, 128, '2014-02-01 00:34:49.000000', 'consum', 0.0219, 'lps'),
	(515388, 128, '2014-02-01 00:34:50.000000', 'consum', 0.0214, 'lps'),
	(515389, 128, '2014-02-01 00:34:51.000000', 'consum', 0.0215, 'lps'),
	(515390, 128, '2014-02-01 00:34:52.000000', 'consum', 0.0212, 'lps'),
	(515391, 128, '2014-02-01 00:34:53.000000', 'consum', 0.0220, 'lps'),
	(515392, 128, '2014-02-01 00:34:54.000000', 'consum', 0.0210, 'lps'),
	(515393, 128, '2014-02-01 00:34:55.000000', 'consum', 0.0223, 'lps'),
	(515394, 128, '2014-02-01 00:34:56.000000', 'consum', 0.0221, 'lps'),
	(515395, 128, '2014-02-01 00:34:57.000000', 'consum', 0.0210, 'lps'),
	(515396, 128, '2014-02-01 00:34:58.000000', 'consum', 0.0221, 'lps'),
	(515397, 128, '2014-02-01 00:34:59.000000', 'consum', 0.0210, 'lps'),
	(515398, 128, '2014-02-01 00:35:00.000000', 'consum', 0.0221, 'lps'),
	(515399, 128, '2014-02-01 00:35:01.000000', 'consum', 0.0222, 'lps'),
	(515400, 128, '2014-02-01 00:35:02.000000', 'consum', 0.0223, 'lps'),
	(515401, 128, '2014-02-01 00:35:03.000000', 'consum', 0.0211, 'lps'),
	(515402, 128, '2014-02-01 00:35:04.000000', 'consum', 0.0219, 'lps'),
	(515403, 128, '2014-02-01 00:35:05.000000', 'consum', 0.0211, 'lps'),
	(515404, 128, '2014-02-01 00:35:06.000000', 'consum', 0.0215, 'lps'),
	(515405, 128, '2014-02-01 00:35:07.000000', 'consum', 0.0221, 'lps'),
	(515406, 128, '2014-02-01 00:35:08.000000', 'consum', 0.0222, 'lps'),
	(515407, 128, '2014-02-01 00:35:09.000000', 'consum', 0.0223, 'lps'),
	(515408, 128, '2014-02-01 00:35:10.000000', 'consum', 0.0210, 'lps'),
	(515409, 128, '2014-02-01 00:35:11.000000', 'consum', 0.0215, 'lps'),
	(515410, 128, '2014-02-01 00:35:12.000000', 'consum', 0.0221, 'lps'),
	(515411, 128, '2014-02-01 00:35:13.000000', 'consum', 0.0223, 'lps'),
	(515412, 128, '2014-02-01 00:35:14.000000', 'consum', 0.0212, 'lps'),
	(515413, 128, '2014-02-01 00:35:15.000000', 'consum', 0.0213, 'lps'),
	(515414, 128, '2014-02-01 00:35:16.000000', 'consum', 0.0218, 'lps'),
	(515415, 128, '2014-02-01 00:35:17.000000', 'consum', 0.0215, 'lps'),
	(515416, 128, '2014-02-01 00:35:18.000000', 'consum', 0.0212, 'lps'),
	(515417, 128, '2014-02-01 00:35:19.000000', 'consum', 0.0216, 'lps'),
	(515418, 128, '2014-02-01 00:35:20.000000', 'consum', 0.0210, 'lps'),
	(515419, 128, '2014-02-01 00:35:21.000000', 'consum', 0.0219, 'lps'),
	(515420, 128, '2014-02-01 00:35:22.000000', 'consum', 0.0214, 'lps'),
	(515421, 128, '2014-02-01 00:35:23.000000', 'consum', 0.0216, 'lps'),
	(515422, 128, '2014-02-01 00:35:24.000000', 'consum', 0.0215, 'lps'),
	(515423, 128, '2014-02-01 00:35:25.000000', 'consum', 0.0219, 'lps'),
	(515424, 128, '2014-02-01 00:35:26.000000', 'consum', 0.0212, 'lps'),
	(515425, 128, '2014-02-01 00:35:27.000000', 'consum', 0.0223, 'lps'),
	(515426, 128, '2014-02-01 00:35:28.000000', 'consum', 0.0210, 'lps'),
	(515427, 128, '2014-02-01 00:35:29.000000', 'consum', 0.0217, 'lps'),
	(515428, 128, '2014-02-01 00:35:30.000000', 'consum', 0.0217, 'lps'),
	(515429, 128, '2014-02-01 00:35:31.000000', 'consum', 0.0223, 'lps'),
	(515430, 128, '2014-02-01 00:35:32.000000', 'consum', 0.0215, 'lps'),
	(515431, 128, '2014-02-01 00:35:33.000000', 'consum', 0.0210, 'lps'),
	(515432, 128, '2014-02-01 00:35:34.000000', 'consum', 0.0223, 'lps'),
	(515433, 128, '2014-02-01 00:35:35.000000', 'consum', 0.0221, 'lps'),
	(515434, 128, '2014-02-01 00:35:36.000000', 'consum', 0.0211, 'lps'),
	(515435, 128, '2014-02-01 00:35:37.000000', 'consum', 0.0210, 'lps'),
	(515436, 128, '2014-02-01 00:35:38.000000', 'consum', 0.0223, 'lps'),
	(515437, 128, '2014-02-01 00:35:39.000000', 'consum', 0.0220, 'lps'),
	(515438, 128, '2014-02-01 00:35:40.000000', 'consum', 0.0219, 'lps'),
	(515439, 128, '2014-02-01 00:35:41.000000', 'consum', 0.0213, 'lps'),
	(515440, 128, '2014-02-01 00:35:42.000000', 'consum', 0.0214, 'lps'),
	(515441, 128, '2014-02-01 00:35:43.000000', 'consum', 0.0220, 'lps'),
	(515442, 128, '2014-02-01 00:35:44.000000', 'consum', 0.0220, 'lps'),
	(515443, 128, '2014-02-01 00:35:45.000000', 'consum', 0.0217, 'lps'),
	(515444, 128, '2014-02-01 00:35:46.000000', 'consum', 0.0214, 'lps'),
	(515445, 128, '2014-02-01 00:35:47.000000', 'consum', 0.0223, 'lps'),
	(515446, 128, '2014-02-01 00:35:48.000000', 'consum', 0.0223, 'lps'),
	(515447, 128, '2014-02-01 00:35:49.000000', 'consum', 0.0220, 'lps'),
	(515448, 128, '2014-02-01 00:35:50.000000', 'consum', 0.0223, 'lps'),
	(515449, 128, '2014-02-01 00:35:51.000000', 'consum', 0.0219, 'lps'),
	(515450, 128, '2014-02-01 00:35:52.000000', 'consum', 0.0218, 'lps'),
	(515451, 128, '2014-02-01 00:35:53.000000', 'consum', 0.0220, 'lps'),
	(515452, 128, '2014-02-01 00:35:54.000000', 'consum', 0.0222, 'lps'),
	(515453, 128, '2014-02-01 00:35:55.000000', 'consum', 0.0214, 'lps'),
	(515454, 128, '2014-02-01 00:35:56.000000', 'consum', 0.0221, 'lps'),
	(515455, 128, '2014-02-01 00:35:57.000000', 'consum', 0.0213, 'lps'),
	(515456, 128, '2014-02-01 00:35:58.000000', 'consum', 0.0219, 'lps'),
	(515457, 128, '2014-02-01 00:35:59.000000', 'consum', 0.0221, 'lps'),
	(515458, 128, '2014-02-01 00:36:00.000000', 'consum', 0.0211, 'lps'),
	(515459, 128, '2014-02-01 00:36:01.000000', 'consum', 0.0222, 'lps'),
	(515460, 128, '2014-02-01 00:36:02.000000', 'consum', 0.0211, 'lps'),
	(515461, 128, '2014-02-01 00:36:03.000000', 'consum', 0.0210, 'lps'),
	(515462, 128, '2014-02-01 00:36:04.000000', 'consum', 0.0219, 'lps'),
	(515463, 128, '2014-02-01 00:36:05.000000', 'consum', 0.0213, 'lps'),
	(515464, 128, '2014-02-01 00:36:06.000000', 'consum', 0.0213, 'lps'),
	(515465, 128, '2014-02-01 00:36:07.000000', 'consum', 0.0217, 'lps'),
	(515466, 128, '2014-02-01 00:36:08.000000', 'consum', 0.0221, 'lps'),
	(515467, 128, '2014-02-01 00:36:09.000000', 'consum', 0.0219, 'lps'),
	(515468, 128, '2014-02-01 00:36:10.000000', 'consum', 0.0221, 'lps'),
	(515469, 128, '2014-02-01 00:36:11.000000', 'consum', 0.0223, 'lps'),
	(515470, 128, '2014-02-01 00:36:12.000000', 'consum', 0.0216, 'lps'),
	(515471, 128, '2014-02-01 00:36:13.000000', 'consum', 0.0214, 'lps'),
	(515472, 128, '2014-02-01 00:36:14.000000', 'consum', 0.0215, 'lps'),
	(515473, 128, '2014-02-01 00:36:15.000000', 'consum', 0.0222, 'lps'),
	(515474, 128, '2014-02-01 00:36:16.000000', 'consum', 0.0214, 'lps'),
	(515475, 128, '2014-02-01 00:36:17.000000', 'consum', 0.0221, 'lps'),
	(515476, 128, '2014-02-01 00:36:18.000000', 'consum', 0.0212, 'lps'),
	(515477, 128, '2014-02-01 00:36:19.000000', 'consum', 0.0216, 'lps'),
	(515478, 128, '2014-02-01 00:36:20.000000', 'consum', 0.0221, 'lps'),
	(515479, 128, '2014-02-01 00:36:21.000000', 'consum', 0.0220, 'lps'),
	(515480, 128, '2014-02-01 00:36:22.000000', 'consum', 0.0215, 'lps'),
	(515481, 128, '2014-02-01 00:36:23.000000', 'consum', 0.0217, 'lps'),
	(515482, 128, '2014-02-01 00:36:24.000000', 'consum', 0.0217, 'lps'),
	(515483, 128, '2014-02-01 00:36:25.000000', 'consum', 0.0223, 'lps'),
	(515484, 128, '2014-02-01 00:36:26.000000', 'consum', 0.0215, 'lps'),
	(515485, 128, '2014-02-01 00:36:27.000000', 'consum', 0.0211, 'lps'),
	(515486, 128, '2014-02-01 00:36:28.000000', 'consum', 0.0212, 'lps'),
	(515487, 128, '2014-02-01 00:36:29.000000', 'consum', 0.0218, 'lps'),
	(515488, 128, '2014-02-01 00:36:30.000000', 'consum', 0.0218, 'lps'),
	(515489, 128, '2014-02-01 00:36:31.000000', 'consum', 0.0210, 'lps'),
	(515490, 128, '2014-02-01 00:36:32.000000', 'consum', 0.0215, 'lps'),
	(515491, 128, '2014-02-01 00:36:33.000000', 'consum', 0.0222, 'lps'),
	(515492, 128, '2014-02-01 00:36:34.000000', 'consum', 0.0211, 'lps'),
	(515493, 128, '2014-02-01 00:36:35.000000', 'consum', 0.0211, 'lps'),
	(515494, 128, '2014-02-01 00:36:36.000000', 'consum', 0.0212, 'lps'),
	(515495, 128, '2014-02-01 00:36:37.000000', 'consum', 0.0215, 'lps'),
	(515496, 128, '2014-02-01 00:36:38.000000', 'consum', 0.0219, 'lps'),
	(515497, 128, '2014-02-01 00:36:39.000000', 'consum', 0.0211, 'lps'),
	(515498, 128, '2014-02-01 00:36:40.000000', 'consum', 0.0215, 'lps'),
	(515499, 128, '2014-02-01 00:36:41.000000', 'consum', 0.0222, 'lps'),
	(515500, 128, '2014-02-01 00:36:42.000000', 'consum', 0.0210, 'lps'),
	(515501, 128, '2014-02-01 00:36:43.000000', 'consum', 0.0220, 'lps'),
	(515502, 128, '2014-02-01 00:36:44.000000', 'consum', 0.0215, 'lps'),
	(515503, 128, '2014-02-01 00:36:45.000000', 'consum', 0.0221, 'lps'),
	(515504, 128, '2014-02-01 00:36:46.000000', 'consum', 0.0222, 'lps'),
	(515505, 128, '2014-02-01 00:36:47.000000', 'consum', 0.0211, 'lps'),
	(515506, 128, '2014-02-01 00:36:48.000000', 'consum', 0.0221, 'lps'),
	(515507, 128, '2014-02-01 00:36:49.000000', 'consum', 0.0220, 'lps'),
	(515508, 128, '2014-02-01 00:36:50.000000', 'consum', 0.0214, 'lps'),
	(515509, 128, '2014-02-01 00:36:51.000000', 'consum', 0.0213, 'lps'),
	(515510, 128, '2014-02-01 00:36:52.000000', 'consum', 0.0216, 'lps'),
	(515511, 128, '2014-02-01 00:36:53.000000', 'consum', 0.0215, 'lps'),
	(515512, 128, '2014-02-01 00:36:54.000000', 'consum', 0.0217, 'lps'),
	(515513, 128, '2014-02-01 00:36:55.000000', 'consum', 0.0219, 'lps'),
	(515514, 128, '2014-02-01 00:36:56.000000', 'consum', 0.0220, 'lps'),
	(515515, 128, '2014-02-01 00:36:57.000000', 'consum', 0.0220, 'lps'),
	(515516, 128, '2014-02-01 00:36:58.000000', 'consum', 0.0214, 'lps'),
	(515517, 128, '2014-02-01 00:36:59.000000', 'consum', 0.0217, 'lps'),
	(515518, 128, '2014-02-01 00:37:00.000000', 'consum', 0.0219, 'lps'),
	(515519, 128, '2014-02-01 00:37:01.000000', 'consum', 0.0221, 'lps'),
	(515520, 128, '2014-02-01 00:37:02.000000', 'consum', 0.0212, 'lps'),
	(515521, 128, '2014-02-01 00:37:03.000000', 'consum', 0.0214, 'lps'),
	(515522, 128, '2014-02-01 00:37:04.000000', 'consum', 0.0212, 'lps'),
	(515523, 128, '2014-02-01 00:37:05.000000', 'consum', 0.0223, 'lps'),
	(515524, 128, '2014-02-01 00:37:06.000000', 'consum', 0.0214, 'lps'),
	(515525, 128, '2014-02-01 00:37:07.000000', 'consum', 0.0217, 'lps'),
	(515526, 128, '2014-02-01 00:37:08.000000', 'consum', 0.0220, 'lps'),
	(515527, 128, '2014-02-01 00:37:09.000000', 'consum', 0.0211, 'lps'),
	(515528, 128, '2014-02-01 00:37:10.000000', 'consum', 0.0213, 'lps'),
	(515529, 128, '2014-02-01 00:37:11.000000', 'consum', 0.0222, 'lps'),
	(515530, 128, '2014-02-01 00:37:12.000000', 'consum', 0.0220, 'lps'),
	(515531, 128, '2014-02-01 00:37:13.000000', 'consum', 0.0210, 'lps'),
	(515532, 128, '2014-02-01 00:37:14.000000', 'consum', 0.0222, 'lps'),
	(515533, 128, '2014-02-01 00:37:15.000000', 'consum', 0.0214, 'lps'),
	(515534, 128, '2014-02-01 00:37:16.000000', 'consum', 0.0211, 'lps'),
	(515535, 128, '2014-02-01 00:37:17.000000', 'consum', 0.0218, 'lps'),
	(515536, 128, '2014-02-01 00:37:18.000000', 'consum', 0.0220, 'lps'),
	(515537, 128, '2014-02-01 00:37:19.000000', 'consum', 0.0222, 'lps'),
	(515538, 128, '2014-02-01 00:37:20.000000', 'consum', 0.0210, 'lps'),
	(515539, 128, '2014-02-01 00:37:21.000000', 'consum', 0.0219, 'lps'),
	(515540, 128, '2014-02-01 00:37:22.000000', 'consum', 0.0212, 'lps'),
	(515541, 128, '2014-02-01 00:37:23.000000', 'consum', 0.0210, 'lps'),
	(515542, 128, '2014-02-01 00:37:24.000000', 'consum', 0.0216, 'lps'),
	(515543, 128, '2014-02-01 00:37:25.000000', 'consum', 0.0213, 'lps'),
	(515544, 128, '2014-02-01 00:37:26.000000', 'consum', 0.0220, 'lps'),
	(515545, 128, '2014-02-01 00:37:27.000000', 'consum', 0.0212, 'lps'),
	(515546, 128, '2014-02-01 00:37:28.000000', 'consum', 0.0216, 'lps'),
	(515547, 128, '2014-02-01 00:37:29.000000', 'consum', 0.0220, 'lps'),
	(515548, 128, '2014-02-01 00:37:30.000000', 'consum', 0.0217, 'lps'),
	(515549, 128, '2014-02-01 00:37:31.000000', 'consum', 0.0213, 'lps'),
	(515550, 128, '2014-02-01 00:37:32.000000', 'consum', 0.0219, 'lps'),
	(515551, 128, '2014-02-01 00:37:33.000000', 'consum', 0.0219, 'lps'),
	(515552, 128, '2014-02-01 00:37:34.000000', 'consum', 0.0216, 'lps'),
	(515553, 128, '2014-02-01 00:37:35.000000', 'consum', 0.0214, 'lps'),
	(515554, 128, '2014-02-01 00:37:36.000000', 'consum', 0.0212, 'lps'),
	(515555, 128, '2014-02-01 00:37:37.000000', 'consum', 0.0222, 'lps'),
	(515556, 128, '2014-02-01 00:37:38.000000', 'consum', 0.0210, 'lps'),
	(515557, 128, '2014-02-01 00:37:39.000000', 'consum', 0.0214, 'lps'),
	(515558, 128, '2014-02-01 00:37:40.000000', 'consum', 0.0217, 'lps'),
	(515559, 128, '2014-02-01 00:37:41.000000', 'consum', 0.0221, 'lps'),
	(515560, 128, '2014-02-01 00:37:42.000000', 'consum', 0.0215, 'lps'),
	(515561, 128, '2014-02-01 00:37:43.000000', 'consum', 0.0215, 'lps'),
	(515562, 128, '2014-02-01 00:37:44.000000', 'consum', 0.0210, 'lps'),
	(515563, 128, '2014-02-01 00:37:45.000000', 'consum', 0.0222, 'lps'),
	(515564, 128, '2014-02-01 00:37:46.000000', 'consum', 0.0213, 'lps'),
	(515565, 128, '2014-02-01 00:37:47.000000', 'consum', 0.0218, 'lps'),
	(515566, 128, '2014-02-01 00:37:48.000000', 'consum', 0.0215, 'lps'),
	(515567, 128, '2014-02-01 00:37:49.000000', 'consum', 0.0210, 'lps'),
	(515568, 128, '2014-02-01 00:37:50.000000', 'consum', 0.0222, 'lps'),
	(515569, 128, '2014-02-01 00:37:51.000000', 'consum', 0.0217, 'lps'),
	(515570, 128, '2014-02-01 00:37:52.000000', 'consum', 0.0211, 'lps'),
	(515571, 128, '2014-02-01 00:37:53.000000', 'consum', 0.0219, 'lps'),
	(515572, 128, '2014-02-01 00:37:54.000000', 'consum', 0.0211, 'lps'),
	(515573, 128, '2014-02-01 00:37:55.000000', 'consum', 0.0218, 'lps'),
	(515574, 128, '2014-02-01 00:37:56.000000', 'consum', 0.0220, 'lps'),
	(515575, 128, '2014-02-01 00:37:57.000000', 'consum', 0.0220, 'lps'),
	(515576, 128, '2014-02-01 00:37:58.000000', 'consum', 0.0217, 'lps'),
	(515577, 128, '2014-02-01 00:37:59.000000', 'consum', 0.0214, 'lps'),
	(515578, 128, '2014-02-01 00:38:00.000000', 'consum', 0.0212, 'lps'),
	(515579, 128, '2014-02-01 00:38:01.000000', 'consum', 0.0221, 'lps'),
	(515580, 128, '2014-02-01 00:38:02.000000', 'consum', 0.0217, 'lps'),
	(515581, 128, '2014-02-01 00:38:03.000000', 'consum', 0.0211, 'lps'),
	(515582, 128, '2014-02-01 00:38:04.000000', 'consum', 0.0211, 'lps'),
	(515583, 128, '2014-02-01 00:38:05.000000', 'consum', 0.0211, 'lps'),
	(515584, 128, '2014-02-01 00:38:06.000000', 'consum', 0.0211, 'lps'),
	(515585, 128, '2014-02-01 00:38:07.000000', 'consum', 0.0216, 'lps'),
	(515586, 128, '2014-02-01 00:38:08.000000', 'consum', 0.0220, 'lps'),
	(515587, 128, '2014-02-01 00:38:09.000000', 'consum', 0.0217, 'lps'),
	(515588, 128, '2014-02-01 00:38:10.000000', 'consum', 0.0215, 'lps'),
	(515589, 128, '2014-02-01 00:38:11.000000', 'consum', 0.0213, 'lps'),
	(515590, 128, '2014-02-01 00:38:12.000000', 'consum', 0.0212, 'lps'),
	(515591, 128, '2014-02-01 00:38:13.000000', 'consum', 0.0210, 'lps'),
	(515592, 128, '2014-02-01 00:38:14.000000', 'consum', 0.0218, 'lps'),
	(515593, 128, '2014-02-01 00:38:15.000000', 'consum', 0.0211, 'lps'),
	(515594, 128, '2014-02-01 00:38:16.000000', 'consum', 0.0218, 'lps'),
	(515595, 128, '2014-02-01 00:38:17.000000', 'consum', 0.0222, 'lps'),
	(515596, 128, '2014-02-01 00:38:18.000000', 'consum', 0.0216, 'lps'),
	(515597, 128, '2014-02-01 00:38:19.000000', 'consum', 0.0217, 'lps'),
	(515598, 128, '2014-02-01 00:38:20.000000', 'consum', 0.0217, 'lps'),
	(515599, 128, '2014-02-01 00:38:21.000000', 'consum', 0.0210, 'lps'),
	(515600, 128, '2014-02-01 00:38:22.000000', 'consum', 0.0215, 'lps'),
	(515601, 128, '2014-02-01 00:38:23.000000', 'consum', 0.0222, 'lps'),
	(515602, 128, '2014-02-01 00:38:24.000000', 'consum', 0.0213, 'lps'),
	(515603, 128, '2014-02-01 00:38:25.000000', 'consum', 0.0216, 'lps'),
	(515604, 128, '2014-02-01 00:38:26.000000', 'consum', 0.0221, 'lps'),
	(515605, 128, '2014-02-01 00:38:27.000000', 'consum', 0.0217, 'lps'),
	(515606, 128, '2014-02-01 00:38:28.000000', 'consum', 0.0215, 'lps'),
	(515607, 128, '2014-02-01 00:38:29.000000', 'consum', 0.0214, 'lps'),
	(515608, 128, '2014-02-01 00:38:30.000000', 'consum', 0.0213, 'lps'),
	(515609, 128, '2014-02-01 00:38:31.000000', 'consum', 0.0217, 'lps'),
	(515610, 128, '2014-02-01 00:38:32.000000', 'consum', 0.0219, 'lps'),
	(515611, 128, '2014-02-01 00:38:33.000000', 'consum', 0.0222, 'lps'),
	(515612, 128, '2014-02-01 00:38:34.000000', 'consum', 0.0216, 'lps'),
	(515613, 128, '2014-02-01 00:38:35.000000', 'consum', 0.0219, 'lps'),
	(515614, 128, '2014-02-01 00:38:36.000000', 'consum', 0.0210, 'lps'),
	(515615, 128, '2014-02-01 00:38:37.000000', 'consum', 0.0212, 'lps'),
	(515616, 128, '2014-02-01 00:38:38.000000', 'consum', 0.0220, 'lps'),
	(515617, 128, '2014-02-01 00:38:39.000000', 'consum', 0.0213, 'lps'),
	(515618, 128, '2014-02-01 00:38:40.000000', 'consum', 0.0222, 'lps'),
	(515619, 128, '2014-02-01 00:38:41.000000', 'consum', 0.0220, 'lps'),
	(515620, 128, '2014-02-01 00:38:42.000000', 'consum', 0.0212, 'lps'),
	(515621, 128, '2014-02-01 00:38:43.000000', 'consum', 0.0219, 'lps'),
	(515622, 128, '2014-02-01 00:38:44.000000', 'consum', 0.0219, 'lps'),
	(515623, 128, '2014-02-01 00:38:45.000000', 'consum', 0.0214, 'lps'),
	(515624, 128, '2014-02-01 00:38:46.000000', 'consum', 0.0221, 'lps'),
	(515625, 128, '2014-02-01 00:38:47.000000', 'consum', 0.0222, 'lps'),
	(515626, 128, '2014-02-01 00:38:48.000000', 'consum', 0.0212, 'lps'),
	(515627, 128, '2014-02-01 00:38:49.000000', 'consum', 0.0212, 'lps'),
	(515628, 128, '2014-02-01 00:38:50.000000', 'consum', 0.0215, 'lps'),
	(515629, 128, '2014-02-01 00:38:51.000000', 'consum', 0.0215, 'lps'),
	(515630, 128, '2014-02-01 00:38:52.000000', 'consum', 0.0220, 'lps'),
	(515631, 128, '2014-02-01 00:38:53.000000', 'consum', 0.0216, 'lps'),
	(515632, 128, '2014-02-01 00:38:54.000000', 'consum', 0.0213, 'lps'),
	(515633, 128, '2014-02-01 00:38:55.000000', 'consum', 0.0219, 'lps'),
	(515634, 128, '2014-02-01 00:38:56.000000', 'consum', 0.0222, 'lps'),
	(515635, 128, '2014-02-01 00:38:57.000000', 'consum', 0.0212, 'lps'),
	(515636, 128, '2014-02-01 00:38:58.000000', 'consum', 0.0213, 'lps'),
	(515637, 128, '2014-02-01 00:38:59.000000', 'consum', 0.0219, 'lps'),
	(515638, 128, '2014-02-01 00:39:00.000000', 'consum', 0.0221, 'lps'),
	(515639, 128, '2014-02-01 00:39:01.000000', 'consum', 0.0211, 'lps'),
	(515640, 128, '2014-02-01 00:39:02.000000', 'consum', 0.0222, 'lps'),
	(515641, 128, '2014-02-01 00:39:03.000000', 'consum', 0.0210, 'lps'),
	(515642, 128, '2014-02-01 00:39:04.000000', 'consum', 0.0220, 'lps'),
	(515643, 128, '2014-02-01 00:39:05.000000', 'consum', 0.0216, 'lps'),
	(515644, 128, '2014-02-01 00:39:06.000000', 'consum', 0.0223, 'lps'),
	(515645, 128, '2014-02-01 00:39:07.000000', 'consum', 0.0218, 'lps'),
	(515646, 128, '2014-02-01 00:39:08.000000', 'consum', 0.0213, 'lps'),
	(515647, 128, '2014-02-01 00:39:09.000000', 'consum', 0.0213, 'lps'),
	(515648, 128, '2014-02-01 00:39:10.000000', 'consum', 0.0217, 'lps'),
	(515649, 128, '2014-02-01 00:39:11.000000', 'consum', 0.0210, 'lps'),
	(515650, 128, '2014-02-01 00:39:12.000000', 'consum', 0.0215, 'lps'),
	(515651, 128, '2014-02-01 00:39:13.000000', 'consum', 0.0223, 'lps'),
	(515652, 128, '2014-02-01 00:39:14.000000', 'consum', 0.0218, 'lps'),
	(515653, 128, '2014-02-01 00:39:15.000000', 'consum', 0.0213, 'lps'),
	(515654, 128, '2014-02-01 00:39:16.000000', 'consum', 0.0216, 'lps'),
	(515655, 128, '2014-02-01 00:39:17.000000', 'consum', 0.0218, 'lps'),
	(515656, 128, '2014-02-01 00:39:18.000000', 'consum', 0.0218, 'lps'),
	(515657, 128, '2014-02-01 00:39:19.000000', 'consum', 0.0214, 'lps'),
	(515658, 128, '2014-02-01 00:39:20.000000', 'consum', 0.0220, 'lps'),
	(515659, 128, '2014-02-01 00:39:21.000000', 'consum', 0.0219, 'lps'),
	(515660, 128, '2014-02-01 00:39:22.000000', 'consum', 0.0212, 'lps'),
	(515661, 128, '2014-02-01 00:39:23.000000', 'consum', 0.0222, 'lps'),
	(515662, 128, '2014-02-01 00:39:24.000000', 'consum', 0.0221, 'lps'),
	(515663, 128, '2014-02-01 00:39:25.000000', 'consum', 0.0215, 'lps'),
	(515664, 128, '2014-02-01 00:39:26.000000', 'consum', 0.0219, 'lps'),
	(515665, 128, '2014-02-01 00:39:27.000000', 'consum', 0.0213, 'lps'),
	(515666, 128, '2014-02-01 00:39:28.000000', 'consum', 0.0211, 'lps'),
	(515667, 128, '2014-02-01 00:39:29.000000', 'consum', 0.0220, 'lps'),
	(515668, 128, '2014-02-01 00:39:30.000000', 'consum', 0.0218, 'lps'),
	(515669, 128, '2014-02-01 00:39:31.000000', 'consum', 0.0218, 'lps'),
	(515670, 128, '2014-02-01 00:39:32.000000', 'consum', 0.0215, 'lps'),
	(515671, 128, '2014-02-01 00:39:33.000000', 'consum', 0.0210, 'lps'),
	(515672, 128, '2014-02-01 00:39:34.000000', 'consum', 0.0211, 'lps'),
	(515673, 128, '2014-02-01 00:39:35.000000', 'consum', 0.0215, 'lps'),
	(515674, 128, '2014-02-01 00:39:36.000000', 'consum', 0.0216, 'lps'),
	(515675, 128, '2014-02-01 00:39:37.000000', 'consum', 0.0215, 'lps'),
	(515676, 128, '2014-02-01 00:39:38.000000', 'consum', 0.0215, 'lps'),
	(515677, 128, '2014-02-01 00:39:39.000000', 'consum', 0.0222, 'lps'),
	(515678, 128, '2014-02-01 00:39:40.000000', 'consum', 0.0215, 'lps'),
	(515679, 128, '2014-02-01 00:39:41.000000', 'consum', 0.0212, 'lps'),
	(515680, 128, '2014-02-01 00:39:42.000000', 'consum', 0.0218, 'lps'),
	(515681, 128, '2014-02-01 00:39:43.000000', 'consum', 0.0219, 'lps'),
	(515682, 128, '2014-02-01 00:39:44.000000', 'consum', 0.0215, 'lps'),
	(515683, 128, '2014-02-01 00:39:45.000000', 'consum', 0.0223, 'lps'),
	(515684, 128, '2014-02-01 00:39:46.000000', 'consum', 0.0220, 'lps'),
	(515685, 128, '2014-02-01 00:39:47.000000', 'consum', 0.0220, 'lps'),
	(515686, 128, '2014-02-01 00:39:48.000000', 'consum', 0.0219, 'lps'),
	(515687, 128, '2014-02-01 00:39:49.000000', 'consum', 0.0210, 'lps'),
	(515688, 128, '2014-02-01 00:39:50.000000', 'consum', 0.0211, 'lps'),
	(515689, 128, '2014-02-01 00:39:51.000000', 'consum', 0.0215, 'lps'),
	(515690, 128, '2014-02-01 00:39:52.000000', 'consum', 0.0219, 'lps'),
	(515691, 128, '2014-02-01 00:39:53.000000', 'consum', 0.0214, 'lps'),
	(515692, 128, '2014-02-01 00:39:54.000000', 'consum', 0.0216, 'lps'),
	(515693, 128, '2014-02-01 00:39:55.000000', 'consum', 0.0215, 'lps'),
	(515694, 128, '2014-02-01 00:39:56.000000', 'consum', 0.0218, 'lps'),
	(515695, 128, '2014-02-01 00:39:57.000000', 'consum', 0.0223, 'lps'),
	(515696, 128, '2014-02-01 00:39:58.000000', 'consum', 0.0222, 'lps'),
	(515697, 128, '2014-02-01 00:39:59.000000', 'consum', 0.0216, 'lps'),
	(515698, 128, '2014-02-01 00:40:00.000000', 'consum', 0.0218, 'lps'),
	(515699, 128, '2014-02-01 00:40:01.000000', 'consum', 0.0222, 'lps'),
	(515700, 128, '2014-02-01 00:40:02.000000', 'consum', 0.0216, 'lps'),
	(515701, 128, '2014-02-01 00:40:03.000000', 'consum', 0.0219, 'lps'),
	(515702, 128, '2014-02-01 00:40:04.000000', 'consum', 0.0222, 'lps'),
	(515703, 128, '2014-02-01 00:40:05.000000', 'consum', 0.0215, 'lps'),
	(515704, 128, '2014-02-01 00:40:06.000000', 'consum', 0.0216, 'lps'),
	(515705, 128, '2014-02-01 00:40:07.000000', 'consum', 0.0210, 'lps'),
	(515706, 128, '2014-02-01 00:40:08.000000', 'consum', 0.0221, 'lps'),
	(515707, 128, '2014-02-01 00:40:09.000000', 'consum', 0.0210, 'lps'),
	(515708, 128, '2014-02-01 00:40:10.000000', 'consum', 0.0221, 'lps'),
	(515709, 128, '2014-02-01 00:40:11.000000', 'consum', 0.0221, 'lps'),
	(515710, 128, '2014-02-01 00:40:12.000000', 'consum', 0.0218, 'lps'),
	(515711, 128, '2014-02-01 00:40:13.000000', 'consum', 0.0221, 'lps'),
	(515712, 128, '2014-02-01 00:40:14.000000', 'consum', 0.0210, 'lps'),
	(515713, 128, '2014-02-01 00:40:15.000000', 'consum', 0.0219, 'lps'),
	(515714, 128, '2014-02-01 00:40:16.000000', 'consum', 0.0215, 'lps'),
	(515715, 128, '2014-02-01 00:40:17.000000', 'consum', 0.0221, 'lps'),
	(515716, 128, '2014-02-01 00:40:18.000000', 'consum', 0.0223, 'lps'),
	(515717, 128, '2014-02-01 00:40:19.000000', 'consum', 0.0214, 'lps'),
	(515718, 128, '2014-02-01 00:40:20.000000', 'consum', 0.0220, 'lps'),
	(515719, 128, '2014-02-01 00:40:21.000000', 'consum', 0.0222, 'lps'),
	(515720, 128, '2014-02-01 00:40:22.000000', 'consum', 0.0211, 'lps'),
	(515721, 128, '2014-02-01 00:40:23.000000', 'consum', 0.0210, 'lps'),
	(515722, 128, '2014-02-01 00:40:24.000000', 'consum', 0.0219, 'lps'),
	(515723, 128, '2014-02-01 00:40:25.000000', 'consum', 0.0214, 'lps'),
	(515724, 128, '2014-02-01 00:40:26.000000', 'consum', 0.0217, 'lps'),
	(515725, 128, '2014-02-01 00:40:27.000000', 'consum', 0.0220, 'lps'),
	(515726, 128, '2014-02-01 00:40:28.000000', 'consum', 0.0210, 'lps'),
	(515727, 128, '2014-02-01 00:40:29.000000', 'consum', 0.0222, 'lps'),
	(515728, 128, '2014-02-01 00:40:30.000000', 'consum', 0.0215, 'lps'),
	(515729, 128, '2014-02-01 00:40:31.000000', 'consum', 0.0212, 'lps'),
	(515730, 128, '2014-02-01 00:40:32.000000', 'consum', 0.0221, 'lps'),
	(515731, 128, '2014-02-01 00:40:33.000000', 'consum', 0.0217, 'lps'),
	(515732, 128, '2014-02-01 00:40:34.000000', 'consum', 0.0213, 'lps'),
	(515733, 128, '2014-02-01 00:40:35.000000', 'consum', 0.0216, 'lps'),
	(515734, 128, '2014-02-01 00:40:36.000000', 'consum', 0.0221, 'lps'),
	(515735, 128, '2014-02-01 00:40:37.000000', 'consum', 0.0219, 'lps'),
	(515736, 128, '2014-02-01 00:40:38.000000', 'consum', 0.0222, 'lps'),
	(515737, 128, '2014-02-01 00:40:39.000000', 'consum', 0.0214, 'lps'),
	(515738, 128, '2014-02-01 00:40:40.000000', 'consum', 0.0222, 'lps'),
	(515739, 128, '2014-02-01 00:40:41.000000', 'consum', 0.0219, 'lps'),
	(515740, 128, '2014-02-01 00:40:42.000000', 'consum', 0.0216, 'lps'),
	(515741, 128, '2014-02-01 00:40:43.000000', 'consum', 0.0217, 'lps'),
	(515742, 128, '2014-02-01 00:40:44.000000', 'consum', 0.0213, 'lps'),
	(515743, 128, '2014-02-01 00:40:45.000000', 'consum', 0.0216, 'lps'),
	(515744, 128, '2014-02-01 00:40:46.000000', 'consum', 0.0220, 'lps'),
	(515745, 128, '2014-02-01 00:40:47.000000', 'consum', 0.0214, 'lps'),
	(515746, 128, '2014-02-01 00:40:48.000000', 'consum', 0.0214, 'lps'),
	(515747, 128, '2014-02-01 00:40:49.000000', 'consum', 0.0219, 'lps'),
	(515748, 128, '2014-02-01 00:40:50.000000', 'consum', 0.0214, 'lps'),
	(515749, 128, '2014-02-01 00:40:51.000000', 'consum', 0.0218, 'lps'),
	(515750, 128, '2014-02-01 00:40:52.000000', 'consum', 0.0212, 'lps'),
	(515751, 128, '2014-02-01 00:40:53.000000', 'consum', 0.0223, 'lps'),
	(515752, 128, '2014-02-01 00:40:54.000000', 'consum', 0.0216, 'lps'),
	(515753, 128, '2014-02-01 00:40:55.000000', 'consum', 0.0213, 'lps'),
	(515754, 128, '2014-02-01 00:40:56.000000', 'consum', 0.0223, 'lps'),
	(515755, 128, '2014-02-01 00:40:57.000000', 'consum', 0.0223, 'lps'),
	(515756, 128, '2014-02-01 00:40:58.000000', 'consum', 0.0222, 'lps'),
	(515757, 128, '2014-02-01 00:40:59.000000', 'consum', 0.0219, 'lps'),
	(515758, 128, '2014-02-01 00:41:00.000000', 'consum', 0.0220, 'lps'),
	(515759, 128, '2014-02-01 00:41:01.000000', 'consum', 0.0219, 'lps'),
	(515760, 128, '2014-02-01 00:41:02.000000', 'consum', 0.0212, 'lps'),
	(515761, 128, '2014-02-01 00:41:03.000000', 'consum', 0.0223, 'lps'),
	(515762, 128, '2014-02-01 00:41:04.000000', 'consum', 0.0211, 'lps'),
	(515763, 128, '2014-02-01 00:41:05.000000', 'consum', 0.0220, 'lps'),
	(515764, 128, '2014-02-01 00:41:06.000000', 'consum', 0.0214, 'lps'),
	(515765, 128, '2014-02-01 00:41:07.000000', 'consum', 0.0216, 'lps'),
	(515766, 128, '2014-02-01 00:41:08.000000', 'consum', 0.0216, 'lps'),
	(515767, 128, '2014-02-01 00:41:09.000000', 'consum', 0.0221, 'lps'),
	(515768, 128, '2014-02-01 00:41:10.000000', 'consum', 0.0218, 'lps'),
	(515769, 128, '2014-02-01 00:41:11.000000', 'consum', 0.0220, 'lps'),
	(515770, 128, '2014-02-01 00:41:12.000000', 'consum', 0.0223, 'lps'),
	(515771, 128, '2014-02-01 00:41:13.000000', 'consum', 0.0218, 'lps'),
	(515772, 128, '2014-02-01 00:41:14.000000', 'consum', 0.0210, 'lps'),
	(515773, 128, '2014-02-01 00:41:15.000000', 'consum', 0.0214, 'lps'),
	(515774, 128, '2014-02-01 00:41:16.000000', 'consum', 0.0218, 'lps'),
	(515775, 128, '2014-02-01 00:41:17.000000', 'consum', 0.0222, 'lps'),
	(515776, 128, '2014-02-01 00:41:18.000000', 'consum', 0.0219, 'lps'),
	(515777, 128, '2014-02-01 00:41:19.000000', 'consum', 0.0219, 'lps'),
	(515778, 128, '2014-02-01 00:41:20.000000', 'consum', 0.0217, 'lps'),
	(515779, 128, '2014-02-01 00:41:21.000000', 'consum', 0.0216, 'lps'),
	(515780, 128, '2014-02-01 00:41:22.000000', 'consum', 0.0220, 'lps'),
	(515781, 128, '2014-02-01 00:41:23.000000', 'consum', 0.0214, 'lps'),
	(515782, 128, '2014-02-01 00:41:24.000000', 'consum', 0.0214, 'lps'),
	(515783, 128, '2014-02-01 00:41:25.000000', 'consum', 0.0218, 'lps'),
	(515784, 128, '2014-02-01 00:41:26.000000', 'consum', 0.0212, 'lps'),
	(515785, 128, '2014-02-01 00:41:27.000000', 'consum', 0.0223, 'lps'),
	(515786, 128, '2014-02-01 00:41:28.000000', 'consum', 0.0216, 'lps'),
	(515787, 128, '2014-02-01 00:41:29.000000', 'consum', 0.0213, 'lps'),
	(515788, 128, '2014-02-01 00:41:30.000000', 'consum', 0.0222, 'lps'),
	(515789, 128, '2014-02-01 00:41:31.000000', 'consum', 0.0221, 'lps'),
	(515790, 128, '2014-02-01 00:41:32.000000', 'consum', 0.0214, 'lps'),
	(515791, 128, '2014-02-01 00:41:33.000000', 'consum', 0.0211, 'lps'),
	(515792, 128, '2014-02-01 00:41:34.000000', 'consum', 0.0216, 'lps'),
	(515793, 128, '2014-02-01 00:41:35.000000', 'consum', 0.0212, 'lps'),
	(515794, 128, '2014-02-01 00:41:36.000000', 'consum', 0.0215, 'lps'),
	(515795, 128, '2014-02-01 00:41:37.000000', 'consum', 0.0216, 'lps'),
	(515796, 128, '2014-02-01 00:41:38.000000', 'consum', 0.0212, 'lps'),
	(515797, 128, '2014-02-01 00:41:39.000000', 'consum', 0.0217, 'lps'),
	(515798, 128, '2014-02-01 00:41:40.000000', 'consum', 0.0210, 'lps'),
	(515799, 128, '2014-02-01 00:41:41.000000', 'consum', 0.0219, 'lps'),
	(515800, 128, '2014-02-01 00:41:42.000000', 'consum', 0.0213, 'lps'),
	(515801, 128, '2014-02-01 00:41:43.000000', 'consum', 0.0211, 'lps'),
	(515802, 128, '2014-02-01 00:41:44.000000', 'consum', 0.0223, 'lps'),
	(515803, 128, '2014-02-01 00:41:45.000000', 'consum', 0.0216, 'lps'),
	(515804, 128, '2014-02-01 00:41:46.000000', 'consum', 0.0217, 'lps'),
	(515805, 128, '2014-02-01 00:41:47.000000', 'consum', 0.0212, 'lps'),
	(515806, 128, '2014-02-01 00:41:48.000000', 'consum', 0.0212, 'lps'),
	(515807, 128, '2014-02-01 00:41:49.000000', 'consum', 0.0216, 'lps'),
	(515808, 128, '2014-02-01 00:41:50.000000', 'consum', 0.0219, 'lps'),
	(515809, 128, '2014-02-01 00:41:51.000000', 'consum', 0.0211, 'lps'),
	(515810, 128, '2014-02-01 00:41:52.000000', 'consum', 0.0218, 'lps'),
	(515811, 128, '2014-02-01 00:41:53.000000', 'consum', 0.0219, 'lps'),
	(515812, 128, '2014-02-01 00:41:54.000000', 'consum', 0.0215, 'lps'),
	(515813, 128, '2014-02-01 00:41:55.000000', 'consum', 0.0223, 'lps'),
	(515814, 128, '2014-02-01 00:41:56.000000', 'consum', 0.0220, 'lps'),
	(515815, 128, '2014-02-01 00:41:57.000000', 'consum', 0.0221, 'lps'),
	(515816, 128, '2014-02-01 00:41:58.000000', 'consum', 0.0222, 'lps'),
	(515817, 128, '2014-02-01 00:41:59.000000', 'consum', 0.0211, 'lps'),
	(515818, 128, '2014-02-01 00:42:00.000000', 'consum', 0.0220, 'lps'),
	(515819, 128, '2014-02-01 00:42:01.000000', 'consum', 0.0215, 'lps'),
	(515820, 128, '2014-02-01 00:42:02.000000', 'consum', 0.0221, 'lps'),
	(515821, 128, '2014-02-01 00:42:03.000000', 'consum', 0.0221, 'lps'),
	(515822, 128, '2014-02-01 00:42:04.000000', 'consum', 0.0218, 'lps'),
	(515823, 128, '2014-02-01 00:42:05.000000', 'consum', 0.0219, 'lps'),
	(515824, 128, '2014-02-01 00:42:06.000000', 'consum', 0.0216, 'lps'),
	(515825, 128, '2014-02-01 00:42:07.000000', 'consum', 0.0216, 'lps'),
	(515826, 128, '2014-02-01 00:42:08.000000', 'consum', 0.0219, 'lps'),
	(515827, 128, '2014-02-01 00:42:09.000000', 'consum', 0.0213, 'lps'),
	(515828, 128, '2014-02-01 00:42:10.000000', 'consum', 0.0210, 'lps'),
	(515829, 128, '2014-02-01 00:42:11.000000', 'consum', 0.0216, 'lps'),
	(515830, 128, '2014-02-01 00:42:12.000000', 'consum', 0.0213, 'lps'),
	(515831, 128, '2014-02-01 00:42:13.000000', 'consum', 0.0222, 'lps'),
	(515832, 128, '2014-02-01 00:42:14.000000', 'consum', 0.0218, 'lps'),
	(515833, 128, '2014-02-01 00:42:15.000000', 'consum', 0.0217, 'lps'),
	(515834, 128, '2014-02-01 00:42:16.000000', 'consum', 0.0219, 'lps'),
	(515835, 128, '2014-02-01 00:42:17.000000', 'consum', 0.0219, 'lps'),
	(515836, 128, '2014-02-01 00:42:18.000000', 'consum', 0.0218, 'lps'),
	(515837, 128, '2014-02-01 00:42:19.000000', 'consum', 0.0221, 'lps'),
	(515838, 128, '2014-02-01 00:42:20.000000', 'consum', 0.0214, 'lps'),
	(515839, 128, '2014-02-01 00:42:21.000000', 'consum', 0.0212, 'lps'),
	(515840, 128, '2014-02-01 00:42:22.000000', 'consum', 0.0223, 'lps'),
	(515841, 128, '2014-02-01 00:42:23.000000', 'consum', 0.0215, 'lps'),
	(515842, 128, '2014-02-01 00:42:24.000000', 'consum', 0.0221, 'lps'),
	(515843, 128, '2014-02-01 00:42:25.000000', 'consum', 0.0210, 'lps'),
	(515844, 128, '2014-02-01 00:42:26.000000', 'consum', 0.0220, 'lps'),
	(515845, 128, '2014-02-01 00:42:27.000000', 'consum', 0.0219, 'lps'),
	(515846, 128, '2014-02-01 00:42:28.000000', 'consum', 0.0213, 'lps'),
	(515847, 128, '2014-02-01 00:42:29.000000', 'consum', 0.0211, 'lps'),
	(515848, 128, '2014-02-01 00:42:30.000000', 'consum', 0.0220, 'lps'),
	(515849, 128, '2014-02-01 00:42:31.000000', 'consum', 0.0216, 'lps'),
	(515850, 128, '2014-02-01 00:42:32.000000', 'consum', 0.0211, 'lps'),
	(515851, 128, '2014-02-01 00:42:33.000000', 'consum', 0.0210, 'lps'),
	(515852, 128, '2014-02-01 00:42:34.000000', 'consum', 0.0210, 'lps'),
	(515853, 128, '2014-02-01 00:42:35.000000', 'consum', 0.0223, 'lps'),
	(515854, 128, '2014-02-01 00:42:36.000000', 'consum', 0.0220, 'lps'),
	(515855, 128, '2014-02-01 00:42:37.000000', 'consum', 0.0222, 'lps'),
	(515856, 128, '2014-02-01 00:42:38.000000', 'consum', 0.0211, 'lps'),
	(515857, 128, '2014-02-01 00:42:39.000000', 'consum', 0.0221, 'lps'),
	(515858, 128, '2014-02-01 00:42:40.000000', 'consum', 0.0221, 'lps'),
	(515859, 128, '2014-02-01 00:42:41.000000', 'consum', 0.0219, 'lps'),
	(515860, 128, '2014-02-01 00:42:42.000000', 'consum', 0.0223, 'lps'),
	(515861, 128, '2014-02-01 00:42:43.000000', 'consum', 0.0222, 'lps'),
	(515862, 128, '2014-02-01 00:42:44.000000', 'consum', 0.0214, 'lps'),
	(515863, 128, '2014-02-01 00:42:45.000000', 'consum', 0.0212, 'lps'),
	(515864, 128, '2014-02-01 00:42:46.000000', 'consum', 0.0220, 'lps'),
	(515865, 128, '2014-02-01 00:42:47.000000', 'consum', 0.0211, 'lps'),
	(515866, 128, '2014-02-01 00:42:48.000000', 'consum', 0.0217, 'lps'),
	(515867, 128, '2014-02-01 00:42:49.000000', 'consum', 0.0214, 'lps'),
	(515868, 128, '2014-02-01 00:42:50.000000', 'consum', 0.0223, 'lps'),
	(515869, 128, '2014-02-01 00:42:51.000000', 'consum', 0.0222, 'lps'),
	(515870, 128, '2014-02-01 00:42:52.000000', 'consum', 0.0216, 'lps'),
	(515871, 128, '2014-02-01 00:42:53.000000', 'consum', 0.0218, 'lps'),
	(515872, 128, '2014-02-01 00:42:54.000000', 'consum', 0.0220, 'lps'),
	(515873, 128, '2014-02-01 00:42:55.000000', 'consum', 0.0210, 'lps'),
	(515874, 128, '2014-02-01 00:42:56.000000', 'consum', 0.0222, 'lps'),
	(515875, 128, '2014-02-01 00:42:57.000000', 'consum', 0.0213, 'lps'),
	(515876, 128, '2014-02-01 00:42:58.000000', 'consum', 0.0219, 'lps'),
	(515877, 128, '2014-02-01 00:42:59.000000', 'consum', 0.0219, 'lps'),
	(515878, 128, '2014-02-01 00:43:00.000000', 'consum', 0.0214, 'lps'),
	(515879, 128, '2014-02-01 00:43:01.000000', 'consum', 0.0216, 'lps'),
	(515880, 128, '2014-02-01 00:43:02.000000', 'consum', 0.0215, 'lps'),
	(515881, 128, '2014-02-01 00:43:03.000000', 'consum', 0.0219, 'lps'),
	(515882, 128, '2014-02-01 00:43:04.000000', 'consum', 0.0210, 'lps'),
	(515883, 128, '2014-02-01 00:43:05.000000', 'consum', 0.0214, 'lps'),
	(515884, 128, '2014-02-01 00:43:06.000000', 'consum', 0.0214, 'lps'),
	(515885, 128, '2014-02-01 00:43:07.000000', 'consum', 0.0219, 'lps'),
	(515886, 128, '2014-02-01 00:43:08.000000', 'consum', 0.0214, 'lps'),
	(515887, 128, '2014-02-01 00:43:09.000000', 'consum', 0.0221, 'lps'),
	(515888, 128, '2014-02-01 00:43:10.000000', 'consum', 0.0210, 'lps'),
	(515889, 128, '2014-02-01 00:43:11.000000', 'consum', 0.0217, 'lps'),
	(515890, 128, '2014-02-01 00:43:12.000000', 'consum', 0.0221, 'lps'),
	(515891, 128, '2014-02-01 00:43:13.000000', 'consum', 0.0216, 'lps'),
	(515892, 128, '2014-02-01 00:43:14.000000', 'consum', 0.0221, 'lps'),
	(515893, 128, '2014-02-01 00:43:15.000000', 'consum', 0.0220, 'lps'),
	(515894, 128, '2014-02-01 00:43:16.000000', 'consum', 0.0215, 'lps'),
	(515895, 128, '2014-02-01 00:43:17.000000', 'consum', 0.0219, 'lps'),
	(515896, 128, '2014-02-01 00:43:18.000000', 'consum', 0.0211, 'lps'),
	(515897, 128, '2014-02-01 00:43:19.000000', 'consum', 0.0218, 'lps'),
	(515898, 128, '2014-02-01 00:43:20.000000', 'consum', 0.0221, 'lps'),
	(515899, 128, '2014-02-01 00:43:21.000000', 'consum', 0.0211, 'lps'),
	(515900, 128, '2014-02-01 00:43:22.000000', 'consum', 0.0212, 'lps'),
	(515901, 128, '2014-02-01 00:43:23.000000', 'consum', 0.0216, 'lps'),
	(515902, 128, '2014-02-01 00:43:24.000000', 'consum', 0.0223, 'lps'),
	(515903, 128, '2014-02-01 00:43:25.000000', 'consum', 0.0215, 'lps'),
	(515904, 128, '2014-02-01 00:43:26.000000', 'consum', 0.0223, 'lps'),
	(515905, 128, '2014-02-01 00:43:27.000000', 'consum', 0.0218, 'lps'),
	(515906, 128, '2014-02-01 00:43:28.000000', 'consum', 0.0214, 'lps'),
	(515907, 128, '2014-02-01 00:43:29.000000', 'consum', 0.0220, 'lps'),
	(515908, 128, '2014-02-01 00:43:30.000000', 'consum', 0.0220, 'lps'),
	(515909, 128, '2014-02-01 00:43:31.000000', 'consum', 0.0217, 'lps'),
	(515910, 128, '2014-02-01 00:43:32.000000', 'consum', 0.0216, 'lps'),
	(515911, 128, '2014-02-01 00:43:33.000000', 'consum', 0.0220, 'lps'),
	(515912, 128, '2014-02-01 00:43:34.000000', 'consum', 0.0213, 'lps'),
	(515913, 128, '2014-02-01 00:43:35.000000', 'consum', 0.0223, 'lps'),
	(515914, 128, '2014-02-01 00:43:36.000000', 'consum', 0.0210, 'lps'),
	(515915, 128, '2014-02-01 00:43:37.000000', 'consum', 0.0214, 'lps'),
	(515916, 128, '2014-02-01 00:43:38.000000', 'consum', 0.0218, 'lps'),
	(515917, 128, '2014-02-01 00:43:39.000000', 'consum', 0.0211, 'lps'),
	(515918, 128, '2014-02-01 00:43:40.000000', 'consum', 0.0220, 'lps'),
	(515919, 128, '2014-02-01 00:43:41.000000', 'consum', 0.0215, 'lps'),
	(515920, 128, '2014-02-01 00:43:42.000000', 'consum', 0.0217, 'lps'),
	(515921, 128, '2014-02-01 00:43:43.000000', 'consum', 0.0220, 'lps'),
	(515922, 128, '2014-02-01 00:43:44.000000', 'consum', 0.0210, 'lps'),
	(515923, 128, '2014-02-01 00:43:45.000000', 'consum', 0.0223, 'lps'),
	(515924, 128, '2014-02-01 00:43:46.000000', 'consum', 0.0220, 'lps'),
	(515925, 128, '2014-02-01 00:43:47.000000', 'consum', 0.0220, 'lps'),
	(515926, 128, '2014-02-01 00:43:48.000000', 'consum', 0.0219, 'lps'),
	(515927, 128, '2014-02-01 00:43:49.000000', 'consum', 0.0210, 'lps'),
	(515928, 128, '2014-02-01 00:43:50.000000', 'consum', 0.0210, 'lps'),
	(515929, 128, '2014-02-01 00:43:51.000000', 'consum', 0.0210, 'lps'),
	(515930, 128, '2014-02-01 00:43:52.000000', 'consum', 0.0213, 'lps'),
	(515931, 128, '2014-02-01 00:43:53.000000', 'consum', 0.0210, 'lps'),
	(515932, 128, '2014-02-01 00:43:54.000000', 'consum', 0.0214, 'lps'),
	(515933, 128, '2014-02-01 00:43:55.000000', 'consum', 0.0217, 'lps'),
	(515934, 128, '2014-02-01 00:43:56.000000', 'consum', 0.0221, 'lps'),
	(515935, 128, '2014-02-01 00:43:57.000000', 'consum', 0.0217, 'lps'),
	(515936, 128, '2014-02-01 00:43:58.000000', 'consum', 0.0211, 'lps'),
	(515937, 128, '2014-02-01 00:43:59.000000', 'consum', 0.0223, 'lps'),
	(515938, 128, '2014-02-01 00:44:00.000000', 'consum', 0.0216, 'lps'),
	(515939, 128, '2014-02-01 00:44:01.000000', 'consum', 0.0217, 'lps'),
	(515940, 128, '2014-02-01 00:44:02.000000', 'consum', 0.0212, 'lps'),
	(515941, 128, '2014-02-01 00:44:03.000000', 'consum', 0.0214, 'lps'),
	(515942, 128, '2014-02-01 00:44:04.000000', 'consum', 0.0211, 'lps'),
	(515943, 128, '2014-02-01 00:44:05.000000', 'consum', 0.0215, 'lps'),
	(515944, 128, '2014-02-01 00:44:06.000000', 'consum', 0.0220, 'lps'),
	(515945, 128, '2014-02-01 00:44:07.000000', 'consum', 0.0218, 'lps'),
	(515946, 128, '2014-02-01 00:44:08.000000', 'consum', 0.0220, 'lps'),
	(515947, 128, '2014-02-01 00:44:09.000000', 'consum', 0.0223, 'lps'),
	(515948, 128, '2014-02-01 00:44:10.000000', 'consum', 0.0217, 'lps'),
	(515949, 128, '2014-02-01 00:44:11.000000', 'consum', 0.0219, 'lps'),
	(515950, 128, '2014-02-01 00:44:12.000000', 'consum', 0.0222, 'lps'),
	(515951, 128, '2014-02-01 00:44:13.000000', 'consum', 0.0216, 'lps'),
	(515952, 128, '2014-02-01 00:44:14.000000', 'consum', 0.0219, 'lps'),
	(515953, 128, '2014-02-01 00:44:15.000000', 'consum', 0.0210, 'lps'),
	(515954, 128, '2014-02-01 00:44:16.000000', 'consum', 0.0210, 'lps'),
	(515955, 128, '2014-02-01 00:44:17.000000', 'consum', 0.0212, 'lps'),
	(515956, 128, '2014-02-01 00:44:18.000000', 'consum', 0.0222, 'lps'),
	(515957, 128, '2014-02-01 00:44:19.000000', 'consum', 0.0219, 'lps'),
	(515958, 128, '2014-02-01 00:44:20.000000', 'consum', 0.0221, 'lps'),
	(515959, 128, '2014-02-01 00:44:21.000000', 'consum', 0.0210, 'lps'),
	(515960, 128, '2014-02-01 00:44:22.000000', 'consum', 0.0221, 'lps'),
	(515961, 128, '2014-02-01 00:44:23.000000', 'consum', 0.0223, 'lps'),
	(515962, 128, '2014-02-01 00:44:24.000000', 'consum', 0.0215, 'lps'),
	(515963, 128, '2014-02-01 00:44:25.000000', 'consum', 0.0211, 'lps'),
	(515964, 128, '2014-02-01 00:44:26.000000', 'consum', 0.0213, 'lps'),
	(515965, 128, '2014-02-01 00:44:27.000000', 'consum', 0.0222, 'lps'),
	(515966, 128, '2014-02-01 00:44:28.000000', 'consum', 0.0222, 'lps'),
	(515967, 128, '2014-02-01 00:44:29.000000', 'consum', 0.0219, 'lps'),
	(515968, 128, '2014-02-01 00:44:30.000000', 'consum', 0.0218, 'lps'),
	(515969, 128, '2014-02-01 00:44:31.000000', 'consum', 0.0210, 'lps'),
	(515970, 128, '2014-02-01 00:44:32.000000', 'consum', 0.0217, 'lps'),
	(515971, 128, '2014-02-01 00:44:33.000000', 'consum', 0.0216, 'lps'),
	(515972, 128, '2014-02-01 00:44:34.000000', 'consum', 0.0219, 'lps'),
	(515973, 128, '2014-02-01 00:44:35.000000', 'consum', 0.0211, 'lps'),
	(515974, 128, '2014-02-01 00:44:36.000000', 'consum', 0.0217, 'lps'),
	(515975, 128, '2014-02-01 00:44:37.000000', 'consum', 0.0215, 'lps'),
	(515976, 128, '2014-02-01 00:44:38.000000', 'consum', 0.0212, 'lps'),
	(515977, 128, '2014-02-01 00:44:39.000000', 'consum', 0.0219, 'lps'),
	(515978, 128, '2014-02-01 00:44:40.000000', 'consum', 0.0221, 'lps'),
	(515979, 128, '2014-02-01 00:44:41.000000', 'consum', 0.0211, 'lps'),
	(515980, 128, '2014-02-01 00:44:42.000000', 'consum', 0.0212, 'lps'),
	(515981, 128, '2014-02-01 00:44:43.000000', 'consum', 0.0215, 'lps'),
	(515982, 128, '2014-02-01 00:44:44.000000', 'consum', 0.0218, 'lps'),
	(515983, 128, '2014-02-01 00:44:45.000000', 'consum', 0.0222, 'lps'),
	(515984, 128, '2014-02-01 00:44:46.000000', 'consum', 0.0217, 'lps'),
	(515985, 128, '2014-02-01 00:44:47.000000', 'consum', 0.0222, 'lps'),
	(515986, 128, '2014-02-01 00:44:48.000000', 'consum', 0.0223, 'lps'),
	(515987, 128, '2014-02-01 00:44:49.000000', 'consum', 0.0211, 'lps'),
	(515988, 128, '2014-02-01 00:44:50.000000', 'consum', 0.0220, 'lps'),
	(515989, 128, '2014-02-01 00:44:51.000000', 'consum', 0.0217, 'lps'),
	(515990, 128, '2014-02-01 00:44:52.000000', 'consum', 0.0212, 'lps'),
	(515991, 128, '2014-02-01 00:44:53.000000', 'consum', 0.0214, 'lps'),
	(515992, 128, '2014-02-01 00:44:54.000000', 'consum', 0.0212, 'lps'),
	(515993, 128, '2014-02-01 00:44:55.000000', 'consum', 0.0222, 'lps'),
	(515994, 128, '2014-02-01 00:44:56.000000', 'consum', 0.0221, 'lps'),
	(515995, 128, '2014-02-01 00:44:57.000000', 'consum', 0.0217, 'lps'),
	(515996, 128, '2014-02-01 00:44:58.000000', 'consum', 0.0211, 'lps'),
	(515997, 128, '2014-02-01 00:44:59.000000', 'consum', 0.0223, 'lps'),
	(515998, 128, '2014-02-01 00:45:00.000000', 'consum', 0.0215, 'lps'),
	(515999, 128, '2014-02-01 00:45:01.000000', 'consum', 0.0211, 'lps'),
	(516000, 128, '2014-02-01 00:45:02.000000', 'consum', 0.0216, 'lps'),
	(516001, 128, '2014-02-01 00:45:03.000000', 'consum', 0.0221, 'lps'),
	(516002, 128, '2014-02-01 00:45:04.000000', 'consum', 0.0223, 'lps'),
	(516003, 128, '2014-02-01 00:45:05.000000', 'consum', 0.0211, 'lps'),
	(516004, 128, '2014-02-01 00:45:06.000000', 'consum', 0.0222, 'lps'),
	(516005, 128, '2014-02-01 00:45:07.000000', 'consum', 0.0222, 'lps'),
	(516006, 128, '2014-02-01 00:45:08.000000', 'consum', 0.0221, 'lps'),
	(516007, 128, '2014-02-01 00:45:09.000000', 'consum', 0.0218, 'lps'),
	(516008, 128, '2014-02-01 00:45:10.000000', 'consum', 0.0214, 'lps'),
	(516009, 128, '2014-02-01 00:45:11.000000', 'consum', 0.0210, 'lps'),
	(516010, 128, '2014-02-01 00:45:12.000000', 'consum', 0.0223, 'lps'),
	(516011, 128, '2014-02-01 00:45:13.000000', 'consum', 0.0223, 'lps'),
	(516012, 128, '2014-02-01 00:45:14.000000', 'consum', 0.0220, 'lps'),
	(516013, 128, '2014-02-01 00:45:15.000000', 'consum', 0.0221, 'lps'),
	(516014, 128, '2014-02-01 00:45:16.000000', 'consum', 0.0221, 'lps'),
	(516015, 128, '2014-02-01 00:45:17.000000', 'consum', 0.0219, 'lps'),
	(516016, 128, '2014-02-01 00:45:18.000000', 'consum', 0.0223, 'lps'),
	(516017, 128, '2014-02-01 00:45:19.000000', 'consum', 0.0220, 'lps'),
	(516018, 128, '2014-02-01 00:45:20.000000', 'consum', 0.0223, 'lps'),
	(516019, 128, '2014-02-01 00:45:21.000000', 'consum', 0.0216, 'lps'),
	(516020, 128, '2014-02-01 00:45:22.000000', 'consum', 0.0217, 'lps'),
	(516021, 128, '2014-02-01 00:45:23.000000', 'consum', 0.0213, 'lps'),
	(516022, 128, '2014-02-01 00:45:24.000000', 'consum', 0.0219, 'lps'),
	(516023, 128, '2014-02-01 00:45:25.000000', 'consum', 0.0218, 'lps'),
	(516024, 128, '2014-02-01 00:45:26.000000', 'consum', 0.0210, 'lps'),
	(516025, 128, '2014-02-01 00:45:27.000000', 'consum', 0.0214, 'lps'),
	(516026, 128, '2014-02-01 00:45:28.000000', 'consum', 0.0216, 'lps'),
	(516027, 128, '2014-02-01 00:45:29.000000', 'consum', 0.0217, 'lps'),
	(516028, 128, '2014-02-01 00:45:30.000000', 'consum', 0.0212, 'lps'),
	(516029, 128, '2014-02-01 00:45:31.000000', 'consum', 0.0212, 'lps'),
	(516030, 128, '2014-02-01 00:45:32.000000', 'consum', 0.0215, 'lps'),
	(516031, 128, '2014-02-01 00:45:33.000000', 'consum', 0.0216, 'lps'),
	(516032, 128, '2014-02-01 00:45:34.000000', 'consum', 0.0213, 'lps'),
	(516033, 128, '2014-02-01 00:45:35.000000', 'consum', 0.0221, 'lps'),
	(516034, 128, '2014-02-01 00:45:36.000000', 'consum', 0.0213, 'lps'),
	(516035, 128, '2014-02-01 00:45:37.000000', 'consum', 0.0223, 'lps'),
	(516036, 128, '2014-02-01 00:45:38.000000', 'consum', 0.0211, 'lps'),
	(516037, 128, '2014-02-01 00:45:39.000000', 'consum', 0.0217, 'lps'),
	(516038, 128, '2014-02-01 00:45:40.000000', 'consum', 0.0216, 'lps'),
	(516039, 128, '2014-02-01 00:45:41.000000', 'consum', 0.0218, 'lps'),
	(516040, 128, '2014-02-01 00:45:42.000000', 'consum', 0.0218, 'lps'),
	(516041, 128, '2014-02-01 00:45:43.000000', 'consum', 0.0214, 'lps'),
	(516042, 128, '2014-02-01 00:45:44.000000', 'consum', 0.0220, 'lps'),
	(516043, 128, '2014-02-01 00:45:45.000000', 'consum', 0.0221, 'lps'),
	(516044, 128, '2014-02-01 00:45:46.000000', 'consum', 0.0219, 'lps'),
	(516045, 128, '2014-02-01 00:45:47.000000', 'consum', 0.0210, 'lps'),
	(516046, 128, '2014-02-01 00:45:48.000000', 'consum', 0.0213, 'lps'),
	(516047, 128, '2014-02-01 00:45:49.000000', 'consum', 0.0211, 'lps'),
	(516048, 128, '2014-02-01 00:45:50.000000', 'consum', 0.0220, 'lps'),
	(516049, 128, '2014-02-01 00:45:51.000000', 'consum', 0.0216, 'lps'),
	(516050, 128, '2014-02-01 00:45:52.000000', 'consum', 0.0212, 'lps'),
	(516051, 128, '2014-02-01 00:45:53.000000', 'consum', 0.0216, 'lps'),
	(516052, 128, '2014-02-01 00:45:54.000000', 'consum', 0.0221, 'lps'),
	(516053, 128, '2014-02-01 00:45:55.000000', 'consum', 0.0217, 'lps'),
	(516054, 128, '2014-02-01 00:45:56.000000', 'consum', 0.0213, 'lps'),
	(516055, 128, '2014-02-01 00:45:57.000000', 'consum', 0.0221, 'lps'),
	(516056, 128, '2014-02-01 00:45:58.000000', 'consum', 0.0211, 'lps'),
	(516057, 128, '2014-02-01 00:45:59.000000', 'consum', 0.0213, 'lps'),
	(516058, 128, '2014-02-01 00:46:00.000000', 'consum', 0.0221, 'lps'),
	(516059, 128, '2014-02-01 00:46:01.000000', 'consum', 0.0213, 'lps'),
	(516060, 128, '2014-02-01 00:46:02.000000', 'consum', 0.0223, 'lps'),
	(516061, 128, '2014-02-01 00:46:03.000000', 'consum', 0.0223, 'lps'),
	(516062, 128, '2014-02-01 00:46:04.000000', 'consum', 0.0222, 'lps'),
	(516063, 128, '2014-02-01 00:46:05.000000', 'consum', 0.0217, 'lps'),
	(516064, 128, '2014-02-01 00:46:06.000000', 'consum', 0.0223, 'lps'),
	(516065, 128, '2014-02-01 00:46:07.000000', 'consum', 0.0215, 'lps'),
	(516066, 128, '2014-02-01 00:46:08.000000', 'consum', 0.0222, 'lps'),
	(516067, 128, '2014-02-01 00:46:09.000000', 'consum', 0.0216, 'lps'),
	(516068, 128, '2014-02-01 00:46:10.000000', 'consum', 0.0219, 'lps'),
	(516069, 128, '2014-02-01 00:46:11.000000', 'consum', 0.0222, 'lps'),
	(516070, 128, '2014-02-01 00:46:12.000000', 'consum', 0.0215, 'lps'),
	(516071, 128, '2014-02-01 00:46:13.000000', 'consum', 0.0214, 'lps'),
	(516072, 128, '2014-02-01 00:46:14.000000', 'consum', 0.0213, 'lps'),
	(516073, 128, '2014-02-01 00:46:15.000000', 'consum', 0.0217, 'lps'),
	(516074, 128, '2014-02-01 00:46:16.000000', 'consum', 0.0222, 'lps'),
	(516075, 128, '2014-02-01 00:46:17.000000', 'consum', 0.0222, 'lps'),
	(516076, 128, '2014-02-01 00:46:18.000000', 'consum', 0.0220, 'lps'),
	(516077, 128, '2014-02-01 00:46:19.000000', 'consum', 0.0210, 'lps'),
	(516078, 128, '2014-02-01 00:46:20.000000', 'consum', 0.0210, 'lps'),
	(516079, 128, '2014-02-01 00:46:21.000000', 'consum', 0.0211, 'lps'),
	(516080, 128, '2014-02-01 00:46:22.000000', 'consum', 0.0215, 'lps'),
	(516081, 128, '2014-02-01 00:46:23.000000', 'consum', 0.0217, 'lps'),
	(516082, 128, '2014-02-01 00:46:24.000000', 'consum', 0.0217, 'lps'),
	(516083, 128, '2014-02-01 00:46:25.000000', 'consum', 0.0223, 'lps'),
	(516084, 128, '2014-02-01 00:46:26.000000', 'consum', 0.0212, 'lps'),
	(516085, 128, '2014-02-01 00:46:27.000000', 'consum', 0.0210, 'lps'),
	(516086, 128, '2014-02-01 00:46:28.000000', 'consum', 0.0220, 'lps'),
	(516087, 128, '2014-02-01 00:46:29.000000', 'consum', 0.0220, 'lps'),
	(516088, 128, '2014-02-01 00:46:30.000000', 'consum', 0.0214, 'lps'),
	(516089, 128, '2014-02-01 00:46:31.000000', 'consum', 0.0215, 'lps'),
	(516090, 128, '2014-02-01 00:46:32.000000', 'consum', 0.0222, 'lps'),
	(516091, 128, '2014-02-01 00:46:33.000000', 'consum', 0.0214, 'lps'),
	(516092, 128, '2014-02-01 00:46:34.000000', 'consum', 0.0221, 'lps'),
	(516093, 128, '2014-02-01 00:46:35.000000', 'consum', 0.0214, 'lps'),
	(516094, 128, '2014-02-01 00:46:36.000000', 'consum', 0.0212, 'lps'),
	(516095, 128, '2014-02-01 00:46:37.000000', 'consum', 0.0220, 'lps'),
	(516096, 128, '2014-02-01 00:46:38.000000', 'consum', 0.0215, 'lps'),
	(516097, 128, '2014-02-01 00:46:39.000000', 'consum', 0.0218, 'lps'),
	(516098, 128, '2014-02-01 00:46:40.000000', 'consum', 0.0210, 'lps'),
	(516099, 128, '2014-02-01 00:46:41.000000', 'consum', 0.0211, 'lps'),
	(516100, 128, '2014-02-01 00:46:42.000000', 'consum', 0.0217, 'lps'),
	(516101, 128, '2014-02-01 00:46:43.000000', 'consum', 0.0214, 'lps'),
	(516102, 128, '2014-02-01 00:46:44.000000', 'consum', 0.0210, 'lps'),
	(516103, 128, '2014-02-01 00:46:45.000000', 'consum', 0.0214, 'lps'),
	(516104, 128, '2014-02-01 00:46:46.000000', 'consum', 0.0215, 'lps'),
	(516105, 128, '2014-02-01 00:46:47.000000', 'consum', 0.0210, 'lps'),
	(516106, 128, '2014-02-01 00:46:48.000000', 'consum', 0.0211, 'lps'),
	(516107, 128, '2014-02-01 00:46:49.000000', 'consum', 0.0215, 'lps'),
	(516108, 128, '2014-02-01 00:46:50.000000', 'consum', 0.0218, 'lps'),
	(516109, 128, '2014-02-01 00:46:51.000000', 'consum', 0.0220, 'lps'),
	(516110, 128, '2014-02-01 00:46:52.000000', 'consum', 0.0210, 'lps'),
	(516111, 128, '2014-02-01 00:46:53.000000', 'consum', 0.0220, 'lps'),
	(516112, 128, '2014-02-01 00:46:54.000000', 'consum', 0.0221, 'lps'),
	(516113, 128, '2014-02-01 00:46:55.000000', 'consum', 0.0219, 'lps'),
	(516114, 128, '2014-02-01 00:46:56.000000', 'consum', 0.0223, 'lps'),
	(516115, 128, '2014-02-01 00:46:57.000000', 'consum', 0.0221, 'lps'),
	(516116, 128, '2014-02-01 00:46:58.000000', 'consum', 0.0214, 'lps'),
	(516117, 128, '2014-02-01 00:46:59.000000', 'consum', 0.0211, 'lps'),
	(516118, 128, '2014-02-01 00:47:00.000000', 'consum', 0.0218, 'lps'),
	(516119, 128, '2014-02-01 00:47:01.000000', 'consum', 0.0221, 'lps'),
	(516120, 128, '2014-02-01 00:47:02.000000', 'consum', 0.0211, 'lps'),
	(516121, 128, '2014-02-01 00:47:03.000000', 'consum', 0.0210, 'lps'),
	(516122, 128, '2014-02-01 00:47:04.000000', 'consum', 0.0222, 'lps'),
	(516123, 128, '2014-02-01 00:47:05.000000', 'consum', 0.0217, 'lps'),
	(516124, 128, '2014-02-01 00:47:06.000000', 'consum', 0.0220, 'lps'),
	(516125, 128, '2014-02-01 00:47:07.000000', 'consum', 0.0215, 'lps'),
	(516126, 128, '2014-02-01 00:47:08.000000', 'consum', 0.0217, 'lps'),
	(516127, 128, '2014-02-01 00:47:09.000000', 'consum', 0.0217, 'lps'),
	(516128, 128, '2014-02-01 00:47:10.000000', 'consum', 0.0211, 'lps'),
	(516129, 128, '2014-02-01 00:47:11.000000', 'consum', 0.0221, 'lps'),
	(516130, 128, '2014-02-01 00:47:12.000000', 'consum', 0.0223, 'lps'),
	(516131, 128, '2014-02-01 00:47:13.000000', 'consum', 0.0213, 'lps'),
	(516132, 128, '2014-02-01 00:47:14.000000', 'consum', 0.0216, 'lps'),
	(516133, 128, '2014-02-01 00:47:15.000000', 'consum', 0.0217, 'lps'),
	(516134, 128, '2014-02-01 00:47:16.000000', 'consum', 0.0213, 'lps'),
	(516135, 128, '2014-02-01 00:47:17.000000', 'consum', 0.0217, 'lps'),
	(516136, 128, '2014-02-01 00:47:18.000000', 'consum', 0.0223, 'lps'),
	(516137, 128, '2014-02-01 00:47:19.000000', 'consum', 0.0214, 'lps'),
	(516138, 128, '2014-02-01 00:47:20.000000', 'consum', 0.0220, 'lps'),
	(516139, 128, '2014-02-01 00:47:21.000000', 'consum', 0.0219, 'lps'),
	(516140, 128, '2014-02-01 00:47:22.000000', 'consum', 0.0214, 'lps'),
	(516141, 128, '2014-02-01 00:47:23.000000', 'consum', 0.0216, 'lps'),
	(516142, 128, '2014-02-01 00:47:24.000000', 'consum', 0.0217, 'lps'),
	(516143, 128, '2014-02-01 00:47:25.000000', 'consum', 0.0210, 'lps'),
	(516144, 128, '2014-02-01 00:47:26.000000', 'consum', 0.0220, 'lps'),
	(516145, 128, '2014-02-01 00:47:27.000000', 'consum', 0.0219, 'lps'),
	(516146, 128, '2014-02-01 00:47:28.000000', 'consum', 0.0223, 'lps'),
	(516147, 128, '2014-02-01 00:47:29.000000', 'consum', 0.0222, 'lps'),
	(516148, 128, '2014-02-01 00:47:30.000000', 'consum', 0.0216, 'lps'),
	(516149, 128, '2014-02-01 00:47:31.000000', 'consum', 0.0218, 'lps'),
	(516150, 128, '2014-02-01 00:47:32.000000', 'consum', 0.0219, 'lps'),
	(516151, 128, '2014-02-01 00:47:33.000000', 'consum', 0.0219, 'lps'),
	(516152, 128, '2014-02-01 00:47:34.000000', 'consum', 0.0214, 'lps'),
	(516153, 128, '2014-02-01 00:47:35.000000', 'consum', 0.0217, 'lps'),
	(516154, 128, '2014-02-01 00:47:36.000000', 'consum', 0.0218, 'lps'),
	(516155, 128, '2014-02-01 00:47:37.000000', 'consum', 0.0217, 'lps'),
	(516156, 128, '2014-02-01 00:47:38.000000', 'consum', 0.0223, 'lps'),
	(516157, 128, '2014-02-01 00:47:39.000000', 'consum', 0.0210, 'lps'),
	(516158, 128, '2014-02-01 00:47:40.000000', 'consum', 0.0215, 'lps'),
	(516159, 128, '2014-02-01 00:47:41.000000', 'consum', 0.0222, 'lps'),
	(516160, 128, '2014-02-01 00:47:42.000000', 'consum', 0.0211, 'lps'),
	(516161, 128, '2014-02-01 00:47:43.000000', 'consum', 0.0222, 'lps'),
	(516162, 128, '2014-02-01 00:47:44.000000', 'consum', 0.0212, 'lps'),
	(516163, 128, '2014-02-01 00:47:45.000000', 'consum', 0.0214, 'lps'),
	(516164, 128, '2014-02-01 00:47:46.000000', 'consum', 0.0223, 'lps'),
	(516165, 128, '2014-02-01 00:47:47.000000', 'consum', 0.0222, 'lps'),
	(516166, 128, '2014-02-01 00:47:48.000000', 'consum', 0.0217, 'lps'),
	(516167, 128, '2014-02-01 00:47:49.000000', 'consum', 0.0222, 'lps'),
	(516168, 128, '2014-02-01 00:47:50.000000', 'consum', 0.0210, 'lps'),
	(516169, 128, '2014-02-01 00:47:51.000000', 'consum', 0.0216, 'lps'),
	(516170, 128, '2014-02-01 00:47:52.000000', 'consum', 0.0212, 'lps'),
	(516171, 128, '2014-02-01 00:47:53.000000', 'consum', 0.0218, 'lps'),
	(516172, 128, '2014-02-01 00:47:54.000000', 'consum', 0.0216, 'lps'),
	(516173, 128, '2014-02-01 00:47:55.000000', 'consum', 0.0214, 'lps'),
	(516174, 128, '2014-02-01 00:47:56.000000', 'consum', 0.0215, 'lps'),
	(516175, 128, '2014-02-01 00:47:57.000000', 'consum', 0.0223, 'lps'),
	(516176, 128, '2014-02-01 00:47:58.000000', 'consum', 0.0220, 'lps'),
	(516177, 128, '2014-02-01 00:47:59.000000', 'consum', 0.0219, 'lps'),
	(516178, 128, '2014-02-01 00:48:00.000000', 'consum', 0.0211, 'lps'),
	(516179, 128, '2014-02-01 00:48:01.000000', 'consum', 0.0216, 'lps'),
	(516180, 128, '2014-02-01 00:48:02.000000', 'consum', 0.0212, 'lps'),
	(516181, 128, '2014-02-01 00:48:03.000000', 'consum', 0.0214, 'lps'),
	(516182, 128, '2014-02-01 00:48:04.000000', 'consum', 0.0212, 'lps'),
	(516183, 128, '2014-02-01 00:48:05.000000', 'consum', 0.0222, 'lps'),
	(516184, 128, '2014-02-01 00:48:06.000000', 'consum', 0.0223, 'lps'),
	(516185, 128, '2014-02-01 00:48:07.000000', 'consum', 0.0211, 'lps'),
	(516186, 128, '2014-02-01 00:48:08.000000', 'consum', 0.0219, 'lps'),
	(516187, 128, '2014-02-01 00:48:09.000000', 'consum', 0.0212, 'lps'),
	(516188, 128, '2014-02-01 00:48:10.000000', 'consum', 0.0219, 'lps'),
	(516189, 128, '2014-02-01 00:48:11.000000', 'consum', 0.0223, 'lps'),
	(516190, 128, '2014-02-01 00:48:12.000000', 'consum', 0.0219, 'lps'),
	(516191, 128, '2014-02-01 00:48:13.000000', 'consum', 0.0215, 'lps'),
	(516192, 128, '2014-02-01 00:48:14.000000', 'consum', 0.0212, 'lps'),
	(516193, 128, '2014-02-01 00:48:15.000000', 'consum', 0.0216, 'lps'),
	(516194, 128, '2014-02-01 00:48:16.000000', 'consum', 0.0223, 'lps'),
	(516195, 128, '2014-02-01 00:48:17.000000', 'consum', 0.0216, 'lps'),
	(516196, 128, '2014-02-01 00:48:18.000000', 'consum', 0.0214, 'lps'),
	(516197, 128, '2014-02-01 00:48:19.000000', 'consum', 0.0213, 'lps'),
	(516198, 128, '2014-02-01 00:48:20.000000', 'consum', 0.0212, 'lps'),
	(516199, 128, '2014-02-01 00:48:21.000000', 'consum', 0.0214, 'lps'),
	(516200, 128, '2014-02-01 00:48:22.000000', 'consum', 0.0211, 'lps'),
	(516201, 128, '2014-02-01 00:48:23.000000', 'consum', 0.0215, 'lps'),
	(516202, 128, '2014-02-01 00:48:24.000000', 'consum', 0.0221, 'lps'),
	(516203, 128, '2014-02-01 00:48:25.000000', 'consum', 0.0223, 'lps'),
	(516204, 128, '2014-02-01 00:48:26.000000', 'consum', 0.0215, 'lps'),
	(516205, 128, '2014-02-01 00:48:27.000000', 'consum', 0.0222, 'lps'),
	(516206, 128, '2014-02-01 00:48:28.000000', 'consum', 0.0215, 'lps'),
	(516207, 128, '2014-02-01 00:48:29.000000', 'consum', 0.0214, 'lps'),
	(516208, 128, '2014-02-01 00:48:30.000000', 'consum', 0.0216, 'lps'),
	(516209, 128, '2014-02-01 00:48:31.000000', 'consum', 0.0213, 'lps'),
	(516210, 128, '2014-02-01 00:48:32.000000', 'consum', 0.0210, 'lps'),
	(516211, 128, '2014-02-01 00:48:33.000000', 'consum', 0.0213, 'lps'),
	(516212, 128, '2014-02-01 00:48:34.000000', 'consum', 0.0212, 'lps'),
	(516213, 128, '2014-02-01 00:48:35.000000', 'consum', 0.0212, 'lps'),
	(516214, 128, '2014-02-01 00:48:36.000000', 'consum', 0.0213, 'lps'),
	(516215, 128, '2014-02-01 00:48:37.000000', 'consum', 0.0221, 'lps'),
	(516216, 128, '2014-02-01 00:48:38.000000', 'consum', 0.0216, 'lps'),
	(516217, 128, '2014-02-01 00:48:39.000000', 'consum', 0.0219, 'lps'),
	(516218, 128, '2014-02-01 00:48:40.000000', 'consum', 0.0212, 'lps'),
	(516219, 128, '2014-02-01 00:48:41.000000', 'consum', 0.0221, 'lps'),
	(516220, 128, '2014-02-01 00:48:42.000000', 'consum', 0.0219, 'lps'),
	(516221, 128, '2014-02-01 00:48:43.000000', 'consum', 0.0221, 'lps'),
	(516222, 128, '2014-02-01 00:48:44.000000', 'consum', 0.0210, 'lps'),
	(516223, 128, '2014-02-01 00:48:45.000000', 'consum', 0.0218, 'lps'),
	(516224, 128, '2014-02-01 00:48:46.000000', 'consum', 0.0211, 'lps'),
	(516225, 128, '2014-02-01 00:48:47.000000', 'consum', 0.0219, 'lps'),
	(516226, 128, '2014-02-01 00:48:48.000000', 'consum', 0.0222, 'lps'),
	(516227, 128, '2014-02-01 00:48:49.000000', 'consum', 0.0219, 'lps'),
	(516228, 128, '2014-02-01 00:48:50.000000', 'consum', 0.0218, 'lps'),
	(516229, 128, '2014-02-01 00:48:51.000000', 'consum', 0.0223, 'lps'),
	(516230, 128, '2014-02-01 00:48:52.000000', 'consum', 0.0212, 'lps'),
	(516231, 128, '2014-02-01 00:48:53.000000', 'consum', 0.0222, 'lps'),
	(516232, 128, '2014-02-01 00:48:54.000000', 'consum', 0.0221, 'lps'),
	(516233, 128, '2014-02-01 00:48:55.000000', 'consum', 0.0218, 'lps'),
	(516234, 128, '2014-02-01 00:48:56.000000', 'consum', 0.0215, 'lps'),
	(516235, 128, '2014-02-01 00:48:57.000000', 'consum', 0.0214, 'lps'),
	(516236, 128, '2014-02-01 00:48:58.000000', 'consum', 0.0216, 'lps'),
	(516237, 128, '2014-02-01 00:48:59.000000', 'consum', 0.0213, 'lps'),
	(516238, 128, '2014-02-01 00:49:00.000000', 'consum', 0.0223, 'lps'),
	(516239, 128, '2014-02-01 00:49:01.000000', 'consum', 0.0211, 'lps'),
	(516240, 128, '2014-02-01 00:49:02.000000', 'consum', 0.0216, 'lps'),
	(516241, 128, '2014-02-01 00:49:03.000000', 'consum', 0.0223, 'lps'),
	(516242, 128, '2014-02-01 00:49:04.000000', 'consum', 0.0216, 'lps'),
	(516243, 128, '2014-02-01 00:49:05.000000', 'consum', 0.0216, 'lps'),
	(516244, 128, '2014-02-01 00:49:06.000000', 'consum', 0.0222, 'lps'),
	(516245, 128, '2014-02-01 00:49:07.000000', 'consum', 0.0212, 'lps'),
	(516246, 128, '2014-02-01 00:49:08.000000', 'consum', 0.0210, 'lps'),
	(516247, 128, '2014-02-01 00:49:09.000000', 'consum', 0.0219, 'lps'),
	(516248, 128, '2014-02-01 00:49:10.000000', 'consum', 0.0213, 'lps'),
	(516249, 128, '2014-02-01 00:49:11.000000', 'consum', 0.0213, 'lps'),
	(516250, 128, '2014-02-01 00:49:12.000000', 'consum', 0.0217, 'lps'),
	(516251, 128, '2014-02-01 00:49:13.000000', 'consum', 0.0220, 'lps'),
	(516252, 128, '2014-02-01 00:49:14.000000', 'consum', 0.0215, 'lps'),
	(516253, 128, '2014-02-01 00:49:15.000000', 'consum', 0.0218, 'lps'),
	(516254, 128, '2014-02-01 00:49:16.000000', 'consum', 0.0220, 'lps'),
	(516255, 128, '2014-02-01 00:49:17.000000', 'consum', 0.0222, 'lps'),
	(516256, 128, '2014-02-01 00:49:18.000000', 'consum', 0.0215, 'lps'),
	(516257, 128, '2014-02-01 00:49:19.000000', 'consum', 0.0214, 'lps'),
	(516258, 128, '2014-02-01 00:49:20.000000', 'consum', 0.0215, 'lps'),
	(516259, 128, '2014-02-01 00:49:21.000000', 'consum', 0.0221, 'lps'),
	(516260, 128, '2014-02-01 00:49:22.000000', 'consum', 0.0212, 'lps'),
	(516261, 128, '2014-02-01 00:49:23.000000', 'consum', 0.0214, 'lps'),
	(516262, 128, '2014-02-01 00:49:24.000000', 'consum', 0.0212, 'lps'),
	(516263, 128, '2014-02-01 00:49:25.000000', 'consum', 0.0222, 'lps'),
	(516264, 128, '2014-02-01 00:49:26.000000', 'consum', 0.0222, 'lps'),
	(516265, 128, '2014-02-01 00:49:27.000000', 'consum', 0.0219, 'lps'),
	(516266, 128, '2014-02-01 00:49:28.000000', 'consum', 0.0221, 'lps'),
	(516267, 128, '2014-02-01 00:49:29.000000', 'consum', 0.0212, 'lps'),
	(516268, 128, '2014-02-01 00:49:30.000000', 'consum', 0.0214, 'lps'),
	(516269, 128, '2014-02-01 00:49:31.000000', 'consum', 0.0212, 'lps'),
	(516270, 128, '2014-02-01 00:49:32.000000', 'consum', 0.0221, 'lps'),
	(516271, 128, '2014-02-01 00:49:33.000000', 'consum', 0.0218, 'lps'),
	(516272, 128, '2014-02-01 00:49:34.000000', 'consum', 0.0217, 'lps'),
	(516273, 128, '2014-02-01 00:49:35.000000', 'consum', 0.0210, 'lps'),
	(516274, 128, '2014-02-01 00:49:36.000000', 'consum', 0.0215, 'lps'),
	(516275, 128, '2014-02-01 00:49:37.000000', 'consum', 0.0221, 'lps'),
	(516276, 128, '2014-02-01 00:49:38.000000', 'consum', 0.0223, 'lps'),
	(516277, 128, '2014-02-01 00:49:39.000000', 'consum', 0.0213, 'lps'),
	(516278, 128, '2014-02-01 00:49:40.000000', 'consum', 0.0215, 'lps'),
	(516279, 128, '2014-02-01 00:49:41.000000', 'consum', 0.0212, 'lps'),
	(516280, 128, '2014-02-01 00:49:42.000000', 'consum', 0.0218, 'lps'),
	(516281, 128, '2014-02-01 00:49:43.000000', 'consum', 0.0220, 'lps'),
	(516282, 128, '2014-02-01 00:49:44.000000', 'consum', 0.0221, 'lps'),
	(516283, 128, '2014-02-01 00:49:45.000000', 'consum', 0.0221, 'lps'),
	(516284, 128, '2014-02-01 00:49:46.000000', 'consum', 0.0217, 'lps'),
	(516285, 128, '2014-02-01 00:49:47.000000', 'consum', 0.0216, 'lps'),
	(516286, 128, '2014-02-01 00:49:48.000000', 'consum', 0.0217, 'lps'),
	(516287, 128, '2014-02-01 00:49:49.000000', 'consum', 0.0213, 'lps'),
	(516288, 128, '2014-02-01 00:49:50.000000', 'consum', 0.0219, 'lps'),
	(516289, 128, '2014-02-01 00:49:51.000000', 'consum', 0.0217, 'lps'),
	(516290, 128, '2014-02-01 00:49:52.000000', 'consum', 0.0220, 'lps'),
	(516291, 128, '2014-02-01 00:49:53.000000', 'consum', 0.0210, 'lps'),
	(516292, 128, '2014-02-01 00:49:54.000000', 'consum', 0.0211, 'lps'),
	(516293, 128, '2014-02-01 00:49:55.000000', 'consum', 0.0214, 'lps'),
	(516294, 128, '2014-02-01 00:49:56.000000', 'consum', 0.0215, 'lps'),
	(516295, 128, '2014-02-01 00:49:57.000000', 'consum', 0.0222, 'lps'),
	(516296, 128, '2014-02-01 00:49:58.000000', 'consum', 0.0216, 'lps'),
	(516297, 128, '2014-02-01 00:49:59.000000', 'consum', 0.0217, 'lps'),
	(516298, 128, '2014-02-01 00:50:00.000000', 'consum', 0.0214, 'lps'),
	(516299, 128, '2014-02-01 00:50:01.000000', 'consum', 0.0211, 'lps'),
	(516300, 128, '2014-02-01 00:50:02.000000', 'consum', 0.0216, 'lps'),
	(516301, 128, '2014-02-01 00:50:03.000000', 'consum', 0.0222, 'lps'),
	(516302, 128, '2014-02-01 00:50:04.000000', 'consum', 0.0212, 'lps'),
	(516303, 128, '2014-02-01 00:50:05.000000', 'consum', 0.0211, 'lps'),
	(516304, 128, '2014-02-01 00:50:06.000000', 'consum', 0.0211, 'lps'),
	(516305, 128, '2014-02-01 00:50:07.000000', 'consum', 0.0210, 'lps'),
	(516306, 128, '2014-02-01 00:50:08.000000', 'consum', 0.0211, 'lps'),
	(516307, 128, '2014-02-01 00:50:09.000000', 'consum', 0.0214, 'lps'),
	(516308, 128, '2014-02-01 00:50:10.000000', 'consum', 0.0214, 'lps'),
	(516309, 128, '2014-02-01 00:50:11.000000', 'consum', 0.0219, 'lps'),
	(516310, 128, '2014-02-01 00:50:12.000000', 'consum', 0.0213, 'lps'),
	(516311, 128, '2014-02-01 00:50:13.000000', 'consum', 0.0213, 'lps'),
	(516312, 128, '2014-02-01 00:50:14.000000', 'consum', 0.0218, 'lps'),
	(516313, 128, '2014-02-01 00:50:15.000000', 'consum', 0.0211, 'lps'),
	(516314, 128, '2014-02-01 00:50:16.000000', 'consum', 0.0220, 'lps'),
	(516315, 128, '2014-02-01 00:50:17.000000', 'consum', 0.0215, 'lps'),
	(516316, 128, '2014-02-01 00:50:18.000000', 'consum', 0.0221, 'lps'),
	(516317, 128, '2014-02-01 00:50:19.000000', 'consum', 0.0223, 'lps'),
	(516318, 128, '2014-02-01 00:50:20.000000', 'consum', 0.0214, 'lps'),
	(516319, 128, '2014-02-01 00:50:21.000000', 'consum', 0.0220, 'lps'),
	(516320, 128, '2014-02-01 00:50:22.000000', 'consum', 0.0222, 'lps'),
	(516321, 128, '2014-02-01 00:50:23.000000', 'consum', 0.0211, 'lps'),
	(516322, 128, '2014-02-01 00:50:24.000000', 'consum', 0.0221, 'lps'),
	(516323, 128, '2014-02-01 00:50:25.000000', 'consum', 0.0221, 'lps'),
	(516324, 128, '2014-02-01 00:50:26.000000', 'consum', 0.0216, 'lps'),
	(516325, 128, '2014-02-01 00:50:27.000000', 'consum', 0.0211, 'lps'),
	(516326, 128, '2014-02-01 00:50:28.000000', 'consum', 0.0212, 'lps'),
	(516327, 128, '2014-02-01 00:50:29.000000', 'consum', 0.0214, 'lps'),
	(516328, 128, '2014-02-01 00:50:30.000000', 'consum', 0.0214, 'lps'),
	(516329, 128, '2014-02-01 00:50:31.000000', 'consum', 0.0218, 'lps'),
	(516330, 128, '2014-02-01 00:50:32.000000', 'consum', 0.0211, 'lps'),
	(516331, 128, '2014-02-01 00:50:33.000000', 'consum', 0.0218, 'lps'),
	(516332, 128, '2014-02-01 00:50:34.000000', 'consum', 0.0218, 'lps'),
	(516333, 128, '2014-02-01 00:50:35.000000', 'consum', 0.0216, 'lps'),
	(516334, 128, '2014-02-01 00:50:36.000000', 'consum', 0.0214, 'lps'),
	(516335, 128, '2014-02-01 00:50:37.000000', 'consum', 0.0215, 'lps'),
	(516336, 128, '2014-02-01 00:50:38.000000', 'consum', 0.0210, 'lps'),
	(516337, 128, '2014-02-01 00:50:39.000000', 'consum', 0.0221, 'lps'),
	(516338, 128, '2014-02-01 00:50:40.000000', 'consum', 0.0222, 'lps'),
	(516339, 128, '2014-02-01 00:50:41.000000', 'consum', 0.0213, 'lps'),
	(516340, 128, '2014-02-01 00:50:42.000000', 'consum', 0.0215, 'lps'),
	(516341, 128, '2014-02-01 00:50:43.000000', 'consum', 0.0215, 'lps'),
	(516342, 128, '2014-02-01 00:50:44.000000', 'consum', 0.0221, 'lps'),
	(516343, 128, '2014-02-01 00:50:45.000000', 'consum', 0.0221, 'lps'),
	(516344, 128, '2014-02-01 00:50:46.000000', 'consum', 0.0220, 'lps'),
	(516345, 128, '2014-02-01 00:50:47.000000', 'consum', 0.0212, 'lps'),
	(516346, 128, '2014-02-01 00:50:48.000000', 'consum', 0.0218, 'lps'),
	(516347, 128, '2014-02-01 00:50:49.000000', 'consum', 0.0217, 'lps'),
	(516348, 128, '2014-02-01 00:50:50.000000', 'consum', 0.0222, 'lps'),
	(516349, 128, '2014-02-01 00:50:51.000000', 'consum', 0.0222, 'lps'),
	(516350, 128, '2014-02-01 00:50:52.000000', 'consum', 0.0221, 'lps'),
	(516351, 128, '2014-02-01 00:50:53.000000', 'consum', 0.0217, 'lps'),
	(516352, 128, '2014-02-01 00:50:54.000000', 'consum', 0.0223, 'lps'),
	(516353, 128, '2014-02-01 00:50:55.000000', 'consum', 0.0213, 'lps'),
	(516354, 128, '2014-02-01 00:50:56.000000', 'consum', 0.0216, 'lps'),
	(516355, 128, '2014-02-01 00:50:57.000000', 'consum', 0.0217, 'lps'),
	(516356, 128, '2014-02-01 00:50:58.000000', 'consum', 0.0214, 'lps'),
	(516357, 128, '2014-02-01 00:50:59.000000', 'consum', 0.0222, 'lps'),
	(516358, 128, '2014-02-01 00:51:00.000000', 'consum', 0.0218, 'lps'),
	(516359, 128, '2014-02-01 00:51:01.000000', 'consum', 0.0215, 'lps'),
	(516360, 128, '2014-02-01 00:51:02.000000', 'consum', 0.0211, 'lps'),
	(516361, 128, '2014-02-01 00:51:03.000000', 'consum', 0.0216, 'lps'),
	(516362, 128, '2014-02-01 00:51:04.000000', 'consum', 0.0210, 'lps'),
	(516363, 128, '2014-02-01 00:51:05.000000', 'consum', 0.0221, 'lps'),
	(516364, 128, '2014-02-01 00:51:06.000000', 'consum', 0.0223, 'lps'),
	(516365, 128, '2014-02-01 00:51:07.000000', 'consum', 0.0214, 'lps'),
	(516366, 128, '2014-02-01 00:51:08.000000', 'consum', 0.0220, 'lps'),
	(516367, 128, '2014-02-01 00:51:09.000000', 'consum', 0.0222, 'lps'),
	(516368, 128, '2014-02-01 00:51:10.000000', 'consum', 0.0210, 'lps'),
	(516369, 128, '2014-02-01 00:51:11.000000', 'consum', 0.0218, 'lps'),
	(516370, 128, '2014-02-01 00:51:12.000000', 'consum', 0.0221, 'lps'),
	(516371, 128, '2014-02-01 00:51:13.000000', 'consum', 0.0213, 'lps'),
	(516372, 128, '2014-02-01 00:51:14.000000', 'consum', 0.0220, 'lps'),
	(516373, 128, '2014-02-01 00:51:15.000000', 'consum', 0.0223, 'lps'),
	(516374, 128, '2014-02-01 00:51:16.000000', 'consum', 0.0218, 'lps'),
	(516375, 128, '2014-02-01 00:51:17.000000', 'consum', 0.0210, 'lps'),
	(516376, 128, '2014-02-01 00:51:18.000000', 'consum', 0.0217, 'lps'),
	(516377, 128, '2014-02-01 00:51:19.000000', 'consum', 0.0218, 'lps'),
	(516378, 128, '2014-02-01 00:51:20.000000', 'consum', 0.0213, 'lps'),
	(516379, 128, '2014-02-01 00:51:21.000000', 'consum', 0.0217, 'lps'),
	(516380, 128, '2014-02-01 00:51:22.000000', 'consum', 0.0220, 'lps'),
	(516381, 128, '2014-02-01 00:51:23.000000', 'consum', 0.0214, 'lps'),
	(516382, 128, '2014-02-01 00:51:24.000000', 'consum', 0.0216, 'lps'),
	(516383, 128, '2014-02-01 00:51:25.000000', 'consum', 0.0212, 'lps'),
	(516384, 128, '2014-02-01 00:51:26.000000', 'consum', 0.0217, 'lps'),
	(516385, 128, '2014-02-01 00:51:27.000000', 'consum', 0.0213, 'lps'),
	(516386, 128, '2014-02-01 00:51:28.000000', 'consum', 0.0216, 'lps'),
	(516387, 128, '2014-02-01 00:51:29.000000', 'consum', 0.0218, 'lps'),
	(516388, 128, '2014-02-01 00:51:30.000000', 'consum', 0.0221, 'lps'),
	(516389, 128, '2014-02-01 00:51:31.000000', 'consum', 0.0210, 'lps'),
	(516390, 128, '2014-02-01 00:51:32.000000', 'consum', 0.0222, 'lps'),
	(516391, 128, '2014-02-01 00:51:33.000000', 'consum', 0.0214, 'lps'),
	(516392, 128, '2014-02-01 00:51:34.000000', 'consum', 0.0221, 'lps'),
	(516393, 128, '2014-02-01 00:51:35.000000', 'consum', 0.0213, 'lps'),
	(516394, 128, '2014-02-01 00:51:36.000000', 'consum', 0.0218, 'lps'),
	(516395, 128, '2014-02-01 00:51:37.000000', 'consum', 0.0216, 'lps'),
	(516396, 128, '2014-02-01 00:51:38.000000', 'consum', 0.0217, 'lps'),
	(516397, 128, '2014-02-01 00:51:39.000000', 'consum', 0.0214, 'lps'),
	(516398, 128, '2014-02-01 00:51:40.000000', 'consum', 0.0221, 'lps'),
	(516399, 128, '2014-02-01 00:51:41.000000', 'consum', 0.0214, 'lps'),
	(516400, 128, '2014-02-01 00:51:42.000000', 'consum', 0.0212, 'lps'),
	(516401, 128, '2014-02-01 00:51:43.000000', 'consum', 0.0221, 'lps'),
	(516402, 128, '2014-02-01 00:51:44.000000', 'consum', 0.0217, 'lps'),
	(516403, 128, '2014-02-01 00:51:45.000000', 'consum', 0.0215, 'lps'),
	(516404, 128, '2014-02-01 00:51:46.000000', 'consum', 0.0211, 'lps'),
	(516405, 128, '2014-02-01 00:51:47.000000', 'consum', 0.0218, 'lps'),
	(516406, 128, '2014-02-01 00:51:48.000000', 'consum', 0.0217, 'lps'),
	(516407, 128, '2014-02-01 00:51:49.000000', 'consum', 0.0223, 'lps'),
	(516408, 128, '2014-02-01 00:51:50.000000', 'consum', 0.0213, 'lps'),
	(516409, 128, '2014-02-01 00:51:51.000000', 'consum', 0.0213, 'lps'),
	(516410, 128, '2014-02-01 00:51:52.000000', 'consum', 0.0215, 'lps'),
	(516411, 128, '2014-02-01 00:51:53.000000', 'consum', 0.0215, 'lps'),
	(516412, 128, '2014-02-01 00:51:54.000000', 'consum', 0.0219, 'lps'),
	(516413, 128, '2014-02-01 00:51:55.000000', 'consum', 0.0214, 'lps'),
	(516414, 128, '2014-02-01 00:51:56.000000', 'consum', 0.0219, 'lps'),
	(516415, 128, '2014-02-01 00:51:57.000000', 'consum', 0.0213, 'lps'),
	(516416, 128, '2014-02-01 00:51:58.000000', 'consum', 0.0214, 'lps'),
	(516417, 128, '2014-02-01 00:51:59.000000', 'consum', 0.0220, 'lps'),
	(516418, 128, '2014-02-01 00:52:00.000000', 'consum', 0.0222, 'lps'),
	(516419, 128, '2014-02-01 00:52:01.000000', 'consum', 0.0211, 'lps'),
	(516420, 128, '2014-02-01 00:52:02.000000', 'consum', 0.0222, 'lps'),
	(516421, 128, '2014-02-01 00:52:03.000000', 'consum', 0.0212, 'lps'),
	(516422, 128, '2014-02-01 00:52:04.000000', 'consum', 0.0214, 'lps'),
	(516423, 128, '2014-02-01 00:52:05.000000', 'consum', 0.0222, 'lps'),
	(516424, 128, '2014-02-01 00:52:06.000000', 'consum', 0.0219, 'lps'),
	(516425, 128, '2014-02-01 00:52:07.000000', 'consum', 0.0217, 'lps'),
	(516426, 128, '2014-02-01 00:52:08.000000', 'consum', 0.0219, 'lps'),
	(516427, 128, '2014-02-01 00:52:09.000000', 'consum', 0.0223, 'lps'),
	(516428, 128, '2014-02-01 00:52:10.000000', 'consum', 0.0217, 'lps'),
	(516429, 128, '2014-02-01 00:52:11.000000', 'consum', 0.0223, 'lps'),
	(516430, 128, '2014-02-01 00:52:12.000000', 'consum', 0.0212, 'lps'),
	(516431, 128, '2014-02-01 00:52:13.000000', 'consum', 0.0222, 'lps'),
	(516432, 128, '2014-02-01 00:52:14.000000', 'consum', 0.0222, 'lps'),
	(516433, 128, '2014-02-01 00:52:15.000000', 'consum', 0.0220, 'lps'),
	(516434, 128, '2014-02-01 00:52:16.000000', 'consum', 0.0211, 'lps'),
	(516435, 128, '2014-02-01 00:52:17.000000', 'consum', 0.0213, 'lps'),
	(516436, 128, '2014-02-01 00:52:18.000000', 'consum', 0.0210, 'lps'),
	(516437, 128, '2014-02-01 00:52:19.000000', 'consum', 0.0215, 'lps'),
	(516438, 128, '2014-02-01 00:52:20.000000', 'consum', 0.0219, 'lps'),
	(516439, 128, '2014-02-01 00:52:21.000000', 'consum', 0.0216, 'lps'),
	(516440, 128, '2014-02-01 00:52:22.000000', 'consum', 0.0213, 'lps'),
	(516441, 128, '2014-02-01 00:52:23.000000', 'consum', 0.0223, 'lps'),
	(516442, 128, '2014-02-01 00:52:24.000000', 'consum', 0.0223, 'lps'),
	(516443, 128, '2014-02-01 00:52:25.000000', 'consum', 0.0222, 'lps'),
	(516444, 128, '2014-02-01 00:52:26.000000', 'consum', 0.0217, 'lps'),
	(516445, 128, '2014-02-01 00:52:27.000000', 'consum', 0.0211, 'lps'),
	(516446, 128, '2014-02-01 00:52:28.000000', 'consum', 0.0223, 'lps'),
	(516447, 128, '2014-02-01 00:52:29.000000', 'consum', 0.0216, 'lps'),
	(516448, 128, '2014-02-01 00:52:30.000000', 'consum', 0.0215, 'lps'),
	(516449, 128, '2014-02-01 00:52:31.000000', 'consum', 0.0217, 'lps'),
	(516450, 128, '2014-02-01 00:52:32.000000', 'consum', 0.0218, 'lps'),
	(516451, 128, '2014-02-01 00:52:33.000000', 'consum', 0.0217, 'lps'),
	(516452, 128, '2014-02-01 00:52:34.000000', 'consum', 0.0219, 'lps'),
	(516453, 128, '2014-02-01 00:52:35.000000', 'consum', 0.0219, 'lps'),
	(516454, 128, '2014-02-01 00:52:36.000000', 'consum', 0.0216, 'lps'),
	(516455, 128, '2014-02-01 00:52:37.000000', 'consum', 0.0214, 'lps'),
	(516456, 128, '2014-02-01 00:52:38.000000', 'consum', 0.0214, 'lps'),
	(516457, 128, '2014-02-01 00:52:39.000000', 'consum', 0.0218, 'lps'),
	(516458, 128, '2014-02-01 00:52:40.000000', 'consum', 0.0222, 'lps'),
	(516459, 128, '2014-02-01 00:52:41.000000', 'consum', 0.0220, 'lps'),
	(516460, 128, '2014-02-01 00:52:42.000000', 'consum', 0.0223, 'lps'),
	(516461, 128, '2014-02-01 00:52:43.000000', 'consum', 0.0218, 'lps'),
	(516462, 128, '2014-02-01 00:52:44.000000', 'consum', 0.0213, 'lps'),
	(516463, 128, '2014-02-01 00:52:45.000000', 'consum', 0.0215, 'lps'),
	(516464, 128, '2014-02-01 00:52:46.000000', 'consum', 0.0213, 'lps'),
	(516465, 128, '2014-02-01 00:52:47.000000', 'consum', 0.0211, 'lps'),
	(516466, 128, '2014-02-01 00:52:48.000000', 'consum', 0.0222, 'lps'),
	(516467, 128, '2014-02-01 00:52:49.000000', 'consum', 0.0210, 'lps'),
	(516468, 128, '2014-02-01 00:52:50.000000', 'consum', 0.0215, 'lps'),
	(516469, 128, '2014-02-01 00:52:51.000000', 'consum', 0.0220, 'lps'),
	(516470, 128, '2014-02-01 00:52:52.000000', 'consum', 0.0221, 'lps'),
	(516471, 128, '2014-02-01 00:52:53.000000', 'consum', 0.0220, 'lps'),
	(516472, 128, '2014-02-01 00:52:54.000000', 'consum', 0.0214, 'lps'),
	(516473, 128, '2014-02-01 00:52:55.000000', 'consum', 0.0214, 'lps'),
	(516474, 128, '2014-02-01 00:52:56.000000', 'consum', 0.0219, 'lps'),
	(516475, 128, '2014-02-01 00:52:57.000000', 'consum', 0.0217, 'lps'),
	(516476, 128, '2014-02-01 00:52:58.000000', 'consum', 0.0219, 'lps'),
	(516477, 128, '2014-02-01 00:52:59.000000', 'consum', 0.0220, 'lps'),
	(516478, 128, '2014-02-01 00:53:00.000000', 'consum', 0.0219, 'lps'),
	(516479, 128, '2014-02-01 00:53:01.000000', 'consum', 0.0212, 'lps'),
	(516480, 128, '2014-02-01 00:53:02.000000', 'consum', 0.0223, 'lps'),
	(516481, 128, '2014-02-01 00:53:03.000000', 'consum', 0.0210, 'lps'),
	(516482, 128, '2014-02-01 00:53:04.000000', 'consum', 0.0217, 'lps'),
	(516483, 128, '2014-02-01 00:53:05.000000', 'consum', 0.0216, 'lps'),
	(516484, 128, '2014-02-01 00:53:06.000000', 'consum', 0.0221, 'lps'),
	(516485, 128, '2014-02-01 00:53:07.000000', 'consum', 0.0218, 'lps'),
	(516486, 128, '2014-02-01 00:53:08.000000', 'consum', 0.0217, 'lps'),
	(516487, 128, '2014-02-01 00:53:09.000000', 'consum', 0.0222, 'lps'),
	(516488, 128, '2014-02-01 00:53:10.000000', 'consum', 0.0223, 'lps'),
	(516489, 128, '2014-02-01 00:53:11.000000', 'consum', 0.0223, 'lps'),
	(516490, 128, '2014-02-01 00:53:12.000000', 'consum', 0.0222, 'lps'),
	(516491, 128, '2014-02-01 00:53:13.000000', 'consum', 0.0220, 'lps'),
	(516492, 128, '2014-02-01 00:53:14.000000', 'consum', 0.0210, 'lps'),
	(516493, 128, '2014-02-01 00:53:15.000000', 'consum', 0.0220, 'lps'),
	(516494, 128, '2014-02-01 00:53:16.000000', 'consum', 0.0220, 'lps'),
	(516495, 128, '2014-02-01 00:53:17.000000', 'consum', 0.0218, 'lps'),
	(516496, 128, '2014-02-01 00:53:18.000000', 'consum', 0.0221, 'lps'),
	(516497, 128, '2014-02-01 00:53:19.000000', 'consum', 0.0215, 'lps'),
	(516498, 128, '2014-02-01 00:53:20.000000', 'consum', 0.0213, 'lps'),
	(516499, 128, '2014-02-01 00:53:21.000000', 'consum', 0.0210, 'lps'),
	(516500, 128, '2014-02-01 00:53:22.000000', 'consum', 0.0218, 'lps'),
	(516501, 128, '2014-02-01 00:53:23.000000', 'consum', 0.0223, 'lps'),
	(516502, 128, '2014-02-01 00:53:24.000000', 'consum', 0.0223, 'lps'),
	(516503, 128, '2014-02-01 00:53:25.000000', 'consum', 0.0221, 'lps'),
	(516504, 128, '2014-02-01 00:53:26.000000', 'consum', 0.0213, 'lps'),
	(516505, 128, '2014-02-01 00:53:27.000000', 'consum', 0.0222, 'lps'),
	(516506, 128, '2014-02-01 00:53:28.000000', 'consum', 0.0219, 'lps'),
	(516507, 128, '2014-02-01 00:53:29.000000', 'consum', 0.0219, 'lps'),
	(516508, 128, '2014-02-01 00:53:30.000000', 'consum', 0.0215, 'lps'),
	(516509, 128, '2014-02-01 00:53:31.000000', 'consum', 0.0221, 'lps'),
	(516510, 128, '2014-02-01 00:53:32.000000', 'consum', 0.0210, 'lps'),
	(516511, 128, '2014-02-01 00:53:33.000000', 'consum', 0.0220, 'lps'),
	(516512, 128, '2014-02-01 00:53:34.000000', 'consum', 0.0219, 'lps'),
	(516513, 128, '2014-02-01 00:53:35.000000', 'consum', 0.0211, 'lps'),
	(516514, 128, '2014-02-01 00:53:36.000000', 'consum', 0.0216, 'lps'),
	(516515, 128, '2014-02-01 00:53:37.000000', 'consum', 0.0222, 'lps'),
	(516516, 128, '2014-02-01 00:53:38.000000', 'consum', 0.0213, 'lps'),
	(516517, 128, '2014-02-01 00:53:39.000000', 'consum', 0.0216, 'lps'),
	(516518, 128, '2014-02-01 00:53:40.000000', 'consum', 0.0219, 'lps'),
	(516519, 128, '2014-02-01 00:53:41.000000', 'consum', 0.0222, 'lps'),
	(516520, 128, '2014-02-01 00:53:42.000000', 'consum', 0.0215, 'lps'),
	(516521, 128, '2014-02-01 00:53:43.000000', 'consum', 0.0214, 'lps'),
	(516522, 128, '2014-02-01 00:53:44.000000', 'consum', 0.0216, 'lps'),
	(516523, 128, '2014-02-01 00:53:45.000000', 'consum', 0.0215, 'lps'),
	(516524, 128, '2014-02-01 00:53:46.000000', 'consum', 0.0215, 'lps'),
	(516525, 128, '2014-02-01 00:53:47.000000', 'consum', 0.0223, 'lps'),
	(516526, 128, '2014-02-01 00:53:48.000000', 'consum', 0.0216, 'lps'),
	(516527, 128, '2014-02-01 00:53:49.000000', 'consum', 0.0218, 'lps'),
	(516528, 128, '2014-02-01 00:53:50.000000', 'consum', 0.0216, 'lps'),
	(516529, 128, '2014-02-01 00:53:51.000000', 'consum', 0.0219, 'lps'),
	(516530, 128, '2014-02-01 00:53:52.000000', 'consum', 0.0221, 'lps'),
	(516531, 128, '2014-02-01 00:53:53.000000', 'consum', 0.0210, 'lps'),
	(516532, 128, '2014-02-01 00:53:54.000000', 'consum', 0.0219, 'lps'),
	(516533, 128, '2014-02-01 00:53:55.000000', 'consum', 0.0216, 'lps'),
	(516534, 128, '2014-02-01 00:53:56.000000', 'consum', 0.0213, 'lps'),
	(516535, 128, '2014-02-01 00:53:57.000000', 'consum', 0.0223, 'lps'),
	(516536, 128, '2014-02-01 00:53:58.000000', 'consum', 0.0211, 'lps'),
	(516537, 128, '2014-02-01 00:53:59.000000', 'consum', 0.0215, 'lps'),
	(516538, 128, '2014-02-01 00:54:00.000000', 'consum', 0.0221, 'lps'),
	(516539, 128, '2014-02-01 00:54:01.000000', 'consum', 0.0210, 'lps'),
	(516540, 128, '2014-02-01 00:54:02.000000', 'consum', 0.0216, 'lps'),
	(516541, 128, '2014-02-01 00:54:03.000000', 'consum', 0.0215, 'lps'),
	(516542, 128, '2014-02-01 00:54:04.000000', 'consum', 0.0217, 'lps'),
	(516543, 128, '2014-02-01 00:54:05.000000', 'consum', 0.0218, 'lps'),
	(516544, 128, '2014-02-01 00:54:06.000000', 'consum', 0.0215, 'lps'),
	(516545, 128, '2014-02-01 00:54:07.000000', 'consum', 0.0223, 'lps'),
	(516546, 128, '2014-02-01 00:54:08.000000', 'consum', 0.0221, 'lps'),
	(516547, 128, '2014-02-01 00:54:09.000000', 'consum', 0.0211, 'lps'),
	(516548, 128, '2014-02-01 00:54:10.000000', 'consum', 0.0210, 'lps'),
	(516549, 128, '2014-02-01 00:54:11.000000', 'consum', 0.0210, 'lps'),
	(516550, 128, '2014-02-01 00:54:12.000000', 'consum', 0.0210, 'lps'),
	(516551, 128, '2014-02-01 00:54:13.000000', 'consum', 0.0222, 'lps'),
	(516552, 128, '2014-02-01 00:54:14.000000', 'consum', 0.0217, 'lps'),
	(516553, 128, '2014-02-01 00:54:15.000000', 'consum', 0.0210, 'lps'),
	(516554, 128, '2014-02-01 00:54:16.000000', 'consum', 0.0218, 'lps'),
	(516555, 128, '2014-02-01 00:54:17.000000', 'consum', 0.0220, 'lps'),
	(516556, 128, '2014-02-01 00:54:18.000000', 'consum', 0.0223, 'lps'),
	(516557, 128, '2014-02-01 00:54:19.000000', 'consum', 0.0218, 'lps'),
	(516558, 128, '2014-02-01 00:54:20.000000', 'consum', 0.0212, 'lps'),
	(516559, 128, '2014-02-01 00:54:21.000000', 'consum', 0.0222, 'lps'),
	(516560, 128, '2014-02-01 00:54:22.000000', 'consum', 0.0210, 'lps'),
	(516561, 128, '2014-02-01 00:54:23.000000', 'consum', 0.0216, 'lps'),
	(516562, 128, '2014-02-01 00:54:24.000000', 'consum', 0.0212, 'lps'),
	(516563, 128, '2014-02-01 00:54:25.000000', 'consum', 0.0217, 'lps'),
	(516564, 128, '2014-02-01 00:54:26.000000', 'consum', 0.0212, 'lps'),
	(516565, 128, '2014-02-01 00:54:27.000000', 'consum', 0.0212, 'lps'),
	(516566, 128, '2014-02-01 00:54:28.000000', 'consum', 0.0217, 'lps'),
	(516567, 128, '2014-02-01 00:54:29.000000', 'consum', 0.0212, 'lps'),
	(516568, 128, '2014-02-01 00:54:30.000000', 'consum', 0.0212, 'lps'),
	(516569, 128, '2014-02-01 00:54:31.000000', 'consum', 0.0213, 'lps'),
	(516570, 128, '2014-02-01 00:54:32.000000', 'consum', 0.0220, 'lps'),
	(516571, 128, '2014-02-01 00:54:33.000000', 'consum', 0.0222, 'lps'),
	(516572, 128, '2014-02-01 00:54:34.000000', 'consum', 0.0216, 'lps'),
	(516573, 128, '2014-02-01 00:54:35.000000', 'consum', 0.0215, 'lps'),
	(516574, 128, '2014-02-01 00:54:36.000000', 'consum', 0.0219, 'lps'),
	(516575, 128, '2014-02-01 00:54:37.000000', 'consum', 0.0215, 'lps'),
	(516576, 128, '2014-02-01 00:54:38.000000', 'consum', 0.0219, 'lps'),
	(516577, 128, '2014-02-01 00:54:39.000000', 'consum', 0.0213, 'lps'),
	(516578, 128, '2014-02-01 00:54:40.000000', 'consum', 0.0212, 'lps'),
	(516579, 128, '2014-02-01 00:54:41.000000', 'consum', 0.0212, 'lps'),
	(516580, 128, '2014-02-01 00:54:42.000000', 'consum', 0.0216, 'lps'),
	(516581, 128, '2014-02-01 00:54:43.000000', 'consum', 0.0219, 'lps'),
	(516582, 128, '2014-02-01 00:54:44.000000', 'consum', 0.0223, 'lps'),
	(516583, 128, '2014-02-01 00:54:45.000000', 'consum', 0.0223, 'lps'),
	(516584, 128, '2014-02-01 00:54:46.000000', 'consum', 0.0221, 'lps'),
	(516585, 128, '2014-02-01 00:54:47.000000', 'consum', 0.0212, 'lps'),
	(516586, 128, '2014-02-01 00:54:48.000000', 'consum', 0.0217, 'lps'),
	(516587, 128, '2014-02-01 00:54:49.000000', 'consum', 0.0223, 'lps'),
	(516588, 128, '2014-02-01 00:54:50.000000', 'consum', 0.0214, 'lps'),
	(516589, 128, '2014-02-01 00:54:51.000000', 'consum', 0.0218, 'lps'),
	(516590, 128, '2014-02-01 00:54:52.000000', 'consum', 0.0210, 'lps'),
	(516591, 128, '2014-02-01 00:54:53.000000', 'consum', 0.0218, 'lps'),
	(516592, 128, '2014-02-01 00:54:54.000000', 'consum', 0.0219, 'lps'),
	(516593, 128, '2014-02-01 00:54:55.000000', 'consum', 0.0218, 'lps'),
	(516594, 128, '2014-02-01 00:54:56.000000', 'consum', 0.0212, 'lps'),
	(516595, 128, '2014-02-01 00:54:57.000000', 'consum', 0.0223, 'lps'),
	(516596, 128, '2014-02-01 00:54:58.000000', 'consum', 0.0212, 'lps'),
	(516597, 128, '2014-02-01 00:54:59.000000', 'consum', 0.0212, 'lps'),
	(516598, 128, '2014-02-01 00:55:00.000000', 'consum', 0.0213, 'lps'),
	(516599, 128, '2014-02-01 00:55:01.000000', 'consum', 0.0221, 'lps'),
	(516600, 128, '2014-02-01 00:55:02.000000', 'consum', 0.0215, 'lps'),
	(516601, 128, '2014-02-01 00:55:03.000000', 'consum', 0.0216, 'lps'),
	(516602, 128, '2014-02-01 00:55:04.000000', 'consum', 0.0210, 'lps'),
	(516603, 128, '2014-02-01 00:55:05.000000', 'consum', 0.0221, 'lps'),
	(516604, 128, '2014-02-01 00:55:06.000000', 'consum', 0.0222, 'lps'),
	(516605, 128, '2014-02-01 00:55:07.000000', 'consum', 0.0212, 'lps'),
	(516606, 128, '2014-02-01 00:55:08.000000', 'consum', 0.0210, 'lps'),
	(516607, 128, '2014-02-01 00:55:09.000000', 'consum', 0.0221, 'lps'),
	(516608, 128, '2014-02-01 00:55:10.000000', 'consum', 0.0211, 'lps'),
	(516609, 128, '2014-02-01 00:55:11.000000', 'consum', 0.0221, 'lps'),
	(516610, 128, '2014-02-01 00:55:12.000000', 'consum', 0.0223, 'lps'),
	(516611, 128, '2014-02-01 00:55:13.000000', 'consum', 0.0216, 'lps'),
	(516612, 128, '2014-02-01 00:55:14.000000', 'consum', 0.0212, 'lps'),
	(516613, 128, '2014-02-01 00:55:15.000000', 'consum', 0.0218, 'lps'),
	(516614, 128, '2014-02-01 00:55:16.000000', 'consum', 0.0215, 'lps'),
	(516615, 128, '2014-02-01 00:55:17.000000', 'consum', 0.0211, 'lps'),
	(516616, 128, '2014-02-01 00:55:18.000000', 'consum', 0.0216, 'lps'),
	(516617, 128, '2014-02-01 00:55:19.000000', 'consum', 0.0222, 'lps'),
	(516618, 128, '2014-02-01 00:55:20.000000', 'consum', 0.0213, 'lps'),
	(516619, 128, '2014-02-01 00:55:21.000000', 'consum', 0.0214, 'lps'),
	(516620, 128, '2014-02-01 00:55:22.000000', 'consum', 0.0210, 'lps'),
	(516621, 128, '2014-02-01 00:55:23.000000', 'consum', 0.0214, 'lps'),
	(516622, 128, '2014-02-01 00:55:24.000000', 'consum', 0.0213, 'lps'),
	(516623, 128, '2014-02-01 00:55:25.000000', 'consum', 0.0217, 'lps'),
	(516624, 128, '2014-02-01 00:55:26.000000', 'consum', 0.0220, 'lps'),
	(516625, 128, '2014-02-01 00:55:27.000000', 'consum', 0.0211, 'lps'),
	(516626, 128, '2014-02-01 00:55:28.000000', 'consum', 0.0216, 'lps'),
	(516627, 128, '2014-02-01 00:55:29.000000', 'consum', 0.0221, 'lps'),
	(516628, 128, '2014-02-01 00:55:30.000000', 'consum', 0.0221, 'lps'),
	(516629, 128, '2014-02-01 00:55:31.000000', 'consum', 0.0217, 'lps'),
	(516630, 128, '2014-02-01 00:55:32.000000', 'consum', 0.0212, 'lps'),
	(516631, 128, '2014-02-01 00:55:33.000000', 'consum', 0.0212, 'lps'),
	(516632, 128, '2014-02-01 00:55:34.000000', 'consum', 0.0218, 'lps'),
	(516633, 128, '2014-02-01 00:55:35.000000', 'consum', 0.0216, 'lps'),
	(516634, 128, '2014-02-01 00:55:36.000000', 'consum', 0.0214, 'lps'),
	(516635, 128, '2014-02-01 00:55:37.000000', 'consum', 0.0215, 'lps'),
	(516636, 128, '2014-02-01 00:55:38.000000', 'consum', 0.0210, 'lps'),
	(516637, 128, '2014-02-01 00:55:39.000000', 'consum', 0.0222, 'lps'),
	(516638, 128, '2014-02-01 00:55:40.000000', 'consum', 0.0216, 'lps'),
	(516639, 128, '2014-02-01 00:55:41.000000', 'consum', 0.0220, 'lps'),
	(516640, 128, '2014-02-01 00:55:42.000000', 'consum', 0.0211, 'lps'),
	(516641, 128, '2014-02-01 00:55:43.000000', 'consum', 0.0214, 'lps'),
	(516642, 128, '2014-02-01 00:55:44.000000', 'consum', 0.0215, 'lps'),
	(516643, 128, '2014-02-01 00:55:45.000000', 'consum', 0.0211, 'lps'),
	(516644, 128, '2014-02-01 00:55:46.000000', 'consum', 0.0212, 'lps'),
	(516645, 128, '2014-02-01 00:55:47.000000', 'consum', 0.0219, 'lps'),
	(516646, 128, '2014-02-01 00:55:48.000000', 'consum', 0.0222, 'lps'),
	(516647, 128, '2014-02-01 00:55:49.000000', 'consum', 0.0214, 'lps'),
	(516648, 128, '2014-02-01 00:55:50.000000', 'consum', 0.0210, 'lps'),
	(516649, 128, '2014-02-01 00:55:51.000000', 'consum', 0.0214, 'lps'),
	(516650, 128, '2014-02-01 00:55:52.000000', 'consum', 0.0213, 'lps'),
	(516651, 128, '2014-02-01 00:55:53.000000', 'consum', 0.0216, 'lps'),
	(516652, 128, '2014-02-01 00:55:54.000000', 'consum', 0.0218, 'lps'),
	(516653, 128, '2014-02-01 00:55:55.000000', 'consum', 0.0219, 'lps'),
	(516654, 128, '2014-02-01 00:55:56.000000', 'consum', 0.0215, 'lps'),
	(516655, 128, '2014-02-01 00:55:57.000000', 'consum', 0.0210, 'lps'),
	(516656, 128, '2014-02-01 00:55:58.000000', 'consum', 0.0211, 'lps'),
	(516657, 128, '2014-02-01 00:55:59.000000', 'consum', 0.0214, 'lps'),
	(516658, 128, '2014-02-01 00:56:00.000000', 'consum', 0.0213, 'lps'),
	(516659, 128, '2014-02-01 00:56:01.000000', 'consum', 0.0213, 'lps'),
	(516660, 128, '2014-02-01 00:56:02.000000', 'consum', 0.0215, 'lps'),
	(516661, 128, '2014-02-01 00:56:03.000000', 'consum', 0.0214, 'lps'),
	(516662, 128, '2014-02-01 00:56:04.000000', 'consum', 0.0218, 'lps'),
	(516663, 128, '2014-02-01 00:56:05.000000', 'consum', 0.0221, 'lps'),
	(516664, 128, '2014-02-01 00:56:06.000000', 'consum', 0.0215, 'lps'),
	(516665, 128, '2014-02-01 00:56:07.000000', 'consum', 0.0217, 'lps'),
	(516666, 128, '2014-02-01 00:56:08.000000', 'consum', 0.0215, 'lps'),
	(516667, 128, '2014-02-01 00:56:09.000000', 'consum', 0.0216, 'lps'),
	(516668, 128, '2014-02-01 00:56:10.000000', 'consum', 0.0212, 'lps'),
	(516669, 128, '2014-02-01 00:56:11.000000', 'consum', 0.0215, 'lps'),
	(516670, 128, '2014-02-01 00:56:12.000000', 'consum', 0.0217, 'lps'),
	(516671, 128, '2014-02-01 00:56:13.000000', 'consum', 0.0218, 'lps'),
	(516672, 128, '2014-02-01 00:56:14.000000', 'consum', 0.0214, 'lps'),
	(516673, 128, '2014-02-01 00:56:15.000000', 'consum', 0.0219, 'lps'),
	(516674, 128, '2014-02-01 00:56:16.000000', 'consum', 0.0216, 'lps'),
	(516675, 128, '2014-02-01 00:56:17.000000', 'consum', 0.0212, 'lps'),
	(516676, 128, '2014-02-01 00:56:18.000000', 'consum', 0.0219, 'lps'),
	(516677, 128, '2014-02-01 00:56:19.000000', 'consum', 0.0221, 'lps'),
	(516678, 128, '2014-02-01 00:56:20.000000', 'consum', 0.0211, 'lps'),
	(516679, 128, '2014-02-01 00:56:21.000000', 'consum', 0.0223, 'lps'),
	(516680, 128, '2014-02-01 00:56:22.000000', 'consum', 0.0215, 'lps'),
	(516681, 128, '2014-02-01 00:56:23.000000', 'consum', 0.0214, 'lps'),
	(516682, 128, '2014-02-01 00:56:24.000000', 'consum', 0.0213, 'lps'),
	(516683, 128, '2014-02-01 00:56:25.000000', 'consum', 0.0216, 'lps'),
	(516684, 128, '2014-02-01 00:56:26.000000', 'consum', 0.0215, 'lps'),
	(516685, 128, '2014-02-01 00:56:27.000000', 'consum', 0.0218, 'lps'),
	(516686, 128, '2014-02-01 00:56:28.000000', 'consum', 0.0221, 'lps'),
	(516687, 128, '2014-02-01 00:56:29.000000', 'consum', 0.0213, 'lps'),
	(516688, 128, '2014-02-01 00:56:30.000000', 'consum', 0.0223, 'lps'),
	(516689, 128, '2014-02-01 00:56:31.000000', 'consum', 0.0223, 'lps'),
	(516690, 128, '2014-02-01 00:56:32.000000', 'consum', 0.0222, 'lps'),
	(516691, 128, '2014-02-01 00:56:33.000000', 'consum', 0.0216, 'lps'),
	(516692, 128, '2014-02-01 00:56:34.000000', 'consum', 0.0220, 'lps'),
	(516693, 128, '2014-02-01 00:56:35.000000', 'consum', 0.0216, 'lps'),
	(516694, 128, '2014-02-01 00:56:36.000000', 'consum', 0.0223, 'lps'),
	(516695, 128, '2014-02-01 00:56:37.000000', 'consum', 0.0214, 'lps'),
	(516696, 128, '2014-02-01 00:56:38.000000', 'consum', 0.0221, 'lps'),
	(516697, 128, '2014-02-01 00:56:39.000000', 'consum', 0.0213, 'lps'),
	(516698, 128, '2014-02-01 00:56:40.000000', 'consum', 0.0221, 'lps'),
	(516699, 128, '2014-02-01 00:56:41.000000', 'consum', 0.0211, 'lps'),
	(516700, 128, '2014-02-01 00:56:42.000000', 'consum', 0.0214, 'lps'),
	(516701, 128, '2014-02-01 00:56:43.000000', 'consum', 0.0211, 'lps'),
	(516702, 128, '2014-02-01 00:56:44.000000', 'consum', 0.0218, 'lps'),
	(516703, 128, '2014-02-01 00:56:45.000000', 'consum', 0.0218, 'lps'),
	(516704, 128, '2014-02-01 00:56:46.000000', 'consum', 0.0216, 'lps'),
	(516705, 128, '2014-02-01 00:56:47.000000', 'consum', 0.0214, 'lps'),
	(516706, 128, '2014-02-01 00:56:48.000000', 'consum', 0.0212, 'lps'),
	(516707, 128, '2014-02-01 00:56:49.000000', 'consum', 0.0210, 'lps'),
	(516708, 128, '2014-02-01 00:56:50.000000', 'consum', 0.0218, 'lps'),
	(516709, 128, '2014-02-01 00:56:51.000000', 'consum', 0.0223, 'lps'),
	(516710, 128, '2014-02-01 00:56:52.000000', 'consum', 0.0223, 'lps'),
	(516711, 128, '2014-02-01 00:56:53.000000', 'consum', 0.0223, 'lps'),
	(516712, 128, '2014-02-01 00:56:54.000000', 'consum', 0.0223, 'lps'),
	(516713, 128, '2014-02-01 00:56:55.000000', 'consum', 0.0223, 'lps'),
	(516714, 128, '2014-02-01 00:56:56.000000', 'consum', 0.0222, 'lps'),
	(516715, 128, '2014-02-01 00:56:57.000000', 'consum', 0.0216, 'lps'),
	(516716, 128, '2014-02-01 00:56:58.000000', 'consum', 0.0219, 'lps'),
	(516717, 128, '2014-02-01 00:56:59.000000', 'consum', 0.0210, 'lps'),
	(516718, 128, '2014-02-01 00:57:00.000000', 'consum', 0.0210, 'lps'),
	(516719, 128, '2014-02-01 00:57:01.000000', 'consum', 0.0213, 'lps'),
	(516720, 128, '2014-02-01 00:57:02.000000', 'consum', 0.0212, 'lps'),
	(516721, 128, '2014-02-01 00:57:03.000000', 'consum', 0.0212, 'lps'),
	(516722, 128, '2014-02-01 00:57:04.000000', 'consum', 0.0213, 'lps'),
	(516723, 128, '2014-02-01 00:57:05.000000', 'consum', 0.0218, 'lps'),
	(516724, 128, '2014-02-01 00:57:06.000000', 'consum', 0.0214, 'lps'),
	(516725, 128, '2014-02-01 00:57:07.000000', 'consum', 0.0222, 'lps'),
	(516726, 128, '2014-02-01 00:57:08.000000', 'consum', 0.0215, 'lps'),
	(516727, 128, '2014-02-01 00:57:09.000000', 'consum', 0.0214, 'lps'),
	(516728, 128, '2014-02-01 00:57:10.000000', 'consum', 0.0217, 'lps'),
	(516729, 128, '2014-02-01 00:57:11.000000', 'consum', 0.0220, 'lps'),
	(516730, 128, '2014-02-01 00:57:12.000000', 'consum', 0.0210, 'lps'),
	(516731, 128, '2014-02-01 00:57:13.000000', 'consum', 0.0222, 'lps'),
	(516732, 128, '2014-02-01 00:57:14.000000', 'consum', 0.0214, 'lps'),
	(516733, 128, '2014-02-01 00:57:15.000000', 'consum', 0.0222, 'lps'),
	(516734, 128, '2014-02-01 00:57:16.000000', 'consum', 0.0219, 'lps'),
	(516735, 128, '2014-02-01 00:57:17.000000', 'consum', 0.0218, 'lps'),
	(516736, 128, '2014-02-01 00:57:18.000000', 'consum', 0.0223, 'lps'),
	(516737, 128, '2014-02-01 00:57:19.000000', 'consum', 0.0210, 'lps'),
	(516738, 128, '2014-02-01 00:57:20.000000', 'consum', 0.0212, 'lps'),
	(516739, 128, '2014-02-01 00:57:21.000000', 'consum', 0.0222, 'lps'),
	(516740, 128, '2014-02-01 00:57:22.000000', 'consum', 0.0223, 'lps'),
	(516741, 128, '2014-02-01 00:57:23.000000', 'consum', 0.0213, 'lps'),
	(516742, 128, '2014-02-01 00:57:24.000000', 'consum', 0.0212, 'lps'),
	(516743, 128, '2014-02-01 00:57:25.000000', 'consum', 0.0212, 'lps'),
	(516744, 128, '2014-02-01 00:57:26.000000', 'consum', 0.0216, 'lps'),
	(516745, 128, '2014-02-01 00:57:27.000000', 'consum', 0.0219, 'lps'),
	(516746, 128, '2014-02-01 00:57:28.000000', 'consum', 0.0222, 'lps'),
	(516747, 128, '2014-02-01 00:57:29.000000', 'consum', 0.0217, 'lps'),
	(516748, 128, '2014-02-01 00:57:30.000000', 'consum', 0.0211, 'lps'),
	(516749, 128, '2014-02-01 00:57:31.000000', 'consum', 0.0223, 'lps'),
	(516750, 128, '2014-02-01 00:57:32.000000', 'consum', 0.0213, 'lps'),
	(516751, 128, '2014-02-01 00:57:33.000000', 'consum', 0.0218, 'lps'),
	(516752, 128, '2014-02-01 00:57:34.000000', 'consum', 0.0213, 'lps'),
	(516753, 128, '2014-02-01 00:57:35.000000', 'consum', 0.0216, 'lps'),
	(516754, 128, '2014-02-01 00:57:36.000000', 'consum', 0.0217, 'lps'),
	(516755, 128, '2014-02-01 00:57:37.000000', 'consum', 0.0214, 'lps'),
	(516756, 128, '2014-02-01 00:57:38.000000', 'consum', 0.0210, 'lps'),
	(516757, 128, '2014-02-01 00:57:39.000000', 'consum', 0.0210, 'lps'),
	(516758, 128, '2014-02-01 00:57:40.000000', 'consum', 0.0213, 'lps'),
	(516759, 128, '2014-02-01 00:57:41.000000', 'consum', 0.0210, 'lps'),
	(516760, 128, '2014-02-01 00:57:42.000000', 'consum', 0.0216, 'lps'),
	(516761, 128, '2014-02-01 00:57:43.000000', 'consum', 0.0213, 'lps'),
	(516762, 128, '2014-02-01 00:57:44.000000', 'consum', 0.0223, 'lps'),
	(516763, 128, '2014-02-01 00:57:45.000000', 'consum', 0.0223, 'lps'),
	(516764, 128, '2014-02-01 00:57:46.000000', 'consum', 0.0210, 'lps'),
	(516765, 128, '2014-02-01 00:57:47.000000', 'consum', 0.0214, 'lps'),
	(516766, 128, '2014-02-01 00:57:48.000000', 'consum', 0.0215, 'lps'),
	(516767, 128, '2014-02-01 00:57:49.000000', 'consum', 0.0211, 'lps'),
	(516768, 128, '2014-02-01 00:57:50.000000', 'consum', 0.0213, 'lps'),
	(516769, 128, '2014-02-01 00:57:51.000000', 'consum', 0.0223, 'lps'),
	(516770, 128, '2014-02-01 00:57:52.000000', 'consum', 0.0211, 'lps'),
	(516771, 128, '2014-02-01 00:57:53.000000', 'consum', 0.0217, 'lps'),
	(516772, 128, '2014-02-01 00:57:54.000000', 'consum', 0.0215, 'lps'),
	(516773, 128, '2014-02-01 00:57:55.000000', 'consum', 0.0216, 'lps'),
	(516774, 128, '2014-02-01 00:57:56.000000', 'consum', 0.0210, 'lps'),
	(516775, 128, '2014-02-01 00:57:57.000000', 'consum', 0.0222, 'lps'),
	(516776, 128, '2014-02-01 00:57:58.000000', 'consum', 0.0213, 'lps'),
	(516777, 128, '2014-02-01 00:57:59.000000', 'consum', 0.0217, 'lps'),
	(516778, 128, '2014-02-01 00:58:00.000000', 'consum', 0.0210, 'lps'),
	(516779, 128, '2014-02-01 00:58:01.000000', 'consum', 0.0217, 'lps'),
	(516780, 128, '2014-02-01 00:58:02.000000', 'consum', 0.0219, 'lps'),
	(516781, 128, '2014-02-01 00:58:03.000000', 'consum', 0.0219, 'lps'),
	(516782, 128, '2014-02-01 00:58:04.000000', 'consum', 0.0216, 'lps'),
	(516783, 128, '2014-02-01 00:58:05.000000', 'consum', 0.0212, 'lps'),
	(516784, 128, '2014-02-01 00:58:06.000000', 'consum', 0.0218, 'lps'),
	(516785, 128, '2014-02-01 00:58:07.000000', 'consum', 0.0214, 'lps'),
	(516786, 128, '2014-02-01 00:58:08.000000', 'consum', 0.0222, 'lps'),
	(516787, 128, '2014-02-01 00:58:09.000000', 'consum', 0.0218, 'lps'),
	(516788, 128, '2014-02-01 00:58:10.000000', 'consum', 0.0212, 'lps'),
	(516789, 128, '2014-02-01 00:58:11.000000', 'consum', 0.0213, 'lps'),
	(516790, 128, '2014-02-01 00:58:12.000000', 'consum', 0.0219, 'lps'),
	(516791, 128, '2014-02-01 00:58:13.000000', 'consum', 0.0220, 'lps'),
	(516792, 128, '2014-02-01 00:58:14.000000', 'consum', 0.0218, 'lps'),
	(516793, 128, '2014-02-01 00:58:15.000000', 'consum', 0.0221, 'lps'),
	(516794, 128, '2014-02-01 00:58:16.000000', 'consum', 0.0212, 'lps'),
	(516795, 128, '2014-02-01 00:58:17.000000', 'consum', 0.0216, 'lps'),
	(516796, 128, '2014-02-01 00:58:18.000000', 'consum', 0.0222, 'lps'),
	(516797, 128, '2014-02-01 00:58:19.000000', 'consum', 0.0211, 'lps'),
	(516798, 128, '2014-02-01 00:58:20.000000', 'consum', 0.0220, 'lps'),
	(516799, 128, '2014-02-01 00:58:21.000000', 'consum', 0.0214, 'lps'),
	(516800, 128, '2014-02-01 00:58:22.000000', 'consum', 0.0218, 'lps'),
	(516801, 128, '2014-02-01 00:58:23.000000', 'consum', 0.0222, 'lps'),
	(516802, 128, '2014-02-01 00:58:24.000000', 'consum', 0.0219, 'lps'),
	(516803, 128, '2014-02-01 00:58:25.000000', 'consum', 0.0219, 'lps'),
	(516804, 128, '2014-02-01 00:58:26.000000', 'consum', 0.0215, 'lps'),
	(516805, 128, '2014-02-01 00:58:27.000000', 'consum', 0.0222, 'lps'),
	(516806, 128, '2014-02-01 00:58:28.000000', 'consum', 0.0214, 'lps'),
	(516807, 128, '2014-02-01 00:58:29.000000', 'consum', 0.0223, 'lps'),
	(516808, 128, '2014-02-01 00:58:30.000000', 'consum', 0.0223, 'lps'),
	(516809, 128, '2014-02-01 00:58:31.000000', 'consum', 0.0222, 'lps'),
	(516810, 128, '2014-02-01 00:58:32.000000', 'consum', 0.0216, 'lps'),
	(516811, 128, '2014-02-01 00:58:33.000000', 'consum', 0.0218, 'lps'),
	(516812, 128, '2014-02-01 00:58:34.000000', 'consum', 0.0220, 'lps'),
	(516813, 128, '2014-02-01 00:58:35.000000', 'consum', 0.0220, 'lps'),
	(516814, 128, '2014-02-01 00:58:36.000000', 'consum', 0.0220, 'lps'),
	(516815, 128, '2014-02-01 00:58:37.000000', 'consum', 0.0213, 'lps'),
	(516816, 128, '2014-02-01 00:58:38.000000', 'consum', 0.0210, 'lps'),
	(516817, 128, '2014-02-01 00:58:39.000000', 'consum', 0.0218, 'lps'),
	(516818, 128, '2014-02-01 00:58:40.000000', 'consum', 0.0221, 'lps'),
	(516819, 128, '2014-02-01 00:58:41.000000', 'consum', 0.0216, 'lps'),
	(516820, 128, '2014-02-01 00:58:42.000000', 'consum', 0.0218, 'lps'),
	(516821, 128, '2014-02-01 00:58:43.000000', 'consum', 0.0221, 'lps'),
	(516822, 128, '2014-02-01 00:58:44.000000', 'consum', 0.0214, 'lps'),
	(516823, 128, '2014-02-01 00:58:45.000000', 'consum', 0.0223, 'lps'),
	(516824, 128, '2014-02-01 00:58:46.000000', 'consum', 0.0222, 'lps'),
	(516825, 128, '2014-02-01 00:58:47.000000', 'consum', 0.0216, 'lps'),
	(516826, 128, '2014-02-01 00:58:48.000000', 'consum', 0.0219, 'lps'),
	(516827, 128, '2014-02-01 00:58:49.000000', 'consum', 0.0210, 'lps'),
	(516828, 128, '2014-02-01 00:58:50.000000', 'consum', 0.0212, 'lps'),
	(516829, 128, '2014-02-01 00:58:51.000000', 'consum', 0.0222, 'lps'),
	(516830, 128, '2014-02-01 00:58:52.000000', 'consum', 0.0220, 'lps'),
	(516831, 128, '2014-02-01 00:58:53.000000', 'consum', 0.0211, 'lps'),
	(516832, 128, '2014-02-01 00:58:54.000000', 'consum', 0.0214, 'lps'),
	(516833, 128, '2014-02-01 00:58:55.000000', 'consum', 0.0213, 'lps'),
	(516834, 128, '2014-02-01 00:58:56.000000', 'consum', 0.0213, 'lps'),
	(516835, 128, '2014-02-01 00:58:57.000000', 'consum', 0.0215, 'lps'),
	(516836, 128, '2014-02-01 00:58:58.000000', 'consum', 0.0216, 'lps'),
	(516837, 128, '2014-02-01 00:58:59.000000', 'consum', 0.0223, 'lps'),
	(516838, 128, '2014-02-01 00:59:00.000000', 'consum', 0.0214, 'lps'),
	(516839, 128, '2014-02-01 00:59:01.000000', 'consum', 0.0222, 'lps'),
	(516840, 128, '2014-02-01 00:59:02.000000', 'consum', 0.0218, 'lps'),
	(516841, 128, '2014-02-01 00:59:03.000000', 'consum', 0.0212, 'lps'),
	(516842, 128, '2014-02-01 00:59:04.000000', 'consum', 0.0210, 'lps'),
	(516843, 128, '2014-02-01 00:59:05.000000', 'consum', 0.0217, 'lps'),
	(516844, 128, '2014-02-01 00:59:06.000000', 'consum', 0.0221, 'lps'),
	(516845, 128, '2014-02-01 00:59:07.000000', 'consum', 0.0213, 'lps'),
	(516846, 128, '2014-02-01 00:59:08.000000', 'consum', 0.0223, 'lps'),
	(516847, 128, '2014-02-01 00:59:09.000000', 'consum', 0.0212, 'lps'),
	(516848, 128, '2014-02-01 00:59:10.000000', 'consum', 0.0220, 'lps'),
	(516849, 128, '2014-02-01 00:59:11.000000', 'consum', 0.0215, 'lps'),
	(516850, 128, '2014-02-01 00:59:12.000000', 'consum', 0.0221, 'lps'),
	(516851, 128, '2014-02-01 00:59:13.000000', 'consum', 0.0220, 'lps'),
	(516852, 128, '2014-02-01 00:59:14.000000', 'consum', 0.0214, 'lps'),
	(516853, 128, '2014-02-01 00:59:15.000000', 'consum', 0.0215, 'lps'),
	(516854, 128, '2014-02-01 00:59:16.000000', 'consum', 0.0210, 'lps'),
	(516855, 128, '2014-02-01 00:59:17.000000', 'consum', 0.0210, 'lps'),
	(516856, 128, '2014-02-01 00:59:18.000000', 'consum', 0.0211, 'lps'),
	(516857, 128, '2014-02-01 00:59:19.000000', 'consum', 0.0214, 'lps'),
	(516858, 128, '2014-02-01 00:59:20.000000', 'consum', 0.0212, 'lps'),
	(516859, 128, '2014-02-01 00:59:21.000000', 'consum', 0.0211, 'lps'),
	(516860, 128, '2014-02-01 00:59:22.000000', 'consum', 0.0211, 'lps'),
	(516861, 128, '2014-02-01 00:59:23.000000', 'consum', 0.0223, 'lps'),
	(516862, 128, '2014-02-01 00:59:24.000000', 'consum', 0.0217, 'lps'),
	(516863, 128, '2014-02-01 00:59:25.000000', 'consum', 0.0223, 'lps'),
	(516864, 128, '2014-02-01 00:59:26.000000', 'consum', 0.0210, 'lps'),
	(516865, 128, '2014-02-01 00:59:27.000000', 'consum', 0.0214, 'lps'),
	(516866, 128, '2014-02-01 00:59:28.000000', 'consum', 0.0217, 'lps'),
	(516867, 128, '2014-02-01 00:59:29.000000', 'consum', 0.0218, 'lps'),
	(516868, 128, '2014-02-01 00:59:30.000000', 'consum', 0.0218, 'lps'),
	(516869, 128, '2014-02-01 00:59:31.000000', 'consum', 0.0212, 'lps'),
	(516870, 128, '2014-02-01 00:59:32.000000', 'consum', 0.0223, 'lps'),
	(516871, 128, '2014-02-01 00:59:33.000000', 'consum', 0.0214, 'lps'),
	(516872, 128, '2014-02-01 00:59:34.000000', 'consum', 0.0221, 'lps'),
	(516873, 128, '2014-02-01 00:59:35.000000', 'consum', 0.0223, 'lps'),
	(516874, 128, '2014-02-01 00:59:36.000000', 'consum', 0.0215, 'lps'),
	(516875, 128, '2014-02-01 00:59:37.000000', 'consum', 0.0212, 'lps'),
	(516876, 128, '2014-02-01 00:59:38.000000', 'consum', 0.0220, 'lps'),
	(516877, 128, '2014-02-01 00:59:39.000000', 'consum', 0.0213, 'lps'),
	(516878, 128, '2014-02-01 00:59:40.000000', 'consum', 0.0222, 'lps'),
	(516879, 128, '2014-02-01 00:59:41.000000', 'consum', 0.0221, 'lps'),
	(516880, 128, '2014-02-01 00:59:42.000000', 'consum', 0.0213, 'lps'),
	(516881, 128, '2014-02-01 00:59:43.000000', 'consum', 0.0221, 'lps'),
	(516882, 128, '2014-02-01 00:59:44.000000', 'consum', 0.0213, 'lps'),
	(516883, 128, '2014-02-01 00:59:45.000000', 'consum', 0.0222, 'lps'),
	(516884, 128, '2014-02-01 00:59:46.000000', 'consum', 0.0219, 'lps'),
	(516885, 128, '2014-02-01 00:59:47.000000', 'consum', 0.0219, 'lps'),
	(516886, 128, '2014-02-01 00:59:48.000000', 'consum', 0.0215, 'lps'),
	(516887, 128, '2014-02-01 00:59:49.000000', 'consum', 0.0210, 'lps'),
	(516888, 128, '2014-02-01 00:59:50.000000', 'consum', 0.0222, 'lps'),
	(516889, 128, '2014-02-01 00:59:51.000000', 'consum', 0.0216, 'lps'),
	(516890, 128, '2014-02-01 00:59:52.000000', 'consum', 0.0216, 'lps'),
	(516891, 128, '2014-02-01 00:59:53.000000', 'consum', 0.0211, 'lps'),
	(516892, 128, '2014-02-01 00:59:54.000000', 'consum', 0.0223, 'lps'),
	(516893, 128, '2014-02-01 00:59:55.000000', 'consum', 0.0217, 'lps'),
	(516894, 128, '2014-02-01 00:59:56.000000', 'consum', 0.0221, 'lps'),
	(516895, 128, '2014-02-01 00:59:57.000000', 'consum', 0.0216, 'lps'),
	(516896, 128, '2014-02-01 00:59:58.000000', 'consum', 0.0220, 'lps'),
	(516897, 128, '2014-02-01 00:59:59.000000', 'consum', 0.0215, 'lps'),
	(516898, 128, '2014-02-01 01:00:00.000000', 'consum', 0.0221, 'lps'),
	(516899, 128, '2014-02-01 01:00:01.000000', 'consum', 0.0222, 'lps'),
	(516900, 128, '2014-02-01 01:00:02.000000', 'consum', 0.0211, 'lps'),
	(516901, 128, '2014-02-01 01:00:03.000000', 'consum', 0.0218, 'lps'),
	(516902, 128, '2014-02-01 01:00:04.000000', 'consum', 0.0223, 'lps'),
	(516903, 128, '2014-02-01 01:00:05.000000', 'consum', 0.0223, 'lps'),
	(516904, 128, '2014-02-01 01:00:06.000000', 'consum', 0.0223, 'lps'),
	(516905, 128, '2014-02-01 01:00:07.000000', 'consum', 0.0221, 'lps'),
	(516906, 128, '2014-02-01 01:00:08.000000', 'consum', 0.0214, 'lps'),
	(516907, 128, '2014-02-01 01:00:09.000000', 'consum', 0.0223, 'lps'),
	(516908, 128, '2014-02-01 01:00:10.000000', 'consum', 0.0210, 'lps'),
	(516909, 128, '2014-02-01 01:00:11.000000', 'consum', 0.0211, 'lps'),
	(516910, 128, '2014-02-01 01:00:12.000000', 'consum', 0.0217, 'lps'),
	(516911, 128, '2014-02-01 01:00:13.000000', 'consum', 0.0215, 'lps'),
	(516912, 128, '2014-02-01 01:00:14.000000', 'consum', 0.0214, 'lps'),
	(516913, 128, '2014-02-01 01:00:15.000000', 'consum', 0.0217, 'lps'),
	(516914, 128, '2014-02-01 01:00:16.000000', 'consum', 0.0219, 'lps'),
	(516915, 128, '2014-02-01 01:00:17.000000', 'consum', 0.0222, 'lps'),
	(516916, 128, '2014-02-01 01:00:18.000000', 'consum', 0.0212, 'lps'),
	(516917, 128, '2014-02-01 01:00:19.000000', 'consum', 0.0215, 'lps'),
	(516918, 128, '2014-02-01 01:00:20.000000', 'consum', 0.0213, 'lps'),
	(516919, 128, '2014-02-01 01:00:21.000000', 'consum', 0.0214, 'lps'),
	(516920, 128, '2014-02-01 01:00:22.000000', 'consum', 0.0218, 'lps'),
	(516921, 128, '2014-02-01 01:00:23.000000', 'consum', 0.0212, 'lps'),
	(516922, 128, '2014-02-01 01:00:24.000000', 'consum', 0.0210, 'lps'),
	(516923, 128, '2014-02-01 01:00:25.000000', 'consum', 0.0220, 'lps'),
	(516924, 128, '2014-02-01 01:00:26.000000', 'consum', 0.0216, 'lps'),
	(516925, 128, '2014-02-01 01:00:27.000000', 'consum', 0.0213, 'lps'),
	(516926, 128, '2014-02-01 01:00:28.000000', 'consum', 0.0220, 'lps'),
	(516927, 128, '2014-02-01 01:00:29.000000', 'consum', 0.0211, 'lps'),
	(516928, 128, '2014-02-01 01:00:30.000000', 'consum', 0.0211, 'lps'),
	(516929, 128, '2014-02-01 01:00:31.000000', 'consum', 0.0215, 'lps'),
	(516930, 128, '2014-02-01 01:00:32.000000', 'consum', 0.0217, 'lps'),
	(516931, 128, '2014-02-01 01:00:33.000000', 'consum', 0.0219, 'lps'),
	(516932, 128, '2014-02-01 01:00:34.000000', 'consum', 0.0218, 'lps'),
	(516933, 128, '2014-02-01 01:00:35.000000', 'consum', 0.0211, 'lps'),
	(516934, 128, '2014-02-01 01:00:36.000000', 'consum', 0.0219, 'lps'),
	(516935, 128, '2014-02-01 01:00:37.000000', 'consum', 0.0212, 'lps'),
	(516936, 128, '2014-02-01 01:00:38.000000', 'consum', 0.0219, 'lps'),
	(516937, 128, '2014-02-01 01:00:39.000000', 'consum', 0.0221, 'lps'),
	(516938, 128, '2014-02-01 01:00:40.000000', 'consum', 0.0210, 'lps'),
	(516939, 128, '2014-02-01 01:00:41.000000', 'consum', 0.0219, 'lps'),
	(516940, 128, '2014-02-01 01:00:42.000000', 'consum', 0.0215, 'lps'),
	(516941, 128, '2014-02-01 01:00:43.000000', 'consum', 0.0223, 'lps'),
	(516942, 128, '2014-02-01 01:00:44.000000', 'consum', 0.0218, 'lps'),
	(516943, 128, '2014-02-01 01:00:45.000000', 'consum', 0.0212, 'lps'),
	(516944, 128, '2014-02-01 01:00:46.000000', 'consum', 0.0223, 'lps'),
	(516945, 128, '2014-02-01 01:00:47.000000', 'consum', 0.0216, 'lps'),
	(516946, 128, '2014-02-01 01:00:48.000000', 'consum', 0.0215, 'lps'),
	(516947, 128, '2014-02-01 01:00:49.000000', 'consum', 0.0218, 'lps'),
	(516948, 128, '2014-02-01 01:00:50.000000', 'consum', 0.0223, 'lps'),
	(516949, 128, '2014-02-01 01:00:51.000000', 'consum', 0.0221, 'lps'),
	(516950, 128, '2014-02-01 01:00:52.000000', 'consum', 0.0212, 'lps'),
	(516951, 128, '2014-02-01 01:00:53.000000', 'consum', 0.0217, 'lps'),
	(516952, 128, '2014-02-01 01:00:54.000000', 'consum', 0.0212, 'lps'),
	(516953, 128, '2014-02-01 01:00:55.000000', 'consum', 0.0212, 'lps'),
	(516954, 128, '2014-02-01 01:00:56.000000', 'consum', 0.0214, 'lps'),
	(516955, 128, '2014-02-01 01:00:57.000000', 'consum', 0.0213, 'lps'),
	(516956, 128, '2014-02-01 01:00:58.000000', 'consum', 0.0213, 'lps'),
	(516957, 128, '2014-02-01 01:00:59.000000', 'consum', 0.0214, 'lps'),
	(516958, 128, '2014-02-01 01:01:00.000000', 'consum', 0.0211, 'lps'),
	(516959, 128, '2014-02-01 01:01:01.000000', 'consum', 0.0215, 'lps'),
	(516960, 128, '2014-02-01 01:01:02.000000', 'consum', 0.0218, 'lps'),
	(516961, 128, '2014-02-01 01:01:03.000000', 'consum', 0.0221, 'lps'),
	(516962, 128, '2014-02-01 01:01:04.000000', 'consum', 0.0214, 'lps'),
	(516963, 128, '2014-02-01 01:01:05.000000', 'consum', 0.0211, 'lps'),
	(516964, 128, '2014-02-01 01:01:06.000000', 'consum', 0.0219, 'lps'),
	(516965, 128, '2014-02-01 01:01:07.000000', 'consum', 0.0211, 'lps'),
	(516966, 128, '2014-02-01 01:01:08.000000', 'consum', 0.0214, 'lps'),
	(516967, 128, '2014-02-01 01:01:09.000000', 'consum', 0.0213, 'lps'),
	(516968, 128, '2014-02-01 01:01:10.000000', 'consum', 0.0217, 'lps'),
	(516969, 128, '2014-02-01 01:01:11.000000', 'consum', 0.0220, 'lps'),
	(516970, 128, '2014-02-01 01:01:12.000000', 'consum', 0.0211, 'lps'),
	(516971, 128, '2014-02-01 01:01:13.000000', 'consum', 0.0215, 'lps'),
	(516972, 128, '2014-02-01 01:01:14.000000', 'consum', 0.0219, 'lps'),
	(516973, 128, '2014-02-01 01:01:15.000000', 'consum', 0.0213, 'lps'),
	(516974, 128, '2014-02-01 01:01:16.000000', 'consum', 0.0211, 'lps'),
	(516975, 128, '2014-02-01 01:01:17.000000', 'consum', 0.0221, 'lps'),
	(516976, 128, '2014-02-01 01:01:18.000000', 'consum', 0.0218, 'lps'),
	(516977, 128, '2014-02-01 01:01:19.000000', 'consum', 0.0221, 'lps'),
	(516978, 128, '2014-02-01 01:01:20.000000', 'consum', 0.0212, 'lps'),
	(516979, 128, '2014-02-01 01:01:21.000000', 'consum', 0.0218, 'lps'),
	(516980, 128, '2014-02-01 01:01:22.000000', 'consum', 0.0213, 'lps'),
	(516981, 128, '2014-02-01 01:01:23.000000', 'consum', 0.0216, 'lps'),
	(516982, 128, '2014-02-01 01:01:24.000000', 'consum', 0.0219, 'lps'),
	(516983, 128, '2014-02-01 01:01:25.000000', 'consum', 0.0211, 'lps'),
	(516984, 128, '2014-02-01 01:01:26.000000', 'consum', 0.0213, 'lps'),
	(516985, 128, '2014-02-01 01:01:27.000000', 'consum', 0.0210, 'lps'),
	(516986, 128, '2014-02-01 01:01:28.000000', 'consum', 0.0215, 'lps'),
	(516987, 128, '2014-02-01 01:01:29.000000', 'consum', 0.0223, 'lps'),
	(516988, 128, '2014-02-01 01:01:30.000000', 'consum', 0.0217, 'lps'),
	(516989, 128, '2014-02-01 01:01:31.000000', 'consum', 0.0220, 'lps'),
	(516990, 128, '2014-02-01 01:01:32.000000', 'consum', 0.0212, 'lps'),
	(516991, 128, '2014-02-01 01:01:33.000000', 'consum', 0.0219, 'lps'),
	(516992, 128, '2014-02-01 01:01:34.000000', 'consum', 0.0221, 'lps'),
	(516993, 128, '2014-02-01 01:01:35.000000', 'consum', 0.0211, 'lps'),
	(516994, 128, '2014-02-01 01:01:36.000000', 'consum', 0.0223, 'lps'),
	(516995, 128, '2014-02-01 01:01:37.000000', 'consum', 0.0217, 'lps'),
	(516996, 128, '2014-02-01 01:01:38.000000', 'consum', 0.0219, 'lps'),
	(516997, 128, '2014-02-01 01:01:39.000000', 'consum', 0.0223, 'lps'),
	(516998, 128, '2014-02-01 01:01:40.000000', 'consum', 0.0220, 'lps'),
	(516999, 128, '2014-02-01 01:01:41.000000', 'consum', 0.0221, 'lps'),
	(517000, 128, '2014-02-01 01:01:42.000000', 'consum', 0.0223, 'lps'),
	(517001, 128, '2014-02-01 01:01:43.000000', 'consum', 0.0213, 'lps'),
	(517002, 128, '2014-02-01 01:01:44.000000', 'consum', 0.0216, 'lps'),
	(517003, 128, '2014-02-01 01:01:45.000000', 'consum', 0.0216, 'lps'),
	(517004, 128, '2014-02-01 01:01:46.000000', 'consum', 0.0221, 'lps'),
	(517005, 128, '2014-02-01 01:01:47.000000', 'consum', 0.0220, 'lps'),
	(517006, 128, '2014-02-01 01:01:48.000000', 'consum', 0.0216, 'lps'),
	(517007, 128, '2014-02-01 01:01:49.000000', 'consum', 0.0223, 'lps'),
	(517008, 128, '2014-02-01 01:01:50.000000', 'consum', 0.0215, 'lps'),
	(517009, 128, '2014-02-01 01:01:51.000000', 'consum', 0.0211, 'lps'),
	(517010, 128, '2014-02-01 01:01:52.000000', 'consum', 0.0215, 'lps'),
	(517011, 128, '2014-02-01 01:01:53.000000', 'consum', 0.0216, 'lps'),
	(517012, 128, '2014-02-01 01:01:54.000000', 'consum', 0.0214, 'lps'),
	(517013, 128, '2014-02-01 01:01:55.000000', 'consum', 0.0210, 'lps'),
	(517014, 128, '2014-02-01 01:01:56.000000', 'consum', 0.0215, 'lps'),
	(517015, 128, '2014-02-01 01:01:57.000000', 'consum', 0.0220, 'lps'),
	(517016, 128, '2014-02-01 01:01:58.000000', 'consum', 0.0219, 'lps'),
	(517017, 128, '2014-02-01 01:01:59.000000', 'consum', 0.0212, 'lps'),
	(517018, 128, '2014-02-01 01:02:00.000000', 'consum', 0.0219, 'lps'),
	(517019, 128, '2014-02-01 01:02:01.000000', 'consum', 0.0221, 'lps'),
	(517020, 128, '2014-02-01 01:02:02.000000', 'consum', 0.0212, 'lps'),
	(517021, 128, '2014-02-01 01:02:03.000000', 'consum', 0.0214, 'lps'),
	(517022, 128, '2014-02-01 01:02:04.000000', 'consum', 0.0213, 'lps'),
	(517023, 128, '2014-02-01 01:02:05.000000', 'consum', 0.0213, 'lps'),
	(517024, 128, '2014-02-01 01:02:06.000000', 'consum', 0.0216, 'lps'),
	(517025, 128, '2014-02-01 01:02:07.000000', 'consum', 0.0219, 'lps'),
	(517026, 128, '2014-02-01 01:02:08.000000', 'consum', 0.0211, 'lps'),
	(517027, 128, '2014-02-01 01:02:09.000000', 'consum', 0.0213, 'lps'),
	(517028, 128, '2014-02-01 01:02:10.000000', 'consum', 0.0223, 'lps'),
	(517029, 128, '2014-02-01 01:02:11.000000', 'consum', 0.0213, 'lps'),
	(517030, 128, '2014-02-01 01:02:12.000000', 'consum', 0.0211, 'lps'),
	(517031, 128, '2014-02-01 01:02:13.000000', 'consum', 0.0223, 'lps'),
	(517032, 128, '2014-02-01 01:02:14.000000', 'consum', 0.0215, 'lps'),
	(517033, 128, '2014-02-01 01:02:15.000000', 'consum', 0.0213, 'lps'),
	(517034, 128, '2014-02-01 01:02:16.000000', 'consum', 0.0223, 'lps'),
	(517035, 128, '2014-02-01 01:02:17.000000', 'consum', 0.0210, 'lps'),
	(517036, 128, '2014-02-01 01:02:18.000000', 'consum', 0.0213, 'lps'),
	(517037, 128, '2014-02-01 01:02:19.000000', 'consum', 0.0213, 'lps'),
	(517038, 128, '2014-02-01 01:02:20.000000', 'consum', 0.0216, 'lps'),
	(517039, 128, '2014-02-01 01:02:21.000000', 'consum', 0.0217, 'lps'),
	(517040, 128, '2014-02-01 01:02:22.000000', 'consum', 0.0212, 'lps'),
	(517041, 128, '2014-02-01 01:02:23.000000', 'consum', 0.0214, 'lps'),
	(517042, 128, '2014-02-01 01:02:24.000000', 'consum', 0.0213, 'lps'),
	(517043, 128, '2014-02-01 01:02:25.000000', 'consum', 0.0211, 'lps'),
	(517044, 128, '2014-02-01 01:02:26.000000', 'consum', 0.0221, 'lps'),
	(517045, 128, '2014-02-01 01:02:27.000000', 'consum', 0.0222, 'lps'),
	(517046, 128, '2014-02-01 01:02:28.000000', 'consum', 0.0221, 'lps'),
	(517047, 128, '2014-02-01 01:02:29.000000', 'consum', 0.0217, 'lps'),
	(517048, 128, '2014-02-01 01:02:30.000000', 'consum', 0.0214, 'lps'),
	(517049, 128, '2014-02-01 01:02:31.000000', 'consum', 0.0222, 'lps'),
	(517050, 128, '2014-02-01 01:02:32.000000', 'consum', 0.0215, 'lps'),
	(517051, 128, '2014-02-01 01:02:33.000000', 'consum', 0.0215, 'lps'),
	(517052, 128, '2014-02-01 01:02:34.000000', 'consum', 0.0219, 'lps'),
	(517053, 128, '2014-02-01 01:02:35.000000', 'consum', 0.0215, 'lps'),
	(517054, 128, '2014-02-01 01:02:36.000000', 'consum', 0.0221, 'lps'),
	(517055, 128, '2014-02-01 01:02:37.000000', 'consum', 0.0223, 'lps'),
	(517056, 128, '2014-02-01 01:02:38.000000', 'consum', 0.0215, 'lps'),
	(517057, 128, '2014-02-01 01:02:39.000000', 'consum', 0.0212, 'lps'),
	(517058, 128, '2014-02-01 01:02:40.000000', 'consum', 0.0217, 'lps'),
	(517059, 128, '2014-02-01 01:02:41.000000', 'consum', 0.0213, 'lps'),
	(517060, 128, '2014-02-01 01:02:42.000000', 'consum', 0.0219, 'lps'),
	(517061, 128, '2014-02-01 01:02:43.000000', 'consum', 0.0216, 'lps'),
	(517062, 128, '2014-02-01 01:02:44.000000', 'consum', 0.0217, 'lps'),
	(517063, 128, '2014-02-01 01:02:45.000000', 'consum', 0.0211, 'lps'),
	(517064, 128, '2014-02-01 01:02:46.000000', 'consum', 0.0222, 'lps'),
	(517065, 128, '2014-02-01 01:02:47.000000', 'consum', 0.0212, 'lps'),
	(517066, 128, '2014-02-01 01:02:48.000000', 'consum', 0.0214, 'lps'),
	(517067, 128, '2014-02-01 01:02:49.000000', 'consum', 0.0210, 'lps'),
	(517068, 128, '2014-02-01 01:02:50.000000', 'consum', 0.0214, 'lps'),
	(517069, 128, '2014-02-01 01:02:51.000000', 'consum', 0.0213, 'lps'),
	(517070, 128, '2014-02-01 01:02:52.000000', 'consum', 0.0217, 'lps'),
	(517071, 128, '2014-02-01 01:02:53.000000', 'consum', 0.0222, 'lps'),
	(517072, 128, '2014-02-01 01:02:54.000000', 'consum', 0.0220, 'lps'),
	(517073, 128, '2014-02-01 01:02:55.000000', 'consum', 0.0211, 'lps'),
	(517074, 128, '2014-02-01 01:02:56.000000', 'consum', 0.0215, 'lps'),
	(517075, 128, '2014-02-01 01:02:57.000000', 'consum', 0.0218, 'lps'),
	(517076, 128, '2014-02-01 01:02:58.000000', 'consum', 0.0222, 'lps'),
	(517077, 128, '2014-02-01 01:02:59.000000', 'consum', 0.0220, 'lps'),
	(517078, 128, '2014-02-01 01:03:00.000000', 'consum', 0.0221, 'lps'),
	(517079, 128, '2014-02-01 01:03:01.000000', 'consum', 0.0210, 'lps'),
	(517080, 128, '2014-02-01 01:03:02.000000', 'consum', 0.0219, 'lps'),
	(517081, 128, '2014-02-01 01:03:03.000000', 'consum', 0.0213, 'lps'),
	(517082, 128, '2014-02-01 01:03:04.000000', 'consum', 0.0211, 'lps'),
	(517083, 128, '2014-02-01 01:03:05.000000', 'consum', 0.0222, 'lps'),
	(517084, 128, '2014-02-01 01:03:06.000000', 'consum', 0.0211, 'lps'),
	(517085, 128, '2014-02-01 01:03:07.000000', 'consum', 0.0221, 'lps'),
	(517086, 128, '2014-02-01 01:03:08.000000', 'consum', 0.0219, 'lps'),
	(517087, 128, '2014-02-01 01:03:09.000000', 'consum', 0.0212, 'lps'),
	(517088, 128, '2014-02-01 01:03:10.000000', 'consum', 0.0220, 'lps'),
	(517089, 128, '2014-02-01 01:03:11.000000', 'consum', 0.0212, 'lps'),
	(517090, 128, '2014-02-01 01:03:12.000000', 'consum', 0.0218, 'lps'),
	(517091, 128, '2014-02-01 01:03:13.000000', 'consum', 0.0218, 'lps'),
	(517092, 128, '2014-02-01 01:03:14.000000', 'consum', 0.0212, 'lps'),
	(517093, 128, '2014-02-01 01:03:15.000000', 'consum', 0.0210, 'lps'),
	(517094, 128, '2014-02-01 01:03:16.000000', 'consum', 0.0220, 'lps'),
	(517095, 128, '2014-02-01 01:03:17.000000', 'consum', 0.0219, 'lps'),
	(517096, 128, '2014-02-01 01:03:18.000000', 'consum', 0.0212, 'lps'),
	(517097, 128, '2014-02-01 01:03:19.000000', 'consum', 0.0222, 'lps'),
	(517098, 128, '2014-02-01 01:03:20.000000', 'consum', 0.0222, 'lps'),
	(517099, 128, '2014-02-01 01:03:21.000000', 'consum', 0.0220, 'lps'),
	(517100, 128, '2014-02-01 01:03:22.000000', 'consum', 0.0212, 'lps'),
	(517101, 128, '2014-02-01 01:03:23.000000', 'consum', 0.0219, 'lps'),
	(517102, 128, '2014-02-01 01:03:24.000000', 'consum', 0.0219, 'lps'),
	(517103, 128, '2014-02-01 01:03:25.000000', 'consum', 0.0215, 'lps'),
	(517104, 128, '2014-02-01 01:03:26.000000', 'consum', 0.0221, 'lps'),
	(517105, 128, '2014-02-01 01:03:27.000000', 'consum', 0.0211, 'lps'),
	(517106, 128, '2014-02-01 01:03:28.000000', 'consum', 0.0212, 'lps'),
	(517107, 128, '2014-02-01 01:03:29.000000', 'consum', 0.0215, 'lps'),
	(517108, 128, '2014-02-01 01:03:30.000000', 'consum', 0.0216, 'lps'),
	(517109, 128, '2014-02-01 01:03:31.000000', 'consum', 0.0212, 'lps'),
	(517110, 128, '2014-02-01 01:03:32.000000', 'consum', 0.0218, 'lps'),
	(517111, 128, '2014-02-01 01:03:33.000000', 'consum', 0.0216, 'lps'),
	(517112, 128, '2014-02-01 01:03:34.000000', 'consum', 0.0217, 'lps'),
	(517113, 128, '2014-02-01 01:03:35.000000', 'consum', 0.0212, 'lps'),
	(517114, 128, '2014-02-01 01:03:36.000000', 'consum', 0.0216, 'lps'),
	(517115, 128, '2014-02-01 01:03:37.000000', 'consum', 0.0219, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(517116, 128, '2014-02-01 01:03:38.000000', 'consum', 0.0212, 'lps'),
	(517117, 128, '2014-02-01 01:03:39.000000', 'consum', 0.0218, 'lps'),
	(517118, 128, '2014-02-01 01:03:40.000000', 'consum', 0.0220, 'lps'),
	(517119, 128, '2014-02-01 01:03:41.000000', 'consum', 0.0220, 'lps'),
	(517120, 128, '2014-02-01 01:03:42.000000', 'consum', 0.0217, 'lps'),
	(517121, 128, '2014-02-01 01:03:43.000000', 'consum', 0.0217, 'lps'),
	(517122, 128, '2014-02-01 01:03:44.000000', 'consum', 0.0223, 'lps'),
	(517123, 128, '2014-02-01 01:03:45.000000', 'consum', 0.0214, 'lps'),
	(517124, 128, '2014-02-01 01:03:46.000000', 'consum', 0.0217, 'lps'),
	(517125, 128, '2014-02-01 01:03:47.000000', 'consum', 0.0221, 'lps'),
	(517126, 128, '2014-02-01 01:03:48.000000', 'consum', 0.0218, 'lps'),
	(517127, 128, '2014-02-01 01:03:49.000000', 'consum', 0.0218, 'lps'),
	(517128, 128, '2014-02-01 01:03:50.000000', 'consum', 0.0223, 'lps'),
	(517129, 128, '2014-02-01 01:03:51.000000', 'consum', 0.0213, 'lps'),
	(517130, 128, '2014-02-01 01:03:52.000000', 'consum', 0.0213, 'lps'),
	(517131, 128, '2014-02-01 01:03:53.000000', 'consum', 0.0216, 'lps'),
	(517132, 128, '2014-02-01 01:03:54.000000', 'consum', 0.0218, 'lps'),
	(517133, 128, '2014-02-01 01:03:55.000000', 'consum', 0.0217, 'lps'),
	(517134, 128, '2014-02-01 01:03:56.000000', 'consum', 0.0221, 'lps'),
	(517135, 128, '2014-02-01 01:03:57.000000', 'consum', 0.0219, 'lps'),
	(517136, 128, '2014-02-01 01:03:58.000000', 'consum', 0.0221, 'lps'),
	(517137, 128, '2014-02-01 01:03:59.000000', 'consum', 0.0211, 'lps'),
	(517138, 128, '2014-02-01 01:04:00.000000', 'consum', 0.0212, 'lps'),
	(517139, 128, '2014-02-01 01:04:01.000000', 'consum', 0.0216, 'lps'),
	(517140, 128, '2014-02-01 01:04:02.000000', 'consum', 0.0220, 'lps'),
	(517141, 128, '2014-02-01 01:04:03.000000', 'consum', 0.0217, 'lps'),
	(517142, 128, '2014-02-01 01:04:04.000000', 'consum', 0.0214, 'lps'),
	(517143, 128, '2014-02-01 01:04:05.000000', 'consum', 0.0210, 'lps'),
	(517144, 128, '2014-02-01 01:04:06.000000', 'consum', 0.0213, 'lps'),
	(517145, 128, '2014-02-01 01:04:07.000000', 'consum', 0.0223, 'lps'),
	(517146, 128, '2014-02-01 01:04:08.000000', 'consum', 0.0212, 'lps'),
	(517147, 128, '2014-02-01 01:04:09.000000', 'consum', 0.0211, 'lps'),
	(517148, 128, '2014-02-01 01:04:10.000000', 'consum', 0.0222, 'lps'),
	(517149, 128, '2014-02-01 01:04:11.000000', 'consum', 0.0213, 'lps'),
	(517150, 128, '2014-02-01 01:04:12.000000', 'consum', 0.0216, 'lps'),
	(517151, 128, '2014-02-01 01:04:13.000000', 'consum', 0.0218, 'lps'),
	(517152, 128, '2014-02-01 01:04:14.000000', 'consum', 0.0220, 'lps'),
	(517153, 128, '2014-02-01 01:04:15.000000', 'consum', 0.0220, 'lps'),
	(517154, 128, '2014-02-01 01:04:16.000000', 'consum', 0.0217, 'lps'),
	(517155, 128, '2014-02-01 01:04:17.000000', 'consum', 0.0215, 'lps'),
	(517156, 128, '2014-02-01 01:04:18.000000', 'consum', 0.0217, 'lps'),
	(517157, 128, '2014-02-01 01:04:19.000000', 'consum', 0.0216, 'lps'),
	(517158, 128, '2014-02-01 01:04:20.000000', 'consum', 0.0218, 'lps'),
	(517159, 128, '2014-02-01 01:04:21.000000', 'consum', 0.0217, 'lps'),
	(517160, 128, '2014-02-01 01:04:22.000000', 'consum', 0.0211, 'lps'),
	(517161, 128, '2014-02-01 01:04:23.000000', 'consum', 0.0220, 'lps'),
	(517162, 128, '2014-02-01 01:04:24.000000', 'consum', 0.0216, 'lps'),
	(517163, 128, '2014-02-01 01:04:25.000000', 'consum', 0.0210, 'lps'),
	(517164, 128, '2014-02-01 01:04:26.000000', 'consum', 0.0222, 'lps'),
	(517165, 128, '2014-02-01 01:04:27.000000', 'consum', 0.0215, 'lps'),
	(517166, 128, '2014-02-01 01:04:28.000000', 'consum', 0.0215, 'lps'),
	(517167, 128, '2014-02-01 01:04:29.000000', 'consum', 0.0217, 'lps'),
	(517168, 128, '2014-02-01 01:04:30.000000', 'consum', 0.0220, 'lps'),
	(517169, 128, '2014-02-01 01:04:31.000000', 'consum', 0.0223, 'lps'),
	(517170, 128, '2014-02-01 01:04:32.000000', 'consum', 0.0217, 'lps'),
	(517171, 128, '2014-02-01 01:04:33.000000', 'consum', 0.0219, 'lps'),
	(517172, 128, '2014-02-01 01:04:34.000000', 'consum', 0.0210, 'lps'),
	(517173, 128, '2014-02-01 01:04:35.000000', 'consum', 0.0223, 'lps'),
	(517174, 128, '2014-02-01 01:04:36.000000', 'consum', 0.0222, 'lps'),
	(517175, 128, '2014-02-01 01:04:37.000000', 'consum', 0.0215, 'lps'),
	(517176, 128, '2014-02-01 01:04:38.000000', 'consum', 0.0216, 'lps'),
	(517177, 128, '2014-02-01 01:04:39.000000', 'consum', 0.0223, 'lps'),
	(517178, 128, '2014-02-01 01:04:40.000000', 'consum', 0.0218, 'lps'),
	(517179, 128, '2014-02-01 01:04:41.000000', 'consum', 0.0212, 'lps'),
	(517180, 128, '2014-02-01 01:04:42.000000', 'consum', 0.0210, 'lps'),
	(517181, 128, '2014-02-01 01:04:43.000000', 'consum', 0.0219, 'lps'),
	(517182, 128, '2014-02-01 01:04:44.000000', 'consum', 0.0213, 'lps'),
	(517183, 128, '2014-02-01 01:04:45.000000', 'consum', 0.0211, 'lps'),
	(517184, 128, '2014-02-01 01:04:46.000000', 'consum', 0.0220, 'lps'),
	(517185, 128, '2014-02-01 01:04:47.000000', 'consum', 0.0218, 'lps'),
	(517186, 128, '2014-02-01 01:04:48.000000', 'consum', 0.0220, 'lps'),
	(517187, 128, '2014-02-01 01:04:49.000000', 'consum', 0.0221, 'lps'),
	(517188, 128, '2014-02-01 01:04:50.000000', 'consum', 0.0221, 'lps'),
	(517189, 128, '2014-02-01 01:04:51.000000', 'consum', 0.0218, 'lps'),
	(517190, 128, '2014-02-01 01:04:52.000000', 'consum', 0.0219, 'lps'),
	(517191, 128, '2014-02-01 01:04:53.000000', 'consum', 0.0219, 'lps'),
	(517192, 128, '2014-02-01 01:04:54.000000', 'consum', 0.0214, 'lps'),
	(517193, 128, '2014-02-01 01:04:55.000000', 'consum', 0.0215, 'lps'),
	(517194, 128, '2014-02-01 01:04:56.000000', 'consum', 0.0212, 'lps'),
	(517195, 128, '2014-02-01 01:04:57.000000', 'consum', 0.0219, 'lps'),
	(517196, 128, '2014-02-01 01:04:58.000000', 'consum', 0.0222, 'lps'),
	(517197, 128, '2014-02-01 01:04:59.000000', 'consum', 0.0215, 'lps'),
	(517198, 128, '2014-02-01 01:05:00.000000', 'consum', 0.0215, 'lps'),
	(517199, 128, '2014-02-01 01:05:01.000000', 'consum', 0.0218, 'lps'),
	(517200, 128, '2014-02-01 01:05:02.000000', 'consum', 0.0210, 'lps'),
	(517201, 128, '2014-02-01 01:05:03.000000', 'consum', 0.0215, 'lps'),
	(517202, 128, '2014-02-01 01:05:04.000000', 'consum', 0.0219, 'lps'),
	(517203, 128, '2014-02-01 01:05:05.000000', 'consum', 0.0213, 'lps'),
	(517204, 128, '2014-02-01 01:05:06.000000', 'consum', 0.0213, 'lps'),
	(517205, 128, '2014-02-01 01:05:07.000000', 'consum', 0.0215, 'lps'),
	(517206, 128, '2014-02-01 01:05:08.000000', 'consum', 0.0213, 'lps'),
	(517207, 128, '2014-02-01 01:05:09.000000', 'consum', 0.0211, 'lps'),
	(517208, 128, '2014-02-01 01:05:10.000000', 'consum', 0.0221, 'lps'),
	(517209, 128, '2014-02-01 01:05:11.000000', 'consum', 0.0220, 'lps'),
	(517210, 128, '2014-02-01 01:05:12.000000', 'consum', 0.0212, 'lps'),
	(517211, 128, '2014-02-01 01:05:13.000000', 'consum', 0.0218, 'lps'),
	(517212, 128, '2014-02-01 01:05:14.000000', 'consum', 0.0216, 'lps'),
	(517213, 128, '2014-02-01 01:05:15.000000', 'consum', 0.0217, 'lps'),
	(517214, 128, '2014-02-01 01:05:16.000000', 'consum', 0.0216, 'lps'),
	(517215, 128, '2014-02-01 01:05:17.000000', 'consum', 0.0216, 'lps'),
	(517216, 128, '2014-02-01 01:05:18.000000', 'consum', 0.0211, 'lps'),
	(517217, 128, '2014-02-01 01:05:19.000000', 'consum', 0.0212, 'lps'),
	(517218, 128, '2014-02-01 01:05:20.000000', 'consum', 0.0215, 'lps'),
	(517219, 128, '2014-02-01 01:05:21.000000', 'consum', 0.0217, 'lps'),
	(517220, 128, '2014-02-01 01:05:22.000000', 'consum', 0.0215, 'lps'),
	(517221, 128, '2014-02-01 01:05:23.000000', 'consum', 0.0214, 'lps'),
	(517222, 128, '2014-02-01 01:05:24.000000', 'consum', 0.0216, 'lps'),
	(517223, 128, '2014-02-01 01:05:25.000000', 'consum', 0.0214, 'lps'),
	(517224, 128, '2014-02-01 01:05:26.000000', 'consum', 0.0214, 'lps'),
	(517225, 128, '2014-02-01 01:05:27.000000', 'consum', 0.0218, 'lps'),
	(517226, 128, '2014-02-01 01:05:28.000000', 'consum', 0.0212, 'lps'),
	(517227, 128, '2014-02-01 01:05:29.000000', 'consum', 0.0210, 'lps'),
	(517228, 128, '2014-02-01 01:05:30.000000', 'consum', 0.0216, 'lps'),
	(517229, 128, '2014-02-01 01:05:31.000000', 'consum', 0.0214, 'lps'),
	(517230, 128, '2014-02-01 01:05:32.000000', 'consum', 0.0214, 'lps'),
	(517231, 128, '2014-02-01 01:05:33.000000', 'consum', 0.0218, 'lps'),
	(517232, 128, '2014-02-01 01:05:34.000000', 'consum', 0.0210, 'lps'),
	(517233, 128, '2014-02-01 01:05:35.000000', 'consum', 0.0215, 'lps'),
	(517234, 128, '2014-02-01 01:05:36.000000', 'consum', 0.0220, 'lps'),
	(517235, 128, '2014-02-01 01:05:37.000000', 'consum', 0.0220, 'lps'),
	(517236, 128, '2014-02-01 01:05:38.000000', 'consum', 0.0214, 'lps'),
	(517237, 128, '2014-02-01 01:05:39.000000', 'consum', 0.0215, 'lps'),
	(517238, 128, '2014-02-01 01:05:40.000000', 'consum', 0.0211, 'lps'),
	(517239, 128, '2014-02-01 01:05:41.000000', 'consum', 0.0215, 'lps'),
	(517240, 128, '2014-02-01 01:05:42.000000', 'consum', 0.0219, 'lps'),
	(517241, 128, '2014-02-01 01:05:43.000000', 'consum', 0.0212, 'lps'),
	(517242, 128, '2014-02-01 01:05:44.000000', 'consum', 0.0223, 'lps'),
	(517243, 128, '2014-02-01 01:05:45.000000', 'consum', 0.0213, 'lps'),
	(517244, 128, '2014-02-01 01:05:46.000000', 'consum', 0.0215, 'lps'),
	(517245, 128, '2014-02-01 01:05:47.000000', 'consum', 0.0214, 'lps'),
	(517246, 128, '2014-02-01 01:05:48.000000', 'consum', 0.0213, 'lps'),
	(517247, 128, '2014-02-01 01:05:49.000000', 'consum', 0.0213, 'lps'),
	(517248, 128, '2014-02-01 01:05:50.000000', 'consum', 0.0217, 'lps'),
	(517249, 128, '2014-02-01 01:05:51.000000', 'consum', 0.0221, 'lps'),
	(517250, 128, '2014-02-01 01:05:52.000000', 'consum', 0.0217, 'lps'),
	(517251, 128, '2014-02-01 01:05:53.000000', 'consum', 0.0211, 'lps'),
	(517252, 128, '2014-02-01 01:05:54.000000', 'consum', 0.0210, 'lps'),
	(517253, 128, '2014-02-01 01:05:55.000000', 'consum', 0.0223, 'lps'),
	(517254, 128, '2014-02-01 01:05:56.000000', 'consum', 0.0217, 'lps'),
	(517255, 128, '2014-02-01 01:05:57.000000', 'consum', 0.0220, 'lps'),
	(517256, 128, '2014-02-01 01:05:58.000000', 'consum', 0.0212, 'lps'),
	(517257, 128, '2014-02-01 01:05:59.000000', 'consum', 0.0219, 'lps'),
	(517258, 128, '2014-02-01 01:06:00.000000', 'consum', 0.0223, 'lps'),
	(517259, 128, '2014-02-01 01:06:01.000000', 'consum', 0.0218, 'lps'),
	(517260, 128, '2014-02-01 01:06:02.000000', 'consum', 0.0214, 'lps'),
	(517261, 128, '2014-02-01 01:06:03.000000', 'consum', 0.0219, 'lps'),
	(517262, 128, '2014-02-01 01:06:04.000000', 'consum', 0.0214, 'lps'),
	(517263, 128, '2014-02-01 01:06:05.000000', 'consum', 0.0220, 'lps'),
	(517264, 128, '2014-02-01 01:06:06.000000', 'consum', 0.0219, 'lps'),
	(517265, 128, '2014-02-01 01:06:07.000000', 'consum', 0.0211, 'lps'),
	(517266, 128, '2014-02-01 01:06:08.000000', 'consum', 0.0217, 'lps'),
	(517267, 128, '2014-02-01 01:06:09.000000', 'consum', 0.0216, 'lps'),
	(517268, 128, '2014-02-01 01:06:10.000000', 'consum', 0.0218, 'lps'),
	(517269, 128, '2014-02-01 01:06:11.000000', 'consum', 0.0220, 'lps'),
	(517270, 128, '2014-02-01 01:06:12.000000', 'consum', 0.0223, 'lps'),
	(517271, 128, '2014-02-01 01:06:13.000000', 'consum', 0.0215, 'lps'),
	(517272, 128, '2014-02-01 01:06:14.000000', 'consum', 0.0211, 'lps'),
	(517273, 128, '2014-02-01 01:06:15.000000', 'consum', 0.0216, 'lps'),
	(517274, 128, '2014-02-01 01:06:16.000000', 'consum', 0.0223, 'lps'),
	(517275, 128, '2014-02-01 01:06:17.000000', 'consum', 0.0216, 'lps'),
	(517276, 128, '2014-02-01 01:06:18.000000', 'consum', 0.0213, 'lps'),
	(517277, 128, '2014-02-01 01:06:19.000000', 'consum', 0.0210, 'lps'),
	(517278, 128, '2014-02-01 01:06:20.000000', 'consum', 0.0213, 'lps'),
	(517279, 128, '2014-02-01 01:06:21.000000', 'consum', 0.0212, 'lps'),
	(517280, 128, '2014-02-01 01:06:22.000000', 'consum', 0.0214, 'lps'),
	(517281, 128, '2014-02-01 01:06:23.000000', 'consum', 0.0222, 'lps'),
	(517282, 128, '2014-02-01 01:06:24.000000', 'consum', 0.0216, 'lps'),
	(517283, 128, '2014-02-01 01:06:25.000000', 'consum', 0.0217, 'lps'),
	(517284, 128, '2014-02-01 01:06:26.000000', 'consum', 0.0216, 'lps'),
	(517285, 128, '2014-02-01 01:06:27.000000', 'consum', 0.0221, 'lps'),
	(517286, 128, '2014-02-01 01:06:28.000000', 'consum', 0.0216, 'lps'),
	(517287, 128, '2014-02-01 01:06:29.000000', 'consum', 0.0223, 'lps'),
	(517288, 128, '2014-02-01 01:06:30.000000', 'consum', 0.0217, 'lps'),
	(517289, 128, '2014-02-01 01:06:31.000000', 'consum', 0.0218, 'lps'),
	(517290, 128, '2014-02-01 01:06:32.000000', 'consum', 0.0218, 'lps'),
	(517291, 128, '2014-02-01 01:06:33.000000', 'consum', 0.0212, 'lps'),
	(517292, 128, '2014-02-01 01:06:34.000000', 'consum', 0.0223, 'lps'),
	(517293, 128, '2014-02-01 01:06:35.000000', 'consum', 0.0214, 'lps'),
	(517294, 128, '2014-02-01 01:06:36.000000', 'consum', 0.0220, 'lps'),
	(517295, 128, '2014-02-01 01:06:37.000000', 'consum', 0.0222, 'lps'),
	(517296, 128, '2014-02-01 01:06:38.000000', 'consum', 0.0210, 'lps'),
	(517297, 128, '2014-02-01 01:06:39.000000', 'consum', 0.0219, 'lps'),
	(517298, 128, '2014-02-01 01:06:40.000000', 'consum', 0.0212, 'lps'),
	(517299, 128, '2014-02-01 01:06:41.000000', 'consum', 0.0222, 'lps'),
	(517300, 128, '2014-02-01 01:06:42.000000', 'consum', 0.0221, 'lps'),
	(517301, 128, '2014-02-01 01:06:43.000000', 'consum', 0.0215, 'lps'),
	(517302, 128, '2014-02-01 01:06:44.000000', 'consum', 0.0216, 'lps'),
	(517303, 128, '2014-02-01 01:06:45.000000', 'consum', 0.0212, 'lps'),
	(517304, 128, '2014-02-01 01:06:46.000000', 'consum', 0.0218, 'lps'),
	(517305, 128, '2014-02-01 01:06:47.000000', 'consum', 0.0216, 'lps'),
	(517306, 128, '2014-02-01 01:06:48.000000', 'consum', 0.0218, 'lps'),
	(517307, 128, '2014-02-01 01:06:49.000000', 'consum', 0.0219, 'lps'),
	(517308, 128, '2014-02-01 01:06:50.000000', 'consum', 0.0215, 'lps'),
	(517309, 128, '2014-02-01 01:06:51.000000', 'consum', 0.0223, 'lps'),
	(517310, 128, '2014-02-01 01:06:52.000000', 'consum', 0.0217, 'lps'),
	(517311, 128, '2014-02-01 01:06:53.000000', 'consum', 0.0222, 'lps'),
	(517312, 128, '2014-02-01 01:06:54.000000', 'consum', 0.0222, 'lps'),
	(517313, 128, '2014-02-01 01:06:55.000000', 'consum', 0.0222, 'lps'),
	(517314, 128, '2014-02-01 01:06:56.000000', 'consum', 0.0219, 'lps'),
	(517315, 128, '2014-02-01 01:06:57.000000', 'consum', 0.0221, 'lps'),
	(517316, 128, '2014-02-01 01:06:58.000000', 'consum', 0.0222, 'lps'),
	(517317, 128, '2014-02-01 01:06:59.000000', 'consum', 0.0223, 'lps'),
	(517318, 128, '2014-02-01 01:07:00.000000', 'consum', 0.0212, 'lps'),
	(517319, 128, '2014-02-01 01:07:01.000000', 'consum', 0.0223, 'lps'),
	(517320, 128, '2014-02-01 01:07:02.000000', 'consum', 0.0215, 'lps'),
	(517321, 128, '2014-02-01 01:07:03.000000', 'consum', 0.0222, 'lps'),
	(517322, 128, '2014-02-01 01:07:04.000000', 'consum', 0.0216, 'lps'),
	(517323, 128, '2014-02-01 01:07:05.000000', 'consum', 0.0218, 'lps'),
	(517324, 128, '2014-02-01 01:07:06.000000', 'consum', 0.0218, 'lps'),
	(517325, 128, '2014-02-01 01:07:07.000000', 'consum', 0.0212, 'lps'),
	(517326, 128, '2014-02-01 01:07:08.000000', 'consum', 0.0210, 'lps'),
	(517327, 128, '2014-02-01 01:07:09.000000', 'consum', 0.0220, 'lps'),
	(517328, 128, '2014-02-01 01:07:10.000000', 'consum', 0.0216, 'lps'),
	(517329, 128, '2014-02-01 01:07:11.000000', 'consum', 0.0211, 'lps'),
	(517330, 128, '2014-02-01 01:07:12.000000', 'consum', 0.0213, 'lps'),
	(517331, 128, '2014-02-01 01:07:13.000000', 'consum', 0.0223, 'lps'),
	(517332, 128, '2014-02-01 01:07:14.000000', 'consum', 0.0222, 'lps'),
	(517333, 128, '2014-02-01 01:07:15.000000', 'consum', 0.0219, 'lps'),
	(517334, 128, '2014-02-01 01:07:16.000000', 'consum', 0.0217, 'lps'),
	(517335, 128, '2014-02-01 01:07:17.000000', 'consum', 0.0221, 'lps'),
	(517336, 128, '2014-02-01 01:07:18.000000', 'consum', 0.0216, 'lps'),
	(517337, 128, '2014-02-01 01:07:19.000000', 'consum', 0.0223, 'lps'),
	(517338, 128, '2014-02-01 01:07:20.000000', 'consum', 0.0215, 'lps'),
	(517339, 128, '2014-02-01 01:07:21.000000', 'consum', 0.0223, 'lps'),
	(517340, 128, '2014-02-01 01:07:22.000000', 'consum', 0.0218, 'lps'),
	(517341, 128, '2014-02-01 01:07:23.000000', 'consum', 0.0212, 'lps'),
	(517342, 128, '2014-02-01 01:07:24.000000', 'consum', 0.0223, 'lps'),
	(517343, 128, '2014-02-01 01:07:25.000000', 'consum', 0.0216, 'lps'),
	(517344, 128, '2014-02-01 01:07:26.000000', 'consum', 0.0214, 'lps'),
	(517345, 128, '2014-02-01 01:07:27.000000', 'consum', 0.0211, 'lps'),
	(517346, 128, '2014-02-01 01:07:28.000000', 'consum', 0.0220, 'lps'),
	(517347, 128, '2014-02-01 01:07:29.000000', 'consum', 0.0216, 'lps'),
	(517348, 128, '2014-02-01 01:07:30.000000', 'consum', 0.0211, 'lps'),
	(517349, 128, '2014-02-01 01:07:31.000000', 'consum', 0.0210, 'lps'),
	(517350, 128, '2014-02-01 01:07:32.000000', 'consum', 0.0223, 'lps'),
	(517351, 128, '2014-02-01 01:07:33.000000', 'consum', 0.0220, 'lps'),
	(517352, 128, '2014-02-01 01:07:34.000000', 'consum', 0.0219, 'lps'),
	(517353, 128, '2014-02-01 01:07:35.000000', 'consum', 0.0213, 'lps'),
	(517354, 128, '2014-02-01 01:07:36.000000', 'consum', 0.0210, 'lps'),
	(517355, 128, '2014-02-01 01:07:37.000000', 'consum', 0.0218, 'lps'),
	(517356, 128, '2014-02-01 01:07:38.000000', 'consum', 0.0223, 'lps'),
	(517357, 128, '2014-02-01 01:07:39.000000', 'consum', 0.0222, 'lps'),
	(517358, 128, '2014-02-01 01:07:40.000000', 'consum', 0.0218, 'lps'),
	(517359, 128, '2014-02-01 01:07:41.000000', 'consum', 0.0213, 'lps'),
	(517360, 128, '2014-02-01 01:07:42.000000', 'consum', 0.0218, 'lps'),
	(517361, 128, '2014-02-01 01:07:43.000000', 'consum', 0.0213, 'lps'),
	(517362, 128, '2014-02-01 01:07:44.000000', 'consum', 0.0214, 'lps'),
	(517363, 128, '2014-02-01 01:07:45.000000', 'consum', 0.0223, 'lps'),
	(517364, 128, '2014-02-01 01:07:46.000000', 'consum', 0.0221, 'lps'),
	(517365, 128, '2014-02-01 01:07:47.000000', 'consum', 0.0214, 'lps'),
	(517366, 128, '2014-02-01 01:07:48.000000', 'consum', 0.0223, 'lps'),
	(517367, 128, '2014-02-01 01:07:49.000000', 'consum', 0.0222, 'lps'),
	(517368, 128, '2014-02-01 01:07:50.000000', 'consum', 0.0217, 'lps'),
	(517369, 128, '2014-02-01 01:07:51.000000', 'consum', 0.0211, 'lps'),
	(517370, 128, '2014-02-01 01:07:52.000000', 'consum', 0.0222, 'lps'),
	(517371, 128, '2014-02-01 01:07:53.000000', 'consum', 0.0213, 'lps'),
	(517372, 128, '2014-02-01 01:07:54.000000', 'consum', 0.0218, 'lps'),
	(517373, 128, '2014-02-01 01:07:55.000000', 'consum', 0.0213, 'lps'),
	(517374, 128, '2014-02-01 01:07:56.000000', 'consum', 0.0216, 'lps'),
	(517375, 128, '2014-02-01 01:07:57.000000', 'consum', 0.0216, 'lps'),
	(517376, 128, '2014-02-01 01:07:58.000000', 'consum', 0.0222, 'lps'),
	(517377, 128, '2014-02-01 01:07:59.000000', 'consum', 0.0212, 'lps'),
	(517378, 128, '2014-02-01 01:08:00.000000', 'consum', 0.0214, 'lps'),
	(517379, 128, '2014-02-01 01:08:01.000000', 'consum', 0.0222, 'lps'),
	(517380, 128, '2014-02-01 01:08:02.000000', 'consum', 0.0218, 'lps'),
	(517381, 128, '2014-02-01 01:08:03.000000', 'consum', 0.0212, 'lps'),
	(517382, 128, '2014-02-01 01:08:04.000000', 'consum', 0.0213, 'lps'),
	(517383, 128, '2014-02-01 01:08:05.000000', 'consum', 0.0219, 'lps'),
	(517384, 128, '2014-02-01 01:08:06.000000', 'consum', 0.0218, 'lps'),
	(517385, 128, '2014-02-01 01:08:07.000000', 'consum', 0.0222, 'lps'),
	(517386, 128, '2014-02-01 01:08:08.000000', 'consum', 0.0220, 'lps'),
	(517387, 128, '2014-02-01 01:08:09.000000', 'consum', 0.0210, 'lps'),
	(517388, 128, '2014-02-01 01:08:10.000000', 'consum', 0.0210, 'lps'),
	(517389, 128, '2014-02-01 01:08:11.000000', 'consum', 0.0211, 'lps'),
	(517390, 128, '2014-02-01 01:08:12.000000', 'consum', 0.0213, 'lps'),
	(517391, 128, '2014-02-01 01:08:13.000000', 'consum', 0.0222, 'lps'),
	(517392, 128, '2014-02-01 01:08:14.000000', 'consum', 0.0222, 'lps'),
	(517393, 128, '2014-02-01 01:08:15.000000', 'consum', 0.0221, 'lps'),
	(517394, 128, '2014-02-01 01:08:16.000000', 'consum', 0.0213, 'lps'),
	(517395, 128, '2014-02-01 01:08:17.000000', 'consum', 0.0220, 'lps'),
	(517396, 128, '2014-02-01 01:08:18.000000', 'consum', 0.0212, 'lps'),
	(517397, 128, '2014-02-01 01:08:19.000000', 'consum', 0.0219, 'lps'),
	(517398, 128, '2014-02-01 01:08:20.000000', 'consum', 0.0220, 'lps'),
	(517399, 128, '2014-02-01 01:08:21.000000', 'consum', 0.0218, 'lps'),
	(517400, 128, '2014-02-01 01:08:22.000000', 'consum', 0.0210, 'lps'),
	(517401, 128, '2014-02-01 01:08:23.000000', 'consum', 0.0212, 'lps'),
	(517402, 128, '2014-02-01 01:08:24.000000', 'consum', 0.0220, 'lps'),
	(517403, 128, '2014-02-01 01:08:25.000000', 'consum', 0.0214, 'lps'),
	(517404, 128, '2014-02-01 01:08:26.000000', 'consum', 0.0214, 'lps'),
	(517405, 128, '2014-02-01 01:08:27.000000', 'consum', 0.0217, 'lps'),
	(517406, 128, '2014-02-01 01:08:28.000000', 'consum', 0.0221, 'lps'),
	(517407, 128, '2014-02-01 01:08:29.000000', 'consum', 0.0217, 'lps'),
	(517408, 128, '2014-02-01 01:08:30.000000', 'consum', 0.0211, 'lps'),
	(517409, 128, '2014-02-01 01:08:31.000000', 'consum', 0.0222, 'lps'),
	(517410, 128, '2014-02-01 01:08:32.000000', 'consum', 0.0211, 'lps'),
	(517411, 128, '2014-02-01 01:08:33.000000', 'consum', 0.0222, 'lps'),
	(517412, 128, '2014-02-01 01:08:34.000000', 'consum', 0.0213, 'lps'),
	(517413, 128, '2014-02-01 01:08:35.000000', 'consum', 0.0218, 'lps'),
	(517414, 128, '2014-02-01 01:08:36.000000', 'consum', 0.0213, 'lps'),
	(517415, 128, '2014-02-01 01:08:37.000000', 'consum', 0.0217, 'lps'),
	(517416, 128, '2014-02-01 01:08:38.000000', 'consum', 0.0220, 'lps'),
	(517417, 128, '2014-02-01 01:08:39.000000', 'consum', 0.0211, 'lps'),
	(517418, 128, '2014-02-01 01:08:40.000000', 'consum', 0.0216, 'lps'),
	(517419, 128, '2014-02-01 01:08:41.000000', 'consum', 0.0223, 'lps'),
	(517420, 128, '2014-02-01 01:08:42.000000', 'consum', 0.0214, 'lps'),
	(517421, 128, '2014-02-01 01:08:43.000000', 'consum', 0.0219, 'lps'),
	(517422, 128, '2014-02-01 01:08:44.000000', 'consum', 0.0217, 'lps'),
	(517423, 128, '2014-02-01 01:08:45.000000', 'consum', 0.0219, 'lps'),
	(517424, 128, '2014-02-01 01:08:46.000000', 'consum', 0.0221, 'lps'),
	(517425, 128, '2014-02-01 01:08:47.000000', 'consum', 0.0223, 'lps'),
	(517426, 128, '2014-02-01 01:08:48.000000', 'consum', 0.0215, 'lps'),
	(517427, 128, '2014-02-01 01:08:49.000000', 'consum', 0.0223, 'lps'),
	(517428, 128, '2014-02-01 01:08:50.000000', 'consum', 0.0222, 'lps'),
	(517429, 128, '2014-02-01 01:08:51.000000', 'consum', 0.0214, 'lps'),
	(517430, 128, '2014-02-01 01:08:52.000000', 'consum', 0.0222, 'lps'),
	(517431, 128, '2014-02-01 01:08:53.000000', 'consum', 0.0219, 'lps'),
	(517432, 128, '2014-02-01 01:08:54.000000', 'consum', 0.0219, 'lps'),
	(517433, 128, '2014-02-01 01:08:55.000000', 'consum', 0.0215, 'lps'),
	(517434, 128, '2014-02-01 01:08:56.000000', 'consum', 0.0221, 'lps'),
	(517435, 128, '2014-02-01 01:08:57.000000', 'consum', 0.0222, 'lps'),
	(517436, 128, '2014-02-01 01:08:58.000000', 'consum', 0.0210, 'lps'),
	(517437, 128, '2014-02-01 01:08:59.000000', 'consum', 0.0217, 'lps'),
	(517438, 128, '2014-02-01 01:09:00.000000', 'consum', 0.0217, 'lps'),
	(517439, 128, '2014-02-01 01:09:01.000000', 'consum', 0.0223, 'lps'),
	(517440, 128, '2014-02-01 01:09:02.000000', 'consum', 0.0216, 'lps'),
	(517441, 128, '2014-02-01 01:09:03.000000', 'consum', 0.0212, 'lps'),
	(517442, 128, '2014-02-01 01:09:04.000000', 'consum', 0.0218, 'lps'),
	(517443, 128, '2014-02-01 01:09:05.000000', 'consum', 0.0215, 'lps'),
	(517444, 128, '2014-02-01 01:09:06.000000', 'consum', 0.0212, 'lps'),
	(517445, 128, '2014-02-01 01:09:07.000000', 'consum', 0.0219, 'lps'),
	(517446, 128, '2014-02-01 01:09:08.000000', 'consum', 0.0223, 'lps'),
	(517447, 128, '2014-02-01 01:09:09.000000', 'consum', 0.0221, 'lps'),
	(517448, 128, '2014-02-01 01:09:10.000000', 'consum', 0.0213, 'lps'),
	(517449, 128, '2014-02-01 01:09:11.000000', 'consum', 0.0219, 'lps'),
	(517450, 128, '2014-02-01 01:09:12.000000', 'consum', 0.0218, 'lps'),
	(517451, 128, '2014-02-01 01:09:13.000000', 'consum', 0.0223, 'lps'),
	(517452, 128, '2014-02-01 01:09:14.000000', 'consum', 0.0223, 'lps'),
	(517453, 128, '2014-02-01 01:09:15.000000', 'consum', 0.0223, 'lps'),
	(517454, 128, '2014-02-01 01:09:16.000000', 'consum', 0.0221, 'lps'),
	(517455, 128, '2014-02-01 01:09:17.000000', 'consum', 0.0215, 'lps'),
	(517456, 128, '2014-02-01 01:09:18.000000', 'consum', 0.0217, 'lps'),
	(517457, 128, '2014-02-01 01:09:19.000000', 'consum', 0.0214, 'lps'),
	(517458, 128, '2014-02-01 01:09:20.000000', 'consum', 0.0211, 'lps'),
	(517459, 128, '2014-02-01 01:09:21.000000', 'consum', 0.0215, 'lps'),
	(517460, 128, '2014-02-01 01:09:22.000000', 'consum', 0.0221, 'lps'),
	(517461, 128, '2014-02-01 01:09:23.000000', 'consum', 0.0222, 'lps'),
	(517462, 128, '2014-02-01 01:09:24.000000', 'consum', 0.0222, 'lps'),
	(517463, 128, '2014-02-01 01:09:25.000000', 'consum', 0.0221, 'lps'),
	(517464, 128, '2014-02-01 01:09:26.000000', 'consum', 0.0214, 'lps'),
	(517465, 128, '2014-02-01 01:09:27.000000', 'consum', 0.0214, 'lps'),
	(517466, 128, '2014-02-01 01:09:28.000000', 'consum', 0.0216, 'lps'),
	(517467, 128, '2014-02-01 01:09:29.000000', 'consum', 0.0214, 'lps'),
	(517468, 128, '2014-02-01 01:09:30.000000', 'consum', 0.0215, 'lps'),
	(517469, 128, '2014-02-01 01:09:31.000000', 'consum', 0.0223, 'lps'),
	(517470, 128, '2014-02-01 01:09:32.000000', 'consum', 0.0219, 'lps'),
	(517471, 128, '2014-02-01 01:09:33.000000', 'consum', 0.0218, 'lps'),
	(517472, 128, '2014-02-01 01:09:34.000000', 'consum', 0.0222, 'lps'),
	(517473, 128, '2014-02-01 01:09:35.000000', 'consum', 0.0220, 'lps'),
	(517474, 128, '2014-02-01 01:09:36.000000', 'consum', 0.0210, 'lps'),
	(517475, 128, '2014-02-01 01:09:37.000000', 'consum', 0.0223, 'lps'),
	(517476, 128, '2014-02-01 01:09:38.000000', 'consum', 0.0221, 'lps'),
	(517477, 128, '2014-02-01 01:09:39.000000', 'consum', 0.0211, 'lps'),
	(517478, 128, '2014-02-01 01:09:40.000000', 'consum', 0.0223, 'lps'),
	(517479, 128, '2014-02-01 01:09:41.000000', 'consum', 0.0217, 'lps'),
	(517480, 128, '2014-02-01 01:09:42.000000', 'consum', 0.0223, 'lps'),
	(517481, 128, '2014-02-01 01:09:43.000000', 'consum', 0.0211, 'lps'),
	(517482, 128, '2014-02-01 01:09:44.000000', 'consum', 0.0219, 'lps'),
	(517483, 128, '2014-02-01 01:09:45.000000', 'consum', 0.0222, 'lps'),
	(517484, 128, '2014-02-01 01:09:46.000000', 'consum', 0.0218, 'lps'),
	(517485, 128, '2014-02-01 01:09:47.000000', 'consum', 0.0214, 'lps'),
	(517486, 128, '2014-02-01 01:09:48.000000', 'consum', 0.0221, 'lps'),
	(517487, 128, '2014-02-01 01:09:49.000000', 'consum', 0.0210, 'lps'),
	(517488, 128, '2014-02-01 01:09:50.000000', 'consum', 0.0221, 'lps'),
	(517489, 128, '2014-02-01 01:09:51.000000', 'consum', 0.0223, 'lps'),
	(517490, 128, '2014-02-01 01:09:52.000000', 'consum', 0.0216, 'lps'),
	(517491, 128, '2014-02-01 01:09:53.000000', 'consum', 0.0215, 'lps'),
	(517492, 128, '2014-02-01 01:09:54.000000', 'consum', 0.0216, 'lps'),
	(517493, 128, '2014-02-01 01:09:55.000000', 'consum', 0.0214, 'lps'),
	(517494, 128, '2014-02-01 01:09:56.000000', 'consum', 0.0212, 'lps'),
	(517495, 128, '2014-02-01 01:09:57.000000', 'consum', 0.0210, 'lps'),
	(517496, 128, '2014-02-01 01:09:58.000000', 'consum', 0.0215, 'lps'),
	(517497, 128, '2014-02-01 01:09:59.000000', 'consum', 0.0223, 'lps'),
	(517498, 128, '2014-02-01 01:10:00.000000', 'consum', 0.0219, 'lps'),
	(517499, 128, '2014-02-01 01:10:01.000000', 'consum', 0.0215, 'lps'),
	(517500, 128, '2014-02-01 01:10:02.000000', 'consum', 0.0211, 'lps'),
	(517501, 128, '2014-02-01 01:10:03.000000', 'consum', 0.0212, 'lps'),
	(517502, 128, '2014-02-01 01:10:04.000000', 'consum', 0.0217, 'lps'),
	(517503, 128, '2014-02-01 01:10:05.000000', 'consum', 0.0213, 'lps'),
	(517504, 128, '2014-02-01 01:10:06.000000', 'consum', 0.0216, 'lps'),
	(517505, 128, '2014-02-01 01:10:07.000000', 'consum', 0.0220, 'lps'),
	(517506, 128, '2014-02-01 01:10:08.000000', 'consum', 0.0215, 'lps'),
	(517507, 128, '2014-02-01 01:10:09.000000', 'consum', 0.0217, 'lps'),
	(517508, 128, '2014-02-01 01:10:10.000000', 'consum', 0.0219, 'lps'),
	(517509, 128, '2014-02-01 01:10:11.000000', 'consum', 0.0218, 'lps'),
	(517510, 128, '2014-02-01 01:10:12.000000', 'consum', 0.0212, 'lps'),
	(517511, 128, '2014-02-01 01:10:13.000000', 'consum', 0.0222, 'lps'),
	(517512, 128, '2014-02-01 01:10:14.000000', 'consum', 0.0211, 'lps'),
	(517513, 128, '2014-02-01 01:10:15.000000', 'consum', 0.0221, 'lps'),
	(517514, 128, '2014-02-01 01:10:16.000000', 'consum', 0.0222, 'lps'),
	(517515, 128, '2014-02-01 01:10:17.000000', 'consum', 0.0222, 'lps'),
	(517516, 128, '2014-02-01 01:10:18.000000', 'consum', 0.0221, 'lps'),
	(517517, 128, '2014-02-01 01:10:19.000000', 'consum', 0.0215, 'lps'),
	(517518, 128, '2014-02-01 01:10:20.000000', 'consum', 0.0215, 'lps'),
	(517519, 128, '2014-02-01 01:10:21.000000', 'consum', 0.0221, 'lps'),
	(517520, 128, '2014-02-01 01:10:22.000000', 'consum', 0.0223, 'lps'),
	(517521, 128, '2014-02-01 01:10:23.000000', 'consum', 0.0214, 'lps'),
	(517522, 128, '2014-02-01 01:10:24.000000', 'consum', 0.0221, 'lps'),
	(517523, 128, '2014-02-01 01:10:25.000000', 'consum', 0.0211, 'lps'),
	(517524, 128, '2014-02-01 01:10:26.000000', 'consum', 0.0210, 'lps'),
	(517525, 128, '2014-02-01 01:10:27.000000', 'consum', 0.0223, 'lps'),
	(517526, 128, '2014-02-01 01:10:28.000000', 'consum', 0.0218, 'lps'),
	(517527, 128, '2014-02-01 01:10:29.000000', 'consum', 0.0213, 'lps'),
	(517528, 128, '2014-02-01 01:10:30.000000', 'consum', 0.0213, 'lps'),
	(517529, 128, '2014-02-01 01:10:31.000000', 'consum', 0.0219, 'lps'),
	(517530, 128, '2014-02-01 01:10:32.000000', 'consum', 0.0220, 'lps'),
	(517531, 128, '2014-02-01 01:10:33.000000', 'consum', 0.0217, 'lps'),
	(517532, 128, '2014-02-01 01:10:34.000000', 'consum', 0.0214, 'lps'),
	(517533, 128, '2014-02-01 01:10:35.000000', 'consum', 0.0211, 'lps'),
	(517534, 128, '2014-02-01 01:10:36.000000', 'consum', 0.0217, 'lps'),
	(517535, 128, '2014-02-01 01:10:37.000000', 'consum', 0.0213, 'lps'),
	(517536, 128, '2014-02-01 01:10:38.000000', 'consum', 0.0219, 'lps'),
	(517537, 128, '2014-02-01 01:10:39.000000', 'consum', 0.0218, 'lps'),
	(517538, 128, '2014-02-01 01:10:40.000000', 'consum', 0.0223, 'lps'),
	(517539, 128, '2014-02-01 01:10:41.000000', 'consum', 0.0210, 'lps'),
	(517540, 128, '2014-02-01 01:10:42.000000', 'consum', 0.0215, 'lps'),
	(517541, 128, '2014-02-01 01:10:43.000000', 'consum', 0.0219, 'lps'),
	(517542, 128, '2014-02-01 01:10:44.000000', 'consum', 0.0213, 'lps'),
	(517543, 128, '2014-02-01 01:10:45.000000', 'consum', 0.0212, 'lps'),
	(517544, 128, '2014-02-01 01:10:46.000000', 'consum', 0.0210, 'lps'),
	(517545, 128, '2014-02-01 01:10:47.000000', 'consum', 0.0221, 'lps'),
	(517546, 128, '2014-02-01 01:10:48.000000', 'consum', 0.0223, 'lps'),
	(517547, 128, '2014-02-01 01:10:49.000000', 'consum', 0.0213, 'lps'),
	(517548, 128, '2014-02-01 01:10:50.000000', 'consum', 0.0217, 'lps'),
	(517549, 128, '2014-02-01 01:10:51.000000', 'consum', 0.0220, 'lps'),
	(517550, 128, '2014-02-01 01:10:52.000000', 'consum', 0.0213, 'lps'),
	(517551, 128, '2014-02-01 01:10:53.000000', 'consum', 0.0223, 'lps'),
	(517552, 128, '2014-02-01 01:10:54.000000', 'consum', 0.0210, 'lps'),
	(517553, 128, '2014-02-01 01:10:55.000000', 'consum', 0.0214, 'lps'),
	(517554, 128, '2014-02-01 01:10:56.000000', 'consum', 0.0216, 'lps'),
	(517555, 128, '2014-02-01 01:10:57.000000', 'consum', 0.0217, 'lps'),
	(517556, 128, '2014-02-01 01:10:58.000000', 'consum', 0.0211, 'lps'),
	(517557, 128, '2014-02-01 01:10:59.000000', 'consum', 0.0210, 'lps'),
	(517558, 128, '2014-02-01 01:11:00.000000', 'consum', 0.0223, 'lps'),
	(517559, 128, '2014-02-01 01:11:01.000000', 'consum', 0.0216, 'lps'),
	(517560, 128, '2014-02-01 01:11:02.000000', 'consum', 0.0218, 'lps'),
	(517561, 128, '2014-02-01 01:11:03.000000', 'consum', 0.0218, 'lps'),
	(517562, 128, '2014-02-01 01:11:04.000000', 'consum', 0.0211, 'lps'),
	(517563, 128, '2014-02-01 01:11:05.000000', 'consum', 0.0222, 'lps'),
	(517564, 128, '2014-02-01 01:11:06.000000', 'consum', 0.0210, 'lps'),
	(517565, 128, '2014-02-01 01:11:07.000000', 'consum', 0.0215, 'lps'),
	(517566, 128, '2014-02-01 01:11:08.000000', 'consum', 0.0223, 'lps'),
	(517567, 128, '2014-02-01 01:11:09.000000', 'consum', 0.0220, 'lps'),
	(517568, 128, '2014-02-01 01:11:10.000000', 'consum', 0.0219, 'lps'),
	(517569, 128, '2014-02-01 01:11:11.000000', 'consum', 0.0214, 'lps'),
	(517570, 128, '2014-02-01 01:11:12.000000', 'consum', 0.0215, 'lps'),
	(517571, 128, '2014-02-01 01:11:13.000000', 'consum', 0.0212, 'lps'),
	(517572, 128, '2014-02-01 01:11:14.000000', 'consum', 0.0217, 'lps'),
	(517573, 128, '2014-02-01 01:11:15.000000', 'consum', 0.0214, 'lps'),
	(517574, 128, '2014-02-01 01:11:16.000000', 'consum', 0.0221, 'lps'),
	(517575, 128, '2014-02-01 01:11:17.000000', 'consum', 0.0215, 'lps'),
	(517576, 128, '2014-02-01 01:11:18.000000', 'consum', 0.0213, 'lps'),
	(517577, 128, '2014-02-01 01:11:19.000000', 'consum', 0.0211, 'lps'),
	(517578, 128, '2014-02-01 01:11:20.000000', 'consum', 0.0221, 'lps'),
	(517579, 128, '2014-02-01 01:11:21.000000', 'consum', 0.0219, 'lps'),
	(517580, 128, '2014-02-01 01:11:22.000000', 'consum', 0.0212, 'lps'),
	(517581, 128, '2014-02-01 01:11:23.000000', 'consum', 0.0218, 'lps'),
	(517582, 128, '2014-02-01 01:11:24.000000', 'consum', 0.0217, 'lps'),
	(517583, 128, '2014-02-01 01:11:25.000000', 'consum', 0.0222, 'lps'),
	(517584, 128, '2014-02-01 01:11:26.000000', 'consum', 0.0222, 'lps'),
	(517585, 128, '2014-02-01 01:11:27.000000', 'consum', 0.0219, 'lps'),
	(517586, 128, '2014-02-01 01:11:28.000000', 'consum', 0.0219, 'lps'),
	(517587, 128, '2014-02-01 01:11:29.000000', 'consum', 0.0216, 'lps'),
	(517588, 128, '2014-02-01 01:11:30.000000', 'consum', 0.0213, 'lps'),
	(517589, 128, '2014-02-01 01:11:31.000000', 'consum', 0.0222, 'lps'),
	(517590, 128, '2014-02-01 01:11:32.000000', 'consum', 0.0218, 'lps'),
	(517591, 128, '2014-02-01 01:11:33.000000', 'consum', 0.0216, 'lps'),
	(517592, 128, '2014-02-01 01:11:34.000000', 'consum', 0.0215, 'lps'),
	(517593, 128, '2014-02-01 01:11:35.000000', 'consum', 0.0217, 'lps'),
	(517594, 128, '2014-02-01 01:11:36.000000', 'consum', 0.0219, 'lps'),
	(517595, 128, '2014-02-01 01:11:37.000000', 'consum', 0.0221, 'lps'),
	(517596, 128, '2014-02-01 01:11:38.000000', 'consum', 0.0222, 'lps'),
	(517597, 128, '2014-02-01 01:11:39.000000', 'consum', 0.0210, 'lps'),
	(517598, 128, '2014-02-01 01:11:40.000000', 'consum', 0.0217, 'lps'),
	(517599, 128, '2014-02-01 01:11:41.000000', 'consum', 0.0217, 'lps'),
	(517600, 128, '2014-02-01 01:11:42.000000', 'consum', 0.0210, 'lps'),
	(517601, 128, '2014-02-01 01:11:43.000000', 'consum', 0.0217, 'lps'),
	(517602, 128, '2014-02-01 01:11:44.000000', 'consum', 0.0217, 'lps'),
	(517603, 128, '2014-02-01 01:11:45.000000', 'consum', 0.0210, 'lps'),
	(517604, 128, '2014-02-01 01:11:46.000000', 'consum', 0.0217, 'lps'),
	(517605, 128, '2014-02-01 01:11:47.000000', 'consum', 0.0219, 'lps'),
	(517606, 128, '2014-02-01 01:11:48.000000', 'consum', 0.0221, 'lps'),
	(517607, 128, '2014-02-01 01:11:49.000000', 'consum', 0.0222, 'lps'),
	(517608, 128, '2014-02-01 01:11:50.000000', 'consum', 0.0210, 'lps'),
	(517609, 128, '2014-02-01 01:11:51.000000', 'consum', 0.0217, 'lps'),
	(517610, 128, '2014-02-01 01:11:52.000000', 'consum', 0.0216, 'lps'),
	(517611, 128, '2014-02-01 01:11:53.000000', 'consum', 0.0221, 'lps'),
	(517612, 128, '2014-02-01 01:11:54.000000', 'consum', 0.0221, 'lps'),
	(517613, 128, '2014-02-01 01:11:55.000000', 'consum', 0.0219, 'lps'),
	(517614, 128, '2014-02-01 01:11:56.000000', 'consum', 0.0219, 'lps'),
	(517615, 128, '2014-02-01 01:11:57.000000', 'consum', 0.0218, 'lps'),
	(517616, 128, '2014-02-01 01:11:58.000000', 'consum', 0.0223, 'lps'),
	(517617, 128, '2014-02-01 01:11:59.000000', 'consum', 0.0222, 'lps'),
	(517618, 128, '2014-02-01 01:12:00.000000', 'consum', 0.0217, 'lps'),
	(517619, 128, '2014-02-01 01:12:01.000000', 'consum', 0.0222, 'lps'),
	(517620, 128, '2014-02-01 01:12:02.000000', 'consum', 0.0210, 'lps'),
	(517621, 128, '2014-02-01 01:12:03.000000', 'consum', 0.0216, 'lps'),
	(517622, 128, '2014-02-01 01:12:04.000000', 'consum', 0.0215, 'lps'),
	(517623, 128, '2014-02-01 01:12:05.000000', 'consum', 0.0214, 'lps'),
	(517624, 128, '2014-02-01 01:12:06.000000', 'consum', 0.0216, 'lps'),
	(517625, 128, '2014-02-01 01:12:07.000000', 'consum', 0.0214, 'lps'),
	(517626, 128, '2014-02-01 01:12:08.000000', 'consum', 0.0211, 'lps'),
	(517627, 128, '2014-02-01 01:12:09.000000', 'consum', 0.0221, 'lps'),
	(517628, 128, '2014-02-01 01:12:10.000000', 'consum', 0.0220, 'lps'),
	(517629, 128, '2014-02-01 01:12:11.000000', 'consum', 0.0212, 'lps'),
	(517630, 128, '2014-02-01 01:12:12.000000', 'consum', 0.0220, 'lps'),
	(517631, 128, '2014-02-01 01:12:13.000000', 'consum', 0.0210, 'lps'),
	(517632, 128, '2014-02-01 01:12:14.000000', 'consum', 0.0210, 'lps'),
	(517633, 128, '2014-02-01 01:12:15.000000', 'consum', 0.0211, 'lps'),
	(517634, 128, '2014-02-01 01:12:16.000000', 'consum', 0.0216, 'lps'),
	(517635, 128, '2014-02-01 01:12:17.000000', 'consum', 0.0210, 'lps'),
	(517636, 128, '2014-02-01 01:12:18.000000', 'consum', 0.0220, 'lps'),
	(517637, 128, '2014-02-01 01:12:19.000000', 'consum', 0.0219, 'lps'),
	(517638, 128, '2014-02-01 01:12:20.000000', 'consum', 0.0212, 'lps'),
	(517639, 128, '2014-02-01 01:12:21.000000', 'consum', 0.0222, 'lps'),
	(517640, 128, '2014-02-01 01:12:22.000000', 'consum', 0.0221, 'lps'),
	(517641, 128, '2014-02-01 01:12:23.000000', 'consum', 0.0217, 'lps'),
	(517642, 128, '2014-02-01 01:12:24.000000', 'consum', 0.0210, 'lps'),
	(517643, 128, '2014-02-01 01:12:25.000000', 'consum', 0.0220, 'lps'),
	(517644, 128, '2014-02-01 01:12:26.000000', 'consum', 0.0219, 'lps'),
	(517645, 128, '2014-02-01 01:12:27.000000', 'consum', 0.0212, 'lps'),
	(517646, 128, '2014-02-01 01:12:28.000000', 'consum', 0.0221, 'lps'),
	(517647, 128, '2014-02-01 01:12:29.000000', 'consum', 0.0215, 'lps'),
	(517648, 128, '2014-02-01 01:12:30.000000', 'consum', 0.0219, 'lps'),
	(517649, 128, '2014-02-01 01:12:31.000000', 'consum', 0.0210, 'lps'),
	(517650, 128, '2014-02-01 01:12:32.000000', 'consum', 0.0214, 'lps'),
	(517651, 128, '2014-02-01 01:12:33.000000', 'consum', 0.0214, 'lps'),
	(517652, 128, '2014-02-01 01:12:34.000000', 'consum', 0.0221, 'lps'),
	(517653, 128, '2014-02-01 01:12:35.000000', 'consum', 0.0210, 'lps'),
	(517654, 128, '2014-02-01 01:12:36.000000', 'consum', 0.0219, 'lps'),
	(517655, 128, '2014-02-01 01:12:37.000000', 'consum', 0.0214, 'lps'),
	(517656, 128, '2014-02-01 01:12:38.000000', 'consum', 0.0217, 'lps'),
	(517657, 128, '2014-02-01 01:12:39.000000', 'consum', 0.0219, 'lps'),
	(517658, 128, '2014-02-01 01:12:40.000000', 'consum', 0.0221, 'lps'),
	(517659, 128, '2014-02-01 01:12:41.000000', 'consum', 0.0223, 'lps'),
	(517660, 128, '2014-02-01 01:12:42.000000', 'consum', 0.0214, 'lps'),
	(517661, 128, '2014-02-01 01:12:43.000000', 'consum', 0.0222, 'lps'),
	(517662, 128, '2014-02-01 01:12:44.000000', 'consum', 0.0216, 'lps'),
	(517663, 128, '2014-02-01 01:12:45.000000', 'consum', 0.0220, 'lps'),
	(517664, 128, '2014-02-01 01:12:46.000000', 'consum', 0.0213, 'lps'),
	(517665, 128, '2014-02-01 01:12:47.000000', 'consum', 0.0223, 'lps'),
	(517666, 128, '2014-02-01 01:12:48.000000', 'consum', 0.0211, 'lps'),
	(517667, 128, '2014-02-01 01:12:49.000000', 'consum', 0.0219, 'lps'),
	(517668, 128, '2014-02-01 01:12:50.000000', 'consum', 0.0223, 'lps'),
	(517669, 128, '2014-02-01 01:12:51.000000', 'consum', 0.0220, 'lps'),
	(517670, 128, '2014-02-01 01:12:52.000000', 'consum', 0.0221, 'lps'),
	(517671, 128, '2014-02-01 01:12:53.000000', 'consum', 0.0223, 'lps'),
	(517672, 128, '2014-02-01 01:12:54.000000', 'consum', 0.0216, 'lps'),
	(517673, 128, '2014-02-01 01:12:55.000000', 'consum', 0.0215, 'lps'),
	(517674, 128, '2014-02-01 01:12:56.000000', 'consum', 0.0217, 'lps'),
	(517675, 128, '2014-02-01 01:12:57.000000', 'consum', 0.0218, 'lps'),
	(517676, 128, '2014-02-01 01:12:58.000000', 'consum', 0.0216, 'lps'),
	(517677, 128, '2014-02-01 01:12:59.000000', 'consum', 0.0217, 'lps'),
	(517678, 128, '2014-02-01 01:13:00.000000', 'consum', 0.0214, 'lps'),
	(517679, 128, '2014-02-01 01:13:01.000000', 'consum', 0.0222, 'lps'),
	(517680, 128, '2014-02-01 01:13:02.000000', 'consum', 0.0218, 'lps'),
	(517681, 128, '2014-02-01 01:13:03.000000', 'consum', 0.0215, 'lps'),
	(517682, 128, '2014-02-01 01:13:04.000000', 'consum', 0.0222, 'lps'),
	(517683, 128, '2014-02-01 01:13:05.000000', 'consum', 0.0217, 'lps'),
	(517684, 128, '2014-02-01 01:13:06.000000', 'consum', 0.0223, 'lps'),
	(517685, 128, '2014-02-01 01:13:07.000000', 'consum', 0.0213, 'lps'),
	(517686, 128, '2014-02-01 01:13:08.000000', 'consum', 0.0212, 'lps'),
	(517687, 128, '2014-02-01 01:13:09.000000', 'consum', 0.0213, 'lps'),
	(517688, 128, '2014-02-01 01:13:10.000000', 'consum', 0.0221, 'lps'),
	(517689, 128, '2014-02-01 01:13:11.000000', 'consum', 0.0215, 'lps'),
	(517690, 128, '2014-02-01 01:13:12.000000', 'consum', 0.0216, 'lps'),
	(517691, 128, '2014-02-01 01:13:13.000000', 'consum', 0.0211, 'lps'),
	(517692, 128, '2014-02-01 01:13:14.000000', 'consum', 0.0213, 'lps'),
	(517693, 128, '2014-02-01 01:13:15.000000', 'consum', 0.0223, 'lps'),
	(517694, 128, '2014-02-01 01:13:16.000000', 'consum', 0.0222, 'lps'),
	(517695, 128, '2014-02-01 01:13:17.000000', 'consum', 0.0220, 'lps'),
	(517696, 128, '2014-02-01 01:13:18.000000', 'consum', 0.0211, 'lps'),
	(517697, 128, '2014-02-01 01:13:19.000000', 'consum', 0.0211, 'lps'),
	(517698, 128, '2014-02-01 01:13:20.000000', 'consum', 0.0215, 'lps'),
	(517699, 128, '2014-02-01 01:13:21.000000', 'consum', 0.0216, 'lps'),
	(517700, 128, '2014-02-01 01:13:22.000000', 'consum', 0.0213, 'lps'),
	(517701, 128, '2014-02-01 01:13:23.000000', 'consum', 0.0223, 'lps'),
	(517702, 128, '2014-02-01 01:13:24.000000', 'consum', 0.0210, 'lps'),
	(517703, 128, '2014-02-01 01:13:25.000000', 'consum', 0.0211, 'lps'),
	(517704, 128, '2014-02-01 01:13:26.000000', 'consum', 0.0218, 'lps'),
	(517705, 128, '2014-02-01 01:13:27.000000', 'consum', 0.0220, 'lps'),
	(517706, 128, '2014-02-01 01:13:28.000000', 'consum', 0.0221, 'lps'),
	(517707, 128, '2014-02-01 01:13:29.000000', 'consum', 0.0221, 'lps'),
	(517708, 128, '2014-02-01 01:13:30.000000', 'consum', 0.0217, 'lps'),
	(517709, 128, '2014-02-01 01:13:31.000000', 'consum', 0.0216, 'lps'),
	(517710, 128, '2014-02-01 01:13:32.000000', 'consum', 0.0217, 'lps'),
	(517711, 128, '2014-02-01 01:13:33.000000', 'consum', 0.0216, 'lps'),
	(517712, 128, '2014-02-01 01:13:34.000000', 'consum', 0.0220, 'lps'),
	(517713, 128, '2014-02-01 01:13:35.000000', 'consum', 0.0213, 'lps'),
	(517714, 128, '2014-02-01 01:13:36.000000', 'consum', 0.0211, 'lps'),
	(517715, 128, '2014-02-01 01:13:37.000000', 'consum', 0.0221, 'lps'),
	(517716, 128, '2014-02-01 01:13:38.000000', 'consum', 0.0221, 'lps'),
	(517717, 128, '2014-02-01 01:13:39.000000', 'consum', 0.0218, 'lps'),
	(517718, 128, '2014-02-01 01:13:40.000000', 'consum', 0.0217, 'lps'),
	(517719, 128, '2014-02-01 01:13:41.000000', 'consum', 0.0220, 'lps'),
	(517720, 128, '2014-02-01 01:13:42.000000', 'consum', 0.0214, 'lps'),
	(517721, 128, '2014-02-01 01:13:43.000000', 'consum', 0.0214, 'lps'),
	(517722, 128, '2014-02-01 01:13:44.000000', 'consum', 0.0217, 'lps'),
	(517723, 128, '2014-02-01 01:13:45.000000', 'consum', 0.0222, 'lps'),
	(517724, 128, '2014-02-01 01:13:46.000000', 'consum', 0.0221, 'lps'),
	(517725, 128, '2014-02-01 01:13:47.000000', 'consum', 0.0216, 'lps'),
	(517726, 128, '2014-02-01 01:13:48.000000', 'consum', 0.0219, 'lps'),
	(517727, 128, '2014-02-01 01:13:49.000000', 'consum', 0.0211, 'lps'),
	(517728, 128, '2014-02-01 01:13:50.000000', 'consum', 0.0215, 'lps'),
	(517729, 128, '2014-02-01 01:13:51.000000', 'consum', 0.0220, 'lps'),
	(517730, 128, '2014-02-01 01:13:52.000000', 'consum', 0.0216, 'lps'),
	(517731, 128, '2014-02-01 01:13:53.000000', 'consum', 0.0211, 'lps'),
	(517732, 128, '2014-02-01 01:13:54.000000', 'consum', 0.0212, 'lps'),
	(517733, 128, '2014-02-01 01:13:55.000000', 'consum', 0.0218, 'lps'),
	(517734, 128, '2014-02-01 01:13:56.000000', 'consum', 0.0214, 'lps'),
	(517735, 128, '2014-02-01 01:13:57.000000', 'consum', 0.0221, 'lps'),
	(517736, 128, '2014-02-01 01:13:58.000000', 'consum', 0.0214, 'lps'),
	(517737, 128, '2014-02-01 01:13:59.000000', 'consum', 0.0210, 'lps'),
	(517738, 128, '2014-02-01 01:14:00.000000', 'consum', 0.0214, 'lps'),
	(517739, 128, '2014-02-01 01:14:01.000000', 'consum', 0.0214, 'lps'),
	(517740, 128, '2014-02-01 01:14:02.000000', 'consum', 0.0219, 'lps'),
	(517741, 128, '2014-02-01 01:14:03.000000', 'consum', 0.0215, 'lps'),
	(517742, 128, '2014-02-01 01:14:04.000000', 'consum', 0.0222, 'lps'),
	(517743, 128, '2014-02-01 01:14:05.000000', 'consum', 0.0214, 'lps'),
	(517744, 128, '2014-02-01 01:14:06.000000', 'consum', 0.0223, 'lps'),
	(517745, 128, '2014-02-01 01:14:07.000000', 'consum', 0.0219, 'lps'),
	(517746, 128, '2014-02-01 01:14:08.000000', 'consum', 0.0220, 'lps'),
	(517747, 128, '2014-02-01 01:14:09.000000', 'consum', 0.0218, 'lps'),
	(517748, 128, '2014-02-01 01:14:10.000000', 'consum', 0.0220, 'lps'),
	(517749, 128, '2014-02-01 01:14:11.000000', 'consum', 0.0223, 'lps'),
	(517750, 128, '2014-02-01 01:14:12.000000', 'consum', 0.0216, 'lps'),
	(517751, 128, '2014-02-01 01:14:13.000000', 'consum', 0.0218, 'lps'),
	(517752, 128, '2014-02-01 01:14:14.000000', 'consum', 0.0219, 'lps'),
	(517753, 128, '2014-02-01 01:14:15.000000', 'consum', 0.0215, 'lps'),
	(517754, 128, '2014-02-01 01:14:16.000000', 'consum', 0.0210, 'lps'),
	(517755, 128, '2014-02-01 01:14:17.000000', 'consum', 0.0223, 'lps'),
	(517756, 128, '2014-02-01 01:14:18.000000', 'consum', 0.0218, 'lps'),
	(517757, 128, '2014-02-01 01:14:19.000000', 'consum', 0.0211, 'lps'),
	(517758, 128, '2014-02-01 01:14:20.000000', 'consum', 0.0221, 'lps'),
	(517759, 128, '2014-02-01 01:14:21.000000', 'consum', 0.0220, 'lps'),
	(517760, 128, '2014-02-01 01:14:22.000000', 'consum', 0.0212, 'lps'),
	(517761, 128, '2014-02-01 01:14:23.000000', 'consum', 0.0221, 'lps'),
	(517762, 128, '2014-02-01 01:14:24.000000', 'consum', 0.0216, 'lps'),
	(517763, 128, '2014-02-01 01:14:25.000000', 'consum', 0.0220, 'lps'),
	(517764, 128, '2014-02-01 01:14:26.000000', 'consum', 0.0216, 'lps'),
	(517765, 128, '2014-02-01 01:14:27.000000', 'consum', 0.0211, 'lps'),
	(517766, 128, '2014-02-01 01:14:28.000000', 'consum', 0.0223, 'lps'),
	(517767, 128, '2014-02-01 01:14:29.000000', 'consum', 0.0220, 'lps'),
	(517768, 128, '2014-02-01 01:14:30.000000', 'consum', 0.0218, 'lps'),
	(517769, 128, '2014-02-01 01:14:31.000000', 'consum', 0.0223, 'lps'),
	(517770, 128, '2014-02-01 01:14:32.000000', 'consum', 0.0221, 'lps'),
	(517771, 128, '2014-02-01 01:14:33.000000', 'consum', 0.0215, 'lps'),
	(517772, 128, '2014-02-01 01:14:34.000000', 'consum', 0.0217, 'lps'),
	(517773, 128, '2014-02-01 01:14:35.000000', 'consum', 0.0215, 'lps'),
	(517774, 128, '2014-02-01 01:14:36.000000', 'consum', 0.0216, 'lps'),
	(517775, 128, '2014-02-01 01:14:37.000000', 'consum', 0.0212, 'lps'),
	(517776, 128, '2014-02-01 01:14:38.000000', 'consum', 0.0215, 'lps'),
	(517777, 128, '2014-02-01 01:14:39.000000', 'consum', 0.0214, 'lps'),
	(517778, 128, '2014-02-01 01:14:40.000000', 'consum', 0.0218, 'lps'),
	(517779, 128, '2014-02-01 01:14:41.000000', 'consum', 0.0211, 'lps'),
	(517780, 128, '2014-02-01 01:14:42.000000', 'consum', 0.0220, 'lps'),
	(517781, 128, '2014-02-01 01:14:43.000000', 'consum', 0.0214, 'lps'),
	(517782, 128, '2014-02-01 01:14:44.000000', 'consum', 0.0216, 'lps'),
	(517783, 128, '2014-02-01 01:14:45.000000', 'consum', 0.0212, 'lps'),
	(517784, 128, '2014-02-01 01:14:46.000000', 'consum', 0.0219, 'lps'),
	(517785, 128, '2014-02-01 01:14:47.000000', 'consum', 0.0222, 'lps'),
	(517786, 128, '2014-02-01 01:14:48.000000', 'consum', 0.0213, 'lps'),
	(517787, 128, '2014-02-01 01:14:49.000000', 'consum', 0.0218, 'lps'),
	(517788, 128, '2014-02-01 01:14:50.000000', 'consum', 0.0216, 'lps'),
	(517789, 128, '2014-02-01 01:14:51.000000', 'consum', 0.0215, 'lps'),
	(517790, 128, '2014-02-01 01:14:52.000000', 'consum', 0.0215, 'lps'),
	(517791, 128, '2014-02-01 01:14:53.000000', 'consum', 0.0210, 'lps'),
	(517792, 128, '2014-02-01 01:14:54.000000', 'consum', 0.0222, 'lps'),
	(517793, 128, '2014-02-01 01:14:55.000000', 'consum', 0.0215, 'lps'),
	(517794, 128, '2014-02-01 01:14:56.000000', 'consum', 0.0212, 'lps'),
	(517795, 128, '2014-02-01 01:14:57.000000', 'consum', 0.0219, 'lps'),
	(517796, 128, '2014-02-01 01:14:58.000000', 'consum', 0.0221, 'lps'),
	(517797, 128, '2014-02-01 01:14:59.000000', 'consum', 0.0212, 'lps'),
	(517798, 128, '2014-02-01 01:15:00.000000', 'consum', 0.0217, 'lps'),
	(517799, 128, '2014-02-01 01:15:01.000000', 'consum', 0.0211, 'lps'),
	(517800, 128, '2014-02-01 01:15:02.000000', 'consum', 0.0220, 'lps'),
	(517801, 128, '2014-02-01 01:15:03.000000', 'consum', 0.0217, 'lps'),
	(517802, 128, '2014-02-01 01:15:04.000000', 'consum', 0.0216, 'lps'),
	(517803, 128, '2014-02-01 01:15:05.000000', 'consum', 0.0218, 'lps'),
	(517804, 128, '2014-02-01 01:15:06.000000', 'consum', 0.0218, 'lps'),
	(517805, 128, '2014-02-01 01:15:07.000000', 'consum', 0.0213, 'lps'),
	(517806, 128, '2014-02-01 01:15:08.000000', 'consum', 0.0216, 'lps'),
	(517807, 128, '2014-02-01 01:15:09.000000', 'consum', 0.0216, 'lps'),
	(517808, 128, '2014-02-01 01:15:10.000000', 'consum', 0.0221, 'lps'),
	(517809, 128, '2014-02-01 01:15:11.000000', 'consum', 0.0223, 'lps'),
	(517810, 128, '2014-02-01 01:15:12.000000', 'consum', 0.0214, 'lps'),
	(517811, 128, '2014-02-01 01:15:13.000000', 'consum', 0.0219, 'lps'),
	(517812, 128, '2014-02-01 01:15:14.000000', 'consum', 0.0216, 'lps'),
	(517813, 128, '2014-02-01 01:15:15.000000', 'consum', 0.0214, 'lps'),
	(517814, 128, '2014-02-01 01:15:16.000000', 'consum', 0.0211, 'lps'),
	(517815, 128, '2014-02-01 01:15:17.000000', 'consum', 0.0218, 'lps'),
	(517816, 128, '2014-02-01 01:15:18.000000', 'consum', 0.0218, 'lps'),
	(517817, 128, '2014-02-01 01:15:19.000000', 'consum', 0.0212, 'lps'),
	(517818, 128, '2014-02-01 01:15:20.000000', 'consum', 0.0212, 'lps'),
	(517819, 128, '2014-02-01 01:15:21.000000', 'consum', 0.0216, 'lps'),
	(517820, 128, '2014-02-01 01:15:22.000000', 'consum', 0.0218, 'lps'),
	(517821, 128, '2014-02-01 01:15:23.000000', 'consum', 0.0221, 'lps'),
	(517822, 128, '2014-02-01 01:15:24.000000', 'consum', 0.0211, 'lps'),
	(517823, 128, '2014-02-01 01:15:25.000000', 'consum', 0.0212, 'lps'),
	(517824, 128, '2014-02-01 01:15:26.000000', 'consum', 0.0217, 'lps'),
	(517825, 128, '2014-02-01 01:15:27.000000', 'consum', 0.0210, 'lps'),
	(517826, 128, '2014-02-01 01:15:28.000000', 'consum', 0.0218, 'lps'),
	(517827, 128, '2014-02-01 01:15:29.000000', 'consum', 0.0221, 'lps'),
	(517828, 128, '2014-02-01 01:15:30.000000', 'consum', 0.0214, 'lps'),
	(517829, 128, '2014-02-01 01:15:31.000000', 'consum', 0.0213, 'lps'),
	(517830, 128, '2014-02-01 01:15:32.000000', 'consum', 0.0214, 'lps'),
	(517831, 128, '2014-02-01 01:15:33.000000', 'consum', 0.0221, 'lps'),
	(517832, 128, '2014-02-01 01:15:34.000000', 'consum', 0.0210, 'lps'),
	(517833, 128, '2014-02-01 01:15:35.000000', 'consum', 0.0220, 'lps'),
	(517834, 128, '2014-02-01 01:15:36.000000', 'consum', 0.0219, 'lps'),
	(517835, 128, '2014-02-01 01:15:37.000000', 'consum', 0.0211, 'lps'),
	(517836, 128, '2014-02-01 01:15:38.000000', 'consum', 0.0215, 'lps'),
	(517837, 128, '2014-02-01 01:15:39.000000', 'consum', 0.0219, 'lps'),
	(517838, 128, '2014-02-01 01:15:40.000000', 'consum', 0.0211, 'lps'),
	(517839, 128, '2014-02-01 01:15:41.000000', 'consum', 0.0220, 'lps'),
	(517840, 128, '2014-02-01 01:15:42.000000', 'consum', 0.0214, 'lps'),
	(517841, 128, '2014-02-01 01:15:43.000000', 'consum', 0.0213, 'lps'),
	(517842, 128, '2014-02-01 01:15:44.000000', 'consum', 0.0215, 'lps'),
	(517843, 128, '2014-02-01 01:15:45.000000', 'consum', 0.0214, 'lps'),
	(517844, 128, '2014-02-01 01:15:46.000000', 'consum', 0.0213, 'lps'),
	(517845, 128, '2014-02-01 01:15:47.000000', 'consum', 0.0215, 'lps'),
	(517846, 128, '2014-02-01 01:15:48.000000', 'consum', 0.0212, 'lps'),
	(517847, 128, '2014-02-01 01:15:49.000000', 'consum', 0.0218, 'lps'),
	(517848, 128, '2014-02-01 01:15:50.000000', 'consum', 0.0216, 'lps'),
	(517849, 128, '2014-02-01 01:15:51.000000', 'consum', 0.0220, 'lps'),
	(517850, 128, '2014-02-01 01:15:52.000000', 'consum', 0.0211, 'lps'),
	(517851, 128, '2014-02-01 01:15:53.000000', 'consum', 0.0215, 'lps'),
	(517852, 128, '2014-02-01 01:15:54.000000', 'consum', 0.0220, 'lps'),
	(517853, 128, '2014-02-01 01:15:55.000000', 'consum', 0.0214, 'lps'),
	(517854, 128, '2014-02-01 01:15:56.000000', 'consum', 0.0218, 'lps'),
	(517855, 128, '2014-02-01 01:15:57.000000', 'consum', 0.0222, 'lps'),
	(517856, 128, '2014-02-01 01:15:58.000000', 'consum', 0.0219, 'lps'),
	(517857, 128, '2014-02-01 01:15:59.000000', 'consum', 0.0220, 'lps'),
	(517858, 128, '2014-02-01 01:16:00.000000', 'consum', 0.0219, 'lps'),
	(517859, 128, '2014-02-01 01:16:01.000000', 'consum', 0.0210, 'lps'),
	(517860, 128, '2014-02-01 01:16:02.000000', 'consum', 0.0215, 'lps'),
	(517861, 128, '2014-02-01 01:16:03.000000', 'consum', 0.0218, 'lps'),
	(517862, 128, '2014-02-01 01:16:04.000000', 'consum', 0.0210, 'lps'),
	(517863, 128, '2014-02-01 01:16:05.000000', 'consum', 0.0212, 'lps'),
	(517864, 128, '2014-02-01 01:16:06.000000', 'consum', 0.0210, 'lps'),
	(517865, 128, '2014-02-01 01:16:07.000000', 'consum', 0.0215, 'lps'),
	(517866, 128, '2014-02-01 01:16:08.000000', 'consum', 0.0222, 'lps'),
	(517867, 128, '2014-02-01 01:16:09.000000', 'consum', 0.0215, 'lps'),
	(517868, 128, '2014-02-01 01:16:10.000000', 'consum', 0.0211, 'lps'),
	(517869, 128, '2014-02-01 01:16:11.000000', 'consum', 0.0217, 'lps'),
	(517870, 128, '2014-02-01 01:16:12.000000', 'consum', 0.0214, 'lps'),
	(517871, 128, '2014-02-01 01:16:13.000000', 'consum', 0.0210, 'lps'),
	(517872, 128, '2014-02-01 01:16:14.000000', 'consum', 0.0211, 'lps'),
	(517873, 128, '2014-02-01 01:16:15.000000', 'consum', 0.0218, 'lps'),
	(517874, 128, '2014-02-01 01:16:16.000000', 'consum', 0.0216, 'lps'),
	(517875, 128, '2014-02-01 01:16:17.000000', 'consum', 0.0219, 'lps'),
	(517876, 128, '2014-02-01 01:16:18.000000', 'consum', 0.0221, 'lps'),
	(517877, 128, '2014-02-01 01:16:19.000000', 'consum', 0.0211, 'lps'),
	(517878, 128, '2014-02-01 01:16:20.000000', 'consum', 0.0212, 'lps'),
	(517879, 128, '2014-02-01 01:16:21.000000', 'consum', 0.0217, 'lps'),
	(517880, 128, '2014-02-01 01:16:22.000000', 'consum', 0.0212, 'lps'),
	(517881, 128, '2014-02-01 01:16:23.000000', 'consum', 0.0213, 'lps'),
	(517882, 128, '2014-02-01 01:16:24.000000', 'consum', 0.0217, 'lps'),
	(517883, 128, '2014-02-01 01:16:25.000000', 'consum', 0.0212, 'lps'),
	(517884, 128, '2014-02-01 01:16:26.000000', 'consum', 0.0213, 'lps'),
	(517885, 128, '2014-02-01 01:16:27.000000', 'consum', 0.0221, 'lps'),
	(517886, 128, '2014-02-01 01:16:28.000000', 'consum', 0.0213, 'lps'),
	(517887, 128, '2014-02-01 01:16:29.000000', 'consum', 0.0221, 'lps'),
	(517888, 128, '2014-02-01 01:16:30.000000', 'consum', 0.0216, 'lps'),
	(517889, 128, '2014-02-01 01:16:31.000000', 'consum', 0.0221, 'lps'),
	(517890, 128, '2014-02-01 01:16:32.000000', 'consum', 0.0217, 'lps'),
	(517891, 128, '2014-02-01 01:16:33.000000', 'consum', 0.0214, 'lps'),
	(517892, 128, '2014-02-01 01:16:34.000000', 'consum', 0.0223, 'lps'),
	(517893, 128, '2014-02-01 01:16:35.000000', 'consum', 0.0220, 'lps'),
	(517894, 128, '2014-02-01 01:16:36.000000', 'consum', 0.0211, 'lps'),
	(517895, 128, '2014-02-01 01:16:37.000000', 'consum', 0.0211, 'lps'),
	(517896, 128, '2014-02-01 01:16:38.000000', 'consum', 0.0214, 'lps'),
	(517897, 128, '2014-02-01 01:16:39.000000', 'consum', 0.0212, 'lps'),
	(517898, 128, '2014-02-01 01:16:40.000000', 'consum', 0.0211, 'lps'),
	(517899, 128, '2014-02-01 01:16:41.000000', 'consum', 0.0222, 'lps'),
	(517900, 128, '2014-02-01 01:16:42.000000', 'consum', 0.0212, 'lps'),
	(517901, 128, '2014-02-01 01:16:43.000000', 'consum', 0.0214, 'lps'),
	(517902, 128, '2014-02-01 01:16:44.000000', 'consum', 0.0210, 'lps'),
	(517903, 128, '2014-02-01 01:16:45.000000', 'consum', 0.0210, 'lps'),
	(517904, 128, '2014-02-01 01:16:46.000000', 'consum', 0.0212, 'lps'),
	(517905, 128, '2014-02-01 01:16:47.000000', 'consum', 0.0222, 'lps'),
	(517906, 128, '2014-02-01 01:16:48.000000', 'consum', 0.0220, 'lps'),
	(517907, 128, '2014-02-01 01:16:49.000000', 'consum', 0.0212, 'lps'),
	(517908, 128, '2014-02-01 01:16:50.000000', 'consum', 0.0217, 'lps'),
	(517909, 128, '2014-02-01 01:16:51.000000', 'consum', 0.0210, 'lps'),
	(517910, 128, '2014-02-01 01:16:52.000000', 'consum', 0.0221, 'lps'),
	(517911, 128, '2014-02-01 01:16:53.000000', 'consum', 0.0221, 'lps'),
	(517912, 128, '2014-02-01 01:16:54.000000', 'consum', 0.0220, 'lps'),
	(517913, 128, '2014-02-01 01:16:55.000000', 'consum', 0.0211, 'lps'),
	(517914, 128, '2014-02-01 01:16:56.000000', 'consum', 0.0217, 'lps'),
	(517915, 128, '2014-02-01 01:16:57.000000', 'consum', 0.0213, 'lps'),
	(517916, 128, '2014-02-01 01:16:58.000000', 'consum', 0.0217, 'lps'),
	(517917, 128, '2014-02-01 01:16:59.000000', 'consum', 0.0211, 'lps'),
	(517918, 128, '2014-02-01 01:17:00.000000', 'consum', 0.0223, 'lps'),
	(517919, 128, '2014-02-01 01:17:01.000000', 'consum', 0.0217, 'lps'),
	(517920, 128, '2014-02-01 01:17:02.000000', 'consum', 0.0220, 'lps'),
	(517921, 128, '2014-02-01 01:17:03.000000', 'consum', 0.0212, 'lps'),
	(517922, 128, '2014-02-01 01:17:04.000000', 'consum', 0.0217, 'lps'),
	(517923, 128, '2014-02-01 01:17:05.000000', 'consum', 0.0211, 'lps'),
	(517924, 128, '2014-02-01 01:17:06.000000', 'consum', 0.0223, 'lps'),
	(517925, 128, '2014-02-01 01:17:07.000000', 'consum', 0.0215, 'lps'),
	(517926, 128, '2014-02-01 01:17:08.000000', 'consum', 0.0213, 'lps'),
	(517927, 128, '2014-02-01 01:17:09.000000', 'consum', 0.0211, 'lps'),
	(517928, 128, '2014-02-01 01:17:10.000000', 'consum', 0.0220, 'lps'),
	(517929, 128, '2014-02-01 01:17:11.000000', 'consum', 0.0214, 'lps'),
	(517930, 128, '2014-02-01 01:17:12.000000', 'consum', 0.0217, 'lps'),
	(517931, 128, '2014-02-01 01:17:13.000000', 'consum', 0.0217, 'lps'),
	(517932, 128, '2014-02-01 01:17:14.000000', 'consum', 0.0211, 'lps'),
	(517933, 128, '2014-02-01 01:17:15.000000', 'consum', 0.0221, 'lps'),
	(517934, 128, '2014-02-01 01:17:16.000000', 'consum', 0.0221, 'lps'),
	(517935, 128, '2014-02-01 01:17:17.000000', 'consum', 0.0218, 'lps'),
	(517936, 128, '2014-02-01 01:17:18.000000', 'consum', 0.0219, 'lps'),
	(517937, 128, '2014-02-01 01:17:19.000000', 'consum', 0.0215, 'lps'),
	(517938, 128, '2014-02-01 01:17:20.000000', 'consum', 0.0210, 'lps'),
	(517939, 128, '2014-02-01 01:17:21.000000', 'consum', 0.0210, 'lps'),
	(517940, 128, '2014-02-01 01:17:22.000000', 'consum', 0.0210, 'lps'),
	(517941, 128, '2014-02-01 01:17:23.000000', 'consum', 0.0223, 'lps'),
	(517942, 128, '2014-02-01 01:17:24.000000', 'consum', 0.0220, 'lps'),
	(517943, 128, '2014-02-01 01:17:25.000000', 'consum', 0.0221, 'lps'),
	(517944, 128, '2014-02-01 01:17:26.000000', 'consum', 0.0223, 'lps'),
	(517945, 128, '2014-02-01 01:17:27.000000', 'consum', 0.0214, 'lps'),
	(517946, 128, '2014-02-01 01:17:28.000000', 'consum', 0.0219, 'lps'),
	(517947, 128, '2014-02-01 01:17:29.000000', 'consum', 0.0217, 'lps'),
	(517948, 128, '2014-02-01 01:17:30.000000', 'consum', 0.0219, 'lps'),
	(517949, 128, '2014-02-01 01:17:31.000000', 'consum', 0.0220, 'lps'),
	(517950, 128, '2014-02-01 01:17:32.000000', 'consum', 0.0219, 'lps'),
	(517951, 128, '2014-02-01 01:17:33.000000', 'consum', 0.0213, 'lps'),
	(517952, 128, '2014-02-01 01:17:34.000000', 'consum', 0.0223, 'lps'),
	(517953, 128, '2014-02-01 01:17:35.000000', 'consum', 0.0214, 'lps'),
	(517954, 128, '2014-02-01 01:17:36.000000', 'consum', 0.0219, 'lps'),
	(517955, 128, '2014-02-01 01:17:37.000000', 'consum', 0.0216, 'lps'),
	(517956, 128, '2014-02-01 01:17:38.000000', 'consum', 0.0211, 'lps'),
	(517957, 128, '2014-02-01 01:17:39.000000', 'consum', 0.0212, 'lps'),
	(517958, 128, '2014-02-01 01:17:40.000000', 'consum', 0.0220, 'lps'),
	(517959, 128, '2014-02-01 01:17:41.000000', 'consum', 0.0223, 'lps'),
	(517960, 128, '2014-02-01 01:17:42.000000', 'consum', 0.0220, 'lps'),
	(517961, 128, '2014-02-01 01:17:43.000000', 'consum', 0.0221, 'lps'),
	(517962, 128, '2014-02-01 01:17:44.000000', 'consum', 0.0220, 'lps'),
	(517963, 128, '2014-02-01 01:17:45.000000', 'consum', 0.0214, 'lps'),
	(517964, 128, '2014-02-01 01:17:46.000000', 'consum', 0.0215, 'lps'),
	(517965, 128, '2014-02-01 01:17:47.000000', 'consum', 0.0221, 'lps'),
	(517966, 128, '2014-02-01 01:17:48.000000', 'consum', 0.0211, 'lps'),
	(517967, 128, '2014-02-01 01:17:49.000000', 'consum', 0.0211, 'lps'),
	(517968, 128, '2014-02-01 01:17:50.000000', 'consum', 0.0213, 'lps'),
	(517969, 128, '2014-02-01 01:17:51.000000', 'consum', 0.0222, 'lps'),
	(517970, 128, '2014-02-01 01:17:52.000000', 'consum', 0.0220, 'lps'),
	(517971, 128, '2014-02-01 01:17:53.000000', 'consum', 0.0210, 'lps'),
	(517972, 128, '2014-02-01 01:17:54.000000', 'consum', 0.0210, 'lps'),
	(517973, 128, '2014-02-01 01:17:55.000000', 'consum', 0.0211, 'lps'),
	(517974, 128, '2014-02-01 01:17:56.000000', 'consum', 0.0214, 'lps'),
	(517975, 128, '2014-02-01 01:17:57.000000', 'consum', 0.0212, 'lps'),
	(517976, 128, '2014-02-01 01:17:58.000000', 'consum', 0.0223, 'lps'),
	(517977, 128, '2014-02-01 01:17:59.000000', 'consum', 0.0213, 'lps'),
	(517978, 128, '2014-02-01 01:18:00.000000', 'consum', 0.0216, 'lps'),
	(517979, 128, '2014-02-01 01:18:01.000000', 'consum', 0.0218, 'lps'),
	(517980, 128, '2014-02-01 01:18:02.000000', 'consum', 0.0217, 'lps'),
	(517981, 128, '2014-02-01 01:18:03.000000', 'consum', 0.0223, 'lps'),
	(517982, 128, '2014-02-01 01:18:04.000000', 'consum', 0.0214, 'lps'),
	(517983, 128, '2014-02-01 01:18:05.000000', 'consum', 0.0218, 'lps'),
	(517984, 128, '2014-02-01 01:18:06.000000', 'consum', 0.0223, 'lps'),
	(517985, 128, '2014-02-01 01:18:07.000000', 'consum', 0.0210, 'lps'),
	(517986, 128, '2014-02-01 01:18:08.000000', 'consum', 0.0213, 'lps'),
	(517987, 128, '2014-02-01 01:18:09.000000', 'consum', 0.0214, 'lps'),
	(517988, 128, '2014-02-01 01:18:10.000000', 'consum', 0.0219, 'lps'),
	(517989, 128, '2014-02-01 01:18:11.000000', 'consum', 0.0218, 'lps'),
	(517990, 128, '2014-02-01 01:18:12.000000', 'consum', 0.0220, 'lps'),
	(517991, 128, '2014-02-01 01:18:13.000000', 'consum', 0.0212, 'lps'),
	(517992, 128, '2014-02-01 01:18:14.000000', 'consum', 0.0216, 'lps'),
	(517993, 128, '2014-02-01 01:18:15.000000', 'consum', 0.0221, 'lps'),
	(517994, 128, '2014-02-01 01:18:16.000000', 'consum', 0.0221, 'lps'),
	(517995, 128, '2014-02-01 01:18:17.000000', 'consum', 0.0217, 'lps'),
	(517996, 128, '2014-02-01 01:18:18.000000', 'consum', 0.0215, 'lps'),
	(517997, 128, '2014-02-01 01:18:19.000000', 'consum', 0.0211, 'lps'),
	(517998, 128, '2014-02-01 01:18:20.000000', 'consum', 0.0218, 'lps'),
	(517999, 128, '2014-02-01 01:18:21.000000', 'consum', 0.0218, 'lps'),
	(518000, 128, '2014-02-01 01:18:22.000000', 'consum', 0.0214, 'lps'),
	(518001, 128, '2014-02-01 01:18:23.000000', 'consum', 0.0219, 'lps'),
	(518002, 128, '2014-02-01 01:18:24.000000', 'consum', 0.0218, 'lps'),
	(518003, 128, '2014-02-01 01:18:25.000000', 'consum', 0.0221, 'lps'),
	(518004, 128, '2014-02-01 01:18:26.000000', 'consum', 0.0212, 'lps'),
	(518005, 128, '2014-02-01 01:18:27.000000', 'consum', 0.0218, 'lps'),
	(518006, 128, '2014-02-01 01:18:28.000000', 'consum', 0.0216, 'lps'),
	(518007, 128, '2014-02-01 01:18:29.000000', 'consum', 0.0215, 'lps'),
	(518008, 128, '2014-02-01 01:18:30.000000', 'consum', 0.0218, 'lps'),
	(518009, 128, '2014-02-01 01:18:31.000000', 'consum', 0.0220, 'lps'),
	(518010, 128, '2014-02-01 01:18:32.000000', 'consum', 0.0211, 'lps'),
	(518011, 128, '2014-02-01 01:18:33.000000', 'consum', 0.0212, 'lps'),
	(518012, 128, '2014-02-01 01:18:34.000000', 'consum', 0.0218, 'lps'),
	(518013, 128, '2014-02-01 01:18:35.000000', 'consum', 0.0218, 'lps'),
	(518014, 128, '2014-02-01 01:18:36.000000', 'consum', 0.0210, 'lps'),
	(518015, 128, '2014-02-01 01:18:37.000000', 'consum', 0.0214, 'lps'),
	(518016, 128, '2014-02-01 01:18:38.000000', 'consum', 0.0217, 'lps'),
	(518017, 128, '2014-02-01 01:18:39.000000', 'consum', 0.0218, 'lps'),
	(518018, 128, '2014-02-01 01:18:40.000000', 'consum', 0.0219, 'lps'),
	(518019, 128, '2014-02-01 01:18:41.000000', 'consum', 0.0215, 'lps'),
	(518020, 128, '2014-02-01 01:18:42.000000', 'consum', 0.0223, 'lps'),
	(518021, 128, '2014-02-01 01:18:43.000000', 'consum', 0.0218, 'lps'),
	(518022, 128, '2014-02-01 01:18:44.000000', 'consum', 0.0212, 'lps'),
	(518023, 128, '2014-02-01 01:18:45.000000', 'consum', 0.0211, 'lps'),
	(518024, 128, '2014-02-01 01:18:46.000000', 'consum', 0.0223, 'lps'),
	(518025, 128, '2014-02-01 01:18:47.000000', 'consum', 0.0216, 'lps'),
	(518026, 128, '2014-02-01 01:18:48.000000', 'consum', 0.0214, 'lps'),
	(518027, 128, '2014-02-01 01:18:49.000000', 'consum', 0.0213, 'lps'),
	(518028, 128, '2014-02-01 01:18:50.000000', 'consum', 0.0215, 'lps'),
	(518029, 128, '2014-02-01 01:18:51.000000', 'consum', 0.0212, 'lps'),
	(518030, 128, '2014-02-01 01:18:52.000000', 'consum', 0.0221, 'lps'),
	(518031, 128, '2014-02-01 01:18:53.000000', 'consum', 0.0218, 'lps'),
	(518032, 128, '2014-02-01 01:18:54.000000', 'consum', 0.0214, 'lps'),
	(518033, 128, '2014-02-01 01:18:55.000000', 'consum', 0.0223, 'lps'),
	(518034, 128, '2014-02-01 01:18:56.000000', 'consum', 0.0222, 'lps'),
	(518035, 128, '2014-02-01 01:18:57.000000', 'consum', 0.0216, 'lps'),
	(518036, 128, '2014-02-01 01:18:58.000000', 'consum', 0.0218, 'lps'),
	(518037, 128, '2014-02-01 01:18:59.000000', 'consum', 0.0217, 'lps'),
	(518038, 128, '2014-02-01 01:19:00.000000', 'consum', 0.0211, 'lps'),
	(518039, 128, '2014-02-01 01:19:01.000000', 'consum', 0.0221, 'lps'),
	(518040, 128, '2014-02-01 01:19:02.000000', 'consum', 0.0219, 'lps'),
	(518041, 128, '2014-02-01 01:19:03.000000', 'consum', 0.0223, 'lps'),
	(518042, 128, '2014-02-01 01:19:04.000000', 'consum', 0.0223, 'lps'),
	(518043, 128, '2014-02-01 01:19:05.000000', 'consum', 0.0219, 'lps'),
	(518044, 128, '2014-02-01 01:19:06.000000', 'consum', 0.0218, 'lps'),
	(518045, 128, '2014-02-01 01:19:07.000000', 'consum', 0.0222, 'lps'),
	(518046, 128, '2014-02-01 01:19:08.000000', 'consum', 0.0219, 'lps'),
	(518047, 128, '2014-02-01 01:19:09.000000', 'consum', 0.0222, 'lps'),
	(518048, 128, '2014-02-01 01:19:10.000000', 'consum', 0.0214, 'lps'),
	(518049, 128, '2014-02-01 01:19:11.000000', 'consum', 0.0222, 'lps'),
	(518050, 128, '2014-02-01 01:19:12.000000', 'consum', 0.0216, 'lps'),
	(518051, 128, '2014-02-01 01:19:13.000000', 'consum', 0.0218, 'lps'),
	(518052, 128, '2014-02-01 01:19:14.000000', 'consum', 0.0218, 'lps'),
	(518053, 128, '2014-02-01 01:19:15.000000', 'consum', 0.0212, 'lps'),
	(518054, 128, '2014-02-01 01:19:16.000000', 'consum', 0.0223, 'lps'),
	(518055, 128, '2014-02-01 01:19:17.000000', 'consum', 0.0217, 'lps'),
	(518056, 128, '2014-02-01 01:19:18.000000', 'consum', 0.0219, 'lps'),
	(518057, 128, '2014-02-01 01:19:19.000000', 'consum', 0.0222, 'lps'),
	(518058, 128, '2014-02-01 01:19:20.000000', 'consum', 0.0214, 'lps'),
	(518059, 128, '2014-02-01 01:19:21.000000', 'consum', 0.0210, 'lps'),
	(518060, 128, '2014-02-01 01:19:22.000000', 'consum', 0.0213, 'lps'),
	(518061, 128, '2014-02-01 01:19:23.000000', 'consum', 0.0210, 'lps'),
	(518062, 128, '2014-02-01 01:19:24.000000', 'consum', 0.0214, 'lps'),
	(518063, 128, '2014-02-01 01:19:25.000000', 'consum', 0.0218, 'lps'),
	(518064, 128, '2014-02-01 01:19:26.000000', 'consum', 0.0211, 'lps'),
	(518065, 128, '2014-02-01 01:19:27.000000', 'consum', 0.0219, 'lps'),
	(518066, 128, '2014-02-01 01:19:28.000000', 'consum', 0.0212, 'lps'),
	(518067, 128, '2014-02-01 01:19:29.000000', 'consum', 0.0221, 'lps'),
	(518068, 128, '2014-02-01 01:19:30.000000', 'consum', 0.0217, 'lps'),
	(518069, 128, '2014-02-01 01:19:31.000000', 'consum', 0.0214, 'lps'),
	(518070, 128, '2014-02-01 01:19:32.000000', 'consum', 0.0222, 'lps'),
	(518071, 128, '2014-02-01 01:19:33.000000', 'consum', 0.0217, 'lps'),
	(518072, 128, '2014-02-01 01:19:34.000000', 'consum', 0.0222, 'lps'),
	(518073, 128, '2014-02-01 01:19:35.000000', 'consum', 0.0223, 'lps'),
	(518074, 128, '2014-02-01 01:19:36.000000', 'consum', 0.0212, 'lps'),
	(518075, 128, '2014-02-01 01:19:37.000000', 'consum', 0.0222, 'lps'),
	(518076, 128, '2014-02-01 01:19:38.000000', 'consum', 0.0211, 'lps'),
	(518077, 128, '2014-02-01 01:19:39.000000', 'consum', 0.0218, 'lps'),
	(518078, 128, '2014-02-01 01:19:40.000000', 'consum', 0.0223, 'lps'),
	(518079, 128, '2014-02-01 01:19:41.000000', 'consum', 0.0221, 'lps'),
	(518080, 128, '2014-02-01 01:19:42.000000', 'consum', 0.0211, 'lps'),
	(518081, 128, '2014-02-01 01:19:43.000000', 'consum', 0.0214, 'lps'),
	(518082, 128, '2014-02-01 01:19:44.000000', 'consum', 0.0212, 'lps'),
	(518083, 128, '2014-02-01 01:19:45.000000', 'consum', 0.0210, 'lps'),
	(518084, 128, '2014-02-01 01:19:46.000000', 'consum', 0.0218, 'lps'),
	(518085, 128, '2014-02-01 01:19:47.000000', 'consum', 0.0222, 'lps'),
	(518086, 128, '2014-02-01 01:19:48.000000', 'consum', 0.0217, 'lps'),
	(518087, 128, '2014-02-01 01:19:49.000000', 'consum', 0.0211, 'lps'),
	(518088, 128, '2014-02-01 01:19:50.000000', 'consum', 0.0222, 'lps'),
	(518089, 128, '2014-02-01 01:19:51.000000', 'consum', 0.0211, 'lps'),
	(518090, 128, '2014-02-01 01:19:52.000000', 'consum', 0.0222, 'lps'),
	(518091, 128, '2014-02-01 01:19:53.000000', 'consum', 0.0211, 'lps'),
	(518092, 128, '2014-02-01 01:19:54.000000', 'consum', 0.0210, 'lps'),
	(518093, 128, '2014-02-01 01:19:55.000000', 'consum', 0.0219, 'lps'),
	(518094, 128, '2014-02-01 01:19:56.000000', 'consum', 0.0215, 'lps'),
	(518095, 128, '2014-02-01 01:19:57.000000', 'consum', 0.0222, 'lps'),
	(518096, 128, '2014-02-01 01:19:58.000000', 'consum', 0.0213, 'lps'),
	(518097, 128, '2014-02-01 01:19:59.000000', 'consum', 0.0218, 'lps'),
	(518098, 128, '2014-02-01 01:20:00.000000', 'consum', 0.0213, 'lps'),
	(518099, 128, '2014-02-01 01:20:01.000000', 'consum', 0.0216, 'lps'),
	(518100, 128, '2014-02-01 01:20:02.000000', 'consum', 0.0218, 'lps'),
	(518101, 128, '2014-02-01 01:20:03.000000', 'consum', 0.0219, 'lps'),
	(518102, 128, '2014-02-01 01:20:04.000000', 'consum', 0.0218, 'lps'),
	(518103, 128, '2014-02-01 01:20:05.000000', 'consum', 0.0221, 'lps'),
	(518104, 128, '2014-02-01 01:20:06.000000', 'consum', 0.0215, 'lps'),
	(518105, 128, '2014-02-01 01:20:07.000000', 'consum', 0.0214, 'lps'),
	(518106, 128, '2014-02-01 01:20:08.000000', 'consum', 0.0219, 'lps'),
	(518107, 128, '2014-02-01 01:20:09.000000', 'consum', 0.0214, 'lps'),
	(518108, 128, '2014-02-01 01:20:10.000000', 'consum', 0.0219, 'lps'),
	(518109, 128, '2014-02-01 01:20:11.000000', 'consum', 0.0212, 'lps'),
	(518110, 128, '2014-02-01 01:20:12.000000', 'consum', 0.0211, 'lps'),
	(518111, 128, '2014-02-01 01:20:13.000000', 'consum', 0.0223, 'lps'),
	(518112, 128, '2014-02-01 01:20:14.000000', 'consum', 0.0214, 'lps'),
	(518113, 128, '2014-02-01 01:20:15.000000', 'consum', 0.0222, 'lps'),
	(518114, 128, '2014-02-01 01:20:16.000000', 'consum', 0.0217, 'lps'),
	(518115, 128, '2014-02-01 01:20:17.000000', 'consum', 0.0222, 'lps'),
	(518116, 128, '2014-02-01 01:20:18.000000', 'consum', 0.0222, 'lps'),
	(518117, 128, '2014-02-01 01:20:19.000000', 'consum', 0.0219, 'lps'),
	(518118, 128, '2014-02-01 01:20:20.000000', 'consum', 0.0222, 'lps'),
	(518119, 128, '2014-02-01 01:20:21.000000', 'consum', 0.0213, 'lps'),
	(518120, 128, '2014-02-01 01:20:22.000000', 'consum', 0.0219, 'lps'),
	(518121, 128, '2014-02-01 01:20:23.000000', 'consum', 0.0220, 'lps'),
	(518122, 128, '2014-02-01 01:20:24.000000', 'consum', 0.0219, 'lps'),
	(518123, 128, '2014-02-01 01:20:25.000000', 'consum', 0.0210, 'lps'),
	(518124, 128, '2014-02-01 01:20:26.000000', 'consum', 0.0213, 'lps'),
	(518125, 128, '2014-02-01 01:20:27.000000', 'consum', 0.0211, 'lps'),
	(518126, 128, '2014-02-01 01:20:28.000000', 'consum', 0.0220, 'lps'),
	(518127, 128, '2014-02-01 01:20:29.000000', 'consum', 0.0215, 'lps'),
	(518128, 128, '2014-02-01 01:20:30.000000', 'consum', 0.0221, 'lps'),
	(518129, 128, '2014-02-01 01:20:31.000000', 'consum', 0.0221, 'lps'),
	(518130, 128, '2014-02-01 01:20:32.000000', 'consum', 0.0220, 'lps'),
	(518131, 128, '2014-02-01 01:20:33.000000', 'consum', 0.0214, 'lps'),
	(518132, 128, '2014-02-01 01:20:34.000000', 'consum', 0.0216, 'lps'),
	(518133, 128, '2014-02-01 01:20:35.000000', 'consum', 0.0212, 'lps'),
	(518134, 128, '2014-02-01 01:20:36.000000', 'consum', 0.0215, 'lps'),
	(518135, 128, '2014-02-01 01:20:37.000000', 'consum', 0.0218, 'lps'),
	(518136, 128, '2014-02-01 01:20:38.000000', 'consum', 0.0223, 'lps'),
	(518137, 128, '2014-02-01 01:20:39.000000', 'consum', 0.0220, 'lps'),
	(518138, 128, '2014-02-01 01:20:40.000000', 'consum', 0.0223, 'lps'),
	(518139, 128, '2014-02-01 01:20:41.000000', 'consum', 0.0216, 'lps'),
	(518140, 128, '2014-02-01 01:20:42.000000', 'consum', 0.0216, 'lps'),
	(518141, 128, '2014-02-01 01:20:43.000000', 'consum', 0.0221, 'lps'),
	(518142, 128, '2014-02-01 01:20:44.000000', 'consum', 0.0220, 'lps'),
	(518143, 128, '2014-02-01 01:20:45.000000', 'consum', 0.0212, 'lps'),
	(518144, 128, '2014-02-01 01:20:46.000000', 'consum', 0.0222, 'lps'),
	(518145, 128, '2014-02-01 01:20:47.000000', 'consum', 0.0221, 'lps'),
	(518146, 128, '2014-02-01 01:20:48.000000', 'consum', 0.0213, 'lps'),
	(518147, 128, '2014-02-01 01:20:49.000000', 'consum', 0.0210, 'lps'),
	(518148, 128, '2014-02-01 01:20:50.000000', 'consum', 0.0216, 'lps'),
	(518149, 128, '2014-02-01 01:20:51.000000', 'consum', 0.0210, 'lps'),
	(518150, 128, '2014-02-01 01:20:52.000000', 'consum', 0.0222, 'lps'),
	(518151, 128, '2014-02-01 01:20:53.000000', 'consum', 0.0216, 'lps'),
	(518152, 128, '2014-02-01 01:20:54.000000', 'consum', 0.0216, 'lps'),
	(518153, 128, '2014-02-01 01:20:55.000000', 'consum', 0.0211, 'lps'),
	(518154, 128, '2014-02-01 01:20:56.000000', 'consum', 0.0211, 'lps'),
	(518155, 128, '2014-02-01 01:20:57.000000', 'consum', 0.0213, 'lps'),
	(518156, 128, '2014-02-01 01:20:58.000000', 'consum', 0.0222, 'lps'),
	(518157, 128, '2014-02-01 01:20:59.000000', 'consum', 0.0220, 'lps'),
	(518158, 128, '2014-02-01 01:21:00.000000', 'consum', 0.0210, 'lps'),
	(518159, 128, '2014-02-01 01:21:01.000000', 'consum', 0.0223, 'lps'),
	(518160, 128, '2014-02-01 01:21:02.000000', 'consum', 0.0219, 'lps'),
	(518161, 128, '2014-02-01 01:21:03.000000', 'consum', 0.0217, 'lps'),
	(518162, 128, '2014-02-01 01:21:04.000000', 'consum', 0.0218, 'lps'),
	(518163, 128, '2014-02-01 01:21:05.000000', 'consum', 0.0214, 'lps'),
	(518164, 128, '2014-02-01 01:21:06.000000', 'consum', 0.0222, 'lps'),
	(518165, 128, '2014-02-01 01:21:07.000000', 'consum', 0.0218, 'lps'),
	(518166, 128, '2014-02-01 01:21:08.000000', 'consum', 0.0212, 'lps'),
	(518167, 128, '2014-02-01 01:21:09.000000', 'consum', 0.0211, 'lps'),
	(518168, 128, '2014-02-01 01:21:10.000000', 'consum', 0.0211, 'lps'),
	(518169, 128, '2014-02-01 01:21:11.000000', 'consum', 0.0214, 'lps'),
	(518170, 128, '2014-02-01 01:21:12.000000', 'consum', 0.0210, 'lps'),
	(518171, 128, '2014-02-01 01:21:13.000000', 'consum', 0.0215, 'lps'),
	(518172, 128, '2014-02-01 01:21:14.000000', 'consum', 0.0222, 'lps'),
	(518173, 128, '2014-02-01 01:21:15.000000', 'consum', 0.0214, 'lps'),
	(518174, 128, '2014-02-01 01:21:16.000000', 'consum', 0.0222, 'lps'),
	(518175, 128, '2014-02-01 01:21:17.000000', 'consum', 0.0215, 'lps'),
	(518176, 128, '2014-02-01 01:21:18.000000', 'consum', 0.0215, 'lps'),
	(518177, 128, '2014-02-01 01:21:19.000000', 'consum', 0.0219, 'lps'),
	(518178, 128, '2014-02-01 01:21:20.000000', 'consum', 0.0213, 'lps'),
	(518179, 128, '2014-02-01 01:21:21.000000', 'consum', 0.0212, 'lps'),
	(518180, 128, '2014-02-01 01:21:22.000000', 'consum', 0.0214, 'lps'),
	(518181, 128, '2014-02-01 01:21:23.000000', 'consum', 0.0222, 'lps'),
	(518182, 128, '2014-02-01 01:21:24.000000', 'consum', 0.0218, 'lps'),
	(518183, 128, '2014-02-01 01:21:25.000000', 'consum', 0.0214, 'lps'),
	(518184, 128, '2014-02-01 01:21:26.000000', 'consum', 0.0221, 'lps'),
	(518185, 128, '2014-02-01 01:21:27.000000', 'consum', 0.0223, 'lps'),
	(518186, 128, '2014-02-01 01:21:28.000000', 'consum', 0.0216, 'lps'),
	(518187, 128, '2014-02-01 01:21:29.000000', 'consum', 0.0215, 'lps'),
	(518188, 128, '2014-02-01 01:21:30.000000', 'consum', 0.0219, 'lps'),
	(518189, 128, '2014-02-01 01:21:31.000000', 'consum', 0.0211, 'lps'),
	(518190, 128, '2014-02-01 01:21:32.000000', 'consum', 0.0217, 'lps'),
	(518191, 128, '2014-02-01 01:21:33.000000', 'consum', 0.0214, 'lps'),
	(518192, 128, '2014-02-01 01:21:34.000000', 'consum', 0.0223, 'lps'),
	(518193, 128, '2014-02-01 01:21:35.000000', 'consum', 0.0223, 'lps'),
	(518194, 128, '2014-02-01 01:21:36.000000', 'consum', 0.0220, 'lps'),
	(518195, 128, '2014-02-01 01:21:37.000000', 'consum', 0.0223, 'lps'),
	(518196, 128, '2014-02-01 01:21:38.000000', 'consum', 0.0218, 'lps'),
	(518197, 128, '2014-02-01 01:21:39.000000', 'consum', 0.0211, 'lps'),
	(518198, 128, '2014-02-01 01:21:40.000000', 'consum', 0.0219, 'lps'),
	(518199, 128, '2014-02-01 01:21:41.000000', 'consum', 0.0211, 'lps'),
	(518200, 128, '2014-02-01 01:21:42.000000', 'consum', 0.0215, 'lps'),
	(518201, 128, '2014-02-01 01:21:43.000000', 'consum', 0.0219, 'lps'),
	(518202, 128, '2014-02-01 01:21:44.000000', 'consum', 0.0214, 'lps'),
	(518203, 128, '2014-02-01 01:21:45.000000', 'consum', 0.0216, 'lps'),
	(518204, 128, '2014-02-01 01:21:46.000000', 'consum', 0.0214, 'lps'),
	(518205, 128, '2014-02-01 01:21:47.000000', 'consum', 0.0215, 'lps'),
	(518206, 128, '2014-02-01 01:21:48.000000', 'consum', 0.0221, 'lps'),
	(518207, 128, '2014-02-01 01:21:49.000000', 'consum', 0.0221, 'lps'),
	(518208, 128, '2014-02-01 01:21:50.000000', 'consum', 0.0222, 'lps'),
	(518209, 128, '2014-02-01 01:21:51.000000', 'consum', 0.0223, 'lps'),
	(518210, 128, '2014-02-01 01:21:52.000000', 'consum', 0.0211, 'lps'),
	(518211, 128, '2014-02-01 01:21:53.000000', 'consum', 0.0221, 'lps'),
	(518212, 128, '2014-02-01 01:21:54.000000', 'consum', 0.0217, 'lps'),
	(518213, 128, '2014-02-01 01:21:55.000000', 'consum', 0.0213, 'lps'),
	(518214, 128, '2014-02-01 01:21:56.000000', 'consum', 0.0219, 'lps'),
	(518215, 128, '2014-02-01 01:21:57.000000', 'consum', 0.0219, 'lps'),
	(518216, 128, '2014-02-01 01:21:58.000000', 'consum', 0.0216, 'lps'),
	(518217, 128, '2014-02-01 01:21:59.000000', 'consum', 0.0211, 'lps'),
	(518218, 128, '2014-02-01 01:22:00.000000', 'consum', 0.0212, 'lps'),
	(518219, 128, '2014-02-01 01:22:01.000000', 'consum', 0.0216, 'lps'),
	(518220, 128, '2014-02-01 01:22:02.000000', 'consum', 0.0221, 'lps'),
	(518221, 128, '2014-02-01 01:22:03.000000', 'consum', 0.0218, 'lps'),
	(518222, 128, '2014-02-01 01:22:04.000000', 'consum', 0.0221, 'lps'),
	(518223, 128, '2014-02-01 01:22:05.000000', 'consum', 0.0210, 'lps'),
	(518224, 128, '2014-02-01 01:22:06.000000', 'consum', 0.0222, 'lps'),
	(518225, 128, '2014-02-01 01:22:07.000000', 'consum', 0.0214, 'lps'),
	(518226, 128, '2014-02-01 01:22:08.000000', 'consum', 0.0223, 'lps'),
	(518227, 128, '2014-02-01 01:22:09.000000', 'consum', 0.0221, 'lps'),
	(518228, 128, '2014-02-01 01:22:10.000000', 'consum', 0.0212, 'lps'),
	(518229, 128, '2014-02-01 01:22:11.000000', 'consum', 0.0218, 'lps'),
	(518230, 128, '2014-02-01 01:22:12.000000', 'consum', 0.0215, 'lps'),
	(518231, 128, '2014-02-01 01:22:13.000000', 'consum', 0.0211, 'lps'),
	(518232, 128, '2014-02-01 01:22:14.000000', 'consum', 0.0216, 'lps'),
	(518233, 128, '2014-02-01 01:22:15.000000', 'consum', 0.0221, 'lps'),
	(518234, 128, '2014-02-01 01:22:16.000000', 'consum', 0.0220, 'lps'),
	(518235, 128, '2014-02-01 01:22:17.000000', 'consum', 0.0215, 'lps'),
	(518236, 128, '2014-02-01 01:22:18.000000', 'consum', 0.0218, 'lps'),
	(518237, 128, '2014-02-01 01:22:19.000000', 'consum', 0.0221, 'lps'),
	(518238, 128, '2014-02-01 01:22:20.000000', 'consum', 0.0215, 'lps'),
	(518239, 128, '2014-02-01 01:22:21.000000', 'consum', 0.0214, 'lps'),
	(518240, 128, '2014-02-01 01:22:22.000000', 'consum', 0.0218, 'lps'),
	(518241, 128, '2014-02-01 01:22:23.000000', 'consum', 0.0210, 'lps'),
	(518242, 128, '2014-02-01 01:22:24.000000', 'consum', 0.0216, 'lps'),
	(518243, 128, '2014-02-01 01:22:25.000000', 'consum', 0.0211, 'lps'),
	(518244, 128, '2014-02-01 01:22:26.000000', 'consum', 0.0210, 'lps'),
	(518245, 128, '2014-02-01 01:22:27.000000', 'consum', 0.0223, 'lps'),
	(518246, 128, '2014-02-01 01:22:28.000000', 'consum', 0.0220, 'lps'),
	(518247, 128, '2014-02-01 01:22:29.000000', 'consum', 0.0222, 'lps'),
	(518248, 128, '2014-02-01 01:22:30.000000', 'consum', 0.0211, 'lps'),
	(518249, 128, '2014-02-01 01:22:31.000000', 'consum', 0.0221, 'lps'),
	(518250, 128, '2014-02-01 01:22:32.000000', 'consum', 0.0220, 'lps'),
	(518251, 128, '2014-02-01 01:22:33.000000', 'consum', 0.0213, 'lps'),
	(518252, 128, '2014-02-01 01:22:34.000000', 'consum', 0.0213, 'lps'),
	(518253, 128, '2014-02-01 01:22:35.000000', 'consum', 0.0213, 'lps'),
	(518254, 128, '2014-02-01 01:22:36.000000', 'consum', 0.0217, 'lps'),
	(518255, 128, '2014-02-01 01:22:37.000000', 'consum', 0.0222, 'lps'),
	(518256, 128, '2014-02-01 01:22:38.000000', 'consum', 0.0223, 'lps'),
	(518257, 128, '2014-02-01 01:22:39.000000', 'consum', 0.0211, 'lps'),
	(518258, 128, '2014-02-01 01:22:40.000000', 'consum', 0.0218, 'lps'),
	(518259, 128, '2014-02-01 01:22:41.000000', 'consum', 0.0220, 'lps'),
	(518260, 128, '2014-02-01 01:22:42.000000', 'consum', 0.0223, 'lps'),
	(518261, 128, '2014-02-01 01:22:43.000000', 'consum', 0.0216, 'lps'),
	(518262, 128, '2014-02-01 01:22:44.000000', 'consum', 0.0217, 'lps'),
	(518263, 128, '2014-02-01 01:22:45.000000', 'consum', 0.0213, 'lps'),
	(518264, 128, '2014-02-01 01:22:46.000000', 'consum', 0.0218, 'lps'),
	(518265, 128, '2014-02-01 01:22:47.000000', 'consum', 0.0213, 'lps'),
	(518266, 128, '2014-02-01 01:22:48.000000', 'consum', 0.0215, 'lps'),
	(518267, 128, '2014-02-01 01:22:49.000000', 'consum', 0.0212, 'lps'),
	(518268, 128, '2014-02-01 01:22:50.000000', 'consum', 0.0221, 'lps'),
	(518269, 128, '2014-02-01 01:22:51.000000', 'consum', 0.0219, 'lps'),
	(518270, 128, '2014-02-01 01:22:52.000000', 'consum', 0.0221, 'lps'),
	(518271, 128, '2014-02-01 01:22:53.000000', 'consum', 0.0210, 'lps'),
	(518272, 128, '2014-02-01 01:22:54.000000', 'consum', 0.0221, 'lps'),
	(518273, 128, '2014-02-01 01:22:55.000000', 'consum', 0.0223, 'lps'),
	(518274, 128, '2014-02-01 01:22:56.000000', 'consum', 0.0214, 'lps'),
	(518275, 128, '2014-02-01 01:22:57.000000', 'consum', 0.0220, 'lps'),
	(518276, 128, '2014-02-01 01:22:58.000000', 'consum', 0.0220, 'lps'),
	(518277, 128, '2014-02-01 01:22:59.000000', 'consum', 0.0218, 'lps'),
	(518278, 128, '2014-02-01 01:23:00.000000', 'consum', 0.0221, 'lps'),
	(518279, 128, '2014-02-01 01:23:01.000000', 'consum', 0.0212, 'lps'),
	(518280, 128, '2014-02-01 01:23:02.000000', 'consum', 0.0217, 'lps'),
	(518281, 128, '2014-02-01 01:23:03.000000', 'consum', 0.0211, 'lps'),
	(518282, 128, '2014-02-01 01:23:04.000000', 'consum', 0.0210, 'lps'),
	(518283, 128, '2014-02-01 01:23:05.000000', 'consum', 0.0221, 'lps'),
	(518284, 128, '2014-02-01 01:23:06.000000', 'consum', 0.0222, 'lps'),
	(518285, 128, '2014-02-01 01:23:07.000000', 'consum', 0.0222, 'lps'),
	(518286, 128, '2014-02-01 01:23:08.000000', 'consum', 0.0222, 'lps'),
	(518287, 128, '2014-02-01 01:23:09.000000', 'consum', 0.0222, 'lps'),
	(518288, 128, '2014-02-01 01:23:10.000000', 'consum', 0.0221, 'lps'),
	(518289, 128, '2014-02-01 01:23:11.000000', 'consum', 0.0214, 'lps'),
	(518290, 128, '2014-02-01 01:23:12.000000', 'consum', 0.0211, 'lps'),
	(518291, 128, '2014-02-01 01:23:13.000000', 'consum', 0.0218, 'lps'),
	(518292, 128, '2014-02-01 01:23:14.000000', 'consum', 0.0219, 'lps'),
	(518293, 128, '2014-02-01 01:23:15.000000', 'consum', 0.0219, 'lps'),
	(518294, 128, '2014-02-01 01:23:16.000000', 'consum', 0.0214, 'lps'),
	(518295, 128, '2014-02-01 01:23:17.000000', 'consum', 0.0215, 'lps'),
	(518296, 128, '2014-02-01 01:23:18.000000', 'consum', 0.0212, 'lps'),
	(518297, 128, '2014-02-01 01:23:19.000000', 'consum', 0.0218, 'lps'),
	(518298, 128, '2014-02-01 01:23:20.000000', 'consum', 0.0219, 'lps'),
	(518299, 128, '2014-02-01 01:23:21.000000', 'consum', 0.0217, 'lps'),
	(518300, 128, '2014-02-01 01:23:22.000000', 'consum', 0.0219, 'lps'),
	(518301, 128, '2014-02-01 01:23:23.000000', 'consum', 0.0220, 'lps'),
	(518302, 128, '2014-02-01 01:23:24.000000', 'consum', 0.0221, 'lps'),
	(518303, 128, '2014-02-01 01:23:25.000000', 'consum', 0.0220, 'lps'),
	(518304, 128, '2014-02-01 01:23:26.000000', 'consum', 0.0212, 'lps'),
	(518305, 128, '2014-02-01 01:23:27.000000', 'consum', 0.0220, 'lps'),
	(518306, 128, '2014-02-01 01:23:28.000000', 'consum', 0.0214, 'lps'),
	(518307, 128, '2014-02-01 01:23:29.000000', 'consum', 0.0214, 'lps'),
	(518308, 128, '2014-02-01 01:23:30.000000', 'consum', 0.0218, 'lps'),
	(518309, 128, '2014-02-01 01:23:31.000000', 'consum', 0.0212, 'lps'),
	(518310, 128, '2014-02-01 01:23:32.000000', 'consum', 0.0223, 'lps'),
	(518311, 128, '2014-02-01 01:23:33.000000', 'consum', 0.0216, 'lps'),
	(518312, 128, '2014-02-01 01:23:34.000000', 'consum', 0.0212, 'lps'),
	(518313, 128, '2014-02-01 01:23:35.000000', 'consum', 0.0219, 'lps'),
	(518314, 128, '2014-02-01 01:23:36.000000', 'consum', 0.0220, 'lps'),
	(518315, 128, '2014-02-01 01:23:37.000000', 'consum', 0.0219, 'lps'),
	(518316, 128, '2014-02-01 01:23:38.000000', 'consum', 0.0213, 'lps'),
	(518317, 128, '2014-02-01 01:23:39.000000', 'consum', 0.0214, 'lps'),
	(518318, 128, '2014-02-01 01:23:40.000000', 'consum', 0.0220, 'lps'),
	(518319, 128, '2014-02-01 01:23:41.000000', 'consum', 0.0219, 'lps'),
	(518320, 128, '2014-02-01 01:23:42.000000', 'consum', 0.0214, 'lps'),
	(518321, 128, '2014-02-01 01:23:43.000000', 'consum', 0.0214, 'lps'),
	(518322, 128, '2014-02-01 01:23:44.000000', 'consum', 0.0222, 'lps'),
	(518323, 128, '2014-02-01 01:23:45.000000', 'consum', 0.0216, 'lps'),
	(518324, 128, '2014-02-01 01:23:46.000000', 'consum', 0.0219, 'lps'),
	(518325, 128, '2014-02-01 01:23:47.000000', 'consum', 0.0211, 'lps'),
	(518326, 128, '2014-02-01 01:23:48.000000', 'consum', 0.0214, 'lps'),
	(518327, 128, '2014-02-01 01:23:49.000000', 'consum', 0.0216, 'lps'),
	(518328, 128, '2014-02-01 01:23:50.000000', 'consum', 0.0214, 'lps'),
	(518329, 128, '2014-02-01 01:23:51.000000', 'consum', 0.0210, 'lps'),
	(518330, 128, '2014-02-01 01:23:52.000000', 'consum', 0.0215, 'lps'),
	(518331, 128, '2014-02-01 01:23:53.000000', 'consum', 0.0220, 'lps'),
	(518332, 128, '2014-02-01 01:23:54.000000', 'consum', 0.0217, 'lps'),
	(518333, 128, '2014-02-01 01:23:55.000000', 'consum', 0.0218, 'lps'),
	(518334, 128, '2014-02-01 01:23:56.000000', 'consum', 0.0213, 'lps'),
	(518335, 128, '2014-02-01 01:23:57.000000', 'consum', 0.0216, 'lps'),
	(518336, 128, '2014-02-01 01:23:58.000000', 'consum', 0.0216, 'lps'),
	(518337, 128, '2014-02-01 01:23:59.000000', 'consum', 0.0211, 'lps'),
	(518338, 128, '2014-02-01 01:24:00.000000', 'consum', 0.0223, 'lps'),
	(518339, 128, '2014-02-01 01:24:01.000000', 'consum', 0.0216, 'lps'),
	(518340, 128, '2014-02-01 01:24:02.000000', 'consum', 0.0217, 'lps'),
	(518341, 128, '2014-02-01 01:24:03.000000', 'consum', 0.0212, 'lps'),
	(518342, 128, '2014-02-01 01:24:04.000000', 'consum', 0.0216, 'lps'),
	(518343, 128, '2014-02-01 01:24:05.000000', 'consum', 0.0221, 'lps'),
	(518344, 128, '2014-02-01 01:24:06.000000', 'consum', 0.0217, 'lps'),
	(518345, 128, '2014-02-01 01:24:07.000000', 'consum', 0.0214, 'lps'),
	(518346, 128, '2014-02-01 01:24:08.000000', 'consum', 0.0222, 'lps'),
	(518347, 128, '2014-02-01 01:24:09.000000', 'consum', 0.0219, 'lps'),
	(518348, 128, '2014-02-01 01:24:10.000000', 'consum', 0.0220, 'lps'),
	(518349, 128, '2014-02-01 01:24:11.000000', 'consum', 0.0218, 'lps'),
	(518350, 128, '2014-02-01 01:24:12.000000', 'consum', 0.0219, 'lps'),
	(518351, 128, '2014-02-01 01:24:13.000000', 'consum', 0.0221, 'lps'),
	(518352, 128, '2014-02-01 01:24:14.000000', 'consum', 0.0221, 'lps'),
	(518353, 128, '2014-02-01 01:24:15.000000', 'consum', 0.0220, 'lps'),
	(518354, 128, '2014-02-01 01:24:16.000000', 'consum', 0.0212, 'lps'),
	(518355, 128, '2014-02-01 01:24:17.000000', 'consum', 0.0220, 'lps'),
	(518356, 128, '2014-02-01 01:24:18.000000', 'consum', 0.0211, 'lps'),
	(518357, 128, '2014-02-01 01:24:19.000000', 'consum', 0.0214, 'lps'),
	(518358, 128, '2014-02-01 01:24:20.000000', 'consum', 0.0215, 'lps'),
	(518359, 128, '2014-02-01 01:24:21.000000', 'consum', 0.0210, 'lps'),
	(518360, 128, '2014-02-01 01:24:22.000000', 'consum', 0.0223, 'lps'),
	(518361, 128, '2014-02-01 01:24:23.000000', 'consum', 0.0219, 'lps'),
	(518362, 128, '2014-02-01 01:24:24.000000', 'consum', 0.0215, 'lps'),
	(518363, 128, '2014-02-01 01:24:25.000000', 'consum', 0.0211, 'lps'),
	(518364, 128, '2014-02-01 01:24:26.000000', 'consum', 0.0215, 'lps'),
	(518365, 128, '2014-02-01 01:24:27.000000', 'consum', 0.0219, 'lps'),
	(518366, 128, '2014-02-01 01:24:28.000000', 'consum', 0.0211, 'lps'),
	(518367, 128, '2014-02-01 01:24:29.000000', 'consum', 0.0218, 'lps'),
	(518368, 128, '2014-02-01 01:24:30.000000', 'consum', 0.0218, 'lps'),
	(518369, 128, '2014-02-01 01:24:31.000000', 'consum', 0.0215, 'lps'),
	(518370, 128, '2014-02-01 01:24:32.000000', 'consum', 0.0223, 'lps'),
	(518371, 128, '2014-02-01 01:24:33.000000', 'consum', 0.0220, 'lps'),
	(518372, 128, '2014-02-01 01:24:34.000000', 'consum', 0.0219, 'lps'),
	(518373, 128, '2014-02-01 01:24:35.000000', 'consum', 0.0214, 'lps'),
	(518374, 128, '2014-02-01 01:24:36.000000', 'consum', 0.0215, 'lps'),
	(518375, 128, '2014-02-01 01:24:37.000000', 'consum', 0.0210, 'lps'),
	(518376, 128, '2014-02-01 01:24:38.000000', 'consum', 0.0210, 'lps'),
	(518377, 128, '2014-02-01 01:24:39.000000', 'consum', 0.0210, 'lps'),
	(518378, 128, '2014-02-01 01:24:40.000000', 'consum', 0.0211, 'lps'),
	(518379, 128, '2014-02-01 01:24:41.000000', 'consum', 0.0215, 'lps'),
	(518380, 128, '2014-02-01 01:24:42.000000', 'consum', 0.0220, 'lps'),
	(518381, 128, '2014-02-01 01:24:43.000000', 'consum', 0.0217, 'lps'),
	(518382, 128, '2014-02-01 01:24:44.000000', 'consum', 0.0217, 'lps'),
	(518383, 128, '2014-02-01 01:24:45.000000', 'consum', 0.0221, 'lps'),
	(518384, 128, '2014-02-01 01:24:46.000000', 'consum', 0.0219, 'lps'),
	(518385, 128, '2014-02-01 01:24:47.000000', 'consum', 0.0210, 'lps'),
	(518386, 128, '2014-02-01 01:24:48.000000', 'consum', 0.0222, 'lps'),
	(518387, 128, '2014-02-01 01:24:49.000000', 'consum', 0.0216, 'lps'),
	(518388, 128, '2014-02-01 01:24:50.000000', 'consum', 0.0217, 'lps'),
	(518389, 128, '2014-02-01 01:24:51.000000', 'consum', 0.0213, 'lps'),
	(518390, 128, '2014-02-01 01:24:52.000000', 'consum', 0.0218, 'lps'),
	(518391, 128, '2014-02-01 01:24:53.000000', 'consum', 0.0214, 'lps'),
	(518392, 128, '2014-02-01 01:24:54.000000', 'consum', 0.0220, 'lps'),
	(518393, 128, '2014-02-01 01:24:55.000000', 'consum', 0.0219, 'lps'),
	(518394, 128, '2014-02-01 01:24:56.000000', 'consum', 0.0215, 'lps'),
	(518395, 128, '2014-02-01 01:24:57.000000', 'consum', 0.0219, 'lps'),
	(518396, 128, '2014-02-01 01:24:58.000000', 'consum', 0.0215, 'lps'),
	(518397, 128, '2014-02-01 01:24:59.000000', 'consum', 0.0210, 'lps'),
	(518398, 128, '2014-02-01 01:25:00.000000', 'consum', 0.0221, 'lps'),
	(518399, 128, '2014-02-01 01:25:01.000000', 'consum', 0.0212, 'lps'),
	(518400, 128, '2014-02-01 01:25:02.000000', 'consum', 0.0213, 'lps'),
	(518401, 128, '2014-02-01 01:25:03.000000', 'consum', 0.0222, 'lps'),
	(518402, 128, '2014-02-01 01:25:04.000000', 'consum', 0.0218, 'lps'),
	(518403, 128, '2014-02-01 01:25:05.000000', 'consum', 0.0213, 'lps'),
	(518404, 128, '2014-02-01 01:25:06.000000', 'consum', 0.0216, 'lps'),
	(518405, 128, '2014-02-01 01:25:07.000000', 'consum', 0.0218, 'lps'),
	(518406, 128, '2014-02-01 01:25:08.000000', 'consum', 0.0217, 'lps'),
	(518407, 128, '2014-02-01 01:25:09.000000', 'consum', 0.0221, 'lps'),
	(518408, 128, '2014-02-01 01:25:10.000000', 'consum', 0.0216, 'lps'),
	(518409, 128, '2014-02-01 01:25:11.000000', 'consum', 0.0221, 'lps'),
	(518410, 128, '2014-02-01 01:25:12.000000', 'consum', 0.0220, 'lps'),
	(518411, 128, '2014-02-01 01:25:13.000000', 'consum', 0.0214, 'lps'),
	(518412, 128, '2014-02-01 01:25:14.000000', 'consum', 0.0212, 'lps'),
	(518413, 128, '2014-02-01 01:25:15.000000', 'consum', 0.0212, 'lps'),
	(518414, 128, '2014-02-01 01:25:16.000000', 'consum', 0.0213, 'lps'),
	(518415, 128, '2014-02-01 01:25:17.000000', 'consum', 0.0221, 'lps'),
	(518416, 128, '2014-02-01 01:25:18.000000', 'consum', 0.0212, 'lps'),
	(518417, 128, '2014-02-01 01:25:19.000000', 'consum', 0.0216, 'lps'),
	(518418, 128, '2014-02-01 01:25:20.000000', 'consum', 0.0219, 'lps'),
	(518419, 128, '2014-02-01 01:25:21.000000', 'consum', 0.0212, 'lps'),
	(518420, 128, '2014-02-01 01:25:22.000000', 'consum', 0.0221, 'lps'),
	(518421, 128, '2014-02-01 01:25:23.000000', 'consum', 0.0217, 'lps'),
	(518422, 128, '2014-02-01 01:25:24.000000', 'consum', 0.0212, 'lps'),
	(518423, 128, '2014-02-01 01:25:25.000000', 'consum', 0.0212, 'lps'),
	(518424, 128, '2014-02-01 01:25:26.000000', 'consum', 0.0216, 'lps'),
	(518425, 128, '2014-02-01 01:25:27.000000', 'consum', 0.0221, 'lps'),
	(518426, 128, '2014-02-01 01:25:28.000000', 'consum', 0.0219, 'lps'),
	(518427, 128, '2014-02-01 01:25:29.000000', 'consum', 0.0210, 'lps'),
	(518428, 128, '2014-02-01 01:25:30.000000', 'consum', 0.0223, 'lps'),
	(518429, 128, '2014-02-01 01:25:31.000000', 'consum', 0.0221, 'lps'),
	(518430, 128, '2014-02-01 01:25:32.000000', 'consum', 0.0213, 'lps'),
	(518431, 128, '2014-02-01 01:25:33.000000', 'consum', 0.0222, 'lps'),
	(518432, 128, '2014-02-01 01:25:34.000000', 'consum', 0.0216, 'lps'),
	(518433, 128, '2014-02-01 01:25:35.000000', 'consum', 0.0222, 'lps'),
	(518434, 128, '2014-02-01 01:25:36.000000', 'consum', 0.0223, 'lps'),
	(518435, 128, '2014-02-01 01:25:37.000000', 'consum', 0.0210, 'lps'),
	(518436, 128, '2014-02-01 01:25:38.000000', 'consum', 0.0216, 'lps'),
	(518437, 128, '2014-02-01 01:25:39.000000', 'consum', 0.0212, 'lps'),
	(518438, 128, '2014-02-01 01:25:40.000000', 'consum', 0.0215, 'lps'),
	(518439, 128, '2014-02-01 01:25:41.000000', 'consum', 0.0218, 'lps'),
	(518440, 128, '2014-02-01 01:25:42.000000', 'consum', 0.0218, 'lps'),
	(518441, 128, '2014-02-01 01:25:43.000000', 'consum', 0.0216, 'lps'),
	(518442, 128, '2014-02-01 01:25:44.000000', 'consum', 0.0215, 'lps'),
	(518443, 128, '2014-02-01 01:25:45.000000', 'consum', 0.0218, 'lps'),
	(518444, 128, '2014-02-01 01:25:46.000000', 'consum', 0.0220, 'lps'),
	(518445, 128, '2014-02-01 01:25:47.000000', 'consum', 0.0211, 'lps'),
	(518446, 128, '2014-02-01 01:25:48.000000', 'consum', 0.0214, 'lps'),
	(518447, 128, '2014-02-01 01:25:49.000000', 'consum', 0.0212, 'lps'),
	(518448, 128, '2014-02-01 01:25:50.000000', 'consum', 0.0223, 'lps'),
	(518449, 128, '2014-02-01 01:25:51.000000', 'consum', 0.0213, 'lps'),
	(518450, 128, '2014-02-01 01:25:52.000000', 'consum', 0.0214, 'lps'),
	(518451, 128, '2014-02-01 01:25:53.000000', 'consum', 0.0220, 'lps'),
	(518452, 128, '2014-02-01 01:25:54.000000', 'consum', 0.0222, 'lps'),
	(518453, 128, '2014-02-01 01:25:55.000000', 'consum', 0.0210, 'lps'),
	(518454, 128, '2014-02-01 01:25:56.000000', 'consum', 0.0220, 'lps'),
	(518455, 128, '2014-02-01 01:25:57.000000', 'consum', 0.0216, 'lps'),
	(518456, 128, '2014-02-01 01:25:58.000000', 'consum', 0.0212, 'lps'),
	(518457, 128, '2014-02-01 01:25:59.000000', 'consum', 0.0218, 'lps'),
	(518458, 128, '2014-02-01 01:26:00.000000', 'consum', 0.0214, 'lps'),
	(518459, 128, '2014-02-01 01:26:01.000000', 'consum', 0.0222, 'lps'),
	(518460, 128, '2014-02-01 01:26:02.000000', 'consum', 0.0218, 'lps'),
	(518461, 128, '2014-02-01 01:26:03.000000', 'consum', 0.0211, 'lps'),
	(518462, 128, '2014-02-01 01:26:04.000000', 'consum', 0.0223, 'lps'),
	(518463, 128, '2014-02-01 01:26:05.000000', 'consum', 0.0214, 'lps'),
	(518464, 128, '2014-02-01 01:26:06.000000', 'consum', 0.0220, 'lps'),
	(518465, 128, '2014-02-01 01:26:07.000000', 'consum', 0.0220, 'lps'),
	(518466, 128, '2014-02-01 01:26:08.000000', 'consum', 0.0217, 'lps'),
	(518467, 128, '2014-02-01 01:26:09.000000', 'consum', 0.0217, 'lps'),
	(518468, 128, '2014-02-01 01:26:10.000000', 'consum', 0.0223, 'lps'),
	(518469, 128, '2014-02-01 01:26:11.000000', 'consum', 0.0214, 'lps'),
	(518470, 128, '2014-02-01 01:26:12.000000', 'consum', 0.0219, 'lps'),
	(518471, 128, '2014-02-01 01:26:13.000000', 'consum', 0.0215, 'lps'),
	(518472, 128, '2014-02-01 01:26:14.000000', 'consum', 0.0222, 'lps'),
	(518473, 128, '2014-02-01 01:26:15.000000', 'consum', 0.0215, 'lps'),
	(518474, 128, '2014-02-01 01:26:16.000000', 'consum', 0.0213, 'lps'),
	(518475, 128, '2014-02-01 01:26:17.000000', 'consum', 0.0210, 'lps'),
	(518476, 128, '2014-02-01 01:26:18.000000', 'consum', 0.0215, 'lps'),
	(518477, 128, '2014-02-01 01:26:19.000000', 'consum', 0.0223, 'lps'),
	(518478, 128, '2014-02-01 01:26:20.000000', 'consum', 0.0216, 'lps'),
	(518479, 128, '2014-02-01 01:26:21.000000', 'consum', 0.0217, 'lps'),
	(518480, 128, '2014-02-01 01:26:22.000000', 'consum', 0.0212, 'lps'),
	(518481, 128, '2014-02-01 01:26:23.000000', 'consum', 0.0215, 'lps'),
	(518482, 128, '2014-02-01 01:26:24.000000', 'consum', 0.0215, 'lps'),
	(518483, 128, '2014-02-01 01:26:25.000000', 'consum', 0.0219, 'lps'),
	(518484, 128, '2014-02-01 01:26:26.000000', 'consum', 0.0212, 'lps'),
	(518485, 128, '2014-02-01 01:26:27.000000', 'consum', 0.0221, 'lps'),
	(518486, 128, '2014-02-01 01:26:28.000000', 'consum', 0.0218, 'lps'),
	(518487, 128, '2014-02-01 01:26:29.000000', 'consum', 0.0220, 'lps'),
	(518488, 128, '2014-02-01 01:26:30.000000', 'consum', 0.0221, 'lps'),
	(518489, 128, '2014-02-01 01:26:31.000000', 'consum', 0.0219, 'lps'),
	(518490, 128, '2014-02-01 01:26:32.000000', 'consum', 0.0212, 'lps'),
	(518491, 128, '2014-02-01 01:26:33.000000', 'consum', 0.0221, 'lps'),
	(518492, 128, '2014-02-01 01:26:34.000000', 'consum', 0.0218, 'lps'),
	(518493, 128, '2014-02-01 01:26:35.000000', 'consum', 0.0216, 'lps'),
	(518494, 128, '2014-02-01 01:26:36.000000', 'consum', 0.0218, 'lps'),
	(518495, 128, '2014-02-01 01:26:37.000000', 'consum', 0.0218, 'lps'),
	(518496, 128, '2014-02-01 01:26:38.000000', 'consum', 0.0214, 'lps'),
	(518497, 128, '2014-02-01 01:26:39.000000', 'consum', 0.0220, 'lps'),
	(518498, 128, '2014-02-01 01:26:40.000000', 'consum', 0.0219, 'lps'),
	(518499, 128, '2014-02-01 01:26:41.000000', 'consum', 0.0211, 'lps'),
	(518500, 128, '2014-02-01 01:26:42.000000', 'consum', 0.0218, 'lps'),
	(518501, 128, '2014-02-01 01:26:43.000000', 'consum', 0.0218, 'lps'),
	(518502, 128, '2014-02-01 01:26:44.000000', 'consum', 0.0215, 'lps'),
	(518503, 128, '2014-02-01 01:26:45.000000', 'consum', 0.0211, 'lps'),
	(518504, 128, '2014-02-01 01:26:46.000000', 'consum', 0.0216, 'lps'),
	(518505, 128, '2014-02-01 01:26:47.000000', 'consum', 0.0222, 'lps'),
	(518506, 128, '2014-02-01 01:26:48.000000', 'consum', 0.0211, 'lps'),
	(518507, 128, '2014-02-01 01:26:49.000000', 'consum', 0.0220, 'lps'),
	(518508, 128, '2014-02-01 01:26:50.000000', 'consum', 0.0217, 'lps'),
	(518509, 128, '2014-02-01 01:26:51.000000', 'consum', 0.0214, 'lps'),
	(518510, 128, '2014-02-01 01:26:52.000000', 'consum', 0.0211, 'lps'),
	(518511, 128, '2014-02-01 01:26:53.000000', 'consum', 0.0215, 'lps'),
	(518512, 128, '2014-02-01 01:26:54.000000', 'consum', 0.0219, 'lps'),
	(518513, 128, '2014-02-01 01:26:55.000000', 'consum', 0.0213, 'lps'),
	(518514, 128, '2014-02-01 01:26:56.000000', 'consum', 0.0214, 'lps'),
	(518515, 128, '2014-02-01 01:26:57.000000', 'consum', 0.0219, 'lps'),
	(518516, 128, '2014-02-01 01:26:58.000000', 'consum', 0.0218, 'lps'),
	(518517, 128, '2014-02-01 01:26:59.000000', 'consum', 0.0221, 'lps'),
	(518518, 128, '2014-02-01 01:27:00.000000', 'consum', 0.0216, 'lps'),
	(518519, 128, '2014-02-01 01:27:01.000000', 'consum', 0.0219, 'lps'),
	(518520, 128, '2014-02-01 01:27:02.000000', 'consum', 0.0223, 'lps'),
	(518521, 128, '2014-02-01 01:27:03.000000', 'consum', 0.0220, 'lps'),
	(518522, 128, '2014-02-01 01:27:04.000000', 'consum', 0.0223, 'lps'),
	(518523, 128, '2014-02-01 01:27:05.000000', 'consum', 0.0218, 'lps'),
	(518524, 128, '2014-02-01 01:27:06.000000', 'consum', 0.0223, 'lps'),
	(518525, 128, '2014-02-01 01:27:07.000000', 'consum', 0.0212, 'lps'),
	(518526, 128, '2014-02-01 01:27:08.000000', 'consum', 0.0222, 'lps'),
	(518527, 128, '2014-02-01 01:27:09.000000', 'consum', 0.0223, 'lps'),
	(518528, 128, '2014-02-01 01:27:10.000000', 'consum', 0.0223, 'lps'),
	(518529, 128, '2014-02-01 01:27:11.000000', 'consum', 0.0212, 'lps'),
	(518530, 128, '2014-02-01 01:27:12.000000', 'consum', 0.0223, 'lps'),
	(518531, 128, '2014-02-01 01:27:13.000000', 'consum', 0.0211, 'lps'),
	(518532, 128, '2014-02-01 01:27:14.000000', 'consum', 0.0222, 'lps'),
	(518533, 128, '2014-02-01 01:27:15.000000', 'consum', 0.0223, 'lps'),
	(518534, 128, '2014-02-01 01:27:16.000000', 'consum', 0.0214, 'lps'),
	(518535, 128, '2014-02-01 01:27:17.000000', 'consum', 0.0218, 'lps'),
	(518536, 128, '2014-02-01 01:27:18.000000', 'consum', 0.0211, 'lps'),
	(518537, 128, '2014-02-01 01:27:19.000000', 'consum', 0.0219, 'lps'),
	(518538, 128, '2014-02-01 01:27:20.000000', 'consum', 0.0211, 'lps'),
	(518539, 128, '2014-02-01 01:27:21.000000', 'consum', 0.0215, 'lps'),
	(518540, 128, '2014-02-01 01:27:22.000000', 'consum', 0.0222, 'lps'),
	(518541, 128, '2014-02-01 01:27:23.000000', 'consum', 0.0210, 'lps'),
	(518542, 128, '2014-02-01 01:27:24.000000', 'consum', 0.0216, 'lps'),
	(518543, 128, '2014-02-01 01:27:25.000000', 'consum', 0.0214, 'lps'),
	(518544, 128, '2014-02-01 01:27:26.000000', 'consum', 0.0210, 'lps'),
	(518545, 128, '2014-02-01 01:27:27.000000', 'consum', 0.0216, 'lps'),
	(518546, 128, '2014-02-01 01:27:28.000000', 'consum', 0.0223, 'lps'),
	(518547, 128, '2014-02-01 01:27:29.000000', 'consum', 0.0217, 'lps'),
	(518548, 128, '2014-02-01 01:27:30.000000', 'consum', 0.0221, 'lps'),
	(518549, 128, '2014-02-01 01:27:31.000000', 'consum', 0.0216, 'lps'),
	(518550, 128, '2014-02-01 01:27:32.000000', 'consum', 0.0210, 'lps'),
	(518551, 128, '2014-02-01 01:27:33.000000', 'consum', 0.0217, 'lps'),
	(518552, 128, '2014-02-01 01:27:34.000000', 'consum', 0.0219, 'lps'),
	(518553, 128, '2014-02-01 01:27:35.000000', 'consum', 0.0220, 'lps'),
	(518554, 128, '2014-02-01 01:27:36.000000', 'consum', 0.0218, 'lps'),
	(518555, 128, '2014-02-01 01:27:37.000000', 'consum', 0.0210, 'lps'),
	(518556, 128, '2014-02-01 01:27:38.000000', 'consum', 0.0211, 'lps'),
	(518557, 128, '2014-02-01 01:27:39.000000', 'consum', 0.0216, 'lps'),
	(518558, 128, '2014-02-01 01:27:40.000000', 'consum', 0.0223, 'lps'),
	(518559, 128, '2014-02-01 01:27:41.000000', 'consum', 0.0218, 'lps'),
	(518560, 128, '2014-02-01 01:27:42.000000', 'consum', 0.0211, 'lps'),
	(518561, 128, '2014-02-01 01:27:43.000000', 'consum', 0.0217, 'lps'),
	(518562, 128, '2014-02-01 01:27:44.000000', 'consum', 0.0217, 'lps'),
	(518563, 128, '2014-02-01 01:27:45.000000', 'consum', 0.0222, 'lps'),
	(518564, 128, '2014-02-01 01:27:46.000000', 'consum', 0.0223, 'lps'),
	(518565, 128, '2014-02-01 01:27:47.000000', 'consum', 0.0213, 'lps'),
	(518566, 128, '2014-02-01 01:27:48.000000', 'consum', 0.0215, 'lps'),
	(518567, 128, '2014-02-01 01:27:49.000000', 'consum', 0.0212, 'lps'),
	(518568, 128, '2014-02-01 01:27:50.000000', 'consum', 0.0217, 'lps'),
	(518569, 128, '2014-02-01 01:27:51.000000', 'consum', 0.0213, 'lps'),
	(518570, 128, '2014-02-01 01:27:52.000000', 'consum', 0.0217, 'lps'),
	(518571, 128, '2014-02-01 01:27:53.000000', 'consum', 0.0222, 'lps'),
	(518572, 128, '2014-02-01 01:27:54.000000', 'consum', 0.0221, 'lps'),
	(518573, 128, '2014-02-01 01:27:55.000000', 'consum', 0.0215, 'lps'),
	(518574, 128, '2014-02-01 01:27:56.000000', 'consum', 0.0219, 'lps'),
	(518575, 128, '2014-02-01 01:27:57.000000', 'consum', 0.0213, 'lps'),
	(518576, 128, '2014-02-01 01:27:58.000000', 'consum', 0.0210, 'lps'),
	(518577, 128, '2014-02-01 01:27:59.000000', 'consum', 0.0216, 'lps'),
	(518578, 128, '2014-02-01 01:28:00.000000', 'consum', 0.0212, 'lps'),
	(518579, 128, '2014-02-01 01:28:01.000000', 'consum', 0.0219, 'lps'),
	(518580, 128, '2014-02-01 01:28:02.000000', 'consum', 0.0219, 'lps'),
	(518581, 128, '2014-02-01 01:28:03.000000', 'consum', 0.0214, 'lps'),
	(518582, 128, '2014-02-01 01:28:04.000000', 'consum', 0.0219, 'lps'),
	(518583, 128, '2014-02-01 01:28:05.000000', 'consum', 0.0213, 'lps'),
	(518584, 128, '2014-02-01 01:28:06.000000', 'consum', 0.0214, 'lps'),
	(518585, 128, '2014-02-01 01:28:07.000000', 'consum', 0.0223, 'lps'),
	(518586, 128, '2014-02-01 01:28:08.000000', 'consum', 0.0221, 'lps'),
	(518587, 128, '2014-02-01 01:28:09.000000', 'consum', 0.0211, 'lps'),
	(518588, 128, '2014-02-01 01:28:10.000000', 'consum', 0.0211, 'lps'),
	(518589, 128, '2014-02-01 01:28:11.000000', 'consum', 0.0214, 'lps'),
	(518590, 128, '2014-02-01 01:28:12.000000', 'consum', 0.0211, 'lps'),
	(518591, 128, '2014-02-01 01:28:13.000000', 'consum', 0.0219, 'lps'),
	(518592, 128, '2014-02-01 01:28:14.000000', 'consum', 0.0223, 'lps'),
	(518593, 128, '2014-02-01 01:28:15.000000', 'consum', 0.0221, 'lps'),
	(518594, 128, '2014-02-01 01:28:16.000000', 'consum', 0.0212, 'lps'),
	(518595, 128, '2014-02-01 01:28:17.000000', 'consum', 0.0215, 'lps'),
	(518596, 128, '2014-02-01 01:28:18.000000', 'consum', 0.0218, 'lps'),
	(518597, 128, '2014-02-01 01:28:19.000000', 'consum', 0.0220, 'lps'),
	(518598, 128, '2014-02-01 01:28:20.000000', 'consum', 0.0210, 'lps'),
	(518599, 128, '2014-02-01 01:28:21.000000', 'consum', 0.0220, 'lps'),
	(518600, 128, '2014-02-01 01:28:22.000000', 'consum', 0.0219, 'lps'),
	(518601, 128, '2014-02-01 01:28:23.000000', 'consum', 0.0211, 'lps'),
	(518602, 128, '2014-02-01 01:28:24.000000', 'consum', 0.0219, 'lps'),
	(518603, 128, '2014-02-01 01:28:25.000000', 'consum', 0.0223, 'lps'),
	(518604, 128, '2014-02-01 01:28:26.000000', 'consum', 0.0222, 'lps'),
	(518605, 128, '2014-02-01 01:28:27.000000', 'consum', 0.0215, 'lps'),
	(518606, 128, '2014-02-01 01:28:28.000000', 'consum', 0.0215, 'lps'),
	(518607, 128, '2014-02-01 01:28:29.000000', 'consum', 0.0221, 'lps'),
	(518608, 128, '2014-02-01 01:28:30.000000', 'consum', 0.0222, 'lps'),
	(518609, 128, '2014-02-01 01:28:31.000000', 'consum', 0.0222, 'lps'),
	(518610, 128, '2014-02-01 01:28:32.000000', 'consum', 0.0223, 'lps'),
	(518611, 128, '2014-02-01 01:28:33.000000', 'consum', 0.0223, 'lps'),
	(518612, 128, '2014-02-01 01:28:34.000000', 'consum', 0.0211, 'lps'),
	(518613, 128, '2014-02-01 01:28:35.000000', 'consum', 0.0216, 'lps'),
	(518614, 128, '2014-02-01 01:28:36.000000', 'consum', 0.0212, 'lps'),
	(518615, 128, '2014-02-01 01:28:37.000000', 'consum', 0.0214, 'lps'),
	(518616, 128, '2014-02-01 01:28:38.000000', 'consum', 0.0214, 'lps'),
	(518617, 128, '2014-02-01 01:28:39.000000', 'consum', 0.0215, 'lps'),
	(518618, 128, '2014-02-01 01:28:40.000000', 'consum', 0.0211, 'lps'),
	(518619, 128, '2014-02-01 01:28:41.000000', 'consum', 0.0216, 'lps'),
	(518620, 128, '2014-02-01 01:28:42.000000', 'consum', 0.0210, 'lps'),
	(518621, 128, '2014-02-01 01:28:43.000000', 'consum', 0.0221, 'lps'),
	(518622, 128, '2014-02-01 01:28:44.000000', 'consum', 0.0221, 'lps'),
	(518623, 128, '2014-02-01 01:28:45.000000', 'consum', 0.0221, 'lps'),
	(518624, 128, '2014-02-01 01:28:46.000000', 'consum', 0.0218, 'lps'),
	(518625, 128, '2014-02-01 01:28:47.000000', 'consum', 0.0217, 'lps'),
	(518626, 128, '2014-02-01 01:28:48.000000', 'consum', 0.0221, 'lps'),
	(518627, 128, '2014-02-01 01:28:49.000000', 'consum', 0.0219, 'lps'),
	(518628, 128, '2014-02-01 01:28:50.000000', 'consum', 0.0220, 'lps'),
	(518629, 128, '2014-02-01 01:28:51.000000', 'consum', 0.0222, 'lps'),
	(518630, 128, '2014-02-01 01:28:52.000000', 'consum', 0.0210, 'lps'),
	(518631, 128, '2014-02-01 01:28:53.000000', 'consum', 0.0217, 'lps'),
	(518632, 128, '2014-02-01 01:28:54.000000', 'consum', 0.0218, 'lps'),
	(518633, 128, '2014-02-01 01:28:55.000000', 'consum', 0.0217, 'lps'),
	(518634, 128, '2014-02-01 01:28:56.000000', 'consum', 0.0220, 'lps'),
	(518635, 128, '2014-02-01 01:28:57.000000', 'consum', 0.0212, 'lps'),
	(518636, 128, '2014-02-01 01:28:58.000000', 'consum', 0.0219, 'lps'),
	(518637, 128, '2014-02-01 01:28:59.000000', 'consum', 0.0219, 'lps'),
	(518638, 128, '2014-02-01 01:29:00.000000', 'consum', 0.0218, 'lps'),
	(518639, 128, '2014-02-01 01:29:01.000000', 'consum', 0.0222, 'lps'),
	(518640, 128, '2014-02-01 01:29:02.000000', 'consum', 0.0219, 'lps'),
	(518641, 128, '2014-02-01 01:29:03.000000', 'consum', 0.0219, 'lps'),
	(518642, 128, '2014-02-01 01:29:04.000000', 'consum', 0.0215, 'lps'),
	(518643, 128, '2014-02-01 01:29:05.000000', 'consum', 0.0220, 'lps'),
	(518644, 128, '2014-02-01 01:29:06.000000', 'consum', 0.0220, 'lps'),
	(518645, 128, '2014-02-01 01:29:07.000000', 'consum', 0.0214, 'lps'),
	(518646, 128, '2014-02-01 01:29:08.000000', 'consum', 0.0215, 'lps'),
	(518647, 128, '2014-02-01 01:29:09.000000', 'consum', 0.0223, 'lps'),
	(518648, 128, '2014-02-01 01:29:10.000000', 'consum', 0.0218, 'lps'),
	(518649, 128, '2014-02-01 01:29:11.000000', 'consum', 0.0214, 'lps'),
	(518650, 128, '2014-02-01 01:29:12.000000', 'consum', 0.0219, 'lps'),
	(518651, 128, '2014-02-01 01:29:13.000000', 'consum', 0.0215, 'lps'),
	(518652, 128, '2014-02-01 01:29:14.000000', 'consum', 0.0210, 'lps'),
	(518653, 128, '2014-02-01 01:29:15.000000', 'consum', 0.0210, 'lps'),
	(518654, 128, '2014-02-01 01:29:16.000000', 'consum', 0.0223, 'lps'),
	(518655, 128, '2014-02-01 01:29:17.000000', 'consum', 0.0220, 'lps'),
	(518656, 128, '2014-02-01 01:29:18.000000', 'consum', 0.0221, 'lps'),
	(518657, 128, '2014-02-01 01:29:19.000000', 'consum', 0.0222, 'lps'),
	(518658, 128, '2014-02-01 01:29:20.000000', 'consum', 0.0210, 'lps'),
	(518659, 128, '2014-02-01 01:29:21.000000', 'consum', 0.0216, 'lps'),
	(518660, 128, '2014-02-01 01:29:22.000000', 'consum', 0.0213, 'lps'),
	(518661, 128, '2014-02-01 01:29:23.000000', 'consum', 0.0220, 'lps'),
	(518662, 128, '2014-02-01 01:29:24.000000', 'consum', 0.0212, 'lps'),
	(518663, 128, '2014-02-01 01:29:25.000000', 'consum', 0.0216, 'lps'),
	(518664, 128, '2014-02-01 01:29:26.000000', 'consum', 0.0223, 'lps'),
	(518665, 128, '2014-02-01 01:29:27.000000', 'consum', 0.0212, 'lps'),
	(518666, 128, '2014-02-01 01:29:28.000000', 'consum', 0.0212, 'lps'),
	(518667, 128, '2014-02-01 01:29:29.000000', 'consum', 0.0216, 'lps'),
	(518668, 128, '2014-02-01 01:29:30.000000', 'consum', 0.0217, 'lps'),
	(518669, 128, '2014-02-01 01:29:31.000000', 'consum', 0.0215, 'lps'),
	(518670, 128, '2014-02-01 01:29:32.000000', 'consum', 0.0216, 'lps'),
	(518671, 128, '2014-02-01 01:29:33.000000', 'consum', 0.0210, 'lps'),
	(518672, 128, '2014-02-01 01:29:34.000000', 'consum', 0.0221, 'lps'),
	(518673, 128, '2014-02-01 01:29:35.000000', 'consum', 0.0210, 'lps'),
	(518674, 128, '2014-02-01 01:29:36.000000', 'consum', 0.0218, 'lps'),
	(518675, 128, '2014-02-01 01:29:37.000000', 'consum', 0.0210, 'lps'),
	(518676, 128, '2014-02-01 01:29:38.000000', 'consum', 0.0213, 'lps'),
	(518677, 128, '2014-02-01 01:29:39.000000', 'consum', 0.0211, 'lps'),
	(518678, 128, '2014-02-01 01:29:40.000000', 'consum', 0.0222, 'lps'),
	(518679, 128, '2014-02-01 01:29:41.000000', 'consum', 0.0211, 'lps'),
	(518680, 128, '2014-02-01 01:29:42.000000', 'consum', 0.0220, 'lps'),
	(518681, 128, '2014-02-01 01:29:43.000000', 'consum', 0.0215, 'lps'),
	(518682, 128, '2014-02-01 01:29:44.000000', 'consum', 0.0220, 'lps'),
	(518683, 128, '2014-02-01 01:29:45.000000', 'consum', 0.0216, 'lps'),
	(518684, 128, '2014-02-01 01:29:46.000000', 'consum', 0.0214, 'lps'),
	(518685, 128, '2014-02-01 01:29:47.000000', 'consum', 0.0223, 'lps'),
	(518686, 128, '2014-02-01 01:29:48.000000', 'consum', 0.0210, 'lps'),
	(518687, 128, '2014-02-01 01:29:49.000000', 'consum', 0.0211, 'lps'),
	(518688, 128, '2014-02-01 01:29:50.000000', 'consum', 0.0216, 'lps'),
	(518689, 128, '2014-02-01 01:29:51.000000', 'consum', 0.0223, 'lps'),
	(518690, 128, '2014-02-01 01:29:52.000000', 'consum', 0.0214, 'lps'),
	(518691, 128, '2014-02-01 01:29:53.000000', 'consum', 0.0222, 'lps'),
	(518692, 128, '2014-02-01 01:29:54.000000', 'consum', 0.0216, 'lps'),
	(518693, 128, '2014-02-01 01:29:55.000000', 'consum', 0.0220, 'lps'),
	(518694, 128, '2014-02-01 01:29:56.000000', 'consum', 0.0214, 'lps'),
	(518695, 128, '2014-02-01 01:29:57.000000', 'consum', 0.0215, 'lps'),
	(518696, 128, '2014-02-01 01:29:58.000000', 'consum', 0.0210, 'lps'),
	(518697, 128, '2014-02-01 01:29:59.000000', 'consum', 0.0222, 'lps'),
	(518698, 128, '2014-02-01 01:30:00.000000', 'consum', 0.0215, 'lps'),
	(518699, 128, '2014-02-01 01:30:01.000000', 'consum', 0.0212, 'lps'),
	(518700, 128, '2014-02-01 01:30:02.000000', 'consum', 0.0220, 'lps'),
	(518701, 128, '2014-02-01 01:30:03.000000', 'consum', 0.0213, 'lps'),
	(518702, 128, '2014-02-01 01:30:04.000000', 'consum', 0.0222, 'lps'),
	(518703, 128, '2014-02-01 01:30:05.000000', 'consum', 0.0219, 'lps'),
	(518704, 128, '2014-02-01 01:30:06.000000', 'consum', 0.0219, 'lps'),
	(518705, 128, '2014-02-01 01:30:07.000000', 'consum', 0.0214, 'lps'),
	(518706, 128, '2014-02-01 01:30:08.000000', 'consum', 0.0221, 'lps'),
	(518707, 128, '2014-02-01 01:30:09.000000', 'consum', 0.0222, 'lps'),
	(518708, 128, '2014-02-01 01:30:10.000000', 'consum', 0.0211, 'lps'),
	(518709, 128, '2014-02-01 01:30:11.000000', 'consum', 0.0222, 'lps'),
	(518710, 128, '2014-02-01 01:30:12.000000', 'consum', 0.0212, 'lps'),
	(518711, 128, '2014-02-01 01:30:13.000000', 'consum', 0.0211, 'lps'),
	(518712, 128, '2014-02-01 01:30:14.000000', 'consum', 0.0223, 'lps'),
	(518713, 128, '2014-02-01 01:30:15.000000', 'consum', 0.0217, 'lps'),
	(518714, 128, '2014-02-01 01:30:16.000000', 'consum', 0.0221, 'lps'),
	(518715, 128, '2014-02-01 01:30:17.000000', 'consum', 0.0216, 'lps'),
	(518716, 128, '2014-02-01 01:30:18.000000', 'consum', 0.0222, 'lps'),
	(518717, 128, '2014-02-01 01:30:19.000000', 'consum', 0.0222, 'lps'),
	(518718, 128, '2014-02-01 01:30:20.000000', 'consum', 0.0210, 'lps'),
	(518719, 128, '2014-02-01 01:30:21.000000', 'consum', 0.0214, 'lps'),
	(518720, 128, '2014-02-01 01:30:22.000000', 'consum', 0.0219, 'lps'),
	(518721, 128, '2014-02-01 01:30:23.000000', 'consum', 0.0214, 'lps'),
	(518722, 128, '2014-02-01 01:30:24.000000', 'consum', 0.0216, 'lps'),
	(518723, 128, '2014-02-01 01:30:25.000000', 'consum', 0.0215, 'lps'),
	(518724, 128, '2014-02-01 01:30:26.000000', 'consum', 0.0217, 'lps'),
	(518725, 128, '2014-02-01 01:30:27.000000', 'consum', 0.0218, 'lps'),
	(518726, 128, '2014-02-01 01:30:28.000000', 'consum', 0.0215, 'lps'),
	(518727, 128, '2014-02-01 01:30:29.000000', 'consum', 0.0213, 'lps'),
	(518728, 128, '2014-02-01 01:30:30.000000', 'consum', 0.0210, 'lps'),
	(518729, 128, '2014-02-01 01:30:31.000000', 'consum', 0.0217, 'lps'),
	(518730, 128, '2014-02-01 01:30:32.000000', 'consum', 0.0214, 'lps'),
	(518731, 128, '2014-02-01 01:30:33.000000', 'consum', 0.0212, 'lps'),
	(518732, 128, '2014-02-01 01:30:34.000000', 'consum', 0.0221, 'lps'),
	(518733, 128, '2014-02-01 01:30:35.000000', 'consum', 0.0217, 'lps'),
	(518734, 128, '2014-02-01 01:30:36.000000', 'consum', 0.0212, 'lps'),
	(518735, 128, '2014-02-01 01:30:37.000000', 'consum', 0.0216, 'lps'),
	(518736, 128, '2014-02-01 01:30:38.000000', 'consum', 0.0219, 'lps'),
	(518737, 128, '2014-02-01 01:30:39.000000', 'consum', 0.0222, 'lps'),
	(518738, 128, '2014-02-01 01:30:40.000000', 'consum', 0.0216, 'lps'),
	(518739, 128, '2014-02-01 01:30:41.000000', 'consum', 0.0217, 'lps'),
	(518740, 128, '2014-02-01 01:30:42.000000', 'consum', 0.0215, 'lps'),
	(518741, 128, '2014-02-01 01:30:43.000000', 'consum', 0.0213, 'lps'),
	(518742, 128, '2014-02-01 01:30:44.000000', 'consum', 0.0212, 'lps'),
	(518743, 128, '2014-02-01 01:30:45.000000', 'consum', 0.0210, 'lps'),
	(518744, 128, '2014-02-01 01:30:46.000000', 'consum', 0.0220, 'lps'),
	(518745, 128, '2014-02-01 01:30:47.000000', 'consum', 0.0218, 'lps'),
	(518746, 128, '2014-02-01 01:30:48.000000', 'consum', 0.0222, 'lps'),
	(518747, 128, '2014-02-01 01:30:49.000000', 'consum', 0.0218, 'lps'),
	(518748, 128, '2014-02-01 01:30:50.000000', 'consum', 0.0212, 'lps'),
	(518749, 128, '2014-02-01 01:30:51.000000', 'consum', 0.0214, 'lps'),
	(518750, 128, '2014-02-01 01:30:52.000000', 'consum', 0.0210, 'lps'),
	(518751, 128, '2014-02-01 01:30:53.000000', 'consum', 0.0210, 'lps'),
	(518752, 128, '2014-02-01 01:30:54.000000', 'consum', 0.0211, 'lps'),
	(518753, 128, '2014-02-01 01:30:55.000000', 'consum', 0.0217, 'lps'),
	(518754, 128, '2014-02-01 01:30:56.000000', 'consum', 0.0215, 'lps'),
	(518755, 128, '2014-02-01 01:30:57.000000', 'consum', 0.0212, 'lps'),
	(518756, 128, '2014-02-01 01:30:58.000000', 'consum', 0.0219, 'lps'),
	(518757, 128, '2014-02-01 01:30:59.000000', 'consum', 0.0222, 'lps'),
	(518758, 128, '2014-02-01 01:31:00.000000', 'consum', 0.0216, 'lps'),
	(518759, 128, '2014-02-01 01:31:01.000000', 'consum', 0.0219, 'lps'),
	(518760, 128, '2014-02-01 01:31:02.000000', 'consum', 0.0222, 'lps'),
	(518761, 128, '2014-02-01 01:31:03.000000', 'consum', 0.0218, 'lps'),
	(518762, 128, '2014-02-01 01:31:04.000000', 'consum', 0.0212, 'lps'),
	(518763, 128, '2014-02-01 01:31:05.000000', 'consum', 0.0213, 'lps'),
	(518764, 128, '2014-02-01 01:31:06.000000', 'consum', 0.0217, 'lps'),
	(518765, 128, '2014-02-01 01:31:07.000000', 'consum', 0.0210, 'lps'),
	(518766, 128, '2014-02-01 01:31:08.000000', 'consum', 0.0215, 'lps'),
	(518767, 128, '2014-02-01 01:31:09.000000', 'consum', 0.0223, 'lps'),
	(518768, 128, '2014-02-01 01:31:10.000000', 'consum', 0.0220, 'lps'),
	(518769, 128, '2014-02-01 01:31:11.000000', 'consum', 0.0221, 'lps'),
	(518770, 128, '2014-02-01 01:31:12.000000', 'consum', 0.0221, 'lps'),
	(518771, 128, '2014-02-01 01:31:13.000000', 'consum', 0.0217, 'lps'),
	(518772, 128, '2014-02-01 01:31:14.000000', 'consum', 0.0215, 'lps'),
	(518773, 128, '2014-02-01 01:31:15.000000', 'consum', 0.0215, 'lps'),
	(518774, 128, '2014-02-01 01:31:16.000000', 'consum', 0.0221, 'lps'),
	(518775, 128, '2014-02-01 01:31:17.000000', 'consum', 0.0222, 'lps'),
	(518776, 128, '2014-02-01 01:31:18.000000', 'consum', 0.0223, 'lps'),
	(518777, 128, '2014-02-01 01:31:19.000000', 'consum', 0.0210, 'lps'),
	(518778, 128, '2014-02-01 01:31:20.000000', 'consum', 0.0215, 'lps'),
	(518779, 128, '2014-02-01 01:31:21.000000', 'consum', 0.0219, 'lps'),
	(518780, 128, '2014-02-01 01:31:22.000000', 'consum', 0.0215, 'lps'),
	(518781, 128, '2014-02-01 01:31:23.000000', 'consum', 0.0222, 'lps'),
	(518782, 128, '2014-02-01 01:31:24.000000', 'consum', 0.0212, 'lps'),
	(518783, 128, '2014-02-01 01:31:25.000000', 'consum', 0.0215, 'lps'),
	(518784, 128, '2014-02-01 01:31:26.000000', 'consum', 0.0212, 'lps'),
	(518785, 128, '2014-02-01 01:31:27.000000', 'consum', 0.0223, 'lps'),
	(518786, 128, '2014-02-01 01:31:28.000000', 'consum', 0.0213, 'lps'),
	(518787, 128, '2014-02-01 01:31:29.000000', 'consum', 0.0215, 'lps'),
	(518788, 128, '2014-02-01 01:31:30.000000', 'consum', 0.0212, 'lps'),
	(518789, 128, '2014-02-01 01:31:31.000000', 'consum', 0.0220, 'lps'),
	(518790, 128, '2014-02-01 01:31:32.000000', 'consum', 0.0212, 'lps'),
	(518791, 128, '2014-02-01 01:31:33.000000', 'consum', 0.0219, 'lps'),
	(518792, 128, '2014-02-01 01:31:34.000000', 'consum', 0.0223, 'lps'),
	(518793, 128, '2014-02-01 01:31:35.000000', 'consum', 0.0218, 'lps'),
	(518794, 128, '2014-02-01 01:31:36.000000', 'consum', 0.0210, 'lps'),
	(518795, 128, '2014-02-01 01:31:37.000000', 'consum', 0.0218, 'lps'),
	(518796, 128, '2014-02-01 01:31:38.000000', 'consum', 0.0220, 'lps'),
	(518797, 128, '2014-02-01 01:31:39.000000', 'consum', 0.0221, 'lps'),
	(518798, 128, '2014-02-01 01:31:40.000000', 'consum', 0.0211, 'lps'),
	(518799, 128, '2014-02-01 01:31:41.000000', 'consum', 0.0223, 'lps'),
	(518800, 128, '2014-02-01 01:31:42.000000', 'consum', 0.0219, 'lps'),
	(518801, 128, '2014-02-01 01:31:43.000000', 'consum', 0.0213, 'lps'),
	(518802, 128, '2014-02-01 01:31:44.000000', 'consum', 0.0214, 'lps'),
	(518803, 128, '2014-02-01 01:31:45.000000', 'consum', 0.0220, 'lps'),
	(518804, 128, '2014-02-01 01:31:46.000000', 'consum', 0.0222, 'lps'),
	(518805, 128, '2014-02-01 01:31:47.000000', 'consum', 0.0212, 'lps'),
	(518806, 128, '2014-02-01 01:31:48.000000', 'consum', 0.0211, 'lps'),
	(518807, 128, '2014-02-01 01:31:49.000000', 'consum', 0.0212, 'lps'),
	(518808, 128, '2014-02-01 01:31:50.000000', 'consum', 0.0218, 'lps'),
	(518809, 128, '2014-02-01 01:31:51.000000', 'consum', 0.0217, 'lps'),
	(518810, 128, '2014-02-01 01:31:52.000000', 'consum', 0.0220, 'lps'),
	(518811, 128, '2014-02-01 01:31:53.000000', 'consum', 0.0212, 'lps'),
	(518812, 128, '2014-02-01 01:31:54.000000', 'consum', 0.0218, 'lps'),
	(518813, 128, '2014-02-01 01:31:55.000000', 'consum', 0.0216, 'lps'),
	(518814, 128, '2014-02-01 01:31:56.000000', 'consum', 0.0217, 'lps'),
	(518815, 128, '2014-02-01 01:31:57.000000', 'consum', 0.0215, 'lps'),
	(518816, 128, '2014-02-01 01:31:58.000000', 'consum', 0.0215, 'lps'),
	(518817, 128, '2014-02-01 01:31:59.000000', 'consum', 0.0221, 'lps'),
	(518818, 128, '2014-02-01 01:32:00.000000', 'consum', 0.0221, 'lps'),
	(518819, 128, '2014-02-01 01:32:01.000000', 'consum', 0.0218, 'lps'),
	(518820, 128, '2014-02-01 01:32:02.000000', 'consum', 0.0220, 'lps'),
	(518821, 128, '2014-02-01 01:32:03.000000', 'consum', 0.0219, 'lps'),
	(518822, 128, '2014-02-01 01:32:04.000000', 'consum', 0.0215, 'lps'),
	(518823, 128, '2014-02-01 01:32:05.000000', 'consum', 0.0220, 'lps'),
	(518824, 128, '2014-02-01 01:32:06.000000', 'consum', 0.0218, 'lps'),
	(518825, 128, '2014-02-01 01:32:07.000000', 'consum', 0.0219, 'lps'),
	(518826, 128, '2014-02-01 01:32:08.000000', 'consum', 0.0218, 'lps'),
	(518827, 128, '2014-02-01 01:32:09.000000', 'consum', 0.0222, 'lps'),
	(518828, 128, '2014-02-01 01:32:10.000000', 'consum', 0.0219, 'lps'),
	(518829, 128, '2014-02-01 01:32:11.000000', 'consum', 0.0221, 'lps'),
	(518830, 128, '2014-02-01 01:32:12.000000', 'consum', 0.0223, 'lps'),
	(518831, 128, '2014-02-01 01:32:13.000000', 'consum', 0.0214, 'lps'),
	(518832, 128, '2014-02-01 01:32:14.000000', 'consum', 0.0221, 'lps'),
	(518833, 128, '2014-02-01 01:32:15.000000', 'consum', 0.0211, 'lps'),
	(518834, 128, '2014-02-01 01:32:16.000000', 'consum', 0.0212, 'lps'),
	(518835, 128, '2014-02-01 01:32:17.000000', 'consum', 0.0217, 'lps'),
	(518836, 128, '2014-02-01 01:32:18.000000', 'consum', 0.0213, 'lps'),
	(518837, 128, '2014-02-01 01:32:19.000000', 'consum', 0.0217, 'lps'),
	(518838, 128, '2014-02-01 01:32:20.000000', 'consum', 0.0210, 'lps'),
	(518839, 128, '2014-02-01 01:32:21.000000', 'consum', 0.0216, 'lps'),
	(518840, 128, '2014-02-01 01:32:22.000000', 'consum', 0.0211, 'lps'),
	(518841, 128, '2014-02-01 01:32:23.000000', 'consum', 0.0215, 'lps'),
	(518842, 128, '2014-02-01 01:32:24.000000', 'consum', 0.0216, 'lps'),
	(518843, 128, '2014-02-01 01:32:25.000000', 'consum', 0.0213, 'lps'),
	(518844, 128, '2014-02-01 01:32:26.000000', 'consum', 0.0219, 'lps'),
	(518845, 128, '2014-02-01 01:32:27.000000', 'consum', 0.0220, 'lps'),
	(518846, 128, '2014-02-01 01:32:28.000000', 'consum', 0.0221, 'lps'),
	(518847, 128, '2014-02-01 01:32:29.000000', 'consum', 0.0219, 'lps'),
	(518848, 128, '2014-02-01 01:32:30.000000', 'consum', 0.0222, 'lps'),
	(518849, 128, '2014-02-01 01:32:31.000000', 'consum', 0.0216, 'lps'),
	(518850, 128, '2014-02-01 01:32:32.000000', 'consum', 0.0218, 'lps'),
	(518851, 128, '2014-02-01 01:32:33.000000', 'consum', 0.0218, 'lps'),
	(518852, 128, '2014-02-01 01:32:34.000000', 'consum', 0.0212, 'lps'),
	(518853, 128, '2014-02-01 01:32:35.000000', 'consum', 0.0213, 'lps'),
	(518854, 128, '2014-02-01 01:32:36.000000', 'consum', 0.0220, 'lps'),
	(518855, 128, '2014-02-01 01:32:37.000000', 'consum', 0.0223, 'lps'),
	(518856, 128, '2014-02-01 01:32:38.000000', 'consum', 0.0219, 'lps'),
	(518857, 128, '2014-02-01 01:32:39.000000', 'consum', 0.0215, 'lps'),
	(518858, 128, '2014-02-01 01:32:40.000000', 'consum', 0.0223, 'lps'),
	(518859, 128, '2014-02-01 01:32:41.000000', 'consum', 0.0219, 'lps'),
	(518860, 128, '2014-02-01 01:32:42.000000', 'consum', 0.0217, 'lps'),
	(518861, 128, '2014-02-01 01:32:43.000000', 'consum', 0.0219, 'lps'),
	(518862, 128, '2014-02-01 01:32:44.000000', 'consum', 0.0221, 'lps'),
	(518863, 128, '2014-02-01 01:32:45.000000', 'consum', 0.0211, 'lps'),
	(518864, 128, '2014-02-01 01:32:46.000000', 'consum', 0.0223, 'lps'),
	(518865, 128, '2014-02-01 01:32:47.000000', 'consum', 0.0218, 'lps'),
	(518866, 128, '2014-02-01 01:32:48.000000', 'consum', 0.0223, 'lps'),
	(518867, 128, '2014-02-01 01:32:49.000000', 'consum', 0.0212, 'lps'),
	(518868, 128, '2014-02-01 01:32:50.000000', 'consum', 0.0222, 'lps'),
	(518869, 128, '2014-02-01 01:32:51.000000', 'consum', 0.0222, 'lps'),
	(518870, 128, '2014-02-01 01:32:52.000000', 'consum', 0.0219, 'lps'),
	(518871, 128, '2014-02-01 01:32:53.000000', 'consum', 0.0222, 'lps'),
	(518872, 128, '2014-02-01 01:32:54.000000', 'consum', 0.0216, 'lps'),
	(518873, 128, '2014-02-01 01:32:55.000000', 'consum', 0.0217, 'lps'),
	(518874, 128, '2014-02-01 01:32:56.000000', 'consum', 0.0213, 'lps'),
	(518875, 128, '2014-02-01 01:32:57.000000', 'consum', 0.0220, 'lps'),
	(518876, 128, '2014-02-01 01:32:58.000000', 'consum', 0.0211, 'lps'),
	(518877, 128, '2014-02-01 01:32:59.000000', 'consum', 0.0210, 'lps'),
	(518878, 128, '2014-02-01 01:33:00.000000', 'consum', 0.0210, 'lps'),
	(518879, 128, '2014-02-01 01:33:01.000000', 'consum', 0.0211, 'lps'),
	(518880, 128, '2014-02-01 01:33:02.000000', 'consum', 0.0214, 'lps'),
	(518881, 128, '2014-02-01 01:33:03.000000', 'consum', 0.0212, 'lps'),
	(518882, 128, '2014-02-01 01:33:04.000000', 'consum', 0.0211, 'lps'),
	(518883, 128, '2014-02-01 01:33:05.000000', 'consum', 0.0211, 'lps'),
	(518884, 128, '2014-02-01 01:33:06.000000', 'consum', 0.0210, 'lps'),
	(518885, 128, '2014-02-01 01:33:07.000000', 'consum', 0.0222, 'lps'),
	(518886, 128, '2014-02-01 01:33:08.000000', 'consum', 0.0214, 'lps'),
	(518887, 128, '2014-02-01 01:33:09.000000', 'consum', 0.0222, 'lps'),
	(518888, 128, '2014-02-01 01:33:10.000000', 'consum', 0.0218, 'lps'),
	(518889, 128, '2014-02-01 01:33:11.000000', 'consum', 0.0214, 'lps'),
	(518890, 128, '2014-02-01 01:33:12.000000', 'consum', 0.0219, 'lps'),
	(518891, 128, '2014-02-01 01:33:13.000000', 'consum', 0.0216, 'lps'),
	(518892, 128, '2014-02-01 01:33:14.000000', 'consum', 0.0214, 'lps'),
	(518893, 128, '2014-02-01 01:33:15.000000', 'consum', 0.0214, 'lps'),
	(518894, 128, '2014-02-01 01:33:16.000000', 'consum', 0.0217, 'lps'),
	(518895, 128, '2014-02-01 01:33:17.000000', 'consum', 0.0219, 'lps'),
	(518896, 128, '2014-02-01 01:33:18.000000', 'consum', 0.0222, 'lps'),
	(518897, 128, '2014-02-01 01:33:19.000000', 'consum', 0.0214, 'lps'),
	(518898, 128, '2014-02-01 01:33:20.000000', 'consum', 0.0210, 'lps'),
	(518899, 128, '2014-02-01 01:33:21.000000', 'consum', 0.0212, 'lps'),
	(518900, 128, '2014-02-01 01:33:22.000000', 'consum', 0.0222, 'lps'),
	(518901, 128, '2014-02-01 01:33:23.000000', 'consum', 0.0223, 'lps'),
	(518902, 128, '2014-02-01 01:33:24.000000', 'consum', 0.0223, 'lps'),
	(518903, 128, '2014-02-01 01:33:25.000000', 'consum', 0.0222, 'lps'),
	(518904, 128, '2014-02-01 01:33:26.000000', 'consum', 0.0218, 'lps'),
	(518905, 128, '2014-02-01 01:33:27.000000', 'consum', 0.0214, 'lps'),
	(518906, 128, '2014-02-01 01:33:28.000000', 'consum', 0.0222, 'lps'),
	(518907, 128, '2014-02-01 01:33:29.000000', 'consum', 0.0214, 'lps'),
	(518908, 128, '2014-02-01 01:33:30.000000', 'consum', 0.0212, 'lps'),
	(518909, 128, '2014-02-01 01:33:31.000000', 'consum', 0.0220, 'lps'),
	(518910, 128, '2014-02-01 01:33:32.000000', 'consum', 0.0214, 'lps'),
	(518911, 128, '2014-02-01 01:33:33.000000', 'consum', 0.0213, 'lps'),
	(518912, 128, '2014-02-01 01:33:34.000000', 'consum', 0.0212, 'lps'),
	(518913, 128, '2014-02-01 01:33:35.000000', 'consum', 0.0213, 'lps'),
	(518914, 128, '2014-02-01 01:33:36.000000', 'consum', 0.0220, 'lps'),
	(518915, 128, '2014-02-01 01:33:37.000000', 'consum', 0.0223, 'lps'),
	(518916, 128, '2014-02-01 01:33:38.000000', 'consum', 0.0216, 'lps'),
	(518917, 128, '2014-02-01 01:33:39.000000', 'consum', 0.0215, 'lps'),
	(518918, 128, '2014-02-01 01:33:40.000000', 'consum', 0.0218, 'lps'),
	(518919, 128, '2014-02-01 01:33:41.000000', 'consum', 0.0222, 'lps'),
	(518920, 128, '2014-02-01 01:33:42.000000', 'consum', 0.0220, 'lps'),
	(518921, 128, '2014-02-01 01:33:43.000000', 'consum', 0.0222, 'lps'),
	(518922, 128, '2014-02-01 01:33:44.000000', 'consum', 0.0213, 'lps'),
	(518923, 128, '2014-02-01 01:33:45.000000', 'consum', 0.0220, 'lps'),
	(518924, 128, '2014-02-01 01:33:46.000000', 'consum', 0.0221, 'lps'),
	(518925, 128, '2014-02-01 01:33:47.000000', 'consum', 0.0210, 'lps'),
	(518926, 128, '2014-02-01 01:33:48.000000', 'consum', 0.0218, 'lps'),
	(518927, 128, '2014-02-01 01:33:49.000000', 'consum', 0.0210, 'lps'),
	(518928, 128, '2014-02-01 01:33:50.000000', 'consum', 0.0214, 'lps'),
	(518929, 128, '2014-02-01 01:33:51.000000', 'consum', 0.0215, 'lps'),
	(518930, 128, '2014-02-01 01:33:52.000000', 'consum', 0.0211, 'lps'),
	(518931, 128, '2014-02-01 01:33:53.000000', 'consum', 0.0212, 'lps'),
	(518932, 128, '2014-02-01 01:33:54.000000', 'consum', 0.0220, 'lps'),
	(518933, 128, '2014-02-01 01:33:55.000000', 'consum', 0.0210, 'lps'),
	(518934, 128, '2014-02-01 01:33:56.000000', 'consum', 0.0210, 'lps'),
	(518935, 128, '2014-02-01 01:33:57.000000', 'consum', 0.0211, 'lps'),
	(518936, 128, '2014-02-01 01:33:58.000000', 'consum', 0.0214, 'lps'),
	(518937, 128, '2014-02-01 01:33:59.000000', 'consum', 0.0214, 'lps'),
	(518938, 128, '2014-02-01 01:34:00.000000', 'consum', 0.0219, 'lps'),
	(518939, 128, '2014-02-01 01:34:01.000000', 'consum', 0.0213, 'lps'),
	(518940, 128, '2014-02-01 01:34:02.000000', 'consum', 0.0216, 'lps'),
	(518941, 128, '2014-02-01 01:34:03.000000', 'consum', 0.0216, 'lps'),
	(518942, 128, '2014-02-01 01:34:04.000000', 'consum', 0.0221, 'lps'),
	(518943, 128, '2014-02-01 01:34:05.000000', 'consum', 0.0219, 'lps'),
	(518944, 128, '2014-02-01 01:34:06.000000', 'consum', 0.0210, 'lps'),
	(518945, 128, '2014-02-01 01:34:07.000000', 'consum', 0.0210, 'lps'),
	(518946, 128, '2014-02-01 01:34:08.000000', 'consum', 0.0213, 'lps'),
	(518947, 128, '2014-02-01 01:34:09.000000', 'consum', 0.0211, 'lps'),
	(518948, 128, '2014-02-01 01:34:10.000000', 'consum', 0.0220, 'lps'),
	(518949, 128, '2014-02-01 01:34:11.000000', 'consum', 0.0216, 'lps'),
	(518950, 128, '2014-02-01 01:34:12.000000', 'consum', 0.0210, 'lps'),
	(518951, 128, '2014-02-01 01:34:13.000000', 'consum', 0.0220, 'lps'),
	(518952, 128, '2014-02-01 01:34:14.000000', 'consum', 0.0219, 'lps'),
	(518953, 128, '2014-02-01 01:34:15.000000', 'consum', 0.0212, 'lps'),
	(518954, 128, '2014-02-01 01:34:16.000000', 'consum', 0.0222, 'lps'),
	(518955, 128, '2014-02-01 01:34:17.000000', 'consum', 0.0210, 'lps'),
	(518956, 128, '2014-02-01 01:34:18.000000', 'consum', 0.0213, 'lps'),
	(518957, 128, '2014-02-01 01:34:19.000000', 'consum', 0.0213, 'lps'),
	(518958, 128, '2014-02-01 01:34:20.000000', 'consum', 0.0219, 'lps'),
	(518959, 128, '2014-02-01 01:34:21.000000', 'consum', 0.0215, 'lps'),
	(518960, 128, '2014-02-01 01:34:22.000000', 'consum', 0.0222, 'lps'),
	(518961, 128, '2014-02-01 01:34:23.000000', 'consum', 0.0215, 'lps'),
	(518962, 128, '2014-02-01 01:34:24.000000', 'consum', 0.0214, 'lps'),
	(518963, 128, '2014-02-01 01:34:25.000000', 'consum', 0.0216, 'lps'),
	(518964, 128, '2014-02-01 01:34:26.000000', 'consum', 0.0213, 'lps'),
	(518965, 128, '2014-02-01 01:34:27.000000', 'consum', 0.0223, 'lps'),
	(518966, 128, '2014-02-01 01:34:28.000000', 'consum', 0.0212, 'lps'),
	(518967, 128, '2014-02-01 01:34:29.000000', 'consum', 0.0220, 'lps'),
	(518968, 128, '2014-02-01 01:34:30.000000', 'consum', 0.0215, 'lps'),
	(518969, 128, '2014-02-01 01:34:31.000000', 'consum', 0.0219, 'lps'),
	(518970, 128, '2014-02-01 01:34:32.000000', 'consum', 0.0213, 'lps'),
	(518971, 128, '2014-02-01 01:34:33.000000', 'consum', 0.0212, 'lps'),
	(518972, 128, '2014-02-01 01:34:34.000000', 'consum', 0.0214, 'lps'),
	(518973, 128, '2014-02-01 01:34:35.000000', 'consum', 0.0221, 'lps'),
	(518974, 128, '2014-02-01 01:34:36.000000', 'consum', 0.0212, 'lps'),
	(518975, 128, '2014-02-01 01:34:37.000000', 'consum', 0.0217, 'lps'),
	(518976, 128, '2014-02-01 01:34:38.000000', 'consum', 0.0223, 'lps'),
	(518977, 128, '2014-02-01 01:34:39.000000', 'consum', 0.0212, 'lps'),
	(518978, 128, '2014-02-01 01:34:40.000000', 'consum', 0.0212, 'lps'),
	(518979, 128, '2014-02-01 01:34:41.000000', 'consum', 0.0214, 'lps'),
	(518980, 128, '2014-02-01 01:34:42.000000', 'consum', 0.0223, 'lps'),
	(518981, 128, '2014-02-01 01:34:43.000000', 'consum', 0.0221, 'lps'),
	(518982, 128, '2014-02-01 01:34:44.000000', 'consum', 0.0214, 'lps'),
	(518983, 128, '2014-02-01 01:34:45.000000', 'consum', 0.0213, 'lps'),
	(518984, 128, '2014-02-01 01:34:46.000000', 'consum', 0.0213, 'lps'),
	(518985, 128, '2014-02-01 01:34:47.000000', 'consum', 0.0217, 'lps'),
	(518986, 128, '2014-02-01 01:34:48.000000', 'consum', 0.0223, 'lps'),
	(518987, 128, '2014-02-01 01:34:49.000000', 'consum', 0.0210, 'lps'),
	(518988, 128, '2014-02-01 01:34:50.000000', 'consum', 0.0213, 'lps'),
	(518989, 128, '2014-02-01 01:34:51.000000', 'consum', 0.0212, 'lps'),
	(518990, 128, '2014-02-01 01:34:52.000000', 'consum', 0.0210, 'lps'),
	(518991, 128, '2014-02-01 01:34:53.000000', 'consum', 0.0221, 'lps'),
	(518992, 128, '2014-02-01 01:34:54.000000', 'consum', 0.0210, 'lps'),
	(518993, 128, '2014-02-01 01:34:55.000000', 'consum', 0.0220, 'lps'),
	(518994, 128, '2014-02-01 01:34:56.000000', 'consum', 0.0218, 'lps'),
	(518995, 128, '2014-02-01 01:34:57.000000', 'consum', 0.0220, 'lps'),
	(518996, 128, '2014-02-01 01:34:58.000000', 'consum', 0.0222, 'lps'),
	(518997, 128, '2014-02-01 01:34:59.000000', 'consum', 0.0213, 'lps'),
	(518998, 128, '2014-02-01 01:35:00.000000', 'consum', 0.0219, 'lps'),
	(518999, 128, '2014-02-01 01:35:01.000000', 'consum', 0.0217, 'lps'),
	(519000, 128, '2014-02-01 01:35:02.000000', 'consum', 0.0219, 'lps'),
	(519001, 128, '2014-02-01 01:35:03.000000', 'consum', 0.0222, 'lps'),
	(519002, 128, '2014-02-01 01:35:04.000000', 'consum', 0.0213, 'lps'),
	(519003, 128, '2014-02-01 01:35:05.000000', 'consum', 0.0219, 'lps'),
	(519004, 128, '2014-02-01 01:35:06.000000', 'consum', 0.0218, 'lps'),
	(519005, 128, '2014-02-01 01:35:07.000000', 'consum', 0.0211, 'lps'),
	(519006, 128, '2014-02-01 01:35:08.000000', 'consum', 0.0218, 'lps'),
	(519007, 128, '2014-02-01 01:35:09.000000', 'consum', 0.0220, 'lps'),
	(519008, 128, '2014-02-01 01:35:10.000000', 'consum', 0.0222, 'lps'),
	(519009, 128, '2014-02-01 01:35:11.000000', 'consum', 0.0212, 'lps'),
	(519010, 128, '2014-02-01 01:35:12.000000', 'consum', 0.0211, 'lps'),
	(519011, 128, '2014-02-01 01:35:13.000000', 'consum', 0.0211, 'lps'),
	(519012, 128, '2014-02-01 01:35:14.000000', 'consum', 0.0212, 'lps'),
	(519013, 128, '2014-02-01 01:35:15.000000', 'consum', 0.0217, 'lps'),
	(519014, 128, '2014-02-01 01:35:16.000000', 'consum', 0.0213, 'lps'),
	(519015, 128, '2014-02-01 01:35:17.000000', 'consum', 0.0219, 'lps'),
	(519016, 128, '2014-02-01 01:35:18.000000', 'consum', 0.0216, 'lps'),
	(519017, 128, '2014-02-01 01:35:19.000000', 'consum', 0.0216, 'lps'),
	(519018, 128, '2014-02-01 01:35:20.000000', 'consum', 0.0221, 'lps'),
	(519019, 128, '2014-02-01 01:35:21.000000', 'consum', 0.0221, 'lps'),
	(519020, 128, '2014-02-01 01:35:22.000000', 'consum', 0.0219, 'lps'),
	(519021, 128, '2014-02-01 01:35:23.000000', 'consum', 0.0221, 'lps'),
	(519022, 128, '2014-02-01 01:35:24.000000', 'consum', 0.0210, 'lps'),
	(519023, 128, '2014-02-01 01:35:25.000000', 'consum', 0.0221, 'lps'),
	(519024, 128, '2014-02-01 01:35:26.000000', 'consum', 0.0221, 'lps'),
	(519025, 128, '2014-02-01 01:35:27.000000', 'consum', 0.0220, 'lps'),
	(519026, 128, '2014-02-01 01:35:28.000000', 'consum', 0.0212, 'lps'),
	(519027, 128, '2014-02-01 01:35:29.000000', 'consum', 0.0218, 'lps'),
	(519028, 128, '2014-02-01 01:35:30.000000', 'consum', 0.0216, 'lps'),
	(519029, 128, '2014-02-01 01:35:31.000000', 'consum', 0.0219, 'lps'),
	(519030, 128, '2014-02-01 01:35:32.000000', 'consum', 0.0221, 'lps'),
	(519031, 128, '2014-02-01 01:35:33.000000', 'consum', 0.0223, 'lps'),
	(519032, 128, '2014-02-01 01:35:34.000000', 'consum', 0.0218, 'lps'),
	(519033, 128, '2014-02-01 01:35:35.000000', 'consum', 0.0210, 'lps'),
	(519034, 128, '2014-02-01 01:35:36.000000', 'consum', 0.0216, 'lps'),
	(519035, 128, '2014-02-01 01:35:37.000000', 'consum', 0.0210, 'lps'),
	(519036, 128, '2014-02-01 01:35:38.000000', 'consum', 0.0223, 'lps'),
	(519037, 128, '2014-02-01 01:35:39.000000', 'consum', 0.0217, 'lps'),
	(519038, 128, '2014-02-01 01:35:40.000000', 'consum', 0.0220, 'lps'),
	(519039, 128, '2014-02-01 01:35:41.000000', 'consum', 0.0213, 'lps'),
	(519040, 128, '2014-02-01 01:35:42.000000', 'consum', 0.0210, 'lps'),
	(519041, 128, '2014-02-01 01:35:43.000000', 'consum', 0.0214, 'lps'),
	(519042, 128, '2014-02-01 01:35:44.000000', 'consum', 0.0216, 'lps'),
	(519043, 128, '2014-02-01 01:35:45.000000', 'consum', 0.0216, 'lps'),
	(519044, 128, '2014-02-01 01:35:46.000000', 'consum', 0.0220, 'lps'),
	(519045, 128, '2014-02-01 01:35:47.000000', 'consum', 0.0216, 'lps'),
	(519046, 128, '2014-02-01 01:35:48.000000', 'consum', 0.0210, 'lps'),
	(519047, 128, '2014-02-01 01:35:49.000000', 'consum', 0.0222, 'lps'),
	(519048, 128, '2014-02-01 01:35:50.000000', 'consum', 0.0214, 'lps'),
	(519049, 128, '2014-02-01 01:35:51.000000', 'consum', 0.0210, 'lps'),
	(519050, 128, '2014-02-01 01:35:52.000000', 'consum', 0.0210, 'lps'),
	(519051, 128, '2014-02-01 01:35:53.000000', 'consum', 0.0212, 'lps'),
	(519052, 128, '2014-02-01 01:35:54.000000', 'consum', 0.0218, 'lps'),
	(519053, 128, '2014-02-01 01:35:55.000000', 'consum', 0.0220, 'lps'),
	(519054, 128, '2014-02-01 01:35:56.000000', 'consum', 0.0221, 'lps'),
	(519055, 128, '2014-02-01 01:35:57.000000', 'consum', 0.0221, 'lps'),
	(519056, 128, '2014-02-01 01:35:58.000000', 'consum', 0.0220, 'lps'),
	(519057, 128, '2014-02-01 01:35:59.000000', 'consum', 0.0214, 'lps'),
	(519058, 128, '2014-02-01 01:36:00.000000', 'consum', 0.0212, 'lps'),
	(519059, 128, '2014-02-01 01:36:01.000000', 'consum', 0.0210, 'lps'),
	(519060, 129, '2014-02-01 00:00:00.000000', 'consum', 0.0221, 'lps'),
	(519061, 129, '2014-02-01 00:00:01.000000', 'consum', 0.0217, 'lps'),
	(519062, 129, '2014-02-01 00:00:02.000000', 'consum', 0.0214, 'lps'),
	(519063, 129, '2014-02-01 00:00:03.000000', 'consum', 0.0210, 'lps'),
	(519064, 129, '2014-02-01 00:00:04.000000', 'consum', 0.0219, 'lps'),
	(519065, 129, '2014-02-01 00:00:05.000000', 'consum', 0.0212, 'lps'),
	(519066, 129, '2014-02-01 00:00:06.000000', 'consum', 0.0217, 'lps'),
	(519067, 129, '2014-02-01 00:00:07.000000', 'consum', 0.0215, 'lps'),
	(519068, 129, '2014-02-01 00:00:08.000000', 'consum', 0.0215, 'lps'),
	(519069, 129, '2014-02-01 00:00:09.000000', 'consum', 0.0220, 'lps'),
	(519070, 129, '2014-02-01 00:00:10.000000', 'consum', 0.0225, 'lps'),
	(519071, 129, '2014-02-01 00:00:11.000000', 'consum', 0.0231, 'lps'),
	(519072, 129, '2014-02-01 00:00:12.000000', 'consum', 0.0228, 'lps'),
	(519073, 129, '2014-02-01 00:00:13.000000', 'consum', 0.0213, 'lps'),
	(519074, 129, '2014-02-01 00:00:14.000000', 'consum', 0.0218, 'lps'),
	(519075, 129, '2014-02-01 00:00:15.000000', 'consum', 0.0220, 'lps'),
	(519076, 129, '2014-02-01 00:00:16.000000', 'consum', 0.0213, 'lps'),
	(519077, 129, '2014-02-01 00:00:17.000000', 'consum', 0.0219, 'lps'),
	(519078, 129, '2014-02-01 00:00:18.000000', 'consum', 0.0222, 'lps'),
	(519079, 129, '2014-02-01 00:00:19.000000', 'consum', 0.0222, 'lps'),
	(519080, 129, '2014-02-01 00:00:20.000000', 'consum', 0.0211, 'lps'),
	(519081, 129, '2014-02-01 00:00:21.000000', 'consum', 0.0225, 'lps'),
	(519082, 129, '2014-02-01 00:00:22.000000', 'consum', 0.0218, 'lps'),
	(519083, 129, '2014-02-01 00:00:23.000000', 'consum', 0.0228, 'lps'),
	(519084, 129, '2014-02-01 00:00:24.000000', 'consum', 0.0211, 'lps'),
	(519085, 129, '2014-02-01 00:00:25.000000', 'consum', 0.0228, 'lps'),
	(519086, 129, '2014-02-01 00:00:26.000000', 'consum', 0.0229, 'lps'),
	(519087, 129, '2014-02-01 00:00:27.000000', 'consum', 0.0211, 'lps'),
	(519088, 129, '2014-02-01 00:00:28.000000', 'consum', 0.0221, 'lps'),
	(519089, 129, '2014-02-01 00:00:29.000000', 'consum', 0.0219, 'lps'),
	(519090, 129, '2014-02-01 00:00:30.000000', 'consum', 0.0223, 'lps'),
	(519091, 129, '2014-02-01 00:00:31.000000', 'consum', 0.0228, 'lps'),
	(519092, 129, '2014-02-01 00:00:32.000000', 'consum', 0.0217, 'lps'),
	(519093, 129, '2014-02-01 00:00:33.000000', 'consum', 0.0211, 'lps'),
	(519094, 129, '2014-02-01 00:00:34.000000', 'consum', 0.0219, 'lps'),
	(519095, 129, '2014-02-01 00:00:35.000000', 'consum', 0.0230, 'lps'),
	(519096, 129, '2014-02-01 00:00:36.000000', 'consum', 0.0218, 'lps'),
	(519097, 129, '2014-02-01 00:00:37.000000', 'consum', 0.0212, 'lps'),
	(519098, 129, '2014-02-01 00:00:38.000000', 'consum', 0.0217, 'lps'),
	(519099, 129, '2014-02-01 00:00:39.000000', 'consum', 0.0217, 'lps'),
	(519100, 129, '2014-02-01 00:00:40.000000', 'consum', 0.0226, 'lps'),
	(519101, 129, '2014-02-01 00:00:41.000000', 'consum', 0.0224, 'lps'),
	(519102, 129, '2014-02-01 00:00:42.000000', 'consum', 0.0210, 'lps'),
	(519103, 129, '2014-02-01 00:00:43.000000', 'consum', 0.0212, 'lps'),
	(519104, 129, '2014-02-01 00:00:44.000000', 'consum', 0.0222, 'lps'),
	(519105, 129, '2014-02-01 00:00:45.000000', 'consum', 0.0221, 'lps'),
	(519106, 129, '2014-02-01 00:00:46.000000', 'consum', 0.0229, 'lps'),
	(519107, 129, '2014-02-01 00:00:47.000000', 'consum', 0.0229, 'lps'),
	(519108, 129, '2014-02-01 00:00:48.000000', 'consum', 0.0227, 'lps'),
	(519109, 129, '2014-02-01 00:00:49.000000', 'consum', 0.0216, 'lps'),
	(519110, 129, '2014-02-01 00:00:50.000000', 'consum', 0.0210, 'lps'),
	(519111, 129, '2014-02-01 00:00:51.000000', 'consum', 0.0213, 'lps'),
	(519112, 129, '2014-02-01 00:00:52.000000', 'consum', 0.0229, 'lps'),
	(519113, 129, '2014-02-01 00:00:53.000000', 'consum', 0.0229, 'lps'),
	(519114, 129, '2014-02-01 00:00:54.000000', 'consum', 0.0229, 'lps'),
	(519115, 129, '2014-02-01 00:00:55.000000', 'consum', 0.0224, 'lps'),
	(519116, 129, '2014-02-01 00:00:56.000000', 'consum', 0.0222, 'lps'),
	(519117, 129, '2014-02-01 00:00:57.000000', 'consum', 0.0210, 'lps'),
	(519118, 129, '2014-02-01 00:00:58.000000', 'consum', 0.0216, 'lps'),
	(519119, 129, '2014-02-01 00:00:59.000000', 'consum', 0.0218, 'lps'),
	(519120, 129, '2014-02-01 00:01:00.000000', 'consum', 0.0211, 'lps'),
	(519121, 129, '2014-02-01 00:01:01.000000', 'consum', 0.0216, 'lps'),
	(519122, 129, '2014-02-01 00:01:02.000000', 'consum', 0.0213, 'lps'),
	(519123, 129, '2014-02-01 00:01:03.000000', 'consum', 0.0229, 'lps'),
	(519124, 129, '2014-02-01 00:01:04.000000', 'consum', 0.0210, 'lps'),
	(519125, 129, '2014-02-01 00:01:05.000000', 'consum', 0.0217, 'lps'),
	(519126, 129, '2014-02-01 00:01:06.000000', 'consum', 0.0227, 'lps'),
	(519127, 129, '2014-02-01 00:01:07.000000', 'consum', 0.0228, 'lps'),
	(519128, 129, '2014-02-01 00:01:08.000000', 'consum', 0.0229, 'lps'),
	(519129, 129, '2014-02-01 00:01:09.000000', 'consum', 0.0230, 'lps'),
	(519130, 129, '2014-02-01 00:01:10.000000', 'consum', 0.0230, 'lps'),
	(519131, 129, '2014-02-01 00:01:11.000000', 'consum', 0.0227, 'lps'),
	(519132, 129, '2014-02-01 00:01:12.000000', 'consum', 0.0215, 'lps'),
	(519133, 129, '2014-02-01 00:01:13.000000', 'consum', 0.0227, 'lps'),
	(519134, 129, '2014-02-01 00:01:14.000000', 'consum', 0.0214, 'lps'),
	(519135, 129, '2014-02-01 00:01:15.000000', 'consum', 0.0224, 'lps'),
	(519136, 129, '2014-02-01 00:01:16.000000', 'consum', 0.0225, 'lps'),
	(519137, 129, '2014-02-01 00:01:17.000000', 'consum', 0.0221, 'lps'),
	(519138, 129, '2014-02-01 00:01:18.000000', 'consum', 0.0222, 'lps'),
	(519139, 129, '2014-02-01 00:01:19.000000', 'consum', 0.0213, 'lps'),
	(519140, 129, '2014-02-01 00:01:20.000000', 'consum', 0.0214, 'lps'),
	(519141, 129, '2014-02-01 00:01:21.000000', 'consum', 0.0221, 'lps'),
	(519142, 129, '2014-02-01 00:01:22.000000', 'consum', 0.0210, 'lps'),
	(519143, 129, '2014-02-01 00:01:23.000000', 'consum', 0.0219, 'lps'),
	(519144, 129, '2014-02-01 00:01:24.000000', 'consum', 0.0214, 'lps'),
	(519145, 129, '2014-02-01 00:01:25.000000', 'consum', 0.0226, 'lps'),
	(519146, 129, '2014-02-01 00:01:26.000000', 'consum', 0.0212, 'lps'),
	(519147, 129, '2014-02-01 00:01:27.000000', 'consum', 0.0216, 'lps'),
	(519148, 129, '2014-02-01 00:01:28.000000', 'consum', 0.0211, 'lps'),
	(519149, 129, '2014-02-01 00:01:29.000000', 'consum', 0.0221, 'lps'),
	(519150, 129, '2014-02-01 00:01:30.000000', 'consum', 0.0217, 'lps'),
	(519151, 129, '2014-02-01 00:01:31.000000', 'consum', 0.0213, 'lps'),
	(519152, 129, '2014-02-01 00:01:32.000000', 'consum', 0.0228, 'lps'),
	(519153, 129, '2014-02-01 00:01:33.000000', 'consum', 0.0224, 'lps'),
	(519154, 129, '2014-02-01 00:01:34.000000', 'consum', 0.0226, 'lps'),
	(519155, 129, '2014-02-01 00:01:35.000000', 'consum', 0.0229, 'lps'),
	(519156, 129, '2014-02-01 00:01:36.000000', 'consum', 0.0211, 'lps'),
	(519157, 129, '2014-02-01 00:01:37.000000', 'consum', 0.0224, 'lps'),
	(519158, 129, '2014-02-01 00:01:38.000000', 'consum', 0.0212, 'lps'),
	(519159, 129, '2014-02-01 00:01:39.000000', 'consum', 0.0224, 'lps'),
	(519160, 129, '2014-02-01 00:01:40.000000', 'consum', 0.0228, 'lps'),
	(519161, 129, '2014-02-01 00:01:41.000000', 'consum', 0.0215, 'lps'),
	(519162, 129, '2014-02-01 00:01:42.000000', 'consum', 0.0224, 'lps'),
	(519163, 129, '2014-02-01 00:01:43.000000', 'consum', 0.0224, 'lps'),
	(519164, 129, '2014-02-01 00:01:44.000000', 'consum', 0.0217, 'lps'),
	(519165, 129, '2014-02-01 00:01:45.000000', 'consum', 0.0225, 'lps'),
	(519166, 129, '2014-02-01 00:01:46.000000', 'consum', 0.0219, 'lps'),
	(519167, 129, '2014-02-01 00:01:47.000000', 'consum', 0.0212, 'lps'),
	(519168, 129, '2014-02-01 00:01:48.000000', 'consum', 0.0214, 'lps'),
	(519169, 129, '2014-02-01 00:01:49.000000', 'consum', 0.0227, 'lps'),
	(519170, 129, '2014-02-01 00:01:50.000000', 'consum', 0.0217, 'lps'),
	(519171, 129, '2014-02-01 00:01:51.000000', 'consum', 0.0217, 'lps'),
	(519172, 129, '2014-02-01 00:01:52.000000', 'consum', 0.0224, 'lps'),
	(519173, 129, '2014-02-01 00:01:53.000000', 'consum', 0.0213, 'lps'),
	(519174, 129, '2014-02-01 00:01:54.000000', 'consum', 0.0230, 'lps'),
	(519175, 129, '2014-02-01 00:01:55.000000', 'consum', 0.0215, 'lps'),
	(519176, 129, '2014-02-01 00:01:56.000000', 'consum', 0.0218, 'lps'),
	(519177, 129, '2014-02-01 00:01:57.000000', 'consum', 0.0212, 'lps'),
	(519178, 129, '2014-02-01 00:01:58.000000', 'consum', 0.0220, 'lps'),
	(519179, 129, '2014-02-01 00:01:59.000000', 'consum', 0.0211, 'lps'),
	(519180, 129, '2014-02-01 00:02:00.000000', 'consum', 0.0231, 'lps'),
	(519181, 129, '2014-02-01 00:02:01.000000', 'consum', 0.0223, 'lps'),
	(519182, 129, '2014-02-01 00:02:02.000000', 'consum', 0.0210, 'lps'),
	(519183, 129, '2014-02-01 00:02:03.000000', 'consum', 0.0219, 'lps'),
	(519184, 129, '2014-02-01 00:02:04.000000', 'consum', 0.0210, 'lps'),
	(519185, 129, '2014-02-01 00:02:05.000000', 'consum', 0.0229, 'lps'),
	(519186, 129, '2014-02-01 00:02:06.000000', 'consum', 0.0217, 'lps'),
	(519187, 129, '2014-02-01 00:02:07.000000', 'consum', 0.0210, 'lps'),
	(519188, 129, '2014-02-01 00:02:08.000000', 'consum', 0.0210, 'lps'),
	(519189, 129, '2014-02-01 00:02:09.000000', 'consum', 0.0213, 'lps'),
	(519190, 129, '2014-02-01 00:02:10.000000', 'consum', 0.0226, 'lps'),
	(519191, 129, '2014-02-01 00:02:11.000000', 'consum', 0.0215, 'lps'),
	(519192, 129, '2014-02-01 00:02:12.000000', 'consum', 0.0211, 'lps'),
	(519193, 129, '2014-02-01 00:02:13.000000', 'consum', 0.0222, 'lps'),
	(519194, 129, '2014-02-01 00:02:14.000000', 'consum', 0.0224, 'lps'),
	(519195, 129, '2014-02-01 00:02:15.000000', 'consum', 0.0220, 'lps'),
	(519196, 129, '2014-02-01 00:02:16.000000', 'consum', 0.0220, 'lps'),
	(519197, 129, '2014-02-01 00:02:17.000000', 'consum', 0.0210, 'lps'),
	(519198, 129, '2014-02-01 00:02:18.000000', 'consum', 0.0222, 'lps'),
	(519199, 129, '2014-02-01 00:02:19.000000', 'consum', 0.0229, 'lps'),
	(519200, 129, '2014-02-01 00:02:20.000000', 'consum', 0.0225, 'lps'),
	(519201, 129, '2014-02-01 00:02:21.000000', 'consum', 0.0227, 'lps'),
	(519202, 129, '2014-02-01 00:02:22.000000', 'consum', 0.0228, 'lps'),
	(519203, 129, '2014-02-01 00:02:23.000000', 'consum', 0.0230, 'lps'),
	(519204, 129, '2014-02-01 00:02:24.000000', 'consum', 0.0212, 'lps'),
	(519205, 129, '2014-02-01 00:02:25.000000', 'consum', 0.0226, 'lps'),
	(519206, 129, '2014-02-01 00:02:26.000000', 'consum', 0.0219, 'lps'),
	(519207, 129, '2014-02-01 00:02:27.000000', 'consum', 0.0227, 'lps'),
	(519208, 129, '2014-02-01 00:02:28.000000', 'consum', 0.0228, 'lps'),
	(519209, 129, '2014-02-01 00:02:29.000000', 'consum', 0.0224, 'lps'),
	(519210, 129, '2014-02-01 00:02:30.000000', 'consum', 0.0229, 'lps'),
	(519211, 129, '2014-02-01 00:02:31.000000', 'consum', 0.0221, 'lps'),
	(519212, 129, '2014-02-01 00:02:32.000000', 'consum', 0.0229, 'lps'),
	(519213, 129, '2014-02-01 00:02:33.000000', 'consum', 0.0227, 'lps'),
	(519214, 129, '2014-02-01 00:02:34.000000', 'consum', 0.0218, 'lps'),
	(519215, 129, '2014-02-01 00:02:35.000000', 'consum', 0.0221, 'lps'),
	(519216, 129, '2014-02-01 00:02:36.000000', 'consum', 0.0221, 'lps'),
	(519217, 129, '2014-02-01 00:02:37.000000', 'consum', 0.0230, 'lps'),
	(519218, 129, '2014-02-01 00:02:38.000000', 'consum', 0.0212, 'lps'),
	(519219, 129, '2014-02-01 00:02:39.000000', 'consum', 0.0225, 'lps'),
	(519220, 129, '2014-02-01 00:02:40.000000', 'consum', 0.0215, 'lps'),
	(519221, 129, '2014-02-01 00:02:41.000000', 'consum', 0.0212, 'lps'),
	(519222, 129, '2014-02-01 00:02:42.000000', 'consum', 0.0227, 'lps'),
	(519223, 129, '2014-02-01 00:02:43.000000', 'consum', 0.0224, 'lps'),
	(519224, 129, '2014-02-01 00:02:44.000000', 'consum', 0.0230, 'lps'),
	(519225, 129, '2014-02-01 00:02:45.000000', 'consum', 0.0224, 'lps'),
	(519226, 129, '2014-02-01 00:02:46.000000', 'consum', 0.0223, 'lps'),
	(519227, 129, '2014-02-01 00:02:47.000000', 'consum', 0.0230, 'lps'),
	(519228, 129, '2014-02-01 00:02:48.000000', 'consum', 0.0229, 'lps'),
	(519229, 129, '2014-02-01 00:02:49.000000', 'consum', 0.0222, 'lps'),
	(519230, 129, '2014-02-01 00:02:50.000000', 'consum', 0.0215, 'lps'),
	(519231, 129, '2014-02-01 00:02:51.000000', 'consum', 0.0221, 'lps'),
	(519232, 129, '2014-02-01 00:02:52.000000', 'consum', 0.0230, 'lps'),
	(519233, 129, '2014-02-01 00:02:53.000000', 'consum', 0.0230, 'lps'),
	(519234, 129, '2014-02-01 00:02:54.000000', 'consum', 0.0210, 'lps'),
	(519235, 129, '2014-02-01 00:02:55.000000', 'consum', 0.0216, 'lps'),
	(519236, 129, '2014-02-01 00:02:56.000000', 'consum', 0.0220, 'lps'),
	(519237, 129, '2014-02-01 00:02:57.000000', 'consum', 0.0219, 'lps'),
	(519238, 129, '2014-02-01 00:02:58.000000', 'consum', 0.0227, 'lps'),
	(519239, 129, '2014-02-01 00:02:59.000000', 'consum', 0.0223, 'lps'),
	(519240, 129, '2014-02-01 00:03:00.000000', 'consum', 0.0225, 'lps'),
	(519241, 129, '2014-02-01 00:03:01.000000', 'consum', 0.0226, 'lps'),
	(519242, 129, '2014-02-01 00:03:02.000000', 'consum', 0.0220, 'lps'),
	(519243, 129, '2014-02-01 00:03:03.000000', 'consum', 0.0216, 'lps'),
	(519244, 129, '2014-02-01 00:03:04.000000', 'consum', 0.0231, 'lps'),
	(519245, 129, '2014-02-01 00:03:05.000000', 'consum', 0.0231, 'lps'),
	(519246, 129, '2014-02-01 00:03:06.000000', 'consum', 0.0229, 'lps'),
	(519247, 129, '2014-02-01 00:03:07.000000', 'consum', 0.0223, 'lps'),
	(519248, 129, '2014-02-01 00:03:08.000000', 'consum', 0.0219, 'lps'),
	(519249, 129, '2014-02-01 00:03:09.000000', 'consum', 0.0216, 'lps'),
	(519250, 129, '2014-02-01 00:03:10.000000', 'consum', 0.0214, 'lps'),
	(519251, 129, '2014-02-01 00:03:11.000000', 'consum', 0.0210, 'lps'),
	(519252, 129, '2014-02-01 00:03:12.000000', 'consum', 0.0224, 'lps'),
	(519253, 129, '2014-02-01 00:03:13.000000', 'consum', 0.0211, 'lps'),
	(519254, 129, '2014-02-01 00:03:14.000000', 'consum', 0.0220, 'lps'),
	(519255, 129, '2014-02-01 00:03:15.000000', 'consum', 0.0214, 'lps'),
	(519256, 129, '2014-02-01 00:03:16.000000', 'consum', 0.0220, 'lps'),
	(519257, 129, '2014-02-01 00:03:17.000000', 'consum', 0.0229, 'lps'),
	(519258, 129, '2014-02-01 00:03:18.000000', 'consum', 0.0231, 'lps'),
	(519259, 129, '2014-02-01 00:03:19.000000', 'consum', 0.0213, 'lps'),
	(519260, 129, '2014-02-01 00:03:20.000000', 'consum', 0.0231, 'lps'),
	(519261, 129, '2014-02-01 00:03:21.000000', 'consum', 0.0217, 'lps'),
	(519262, 129, '2014-02-01 00:03:22.000000', 'consum', 0.0228, 'lps'),
	(519263, 129, '2014-02-01 00:03:23.000000', 'consum', 0.0212, 'lps'),
	(519264, 129, '2014-02-01 00:03:24.000000', 'consum', 0.0213, 'lps'),
	(519265, 129, '2014-02-01 00:03:25.000000', 'consum', 0.0217, 'lps'),
	(519266, 129, '2014-02-01 00:03:26.000000', 'consum', 0.0216, 'lps'),
	(519267, 129, '2014-02-01 00:03:27.000000', 'consum', 0.0217, 'lps'),
	(519268, 129, '2014-02-01 00:03:28.000000', 'consum', 0.0229, 'lps'),
	(519269, 129, '2014-02-01 00:03:29.000000', 'consum', 0.0217, 'lps'),
	(519270, 129, '2014-02-01 00:03:30.000000', 'consum', 0.0210, 'lps'),
	(519271, 129, '2014-02-01 00:03:31.000000', 'consum', 0.0214, 'lps'),
	(519272, 129, '2014-02-01 00:03:32.000000', 'consum', 0.0228, 'lps'),
	(519273, 129, '2014-02-01 00:03:33.000000', 'consum', 0.0225, 'lps'),
	(519274, 129, '2014-02-01 00:03:34.000000', 'consum', 0.0210, 'lps'),
	(519275, 129, '2014-02-01 00:03:35.000000', 'consum', 0.0230, 'lps'),
	(519276, 129, '2014-02-01 00:03:36.000000', 'consum', 0.0223, 'lps'),
	(519277, 129, '2014-02-01 00:03:37.000000', 'consum', 0.0214, 'lps'),
	(519278, 129, '2014-02-01 00:03:38.000000', 'consum', 0.0216, 'lps'),
	(519279, 129, '2014-02-01 00:03:39.000000', 'consum', 0.0229, 'lps'),
	(519280, 129, '2014-02-01 00:03:40.000000', 'consum', 0.0219, 'lps'),
	(519281, 129, '2014-02-01 00:03:41.000000', 'consum', 0.0221, 'lps'),
	(519282, 129, '2014-02-01 00:03:42.000000', 'consum', 0.0215, 'lps'),
	(519283, 129, '2014-02-01 00:03:43.000000', 'consum', 0.0225, 'lps'),
	(519284, 129, '2014-02-01 00:03:44.000000', 'consum', 0.0227, 'lps'),
	(519285, 129, '2014-02-01 00:03:45.000000', 'consum', 0.0228, 'lps'),
	(519286, 129, '2014-02-01 00:03:46.000000', 'consum', 0.0227, 'lps'),
	(519287, 129, '2014-02-01 00:03:47.000000', 'consum', 0.0220, 'lps'),
	(519288, 129, '2014-02-01 00:03:48.000000', 'consum', 0.0230, 'lps'),
	(519289, 129, '2014-02-01 00:03:49.000000', 'consum', 0.0217, 'lps'),
	(519290, 129, '2014-02-01 00:03:50.000000', 'consum', 0.0228, 'lps'),
	(519291, 129, '2014-02-01 00:03:51.000000', 'consum', 0.0214, 'lps'),
	(519292, 129, '2014-02-01 00:03:52.000000', 'consum', 0.0222, 'lps'),
	(519293, 129, '2014-02-01 00:03:53.000000', 'consum', 0.0215, 'lps'),
	(519294, 129, '2014-02-01 00:03:54.000000', 'consum', 0.0220, 'lps'),
	(519295, 129, '2014-02-01 00:03:55.000000', 'consum', 0.0222, 'lps'),
	(519296, 129, '2014-02-01 00:03:56.000000', 'consum', 0.0221, 'lps'),
	(519297, 129, '2014-02-01 00:03:57.000000', 'consum', 0.0228, 'lps'),
	(519298, 129, '2014-02-01 00:03:58.000000', 'consum', 0.0224, 'lps'),
	(519299, 129, '2014-02-01 00:03:59.000000', 'consum', 0.0228, 'lps'),
	(519300, 129, '2014-02-01 00:04:00.000000', 'consum', 0.0214, 'lps'),
	(519301, 129, '2014-02-01 00:04:01.000000', 'consum', 0.0218, 'lps'),
	(519302, 129, '2014-02-01 00:04:02.000000', 'consum', 0.0219, 'lps'),
	(519303, 129, '2014-02-01 00:04:03.000000', 'consum', 0.0230, 'lps'),
	(519304, 129, '2014-02-01 00:04:04.000000', 'consum', 0.0220, 'lps'),
	(519305, 129, '2014-02-01 00:04:05.000000', 'consum', 0.0222, 'lps'),
	(519306, 129, '2014-02-01 00:04:06.000000', 'consum', 0.0217, 'lps'),
	(519307, 129, '2014-02-01 00:04:07.000000', 'consum', 0.0211, 'lps'),
	(519308, 129, '2014-02-01 00:04:08.000000', 'consum', 0.0218, 'lps'),
	(519309, 129, '2014-02-01 00:04:09.000000', 'consum', 0.0223, 'lps'),
	(519310, 129, '2014-02-01 00:04:10.000000', 'consum', 0.0230, 'lps'),
	(519311, 129, '2014-02-01 00:04:11.000000', 'consum', 0.0230, 'lps'),
	(519312, 129, '2014-02-01 00:04:12.000000', 'consum', 0.0225, 'lps'),
	(519313, 129, '2014-02-01 00:04:13.000000', 'consum', 0.0227, 'lps'),
	(519314, 129, '2014-02-01 00:04:14.000000', 'consum', 0.0227, 'lps'),
	(519315, 129, '2014-02-01 00:04:15.000000', 'consum', 0.0222, 'lps'),
	(519316, 129, '2014-02-01 00:04:16.000000', 'consum', 0.0219, 'lps'),
	(519317, 129, '2014-02-01 00:04:17.000000', 'consum', 0.0220, 'lps'),
	(519318, 129, '2014-02-01 00:04:18.000000', 'consum', 0.0211, 'lps'),
	(519319, 129, '2014-02-01 00:04:19.000000', 'consum', 0.0210, 'lps'),
	(519320, 129, '2014-02-01 00:04:20.000000', 'consum', 0.0227, 'lps'),
	(519321, 129, '2014-02-01 00:04:21.000000', 'consum', 0.0230, 'lps'),
	(519322, 129, '2014-02-01 00:04:22.000000', 'consum', 0.0217, 'lps'),
	(519323, 129, '2014-02-01 00:04:23.000000', 'consum', 0.0227, 'lps'),
	(519324, 129, '2014-02-01 00:04:24.000000', 'consum', 0.0210, 'lps'),
	(519325, 129, '2014-02-01 00:04:25.000000', 'consum', 0.0225, 'lps'),
	(519326, 129, '2014-02-01 00:04:26.000000', 'consum', 0.0221, 'lps'),
	(519327, 129, '2014-02-01 00:04:27.000000', 'consum', 0.0219, 'lps'),
	(519328, 129, '2014-02-01 00:04:28.000000', 'consum', 0.0223, 'lps'),
	(519329, 129, '2014-02-01 00:04:29.000000', 'consum', 0.0227, 'lps'),
	(519330, 129, '2014-02-01 00:04:30.000000', 'consum', 0.0213, 'lps'),
	(519331, 129, '2014-02-01 00:04:31.000000', 'consum', 0.0218, 'lps'),
	(519332, 129, '2014-02-01 00:04:32.000000', 'consum', 0.0219, 'lps'),
	(519333, 129, '2014-02-01 00:04:33.000000', 'consum', 0.0212, 'lps'),
	(519334, 129, '2014-02-01 00:04:34.000000', 'consum', 0.0213, 'lps'),
	(519335, 129, '2014-02-01 00:04:35.000000', 'consum', 0.0220, 'lps'),
	(519336, 129, '2014-02-01 00:04:36.000000', 'consum', 0.0230, 'lps'),
	(519337, 129, '2014-02-01 00:04:37.000000', 'consum', 0.0216, 'lps'),
	(519338, 129, '2014-02-01 00:04:38.000000', 'consum', 0.0221, 'lps'),
	(519339, 129, '2014-02-01 00:04:39.000000', 'consum', 0.0228, 'lps'),
	(519340, 129, '2014-02-01 00:04:40.000000', 'consum', 0.0222, 'lps'),
	(519341, 129, '2014-02-01 00:04:41.000000', 'consum', 0.0218, 'lps'),
	(519342, 129, '2014-02-01 00:04:42.000000', 'consum', 0.0216, 'lps'),
	(519343, 129, '2014-02-01 00:04:43.000000', 'consum', 0.0214, 'lps'),
	(519344, 129, '2014-02-01 00:04:44.000000', 'consum', 0.0211, 'lps'),
	(519345, 129, '2014-02-01 00:04:45.000000', 'consum', 0.0228, 'lps'),
	(519346, 129, '2014-02-01 00:04:46.000000', 'consum', 0.0210, 'lps'),
	(519347, 129, '2014-02-01 00:04:47.000000', 'consum', 0.0220, 'lps'),
	(519348, 129, '2014-02-01 00:04:48.000000', 'consum', 0.0218, 'lps'),
	(519349, 129, '2014-02-01 00:04:49.000000', 'consum', 0.0222, 'lps'),
	(519350, 129, '2014-02-01 00:04:50.000000', 'consum', 0.0223, 'lps'),
	(519351, 129, '2014-02-01 00:04:51.000000', 'consum', 0.0218, 'lps'),
	(519352, 129, '2014-02-01 00:04:52.000000', 'consum', 0.0213, 'lps'),
	(519353, 129, '2014-02-01 00:04:53.000000', 'consum', 0.0222, 'lps'),
	(519354, 129, '2014-02-01 00:04:54.000000', 'consum', 0.0219, 'lps'),
	(519355, 129, '2014-02-01 00:04:55.000000', 'consum', 0.0220, 'lps'),
	(519356, 129, '2014-02-01 00:04:56.000000', 'consum', 0.0212, 'lps'),
	(519357, 129, '2014-02-01 00:04:57.000000', 'consum', 0.0213, 'lps'),
	(519358, 129, '2014-02-01 00:04:58.000000', 'consum', 0.0219, 'lps'),
	(519359, 129, '2014-02-01 00:04:59.000000', 'consum', 0.0224, 'lps'),
	(519360, 129, '2014-02-01 00:05:00.000000', 'consum', 0.0231, 'lps'),
	(519361, 129, '2014-02-01 00:05:01.000000', 'consum', 0.0230, 'lps'),
	(519362, 129, '2014-02-01 00:05:02.000000', 'consum', 0.0228, 'lps'),
	(519363, 129, '2014-02-01 00:05:03.000000', 'consum', 0.0215, 'lps'),
	(519364, 129, '2014-02-01 00:05:04.000000', 'consum', 0.0226, 'lps'),
	(519365, 129, '2014-02-01 00:05:05.000000', 'consum', 0.0230, 'lps'),
	(519366, 129, '2014-02-01 00:05:06.000000', 'consum', 0.0220, 'lps'),
	(519367, 129, '2014-02-01 00:05:07.000000', 'consum', 0.0223, 'lps'),
	(519368, 129, '2014-02-01 00:05:08.000000', 'consum', 0.0222, 'lps'),
	(519369, 129, '2014-02-01 00:05:09.000000', 'consum', 0.0210, 'lps'),
	(519370, 129, '2014-02-01 00:05:10.000000', 'consum', 0.0220, 'lps'),
	(519371, 129, '2014-02-01 00:05:11.000000', 'consum', 0.0214, 'lps'),
	(519372, 129, '2014-02-01 00:05:12.000000', 'consum', 0.0226, 'lps'),
	(519373, 129, '2014-02-01 00:05:13.000000', 'consum', 0.0210, 'lps'),
	(519374, 129, '2014-02-01 00:05:14.000000', 'consum', 0.0227, 'lps'),
	(519375, 129, '2014-02-01 00:05:15.000000', 'consum', 0.0231, 'lps'),
	(519376, 129, '2014-02-01 00:05:16.000000', 'consum', 0.0219, 'lps'),
	(519377, 129, '2014-02-01 00:05:17.000000', 'consum', 0.0217, 'lps'),
	(519378, 129, '2014-02-01 00:05:18.000000', 'consum', 0.0216, 'lps'),
	(519379, 129, '2014-02-01 00:05:19.000000', 'consum', 0.0221, 'lps'),
	(519380, 129, '2014-02-01 00:05:20.000000', 'consum', 0.0226, 'lps'),
	(519381, 129, '2014-02-01 00:05:21.000000', 'consum', 0.0213, 'lps'),
	(519382, 129, '2014-02-01 00:05:22.000000', 'consum', 0.0220, 'lps'),
	(519383, 129, '2014-02-01 00:05:23.000000', 'consum', 0.0228, 'lps'),
	(519384, 129, '2014-02-01 00:05:24.000000', 'consum', 0.0230, 'lps'),
	(519385, 129, '2014-02-01 00:05:25.000000', 'consum', 0.0211, 'lps'),
	(519386, 129, '2014-02-01 00:05:26.000000', 'consum', 0.0223, 'lps'),
	(519387, 129, '2014-02-01 00:05:27.000000', 'consum', 0.0229, 'lps'),
	(519388, 129, '2014-02-01 00:05:28.000000', 'consum', 0.0222, 'lps'),
	(519389, 129, '2014-02-01 00:05:29.000000', 'consum', 0.0212, 'lps'),
	(519390, 129, '2014-02-01 00:05:30.000000', 'consum', 0.0231, 'lps'),
	(519391, 129, '2014-02-01 00:05:31.000000', 'consum', 0.0220, 'lps'),
	(519392, 129, '2014-02-01 00:05:32.000000', 'consum', 0.0218, 'lps'),
	(519393, 129, '2014-02-01 00:05:33.000000', 'consum', 0.0220, 'lps'),
	(519394, 129, '2014-02-01 00:05:34.000000', 'consum', 0.0216, 'lps'),
	(519395, 129, '2014-02-01 00:05:35.000000', 'consum', 0.0211, 'lps'),
	(519396, 129, '2014-02-01 00:05:36.000000', 'consum', 0.0217, 'lps'),
	(519397, 129, '2014-02-01 00:05:37.000000', 'consum', 0.0223, 'lps'),
	(519398, 129, '2014-02-01 00:05:38.000000', 'consum', 0.0230, 'lps'),
	(519399, 129, '2014-02-01 00:05:39.000000', 'consum', 0.0230, 'lps'),
	(519400, 129, '2014-02-01 00:05:40.000000', 'consum', 0.0226, 'lps'),
	(519401, 129, '2014-02-01 00:05:41.000000', 'consum', 0.0230, 'lps'),
	(519402, 129, '2014-02-01 00:05:42.000000', 'consum', 0.0220, 'lps'),
	(519403, 129, '2014-02-01 00:05:43.000000', 'consum', 0.0222, 'lps'),
	(519404, 129, '2014-02-01 00:05:44.000000', 'consum', 0.0218, 'lps'),
	(519405, 129, '2014-02-01 00:05:45.000000', 'consum', 0.0215, 'lps'),
	(519406, 129, '2014-02-01 00:05:46.000000', 'consum', 0.0210, 'lps'),
	(519407, 129, '2014-02-01 00:05:47.000000', 'consum', 0.0219, 'lps'),
	(519408, 129, '2014-02-01 00:05:48.000000', 'consum', 0.0211, 'lps'),
	(519409, 129, '2014-02-01 00:05:49.000000', 'consum', 0.0210, 'lps'),
	(519410, 129, '2014-02-01 00:05:50.000000', 'consum', 0.0228, 'lps'),
	(519411, 129, '2014-02-01 00:05:51.000000', 'consum', 0.0215, 'lps'),
	(519412, 129, '2014-02-01 00:05:52.000000', 'consum', 0.0223, 'lps'),
	(519413, 129, '2014-02-01 00:05:53.000000', 'consum', 0.0216, 'lps'),
	(519414, 129, '2014-02-01 00:05:54.000000', 'consum', 0.0224, 'lps'),
	(519415, 129, '2014-02-01 00:05:55.000000', 'consum', 0.0218, 'lps'),
	(519416, 129, '2014-02-01 00:05:56.000000', 'consum', 0.0210, 'lps'),
	(519417, 129, '2014-02-01 00:05:57.000000', 'consum', 0.0230, 'lps'),
	(519418, 129, '2014-02-01 00:05:58.000000', 'consum', 0.0220, 'lps'),
	(519419, 129, '2014-02-01 00:05:59.000000', 'consum', 0.0226, 'lps'),
	(519420, 129, '2014-02-01 00:06:00.000000', 'consum', 0.0216, 'lps'),
	(519421, 129, '2014-02-01 00:06:01.000000', 'consum', 0.0212, 'lps'),
	(519422, 129, '2014-02-01 00:06:02.000000', 'consum', 0.0227, 'lps'),
	(519423, 129, '2014-02-01 00:06:03.000000', 'consum', 0.0221, 'lps'),
	(519424, 129, '2014-02-01 00:06:04.000000', 'consum', 0.0217, 'lps'),
	(519425, 129, '2014-02-01 00:06:05.000000', 'consum', 0.0210, 'lps'),
	(519426, 129, '2014-02-01 00:06:06.000000', 'consum', 0.0211, 'lps'),
	(519427, 129, '2014-02-01 00:06:07.000000', 'consum', 0.0219, 'lps'),
	(519428, 129, '2014-02-01 00:06:08.000000', 'consum', 0.0227, 'lps'),
	(519429, 129, '2014-02-01 00:06:09.000000', 'consum', 0.0225, 'lps'),
	(519430, 129, '2014-02-01 00:06:10.000000', 'consum', 0.0213, 'lps'),
	(519431, 129, '2014-02-01 00:06:11.000000', 'consum', 0.0223, 'lps'),
	(519432, 129, '2014-02-01 00:06:12.000000', 'consum', 0.0222, 'lps'),
	(519433, 129, '2014-02-01 00:06:13.000000', 'consum', 0.0231, 'lps'),
	(519434, 129, '2014-02-01 00:06:14.000000', 'consum', 0.0216, 'lps'),
	(519435, 129, '2014-02-01 00:06:15.000000', 'consum', 0.0221, 'lps'),
	(519436, 129, '2014-02-01 00:06:16.000000', 'consum', 0.0225, 'lps'),
	(519437, 129, '2014-02-01 00:06:17.000000', 'consum', 0.0210, 'lps'),
	(519438, 129, '2014-02-01 00:06:18.000000', 'consum', 0.0231, 'lps'),
	(519439, 129, '2014-02-01 00:06:19.000000', 'consum', 0.0229, 'lps'),
	(519440, 129, '2014-02-01 00:06:20.000000', 'consum', 0.0218, 'lps'),
	(519441, 129, '2014-02-01 00:06:21.000000', 'consum', 0.0216, 'lps'),
	(519442, 129, '2014-02-01 00:06:22.000000', 'consum', 0.0216, 'lps'),
	(519443, 129, '2014-02-01 00:06:23.000000', 'consum', 0.0223, 'lps'),
	(519444, 129, '2014-02-01 00:06:24.000000', 'consum', 0.0214, 'lps'),
	(519445, 129, '2014-02-01 00:06:25.000000', 'consum', 0.0212, 'lps'),
	(519446, 129, '2014-02-01 00:06:26.000000', 'consum', 0.0230, 'lps'),
	(519447, 129, '2014-02-01 00:06:27.000000', 'consum', 0.0218, 'lps'),
	(519448, 129, '2014-02-01 00:06:28.000000', 'consum', 0.0213, 'lps'),
	(519449, 129, '2014-02-01 00:06:29.000000', 'consum', 0.0222, 'lps'),
	(519450, 129, '2014-02-01 00:06:30.000000', 'consum', 0.0220, 'lps'),
	(519451, 129, '2014-02-01 00:06:31.000000', 'consum', 0.0224, 'lps'),
	(519452, 129, '2014-02-01 00:06:32.000000', 'consum', 0.0227, 'lps'),
	(519453, 129, '2014-02-01 00:06:33.000000', 'consum', 0.0210, 'lps'),
	(519454, 129, '2014-02-01 00:06:34.000000', 'consum', 0.0225, 'lps'),
	(519455, 129, '2014-02-01 00:06:35.000000', 'consum', 0.0220, 'lps'),
	(519456, 129, '2014-02-01 00:06:36.000000', 'consum', 0.0214, 'lps'),
	(519457, 129, '2014-02-01 00:06:37.000000', 'consum', 0.0223, 'lps'),
	(519458, 129, '2014-02-01 00:06:38.000000', 'consum', 0.0221, 'lps'),
	(519459, 129, '2014-02-01 00:06:39.000000', 'consum', 0.0226, 'lps'),
	(519460, 129, '2014-02-01 00:06:40.000000', 'consum', 0.0215, 'lps'),
	(519461, 129, '2014-02-01 00:06:41.000000', 'consum', 0.0230, 'lps'),
	(519462, 129, '2014-02-01 00:06:42.000000', 'consum', 0.0230, 'lps'),
	(519463, 129, '2014-02-01 00:06:43.000000', 'consum', 0.0227, 'lps'),
	(519464, 129, '2014-02-01 00:06:44.000000', 'consum', 0.0213, 'lps'),
	(519465, 129, '2014-02-01 00:06:45.000000', 'consum', 0.0221, 'lps'),
	(519466, 129, '2014-02-01 00:06:46.000000', 'consum', 0.0211, 'lps'),
	(519467, 129, '2014-02-01 00:06:47.000000', 'consum', 0.0228, 'lps'),
	(519468, 129, '2014-02-01 00:06:48.000000', 'consum', 0.0229, 'lps'),
	(519469, 129, '2014-02-01 00:06:49.000000', 'consum', 0.0210, 'lps'),
	(519470, 129, '2014-02-01 00:06:50.000000', 'consum', 0.0217, 'lps'),
	(519471, 129, '2014-02-01 00:06:51.000000', 'consum', 0.0224, 'lps'),
	(519472, 129, '2014-02-01 00:06:52.000000', 'consum', 0.0215, 'lps'),
	(519473, 129, '2014-02-01 00:06:53.000000', 'consum', 0.0215, 'lps'),
	(519474, 129, '2014-02-01 00:06:54.000000', 'consum', 0.0220, 'lps'),
	(519475, 129, '2014-02-01 00:06:55.000000', 'consum', 0.0224, 'lps'),
	(519476, 129, '2014-02-01 00:06:56.000000', 'consum', 0.0228, 'lps'),
	(519477, 129, '2014-02-01 00:06:57.000000', 'consum', 0.0216, 'lps'),
	(519478, 129, '2014-02-01 00:06:58.000000', 'consum', 0.0210, 'lps'),
	(519479, 129, '2014-02-01 00:06:59.000000', 'consum', 0.0211, 'lps'),
	(519480, 129, '2014-02-01 00:07:00.000000', 'consum', 0.0218, 'lps'),
	(519481, 129, '2014-02-01 00:07:01.000000', 'consum', 0.0224, 'lps'),
	(519482, 129, '2014-02-01 00:07:02.000000', 'consum', 0.0215, 'lps'),
	(519483, 129, '2014-02-01 00:07:03.000000', 'consum', 0.0214, 'lps'),
	(519484, 129, '2014-02-01 00:07:04.000000', 'consum', 0.0217, 'lps'),
	(519485, 129, '2014-02-01 00:07:05.000000', 'consum', 0.0212, 'lps'),
	(519486, 129, '2014-02-01 00:07:06.000000', 'consum', 0.0220, 'lps'),
	(519487, 129, '2014-02-01 00:07:07.000000', 'consum', 0.0231, 'lps'),
	(519488, 129, '2014-02-01 00:07:08.000000', 'consum', 0.0222, 'lps'),
	(519489, 129, '2014-02-01 00:07:09.000000', 'consum', 0.0227, 'lps'),
	(519490, 129, '2014-02-01 00:07:10.000000', 'consum', 0.0217, 'lps'),
	(519491, 129, '2014-02-01 00:07:11.000000', 'consum', 0.0214, 'lps'),
	(519492, 129, '2014-02-01 00:07:12.000000', 'consum', 0.0212, 'lps'),
	(519493, 129, '2014-02-01 00:07:13.000000', 'consum', 0.0231, 'lps'),
	(519494, 129, '2014-02-01 00:07:14.000000', 'consum', 0.0220, 'lps'),
	(519495, 129, '2014-02-01 00:07:15.000000', 'consum', 0.0220, 'lps'),
	(519496, 129, '2014-02-01 00:07:16.000000', 'consum', 0.0229, 'lps'),
	(519497, 129, '2014-02-01 00:07:17.000000', 'consum', 0.0212, 'lps'),
	(519498, 129, '2014-02-01 00:07:18.000000', 'consum', 0.0229, 'lps'),
	(519499, 129, '2014-02-01 00:07:19.000000', 'consum', 0.0211, 'lps'),
	(519500, 129, '2014-02-01 00:07:20.000000', 'consum', 0.0224, 'lps'),
	(519501, 129, '2014-02-01 00:07:21.000000', 'consum', 0.0211, 'lps'),
	(519502, 129, '2014-02-01 00:07:22.000000', 'consum', 0.0217, 'lps'),
	(519503, 129, '2014-02-01 00:07:23.000000', 'consum', 0.0222, 'lps'),
	(519504, 129, '2014-02-01 00:07:24.000000', 'consum', 0.0226, 'lps'),
	(519505, 129, '2014-02-01 00:07:25.000000', 'consum', 0.0211, 'lps'),
	(519506, 129, '2014-02-01 00:07:26.000000', 'consum', 0.0211, 'lps'),
	(519507, 129, '2014-02-01 00:07:27.000000', 'consum', 0.0214, 'lps'),
	(519508, 129, '2014-02-01 00:07:28.000000', 'consum', 0.0229, 'lps'),
	(519509, 129, '2014-02-01 00:07:29.000000', 'consum', 0.0225, 'lps'),
	(519510, 129, '2014-02-01 00:07:30.000000', 'consum', 0.0229, 'lps'),
	(519511, 129, '2014-02-01 00:07:31.000000', 'consum', 0.0219, 'lps'),
	(519512, 129, '2014-02-01 00:07:32.000000', 'consum', 0.0217, 'lps'),
	(519513, 129, '2014-02-01 00:07:33.000000', 'consum', 0.0220, 'lps'),
	(519514, 129, '2014-02-01 00:07:34.000000', 'consum', 0.0216, 'lps'),
	(519515, 129, '2014-02-01 00:07:35.000000', 'consum', 0.0211, 'lps'),
	(519516, 129, '2014-02-01 00:07:36.000000', 'consum', 0.0219, 'lps'),
	(519517, 129, '2014-02-01 00:07:37.000000', 'consum', 0.0210, 'lps'),
	(519518, 129, '2014-02-01 00:07:38.000000', 'consum', 0.0229, 'lps'),
	(519519, 129, '2014-02-01 00:07:39.000000', 'consum', 0.0215, 'lps'),
	(519520, 129, '2014-02-01 00:07:40.000000', 'consum', 0.0222, 'lps'),
	(519521, 129, '2014-02-01 00:07:41.000000', 'consum', 0.0212, 'lps'),
	(519522, 129, '2014-02-01 00:07:42.000000', 'consum', 0.0229, 'lps'),
	(519523, 129, '2014-02-01 00:07:43.000000', 'consum', 0.0231, 'lps'),
	(519524, 129, '2014-02-01 00:07:44.000000', 'consum', 0.0218, 'lps'),
	(519525, 129, '2014-02-01 00:07:45.000000', 'consum', 0.0228, 'lps'),
	(519526, 129, '2014-02-01 00:07:46.000000', 'consum', 0.0214, 'lps'),
	(519527, 129, '2014-02-01 00:07:47.000000', 'consum', 0.0219, 'lps'),
	(519528, 129, '2014-02-01 00:07:48.000000', 'consum', 0.0220, 'lps'),
	(519529, 129, '2014-02-01 00:07:49.000000', 'consum', 0.0211, 'lps'),
	(519530, 129, '2014-02-01 00:07:50.000000', 'consum', 0.0210, 'lps'),
	(519531, 129, '2014-02-01 00:07:51.000000', 'consum', 0.0227, 'lps'),
	(519532, 129, '2014-02-01 00:07:52.000000', 'consum', 0.0229, 'lps'),
	(519533, 129, '2014-02-01 00:07:53.000000', 'consum', 0.0212, 'lps'),
	(519534, 129, '2014-02-01 00:07:54.000000', 'consum', 0.0228, 'lps'),
	(519535, 129, '2014-02-01 00:07:55.000000', 'consum', 0.0230, 'lps'),
	(519536, 129, '2014-02-01 00:07:56.000000', 'consum', 0.0213, 'lps'),
	(519537, 129, '2014-02-01 00:07:57.000000', 'consum', 0.0229, 'lps'),
	(519538, 129, '2014-02-01 00:07:58.000000', 'consum', 0.0231, 'lps'),
	(519539, 129, '2014-02-01 00:07:59.000000', 'consum', 0.0215, 'lps'),
	(519540, 129, '2014-02-01 00:08:00.000000', 'consum', 0.0218, 'lps'),
	(519541, 129, '2014-02-01 00:08:01.000000', 'consum', 0.0213, 'lps'),
	(519542, 129, '2014-02-01 00:08:02.000000', 'consum', 0.0225, 'lps'),
	(519543, 129, '2014-02-01 00:08:03.000000', 'consum', 0.0230, 'lps'),
	(519544, 129, '2014-02-01 00:08:04.000000', 'consum', 0.0223, 'lps'),
	(519545, 129, '2014-02-01 00:08:05.000000', 'consum', 0.0214, 'lps'),
	(519546, 129, '2014-02-01 00:08:06.000000', 'consum', 0.0213, 'lps'),
	(519547, 129, '2014-02-01 00:08:07.000000', 'consum', 0.0215, 'lps'),
	(519548, 129, '2014-02-01 00:08:08.000000', 'consum', 0.0226, 'lps'),
	(519549, 129, '2014-02-01 00:08:09.000000', 'consum', 0.0212, 'lps'),
	(519550, 129, '2014-02-01 00:08:10.000000', 'consum', 0.0213, 'lps'),
	(519551, 129, '2014-02-01 00:08:11.000000', 'consum', 0.0221, 'lps'),
	(519552, 129, '2014-02-01 00:08:12.000000', 'consum', 0.0213, 'lps'),
	(519553, 129, '2014-02-01 00:08:13.000000', 'consum', 0.0212, 'lps'),
	(519554, 129, '2014-02-01 00:08:14.000000', 'consum', 0.0215, 'lps'),
	(519555, 129, '2014-02-01 00:08:15.000000', 'consum', 0.0227, 'lps'),
	(519556, 129, '2014-02-01 00:08:16.000000', 'consum', 0.0215, 'lps'),
	(519557, 129, '2014-02-01 00:08:17.000000', 'consum', 0.0228, 'lps'),
	(519558, 129, '2014-02-01 00:08:18.000000', 'consum', 0.0218, 'lps'),
	(519559, 129, '2014-02-01 00:08:19.000000', 'consum', 0.0222, 'lps'),
	(519560, 129, '2014-02-01 00:08:20.000000', 'consum', 0.0221, 'lps'),
	(519561, 129, '2014-02-01 00:08:21.000000', 'consum', 0.0210, 'lps'),
	(519562, 129, '2014-02-01 00:08:22.000000', 'consum', 0.0221, 'lps'),
	(519563, 129, '2014-02-01 00:08:23.000000', 'consum', 0.0221, 'lps'),
	(519564, 129, '2014-02-01 00:08:24.000000', 'consum', 0.0211, 'lps'),
	(519565, 129, '2014-02-01 00:08:25.000000', 'consum', 0.0226, 'lps'),
	(519566, 129, '2014-02-01 00:08:26.000000', 'consum', 0.0222, 'lps'),
	(519567, 129, '2014-02-01 00:08:27.000000', 'consum', 0.0221, 'lps'),
	(519568, 129, '2014-02-01 00:08:28.000000', 'consum', 0.0229, 'lps'),
	(519569, 129, '2014-02-01 00:08:29.000000', 'consum', 0.0229, 'lps'),
	(519570, 129, '2014-02-01 00:08:30.000000', 'consum', 0.0225, 'lps'),
	(519571, 129, '2014-02-01 00:08:31.000000', 'consum', 0.0230, 'lps'),
	(519572, 129, '2014-02-01 00:08:32.000000', 'consum', 0.0221, 'lps'),
	(519573, 129, '2014-02-01 00:08:33.000000', 'consum', 0.0228, 'lps'),
	(519574, 129, '2014-02-01 00:08:34.000000', 'consum', 0.0224, 'lps'),
	(519575, 129, '2014-02-01 00:08:35.000000', 'consum', 0.0224, 'lps'),
	(519576, 129, '2014-02-01 00:08:36.000000', 'consum', 0.0219, 'lps'),
	(519577, 129, '2014-02-01 00:08:37.000000', 'consum', 0.0211, 'lps'),
	(519578, 129, '2014-02-01 00:08:38.000000', 'consum', 0.0212, 'lps'),
	(519579, 129, '2014-02-01 00:08:39.000000', 'consum', 0.0216, 'lps'),
	(519580, 129, '2014-02-01 00:08:40.000000', 'consum', 0.0214, 'lps'),
	(519581, 129, '2014-02-01 00:08:41.000000', 'consum', 0.0211, 'lps'),
	(519582, 129, '2014-02-01 00:08:42.000000', 'consum', 0.0225, 'lps'),
	(519583, 129, '2014-02-01 00:08:43.000000', 'consum', 0.0218, 'lps'),
	(519584, 129, '2014-02-01 00:08:44.000000', 'consum', 0.0226, 'lps'),
	(519585, 129, '2014-02-01 00:08:45.000000', 'consum', 0.0225, 'lps'),
	(519586, 129, '2014-02-01 00:08:46.000000', 'consum', 0.0216, 'lps'),
	(519587, 129, '2014-02-01 00:08:47.000000', 'consum', 0.0216, 'lps'),
	(519588, 129, '2014-02-01 00:08:48.000000', 'consum', 0.0222, 'lps'),
	(519589, 129, '2014-02-01 00:08:49.000000', 'consum', 0.0229, 'lps'),
	(519590, 129, '2014-02-01 00:08:50.000000', 'consum', 0.0229, 'lps'),
	(519591, 129, '2014-02-01 00:08:51.000000', 'consum', 0.0223, 'lps'),
	(519592, 129, '2014-02-01 00:08:52.000000', 'consum', 0.0220, 'lps'),
	(519593, 129, '2014-02-01 00:08:53.000000', 'consum', 0.0222, 'lps'),
	(519594, 129, '2014-02-01 00:08:54.000000', 'consum', 0.0220, 'lps'),
	(519595, 129, '2014-02-01 00:08:55.000000', 'consum', 0.0224, 'lps'),
	(519596, 129, '2014-02-01 00:08:56.000000', 'consum', 0.0228, 'lps'),
	(519597, 129, '2014-02-01 00:08:57.000000', 'consum', 0.0213, 'lps'),
	(519598, 129, '2014-02-01 00:08:58.000000', 'consum', 0.0217, 'lps'),
	(519599, 129, '2014-02-01 00:08:59.000000', 'consum', 0.0214, 'lps'),
	(519600, 129, '2014-02-01 00:09:00.000000', 'consum', 0.0231, 'lps'),
	(519601, 129, '2014-02-01 00:09:01.000000', 'consum', 0.0216, 'lps'),
	(519602, 129, '2014-02-01 00:09:02.000000', 'consum', 0.0220, 'lps'),
	(519603, 129, '2014-02-01 00:09:03.000000', 'consum', 0.0224, 'lps'),
	(519604, 129, '2014-02-01 00:09:04.000000', 'consum', 0.0225, 'lps'),
	(519605, 129, '2014-02-01 00:09:05.000000', 'consum', 0.0223, 'lps'),
	(519606, 129, '2014-02-01 00:09:06.000000', 'consum', 0.0229, 'lps'),
	(519607, 129, '2014-02-01 00:09:07.000000', 'consum', 0.0223, 'lps'),
	(519608, 129, '2014-02-01 00:09:08.000000', 'consum', 0.0220, 'lps'),
	(519609, 129, '2014-02-01 00:09:09.000000', 'consum', 0.0221, 'lps'),
	(519610, 129, '2014-02-01 00:09:10.000000', 'consum', 0.0212, 'lps'),
	(519611, 129, '2014-02-01 00:09:11.000000', 'consum', 0.0231, 'lps'),
	(519612, 129, '2014-02-01 00:09:12.000000', 'consum', 0.0221, 'lps'),
	(519613, 129, '2014-02-01 00:09:13.000000', 'consum', 0.0224, 'lps'),
	(519614, 129, '2014-02-01 00:09:14.000000', 'consum', 0.0228, 'lps'),
	(519615, 129, '2014-02-01 00:09:15.000000', 'consum', 0.0214, 'lps'),
	(519616, 129, '2014-02-01 00:09:16.000000', 'consum', 0.0218, 'lps'),
	(519617, 129, '2014-02-01 00:09:17.000000', 'consum', 0.0219, 'lps'),
	(519618, 129, '2014-02-01 00:09:18.000000', 'consum', 0.0231, 'lps'),
	(519619, 129, '2014-02-01 00:09:19.000000', 'consum', 0.0224, 'lps'),
	(519620, 129, '2014-02-01 00:09:20.000000', 'consum', 0.0215, 'lps'),
	(519621, 129, '2014-02-01 00:09:21.000000', 'consum', 0.0215, 'lps'),
	(519622, 129, '2014-02-01 00:09:22.000000', 'consum', 0.0221, 'lps'),
	(519623, 129, '2014-02-01 00:09:23.000000', 'consum', 0.0228, 'lps'),
	(519624, 129, '2014-02-01 00:09:24.000000', 'consum', 0.0223, 'lps'),
	(519625, 129, '2014-02-01 00:09:25.000000', 'consum', 0.0223, 'lps'),
	(519626, 129, '2014-02-01 00:09:26.000000', 'consum', 0.0213, 'lps'),
	(519627, 129, '2014-02-01 00:09:27.000000', 'consum', 0.0210, 'lps'),
	(519628, 129, '2014-02-01 00:09:28.000000', 'consum', 0.0223, 'lps'),
	(519629, 129, '2014-02-01 00:09:29.000000', 'consum', 0.0211, 'lps'),
	(519630, 129, '2014-02-01 00:09:30.000000', 'consum', 0.0221, 'lps'),
	(519631, 129, '2014-02-01 00:09:31.000000', 'consum', 0.0217, 'lps'),
	(519632, 129, '2014-02-01 00:09:32.000000', 'consum', 0.0211, 'lps'),
	(519633, 129, '2014-02-01 00:09:33.000000', 'consum', 0.0216, 'lps'),
	(519634, 129, '2014-02-01 00:09:34.000000', 'consum', 0.0218, 'lps'),
	(519635, 129, '2014-02-01 00:09:35.000000', 'consum', 0.0212, 'lps'),
	(519636, 129, '2014-02-01 00:09:36.000000', 'consum', 0.0215, 'lps'),
	(519637, 129, '2014-02-01 00:09:37.000000', 'consum', 0.0211, 'lps'),
	(519638, 129, '2014-02-01 00:09:38.000000', 'consum', 0.0221, 'lps'),
	(519639, 129, '2014-02-01 00:09:39.000000', 'consum', 0.0217, 'lps'),
	(519640, 129, '2014-02-01 00:09:40.000000', 'consum', 0.0213, 'lps'),
	(519641, 129, '2014-02-01 00:09:41.000000', 'consum', 0.0227, 'lps'),
	(519642, 129, '2014-02-01 00:09:42.000000', 'consum', 0.0218, 'lps'),
	(519643, 129, '2014-02-01 00:09:43.000000', 'consum', 0.0225, 'lps'),
	(519644, 129, '2014-02-01 00:09:44.000000', 'consum', 0.0216, 'lps'),
	(519645, 129, '2014-02-01 00:09:45.000000', 'consum', 0.0216, 'lps'),
	(519646, 129, '2014-02-01 00:09:46.000000', 'consum', 0.0223, 'lps'),
	(519647, 129, '2014-02-01 00:09:47.000000', 'consum', 0.0212, 'lps'),
	(519648, 129, '2014-02-01 00:09:48.000000', 'consum', 0.0227, 'lps'),
	(519649, 129, '2014-02-01 00:09:49.000000', 'consum', 0.0226, 'lps'),
	(519650, 129, '2014-02-01 00:09:50.000000', 'consum', 0.0214, 'lps'),
	(519651, 129, '2014-02-01 00:09:51.000000', 'consum', 0.0226, 'lps'),
	(519652, 129, '2014-02-01 00:09:52.000000', 'consum', 0.0215, 'lps'),
	(519653, 129, '2014-02-01 00:09:53.000000', 'consum', 0.0231, 'lps'),
	(519654, 129, '2014-02-01 00:09:54.000000', 'consum', 0.0213, 'lps'),
	(519655, 129, '2014-02-01 00:09:55.000000', 'consum', 0.0229, 'lps'),
	(519656, 129, '2014-02-01 00:09:56.000000', 'consum', 0.0229, 'lps'),
	(519657, 129, '2014-02-01 00:09:57.000000', 'consum', 0.0228, 'lps'),
	(519658, 129, '2014-02-01 00:09:58.000000', 'consum', 0.0222, 'lps'),
	(519659, 129, '2014-02-01 00:09:59.000000', 'consum', 0.0214, 'lps'),
	(519660, 129, '2014-02-01 00:10:00.000000', 'consum', 0.0218, 'lps'),
	(519661, 129, '2014-02-01 00:10:01.000000', 'consum', 0.0217, 'lps'),
	(519662, 129, '2014-02-01 00:10:02.000000', 'consum', 0.0221, 'lps'),
	(519663, 129, '2014-02-01 00:10:03.000000', 'consum', 0.0223, 'lps'),
	(519664, 129, '2014-02-01 00:10:04.000000', 'consum', 0.0221, 'lps'),
	(519665, 129, '2014-02-01 00:10:05.000000', 'consum', 0.0224, 'lps'),
	(519666, 129, '2014-02-01 00:10:06.000000', 'consum', 0.0228, 'lps'),
	(519667, 129, '2014-02-01 00:10:07.000000', 'consum', 0.0213, 'lps'),
	(519668, 129, '2014-02-01 00:10:08.000000', 'consum', 0.0218, 'lps'),
	(519669, 129, '2014-02-01 00:10:09.000000', 'consum', 0.0217, 'lps'),
	(519670, 129, '2014-02-01 00:10:10.000000', 'consum', 0.0222, 'lps'),
	(519671, 129, '2014-02-01 00:10:11.000000', 'consum', 0.0227, 'lps'),
	(519672, 129, '2014-02-01 00:10:12.000000', 'consum', 0.0217, 'lps'),
	(519673, 129, '2014-02-01 00:10:13.000000', 'consum', 0.0215, 'lps'),
	(519674, 129, '2014-02-01 00:10:14.000000', 'consum', 0.0215, 'lps'),
	(519675, 129, '2014-02-01 00:10:15.000000', 'consum', 0.0220, 'lps'),
	(519676, 129, '2014-02-01 00:10:16.000000', 'consum', 0.0224, 'lps'),
	(519677, 129, '2014-02-01 00:10:17.000000', 'consum', 0.0230, 'lps'),
	(519678, 129, '2014-02-01 00:10:18.000000', 'consum', 0.0225, 'lps'),
	(519679, 129, '2014-02-01 00:10:19.000000', 'consum', 0.0226, 'lps'),
	(519680, 129, '2014-02-01 00:10:20.000000', 'consum', 0.0223, 'lps'),
	(519681, 129, '2014-02-01 00:10:21.000000', 'consum', 0.0227, 'lps'),
	(519682, 129, '2014-02-01 00:10:22.000000', 'consum', 0.0213, 'lps'),
	(519683, 129, '2014-02-01 00:10:23.000000', 'consum', 0.0217, 'lps'),
	(519684, 129, '2014-02-01 00:10:24.000000', 'consum', 0.0215, 'lps'),
	(519685, 129, '2014-02-01 00:10:25.000000', 'consum', 0.0214, 'lps'),
	(519686, 129, '2014-02-01 00:10:26.000000', 'consum', 0.0215, 'lps'),
	(519687, 129, '2014-02-01 00:10:27.000000', 'consum', 0.0225, 'lps'),
	(519688, 129, '2014-02-01 00:10:28.000000', 'consum', 0.0228, 'lps'),
	(519689, 129, '2014-02-01 00:10:29.000000', 'consum', 0.0230, 'lps'),
	(519690, 129, '2014-02-01 00:10:30.000000', 'consum', 0.0216, 'lps'),
	(519691, 129, '2014-02-01 00:10:31.000000', 'consum', 0.0222, 'lps'),
	(519692, 129, '2014-02-01 00:10:32.000000', 'consum', 0.0229, 'lps'),
	(519693, 129, '2014-02-01 00:10:33.000000', 'consum', 0.0228, 'lps'),
	(519694, 129, '2014-02-01 00:10:34.000000', 'consum', 0.0222, 'lps'),
	(519695, 129, '2014-02-01 00:10:35.000000', 'consum', 0.0214, 'lps'),
	(519696, 129, '2014-02-01 00:10:36.000000', 'consum', 0.0217, 'lps'),
	(519697, 129, '2014-02-01 00:10:37.000000', 'consum', 0.0213, 'lps'),
	(519698, 129, '2014-02-01 00:10:38.000000', 'consum', 0.0228, 'lps'),
	(519699, 129, '2014-02-01 00:10:39.000000', 'consum', 0.0223, 'lps'),
	(519700, 129, '2014-02-01 00:10:40.000000', 'consum', 0.0223, 'lps'),
	(519701, 129, '2014-02-01 00:10:41.000000', 'consum', 0.0212, 'lps'),
	(519702, 129, '2014-02-01 00:10:42.000000', 'consum', 0.0228, 'lps'),
	(519703, 129, '2014-02-01 00:10:43.000000', 'consum', 0.0229, 'lps'),
	(519704, 129, '2014-02-01 00:10:44.000000', 'consum', 0.0228, 'lps'),
	(519705, 129, '2014-02-01 00:10:45.000000', 'consum', 0.0221, 'lps'),
	(519706, 129, '2014-02-01 00:10:46.000000', 'consum', 0.0212, 'lps'),
	(519707, 129, '2014-02-01 00:10:47.000000', 'consum', 0.0211, 'lps'),
	(519708, 129, '2014-02-01 00:10:48.000000', 'consum', 0.0229, 'lps'),
	(519709, 129, '2014-02-01 00:10:49.000000', 'consum', 0.0218, 'lps'),
	(519710, 129, '2014-02-01 00:10:50.000000', 'consum', 0.0212, 'lps'),
	(519711, 129, '2014-02-01 00:10:51.000000', 'consum', 0.0221, 'lps'),
	(519712, 129, '2014-02-01 00:10:52.000000', 'consum', 0.0214, 'lps'),
	(519713, 129, '2014-02-01 00:10:53.000000', 'consum', 0.0220, 'lps'),
	(519714, 129, '2014-02-01 00:10:54.000000', 'consum', 0.0225, 'lps'),
	(519715, 129, '2014-02-01 00:10:55.000000', 'consum', 0.0214, 'lps'),
	(519716, 129, '2014-02-01 00:10:56.000000', 'consum', 0.0229, 'lps'),
	(519717, 129, '2014-02-01 00:10:57.000000', 'consum', 0.0228, 'lps'),
	(519718, 129, '2014-02-01 00:10:58.000000', 'consum', 0.0222, 'lps'),
	(519719, 129, '2014-02-01 00:10:59.000000', 'consum', 0.0217, 'lps'),
	(519720, 129, '2014-02-01 00:11:00.000000', 'consum', 0.0229, 'lps'),
	(519721, 129, '2014-02-01 00:11:01.000000', 'consum', 0.0219, 'lps'),
	(519722, 129, '2014-02-01 00:11:02.000000', 'consum', 0.0223, 'lps'),
	(519723, 129, '2014-02-01 00:11:03.000000', 'consum', 0.0225, 'lps'),
	(519724, 129, '2014-02-01 00:11:04.000000', 'consum', 0.0225, 'lps'),
	(519725, 129, '2014-02-01 00:11:05.000000', 'consum', 0.0217, 'lps'),
	(519726, 129, '2014-02-01 00:11:06.000000', 'consum', 0.0221, 'lps'),
	(519727, 129, '2014-02-01 00:11:07.000000', 'consum', 0.0226, 'lps'),
	(519728, 129, '2014-02-01 00:11:08.000000', 'consum', 0.0210, 'lps'),
	(519729, 129, '2014-02-01 00:11:09.000000', 'consum', 0.0230, 'lps'),
	(519730, 129, '2014-02-01 00:11:10.000000', 'consum', 0.0224, 'lps'),
	(519731, 129, '2014-02-01 00:11:11.000000', 'consum', 0.0217, 'lps'),
	(519732, 129, '2014-02-01 00:11:12.000000', 'consum', 0.0229, 'lps'),
	(519733, 129, '2014-02-01 00:11:13.000000', 'consum', 0.0216, 'lps'),
	(519734, 129, '2014-02-01 00:11:14.000000', 'consum', 0.0229, 'lps'),
	(519735, 129, '2014-02-01 00:11:15.000000', 'consum', 0.0222, 'lps'),
	(519736, 129, '2014-02-01 00:11:16.000000', 'consum', 0.0212, 'lps'),
	(519737, 129, '2014-02-01 00:11:17.000000', 'consum', 0.0230, 'lps'),
	(519738, 129, '2014-02-01 00:11:18.000000', 'consum', 0.0216, 'lps'),
	(519739, 129, '2014-02-01 00:11:19.000000', 'consum', 0.0226, 'lps'),
	(519740, 129, '2014-02-01 00:11:20.000000', 'consum', 0.0229, 'lps'),
	(519741, 129, '2014-02-01 00:11:21.000000', 'consum', 0.0214, 'lps'),
	(519742, 129, '2014-02-01 00:11:22.000000', 'consum', 0.0217, 'lps'),
	(519743, 129, '2014-02-01 00:11:23.000000', 'consum', 0.0212, 'lps'),
	(519744, 129, '2014-02-01 00:11:24.000000', 'consum', 0.0221, 'lps'),
	(519745, 129, '2014-02-01 00:11:25.000000', 'consum', 0.0217, 'lps'),
	(519746, 129, '2014-02-01 00:11:26.000000', 'consum', 0.0214, 'lps'),
	(519747, 129, '2014-02-01 00:11:27.000000', 'consum', 0.0228, 'lps'),
	(519748, 129, '2014-02-01 00:11:28.000000', 'consum', 0.0222, 'lps'),
	(519749, 129, '2014-02-01 00:11:29.000000', 'consum', 0.0216, 'lps'),
	(519750, 129, '2014-02-01 00:11:30.000000', 'consum', 0.0229, 'lps'),
	(519751, 129, '2014-02-01 00:11:31.000000', 'consum', 0.0221, 'lps'),
	(519752, 129, '2014-02-01 00:11:32.000000', 'consum', 0.0210, 'lps'),
	(519753, 129, '2014-02-01 00:11:33.000000', 'consum', 0.0221, 'lps'),
	(519754, 129, '2014-02-01 00:11:34.000000', 'consum', 0.0223, 'lps'),
	(519755, 129, '2014-02-01 00:11:35.000000', 'consum', 0.0219, 'lps'),
	(519756, 129, '2014-02-01 00:11:36.000000', 'consum', 0.0216, 'lps'),
	(519757, 129, '2014-02-01 00:11:37.000000', 'consum', 0.0214, 'lps'),
	(519758, 129, '2014-02-01 00:11:38.000000', 'consum', 0.0212, 'lps'),
	(519759, 129, '2014-02-01 00:11:39.000000', 'consum', 0.0229, 'lps'),
	(519760, 129, '2014-02-01 00:11:40.000000', 'consum', 0.0213, 'lps'),
	(519761, 129, '2014-02-01 00:11:41.000000', 'consum', 0.0214, 'lps'),
	(519762, 129, '2014-02-01 00:11:42.000000', 'consum', 0.0221, 'lps'),
	(519763, 129, '2014-02-01 00:11:43.000000', 'consum', 0.0230, 'lps'),
	(519764, 129, '2014-02-01 00:11:44.000000', 'consum', 0.0212, 'lps'),
	(519765, 129, '2014-02-01 00:11:45.000000', 'consum', 0.0227, 'lps'),
	(519766, 129, '2014-02-01 00:11:46.000000', 'consum', 0.0223, 'lps'),
	(519767, 129, '2014-02-01 00:11:47.000000', 'consum', 0.0225, 'lps'),
	(519768, 129, '2014-02-01 00:11:48.000000', 'consum', 0.0225, 'lps'),
	(519769, 129, '2014-02-01 00:11:49.000000', 'consum', 0.0218, 'lps'),
	(519770, 129, '2014-02-01 00:11:50.000000', 'consum', 0.0227, 'lps'),
	(519771, 129, '2014-02-01 00:11:51.000000', 'consum', 0.0228, 'lps'),
	(519772, 129, '2014-02-01 00:11:52.000000', 'consum', 0.0226, 'lps'),
	(519773, 129, '2014-02-01 00:11:53.000000', 'consum', 0.0215, 'lps'),
	(519774, 129, '2014-02-01 00:11:54.000000', 'consum', 0.0210, 'lps'),
	(519775, 129, '2014-02-01 00:11:55.000000', 'consum', 0.0217, 'lps'),
	(519776, 129, '2014-02-01 00:11:56.000000', 'consum', 0.0223, 'lps'),
	(519777, 129, '2014-02-01 00:11:57.000000', 'consum', 0.0231, 'lps'),
	(519778, 129, '2014-02-01 00:11:58.000000', 'consum', 0.0214, 'lps'),
	(519779, 129, '2014-02-01 00:11:59.000000', 'consum', 0.0210, 'lps'),
	(519780, 129, '2014-02-01 00:12:00.000000', 'consum', 0.0222, 'lps'),
	(519781, 129, '2014-02-01 00:12:01.000000', 'consum', 0.0225, 'lps'),
	(519782, 129, '2014-02-01 00:12:02.000000', 'consum', 0.0229, 'lps'),
	(519783, 129, '2014-02-01 00:12:03.000000', 'consum', 0.0218, 'lps'),
	(519784, 129, '2014-02-01 00:12:04.000000', 'consum', 0.0212, 'lps'),
	(519785, 129, '2014-02-01 00:12:05.000000', 'consum', 0.0222, 'lps'),
	(519786, 129, '2014-02-01 00:12:06.000000', 'consum', 0.0218, 'lps'),
	(519787, 129, '2014-02-01 00:12:07.000000', 'consum', 0.0213, 'lps'),
	(519788, 129, '2014-02-01 00:12:08.000000', 'consum', 0.0225, 'lps'),
	(519789, 129, '2014-02-01 00:12:09.000000', 'consum', 0.0212, 'lps'),
	(519790, 129, '2014-02-01 00:12:10.000000', 'consum', 0.0219, 'lps'),
	(519791, 129, '2014-02-01 00:12:11.000000', 'consum', 0.0229, 'lps'),
	(519792, 129, '2014-02-01 00:12:12.000000', 'consum', 0.0231, 'lps'),
	(519793, 129, '2014-02-01 00:12:13.000000', 'consum', 0.0217, 'lps'),
	(519794, 129, '2014-02-01 00:12:14.000000', 'consum', 0.0226, 'lps'),
	(519795, 129, '2014-02-01 00:12:15.000000', 'consum', 0.0226, 'lps'),
	(519796, 129, '2014-02-01 00:12:16.000000', 'consum', 0.0219, 'lps'),
	(519797, 129, '2014-02-01 00:12:17.000000', 'consum', 0.0229, 'lps'),
	(519798, 129, '2014-02-01 00:12:18.000000', 'consum', 0.0215, 'lps'),
	(519799, 129, '2014-02-01 00:12:19.000000', 'consum', 0.0223, 'lps'),
	(519800, 129, '2014-02-01 00:12:20.000000', 'consum', 0.0216, 'lps'),
	(519801, 129, '2014-02-01 00:12:21.000000', 'consum', 0.0225, 'lps'),
	(519802, 129, '2014-02-01 00:12:22.000000', 'consum', 0.0222, 'lps'),
	(519803, 129, '2014-02-01 00:12:23.000000', 'consum', 0.0226, 'lps'),
	(519804, 129, '2014-02-01 00:12:24.000000', 'consum', 0.0231, 'lps'),
	(519805, 129, '2014-02-01 00:12:25.000000', 'consum', 0.0226, 'lps'),
	(519806, 129, '2014-02-01 00:12:26.000000', 'consum', 0.0227, 'lps'),
	(519807, 129, '2014-02-01 00:12:27.000000', 'consum', 0.0226, 'lps'),
	(519808, 129, '2014-02-01 00:12:28.000000', 'consum', 0.0218, 'lps'),
	(519809, 129, '2014-02-01 00:12:29.000000', 'consum', 0.0223, 'lps'),
	(519810, 129, '2014-02-01 00:12:30.000000', 'consum', 0.0229, 'lps'),
	(519811, 129, '2014-02-01 00:12:31.000000', 'consum', 0.0225, 'lps'),
	(519812, 129, '2014-02-01 00:12:32.000000', 'consum', 0.0226, 'lps'),
	(519813, 129, '2014-02-01 00:12:33.000000', 'consum', 0.0223, 'lps'),
	(519814, 129, '2014-02-01 00:12:34.000000', 'consum', 0.0229, 'lps'),
	(519815, 129, '2014-02-01 00:12:35.000000', 'consum', 0.0220, 'lps'),
	(519816, 129, '2014-02-01 00:12:36.000000', 'consum', 0.0229, 'lps'),
	(519817, 129, '2014-02-01 00:12:37.000000', 'consum', 0.0230, 'lps'),
	(519818, 129, '2014-02-01 00:12:38.000000', 'consum', 0.0230, 'lps'),
	(519819, 129, '2014-02-01 00:12:39.000000', 'consum', 0.0230, 'lps'),
	(519820, 129, '2014-02-01 00:12:40.000000', 'consum', 0.0226, 'lps'),
	(519821, 129, '2014-02-01 00:12:41.000000', 'consum', 0.0212, 'lps'),
	(519822, 129, '2014-02-01 00:12:42.000000', 'consum', 0.0213, 'lps'),
	(519823, 129, '2014-02-01 00:12:43.000000', 'consum', 0.0222, 'lps'),
	(519824, 129, '2014-02-01 00:12:44.000000', 'consum', 0.0215, 'lps'),
	(519825, 129, '2014-02-01 00:12:45.000000', 'consum', 0.0221, 'lps'),
	(519826, 129, '2014-02-01 00:12:46.000000', 'consum', 0.0231, 'lps'),
	(519827, 129, '2014-02-01 00:12:47.000000', 'consum', 0.0215, 'lps'),
	(519828, 129, '2014-02-01 00:12:48.000000', 'consum', 0.0218, 'lps'),
	(519829, 129, '2014-02-01 00:12:49.000000', 'consum', 0.0211, 'lps'),
	(519830, 129, '2014-02-01 00:12:50.000000', 'consum', 0.0213, 'lps'),
	(519831, 129, '2014-02-01 00:12:51.000000', 'consum', 0.0225, 'lps'),
	(519832, 129, '2014-02-01 00:12:52.000000', 'consum', 0.0210, 'lps'),
	(519833, 129, '2014-02-01 00:12:53.000000', 'consum', 0.0230, 'lps'),
	(519834, 129, '2014-02-01 00:12:54.000000', 'consum', 0.0223, 'lps'),
	(519835, 129, '2014-02-01 00:12:55.000000', 'consum', 0.0216, 'lps'),
	(519836, 129, '2014-02-01 00:12:56.000000', 'consum', 0.0225, 'lps'),
	(519837, 129, '2014-02-01 00:12:57.000000', 'consum', 0.0221, 'lps'),
	(519838, 129, '2014-02-01 00:12:58.000000', 'consum', 0.0220, 'lps'),
	(519839, 129, '2014-02-01 00:12:59.000000', 'consum', 0.0227, 'lps'),
	(519840, 129, '2014-02-01 00:13:00.000000', 'consum', 0.0225, 'lps'),
	(519841, 129, '2014-02-01 00:13:01.000000', 'consum', 0.0231, 'lps'),
	(519842, 129, '2014-02-01 00:13:02.000000', 'consum', 0.0227, 'lps'),
	(519843, 129, '2014-02-01 00:13:03.000000', 'consum', 0.0210, 'lps'),
	(519844, 129, '2014-02-01 00:13:04.000000', 'consum', 0.0228, 'lps'),
	(519845, 129, '2014-02-01 00:13:05.000000', 'consum', 0.0210, 'lps'),
	(519846, 129, '2014-02-01 00:13:06.000000', 'consum', 0.0224, 'lps'),
	(519847, 129, '2014-02-01 00:13:07.000000', 'consum', 0.0213, 'lps'),
	(519848, 129, '2014-02-01 00:13:08.000000', 'consum', 0.0226, 'lps'),
	(519849, 129, '2014-02-01 00:13:09.000000', 'consum', 0.0218, 'lps'),
	(519850, 129, '2014-02-01 00:13:10.000000', 'consum', 0.0225, 'lps'),
	(519851, 129, '2014-02-01 00:13:11.000000', 'consum', 0.0217, 'lps'),
	(519852, 129, '2014-02-01 00:13:12.000000', 'consum', 0.0222, 'lps'),
	(519853, 129, '2014-02-01 00:13:13.000000', 'consum', 0.0228, 'lps'),
	(519854, 129, '2014-02-01 00:13:14.000000', 'consum', 0.0220, 'lps'),
	(519855, 129, '2014-02-01 00:13:15.000000', 'consum', 0.0227, 'lps'),
	(519856, 129, '2014-02-01 00:13:16.000000', 'consum', 0.0221, 'lps'),
	(519857, 129, '2014-02-01 00:13:17.000000', 'consum', 0.0216, 'lps'),
	(519858, 129, '2014-02-01 00:13:18.000000', 'consum', 0.0231, 'lps'),
	(519859, 129, '2014-02-01 00:13:19.000000', 'consum', 0.0230, 'lps'),
	(519860, 129, '2014-02-01 00:13:20.000000', 'consum', 0.0228, 'lps'),
	(519861, 129, '2014-02-01 00:13:21.000000', 'consum', 0.0215, 'lps'),
	(519862, 129, '2014-02-01 00:13:22.000000', 'consum', 0.0227, 'lps'),
	(519863, 129, '2014-02-01 00:13:23.000000', 'consum', 0.0214, 'lps'),
	(519864, 129, '2014-02-01 00:13:24.000000', 'consum', 0.0222, 'lps'),
	(519865, 129, '2014-02-01 00:13:25.000000', 'consum', 0.0217, 'lps'),
	(519866, 129, '2014-02-01 00:13:26.000000', 'consum', 0.0231, 'lps'),
	(519867, 129, '2014-02-01 00:13:27.000000', 'consum', 0.0228, 'lps'),
	(519868, 129, '2014-02-01 00:13:28.000000', 'consum', 0.0215, 'lps'),
	(519869, 129, '2014-02-01 00:13:29.000000', 'consum', 0.0227, 'lps'),
	(519870, 129, '2014-02-01 00:13:30.000000', 'consum', 0.0215, 'lps'),
	(519871, 129, '2014-02-01 00:13:31.000000', 'consum', 0.0228, 'lps'),
	(519872, 129, '2014-02-01 00:13:32.000000', 'consum', 0.0221, 'lps'),
	(519873, 129, '2014-02-01 00:13:33.000000', 'consum', 0.0231, 'lps'),
	(519874, 129, '2014-02-01 00:13:34.000000', 'consum', 0.0220, 'lps'),
	(519875, 129, '2014-02-01 00:13:35.000000', 'consum', 0.0216, 'lps'),
	(519876, 129, '2014-02-01 00:13:36.000000', 'consum', 0.0210, 'lps'),
	(519877, 129, '2014-02-01 00:13:37.000000', 'consum', 0.0218, 'lps'),
	(519878, 129, '2014-02-01 00:13:38.000000', 'consum', 0.0226, 'lps'),
	(519879, 129, '2014-02-01 00:13:39.000000', 'consum', 0.0221, 'lps'),
	(519880, 129, '2014-02-01 00:13:40.000000', 'consum', 0.0221, 'lps'),
	(519881, 129, '2014-02-01 00:13:41.000000', 'consum', 0.0231, 'lps'),
	(519882, 129, '2014-02-01 00:13:42.000000', 'consum', 0.0218, 'lps'),
	(519883, 129, '2014-02-01 00:13:43.000000', 'consum', 0.0231, 'lps'),
	(519884, 129, '2014-02-01 00:13:44.000000', 'consum', 0.0224, 'lps'),
	(519885, 129, '2014-02-01 00:13:45.000000', 'consum', 0.0217, 'lps'),
	(519886, 129, '2014-02-01 00:13:46.000000', 'consum', 0.0228, 'lps'),
	(519887, 129, '2014-02-01 00:13:47.000000', 'consum', 0.0214, 'lps'),
	(519888, 129, '2014-02-01 00:13:48.000000', 'consum', 0.0220, 'lps'),
	(519889, 129, '2014-02-01 00:13:49.000000', 'consum', 0.0225, 'lps'),
	(519890, 129, '2014-02-01 00:13:50.000000', 'consum', 0.0211, 'lps'),
	(519891, 129, '2014-02-01 00:13:51.000000', 'consum', 0.0214, 'lps'),
	(519892, 129, '2014-02-01 00:13:52.000000', 'consum', 0.0227, 'lps'),
	(519893, 129, '2014-02-01 00:13:53.000000', 'consum', 0.0219, 'lps'),
	(519894, 129, '2014-02-01 00:13:54.000000', 'consum', 0.0227, 'lps'),
	(519895, 129, '2014-02-01 00:13:55.000000', 'consum', 0.0223, 'lps'),
	(519896, 129, '2014-02-01 00:13:56.000000', 'consum', 0.0225, 'lps'),
	(519897, 129, '2014-02-01 00:13:57.000000', 'consum', 0.0225, 'lps'),
	(519898, 129, '2014-02-01 00:13:58.000000', 'consum', 0.0220, 'lps'),
	(519899, 129, '2014-02-01 00:13:59.000000', 'consum', 0.0214, 'lps'),
	(519900, 129, '2014-02-01 00:14:00.000000', 'consum', 0.0222, 'lps'),
	(519901, 129, '2014-02-01 00:14:01.000000', 'consum', 0.0215, 'lps'),
	(519902, 129, '2014-02-01 00:14:02.000000', 'consum', 0.0220, 'lps'),
	(519903, 129, '2014-02-01 00:14:03.000000', 'consum', 0.0226, 'lps'),
	(519904, 129, '2014-02-01 00:14:04.000000', 'consum', 0.0216, 'lps'),
	(519905, 129, '2014-02-01 00:14:05.000000', 'consum', 0.0214, 'lps'),
	(519906, 129, '2014-02-01 00:14:06.000000', 'consum', 0.0212, 'lps'),
	(519907, 129, '2014-02-01 00:14:07.000000', 'consum', 0.0231, 'lps'),
	(519908, 129, '2014-02-01 00:14:08.000000', 'consum', 0.0221, 'lps'),
	(519909, 129, '2014-02-01 00:14:09.000000', 'consum', 0.0226, 'lps'),
	(519910, 129, '2014-02-01 00:14:10.000000', 'consum', 0.0215, 'lps'),
	(519911, 129, '2014-02-01 00:14:11.000000', 'consum', 0.0228, 'lps'),
	(519912, 129, '2014-02-01 00:14:12.000000', 'consum', 0.0222, 'lps'),
	(519913, 129, '2014-02-01 00:14:13.000000', 'consum', 0.0214, 'lps'),
	(519914, 129, '2014-02-01 00:14:14.000000', 'consum', 0.0218, 'lps'),
	(519915, 129, '2014-02-01 00:14:15.000000', 'consum', 0.0217, 'lps'),
	(519916, 129, '2014-02-01 00:14:16.000000', 'consum', 0.0221, 'lps'),
	(519917, 129, '2014-02-01 00:14:17.000000', 'consum', 0.0222, 'lps'),
	(519918, 129, '2014-02-01 00:14:18.000000', 'consum', 0.0217, 'lps'),
	(519919, 129, '2014-02-01 00:14:19.000000', 'consum', 0.0229, 'lps'),
	(519920, 129, '2014-02-01 00:14:20.000000', 'consum', 0.0219, 'lps'),
	(519921, 129, '2014-02-01 00:14:21.000000', 'consum', 0.0221, 'lps'),
	(519922, 129, '2014-02-01 00:14:22.000000', 'consum', 0.0216, 'lps'),
	(519923, 129, '2014-02-01 00:14:23.000000', 'consum', 0.0230, 'lps'),
	(519924, 129, '2014-02-01 00:14:24.000000', 'consum', 0.0225, 'lps'),
	(519925, 129, '2014-02-01 00:14:25.000000', 'consum', 0.0225, 'lps'),
	(519926, 129, '2014-02-01 00:14:26.000000', 'consum', 0.0218, 'lps'),
	(519927, 129, '2014-02-01 00:14:27.000000', 'consum', 0.0229, 'lps'),
	(519928, 129, '2014-02-01 00:14:28.000000', 'consum', 0.0216, 'lps'),
	(519929, 129, '2014-02-01 00:14:29.000000', 'consum', 0.0228, 'lps'),
	(519930, 129, '2014-02-01 00:14:30.000000', 'consum', 0.0217, 'lps'),
	(519931, 129, '2014-02-01 00:14:31.000000', 'consum', 0.0214, 'lps'),
	(519932, 129, '2014-02-01 00:14:32.000000', 'consum', 0.0231, 'lps'),
	(519933, 129, '2014-02-01 00:14:33.000000', 'consum', 0.0215, 'lps'),
	(519934, 129, '2014-02-01 00:14:34.000000', 'consum', 0.0217, 'lps'),
	(519935, 129, '2014-02-01 00:14:35.000000', 'consum', 0.0228, 'lps'),
	(519936, 129, '2014-02-01 00:14:36.000000', 'consum', 0.0216, 'lps'),
	(519937, 129, '2014-02-01 00:14:37.000000', 'consum', 0.0228, 'lps'),
	(519938, 129, '2014-02-01 00:14:38.000000', 'consum', 0.0217, 'lps'),
	(519939, 129, '2014-02-01 00:14:39.000000', 'consum', 0.0215, 'lps'),
	(519940, 129, '2014-02-01 00:14:40.000000', 'consum', 0.0214, 'lps'),
	(519941, 129, '2014-02-01 00:14:41.000000', 'consum', 0.0216, 'lps'),
	(519942, 129, '2014-02-01 00:14:42.000000', 'consum', 0.0228, 'lps'),
	(519943, 129, '2014-02-01 00:14:43.000000', 'consum', 0.0218, 'lps'),
	(519944, 129, '2014-02-01 00:14:44.000000', 'consum', 0.0219, 'lps'),
	(519945, 129, '2014-02-01 00:14:45.000000', 'consum', 0.0210, 'lps'),
	(519946, 129, '2014-02-01 00:14:46.000000', 'consum', 0.0225, 'lps'),
	(519947, 129, '2014-02-01 00:14:47.000000', 'consum', 0.0222, 'lps'),
	(519948, 129, '2014-02-01 00:14:48.000000', 'consum', 0.0222, 'lps'),
	(519949, 129, '2014-02-01 00:14:49.000000', 'consum', 0.0216, 'lps'),
	(519950, 129, '2014-02-01 00:14:50.000000', 'consum', 0.0225, 'lps'),
	(519951, 129, '2014-02-01 00:14:51.000000', 'consum', 0.0223, 'lps'),
	(519952, 129, '2014-02-01 00:14:52.000000', 'consum', 0.0230, 'lps'),
	(519953, 129, '2014-02-01 00:14:53.000000', 'consum', 0.0228, 'lps'),
	(519954, 129, '2014-02-01 00:14:54.000000', 'consum', 0.0219, 'lps'),
	(519955, 129, '2014-02-01 00:14:55.000000', 'consum', 0.0225, 'lps'),
	(519956, 129, '2014-02-01 00:14:56.000000', 'consum', 0.0212, 'lps'),
	(519957, 129, '2014-02-01 00:14:57.000000', 'consum', 0.0222, 'lps'),
	(519958, 129, '2014-02-01 00:14:58.000000', 'consum', 0.0218, 'lps'),
	(519959, 129, '2014-02-01 00:14:59.000000', 'consum', 0.0216, 'lps'),
	(519960, 129, '2014-02-01 00:15:00.000000', 'consum', 0.0217, 'lps'),
	(519961, 129, '2014-02-01 00:15:01.000000', 'consum', 0.0228, 'lps'),
	(519962, 129, '2014-02-01 00:15:02.000000', 'consum', 0.0213, 'lps'),
	(519963, 129, '2014-02-01 00:15:03.000000', 'consum', 0.0217, 'lps'),
	(519964, 129, '2014-02-01 00:15:04.000000', 'consum', 0.0212, 'lps'),
	(519965, 129, '2014-02-01 00:15:05.000000', 'consum', 0.0222, 'lps'),
	(519966, 129, '2014-02-01 00:15:06.000000', 'consum', 0.0221, 'lps'),
	(519967, 129, '2014-02-01 00:15:07.000000', 'consum', 0.0228, 'lps'),
	(519968, 129, '2014-02-01 00:15:08.000000', 'consum', 0.0226, 'lps'),
	(519969, 129, '2014-02-01 00:15:09.000000', 'consum', 0.0212, 'lps'),
	(519970, 129, '2014-02-01 00:15:10.000000', 'consum', 0.0219, 'lps'),
	(519971, 129, '2014-02-01 00:15:11.000000', 'consum', 0.0228, 'lps'),
	(519972, 129, '2014-02-01 00:15:12.000000', 'consum', 0.0227, 'lps'),
	(519973, 129, '2014-02-01 00:15:13.000000', 'consum', 0.0222, 'lps'),
	(519974, 129, '2014-02-01 00:15:14.000000', 'consum', 0.0219, 'lps'),
	(519975, 129, '2014-02-01 00:15:15.000000', 'consum', 0.0221, 'lps'),
	(519976, 129, '2014-02-01 00:15:16.000000', 'consum', 0.0213, 'lps'),
	(519977, 129, '2014-02-01 00:15:17.000000', 'consum', 0.0216, 'lps'),
	(519978, 129, '2014-02-01 00:15:18.000000', 'consum', 0.0211, 'lps'),
	(519979, 129, '2014-02-01 00:15:19.000000', 'consum', 0.0220, 'lps'),
	(519980, 129, '2014-02-01 00:15:20.000000', 'consum', 0.0214, 'lps'),
	(519981, 129, '2014-02-01 00:15:21.000000', 'consum', 0.0220, 'lps'),
	(519982, 129, '2014-02-01 00:15:22.000000', 'consum', 0.0228, 'lps'),
	(519983, 129, '2014-02-01 00:15:23.000000', 'consum', 0.0227, 'lps'),
	(519984, 129, '2014-02-01 00:15:24.000000', 'consum', 0.0219, 'lps'),
	(519985, 129, '2014-02-01 00:15:25.000000', 'consum', 0.0229, 'lps'),
	(519986, 129, '2014-02-01 00:15:26.000000', 'consum', 0.0231, 'lps'),
	(519987, 129, '2014-02-01 00:15:27.000000', 'consum', 0.0215, 'lps'),
	(519988, 129, '2014-02-01 00:15:28.000000', 'consum', 0.0215, 'lps'),
	(519989, 129, '2014-02-01 00:15:29.000000', 'consum', 0.0223, 'lps'),
	(519990, 129, '2014-02-01 00:15:30.000000', 'consum', 0.0214, 'lps'),
	(519991, 129, '2014-02-01 00:15:31.000000', 'consum', 0.0216, 'lps'),
	(519992, 129, '2014-02-01 00:15:32.000000', 'consum', 0.0228, 'lps'),
	(519993, 129, '2014-02-01 00:15:33.000000', 'consum', 0.0214, 'lps'),
	(519994, 129, '2014-02-01 00:15:34.000000', 'consum', 0.0224, 'lps'),
	(519995, 129, '2014-02-01 00:15:35.000000', 'consum', 0.0223, 'lps'),
	(519996, 129, '2014-02-01 00:15:36.000000', 'consum', 0.0212, 'lps'),
	(519997, 129, '2014-02-01 00:15:37.000000', 'consum', 0.0227, 'lps'),
	(519998, 129, '2014-02-01 00:15:38.000000', 'consum', 0.0220, 'lps'),
	(519999, 129, '2014-02-01 00:15:39.000000', 'consum', 0.0213, 'lps'),
	(520000, 129, '2014-02-01 00:15:40.000000', 'consum', 0.0216, 'lps'),
	(520001, 129, '2014-02-01 00:15:41.000000', 'consum', 0.0211, 'lps'),
	(520002, 129, '2014-02-01 00:15:42.000000', 'consum', 0.0220, 'lps'),
	(520003, 129, '2014-02-01 00:15:43.000000', 'consum', 0.0212, 'lps'),
	(520004, 129, '2014-02-01 00:15:44.000000', 'consum', 0.0215, 'lps'),
	(520005, 129, '2014-02-01 00:15:45.000000', 'consum', 0.0228, 'lps'),
	(520006, 129, '2014-02-01 00:15:46.000000', 'consum', 0.0219, 'lps'),
	(520007, 129, '2014-02-01 00:15:47.000000', 'consum', 0.0223, 'lps'),
	(520008, 129, '2014-02-01 00:15:48.000000', 'consum', 0.0225, 'lps'),
	(520009, 129, '2014-02-01 00:15:49.000000', 'consum', 0.0228, 'lps'),
	(520010, 129, '2014-02-01 00:15:50.000000', 'consum', 0.0231, 'lps'),
	(520011, 129, '2014-02-01 00:15:51.000000', 'consum', 0.0220, 'lps'),
	(520012, 129, '2014-02-01 00:15:52.000000', 'consum', 0.0217, 'lps'),
	(520013, 129, '2014-02-01 00:15:53.000000', 'consum', 0.0215, 'lps'),
	(520014, 129, '2014-02-01 00:15:54.000000', 'consum', 0.0216, 'lps'),
	(520015, 129, '2014-02-01 00:15:55.000000', 'consum', 0.0227, 'lps'),
	(520016, 129, '2014-02-01 00:15:56.000000', 'consum', 0.0211, 'lps'),
	(520017, 129, '2014-02-01 00:15:57.000000', 'consum', 0.0229, 'lps'),
	(520018, 129, '2014-02-01 00:15:58.000000', 'consum', 0.0215, 'lps'),
	(520019, 129, '2014-02-01 00:15:59.000000', 'consum', 0.0224, 'lps'),
	(520020, 129, '2014-02-01 00:16:00.000000', 'consum', 0.0220, 'lps'),
	(520021, 129, '2014-02-01 00:16:01.000000', 'consum', 0.0220, 'lps'),
	(520022, 129, '2014-02-01 00:16:02.000000', 'consum', 0.0231, 'lps'),
	(520023, 129, '2014-02-01 00:16:03.000000', 'consum', 0.0218, 'lps'),
	(520024, 129, '2014-02-01 00:16:04.000000', 'consum', 0.0212, 'lps'),
	(520025, 129, '2014-02-01 00:16:05.000000', 'consum', 0.0215, 'lps'),
	(520026, 129, '2014-02-01 00:16:06.000000', 'consum', 0.0231, 'lps'),
	(520027, 129, '2014-02-01 00:16:07.000000', 'consum', 0.0215, 'lps'),
	(520028, 129, '2014-02-01 00:16:08.000000', 'consum', 0.0213, 'lps'),
	(520029, 129, '2014-02-01 00:16:09.000000', 'consum', 0.0210, 'lps'),
	(520030, 129, '2014-02-01 00:16:10.000000', 'consum', 0.0225, 'lps'),
	(520031, 129, '2014-02-01 00:16:11.000000', 'consum', 0.0218, 'lps'),
	(520032, 129, '2014-02-01 00:16:12.000000', 'consum', 0.0229, 'lps'),
	(520033, 129, '2014-02-01 00:16:13.000000', 'consum', 0.0214, 'lps'),
	(520034, 129, '2014-02-01 00:16:14.000000', 'consum', 0.0219, 'lps'),
	(520035, 129, '2014-02-01 00:16:15.000000', 'consum', 0.0221, 'lps'),
	(520036, 129, '2014-02-01 00:16:16.000000', 'consum', 0.0215, 'lps'),
	(520037, 129, '2014-02-01 00:16:17.000000', 'consum', 0.0228, 'lps'),
	(520038, 129, '2014-02-01 00:16:18.000000', 'consum', 0.0216, 'lps'),
	(520039, 129, '2014-02-01 00:16:19.000000', 'consum', 0.0230, 'lps'),
	(520040, 129, '2014-02-01 00:16:20.000000', 'consum', 0.0228, 'lps'),
	(520041, 129, '2014-02-01 00:16:21.000000', 'consum', 0.0220, 'lps'),
	(520042, 129, '2014-02-01 00:16:22.000000', 'consum', 0.0227, 'lps'),
	(520043, 129, '2014-02-01 00:16:23.000000', 'consum', 0.0221, 'lps'),
	(520044, 129, '2014-02-01 00:16:24.000000', 'consum', 0.0214, 'lps'),
	(520045, 129, '2014-02-01 00:16:25.000000', 'consum', 0.0219, 'lps'),
	(520046, 129, '2014-02-01 00:16:26.000000', 'consum', 0.0223, 'lps'),
	(520047, 129, '2014-02-01 00:16:27.000000', 'consum', 0.0227, 'lps'),
	(520048, 129, '2014-02-01 00:16:28.000000', 'consum', 0.0211, 'lps'),
	(520049, 129, '2014-02-01 00:16:29.000000', 'consum', 0.0230, 'lps'),
	(520050, 129, '2014-02-01 00:16:30.000000', 'consum', 0.0222, 'lps'),
	(520051, 129, '2014-02-01 00:16:31.000000', 'consum', 0.0210, 'lps'),
	(520052, 129, '2014-02-01 00:16:32.000000', 'consum', 0.0216, 'lps'),
	(520053, 129, '2014-02-01 00:16:33.000000', 'consum', 0.0220, 'lps'),
	(520054, 129, '2014-02-01 00:16:34.000000', 'consum', 0.0221, 'lps'),
	(520055, 129, '2014-02-01 00:16:35.000000', 'consum', 0.0212, 'lps'),
	(520056, 129, '2014-02-01 00:16:36.000000', 'consum', 0.0211, 'lps'),
	(520057, 129, '2014-02-01 00:16:37.000000', 'consum', 0.0231, 'lps'),
	(520058, 129, '2014-02-01 00:16:38.000000', 'consum', 0.0224, 'lps'),
	(520059, 129, '2014-02-01 00:16:39.000000', 'consum', 0.0216, 'lps'),
	(520060, 129, '2014-02-01 00:16:40.000000', 'consum', 0.0221, 'lps'),
	(520061, 129, '2014-02-01 00:16:41.000000', 'consum', 0.0225, 'lps'),
	(520062, 129, '2014-02-01 00:16:42.000000', 'consum', 0.0229, 'lps'),
	(520063, 129, '2014-02-01 00:16:43.000000', 'consum', 0.0219, 'lps'),
	(520064, 129, '2014-02-01 00:16:44.000000', 'consum', 0.0221, 'lps'),
	(520065, 129, '2014-02-01 00:16:45.000000', 'consum', 0.0218, 'lps'),
	(520066, 129, '2014-02-01 00:16:46.000000', 'consum', 0.0215, 'lps'),
	(520067, 129, '2014-02-01 00:16:47.000000', 'consum', 0.0210, 'lps'),
	(520068, 129, '2014-02-01 00:16:48.000000', 'consum', 0.0219, 'lps'),
	(520069, 129, '2014-02-01 00:16:49.000000', 'consum', 0.0213, 'lps'),
	(520070, 129, '2014-02-01 00:16:50.000000', 'consum', 0.0218, 'lps'),
	(520071, 129, '2014-02-01 00:16:51.000000', 'consum', 0.0222, 'lps'),
	(520072, 129, '2014-02-01 00:16:52.000000', 'consum', 0.0223, 'lps'),
	(520073, 129, '2014-02-01 00:16:53.000000', 'consum', 0.0219, 'lps'),
	(520074, 129, '2014-02-01 00:16:54.000000', 'consum', 0.0215, 'lps'),
	(520075, 129, '2014-02-01 00:16:55.000000', 'consum', 0.0210, 'lps'),
	(520076, 129, '2014-02-01 00:16:56.000000', 'consum', 0.0219, 'lps'),
	(520077, 129, '2014-02-01 00:16:57.000000', 'consum', 0.0210, 'lps'),
	(520078, 129, '2014-02-01 00:16:58.000000', 'consum', 0.0226, 'lps'),
	(520079, 129, '2014-02-01 00:16:59.000000', 'consum', 0.0225, 'lps'),
	(520080, 129, '2014-02-01 00:17:00.000000', 'consum', 0.0218, 'lps'),
	(520081, 129, '2014-02-01 00:17:01.000000', 'consum', 0.0224, 'lps'),
	(520082, 129, '2014-02-01 00:17:02.000000', 'consum', 0.0215, 'lps'),
	(520083, 129, '2014-02-01 00:17:03.000000', 'consum', 0.0216, 'lps'),
	(520084, 129, '2014-02-01 00:17:04.000000', 'consum', 0.0226, 'lps'),
	(520085, 129, '2014-02-01 00:17:05.000000', 'consum', 0.0226, 'lps'),
	(520086, 129, '2014-02-01 00:17:06.000000', 'consum', 0.0221, 'lps'),
	(520087, 129, '2014-02-01 00:17:07.000000', 'consum', 0.0220, 'lps'),
	(520088, 129, '2014-02-01 00:17:08.000000', 'consum', 0.0226, 'lps'),
	(520089, 129, '2014-02-01 00:17:09.000000', 'consum', 0.0216, 'lps'),
	(520090, 129, '2014-02-01 00:17:10.000000', 'consum', 0.0214, 'lps'),
	(520091, 129, '2014-02-01 00:17:11.000000', 'consum', 0.0213, 'lps'),
	(520092, 129, '2014-02-01 00:17:12.000000', 'consum', 0.0213, 'lps'),
	(520093, 129, '2014-02-01 00:17:13.000000', 'consum', 0.0218, 'lps'),
	(520094, 129, '2014-02-01 00:17:14.000000', 'consum', 0.0220, 'lps'),
	(520095, 129, '2014-02-01 00:17:15.000000', 'consum', 0.0212, 'lps'),
	(520096, 129, '2014-02-01 00:17:16.000000', 'consum', 0.0215, 'lps'),
	(520097, 129, '2014-02-01 00:17:17.000000', 'consum', 0.0230, 'lps'),
	(520098, 129, '2014-02-01 00:17:18.000000', 'consum', 0.0228, 'lps'),
	(520099, 129, '2014-02-01 00:17:19.000000', 'consum', 0.0218, 'lps'),
	(520100, 129, '2014-02-01 00:17:20.000000', 'consum', 0.0218, 'lps'),
	(520101, 129, '2014-02-01 00:17:21.000000', 'consum', 0.0226, 'lps'),
	(520102, 129, '2014-02-01 00:17:22.000000', 'consum', 0.0225, 'lps'),
	(520103, 129, '2014-02-01 00:17:23.000000', 'consum', 0.0215, 'lps'),
	(520104, 129, '2014-02-01 00:17:24.000000', 'consum', 0.0211, 'lps'),
	(520105, 129, '2014-02-01 00:17:25.000000', 'consum', 0.0225, 'lps'),
	(520106, 129, '2014-02-01 00:17:26.000000', 'consum', 0.0216, 'lps'),
	(520107, 129, '2014-02-01 00:17:27.000000', 'consum', 0.0218, 'lps'),
	(520108, 129, '2014-02-01 00:17:28.000000', 'consum', 0.0211, 'lps'),
	(520109, 129, '2014-02-01 00:17:29.000000', 'consum', 0.0211, 'lps'),
	(520110, 129, '2014-02-01 00:17:30.000000', 'consum', 0.0215, 'lps'),
	(520111, 129, '2014-02-01 00:17:31.000000', 'consum', 0.0231, 'lps'),
	(520112, 129, '2014-02-01 00:17:32.000000', 'consum', 0.0212, 'lps'),
	(520113, 129, '2014-02-01 00:17:33.000000', 'consum', 0.0225, 'lps'),
	(520114, 129, '2014-02-01 00:17:34.000000', 'consum', 0.0215, 'lps'),
	(520115, 129, '2014-02-01 00:17:35.000000', 'consum', 0.0231, 'lps'),
	(520116, 129, '2014-02-01 00:17:36.000000', 'consum', 0.0216, 'lps'),
	(520117, 129, '2014-02-01 00:17:37.000000', 'consum', 0.0220, 'lps'),
	(520118, 129, '2014-02-01 00:17:38.000000', 'consum', 0.0220, 'lps'),
	(520119, 129, '2014-02-01 00:17:39.000000', 'consum', 0.0210, 'lps'),
	(520120, 129, '2014-02-01 00:17:40.000000', 'consum', 0.0222, 'lps'),
	(520121, 129, '2014-02-01 00:17:41.000000', 'consum', 0.0227, 'lps'),
	(520122, 129, '2014-02-01 00:17:42.000000', 'consum', 0.0216, 'lps'),
	(520123, 129, '2014-02-01 00:17:43.000000', 'consum', 0.0211, 'lps'),
	(520124, 129, '2014-02-01 00:17:44.000000', 'consum', 0.0220, 'lps'),
	(520125, 129, '2014-02-01 00:17:45.000000', 'consum', 0.0215, 'lps'),
	(520126, 129, '2014-02-01 00:17:46.000000', 'consum', 0.0227, 'lps'),
	(520127, 129, '2014-02-01 00:17:47.000000', 'consum', 0.0216, 'lps'),
	(520128, 129, '2014-02-01 00:17:48.000000', 'consum', 0.0230, 'lps'),
	(520129, 129, '2014-02-01 00:17:49.000000', 'consum', 0.0229, 'lps'),
	(520130, 129, '2014-02-01 00:17:50.000000', 'consum', 0.0223, 'lps'),
	(520131, 129, '2014-02-01 00:17:51.000000', 'consum', 0.0219, 'lps'),
	(520132, 129, '2014-02-01 00:17:52.000000', 'consum', 0.0216, 'lps'),
	(520133, 129, '2014-02-01 00:17:53.000000', 'consum', 0.0216, 'lps'),
	(520134, 129, '2014-02-01 00:17:54.000000', 'consum', 0.0219, 'lps'),
	(520135, 129, '2014-02-01 00:17:55.000000', 'consum', 0.0218, 'lps'),
	(520136, 129, '2014-02-01 00:17:56.000000', 'consum', 0.0224, 'lps'),
	(520137, 129, '2014-02-01 00:17:57.000000', 'consum', 0.0211, 'lps'),
	(520138, 129, '2014-02-01 00:17:58.000000', 'consum', 0.0219, 'lps'),
	(520139, 129, '2014-02-01 00:17:59.000000', 'consum', 0.0228, 'lps'),
	(520140, 129, '2014-02-01 00:18:00.000000', 'consum', 0.0231, 'lps'),
	(520141, 129, '2014-02-01 00:18:01.000000', 'consum', 0.0217, 'lps'),
	(520142, 129, '2014-02-01 00:18:02.000000', 'consum', 0.0225, 'lps'),
	(520143, 129, '2014-02-01 00:18:03.000000', 'consum', 0.0220, 'lps'),
	(520144, 129, '2014-02-01 00:18:04.000000', 'consum', 0.0216, 'lps'),
	(520145, 129, '2014-02-01 00:18:05.000000', 'consum', 0.0210, 'lps'),
	(520146, 129, '2014-02-01 00:18:06.000000', 'consum', 0.0215, 'lps'),
	(520147, 129, '2014-02-01 00:18:07.000000', 'consum', 0.0215, 'lps'),
	(520148, 129, '2014-02-01 00:18:08.000000', 'consum', 0.0219, 'lps'),
	(520149, 129, '2014-02-01 00:18:09.000000', 'consum', 0.0219, 'lps'),
	(520150, 129, '2014-02-01 00:18:10.000000', 'consum', 0.0228, 'lps'),
	(520151, 129, '2014-02-01 00:18:11.000000', 'consum', 0.0210, 'lps'),
	(520152, 129, '2014-02-01 00:18:12.000000', 'consum', 0.0220, 'lps'),
	(520153, 129, '2014-02-01 00:18:13.000000', 'consum', 0.0215, 'lps'),
	(520154, 129, '2014-02-01 00:18:14.000000', 'consum', 0.0231, 'lps'),
	(520155, 129, '2014-02-01 00:18:15.000000', 'consum', 0.0210, 'lps'),
	(520156, 129, '2014-02-01 00:18:16.000000', 'consum', 0.0213, 'lps'),
	(520157, 129, '2014-02-01 00:18:17.000000', 'consum', 0.0228, 'lps'),
	(520158, 129, '2014-02-01 00:18:18.000000', 'consum', 0.0224, 'lps'),
	(520159, 129, '2014-02-01 00:18:19.000000', 'consum', 0.0226, 'lps'),
	(520160, 129, '2014-02-01 00:18:20.000000', 'consum', 0.0227, 'lps'),
	(520161, 129, '2014-02-01 00:18:21.000000', 'consum', 0.0227, 'lps'),
	(520162, 129, '2014-02-01 00:18:22.000000', 'consum', 0.0222, 'lps'),
	(520163, 129, '2014-02-01 00:18:23.000000', 'consum', 0.0219, 'lps'),
	(520164, 129, '2014-02-01 00:18:24.000000', 'consum', 0.0218, 'lps'),
	(520165, 129, '2014-02-01 00:18:25.000000', 'consum', 0.0225, 'lps'),
	(520166, 129, '2014-02-01 00:18:26.000000', 'consum', 0.0217, 'lps'),
	(520167, 129, '2014-02-01 00:18:27.000000', 'consum', 0.0223, 'lps'),
	(520168, 129, '2014-02-01 00:18:28.000000', 'consum', 0.0231, 'lps'),
	(520169, 129, '2014-02-01 00:18:29.000000', 'consum', 0.0211, 'lps'),
	(520170, 129, '2014-02-01 00:18:30.000000', 'consum', 0.0220, 'lps'),
	(520171, 129, '2014-02-01 00:18:31.000000', 'consum', 0.0211, 'lps'),
	(520172, 129, '2014-02-01 00:18:32.000000', 'consum', 0.0231, 'lps'),
	(520173, 129, '2014-02-01 00:18:33.000000', 'consum', 0.0225, 'lps'),
	(520174, 129, '2014-02-01 00:18:34.000000', 'consum', 0.0223, 'lps'),
	(520175, 129, '2014-02-01 00:18:35.000000', 'consum', 0.0230, 'lps'),
	(520176, 129, '2014-02-01 00:18:36.000000', 'consum', 0.0226, 'lps'),
	(520177, 129, '2014-02-01 00:18:37.000000', 'consum', 0.0211, 'lps'),
	(520178, 129, '2014-02-01 00:18:38.000000', 'consum', 0.0212, 'lps'),
	(520179, 129, '2014-02-01 00:18:39.000000', 'consum', 0.0215, 'lps'),
	(520180, 129, '2014-02-01 00:18:40.000000', 'consum', 0.0229, 'lps'),
	(520181, 129, '2014-02-01 00:18:41.000000', 'consum', 0.0224, 'lps'),
	(520182, 129, '2014-02-01 00:18:42.000000', 'consum', 0.0226, 'lps'),
	(520183, 129, '2014-02-01 00:18:43.000000', 'consum', 0.0225, 'lps'),
	(520184, 129, '2014-02-01 00:18:44.000000', 'consum', 0.0217, 'lps'),
	(520185, 129, '2014-02-01 00:18:45.000000', 'consum', 0.0221, 'lps'),
	(520186, 129, '2014-02-01 00:18:46.000000', 'consum', 0.0221, 'lps'),
	(520187, 129, '2014-02-01 00:18:47.000000', 'consum', 0.0213, 'lps'),
	(520188, 129, '2014-02-01 00:18:48.000000', 'consum', 0.0214, 'lps'),
	(520189, 129, '2014-02-01 00:18:49.000000', 'consum', 0.0223, 'lps'),
	(520190, 129, '2014-02-01 00:18:50.000000', 'consum', 0.0218, 'lps'),
	(520191, 129, '2014-02-01 00:18:51.000000', 'consum', 0.0214, 'lps'),
	(520192, 129, '2014-02-01 00:18:52.000000', 'consum', 0.0226, 'lps'),
	(520193, 129, '2014-02-01 00:18:53.000000', 'consum', 0.0214, 'lps'),
	(520194, 129, '2014-02-01 00:18:54.000000', 'consum', 0.0226, 'lps'),
	(520195, 129, '2014-02-01 00:18:55.000000', 'consum', 0.0212, 'lps'),
	(520196, 129, '2014-02-01 00:18:56.000000', 'consum', 0.0217, 'lps'),
	(520197, 129, '2014-02-01 00:18:57.000000', 'consum', 0.0218, 'lps'),
	(520198, 129, '2014-02-01 00:18:58.000000', 'consum', 0.0229, 'lps'),
	(520199, 129, '2014-02-01 00:18:59.000000', 'consum', 0.0214, 'lps'),
	(520200, 129, '2014-02-01 00:19:00.000000', 'consum', 0.0218, 'lps'),
	(520201, 129, '2014-02-01 00:19:01.000000', 'consum', 0.0217, 'lps'),
	(520202, 129, '2014-02-01 00:19:02.000000', 'consum', 0.0223, 'lps'),
	(520203, 129, '2014-02-01 00:19:03.000000', 'consum', 0.0231, 'lps'),
	(520204, 129, '2014-02-01 00:19:04.000000', 'consum', 0.0211, 'lps'),
	(520205, 129, '2014-02-01 00:19:05.000000', 'consum', 0.0217, 'lps'),
	(520206, 129, '2014-02-01 00:19:06.000000', 'consum', 0.0221, 'lps'),
	(520207, 129, '2014-02-01 00:19:07.000000', 'consum', 0.0221, 'lps'),
	(520208, 129, '2014-02-01 00:19:08.000000', 'consum', 0.0214, 'lps'),
	(520209, 129, '2014-02-01 00:19:09.000000', 'consum', 0.0217, 'lps'),
	(520210, 129, '2014-02-01 00:19:10.000000', 'consum', 0.0212, 'lps'),
	(520211, 129, '2014-02-01 00:19:11.000000', 'consum', 0.0223, 'lps'),
	(520212, 129, '2014-02-01 00:19:12.000000', 'consum', 0.0225, 'lps'),
	(520213, 129, '2014-02-01 00:19:13.000000', 'consum', 0.0222, 'lps'),
	(520214, 129, '2014-02-01 00:19:14.000000', 'consum', 0.0228, 'lps'),
	(520215, 129, '2014-02-01 00:19:15.000000', 'consum', 0.0221, 'lps'),
	(520216, 129, '2014-02-01 00:19:16.000000', 'consum', 0.0210, 'lps'),
	(520217, 129, '2014-02-01 00:19:17.000000', 'consum', 0.0223, 'lps'),
	(520218, 129, '2014-02-01 00:19:18.000000', 'consum', 0.0210, 'lps'),
	(520219, 129, '2014-02-01 00:19:19.000000', 'consum', 0.0215, 'lps'),
	(520220, 129, '2014-02-01 00:19:20.000000', 'consum', 0.0214, 'lps'),
	(520221, 129, '2014-02-01 00:19:21.000000', 'consum', 0.0215, 'lps'),
	(520222, 129, '2014-02-01 00:19:22.000000', 'consum', 0.0225, 'lps'),
	(520223, 129, '2014-02-01 00:19:23.000000', 'consum', 0.0224, 'lps'),
	(520224, 129, '2014-02-01 00:19:24.000000', 'consum', 0.0215, 'lps'),
	(520225, 129, '2014-02-01 00:19:25.000000', 'consum', 0.0215, 'lps'),
	(520226, 129, '2014-02-01 00:19:26.000000', 'consum', 0.0223, 'lps'),
	(520227, 129, '2014-02-01 00:19:27.000000', 'consum', 0.0213, 'lps'),
	(520228, 129, '2014-02-01 00:19:28.000000', 'consum', 0.0212, 'lps'),
	(520229, 129, '2014-02-01 00:19:29.000000', 'consum', 0.0231, 'lps'),
	(520230, 129, '2014-02-01 00:19:30.000000', 'consum', 0.0222, 'lps'),
	(520231, 129, '2014-02-01 00:19:31.000000', 'consum', 0.0229, 'lps'),
	(520232, 129, '2014-02-01 00:19:32.000000', 'consum', 0.0226, 'lps'),
	(520233, 129, '2014-02-01 00:19:33.000000', 'consum', 0.0211, 'lps'),
	(520234, 129, '2014-02-01 00:19:34.000000', 'consum', 0.0213, 'lps'),
	(520235, 129, '2014-02-01 00:19:35.000000', 'consum', 0.0221, 'lps'),
	(520236, 129, '2014-02-01 00:19:36.000000', 'consum', 0.0212, 'lps'),
	(520237, 129, '2014-02-01 00:19:37.000000', 'consum', 0.0231, 'lps'),
	(520238, 129, '2014-02-01 00:19:38.000000', 'consum', 0.0223, 'lps'),
	(520239, 129, '2014-02-01 00:19:39.000000', 'consum', 0.0213, 'lps'),
	(520240, 129, '2014-02-01 00:19:40.000000', 'consum', 0.0228, 'lps'),
	(520241, 129, '2014-02-01 00:19:41.000000', 'consum', 0.0228, 'lps'),
	(520242, 129, '2014-02-01 00:19:42.000000', 'consum', 0.0225, 'lps'),
	(520243, 129, '2014-02-01 00:19:43.000000', 'consum', 0.0230, 'lps'),
	(520244, 129, '2014-02-01 00:19:44.000000', 'consum', 0.0223, 'lps'),
	(520245, 129, '2014-02-01 00:19:45.000000', 'consum', 0.0215, 'lps'),
	(520246, 129, '2014-02-01 00:19:46.000000', 'consum', 0.0218, 'lps'),
	(520247, 129, '2014-02-01 00:19:47.000000', 'consum', 0.0212, 'lps'),
	(520248, 129, '2014-02-01 00:19:48.000000', 'consum', 0.0219, 'lps'),
	(520249, 129, '2014-02-01 00:19:49.000000', 'consum', 0.0229, 'lps'),
	(520250, 129, '2014-02-01 00:19:50.000000', 'consum', 0.0210, 'lps'),
	(520251, 129, '2014-02-01 00:19:51.000000', 'consum', 0.0222, 'lps'),
	(520252, 129, '2014-02-01 00:19:52.000000', 'consum', 0.0227, 'lps'),
	(520253, 129, '2014-02-01 00:19:53.000000', 'consum', 0.0215, 'lps'),
	(520254, 129, '2014-02-01 00:19:54.000000', 'consum', 0.0228, 'lps'),
	(520255, 129, '2014-02-01 00:19:55.000000', 'consum', 0.0221, 'lps'),
	(520256, 129, '2014-02-01 00:19:56.000000', 'consum', 0.0213, 'lps'),
	(520257, 129, '2014-02-01 00:19:57.000000', 'consum', 0.0211, 'lps'),
	(520258, 129, '2014-02-01 00:19:58.000000', 'consum', 0.0229, 'lps'),
	(520259, 129, '2014-02-01 00:19:59.000000', 'consum', 0.0213, 'lps'),
	(520260, 129, '2014-02-01 00:20:00.000000', 'consum', 0.0215, 'lps'),
	(520261, 129, '2014-02-01 00:20:01.000000', 'consum', 0.0226, 'lps'),
	(520262, 129, '2014-02-01 00:20:02.000000', 'consum', 0.0231, 'lps'),
	(520263, 129, '2014-02-01 00:20:03.000000', 'consum', 0.0222, 'lps'),
	(520264, 129, '2014-02-01 00:20:04.000000', 'consum', 0.0231, 'lps'),
	(520265, 129, '2014-02-01 00:20:05.000000', 'consum', 0.0213, 'lps'),
	(520266, 129, '2014-02-01 00:20:06.000000', 'consum', 0.0229, 'lps'),
	(520267, 129, '2014-02-01 00:20:07.000000', 'consum', 0.0210, 'lps'),
	(520268, 129, '2014-02-01 00:20:08.000000', 'consum', 0.0217, 'lps'),
	(520269, 129, '2014-02-01 00:20:09.000000', 'consum', 0.0223, 'lps'),
	(520270, 129, '2014-02-01 00:20:10.000000', 'consum', 0.0214, 'lps'),
	(520271, 129, '2014-02-01 00:20:11.000000', 'consum', 0.0210, 'lps'),
	(520272, 129, '2014-02-01 00:20:12.000000', 'consum', 0.0220, 'lps'),
	(520273, 129, '2014-02-01 00:20:13.000000', 'consum', 0.0220, 'lps'),
	(520274, 129, '2014-02-01 00:20:14.000000', 'consum', 0.0228, 'lps'),
	(520275, 129, '2014-02-01 00:20:15.000000', 'consum', 0.0226, 'lps'),
	(520276, 129, '2014-02-01 00:20:16.000000', 'consum', 0.0216, 'lps'),
	(520277, 129, '2014-02-01 00:20:17.000000', 'consum', 0.0214, 'lps'),
	(520278, 129, '2014-02-01 00:20:18.000000', 'consum', 0.0212, 'lps'),
	(520279, 129, '2014-02-01 00:20:19.000000', 'consum', 0.0211, 'lps'),
	(520280, 129, '2014-02-01 00:20:20.000000', 'consum', 0.0229, 'lps'),
	(520281, 129, '2014-02-01 00:20:21.000000', 'consum', 0.0216, 'lps'),
	(520282, 129, '2014-02-01 00:20:22.000000', 'consum', 0.0229, 'lps'),
	(520283, 129, '2014-02-01 00:20:23.000000', 'consum', 0.0219, 'lps'),
	(520284, 129, '2014-02-01 00:20:24.000000', 'consum', 0.0219, 'lps'),
	(520285, 129, '2014-02-01 00:20:25.000000', 'consum', 0.0210, 'lps'),
	(520286, 129, '2014-02-01 00:20:26.000000', 'consum', 0.0225, 'lps'),
	(520287, 129, '2014-02-01 00:20:27.000000', 'consum', 0.0219, 'lps'),
	(520288, 129, '2014-02-01 00:20:28.000000', 'consum', 0.0231, 'lps'),
	(520289, 129, '2014-02-01 00:20:29.000000', 'consum', 0.0225, 'lps'),
	(520290, 129, '2014-02-01 00:20:30.000000', 'consum', 0.0224, 'lps'),
	(520291, 129, '2014-02-01 00:20:31.000000', 'consum', 0.0212, 'lps'),
	(520292, 129, '2014-02-01 00:20:32.000000', 'consum', 0.0223, 'lps'),
	(520293, 129, '2014-02-01 00:20:33.000000', 'consum', 0.0224, 'lps'),
	(520294, 129, '2014-02-01 00:20:34.000000', 'consum', 0.0221, 'lps'),
	(520295, 129, '2014-02-01 00:20:35.000000', 'consum', 0.0223, 'lps'),
	(520296, 129, '2014-02-01 00:20:36.000000', 'consum', 0.0220, 'lps'),
	(520297, 129, '2014-02-01 00:20:37.000000', 'consum', 0.0223, 'lps'),
	(520298, 129, '2014-02-01 00:20:38.000000', 'consum', 0.0221, 'lps'),
	(520299, 129, '2014-02-01 00:20:39.000000', 'consum', 0.0228, 'lps'),
	(520300, 129, '2014-02-01 00:20:40.000000', 'consum', 0.0222, 'lps'),
	(520301, 129, '2014-02-01 00:20:41.000000', 'consum', 0.0217, 'lps'),
	(520302, 129, '2014-02-01 00:20:42.000000', 'consum', 0.0211, 'lps'),
	(520303, 129, '2014-02-01 00:20:43.000000', 'consum', 0.0218, 'lps'),
	(520304, 129, '2014-02-01 00:20:44.000000', 'consum', 0.0222, 'lps'),
	(520305, 129, '2014-02-01 00:20:45.000000', 'consum', 0.0227, 'lps'),
	(520306, 129, '2014-02-01 00:20:46.000000', 'consum', 0.0213, 'lps'),
	(520307, 129, '2014-02-01 00:20:47.000000', 'consum', 0.0221, 'lps'),
	(520308, 129, '2014-02-01 00:20:48.000000', 'consum', 0.0213, 'lps'),
	(520309, 129, '2014-02-01 00:20:49.000000', 'consum', 0.0212, 'lps'),
	(520310, 129, '2014-02-01 00:20:50.000000', 'consum', 0.0213, 'lps'),
	(520311, 129, '2014-02-01 00:20:51.000000', 'consum', 0.0221, 'lps'),
	(520312, 129, '2014-02-01 00:20:52.000000', 'consum', 0.0231, 'lps'),
	(520313, 129, '2014-02-01 00:20:53.000000', 'consum', 0.0219, 'lps'),
	(520314, 129, '2014-02-01 00:20:54.000000', 'consum', 0.0213, 'lps'),
	(520315, 129, '2014-02-01 00:20:55.000000', 'consum', 0.0221, 'lps'),
	(520316, 129, '2014-02-01 00:20:56.000000', 'consum', 0.0214, 'lps'),
	(520317, 129, '2014-02-01 00:20:57.000000', 'consum', 0.0220, 'lps'),
	(520318, 129, '2014-02-01 00:20:58.000000', 'consum', 0.0227, 'lps'),
	(520319, 129, '2014-02-01 00:20:59.000000', 'consum', 0.0221, 'lps'),
	(520320, 129, '2014-02-01 00:21:00.000000', 'consum', 0.0213, 'lps'),
	(520321, 129, '2014-02-01 00:21:01.000000', 'consum', 0.0215, 'lps'),
	(520322, 129, '2014-02-01 00:21:02.000000', 'consum', 0.0227, 'lps'),
	(520323, 129, '2014-02-01 00:21:03.000000', 'consum', 0.0212, 'lps'),
	(520324, 129, '2014-02-01 00:21:04.000000', 'consum', 0.0217, 'lps'),
	(520325, 129, '2014-02-01 00:21:05.000000', 'consum', 0.0216, 'lps'),
	(520326, 129, '2014-02-01 00:21:06.000000', 'consum', 0.0221, 'lps'),
	(520327, 129, '2014-02-01 00:21:07.000000', 'consum', 0.0224, 'lps'),
	(520328, 129, '2014-02-01 00:21:08.000000', 'consum', 0.0227, 'lps'),
	(520329, 129, '2014-02-01 00:21:09.000000', 'consum', 0.0231, 'lps'),
	(520330, 129, '2014-02-01 00:21:10.000000', 'consum', 0.0222, 'lps'),
	(520331, 129, '2014-02-01 00:21:11.000000', 'consum', 0.0227, 'lps'),
	(520332, 129, '2014-02-01 00:21:12.000000', 'consum', 0.0217, 'lps'),
	(520333, 129, '2014-02-01 00:21:13.000000', 'consum', 0.0217, 'lps'),
	(520334, 129, '2014-02-01 00:21:14.000000', 'consum', 0.0222, 'lps'),
	(520335, 129, '2014-02-01 00:21:15.000000', 'consum', 0.0229, 'lps'),
	(520336, 129, '2014-02-01 00:21:16.000000', 'consum', 0.0227, 'lps'),
	(520337, 129, '2014-02-01 00:21:17.000000', 'consum', 0.0217, 'lps'),
	(520338, 129, '2014-02-01 00:21:18.000000', 'consum', 0.0214, 'lps'),
	(520339, 129, '2014-02-01 00:21:19.000000', 'consum', 0.0210, 'lps'),
	(520340, 129, '2014-02-01 00:21:20.000000', 'consum', 0.0220, 'lps'),
	(520341, 129, '2014-02-01 00:21:21.000000', 'consum', 0.0218, 'lps'),
	(520342, 129, '2014-02-01 00:21:22.000000', 'consum', 0.0218, 'lps'),
	(520343, 129, '2014-02-01 00:21:23.000000', 'consum', 0.0228, 'lps'),
	(520344, 129, '2014-02-01 00:21:24.000000', 'consum', 0.0211, 'lps'),
	(520345, 129, '2014-02-01 00:21:25.000000', 'consum', 0.0227, 'lps'),
	(520346, 129, '2014-02-01 00:21:26.000000', 'consum', 0.0224, 'lps'),
	(520347, 129, '2014-02-01 00:21:27.000000', 'consum', 0.0211, 'lps'),
	(520348, 129, '2014-02-01 00:21:28.000000', 'consum', 0.0217, 'lps'),
	(520349, 129, '2014-02-01 00:21:29.000000', 'consum', 0.0222, 'lps'),
	(520350, 129, '2014-02-01 00:21:30.000000', 'consum', 0.0227, 'lps'),
	(520351, 129, '2014-02-01 00:21:31.000000', 'consum', 0.0214, 'lps'),
	(520352, 129, '2014-02-01 00:21:32.000000', 'consum', 0.0223, 'lps'),
	(520353, 129, '2014-02-01 00:21:33.000000', 'consum', 0.0218, 'lps'),
	(520354, 129, '2014-02-01 00:21:34.000000', 'consum', 0.0214, 'lps'),
	(520355, 129, '2014-02-01 00:21:35.000000', 'consum', 0.0228, 'lps'),
	(520356, 129, '2014-02-01 00:21:36.000000', 'consum', 0.0223, 'lps'),
	(520357, 129, '2014-02-01 00:21:37.000000', 'consum', 0.0220, 'lps'),
	(520358, 129, '2014-02-01 00:21:38.000000', 'consum', 0.0223, 'lps'),
	(520359, 129, '2014-02-01 00:21:39.000000', 'consum', 0.0221, 'lps'),
	(520360, 129, '2014-02-01 00:21:40.000000', 'consum', 0.0228, 'lps'),
	(520361, 129, '2014-02-01 00:21:41.000000', 'consum', 0.0221, 'lps'),
	(520362, 129, '2014-02-01 00:21:42.000000', 'consum', 0.0215, 'lps'),
	(520363, 129, '2014-02-01 00:21:43.000000', 'consum', 0.0224, 'lps'),
	(520364, 129, '2014-02-01 00:21:44.000000', 'consum', 0.0221, 'lps'),
	(520365, 129, '2014-02-01 00:21:45.000000', 'consum', 0.0222, 'lps'),
	(520366, 129, '2014-02-01 00:21:46.000000', 'consum', 0.0218, 'lps'),
	(520367, 129, '2014-02-01 00:21:47.000000', 'consum', 0.0214, 'lps'),
	(520368, 129, '2014-02-01 00:21:48.000000', 'consum', 0.0228, 'lps'),
	(520369, 129, '2014-02-01 00:21:49.000000', 'consum', 0.0221, 'lps'),
	(520370, 129, '2014-02-01 00:21:50.000000', 'consum', 0.0214, 'lps'),
	(520371, 129, '2014-02-01 00:21:51.000000', 'consum', 0.0217, 'lps'),
	(520372, 129, '2014-02-01 00:21:52.000000', 'consum', 0.0213, 'lps'),
	(520373, 129, '2014-02-01 00:21:53.000000', 'consum', 0.0227, 'lps'),
	(520374, 129, '2014-02-01 00:21:54.000000', 'consum', 0.0218, 'lps'),
	(520375, 129, '2014-02-01 00:21:55.000000', 'consum', 0.0223, 'lps'),
	(520376, 129, '2014-02-01 00:21:56.000000', 'consum', 0.0228, 'lps'),
	(520377, 129, '2014-02-01 00:21:57.000000', 'consum', 0.0218, 'lps'),
	(520378, 129, '2014-02-01 00:21:58.000000', 'consum', 0.0218, 'lps'),
	(520379, 129, '2014-02-01 00:21:59.000000', 'consum', 0.0228, 'lps'),
	(520380, 129, '2014-02-01 00:22:00.000000', 'consum', 0.0210, 'lps'),
	(520381, 129, '2014-02-01 00:22:01.000000', 'consum', 0.0223, 'lps'),
	(520382, 129, '2014-02-01 00:22:02.000000', 'consum', 0.0210, 'lps'),
	(520383, 129, '2014-02-01 00:22:03.000000', 'consum', 0.0214, 'lps'),
	(520384, 129, '2014-02-01 00:22:04.000000', 'consum', 0.0231, 'lps'),
	(520385, 129, '2014-02-01 00:22:05.000000', 'consum', 0.0216, 'lps'),
	(520386, 129, '2014-02-01 00:22:06.000000', 'consum', 0.0220, 'lps'),
	(520387, 129, '2014-02-01 00:22:07.000000', 'consum', 0.0220, 'lps'),
	(520388, 129, '2014-02-01 00:22:08.000000', 'consum', 0.0211, 'lps'),
	(520389, 129, '2014-02-01 00:22:09.000000', 'consum', 0.0227, 'lps'),
	(520390, 129, '2014-02-01 00:22:10.000000', 'consum', 0.0227, 'lps'),
	(520391, 129, '2014-02-01 00:22:11.000000', 'consum', 0.0222, 'lps'),
	(520392, 129, '2014-02-01 00:22:12.000000', 'consum', 0.0222, 'lps'),
	(520393, 129, '2014-02-01 00:22:13.000000', 'consum', 0.0210, 'lps'),
	(520394, 129, '2014-02-01 00:22:14.000000', 'consum', 0.0220, 'lps'),
	(520395, 129, '2014-02-01 00:22:15.000000', 'consum', 0.0218, 'lps'),
	(520396, 129, '2014-02-01 00:22:16.000000', 'consum', 0.0219, 'lps'),
	(520397, 129, '2014-02-01 00:22:17.000000', 'consum', 0.0231, 'lps'),
	(520398, 129, '2014-02-01 00:22:18.000000', 'consum', 0.0221, 'lps'),
	(520399, 129, '2014-02-01 00:22:19.000000', 'consum', 0.0225, 'lps'),
	(520400, 129, '2014-02-01 00:22:20.000000', 'consum', 0.0230, 'lps'),
	(520401, 129, '2014-02-01 00:22:21.000000', 'consum', 0.0223, 'lps'),
	(520402, 129, '2014-02-01 00:22:22.000000', 'consum', 0.0216, 'lps'),
	(520403, 129, '2014-02-01 00:22:23.000000', 'consum', 0.0223, 'lps'),
	(520404, 129, '2014-02-01 00:22:24.000000', 'consum', 0.0214, 'lps'),
	(520405, 129, '2014-02-01 00:22:25.000000', 'consum', 0.0213, 'lps'),
	(520406, 129, '2014-02-01 00:22:26.000000', 'consum', 0.0212, 'lps'),
	(520407, 129, '2014-02-01 00:22:27.000000', 'consum', 0.0214, 'lps'),
	(520408, 129, '2014-02-01 00:22:28.000000', 'consum', 0.0225, 'lps'),
	(520409, 129, '2014-02-01 00:22:29.000000', 'consum', 0.0230, 'lps'),
	(520410, 129, '2014-02-01 00:22:30.000000', 'consum', 0.0221, 'lps'),
	(520411, 129, '2014-02-01 00:22:31.000000', 'consum', 0.0227, 'lps'),
	(520412, 129, '2014-02-01 00:22:32.000000', 'consum', 0.0217, 'lps'),
	(520413, 129, '2014-02-01 00:22:33.000000', 'consum', 0.0219, 'lps'),
	(520414, 129, '2014-02-01 00:22:34.000000', 'consum', 0.0211, 'lps'),
	(520415, 129, '2014-02-01 00:22:35.000000', 'consum', 0.0231, 'lps'),
	(520416, 129, '2014-02-01 00:22:36.000000', 'consum', 0.0226, 'lps'),
	(520417, 129, '2014-02-01 00:22:37.000000', 'consum', 0.0229, 'lps'),
	(520418, 129, '2014-02-01 00:22:38.000000', 'consum', 0.0210, 'lps'),
	(520419, 129, '2014-02-01 00:22:39.000000', 'consum', 0.0222, 'lps'),
	(520420, 129, '2014-02-01 00:22:40.000000', 'consum', 0.0227, 'lps'),
	(520421, 129, '2014-02-01 00:22:41.000000', 'consum', 0.0215, 'lps'),
	(520422, 129, '2014-02-01 00:22:42.000000', 'consum', 0.0228, 'lps'),
	(520423, 129, '2014-02-01 00:22:43.000000', 'consum', 0.0219, 'lps'),
	(520424, 129, '2014-02-01 00:22:44.000000', 'consum', 0.0225, 'lps'),
	(520425, 129, '2014-02-01 00:22:45.000000', 'consum', 0.0213, 'lps'),
	(520426, 129, '2014-02-01 00:22:46.000000', 'consum', 0.0226, 'lps'),
	(520427, 129, '2014-02-01 00:22:47.000000', 'consum', 0.0213, 'lps'),
	(520428, 129, '2014-02-01 00:22:48.000000', 'consum', 0.0222, 'lps'),
	(520429, 129, '2014-02-01 00:22:49.000000', 'consum', 0.0217, 'lps'),
	(520430, 129, '2014-02-01 00:22:50.000000', 'consum', 0.0231, 'lps'),
	(520431, 129, '2014-02-01 00:22:51.000000', 'consum', 0.0228, 'lps'),
	(520432, 129, '2014-02-01 00:22:52.000000', 'consum', 0.0217, 'lps'),
	(520433, 129, '2014-02-01 00:22:53.000000', 'consum', 0.0212, 'lps'),
	(520434, 129, '2014-02-01 00:22:54.000000', 'consum', 0.0221, 'lps'),
	(520435, 129, '2014-02-01 00:22:55.000000', 'consum', 0.0215, 'lps'),
	(520436, 129, '2014-02-01 00:22:56.000000', 'consum', 0.0227, 'lps'),
	(520437, 129, '2014-02-01 00:22:57.000000', 'consum', 0.0212, 'lps'),
	(520438, 129, '2014-02-01 00:22:58.000000', 'consum', 0.0213, 'lps'),
	(520439, 129, '2014-02-01 00:22:59.000000', 'consum', 0.0222, 'lps'),
	(520440, 129, '2014-02-01 00:23:00.000000', 'consum', 0.0217, 'lps'),
	(520441, 129, '2014-02-01 00:23:01.000000', 'consum', 0.0211, 'lps'),
	(520442, 129, '2014-02-01 00:23:02.000000', 'consum', 0.0214, 'lps'),
	(520443, 129, '2014-02-01 00:23:03.000000', 'consum', 0.0229, 'lps'),
	(520444, 129, '2014-02-01 00:23:04.000000', 'consum', 0.0228, 'lps'),
	(520445, 129, '2014-02-01 00:23:05.000000', 'consum', 0.0221, 'lps'),
	(520446, 129, '2014-02-01 00:23:06.000000', 'consum', 0.0211, 'lps'),
	(520447, 129, '2014-02-01 00:23:07.000000', 'consum', 0.0225, 'lps'),
	(520448, 129, '2014-02-01 00:23:08.000000', 'consum', 0.0218, 'lps'),
	(520449, 129, '2014-02-01 00:23:09.000000', 'consum', 0.0226, 'lps'),
	(520450, 129, '2014-02-01 00:23:10.000000', 'consum', 0.0223, 'lps'),
	(520451, 129, '2014-02-01 00:23:11.000000', 'consum', 0.0229, 'lps'),
	(520452, 129, '2014-02-01 00:23:12.000000', 'consum', 0.0222, 'lps'),
	(520453, 129, '2014-02-01 00:23:13.000000', 'consum', 0.0214, 'lps'),
	(520454, 129, '2014-02-01 00:23:14.000000', 'consum', 0.0215, 'lps'),
	(520455, 129, '2014-02-01 00:23:15.000000', 'consum', 0.0226, 'lps'),
	(520456, 129, '2014-02-01 00:23:16.000000', 'consum', 0.0229, 'lps'),
	(520457, 129, '2014-02-01 00:23:17.000000', 'consum', 0.0216, 'lps'),
	(520458, 129, '2014-02-01 00:23:18.000000', 'consum', 0.0228, 'lps'),
	(520459, 129, '2014-02-01 00:23:19.000000', 'consum', 0.0217, 'lps'),
	(520460, 129, '2014-02-01 00:23:20.000000', 'consum', 0.0213, 'lps'),
	(520461, 129, '2014-02-01 00:23:21.000000', 'consum', 0.0225, 'lps'),
	(520462, 129, '2014-02-01 00:23:22.000000', 'consum', 0.0210, 'lps'),
	(520463, 129, '2014-02-01 00:23:23.000000', 'consum', 0.0231, 'lps'),
	(520464, 129, '2014-02-01 00:23:24.000000', 'consum', 0.0230, 'lps'),
	(520465, 129, '2014-02-01 00:23:25.000000', 'consum', 0.0223, 'lps'),
	(520466, 129, '2014-02-01 00:23:26.000000', 'consum', 0.0218, 'lps'),
	(520467, 129, '2014-02-01 00:23:27.000000', 'consum', 0.0212, 'lps'),
	(520468, 129, '2014-02-01 00:23:28.000000', 'consum', 0.0215, 'lps'),
	(520469, 129, '2014-02-01 00:23:29.000000', 'consum', 0.0210, 'lps'),
	(520470, 129, '2014-02-01 00:23:30.000000', 'consum', 0.0219, 'lps'),
	(520471, 129, '2014-02-01 00:23:31.000000', 'consum', 0.0231, 'lps'),
	(520472, 129, '2014-02-01 00:23:32.000000', 'consum', 0.0223, 'lps'),
	(520473, 129, '2014-02-01 00:23:33.000000', 'consum', 0.0211, 'lps'),
	(520474, 129, '2014-02-01 00:23:34.000000', 'consum', 0.0222, 'lps'),
	(520475, 129, '2014-02-01 00:23:35.000000', 'consum', 0.0224, 'lps'),
	(520476, 129, '2014-02-01 00:23:36.000000', 'consum', 0.0223, 'lps'),
	(520477, 129, '2014-02-01 00:23:37.000000', 'consum', 0.0210, 'lps'),
	(520478, 129, '2014-02-01 00:23:38.000000', 'consum', 0.0215, 'lps'),
	(520479, 129, '2014-02-01 00:23:39.000000', 'consum', 0.0213, 'lps'),
	(520480, 129, '2014-02-01 00:23:40.000000', 'consum', 0.0212, 'lps'),
	(520481, 129, '2014-02-01 00:23:41.000000', 'consum', 0.0211, 'lps'),
	(520482, 129, '2014-02-01 00:23:42.000000', 'consum', 0.0212, 'lps'),
	(520483, 129, '2014-02-01 00:23:43.000000', 'consum', 0.0214, 'lps'),
	(520484, 129, '2014-02-01 00:23:44.000000', 'consum', 0.0226, 'lps'),
	(520485, 129, '2014-02-01 00:23:45.000000', 'consum', 0.0210, 'lps'),
	(520486, 129, '2014-02-01 00:23:46.000000', 'consum', 0.0231, 'lps'),
	(520487, 129, '2014-02-01 00:23:47.000000', 'consum', 0.0226, 'lps'),
	(520488, 129, '2014-02-01 00:23:48.000000', 'consum', 0.0229, 'lps'),
	(520489, 129, '2014-02-01 00:23:49.000000', 'consum', 0.0213, 'lps'),
	(520490, 129, '2014-02-01 00:23:50.000000', 'consum', 0.0215, 'lps'),
	(520491, 129, '2014-02-01 00:23:51.000000', 'consum', 0.0223, 'lps'),
	(520492, 129, '2014-02-01 00:23:52.000000', 'consum', 0.0216, 'lps'),
	(520493, 129, '2014-02-01 00:23:53.000000', 'consum', 0.0225, 'lps'),
	(520494, 129, '2014-02-01 00:23:54.000000', 'consum', 0.0223, 'lps'),
	(520495, 129, '2014-02-01 00:23:55.000000', 'consum', 0.0230, 'lps'),
	(520496, 129, '2014-02-01 00:23:56.000000', 'consum', 0.0226, 'lps'),
	(520497, 129, '2014-02-01 00:23:57.000000', 'consum', 0.0211, 'lps'),
	(520498, 129, '2014-02-01 00:23:58.000000', 'consum', 0.0231, 'lps'),
	(520499, 129, '2014-02-01 00:23:59.000000', 'consum', 0.0224, 'lps'),
	(520500, 129, '2014-02-01 00:24:00.000000', 'consum', 0.0219, 'lps'),
	(520501, 129, '2014-02-01 00:24:01.000000', 'consum', 0.0211, 'lps'),
	(520502, 129, '2014-02-01 00:24:02.000000', 'consum', 0.0214, 'lps'),
	(520503, 129, '2014-02-01 00:24:03.000000', 'consum', 0.0225, 'lps'),
	(520504, 129, '2014-02-01 00:24:04.000000', 'consum', 0.0230, 'lps'),
	(520505, 129, '2014-02-01 00:24:05.000000', 'consum', 0.0221, 'lps'),
	(520506, 129, '2014-02-01 00:24:06.000000', 'consum', 0.0227, 'lps'),
	(520507, 129, '2014-02-01 00:24:07.000000', 'consum', 0.0217, 'lps'),
	(520508, 129, '2014-02-01 00:24:08.000000', 'consum', 0.0219, 'lps'),
	(520509, 129, '2014-02-01 00:24:09.000000', 'consum', 0.0211, 'lps'),
	(520510, 129, '2014-02-01 00:24:10.000000', 'consum', 0.0211, 'lps'),
	(520511, 129, '2014-02-01 00:24:11.000000', 'consum', 0.0211, 'lps'),
	(520512, 129, '2014-02-01 00:24:12.000000', 'consum', 0.0214, 'lps'),
	(520513, 129, '2014-02-01 00:24:13.000000', 'consum', 0.0227, 'lps'),
	(520514, 129, '2014-02-01 00:24:14.000000', 'consum', 0.0218, 'lps'),
	(520515, 129, '2014-02-01 00:24:15.000000', 'consum', 0.0220, 'lps'),
	(520516, 129, '2014-02-01 00:24:16.000000', 'consum', 0.0216, 'lps'),
	(520517, 129, '2014-02-01 00:24:17.000000', 'consum', 0.0231, 'lps'),
	(520518, 129, '2014-02-01 00:24:18.000000', 'consum', 0.0210, 'lps'),
	(520519, 129, '2014-02-01 00:24:19.000000', 'consum', 0.0214, 'lps'),
	(520520, 129, '2014-02-01 00:24:20.000000', 'consum', 0.0230, 'lps'),
	(520521, 129, '2014-02-01 00:24:21.000000', 'consum', 0.0211, 'lps'),
	(520522, 129, '2014-02-01 00:24:22.000000', 'consum', 0.0221, 'lps'),
	(520523, 129, '2014-02-01 00:24:23.000000', 'consum', 0.0217, 'lps'),
	(520524, 129, '2014-02-01 00:24:24.000000', 'consum', 0.0215, 'lps'),
	(520525, 129, '2014-02-01 00:24:25.000000', 'consum', 0.0215, 'lps'),
	(520526, 129, '2014-02-01 00:24:26.000000', 'consum', 0.0220, 'lps'),
	(520527, 129, '2014-02-01 00:24:27.000000', 'consum', 0.0224, 'lps'),
	(520528, 129, '2014-02-01 00:24:28.000000', 'consum', 0.0230, 'lps'),
	(520529, 129, '2014-02-01 00:24:29.000000', 'consum', 0.0223, 'lps'),
	(520530, 129, '2014-02-01 00:24:30.000000', 'consum', 0.0214, 'lps'),
	(520531, 129, '2014-02-01 00:24:31.000000', 'consum', 0.0216, 'lps'),
	(520532, 129, '2014-02-01 00:24:32.000000', 'consum', 0.0229, 'lps'),
	(520533, 129, '2014-02-01 00:24:33.000000', 'consum', 0.0222, 'lps'),
	(520534, 129, '2014-02-01 00:24:34.000000', 'consum', 0.0214, 'lps'),
	(520535, 129, '2014-02-01 00:24:35.000000', 'consum', 0.0216, 'lps'),
	(520536, 129, '2014-02-01 00:24:36.000000', 'consum', 0.0228, 'lps'),
	(520537, 129, '2014-02-01 00:24:37.000000', 'consum', 0.0218, 'lps'),
	(520538, 129, '2014-02-01 00:24:38.000000', 'consum', 0.0217, 'lps'),
	(520539, 129, '2014-02-01 00:24:39.000000', 'consum', 0.0223, 'lps'),
	(520540, 129, '2014-02-01 00:24:40.000000', 'consum', 0.0212, 'lps'),
	(520541, 129, '2014-02-01 00:24:41.000000', 'consum', 0.0223, 'lps'),
	(520542, 129, '2014-02-01 00:24:42.000000', 'consum', 0.0224, 'lps'),
	(520543, 129, '2014-02-01 00:24:43.000000', 'consum', 0.0223, 'lps'),
	(520544, 129, '2014-02-01 00:24:44.000000', 'consum', 0.0230, 'lps'),
	(520545, 129, '2014-02-01 00:24:45.000000', 'consum', 0.0231, 'lps'),
	(520546, 129, '2014-02-01 00:24:46.000000', 'consum', 0.0230, 'lps'),
	(520547, 129, '2014-02-01 00:24:47.000000', 'consum', 0.0229, 'lps'),
	(520548, 129, '2014-02-01 00:24:48.000000', 'consum', 0.0222, 'lps'),
	(520549, 129, '2014-02-01 00:24:49.000000', 'consum', 0.0215, 'lps'),
	(520550, 129, '2014-02-01 00:24:50.000000', 'consum', 0.0223, 'lps'),
	(520551, 129, '2014-02-01 00:24:51.000000', 'consum', 0.0213, 'lps'),
	(520552, 129, '2014-02-01 00:24:52.000000', 'consum', 0.0231, 'lps'),
	(520553, 129, '2014-02-01 00:24:53.000000', 'consum', 0.0220, 'lps'),
	(520554, 129, '2014-02-01 00:24:54.000000', 'consum', 0.0219, 'lps'),
	(520555, 129, '2014-02-01 00:24:55.000000', 'consum', 0.0227, 'lps'),
	(520556, 129, '2014-02-01 00:24:56.000000', 'consum', 0.0221, 'lps'),
	(520557, 129, '2014-02-01 00:24:57.000000', 'consum', 0.0218, 'lps'),
	(520558, 129, '2014-02-01 00:24:58.000000', 'consum', 0.0217, 'lps'),
	(520559, 129, '2014-02-01 00:24:59.000000', 'consum', 0.0222, 'lps'),
	(520560, 129, '2014-02-01 00:25:00.000000', 'consum', 0.0227, 'lps'),
	(520561, 129, '2014-02-01 00:25:01.000000', 'consum', 0.0216, 'lps'),
	(520562, 129, '2014-02-01 00:25:02.000000', 'consum', 0.0231, 'lps'),
	(520563, 129, '2014-02-01 00:25:03.000000', 'consum', 0.0212, 'lps'),
	(520564, 129, '2014-02-01 00:25:04.000000', 'consum', 0.0221, 'lps'),
	(520565, 129, '2014-02-01 00:25:05.000000', 'consum', 0.0218, 'lps'),
	(520566, 129, '2014-02-01 00:25:06.000000', 'consum', 0.0215, 'lps'),
	(520567, 129, '2014-02-01 00:25:07.000000', 'consum', 0.0213, 'lps'),
	(520568, 129, '2014-02-01 00:25:08.000000', 'consum', 0.0212, 'lps'),
	(520569, 129, '2014-02-01 00:25:09.000000', 'consum', 0.0210, 'lps'),
	(520570, 129, '2014-02-01 00:25:10.000000', 'consum', 0.0225, 'lps'),
	(520571, 129, '2014-02-01 00:25:11.000000', 'consum', 0.0223, 'lps'),
	(520572, 129, '2014-02-01 00:25:12.000000', 'consum', 0.0228, 'lps'),
	(520573, 129, '2014-02-01 00:25:13.000000', 'consum', 0.0218, 'lps'),
	(520574, 129, '2014-02-01 00:25:14.000000', 'consum', 0.0217, 'lps'),
	(520575, 129, '2014-02-01 00:25:15.000000', 'consum', 0.0223, 'lps'),
	(520576, 129, '2014-02-01 00:25:16.000000', 'consum', 0.0231, 'lps'),
	(520577, 129, '2014-02-01 00:25:17.000000', 'consum', 0.0210, 'lps'),
	(520578, 129, '2014-02-01 00:25:18.000000', 'consum', 0.0216, 'lps'),
	(520579, 129, '2014-02-01 00:25:19.000000', 'consum', 0.0216, 'lps'),
	(520580, 129, '2014-02-01 00:25:20.000000', 'consum', 0.0223, 'lps'),
	(520581, 129, '2014-02-01 00:25:21.000000', 'consum', 0.0216, 'lps'),
	(520582, 129, '2014-02-01 00:25:22.000000', 'consum', 0.0221, 'lps'),
	(520583, 129, '2014-02-01 00:25:23.000000', 'consum', 0.0225, 'lps'),
	(520584, 129, '2014-02-01 00:25:24.000000', 'consum', 0.0210, 'lps'),
	(520585, 129, '2014-02-01 00:25:25.000000', 'consum', 0.0211, 'lps'),
	(520586, 129, '2014-02-01 00:25:26.000000', 'consum', 0.0213, 'lps'),
	(520587, 129, '2014-02-01 00:25:27.000000', 'consum', 0.0222, 'lps'),
	(520588, 129, '2014-02-01 00:25:28.000000', 'consum', 0.0219, 'lps'),
	(520589, 129, '2014-02-01 00:25:29.000000', 'consum', 0.0219, 'lps'),
	(520590, 129, '2014-02-01 00:25:30.000000', 'consum', 0.0227, 'lps'),
	(520591, 129, '2014-02-01 00:25:31.000000', 'consum', 0.0226, 'lps'),
	(520592, 129, '2014-02-01 00:25:32.000000', 'consum', 0.0216, 'lps'),
	(520593, 129, '2014-02-01 00:25:33.000000', 'consum', 0.0217, 'lps'),
	(520594, 129, '2014-02-01 00:25:34.000000', 'consum', 0.0226, 'lps'),
	(520595, 129, '2014-02-01 00:25:35.000000', 'consum', 0.0226, 'lps'),
	(520596, 129, '2014-02-01 00:25:36.000000', 'consum', 0.0222, 'lps'),
	(520597, 129, '2014-02-01 00:25:37.000000', 'consum', 0.0220, 'lps'),
	(520598, 129, '2014-02-01 00:25:38.000000', 'consum', 0.0225, 'lps'),
	(520599, 129, '2014-02-01 00:25:39.000000', 'consum', 0.0211, 'lps'),
	(520600, 129, '2014-02-01 00:25:40.000000', 'consum', 0.0217, 'lps'),
	(520601, 129, '2014-02-01 00:25:41.000000', 'consum', 0.0217, 'lps'),
	(520602, 129, '2014-02-01 00:25:42.000000', 'consum', 0.0226, 'lps'),
	(520603, 129, '2014-02-01 00:25:43.000000', 'consum', 0.0226, 'lps'),
	(520604, 129, '2014-02-01 00:25:44.000000', 'consum', 0.0219, 'lps'),
	(520605, 129, '2014-02-01 00:25:45.000000', 'consum', 0.0231, 'lps'),
	(520606, 129, '2014-02-01 00:25:46.000000', 'consum', 0.0222, 'lps'),
	(520607, 129, '2014-02-01 00:25:47.000000', 'consum', 0.0231, 'lps'),
	(520608, 129, '2014-02-01 00:25:48.000000', 'consum', 0.0211, 'lps'),
	(520609, 129, '2014-02-01 00:25:49.000000', 'consum', 0.0219, 'lps'),
	(520610, 129, '2014-02-01 00:25:50.000000', 'consum', 0.0229, 'lps'),
	(520611, 129, '2014-02-01 00:25:51.000000', 'consum', 0.0215, 'lps'),
	(520612, 129, '2014-02-01 00:25:52.000000', 'consum', 0.0223, 'lps'),
	(520613, 129, '2014-02-01 00:25:53.000000', 'consum', 0.0215, 'lps'),
	(520614, 129, '2014-02-01 00:25:54.000000', 'consum', 0.0218, 'lps'),
	(520615, 129, '2014-02-01 00:25:55.000000', 'consum', 0.0212, 'lps'),
	(520616, 129, '2014-02-01 00:25:56.000000', 'consum', 0.0222, 'lps'),
	(520617, 129, '2014-02-01 00:25:57.000000', 'consum', 0.0219, 'lps'),
	(520618, 129, '2014-02-01 00:25:58.000000', 'consum', 0.0221, 'lps'),
	(520619, 129, '2014-02-01 00:25:59.000000', 'consum', 0.0217, 'lps'),
	(520620, 129, '2014-02-01 00:26:00.000000', 'consum', 0.0212, 'lps'),
	(520621, 129, '2014-02-01 00:26:01.000000', 'consum', 0.0221, 'lps'),
	(520622, 129, '2014-02-01 00:26:02.000000', 'consum', 0.0215, 'lps'),
	(520623, 129, '2014-02-01 00:26:03.000000', 'consum', 0.0225, 'lps'),
	(520624, 129, '2014-02-01 00:26:04.000000', 'consum', 0.0226, 'lps'),
	(520625, 129, '2014-02-01 00:26:05.000000', 'consum', 0.0224, 'lps'),
	(520626, 129, '2014-02-01 00:26:06.000000', 'consum', 0.0231, 'lps'),
	(520627, 129, '2014-02-01 00:26:07.000000', 'consum', 0.0210, 'lps'),
	(520628, 129, '2014-02-01 00:26:08.000000', 'consum', 0.0214, 'lps'),
	(520629, 129, '2014-02-01 00:26:09.000000', 'consum', 0.0231, 'lps'),
	(520630, 129, '2014-02-01 00:26:10.000000', 'consum', 0.0216, 'lps'),
	(520631, 129, '2014-02-01 00:26:11.000000', 'consum', 0.0220, 'lps'),
	(520632, 129, '2014-02-01 00:26:12.000000', 'consum', 0.0219, 'lps'),
	(520633, 129, '2014-02-01 00:26:13.000000', 'consum', 0.0226, 'lps'),
	(520634, 129, '2014-02-01 00:26:14.000000', 'consum', 0.0219, 'lps'),
	(520635, 129, '2014-02-01 00:26:15.000000', 'consum', 0.0210, 'lps'),
	(520636, 129, '2014-02-01 00:26:16.000000', 'consum', 0.0228, 'lps'),
	(520637, 129, '2014-02-01 00:26:17.000000', 'consum', 0.0210, 'lps'),
	(520638, 129, '2014-02-01 00:26:18.000000', 'consum', 0.0224, 'lps'),
	(520639, 129, '2014-02-01 00:26:19.000000', 'consum', 0.0214, 'lps'),
	(520640, 129, '2014-02-01 00:26:20.000000', 'consum', 0.0231, 'lps'),
	(520641, 129, '2014-02-01 00:26:21.000000', 'consum', 0.0218, 'lps'),
	(520642, 129, '2014-02-01 00:26:22.000000', 'consum', 0.0229, 'lps'),
	(520643, 129, '2014-02-01 00:26:23.000000', 'consum', 0.0216, 'lps'),
	(520644, 129, '2014-02-01 00:26:24.000000', 'consum', 0.0228, 'lps'),
	(520645, 129, '2014-02-01 00:26:25.000000', 'consum', 0.0218, 'lps'),
	(520646, 129, '2014-02-01 00:26:26.000000', 'consum', 0.0217, 'lps'),
	(520647, 129, '2014-02-01 00:26:27.000000', 'consum', 0.0220, 'lps'),
	(520648, 129, '2014-02-01 00:26:28.000000', 'consum', 0.0220, 'lps'),
	(520649, 129, '2014-02-01 00:26:29.000000', 'consum', 0.0229, 'lps'),
	(520650, 129, '2014-02-01 00:26:30.000000', 'consum', 0.0231, 'lps'),
	(520651, 129, '2014-02-01 00:26:31.000000', 'consum', 0.0214, 'lps'),
	(520652, 129, '2014-02-01 00:26:32.000000', 'consum', 0.0211, 'lps'),
	(520653, 129, '2014-02-01 00:26:33.000000', 'consum', 0.0228, 'lps'),
	(520654, 129, '2014-02-01 00:26:34.000000', 'consum', 0.0230, 'lps'),
	(520655, 129, '2014-02-01 00:26:35.000000', 'consum', 0.0214, 'lps'),
	(520656, 129, '2014-02-01 00:26:36.000000', 'consum', 0.0212, 'lps'),
	(520657, 129, '2014-02-01 00:26:37.000000', 'consum', 0.0210, 'lps'),
	(520658, 129, '2014-02-01 00:26:38.000000', 'consum', 0.0226, 'lps'),
	(520659, 129, '2014-02-01 00:26:39.000000', 'consum', 0.0223, 'lps'),
	(520660, 129, '2014-02-01 00:26:40.000000', 'consum', 0.0228, 'lps'),
	(520661, 129, '2014-02-01 00:26:41.000000', 'consum', 0.0220, 'lps'),
	(520662, 129, '2014-02-01 00:26:42.000000', 'consum', 0.0227, 'lps'),
	(520663, 129, '2014-02-01 00:26:43.000000', 'consum', 0.0221, 'lps'),
	(520664, 129, '2014-02-01 00:26:44.000000', 'consum', 0.0213, 'lps'),
	(520665, 129, '2014-02-01 00:26:45.000000', 'consum', 0.0218, 'lps'),
	(520666, 129, '2014-02-01 00:26:46.000000', 'consum', 0.0217, 'lps'),
	(520667, 129, '2014-02-01 00:26:47.000000', 'consum', 0.0221, 'lps'),
	(520668, 129, '2014-02-01 00:26:48.000000', 'consum', 0.0222, 'lps'),
	(520669, 129, '2014-02-01 00:26:49.000000', 'consum', 0.0218, 'lps'),
	(520670, 129, '2014-02-01 00:26:50.000000', 'consum', 0.0214, 'lps'),
	(520671, 129, '2014-02-01 00:26:51.000000', 'consum', 0.0227, 'lps'),
	(520672, 129, '2014-02-01 00:26:52.000000', 'consum', 0.0220, 'lps'),
	(520673, 129, '2014-02-01 00:26:53.000000', 'consum', 0.0229, 'lps'),
	(520674, 129, '2014-02-01 00:26:54.000000', 'consum', 0.0211, 'lps'),
	(520675, 129, '2014-02-01 00:26:55.000000', 'consum', 0.0225, 'lps'),
	(520676, 129, '2014-02-01 00:26:56.000000', 'consum', 0.0215, 'lps'),
	(520677, 129, '2014-02-01 00:26:57.000000', 'consum', 0.0214, 'lps'),
	(520678, 129, '2014-02-01 00:26:58.000000', 'consum', 0.0213, 'lps'),
	(520679, 129, '2014-02-01 00:26:59.000000', 'consum', 0.0214, 'lps'),
	(520680, 129, '2014-02-01 00:27:00.000000', 'consum', 0.0224, 'lps'),
	(520681, 129, '2014-02-01 00:27:01.000000', 'consum', 0.0222, 'lps'),
	(520682, 129, '2014-02-01 00:27:02.000000', 'consum', 0.0229, 'lps'),
	(520683, 129, '2014-02-01 00:27:03.000000', 'consum', 0.0228, 'lps'),
	(520684, 129, '2014-02-01 00:27:04.000000', 'consum', 0.0219, 'lps'),
	(520685, 129, '2014-02-01 00:27:05.000000', 'consum', 0.0224, 'lps'),
	(520686, 129, '2014-02-01 00:27:06.000000', 'consum', 0.0231, 'lps'),
	(520687, 129, '2014-02-01 00:27:07.000000', 'consum', 0.0228, 'lps'),
	(520688, 129, '2014-02-01 00:27:08.000000', 'consum', 0.0217, 'lps'),
	(520689, 129, '2014-02-01 00:27:09.000000', 'consum', 0.0214, 'lps'),
	(520690, 129, '2014-02-01 00:27:10.000000', 'consum', 0.0229, 'lps'),
	(520691, 129, '2014-02-01 00:27:11.000000', 'consum', 0.0230, 'lps'),
	(520692, 129, '2014-02-01 00:27:12.000000', 'consum', 0.0210, 'lps'),
	(520693, 129, '2014-02-01 00:27:13.000000', 'consum', 0.0217, 'lps'),
	(520694, 129, '2014-02-01 00:27:14.000000', 'consum', 0.0225, 'lps'),
	(520695, 129, '2014-02-01 00:27:15.000000', 'consum', 0.0217, 'lps'),
	(520696, 129, '2014-02-01 00:27:16.000000', 'consum', 0.0224, 'lps'),
	(520697, 129, '2014-02-01 00:27:17.000000', 'consum', 0.0214, 'lps'),
	(520698, 129, '2014-02-01 00:27:18.000000', 'consum', 0.0212, 'lps'),
	(520699, 129, '2014-02-01 00:27:19.000000', 'consum', 0.0231, 'lps'),
	(520700, 129, '2014-02-01 00:27:20.000000', 'consum', 0.0219, 'lps'),
	(520701, 129, '2014-02-01 00:27:21.000000', 'consum', 0.0215, 'lps'),
	(520702, 129, '2014-02-01 00:27:22.000000', 'consum', 0.0210, 'lps'),
	(520703, 129, '2014-02-01 00:27:23.000000', 'consum', 0.0217, 'lps'),
	(520704, 129, '2014-02-01 00:27:24.000000', 'consum', 0.0224, 'lps'),
	(520705, 129, '2014-02-01 00:27:25.000000', 'consum', 0.0217, 'lps'),
	(520706, 129, '2014-02-01 00:27:26.000000', 'consum', 0.0223, 'lps'),
	(520707, 129, '2014-02-01 00:27:27.000000', 'consum', 0.0231, 'lps'),
	(520708, 129, '2014-02-01 00:27:28.000000', 'consum', 0.0214, 'lps'),
	(520709, 129, '2014-02-01 00:27:29.000000', 'consum', 0.0211, 'lps'),
	(520710, 129, '2014-02-01 00:27:30.000000', 'consum', 0.0225, 'lps'),
	(520711, 129, '2014-02-01 00:27:31.000000', 'consum', 0.0217, 'lps'),
	(520712, 129, '2014-02-01 00:27:32.000000', 'consum', 0.0224, 'lps'),
	(520713, 129, '2014-02-01 00:27:33.000000', 'consum', 0.0214, 'lps'),
	(520714, 129, '2014-02-01 00:27:34.000000', 'consum', 0.0210, 'lps'),
	(520715, 129, '2014-02-01 00:27:35.000000', 'consum', 0.0222, 'lps'),
	(520716, 129, '2014-02-01 00:27:36.000000', 'consum', 0.0226, 'lps'),
	(520717, 129, '2014-02-01 00:27:37.000000', 'consum', 0.0212, 'lps'),
	(520718, 129, '2014-02-01 00:27:38.000000', 'consum', 0.0213, 'lps'),
	(520719, 129, '2014-02-01 00:27:39.000000', 'consum', 0.0222, 'lps'),
	(520720, 129, '2014-02-01 00:27:40.000000', 'consum', 0.0218, 'lps'),
	(520721, 129, '2014-02-01 00:27:41.000000', 'consum', 0.0212, 'lps'),
	(520722, 129, '2014-02-01 00:27:42.000000', 'consum', 0.0222, 'lps'),
	(520723, 129, '2014-02-01 00:27:43.000000', 'consum', 0.0218, 'lps'),
	(520724, 129, '2014-02-01 00:27:44.000000', 'consum', 0.0214, 'lps'),
	(520725, 129, '2014-02-01 00:27:45.000000', 'consum', 0.0228, 'lps'),
	(520726, 129, '2014-02-01 00:27:46.000000', 'consum', 0.0222, 'lps'),
	(520727, 129, '2014-02-01 00:27:47.000000', 'consum', 0.0217, 'lps'),
	(520728, 129, '2014-02-01 00:27:48.000000', 'consum', 0.0211, 'lps'),
	(520729, 129, '2014-02-01 00:27:49.000000', 'consum', 0.0215, 'lps'),
	(520730, 129, '2014-02-01 00:27:50.000000', 'consum', 0.0210, 'lps'),
	(520731, 129, '2014-02-01 00:27:51.000000', 'consum', 0.0220, 'lps'),
	(520732, 129, '2014-02-01 00:27:52.000000', 'consum', 0.0214, 'lps'),
	(520733, 129, '2014-02-01 00:27:53.000000', 'consum', 0.0222, 'lps'),
	(520734, 129, '2014-02-01 00:27:54.000000', 'consum', 0.0216, 'lps'),
	(520735, 129, '2014-02-01 00:27:55.000000', 'consum', 0.0226, 'lps'),
	(520736, 129, '2014-02-01 00:27:56.000000', 'consum', 0.0230, 'lps'),
	(520737, 129, '2014-02-01 00:27:57.000000', 'consum', 0.0218, 'lps'),
	(520738, 129, '2014-02-01 00:27:58.000000', 'consum', 0.0212, 'lps'),
	(520739, 129, '2014-02-01 00:27:59.000000', 'consum', 0.0220, 'lps'),
	(520740, 129, '2014-02-01 00:28:00.000000', 'consum', 0.0211, 'lps'),
	(520741, 129, '2014-02-01 00:28:01.000000', 'consum', 0.0229, 'lps'),
	(520742, 129, '2014-02-01 00:28:02.000000', 'consum', 0.0213, 'lps'),
	(520743, 129, '2014-02-01 00:28:03.000000', 'consum', 0.0211, 'lps'),
	(520744, 129, '2014-02-01 00:28:04.000000', 'consum', 0.0231, 'lps'),
	(520745, 129, '2014-02-01 00:28:05.000000', 'consum', 0.0226, 'lps'),
	(520746, 129, '2014-02-01 00:28:06.000000', 'consum', 0.0224, 'lps'),
	(520747, 129, '2014-02-01 00:28:07.000000', 'consum', 0.0213, 'lps'),
	(520748, 129, '2014-02-01 00:28:08.000000', 'consum', 0.0228, 'lps'),
	(520749, 129, '2014-02-01 00:28:09.000000', 'consum', 0.0223, 'lps'),
	(520750, 129, '2014-02-01 00:28:10.000000', 'consum', 0.0223, 'lps'),
	(520751, 129, '2014-02-01 00:28:11.000000', 'consum', 0.0216, 'lps'),
	(520752, 129, '2014-02-01 00:28:12.000000', 'consum', 0.0221, 'lps'),
	(520753, 129, '2014-02-01 00:28:13.000000', 'consum', 0.0227, 'lps'),
	(520754, 129, '2014-02-01 00:28:14.000000', 'consum', 0.0220, 'lps'),
	(520755, 129, '2014-02-01 00:28:15.000000', 'consum', 0.0230, 'lps'),
	(520756, 129, '2014-02-01 00:28:16.000000', 'consum', 0.0216, 'lps'),
	(520757, 129, '2014-02-01 00:28:17.000000', 'consum', 0.0225, 'lps'),
	(520758, 129, '2014-02-01 00:28:18.000000', 'consum', 0.0225, 'lps'),
	(520759, 129, '2014-02-01 00:28:19.000000', 'consum', 0.0215, 'lps'),
	(520760, 129, '2014-02-01 00:28:20.000000', 'consum', 0.0213, 'lps'),
	(520761, 129, '2014-02-01 00:28:21.000000', 'consum', 0.0212, 'lps'),
	(520762, 129, '2014-02-01 00:28:22.000000', 'consum', 0.0213, 'lps'),
	(520763, 129, '2014-02-01 00:28:23.000000', 'consum', 0.0218, 'lps'),
	(520764, 129, '2014-02-01 00:28:24.000000', 'consum', 0.0218, 'lps'),
	(520765, 129, '2014-02-01 00:28:25.000000', 'consum', 0.0226, 'lps'),
	(520766, 129, '2014-02-01 00:28:26.000000', 'consum', 0.0223, 'lps'),
	(520767, 129, '2014-02-01 00:28:27.000000', 'consum', 0.0228, 'lps'),
	(520768, 129, '2014-02-01 00:28:28.000000', 'consum', 0.0217, 'lps'),
	(520769, 129, '2014-02-01 00:28:29.000000', 'consum', 0.0213, 'lps'),
	(520770, 129, '2014-02-01 00:28:30.000000', 'consum', 0.0229, 'lps'),
	(520771, 129, '2014-02-01 00:28:31.000000', 'consum', 0.0228, 'lps'),
	(520772, 129, '2014-02-01 00:28:32.000000', 'consum', 0.0220, 'lps'),
	(520773, 129, '2014-02-01 00:28:33.000000', 'consum', 0.0231, 'lps'),
	(520774, 129, '2014-02-01 00:28:34.000000', 'consum', 0.0219, 'lps'),
	(520775, 129, '2014-02-01 00:28:35.000000', 'consum', 0.0214, 'lps'),
	(520776, 129, '2014-02-01 00:28:36.000000', 'consum', 0.0225, 'lps'),
	(520777, 129, '2014-02-01 00:28:37.000000', 'consum', 0.0210, 'lps'),
	(520778, 129, '2014-02-01 00:28:38.000000', 'consum', 0.0230, 'lps'),
	(520779, 129, '2014-02-01 00:28:39.000000', 'consum', 0.0221, 'lps'),
	(520780, 129, '2014-02-01 00:28:40.000000', 'consum', 0.0230, 'lps'),
	(520781, 129, '2014-02-01 00:28:41.000000', 'consum', 0.0210, 'lps'),
	(520782, 129, '2014-02-01 00:28:42.000000', 'consum', 0.0217, 'lps'),
	(520783, 129, '2014-02-01 00:28:43.000000', 'consum', 0.0223, 'lps'),
	(520784, 129, '2014-02-01 00:28:44.000000', 'consum', 0.0231, 'lps'),
	(520785, 129, '2014-02-01 00:28:45.000000', 'consum', 0.0212, 'lps'),
	(520786, 129, '2014-02-01 00:28:46.000000', 'consum', 0.0225, 'lps'),
	(520787, 129, '2014-02-01 00:28:47.000000', 'consum', 0.0211, 'lps'),
	(520788, 129, '2014-02-01 00:28:48.000000', 'consum', 0.0217, 'lps'),
	(520789, 129, '2014-02-01 00:28:49.000000', 'consum', 0.0220, 'lps'),
	(520790, 129, '2014-02-01 00:28:50.000000', 'consum', 0.0218, 'lps'),
	(520791, 129, '2014-02-01 00:28:51.000000', 'consum', 0.0219, 'lps'),
	(520792, 129, '2014-02-01 00:28:52.000000', 'consum', 0.0231, 'lps'),
	(520793, 129, '2014-02-01 00:28:53.000000', 'consum', 0.0222, 'lps'),
	(520794, 129, '2014-02-01 00:28:54.000000', 'consum', 0.0228, 'lps'),
	(520795, 129, '2014-02-01 00:28:55.000000', 'consum', 0.0224, 'lps'),
	(520796, 129, '2014-02-01 00:28:56.000000', 'consum', 0.0223, 'lps'),
	(520797, 129, '2014-02-01 00:28:57.000000', 'consum', 0.0214, 'lps'),
	(520798, 129, '2014-02-01 00:28:58.000000', 'consum', 0.0214, 'lps'),
	(520799, 129, '2014-02-01 00:28:59.000000', 'consum', 0.0216, 'lps'),
	(520800, 129, '2014-02-01 00:29:00.000000', 'consum', 0.0230, 'lps'),
	(520801, 129, '2014-02-01 00:29:01.000000', 'consum', 0.0226, 'lps'),
	(520802, 129, '2014-02-01 00:29:02.000000', 'consum', 0.0211, 'lps'),
	(520803, 129, '2014-02-01 00:29:03.000000', 'consum', 0.0230, 'lps'),
	(520804, 129, '2014-02-01 00:29:04.000000', 'consum', 0.0223, 'lps'),
	(520805, 129, '2014-02-01 00:29:05.000000', 'consum', 0.0213, 'lps'),
	(520806, 129, '2014-02-01 00:29:06.000000', 'consum', 0.0211, 'lps'),
	(520807, 129, '2014-02-01 00:29:07.000000', 'consum', 0.0228, 'lps'),
	(520808, 129, '2014-02-01 00:29:08.000000', 'consum', 0.0231, 'lps'),
	(520809, 129, '2014-02-01 00:29:09.000000', 'consum', 0.0219, 'lps'),
	(520810, 129, '2014-02-01 00:29:10.000000', 'consum', 0.0213, 'lps'),
	(520811, 129, '2014-02-01 00:29:11.000000', 'consum', 0.0220, 'lps'),
	(520812, 129, '2014-02-01 00:29:12.000000', 'consum', 0.0230, 'lps'),
	(520813, 129, '2014-02-01 00:29:13.000000', 'consum', 0.0213, 'lps'),
	(520814, 129, '2014-02-01 00:29:14.000000', 'consum', 0.0212, 'lps'),
	(520815, 129, '2014-02-01 00:29:15.000000', 'consum', 0.0212, 'lps'),
	(520816, 129, '2014-02-01 00:29:16.000000', 'consum', 0.0213, 'lps'),
	(520817, 129, '2014-02-01 00:29:17.000000', 'consum', 0.0220, 'lps'),
	(520818, 129, '2014-02-01 00:29:18.000000', 'consum', 0.0228, 'lps'),
	(520819, 129, '2014-02-01 00:29:19.000000', 'consum', 0.0229, 'lps'),
	(520820, 129, '2014-02-01 00:29:20.000000', 'consum', 0.0228, 'lps'),
	(520821, 129, '2014-02-01 00:29:21.000000', 'consum', 0.0224, 'lps'),
	(520822, 129, '2014-02-01 00:29:22.000000', 'consum', 0.0223, 'lps'),
	(520823, 129, '2014-02-01 00:29:23.000000', 'consum', 0.0213, 'lps'),
	(520824, 129, '2014-02-01 00:29:24.000000', 'consum', 0.0231, 'lps'),
	(520825, 129, '2014-02-01 00:29:25.000000', 'consum', 0.0217, 'lps'),
	(520826, 129, '2014-02-01 00:29:26.000000', 'consum', 0.0229, 'lps'),
	(520827, 129, '2014-02-01 00:29:27.000000', 'consum', 0.0217, 'lps'),
	(520828, 129, '2014-02-01 00:29:28.000000', 'consum', 0.0210, 'lps'),
	(520829, 129, '2014-02-01 00:29:29.000000', 'consum', 0.0212, 'lps'),
	(520830, 129, '2014-02-01 00:29:30.000000', 'consum', 0.0220, 'lps'),
	(520831, 129, '2014-02-01 00:29:31.000000', 'consum', 0.0210, 'lps'),
	(520832, 129, '2014-02-01 00:29:32.000000', 'consum', 0.0223, 'lps'),
	(520833, 129, '2014-02-01 00:29:33.000000', 'consum', 0.0211, 'lps'),
	(520834, 129, '2014-02-01 00:29:34.000000', 'consum', 0.0221, 'lps'),
	(520835, 129, '2014-02-01 00:29:35.000000', 'consum', 0.0217, 'lps'),
	(520836, 129, '2014-02-01 00:29:36.000000', 'consum', 0.0214, 'lps'),
	(520837, 129, '2014-02-01 00:29:37.000000', 'consum', 0.0211, 'lps'),
	(520838, 129, '2014-02-01 00:29:38.000000', 'consum', 0.0224, 'lps'),
	(520839, 129, '2014-02-01 00:29:39.000000', 'consum', 0.0210, 'lps'),
	(520840, 129, '2014-02-01 00:29:40.000000', 'consum', 0.0213, 'lps'),
	(520841, 129, '2014-02-01 00:29:41.000000', 'consum', 0.0225, 'lps'),
	(520842, 129, '2014-02-01 00:29:42.000000', 'consum', 0.0231, 'lps'),
	(520843, 129, '2014-02-01 00:29:43.000000', 'consum', 0.0229, 'lps'),
	(520844, 129, '2014-02-01 00:29:44.000000', 'consum', 0.0222, 'lps'),
	(520845, 129, '2014-02-01 00:29:45.000000', 'consum', 0.0211, 'lps'),
	(520846, 129, '2014-02-01 00:29:46.000000', 'consum', 0.0222, 'lps'),
	(520847, 129, '2014-02-01 00:29:47.000000', 'consum', 0.0226, 'lps'),
	(520848, 129, '2014-02-01 00:29:48.000000', 'consum', 0.0210, 'lps'),
	(520849, 129, '2014-02-01 00:29:49.000000', 'consum', 0.0227, 'lps'),
	(520850, 129, '2014-02-01 00:29:50.000000', 'consum', 0.0210, 'lps'),
	(520851, 129, '2014-02-01 00:29:51.000000', 'consum', 0.0226, 'lps'),
	(520852, 129, '2014-02-01 00:29:52.000000', 'consum', 0.0223, 'lps'),
	(520853, 129, '2014-02-01 00:29:53.000000', 'consum', 0.0230, 'lps'),
	(520854, 129, '2014-02-01 00:29:54.000000', 'consum', 0.0225, 'lps'),
	(520855, 129, '2014-02-01 00:29:55.000000', 'consum', 0.0226, 'lps'),
	(520856, 129, '2014-02-01 00:29:56.000000', 'consum', 0.0223, 'lps'),
	(520857, 129, '2014-02-01 00:29:57.000000', 'consum', 0.0226, 'lps'),
	(520858, 129, '2014-02-01 00:29:58.000000', 'consum', 0.0230, 'lps'),
	(520859, 129, '2014-02-01 00:29:59.000000', 'consum', 0.0219, 'lps'),
	(520860, 129, '2014-02-01 00:30:00.000000', 'consum', 0.0217, 'lps'),
	(520861, 129, '2014-02-01 00:30:01.000000', 'consum', 0.0220, 'lps'),
	(520862, 129, '2014-02-01 00:30:02.000000', 'consum', 0.0218, 'lps'),
	(520863, 129, '2014-02-01 00:30:03.000000', 'consum', 0.0221, 'lps'),
	(520864, 129, '2014-02-01 00:30:04.000000', 'consum', 0.0221, 'lps'),
	(520865, 129, '2014-02-01 00:30:05.000000', 'consum', 0.0229, 'lps'),
	(520866, 129, '2014-02-01 00:30:06.000000', 'consum', 0.0231, 'lps'),
	(520867, 129, '2014-02-01 00:30:07.000000', 'consum', 0.0215, 'lps'),
	(520868, 129, '2014-02-01 00:30:08.000000', 'consum', 0.0217, 'lps'),
	(520869, 129, '2014-02-01 00:30:09.000000', 'consum', 0.0231, 'lps'),
	(520870, 129, '2014-02-01 00:30:10.000000', 'consum', 0.0228, 'lps'),
	(520871, 129, '2014-02-01 00:30:11.000000', 'consum', 0.0214, 'lps'),
	(520872, 129, '2014-02-01 00:30:12.000000', 'consum', 0.0220, 'lps'),
	(520873, 129, '2014-02-01 00:30:13.000000', 'consum', 0.0227, 'lps'),
	(520874, 129, '2014-02-01 00:30:14.000000', 'consum', 0.0222, 'lps'),
	(520875, 129, '2014-02-01 00:30:15.000000', 'consum', 0.0218, 'lps'),
	(520876, 129, '2014-02-01 00:30:16.000000', 'consum', 0.0215, 'lps'),
	(520877, 129, '2014-02-01 00:30:17.000000', 'consum', 0.0210, 'lps'),
	(520878, 129, '2014-02-01 00:30:18.000000', 'consum', 0.0218, 'lps'),
	(520879, 129, '2014-02-01 00:30:19.000000', 'consum', 0.0229, 'lps'),
	(520880, 129, '2014-02-01 00:30:20.000000', 'consum', 0.0216, 'lps'),
	(520881, 129, '2014-02-01 00:30:21.000000', 'consum', 0.0229, 'lps'),
	(520882, 129, '2014-02-01 00:30:22.000000', 'consum', 0.0221, 'lps'),
	(520883, 129, '2014-02-01 00:30:23.000000', 'consum', 0.0210, 'lps'),
	(520884, 129, '2014-02-01 00:30:24.000000', 'consum', 0.0220, 'lps'),
	(520885, 129, '2014-02-01 00:30:25.000000', 'consum', 0.0216, 'lps'),
	(520886, 129, '2014-02-01 00:30:26.000000', 'consum', 0.0211, 'lps'),
	(520887, 129, '2014-02-01 00:30:27.000000', 'consum', 0.0221, 'lps'),
	(520888, 129, '2014-02-01 00:30:28.000000', 'consum', 0.0218, 'lps'),
	(520889, 129, '2014-02-01 00:30:29.000000', 'consum', 0.0216, 'lps'),
	(520890, 129, '2014-02-01 00:30:30.000000', 'consum', 0.0219, 'lps'),
	(520891, 129, '2014-02-01 00:30:31.000000', 'consum', 0.0215, 'lps'),
	(520892, 129, '2014-02-01 00:30:32.000000', 'consum', 0.0228, 'lps'),
	(520893, 129, '2014-02-01 00:30:33.000000', 'consum', 0.0221, 'lps'),
	(520894, 129, '2014-02-01 00:30:34.000000', 'consum', 0.0213, 'lps'),
	(520895, 129, '2014-02-01 00:30:35.000000', 'consum', 0.0213, 'lps'),
	(520896, 129, '2014-02-01 00:30:36.000000', 'consum', 0.0216, 'lps'),
	(520897, 129, '2014-02-01 00:30:37.000000', 'consum', 0.0210, 'lps'),
	(520898, 129, '2014-02-01 00:30:38.000000', 'consum', 0.0215, 'lps'),
	(520899, 129, '2014-02-01 00:30:39.000000', 'consum', 0.0215, 'lps'),
	(520900, 129, '2014-02-01 00:30:40.000000', 'consum', 0.0218, 'lps'),
	(520901, 129, '2014-02-01 00:30:41.000000', 'consum', 0.0213, 'lps'),
	(520902, 129, '2014-02-01 00:30:42.000000', 'consum', 0.0226, 'lps'),
	(520903, 129, '2014-02-01 00:30:43.000000', 'consum', 0.0216, 'lps'),
	(520904, 129, '2014-02-01 00:30:44.000000', 'consum', 0.0212, 'lps'),
	(520905, 129, '2014-02-01 00:30:45.000000', 'consum', 0.0225, 'lps'),
	(520906, 129, '2014-02-01 00:30:46.000000', 'consum', 0.0212, 'lps'),
	(520907, 129, '2014-02-01 00:30:47.000000', 'consum', 0.0221, 'lps'),
	(520908, 129, '2014-02-01 00:30:48.000000', 'consum', 0.0215, 'lps'),
	(520909, 129, '2014-02-01 00:30:49.000000', 'consum', 0.0226, 'lps'),
	(520910, 129, '2014-02-01 00:30:50.000000', 'consum', 0.0231, 'lps'),
	(520911, 129, '2014-02-01 00:30:51.000000', 'consum', 0.0221, 'lps'),
	(520912, 129, '2014-02-01 00:30:52.000000', 'consum', 0.0227, 'lps'),
	(520913, 129, '2014-02-01 00:30:53.000000', 'consum', 0.0218, 'lps'),
	(520914, 129, '2014-02-01 00:30:54.000000', 'consum', 0.0221, 'lps'),
	(520915, 129, '2014-02-01 00:30:55.000000', 'consum', 0.0219, 'lps'),
	(520916, 129, '2014-02-01 00:30:56.000000', 'consum', 0.0225, 'lps'),
	(520917, 129, '2014-02-01 00:30:57.000000', 'consum', 0.0212, 'lps'),
	(520918, 129, '2014-02-01 00:30:58.000000', 'consum', 0.0218, 'lps'),
	(520919, 129, '2014-02-01 00:30:59.000000', 'consum', 0.0225, 'lps'),
	(520920, 129, '2014-02-01 00:31:00.000000', 'consum', 0.0216, 'lps'),
	(520921, 129, '2014-02-01 00:31:01.000000', 'consum', 0.0220, 'lps'),
	(520922, 129, '2014-02-01 00:31:02.000000', 'consum', 0.0218, 'lps'),
	(520923, 129, '2014-02-01 00:31:03.000000', 'consum', 0.0221, 'lps'),
	(520924, 129, '2014-02-01 00:31:04.000000', 'consum', 0.0218, 'lps'),
	(520925, 129, '2014-02-01 00:31:05.000000', 'consum', 0.0217, 'lps'),
	(520926, 129, '2014-02-01 00:31:06.000000', 'consum', 0.0222, 'lps'),
	(520927, 129, '2014-02-01 00:31:07.000000', 'consum', 0.0229, 'lps'),
	(520928, 129, '2014-02-01 00:31:08.000000', 'consum', 0.0226, 'lps'),
	(520929, 129, '2014-02-01 00:31:09.000000', 'consum', 0.0231, 'lps'),
	(520930, 129, '2014-02-01 00:31:10.000000', 'consum', 0.0225, 'lps'),
	(520931, 129, '2014-02-01 00:31:11.000000', 'consum', 0.0220, 'lps'),
	(520932, 129, '2014-02-01 00:31:12.000000', 'consum', 0.0218, 'lps'),
	(520933, 129, '2014-02-01 00:31:13.000000', 'consum', 0.0220, 'lps'),
	(520934, 129, '2014-02-01 00:31:14.000000', 'consum', 0.0215, 'lps'),
	(520935, 129, '2014-02-01 00:31:15.000000', 'consum', 0.0225, 'lps'),
	(520936, 129, '2014-02-01 00:31:16.000000', 'consum', 0.0228, 'lps'),
	(520937, 129, '2014-02-01 00:31:17.000000', 'consum', 0.0212, 'lps'),
	(520938, 129, '2014-02-01 00:31:18.000000', 'consum', 0.0211, 'lps'),
	(520939, 129, '2014-02-01 00:31:19.000000', 'consum', 0.0210, 'lps'),
	(520940, 129, '2014-02-01 00:31:20.000000', 'consum', 0.0227, 'lps'),
	(520941, 129, '2014-02-01 00:31:21.000000', 'consum', 0.0211, 'lps'),
	(520942, 129, '2014-02-01 00:31:22.000000', 'consum', 0.0227, 'lps'),
	(520943, 129, '2014-02-01 00:31:23.000000', 'consum', 0.0228, 'lps'),
	(520944, 129, '2014-02-01 00:31:24.000000', 'consum', 0.0229, 'lps'),
	(520945, 129, '2014-02-01 00:31:25.000000', 'consum', 0.0227, 'lps'),
	(520946, 129, '2014-02-01 00:31:26.000000', 'consum', 0.0216, 'lps'),
	(520947, 129, '2014-02-01 00:31:27.000000', 'consum', 0.0211, 'lps'),
	(520948, 129, '2014-02-01 00:31:28.000000', 'consum', 0.0221, 'lps'),
	(520949, 129, '2014-02-01 00:31:29.000000', 'consum', 0.0219, 'lps'),
	(520950, 129, '2014-02-01 00:31:30.000000', 'consum', 0.0221, 'lps'),
	(520951, 129, '2014-02-01 00:31:31.000000', 'consum', 0.0218, 'lps'),
	(520952, 129, '2014-02-01 00:31:32.000000', 'consum', 0.0215, 'lps'),
	(520953, 129, '2014-02-01 00:31:33.000000', 'consum', 0.0213, 'lps'),
	(520954, 129, '2014-02-01 00:31:34.000000', 'consum', 0.0210, 'lps'),
	(520955, 129, '2014-02-01 00:31:35.000000', 'consum', 0.0222, 'lps'),
	(520956, 129, '2014-02-01 00:31:36.000000', 'consum', 0.0229, 'lps'),
	(520957, 129, '2014-02-01 00:31:37.000000', 'consum', 0.0224, 'lps'),
	(520958, 129, '2014-02-01 00:31:38.000000', 'consum', 0.0225, 'lps'),
	(520959, 129, '2014-02-01 00:31:39.000000', 'consum', 0.0219, 'lps'),
	(520960, 129, '2014-02-01 00:31:40.000000', 'consum', 0.0213, 'lps'),
	(520961, 129, '2014-02-01 00:31:41.000000', 'consum', 0.0219, 'lps'),
	(520962, 129, '2014-02-01 00:31:42.000000', 'consum', 0.0224, 'lps'),
	(520963, 129, '2014-02-01 00:31:43.000000', 'consum', 0.0212, 'lps'),
	(520964, 129, '2014-02-01 00:31:44.000000', 'consum', 0.0222, 'lps'),
	(520965, 129, '2014-02-01 00:31:45.000000', 'consum', 0.0222, 'lps'),
	(520966, 129, '2014-02-01 00:31:46.000000', 'consum', 0.0210, 'lps'),
	(520967, 129, '2014-02-01 00:31:47.000000', 'consum', 0.0218, 'lps'),
	(520968, 129, '2014-02-01 00:31:48.000000', 'consum', 0.0227, 'lps'),
	(520969, 129, '2014-02-01 00:31:49.000000', 'consum', 0.0231, 'lps'),
	(520970, 129, '2014-02-01 00:31:50.000000', 'consum', 0.0220, 'lps'),
	(520971, 129, '2014-02-01 00:31:51.000000', 'consum', 0.0219, 'lps'),
	(520972, 129, '2014-02-01 00:31:52.000000', 'consum', 0.0225, 'lps'),
	(520973, 129, '2014-02-01 00:31:53.000000', 'consum', 0.0214, 'lps'),
	(520974, 129, '2014-02-01 00:31:54.000000', 'consum', 0.0231, 'lps'),
	(520975, 129, '2014-02-01 00:31:55.000000', 'consum', 0.0215, 'lps'),
	(520976, 129, '2014-02-01 00:31:56.000000', 'consum', 0.0218, 'lps'),
	(520977, 129, '2014-02-01 00:31:57.000000', 'consum', 0.0212, 'lps'),
	(520978, 129, '2014-02-01 00:31:58.000000', 'consum', 0.0218, 'lps'),
	(520979, 129, '2014-02-01 00:31:59.000000', 'consum', 0.0224, 'lps'),
	(520980, 129, '2014-02-01 00:32:00.000000', 'consum', 0.0212, 'lps'),
	(520981, 129, '2014-02-01 00:32:01.000000', 'consum', 0.0224, 'lps'),
	(520982, 129, '2014-02-01 00:32:02.000000', 'consum', 0.0228, 'lps'),
	(520983, 129, '2014-02-01 00:32:03.000000', 'consum', 0.0215, 'lps'),
	(520984, 129, '2014-02-01 00:32:04.000000', 'consum', 0.0227, 'lps'),
	(520985, 129, '2014-02-01 00:32:05.000000', 'consum', 0.0215, 'lps'),
	(520986, 129, '2014-02-01 00:32:06.000000', 'consum', 0.0228, 'lps'),
	(520987, 129, '2014-02-01 00:32:07.000000', 'consum', 0.0221, 'lps'),
	(520988, 129, '2014-02-01 00:32:08.000000', 'consum', 0.0211, 'lps'),
	(520989, 129, '2014-02-01 00:32:09.000000', 'consum', 0.0227, 'lps'),
	(520990, 129, '2014-02-01 00:32:10.000000', 'consum', 0.0224, 'lps'),
	(520991, 129, '2014-02-01 00:32:11.000000', 'consum', 0.0230, 'lps'),
	(520992, 129, '2014-02-01 00:32:12.000000', 'consum', 0.0224, 'lps'),
	(520993, 129, '2014-02-01 00:32:13.000000', 'consum', 0.0223, 'lps'),
	(520994, 129, '2014-02-01 00:32:14.000000', 'consum', 0.0210, 'lps'),
	(520995, 129, '2014-02-01 00:32:15.000000', 'consum', 0.0216, 'lps'),
	(520996, 129, '2014-02-01 00:32:16.000000', 'consum', 0.0220, 'lps'),
	(520997, 129, '2014-02-01 00:32:17.000000', 'consum', 0.0219, 'lps'),
	(520998, 129, '2014-02-01 00:32:18.000000', 'consum', 0.0227, 'lps'),
	(520999, 129, '2014-02-01 00:32:19.000000', 'consum', 0.0225, 'lps'),
	(521000, 129, '2014-02-01 00:32:20.000000', 'consum', 0.0213, 'lps'),
	(521001, 129, '2014-02-01 00:32:21.000000', 'consum', 0.0222, 'lps'),
	(521002, 129, '2014-02-01 00:32:22.000000', 'consum', 0.0218, 'lps'),
	(521003, 129, '2014-02-01 00:32:23.000000', 'consum', 0.0214, 'lps'),
	(521004, 129, '2014-02-01 00:32:24.000000', 'consum', 0.0229, 'lps'),
	(521005, 129, '2014-02-01 00:32:25.000000', 'consum', 0.0228, 'lps'),
	(521006, 129, '2014-02-01 00:32:26.000000', 'consum', 0.0221, 'lps'),
	(521007, 129, '2014-02-01 00:32:27.000000', 'consum', 0.0212, 'lps'),
	(521008, 129, '2014-02-01 00:32:28.000000', 'consum', 0.0230, 'lps'),
	(521009, 129, '2014-02-01 00:32:29.000000', 'consum', 0.0218, 'lps'),
	(521010, 129, '2014-02-01 00:32:30.000000', 'consum', 0.0214, 'lps'),
	(521011, 129, '2014-02-01 00:32:31.000000', 'consum', 0.0228, 'lps'),
	(521012, 129, '2014-02-01 00:32:32.000000', 'consum', 0.0220, 'lps'),
	(521013, 129, '2014-02-01 00:32:33.000000', 'consum', 0.0231, 'lps'),
	(521014, 129, '2014-02-01 00:32:34.000000', 'consum', 0.0220, 'lps'),
	(521015, 129, '2014-02-01 00:32:35.000000', 'consum', 0.0218, 'lps'),
	(521016, 129, '2014-02-01 00:32:36.000000', 'consum', 0.0221, 'lps'),
	(521017, 129, '2014-02-01 00:32:37.000000', 'consum', 0.0218, 'lps'),
	(521018, 129, '2014-02-01 00:32:38.000000', 'consum', 0.0218, 'lps'),
	(521019, 129, '2014-02-01 00:32:39.000000', 'consum', 0.0228, 'lps'),
	(521020, 129, '2014-02-01 00:32:40.000000', 'consum', 0.0230, 'lps'),
	(521021, 129, '2014-02-01 00:32:41.000000', 'consum', 0.0214, 'lps'),
	(521022, 129, '2014-02-01 00:32:42.000000', 'consum', 0.0213, 'lps'),
	(521023, 129, '2014-02-01 00:32:43.000000', 'consum', 0.0214, 'lps'),
	(521024, 129, '2014-02-01 00:32:44.000000', 'consum', 0.0223, 'lps'),
	(521025, 129, '2014-02-01 00:32:45.000000', 'consum', 0.0219, 'lps'),
	(521026, 129, '2014-02-01 00:32:46.000000', 'consum', 0.0218, 'lps'),
	(521027, 129, '2014-02-01 00:32:47.000000', 'consum', 0.0221, 'lps'),
	(521028, 129, '2014-02-01 00:32:48.000000', 'consum', 0.0222, 'lps'),
	(521029, 129, '2014-02-01 00:32:49.000000', 'consum', 0.0212, 'lps'),
	(521030, 129, '2014-02-01 00:32:50.000000', 'consum', 0.0210, 'lps'),
	(521031, 129, '2014-02-01 00:32:51.000000', 'consum', 0.0225, 'lps'),
	(521032, 129, '2014-02-01 00:32:52.000000', 'consum', 0.0221, 'lps'),
	(521033, 129, '2014-02-01 00:32:53.000000', 'consum', 0.0218, 'lps'),
	(521034, 129, '2014-02-01 00:32:54.000000', 'consum', 0.0220, 'lps'),
	(521035, 129, '2014-02-01 00:32:55.000000', 'consum', 0.0215, 'lps'),
	(521036, 129, '2014-02-01 00:32:56.000000', 'consum', 0.0224, 'lps'),
	(521037, 129, '2014-02-01 00:32:57.000000', 'consum', 0.0225, 'lps'),
	(521038, 129, '2014-02-01 00:32:58.000000', 'consum', 0.0219, 'lps'),
	(521039, 129, '2014-02-01 00:32:59.000000', 'consum', 0.0211, 'lps'),
	(521040, 129, '2014-02-01 00:33:00.000000', 'consum', 0.0211, 'lps'),
	(521041, 129, '2014-02-01 00:33:01.000000', 'consum', 0.0214, 'lps'),
	(521042, 129, '2014-02-01 00:33:02.000000', 'consum', 0.0228, 'lps'),
	(521043, 129, '2014-02-01 00:33:03.000000', 'consum', 0.0219, 'lps'),
	(521044, 129, '2014-02-01 00:33:04.000000', 'consum', 0.0227, 'lps'),
	(521045, 129, '2014-02-01 00:33:05.000000', 'consum', 0.0224, 'lps'),
	(521046, 129, '2014-02-01 00:33:06.000000', 'consum', 0.0230, 'lps'),
	(521047, 129, '2014-02-01 00:33:07.000000', 'consum', 0.0225, 'lps'),
	(521048, 129, '2014-02-01 00:33:08.000000', 'consum', 0.0226, 'lps'),
	(521049, 129, '2014-02-01 00:33:09.000000', 'consum', 0.0223, 'lps'),
	(521050, 129, '2014-02-01 00:33:10.000000', 'consum', 0.0227, 'lps'),
	(521051, 129, '2014-02-01 00:33:11.000000', 'consum', 0.0214, 'lps'),
	(521052, 129, '2014-02-01 00:33:12.000000', 'consum', 0.0222, 'lps'),
	(521053, 129, '2014-02-01 00:33:13.000000', 'consum', 0.0215, 'lps'),
	(521054, 129, '2014-02-01 00:33:14.000000', 'consum', 0.0223, 'lps'),
	(521055, 129, '2014-02-01 00:33:15.000000', 'consum', 0.0216, 'lps'),
	(521056, 129, '2014-02-01 00:33:16.000000', 'consum', 0.0221, 'lps'),
	(521057, 129, '2014-02-01 00:33:17.000000', 'consum', 0.0227, 'lps'),
	(521058, 129, '2014-02-01 00:33:18.000000', 'consum', 0.0218, 'lps'),
	(521059, 129, '2014-02-01 00:33:19.000000', 'consum', 0.0220, 'lps'),
	(521060, 129, '2014-02-01 00:33:20.000000', 'consum', 0.0218, 'lps'),
	(521061, 129, '2014-02-01 00:33:21.000000', 'consum', 0.0217, 'lps'),
	(521062, 129, '2014-02-01 00:33:22.000000', 'consum', 0.0223, 'lps'),
	(521063, 129, '2014-02-01 00:33:23.000000', 'consum', 0.0211, 'lps'),
	(521064, 129, '2014-02-01 00:33:24.000000', 'consum', 0.0219, 'lps'),
	(521065, 129, '2014-02-01 00:33:25.000000', 'consum', 0.0230, 'lps'),
	(521066, 129, '2014-02-01 00:33:26.000000', 'consum', 0.0217, 'lps'),
	(521067, 129, '2014-02-01 00:33:27.000000', 'consum', 0.0210, 'lps'),
	(521068, 129, '2014-02-01 00:33:28.000000', 'consum', 0.0231, 'lps'),
	(521069, 129, '2014-02-01 00:33:29.000000', 'consum', 0.0228, 'lps'),
	(521070, 129, '2014-02-01 00:33:30.000000', 'consum', 0.0214, 'lps'),
	(521071, 129, '2014-02-01 00:33:31.000000', 'consum', 0.0223, 'lps'),
	(521072, 129, '2014-02-01 00:33:32.000000', 'consum', 0.0218, 'lps'),
	(521073, 129, '2014-02-01 00:33:33.000000', 'consum', 0.0210, 'lps'),
	(521074, 129, '2014-02-01 00:33:34.000000', 'consum', 0.0231, 'lps'),
	(521075, 129, '2014-02-01 00:33:35.000000', 'consum', 0.0228, 'lps'),
	(521076, 129, '2014-02-01 00:33:36.000000', 'consum', 0.0217, 'lps'),
	(521077, 129, '2014-02-01 00:33:37.000000', 'consum', 0.0212, 'lps'),
	(521078, 129, '2014-02-01 00:33:38.000000', 'consum', 0.0220, 'lps'),
	(521079, 129, '2014-02-01 00:33:39.000000', 'consum', 0.0213, 'lps'),
	(521080, 129, '2014-02-01 00:33:40.000000', 'consum', 0.0217, 'lps'),
	(521081, 129, '2014-02-01 00:33:41.000000', 'consum', 0.0213, 'lps'),
	(521082, 129, '2014-02-01 00:33:42.000000', 'consum', 0.0227, 'lps'),
	(521083, 129, '2014-02-01 00:33:43.000000', 'consum', 0.0222, 'lps'),
	(521084, 129, '2014-02-01 00:33:44.000000', 'consum', 0.0218, 'lps'),
	(521085, 129, '2014-02-01 00:33:45.000000', 'consum', 0.0216, 'lps'),
	(521086, 129, '2014-02-01 00:33:46.000000', 'consum', 0.0214, 'lps'),
	(521087, 129, '2014-02-01 00:33:47.000000', 'consum', 0.0213, 'lps'),
	(521088, 129, '2014-02-01 00:33:48.000000', 'consum', 0.0214, 'lps'),
	(521089, 129, '2014-02-01 00:33:49.000000', 'consum', 0.0221, 'lps'),
	(521090, 129, '2014-02-01 00:33:50.000000', 'consum', 0.0231, 'lps'),
	(521091, 129, '2014-02-01 00:33:51.000000', 'consum', 0.0216, 'lps'),
	(521092, 129, '2014-02-01 00:33:52.000000', 'consum', 0.0223, 'lps'),
	(521093, 129, '2014-02-01 00:33:53.000000', 'consum', 0.0211, 'lps'),
	(521094, 129, '2014-02-01 00:33:54.000000', 'consum', 0.0224, 'lps'),
	(521095, 129, '2014-02-01 00:33:55.000000', 'consum', 0.0231, 'lps'),
	(521096, 129, '2014-02-01 00:33:56.000000', 'consum', 0.0229, 'lps'),
	(521097, 129, '2014-02-01 00:33:57.000000', 'consum', 0.0221, 'lps'),
	(521098, 129, '2014-02-01 00:33:58.000000', 'consum', 0.0231, 'lps'),
	(521099, 129, '2014-02-01 00:33:59.000000', 'consum', 0.0216, 'lps'),
	(521100, 129, '2014-02-01 00:34:00.000000', 'consum', 0.0223, 'lps'),
	(521101, 129, '2014-02-01 00:34:01.000000', 'consum', 0.0211, 'lps'),
	(521102, 129, '2014-02-01 00:34:02.000000', 'consum', 0.0223, 'lps'),
	(521103, 129, '2014-02-01 00:34:03.000000', 'consum', 0.0228, 'lps'),
	(521104, 129, '2014-02-01 00:34:04.000000', 'consum', 0.0218, 'lps'),
	(521105, 129, '2014-02-01 00:34:05.000000', 'consum', 0.0217, 'lps'),
	(521106, 129, '2014-02-01 00:34:06.000000', 'consum', 0.0220, 'lps'),
	(521107, 129, '2014-02-01 00:34:07.000000', 'consum', 0.0220, 'lps'),
	(521108, 129, '2014-02-01 00:34:08.000000', 'consum', 0.0210, 'lps'),
	(521109, 129, '2014-02-01 00:34:09.000000', 'consum', 0.0223, 'lps'),
	(521110, 129, '2014-02-01 00:34:10.000000', 'consum', 0.0230, 'lps'),
	(521111, 129, '2014-02-01 00:34:11.000000', 'consum', 0.0230, 'lps'),
	(521112, 129, '2014-02-01 00:34:12.000000', 'consum', 0.0227, 'lps'),
	(521113, 129, '2014-02-01 00:34:13.000000', 'consum', 0.0214, 'lps'),
	(521114, 129, '2014-02-01 00:34:14.000000', 'consum', 0.0222, 'lps'),
	(521115, 129, '2014-02-01 00:34:15.000000', 'consum', 0.0215, 'lps'),
	(521116, 129, '2014-02-01 00:34:16.000000', 'consum', 0.0223, 'lps'),
	(521117, 129, '2014-02-01 00:34:17.000000', 'consum', 0.0216, 'lps'),
	(521118, 129, '2014-02-01 00:34:18.000000', 'consum', 0.0225, 'lps'),
	(521119, 129, '2014-02-01 00:34:19.000000', 'consum', 0.0222, 'lps'),
	(521120, 129, '2014-02-01 00:34:20.000000', 'consum', 0.0225, 'lps'),
	(521121, 129, '2014-02-01 00:34:21.000000', 'consum', 0.0229, 'lps'),
	(521122, 129, '2014-02-01 00:34:22.000000', 'consum', 0.0215, 'lps'),
	(521123, 129, '2014-02-01 00:34:23.000000', 'consum', 0.0221, 'lps'),
	(521124, 129, '2014-02-01 00:34:24.000000', 'consum', 0.0231, 'lps'),
	(521125, 129, '2014-02-01 00:34:25.000000', 'consum', 0.0215, 'lps'),
	(521126, 129, '2014-02-01 00:34:26.000000', 'consum', 0.0219, 'lps'),
	(521127, 129, '2014-02-01 00:34:27.000000', 'consum', 0.0216, 'lps'),
	(521128, 129, '2014-02-01 00:34:28.000000', 'consum', 0.0214, 'lps'),
	(521129, 129, '2014-02-01 00:34:29.000000', 'consum', 0.0215, 'lps'),
	(521130, 129, '2014-02-01 00:34:30.000000', 'consum', 0.0220, 'lps'),
	(521131, 129, '2014-02-01 00:34:31.000000', 'consum', 0.0224, 'lps'),
	(521132, 129, '2014-02-01 00:34:32.000000', 'consum', 0.0228, 'lps'),
	(521133, 129, '2014-02-01 00:34:33.000000', 'consum', 0.0216, 'lps'),
	(521134, 129, '2014-02-01 00:34:34.000000', 'consum', 0.0228, 'lps'),
	(521135, 129, '2014-02-01 00:34:35.000000', 'consum', 0.0219, 'lps'),
	(521136, 129, '2014-02-01 00:34:36.000000', 'consum', 0.0222, 'lps'),
	(521137, 129, '2014-02-01 00:34:37.000000', 'consum', 0.0224, 'lps'),
	(521138, 129, '2014-02-01 00:34:38.000000', 'consum', 0.0220, 'lps'),
	(521139, 129, '2014-02-01 00:34:39.000000', 'consum', 0.0218, 'lps'),
	(521140, 129, '2014-02-01 00:34:40.000000', 'consum', 0.0221, 'lps'),
	(521141, 129, '2014-02-01 00:34:41.000000', 'consum', 0.0220, 'lps'),
	(521142, 129, '2014-02-01 00:34:42.000000', 'consum', 0.0228, 'lps'),
	(521143, 129, '2014-02-01 00:34:43.000000', 'consum', 0.0227, 'lps'),
	(521144, 129, '2014-02-01 00:34:44.000000', 'consum', 0.0218, 'lps'),
	(521145, 129, '2014-02-01 00:34:45.000000', 'consum', 0.0223, 'lps'),
	(521146, 129, '2014-02-01 00:34:46.000000', 'consum', 0.0231, 'lps'),
	(521147, 129, '2014-02-01 00:34:47.000000', 'consum', 0.0229, 'lps'),
	(521148, 129, '2014-02-01 00:34:48.000000', 'consum', 0.0223, 'lps'),
	(521149, 129, '2014-02-01 00:34:49.000000', 'consum', 0.0217, 'lps'),
	(521150, 129, '2014-02-01 00:34:50.000000', 'consum', 0.0228, 'lps'),
	(521151, 129, '2014-02-01 00:34:51.000000', 'consum', 0.0215, 'lps'),
	(521152, 129, '2014-02-01 00:34:52.000000', 'consum', 0.0223, 'lps'),
	(521153, 129, '2014-02-01 00:34:53.000000', 'consum', 0.0219, 'lps'),
	(521154, 129, '2014-02-01 00:34:54.000000', 'consum', 0.0217, 'lps'),
	(521155, 129, '2014-02-01 00:34:55.000000', 'consum', 0.0220, 'lps'),
	(521156, 129, '2014-02-01 00:34:56.000000', 'consum', 0.0215, 'lps'),
	(521157, 129, '2014-02-01 00:34:57.000000', 'consum', 0.0226, 'lps'),
	(521158, 129, '2014-02-01 00:34:58.000000', 'consum', 0.0212, 'lps'),
	(521159, 129, '2014-02-01 00:34:59.000000', 'consum', 0.0216, 'lps'),
	(521160, 129, '2014-02-01 00:35:00.000000', 'consum', 0.0212, 'lps'),
	(521161, 129, '2014-02-01 00:35:01.000000', 'consum', 0.0224, 'lps'),
	(521162, 129, '2014-02-01 00:35:02.000000', 'consum', 0.0230, 'lps'),
	(521163, 129, '2014-02-01 00:35:03.000000', 'consum', 0.0227, 'lps'),
	(521164, 129, '2014-02-01 00:35:04.000000', 'consum', 0.0211, 'lps'),
	(521165, 129, '2014-02-01 00:35:05.000000', 'consum', 0.0210, 'lps'),
	(521166, 129, '2014-02-01 00:35:06.000000', 'consum', 0.0229, 'lps'),
	(521167, 129, '2014-02-01 00:35:07.000000', 'consum', 0.0219, 'lps'),
	(521168, 129, '2014-02-01 00:35:08.000000', 'consum', 0.0218, 'lps'),
	(521169, 129, '2014-02-01 00:35:09.000000', 'consum', 0.0225, 'lps'),
	(521170, 129, '2014-02-01 00:35:10.000000', 'consum', 0.0217, 'lps'),
	(521171, 129, '2014-02-01 00:35:11.000000', 'consum', 0.0223, 'lps'),
	(521172, 129, '2014-02-01 00:35:12.000000', 'consum', 0.0230, 'lps'),
	(521173, 129, '2014-02-01 00:35:13.000000', 'consum', 0.0231, 'lps'),
	(521174, 129, '2014-02-01 00:35:14.000000', 'consum', 0.0211, 'lps'),
	(521175, 129, '2014-02-01 00:35:15.000000', 'consum', 0.0217, 'lps'),
	(521176, 129, '2014-02-01 00:35:16.000000', 'consum', 0.0220, 'lps'),
	(521177, 129, '2014-02-01 00:35:17.000000', 'consum', 0.0218, 'lps'),
	(521178, 129, '2014-02-01 00:35:18.000000', 'consum', 0.0221, 'lps'),
	(521179, 129, '2014-02-01 00:35:19.000000', 'consum', 0.0218, 'lps'),
	(521180, 129, '2014-02-01 00:35:20.000000', 'consum', 0.0220, 'lps'),
	(521181, 129, '2014-02-01 00:35:21.000000', 'consum', 0.0213, 'lps'),
	(521182, 129, '2014-02-01 00:35:22.000000', 'consum', 0.0216, 'lps'),
	(521183, 129, '2014-02-01 00:35:23.000000', 'consum', 0.0212, 'lps'),
	(521184, 129, '2014-02-01 00:35:24.000000', 'consum', 0.0225, 'lps'),
	(521185, 129, '2014-02-01 00:35:25.000000', 'consum', 0.0214, 'lps'),
	(521186, 129, '2014-02-01 00:35:26.000000', 'consum', 0.0230, 'lps'),
	(521187, 129, '2014-02-01 00:35:27.000000', 'consum', 0.0210, 'lps'),
	(521188, 129, '2014-02-01 00:35:28.000000', 'consum', 0.0216, 'lps'),
	(521189, 129, '2014-02-01 00:35:29.000000', 'consum', 0.0219, 'lps'),
	(521190, 129, '2014-02-01 00:35:30.000000', 'consum', 0.0215, 'lps'),
	(521191, 129, '2014-02-01 00:35:31.000000', 'consum', 0.0210, 'lps'),
	(521192, 129, '2014-02-01 00:35:32.000000', 'consum', 0.0217, 'lps'),
	(521193, 129, '2014-02-01 00:35:33.000000', 'consum', 0.0224, 'lps'),
	(521194, 129, '2014-02-01 00:35:34.000000', 'consum', 0.0214, 'lps'),
	(521195, 129, '2014-02-01 00:35:35.000000', 'consum', 0.0231, 'lps'),
	(521196, 129, '2014-02-01 00:35:36.000000', 'consum', 0.0218, 'lps'),
	(521197, 129, '2014-02-01 00:35:37.000000', 'consum', 0.0231, 'lps'),
	(521198, 129, '2014-02-01 00:35:38.000000', 'consum', 0.0224, 'lps'),
	(521199, 129, '2014-02-01 00:35:39.000000', 'consum', 0.0219, 'lps'),
	(521200, 129, '2014-02-01 00:35:40.000000', 'consum', 0.0213, 'lps'),
	(521201, 129, '2014-02-01 00:35:41.000000', 'consum', 0.0219, 'lps'),
	(521202, 129, '2014-02-01 00:35:42.000000', 'consum', 0.0223, 'lps'),
	(521203, 129, '2014-02-01 00:35:43.000000', 'consum', 0.0230, 'lps'),
	(521204, 129, '2014-02-01 00:35:44.000000', 'consum', 0.0228, 'lps'),
	(521205, 129, '2014-02-01 00:35:45.000000', 'consum', 0.0216, 'lps'),
	(521206, 129, '2014-02-01 00:35:46.000000', 'consum', 0.0229, 'lps'),
	(521207, 129, '2014-02-01 00:35:47.000000', 'consum', 0.0224, 'lps'),
	(521208, 129, '2014-02-01 00:35:48.000000', 'consum', 0.0225, 'lps'),
	(521209, 129, '2014-02-01 00:35:49.000000', 'consum', 0.0220, 'lps'),
	(521210, 129, '2014-02-01 00:35:50.000000', 'consum', 0.0217, 'lps'),
	(521211, 129, '2014-02-01 00:35:51.000000', 'consum', 0.0215, 'lps'),
	(521212, 129, '2014-02-01 00:35:52.000000', 'consum', 0.0214, 'lps'),
	(521213, 129, '2014-02-01 00:35:53.000000', 'consum', 0.0217, 'lps'),
	(521214, 129, '2014-02-01 00:35:54.000000', 'consum', 0.0212, 'lps'),
	(521215, 129, '2014-02-01 00:35:55.000000', 'consum', 0.0222, 'lps'),
	(521216, 129, '2014-02-01 00:35:56.000000', 'consum', 0.0220, 'lps'),
	(521217, 129, '2014-02-01 00:35:57.000000', 'consum', 0.0222, 'lps'),
	(521218, 129, '2014-02-01 00:35:58.000000', 'consum', 0.0221, 'lps'),
	(521219, 129, '2014-02-01 00:35:59.000000', 'consum', 0.0230, 'lps'),
	(521220, 129, '2014-02-01 00:36:00.000000', 'consum', 0.0213, 'lps'),
	(521221, 129, '2014-02-01 00:36:01.000000', 'consum', 0.0228, 'lps'),
	(521222, 129, '2014-02-01 00:36:02.000000', 'consum', 0.0227, 'lps'),
	(521223, 129, '2014-02-01 00:36:03.000000', 'consum', 0.0219, 'lps'),
	(521224, 129, '2014-02-01 00:36:04.000000', 'consum', 0.0227, 'lps'),
	(521225, 129, '2014-02-01 00:36:05.000000', 'consum', 0.0222, 'lps'),
	(521226, 129, '2014-02-01 00:36:06.000000', 'consum', 0.0222, 'lps'),
	(521227, 129, '2014-02-01 00:36:07.000000', 'consum', 0.0211, 'lps'),
	(521228, 129, '2014-02-01 00:36:08.000000', 'consum', 0.0226, 'lps'),
	(521229, 129, '2014-02-01 00:36:09.000000', 'consum', 0.0220, 'lps'),
	(521230, 129, '2014-02-01 00:36:10.000000', 'consum', 0.0213, 'lps'),
	(521231, 129, '2014-02-01 00:36:11.000000', 'consum', 0.0218, 'lps'),
	(521232, 129, '2014-02-01 00:36:12.000000', 'consum', 0.0218, 'lps'),
	(521233, 129, '2014-02-01 00:36:13.000000', 'consum', 0.0225, 'lps'),
	(521234, 129, '2014-02-01 00:36:14.000000', 'consum', 0.0219, 'lps'),
	(521235, 129, '2014-02-01 00:36:15.000000', 'consum', 0.0211, 'lps'),
	(521236, 129, '2014-02-01 00:36:16.000000', 'consum', 0.0211, 'lps'),
	(521237, 129, '2014-02-01 00:36:17.000000', 'consum', 0.0210, 'lps'),
	(521238, 129, '2014-02-01 00:36:18.000000', 'consum', 0.0230, 'lps'),
	(521239, 129, '2014-02-01 00:36:19.000000', 'consum', 0.0225, 'lps'),
	(521240, 129, '2014-02-01 00:36:20.000000', 'consum', 0.0224, 'lps'),
	(521241, 129, '2014-02-01 00:36:21.000000', 'consum', 0.0214, 'lps'),
	(521242, 129, '2014-02-01 00:36:22.000000', 'consum', 0.0230, 'lps'),
	(521243, 129, '2014-02-01 00:36:23.000000', 'consum', 0.0214, 'lps'),
	(521244, 129, '2014-02-01 00:36:24.000000', 'consum', 0.0213, 'lps'),
	(521245, 129, '2014-02-01 00:36:25.000000', 'consum', 0.0212, 'lps'),
	(521246, 129, '2014-02-01 00:36:26.000000', 'consum', 0.0215, 'lps'),
	(521247, 129, '2014-02-01 00:36:27.000000', 'consum', 0.0226, 'lps'),
	(521248, 129, '2014-02-01 00:36:28.000000', 'consum', 0.0210, 'lps'),
	(521249, 129, '2014-02-01 00:36:29.000000', 'consum', 0.0228, 'lps'),
	(521250, 129, '2014-02-01 00:36:30.000000', 'consum', 0.0212, 'lps'),
	(521251, 129, '2014-02-01 00:36:31.000000', 'consum', 0.0210, 'lps'),
	(521252, 129, '2014-02-01 00:36:32.000000', 'consum', 0.0226, 'lps'),
	(521253, 129, '2014-02-01 00:36:33.000000', 'consum', 0.0225, 'lps'),
	(521254, 129, '2014-02-01 00:36:34.000000', 'consum', 0.0215, 'lps'),
	(521255, 129, '2014-02-01 00:36:35.000000', 'consum', 0.0212, 'lps'),
	(521256, 129, '2014-02-01 00:36:36.000000', 'consum', 0.0226, 'lps'),
	(521257, 129, '2014-02-01 00:36:37.000000', 'consum', 0.0221, 'lps'),
	(521258, 129, '2014-02-01 00:36:38.000000', 'consum', 0.0218, 'lps'),
	(521259, 129, '2014-02-01 00:36:39.000000', 'consum', 0.0218, 'lps'),
	(521260, 129, '2014-02-01 00:36:40.000000', 'consum', 0.0225, 'lps'),
	(521261, 129, '2014-02-01 00:36:41.000000', 'consum', 0.0220, 'lps'),
	(521262, 129, '2014-02-01 00:36:42.000000', 'consum', 0.0213, 'lps'),
	(521263, 129, '2014-02-01 00:36:43.000000', 'consum', 0.0220, 'lps'),
	(521264, 129, '2014-02-01 00:36:44.000000', 'consum', 0.0229, 'lps'),
	(521265, 129, '2014-02-01 00:36:45.000000', 'consum', 0.0229, 'lps'),
	(521266, 129, '2014-02-01 00:36:46.000000', 'consum', 0.0228, 'lps'),
	(521267, 129, '2014-02-01 00:36:47.000000', 'consum', 0.0219, 'lps'),
	(521268, 129, '2014-02-01 00:36:48.000000', 'consum', 0.0227, 'lps'),
	(521269, 129, '2014-02-01 00:36:49.000000', 'consum', 0.0223, 'lps'),
	(521270, 129, '2014-02-01 00:36:50.000000', 'consum', 0.0227, 'lps'),
	(521271, 129, '2014-02-01 00:36:51.000000', 'consum', 0.0210, 'lps'),
	(521272, 129, '2014-02-01 00:36:52.000000', 'consum', 0.0225, 'lps'),
	(521273, 129, '2014-02-01 00:36:53.000000', 'consum', 0.0220, 'lps'),
	(521274, 129, '2014-02-01 00:36:54.000000', 'consum', 0.0214, 'lps'),
	(521275, 129, '2014-02-01 00:36:55.000000', 'consum', 0.0224, 'lps'),
	(521276, 129, '2014-02-01 00:36:56.000000', 'consum', 0.0224, 'lps'),
	(521277, 129, '2014-02-01 00:36:57.000000', 'consum', 0.0218, 'lps'),
	(521278, 129, '2014-02-01 00:36:58.000000', 'consum', 0.0228, 'lps'),
	(521279, 129, '2014-02-01 00:36:59.000000', 'consum', 0.0213, 'lps'),
	(521280, 129, '2014-02-01 00:37:00.000000', 'consum', 0.0215, 'lps'),
	(521281, 129, '2014-02-01 00:37:01.000000', 'consum', 0.0227, 'lps'),
	(521282, 129, '2014-02-01 00:37:02.000000', 'consum', 0.0214, 'lps'),
	(521283, 129, '2014-02-01 00:37:03.000000', 'consum', 0.0225, 'lps'),
	(521284, 129, '2014-02-01 00:37:04.000000', 'consum', 0.0230, 'lps'),
	(521285, 129, '2014-02-01 00:37:05.000000', 'consum', 0.0221, 'lps'),
	(521286, 129, '2014-02-01 00:37:06.000000', 'consum', 0.0229, 'lps'),
	(521287, 129, '2014-02-01 00:37:07.000000', 'consum', 0.0228, 'lps'),
	(521288, 129, '2014-02-01 00:37:08.000000', 'consum', 0.0220, 'lps'),
	(521289, 129, '2014-02-01 00:37:09.000000', 'consum', 0.0231, 'lps'),
	(521290, 129, '2014-02-01 00:37:10.000000', 'consum', 0.0217, 'lps'),
	(521291, 129, '2014-02-01 00:37:11.000000', 'consum', 0.0226, 'lps'),
	(521292, 129, '2014-02-01 00:37:12.000000', 'consum', 0.0226, 'lps'),
	(521293, 129, '2014-02-01 00:37:13.000000', 'consum', 0.0222, 'lps'),
	(521294, 129, '2014-02-01 00:37:14.000000', 'consum', 0.0221, 'lps'),
	(521295, 129, '2014-02-01 00:37:15.000000', 'consum', 0.0229, 'lps'),
	(521296, 129, '2014-02-01 00:37:16.000000', 'consum', 0.0229, 'lps'),
	(521297, 129, '2014-02-01 00:37:17.000000', 'consum', 0.0226, 'lps'),
	(521298, 129, '2014-02-01 00:37:18.000000', 'consum', 0.0213, 'lps'),
	(521299, 129, '2014-02-01 00:37:19.000000', 'consum', 0.0222, 'lps'),
	(521300, 129, '2014-02-01 00:37:20.000000', 'consum', 0.0215, 'lps'),
	(521301, 129, '2014-02-01 00:37:21.000000', 'consum', 0.0223, 'lps'),
	(521302, 129, '2014-02-01 00:37:22.000000', 'consum', 0.0215, 'lps'),
	(521303, 129, '2014-02-01 00:37:23.000000', 'consum', 0.0219, 'lps'),
	(521304, 129, '2014-02-01 00:37:24.000000', 'consum', 0.0219, 'lps'),
	(521305, 129, '2014-02-01 00:37:25.000000', 'consum', 0.0229, 'lps'),
	(521306, 129, '2014-02-01 00:37:26.000000', 'consum', 0.0211, 'lps'),
	(521307, 129, '2014-02-01 00:37:27.000000', 'consum', 0.0226, 'lps'),
	(521308, 129, '2014-02-01 00:37:28.000000', 'consum', 0.0220, 'lps'),
	(521309, 129, '2014-02-01 00:37:29.000000', 'consum', 0.0215, 'lps'),
	(521310, 129, '2014-02-01 00:37:30.000000', 'consum', 0.0226, 'lps'),
	(521311, 129, '2014-02-01 00:37:31.000000', 'consum', 0.0210, 'lps'),
	(521312, 129, '2014-02-01 00:37:32.000000', 'consum', 0.0228, 'lps'),
	(521313, 129, '2014-02-01 00:37:33.000000', 'consum', 0.0211, 'lps'),
	(521314, 129, '2014-02-01 00:37:34.000000', 'consum', 0.0231, 'lps'),
	(521315, 129, '2014-02-01 00:37:35.000000', 'consum', 0.0222, 'lps'),
	(521316, 129, '2014-02-01 00:37:36.000000', 'consum', 0.0230, 'lps'),
	(521317, 129, '2014-02-01 00:37:37.000000', 'consum', 0.0230, 'lps'),
	(521318, 129, '2014-02-01 00:37:38.000000', 'consum', 0.0228, 'lps'),
	(521319, 129, '2014-02-01 00:37:39.000000', 'consum', 0.0219, 'lps'),
	(521320, 129, '2014-02-01 00:37:40.000000', 'consum', 0.0222, 'lps'),
	(521321, 129, '2014-02-01 00:37:41.000000', 'consum', 0.0224, 'lps'),
	(521322, 129, '2014-02-01 00:37:42.000000', 'consum', 0.0223, 'lps'),
	(521323, 129, '2014-02-01 00:37:43.000000', 'consum', 0.0231, 'lps'),
	(521324, 129, '2014-02-01 00:37:44.000000', 'consum', 0.0213, 'lps'),
	(521325, 129, '2014-02-01 00:37:45.000000', 'consum', 0.0226, 'lps'),
	(521326, 129, '2014-02-01 00:37:46.000000', 'consum', 0.0218, 'lps'),
	(521327, 129, '2014-02-01 00:37:47.000000', 'consum', 0.0222, 'lps'),
	(521328, 129, '2014-02-01 00:37:48.000000', 'consum', 0.0223, 'lps'),
	(521329, 129, '2014-02-01 00:37:49.000000', 'consum', 0.0221, 'lps'),
	(521330, 129, '2014-02-01 00:37:50.000000', 'consum', 0.0226, 'lps'),
	(521331, 129, '2014-02-01 00:37:51.000000', 'consum', 0.0215, 'lps'),
	(521332, 129, '2014-02-01 00:37:52.000000', 'consum', 0.0228, 'lps'),
	(521333, 129, '2014-02-01 00:37:53.000000', 'consum', 0.0221, 'lps'),
	(521334, 129, '2014-02-01 00:37:54.000000', 'consum', 0.0212, 'lps'),
	(521335, 129, '2014-02-01 00:37:55.000000', 'consum', 0.0211, 'lps'),
	(521336, 129, '2014-02-01 00:37:56.000000', 'consum', 0.0228, 'lps'),
	(521337, 129, '2014-02-01 00:37:57.000000', 'consum', 0.0211, 'lps'),
	(521338, 129, '2014-02-01 00:37:58.000000', 'consum', 0.0229, 'lps'),
	(521339, 129, '2014-02-01 00:37:59.000000', 'consum', 0.0214, 'lps'),
	(521340, 129, '2014-02-01 00:38:00.000000', 'consum', 0.0218, 'lps'),
	(521341, 129, '2014-02-01 00:38:01.000000', 'consum', 0.0214, 'lps'),
	(521342, 129, '2014-02-01 00:38:02.000000', 'consum', 0.0230, 'lps'),
	(521343, 129, '2014-02-01 00:38:03.000000', 'consum', 0.0210, 'lps'),
	(521344, 129, '2014-02-01 00:38:04.000000', 'consum', 0.0215, 'lps'),
	(521345, 129, '2014-02-01 00:38:05.000000', 'consum', 0.0214, 'lps'),
	(521346, 129, '2014-02-01 00:38:06.000000', 'consum', 0.0215, 'lps'),
	(521347, 129, '2014-02-01 00:38:07.000000', 'consum', 0.0223, 'lps'),
	(521348, 129, '2014-02-01 00:38:08.000000', 'consum', 0.0216, 'lps'),
	(521349, 129, '2014-02-01 00:38:09.000000', 'consum', 0.0223, 'lps'),
	(521350, 129, '2014-02-01 00:38:10.000000', 'consum', 0.0215, 'lps'),
	(521351, 129, '2014-02-01 00:38:11.000000', 'consum', 0.0219, 'lps'),
	(521352, 129, '2014-02-01 00:38:12.000000', 'consum', 0.0216, 'lps'),
	(521353, 129, '2014-02-01 00:38:13.000000', 'consum', 0.0217, 'lps'),
	(521354, 129, '2014-02-01 00:38:14.000000', 'consum', 0.0226, 'lps'),
	(521355, 129, '2014-02-01 00:38:15.000000', 'consum', 0.0223, 'lps'),
	(521356, 129, '2014-02-01 00:38:16.000000', 'consum', 0.0231, 'lps'),
	(521357, 129, '2014-02-01 00:38:17.000000', 'consum', 0.0210, 'lps'),
	(521358, 129, '2014-02-01 00:38:18.000000', 'consum', 0.0212, 'lps'),
	(521359, 129, '2014-02-01 00:38:19.000000', 'consum', 0.0223, 'lps'),
	(521360, 129, '2014-02-01 00:38:20.000000', 'consum', 0.0224, 'lps'),
	(521361, 129, '2014-02-01 00:38:21.000000', 'consum', 0.0220, 'lps'),
	(521362, 129, '2014-02-01 00:38:22.000000', 'consum', 0.0220, 'lps'),
	(521363, 129, '2014-02-01 00:38:23.000000', 'consum', 0.0230, 'lps'),
	(521364, 129, '2014-02-01 00:38:24.000000', 'consum', 0.0213, 'lps'),
	(521365, 129, '2014-02-01 00:38:25.000000', 'consum', 0.0230, 'lps'),
	(521366, 129, '2014-02-01 00:38:26.000000', 'consum', 0.0217, 'lps'),
	(521367, 129, '2014-02-01 00:38:27.000000', 'consum', 0.0229, 'lps'),
	(521368, 129, '2014-02-01 00:38:28.000000', 'consum', 0.0217, 'lps'),
	(521369, 129, '2014-02-01 00:38:29.000000', 'consum', 0.0211, 'lps'),
	(521370, 129, '2014-02-01 00:38:30.000000', 'consum', 0.0217, 'lps'),
	(521371, 129, '2014-02-01 00:38:31.000000', 'consum', 0.0221, 'lps'),
	(521372, 129, '2014-02-01 00:38:32.000000', 'consum', 0.0222, 'lps'),
	(521373, 129, '2014-02-01 00:38:33.000000', 'consum', 0.0215, 'lps'),
	(521374, 129, '2014-02-01 00:38:34.000000', 'consum', 0.0221, 'lps'),
	(521375, 129, '2014-02-01 00:38:35.000000', 'consum', 0.0227, 'lps'),
	(521376, 129, '2014-02-01 00:38:36.000000', 'consum', 0.0221, 'lps'),
	(521377, 129, '2014-02-01 00:38:37.000000', 'consum', 0.0215, 'lps'),
	(521378, 129, '2014-02-01 00:38:38.000000', 'consum', 0.0225, 'lps'),
	(521379, 129, '2014-02-01 00:38:39.000000', 'consum', 0.0227, 'lps'),
	(521380, 129, '2014-02-01 00:38:40.000000', 'consum', 0.0229, 'lps'),
	(521381, 129, '2014-02-01 00:38:41.000000', 'consum', 0.0210, 'lps'),
	(521382, 129, '2014-02-01 00:38:42.000000', 'consum', 0.0218, 'lps'),
	(521383, 129, '2014-02-01 00:38:43.000000', 'consum', 0.0228, 'lps'),
	(521384, 129, '2014-02-01 00:38:44.000000', 'consum', 0.0210, 'lps'),
	(521385, 129, '2014-02-01 00:38:45.000000', 'consum', 0.0222, 'lps'),
	(521386, 129, '2014-02-01 00:38:46.000000', 'consum', 0.0229, 'lps'),
	(521387, 129, '2014-02-01 00:38:47.000000', 'consum', 0.0224, 'lps'),
	(521388, 129, '2014-02-01 00:38:48.000000', 'consum', 0.0224, 'lps'),
	(521389, 129, '2014-02-01 00:38:49.000000', 'consum', 0.0216, 'lps'),
	(521390, 129, '2014-02-01 00:38:50.000000', 'consum', 0.0219, 'lps'),
	(521391, 129, '2014-02-01 00:38:51.000000', 'consum', 0.0217, 'lps'),
	(521392, 129, '2014-02-01 00:38:52.000000', 'consum', 0.0220, 'lps'),
	(521393, 129, '2014-02-01 00:38:53.000000', 'consum', 0.0216, 'lps'),
	(521394, 129, '2014-02-01 00:38:54.000000', 'consum', 0.0212, 'lps'),
	(521395, 129, '2014-02-01 00:38:55.000000', 'consum', 0.0225, 'lps'),
	(521396, 129, '2014-02-01 00:38:56.000000', 'consum', 0.0211, 'lps'),
	(521397, 129, '2014-02-01 00:38:57.000000', 'consum', 0.0216, 'lps'),
	(521398, 129, '2014-02-01 00:38:58.000000', 'consum', 0.0216, 'lps'),
	(521399, 129, '2014-02-01 00:38:59.000000', 'consum', 0.0223, 'lps'),
	(521400, 129, '2014-02-01 00:39:00.000000', 'consum', 0.0212, 'lps'),
	(521401, 129, '2014-02-01 00:39:01.000000', 'consum', 0.0226, 'lps'),
	(521402, 129, '2014-02-01 00:39:02.000000', 'consum', 0.0219, 'lps'),
	(521403, 129, '2014-02-01 00:39:03.000000', 'consum', 0.0230, 'lps'),
	(521404, 129, '2014-02-01 00:39:04.000000', 'consum', 0.0217, 'lps'),
	(521405, 129, '2014-02-01 00:39:05.000000', 'consum', 0.0230, 'lps'),
	(521406, 129, '2014-02-01 00:39:06.000000', 'consum', 0.0222, 'lps'),
	(521407, 129, '2014-02-01 00:39:07.000000', 'consum', 0.0213, 'lps'),
	(521408, 129, '2014-02-01 00:39:08.000000', 'consum', 0.0231, 'lps'),
	(521409, 129, '2014-02-01 00:39:09.000000', 'consum', 0.0221, 'lps'),
	(521410, 129, '2014-02-01 00:39:10.000000', 'consum', 0.0224, 'lps'),
	(521411, 129, '2014-02-01 00:39:11.000000', 'consum', 0.0224, 'lps'),
	(521412, 129, '2014-02-01 00:39:12.000000', 'consum', 0.0219, 'lps'),
	(521413, 129, '2014-02-01 00:39:13.000000', 'consum', 0.0210, 'lps'),
	(521414, 129, '2014-02-01 00:39:14.000000', 'consum', 0.0230, 'lps'),
	(521415, 129, '2014-02-01 00:39:15.000000', 'consum', 0.0223, 'lps'),
	(521416, 129, '2014-02-01 00:39:16.000000', 'consum', 0.0216, 'lps'),
	(521417, 129, '2014-02-01 00:39:17.000000', 'consum', 0.0222, 'lps'),
	(521418, 129, '2014-02-01 00:39:18.000000', 'consum', 0.0229, 'lps'),
	(521419, 129, '2014-02-01 00:39:19.000000', 'consum', 0.0229, 'lps'),
	(521420, 129, '2014-02-01 00:39:20.000000', 'consum', 0.0225, 'lps'),
	(521421, 129, '2014-02-01 00:39:21.000000', 'consum', 0.0227, 'lps'),
	(521422, 129, '2014-02-01 00:39:22.000000', 'consum', 0.0231, 'lps'),
	(521423, 129, '2014-02-01 00:39:23.000000', 'consum', 0.0219, 'lps'),
	(521424, 129, '2014-02-01 00:39:24.000000', 'consum', 0.0216, 'lps'),
	(521425, 129, '2014-02-01 00:39:25.000000', 'consum', 0.0211, 'lps'),
	(521426, 129, '2014-02-01 00:39:26.000000', 'consum', 0.0222, 'lps'),
	(521427, 129, '2014-02-01 00:39:27.000000', 'consum', 0.0224, 'lps'),
	(521428, 129, '2014-02-01 00:39:28.000000', 'consum', 0.0222, 'lps'),
	(521429, 129, '2014-02-01 00:39:29.000000', 'consum', 0.0228, 'lps'),
	(521430, 129, '2014-02-01 00:39:30.000000', 'consum', 0.0219, 'lps'),
	(521431, 129, '2014-02-01 00:39:31.000000', 'consum', 0.0226, 'lps'),
	(521432, 129, '2014-02-01 00:39:32.000000', 'consum', 0.0218, 'lps'),
	(521433, 129, '2014-02-01 00:39:33.000000', 'consum', 0.0223, 'lps'),
	(521434, 129, '2014-02-01 00:39:34.000000', 'consum', 0.0230, 'lps'),
	(521435, 129, '2014-02-01 00:39:35.000000', 'consum', 0.0230, 'lps'),
	(521436, 129, '2014-02-01 00:39:36.000000', 'consum', 0.0227, 'lps'),
	(521437, 129, '2014-02-01 00:39:37.000000', 'consum', 0.0216, 'lps'),
	(521438, 129, '2014-02-01 00:39:38.000000', 'consum', 0.0230, 'lps'),
	(521439, 129, '2014-02-01 00:39:39.000000', 'consum', 0.0227, 'lps'),
	(521440, 129, '2014-02-01 00:39:40.000000', 'consum', 0.0213, 'lps'),
	(521441, 129, '2014-02-01 00:39:41.000000', 'consum', 0.0220, 'lps'),
	(521442, 129, '2014-02-01 00:39:42.000000', 'consum', 0.0230, 'lps'),
	(521443, 129, '2014-02-01 00:39:43.000000', 'consum', 0.0215, 'lps'),
	(521444, 129, '2014-02-01 00:39:44.000000', 'consum', 0.0219, 'lps'),
	(521445, 129, '2014-02-01 00:39:45.000000', 'consum', 0.0219, 'lps'),
	(521446, 129, '2014-02-01 00:39:46.000000', 'consum', 0.0226, 'lps'),
	(521447, 129, '2014-02-01 00:39:47.000000', 'consum', 0.0221, 'lps'),
	(521448, 129, '2014-02-01 00:39:48.000000', 'consum', 0.0219, 'lps'),
	(521449, 129, '2014-02-01 00:39:49.000000', 'consum', 0.0219, 'lps'),
	(521450, 129, '2014-02-01 00:39:50.000000', 'consum', 0.0210, 'lps'),
	(521451, 129, '2014-02-01 00:39:51.000000', 'consum', 0.0225, 'lps'),
	(521452, 129, '2014-02-01 00:39:52.000000', 'consum', 0.0220, 'lps'),
	(521453, 129, '2014-02-01 00:39:53.000000', 'consum', 0.0215, 'lps'),
	(521454, 129, '2014-02-01 00:39:54.000000', 'consum', 0.0227, 'lps'),
	(521455, 129, '2014-02-01 00:39:55.000000', 'consum', 0.0217, 'lps'),
	(521456, 129, '2014-02-01 00:39:56.000000', 'consum', 0.0216, 'lps'),
	(521457, 129, '2014-02-01 00:39:57.000000', 'consum', 0.0220, 'lps'),
	(521458, 129, '2014-02-01 00:39:58.000000', 'consum', 0.0218, 'lps'),
	(521459, 129, '2014-02-01 00:39:59.000000', 'consum', 0.0222, 'lps'),
	(521460, 129, '2014-02-01 00:40:00.000000', 'consum', 0.0224, 'lps'),
	(521461, 129, '2014-02-01 00:40:01.000000', 'consum', 0.0222, 'lps'),
	(521462, 129, '2014-02-01 00:40:02.000000', 'consum', 0.0230, 'lps'),
	(521463, 129, '2014-02-01 00:40:03.000000', 'consum', 0.0228, 'lps'),
	(521464, 129, '2014-02-01 00:40:04.000000', 'consum', 0.0220, 'lps'),
	(521465, 129, '2014-02-01 00:40:05.000000', 'consum', 0.0229, 'lps'),
	(521466, 129, '2014-02-01 00:40:06.000000', 'consum', 0.0231, 'lps'),
	(521467, 129, '2014-02-01 00:40:07.000000', 'consum', 0.0215, 'lps'),
	(521468, 129, '2014-02-01 00:40:08.000000', 'consum', 0.0218, 'lps'),
	(521469, 129, '2014-02-01 00:40:09.000000', 'consum', 0.0211, 'lps'),
	(521470, 129, '2014-02-01 00:40:10.000000', 'consum', 0.0212, 'lps'),
	(521471, 129, '2014-02-01 00:40:11.000000', 'consum', 0.0220, 'lps'),
	(521472, 129, '2014-02-01 00:40:12.000000', 'consum', 0.0211, 'lps'),
	(521473, 129, '2014-02-01 00:40:13.000000', 'consum', 0.0228, 'lps'),
	(521474, 129, '2014-02-01 00:40:14.000000', 'consum', 0.0212, 'lps'),
	(521475, 129, '2014-02-01 00:40:15.000000', 'consum', 0.0229, 'lps'),
	(521476, 129, '2014-02-01 00:40:16.000000', 'consum', 0.0214, 'lps'),
	(521477, 129, '2014-02-01 00:40:17.000000', 'consum', 0.0216, 'lps'),
	(521478, 129, '2014-02-01 00:40:18.000000', 'consum', 0.0227, 'lps'),
	(521479, 129, '2014-02-01 00:40:19.000000', 'consum', 0.0214, 'lps'),
	(521480, 129, '2014-02-01 00:40:20.000000', 'consum', 0.0223, 'lps'),
	(521481, 129, '2014-02-01 00:40:21.000000', 'consum', 0.0221, 'lps'),
	(521482, 129, '2014-02-01 00:40:22.000000', 'consum', 0.0226, 'lps'),
	(521483, 129, '2014-02-01 00:40:23.000000', 'consum', 0.0212, 'lps'),
	(521484, 129, '2014-02-01 00:40:24.000000', 'consum', 0.0217, 'lps'),
	(521485, 129, '2014-02-01 00:40:25.000000', 'consum', 0.0220, 'lps'),
	(521486, 129, '2014-02-01 00:40:26.000000', 'consum', 0.0215, 'lps'),
	(521487, 129, '2014-02-01 00:40:27.000000', 'consum', 0.0227, 'lps'),
	(521488, 129, '2014-02-01 00:40:28.000000', 'consum', 0.0217, 'lps'),
	(521489, 129, '2014-02-01 00:40:29.000000', 'consum', 0.0215, 'lps'),
	(521490, 129, '2014-02-01 00:40:30.000000', 'consum', 0.0217, 'lps'),
	(521491, 129, '2014-02-01 00:40:31.000000', 'consum', 0.0228, 'lps'),
	(521492, 129, '2014-02-01 00:40:32.000000', 'consum', 0.0212, 'lps'),
	(521493, 129, '2014-02-01 00:40:33.000000', 'consum', 0.0212, 'lps'),
	(521494, 129, '2014-02-01 00:40:34.000000', 'consum', 0.0214, 'lps'),
	(521495, 129, '2014-02-01 00:40:35.000000', 'consum', 0.0225, 'lps'),
	(521496, 129, '2014-02-01 00:40:36.000000', 'consum', 0.0230, 'lps'),
	(521497, 129, '2014-02-01 00:40:37.000000', 'consum', 0.0223, 'lps'),
	(521498, 129, '2014-02-01 00:40:38.000000', 'consum', 0.0214, 'lps'),
	(521499, 129, '2014-02-01 00:40:39.000000', 'consum', 0.0214, 'lps'),
	(521500, 129, '2014-02-01 00:40:40.000000', 'consum', 0.0219, 'lps'),
	(521501, 129, '2014-02-01 00:40:41.000000', 'consum', 0.0219, 'lps'),
	(521502, 129, '2014-02-01 00:40:42.000000', 'consum', 0.0229, 'lps'),
	(521503, 129, '2014-02-01 00:40:43.000000', 'consum', 0.0213, 'lps'),
	(521504, 129, '2014-02-01 00:40:44.000000', 'consum', 0.0214, 'lps'),
	(521505, 129, '2014-02-01 00:40:45.000000', 'consum', 0.0221, 'lps'),
	(521506, 129, '2014-02-01 00:40:46.000000', 'consum', 0.0230, 'lps'),
	(521507, 129, '2014-02-01 00:40:47.000000', 'consum', 0.0213, 'lps'),
	(521508, 129, '2014-02-01 00:40:48.000000', 'consum', 0.0229, 'lps'),
	(521509, 129, '2014-02-01 00:40:49.000000', 'consum', 0.0211, 'lps'),
	(521510, 129, '2014-02-01 00:40:50.000000', 'consum', 0.0222, 'lps'),
	(521511, 129, '2014-02-01 00:40:51.000000', 'consum', 0.0226, 'lps'),
	(521512, 129, '2014-02-01 00:40:52.000000', 'consum', 0.0210, 'lps'),
	(521513, 129, '2014-02-01 00:40:53.000000', 'consum', 0.0229, 'lps'),
	(521514, 129, '2014-02-01 00:40:54.000000', 'consum', 0.0215, 'lps'),
	(521515, 129, '2014-02-01 00:40:55.000000', 'consum', 0.0225, 'lps'),
	(521516, 129, '2014-02-01 00:40:56.000000', 'consum', 0.0227, 'lps'),
	(521517, 129, '2014-02-01 00:40:57.000000', 'consum', 0.0229, 'lps'),
	(521518, 129, '2014-02-01 00:40:58.000000', 'consum', 0.0210, 'lps'),
	(521519, 129, '2014-02-01 00:40:59.000000', 'consum', 0.0219, 'lps'),
	(521520, 129, '2014-02-01 00:41:00.000000', 'consum', 0.0210, 'lps'),
	(521521, 129, '2014-02-01 00:41:01.000000', 'consum', 0.0230, 'lps'),
	(521522, 129, '2014-02-01 00:41:02.000000', 'consum', 0.0220, 'lps'),
	(521523, 129, '2014-02-01 00:41:03.000000', 'consum', 0.0222, 'lps'),
	(521524, 129, '2014-02-01 00:41:04.000000', 'consum', 0.0220, 'lps'),
	(521525, 129, '2014-02-01 00:41:05.000000', 'consum', 0.0223, 'lps'),
	(521526, 129, '2014-02-01 00:41:06.000000', 'consum', 0.0226, 'lps'),
	(521527, 129, '2014-02-01 00:41:07.000000', 'consum', 0.0226, 'lps'),
	(521528, 129, '2014-02-01 00:41:08.000000', 'consum', 0.0223, 'lps'),
	(521529, 129, '2014-02-01 00:41:09.000000', 'consum', 0.0228, 'lps'),
	(521530, 129, '2014-02-01 00:41:10.000000', 'consum', 0.0216, 'lps'),
	(521531, 129, '2014-02-01 00:41:11.000000', 'consum', 0.0230, 'lps'),
	(521532, 129, '2014-02-01 00:41:12.000000', 'consum', 0.0228, 'lps'),
	(521533, 129, '2014-02-01 00:41:13.000000', 'consum', 0.0217, 'lps'),
	(521534, 129, '2014-02-01 00:41:14.000000', 'consum', 0.0216, 'lps'),
	(521535, 129, '2014-02-01 00:41:15.000000', 'consum', 0.0217, 'lps'),
	(521536, 129, '2014-02-01 00:41:16.000000', 'consum', 0.0230, 'lps'),
	(521537, 129, '2014-02-01 00:41:17.000000', 'consum', 0.0222, 'lps'),
	(521538, 129, '2014-02-01 00:41:18.000000', 'consum', 0.0231, 'lps'),
	(521539, 129, '2014-02-01 00:41:19.000000', 'consum', 0.0216, 'lps'),
	(521540, 129, '2014-02-01 00:41:20.000000', 'consum', 0.0219, 'lps'),
	(521541, 129, '2014-02-01 00:41:21.000000', 'consum', 0.0215, 'lps'),
	(521542, 129, '2014-02-01 00:41:22.000000', 'consum', 0.0231, 'lps'),
	(521543, 129, '2014-02-01 00:41:23.000000', 'consum', 0.0213, 'lps'),
	(521544, 129, '2014-02-01 00:41:24.000000', 'consum', 0.0229, 'lps'),
	(521545, 129, '2014-02-01 00:41:25.000000', 'consum', 0.0228, 'lps'),
	(521546, 129, '2014-02-01 00:41:26.000000', 'consum', 0.0224, 'lps'),
	(521547, 129, '2014-02-01 00:41:27.000000', 'consum', 0.0224, 'lps'),
	(521548, 129, '2014-02-01 00:41:28.000000', 'consum', 0.0217, 'lps'),
	(521549, 129, '2014-02-01 00:41:29.000000', 'consum', 0.0226, 'lps'),
	(521550, 129, '2014-02-01 00:41:30.000000', 'consum', 0.0227, 'lps'),
	(521551, 129, '2014-02-01 00:41:31.000000', 'consum', 0.0224, 'lps'),
	(521552, 129, '2014-02-01 00:41:32.000000', 'consum', 0.0210, 'lps'),
	(521553, 129, '2014-02-01 00:41:33.000000', 'consum', 0.0211, 'lps'),
	(521554, 129, '2014-02-01 00:41:34.000000', 'consum', 0.0214, 'lps'),
	(521555, 129, '2014-02-01 00:41:35.000000', 'consum', 0.0227, 'lps'),
	(521556, 129, '2014-02-01 00:41:36.000000', 'consum', 0.0217, 'lps'),
	(521557, 129, '2014-02-01 00:41:37.000000', 'consum', 0.0216, 'lps'),
	(521558, 129, '2014-02-01 00:41:38.000000', 'consum', 0.0222, 'lps'),
	(521559, 129, '2014-02-01 00:41:39.000000', 'consum', 0.0231, 'lps'),
	(521560, 129, '2014-02-01 00:41:40.000000', 'consum', 0.0212, 'lps'),
	(521561, 129, '2014-02-01 00:41:41.000000', 'consum', 0.0223, 'lps'),
	(521562, 129, '2014-02-01 00:41:42.000000', 'consum', 0.0225, 'lps'),
	(521563, 129, '2014-02-01 00:41:43.000000', 'consum', 0.0226, 'lps'),
	(521564, 129, '2014-02-01 00:41:44.000000', 'consum', 0.0224, 'lps'),
	(521565, 129, '2014-02-01 00:41:45.000000', 'consum', 0.0230, 'lps'),
	(521566, 129, '2014-02-01 00:41:46.000000', 'consum', 0.0227, 'lps'),
	(521567, 129, '2014-02-01 00:41:47.000000', 'consum', 0.0213, 'lps'),
	(521568, 129, '2014-02-01 00:41:48.000000', 'consum', 0.0218, 'lps'),
	(521569, 129, '2014-02-01 00:41:49.000000', 'consum', 0.0219, 'lps'),
	(521570, 129, '2014-02-01 00:41:50.000000', 'consum', 0.0210, 'lps'),
	(521571, 129, '2014-02-01 00:41:51.000000', 'consum', 0.0229, 'lps'),
	(521572, 129, '2014-02-01 00:41:52.000000', 'consum', 0.0215, 'lps'),
	(521573, 129, '2014-02-01 00:41:53.000000', 'consum', 0.0223, 'lps'),
	(521574, 129, '2014-02-01 00:41:54.000000', 'consum', 0.0218, 'lps'),
	(521575, 129, '2014-02-01 00:41:55.000000', 'consum', 0.0211, 'lps'),
	(521576, 129, '2014-02-01 00:41:56.000000', 'consum', 0.0215, 'lps'),
	(521577, 129, '2014-02-01 00:41:57.000000', 'consum', 0.0230, 'lps'),
	(521578, 129, '2014-02-01 00:41:58.000000', 'consum', 0.0230, 'lps'),
	(521579, 129, '2014-02-01 00:41:59.000000', 'consum', 0.0231, 'lps'),
	(521580, 129, '2014-02-01 00:42:00.000000', 'consum', 0.0210, 'lps'),
	(521581, 129, '2014-02-01 00:42:01.000000', 'consum', 0.0212, 'lps'),
	(521582, 129, '2014-02-01 00:42:02.000000', 'consum', 0.0222, 'lps'),
	(521583, 129, '2014-02-01 00:42:03.000000', 'consum', 0.0221, 'lps'),
	(521584, 129, '2014-02-01 00:42:04.000000', 'consum', 0.0227, 'lps'),
	(521585, 129, '2014-02-01 00:42:05.000000', 'consum', 0.0219, 'lps'),
	(521586, 129, '2014-02-01 00:42:06.000000', 'consum', 0.0228, 'lps'),
	(521587, 129, '2014-02-01 00:42:07.000000', 'consum', 0.0229, 'lps'),
	(521588, 129, '2014-02-01 00:42:08.000000', 'consum', 0.0230, 'lps'),
	(521589, 129, '2014-02-01 00:42:09.000000', 'consum', 0.0230, 'lps'),
	(521590, 129, '2014-02-01 00:42:10.000000', 'consum', 0.0229, 'lps'),
	(521591, 129, '2014-02-01 00:42:11.000000', 'consum', 0.0225, 'lps'),
	(521592, 129, '2014-02-01 00:42:12.000000', 'consum', 0.0226, 'lps'),
	(521593, 129, '2014-02-01 00:42:13.000000', 'consum', 0.0226, 'lps'),
	(521594, 129, '2014-02-01 00:42:14.000000', 'consum', 0.0221, 'lps'),
	(521595, 129, '2014-02-01 00:42:15.000000', 'consum', 0.0215, 'lps'),
	(521596, 129, '2014-02-01 00:42:16.000000', 'consum', 0.0227, 'lps'),
	(521597, 129, '2014-02-01 00:42:17.000000', 'consum', 0.0213, 'lps'),
	(521598, 129, '2014-02-01 00:42:18.000000', 'consum', 0.0221, 'lps'),
	(521599, 129, '2014-02-01 00:42:19.000000', 'consum', 0.0210, 'lps'),
	(521600, 129, '2014-02-01 00:42:20.000000', 'consum', 0.0220, 'lps'),
	(521601, 129, '2014-02-01 00:42:21.000000', 'consum', 0.0219, 'lps'),
	(521602, 129, '2014-02-01 00:42:22.000000', 'consum', 0.0223, 'lps'),
	(521603, 129, '2014-02-01 00:42:23.000000', 'consum', 0.0228, 'lps'),
	(521604, 129, '2014-02-01 00:42:24.000000', 'consum', 0.0218, 'lps'),
	(521605, 129, '2014-02-01 00:42:25.000000', 'consum', 0.0220, 'lps'),
	(521606, 129, '2014-02-01 00:42:26.000000', 'consum', 0.0212, 'lps'),
	(521607, 129, '2014-02-01 00:42:27.000000', 'consum', 0.0212, 'lps'),
	(521608, 129, '2014-02-01 00:42:28.000000', 'consum', 0.0214, 'lps'),
	(521609, 129, '2014-02-01 00:42:29.000000', 'consum', 0.0224, 'lps'),
	(521610, 129, '2014-02-01 00:42:30.000000', 'consum', 0.0225, 'lps'),
	(521611, 129, '2014-02-01 00:42:31.000000', 'consum', 0.0223, 'lps'),
	(521612, 129, '2014-02-01 00:42:32.000000', 'consum', 0.0229, 'lps'),
	(521613, 129, '2014-02-01 00:42:33.000000', 'consum', 0.0223, 'lps'),
	(521614, 129, '2014-02-01 00:42:34.000000', 'consum', 0.0219, 'lps'),
	(521615, 129, '2014-02-01 00:42:35.000000', 'consum', 0.0215, 'lps'),
	(521616, 129, '2014-02-01 00:42:36.000000', 'consum', 0.0229, 'lps'),
	(521617, 129, '2014-02-01 00:42:37.000000', 'consum', 0.0227, 'lps'),
	(521618, 129, '2014-02-01 00:42:38.000000', 'consum', 0.0217, 'lps'),
	(521619, 129, '2014-02-01 00:42:39.000000', 'consum', 0.0216, 'lps'),
	(521620, 129, '2014-02-01 00:42:40.000000', 'consum', 0.0219, 'lps'),
	(521621, 129, '2014-02-01 00:42:41.000000', 'consum', 0.0215, 'lps'),
	(521622, 129, '2014-02-01 00:42:42.000000', 'consum', 0.0231, 'lps'),
	(521623, 129, '2014-02-01 00:42:43.000000', 'consum', 0.0214, 'lps'),
	(521624, 129, '2014-02-01 00:42:44.000000', 'consum', 0.0212, 'lps'),
	(521625, 129, '2014-02-01 00:42:45.000000', 'consum', 0.0230, 'lps'),
	(521626, 129, '2014-02-01 00:42:46.000000', 'consum', 0.0218, 'lps'),
	(521627, 129, '2014-02-01 00:42:47.000000', 'consum', 0.0231, 'lps'),
	(521628, 129, '2014-02-01 00:42:48.000000', 'consum', 0.0229, 'lps'),
	(521629, 129, '2014-02-01 00:42:49.000000', 'consum', 0.0220, 'lps'),
	(521630, 129, '2014-02-01 00:42:50.000000', 'consum', 0.0224, 'lps'),
	(521631, 129, '2014-02-01 00:42:51.000000', 'consum', 0.0229, 'lps'),
	(521632, 129, '2014-02-01 00:42:52.000000', 'consum', 0.0219, 'lps'),
	(521633, 129, '2014-02-01 00:42:53.000000', 'consum', 0.0221, 'lps'),
	(521634, 129, '2014-02-01 00:42:54.000000', 'consum', 0.0218, 'lps'),
	(521635, 129, '2014-02-01 00:42:55.000000', 'consum', 0.0219, 'lps'),
	(521636, 129, '2014-02-01 00:42:56.000000', 'consum', 0.0228, 'lps'),
	(521637, 129, '2014-02-01 00:42:57.000000', 'consum', 0.0229, 'lps'),
	(521638, 129, '2014-02-01 00:42:58.000000', 'consum', 0.0210, 'lps'),
	(521639, 129, '2014-02-01 00:42:59.000000', 'consum', 0.0220, 'lps'),
	(521640, 129, '2014-02-01 00:43:00.000000', 'consum', 0.0217, 'lps'),
	(521641, 129, '2014-02-01 00:43:01.000000', 'consum', 0.0213, 'lps'),
	(521642, 129, '2014-02-01 00:43:02.000000', 'consum', 0.0230, 'lps'),
	(521643, 129, '2014-02-01 00:43:03.000000', 'consum', 0.0210, 'lps'),
	(521644, 129, '2014-02-01 00:43:04.000000', 'consum', 0.0217, 'lps'),
	(521645, 129, '2014-02-01 00:43:05.000000', 'consum', 0.0224, 'lps'),
	(521646, 129, '2014-02-01 00:43:06.000000', 'consum', 0.0213, 'lps'),
	(521647, 129, '2014-02-01 00:43:07.000000', 'consum', 0.0231, 'lps'),
	(521648, 129, '2014-02-01 00:43:08.000000', 'consum', 0.0218, 'lps'),
	(521649, 129, '2014-02-01 00:43:09.000000', 'consum', 0.0231, 'lps'),
	(521650, 129, '2014-02-01 00:43:10.000000', 'consum', 0.0225, 'lps'),
	(521651, 129, '2014-02-01 00:43:11.000000', 'consum', 0.0221, 'lps'),
	(521652, 129, '2014-02-01 00:43:12.000000', 'consum', 0.0221, 'lps'),
	(521653, 129, '2014-02-01 00:43:13.000000', 'consum', 0.0231, 'lps'),
	(521654, 129, '2014-02-01 00:43:14.000000', 'consum', 0.0219, 'lps'),
	(521655, 129, '2014-02-01 00:43:15.000000', 'consum', 0.0215, 'lps'),
	(521656, 129, '2014-02-01 00:43:16.000000', 'consum', 0.0229, 'lps'),
	(521657, 129, '2014-02-01 00:43:17.000000', 'consum', 0.0227, 'lps'),
	(521658, 129, '2014-02-01 00:43:18.000000', 'consum', 0.0213, 'lps'),
	(521659, 129, '2014-02-01 00:43:19.000000', 'consum', 0.0220, 'lps'),
	(521660, 129, '2014-02-01 00:43:20.000000', 'consum', 0.0228, 'lps'),
	(521661, 129, '2014-02-01 00:43:21.000000', 'consum', 0.0226, 'lps'),
	(521662, 129, '2014-02-01 00:43:22.000000', 'consum', 0.0218, 'lps'),
	(521663, 129, '2014-02-01 00:43:23.000000', 'consum', 0.0221, 'lps'),
	(521664, 129, '2014-02-01 00:43:24.000000', 'consum', 0.0220, 'lps'),
	(521665, 129, '2014-02-01 00:43:25.000000', 'consum', 0.0228, 'lps'),
	(521666, 129, '2014-02-01 00:43:26.000000', 'consum', 0.0225, 'lps'),
	(521667, 129, '2014-02-01 00:43:27.000000', 'consum', 0.0231, 'lps'),
	(521668, 129, '2014-02-01 00:43:28.000000', 'consum', 0.0227, 'lps'),
	(521669, 129, '2014-02-01 00:43:29.000000', 'consum', 0.0212, 'lps'),
	(521670, 129, '2014-02-01 00:43:30.000000', 'consum', 0.0213, 'lps'),
	(521671, 129, '2014-02-01 00:43:31.000000', 'consum', 0.0218, 'lps'),
	(521672, 129, '2014-02-01 00:43:32.000000', 'consum', 0.0222, 'lps'),
	(521673, 129, '2014-02-01 00:43:33.000000', 'consum', 0.0225, 'lps'),
	(521674, 129, '2014-02-01 00:43:34.000000', 'consum', 0.0228, 'lps'),
	(521675, 129, '2014-02-01 00:43:35.000000', 'consum', 0.0212, 'lps'),
	(521676, 129, '2014-02-01 00:43:36.000000', 'consum', 0.0231, 'lps'),
	(521677, 129, '2014-02-01 00:43:37.000000', 'consum', 0.0220, 'lps'),
	(521678, 129, '2014-02-01 00:43:38.000000', 'consum', 0.0222, 'lps'),
	(521679, 129, '2014-02-01 00:43:39.000000', 'consum', 0.0217, 'lps'),
	(521680, 129, '2014-02-01 00:43:40.000000', 'consum', 0.0211, 'lps'),
	(521681, 129, '2014-02-01 00:43:41.000000', 'consum', 0.0216, 'lps'),
	(521682, 129, '2014-02-01 00:43:42.000000', 'consum', 0.0215, 'lps'),
	(521683, 129, '2014-02-01 00:43:43.000000', 'consum', 0.0217, 'lps'),
	(521684, 129, '2014-02-01 00:43:44.000000', 'consum', 0.0230, 'lps'),
	(521685, 129, '2014-02-01 00:43:45.000000', 'consum', 0.0225, 'lps'),
	(521686, 129, '2014-02-01 00:43:46.000000', 'consum', 0.0225, 'lps'),
	(521687, 129, '2014-02-01 00:43:47.000000', 'consum', 0.0218, 'lps'),
	(521688, 129, '2014-02-01 00:43:48.000000', 'consum', 0.0226, 'lps'),
	(521689, 129, '2014-02-01 00:43:49.000000', 'consum', 0.0225, 'lps'),
	(521690, 129, '2014-02-01 00:43:50.000000', 'consum', 0.0214, 'lps'),
	(521691, 129, '2014-02-01 00:43:51.000000', 'consum', 0.0231, 'lps'),
	(521692, 129, '2014-02-01 00:43:52.000000', 'consum', 0.0216, 'lps'),
	(521693, 129, '2014-02-01 00:43:53.000000', 'consum', 0.0220, 'lps'),
	(521694, 129, '2014-02-01 00:43:54.000000', 'consum', 0.0220, 'lps'),
	(521695, 129, '2014-02-01 00:43:55.000000', 'consum', 0.0231, 'lps'),
	(521696, 129, '2014-02-01 00:43:56.000000', 'consum', 0.0219, 'lps'),
	(521697, 129, '2014-02-01 00:43:57.000000', 'consum', 0.0214, 'lps'),
	(521698, 129, '2014-02-01 00:43:58.000000', 'consum', 0.0228, 'lps'),
	(521699, 129, '2014-02-01 00:43:59.000000', 'consum', 0.0219, 'lps'),
	(521700, 129, '2014-02-01 00:44:00.000000', 'consum', 0.0227, 'lps'),
	(521701, 129, '2014-02-01 00:44:01.000000', 'consum', 0.0222, 'lps'),
	(521702, 129, '2014-02-01 00:44:02.000000', 'consum', 0.0222, 'lps'),
	(521703, 129, '2014-02-01 00:44:03.000000', 'consum', 0.0211, 'lps'),
	(521704, 129, '2014-02-01 00:44:04.000000', 'consum', 0.0226, 'lps'),
	(521705, 129, '2014-02-01 00:44:05.000000', 'consum', 0.0218, 'lps'),
	(521706, 129, '2014-02-01 00:44:06.000000', 'consum', 0.0228, 'lps'),
	(521707, 129, '2014-02-01 00:44:07.000000', 'consum', 0.0231, 'lps'),
	(521708, 129, '2014-02-01 00:44:08.000000', 'consum', 0.0216, 'lps'),
	(521709, 129, '2014-02-01 00:44:09.000000', 'consum', 0.0224, 'lps'),
	(521710, 129, '2014-02-01 00:44:10.000000', 'consum', 0.0218, 'lps'),
	(521711, 129, '2014-02-01 00:44:11.000000', 'consum', 0.0229, 'lps'),
	(521712, 129, '2014-02-01 00:44:12.000000', 'consum', 0.0218, 'lps'),
	(521713, 129, '2014-02-01 00:44:13.000000', 'consum', 0.0215, 'lps'),
	(521714, 129, '2014-02-01 00:44:14.000000', 'consum', 0.0213, 'lps'),
	(521715, 129, '2014-02-01 00:44:15.000000', 'consum', 0.0229, 'lps'),
	(521716, 129, '2014-02-01 00:44:16.000000', 'consum', 0.0211, 'lps'),
	(521717, 129, '2014-02-01 00:44:17.000000', 'consum', 0.0225, 'lps'),
	(521718, 129, '2014-02-01 00:44:18.000000', 'consum', 0.0217, 'lps'),
	(521719, 129, '2014-02-01 00:44:19.000000', 'consum', 0.0221, 'lps'),
	(521720, 129, '2014-02-01 00:44:20.000000', 'consum', 0.0224, 'lps'),
	(521721, 129, '2014-02-01 00:44:21.000000', 'consum', 0.0225, 'lps'),
	(521722, 129, '2014-02-01 00:44:22.000000', 'consum', 0.0223, 'lps'),
	(521723, 129, '2014-02-01 00:44:23.000000', 'consum', 0.0231, 'lps'),
	(521724, 129, '2014-02-01 00:44:24.000000', 'consum', 0.0230, 'lps'),
	(521725, 129, '2014-02-01 00:44:25.000000', 'consum', 0.0225, 'lps'),
	(521726, 129, '2014-02-01 00:44:26.000000', 'consum', 0.0227, 'lps'),
	(521727, 129, '2014-02-01 00:44:27.000000', 'consum', 0.0229, 'lps'),
	(521728, 129, '2014-02-01 00:44:28.000000', 'consum', 0.0230, 'lps'),
	(521729, 129, '2014-02-01 00:44:29.000000', 'consum', 0.0211, 'lps'),
	(521730, 129, '2014-02-01 00:44:30.000000', 'consum', 0.0223, 'lps'),
	(521731, 129, '2014-02-01 00:44:31.000000', 'consum', 0.0228, 'lps'),
	(521732, 129, '2014-02-01 00:44:32.000000', 'consum', 0.0216, 'lps'),
	(521733, 129, '2014-02-01 00:44:33.000000', 'consum', 0.0210, 'lps'),
	(521734, 129, '2014-02-01 00:44:34.000000', 'consum', 0.0213, 'lps'),
	(521735, 129, '2014-02-01 00:44:35.000000', 'consum', 0.0225, 'lps'),
	(521736, 129, '2014-02-01 00:44:36.000000', 'consum', 0.0212, 'lps'),
	(521737, 129, '2014-02-01 00:44:37.000000', 'consum', 0.0218, 'lps'),
	(521738, 129, '2014-02-01 00:44:38.000000', 'consum', 0.0224, 'lps'),
	(521739, 129, '2014-02-01 00:44:39.000000', 'consum', 0.0211, 'lps'),
	(521740, 129, '2014-02-01 00:44:40.000000', 'consum', 0.0218, 'lps'),
	(521741, 129, '2014-02-01 00:44:41.000000', 'consum', 0.0225, 'lps'),
	(521742, 129, '2014-02-01 00:44:42.000000', 'consum', 0.0217, 'lps'),
	(521743, 129, '2014-02-01 00:44:43.000000', 'consum', 0.0223, 'lps'),
	(521744, 129, '2014-02-01 00:44:44.000000', 'consum', 0.0212, 'lps'),
	(521745, 129, '2014-02-01 00:44:45.000000', 'consum', 0.0225, 'lps'),
	(521746, 129, '2014-02-01 00:44:46.000000', 'consum', 0.0212, 'lps'),
	(521747, 129, '2014-02-01 00:44:47.000000', 'consum', 0.0219, 'lps'),
	(521748, 129, '2014-02-01 00:44:48.000000', 'consum', 0.0227, 'lps'),
	(521749, 129, '2014-02-01 00:44:49.000000', 'consum', 0.0226, 'lps'),
	(521750, 129, '2014-02-01 00:44:50.000000', 'consum', 0.0216, 'lps'),
	(521751, 129, '2014-02-01 00:44:51.000000', 'consum', 0.0214, 'lps'),
	(521752, 129, '2014-02-01 00:44:52.000000', 'consum', 0.0214, 'lps'),
	(521753, 129, '2014-02-01 00:44:53.000000', 'consum', 0.0219, 'lps'),
	(521754, 129, '2014-02-01 00:44:54.000000', 'consum', 0.0220, 'lps'),
	(521755, 129, '2014-02-01 00:44:55.000000', 'consum', 0.0211, 'lps'),
	(521756, 129, '2014-02-01 00:44:56.000000', 'consum', 0.0230, 'lps'),
	(521757, 129, '2014-02-01 00:44:57.000000', 'consum', 0.0220, 'lps'),
	(521758, 129, '2014-02-01 00:44:58.000000', 'consum', 0.0224, 'lps'),
	(521759, 129, '2014-02-01 00:44:59.000000', 'consum', 0.0227, 'lps'),
	(521760, 129, '2014-02-01 00:45:00.000000', 'consum', 0.0231, 'lps'),
	(521761, 129, '2014-02-01 00:45:01.000000', 'consum', 0.0222, 'lps'),
	(521762, 129, '2014-02-01 00:45:02.000000', 'consum', 0.0228, 'lps'),
	(521763, 129, '2014-02-01 00:45:03.000000', 'consum', 0.0222, 'lps'),
	(521764, 129, '2014-02-01 00:45:04.000000', 'consum', 0.0218, 'lps'),
	(521765, 129, '2014-02-01 00:45:05.000000', 'consum', 0.0213, 'lps'),
	(521766, 129, '2014-02-01 00:45:06.000000', 'consum', 0.0222, 'lps'),
	(521767, 129, '2014-02-01 00:45:07.000000', 'consum', 0.0220, 'lps'),
	(521768, 129, '2014-02-01 00:45:08.000000', 'consum', 0.0222, 'lps'),
	(521769, 129, '2014-02-01 00:45:09.000000', 'consum', 0.0220, 'lps'),
	(521770, 129, '2014-02-01 00:45:10.000000', 'consum', 0.0224, 'lps'),
	(521771, 129, '2014-02-01 00:45:11.000000', 'consum', 0.0230, 'lps'),
	(521772, 129, '2014-02-01 00:45:12.000000', 'consum', 0.0222, 'lps'),
	(521773, 129, '2014-02-01 00:45:13.000000', 'consum', 0.0210, 'lps'),
	(521774, 129, '2014-02-01 00:45:14.000000', 'consum', 0.0218, 'lps'),
	(521775, 129, '2014-02-01 00:45:15.000000', 'consum', 0.0229, 'lps'),
	(521776, 129, '2014-02-01 00:45:16.000000', 'consum', 0.0218, 'lps'),
	(521777, 129, '2014-02-01 00:45:17.000000', 'consum', 0.0214, 'lps'),
	(521778, 129, '2014-02-01 00:45:18.000000', 'consum', 0.0229, 'lps'),
	(521779, 129, '2014-02-01 00:45:19.000000', 'consum', 0.0229, 'lps'),
	(521780, 129, '2014-02-01 00:45:20.000000', 'consum', 0.0224, 'lps'),
	(521781, 129, '2014-02-01 00:45:21.000000', 'consum', 0.0225, 'lps'),
	(521782, 129, '2014-02-01 00:45:22.000000', 'consum', 0.0223, 'lps'),
	(521783, 129, '2014-02-01 00:45:23.000000', 'consum', 0.0228, 'lps'),
	(521784, 129, '2014-02-01 00:45:24.000000', 'consum', 0.0220, 'lps'),
	(521785, 129, '2014-02-01 00:45:25.000000', 'consum', 0.0228, 'lps'),
	(521786, 129, '2014-02-01 00:45:26.000000', 'consum', 0.0227, 'lps'),
	(521787, 129, '2014-02-01 00:45:27.000000', 'consum', 0.0220, 'lps'),
	(521788, 129, '2014-02-01 00:45:28.000000', 'consum', 0.0210, 'lps'),
	(521789, 129, '2014-02-01 00:45:29.000000', 'consum', 0.0222, 'lps'),
	(521790, 129, '2014-02-01 00:45:30.000000', 'consum', 0.0228, 'lps'),
	(521791, 129, '2014-02-01 00:45:31.000000', 'consum', 0.0222, 'lps'),
	(521792, 129, '2014-02-01 00:45:32.000000', 'consum', 0.0214, 'lps'),
	(521793, 129, '2014-02-01 00:45:33.000000', 'consum', 0.0216, 'lps'),
	(521794, 129, '2014-02-01 00:45:34.000000', 'consum', 0.0231, 'lps'),
	(521795, 129, '2014-02-01 00:45:35.000000', 'consum', 0.0229, 'lps'),
	(521796, 129, '2014-02-01 00:45:36.000000', 'consum', 0.0221, 'lps'),
	(521797, 129, '2014-02-01 00:45:37.000000', 'consum', 0.0230, 'lps'),
	(521798, 129, '2014-02-01 00:45:38.000000', 'consum', 0.0212, 'lps'),
	(521799, 129, '2014-02-01 00:45:39.000000', 'consum', 0.0225, 'lps'),
	(521800, 129, '2014-02-01 00:45:40.000000', 'consum', 0.0214, 'lps'),
	(521801, 129, '2014-02-01 00:45:41.000000', 'consum', 0.0210, 'lps'),
	(521802, 129, '2014-02-01 00:45:42.000000', 'consum', 0.0217, 'lps'),
	(521803, 129, '2014-02-01 00:45:43.000000', 'consum', 0.0226, 'lps'),
	(521804, 129, '2014-02-01 00:45:44.000000', 'consum', 0.0223, 'lps'),
	(521805, 129, '2014-02-01 00:45:45.000000', 'consum', 0.0231, 'lps'),
	(521806, 129, '2014-02-01 00:45:46.000000', 'consum', 0.0230, 'lps'),
	(521807, 129, '2014-02-01 00:45:47.000000', 'consum', 0.0225, 'lps'),
	(521808, 129, '2014-02-01 00:45:48.000000', 'consum', 0.0227, 'lps'),
	(521809, 129, '2014-02-01 00:45:49.000000', 'consum', 0.0228, 'lps'),
	(521810, 129, '2014-02-01 00:45:50.000000', 'consum', 0.0225, 'lps'),
	(521811, 129, '2014-02-01 00:45:51.000000', 'consum', 0.0213, 'lps'),
	(521812, 129, '2014-02-01 00:45:52.000000', 'consum', 0.0224, 'lps'),
	(521813, 129, '2014-02-01 00:45:53.000000', 'consum', 0.0228, 'lps'),
	(521814, 129, '2014-02-01 00:45:54.000000', 'consum', 0.0214, 'lps'),
	(521815, 129, '2014-02-01 00:45:55.000000', 'consum', 0.0222, 'lps'),
	(521816, 129, '2014-02-01 00:45:56.000000', 'consum', 0.0213, 'lps'),
	(521817, 129, '2014-02-01 00:45:57.000000', 'consum', 0.0210, 'lps'),
	(521818, 129, '2014-02-01 00:45:58.000000', 'consum', 0.0226, 'lps'),
	(521819, 129, '2014-02-01 00:45:59.000000', 'consum', 0.0225, 'lps'),
	(521820, 129, '2014-02-01 00:46:00.000000', 'consum', 0.0216, 'lps'),
	(521821, 129, '2014-02-01 00:46:01.000000', 'consum', 0.0216, 'lps'),
	(521822, 129, '2014-02-01 00:46:02.000000', 'consum', 0.0222, 'lps'),
	(521823, 129, '2014-02-01 00:46:03.000000', 'consum', 0.0230, 'lps'),
	(521824, 129, '2014-02-01 00:46:04.000000', 'consum', 0.0229, 'lps'),
	(521825, 129, '2014-02-01 00:46:05.000000', 'consum', 0.0227, 'lps'),
	(521826, 129, '2014-02-01 00:46:06.000000', 'consum', 0.0215, 'lps'),
	(521827, 129, '2014-02-01 00:46:07.000000', 'consum', 0.0230, 'lps'),
	(521828, 129, '2014-02-01 00:46:08.000000', 'consum', 0.0229, 'lps'),
	(521829, 129, '2014-02-01 00:46:09.000000', 'consum', 0.0224, 'lps'),
	(521830, 129, '2014-02-01 00:46:10.000000', 'consum', 0.0224, 'lps'),
	(521831, 129, '2014-02-01 00:46:11.000000', 'consum', 0.0216, 'lps'),
	(521832, 129, '2014-02-01 00:46:12.000000', 'consum', 0.0219, 'lps'),
	(521833, 129, '2014-02-01 00:46:13.000000', 'consum', 0.0215, 'lps'),
	(521834, 129, '2014-02-01 00:46:14.000000', 'consum', 0.0211, 'lps'),
	(521835, 129, '2014-02-01 00:46:15.000000', 'consum', 0.0221, 'lps'),
	(521836, 129, '2014-02-01 00:46:16.000000', 'consum', 0.0219, 'lps'),
	(521837, 129, '2014-02-01 00:46:17.000000', 'consum', 0.0222, 'lps'),
	(521838, 129, '2014-02-01 00:46:18.000000', 'consum', 0.0224, 'lps'),
	(521839, 129, '2014-02-01 00:46:19.000000', 'consum', 0.0219, 'lps'),
	(521840, 129, '2014-02-01 00:46:20.000000', 'consum', 0.0216, 'lps'),
	(521841, 129, '2014-02-01 00:46:21.000000', 'consum', 0.0211, 'lps'),
	(521842, 129, '2014-02-01 00:46:22.000000', 'consum', 0.0220, 'lps'),
	(521843, 129, '2014-02-01 00:46:23.000000', 'consum', 0.0213, 'lps'),
	(521844, 129, '2014-02-01 00:46:24.000000', 'consum', 0.0217, 'lps'),
	(521845, 129, '2014-02-01 00:46:25.000000', 'consum', 0.0216, 'lps'),
	(521846, 129, '2014-02-01 00:46:26.000000', 'consum', 0.0219, 'lps'),
	(521847, 129, '2014-02-01 00:46:27.000000', 'consum', 0.0216, 'lps'),
	(521848, 129, '2014-02-01 00:46:28.000000', 'consum', 0.0214, 'lps'),
	(521849, 129, '2014-02-01 00:46:29.000000', 'consum', 0.0210, 'lps'),
	(521850, 129, '2014-02-01 00:46:30.000000', 'consum', 0.0222, 'lps'),
	(521851, 129, '2014-02-01 00:46:31.000000', 'consum', 0.0226, 'lps'),
	(521852, 129, '2014-02-01 00:46:32.000000', 'consum', 0.0212, 'lps'),
	(521853, 129, '2014-02-01 00:46:33.000000', 'consum', 0.0217, 'lps'),
	(521854, 129, '2014-02-01 00:46:34.000000', 'consum', 0.0218, 'lps'),
	(521855, 129, '2014-02-01 00:46:35.000000', 'consum', 0.0230, 'lps'),
	(521856, 129, '2014-02-01 00:46:36.000000', 'consum', 0.0220, 'lps'),
	(521857, 129, '2014-02-01 00:46:37.000000', 'consum', 0.0220, 'lps'),
	(521858, 129, '2014-02-01 00:46:38.000000', 'consum', 0.0211, 'lps'),
	(521859, 129, '2014-02-01 00:46:39.000000', 'consum', 0.0230, 'lps'),
	(521860, 129, '2014-02-01 00:46:40.000000', 'consum', 0.0218, 'lps'),
	(521861, 129, '2014-02-01 00:46:41.000000', 'consum', 0.0212, 'lps'),
	(521862, 129, '2014-02-01 00:46:42.000000', 'consum', 0.0220, 'lps'),
	(521863, 129, '2014-02-01 00:46:43.000000', 'consum', 0.0211, 'lps'),
	(521864, 129, '2014-02-01 00:46:44.000000', 'consum', 0.0229, 'lps'),
	(521865, 129, '2014-02-01 00:46:45.000000', 'consum', 0.0213, 'lps'),
	(521866, 129, '2014-02-01 00:46:46.000000', 'consum', 0.0212, 'lps'),
	(521867, 129, '2014-02-01 00:46:47.000000', 'consum', 0.0214, 'lps'),
	(521868, 129, '2014-02-01 00:46:48.000000', 'consum', 0.0223, 'lps'),
	(521869, 129, '2014-02-01 00:46:49.000000', 'consum', 0.0221, 'lps'),
	(521870, 129, '2014-02-01 00:46:50.000000', 'consum', 0.0224, 'lps'),
	(521871, 129, '2014-02-01 00:46:51.000000', 'consum', 0.0226, 'lps'),
	(521872, 129, '2014-02-01 00:46:52.000000', 'consum', 0.0226, 'lps'),
	(521873, 129, '2014-02-01 00:46:53.000000', 'consum', 0.0219, 'lps'),
	(521874, 129, '2014-02-01 00:46:54.000000', 'consum', 0.0211, 'lps'),
	(521875, 129, '2014-02-01 00:46:55.000000', 'consum', 0.0230, 'lps'),
	(521876, 129, '2014-02-01 00:46:56.000000', 'consum', 0.0219, 'lps'),
	(521877, 129, '2014-02-01 00:46:57.000000', 'consum', 0.0219, 'lps'),
	(521878, 129, '2014-02-01 00:46:58.000000', 'consum', 0.0229, 'lps'),
	(521879, 129, '2014-02-01 00:46:59.000000', 'consum', 0.0213, 'lps'),
	(521880, 129, '2014-02-01 00:47:00.000000', 'consum', 0.0214, 'lps'),
	(521881, 129, '2014-02-01 00:47:01.000000', 'consum', 0.0218, 'lps'),
	(521882, 129, '2014-02-01 00:47:02.000000', 'consum', 0.0220, 'lps'),
	(521883, 129, '2014-02-01 00:47:03.000000', 'consum', 0.0212, 'lps'),
	(521884, 129, '2014-02-01 00:47:04.000000', 'consum', 0.0212, 'lps'),
	(521885, 129, '2014-02-01 00:47:05.000000', 'consum', 0.0215, 'lps'),
	(521886, 129, '2014-02-01 00:47:06.000000', 'consum', 0.0231, 'lps'),
	(521887, 129, '2014-02-01 00:47:07.000000', 'consum', 0.0212, 'lps'),
	(521888, 129, '2014-02-01 00:47:08.000000', 'consum', 0.0224, 'lps'),
	(521889, 129, '2014-02-01 00:47:09.000000', 'consum', 0.0230, 'lps'),
	(521890, 129, '2014-02-01 00:47:10.000000', 'consum', 0.0225, 'lps'),
	(521891, 129, '2014-02-01 00:47:11.000000', 'consum', 0.0225, 'lps'),
	(521892, 129, '2014-02-01 00:47:12.000000', 'consum', 0.0220, 'lps'),
	(521893, 129, '2014-02-01 00:47:13.000000', 'consum', 0.0216, 'lps'),
	(521894, 129, '2014-02-01 00:47:14.000000', 'consum', 0.0230, 'lps'),
	(521895, 129, '2014-02-01 00:47:15.000000', 'consum', 0.0228, 'lps'),
	(521896, 129, '2014-02-01 00:47:16.000000', 'consum', 0.0217, 'lps'),
	(521897, 129, '2014-02-01 00:47:17.000000', 'consum', 0.0213, 'lps'),
	(521898, 129, '2014-02-01 00:47:18.000000', 'consum', 0.0228, 'lps'),
	(521899, 129, '2014-02-01 00:47:19.000000', 'consum', 0.0224, 'lps'),
	(521900, 129, '2014-02-01 00:47:20.000000', 'consum', 0.0226, 'lps'),
	(521901, 129, '2014-02-01 00:47:21.000000', 'consum', 0.0226, 'lps'),
	(521902, 129, '2014-02-01 00:47:22.000000', 'consum', 0.0220, 'lps'),
	(521903, 129, '2014-02-01 00:47:23.000000', 'consum', 0.0214, 'lps'),
	(521904, 129, '2014-02-01 00:47:24.000000', 'consum', 0.0223, 'lps'),
	(521905, 129, '2014-02-01 00:47:25.000000', 'consum', 0.0220, 'lps'),
	(521906, 129, '2014-02-01 00:47:26.000000', 'consum', 0.0221, 'lps'),
	(521907, 129, '2014-02-01 00:47:27.000000', 'consum', 0.0213, 'lps'),
	(521908, 129, '2014-02-01 00:47:28.000000', 'consum', 0.0214, 'lps'),
	(521909, 129, '2014-02-01 00:47:29.000000', 'consum', 0.0223, 'lps'),
	(521910, 129, '2014-02-01 00:47:30.000000', 'consum', 0.0220, 'lps'),
	(521911, 129, '2014-02-01 00:47:31.000000', 'consum', 0.0222, 'lps'),
	(521912, 129, '2014-02-01 00:47:32.000000', 'consum', 0.0218, 'lps'),
	(521913, 129, '2014-02-01 00:47:33.000000', 'consum', 0.0215, 'lps'),
	(521914, 129, '2014-02-01 00:47:34.000000', 'consum', 0.0213, 'lps'),
	(521915, 129, '2014-02-01 00:47:35.000000', 'consum', 0.0231, 'lps'),
	(521916, 129, '2014-02-01 00:47:36.000000', 'consum', 0.0219, 'lps'),
	(521917, 129, '2014-02-01 00:47:37.000000', 'consum', 0.0212, 'lps'),
	(521918, 129, '2014-02-01 00:47:38.000000', 'consum', 0.0217, 'lps'),
	(521919, 129, '2014-02-01 00:47:39.000000', 'consum', 0.0219, 'lps'),
	(521920, 129, '2014-02-01 00:47:40.000000', 'consum', 0.0211, 'lps'),
	(521921, 129, '2014-02-01 00:47:41.000000', 'consum', 0.0210, 'lps'),
	(521922, 129, '2014-02-01 00:47:42.000000', 'consum', 0.0230, 'lps'),
	(521923, 129, '2014-02-01 00:47:43.000000', 'consum', 0.0222, 'lps'),
	(521924, 129, '2014-02-01 00:47:44.000000', 'consum', 0.0210, 'lps'),
	(521925, 129, '2014-02-01 00:47:45.000000', 'consum', 0.0220, 'lps'),
	(521926, 129, '2014-02-01 00:47:46.000000', 'consum', 0.0216, 'lps'),
	(521927, 129, '2014-02-01 00:47:47.000000', 'consum', 0.0231, 'lps'),
	(521928, 129, '2014-02-01 00:47:48.000000', 'consum', 0.0210, 'lps'),
	(521929, 129, '2014-02-01 00:47:49.000000', 'consum', 0.0215, 'lps'),
	(521930, 129, '2014-02-01 00:47:50.000000', 'consum', 0.0212, 'lps'),
	(521931, 129, '2014-02-01 00:47:51.000000', 'consum', 0.0228, 'lps'),
	(521932, 129, '2014-02-01 00:47:52.000000', 'consum', 0.0231, 'lps'),
	(521933, 129, '2014-02-01 00:47:53.000000', 'consum', 0.0214, 'lps'),
	(521934, 129, '2014-02-01 00:47:54.000000', 'consum', 0.0213, 'lps'),
	(521935, 129, '2014-02-01 00:47:55.000000', 'consum', 0.0212, 'lps'),
	(521936, 129, '2014-02-01 00:47:56.000000', 'consum', 0.0210, 'lps'),
	(521937, 129, '2014-02-01 00:47:57.000000', 'consum', 0.0230, 'lps'),
	(521938, 129, '2014-02-01 00:47:58.000000', 'consum', 0.0222, 'lps'),
	(521939, 129, '2014-02-01 00:47:59.000000', 'consum', 0.0210, 'lps'),
	(521940, 129, '2014-02-01 00:48:00.000000', 'consum', 0.0217, 'lps'),
	(521941, 129, '2014-02-01 00:48:01.000000', 'consum', 0.0225, 'lps'),
	(521942, 129, '2014-02-01 00:48:02.000000', 'consum', 0.0219, 'lps'),
	(521943, 129, '2014-02-01 00:48:03.000000', 'consum', 0.0210, 'lps'),
	(521944, 129, '2014-02-01 00:48:04.000000', 'consum', 0.0227, 'lps'),
	(521945, 129, '2014-02-01 00:48:05.000000', 'consum', 0.0229, 'lps'),
	(521946, 129, '2014-02-01 00:48:06.000000', 'consum', 0.0212, 'lps'),
	(521947, 129, '2014-02-01 00:48:07.000000', 'consum', 0.0230, 'lps'),
	(521948, 129, '2014-02-01 00:48:08.000000', 'consum', 0.0214, 'lps'),
	(521949, 129, '2014-02-01 00:48:09.000000', 'consum', 0.0216, 'lps'),
	(521950, 129, '2014-02-01 00:48:10.000000', 'consum', 0.0230, 'lps'),
	(521951, 129, '2014-02-01 00:48:11.000000', 'consum', 0.0227, 'lps'),
	(521952, 129, '2014-02-01 00:48:12.000000', 'consum', 0.0211, 'lps'),
	(521953, 129, '2014-02-01 00:48:13.000000', 'consum', 0.0211, 'lps'),
	(521954, 129, '2014-02-01 00:48:14.000000', 'consum', 0.0211, 'lps'),
	(521955, 129, '2014-02-01 00:48:15.000000', 'consum', 0.0214, 'lps'),
	(521956, 129, '2014-02-01 00:48:16.000000', 'consum', 0.0227, 'lps'),
	(521957, 129, '2014-02-01 00:48:17.000000', 'consum', 0.0218, 'lps'),
	(521958, 129, '2014-02-01 00:48:18.000000', 'consum', 0.0220, 'lps'),
	(521959, 129, '2014-02-01 00:48:19.000000', 'consum', 0.0217, 'lps'),
	(521960, 129, '2014-02-01 00:48:20.000000', 'consum', 0.0214, 'lps'),
	(521961, 129, '2014-02-01 00:48:21.000000', 'consum', 0.0211, 'lps'),
	(521962, 129, '2014-02-01 00:48:22.000000', 'consum', 0.0226, 'lps'),
	(521963, 129, '2014-02-01 00:48:23.000000', 'consum', 0.0222, 'lps'),
	(521964, 129, '2014-02-01 00:48:24.000000', 'consum', 0.0223, 'lps'),
	(521965, 129, '2014-02-01 00:48:25.000000', 'consum', 0.0218, 'lps'),
	(521966, 129, '2014-02-01 00:48:26.000000', 'consum', 0.0210, 'lps'),
	(521967, 129, '2014-02-01 00:48:27.000000', 'consum', 0.0229, 'lps'),
	(521968, 129, '2014-02-01 00:48:28.000000', 'consum', 0.0220, 'lps'),
	(521969, 129, '2014-02-01 00:48:29.000000', 'consum', 0.0223, 'lps'),
	(521970, 129, '2014-02-01 00:48:30.000000', 'consum', 0.0223, 'lps'),
	(521971, 129, '2014-02-01 00:48:31.000000', 'consum', 0.0216, 'lps'),
	(521972, 129, '2014-02-01 00:48:32.000000', 'consum', 0.0223, 'lps'),
	(521973, 129, '2014-02-01 00:48:33.000000', 'consum', 0.0213, 'lps'),
	(521974, 129, '2014-02-01 00:48:34.000000', 'consum', 0.0210, 'lps'),
	(521975, 129, '2014-02-01 00:48:35.000000', 'consum', 0.0221, 'lps'),
	(521976, 129, '2014-02-01 00:48:36.000000', 'consum', 0.0222, 'lps'),
	(521977, 129, '2014-02-01 00:48:37.000000', 'consum', 0.0217, 'lps'),
	(521978, 129, '2014-02-01 00:48:38.000000', 'consum', 0.0229, 'lps'),
	(521979, 129, '2014-02-01 00:48:39.000000', 'consum', 0.0220, 'lps'),
	(521980, 129, '2014-02-01 00:48:40.000000', 'consum', 0.0227, 'lps'),
	(521981, 129, '2014-02-01 00:48:41.000000', 'consum', 0.0222, 'lps'),
	(521982, 129, '2014-02-01 00:48:42.000000', 'consum', 0.0217, 'lps'),
	(521983, 129, '2014-02-01 00:48:43.000000', 'consum', 0.0210, 'lps'),
	(521984, 129, '2014-02-01 00:48:44.000000', 'consum', 0.0211, 'lps'),
	(521985, 129, '2014-02-01 00:48:45.000000', 'consum', 0.0216, 'lps'),
	(521986, 129, '2014-02-01 00:48:46.000000', 'consum', 0.0216, 'lps'),
	(521987, 129, '2014-02-01 00:48:47.000000', 'consum', 0.0220, 'lps'),
	(521988, 129, '2014-02-01 00:48:48.000000', 'consum', 0.0223, 'lps'),
	(521989, 129, '2014-02-01 00:48:49.000000', 'consum', 0.0222, 'lps'),
	(521990, 129, '2014-02-01 00:48:50.000000', 'consum', 0.0211, 'lps'),
	(521991, 129, '2014-02-01 00:48:51.000000', 'consum', 0.0223, 'lps'),
	(521992, 129, '2014-02-01 00:48:52.000000', 'consum', 0.0228, 'lps'),
	(521993, 129, '2014-02-01 00:48:53.000000', 'consum', 0.0218, 'lps'),
	(521994, 129, '2014-02-01 00:48:54.000000', 'consum', 0.0218, 'lps'),
	(521995, 129, '2014-02-01 00:48:55.000000', 'consum', 0.0225, 'lps'),
	(521996, 129, '2014-02-01 00:48:56.000000', 'consum', 0.0217, 'lps'),
	(521997, 129, '2014-02-01 00:48:57.000000', 'consum', 0.0225, 'lps'),
	(521998, 129, '2014-02-01 00:48:58.000000', 'consum', 0.0218, 'lps'),
	(521999, 129, '2014-02-01 00:48:59.000000', 'consum', 0.0227, 'lps'),
	(522000, 129, '2014-02-01 00:49:00.000000', 'consum', 0.0229, 'lps'),
	(522001, 129, '2014-02-01 00:49:01.000000', 'consum', 0.0210, 'lps'),
	(522002, 129, '2014-02-01 00:49:02.000000', 'consum', 0.0221, 'lps'),
	(522003, 129, '2014-02-01 00:49:03.000000', 'consum', 0.0223, 'lps'),
	(522004, 129, '2014-02-01 00:49:04.000000', 'consum', 0.0217, 'lps'),
	(522005, 129, '2014-02-01 00:49:05.000000', 'consum', 0.0231, 'lps'),
	(522006, 129, '2014-02-01 00:49:06.000000', 'consum', 0.0229, 'lps'),
	(522007, 129, '2014-02-01 00:49:07.000000', 'consum', 0.0219, 'lps'),
	(522008, 129, '2014-02-01 00:49:08.000000', 'consum', 0.0219, 'lps'),
	(522009, 129, '2014-02-01 00:49:09.000000', 'consum', 0.0229, 'lps'),
	(522010, 129, '2014-02-01 00:49:10.000000', 'consum', 0.0214, 'lps'),
	(522011, 129, '2014-02-01 00:49:11.000000', 'consum', 0.0217, 'lps'),
	(522012, 129, '2014-02-01 00:49:12.000000', 'consum', 0.0210, 'lps'),
	(522013, 129, '2014-02-01 00:49:13.000000', 'consum', 0.0214, 'lps'),
	(522014, 129, '2014-02-01 00:49:14.000000', 'consum', 0.0227, 'lps'),
	(522015, 129, '2014-02-01 00:49:15.000000', 'consum', 0.0221, 'lps'),
	(522016, 129, '2014-02-01 00:49:16.000000', 'consum', 0.0211, 'lps'),
	(522017, 129, '2014-02-01 00:49:17.000000', 'consum', 0.0230, 'lps'),
	(522018, 129, '2014-02-01 00:49:18.000000', 'consum', 0.0216, 'lps'),
	(522019, 129, '2014-02-01 00:49:19.000000', 'consum', 0.0226, 'lps'),
	(522020, 129, '2014-02-01 00:49:20.000000', 'consum', 0.0230, 'lps'),
	(522021, 129, '2014-02-01 00:49:21.000000', 'consum', 0.0217, 'lps'),
	(522022, 129, '2014-02-01 00:49:22.000000', 'consum', 0.0229, 'lps'),
	(522023, 129, '2014-02-01 00:49:23.000000', 'consum', 0.0219, 'lps'),
	(522024, 129, '2014-02-01 00:49:24.000000', 'consum', 0.0220, 'lps'),
	(522025, 129, '2014-02-01 00:49:25.000000', 'consum', 0.0213, 'lps'),
	(522026, 129, '2014-02-01 00:49:26.000000', 'consum', 0.0216, 'lps'),
	(522027, 129, '2014-02-01 00:49:27.000000', 'consum', 0.0210, 'lps'),
	(522028, 129, '2014-02-01 00:49:28.000000', 'consum', 0.0215, 'lps'),
	(522029, 129, '2014-02-01 00:49:29.000000', 'consum', 0.0215, 'lps'),
	(522030, 129, '2014-02-01 00:49:30.000000', 'consum', 0.0218, 'lps'),
	(522031, 129, '2014-02-01 00:49:31.000000', 'consum', 0.0214, 'lps'),
	(522032, 129, '2014-02-01 00:49:32.000000', 'consum', 0.0229, 'lps'),
	(522033, 129, '2014-02-01 00:49:33.000000', 'consum', 0.0228, 'lps'),
	(522034, 129, '2014-02-01 00:49:34.000000', 'consum', 0.0222, 'lps'),
	(522035, 129, '2014-02-01 00:49:35.000000', 'consum', 0.0214, 'lps'),
	(522036, 129, '2014-02-01 00:49:36.000000', 'consum', 0.0219, 'lps'),
	(522037, 129, '2014-02-01 00:49:37.000000', 'consum', 0.0221, 'lps'),
	(522038, 129, '2014-02-01 00:49:38.000000', 'consum', 0.0217, 'lps'),
	(522039, 129, '2014-02-01 00:49:39.000000', 'consum', 0.0212, 'lps'),
	(522040, 129, '2014-02-01 00:49:40.000000', 'consum', 0.0223, 'lps'),
	(522041, 129, '2014-02-01 00:49:41.000000', 'consum', 0.0223, 'lps'),
	(522042, 129, '2014-02-01 00:49:42.000000', 'consum', 0.0214, 'lps'),
	(522043, 129, '2014-02-01 00:49:43.000000', 'consum', 0.0213, 'lps'),
	(522044, 129, '2014-02-01 00:49:44.000000', 'consum', 0.0215, 'lps'),
	(522045, 129, '2014-02-01 00:49:45.000000', 'consum', 0.0224, 'lps'),
	(522046, 129, '2014-02-01 00:49:46.000000', 'consum', 0.0224, 'lps'),
	(522047, 129, '2014-02-01 00:49:47.000000', 'consum', 0.0214, 'lps'),
	(522048, 129, '2014-02-01 00:49:48.000000', 'consum', 0.0212, 'lps'),
	(522049, 129, '2014-02-01 00:49:49.000000', 'consum', 0.0229, 'lps'),
	(522050, 129, '2014-02-01 00:49:50.000000', 'consum', 0.0214, 'lps'),
	(522051, 129, '2014-02-01 00:49:51.000000', 'consum', 0.0216, 'lps'),
	(522052, 129, '2014-02-01 00:49:52.000000', 'consum', 0.0230, 'lps'),
	(522053, 129, '2014-02-01 00:49:53.000000', 'consum', 0.0226, 'lps'),
	(522054, 129, '2014-02-01 00:49:54.000000', 'consum', 0.0230, 'lps'),
	(522055, 129, '2014-02-01 00:49:55.000000', 'consum', 0.0217, 'lps'),
	(522056, 129, '2014-02-01 00:49:56.000000', 'consum', 0.0210, 'lps'),
	(522057, 129, '2014-02-01 00:49:57.000000', 'consum', 0.0210, 'lps'),
	(522058, 129, '2014-02-01 00:49:58.000000', 'consum', 0.0210, 'lps'),
	(522059, 129, '2014-02-01 00:49:59.000000', 'consum', 0.0212, 'lps'),
	(522060, 129, '2014-02-01 00:50:00.000000', 'consum', 0.0220, 'lps'),
	(522061, 129, '2014-02-01 00:50:01.000000', 'consum', 0.0212, 'lps'),
	(522062, 129, '2014-02-01 00:50:02.000000', 'consum', 0.0210, 'lps'),
	(522063, 129, '2014-02-01 00:50:03.000000', 'consum', 0.0228, 'lps'),
	(522064, 129, '2014-02-01 00:50:04.000000', 'consum', 0.0214, 'lps'),
	(522065, 129, '2014-02-01 00:50:05.000000', 'consum', 0.0217, 'lps'),
	(522066, 129, '2014-02-01 00:50:06.000000', 'consum', 0.0214, 'lps'),
	(522067, 129, '2014-02-01 00:50:07.000000', 'consum', 0.0210, 'lps'),
	(522068, 129, '2014-02-01 00:50:08.000000', 'consum', 0.0218, 'lps'),
	(522069, 129, '2014-02-01 00:50:09.000000', 'consum', 0.0230, 'lps'),
	(522070, 129, '2014-02-01 00:50:10.000000', 'consum', 0.0221, 'lps'),
	(522071, 129, '2014-02-01 00:50:11.000000', 'consum', 0.0228, 'lps'),
	(522072, 129, '2014-02-01 00:50:12.000000', 'consum', 0.0223, 'lps'),
	(522073, 129, '2014-02-01 00:50:13.000000', 'consum', 0.0221, 'lps'),
	(522074, 129, '2014-02-01 00:50:14.000000', 'consum', 0.0228, 'lps'),
	(522075, 129, '2014-02-01 00:50:15.000000', 'consum', 0.0222, 'lps'),
	(522076, 129, '2014-02-01 00:50:16.000000', 'consum', 0.0215, 'lps'),
	(522077, 129, '2014-02-01 00:50:17.000000', 'consum', 0.0223, 'lps'),
	(522078, 129, '2014-02-01 00:50:18.000000', 'consum', 0.0214, 'lps'),
	(522079, 129, '2014-02-01 00:50:19.000000', 'consum', 0.0217, 'lps'),
	(522080, 129, '2014-02-01 00:50:20.000000', 'consum', 0.0210, 'lps'),
	(522081, 129, '2014-02-01 00:50:21.000000', 'consum', 0.0211, 'lps'),
	(522082, 129, '2014-02-01 00:50:22.000000', 'consum', 0.0214, 'lps'),
	(522083, 129, '2014-02-01 00:50:23.000000', 'consum', 0.0230, 'lps'),
	(522084, 129, '2014-02-01 00:50:24.000000', 'consum', 0.0211, 'lps'),
	(522085, 129, '2014-02-01 00:50:25.000000', 'consum', 0.0219, 'lps'),
	(522086, 129, '2014-02-01 00:50:26.000000', 'consum', 0.0211, 'lps'),
	(522087, 129, '2014-02-01 00:50:27.000000', 'consum', 0.0212, 'lps'),
	(522088, 129, '2014-02-01 00:50:28.000000', 'consum', 0.0214, 'lps'),
	(522089, 129, '2014-02-01 00:50:29.000000', 'consum', 0.0228, 'lps'),
	(522090, 129, '2014-02-01 00:50:30.000000', 'consum', 0.0219, 'lps'),
	(522091, 129, '2014-02-01 00:50:31.000000', 'consum', 0.0225, 'lps'),
	(522092, 129, '2014-02-01 00:50:32.000000', 'consum', 0.0213, 'lps'),
	(522093, 129, '2014-02-01 00:50:33.000000', 'consum', 0.0226, 'lps'),
	(522094, 129, '2014-02-01 00:50:34.000000', 'consum', 0.0214, 'lps'),
	(522095, 129, '2014-02-01 00:50:35.000000', 'consum', 0.0228, 'lps'),
	(522096, 129, '2014-02-01 00:50:36.000000', 'consum', 0.0223, 'lps'),
	(522097, 129, '2014-02-01 00:50:37.000000', 'consum', 0.0220, 'lps'),
	(522098, 129, '2014-02-01 00:50:38.000000', 'consum', 0.0220, 'lps'),
	(522099, 129, '2014-02-01 00:50:39.000000', 'consum', 0.0210, 'lps'),
	(522100, 129, '2014-02-01 00:50:40.000000', 'consum', 0.0223, 'lps'),
	(522101, 129, '2014-02-01 00:50:41.000000', 'consum', 0.0213, 'lps'),
	(522102, 129, '2014-02-01 00:50:42.000000', 'consum', 0.0227, 'lps'),
	(522103, 129, '2014-02-01 00:50:43.000000', 'consum', 0.0222, 'lps'),
	(522104, 129, '2014-02-01 00:50:44.000000', 'consum', 0.0219, 'lps'),
	(522105, 129, '2014-02-01 00:50:45.000000', 'consum', 0.0219, 'lps'),
	(522106, 129, '2014-02-01 00:50:46.000000', 'consum', 0.0231, 'lps'),
	(522107, 129, '2014-02-01 00:50:47.000000', 'consum', 0.0221, 'lps'),
	(522108, 129, '2014-02-01 00:50:48.000000', 'consum', 0.0226, 'lps'),
	(522109, 129, '2014-02-01 00:50:49.000000', 'consum', 0.0214, 'lps'),
	(522110, 129, '2014-02-01 00:50:50.000000', 'consum', 0.0224, 'lps'),
	(522111, 129, '2014-02-01 00:50:51.000000', 'consum', 0.0225, 'lps'),
	(522112, 129, '2014-02-01 00:50:52.000000', 'consum', 0.0221, 'lps'),
	(522113, 129, '2014-02-01 00:50:53.000000', 'consum', 0.0223, 'lps'),
	(522114, 129, '2014-02-01 00:50:54.000000', 'consum', 0.0218, 'lps'),
	(522115, 129, '2014-02-01 00:50:55.000000', 'consum', 0.0211, 'lps'),
	(522116, 129, '2014-02-01 00:50:56.000000', 'consum', 0.0215, 'lps'),
	(522117, 129, '2014-02-01 00:50:57.000000', 'consum', 0.0210, 'lps'),
	(522118, 129, '2014-02-01 00:50:58.000000', 'consum', 0.0217, 'lps'),
	(522119, 129, '2014-02-01 00:50:59.000000', 'consum', 0.0225, 'lps'),
	(522120, 129, '2014-02-01 00:51:00.000000', 'consum', 0.0219, 'lps'),
	(522121, 129, '2014-02-01 00:51:01.000000', 'consum', 0.0213, 'lps'),
	(522122, 129, '2014-02-01 00:51:02.000000', 'consum', 0.0218, 'lps'),
	(522123, 129, '2014-02-01 00:51:03.000000', 'consum', 0.0219, 'lps'),
	(522124, 129, '2014-02-01 00:51:04.000000', 'consum', 0.0210, 'lps'),
	(522125, 129, '2014-02-01 00:51:05.000000', 'consum', 0.0226, 'lps'),
	(522126, 129, '2014-02-01 00:51:06.000000', 'consum', 0.0227, 'lps'),
	(522127, 129, '2014-02-01 00:51:07.000000', 'consum', 0.0226, 'lps'),
	(522128, 129, '2014-02-01 00:51:08.000000', 'consum', 0.0216, 'lps'),
	(522129, 129, '2014-02-01 00:51:09.000000', 'consum', 0.0214, 'lps'),
	(522130, 129, '2014-02-01 00:51:10.000000', 'consum', 0.0214, 'lps'),
	(522131, 129, '2014-02-01 00:51:11.000000', 'consum', 0.0219, 'lps'),
	(522132, 129, '2014-02-01 00:51:12.000000', 'consum', 0.0219, 'lps'),
	(522133, 129, '2014-02-01 00:51:13.000000', 'consum', 0.0231, 'lps'),
	(522134, 129, '2014-02-01 00:51:14.000000', 'consum', 0.0223, 'lps'),
	(522135, 129, '2014-02-01 00:51:15.000000', 'consum', 0.0213, 'lps'),
	(522136, 129, '2014-02-01 00:51:16.000000', 'consum', 0.0229, 'lps'),
	(522137, 129, '2014-02-01 00:51:17.000000', 'consum', 0.0210, 'lps'),
	(522138, 129, '2014-02-01 00:51:18.000000', 'consum', 0.0218, 'lps'),
	(522139, 129, '2014-02-01 00:51:19.000000', 'consum', 0.0231, 'lps'),
	(522140, 129, '2014-02-01 00:51:20.000000', 'consum', 0.0224, 'lps'),
	(522141, 129, '2014-02-01 00:51:21.000000', 'consum', 0.0219, 'lps'),
	(522142, 129, '2014-02-01 00:51:22.000000', 'consum', 0.0213, 'lps'),
	(522143, 129, '2014-02-01 00:51:23.000000', 'consum', 0.0221, 'lps'),
	(522144, 129, '2014-02-01 00:51:24.000000', 'consum', 0.0214, 'lps'),
	(522145, 129, '2014-02-01 00:51:25.000000', 'consum', 0.0217, 'lps'),
	(522146, 129, '2014-02-01 00:51:26.000000', 'consum', 0.0211, 'lps'),
	(522147, 129, '2014-02-01 00:51:27.000000', 'consum', 0.0219, 'lps'),
	(522148, 129, '2014-02-01 00:51:28.000000', 'consum', 0.0227, 'lps'),
	(522149, 129, '2014-02-01 00:51:29.000000', 'consum', 0.0228, 'lps'),
	(522150, 129, '2014-02-01 00:51:30.000000', 'consum', 0.0226, 'lps'),
	(522151, 129, '2014-02-01 00:51:31.000000', 'consum', 0.0216, 'lps'),
	(522152, 129, '2014-02-01 00:51:32.000000', 'consum', 0.0214, 'lps'),
	(522153, 129, '2014-02-01 00:51:33.000000', 'consum', 0.0212, 'lps'),
	(522154, 129, '2014-02-01 00:51:34.000000', 'consum', 0.0229, 'lps'),
	(522155, 129, '2014-02-01 00:51:35.000000', 'consum', 0.0211, 'lps'),
	(522156, 129, '2014-02-01 00:51:36.000000', 'consum', 0.0228, 'lps'),
	(522157, 129, '2014-02-01 00:51:37.000000', 'consum', 0.0229, 'lps'),
	(522158, 129, '2014-02-01 00:51:38.000000', 'consum', 0.0229, 'lps'),
	(522159, 129, '2014-02-01 00:51:39.000000', 'consum', 0.0225, 'lps'),
	(522160, 129, '2014-02-01 00:51:40.000000', 'consum', 0.0231, 'lps'),
	(522161, 129, '2014-02-01 00:51:41.000000', 'consum', 0.0226, 'lps'),
	(522162, 129, '2014-02-01 00:51:42.000000', 'consum', 0.0226, 'lps'),
	(522163, 129, '2014-02-01 00:51:43.000000', 'consum', 0.0223, 'lps'),
	(522164, 129, '2014-02-01 00:51:44.000000', 'consum', 0.0227, 'lps'),
	(522165, 129, '2014-02-01 00:51:45.000000', 'consum', 0.0210, 'lps'),
	(522166, 129, '2014-02-01 00:51:46.000000', 'consum', 0.0228, 'lps'),
	(522167, 129, '2014-02-01 00:51:47.000000', 'consum', 0.0213, 'lps'),
	(522168, 129, '2014-02-01 00:51:48.000000', 'consum', 0.0215, 'lps'),
	(522169, 129, '2014-02-01 00:51:49.000000', 'consum', 0.0224, 'lps'),
	(522170, 129, '2014-02-01 00:51:50.000000', 'consum', 0.0225, 'lps'),
	(522171, 129, '2014-02-01 00:51:51.000000', 'consum', 0.0221, 'lps'),
	(522172, 129, '2014-02-01 00:51:52.000000', 'consum', 0.0219, 'lps'),
	(522173, 129, '2014-02-01 00:51:53.000000', 'consum', 0.0225, 'lps'),
	(522174, 129, '2014-02-01 00:51:54.000000', 'consum', 0.0211, 'lps'),
	(522175, 129, '2014-02-01 00:51:55.000000', 'consum', 0.0217, 'lps'),
	(522176, 129, '2014-02-01 00:51:56.000000', 'consum', 0.0219, 'lps'),
	(522177, 129, '2014-02-01 00:51:57.000000', 'consum', 0.0215, 'lps'),
	(522178, 129, '2014-02-01 00:51:58.000000', 'consum', 0.0228, 'lps'),
	(522179, 129, '2014-02-01 00:51:59.000000', 'consum', 0.0221, 'lps'),
	(522180, 129, '2014-02-01 00:52:00.000000', 'consum', 0.0211, 'lps'),
	(522181, 129, '2014-02-01 00:52:01.000000', 'consum', 0.0226, 'lps'),
	(522182, 129, '2014-02-01 00:52:02.000000', 'consum', 0.0220, 'lps'),
	(522183, 129, '2014-02-01 00:52:03.000000', 'consum', 0.0215, 'lps'),
	(522184, 129, '2014-02-01 00:52:04.000000', 'consum', 0.0226, 'lps'),
	(522185, 129, '2014-02-01 00:52:05.000000', 'consum', 0.0211, 'lps'),
	(522186, 129, '2014-02-01 00:52:06.000000', 'consum', 0.0213, 'lps'),
	(522187, 129, '2014-02-01 00:52:07.000000', 'consum', 0.0220, 'lps'),
	(522188, 129, '2014-02-01 00:52:08.000000', 'consum', 0.0229, 'lps'),
	(522189, 129, '2014-02-01 00:52:09.000000', 'consum', 0.0211, 'lps'),
	(522190, 129, '2014-02-01 00:52:10.000000', 'consum', 0.0224, 'lps'),
	(522191, 129, '2014-02-01 00:52:11.000000', 'consum', 0.0213, 'lps'),
	(522192, 129, '2014-02-01 00:52:12.000000', 'consum', 0.0227, 'lps'),
	(522193, 129, '2014-02-01 00:52:13.000000', 'consum', 0.0220, 'lps'),
	(522194, 129, '2014-02-01 00:52:14.000000', 'consum', 0.0210, 'lps'),
	(522195, 129, '2014-02-01 00:52:15.000000', 'consum', 0.0223, 'lps'),
	(522196, 129, '2014-02-01 00:52:16.000000', 'consum', 0.0211, 'lps'),
	(522197, 129, '2014-02-01 00:52:17.000000', 'consum', 0.0221, 'lps'),
	(522198, 129, '2014-02-01 00:52:18.000000', 'consum', 0.0218, 'lps'),
	(522199, 129, '2014-02-01 00:52:19.000000', 'consum', 0.0217, 'lps'),
	(522200, 129, '2014-02-01 00:52:20.000000', 'consum', 0.0221, 'lps'),
	(522201, 129, '2014-02-01 00:52:21.000000', 'consum', 0.0225, 'lps'),
	(522202, 129, '2014-02-01 00:52:22.000000', 'consum', 0.0229, 'lps'),
	(522203, 129, '2014-02-01 00:52:23.000000', 'consum', 0.0214, 'lps'),
	(522204, 129, '2014-02-01 00:52:24.000000', 'consum', 0.0221, 'lps'),
	(522205, 129, '2014-02-01 00:52:25.000000', 'consum', 0.0210, 'lps'),
	(522206, 129, '2014-02-01 00:52:26.000000', 'consum', 0.0218, 'lps'),
	(522207, 129, '2014-02-01 00:52:27.000000', 'consum', 0.0231, 'lps'),
	(522208, 129, '2014-02-01 00:52:28.000000', 'consum', 0.0225, 'lps'),
	(522209, 129, '2014-02-01 00:52:29.000000', 'consum', 0.0224, 'lps'),
	(522210, 129, '2014-02-01 00:52:30.000000', 'consum', 0.0212, 'lps'),
	(522211, 129, '2014-02-01 00:52:31.000000', 'consum', 0.0223, 'lps'),
	(522212, 129, '2014-02-01 00:52:32.000000', 'consum', 0.0223, 'lps'),
	(522213, 129, '2014-02-01 00:52:33.000000', 'consum', 0.0218, 'lps'),
	(522214, 129, '2014-02-01 00:52:34.000000', 'consum', 0.0231, 'lps'),
	(522215, 129, '2014-02-01 00:52:35.000000', 'consum', 0.0227, 'lps'),
	(522216, 129, '2014-02-01 00:52:36.000000', 'consum', 0.0212, 'lps'),
	(522217, 129, '2014-02-01 00:52:37.000000', 'consum', 0.0212, 'lps'),
	(522218, 129, '2014-02-01 00:52:38.000000', 'consum', 0.0216, 'lps'),
	(522219, 129, '2014-02-01 00:52:39.000000', 'consum', 0.0210, 'lps'),
	(522220, 129, '2014-02-01 00:52:40.000000', 'consum', 0.0214, 'lps'),
	(522221, 129, '2014-02-01 00:52:41.000000', 'consum', 0.0210, 'lps'),
	(522222, 129, '2014-02-01 00:52:42.000000', 'consum', 0.0219, 'lps'),
	(522223, 129, '2014-02-01 00:52:43.000000', 'consum', 0.0213, 'lps'),
	(522224, 129, '2014-02-01 00:52:44.000000', 'consum', 0.0222, 'lps'),
	(522225, 129, '2014-02-01 00:52:45.000000', 'consum', 0.0215, 'lps'),
	(522226, 129, '2014-02-01 00:52:46.000000', 'consum', 0.0223, 'lps'),
	(522227, 129, '2014-02-01 00:52:47.000000', 'consum', 0.0217, 'lps'),
	(522228, 129, '2014-02-01 00:52:48.000000', 'consum', 0.0230, 'lps'),
	(522229, 129, '2014-02-01 00:52:49.000000', 'consum', 0.0222, 'lps'),
	(522230, 129, '2014-02-01 00:52:50.000000', 'consum', 0.0231, 'lps'),
	(522231, 129, '2014-02-01 00:52:51.000000', 'consum', 0.0215, 'lps'),
	(522232, 129, '2014-02-01 00:52:52.000000', 'consum', 0.0216, 'lps'),
	(522233, 129, '2014-02-01 00:52:53.000000', 'consum', 0.0227, 'lps'),
	(522234, 129, '2014-02-01 00:52:54.000000', 'consum', 0.0210, 'lps'),
	(522235, 129, '2014-02-01 00:52:55.000000', 'consum', 0.0227, 'lps'),
	(522236, 129, '2014-02-01 00:52:56.000000', 'consum', 0.0230, 'lps'),
	(522237, 129, '2014-02-01 00:52:57.000000', 'consum', 0.0213, 'lps'),
	(522238, 129, '2014-02-01 00:52:58.000000', 'consum', 0.0212, 'lps'),
	(522239, 129, '2014-02-01 00:52:59.000000', 'consum', 0.0231, 'lps'),
	(522240, 129, '2014-02-01 00:53:00.000000', 'consum', 0.0221, 'lps'),
	(522241, 129, '2014-02-01 00:53:01.000000', 'consum', 0.0224, 'lps'),
	(522242, 129, '2014-02-01 00:53:02.000000', 'consum', 0.0227, 'lps'),
	(522243, 129, '2014-02-01 00:53:03.000000', 'consum', 0.0211, 'lps'),
	(522244, 129, '2014-02-01 00:53:04.000000', 'consum', 0.0229, 'lps'),
	(522245, 129, '2014-02-01 00:53:05.000000', 'consum', 0.0213, 'lps'),
	(522246, 129, '2014-02-01 00:53:06.000000', 'consum', 0.0214, 'lps'),
	(522247, 129, '2014-02-01 00:53:07.000000', 'consum', 0.0222, 'lps'),
	(522248, 129, '2014-02-01 00:53:08.000000', 'consum', 0.0213, 'lps'),
	(522249, 129, '2014-02-01 00:53:09.000000', 'consum', 0.0211, 'lps'),
	(522250, 129, '2014-02-01 00:53:10.000000', 'consum', 0.0228, 'lps'),
	(522251, 129, '2014-02-01 00:53:11.000000', 'consum', 0.0210, 'lps'),
	(522252, 129, '2014-02-01 00:53:12.000000', 'consum', 0.0222, 'lps'),
	(522253, 129, '2014-02-01 00:53:13.000000', 'consum', 0.0228, 'lps'),
	(522254, 129, '2014-02-01 00:53:14.000000', 'consum', 0.0219, 'lps'),
	(522255, 129, '2014-02-01 00:53:15.000000', 'consum', 0.0222, 'lps'),
	(522256, 129, '2014-02-01 00:53:16.000000', 'consum', 0.0224, 'lps'),
	(522257, 129, '2014-02-01 00:53:17.000000', 'consum', 0.0221, 'lps'),
	(522258, 129, '2014-02-01 00:53:18.000000', 'consum', 0.0226, 'lps'),
	(522259, 129, '2014-02-01 00:53:19.000000', 'consum', 0.0212, 'lps'),
	(522260, 129, '2014-02-01 00:53:20.000000', 'consum', 0.0216, 'lps'),
	(522261, 129, '2014-02-01 00:53:21.000000', 'consum', 0.0214, 'lps'),
	(522262, 129, '2014-02-01 00:53:22.000000', 'consum', 0.0213, 'lps'),
	(522263, 129, '2014-02-01 00:53:23.000000', 'consum', 0.0215, 'lps'),
	(522264, 129, '2014-02-01 00:53:24.000000', 'consum', 0.0224, 'lps'),
	(522265, 129, '2014-02-01 00:53:25.000000', 'consum', 0.0221, 'lps'),
	(522266, 129, '2014-02-01 00:53:26.000000', 'consum', 0.0224, 'lps'),
	(522267, 129, '2014-02-01 00:53:27.000000', 'consum', 0.0227, 'lps'),
	(522268, 129, '2014-02-01 00:53:28.000000', 'consum', 0.0229, 'lps'),
	(522269, 129, '2014-02-01 00:53:29.000000', 'consum', 0.0211, 'lps'),
	(522270, 129, '2014-02-01 00:53:30.000000', 'consum', 0.0223, 'lps'),
	(522271, 129, '2014-02-01 00:53:31.000000', 'consum', 0.0229, 'lps'),
	(522272, 129, '2014-02-01 00:53:32.000000', 'consum', 0.0223, 'lps'),
	(522273, 129, '2014-02-01 00:53:33.000000', 'consum', 0.0220, 'lps'),
	(522274, 129, '2014-02-01 00:53:34.000000', 'consum', 0.0219, 'lps'),
	(522275, 129, '2014-02-01 00:53:35.000000', 'consum', 0.0226, 'lps'),
	(522276, 129, '2014-02-01 00:53:36.000000', 'consum', 0.0219, 'lps'),
	(522277, 129, '2014-02-01 00:53:37.000000', 'consum', 0.0230, 'lps'),
	(522278, 129, '2014-02-01 00:53:38.000000', 'consum', 0.0216, 'lps'),
	(522279, 129, '2014-02-01 00:53:39.000000', 'consum', 0.0227, 'lps'),
	(522280, 129, '2014-02-01 00:53:40.000000', 'consum', 0.0212, 'lps'),
	(522281, 129, '2014-02-01 00:53:41.000000', 'consum', 0.0211, 'lps'),
	(522282, 129, '2014-02-01 00:53:42.000000', 'consum', 0.0210, 'lps'),
	(522283, 129, '2014-02-01 00:53:43.000000', 'consum', 0.0228, 'lps'),
	(522284, 129, '2014-02-01 00:53:44.000000', 'consum', 0.0213, 'lps'),
	(522285, 129, '2014-02-01 00:53:45.000000', 'consum', 0.0216, 'lps'),
	(522286, 129, '2014-02-01 00:53:46.000000', 'consum', 0.0210, 'lps'),
	(522287, 129, '2014-02-01 00:53:47.000000', 'consum', 0.0215, 'lps'),
	(522288, 129, '2014-02-01 00:53:48.000000', 'consum', 0.0213, 'lps'),
	(522289, 129, '2014-02-01 00:53:49.000000', 'consum', 0.0231, 'lps'),
	(522290, 129, '2014-02-01 00:53:50.000000', 'consum', 0.0219, 'lps'),
	(522291, 129, '2014-02-01 00:53:51.000000', 'consum', 0.0214, 'lps'),
	(522292, 129, '2014-02-01 00:53:52.000000', 'consum', 0.0225, 'lps'),
	(522293, 129, '2014-02-01 00:53:53.000000', 'consum', 0.0231, 'lps'),
	(522294, 129, '2014-02-01 00:53:54.000000', 'consum', 0.0225, 'lps'),
	(522295, 129, '2014-02-01 00:53:55.000000', 'consum', 0.0224, 'lps'),
	(522296, 129, '2014-02-01 00:53:56.000000', 'consum', 0.0212, 'lps'),
	(522297, 129, '2014-02-01 00:53:57.000000', 'consum', 0.0225, 'lps'),
	(522298, 129, '2014-02-01 00:53:58.000000', 'consum', 0.0211, 'lps'),
	(522299, 129, '2014-02-01 00:53:59.000000', 'consum', 0.0217, 'lps'),
	(522300, 129, '2014-02-01 00:54:00.000000', 'consum', 0.0220, 'lps'),
	(522301, 129, '2014-02-01 00:54:01.000000', 'consum', 0.0216, 'lps'),
	(522302, 129, '2014-02-01 00:54:02.000000', 'consum', 0.0212, 'lps'),
	(522303, 129, '2014-02-01 00:54:03.000000', 'consum', 0.0223, 'lps'),
	(522304, 129, '2014-02-01 00:54:04.000000', 'consum', 0.0226, 'lps'),
	(522305, 129, '2014-02-01 00:54:05.000000', 'consum', 0.0231, 'lps'),
	(522306, 129, '2014-02-01 00:54:06.000000', 'consum', 0.0222, 'lps'),
	(522307, 129, '2014-02-01 00:54:07.000000', 'consum', 0.0231, 'lps'),
	(522308, 129, '2014-02-01 00:54:08.000000', 'consum', 0.0214, 'lps'),
	(522309, 129, '2014-02-01 00:54:09.000000', 'consum', 0.0212, 'lps'),
	(522310, 129, '2014-02-01 00:54:10.000000', 'consum', 0.0230, 'lps'),
	(522311, 129, '2014-02-01 00:54:11.000000', 'consum', 0.0216, 'lps'),
	(522312, 129, '2014-02-01 00:54:12.000000', 'consum', 0.0223, 'lps'),
	(522313, 129, '2014-02-01 00:54:13.000000', 'consum', 0.0214, 'lps'),
	(522314, 129, '2014-02-01 00:54:14.000000', 'consum', 0.0213, 'lps'),
	(522315, 129, '2014-02-01 00:54:15.000000', 'consum', 0.0215, 'lps'),
	(522316, 129, '2014-02-01 00:54:16.000000', 'consum', 0.0224, 'lps'),
	(522317, 129, '2014-02-01 00:54:17.000000', 'consum', 0.0223, 'lps'),
	(522318, 129, '2014-02-01 00:54:18.000000', 'consum', 0.0211, 'lps'),
	(522319, 129, '2014-02-01 00:54:19.000000', 'consum', 0.0222, 'lps'),
	(522320, 129, '2014-02-01 00:54:20.000000', 'consum', 0.0222, 'lps'),
	(522321, 129, '2014-02-01 00:54:21.000000', 'consum', 0.0215, 'lps'),
	(522322, 129, '2014-02-01 00:54:22.000000', 'consum', 0.0219, 'lps'),
	(522323, 129, '2014-02-01 00:54:23.000000', 'consum', 0.0221, 'lps'),
	(522324, 129, '2014-02-01 00:54:24.000000', 'consum', 0.0214, 'lps'),
	(522325, 129, '2014-02-01 00:54:25.000000', 'consum', 0.0219, 'lps'),
	(522326, 129, '2014-02-01 00:54:26.000000', 'consum', 0.0221, 'lps'),
	(522327, 129, '2014-02-01 00:54:27.000000', 'consum', 0.0219, 'lps'),
	(522328, 129, '2014-02-01 00:54:28.000000', 'consum', 0.0220, 'lps'),
	(522329, 129, '2014-02-01 00:54:29.000000', 'consum', 0.0211, 'lps'),
	(522330, 129, '2014-02-01 00:54:30.000000', 'consum', 0.0230, 'lps'),
	(522331, 130, '2014-02-01 00:00:00.000000', 'consum', 0.0227, 'lps'),
	(522332, 130, '2014-02-01 00:00:01.000000', 'consum', 0.0220, 'lps'),
	(522333, 130, '2014-02-01 00:00:02.000000', 'consum', 0.0225, 'lps'),
	(522334, 130, '2014-02-01 00:00:03.000000', 'consum', 0.0220, 'lps'),
	(522335, 130, '2014-02-01 00:00:04.000000', 'consum', 0.0216, 'lps'),
	(522336, 130, '2014-02-01 00:00:05.000000', 'consum', 0.0210, 'lps'),
	(522337, 130, '2014-02-01 00:00:06.000000', 'consum', 0.0227, 'lps'),
	(522338, 130, '2014-02-01 00:00:07.000000', 'consum', 0.0225, 'lps'),
	(522339, 130, '2014-02-01 00:00:08.000000', 'consum', 0.0218, 'lps'),
	(522340, 130, '2014-02-01 00:00:09.000000', 'consum', 0.0223, 'lps'),
	(522341, 130, '2014-02-01 00:00:10.000000', 'consum', 0.0217, 'lps'),
	(522342, 130, '2014-02-01 00:00:11.000000', 'consum', 0.0221, 'lps'),
	(522343, 130, '2014-02-01 00:00:12.000000', 'consum', 0.0212, 'lps'),
	(522344, 130, '2014-02-01 00:00:13.000000', 'consum', 0.0221, 'lps'),
	(522345, 130, '2014-02-01 00:00:14.000000', 'consum', 0.0226, 'lps'),
	(522346, 130, '2014-02-01 00:00:15.000000', 'consum', 0.0219, 'lps'),
	(522347, 130, '2014-02-01 00:00:16.000000', 'consum', 0.0210, 'lps'),
	(522348, 130, '2014-02-01 00:00:17.000000', 'consum', 0.0217, 'lps'),
	(522349, 130, '2014-02-01 00:00:18.000000', 'consum', 0.0227, 'lps'),
	(522350, 130, '2014-02-01 00:00:19.000000', 'consum', 0.0220, 'lps'),
	(522351, 130, '2014-02-01 00:00:20.000000', 'consum', 0.0210, 'lps'),
	(522352, 130, '2014-02-01 00:00:21.000000', 'consum', 0.0217, 'lps'),
	(522353, 130, '2014-02-01 00:00:22.000000', 'consum', 0.0211, 'lps'),
	(522354, 130, '2014-02-01 00:00:23.000000', 'consum', 0.0210, 'lps'),
	(522355, 130, '2014-02-01 00:00:24.000000', 'consum', 0.0227, 'lps'),
	(522356, 130, '2014-02-01 00:00:25.000000', 'consum', 0.0224, 'lps'),
	(522357, 130, '2014-02-01 00:00:26.000000', 'consum', 0.0213, 'lps'),
	(522358, 130, '2014-02-01 00:00:27.000000', 'consum', 0.0216, 'lps'),
	(522359, 130, '2014-02-01 00:00:28.000000', 'consum', 0.0215, 'lps'),
	(522360, 130, '2014-02-01 00:00:29.000000', 'consum', 0.0217, 'lps'),
	(522361, 130, '2014-02-01 00:00:30.000000', 'consum', 0.0213, 'lps'),
	(522362, 130, '2014-02-01 00:00:31.000000', 'consum', 0.0222, 'lps'),
	(522363, 130, '2014-02-01 00:00:32.000000', 'consum', 0.0227, 'lps'),
	(522364, 130, '2014-02-01 00:00:33.000000', 'consum', 0.0224, 'lps'),
	(522365, 130, '2014-02-01 00:00:34.000000', 'consum', 0.0210, 'lps'),
	(522366, 130, '2014-02-01 00:00:35.000000', 'consum', 0.0221, 'lps'),
	(522367, 130, '2014-02-01 00:00:36.000000', 'consum', 0.0214, 'lps'),
	(522368, 130, '2014-02-01 00:00:37.000000', 'consum', 0.0213, 'lps'),
	(522369, 130, '2014-02-01 00:00:38.000000', 'consum', 0.0217, 'lps'),
	(522370, 130, '2014-02-01 00:00:39.000000', 'consum', 0.0215, 'lps'),
	(522371, 130, '2014-02-01 00:00:40.000000', 'consum', 0.0215, 'lps'),
	(522372, 130, '2014-02-01 00:00:41.000000', 'consum', 0.0221, 'lps'),
	(522373, 130, '2014-02-01 00:00:42.000000', 'consum', 0.0217, 'lps'),
	(522374, 130, '2014-02-01 00:00:43.000000', 'consum', 0.0227, 'lps'),
	(522375, 130, '2014-02-01 00:00:44.000000', 'consum', 0.0221, 'lps'),
	(522376, 130, '2014-02-01 00:00:45.000000', 'consum', 0.0215, 'lps'),
	(522377, 130, '2014-02-01 00:00:46.000000', 'consum', 0.0222, 'lps'),
	(522378, 130, '2014-02-01 00:00:47.000000', 'consum', 0.0218, 'lps'),
	(522379, 130, '2014-02-01 00:00:48.000000', 'consum', 0.0217, 'lps'),
	(522380, 130, '2014-02-01 00:00:49.000000', 'consum', 0.0219, 'lps'),
	(522381, 130, '2014-02-01 00:00:50.000000', 'consum', 0.0219, 'lps'),
	(522382, 130, '2014-02-01 00:00:51.000000', 'consum', 0.0225, 'lps'),
	(522383, 130, '2014-02-01 00:00:52.000000', 'consum', 0.0225, 'lps'),
	(522384, 130, '2014-02-01 00:00:53.000000', 'consum', 0.0223, 'lps'),
	(522385, 130, '2014-02-01 00:00:54.000000', 'consum', 0.0210, 'lps'),
	(522386, 130, '2014-02-01 00:00:55.000000', 'consum', 0.0225, 'lps'),
	(522387, 130, '2014-02-01 00:00:56.000000', 'consum', 0.0216, 'lps'),
	(522388, 130, '2014-02-01 00:00:57.000000', 'consum', 0.0213, 'lps'),
	(522389, 130, '2014-02-01 00:00:58.000000', 'consum', 0.0224, 'lps'),
	(522390, 130, '2014-02-01 00:00:59.000000', 'consum', 0.0220, 'lps'),
	(522391, 130, '2014-02-01 00:01:00.000000', 'consum', 0.0217, 'lps'),
	(522392, 130, '2014-02-01 00:01:01.000000', 'consum', 0.0214, 'lps'),
	(522393, 130, '2014-02-01 00:01:02.000000', 'consum', 0.0211, 'lps'),
	(522394, 130, '2014-02-01 00:01:03.000000', 'consum', 0.0222, 'lps'),
	(522395, 130, '2014-02-01 00:01:04.000000', 'consum', 0.0212, 'lps'),
	(522396, 130, '2014-02-01 00:01:05.000000', 'consum', 0.0221, 'lps'),
	(522397, 130, '2014-02-01 00:01:06.000000', 'consum', 0.0226, 'lps'),
	(522398, 130, '2014-02-01 00:01:07.000000', 'consum', 0.0218, 'lps'),
	(522399, 130, '2014-02-01 00:01:08.000000', 'consum', 0.0223, 'lps'),
	(522400, 130, '2014-02-01 00:01:09.000000', 'consum', 0.0214, 'lps'),
	(522401, 130, '2014-02-01 00:01:10.000000', 'consum', 0.0227, 'lps'),
	(522402, 130, '2014-02-01 00:01:11.000000', 'consum', 0.0213, 'lps'),
	(522403, 130, '2014-02-01 00:01:12.000000', 'consum', 0.0226, 'lps'),
	(522404, 130, '2014-02-01 00:01:13.000000', 'consum', 0.0211, 'lps'),
	(522405, 130, '2014-02-01 00:01:14.000000', 'consum', 0.0219, 'lps'),
	(522406, 130, '2014-02-01 00:01:15.000000', 'consum', 0.0220, 'lps'),
	(522407, 130, '2014-02-01 00:01:16.000000', 'consum', 0.0215, 'lps'),
	(522408, 130, '2014-02-01 00:01:17.000000', 'consum', 0.0225, 'lps'),
	(522409, 130, '2014-02-01 00:01:18.000000', 'consum', 0.0214, 'lps'),
	(522410, 130, '2014-02-01 00:01:19.000000', 'consum', 0.0220, 'lps'),
	(522411, 130, '2014-02-01 00:01:20.000000', 'consum', 0.0215, 'lps'),
	(522412, 130, '2014-02-01 00:01:21.000000', 'consum', 0.0224, 'lps'),
	(522413, 130, '2014-02-01 00:01:22.000000', 'consum', 0.0210, 'lps'),
	(522414, 130, '2014-02-01 00:01:23.000000', 'consum', 0.0225, 'lps'),
	(522415, 130, '2014-02-01 00:01:24.000000', 'consum', 0.0211, 'lps'),
	(522416, 130, '2014-02-01 00:01:25.000000', 'consum', 0.0223, 'lps'),
	(522417, 130, '2014-02-01 00:01:26.000000', 'consum', 0.0221, 'lps'),
	(522418, 130, '2014-02-01 00:01:27.000000', 'consum', 0.0224, 'lps'),
	(522419, 130, '2014-02-01 00:01:28.000000', 'consum', 0.0214, 'lps'),
	(522420, 130, '2014-02-01 00:01:29.000000', 'consum', 0.0225, 'lps'),
	(522421, 130, '2014-02-01 00:01:30.000000', 'consum', 0.0218, 'lps'),
	(522422, 130, '2014-02-01 00:01:31.000000', 'consum', 0.0226, 'lps'),
	(522423, 130, '2014-02-01 00:01:32.000000', 'consum', 0.0227, 'lps'),
	(522424, 130, '2014-02-01 00:01:33.000000', 'consum', 0.0214, 'lps'),
	(522425, 130, '2014-02-01 00:01:34.000000', 'consum', 0.0217, 'lps'),
	(522426, 130, '2014-02-01 00:01:35.000000', 'consum', 0.0213, 'lps'),
	(522427, 130, '2014-02-01 00:01:36.000000', 'consum', 0.0223, 'lps'),
	(522428, 130, '2014-02-01 00:01:37.000000', 'consum', 0.0215, 'lps'),
	(522429, 130, '2014-02-01 00:01:38.000000', 'consum', 0.0211, 'lps'),
	(522430, 130, '2014-02-01 00:01:39.000000', 'consum', 0.0222, 'lps'),
	(522431, 130, '2014-02-01 00:01:40.000000', 'consum', 0.0211, 'lps'),
	(522432, 130, '2014-02-01 00:01:41.000000', 'consum', 0.0218, 'lps'),
	(522433, 130, '2014-02-01 00:01:42.000000', 'consum', 0.0210, 'lps'),
	(522434, 130, '2014-02-01 00:01:43.000000', 'consum', 0.0221, 'lps'),
	(522435, 130, '2014-02-01 00:01:44.000000', 'consum', 0.0215, 'lps'),
	(522436, 130, '2014-02-01 00:01:45.000000', 'consum', 0.0217, 'lps'),
	(522437, 130, '2014-02-01 00:01:46.000000', 'consum', 0.0213, 'lps'),
	(522438, 130, '2014-02-01 00:01:47.000000', 'consum', 0.0222, 'lps'),
	(522439, 130, '2014-02-01 00:01:48.000000', 'consum', 0.0210, 'lps'),
	(522440, 130, '2014-02-01 00:01:49.000000', 'consum', 0.0227, 'lps'),
	(522441, 130, '2014-02-01 00:01:50.000000', 'consum', 0.0223, 'lps'),
	(522442, 130, '2014-02-01 00:01:51.000000', 'consum', 0.0227, 'lps'),
	(522443, 130, '2014-02-01 00:01:52.000000', 'consum', 0.0218, 'lps'),
	(522444, 130, '2014-02-01 00:01:53.000000', 'consum', 0.0218, 'lps'),
	(522445, 130, '2014-02-01 00:01:54.000000', 'consum', 0.0210, 'lps'),
	(522446, 130, '2014-02-01 00:01:55.000000', 'consum', 0.0221, 'lps'),
	(522447, 130, '2014-02-01 00:01:56.000000', 'consum', 0.0210, 'lps'),
	(522448, 130, '2014-02-01 00:01:57.000000', 'consum', 0.0215, 'lps'),
	(522449, 130, '2014-02-01 00:01:58.000000', 'consum', 0.0216, 'lps'),
	(522450, 130, '2014-02-01 00:01:59.000000', 'consum', 0.0225, 'lps'),
	(522451, 130, '2014-02-01 00:02:00.000000', 'consum', 0.0213, 'lps'),
	(522452, 130, '2014-02-01 00:02:01.000000', 'consum', 0.0216, 'lps'),
	(522453, 130, '2014-02-01 00:02:02.000000', 'consum', 0.0214, 'lps'),
	(522454, 130, '2014-02-01 00:02:03.000000', 'consum', 0.0215, 'lps'),
	(522455, 130, '2014-02-01 00:02:04.000000', 'consum', 0.0221, 'lps'),
	(522456, 130, '2014-02-01 00:02:05.000000', 'consum', 0.0213, 'lps'),
	(522457, 130, '2014-02-01 00:02:06.000000', 'consum', 0.0213, 'lps'),
	(522458, 130, '2014-02-01 00:02:07.000000', 'consum', 0.0215, 'lps'),
	(522459, 130, '2014-02-01 00:02:08.000000', 'consum', 0.0227, 'lps'),
	(522460, 130, '2014-02-01 00:02:09.000000', 'consum', 0.0210, 'lps'),
	(522461, 130, '2014-02-01 00:02:10.000000', 'consum', 0.0212, 'lps'),
	(522462, 130, '2014-02-01 00:02:11.000000', 'consum', 0.0221, 'lps'),
	(522463, 130, '2014-02-01 00:02:12.000000', 'consum', 0.0225, 'lps'),
	(522464, 130, '2014-02-01 00:02:13.000000', 'consum', 0.0216, 'lps'),
	(522465, 130, '2014-02-01 00:02:14.000000', 'consum', 0.0214, 'lps'),
	(522466, 130, '2014-02-01 00:02:15.000000', 'consum', 0.0213, 'lps'),
	(522467, 130, '2014-02-01 00:02:16.000000', 'consum', 0.0212, 'lps'),
	(522468, 130, '2014-02-01 00:02:17.000000', 'consum', 0.0210, 'lps'),
	(522469, 130, '2014-02-01 00:02:18.000000', 'consum', 0.0224, 'lps'),
	(522470, 130, '2014-02-01 00:02:19.000000', 'consum', 0.0225, 'lps'),
	(522471, 130, '2014-02-01 00:02:20.000000', 'consum', 0.0227, 'lps'),
	(522472, 130, '2014-02-01 00:02:21.000000', 'consum', 0.0215, 'lps'),
	(522473, 130, '2014-02-01 00:02:22.000000', 'consum', 0.0222, 'lps'),
	(522474, 130, '2014-02-01 00:02:23.000000', 'consum', 0.0216, 'lps'),
	(522475, 130, '2014-02-01 00:02:24.000000', 'consum', 0.0225, 'lps'),
	(522476, 130, '2014-02-01 00:02:25.000000', 'consum', 0.0212, 'lps'),
	(522477, 130, '2014-02-01 00:02:26.000000', 'consum', 0.0210, 'lps'),
	(522478, 130, '2014-02-01 00:02:27.000000', 'consum', 0.0225, 'lps'),
	(522479, 130, '2014-02-01 00:02:28.000000', 'consum', 0.0212, 'lps'),
	(522480, 130, '2014-02-01 00:02:29.000000', 'consum', 0.0214, 'lps'),
	(522481, 130, '2014-02-01 00:02:30.000000', 'consum', 0.0221, 'lps'),
	(522482, 130, '2014-02-01 00:02:31.000000', 'consum', 0.0219, 'lps'),
	(522483, 130, '2014-02-01 00:02:32.000000', 'consum', 0.0224, 'lps'),
	(522484, 130, '2014-02-01 00:02:33.000000', 'consum', 0.0218, 'lps'),
	(522485, 130, '2014-02-01 00:02:34.000000', 'consum', 0.0226, 'lps'),
	(522486, 130, '2014-02-01 00:02:35.000000', 'consum', 0.0212, 'lps'),
	(522487, 130, '2014-02-01 00:02:36.000000', 'consum', 0.0227, 'lps'),
	(522488, 130, '2014-02-01 00:02:37.000000', 'consum', 0.0217, 'lps'),
	(522489, 130, '2014-02-01 00:02:38.000000', 'consum', 0.0211, 'lps'),
	(522490, 130, '2014-02-01 00:02:39.000000', 'consum', 0.0215, 'lps'),
	(522491, 130, '2014-02-01 00:02:40.000000', 'consum', 0.0214, 'lps'),
	(522492, 130, '2014-02-01 00:02:41.000000', 'consum', 0.0216, 'lps'),
	(522493, 130, '2014-02-01 00:02:42.000000', 'consum', 0.0226, 'lps'),
	(522494, 130, '2014-02-01 00:02:43.000000', 'consum', 0.0220, 'lps'),
	(522495, 130, '2014-02-01 00:02:44.000000', 'consum', 0.0214, 'lps'),
	(522496, 130, '2014-02-01 00:02:45.000000', 'consum', 0.0217, 'lps'),
	(522497, 130, '2014-02-01 00:02:46.000000', 'consum', 0.0216, 'lps'),
	(522498, 130, '2014-02-01 00:02:47.000000', 'consum', 0.0220, 'lps'),
	(522499, 130, '2014-02-01 00:02:48.000000', 'consum', 0.0225, 'lps'),
	(522500, 130, '2014-02-01 00:02:49.000000', 'consum', 0.0220, 'lps'),
	(522501, 130, '2014-02-01 00:02:50.000000', 'consum', 0.0215, 'lps'),
	(522502, 130, '2014-02-01 00:02:51.000000', 'consum', 0.0224, 'lps'),
	(522503, 130, '2014-02-01 00:02:52.000000', 'consum', 0.0211, 'lps'),
	(522504, 130, '2014-02-01 00:02:53.000000', 'consum', 0.0227, 'lps'),
	(522505, 130, '2014-02-01 00:02:54.000000', 'consum', 0.0222, 'lps'),
	(522506, 130, '2014-02-01 00:02:55.000000', 'consum', 0.0220, 'lps'),
	(522507, 130, '2014-02-01 00:02:56.000000', 'consum', 0.0222, 'lps'),
	(522508, 130, '2014-02-01 00:02:57.000000', 'consum', 0.0224, 'lps'),
	(522509, 130, '2014-02-01 00:02:58.000000', 'consum', 0.0225, 'lps'),
	(522510, 130, '2014-02-01 00:02:59.000000', 'consum', 0.0224, 'lps'),
	(522511, 130, '2014-02-01 00:03:00.000000', 'consum', 0.0221, 'lps'),
	(522512, 130, '2014-02-01 00:03:01.000000', 'consum', 0.0222, 'lps'),
	(522513, 130, '2014-02-01 00:03:02.000000', 'consum', 0.0219, 'lps'),
	(522514, 130, '2014-02-01 00:03:03.000000', 'consum', 0.0221, 'lps'),
	(522515, 130, '2014-02-01 00:03:04.000000', 'consum', 0.0219, 'lps'),
	(522516, 130, '2014-02-01 00:03:05.000000', 'consum', 0.0224, 'lps'),
	(522517, 130, '2014-02-01 00:03:06.000000', 'consum', 0.0217, 'lps'),
	(522518, 130, '2014-02-01 00:03:07.000000', 'consum', 0.0219, 'lps'),
	(522519, 130, '2014-02-01 00:03:08.000000', 'consum', 0.0220, 'lps'),
	(522520, 130, '2014-02-01 00:03:09.000000', 'consum', 0.0214, 'lps'),
	(522521, 130, '2014-02-01 00:03:10.000000', 'consum', 0.0220, 'lps'),
	(522522, 130, '2014-02-01 00:03:11.000000', 'consum', 0.0213, 'lps'),
	(522523, 130, '2014-02-01 00:03:12.000000', 'consum', 0.0212, 'lps'),
	(522524, 130, '2014-02-01 00:03:13.000000', 'consum', 0.0214, 'lps'),
	(522525, 130, '2014-02-01 00:03:14.000000', 'consum', 0.0223, 'lps'),
	(522526, 130, '2014-02-01 00:03:15.000000', 'consum', 0.0227, 'lps'),
	(522527, 130, '2014-02-01 00:03:16.000000', 'consum', 0.0222, 'lps'),
	(522528, 130, '2014-02-01 00:03:17.000000', 'consum', 0.0220, 'lps'),
	(522529, 130, '2014-02-01 00:03:18.000000', 'consum', 0.0224, 'lps'),
	(522530, 130, '2014-02-01 00:03:19.000000', 'consum', 0.0212, 'lps'),
	(522531, 130, '2014-02-01 00:03:20.000000', 'consum', 0.0217, 'lps'),
	(522532, 130, '2014-02-01 00:03:21.000000', 'consum', 0.0222, 'lps'),
	(522533, 130, '2014-02-01 00:03:22.000000', 'consum', 0.0214, 'lps'),
	(522534, 130, '2014-02-01 00:03:23.000000', 'consum', 0.0212, 'lps'),
	(522535, 130, '2014-02-01 00:03:24.000000', 'consum', 0.0227, 'lps'),
	(522536, 130, '2014-02-01 00:03:25.000000', 'consum', 0.0217, 'lps'),
	(522537, 130, '2014-02-01 00:03:26.000000', 'consum', 0.0214, 'lps'),
	(522538, 130, '2014-02-01 00:03:27.000000', 'consum', 0.0226, 'lps'),
	(522539, 130, '2014-02-01 00:03:28.000000', 'consum', 0.0224, 'lps'),
	(522540, 130, '2014-02-01 00:03:29.000000', 'consum', 0.0215, 'lps'),
	(522541, 130, '2014-02-01 00:03:30.000000', 'consum', 0.0213, 'lps'),
	(522542, 130, '2014-02-01 00:03:31.000000', 'consum', 0.0211, 'lps'),
	(522543, 130, '2014-02-01 00:03:32.000000', 'consum', 0.0222, 'lps'),
	(522544, 130, '2014-02-01 00:03:33.000000', 'consum', 0.0215, 'lps'),
	(522545, 130, '2014-02-01 00:03:34.000000', 'consum', 0.0217, 'lps'),
	(522546, 130, '2014-02-01 00:03:35.000000', 'consum', 0.0214, 'lps'),
	(522547, 130, '2014-02-01 00:03:36.000000', 'consum', 0.0210, 'lps'),
	(522548, 130, '2014-02-01 00:03:37.000000', 'consum', 0.0214, 'lps'),
	(522549, 130, '2014-02-01 00:03:38.000000', 'consum', 0.0215, 'lps'),
	(522550, 130, '2014-02-01 00:03:39.000000', 'consum', 0.0224, 'lps'),
	(522551, 130, '2014-02-01 00:03:40.000000', 'consum', 0.0211, 'lps'),
	(522552, 130, '2014-02-01 00:03:41.000000', 'consum', 0.0226, 'lps'),
	(522553, 130, '2014-02-01 00:03:42.000000', 'consum', 0.0215, 'lps'),
	(522554, 130, '2014-02-01 00:03:43.000000', 'consum', 0.0222, 'lps'),
	(522555, 130, '2014-02-01 00:03:44.000000', 'consum', 0.0223, 'lps'),
	(522556, 130, '2014-02-01 00:03:45.000000', 'consum', 0.0218, 'lps'),
	(522557, 130, '2014-02-01 00:03:46.000000', 'consum', 0.0214, 'lps'),
	(522558, 130, '2014-02-01 00:03:47.000000', 'consum', 0.0224, 'lps'),
	(522559, 130, '2014-02-01 00:03:48.000000', 'consum', 0.0215, 'lps'),
	(522560, 130, '2014-02-01 00:03:49.000000', 'consum', 0.0210, 'lps'),
	(522561, 130, '2014-02-01 00:03:50.000000', 'consum', 0.0213, 'lps'),
	(522562, 130, '2014-02-01 00:03:51.000000', 'consum', 0.0226, 'lps'),
	(522563, 130, '2014-02-01 00:03:52.000000', 'consum', 0.0211, 'lps'),
	(522564, 130, '2014-02-01 00:03:53.000000', 'consum', 0.0221, 'lps'),
	(522565, 130, '2014-02-01 00:03:54.000000', 'consum', 0.0227, 'lps'),
	(522566, 130, '2014-02-01 00:03:55.000000', 'consum', 0.0224, 'lps'),
	(522567, 130, '2014-02-01 00:03:56.000000', 'consum', 0.0213, 'lps'),
	(522568, 130, '2014-02-01 00:03:57.000000', 'consum', 0.0218, 'lps'),
	(522569, 130, '2014-02-01 00:03:58.000000', 'consum', 0.0226, 'lps'),
	(522570, 130, '2014-02-01 00:03:59.000000', 'consum', 0.0212, 'lps'),
	(522571, 130, '2014-02-01 00:04:00.000000', 'consum', 0.0227, 'lps'),
	(522572, 130, '2014-02-01 00:04:01.000000', 'consum', 0.0216, 'lps'),
	(522573, 130, '2014-02-01 00:04:02.000000', 'consum', 0.0224, 'lps'),
	(522574, 130, '2014-02-01 00:04:03.000000', 'consum', 0.0210, 'lps'),
	(522575, 130, '2014-02-01 00:04:04.000000', 'consum', 0.0224, 'lps'),
	(522576, 130, '2014-02-01 00:04:05.000000', 'consum', 0.0226, 'lps'),
	(522577, 130, '2014-02-01 00:04:06.000000', 'consum', 0.0211, 'lps'),
	(522578, 130, '2014-02-01 00:04:07.000000', 'consum', 0.0223, 'lps'),
	(522579, 130, '2014-02-01 00:04:08.000000', 'consum', 0.0217, 'lps'),
	(522580, 130, '2014-02-01 00:04:09.000000', 'consum', 0.0226, 'lps'),
	(522581, 130, '2014-02-01 00:04:10.000000', 'consum', 0.0214, 'lps'),
	(522582, 130, '2014-02-01 00:04:11.000000', 'consum', 0.0218, 'lps'),
	(522583, 130, '2014-02-01 00:04:12.000000', 'consum', 0.0220, 'lps'),
	(522584, 130, '2014-02-01 00:04:13.000000', 'consum', 0.0221, 'lps'),
	(522585, 130, '2014-02-01 00:04:14.000000', 'consum', 0.0218, 'lps'),
	(522586, 130, '2014-02-01 00:04:15.000000', 'consum', 0.0216, 'lps'),
	(522587, 130, '2014-02-01 00:04:16.000000', 'consum', 0.0217, 'lps'),
	(522588, 130, '2014-02-01 00:04:17.000000', 'consum', 0.0227, 'lps'),
	(522589, 130, '2014-02-01 00:04:18.000000', 'consum', 0.0222, 'lps'),
	(522590, 130, '2014-02-01 00:04:19.000000', 'consum', 0.0218, 'lps'),
	(522591, 130, '2014-02-01 00:04:20.000000', 'consum', 0.0213, 'lps'),
	(522592, 130, '2014-02-01 00:04:21.000000', 'consum', 0.0221, 'lps'),
	(522593, 130, '2014-02-01 00:04:22.000000', 'consum', 0.0220, 'lps'),
	(522594, 130, '2014-02-01 00:04:23.000000', 'consum', 0.0211, 'lps'),
	(522595, 130, '2014-02-01 00:04:24.000000', 'consum', 0.0219, 'lps'),
	(522596, 130, '2014-02-01 00:04:25.000000', 'consum', 0.0218, 'lps'),
	(522597, 130, '2014-02-01 00:04:26.000000', 'consum', 0.0222, 'lps'),
	(522598, 130, '2014-02-01 00:04:27.000000', 'consum', 0.0212, 'lps'),
	(522599, 130, '2014-02-01 00:04:28.000000', 'consum', 0.0219, 'lps'),
	(522600, 130, '2014-02-01 00:04:29.000000', 'consum', 0.0213, 'lps'),
	(522601, 130, '2014-02-01 00:04:30.000000', 'consum', 0.0218, 'lps'),
	(522602, 130, '2014-02-01 00:04:31.000000', 'consum', 0.0224, 'lps'),
	(522603, 130, '2014-02-01 00:04:32.000000', 'consum', 0.0219, 'lps'),
	(522604, 130, '2014-02-01 00:04:33.000000', 'consum', 0.0213, 'lps'),
	(522605, 130, '2014-02-01 00:04:34.000000', 'consum', 0.0217, 'lps'),
	(522606, 130, '2014-02-01 00:04:35.000000', 'consum', 0.0219, 'lps'),
	(522607, 130, '2014-02-01 00:04:36.000000', 'consum', 0.0215, 'lps'),
	(522608, 130, '2014-02-01 00:04:37.000000', 'consum', 0.0226, 'lps'),
	(522609, 130, '2014-02-01 00:04:38.000000', 'consum', 0.0222, 'lps'),
	(522610, 130, '2014-02-01 00:04:39.000000', 'consum', 0.0221, 'lps'),
	(522611, 130, '2014-02-01 00:04:40.000000', 'consum', 0.0214, 'lps'),
	(522612, 130, '2014-02-01 00:04:41.000000', 'consum', 0.0213, 'lps'),
	(522613, 130, '2014-02-01 00:04:42.000000', 'consum', 0.0215, 'lps'),
	(522614, 130, '2014-02-01 00:04:43.000000', 'consum', 0.0225, 'lps'),
	(522615, 130, '2014-02-01 00:04:44.000000', 'consum', 0.0216, 'lps'),
	(522616, 130, '2014-02-01 00:04:45.000000', 'consum', 0.0215, 'lps'),
	(522617, 130, '2014-02-01 00:04:46.000000', 'consum', 0.0218, 'lps'),
	(522618, 130, '2014-02-01 00:04:47.000000', 'consum', 0.0217, 'lps'),
	(522619, 130, '2014-02-01 00:04:48.000000', 'consum', 0.0219, 'lps'),
	(522620, 130, '2014-02-01 00:04:49.000000', 'consum', 0.0220, 'lps'),
	(522621, 130, '2014-02-01 00:04:50.000000', 'consum', 0.0215, 'lps'),
	(522622, 130, '2014-02-01 00:04:51.000000', 'consum', 0.0223, 'lps'),
	(522623, 130, '2014-02-01 00:04:52.000000', 'consum', 0.0224, 'lps'),
	(522624, 130, '2014-02-01 00:04:53.000000', 'consum', 0.0225, 'lps'),
	(522625, 130, '2014-02-01 00:04:54.000000', 'consum', 0.0227, 'lps'),
	(522626, 130, '2014-02-01 00:04:55.000000', 'consum', 0.0212, 'lps'),
	(522627, 130, '2014-02-01 00:04:56.000000', 'consum', 0.0225, 'lps'),
	(522628, 130, '2014-02-01 00:04:57.000000', 'consum', 0.0223, 'lps'),
	(522629, 130, '2014-02-01 00:04:58.000000', 'consum', 0.0213, 'lps'),
	(522630, 130, '2014-02-01 00:04:59.000000', 'consum', 0.0223, 'lps'),
	(522631, 130, '2014-02-01 00:05:00.000000', 'consum', 0.0211, 'lps'),
	(522632, 130, '2014-02-01 00:05:01.000000', 'consum', 0.0213, 'lps'),
	(522633, 130, '2014-02-01 00:05:02.000000', 'consum', 0.0223, 'lps'),
	(522634, 130, '2014-02-01 00:05:03.000000', 'consum', 0.0212, 'lps'),
	(522635, 130, '2014-02-01 00:05:04.000000', 'consum', 0.0217, 'lps'),
	(522636, 130, '2014-02-01 00:05:05.000000', 'consum', 0.0221, 'lps'),
	(522637, 130, '2014-02-01 00:05:06.000000', 'consum', 0.0211, 'lps'),
	(522638, 130, '2014-02-01 00:05:07.000000', 'consum', 0.0218, 'lps'),
	(522639, 130, '2014-02-01 00:05:08.000000', 'consum', 0.0210, 'lps'),
	(522640, 130, '2014-02-01 00:05:09.000000', 'consum', 0.0224, 'lps'),
	(522641, 130, '2014-02-01 00:05:10.000000', 'consum', 0.0224, 'lps'),
	(522642, 130, '2014-02-01 00:05:11.000000', 'consum', 0.0222, 'lps'),
	(522643, 130, '2014-02-01 00:05:12.000000', 'consum', 0.0210, 'lps'),
	(522644, 130, '2014-02-01 00:05:13.000000', 'consum', 0.0227, 'lps'),
	(522645, 130, '2014-02-01 00:05:14.000000', 'consum', 0.0224, 'lps'),
	(522646, 130, '2014-02-01 00:05:15.000000', 'consum', 0.0214, 'lps'),
	(522647, 130, '2014-02-01 00:05:16.000000', 'consum', 0.0222, 'lps'),
	(522648, 130, '2014-02-01 00:05:17.000000', 'consum', 0.0224, 'lps'),
	(522649, 130, '2014-02-01 00:05:18.000000', 'consum', 0.0225, 'lps'),
	(522650, 130, '2014-02-01 00:05:19.000000', 'consum', 0.0226, 'lps'),
	(522651, 130, '2014-02-01 00:05:20.000000', 'consum', 0.0226, 'lps'),
	(522652, 130, '2014-02-01 00:05:21.000000', 'consum', 0.0226, 'lps'),
	(522653, 130, '2014-02-01 00:05:22.000000', 'consum', 0.0224, 'lps'),
	(522654, 130, '2014-02-01 00:05:23.000000', 'consum', 0.0216, 'lps'),
	(522655, 130, '2014-02-01 00:05:24.000000', 'consum', 0.0217, 'lps'),
	(522656, 130, '2014-02-01 00:05:25.000000', 'consum', 0.0226, 'lps'),
	(522657, 130, '2014-02-01 00:05:26.000000', 'consum', 0.0215, 'lps'),
	(522658, 130, '2014-02-01 00:05:27.000000', 'consum', 0.0225, 'lps'),
	(522659, 130, '2014-02-01 00:05:28.000000', 'consum', 0.0217, 'lps'),
	(522660, 130, '2014-02-01 00:05:29.000000', 'consum', 0.0219, 'lps'),
	(522661, 130, '2014-02-01 00:05:30.000000', 'consum', 0.0214, 'lps'),
	(522662, 130, '2014-02-01 00:05:31.000000', 'consum', 0.0221, 'lps'),
	(522663, 130, '2014-02-01 00:05:32.000000', 'consum', 0.0217, 'lps'),
	(522664, 130, '2014-02-01 00:05:33.000000', 'consum', 0.0214, 'lps'),
	(522665, 130, '2014-02-01 00:05:34.000000', 'consum', 0.0210, 'lps'),
	(522666, 130, '2014-02-01 00:05:35.000000', 'consum', 0.0217, 'lps'),
	(522667, 130, '2014-02-01 00:05:36.000000', 'consum', 0.0227, 'lps'),
	(522668, 130, '2014-02-01 00:05:37.000000', 'consum', 0.0221, 'lps'),
	(522669, 130, '2014-02-01 00:05:38.000000', 'consum', 0.0214, 'lps'),
	(522670, 130, '2014-02-01 00:05:39.000000', 'consum', 0.0217, 'lps'),
	(522671, 130, '2014-02-01 00:05:40.000000', 'consum', 0.0216, 'lps'),
	(522672, 130, '2014-02-01 00:05:41.000000', 'consum', 0.0217, 'lps'),
	(522673, 130, '2014-02-01 00:05:42.000000', 'consum', 0.0210, 'lps'),
	(522674, 130, '2014-02-01 00:05:43.000000', 'consum', 0.0224, 'lps'),
	(522675, 130, '2014-02-01 00:05:44.000000', 'consum', 0.0211, 'lps'),
	(522676, 130, '2014-02-01 00:05:45.000000', 'consum', 0.0225, 'lps'),
	(522677, 130, '2014-02-01 00:05:46.000000', 'consum', 0.0211, 'lps'),
	(522678, 130, '2014-02-01 00:05:47.000000', 'consum', 0.0226, 'lps'),
	(522679, 130, '2014-02-01 00:05:48.000000', 'consum', 0.0213, 'lps'),
	(522680, 130, '2014-02-01 00:05:49.000000', 'consum', 0.0214, 'lps'),
	(522681, 130, '2014-02-01 00:05:50.000000', 'consum', 0.0223, 'lps'),
	(522682, 130, '2014-02-01 00:05:51.000000', 'consum', 0.0227, 'lps'),
	(522683, 130, '2014-02-01 00:05:52.000000', 'consum', 0.0222, 'lps'),
	(522684, 130, '2014-02-01 00:05:53.000000', 'consum', 0.0218, 'lps'),
	(522685, 130, '2014-02-01 00:05:54.000000', 'consum', 0.0215, 'lps'),
	(522686, 130, '2014-02-01 00:05:55.000000', 'consum', 0.0211, 'lps'),
	(522687, 130, '2014-02-01 00:05:56.000000', 'consum', 0.0218, 'lps'),
	(522688, 130, '2014-02-01 00:05:57.000000', 'consum', 0.0211, 'lps'),
	(522689, 130, '2014-02-01 00:05:58.000000', 'consum', 0.0212, 'lps'),
	(522690, 130, '2014-02-01 00:05:59.000000', 'consum', 0.0215, 'lps'),
	(522691, 130, '2014-02-01 00:06:00.000000', 'consum', 0.0214, 'lps'),
	(522692, 130, '2014-02-01 00:06:01.000000', 'consum', 0.0213, 'lps'),
	(522693, 130, '2014-02-01 00:06:02.000000', 'consum', 0.0215, 'lps'),
	(522694, 130, '2014-02-01 00:06:03.000000', 'consum', 0.0210, 'lps'),
	(522695, 130, '2014-02-01 00:06:04.000000', 'consum', 0.0213, 'lps'),
	(522696, 130, '2014-02-01 00:06:05.000000', 'consum', 0.0225, 'lps'),
	(522697, 130, '2014-02-01 00:06:06.000000', 'consum', 0.0223, 'lps'),
	(522698, 130, '2014-02-01 00:06:07.000000', 'consum', 0.0213, 'lps'),
	(522699, 130, '2014-02-01 00:06:08.000000', 'consum', 0.0224, 'lps'),
	(522700, 130, '2014-02-01 00:06:09.000000', 'consum', 0.0215, 'lps'),
	(522701, 130, '2014-02-01 00:06:10.000000', 'consum', 0.0211, 'lps'),
	(522702, 130, '2014-02-01 00:06:11.000000', 'consum', 0.0220, 'lps'),
	(522703, 130, '2014-02-01 00:06:12.000000', 'consum', 0.0219, 'lps'),
	(522704, 130, '2014-02-01 00:06:13.000000', 'consum', 0.0210, 'lps'),
	(522705, 130, '2014-02-01 00:06:14.000000', 'consum', 0.0218, 'lps'),
	(522706, 130, '2014-02-01 00:06:15.000000', 'consum', 0.0216, 'lps'),
	(522707, 130, '2014-02-01 00:06:16.000000', 'consum', 0.0214, 'lps'),
	(522708, 130, '2014-02-01 00:06:17.000000', 'consum', 0.0213, 'lps'),
	(522709, 130, '2014-02-01 00:06:18.000000', 'consum', 0.0213, 'lps'),
	(522710, 130, '2014-02-01 00:06:19.000000', 'consum', 0.0217, 'lps'),
	(522711, 130, '2014-02-01 00:06:20.000000', 'consum', 0.0220, 'lps'),
	(522712, 130, '2014-02-01 00:06:21.000000', 'consum', 0.0220, 'lps'),
	(522713, 130, '2014-02-01 00:06:22.000000', 'consum', 0.0211, 'lps'),
	(522714, 130, '2014-02-01 00:06:23.000000', 'consum', 0.0224, 'lps'),
	(522715, 130, '2014-02-01 00:06:24.000000', 'consum', 0.0223, 'lps'),
	(522716, 130, '2014-02-01 00:06:25.000000', 'consum', 0.0214, 'lps'),
	(522717, 130, '2014-02-01 00:06:26.000000', 'consum', 0.0211, 'lps'),
	(522718, 130, '2014-02-01 00:06:27.000000', 'consum', 0.0220, 'lps'),
	(522719, 130, '2014-02-01 00:06:28.000000', 'consum', 0.0220, 'lps'),
	(522720, 130, '2014-02-01 00:06:29.000000', 'consum', 0.0215, 'lps'),
	(522721, 130, '2014-02-01 00:06:30.000000', 'consum', 0.0222, 'lps'),
	(522722, 130, '2014-02-01 00:06:31.000000', 'consum', 0.0220, 'lps'),
	(522723, 130, '2014-02-01 00:06:32.000000', 'consum', 0.0223, 'lps'),
	(522724, 130, '2014-02-01 00:06:33.000000', 'consum', 0.0227, 'lps'),
	(522725, 130, '2014-02-01 00:06:34.000000', 'consum', 0.0221, 'lps'),
	(522726, 130, '2014-02-01 00:06:35.000000', 'consum', 0.0215, 'lps'),
	(522727, 130, '2014-02-01 00:06:36.000000', 'consum', 0.0219, 'lps'),
	(522728, 130, '2014-02-01 00:06:37.000000', 'consum', 0.0223, 'lps'),
	(522729, 130, '2014-02-01 00:06:38.000000', 'consum', 0.0212, 'lps'),
	(522730, 130, '2014-02-01 00:06:39.000000', 'consum', 0.0220, 'lps'),
	(522731, 130, '2014-02-01 00:06:40.000000', 'consum', 0.0217, 'lps'),
	(522732, 130, '2014-02-01 00:06:41.000000', 'consum', 0.0217, 'lps'),
	(522733, 130, '2014-02-01 00:06:42.000000', 'consum', 0.0222, 'lps'),
	(522734, 130, '2014-02-01 00:06:43.000000', 'consum', 0.0214, 'lps'),
	(522735, 130, '2014-02-01 00:06:44.000000', 'consum', 0.0215, 'lps'),
	(522736, 130, '2014-02-01 00:06:45.000000', 'consum', 0.0220, 'lps'),
	(522737, 130, '2014-02-01 00:06:46.000000', 'consum', 0.0211, 'lps'),
	(522738, 130, '2014-02-01 00:06:47.000000', 'consum', 0.0222, 'lps'),
	(522739, 130, '2014-02-01 00:06:48.000000', 'consum', 0.0213, 'lps'),
	(522740, 130, '2014-02-01 00:06:49.000000', 'consum', 0.0225, 'lps'),
	(522741, 130, '2014-02-01 00:06:50.000000', 'consum', 0.0224, 'lps'),
	(522742, 130, '2014-02-01 00:06:51.000000', 'consum', 0.0216, 'lps'),
	(522743, 130, '2014-02-01 00:06:52.000000', 'consum', 0.0217, 'lps'),
	(522744, 130, '2014-02-01 00:06:53.000000', 'consum', 0.0210, 'lps'),
	(522745, 130, '2014-02-01 00:06:54.000000', 'consum', 0.0226, 'lps'),
	(522746, 130, '2014-02-01 00:06:55.000000', 'consum', 0.0217, 'lps'),
	(522747, 130, '2014-02-01 00:06:56.000000', 'consum', 0.0217, 'lps'),
	(522748, 130, '2014-02-01 00:06:57.000000', 'consum', 0.0225, 'lps'),
	(522749, 130, '2014-02-01 00:06:58.000000', 'consum', 0.0211, 'lps'),
	(522750, 130, '2014-02-01 00:06:59.000000', 'consum', 0.0222, 'lps'),
	(522751, 130, '2014-02-01 00:07:00.000000', 'consum', 0.0213, 'lps'),
	(522752, 130, '2014-02-01 00:07:01.000000', 'consum', 0.0210, 'lps'),
	(522753, 130, '2014-02-01 00:07:02.000000', 'consum', 0.0217, 'lps'),
	(522754, 130, '2014-02-01 00:07:03.000000', 'consum', 0.0226, 'lps'),
	(522755, 130, '2014-02-01 00:07:04.000000', 'consum', 0.0219, 'lps'),
	(522756, 130, '2014-02-01 00:07:05.000000', 'consum', 0.0226, 'lps'),
	(522757, 130, '2014-02-01 00:07:06.000000', 'consum', 0.0225, 'lps'),
	(522758, 130, '2014-02-01 00:07:07.000000', 'consum', 0.0219, 'lps'),
	(522759, 130, '2014-02-01 00:07:08.000000', 'consum', 0.0213, 'lps'),
	(522760, 130, '2014-02-01 00:07:09.000000', 'consum', 0.0214, 'lps'),
	(522761, 130, '2014-02-01 00:07:10.000000', 'consum', 0.0220, 'lps'),
	(522762, 130, '2014-02-01 00:07:11.000000', 'consum', 0.0216, 'lps'),
	(522763, 130, '2014-02-01 00:07:12.000000', 'consum', 0.0227, 'lps'),
	(522764, 130, '2014-02-01 00:07:13.000000', 'consum', 0.0222, 'lps'),
	(522765, 130, '2014-02-01 00:07:14.000000', 'consum', 0.0220, 'lps'),
	(522766, 130, '2014-02-01 00:07:15.000000', 'consum', 0.0226, 'lps'),
	(522767, 130, '2014-02-01 00:07:16.000000', 'consum', 0.0223, 'lps'),
	(522768, 130, '2014-02-01 00:07:17.000000', 'consum', 0.0210, 'lps'),
	(522769, 130, '2014-02-01 00:07:18.000000', 'consum', 0.0224, 'lps'),
	(522770, 130, '2014-02-01 00:07:19.000000', 'consum', 0.0210, 'lps'),
	(522771, 130, '2014-02-01 00:07:20.000000', 'consum', 0.0223, 'lps'),
	(522772, 130, '2014-02-01 00:07:21.000000', 'consum', 0.0222, 'lps'),
	(522773, 130, '2014-02-01 00:07:22.000000', 'consum', 0.0213, 'lps'),
	(522774, 130, '2014-02-01 00:07:23.000000', 'consum', 0.0227, 'lps'),
	(522775, 130, '2014-02-01 00:07:24.000000', 'consum', 0.0212, 'lps'),
	(522776, 130, '2014-02-01 00:07:25.000000', 'consum', 0.0225, 'lps'),
	(522777, 130, '2014-02-01 00:07:26.000000', 'consum', 0.0224, 'lps'),
	(522778, 130, '2014-02-01 00:07:27.000000', 'consum', 0.0219, 'lps'),
	(522779, 130, '2014-02-01 00:07:28.000000', 'consum', 0.0213, 'lps'),
	(522780, 130, '2014-02-01 00:07:29.000000', 'consum', 0.0217, 'lps'),
	(522781, 130, '2014-02-01 00:07:30.000000', 'consum', 0.0220, 'lps'),
	(522782, 130, '2014-02-01 00:07:31.000000', 'consum', 0.0220, 'lps'),
	(522783, 130, '2014-02-01 00:07:32.000000', 'consum', 0.0213, 'lps'),
	(522784, 130, '2014-02-01 00:07:33.000000', 'consum', 0.0211, 'lps'),
	(522785, 130, '2014-02-01 00:07:34.000000', 'consum', 0.0227, 'lps'),
	(522786, 130, '2014-02-01 00:07:35.000000', 'consum', 0.0222, 'lps'),
	(522787, 130, '2014-02-01 00:07:36.000000', 'consum', 0.0216, 'lps'),
	(522788, 130, '2014-02-01 00:07:37.000000', 'consum', 0.0224, 'lps'),
	(522789, 130, '2014-02-01 00:07:38.000000', 'consum', 0.0225, 'lps'),
	(522790, 130, '2014-02-01 00:07:39.000000', 'consum', 0.0225, 'lps'),
	(522791, 130, '2014-02-01 00:07:40.000000', 'consum', 0.0222, 'lps'),
	(522792, 130, '2014-02-01 00:07:41.000000', 'consum', 0.0211, 'lps'),
	(522793, 130, '2014-02-01 00:07:42.000000', 'consum', 0.0212, 'lps'),
	(522794, 130, '2014-02-01 00:07:43.000000', 'consum', 0.0217, 'lps'),
	(522795, 130, '2014-02-01 00:07:44.000000', 'consum', 0.0225, 'lps'),
	(522796, 130, '2014-02-01 00:07:45.000000', 'consum', 0.0225, 'lps'),
	(522797, 130, '2014-02-01 00:07:46.000000', 'consum', 0.0224, 'lps'),
	(522798, 130, '2014-02-01 00:07:47.000000', 'consum', 0.0218, 'lps'),
	(522799, 130, '2014-02-01 00:07:48.000000', 'consum', 0.0225, 'lps'),
	(522800, 130, '2014-02-01 00:07:49.000000', 'consum', 0.0227, 'lps'),
	(522801, 130, '2014-02-01 00:07:50.000000', 'consum', 0.0214, 'lps'),
	(522802, 130, '2014-02-01 00:07:51.000000', 'consum', 0.0217, 'lps'),
	(522803, 130, '2014-02-01 00:07:52.000000', 'consum', 0.0215, 'lps'),
	(522804, 130, '2014-02-01 00:07:53.000000', 'consum', 0.0214, 'lps'),
	(522805, 130, '2014-02-01 00:07:54.000000', 'consum', 0.0217, 'lps'),
	(522806, 130, '2014-02-01 00:07:55.000000', 'consum', 0.0215, 'lps'),
	(522807, 130, '2014-02-01 00:07:56.000000', 'consum', 0.0214, 'lps'),
	(522808, 130, '2014-02-01 00:07:57.000000', 'consum', 0.0218, 'lps'),
	(522809, 130, '2014-02-01 00:07:58.000000', 'consum', 0.0217, 'lps'),
	(522810, 130, '2014-02-01 00:07:59.000000', 'consum', 0.0224, 'lps'),
	(522811, 130, '2014-02-01 00:08:00.000000', 'consum', 0.0223, 'lps'),
	(522812, 130, '2014-02-01 00:08:01.000000', 'consum', 0.0215, 'lps'),
	(522813, 130, '2014-02-01 00:08:02.000000', 'consum', 0.0213, 'lps'),
	(522814, 130, '2014-02-01 00:08:03.000000', 'consum', 0.0213, 'lps'),
	(522815, 130, '2014-02-01 00:08:04.000000', 'consum', 0.0215, 'lps'),
	(522816, 130, '2014-02-01 00:08:05.000000', 'consum', 0.0210, 'lps'),
	(522817, 130, '2014-02-01 00:08:06.000000', 'consum', 0.0213, 'lps'),
	(522818, 130, '2014-02-01 00:08:07.000000', 'consum', 0.0225, 'lps'),
	(522819, 130, '2014-02-01 00:08:08.000000', 'consum', 0.0223, 'lps'),
	(522820, 130, '2014-02-01 00:08:09.000000', 'consum', 0.0211, 'lps'),
	(522821, 130, '2014-02-01 00:08:10.000000', 'consum', 0.0212, 'lps'),
	(522822, 130, '2014-02-01 00:08:11.000000', 'consum', 0.0217, 'lps'),
	(522823, 130, '2014-02-01 00:08:12.000000', 'consum', 0.0223, 'lps'),
	(522824, 130, '2014-02-01 00:08:13.000000', 'consum', 0.0218, 'lps'),
	(522825, 130, '2014-02-01 00:08:14.000000', 'consum', 0.0211, 'lps'),
	(522826, 130, '2014-02-01 00:08:15.000000', 'consum', 0.0227, 'lps'),
	(522827, 130, '2014-02-01 00:08:16.000000', 'consum', 0.0222, 'lps'),
	(522828, 130, '2014-02-01 00:08:17.000000', 'consum', 0.0219, 'lps'),
	(522829, 130, '2014-02-01 00:08:18.000000', 'consum', 0.0218, 'lps'),
	(522830, 130, '2014-02-01 00:08:19.000000', 'consum', 0.0226, 'lps'),
	(522831, 130, '2014-02-01 00:08:20.000000', 'consum', 0.0213, 'lps'),
	(522832, 130, '2014-02-01 00:08:21.000000', 'consum', 0.0213, 'lps'),
	(522833, 130, '2014-02-01 00:08:22.000000', 'consum', 0.0218, 'lps'),
	(522834, 130, '2014-02-01 00:08:23.000000', 'consum', 0.0220, 'lps'),
	(522835, 130, '2014-02-01 00:08:24.000000', 'consum', 0.0220, 'lps'),
	(522836, 130, '2014-02-01 00:08:25.000000', 'consum', 0.0213, 'lps'),
	(522837, 130, '2014-02-01 00:08:26.000000', 'consum', 0.0214, 'lps'),
	(522838, 130, '2014-02-01 00:08:27.000000', 'consum', 0.0220, 'lps'),
	(522839, 130, '2014-02-01 00:08:28.000000', 'consum', 0.0213, 'lps'),
	(522840, 130, '2014-02-01 00:08:29.000000', 'consum', 0.0213, 'lps'),
	(522841, 130, '2014-02-01 00:08:30.000000', 'consum', 0.0217, 'lps'),
	(522842, 130, '2014-02-01 00:08:31.000000', 'consum', 0.0217, 'lps'),
	(522843, 130, '2014-02-01 00:08:32.000000', 'consum', 0.0224, 'lps'),
	(522844, 130, '2014-02-01 00:08:33.000000', 'consum', 0.0225, 'lps'),
	(522845, 130, '2014-02-01 00:08:34.000000', 'consum', 0.0226, 'lps'),
	(522846, 130, '2014-02-01 00:08:35.000000', 'consum', 0.0210, 'lps'),
	(522847, 130, '2014-02-01 00:08:36.000000', 'consum', 0.0218, 'lps'),
	(522848, 130, '2014-02-01 00:08:37.000000', 'consum', 0.0212, 'lps'),
	(522849, 130, '2014-02-01 00:08:38.000000', 'consum', 0.0216, 'lps'),
	(522850, 130, '2014-02-01 00:08:39.000000', 'consum', 0.0218, 'lps'),
	(522851, 130, '2014-02-01 00:08:40.000000', 'consum', 0.0212, 'lps'),
	(522852, 130, '2014-02-01 00:08:41.000000', 'consum', 0.0216, 'lps'),
	(522853, 130, '2014-02-01 00:08:42.000000', 'consum', 0.0214, 'lps'),
	(522854, 130, '2014-02-01 00:08:43.000000', 'consum', 0.0216, 'lps'),
	(522855, 130, '2014-02-01 00:08:44.000000', 'consum', 0.0226, 'lps'),
	(522856, 130, '2014-02-01 00:08:45.000000', 'consum', 0.0218, 'lps'),
	(522857, 130, '2014-02-01 00:08:46.000000', 'consum', 0.0222, 'lps'),
	(522858, 130, '2014-02-01 00:08:47.000000', 'consum', 0.0211, 'lps'),
	(522859, 130, '2014-02-01 00:08:48.000000', 'consum', 0.0214, 'lps'),
	(522860, 130, '2014-02-01 00:08:49.000000', 'consum', 0.0211, 'lps'),
	(522861, 130, '2014-02-01 00:08:50.000000', 'consum', 0.0220, 'lps'),
	(522862, 130, '2014-02-01 00:08:51.000000', 'consum', 0.0223, 'lps'),
	(522863, 130, '2014-02-01 00:08:52.000000', 'consum', 0.0227, 'lps'),
	(522864, 130, '2014-02-01 00:08:53.000000', 'consum', 0.0221, 'lps'),
	(522865, 130, '2014-02-01 00:08:54.000000', 'consum', 0.0214, 'lps'),
	(522866, 130, '2014-02-01 00:08:55.000000', 'consum', 0.0213, 'lps'),
	(522867, 130, '2014-02-01 00:08:56.000000', 'consum', 0.0217, 'lps'),
	(522868, 130, '2014-02-01 00:08:57.000000', 'consum', 0.0218, 'lps'),
	(522869, 130, '2014-02-01 00:08:58.000000', 'consum', 0.0211, 'lps'),
	(522870, 130, '2014-02-01 00:08:59.000000', 'consum', 0.0227, 'lps'),
	(522871, 130, '2014-02-01 00:09:00.000000', 'consum', 0.0220, 'lps'),
	(522872, 130, '2014-02-01 00:09:01.000000', 'consum', 0.0211, 'lps'),
	(522873, 130, '2014-02-01 00:09:02.000000', 'consum', 0.0221, 'lps'),
	(522874, 130, '2014-02-01 00:09:03.000000', 'consum', 0.0226, 'lps'),
	(522875, 130, '2014-02-01 00:09:04.000000', 'consum', 0.0220, 'lps'),
	(522876, 130, '2014-02-01 00:09:05.000000', 'consum', 0.0213, 'lps'),
	(522877, 130, '2014-02-01 00:09:06.000000', 'consum', 0.0213, 'lps'),
	(522878, 130, '2014-02-01 00:09:07.000000', 'consum', 0.0217, 'lps'),
	(522879, 130, '2014-02-01 00:09:08.000000', 'consum', 0.0220, 'lps'),
	(522880, 130, '2014-02-01 00:09:09.000000', 'consum', 0.0220, 'lps'),
	(522881, 130, '2014-02-01 00:09:10.000000', 'consum', 0.0214, 'lps'),
	(522882, 130, '2014-02-01 00:09:11.000000', 'consum', 0.0217, 'lps'),
	(522883, 130, '2014-02-01 00:09:12.000000', 'consum', 0.0217, 'lps'),
	(522884, 130, '2014-02-01 00:09:13.000000', 'consum', 0.0224, 'lps'),
	(522885, 130, '2014-02-01 00:09:14.000000', 'consum', 0.0225, 'lps'),
	(522886, 130, '2014-02-01 00:09:15.000000', 'consum', 0.0224, 'lps'),
	(522887, 130, '2014-02-01 00:09:16.000000', 'consum', 0.0220, 'lps'),
	(522888, 130, '2014-02-01 00:09:17.000000', 'consum', 0.0216, 'lps'),
	(522889, 130, '2014-02-01 00:09:18.000000', 'consum', 0.0211, 'lps'),
	(522890, 130, '2014-02-01 00:09:19.000000', 'consum', 0.0215, 'lps'),
	(522891, 130, '2014-02-01 00:09:20.000000', 'consum', 0.0215, 'lps'),
	(522892, 130, '2014-02-01 00:09:21.000000', 'consum', 0.0221, 'lps'),
	(522893, 130, '2014-02-01 00:09:22.000000', 'consum', 0.0213, 'lps'),
	(522894, 130, '2014-02-01 00:09:23.000000', 'consum', 0.0211, 'lps'),
	(522895, 130, '2014-02-01 00:09:24.000000', 'consum', 0.0225, 'lps'),
	(522896, 130, '2014-02-01 00:09:25.000000', 'consum', 0.0210, 'lps'),
	(522897, 130, '2014-02-01 00:09:26.000000', 'consum', 0.0219, 'lps'),
	(522898, 130, '2014-02-01 00:09:27.000000', 'consum', 0.0221, 'lps'),
	(522899, 130, '2014-02-01 00:09:28.000000', 'consum', 0.0218, 'lps'),
	(522900, 130, '2014-02-01 00:09:29.000000', 'consum', 0.0218, 'lps'),
	(522901, 130, '2014-02-01 00:09:30.000000', 'consum', 0.0227, 'lps'),
	(522902, 130, '2014-02-01 00:09:31.000000', 'consum', 0.0218, 'lps'),
	(522903, 130, '2014-02-01 00:09:32.000000', 'consum', 0.0216, 'lps'),
	(522904, 130, '2014-02-01 00:09:33.000000', 'consum', 0.0218, 'lps'),
	(522905, 130, '2014-02-01 00:09:34.000000', 'consum', 0.0216, 'lps'),
	(522906, 130, '2014-02-01 00:09:35.000000', 'consum', 0.0214, 'lps'),
	(522907, 130, '2014-02-01 00:09:36.000000', 'consum', 0.0214, 'lps'),
	(522908, 130, '2014-02-01 00:09:37.000000', 'consum', 0.0217, 'lps'),
	(522909, 130, '2014-02-01 00:09:38.000000', 'consum', 0.0216, 'lps'),
	(522910, 130, '2014-02-01 00:09:39.000000', 'consum', 0.0219, 'lps'),
	(522911, 130, '2014-02-01 00:09:40.000000', 'consum', 0.0218, 'lps'),
	(522912, 130, '2014-02-01 00:09:41.000000', 'consum', 0.0226, 'lps'),
	(522913, 130, '2014-02-01 00:09:42.000000', 'consum', 0.0214, 'lps'),
	(522914, 130, '2014-02-01 00:09:43.000000', 'consum', 0.0216, 'lps'),
	(522915, 130, '2014-02-01 00:09:44.000000', 'consum', 0.0211, 'lps'),
	(522916, 130, '2014-02-01 00:09:45.000000', 'consum', 0.0215, 'lps'),
	(522917, 130, '2014-02-01 00:09:46.000000', 'consum', 0.0216, 'lps'),
	(522918, 130, '2014-02-01 00:09:47.000000', 'consum', 0.0223, 'lps'),
	(522919, 130, '2014-02-01 00:09:48.000000', 'consum', 0.0222, 'lps'),
	(522920, 130, '2014-02-01 00:09:49.000000', 'consum', 0.0214, 'lps'),
	(522921, 130, '2014-02-01 00:09:50.000000', 'consum', 0.0212, 'lps'),
	(522922, 130, '2014-02-01 00:09:51.000000', 'consum', 0.0210, 'lps'),
	(522923, 130, '2014-02-01 00:09:52.000000', 'consum', 0.0221, 'lps'),
	(522924, 130, '2014-02-01 00:09:53.000000', 'consum', 0.0211, 'lps'),
	(522925, 130, '2014-02-01 00:09:54.000000', 'consum', 0.0218, 'lps'),
	(522926, 130, '2014-02-01 00:09:55.000000', 'consum', 0.0214, 'lps'),
	(522927, 130, '2014-02-01 00:09:56.000000', 'consum', 0.0223, 'lps'),
	(522928, 130, '2014-02-01 00:09:57.000000', 'consum', 0.0226, 'lps'),
	(522929, 130, '2014-02-01 00:09:58.000000', 'consum', 0.0217, 'lps'),
	(522930, 130, '2014-02-01 00:09:59.000000', 'consum', 0.0214, 'lps'),
	(522931, 130, '2014-02-01 00:10:00.000000', 'consum', 0.0212, 'lps'),
	(522932, 130, '2014-02-01 00:10:01.000000', 'consum', 0.0226, 'lps'),
	(522933, 130, '2014-02-01 00:10:02.000000', 'consum', 0.0214, 'lps'),
	(522934, 130, '2014-02-01 00:10:03.000000', 'consum', 0.0218, 'lps'),
	(522935, 130, '2014-02-01 00:10:04.000000', 'consum', 0.0218, 'lps'),
	(522936, 130, '2014-02-01 00:10:05.000000', 'consum', 0.0211, 'lps'),
	(522937, 130, '2014-02-01 00:10:06.000000', 'consum', 0.0227, 'lps'),
	(522938, 130, '2014-02-01 00:10:07.000000', 'consum', 0.0218, 'lps'),
	(522939, 130, '2014-02-01 00:10:08.000000', 'consum', 0.0220, 'lps'),
	(522940, 130, '2014-02-01 00:10:09.000000', 'consum', 0.0217, 'lps'),
	(522941, 130, '2014-02-01 00:10:10.000000', 'consum', 0.0217, 'lps'),
	(522942, 130, '2014-02-01 00:10:11.000000', 'consum', 0.0222, 'lps'),
	(522943, 130, '2014-02-01 00:10:12.000000', 'consum', 0.0214, 'lps'),
	(522944, 130, '2014-02-01 00:10:13.000000', 'consum', 0.0215, 'lps'),
	(522945, 130, '2014-02-01 00:10:14.000000', 'consum', 0.0221, 'lps'),
	(522946, 130, '2014-02-01 00:10:15.000000', 'consum', 0.0216, 'lps'),
	(522947, 130, '2014-02-01 00:10:16.000000', 'consum', 0.0225, 'lps'),
	(522948, 130, '2014-02-01 00:10:17.000000', 'consum', 0.0214, 'lps'),
	(522949, 130, '2014-02-01 00:10:18.000000', 'consum', 0.0221, 'lps'),
	(522950, 130, '2014-02-01 00:10:19.000000', 'consum', 0.0219, 'lps'),
	(522951, 130, '2014-02-01 00:10:20.000000', 'consum', 0.0221, 'lps'),
	(522952, 130, '2014-02-01 00:10:21.000000', 'consum', 0.0220, 'lps'),
	(522953, 130, '2014-02-01 00:10:22.000000', 'consum', 0.0212, 'lps'),
	(522954, 130, '2014-02-01 00:10:23.000000', 'consum', 0.0224, 'lps'),
	(522955, 130, '2014-02-01 00:10:24.000000', 'consum', 0.0222, 'lps'),
	(522956, 130, '2014-02-01 00:10:25.000000', 'consum', 0.0226, 'lps'),
	(522957, 130, '2014-02-01 00:10:26.000000', 'consum', 0.0220, 'lps'),
	(522958, 130, '2014-02-01 00:10:27.000000', 'consum', 0.0214, 'lps'),
	(522959, 130, '2014-02-01 00:10:28.000000', 'consum', 0.0216, 'lps'),
	(522960, 130, '2014-02-01 00:10:29.000000', 'consum', 0.0211, 'lps'),
	(522961, 130, '2014-02-01 00:10:30.000000', 'consum', 0.0215, 'lps'),
	(522962, 130, '2014-02-01 00:10:31.000000', 'consum', 0.0216, 'lps'),
	(522963, 130, '2014-02-01 00:10:32.000000', 'consum', 0.0227, 'lps'),
	(522964, 130, '2014-02-01 00:10:33.000000', 'consum', 0.0222, 'lps'),
	(522965, 130, '2014-02-01 00:10:34.000000', 'consum', 0.0218, 'lps'),
	(522966, 130, '2014-02-01 00:10:35.000000', 'consum', 0.0216, 'lps'),
	(522967, 130, '2014-02-01 00:10:36.000000', 'consum', 0.0215, 'lps'),
	(522968, 130, '2014-02-01 00:10:37.000000', 'consum', 0.0220, 'lps'),
	(522969, 130, '2014-02-01 00:10:38.000000', 'consum', 0.0227, 'lps'),
	(522970, 130, '2014-02-01 00:10:39.000000', 'consum', 0.0227, 'lps'),
	(522971, 130, '2014-02-01 00:10:40.000000', 'consum', 0.0210, 'lps'),
	(522972, 130, '2014-02-01 00:10:41.000000', 'consum', 0.0212, 'lps'),
	(522973, 130, '2014-02-01 00:10:42.000000', 'consum', 0.0220, 'lps'),
	(522974, 130, '2014-02-01 00:10:43.000000', 'consum', 0.0222, 'lps'),
	(522975, 130, '2014-02-01 00:10:44.000000', 'consum', 0.0219, 'lps'),
	(522976, 130, '2014-02-01 00:10:45.000000', 'consum', 0.0221, 'lps'),
	(522977, 130, '2014-02-01 00:10:46.000000', 'consum', 0.0221, 'lps'),
	(522978, 130, '2014-02-01 00:10:47.000000', 'consum', 0.0215, 'lps'),
	(522979, 130, '2014-02-01 00:10:48.000000', 'consum', 0.0221, 'lps'),
	(522980, 130, '2014-02-01 00:10:49.000000', 'consum', 0.0214, 'lps'),
	(522981, 130, '2014-02-01 00:10:50.000000', 'consum', 0.0217, 'lps'),
	(522982, 130, '2014-02-01 00:10:51.000000', 'consum', 0.0214, 'lps'),
	(522983, 130, '2014-02-01 00:10:52.000000', 'consum', 0.0211, 'lps'),
	(522984, 130, '2014-02-01 00:10:53.000000', 'consum', 0.0220, 'lps'),
	(522985, 130, '2014-02-01 00:10:54.000000', 'consum', 0.0224, 'lps'),
	(522986, 130, '2014-02-01 00:10:55.000000', 'consum', 0.0211, 'lps'),
	(522987, 130, '2014-02-01 00:10:56.000000', 'consum', 0.0212, 'lps'),
	(522988, 130, '2014-02-01 00:10:57.000000', 'consum', 0.0216, 'lps'),
	(522989, 130, '2014-02-01 00:10:58.000000', 'consum', 0.0219, 'lps'),
	(522990, 130, '2014-02-01 00:10:59.000000', 'consum', 0.0216, 'lps'),
	(522991, 130, '2014-02-01 00:11:00.000000', 'consum', 0.0216, 'lps'),
	(522992, 130, '2014-02-01 00:11:01.000000', 'consum', 0.0221, 'lps'),
	(522993, 130, '2014-02-01 00:11:02.000000', 'consum', 0.0211, 'lps'),
	(522994, 130, '2014-02-01 00:11:03.000000', 'consum', 0.0221, 'lps'),
	(522995, 130, '2014-02-01 00:11:04.000000', 'consum', 0.0226, 'lps'),
	(522996, 130, '2014-02-01 00:11:05.000000', 'consum', 0.0223, 'lps'),
	(522997, 130, '2014-02-01 00:11:06.000000', 'consum', 0.0226, 'lps'),
	(522998, 130, '2014-02-01 00:11:07.000000', 'consum', 0.0216, 'lps'),
	(522999, 130, '2014-02-01 00:11:08.000000', 'consum', 0.0211, 'lps'),
	(523000, 130, '2014-02-01 00:11:09.000000', 'consum', 0.0216, 'lps'),
	(523001, 130, '2014-02-01 00:11:10.000000', 'consum', 0.0218, 'lps'),
	(523002, 130, '2014-02-01 00:11:11.000000', 'consum', 0.0213, 'lps'),
	(523003, 130, '2014-02-01 00:11:12.000000', 'consum', 0.0221, 'lps'),
	(523004, 130, '2014-02-01 00:11:13.000000', 'consum', 0.0221, 'lps'),
	(523005, 130, '2014-02-01 00:11:14.000000', 'consum', 0.0214, 'lps'),
	(523006, 130, '2014-02-01 00:11:15.000000', 'consum', 0.0217, 'lps'),
	(523007, 130, '2014-02-01 00:11:16.000000', 'consum', 0.0213, 'lps'),
	(523008, 130, '2014-02-01 00:11:17.000000', 'consum', 0.0221, 'lps'),
	(523009, 130, '2014-02-01 00:11:18.000000', 'consum', 0.0224, 'lps'),
	(523010, 130, '2014-02-01 00:11:19.000000', 'consum', 0.0212, 'lps'),
	(523011, 130, '2014-02-01 00:11:20.000000', 'consum', 0.0213, 'lps'),
	(523012, 130, '2014-02-01 00:11:21.000000', 'consum', 0.0222, 'lps'),
	(523013, 130, '2014-02-01 00:11:22.000000', 'consum', 0.0222, 'lps'),
	(523014, 130, '2014-02-01 00:11:23.000000', 'consum', 0.0218, 'lps'),
	(523015, 130, '2014-02-01 00:11:24.000000', 'consum', 0.0213, 'lps'),
	(523016, 130, '2014-02-01 00:11:25.000000', 'consum', 0.0219, 'lps'),
	(523017, 130, '2014-02-01 00:11:26.000000', 'consum', 0.0210, 'lps'),
	(523018, 130, '2014-02-01 00:11:27.000000', 'consum', 0.0222, 'lps'),
	(523019, 130, '2014-02-01 00:11:28.000000', 'consum', 0.0213, 'lps'),
	(523020, 130, '2014-02-01 00:11:29.000000', 'consum', 0.0211, 'lps'),
	(523021, 130, '2014-02-01 00:11:30.000000', 'consum', 0.0224, 'lps'),
	(523022, 130, '2014-02-01 00:11:31.000000', 'consum', 0.0225, 'lps'),
	(523023, 130, '2014-02-01 00:11:32.000000', 'consum', 0.0224, 'lps'),
	(523024, 130, '2014-02-01 00:11:33.000000', 'consum', 0.0216, 'lps'),
	(523025, 130, '2014-02-01 00:11:34.000000', 'consum', 0.0218, 'lps'),
	(523026, 130, '2014-02-01 00:11:35.000000', 'consum', 0.0212, 'lps'),
	(523027, 130, '2014-02-01 00:11:36.000000', 'consum', 0.0216, 'lps'),
	(523028, 130, '2014-02-01 00:11:37.000000', 'consum', 0.0218, 'lps'),
	(523029, 130, '2014-02-01 00:11:38.000000', 'consum', 0.0215, 'lps'),
	(523030, 130, '2014-02-01 00:11:39.000000', 'consum', 0.0212, 'lps'),
	(523031, 130, '2014-02-01 00:11:40.000000', 'consum', 0.0223, 'lps'),
	(523032, 130, '2014-02-01 00:11:41.000000', 'consum', 0.0215, 'lps'),
	(523033, 130, '2014-02-01 00:11:42.000000', 'consum', 0.0214, 'lps'),
	(523034, 130, '2014-02-01 00:11:43.000000', 'consum', 0.0217, 'lps'),
	(523035, 130, '2014-02-01 00:11:44.000000', 'consum', 0.0215, 'lps'),
	(523036, 130, '2014-02-01 00:11:45.000000', 'consum', 0.0213, 'lps'),
	(523037, 130, '2014-02-01 00:11:46.000000', 'consum', 0.0211, 'lps'),
	(523038, 130, '2014-02-01 00:11:47.000000', 'consum', 0.0223, 'lps'),
	(523039, 130, '2014-02-01 00:11:48.000000', 'consum', 0.0221, 'lps'),
	(523040, 130, '2014-02-01 00:11:49.000000', 'consum', 0.0224, 'lps'),
	(523041, 130, '2014-02-01 00:11:50.000000', 'consum', 0.0214, 'lps'),
	(523042, 130, '2014-02-01 00:11:51.000000', 'consum', 0.0224, 'lps'),
	(523043, 130, '2014-02-01 00:11:52.000000', 'consum', 0.0216, 'lps'),
	(523044, 130, '2014-02-01 00:11:53.000000', 'consum', 0.0215, 'lps'),
	(523045, 130, '2014-02-01 00:11:54.000000', 'consum', 0.0217, 'lps'),
	(523046, 130, '2014-02-01 00:11:55.000000', 'consum', 0.0213, 'lps'),
	(523047, 130, '2014-02-01 00:11:56.000000', 'consum', 0.0221, 'lps'),
	(523048, 130, '2014-02-01 00:11:57.000000', 'consum', 0.0222, 'lps'),
	(523049, 130, '2014-02-01 00:11:58.000000', 'consum', 0.0217, 'lps'),
	(523050, 130, '2014-02-01 00:11:59.000000', 'consum', 0.0212, 'lps'),
	(523051, 130, '2014-02-01 00:12:00.000000', 'consum', 0.0217, 'lps'),
	(523052, 130, '2014-02-01 00:12:01.000000', 'consum', 0.0222, 'lps'),
	(523053, 130, '2014-02-01 00:12:02.000000', 'consum', 0.0213, 'lps'),
	(523054, 130, '2014-02-01 00:12:03.000000', 'consum', 0.0224, 'lps'),
	(523055, 130, '2014-02-01 00:12:04.000000', 'consum', 0.0220, 'lps'),
	(523056, 130, '2014-02-01 00:12:05.000000', 'consum', 0.0218, 'lps'),
	(523057, 130, '2014-02-01 00:12:06.000000', 'consum', 0.0220, 'lps'),
	(523058, 130, '2014-02-01 00:12:07.000000', 'consum', 0.0220, 'lps'),
	(523059, 130, '2014-02-01 00:12:08.000000', 'consum', 0.0210, 'lps'),
	(523060, 130, '2014-02-01 00:12:09.000000', 'consum', 0.0216, 'lps'),
	(523061, 130, '2014-02-01 00:12:10.000000', 'consum', 0.0224, 'lps'),
	(523062, 130, '2014-02-01 00:12:11.000000', 'consum', 0.0227, 'lps'),
	(523063, 130, '2014-02-01 00:12:12.000000', 'consum', 0.0218, 'lps'),
	(523064, 130, '2014-02-01 00:12:13.000000', 'consum', 0.0218, 'lps'),
	(523065, 130, '2014-02-01 00:12:14.000000', 'consum', 0.0226, 'lps'),
	(523066, 130, '2014-02-01 00:12:15.000000', 'consum', 0.0210, 'lps'),
	(523067, 130, '2014-02-01 00:12:16.000000', 'consum', 0.0219, 'lps'),
	(523068, 130, '2014-02-01 00:12:17.000000', 'consum', 0.0219, 'lps'),
	(523069, 130, '2014-02-01 00:12:18.000000', 'consum', 0.0211, 'lps'),
	(523070, 130, '2014-02-01 00:12:19.000000', 'consum', 0.0226, 'lps'),
	(523071, 130, '2014-02-01 00:12:20.000000', 'consum', 0.0215, 'lps'),
	(523072, 130, '2014-02-01 00:12:21.000000', 'consum', 0.0221, 'lps'),
	(523073, 130, '2014-02-01 00:12:22.000000', 'consum', 0.0216, 'lps'),
	(523074, 130, '2014-02-01 00:12:23.000000', 'consum', 0.0227, 'lps'),
	(523075, 130, '2014-02-01 00:12:24.000000', 'consum', 0.0220, 'lps'),
	(523076, 130, '2014-02-01 00:12:25.000000', 'consum', 0.0213, 'lps'),
	(523077, 130, '2014-02-01 00:12:26.000000', 'consum', 0.0211, 'lps'),
	(523078, 130, '2014-02-01 00:12:27.000000', 'consum', 0.0227, 'lps'),
	(523079, 130, '2014-02-01 00:12:28.000000', 'consum', 0.0218, 'lps'),
	(523080, 130, '2014-02-01 00:12:29.000000', 'consum', 0.0220, 'lps'),
	(523081, 130, '2014-02-01 00:12:30.000000', 'consum', 0.0217, 'lps'),
	(523082, 130, '2014-02-01 00:12:31.000000', 'consum', 0.0215, 'lps'),
	(523083, 130, '2014-02-01 00:12:32.000000', 'consum', 0.0217, 'lps'),
	(523084, 130, '2014-02-01 00:12:33.000000', 'consum', 0.0211, 'lps'),
	(523085, 130, '2014-02-01 00:12:34.000000', 'consum', 0.0215, 'lps'),
	(523086, 130, '2014-02-01 00:12:35.000000', 'consum', 0.0211, 'lps'),
	(523087, 130, '2014-02-01 00:12:36.000000', 'consum', 0.0222, 'lps'),
	(523088, 130, '2014-02-01 00:12:37.000000', 'consum', 0.0211, 'lps'),
	(523089, 130, '2014-02-01 00:12:38.000000', 'consum', 0.0215, 'lps'),
	(523090, 130, '2014-02-01 00:12:39.000000', 'consum', 0.0215, 'lps'),
	(523091, 130, '2014-02-01 00:12:40.000000', 'consum', 0.0222, 'lps'),
	(523092, 130, '2014-02-01 00:12:41.000000', 'consum', 0.0219, 'lps'),
	(523093, 130, '2014-02-01 00:12:42.000000', 'consum', 0.0217, 'lps'),
	(523094, 130, '2014-02-01 00:12:43.000000', 'consum', 0.0220, 'lps'),
	(523095, 130, '2014-02-01 00:12:44.000000', 'consum', 0.0223, 'lps'),
	(523096, 130, '2014-02-01 00:12:45.000000', 'consum', 0.0210, 'lps'),
	(523097, 130, '2014-02-01 00:12:46.000000', 'consum', 0.0223, 'lps'),
	(523098, 130, '2014-02-01 00:12:47.000000', 'consum', 0.0224, 'lps'),
	(523099, 130, '2014-02-01 00:12:48.000000', 'consum', 0.0222, 'lps'),
	(523100, 130, '2014-02-01 00:12:49.000000', 'consum', 0.0212, 'lps'),
	(523101, 130, '2014-02-01 00:12:50.000000', 'consum', 0.0219, 'lps'),
	(523102, 130, '2014-02-01 00:12:51.000000', 'consum', 0.0215, 'lps'),
	(523103, 130, '2014-02-01 00:12:52.000000', 'consum', 0.0224, 'lps'),
	(523104, 130, '2014-02-01 00:12:53.000000', 'consum', 0.0213, 'lps'),
	(523105, 130, '2014-02-01 00:12:54.000000', 'consum', 0.0219, 'lps'),
	(523106, 130, '2014-02-01 00:12:55.000000', 'consum', 0.0212, 'lps'),
	(523107, 130, '2014-02-01 00:12:56.000000', 'consum', 0.0210, 'lps'),
	(523108, 130, '2014-02-01 00:12:57.000000', 'consum', 0.0225, 'lps'),
	(523109, 130, '2014-02-01 00:12:58.000000', 'consum', 0.0211, 'lps'),
	(523110, 130, '2014-02-01 00:12:59.000000', 'consum', 0.0226, 'lps'),
	(523111, 130, '2014-02-01 00:13:00.000000', 'consum', 0.0215, 'lps'),
	(523112, 130, '2014-02-01 00:13:01.000000', 'consum', 0.0225, 'lps'),
	(523113, 130, '2014-02-01 00:13:02.000000', 'consum', 0.0214, 'lps'),
	(523114, 130, '2014-02-01 00:13:03.000000', 'consum', 0.0222, 'lps'),
	(523115, 130, '2014-02-01 00:13:04.000000', 'consum', 0.0223, 'lps'),
	(523116, 130, '2014-02-01 00:13:05.000000', 'consum', 0.0223, 'lps'),
	(523117, 130, '2014-02-01 00:13:06.000000', 'consum', 0.0216, 'lps'),
	(523118, 130, '2014-02-01 00:13:07.000000', 'consum', 0.0220, 'lps'),
	(523119, 130, '2014-02-01 00:13:08.000000', 'consum', 0.0224, 'lps'),
	(523120, 130, '2014-02-01 00:13:09.000000', 'consum', 0.0217, 'lps'),
	(523121, 130, '2014-02-01 00:13:10.000000', 'consum', 0.0219, 'lps'),
	(523122, 130, '2014-02-01 00:13:11.000000', 'consum', 0.0216, 'lps'),
	(523123, 130, '2014-02-01 00:13:12.000000', 'consum', 0.0213, 'lps'),
	(523124, 130, '2014-02-01 00:13:13.000000', 'consum', 0.0226, 'lps'),
	(523125, 130, '2014-02-01 00:13:14.000000', 'consum', 0.0210, 'lps'),
	(523126, 130, '2014-02-01 00:13:15.000000', 'consum', 0.0215, 'lps'),
	(523127, 130, '2014-02-01 00:13:16.000000', 'consum', 0.0220, 'lps'),
	(523128, 130, '2014-02-01 00:13:17.000000', 'consum', 0.0227, 'lps'),
	(523129, 130, '2014-02-01 00:13:18.000000', 'consum', 0.0213, 'lps'),
	(523130, 130, '2014-02-01 00:13:19.000000', 'consum', 0.0226, 'lps'),
	(523131, 130, '2014-02-01 00:13:20.000000', 'consum', 0.0211, 'lps'),
	(523132, 130, '2014-02-01 00:13:21.000000', 'consum', 0.0221, 'lps'),
	(523133, 130, '2014-02-01 00:13:22.000000', 'consum', 0.0225, 'lps'),
	(523134, 130, '2014-02-01 00:13:23.000000', 'consum', 0.0219, 'lps'),
	(523135, 130, '2014-02-01 00:13:24.000000', 'consum', 0.0227, 'lps'),
	(523136, 130, '2014-02-01 00:13:25.000000', 'consum', 0.0214, 'lps'),
	(523137, 130, '2014-02-01 00:13:26.000000', 'consum', 0.0217, 'lps'),
	(523138, 130, '2014-02-01 00:13:27.000000', 'consum', 0.0216, 'lps'),
	(523139, 130, '2014-02-01 00:13:28.000000', 'consum', 0.0218, 'lps'),
	(523140, 130, '2014-02-01 00:13:29.000000', 'consum', 0.0216, 'lps'),
	(523141, 130, '2014-02-01 00:13:30.000000', 'consum', 0.0215, 'lps'),
	(523142, 130, '2014-02-01 00:13:31.000000', 'consum', 0.0217, 'lps'),
	(523143, 130, '2014-02-01 00:13:32.000000', 'consum', 0.0213, 'lps'),
	(523144, 130, '2014-02-01 00:13:33.000000', 'consum', 0.0221, 'lps'),
	(523145, 130, '2014-02-01 00:13:34.000000', 'consum', 0.0223, 'lps'),
	(523146, 130, '2014-02-01 00:13:35.000000', 'consum', 0.0224, 'lps'),
	(523147, 130, '2014-02-01 00:13:36.000000', 'consum', 0.0221, 'lps'),
	(523148, 130, '2014-02-01 00:13:37.000000', 'consum', 0.0226, 'lps'),
	(523149, 130, '2014-02-01 00:13:38.000000', 'consum', 0.0222, 'lps'),
	(523150, 130, '2014-02-01 00:13:39.000000', 'consum', 0.0220, 'lps'),
	(523151, 130, '2014-02-01 00:13:40.000000', 'consum', 0.0226, 'lps'),
	(523152, 130, '2014-02-01 00:13:41.000000', 'consum', 0.0224, 'lps'),
	(523153, 130, '2014-02-01 00:13:42.000000', 'consum', 0.0216, 'lps'),
	(523154, 130, '2014-02-01 00:13:43.000000', 'consum', 0.0216, 'lps'),
	(523155, 130, '2014-02-01 00:13:44.000000', 'consum', 0.0220, 'lps'),
	(523156, 130, '2014-02-01 00:13:45.000000', 'consum', 0.0227, 'lps'),
	(523157, 130, '2014-02-01 00:13:46.000000', 'consum', 0.0213, 'lps'),
	(523158, 130, '2014-02-01 00:13:47.000000', 'consum', 0.0226, 'lps'),
	(523159, 130, '2014-02-01 00:13:48.000000', 'consum', 0.0227, 'lps'),
	(523160, 130, '2014-02-01 00:13:49.000000', 'consum', 0.0213, 'lps'),
	(523161, 130, '2014-02-01 00:13:50.000000', 'consum', 0.0211, 'lps'),
	(523162, 130, '2014-02-01 00:13:51.000000', 'consum', 0.0223, 'lps'),
	(523163, 130, '2014-02-01 00:13:52.000000', 'consum', 0.0219, 'lps'),
	(523164, 130, '2014-02-01 00:13:53.000000', 'consum', 0.0217, 'lps'),
	(523165, 130, '2014-02-01 00:13:54.000000', 'consum', 0.0217, 'lps'),
	(523166, 130, '2014-02-01 00:13:55.000000', 'consum', 0.0224, 'lps'),
	(523167, 130, '2014-02-01 00:13:56.000000', 'consum', 0.0223, 'lps'),
	(523168, 130, '2014-02-01 00:13:57.000000', 'consum', 0.0216, 'lps'),
	(523169, 130, '2014-02-01 00:13:58.000000', 'consum', 0.0221, 'lps'),
	(523170, 130, '2014-02-01 00:13:59.000000', 'consum', 0.0212, 'lps'),
	(523171, 130, '2014-02-01 00:14:00.000000', 'consum', 0.0222, 'lps'),
	(523172, 130, '2014-02-01 00:14:01.000000', 'consum', 0.0227, 'lps'),
	(523173, 130, '2014-02-01 00:14:02.000000', 'consum', 0.0227, 'lps'),
	(523174, 130, '2014-02-01 00:14:03.000000', 'consum', 0.0224, 'lps'),
	(523175, 130, '2014-02-01 00:14:04.000000', 'consum', 0.0210, 'lps'),
	(523176, 130, '2014-02-01 00:14:05.000000', 'consum', 0.0225, 'lps'),
	(523177, 130, '2014-02-01 00:14:06.000000', 'consum', 0.0212, 'lps'),
	(523178, 130, '2014-02-01 00:14:07.000000', 'consum', 0.0214, 'lps'),
	(523179, 130, '2014-02-01 00:14:08.000000', 'consum', 0.0222, 'lps'),
	(523180, 130, '2014-02-01 00:14:09.000000', 'consum', 0.0221, 'lps'),
	(523181, 130, '2014-02-01 00:14:10.000000', 'consum', 0.0215, 'lps'),
	(523182, 130, '2014-02-01 00:14:11.000000', 'consum', 0.0219, 'lps'),
	(523183, 130, '2014-02-01 00:14:12.000000', 'consum', 0.0221, 'lps'),
	(523184, 130, '2014-02-01 00:14:13.000000', 'consum', 0.0223, 'lps'),
	(523185, 130, '2014-02-01 00:14:14.000000', 'consum', 0.0223, 'lps'),
	(523186, 130, '2014-02-01 00:14:15.000000', 'consum', 0.0218, 'lps'),
	(523187, 130, '2014-02-01 00:14:16.000000', 'consum', 0.0213, 'lps'),
	(523188, 130, '2014-02-01 00:14:17.000000', 'consum', 0.0219, 'lps'),
	(523189, 130, '2014-02-01 00:14:18.000000', 'consum', 0.0211, 'lps'),
	(523190, 130, '2014-02-01 00:14:19.000000', 'consum', 0.0223, 'lps'),
	(523191, 130, '2014-02-01 00:14:20.000000', 'consum', 0.0220, 'lps'),
	(523192, 130, '2014-02-01 00:14:21.000000', 'consum', 0.0219, 'lps'),
	(523193, 130, '2014-02-01 00:14:22.000000', 'consum', 0.0211, 'lps'),
	(523194, 130, '2014-02-01 00:14:23.000000', 'consum', 0.0221, 'lps'),
	(523195, 130, '2014-02-01 00:14:24.000000', 'consum', 0.0210, 'lps'),
	(523196, 130, '2014-02-01 00:14:25.000000', 'consum', 0.0213, 'lps'),
	(523197, 130, '2014-02-01 00:14:26.000000', 'consum', 0.0224, 'lps'),
	(523198, 130, '2014-02-01 00:14:27.000000', 'consum', 0.0220, 'lps'),
	(523199, 130, '2014-02-01 00:14:28.000000', 'consum', 0.0216, 'lps'),
	(523200, 130, '2014-02-01 00:14:29.000000', 'consum', 0.0211, 'lps'),
	(523201, 130, '2014-02-01 00:14:30.000000', 'consum', 0.0215, 'lps'),
	(523202, 130, '2014-02-01 00:14:31.000000', 'consum', 0.0216, 'lps'),
	(523203, 130, '2014-02-01 00:14:32.000000', 'consum', 0.0226, 'lps'),
	(523204, 130, '2014-02-01 00:14:33.000000', 'consum', 0.0218, 'lps'),
	(523205, 130, '2014-02-01 00:14:34.000000', 'consum', 0.0221, 'lps'),
	(523206, 130, '2014-02-01 00:14:35.000000', 'consum', 0.0222, 'lps'),
	(523207, 130, '2014-02-01 00:14:36.000000', 'consum', 0.0220, 'lps'),
	(523208, 130, '2014-02-01 00:14:37.000000', 'consum', 0.0225, 'lps'),
	(523209, 130, '2014-02-01 00:14:38.000000', 'consum', 0.0219, 'lps'),
	(523210, 130, '2014-02-01 00:14:39.000000', 'consum', 0.0211, 'lps'),
	(523211, 130, '2014-02-01 00:14:40.000000', 'consum', 0.0223, 'lps'),
	(523212, 130, '2014-02-01 00:14:41.000000', 'consum', 0.0218, 'lps'),
	(523213, 130, '2014-02-01 00:14:42.000000', 'consum', 0.0212, 'lps'),
	(523214, 130, '2014-02-01 00:14:43.000000', 'consum', 0.0213, 'lps'),
	(523215, 130, '2014-02-01 00:14:44.000000', 'consum', 0.0222, 'lps'),
	(523216, 130, '2014-02-01 00:14:45.000000', 'consum', 0.0223, 'lps'),
	(523217, 130, '2014-02-01 00:14:46.000000', 'consum', 0.0223, 'lps'),
	(523218, 130, '2014-02-01 00:14:47.000000', 'consum', 0.0220, 'lps'),
	(523219, 130, '2014-02-01 00:14:48.000000', 'consum', 0.0221, 'lps'),
	(523220, 130, '2014-02-01 00:14:49.000000', 'consum', 0.0217, 'lps'),
	(523221, 130, '2014-02-01 00:14:50.000000', 'consum', 0.0213, 'lps'),
	(523222, 130, '2014-02-01 00:14:51.000000', 'consum', 0.0221, 'lps'),
	(523223, 130, '2014-02-01 00:14:52.000000', 'consum', 0.0222, 'lps'),
	(523224, 130, '2014-02-01 00:14:53.000000', 'consum', 0.0219, 'lps'),
	(523225, 130, '2014-02-01 00:14:54.000000', 'consum', 0.0220, 'lps'),
	(523226, 130, '2014-02-01 00:14:55.000000', 'consum', 0.0213, 'lps'),
	(523227, 130, '2014-02-01 00:14:56.000000', 'consum', 0.0217, 'lps'),
	(523228, 130, '2014-02-01 00:14:57.000000', 'consum', 0.0217, 'lps'),
	(523229, 130, '2014-02-01 00:14:58.000000', 'consum', 0.0225, 'lps'),
	(523230, 130, '2014-02-01 00:14:59.000000', 'consum', 0.0212, 'lps'),
	(523231, 130, '2014-02-01 00:15:00.000000', 'consum', 0.0211, 'lps'),
	(523232, 130, '2014-02-01 00:15:01.000000', 'consum', 0.0211, 'lps'),
	(523233, 130, '2014-02-01 00:15:02.000000', 'consum', 0.0211, 'lps'),
	(523234, 130, '2014-02-01 00:15:03.000000', 'consum', 0.0211, 'lps'),
	(523235, 130, '2014-02-01 00:15:04.000000', 'consum', 0.0214, 'lps'),
	(523236, 130, '2014-02-01 00:15:05.000000', 'consum', 0.0227, 'lps'),
	(523237, 130, '2014-02-01 00:15:06.000000', 'consum', 0.0212, 'lps'),
	(523238, 130, '2014-02-01 00:15:07.000000', 'consum', 0.0224, 'lps'),
	(523239, 130, '2014-02-01 00:15:08.000000', 'consum', 0.0221, 'lps'),
	(523240, 130, '2014-02-01 00:15:09.000000', 'consum', 0.0223, 'lps'),
	(523241, 130, '2014-02-01 00:15:10.000000', 'consum', 0.0226, 'lps'),
	(523242, 130, '2014-02-01 00:15:11.000000', 'consum', 0.0213, 'lps'),
	(523243, 130, '2014-02-01 00:15:12.000000', 'consum', 0.0213, 'lps'),
	(523244, 130, '2014-02-01 00:15:13.000000', 'consum', 0.0216, 'lps'),
	(523245, 130, '2014-02-01 00:15:14.000000', 'consum', 0.0215, 'lps'),
	(523246, 130, '2014-02-01 00:15:15.000000', 'consum', 0.0218, 'lps'),
	(523247, 130, '2014-02-01 00:15:16.000000', 'consum', 0.0218, 'lps'),
	(523248, 130, '2014-02-01 00:15:17.000000', 'consum', 0.0224, 'lps'),
	(523249, 130, '2014-02-01 00:15:18.000000', 'consum', 0.0220, 'lps'),
	(523250, 130, '2014-02-01 00:15:19.000000', 'consum', 0.0220, 'lps'),
	(523251, 130, '2014-02-01 00:15:20.000000', 'consum', 0.0214, 'lps'),
	(523252, 130, '2014-02-01 00:15:21.000000', 'consum', 0.0218, 'lps'),
	(523253, 130, '2014-02-01 00:15:22.000000', 'consum', 0.0219, 'lps'),
	(523254, 130, '2014-02-01 00:15:23.000000', 'consum', 0.0214, 'lps'),
	(523255, 130, '2014-02-01 00:15:24.000000', 'consum', 0.0220, 'lps'),
	(523256, 130, '2014-02-01 00:15:25.000000', 'consum', 0.0215, 'lps'),
	(523257, 130, '2014-02-01 00:15:26.000000', 'consum', 0.0222, 'lps'),
	(523258, 130, '2014-02-01 00:15:27.000000', 'consum', 0.0218, 'lps'),
	(523259, 130, '2014-02-01 00:15:28.000000', 'consum', 0.0217, 'lps'),
	(523260, 130, '2014-02-01 00:15:29.000000', 'consum', 0.0219, 'lps'),
	(523261, 130, '2014-02-01 00:15:30.000000', 'consum', 0.0218, 'lps'),
	(523262, 130, '2014-02-01 00:15:31.000000', 'consum', 0.0223, 'lps'),
	(523263, 130, '2014-02-01 00:15:32.000000', 'consum', 0.0215, 'lps'),
	(523264, 130, '2014-02-01 00:15:33.000000', 'consum', 0.0215, 'lps'),
	(523265, 130, '2014-02-01 00:15:34.000000', 'consum', 0.0222, 'lps'),
	(523266, 130, '2014-02-01 00:15:35.000000', 'consum', 0.0217, 'lps'),
	(523267, 130, '2014-02-01 00:15:36.000000', 'consum', 0.0227, 'lps'),
	(523268, 130, '2014-02-01 00:15:37.000000', 'consum', 0.0220, 'lps'),
	(523269, 130, '2014-02-01 00:15:38.000000', 'consum', 0.0210, 'lps'),
	(523270, 130, '2014-02-01 00:15:39.000000', 'consum', 0.0218, 'lps'),
	(523271, 130, '2014-02-01 00:15:40.000000', 'consum', 0.0216, 'lps'),
	(523272, 130, '2014-02-01 00:15:41.000000', 'consum', 0.0213, 'lps'),
	(523273, 130, '2014-02-01 00:15:42.000000', 'consum', 0.0227, 'lps'),
	(523274, 130, '2014-02-01 00:15:43.000000', 'consum', 0.0216, 'lps'),
	(523275, 130, '2014-02-01 00:15:44.000000', 'consum', 0.0226, 'lps'),
	(523276, 130, '2014-02-01 00:15:45.000000', 'consum', 0.0217, 'lps'),
	(523277, 130, '2014-02-01 00:15:46.000000', 'consum', 0.0214, 'lps'),
	(523278, 130, '2014-02-01 00:15:47.000000', 'consum', 0.0211, 'lps'),
	(523279, 130, '2014-02-01 00:15:48.000000', 'consum', 0.0220, 'lps'),
	(523280, 130, '2014-02-01 00:15:49.000000', 'consum', 0.0224, 'lps'),
	(523281, 130, '2014-02-01 00:15:50.000000', 'consum', 0.0215, 'lps'),
	(523282, 130, '2014-02-01 00:15:51.000000', 'consum', 0.0227, 'lps'),
	(523283, 130, '2014-02-01 00:15:52.000000', 'consum', 0.0210, 'lps'),
	(523284, 130, '2014-02-01 00:15:53.000000', 'consum', 0.0214, 'lps'),
	(523285, 130, '2014-02-01 00:15:54.000000', 'consum', 0.0214, 'lps'),
	(523286, 130, '2014-02-01 00:15:55.000000', 'consum', 0.0216, 'lps'),
	(523287, 130, '2014-02-01 00:15:56.000000', 'consum', 0.0211, 'lps'),
	(523288, 130, '2014-02-01 00:15:57.000000', 'consum', 0.0216, 'lps'),
	(523289, 130, '2014-02-01 00:15:58.000000', 'consum', 0.0218, 'lps'),
	(523290, 130, '2014-02-01 00:15:59.000000', 'consum', 0.0214, 'lps'),
	(523291, 130, '2014-02-01 00:16:00.000000', 'consum', 0.0226, 'lps'),
	(523292, 130, '2014-02-01 00:16:01.000000', 'consum', 0.0224, 'lps'),
	(523293, 130, '2014-02-01 00:16:02.000000', 'consum', 0.0213, 'lps'),
	(523294, 130, '2014-02-01 00:16:03.000000', 'consum', 0.0219, 'lps'),
	(523295, 130, '2014-02-01 00:16:04.000000', 'consum', 0.0211, 'lps'),
	(523296, 130, '2014-02-01 00:16:05.000000', 'consum', 0.0227, 'lps'),
	(523297, 130, '2014-02-01 00:16:06.000000', 'consum', 0.0219, 'lps'),
	(523298, 130, '2014-02-01 00:16:07.000000', 'consum', 0.0223, 'lps'),
	(523299, 130, '2014-02-01 00:16:08.000000', 'consum', 0.0211, 'lps'),
	(523300, 130, '2014-02-01 00:16:09.000000', 'consum', 0.0211, 'lps'),
	(523301, 130, '2014-02-01 00:16:10.000000', 'consum', 0.0216, 'lps'),
	(523302, 130, '2014-02-01 00:16:11.000000', 'consum', 0.0219, 'lps'),
	(523303, 130, '2014-02-01 00:16:12.000000', 'consum', 0.0218, 'lps'),
	(523304, 130, '2014-02-01 00:16:13.000000', 'consum', 0.0225, 'lps'),
	(523305, 130, '2014-02-01 00:16:14.000000', 'consum', 0.0227, 'lps'),
	(523306, 130, '2014-02-01 00:16:15.000000', 'consum', 0.0212, 'lps'),
	(523307, 130, '2014-02-01 00:16:16.000000', 'consum', 0.0223, 'lps'),
	(523308, 130, '2014-02-01 00:16:17.000000', 'consum', 0.0215, 'lps'),
	(523309, 130, '2014-02-01 00:16:18.000000', 'consum', 0.0215, 'lps'),
	(523310, 130, '2014-02-01 00:16:19.000000', 'consum', 0.0220, 'lps'),
	(523311, 130, '2014-02-01 00:16:20.000000', 'consum', 0.0212, 'lps'),
	(523312, 130, '2014-02-01 00:16:21.000000', 'consum', 0.0224, 'lps'),
	(523313, 130, '2014-02-01 00:16:22.000000', 'consum', 0.0222, 'lps'),
	(523314, 130, '2014-02-01 00:16:23.000000', 'consum', 0.0212, 'lps'),
	(523315, 130, '2014-02-01 00:16:24.000000', 'consum', 0.0219, 'lps'),
	(523316, 130, '2014-02-01 00:16:25.000000', 'consum', 0.0215, 'lps'),
	(523317, 130, '2014-02-01 00:16:26.000000', 'consum', 0.0226, 'lps'),
	(523318, 130, '2014-02-01 00:16:27.000000', 'consum', 0.0223, 'lps'),
	(523319, 130, '2014-02-01 00:16:28.000000', 'consum', 0.0227, 'lps'),
	(523320, 130, '2014-02-01 00:16:29.000000', 'consum', 0.0219, 'lps'),
	(523321, 130, '2014-02-01 00:16:30.000000', 'consum', 0.0223, 'lps'),
	(523322, 130, '2014-02-01 00:16:31.000000', 'consum', 0.0212, 'lps'),
	(523323, 130, '2014-02-01 00:16:32.000000', 'consum', 0.0216, 'lps'),
	(523324, 130, '2014-02-01 00:16:33.000000', 'consum', 0.0219, 'lps'),
	(523325, 130, '2014-02-01 00:16:34.000000', 'consum', 0.0218, 'lps'),
	(523326, 130, '2014-02-01 00:16:35.000000', 'consum', 0.0223, 'lps'),
	(523327, 130, '2014-02-01 00:16:36.000000', 'consum', 0.0214, 'lps'),
	(523328, 130, '2014-02-01 00:16:37.000000', 'consum', 0.0212, 'lps'),
	(523329, 130, '2014-02-01 00:16:38.000000', 'consum', 0.0226, 'lps'),
	(523330, 130, '2014-02-01 00:16:39.000000', 'consum', 0.0212, 'lps'),
	(523331, 130, '2014-02-01 00:16:40.000000', 'consum', 0.0210, 'lps'),
	(523332, 130, '2014-02-01 00:16:41.000000', 'consum', 0.0223, 'lps'),
	(523333, 130, '2014-02-01 00:16:42.000000', 'consum', 0.0221, 'lps'),
	(523334, 130, '2014-02-01 00:16:43.000000', 'consum', 0.0227, 'lps'),
	(523335, 130, '2014-02-01 00:16:44.000000', 'consum', 0.0227, 'lps'),
	(523336, 130, '2014-02-01 00:16:45.000000', 'consum', 0.0227, 'lps'),
	(523337, 130, '2014-02-01 00:16:46.000000', 'consum', 0.0227, 'lps'),
	(523338, 130, '2014-02-01 00:16:47.000000', 'consum', 0.0225, 'lps'),
	(523339, 130, '2014-02-01 00:16:48.000000', 'consum', 0.0218, 'lps'),
	(523340, 130, '2014-02-01 00:16:49.000000', 'consum', 0.0221, 'lps'),
	(523341, 130, '2014-02-01 00:16:50.000000', 'consum', 0.0227, 'lps'),
	(523342, 130, '2014-02-01 00:16:51.000000', 'consum', 0.0223, 'lps'),
	(523343, 130, '2014-02-01 00:16:52.000000', 'consum', 0.0225, 'lps'),
	(523344, 130, '2014-02-01 00:16:53.000000', 'consum', 0.0213, 'lps'),
	(523345, 130, '2014-02-01 00:16:54.000000', 'consum', 0.0216, 'lps'),
	(523346, 130, '2014-02-01 00:16:55.000000', 'consum', 0.0213, 'lps'),
	(523347, 130, '2014-02-01 00:16:56.000000', 'consum', 0.0225, 'lps'),
	(523348, 130, '2014-02-01 00:16:57.000000', 'consum', 0.0225, 'lps'),
	(523349, 130, '2014-02-01 00:16:58.000000', 'consum', 0.0220, 'lps'),
	(523350, 130, '2014-02-01 00:16:59.000000', 'consum', 0.0214, 'lps'),
	(523351, 130, '2014-02-01 00:17:00.000000', 'consum', 0.0221, 'lps'),
	(523352, 130, '2014-02-01 00:17:01.000000', 'consum', 0.0218, 'lps'),
	(523353, 130, '2014-02-01 00:17:02.000000', 'consum', 0.0215, 'lps'),
	(523354, 130, '2014-02-01 00:17:03.000000', 'consum', 0.0212, 'lps'),
	(523355, 130, '2014-02-01 00:17:04.000000', 'consum', 0.0224, 'lps'),
	(523356, 130, '2014-02-01 00:17:05.000000', 'consum', 0.0220, 'lps'),
	(523357, 130, '2014-02-01 00:17:06.000000', 'consum', 0.0220, 'lps'),
	(523358, 130, '2014-02-01 00:17:07.000000', 'consum', 0.0211, 'lps'),
	(523359, 130, '2014-02-01 00:17:08.000000', 'consum', 0.0220, 'lps'),
	(523360, 130, '2014-02-01 00:17:09.000000', 'consum', 0.0223, 'lps'),
	(523361, 130, '2014-02-01 00:17:10.000000', 'consum', 0.0210, 'lps'),
	(523362, 130, '2014-02-01 00:17:11.000000', 'consum', 0.0225, 'lps'),
	(523363, 130, '2014-02-01 00:17:12.000000', 'consum', 0.0214, 'lps'),
	(523364, 130, '2014-02-01 00:17:13.000000', 'consum', 0.0220, 'lps'),
	(523365, 130, '2014-02-01 00:17:14.000000', 'consum', 0.0213, 'lps'),
	(523366, 130, '2014-02-01 00:17:15.000000', 'consum', 0.0212, 'lps'),
	(523367, 130, '2014-02-01 00:17:16.000000', 'consum', 0.0214, 'lps'),
	(523368, 130, '2014-02-01 00:17:17.000000', 'consum', 0.0225, 'lps'),
	(523369, 130, '2014-02-01 00:17:18.000000', 'consum', 0.0217, 'lps'),
	(523370, 130, '2014-02-01 00:17:19.000000', 'consum', 0.0219, 'lps'),
	(523371, 130, '2014-02-01 00:17:20.000000', 'consum', 0.0216, 'lps'),
	(523372, 130, '2014-02-01 00:17:21.000000', 'consum', 0.0213, 'lps'),
	(523373, 130, '2014-02-01 00:17:22.000000', 'consum', 0.0226, 'lps'),
	(523374, 130, '2014-02-01 00:17:23.000000', 'consum', 0.0210, 'lps'),
	(523375, 130, '2014-02-01 00:17:24.000000', 'consum', 0.0215, 'lps'),
	(523376, 130, '2014-02-01 00:17:25.000000', 'consum', 0.0220, 'lps'),
	(523377, 130, '2014-02-01 00:17:26.000000', 'consum', 0.0210, 'lps'),
	(523378, 130, '2014-02-01 00:17:27.000000', 'consum', 0.0216, 'lps'),
	(523379, 130, '2014-02-01 00:17:28.000000', 'consum', 0.0220, 'lps'),
	(523380, 130, '2014-02-01 00:17:29.000000', 'consum', 0.0227, 'lps'),
	(523381, 130, '2014-02-01 00:17:30.000000', 'consum', 0.0227, 'lps'),
	(523382, 130, '2014-02-01 00:17:31.000000', 'consum', 0.0227, 'lps'),
	(523383, 130, '2014-02-01 00:17:32.000000', 'consum', 0.0210, 'lps'),
	(523384, 130, '2014-02-01 00:17:33.000000', 'consum', 0.0212, 'lps'),
	(523385, 130, '2014-02-01 00:17:34.000000', 'consum', 0.0221, 'lps'),
	(523386, 130, '2014-02-01 00:17:35.000000', 'consum', 0.0223, 'lps'),
	(523387, 130, '2014-02-01 00:17:36.000000', 'consum', 0.0224, 'lps'),
	(523388, 130, '2014-02-01 00:17:37.000000', 'consum', 0.0226, 'lps'),
	(523389, 130, '2014-02-01 00:17:38.000000', 'consum', 0.0227, 'lps'),
	(523390, 130, '2014-02-01 00:17:39.000000', 'consum', 0.0214, 'lps'),
	(523391, 130, '2014-02-01 00:17:40.000000', 'consum', 0.0213, 'lps'),
	(523392, 130, '2014-02-01 00:17:41.000000', 'consum', 0.0215, 'lps'),
	(523393, 130, '2014-02-01 00:17:42.000000', 'consum', 0.0226, 'lps'),
	(523394, 130, '2014-02-01 00:17:43.000000', 'consum', 0.0220, 'lps'),
	(523395, 130, '2014-02-01 00:17:44.000000', 'consum', 0.0213, 'lps'),
	(523396, 130, '2014-02-01 00:17:45.000000', 'consum', 0.0212, 'lps'),
	(523397, 130, '2014-02-01 00:17:46.000000', 'consum', 0.0213, 'lps'),
	(523398, 130, '2014-02-01 00:17:47.000000', 'consum', 0.0220, 'lps'),
	(523399, 130, '2014-02-01 00:17:48.000000', 'consum', 0.0213, 'lps'),
	(523400, 130, '2014-02-01 00:17:49.000000', 'consum', 0.0216, 'lps'),
	(523401, 130, '2014-02-01 00:17:50.000000', 'consum', 0.0214, 'lps'),
	(523402, 130, '2014-02-01 00:17:51.000000', 'consum', 0.0212, 'lps'),
	(523403, 130, '2014-02-01 00:17:52.000000', 'consum', 0.0226, 'lps'),
	(523404, 130, '2014-02-01 00:17:53.000000', 'consum', 0.0214, 'lps'),
	(523405, 130, '2014-02-01 00:17:54.000000', 'consum', 0.0218, 'lps'),
	(523406, 130, '2014-02-01 00:17:55.000000', 'consum', 0.0219, 'lps'),
	(523407, 130, '2014-02-01 00:17:56.000000', 'consum', 0.0214, 'lps'),
	(523408, 130, '2014-02-01 00:17:57.000000', 'consum', 0.0224, 'lps'),
	(523409, 130, '2014-02-01 00:17:58.000000', 'consum', 0.0212, 'lps'),
	(523410, 130, '2014-02-01 00:17:59.000000', 'consum', 0.0216, 'lps'),
	(523411, 130, '2014-02-01 00:18:00.000000', 'consum', 0.0215, 'lps'),
	(523412, 130, '2014-02-01 00:18:01.000000', 'consum', 0.0219, 'lps'),
	(523413, 130, '2014-02-01 00:18:02.000000', 'consum', 0.0223, 'lps'),
	(523414, 130, '2014-02-01 00:18:03.000000', 'consum', 0.0213, 'lps'),
	(523415, 130, '2014-02-01 00:18:04.000000', 'consum', 0.0222, 'lps'),
	(523416, 130, '2014-02-01 00:18:05.000000', 'consum', 0.0225, 'lps'),
	(523417, 130, '2014-02-01 00:18:06.000000', 'consum', 0.0213, 'lps'),
	(523418, 130, '2014-02-01 00:18:07.000000', 'consum', 0.0217, 'lps'),
	(523419, 130, '2014-02-01 00:18:08.000000', 'consum', 0.0217, 'lps'),
	(523420, 130, '2014-02-01 00:18:09.000000', 'consum', 0.0225, 'lps'),
	(523421, 130, '2014-02-01 00:18:10.000000', 'consum', 0.0211, 'lps'),
	(523422, 130, '2014-02-01 00:18:11.000000', 'consum', 0.0226, 'lps'),
	(523423, 130, '2014-02-01 00:18:12.000000', 'consum', 0.0213, 'lps'),
	(523424, 130, '2014-02-01 00:18:13.000000', 'consum', 0.0215, 'lps'),
	(523425, 130, '2014-02-01 00:18:14.000000', 'consum', 0.0227, 'lps'),
	(523426, 130, '2014-02-01 00:18:15.000000', 'consum', 0.0225, 'lps'),
	(523427, 130, '2014-02-01 00:18:16.000000', 'consum', 0.0217, 'lps'),
	(523428, 130, '2014-02-01 00:18:17.000000', 'consum', 0.0221, 'lps'),
	(523429, 130, '2014-02-01 00:18:18.000000', 'consum', 0.0223, 'lps'),
	(523430, 130, '2014-02-01 00:18:19.000000', 'consum', 0.0226, 'lps'),
	(523431, 130, '2014-02-01 00:18:20.000000', 'consum', 0.0215, 'lps'),
	(523432, 130, '2014-02-01 00:18:21.000000', 'consum', 0.0222, 'lps'),
	(523433, 130, '2014-02-01 00:18:22.000000', 'consum', 0.0220, 'lps'),
	(523434, 130, '2014-02-01 00:18:23.000000', 'consum', 0.0226, 'lps'),
	(523435, 130, '2014-02-01 00:18:24.000000', 'consum', 0.0225, 'lps'),
	(523436, 130, '2014-02-01 00:18:25.000000', 'consum', 0.0219, 'lps'),
	(523437, 130, '2014-02-01 00:18:26.000000', 'consum', 0.0227, 'lps'),
	(523438, 130, '2014-02-01 00:18:27.000000', 'consum', 0.0217, 'lps'),
	(523439, 130, '2014-02-01 00:18:28.000000', 'consum', 0.0227, 'lps'),
	(523440, 130, '2014-02-01 00:18:29.000000', 'consum', 0.0223, 'lps'),
	(523441, 130, '2014-02-01 00:18:30.000000', 'consum', 0.0225, 'lps'),
	(523442, 130, '2014-02-01 00:18:31.000000', 'consum', 0.0210, 'lps'),
	(523443, 130, '2014-02-01 00:18:32.000000', 'consum', 0.0218, 'lps'),
	(523444, 130, '2014-02-01 00:18:33.000000', 'consum', 0.0214, 'lps'),
	(523445, 130, '2014-02-01 00:18:34.000000', 'consum', 0.0224, 'lps'),
	(523446, 130, '2014-02-01 00:18:35.000000', 'consum', 0.0215, 'lps'),
	(523447, 130, '2014-02-01 00:18:36.000000', 'consum', 0.0212, 'lps'),
	(523448, 130, '2014-02-01 00:18:37.000000', 'consum', 0.0222, 'lps'),
	(523449, 130, '2014-02-01 00:18:38.000000', 'consum', 0.0211, 'lps'),
	(523450, 130, '2014-02-01 00:18:39.000000', 'consum', 0.0215, 'lps'),
	(523451, 130, '2014-02-01 00:18:40.000000', 'consum', 0.0216, 'lps'),
	(523452, 130, '2014-02-01 00:18:41.000000', 'consum', 0.0224, 'lps'),
	(523453, 130, '2014-02-01 00:18:42.000000', 'consum', 0.0227, 'lps'),
	(523454, 130, '2014-02-01 00:18:43.000000', 'consum', 0.0218, 'lps'),
	(523455, 130, '2014-02-01 00:18:44.000000', 'consum', 0.0216, 'lps'),
	(523456, 130, '2014-02-01 00:18:45.000000', 'consum', 0.0217, 'lps'),
	(523457, 130, '2014-02-01 00:18:46.000000', 'consum', 0.0212, 'lps'),
	(523458, 130, '2014-02-01 00:18:47.000000', 'consum', 0.0215, 'lps'),
	(523459, 130, '2014-02-01 00:18:48.000000', 'consum', 0.0213, 'lps'),
	(523460, 130, '2014-02-01 00:18:49.000000', 'consum', 0.0227, 'lps'),
	(523461, 130, '2014-02-01 00:18:50.000000', 'consum', 0.0216, 'lps'),
	(523462, 130, '2014-02-01 00:18:51.000000', 'consum', 0.0223, 'lps'),
	(523463, 130, '2014-02-01 00:18:52.000000', 'consum', 0.0222, 'lps'),
	(523464, 130, '2014-02-01 00:18:53.000000', 'consum', 0.0215, 'lps'),
	(523465, 130, '2014-02-01 00:18:54.000000', 'consum', 0.0217, 'lps'),
	(523466, 130, '2014-02-01 00:18:55.000000', 'consum', 0.0211, 'lps'),
	(523467, 130, '2014-02-01 00:18:56.000000', 'consum', 0.0213, 'lps'),
	(523468, 130, '2014-02-01 00:18:57.000000', 'consum', 0.0223, 'lps'),
	(523469, 130, '2014-02-01 00:18:58.000000', 'consum', 0.0212, 'lps'),
	(523470, 130, '2014-02-01 00:18:59.000000', 'consum', 0.0217, 'lps'),
	(523471, 130, '2014-02-01 00:19:00.000000', 'consum', 0.0224, 'lps'),
	(523472, 130, '2014-02-01 00:19:01.000000', 'consum', 0.0220, 'lps'),
	(523473, 130, '2014-02-01 00:19:02.000000', 'consum', 0.0221, 'lps'),
	(523474, 130, '2014-02-01 00:19:03.000000', 'consum', 0.0218, 'lps'),
	(523475, 130, '2014-02-01 00:19:04.000000', 'consum', 0.0218, 'lps'),
	(523476, 130, '2014-02-01 00:19:05.000000', 'consum', 0.0224, 'lps'),
	(523477, 130, '2014-02-01 00:19:06.000000', 'consum', 0.0220, 'lps'),
	(523478, 130, '2014-02-01 00:19:07.000000', 'consum', 0.0218, 'lps'),
	(523479, 130, '2014-02-01 00:19:08.000000', 'consum', 0.0222, 'lps'),
	(523480, 130, '2014-02-01 00:19:09.000000', 'consum', 0.0212, 'lps'),
	(523481, 130, '2014-02-01 00:19:10.000000', 'consum', 0.0219, 'lps'),
	(523482, 130, '2014-02-01 00:19:11.000000', 'consum', 0.0212, 'lps'),
	(523483, 130, '2014-02-01 00:19:12.000000', 'consum', 0.0213, 'lps'),
	(523484, 130, '2014-02-01 00:19:13.000000', 'consum', 0.0219, 'lps'),
	(523485, 130, '2014-02-01 00:19:14.000000', 'consum', 0.0212, 'lps'),
	(523486, 130, '2014-02-01 00:19:15.000000', 'consum', 0.0212, 'lps'),
	(523487, 130, '2014-02-01 00:19:16.000000', 'consum', 0.0212, 'lps'),
	(523488, 130, '2014-02-01 00:19:17.000000', 'consum', 0.0217, 'lps'),
	(523489, 130, '2014-02-01 00:19:18.000000', 'consum', 0.0220, 'lps'),
	(523490, 130, '2014-02-01 00:19:19.000000', 'consum', 0.0223, 'lps'),
	(523491, 130, '2014-02-01 00:19:20.000000', 'consum', 0.0210, 'lps'),
	(523492, 130, '2014-02-01 00:19:21.000000', 'consum', 0.0226, 'lps'),
	(523493, 130, '2014-02-01 00:19:22.000000', 'consum', 0.0218, 'lps'),
	(523494, 130, '2014-02-01 00:19:23.000000', 'consum', 0.0219, 'lps'),
	(523495, 130, '2014-02-01 00:19:24.000000', 'consum', 0.0216, 'lps'),
	(523496, 130, '2014-02-01 00:19:25.000000', 'consum', 0.0211, 'lps'),
	(523497, 130, '2014-02-01 00:19:26.000000', 'consum', 0.0218, 'lps'),
	(523498, 130, '2014-02-01 00:19:27.000000', 'consum', 0.0212, 'lps'),
	(523499, 130, '2014-02-01 00:19:28.000000', 'consum', 0.0214, 'lps'),
	(523500, 130, '2014-02-01 00:19:29.000000', 'consum', 0.0224, 'lps'),
	(523501, 130, '2014-02-01 00:19:30.000000', 'consum', 0.0215, 'lps'),
	(523502, 130, '2014-02-01 00:19:31.000000', 'consum', 0.0210, 'lps'),
	(523503, 130, '2014-02-01 00:19:32.000000', 'consum', 0.0215, 'lps'),
	(523504, 130, '2014-02-01 00:19:33.000000', 'consum', 0.0215, 'lps'),
	(523505, 130, '2014-02-01 00:19:34.000000', 'consum', 0.0222, 'lps'),
	(523506, 130, '2014-02-01 00:19:35.000000', 'consum', 0.0220, 'lps'),
	(523507, 130, '2014-02-01 00:19:36.000000', 'consum', 0.0225, 'lps'),
	(523508, 130, '2014-02-01 00:19:37.000000', 'consum', 0.0218, 'lps'),
	(523509, 130, '2014-02-01 00:19:38.000000', 'consum', 0.0225, 'lps'),
	(523510, 130, '2014-02-01 00:19:39.000000', 'consum', 0.0224, 'lps'),
	(523511, 130, '2014-02-01 00:19:40.000000', 'consum', 0.0220, 'lps'),
	(523512, 130, '2014-02-01 00:19:41.000000', 'consum', 0.0217, 'lps'),
	(523513, 130, '2014-02-01 00:19:42.000000', 'consum', 0.0217, 'lps'),
	(523514, 130, '2014-02-01 00:19:43.000000', 'consum', 0.0225, 'lps'),
	(523515, 130, '2014-02-01 00:19:44.000000', 'consum', 0.0226, 'lps'),
	(523516, 130, '2014-02-01 00:19:45.000000', 'consum', 0.0212, 'lps'),
	(523517, 130, '2014-02-01 00:19:46.000000', 'consum', 0.0224, 'lps'),
	(523518, 130, '2014-02-01 00:19:47.000000', 'consum', 0.0221, 'lps'),
	(523519, 130, '2014-02-01 00:19:48.000000', 'consum', 0.0224, 'lps'),
	(523520, 130, '2014-02-01 00:19:49.000000', 'consum', 0.0227, 'lps'),
	(523521, 130, '2014-02-01 00:19:50.000000', 'consum', 0.0221, 'lps'),
	(523522, 130, '2014-02-01 00:19:51.000000', 'consum', 0.0214, 'lps'),
	(523523, 130, '2014-02-01 00:19:52.000000', 'consum', 0.0215, 'lps'),
	(523524, 130, '2014-02-01 00:19:53.000000', 'consum', 0.0225, 'lps'),
	(523525, 130, '2014-02-01 00:19:54.000000', 'consum', 0.0217, 'lps'),
	(523526, 130, '2014-02-01 00:19:55.000000', 'consum', 0.0219, 'lps'),
	(523527, 130, '2014-02-01 00:19:56.000000', 'consum', 0.0217, 'lps'),
	(523528, 130, '2014-02-01 00:19:57.000000', 'consum', 0.0217, 'lps'),
	(523529, 130, '2014-02-01 00:19:58.000000', 'consum', 0.0226, 'lps'),
	(523530, 130, '2014-02-01 00:19:59.000000', 'consum', 0.0214, 'lps'),
	(523531, 130, '2014-02-01 00:20:00.000000', 'consum', 0.0220, 'lps'),
	(523532, 130, '2014-02-01 00:20:01.000000', 'consum', 0.0214, 'lps'),
	(523533, 130, '2014-02-01 00:20:02.000000', 'consum', 0.0216, 'lps'),
	(523534, 130, '2014-02-01 00:20:03.000000', 'consum', 0.0210, 'lps'),
	(523535, 130, '2014-02-01 00:20:04.000000', 'consum', 0.0210, 'lps'),
	(523536, 130, '2014-02-01 00:20:05.000000', 'consum', 0.0210, 'lps'),
	(523537, 130, '2014-02-01 00:20:06.000000', 'consum', 0.0227, 'lps'),
	(523538, 130, '2014-02-01 00:20:07.000000', 'consum', 0.0227, 'lps'),
	(523539, 130, '2014-02-01 00:20:08.000000', 'consum', 0.0227, 'lps'),
	(523540, 130, '2014-02-01 00:20:09.000000', 'consum', 0.0224, 'lps'),
	(523541, 130, '2014-02-01 00:20:10.000000', 'consum', 0.0212, 'lps'),
	(523542, 130, '2014-02-01 00:20:11.000000', 'consum', 0.0214, 'lps'),
	(523543, 130, '2014-02-01 00:20:12.000000', 'consum', 0.0223, 'lps'),
	(523544, 130, '2014-02-01 00:20:13.000000', 'consum', 0.0212, 'lps'),
	(523545, 130, '2014-02-01 00:20:14.000000', 'consum', 0.0217, 'lps'),
	(523546, 130, '2014-02-01 00:20:15.000000', 'consum', 0.0222, 'lps'),
	(523547, 130, '2014-02-01 00:20:16.000000', 'consum', 0.0213, 'lps'),
	(523548, 130, '2014-02-01 00:20:17.000000', 'consum', 0.0224, 'lps'),
	(523549, 130, '2014-02-01 00:20:18.000000', 'consum', 0.0219, 'lps'),
	(523550, 130, '2014-02-01 00:20:19.000000', 'consum', 0.0215, 'lps'),
	(523551, 130, '2014-02-01 00:20:20.000000', 'consum', 0.0226, 'lps'),
	(523552, 130, '2014-02-01 00:20:21.000000', 'consum', 0.0220, 'lps'),
	(523553, 130, '2014-02-01 00:20:22.000000', 'consum', 0.0213, 'lps'),
	(523554, 130, '2014-02-01 00:20:23.000000', 'consum', 0.0212, 'lps'),
	(523555, 130, '2014-02-01 00:20:24.000000', 'consum', 0.0214, 'lps'),
	(523556, 130, '2014-02-01 00:20:25.000000', 'consum', 0.0226, 'lps'),
	(523557, 130, '2014-02-01 00:20:26.000000', 'consum', 0.0221, 'lps'),
	(523558, 130, '2014-02-01 00:20:27.000000', 'consum', 0.0221, 'lps'),
	(523559, 130, '2014-02-01 00:20:28.000000', 'consum', 0.0212, 'lps'),
	(523560, 130, '2014-02-01 00:20:29.000000', 'consum', 0.0223, 'lps'),
	(523561, 130, '2014-02-01 00:20:30.000000', 'consum', 0.0215, 'lps'),
	(523562, 130, '2014-02-01 00:20:31.000000', 'consum', 0.0216, 'lps'),
	(523563, 130, '2014-02-01 00:20:32.000000', 'consum', 0.0223, 'lps'),
	(523564, 130, '2014-02-01 00:20:33.000000', 'consum', 0.0225, 'lps'),
	(523565, 130, '2014-02-01 00:20:34.000000', 'consum', 0.0227, 'lps'),
	(523566, 130, '2014-02-01 00:20:35.000000', 'consum', 0.0215, 'lps'),
	(523567, 130, '2014-02-01 00:20:36.000000', 'consum', 0.0221, 'lps'),
	(523568, 130, '2014-02-01 00:20:37.000000', 'consum', 0.0212, 'lps'),
	(523569, 130, '2014-02-01 00:20:38.000000', 'consum', 0.0224, 'lps'),
	(523570, 130, '2014-02-01 00:20:39.000000', 'consum', 0.0222, 'lps'),
	(523571, 130, '2014-02-01 00:20:40.000000', 'consum', 0.0211, 'lps'),
	(523572, 130, '2014-02-01 00:20:41.000000', 'consum', 0.0215, 'lps'),
	(523573, 130, '2014-02-01 00:20:42.000000', 'consum', 0.0216, 'lps'),
	(523574, 130, '2014-02-01 00:20:43.000000', 'consum', 0.0223, 'lps'),
	(523575, 130, '2014-02-01 00:20:44.000000', 'consum', 0.0222, 'lps'),
	(523576, 130, '2014-02-01 00:20:45.000000', 'consum', 0.0215, 'lps'),
	(523577, 130, '2014-02-01 00:20:46.000000', 'consum', 0.0217, 'lps'),
	(523578, 130, '2014-02-01 00:20:47.000000', 'consum', 0.0211, 'lps'),
	(523579, 130, '2014-02-01 00:20:48.000000', 'consum', 0.0214, 'lps'),
	(523580, 130, '2014-02-01 00:20:49.000000', 'consum', 0.0210, 'lps'),
	(523581, 130, '2014-02-01 00:20:50.000000', 'consum', 0.0215, 'lps'),
	(523582, 130, '2014-02-01 00:20:51.000000', 'consum', 0.0217, 'lps'),
	(523583, 130, '2014-02-01 00:20:52.000000', 'consum', 0.0212, 'lps'),
	(523584, 130, '2014-02-01 00:20:53.000000', 'consum', 0.0220, 'lps'),
	(523585, 130, '2014-02-01 00:20:54.000000', 'consum', 0.0217, 'lps'),
	(523586, 130, '2014-02-01 00:20:55.000000', 'consum', 0.0215, 'lps'),
	(523587, 130, '2014-02-01 00:20:56.000000', 'consum', 0.0215, 'lps'),
	(523588, 130, '2014-02-01 00:20:57.000000', 'consum', 0.0219, 'lps'),
	(523589, 130, '2014-02-01 00:20:58.000000', 'consum', 0.0224, 'lps'),
	(523590, 130, '2014-02-01 00:20:59.000000', 'consum', 0.0218, 'lps'),
	(523591, 130, '2014-02-01 00:21:00.000000', 'consum', 0.0227, 'lps'),
	(523592, 130, '2014-02-01 00:21:01.000000', 'consum', 0.0215, 'lps'),
	(523593, 130, '2014-02-01 00:21:02.000000', 'consum', 0.0224, 'lps'),
	(523594, 130, '2014-02-01 00:21:03.000000', 'consum', 0.0226, 'lps'),
	(523595, 130, '2014-02-01 00:21:04.000000', 'consum', 0.0214, 'lps'),
	(523596, 130, '2014-02-01 00:21:05.000000', 'consum', 0.0217, 'lps'),
	(523597, 130, '2014-02-01 00:21:06.000000', 'consum', 0.0216, 'lps'),
	(523598, 130, '2014-02-01 00:21:07.000000', 'consum', 0.0220, 'lps'),
	(523599, 130, '2014-02-01 00:21:08.000000', 'consum', 0.0226, 'lps'),
	(523600, 130, '2014-02-01 00:21:09.000000', 'consum', 0.0224, 'lps'),
	(523601, 130, '2014-02-01 00:21:10.000000', 'consum', 0.0214, 'lps'),
	(523602, 130, '2014-02-01 00:21:11.000000', 'consum', 0.0227, 'lps'),
	(523603, 130, '2014-02-01 00:21:12.000000', 'consum', 0.0226, 'lps'),
	(523604, 130, '2014-02-01 00:21:13.000000', 'consum', 0.0224, 'lps'),
	(523605, 130, '2014-02-01 00:21:14.000000', 'consum', 0.0214, 'lps'),
	(523606, 130, '2014-02-01 00:21:15.000000', 'consum', 0.0225, 'lps'),
	(523607, 130, '2014-02-01 00:21:16.000000', 'consum', 0.0220, 'lps'),
	(523608, 130, '2014-02-01 00:21:17.000000', 'consum', 0.0214, 'lps'),
	(523609, 130, '2014-02-01 00:21:18.000000', 'consum', 0.0218, 'lps'),
	(523610, 130, '2014-02-01 00:21:19.000000', 'consum', 0.0221, 'lps'),
	(523611, 130, '2014-02-01 00:21:20.000000', 'consum', 0.0222, 'lps'),
	(523612, 130, '2014-02-01 00:21:21.000000', 'consum', 0.0222, 'lps'),
	(523613, 130, '2014-02-01 00:21:22.000000', 'consum', 0.0214, 'lps'),
	(523614, 130, '2014-02-01 00:21:23.000000', 'consum', 0.0214, 'lps'),
	(523615, 130, '2014-02-01 00:21:24.000000', 'consum', 0.0220, 'lps'),
	(523616, 130, '2014-02-01 00:21:25.000000', 'consum', 0.0212, 'lps'),
	(523617, 130, '2014-02-01 00:21:26.000000', 'consum', 0.0227, 'lps'),
	(523618, 130, '2014-02-01 00:21:27.000000', 'consum', 0.0218, 'lps'),
	(523619, 130, '2014-02-01 00:21:28.000000', 'consum', 0.0218, 'lps'),
	(523620, 130, '2014-02-01 00:21:29.000000', 'consum', 0.0225, 'lps'),
	(523621, 130, '2014-02-01 00:21:30.000000', 'consum', 0.0227, 'lps'),
	(523622, 130, '2014-02-01 00:21:31.000000', 'consum', 0.0212, 'lps'),
	(523623, 130, '2014-02-01 00:21:32.000000', 'consum', 0.0225, 'lps'),
	(523624, 130, '2014-02-01 00:21:33.000000', 'consum', 0.0226, 'lps'),
	(523625, 130, '2014-02-01 00:21:34.000000', 'consum', 0.0227, 'lps'),
	(523626, 130, '2014-02-01 00:21:35.000000', 'consum', 0.0210, 'lps'),
	(523627, 130, '2014-02-01 00:21:36.000000', 'consum', 0.0213, 'lps'),
	(523628, 130, '2014-02-01 00:21:37.000000', 'consum', 0.0225, 'lps'),
	(523629, 130, '2014-02-01 00:21:38.000000', 'consum', 0.0225, 'lps'),
	(523630, 130, '2014-02-01 00:21:39.000000', 'consum', 0.0223, 'lps'),
	(523631, 130, '2014-02-01 00:21:40.000000', 'consum', 0.0213, 'lps'),
	(523632, 130, '2014-02-01 00:21:41.000000', 'consum', 0.0223, 'lps'),
	(523633, 130, '2014-02-01 00:21:42.000000', 'consum', 0.0211, 'lps'),
	(523634, 130, '2014-02-01 00:21:43.000000', 'consum', 0.0211, 'lps'),
	(523635, 130, '2014-02-01 00:21:44.000000', 'consum', 0.0215, 'lps'),
	(523636, 130, '2014-02-01 00:21:45.000000', 'consum', 0.0212, 'lps'),
	(523637, 130, '2014-02-01 00:21:46.000000', 'consum', 0.0224, 'lps'),
	(523638, 130, '2014-02-01 00:21:47.000000', 'consum', 0.0222, 'lps'),
	(523639, 130, '2014-02-01 00:21:48.000000', 'consum', 0.0210, 'lps'),
	(523640, 130, '2014-02-01 00:21:49.000000', 'consum', 0.0226, 'lps'),
	(523641, 130, '2014-02-01 00:21:50.000000', 'consum', 0.0222, 'lps'),
	(523642, 130, '2014-02-01 00:21:51.000000', 'consum', 0.0222, 'lps'),
	(523643, 130, '2014-02-01 00:21:52.000000', 'consum', 0.0214, 'lps'),
	(523644, 130, '2014-02-01 00:21:53.000000', 'consum', 0.0213, 'lps'),
	(523645, 130, '2014-02-01 00:21:54.000000', 'consum', 0.0214, 'lps'),
	(523646, 130, '2014-02-01 00:21:55.000000', 'consum', 0.0221, 'lps'),
	(523647, 130, '2014-02-01 00:21:56.000000', 'consum', 0.0219, 'lps'),
	(523648, 130, '2014-02-01 00:21:57.000000', 'consum', 0.0220, 'lps'),
	(523649, 130, '2014-02-01 00:21:58.000000', 'consum', 0.0218, 'lps'),
	(523650, 130, '2014-02-01 00:21:59.000000', 'consum', 0.0221, 'lps'),
	(523651, 130, '2014-02-01 00:22:00.000000', 'consum', 0.0222, 'lps'),
	(523652, 130, '2014-02-01 00:22:01.000000', 'consum', 0.0219, 'lps'),
	(523653, 130, '2014-02-01 00:22:02.000000', 'consum', 0.0221, 'lps'),
	(523654, 130, '2014-02-01 00:22:03.000000', 'consum', 0.0222, 'lps'),
	(523655, 130, '2014-02-01 00:22:04.000000', 'consum', 0.0217, 'lps'),
	(523656, 130, '2014-02-01 00:22:05.000000', 'consum', 0.0227, 'lps'),
	(523657, 130, '2014-02-01 00:22:06.000000', 'consum', 0.0222, 'lps'),
	(523658, 130, '2014-02-01 00:22:07.000000', 'consum', 0.0217, 'lps'),
	(523659, 130, '2014-02-01 00:22:08.000000', 'consum', 0.0212, 'lps'),
	(523660, 130, '2014-02-01 00:22:09.000000', 'consum', 0.0218, 'lps'),
	(523661, 130, '2014-02-01 00:22:10.000000', 'consum', 0.0225, 'lps'),
	(523662, 130, '2014-02-01 00:22:11.000000', 'consum', 0.0210, 'lps'),
	(523663, 130, '2014-02-01 00:22:12.000000', 'consum', 0.0217, 'lps'),
	(523664, 130, '2014-02-01 00:22:13.000000', 'consum', 0.0227, 'lps'),
	(523665, 130, '2014-02-01 00:22:14.000000', 'consum', 0.0221, 'lps'),
	(523666, 130, '2014-02-01 00:22:15.000000', 'consum', 0.0214, 'lps'),
	(523667, 130, '2014-02-01 00:22:16.000000', 'consum', 0.0216, 'lps'),
	(523668, 130, '2014-02-01 00:22:17.000000', 'consum', 0.0211, 'lps'),
	(523669, 130, '2014-02-01 00:22:18.000000', 'consum', 0.0214, 'lps'),
	(523670, 130, '2014-02-01 00:22:19.000000', 'consum', 0.0210, 'lps'),
	(523671, 130, '2014-02-01 00:22:20.000000', 'consum', 0.0217, 'lps'),
	(523672, 130, '2014-02-01 00:22:21.000000', 'consum', 0.0226, 'lps'),
	(523673, 130, '2014-02-01 00:22:22.000000', 'consum', 0.0217, 'lps'),
	(523674, 130, '2014-02-01 00:22:23.000000', 'consum', 0.0216, 'lps'),
	(523675, 130, '2014-02-01 00:22:24.000000', 'consum', 0.0220, 'lps'),
	(523676, 130, '2014-02-01 00:22:25.000000', 'consum', 0.0224, 'lps'),
	(523677, 130, '2014-02-01 00:22:26.000000', 'consum', 0.0216, 'lps'),
	(523678, 130, '2014-02-01 00:22:27.000000', 'consum', 0.0214, 'lps'),
	(523679, 130, '2014-02-01 00:22:28.000000', 'consum', 0.0213, 'lps'),
	(523680, 130, '2014-02-01 00:22:29.000000', 'consum', 0.0216, 'lps'),
	(523681, 130, '2014-02-01 00:22:30.000000', 'consum', 0.0212, 'lps'),
	(523682, 130, '2014-02-01 00:22:31.000000', 'consum', 0.0219, 'lps'),
	(523683, 130, '2014-02-01 00:22:32.000000', 'consum', 0.0215, 'lps'),
	(523684, 130, '2014-02-01 00:22:33.000000', 'consum', 0.0225, 'lps'),
	(523685, 130, '2014-02-01 00:22:34.000000', 'consum', 0.0219, 'lps'),
	(523686, 130, '2014-02-01 00:22:35.000000', 'consum', 0.0227, 'lps'),
	(523687, 130, '2014-02-01 00:22:36.000000', 'consum', 0.0214, 'lps'),
	(523688, 130, '2014-02-01 00:22:37.000000', 'consum', 0.0217, 'lps'),
	(523689, 130, '2014-02-01 00:22:38.000000', 'consum', 0.0214, 'lps'),
	(523690, 130, '2014-02-01 00:22:39.000000', 'consum', 0.0212, 'lps'),
	(523691, 130, '2014-02-01 00:22:40.000000', 'consum', 0.0223, 'lps'),
	(523692, 130, '2014-02-01 00:22:41.000000', 'consum', 0.0217, 'lps'),
	(523693, 130, '2014-02-01 00:22:42.000000', 'consum', 0.0226, 'lps'),
	(523694, 130, '2014-02-01 00:22:43.000000', 'consum', 0.0214, 'lps'),
	(523695, 130, '2014-02-01 00:22:44.000000', 'consum', 0.0220, 'lps'),
	(523696, 130, '2014-02-01 00:22:45.000000', 'consum', 0.0212, 'lps'),
	(523697, 130, '2014-02-01 00:22:46.000000', 'consum', 0.0227, 'lps'),
	(523698, 130, '2014-02-01 00:22:47.000000', 'consum', 0.0217, 'lps'),
	(523699, 130, '2014-02-01 00:22:48.000000', 'consum', 0.0211, 'lps'),
	(523700, 130, '2014-02-01 00:22:49.000000', 'consum', 0.0214, 'lps'),
	(523701, 130, '2014-02-01 00:22:50.000000', 'consum', 0.0227, 'lps'),
	(523702, 130, '2014-02-01 00:22:51.000000', 'consum', 0.0212, 'lps'),
	(523703, 130, '2014-02-01 00:22:52.000000', 'consum', 0.0225, 'lps'),
	(523704, 130, '2014-02-01 00:22:53.000000', 'consum', 0.0225, 'lps'),
	(523705, 130, '2014-02-01 00:22:54.000000', 'consum', 0.0224, 'lps'),
	(523706, 130, '2014-02-01 00:22:55.000000', 'consum', 0.0214, 'lps'),
	(523707, 130, '2014-02-01 00:22:56.000000', 'consum', 0.0227, 'lps'),
	(523708, 130, '2014-02-01 00:22:57.000000', 'consum', 0.0227, 'lps'),
	(523709, 130, '2014-02-01 00:22:58.000000', 'consum', 0.0212, 'lps'),
	(523710, 130, '2014-02-01 00:22:59.000000', 'consum', 0.0220, 'lps'),
	(523711, 130, '2014-02-01 00:23:00.000000', 'consum', 0.0221, 'lps'),
	(523712, 130, '2014-02-01 00:23:01.000000', 'consum', 0.0218, 'lps'),
	(523713, 130, '2014-02-01 00:23:02.000000', 'consum', 0.0215, 'lps'),
	(523714, 130, '2014-02-01 00:23:03.000000', 'consum', 0.0211, 'lps'),
	(523715, 130, '2014-02-01 00:23:04.000000', 'consum', 0.0220, 'lps'),
	(523716, 130, '2014-02-01 00:23:05.000000', 'consum', 0.0220, 'lps'),
	(523717, 130, '2014-02-01 00:23:06.000000', 'consum', 0.0215, 'lps'),
	(523718, 130, '2014-02-01 00:23:07.000000', 'consum', 0.0221, 'lps'),
	(523719, 130, '2014-02-01 00:23:08.000000', 'consum', 0.0215, 'lps'),
	(523720, 130, '2014-02-01 00:23:09.000000', 'consum', 0.0222, 'lps'),
	(523721, 130, '2014-02-01 00:23:10.000000', 'consum', 0.0219, 'lps'),
	(523722, 130, '2014-02-01 00:23:11.000000', 'consum', 0.0221, 'lps'),
	(523723, 130, '2014-02-01 00:23:12.000000', 'consum', 0.0219, 'lps'),
	(523724, 130, '2014-02-01 00:23:13.000000', 'consum', 0.0222, 'lps'),
	(523725, 130, '2014-02-01 00:23:14.000000', 'consum', 0.0225, 'lps'),
	(523726, 130, '2014-02-01 00:23:15.000000', 'consum', 0.0214, 'lps'),
	(523727, 130, '2014-02-01 00:23:16.000000', 'consum', 0.0220, 'lps'),
	(523728, 130, '2014-02-01 00:23:17.000000', 'consum', 0.0212, 'lps'),
	(523729, 130, '2014-02-01 00:23:18.000000', 'consum', 0.0210, 'lps'),
	(523730, 130, '2014-02-01 00:23:19.000000', 'consum', 0.0221, 'lps'),
	(523731, 130, '2014-02-01 00:23:20.000000', 'consum', 0.0212, 'lps'),
	(523732, 130, '2014-02-01 00:23:21.000000', 'consum', 0.0226, 'lps'),
	(523733, 130, '2014-02-01 00:23:22.000000', 'consum', 0.0210, 'lps'),
	(523734, 130, '2014-02-01 00:23:23.000000', 'consum', 0.0217, 'lps'),
	(523735, 130, '2014-02-01 00:23:24.000000', 'consum', 0.0226, 'lps'),
	(523736, 130, '2014-02-01 00:23:25.000000', 'consum', 0.0218, 'lps'),
	(523737, 130, '2014-02-01 00:23:26.000000', 'consum', 0.0222, 'lps'),
	(523738, 130, '2014-02-01 00:23:27.000000', 'consum', 0.0225, 'lps'),
	(523739, 130, '2014-02-01 00:23:28.000000', 'consum', 0.0213, 'lps'),
	(523740, 130, '2014-02-01 00:23:29.000000', 'consum', 0.0219, 'lps'),
	(523741, 130, '2014-02-01 00:23:30.000000', 'consum', 0.0227, 'lps'),
	(523742, 130, '2014-02-01 00:23:31.000000', 'consum', 0.0214, 'lps'),
	(523743, 130, '2014-02-01 00:23:32.000000', 'consum', 0.0217, 'lps'),
	(523744, 130, '2014-02-01 00:23:33.000000', 'consum', 0.0214, 'lps'),
	(523745, 130, '2014-02-01 00:23:34.000000', 'consum', 0.0226, 'lps'),
	(523746, 130, '2014-02-01 00:23:35.000000', 'consum', 0.0227, 'lps'),
	(523747, 130, '2014-02-01 00:23:36.000000', 'consum', 0.0210, 'lps'),
	(523748, 130, '2014-02-01 00:23:37.000000', 'consum', 0.0216, 'lps'),
	(523749, 130, '2014-02-01 00:23:38.000000', 'consum', 0.0221, 'lps'),
	(523750, 130, '2014-02-01 00:23:39.000000', 'consum', 0.0227, 'lps'),
	(523751, 130, '2014-02-01 00:23:40.000000', 'consum', 0.0212, 'lps'),
	(523752, 130, '2014-02-01 00:23:41.000000', 'consum', 0.0224, 'lps'),
	(523753, 130, '2014-02-01 00:23:42.000000', 'consum', 0.0218, 'lps'),
	(523754, 130, '2014-02-01 00:23:43.000000', 'consum', 0.0226, 'lps'),
	(523755, 130, '2014-02-01 00:23:44.000000', 'consum', 0.0216, 'lps'),
	(523756, 130, '2014-02-01 00:23:45.000000', 'consum', 0.0225, 'lps'),
	(523757, 130, '2014-02-01 00:23:46.000000', 'consum', 0.0215, 'lps'),
	(523758, 130, '2014-02-01 00:23:47.000000', 'consum', 0.0227, 'lps'),
	(523759, 130, '2014-02-01 00:23:48.000000', 'consum', 0.0224, 'lps'),
	(523760, 130, '2014-02-01 00:23:49.000000', 'consum', 0.0214, 'lps'),
	(523761, 130, '2014-02-01 00:23:50.000000', 'consum', 0.0224, 'lps'),
	(523762, 130, '2014-02-01 00:23:51.000000', 'consum', 0.0216, 'lps'),
	(523763, 130, '2014-02-01 00:23:52.000000', 'consum', 0.0214, 'lps'),
	(523764, 130, '2014-02-01 00:23:53.000000', 'consum', 0.0214, 'lps'),
	(523765, 130, '2014-02-01 00:23:54.000000', 'consum', 0.0218, 'lps'),
	(523766, 130, '2014-02-01 00:23:55.000000', 'consum', 0.0219, 'lps'),
	(523767, 130, '2014-02-01 00:23:56.000000', 'consum', 0.0214, 'lps'),
	(523768, 130, '2014-02-01 00:23:57.000000', 'consum', 0.0223, 'lps'),
	(523769, 130, '2014-02-01 00:23:58.000000', 'consum', 0.0225, 'lps'),
	(523770, 130, '2014-02-01 00:23:59.000000', 'consum', 0.0212, 'lps'),
	(523771, 130, '2014-02-01 00:24:00.000000', 'consum', 0.0212, 'lps'),
	(523772, 130, '2014-02-01 00:24:01.000000', 'consum', 0.0215, 'lps'),
	(523773, 130, '2014-02-01 00:24:02.000000', 'consum', 0.0227, 'lps'),
	(523774, 130, '2014-02-01 00:24:03.000000', 'consum', 0.0210, 'lps'),
	(523775, 130, '2014-02-01 00:24:04.000000', 'consum', 0.0215, 'lps'),
	(523776, 130, '2014-02-01 00:24:05.000000', 'consum', 0.0215, 'lps'),
	(523777, 130, '2014-02-01 00:24:06.000000', 'consum', 0.0222, 'lps'),
	(523778, 130, '2014-02-01 00:24:07.000000', 'consum', 0.0221, 'lps'),
	(523779, 130, '2014-02-01 00:24:08.000000', 'consum', 0.0227, 'lps'),
	(523780, 130, '2014-02-01 00:24:09.000000', 'consum', 0.0227, 'lps'),
	(523781, 130, '2014-02-01 00:24:10.000000', 'consum', 0.0227, 'lps'),
	(523782, 130, '2014-02-01 00:24:11.000000', 'consum', 0.0225, 'lps'),
	(523783, 130, '2014-02-01 00:24:12.000000', 'consum', 0.0218, 'lps'),
	(523784, 130, '2014-02-01 00:24:13.000000', 'consum', 0.0224, 'lps'),
	(523785, 130, '2014-02-01 00:24:14.000000', 'consum', 0.0221, 'lps'),
	(523786, 130, '2014-02-01 00:24:15.000000', 'consum', 0.0222, 'lps'),
	(523787, 130, '2014-02-01 00:24:16.000000', 'consum', 0.0218, 'lps'),
	(523788, 130, '2014-02-01 00:24:17.000000', 'consum', 0.0216, 'lps'),
	(523789, 130, '2014-02-01 00:24:18.000000', 'consum', 0.0218, 'lps'),
	(523790, 130, '2014-02-01 00:24:19.000000', 'consum', 0.0215, 'lps'),
	(523791, 130, '2014-02-01 00:24:20.000000', 'consum', 0.0210, 'lps'),
	(523792, 130, '2014-02-01 00:24:21.000000', 'consum', 0.0214, 'lps'),
	(523793, 130, '2014-02-01 00:24:22.000000', 'consum', 0.0213, 'lps'),
	(523794, 130, '2014-02-01 00:24:23.000000', 'consum', 0.0212, 'lps'),
	(523795, 130, '2014-02-01 00:24:24.000000', 'consum', 0.0214, 'lps'),
	(523796, 130, '2014-02-01 00:24:25.000000', 'consum', 0.0224, 'lps'),
	(523797, 130, '2014-02-01 00:24:26.000000', 'consum', 0.0214, 'lps'),
	(523798, 130, '2014-02-01 00:24:27.000000', 'consum', 0.0226, 'lps'),
	(523799, 130, '2014-02-01 00:24:28.000000', 'consum', 0.0224, 'lps'),
	(523800, 130, '2014-02-01 00:24:29.000000', 'consum', 0.0212, 'lps'),
	(523801, 130, '2014-02-01 00:24:30.000000', 'consum', 0.0217, 'lps'),
	(523802, 130, '2014-02-01 00:24:31.000000', 'consum', 0.0220, 'lps'),
	(523803, 130, '2014-02-01 00:24:32.000000', 'consum', 0.0222, 'lps'),
	(523804, 130, '2014-02-01 00:24:33.000000', 'consum', 0.0222, 'lps'),
	(523805, 130, '2014-02-01 00:24:34.000000', 'consum', 0.0217, 'lps'),
	(523806, 130, '2014-02-01 00:24:35.000000', 'consum', 0.0226, 'lps'),
	(523807, 130, '2014-02-01 00:24:36.000000', 'consum', 0.0215, 'lps'),
	(523808, 130, '2014-02-01 00:24:37.000000', 'consum', 0.0226, 'lps'),
	(523809, 130, '2014-02-01 00:24:38.000000', 'consum', 0.0220, 'lps'),
	(523810, 130, '2014-02-01 00:24:39.000000', 'consum', 0.0214, 'lps'),
	(523811, 130, '2014-02-01 00:24:40.000000', 'consum', 0.0216, 'lps'),
	(523812, 130, '2014-02-01 00:24:41.000000', 'consum', 0.0212, 'lps'),
	(523813, 130, '2014-02-01 00:24:42.000000', 'consum', 0.0221, 'lps'),
	(523814, 130, '2014-02-01 00:24:43.000000', 'consum', 0.0223, 'lps'),
	(523815, 130, '2014-02-01 00:24:44.000000', 'consum', 0.0226, 'lps'),
	(523816, 130, '2014-02-01 00:24:45.000000', 'consum', 0.0216, 'lps'),
	(523817, 130, '2014-02-01 00:24:46.000000', 'consum', 0.0210, 'lps'),
	(523818, 130, '2014-02-01 00:24:47.000000', 'consum', 0.0227, 'lps'),
	(523819, 130, '2014-02-01 00:24:48.000000', 'consum', 0.0225, 'lps'),
	(523820, 130, '2014-02-01 00:24:49.000000', 'consum', 0.0214, 'lps'),
	(523821, 130, '2014-02-01 00:24:50.000000', 'consum', 0.0223, 'lps'),
	(523822, 130, '2014-02-01 00:24:51.000000', 'consum', 0.0210, 'lps'),
	(523823, 130, '2014-02-01 00:24:52.000000', 'consum', 0.0225, 'lps'),
	(523824, 130, '2014-02-01 00:24:53.000000', 'consum', 0.0215, 'lps'),
	(523825, 130, '2014-02-01 00:24:54.000000', 'consum', 0.0225, 'lps'),
	(523826, 130, '2014-02-01 00:24:55.000000', 'consum', 0.0215, 'lps'),
	(523827, 130, '2014-02-01 00:24:56.000000', 'consum', 0.0227, 'lps'),
	(523828, 130, '2014-02-01 00:24:57.000000', 'consum', 0.0225, 'lps'),
	(523829, 130, '2014-02-01 00:24:58.000000', 'consum', 0.0219, 'lps'),
	(523830, 130, '2014-02-01 00:24:59.000000', 'consum', 0.0226, 'lps'),
	(523831, 130, '2014-02-01 00:25:00.000000', 'consum', 0.0212, 'lps'),
	(523832, 130, '2014-02-01 00:25:01.000000', 'consum', 0.0224, 'lps'),
	(523833, 130, '2014-02-01 00:25:02.000000', 'consum', 0.0220, 'lps'),
	(523834, 130, '2014-02-01 00:25:03.000000', 'consum', 0.0218, 'lps'),
	(523835, 130, '2014-02-01 00:25:04.000000', 'consum', 0.0223, 'lps'),
	(523836, 130, '2014-02-01 00:25:05.000000', 'consum', 0.0213, 'lps'),
	(523837, 130, '2014-02-01 00:25:06.000000', 'consum', 0.0224, 'lps'),
	(523838, 130, '2014-02-01 00:25:07.000000', 'consum', 0.0216, 'lps'),
	(523839, 130, '2014-02-01 00:25:08.000000', 'consum', 0.0216, 'lps'),
	(523840, 130, '2014-02-01 00:25:09.000000', 'consum', 0.0225, 'lps'),
	(523841, 130, '2014-02-01 00:25:10.000000', 'consum', 0.0211, 'lps'),
	(523842, 130, '2014-02-01 00:25:11.000000', 'consum', 0.0226, 'lps'),
	(523843, 130, '2014-02-01 00:25:12.000000', 'consum', 0.0216, 'lps'),
	(523844, 130, '2014-02-01 00:25:13.000000', 'consum', 0.0226, 'lps'),
	(523845, 130, '2014-02-01 00:25:14.000000', 'consum', 0.0219, 'lps'),
	(523846, 130, '2014-02-01 00:25:15.000000', 'consum', 0.0227, 'lps'),
	(523847, 130, '2014-02-01 00:25:16.000000', 'consum', 0.0214, 'lps'),
	(523848, 130, '2014-02-01 00:25:17.000000', 'consum', 0.0215, 'lps'),
	(523849, 130, '2014-02-01 00:25:18.000000', 'consum', 0.0223, 'lps'),
	(523850, 130, '2014-02-01 00:25:19.000000', 'consum', 0.0225, 'lps'),
	(523851, 130, '2014-02-01 00:25:20.000000', 'consum', 0.0211, 'lps'),
	(523852, 130, '2014-02-01 00:25:21.000000', 'consum', 0.0223, 'lps'),
	(523853, 130, '2014-02-01 00:25:22.000000', 'consum', 0.0218, 'lps'),
	(523854, 130, '2014-02-01 00:25:23.000000', 'consum', 0.0214, 'lps'),
	(523855, 130, '2014-02-01 00:25:24.000000', 'consum', 0.0222, 'lps'),
	(523856, 130, '2014-02-01 00:25:25.000000', 'consum', 0.0224, 'lps'),
	(523857, 130, '2014-02-01 00:25:26.000000', 'consum', 0.0224, 'lps'),
	(523858, 130, '2014-02-01 00:25:27.000000', 'consum', 0.0223, 'lps'),
	(523859, 130, '2014-02-01 00:25:28.000000', 'consum', 0.0214, 'lps'),
	(523860, 130, '2014-02-01 00:25:29.000000', 'consum', 0.0210, 'lps'),
	(523861, 130, '2014-02-01 00:25:30.000000', 'consum', 0.0217, 'lps'),
	(523862, 130, '2014-02-01 00:25:31.000000', 'consum', 0.0210, 'lps'),
	(523863, 130, '2014-02-01 00:25:32.000000', 'consum', 0.0223, 'lps'),
	(523864, 130, '2014-02-01 00:25:33.000000', 'consum', 0.0223, 'lps'),
	(523865, 130, '2014-02-01 00:25:34.000000', 'consum', 0.0217, 'lps'),
	(523866, 130, '2014-02-01 00:25:35.000000', 'consum', 0.0223, 'lps'),
	(523867, 130, '2014-02-01 00:25:36.000000', 'consum', 0.0222, 'lps'),
	(523868, 130, '2014-02-01 00:25:37.000000', 'consum', 0.0211, 'lps'),
	(523869, 130, '2014-02-01 00:25:38.000000', 'consum', 0.0216, 'lps'),
	(523870, 130, '2014-02-01 00:25:39.000000', 'consum', 0.0221, 'lps'),
	(523871, 130, '2014-02-01 00:25:40.000000', 'consum', 0.0212, 'lps'),
	(523872, 130, '2014-02-01 00:25:41.000000', 'consum', 0.0221, 'lps'),
	(523873, 130, '2014-02-01 00:25:42.000000', 'consum', 0.0226, 'lps'),
	(523874, 130, '2014-02-01 00:25:43.000000', 'consum', 0.0221, 'lps'),
	(523875, 130, '2014-02-01 00:25:44.000000', 'consum', 0.0217, 'lps'),
	(523876, 130, '2014-02-01 00:25:45.000000', 'consum', 0.0215, 'lps'),
	(523877, 130, '2014-02-01 00:25:46.000000', 'consum', 0.0211, 'lps'),
	(523878, 130, '2014-02-01 00:25:47.000000', 'consum', 0.0219, 'lps'),
	(523879, 130, '2014-02-01 00:25:48.000000', 'consum', 0.0217, 'lps'),
	(523880, 130, '2014-02-01 00:25:49.000000', 'consum', 0.0219, 'lps'),
	(523881, 130, '2014-02-01 00:25:50.000000', 'consum', 0.0214, 'lps'),
	(523882, 130, '2014-02-01 00:25:51.000000', 'consum', 0.0224, 'lps'),
	(523883, 130, '2014-02-01 00:25:52.000000', 'consum', 0.0214, 'lps'),
	(523884, 130, '2014-02-01 00:25:53.000000', 'consum', 0.0224, 'lps'),
	(523885, 130, '2014-02-01 00:25:54.000000', 'consum', 0.0216, 'lps'),
	(523886, 130, '2014-02-01 00:25:55.000000', 'consum', 0.0214, 'lps'),
	(523887, 130, '2014-02-01 00:25:56.000000', 'consum', 0.0213, 'lps'),
	(523888, 130, '2014-02-01 00:25:57.000000', 'consum', 0.0215, 'lps'),
	(523889, 130, '2014-02-01 00:25:58.000000', 'consum', 0.0225, 'lps'),
	(523890, 130, '2014-02-01 00:25:59.000000', 'consum', 0.0218, 'lps'),
	(523891, 130, '2014-02-01 00:26:00.000000', 'consum', 0.0222, 'lps'),
	(523892, 130, '2014-02-01 00:26:01.000000', 'consum', 0.0212, 'lps'),
	(523893, 130, '2014-02-01 00:26:02.000000', 'consum', 0.0220, 'lps'),
	(523894, 130, '2014-02-01 00:26:03.000000', 'consum', 0.0218, 'lps'),
	(523895, 130, '2014-02-01 00:26:04.000000', 'consum', 0.0221, 'lps'),
	(523896, 130, '2014-02-01 00:26:05.000000', 'consum', 0.0224, 'lps'),
	(523897, 130, '2014-02-01 00:26:06.000000', 'consum', 0.0227, 'lps'),
	(523898, 130, '2014-02-01 00:26:07.000000', 'consum', 0.0220, 'lps'),
	(523899, 130, '2014-02-01 00:26:08.000000', 'consum', 0.0227, 'lps'),
	(523900, 130, '2014-02-01 00:26:09.000000', 'consum', 0.0227, 'lps'),
	(523901, 130, '2014-02-01 00:26:10.000000', 'consum', 0.0211, 'lps'),
	(523902, 130, '2014-02-01 00:26:11.000000', 'consum', 0.0219, 'lps'),
	(523903, 130, '2014-02-01 00:26:12.000000', 'consum', 0.0216, 'lps'),
	(523904, 130, '2014-02-01 00:26:13.000000', 'consum', 0.0214, 'lps'),
	(523905, 130, '2014-02-01 00:26:14.000000', 'consum', 0.0214, 'lps'),
	(523906, 130, '2014-02-01 00:26:15.000000', 'consum', 0.0217, 'lps'),
	(523907, 130, '2014-02-01 00:26:16.000000', 'consum', 0.0217, 'lps'),
	(523908, 130, '2014-02-01 00:26:17.000000', 'consum', 0.0224, 'lps'),
	(523909, 130, '2014-02-01 00:26:18.000000', 'consum', 0.0221, 'lps'),
	(523910, 130, '2014-02-01 00:26:19.000000', 'consum', 0.0226, 'lps'),
	(523911, 130, '2014-02-01 00:26:20.000000', 'consum', 0.0221, 'lps'),
	(523912, 130, '2014-02-01 00:26:21.000000', 'consum', 0.0217, 'lps'),
	(523913, 130, '2014-02-01 00:26:22.000000', 'consum', 0.0211, 'lps'),
	(523914, 130, '2014-02-01 00:26:23.000000', 'consum', 0.0213, 'lps'),
	(523915, 130, '2014-02-01 00:26:24.000000', 'consum', 0.0225, 'lps'),
	(523916, 130, '2014-02-01 00:26:25.000000', 'consum', 0.0221, 'lps'),
	(523917, 130, '2014-02-01 00:26:26.000000', 'consum', 0.0221, 'lps'),
	(523918, 130, '2014-02-01 00:26:27.000000', 'consum', 0.0215, 'lps'),
	(523919, 130, '2014-02-01 00:26:28.000000', 'consum', 0.0219, 'lps'),
	(523920, 130, '2014-02-01 00:26:29.000000', 'consum', 0.0222, 'lps'),
	(523921, 130, '2014-02-01 00:26:30.000000', 'consum', 0.0210, 'lps'),
	(523922, 130, '2014-02-01 00:26:31.000000', 'consum', 0.0225, 'lps'),
	(523923, 130, '2014-02-01 00:26:32.000000', 'consum', 0.0216, 'lps'),
	(523924, 130, '2014-02-01 00:26:33.000000', 'consum', 0.0213, 'lps'),
	(523925, 130, '2014-02-01 00:26:34.000000', 'consum', 0.0227, 'lps'),
	(523926, 130, '2014-02-01 00:26:35.000000', 'consum', 0.0213, 'lps'),
	(523927, 130, '2014-02-01 00:26:36.000000', 'consum', 0.0212, 'lps'),
	(523928, 130, '2014-02-01 00:26:37.000000', 'consum', 0.0227, 'lps'),
	(523929, 130, '2014-02-01 00:26:38.000000', 'consum', 0.0217, 'lps'),
	(523930, 130, '2014-02-01 00:26:39.000000', 'consum', 0.0214, 'lps'),
	(523931, 130, '2014-02-01 00:26:40.000000', 'consum', 0.0210, 'lps'),
	(523932, 130, '2014-02-01 00:26:41.000000', 'consum', 0.0216, 'lps'),
	(523933, 130, '2014-02-01 00:26:42.000000', 'consum', 0.0224, 'lps'),
	(523934, 130, '2014-02-01 00:26:43.000000', 'consum', 0.0224, 'lps'),
	(523935, 130, '2014-02-01 00:26:44.000000', 'consum', 0.0222, 'lps'),
	(523936, 130, '2014-02-01 00:26:45.000000', 'consum', 0.0210, 'lps'),
	(523937, 130, '2014-02-01 00:26:46.000000', 'consum', 0.0212, 'lps'),
	(523938, 130, '2014-02-01 00:26:47.000000', 'consum', 0.0220, 'lps'),
	(523939, 130, '2014-02-01 00:26:48.000000', 'consum', 0.0220, 'lps'),
	(523940, 130, '2014-02-01 00:26:49.000000', 'consum', 0.0210, 'lps'),
	(523941, 130, '2014-02-01 00:26:50.000000', 'consum', 0.0217, 'lps'),
	(523942, 130, '2014-02-01 00:26:51.000000', 'consum', 0.0211, 'lps'),
	(523943, 130, '2014-02-01 00:26:52.000000', 'consum', 0.0212, 'lps'),
	(523944, 130, '2014-02-01 00:26:53.000000', 'consum', 0.0219, 'lps'),
	(523945, 130, '2014-02-01 00:26:54.000000', 'consum', 0.0212, 'lps'),
	(523946, 130, '2014-02-01 00:26:55.000000', 'consum', 0.0211, 'lps'),
	(523947, 130, '2014-02-01 00:26:56.000000', 'consum', 0.0211, 'lps'),
	(523948, 130, '2014-02-01 00:26:57.000000', 'consum', 0.0212, 'lps'),
	(523949, 130, '2014-02-01 00:26:58.000000', 'consum', 0.0217, 'lps'),
	(523950, 130, '2014-02-01 00:26:59.000000', 'consum', 0.0220, 'lps'),
	(523951, 130, '2014-02-01 00:27:00.000000', 'consum', 0.0223, 'lps'),
	(523952, 130, '2014-02-01 00:27:01.000000', 'consum', 0.0227, 'lps'),
	(523953, 130, '2014-02-01 00:27:02.000000', 'consum', 0.0221, 'lps'),
	(523954, 130, '2014-02-01 00:27:03.000000', 'consum', 0.0215, 'lps'),
	(523955, 130, '2014-02-01 00:27:04.000000', 'consum', 0.0220, 'lps'),
	(523956, 130, '2014-02-01 00:27:05.000000', 'consum', 0.0226, 'lps'),
	(523957, 130, '2014-02-01 00:27:06.000000', 'consum', 0.0227, 'lps'),
	(523958, 130, '2014-02-01 00:27:07.000000', 'consum', 0.0227, 'lps'),
	(523959, 130, '2014-02-01 00:27:08.000000', 'consum', 0.0211, 'lps'),
	(523960, 130, '2014-02-01 00:27:09.000000', 'consum', 0.0219, 'lps'),
	(523961, 130, '2014-02-01 00:27:10.000000', 'consum', 0.0216, 'lps'),
	(523962, 130, '2014-02-01 00:27:11.000000', 'consum', 0.0212, 'lps'),
	(523963, 130, '2014-02-01 00:27:12.000000', 'consum', 0.0223, 'lps'),
	(523964, 130, '2014-02-01 00:27:13.000000', 'consum', 0.0216, 'lps'),
	(523965, 130, '2014-02-01 00:27:14.000000', 'consum', 0.0217, 'lps'),
	(523966, 130, '2014-02-01 00:27:15.000000', 'consum', 0.0227, 'lps'),
	(523967, 130, '2014-02-01 00:27:16.000000', 'consum', 0.0222, 'lps'),
	(523968, 130, '2014-02-01 00:27:17.000000', 'consum', 0.0218, 'lps'),
	(523969, 130, '2014-02-01 00:27:18.000000', 'consum', 0.0215, 'lps'),
	(523970, 130, '2014-02-01 00:27:19.000000', 'consum', 0.0210, 'lps'),
	(523971, 130, '2014-02-01 00:27:20.000000', 'consum', 0.0216, 'lps'),
	(523972, 130, '2014-02-01 00:27:21.000000', 'consum', 0.0223, 'lps'),
	(523973, 130, '2014-02-01 00:27:22.000000', 'consum', 0.0220, 'lps'),
	(523974, 130, '2014-02-01 00:27:23.000000', 'consum', 0.0223, 'lps'),
	(523975, 130, '2014-02-01 00:27:24.000000', 'consum', 0.0210, 'lps'),
	(523976, 130, '2014-02-01 00:27:25.000000', 'consum', 0.0224, 'lps'),
	(523977, 130, '2014-02-01 00:27:26.000000', 'consum', 0.0225, 'lps'),
	(523978, 130, '2014-02-01 00:27:27.000000', 'consum', 0.0210, 'lps'),
	(523979, 130, '2014-02-01 00:27:28.000000', 'consum', 0.0220, 'lps'),
	(523980, 130, '2014-02-01 00:27:29.000000', 'consum', 0.0223, 'lps'),
	(523981, 130, '2014-02-01 00:27:30.000000', 'consum', 0.0226, 'lps'),
	(523982, 130, '2014-02-01 00:27:31.000000', 'consum', 0.0219, 'lps'),
	(523983, 130, '2014-02-01 00:27:32.000000', 'consum', 0.0223, 'lps'),
	(523984, 130, '2014-02-01 00:27:33.000000', 'consum', 0.0212, 'lps'),
	(523985, 130, '2014-02-01 00:27:34.000000', 'consum', 0.0219, 'lps'),
	(523986, 130, '2014-02-01 00:27:35.000000', 'consum', 0.0212, 'lps'),
	(523987, 130, '2014-02-01 00:27:36.000000', 'consum', 0.0214, 'lps'),
	(523988, 130, '2014-02-01 00:27:37.000000', 'consum', 0.0225, 'lps'),
	(523989, 130, '2014-02-01 00:27:38.000000', 'consum', 0.0217, 'lps'),
	(523990, 130, '2014-02-01 00:27:39.000000', 'consum', 0.0220, 'lps'),
	(523991, 130, '2014-02-01 00:27:40.000000', 'consum', 0.0222, 'lps'),
	(523992, 130, '2014-02-01 00:27:41.000000', 'consum', 0.0222, 'lps'),
	(523993, 130, '2014-02-01 00:27:42.000000', 'consum', 0.0217, 'lps'),
	(523994, 130, '2014-02-01 00:27:43.000000', 'consum', 0.0210, 'lps'),
	(523995, 130, '2014-02-01 00:27:44.000000', 'consum', 0.0226, 'lps'),
	(523996, 130, '2014-02-01 00:27:45.000000', 'consum', 0.0216, 'lps'),
	(523997, 130, '2014-02-01 00:27:46.000000', 'consum', 0.0213, 'lps'),
	(523998, 130, '2014-02-01 00:27:47.000000', 'consum', 0.0223, 'lps'),
	(523999, 130, '2014-02-01 00:27:48.000000', 'consum', 0.0212, 'lps'),
	(524000, 130, '2014-02-01 00:27:49.000000', 'consum', 0.0220, 'lps'),
	(524001, 130, '2014-02-01 00:27:50.000000', 'consum', 0.0219, 'lps'),
	(524002, 130, '2014-02-01 00:27:51.000000', 'consum', 0.0225, 'lps'),
	(524003, 130, '2014-02-01 00:27:52.000000', 'consum', 0.0222, 'lps'),
	(524004, 130, '2014-02-01 00:27:53.000000', 'consum', 0.0225, 'lps'),
	(524005, 130, '2014-02-01 00:27:54.000000', 'consum', 0.0213, 'lps'),
	(524006, 130, '2014-02-01 00:27:55.000000', 'consum', 0.0217, 'lps'),
	(524007, 130, '2014-02-01 00:27:56.000000', 'consum', 0.0219, 'lps'),
	(524008, 130, '2014-02-01 00:27:57.000000', 'consum', 0.0218, 'lps'),
	(524009, 130, '2014-02-01 00:27:58.000000', 'consum', 0.0221, 'lps'),
	(524010, 130, '2014-02-01 00:27:59.000000', 'consum', 0.0226, 'lps'),
	(524011, 130, '2014-02-01 00:28:00.000000', 'consum', 0.0220, 'lps'),
	(524012, 130, '2014-02-01 00:28:01.000000', 'consum', 0.0212, 'lps'),
	(524013, 130, '2014-02-01 00:28:02.000000', 'consum', 0.0226, 'lps'),
	(524014, 130, '2014-02-01 00:28:03.000000', 'consum', 0.0214, 'lps'),
	(524015, 130, '2014-02-01 00:28:04.000000', 'consum', 0.0219, 'lps'),
	(524016, 130, '2014-02-01 00:28:05.000000', 'consum', 0.0225, 'lps'),
	(524017, 130, '2014-02-01 00:28:06.000000', 'consum', 0.0220, 'lps'),
	(524018, 130, '2014-02-01 00:28:07.000000', 'consum', 0.0219, 'lps'),
	(524019, 130, '2014-02-01 00:28:08.000000', 'consum', 0.0224, 'lps'),
	(524020, 130, '2014-02-01 00:28:09.000000', 'consum', 0.0218, 'lps'),
	(524021, 130, '2014-02-01 00:28:10.000000', 'consum', 0.0210, 'lps'),
	(524022, 130, '2014-02-01 00:28:11.000000', 'consum', 0.0223, 'lps'),
	(524023, 130, '2014-02-01 00:28:12.000000', 'consum', 0.0220, 'lps'),
	(524024, 130, '2014-02-01 00:28:13.000000', 'consum', 0.0222, 'lps'),
	(524025, 130, '2014-02-01 00:28:14.000000', 'consum', 0.0220, 'lps'),
	(524026, 130, '2014-02-01 00:28:15.000000', 'consum', 0.0227, 'lps'),
	(524027, 130, '2014-02-01 00:28:16.000000', 'consum', 0.0212, 'lps'),
	(524028, 130, '2014-02-01 00:28:17.000000', 'consum', 0.0223, 'lps'),
	(524029, 130, '2014-02-01 00:28:18.000000', 'consum', 0.0216, 'lps'),
	(524030, 130, '2014-02-01 00:28:19.000000', 'consum', 0.0218, 'lps'),
	(524031, 130, '2014-02-01 00:28:20.000000', 'consum', 0.0215, 'lps'),
	(524032, 130, '2014-02-01 00:28:21.000000', 'consum', 0.0211, 'lps'),
	(524033, 130, '2014-02-01 00:28:22.000000', 'consum', 0.0217, 'lps'),
	(524034, 130, '2014-02-01 00:28:23.000000', 'consum', 0.0227, 'lps'),
	(524035, 130, '2014-02-01 00:28:24.000000', 'consum', 0.0218, 'lps'),
	(524036, 130, '2014-02-01 00:28:25.000000', 'consum', 0.0218, 'lps'),
	(524037, 130, '2014-02-01 00:28:26.000000', 'consum', 0.0227, 'lps'),
	(524038, 130, '2014-02-01 00:28:27.000000', 'consum', 0.0219, 'lps'),
	(524039, 130, '2014-02-01 00:28:28.000000', 'consum', 0.0223, 'lps'),
	(524040, 130, '2014-02-01 00:28:29.000000', 'consum', 0.0211, 'lps'),
	(524041, 130, '2014-02-01 00:28:30.000000', 'consum', 0.0215, 'lps'),
	(524042, 130, '2014-02-01 00:28:31.000000', 'consum', 0.0213, 'lps'),
	(524043, 130, '2014-02-01 00:28:32.000000', 'consum', 0.0227, 'lps'),
	(524044, 130, '2014-02-01 00:28:33.000000', 'consum', 0.0214, 'lps'),
	(524045, 130, '2014-02-01 00:28:34.000000', 'consum', 0.0218, 'lps'),
	(524046, 130, '2014-02-01 00:28:35.000000', 'consum', 0.0222, 'lps'),
	(524047, 130, '2014-02-01 00:28:36.000000', 'consum', 0.0225, 'lps'),
	(524048, 130, '2014-02-01 00:28:37.000000', 'consum', 0.0214, 'lps'),
	(524049, 130, '2014-02-01 00:28:38.000000', 'consum', 0.0222, 'lps'),
	(524050, 130, '2014-02-01 00:28:39.000000', 'consum', 0.0222, 'lps'),
	(524051, 130, '2014-02-01 00:28:40.000000', 'consum', 0.0215, 'lps'),
	(524052, 130, '2014-02-01 00:28:41.000000', 'consum', 0.0220, 'lps'),
	(524053, 130, '2014-02-01 00:28:42.000000', 'consum', 0.0210, 'lps'),
	(524054, 130, '2014-02-01 00:28:43.000000', 'consum', 0.0217, 'lps'),
	(524055, 130, '2014-02-01 00:28:44.000000', 'consum', 0.0210, 'lps'),
	(524056, 130, '2014-02-01 00:28:45.000000', 'consum', 0.0223, 'lps'),
	(524057, 130, '2014-02-01 00:28:46.000000', 'consum', 0.0225, 'lps'),
	(524058, 130, '2014-02-01 00:28:47.000000', 'consum', 0.0225, 'lps'),
	(524059, 130, '2014-02-01 00:28:48.000000', 'consum', 0.0223, 'lps'),
	(524060, 130, '2014-02-01 00:28:49.000000', 'consum', 0.0213, 'lps'),
	(524061, 130, '2014-02-01 00:28:50.000000', 'consum', 0.0222, 'lps'),
	(524062, 130, '2014-02-01 00:28:51.000000', 'consum', 0.0227, 'lps'),
	(524063, 130, '2014-02-01 00:28:52.000000', 'consum', 0.0221, 'lps'),
	(524064, 130, '2014-02-01 00:28:53.000000', 'consum', 0.0216, 'lps'),
	(524065, 130, '2014-02-01 00:28:54.000000', 'consum', 0.0227, 'lps'),
	(524066, 130, '2014-02-01 00:28:55.000000', 'consum', 0.0224, 'lps'),
	(524067, 130, '2014-02-01 00:28:56.000000', 'consum', 0.0210, 'lps'),
	(524068, 130, '2014-02-01 00:28:57.000000', 'consum', 0.0224, 'lps'),
	(524069, 130, '2014-02-01 00:28:58.000000', 'consum', 0.0224, 'lps'),
	(524070, 130, '2014-02-01 00:28:59.000000', 'consum', 0.0221, 'lps'),
	(524071, 130, '2014-02-01 00:29:00.000000', 'consum', 0.0223, 'lps'),
	(524072, 130, '2014-02-01 00:29:01.000000', 'consum', 0.0224, 'lps'),
	(524073, 130, '2014-02-01 00:29:02.000000', 'consum', 0.0223, 'lps'),
	(524074, 130, '2014-02-01 00:29:03.000000', 'consum', 0.0217, 'lps'),
	(524075, 130, '2014-02-01 00:29:04.000000', 'consum', 0.0223, 'lps'),
	(524076, 130, '2014-02-01 00:29:05.000000', 'consum', 0.0219, 'lps'),
	(524077, 130, '2014-02-01 00:29:06.000000', 'consum', 0.0215, 'lps'),
	(524078, 130, '2014-02-01 00:29:07.000000', 'consum', 0.0227, 'lps'),
	(524079, 130, '2014-02-01 00:29:08.000000', 'consum', 0.0225, 'lps'),
	(524080, 130, '2014-02-01 00:29:09.000000', 'consum', 0.0218, 'lps'),
	(524081, 130, '2014-02-01 00:29:10.000000', 'consum', 0.0223, 'lps'),
	(524082, 130, '2014-02-01 00:29:11.000000', 'consum', 0.0216, 'lps'),
	(524083, 130, '2014-02-01 00:29:12.000000', 'consum', 0.0219, 'lps'),
	(524084, 130, '2014-02-01 00:29:13.000000', 'consum', 0.0220, 'lps'),
	(524085, 130, '2014-02-01 00:29:14.000000', 'consum', 0.0215, 'lps'),
	(524086, 130, '2014-02-01 00:29:15.000000', 'consum', 0.0224, 'lps'),
	(524087, 130, '2014-02-01 00:29:16.000000', 'consum', 0.0213, 'lps'),
	(524088, 130, '2014-02-01 00:29:17.000000', 'consum', 0.0220, 'lps'),
	(524089, 130, '2014-02-01 00:29:18.000000', 'consum', 0.0214, 'lps'),
	(524090, 130, '2014-02-01 00:29:19.000000', 'consum', 0.0219, 'lps'),
	(524091, 130, '2014-02-01 00:29:20.000000', 'consum', 0.0225, 'lps'),
	(524092, 130, '2014-02-01 00:29:21.000000', 'consum', 0.0223, 'lps'),
	(524093, 130, '2014-02-01 00:29:22.000000', 'consum', 0.0211, 'lps'),
	(524094, 130, '2014-02-01 00:29:23.000000', 'consum', 0.0214, 'lps'),
	(524095, 130, '2014-02-01 00:29:24.000000', 'consum', 0.0227, 'lps'),
	(524096, 130, '2014-02-01 00:29:25.000000', 'consum', 0.0212, 'lps'),
	(524097, 130, '2014-02-01 00:29:26.000000', 'consum', 0.0221, 'lps'),
	(524098, 130, '2014-02-01 00:29:27.000000', 'consum', 0.0226, 'lps'),
	(524099, 130, '2014-02-01 00:29:28.000000', 'consum', 0.0220, 'lps'),
	(524100, 130, '2014-02-01 00:29:29.000000', 'consum', 0.0213, 'lps'),
	(524101, 130, '2014-02-01 00:29:30.000000', 'consum', 0.0214, 'lps'),
	(524102, 130, '2014-02-01 00:29:31.000000', 'consum', 0.0220, 'lps'),
	(524103, 130, '2014-02-01 00:29:32.000000', 'consum', 0.0214, 'lps'),
	(524104, 130, '2014-02-01 00:29:33.000000', 'consum', 0.0216, 'lps'),
	(524105, 130, '2014-02-01 00:29:34.000000', 'consum', 0.0212, 'lps'),
	(524106, 130, '2014-02-01 00:29:35.000000', 'consum', 0.0220, 'lps'),
	(524107, 130, '2014-02-01 00:29:36.000000', 'consum', 0.0217, 'lps'),
	(524108, 130, '2014-02-01 00:29:37.000000', 'consum', 0.0219, 'lps'),
	(524109, 130, '2014-02-01 00:29:38.000000', 'consum', 0.0213, 'lps'),
	(524110, 130, '2014-02-01 00:29:39.000000', 'consum', 0.0218, 'lps'),
	(524111, 130, '2014-02-01 00:29:40.000000', 'consum', 0.0226, 'lps'),
	(524112, 130, '2014-02-01 00:29:41.000000', 'consum', 0.0227, 'lps'),
	(524113, 130, '2014-02-01 00:29:42.000000', 'consum', 0.0211, 'lps'),
	(524114, 130, '2014-02-01 00:29:43.000000', 'consum', 0.0219, 'lps'),
	(524115, 130, '2014-02-01 00:29:44.000000', 'consum', 0.0216, 'lps'),
	(524116, 130, '2014-02-01 00:29:45.000000', 'consum', 0.0212, 'lps'),
	(524117, 130, '2014-02-01 00:29:46.000000', 'consum', 0.0223, 'lps'),
	(524118, 130, '2014-02-01 00:29:47.000000', 'consum', 0.0213, 'lps'),
	(524119, 130, '2014-02-01 00:29:48.000000', 'consum', 0.0225, 'lps'),
	(524120, 130, '2014-02-01 00:29:49.000000', 'consum', 0.0222, 'lps'),
	(524121, 130, '2014-02-01 00:29:50.000000', 'consum', 0.0226, 'lps'),
	(524122, 130, '2014-02-01 00:29:51.000000', 'consum', 0.0216, 'lps'),
	(524123, 130, '2014-02-01 00:29:52.000000', 'consum', 0.0212, 'lps'),
	(524124, 130, '2014-02-01 00:29:53.000000', 'consum', 0.0222, 'lps'),
	(524125, 130, '2014-02-01 00:29:54.000000', 'consum', 0.0225, 'lps'),
	(524126, 130, '2014-02-01 00:29:55.000000', 'consum', 0.0217, 'lps'),
	(524127, 130, '2014-02-01 00:29:56.000000', 'consum', 0.0216, 'lps'),
	(524128, 130, '2014-02-01 00:29:57.000000', 'consum', 0.0220, 'lps'),
	(524129, 130, '2014-02-01 00:29:58.000000', 'consum', 0.0223, 'lps'),
	(524130, 130, '2014-02-01 00:29:59.000000', 'consum', 0.0211, 'lps'),
	(524131, 130, '2014-02-01 00:30:00.000000', 'consum', 0.0211, 'lps'),
	(524132, 130, '2014-02-01 00:30:01.000000', 'consum', 0.0214, 'lps'),
	(524133, 130, '2014-02-01 00:30:02.000000', 'consum', 0.0211, 'lps'),
	(524134, 130, '2014-02-01 00:30:03.000000', 'consum', 0.0219, 'lps'),
	(524135, 130, '2014-02-01 00:30:04.000000', 'consum', 0.0217, 'lps'),
	(524136, 130, '2014-02-01 00:30:05.000000', 'consum', 0.0221, 'lps'),
	(524137, 130, '2014-02-01 00:30:06.000000', 'consum', 0.0224, 'lps'),
	(524138, 130, '2014-02-01 00:30:07.000000', 'consum', 0.0211, 'lps'),
	(524139, 130, '2014-02-01 00:30:08.000000', 'consum', 0.0211, 'lps'),
	(524140, 130, '2014-02-01 00:30:09.000000', 'consum', 0.0210, 'lps'),
	(524141, 130, '2014-02-01 00:30:10.000000', 'consum', 0.0211, 'lps'),
	(524142, 130, '2014-02-01 00:30:11.000000', 'consum', 0.0214, 'lps'),
	(524143, 130, '2014-02-01 00:30:12.000000', 'consum', 0.0225, 'lps'),
	(524144, 130, '2014-02-01 00:30:13.000000', 'consum', 0.0223, 'lps'),
	(524145, 130, '2014-02-01 00:30:14.000000', 'consum', 0.0213, 'lps'),
	(524146, 130, '2014-02-01 00:30:15.000000', 'consum', 0.0220, 'lps'),
	(524147, 130, '2014-02-01 00:30:16.000000', 'consum', 0.0217, 'lps'),
	(524148, 130, '2014-02-01 00:30:17.000000', 'consum', 0.0214, 'lps'),
	(524149, 130, '2014-02-01 00:30:18.000000', 'consum', 0.0227, 'lps'),
	(524150, 130, '2014-02-01 00:30:19.000000', 'consum', 0.0212, 'lps'),
	(524151, 130, '2014-02-01 00:30:20.000000', 'consum', 0.0223, 'lps'),
	(524152, 130, '2014-02-01 00:30:21.000000', 'consum', 0.0217, 'lps'),
	(524153, 130, '2014-02-01 00:30:22.000000', 'consum', 0.0226, 'lps'),
	(524154, 130, '2014-02-01 00:30:23.000000', 'consum', 0.0213, 'lps'),
	(524155, 130, '2014-02-01 00:30:24.000000', 'consum', 0.0213, 'lps'),
	(524156, 130, '2014-02-01 00:30:25.000000', 'consum', 0.0219, 'lps'),
	(524157, 130, '2014-02-01 00:30:26.000000', 'consum', 0.0227, 'lps'),
	(524158, 130, '2014-02-01 00:30:27.000000', 'consum', 0.0216, 'lps'),
	(524159, 130, '2014-02-01 00:30:28.000000', 'consum', 0.0226, 'lps'),
	(524160, 130, '2014-02-01 00:30:29.000000', 'consum', 0.0219, 'lps'),
	(524161, 130, '2014-02-01 00:30:30.000000', 'consum', 0.0223, 'lps'),
	(524162, 130, '2014-02-01 00:30:31.000000', 'consum', 0.0215, 'lps'),
	(524163, 130, '2014-02-01 00:30:32.000000', 'consum', 0.0214, 'lps'),
	(524164, 130, '2014-02-01 00:30:33.000000', 'consum', 0.0215, 'lps'),
	(524165, 130, '2014-02-01 00:30:34.000000', 'consum', 0.0224, 'lps'),
	(524166, 130, '2014-02-01 00:30:35.000000', 'consum', 0.0210, 'lps'),
	(524167, 130, '2014-02-01 00:30:36.000000', 'consum', 0.0223, 'lps'),
	(524168, 130, '2014-02-01 00:30:37.000000', 'consum', 0.0223, 'lps'),
	(524169, 130, '2014-02-01 00:30:38.000000', 'consum', 0.0216, 'lps'),
	(524170, 130, '2014-02-01 00:30:39.000000', 'consum', 0.0220, 'lps'),
	(524171, 130, '2014-02-01 00:30:40.000000', 'consum', 0.0225, 'lps'),
	(524172, 130, '2014-02-01 00:30:41.000000', 'consum', 0.0220, 'lps'),
	(524173, 130, '2014-02-01 00:30:42.000000', 'consum', 0.0217, 'lps'),
	(524174, 130, '2014-02-01 00:30:43.000000', 'consum', 0.0213, 'lps'),
	(524175, 130, '2014-02-01 00:30:44.000000', 'consum', 0.0223, 'lps'),
	(524176, 130, '2014-02-01 00:30:45.000000', 'consum', 0.0214, 'lps'),
	(524177, 130, '2014-02-01 00:30:46.000000', 'consum', 0.0226, 'lps'),
	(524178, 130, '2014-02-01 00:30:47.000000', 'consum', 0.0226, 'lps'),
	(524179, 130, '2014-02-01 00:30:48.000000', 'consum', 0.0222, 'lps'),
	(524180, 130, '2014-02-01 00:30:49.000000', 'consum', 0.0224, 'lps'),
	(524181, 130, '2014-02-01 00:30:50.000000', 'consum', 0.0210, 'lps'),
	(524182, 130, '2014-02-01 00:30:51.000000', 'consum', 0.0220, 'lps'),
	(524183, 130, '2014-02-01 00:30:52.000000', 'consum', 0.0226, 'lps'),
	(524184, 130, '2014-02-01 00:30:53.000000', 'consum', 0.0222, 'lps'),
	(524185, 130, '2014-02-01 00:30:54.000000', 'consum', 0.0226, 'lps'),
	(524186, 130, '2014-02-01 00:30:55.000000', 'consum', 0.0218, 'lps'),
	(524187, 130, '2014-02-01 00:30:56.000000', 'consum', 0.0218, 'lps'),
	(524188, 130, '2014-02-01 00:30:57.000000', 'consum', 0.0227, 'lps'),
	(524189, 130, '2014-02-01 00:30:58.000000', 'consum', 0.0220, 'lps'),
	(524190, 130, '2014-02-01 00:30:59.000000', 'consum', 0.0225, 'lps'),
	(524191, 130, '2014-02-01 00:31:00.000000', 'consum', 0.0220, 'lps'),
	(524192, 130, '2014-02-01 00:31:01.000000', 'consum', 0.0214, 'lps'),
	(524193, 130, '2014-02-01 00:31:02.000000', 'consum', 0.0219, 'lps'),
	(524194, 130, '2014-02-01 00:31:03.000000', 'consum', 0.0226, 'lps'),
	(524195, 130, '2014-02-01 00:31:04.000000', 'consum', 0.0227, 'lps'),
	(524196, 130, '2014-02-01 00:31:05.000000', 'consum', 0.0212, 'lps'),
	(524197, 130, '2014-02-01 00:31:06.000000', 'consum', 0.0225, 'lps'),
	(524198, 130, '2014-02-01 00:31:07.000000', 'consum', 0.0223, 'lps'),
	(524199, 130, '2014-02-01 00:31:08.000000', 'consum', 0.0214, 'lps'),
	(524200, 130, '2014-02-01 00:31:09.000000', 'consum', 0.0227, 'lps'),
	(524201, 130, '2014-02-01 00:31:10.000000', 'consum', 0.0212, 'lps'),
	(524202, 130, '2014-02-01 00:31:11.000000', 'consum', 0.0224, 'lps'),
	(524203, 130, '2014-02-01 00:31:12.000000', 'consum', 0.0220, 'lps'),
	(524204, 130, '2014-02-01 00:31:13.000000', 'consum', 0.0219, 'lps'),
	(524205, 130, '2014-02-01 00:31:14.000000', 'consum', 0.0223, 'lps'),
	(524206, 130, '2014-02-01 00:31:15.000000', 'consum', 0.0215, 'lps'),
	(524207, 130, '2014-02-01 00:31:16.000000', 'consum', 0.0213, 'lps'),
	(524208, 130, '2014-02-01 00:31:17.000000', 'consum', 0.0210, 'lps'),
	(524209, 130, '2014-02-01 00:31:18.000000', 'consum', 0.0222, 'lps'),
	(524210, 130, '2014-02-01 00:31:19.000000', 'consum', 0.0214, 'lps'),
	(524211, 130, '2014-02-01 00:31:20.000000', 'consum', 0.0213, 'lps'),
	(524212, 130, '2014-02-01 00:31:21.000000', 'consum', 0.0214, 'lps'),
	(524213, 130, '2014-02-01 00:31:22.000000', 'consum', 0.0220, 'lps'),
	(524214, 130, '2014-02-01 00:31:23.000000', 'consum', 0.0214, 'lps'),
	(524215, 130, '2014-02-01 00:31:24.000000', 'consum', 0.0217, 'lps'),
	(524216, 130, '2014-02-01 00:31:25.000000', 'consum', 0.0215, 'lps'),
	(524217, 130, '2014-02-01 00:31:26.000000', 'consum', 0.0214, 'lps'),
	(524218, 130, '2014-02-01 00:31:27.000000', 'consum', 0.0218, 'lps'),
	(524219, 130, '2014-02-01 00:31:28.000000', 'consum', 0.0221, 'lps'),
	(524220, 130, '2014-02-01 00:31:29.000000', 'consum', 0.0221, 'lps'),
	(524221, 130, '2014-02-01 00:31:30.000000', 'consum', 0.0215, 'lps'),
	(524222, 130, '2014-02-01 00:31:31.000000', 'consum', 0.0221, 'lps'),
	(524223, 130, '2014-02-01 00:31:32.000000', 'consum', 0.0213, 'lps'),
	(524224, 130, '2014-02-01 00:31:33.000000', 'consum', 0.0211, 'lps'),
	(524225, 130, '2014-02-01 00:31:34.000000', 'consum', 0.0223, 'lps'),
	(524226, 130, '2014-02-01 00:31:35.000000', 'consum', 0.0218, 'lps'),
	(524227, 130, '2014-02-01 00:31:36.000000', 'consum', 0.0214, 'lps'),
	(524228, 130, '2014-02-01 00:31:37.000000', 'consum', 0.0225, 'lps'),
	(524229, 130, '2014-02-01 00:31:38.000000', 'consum', 0.0220, 'lps'),
	(524230, 130, '2014-02-01 00:31:39.000000', 'consum', 0.0213, 'lps'),
	(524231, 130, '2014-02-01 00:31:40.000000', 'consum', 0.0215, 'lps'),
	(524232, 130, '2014-02-01 00:31:41.000000', 'consum', 0.0227, 'lps'),
	(524233, 130, '2014-02-01 00:31:42.000000', 'consum', 0.0226, 'lps'),
	(524234, 130, '2014-02-01 00:31:43.000000', 'consum', 0.0220, 'lps'),
	(524235, 130, '2014-02-01 00:31:44.000000', 'consum', 0.0215, 'lps'),
	(524236, 130, '2014-02-01 00:31:45.000000', 'consum', 0.0223, 'lps'),
	(524237, 130, '2014-02-01 00:31:46.000000', 'consum', 0.0226, 'lps'),
	(524238, 130, '2014-02-01 00:31:47.000000', 'consum', 0.0214, 'lps'),
	(524239, 130, '2014-02-01 00:31:48.000000', 'consum', 0.0220, 'lps'),
	(524240, 130, '2014-02-01 00:31:49.000000', 'consum', 0.0212, 'lps'),
	(524241, 130, '2014-02-01 00:31:50.000000', 'consum', 0.0210, 'lps'),
	(524242, 130, '2014-02-01 00:31:51.000000', 'consum', 0.0220, 'lps'),
	(524243, 130, '2014-02-01 00:31:52.000000', 'consum', 0.0225, 'lps'),
	(524244, 130, '2014-02-01 00:31:53.000000', 'consum', 0.0218, 'lps'),
	(524245, 130, '2014-02-01 00:31:54.000000', 'consum', 0.0223, 'lps'),
	(524246, 130, '2014-02-01 00:31:55.000000', 'consum', 0.0218, 'lps'),
	(524247, 130, '2014-02-01 00:31:56.000000', 'consum', 0.0212, 'lps'),
	(524248, 130, '2014-02-01 00:31:57.000000', 'consum', 0.0215, 'lps'),
	(524249, 130, '2014-02-01 00:31:58.000000', 'consum', 0.0210, 'lps'),
	(524250, 130, '2014-02-01 00:31:59.000000', 'consum', 0.0213, 'lps'),
	(524251, 130, '2014-02-01 00:32:00.000000', 'consum', 0.0225, 'lps'),
	(524252, 130, '2014-02-01 00:32:01.000000', 'consum', 0.0223, 'lps'),
	(524253, 130, '2014-02-01 00:32:02.000000', 'consum', 0.0212, 'lps'),
	(524254, 130, '2014-02-01 00:32:03.000000', 'consum', 0.0217, 'lps'),
	(524255, 130, '2014-02-01 00:32:04.000000', 'consum', 0.0224, 'lps'),
	(524256, 130, '2014-02-01 00:32:05.000000', 'consum', 0.0223, 'lps'),
	(524257, 130, '2014-02-01 00:32:06.000000', 'consum', 0.0214, 'lps'),
	(524258, 130, '2014-02-01 00:32:07.000000', 'consum', 0.0227, 'lps'),
	(524259, 130, '2014-02-01 00:32:08.000000', 'consum', 0.0210, 'lps'),
	(524260, 130, '2014-02-01 00:32:09.000000', 'consum', 0.0216, 'lps'),
	(524261, 130, '2014-02-01 00:32:10.000000', 'consum', 0.0221, 'lps'),
	(524262, 130, '2014-02-01 00:32:11.000000', 'consum', 0.0214, 'lps'),
	(524263, 130, '2014-02-01 00:32:12.000000', 'consum', 0.0215, 'lps'),
	(524264, 130, '2014-02-01 00:32:13.000000', 'consum', 0.0224, 'lps'),
	(524265, 130, '2014-02-01 00:32:14.000000', 'consum', 0.0211, 'lps'),
	(524266, 130, '2014-02-01 00:32:15.000000', 'consum', 0.0210, 'lps'),
	(524267, 130, '2014-02-01 00:32:16.000000', 'consum', 0.0223, 'lps'),
	(524268, 130, '2014-02-01 00:32:17.000000', 'consum', 0.0223, 'lps'),
	(524269, 130, '2014-02-01 00:32:18.000000', 'consum', 0.0218, 'lps'),
	(524270, 130, '2014-02-01 00:32:19.000000', 'consum', 0.0213, 'lps'),
	(524271, 130, '2014-02-01 00:32:20.000000', 'consum', 0.0218, 'lps'),
	(524272, 130, '2014-02-01 00:32:21.000000', 'consum', 0.0223, 'lps'),
	(524273, 130, '2014-02-01 00:32:22.000000', 'consum', 0.0215, 'lps'),
	(524274, 130, '2014-02-01 00:32:23.000000', 'consum', 0.0213, 'lps'),
	(524275, 130, '2014-02-01 00:32:24.000000', 'consum', 0.0214, 'lps'),
	(524276, 130, '2014-02-01 00:32:25.000000', 'consum', 0.0218, 'lps'),
	(524277, 130, '2014-02-01 00:32:26.000000', 'consum', 0.0223, 'lps'),
	(524278, 130, '2014-02-01 00:32:27.000000', 'consum', 0.0216, 'lps'),
	(524279, 130, '2014-02-01 00:32:28.000000', 'consum', 0.0220, 'lps'),
	(524280, 130, '2014-02-01 00:32:29.000000', 'consum', 0.0225, 'lps'),
	(524281, 130, '2014-02-01 00:32:30.000000', 'consum', 0.0217, 'lps'),
	(524282, 130, '2014-02-01 00:32:31.000000', 'consum', 0.0219, 'lps'),
	(524283, 130, '2014-02-01 00:32:32.000000', 'consum', 0.0218, 'lps'),
	(524284, 130, '2014-02-01 00:32:33.000000', 'consum', 0.0223, 'lps'),
	(524285, 130, '2014-02-01 00:32:34.000000', 'consum', 0.0215, 'lps'),
	(524286, 130, '2014-02-01 00:32:35.000000', 'consum', 0.0215, 'lps'),
	(524287, 130, '2014-02-01 00:32:36.000000', 'consum', 0.0219, 'lps'),
	(524288, 130, '2014-02-01 00:32:37.000000', 'consum', 0.0221, 'lps'),
	(524289, 130, '2014-02-01 00:32:38.000000', 'consum', 0.0224, 'lps'),
	(524290, 130, '2014-02-01 00:32:39.000000', 'consum', 0.0227, 'lps'),
	(524291, 130, '2014-02-01 00:32:40.000000', 'consum', 0.0219, 'lps'),
	(524292, 130, '2014-02-01 00:32:41.000000', 'consum', 0.0222, 'lps'),
	(524293, 130, '2014-02-01 00:32:42.000000', 'consum', 0.0224, 'lps'),
	(524294, 130, '2014-02-01 00:32:43.000000', 'consum', 0.0211, 'lps'),
	(524295, 130, '2014-02-01 00:32:44.000000', 'consum', 0.0210, 'lps'),
	(524296, 130, '2014-02-01 00:32:45.000000', 'consum', 0.0226, 'lps'),
	(524297, 130, '2014-02-01 00:32:46.000000', 'consum', 0.0216, 'lps'),
	(524298, 130, '2014-02-01 00:32:47.000000', 'consum', 0.0211, 'lps'),
	(524299, 130, '2014-02-01 00:32:48.000000', 'consum', 0.0215, 'lps'),
	(524300, 130, '2014-02-01 00:32:49.000000', 'consum', 0.0213, 'lps'),
	(524301, 130, '2014-02-01 00:32:50.000000', 'consum', 0.0214, 'lps'),
	(524302, 130, '2014-02-01 00:32:51.000000', 'consum', 0.0218, 'lps'),
	(524303, 130, '2014-02-01 00:32:52.000000', 'consum', 0.0224, 'lps'),
	(524304, 130, '2014-02-01 00:32:53.000000', 'consum', 0.0219, 'lps'),
	(524305, 130, '2014-02-01 00:32:54.000000', 'consum', 0.0212, 'lps'),
	(524306, 130, '2014-02-01 00:32:55.000000', 'consum', 0.0215, 'lps'),
	(524307, 130, '2014-02-01 00:32:56.000000', 'consum', 0.0226, 'lps'),
	(524308, 130, '2014-02-01 00:32:57.000000', 'consum', 0.0223, 'lps'),
	(524309, 130, '2014-02-01 00:32:58.000000', 'consum', 0.0211, 'lps'),
	(524310, 130, '2014-02-01 00:32:59.000000', 'consum', 0.0213, 'lps'),
	(524311, 130, '2014-02-01 00:33:00.000000', 'consum', 0.0223, 'lps'),
	(524312, 130, '2014-02-01 00:33:01.000000', 'consum', 0.0211, 'lps'),
	(524313, 130, '2014-02-01 00:33:02.000000', 'consum', 0.0211, 'lps'),
	(524314, 130, '2014-02-01 00:33:03.000000', 'consum', 0.0214, 'lps'),
	(524315, 130, '2014-02-01 00:33:04.000000', 'consum', 0.0227, 'lps'),
	(524316, 130, '2014-02-01 00:33:05.000000', 'consum', 0.0212, 'lps'),
	(524317, 130, '2014-02-01 00:33:06.000000', 'consum', 0.0225, 'lps'),
	(524318, 130, '2014-02-01 00:33:07.000000', 'consum', 0.0223, 'lps'),
	(524319, 130, '2014-02-01 00:33:08.000000', 'consum', 0.0215, 'lps'),
	(524320, 130, '2014-02-01 00:33:09.000000', 'consum', 0.0215, 'lps'),
	(524321, 130, '2014-02-01 00:33:10.000000', 'consum', 0.0218, 'lps'),
	(524322, 130, '2014-02-01 00:33:11.000000', 'consum', 0.0220, 'lps'),
	(524323, 130, '2014-02-01 00:33:12.000000', 'consum', 0.0215, 'lps'),
	(524324, 130, '2014-02-01 00:33:13.000000', 'consum', 0.0227, 'lps'),
	(524325, 130, '2014-02-01 00:33:14.000000', 'consum', 0.0226, 'lps'),
	(524326, 130, '2014-02-01 00:33:15.000000', 'consum', 0.0220, 'lps'),
	(524327, 130, '2014-02-01 00:33:16.000000', 'consum', 0.0213, 'lps'),
	(524328, 130, '2014-02-01 00:33:17.000000', 'consum', 0.0212, 'lps'),
	(524329, 130, '2014-02-01 00:33:18.000000', 'consum', 0.0211, 'lps'),
	(524330, 130, '2014-02-01 00:33:19.000000', 'consum', 0.0211, 'lps'),
	(524331, 130, '2014-02-01 00:33:20.000000', 'consum', 0.0211, 'lps'),
	(524332, 130, '2014-02-01 00:33:21.000000', 'consum', 0.0215, 'lps'),
	(524333, 130, '2014-02-01 00:33:22.000000', 'consum', 0.0212, 'lps'),
	(524334, 130, '2014-02-01 00:33:23.000000', 'consum', 0.0226, 'lps'),
	(524335, 130, '2014-02-01 00:33:24.000000', 'consum', 0.0212, 'lps'),
	(524336, 130, '2014-02-01 00:33:25.000000', 'consum', 0.0224, 'lps'),
	(524337, 130, '2014-02-01 00:33:26.000000', 'consum', 0.0224, 'lps'),
	(524338, 130, '2014-02-01 00:33:27.000000', 'consum', 0.0218, 'lps'),
	(524339, 130, '2014-02-01 00:33:28.000000', 'consum', 0.0226, 'lps'),
	(524340, 130, '2014-02-01 00:33:29.000000', 'consum', 0.0213, 'lps'),
	(524341, 130, '2014-02-01 00:33:30.000000', 'consum', 0.0212, 'lps'),
	(524342, 130, '2014-02-01 00:33:31.000000', 'consum', 0.0214, 'lps'),
	(524343, 130, '2014-02-01 00:33:32.000000', 'consum', 0.0222, 'lps'),
	(524344, 130, '2014-02-01 00:33:33.000000', 'consum', 0.0225, 'lps'),
	(524345, 130, '2014-02-01 00:33:34.000000', 'consum', 0.0214, 'lps'),
	(524346, 130, '2014-02-01 00:33:35.000000', 'consum', 0.0221, 'lps'),
	(524347, 130, '2014-02-01 00:33:36.000000', 'consum', 0.0218, 'lps'),
	(524348, 130, '2014-02-01 00:33:37.000000', 'consum', 0.0217, 'lps'),
	(524349, 130, '2014-02-01 00:33:38.000000', 'consum', 0.0223, 'lps'),
	(524350, 130, '2014-02-01 00:33:39.000000', 'consum', 0.0215, 'lps'),
	(524351, 130, '2014-02-01 00:33:40.000000', 'consum', 0.0218, 'lps'),
	(524352, 130, '2014-02-01 00:33:41.000000', 'consum', 0.0215, 'lps'),
	(524353, 130, '2014-02-01 00:33:42.000000', 'consum', 0.0211, 'lps'),
	(524354, 130, '2014-02-01 00:33:43.000000', 'consum', 0.0217, 'lps'),
	(524355, 130, '2014-02-01 00:33:44.000000', 'consum', 0.0227, 'lps'),
	(524356, 130, '2014-02-01 00:33:45.000000', 'consum', 0.0222, 'lps'),
	(524357, 130, '2014-02-01 00:33:46.000000', 'consum', 0.0218, 'lps'),
	(524358, 130, '2014-02-01 00:33:47.000000', 'consum', 0.0215, 'lps'),
	(524359, 130, '2014-02-01 00:33:48.000000', 'consum', 0.0227, 'lps'),
	(524360, 130, '2014-02-01 00:33:49.000000', 'consum', 0.0212, 'lps'),
	(524361, 130, '2014-02-01 00:33:50.000000', 'consum', 0.0220, 'lps'),
	(524362, 130, '2014-02-01 00:33:51.000000', 'consum', 0.0220, 'lps'),
	(524363, 130, '2014-02-01 00:33:52.000000', 'consum', 0.0214, 'lps'),
	(524364, 130, '2014-02-01 00:33:53.000000', 'consum', 0.0219, 'lps'),
	(524365, 130, '2014-02-01 00:33:54.000000', 'consum', 0.0224, 'lps'),
	(524366, 130, '2014-02-01 00:33:55.000000', 'consum', 0.0217, 'lps'),
	(524367, 130, '2014-02-01 00:33:56.000000', 'consum', 0.0221, 'lps'),
	(524368, 130, '2014-02-01 00:33:57.000000', 'consum', 0.0227, 'lps'),
	(524369, 130, '2014-02-01 00:33:58.000000', 'consum', 0.0210, 'lps'),
	(524370, 130, '2014-02-01 00:33:59.000000', 'consum', 0.0211, 'lps'),
	(524371, 130, '2014-02-01 00:34:00.000000', 'consum', 0.0218, 'lps'),
	(524372, 130, '2014-02-01 00:34:01.000000', 'consum', 0.0210, 'lps'),
	(524373, 130, '2014-02-01 00:34:02.000000', 'consum', 0.0223, 'lps'),
	(524374, 130, '2014-02-01 00:34:03.000000', 'consum', 0.0221, 'lps'),
	(524375, 130, '2014-02-01 00:34:04.000000', 'consum', 0.0226, 'lps'),
	(524376, 130, '2014-02-01 00:34:05.000000', 'consum', 0.0224, 'lps'),
	(524377, 130, '2014-02-01 00:34:06.000000', 'consum', 0.0211, 'lps'),
	(524378, 130, '2014-02-01 00:34:07.000000', 'consum', 0.0212, 'lps'),
	(524379, 130, '2014-02-01 00:34:08.000000', 'consum', 0.0218, 'lps'),
	(524380, 130, '2014-02-01 00:34:09.000000', 'consum', 0.0227, 'lps'),
	(524381, 130, '2014-02-01 00:34:10.000000', 'consum', 0.0217, 'lps'),
	(524382, 130, '2014-02-01 00:34:11.000000', 'consum', 0.0213, 'lps'),
	(524383, 130, '2014-02-01 00:34:12.000000', 'consum', 0.0222, 'lps'),
	(524384, 130, '2014-02-01 00:34:13.000000', 'consum', 0.0225, 'lps'),
	(524385, 130, '2014-02-01 00:34:14.000000', 'consum', 0.0213, 'lps'),
	(524386, 130, '2014-02-01 00:34:15.000000', 'consum', 0.0217, 'lps'),
	(524387, 130, '2014-02-01 00:34:16.000000', 'consum', 0.0218, 'lps'),
	(524388, 130, '2014-02-01 00:34:17.000000', 'consum', 0.0213, 'lps'),
	(524389, 130, '2014-02-01 00:34:18.000000', 'consum', 0.0219, 'lps'),
	(524390, 130, '2014-02-01 00:34:19.000000', 'consum', 0.0227, 'lps'),
	(524391, 130, '2014-02-01 00:34:20.000000', 'consum', 0.0217, 'lps'),
	(524392, 130, '2014-02-01 00:34:21.000000', 'consum', 0.0211, 'lps'),
	(524393, 130, '2014-02-01 00:34:22.000000', 'consum', 0.0215, 'lps'),
	(524394, 130, '2014-02-01 00:34:23.000000', 'consum', 0.0212, 'lps'),
	(524395, 130, '2014-02-01 00:34:24.000000', 'consum', 0.0224, 'lps'),
	(524396, 130, '2014-02-01 00:34:25.000000', 'consum', 0.0219, 'lps'),
	(524397, 130, '2014-02-01 00:34:26.000000', 'consum', 0.0216, 'lps'),
	(524398, 130, '2014-02-01 00:34:27.000000', 'consum', 0.0211, 'lps'),
	(524399, 130, '2014-02-01 00:34:28.000000', 'consum', 0.0217, 'lps'),
	(524400, 130, '2014-02-01 00:34:29.000000', 'consum', 0.0226, 'lps'),
	(524401, 130, '2014-02-01 00:34:30.000000', 'consum', 0.0213, 'lps'),
	(524402, 130, '2014-02-01 00:34:31.000000', 'consum', 0.0216, 'lps'),
	(524403, 130, '2014-02-01 00:34:32.000000', 'consum', 0.0210, 'lps'),
	(524404, 130, '2014-02-01 00:34:33.000000', 'consum', 0.0214, 'lps'),
	(524405, 130, '2014-02-01 00:34:34.000000', 'consum', 0.0211, 'lps'),
	(524406, 130, '2014-02-01 00:34:35.000000', 'consum', 0.0223, 'lps'),
	(524407, 130, '2014-02-01 00:34:36.000000', 'consum', 0.0219, 'lps'),
	(524408, 130, '2014-02-01 00:34:37.000000', 'consum', 0.0217, 'lps'),
	(524409, 130, '2014-02-01 00:34:38.000000', 'consum', 0.0219, 'lps'),
	(524410, 130, '2014-02-01 00:34:39.000000', 'consum', 0.0217, 'lps'),
	(524411, 130, '2014-02-01 00:34:40.000000', 'consum', 0.0215, 'lps'),
	(524412, 130, '2014-02-01 00:34:41.000000', 'consum', 0.0218, 'lps'),
	(524413, 130, '2014-02-01 00:34:42.000000', 'consum', 0.0215, 'lps'),
	(524414, 130, '2014-02-01 00:34:43.000000', 'consum', 0.0211, 'lps'),
	(524415, 130, '2014-02-01 00:34:44.000000', 'consum', 0.0221, 'lps'),
	(524416, 130, '2014-02-01 00:34:45.000000', 'consum', 0.0227, 'lps'),
	(524417, 130, '2014-02-01 00:34:46.000000', 'consum', 0.0224, 'lps'),
	(524418, 130, '2014-02-01 00:34:47.000000', 'consum', 0.0213, 'lps'),
	(524419, 130, '2014-02-01 00:34:48.000000', 'consum', 0.0221, 'lps'),
	(524420, 130, '2014-02-01 00:34:49.000000', 'consum', 0.0219, 'lps'),
	(524421, 130, '2014-02-01 00:34:50.000000', 'consum', 0.0221, 'lps'),
	(524422, 130, '2014-02-01 00:34:51.000000', 'consum', 0.0223, 'lps'),
	(524423, 130, '2014-02-01 00:34:52.000000', 'consum', 0.0223, 'lps'),
	(524424, 130, '2014-02-01 00:34:53.000000', 'consum', 0.0220, 'lps'),
	(524425, 130, '2014-02-01 00:34:54.000000', 'consum', 0.0219, 'lps'),
	(524426, 130, '2014-02-01 00:34:55.000000', 'consum', 0.0210, 'lps'),
	(524427, 130, '2014-02-01 00:34:56.000000', 'consum', 0.0219, 'lps'),
	(524428, 130, '2014-02-01 00:34:57.000000', 'consum', 0.0219, 'lps'),
	(524429, 130, '2014-02-01 00:34:58.000000', 'consum', 0.0212, 'lps'),
	(524430, 130, '2014-02-01 00:34:59.000000', 'consum', 0.0227, 'lps'),
	(524431, 130, '2014-02-01 00:35:00.000000', 'consum', 0.0218, 'lps'),
	(524432, 130, '2014-02-01 00:35:01.000000', 'consum', 0.0216, 'lps'),
	(524433, 130, '2014-02-01 00:35:02.000000', 'consum', 0.0218, 'lps'),
	(524434, 130, '2014-02-01 00:35:03.000000', 'consum', 0.0216, 'lps'),
	(524435, 130, '2014-02-01 00:35:04.000000', 'consum', 0.0215, 'lps'),
	(524436, 130, '2014-02-01 00:35:05.000000', 'consum', 0.0218, 'lps'),
	(524437, 130, '2014-02-01 00:35:06.000000', 'consum', 0.0217, 'lps'),
	(524438, 130, '2014-02-01 00:35:07.000000', 'consum', 0.0222, 'lps'),
	(524439, 130, '2014-02-01 00:35:08.000000', 'consum', 0.0213, 'lps'),
	(524440, 130, '2014-02-01 00:35:09.000000', 'consum', 0.0224, 'lps'),
	(524441, 130, '2014-02-01 00:35:10.000000', 'consum', 0.0217, 'lps'),
	(524442, 130, '2014-02-01 00:35:11.000000', 'consum', 0.0223, 'lps'),
	(524443, 130, '2014-02-01 00:35:12.000000', 'consum', 0.0217, 'lps'),
	(524444, 130, '2014-02-01 00:35:13.000000', 'consum', 0.0227, 'lps'),
	(524445, 130, '2014-02-01 00:35:14.000000', 'consum', 0.0221, 'lps'),
	(524446, 130, '2014-02-01 00:35:15.000000', 'consum', 0.0214, 'lps'),
	(524447, 130, '2014-02-01 00:35:16.000000', 'consum', 0.0217, 'lps'),
	(524448, 130, '2014-02-01 00:35:17.000000', 'consum', 0.0215, 'lps'),
	(524449, 130, '2014-02-01 00:35:18.000000', 'consum', 0.0213, 'lps'),
	(524450, 130, '2014-02-01 00:35:19.000000', 'consum', 0.0210, 'lps'),
	(524451, 130, '2014-02-01 00:35:20.000000', 'consum', 0.0220, 'lps'),
	(524452, 130, '2014-02-01 00:35:21.000000', 'consum', 0.0225, 'lps'),
	(524453, 130, '2014-02-01 00:35:22.000000', 'consum', 0.0221, 'lps'),
	(524454, 130, '2014-02-01 00:35:23.000000', 'consum', 0.0218, 'lps'),
	(524455, 130, '2014-02-01 00:35:24.000000', 'consum', 0.0219, 'lps'),
	(524456, 130, '2014-02-01 00:35:25.000000', 'consum', 0.0212, 'lps'),
	(524457, 130, '2014-02-01 00:35:26.000000', 'consum', 0.0213, 'lps'),
	(524458, 130, '2014-02-01 00:35:27.000000', 'consum', 0.0217, 'lps'),
	(524459, 130, '2014-02-01 00:35:28.000000', 'consum', 0.0220, 'lps'),
	(524460, 130, '2014-02-01 00:35:29.000000', 'consum', 0.0222, 'lps'),
	(524461, 130, '2014-02-01 00:35:30.000000', 'consum', 0.0222, 'lps'),
	(524462, 130, '2014-02-01 00:35:31.000000', 'consum', 0.0216, 'lps'),
	(524463, 130, '2014-02-01 00:35:32.000000', 'consum', 0.0221, 'lps'),
	(524464, 130, '2014-02-01 00:35:33.000000', 'consum', 0.0215, 'lps'),
	(524465, 130, '2014-02-01 00:35:34.000000', 'consum', 0.0217, 'lps'),
	(524466, 130, '2014-02-01 00:35:35.000000', 'consum', 0.0214, 'lps'),
	(524467, 130, '2014-02-01 00:35:36.000000', 'consum', 0.0210, 'lps'),
	(524468, 130, '2014-02-01 00:35:37.000000', 'consum', 0.0217, 'lps'),
	(524469, 130, '2014-02-01 00:35:38.000000', 'consum', 0.0226, 'lps'),
	(524470, 130, '2014-02-01 00:35:39.000000', 'consum', 0.0216, 'lps'),
	(524471, 130, '2014-02-01 00:35:40.000000', 'consum', 0.0210, 'lps'),
	(524472, 130, '2014-02-01 00:35:41.000000', 'consum', 0.0211, 'lps'),
	(524473, 130, '2014-02-01 00:35:42.000000', 'consum', 0.0214, 'lps'),
	(524474, 130, '2014-02-01 00:35:43.000000', 'consum', 0.0210, 'lps'),
	(524475, 130, '2014-02-01 00:35:44.000000', 'consum', 0.0216, 'lps'),
	(524476, 130, '2014-02-01 00:35:45.000000', 'consum', 0.0223, 'lps'),
	(524477, 130, '2014-02-01 00:35:46.000000', 'consum', 0.0224, 'lps'),
	(524478, 130, '2014-02-01 00:35:47.000000', 'consum', 0.0220, 'lps'),
	(524479, 130, '2014-02-01 00:35:48.000000', 'consum', 0.0220, 'lps'),
	(524480, 130, '2014-02-01 00:35:49.000000', 'consum', 0.0214, 'lps'),
	(524481, 130, '2014-02-01 00:35:50.000000', 'consum', 0.0217, 'lps'),
	(524482, 130, '2014-02-01 00:35:51.000000', 'consum', 0.0215, 'lps'),
	(524483, 130, '2014-02-01 00:35:52.000000', 'consum', 0.0216, 'lps'),
	(524484, 130, '2014-02-01 00:35:53.000000', 'consum', 0.0225, 'lps'),
	(524485, 130, '2014-02-01 00:35:54.000000', 'consum', 0.0214, 'lps'),
	(524486, 130, '2014-02-01 00:35:55.000000', 'consum', 0.0221, 'lps'),
	(524487, 130, '2014-02-01 00:35:56.000000', 'consum', 0.0217, 'lps'),
	(524488, 130, '2014-02-01 00:35:57.000000', 'consum', 0.0213, 'lps'),
	(524489, 130, '2014-02-01 00:35:58.000000', 'consum', 0.0222, 'lps'),
	(524490, 130, '2014-02-01 00:35:59.000000', 'consum', 0.0224, 'lps'),
	(524491, 130, '2014-02-01 00:36:00.000000', 'consum', 0.0212, 'lps'),
	(524492, 130, '2014-02-01 00:36:01.000000', 'consum', 0.0212, 'lps'),
	(524493, 130, '2014-02-01 00:36:02.000000', 'consum', 0.0213, 'lps'),
	(524494, 130, '2014-02-01 00:36:03.000000', 'consum', 0.0222, 'lps'),
	(524495, 130, '2014-02-01 00:36:04.000000', 'consum', 0.0223, 'lps'),
	(524496, 130, '2014-02-01 00:36:05.000000', 'consum', 0.0224, 'lps'),
	(524497, 130, '2014-02-01 00:36:06.000000', 'consum', 0.0221, 'lps'),
	(524498, 130, '2014-02-01 00:36:07.000000', 'consum', 0.0224, 'lps'),
	(524499, 130, '2014-02-01 00:36:08.000000', 'consum', 0.0210, 'lps'),
	(524500, 130, '2014-02-01 00:36:09.000000', 'consum', 0.0223, 'lps'),
	(524501, 130, '2014-02-01 00:36:10.000000', 'consum', 0.0223, 'lps'),
	(524502, 130, '2014-02-01 00:36:11.000000', 'consum', 0.0216, 'lps'),
	(524503, 130, '2014-02-01 00:36:12.000000', 'consum', 0.0222, 'lps'),
	(524504, 130, '2014-02-01 00:36:13.000000', 'consum', 0.0216, 'lps'),
	(524505, 130, '2014-02-01 00:36:14.000000', 'consum', 0.0222, 'lps'),
	(524506, 130, '2014-02-01 00:36:15.000000', 'consum', 0.0217, 'lps'),
	(524507, 130, '2014-02-01 00:36:16.000000', 'consum', 0.0211, 'lps'),
	(524508, 130, '2014-02-01 00:36:17.000000', 'consum', 0.0212, 'lps'),
	(524509, 130, '2014-02-01 00:36:18.000000', 'consum', 0.0218, 'lps'),
	(524510, 130, '2014-02-01 00:36:19.000000', 'consum', 0.0225, 'lps'),
	(524511, 130, '2014-02-01 00:36:20.000000', 'consum', 0.0226, 'lps'),
	(524512, 130, '2014-02-01 00:36:21.000000', 'consum', 0.0211, 'lps'),
	(524513, 130, '2014-02-01 00:36:22.000000', 'consum', 0.0219, 'lps'),
	(524514, 130, '2014-02-01 00:36:23.000000', 'consum', 0.0218, 'lps'),
	(524515, 130, '2014-02-01 00:36:24.000000', 'consum', 0.0224, 'lps'),
	(524516, 130, '2014-02-01 00:36:25.000000', 'consum', 0.0219, 'lps'),
	(524517, 130, '2014-02-01 00:36:26.000000', 'consum', 0.0215, 'lps'),
	(524518, 130, '2014-02-01 00:36:27.000000', 'consum', 0.0226, 'lps'),
	(524519, 130, '2014-02-01 00:36:28.000000', 'consum', 0.0221, 'lps'),
	(524520, 130, '2014-02-01 00:36:29.000000', 'consum', 0.0216, 'lps'),
	(524521, 130, '2014-02-01 00:36:30.000000', 'consum', 0.0225, 'lps'),
	(524522, 130, '2014-02-01 00:36:31.000000', 'consum', 0.0216, 'lps'),
	(524523, 130, '2014-02-01 00:36:32.000000', 'consum', 0.0214, 'lps'),
	(524524, 130, '2014-02-01 00:36:33.000000', 'consum', 0.0227, 'lps'),
	(524525, 130, '2014-02-01 00:36:34.000000', 'consum', 0.0215, 'lps'),
	(524526, 130, '2014-02-01 00:36:35.000000', 'consum', 0.0219, 'lps'),
	(524527, 130, '2014-02-01 00:36:36.000000', 'consum', 0.0222, 'lps'),
	(524528, 130, '2014-02-01 00:36:37.000000', 'consum', 0.0227, 'lps'),
	(524529, 130, '2014-02-01 00:36:38.000000', 'consum', 0.0223, 'lps'),
	(524530, 130, '2014-02-01 00:36:39.000000', 'consum', 0.0223, 'lps'),
	(524531, 130, '2014-02-01 00:36:40.000000', 'consum', 0.0220, 'lps'),
	(524532, 130, '2014-02-01 00:36:41.000000', 'consum', 0.0222, 'lps'),
	(524533, 130, '2014-02-01 00:36:42.000000', 'consum', 0.0222, 'lps'),
	(524534, 130, '2014-02-01 00:36:43.000000', 'consum', 0.0216, 'lps'),
	(524535, 130, '2014-02-01 00:36:44.000000', 'consum', 0.0222, 'lps'),
	(524536, 130, '2014-02-01 00:36:45.000000', 'consum', 0.0216, 'lps'),
	(524537, 130, '2014-02-01 00:36:46.000000', 'consum', 0.0223, 'lps'),
	(524538, 130, '2014-02-01 00:36:47.000000', 'consum', 0.0223, 'lps'),
	(524539, 130, '2014-02-01 00:36:48.000000', 'consum', 0.0216, 'lps'),
	(524540, 130, '2014-02-01 00:36:49.000000', 'consum', 0.0222, 'lps'),
	(524541, 130, '2014-02-01 00:36:50.000000', 'consum', 0.0214, 'lps'),
	(524542, 130, '2014-02-01 00:36:51.000000', 'consum', 0.0212, 'lps'),
	(524543, 130, '2014-02-01 00:36:52.000000', 'consum', 0.0210, 'lps'),
	(524544, 130, '2014-02-01 00:36:53.000000', 'consum', 0.0221, 'lps'),
	(524545, 130, '2014-02-01 00:36:54.000000', 'consum', 0.0212, 'lps'),
	(524546, 130, '2014-02-01 00:36:55.000000', 'consum', 0.0225, 'lps'),
	(524547, 130, '2014-02-01 00:36:56.000000', 'consum', 0.0226, 'lps'),
	(524548, 130, '2014-02-01 00:36:57.000000', 'consum', 0.0225, 'lps'),
	(524549, 130, '2014-02-01 00:36:58.000000', 'consum', 0.0221, 'lps'),
	(524550, 130, '2014-02-01 00:36:59.000000', 'consum', 0.0220, 'lps'),
	(524551, 130, '2014-02-01 00:37:00.000000', 'consum', 0.0211, 'lps'),
	(524552, 130, '2014-02-01 00:37:01.000000', 'consum', 0.0221, 'lps'),
	(524553, 130, '2014-02-01 00:37:02.000000', 'consum', 0.0210, 'lps'),
	(524554, 130, '2014-02-01 00:37:03.000000', 'consum', 0.0213, 'lps'),
	(524555, 130, '2014-02-01 00:37:04.000000', 'consum', 0.0227, 'lps'),
	(524556, 130, '2014-02-01 00:37:05.000000', 'consum', 0.0212, 'lps'),
	(524557, 130, '2014-02-01 00:37:06.000000', 'consum', 0.0226, 'lps'),
	(524558, 130, '2014-02-01 00:37:07.000000', 'consum', 0.0210, 'lps'),
	(524559, 130, '2014-02-01 00:37:08.000000', 'consum', 0.0217, 'lps'),
	(524560, 130, '2014-02-01 00:37:09.000000', 'consum', 0.0210, 'lps'),
	(524561, 130, '2014-02-01 00:37:10.000000', 'consum', 0.0224, 'lps'),
	(524562, 130, '2014-02-01 00:37:11.000000', 'consum', 0.0227, 'lps'),
	(524563, 130, '2014-02-01 00:37:12.000000', 'consum', 0.0218, 'lps'),
	(524564, 130, '2014-02-01 00:37:13.000000', 'consum', 0.0217, 'lps'),
	(524565, 130, '2014-02-01 00:37:14.000000', 'consum', 0.0223, 'lps'),
	(524566, 130, '2014-02-01 00:37:15.000000', 'consum', 0.0216, 'lps'),
	(524567, 130, '2014-02-01 00:37:16.000000', 'consum', 0.0220, 'lps'),
	(524568, 130, '2014-02-01 00:37:17.000000', 'consum', 0.0226, 'lps'),
	(524569, 130, '2014-02-01 00:37:18.000000', 'consum', 0.0224, 'lps'),
	(524570, 130, '2014-02-01 00:37:19.000000', 'consum', 0.0216, 'lps'),
	(524571, 130, '2014-02-01 00:37:20.000000', 'consum', 0.0217, 'lps'),
	(524572, 130, '2014-02-01 00:37:21.000000', 'consum', 0.0210, 'lps'),
	(524573, 130, '2014-02-01 00:37:22.000000', 'consum', 0.0223, 'lps'),
	(524574, 130, '2014-02-01 00:37:23.000000', 'consum', 0.0221, 'lps'),
	(524575, 130, '2014-02-01 00:37:24.000000', 'consum', 0.0211, 'lps'),
	(524576, 130, '2014-02-01 00:37:25.000000', 'consum', 0.0218, 'lps'),
	(524577, 130, '2014-02-01 00:37:26.000000', 'consum', 0.0212, 'lps'),
	(524578, 130, '2014-02-01 00:37:27.000000', 'consum', 0.0213, 'lps'),
	(524579, 130, '2014-02-01 00:37:28.000000', 'consum', 0.0221, 'lps'),
	(524580, 130, '2014-02-01 00:37:29.000000', 'consum', 0.0218, 'lps'),
	(524581, 130, '2014-02-01 00:37:30.000000', 'consum', 0.0220, 'lps'),
	(524582, 130, '2014-02-01 00:37:31.000000', 'consum', 0.0219, 'lps'),
	(524583, 130, '2014-02-01 00:37:32.000000', 'consum', 0.0224, 'lps'),
	(524584, 130, '2014-02-01 00:37:33.000000', 'consum', 0.0218, 'lps'),
	(524585, 130, '2014-02-01 00:37:34.000000', 'consum', 0.0224, 'lps'),
	(524586, 130, '2014-02-01 00:37:35.000000', 'consum', 0.0224, 'lps'),
	(524587, 130, '2014-02-01 00:37:36.000000', 'consum', 0.0218, 'lps'),
	(524588, 130, '2014-02-01 00:37:37.000000', 'consum', 0.0226, 'lps'),
	(524589, 130, '2014-02-01 00:37:38.000000', 'consum', 0.0212, 'lps'),
	(524590, 130, '2014-02-01 00:37:39.000000', 'consum', 0.0227, 'lps'),
	(524591, 130, '2014-02-01 00:37:40.000000', 'consum', 0.0217, 'lps'),
	(524592, 130, '2014-02-01 00:37:41.000000', 'consum', 0.0214, 'lps'),
	(524593, 130, '2014-02-01 00:37:42.000000', 'consum', 0.0226, 'lps'),
	(524594, 130, '2014-02-01 00:37:43.000000', 'consum', 0.0226, 'lps'),
	(524595, 130, '2014-02-01 00:37:44.000000', 'consum', 0.0223, 'lps'),
	(524596, 130, '2014-02-01 00:37:45.000000', 'consum', 0.0212, 'lps'),
	(524597, 130, '2014-02-01 00:37:46.000000', 'consum', 0.0215, 'lps'),
	(524598, 130, '2014-02-01 00:37:47.000000', 'consum', 0.0214, 'lps'),
	(524599, 130, '2014-02-01 00:37:48.000000', 'consum', 0.0214, 'lps'),
	(524600, 130, '2014-02-01 00:37:49.000000', 'consum', 0.0220, 'lps'),
	(524601, 130, '2014-02-01 00:37:50.000000', 'consum', 0.0210, 'lps'),
	(524602, 130, '2014-02-01 00:37:51.000000', 'consum', 0.0216, 'lps'),
	(524603, 130, '2014-02-01 00:37:52.000000', 'consum', 0.0226, 'lps'),
	(524604, 130, '2014-02-01 00:37:53.000000', 'consum', 0.0216, 'lps'),
	(524605, 130, '2014-02-01 00:37:54.000000', 'consum', 0.0210, 'lps'),
	(524606, 130, '2014-02-01 00:37:55.000000', 'consum', 0.0211, 'lps'),
	(524607, 130, '2014-02-01 00:37:56.000000', 'consum', 0.0217, 'lps'),
	(524608, 130, '2014-02-01 00:37:57.000000', 'consum', 0.0223, 'lps'),
	(524609, 130, '2014-02-01 00:37:58.000000', 'consum', 0.0221, 'lps'),
	(524610, 130, '2014-02-01 00:37:59.000000', 'consum', 0.0224, 'lps'),
	(524611, 130, '2014-02-01 00:38:00.000000', 'consum', 0.0213, 'lps'),
	(524612, 130, '2014-02-01 00:38:01.000000', 'consum', 0.0219, 'lps'),
	(524613, 130, '2014-02-01 00:38:02.000000', 'consum', 0.0227, 'lps'),
	(524614, 130, '2014-02-01 00:38:03.000000', 'consum', 0.0217, 'lps'),
	(524615, 130, '2014-02-01 00:38:04.000000', 'consum', 0.0211, 'lps'),
	(524616, 130, '2014-02-01 00:38:05.000000', 'consum', 0.0211, 'lps'),
	(524617, 130, '2014-02-01 00:38:06.000000', 'consum', 0.0216, 'lps'),
	(524618, 130, '2014-02-01 00:38:07.000000', 'consum', 0.0216, 'lps'),
	(524619, 130, '2014-02-01 00:38:08.000000', 'consum', 0.0224, 'lps'),
	(524620, 130, '2014-02-01 00:38:09.000000', 'consum', 0.0225, 'lps'),
	(524621, 130, '2014-02-01 00:38:10.000000', 'consum', 0.0227, 'lps'),
	(524622, 130, '2014-02-01 00:38:11.000000', 'consum', 0.0215, 'lps'),
	(524623, 130, '2014-02-01 00:38:12.000000', 'consum', 0.0220, 'lps'),
	(524624, 130, '2014-02-01 00:38:13.000000', 'consum', 0.0211, 'lps'),
	(524625, 130, '2014-02-01 00:38:14.000000', 'consum', 0.0220, 'lps'),
	(524626, 130, '2014-02-01 00:38:15.000000', 'consum', 0.0222, 'lps'),
	(524627, 130, '2014-02-01 00:38:16.000000', 'consum', 0.0222, 'lps'),
	(524628, 130, '2014-02-01 00:38:17.000000', 'consum', 0.0219, 'lps'),
	(524629, 130, '2014-02-01 00:38:18.000000', 'consum', 0.0217, 'lps'),
	(524630, 130, '2014-02-01 00:38:19.000000', 'consum', 0.0220, 'lps'),
	(524631, 130, '2014-02-01 00:38:20.000000', 'consum', 0.0219, 'lps'),
	(524632, 130, '2014-02-01 00:38:21.000000', 'consum', 0.0210, 'lps'),
	(524633, 130, '2014-02-01 00:38:22.000000', 'consum', 0.0218, 'lps'),
	(524634, 130, '2014-02-01 00:38:23.000000', 'consum', 0.0217, 'lps'),
	(524635, 130, '2014-02-01 00:38:24.000000', 'consum', 0.0220, 'lps'),
	(524636, 130, '2014-02-01 00:38:25.000000', 'consum', 0.0221, 'lps'),
	(524637, 130, '2014-02-01 00:38:26.000000', 'consum', 0.0220, 'lps'),
	(524638, 130, '2014-02-01 00:38:27.000000', 'consum', 0.0225, 'lps'),
	(524639, 130, '2014-02-01 00:38:28.000000', 'consum', 0.0220, 'lps'),
	(524640, 130, '2014-02-01 00:38:29.000000', 'consum', 0.0214, 'lps'),
	(524641, 130, '2014-02-01 00:38:30.000000', 'consum', 0.0218, 'lps'),
	(524642, 130, '2014-02-01 00:38:31.000000', 'consum', 0.0221, 'lps'),
	(524643, 130, '2014-02-01 00:38:32.000000', 'consum', 0.0225, 'lps'),
	(524644, 130, '2014-02-01 00:38:33.000000', 'consum', 0.0217, 'lps'),
	(524645, 130, '2014-02-01 00:38:34.000000', 'consum', 0.0217, 'lps'),
	(524646, 130, '2014-02-01 00:38:35.000000', 'consum', 0.0225, 'lps'),
	(524647, 130, '2014-02-01 00:38:36.000000', 'consum', 0.0212, 'lps'),
	(524648, 130, '2014-02-01 00:38:37.000000', 'consum', 0.0227, 'lps'),
	(524649, 130, '2014-02-01 00:38:38.000000', 'consum', 0.0219, 'lps'),
	(524650, 130, '2014-02-01 00:38:39.000000', 'consum', 0.0221, 'lps'),
	(524651, 130, '2014-02-01 00:38:40.000000', 'consum', 0.0220, 'lps'),
	(524652, 130, '2014-02-01 00:38:41.000000', 'consum', 0.0211, 'lps'),
	(524653, 130, '2014-02-01 00:38:42.000000', 'consum', 0.0222, 'lps'),
	(524654, 130, '2014-02-01 00:38:43.000000', 'consum', 0.0211, 'lps'),
	(524655, 130, '2014-02-01 00:38:44.000000', 'consum', 0.0217, 'lps'),
	(524656, 130, '2014-02-01 00:38:45.000000', 'consum', 0.0223, 'lps'),
	(524657, 130, '2014-02-01 00:38:46.000000', 'consum', 0.0217, 'lps'),
	(524658, 130, '2014-02-01 00:38:47.000000', 'consum', 0.0210, 'lps'),
	(524659, 130, '2014-02-01 00:38:48.000000', 'consum', 0.0223, 'lps'),
	(524660, 130, '2014-02-01 00:38:49.000000', 'consum', 0.0223, 'lps'),
	(524661, 130, '2014-02-01 00:38:50.000000', 'consum', 0.0217, 'lps'),
	(524662, 130, '2014-02-01 00:38:51.000000', 'consum', 0.0223, 'lps'),
	(524663, 130, '2014-02-01 00:38:52.000000', 'consum', 0.0221, 'lps'),
	(524664, 130, '2014-02-01 00:38:53.000000', 'consum', 0.0210, 'lps'),
	(524665, 130, '2014-02-01 00:38:54.000000', 'consum', 0.0211, 'lps'),
	(524666, 130, '2014-02-01 00:38:55.000000', 'consum', 0.0218, 'lps'),
	(524667, 130, '2014-02-01 00:38:56.000000', 'consum', 0.0210, 'lps'),
	(524668, 130, '2014-02-01 00:38:57.000000', 'consum', 0.0225, 'lps'),
	(524669, 130, '2014-02-01 00:38:58.000000', 'consum', 0.0211, 'lps'),
	(524670, 130, '2014-02-01 00:38:59.000000', 'consum', 0.0223, 'lps'),
	(524671, 130, '2014-02-01 00:39:00.000000', 'consum', 0.0221, 'lps'),
	(524672, 130, '2014-02-01 00:39:01.000000', 'consum', 0.0225, 'lps'),
	(524673, 130, '2014-02-01 00:39:02.000000', 'consum', 0.0218, 'lps'),
	(524674, 130, '2014-02-01 00:39:03.000000', 'consum', 0.0221, 'lps'),
	(524675, 130, '2014-02-01 00:39:04.000000', 'consum', 0.0227, 'lps'),
	(524676, 130, '2014-02-01 00:39:05.000000', 'consum', 0.0223, 'lps'),
	(524677, 130, '2014-02-01 00:39:06.000000', 'consum', 0.0227, 'lps'),
	(524678, 130, '2014-02-01 00:39:07.000000', 'consum', 0.0220, 'lps'),
	(524679, 130, '2014-02-01 00:39:08.000000', 'consum', 0.0210, 'lps'),
	(524680, 130, '2014-02-01 00:39:09.000000', 'consum', 0.0214, 'lps'),
	(524681, 130, '2014-02-01 00:39:10.000000', 'consum', 0.0215, 'lps'),
	(524682, 130, '2014-02-01 00:39:11.000000', 'consum', 0.0221, 'lps'),
	(524683, 130, '2014-02-01 00:39:12.000000', 'consum', 0.0216, 'lps'),
	(524684, 130, '2014-02-01 00:39:13.000000', 'consum', 0.0224, 'lps'),
	(524685, 130, '2014-02-01 00:39:14.000000', 'consum', 0.0211, 'lps'),
	(524686, 130, '2014-02-01 00:39:15.000000', 'consum', 0.0226, 'lps'),
	(524687, 130, '2014-02-01 00:39:16.000000', 'consum', 0.0215, 'lps'),
	(524688, 130, '2014-02-01 00:39:17.000000', 'consum', 0.0223, 'lps'),
	(524689, 130, '2014-02-01 00:39:18.000000', 'consum', 0.0226, 'lps'),
	(524690, 130, '2014-02-01 00:39:19.000000', 'consum', 0.0217, 'lps'),
	(524691, 130, '2014-02-01 00:39:20.000000', 'consum', 0.0213, 'lps'),
	(524692, 130, '2014-02-01 00:39:21.000000', 'consum', 0.0223, 'lps'),
	(524693, 130, '2014-02-01 00:39:22.000000', 'consum', 0.0211, 'lps'),
	(524694, 130, '2014-02-01 00:39:23.000000', 'consum', 0.0214, 'lps'),
	(524695, 130, '2014-02-01 00:39:24.000000', 'consum', 0.0211, 'lps'),
	(524696, 130, '2014-02-01 00:39:25.000000', 'consum', 0.0219, 'lps'),
	(524697, 130, '2014-02-01 00:39:26.000000', 'consum', 0.0216, 'lps'),
	(524698, 130, '2014-02-01 00:39:27.000000', 'consum', 0.0213, 'lps'),
	(524699, 130, '2014-02-01 00:39:28.000000', 'consum', 0.0226, 'lps'),
	(524700, 130, '2014-02-01 00:39:29.000000', 'consum', 0.0211, 'lps'),
	(524701, 130, '2014-02-01 00:39:30.000000', 'consum', 0.0221, 'lps'),
	(524702, 130, '2014-02-01 00:39:31.000000', 'consum', 0.0224, 'lps'),
	(524703, 130, '2014-02-01 00:39:32.000000', 'consum', 0.0214, 'lps'),
	(524704, 130, '2014-02-01 00:39:33.000000', 'consum', 0.0223, 'lps'),
	(524705, 130, '2014-02-01 00:39:34.000000', 'consum', 0.0212, 'lps'),
	(524706, 130, '2014-02-01 00:39:35.000000', 'consum', 0.0215, 'lps'),
	(524707, 130, '2014-02-01 00:39:36.000000', 'consum', 0.0212, 'lps'),
	(524708, 130, '2014-02-01 00:39:37.000000', 'consum', 0.0223, 'lps'),
	(524709, 130, '2014-02-01 00:39:38.000000', 'consum', 0.0216, 'lps'),
	(524710, 130, '2014-02-01 00:39:39.000000', 'consum', 0.0221, 'lps'),
	(524711, 130, '2014-02-01 00:39:40.000000', 'consum', 0.0227, 'lps'),
	(524712, 130, '2014-02-01 00:39:41.000000', 'consum', 0.0211, 'lps'),
	(524713, 130, '2014-02-01 00:39:42.000000', 'consum', 0.0216, 'lps'),
	(524714, 130, '2014-02-01 00:39:43.000000', 'consum', 0.0219, 'lps'),
	(524715, 130, '2014-02-01 00:39:44.000000', 'consum', 0.0220, 'lps'),
	(524716, 130, '2014-02-01 00:39:45.000000', 'consum', 0.0217, 'lps'),
	(524717, 130, '2014-02-01 00:39:46.000000', 'consum', 0.0214, 'lps'),
	(524718, 130, '2014-02-01 00:39:47.000000', 'consum', 0.0210, 'lps'),
	(524719, 130, '2014-02-01 00:39:48.000000', 'consum', 0.0216, 'lps'),
	(524720, 130, '2014-02-01 00:39:49.000000', 'consum', 0.0221, 'lps'),
	(524721, 130, '2014-02-01 00:39:50.000000', 'consum', 0.0213, 'lps'),
	(524722, 130, '2014-02-01 00:39:51.000000', 'consum', 0.0212, 'lps'),
	(524723, 130, '2014-02-01 00:39:52.000000', 'consum', 0.0227, 'lps'),
	(524724, 130, '2014-02-01 00:39:53.000000', 'consum', 0.0218, 'lps'),
	(524725, 130, '2014-02-01 00:39:54.000000', 'consum', 0.0218, 'lps'),
	(524726, 130, '2014-02-01 00:39:55.000000', 'consum', 0.0227, 'lps'),
	(524727, 130, '2014-02-01 00:39:56.000000', 'consum', 0.0217, 'lps'),
	(524728, 130, '2014-02-01 00:39:57.000000', 'consum', 0.0212, 'lps'),
	(524729, 130, '2014-02-01 00:39:58.000000', 'consum', 0.0219, 'lps'),
	(524730, 130, '2014-02-01 00:39:59.000000', 'consum', 0.0213, 'lps'),
	(524731, 130, '2014-02-01 00:40:00.000000', 'consum', 0.0215, 'lps'),
	(524732, 130, '2014-02-01 00:40:01.000000', 'consum', 0.0227, 'lps'),
	(524733, 130, '2014-02-01 00:40:02.000000', 'consum', 0.0227, 'lps'),
	(524734, 130, '2014-02-01 00:40:03.000000', 'consum', 0.0225, 'lps'),
	(524735, 130, '2014-02-01 00:40:04.000000', 'consum', 0.0216, 'lps'),
	(524736, 130, '2014-02-01 00:40:05.000000', 'consum', 0.0216, 'lps'),
	(524737, 130, '2014-02-01 00:40:06.000000', 'consum', 0.0221, 'lps'),
	(524738, 130, '2014-02-01 00:40:07.000000', 'consum', 0.0212, 'lps'),
	(524739, 130, '2014-02-01 00:40:08.000000', 'consum', 0.0223, 'lps'),
	(524740, 130, '2014-02-01 00:40:09.000000', 'consum', 0.0217, 'lps'),
	(524741, 130, '2014-02-01 00:40:10.000000', 'consum', 0.0224, 'lps'),
	(524742, 130, '2014-02-01 00:40:11.000000', 'consum', 0.0223, 'lps'),
	(524743, 130, '2014-02-01 00:40:12.000000', 'consum', 0.0214, 'lps'),
	(524744, 130, '2014-02-01 00:40:13.000000', 'consum', 0.0210, 'lps'),
	(524745, 130, '2014-02-01 00:40:14.000000', 'consum', 0.0219, 'lps'),
	(524746, 130, '2014-02-01 00:40:15.000000', 'consum', 0.0216, 'lps'),
	(524747, 130, '2014-02-01 00:40:16.000000', 'consum', 0.0216, 'lps'),
	(524748, 130, '2014-02-01 00:40:17.000000', 'consum', 0.0220, 'lps'),
	(524749, 130, '2014-02-01 00:40:18.000000', 'consum', 0.0226, 'lps'),
	(524750, 130, '2014-02-01 00:40:19.000000', 'consum', 0.0223, 'lps'),
	(524751, 130, '2014-02-01 00:40:20.000000', 'consum', 0.0227, 'lps'),
	(524752, 130, '2014-02-01 00:40:21.000000', 'consum', 0.0222, 'lps'),
	(524753, 130, '2014-02-01 00:40:22.000000', 'consum', 0.0217, 'lps'),
	(524754, 130, '2014-02-01 00:40:23.000000', 'consum', 0.0212, 'lps'),
	(524755, 130, '2014-02-01 00:40:24.000000', 'consum', 0.0218, 'lps'),
	(524756, 130, '2014-02-01 00:40:25.000000', 'consum', 0.0225, 'lps'),
	(524757, 130, '2014-02-01 00:40:26.000000', 'consum', 0.0210, 'lps'),
	(524758, 130, '2014-02-01 00:40:27.000000', 'consum', 0.0219, 'lps'),
	(524759, 130, '2014-02-01 00:40:28.000000', 'consum', 0.0217, 'lps'),
	(524760, 130, '2014-02-01 00:40:29.000000', 'consum', 0.0219, 'lps'),
	(524761, 130, '2014-02-01 00:40:30.000000', 'consum', 0.0215, 'lps'),
	(524762, 130, '2014-02-01 00:40:31.000000', 'consum', 0.0211, 'lps'),
	(524763, 130, '2014-02-01 00:40:32.000000', 'consum', 0.0218, 'lps'),
	(524764, 130, '2014-02-01 00:40:33.000000', 'consum', 0.0210, 'lps'),
	(524765, 130, '2014-02-01 00:40:34.000000', 'consum', 0.0224, 'lps'),
	(524766, 130, '2014-02-01 00:40:35.000000', 'consum', 0.0225, 'lps'),
	(524767, 130, '2014-02-01 00:40:36.000000', 'consum', 0.0227, 'lps'),
	(524768, 130, '2014-02-01 00:40:37.000000', 'consum', 0.0215, 'lps'),
	(524769, 130, '2014-02-01 00:40:38.000000', 'consum', 0.0218, 'lps'),
	(524770, 130, '2014-02-01 00:40:39.000000', 'consum', 0.0220, 'lps'),
	(524771, 130, '2014-02-01 00:40:40.000000', 'consum', 0.0218, 'lps'),
	(524772, 130, '2014-02-01 00:40:41.000000', 'consum', 0.0221, 'lps'),
	(524773, 130, '2014-02-01 00:40:42.000000', 'consum', 0.0224, 'lps'),
	(524774, 130, '2014-02-01 00:40:43.000000', 'consum', 0.0211, 'lps'),
	(524775, 130, '2014-02-01 00:40:44.000000', 'consum', 0.0210, 'lps'),
	(524776, 130, '2014-02-01 00:40:45.000000', 'consum', 0.0223, 'lps'),
	(524777, 130, '2014-02-01 00:40:46.000000', 'consum', 0.0224, 'lps'),
	(524778, 130, '2014-02-01 00:40:47.000000', 'consum', 0.0223, 'lps'),
	(524779, 130, '2014-02-01 00:40:48.000000', 'consum', 0.0214, 'lps'),
	(524780, 130, '2014-02-01 00:40:49.000000', 'consum', 0.0211, 'lps'),
	(524781, 130, '2014-02-01 00:40:50.000000', 'consum', 0.0220, 'lps'),
	(524782, 130, '2014-02-01 00:40:51.000000', 'consum', 0.0221, 'lps'),
	(524783, 130, '2014-02-01 00:40:52.000000', 'consum', 0.0218, 'lps'),
	(524784, 130, '2014-02-01 00:40:53.000000', 'consum', 0.0218, 'lps'),
	(524785, 130, '2014-02-01 00:40:54.000000', 'consum', 0.0227, 'lps'),
	(524786, 130, '2014-02-01 00:40:55.000000', 'consum', 0.0217, 'lps'),
	(524787, 130, '2014-02-01 00:40:56.000000', 'consum', 0.0213, 'lps'),
	(524788, 130, '2014-02-01 00:40:57.000000', 'consum', 0.0222, 'lps'),
	(524789, 130, '2014-02-01 00:40:58.000000', 'consum', 0.0227, 'lps'),
	(524790, 130, '2014-02-01 00:40:59.000000', 'consum', 0.0223, 'lps'),
	(524791, 130, '2014-02-01 00:41:00.000000', 'consum', 0.0223, 'lps'),
	(524792, 130, '2014-02-01 00:41:01.000000', 'consum', 0.0221, 'lps'),
	(524793, 130, '2014-02-01 00:41:02.000000', 'consum', 0.0224, 'lps'),
	(524794, 130, '2014-02-01 00:41:03.000000', 'consum', 0.0214, 'lps'),
	(524795, 130, '2014-02-01 00:41:04.000000', 'consum', 0.0224, 'lps'),
	(524796, 130, '2014-02-01 00:41:05.000000', 'consum', 0.0213, 'lps'),
	(524797, 130, '2014-02-01 00:41:06.000000', 'consum', 0.0219, 'lps'),
	(524798, 130, '2014-02-01 00:41:07.000000', 'consum', 0.0211, 'lps'),
	(524799, 130, '2014-02-01 00:41:08.000000', 'consum', 0.0226, 'lps'),
	(524800, 130, '2014-02-01 00:41:09.000000', 'consum', 0.0214, 'lps'),
	(524801, 130, '2014-02-01 00:41:10.000000', 'consum', 0.0218, 'lps'),
	(524802, 130, '2014-02-01 00:41:11.000000', 'consum', 0.0220, 'lps'),
	(524803, 130, '2014-02-01 00:41:12.000000', 'consum', 0.0219, 'lps'),
	(524804, 130, '2014-02-01 00:41:13.000000', 'consum', 0.0226, 'lps'),
	(524805, 130, '2014-02-01 00:41:14.000000', 'consum', 0.0211, 'lps'),
	(524806, 130, '2014-02-01 00:41:15.000000', 'consum', 0.0222, 'lps'),
	(524807, 130, '2014-02-01 00:41:16.000000', 'consum', 0.0211, 'lps'),
	(524808, 130, '2014-02-01 00:41:17.000000', 'consum', 0.0216, 'lps'),
	(524809, 130, '2014-02-01 00:41:18.000000', 'consum', 0.0220, 'lps'),
	(524810, 130, '2014-02-01 00:41:19.000000', 'consum', 0.0224, 'lps'),
	(524811, 130, '2014-02-01 00:41:20.000000', 'consum', 0.0216, 'lps'),
	(524812, 130, '2014-02-01 00:41:21.000000', 'consum', 0.0217, 'lps'),
	(524813, 130, '2014-02-01 00:41:22.000000', 'consum', 0.0225, 'lps'),
	(524814, 130, '2014-02-01 00:41:23.000000', 'consum', 0.0213, 'lps'),
	(524815, 130, '2014-02-01 00:41:24.000000', 'consum', 0.0216, 'lps'),
	(524816, 130, '2014-02-01 00:41:25.000000', 'consum', 0.0214, 'lps'),
	(524817, 130, '2014-02-01 00:41:26.000000', 'consum', 0.0210, 'lps'),
	(524818, 130, '2014-02-01 00:41:27.000000', 'consum', 0.0219, 'lps'),
	(524819, 130, '2014-02-01 00:41:28.000000', 'consum', 0.0218, 'lps'),
	(524820, 130, '2014-02-01 00:41:29.000000', 'consum', 0.0224, 'lps'),
	(524821, 130, '2014-02-01 00:41:30.000000', 'consum', 0.0222, 'lps'),
	(524822, 130, '2014-02-01 00:41:31.000000', 'consum', 0.0211, 'lps'),
	(524823, 130, '2014-02-01 00:41:32.000000', 'consum', 0.0216, 'lps'),
	(524824, 130, '2014-02-01 00:41:33.000000', 'consum', 0.0220, 'lps'),
	(524825, 130, '2014-02-01 00:41:34.000000', 'consum', 0.0224, 'lps'),
	(524826, 130, '2014-02-01 00:41:35.000000', 'consum', 0.0214, 'lps'),
	(524827, 130, '2014-02-01 00:41:36.000000', 'consum', 0.0224, 'lps'),
	(524828, 130, '2014-02-01 00:41:37.000000', 'consum', 0.0213, 'lps'),
	(524829, 130, '2014-02-01 00:41:38.000000', 'consum', 0.0221, 'lps'),
	(524830, 130, '2014-02-01 00:41:39.000000', 'consum', 0.0222, 'lps'),
	(524831, 130, '2014-02-01 00:41:40.000000', 'consum', 0.0218, 'lps'),
	(524832, 130, '2014-02-01 00:41:41.000000', 'consum', 0.0216, 'lps'),
	(524833, 130, '2014-02-01 00:41:42.000000', 'consum', 0.0214, 'lps'),
	(524834, 130, '2014-02-01 00:41:43.000000', 'consum', 0.0214, 'lps'),
	(524835, 130, '2014-02-01 00:41:44.000000', 'consum', 0.0217, 'lps'),
	(524836, 130, '2014-02-01 00:41:45.000000', 'consum', 0.0218, 'lps'),
	(524837, 130, '2014-02-01 00:41:46.000000', 'consum', 0.0211, 'lps'),
	(524838, 130, '2014-02-01 00:41:47.000000', 'consum', 0.0210, 'lps'),
	(524839, 130, '2014-02-01 00:41:48.000000', 'consum', 0.0226, 'lps'),
	(524840, 130, '2014-02-01 00:41:49.000000', 'consum', 0.0217, 'lps'),
	(524841, 130, '2014-02-01 00:41:50.000000', 'consum', 0.0215, 'lps'),
	(524842, 130, '2014-02-01 00:41:51.000000', 'consum', 0.0214, 'lps'),
	(524843, 130, '2014-02-01 00:41:52.000000', 'consum', 0.0216, 'lps'),
	(524844, 130, '2014-02-01 00:41:53.000000', 'consum', 0.0212, 'lps'),
	(524845, 130, '2014-02-01 00:41:54.000000', 'consum', 0.0220, 'lps'),
	(524846, 130, '2014-02-01 00:41:55.000000', 'consum', 0.0220, 'lps'),
	(524847, 130, '2014-02-01 00:41:56.000000', 'consum', 0.0212, 'lps'),
	(524848, 130, '2014-02-01 00:41:57.000000', 'consum', 0.0224, 'lps'),
	(524849, 130, '2014-02-01 00:41:58.000000', 'consum', 0.0224, 'lps'),
	(524850, 130, '2014-02-01 00:41:59.000000', 'consum', 0.0218, 'lps'),
	(524851, 130, '2014-02-01 00:42:00.000000', 'consum', 0.0211, 'lps'),
	(524852, 130, '2014-02-01 00:42:01.000000', 'consum', 0.0227, 'lps'),
	(524853, 130, '2014-02-01 00:42:02.000000', 'consum', 0.0218, 'lps'),
	(524854, 130, '2014-02-01 00:42:03.000000', 'consum', 0.0219, 'lps'),
	(524855, 130, '2014-02-01 00:42:04.000000', 'consum', 0.0213, 'lps'),
	(524856, 130, '2014-02-01 00:42:05.000000', 'consum', 0.0218, 'lps'),
	(524857, 130, '2014-02-01 00:42:06.000000', 'consum', 0.0223, 'lps'),
	(524858, 130, '2014-02-01 00:42:07.000000', 'consum', 0.0215, 'lps'),
	(524859, 130, '2014-02-01 00:42:08.000000', 'consum', 0.0214, 'lps'),
	(524860, 130, '2014-02-01 00:42:09.000000', 'consum', 0.0216, 'lps'),
	(524861, 130, '2014-02-01 00:42:10.000000', 'consum', 0.0226, 'lps'),
	(524862, 130, '2014-02-01 00:42:11.000000', 'consum', 0.0222, 'lps'),
	(524863, 130, '2014-02-01 00:42:12.000000', 'consum', 0.0221, 'lps'),
	(524864, 130, '2014-02-01 00:42:13.000000', 'consum', 0.0213, 'lps'),
	(524865, 130, '2014-02-01 00:42:14.000000', 'consum', 0.0227, 'lps'),
	(524866, 130, '2014-02-01 00:42:15.000000', 'consum', 0.0216, 'lps'),
	(524867, 130, '2014-02-01 00:42:16.000000', 'consum', 0.0223, 'lps'),
	(524868, 130, '2014-02-01 00:42:17.000000', 'consum', 0.0223, 'lps'),
	(524869, 130, '2014-02-01 00:42:18.000000', 'consum', 0.0218, 'lps'),
	(524870, 130, '2014-02-01 00:42:19.000000', 'consum', 0.0211, 'lps'),
	(524871, 130, '2014-02-01 00:42:20.000000', 'consum', 0.0212, 'lps'),
	(524872, 130, '2014-02-01 00:42:21.000000', 'consum', 0.0215, 'lps'),
	(524873, 130, '2014-02-01 00:42:22.000000', 'consum', 0.0213, 'lps'),
	(524874, 130, '2014-02-01 00:42:23.000000', 'consum', 0.0227, 'lps'),
	(524875, 130, '2014-02-01 00:42:24.000000', 'consum', 0.0216, 'lps'),
	(524876, 130, '2014-02-01 00:42:25.000000', 'consum', 0.0223, 'lps'),
	(524877, 130, '2014-02-01 00:42:26.000000', 'consum', 0.0223, 'lps'),
	(524878, 130, '2014-02-01 00:42:27.000000', 'consum', 0.0219, 'lps'),
	(524879, 130, '2014-02-01 00:42:28.000000', 'consum', 0.0218, 'lps'),
	(524880, 130, '2014-02-01 00:42:29.000000', 'consum', 0.0223, 'lps'),
	(524881, 130, '2014-02-01 00:42:30.000000', 'consum', 0.0214, 'lps'),
	(524882, 130, '2014-02-01 00:42:31.000000', 'consum', 0.0227, 'lps'),
	(524883, 130, '2014-02-01 00:42:32.000000', 'consum', 0.0213, 'lps'),
	(524884, 130, '2014-02-01 00:42:33.000000', 'consum', 0.0210, 'lps'),
	(524885, 130, '2014-02-01 00:42:34.000000', 'consum', 0.0219, 'lps'),
	(524886, 130, '2014-02-01 00:42:35.000000', 'consum', 0.0219, 'lps'),
	(524887, 130, '2014-02-01 00:42:36.000000', 'consum', 0.0212, 'lps'),
	(524888, 130, '2014-02-01 00:42:37.000000', 'consum', 0.0211, 'lps'),
	(524889, 130, '2014-02-01 00:42:38.000000', 'consum', 0.0210, 'lps'),
	(524890, 130, '2014-02-01 00:42:39.000000', 'consum', 0.0224, 'lps'),
	(524891, 130, '2014-02-01 00:42:40.000000', 'consum', 0.0227, 'lps'),
	(524892, 130, '2014-02-01 00:42:41.000000', 'consum', 0.0219, 'lps'),
	(524893, 130, '2014-02-01 00:42:42.000000', 'consum', 0.0222, 'lps'),
	(524894, 130, '2014-02-01 00:42:43.000000', 'consum', 0.0223, 'lps'),
	(524895, 130, '2014-02-01 00:42:44.000000', 'consum', 0.0224, 'lps'),
	(524896, 130, '2014-02-01 00:42:45.000000', 'consum', 0.0223, 'lps'),
	(524897, 130, '2014-02-01 00:42:46.000000', 'consum', 0.0215, 'lps'),
	(524898, 130, '2014-02-01 00:42:47.000000', 'consum', 0.0215, 'lps'),
	(524899, 130, '2014-02-01 00:42:48.000000', 'consum', 0.0220, 'lps'),
	(524900, 130, '2014-02-01 00:42:49.000000', 'consum', 0.0211, 'lps'),
	(524901, 130, '2014-02-01 00:42:50.000000', 'consum', 0.0219, 'lps'),
	(524902, 130, '2014-02-01 00:42:51.000000', 'consum', 0.0220, 'lps'),
	(524903, 130, '2014-02-01 00:42:52.000000', 'consum', 0.0212, 'lps'),
	(524904, 130, '2014-02-01 00:42:53.000000', 'consum', 0.0227, 'lps'),
	(524905, 130, '2014-02-01 00:42:54.000000', 'consum', 0.0217, 'lps'),
	(524906, 130, '2014-02-01 00:42:55.000000', 'consum', 0.0213, 'lps'),
	(524907, 130, '2014-02-01 00:42:56.000000', 'consum', 0.0222, 'lps'),
	(524908, 130, '2014-02-01 00:42:57.000000', 'consum', 0.0227, 'lps'),
	(524909, 130, '2014-02-01 00:42:58.000000', 'consum', 0.0223, 'lps'),
	(524910, 130, '2014-02-01 00:42:59.000000', 'consum', 0.0225, 'lps'),
	(524911, 130, '2014-02-01 00:43:00.000000', 'consum', 0.0211, 'lps'),
	(524912, 130, '2014-02-01 00:43:01.000000', 'consum', 0.0223, 'lps'),
	(524913, 130, '2014-02-01 00:43:02.000000', 'consum', 0.0218, 'lps'),
	(524914, 130, '2014-02-01 00:43:03.000000', 'consum', 0.0214, 'lps'),
	(524915, 130, '2014-02-01 00:43:04.000000', 'consum', 0.0222, 'lps'),
	(524916, 130, '2014-02-01 00:43:05.000000', 'consum', 0.0221, 'lps'),
	(524917, 130, '2014-02-01 00:43:06.000000', 'consum', 0.0214, 'lps'),
	(524918, 130, '2014-02-01 00:43:07.000000', 'consum', 0.0217, 'lps'),
	(524919, 130, '2014-02-01 00:43:08.000000', 'consum', 0.0212, 'lps'),
	(524920, 130, '2014-02-01 00:43:09.000000', 'consum', 0.0218, 'lps'),
	(524921, 130, '2014-02-01 00:43:10.000000', 'consum', 0.0211, 'lps'),
	(524922, 130, '2014-02-01 00:43:11.000000', 'consum', 0.0227, 'lps'),
	(524923, 130, '2014-02-01 00:43:12.000000', 'consum', 0.0222, 'lps'),
	(524924, 130, '2014-02-01 00:43:13.000000', 'consum', 0.0218, 'lps'),
	(524925, 130, '2014-02-01 00:43:14.000000', 'consum', 0.0215, 'lps'),
	(524926, 130, '2014-02-01 00:43:15.000000', 'consum', 0.0227, 'lps'),
	(524927, 130, '2014-02-01 00:43:16.000000', 'consum', 0.0212, 'lps'),
	(524928, 130, '2014-02-01 00:43:17.000000', 'consum', 0.0220, 'lps'),
	(524929, 130, '2014-02-01 00:43:18.000000', 'consum', 0.0222, 'lps'),
	(524930, 130, '2014-02-01 00:43:19.000000', 'consum', 0.0221, 'lps'),
	(524931, 130, '2014-02-01 00:43:20.000000', 'consum', 0.0227, 'lps'),
	(524932, 130, '2014-02-01 00:43:21.000000', 'consum', 0.0212, 'lps'),
	(524933, 130, '2014-02-01 00:43:22.000000', 'consum', 0.0224, 'lps'),
	(524934, 130, '2014-02-01 00:43:23.000000', 'consum', 0.0218, 'lps'),
	(524935, 130, '2014-02-01 00:43:24.000000', 'consum', 0.0226, 'lps'),
	(524936, 130, '2014-02-01 00:43:25.000000', 'consum', 0.0213, 'lps'),
	(524937, 130, '2014-02-01 00:43:26.000000', 'consum', 0.0213, 'lps'),
	(524938, 130, '2014-02-01 00:43:27.000000', 'consum', 0.0217, 'lps'),
	(524939, 130, '2014-02-01 00:43:28.000000', 'consum', 0.0219, 'lps'),
	(524940, 130, '2014-02-01 00:43:29.000000', 'consum', 0.0218, 'lps'),
	(524941, 130, '2014-02-01 00:43:30.000000', 'consum', 0.0222, 'lps'),
	(524942, 130, '2014-02-01 00:43:31.000000', 'consum', 0.0210, 'lps'),
	(524943, 130, '2014-02-01 00:43:32.000000', 'consum', 0.0212, 'lps'),
	(524944, 130, '2014-02-01 00:43:33.000000', 'consum', 0.0221, 'lps'),
	(524945, 130, '2014-02-01 00:43:34.000000', 'consum', 0.0223, 'lps'),
	(524946, 130, '2014-02-01 00:43:35.000000', 'consum', 0.0225, 'lps'),
	(524947, 130, '2014-02-01 00:43:36.000000', 'consum', 0.0210, 'lps'),
	(524948, 130, '2014-02-01 00:43:37.000000', 'consum', 0.0217, 'lps'),
	(524949, 130, '2014-02-01 00:43:38.000000', 'consum', 0.0213, 'lps'),
	(524950, 130, '2014-02-01 00:43:39.000000', 'consum', 0.0221, 'lps'),
	(524951, 130, '2014-02-01 00:43:40.000000', 'consum', 0.0219, 'lps'),
	(524952, 130, '2014-02-01 00:43:41.000000', 'consum', 0.0223, 'lps'),
	(524953, 130, '2014-02-01 00:43:42.000000', 'consum', 0.0215, 'lps'),
	(524954, 130, '2014-02-01 00:43:43.000000', 'consum', 0.0213, 'lps'),
	(524955, 130, '2014-02-01 00:43:44.000000', 'consum', 0.0213, 'lps'),
	(524956, 130, '2014-02-01 00:43:45.000000', 'consum', 0.0213, 'lps'),
	(524957, 130, '2014-02-01 00:43:46.000000', 'consum', 0.0217, 'lps'),
	(524958, 130, '2014-02-01 00:43:47.000000', 'consum', 0.0221, 'lps'),
	(524959, 130, '2014-02-01 00:43:48.000000', 'consum', 0.0224, 'lps'),
	(524960, 130, '2014-02-01 00:43:49.000000', 'consum', 0.0214, 'lps'),
	(524961, 130, '2014-02-01 00:43:50.000000', 'consum', 0.0222, 'lps'),
	(524962, 130, '2014-02-01 00:43:51.000000', 'consum', 0.0223, 'lps'),
	(524963, 130, '2014-02-01 00:43:52.000000', 'consum', 0.0221, 'lps'),
	(524964, 130, '2014-02-01 00:43:53.000000', 'consum', 0.0226, 'lps'),
	(524965, 130, '2014-02-01 00:43:54.000000', 'consum', 0.0223, 'lps'),
	(524966, 130, '2014-02-01 00:43:55.000000', 'consum', 0.0225, 'lps'),
	(524967, 130, '2014-02-01 00:43:56.000000', 'consum', 0.0214, 'lps'),
	(524968, 130, '2014-02-01 00:43:57.000000', 'consum', 0.0218, 'lps'),
	(524969, 130, '2014-02-01 00:43:58.000000', 'consum', 0.0223, 'lps'),
	(524970, 130, '2014-02-01 00:43:59.000000', 'consum', 0.0215, 'lps'),
	(524971, 130, '2014-02-01 00:44:00.000000', 'consum', 0.0214, 'lps'),
	(524972, 130, '2014-02-01 00:44:01.000000', 'consum', 0.0216, 'lps'),
	(524973, 130, '2014-02-01 00:44:02.000000', 'consum', 0.0227, 'lps'),
	(524974, 130, '2014-02-01 00:44:03.000000', 'consum', 0.0226, 'lps'),
	(524975, 130, '2014-02-01 00:44:04.000000', 'consum', 0.0220, 'lps'),
	(524976, 130, '2014-02-01 00:44:05.000000', 'consum', 0.0211, 'lps'),
	(524977, 130, '2014-02-01 00:44:06.000000', 'consum', 0.0224, 'lps'),
	(524978, 130, '2014-02-01 00:44:07.000000', 'consum', 0.0221, 'lps'),
	(524979, 130, '2014-02-01 00:44:08.000000', 'consum', 0.0226, 'lps'),
	(524980, 130, '2014-02-01 00:44:09.000000', 'consum', 0.0219, 'lps'),
	(524981, 130, '2014-02-01 00:44:10.000000', 'consum', 0.0227, 'lps'),
	(524982, 130, '2014-02-01 00:44:11.000000', 'consum', 0.0215, 'lps'),
	(524983, 130, '2014-02-01 00:44:12.000000', 'consum', 0.0220, 'lps'),
	(524984, 130, '2014-02-01 00:44:13.000000', 'consum', 0.0210, 'lps'),
	(524985, 130, '2014-02-01 00:44:14.000000', 'consum', 0.0217, 'lps'),
	(524986, 130, '2014-02-01 00:44:15.000000', 'consum', 0.0225, 'lps'),
	(524987, 130, '2014-02-01 00:44:16.000000', 'consum', 0.0212, 'lps'),
	(524988, 130, '2014-02-01 00:44:17.000000', 'consum', 0.0212, 'lps'),
	(524989, 130, '2014-02-01 00:44:18.000000', 'consum', 0.0215, 'lps'),
	(524990, 130, '2014-02-01 00:44:19.000000', 'consum', 0.0211, 'lps'),
	(524991, 130, '2014-02-01 00:44:20.000000', 'consum', 0.0218, 'lps'),
	(524992, 130, '2014-02-01 00:44:21.000000', 'consum', 0.0213, 'lps'),
	(524993, 130, '2014-02-01 00:44:22.000000', 'consum', 0.0219, 'lps'),
	(524994, 130, '2014-02-01 00:44:23.000000', 'consum', 0.0212, 'lps'),
	(524995, 130, '2014-02-01 00:44:24.000000', 'consum', 0.0227, 'lps'),
	(524996, 130, '2014-02-01 00:44:25.000000', 'consum', 0.0218, 'lps'),
	(524997, 130, '2014-02-01 00:44:26.000000', 'consum', 0.0220, 'lps'),
	(524998, 130, '2014-02-01 00:44:27.000000', 'consum', 0.0216, 'lps'),
	(524999, 130, '2014-02-01 00:44:28.000000', 'consum', 0.0212, 'lps'),
	(525000, 130, '2014-02-01 00:44:29.000000', 'consum', 0.0219, 'lps'),
	(525001, 130, '2014-02-01 00:44:30.000000', 'consum', 0.0212, 'lps'),
	(525002, 130, '2014-02-01 00:44:31.000000', 'consum', 0.0213, 'lps'),
	(525003, 130, '2014-02-01 00:44:32.000000', 'consum', 0.0221, 'lps'),
	(525004, 130, '2014-02-01 00:44:33.000000', 'consum', 0.0218, 'lps'),
	(525005, 130, '2014-02-01 00:44:34.000000', 'consum', 0.0219, 'lps'),
	(525006, 130, '2014-02-01 00:44:35.000000', 'consum', 0.0214, 'lps'),
	(525007, 130, '2014-02-01 00:44:36.000000', 'consum', 0.0222, 'lps'),
	(525008, 130, '2014-02-01 00:44:37.000000', 'consum', 0.0221, 'lps'),
	(525009, 130, '2014-02-01 00:44:38.000000', 'consum', 0.0212, 'lps'),
	(525010, 130, '2014-02-01 00:44:39.000000', 'consum', 0.0223, 'lps'),
	(525011, 130, '2014-02-01 00:44:40.000000', 'consum', 0.0217, 'lps'),
	(525012, 130, '2014-02-01 00:44:41.000000', 'consum', 0.0223, 'lps'),
	(525013, 130, '2014-02-01 00:44:42.000000', 'consum', 0.0219, 'lps'),
	(525014, 130, '2014-02-01 00:44:43.000000', 'consum', 0.0218, 'lps'),
	(525015, 130, '2014-02-01 00:44:44.000000', 'consum', 0.0224, 'lps'),
	(525016, 130, '2014-02-01 00:44:45.000000', 'consum', 0.0221, 'lps'),
	(525017, 130, '2014-02-01 00:44:46.000000', 'consum', 0.0220, 'lps'),
	(525018, 130, '2014-02-01 00:44:47.000000', 'consum', 0.0213, 'lps'),
	(525019, 130, '2014-02-01 00:44:48.000000', 'consum', 0.0213, 'lps'),
	(525020, 130, '2014-02-01 00:44:49.000000', 'consum', 0.0218, 'lps'),
	(525021, 130, '2014-02-01 00:44:50.000000', 'consum', 0.0222, 'lps'),
	(525022, 130, '2014-02-01 00:44:51.000000', 'consum', 0.0210, 'lps'),
	(525023, 130, '2014-02-01 00:44:52.000000', 'consum', 0.0213, 'lps'),
	(525024, 130, '2014-02-01 00:44:53.000000', 'consum', 0.0222, 'lps'),
	(525025, 130, '2014-02-01 00:44:54.000000', 'consum', 0.0210, 'lps'),
	(525026, 130, '2014-02-01 00:44:55.000000', 'consum', 0.0210, 'lps'),
	(525027, 130, '2014-02-01 00:44:56.000000', 'consum', 0.0212, 'lps'),
	(525028, 130, '2014-02-01 00:44:57.000000', 'consum', 0.0220, 'lps'),
	(525029, 130, '2014-02-01 00:44:58.000000', 'consum', 0.0217, 'lps'),
	(525030, 130, '2014-02-01 00:44:59.000000', 'consum', 0.0215, 'lps'),
	(525031, 130, '2014-02-01 00:45:00.000000', 'consum', 0.0215, 'lps'),
	(525032, 130, '2014-02-01 00:45:01.000000', 'consum', 0.0220, 'lps'),
	(525033, 130, '2014-02-01 00:45:02.000000', 'consum', 0.0210, 'lps'),
	(525034, 130, '2014-02-01 00:45:03.000000', 'consum', 0.0215, 'lps'),
	(525035, 130, '2014-02-01 00:45:04.000000', 'consum', 0.0218, 'lps'),
	(525036, 130, '2014-02-01 00:45:05.000000', 'consum', 0.0219, 'lps'),
	(525037, 130, '2014-02-01 00:45:06.000000', 'consum', 0.0212, 'lps'),
	(525038, 130, '2014-02-01 00:45:07.000000', 'consum', 0.0213, 'lps'),
	(525039, 130, '2014-02-01 00:45:08.000000', 'consum', 0.0220, 'lps'),
	(525040, 130, '2014-02-01 00:45:09.000000', 'consum', 0.0216, 'lps'),
	(525041, 130, '2014-02-01 00:45:10.000000', 'consum', 0.0210, 'lps'),
	(525042, 130, '2014-02-01 00:45:11.000000', 'consum', 0.0212, 'lps'),
	(525043, 130, '2014-02-01 00:45:12.000000', 'consum', 0.0218, 'lps'),
	(525044, 130, '2014-02-01 00:45:13.000000', 'consum', 0.0211, 'lps'),
	(525045, 130, '2014-02-01 00:45:14.000000', 'consum', 0.0226, 'lps'),
	(525046, 130, '2014-02-01 00:45:15.000000', 'consum', 0.0214, 'lps'),
	(525047, 130, '2014-02-01 00:45:16.000000', 'consum', 0.0218, 'lps'),
	(525048, 130, '2014-02-01 00:45:17.000000', 'consum', 0.0223, 'lps'),
	(525049, 130, '2014-02-01 00:45:18.000000', 'consum', 0.0216, 'lps'),
	(525050, 130, '2014-02-01 00:45:19.000000', 'consum', 0.0218, 'lps'),
	(525051, 130, '2014-02-01 00:45:20.000000', 'consum', 0.0214, 'lps'),
	(525052, 130, '2014-02-01 00:45:21.000000', 'consum', 0.0224, 'lps'),
	(525053, 130, '2014-02-01 00:45:22.000000', 'consum', 0.0215, 'lps'),
	(525054, 130, '2014-02-01 00:45:23.000000', 'consum', 0.0211, 'lps'),
	(525055, 130, '2014-02-01 00:45:24.000000', 'consum', 0.0218, 'lps'),
	(525056, 130, '2014-02-01 00:45:25.000000', 'consum', 0.0212, 'lps'),
	(525057, 130, '2014-02-01 00:45:26.000000', 'consum', 0.0215, 'lps'),
	(525058, 130, '2014-02-01 00:45:27.000000', 'consum', 0.0211, 'lps'),
	(525059, 130, '2014-02-01 00:45:28.000000', 'consum', 0.0218, 'lps'),
	(525060, 130, '2014-02-01 00:45:29.000000', 'consum', 0.0211, 'lps'),
	(525061, 130, '2014-02-01 00:45:30.000000', 'consum', 0.0211, 'lps'),
	(525062, 130, '2014-02-01 00:45:31.000000', 'consum', 0.0211, 'lps'),
	(525063, 130, '2014-02-01 00:45:32.000000', 'consum', 0.0215, 'lps'),
	(525064, 130, '2014-02-01 00:45:33.000000', 'consum', 0.0212, 'lps'),
	(525065, 130, '2014-02-01 00:45:34.000000', 'consum', 0.0223, 'lps'),
	(525066, 130, '2014-02-01 00:45:35.000000', 'consum', 0.0216, 'lps'),
	(525067, 130, '2014-02-01 00:45:36.000000', 'consum', 0.0221, 'lps'),
	(525068, 130, '2014-02-01 00:45:37.000000', 'consum', 0.0227, 'lps'),
	(525069, 130, '2014-02-01 00:45:38.000000', 'consum', 0.0210, 'lps'),
	(525070, 130, '2014-02-01 00:45:39.000000', 'consum', 0.0213, 'lps'),
	(525071, 130, '2014-02-01 00:45:40.000000', 'consum', 0.0226, 'lps'),
	(525072, 130, '2014-02-01 00:45:41.000000', 'consum', 0.0211, 'lps'),
	(525073, 130, '2014-02-01 00:45:42.000000', 'consum', 0.0221, 'lps'),
	(525074, 130, '2014-02-01 00:45:43.000000', 'consum', 0.0225, 'lps'),
	(525075, 130, '2014-02-01 00:45:44.000000', 'consum', 0.0218, 'lps'),
	(525076, 130, '2014-02-01 00:45:45.000000', 'consum', 0.0223, 'lps'),
	(525077, 130, '2014-02-01 00:45:46.000000', 'consum', 0.0214, 'lps'),
	(525078, 130, '2014-02-01 00:45:47.000000', 'consum', 0.0210, 'lps'),
	(525079, 130, '2014-02-01 00:45:48.000000', 'consum', 0.0216, 'lps'),
	(525080, 130, '2014-02-01 00:45:49.000000', 'consum', 0.0223, 'lps'),
	(525081, 130, '2014-02-01 00:45:50.000000', 'consum', 0.0223, 'lps'),
	(525082, 130, '2014-02-01 00:45:51.000000', 'consum', 0.0216, 'lps'),
	(525083, 130, '2014-02-01 00:45:52.000000', 'consum', 0.0219, 'lps'),
	(525084, 130, '2014-02-01 00:45:53.000000', 'consum', 0.0220, 'lps'),
	(525085, 130, '2014-02-01 00:45:54.000000', 'consum', 0.0216, 'lps'),
	(525086, 130, '2014-02-01 00:45:55.000000', 'consum', 0.0226, 'lps'),
	(525087, 130, '2014-02-01 00:45:56.000000', 'consum', 0.0222, 'lps'),
	(525088, 130, '2014-02-01 00:45:57.000000', 'consum', 0.0220, 'lps'),
	(525089, 130, '2014-02-01 00:45:58.000000', 'consum', 0.0226, 'lps'),
	(525090, 130, '2014-02-01 00:45:59.000000', 'consum', 0.0226, 'lps'),
	(525091, 130, '2014-02-01 00:46:00.000000', 'consum', 0.0223, 'lps'),
	(525092, 130, '2014-02-01 00:46:01.000000', 'consum', 0.0210, 'lps'),
	(525093, 130, '2014-02-01 00:46:02.000000', 'consum', 0.0224, 'lps'),
	(525094, 130, '2014-02-01 00:46:03.000000', 'consum', 0.0227, 'lps'),
	(525095, 130, '2014-02-01 00:46:04.000000', 'consum', 0.0218, 'lps'),
	(525096, 130, '2014-02-01 00:46:05.000000', 'consum', 0.0217, 'lps'),
	(525097, 130, '2014-02-01 00:46:06.000000', 'consum', 0.0223, 'lps'),
	(525098, 130, '2014-02-01 00:46:07.000000', 'consum', 0.0219, 'lps'),
	(525099, 130, '2014-02-01 00:46:08.000000', 'consum', 0.0214, 'lps'),
	(525100, 130, '2014-02-01 00:46:09.000000', 'consum', 0.0223, 'lps'),
	(525101, 130, '2014-02-01 00:46:10.000000', 'consum', 0.0211, 'lps'),
	(525102, 130, '2014-02-01 00:46:11.000000', 'consum', 0.0210, 'lps'),
	(525103, 130, '2014-02-01 00:46:12.000000', 'consum', 0.0210, 'lps'),
	(525104, 130, '2014-02-01 00:46:13.000000', 'consum', 0.0225, 'lps'),
	(525105, 130, '2014-02-01 00:46:14.000000', 'consum', 0.0217, 'lps'),
	(525106, 130, '2014-02-01 00:46:15.000000', 'consum', 0.0216, 'lps'),
	(525107, 130, '2014-02-01 00:46:16.000000', 'consum', 0.0220, 'lps'),
	(525108, 130, '2014-02-01 00:46:17.000000', 'consum', 0.0225, 'lps'),
	(525109, 130, '2014-02-01 00:46:18.000000', 'consum', 0.0219, 'lps'),
	(525110, 130, '2014-02-01 00:46:19.000000', 'consum', 0.0211, 'lps'),
	(525111, 130, '2014-02-01 00:46:20.000000', 'consum', 0.0224, 'lps'),
	(525112, 130, '2014-02-01 00:46:21.000000', 'consum', 0.0222, 'lps'),
	(525113, 130, '2014-02-01 00:46:22.000000', 'consum', 0.0213, 'lps'),
	(525114, 130, '2014-02-01 00:46:23.000000', 'consum', 0.0225, 'lps'),
	(525115, 130, '2014-02-01 00:46:24.000000', 'consum', 0.0220, 'lps'),
	(525116, 130, '2014-02-01 00:46:25.000000', 'consum', 0.0217, 'lps'),
	(525117, 130, '2014-02-01 00:46:26.000000', 'consum', 0.0217, 'lps'),
	(525118, 130, '2014-02-01 00:46:27.000000', 'consum', 0.0224, 'lps'),
	(525119, 130, '2014-02-01 00:46:28.000000', 'consum', 0.0224, 'lps'),
	(525120, 130, '2014-02-01 00:46:29.000000', 'consum', 0.0220, 'lps'),
	(525121, 130, '2014-02-01 00:46:30.000000', 'consum', 0.0218, 'lps'),
	(525122, 130, '2014-02-01 00:46:31.000000', 'consum', 0.0219, 'lps'),
	(525123, 130, '2014-02-01 00:46:32.000000', 'consum', 0.0214, 'lps'),
	(525124, 130, '2014-02-01 00:46:33.000000', 'consum', 0.0222, 'lps'),
	(525125, 130, '2014-02-01 00:46:34.000000', 'consum', 0.0221, 'lps'),
	(525126, 130, '2014-02-01 00:46:35.000000', 'consum', 0.0212, 'lps'),
	(525127, 130, '2014-02-01 00:46:36.000000', 'consum', 0.0224, 'lps'),
	(525128, 130, '2014-02-01 00:46:37.000000', 'consum', 0.0222, 'lps'),
	(525129, 130, '2014-02-01 00:46:38.000000', 'consum', 0.0210, 'lps'),
	(525130, 130, '2014-02-01 00:46:39.000000', 'consum', 0.0210, 'lps'),
	(525131, 130, '2014-02-01 00:46:40.000000', 'consum', 0.0227, 'lps'),
	(525132, 130, '2014-02-01 00:46:41.000000', 'consum', 0.0224, 'lps'),
	(525133, 130, '2014-02-01 00:46:42.000000', 'consum', 0.0212, 'lps'),
	(525134, 130, '2014-02-01 00:46:43.000000', 'consum', 0.0214, 'lps'),
	(525135, 130, '2014-02-01 00:46:44.000000', 'consum', 0.0225, 'lps'),
	(525136, 130, '2014-02-01 00:46:45.000000', 'consum', 0.0220, 'lps'),
	(525137, 130, '2014-02-01 00:46:46.000000', 'consum', 0.0213, 'lps'),
	(525138, 130, '2014-02-01 00:46:47.000000', 'consum', 0.0215, 'lps'),
	(525139, 130, '2014-02-01 00:46:48.000000', 'consum', 0.0227, 'lps'),
	(525140, 130, '2014-02-01 00:46:49.000000', 'consum', 0.0210, 'lps'),
	(525141, 130, '2014-02-01 00:46:50.000000', 'consum', 0.0213, 'lps'),
	(525142, 130, '2014-02-01 00:46:51.000000', 'consum', 0.0224, 'lps'),
	(525143, 130, '2014-02-01 00:46:52.000000', 'consum', 0.0217, 'lps'),
	(525144, 130, '2014-02-01 00:46:53.000000', 'consum', 0.0224, 'lps'),
	(525145, 130, '2014-02-01 00:46:54.000000', 'consum', 0.0224, 'lps'),
	(525146, 130, '2014-02-01 00:46:55.000000', 'consum', 0.0218, 'lps'),
	(525147, 130, '2014-02-01 00:46:56.000000', 'consum', 0.0226, 'lps'),
	(525148, 130, '2014-02-01 00:46:57.000000', 'consum', 0.0212, 'lps'),
	(525149, 130, '2014-02-01 00:46:58.000000', 'consum', 0.0210, 'lps'),
	(525150, 130, '2014-02-01 00:46:59.000000', 'consum', 0.0222, 'lps'),
	(525151, 130, '2014-02-01 00:47:00.000000', 'consum', 0.0218, 'lps'),
	(525152, 130, '2014-02-01 00:47:01.000000', 'consum', 0.0213, 'lps'),
	(525153, 130, '2014-02-01 00:47:02.000000', 'consum', 0.0218, 'lps'),
	(525154, 130, '2014-02-01 00:47:03.000000', 'consum', 0.0226, 'lps'),
	(525155, 130, '2014-02-01 00:47:04.000000', 'consum', 0.0210, 'lps'),
	(525156, 130, '2014-02-01 00:47:05.000000', 'consum', 0.0220, 'lps'),
	(525157, 130, '2014-02-01 00:47:06.000000', 'consum', 0.0222, 'lps'),
	(525158, 130, '2014-02-01 00:47:07.000000', 'consum', 0.0223, 'lps'),
	(525159, 130, '2014-02-01 00:47:08.000000', 'consum', 0.0221, 'lps'),
	(525160, 130, '2014-02-01 00:47:09.000000', 'consum', 0.0210, 'lps'),
	(525161, 130, '2014-02-01 00:47:10.000000', 'consum', 0.0212, 'lps'),
	(525162, 130, '2014-02-01 00:47:11.000000', 'consum', 0.0221, 'lps'),
	(525163, 130, '2014-02-01 00:47:12.000000', 'consum', 0.0224, 'lps'),
	(525164, 130, '2014-02-01 00:47:13.000000', 'consum', 0.0227, 'lps'),
	(525165, 130, '2014-02-01 00:47:14.000000', 'consum', 0.0221, 'lps'),
	(525166, 130, '2014-02-01 00:47:15.000000', 'consum', 0.0213, 'lps'),
	(525167, 130, '2014-02-01 00:47:16.000000', 'consum', 0.0211, 'lps'),
	(525168, 130, '2014-02-01 00:47:17.000000', 'consum', 0.0225, 'lps'),
	(525169, 130, '2014-02-01 00:47:18.000000', 'consum', 0.0211, 'lps'),
	(525170, 130, '2014-02-01 00:47:19.000000', 'consum', 0.0223, 'lps'),
	(525171, 130, '2014-02-01 00:47:20.000000', 'consum', 0.0218, 'lps'),
	(525172, 130, '2014-02-01 00:47:21.000000', 'consum', 0.0212, 'lps'),
	(525173, 130, '2014-02-01 00:47:22.000000', 'consum', 0.0215, 'lps'),
	(525174, 130, '2014-02-01 00:47:23.000000', 'consum', 0.0210, 'lps'),
	(525175, 130, '2014-02-01 00:47:24.000000', 'consum', 0.0212, 'lps'),
	(525176, 130, '2014-02-01 00:47:25.000000', 'consum', 0.0224, 'lps'),
	(525177, 130, '2014-02-01 00:47:26.000000', 'consum', 0.0220, 'lps'),
	(525178, 130, '2014-02-01 00:47:27.000000', 'consum', 0.0218, 'lps'),
	(525179, 130, '2014-02-01 00:47:28.000000', 'consum', 0.0220, 'lps'),
	(525180, 130, '2014-02-01 00:47:29.000000', 'consum', 0.0219, 'lps'),
	(525181, 130, '2014-02-01 00:47:30.000000', 'consum', 0.0224, 'lps'),
	(525182, 130, '2014-02-01 00:47:31.000000', 'consum', 0.0220, 'lps'),
	(525183, 130, '2014-02-01 00:47:32.000000', 'consum', 0.0219, 'lps'),
	(525184, 130, '2014-02-01 00:47:33.000000', 'consum', 0.0223, 'lps'),
	(525185, 130, '2014-02-01 00:47:34.000000', 'consum', 0.0215, 'lps'),
	(525186, 130, '2014-02-01 00:47:35.000000', 'consum', 0.0215, 'lps'),
	(525187, 130, '2014-02-01 00:47:36.000000', 'consum', 0.0221, 'lps'),
	(525188, 130, '2014-02-01 00:47:37.000000', 'consum', 0.0211, 'lps'),
	(525189, 130, '2014-02-01 00:47:38.000000', 'consum', 0.0222, 'lps'),
	(525190, 130, '2014-02-01 00:47:39.000000', 'consum', 0.0212, 'lps'),
	(525191, 130, '2014-02-01 00:47:40.000000', 'consum', 0.0222, 'lps'),
	(525192, 130, '2014-02-01 00:47:41.000000', 'consum', 0.0212, 'lps'),
	(525193, 130, '2014-02-01 00:47:42.000000', 'consum', 0.0217, 'lps'),
	(525194, 130, '2014-02-01 00:47:43.000000', 'consum', 0.0223, 'lps'),
	(525195, 130, '2014-02-01 00:47:44.000000', 'consum', 0.0220, 'lps'),
	(525196, 130, '2014-02-01 00:47:45.000000', 'consum', 0.0219, 'lps'),
	(525197, 130, '2014-02-01 00:47:46.000000', 'consum', 0.0226, 'lps'),
	(525198, 130, '2014-02-01 00:47:47.000000', 'consum', 0.0227, 'lps'),
	(525199, 130, '2014-02-01 00:47:48.000000', 'consum', 0.0212, 'lps'),
	(525200, 130, '2014-02-01 00:47:49.000000', 'consum', 0.0223, 'lps'),
	(525201, 130, '2014-02-01 00:47:50.000000', 'consum', 0.0215, 'lps'),
	(525202, 130, '2014-02-01 00:47:51.000000', 'consum', 0.0216, 'lps'),
	(525203, 130, '2014-02-01 00:47:52.000000', 'consum', 0.0224, 'lps'),
	(525204, 130, '2014-02-01 00:47:53.000000', 'consum', 0.0226, 'lps'),
	(525205, 130, '2014-02-01 00:47:54.000000', 'consum', 0.0213, 'lps'),
	(525206, 130, '2014-02-01 00:47:55.000000', 'consum', 0.0214, 'lps'),
	(525207, 130, '2014-02-01 00:47:56.000000', 'consum', 0.0222, 'lps'),
	(525208, 130, '2014-02-01 00:47:57.000000', 'consum', 0.0221, 'lps'),
	(525209, 130, '2014-02-01 00:47:58.000000', 'consum', 0.0211, 'lps'),
	(525210, 130, '2014-02-01 00:47:59.000000', 'consum', 0.0217, 'lps'),
	(525211, 130, '2014-02-01 00:48:00.000000', 'consum', 0.0227, 'lps'),
	(525212, 130, '2014-02-01 00:48:01.000000', 'consum', 0.0222, 'lps'),
	(525213, 130, '2014-02-01 00:48:02.000000', 'consum', 0.0217, 'lps'),
	(525214, 130, '2014-02-01 00:48:03.000000', 'consum', 0.0211, 'lps'),
	(525215, 130, '2014-02-01 00:48:04.000000', 'consum', 0.0211, 'lps'),
	(525216, 130, '2014-02-01 00:48:05.000000', 'consum', 0.0214, 'lps'),
	(525217, 130, '2014-02-01 00:48:06.000000', 'consum', 0.0227, 'lps'),
	(525218, 130, '2014-02-01 00:48:07.000000', 'consum', 0.0212, 'lps'),
	(525219, 130, '2014-02-01 00:48:08.000000', 'consum', 0.0225, 'lps'),
	(525220, 130, '2014-02-01 00:48:09.000000', 'consum', 0.0225, 'lps'),
	(525221, 130, '2014-02-01 00:48:10.000000', 'consum', 0.0220, 'lps'),
	(525222, 130, '2014-02-01 00:48:11.000000', 'consum', 0.0216, 'lps'),
	(525223, 130, '2014-02-01 00:48:12.000000', 'consum', 0.0212, 'lps'),
	(525224, 130, '2014-02-01 00:48:13.000000', 'consum', 0.0221, 'lps'),
	(525225, 130, '2014-02-01 00:48:14.000000', 'consum', 0.0225, 'lps'),
	(525226, 130, '2014-02-01 00:48:15.000000', 'consum', 0.0214, 'lps'),
	(525227, 130, '2014-02-01 00:48:16.000000', 'consum', 0.0221, 'lps'),
	(525228, 130, '2014-02-01 00:48:17.000000', 'consum', 0.0219, 'lps'),
	(525229, 130, '2014-02-01 00:48:18.000000', 'consum', 0.0220, 'lps'),
	(525230, 130, '2014-02-01 00:48:19.000000', 'consum', 0.0217, 'lps'),
	(525231, 130, '2014-02-01 00:48:20.000000', 'consum', 0.0215, 'lps'),
	(525232, 130, '2014-02-01 00:48:21.000000', 'consum', 0.0215, 'lps'),
	(525233, 130, '2014-02-01 00:48:22.000000', 'consum', 0.0218, 'lps'),
	(525234, 130, '2014-02-01 00:48:23.000000', 'consum', 0.0221, 'lps'),
	(525235, 130, '2014-02-01 00:48:24.000000', 'consum', 0.0223, 'lps'),
	(525236, 130, '2014-02-01 00:48:25.000000', 'consum', 0.0224, 'lps'),
	(525237, 130, '2014-02-01 00:48:26.000000', 'consum', 0.0223, 'lps'),
	(525238, 130, '2014-02-01 00:48:27.000000', 'consum', 0.0216, 'lps'),
	(525239, 130, '2014-02-01 00:48:28.000000', 'consum', 0.0220, 'lps'),
	(525240, 130, '2014-02-01 00:48:29.000000', 'consum', 0.0224, 'lps'),
	(525241, 130, '2014-02-01 00:48:30.000000', 'consum', 0.0213, 'lps'),
	(525242, 130, '2014-02-01 00:48:31.000000', 'consum', 0.0222, 'lps'),
	(525243, 130, '2014-02-01 00:48:32.000000', 'consum', 0.0224, 'lps'),
	(525244, 130, '2014-02-01 00:48:33.000000', 'consum', 0.0211, 'lps'),
	(525245, 130, '2014-02-01 00:48:34.000000', 'consum', 0.0224, 'lps'),
	(525246, 130, '2014-02-01 00:48:35.000000', 'consum', 0.0225, 'lps'),
	(525247, 130, '2014-02-01 00:48:36.000000', 'consum', 0.0227, 'lps'),
	(525248, 130, '2014-02-01 00:48:37.000000', 'consum', 0.0213, 'lps'),
	(525249, 130, '2014-02-01 00:48:38.000000', 'consum', 0.0210, 'lps'),
	(525250, 130, '2014-02-01 00:48:39.000000', 'consum', 0.0222, 'lps'),
	(525251, 130, '2014-02-01 00:48:40.000000', 'consum', 0.0215, 'lps'),
	(525252, 130, '2014-02-01 00:48:41.000000', 'consum', 0.0216, 'lps'),
	(525253, 130, '2014-02-01 00:48:42.000000', 'consum', 0.0227, 'lps'),
	(525254, 130, '2014-02-01 00:48:43.000000', 'consum', 0.0224, 'lps'),
	(525255, 130, '2014-02-01 00:48:44.000000', 'consum', 0.0211, 'lps'),
	(525256, 130, '2014-02-01 00:48:45.000000', 'consum', 0.0211, 'lps'),
	(525257, 130, '2014-02-01 00:48:46.000000', 'consum', 0.0213, 'lps'),
	(525258, 130, '2014-02-01 00:48:47.000000', 'consum', 0.0221, 'lps'),
	(525259, 130, '2014-02-01 00:48:48.000000', 'consum', 0.0220, 'lps'),
	(525260, 130, '2014-02-01 00:48:49.000000', 'consum', 0.0226, 'lps'),
	(525261, 130, '2014-02-01 00:48:50.000000', 'consum', 0.0210, 'lps'),
	(525262, 130, '2014-02-01 00:48:51.000000', 'consum', 0.0213, 'lps'),
	(525263, 130, '2014-02-01 00:48:52.000000', 'consum', 0.0227, 'lps'),
	(525264, 130, '2014-02-01 00:48:53.000000', 'consum', 0.0214, 'lps'),
	(525265, 130, '2014-02-01 00:48:54.000000', 'consum', 0.0215, 'lps'),
	(525266, 130, '2014-02-01 00:48:55.000000', 'consum', 0.0225, 'lps'),
	(525267, 130, '2014-02-01 00:48:56.000000', 'consum', 0.0215, 'lps'),
	(525268, 130, '2014-02-01 00:48:57.000000', 'consum', 0.0210, 'lps'),
	(525269, 130, '2014-02-01 00:48:58.000000', 'consum', 0.0211, 'lps'),
	(525270, 130, '2014-02-01 00:48:59.000000', 'consum', 0.0218, 'lps'),
	(525271, 130, '2014-02-01 00:49:00.000000', 'consum', 0.0210, 'lps'),
	(525272, 130, '2014-02-01 00:49:01.000000', 'consum', 0.0225, 'lps'),
	(525273, 130, '2014-02-01 00:49:02.000000', 'consum', 0.0212, 'lps'),
	(525274, 130, '2014-02-01 00:49:03.000000', 'consum', 0.0212, 'lps'),
	(525275, 130, '2014-02-01 00:49:04.000000', 'consum', 0.0215, 'lps'),
	(525276, 130, '2014-02-01 00:49:05.000000', 'consum', 0.0212, 'lps'),
	(525277, 130, '2014-02-01 00:49:06.000000', 'consum', 0.0223, 'lps'),
	(525278, 130, '2014-02-01 00:49:07.000000', 'consum', 0.0215, 'lps'),
	(525279, 130, '2014-02-01 00:49:08.000000', 'consum', 0.0213, 'lps'),
	(525280, 130, '2014-02-01 00:49:09.000000', 'consum', 0.0212, 'lps'),
	(525281, 130, '2014-02-01 00:49:10.000000', 'consum', 0.0212, 'lps'),
	(525282, 130, '2014-02-01 00:49:11.000000', 'consum', 0.0212, 'lps'),
	(525283, 130, '2014-02-01 00:49:12.000000', 'consum', 0.0216, 'lps'),
	(525284, 130, '2014-02-01 00:49:13.000000', 'consum', 0.0215, 'lps'),
	(525285, 130, '2014-02-01 00:49:14.000000', 'consum', 0.0218, 'lps'),
	(525286, 130, '2014-02-01 00:49:15.000000', 'consum', 0.0216, 'lps'),
	(525287, 130, '2014-02-01 00:49:16.000000', 'consum', 0.0218, 'lps'),
	(525288, 130, '2014-02-01 00:49:17.000000', 'consum', 0.0213, 'lps'),
	(525289, 130, '2014-02-01 00:49:18.000000', 'consum', 0.0221, 'lps'),
	(525290, 130, '2014-02-01 00:49:19.000000', 'consum', 0.0222, 'lps'),
	(525291, 130, '2014-02-01 00:49:20.000000', 'consum', 0.0218, 'lps'),
	(525292, 130, '2014-02-01 00:49:21.000000', 'consum', 0.0213, 'lps'),
	(525293, 130, '2014-02-01 00:49:22.000000', 'consum', 0.0221, 'lps'),
	(525294, 130, '2014-02-01 00:49:23.000000', 'consum', 0.0219, 'lps'),
	(525295, 130, '2014-02-01 00:49:24.000000', 'consum', 0.0224, 'lps'),
	(525296, 130, '2014-02-01 00:49:25.000000', 'consum', 0.0216, 'lps'),
	(525297, 130, '2014-02-01 00:49:26.000000', 'consum', 0.0217, 'lps'),
	(525298, 130, '2014-02-01 00:49:27.000000', 'consum', 0.0211, 'lps'),
	(525299, 130, '2014-02-01 00:49:28.000000', 'consum', 0.0213, 'lps'),
	(525300, 130, '2014-02-01 00:49:29.000000', 'consum', 0.0222, 'lps'),
	(525301, 130, '2014-02-01 00:49:30.000000', 'consum', 0.0224, 'lps'),
	(525302, 130, '2014-02-01 00:49:31.000000', 'consum', 0.0227, 'lps'),
	(525303, 130, '2014-02-01 00:49:32.000000', 'consum', 0.0217, 'lps'),
	(525304, 130, '2014-02-01 00:49:33.000000', 'consum', 0.0213, 'lps'),
	(525305, 130, '2014-02-01 00:49:34.000000', 'consum', 0.0221, 'lps'),
	(525306, 130, '2014-02-01 00:49:35.000000', 'consum', 0.0220, 'lps'),
	(525307, 130, '2014-02-01 00:49:36.000000', 'consum', 0.0211, 'lps'),
	(525308, 130, '2014-02-01 00:49:37.000000', 'consum', 0.0222, 'lps'),
	(525309, 130, '2014-02-01 00:49:38.000000', 'consum', 0.0211, 'lps'),
	(525310, 130, '2014-02-01 00:49:39.000000', 'consum', 0.0218, 'lps'),
	(525311, 130, '2014-02-01 00:49:40.000000', 'consum', 0.0227, 'lps'),
	(525312, 130, '2014-02-01 00:49:41.000000', 'consum', 0.0217, 'lps'),
	(525313, 130, '2014-02-01 00:49:42.000000', 'consum', 0.0215, 'lps'),
	(525314, 130, '2014-02-01 00:49:43.000000', 'consum', 0.0214, 'lps'),
	(525315, 130, '2014-02-01 00:49:44.000000', 'consum', 0.0216, 'lps'),
	(525316, 130, '2014-02-01 00:49:45.000000', 'consum', 0.0212, 'lps'),
	(525317, 130, '2014-02-01 00:49:46.000000', 'consum', 0.0219, 'lps'),
	(525318, 130, '2014-02-01 00:49:47.000000', 'consum', 0.0214, 'lps'),
	(525319, 130, '2014-02-01 00:49:48.000000', 'consum', 0.0223, 'lps'),
	(525320, 130, '2014-02-01 00:49:49.000000', 'consum', 0.0226, 'lps'),
	(525321, 130, '2014-02-01 00:49:50.000000', 'consum', 0.0217, 'lps'),
	(525322, 130, '2014-02-01 00:49:51.000000', 'consum', 0.0215, 'lps'),
	(525323, 130, '2014-02-01 00:49:52.000000', 'consum', 0.0215, 'lps'),
	(525324, 130, '2014-02-01 00:49:53.000000', 'consum', 0.0220, 'lps'),
	(525325, 130, '2014-02-01 00:49:54.000000', 'consum', 0.0210, 'lps'),
	(525326, 130, '2014-02-01 00:49:55.000000', 'consum', 0.0214, 'lps'),
	(525327, 130, '2014-02-01 00:49:56.000000', 'consum', 0.0214, 'lps'),
	(525328, 130, '2014-02-01 00:49:57.000000', 'consum', 0.0221, 'lps'),
	(525329, 130, '2014-02-01 00:49:58.000000', 'consum', 0.0214, 'lps'),
	(525330, 130, '2014-02-01 00:49:59.000000', 'consum', 0.0217, 'lps'),
	(525331, 130, '2014-02-01 00:50:00.000000', 'consum', 0.0214, 'lps'),
	(525332, 130, '2014-02-01 00:50:01.000000', 'consum', 0.0210, 'lps'),
	(525333, 130, '2014-02-01 00:50:02.000000', 'consum', 0.0219, 'lps'),
	(525334, 130, '2014-02-01 00:50:03.000000', 'consum', 0.0217, 'lps'),
	(525335, 130, '2014-02-01 00:50:04.000000', 'consum', 0.0219, 'lps'),
	(525336, 130, '2014-02-01 00:50:05.000000', 'consum', 0.0215, 'lps'),
	(525337, 130, '2014-02-01 00:50:06.000000', 'consum', 0.0227, 'lps'),
	(525338, 130, '2014-02-01 00:50:07.000000', 'consum', 0.0227, 'lps'),
	(525339, 130, '2014-02-01 00:50:08.000000', 'consum', 0.0226, 'lps'),
	(525340, 130, '2014-02-01 00:50:09.000000', 'consum', 0.0220, 'lps'),
	(525341, 130, '2014-02-01 00:50:10.000000', 'consum', 0.0216, 'lps'),
	(525342, 130, '2014-02-01 00:50:11.000000', 'consum', 0.0226, 'lps'),
	(525343, 130, '2014-02-01 00:50:12.000000', 'consum', 0.0218, 'lps'),
	(525344, 130, '2014-02-01 00:50:13.000000', 'consum', 0.0221, 'lps'),
	(525345, 130, '2014-02-01 00:50:14.000000', 'consum', 0.0222, 'lps'),
	(525346, 130, '2014-02-01 00:50:15.000000', 'consum', 0.0221, 'lps'),
	(525347, 130, '2014-02-01 00:50:16.000000', 'consum', 0.0212, 'lps'),
	(525348, 130, '2014-02-01 00:50:17.000000', 'consum', 0.0223, 'lps'),
	(525349, 130, '2014-02-01 00:50:18.000000', 'consum', 0.0214, 'lps'),
	(525350, 130, '2014-02-01 00:50:19.000000', 'consum', 0.0210, 'lps'),
	(525351, 130, '2014-02-01 00:50:20.000000', 'consum', 0.0217, 'lps'),
	(525352, 130, '2014-02-01 00:50:21.000000', 'consum', 0.0210, 'lps'),
	(525353, 130, '2014-02-01 00:50:22.000000', 'consum', 0.0224, 'lps'),
	(525354, 130, '2014-02-01 00:50:23.000000', 'consum', 0.0210, 'lps'),
	(525355, 130, '2014-02-01 00:50:24.000000', 'consum', 0.0223, 'lps'),
	(525356, 130, '2014-02-01 00:50:25.000000', 'consum', 0.0221, 'lps'),
	(525357, 130, '2014-02-01 00:50:26.000000', 'consum', 0.0224, 'lps'),
	(525358, 130, '2014-02-01 00:50:27.000000', 'consum', 0.0215, 'lps'),
	(525359, 130, '2014-02-01 00:50:28.000000', 'consum', 0.0210, 'lps'),
	(525360, 130, '2014-02-01 00:50:29.000000', 'consum', 0.0214, 'lps'),
	(525361, 130, '2014-02-01 00:50:30.000000', 'consum', 0.0211, 'lps'),
	(525362, 130, '2014-02-01 00:50:31.000000', 'consum', 0.0223, 'lps'),
	(525363, 130, '2014-02-01 00:50:32.000000', 'consum', 0.0218, 'lps'),
	(525364, 130, '2014-02-01 00:50:33.000000', 'consum', 0.0213, 'lps'),
	(525365, 130, '2014-02-01 00:50:34.000000', 'consum', 0.0221, 'lps'),
	(525366, 130, '2014-02-01 00:50:35.000000', 'consum', 0.0217, 'lps'),
	(525367, 130, '2014-02-01 00:50:36.000000', 'consum', 0.0213, 'lps'),
	(525368, 130, '2014-02-01 00:50:37.000000', 'consum', 0.0224, 'lps'),
	(525369, 130, '2014-02-01 00:50:38.000000', 'consum', 0.0218, 'lps'),
	(525370, 130, '2014-02-01 00:50:39.000000', 'consum', 0.0224, 'lps'),
	(525371, 130, '2014-02-01 00:50:40.000000', 'consum', 0.0223, 'lps'),
	(525372, 130, '2014-02-01 00:50:41.000000', 'consum', 0.0216, 'lps'),
	(525373, 130, '2014-02-01 00:50:42.000000', 'consum', 0.0220, 'lps'),
	(525374, 130, '2014-02-01 00:50:43.000000', 'consum', 0.0225, 'lps'),
	(525375, 130, '2014-02-01 00:50:44.000000', 'consum', 0.0217, 'lps'),
	(525376, 130, '2014-02-01 00:50:45.000000', 'consum', 0.0221, 'lps'),
	(525377, 130, '2014-02-01 00:50:46.000000', 'consum', 0.0226, 'lps'),
	(525378, 130, '2014-02-01 00:50:47.000000', 'consum', 0.0220, 'lps'),
	(525379, 130, '2014-02-01 00:50:48.000000', 'consum', 0.0212, 'lps'),
	(525380, 130, '2014-02-01 00:50:49.000000', 'consum', 0.0210, 'lps'),
	(525381, 130, '2014-02-01 00:50:50.000000', 'consum', 0.0224, 'lps'),
	(525382, 130, '2014-02-01 00:50:51.000000', 'consum', 0.0226, 'lps'),
	(525383, 130, '2014-02-01 00:50:52.000000', 'consum', 0.0212, 'lps'),
	(525384, 130, '2014-02-01 00:50:53.000000', 'consum', 0.0210, 'lps'),
	(525385, 130, '2014-02-01 00:50:54.000000', 'consum', 0.0223, 'lps'),
	(525386, 130, '2014-02-01 00:50:55.000000', 'consum', 0.0221, 'lps'),
	(525387, 130, '2014-02-01 00:50:56.000000', 'consum', 0.0226, 'lps'),
	(525388, 130, '2014-02-01 00:50:57.000000', 'consum', 0.0221, 'lps'),
	(525389, 130, '2014-02-01 00:50:58.000000', 'consum', 0.0219, 'lps'),
	(525390, 130, '2014-02-01 00:50:59.000000', 'consum', 0.0220, 'lps'),
	(525391, 130, '2014-02-01 00:51:00.000000', 'consum', 0.0217, 'lps'),
	(525392, 130, '2014-02-01 00:51:01.000000', 'consum', 0.0214, 'lps'),
	(525393, 130, '2014-02-01 00:51:02.000000', 'consum', 0.0212, 'lps'),
	(525394, 130, '2014-02-01 00:51:03.000000', 'consum', 0.0224, 'lps'),
	(525395, 130, '2014-02-01 00:51:04.000000', 'consum', 0.0221, 'lps'),
	(525396, 130, '2014-02-01 00:51:05.000000', 'consum', 0.0224, 'lps'),
	(525397, 130, '2014-02-01 00:51:06.000000', 'consum', 0.0213, 'lps'),
	(525398, 130, '2014-02-01 00:51:07.000000', 'consum', 0.0220, 'lps'),
	(525399, 130, '2014-02-01 00:51:08.000000', 'consum', 0.0213, 'lps'),
	(525400, 130, '2014-02-01 00:51:09.000000', 'consum', 0.0215, 'lps'),
	(525401, 130, '2014-02-01 00:51:10.000000', 'consum', 0.0225, 'lps'),
	(525402, 130, '2014-02-01 00:51:11.000000', 'consum', 0.0217, 'lps'),
	(525403, 130, '2014-02-01 00:51:12.000000', 'consum', 0.0221, 'lps'),
	(525404, 130, '2014-02-01 00:51:13.000000', 'consum', 0.0224, 'lps'),
	(525405, 130, '2014-02-01 00:51:14.000000', 'consum', 0.0211, 'lps'),
	(525406, 130, '2014-02-01 00:51:15.000000', 'consum', 0.0227, 'lps'),
	(525407, 130, '2014-02-01 00:51:16.000000', 'consum', 0.0222, 'lps'),
	(525408, 130, '2014-02-01 00:51:17.000000', 'consum', 0.0218, 'lps'),
	(525409, 130, '2014-02-01 00:51:18.000000', 'consum', 0.0214, 'lps'),
	(525410, 130, '2014-02-01 00:51:19.000000', 'consum', 0.0227, 'lps'),
	(525411, 130, '2014-02-01 00:51:20.000000', 'consum', 0.0227, 'lps'),
	(525412, 130, '2014-02-01 00:51:21.000000', 'consum', 0.0227, 'lps'),
	(525413, 130, '2014-02-01 00:51:22.000000', 'consum', 0.0225, 'lps'),
	(525414, 130, '2014-02-01 00:51:23.000000', 'consum', 0.0217, 'lps'),
	(525415, 130, '2014-02-01 00:51:24.000000', 'consum', 0.0219, 'lps'),
	(525416, 130, '2014-02-01 00:51:25.000000', 'consum', 0.0216, 'lps'),
	(525417, 130, '2014-02-01 00:51:26.000000', 'consum', 0.0216, 'lps'),
	(525418, 130, '2014-02-01 00:51:27.000000', 'consum', 0.0219, 'lps'),
	(525419, 130, '2014-02-01 00:51:28.000000', 'consum', 0.0222, 'lps'),
	(525420, 130, '2014-02-01 00:51:29.000000', 'consum', 0.0226, 'lps'),
	(525421, 130, '2014-02-01 00:51:30.000000', 'consum', 0.0216, 'lps'),
	(525422, 130, '2014-02-01 00:51:31.000000', 'consum', 0.0213, 'lps'),
	(525423, 130, '2014-02-01 00:51:32.000000', 'consum', 0.0223, 'lps'),
	(525424, 130, '2014-02-01 00:51:33.000000', 'consum', 0.0214, 'lps'),
	(525425, 130, '2014-02-01 00:51:34.000000', 'consum', 0.0211, 'lps'),
	(525426, 130, '2014-02-01 00:51:35.000000', 'consum', 0.0219, 'lps'),
	(525427, 130, '2014-02-01 00:51:36.000000', 'consum', 0.0216, 'lps'),
	(525428, 130, '2014-02-01 00:51:37.000000', 'consum', 0.0215, 'lps'),
	(525429, 130, '2014-02-01 00:51:38.000000', 'consum', 0.0216, 'lps'),
	(525430, 130, '2014-02-01 00:51:39.000000', 'consum', 0.0227, 'lps'),
	(525431, 130, '2014-02-01 00:51:40.000000', 'consum', 0.0221, 'lps'),
	(525432, 130, '2014-02-01 00:51:41.000000', 'consum', 0.0218, 'lps'),
	(525433, 130, '2014-02-01 00:51:42.000000', 'consum', 0.0214, 'lps'),
	(525434, 130, '2014-02-01 00:51:43.000000', 'consum', 0.0210, 'lps'),
	(525435, 130, '2014-02-01 00:51:44.000000', 'consum', 0.0215, 'lps'),
	(525436, 130, '2014-02-01 00:51:45.000000', 'consum', 0.0217, 'lps'),
	(525437, 130, '2014-02-01 00:51:46.000000', 'consum', 0.0213, 'lps'),
	(525438, 130, '2014-02-01 00:51:47.000000', 'consum', 0.0221, 'lps'),
	(525439, 130, '2014-02-01 00:51:48.000000', 'consum', 0.0220, 'lps'),
	(525440, 130, '2014-02-01 00:51:49.000000', 'consum', 0.0210, 'lps'),
	(525441, 130, '2014-02-01 00:51:50.000000', 'consum', 0.0217, 'lps'),
	(525442, 130, '2014-02-01 00:51:51.000000', 'consum', 0.0227, 'lps'),
	(525443, 130, '2014-02-01 00:51:52.000000', 'consum', 0.0219, 'lps'),
	(525444, 130, '2014-02-01 00:51:53.000000', 'consum', 0.0223, 'lps'),
	(525445, 130, '2014-02-01 00:51:54.000000', 'consum', 0.0212, 'lps'),
	(525446, 130, '2014-02-01 00:51:55.000000', 'consum', 0.0219, 'lps'),
	(525447, 130, '2014-02-01 00:51:56.000000', 'consum', 0.0211, 'lps'),
	(525448, 130, '2014-02-01 00:51:57.000000', 'consum', 0.0225, 'lps'),
	(525449, 130, '2014-02-01 00:51:58.000000', 'consum', 0.0212, 'lps'),
	(525450, 130, '2014-02-01 00:51:59.000000', 'consum', 0.0227, 'lps'),
	(525451, 130, '2014-02-01 00:52:00.000000', 'consum', 0.0218, 'lps'),
	(525452, 130, '2014-02-01 00:52:01.000000', 'consum', 0.0220, 'lps'),
	(525453, 130, '2014-02-01 00:52:02.000000', 'consum', 0.0215, 'lps'),
	(525454, 130, '2014-02-01 00:52:03.000000', 'consum', 0.0226, 'lps'),
	(525455, 130, '2014-02-01 00:52:04.000000', 'consum', 0.0222, 'lps'),
	(525456, 130, '2014-02-01 00:52:05.000000', 'consum', 0.0223, 'lps'),
	(525457, 130, '2014-02-01 00:52:06.000000', 'consum', 0.0222, 'lps'),
	(525458, 130, '2014-02-01 00:52:07.000000', 'consum', 0.0212, 'lps'),
	(525459, 130, '2014-02-01 00:52:08.000000', 'consum', 0.0222, 'lps'),
	(525460, 130, '2014-02-01 00:52:09.000000', 'consum', 0.0211, 'lps'),
	(525461, 130, '2014-02-01 00:52:10.000000', 'consum', 0.0213, 'lps'),
	(525462, 130, '2014-02-01 00:52:11.000000', 'consum', 0.0225, 'lps'),
	(525463, 130, '2014-02-01 00:52:12.000000', 'consum', 0.0223, 'lps'),
	(525464, 130, '2014-02-01 00:52:13.000000', 'consum', 0.0211, 'lps'),
	(525465, 130, '2014-02-01 00:52:14.000000', 'consum', 0.0214, 'lps'),
	(525466, 130, '2014-02-01 00:52:15.000000', 'consum', 0.0211, 'lps'),
	(525467, 130, '2014-02-01 00:52:16.000000', 'consum', 0.0218, 'lps'),
	(525468, 130, '2014-02-01 00:52:17.000000', 'consum', 0.0212, 'lps'),
	(525469, 130, '2014-02-01 00:52:18.000000', 'consum', 0.0215, 'lps'),
	(525470, 130, '2014-02-01 00:52:19.000000', 'consum', 0.0213, 'lps'),
	(525471, 130, '2014-02-01 00:52:20.000000', 'consum', 0.0210, 'lps'),
	(525472, 130, '2014-02-01 00:52:21.000000', 'consum', 0.0220, 'lps'),
	(525473, 130, '2014-02-01 00:52:22.000000', 'consum', 0.0226, 'lps'),
	(525474, 130, '2014-02-01 00:52:23.000000', 'consum', 0.0222, 'lps'),
	(525475, 130, '2014-02-01 00:52:24.000000', 'consum', 0.0223, 'lps'),
	(525476, 130, '2014-02-01 00:52:25.000000', 'consum', 0.0223, 'lps'),
	(525477, 130, '2014-02-01 00:52:26.000000', 'consum', 0.0217, 'lps'),
	(525478, 130, '2014-02-01 00:52:27.000000', 'consum', 0.0226, 'lps'),
	(525479, 130, '2014-02-01 00:52:28.000000', 'consum', 0.0214, 'lps'),
	(525480, 130, '2014-02-01 00:52:29.000000', 'consum', 0.0219, 'lps'),
	(525481, 130, '2014-02-01 00:52:30.000000', 'consum', 0.0224, 'lps'),
	(525482, 130, '2014-02-01 00:52:31.000000', 'consum', 0.0218, 'lps'),
	(525483, 130, '2014-02-01 00:52:32.000000', 'consum', 0.0227, 'lps'),
	(525484, 130, '2014-02-01 00:52:33.000000', 'consum', 0.0216, 'lps'),
	(525485, 130, '2014-02-01 00:52:34.000000', 'consum', 0.0226, 'lps'),
	(525486, 130, '2014-02-01 00:52:35.000000', 'consum', 0.0218, 'lps'),
	(525487, 130, '2014-02-01 00:52:36.000000', 'consum', 0.0221, 'lps'),
	(525488, 130, '2014-02-01 00:52:37.000000', 'consum', 0.0226, 'lps'),
	(525489, 130, '2014-02-01 00:52:38.000000', 'consum', 0.0219, 'lps'),
	(525490, 130, '2014-02-01 00:52:39.000000', 'consum', 0.0224, 'lps'),
	(525491, 130, '2014-02-01 00:52:40.000000', 'consum', 0.0219, 'lps'),
	(525492, 130, '2014-02-01 00:52:41.000000', 'consum', 0.0213, 'lps'),
	(525493, 130, '2014-02-01 00:52:42.000000', 'consum', 0.0216, 'lps'),
	(525494, 130, '2014-02-01 00:52:43.000000', 'consum', 0.0213, 'lps'),
	(525495, 130, '2014-02-01 00:52:44.000000', 'consum', 0.0225, 'lps'),
	(525496, 130, '2014-02-01 00:52:45.000000', 'consum', 0.0224, 'lps'),
	(525497, 130, '2014-02-01 00:52:46.000000', 'consum', 0.0217, 'lps'),
	(525498, 130, '2014-02-01 00:52:47.000000', 'consum', 0.0220, 'lps'),
	(525499, 130, '2014-02-01 00:52:48.000000', 'consum', 0.0224, 'lps'),
	(525500, 130, '2014-02-01 00:52:49.000000', 'consum', 0.0213, 'lps'),
	(525501, 130, '2014-02-01 00:52:50.000000', 'consum', 0.0221, 'lps'),
	(525502, 130, '2014-02-01 00:52:51.000000', 'consum', 0.0218, 'lps'),
	(525503, 130, '2014-02-01 00:52:52.000000', 'consum', 0.0220, 'lps'),
	(525504, 130, '2014-02-01 00:52:53.000000', 'consum', 0.0219, 'lps'),
	(525505, 130, '2014-02-01 00:52:54.000000', 'consum', 0.0226, 'lps'),
	(525506, 130, '2014-02-01 00:52:55.000000', 'consum', 0.0210, 'lps'),
	(525507, 130, '2014-02-01 00:52:56.000000', 'consum', 0.0216, 'lps'),
	(525508, 130, '2014-02-01 00:52:57.000000', 'consum', 0.0223, 'lps'),
	(525509, 130, '2014-02-01 00:52:58.000000', 'consum', 0.0221, 'lps'),
	(525510, 130, '2014-02-01 00:52:59.000000', 'consum', 0.0227, 'lps'),
	(525511, 130, '2014-02-01 00:53:00.000000', 'consum', 0.0224, 'lps'),
	(525512, 130, '2014-02-01 00:53:01.000000', 'consum', 0.0214, 'lps'),
	(525513, 130, '2014-02-01 00:53:02.000000', 'consum', 0.0224, 'lps'),
	(525514, 130, '2014-02-01 00:53:03.000000', 'consum', 0.0216, 'lps'),
	(525515, 130, '2014-02-01 00:53:04.000000', 'consum', 0.0214, 'lps'),
	(525516, 130, '2014-02-01 00:53:05.000000', 'consum', 0.0212, 'lps'),
	(525517, 130, '2014-02-01 00:53:06.000000', 'consum', 0.0226, 'lps'),
	(525518, 130, '2014-02-01 00:53:07.000000', 'consum', 0.0215, 'lps'),
	(525519, 130, '2014-02-01 00:53:08.000000', 'consum', 0.0222, 'lps'),
	(525520, 130, '2014-02-01 00:53:09.000000', 'consum', 0.0221, 'lps'),
	(525521, 130, '2014-02-01 00:53:10.000000', 'consum', 0.0212, 'lps'),
	(525522, 130, '2014-02-01 00:53:11.000000', 'consum', 0.0223, 'lps'),
	(525523, 130, '2014-02-01 00:53:12.000000', 'consum', 0.0216, 'lps'),
	(525524, 130, '2014-02-01 00:53:13.000000', 'consum', 0.0219, 'lps'),
	(525525, 130, '2014-02-01 00:53:14.000000', 'consum', 0.0219, 'lps'),
	(525526, 130, '2014-02-01 00:53:15.000000', 'consum', 0.0212, 'lps'),
	(525527, 130, '2014-02-01 00:53:16.000000', 'consum', 0.0210, 'lps'),
	(525528, 130, '2014-02-01 00:53:17.000000', 'consum', 0.0224, 'lps'),
	(525529, 130, '2014-02-01 00:53:18.000000', 'consum', 0.0225, 'lps'),
	(525530, 130, '2014-02-01 00:53:19.000000', 'consum', 0.0226, 'lps'),
	(525531, 130, '2014-02-01 00:53:20.000000', 'consum', 0.0211, 'lps'),
	(525532, 130, '2014-02-01 00:53:21.000000', 'consum', 0.0222, 'lps'),
	(525533, 130, '2014-02-01 00:53:22.000000', 'consum', 0.0214, 'lps'),
	(525534, 130, '2014-02-01 00:53:23.000000', 'consum', 0.0212, 'lps'),
	(525535, 130, '2014-02-01 00:53:24.000000', 'consum', 0.0224, 'lps'),
	(525536, 130, '2014-02-01 00:53:25.000000', 'consum', 0.0223, 'lps'),
	(525537, 130, '2014-02-01 00:53:26.000000', 'consum', 0.0213, 'lps'),
	(525538, 130, '2014-02-01 00:53:27.000000', 'consum', 0.0226, 'lps'),
	(525539, 130, '2014-02-01 00:53:28.000000', 'consum', 0.0225, 'lps'),
	(525540, 130, '2014-02-01 00:53:29.000000', 'consum', 0.0219, 'lps'),
	(525541, 130, '2014-02-01 00:53:30.000000', 'consum', 0.0210, 'lps'),
	(525542, 130, '2014-02-01 00:53:31.000000', 'consum', 0.0221, 'lps'),
	(525543, 130, '2014-02-01 00:53:32.000000', 'consum', 0.0213, 'lps'),
	(525544, 130, '2014-02-01 00:53:33.000000', 'consum', 0.0226, 'lps'),
	(525545, 130, '2014-02-01 00:53:34.000000', 'consum', 0.0210, 'lps'),
	(525546, 130, '2014-02-01 00:53:35.000000', 'consum', 0.0216, 'lps'),
	(525547, 130, '2014-02-01 00:53:36.000000', 'consum', 0.0223, 'lps'),
	(525548, 130, '2014-02-01 00:53:37.000000', 'consum', 0.0222, 'lps'),
	(525549, 130, '2014-02-01 00:53:38.000000', 'consum', 0.0213, 'lps'),
	(525550, 130, '2014-02-01 00:53:39.000000', 'consum', 0.0210, 'lps'),
	(525551, 130, '2014-02-01 00:53:40.000000', 'consum', 0.0217, 'lps'),
	(525552, 130, '2014-02-01 00:53:41.000000', 'consum', 0.0227, 'lps'),
	(525553, 130, '2014-02-01 00:53:42.000000', 'consum', 0.0220, 'lps'),
	(525554, 130, '2014-02-01 00:53:43.000000', 'consum', 0.0210, 'lps'),
	(525555, 130, '2014-02-01 00:53:44.000000', 'consum', 0.0216, 'lps'),
	(525556, 130, '2014-02-01 00:53:45.000000', 'consum', 0.0224, 'lps'),
	(525557, 130, '2014-02-01 00:53:46.000000', 'consum', 0.0224, 'lps'),
	(525558, 130, '2014-02-01 00:53:47.000000', 'consum', 0.0224, 'lps'),
	(525559, 130, '2014-02-01 00:53:48.000000', 'consum', 0.0218, 'lps'),
	(525560, 130, '2014-02-01 00:53:49.000000', 'consum', 0.0211, 'lps'),
	(525561, 130, '2014-02-01 00:53:50.000000', 'consum', 0.0227, 'lps'),
	(525562, 130, '2014-02-01 00:53:51.000000', 'consum', 0.0220, 'lps'),
	(525563, 130, '2014-02-01 00:53:52.000000', 'consum', 0.0211, 'lps'),
	(525564, 130, '2014-02-01 00:53:53.000000', 'consum', 0.0221, 'lps'),
	(525565, 130, '2014-02-01 00:53:54.000000', 'consum', 0.0225, 'lps'),
	(525566, 130, '2014-02-01 00:53:55.000000', 'consum', 0.0218, 'lps'),
	(525567, 130, '2014-02-01 00:53:56.000000', 'consum', 0.0223, 'lps'),
	(525568, 130, '2014-02-01 00:53:57.000000', 'consum', 0.0214, 'lps'),
	(525569, 130, '2014-02-01 00:53:58.000000', 'consum', 0.0210, 'lps'),
	(525570, 130, '2014-02-01 00:53:59.000000', 'consum', 0.0215, 'lps'),
	(525571, 130, '2014-02-01 00:54:00.000000', 'consum', 0.0219, 'lps'),
	(525572, 130, '2014-02-01 00:54:01.000000', 'consum', 0.0221, 'lps'),
	(525573, 130, '2014-02-01 00:54:02.000000', 'consum', 0.0223, 'lps'),
	(525574, 130, '2014-02-01 00:54:03.000000', 'consum', 0.0223, 'lps'),
	(525575, 130, '2014-02-01 00:54:04.000000', 'consum', 0.0219, 'lps'),
	(525576, 130, '2014-02-01 00:54:05.000000', 'consum', 0.0216, 'lps'),
	(525577, 130, '2014-02-01 00:54:06.000000', 'consum', 0.0213, 'lps'),
	(525578, 130, '2014-02-01 00:54:07.000000', 'consum', 0.0226, 'lps'),
	(525579, 130, '2014-02-01 00:54:08.000000', 'consum', 0.0226, 'lps'),
	(525580, 130, '2014-02-01 00:54:09.000000', 'consum', 0.0224, 'lps'),
	(525581, 130, '2014-02-01 00:54:10.000000', 'consum', 0.0216, 'lps'),
	(525582, 130, '2014-02-01 00:54:11.000000', 'consum', 0.0217, 'lps'),
	(525583, 130, '2014-02-01 00:54:12.000000', 'consum', 0.0210, 'lps'),
	(525584, 130, '2014-02-01 00:54:13.000000', 'consum', 0.0225, 'lps'),
	(525585, 130, '2014-02-01 00:54:14.000000', 'consum', 0.0213, 'lps'),
	(525586, 130, '2014-02-01 00:54:15.000000', 'consum', 0.0218, 'lps'),
	(525587, 130, '2014-02-01 00:54:16.000000', 'consum', 0.0222, 'lps'),
	(525588, 130, '2014-02-01 00:54:17.000000', 'consum', 0.0210, 'lps'),
	(525589, 130, '2014-02-01 00:54:18.000000', 'consum', 0.0211, 'lps'),
	(525590, 130, '2014-02-01 00:54:19.000000', 'consum', 0.0216, 'lps'),
	(525591, 130, '2014-02-01 00:54:20.000000', 'consum', 0.0220, 'lps'),
	(525592, 130, '2014-02-01 00:54:21.000000', 'consum', 0.0226, 'lps'),
	(525593, 130, '2014-02-01 00:54:22.000000', 'consum', 0.0223, 'lps'),
	(525594, 130, '2014-02-01 00:54:23.000000', 'consum', 0.0226, 'lps'),
	(525595, 130, '2014-02-01 00:54:24.000000', 'consum', 0.0216, 'lps'),
	(525596, 130, '2014-02-01 00:54:25.000000', 'consum', 0.0210, 'lps'),
	(525597, 130, '2014-02-01 00:54:26.000000', 'consum', 0.0211, 'lps'),
	(525598, 130, '2014-02-01 00:54:27.000000', 'consum', 0.0215, 'lps'),
	(525599, 130, '2014-02-01 00:54:28.000000', 'consum', 0.0216, 'lps'),
	(525600, 130, '2014-02-01 00:54:29.000000', 'consum', 0.0223, 'lps'),
	(525601, 130, '2014-02-01 00:54:30.000000', 'consum', 0.0225, 'lps'),
	(525602, 130, '2014-02-01 00:54:31.000000', 'consum', 0.0226, 'lps'),
	(525603, 130, '2014-02-01 00:54:32.000000', 'consum', 0.0211, 'lps'),
	(525604, 130, '2014-02-01 00:54:33.000000', 'consum', 0.0221, 'lps'),
	(525605, 130, '2014-02-01 00:54:34.000000', 'consum', 0.0225, 'lps'),
	(525606, 130, '2014-02-01 00:54:35.000000', 'consum', 0.0219, 'lps'),
	(525607, 130, '2014-02-01 00:54:36.000000', 'consum', 0.0210, 'lps'),
	(525608, 130, '2014-02-01 00:54:37.000000', 'consum', 0.0220, 'lps'),
	(525609, 130, '2014-02-01 00:54:38.000000', 'consum', 0.0224, 'lps'),
	(525610, 130, '2014-02-01 00:54:39.000000', 'consum', 0.0213, 'lps'),
	(525611, 130, '2014-02-01 00:54:40.000000', 'consum', 0.0222, 'lps'),
	(525612, 130, '2014-02-01 00:54:41.000000', 'consum', 0.0224, 'lps'),
	(525613, 130, '2014-02-01 00:54:42.000000', 'consum', 0.0227, 'lps'),
	(525614, 130, '2014-02-01 00:54:43.000000', 'consum', 0.0219, 'lps'),
	(525615, 130, '2014-02-01 00:54:44.000000', 'consum', 0.0223, 'lps'),
	(525616, 130, '2014-02-01 00:54:45.000000', 'consum', 0.0211, 'lps'),
	(525617, 130, '2014-02-01 00:54:46.000000', 'consum', 0.0213, 'lps'),
	(525618, 130, '2014-02-01 00:54:47.000000', 'consum', 0.0222, 'lps'),
	(525619, 130, '2014-02-01 00:54:48.000000', 'consum', 0.0225, 'lps'),
	(525620, 130, '2014-02-01 00:54:49.000000', 'consum', 0.0212, 'lps'),
	(525621, 130, '2014-02-01 00:54:50.000000', 'consum', 0.0214, 'lps'),
	(525622, 130, '2014-02-01 00:54:51.000000', 'consum', 0.0225, 'lps'),
	(525623, 130, '2014-02-01 00:54:52.000000', 'consum', 0.0217, 'lps'),
	(525624, 130, '2014-02-01 00:54:53.000000', 'consum', 0.0218, 'lps'),
	(525625, 130, '2014-02-01 00:54:54.000000', 'consum', 0.0211, 'lps'),
	(525626, 130, '2014-02-01 00:54:55.000000', 'consum', 0.0211, 'lps'),
	(525627, 130, '2014-02-01 00:54:56.000000', 'consum', 0.0211, 'lps'),
	(525628, 130, '2014-02-01 00:54:57.000000', 'consum', 0.0213, 'lps'),
	(525629, 130, '2014-02-01 00:54:58.000000', 'consum', 0.0221, 'lps'),
	(525630, 130, '2014-02-01 00:54:59.000000', 'consum', 0.0222, 'lps'),
	(525631, 130, '2014-02-01 00:55:00.000000', 'consum', 0.0219, 'lps'),
	(525632, 130, '2014-02-01 00:55:01.000000', 'consum', 0.0219, 'lps'),
	(525633, 130, '2014-02-01 00:55:02.000000', 'consum', 0.0227, 'lps'),
	(525634, 130, '2014-02-01 00:55:03.000000', 'consum', 0.0217, 'lps'),
	(525635, 130, '2014-02-01 00:55:04.000000', 'consum', 0.0212, 'lps'),
	(525636, 130, '2014-02-01 00:55:05.000000', 'consum', 0.0215, 'lps'),
	(525637, 130, '2014-02-01 00:55:06.000000', 'consum', 0.0214, 'lps'),
	(525638, 130, '2014-02-01 00:55:07.000000', 'consum', 0.0216, 'lps'),
	(525639, 130, '2014-02-01 00:55:08.000000', 'consum', 0.0210, 'lps'),
	(525640, 130, '2014-02-01 00:55:09.000000', 'consum', 0.0210, 'lps'),
	(525641, 130, '2014-02-01 00:55:10.000000', 'consum', 0.0211, 'lps'),
	(525642, 130, '2014-02-01 00:55:11.000000', 'consum', 0.0214, 'lps'),
	(525643, 130, '2014-02-01 00:55:12.000000', 'consum', 0.0210, 'lps'),
	(525644, 130, '2014-02-01 00:55:13.000000', 'consum', 0.0217, 'lps'),
	(525645, 130, '2014-02-01 00:55:14.000000', 'consum', 0.0226, 'lps'),
	(525646, 130, '2014-02-01 00:55:15.000000', 'consum', 0.0217, 'lps'),
	(525647, 130, '2014-02-01 00:55:16.000000', 'consum', 0.0214, 'lps'),
	(525648, 130, '2014-02-01 00:55:17.000000', 'consum', 0.0227, 'lps'),
	(525649, 130, '2014-02-01 00:55:18.000000', 'consum', 0.0212, 'lps'),
	(525650, 130, '2014-02-01 00:55:19.000000', 'consum', 0.0224, 'lps'),
	(525651, 130, '2014-02-01 00:55:20.000000', 'consum', 0.0219, 'lps'),
	(525652, 130, '2014-02-01 00:55:21.000000', 'consum', 0.0216, 'lps'),
	(525653, 130, '2014-02-01 00:55:22.000000', 'consum', 0.0214, 'lps'),
	(525654, 130, '2014-02-01 00:55:23.000000', 'consum', 0.0210, 'lps'),
	(525655, 130, '2014-02-01 00:55:24.000000', 'consum', 0.0218, 'lps'),
	(525656, 130, '2014-02-01 00:55:25.000000', 'consum', 0.0215, 'lps'),
	(525657, 130, '2014-02-01 00:55:26.000000', 'consum', 0.0210, 'lps'),
	(525658, 130, '2014-02-01 00:55:27.000000', 'consum', 0.0215, 'lps'),
	(525659, 130, '2014-02-01 00:55:28.000000', 'consum', 0.0216, 'lps'),
	(525660, 130, '2014-02-01 00:55:29.000000', 'consum', 0.0226, 'lps'),
	(525661, 130, '2014-02-01 00:55:30.000000', 'consum', 0.0219, 'lps'),
	(525662, 130, '2014-02-01 00:55:31.000000', 'consum', 0.0227, 'lps'),
	(525663, 130, '2014-02-01 00:55:32.000000', 'consum', 0.0211, 'lps'),
	(525664, 130, '2014-02-01 00:55:33.000000', 'consum', 0.0222, 'lps'),
	(525665, 130, '2014-02-01 00:55:34.000000', 'consum', 0.0210, 'lps'),
	(525666, 130, '2014-02-01 00:55:35.000000', 'consum', 0.0212, 'lps'),
	(525667, 130, '2014-02-01 00:55:36.000000', 'consum', 0.0221, 'lps'),
	(525668, 130, '2014-02-01 00:55:37.000000', 'consum', 0.0223, 'lps'),
	(525669, 130, '2014-02-01 00:55:38.000000', 'consum', 0.0222, 'lps'),
	(525670, 130, '2014-02-01 00:55:39.000000', 'consum', 0.0217, 'lps'),
	(525671, 130, '2014-02-01 00:55:40.000000', 'consum', 0.0210, 'lps'),
	(525672, 130, '2014-02-01 00:55:41.000000', 'consum', 0.0224, 'lps'),
	(525673, 130, '2014-02-01 00:55:42.000000', 'consum', 0.0227, 'lps'),
	(525674, 130, '2014-02-01 00:55:43.000000', 'consum', 0.0216, 'lps'),
	(525675, 130, '2014-02-01 00:55:44.000000', 'consum', 0.0227, 'lps'),
	(525676, 130, '2014-02-01 00:55:45.000000', 'consum', 0.0222, 'lps'),
	(525677, 130, '2014-02-01 00:55:46.000000', 'consum', 0.0219, 'lps'),
	(525678, 130, '2014-02-01 00:55:47.000000', 'consum', 0.0220, 'lps'),
	(525679, 130, '2014-02-01 00:55:48.000000', 'consum', 0.0216, 'lps'),
	(525680, 130, '2014-02-01 00:55:49.000000', 'consum', 0.0212, 'lps'),
	(525681, 130, '2014-02-01 00:55:50.000000', 'consum', 0.0221, 'lps'),
	(525682, 130, '2014-02-01 00:55:51.000000', 'consum', 0.0220, 'lps'),
	(525683, 130, '2014-02-01 00:55:52.000000', 'consum', 0.0213, 'lps'),
	(525684, 130, '2014-02-01 00:55:53.000000', 'consum', 0.0211, 'lps'),
	(525685, 130, '2014-02-01 00:55:54.000000', 'consum', 0.0225, 'lps'),
	(525686, 130, '2014-02-01 00:55:55.000000', 'consum', 0.0211, 'lps'),
	(525687, 130, '2014-02-01 00:55:56.000000', 'consum', 0.0225, 'lps'),
	(525688, 130, '2014-02-01 00:55:57.000000', 'consum', 0.0227, 'lps'),
	(525689, 130, '2014-02-01 00:55:58.000000', 'consum', 0.0217, 'lps'),
	(525690, 130, '2014-02-01 00:55:59.000000', 'consum', 0.0211, 'lps'),
	(525691, 130, '2014-02-01 00:56:00.000000', 'consum', 0.0211, 'lps'),
	(525692, 130, '2014-02-01 00:56:01.000000', 'consum', 0.0212, 'lps'),
	(525693, 130, '2014-02-01 00:56:02.000000', 'consum', 0.0219, 'lps'),
	(525694, 130, '2014-02-01 00:56:03.000000', 'consum', 0.0214, 'lps'),
	(525695, 130, '2014-02-01 00:56:04.000000', 'consum', 0.0220, 'lps'),
	(525696, 130, '2014-02-01 00:56:05.000000', 'consum', 0.0213, 'lps'),
	(525697, 130, '2014-02-01 00:56:06.000000', 'consum', 0.0212, 'lps'),
	(525698, 130, '2014-02-01 00:56:07.000000', 'consum', 0.0211, 'lps'),
	(525699, 130, '2014-02-01 00:56:08.000000', 'consum', 0.0211, 'lps'),
	(525700, 130, '2014-02-01 00:56:09.000000', 'consum', 0.0214, 'lps'),
	(525701, 130, '2014-02-01 00:56:10.000000', 'consum', 0.0210, 'lps'),
	(525702, 130, '2014-02-01 00:56:11.000000', 'consum', 0.0213, 'lps'),
	(525703, 130, '2014-02-01 00:56:12.000000', 'consum', 0.0211, 'lps'),
	(525704, 130, '2014-02-01 00:56:13.000000', 'consum', 0.0222, 'lps'),
	(525705, 130, '2014-02-01 00:56:14.000000', 'consum', 0.0213, 'lps'),
	(525706, 130, '2014-02-01 00:56:15.000000', 'consum', 0.0226, 'lps'),
	(525707, 130, '2014-02-01 00:56:16.000000', 'consum', 0.0226, 'lps'),
	(525708, 130, '2014-02-01 00:56:17.000000', 'consum', 0.0226, 'lps'),
	(525709, 130, '2014-02-01 00:56:18.000000', 'consum', 0.0224, 'lps'),
	(525710, 130, '2014-02-01 00:56:19.000000', 'consum', 0.0216, 'lps'),
	(525711, 130, '2014-02-01 00:56:20.000000', 'consum', 0.0214, 'lps'),
	(525712, 130, '2014-02-01 00:56:21.000000', 'consum', 0.0212, 'lps'),
	(525713, 130, '2014-02-01 00:56:22.000000', 'consum', 0.0226, 'lps'),
	(525714, 130, '2014-02-01 00:56:23.000000', 'consum', 0.0215, 'lps'),
	(525715, 130, '2014-02-01 00:56:24.000000', 'consum', 0.0220, 'lps'),
	(525716, 130, '2014-02-01 00:56:25.000000', 'consum', 0.0213, 'lps'),
	(525717, 130, '2014-02-01 00:56:26.000000', 'consum', 0.0214, 'lps'),
	(525718, 130, '2014-02-01 00:56:27.000000', 'consum', 0.0218, 'lps'),
	(525719, 130, '2014-02-01 00:56:28.000000', 'consum', 0.0224, 'lps'),
	(525720, 130, '2014-02-01 00:56:29.000000', 'consum', 0.0217, 'lps'),
	(525721, 130, '2014-02-01 00:56:30.000000', 'consum', 0.0223, 'lps'),
	(525722, 130, '2014-02-01 00:56:31.000000', 'consum', 0.0219, 'lps'),
	(525723, 130, '2014-02-01 00:56:32.000000', 'consum', 0.0218, 'lps'),
	(525724, 130, '2014-02-01 00:56:33.000000', 'consum', 0.0221, 'lps'),
	(525725, 130, '2014-02-01 00:56:34.000000', 'consum', 0.0223, 'lps'),
	(525726, 130, '2014-02-01 00:56:35.000000', 'consum', 0.0225, 'lps'),
	(525727, 130, '2014-02-01 00:56:36.000000', 'consum', 0.0213, 'lps'),
	(525728, 130, '2014-02-01 00:56:37.000000', 'consum', 0.0215, 'lps'),
	(525729, 130, '2014-02-01 00:56:38.000000', 'consum', 0.0225, 'lps'),
	(525730, 130, '2014-02-01 00:56:39.000000', 'consum', 0.0218, 'lps'),
	(525731, 130, '2014-02-01 00:56:40.000000', 'consum', 0.0223, 'lps'),
	(525732, 130, '2014-02-01 00:56:41.000000', 'consum', 0.0214, 'lps'),
	(525733, 130, '2014-02-01 00:56:42.000000', 'consum', 0.0227, 'lps'),
	(525734, 130, '2014-02-01 00:56:43.000000', 'consum', 0.0213, 'lps'),
	(525735, 130, '2014-02-01 00:56:44.000000', 'consum', 0.0227, 'lps'),
	(525736, 130, '2014-02-01 00:56:45.000000', 'consum', 0.0215, 'lps'),
	(525737, 130, '2014-02-01 00:56:46.000000', 'consum', 0.0219, 'lps'),
	(525738, 130, '2014-02-01 00:56:47.000000', 'consum', 0.0224, 'lps'),
	(525739, 130, '2014-02-01 00:56:48.000000', 'consum', 0.0215, 'lps'),
	(525740, 130, '2014-02-01 00:56:49.000000', 'consum', 0.0214, 'lps'),
	(525741, 130, '2014-02-01 00:56:50.000000', 'consum', 0.0215, 'lps'),
	(525742, 130, '2014-02-01 00:56:51.000000', 'consum', 0.0225, 'lps'),
	(525743, 130, '2014-02-01 00:56:52.000000', 'consum', 0.0215, 'lps'),
	(525744, 130, '2014-02-01 00:56:53.000000', 'consum', 0.0225, 'lps'),
	(525745, 130, '2014-02-01 00:56:54.000000', 'consum', 0.0217, 'lps'),
	(525746, 130, '2014-02-01 00:56:55.000000', 'consum', 0.0218, 'lps'),
	(525747, 130, '2014-02-01 00:56:56.000000', 'consum', 0.0211, 'lps'),
	(525748, 130, '2014-02-01 00:56:57.000000', 'consum', 0.0227, 'lps'),
	(525749, 130, '2014-02-01 00:56:58.000000', 'consum', 0.0221, 'lps'),
	(525750, 130, '2014-02-01 00:56:59.000000', 'consum', 0.0217, 'lps'),
	(525751, 130, '2014-02-01 00:57:00.000000', 'consum', 0.0210, 'lps'),
	(525752, 130, '2014-02-01 00:57:01.000000', 'consum', 0.0225, 'lps'),
	(525753, 130, '2014-02-01 00:57:02.000000', 'consum', 0.0212, 'lps'),
	(525754, 130, '2014-02-01 00:57:03.000000', 'consum', 0.0214, 'lps'),
	(525755, 130, '2014-02-01 00:57:04.000000', 'consum', 0.0225, 'lps'),
	(525756, 130, '2014-02-01 00:57:05.000000', 'consum', 0.0220, 'lps'),
	(525757, 130, '2014-02-01 00:57:06.000000', 'consum', 0.0215, 'lps'),
	(525758, 130, '2014-02-01 00:57:07.000000', 'consum', 0.0222, 'lps'),
	(525759, 130, '2014-02-01 00:57:08.000000', 'consum', 0.0220, 'lps'),
	(525760, 130, '2014-02-01 00:57:09.000000', 'consum', 0.0225, 'lps'),
	(525761, 130, '2014-02-01 00:57:10.000000', 'consum', 0.0221, 'lps'),
	(525762, 130, '2014-02-01 00:57:11.000000', 'consum', 0.0220, 'lps'),
	(525763, 130, '2014-02-01 00:57:12.000000', 'consum', 0.0225, 'lps'),
	(525764, 130, '2014-02-01 00:57:13.000000', 'consum', 0.0221, 'lps'),
	(525765, 130, '2014-02-01 00:57:14.000000', 'consum', 0.0220, 'lps'),
	(525766, 130, '2014-02-01 00:57:15.000000', 'consum', 0.0226, 'lps'),
	(525767, 130, '2014-02-01 00:57:16.000000', 'consum', 0.0225, 'lps'),
	(525768, 130, '2014-02-01 00:57:17.000000', 'consum', 0.0219, 'lps'),
	(525769, 130, '2014-02-01 00:57:18.000000', 'consum', 0.0211, 'lps'),
	(525770, 130, '2014-02-01 00:57:19.000000', 'consum', 0.0225, 'lps'),
	(525771, 130, '2014-02-01 00:57:20.000000', 'consum', 0.0227, 'lps'),
	(525772, 130, '2014-02-01 00:57:21.000000', 'consum', 0.0214, 'lps'),
	(525773, 130, '2014-02-01 00:57:22.000000', 'consum', 0.0215, 'lps'),
	(525774, 130, '2014-02-01 00:57:23.000000', 'consum', 0.0223, 'lps'),
	(525775, 130, '2014-02-01 00:57:24.000000', 'consum', 0.0225, 'lps'),
	(525776, 130, '2014-02-01 00:57:25.000000', 'consum', 0.0210, 'lps'),
	(525777, 130, '2014-02-01 00:57:26.000000', 'consum', 0.0218, 'lps'),
	(525778, 130, '2014-02-01 00:57:27.000000', 'consum', 0.0216, 'lps'),
	(525779, 130, '2014-02-01 00:57:28.000000', 'consum', 0.0217, 'lps'),
	(525780, 130, '2014-02-01 00:57:29.000000', 'consum', 0.0210, 'lps'),
	(525781, 130, '2014-02-01 00:57:30.000000', 'consum', 0.0226, 'lps'),
	(525782, 130, '2014-02-01 00:57:31.000000', 'consum', 0.0218, 'lps'),
	(525783, 130, '2014-02-01 00:57:32.000000', 'consum', 0.0219, 'lps'),
	(525784, 130, '2014-02-01 00:57:33.000000', 'consum', 0.0215, 'lps'),
	(525785, 130, '2014-02-01 00:57:34.000000', 'consum', 0.0226, 'lps'),
	(525786, 130, '2014-02-01 00:57:35.000000', 'consum', 0.0223, 'lps'),
	(525787, 130, '2014-02-01 00:57:36.000000', 'consum', 0.0225, 'lps'),
	(525788, 130, '2014-02-01 00:57:37.000000', 'consum', 0.0214, 'lps'),
	(525789, 130, '2014-02-01 00:57:38.000000', 'consum', 0.0218, 'lps'),
	(525790, 130, '2014-02-01 00:57:39.000000', 'consum', 0.0222, 'lps'),
	(525791, 130, '2014-02-01 00:57:40.000000', 'consum', 0.0211, 'lps'),
	(525792, 130, '2014-02-01 00:57:41.000000', 'consum', 0.0217, 'lps'),
	(525793, 130, '2014-02-01 00:57:42.000000', 'consum', 0.0223, 'lps'),
	(525794, 130, '2014-02-01 00:57:43.000000', 'consum', 0.0218, 'lps'),
	(525795, 130, '2014-02-01 00:57:44.000000', 'consum', 0.0211, 'lps'),
	(525796, 130, '2014-02-01 00:57:45.000000', 'consum', 0.0210, 'lps'),
	(525797, 130, '2014-02-01 00:57:46.000000', 'consum', 0.0210, 'lps'),
	(525798, 130, '2014-02-01 00:57:47.000000', 'consum', 0.0225, 'lps'),
	(525799, 130, '2014-02-01 00:57:48.000000', 'consum', 0.0215, 'lps'),
	(525800, 130, '2014-02-01 00:57:49.000000', 'consum', 0.0227, 'lps'),
	(525801, 130, '2014-02-01 00:57:50.000000', 'consum', 0.0225, 'lps'),
	(525802, 130, '2014-02-01 00:57:51.000000', 'consum', 0.0219, 'lps'),
	(525803, 130, '2014-02-01 00:57:52.000000', 'consum', 0.0227, 'lps'),
	(525804, 130, '2014-02-01 00:57:53.000000', 'consum', 0.0215, 'lps'),
	(525805, 130, '2014-02-01 00:57:54.000000', 'consum', 0.0221, 'lps'),
	(525806, 130, '2014-02-01 00:57:55.000000', 'consum', 0.0212, 'lps'),
	(525807, 130, '2014-02-01 00:57:56.000000', 'consum', 0.0226, 'lps'),
	(525808, 130, '2014-02-01 00:57:57.000000', 'consum', 0.0214, 'lps'),
	(525809, 130, '2014-02-01 00:57:58.000000', 'consum', 0.0216, 'lps'),
	(525810, 130, '2014-02-01 00:57:59.000000', 'consum', 0.0212, 'lps'),
	(525811, 130, '2014-02-01 00:58:00.000000', 'consum', 0.0219, 'lps'),
	(525812, 130, '2014-02-01 00:58:01.000000', 'consum', 0.0215, 'lps'),
	(525813, 130, '2014-02-01 00:58:02.000000', 'consum', 0.0225, 'lps'),
	(525814, 130, '2014-02-01 00:58:03.000000', 'consum', 0.0219, 'lps'),
	(525815, 130, '2014-02-01 00:58:04.000000', 'consum', 0.0226, 'lps'),
	(525816, 130, '2014-02-01 00:58:05.000000', 'consum', 0.0210, 'lps'),
	(525817, 130, '2014-02-01 00:58:06.000000', 'consum', 0.0216, 'lps'),
	(525818, 130, '2014-02-01 00:58:07.000000', 'consum', 0.0222, 'lps'),
	(525819, 130, '2014-02-01 00:58:08.000000', 'consum', 0.0219, 'lps'),
	(525820, 130, '2014-02-01 00:58:09.000000', 'consum', 0.0217, 'lps'),
	(525821, 130, '2014-02-01 00:58:10.000000', 'consum', 0.0217, 'lps'),
	(525822, 130, '2014-02-01 00:58:11.000000', 'consum', 0.0210, 'lps'),
	(525823, 130, '2014-02-01 00:58:12.000000', 'consum', 0.0225, 'lps'),
	(525824, 130, '2014-02-01 00:58:13.000000', 'consum', 0.0214, 'lps'),
	(525825, 130, '2014-02-01 00:58:14.000000', 'consum', 0.0219, 'lps'),
	(525826, 130, '2014-02-01 00:58:15.000000', 'consum', 0.0210, 'lps'),
	(525827, 130, '2014-02-01 00:58:16.000000', 'consum', 0.0217, 'lps'),
	(525828, 130, '2014-02-01 00:58:17.000000', 'consum', 0.0227, 'lps'),
	(525829, 130, '2014-02-01 00:58:18.000000', 'consum', 0.0221, 'lps'),
	(525830, 130, '2014-02-01 00:58:19.000000', 'consum', 0.0215, 'lps'),
	(525831, 130, '2014-02-01 00:58:20.000000', 'consum', 0.0223, 'lps'),
	(525832, 130, '2014-02-01 00:58:21.000000', 'consum', 0.0221, 'lps'),
	(525833, 130, '2014-02-01 00:58:22.000000', 'consum', 0.0210, 'lps'),
	(525834, 130, '2014-02-01 00:58:23.000000', 'consum', 0.0212, 'lps'),
	(525835, 130, '2014-02-01 00:58:24.000000', 'consum', 0.0222, 'lps'),
	(525836, 130, '2014-02-01 00:58:25.000000', 'consum', 0.0212, 'lps'),
	(525837, 130, '2014-02-01 00:58:26.000000', 'consum', 0.0219, 'lps'),
	(525838, 130, '2014-02-01 00:58:27.000000', 'consum', 0.0214, 'lps'),
	(525839, 130, '2014-02-01 00:58:28.000000', 'consum', 0.0220, 'lps'),
	(525840, 130, '2014-02-01 00:58:29.000000', 'consum', 0.0214, 'lps'),
	(525841, 130, '2014-02-01 00:58:30.000000', 'consum', 0.0219, 'lps'),
	(525842, 130, '2014-02-01 00:58:31.000000', 'consum', 0.0223, 'lps'),
	(525843, 130, '2014-02-01 00:58:32.000000', 'consum', 0.0215, 'lps'),
	(525844, 130, '2014-02-01 00:58:33.000000', 'consum', 0.0215, 'lps'),
	(525845, 130, '2014-02-01 00:58:34.000000', 'consum', 0.0221, 'lps'),
	(525846, 130, '2014-02-01 00:58:35.000000', 'consum', 0.0215, 'lps'),
	(525847, 130, '2014-02-01 00:58:36.000000', 'consum', 0.0219, 'lps'),
	(525848, 130, '2014-02-01 00:58:37.000000', 'consum', 0.0222, 'lps'),
	(525849, 130, '2014-02-01 00:58:38.000000', 'consum', 0.0227, 'lps'),
	(525850, 130, '2014-02-01 00:58:39.000000', 'consum', 0.0224, 'lps'),
	(525851, 130, '2014-02-01 00:58:40.000000', 'consum', 0.0227, 'lps'),
	(525852, 130, '2014-02-01 00:58:41.000000', 'consum', 0.0221, 'lps'),
	(525853, 130, '2014-02-01 00:58:42.000000', 'consum', 0.0211, 'lps'),
	(525854, 130, '2014-02-01 00:58:43.000000', 'consum', 0.0221, 'lps'),
	(525855, 130, '2014-02-01 00:58:44.000000', 'consum', 0.0226, 'lps'),
	(525856, 130, '2014-02-01 00:58:45.000000', 'consum', 0.0219, 'lps'),
	(525857, 130, '2014-02-01 00:58:46.000000', 'consum', 0.0210, 'lps'),
	(525858, 130, '2014-02-01 00:58:47.000000', 'consum', 0.0219, 'lps'),
	(525859, 130, '2014-02-01 00:58:48.000000', 'consum', 0.0221, 'lps'),
	(525860, 130, '2014-02-01 00:58:49.000000', 'consum', 0.0219, 'lps'),
	(525861, 130, '2014-02-01 00:58:50.000000', 'consum', 0.0222, 'lps'),
	(525862, 130, '2014-02-01 00:58:51.000000', 'consum', 0.0225, 'lps'),
	(525863, 130, '2014-02-01 00:58:52.000000', 'consum', 0.0213, 'lps'),
	(525864, 130, '2014-02-01 00:58:53.000000', 'consum', 0.0219, 'lps'),
	(525865, 130, '2014-02-01 00:58:54.000000', 'consum', 0.0227, 'lps'),
	(525866, 130, '2014-02-01 00:58:55.000000', 'consum', 0.0215, 'lps'),
	(525867, 130, '2014-02-01 00:58:56.000000', 'consum', 0.0221, 'lps'),
	(525868, 130, '2014-02-01 00:58:57.000000', 'consum', 0.0216, 'lps'),
	(525869, 130, '2014-02-01 00:58:58.000000', 'consum', 0.0222, 'lps'),
	(525870, 130, '2014-02-01 00:58:59.000000', 'consum', 0.0219, 'lps'),
	(525871, 130, '2014-02-01 00:59:00.000000', 'consum', 0.0217, 'lps'),
	(525872, 130, '2014-02-01 00:59:01.000000', 'consum', 0.0220, 'lps'),
	(525873, 130, '2014-02-01 00:59:02.000000', 'consum', 0.0221, 'lps'),
	(525874, 130, '2014-02-01 00:59:03.000000', 'consum', 0.0217, 'lps'),
	(525875, 130, '2014-02-01 00:59:04.000000', 'consum', 0.0213, 'lps'),
	(525876, 130, '2014-02-01 00:59:05.000000', 'consum', 0.0223, 'lps'),
	(525877, 130, '2014-02-01 00:59:06.000000', 'consum', 0.0211, 'lps'),
	(525878, 130, '2014-02-01 00:59:07.000000', 'consum', 0.0213, 'lps'),
	(525879, 130, '2014-02-01 00:59:08.000000', 'consum', 0.0221, 'lps'),
	(525880, 130, '2014-02-01 00:59:09.000000', 'consum', 0.0221, 'lps'),
	(525881, 130, '2014-02-01 00:59:10.000000', 'consum', 0.0216, 'lps'),
	(525882, 130, '2014-02-01 00:59:11.000000', 'consum', 0.0224, 'lps'),
	(525883, 130, '2014-02-01 00:59:12.000000', 'consum', 0.0210, 'lps'),
	(525884, 130, '2014-02-01 00:59:13.000000', 'consum', 0.0223, 'lps'),
	(525885, 130, '2014-02-01 00:59:14.000000', 'consum', 0.0222, 'lps'),
	(525886, 130, '2014-02-01 00:59:15.000000', 'consum', 0.0214, 'lps'),
	(525887, 130, '2014-02-01 00:59:16.000000', 'consum', 0.0212, 'lps'),
	(525888, 130, '2014-02-01 00:59:17.000000', 'consum', 0.0210, 'lps'),
	(525889, 130, '2014-02-01 00:59:18.000000', 'consum', 0.0221, 'lps'),
	(525890, 130, '2014-02-01 00:59:19.000000', 'consum', 0.0211, 'lps'),
	(525891, 130, '2014-02-01 00:59:20.000000', 'consum', 0.0221, 'lps'),
	(525892, 130, '2014-02-01 00:59:21.000000', 'consum', 0.0224, 'lps'),
	(525893, 130, '2014-02-01 00:59:22.000000', 'consum', 0.0213, 'lps'),
	(525894, 130, '2014-02-01 00:59:23.000000', 'consum', 0.0217, 'lps'),
	(525895, 130, '2014-02-01 00:59:24.000000', 'consum', 0.0219, 'lps'),
	(525896, 130, '2014-02-01 00:59:25.000000', 'consum', 0.0219, 'lps'),
	(525897, 130, '2014-02-01 00:59:26.000000', 'consum', 0.0226, 'lps'),
	(525898, 130, '2014-02-01 00:59:27.000000', 'consum', 0.0212, 'lps'),
	(525899, 130, '2014-02-01 00:59:28.000000', 'consum', 0.0227, 'lps'),
	(525900, 130, '2014-02-01 00:59:29.000000', 'consum', 0.0218, 'lps'),
	(525901, 130, '2014-02-01 00:59:30.000000', 'consum', 0.0216, 'lps'),
	(525902, 130, '2014-02-01 00:59:31.000000', 'consum', 0.0216, 'lps'),
	(525903, 130, '2014-02-01 00:59:32.000000', 'consum', 0.0224, 'lps'),
	(525904, 130, '2014-02-01 00:59:33.000000', 'consum', 0.0224, 'lps'),
	(525905, 130, '2014-02-01 00:59:34.000000', 'consum', 0.0224, 'lps'),
	(525906, 130, '2014-02-01 00:59:35.000000', 'consum', 0.0217, 'lps'),
	(525907, 130, '2014-02-01 00:59:36.000000', 'consum', 0.0223, 'lps'),
	(525908, 130, '2014-02-01 00:59:37.000000', 'consum', 0.0219, 'lps'),
	(525909, 130, '2014-02-01 00:59:38.000000', 'consum', 0.0214, 'lps'),
	(525910, 130, '2014-02-01 00:59:39.000000', 'consum', 0.0223, 'lps'),
	(525911, 130, '2014-02-01 00:59:40.000000', 'consum', 0.0227, 'lps'),
	(525912, 130, '2014-02-01 00:59:41.000000', 'consum', 0.0220, 'lps'),
	(525913, 130, '2014-02-01 00:59:42.000000', 'consum', 0.0227, 'lps'),
	(525914, 130, '2014-02-01 00:59:43.000000', 'consum', 0.0212, 'lps'),
	(525915, 130, '2014-02-01 00:59:44.000000', 'consum', 0.0222, 'lps'),
	(525916, 130, '2014-02-01 00:59:45.000000', 'consum', 0.0211, 'lps'),
	(525917, 130, '2014-02-01 00:59:46.000000', 'consum', 0.0216, 'lps'),
	(525918, 130, '2014-02-01 00:59:47.000000', 'consum', 0.0219, 'lps'),
	(525919, 130, '2014-02-01 00:59:48.000000', 'consum', 0.0221, 'lps'),
	(525920, 130, '2014-02-01 00:59:49.000000', 'consum', 0.0219, 'lps'),
	(525921, 130, '2014-02-01 00:59:50.000000', 'consum', 0.0222, 'lps'),
	(525922, 130, '2014-02-01 00:59:51.000000', 'consum', 0.0227, 'lps'),
	(525923, 130, '2014-02-01 00:59:52.000000', 'consum', 0.0224, 'lps'),
	(525924, 130, '2014-02-01 00:59:53.000000', 'consum', 0.0210, 'lps'),
	(525925, 130, '2014-02-01 00:59:54.000000', 'consum', 0.0222, 'lps'),
	(525926, 130, '2014-02-01 00:59:55.000000', 'consum', 0.0215, 'lps'),
	(525927, 130, '2014-02-01 00:59:56.000000', 'consum', 0.0220, 'lps'),
	(525928, 130, '2014-02-01 00:59:57.000000', 'consum', 0.0211, 'lps'),
	(525929, 130, '2014-02-01 00:59:58.000000', 'consum', 0.0219, 'lps'),
	(525930, 130, '2014-02-01 00:59:59.000000', 'consum', 0.0217, 'lps'),
	(525931, 130, '2014-02-01 01:00:00.000000', 'consum', 0.0220, 'lps'),
	(525932, 130, '2014-02-01 01:00:01.000000', 'consum', 0.0218, 'lps'),
	(525933, 130, '2014-02-01 01:00:02.000000', 'consum', 0.0224, 'lps'),
	(525934, 130, '2014-02-01 01:00:03.000000', 'consum', 0.0219, 'lps'),
	(525935, 130, '2014-02-01 01:00:04.000000', 'consum', 0.0215, 'lps'),
	(525936, 130, '2014-02-01 01:00:05.000000', 'consum', 0.0225, 'lps'),
	(525937, 130, '2014-02-01 01:00:06.000000', 'consum', 0.0218, 'lps'),
	(525938, 130, '2014-02-01 01:00:07.000000', 'consum', 0.0223, 'lps'),
	(525939, 130, '2014-02-01 01:00:08.000000', 'consum', 0.0216, 'lps'),
	(525940, 130, '2014-02-01 01:00:09.000000', 'consum', 0.0220, 'lps'),
	(525941, 130, '2014-02-01 01:00:10.000000', 'consum', 0.0222, 'lps'),
	(525942, 130, '2014-02-01 01:00:11.000000', 'consum', 0.0222, 'lps'),
	(525943, 130, '2014-02-01 01:00:12.000000', 'consum', 0.0219, 'lps'),
	(525944, 130, '2014-02-01 01:00:13.000000', 'consum', 0.0221, 'lps'),
	(525945, 130, '2014-02-01 01:00:14.000000', 'consum', 0.0218, 'lps'),
	(525946, 130, '2014-02-01 01:00:15.000000', 'consum', 0.0217, 'lps'),
	(525947, 130, '2014-02-01 01:00:16.000000', 'consum', 0.0222, 'lps'),
	(525948, 130, '2014-02-01 01:00:17.000000', 'consum', 0.0214, 'lps'),
	(525949, 130, '2014-02-01 01:00:18.000000', 'consum', 0.0212, 'lps'),
	(525950, 130, '2014-02-01 01:00:19.000000', 'consum', 0.0210, 'lps'),
	(525951, 130, '2014-02-01 01:00:20.000000', 'consum', 0.0221, 'lps'),
	(525952, 130, '2014-02-01 01:00:21.000000', 'consum', 0.0214, 'lps'),
	(525953, 130, '2014-02-01 01:00:22.000000', 'consum', 0.0212, 'lps'),
	(525954, 130, '2014-02-01 01:00:23.000000', 'consum', 0.0211, 'lps'),
	(525955, 130, '2014-02-01 01:00:24.000000', 'consum', 0.0226, 'lps'),
	(525956, 130, '2014-02-01 01:00:25.000000', 'consum', 0.0217, 'lps'),
	(525957, 130, '2014-02-01 01:00:26.000000', 'consum', 0.0214, 'lps'),
	(525958, 130, '2014-02-01 01:00:27.000000', 'consum', 0.0226, 'lps'),
	(525959, 130, '2014-02-01 01:00:28.000000', 'consum', 0.0226, 'lps'),
	(525960, 130, '2014-02-01 01:00:29.000000', 'consum', 0.0225, 'lps'),
	(525961, 130, '2014-02-01 01:00:30.000000', 'consum', 0.0218, 'lps'),
	(525962, 130, '2014-02-01 01:00:31.000000', 'consum', 0.0225, 'lps'),
	(525963, 130, '2014-02-01 01:00:32.000000', 'consum', 0.0226, 'lps'),
	(525964, 130, '2014-02-01 01:00:33.000000', 'consum', 0.0227, 'lps'),
	(525965, 130, '2014-02-01 01:00:34.000000', 'consum', 0.0211, 'lps'),
	(525966, 130, '2014-02-01 01:00:35.000000', 'consum', 0.0220, 'lps'),
	(525967, 130, '2014-02-01 01:00:36.000000', 'consum', 0.0222, 'lps'),
	(525968, 130, '2014-02-01 01:00:37.000000', 'consum', 0.0222, 'lps'),
	(525969, 130, '2014-02-01 01:00:38.000000', 'consum', 0.0216, 'lps'),
	(525970, 130, '2014-02-01 01:00:39.000000', 'consum', 0.0223, 'lps'),
	(525971, 130, '2014-02-01 01:00:40.000000', 'consum', 0.0221, 'lps'),
	(525972, 130, '2014-02-01 01:00:41.000000', 'consum', 0.0225, 'lps'),
	(525973, 130, '2014-02-01 01:00:42.000000', 'consum', 0.0219, 'lps'),
	(525974, 130, '2014-02-01 01:00:43.000000', 'consum', 0.0227, 'lps'),
	(525975, 130, '2014-02-01 01:00:44.000000', 'consum', 0.0213, 'lps'),
	(525976, 130, '2014-02-01 01:00:45.000000', 'consum', 0.0211, 'lps'),
	(525977, 130, '2014-02-01 01:00:46.000000', 'consum', 0.0226, 'lps'),
	(525978, 130, '2014-02-01 01:00:47.000000', 'consum', 0.0213, 'lps'),
	(525979, 130, '2014-02-01 01:00:48.000000', 'consum', 0.0214, 'lps'),
	(525980, 130, '2014-02-01 01:00:49.000000', 'consum', 0.0224, 'lps'),
	(525981, 130, '2014-02-01 01:00:50.000000', 'consum', 0.0211, 'lps'),
	(525982, 130, '2014-02-01 01:00:51.000000', 'consum', 0.0211, 'lps'),
	(525983, 130, '2014-02-01 01:00:52.000000', 'consum', 0.0213, 'lps'),
	(525984, 130, '2014-02-01 01:00:53.000000', 'consum', 0.0224, 'lps'),
	(525985, 130, '2014-02-01 01:00:54.000000', 'consum', 0.0217, 'lps'),
	(525986, 130, '2014-02-01 01:00:55.000000', 'consum', 0.0222, 'lps'),
	(525987, 130, '2014-02-01 01:00:56.000000', 'consum', 0.0213, 'lps'),
	(525988, 130, '2014-02-01 01:00:57.000000', 'consum', 0.0225, 'lps'),
	(525989, 130, '2014-02-01 01:00:58.000000', 'consum', 0.0223, 'lps'),
	(525990, 130, '2014-02-01 01:00:59.000000', 'consum', 0.0213, 'lps'),
	(525991, 130, '2014-02-01 01:01:00.000000', 'consum', 0.0221, 'lps'),
	(525992, 130, '2014-02-01 01:01:01.000000', 'consum', 0.0222, 'lps'),
	(525993, 130, '2014-02-01 01:01:02.000000', 'consum', 0.0221, 'lps'),
	(525994, 130, '2014-02-01 01:01:03.000000', 'consum', 0.0227, 'lps'),
	(525995, 130, '2014-02-01 01:01:04.000000', 'consum', 0.0226, 'lps'),
	(525996, 130, '2014-02-01 01:01:05.000000', 'consum', 0.0224, 'lps'),
	(525997, 130, '2014-02-01 01:01:06.000000', 'consum', 0.0215, 'lps'),
	(525998, 130, '2014-02-01 01:01:07.000000', 'consum', 0.0226, 'lps'),
	(525999, 130, '2014-02-01 01:01:08.000000', 'consum', 0.0225, 'lps'),
	(526000, 130, '2014-02-01 01:01:09.000000', 'consum', 0.0217, 'lps'),
	(526001, 130, '2014-02-01 01:01:10.000000', 'consum', 0.0221, 'lps'),
	(526002, 130, '2014-02-01 01:01:11.000000', 'consum', 0.0227, 'lps'),
	(526003, 130, '2014-02-01 01:01:12.000000', 'consum', 0.0226, 'lps'),
	(526004, 130, '2014-02-01 01:01:13.000000', 'consum', 0.0223, 'lps'),
	(526005, 130, '2014-02-01 01:01:14.000000', 'consum', 0.0226, 'lps'),
	(526006, 130, '2014-02-01 01:01:15.000000', 'consum', 0.0215, 'lps'),
	(526007, 130, '2014-02-01 01:01:16.000000', 'consum', 0.0224, 'lps'),
	(526008, 130, '2014-02-01 01:01:17.000000', 'consum', 0.0211, 'lps'),
	(526009, 130, '2014-02-01 01:01:18.000000', 'consum', 0.0210, 'lps'),
	(526010, 130, '2014-02-01 01:01:19.000000', 'consum', 0.0226, 'lps'),
	(526011, 130, '2014-02-01 01:01:20.000000', 'consum', 0.0219, 'lps'),
	(526012, 130, '2014-02-01 01:01:21.000000', 'consum', 0.0224, 'lps'),
	(526013, 130, '2014-02-01 01:01:22.000000', 'consum', 0.0220, 'lps'),
	(526014, 130, '2014-02-01 01:01:23.000000', 'consum', 0.0217, 'lps'),
	(526015, 130, '2014-02-01 01:01:24.000000', 'consum', 0.0215, 'lps'),
	(526016, 130, '2014-02-01 01:01:25.000000', 'consum', 0.0215, 'lps'),
	(526017, 130, '2014-02-01 01:01:26.000000', 'consum', 0.0219, 'lps'),
	(526018, 130, '2014-02-01 01:01:27.000000', 'consum', 0.0223, 'lps'),
	(526019, 130, '2014-02-01 01:01:28.000000', 'consum', 0.0212, 'lps'),
	(526020, 130, '2014-02-01 01:01:29.000000', 'consum', 0.0217, 'lps'),
	(526021, 130, '2014-02-01 01:01:30.000000', 'consum', 0.0223, 'lps'),
	(526022, 130, '2014-02-01 01:01:31.000000', 'consum', 0.0216, 'lps'),
	(526023, 130, '2014-02-01 01:01:32.000000', 'consum', 0.0220, 'lps'),
	(526024, 130, '2014-02-01 01:01:33.000000', 'consum', 0.0227, 'lps'),
	(526025, 130, '2014-02-01 01:01:34.000000', 'consum', 0.0226, 'lps'),
	(526026, 130, '2014-02-01 01:01:35.000000', 'consum', 0.0225, 'lps'),
	(526027, 130, '2014-02-01 01:01:36.000000', 'consum', 0.0217, 'lps'),
	(526028, 130, '2014-02-01 01:01:37.000000', 'consum', 0.0218, 'lps'),
	(526029, 130, '2014-02-01 01:01:38.000000', 'consum', 0.0212, 'lps'),
	(526030, 130, '2014-02-01 01:01:39.000000', 'consum', 0.0213, 'lps'),
	(526031, 130, '2014-02-01 01:01:40.000000', 'consum', 0.0222, 'lps'),
	(526032, 130, '2014-02-01 01:01:41.000000', 'consum', 0.0225, 'lps'),
	(526033, 130, '2014-02-01 01:01:42.000000', 'consum', 0.0213, 'lps'),
	(526034, 130, '2014-02-01 01:01:43.000000', 'consum', 0.0216, 'lps'),
	(526035, 130, '2014-02-01 01:01:44.000000', 'consum', 0.0214, 'lps'),
	(526036, 130, '2014-02-01 01:01:45.000000', 'consum', 0.0211, 'lps'),
	(526037, 130, '2014-02-01 01:01:46.000000', 'consum', 0.0223, 'lps'),
	(526038, 130, '2014-02-01 01:01:47.000000', 'consum', 0.0217, 'lps'),
	(526039, 130, '2014-02-01 01:01:48.000000', 'consum', 0.0225, 'lps'),
	(526040, 130, '2014-02-01 01:01:49.000000', 'consum', 0.0211, 'lps'),
	(526041, 130, '2014-02-01 01:01:50.000000', 'consum', 0.0223, 'lps'),
	(526042, 130, '2014-02-01 01:01:51.000000', 'consum', 0.0222, 'lps'),
	(526043, 130, '2014-02-01 01:01:52.000000', 'consum', 0.0210, 'lps'),
	(526044, 130, '2014-02-01 01:01:53.000000', 'consum', 0.0211, 'lps'),
	(526045, 130, '2014-02-01 01:01:54.000000', 'consum', 0.0215, 'lps'),
	(526046, 130, '2014-02-01 01:01:55.000000', 'consum', 0.0214, 'lps'),
	(526047, 130, '2014-02-01 01:01:56.000000', 'consum', 0.0216, 'lps'),
	(526048, 130, '2014-02-01 01:01:57.000000', 'consum', 0.0210, 'lps'),
	(526049, 130, '2014-02-01 01:01:58.000000', 'consum', 0.0213, 'lps'),
	(526050, 130, '2014-02-01 01:01:59.000000', 'consum', 0.0224, 'lps'),
	(526051, 130, '2014-02-01 01:02:00.000000', 'consum', 0.0217, 'lps'),
	(526052, 130, '2014-02-01 01:02:01.000000', 'consum', 0.0220, 'lps'),
	(526053, 130, '2014-02-01 01:02:02.000000', 'consum', 0.0223, 'lps'),
	(526054, 130, '2014-02-01 01:02:03.000000', 'consum', 0.0226, 'lps'),
	(526055, 130, '2014-02-01 01:02:04.000000', 'consum', 0.0218, 'lps'),
	(526056, 130, '2014-02-01 01:02:05.000000', 'consum', 0.0218, 'lps'),
	(526057, 130, '2014-02-01 01:02:06.000000', 'consum', 0.0226, 'lps'),
	(526058, 130, '2014-02-01 01:02:07.000000', 'consum', 0.0212, 'lps'),
	(526059, 130, '2014-02-01 01:02:08.000000', 'consum', 0.0210, 'lps'),
	(526060, 130, '2014-02-01 01:02:09.000000', 'consum', 0.0223, 'lps'),
	(526061, 130, '2014-02-01 01:02:10.000000', 'consum', 0.0222, 'lps'),
	(526062, 130, '2014-02-01 01:02:11.000000', 'consum', 0.0214, 'lps'),
	(526063, 130, '2014-02-01 01:02:12.000000', 'consum', 0.0210, 'lps'),
	(526064, 130, '2014-02-01 01:02:13.000000', 'consum', 0.0218, 'lps'),
	(526065, 130, '2014-02-01 01:02:14.000000', 'consum', 0.0216, 'lps'),
	(526066, 130, '2014-02-01 01:02:15.000000', 'consum', 0.0214, 'lps'),
	(526067, 130, '2014-02-01 01:02:16.000000', 'consum', 0.0212, 'lps'),
	(526068, 130, '2014-02-01 01:02:17.000000', 'consum', 0.0211, 'lps'),
	(526069, 130, '2014-02-01 01:02:18.000000', 'consum', 0.0225, 'lps'),
	(526070, 130, '2014-02-01 01:02:19.000000', 'consum', 0.0211, 'lps'),
	(526071, 130, '2014-02-01 01:02:20.000000', 'consum', 0.0223, 'lps'),
	(526072, 130, '2014-02-01 01:02:21.000000', 'consum', 0.0219, 'lps'),
	(526073, 130, '2014-02-01 01:02:22.000000', 'consum', 0.0219, 'lps'),
	(526074, 130, '2014-02-01 01:02:23.000000', 'consum', 0.0225, 'lps'),
	(526075, 130, '2014-02-01 01:02:24.000000', 'consum', 0.0226, 'lps'),
	(526076, 130, '2014-02-01 01:02:25.000000', 'consum', 0.0224, 'lps'),
	(526077, 130, '2014-02-01 01:02:26.000000', 'consum', 0.0218, 'lps'),
	(526078, 130, '2014-02-01 01:02:27.000000', 'consum', 0.0224, 'lps'),
	(526079, 130, '2014-02-01 01:02:28.000000', 'consum', 0.0221, 'lps'),
	(526080, 130, '2014-02-01 01:02:29.000000', 'consum', 0.0225, 'lps'),
	(526081, 130, '2014-02-01 01:02:30.000000', 'consum', 0.0214, 'lps'),
	(526082, 130, '2014-02-01 01:02:31.000000', 'consum', 0.0222, 'lps'),
	(526083, 130, '2014-02-01 01:02:32.000000', 'consum', 0.0224, 'lps'),
	(526084, 130, '2014-02-01 01:02:33.000000', 'consum', 0.0224, 'lps'),
	(526085, 130, '2014-02-01 01:02:34.000000', 'consum', 0.0220, 'lps'),
	(526086, 130, '2014-02-01 01:02:35.000000', 'consum', 0.0221, 'lps'),
	(526087, 130, '2014-02-01 01:02:36.000000', 'consum', 0.0218, 'lps'),
	(526088, 130, '2014-02-01 01:02:37.000000', 'consum', 0.0215, 'lps'),
	(526089, 130, '2014-02-01 01:02:38.000000', 'consum', 0.0214, 'lps'),
	(526090, 130, '2014-02-01 01:02:39.000000', 'consum', 0.0213, 'lps'),
	(526091, 130, '2014-02-01 01:02:40.000000', 'consum', 0.0213, 'lps'),
	(526092, 130, '2014-02-01 01:02:41.000000', 'consum', 0.0216, 'lps'),
	(526093, 130, '2014-02-01 01:02:42.000000', 'consum', 0.0214, 'lps'),
	(526094, 130, '2014-02-01 01:02:43.000000', 'consum', 0.0211, 'lps'),
	(526095, 130, '2014-02-01 01:02:44.000000', 'consum', 0.0225, 'lps'),
	(526096, 130, '2014-02-01 01:02:45.000000', 'consum', 0.0225, 'lps'),
	(526097, 130, '2014-02-01 01:02:46.000000', 'consum', 0.0224, 'lps'),
	(526098, 130, '2014-02-01 01:02:47.000000', 'consum', 0.0217, 'lps'),
	(526099, 130, '2014-02-01 01:02:48.000000', 'consum', 0.0223, 'lps'),
	(526100, 130, '2014-02-01 01:02:49.000000', 'consum', 0.0220, 'lps'),
	(526101, 130, '2014-02-01 01:02:50.000000', 'consum', 0.0218, 'lps'),
	(526102, 130, '2014-02-01 01:02:51.000000', 'consum', 0.0221, 'lps'),
	(526103, 130, '2014-02-01 01:02:52.000000', 'consum', 0.0226, 'lps'),
	(526104, 130, '2014-02-01 01:02:53.000000', 'consum', 0.0219, 'lps'),
	(526105, 130, '2014-02-01 01:02:54.000000', 'consum', 0.0227, 'lps'),
	(526106, 130, '2014-02-01 01:02:55.000000', 'consum', 0.0215, 'lps'),
	(526107, 130, '2014-02-01 01:02:56.000000', 'consum', 0.0221, 'lps'),
	(526108, 130, '2014-02-01 01:02:57.000000', 'consum', 0.0215, 'lps'),
	(526109, 130, '2014-02-01 01:02:58.000000', 'consum', 0.0218, 'lps'),
	(526110, 130, '2014-02-01 01:02:59.000000', 'consum', 0.0220, 'lps'),
	(526111, 130, '2014-02-01 01:03:00.000000', 'consum', 0.0219, 'lps'),
	(526112, 130, '2014-02-01 01:03:01.000000', 'consum', 0.0226, 'lps'),
	(526113, 130, '2014-02-01 01:03:02.000000', 'consum', 0.0225, 'lps'),
	(526114, 130, '2014-02-01 01:03:03.000000', 'consum', 0.0220, 'lps'),
	(526115, 130, '2014-02-01 01:03:04.000000', 'consum', 0.0218, 'lps'),
	(526116, 130, '2014-02-01 01:03:05.000000', 'consum', 0.0218, 'lps'),
	(526117, 130, '2014-02-01 01:03:06.000000', 'consum', 0.0227, 'lps'),
	(526118, 130, '2014-02-01 01:03:07.000000', 'consum', 0.0219, 'lps'),
	(526119, 130, '2014-02-01 01:03:08.000000', 'consum', 0.0219, 'lps'),
	(526120, 130, '2014-02-01 01:03:09.000000', 'consum', 0.0214, 'lps'),
	(526121, 130, '2014-02-01 01:03:10.000000', 'consum', 0.0222, 'lps'),
	(526122, 130, '2014-02-01 01:03:11.000000', 'consum', 0.0221, 'lps'),
	(526123, 130, '2014-02-01 01:03:12.000000', 'consum', 0.0212, 'lps'),
	(526124, 130, '2014-02-01 01:03:13.000000', 'consum', 0.0221, 'lps'),
	(526125, 130, '2014-02-01 01:03:14.000000', 'consum', 0.0227, 'lps'),
	(526126, 130, '2014-02-01 01:03:15.000000', 'consum', 0.0223, 'lps'),
	(526127, 130, '2014-02-01 01:03:16.000000', 'consum', 0.0210, 'lps'),
	(526128, 130, '2014-02-01 01:03:17.000000', 'consum', 0.0224, 'lps'),
	(526129, 130, '2014-02-01 01:03:18.000000', 'consum', 0.0210, 'lps'),
	(526130, 130, '2014-02-01 01:03:19.000000', 'consum', 0.0222, 'lps'),
	(526131, 130, '2014-02-01 01:03:20.000000', 'consum', 0.0217, 'lps'),
	(526132, 130, '2014-02-01 01:03:21.000000', 'consum', 0.0226, 'lps'),
	(526133, 130, '2014-02-01 01:03:22.000000', 'consum', 0.0218, 'lps'),
	(526134, 130, '2014-02-01 01:03:23.000000', 'consum', 0.0217, 'lps'),
	(526135, 130, '2014-02-01 01:03:24.000000', 'consum', 0.0224, 'lps'),
	(526136, 130, '2014-02-01 01:03:25.000000', 'consum', 0.0224, 'lps'),
	(526137, 130, '2014-02-01 01:03:26.000000', 'consum', 0.0219, 'lps'),
	(526138, 130, '2014-02-01 01:03:27.000000', 'consum', 0.0213, 'lps'),
	(526139, 130, '2014-02-01 01:03:28.000000', 'consum', 0.0217, 'lps'),
	(526140, 130, '2014-02-01 01:03:29.000000', 'consum', 0.0219, 'lps'),
	(526141, 130, '2014-02-01 01:03:30.000000', 'consum', 0.0216, 'lps'),
	(526142, 130, '2014-02-01 01:03:31.000000', 'consum', 0.0214, 'lps'),
	(526143, 130, '2014-02-01 01:03:32.000000', 'consum', 0.0211, 'lps'),
	(526144, 130, '2014-02-01 01:03:33.000000', 'consum', 0.0221, 'lps'),
	(526145, 130, '2014-02-01 01:03:34.000000', 'consum', 0.0227, 'lps'),
	(526146, 130, '2014-02-01 01:03:35.000000', 'consum', 0.0211, 'lps'),
	(526147, 130, '2014-02-01 01:03:36.000000', 'consum', 0.0216, 'lps'),
	(526148, 130, '2014-02-01 01:03:37.000000', 'consum', 0.0220, 'lps'),
	(526149, 130, '2014-02-01 01:03:38.000000', 'consum', 0.0223, 'lps'),
	(526150, 130, '2014-02-01 01:03:39.000000', 'consum', 0.0227, 'lps'),
	(526151, 130, '2014-02-01 01:03:40.000000', 'consum', 0.0223, 'lps'),
	(526152, 130, '2014-02-01 01:03:41.000000', 'consum', 0.0224, 'lps'),
	(526153, 130, '2014-02-01 01:03:42.000000', 'consum', 0.0222, 'lps'),
	(526154, 130, '2014-02-01 01:03:43.000000', 'consum', 0.0210, 'lps'),
	(526155, 130, '2014-02-01 01:03:44.000000', 'consum', 0.0214, 'lps'),
	(526156, 130, '2014-02-01 01:03:45.000000', 'consum', 0.0227, 'lps'),
	(526157, 130, '2014-02-01 01:03:46.000000', 'consum', 0.0211, 'lps'),
	(526158, 130, '2014-02-01 01:03:47.000000', 'consum', 0.0220, 'lps'),
	(526159, 130, '2014-02-01 01:03:48.000000', 'consum', 0.0223, 'lps'),
	(526160, 130, '2014-02-01 01:03:49.000000', 'consum', 0.0226, 'lps'),
	(526161, 130, '2014-02-01 01:03:50.000000', 'consum', 0.0217, 'lps'),
	(526162, 130, '2014-02-01 01:03:51.000000', 'consum', 0.0214, 'lps'),
	(526163, 130, '2014-02-01 01:03:52.000000', 'consum', 0.0210, 'lps'),
	(526164, 130, '2014-02-01 01:03:53.000000', 'consum', 0.0217, 'lps'),
	(526165, 130, '2014-02-01 01:03:54.000000', 'consum', 0.0226, 'lps'),
	(526166, 130, '2014-02-01 01:03:55.000000', 'consum', 0.0217, 'lps'),
	(526167, 130, '2014-02-01 01:03:56.000000', 'consum', 0.0217, 'lps'),
	(526168, 130, '2014-02-01 01:03:57.000000', 'consum', 0.0223, 'lps'),
	(526169, 130, '2014-02-01 01:03:58.000000', 'consum', 0.0219, 'lps'),
	(526170, 130, '2014-02-01 01:03:59.000000', 'consum', 0.0217, 'lps'),
	(526171, 130, '2014-02-01 01:04:00.000000', 'consum', 0.0216, 'lps'),
	(526172, 130, '2014-02-01 01:04:01.000000', 'consum', 0.0222, 'lps'),
	(526173, 130, '2014-02-01 01:04:02.000000', 'consum', 0.0214, 'lps'),
	(526174, 130, '2014-02-01 01:04:03.000000', 'consum', 0.0214, 'lps'),
	(526175, 130, '2014-02-01 01:04:04.000000', 'consum', 0.0220, 'lps'),
	(526176, 130, '2014-02-01 01:04:05.000000', 'consum', 0.0211, 'lps'),
	(526177, 130, '2014-02-01 01:04:06.000000', 'consum', 0.0223, 'lps'),
	(526178, 130, '2014-02-01 01:04:07.000000', 'consum', 0.0216, 'lps'),
	(526179, 130, '2014-02-01 01:04:08.000000', 'consum', 0.0220, 'lps'),
	(526180, 130, '2014-02-01 01:04:09.000000', 'consum', 0.0225, 'lps'),
	(526181, 130, '2014-02-01 01:04:10.000000', 'consum', 0.0218, 'lps'),
	(526182, 130, '2014-02-01 01:04:11.000000', 'consum', 0.0223, 'lps'),
	(526183, 130, '2014-02-01 01:04:12.000000', 'consum', 0.0216, 'lps'),
	(526184, 130, '2014-02-01 01:04:13.000000', 'consum', 0.0221, 'lps'),
	(526185, 130, '2014-02-01 01:04:14.000000', 'consum', 0.0227, 'lps'),
	(526186, 130, '2014-02-01 01:04:15.000000', 'consum', 0.0226, 'lps'),
	(526187, 130, '2014-02-01 01:04:16.000000', 'consum', 0.0224, 'lps'),
	(526188, 130, '2014-02-01 01:04:17.000000', 'consum', 0.0215, 'lps'),
	(526189, 130, '2014-02-01 01:04:18.000000', 'consum', 0.0212, 'lps'),
	(526190, 130, '2014-02-01 01:04:19.000000', 'consum', 0.0220, 'lps'),
	(526191, 130, '2014-02-01 01:04:20.000000', 'consum', 0.0222, 'lps'),
	(526192, 130, '2014-02-01 01:04:21.000000', 'consum', 0.0219, 'lps'),
	(526193, 130, '2014-02-01 01:04:22.000000', 'consum', 0.0223, 'lps'),
	(526194, 130, '2014-02-01 01:04:23.000000', 'consum', 0.0211, 'lps'),
	(526195, 130, '2014-02-01 01:04:24.000000', 'consum', 0.0214, 'lps'),
	(526196, 130, '2014-02-01 01:04:25.000000', 'consum', 0.0226, 'lps'),
	(526197, 130, '2014-02-01 01:04:26.000000', 'consum', 0.0225, 'lps'),
	(526198, 130, '2014-02-01 01:04:27.000000', 'consum', 0.0220, 'lps'),
	(526199, 130, '2014-02-01 01:04:28.000000', 'consum', 0.0213, 'lps'),
	(526200, 130, '2014-02-01 01:04:29.000000', 'consum', 0.0216, 'lps'),
	(526201, 130, '2014-02-01 01:04:30.000000', 'consum', 0.0211, 'lps'),
	(526202, 130, '2014-02-01 01:04:31.000000', 'consum', 0.0215, 'lps'),
	(526203, 130, '2014-02-01 01:04:32.000000', 'consum', 0.0217, 'lps'),
	(526204, 130, '2014-02-01 01:04:33.000000', 'consum', 0.0210, 'lps'),
	(526205, 130, '2014-02-01 01:04:34.000000', 'consum', 0.0211, 'lps'),
	(526206, 130, '2014-02-01 01:04:35.000000', 'consum', 0.0212, 'lps'),
	(526207, 130, '2014-02-01 01:04:36.000000', 'consum', 0.0219, 'lps'),
	(526208, 130, '2014-02-01 01:04:37.000000', 'consum', 0.0212, 'lps'),
	(526209, 130, '2014-02-01 01:04:38.000000', 'consum', 0.0214, 'lps'),
	(526210, 130, '2014-02-01 01:04:39.000000', 'consum', 0.0224, 'lps'),
	(526211, 130, '2014-02-01 01:04:40.000000', 'consum', 0.0214, 'lps'),
	(526212, 130, '2014-02-01 01:04:41.000000', 'consum', 0.0224, 'lps'),
	(526213, 130, '2014-02-01 01:04:42.000000', 'consum', 0.0215, 'lps'),
	(526214, 130, '2014-02-01 01:04:43.000000', 'consum', 0.0227, 'lps'),
	(526215, 130, '2014-02-01 01:04:44.000000', 'consum', 0.0212, 'lps'),
	(526216, 130, '2014-02-01 01:04:45.000000', 'consum', 0.0221, 'lps'),
	(526217, 130, '2014-02-01 01:04:46.000000', 'consum', 0.0225, 'lps'),
	(526218, 130, '2014-02-01 01:04:47.000000', 'consum', 0.0214, 'lps'),
	(526219, 130, '2014-02-01 01:04:48.000000', 'consum', 0.0224, 'lps'),
	(526220, 130, '2014-02-01 01:04:49.000000', 'consum', 0.0212, 'lps'),
	(526221, 130, '2014-02-01 01:04:50.000000', 'consum', 0.0215, 'lps'),
	(526222, 130, '2014-02-01 01:04:51.000000', 'consum', 0.0213, 'lps'),
	(526223, 130, '2014-02-01 01:04:52.000000', 'consum', 0.0212, 'lps'),
	(526224, 130, '2014-02-01 01:04:53.000000', 'consum', 0.0227, 'lps'),
	(526225, 130, '2014-02-01 01:04:54.000000', 'consum', 0.0220, 'lps'),
	(526226, 130, '2014-02-01 01:04:55.000000', 'consum', 0.0226, 'lps'),
	(526227, 130, '2014-02-01 01:04:56.000000', 'consum', 0.0226, 'lps'),
	(526228, 130, '2014-02-01 01:04:57.000000', 'consum', 0.0225, 'lps'),
	(526229, 130, '2014-02-01 01:04:58.000000', 'consum', 0.0220, 'lps'),
	(526230, 130, '2014-02-01 01:04:59.000000', 'consum', 0.0216, 'lps'),
	(526231, 130, '2014-02-01 01:05:00.000000', 'consum', 0.0211, 'lps'),
	(526232, 130, '2014-02-01 01:05:01.000000', 'consum', 0.0215, 'lps'),
	(526233, 130, '2014-02-01 01:05:02.000000', 'consum', 0.0216, 'lps'),
	(526234, 130, '2014-02-01 01:05:03.000000', 'consum', 0.0223, 'lps'),
	(526235, 130, '2014-02-01 01:05:04.000000', 'consum', 0.0222, 'lps'),
	(526236, 130, '2014-02-01 01:05:05.000000', 'consum', 0.0212, 'lps'),
	(526237, 130, '2014-02-01 01:05:06.000000', 'consum', 0.0223, 'lps'),
	(526238, 130, '2014-02-01 01:05:07.000000', 'consum', 0.0216, 'lps'),
	(526239, 130, '2014-02-01 01:05:08.000000', 'consum', 0.0219, 'lps'),
	(526240, 130, '2014-02-01 01:05:09.000000', 'consum', 0.0219, 'lps'),
	(526241, 130, '2014-02-01 01:05:10.000000', 'consum', 0.0210, 'lps'),
	(526242, 130, '2014-02-01 01:05:11.000000', 'consum', 0.0221, 'lps'),
	(526243, 130, '2014-02-01 01:05:12.000000', 'consum', 0.0211, 'lps'),
	(526244, 130, '2014-02-01 01:05:13.000000', 'consum', 0.0218, 'lps'),
	(526245, 130, '2014-02-01 01:05:14.000000', 'consum', 0.0210, 'lps'),
	(526246, 130, '2014-02-01 01:05:15.000000', 'consum', 0.0224, 'lps'),
	(526247, 130, '2014-02-01 01:05:16.000000', 'consum', 0.0210, 'lps'),
	(526248, 130, '2014-02-01 01:05:17.000000', 'consum', 0.0221, 'lps'),
	(526249, 130, '2014-02-01 01:05:18.000000', 'consum', 0.0212, 'lps'),
	(526250, 130, '2014-02-01 01:05:19.000000', 'consum', 0.0223, 'lps'),
	(526251, 130, '2014-02-01 01:05:20.000000', 'consum', 0.0214, 'lps'),
	(526252, 130, '2014-02-01 01:05:21.000000', 'consum', 0.0213, 'lps'),
	(526253, 130, '2014-02-01 01:05:22.000000', 'consum', 0.0210, 'lps'),
	(526254, 130, '2014-02-01 01:05:23.000000', 'consum', 0.0223, 'lps'),
	(526255, 130, '2014-02-01 01:05:24.000000', 'consum', 0.0219, 'lps'),
	(526256, 130, '2014-02-01 01:05:25.000000', 'consum', 0.0216, 'lps'),
	(526257, 130, '2014-02-01 01:05:26.000000', 'consum', 0.0214, 'lps'),
	(526258, 130, '2014-02-01 01:05:27.000000', 'consum', 0.0213, 'lps'),
	(526259, 130, '2014-02-01 01:05:28.000000', 'consum', 0.0215, 'lps'),
	(526260, 130, '2014-02-01 01:05:29.000000', 'consum', 0.0226, 'lps'),
	(526261, 130, '2014-02-01 01:05:30.000000', 'consum', 0.0221, 'lps'),
	(526262, 130, '2014-02-01 01:05:31.000000', 'consum', 0.0216, 'lps'),
	(526263, 130, '2014-02-01 01:05:32.000000', 'consum', 0.0210, 'lps'),
	(526264, 130, '2014-02-01 01:05:33.000000', 'consum', 0.0225, 'lps'),
	(526265, 130, '2014-02-01 01:05:34.000000', 'consum', 0.0217, 'lps'),
	(526266, 130, '2014-02-01 01:05:35.000000', 'consum', 0.0218, 'lps'),
	(526267, 130, '2014-02-01 01:05:36.000000', 'consum', 0.0212, 'lps'),
	(526268, 130, '2014-02-01 01:05:37.000000', 'consum', 0.0214, 'lps'),
	(526269, 130, '2014-02-01 01:05:38.000000', 'consum', 0.0225, 'lps'),
	(526270, 130, '2014-02-01 01:05:39.000000', 'consum', 0.0219, 'lps'),
	(526271, 130, '2014-02-01 01:05:40.000000', 'consum', 0.0212, 'lps'),
	(526272, 130, '2014-02-01 01:05:41.000000', 'consum', 0.0210, 'lps'),
	(526273, 130, '2014-02-01 01:05:42.000000', 'consum', 0.0222, 'lps'),
	(526274, 130, '2014-02-01 01:05:43.000000', 'consum', 0.0216, 'lps'),
	(526275, 130, '2014-02-01 01:05:44.000000', 'consum', 0.0221, 'lps'),
	(526276, 130, '2014-02-01 01:05:45.000000', 'consum', 0.0214, 'lps'),
	(526277, 130, '2014-02-01 01:05:46.000000', 'consum', 0.0214, 'lps'),
	(526278, 130, '2014-02-01 01:05:47.000000', 'consum', 0.0221, 'lps'),
	(526279, 130, '2014-02-01 01:05:48.000000', 'consum', 0.0216, 'lps'),
	(526280, 130, '2014-02-01 01:05:49.000000', 'consum', 0.0227, 'lps'),
	(526281, 130, '2014-02-01 01:05:50.000000', 'consum', 0.0222, 'lps'),
	(526282, 130, '2014-02-01 01:05:51.000000', 'consum', 0.0221, 'lps'),
	(526283, 130, '2014-02-01 01:05:52.000000', 'consum', 0.0227, 'lps'),
	(526284, 130, '2014-02-01 01:05:53.000000', 'consum', 0.0227, 'lps'),
	(526285, 130, '2014-02-01 01:05:54.000000', 'consum', 0.0227, 'lps'),
	(526286, 130, '2014-02-01 01:05:55.000000', 'consum', 0.0226, 'lps'),
	(526287, 130, '2014-02-01 01:05:56.000000', 'consum', 0.0222, 'lps'),
	(526288, 130, '2014-02-01 01:05:57.000000', 'consum', 0.0224, 'lps'),
	(526289, 130, '2014-02-01 01:05:58.000000', 'consum', 0.0226, 'lps'),
	(526290, 130, '2014-02-01 01:05:59.000000', 'consum', 0.0211, 'lps'),
	(526291, 130, '2014-02-01 01:06:00.000000', 'consum', 0.0223, 'lps'),
	(526292, 130, '2014-02-01 01:06:01.000000', 'consum', 0.0217, 'lps'),
	(526293, 130, '2014-02-01 01:06:02.000000', 'consum', 0.0227, 'lps'),
	(526294, 130, '2014-02-01 01:06:03.000000', 'consum', 0.0220, 'lps'),
	(526295, 130, '2014-02-01 01:06:04.000000', 'consum', 0.0227, 'lps'),
	(526296, 130, '2014-02-01 01:06:05.000000', 'consum', 0.0213, 'lps'),
	(526297, 130, '2014-02-01 01:06:06.000000', 'consum', 0.0227, 'lps'),
	(526298, 130, '2014-02-01 01:06:07.000000', 'consum', 0.0216, 'lps'),
	(526299, 130, '2014-02-01 01:06:08.000000', 'consum', 0.0225, 'lps'),
	(526300, 130, '2014-02-01 01:06:09.000000', 'consum', 0.0214, 'lps'),
	(526301, 130, '2014-02-01 01:06:10.000000', 'consum', 0.0222, 'lps'),
	(526302, 130, '2014-02-01 01:06:11.000000', 'consum', 0.0220, 'lps'),
	(526303, 130, '2014-02-01 01:06:12.000000', 'consum', 0.0225, 'lps'),
	(526304, 130, '2014-02-01 01:06:13.000000', 'consum', 0.0218, 'lps'),
	(526305, 130, '2014-02-01 01:06:14.000000', 'consum', 0.0224, 'lps'),
	(526306, 130, '2014-02-01 01:06:15.000000', 'consum', 0.0223, 'lps'),
	(526307, 130, '2014-02-01 01:06:16.000000', 'consum', 0.0214, 'lps'),
	(526308, 130, '2014-02-01 01:06:17.000000', 'consum', 0.0211, 'lps'),
	(526309, 130, '2014-02-01 01:06:18.000000', 'consum', 0.0221, 'lps'),
	(526310, 130, '2014-02-01 01:06:19.000000', 'consum', 0.0226, 'lps'),
	(526311, 130, '2014-02-01 01:06:20.000000', 'consum', 0.0221, 'lps'),
	(526312, 130, '2014-02-01 01:06:21.000000', 'consum', 0.0219, 'lps'),
	(526313, 130, '2014-02-01 01:06:22.000000', 'consum', 0.0222, 'lps'),
	(526314, 130, '2014-02-01 01:06:23.000000', 'consum', 0.0225, 'lps'),
	(526315, 130, '2014-02-01 01:06:24.000000', 'consum', 0.0213, 'lps'),
	(526316, 130, '2014-02-01 01:06:25.000000', 'consum', 0.0218, 'lps'),
	(526317, 130, '2014-02-01 01:06:26.000000', 'consum', 0.0223, 'lps'),
	(526318, 130, '2014-02-01 01:06:27.000000', 'consum', 0.0214, 'lps'),
	(526319, 130, '2014-02-01 01:06:28.000000', 'consum', 0.0227, 'lps'),
	(526320, 130, '2014-02-01 01:06:29.000000', 'consum', 0.0212, 'lps'),
	(526321, 130, '2014-02-01 01:06:30.000000', 'consum', 0.0222, 'lps'),
	(526322, 130, '2014-02-01 01:06:31.000000', 'consum', 0.0212, 'lps'),
	(526323, 130, '2014-02-01 01:06:32.000000', 'consum', 0.0222, 'lps'),
	(526324, 130, '2014-02-01 01:06:33.000000', 'consum', 0.0226, 'lps'),
	(526325, 130, '2014-02-01 01:06:34.000000', 'consum', 0.0219, 'lps'),
	(526326, 130, '2014-02-01 01:06:35.000000', 'consum', 0.0225, 'lps'),
	(526327, 130, '2014-02-01 01:06:36.000000', 'consum', 0.0224, 'lps'),
	(526328, 130, '2014-02-01 01:06:37.000000', 'consum', 0.0218, 'lps'),
	(526329, 130, '2014-02-01 01:06:38.000000', 'consum', 0.0224, 'lps'),
	(526330, 130, '2014-02-01 01:06:39.000000', 'consum', 0.0223, 'lps'),
	(526331, 130, '2014-02-01 01:06:40.000000', 'consum', 0.0214, 'lps'),
	(526332, 130, '2014-02-01 01:06:41.000000', 'consum', 0.0210, 'lps'),
	(526333, 130, '2014-02-01 01:06:42.000000', 'consum', 0.0216, 'lps'),
	(526334, 130, '2014-02-01 01:06:43.000000', 'consum', 0.0222, 'lps'),
	(526335, 130, '2014-02-01 01:06:44.000000', 'consum', 0.0216, 'lps'),
	(526336, 130, '2014-02-01 01:06:45.000000', 'consum', 0.0222, 'lps'),
	(526337, 130, '2014-02-01 01:06:46.000000', 'consum', 0.0217, 'lps'),
	(526338, 130, '2014-02-01 01:06:47.000000', 'consum', 0.0210, 'lps'),
	(526339, 130, '2014-02-01 01:06:48.000000', 'consum', 0.0225, 'lps'),
	(526340, 130, '2014-02-01 01:06:49.000000', 'consum', 0.0215, 'lps'),
	(526341, 130, '2014-02-01 01:06:50.000000', 'consum', 0.0226, 'lps'),
	(526342, 130, '2014-02-01 01:06:51.000000', 'consum', 0.0223, 'lps'),
	(526343, 130, '2014-02-01 01:06:52.000000', 'consum', 0.0224, 'lps'),
	(526344, 130, '2014-02-01 01:06:53.000000', 'consum', 0.0226, 'lps'),
	(526345, 130, '2014-02-01 01:06:54.000000', 'consum', 0.0214, 'lps'),
	(526346, 130, '2014-02-01 01:06:55.000000', 'consum', 0.0216, 'lps'),
	(526347, 130, '2014-02-01 01:06:56.000000', 'consum', 0.0211, 'lps'),
	(526348, 130, '2014-02-01 01:06:57.000000', 'consum', 0.0215, 'lps'),
	(526349, 130, '2014-02-01 01:06:58.000000', 'consum', 0.0217, 'lps'),
	(526350, 130, '2014-02-01 01:06:59.000000', 'consum', 0.0227, 'lps'),
	(526351, 130, '2014-02-01 01:07:00.000000', 'consum', 0.0222, 'lps'),
	(526352, 130, '2014-02-01 01:07:01.000000', 'consum', 0.0221, 'lps'),
	(526353, 130, '2014-02-01 01:07:02.000000', 'consum', 0.0212, 'lps'),
	(526354, 130, '2014-02-01 01:07:03.000000', 'consum', 0.0222, 'lps'),
	(526355, 130, '2014-02-01 01:07:04.000000', 'consum', 0.0213, 'lps'),
	(526356, 130, '2014-02-01 01:07:05.000000', 'consum', 0.0223, 'lps'),
	(526357, 130, '2014-02-01 01:07:06.000000', 'consum', 0.0214, 'lps'),
	(526358, 130, '2014-02-01 01:07:07.000000', 'consum', 0.0210, 'lps'),
	(526359, 130, '2014-02-01 01:07:08.000000', 'consum', 0.0217, 'lps'),
	(526360, 130, '2014-02-01 01:07:09.000000', 'consum', 0.0227, 'lps'),
	(526361, 130, '2014-02-01 01:07:10.000000', 'consum', 0.0219, 'lps'),
	(526362, 130, '2014-02-01 01:07:11.000000', 'consum', 0.0223, 'lps'),
	(526363, 130, '2014-02-01 01:07:12.000000', 'consum', 0.0214, 'lps'),
	(526364, 130, '2014-02-01 01:07:13.000000', 'consum', 0.0210, 'lps'),
	(526365, 130, '2014-02-01 01:07:14.000000', 'consum', 0.0215, 'lps'),
	(526366, 130, '2014-02-01 01:07:15.000000', 'consum', 0.0220, 'lps'),
	(526367, 130, '2014-02-01 01:07:16.000000', 'consum', 0.0224, 'lps'),
	(526368, 130, '2014-02-01 01:07:17.000000', 'consum', 0.0218, 'lps'),
	(526369, 130, '2014-02-01 01:07:18.000000', 'consum', 0.0224, 'lps'),
	(526370, 130, '2014-02-01 01:07:19.000000', 'consum', 0.0221, 'lps'),
	(526371, 130, '2014-02-01 01:07:20.000000', 'consum', 0.0222, 'lps'),
	(526372, 130, '2014-02-01 01:07:21.000000', 'consum', 0.0222, 'lps'),
	(526373, 130, '2014-02-01 01:07:22.000000', 'consum', 0.0217, 'lps'),
	(526374, 130, '2014-02-01 01:07:23.000000', 'consum', 0.0210, 'lps'),
	(526375, 130, '2014-02-01 01:07:24.000000', 'consum', 0.0225, 'lps'),
	(526376, 130, '2014-02-01 01:07:25.000000', 'consum', 0.0214, 'lps'),
	(526377, 130, '2014-02-01 01:07:26.000000', 'consum', 0.0220, 'lps'),
	(526378, 130, '2014-02-01 01:07:27.000000', 'consum', 0.0211, 'lps'),
	(526379, 130, '2014-02-01 01:07:28.000000', 'consum', 0.0225, 'lps'),
	(526380, 130, '2014-02-01 01:07:29.000000', 'consum', 0.0225, 'lps'),
	(526381, 130, '2014-02-01 01:07:30.000000', 'consum', 0.0226, 'lps'),
	(526382, 130, '2014-02-01 01:07:31.000000', 'consum', 0.0226, 'lps'),
	(526383, 130, '2014-02-01 01:07:32.000000', 'consum', 0.0224, 'lps'),
	(526384, 130, '2014-02-01 01:07:33.000000', 'consum', 0.0217, 'lps'),
	(526385, 130, '2014-02-01 01:07:34.000000', 'consum', 0.0218, 'lps'),
	(526386, 130, '2014-02-01 01:07:35.000000', 'consum', 0.0214, 'lps'),
	(526387, 130, '2014-02-01 01:07:36.000000', 'consum', 0.0222, 'lps'),
	(526388, 130, '2014-02-01 01:07:37.000000', 'consum', 0.0223, 'lps'),
	(526389, 130, '2014-02-01 01:07:38.000000', 'consum', 0.0221, 'lps'),
	(526390, 130, '2014-02-01 01:07:39.000000', 'consum', 0.0210, 'lps'),
	(526391, 130, '2014-02-01 01:07:40.000000', 'consum', 0.0214, 'lps'),
	(526392, 130, '2014-02-01 01:07:41.000000', 'consum', 0.0210, 'lps'),
	(526393, 130, '2014-02-01 01:07:42.000000', 'consum', 0.0217, 'lps'),
	(526394, 130, '2014-02-01 01:07:43.000000', 'consum', 0.0227, 'lps'),
	(526395, 130, '2014-02-01 01:07:44.000000', 'consum', 0.0222, 'lps'),
	(526396, 130, '2014-02-01 01:07:45.000000', 'consum', 0.0220, 'lps'),
	(526397, 130, '2014-02-01 01:07:46.000000', 'consum', 0.0225, 'lps'),
	(526398, 130, '2014-02-01 01:07:47.000000', 'consum', 0.0220, 'lps'),
	(526399, 130, '2014-02-01 01:07:48.000000', 'consum', 0.0216, 'lps'),
	(526400, 130, '2014-02-01 01:07:49.000000', 'consum', 0.0226, 'lps'),
	(526401, 130, '2014-02-01 01:07:50.000000', 'consum', 0.0219, 'lps'),
	(526402, 130, '2014-02-01 01:07:51.000000', 'consum', 0.0224, 'lps'),
	(526403, 130, '2014-02-01 01:07:52.000000', 'consum', 0.0221, 'lps'),
	(526404, 130, '2014-02-01 01:07:53.000000', 'consum', 0.0220, 'lps'),
	(526405, 130, '2014-02-01 01:07:54.000000', 'consum', 0.0213, 'lps'),
	(526406, 130, '2014-02-01 01:07:55.000000', 'consum', 0.0210, 'lps'),
	(526407, 130, '2014-02-01 01:07:56.000000', 'consum', 0.0222, 'lps'),
	(526408, 130, '2014-02-01 01:07:57.000000', 'consum', 0.0214, 'lps'),
	(526409, 130, '2014-02-01 01:07:58.000000', 'consum', 0.0213, 'lps'),
	(526410, 130, '2014-02-01 01:07:59.000000', 'consum', 0.0215, 'lps'),
	(526411, 130, '2014-02-01 01:08:00.000000', 'consum', 0.0227, 'lps'),
	(526412, 130, '2014-02-01 01:08:01.000000', 'consum', 0.0224, 'lps'),
	(526413, 130, '2014-02-01 01:08:02.000000', 'consum', 0.0213, 'lps'),
	(526414, 130, '2014-02-01 01:08:03.000000', 'consum', 0.0220, 'lps'),
	(526415, 130, '2014-02-01 01:08:04.000000', 'consum', 0.0216, 'lps'),
	(526416, 130, '2014-02-01 01:08:05.000000', 'consum', 0.0227, 'lps'),
	(526417, 130, '2014-02-01 01:08:06.000000', 'consum', 0.0222, 'lps'),
	(526418, 130, '2014-02-01 01:08:07.000000', 'consum', 0.0221, 'lps'),
	(526419, 130, '2014-02-01 01:08:08.000000', 'consum', 0.0212, 'lps'),
	(526420, 130, '2014-02-01 01:08:09.000000', 'consum', 0.0221, 'lps'),
	(526421, 130, '2014-02-01 01:08:10.000000', 'consum', 0.0226, 'lps'),
	(526422, 130, '2014-02-01 01:08:11.000000', 'consum', 0.0222, 'lps'),
	(526423, 130, '2014-02-01 01:08:12.000000', 'consum', 0.0222, 'lps'),
	(526424, 130, '2014-02-01 01:08:13.000000', 'consum', 0.0215, 'lps'),
	(526425, 130, '2014-02-01 01:08:14.000000', 'consum', 0.0217, 'lps'),
	(526426, 130, '2014-02-01 01:08:15.000000', 'consum', 0.0212, 'lps'),
	(526427, 130, '2014-02-01 01:08:16.000000', 'consum', 0.0218, 'lps'),
	(526428, 130, '2014-02-01 01:08:17.000000', 'consum', 0.0210, 'lps'),
	(526429, 130, '2014-02-01 01:08:18.000000', 'consum', 0.0223, 'lps'),
	(526430, 130, '2014-02-01 01:08:19.000000', 'consum', 0.0223, 'lps'),
	(526431, 130, '2014-02-01 01:08:20.000000', 'consum', 0.0215, 'lps'),
	(526432, 130, '2014-02-01 01:08:21.000000', 'consum', 0.0216, 'lps'),
	(526433, 130, '2014-02-01 01:08:22.000000', 'consum', 0.0227, 'lps'),
	(526434, 130, '2014-02-01 01:08:23.000000', 'consum', 0.0222, 'lps'),
	(526435, 130, '2014-02-01 01:08:24.000000', 'consum', 0.0220, 'lps'),
	(526436, 130, '2014-02-01 01:08:25.000000', 'consum', 0.0225, 'lps'),
	(526437, 130, '2014-02-01 01:08:26.000000', 'consum', 0.0219, 'lps'),
	(526438, 130, '2014-02-01 01:08:27.000000', 'consum', 0.0227, 'lps'),
	(526439, 130, '2014-02-01 01:08:28.000000', 'consum', 0.0214, 'lps'),
	(526440, 130, '2014-02-01 01:08:29.000000', 'consum', 0.0217, 'lps'),
	(526441, 130, '2014-02-01 01:08:30.000000', 'consum', 0.0215, 'lps'),
	(526442, 130, '2014-02-01 01:08:31.000000', 'consum', 0.0215, 'lps'),
	(526443, 130, '2014-02-01 01:08:32.000000', 'consum', 0.0218, 'lps'),
	(526444, 130, '2014-02-01 01:08:33.000000', 'consum', 0.0220, 'lps'),
	(526445, 130, '2014-02-01 01:08:34.000000', 'consum', 0.0216, 'lps'),
	(526446, 130, '2014-02-01 01:08:35.000000', 'consum', 0.0212, 'lps'),
	(526447, 130, '2014-02-01 01:08:36.000000', 'consum', 0.0222, 'lps'),
	(526448, 130, '2014-02-01 01:08:37.000000', 'consum', 0.0225, 'lps'),
	(526449, 130, '2014-02-01 01:08:38.000000', 'consum', 0.0216, 'lps'),
	(526450, 130, '2014-02-01 01:08:39.000000', 'consum', 0.0214, 'lps'),
	(526451, 130, '2014-02-01 01:08:40.000000', 'consum', 0.0210, 'lps'),
	(526452, 130, '2014-02-01 01:08:41.000000', 'consum', 0.0216, 'lps'),
	(526453, 130, '2014-02-01 01:08:42.000000', 'consum', 0.0226, 'lps'),
	(526454, 130, '2014-02-01 01:08:43.000000', 'consum', 0.0216, 'lps'),
	(526455, 130, '2014-02-01 01:08:44.000000', 'consum', 0.0211, 'lps'),
	(526456, 130, '2014-02-01 01:08:45.000000', 'consum', 0.0214, 'lps'),
	(526457, 130, '2014-02-01 01:08:46.000000', 'consum', 0.0211, 'lps'),
	(526458, 130, '2014-02-01 01:08:47.000000', 'consum', 0.0220, 'lps'),
	(526459, 130, '2014-02-01 01:08:48.000000', 'consum', 0.0223, 'lps'),
	(526460, 130, '2014-02-01 01:08:49.000000', 'consum', 0.0225, 'lps'),
	(526461, 130, '2014-02-01 01:08:50.000000', 'consum', 0.0213, 'lps'),
	(526462, 130, '2014-02-01 01:08:51.000000', 'consum', 0.0214, 'lps'),
	(526463, 130, '2014-02-01 01:08:52.000000', 'consum', 0.0222, 'lps'),
	(526464, 130, '2014-02-01 01:08:53.000000', 'consum', 0.0222, 'lps'),
	(526465, 130, '2014-02-01 01:08:54.000000', 'consum', 0.0218, 'lps'),
	(526466, 130, '2014-02-01 01:08:55.000000', 'consum', 0.0216, 'lps'),
	(526467, 130, '2014-02-01 01:08:56.000000', 'consum', 0.0214, 'lps'),
	(526468, 130, '2014-02-01 01:08:57.000000', 'consum', 0.0214, 'lps'),
	(526469, 130, '2014-02-01 01:08:58.000000', 'consum', 0.0220, 'lps'),
	(526470, 130, '2014-02-01 01:08:59.000000', 'consum', 0.0211, 'lps'),
	(526471, 130, '2014-02-01 01:09:00.000000', 'consum', 0.0222, 'lps'),
	(526472, 130, '2014-02-01 01:09:01.000000', 'consum', 0.0214, 'lps'),
	(526473, 130, '2014-02-01 01:09:02.000000', 'consum', 0.0210, 'lps'),
	(526474, 130, '2014-02-01 01:09:03.000000', 'consum', 0.0218, 'lps'),
	(526475, 130, '2014-02-01 01:09:04.000000', 'consum', 0.0213, 'lps'),
	(526476, 130, '2014-02-01 01:09:05.000000', 'consum', 0.0219, 'lps'),
	(526477, 130, '2014-02-01 01:09:06.000000', 'consum', 0.0212, 'lps'),
	(526478, 130, '2014-02-01 01:09:07.000000', 'consum', 0.0227, 'lps'),
	(526479, 130, '2014-02-01 01:09:08.000000', 'consum', 0.0221, 'lps'),
	(526480, 130, '2014-02-01 01:09:09.000000', 'consum', 0.0214, 'lps'),
	(526481, 130, '2014-02-01 01:09:10.000000', 'consum', 0.0214, 'lps'),
	(526482, 130, '2014-02-01 01:09:11.000000', 'consum', 0.0218, 'lps'),
	(526483, 130, '2014-02-01 01:09:12.000000', 'consum', 0.0221, 'lps'),
	(526484, 130, '2014-02-01 01:09:13.000000', 'consum', 0.0224, 'lps'),
	(526485, 130, '2014-02-01 01:09:14.000000', 'consum', 0.0210, 'lps'),
	(526486, 130, '2014-02-01 01:09:15.000000', 'consum', 0.0223, 'lps'),
	(526487, 130, '2014-02-01 01:09:16.000000', 'consum', 0.0222, 'lps'),
	(526488, 130, '2014-02-01 01:09:17.000000', 'consum', 0.0213, 'lps'),
	(526489, 130, '2014-02-01 01:09:18.000000', 'consum', 0.0224, 'lps'),
	(526490, 130, '2014-02-01 01:09:19.000000', 'consum', 0.0220, 'lps'),
	(526491, 130, '2014-02-01 01:09:20.000000', 'consum', 0.0216, 'lps'),
	(526492, 130, '2014-02-01 01:09:21.000000', 'consum', 0.0212, 'lps'),
	(526493, 130, '2014-02-01 01:09:22.000000', 'consum', 0.0222, 'lps'),
	(526494, 130, '2014-02-01 01:09:23.000000', 'consum', 0.0210, 'lps'),
	(526495, 130, '2014-02-01 01:09:24.000000', 'consum', 0.0226, 'lps'),
	(526496, 130, '2014-02-01 01:09:25.000000', 'consum', 0.0221, 'lps'),
	(526497, 130, '2014-02-01 01:09:26.000000', 'consum', 0.0215, 'lps'),
	(526498, 130, '2014-02-01 01:09:27.000000', 'consum', 0.0220, 'lps'),
	(526499, 130, '2014-02-01 01:09:28.000000', 'consum', 0.0211, 'lps'),
	(526500, 130, '2014-02-01 01:09:29.000000', 'consum', 0.0222, 'lps'),
	(526501, 130, '2014-02-01 01:09:30.000000', 'consum', 0.0212, 'lps'),
	(526502, 130, '2014-02-01 01:09:31.000000', 'consum', 0.0223, 'lps'),
	(526503, 130, '2014-02-01 01:09:32.000000', 'consum', 0.0214, 'lps'),
	(526504, 130, '2014-02-01 01:09:33.000000', 'consum', 0.0212, 'lps'),
	(526505, 130, '2014-02-01 01:09:34.000000', 'consum', 0.0223, 'lps'),
	(526506, 130, '2014-02-01 01:09:35.000000', 'consum', 0.0218, 'lps'),
	(526507, 130, '2014-02-01 01:09:36.000000', 'consum', 0.0227, 'lps'),
	(526508, 130, '2014-02-01 01:09:37.000000', 'consum', 0.0220, 'lps'),
	(526509, 130, '2014-02-01 01:09:38.000000', 'consum', 0.0226, 'lps'),
	(526510, 130, '2014-02-01 01:09:39.000000', 'consum', 0.0223, 'lps'),
	(526511, 130, '2014-02-01 01:09:40.000000', 'consum', 0.0213, 'lps'),
	(526512, 130, '2014-02-01 01:09:41.000000', 'consum', 0.0220, 'lps'),
	(526513, 130, '2014-02-01 01:09:42.000000', 'consum', 0.0216, 'lps'),
	(526514, 130, '2014-02-01 01:09:43.000000', 'consum', 0.0210, 'lps'),
	(526515, 130, '2014-02-01 01:09:44.000000', 'consum', 0.0212, 'lps'),
	(526516, 130, '2014-02-01 01:09:45.000000', 'consum', 0.0218, 'lps'),
	(526517, 130, '2014-02-01 01:09:46.000000', 'consum', 0.0226, 'lps'),
	(526518, 130, '2014-02-01 01:09:47.000000', 'consum', 0.0215, 'lps'),
	(526519, 130, '2014-02-01 01:09:48.000000', 'consum', 0.0221, 'lps'),
	(526520, 130, '2014-02-01 01:09:49.000000', 'consum', 0.0215, 'lps'),
	(526521, 130, '2014-02-01 01:09:50.000000', 'consum', 0.0222, 'lps'),
	(526522, 130, '2014-02-01 01:09:51.000000', 'consum', 0.0221, 'lps'),
	(526523, 130, '2014-02-01 01:09:52.000000', 'consum', 0.0227, 'lps'),
	(526524, 130, '2014-02-01 01:09:53.000000', 'consum', 0.0227, 'lps'),
	(526525, 130, '2014-02-01 01:09:54.000000', 'consum', 0.0226, 'lps'),
	(526526, 130, '2014-02-01 01:09:55.000000', 'consum', 0.0222, 'lps'),
	(526527, 130, '2014-02-01 01:09:56.000000', 'consum', 0.0223, 'lps'),
	(526528, 130, '2014-02-01 01:09:57.000000', 'consum', 0.0223, 'lps'),
	(526529, 130, '2014-02-01 01:09:58.000000', 'consum', 0.0217, 'lps'),
	(526530, 130, '2014-02-01 01:09:59.000000', 'consum', 0.0224, 'lps'),
	(526531, 130, '2014-02-01 01:10:00.000000', 'consum', 0.0222, 'lps'),
	(526532, 130, '2014-02-01 01:10:01.000000', 'consum', 0.0212, 'lps'),
	(526533, 130, '2014-02-01 01:10:02.000000', 'consum', 0.0222, 'lps'),
	(526534, 130, '2014-02-01 01:10:03.000000', 'consum', 0.0227, 'lps'),
	(526535, 130, '2014-02-01 01:10:04.000000', 'consum', 0.0222, 'lps'),
	(526536, 130, '2014-02-01 01:10:05.000000', 'consum', 0.0220, 'lps'),
	(526537, 130, '2014-02-01 01:10:06.000000', 'consum', 0.0224, 'lps'),
	(526538, 130, '2014-02-01 01:10:07.000000', 'consum', 0.0213, 'lps'),
	(526539, 130, '2014-02-01 01:10:08.000000', 'consum', 0.0222, 'lps'),
	(526540, 130, '2014-02-01 01:10:09.000000', 'consum', 0.0227, 'lps'),
	(526541, 130, '2014-02-01 01:10:10.000000', 'consum', 0.0221, 'lps'),
	(526542, 130, '2014-02-01 01:10:11.000000', 'consum', 0.0215, 'lps'),
	(526543, 130, '2014-02-01 01:10:12.000000', 'consum', 0.0219, 'lps'),
	(526544, 130, '2014-02-01 01:10:13.000000', 'consum', 0.0225, 'lps'),
	(526545, 130, '2014-02-01 01:10:14.000000', 'consum', 0.0223, 'lps'),
	(526546, 130, '2014-02-01 01:10:15.000000', 'consum', 0.0213, 'lps'),
	(526547, 130, '2014-02-01 01:10:16.000000', 'consum', 0.0221, 'lps'),
	(526548, 130, '2014-02-01 01:10:17.000000', 'consum', 0.0223, 'lps'),
	(526549, 130, '2014-02-01 01:10:18.000000', 'consum', 0.0222, 'lps'),
	(526550, 130, '2014-02-01 01:10:19.000000', 'consum', 0.0215, 'lps'),
	(526551, 130, '2014-02-01 01:10:20.000000', 'consum', 0.0218, 'lps'),
	(526552, 130, '2014-02-01 01:10:21.000000', 'consum', 0.0215, 'lps'),
	(526553, 130, '2014-02-01 01:10:22.000000', 'consum', 0.0212, 'lps'),
	(526554, 130, '2014-02-01 01:10:23.000000', 'consum', 0.0224, 'lps'),
	(526555, 130, '2014-02-01 01:10:24.000000', 'consum', 0.0219, 'lps'),
	(526556, 130, '2014-02-01 01:10:25.000000', 'consum', 0.0216, 'lps'),
	(526557, 130, '2014-02-01 01:10:26.000000', 'consum', 0.0213, 'lps'),
	(526558, 130, '2014-02-01 01:10:27.000000', 'consum', 0.0223, 'lps'),
	(526559, 130, '2014-02-01 01:10:28.000000', 'consum', 0.0214, 'lps'),
	(526560, 130, '2014-02-01 01:10:29.000000', 'consum', 0.0210, 'lps'),
	(526561, 130, '2014-02-01 01:10:30.000000', 'consum', 0.0216, 'lps'),
	(526562, 130, '2014-02-01 01:10:31.000000', 'consum', 0.0224, 'lps'),
	(526563, 130, '2014-02-01 01:10:32.000000', 'consum', 0.0227, 'lps'),
	(526564, 130, '2014-02-01 01:10:33.000000', 'consum', 0.0216, 'lps'),
	(526565, 130, '2014-02-01 01:10:34.000000', 'consum', 0.0226, 'lps'),
	(526566, 130, '2014-02-01 01:10:35.000000', 'consum', 0.0220, 'lps'),
	(526567, 130, '2014-02-01 01:10:36.000000', 'consum', 0.0213, 'lps'),
	(526568, 130, '2014-02-01 01:10:37.000000', 'consum', 0.0212, 'lps'),
	(526569, 130, '2014-02-01 01:10:38.000000', 'consum', 0.0212, 'lps'),
	(526570, 130, '2014-02-01 01:10:39.000000', 'consum', 0.0216, 'lps'),
	(526571, 130, '2014-02-01 01:10:40.000000', 'consum', 0.0214, 'lps'),
	(526572, 130, '2014-02-01 01:10:41.000000', 'consum', 0.0212, 'lps'),
	(526573, 130, '2014-02-01 01:10:42.000000', 'consum', 0.0211, 'lps'),
	(526574, 130, '2014-02-01 01:10:43.000000', 'consum', 0.0210, 'lps'),
	(526575, 130, '2014-02-01 01:10:44.000000', 'consum', 0.0225, 'lps'),
	(526576, 130, '2014-02-01 01:10:45.000000', 'consum', 0.0213, 'lps'),
	(526577, 130, '2014-02-01 01:10:46.000000', 'consum', 0.0218, 'lps'),
	(526578, 130, '2014-02-01 01:10:47.000000', 'consum', 0.0221, 'lps'),
	(526579, 130, '2014-02-01 01:10:48.000000', 'consum', 0.0225, 'lps'),
	(526580, 130, '2014-02-01 01:10:49.000000', 'consum', 0.0217, 'lps'),
	(526581, 130, '2014-02-01 01:10:50.000000', 'consum', 0.0220, 'lps'),
	(526582, 130, '2014-02-01 01:10:51.000000', 'consum', 0.0218, 'lps'),
	(526583, 130, '2014-02-01 01:10:52.000000', 'consum', 0.0222, 'lps'),
	(526584, 130, '2014-02-01 01:10:53.000000', 'consum', 0.0210, 'lps'),
	(526585, 130, '2014-02-01 01:10:54.000000', 'consum', 0.0227, 'lps'),
	(526586, 130, '2014-02-01 01:10:55.000000', 'consum', 0.0226, 'lps'),
	(526587, 130, '2014-02-01 01:10:56.000000', 'consum', 0.0219, 'lps'),
	(526588, 130, '2014-02-01 01:10:57.000000', 'consum', 0.0210, 'lps'),
	(526589, 130, '2014-02-01 01:10:58.000000', 'consum', 0.0218, 'lps'),
	(526590, 130, '2014-02-01 01:10:59.000000', 'consum', 0.0215, 'lps'),
	(526591, 130, '2014-02-01 01:11:00.000000', 'consum', 0.0211, 'lps'),
	(526592, 130, '2014-02-01 01:11:01.000000', 'consum', 0.0221, 'lps'),
	(526593, 130, '2014-02-01 01:11:02.000000', 'consum', 0.0223, 'lps'),
	(526594, 130, '2014-02-01 01:11:03.000000', 'consum', 0.0210, 'lps'),
	(526595, 130, '2014-02-01 01:11:04.000000', 'consum', 0.0222, 'lps'),
	(526596, 130, '2014-02-01 01:11:05.000000', 'consum', 0.0220, 'lps'),
	(526597, 130, '2014-02-01 01:11:06.000000', 'consum', 0.0222, 'lps'),
	(526598, 130, '2014-02-01 01:11:07.000000', 'consum', 0.0222, 'lps'),
	(526599, 130, '2014-02-01 01:11:08.000000', 'consum', 0.0219, 'lps'),
	(526600, 130, '2014-02-01 01:11:09.000000', 'consum', 0.0220, 'lps'),
	(526601, 130, '2014-02-01 01:11:10.000000', 'consum', 0.0216, 'lps'),
	(526602, 130, '2014-02-01 01:11:11.000000', 'consum', 0.0227, 'lps'),
	(526603, 130, '2014-02-01 01:11:12.000000', 'consum', 0.0226, 'lps'),
	(526604, 130, '2014-02-01 01:11:13.000000', 'consum', 0.0218, 'lps'),
	(526605, 130, '2014-02-01 01:11:14.000000', 'consum', 0.0222, 'lps'),
	(526606, 130, '2014-02-01 01:11:15.000000', 'consum', 0.0212, 'lps'),
	(526607, 130, '2014-02-01 01:11:16.000000', 'consum', 0.0221, 'lps'),
	(526608, 130, '2014-02-01 01:11:17.000000', 'consum', 0.0222, 'lps'),
	(526609, 130, '2014-02-01 01:11:18.000000', 'consum', 0.0219, 'lps'),
	(526610, 130, '2014-02-01 01:11:19.000000', 'consum', 0.0222, 'lps'),
	(526611, 130, '2014-02-01 01:11:20.000000', 'consum', 0.0224, 'lps'),
	(526612, 130, '2014-02-01 01:11:21.000000', 'consum', 0.0225, 'lps'),
	(526613, 130, '2014-02-01 01:11:22.000000', 'consum', 0.0210, 'lps'),
	(526614, 130, '2014-02-01 01:11:23.000000', 'consum', 0.0218, 'lps'),
	(526615, 130, '2014-02-01 01:11:24.000000', 'consum', 0.0214, 'lps'),
	(526616, 130, '2014-02-01 01:11:25.000000', 'consum', 0.0223, 'lps'),
	(526617, 130, '2014-02-01 01:11:26.000000', 'consum', 0.0212, 'lps'),
	(526618, 130, '2014-02-01 01:11:27.000000', 'consum', 0.0216, 'lps'),
	(526619, 130, '2014-02-01 01:11:28.000000', 'consum', 0.0218, 'lps'),
	(526620, 130, '2014-02-01 01:11:29.000000', 'consum', 0.0215, 'lps'),
	(526621, 130, '2014-02-01 01:11:30.000000', 'consum', 0.0227, 'lps'),
	(526622, 130, '2014-02-01 01:11:31.000000', 'consum', 0.0226, 'lps'),
	(526623, 130, '2014-02-01 01:11:32.000000', 'consum', 0.0222, 'lps'),
	(526624, 130, '2014-02-01 01:11:33.000000', 'consum', 0.0221, 'lps'),
	(526625, 130, '2014-02-01 01:11:34.000000', 'consum', 0.0214, 'lps'),
	(526626, 130, '2014-02-01 01:11:35.000000', 'consum', 0.0216, 'lps'),
	(526627, 130, '2014-02-01 01:11:36.000000', 'consum', 0.0227, 'lps'),
	(526628, 130, '2014-02-01 01:11:37.000000', 'consum', 0.0225, 'lps'),
	(526629, 130, '2014-02-01 01:11:38.000000', 'consum', 0.0215, 'lps'),
	(526630, 130, '2014-02-01 01:11:39.000000', 'consum', 0.0210, 'lps'),
	(526631, 130, '2014-02-01 01:11:40.000000', 'consum', 0.0211, 'lps'),
	(526632, 130, '2014-02-01 01:11:41.000000', 'consum', 0.0217, 'lps'),
	(526633, 130, '2014-02-01 01:11:42.000000', 'consum', 0.0225, 'lps'),
	(526634, 130, '2014-02-01 01:11:43.000000', 'consum', 0.0210, 'lps'),
	(526635, 130, '2014-02-01 01:11:44.000000', 'consum', 0.0221, 'lps'),
	(526636, 130, '2014-02-01 01:11:45.000000', 'consum', 0.0227, 'lps'),
	(526637, 130, '2014-02-01 01:11:46.000000', 'consum', 0.0210, 'lps'),
	(526638, 130, '2014-02-01 01:11:47.000000', 'consum', 0.0213, 'lps'),
	(526639, 130, '2014-02-01 01:11:48.000000', 'consum', 0.0224, 'lps'),
	(526640, 130, '2014-02-01 01:11:49.000000', 'consum', 0.0218, 'lps'),
	(526641, 130, '2014-02-01 01:11:50.000000', 'consum', 0.0227, 'lps'),
	(526642, 130, '2014-02-01 01:11:51.000000', 'consum', 0.0217, 'lps'),
	(526643, 130, '2014-02-01 01:11:52.000000', 'consum', 0.0211, 'lps'),
	(526644, 130, '2014-02-01 01:11:53.000000', 'consum', 0.0214, 'lps'),
	(526645, 130, '2014-02-01 01:11:54.000000', 'consum', 0.0227, 'lps'),
	(526646, 130, '2014-02-01 01:11:55.000000', 'consum', 0.0210, 'lps'),
	(526647, 130, '2014-02-01 01:11:56.000000', 'consum', 0.0216, 'lps'),
	(526648, 130, '2014-02-01 01:11:57.000000', 'consum', 0.0223, 'lps'),
	(526649, 130, '2014-02-01 01:11:58.000000', 'consum', 0.0222, 'lps'),
	(526650, 130, '2014-02-01 01:11:59.000000', 'consum', 0.0213, 'lps'),
	(526651, 130, '2014-02-01 01:12:00.000000', 'consum', 0.0226, 'lps'),
	(526652, 130, '2014-02-01 01:12:01.000000', 'consum', 0.0210, 'lps'),
	(526653, 130, '2014-02-01 01:12:02.000000', 'consum', 0.0218, 'lps'),
	(526654, 130, '2014-02-01 01:12:03.000000', 'consum', 0.0211, 'lps'),
	(526655, 130, '2014-02-01 01:12:04.000000', 'consum', 0.0210, 'lps'),
	(526656, 130, '2014-02-01 01:12:05.000000', 'consum', 0.0226, 'lps'),
	(526657, 130, '2014-02-01 01:12:06.000000', 'consum', 0.0219, 'lps'),
	(526658, 130, '2014-02-01 01:12:07.000000', 'consum', 0.0227, 'lps'),
	(526659, 130, '2014-02-01 01:12:08.000000', 'consum', 0.0214, 'lps'),
	(526660, 130, '2014-02-01 01:12:09.000000', 'consum', 0.0214, 'lps'),
	(526661, 130, '2014-02-01 01:12:10.000000', 'consum', 0.0218, 'lps'),
	(526662, 130, '2014-02-01 01:12:11.000000', 'consum', 0.0219, 'lps'),
	(526663, 130, '2014-02-01 01:12:12.000000', 'consum', 0.0217, 'lps'),
	(526664, 130, '2014-02-01 01:12:13.000000', 'consum', 0.0217, 'lps'),
	(526665, 130, '2014-02-01 01:12:14.000000', 'consum', 0.0225, 'lps'),
	(526666, 130, '2014-02-01 01:12:15.000000', 'consum', 0.0212, 'lps'),
	(526667, 130, '2014-02-01 01:12:16.000000', 'consum', 0.0227, 'lps'),
	(526668, 130, '2014-02-01 01:12:17.000000', 'consum', 0.0219, 'lps'),
	(526669, 130, '2014-02-01 01:12:18.000000', 'consum', 0.0222, 'lps'),
	(526670, 130, '2014-02-01 01:12:19.000000', 'consum', 0.0225, 'lps'),
	(526671, 130, '2014-02-01 01:12:20.000000', 'consum', 0.0212, 'lps'),
	(526672, 130, '2014-02-01 01:12:21.000000', 'consum', 0.0214, 'lps'),
	(526673, 130, '2014-02-01 01:12:22.000000', 'consum', 0.0223, 'lps'),
	(526674, 130, '2014-02-01 01:12:23.000000', 'consum', 0.0210, 'lps'),
	(526675, 130, '2014-02-01 01:12:24.000000', 'consum', 0.0226, 'lps'),
	(526676, 130, '2014-02-01 01:12:25.000000', 'consum', 0.0218, 'lps'),
	(526677, 130, '2014-02-01 01:12:26.000000', 'consum', 0.0219, 'lps'),
	(526678, 130, '2014-02-01 01:12:27.000000', 'consum', 0.0215, 'lps'),
	(526679, 130, '2014-02-01 01:12:28.000000', 'consum', 0.0227, 'lps'),
	(526680, 130, '2014-02-01 01:12:29.000000', 'consum', 0.0226, 'lps'),
	(526681, 130, '2014-02-01 01:12:30.000000', 'consum', 0.0221, 'lps'),
	(526682, 130, '2014-02-01 01:12:31.000000', 'consum', 0.0218, 'lps'),
	(526683, 130, '2014-02-01 01:12:32.000000', 'consum', 0.0216, 'lps'),
	(526684, 130, '2014-02-01 01:12:33.000000', 'consum', 0.0217, 'lps'),
	(526685, 130, '2014-02-01 01:12:34.000000', 'consum', 0.0227, 'lps'),
	(526686, 130, '2014-02-01 01:12:35.000000', 'consum', 0.0220, 'lps'),
	(526687, 130, '2014-02-01 01:12:36.000000', 'consum', 0.0212, 'lps'),
	(526688, 130, '2014-02-01 01:12:37.000000', 'consum', 0.0224, 'lps'),
	(526689, 130, '2014-02-01 01:12:38.000000', 'consum', 0.0220, 'lps'),
	(526690, 130, '2014-02-01 01:12:39.000000', 'consum', 0.0219, 'lps'),
	(526691, 130, '2014-02-01 01:12:40.000000', 'consum', 0.0226, 'lps'),
	(526692, 130, '2014-02-01 01:12:41.000000', 'consum', 0.0226, 'lps'),
	(526693, 130, '2014-02-01 01:12:42.000000', 'consum', 0.0226, 'lps'),
	(526694, 130, '2014-02-01 01:12:43.000000', 'consum', 0.0222, 'lps'),
	(526695, 130, '2014-02-01 01:12:44.000000', 'consum', 0.0225, 'lps'),
	(526696, 130, '2014-02-01 01:12:45.000000', 'consum', 0.0213, 'lps'),
	(526697, 130, '2014-02-01 01:12:46.000000', 'consum', 0.0215, 'lps'),
	(526698, 130, '2014-02-01 01:12:47.000000', 'consum', 0.0212, 'lps'),
	(526699, 130, '2014-02-01 01:12:48.000000', 'consum', 0.0220, 'lps'),
	(526700, 130, '2014-02-01 01:12:49.000000', 'consum', 0.0219, 'lps'),
	(526701, 130, '2014-02-01 01:12:50.000000', 'consum', 0.0226, 'lps'),
	(526702, 130, '2014-02-01 01:12:51.000000', 'consum', 0.0227, 'lps'),
	(526703, 130, '2014-02-01 01:12:52.000000', 'consum', 0.0211, 'lps'),
	(526704, 130, '2014-02-01 01:12:53.000000', 'consum', 0.0219, 'lps'),
	(526705, 130, '2014-02-01 01:12:54.000000', 'consum', 0.0218, 'lps'),
	(526706, 130, '2014-02-01 01:12:55.000000', 'consum', 0.0222, 'lps'),
	(526707, 130, '2014-02-01 01:12:56.000000', 'consum', 0.0213, 'lps'),
	(526708, 130, '2014-02-01 01:12:57.000000', 'consum', 0.0223, 'lps'),
	(526709, 130, '2014-02-01 01:12:58.000000', 'consum', 0.0212, 'lps'),
	(526710, 130, '2014-02-01 01:12:59.000000', 'consum', 0.0220, 'lps'),
	(526711, 130, '2014-02-01 01:13:00.000000', 'consum', 0.0218, 'lps'),
	(526712, 130, '2014-02-01 01:13:01.000000', 'consum', 0.0221, 'lps'),
	(526713, 130, '2014-02-01 01:13:02.000000', 'consum', 0.0223, 'lps'),
	(526714, 130, '2014-02-01 01:13:03.000000', 'consum', 0.0226, 'lps'),
	(526715, 130, '2014-02-01 01:13:04.000000', 'consum', 0.0216, 'lps'),
	(526716, 130, '2014-02-01 01:13:05.000000', 'consum', 0.0210, 'lps'),
	(526717, 130, '2014-02-01 01:13:06.000000', 'consum', 0.0227, 'lps'),
	(526718, 130, '2014-02-01 01:13:07.000000', 'consum', 0.0223, 'lps'),
	(526719, 130, '2014-02-01 01:13:08.000000', 'consum', 0.0224, 'lps'),
	(526720, 130, '2014-02-01 01:13:09.000000', 'consum', 0.0223, 'lps'),
	(526721, 130, '2014-02-01 01:13:10.000000', 'consum', 0.0215, 'lps'),
	(526722, 130, '2014-02-01 01:13:11.000000', 'consum', 0.0218, 'lps'),
	(526723, 130, '2014-02-01 01:13:12.000000', 'consum', 0.0214, 'lps'),
	(526724, 130, '2014-02-01 01:13:13.000000', 'consum', 0.0226, 'lps'),
	(526725, 130, '2014-02-01 01:13:14.000000', 'consum', 0.0226, 'lps'),
	(526726, 130, '2014-02-01 01:13:15.000000', 'consum', 0.0222, 'lps'),
	(526727, 130, '2014-02-01 01:13:16.000000', 'consum', 0.0225, 'lps'),
	(526728, 130, '2014-02-01 01:13:17.000000', 'consum', 0.0210, 'lps'),
	(526729, 130, '2014-02-01 01:13:18.000000', 'consum', 0.0223, 'lps'),
	(526730, 130, '2014-02-01 01:13:19.000000', 'consum', 0.0218, 'lps'),
	(526731, 130, '2014-02-01 01:13:20.000000', 'consum', 0.0214, 'lps'),
	(526732, 130, '2014-02-01 01:13:21.000000', 'consum', 0.0224, 'lps'),
	(526733, 130, '2014-02-01 01:13:22.000000', 'consum', 0.0214, 'lps'),
	(526734, 130, '2014-02-01 01:13:23.000000', 'consum', 0.0225, 'lps'),
	(526735, 130, '2014-02-01 01:13:24.000000', 'consum', 0.0221, 'lps'),
	(526736, 130, '2014-02-01 01:13:25.000000', 'consum', 0.0218, 'lps'),
	(526737, 131, '2014-02-01 00:00:00.000000', 'consum', 0.0212, 'lps'),
	(526738, 131, '2014-02-01 00:00:01.000000', 'consum', 0.0223, 'lps'),
	(526739, 131, '2014-02-01 00:00:02.000000', 'consum', 0.0215, 'lps'),
	(526740, 131, '2014-02-01 00:00:03.000000', 'consum', 0.0215, 'lps'),
	(526741, 131, '2014-02-01 00:00:04.000000', 'consum', 0.0221, 'lps'),
	(526742, 131, '2014-02-01 00:00:05.000000', 'consum', 0.0215, 'lps'),
	(526743, 131, '2014-02-01 00:00:06.000000', 'consum', 0.0219, 'lps'),
	(526744, 131, '2014-02-01 00:00:07.000000', 'consum', 0.0223, 'lps'),
	(526745, 131, '2014-02-01 00:00:08.000000', 'consum', 0.0215, 'lps'),
	(526746, 131, '2014-02-01 00:00:09.000000', 'consum', 0.0211, 'lps'),
	(526747, 131, '2014-02-01 00:00:10.000000', 'consum', 0.0218, 'lps'),
	(526748, 131, '2014-02-01 00:00:11.000000', 'consum', 0.0212, 'lps'),
	(526749, 131, '2014-02-01 00:00:12.000000', 'consum', 0.0217, 'lps'),
	(526750, 131, '2014-02-01 00:00:13.000000', 'consum', 0.0221, 'lps'),
	(526751, 131, '2014-02-01 00:00:14.000000', 'consum', 0.0224, 'lps'),
	(526752, 131, '2014-02-01 00:00:15.000000', 'consum', 0.0214, 'lps'),
	(526753, 131, '2014-02-01 00:00:16.000000', 'consum', 0.0226, 'lps'),
	(526754, 131, '2014-02-01 00:00:17.000000', 'consum', 0.0221, 'lps'),
	(526755, 131, '2014-02-01 00:00:18.000000', 'consum', 0.0219, 'lps'),
	(526756, 131, '2014-02-01 00:00:19.000000', 'consum', 0.0223, 'lps'),
	(526757, 131, '2014-02-01 00:00:20.000000', 'consum', 0.0214, 'lps'),
	(526758, 131, '2014-02-01 00:00:21.000000', 'consum', 0.0226, 'lps'),
	(526759, 131, '2014-02-01 00:00:22.000000', 'consum', 0.0225, 'lps'),
	(526760, 131, '2014-02-01 00:00:23.000000', 'consum', 0.0218, 'lps'),
	(526761, 131, '2014-02-01 00:00:24.000000', 'consum', 0.0225, 'lps'),
	(526762, 131, '2014-02-01 00:00:25.000000', 'consum', 0.0225, 'lps'),
	(526763, 131, '2014-02-01 00:00:26.000000', 'consum', 0.0221, 'lps'),
	(526764, 131, '2014-02-01 00:00:27.000000', 'consum', 0.0223, 'lps'),
	(526765, 131, '2014-02-01 00:00:28.000000', 'consum', 0.0223, 'lps'),
	(526766, 131, '2014-02-01 00:00:29.000000', 'consum', 0.0218, 'lps'),
	(526767, 131, '2014-02-01 00:00:30.000000', 'consum', 0.0213, 'lps'),
	(526768, 131, '2014-02-01 00:00:31.000000', 'consum', 0.0219, 'lps'),
	(526769, 131, '2014-02-01 00:00:32.000000', 'consum', 0.0227, 'lps'),
	(526770, 131, '2014-02-01 00:00:33.000000', 'consum', 0.0215, 'lps'),
	(526771, 131, '2014-02-01 00:00:34.000000', 'consum', 0.0222, 'lps'),
	(526772, 131, '2014-02-01 00:00:35.000000', 'consum', 0.0220, 'lps'),
	(526773, 131, '2014-02-01 00:00:36.000000', 'consum', 0.0223, 'lps'),
	(526774, 131, '2014-02-01 00:00:37.000000', 'consum', 0.0211, 'lps'),
	(526775, 131, '2014-02-01 00:00:38.000000', 'consum', 0.0213, 'lps'),
	(526776, 131, '2014-02-01 00:00:39.000000', 'consum', 0.0223, 'lps'),
	(526777, 131, '2014-02-01 00:00:40.000000', 'consum', 0.0213, 'lps'),
	(526778, 131, '2014-02-01 00:00:41.000000', 'consum', 0.0221, 'lps'),
	(526779, 131, '2014-02-01 00:00:42.000000', 'consum', 0.0221, 'lps'),
	(526780, 131, '2014-02-01 00:00:43.000000', 'consum', 0.0216, 'lps'),
	(526781, 131, '2014-02-01 00:00:44.000000', 'consum', 0.0224, 'lps'),
	(526782, 131, '2014-02-01 00:00:45.000000', 'consum', 0.0225, 'lps'),
	(526783, 131, '2014-02-01 00:00:46.000000', 'consum', 0.0210, 'lps'),
	(526784, 131, '2014-02-01 00:00:47.000000', 'consum', 0.0219, 'lps'),
	(526785, 131, '2014-02-01 00:00:48.000000', 'consum', 0.0221, 'lps'),
	(526786, 131, '2014-02-01 00:00:49.000000', 'consum', 0.0220, 'lps'),
	(526787, 131, '2014-02-01 00:00:50.000000', 'consum', 0.0227, 'lps'),
	(526788, 131, '2014-02-01 00:00:51.000000', 'consum', 0.0211, 'lps'),
	(526789, 131, '2014-02-01 00:00:52.000000', 'consum', 0.0219, 'lps'),
	(526790, 131, '2014-02-01 00:00:53.000000', 'consum', 0.0216, 'lps'),
	(526791, 131, '2014-02-01 00:00:54.000000', 'consum', 0.0213, 'lps'),
	(526792, 131, '2014-02-01 00:00:55.000000', 'consum', 0.0224, 'lps'),
	(526793, 131, '2014-02-01 00:00:56.000000', 'consum', 0.0220, 'lps'),
	(526794, 131, '2014-02-01 00:00:57.000000', 'consum', 0.0218, 'lps'),
	(526795, 131, '2014-02-01 00:00:58.000000', 'consum', 0.0221, 'lps'),
	(526796, 131, '2014-02-01 00:00:59.000000', 'consum', 0.0223, 'lps'),
	(526797, 131, '2014-02-01 00:01:00.000000', 'consum', 0.0223, 'lps'),
	(526798, 131, '2014-02-01 00:01:01.000000', 'consum', 0.0218, 'lps'),
	(526799, 131, '2014-02-01 00:01:02.000000', 'consum', 0.0212, 'lps'),
	(526800, 131, '2014-02-01 00:01:03.000000', 'consum', 0.0215, 'lps'),
	(526801, 131, '2014-02-01 00:01:04.000000', 'consum', 0.0213, 'lps'),
	(526802, 131, '2014-02-01 00:01:05.000000', 'consum', 0.0210, 'lps'),
	(526803, 131, '2014-02-01 00:01:06.000000', 'consum', 0.0219, 'lps'),
	(526804, 131, '2014-02-01 00:01:07.000000', 'consum', 0.0219, 'lps'),
	(526805, 131, '2014-02-01 00:01:08.000000', 'consum', 0.0212, 'lps'),
	(526806, 131, '2014-02-01 00:01:09.000000', 'consum', 0.0210, 'lps'),
	(526807, 131, '2014-02-01 00:01:10.000000', 'consum', 0.0222, 'lps'),
	(526808, 131, '2014-02-01 00:01:11.000000', 'consum', 0.0216, 'lps'),
	(526809, 131, '2014-02-01 00:01:12.000000', 'consum', 0.0222, 'lps'),
	(526810, 131, '2014-02-01 00:01:13.000000', 'consum', 0.0219, 'lps'),
	(526811, 131, '2014-02-01 00:01:14.000000', 'consum', 0.0217, 'lps'),
	(526812, 131, '2014-02-01 00:01:15.000000', 'consum', 0.0219, 'lps'),
	(526813, 131, '2014-02-01 00:01:16.000000', 'consum', 0.0219, 'lps'),
	(526814, 131, '2014-02-01 00:01:17.000000', 'consum', 0.0225, 'lps'),
	(526815, 131, '2014-02-01 00:01:18.000000', 'consum', 0.0225, 'lps'),
	(526816, 131, '2014-02-01 00:01:19.000000', 'consum', 0.0221, 'lps'),
	(526817, 131, '2014-02-01 00:01:20.000000', 'consum', 0.0220, 'lps'),
	(526818, 131, '2014-02-01 00:01:21.000000', 'consum', 0.0210, 'lps'),
	(526819, 131, '2014-02-01 00:01:22.000000', 'consum', 0.0218, 'lps'),
	(526820, 131, '2014-02-01 00:01:23.000000', 'consum', 0.0212, 'lps'),
	(526821, 131, '2014-02-01 00:01:24.000000', 'consum', 0.0214, 'lps'),
	(526822, 131, '2014-02-01 00:01:25.000000', 'consum', 0.0226, 'lps'),
	(526823, 131, '2014-02-01 00:01:26.000000', 'consum', 0.0223, 'lps'),
	(526824, 131, '2014-02-01 00:01:27.000000', 'consum', 0.0210, 'lps'),
	(526825, 131, '2014-02-01 00:01:28.000000', 'consum', 0.0227, 'lps'),
	(526826, 131, '2014-02-01 00:01:29.000000', 'consum', 0.0222, 'lps'),
	(526827, 131, '2014-02-01 00:01:30.000000', 'consum', 0.0219, 'lps'),
	(526828, 131, '2014-02-01 00:01:31.000000', 'consum', 0.0220, 'lps'),
	(526829, 131, '2014-02-01 00:01:32.000000', 'consum', 0.0214, 'lps'),
	(526830, 131, '2014-02-01 00:01:33.000000', 'consum', 0.0218, 'lps'),
	(526831, 131, '2014-02-01 00:01:34.000000', 'consum', 0.0221, 'lps'),
	(526832, 131, '2014-02-01 00:01:35.000000', 'consum', 0.0225, 'lps'),
	(526833, 131, '2014-02-01 00:01:36.000000', 'consum', 0.0216, 'lps'),
	(526834, 131, '2014-02-01 00:01:37.000000', 'consum', 0.0212, 'lps'),
	(526835, 131, '2014-02-01 00:01:38.000000', 'consum', 0.0223, 'lps'),
	(526836, 131, '2014-02-01 00:01:39.000000', 'consum', 0.0215, 'lps'),
	(526837, 131, '2014-02-01 00:01:40.000000', 'consum', 0.0214, 'lps'),
	(526838, 131, '2014-02-01 00:01:41.000000', 'consum', 0.0216, 'lps'),
	(526839, 131, '2014-02-01 00:01:42.000000', 'consum', 0.0210, 'lps'),
	(526840, 131, '2014-02-01 00:01:43.000000', 'consum', 0.0227, 'lps'),
	(526841, 131, '2014-02-01 00:01:44.000000', 'consum', 0.0226, 'lps'),
	(526842, 131, '2014-02-01 00:01:45.000000', 'consum', 0.0223, 'lps'),
	(526843, 131, '2014-02-01 00:01:46.000000', 'consum', 0.0224, 'lps'),
	(526844, 131, '2014-02-01 00:01:47.000000', 'consum', 0.0227, 'lps'),
	(526845, 131, '2014-02-01 00:01:48.000000', 'consum', 0.0215, 'lps'),
	(526846, 131, '2014-02-01 00:01:49.000000', 'consum', 0.0220, 'lps'),
	(526847, 131, '2014-02-01 00:01:50.000000', 'consum', 0.0210, 'lps'),
	(526848, 131, '2014-02-01 00:01:51.000000', 'consum', 0.0215, 'lps'),
	(526849, 131, '2014-02-01 00:01:52.000000', 'consum', 0.0217, 'lps'),
	(526850, 131, '2014-02-01 00:01:53.000000', 'consum', 0.0216, 'lps'),
	(526851, 131, '2014-02-01 00:01:54.000000', 'consum', 0.0216, 'lps'),
	(526852, 131, '2014-02-01 00:01:55.000000', 'consum', 0.0223, 'lps'),
	(526853, 131, '2014-02-01 00:01:56.000000', 'consum', 0.0224, 'lps'),
	(526854, 131, '2014-02-01 00:01:57.000000', 'consum', 0.0222, 'lps'),
	(526855, 131, '2014-02-01 00:01:58.000000', 'consum', 0.0210, 'lps'),
	(526856, 131, '2014-02-01 00:01:59.000000', 'consum', 0.0211, 'lps'),
	(526857, 131, '2014-02-01 00:02:00.000000', 'consum', 0.0216, 'lps'),
	(526858, 131, '2014-02-01 00:02:01.000000', 'consum', 0.0221, 'lps'),
	(526859, 131, '2014-02-01 00:02:02.000000', 'consum', 0.0211, 'lps'),
	(526860, 131, '2014-02-01 00:02:03.000000', 'consum', 0.0216, 'lps'),
	(526861, 131, '2014-02-01 00:02:04.000000', 'consum', 0.0220, 'lps'),
	(526862, 131, '2014-02-01 00:02:05.000000', 'consum', 0.0225, 'lps'),
	(526863, 131, '2014-02-01 00:02:06.000000', 'consum', 0.0220, 'lps'),
	(526864, 131, '2014-02-01 00:02:07.000000', 'consum', 0.0216, 'lps'),
	(526865, 131, '2014-02-01 00:02:08.000000', 'consum', 0.0211, 'lps'),
	(526866, 131, '2014-02-01 00:02:09.000000', 'consum', 0.0215, 'lps'),
	(526867, 131, '2014-02-01 00:02:10.000000', 'consum', 0.0214, 'lps'),
	(526868, 131, '2014-02-01 00:02:11.000000', 'consum', 0.0216, 'lps'),
	(526869, 131, '2014-02-01 00:02:12.000000', 'consum', 0.0212, 'lps'),
	(526870, 131, '2014-02-01 00:02:13.000000', 'consum', 0.0219, 'lps'),
	(526871, 131, '2014-02-01 00:02:14.000000', 'consum', 0.0214, 'lps'),
	(526872, 131, '2014-02-01 00:02:15.000000', 'consum', 0.0221, 'lps'),
	(526873, 131, '2014-02-01 00:02:16.000000', 'consum', 0.0216, 'lps'),
	(526874, 131, '2014-02-01 00:02:17.000000', 'consum', 0.0210, 'lps'),
	(526875, 131, '2014-02-01 00:02:18.000000', 'consum', 0.0226, 'lps'),
	(526876, 131, '2014-02-01 00:02:19.000000', 'consum', 0.0219, 'lps'),
	(526877, 131, '2014-02-01 00:02:20.000000', 'consum', 0.0224, 'lps'),
	(526878, 131, '2014-02-01 00:02:21.000000', 'consum', 0.0218, 'lps'),
	(526879, 131, '2014-02-01 00:02:22.000000', 'consum', 0.0211, 'lps'),
	(526880, 131, '2014-02-01 00:02:23.000000', 'consum', 0.0226, 'lps'),
	(526881, 131, '2014-02-01 00:02:24.000000', 'consum', 0.0216, 'lps'),
	(526882, 131, '2014-02-01 00:02:25.000000', 'consum', 0.0227, 'lps'),
	(526883, 131, '2014-02-01 00:02:26.000000', 'consum', 0.0225, 'lps'),
	(526884, 131, '2014-02-01 00:02:27.000000', 'consum', 0.0218, 'lps'),
	(526885, 131, '2014-02-01 00:02:28.000000', 'consum', 0.0220, 'lps'),
	(526886, 131, '2014-02-01 00:02:29.000000', 'consum', 0.0221, 'lps'),
	(526887, 131, '2014-02-01 00:02:30.000000', 'consum', 0.0216, 'lps'),
	(526888, 131, '2014-02-01 00:02:31.000000', 'consum', 0.0224, 'lps'),
	(526889, 131, '2014-02-01 00:02:32.000000', 'consum', 0.0211, 'lps'),
	(526890, 131, '2014-02-01 00:02:33.000000', 'consum', 0.0210, 'lps'),
	(526891, 131, '2014-02-01 00:02:34.000000', 'consum', 0.0223, 'lps'),
	(526892, 131, '2014-02-01 00:02:35.000000', 'consum', 0.0222, 'lps'),
	(526893, 131, '2014-02-01 00:02:36.000000', 'consum', 0.0212, 'lps'),
	(526894, 131, '2014-02-01 00:02:37.000000', 'consum', 0.0224, 'lps'),
	(526895, 131, '2014-02-01 00:02:38.000000', 'consum', 0.0219, 'lps'),
	(526896, 131, '2014-02-01 00:02:39.000000', 'consum', 0.0213, 'lps'),
	(526897, 131, '2014-02-01 00:02:40.000000', 'consum', 0.0216, 'lps'),
	(526898, 131, '2014-02-01 00:02:41.000000', 'consum', 0.0212, 'lps'),
	(526899, 131, '2014-02-01 00:02:42.000000', 'consum', 0.0222, 'lps'),
	(526900, 131, '2014-02-01 00:02:43.000000', 'consum', 0.0212, 'lps'),
	(526901, 131, '2014-02-01 00:02:44.000000', 'consum', 0.0218, 'lps'),
	(526902, 131, '2014-02-01 00:02:45.000000', 'consum', 0.0210, 'lps'),
	(526903, 131, '2014-02-01 00:02:46.000000', 'consum', 0.0220, 'lps'),
	(526904, 131, '2014-02-01 00:02:47.000000', 'consum', 0.0227, 'lps'),
	(526905, 131, '2014-02-01 00:02:48.000000', 'consum', 0.0212, 'lps'),
	(526906, 131, '2014-02-01 00:02:49.000000', 'consum', 0.0224, 'lps'),
	(526907, 131, '2014-02-01 00:02:50.000000', 'consum', 0.0218, 'lps'),
	(526908, 131, '2014-02-01 00:02:51.000000', 'consum', 0.0226, 'lps'),
	(526909, 131, '2014-02-01 00:02:52.000000', 'consum', 0.0215, 'lps'),
	(526910, 131, '2014-02-01 00:02:53.000000', 'consum', 0.0223, 'lps'),
	(526911, 131, '2014-02-01 00:02:54.000000', 'consum', 0.0225, 'lps'),
	(526912, 131, '2014-02-01 00:02:55.000000', 'consum', 0.0212, 'lps'),
	(526913, 131, '2014-02-01 00:02:56.000000', 'consum', 0.0210, 'lps'),
	(526914, 131, '2014-02-01 00:02:57.000000', 'consum', 0.0222, 'lps'),
	(526915, 131, '2014-02-01 00:02:58.000000', 'consum', 0.0218, 'lps'),
	(526916, 131, '2014-02-01 00:02:59.000000', 'consum', 0.0212, 'lps'),
	(526917, 131, '2014-02-01 00:03:00.000000', 'consum', 0.0215, 'lps'),
	(526918, 131, '2014-02-01 00:03:01.000000', 'consum', 0.0212, 'lps'),
	(526919, 131, '2014-02-01 00:03:02.000000', 'consum', 0.0223, 'lps'),
	(526920, 131, '2014-02-01 00:03:03.000000', 'consum', 0.0218, 'lps'),
	(526921, 131, '2014-02-01 00:03:04.000000', 'consum', 0.0226, 'lps'),
	(526922, 131, '2014-02-01 00:03:05.000000', 'consum', 0.0214, 'lps'),
	(526923, 131, '2014-02-01 00:03:06.000000', 'consum', 0.0217, 'lps'),
	(526924, 131, '2014-02-01 00:03:07.000000', 'consum', 0.0215, 'lps'),
	(526925, 131, '2014-02-01 00:03:08.000000', 'consum', 0.0216, 'lps'),
	(526926, 131, '2014-02-01 00:03:09.000000', 'consum', 0.0224, 'lps'),
	(526927, 131, '2014-02-01 00:03:10.000000', 'consum', 0.0211, 'lps'),
	(526928, 131, '2014-02-01 00:03:11.000000', 'consum', 0.0226, 'lps'),
	(526929, 131, '2014-02-01 00:03:12.000000', 'consum', 0.0214, 'lps'),
	(526930, 131, '2014-02-01 00:03:13.000000', 'consum', 0.0220, 'lps'),
	(526931, 131, '2014-02-01 00:03:14.000000', 'consum', 0.0214, 'lps'),
	(526932, 131, '2014-02-01 00:03:15.000000', 'consum', 0.0216, 'lps'),
	(526933, 131, '2014-02-01 00:03:16.000000', 'consum', 0.0211, 'lps'),
	(526934, 131, '2014-02-01 00:03:17.000000', 'consum', 0.0217, 'lps'),
	(526935, 131, '2014-02-01 00:03:18.000000', 'consum', 0.0223, 'lps'),
	(526936, 131, '2014-02-01 00:03:19.000000', 'consum', 0.0219, 'lps'),
	(526937, 131, '2014-02-01 00:03:20.000000', 'consum', 0.0218, 'lps'),
	(526938, 131, '2014-02-01 00:03:21.000000', 'consum', 0.0223, 'lps'),
	(526939, 131, '2014-02-01 00:03:22.000000', 'consum', 0.0215, 'lps'),
	(526940, 131, '2014-02-01 00:03:23.000000', 'consum', 0.0212, 'lps'),
	(526941, 131, '2014-02-01 00:03:24.000000', 'consum', 0.0227, 'lps'),
	(526942, 131, '2014-02-01 00:03:25.000000', 'consum', 0.0218, 'lps'),
	(526943, 131, '2014-02-01 00:03:26.000000', 'consum', 0.0215, 'lps'),
	(526944, 131, '2014-02-01 00:03:27.000000', 'consum', 0.0214, 'lps'),
	(526945, 131, '2014-02-01 00:03:28.000000', 'consum', 0.0215, 'lps'),
	(526946, 131, '2014-02-01 00:03:29.000000', 'consum', 0.0225, 'lps'),
	(526947, 131, '2014-02-01 00:03:30.000000', 'consum', 0.0216, 'lps'),
	(526948, 131, '2014-02-01 00:03:31.000000', 'consum', 0.0211, 'lps'),
	(526949, 131, '2014-02-01 00:03:32.000000', 'consum', 0.0216, 'lps'),
	(526950, 131, '2014-02-01 00:03:33.000000', 'consum', 0.0222, 'lps'),
	(526951, 131, '2014-02-01 00:03:34.000000', 'consum', 0.0214, 'lps'),
	(526952, 131, '2014-02-01 00:03:35.000000', 'consum', 0.0214, 'lps'),
	(526953, 131, '2014-02-01 00:03:36.000000', 'consum', 0.0216, 'lps'),
	(526954, 131, '2014-02-01 00:03:37.000000', 'consum', 0.0213, 'lps'),
	(526955, 131, '2014-02-01 00:03:38.000000', 'consum', 0.0223, 'lps'),
	(526956, 131, '2014-02-01 00:03:39.000000', 'consum', 0.0215, 'lps'),
	(526957, 131, '2014-02-01 00:03:40.000000', 'consum', 0.0213, 'lps'),
	(526958, 131, '2014-02-01 00:03:41.000000', 'consum', 0.0211, 'lps'),
	(526959, 131, '2014-02-01 00:03:42.000000', 'consum', 0.0225, 'lps'),
	(526960, 131, '2014-02-01 00:03:43.000000', 'consum', 0.0211, 'lps'),
	(526961, 131, '2014-02-01 00:03:44.000000', 'consum', 0.0225, 'lps'),
	(526962, 131, '2014-02-01 00:03:45.000000', 'consum', 0.0211, 'lps'),
	(526963, 131, '2014-02-01 00:03:46.000000', 'consum', 0.0224, 'lps'),
	(526964, 131, '2014-02-01 00:03:47.000000', 'consum', 0.0222, 'lps'),
	(526965, 131, '2014-02-01 00:03:48.000000', 'consum', 0.0212, 'lps'),
	(526966, 131, '2014-02-01 00:03:49.000000', 'consum', 0.0221, 'lps'),
	(526967, 131, '2014-02-01 00:03:50.000000', 'consum', 0.0221, 'lps'),
	(526968, 131, '2014-02-01 00:03:51.000000', 'consum', 0.0216, 'lps'),
	(526969, 131, '2014-02-01 00:03:52.000000', 'consum', 0.0224, 'lps'),
	(526970, 131, '2014-02-01 00:03:53.000000', 'consum', 0.0227, 'lps'),
	(526971, 131, '2014-02-01 00:03:54.000000', 'consum', 0.0216, 'lps'),
	(526972, 131, '2014-02-01 00:03:55.000000', 'consum', 0.0227, 'lps'),
	(526973, 131, '2014-02-01 00:03:56.000000', 'consum', 0.0223, 'lps'),
	(526974, 131, '2014-02-01 00:03:57.000000', 'consum', 0.0225, 'lps'),
	(526975, 131, '2014-02-01 00:03:58.000000', 'consum', 0.0211, 'lps'),
	(526976, 131, '2014-02-01 00:03:59.000000', 'consum', 0.0223, 'lps'),
	(526977, 131, '2014-02-01 00:04:00.000000', 'consum', 0.0221, 'lps'),
	(526978, 131, '2014-02-01 00:04:01.000000', 'consum', 0.0225, 'lps'),
	(526979, 131, '2014-02-01 00:04:02.000000', 'consum', 0.0218, 'lps'),
	(526980, 131, '2014-02-01 00:04:03.000000', 'consum', 0.0223, 'lps'),
	(526981, 131, '2014-02-01 00:04:04.000000', 'consum', 0.0217, 'lps'),
	(526982, 131, '2014-02-01 00:04:05.000000', 'consum', 0.0224, 'lps'),
	(526983, 131, '2014-02-01 00:04:06.000000', 'consum', 0.0221, 'lps'),
	(526984, 131, '2014-02-01 00:04:07.000000', 'consum', 0.0225, 'lps'),
	(526985, 131, '2014-02-01 00:04:08.000000', 'consum', 0.0216, 'lps'),
	(526986, 131, '2014-02-01 00:04:09.000000', 'consum', 0.0212, 'lps'),
	(526987, 131, '2014-02-01 00:04:10.000000', 'consum', 0.0224, 'lps'),
	(526988, 131, '2014-02-01 00:04:11.000000', 'consum', 0.0218, 'lps'),
	(526989, 131, '2014-02-01 00:04:12.000000', 'consum', 0.0225, 'lps'),
	(526990, 131, '2014-02-01 00:04:13.000000', 'consum', 0.0210, 'lps'),
	(526991, 131, '2014-02-01 00:04:14.000000', 'consum', 0.0217, 'lps'),
	(526992, 131, '2014-02-01 00:04:15.000000', 'consum', 0.0210, 'lps'),
	(526993, 131, '2014-02-01 00:04:16.000000', 'consum', 0.0226, 'lps'),
	(526994, 131, '2014-02-01 00:04:17.000000', 'consum', 0.0220, 'lps'),
	(526995, 131, '2014-02-01 00:04:18.000000', 'consum', 0.0213, 'lps'),
	(526996, 131, '2014-02-01 00:04:19.000000', 'consum', 0.0210, 'lps'),
	(526997, 131, '2014-02-01 00:04:20.000000', 'consum', 0.0223, 'lps'),
	(526998, 131, '2014-02-01 00:04:21.000000', 'consum', 0.0220, 'lps'),
	(526999, 131, '2014-02-01 00:04:22.000000', 'consum', 0.0221, 'lps'),
	(527000, 131, '2014-02-01 00:04:23.000000', 'consum', 0.0216, 'lps'),
	(527001, 131, '2014-02-01 00:04:24.000000', 'consum', 0.0210, 'lps'),
	(527002, 131, '2014-02-01 00:04:25.000000', 'consum', 0.0226, 'lps'),
	(527003, 131, '2014-02-01 00:04:26.000000', 'consum', 0.0221, 'lps'),
	(527004, 131, '2014-02-01 00:04:27.000000', 'consum', 0.0217, 'lps'),
	(527005, 131, '2014-02-01 00:04:28.000000', 'consum', 0.0211, 'lps'),
	(527006, 131, '2014-02-01 00:04:29.000000', 'consum', 0.0214, 'lps'),
	(527007, 131, '2014-02-01 00:04:30.000000', 'consum', 0.0226, 'lps'),
	(527008, 131, '2014-02-01 00:04:31.000000', 'consum', 0.0226, 'lps'),
	(527009, 131, '2014-02-01 00:04:32.000000', 'consum', 0.0223, 'lps'),
	(527010, 131, '2014-02-01 00:04:33.000000', 'consum', 0.0210, 'lps'),
	(527011, 131, '2014-02-01 00:04:34.000000', 'consum', 0.0225, 'lps'),
	(527012, 131, '2014-02-01 00:04:35.000000', 'consum', 0.0215, 'lps'),
	(527013, 131, '2014-02-01 00:04:36.000000', 'consum', 0.0225, 'lps'),
	(527014, 131, '2014-02-01 00:04:37.000000', 'consum', 0.0217, 'lps'),
	(527015, 131, '2014-02-01 00:04:38.000000', 'consum', 0.0219, 'lps'),
	(527016, 131, '2014-02-01 00:04:39.000000', 'consum', 0.0217, 'lps'),
	(527017, 131, '2014-02-01 00:04:40.000000', 'consum', 0.0216, 'lps'),
	(527018, 131, '2014-02-01 00:04:41.000000', 'consum', 0.0223, 'lps'),
	(527019, 131, '2014-02-01 00:04:42.000000', 'consum', 0.0219, 'lps'),
	(527020, 131, '2014-02-01 00:04:43.000000', 'consum', 0.0218, 'lps'),
	(527021, 131, '2014-02-01 00:04:44.000000', 'consum', 0.0222, 'lps'),
	(527022, 131, '2014-02-01 00:04:45.000000', 'consum', 0.0212, 'lps'),
	(527023, 131, '2014-02-01 00:04:46.000000', 'consum', 0.0220, 'lps'),
	(527024, 131, '2014-02-01 00:04:47.000000', 'consum', 0.0221, 'lps'),
	(527025, 131, '2014-02-01 00:04:48.000000', 'consum', 0.0214, 'lps'),
	(527026, 131, '2014-02-01 00:04:49.000000', 'consum', 0.0215, 'lps'),
	(527027, 131, '2014-02-01 00:04:50.000000', 'consum', 0.0225, 'lps'),
	(527028, 131, '2014-02-01 00:04:51.000000', 'consum', 0.0216, 'lps'),
	(527029, 131, '2014-02-01 00:04:52.000000', 'consum', 0.0213, 'lps'),
	(527030, 131, '2014-02-01 00:04:53.000000', 'consum', 0.0225, 'lps'),
	(527031, 131, '2014-02-01 00:04:54.000000', 'consum', 0.0225, 'lps'),
	(527032, 131, '2014-02-01 00:04:55.000000', 'consum', 0.0220, 'lps'),
	(527033, 131, '2014-02-01 00:04:56.000000', 'consum', 0.0217, 'lps'),
	(527034, 131, '2014-02-01 00:04:57.000000', 'consum', 0.0216, 'lps'),
	(527035, 131, '2014-02-01 00:04:58.000000', 'consum', 0.0221, 'lps'),
	(527036, 131, '2014-02-01 00:04:59.000000', 'consum', 0.0210, 'lps'),
	(527037, 131, '2014-02-01 00:05:00.000000', 'consum', 0.0212, 'lps'),
	(527038, 131, '2014-02-01 00:05:01.000000', 'consum', 0.0223, 'lps'),
	(527039, 131, '2014-02-01 00:05:02.000000', 'consum', 0.0216, 'lps'),
	(527040, 131, '2014-02-01 00:05:03.000000', 'consum', 0.0219, 'lps'),
	(527041, 131, '2014-02-01 00:05:04.000000', 'consum', 0.0221, 'lps'),
	(527042, 131, '2014-02-01 00:05:05.000000', 'consum', 0.0218, 'lps'),
	(527043, 131, '2014-02-01 00:05:06.000000', 'consum', 0.0218, 'lps'),
	(527044, 131, '2014-02-01 00:05:07.000000', 'consum', 0.0227, 'lps'),
	(527045, 131, '2014-02-01 00:05:08.000000', 'consum', 0.0219, 'lps'),
	(527046, 131, '2014-02-01 00:05:09.000000', 'consum', 0.0222, 'lps'),
	(527047, 131, '2014-02-01 00:05:10.000000', 'consum', 0.0224, 'lps'),
	(527048, 131, '2014-02-01 00:05:11.000000', 'consum', 0.0226, 'lps'),
	(527049, 131, '2014-02-01 00:05:12.000000', 'consum', 0.0214, 'lps'),
	(527050, 131, '2014-02-01 00:05:13.000000', 'consum', 0.0220, 'lps'),
	(527051, 131, '2014-02-01 00:05:14.000000', 'consum', 0.0212, 'lps'),
	(527052, 131, '2014-02-01 00:05:15.000000', 'consum', 0.0225, 'lps'),
	(527053, 131, '2014-02-01 00:05:16.000000', 'consum', 0.0225, 'lps'),
	(527054, 131, '2014-02-01 00:05:17.000000', 'consum', 0.0224, 'lps'),
	(527055, 131, '2014-02-01 00:05:18.000000', 'consum', 0.0215, 'lps'),
	(527056, 131, '2014-02-01 00:05:19.000000', 'consum', 0.0213, 'lps'),
	(527057, 131, '2014-02-01 00:05:20.000000', 'consum', 0.0210, 'lps'),
	(527058, 131, '2014-02-01 00:05:21.000000', 'consum', 0.0220, 'lps'),
	(527059, 131, '2014-02-01 00:05:22.000000', 'consum', 0.0225, 'lps'),
	(527060, 131, '2014-02-01 00:05:23.000000', 'consum', 0.0221, 'lps'),
	(527061, 131, '2014-02-01 00:05:24.000000', 'consum', 0.0217, 'lps'),
	(527062, 131, '2014-02-01 00:05:25.000000', 'consum', 0.0216, 'lps'),
	(527063, 131, '2014-02-01 00:05:26.000000', 'consum', 0.0218, 'lps'),
	(527064, 131, '2014-02-01 00:05:27.000000', 'consum', 0.0213, 'lps'),
	(527065, 131, '2014-02-01 00:05:28.000000', 'consum', 0.0221, 'lps'),
	(527066, 131, '2014-02-01 00:05:29.000000', 'consum', 0.0219, 'lps'),
	(527067, 131, '2014-02-01 00:05:30.000000', 'consum', 0.0225, 'lps'),
	(527068, 131, '2014-02-01 00:05:31.000000', 'consum', 0.0221, 'lps'),
	(527069, 131, '2014-02-01 00:05:32.000000', 'consum', 0.0221, 'lps'),
	(527070, 131, '2014-02-01 00:05:33.000000', 'consum', 0.0214, 'lps'),
	(527071, 131, '2014-02-01 00:05:34.000000', 'consum', 0.0217, 'lps'),
	(527072, 131, '2014-02-01 00:05:35.000000', 'consum', 0.0216, 'lps'),
	(527073, 131, '2014-02-01 00:05:36.000000', 'consum', 0.0218, 'lps'),
	(527074, 131, '2014-02-01 00:05:37.000000', 'consum', 0.0213, 'lps'),
	(527075, 131, '2014-02-01 00:05:38.000000', 'consum', 0.0220, 'lps'),
	(527076, 131, '2014-02-01 00:05:39.000000', 'consum', 0.0217, 'lps'),
	(527077, 131, '2014-02-01 00:05:40.000000', 'consum', 0.0214, 'lps'),
	(527078, 131, '2014-02-01 00:05:41.000000', 'consum', 0.0226, 'lps'),
	(527079, 131, '2014-02-01 00:05:42.000000', 'consum', 0.0210, 'lps'),
	(527080, 131, '2014-02-01 00:05:43.000000', 'consum', 0.0214, 'lps'),
	(527081, 131, '2014-02-01 00:05:44.000000', 'consum', 0.0213, 'lps'),
	(527082, 131, '2014-02-01 00:05:45.000000', 'consum', 0.0214, 'lps'),
	(527083, 131, '2014-02-01 00:05:46.000000', 'consum', 0.0222, 'lps'),
	(527084, 131, '2014-02-01 00:05:47.000000', 'consum', 0.0222, 'lps'),
	(527085, 131, '2014-02-01 00:05:48.000000', 'consum', 0.0216, 'lps'),
	(527086, 131, '2014-02-01 00:05:49.000000', 'consum', 0.0225, 'lps'),
	(527087, 131, '2014-02-01 00:05:50.000000', 'consum', 0.0210, 'lps'),
	(527088, 131, '2014-02-01 00:05:51.000000', 'consum', 0.0222, 'lps'),
	(527089, 131, '2014-02-01 00:05:52.000000', 'consum', 0.0214, 'lps'),
	(527090, 131, '2014-02-01 00:05:53.000000', 'consum', 0.0213, 'lps'),
	(527091, 131, '2014-02-01 00:05:54.000000', 'consum', 0.0213, 'lps'),
	(527092, 131, '2014-02-01 00:05:55.000000', 'consum', 0.0218, 'lps'),
	(527093, 131, '2014-02-01 00:05:56.000000', 'consum', 0.0221, 'lps'),
	(527094, 131, '2014-02-01 00:05:57.000000', 'consum', 0.0225, 'lps'),
	(527095, 131, '2014-02-01 00:05:58.000000', 'consum', 0.0214, 'lps'),
	(527096, 131, '2014-02-01 00:05:59.000000', 'consum', 0.0225, 'lps'),
	(527097, 131, '2014-02-01 00:06:00.000000', 'consum', 0.0219, 'lps'),
	(527098, 131, '2014-02-01 00:06:01.000000', 'consum', 0.0211, 'lps'),
	(527099, 131, '2014-02-01 00:06:02.000000', 'consum', 0.0222, 'lps'),
	(527100, 131, '2014-02-01 00:06:03.000000', 'consum', 0.0215, 'lps'),
	(527101, 131, '2014-02-01 00:06:04.000000', 'consum', 0.0218, 'lps'),
	(527102, 131, '2014-02-01 00:06:05.000000', 'consum', 0.0217, 'lps'),
	(527103, 131, '2014-02-01 00:06:06.000000', 'consum', 0.0223, 'lps'),
	(527104, 131, '2014-02-01 00:06:07.000000', 'consum', 0.0218, 'lps'),
	(527105, 131, '2014-02-01 00:06:08.000000', 'consum', 0.0211, 'lps'),
	(527106, 131, '2014-02-01 00:06:09.000000', 'consum', 0.0227, 'lps'),
	(527107, 131, '2014-02-01 00:06:10.000000', 'consum', 0.0221, 'lps'),
	(527108, 131, '2014-02-01 00:06:11.000000', 'consum', 0.0215, 'lps'),
	(527109, 131, '2014-02-01 00:06:12.000000', 'consum', 0.0221, 'lps'),
	(527110, 131, '2014-02-01 00:06:13.000000', 'consum', 0.0215, 'lps'),
	(527111, 131, '2014-02-01 00:06:14.000000', 'consum', 0.0221, 'lps'),
	(527112, 131, '2014-02-01 00:06:15.000000', 'consum', 0.0214, 'lps'),
	(527113, 131, '2014-02-01 00:06:16.000000', 'consum', 0.0213, 'lps'),
	(527114, 131, '2014-02-01 00:06:17.000000', 'consum', 0.0216, 'lps'),
	(527115, 131, '2014-02-01 00:06:18.000000', 'consum', 0.0211, 'lps'),
	(527116, 131, '2014-02-01 00:06:19.000000', 'consum', 0.0216, 'lps'),
	(527117, 131, '2014-02-01 00:06:20.000000', 'consum', 0.0219, 'lps'),
	(527118, 131, '2014-02-01 00:06:21.000000', 'consum', 0.0222, 'lps'),
	(527119, 131, '2014-02-01 00:06:22.000000', 'consum', 0.0222, 'lps'),
	(527120, 131, '2014-02-01 00:06:23.000000', 'consum', 0.0219, 'lps'),
	(527121, 131, '2014-02-01 00:06:24.000000', 'consum', 0.0219, 'lps'),
	(527122, 131, '2014-02-01 00:06:25.000000', 'consum', 0.0210, 'lps'),
	(527123, 131, '2014-02-01 00:06:26.000000', 'consum', 0.0221, 'lps'),
	(527124, 131, '2014-02-01 00:06:27.000000', 'consum', 0.0210, 'lps'),
	(527125, 131, '2014-02-01 00:06:28.000000', 'consum', 0.0214, 'lps'),
	(527126, 131, '2014-02-01 00:06:29.000000', 'consum', 0.0211, 'lps'),
	(527127, 131, '2014-02-01 00:06:30.000000', 'consum', 0.0222, 'lps'),
	(527128, 131, '2014-02-01 00:06:31.000000', 'consum', 0.0216, 'lps'),
	(527129, 131, '2014-02-01 00:06:32.000000', 'consum', 0.0219, 'lps'),
	(527130, 131, '2014-02-01 00:06:33.000000', 'consum', 0.0222, 'lps'),
	(527131, 131, '2014-02-01 00:06:34.000000', 'consum', 0.0223, 'lps'),
	(527132, 131, '2014-02-01 00:06:35.000000', 'consum', 0.0224, 'lps'),
	(527133, 131, '2014-02-01 00:06:36.000000', 'consum', 0.0224, 'lps'),
	(527134, 131, '2014-02-01 00:06:37.000000', 'consum', 0.0219, 'lps'),
	(527135, 131, '2014-02-01 00:06:38.000000', 'consum', 0.0214, 'lps'),
	(527136, 131, '2014-02-01 00:06:39.000000', 'consum', 0.0220, 'lps'),
	(527137, 131, '2014-02-01 00:06:40.000000', 'consum', 0.0212, 'lps'),
	(527138, 131, '2014-02-01 00:06:41.000000', 'consum', 0.0210, 'lps'),
	(527139, 131, '2014-02-01 00:06:42.000000', 'consum', 0.0221, 'lps'),
	(527140, 131, '2014-02-01 00:06:43.000000', 'consum', 0.0213, 'lps'),
	(527141, 131, '2014-02-01 00:06:44.000000', 'consum', 0.0226, 'lps'),
	(527142, 131, '2014-02-01 00:06:45.000000', 'consum', 0.0211, 'lps'),
	(527143, 131, '2014-02-01 00:06:46.000000', 'consum', 0.0220, 'lps'),
	(527144, 131, '2014-02-01 00:06:47.000000', 'consum', 0.0221, 'lps'),
	(527145, 131, '2014-02-01 00:06:48.000000', 'consum', 0.0221, 'lps'),
	(527146, 131, '2014-02-01 00:06:49.000000', 'consum', 0.0211, 'lps'),
	(527147, 131, '2014-02-01 00:06:50.000000', 'consum', 0.0220, 'lps'),
	(527148, 131, '2014-02-01 00:06:51.000000', 'consum', 0.0222, 'lps'),
	(527149, 131, '2014-02-01 00:06:52.000000', 'consum', 0.0221, 'lps'),
	(527150, 131, '2014-02-01 00:06:53.000000', 'consum', 0.0212, 'lps'),
	(527151, 131, '2014-02-01 00:06:54.000000', 'consum', 0.0223, 'lps'),
	(527152, 131, '2014-02-01 00:06:55.000000', 'consum', 0.0218, 'lps'),
	(527153, 131, '2014-02-01 00:06:56.000000', 'consum', 0.0227, 'lps'),
	(527154, 131, '2014-02-01 00:06:57.000000', 'consum', 0.0220, 'lps'),
	(527155, 131, '2014-02-01 00:06:58.000000', 'consum', 0.0224, 'lps'),
	(527156, 131, '2014-02-01 00:06:59.000000', 'consum', 0.0217, 'lps'),
	(527157, 131, '2014-02-01 00:07:00.000000', 'consum', 0.0220, 'lps'),
	(527158, 131, '2014-02-01 00:07:01.000000', 'consum', 0.0223, 'lps'),
	(527159, 131, '2014-02-01 00:07:02.000000', 'consum', 0.0226, 'lps'),
	(527160, 131, '2014-02-01 00:07:03.000000', 'consum', 0.0216, 'lps'),
	(527161, 131, '2014-02-01 00:07:04.000000', 'consum', 0.0212, 'lps'),
	(527162, 131, '2014-02-01 00:07:05.000000', 'consum', 0.0221, 'lps'),
	(527163, 131, '2014-02-01 00:07:06.000000', 'consum', 0.0221, 'lps'),
	(527164, 131, '2014-02-01 00:07:07.000000', 'consum', 0.0217, 'lps'),
	(527165, 131, '2014-02-01 00:07:08.000000', 'consum', 0.0212, 'lps'),
	(527166, 131, '2014-02-01 00:07:09.000000', 'consum', 0.0215, 'lps'),
	(527167, 131, '2014-02-01 00:07:10.000000', 'consum', 0.0215, 'lps'),
	(527168, 131, '2014-02-01 00:07:11.000000', 'consum', 0.0219, 'lps'),
	(527169, 131, '2014-02-01 00:07:12.000000', 'consum', 0.0224, 'lps'),
	(527170, 131, '2014-02-01 00:07:13.000000', 'consum', 0.0216, 'lps'),
	(527171, 131, '2014-02-01 00:07:14.000000', 'consum', 0.0216, 'lps'),
	(527172, 131, '2014-02-01 00:07:15.000000', 'consum', 0.0221, 'lps'),
	(527173, 131, '2014-02-01 00:07:16.000000', 'consum', 0.0214, 'lps'),
	(527174, 131, '2014-02-01 00:07:17.000000', 'consum', 0.0215, 'lps'),
	(527175, 131, '2014-02-01 00:07:18.000000', 'consum', 0.0222, 'lps'),
	(527176, 131, '2014-02-01 00:07:19.000000', 'consum', 0.0222, 'lps'),
	(527177, 131, '2014-02-01 00:07:20.000000', 'consum', 0.0215, 'lps'),
	(527178, 131, '2014-02-01 00:07:21.000000', 'consum', 0.0217, 'lps'),
	(527179, 131, '2014-02-01 00:07:22.000000', 'consum', 0.0213, 'lps'),
	(527180, 131, '2014-02-01 00:07:23.000000', 'consum', 0.0221, 'lps'),
	(527181, 131, '2014-02-01 00:07:24.000000', 'consum', 0.0220, 'lps'),
	(527182, 131, '2014-02-01 00:07:25.000000', 'consum', 0.0212, 'lps'),
	(527183, 131, '2014-02-01 00:07:26.000000', 'consum', 0.0226, 'lps'),
	(527184, 131, '2014-02-01 00:07:27.000000', 'consum', 0.0212, 'lps'),
	(527185, 131, '2014-02-01 00:07:28.000000', 'consum', 0.0210, 'lps'),
	(527186, 131, '2014-02-01 00:07:29.000000', 'consum', 0.0224, 'lps'),
	(527187, 131, '2014-02-01 00:07:30.000000', 'consum', 0.0223, 'lps'),
	(527188, 131, '2014-02-01 00:07:31.000000', 'consum', 0.0217, 'lps'),
	(527189, 131, '2014-02-01 00:07:32.000000', 'consum', 0.0224, 'lps'),
	(527190, 131, '2014-02-01 00:07:33.000000', 'consum', 0.0223, 'lps'),
	(527191, 131, '2014-02-01 00:07:34.000000', 'consum', 0.0216, 'lps'),
	(527192, 131, '2014-02-01 00:07:35.000000', 'consum', 0.0218, 'lps'),
	(527193, 131, '2014-02-01 00:07:36.000000', 'consum', 0.0215, 'lps'),
	(527194, 131, '2014-02-01 00:07:37.000000', 'consum', 0.0210, 'lps'),
	(527195, 131, '2014-02-01 00:07:38.000000', 'consum', 0.0214, 'lps'),
	(527196, 131, '2014-02-01 00:07:39.000000', 'consum', 0.0214, 'lps'),
	(527197, 131, '2014-02-01 00:07:40.000000', 'consum', 0.0216, 'lps'),
	(527198, 131, '2014-02-01 00:07:41.000000', 'consum', 0.0213, 'lps'),
	(527199, 131, '2014-02-01 00:07:42.000000', 'consum', 0.0224, 'lps'),
	(527200, 131, '2014-02-01 00:07:43.000000', 'consum', 0.0219, 'lps'),
	(527201, 131, '2014-02-01 00:07:44.000000', 'consum', 0.0213, 'lps'),
	(527202, 131, '2014-02-01 00:07:45.000000', 'consum', 0.0216, 'lps'),
	(527203, 131, '2014-02-01 00:07:46.000000', 'consum', 0.0216, 'lps'),
	(527204, 131, '2014-02-01 00:07:47.000000', 'consum', 0.0219, 'lps'),
	(527205, 131, '2014-02-01 00:07:48.000000', 'consum', 0.0220, 'lps'),
	(527206, 131, '2014-02-01 00:07:49.000000', 'consum', 0.0216, 'lps'),
	(527207, 131, '2014-02-01 00:07:50.000000', 'consum', 0.0212, 'lps'),
	(527208, 131, '2014-02-01 00:07:51.000000', 'consum', 0.0221, 'lps'),
	(527209, 131, '2014-02-01 00:07:52.000000', 'consum', 0.0222, 'lps'),
	(527210, 131, '2014-02-01 00:07:53.000000', 'consum', 0.0219, 'lps'),
	(527211, 131, '2014-02-01 00:07:54.000000', 'consum', 0.0221, 'lps'),
	(527212, 131, '2014-02-01 00:07:55.000000', 'consum', 0.0220, 'lps'),
	(527213, 131, '2014-02-01 00:07:56.000000', 'consum', 0.0211, 'lps'),
	(527214, 131, '2014-02-01 00:07:57.000000', 'consum', 0.0219, 'lps'),
	(527215, 131, '2014-02-01 00:07:58.000000', 'consum', 0.0219, 'lps'),
	(527216, 131, '2014-02-01 00:07:59.000000', 'consum', 0.0227, 'lps'),
	(527217, 131, '2014-02-01 00:08:00.000000', 'consum', 0.0214, 'lps'),
	(527218, 131, '2014-02-01 00:08:01.000000', 'consum', 0.0215, 'lps'),
	(527219, 131, '2014-02-01 00:08:02.000000', 'consum', 0.0223, 'lps'),
	(527220, 131, '2014-02-01 00:08:03.000000', 'consum', 0.0226, 'lps'),
	(527221, 131, '2014-02-01 00:08:04.000000', 'consum', 0.0216, 'lps'),
	(527222, 131, '2014-02-01 00:08:05.000000', 'consum', 0.0211, 'lps'),
	(527223, 131, '2014-02-01 00:08:06.000000', 'consum', 0.0215, 'lps'),
	(527224, 131, '2014-02-01 00:08:07.000000', 'consum', 0.0215, 'lps'),
	(527225, 131, '2014-02-01 00:08:08.000000', 'consum', 0.0221, 'lps'),
	(527226, 131, '2014-02-01 00:08:09.000000', 'consum', 0.0214, 'lps'),
	(527227, 131, '2014-02-01 00:08:10.000000', 'consum', 0.0216, 'lps'),
	(527228, 131, '2014-02-01 00:08:11.000000', 'consum', 0.0212, 'lps'),
	(527229, 131, '2014-02-01 00:08:12.000000', 'consum', 0.0219, 'lps'),
	(527230, 131, '2014-02-01 00:08:13.000000', 'consum', 0.0215, 'lps'),
	(527231, 131, '2014-02-01 00:08:14.000000', 'consum', 0.0224, 'lps'),
	(527232, 131, '2014-02-01 00:08:15.000000', 'consum', 0.0214, 'lps'),
	(527233, 131, '2014-02-01 00:08:16.000000', 'consum', 0.0224, 'lps'),
	(527234, 131, '2014-02-01 00:08:17.000000', 'consum', 0.0215, 'lps'),
	(527235, 131, '2014-02-01 00:08:18.000000', 'consum', 0.0212, 'lps'),
	(527236, 131, '2014-02-01 00:08:19.000000', 'consum', 0.0224, 'lps'),
	(527237, 131, '2014-02-01 00:08:20.000000', 'consum', 0.0219, 'lps'),
	(527238, 131, '2014-02-01 00:08:21.000000', 'consum', 0.0214, 'lps'),
	(527239, 131, '2014-02-01 00:08:22.000000', 'consum', 0.0224, 'lps'),
	(527240, 131, '2014-02-01 00:08:23.000000', 'consum', 0.0211, 'lps'),
	(527241, 131, '2014-02-01 00:08:24.000000', 'consum', 0.0227, 'lps'),
	(527242, 131, '2014-02-01 00:08:25.000000', 'consum', 0.0223, 'lps'),
	(527243, 131, '2014-02-01 00:08:26.000000', 'consum', 0.0223, 'lps'),
	(527244, 131, '2014-02-01 00:08:27.000000', 'consum', 0.0220, 'lps'),
	(527245, 131, '2014-02-01 00:08:28.000000', 'consum', 0.0219, 'lps'),
	(527246, 131, '2014-02-01 00:08:29.000000', 'consum', 0.0210, 'lps'),
	(527247, 131, '2014-02-01 00:08:30.000000', 'consum', 0.0219, 'lps'),
	(527248, 131, '2014-02-01 00:08:31.000000', 'consum', 0.0219, 'lps'),
	(527249, 131, '2014-02-01 00:08:32.000000', 'consum', 0.0211, 'lps'),
	(527250, 131, '2014-02-01 00:08:33.000000', 'consum', 0.0223, 'lps'),
	(527251, 131, '2014-02-01 00:08:34.000000', 'consum', 0.0218, 'lps'),
	(527252, 131, '2014-02-01 00:08:35.000000', 'consum', 0.0212, 'lps'),
	(527253, 131, '2014-02-01 00:08:36.000000', 'consum', 0.0215, 'lps'),
	(527254, 131, '2014-02-01 00:08:37.000000', 'consum', 0.0212, 'lps'),
	(527255, 131, '2014-02-01 00:08:38.000000', 'consum', 0.0222, 'lps'),
	(527256, 131, '2014-02-01 00:08:39.000000', 'consum', 0.0211, 'lps'),
	(527257, 131, '2014-02-01 00:08:40.000000', 'consum', 0.0214, 'lps'),
	(527258, 131, '2014-02-01 00:08:41.000000', 'consum', 0.0211, 'lps'),
	(527259, 131, '2014-02-01 00:08:42.000000', 'consum', 0.0223, 'lps'),
	(527260, 131, '2014-02-01 00:08:43.000000', 'consum', 0.0219, 'lps'),
	(527261, 131, '2014-02-01 00:08:44.000000', 'consum', 0.0215, 'lps'),
	(527262, 131, '2014-02-01 00:08:45.000000', 'consum', 0.0227, 'lps'),
	(527263, 131, '2014-02-01 00:08:46.000000', 'consum', 0.0226, 'lps'),
	(527264, 131, '2014-02-01 00:08:47.000000', 'consum', 0.0222, 'lps'),
	(527265, 131, '2014-02-01 00:08:48.000000', 'consum', 0.0222, 'lps'),
	(527266, 131, '2014-02-01 00:08:49.000000', 'consum', 0.0216, 'lps'),
	(527267, 131, '2014-02-01 00:08:50.000000', 'consum', 0.0221, 'lps'),
	(527268, 131, '2014-02-01 00:08:51.000000', 'consum', 0.0214, 'lps'),
	(527269, 131, '2014-02-01 00:08:52.000000', 'consum', 0.0216, 'lps'),
	(527270, 131, '2014-02-01 00:08:53.000000', 'consum', 0.0211, 'lps'),
	(527271, 131, '2014-02-01 00:08:54.000000', 'consum', 0.0215, 'lps'),
	(527272, 131, '2014-02-01 00:08:55.000000', 'consum', 0.0212, 'lps'),
	(527273, 131, '2014-02-01 00:08:56.000000', 'consum', 0.0225, 'lps'),
	(527274, 131, '2014-02-01 00:08:57.000000', 'consum', 0.0226, 'lps'),
	(527275, 131, '2014-02-01 00:08:58.000000', 'consum', 0.0211, 'lps'),
	(527276, 131, '2014-02-01 00:08:59.000000', 'consum', 0.0221, 'lps'),
	(527277, 131, '2014-02-01 00:09:00.000000', 'consum', 0.0227, 'lps'),
	(527278, 131, '2014-02-01 00:09:01.000000', 'consum', 0.0210, 'lps'),
	(527279, 131, '2014-02-01 00:09:02.000000', 'consum', 0.0211, 'lps'),
	(527280, 131, '2014-02-01 00:09:03.000000', 'consum', 0.0214, 'lps'),
	(527281, 131, '2014-02-01 00:09:04.000000', 'consum', 0.0212, 'lps'),
	(527282, 131, '2014-02-01 00:09:05.000000', 'consum', 0.0226, 'lps'),
	(527283, 131, '2014-02-01 00:09:06.000000', 'consum', 0.0213, 'lps'),
	(527284, 131, '2014-02-01 00:09:07.000000', 'consum', 0.0215, 'lps'),
	(527285, 131, '2014-02-01 00:09:08.000000', 'consum', 0.0226, 'lps'),
	(527286, 131, '2014-02-01 00:09:09.000000', 'consum', 0.0219, 'lps'),
	(527287, 131, '2014-02-01 00:09:10.000000', 'consum', 0.0227, 'lps'),
	(527288, 131, '2014-02-01 00:09:11.000000', 'consum', 0.0215, 'lps'),
	(527289, 131, '2014-02-01 00:09:12.000000', 'consum', 0.0219, 'lps'),
	(527290, 131, '2014-02-01 00:09:13.000000', 'consum', 0.0224, 'lps'),
	(527291, 131, '2014-02-01 00:09:14.000000', 'consum', 0.0215, 'lps'),
	(527292, 131, '2014-02-01 00:09:15.000000', 'consum', 0.0214, 'lps'),
	(527293, 131, '2014-02-01 00:09:16.000000', 'consum', 0.0216, 'lps'),
	(527294, 131, '2014-02-01 00:09:17.000000', 'consum', 0.0210, 'lps'),
	(527295, 131, '2014-02-01 00:09:18.000000', 'consum', 0.0211, 'lps'),
	(527296, 131, '2014-02-01 00:09:19.000000', 'consum', 0.0213, 'lps'),
	(527297, 131, '2014-02-01 00:09:20.000000', 'consum', 0.0223, 'lps'),
	(527298, 131, '2014-02-01 00:09:21.000000', 'consum', 0.0213, 'lps'),
	(527299, 131, '2014-02-01 00:09:22.000000', 'consum', 0.0224, 'lps'),
	(527300, 131, '2014-02-01 00:09:23.000000', 'consum', 0.0218, 'lps'),
	(527301, 131, '2014-02-01 00:09:24.000000', 'consum', 0.0227, 'lps'),
	(527302, 131, '2014-02-01 00:09:25.000000', 'consum', 0.0215, 'lps'),
	(527303, 131, '2014-02-01 00:09:26.000000', 'consum', 0.0223, 'lps'),
	(527304, 131, '2014-02-01 00:09:27.000000', 'consum', 0.0222, 'lps'),
	(527305, 131, '2014-02-01 00:09:28.000000', 'consum', 0.0216, 'lps'),
	(527306, 131, '2014-02-01 00:09:29.000000', 'consum', 0.0220, 'lps'),
	(527307, 131, '2014-02-01 00:09:30.000000', 'consum', 0.0227, 'lps'),
	(527308, 131, '2014-02-01 00:09:31.000000', 'consum', 0.0212, 'lps'),
	(527309, 131, '2014-02-01 00:09:32.000000', 'consum', 0.0222, 'lps'),
	(527310, 131, '2014-02-01 00:09:33.000000', 'consum', 0.0212, 'lps'),
	(527311, 131, '2014-02-01 00:09:34.000000', 'consum', 0.0221, 'lps'),
	(527312, 131, '2014-02-01 00:09:35.000000', 'consum', 0.0222, 'lps'),
	(527313, 131, '2014-02-01 00:09:36.000000', 'consum', 0.0221, 'lps'),
	(527314, 131, '2014-02-01 00:09:37.000000', 'consum', 0.0227, 'lps'),
	(527315, 131, '2014-02-01 00:09:38.000000', 'consum', 0.0227, 'lps'),
	(527316, 131, '2014-02-01 00:09:39.000000', 'consum', 0.0226, 'lps'),
	(527317, 131, '2014-02-01 00:09:40.000000', 'consum', 0.0222, 'lps'),
	(527318, 131, '2014-02-01 00:09:41.000000', 'consum', 0.0222, 'lps'),
	(527319, 131, '2014-02-01 00:09:42.000000', 'consum', 0.0219, 'lps'),
	(527320, 131, '2014-02-01 00:09:43.000000', 'consum', 0.0218, 'lps'),
	(527321, 131, '2014-02-01 00:09:44.000000', 'consum', 0.0225, 'lps'),
	(527322, 131, '2014-02-01 00:09:45.000000', 'consum', 0.0223, 'lps'),
	(527323, 131, '2014-02-01 00:09:46.000000', 'consum', 0.0214, 'lps'),
	(527324, 131, '2014-02-01 00:09:47.000000', 'consum', 0.0210, 'lps'),
	(527325, 131, '2014-02-01 00:09:48.000000', 'consum', 0.0214, 'lps'),
	(527326, 131, '2014-02-01 00:09:49.000000', 'consum', 0.0215, 'lps'),
	(527327, 131, '2014-02-01 00:09:50.000000', 'consum', 0.0222, 'lps'),
	(527328, 131, '2014-02-01 00:09:51.000000', 'consum', 0.0220, 'lps'),
	(527329, 131, '2014-02-01 00:09:52.000000', 'consum', 0.0223, 'lps'),
	(527330, 131, '2014-02-01 00:09:53.000000', 'consum', 0.0211, 'lps'),
	(527331, 131, '2014-02-01 00:09:54.000000', 'consum', 0.0213, 'lps'),
	(527332, 131, '2014-02-01 00:09:55.000000', 'consum', 0.0222, 'lps'),
	(527333, 131, '2014-02-01 00:09:56.000000', 'consum', 0.0226, 'lps'),
	(527334, 131, '2014-02-01 00:09:57.000000', 'consum', 0.0219, 'lps'),
	(527335, 131, '2014-02-01 00:09:58.000000', 'consum', 0.0226, 'lps'),
	(527336, 131, '2014-02-01 00:09:59.000000', 'consum', 0.0227, 'lps'),
	(527337, 131, '2014-02-01 00:10:00.000000', 'consum', 0.0211, 'lps'),
	(527338, 131, '2014-02-01 00:10:01.000000', 'consum', 0.0221, 'lps'),
	(527339, 131, '2014-02-01 00:10:02.000000', 'consum', 0.0223, 'lps'),
	(527340, 131, '2014-02-01 00:10:03.000000', 'consum', 0.0226, 'lps'),
	(527341, 131, '2014-02-01 00:10:04.000000', 'consum', 0.0217, 'lps'),
	(527342, 131, '2014-02-01 00:10:05.000000', 'consum', 0.0216, 'lps'),
	(527343, 131, '2014-02-01 00:10:06.000000', 'consum', 0.0219, 'lps'),
	(527344, 131, '2014-02-01 00:10:07.000000', 'consum', 0.0221, 'lps'),
	(527345, 131, '2014-02-01 00:10:08.000000', 'consum', 0.0220, 'lps'),
	(527346, 131, '2014-02-01 00:10:09.000000', 'consum', 0.0225, 'lps'),
	(527347, 131, '2014-02-01 00:10:10.000000', 'consum', 0.0222, 'lps'),
	(527348, 131, '2014-02-01 00:10:11.000000', 'consum', 0.0223, 'lps'),
	(527349, 131, '2014-02-01 00:10:12.000000', 'consum', 0.0224, 'lps'),
	(527350, 131, '2014-02-01 00:10:13.000000', 'consum', 0.0222, 'lps'),
	(527351, 131, '2014-02-01 00:10:14.000000', 'consum', 0.0212, 'lps'),
	(527352, 131, '2014-02-01 00:10:15.000000', 'consum', 0.0220, 'lps'),
	(527353, 131, '2014-02-01 00:10:16.000000', 'consum', 0.0218, 'lps'),
	(527354, 131, '2014-02-01 00:10:17.000000', 'consum', 0.0222, 'lps'),
	(527355, 131, '2014-02-01 00:10:18.000000', 'consum', 0.0211, 'lps'),
	(527356, 131, '2014-02-01 00:10:19.000000', 'consum', 0.0214, 'lps'),
	(527357, 131, '2014-02-01 00:10:20.000000', 'consum', 0.0211, 'lps'),
	(527358, 131, '2014-02-01 00:10:21.000000', 'consum', 0.0220, 'lps'),
	(527359, 131, '2014-02-01 00:10:22.000000', 'consum', 0.0222, 'lps'),
	(527360, 131, '2014-02-01 00:10:23.000000', 'consum', 0.0223, 'lps'),
	(527361, 131, '2014-02-01 00:10:24.000000', 'consum', 0.0221, 'lps'),
	(527362, 131, '2014-02-01 00:10:25.000000', 'consum', 0.0226, 'lps'),
	(527363, 131, '2014-02-01 00:10:26.000000', 'consum', 0.0220, 'lps'),
	(527364, 131, '2014-02-01 00:10:27.000000', 'consum', 0.0216, 'lps'),
	(527365, 131, '2014-02-01 00:10:28.000000', 'consum', 0.0227, 'lps'),
	(527366, 131, '2014-02-01 00:10:29.000000', 'consum', 0.0222, 'lps'),
	(527367, 131, '2014-02-01 00:10:30.000000', 'consum', 0.0221, 'lps'),
	(527368, 131, '2014-02-01 00:10:31.000000', 'consum', 0.0211, 'lps'),
	(527369, 131, '2014-02-01 00:10:32.000000', 'consum', 0.0217, 'lps'),
	(527370, 131, '2014-02-01 00:10:33.000000', 'consum', 0.0223, 'lps'),
	(527371, 131, '2014-02-01 00:10:34.000000', 'consum', 0.0222, 'lps'),
	(527372, 131, '2014-02-01 00:10:35.000000', 'consum', 0.0214, 'lps'),
	(527373, 131, '2014-02-01 00:10:36.000000', 'consum', 0.0212, 'lps'),
	(527374, 131, '2014-02-01 00:10:37.000000', 'consum', 0.0210, 'lps'),
	(527375, 131, '2014-02-01 00:10:38.000000', 'consum', 0.0220, 'lps'),
	(527376, 131, '2014-02-01 00:10:39.000000', 'consum', 0.0227, 'lps'),
	(527377, 131, '2014-02-01 00:10:40.000000', 'consum', 0.0211, 'lps'),
	(527378, 131, '2014-02-01 00:10:41.000000', 'consum', 0.0217, 'lps'),
	(527379, 131, '2014-02-01 00:10:42.000000', 'consum', 0.0225, 'lps'),
	(527380, 131, '2014-02-01 00:10:43.000000', 'consum', 0.0210, 'lps'),
	(527381, 131, '2014-02-01 00:10:44.000000', 'consum', 0.0219, 'lps'),
	(527382, 131, '2014-02-01 00:10:45.000000', 'consum', 0.0220, 'lps'),
	(527383, 131, '2014-02-01 00:10:46.000000', 'consum', 0.0214, 'lps'),
	(527384, 131, '2014-02-01 00:10:47.000000', 'consum', 0.0219, 'lps'),
	(527385, 131, '2014-02-01 00:10:48.000000', 'consum', 0.0224, 'lps'),
	(527386, 131, '2014-02-01 00:10:49.000000', 'consum', 0.0221, 'lps'),
	(527387, 131, '2014-02-01 00:10:50.000000', 'consum', 0.0221, 'lps'),
	(527388, 131, '2014-02-01 00:10:51.000000', 'consum', 0.0214, 'lps'),
	(527389, 131, '2014-02-01 00:10:52.000000', 'consum', 0.0218, 'lps'),
	(527390, 131, '2014-02-01 00:10:53.000000', 'consum', 0.0221, 'lps'),
	(527391, 131, '2014-02-01 00:10:54.000000', 'consum', 0.0223, 'lps'),
	(527392, 131, '2014-02-01 00:10:55.000000', 'consum', 0.0222, 'lps'),
	(527393, 131, '2014-02-01 00:10:56.000000', 'consum', 0.0216, 'lps'),
	(527394, 131, '2014-02-01 00:10:57.000000', 'consum', 0.0223, 'lps'),
	(527395, 131, '2014-02-01 00:10:58.000000', 'consum', 0.0221, 'lps'),
	(527396, 131, '2014-02-01 00:10:59.000000', 'consum', 0.0226, 'lps'),
	(527397, 131, '2014-02-01 00:11:00.000000', 'consum', 0.0224, 'lps'),
	(527398, 131, '2014-02-01 00:11:01.000000', 'consum', 0.0212, 'lps'),
	(527399, 131, '2014-02-01 00:11:02.000000', 'consum', 0.0214, 'lps'),
	(527400, 131, '2014-02-01 00:11:03.000000', 'consum', 0.0224, 'lps'),
	(527401, 131, '2014-02-01 00:11:04.000000', 'consum', 0.0214, 'lps'),
	(527402, 131, '2014-02-01 00:11:05.000000', 'consum', 0.0227, 'lps'),
	(527403, 131, '2014-02-01 00:11:06.000000', 'consum', 0.0227, 'lps'),
	(527404, 131, '2014-02-01 00:11:07.000000', 'consum', 0.0226, 'lps'),
	(527405, 131, '2014-02-01 00:11:08.000000', 'consum', 0.0221, 'lps'),
	(527406, 131, '2014-02-01 00:11:09.000000', 'consum', 0.0219, 'lps'),
	(527407, 131, '2014-02-01 00:11:10.000000', 'consum', 0.0221, 'lps'),
	(527408, 131, '2014-02-01 00:11:11.000000', 'consum', 0.0221, 'lps'),
	(527409, 131, '2014-02-01 00:11:12.000000', 'consum', 0.0216, 'lps'),
	(527410, 131, '2014-02-01 00:11:13.000000', 'consum', 0.0223, 'lps'),
	(527411, 131, '2014-02-01 00:11:14.000000', 'consum', 0.0224, 'lps'),
	(527412, 131, '2014-02-01 00:11:15.000000', 'consum', 0.0222, 'lps'),
	(527413, 131, '2014-02-01 00:11:16.000000', 'consum', 0.0210, 'lps'),
	(527414, 131, '2014-02-01 00:11:17.000000', 'consum', 0.0210, 'lps'),
	(527415, 131, '2014-02-01 00:11:18.000000', 'consum', 0.0211, 'lps'),
	(527416, 131, '2014-02-01 00:11:19.000000', 'consum', 0.0217, 'lps'),
	(527417, 131, '2014-02-01 00:11:20.000000', 'consum', 0.0224, 'lps'),
	(527418, 131, '2014-02-01 00:11:21.000000', 'consum', 0.0223, 'lps'),
	(527419, 131, '2014-02-01 00:11:22.000000', 'consum', 0.0218, 'lps'),
	(527420, 131, '2014-02-01 00:11:23.000000', 'consum', 0.0227, 'lps'),
	(527421, 131, '2014-02-01 00:11:24.000000', 'consum', 0.0218, 'lps'),
	(527422, 131, '2014-02-01 00:11:25.000000', 'consum', 0.0217, 'lps'),
	(527423, 131, '2014-02-01 00:11:26.000000', 'consum', 0.0224, 'lps'),
	(527424, 131, '2014-02-01 00:11:27.000000', 'consum', 0.0221, 'lps'),
	(527425, 131, '2014-02-01 00:11:28.000000', 'consum', 0.0224, 'lps'),
	(527426, 131, '2014-02-01 00:11:29.000000', 'consum', 0.0210, 'lps'),
	(527427, 131, '2014-02-01 00:11:30.000000', 'consum', 0.0226, 'lps'),
	(527428, 131, '2014-02-01 00:11:31.000000', 'consum', 0.0215, 'lps'),
	(527429, 131, '2014-02-01 00:11:32.000000', 'consum', 0.0226, 'lps'),
	(527430, 131, '2014-02-01 00:11:33.000000', 'consum', 0.0219, 'lps'),
	(527431, 131, '2014-02-01 00:11:34.000000', 'consum', 0.0226, 'lps'),
	(527432, 131, '2014-02-01 00:11:35.000000', 'consum', 0.0227, 'lps'),
	(527433, 131, '2014-02-01 00:11:36.000000', 'consum', 0.0214, 'lps'),
	(527434, 131, '2014-02-01 00:11:37.000000', 'consum', 0.0215, 'lps'),
	(527435, 131, '2014-02-01 00:11:38.000000', 'consum', 0.0224, 'lps'),
	(527436, 131, '2014-02-01 00:11:39.000000', 'consum', 0.0212, 'lps'),
	(527437, 131, '2014-02-01 00:11:40.000000', 'consum', 0.0213, 'lps'),
	(527438, 131, '2014-02-01 00:11:41.000000', 'consum', 0.0219, 'lps'),
	(527439, 131, '2014-02-01 00:11:42.000000', 'consum', 0.0211, 'lps'),
	(527440, 131, '2014-02-01 00:11:43.000000', 'consum', 0.0225, 'lps'),
	(527441, 131, '2014-02-01 00:11:44.000000', 'consum', 0.0211, 'lps'),
	(527442, 131, '2014-02-01 00:11:45.000000', 'consum', 0.0225, 'lps'),
	(527443, 131, '2014-02-01 00:11:46.000000', 'consum', 0.0226, 'lps'),
	(527444, 131, '2014-02-01 00:11:47.000000', 'consum', 0.0227, 'lps'),
	(527445, 131, '2014-02-01 00:11:48.000000', 'consum', 0.0214, 'lps'),
	(527446, 131, '2014-02-01 00:11:49.000000', 'consum', 0.0215, 'lps'),
	(527447, 131, '2014-02-01 00:11:50.000000', 'consum', 0.0222, 'lps'),
	(527448, 131, '2014-02-01 00:11:51.000000', 'consum', 0.0222, 'lps'),
	(527449, 131, '2014-02-01 00:11:52.000000', 'consum', 0.0215, 'lps'),
	(527450, 131, '2014-02-01 00:11:53.000000', 'consum', 0.0216, 'lps'),
	(527451, 131, '2014-02-01 00:11:54.000000', 'consum', 0.0225, 'lps'),
	(527452, 131, '2014-02-01 00:11:55.000000', 'consum', 0.0217, 'lps'),
	(527453, 131, '2014-02-01 00:11:56.000000', 'consum', 0.0216, 'lps'),
	(527454, 131, '2014-02-01 00:11:57.000000', 'consum', 0.0220, 'lps'),
	(527455, 131, '2014-02-01 00:11:58.000000', 'consum', 0.0224, 'lps'),
	(527456, 131, '2014-02-01 00:11:59.000000', 'consum', 0.0216, 'lps'),
	(527457, 131, '2014-02-01 00:12:00.000000', 'consum', 0.0214, 'lps'),
	(527458, 131, '2014-02-01 00:12:01.000000', 'consum', 0.0214, 'lps'),
	(527459, 131, '2014-02-01 00:12:02.000000', 'consum', 0.0218, 'lps'),
	(527460, 131, '2014-02-01 00:12:03.000000', 'consum', 0.0223, 'lps'),
	(527461, 131, '2014-02-01 00:12:04.000000', 'consum', 0.0212, 'lps'),
	(527462, 131, '2014-02-01 00:12:05.000000', 'consum', 0.0218, 'lps'),
	(527463, 131, '2014-02-01 00:12:06.000000', 'consum', 0.0226, 'lps'),
	(527464, 131, '2014-02-01 00:12:07.000000', 'consum', 0.0214, 'lps'),
	(527465, 131, '2014-02-01 00:12:08.000000', 'consum', 0.0219, 'lps'),
	(527466, 131, '2014-02-01 00:12:09.000000', 'consum', 0.0227, 'lps'),
	(527467, 131, '2014-02-01 00:12:10.000000', 'consum', 0.0213, 'lps'),
	(527468, 131, '2014-02-01 00:12:11.000000', 'consum', 0.0226, 'lps'),
	(527469, 131, '2014-02-01 00:12:12.000000', 'consum', 0.0213, 'lps'),
	(527470, 131, '2014-02-01 00:12:13.000000', 'consum', 0.0211, 'lps'),
	(527471, 131, '2014-02-01 00:12:14.000000', 'consum', 0.0226, 'lps'),
	(527472, 131, '2014-02-01 00:12:15.000000', 'consum', 0.0216, 'lps'),
	(527473, 131, '2014-02-01 00:12:16.000000', 'consum', 0.0226, 'lps'),
	(527474, 131, '2014-02-01 00:12:17.000000', 'consum', 0.0222, 'lps'),
	(527475, 131, '2014-02-01 00:12:18.000000', 'consum', 0.0219, 'lps'),
	(527476, 131, '2014-02-01 00:12:19.000000', 'consum', 0.0222, 'lps'),
	(527477, 131, '2014-02-01 00:12:20.000000', 'consum', 0.0226, 'lps'),
	(527478, 131, '2014-02-01 00:12:21.000000', 'consum', 0.0219, 'lps'),
	(527479, 131, '2014-02-01 00:12:22.000000', 'consum', 0.0226, 'lps'),
	(527480, 131, '2014-02-01 00:12:23.000000', 'consum', 0.0227, 'lps'),
	(527481, 131, '2014-02-01 00:12:24.000000', 'consum', 0.0210, 'lps'),
	(527482, 131, '2014-02-01 00:12:25.000000', 'consum', 0.0216, 'lps'),
	(527483, 131, '2014-02-01 00:12:26.000000', 'consum', 0.0223, 'lps'),
	(527484, 131, '2014-02-01 00:12:27.000000', 'consum', 0.0218, 'lps'),
	(527485, 131, '2014-02-01 00:12:28.000000', 'consum', 0.0214, 'lps'),
	(527486, 131, '2014-02-01 00:12:29.000000', 'consum', 0.0224, 'lps'),
	(527487, 131, '2014-02-01 00:12:30.000000', 'consum', 0.0213, 'lps'),
	(527488, 131, '2014-02-01 00:12:31.000000', 'consum', 0.0219, 'lps'),
	(527489, 131, '2014-02-01 00:12:32.000000', 'consum', 0.0211, 'lps'),
	(527490, 131, '2014-02-01 00:12:33.000000', 'consum', 0.0226, 'lps'),
	(527491, 131, '2014-02-01 00:12:34.000000', 'consum', 0.0213, 'lps'),
	(527492, 131, '2014-02-01 00:12:35.000000', 'consum', 0.0214, 'lps'),
	(527493, 131, '2014-02-01 00:12:36.000000', 'consum', 0.0220, 'lps'),
	(527494, 131, '2014-02-01 00:12:37.000000', 'consum', 0.0214, 'lps'),
	(527495, 131, '2014-02-01 00:12:38.000000', 'consum', 0.0220, 'lps'),
	(527496, 131, '2014-02-01 00:12:39.000000', 'consum', 0.0210, 'lps'),
	(527497, 131, '2014-02-01 00:12:40.000000', 'consum', 0.0217, 'lps'),
	(527498, 131, '2014-02-01 00:12:41.000000', 'consum', 0.0211, 'lps'),
	(527499, 131, '2014-02-01 00:12:42.000000', 'consum', 0.0212, 'lps'),
	(527500, 131, '2014-02-01 00:12:43.000000', 'consum', 0.0218, 'lps'),
	(527501, 131, '2014-02-01 00:12:44.000000', 'consum', 0.0225, 'lps'),
	(527502, 131, '2014-02-01 00:12:45.000000', 'consum', 0.0225, 'lps'),
	(527503, 131, '2014-02-01 00:12:46.000000', 'consum', 0.0222, 'lps'),
	(527504, 131, '2014-02-01 00:12:47.000000', 'consum', 0.0225, 'lps'),
	(527505, 131, '2014-02-01 00:12:48.000000', 'consum', 0.0216, 'lps'),
	(527506, 131, '2014-02-01 00:12:49.000000', 'consum', 0.0211, 'lps'),
	(527507, 131, '2014-02-01 00:12:50.000000', 'consum', 0.0219, 'lps'),
	(527508, 131, '2014-02-01 00:12:51.000000', 'consum', 0.0213, 'lps'),
	(527509, 131, '2014-02-01 00:12:52.000000', 'consum', 0.0219, 'lps'),
	(527510, 131, '2014-02-01 00:12:53.000000', 'consum', 0.0227, 'lps'),
	(527511, 131, '2014-02-01 00:12:54.000000', 'consum', 0.0213, 'lps'),
	(527512, 131, '2014-02-01 00:12:55.000000', 'consum', 0.0212, 'lps'),
	(527513, 131, '2014-02-01 00:12:56.000000', 'consum', 0.0210, 'lps'),
	(527514, 131, '2014-02-01 00:12:57.000000', 'consum', 0.0222, 'lps'),
	(527515, 131, '2014-02-01 00:12:58.000000', 'consum', 0.0217, 'lps'),
	(527516, 131, '2014-02-01 00:12:59.000000', 'consum', 0.0227, 'lps'),
	(527517, 131, '2014-02-01 00:13:00.000000', 'consum', 0.0220, 'lps'),
	(527518, 131, '2014-02-01 00:13:01.000000', 'consum', 0.0210, 'lps'),
	(527519, 131, '2014-02-01 00:13:02.000000', 'consum', 0.0218, 'lps'),
	(527520, 131, '2014-02-01 00:13:03.000000', 'consum', 0.0214, 'lps'),
	(527521, 131, '2014-02-01 00:13:04.000000', 'consum', 0.0223, 'lps'),
	(527522, 131, '2014-02-01 00:13:05.000000', 'consum', 0.0212, 'lps'),
	(527523, 131, '2014-02-01 00:13:06.000000', 'consum', 0.0215, 'lps'),
	(527524, 131, '2014-02-01 00:13:07.000000', 'consum', 0.0212, 'lps'),
	(527525, 131, '2014-02-01 00:13:08.000000', 'consum', 0.0225, 'lps'),
	(527526, 131, '2014-02-01 00:13:09.000000', 'consum', 0.0224, 'lps'),
	(527527, 131, '2014-02-01 00:13:10.000000', 'consum', 0.0218, 'lps'),
	(527528, 131, '2014-02-01 00:13:11.000000', 'consum', 0.0225, 'lps'),
	(527529, 131, '2014-02-01 00:13:12.000000', 'consum', 0.0227, 'lps'),
	(527530, 131, '2014-02-01 00:13:13.000000', 'consum', 0.0213, 'lps'),
	(527531, 131, '2014-02-01 00:13:14.000000', 'consum', 0.0211, 'lps'),
	(527532, 131, '2014-02-01 00:13:15.000000', 'consum', 0.0224, 'lps'),
	(527533, 131, '2014-02-01 00:13:16.000000', 'consum', 0.0224, 'lps'),
	(527534, 131, '2014-02-01 00:13:17.000000', 'consum', 0.0221, 'lps'),
	(527535, 131, '2014-02-01 00:13:18.000000', 'consum', 0.0224, 'lps'),
	(527536, 131, '2014-02-01 00:13:19.000000', 'consum', 0.0212, 'lps'),
	(527537, 131, '2014-02-01 00:13:20.000000', 'consum', 0.0215, 'lps'),
	(527538, 131, '2014-02-01 00:13:21.000000', 'consum', 0.0212, 'lps'),
	(527539, 131, '2014-02-01 00:13:22.000000', 'consum', 0.0222, 'lps'),
	(527540, 131, '2014-02-01 00:13:23.000000', 'consum', 0.0210, 'lps'),
	(527541, 131, '2014-02-01 00:13:24.000000', 'consum', 0.0212, 'lps'),
	(527542, 131, '2014-02-01 00:13:25.000000', 'consum', 0.0219, 'lps'),
	(527543, 131, '2014-02-01 00:13:26.000000', 'consum', 0.0215, 'lps'),
	(527544, 131, '2014-02-01 00:13:27.000000', 'consum', 0.0226, 'lps'),
	(527545, 131, '2014-02-01 00:13:28.000000', 'consum', 0.0223, 'lps'),
	(527546, 131, '2014-02-01 00:13:29.000000', 'consum', 0.0227, 'lps'),
	(527547, 131, '2014-02-01 00:13:30.000000', 'consum', 0.0218, 'lps'),
	(527548, 131, '2014-02-01 00:13:31.000000', 'consum', 0.0221, 'lps'),
	(527549, 131, '2014-02-01 00:13:32.000000', 'consum', 0.0222, 'lps'),
	(527550, 131, '2014-02-01 00:13:33.000000', 'consum', 0.0220, 'lps'),
	(527551, 131, '2014-02-01 00:13:34.000000', 'consum', 0.0222, 'lps'),
	(527552, 131, '2014-02-01 00:13:35.000000', 'consum', 0.0226, 'lps'),
	(527553, 131, '2014-02-01 00:13:36.000000', 'consum', 0.0216, 'lps'),
	(527554, 131, '2014-02-01 00:13:37.000000', 'consum', 0.0227, 'lps'),
	(527555, 131, '2014-02-01 00:13:38.000000', 'consum', 0.0227, 'lps'),
	(527556, 131, '2014-02-01 00:13:39.000000', 'consum', 0.0224, 'lps'),
	(527557, 131, '2014-02-01 00:13:40.000000', 'consum', 0.0211, 'lps'),
	(527558, 131, '2014-02-01 00:13:41.000000', 'consum', 0.0211, 'lps'),
	(527559, 131, '2014-02-01 00:13:42.000000', 'consum', 0.0214, 'lps'),
	(527560, 131, '2014-02-01 00:13:43.000000', 'consum', 0.0227, 'lps'),
	(527561, 131, '2014-02-01 00:13:44.000000', 'consum', 0.0211, 'lps'),
	(527562, 131, '2014-02-01 00:13:45.000000', 'consum', 0.0217, 'lps'),
	(527563, 131, '2014-02-01 00:13:46.000000', 'consum', 0.0226, 'lps'),
	(527564, 131, '2014-02-01 00:13:47.000000', 'consum', 0.0217, 'lps'),
	(527565, 131, '2014-02-01 00:13:48.000000', 'consum', 0.0213, 'lps'),
	(527566, 131, '2014-02-01 00:13:49.000000', 'consum', 0.0225, 'lps'),
	(527567, 131, '2014-02-01 00:13:50.000000', 'consum', 0.0220, 'lps'),
	(527568, 131, '2014-02-01 00:13:51.000000', 'consum', 0.0217, 'lps'),
	(527569, 131, '2014-02-01 00:13:52.000000', 'consum', 0.0216, 'lps'),
	(527570, 131, '2014-02-01 00:13:53.000000', 'consum', 0.0217, 'lps'),
	(527571, 131, '2014-02-01 00:13:54.000000', 'consum', 0.0212, 'lps'),
	(527572, 131, '2014-02-01 00:13:55.000000', 'consum', 0.0215, 'lps'),
	(527573, 131, '2014-02-01 00:13:56.000000', 'consum', 0.0213, 'lps'),
	(527574, 131, '2014-02-01 00:13:57.000000', 'consum', 0.0210, 'lps'),
	(527575, 131, '2014-02-01 00:13:58.000000', 'consum', 0.0221, 'lps'),
	(527576, 131, '2014-02-01 00:13:59.000000', 'consum', 0.0210, 'lps'),
	(527577, 131, '2014-02-01 00:14:00.000000', 'consum', 0.0213, 'lps'),
	(527578, 131, '2014-02-01 00:14:01.000000', 'consum', 0.0226, 'lps'),
	(527579, 131, '2014-02-01 00:14:02.000000', 'consum', 0.0225, 'lps'),
	(527580, 131, '2014-02-01 00:14:03.000000', 'consum', 0.0223, 'lps'),
	(527581, 131, '2014-02-01 00:14:04.000000', 'consum', 0.0213, 'lps'),
	(527582, 131, '2014-02-01 00:14:05.000000', 'consum', 0.0220, 'lps'),
	(527583, 131, '2014-02-01 00:14:06.000000', 'consum', 0.0215, 'lps'),
	(527584, 131, '2014-02-01 00:14:07.000000', 'consum', 0.0226, 'lps'),
	(527585, 131, '2014-02-01 00:14:08.000000', 'consum', 0.0219, 'lps'),
	(527586, 131, '2014-02-01 00:14:09.000000', 'consum', 0.0225, 'lps'),
	(527587, 131, '2014-02-01 00:14:10.000000', 'consum', 0.0222, 'lps'),
	(527588, 131, '2014-02-01 00:14:11.000000', 'consum', 0.0225, 'lps'),
	(527589, 131, '2014-02-01 00:14:12.000000', 'consum', 0.0216, 'lps'),
	(527590, 131, '2014-02-01 00:14:13.000000', 'consum', 0.0211, 'lps'),
	(527591, 131, '2014-02-01 00:14:14.000000', 'consum', 0.0218, 'lps'),
	(527592, 131, '2014-02-01 00:14:15.000000', 'consum', 0.0212, 'lps'),
	(527593, 131, '2014-02-01 00:14:16.000000', 'consum', 0.0214, 'lps'),
	(527594, 131, '2014-02-01 00:14:17.000000', 'consum', 0.0224, 'lps'),
	(527595, 131, '2014-02-01 00:14:18.000000', 'consum', 0.0215, 'lps'),
	(527596, 131, '2014-02-01 00:14:19.000000', 'consum', 0.0213, 'lps'),
	(527597, 131, '2014-02-01 00:14:20.000000', 'consum', 0.0226, 'lps'),
	(527598, 131, '2014-02-01 00:14:21.000000', 'consum', 0.0212, 'lps'),
	(527599, 131, '2014-02-01 00:14:22.000000', 'consum', 0.0226, 'lps'),
	(527600, 131, '2014-02-01 00:14:23.000000', 'consum', 0.0212, 'lps'),
	(527601, 131, '2014-02-01 00:14:24.000000', 'consum', 0.0224, 'lps'),
	(527602, 131, '2014-02-01 00:14:25.000000', 'consum', 0.0224, 'lps'),
	(527603, 131, '2014-02-01 00:14:26.000000', 'consum', 0.0221, 'lps'),
	(527604, 131, '2014-02-01 00:14:27.000000', 'consum', 0.0221, 'lps'),
	(527605, 131, '2014-02-01 00:14:28.000000', 'consum', 0.0214, 'lps'),
	(527606, 131, '2014-02-01 00:14:29.000000', 'consum', 0.0216, 'lps'),
	(527607, 131, '2014-02-01 00:14:30.000000', 'consum', 0.0212, 'lps'),
	(527608, 131, '2014-02-01 00:14:31.000000', 'consum', 0.0219, 'lps'),
	(527609, 131, '2014-02-01 00:14:32.000000', 'consum', 0.0213, 'lps'),
	(527610, 131, '2014-02-01 00:14:33.000000', 'consum', 0.0218, 'lps'),
	(527611, 131, '2014-02-01 00:14:34.000000', 'consum', 0.0225, 'lps'),
	(527612, 131, '2014-02-01 00:14:35.000000', 'consum', 0.0224, 'lps'),
	(527613, 131, '2014-02-01 00:14:36.000000', 'consum', 0.0218, 'lps'),
	(527614, 131, '2014-02-01 00:14:37.000000', 'consum', 0.0210, 'lps'),
	(527615, 131, '2014-02-01 00:14:38.000000', 'consum', 0.0220, 'lps'),
	(527616, 131, '2014-02-01 00:14:39.000000', 'consum', 0.0224, 'lps'),
	(527617, 131, '2014-02-01 00:14:40.000000', 'consum', 0.0214, 'lps'),
	(527618, 131, '2014-02-01 00:14:41.000000', 'consum', 0.0224, 'lps'),
	(527619, 131, '2014-02-01 00:14:42.000000', 'consum', 0.0213, 'lps'),
	(527620, 131, '2014-02-01 00:14:43.000000', 'consum', 0.0223, 'lps'),
	(527621, 131, '2014-02-01 00:14:44.000000', 'consum', 0.0213, 'lps'),
	(527622, 131, '2014-02-01 00:14:45.000000', 'consum', 0.0222, 'lps'),
	(527623, 131, '2014-02-01 00:14:46.000000', 'consum', 0.0224, 'lps'),
	(527624, 131, '2014-02-01 00:14:47.000000', 'consum', 0.0210, 'lps'),
	(527625, 131, '2014-02-01 00:14:48.000000', 'consum', 0.0221, 'lps'),
	(527626, 131, '2014-02-01 00:14:49.000000', 'consum', 0.0213, 'lps'),
	(527627, 131, '2014-02-01 00:14:50.000000', 'consum', 0.0226, 'lps'),
	(527628, 131, '2014-02-01 00:14:51.000000', 'consum', 0.0211, 'lps'),
	(527629, 131, '2014-02-01 00:14:52.000000', 'consum', 0.0220, 'lps'),
	(527630, 131, '2014-02-01 00:14:53.000000', 'consum', 0.0222, 'lps'),
	(527631, 131, '2014-02-01 00:14:54.000000', 'consum', 0.0223, 'lps'),
	(527632, 131, '2014-02-01 00:14:55.000000', 'consum', 0.0221, 'lps'),
	(527633, 131, '2014-02-01 00:14:56.000000', 'consum', 0.0226, 'lps'),
	(527634, 131, '2014-02-01 00:14:57.000000', 'consum', 0.0220, 'lps'),
	(527635, 131, '2014-02-01 00:14:58.000000', 'consum', 0.0214, 'lps'),
	(527636, 131, '2014-02-01 00:14:59.000000', 'consum', 0.0217, 'lps'),
	(527637, 131, '2014-02-01 00:15:00.000000', 'consum', 0.0218, 'lps'),
	(527638, 131, '2014-02-01 00:15:01.000000', 'consum', 0.0212, 'lps'),
	(527639, 131, '2014-02-01 00:15:02.000000', 'consum', 0.0213, 'lps'),
	(527640, 131, '2014-02-01 00:15:03.000000', 'consum', 0.0219, 'lps'),
	(527641, 131, '2014-02-01 00:15:04.000000', 'consum', 0.0227, 'lps'),
	(527642, 131, '2014-02-01 00:15:05.000000', 'consum', 0.0217, 'lps'),
	(527643, 131, '2014-02-01 00:15:06.000000', 'consum', 0.0214, 'lps'),
	(527644, 131, '2014-02-01 00:15:07.000000', 'consum', 0.0224, 'lps'),
	(527645, 131, '2014-02-01 00:15:08.000000', 'consum', 0.0216, 'lps'),
	(527646, 131, '2014-02-01 00:15:09.000000', 'consum', 0.0215, 'lps'),
	(527647, 131, '2014-02-01 00:15:10.000000', 'consum', 0.0220, 'lps'),
	(527648, 131, '2014-02-01 00:15:11.000000', 'consum', 0.0210, 'lps'),
	(527649, 131, '2014-02-01 00:15:12.000000', 'consum', 0.0218, 'lps'),
	(527650, 131, '2014-02-01 00:15:13.000000', 'consum', 0.0211, 'lps'),
	(527651, 131, '2014-02-01 00:15:14.000000', 'consum', 0.0227, 'lps'),
	(527652, 131, '2014-02-01 00:15:15.000000', 'consum', 0.0222, 'lps'),
	(527653, 131, '2014-02-01 00:15:16.000000', 'consum', 0.0218, 'lps'),
	(527654, 131, '2014-02-01 00:15:17.000000', 'consum', 0.0216, 'lps'),
	(527655, 131, '2014-02-01 00:15:18.000000', 'consum', 0.0215, 'lps'),
	(527656, 131, '2014-02-01 00:15:19.000000', 'consum', 0.0219, 'lps'),
	(527657, 131, '2014-02-01 00:15:20.000000', 'consum', 0.0224, 'lps'),
	(527658, 131, '2014-02-01 00:15:21.000000', 'consum', 0.0215, 'lps'),
	(527659, 131, '2014-02-01 00:15:22.000000', 'consum', 0.0211, 'lps'),
	(527660, 131, '2014-02-01 00:15:23.000000', 'consum', 0.0221, 'lps'),
	(527661, 131, '2014-02-01 00:15:24.000000', 'consum', 0.0224, 'lps'),
	(527662, 131, '2014-02-01 00:15:25.000000', 'consum', 0.0212, 'lps'),
	(527663, 131, '2014-02-01 00:15:26.000000', 'consum', 0.0215, 'lps'),
	(527664, 131, '2014-02-01 00:15:27.000000', 'consum', 0.0211, 'lps'),
	(527665, 131, '2014-02-01 00:15:28.000000', 'consum', 0.0219, 'lps'),
	(527666, 131, '2014-02-01 00:15:29.000000', 'consum', 0.0215, 'lps'),
	(527667, 131, '2014-02-01 00:15:30.000000', 'consum', 0.0226, 'lps'),
	(527668, 131, '2014-02-01 00:15:31.000000', 'consum', 0.0224, 'lps'),
	(527669, 131, '2014-02-01 00:15:32.000000', 'consum', 0.0214, 'lps'),
	(527670, 131, '2014-02-01 00:15:33.000000', 'consum', 0.0224, 'lps'),
	(527671, 131, '2014-02-01 00:15:34.000000', 'consum', 0.0215, 'lps'),
	(527672, 131, '2014-02-01 00:15:35.000000', 'consum', 0.0210, 'lps'),
	(527673, 131, '2014-02-01 00:15:36.000000', 'consum', 0.0215, 'lps'),
	(527674, 131, '2014-02-01 00:15:37.000000', 'consum', 0.0218, 'lps'),
	(527675, 131, '2014-02-01 00:15:38.000000', 'consum', 0.0215, 'lps'),
	(527676, 131, '2014-02-01 00:15:39.000000', 'consum', 0.0213, 'lps'),
	(527677, 131, '2014-02-01 00:15:40.000000', 'consum', 0.0227, 'lps'),
	(527678, 131, '2014-02-01 00:15:41.000000', 'consum', 0.0216, 'lps'),
	(527679, 131, '2014-02-01 00:15:42.000000', 'consum', 0.0226, 'lps'),
	(527680, 131, '2014-02-01 00:15:43.000000', 'consum', 0.0217, 'lps'),
	(527681, 131, '2014-02-01 00:15:44.000000', 'consum', 0.0218, 'lps'),
	(527682, 131, '2014-02-01 00:15:45.000000', 'consum', 0.0211, 'lps'),
	(527683, 131, '2014-02-01 00:15:46.000000', 'consum', 0.0210, 'lps'),
	(527684, 131, '2014-02-01 00:15:47.000000', 'consum', 0.0224, 'lps'),
	(527685, 131, '2014-02-01 00:15:48.000000', 'consum', 0.0226, 'lps'),
	(527686, 131, '2014-02-01 00:15:49.000000', 'consum', 0.0215, 'lps'),
	(527687, 131, '2014-02-01 00:15:50.000000', 'consum', 0.0223, 'lps'),
	(527688, 131, '2014-02-01 00:15:51.000000', 'consum', 0.0224, 'lps'),
	(527689, 131, '2014-02-01 00:15:52.000000', 'consum', 0.0222, 'lps'),
	(527690, 131, '2014-02-01 00:15:53.000000', 'consum', 0.0214, 'lps'),
	(527691, 131, '2014-02-01 00:15:54.000000', 'consum', 0.0227, 'lps'),
	(527692, 131, '2014-02-01 00:15:55.000000', 'consum', 0.0214, 'lps'),
	(527693, 131, '2014-02-01 00:15:56.000000', 'consum', 0.0214, 'lps'),
	(527694, 131, '2014-02-01 00:15:57.000000', 'consum', 0.0221, 'lps'),
	(527695, 131, '2014-02-01 00:15:58.000000', 'consum', 0.0216, 'lps'),
	(527696, 131, '2014-02-01 00:15:59.000000', 'consum', 0.0227, 'lps'),
	(527697, 131, '2014-02-01 00:16:00.000000', 'consum', 0.0221, 'lps'),
	(527698, 131, '2014-02-01 00:16:01.000000', 'consum', 0.0214, 'lps'),
	(527699, 131, '2014-02-01 00:16:02.000000', 'consum', 0.0215, 'lps'),
	(527700, 131, '2014-02-01 00:16:03.000000', 'consum', 0.0225, 'lps'),
	(527701, 131, '2014-02-01 00:16:04.000000', 'consum', 0.0218, 'lps'),
	(527702, 131, '2014-02-01 00:16:05.000000', 'consum', 0.0220, 'lps'),
	(527703, 131, '2014-02-01 00:16:06.000000', 'consum', 0.0221, 'lps'),
	(527704, 131, '2014-02-01 00:16:07.000000', 'consum', 0.0217, 'lps'),
	(527705, 131, '2014-02-01 00:16:08.000000', 'consum', 0.0213, 'lps'),
	(527706, 131, '2014-02-01 00:16:09.000000', 'consum', 0.0222, 'lps'),
	(527707, 131, '2014-02-01 00:16:10.000000', 'consum', 0.0210, 'lps'),
	(527708, 131, '2014-02-01 00:16:11.000000', 'consum', 0.0225, 'lps'),
	(527709, 131, '2014-02-01 00:16:12.000000', 'consum', 0.0217, 'lps'),
	(527710, 131, '2014-02-01 00:16:13.000000', 'consum', 0.0216, 'lps'),
	(527711, 131, '2014-02-01 00:16:14.000000', 'consum', 0.0220, 'lps'),
	(527712, 131, '2014-02-01 00:16:15.000000', 'consum', 0.0224, 'lps'),
	(527713, 131, '2014-02-01 00:16:16.000000', 'consum', 0.0214, 'lps'),
	(527714, 131, '2014-02-01 00:16:17.000000', 'consum', 0.0224, 'lps'),
	(527715, 131, '2014-02-01 00:16:18.000000', 'consum', 0.0216, 'lps'),
	(527716, 131, '2014-02-01 00:16:19.000000', 'consum', 0.0215, 'lps'),
	(527717, 131, '2014-02-01 00:16:20.000000', 'consum', 0.0218, 'lps'),
	(527718, 131, '2014-02-01 00:16:21.000000', 'consum', 0.0217, 'lps'),
	(527719, 131, '2014-02-01 00:16:22.000000', 'consum', 0.0221, 'lps'),
	(527720, 131, '2014-02-01 00:16:23.000000', 'consum', 0.0226, 'lps'),
	(527721, 131, '2014-02-01 00:16:24.000000', 'consum', 0.0221, 'lps'),
	(527722, 131, '2014-02-01 00:16:25.000000', 'consum', 0.0218, 'lps'),
	(527723, 131, '2014-02-01 00:16:26.000000', 'consum', 0.0219, 'lps'),
	(527724, 131, '2014-02-01 00:16:27.000000', 'consum', 0.0215, 'lps'),
	(527725, 131, '2014-02-01 00:16:28.000000', 'consum', 0.0224, 'lps'),
	(527726, 131, '2014-02-01 00:16:29.000000', 'consum', 0.0211, 'lps'),
	(527727, 131, '2014-02-01 00:16:30.000000', 'consum', 0.0227, 'lps'),
	(527728, 131, '2014-02-01 00:16:31.000000', 'consum', 0.0221, 'lps'),
	(527729, 131, '2014-02-01 00:16:32.000000', 'consum', 0.0214, 'lps'),
	(527730, 131, '2014-02-01 00:16:33.000000', 'consum', 0.0215, 'lps'),
	(527731, 131, '2014-02-01 00:16:34.000000', 'consum', 0.0223, 'lps'),
	(527732, 131, '2014-02-01 00:16:35.000000', 'consum', 0.0224, 'lps'),
	(527733, 131, '2014-02-01 00:16:36.000000', 'consum', 0.0223, 'lps'),
	(527734, 131, '2014-02-01 00:16:37.000000', 'consum', 0.0217, 'lps'),
	(527735, 131, '2014-02-01 00:16:38.000000', 'consum', 0.0223, 'lps'),
	(527736, 131, '2014-02-01 00:16:39.000000', 'consum', 0.0221, 'lps'),
	(527737, 131, '2014-02-01 00:16:40.000000', 'consum', 0.0224, 'lps'),
	(527738, 131, '2014-02-01 00:16:41.000000', 'consum', 0.0212, 'lps'),
	(527739, 131, '2014-02-01 00:16:42.000000', 'consum', 0.0214, 'lps'),
	(527740, 131, '2014-02-01 00:16:43.000000', 'consum', 0.0227, 'lps'),
	(527741, 131, '2014-02-01 00:16:44.000000', 'consum', 0.0211, 'lps'),
	(527742, 131, '2014-02-01 00:16:45.000000', 'consum', 0.0216, 'lps'),
	(527743, 131, '2014-02-01 00:16:46.000000', 'consum', 0.0221, 'lps'),
	(527744, 131, '2014-02-01 00:16:47.000000', 'consum', 0.0214, 'lps'),
	(527745, 131, '2014-02-01 00:16:48.000000', 'consum', 0.0212, 'lps'),
	(527746, 131, '2014-02-01 00:16:49.000000', 'consum', 0.0226, 'lps'),
	(527747, 131, '2014-02-01 00:16:50.000000', 'consum', 0.0213, 'lps'),
	(527748, 131, '2014-02-01 00:16:51.000000', 'consum', 0.0213, 'lps'),
	(527749, 131, '2014-02-01 00:16:52.000000', 'consum', 0.0218, 'lps'),
	(527750, 131, '2014-02-01 00:16:53.000000', 'consum', 0.0224, 'lps'),
	(527751, 131, '2014-02-01 00:16:54.000000', 'consum', 0.0222, 'lps'),
	(527752, 131, '2014-02-01 00:16:55.000000', 'consum', 0.0226, 'lps'),
	(527753, 131, '2014-02-01 00:16:56.000000', 'consum', 0.0221, 'lps'),
	(527754, 131, '2014-02-01 00:16:57.000000', 'consum', 0.0217, 'lps'),
	(527755, 131, '2014-02-01 00:16:58.000000', 'consum', 0.0213, 'lps'),
	(527756, 131, '2014-02-01 00:16:59.000000', 'consum', 0.0222, 'lps'),
	(527757, 131, '2014-02-01 00:17:00.000000', 'consum', 0.0225, 'lps'),
	(527758, 131, '2014-02-01 00:17:01.000000', 'consum', 0.0215, 'lps'),
	(527759, 131, '2014-02-01 00:17:02.000000', 'consum', 0.0210, 'lps'),
	(527760, 131, '2014-02-01 00:17:03.000000', 'consum', 0.0211, 'lps'),
	(527761, 131, '2014-02-01 00:17:04.000000', 'consum', 0.0215, 'lps'),
	(527762, 131, '2014-02-01 00:17:05.000000', 'consum', 0.0213, 'lps'),
	(527763, 131, '2014-02-01 00:17:06.000000', 'consum', 0.0213, 'lps'),
	(527764, 131, '2014-02-01 00:17:07.000000', 'consum', 0.0217, 'lps'),
	(527765, 131, '2014-02-01 00:17:08.000000', 'consum', 0.0219, 'lps'),
	(527766, 131, '2014-02-01 00:17:09.000000', 'consum', 0.0217, 'lps'),
	(527767, 131, '2014-02-01 00:17:10.000000', 'consum', 0.0219, 'lps'),
	(527768, 131, '2014-02-01 00:17:11.000000', 'consum', 0.0213, 'lps'),
	(527769, 131, '2014-02-01 00:17:12.000000', 'consum', 0.0220, 'lps'),
	(527770, 131, '2014-02-01 00:17:13.000000', 'consum', 0.0216, 'lps'),
	(527771, 131, '2014-02-01 00:17:14.000000', 'consum', 0.0226, 'lps'),
	(527772, 131, '2014-02-01 00:17:15.000000', 'consum', 0.0218, 'lps'),
	(527773, 131, '2014-02-01 00:17:16.000000', 'consum', 0.0221, 'lps'),
	(527774, 131, '2014-02-01 00:17:17.000000', 'consum', 0.0226, 'lps'),
	(527775, 131, '2014-02-01 00:17:18.000000', 'consum', 0.0218, 'lps'),
	(527776, 131, '2014-02-01 00:17:19.000000', 'consum', 0.0222, 'lps'),
	(527777, 131, '2014-02-01 00:17:20.000000', 'consum', 0.0211, 'lps'),
	(527778, 131, '2014-02-01 00:17:21.000000', 'consum', 0.0214, 'lps'),
	(527779, 131, '2014-02-01 00:17:22.000000', 'consum', 0.0211, 'lps'),
	(527780, 131, '2014-02-01 00:17:23.000000', 'consum', 0.0223, 'lps'),
	(527781, 131, '2014-02-01 00:17:24.000000', 'consum', 0.0216, 'lps'),
	(527782, 131, '2014-02-01 00:17:25.000000', 'consum', 0.0222, 'lps'),
	(527783, 131, '2014-02-01 00:17:26.000000', 'consum', 0.0214, 'lps'),
	(527784, 131, '2014-02-01 00:17:27.000000', 'consum', 0.0212, 'lps'),
	(527785, 131, '2014-02-01 00:17:28.000000', 'consum', 0.0227, 'lps'),
	(527786, 131, '2014-02-01 00:17:29.000000', 'consum', 0.0219, 'lps'),
	(527787, 131, '2014-02-01 00:17:30.000000', 'consum', 0.0223, 'lps'),
	(527788, 131, '2014-02-01 00:17:31.000000', 'consum', 0.0210, 'lps'),
	(527789, 131, '2014-02-01 00:17:32.000000', 'consum', 0.0225, 'lps'),
	(527790, 131, '2014-02-01 00:17:33.000000', 'consum', 0.0215, 'lps'),
	(527791, 131, '2014-02-01 00:17:34.000000', 'consum', 0.0225, 'lps'),
	(527792, 131, '2014-02-01 00:17:35.000000', 'consum', 0.0218, 'lps'),
	(527793, 131, '2014-02-01 00:17:36.000000', 'consum', 0.0225, 'lps'),
	(527794, 131, '2014-02-01 00:17:37.000000', 'consum', 0.0225, 'lps'),
	(527795, 131, '2014-02-01 00:17:38.000000', 'consum', 0.0221, 'lps'),
	(527796, 131, '2014-02-01 00:17:39.000000', 'consum', 0.0219, 'lps'),
	(527797, 131, '2014-02-01 00:17:40.000000', 'consum', 0.0224, 'lps'),
	(527798, 131, '2014-02-01 00:17:41.000000', 'consum', 0.0217, 'lps'),
	(527799, 131, '2014-02-01 00:17:42.000000', 'consum', 0.0222, 'lps'),
	(527800, 131, '2014-02-01 00:17:43.000000', 'consum', 0.0214, 'lps'),
	(527801, 131, '2014-02-01 00:17:44.000000', 'consum', 0.0211, 'lps'),
	(527802, 131, '2014-02-01 00:17:45.000000', 'consum', 0.0224, 'lps'),
	(527803, 131, '2014-02-01 00:17:46.000000', 'consum', 0.0223, 'lps'),
	(527804, 131, '2014-02-01 00:17:47.000000', 'consum', 0.0216, 'lps'),
	(527805, 131, '2014-02-01 00:17:48.000000', 'consum', 0.0217, 'lps'),
	(527806, 131, '2014-02-01 00:17:49.000000', 'consum', 0.0212, 'lps'),
	(527807, 131, '2014-02-01 00:17:50.000000', 'consum', 0.0218, 'lps'),
	(527808, 131, '2014-02-01 00:17:51.000000', 'consum', 0.0226, 'lps'),
	(527809, 131, '2014-02-01 00:17:52.000000', 'consum', 0.0211, 'lps'),
	(527810, 131, '2014-02-01 00:17:53.000000', 'consum', 0.0223, 'lps'),
	(527811, 131, '2014-02-01 00:17:54.000000', 'consum', 0.0219, 'lps'),
	(527812, 131, '2014-02-01 00:17:55.000000', 'consum', 0.0214, 'lps'),
	(527813, 131, '2014-02-01 00:17:56.000000', 'consum', 0.0224, 'lps'),
	(527814, 131, '2014-02-01 00:17:57.000000', 'consum', 0.0215, 'lps'),
	(527815, 131, '2014-02-01 00:17:58.000000', 'consum', 0.0211, 'lps'),
	(527816, 131, '2014-02-01 00:17:59.000000', 'consum', 0.0218, 'lps'),
	(527817, 131, '2014-02-01 00:18:00.000000', 'consum', 0.0214, 'lps'),
	(527818, 131, '2014-02-01 00:18:01.000000', 'consum', 0.0221, 'lps'),
	(527819, 131, '2014-02-01 00:18:02.000000', 'consum', 0.0218, 'lps'),
	(527820, 131, '2014-02-01 00:18:03.000000', 'consum', 0.0217, 'lps'),
	(527821, 131, '2014-02-01 00:18:04.000000', 'consum', 0.0221, 'lps'),
	(527822, 131, '2014-02-01 00:18:05.000000', 'consum', 0.0227, 'lps'),
	(527823, 131, '2014-02-01 00:18:06.000000', 'consum', 0.0210, 'lps'),
	(527824, 131, '2014-02-01 00:18:07.000000', 'consum', 0.0214, 'lps'),
	(527825, 131, '2014-02-01 00:18:08.000000', 'consum', 0.0212, 'lps'),
	(527826, 131, '2014-02-01 00:18:09.000000', 'consum', 0.0225, 'lps'),
	(527827, 131, '2014-02-01 00:18:10.000000', 'consum', 0.0210, 'lps'),
	(527828, 131, '2014-02-01 00:18:11.000000', 'consum', 0.0217, 'lps'),
	(527829, 131, '2014-02-01 00:18:12.000000', 'consum', 0.0227, 'lps'),
	(527830, 131, '2014-02-01 00:18:13.000000', 'consum', 0.0221, 'lps'),
	(527831, 131, '2014-02-01 00:18:14.000000', 'consum', 0.0215, 'lps'),
	(527832, 131, '2014-02-01 00:18:15.000000', 'consum', 0.0219, 'lps'),
	(527833, 131, '2014-02-01 00:18:16.000000', 'consum', 0.0223, 'lps'),
	(527834, 131, '2014-02-01 00:18:17.000000', 'consum', 0.0211, 'lps'),
	(527835, 131, '2014-02-01 00:18:18.000000', 'consum', 0.0216, 'lps'),
	(527836, 131, '2014-02-01 00:18:19.000000', 'consum', 0.0218, 'lps'),
	(527837, 131, '2014-02-01 00:18:20.000000', 'consum', 0.0212, 'lps'),
	(527838, 131, '2014-02-01 00:18:21.000000', 'consum', 0.0218, 'lps'),
	(527839, 131, '2014-02-01 00:18:22.000000', 'consum', 0.0223, 'lps'),
	(527840, 131, '2014-02-01 00:18:23.000000', 'consum', 0.0219, 'lps'),
	(527841, 131, '2014-02-01 00:18:24.000000', 'consum', 0.0216, 'lps'),
	(527842, 131, '2014-02-01 00:18:25.000000', 'consum', 0.0211, 'lps'),
	(527843, 131, '2014-02-01 00:18:26.000000', 'consum', 0.0219, 'lps'),
	(527844, 131, '2014-02-01 00:18:27.000000', 'consum', 0.0215, 'lps'),
	(527845, 131, '2014-02-01 00:18:28.000000', 'consum', 0.0225, 'lps'),
	(527846, 131, '2014-02-01 00:18:29.000000', 'consum', 0.0219, 'lps'),
	(527847, 131, '2014-02-01 00:18:30.000000', 'consum', 0.0227, 'lps'),
	(527848, 131, '2014-02-01 00:18:31.000000', 'consum', 0.0216, 'lps'),
	(527849, 131, '2014-02-01 00:18:32.000000', 'consum', 0.0226, 'lps'),
	(527850, 131, '2014-02-01 00:18:33.000000', 'consum', 0.0216, 'lps'),
	(527851, 131, '2014-02-01 00:18:34.000000', 'consum', 0.0213, 'lps'),
	(527852, 131, '2014-02-01 00:18:35.000000', 'consum', 0.0226, 'lps'),
	(527853, 131, '2014-02-01 00:18:36.000000', 'consum', 0.0210, 'lps'),
	(527854, 131, '2014-02-01 00:18:37.000000', 'consum', 0.0214, 'lps'),
	(527855, 131, '2014-02-01 00:18:38.000000', 'consum', 0.0215, 'lps'),
	(527856, 131, '2014-02-01 00:18:39.000000', 'consum', 0.0223, 'lps'),
	(527857, 131, '2014-02-01 00:18:40.000000', 'consum', 0.0223, 'lps'),
	(527858, 131, '2014-02-01 00:18:41.000000', 'consum', 0.0217, 'lps'),
	(527859, 131, '2014-02-01 00:18:42.000000', 'consum', 0.0210, 'lps'),
	(527860, 131, '2014-02-01 00:18:43.000000', 'consum', 0.0224, 'lps'),
	(527861, 131, '2014-02-01 00:18:44.000000', 'consum', 0.0227, 'lps'),
	(527862, 131, '2014-02-01 00:18:45.000000', 'consum', 0.0218, 'lps'),
	(527863, 131, '2014-02-01 00:18:46.000000', 'consum', 0.0218, 'lps'),
	(527864, 131, '2014-02-01 00:18:47.000000', 'consum', 0.0227, 'lps'),
	(527865, 131, '2014-02-01 00:18:48.000000', 'consum', 0.0217, 'lps'),
	(527866, 131, '2014-02-01 00:18:49.000000', 'consum', 0.0212, 'lps'),
	(527867, 131, '2014-02-01 00:18:50.000000', 'consum', 0.0217, 'lps'),
	(527868, 131, '2014-02-01 00:18:51.000000', 'consum', 0.0222, 'lps'),
	(527869, 131, '2014-02-01 00:18:52.000000', 'consum', 0.0214, 'lps'),
	(527870, 131, '2014-02-01 00:18:53.000000', 'consum', 0.0212, 'lps'),
	(527871, 131, '2014-02-01 00:18:54.000000', 'consum', 0.0226, 'lps'),
	(527872, 131, '2014-02-01 00:18:55.000000', 'consum', 0.0212, 'lps'),
	(527873, 131, '2014-02-01 00:18:56.000000', 'consum', 0.0211, 'lps'),
	(527874, 131, '2014-02-01 00:18:57.000000', 'consum', 0.0226, 'lps'),
	(527875, 131, '2014-02-01 00:18:58.000000', 'consum', 0.0215, 'lps'),
	(527876, 131, '2014-02-01 00:18:59.000000', 'consum', 0.0223, 'lps'),
	(527877, 131, '2014-02-01 00:19:00.000000', 'consum', 0.0227, 'lps'),
	(527878, 131, '2014-02-01 00:19:01.000000', 'consum', 0.0220, 'lps'),
	(527879, 131, '2014-02-01 00:19:02.000000', 'consum', 0.0226, 'lps'),
	(527880, 131, '2014-02-01 00:19:03.000000', 'consum', 0.0225, 'lps'),
	(527881, 131, '2014-02-01 00:19:04.000000', 'consum', 0.0221, 'lps'),
	(527882, 131, '2014-02-01 00:19:05.000000', 'consum', 0.0220, 'lps'),
	(527883, 131, '2014-02-01 00:19:06.000000', 'consum', 0.0226, 'lps'),
	(527884, 131, '2014-02-01 00:19:07.000000', 'consum', 0.0227, 'lps'),
	(527885, 131, '2014-02-01 00:19:08.000000', 'consum', 0.0211, 'lps'),
	(527886, 131, '2014-02-01 00:19:09.000000', 'consum', 0.0219, 'lps'),
	(527887, 131, '2014-02-01 00:19:10.000000', 'consum', 0.0215, 'lps'),
	(527888, 131, '2014-02-01 00:19:11.000000', 'consum', 0.0227, 'lps'),
	(527889, 131, '2014-02-01 00:19:12.000000', 'consum', 0.0227, 'lps'),
	(527890, 131, '2014-02-01 00:19:13.000000', 'consum', 0.0225, 'lps'),
	(527891, 131, '2014-02-01 00:19:14.000000', 'consum', 0.0216, 'lps'),
	(527892, 131, '2014-02-01 00:19:15.000000', 'consum', 0.0215, 'lps'),
	(527893, 131, '2014-02-01 00:19:16.000000', 'consum', 0.0218, 'lps'),
	(527894, 131, '2014-02-01 00:19:17.000000', 'consum', 0.0215, 'lps'),
	(527895, 131, '2014-02-01 00:19:18.000000', 'consum', 0.0214, 'lps'),
	(527896, 131, '2014-02-01 00:19:19.000000', 'consum', 0.0216, 'lps'),
	(527897, 131, '2014-02-01 00:19:20.000000', 'consum', 0.0211, 'lps'),
	(527898, 131, '2014-02-01 00:19:21.000000', 'consum', 0.0213, 'lps'),
	(527899, 131, '2014-02-01 00:19:22.000000', 'consum', 0.0223, 'lps'),
	(527900, 131, '2014-02-01 00:19:23.000000', 'consum', 0.0213, 'lps'),
	(527901, 131, '2014-02-01 00:19:24.000000', 'consum', 0.0224, 'lps'),
	(527902, 131, '2014-02-01 00:19:25.000000', 'consum', 0.0217, 'lps'),
	(527903, 131, '2014-02-01 00:19:26.000000', 'consum', 0.0220, 'lps'),
	(527904, 131, '2014-02-01 00:19:27.000000', 'consum', 0.0220, 'lps'),
	(527905, 131, '2014-02-01 00:19:28.000000', 'consum', 0.0216, 'lps'),
	(527906, 131, '2014-02-01 00:19:29.000000', 'consum', 0.0227, 'lps'),
	(527907, 131, '2014-02-01 00:19:30.000000', 'consum', 0.0225, 'lps'),
	(527908, 131, '2014-02-01 00:19:31.000000', 'consum', 0.0216, 'lps'),
	(527909, 131, '2014-02-01 00:19:32.000000', 'consum', 0.0214, 'lps'),
	(527910, 131, '2014-02-01 00:19:33.000000', 'consum', 0.0212, 'lps'),
	(527911, 131, '2014-02-01 00:19:34.000000', 'consum', 0.0225, 'lps'),
	(527912, 131, '2014-02-01 00:19:35.000000', 'consum', 0.0227, 'lps'),
	(527913, 131, '2014-02-01 00:19:36.000000', 'consum', 0.0216, 'lps'),
	(527914, 131, '2014-02-01 00:19:37.000000', 'consum', 0.0224, 'lps'),
	(527915, 131, '2014-02-01 00:19:38.000000', 'consum', 0.0210, 'lps'),
	(527916, 131, '2014-02-01 00:19:39.000000', 'consum', 0.0221, 'lps'),
	(527917, 131, '2014-02-01 00:19:40.000000', 'consum', 0.0214, 'lps'),
	(527918, 131, '2014-02-01 00:19:41.000000', 'consum', 0.0212, 'lps'),
	(527919, 131, '2014-02-01 00:19:42.000000', 'consum', 0.0212, 'lps'),
	(527920, 131, '2014-02-01 00:19:43.000000', 'consum', 0.0213, 'lps'),
	(527921, 131, '2014-02-01 00:19:44.000000', 'consum', 0.0219, 'lps'),
	(527922, 131, '2014-02-01 00:19:45.000000', 'consum', 0.0227, 'lps'),
	(527923, 131, '2014-02-01 00:19:46.000000', 'consum', 0.0217, 'lps'),
	(527924, 131, '2014-02-01 00:19:47.000000', 'consum', 0.0212, 'lps'),
	(527925, 131, '2014-02-01 00:19:48.000000', 'consum', 0.0217, 'lps'),
	(527926, 131, '2014-02-01 00:19:49.000000', 'consum', 0.0223, 'lps'),
	(527927, 131, '2014-02-01 00:19:50.000000', 'consum', 0.0219, 'lps'),
	(527928, 131, '2014-02-01 00:19:51.000000', 'consum', 0.0218, 'lps'),
	(527929, 131, '2014-02-01 00:19:52.000000', 'consum', 0.0220, 'lps'),
	(527930, 131, '2014-02-01 00:19:53.000000', 'consum', 0.0220, 'lps'),
	(527931, 131, '2014-02-01 00:19:54.000000', 'consum', 0.0212, 'lps'),
	(527932, 131, '2014-02-01 00:19:55.000000', 'consum', 0.0226, 'lps'),
	(527933, 131, '2014-02-01 00:19:56.000000', 'consum', 0.0213, 'lps'),
	(527934, 131, '2014-02-01 00:19:57.000000', 'consum', 0.0215, 'lps'),
	(527935, 131, '2014-02-01 00:19:58.000000', 'consum', 0.0224, 'lps'),
	(527936, 131, '2014-02-01 00:19:59.000000', 'consum', 0.0212, 'lps'),
	(527937, 131, '2014-02-01 00:20:00.000000', 'consum', 0.0217, 'lps'),
	(527938, 131, '2014-02-01 00:20:01.000000', 'consum', 0.0220, 'lps'),
	(527939, 131, '2014-02-01 00:20:02.000000', 'consum', 0.0220, 'lps'),
	(527940, 131, '2014-02-01 00:20:03.000000', 'consum', 0.0215, 'lps'),
	(527941, 131, '2014-02-01 00:20:04.000000', 'consum', 0.0222, 'lps'),
	(527942, 131, '2014-02-01 00:20:05.000000', 'consum', 0.0219, 'lps'),
	(527943, 131, '2014-02-01 00:20:06.000000', 'consum', 0.0220, 'lps'),
	(527944, 131, '2014-02-01 00:20:07.000000', 'consum', 0.0214, 'lps'),
	(527945, 131, '2014-02-01 00:20:08.000000', 'consum', 0.0221, 'lps'),
	(527946, 131, '2014-02-01 00:20:09.000000', 'consum', 0.0216, 'lps'),
	(527947, 131, '2014-02-01 00:20:10.000000', 'consum', 0.0225, 'lps'),
	(527948, 131, '2014-02-01 00:20:11.000000', 'consum', 0.0213, 'lps'),
	(527949, 131, '2014-02-01 00:20:12.000000', 'consum', 0.0216, 'lps'),
	(527950, 131, '2014-02-01 00:20:13.000000', 'consum', 0.0215, 'lps'),
	(527951, 131, '2014-02-01 00:20:14.000000', 'consum', 0.0216, 'lps'),
	(527952, 131, '2014-02-01 00:20:15.000000', 'consum', 0.0227, 'lps'),
	(527953, 131, '2014-02-01 00:20:16.000000', 'consum', 0.0224, 'lps'),
	(527954, 131, '2014-02-01 00:20:17.000000', 'consum', 0.0227, 'lps'),
	(527955, 131, '2014-02-01 00:20:18.000000', 'consum', 0.0221, 'lps'),
	(527956, 131, '2014-02-01 00:20:19.000000', 'consum', 0.0212, 'lps'),
	(527957, 131, '2014-02-01 00:20:20.000000', 'consum', 0.0223, 'lps'),
	(527958, 131, '2014-02-01 00:20:21.000000', 'consum', 0.0214, 'lps'),
	(527959, 131, '2014-02-01 00:20:22.000000', 'consum', 0.0212, 'lps'),
	(527960, 131, '2014-02-01 00:20:23.000000', 'consum', 0.0227, 'lps'),
	(527961, 131, '2014-02-01 00:20:24.000000', 'consum', 0.0219, 'lps'),
	(527962, 131, '2014-02-01 00:20:25.000000', 'consum', 0.0220, 'lps'),
	(527963, 131, '2014-02-01 00:20:26.000000', 'consum', 0.0214, 'lps'),
	(527964, 131, '2014-02-01 00:20:27.000000', 'consum', 0.0221, 'lps'),
	(527965, 131, '2014-02-01 00:20:28.000000', 'consum', 0.0215, 'lps'),
	(527966, 131, '2014-02-01 00:20:29.000000', 'consum', 0.0224, 'lps'),
	(527967, 131, '2014-02-01 00:20:30.000000', 'consum', 0.0227, 'lps'),
	(527968, 131, '2014-02-01 00:20:31.000000', 'consum', 0.0218, 'lps'),
	(527969, 131, '2014-02-01 00:20:32.000000', 'consum', 0.0219, 'lps'),
	(527970, 131, '2014-02-01 00:20:33.000000', 'consum', 0.0215, 'lps'),
	(527971, 131, '2014-02-01 00:20:34.000000', 'consum', 0.0223, 'lps'),
	(527972, 131, '2014-02-01 00:20:35.000000', 'consum', 0.0226, 'lps'),
	(527973, 131, '2014-02-01 00:20:36.000000', 'consum', 0.0217, 'lps'),
	(527974, 131, '2014-02-01 00:20:37.000000', 'consum', 0.0215, 'lps'),
	(527975, 131, '2014-02-01 00:20:38.000000', 'consum', 0.0213, 'lps'),
	(527976, 131, '2014-02-01 00:20:39.000000', 'consum', 0.0212, 'lps'),
	(527977, 131, '2014-02-01 00:20:40.000000', 'consum', 0.0210, 'lps'),
	(527978, 131, '2014-02-01 00:20:41.000000', 'consum', 0.0224, 'lps'),
	(527979, 131, '2014-02-01 00:20:42.000000', 'consum', 0.0224, 'lps'),
	(527980, 131, '2014-02-01 00:20:43.000000', 'consum', 0.0224, 'lps'),
	(527981, 131, '2014-02-01 00:20:44.000000', 'consum', 0.0217, 'lps'),
	(527982, 131, '2014-02-01 00:20:45.000000', 'consum', 0.0223, 'lps'),
	(527983, 131, '2014-02-01 00:20:46.000000', 'consum', 0.0216, 'lps'),
	(527984, 131, '2014-02-01 00:20:47.000000', 'consum', 0.0223, 'lps'),
	(527985, 131, '2014-02-01 00:20:48.000000', 'consum', 0.0219, 'lps'),
	(527986, 131, '2014-02-01 00:20:49.000000', 'consum', 0.0219, 'lps'),
	(527987, 131, '2014-02-01 00:20:50.000000', 'consum', 0.0227, 'lps'),
	(527988, 131, '2014-02-01 00:20:51.000000', 'consum', 0.0216, 'lps'),
	(527989, 131, '2014-02-01 00:20:52.000000', 'consum', 0.0223, 'lps'),
	(527990, 131, '2014-02-01 00:20:53.000000', 'consum', 0.0222, 'lps'),
	(527991, 131, '2014-02-01 00:20:54.000000', 'consum', 0.0215, 'lps'),
	(527992, 131, '2014-02-01 00:20:55.000000', 'consum', 0.0216, 'lps'),
	(527993, 131, '2014-02-01 00:20:56.000000', 'consum', 0.0227, 'lps'),
	(527994, 131, '2014-02-01 00:20:57.000000', 'consum', 0.0222, 'lps'),
	(527995, 131, '2014-02-01 00:20:58.000000', 'consum', 0.0219, 'lps'),
	(527996, 131, '2014-02-01 00:20:59.000000', 'consum', 0.0222, 'lps'),
	(527997, 131, '2014-02-01 00:21:00.000000', 'consum', 0.0225, 'lps'),
	(527998, 131, '2014-02-01 00:21:01.000000', 'consum', 0.0214, 'lps'),
	(527999, 131, '2014-02-01 00:21:02.000000', 'consum', 0.0219, 'lps'),
	(528000, 131, '2014-02-01 00:21:03.000000', 'consum', 0.0210, 'lps'),
	(528001, 131, '2014-02-01 00:21:04.000000', 'consum', 0.0217, 'lps'),
	(528002, 131, '2014-02-01 00:21:05.000000', 'consum', 0.0227, 'lps'),
	(528003, 131, '2014-02-01 00:21:06.000000', 'consum', 0.0221, 'lps'),
	(528004, 131, '2014-02-01 00:21:07.000000', 'consum', 0.0215, 'lps'),
	(528005, 131, '2014-02-01 00:21:08.000000', 'consum', 0.0223, 'lps'),
	(528006, 131, '2014-02-01 00:21:09.000000', 'consum', 0.0221, 'lps'),
	(528007, 131, '2014-02-01 00:21:10.000000', 'consum', 0.0227, 'lps'),
	(528008, 131, '2014-02-01 00:21:11.000000', 'consum', 0.0210, 'lps'),
	(528009, 131, '2014-02-01 00:21:12.000000', 'consum', 0.0211, 'lps'),
	(528010, 131, '2014-02-01 00:21:13.000000', 'consum', 0.0218, 'lps'),
	(528011, 131, '2014-02-01 00:21:14.000000', 'consum', 0.0212, 'lps'),
	(528012, 131, '2014-02-01 00:21:15.000000', 'consum', 0.0213, 'lps'),
	(528013, 131, '2014-02-01 00:21:16.000000', 'consum', 0.0221, 'lps'),
	(528014, 131, '2014-02-01 00:21:17.000000', 'consum', 0.0218, 'lps'),
	(528015, 131, '2014-02-01 00:21:18.000000', 'consum', 0.0220, 'lps'),
	(528016, 131, '2014-02-01 00:21:19.000000', 'consum', 0.0218, 'lps'),
	(528017, 131, '2014-02-01 00:21:20.000000', 'consum', 0.0220, 'lps'),
	(528018, 131, '2014-02-01 00:21:21.000000', 'consum', 0.0217, 'lps'),
	(528019, 131, '2014-02-01 00:21:22.000000', 'consum', 0.0219, 'lps'),
	(528020, 131, '2014-02-01 00:21:23.000000', 'consum', 0.0214, 'lps'),
	(528021, 131, '2014-02-01 00:21:24.000000', 'consum', 0.0221, 'lps'),
	(528022, 131, '2014-02-01 00:21:25.000000', 'consum', 0.0218, 'lps'),
	(528023, 131, '2014-02-01 00:21:26.000000', 'consum', 0.0219, 'lps'),
	(528024, 131, '2014-02-01 00:21:27.000000', 'consum', 0.0215, 'lps'),
	(528025, 131, '2014-02-01 00:21:28.000000', 'consum', 0.0223, 'lps'),
	(528026, 131, '2014-02-01 00:21:29.000000', 'consum', 0.0226, 'lps'),
	(528027, 131, '2014-02-01 00:21:30.000000', 'consum', 0.0216, 'lps'),
	(528028, 131, '2014-02-01 00:21:31.000000', 'consum', 0.0210, 'lps'),
	(528029, 131, '2014-02-01 00:21:32.000000', 'consum', 0.0212, 'lps'),
	(528030, 131, '2014-02-01 00:21:33.000000', 'consum', 0.0221, 'lps'),
	(528031, 131, '2014-02-01 00:21:34.000000', 'consum', 0.0221, 'lps'),
	(528032, 131, '2014-02-01 00:21:35.000000', 'consum', 0.0215, 'lps'),
	(528033, 131, '2014-02-01 00:21:36.000000', 'consum', 0.0223, 'lps'),
	(528034, 131, '2014-02-01 00:21:37.000000', 'consum', 0.0221, 'lps'),
	(528035, 131, '2014-02-01 00:21:38.000000', 'consum', 0.0211, 'lps'),
	(528036, 131, '2014-02-01 00:21:39.000000', 'consum', 0.0216, 'lps'),
	(528037, 131, '2014-02-01 00:21:40.000000', 'consum', 0.0221, 'lps'),
	(528038, 131, '2014-02-01 00:21:41.000000', 'consum', 0.0213, 'lps'),
	(528039, 131, '2014-02-01 00:21:42.000000', 'consum', 0.0226, 'lps'),
	(528040, 131, '2014-02-01 00:21:43.000000', 'consum', 0.0210, 'lps'),
	(528041, 131, '2014-02-01 00:21:44.000000', 'consum', 0.0216, 'lps'),
	(528042, 131, '2014-02-01 00:21:45.000000', 'consum', 0.0221, 'lps'),
	(528043, 131, '2014-02-01 00:21:46.000000', 'consum', 0.0214, 'lps'),
	(528044, 131, '2014-02-01 00:21:47.000000', 'consum', 0.0216, 'lps'),
	(528045, 131, '2014-02-01 00:21:48.000000', 'consum', 0.0226, 'lps'),
	(528046, 131, '2014-02-01 00:21:49.000000', 'consum', 0.0220, 'lps'),
	(528047, 131, '2014-02-01 00:21:50.000000', 'consum', 0.0210, 'lps'),
	(528048, 131, '2014-02-01 00:21:51.000000', 'consum', 0.0219, 'lps'),
	(528049, 131, '2014-02-01 00:21:52.000000', 'consum', 0.0217, 'lps'),
	(528050, 131, '2014-02-01 00:21:53.000000', 'consum', 0.0220, 'lps'),
	(528051, 131, '2014-02-01 00:21:54.000000', 'consum', 0.0220, 'lps'),
	(528052, 131, '2014-02-01 00:21:55.000000', 'consum', 0.0214, 'lps'),
	(528053, 131, '2014-02-01 00:21:56.000000', 'consum', 0.0218, 'lps'),
	(528054, 131, '2014-02-01 00:21:57.000000', 'consum', 0.0221, 'lps'),
	(528055, 131, '2014-02-01 00:21:58.000000', 'consum', 0.0223, 'lps'),
	(528056, 131, '2014-02-01 00:21:59.000000', 'consum', 0.0225, 'lps'),
	(528057, 131, '2014-02-01 00:22:00.000000', 'consum', 0.0210, 'lps'),
	(528058, 131, '2014-02-01 00:22:01.000000', 'consum', 0.0221, 'lps'),
	(528059, 131, '2014-02-01 00:22:02.000000', 'consum', 0.0212, 'lps'),
	(528060, 131, '2014-02-01 00:22:03.000000', 'consum', 0.0224, 'lps'),
	(528061, 131, '2014-02-01 00:22:04.000000', 'consum', 0.0219, 'lps'),
	(528062, 131, '2014-02-01 00:22:05.000000', 'consum', 0.0212, 'lps'),
	(528063, 131, '2014-02-01 00:22:06.000000', 'consum', 0.0213, 'lps'),
	(528064, 131, '2014-02-01 00:22:07.000000', 'consum', 0.0221, 'lps'),
	(528065, 131, '2014-02-01 00:22:08.000000', 'consum', 0.0219, 'lps'),
	(528066, 131, '2014-02-01 00:22:09.000000', 'consum', 0.0221, 'lps'),
	(528067, 131, '2014-02-01 00:22:10.000000', 'consum', 0.0220, 'lps'),
	(528068, 131, '2014-02-01 00:22:11.000000', 'consum', 0.0212, 'lps'),
	(528069, 131, '2014-02-01 00:22:12.000000', 'consum', 0.0226, 'lps'),
	(528070, 131, '2014-02-01 00:22:13.000000', 'consum', 0.0212, 'lps'),
	(528071, 131, '2014-02-01 00:22:14.000000', 'consum', 0.0227, 'lps'),
	(528072, 131, '2014-02-01 00:22:15.000000', 'consum', 0.0219, 'lps'),
	(528073, 131, '2014-02-01 00:22:16.000000', 'consum', 0.0220, 'lps'),
	(528074, 131, '2014-02-01 00:22:17.000000', 'consum', 0.0216, 'lps'),
	(528075, 131, '2014-02-01 00:22:18.000000', 'consum', 0.0213, 'lps'),
	(528076, 131, '2014-02-01 00:22:19.000000', 'consum', 0.0223, 'lps'),
	(528077, 131, '2014-02-01 00:22:20.000000', 'consum', 0.0212, 'lps'),
	(528078, 131, '2014-02-01 00:22:21.000000', 'consum', 0.0220, 'lps'),
	(528079, 131, '2014-02-01 00:22:22.000000', 'consum', 0.0216, 'lps'),
	(528080, 131, '2014-02-01 00:22:23.000000', 'consum', 0.0212, 'lps'),
	(528081, 131, '2014-02-01 00:22:24.000000', 'consum', 0.0219, 'lps'),
	(528082, 131, '2014-02-01 00:22:25.000000', 'consum', 0.0215, 'lps'),
	(528083, 131, '2014-02-01 00:22:26.000000', 'consum', 0.0226, 'lps'),
	(528084, 131, '2014-02-01 00:22:27.000000', 'consum', 0.0223, 'lps'),
	(528085, 131, '2014-02-01 00:22:28.000000', 'consum', 0.0211, 'lps'),
	(528086, 131, '2014-02-01 00:22:29.000000', 'consum', 0.0227, 'lps'),
	(528087, 131, '2014-02-01 00:22:30.000000', 'consum', 0.0221, 'lps'),
	(528088, 131, '2014-02-01 00:22:31.000000', 'consum', 0.0215, 'lps'),
	(528089, 131, '2014-02-01 00:22:32.000000', 'consum', 0.0220, 'lps'),
	(528090, 131, '2014-02-01 00:22:33.000000', 'consum', 0.0226, 'lps'),
	(528091, 131, '2014-02-01 00:22:34.000000', 'consum', 0.0226, 'lps'),
	(528092, 131, '2014-02-01 00:22:35.000000', 'consum', 0.0224, 'lps'),
	(528093, 131, '2014-02-01 00:22:36.000000', 'consum', 0.0216, 'lps'),
	(528094, 131, '2014-02-01 00:22:37.000000', 'consum', 0.0214, 'lps'),
	(528095, 131, '2014-02-01 00:22:38.000000', 'consum', 0.0215, 'lps'),
	(528096, 131, '2014-02-01 00:22:39.000000', 'consum', 0.0224, 'lps'),
	(528097, 131, '2014-02-01 00:22:40.000000', 'consum', 0.0212, 'lps'),
	(528098, 131, '2014-02-01 00:22:41.000000', 'consum', 0.0212, 'lps'),
	(528099, 131, '2014-02-01 00:22:42.000000', 'consum', 0.0213, 'lps'),
	(528100, 131, '2014-02-01 00:22:43.000000', 'consum', 0.0223, 'lps'),
	(528101, 131, '2014-02-01 00:22:44.000000', 'consum', 0.0212, 'lps'),
	(528102, 131, '2014-02-01 00:22:45.000000', 'consum', 0.0218, 'lps'),
	(528103, 131, '2014-02-01 00:22:46.000000', 'consum', 0.0227, 'lps'),
	(528104, 131, '2014-02-01 00:22:47.000000', 'consum', 0.0215, 'lps'),
	(528105, 131, '2014-02-01 00:22:48.000000', 'consum', 0.0220, 'lps'),
	(528106, 131, '2014-02-01 00:22:49.000000', 'consum', 0.0210, 'lps'),
	(528107, 131, '2014-02-01 00:22:50.000000', 'consum', 0.0217, 'lps'),
	(528108, 131, '2014-02-01 00:22:51.000000', 'consum', 0.0211, 'lps'),
	(528109, 131, '2014-02-01 00:22:52.000000', 'consum', 0.0211, 'lps'),
	(528110, 131, '2014-02-01 00:22:53.000000', 'consum', 0.0211, 'lps'),
	(528111, 131, '2014-02-01 00:22:54.000000', 'consum', 0.0215, 'lps'),
	(528112, 131, '2014-02-01 00:22:55.000000', 'consum', 0.0213, 'lps'),
	(528113, 131, '2014-02-01 00:22:56.000000', 'consum', 0.0210, 'lps'),
	(528114, 131, '2014-02-01 00:22:57.000000', 'consum', 0.0222, 'lps'),
	(528115, 131, '2014-02-01 00:22:58.000000', 'consum', 0.0213, 'lps'),
	(528116, 131, '2014-02-01 00:22:59.000000', 'consum', 0.0210, 'lps'),
	(528117, 131, '2014-02-01 00:23:00.000000', 'consum', 0.0220, 'lps'),
	(528118, 131, '2014-02-01 00:23:01.000000', 'consum', 0.0224, 'lps'),
	(528119, 131, '2014-02-01 00:23:02.000000', 'consum', 0.0216, 'lps'),
	(528120, 131, '2014-02-01 00:23:03.000000', 'consum', 0.0217, 'lps'),
	(528121, 131, '2014-02-01 00:23:04.000000', 'consum', 0.0224, 'lps'),
	(528122, 131, '2014-02-01 00:23:05.000000', 'consum', 0.0226, 'lps'),
	(528123, 131, '2014-02-01 00:23:06.000000', 'consum', 0.0211, 'lps'),
	(528124, 131, '2014-02-01 00:23:07.000000', 'consum', 0.0224, 'lps'),
	(528125, 131, '2014-02-01 00:23:08.000000', 'consum', 0.0220, 'lps'),
	(528126, 131, '2014-02-01 00:23:09.000000', 'consum', 0.0221, 'lps'),
	(528127, 131, '2014-02-01 00:23:10.000000', 'consum', 0.0219, 'lps'),
	(528128, 131, '2014-02-01 00:23:11.000000', 'consum', 0.0220, 'lps'),
	(528129, 131, '2014-02-01 00:23:12.000000', 'consum', 0.0215, 'lps'),
	(528130, 131, '2014-02-01 00:23:13.000000', 'consum', 0.0223, 'lps'),
	(528131, 131, '2014-02-01 00:23:14.000000', 'consum', 0.0227, 'lps'),
	(528132, 131, '2014-02-01 00:23:15.000000', 'consum', 0.0220, 'lps'),
	(528133, 131, '2014-02-01 00:23:16.000000', 'consum', 0.0226, 'lps'),
	(528134, 131, '2014-02-01 00:23:17.000000', 'consum', 0.0227, 'lps'),
	(528135, 131, '2014-02-01 00:23:18.000000', 'consum', 0.0211, 'lps'),
	(528136, 131, '2014-02-01 00:23:19.000000', 'consum', 0.0218, 'lps'),
	(528137, 131, '2014-02-01 00:23:20.000000', 'consum', 0.0212, 'lps'),
	(528138, 131, '2014-02-01 00:23:21.000000', 'consum', 0.0215, 'lps'),
	(528139, 131, '2014-02-01 00:23:22.000000', 'consum', 0.0211, 'lps'),
	(528140, 131, '2014-02-01 00:23:23.000000', 'consum', 0.0219, 'lps'),
	(528141, 131, '2014-02-01 00:23:24.000000', 'consum', 0.0215, 'lps'),
	(528142, 131, '2014-02-01 00:23:25.000000', 'consum', 0.0227, 'lps'),
	(528143, 131, '2014-02-01 00:23:26.000000', 'consum', 0.0210, 'lps'),
	(528144, 131, '2014-02-01 00:23:27.000000', 'consum', 0.0210, 'lps'),
	(528145, 131, '2014-02-01 00:23:28.000000', 'consum', 0.0214, 'lps'),
	(528146, 131, '2014-02-01 00:23:29.000000', 'consum', 0.0213, 'lps'),
	(528147, 131, '2014-02-01 00:23:30.000000', 'consum', 0.0213, 'lps'),
	(528148, 131, '2014-02-01 00:23:31.000000', 'consum', 0.0217, 'lps'),
	(528149, 131, '2014-02-01 00:23:32.000000', 'consum', 0.0218, 'lps'),
	(528150, 131, '2014-02-01 00:23:33.000000', 'consum', 0.0211, 'lps'),
	(528151, 131, '2014-02-01 00:23:34.000000', 'consum', 0.0211, 'lps'),
	(528152, 131, '2014-02-01 00:23:35.000000', 'consum', 0.0210, 'lps'),
	(528153, 131, '2014-02-01 00:23:36.000000', 'consum', 0.0226, 'lps'),
	(528154, 131, '2014-02-01 00:23:37.000000', 'consum', 0.0217, 'lps'),
	(528155, 131, '2014-02-01 00:23:38.000000', 'consum', 0.0218, 'lps'),
	(528156, 131, '2014-02-01 00:23:39.000000', 'consum', 0.0227, 'lps'),
	(528157, 131, '2014-02-01 00:23:40.000000', 'consum', 0.0219, 'lps'),
	(528158, 131, '2014-02-01 00:23:41.000000', 'consum', 0.0224, 'lps'),
	(528159, 131, '2014-02-01 00:23:42.000000', 'consum', 0.0217, 'lps'),
	(528160, 131, '2014-02-01 00:23:43.000000', 'consum', 0.0223, 'lps'),
	(528161, 131, '2014-02-01 00:23:44.000000', 'consum', 0.0216, 'lps'),
	(528162, 131, '2014-02-01 00:23:45.000000', 'consum', 0.0222, 'lps'),
	(528163, 131, '2014-02-01 00:23:46.000000', 'consum', 0.0215, 'lps'),
	(528164, 131, '2014-02-01 00:23:47.000000', 'consum', 0.0216, 'lps'),
	(528165, 131, '2014-02-01 00:23:48.000000', 'consum', 0.0225, 'lps'),
	(528166, 131, '2014-02-01 00:23:49.000000', 'consum', 0.0217, 'lps'),
	(528167, 131, '2014-02-01 00:23:50.000000', 'consum', 0.0216, 'lps'),
	(528168, 131, '2014-02-01 00:23:51.000000', 'consum', 0.0218, 'lps'),
	(528169, 131, '2014-02-01 00:23:52.000000', 'consum', 0.0217, 'lps'),
	(528170, 131, '2014-02-01 00:23:53.000000', 'consum', 0.0219, 'lps'),
	(528171, 131, '2014-02-01 00:23:54.000000', 'consum', 0.0217, 'lps'),
	(528172, 131, '2014-02-01 00:23:55.000000', 'consum', 0.0219, 'lps'),
	(528173, 131, '2014-02-01 00:23:56.000000', 'consum', 0.0217, 'lps'),
	(528174, 131, '2014-02-01 00:23:57.000000', 'consum', 0.0218, 'lps'),
	(528175, 131, '2014-02-01 00:23:58.000000', 'consum', 0.0213, 'lps'),
	(528176, 131, '2014-02-01 00:23:59.000000', 'consum', 0.0217, 'lps'),
	(528177, 131, '2014-02-01 00:24:00.000000', 'consum', 0.0219, 'lps'),
	(528178, 131, '2014-02-01 00:24:01.000000', 'consum', 0.0217, 'lps'),
	(528179, 131, '2014-02-01 00:24:02.000000', 'consum', 0.0219, 'lps'),
	(528180, 131, '2014-02-01 00:24:03.000000', 'consum', 0.0216, 'lps'),
	(528181, 131, '2014-02-01 00:24:04.000000', 'consum', 0.0213, 'lps'),
	(528182, 131, '2014-02-01 00:24:05.000000', 'consum', 0.0210, 'lps'),
	(528183, 131, '2014-02-01 00:24:06.000000', 'consum', 0.0217, 'lps'),
	(528184, 131, '2014-02-01 00:24:07.000000', 'consum', 0.0210, 'lps'),
	(528185, 131, '2014-02-01 00:24:08.000000', 'consum', 0.0226, 'lps'),
	(528186, 131, '2014-02-01 00:24:09.000000', 'consum', 0.0216, 'lps'),
	(528187, 131, '2014-02-01 00:24:10.000000', 'consum', 0.0213, 'lps'),
	(528188, 131, '2014-02-01 00:24:11.000000', 'consum', 0.0225, 'lps'),
	(528189, 131, '2014-02-01 00:24:12.000000', 'consum', 0.0222, 'lps'),
	(528190, 131, '2014-02-01 00:24:13.000000', 'consum', 0.0226, 'lps'),
	(528191, 131, '2014-02-01 00:24:14.000000', 'consum', 0.0220, 'lps'),
	(528192, 131, '2014-02-01 00:24:15.000000', 'consum', 0.0212, 'lps'),
	(528193, 131, '2014-02-01 00:24:16.000000', 'consum', 0.0227, 'lps'),
	(528194, 131, '2014-02-01 00:24:17.000000', 'consum', 0.0216, 'lps'),
	(528195, 131, '2014-02-01 00:24:18.000000', 'consum', 0.0224, 'lps'),
	(528196, 131, '2014-02-01 00:24:19.000000', 'consum', 0.0210, 'lps'),
	(528197, 131, '2014-02-01 00:24:20.000000', 'consum', 0.0224, 'lps'),
	(528198, 131, '2014-02-01 00:24:21.000000', 'consum', 0.0227, 'lps'),
	(528199, 131, '2014-02-01 00:24:22.000000', 'consum', 0.0217, 'lps'),
	(528200, 131, '2014-02-01 00:24:23.000000', 'consum', 0.0212, 'lps'),
	(528201, 131, '2014-02-01 00:24:24.000000', 'consum', 0.0217, 'lps'),
	(528202, 131, '2014-02-01 00:24:25.000000', 'consum', 0.0221, 'lps'),
	(528203, 131, '2014-02-01 00:24:26.000000', 'consum', 0.0210, 'lps'),
	(528204, 131, '2014-02-01 00:24:27.000000', 'consum', 0.0214, 'lps'),
	(528205, 131, '2014-02-01 00:24:28.000000', 'consum', 0.0213, 'lps'),
	(528206, 131, '2014-02-01 00:24:29.000000', 'consum', 0.0213, 'lps'),
	(528207, 131, '2014-02-01 00:24:30.000000', 'consum', 0.0217, 'lps'),
	(528208, 131, '2014-02-01 00:24:31.000000', 'consum', 0.0218, 'lps'),
	(528209, 131, '2014-02-01 00:24:32.000000', 'consum', 0.0213, 'lps'),
	(528210, 131, '2014-02-01 00:24:33.000000', 'consum', 0.0220, 'lps'),
	(528211, 131, '2014-02-01 00:24:34.000000', 'consum', 0.0215, 'lps'),
	(528212, 131, '2014-02-01 00:24:35.000000', 'consum', 0.0225, 'lps'),
	(528213, 131, '2014-02-01 00:24:36.000000', 'consum', 0.0214, 'lps'),
	(528214, 131, '2014-02-01 00:24:37.000000', 'consum', 0.0221, 'lps'),
	(528215, 131, '2014-02-01 00:24:38.000000', 'consum', 0.0219, 'lps'),
	(528216, 131, '2014-02-01 00:24:39.000000', 'consum', 0.0222, 'lps'),
	(528217, 131, '2014-02-01 00:24:40.000000', 'consum', 0.0226, 'lps'),
	(528218, 131, '2014-02-01 00:24:41.000000', 'consum', 0.0217, 'lps'),
	(528219, 131, '2014-02-01 00:24:42.000000', 'consum', 0.0216, 'lps'),
	(528220, 131, '2014-02-01 00:24:43.000000', 'consum', 0.0219, 'lps'),
	(528221, 131, '2014-02-01 00:24:44.000000', 'consum', 0.0222, 'lps'),
	(528222, 131, '2014-02-01 00:24:45.000000', 'consum', 0.0223, 'lps'),
	(528223, 131, '2014-02-01 00:24:46.000000', 'consum', 0.0224, 'lps'),
	(528224, 131, '2014-02-01 00:24:47.000000', 'consum', 0.0224, 'lps'),
	(528225, 131, '2014-02-01 00:24:48.000000', 'consum', 0.0217, 'lps'),
	(528226, 131, '2014-02-01 00:24:49.000000', 'consum', 0.0225, 'lps'),
	(528227, 131, '2014-02-01 00:24:50.000000', 'consum', 0.0225, 'lps'),
	(528228, 131, '2014-02-01 00:24:51.000000', 'consum', 0.0225, 'lps'),
	(528229, 131, '2014-02-01 00:24:52.000000', 'consum', 0.0223, 'lps'),
	(528230, 131, '2014-02-01 00:24:53.000000', 'consum', 0.0213, 'lps'),
	(528231, 131, '2014-02-01 00:24:54.000000', 'consum', 0.0222, 'lps'),
	(528232, 131, '2014-02-01 00:24:55.000000', 'consum', 0.0227, 'lps'),
	(528233, 131, '2014-02-01 00:24:56.000000', 'consum', 0.0220, 'lps'),
	(528234, 131, '2014-02-01 00:24:57.000000', 'consum', 0.0213, 'lps'),
	(528235, 131, '2014-02-01 00:24:58.000000', 'consum', 0.0211, 'lps'),
	(528236, 131, '2014-02-01 00:24:59.000000', 'consum', 0.0225, 'lps'),
	(528237, 131, '2014-02-01 00:25:00.000000', 'consum', 0.0210, 'lps'),
	(528238, 131, '2014-02-01 00:25:01.000000', 'consum', 0.0218, 'lps'),
	(528239, 131, '2014-02-01 00:25:02.000000', 'consum', 0.0216, 'lps'),
	(528240, 131, '2014-02-01 00:25:03.000000', 'consum', 0.0215, 'lps'),
	(528241, 131, '2014-02-01 00:25:04.000000', 'consum', 0.0217, 'lps'),
	(528242, 131, '2014-02-01 00:25:05.000000', 'consum', 0.0213, 'lps'),
	(528243, 131, '2014-02-01 00:25:06.000000', 'consum', 0.0222, 'lps'),
	(528244, 131, '2014-02-01 00:25:07.000000', 'consum', 0.0227, 'lps'),
	(528245, 131, '2014-02-01 00:25:08.000000', 'consum', 0.0224, 'lps'),
	(528246, 131, '2014-02-01 00:25:09.000000', 'consum', 0.0210, 'lps'),
	(528247, 131, '2014-02-01 00:25:10.000000', 'consum', 0.0225, 'lps'),
	(528248, 131, '2014-02-01 00:25:11.000000', 'consum', 0.0210, 'lps'),
	(528249, 131, '2014-02-01 00:25:12.000000', 'consum', 0.0223, 'lps'),
	(528250, 131, '2014-02-01 00:25:13.000000', 'consum', 0.0219, 'lps'),
	(528251, 131, '2014-02-01 00:25:14.000000', 'consum', 0.0217, 'lps'),
	(528252, 131, '2014-02-01 00:25:15.000000', 'consum', 0.0217, 'lps'),
	(528253, 131, '2014-02-01 00:25:16.000000', 'consum', 0.0227, 'lps'),
	(528254, 131, '2014-02-01 00:25:17.000000', 'consum', 0.0219, 'lps'),
	(528255, 131, '2014-02-01 00:25:18.000000', 'consum', 0.0223, 'lps'),
	(528256, 131, '2014-02-01 00:25:19.000000', 'consum', 0.0211, 'lps'),
	(528257, 131, '2014-02-01 00:25:20.000000', 'consum', 0.0211, 'lps'),
	(528258, 131, '2014-02-01 00:25:21.000000', 'consum', 0.0216, 'lps'),
	(528259, 131, '2014-02-01 00:25:22.000000', 'consum', 0.0218, 'lps'),
	(528260, 131, '2014-02-01 00:25:23.000000', 'consum', 0.0215, 'lps'),
	(528261, 131, '2014-02-01 00:25:24.000000', 'consum', 0.0213, 'lps'),
	(528262, 131, '2014-02-01 00:25:25.000000', 'consum', 0.0211, 'lps'),
	(528263, 131, '2014-02-01 00:25:26.000000', 'consum', 0.0221, 'lps'),
	(528264, 131, '2014-02-01 00:25:27.000000', 'consum', 0.0212, 'lps'),
	(528265, 131, '2014-02-01 00:25:28.000000', 'consum', 0.0223, 'lps'),
	(528266, 131, '2014-02-01 00:25:29.000000', 'consum', 0.0214, 'lps'),
	(528267, 131, '2014-02-01 00:25:30.000000', 'consum', 0.0210, 'lps'),
	(528268, 131, '2014-02-01 00:25:31.000000', 'consum', 0.0216, 'lps'),
	(528269, 131, '2014-02-01 00:25:32.000000', 'consum', 0.0223, 'lps'),
	(528270, 131, '2014-02-01 00:25:33.000000', 'consum', 0.0223, 'lps'),
	(528271, 131, '2014-02-01 00:25:34.000000', 'consum', 0.0219, 'lps'),
	(528272, 131, '2014-02-01 00:25:35.000000', 'consum', 0.0214, 'lps'),
	(528273, 131, '2014-02-01 00:25:36.000000', 'consum', 0.0221, 'lps'),
	(528274, 131, '2014-02-01 00:25:37.000000', 'consum', 0.0221, 'lps'),
	(528275, 131, '2014-02-01 00:25:38.000000', 'consum', 0.0211, 'lps'),
	(528276, 131, '2014-02-01 00:25:39.000000', 'consum', 0.0219, 'lps'),
	(528277, 131, '2014-02-01 00:25:40.000000', 'consum', 0.0215, 'lps'),
	(528278, 131, '2014-02-01 00:25:41.000000', 'consum', 0.0212, 'lps'),
	(528279, 131, '2014-02-01 00:25:42.000000', 'consum', 0.0221, 'lps'),
	(528280, 131, '2014-02-01 00:25:43.000000', 'consum', 0.0223, 'lps'),
	(528281, 131, '2014-02-01 00:25:44.000000', 'consum', 0.0226, 'lps'),
	(528282, 131, '2014-02-01 00:25:45.000000', 'consum', 0.0215, 'lps'),
	(528283, 131, '2014-02-01 00:25:46.000000', 'consum', 0.0225, 'lps'),
	(528284, 131, '2014-02-01 00:25:47.000000', 'consum', 0.0217, 'lps'),
	(528285, 131, '2014-02-01 00:25:48.000000', 'consum', 0.0217, 'lps'),
	(528286, 131, '2014-02-01 00:25:49.000000', 'consum', 0.0224, 'lps'),
	(528287, 131, '2014-02-01 00:25:50.000000', 'consum', 0.0224, 'lps'),
	(528288, 131, '2014-02-01 00:25:51.000000', 'consum', 0.0222, 'lps'),
	(528289, 131, '2014-02-01 00:25:52.000000', 'consum', 0.0226, 'lps'),
	(528290, 131, '2014-02-01 00:25:53.000000', 'consum', 0.0221, 'lps'),
	(528291, 131, '2014-02-01 00:25:54.000000', 'consum', 0.0215, 'lps'),
	(528292, 131, '2014-02-01 00:25:55.000000', 'consum', 0.0223, 'lps'),
	(528293, 131, '2014-02-01 00:25:56.000000', 'consum', 0.0221, 'lps'),
	(528294, 131, '2014-02-01 00:25:57.000000', 'consum', 0.0212, 'lps'),
	(528295, 131, '2014-02-01 00:25:58.000000', 'consum', 0.0221, 'lps'),
	(528296, 131, '2014-02-01 00:25:59.000000', 'consum', 0.0225, 'lps'),
	(528297, 131, '2014-02-01 00:26:00.000000', 'consum', 0.0215, 'lps'),
	(528298, 131, '2014-02-01 00:26:01.000000', 'consum', 0.0226, 'lps'),
	(528299, 131, '2014-02-01 00:26:02.000000', 'consum', 0.0224, 'lps'),
	(528300, 131, '2014-02-01 00:26:03.000000', 'consum', 0.0212, 'lps'),
	(528301, 131, '2014-02-01 00:26:04.000000', 'consum', 0.0216, 'lps'),
	(528302, 131, '2014-02-01 00:26:05.000000', 'consum', 0.0216, 'lps'),
	(528303, 131, '2014-02-01 00:26:06.000000', 'consum', 0.0224, 'lps'),
	(528304, 131, '2014-02-01 00:26:07.000000', 'consum', 0.0224, 'lps'),
	(528305, 131, '2014-02-01 00:26:08.000000', 'consum', 0.0220, 'lps'),
	(528306, 131, '2014-02-01 00:26:09.000000', 'consum', 0.0220, 'lps'),
	(528307, 131, '2014-02-01 00:26:10.000000', 'consum', 0.0214, 'lps'),
	(528308, 131, '2014-02-01 00:26:11.000000', 'consum', 0.0215, 'lps'),
	(528309, 131, '2014-02-01 00:26:12.000000', 'consum', 0.0226, 'lps'),
	(528310, 131, '2014-02-01 00:26:13.000000', 'consum', 0.0220, 'lps'),
	(528311, 131, '2014-02-01 00:26:14.000000', 'consum', 0.0212, 'lps'),
	(528312, 131, '2014-02-01 00:26:15.000000', 'consum', 0.0210, 'lps'),
	(528313, 131, '2014-02-01 00:26:16.000000', 'consum', 0.0222, 'lps'),
	(528314, 131, '2014-02-01 00:26:17.000000', 'consum', 0.0216, 'lps'),
	(528315, 131, '2014-02-01 00:26:18.000000', 'consum', 0.0225, 'lps'),
	(528316, 131, '2014-02-01 00:26:19.000000', 'consum', 0.0210, 'lps'),
	(528317, 131, '2014-02-01 00:26:20.000000', 'consum', 0.0222, 'lps'),
	(528318, 131, '2014-02-01 00:26:21.000000', 'consum', 0.0215, 'lps'),
	(528319, 131, '2014-02-01 00:26:22.000000', 'consum', 0.0219, 'lps'),
	(528320, 131, '2014-02-01 00:26:23.000000', 'consum', 0.0223, 'lps'),
	(528321, 131, '2014-02-01 00:26:24.000000', 'consum', 0.0213, 'lps'),
	(528322, 131, '2014-02-01 00:26:25.000000', 'consum', 0.0223, 'lps'),
	(528323, 131, '2014-02-01 00:26:26.000000', 'consum', 0.0210, 'lps'),
	(528324, 131, '2014-02-01 00:26:27.000000', 'consum', 0.0226, 'lps'),
	(528325, 131, '2014-02-01 00:26:28.000000', 'consum', 0.0221, 'lps'),
	(528326, 131, '2014-02-01 00:26:29.000000', 'consum', 0.0215, 'lps'),
	(528327, 131, '2014-02-01 00:26:30.000000', 'consum', 0.0219, 'lps'),
	(528328, 131, '2014-02-01 00:26:31.000000', 'consum', 0.0226, 'lps'),
	(528329, 131, '2014-02-01 00:26:32.000000', 'consum', 0.0224, 'lps'),
	(528330, 131, '2014-02-01 00:26:33.000000', 'consum', 0.0217, 'lps'),
	(528331, 131, '2014-02-01 00:26:34.000000', 'consum', 0.0221, 'lps'),
	(528332, 131, '2014-02-01 00:26:35.000000', 'consum', 0.0226, 'lps'),
	(528333, 131, '2014-02-01 00:26:36.000000', 'consum', 0.0223, 'lps'),
	(528334, 131, '2014-02-01 00:26:37.000000', 'consum', 0.0225, 'lps'),
	(528335, 131, '2014-02-01 00:26:38.000000', 'consum', 0.0211, 'lps'),
	(528336, 131, '2014-02-01 00:26:39.000000', 'consum', 0.0224, 'lps'),
	(528337, 131, '2014-02-01 00:26:40.000000', 'consum', 0.0223, 'lps'),
	(528338, 131, '2014-02-01 00:26:41.000000', 'consum', 0.0217, 'lps'),
	(528339, 131, '2014-02-01 00:26:42.000000', 'consum', 0.0223, 'lps'),
	(528340, 131, '2014-02-01 00:26:43.000000', 'consum', 0.0217, 'lps'),
	(528341, 131, '2014-02-01 00:26:44.000000', 'consum', 0.0227, 'lps'),
	(528342, 131, '2014-02-01 00:26:45.000000', 'consum', 0.0219, 'lps'),
	(528343, 131, '2014-02-01 00:26:46.000000', 'consum', 0.0222, 'lps'),
	(528344, 131, '2014-02-01 00:26:47.000000', 'consum', 0.0210, 'lps'),
	(528345, 131, '2014-02-01 00:26:48.000000', 'consum', 0.0225, 'lps'),
	(528346, 131, '2014-02-01 00:26:49.000000', 'consum', 0.0217, 'lps'),
	(528347, 131, '2014-02-01 00:26:50.000000', 'consum', 0.0218, 'lps'),
	(528348, 131, '2014-02-01 00:26:51.000000', 'consum', 0.0227, 'lps'),
	(528349, 131, '2014-02-01 00:26:52.000000', 'consum', 0.0221, 'lps'),
	(528350, 131, '2014-02-01 00:26:53.000000', 'consum', 0.0212, 'lps'),
	(528351, 131, '2014-02-01 00:26:54.000000', 'consum', 0.0225, 'lps'),
	(528352, 131, '2014-02-01 00:26:55.000000', 'consum', 0.0226, 'lps'),
	(528353, 131, '2014-02-01 00:26:56.000000', 'consum', 0.0225, 'lps'),
	(528354, 131, '2014-02-01 00:26:57.000000', 'consum', 0.0221, 'lps'),
	(528355, 131, '2014-02-01 00:26:58.000000', 'consum', 0.0220, 'lps'),
	(528356, 131, '2014-02-01 00:26:59.000000', 'consum', 0.0211, 'lps'),
	(528357, 131, '2014-02-01 00:27:00.000000', 'consum', 0.0221, 'lps'),
	(528358, 131, '2014-02-01 00:27:01.000000', 'consum', 0.0226, 'lps'),
	(528359, 131, '2014-02-01 00:27:02.000000', 'consum', 0.0224, 'lps'),
	(528360, 131, '2014-02-01 00:27:03.000000', 'consum', 0.0212, 'lps'),
	(528361, 131, '2014-02-01 00:27:04.000000', 'consum', 0.0213, 'lps'),
	(528362, 131, '2014-02-01 00:27:05.000000', 'consum', 0.0222, 'lps'),
	(528363, 131, '2014-02-01 00:27:06.000000', 'consum', 0.0224, 'lps'),
	(528364, 131, '2014-02-01 00:27:07.000000', 'consum', 0.0210, 'lps'),
	(528365, 131, '2014-02-01 00:27:08.000000', 'consum', 0.0222, 'lps'),
	(528366, 131, '2014-02-01 00:27:09.000000', 'consum', 0.0216, 'lps'),
	(528367, 131, '2014-02-01 00:27:10.000000', 'consum', 0.0222, 'lps'),
	(528368, 131, '2014-02-01 00:27:11.000000', 'consum', 0.0216, 'lps'),
	(528369, 131, '2014-02-01 00:27:12.000000', 'consum', 0.0225, 'lps'),
	(528370, 131, '2014-02-01 00:27:13.000000', 'consum', 0.0212, 'lps'),
	(528371, 131, '2014-02-01 00:27:14.000000', 'consum', 0.0212, 'lps'),
	(528372, 131, '2014-02-01 00:27:15.000000', 'consum', 0.0216, 'lps'),
	(528373, 131, '2014-02-01 00:27:16.000000', 'consum', 0.0215, 'lps'),
	(528374, 131, '2014-02-01 00:27:17.000000', 'consum', 0.0217, 'lps'),
	(528375, 131, '2014-02-01 00:27:18.000000', 'consum', 0.0214, 'lps'),
	(528376, 131, '2014-02-01 00:27:19.000000', 'consum', 0.0211, 'lps'),
	(528377, 131, '2014-02-01 00:27:20.000000', 'consum', 0.0218, 'lps'),
	(528378, 131, '2014-02-01 00:27:21.000000', 'consum', 0.0213, 'lps'),
	(528379, 131, '2014-02-01 00:27:22.000000', 'consum', 0.0218, 'lps'),
	(528380, 131, '2014-02-01 00:27:23.000000', 'consum', 0.0225, 'lps'),
	(528381, 131, '2014-02-01 00:27:24.000000', 'consum', 0.0226, 'lps'),
	(528382, 131, '2014-02-01 00:27:25.000000', 'consum', 0.0226, 'lps'),
	(528383, 131, '2014-02-01 00:27:26.000000', 'consum', 0.0227, 'lps'),
	(528384, 131, '2014-02-01 00:27:27.000000', 'consum', 0.0210, 'lps'),
	(528385, 131, '2014-02-01 00:27:28.000000', 'consum', 0.0212, 'lps'),
	(528386, 131, '2014-02-01 00:27:29.000000', 'consum', 0.0223, 'lps'),
	(528387, 131, '2014-02-01 00:27:30.000000', 'consum', 0.0213, 'lps'),
	(528388, 131, '2014-02-01 00:27:31.000000', 'consum', 0.0223, 'lps'),
	(528389, 131, '2014-02-01 00:27:32.000000', 'consum', 0.0212, 'lps'),
	(528390, 131, '2014-02-01 00:27:33.000000', 'consum', 0.0219, 'lps'),
	(528391, 131, '2014-02-01 00:27:34.000000', 'consum', 0.0215, 'lps'),
	(528392, 131, '2014-02-01 00:27:35.000000', 'consum', 0.0225, 'lps'),
	(528393, 131, '2014-02-01 00:27:36.000000', 'consum', 0.0216, 'lps'),
	(528394, 131, '2014-02-01 00:27:37.000000', 'consum', 0.0214, 'lps'),
	(528395, 131, '2014-02-01 00:27:38.000000', 'consum', 0.0211, 'lps'),
	(528396, 131, '2014-02-01 00:27:39.000000', 'consum', 0.0222, 'lps'),
	(528397, 131, '2014-02-01 00:27:40.000000', 'consum', 0.0214, 'lps'),
	(528398, 131, '2014-02-01 00:27:41.000000', 'consum', 0.0213, 'lps'),
	(528399, 131, '2014-02-01 00:27:42.000000', 'consum', 0.0213, 'lps'),
	(528400, 131, '2014-02-01 00:27:43.000000', 'consum', 0.0216, 'lps'),
	(528401, 131, '2014-02-01 00:27:44.000000', 'consum', 0.0213, 'lps'),
	(528402, 131, '2014-02-01 00:27:45.000000', 'consum', 0.0225, 'lps'),
	(528403, 131, '2014-02-01 00:27:46.000000', 'consum', 0.0225, 'lps'),
	(528404, 131, '2014-02-01 00:27:47.000000', 'consum', 0.0221, 'lps'),
	(528405, 131, '2014-02-01 00:27:48.000000', 'consum', 0.0219, 'lps'),
	(528406, 131, '2014-02-01 00:27:49.000000', 'consum', 0.0224, 'lps'),
	(528407, 131, '2014-02-01 00:27:50.000000', 'consum', 0.0216, 'lps'),
	(528408, 131, '2014-02-01 00:27:51.000000', 'consum', 0.0219, 'lps'),
	(528409, 131, '2014-02-01 00:27:52.000000', 'consum', 0.0219, 'lps'),
	(528410, 131, '2014-02-01 00:27:53.000000', 'consum', 0.0210, 'lps'),
	(528411, 131, '2014-02-01 00:27:54.000000', 'consum', 0.0220, 'lps'),
	(528412, 131, '2014-02-01 00:27:55.000000', 'consum', 0.0223, 'lps'),
	(528413, 131, '2014-02-01 00:27:56.000000', 'consum', 0.0210, 'lps'),
	(528414, 131, '2014-02-01 00:27:57.000000', 'consum', 0.0227, 'lps'),
	(528415, 131, '2014-02-01 00:27:58.000000', 'consum', 0.0221, 'lps'),
	(528416, 131, '2014-02-01 00:27:59.000000', 'consum', 0.0216, 'lps'),
	(528417, 131, '2014-02-01 00:28:00.000000', 'consum', 0.0224, 'lps'),
	(528418, 131, '2014-02-01 00:28:01.000000', 'consum', 0.0210, 'lps'),
	(528419, 131, '2014-02-01 00:28:02.000000', 'consum', 0.0224, 'lps'),
	(528420, 131, '2014-02-01 00:28:03.000000', 'consum', 0.0223, 'lps'),
	(528421, 131, '2014-02-01 00:28:04.000000', 'consum', 0.0217, 'lps'),
	(528422, 131, '2014-02-01 00:28:05.000000', 'consum', 0.0225, 'lps'),
	(528423, 131, '2014-02-01 00:28:06.000000', 'consum', 0.0226, 'lps'),
	(528424, 131, '2014-02-01 00:28:07.000000', 'consum', 0.0212, 'lps'),
	(528425, 131, '2014-02-01 00:28:08.000000', 'consum', 0.0227, 'lps'),
	(528426, 131, '2014-02-01 00:28:09.000000', 'consum', 0.0218, 'lps'),
	(528427, 131, '2014-02-01 00:28:10.000000', 'consum', 0.0217, 'lps'),
	(528428, 131, '2014-02-01 00:28:11.000000', 'consum', 0.0223, 'lps'),
	(528429, 131, '2014-02-01 00:28:12.000000', 'consum', 0.0217, 'lps'),
	(528430, 131, '2014-02-01 00:28:13.000000', 'consum', 0.0227, 'lps'),
	(528431, 131, '2014-02-01 00:28:14.000000', 'consum', 0.0217, 'lps'),
	(528432, 131, '2014-02-01 00:28:15.000000', 'consum', 0.0216, 'lps'),
	(528433, 131, '2014-02-01 00:28:16.000000', 'consum', 0.0217, 'lps'),
	(528434, 131, '2014-02-01 00:28:17.000000', 'consum', 0.0210, 'lps'),
	(528435, 131, '2014-02-01 00:28:18.000000', 'consum', 0.0225, 'lps'),
	(528436, 131, '2014-02-01 00:28:19.000000', 'consum', 0.0214, 'lps'),
	(528437, 131, '2014-02-01 00:28:20.000000', 'consum', 0.0220, 'lps'),
	(528438, 131, '2014-02-01 00:28:21.000000', 'consum', 0.0215, 'lps'),
	(528439, 131, '2014-02-01 00:28:22.000000', 'consum', 0.0223, 'lps'),
	(528440, 131, '2014-02-01 00:28:23.000000', 'consum', 0.0225, 'lps'),
	(528441, 131, '2014-02-01 00:28:24.000000', 'consum', 0.0210, 'lps'),
	(528442, 131, '2014-02-01 00:28:25.000000', 'consum', 0.0220, 'lps'),
	(528443, 131, '2014-02-01 00:28:26.000000', 'consum', 0.0223, 'lps'),
	(528444, 131, '2014-02-01 00:28:27.000000', 'consum', 0.0211, 'lps'),
	(528445, 131, '2014-02-01 00:28:28.000000', 'consum', 0.0211, 'lps'),
	(528446, 131, '2014-02-01 00:28:29.000000', 'consum', 0.0214, 'lps'),
	(528447, 131, '2014-02-01 00:28:30.000000', 'consum', 0.0227, 'lps'),
	(528448, 131, '2014-02-01 00:28:31.000000', 'consum', 0.0211, 'lps'),
	(528449, 131, '2014-02-01 00:28:32.000000', 'consum', 0.0218, 'lps'),
	(528450, 131, '2014-02-01 00:28:33.000000', 'consum', 0.0212, 'lps'),
	(528451, 131, '2014-02-01 00:28:34.000000', 'consum', 0.0213, 'lps'),
	(528452, 131, '2014-02-01 00:28:35.000000', 'consum', 0.0219, 'lps'),
	(528453, 131, '2014-02-01 00:28:36.000000', 'consum', 0.0211, 'lps'),
	(528454, 131, '2014-02-01 00:28:37.000000', 'consum', 0.0223, 'lps'),
	(528455, 131, '2014-02-01 00:28:38.000000', 'consum', 0.0220, 'lps'),
	(528456, 131, '2014-02-01 00:28:39.000000', 'consum', 0.0223, 'lps'),
	(528457, 131, '2014-02-01 00:28:40.000000', 'consum', 0.0226, 'lps'),
	(528458, 131, '2014-02-01 00:28:41.000000', 'consum', 0.0217, 'lps'),
	(528459, 131, '2014-02-01 00:28:42.000000', 'consum', 0.0216, 'lps'),
	(528460, 131, '2014-02-01 00:28:43.000000', 'consum', 0.0220, 'lps'),
	(528461, 131, '2014-02-01 00:28:44.000000', 'consum', 0.0224, 'lps'),
	(528462, 131, '2014-02-01 00:28:45.000000', 'consum', 0.0215, 'lps'),
	(528463, 131, '2014-02-01 00:28:46.000000', 'consum', 0.0227, 'lps'),
	(528464, 131, '2014-02-01 00:28:47.000000', 'consum', 0.0212, 'lps'),
	(528465, 131, '2014-02-01 00:28:48.000000', 'consum', 0.0222, 'lps'),
	(528466, 131, '2014-02-01 00:28:49.000000', 'consum', 0.0210, 'lps'),
	(528467, 131, '2014-02-01 00:28:50.000000', 'consum', 0.0227, 'lps'),
	(528468, 131, '2014-02-01 00:28:51.000000', 'consum', 0.0224, 'lps'),
	(528469, 131, '2014-02-01 00:28:52.000000', 'consum', 0.0210, 'lps'),
	(528470, 131, '2014-02-01 00:28:53.000000', 'consum', 0.0226, 'lps'),
	(528471, 131, '2014-02-01 00:28:54.000000', 'consum', 0.0215, 'lps'),
	(528472, 131, '2014-02-01 00:28:55.000000', 'consum', 0.0227, 'lps'),
	(528473, 131, '2014-02-01 00:28:56.000000', 'consum', 0.0224, 'lps'),
	(528474, 131, '2014-02-01 00:28:57.000000', 'consum', 0.0214, 'lps'),
	(528475, 131, '2014-02-01 00:28:58.000000', 'consum', 0.0225, 'lps'),
	(528476, 131, '2014-02-01 00:28:59.000000', 'consum', 0.0217, 'lps'),
	(528477, 131, '2014-02-01 00:29:00.000000', 'consum', 0.0219, 'lps'),
	(528478, 131, '2014-02-01 00:29:01.000000', 'consum', 0.0216, 'lps'),
	(528479, 131, '2014-02-01 00:29:02.000000', 'consum', 0.0216, 'lps'),
	(528480, 131, '2014-02-01 00:29:03.000000', 'consum', 0.0219, 'lps'),
	(528481, 131, '2014-02-01 00:29:04.000000', 'consum', 0.0223, 'lps'),
	(528482, 131, '2014-02-01 00:29:05.000000', 'consum', 0.0227, 'lps'),
	(528483, 131, '2014-02-01 00:29:06.000000', 'consum', 0.0223, 'lps'),
	(528484, 131, '2014-02-01 00:29:07.000000', 'consum', 0.0223, 'lps'),
	(528485, 131, '2014-02-01 00:29:08.000000', 'consum', 0.0218, 'lps'),
	(528486, 131, '2014-02-01 00:29:09.000000', 'consum', 0.0211, 'lps'),
	(528487, 131, '2014-02-01 00:29:10.000000', 'consum', 0.0226, 'lps'),
	(528488, 131, '2014-02-01 00:29:11.000000', 'consum', 0.0219, 'lps'),
	(528489, 131, '2014-02-01 00:29:12.000000', 'consum', 0.0224, 'lps'),
	(528490, 131, '2014-02-01 00:29:13.000000', 'consum', 0.0218, 'lps'),
	(528491, 131, '2014-02-01 00:29:14.000000', 'consum', 0.0225, 'lps'),
	(528492, 131, '2014-02-01 00:29:15.000000', 'consum', 0.0227, 'lps'),
	(528493, 131, '2014-02-01 00:29:16.000000', 'consum', 0.0214, 'lps'),
	(528494, 131, '2014-02-01 00:29:17.000000', 'consum', 0.0216, 'lps'),
	(528495, 131, '2014-02-01 00:29:18.000000', 'consum', 0.0227, 'lps'),
	(528496, 131, '2014-02-01 00:29:19.000000', 'consum', 0.0226, 'lps'),
	(528497, 131, '2014-02-01 00:29:20.000000', 'consum', 0.0220, 'lps'),
	(528498, 131, '2014-02-01 00:29:21.000000', 'consum', 0.0213, 'lps'),
	(528499, 131, '2014-02-01 00:29:22.000000', 'consum', 0.0212, 'lps'),
	(528500, 131, '2014-02-01 00:29:23.000000', 'consum', 0.0214, 'lps'),
	(528501, 131, '2014-02-01 00:29:24.000000', 'consum', 0.0224, 'lps'),
	(528502, 131, '2014-02-01 00:29:25.000000', 'consum', 0.0216, 'lps'),
	(528503, 131, '2014-02-01 00:29:26.000000', 'consum', 0.0216, 'lps'),
	(528504, 131, '2014-02-01 00:29:27.000000', 'consum', 0.0222, 'lps'),
	(528505, 131, '2014-02-01 00:29:28.000000', 'consum', 0.0218, 'lps'),
	(528506, 131, '2014-02-01 00:29:29.000000', 'consum', 0.0212, 'lps'),
	(528507, 131, '2014-02-01 00:29:30.000000', 'consum', 0.0217, 'lps'),
	(528508, 131, '2014-02-01 00:29:31.000000', 'consum', 0.0221, 'lps'),
	(528509, 131, '2014-02-01 00:29:32.000000', 'consum', 0.0227, 'lps'),
	(528510, 131, '2014-02-01 00:29:33.000000', 'consum', 0.0210, 'lps'),
	(528511, 131, '2014-02-01 00:29:34.000000', 'consum', 0.0211, 'lps'),
	(528512, 131, '2014-02-01 00:29:35.000000', 'consum', 0.0218, 'lps'),
	(528513, 131, '2014-02-01 00:29:36.000000', 'consum', 0.0210, 'lps'),
	(528514, 131, '2014-02-01 00:29:37.000000', 'consum', 0.0224, 'lps'),
	(528515, 131, '2014-02-01 00:29:38.000000', 'consum', 0.0227, 'lps'),
	(528516, 131, '2014-02-01 00:29:39.000000', 'consum', 0.0218, 'lps'),
	(528517, 131, '2014-02-01 00:29:40.000000', 'consum', 0.0218, 'lps'),
	(528518, 131, '2014-02-01 00:29:41.000000', 'consum', 0.0224, 'lps'),
	(528519, 131, '2014-02-01 00:29:42.000000', 'consum', 0.0220, 'lps'),
	(528520, 131, '2014-02-01 00:29:43.000000', 'consum', 0.0220, 'lps'),
	(528521, 131, '2014-02-01 00:29:44.000000', 'consum', 0.0214, 'lps'),
	(528522, 131, '2014-02-01 00:29:45.000000', 'consum', 0.0217, 'lps'),
	(528523, 131, '2014-02-01 00:29:46.000000', 'consum', 0.0215, 'lps'),
	(528524, 131, '2014-02-01 00:29:47.000000', 'consum', 0.0213, 'lps'),
	(528525, 131, '2014-02-01 00:29:48.000000', 'consum', 0.0214, 'lps'),
	(528526, 131, '2014-02-01 00:29:49.000000', 'consum', 0.0219, 'lps'),
	(528527, 131, '2014-02-01 00:29:50.000000', 'consum', 0.0227, 'lps'),
	(528528, 131, '2014-02-01 00:29:51.000000', 'consum', 0.0214, 'lps'),
	(528529, 131, '2014-02-01 00:29:52.000000', 'consum', 0.0217, 'lps'),
	(528530, 131, '2014-02-01 00:29:53.000000', 'consum', 0.0214, 'lps'),
	(528531, 131, '2014-02-01 00:29:54.000000', 'consum', 0.0211, 'lps'),
	(528532, 131, '2014-02-01 00:29:55.000000', 'consum', 0.0222, 'lps'),
	(528533, 131, '2014-02-01 00:29:56.000000', 'consum', 0.0213, 'lps'),
	(528534, 131, '2014-02-01 00:29:57.000000', 'consum', 0.0224, 'lps'),
	(528535, 131, '2014-02-01 00:29:58.000000', 'consum', 0.0218, 'lps'),
	(528536, 131, '2014-02-01 00:29:59.000000', 'consum', 0.0210, 'lps'),
	(528537, 131, '2014-02-01 00:30:00.000000', 'consum', 0.0221, 'lps'),
	(528538, 131, '2014-02-01 00:30:01.000000', 'consum', 0.0214, 'lps'),
	(528539, 131, '2014-02-01 00:30:02.000000', 'consum', 0.0212, 'lps'),
	(528540, 131, '2014-02-01 00:30:03.000000', 'consum', 0.0210, 'lps'),
	(528541, 131, '2014-02-01 00:30:04.000000', 'consum', 0.0224, 'lps'),
	(528542, 131, '2014-02-01 00:30:05.000000', 'consum', 0.0225, 'lps'),
	(528543, 131, '2014-02-01 00:30:06.000000', 'consum', 0.0227, 'lps'),
	(528544, 131, '2014-02-01 00:30:07.000000', 'consum', 0.0214, 'lps'),
	(528545, 131, '2014-02-01 00:30:08.000000', 'consum', 0.0215, 'lps'),
	(528546, 131, '2014-02-01 00:30:09.000000', 'consum', 0.0223, 'lps'),
	(528547, 131, '2014-02-01 00:30:10.000000', 'consum', 0.0225, 'lps'),
	(528548, 131, '2014-02-01 00:30:11.000000', 'consum', 0.0210, 'lps'),
	(528549, 131, '2014-02-01 00:30:12.000000', 'consum', 0.0222, 'lps'),
	(528550, 131, '2014-02-01 00:30:13.000000', 'consum', 0.0213, 'lps'),
	(528551, 131, '2014-02-01 00:30:14.000000', 'consum', 0.0227, 'lps'),
	(528552, 131, '2014-02-01 00:30:15.000000', 'consum', 0.0214, 'lps'),
	(528553, 131, '2014-02-01 00:30:16.000000', 'consum', 0.0216, 'lps'),
	(528554, 131, '2014-02-01 00:30:17.000000', 'consum', 0.0227, 'lps'),
	(528555, 131, '2014-02-01 00:30:18.000000', 'consum', 0.0222, 'lps'),
	(528556, 131, '2014-02-01 00:30:19.000000', 'consum', 0.0223, 'lps'),
	(528557, 131, '2014-02-01 00:30:20.000000', 'consum', 0.0220, 'lps'),
	(528558, 131, '2014-02-01 00:30:21.000000', 'consum', 0.0222, 'lps'),
	(528559, 131, '2014-02-01 00:30:22.000000', 'consum', 0.0220, 'lps'),
	(528560, 131, '2014-02-01 00:30:23.000000', 'consum', 0.0210, 'lps'),
	(528561, 131, '2014-02-01 00:30:24.000000', 'consum', 0.0214, 'lps'),
	(528562, 131, '2014-02-01 00:30:25.000000', 'consum', 0.0212, 'lps'),
	(528563, 131, '2014-02-01 00:30:26.000000', 'consum', 0.0210, 'lps'),
	(528564, 131, '2014-02-01 00:30:27.000000', 'consum', 0.0222, 'lps'),
	(528565, 131, '2014-02-01 00:30:28.000000', 'consum', 0.0216, 'lps'),
	(528566, 131, '2014-02-01 00:30:29.000000', 'consum', 0.0223, 'lps'),
	(528567, 131, '2014-02-01 00:30:30.000000', 'consum', 0.0223, 'lps'),
	(528568, 131, '2014-02-01 00:30:31.000000', 'consum', 0.0215, 'lps'),
	(528569, 131, '2014-02-01 00:30:32.000000', 'consum', 0.0218, 'lps'),
	(528570, 131, '2014-02-01 00:30:33.000000', 'consum', 0.0215, 'lps'),
	(528571, 131, '2014-02-01 00:30:34.000000', 'consum', 0.0214, 'lps'),
	(528572, 131, '2014-02-01 00:30:35.000000', 'consum', 0.0216, 'lps'),
	(528573, 131, '2014-02-01 00:30:36.000000', 'consum', 0.0227, 'lps'),
	(528574, 131, '2014-02-01 00:30:37.000000', 'consum', 0.0222, 'lps'),
	(528575, 131, '2014-02-01 00:30:38.000000', 'consum', 0.0223, 'lps'),
	(528576, 131, '2014-02-01 00:30:39.000000', 'consum', 0.0219, 'lps'),
	(528577, 131, '2014-02-01 00:30:40.000000', 'consum', 0.0215, 'lps'),
	(528578, 131, '2014-02-01 00:30:41.000000', 'consum', 0.0212, 'lps'),
	(528579, 131, '2014-02-01 00:30:42.000000', 'consum', 0.0223, 'lps'),
	(528580, 131, '2014-02-01 00:30:43.000000', 'consum', 0.0213, 'lps'),
	(528581, 131, '2014-02-01 00:30:44.000000', 'consum', 0.0225, 'lps'),
	(528582, 131, '2014-02-01 00:30:45.000000', 'consum', 0.0220, 'lps'),
	(528583, 131, '2014-02-01 00:30:46.000000', 'consum', 0.0216, 'lps'),
	(528584, 131, '2014-02-01 00:30:47.000000', 'consum', 0.0212, 'lps'),
	(528585, 131, '2014-02-01 00:30:48.000000', 'consum', 0.0222, 'lps'),
	(528586, 131, '2014-02-01 00:30:49.000000', 'consum', 0.0226, 'lps'),
	(528587, 131, '2014-02-01 00:30:50.000000', 'consum', 0.0218, 'lps'),
	(528588, 131, '2014-02-01 00:30:51.000000', 'consum', 0.0222, 'lps'),
	(528589, 131, '2014-02-01 00:30:52.000000', 'consum', 0.0227, 'lps'),
	(528590, 131, '2014-02-01 00:30:53.000000', 'consum', 0.0226, 'lps'),
	(528591, 131, '2014-02-01 00:30:54.000000', 'consum', 0.0221, 'lps'),
	(528592, 131, '2014-02-01 00:30:55.000000', 'consum', 0.0215, 'lps'),
	(528593, 131, '2014-02-01 00:30:56.000000', 'consum', 0.0223, 'lps'),
	(528594, 131, '2014-02-01 00:30:57.000000', 'consum', 0.0223, 'lps'),
	(528595, 131, '2014-02-01 00:30:58.000000', 'consum', 0.0217, 'lps'),
	(528596, 131, '2014-02-01 00:30:59.000000', 'consum', 0.0227, 'lps'),
	(528597, 131, '2014-02-01 00:31:00.000000', 'consum', 0.0222, 'lps'),
	(528598, 131, '2014-02-01 00:31:01.000000', 'consum', 0.0217, 'lps'),
	(528599, 131, '2014-02-01 00:31:02.000000', 'consum', 0.0211, 'lps'),
	(528600, 131, '2014-02-01 00:31:03.000000', 'consum', 0.0211, 'lps'),
	(528601, 131, '2014-02-01 00:31:04.000000', 'consum', 0.0215, 'lps'),
	(528602, 131, '2014-02-01 00:31:05.000000', 'consum', 0.0212, 'lps'),
	(528603, 131, '2014-02-01 00:31:06.000000', 'consum', 0.0222, 'lps'),
	(528604, 131, '2014-02-01 00:31:07.000000', 'consum', 0.0213, 'lps'),
	(528605, 131, '2014-02-01 00:31:08.000000', 'consum', 0.0227, 'lps'),
	(528606, 131, '2014-02-01 00:31:09.000000', 'consum', 0.0213, 'lps'),
	(528607, 131, '2014-02-01 00:31:10.000000', 'consum', 0.0211, 'lps'),
	(528608, 131, '2014-02-01 00:31:11.000000', 'consum', 0.0223, 'lps'),
	(528609, 131, '2014-02-01 00:31:12.000000', 'consum', 0.0219, 'lps'),
	(528610, 131, '2014-02-01 00:31:13.000000', 'consum', 0.0216, 'lps'),
	(528611, 131, '2014-02-01 00:31:14.000000', 'consum', 0.0212, 'lps'),
	(528612, 131, '2014-02-01 00:31:15.000000', 'consum', 0.0222, 'lps'),
	(528613, 131, '2014-02-01 00:31:16.000000', 'consum', 0.0212, 'lps'),
	(528614, 131, '2014-02-01 00:31:17.000000', 'consum', 0.0220, 'lps'),
	(528615, 131, '2014-02-01 00:31:18.000000', 'consum', 0.0216, 'lps'),
	(528616, 131, '2014-02-01 00:31:19.000000', 'consum', 0.0214, 'lps'),
	(528617, 131, '2014-02-01 00:31:20.000000', 'consum', 0.0227, 'lps'),
	(528618, 131, '2014-02-01 00:31:21.000000', 'consum', 0.0215, 'lps'),
	(528619, 131, '2014-02-01 00:31:22.000000', 'consum', 0.0218, 'lps'),
	(528620, 131, '2014-02-01 00:31:23.000000', 'consum', 0.0219, 'lps'),
	(528621, 131, '2014-02-01 00:31:24.000000', 'consum', 0.0213, 'lps'),
	(528622, 131, '2014-02-01 00:31:25.000000', 'consum', 0.0218, 'lps'),
	(528623, 131, '2014-02-01 00:31:26.000000', 'consum', 0.0225, 'lps'),
	(528624, 131, '2014-02-01 00:31:27.000000', 'consum', 0.0222, 'lps'),
	(528625, 131, '2014-02-01 00:31:28.000000', 'consum', 0.0225, 'lps'),
	(528626, 131, '2014-02-01 00:31:29.000000', 'consum', 0.0214, 'lps'),
	(528627, 131, '2014-02-01 00:31:30.000000', 'consum', 0.0222, 'lps'),
	(528628, 131, '2014-02-01 00:31:31.000000', 'consum', 0.0223, 'lps'),
	(528629, 131, '2014-02-01 00:31:32.000000', 'consum', 0.0221, 'lps'),
	(528630, 131, '2014-02-01 00:31:33.000000', 'consum', 0.0227, 'lps'),
	(528631, 131, '2014-02-01 00:31:34.000000', 'consum', 0.0225, 'lps'),
	(528632, 131, '2014-02-01 00:31:35.000000', 'consum', 0.0219, 'lps'),
	(528633, 131, '2014-02-01 00:31:36.000000', 'consum', 0.0225, 'lps'),
	(528634, 131, '2014-02-01 00:31:37.000000', 'consum', 0.0225, 'lps'),
	(528635, 131, '2014-02-01 00:31:38.000000', 'consum', 0.0224, 'lps'),
	(528636, 131, '2014-02-01 00:31:39.000000', 'consum', 0.0216, 'lps'),
	(528637, 131, '2014-02-01 00:31:40.000000', 'consum', 0.0216, 'lps'),
	(528638, 131, '2014-02-01 00:31:41.000000', 'consum', 0.0221, 'lps'),
	(528639, 131, '2014-02-01 00:31:42.000000', 'consum', 0.0214, 'lps'),
	(528640, 131, '2014-02-01 00:31:43.000000', 'consum', 0.0215, 'lps'),
	(528641, 131, '2014-02-01 00:31:44.000000', 'consum', 0.0223, 'lps'),
	(528642, 131, '2014-02-01 00:31:45.000000', 'consum', 0.0224, 'lps'),
	(528643, 131, '2014-02-01 00:31:46.000000', 'consum', 0.0225, 'lps'),
	(528644, 131, '2014-02-01 00:31:47.000000', 'consum', 0.0223, 'lps'),
	(528645, 131, '2014-02-01 00:31:48.000000', 'consum', 0.0213, 'lps'),
	(528646, 131, '2014-02-01 00:31:49.000000', 'consum', 0.0222, 'lps'),
	(528647, 131, '2014-02-01 00:31:50.000000', 'consum', 0.0210, 'lps'),
	(528648, 131, '2014-02-01 00:31:51.000000', 'consum', 0.0226, 'lps'),
	(528649, 131, '2014-02-01 00:31:52.000000', 'consum', 0.0221, 'lps'),
	(528650, 131, '2014-02-01 00:31:53.000000', 'consum', 0.0218, 'lps'),
	(528651, 131, '2014-02-01 00:31:54.000000', 'consum', 0.0216, 'lps'),
	(528652, 131, '2014-02-01 00:31:55.000000', 'consum', 0.0216, 'lps'),
	(528653, 131, '2014-02-01 00:31:56.000000', 'consum', 0.0224, 'lps'),
	(528654, 131, '2014-02-01 00:31:57.000000', 'consum', 0.0225, 'lps'),
	(528655, 131, '2014-02-01 00:31:58.000000', 'consum', 0.0224, 'lps'),
	(528656, 131, '2014-02-01 00:31:59.000000', 'consum', 0.0221, 'lps'),
	(528657, 131, '2014-02-01 00:32:00.000000', 'consum', 0.0220, 'lps'),
	(528658, 131, '2014-02-01 00:32:01.000000', 'consum', 0.0212, 'lps'),
	(528659, 131, '2014-02-01 00:32:02.000000', 'consum', 0.0227, 'lps'),
	(528660, 131, '2014-02-01 00:32:03.000000', 'consum', 0.0216, 'lps'),
	(528661, 131, '2014-02-01 00:32:04.000000', 'consum', 0.0227, 'lps'),
	(528662, 131, '2014-02-01 00:32:05.000000', 'consum', 0.0222, 'lps'),
	(528663, 131, '2014-02-01 00:32:06.000000', 'consum', 0.0222, 'lps'),
	(528664, 131, '2014-02-01 00:32:07.000000', 'consum', 0.0215, 'lps'),
	(528665, 131, '2014-02-01 00:32:08.000000', 'consum', 0.0218, 'lps'),
	(528666, 131, '2014-02-01 00:32:09.000000', 'consum', 0.0217, 'lps'),
	(528667, 131, '2014-02-01 00:32:10.000000', 'consum', 0.0221, 'lps'),
	(528668, 131, '2014-02-01 00:32:11.000000', 'consum', 0.0211, 'lps'),
	(528669, 131, '2014-02-01 00:32:12.000000', 'consum', 0.0215, 'lps'),
	(528670, 131, '2014-02-01 00:32:13.000000', 'consum', 0.0216, 'lps'),
	(528671, 131, '2014-02-01 00:32:14.000000', 'consum', 0.0226, 'lps'),
	(528672, 131, '2014-02-01 00:32:15.000000', 'consum', 0.0218, 'lps'),
	(528673, 131, '2014-02-01 00:32:16.000000', 'consum', 0.0221, 'lps'),
	(528674, 131, '2014-02-01 00:32:17.000000', 'consum', 0.0223, 'lps'),
	(528675, 131, '2014-02-01 00:32:18.000000', 'consum', 0.0226, 'lps'),
	(528676, 131, '2014-02-01 00:32:19.000000', 'consum', 0.0214, 'lps'),
	(528677, 131, '2014-02-01 00:32:20.000000', 'consum', 0.0218, 'lps'),
	(528678, 131, '2014-02-01 00:32:21.000000', 'consum', 0.0223, 'lps'),
	(528679, 131, '2014-02-01 00:32:22.000000', 'consum', 0.0215, 'lps'),
	(528680, 131, '2014-02-01 00:32:23.000000', 'consum', 0.0215, 'lps'),
	(528681, 131, '2014-02-01 00:32:24.000000', 'consum', 0.0221, 'lps'),
	(528682, 131, '2014-02-01 00:32:25.000000', 'consum', 0.0214, 'lps'),
	(528683, 131, '2014-02-01 00:32:26.000000', 'consum', 0.0213, 'lps'),
	(528684, 131, '2014-02-01 00:32:27.000000', 'consum', 0.0217, 'lps'),
	(528685, 131, '2014-02-01 00:32:28.000000', 'consum', 0.0217, 'lps'),
	(528686, 131, '2014-02-01 00:32:29.000000', 'consum', 0.0224, 'lps'),
	(528687, 131, '2014-02-01 00:32:30.000000', 'consum', 0.0225, 'lps'),
	(528688, 131, '2014-02-01 00:32:31.000000', 'consum', 0.0223, 'lps'),
	(528689, 131, '2014-02-01 00:32:32.000000', 'consum', 0.0215, 'lps'),
	(528690, 131, '2014-02-01 00:32:33.000000', 'consum', 0.0213, 'lps'),
	(528691, 131, '2014-02-01 00:32:34.000000', 'consum', 0.0211, 'lps'),
	(528692, 131, '2014-02-01 00:32:35.000000', 'consum', 0.0225, 'lps'),
	(528693, 131, '2014-02-01 00:32:36.000000', 'consum', 0.0211, 'lps'),
	(528694, 131, '2014-02-01 00:32:37.000000', 'consum', 0.0223, 'lps'),
	(528695, 131, '2014-02-01 00:32:38.000000', 'consum', 0.0221, 'lps'),
	(528696, 131, '2014-02-01 00:32:39.000000', 'consum', 0.0223, 'lps'),
	(528697, 131, '2014-02-01 00:32:40.000000', 'consum', 0.0227, 'lps'),
	(528698, 131, '2014-02-01 00:32:41.000000', 'consum', 0.0222, 'lps'),
	(528699, 131, '2014-02-01 00:32:42.000000', 'consum', 0.0217, 'lps'),
	(528700, 131, '2014-02-01 00:32:43.000000', 'consum', 0.0210, 'lps'),
	(528701, 131, '2014-02-01 00:32:44.000000', 'consum', 0.0224, 'lps'),
	(528702, 131, '2014-02-01 00:32:45.000000', 'consum', 0.0211, 'lps'),
	(528703, 131, '2014-02-01 00:32:46.000000', 'consum', 0.0226, 'lps'),
	(528704, 131, '2014-02-01 00:32:47.000000', 'consum', 0.0215, 'lps'),
	(528705, 131, '2014-02-01 00:32:48.000000', 'consum', 0.0225, 'lps'),
	(528706, 131, '2014-02-01 00:32:49.000000', 'consum', 0.0214, 'lps'),
	(528707, 131, '2014-02-01 00:32:50.000000', 'consum', 0.0223, 'lps'),
	(528708, 131, '2014-02-01 00:32:51.000000', 'consum', 0.0227, 'lps'),
	(528709, 131, '2014-02-01 00:32:52.000000', 'consum', 0.0220, 'lps'),
	(528710, 131, '2014-02-01 00:32:53.000000', 'consum', 0.0212, 'lps'),
	(528711, 131, '2014-02-01 00:32:54.000000', 'consum', 0.0225, 'lps'),
	(528712, 131, '2014-02-01 00:32:55.000000', 'consum', 0.0225, 'lps'),
	(528713, 131, '2014-02-01 00:32:56.000000', 'consum', 0.0222, 'lps'),
	(528714, 131, '2014-02-01 00:32:57.000000', 'consum', 0.0224, 'lps'),
	(528715, 131, '2014-02-01 00:32:58.000000', 'consum', 0.0210, 'lps'),
	(528716, 131, '2014-02-01 00:32:59.000000', 'consum', 0.0223, 'lps'),
	(528717, 131, '2014-02-01 00:33:00.000000', 'consum', 0.0223, 'lps'),
	(528718, 131, '2014-02-01 00:33:01.000000', 'consum', 0.0217, 'lps'),
	(528719, 131, '2014-02-01 00:33:02.000000', 'consum', 0.0225, 'lps'),
	(528720, 131, '2014-02-01 00:33:03.000000', 'consum', 0.0211, 'lps'),
	(528721, 131, '2014-02-01 00:33:04.000000', 'consum', 0.0224, 'lps'),
	(528722, 131, '2014-02-01 00:33:05.000000', 'consum', 0.0222, 'lps'),
	(528723, 131, '2014-02-01 00:33:06.000000', 'consum', 0.0211, 'lps'),
	(528724, 131, '2014-02-01 00:33:07.000000', 'consum', 0.0217, 'lps'),
	(528725, 131, '2014-02-01 00:33:08.000000', 'consum', 0.0225, 'lps'),
	(528726, 131, '2014-02-01 00:33:09.000000', 'consum', 0.0227, 'lps'),
	(528727, 131, '2014-02-01 00:33:10.000000', 'consum', 0.0217, 'lps'),
	(528728, 131, '2014-02-01 00:33:11.000000', 'consum', 0.0210, 'lps'),
	(528729, 131, '2014-02-01 00:33:12.000000', 'consum', 0.0227, 'lps'),
	(528730, 131, '2014-02-01 00:33:13.000000', 'consum', 0.0223, 'lps'),
	(528731, 131, '2014-02-01 00:33:14.000000', 'consum', 0.0226, 'lps'),
	(528732, 131, '2014-02-01 00:33:15.000000', 'consum', 0.0216, 'lps'),
	(528733, 131, '2014-02-01 00:33:16.000000', 'consum', 0.0210, 'lps'),
	(528734, 131, '2014-02-01 00:33:17.000000', 'consum', 0.0211, 'lps'),
	(528735, 131, '2014-02-01 00:33:18.000000', 'consum', 0.0216, 'lps'),
	(528736, 131, '2014-02-01 00:33:19.000000', 'consum', 0.0219, 'lps'),
	(528737, 131, '2014-02-01 00:33:20.000000', 'consum', 0.0221, 'lps'),
	(528738, 131, '2014-02-01 00:33:21.000000', 'consum', 0.0219, 'lps'),
	(528739, 131, '2014-02-01 00:33:22.000000', 'consum', 0.0224, 'lps'),
	(528740, 131, '2014-02-01 00:33:23.000000', 'consum', 0.0215, 'lps'),
	(528741, 131, '2014-02-01 00:33:24.000000', 'consum', 0.0213, 'lps'),
	(528742, 131, '2014-02-01 00:33:25.000000', 'consum', 0.0212, 'lps'),
	(528743, 131, '2014-02-01 00:33:26.000000', 'consum', 0.0210, 'lps'),
	(528744, 131, '2014-02-01 00:33:27.000000', 'consum', 0.0221, 'lps'),
	(528745, 131, '2014-02-01 00:33:28.000000', 'consum', 0.0215, 'lps'),
	(528746, 131, '2014-02-01 00:33:29.000000', 'consum', 0.0218, 'lps'),
	(528747, 131, '2014-02-01 00:33:30.000000', 'consum', 0.0217, 'lps'),
	(528748, 131, '2014-02-01 00:33:31.000000', 'consum', 0.0224, 'lps'),
	(528749, 131, '2014-02-01 00:33:32.000000', 'consum', 0.0221, 'lps'),
	(528750, 131, '2014-02-01 00:33:33.000000', 'consum', 0.0224, 'lps'),
	(528751, 131, '2014-02-01 00:33:34.000000', 'consum', 0.0212, 'lps'),
	(528752, 131, '2014-02-01 00:33:35.000000', 'consum', 0.0215, 'lps'),
	(528753, 131, '2014-02-01 00:33:36.000000', 'consum', 0.0211, 'lps'),
	(528754, 131, '2014-02-01 00:33:37.000000', 'consum', 0.0218, 'lps'),
	(528755, 131, '2014-02-01 00:33:38.000000', 'consum', 0.0214, 'lps'),
	(528756, 131, '2014-02-01 00:33:39.000000', 'consum', 0.0221, 'lps'),
	(528757, 131, '2014-02-01 00:33:40.000000', 'consum', 0.0219, 'lps'),
	(528758, 131, '2014-02-01 00:33:41.000000', 'consum', 0.0222, 'lps'),
	(528759, 131, '2014-02-01 00:33:42.000000', 'consum', 0.0226, 'lps'),
	(528760, 131, '2014-02-01 00:33:43.000000', 'consum', 0.0217, 'lps'),
	(528761, 131, '2014-02-01 00:33:44.000000', 'consum', 0.0216, 'lps'),
	(528762, 131, '2014-02-01 00:33:45.000000', 'consum', 0.0221, 'lps'),
	(528763, 131, '2014-02-01 00:33:46.000000', 'consum', 0.0227, 'lps'),
	(528764, 131, '2014-02-01 00:33:47.000000', 'consum', 0.0210, 'lps'),
	(528765, 131, '2014-02-01 00:33:48.000000', 'consum', 0.0212, 'lps'),
	(528766, 131, '2014-02-01 00:33:49.000000', 'consum', 0.0222, 'lps'),
	(528767, 131, '2014-02-01 00:33:50.000000', 'consum', 0.0227, 'lps'),
	(528768, 131, '2014-02-01 00:33:51.000000', 'consum', 0.0225, 'lps'),
	(528769, 131, '2014-02-01 00:33:52.000000', 'consum', 0.0217, 'lps'),
	(528770, 131, '2014-02-01 00:33:53.000000', 'consum', 0.0218, 'lps'),
	(528771, 131, '2014-02-01 00:33:54.000000', 'consum', 0.0210, 'lps'),
	(528772, 131, '2014-02-01 00:33:55.000000', 'consum', 0.0222, 'lps'),
	(528773, 131, '2014-02-01 00:33:56.000000', 'consum', 0.0218, 'lps'),
	(528774, 131, '2014-02-01 00:33:57.000000', 'consum', 0.0213, 'lps'),
	(528775, 131, '2014-02-01 00:33:58.000000', 'consum', 0.0222, 'lps'),
	(528776, 131, '2014-02-01 00:33:59.000000', 'consum', 0.0225, 'lps'),
	(528777, 131, '2014-02-01 00:34:00.000000', 'consum', 0.0214, 'lps'),
	(528778, 131, '2014-02-01 00:34:01.000000', 'consum', 0.0222, 'lps'),
	(528779, 131, '2014-02-01 00:34:02.000000', 'consum', 0.0221, 'lps'),
	(528780, 131, '2014-02-01 00:34:03.000000', 'consum', 0.0210, 'lps'),
	(528781, 131, '2014-02-01 00:34:04.000000', 'consum', 0.0214, 'lps'),
	(528782, 131, '2014-02-01 00:34:05.000000', 'consum', 0.0214, 'lps'),
	(528783, 131, '2014-02-01 00:34:06.000000', 'consum', 0.0218, 'lps'),
	(528784, 131, '2014-02-01 00:34:07.000000', 'consum', 0.0222, 'lps'),
	(528785, 131, '2014-02-01 00:34:08.000000', 'consum', 0.0227, 'lps'),
	(528786, 131, '2014-02-01 00:34:09.000000', 'consum', 0.0222, 'lps'),
	(528787, 131, '2014-02-01 00:34:10.000000', 'consum', 0.0220, 'lps'),
	(528788, 131, '2014-02-01 00:34:11.000000', 'consum', 0.0224, 'lps'),
	(528789, 131, '2014-02-01 00:34:12.000000', 'consum', 0.0214, 'lps'),
	(528790, 131, '2014-02-01 00:34:13.000000', 'consum', 0.0227, 'lps'),
	(528791, 131, '2014-02-01 00:34:14.000000', 'consum', 0.0211, 'lps'),
	(528792, 131, '2014-02-01 00:34:15.000000', 'consum', 0.0220, 'lps'),
	(528793, 131, '2014-02-01 00:34:16.000000', 'consum', 0.0219, 'lps'),
	(528794, 131, '2014-02-01 00:34:17.000000', 'consum', 0.0225, 'lps'),
	(528795, 131, '2014-02-01 00:34:18.000000', 'consum', 0.0222, 'lps'),
	(528796, 131, '2014-02-01 00:34:19.000000', 'consum', 0.0210, 'lps'),
	(528797, 131, '2014-02-01 00:34:20.000000', 'consum', 0.0211, 'lps'),
	(528798, 131, '2014-02-01 00:34:21.000000', 'consum', 0.0214, 'lps'),
	(528799, 131, '2014-02-01 00:34:22.000000', 'consum', 0.0211, 'lps'),
	(528800, 131, '2014-02-01 00:34:23.000000', 'consum', 0.0222, 'lps'),
	(528801, 131, '2014-02-01 00:34:24.000000', 'consum', 0.0214, 'lps'),
	(528802, 131, '2014-02-01 00:34:25.000000', 'consum', 0.0210, 'lps'),
	(528803, 131, '2014-02-01 00:34:26.000000', 'consum', 0.0217, 'lps'),
	(528804, 131, '2014-02-01 00:34:27.000000', 'consum', 0.0227, 'lps'),
	(528805, 131, '2014-02-01 00:34:28.000000', 'consum', 0.0221, 'lps'),
	(528806, 131, '2014-02-01 00:34:29.000000', 'consum', 0.0216, 'lps'),
	(528807, 131, '2014-02-01 00:34:30.000000', 'consum', 0.0226, 'lps'),
	(528808, 131, '2014-02-01 00:34:31.000000', 'consum', 0.0218, 'lps'),
	(528809, 131, '2014-02-01 00:34:32.000000', 'consum', 0.0222, 'lps'),
	(528810, 131, '2014-02-01 00:34:33.000000', 'consum', 0.0226, 'lps'),
	(528811, 131, '2014-02-01 00:34:34.000000', 'consum', 0.0219, 'lps'),
	(528812, 131, '2014-02-01 00:34:35.000000', 'consum', 0.0224, 'lps'),
	(528813, 131, '2014-02-01 00:34:36.000000', 'consum', 0.0220, 'lps'),
	(528814, 131, '2014-02-01 00:34:37.000000', 'consum', 0.0218, 'lps'),
	(528815, 131, '2014-02-01 00:34:38.000000', 'consum', 0.0219, 'lps'),
	(528816, 131, '2014-02-01 00:34:39.000000', 'consum', 0.0212, 'lps'),
	(528817, 131, '2014-02-01 00:34:40.000000', 'consum', 0.0214, 'lps'),
	(528818, 131, '2014-02-01 00:34:41.000000', 'consum', 0.0224, 'lps'),
	(528819, 131, '2014-02-01 00:34:42.000000', 'consum', 0.0215, 'lps'),
	(528820, 131, '2014-02-01 00:34:43.000000', 'consum', 0.0227, 'lps'),
	(528821, 131, '2014-02-01 00:34:44.000000', 'consum', 0.0211, 'lps'),
	(528822, 131, '2014-02-01 00:34:45.000000', 'consum', 0.0218, 'lps'),
	(528823, 131, '2014-02-01 00:34:46.000000', 'consum', 0.0210, 'lps'),
	(528824, 131, '2014-02-01 00:34:47.000000', 'consum', 0.0224, 'lps'),
	(528825, 131, '2014-02-01 00:34:48.000000', 'consum', 0.0227, 'lps'),
	(528826, 131, '2014-02-01 00:34:49.000000', 'consum', 0.0218, 'lps'),
	(528827, 131, '2014-02-01 00:34:50.000000', 'consum', 0.0216, 'lps'),
	(528828, 131, '2014-02-01 00:34:51.000000', 'consum', 0.0215, 'lps'),
	(528829, 131, '2014-02-01 00:34:52.000000', 'consum', 0.0221, 'lps'),
	(528830, 131, '2014-02-01 00:34:53.000000', 'consum', 0.0213, 'lps'),
	(528831, 131, '2014-02-01 00:34:54.000000', 'consum', 0.0210, 'lps'),
	(528832, 131, '2014-02-01 00:34:55.000000', 'consum', 0.0221, 'lps'),
	(528833, 131, '2014-02-01 00:34:56.000000', 'consum', 0.0227, 'lps'),
	(528834, 131, '2014-02-01 00:34:57.000000', 'consum', 0.0210, 'lps'),
	(528835, 131, '2014-02-01 00:34:58.000000', 'consum', 0.0213, 'lps'),
	(528836, 131, '2014-02-01 00:34:59.000000', 'consum', 0.0224, 'lps'),
	(528837, 131, '2014-02-01 00:35:00.000000', 'consum', 0.0220, 'lps'),
	(528838, 131, '2014-02-01 00:35:01.000000', 'consum', 0.0218, 'lps'),
	(528839, 131, '2014-02-01 00:35:02.000000', 'consum', 0.0222, 'lps'),
	(528840, 131, '2014-02-01 00:35:03.000000', 'consum', 0.0210, 'lps'),
	(528841, 131, '2014-02-01 00:35:04.000000', 'consum', 0.0211, 'lps'),
	(528842, 131, '2014-02-01 00:35:05.000000', 'consum', 0.0215, 'lps'),
	(528843, 131, '2014-02-01 00:35:06.000000', 'consum', 0.0213, 'lps'),
	(528844, 131, '2014-02-01 00:35:07.000000', 'consum', 0.0210, 'lps'),
	(528845, 131, '2014-02-01 00:35:08.000000', 'consum', 0.0223, 'lps'),
	(528846, 131, '2014-02-01 00:35:09.000000', 'consum', 0.0218, 'lps'),
	(528847, 131, '2014-02-01 00:35:10.000000', 'consum', 0.0212, 'lps'),
	(528848, 131, '2014-02-01 00:35:11.000000', 'consum', 0.0215, 'lps'),
	(528849, 131, '2014-02-01 00:35:12.000000', 'consum', 0.0213, 'lps'),
	(528850, 131, '2014-02-01 00:35:13.000000', 'consum', 0.0227, 'lps'),
	(528851, 131, '2014-02-01 00:35:14.000000', 'consum', 0.0216, 'lps'),
	(528852, 131, '2014-02-01 00:35:15.000000', 'consum', 0.0223, 'lps'),
	(528853, 131, '2014-02-01 00:35:16.000000', 'consum', 0.0221, 'lps'),
	(528854, 131, '2014-02-01 00:35:17.000000', 'consum', 0.0226, 'lps'),
	(528855, 131, '2014-02-01 00:35:18.000000', 'consum', 0.0223, 'lps'),
	(528856, 131, '2014-02-01 00:35:19.000000', 'consum', 0.0227, 'lps'),
	(528857, 131, '2014-02-01 00:35:20.000000', 'consum', 0.0223, 'lps'),
	(528858, 131, '2014-02-01 00:35:21.000000', 'consum', 0.0221, 'lps'),
	(528859, 131, '2014-02-01 00:35:22.000000', 'consum', 0.0210, 'lps'),
	(528860, 131, '2014-02-01 00:35:23.000000', 'consum', 0.0215, 'lps'),
	(528861, 131, '2014-02-01 00:35:24.000000', 'consum', 0.0217, 'lps'),
	(528862, 131, '2014-02-01 00:35:25.000000', 'consum', 0.0214, 'lps'),
	(528863, 131, '2014-02-01 00:35:26.000000', 'consum', 0.0224, 'lps'),
	(528864, 131, '2014-02-01 00:35:27.000000', 'consum', 0.0216, 'lps'),
	(528865, 131, '2014-02-01 00:35:28.000000', 'consum', 0.0217, 'lps'),
	(528866, 131, '2014-02-01 00:35:29.000000', 'consum', 0.0226, 'lps'),
	(528867, 131, '2014-02-01 00:35:30.000000', 'consum', 0.0217, 'lps'),
	(528868, 131, '2014-02-01 00:35:31.000000', 'consum', 0.0214, 'lps'),
	(528869, 131, '2014-02-01 00:35:32.000000', 'consum', 0.0210, 'lps'),
	(528870, 131, '2014-02-01 00:35:33.000000', 'consum', 0.0215, 'lps'),
	(528871, 131, '2014-02-01 00:35:34.000000', 'consum', 0.0220, 'lps'),
	(528872, 131, '2014-02-01 00:35:35.000000', 'consum', 0.0210, 'lps'),
	(528873, 131, '2014-02-01 00:35:36.000000', 'consum', 0.0217, 'lps'),
	(528874, 131, '2014-02-01 00:35:37.000000', 'consum', 0.0225, 'lps'),
	(528875, 131, '2014-02-01 00:35:38.000000', 'consum', 0.0212, 'lps'),
	(528876, 131, '2014-02-01 00:35:39.000000', 'consum', 0.0210, 'lps'),
	(528877, 131, '2014-02-01 00:35:40.000000', 'consum', 0.0222, 'lps'),
	(528878, 131, '2014-02-01 00:35:41.000000', 'consum', 0.0217, 'lps'),
	(528879, 131, '2014-02-01 00:35:42.000000', 'consum', 0.0211, 'lps'),
	(528880, 131, '2014-02-01 00:35:43.000000', 'consum', 0.0210, 'lps'),
	(528881, 131, '2014-02-01 00:35:44.000000', 'consum', 0.0226, 'lps'),
	(528882, 131, '2014-02-01 00:35:45.000000', 'consum', 0.0220, 'lps'),
	(528883, 131, '2014-02-01 00:35:46.000000', 'consum', 0.0212, 'lps'),
	(528884, 131, '2014-02-01 00:35:47.000000', 'consum', 0.0225, 'lps'),
	(528885, 131, '2014-02-01 00:35:48.000000', 'consum', 0.0227, 'lps'),
	(528886, 131, '2014-02-01 00:35:49.000000', 'consum', 0.0216, 'lps'),
	(528887, 131, '2014-02-01 00:35:50.000000', 'consum', 0.0224, 'lps'),
	(528888, 131, '2014-02-01 00:35:51.000000', 'consum', 0.0210, 'lps'),
	(528889, 131, '2014-02-01 00:35:52.000000', 'consum', 0.0222, 'lps'),
	(528890, 131, '2014-02-01 00:35:53.000000', 'consum', 0.0218, 'lps'),
	(528891, 131, '2014-02-01 00:35:54.000000', 'consum', 0.0213, 'lps'),
	(528892, 131, '2014-02-01 00:35:55.000000', 'consum', 0.0222, 'lps'),
	(528893, 131, '2014-02-01 00:35:56.000000', 'consum', 0.0222, 'lps'),
	(528894, 131, '2014-02-01 00:35:57.000000', 'consum', 0.0218, 'lps'),
	(528895, 131, '2014-02-01 00:35:58.000000', 'consum', 0.0214, 'lps'),
	(528896, 131, '2014-02-01 00:35:59.000000', 'consum', 0.0225, 'lps'),
	(528897, 131, '2014-02-01 00:36:00.000000', 'consum', 0.0219, 'lps'),
	(528898, 131, '2014-02-01 00:36:01.000000', 'consum', 0.0212, 'lps'),
	(528899, 131, '2014-02-01 00:36:02.000000', 'consum', 0.0211, 'lps'),
	(528900, 131, '2014-02-01 00:36:03.000000', 'consum', 0.0227, 'lps'),
	(528901, 131, '2014-02-01 00:36:04.000000', 'consum', 0.0222, 'lps'),
	(528902, 131, '2014-02-01 00:36:05.000000', 'consum', 0.0217, 'lps'),
	(528903, 131, '2014-02-01 00:36:06.000000', 'consum', 0.0211, 'lps'),
	(528904, 131, '2014-02-01 00:36:07.000000', 'consum', 0.0210, 'lps'),
	(528905, 131, '2014-02-01 00:36:08.000000', 'consum', 0.0210, 'lps'),
	(528906, 131, '2014-02-01 00:36:09.000000', 'consum', 0.0211, 'lps'),
	(528907, 131, '2014-02-01 00:36:10.000000', 'consum', 0.0213, 'lps'),
	(528908, 131, '2014-02-01 00:36:11.000000', 'consum', 0.0222, 'lps'),
	(528909, 131, '2014-02-01 00:36:12.000000', 'consum', 0.0226, 'lps'),
	(528910, 131, '2014-02-01 00:36:13.000000', 'consum', 0.0220, 'lps'),
	(528911, 131, '2014-02-01 00:36:14.000000', 'consum', 0.0210, 'lps'),
	(528912, 131, '2014-02-01 00:36:15.000000', 'consum', 0.0217, 'lps'),
	(528913, 131, '2014-02-01 00:36:16.000000', 'consum', 0.0212, 'lps'),
	(528914, 131, '2014-02-01 00:36:17.000000', 'consum', 0.0216, 'lps'),
	(528915, 131, '2014-02-01 00:36:18.000000', 'consum', 0.0215, 'lps'),
	(528916, 131, '2014-02-01 00:36:19.000000', 'consum', 0.0219, 'lps'),
	(528917, 131, '2014-02-01 00:36:20.000000', 'consum', 0.0222, 'lps'),
	(528918, 131, '2014-02-01 00:36:21.000000', 'consum', 0.0226, 'lps'),
	(528919, 131, '2014-02-01 00:36:22.000000', 'consum', 0.0220, 'lps'),
	(528920, 131, '2014-02-01 00:36:23.000000', 'consum', 0.0211, 'lps'),
	(528921, 131, '2014-02-01 00:36:24.000000', 'consum', 0.0223, 'lps'),
	(528922, 131, '2014-02-01 00:36:25.000000', 'consum', 0.0217, 'lps'),
	(528923, 131, '2014-02-01 00:36:26.000000', 'consum', 0.0224, 'lps'),
	(528924, 131, '2014-02-01 00:36:27.000000', 'consum', 0.0226, 'lps'),
	(528925, 131, '2014-02-01 00:36:28.000000', 'consum', 0.0227, 'lps'),
	(528926, 131, '2014-02-01 00:36:29.000000', 'consum', 0.0213, 'lps'),
	(528927, 131, '2014-02-01 00:36:30.000000', 'consum', 0.0212, 'lps'),
	(528928, 131, '2014-02-01 00:36:31.000000', 'consum', 0.0210, 'lps'),
	(528929, 131, '2014-02-01 00:36:32.000000', 'consum', 0.0221, 'lps'),
	(528930, 131, '2014-02-01 00:36:33.000000', 'consum', 0.0212, 'lps'),
	(528931, 131, '2014-02-01 00:36:34.000000', 'consum', 0.0224, 'lps'),
	(528932, 131, '2014-02-01 00:36:35.000000', 'consum', 0.0221, 'lps'),
	(528933, 131, '2014-02-01 00:36:36.000000', 'consum', 0.0224, 'lps'),
	(528934, 131, '2014-02-01 00:36:37.000000', 'consum', 0.0211, 'lps'),
	(528935, 131, '2014-02-01 00:36:38.000000', 'consum', 0.0211, 'lps'),
	(528936, 131, '2014-02-01 00:36:39.000000', 'consum', 0.0211, 'lps'),
	(528937, 131, '2014-02-01 00:36:40.000000', 'consum', 0.0212, 'lps'),
	(528938, 131, '2014-02-01 00:36:41.000000', 'consum', 0.0216, 'lps'),
	(528939, 131, '2014-02-01 00:36:42.000000', 'consum', 0.0219, 'lps'),
	(528940, 131, '2014-02-01 00:36:43.000000', 'consum', 0.0219, 'lps'),
	(528941, 131, '2014-02-01 00:36:44.000000', 'consum', 0.0227, 'lps'),
	(528942, 131, '2014-02-01 00:36:45.000000', 'consum', 0.0217, 'lps'),
	(528943, 131, '2014-02-01 00:36:46.000000', 'consum', 0.0213, 'lps'),
	(528944, 131, '2014-02-01 00:36:47.000000', 'consum', 0.0223, 'lps'),
	(528945, 131, '2014-02-01 00:36:48.000000', 'consum', 0.0212, 'lps'),
	(528946, 131, '2014-02-01 00:36:49.000000', 'consum', 0.0216, 'lps'),
	(528947, 131, '2014-02-01 00:36:50.000000', 'consum', 0.0216, 'lps'),
	(528948, 131, '2014-02-01 00:36:51.000000', 'consum', 0.0225, 'lps'),
	(528949, 131, '2014-02-01 00:36:52.000000', 'consum', 0.0212, 'lps'),
	(528950, 131, '2014-02-01 00:36:53.000000', 'consum', 0.0213, 'lps'),
	(528951, 131, '2014-02-01 00:36:54.000000', 'consum', 0.0217, 'lps'),
	(528952, 131, '2014-02-01 00:36:55.000000', 'consum', 0.0218, 'lps'),
	(528953, 131, '2014-02-01 00:36:56.000000', 'consum', 0.0210, 'lps'),
	(528954, 131, '2014-02-01 00:36:57.000000', 'consum', 0.0226, 'lps'),
	(528955, 131, '2014-02-01 00:36:58.000000', 'consum', 0.0219, 'lps'),
	(528956, 131, '2014-02-01 00:36:59.000000', 'consum', 0.0226, 'lps'),
	(528957, 131, '2014-02-01 00:37:00.000000', 'consum', 0.0224, 'lps'),
	(528958, 131, '2014-02-01 00:37:01.000000', 'consum', 0.0217, 'lps'),
	(528959, 131, '2014-02-01 00:37:02.000000', 'consum', 0.0222, 'lps'),
	(528960, 131, '2014-02-01 00:37:03.000000', 'consum', 0.0211, 'lps'),
	(528961, 131, '2014-02-01 00:37:04.000000', 'consum', 0.0218, 'lps'),
	(528962, 131, '2014-02-01 00:37:05.000000', 'consum', 0.0227, 'lps'),
	(528963, 131, '2014-02-01 00:37:06.000000', 'consum', 0.0219, 'lps'),
	(528964, 131, '2014-02-01 00:37:07.000000', 'consum', 0.0220, 'lps'),
	(528965, 131, '2014-02-01 00:37:08.000000', 'consum', 0.0219, 'lps'),
	(528966, 131, '2014-02-01 00:37:09.000000', 'consum', 0.0223, 'lps'),
	(528967, 131, '2014-02-01 00:37:10.000000', 'consum', 0.0212, 'lps'),
	(528968, 131, '2014-02-01 00:37:11.000000', 'consum', 0.0220, 'lps'),
	(528969, 131, '2014-02-01 00:37:12.000000', 'consum', 0.0216, 'lps'),
	(528970, 131, '2014-02-01 00:37:13.000000', 'consum', 0.0212, 'lps'),
	(528971, 131, '2014-02-01 00:37:14.000000', 'consum', 0.0219, 'lps'),
	(528972, 131, '2014-02-01 00:37:15.000000', 'consum', 0.0215, 'lps'),
	(528973, 131, '2014-02-01 00:37:16.000000', 'consum', 0.0210, 'lps'),
	(528974, 131, '2014-02-01 00:37:17.000000', 'consum', 0.0212, 'lps'),
	(528975, 131, '2014-02-01 00:37:18.000000', 'consum', 0.0219, 'lps'),
	(528976, 131, '2014-02-01 00:37:19.000000', 'consum', 0.0216, 'lps'),
	(528977, 131, '2014-02-01 00:37:20.000000', 'consum', 0.0211, 'lps'),
	(528978, 131, '2014-02-01 00:37:21.000000', 'consum', 0.0216, 'lps'),
	(528979, 131, '2014-02-01 00:37:22.000000', 'consum', 0.0220, 'lps'),
	(528980, 131, '2014-02-01 00:37:23.000000', 'consum', 0.0224, 'lps'),
	(528981, 131, '2014-02-01 00:37:24.000000', 'consum', 0.0214, 'lps'),
	(528982, 131, '2014-02-01 00:37:25.000000', 'consum', 0.0226, 'lps'),
	(528983, 131, '2014-02-01 00:37:26.000000', 'consum', 0.0223, 'lps'),
	(528984, 131, '2014-02-01 00:37:27.000000', 'consum', 0.0227, 'lps'),
	(528985, 131, '2014-02-01 00:37:28.000000', 'consum', 0.0221, 'lps'),
	(528986, 131, '2014-02-01 00:37:29.000000', 'consum', 0.0216, 'lps'),
	(528987, 131, '2014-02-01 00:37:30.000000', 'consum', 0.0225, 'lps'),
	(528988, 131, '2014-02-01 00:37:31.000000', 'consum', 0.0214, 'lps'),
	(528989, 131, '2014-02-01 00:37:32.000000', 'consum', 0.0220, 'lps'),
	(528990, 131, '2014-02-01 00:37:33.000000', 'consum', 0.0215, 'lps'),
	(528991, 131, '2014-02-01 00:37:34.000000', 'consum', 0.0220, 'lps'),
	(528992, 131, '2014-02-01 00:37:35.000000', 'consum', 0.0212, 'lps'),
	(528993, 131, '2014-02-01 00:37:36.000000', 'consum', 0.0225, 'lps'),
	(528994, 131, '2014-02-01 00:37:37.000000', 'consum', 0.0210, 'lps'),
	(528995, 131, '2014-02-01 00:37:38.000000', 'consum', 0.0217, 'lps'),
	(528996, 131, '2014-02-01 00:37:39.000000', 'consum', 0.0210, 'lps'),
	(528997, 131, '2014-02-01 00:37:40.000000', 'consum', 0.0226, 'lps'),
	(528998, 131, '2014-02-01 00:37:41.000000', 'consum', 0.0220, 'lps'),
	(528999, 131, '2014-02-01 00:37:42.000000', 'consum', 0.0227, 'lps'),
	(529000, 131, '2014-02-01 00:37:43.000000', 'consum', 0.0215, 'lps'),
	(529001, 131, '2014-02-01 00:37:44.000000', 'consum', 0.0220, 'lps'),
	(529002, 131, '2014-02-01 00:37:45.000000', 'consum', 0.0227, 'lps'),
	(529003, 131, '2014-02-01 00:37:46.000000', 'consum', 0.0213, 'lps'),
	(529004, 131, '2014-02-01 00:37:47.000000', 'consum', 0.0226, 'lps'),
	(529005, 131, '2014-02-01 00:37:48.000000', 'consum', 0.0210, 'lps'),
	(529006, 131, '2014-02-01 00:37:49.000000', 'consum', 0.0217, 'lps'),
	(529007, 131, '2014-02-01 00:37:50.000000', 'consum', 0.0210, 'lps'),
	(529008, 131, '2014-02-01 00:37:51.000000', 'consum', 0.0225, 'lps'),
	(529009, 131, '2014-02-01 00:37:52.000000', 'consum', 0.0215, 'lps'),
	(529010, 131, '2014-02-01 00:37:53.000000', 'consum', 0.0224, 'lps'),
	(529011, 131, '2014-02-01 00:37:54.000000', 'consum', 0.0212, 'lps'),
	(529012, 131, '2014-02-01 00:37:55.000000', 'consum', 0.0213, 'lps'),
	(529013, 131, '2014-02-01 00:37:56.000000', 'consum', 0.0222, 'lps'),
	(529014, 131, '2014-02-01 00:37:57.000000', 'consum', 0.0223, 'lps'),
	(529015, 131, '2014-02-01 00:37:58.000000', 'consum', 0.0221, 'lps'),
	(529016, 131, '2014-02-01 00:37:59.000000', 'consum', 0.0210, 'lps'),
	(529017, 131, '2014-02-01 00:38:00.000000', 'consum', 0.0213, 'lps'),
	(529018, 131, '2014-02-01 00:38:01.000000', 'consum', 0.0225, 'lps'),
	(529019, 131, '2014-02-01 00:38:02.000000', 'consum', 0.0221, 'lps'),
	(529020, 131, '2014-02-01 00:38:03.000000', 'consum', 0.0223, 'lps'),
	(529021, 131, '2014-02-01 00:38:04.000000', 'consum', 0.0223, 'lps'),
	(529022, 131, '2014-02-01 00:38:05.000000', 'consum', 0.0218, 'lps'),
	(529023, 131, '2014-02-01 00:38:06.000000', 'consum', 0.0213, 'lps'),
	(529024, 131, '2014-02-01 00:38:07.000000', 'consum', 0.0218, 'lps'),
	(529025, 131, '2014-02-01 00:38:08.000000', 'consum', 0.0226, 'lps'),
	(529026, 131, '2014-02-01 00:38:09.000000', 'consum', 0.0210, 'lps'),
	(529027, 131, '2014-02-01 00:38:10.000000', 'consum', 0.0219, 'lps'),
	(529028, 131, '2014-02-01 00:38:11.000000', 'consum', 0.0218, 'lps'),
	(529029, 131, '2014-02-01 00:38:12.000000', 'consum', 0.0223, 'lps'),
	(529030, 131, '2014-02-01 00:38:13.000000', 'consum', 0.0216, 'lps'),
	(529031, 131, '2014-02-01 00:38:14.000000', 'consum', 0.0219, 'lps'),
	(529032, 131, '2014-02-01 00:38:15.000000', 'consum', 0.0220, 'lps'),
	(529033, 131, '2014-02-01 00:38:16.000000', 'consum', 0.0214, 'lps'),
	(529034, 131, '2014-02-01 00:38:17.000000', 'consum', 0.0218, 'lps'),
	(529035, 131, '2014-02-01 00:38:18.000000', 'consum', 0.0223, 'lps'),
	(529036, 131, '2014-02-01 00:38:19.000000', 'consum', 0.0215, 'lps'),
	(529037, 131, '2014-02-01 00:38:20.000000', 'consum', 0.0213, 'lps'),
	(529038, 131, '2014-02-01 00:38:21.000000', 'consum', 0.0213, 'lps'),
	(529039, 131, '2014-02-01 00:38:22.000000', 'consum', 0.0216, 'lps'),
	(529040, 131, '2014-02-01 00:38:23.000000', 'consum', 0.0211, 'lps'),
	(529041, 131, '2014-02-01 00:38:24.000000', 'consum', 0.0219, 'lps'),
	(529042, 131, '2014-02-01 00:38:25.000000', 'consum', 0.0213, 'lps'),
	(529043, 131, '2014-02-01 00:38:26.000000', 'consum', 0.0217, 'lps'),
	(529044, 131, '2014-02-01 00:38:27.000000', 'consum', 0.0221, 'lps'),
	(529045, 131, '2014-02-01 00:38:28.000000', 'consum', 0.0226, 'lps'),
	(529046, 131, '2014-02-01 00:38:29.000000', 'consum', 0.0223, 'lps'),
	(529047, 131, '2014-02-01 00:38:30.000000', 'consum', 0.0225, 'lps'),
	(529048, 131, '2014-02-01 00:38:31.000000', 'consum', 0.0227, 'lps'),
	(529049, 131, '2014-02-01 00:38:32.000000', 'consum', 0.0218, 'lps'),
	(529050, 131, '2014-02-01 00:38:33.000000', 'consum', 0.0217, 'lps'),
	(529051, 131, '2014-02-01 00:38:34.000000', 'consum', 0.0220, 'lps'),
	(529052, 131, '2014-02-01 00:38:35.000000', 'consum', 0.0221, 'lps'),
	(529053, 131, '2014-02-01 00:38:36.000000', 'consum', 0.0220, 'lps'),
	(529054, 131, '2014-02-01 00:38:37.000000', 'consum', 0.0226, 'lps'),
	(529055, 131, '2014-02-01 00:38:38.000000', 'consum', 0.0224, 'lps'),
	(529056, 131, '2014-02-01 00:38:39.000000', 'consum', 0.0215, 'lps'),
	(529057, 131, '2014-02-01 00:38:40.000000', 'consum', 0.0211, 'lps'),
	(529058, 131, '2014-02-01 00:38:41.000000', 'consum', 0.0219, 'lps'),
	(529059, 131, '2014-02-01 00:38:42.000000', 'consum', 0.0216, 'lps'),
	(529060, 131, '2014-02-01 00:38:43.000000', 'consum', 0.0213, 'lps'),
	(529061, 131, '2014-02-01 00:38:44.000000', 'consum', 0.0227, 'lps'),
	(529062, 131, '2014-02-01 00:38:45.000000', 'consum', 0.0215, 'lps'),
	(529063, 131, '2014-02-01 00:38:46.000000', 'consum', 0.0218, 'lps'),
	(529064, 131, '2014-02-01 00:38:47.000000', 'consum', 0.0218, 'lps'),
	(529065, 131, '2014-02-01 00:38:48.000000', 'consum', 0.0210, 'lps'),
	(529066, 131, '2014-02-01 00:38:49.000000', 'consum', 0.0221, 'lps'),
	(529067, 131, '2014-02-01 00:38:50.000000', 'consum', 0.0211, 'lps'),
	(529068, 131, '2014-02-01 00:38:51.000000', 'consum', 0.0219, 'lps'),
	(529069, 131, '2014-02-01 00:38:52.000000', 'consum', 0.0216, 'lps'),
	(529070, 131, '2014-02-01 00:38:53.000000', 'consum', 0.0215, 'lps'),
	(529071, 131, '2014-02-01 00:38:54.000000', 'consum', 0.0219, 'lps'),
	(529072, 131, '2014-02-01 00:38:55.000000', 'consum', 0.0220, 'lps'),
	(529073, 131, '2014-02-01 00:38:56.000000', 'consum', 0.0218, 'lps'),
	(529074, 131, '2014-02-01 00:38:57.000000', 'consum', 0.0220, 'lps'),
	(529075, 131, '2014-02-01 00:38:58.000000', 'consum', 0.0216, 'lps'),
	(529076, 131, '2014-02-01 00:38:59.000000', 'consum', 0.0213, 'lps'),
	(529077, 131, '2014-02-01 00:39:00.000000', 'consum', 0.0224, 'lps'),
	(529078, 131, '2014-02-01 00:39:01.000000', 'consum', 0.0219, 'lps'),
	(529079, 131, '2014-02-01 00:39:02.000000', 'consum', 0.0212, 'lps'),
	(529080, 131, '2014-02-01 00:39:03.000000', 'consum', 0.0213, 'lps'),
	(529081, 131, '2014-02-01 00:39:04.000000', 'consum', 0.0220, 'lps'),
	(529082, 131, '2014-02-01 00:39:05.000000', 'consum', 0.0216, 'lps'),
	(529083, 131, '2014-02-01 00:39:06.000000', 'consum', 0.0210, 'lps'),
	(529084, 131, '2014-02-01 00:39:07.000000', 'consum', 0.0227, 'lps'),
	(529085, 131, '2014-02-01 00:39:08.000000', 'consum', 0.0223, 'lps'),
	(529086, 131, '2014-02-01 00:39:09.000000', 'consum', 0.0227, 'lps'),
	(529087, 131, '2014-02-01 00:39:10.000000', 'consum', 0.0220, 'lps'),
	(529088, 131, '2014-02-01 00:39:11.000000', 'consum', 0.0227, 'lps'),
	(529089, 131, '2014-02-01 00:39:12.000000', 'consum', 0.0211, 'lps'),
	(529090, 131, '2014-02-01 00:39:13.000000', 'consum', 0.0220, 'lps'),
	(529091, 131, '2014-02-01 00:39:14.000000', 'consum', 0.0220, 'lps'),
	(529092, 131, '2014-02-01 00:39:15.000000', 'consum', 0.0212, 'lps'),
	(529093, 131, '2014-02-01 00:39:16.000000', 'consum', 0.0225, 'lps'),
	(529094, 131, '2014-02-01 00:39:17.000000', 'consum', 0.0211, 'lps'),
	(529095, 131, '2014-02-01 00:39:18.000000', 'consum', 0.0222, 'lps'),
	(529096, 131, '2014-02-01 00:39:19.000000', 'consum', 0.0213, 'lps'),
	(529097, 131, '2014-02-01 00:39:20.000000', 'consum', 0.0210, 'lps'),
	(529098, 131, '2014-02-01 00:39:21.000000', 'consum', 0.0218, 'lps'),
	(529099, 131, '2014-02-01 00:39:22.000000', 'consum', 0.0214, 'lps'),
	(529100, 131, '2014-02-01 00:39:23.000000', 'consum', 0.0225, 'lps'),
	(529101, 131, '2014-02-01 00:39:24.000000', 'consum', 0.0220, 'lps'),
	(529102, 131, '2014-02-01 00:39:25.000000', 'consum', 0.0217, 'lps'),
	(529103, 131, '2014-02-01 00:39:26.000000', 'consum', 0.0215, 'lps'),
	(529104, 131, '2014-02-01 00:39:27.000000', 'consum', 0.0216, 'lps'),
	(529105, 131, '2014-02-01 00:39:28.000000', 'consum', 0.0222, 'lps'),
	(529106, 131, '2014-02-01 00:39:29.000000', 'consum', 0.0218, 'lps'),
	(529107, 131, '2014-02-01 00:39:30.000000', 'consum', 0.0214, 'lps'),
	(529108, 131, '2014-02-01 00:39:31.000000', 'consum', 0.0224, 'lps'),
	(529109, 131, '2014-02-01 00:39:32.000000', 'consum', 0.0215, 'lps'),
	(529110, 131, '2014-02-01 00:39:33.000000', 'consum', 0.0213, 'lps'),
	(529111, 131, '2014-02-01 00:39:34.000000', 'consum', 0.0211, 'lps'),
	(529112, 131, '2014-02-01 00:39:35.000000', 'consum', 0.0223, 'lps'),
	(529113, 131, '2014-02-01 00:39:36.000000', 'consum', 0.0217, 'lps'),
	(529114, 131, '2014-02-01 00:39:37.000000', 'consum', 0.0225, 'lps'),
	(529115, 131, '2014-02-01 00:39:38.000000', 'consum', 0.0211, 'lps'),
	(529116, 131, '2014-02-01 00:39:39.000000', 'consum', 0.0226, 'lps'),
	(529117, 131, '2014-02-01 00:39:40.000000', 'consum', 0.0214, 'lps'),
	(529118, 131, '2014-02-01 00:39:41.000000', 'consum', 0.0220, 'lps'),
	(529119, 131, '2014-02-01 00:39:42.000000', 'consum', 0.0213, 'lps'),
	(529120, 131, '2014-02-01 00:39:43.000000', 'consum', 0.0211, 'lps'),
	(529121, 131, '2014-02-01 00:39:44.000000', 'consum', 0.0225, 'lps'),
	(529122, 131, '2014-02-01 00:39:45.000000', 'consum', 0.0211, 'lps'),
	(529123, 131, '2014-02-01 00:39:46.000000', 'consum', 0.0225, 'lps'),
	(529124, 131, '2014-02-01 00:39:47.000000', 'consum', 0.0212, 'lps'),
	(529125, 131, '2014-02-01 00:39:48.000000', 'consum', 0.0211, 'lps'),
	(529126, 131, '2014-02-01 00:39:49.000000', 'consum', 0.0210, 'lps'),
	(529127, 131, '2014-02-01 00:39:50.000000', 'consum', 0.0226, 'lps'),
	(529128, 131, '2014-02-01 00:39:51.000000', 'consum', 0.0218, 'lps'),
	(529129, 131, '2014-02-01 00:39:52.000000', 'consum', 0.0218, 'lps'),
	(529130, 131, '2014-02-01 00:39:53.000000', 'consum', 0.0212, 'lps'),
	(529131, 131, '2014-02-01 00:39:54.000000', 'consum', 0.0212, 'lps'),
	(529132, 131, '2014-02-01 00:39:55.000000', 'consum', 0.0217, 'lps'),
	(529133, 131, '2014-02-01 00:39:56.000000', 'consum', 0.0218, 'lps'),
	(529134, 131, '2014-02-01 00:39:57.000000', 'consum', 0.0215, 'lps'),
	(529135, 131, '2014-02-01 00:39:58.000000', 'consum', 0.0211, 'lps'),
	(529136, 131, '2014-02-01 00:39:59.000000', 'consum', 0.0217, 'lps'),
	(529137, 131, '2014-02-01 00:40:00.000000', 'consum', 0.0227, 'lps'),
	(529138, 131, '2014-02-01 00:40:01.000000', 'consum', 0.0219, 'lps'),
	(529139, 131, '2014-02-01 00:40:02.000000', 'consum', 0.0223, 'lps'),
	(529140, 131, '2014-02-01 00:40:03.000000', 'consum', 0.0214, 'lps'),
	(529141, 131, '2014-02-01 00:40:04.000000', 'consum', 0.0210, 'lps'),
	(529142, 131, '2014-02-01 00:40:05.000000', 'consum', 0.0214, 'lps'),
	(529143, 131, '2014-02-01 00:40:06.000000', 'consum', 0.0215, 'lps'),
	(529144, 131, '2014-02-01 00:40:07.000000', 'consum', 0.0221, 'lps'),
	(529145, 131, '2014-02-01 00:40:08.000000', 'consum', 0.0216, 'lps'),
	(529146, 131, '2014-02-01 00:40:09.000000', 'consum', 0.0226, 'lps'),
	(529147, 131, '2014-02-01 00:40:10.000000', 'consum', 0.0216, 'lps'),
	(529148, 131, '2014-02-01 00:40:11.000000', 'consum', 0.0212, 'lps'),
	(529149, 131, '2014-02-01 00:40:12.000000', 'consum', 0.0222, 'lps'),
	(529150, 131, '2014-02-01 00:40:13.000000', 'consum', 0.0227, 'lps'),
	(529151, 131, '2014-02-01 00:40:14.000000', 'consum', 0.0224, 'lps'),
	(529152, 131, '2014-02-01 00:40:15.000000', 'consum', 0.0210, 'lps'),
	(529153, 131, '2014-02-01 00:40:16.000000', 'consum', 0.0225, 'lps'),
	(529154, 131, '2014-02-01 00:40:17.000000', 'consum', 0.0212, 'lps'),
	(529155, 131, '2014-02-01 00:40:18.000000', 'consum', 0.0211, 'lps'),
	(529156, 131, '2014-02-01 00:40:19.000000', 'consum', 0.0212, 'lps'),
	(529157, 131, '2014-02-01 00:40:20.000000', 'consum', 0.0214, 'lps'),
	(529158, 131, '2014-02-01 00:40:21.000000', 'consum', 0.0227, 'lps'),
	(529159, 131, '2014-02-01 00:40:22.000000', 'consum', 0.0212, 'lps'),
	(529160, 131, '2014-02-01 00:40:23.000000', 'consum', 0.0221, 'lps'),
	(529161, 131, '2014-02-01 00:40:24.000000', 'consum', 0.0224, 'lps'),
	(529162, 131, '2014-02-01 00:40:25.000000', 'consum', 0.0214, 'lps'),
	(529163, 131, '2014-02-01 00:40:26.000000', 'consum', 0.0222, 'lps'),
	(529164, 131, '2014-02-01 00:40:27.000000', 'consum', 0.0222, 'lps'),
	(529165, 131, '2014-02-01 00:40:28.000000', 'consum', 0.0218, 'lps'),
	(529166, 131, '2014-02-01 00:40:29.000000', 'consum', 0.0214, 'lps'),
	(529167, 131, '2014-02-01 00:40:30.000000', 'consum', 0.0223, 'lps'),
	(529168, 131, '2014-02-01 00:40:31.000000', 'consum', 0.0210, 'lps'),
	(529169, 131, '2014-02-01 00:40:32.000000', 'consum', 0.0225, 'lps'),
	(529170, 131, '2014-02-01 00:40:33.000000', 'consum', 0.0212, 'lps'),
	(529171, 131, '2014-02-01 00:40:34.000000', 'consum', 0.0214, 'lps'),
	(529172, 131, '2014-02-01 00:40:35.000000', 'consum', 0.0226, 'lps'),
	(529173, 131, '2014-02-01 00:40:36.000000', 'consum', 0.0221, 'lps'),
	(529174, 131, '2014-02-01 00:40:37.000000', 'consum', 0.0220, 'lps'),
	(529175, 131, '2014-02-01 00:40:38.000000', 'consum', 0.0226, 'lps'),
	(529176, 131, '2014-02-01 00:40:39.000000', 'consum', 0.0223, 'lps'),
	(529177, 131, '2014-02-01 00:40:40.000000', 'consum', 0.0211, 'lps'),
	(529178, 131, '2014-02-01 00:40:41.000000', 'consum', 0.0214, 'lps'),
	(529179, 131, '2014-02-01 00:40:42.000000', 'consum', 0.0210, 'lps'),
	(529180, 131, '2014-02-01 00:40:43.000000', 'consum', 0.0214, 'lps'),
	(529181, 131, '2014-02-01 00:40:44.000000', 'consum', 0.0212, 'lps'),
	(529182, 131, '2014-02-01 00:40:45.000000', 'consum', 0.0226, 'lps'),
	(529183, 131, '2014-02-01 00:40:46.000000', 'consum', 0.0211, 'lps'),
	(529184, 131, '2014-02-01 00:40:47.000000', 'consum', 0.0225, 'lps'),
	(529185, 131, '2014-02-01 00:40:48.000000', 'consum', 0.0210, 'lps'),
	(529186, 131, '2014-02-01 00:40:49.000000', 'consum', 0.0220, 'lps'),
	(529187, 131, '2014-02-01 00:40:50.000000', 'consum', 0.0225, 'lps'),
	(529188, 131, '2014-02-01 00:40:51.000000', 'consum', 0.0221, 'lps'),
	(529189, 131, '2014-02-01 00:40:52.000000', 'consum', 0.0218, 'lps'),
	(529190, 131, '2014-02-01 00:40:53.000000', 'consum', 0.0216, 'lps'),
	(529191, 131, '2014-02-01 00:40:54.000000', 'consum', 0.0218, 'lps'),
	(529192, 131, '2014-02-01 00:40:55.000000', 'consum', 0.0216, 'lps'),
	(529193, 131, '2014-02-01 00:40:56.000000', 'consum', 0.0215, 'lps'),
	(529194, 131, '2014-02-01 00:40:57.000000', 'consum', 0.0220, 'lps'),
	(529195, 131, '2014-02-01 00:40:58.000000', 'consum', 0.0225, 'lps'),
	(529196, 131, '2014-02-01 00:40:59.000000', 'consum', 0.0221, 'lps'),
	(529197, 131, '2014-02-01 00:41:00.000000', 'consum', 0.0221, 'lps'),
	(529198, 131, '2014-02-01 00:41:01.000000', 'consum', 0.0212, 'lps'),
	(529199, 131, '2014-02-01 00:41:02.000000', 'consum', 0.0227, 'lps'),
	(529200, 131, '2014-02-01 00:41:03.000000', 'consum', 0.0215, 'lps'),
	(529201, 131, '2014-02-01 00:41:04.000000', 'consum', 0.0222, 'lps'),
	(529202, 131, '2014-02-01 00:41:05.000000', 'consum', 0.0217, 'lps'),
	(529203, 131, '2014-02-01 00:41:06.000000', 'consum', 0.0212, 'lps'),
	(529204, 131, '2014-02-01 00:41:07.000000', 'consum', 0.0219, 'lps'),
	(529205, 131, '2014-02-01 00:41:08.000000', 'consum', 0.0210, 'lps'),
	(529206, 131, '2014-02-01 00:41:09.000000', 'consum', 0.0223, 'lps'),
	(529207, 131, '2014-02-01 00:41:10.000000', 'consum', 0.0220, 'lps'),
	(529208, 131, '2014-02-01 00:41:11.000000', 'consum', 0.0220, 'lps'),
	(529209, 131, '2014-02-01 00:41:12.000000', 'consum', 0.0214, 'lps'),
	(529210, 131, '2014-02-01 00:41:13.000000', 'consum', 0.0217, 'lps'),
	(529211, 131, '2014-02-01 00:41:14.000000', 'consum', 0.0218, 'lps'),
	(529212, 131, '2014-02-01 00:41:15.000000', 'consum', 0.0226, 'lps'),
	(529213, 131, '2014-02-01 00:41:16.000000', 'consum', 0.0215, 'lps'),
	(529214, 131, '2014-02-01 00:41:17.000000', 'consum', 0.0224, 'lps'),
	(529215, 131, '2014-02-01 00:41:18.000000', 'consum', 0.0210, 'lps'),
	(529216, 131, '2014-02-01 00:41:19.000000', 'consum', 0.0223, 'lps'),
	(529217, 131, '2014-02-01 00:41:20.000000', 'consum', 0.0221, 'lps'),
	(529218, 131, '2014-02-01 00:41:21.000000', 'consum', 0.0210, 'lps'),
	(529219, 131, '2014-02-01 00:41:22.000000', 'consum', 0.0213, 'lps'),
	(529220, 131, '2014-02-01 00:41:23.000000', 'consum', 0.0224, 'lps'),
	(529221, 131, '2014-02-01 00:41:24.000000', 'consum', 0.0218, 'lps'),
	(529222, 131, '2014-02-01 00:41:25.000000', 'consum', 0.0227, 'lps'),
	(529223, 131, '2014-02-01 00:41:26.000000', 'consum', 0.0218, 'lps'),
	(529224, 131, '2014-02-01 00:41:27.000000', 'consum', 0.0218, 'lps'),
	(529225, 131, '2014-02-01 00:41:28.000000', 'consum', 0.0227, 'lps'),
	(529226, 131, '2014-02-01 00:41:29.000000', 'consum', 0.0216, 'lps'),
	(529227, 131, '2014-02-01 00:41:30.000000', 'consum', 0.0224, 'lps'),
	(529228, 131, '2014-02-01 00:41:31.000000', 'consum', 0.0212, 'lps'),
	(529229, 131, '2014-02-01 00:41:32.000000', 'consum', 0.0212, 'lps'),
	(529230, 131, '2014-02-01 00:41:33.000000', 'consum', 0.0214, 'lps'),
	(529231, 131, '2014-02-01 00:41:34.000000', 'consum', 0.0226, 'lps'),
	(529232, 131, '2014-02-01 00:41:35.000000', 'consum', 0.0223, 'lps'),
	(529233, 131, '2014-02-01 00:41:36.000000', 'consum', 0.0210, 'lps'),
	(529234, 131, '2014-02-01 00:41:37.000000', 'consum', 0.0227, 'lps'),
	(529235, 131, '2014-02-01 00:41:38.000000', 'consum', 0.0224, 'lps'),
	(529236, 131, '2014-02-01 00:41:39.000000', 'consum', 0.0212, 'lps'),
	(529237, 131, '2014-02-01 00:41:40.000000', 'consum', 0.0212, 'lps'),
	(529238, 131, '2014-02-01 00:41:41.000000', 'consum', 0.0216, 'lps'),
	(529239, 131, '2014-02-01 00:41:42.000000', 'consum', 0.0215, 'lps'),
	(529240, 131, '2014-02-01 00:41:43.000000', 'consum', 0.0218, 'lps'),
	(529241, 131, '2014-02-01 00:41:44.000000', 'consum', 0.0219, 'lps'),
	(529242, 131, '2014-02-01 00:41:45.000000', 'consum', 0.0211, 'lps'),
	(529243, 131, '2014-02-01 00:41:46.000000', 'consum', 0.0224, 'lps'),
	(529244, 131, '2014-02-01 00:41:47.000000', 'consum', 0.0225, 'lps'),
	(529245, 131, '2014-02-01 00:41:48.000000', 'consum', 0.0226, 'lps'),
	(529246, 131, '2014-02-01 00:41:49.000000', 'consum', 0.0225, 'lps'),
	(529247, 131, '2014-02-01 00:41:50.000000', 'consum', 0.0223, 'lps'),
	(529248, 131, '2014-02-01 00:41:51.000000', 'consum', 0.0211, 'lps'),
	(529249, 131, '2014-02-01 00:41:52.000000', 'consum', 0.0212, 'lps'),
	(529250, 131, '2014-02-01 00:41:53.000000', 'consum', 0.0216, 'lps'),
	(529251, 131, '2014-02-01 00:41:54.000000', 'consum', 0.0218, 'lps'),
	(529252, 131, '2014-02-01 00:41:55.000000', 'consum', 0.0216, 'lps'),
	(529253, 131, '2014-02-01 00:41:56.000000', 'consum', 0.0216, 'lps'),
	(529254, 131, '2014-02-01 00:41:57.000000', 'consum', 0.0224, 'lps'),
	(529255, 131, '2014-02-01 00:41:58.000000', 'consum', 0.0224, 'lps'),
	(529256, 131, '2014-02-01 00:41:59.000000', 'consum', 0.0221, 'lps'),
	(529257, 131, '2014-02-01 00:42:00.000000', 'consum', 0.0223, 'lps'),
	(529258, 131, '2014-02-01 00:42:01.000000', 'consum', 0.0224, 'lps'),
	(529259, 131, '2014-02-01 00:42:02.000000', 'consum', 0.0223, 'lps'),
	(529260, 131, '2014-02-01 00:42:03.000000', 'consum', 0.0217, 'lps'),
	(529261, 131, '2014-02-01 00:42:04.000000', 'consum', 0.0224, 'lps'),
	(529262, 131, '2014-02-01 00:42:05.000000', 'consum', 0.0224, 'lps'),
	(529263, 131, '2014-02-01 00:42:06.000000', 'consum', 0.0220, 'lps'),
	(529264, 131, '2014-02-01 00:42:07.000000', 'consum', 0.0218, 'lps'),
	(529265, 131, '2014-02-01 00:42:08.000000', 'consum', 0.0222, 'lps'),
	(529266, 131, '2014-02-01 00:42:09.000000', 'consum', 0.0227, 'lps'),
	(529267, 131, '2014-02-01 00:42:10.000000', 'consum', 0.0224, 'lps'),
	(529268, 131, '2014-02-01 00:42:11.000000', 'consum', 0.0211, 'lps'),
	(529269, 131, '2014-02-01 00:42:12.000000', 'consum', 0.0226, 'lps'),
	(529270, 131, '2014-02-01 00:42:13.000000', 'consum', 0.0217, 'lps'),
	(529271, 131, '2014-02-01 00:42:14.000000', 'consum', 0.0217, 'lps'),
	(529272, 131, '2014-02-01 00:42:15.000000', 'consum', 0.0221, 'lps'),
	(529273, 131, '2014-02-01 00:42:16.000000', 'consum', 0.0212, 'lps'),
	(529274, 131, '2014-02-01 00:42:17.000000', 'consum', 0.0221, 'lps'),
	(529275, 131, '2014-02-01 00:42:18.000000', 'consum', 0.0224, 'lps'),
	(529276, 131, '2014-02-01 00:42:19.000000', 'consum', 0.0211, 'lps'),
	(529277, 131, '2014-02-01 00:42:20.000000', 'consum', 0.0211, 'lps'),
	(529278, 131, '2014-02-01 00:42:21.000000', 'consum', 0.0211, 'lps'),
	(529279, 131, '2014-02-01 00:42:22.000000', 'consum', 0.0213, 'lps'),
	(529280, 131, '2014-02-01 00:42:23.000000', 'consum', 0.0224, 'lps'),
	(529281, 131, '2014-02-01 00:42:24.000000', 'consum', 0.0217, 'lps'),
	(529282, 131, '2014-02-01 00:42:25.000000', 'consum', 0.0219, 'lps'),
	(529283, 131, '2014-02-01 00:42:26.000000', 'consum', 0.0220, 'lps'),
	(529284, 131, '2014-02-01 00:42:27.000000', 'consum', 0.0213, 'lps'),
	(529285, 131, '2014-02-01 00:42:28.000000', 'consum', 0.0213, 'lps'),
	(529286, 131, '2014-02-01 00:42:29.000000', 'consum', 0.0216, 'lps'),
	(529287, 131, '2014-02-01 00:42:30.000000', 'consum', 0.0215, 'lps'),
	(529288, 131, '2014-02-01 00:42:31.000000', 'consum', 0.0216, 'lps'),
	(529289, 131, '2014-02-01 00:42:32.000000', 'consum', 0.0227, 'lps'),
	(529290, 131, '2014-02-01 00:42:33.000000', 'consum', 0.0221, 'lps'),
	(529291, 131, '2014-02-01 00:42:34.000000', 'consum', 0.0216, 'lps'),
	(529292, 131, '2014-02-01 00:42:35.000000', 'consum', 0.0225, 'lps'),
	(529293, 131, '2014-02-01 00:42:36.000000', 'consum', 0.0215, 'lps'),
	(529294, 131, '2014-02-01 00:42:37.000000', 'consum', 0.0226, 'lps'),
	(529295, 131, '2014-02-01 00:42:38.000000', 'consum', 0.0221, 'lps'),
	(529296, 131, '2014-02-01 00:42:39.000000', 'consum', 0.0218, 'lps'),
	(529297, 131, '2014-02-01 00:42:40.000000', 'consum', 0.0217, 'lps'),
	(529298, 131, '2014-02-01 00:42:41.000000', 'consum', 0.0221, 'lps'),
	(529299, 131, '2014-02-01 00:42:42.000000', 'consum', 0.0210, 'lps'),
	(529300, 131, '2014-02-01 00:42:43.000000', 'consum', 0.0213, 'lps'),
	(529301, 131, '2014-02-01 00:42:44.000000', 'consum', 0.0227, 'lps'),
	(529302, 131, '2014-02-01 00:42:45.000000', 'consum', 0.0214, 'lps'),
	(529303, 131, '2014-02-01 00:42:46.000000', 'consum', 0.0214, 'lps'),
	(529304, 131, '2014-02-01 00:42:47.000000', 'consum', 0.0219, 'lps'),
	(529305, 131, '2014-02-01 00:42:48.000000', 'consum', 0.0226, 'lps'),
	(529306, 131, '2014-02-01 00:42:49.000000', 'consum', 0.0210, 'lps'),
	(529307, 131, '2014-02-01 00:42:50.000000', 'consum', 0.0214, 'lps'),
	(529308, 131, '2014-02-01 00:42:51.000000', 'consum', 0.0213, 'lps'),
	(529309, 131, '2014-02-01 00:42:52.000000', 'consum', 0.0215, 'lps'),
	(529310, 131, '2014-02-01 00:42:53.000000', 'consum', 0.0227, 'lps'),
	(529311, 131, '2014-02-01 00:42:54.000000', 'consum', 0.0225, 'lps'),
	(529312, 131, '2014-02-01 00:42:55.000000', 'consum', 0.0217, 'lps'),
	(529313, 131, '2014-02-01 00:42:56.000000', 'consum', 0.0218, 'lps'),
	(529314, 131, '2014-02-01 00:42:57.000000', 'consum', 0.0210, 'lps'),
	(529315, 131, '2014-02-01 00:42:58.000000', 'consum', 0.0226, 'lps'),
	(529316, 131, '2014-02-01 00:42:59.000000', 'consum', 0.0216, 'lps'),
	(529317, 131, '2014-02-01 00:43:00.000000', 'consum', 0.0211, 'lps'),
	(529318, 131, '2014-02-01 00:43:01.000000', 'consum', 0.0215, 'lps'),
	(529319, 131, '2014-02-01 00:43:02.000000', 'consum', 0.0216, 'lps'),
	(529320, 131, '2014-02-01 00:43:03.000000', 'consum', 0.0224, 'lps'),
	(529321, 131, '2014-02-01 00:43:04.000000', 'consum', 0.0225, 'lps'),
	(529322, 131, '2014-02-01 00:43:05.000000', 'consum', 0.0210, 'lps'),
	(529323, 131, '2014-02-01 00:43:06.000000', 'consum', 0.0217, 'lps'),
	(529324, 131, '2014-02-01 00:43:07.000000', 'consum', 0.0212, 'lps'),
	(529325, 131, '2014-02-01 00:43:08.000000', 'consum', 0.0218, 'lps'),
	(529326, 131, '2014-02-01 00:43:09.000000', 'consum', 0.0224, 'lps'),
	(529327, 131, '2014-02-01 00:43:10.000000', 'consum', 0.0222, 'lps'),
	(529328, 131, '2014-02-01 00:43:11.000000', 'consum', 0.0226, 'lps'),
	(529329, 131, '2014-02-01 00:43:12.000000', 'consum', 0.0221, 'lps'),
	(529330, 131, '2014-02-01 00:43:13.000000', 'consum', 0.0216, 'lps'),
	(529331, 131, '2014-02-01 00:43:14.000000', 'consum', 0.0224, 'lps'),
	(529332, 131, '2014-02-01 00:43:15.000000', 'consum', 0.0212, 'lps'),
	(529333, 131, '2014-02-01 00:43:16.000000', 'consum', 0.0213, 'lps'),
	(529334, 131, '2014-02-01 00:43:17.000000', 'consum', 0.0220, 'lps'),
	(529335, 131, '2014-02-01 00:43:18.000000', 'consum', 0.0213, 'lps'),
	(529336, 131, '2014-02-01 00:43:19.000000', 'consum', 0.0216, 'lps'),
	(529337, 131, '2014-02-01 00:43:20.000000', 'consum', 0.0212, 'lps'),
	(529338, 131, '2014-02-01 00:43:21.000000', 'consum', 0.0223, 'lps'),
	(529339, 131, '2014-02-01 00:43:22.000000', 'consum', 0.0212, 'lps'),
	(529340, 131, '2014-02-01 00:43:23.000000', 'consum', 0.0220, 'lps'),
	(529341, 131, '2014-02-01 00:43:24.000000', 'consum', 0.0220, 'lps'),
	(529342, 131, '2014-02-01 00:43:25.000000', 'consum', 0.0227, 'lps'),
	(529343, 131, '2014-02-01 00:43:26.000000', 'consum', 0.0214, 'lps'),
	(529344, 131, '2014-02-01 00:43:27.000000', 'consum', 0.0213, 'lps'),
	(529345, 131, '2014-02-01 00:43:28.000000', 'consum', 0.0214, 'lps'),
	(529346, 131, '2014-02-01 00:43:29.000000', 'consum', 0.0223, 'lps'),
	(529347, 131, '2014-02-01 00:43:30.000000', 'consum', 0.0210, 'lps'),
	(529348, 131, '2014-02-01 00:43:31.000000', 'consum', 0.0224, 'lps'),
	(529349, 131, '2014-02-01 00:43:32.000000', 'consum', 0.0211, 'lps'),
	(529350, 131, '2014-02-01 00:43:33.000000', 'consum', 0.0224, 'lps'),
	(529351, 131, '2014-02-01 00:43:34.000000', 'consum', 0.0225, 'lps'),
	(529352, 131, '2014-02-01 00:43:35.000000', 'consum', 0.0226, 'lps'),
	(529353, 131, '2014-02-01 00:43:36.000000', 'consum', 0.0227, 'lps'),
	(529354, 131, '2014-02-01 00:43:37.000000', 'consum', 0.0212, 'lps'),
	(529355, 131, '2014-02-01 00:43:38.000000', 'consum', 0.0223, 'lps'),
	(529356, 131, '2014-02-01 00:43:39.000000', 'consum', 0.0218, 'lps'),
	(529357, 131, '2014-02-01 00:43:40.000000', 'consum', 0.0226, 'lps'),
	(529358, 131, '2014-02-01 00:43:41.000000', 'consum', 0.0213, 'lps'),
	(529359, 131, '2014-02-01 00:43:42.000000', 'consum', 0.0214, 'lps'),
	(529360, 131, '2014-02-01 00:43:43.000000', 'consum', 0.0223, 'lps'),
	(529361, 131, '2014-02-01 00:43:44.000000', 'consum', 0.0210, 'lps'),
	(529362, 131, '2014-02-01 00:43:45.000000', 'consum', 0.0225, 'lps'),
	(529363, 131, '2014-02-01 00:43:46.000000', 'consum', 0.0214, 'lps'),
	(529364, 131, '2014-02-01 00:43:47.000000', 'consum', 0.0222, 'lps'),
	(529365, 131, '2014-02-01 00:43:48.000000', 'consum', 0.0223, 'lps'),
	(529366, 131, '2014-02-01 00:43:49.000000', 'consum', 0.0220, 'lps'),
	(529367, 131, '2014-02-01 00:43:50.000000', 'consum', 0.0222, 'lps'),
	(529368, 131, '2014-02-01 00:43:51.000000', 'consum', 0.0222, 'lps'),
	(529369, 131, '2014-02-01 00:43:52.000000', 'consum', 0.0215, 'lps'),
	(529370, 131, '2014-02-01 00:43:53.000000', 'consum', 0.0221, 'lps'),
	(529371, 131, '2014-02-01 00:43:54.000000', 'consum', 0.0212, 'lps'),
	(529372, 131, '2014-02-01 00:43:55.000000', 'consum', 0.0224, 'lps'),
	(529373, 131, '2014-02-01 00:43:56.000000', 'consum', 0.0219, 'lps'),
	(529374, 131, '2014-02-01 00:43:57.000000', 'consum', 0.0215, 'lps'),
	(529375, 131, '2014-02-01 00:43:58.000000', 'consum', 0.0224, 'lps'),
	(529376, 131, '2014-02-01 00:43:59.000000', 'consum', 0.0214, 'lps'),
	(529377, 131, '2014-02-01 00:44:00.000000', 'consum', 0.0223, 'lps'),
	(529378, 131, '2014-02-01 00:44:01.000000', 'consum', 0.0210, 'lps'),
	(529379, 131, '2014-02-01 00:44:02.000000', 'consum', 0.0223, 'lps'),
	(529380, 131, '2014-02-01 00:44:03.000000', 'consum', 0.0225, 'lps'),
	(529381, 131, '2014-02-01 00:44:04.000000', 'consum', 0.0210, 'lps'),
	(529382, 131, '2014-02-01 00:44:05.000000', 'consum', 0.0220, 'lps'),
	(529383, 131, '2014-02-01 00:44:06.000000', 'consum', 0.0223, 'lps'),
	(529384, 131, '2014-02-01 00:44:07.000000', 'consum', 0.0210, 'lps'),
	(529385, 131, '2014-02-01 00:44:08.000000', 'consum', 0.0226, 'lps'),
	(529386, 131, '2014-02-01 00:44:09.000000', 'consum', 0.0218, 'lps'),
	(529387, 131, '2014-02-01 00:44:10.000000', 'consum', 0.0222, 'lps'),
	(529388, 131, '2014-02-01 00:44:11.000000', 'consum', 0.0210, 'lps'),
	(529389, 131, '2014-02-01 00:44:12.000000', 'consum', 0.0212, 'lps'),
	(529390, 131, '2014-02-01 00:44:13.000000', 'consum', 0.0218, 'lps'),
	(529391, 131, '2014-02-01 00:44:14.000000', 'consum', 0.0226, 'lps'),
	(529392, 131, '2014-02-01 00:44:15.000000', 'consum', 0.0215, 'lps'),
	(529393, 131, '2014-02-01 00:44:16.000000', 'consum', 0.0221, 'lps'),
	(529394, 131, '2014-02-01 00:44:17.000000', 'consum', 0.0214, 'lps'),
	(529395, 131, '2014-02-01 00:44:18.000000', 'consum', 0.0216, 'lps'),
	(529396, 131, '2014-02-01 00:44:19.000000', 'consum', 0.0211, 'lps'),
	(529397, 131, '2014-02-01 00:44:20.000000', 'consum', 0.0215, 'lps'),
	(529398, 131, '2014-02-01 00:44:21.000000', 'consum', 0.0214, 'lps'),
	(529399, 131, '2014-02-01 00:44:22.000000', 'consum', 0.0215, 'lps'),
	(529400, 131, '2014-02-01 00:44:23.000000', 'consum', 0.0222, 'lps'),
	(529401, 131, '2014-02-01 00:44:24.000000', 'consum', 0.0222, 'lps'),
	(529402, 131, '2014-02-01 00:44:25.000000', 'consum', 0.0218, 'lps'),
	(529403, 131, '2014-02-01 00:44:26.000000', 'consum', 0.0212, 'lps'),
	(529404, 131, '2014-02-01 00:44:27.000000', 'consum', 0.0217, 'lps'),
	(529405, 131, '2014-02-01 00:44:28.000000', 'consum', 0.0218, 'lps'),
	(529406, 131, '2014-02-01 00:44:29.000000', 'consum', 0.0214, 'lps'),
	(529407, 131, '2014-02-01 00:44:30.000000', 'consum', 0.0225, 'lps'),
	(529408, 131, '2014-02-01 00:44:31.000000', 'consum', 0.0217, 'lps'),
	(529409, 131, '2014-02-01 00:44:32.000000', 'consum', 0.0221, 'lps'),
	(529410, 131, '2014-02-01 00:44:33.000000', 'consum', 0.0210, 'lps'),
	(529411, 131, '2014-02-01 00:44:34.000000', 'consum', 0.0211, 'lps'),
	(529412, 131, '2014-02-01 00:44:35.000000', 'consum', 0.0214, 'lps'),
	(529413, 131, '2014-02-01 00:44:36.000000', 'consum', 0.0211, 'lps'),
	(529414, 131, '2014-02-01 00:44:37.000000', 'consum', 0.0222, 'lps'),
	(529415, 131, '2014-02-01 00:44:38.000000', 'consum', 0.0213, 'lps'),
	(529416, 131, '2014-02-01 00:44:39.000000', 'consum', 0.0227, 'lps'),
	(529417, 131, '2014-02-01 00:44:40.000000', 'consum', 0.0214, 'lps'),
	(529418, 131, '2014-02-01 00:44:41.000000', 'consum', 0.0214, 'lps'),
	(529419, 131, '2014-02-01 00:44:42.000000', 'consum', 0.0218, 'lps'),
	(529420, 131, '2014-02-01 00:44:43.000000', 'consum', 0.0220, 'lps'),
	(529421, 131, '2014-02-01 00:44:44.000000', 'consum', 0.0219, 'lps'),
	(529422, 131, '2014-02-01 00:44:45.000000', 'consum', 0.0227, 'lps'),
	(529423, 131, '2014-02-01 00:44:46.000000', 'consum', 0.0213, 'lps'),
	(529424, 131, '2014-02-01 00:44:47.000000', 'consum', 0.0210, 'lps'),
	(529425, 131, '2014-02-01 00:44:48.000000', 'consum', 0.0219, 'lps'),
	(529426, 131, '2014-02-01 00:44:49.000000', 'consum', 0.0219, 'lps'),
	(529427, 131, '2014-02-01 00:44:50.000000', 'consum', 0.0212, 'lps'),
	(529428, 131, '2014-02-01 00:44:51.000000', 'consum', 0.0210, 'lps'),
	(529429, 131, '2014-02-01 00:44:52.000000', 'consum', 0.0221, 'lps'),
	(529430, 131, '2014-02-01 00:44:53.000000', 'consum', 0.0214, 'lps'),
	(529431, 131, '2014-02-01 00:44:54.000000', 'consum', 0.0214, 'lps'),
	(529432, 131, '2014-02-01 00:44:55.000000', 'consum', 0.0218, 'lps'),
	(529433, 131, '2014-02-01 00:44:56.000000', 'consum', 0.0222, 'lps'),
	(529434, 131, '2014-02-01 00:44:57.000000', 'consum', 0.0226, 'lps'),
	(529435, 131, '2014-02-01 00:44:58.000000', 'consum', 0.0221, 'lps'),
	(529436, 131, '2014-02-01 00:44:59.000000', 'consum', 0.0215, 'lps'),
	(529437, 131, '2014-02-01 00:45:00.000000', 'consum', 0.0220, 'lps'),
	(529438, 131, '2014-02-01 00:45:01.000000', 'consum', 0.0211, 'lps'),
	(529439, 131, '2014-02-01 00:45:02.000000', 'consum', 0.0223, 'lps'),
	(529440, 131, '2014-02-01 00:45:03.000000', 'consum', 0.0218, 'lps'),
	(529441, 131, '2014-02-01 00:45:04.000000', 'consum', 0.0212, 'lps'),
	(529442, 131, '2014-02-01 00:45:05.000000', 'consum', 0.0214, 'lps'),
	(529443, 131, '2014-02-01 00:45:06.000000', 'consum', 0.0222, 'lps'),
	(529444, 131, '2014-02-01 00:45:07.000000', 'consum', 0.0225, 'lps'),
	(529445, 131, '2014-02-01 00:45:08.000000', 'consum', 0.0214, 'lps'),
	(529446, 131, '2014-02-01 00:45:09.000000', 'consum', 0.0219, 'lps'),
	(529447, 131, '2014-02-01 00:45:10.000000', 'consum', 0.0225, 'lps'),
	(529448, 131, '2014-02-01 00:45:11.000000', 'consum', 0.0226, 'lps'),
	(529449, 131, '2014-02-01 00:45:12.000000', 'consum', 0.0225, 'lps'),
	(529450, 131, '2014-02-01 00:45:13.000000', 'consum', 0.0220, 'lps'),
	(529451, 131, '2014-02-01 00:45:14.000000', 'consum', 0.0217, 'lps'),
	(529452, 131, '2014-02-01 00:45:15.000000', 'consum', 0.0216, 'lps'),
	(529453, 131, '2014-02-01 00:45:16.000000', 'consum', 0.0217, 'lps'),
	(529454, 131, '2014-02-01 00:45:17.000000', 'consum', 0.0227, 'lps'),
	(529455, 131, '2014-02-01 00:45:18.000000', 'consum', 0.0223, 'lps'),
	(529456, 131, '2014-02-01 00:45:19.000000', 'consum', 0.0224, 'lps'),
	(529457, 131, '2014-02-01 00:45:20.000000', 'consum', 0.0222, 'lps'),
	(529458, 131, '2014-02-01 00:45:21.000000', 'consum', 0.0212, 'lps'),
	(529459, 131, '2014-02-01 00:45:22.000000', 'consum', 0.0222, 'lps'),
	(529460, 131, '2014-02-01 00:45:23.000000', 'consum', 0.0226, 'lps'),
	(529461, 131, '2014-02-01 00:45:24.000000', 'consum', 0.0221, 'lps'),
	(529462, 131, '2014-02-01 00:45:25.000000', 'consum', 0.0216, 'lps'),
	(529463, 131, '2014-02-01 00:45:26.000000', 'consum', 0.0227, 'lps'),
	(529464, 131, '2014-02-01 00:45:27.000000', 'consum', 0.0223, 'lps'),
	(529465, 131, '2014-02-01 00:45:28.000000', 'consum', 0.0226, 'lps'),
	(529466, 131, '2014-02-01 00:45:29.000000', 'consum', 0.0214, 'lps'),
	(529467, 131, '2014-02-01 00:45:30.000000', 'consum', 0.0217, 'lps'),
	(529468, 131, '2014-02-01 00:45:31.000000', 'consum', 0.0216, 'lps'),
	(529469, 131, '2014-02-01 00:45:32.000000', 'consum', 0.0219, 'lps'),
	(529470, 131, '2014-02-01 00:45:33.000000', 'consum', 0.0219, 'lps'),
	(529471, 131, '2014-02-01 00:45:34.000000', 'consum', 0.0227, 'lps'),
	(529472, 131, '2014-02-01 00:45:35.000000', 'consum', 0.0218, 'lps'),
	(529473, 131, '2014-02-01 00:45:36.000000', 'consum', 0.0217, 'lps'),
	(529474, 131, '2014-02-01 00:45:37.000000', 'consum', 0.0221, 'lps'),
	(529475, 131, '2014-02-01 00:45:38.000000', 'consum', 0.0225, 'lps'),
	(529476, 131, '2014-02-01 00:45:39.000000', 'consum', 0.0218, 'lps'),
	(529477, 131, '2014-02-01 00:45:40.000000', 'consum', 0.0223, 'lps'),
	(529478, 131, '2014-02-01 00:45:41.000000', 'consum', 0.0217, 'lps'),
	(529479, 131, '2014-02-01 00:45:42.000000', 'consum', 0.0226, 'lps'),
	(529480, 131, '2014-02-01 00:45:43.000000', 'consum', 0.0212, 'lps'),
	(529481, 131, '2014-02-01 00:45:44.000000', 'consum', 0.0210, 'lps'),
	(529482, 131, '2014-02-01 00:45:45.000000', 'consum', 0.0221, 'lps'),
	(529483, 131, '2014-02-01 00:45:46.000000', 'consum', 0.0211, 'lps'),
	(529484, 131, '2014-02-01 00:45:47.000000', 'consum', 0.0219, 'lps'),
	(529485, 131, '2014-02-01 00:45:48.000000', 'consum', 0.0216, 'lps'),
	(529486, 131, '2014-02-01 00:45:49.000000', 'consum', 0.0215, 'lps'),
	(529487, 131, '2014-02-01 00:45:50.000000', 'consum', 0.0217, 'lps'),
	(529488, 131, '2014-02-01 00:45:51.000000', 'consum', 0.0213, 'lps'),
	(529489, 131, '2014-02-01 00:45:52.000000', 'consum', 0.0223, 'lps'),
	(529490, 131, '2014-02-01 00:45:53.000000', 'consum', 0.0211, 'lps'),
	(529491, 131, '2014-02-01 00:45:54.000000', 'consum', 0.0214, 'lps'),
	(529492, 131, '2014-02-01 00:45:55.000000', 'consum', 0.0211, 'lps'),
	(529493, 131, '2014-02-01 00:45:56.000000', 'consum', 0.0220, 'lps'),
	(529494, 131, '2014-02-01 00:45:57.000000', 'consum', 0.0221, 'lps'),
	(529495, 131, '2014-02-01 00:45:58.000000', 'consum', 0.0217, 'lps'),
	(529496, 131, '2014-02-01 00:45:59.000000', 'consum', 0.0214, 'lps'),
	(529497, 131, '2014-02-01 00:46:00.000000', 'consum', 0.0211, 'lps'),
	(529498, 131, '2014-02-01 00:46:01.000000', 'consum', 0.0220, 'lps'),
	(529499, 131, '2014-02-01 00:46:02.000000', 'consum', 0.0221, 'lps'),
	(529500, 131, '2014-02-01 00:46:03.000000', 'consum', 0.0217, 'lps'),
	(529501, 131, '2014-02-01 00:46:04.000000', 'consum', 0.0213, 'lps'),
	(529502, 131, '2014-02-01 00:46:05.000000', 'consum', 0.0223, 'lps'),
	(529503, 131, '2014-02-01 00:46:06.000000', 'consum', 0.0211, 'lps'),
	(529504, 131, '2014-02-01 00:46:07.000000', 'consum', 0.0211, 'lps'),
	(529505, 131, '2014-02-01 00:46:08.000000', 'consum', 0.0215, 'lps'),
	(529506, 131, '2014-02-01 00:46:09.000000', 'consum', 0.0214, 'lps'),
	(529507, 131, '2014-02-01 00:46:10.000000', 'consum', 0.0215, 'lps'),
	(529508, 131, '2014-02-01 00:46:11.000000', 'consum', 0.0222, 'lps'),
	(529509, 131, '2014-02-01 00:46:12.000000', 'consum', 0.0220, 'lps'),
	(529510, 131, '2014-02-01 00:46:13.000000', 'consum', 0.0226, 'lps'),
	(529511, 131, '2014-02-01 00:46:14.000000', 'consum', 0.0226, 'lps'),
	(529512, 131, '2014-02-01 00:46:15.000000', 'consum', 0.0222, 'lps'),
	(529513, 131, '2014-02-01 00:46:16.000000', 'consum', 0.0222, 'lps'),
	(529514, 131, '2014-02-01 00:46:17.000000', 'consum', 0.0217, 'lps'),
	(529515, 131, '2014-02-01 00:46:18.000000', 'consum', 0.0210, 'lps'),
	(529516, 131, '2014-02-01 00:46:19.000000', 'consum', 0.0225, 'lps'),
	(529517, 131, '2014-02-01 00:46:20.000000', 'consum', 0.0213, 'lps'),
	(529518, 131, '2014-02-01 00:46:21.000000', 'consum', 0.0216, 'lps'),
	(529519, 131, '2014-02-01 00:46:22.000000', 'consum', 0.0216, 'lps'),
	(529520, 131, '2014-02-01 00:46:23.000000', 'consum', 0.0221, 'lps'),
	(529521, 131, '2014-02-01 00:46:24.000000', 'consum', 0.0212, 'lps'),
	(529522, 131, '2014-02-01 00:46:25.000000', 'consum', 0.0223, 'lps'),
	(529523, 131, '2014-02-01 00:46:26.000000', 'consum', 0.0215, 'lps'),
	(529524, 131, '2014-02-01 00:46:27.000000', 'consum', 0.0214, 'lps'),
	(529525, 131, '2014-02-01 00:46:28.000000', 'consum', 0.0216, 'lps'),
	(529526, 131, '2014-02-01 00:46:29.000000', 'consum', 0.0210, 'lps'),
	(529527, 131, '2014-02-01 00:46:30.000000', 'consum', 0.0212, 'lps'),
	(529528, 131, '2014-02-01 00:46:31.000000', 'consum', 0.0219, 'lps'),
	(529529, 131, '2014-02-01 00:46:32.000000', 'consum', 0.0213, 'lps'),
	(529530, 131, '2014-02-01 00:46:33.000000', 'consum', 0.0216, 'lps'),
	(529531, 131, '2014-02-01 00:46:34.000000', 'consum', 0.0215, 'lps'),
	(529532, 131, '2014-02-01 00:46:35.000000', 'consum', 0.0218, 'lps'),
	(529533, 131, '2014-02-01 00:46:36.000000', 'consum', 0.0216, 'lps'),
	(529534, 131, '2014-02-01 00:46:37.000000', 'consum', 0.0215, 'lps'),
	(529535, 131, '2014-02-01 00:46:38.000000', 'consum', 0.0221, 'lps'),
	(529536, 131, '2014-02-01 00:46:39.000000', 'consum', 0.0212, 'lps'),
	(529537, 131, '2014-02-01 00:46:40.000000', 'consum', 0.0224, 'lps'),
	(529538, 131, '2014-02-01 00:46:41.000000', 'consum', 0.0220, 'lps'),
	(529539, 131, '2014-02-01 00:46:42.000000', 'consum', 0.0217, 'lps'),
	(529540, 131, '2014-02-01 00:46:43.000000', 'consum', 0.0216, 'lps'),
	(529541, 131, '2014-02-01 00:46:44.000000', 'consum', 0.0221, 'lps'),
	(529542, 131, '2014-02-01 00:46:45.000000', 'consum', 0.0212, 'lps'),
	(529543, 131, '2014-02-01 00:46:46.000000', 'consum', 0.0224, 'lps'),
	(529544, 131, '2014-02-01 00:46:47.000000', 'consum', 0.0218, 'lps'),
	(529545, 131, '2014-02-01 00:46:48.000000', 'consum', 0.0226, 'lps'),
	(529546, 131, '2014-02-01 00:46:49.000000', 'consum', 0.0213, 'lps'),
	(529547, 131, '2014-02-01 00:46:50.000000', 'consum', 0.0213, 'lps'),
	(529548, 131, '2014-02-01 00:46:51.000000', 'consum', 0.0218, 'lps'),
	(529549, 131, '2014-02-01 00:46:52.000000', 'consum', 0.0223, 'lps'),
	(529550, 131, '2014-02-01 00:46:53.000000', 'consum', 0.0216, 'lps'),
	(529551, 131, '2014-02-01 00:46:54.000000', 'consum', 0.0218, 'lps'),
	(529552, 131, '2014-02-01 00:46:55.000000', 'consum', 0.0213, 'lps'),
	(529553, 131, '2014-02-01 00:46:56.000000', 'consum', 0.0223, 'lps'),
	(529554, 131, '2014-02-01 00:46:57.000000', 'consum', 0.0211, 'lps'),
	(529555, 131, '2014-02-01 00:46:58.000000', 'consum', 0.0211, 'lps'),
	(529556, 131, '2014-02-01 00:46:59.000000', 'consum', 0.0213, 'lps'),
	(529557, 131, '2014-02-01 00:47:00.000000', 'consum', 0.0221, 'lps'),
	(529558, 131, '2014-02-01 00:47:01.000000', 'consum', 0.0223, 'lps'),
	(529559, 131, '2014-02-01 00:47:02.000000', 'consum', 0.0222, 'lps'),
	(529560, 131, '2014-02-01 00:47:03.000000', 'consum', 0.0213, 'lps'),
	(529561, 131, '2014-02-01 00:47:04.000000', 'consum', 0.0226, 'lps'),
	(529562, 131, '2014-02-01 00:47:05.000000', 'consum', 0.0211, 'lps'),
	(529563, 131, '2014-02-01 00:47:06.000000', 'consum', 0.0219, 'lps'),
	(529564, 131, '2014-02-01 00:47:07.000000', 'consum', 0.0220, 'lps'),
	(529565, 131, '2014-02-01 00:47:08.000000', 'consum', 0.0212, 'lps'),
	(529566, 131, '2014-02-01 00:47:09.000000', 'consum', 0.0211, 'lps'),
	(529567, 131, '2014-02-01 00:47:10.000000', 'consum', 0.0227, 'lps'),
	(529568, 131, '2014-02-01 00:47:11.000000', 'consum', 0.0221, 'lps'),
	(529569, 131, '2014-02-01 00:47:12.000000', 'consum', 0.0215, 'lps'),
	(529570, 131, '2014-02-01 00:47:13.000000', 'consum', 0.0219, 'lps'),
	(529571, 131, '2014-02-01 00:47:14.000000', 'consum', 0.0223, 'lps'),
	(529572, 131, '2014-02-01 00:47:15.000000', 'consum', 0.0214, 'lps'),
	(529573, 131, '2014-02-01 00:47:16.000000', 'consum', 0.0225, 'lps'),
	(529574, 131, '2014-02-01 00:47:17.000000', 'consum', 0.0220, 'lps'),
	(529575, 131, '2014-02-01 00:47:18.000000', 'consum', 0.0217, 'lps'),
	(529576, 131, '2014-02-01 00:47:19.000000', 'consum', 0.0216, 'lps'),
	(529577, 131, '2014-02-01 00:47:20.000000', 'consum', 0.0218, 'lps'),
	(529578, 131, '2014-02-01 00:47:21.000000', 'consum', 0.0216, 'lps'),
	(529579, 131, '2014-02-01 00:47:22.000000', 'consum', 0.0216, 'lps'),
	(529580, 131, '2014-02-01 00:47:23.000000', 'consum', 0.0223, 'lps'),
	(529581, 131, '2014-02-01 00:47:24.000000', 'consum', 0.0223, 'lps'),
	(529582, 131, '2014-02-01 00:47:25.000000', 'consum', 0.0216, 'lps'),
	(529583, 131, '2014-02-01 00:47:26.000000', 'consum', 0.0220, 'lps'),
	(529584, 131, '2014-02-01 00:47:27.000000', 'consum', 0.0226, 'lps'),
	(529585, 131, '2014-02-01 00:47:28.000000', 'consum', 0.0224, 'lps'),
	(529586, 131, '2014-02-01 00:47:29.000000', 'consum', 0.0213, 'lps'),
	(529587, 131, '2014-02-01 00:47:30.000000', 'consum', 0.0219, 'lps'),
	(529588, 131, '2014-02-01 00:47:31.000000', 'consum', 0.0213, 'lps'),
	(529589, 131, '2014-02-01 00:47:32.000000', 'consum', 0.0217, 'lps'),
	(529590, 131, '2014-02-01 00:47:33.000000', 'consum', 0.0217, 'lps'),
	(529591, 131, '2014-02-01 00:47:34.000000', 'consum', 0.0223, 'lps'),
	(529592, 131, '2014-02-01 00:47:35.000000', 'consum', 0.0220, 'lps'),
	(529593, 131, '2014-02-01 00:47:36.000000', 'consum', 0.0223, 'lps'),
	(529594, 131, '2014-02-01 00:47:37.000000', 'consum', 0.0225, 'lps'),
	(529595, 131, '2014-02-01 00:47:38.000000', 'consum', 0.0227, 'lps'),
	(529596, 131, '2014-02-01 00:47:39.000000', 'consum', 0.0218, 'lps'),
	(529597, 131, '2014-02-01 00:47:40.000000', 'consum', 0.0215, 'lps'),
	(529598, 131, '2014-02-01 00:47:41.000000', 'consum', 0.0213, 'lps'),
	(529599, 131, '2014-02-01 00:47:42.000000', 'consum', 0.0227, 'lps'),
	(529600, 131, '2014-02-01 00:47:43.000000', 'consum', 0.0215, 'lps'),
	(529601, 131, '2014-02-01 00:47:44.000000', 'consum', 0.0219, 'lps'),
	(529602, 131, '2014-02-01 00:47:45.000000', 'consum', 0.0225, 'lps'),
	(529603, 131, '2014-02-01 00:47:46.000000', 'consum', 0.0221, 'lps'),
	(529604, 131, '2014-02-01 00:47:47.000000', 'consum', 0.0222, 'lps'),
	(529605, 131, '2014-02-01 00:47:48.000000', 'consum', 0.0220, 'lps'),
	(529606, 131, '2014-02-01 00:47:49.000000', 'consum', 0.0222, 'lps'),
	(529607, 131, '2014-02-01 00:47:50.000000', 'consum', 0.0222, 'lps'),
	(529608, 131, '2014-02-01 00:47:51.000000', 'consum', 0.0218, 'lps'),
	(529609, 131, '2014-02-01 00:47:52.000000', 'consum', 0.0214, 'lps'),
	(529610, 131, '2014-02-01 00:47:53.000000', 'consum', 0.0226, 'lps'),
	(529611, 131, '2014-02-01 00:47:54.000000', 'consum', 0.0222, 'lps'),
	(529612, 131, '2014-02-01 00:47:55.000000', 'consum', 0.0224, 'lps'),
	(529613, 131, '2014-02-01 00:47:56.000000', 'consum', 0.0225, 'lps'),
	(529614, 131, '2014-02-01 00:47:57.000000', 'consum', 0.0224, 'lps'),
	(529615, 131, '2014-02-01 00:47:58.000000', 'consum', 0.0221, 'lps'),
	(529616, 131, '2014-02-01 00:47:59.000000', 'consum', 0.0223, 'lps'),
	(529617, 131, '2014-02-01 00:48:00.000000', 'consum', 0.0225, 'lps'),
	(529618, 131, '2014-02-01 00:48:01.000000', 'consum', 0.0212, 'lps'),
	(529619, 131, '2014-02-01 00:48:02.000000', 'consum', 0.0227, 'lps'),
	(529620, 131, '2014-02-01 00:48:03.000000', 'consum', 0.0220, 'lps'),
	(529621, 131, '2014-02-01 00:48:04.000000', 'consum', 0.0226, 'lps'),
	(529622, 131, '2014-02-01 00:48:05.000000', 'consum', 0.0224, 'lps'),
	(529623, 131, '2014-02-01 00:48:06.000000', 'consum', 0.0215, 'lps'),
	(529624, 131, '2014-02-01 00:48:07.000000', 'consum', 0.0227, 'lps'),
	(529625, 131, '2014-02-01 00:48:08.000000', 'consum', 0.0212, 'lps'),
	(529626, 131, '2014-02-01 00:48:09.000000', 'consum', 0.0222, 'lps'),
	(529627, 131, '2014-02-01 00:48:10.000000', 'consum', 0.0212, 'lps'),
	(529628, 131, '2014-02-01 00:48:11.000000', 'consum', 0.0218, 'lps'),
	(529629, 131, '2014-02-01 00:48:12.000000', 'consum', 0.0227, 'lps'),
	(529630, 131, '2014-02-01 00:48:13.000000', 'consum', 0.0217, 'lps'),
	(529631, 131, '2014-02-01 00:48:14.000000', 'consum', 0.0213, 'lps'),
	(529632, 131, '2014-02-01 00:48:15.000000', 'consum', 0.0223, 'lps'),
	(529633, 131, '2014-02-01 00:48:16.000000', 'consum', 0.0211, 'lps'),
	(529634, 131, '2014-02-01 00:48:17.000000', 'consum', 0.0214, 'lps'),
	(529635, 131, '2014-02-01 00:48:18.000000', 'consum', 0.0211, 'lps'),
	(529636, 131, '2014-02-01 00:48:19.000000', 'consum', 0.0221, 'lps'),
	(529637, 131, '2014-02-01 00:48:20.000000', 'consum', 0.0226, 'lps'),
	(529638, 131, '2014-02-01 00:48:21.000000', 'consum', 0.0221, 'lps'),
	(529639, 131, '2014-02-01 00:48:22.000000', 'consum', 0.0217, 'lps'),
	(529640, 131, '2014-02-01 00:48:23.000000', 'consum', 0.0213, 'lps'),
	(529641, 131, '2014-02-01 00:48:24.000000', 'consum', 0.0223, 'lps'),
	(529642, 131, '2014-02-01 00:48:25.000000', 'consum', 0.0212, 'lps'),
	(529643, 131, '2014-02-01 00:48:26.000000', 'consum', 0.0216, 'lps'),
	(529644, 131, '2014-02-01 00:48:27.000000', 'consum', 0.0219, 'lps'),
	(529645, 131, '2014-02-01 00:48:28.000000', 'consum', 0.0220, 'lps'),
	(529646, 131, '2014-02-01 00:48:29.000000', 'consum', 0.0216, 'lps'),
	(529647, 131, '2014-02-01 00:48:30.000000', 'consum', 0.0225, 'lps'),
	(529648, 131, '2014-02-01 00:48:31.000000', 'consum', 0.0217, 'lps'),
	(529649, 131, '2014-02-01 00:48:32.000000', 'consum', 0.0218, 'lps'),
	(529650, 131, '2014-02-01 00:48:33.000000', 'consum', 0.0213, 'lps'),
	(529651, 131, '2014-02-01 00:48:34.000000', 'consum', 0.0216, 'lps'),
	(529652, 131, '2014-02-01 00:48:35.000000', 'consum', 0.0216, 'lps'),
	(529653, 131, '2014-02-01 00:48:36.000000', 'consum', 0.0221, 'lps'),
	(529654, 131, '2014-02-01 00:48:37.000000', 'consum', 0.0214, 'lps'),
	(529655, 131, '2014-02-01 00:48:38.000000', 'consum', 0.0213, 'lps'),
	(529656, 131, '2014-02-01 00:48:39.000000', 'consum', 0.0214, 'lps'),
	(529657, 131, '2014-02-01 00:48:40.000000', 'consum', 0.0220, 'lps'),
	(529658, 131, '2014-02-01 00:48:41.000000', 'consum', 0.0213, 'lps'),
	(529659, 131, '2014-02-01 00:48:42.000000', 'consum', 0.0215, 'lps'),
	(529660, 131, '2014-02-01 00:48:43.000000', 'consum', 0.0210, 'lps'),
	(529661, 131, '2014-02-01 00:48:44.000000', 'consum', 0.0210, 'lps'),
	(529662, 131, '2014-02-01 00:48:45.000000', 'consum', 0.0213, 'lps'),
	(529663, 131, '2014-02-01 00:48:46.000000', 'consum', 0.0226, 'lps'),
	(529664, 131, '2014-02-01 00:48:47.000000', 'consum', 0.0225, 'lps'),
	(529665, 131, '2014-02-01 00:48:48.000000', 'consum', 0.0223, 'lps'),
	(529666, 131, '2014-02-01 00:48:49.000000', 'consum', 0.0210, 'lps'),
	(529667, 131, '2014-02-01 00:48:50.000000', 'consum', 0.0225, 'lps'),
	(529668, 131, '2014-02-01 00:48:51.000000', 'consum', 0.0215, 'lps'),
	(529669, 131, '2014-02-01 00:48:52.000000', 'consum', 0.0227, 'lps'),
	(529670, 131, '2014-02-01 00:48:53.000000', 'consum', 0.0210, 'lps'),
	(529671, 131, '2014-02-01 00:48:54.000000', 'consum', 0.0211, 'lps'),
	(529672, 131, '2014-02-01 00:48:55.000000', 'consum', 0.0215, 'lps'),
	(529673, 131, '2014-02-01 00:48:56.000000', 'consum', 0.0213, 'lps'),
	(529674, 131, '2014-02-01 00:48:57.000000', 'consum', 0.0214, 'lps'),
	(529675, 131, '2014-02-01 00:48:58.000000', 'consum', 0.0220, 'lps'),
	(529676, 131, '2014-02-01 00:48:59.000000', 'consum', 0.0214, 'lps'),
	(529677, 131, '2014-02-01 00:49:00.000000', 'consum', 0.0219, 'lps'),
	(529678, 131, '2014-02-01 00:49:01.000000', 'consum', 0.0224, 'lps'),
	(529679, 131, '2014-02-01 00:49:02.000000', 'consum', 0.0217, 'lps'),
	(529680, 131, '2014-02-01 00:49:03.000000', 'consum', 0.0221, 'lps'),
	(529681, 131, '2014-02-01 00:49:04.000000', 'consum', 0.0210, 'lps'),
	(529682, 131, '2014-02-01 00:49:05.000000', 'consum', 0.0215, 'lps'),
	(529683, 131, '2014-02-01 00:49:06.000000', 'consum', 0.0215, 'lps'),
	(529684, 131, '2014-02-01 00:49:07.000000', 'consum', 0.0222, 'lps'),
	(529685, 131, '2014-02-01 00:49:08.000000', 'consum', 0.0218, 'lps'),
	(529686, 131, '2014-02-01 00:49:09.000000', 'consum', 0.0215, 'lps'),
	(529687, 131, '2014-02-01 00:49:10.000000', 'consum', 0.0211, 'lps'),
	(529688, 131, '2014-02-01 00:49:11.000000', 'consum', 0.0217, 'lps'),
	(529689, 131, '2014-02-01 00:49:12.000000', 'consum', 0.0210, 'lps'),
	(529690, 131, '2014-02-01 00:49:13.000000', 'consum', 0.0223, 'lps'),
	(529691, 131, '2014-02-01 00:49:14.000000', 'consum', 0.0222, 'lps'),
	(529692, 131, '2014-02-01 00:49:15.000000', 'consum', 0.0216, 'lps'),
	(529693, 131, '2014-02-01 00:49:16.000000', 'consum', 0.0219, 'lps'),
	(529694, 131, '2014-02-01 00:49:17.000000', 'consum', 0.0220, 'lps'),
	(529695, 131, '2014-02-01 00:49:18.000000', 'consum', 0.0217, 'lps'),
	(529696, 131, '2014-02-01 00:49:19.000000', 'consum', 0.0213, 'lps'),
	(529697, 131, '2014-02-01 00:49:20.000000', 'consum', 0.0223, 'lps'),
	(529698, 131, '2014-02-01 00:49:21.000000', 'consum', 0.0215, 'lps'),
	(529699, 131, '2014-02-01 00:49:22.000000', 'consum', 0.0212, 'lps'),
	(529700, 131, '2014-02-01 00:49:23.000000', 'consum', 0.0225, 'lps'),
	(529701, 131, '2014-02-01 00:49:24.000000', 'consum', 0.0227, 'lps'),
	(529702, 131, '2014-02-01 00:49:25.000000', 'consum', 0.0213, 'lps'),
	(529703, 131, '2014-02-01 00:49:26.000000', 'consum', 0.0227, 'lps'),
	(529704, 131, '2014-02-01 00:49:27.000000', 'consum', 0.0214, 'lps'),
	(529705, 131, '2014-02-01 00:49:28.000000', 'consum', 0.0216, 'lps'),
	(529706, 131, '2014-02-01 00:49:29.000000', 'consum', 0.0212, 'lps'),
	(529707, 131, '2014-02-01 00:49:30.000000', 'consum', 0.0218, 'lps'),
	(529708, 131, '2014-02-01 00:49:31.000000', 'consum', 0.0226, 'lps'),
	(529709, 131, '2014-02-01 00:49:32.000000', 'consum', 0.0215, 'lps'),
	(529710, 131, '2014-02-01 00:49:33.000000', 'consum', 0.0222, 'lps'),
	(529711, 131, '2014-02-01 00:49:34.000000', 'consum', 0.0221, 'lps'),
	(529712, 131, '2014-02-01 00:49:35.000000', 'consum', 0.0212, 'lps'),
	(529713, 131, '2014-02-01 00:49:36.000000', 'consum', 0.0222, 'lps'),
	(529714, 131, '2014-02-01 00:49:37.000000', 'consum', 0.0212, 'lps'),
	(529715, 131, '2014-02-01 00:49:38.000000', 'consum', 0.0221, 'lps'),
	(529716, 131, '2014-02-01 00:49:39.000000', 'consum', 0.0221, 'lps'),
	(529717, 131, '2014-02-01 00:49:40.000000', 'consum', 0.0216, 'lps'),
	(529718, 131, '2014-02-01 00:49:41.000000', 'consum', 0.0227, 'lps'),
	(529719, 131, '2014-02-01 00:49:42.000000', 'consum', 0.0222, 'lps'),
	(529720, 131, '2014-02-01 00:49:43.000000', 'consum', 0.0218, 'lps'),
	(529721, 131, '2014-02-01 00:49:44.000000', 'consum', 0.0217, 'lps'),
	(529722, 131, '2014-02-01 00:49:45.000000', 'consum', 0.0222, 'lps'),
	(529723, 131, '2014-02-01 00:49:46.000000', 'consum', 0.0213, 'lps'),
	(529724, 131, '2014-02-01 00:49:47.000000', 'consum', 0.0225, 'lps'),
	(529725, 131, '2014-02-01 00:49:48.000000', 'consum', 0.0222, 'lps'),
	(529726, 131, '2014-02-01 00:49:49.000000', 'consum', 0.0225, 'lps'),
	(529727, 131, '2014-02-01 00:49:50.000000', 'consum', 0.0214, 'lps'),
	(529728, 131, '2014-02-01 00:49:51.000000', 'consum', 0.0221, 'lps'),
	(529729, 131, '2014-02-01 00:49:52.000000', 'consum', 0.0219, 'lps'),
	(529730, 131, '2014-02-01 00:49:53.000000', 'consum', 0.0222, 'lps'),
	(529731, 131, '2014-02-01 00:49:54.000000', 'consum', 0.0226, 'lps'),
	(529732, 131, '2014-02-01 00:49:55.000000', 'consum', 0.0217, 'lps'),
	(529733, 131, '2014-02-01 00:49:56.000000', 'consum', 0.0217, 'lps'),
	(529734, 131, '2014-02-01 00:49:57.000000', 'consum', 0.0223, 'lps'),
	(529735, 131, '2014-02-01 00:49:58.000000', 'consum', 0.0220, 'lps'),
	(529736, 131, '2014-02-01 00:49:59.000000', 'consum', 0.0222, 'lps'),
	(529737, 131, '2014-02-01 00:50:00.000000', 'consum', 0.0223, 'lps'),
	(529738, 131, '2014-02-01 00:50:01.000000', 'consum', 0.0219, 'lps'),
	(529739, 131, '2014-02-01 00:50:02.000000', 'consum', 0.0217, 'lps'),
	(529740, 131, '2014-02-01 00:50:03.000000', 'consum', 0.0218, 'lps'),
	(529741, 131, '2014-02-01 00:50:04.000000', 'consum', 0.0213, 'lps'),
	(529742, 131, '2014-02-01 00:50:05.000000', 'consum', 0.0219, 'lps'),
	(529743, 131, '2014-02-01 00:50:06.000000', 'consum', 0.0211, 'lps'),
	(529744, 131, '2014-02-01 00:50:07.000000', 'consum', 0.0223, 'lps'),
	(529745, 131, '2014-02-01 00:50:08.000000', 'consum', 0.0219, 'lps'),
	(529746, 131, '2014-02-01 00:50:09.000000', 'consum', 0.0218, 'lps'),
	(529747, 131, '2014-02-01 00:50:10.000000', 'consum', 0.0224, 'lps'),
	(529748, 131, '2014-02-01 00:50:11.000000', 'consum', 0.0219, 'lps'),
	(529749, 131, '2014-02-01 00:50:12.000000', 'consum', 0.0214, 'lps'),
	(529750, 131, '2014-02-01 00:50:13.000000', 'consum', 0.0220, 'lps'),
	(529751, 131, '2014-02-01 00:50:14.000000', 'consum', 0.0215, 'lps'),
	(529752, 131, '2014-02-01 00:50:15.000000', 'consum', 0.0223, 'lps'),
	(529753, 131, '2014-02-01 00:50:16.000000', 'consum', 0.0226, 'lps'),
	(529754, 131, '2014-02-01 00:50:17.000000', 'consum', 0.0214, 'lps'),
	(529755, 131, '2014-02-01 00:50:18.000000', 'consum', 0.0219, 'lps'),
	(529756, 131, '2014-02-01 00:50:19.000000', 'consum', 0.0225, 'lps'),
	(529757, 131, '2014-02-01 00:50:20.000000', 'consum', 0.0224, 'lps'),
	(529758, 131, '2014-02-01 00:50:21.000000', 'consum', 0.0218, 'lps'),
	(529759, 131, '2014-02-01 00:50:22.000000', 'consum', 0.0227, 'lps'),
	(529760, 131, '2014-02-01 00:50:23.000000', 'consum', 0.0218, 'lps'),
	(529761, 131, '2014-02-01 00:50:24.000000', 'consum', 0.0216, 'lps'),
	(529762, 131, '2014-02-01 00:50:25.000000', 'consum', 0.0218, 'lps'),
	(529763, 131, '2014-02-01 00:50:26.000000', 'consum', 0.0212, 'lps'),
	(529764, 131, '2014-02-01 00:50:27.000000', 'consum', 0.0217, 'lps'),
	(529765, 131, '2014-02-01 00:50:28.000000', 'consum', 0.0221, 'lps'),
	(529766, 131, '2014-02-01 00:50:29.000000', 'consum', 0.0227, 'lps'),
	(529767, 131, '2014-02-01 00:50:30.000000', 'consum', 0.0225, 'lps'),
	(529768, 131, '2014-02-01 00:50:31.000000', 'consum', 0.0218, 'lps'),
	(529769, 131, '2014-02-01 00:50:32.000000', 'consum', 0.0223, 'lps'),
	(529770, 131, '2014-02-01 00:50:33.000000', 'consum', 0.0214, 'lps'),
	(529771, 131, '2014-02-01 00:50:34.000000', 'consum', 0.0212, 'lps'),
	(529772, 131, '2014-02-01 00:50:35.000000', 'consum', 0.0227, 'lps'),
	(529773, 131, '2014-02-01 00:50:36.000000', 'consum', 0.0218, 'lps'),
	(529774, 131, '2014-02-01 00:50:37.000000', 'consum', 0.0217, 'lps'),
	(529775, 131, '2014-02-01 00:50:38.000000', 'consum', 0.0221, 'lps'),
	(529776, 131, '2014-02-01 00:50:39.000000', 'consum', 0.0211, 'lps'),
	(529777, 131, '2014-02-01 00:50:40.000000', 'consum', 0.0215, 'lps'),
	(529778, 131, '2014-02-01 00:50:41.000000', 'consum', 0.0218, 'lps'),
	(529779, 131, '2014-02-01 00:50:42.000000', 'consum', 0.0215, 'lps'),
	(529780, 131, '2014-02-01 00:50:43.000000', 'consum', 0.0214, 'lps'),
	(529781, 131, '2014-02-01 00:50:44.000000', 'consum', 0.0215, 'lps'),
	(529782, 131, '2014-02-01 00:50:45.000000', 'consum', 0.0223, 'lps'),
	(529783, 131, '2014-02-01 00:50:46.000000', 'consum', 0.0223, 'lps'),
	(529784, 131, '2014-02-01 00:50:47.000000', 'consum', 0.0220, 'lps'),
	(529785, 131, '2014-02-01 00:50:48.000000', 'consum', 0.0221, 'lps'),
	(529786, 131, '2014-02-01 00:50:49.000000', 'consum', 0.0218, 'lps'),
	(529787, 131, '2014-02-01 00:50:50.000000', 'consum', 0.0216, 'lps'),
	(529788, 131, '2014-02-01 00:50:51.000000', 'consum', 0.0217, 'lps'),
	(529789, 131, '2014-02-01 00:50:52.000000', 'consum', 0.0227, 'lps'),
	(529790, 131, '2014-02-01 00:50:53.000000', 'consum', 0.0219, 'lps'),
	(529791, 131, '2014-02-01 00:50:54.000000', 'consum', 0.0224, 'lps'),
	(529792, 131, '2014-02-01 00:50:55.000000', 'consum', 0.0216, 'lps'),
	(529793, 131, '2014-02-01 00:50:56.000000', 'consum', 0.0219, 'lps'),
	(529794, 131, '2014-02-01 00:50:57.000000', 'consum', 0.0217, 'lps'),
	(529795, 131, '2014-02-01 00:50:58.000000', 'consum', 0.0221, 'lps'),
	(529796, 131, '2014-02-01 00:50:59.000000', 'consum', 0.0224, 'lps'),
	(529797, 131, '2014-02-01 00:51:00.000000', 'consum', 0.0213, 'lps'),
	(529798, 131, '2014-02-01 00:51:01.000000', 'consum', 0.0219, 'lps'),
	(529799, 131, '2014-02-01 00:51:02.000000', 'consum', 0.0210, 'lps'),
	(529800, 131, '2014-02-01 00:51:03.000000', 'consum', 0.0222, 'lps'),
	(529801, 131, '2014-02-01 00:51:04.000000', 'consum', 0.0214, 'lps'),
	(529802, 131, '2014-02-01 00:51:05.000000', 'consum', 0.0215, 'lps'),
	(529803, 131, '2014-02-01 00:51:06.000000', 'consum', 0.0222, 'lps'),
	(529804, 131, '2014-02-01 00:51:07.000000', 'consum', 0.0219, 'lps'),
	(529805, 131, '2014-02-01 00:51:08.000000', 'consum', 0.0220, 'lps'),
	(529806, 131, '2014-02-01 00:51:09.000000', 'consum', 0.0215, 'lps'),
	(529807, 131, '2014-02-01 00:51:10.000000', 'consum', 0.0226, 'lps'),
	(529808, 131, '2014-02-01 00:51:11.000000', 'consum', 0.0219, 'lps'),
	(529809, 131, '2014-02-01 00:51:12.000000', 'consum', 0.0210, 'lps'),
	(529810, 131, '2014-02-01 00:51:13.000000', 'consum', 0.0217, 'lps'),
	(529811, 131, '2014-02-01 00:51:14.000000', 'consum', 0.0212, 'lps'),
	(529812, 131, '2014-02-01 00:51:15.000000', 'consum', 0.0217, 'lps'),
	(529813, 131, '2014-02-01 00:51:16.000000', 'consum', 0.0222, 'lps'),
	(529814, 131, '2014-02-01 00:51:17.000000', 'consum', 0.0214, 'lps'),
	(529815, 131, '2014-02-01 00:51:18.000000', 'consum', 0.0211, 'lps'),
	(529816, 131, '2014-02-01 00:51:19.000000', 'consum', 0.0220, 'lps'),
	(529817, 131, '2014-02-01 00:51:20.000000', 'consum', 0.0224, 'lps'),
	(529818, 131, '2014-02-01 00:51:21.000000', 'consum', 0.0212, 'lps'),
	(529819, 131, '2014-02-01 00:51:22.000000', 'consum', 0.0217, 'lps'),
	(529820, 131, '2014-02-01 00:51:23.000000', 'consum', 0.0219, 'lps'),
	(529821, 131, '2014-02-01 00:51:24.000000', 'consum', 0.0217, 'lps'),
	(529822, 131, '2014-02-01 00:51:25.000000', 'consum', 0.0217, 'lps'),
	(529823, 131, '2014-02-01 00:51:26.000000', 'consum', 0.0226, 'lps'),
	(529824, 131, '2014-02-01 00:51:27.000000', 'consum', 0.0213, 'lps'),
	(529825, 131, '2014-02-01 00:51:28.000000', 'consum', 0.0217, 'lps'),
	(529826, 131, '2014-02-01 00:51:29.000000', 'consum', 0.0216, 'lps'),
	(529827, 131, '2014-02-01 00:51:30.000000', 'consum', 0.0220, 'lps'),
	(529828, 131, '2014-02-01 00:51:31.000000', 'consum', 0.0225, 'lps'),
	(529829, 131, '2014-02-01 00:51:32.000000', 'consum', 0.0219, 'lps'),
	(529830, 131, '2014-02-01 00:51:33.000000', 'consum', 0.0212, 'lps'),
	(529831, 131, '2014-02-01 00:51:34.000000', 'consum', 0.0212, 'lps'),
	(529832, 131, '2014-02-01 00:51:35.000000', 'consum', 0.0212, 'lps'),
	(529833, 131, '2014-02-01 00:51:36.000000', 'consum', 0.0214, 'lps'),
	(529834, 131, '2014-02-01 00:51:37.000000', 'consum', 0.0226, 'lps'),
	(529835, 131, '2014-02-01 00:51:38.000000', 'consum', 0.0226, 'lps'),
	(529836, 131, '2014-02-01 00:51:39.000000', 'consum', 0.0223, 'lps'),
	(529837, 131, '2014-02-01 00:51:40.000000', 'consum', 0.0227, 'lps'),
	(529838, 131, '2014-02-01 00:51:41.000000', 'consum', 0.0220, 'lps'),
	(529839, 131, '2014-02-01 00:51:42.000000', 'consum', 0.0210, 'lps'),
	(529840, 131, '2014-02-01 00:51:43.000000', 'consum', 0.0217, 'lps'),
	(529841, 131, '2014-02-01 00:51:44.000000', 'consum', 0.0227, 'lps'),
	(529842, 131, '2014-02-01 00:51:45.000000', 'consum', 0.0222, 'lps'),
	(529843, 131, '2014-02-01 00:51:46.000000', 'consum', 0.0218, 'lps'),
	(529844, 131, '2014-02-01 00:51:47.000000', 'consum', 0.0214, 'lps'),
	(529845, 131, '2014-02-01 00:51:48.000000', 'consum', 0.0224, 'lps'),
	(529846, 131, '2014-02-01 00:51:49.000000', 'consum', 0.0215, 'lps'),
	(529847, 131, '2014-02-01 00:51:50.000000', 'consum', 0.0211, 'lps'),
	(529848, 131, '2014-02-01 00:51:51.000000', 'consum', 0.0217, 'lps'),
	(529849, 131, '2014-02-01 00:51:52.000000', 'consum', 0.0210, 'lps'),
	(529850, 131, '2014-02-01 00:51:53.000000', 'consum', 0.0224, 'lps'),
	(529851, 131, '2014-02-01 00:51:54.000000', 'consum', 0.0225, 'lps'),
	(529852, 131, '2014-02-01 00:51:55.000000', 'consum', 0.0210, 'lps'),
	(529853, 131, '2014-02-01 00:51:56.000000', 'consum', 0.0217, 'lps'),
	(529854, 131, '2014-02-01 00:51:57.000000', 'consum', 0.0227, 'lps'),
	(529855, 131, '2014-02-01 00:51:58.000000', 'consum', 0.0224, 'lps'),
	(529856, 131, '2014-02-01 00:51:59.000000', 'consum', 0.0227, 'lps'),
	(529857, 131, '2014-02-01 00:52:00.000000', 'consum', 0.0216, 'lps'),
	(529858, 131, '2014-02-01 00:52:01.000000', 'consum', 0.0227, 'lps'),
	(529859, 131, '2014-02-01 00:52:02.000000', 'consum', 0.0223, 'lps'),
	(529860, 131, '2014-02-01 00:52:03.000000', 'consum', 0.0227, 'lps'),
	(529861, 131, '2014-02-01 00:52:04.000000', 'consum', 0.0219, 'lps'),
	(529862, 131, '2014-02-01 00:52:05.000000', 'consum', 0.0221, 'lps'),
	(529863, 131, '2014-02-01 00:52:06.000000', 'consum', 0.0223, 'lps'),
	(529864, 131, '2014-02-01 00:52:07.000000', 'consum', 0.0223, 'lps'),
	(529865, 131, '2014-02-01 00:52:08.000000', 'consum', 0.0218, 'lps'),
	(529866, 131, '2014-02-01 00:52:09.000000', 'consum', 0.0214, 'lps'),
	(529867, 131, '2014-02-01 00:52:10.000000', 'consum', 0.0222, 'lps'),
	(529868, 131, '2014-02-01 00:52:11.000000', 'consum', 0.0222, 'lps'),
	(529869, 131, '2014-02-01 00:52:12.000000', 'consum', 0.0219, 'lps'),
	(529870, 131, '2014-02-01 00:52:13.000000', 'consum', 0.0219, 'lps'),
	(529871, 131, '2014-02-01 00:52:14.000000', 'consum', 0.0210, 'lps'),
	(529872, 131, '2014-02-01 00:52:15.000000', 'consum', 0.0219, 'lps'),
	(529873, 131, '2014-02-01 00:52:16.000000', 'consum', 0.0222, 'lps'),
	(529874, 131, '2014-02-01 00:52:17.000000', 'consum', 0.0223, 'lps'),
	(529875, 131, '2014-02-01 00:52:18.000000', 'consum', 0.0223, 'lps'),
	(529876, 131, '2014-02-01 00:52:19.000000', 'consum', 0.0218, 'lps'),
	(529877, 131, '2014-02-01 00:52:20.000000', 'consum', 0.0212, 'lps'),
	(529878, 131, '2014-02-01 00:52:21.000000', 'consum', 0.0215, 'lps'),
	(529879, 131, '2014-02-01 00:52:22.000000', 'consum', 0.0210, 'lps'),
	(529880, 131, '2014-02-01 00:52:23.000000', 'consum', 0.0214, 'lps'),
	(529881, 131, '2014-02-01 00:52:24.000000', 'consum', 0.0213, 'lps'),
	(529882, 131, '2014-02-01 00:52:25.000000', 'consum', 0.0213, 'lps'),
	(529883, 131, '2014-02-01 00:52:26.000000', 'consum', 0.0215, 'lps'),
	(529884, 131, '2014-02-01 00:52:27.000000', 'consum', 0.0212, 'lps'),
	(529885, 131, '2014-02-01 00:52:28.000000', 'consum', 0.0221, 'lps'),
	(529886, 131, '2014-02-01 00:52:29.000000', 'consum', 0.0224, 'lps'),
	(529887, 131, '2014-02-01 00:52:30.000000', 'consum', 0.0211, 'lps'),
	(529888, 131, '2014-02-01 00:52:31.000000', 'consum', 0.0212, 'lps'),
	(529889, 131, '2014-02-01 00:52:32.000000', 'consum', 0.0216, 'lps'),
	(529890, 131, '2014-02-01 00:52:33.000000', 'consum', 0.0217, 'lps'),
	(529891, 131, '2014-02-01 00:52:34.000000', 'consum', 0.0211, 'lps'),
	(529892, 131, '2014-02-01 00:52:35.000000', 'consum', 0.0227, 'lps'),
	(529893, 131, '2014-02-01 00:52:36.000000', 'consum', 0.0223, 'lps'),
	(529894, 131, '2014-02-01 00:52:37.000000', 'consum', 0.0222, 'lps'),
	(529895, 131, '2014-02-01 00:52:38.000000', 'consum', 0.0216, 'lps'),
	(529896, 131, '2014-02-01 00:52:39.000000', 'consum', 0.0221, 'lps'),
	(529897, 131, '2014-02-01 00:52:40.000000', 'consum', 0.0213, 'lps'),
	(529898, 131, '2014-02-01 00:52:41.000000', 'consum', 0.0210, 'lps'),
	(529899, 131, '2014-02-01 00:52:42.000000', 'consum', 0.0218, 'lps'),
	(529900, 131, '2014-02-01 00:52:43.000000', 'consum', 0.0217, 'lps'),
	(529901, 131, '2014-02-01 00:52:44.000000', 'consum', 0.0220, 'lps'),
	(529902, 131, '2014-02-01 00:52:45.000000', 'consum', 0.0224, 'lps'),
	(529903, 131, '2014-02-01 00:52:46.000000', 'consum', 0.0211, 'lps'),
	(529904, 131, '2014-02-01 00:52:47.000000', 'consum', 0.0210, 'lps'),
	(529905, 131, '2014-02-01 00:52:48.000000', 'consum', 0.0227, 'lps'),
	(529906, 131, '2014-02-01 00:52:49.000000', 'consum', 0.0221, 'lps'),
	(529907, 131, '2014-02-01 00:52:50.000000', 'consum', 0.0216, 'lps'),
	(529908, 131, '2014-02-01 00:52:51.000000', 'consum', 0.0226, 'lps'),
	(529909, 131, '2014-02-01 00:52:52.000000', 'consum', 0.0217, 'lps'),
	(529910, 131, '2014-02-01 00:52:53.000000', 'consum', 0.0215, 'lps'),
	(529911, 131, '2014-02-01 00:52:54.000000', 'consum', 0.0214, 'lps'),
	(529912, 131, '2014-02-01 00:52:55.000000', 'consum', 0.0218, 'lps'),
	(529913, 131, '2014-02-01 00:52:56.000000', 'consum', 0.0221, 'lps'),
	(529914, 131, '2014-02-01 00:52:57.000000', 'consum', 0.0224, 'lps'),
	(529915, 131, '2014-02-01 00:52:58.000000', 'consum', 0.0226, 'lps'),
	(529916, 131, '2014-02-01 00:52:59.000000', 'consum', 0.0216, 'lps'),
	(529917, 131, '2014-02-01 00:53:00.000000', 'consum', 0.0210, 'lps'),
	(529918, 131, '2014-02-01 00:53:01.000000', 'consum', 0.0210, 'lps'),
	(529919, 131, '2014-02-01 00:53:02.000000', 'consum', 0.0212, 'lps'),
	(529920, 131, '2014-02-01 00:53:03.000000', 'consum', 0.0219, 'lps'),
	(529921, 131, '2014-02-01 00:53:04.000000', 'consum', 0.0215, 'lps'),
	(529922, 131, '2014-02-01 00:53:05.000000', 'consum', 0.0225, 'lps'),
	(529923, 131, '2014-02-01 00:53:06.000000', 'consum', 0.0215, 'lps'),
	(529924, 131, '2014-02-01 00:53:07.000000', 'consum', 0.0227, 'lps'),
	(529925, 131, '2014-02-01 00:53:08.000000', 'consum', 0.0211, 'lps'),
	(529926, 131, '2014-02-01 00:53:09.000000', 'consum', 0.0215, 'lps'),
	(529927, 131, '2014-02-01 00:53:10.000000', 'consum', 0.0218, 'lps'),
	(529928, 131, '2014-02-01 00:53:11.000000', 'consum', 0.0217, 'lps'),
	(529929, 131, '2014-02-01 00:53:12.000000', 'consum', 0.0220, 'lps'),
	(529930, 131, '2014-02-01 00:53:13.000000', 'consum', 0.0220, 'lps'),
	(529931, 131, '2014-02-01 00:53:14.000000', 'consum', 0.0215, 'lps'),
	(529932, 131, '2014-02-01 00:53:15.000000', 'consum', 0.0222, 'lps'),
	(529933, 131, '2014-02-01 00:53:16.000000', 'consum', 0.0220, 'lps'),
	(529934, 131, '2014-02-01 00:53:17.000000', 'consum', 0.0223, 'lps'),
	(529935, 131, '2014-02-01 00:53:18.000000', 'consum', 0.0211, 'lps'),
	(529936, 131, '2014-02-01 00:53:19.000000', 'consum', 0.0214, 'lps'),
	(529937, 131, '2014-02-01 00:53:20.000000', 'consum', 0.0224, 'lps'),
	(529938, 131, '2014-02-01 00:53:21.000000', 'consum', 0.0218, 'lps'),
	(529939, 131, '2014-02-01 00:53:22.000000', 'consum', 0.0224, 'lps'),
	(529940, 131, '2014-02-01 00:53:23.000000', 'consum', 0.0221, 'lps'),
	(529941, 131, '2014-02-01 00:53:24.000000', 'consum', 0.0225, 'lps'),
	(529942, 131, '2014-02-01 00:53:25.000000', 'consum', 0.0216, 'lps'),
	(529943, 131, '2014-02-01 00:53:26.000000', 'consum', 0.0215, 'lps'),
	(529944, 131, '2014-02-01 00:53:27.000000', 'consum', 0.0217, 'lps'),
	(529945, 131, '2014-02-01 00:53:28.000000', 'consum', 0.0212, 'lps'),
	(529946, 131, '2014-02-01 00:53:29.000000', 'consum', 0.0219, 'lps'),
	(529947, 131, '2014-02-01 00:53:30.000000', 'consum', 0.0212, 'lps'),
	(529948, 131, '2014-02-01 00:53:31.000000', 'consum', 0.0212, 'lps'),
	(529949, 131, '2014-02-01 00:53:32.000000', 'consum', 0.0213, 'lps'),
	(529950, 131, '2014-02-01 00:53:33.000000', 'consum', 0.0222, 'lps'),
	(529951, 131, '2014-02-01 00:53:34.000000', 'consum', 0.0226, 'lps'),
	(529952, 131, '2014-02-01 00:53:35.000000', 'consum', 0.0218, 'lps'),
	(529953, 131, '2014-02-01 00:53:36.000000', 'consum', 0.0222, 'lps'),
	(529954, 131, '2014-02-01 00:53:37.000000', 'consum', 0.0226, 'lps'),
	(529955, 131, '2014-02-01 00:53:38.000000', 'consum', 0.0221, 'lps'),
	(529956, 131, '2014-02-01 00:53:39.000000', 'consum', 0.0217, 'lps'),
	(529957, 131, '2014-02-01 00:53:40.000000', 'consum', 0.0214, 'lps'),
	(529958, 131, '2014-02-01 00:53:41.000000', 'consum', 0.0226, 'lps'),
	(529959, 131, '2014-02-01 00:53:42.000000', 'consum', 0.0224, 'lps'),
	(529960, 131, '2014-02-01 00:53:43.000000', 'consum', 0.0215, 'lps'),
	(529961, 131, '2014-02-01 00:53:44.000000', 'consum', 0.0211, 'lps'),
	(529962, 131, '2014-02-01 00:53:45.000000', 'consum', 0.0221, 'lps'),
	(529963, 131, '2014-02-01 00:53:46.000000', 'consum', 0.0223, 'lps'),
	(529964, 131, '2014-02-01 00:53:47.000000', 'consum', 0.0210, 'lps'),
	(529965, 131, '2014-02-01 00:53:48.000000', 'consum', 0.0224, 'lps'),
	(529966, 131, '2014-02-01 00:53:49.000000', 'consum', 0.0227, 'lps'),
	(529967, 131, '2014-02-01 00:53:50.000000', 'consum', 0.0217, 'lps'),
	(529968, 131, '2014-02-01 00:53:51.000000', 'consum', 0.0212, 'lps'),
	(529969, 131, '2014-02-01 00:53:52.000000', 'consum', 0.0218, 'lps'),
	(529970, 131, '2014-02-01 00:53:53.000000', 'consum', 0.0227, 'lps'),
	(529971, 131, '2014-02-01 00:53:54.000000', 'consum', 0.0216, 'lps'),
	(529972, 131, '2014-02-01 00:53:55.000000', 'consum', 0.0210, 'lps'),
	(529973, 131, '2014-02-01 00:53:56.000000', 'consum', 0.0226, 'lps'),
	(529974, 131, '2014-02-01 00:53:57.000000', 'consum', 0.0219, 'lps'),
	(529975, 131, '2014-02-01 00:53:58.000000', 'consum', 0.0224, 'lps'),
	(529976, 131, '2014-02-01 00:53:59.000000', 'consum', 0.0219, 'lps'),
	(529977, 131, '2014-02-01 00:54:00.000000', 'consum', 0.0212, 'lps'),
	(529978, 131, '2014-02-01 00:54:01.000000', 'consum', 0.0214, 'lps'),
	(529979, 131, '2014-02-01 00:54:02.000000', 'consum', 0.0224, 'lps'),
	(529980, 131, '2014-02-01 00:54:03.000000', 'consum', 0.0215, 'lps'),
	(529981, 131, '2014-02-01 00:54:04.000000', 'consum', 0.0212, 'lps'),
	(529982, 131, '2014-02-01 00:54:05.000000', 'consum', 0.0223, 'lps'),
	(529983, 131, '2014-02-01 00:54:06.000000', 'consum', 0.0213, 'lps'),
	(529984, 131, '2014-02-01 00:54:07.000000', 'consum', 0.0225, 'lps'),
	(529985, 131, '2014-02-01 00:54:08.000000', 'consum', 0.0223, 'lps'),
	(529986, 131, '2014-02-01 00:54:09.000000', 'consum', 0.0210, 'lps'),
	(529987, 131, '2014-02-01 00:54:10.000000', 'consum', 0.0225, 'lps'),
	(529988, 131, '2014-02-01 00:54:11.000000', 'consum', 0.0216, 'lps'),
	(529989, 131, '2014-02-01 00:54:12.000000', 'consum', 0.0214, 'lps'),
	(529990, 131, '2014-02-01 00:54:13.000000', 'consum', 0.0210, 'lps'),
	(529991, 131, '2014-02-01 00:54:14.000000', 'consum', 0.0217, 'lps'),
	(529992, 131, '2014-02-01 00:54:15.000000', 'consum', 0.0227, 'lps'),
	(529993, 131, '2014-02-01 00:54:16.000000', 'consum', 0.0222, 'lps'),
	(529994, 131, '2014-02-01 00:54:17.000000', 'consum', 0.0218, 'lps'),
	(529995, 131, '2014-02-01 00:54:18.000000', 'consum', 0.0215, 'lps'),
	(529996, 131, '2014-02-01 00:54:19.000000', 'consum', 0.0214, 'lps'),
	(529997, 131, '2014-02-01 00:54:20.000000', 'consum', 0.0212, 'lps'),
	(529998, 131, '2014-02-01 00:54:21.000000', 'consum', 0.0210, 'lps'),
	(529999, 131, '2014-02-01 00:54:22.000000', 'consum', 0.0222, 'lps'),
	(530000, 131, '2014-02-01 00:54:23.000000', 'consum', 0.0218, 'lps'),
	(530001, 131, '2014-02-01 00:54:24.000000', 'consum', 0.0212, 'lps'),
	(530002, 131, '2014-02-01 00:54:25.000000', 'consum', 0.0216, 'lps'),
	(530003, 131, '2014-02-01 00:54:26.000000', 'consum', 0.0214, 'lps'),
	(530004, 131, '2014-02-01 00:54:27.000000', 'consum', 0.0215, 'lps'),
	(530005, 131, '2014-02-01 00:54:28.000000', 'consum', 0.0221, 'lps'),
	(530006, 131, '2014-02-01 00:54:29.000000', 'consum', 0.0215, 'lps'),
	(530007, 131, '2014-02-01 00:54:30.000000', 'consum', 0.0223, 'lps'),
	(530008, 131, '2014-02-01 00:54:31.000000', 'consum', 0.0222, 'lps'),
	(530009, 131, '2014-02-01 00:54:32.000000', 'consum', 0.0215, 'lps'),
	(530010, 131, '2014-02-01 00:54:33.000000', 'consum', 0.0219, 'lps'),
	(530011, 131, '2014-02-01 00:54:34.000000', 'consum', 0.0221, 'lps'),
	(530012, 131, '2014-02-01 00:54:35.000000', 'consum', 0.0222, 'lps'),
	(530013, 131, '2014-02-01 00:54:36.000000', 'consum', 0.0217, 'lps'),
	(530014, 131, '2014-02-01 00:54:37.000000', 'consum', 0.0211, 'lps'),
	(530015, 131, '2014-02-01 00:54:38.000000', 'consum', 0.0211, 'lps'),
	(530016, 131, '2014-02-01 00:54:39.000000', 'consum', 0.0213, 'lps'),
	(530017, 131, '2014-02-01 00:54:40.000000', 'consum', 0.0224, 'lps'),
	(530018, 131, '2014-02-01 00:54:41.000000', 'consum', 0.0218, 'lps'),
	(530019, 131, '2014-02-01 00:54:42.000000', 'consum', 0.0225, 'lps'),
	(530020, 131, '2014-02-01 00:54:43.000000', 'consum', 0.0225, 'lps'),
	(530021, 131, '2014-02-01 00:54:44.000000', 'consum', 0.0224, 'lps'),
	(530022, 131, '2014-02-01 00:54:45.000000', 'consum', 0.0217, 'lps'),
	(530023, 131, '2014-02-01 00:54:46.000000', 'consum', 0.0222, 'lps'),
	(530024, 131, '2014-02-01 00:54:47.000000', 'consum', 0.0212, 'lps'),
	(530025, 131, '2014-02-01 00:54:48.000000', 'consum', 0.0223, 'lps'),
	(530026, 131, '2014-02-01 00:54:49.000000', 'consum', 0.0213, 'lps'),
	(530027, 131, '2014-02-01 00:54:50.000000', 'consum', 0.0225, 'lps'),
	(530028, 131, '2014-02-01 00:54:51.000000', 'consum', 0.0223, 'lps'),
	(530029, 131, '2014-02-01 00:54:52.000000', 'consum', 0.0211, 'lps'),
	(530030, 131, '2014-02-01 00:54:53.000000', 'consum', 0.0212, 'lps'),
	(530031, 131, '2014-02-01 00:54:54.000000', 'consum', 0.0217, 'lps'),
	(530032, 131, '2014-02-01 00:54:55.000000', 'consum', 0.0222, 'lps'),
	(530033, 131, '2014-02-01 00:54:56.000000', 'consum', 0.0214, 'lps'),
	(530034, 131, '2014-02-01 00:54:57.000000', 'consum', 0.0213, 'lps'),
	(530035, 131, '2014-02-01 00:54:58.000000', 'consum', 0.0214, 'lps'),
	(530036, 131, '2014-02-01 00:54:59.000000', 'consum', 0.0219, 'lps'),
	(530037, 131, '2014-02-01 00:55:00.000000', 'consum', 0.0227, 'lps'),
	(530038, 131, '2014-02-01 00:55:01.000000', 'consum', 0.0215, 'lps'),
	(530039, 131, '2014-02-01 00:55:02.000000', 'consum', 0.0218, 'lps'),
	(530040, 131, '2014-02-01 00:55:03.000000', 'consum', 0.0219, 'lps'),
	(530041, 131, '2014-02-01 00:55:04.000000', 'consum', 0.0212, 'lps'),
	(530042, 131, '2014-02-01 00:55:05.000000', 'consum', 0.0215, 'lps'),
	(530043, 131, '2014-02-01 00:55:06.000000', 'consum', 0.0226, 'lps'),
	(530044, 131, '2014-02-01 00:55:07.000000', 'consum', 0.0222, 'lps'),
	(530045, 131, '2014-02-01 00:55:08.000000', 'consum', 0.0221, 'lps'),
	(530046, 131, '2014-02-01 00:55:09.000000', 'consum', 0.0213, 'lps'),
	(530047, 131, '2014-02-01 00:55:10.000000', 'consum', 0.0210, 'lps'),
	(530048, 131, '2014-02-01 00:55:11.000000', 'consum', 0.0222, 'lps'),
	(530049, 131, '2014-02-01 00:55:12.000000', 'consum', 0.0214, 'lps'),
	(530050, 131, '2014-02-01 00:55:13.000000', 'consum', 0.0214, 'lps'),
	(530051, 131, '2014-02-01 00:55:14.000000', 'consum', 0.0219, 'lps'),
	(530052, 131, '2014-02-01 00:55:15.000000', 'consum', 0.0226, 'lps'),
	(530053, 131, '2014-02-01 00:55:16.000000', 'consum', 0.0225, 'lps'),
	(530054, 131, '2014-02-01 00:55:17.000000', 'consum', 0.0220, 'lps'),
	(530055, 131, '2014-02-01 00:55:18.000000', 'consum', 0.0215, 'lps'),
	(530056, 131, '2014-02-01 00:55:19.000000', 'consum', 0.0226, 'lps'),
	(530057, 131, '2014-02-01 00:55:20.000000', 'consum', 0.0221, 'lps'),
	(530058, 131, '2014-02-01 00:55:21.000000', 'consum', 0.0219, 'lps'),
	(530059, 131, '2014-02-01 00:55:22.000000', 'consum', 0.0219, 'lps'),
	(530060, 131, '2014-02-01 00:55:23.000000', 'consum', 0.0213, 'lps'),
	(530061, 131, '2014-02-01 00:55:24.000000', 'consum', 0.0215, 'lps'),
	(530062, 131, '2014-02-01 00:55:25.000000', 'consum', 0.0226, 'lps'),
	(530063, 131, '2014-02-01 00:55:26.000000', 'consum', 0.0221, 'lps'),
	(530064, 131, '2014-02-01 00:55:27.000000', 'consum', 0.0219, 'lps'),
	(530065, 131, '2014-02-01 00:55:28.000000', 'consum', 0.0222, 'lps'),
	(530066, 131, '2014-02-01 00:55:29.000000', 'consum', 0.0225, 'lps'),
	(530067, 131, '2014-02-01 00:55:30.000000', 'consum', 0.0213, 'lps'),
	(530068, 131, '2014-02-01 00:55:31.000000', 'consum', 0.0219, 'lps'),
	(530069, 131, '2014-02-01 00:55:32.000000', 'consum', 0.0227, 'lps'),
	(530070, 131, '2014-02-01 00:55:33.000000', 'consum', 0.0213, 'lps'),
	(530071, 131, '2014-02-01 00:55:34.000000', 'consum', 0.0213, 'lps'),
	(530072, 131, '2014-02-01 00:55:35.000000', 'consum', 0.0214, 'lps'),
	(530073, 131, '2014-02-01 00:55:36.000000', 'consum', 0.0225, 'lps'),
	(530074, 131, '2014-02-01 00:55:37.000000', 'consum', 0.0216, 'lps'),
	(530075, 131, '2014-02-01 00:55:38.000000', 'consum', 0.0215, 'lps'),
	(530076, 131, '2014-02-01 00:55:39.000000', 'consum', 0.0217, 'lps'),
	(530077, 131, '2014-02-01 00:55:40.000000', 'consum', 0.0211, 'lps'),
	(530078, 131, '2014-02-01 00:55:41.000000', 'consum', 0.0215, 'lps'),
	(530079, 131, '2014-02-01 00:55:42.000000', 'consum', 0.0212, 'lps'),
	(530080, 131, '2014-02-01 00:55:43.000000', 'consum', 0.0224, 'lps'),
	(530081, 131, '2014-02-01 00:55:44.000000', 'consum', 0.0220, 'lps'),
	(530082, 131, '2014-02-01 00:55:45.000000', 'consum', 0.0221, 'lps'),
	(530083, 131, '2014-02-01 00:55:46.000000', 'consum', 0.0216, 'lps'),
	(530084, 131, '2014-02-01 00:55:47.000000', 'consum', 0.0227, 'lps'),
	(530085, 131, '2014-02-01 00:55:48.000000', 'consum', 0.0223, 'lps'),
	(530086, 131, '2014-02-01 00:55:49.000000', 'consum', 0.0223, 'lps'),
	(530087, 131, '2014-02-01 00:55:50.000000', 'consum', 0.0221, 'lps'),
	(530088, 131, '2014-02-01 00:55:51.000000', 'consum', 0.0226, 'lps'),
	(530089, 131, '2014-02-01 00:55:52.000000', 'consum', 0.0221, 'lps'),
	(530090, 131, '2014-02-01 00:55:53.000000', 'consum', 0.0218, 'lps'),
	(530091, 131, '2014-02-01 00:55:54.000000', 'consum', 0.0216, 'lps'),
	(530092, 131, '2014-02-01 00:55:55.000000', 'consum', 0.0218, 'lps'),
	(530093, 131, '2014-02-01 00:55:56.000000', 'consum', 0.0216, 'lps'),
	(530094, 131, '2014-02-01 00:55:57.000000', 'consum', 0.0213, 'lps'),
	(530095, 131, '2014-02-01 00:55:58.000000', 'consum', 0.0210, 'lps'),
	(530096, 131, '2014-02-01 00:55:59.000000', 'consum', 0.0217, 'lps'),
	(530097, 131, '2014-02-01 00:56:00.000000', 'consum', 0.0227, 'lps'),
	(530098, 131, '2014-02-01 00:56:01.000000', 'consum', 0.0224, 'lps'),
	(530099, 131, '2014-02-01 00:56:02.000000', 'consum', 0.0227, 'lps'),
	(530100, 131, '2014-02-01 00:56:03.000000', 'consum', 0.0218, 'lps'),
	(530101, 131, '2014-02-01 00:56:04.000000', 'consum', 0.0218, 'lps'),
	(530102, 131, '2014-02-01 00:56:05.000000', 'consum', 0.0225, 'lps'),
	(530103, 131, '2014-02-01 00:56:06.000000', 'consum', 0.0210, 'lps'),
	(530104, 131, '2014-02-01 00:56:07.000000', 'consum', 0.0217, 'lps'),
	(530105, 131, '2014-02-01 00:56:08.000000', 'consum', 0.0210, 'lps'),
	(530106, 131, '2014-02-01 00:56:09.000000', 'consum', 0.0225, 'lps'),
	(530107, 131, '2014-02-01 00:56:10.000000', 'consum', 0.0215, 'lps'),
	(530108, 131, '2014-02-01 00:56:11.000000', 'consum', 0.0227, 'lps'),
	(530109, 131, '2014-02-01 00:56:12.000000', 'consum', 0.0225, 'lps'),
	(530110, 131, '2014-02-01 00:56:13.000000', 'consum', 0.0216, 'lps'),
	(530111, 131, '2014-02-01 00:56:14.000000', 'consum', 0.0214, 'lps'),
	(530112, 131, '2014-02-01 00:56:15.000000', 'consum', 0.0213, 'lps'),
	(530113, 131, '2014-02-01 00:56:16.000000', 'consum', 0.0213, 'lps'),
	(530114, 131, '2014-02-01 00:56:17.000000', 'consum', 0.0217, 'lps'),
	(530115, 131, '2014-02-01 00:56:18.000000', 'consum', 0.0219, 'lps'),
	(530116, 131, '2014-02-01 00:56:19.000000', 'consum', 0.0217, 'lps'),
	(530117, 131, '2014-02-01 00:56:20.000000', 'consum', 0.0218, 'lps'),
	(530118, 131, '2014-02-01 00:56:21.000000', 'consum', 0.0227, 'lps'),
	(530119, 131, '2014-02-01 00:56:22.000000', 'consum', 0.0221, 'lps'),
	(530120, 131, '2014-02-01 00:56:23.000000', 'consum', 0.0211, 'lps'),
	(530121, 131, '2014-02-01 00:56:24.000000', 'consum', 0.0221, 'lps'),
	(530122, 131, '2014-02-01 00:56:25.000000', 'consum', 0.0227, 'lps'),
	(530123, 131, '2014-02-01 00:56:26.000000', 'consum', 0.0225, 'lps'),
	(530124, 131, '2014-02-01 00:56:27.000000', 'consum', 0.0218, 'lps'),
	(530125, 131, '2014-02-01 00:56:28.000000', 'consum', 0.0225, 'lps'),
	(530126, 131, '2014-02-01 00:56:29.000000', 'consum', 0.0222, 'lps'),
	(530127, 131, '2014-02-01 00:56:30.000000', 'consum', 0.0211, 'lps'),
	(530128, 131, '2014-02-01 00:56:31.000000', 'consum', 0.0214, 'lps'),
	(530129, 131, '2014-02-01 00:56:32.000000', 'consum', 0.0226, 'lps'),
	(530130, 131, '2014-02-01 00:56:33.000000', 'consum', 0.0224, 'lps'),
	(530131, 131, '2014-02-01 00:56:34.000000', 'consum', 0.0217, 'lps'),
	(530132, 131, '2014-02-01 00:56:35.000000', 'consum', 0.0220, 'lps'),
	(530133, 131, '2014-02-01 00:56:36.000000', 'consum', 0.0221, 'lps'),
	(530134, 131, '2014-02-01 00:56:37.000000', 'consum', 0.0220, 'lps'),
	(530135, 131, '2014-02-01 00:56:38.000000', 'consum', 0.0226, 'lps'),
	(530136, 131, '2014-02-01 00:56:39.000000', 'consum', 0.0226, 'lps'),
	(530137, 131, '2014-02-01 00:56:40.000000', 'consum', 0.0225, 'lps'),
	(530138, 131, '2014-02-01 00:56:41.000000', 'consum', 0.0220, 'lps'),
	(530139, 131, '2014-02-01 00:56:42.000000', 'consum', 0.0214, 'lps'),
	(530140, 131, '2014-02-01 00:56:43.000000', 'consum', 0.0219, 'lps'),
	(530141, 131, '2014-02-01 00:56:44.000000', 'consum', 0.0224, 'lps'),
	(530142, 131, '2014-02-01 00:56:45.000000', 'consum', 0.0218, 'lps'),
	(530143, 131, '2014-02-01 00:56:46.000000', 'consum', 0.0226, 'lps'),
	(530144, 131, '2014-02-01 00:56:47.000000', 'consum', 0.0215, 'lps'),
	(530145, 131, '2014-02-01 00:56:48.000000', 'consum', 0.0221, 'lps'),
	(530146, 131, '2014-02-01 00:56:49.000000', 'consum', 0.0215, 'lps'),
	(530147, 131, '2014-02-01 00:56:50.000000', 'consum', 0.0220, 'lps'),
	(530148, 131, '2014-02-01 00:56:51.000000', 'consum', 0.0210, 'lps'),
	(530149, 131, '2014-02-01 00:56:52.000000', 'consum', 0.0215, 'lps'),
	(530150, 131, '2014-02-01 00:56:53.000000', 'consum', 0.0218, 'lps'),
	(530151, 131, '2014-02-01 00:56:54.000000', 'consum', 0.0217, 'lps'),
	(530152, 131, '2014-02-01 00:56:55.000000', 'consum', 0.0224, 'lps'),
	(530153, 131, '2014-02-01 00:56:56.000000', 'consum', 0.0220, 'lps'),
	(530154, 131, '2014-02-01 00:56:57.000000', 'consum', 0.0222, 'lps'),
	(530155, 131, '2014-02-01 00:56:58.000000', 'consum', 0.0221, 'lps'),
	(530156, 131, '2014-02-01 00:56:59.000000', 'consum', 0.0212, 'lps'),
	(530157, 131, '2014-02-01 00:57:00.000000', 'consum', 0.0223, 'lps'),
	(530158, 131, '2014-02-01 00:57:01.000000', 'consum', 0.0214, 'lps'),
	(530159, 131, '2014-02-01 00:57:02.000000', 'consum', 0.0212, 'lps'),
	(530160, 131, '2014-02-01 00:57:03.000000', 'consum', 0.0225, 'lps'),
	(530161, 131, '2014-02-01 00:57:04.000000', 'consum', 0.0226, 'lps'),
	(530162, 131, '2014-02-01 00:57:05.000000', 'consum', 0.0227, 'lps'),
	(530163, 131, '2014-02-01 00:57:06.000000', 'consum', 0.0211, 'lps'),
	(530164, 131, '2014-02-01 00:57:07.000000', 'consum', 0.0221, 'lps'),
	(530165, 131, '2014-02-01 00:57:08.000000', 'consum', 0.0224, 'lps'),
	(530166, 131, '2014-02-01 00:57:09.000000', 'consum', 0.0210, 'lps'),
	(530167, 131, '2014-02-01 00:57:10.000000', 'consum', 0.0225, 'lps'),
	(530168, 131, '2014-02-01 00:57:11.000000', 'consum', 0.0215, 'lps'),
	(530169, 131, '2014-02-01 00:57:12.000000', 'consum', 0.0224, 'lps'),
	(530170, 131, '2014-02-01 00:57:13.000000', 'consum', 0.0211, 'lps'),
	(530171, 131, '2014-02-01 00:57:14.000000', 'consum', 0.0226, 'lps'),
	(530172, 131, '2014-02-01 00:57:15.000000', 'consum', 0.0218, 'lps'),
	(530173, 131, '2014-02-01 00:57:16.000000', 'consum', 0.0221, 'lps'),
	(530174, 131, '2014-02-01 00:57:17.000000', 'consum', 0.0222, 'lps'),
	(530175, 131, '2014-02-01 00:57:18.000000', 'consum', 0.0221, 'lps'),
	(530176, 131, '2014-02-01 00:57:19.000000', 'consum', 0.0213, 'lps'),
	(530177, 131, '2014-02-01 00:57:20.000000', 'consum', 0.0227, 'lps'),
	(530178, 131, '2014-02-01 00:57:21.000000', 'consum', 0.0213, 'lps'),
	(530179, 131, '2014-02-01 00:57:22.000000', 'consum', 0.0211, 'lps'),
	(530180, 131, '2014-02-01 00:57:23.000000', 'consum', 0.0226, 'lps'),
	(530181, 131, '2014-02-01 00:57:24.000000', 'consum', 0.0214, 'lps'),
	(530182, 131, '2014-02-01 00:57:25.000000', 'consum', 0.0219, 'lps'),
	(530183, 131, '2014-02-01 00:57:26.000000', 'consum', 0.0225, 'lps'),
	(530184, 131, '2014-02-01 00:57:27.000000', 'consum', 0.0221, 'lps'),
	(530185, 131, '2014-02-01 00:57:28.000000', 'consum', 0.0222, 'lps'),
	(530186, 131, '2014-02-01 00:57:29.000000', 'consum', 0.0219, 'lps'),
	(530187, 131, '2014-02-01 00:57:30.000000', 'consum', 0.0220, 'lps'),
	(530188, 131, '2014-02-01 00:57:31.000000', 'consum', 0.0213, 'lps'),
	(530189, 131, '2014-02-01 00:57:32.000000', 'consum', 0.0216, 'lps'),
	(530190, 131, '2014-02-01 00:57:33.000000', 'consum', 0.0212, 'lps'),
	(530191, 131, '2014-02-01 00:57:34.000000', 'consum', 0.0223, 'lps'),
	(530192, 131, '2014-02-01 00:57:35.000000', 'consum', 0.0215, 'lps'),
	(530193, 131, '2014-02-01 00:57:36.000000', 'consum', 0.0214, 'lps'),
	(530194, 131, '2014-02-01 00:57:37.000000', 'consum', 0.0216, 'lps'),
	(530195, 131, '2014-02-01 00:57:38.000000', 'consum', 0.0227, 'lps'),
	(530196, 131, '2014-02-01 00:57:39.000000', 'consum', 0.0225, 'lps'),
	(530197, 131, '2014-02-01 00:57:40.000000', 'consum', 0.0218, 'lps'),
	(530198, 131, '2014-02-01 00:57:41.000000', 'consum', 0.0220, 'lps'),
	(530199, 131, '2014-02-01 00:57:42.000000', 'consum', 0.0222, 'lps'),
	(530200, 131, '2014-02-01 00:57:43.000000', 'consum', 0.0221, 'lps'),
	(530201, 131, '2014-02-01 00:57:44.000000', 'consum', 0.0211, 'lps'),
	(530202, 131, '2014-02-01 00:57:45.000000', 'consum', 0.0220, 'lps'),
	(530203, 131, '2014-02-01 00:57:46.000000', 'consum', 0.0223, 'lps'),
	(530204, 131, '2014-02-01 00:57:47.000000', 'consum', 0.0224, 'lps'),
	(530205, 131, '2014-02-01 00:57:48.000000', 'consum', 0.0225, 'lps'),
	(530206, 131, '2014-02-01 00:57:49.000000', 'consum', 0.0226, 'lps'),
	(530207, 131, '2014-02-01 00:57:50.000000', 'consum', 0.0211, 'lps'),
	(530208, 131, '2014-02-01 00:57:51.000000', 'consum', 0.0219, 'lps'),
	(530209, 131, '2014-02-01 00:57:52.000000', 'consum', 0.0219, 'lps'),
	(530210, 131, '2014-02-01 00:57:53.000000', 'consum', 0.0227, 'lps'),
	(530211, 131, '2014-02-01 00:57:54.000000', 'consum', 0.0216, 'lps'),
	(530212, 131, '2014-02-01 00:57:55.000000', 'consum', 0.0223, 'lps'),
	(530213, 131, '2014-02-01 00:57:56.000000', 'consum', 0.0222, 'lps'),
	(530214, 131, '2014-02-01 00:57:57.000000', 'consum', 0.0214, 'lps'),
	(530215, 131, '2014-02-01 00:57:58.000000', 'consum', 0.0214, 'lps'),
	(530216, 131, '2014-02-01 00:57:59.000000', 'consum', 0.0216, 'lps'),
	(530217, 131, '2014-02-01 00:58:00.000000', 'consum', 0.0213, 'lps'),
	(530218, 131, '2014-02-01 00:58:01.000000', 'consum', 0.0225, 'lps'),
	(530219, 131, '2014-02-01 00:58:02.000000', 'consum', 0.0220, 'lps'),
	(530220, 131, '2014-02-01 00:58:03.000000', 'consum', 0.0219, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(530221, 131, '2014-02-01 00:58:04.000000', 'consum', 0.0223, 'lps'),
	(530222, 131, '2014-02-01 00:58:05.000000', 'consum', 0.0212, 'lps'),
	(530223, 131, '2014-02-01 00:58:06.000000', 'consum', 0.0218, 'lps'),
	(530224, 131, '2014-02-01 00:58:07.000000', 'consum', 0.0227, 'lps'),
	(530225, 131, '2014-02-01 00:58:08.000000', 'consum', 0.0215, 'lps'),
	(530226, 131, '2014-02-01 00:58:09.000000', 'consum', 0.0224, 'lps'),
	(530227, 131, '2014-02-01 00:58:10.000000', 'consum', 0.0210, 'lps'),
	(530228, 131, '2014-02-01 00:58:11.000000', 'consum', 0.0221, 'lps'),
	(530229, 131, '2014-02-01 00:58:12.000000', 'consum', 0.0213, 'lps'),
	(530230, 131, '2014-02-01 00:58:13.000000', 'consum', 0.0212, 'lps'),
	(530231, 131, '2014-02-01 00:58:14.000000', 'consum', 0.0211, 'lps'),
	(530232, 131, '2014-02-01 00:58:15.000000', 'consum', 0.0227, 'lps'),
	(530233, 131, '2014-02-01 00:58:16.000000', 'consum', 0.0219, 'lps'),
	(530234, 131, '2014-02-01 00:58:17.000000', 'consum', 0.0222, 'lps'),
	(530235, 131, '2014-02-01 00:58:18.000000', 'consum', 0.0226, 'lps'),
	(530236, 131, '2014-02-01 00:58:19.000000', 'consum', 0.0219, 'lps'),
	(530237, 131, '2014-02-01 00:58:20.000000', 'consum', 0.0224, 'lps'),
	(530238, 131, '2014-02-01 00:58:21.000000', 'consum', 0.0218, 'lps'),
	(530239, 131, '2014-02-01 00:58:22.000000', 'consum', 0.0211, 'lps'),
	(530240, 131, '2014-02-01 00:58:23.000000', 'consum', 0.0224, 'lps'),
	(530241, 131, '2014-02-01 00:58:24.000000', 'consum', 0.0225, 'lps'),
	(530242, 131, '2014-02-01 00:58:25.000000', 'consum', 0.0226, 'lps'),
	(530243, 131, '2014-02-01 00:58:26.000000', 'consum', 0.0226, 'lps'),
	(530244, 131, '2014-02-01 00:58:27.000000', 'consum', 0.0223, 'lps'),
	(530245, 131, '2014-02-01 00:58:28.000000', 'consum', 0.0213, 'lps'),
	(530246, 131, '2014-02-01 00:58:29.000000', 'consum', 0.0221, 'lps'),
	(530247, 131, '2014-02-01 00:58:30.000000', 'consum', 0.0218, 'lps'),
	(530248, 131, '2014-02-01 00:58:31.000000', 'consum', 0.0221, 'lps'),
	(530249, 131, '2014-02-01 00:58:32.000000', 'consum', 0.0224, 'lps'),
	(530250, 131, '2014-02-01 00:58:33.000000', 'consum', 0.0210, 'lps'),
	(530251, 131, '2014-02-01 00:58:34.000000', 'consum', 0.0225, 'lps'),
	(530252, 131, '2014-02-01 00:58:35.000000', 'consum', 0.0210, 'lps'),
	(530253, 131, '2014-02-01 00:58:36.000000', 'consum', 0.0221, 'lps'),
	(530254, 131, '2014-02-01 00:58:37.000000', 'consum', 0.0210, 'lps'),
	(530255, 131, '2014-02-01 00:58:38.000000', 'consum', 0.0215, 'lps'),
	(530256, 131, '2014-02-01 00:58:39.000000', 'consum', 0.0216, 'lps'),
	(530257, 131, '2014-02-01 00:58:40.000000', 'consum', 0.0227, 'lps'),
	(530258, 131, '2014-02-01 00:58:41.000000', 'consum', 0.0221, 'lps'),
	(530259, 131, '2014-02-01 00:58:42.000000', 'consum', 0.0216, 'lps'),
	(530260, 131, '2014-02-01 00:58:43.000000', 'consum', 0.0225, 'lps'),
	(530261, 131, '2014-02-01 00:58:44.000000', 'consum', 0.0215, 'lps'),
	(530262, 131, '2014-02-01 00:58:45.000000', 'consum', 0.0225, 'lps'),
	(530263, 131, '2014-02-01 00:58:46.000000', 'consum', 0.0217, 'lps'),
	(530264, 131, '2014-02-01 00:58:47.000000', 'consum', 0.0220, 'lps'),
	(530265, 131, '2014-02-01 00:58:48.000000', 'consum', 0.0221, 'lps'),
	(530266, 131, '2014-02-01 00:58:49.000000', 'consum', 0.0215, 'lps'),
	(530267, 131, '2014-02-01 00:58:50.000000', 'consum', 0.0223, 'lps'),
	(530268, 131, '2014-02-01 00:58:51.000000', 'consum', 0.0226, 'lps'),
	(530269, 131, '2014-02-01 00:58:52.000000', 'consum', 0.0213, 'lps'),
	(530270, 131, '2014-02-01 00:58:53.000000', 'consum', 0.0215, 'lps'),
	(530271, 131, '2014-02-01 00:58:54.000000', 'consum', 0.0226, 'lps'),
	(530272, 131, '2014-02-01 00:58:55.000000', 'consum', 0.0223, 'lps'),
	(530273, 131, '2014-02-01 00:58:56.000000', 'consum', 0.0227, 'lps'),
	(530274, 131, '2014-02-01 00:58:57.000000', 'consum', 0.0222, 'lps'),
	(530275, 131, '2014-02-01 00:58:58.000000', 'consum', 0.0218, 'lps'),
	(530276, 131, '2014-02-01 00:58:59.000000', 'consum', 0.0214, 'lps'),
	(530277, 131, '2014-02-01 00:59:00.000000', 'consum', 0.0225, 'lps'),
	(530278, 131, '2014-02-01 00:59:01.000000', 'consum', 0.0219, 'lps'),
	(530279, 131, '2014-02-01 00:59:02.000000', 'consum', 0.0213, 'lps'),
	(530280, 131, '2014-02-01 00:59:03.000000', 'consum', 0.0213, 'lps'),
	(530281, 131, '2014-02-01 00:59:04.000000', 'consum', 0.0219, 'lps'),
	(530282, 131, '2014-02-01 00:59:05.000000', 'consum', 0.0211, 'lps'),
	(530283, 131, '2014-02-01 00:59:06.000000', 'consum', 0.0223, 'lps'),
	(530284, 131, '2014-02-01 00:59:07.000000', 'consum', 0.0218, 'lps'),
	(530285, 131, '2014-02-01 00:59:08.000000', 'consum', 0.0213, 'lps'),
	(530286, 131, '2014-02-01 00:59:09.000000', 'consum', 0.0219, 'lps'),
	(530287, 131, '2014-02-01 00:59:10.000000', 'consum', 0.0227, 'lps'),
	(530288, 131, '2014-02-01 00:59:11.000000', 'consum', 0.0217, 'lps'),
	(530289, 131, '2014-02-01 00:59:12.000000', 'consum', 0.0212, 'lps'),
	(530290, 131, '2014-02-01 00:59:13.000000', 'consum', 0.0219, 'lps'),
	(530291, 131, '2014-02-01 00:59:14.000000', 'consum', 0.0211, 'lps'),
	(530292, 131, '2014-02-01 00:59:15.000000', 'consum', 0.0226, 'lps'),
	(530293, 131, '2014-02-01 00:59:16.000000', 'consum', 0.0216, 'lps'),
	(530294, 131, '2014-02-01 00:59:17.000000', 'consum', 0.0210, 'lps'),
	(530295, 131, '2014-02-01 00:59:18.000000', 'consum', 0.0212, 'lps'),
	(530296, 131, '2014-02-01 00:59:19.000000', 'consum', 0.0220, 'lps'),
	(530297, 131, '2014-02-01 00:59:20.000000', 'consum', 0.0218, 'lps'),
	(530298, 131, '2014-02-01 00:59:21.000000', 'consum', 0.0220, 'lps'),
	(530299, 131, '2014-02-01 00:59:22.000000', 'consum', 0.0220, 'lps'),
	(530300, 131, '2014-02-01 00:59:23.000000', 'consum', 0.0213, 'lps'),
	(530301, 131, '2014-02-01 00:59:24.000000', 'consum', 0.0213, 'lps'),
	(530302, 131, '2014-02-01 00:59:25.000000', 'consum', 0.0214, 'lps'),
	(530303, 131, '2014-02-01 00:59:26.000000', 'consum', 0.0223, 'lps'),
	(530304, 131, '2014-02-01 00:59:27.000000', 'consum', 0.0211, 'lps'),
	(530305, 131, '2014-02-01 00:59:28.000000', 'consum', 0.0213, 'lps'),
	(530306, 131, '2014-02-01 00:59:29.000000', 'consum', 0.0223, 'lps'),
	(530307, 131, '2014-02-01 00:59:30.000000', 'consum', 0.0211, 'lps'),
	(530308, 131, '2014-02-01 00:59:31.000000', 'consum', 0.0212, 'lps'),
	(530309, 131, '2014-02-01 00:59:32.000000', 'consum', 0.0216, 'lps'),
	(530310, 131, '2014-02-01 00:59:33.000000', 'consum', 0.0218, 'lps'),
	(530311, 131, '2014-02-01 00:59:34.000000', 'consum', 0.0214, 'lps'),
	(530312, 131, '2014-02-01 00:59:35.000000', 'consum', 0.0223, 'lps'),
	(530313, 131, '2014-02-01 00:59:36.000000', 'consum', 0.0211, 'lps'),
	(530314, 131, '2014-02-01 00:59:37.000000', 'consum', 0.0210, 'lps'),
	(530315, 131, '2014-02-01 00:59:38.000000', 'consum', 0.0211, 'lps'),
	(530316, 131, '2014-02-01 00:59:39.000000', 'consum', 0.0213, 'lps'),
	(530317, 131, '2014-02-01 00:59:40.000000', 'consum', 0.0224, 'lps'),
	(530318, 131, '2014-02-01 00:59:41.000000', 'consum', 0.0215, 'lps'),
	(530319, 131, '2014-02-01 00:59:42.000000', 'consum', 0.0213, 'lps'),
	(530320, 131, '2014-02-01 00:59:43.000000', 'consum', 0.0211, 'lps'),
	(530321, 131, '2014-02-01 00:59:44.000000', 'consum', 0.0222, 'lps'),
	(530322, 131, '2014-02-01 00:59:45.000000', 'consum', 0.0216, 'lps'),
	(530323, 131, '2014-02-01 00:59:46.000000', 'consum', 0.0221, 'lps'),
	(530324, 131, '2014-02-01 00:59:47.000000', 'consum', 0.0211, 'lps'),
	(530325, 131, '2014-02-01 00:59:48.000000', 'consum', 0.0219, 'lps'),
	(530326, 131, '2014-02-01 00:59:49.000000', 'consum', 0.0216, 'lps'),
	(530327, 131, '2014-02-01 00:59:50.000000', 'consum', 0.0216, 'lps'),
	(530328, 131, '2014-02-01 00:59:51.000000', 'consum', 0.0220, 'lps'),
	(530329, 131, '2014-02-01 00:59:52.000000', 'consum', 0.0224, 'lps'),
	(530330, 131, '2014-02-01 00:59:53.000000', 'consum', 0.0214, 'lps'),
	(530331, 131, '2014-02-01 00:59:54.000000', 'consum', 0.0225, 'lps'),
	(530332, 131, '2014-02-01 00:59:55.000000', 'consum', 0.0219, 'lps'),
	(530333, 131, '2014-02-01 00:59:56.000000', 'consum', 0.0210, 'lps'),
	(530334, 131, '2014-02-01 00:59:57.000000', 'consum', 0.0218, 'lps'),
	(530335, 131, '2014-02-01 00:59:58.000000', 'consum', 0.0217, 'lps'),
	(530336, 131, '2014-02-01 00:59:59.000000', 'consum', 0.0220, 'lps'),
	(530337, 131, '2014-02-01 01:00:00.000000', 'consum', 0.0221, 'lps'),
	(530338, 131, '2014-02-01 01:00:01.000000', 'consum', 0.0220, 'lps'),
	(530339, 131, '2014-02-01 01:00:02.000000', 'consum', 0.0225, 'lps'),
	(530340, 131, '2014-02-01 01:00:03.000000', 'consum', 0.0218, 'lps'),
	(530341, 131, '2014-02-01 01:00:04.000000', 'consum', 0.0226, 'lps'),
	(530342, 131, '2014-02-01 01:00:05.000000', 'consum', 0.0214, 'lps'),
	(530343, 131, '2014-02-01 01:00:06.000000', 'consum', 0.0215, 'lps'),
	(530344, 131, '2014-02-01 01:00:07.000000', 'consum', 0.0226, 'lps'),
	(530345, 131, '2014-02-01 01:00:08.000000', 'consum', 0.0219, 'lps'),
	(530346, 131, '2014-02-01 01:00:09.000000', 'consum', 0.0225, 'lps'),
	(530347, 131, '2014-02-01 01:00:10.000000', 'consum', 0.0225, 'lps'),
	(530348, 131, '2014-02-01 01:00:11.000000', 'consum', 0.0223, 'lps'),
	(530349, 131, '2014-02-01 01:00:12.000000', 'consum', 0.0212, 'lps'),
	(530350, 131, '2014-02-01 01:00:13.000000', 'consum', 0.0218, 'lps'),
	(530351, 131, '2014-02-01 01:00:14.000000', 'consum', 0.0227, 'lps'),
	(530352, 131, '2014-02-01 01:00:15.000000', 'consum', 0.0218, 'lps'),
	(530353, 131, '2014-02-01 01:00:16.000000', 'consum', 0.0217, 'lps'),
	(530354, 131, '2014-02-01 01:00:17.000000', 'consum', 0.0220, 'lps'),
	(530355, 131, '2014-02-01 01:00:18.000000', 'consum', 0.0223, 'lps'),
	(530356, 131, '2014-02-01 01:00:19.000000', 'consum', 0.0226, 'lps'),
	(530357, 131, '2014-02-01 01:00:20.000000', 'consum', 0.0217, 'lps'),
	(530358, 131, '2014-02-01 01:00:21.000000', 'consum', 0.0217, 'lps'),
	(530359, 131, '2014-02-01 01:00:22.000000', 'consum', 0.0222, 'lps'),
	(530360, 131, '2014-02-01 01:00:23.000000', 'consum', 0.0213, 'lps'),
	(530361, 131, '2014-02-01 01:00:24.000000', 'consum', 0.0210, 'lps'),
	(530362, 131, '2014-02-01 01:00:25.000000', 'consum', 0.0218, 'lps'),
	(530363, 131, '2014-02-01 01:00:26.000000', 'consum', 0.0216, 'lps'),
	(530364, 131, '2014-02-01 01:00:27.000000', 'consum', 0.0216, 'lps'),
	(530365, 131, '2014-02-01 01:00:28.000000', 'consum', 0.0223, 'lps'),
	(530366, 131, '2014-02-01 01:00:29.000000', 'consum', 0.0222, 'lps'),
	(530367, 131, '2014-02-01 01:00:30.000000', 'consum', 0.0212, 'lps'),
	(530368, 131, '2014-02-01 01:00:31.000000', 'consum', 0.0220, 'lps'),
	(530369, 131, '2014-02-01 01:00:32.000000', 'consum', 0.0220, 'lps'),
	(530370, 131, '2014-02-01 01:00:33.000000', 'consum', 0.0211, 'lps'),
	(530371, 131, '2014-02-01 01:00:34.000000', 'consum', 0.0222, 'lps'),
	(530372, 131, '2014-02-01 01:00:35.000000', 'consum', 0.0213, 'lps'),
	(530373, 131, '2014-02-01 01:00:36.000000', 'consum', 0.0225, 'lps'),
	(530374, 131, '2014-02-01 01:00:37.000000', 'consum', 0.0224, 'lps'),
	(530375, 131, '2014-02-01 01:00:38.000000', 'consum', 0.0216, 'lps'),
	(530376, 131, '2014-02-01 01:00:39.000000', 'consum', 0.0219, 'lps'),
	(530377, 131, '2014-02-01 01:00:40.000000', 'consum', 0.0218, 'lps'),
	(530378, 131, '2014-02-01 01:00:41.000000', 'consum', 0.0226, 'lps'),
	(530379, 131, '2014-02-01 01:00:42.000000', 'consum', 0.0227, 'lps'),
	(530380, 131, '2014-02-01 01:00:43.000000', 'consum', 0.0214, 'lps'),
	(530381, 131, '2014-02-01 01:00:44.000000', 'consum', 0.0214, 'lps'),
	(530382, 131, '2014-02-01 01:00:45.000000', 'consum', 0.0217, 'lps'),
	(530383, 131, '2014-02-01 01:00:46.000000', 'consum', 0.0218, 'lps'),
	(530384, 131, '2014-02-01 01:00:47.000000', 'consum', 0.0211, 'lps'),
	(530385, 131, '2014-02-01 01:00:48.000000', 'consum', 0.0211, 'lps'),
	(530386, 131, '2014-02-01 01:00:49.000000', 'consum', 0.0213, 'lps'),
	(530387, 131, '2014-02-01 01:00:50.000000', 'consum', 0.0222, 'lps'),
	(530388, 131, '2014-02-01 01:00:51.000000', 'consum', 0.0225, 'lps'),
	(530389, 131, '2014-02-01 01:00:52.000000', 'consum', 0.0215, 'lps'),
	(530390, 131, '2014-02-01 01:00:53.000000', 'consum', 0.0227, 'lps'),
	(530391, 131, '2014-02-01 01:00:54.000000', 'consum', 0.0223, 'lps'),
	(530392, 131, '2014-02-01 01:00:55.000000', 'consum', 0.0210, 'lps'),
	(530393, 131, '2014-02-01 01:00:56.000000', 'consum', 0.0225, 'lps'),
	(530394, 131, '2014-02-01 01:00:57.000000', 'consum', 0.0214, 'lps'),
	(530395, 131, '2014-02-01 01:00:58.000000', 'consum', 0.0220, 'lps'),
	(530396, 131, '2014-02-01 01:00:59.000000', 'consum', 0.0213, 'lps'),
	(530397, 131, '2014-02-01 01:01:00.000000', 'consum', 0.0213, 'lps'),
	(530398, 131, '2014-02-01 01:01:01.000000', 'consum', 0.0218, 'lps'),
	(530399, 131, '2014-02-01 01:01:02.000000', 'consum', 0.0222, 'lps'),
	(530400, 131, '2014-02-01 01:01:03.000000', 'consum', 0.0212, 'lps'),
	(530401, 131, '2014-02-01 01:01:04.000000', 'consum', 0.0222, 'lps'),
	(530402, 131, '2014-02-01 01:01:05.000000', 'consum', 0.0225, 'lps'),
	(530403, 131, '2014-02-01 01:01:06.000000', 'consum', 0.0215, 'lps'),
	(530404, 131, '2014-02-01 01:01:07.000000', 'consum', 0.0227, 'lps'),
	(530405, 131, '2014-02-01 01:01:08.000000', 'consum', 0.0226, 'lps'),
	(530406, 131, '2014-02-01 01:01:09.000000', 'consum', 0.0220, 'lps'),
	(530407, 131, '2014-02-01 01:01:10.000000', 'consum', 0.0214, 'lps'),
	(530408, 131, '2014-02-01 01:01:11.000000', 'consum', 0.0220, 'lps'),
	(530409, 131, '2014-02-01 01:01:12.000000', 'consum', 0.0227, 'lps'),
	(530410, 131, '2014-02-01 01:01:13.000000', 'consum', 0.0214, 'lps'),
	(530411, 131, '2014-02-01 01:01:14.000000', 'consum', 0.0216, 'lps'),
	(530412, 131, '2014-02-01 01:01:15.000000', 'consum', 0.0227, 'lps'),
	(530413, 131, '2014-02-01 01:01:16.000000', 'consum', 0.0225, 'lps'),
	(530414, 131, '2014-02-01 01:01:17.000000', 'consum', 0.0215, 'lps'),
	(530415, 131, '2014-02-01 01:01:18.000000', 'consum', 0.0210, 'lps'),
	(530416, 131, '2014-02-01 01:01:19.000000', 'consum', 0.0213, 'lps'),
	(530417, 131, '2014-02-01 01:01:20.000000', 'consum', 0.0224, 'lps'),
	(530418, 131, '2014-02-01 01:01:21.000000', 'consum', 0.0220, 'lps'),
	(530419, 131, '2014-02-01 01:01:22.000000', 'consum', 0.0217, 'lps'),
	(530420, 131, '2014-02-01 01:01:23.000000', 'consum', 0.0218, 'lps'),
	(530421, 131, '2014-02-01 01:01:24.000000', 'consum', 0.0227, 'lps'),
	(530422, 131, '2014-02-01 01:01:25.000000', 'consum', 0.0220, 'lps'),
	(530423, 131, '2014-02-01 01:01:26.000000', 'consum', 0.0224, 'lps'),
	(530424, 131, '2014-02-01 01:01:27.000000', 'consum', 0.0217, 'lps'),
	(530425, 131, '2014-02-01 01:01:28.000000', 'consum', 0.0219, 'lps'),
	(530426, 131, '2014-02-01 01:01:29.000000', 'consum', 0.0217, 'lps'),
	(530427, 131, '2014-02-01 01:01:30.000000', 'consum', 0.0221, 'lps'),
	(530428, 131, '2014-02-01 01:01:31.000000', 'consum', 0.0225, 'lps'),
	(530429, 131, '2014-02-01 01:01:32.000000', 'consum', 0.0217, 'lps'),
	(530430, 131, '2014-02-01 01:01:33.000000', 'consum', 0.0220, 'lps'),
	(530431, 131, '2014-02-01 01:01:34.000000', 'consum', 0.0221, 'lps'),
	(530432, 131, '2014-02-01 01:01:35.000000', 'consum', 0.0217, 'lps'),
	(530433, 131, '2014-02-01 01:01:36.000000', 'consum', 0.0213, 'lps'),
	(530434, 131, '2014-02-01 01:01:37.000000', 'consum', 0.0222, 'lps'),
	(530435, 131, '2014-02-01 01:01:38.000000', 'consum', 0.0226, 'lps'),
	(530436, 131, '2014-02-01 01:01:39.000000', 'consum', 0.0218, 'lps'),
	(530437, 131, '2014-02-01 01:01:40.000000', 'consum', 0.0223, 'lps'),
	(530438, 131, '2014-02-01 01:01:41.000000', 'consum', 0.0212, 'lps'),
	(530439, 131, '2014-02-01 01:01:42.000000', 'consum', 0.0220, 'lps'),
	(530440, 131, '2014-02-01 01:01:43.000000', 'consum', 0.0217, 'lps'),
	(530441, 131, '2014-02-01 01:01:44.000000', 'consum', 0.0214, 'lps'),
	(530442, 131, '2014-02-01 01:01:45.000000', 'consum', 0.0212, 'lps'),
	(530443, 131, '2014-02-01 01:01:46.000000', 'consum', 0.0227, 'lps'),
	(530444, 131, '2014-02-01 01:01:47.000000', 'consum', 0.0217, 'lps'),
	(530445, 131, '2014-02-01 01:01:48.000000', 'consum', 0.0214, 'lps'),
	(530446, 131, '2014-02-01 01:01:49.000000', 'consum', 0.0227, 'lps'),
	(530447, 131, '2014-02-01 01:01:50.000000', 'consum', 0.0212, 'lps'),
	(530448, 131, '2014-02-01 01:01:51.000000', 'consum', 0.0222, 'lps'),
	(530449, 131, '2014-02-01 01:01:52.000000', 'consum', 0.0213, 'lps'),
	(530450, 131, '2014-02-01 01:01:53.000000', 'consum', 0.0225, 'lps'),
	(530451, 131, '2014-02-01 01:01:54.000000', 'consum', 0.0222, 'lps'),
	(530452, 131, '2014-02-01 01:01:55.000000', 'consum', 0.0225, 'lps'),
	(530453, 131, '2014-02-01 01:01:56.000000', 'consum', 0.0212, 'lps'),
	(530454, 131, '2014-02-01 01:01:57.000000', 'consum', 0.0212, 'lps'),
	(530455, 131, '2014-02-01 01:01:58.000000', 'consum', 0.0215, 'lps'),
	(530456, 131, '2014-02-01 01:01:59.000000', 'consum', 0.0213, 'lps'),
	(530457, 131, '2014-02-01 01:02:00.000000', 'consum', 0.0226, 'lps'),
	(530458, 131, '2014-02-01 01:02:01.000000', 'consum', 0.0210, 'lps'),
	(530459, 131, '2014-02-01 01:02:02.000000', 'consum', 0.0215, 'lps'),
	(530460, 131, '2014-02-01 01:02:03.000000', 'consum', 0.0218, 'lps'),
	(530461, 131, '2014-02-01 01:02:04.000000', 'consum', 0.0218, 'lps'),
	(530462, 131, '2014-02-01 01:02:05.000000', 'consum', 0.0225, 'lps'),
	(530463, 131, '2014-02-01 01:02:06.000000', 'consum', 0.0210, 'lps'),
	(530464, 131, '2014-02-01 01:02:07.000000', 'consum', 0.0217, 'lps'),
	(530465, 131, '2014-02-01 01:02:08.000000', 'consum', 0.0210, 'lps'),
	(530466, 131, '2014-02-01 01:02:09.000000', 'consum', 0.0224, 'lps'),
	(530467, 131, '2014-02-01 01:02:10.000000', 'consum', 0.0212, 'lps'),
	(530468, 131, '2014-02-01 01:02:11.000000', 'consum', 0.0211, 'lps'),
	(530469, 131, '2014-02-01 01:02:12.000000', 'consum', 0.0213, 'lps'),
	(530470, 131, '2014-02-01 01:02:13.000000', 'consum', 0.0219, 'lps'),
	(530471, 131, '2014-02-01 01:02:14.000000', 'consum', 0.0212, 'lps'),
	(530472, 131, '2014-02-01 01:02:15.000000', 'consum', 0.0213, 'lps'),
	(530473, 131, '2014-02-01 01:02:16.000000', 'consum', 0.0217, 'lps'),
	(530474, 131, '2014-02-01 01:02:17.000000', 'consum', 0.0220, 'lps'),
	(530475, 131, '2014-02-01 01:02:18.000000', 'consum', 0.0221, 'lps'),
	(530476, 131, '2014-02-01 01:02:19.000000', 'consum', 0.0217, 'lps'),
	(530477, 131, '2014-02-01 01:02:20.000000', 'consum', 0.0214, 'lps'),
	(530478, 131, '2014-02-01 01:02:21.000000', 'consum', 0.0227, 'lps'),
	(530479, 131, '2014-02-01 01:02:22.000000', 'consum', 0.0213, 'lps'),
	(530480, 131, '2014-02-01 01:02:23.000000', 'consum', 0.0211, 'lps'),
	(530481, 131, '2014-02-01 01:02:24.000000', 'consum', 0.0223, 'lps'),
	(530482, 131, '2014-02-01 01:02:25.000000', 'consum', 0.0217, 'lps'),
	(530483, 131, '2014-02-01 01:02:26.000000', 'consum', 0.0227, 'lps'),
	(530484, 131, '2014-02-01 01:02:27.000000', 'consum', 0.0220, 'lps'),
	(530485, 131, '2014-02-01 01:02:28.000000', 'consum', 0.0225, 'lps'),
	(530486, 131, '2014-02-01 01:02:29.000000', 'consum', 0.0222, 'lps'),
	(530487, 131, '2014-02-01 01:02:30.000000', 'consum', 0.0225, 'lps'),
	(530488, 131, '2014-02-01 01:02:31.000000', 'consum', 0.0215, 'lps'),
	(530489, 131, '2014-02-01 01:02:32.000000', 'consum', 0.0227, 'lps'),
	(530490, 131, '2014-02-01 01:02:33.000000', 'consum', 0.0227, 'lps'),
	(530491, 131, '2014-02-01 01:02:34.000000', 'consum', 0.0226, 'lps'),
	(530492, 131, '2014-02-01 01:02:35.000000', 'consum', 0.0219, 'lps'),
	(530493, 131, '2014-02-01 01:02:36.000000', 'consum', 0.0211, 'lps'),
	(530494, 131, '2014-02-01 01:02:37.000000', 'consum', 0.0223, 'lps'),
	(530495, 131, '2014-02-01 01:02:38.000000', 'consum', 0.0217, 'lps'),
	(530496, 131, '2014-02-01 01:02:39.000000', 'consum', 0.0225, 'lps'),
	(530497, 131, '2014-02-01 01:02:40.000000', 'consum', 0.0212, 'lps'),
	(530498, 131, '2014-02-01 01:02:41.000000', 'consum', 0.0213, 'lps'),
	(530499, 131, '2014-02-01 01:02:42.000000', 'consum', 0.0216, 'lps'),
	(530500, 131, '2014-02-01 01:02:43.000000', 'consum', 0.0216, 'lps'),
	(530501, 131, '2014-02-01 01:02:44.000000', 'consum', 0.0223, 'lps'),
	(530502, 131, '2014-02-01 01:02:45.000000', 'consum', 0.0221, 'lps'),
	(530503, 131, '2014-02-01 01:02:46.000000', 'consum', 0.0226, 'lps'),
	(530504, 131, '2014-02-01 01:02:47.000000', 'consum', 0.0222, 'lps'),
	(530505, 131, '2014-02-01 01:02:48.000000', 'consum', 0.0223, 'lps'),
	(530506, 131, '2014-02-01 01:02:49.000000', 'consum', 0.0222, 'lps'),
	(530507, 131, '2014-02-01 01:02:50.000000', 'consum', 0.0215, 'lps'),
	(530508, 131, '2014-02-01 01:02:51.000000', 'consum', 0.0215, 'lps'),
	(530509, 131, '2014-02-01 01:02:52.000000', 'consum', 0.0220, 'lps'),
	(530510, 131, '2014-02-01 01:02:53.000000', 'consum', 0.0227, 'lps'),
	(530511, 131, '2014-02-01 01:02:54.000000', 'consum', 0.0213, 'lps'),
	(530512, 131, '2014-02-01 01:02:55.000000', 'consum', 0.0211, 'lps'),
	(530513, 131, '2014-02-01 01:02:56.000000', 'consum', 0.0223, 'lps'),
	(530514, 131, '2014-02-01 01:02:57.000000', 'consum', 0.0220, 'lps'),
	(530515, 131, '2014-02-01 01:02:58.000000', 'consum', 0.0222, 'lps'),
	(530516, 131, '2014-02-01 01:02:59.000000', 'consum', 0.0223, 'lps'),
	(530517, 131, '2014-02-01 01:03:00.000000', 'consum', 0.0220, 'lps'),
	(530518, 131, '2014-02-01 01:03:01.000000', 'consum', 0.0223, 'lps'),
	(530519, 131, '2014-02-01 01:03:02.000000', 'consum', 0.0210, 'lps'),
	(530520, 131, '2014-02-01 01:03:03.000000', 'consum', 0.0224, 'lps'),
	(530521, 131, '2014-02-01 01:03:04.000000', 'consum', 0.0226, 'lps'),
	(530522, 131, '2014-02-01 01:03:05.000000', 'consum', 0.0213, 'lps'),
	(530523, 131, '2014-02-01 01:03:06.000000', 'consum', 0.0213, 'lps'),
	(530524, 131, '2014-02-01 01:03:07.000000', 'consum', 0.0215, 'lps'),
	(530525, 131, '2014-02-01 01:03:08.000000', 'consum', 0.0210, 'lps'),
	(530526, 131, '2014-02-01 01:03:09.000000', 'consum', 0.0213, 'lps'),
	(530527, 131, '2014-02-01 01:03:10.000000', 'consum', 0.0227, 'lps'),
	(530528, 131, '2014-02-01 01:03:11.000000', 'consum', 0.0214, 'lps'),
	(530529, 131, '2014-02-01 01:03:12.000000', 'consum', 0.0213, 'lps'),
	(530530, 131, '2014-02-01 01:03:13.000000', 'consum', 0.0216, 'lps'),
	(530531, 131, '2014-02-01 01:03:14.000000', 'consum', 0.0214, 'lps'),
	(530532, 131, '2014-02-01 01:03:15.000000', 'consum', 0.0213, 'lps'),
	(530533, 131, '2014-02-01 01:03:16.000000', 'consum', 0.0213, 'lps'),
	(530534, 131, '2014-02-01 01:03:17.000000', 'consum', 0.0216, 'lps'),
	(530535, 131, '2014-02-01 01:03:18.000000', 'consum', 0.0215, 'lps'),
	(530536, 131, '2014-02-01 01:03:19.000000', 'consum', 0.0218, 'lps'),
	(530537, 131, '2014-02-01 01:03:20.000000', 'consum', 0.0218, 'lps'),
	(530538, 131, '2014-02-01 01:03:21.000000', 'consum', 0.0226, 'lps'),
	(530539, 131, '2014-02-01 01:03:22.000000', 'consum', 0.0214, 'lps'),
	(530540, 131, '2014-02-01 01:03:23.000000', 'consum', 0.0217, 'lps'),
	(530541, 131, '2014-02-01 01:03:24.000000', 'consum', 0.0214, 'lps'),
	(530542, 131, '2014-02-01 01:03:25.000000', 'consum', 0.0227, 'lps'),
	(530543, 131, '2014-02-01 01:03:26.000000', 'consum', 0.0213, 'lps'),
	(530544, 131, '2014-02-01 01:03:27.000000', 'consum', 0.0227, 'lps'),
	(530545, 131, '2014-02-01 01:03:28.000000', 'consum', 0.0214, 'lps'),
	(530546, 131, '2014-02-01 01:03:29.000000', 'consum', 0.0215, 'lps'),
	(530547, 131, '2014-02-01 01:03:30.000000', 'consum', 0.0225, 'lps'),
	(530548, 131, '2014-02-01 01:03:31.000000', 'consum', 0.0218, 'lps'),
	(530549, 131, '2014-02-01 01:03:32.000000', 'consum', 0.0222, 'lps'),
	(530550, 131, '2014-02-01 01:03:33.000000', 'consum', 0.0211, 'lps'),
	(530551, 131, '2014-02-01 01:03:34.000000', 'consum', 0.0216, 'lps'),
	(530552, 131, '2014-02-01 01:03:35.000000', 'consum', 0.0219, 'lps'),
	(530553, 131, '2014-02-01 01:03:36.000000', 'consum', 0.0218, 'lps'),
	(530554, 131, '2014-02-01 01:03:37.000000', 'consum', 0.0223, 'lps'),
	(530555, 131, '2014-02-01 01:03:38.000000', 'consum', 0.0219, 'lps'),
	(530556, 131, '2014-02-01 01:03:39.000000', 'consum', 0.0213, 'lps'),
	(530557, 131, '2014-02-01 01:03:40.000000', 'consum', 0.0217, 'lps'),
	(530558, 131, '2014-02-01 01:03:41.000000', 'consum', 0.0217, 'lps'),
	(530559, 131, '2014-02-01 01:03:42.000000', 'consum', 0.0227, 'lps'),
	(530560, 131, '2014-02-01 01:03:43.000000', 'consum', 0.0222, 'lps'),
	(530561, 131, '2014-02-01 01:03:44.000000', 'consum', 0.0216, 'lps'),
	(530562, 131, '2014-02-01 01:03:45.000000', 'consum', 0.0224, 'lps'),
	(530563, 131, '2014-02-01 01:03:46.000000', 'consum', 0.0225, 'lps'),
	(530564, 131, '2014-02-01 01:03:47.000000', 'consum', 0.0210, 'lps'),
	(530565, 131, '2014-02-01 01:03:48.000000', 'consum', 0.0216, 'lps'),
	(530566, 131, '2014-02-01 01:03:49.000000', 'consum', 0.0226, 'lps'),
	(530567, 131, '2014-02-01 01:03:50.000000', 'consum', 0.0218, 'lps'),
	(530568, 131, '2014-02-01 01:03:51.000000', 'consum', 0.0218, 'lps'),
	(530569, 131, '2014-02-01 01:03:52.000000', 'consum', 0.0210, 'lps'),
	(530570, 131, '2014-02-01 01:03:53.000000', 'consum', 0.0224, 'lps'),
	(530571, 131, '2014-02-01 01:03:54.000000', 'consum', 0.0226, 'lps'),
	(530572, 131, '2014-02-01 01:03:55.000000', 'consum', 0.0212, 'lps'),
	(530573, 131, '2014-02-01 01:03:56.000000', 'consum', 0.0227, 'lps'),
	(530574, 131, '2014-02-01 01:03:57.000000', 'consum', 0.0217, 'lps'),
	(530575, 131, '2014-02-01 01:03:58.000000', 'consum', 0.0212, 'lps'),
	(530576, 131, '2014-02-01 01:03:59.000000', 'consum', 0.0219, 'lps'),
	(530577, 131, '2014-02-01 01:04:00.000000', 'consum', 0.0214, 'lps'),
	(530578, 131, '2014-02-01 01:04:01.000000', 'consum', 0.0219, 'lps'),
	(530579, 131, '2014-02-01 01:04:02.000000', 'consum', 0.0210, 'lps'),
	(530580, 131, '2014-02-01 01:04:03.000000', 'consum', 0.0217, 'lps'),
	(530581, 131, '2014-02-01 01:04:04.000000', 'consum', 0.0210, 'lps'),
	(530582, 131, '2014-02-01 01:04:05.000000', 'consum', 0.0210, 'lps'),
	(530583, 131, '2014-02-01 01:04:06.000000', 'consum', 0.0225, 'lps'),
	(530584, 131, '2014-02-01 01:04:07.000000', 'consum', 0.0217, 'lps'),
	(530585, 131, '2014-02-01 01:04:08.000000', 'consum', 0.0217, 'lps'),
	(530586, 131, '2014-02-01 01:04:09.000000', 'consum', 0.0224, 'lps'),
	(530587, 131, '2014-02-01 01:04:10.000000', 'consum', 0.0223, 'lps'),
	(530588, 131, '2014-02-01 01:04:11.000000', 'consum', 0.0216, 'lps'),
	(530589, 131, '2014-02-01 01:04:12.000000', 'consum', 0.0219, 'lps'),
	(530590, 131, '2014-02-01 01:04:13.000000', 'consum', 0.0221, 'lps'),
	(530591, 131, '2014-02-01 01:04:14.000000', 'consum', 0.0221, 'lps'),
	(530592, 131, '2014-02-01 01:04:15.000000', 'consum', 0.0214, 'lps'),
	(530593, 131, '2014-02-01 01:04:16.000000', 'consum', 0.0217, 'lps'),
	(530594, 131, '2014-02-01 01:04:17.000000', 'consum', 0.0215, 'lps'),
	(530595, 131, '2014-02-01 01:04:18.000000', 'consum', 0.0214, 'lps'),
	(530596, 131, '2014-02-01 01:04:19.000000', 'consum', 0.0214, 'lps'),
	(530597, 131, '2014-02-01 01:04:20.000000', 'consum', 0.0219, 'lps'),
	(530598, 131, '2014-02-01 01:04:21.000000', 'consum', 0.0227, 'lps'),
	(530599, 131, '2014-02-01 01:04:22.000000', 'consum', 0.0213, 'lps'),
	(530600, 131, '2014-02-01 01:04:23.000000', 'consum', 0.0212, 'lps'),
	(530601, 131, '2014-02-01 01:04:24.000000', 'consum', 0.0213, 'lps'),
	(530602, 131, '2014-02-01 01:04:25.000000', 'consum', 0.0216, 'lps'),
	(530603, 131, '2014-02-01 01:04:26.000000', 'consum', 0.0216, 'lps'),
	(530604, 131, '2014-02-01 01:04:27.000000', 'consum', 0.0222, 'lps'),
	(530605, 131, '2014-02-01 01:04:28.000000', 'consum', 0.0218, 'lps'),
	(530606, 131, '2014-02-01 01:04:29.000000', 'consum', 0.0212, 'lps'),
	(530607, 131, '2014-02-01 01:04:30.000000', 'consum', 0.0217, 'lps'),
	(530608, 131, '2014-02-01 01:04:31.000000', 'consum', 0.0221, 'lps'),
	(530609, 131, '2014-02-01 01:04:32.000000', 'consum', 0.0226, 'lps'),
	(530610, 131, '2014-02-01 01:04:33.000000', 'consum', 0.0222, 'lps'),
	(530611, 131, '2014-02-01 01:04:34.000000', 'consum', 0.0224, 'lps'),
	(530612, 131, '2014-02-01 01:04:35.000000', 'consum', 0.0225, 'lps'),
	(530613, 131, '2014-02-01 01:04:36.000000', 'consum', 0.0226, 'lps'),
	(530614, 131, '2014-02-01 01:04:37.000000', 'consum', 0.0225, 'lps'),
	(530615, 131, '2014-02-01 01:04:38.000000', 'consum', 0.0223, 'lps'),
	(530616, 131, '2014-02-01 01:04:39.000000', 'consum', 0.0227, 'lps'),
	(530617, 131, '2014-02-01 01:04:40.000000', 'consum', 0.0224, 'lps'),
	(530618, 131, '2014-02-01 01:04:41.000000', 'consum', 0.0227, 'lps'),
	(530619, 131, '2014-02-01 01:04:42.000000', 'consum', 0.0217, 'lps'),
	(530620, 131, '2014-02-01 01:04:43.000000', 'consum', 0.0212, 'lps'),
	(530621, 131, '2014-02-01 01:04:44.000000', 'consum', 0.0217, 'lps'),
	(530622, 131, '2014-02-01 01:04:45.000000', 'consum', 0.0222, 'lps'),
	(530623, 131, '2014-02-01 01:04:46.000000', 'consum', 0.0214, 'lps'),
	(530624, 131, '2014-02-01 01:04:47.000000', 'consum', 0.0213, 'lps'),
	(530625, 131, '2014-02-01 01:04:48.000000', 'consum', 0.0215, 'lps'),
	(530626, 131, '2014-02-01 01:04:49.000000', 'consum', 0.0224, 'lps'),
	(530627, 131, '2014-02-01 01:04:50.000000', 'consum', 0.0211, 'lps'),
	(530628, 131, '2014-02-01 01:04:51.000000', 'consum', 0.0210, 'lps'),
	(530629, 131, '2014-02-01 01:04:52.000000', 'consum', 0.0225, 'lps'),
	(530630, 131, '2014-02-01 01:04:53.000000', 'consum', 0.0214, 'lps'),
	(530631, 131, '2014-02-01 01:04:54.000000', 'consum', 0.0223, 'lps'),
	(530632, 131, '2014-02-01 01:04:55.000000', 'consum', 0.0225, 'lps'),
	(530633, 131, '2014-02-01 01:04:56.000000', 'consum', 0.0213, 'lps'),
	(530634, 131, '2014-02-01 01:04:57.000000', 'consum', 0.0214, 'lps'),
	(530635, 131, '2014-02-01 01:04:58.000000', 'consum', 0.0224, 'lps'),
	(530636, 131, '2014-02-01 01:04:59.000000', 'consum', 0.0212, 'lps'),
	(530637, 131, '2014-02-01 01:05:00.000000', 'consum', 0.0217, 'lps'),
	(530638, 131, '2014-02-01 01:05:01.000000', 'consum', 0.0221, 'lps'),
	(530639, 131, '2014-02-01 01:05:02.000000', 'consum', 0.0226, 'lps'),
	(530640, 131, '2014-02-01 01:05:03.000000', 'consum', 0.0221, 'lps'),
	(530641, 131, '2014-02-01 01:05:04.000000', 'consum', 0.0217, 'lps'),
	(530642, 131, '2014-02-01 01:05:05.000000', 'consum', 0.0212, 'lps'),
	(530643, 131, '2014-02-01 01:05:06.000000', 'consum', 0.0220, 'lps'),
	(530644, 131, '2014-02-01 01:05:07.000000', 'consum', 0.0219, 'lps'),
	(530645, 131, '2014-02-01 01:05:08.000000', 'consum', 0.0224, 'lps'),
	(530646, 131, '2014-02-01 01:05:09.000000', 'consum', 0.0218, 'lps'),
	(530647, 131, '2014-02-01 01:05:10.000000', 'consum', 0.0225, 'lps'),
	(530648, 131, '2014-02-01 01:05:11.000000', 'consum', 0.0227, 'lps'),
	(530649, 131, '2014-02-01 01:05:12.000000', 'consum', 0.0214, 'lps'),
	(530650, 131, '2014-02-01 01:05:13.000000', 'consum', 0.0214, 'lps'),
	(530651, 131, '2014-02-01 01:05:14.000000', 'consum', 0.0219, 'lps'),
	(530652, 131, '2014-02-01 01:05:15.000000', 'consum', 0.0226, 'lps'),
	(530653, 131, '2014-02-01 01:05:16.000000', 'consum', 0.0226, 'lps'),
	(530654, 131, '2014-02-01 01:05:17.000000', 'consum', 0.0225, 'lps'),
	(530655, 131, '2014-02-01 01:05:18.000000', 'consum', 0.0219, 'lps'),
	(530656, 131, '2014-02-01 01:05:19.000000', 'consum', 0.0211, 'lps'),
	(530657, 131, '2014-02-01 01:05:20.000000', 'consum', 0.0225, 'lps'),
	(530658, 131, '2014-02-01 01:05:21.000000', 'consum', 0.0210, 'lps'),
	(530659, 131, '2014-02-01 01:05:22.000000', 'consum', 0.0221, 'lps'),
	(530660, 131, '2014-02-01 01:05:23.000000', 'consum', 0.0227, 'lps'),
	(530661, 131, '2014-02-01 01:05:24.000000', 'consum', 0.0211, 'lps'),
	(530662, 131, '2014-02-01 01:05:25.000000', 'consum', 0.0218, 'lps'),
	(530663, 131, '2014-02-01 01:05:26.000000', 'consum', 0.0211, 'lps'),
	(530664, 131, '2014-02-01 01:05:27.000000', 'consum', 0.0210, 'lps'),
	(530665, 131, '2014-02-01 01:05:28.000000', 'consum', 0.0226, 'lps'),
	(530666, 131, '2014-02-01 01:05:29.000000', 'consum', 0.0220, 'lps'),
	(530667, 131, '2014-02-01 01:05:30.000000', 'consum', 0.0227, 'lps'),
	(530668, 131, '2014-02-01 01:05:31.000000', 'consum', 0.0214, 'lps'),
	(530669, 131, '2014-02-01 01:05:32.000000', 'consum', 0.0215, 'lps'),
	(530670, 131, '2014-02-01 01:05:33.000000', 'consum', 0.0225, 'lps'),
	(530671, 131, '2014-02-01 01:05:34.000000', 'consum', 0.0215, 'lps'),
	(530672, 131, '2014-02-01 01:05:35.000000', 'consum', 0.0210, 'lps'),
	(530673, 131, '2014-02-01 01:05:36.000000', 'consum', 0.0215, 'lps'),
	(530674, 131, '2014-02-01 01:05:37.000000', 'consum', 0.0214, 'lps'),
	(530675, 131, '2014-02-01 01:05:38.000000', 'consum', 0.0218, 'lps'),
	(530676, 131, '2014-02-01 01:05:39.000000', 'consum', 0.0218, 'lps'),
	(530677, 131, '2014-02-01 01:05:40.000000', 'consum', 0.0226, 'lps'),
	(530678, 131, '2014-02-01 01:05:41.000000', 'consum', 0.0215, 'lps'),
	(530679, 131, '2014-02-01 01:05:42.000000', 'consum', 0.0222, 'lps'),
	(530680, 131, '2014-02-01 01:05:43.000000', 'consum', 0.0219, 'lps'),
	(530681, 131, '2014-02-01 01:05:44.000000', 'consum', 0.0218, 'lps'),
	(530682, 131, '2014-02-01 01:05:45.000000', 'consum', 0.0227, 'lps'),
	(530683, 131, '2014-02-01 01:05:46.000000', 'consum', 0.0216, 'lps'),
	(530684, 131, '2014-02-01 01:05:47.000000', 'consum', 0.0227, 'lps'),
	(530685, 131, '2014-02-01 01:05:48.000000', 'consum', 0.0221, 'lps'),
	(530686, 131, '2014-02-01 01:05:49.000000', 'consum', 0.0216, 'lps'),
	(530687, 131, '2014-02-01 01:05:50.000000', 'consum', 0.0225, 'lps'),
	(530688, 131, '2014-02-01 01:05:51.000000', 'consum', 0.0212, 'lps'),
	(530689, 131, '2014-02-01 01:05:52.000000', 'consum', 0.0213, 'lps'),
	(530690, 131, '2014-02-01 01:05:53.000000', 'consum', 0.0218, 'lps'),
	(530691, 131, '2014-02-01 01:05:54.000000', 'consum', 0.0223, 'lps'),
	(530692, 131, '2014-02-01 01:05:55.000000', 'consum', 0.0218, 'lps'),
	(530693, 131, '2014-02-01 01:05:56.000000', 'consum', 0.0212, 'lps'),
	(530694, 131, '2014-02-01 01:05:57.000000', 'consum', 0.0212, 'lps'),
	(530695, 131, '2014-02-01 01:05:58.000000', 'consum', 0.0216, 'lps'),
	(530696, 131, '2014-02-01 01:05:59.000000', 'consum', 0.0217, 'lps'),
	(530697, 131, '2014-02-01 01:06:00.000000', 'consum', 0.0210, 'lps'),
	(530698, 131, '2014-02-01 01:06:01.000000', 'consum', 0.0225, 'lps'),
	(530699, 131, '2014-02-01 01:06:02.000000', 'consum', 0.0215, 'lps'),
	(530700, 131, '2014-02-01 01:06:03.000000', 'consum', 0.0226, 'lps'),
	(530701, 131, '2014-02-01 01:06:04.000000', 'consum', 0.0221, 'lps'),
	(530702, 131, '2014-02-01 01:06:05.000000', 'consum', 0.0217, 'lps'),
	(530703, 131, '2014-02-01 01:06:06.000000', 'consum', 0.0212, 'lps'),
	(530704, 131, '2014-02-01 01:06:07.000000', 'consum', 0.0217, 'lps'),
	(530705, 131, '2014-02-01 01:06:08.000000', 'consum', 0.0224, 'lps'),
	(530706, 131, '2014-02-01 01:06:09.000000', 'consum', 0.0221, 'lps'),
	(530707, 131, '2014-02-01 01:06:10.000000', 'consum', 0.0224, 'lps'),
	(530708, 131, '2014-02-01 01:06:11.000000', 'consum', 0.0213, 'lps'),
	(530709, 131, '2014-02-01 01:06:12.000000', 'consum', 0.0218, 'lps'),
	(530710, 131, '2014-02-01 01:06:13.000000', 'consum', 0.0226, 'lps'),
	(530711, 131, '2014-02-01 01:06:14.000000', 'consum', 0.0211, 'lps'),
	(530712, 131, '2014-02-01 01:06:15.000000', 'consum', 0.0220, 'lps'),
	(530713, 131, '2014-02-01 01:06:16.000000', 'consum', 0.0223, 'lps'),
	(530714, 131, '2014-02-01 01:06:17.000000', 'consum', 0.0210, 'lps'),
	(530715, 131, '2014-02-01 01:06:18.000000', 'consum', 0.0226, 'lps'),
	(530716, 131, '2014-02-01 01:06:19.000000', 'consum', 0.0218, 'lps'),
	(530717, 131, '2014-02-01 01:06:20.000000', 'consum', 0.0221, 'lps'),
	(530718, 131, '2014-02-01 01:06:21.000000', 'consum', 0.0223, 'lps'),
	(530719, 131, '2014-02-01 01:06:22.000000', 'consum', 0.0227, 'lps'),
	(530720, 131, '2014-02-01 01:06:23.000000', 'consum', 0.0217, 'lps'),
	(530721, 131, '2014-02-01 01:06:24.000000', 'consum', 0.0213, 'lps'),
	(530722, 131, '2014-02-01 01:06:25.000000', 'consum', 0.0222, 'lps'),
	(530723, 131, '2014-02-01 01:06:26.000000', 'consum', 0.0225, 'lps'),
	(530724, 131, '2014-02-01 01:06:27.000000', 'consum', 0.0213, 'lps'),
	(530725, 131, '2014-02-01 01:06:28.000000', 'consum', 0.0217, 'lps'),
	(530726, 131, '2014-02-01 01:06:29.000000', 'consum', 0.0219, 'lps'),
	(530727, 131, '2014-02-01 01:06:30.000000', 'consum', 0.0215, 'lps'),
	(530728, 131, '2014-02-01 01:06:31.000000', 'consum', 0.0211, 'lps'),
	(530729, 131, '2014-02-01 01:06:32.000000', 'consum', 0.0219, 'lps'),
	(530730, 131, '2014-02-01 01:06:33.000000', 'consum', 0.0216, 'lps'),
	(530731, 131, '2014-02-01 01:06:34.000000', 'consum', 0.0213, 'lps'),
	(530732, 131, '2014-02-01 01:06:35.000000', 'consum', 0.0225, 'lps'),
	(530733, 131, '2014-02-01 01:06:36.000000', 'consum', 0.0223, 'lps'),
	(530734, 131, '2014-02-01 01:06:37.000000', 'consum', 0.0214, 'lps'),
	(530735, 131, '2014-02-01 01:06:38.000000', 'consum', 0.0210, 'lps'),
	(530736, 131, '2014-02-01 01:06:39.000000', 'consum', 0.0215, 'lps'),
	(530737, 131, '2014-02-01 01:06:40.000000', 'consum', 0.0216, 'lps'),
	(530738, 131, '2014-02-01 01:06:41.000000', 'consum', 0.0226, 'lps'),
	(530739, 131, '2014-02-01 01:06:42.000000', 'consum', 0.0219, 'lps'),
	(530740, 131, '2014-02-01 01:06:43.000000', 'consum', 0.0224, 'lps'),
	(530741, 131, '2014-02-01 01:06:44.000000', 'consum', 0.0220, 'lps'),
	(530742, 131, '2014-02-01 01:06:45.000000', 'consum', 0.0220, 'lps'),
	(530743, 131, '2014-02-01 01:06:46.000000', 'consum', 0.0227, 'lps'),
	(530744, 131, '2014-02-01 01:06:47.000000', 'consum', 0.0213, 'lps'),
	(530745, 131, '2014-02-01 01:06:48.000000', 'consum', 0.0211, 'lps'),
	(530746, 131, '2014-02-01 01:06:49.000000', 'consum', 0.0224, 'lps'),
	(530747, 131, '2014-02-01 01:06:50.000000', 'consum', 0.0225, 'lps'),
	(530748, 131, '2014-02-01 01:06:51.000000', 'consum', 0.0226, 'lps'),
	(530749, 131, '2014-02-01 01:06:52.000000', 'consum', 0.0226, 'lps'),
	(530750, 131, '2014-02-01 01:06:53.000000', 'consum', 0.0225, 'lps'),
	(530751, 131, '2014-02-01 01:06:54.000000', 'consum', 0.0221, 'lps'),
	(530752, 131, '2014-02-01 01:06:55.000000', 'consum', 0.0219, 'lps'),
	(530753, 131, '2014-02-01 01:06:56.000000', 'consum', 0.0225, 'lps'),
	(530754, 131, '2014-02-01 01:06:57.000000', 'consum', 0.0220, 'lps'),
	(530755, 131, '2014-02-01 01:06:58.000000', 'consum', 0.0216, 'lps'),
	(530756, 131, '2014-02-01 01:06:59.000000', 'consum', 0.0227, 'lps'),
	(530757, 131, '2014-02-01 01:07:00.000000', 'consum', 0.0223, 'lps'),
	(530758, 131, '2014-02-01 01:07:01.000000', 'consum', 0.0226, 'lps'),
	(530759, 131, '2014-02-01 01:07:02.000000', 'consum', 0.0215, 'lps'),
	(530760, 131, '2014-02-01 01:07:03.000000', 'consum', 0.0225, 'lps'),
	(530761, 131, '2014-02-01 01:07:04.000000', 'consum', 0.0216, 'lps'),
	(530762, 131, '2014-02-01 01:07:05.000000', 'consum', 0.0211, 'lps'),
	(530763, 131, '2014-02-01 01:07:06.000000', 'consum', 0.0218, 'lps'),
	(530764, 131, '2014-02-01 01:07:07.000000', 'consum', 0.0227, 'lps'),
	(530765, 131, '2014-02-01 01:07:08.000000', 'consum', 0.0220, 'lps'),
	(530766, 131, '2014-02-01 01:07:09.000000', 'consum', 0.0226, 'lps'),
	(530767, 131, '2014-02-01 01:07:10.000000', 'consum', 0.0227, 'lps'),
	(530768, 131, '2014-02-01 01:07:11.000000', 'consum', 0.0226, 'lps'),
	(530769, 131, '2014-02-01 01:07:12.000000', 'consum', 0.0225, 'lps'),
	(530770, 131, '2014-02-01 01:07:13.000000', 'consum', 0.0217, 'lps'),
	(530771, 131, '2014-02-01 01:07:14.000000', 'consum', 0.0217, 'lps'),
	(530772, 131, '2014-02-01 01:07:15.000000', 'consum', 0.0210, 'lps'),
	(530773, 131, '2014-02-01 01:07:16.000000', 'consum', 0.0223, 'lps'),
	(530774, 131, '2014-02-01 01:07:17.000000', 'consum', 0.0223, 'lps'),
	(530775, 131, '2014-02-01 01:07:18.000000', 'consum', 0.0218, 'lps'),
	(530776, 131, '2014-02-01 01:07:19.000000', 'consum', 0.0213, 'lps'),
	(530777, 131, '2014-02-01 01:07:20.000000', 'consum', 0.0219, 'lps'),
	(530778, 131, '2014-02-01 01:07:21.000000', 'consum', 0.0210, 'lps'),
	(530779, 131, '2014-02-01 01:07:22.000000', 'consum', 0.0221, 'lps'),
	(530780, 131, '2014-02-01 01:07:23.000000', 'consum', 0.0211, 'lps'),
	(530781, 131, '2014-02-01 01:07:24.000000', 'consum', 0.0220, 'lps'),
	(530782, 131, '2014-02-01 01:07:25.000000', 'consum', 0.0220, 'lps'),
	(530783, 131, '2014-02-01 01:07:26.000000', 'consum', 0.0212, 'lps'),
	(530784, 131, '2014-02-01 01:07:27.000000', 'consum', 0.0227, 'lps'),
	(530785, 131, '2014-02-01 01:07:28.000000', 'consum', 0.0218, 'lps'),
	(530786, 131, '2014-02-01 01:07:29.000000', 'consum', 0.0218, 'lps'),
	(530787, 131, '2014-02-01 01:07:30.000000', 'consum', 0.0225, 'lps'),
	(530788, 131, '2014-02-01 01:07:31.000000', 'consum', 0.0227, 'lps'),
	(530789, 131, '2014-02-01 01:07:32.000000', 'consum', 0.0213, 'lps'),
	(530790, 131, '2014-02-01 01:07:33.000000', 'consum', 0.0213, 'lps'),
	(530791, 131, '2014-02-01 01:07:34.000000', 'consum', 0.0214, 'lps'),
	(530792, 131, '2014-02-01 01:07:35.000000', 'consum', 0.0221, 'lps'),
	(530793, 131, '2014-02-01 01:07:36.000000', 'consum', 0.0217, 'lps'),
	(530794, 131, '2014-02-01 01:07:37.000000', 'consum', 0.0212, 'lps'),
	(530795, 131, '2014-02-01 01:07:38.000000', 'consum', 0.0217, 'lps'),
	(530796, 131, '2014-02-01 01:07:39.000000', 'consum', 0.0223, 'lps'),
	(530797, 131, '2014-02-01 01:07:40.000000', 'consum', 0.0216, 'lps'),
	(530798, 131, '2014-02-01 01:07:41.000000', 'consum', 0.0222, 'lps'),
	(530799, 131, '2014-02-01 01:07:42.000000', 'consum', 0.0215, 'lps'),
	(530800, 131, '2014-02-01 01:07:43.000000', 'consum', 0.0218, 'lps'),
	(530801, 131, '2014-02-01 01:07:44.000000', 'consum', 0.0218, 'lps'),
	(530802, 131, '2014-02-01 01:07:45.000000', 'consum', 0.0227, 'lps'),
	(530803, 131, '2014-02-01 01:07:46.000000', 'consum', 0.0216, 'lps'),
	(530804, 131, '2014-02-01 01:07:47.000000', 'consum', 0.0225, 'lps'),
	(530805, 131, '2014-02-01 01:07:48.000000', 'consum', 0.0213, 'lps'),
	(530806, 131, '2014-02-01 01:07:49.000000', 'consum', 0.0215, 'lps'),
	(530807, 131, '2014-02-01 01:07:50.000000', 'consum', 0.0211, 'lps'),
	(530808, 131, '2014-02-01 01:07:51.000000', 'consum', 0.0219, 'lps'),
	(530809, 131, '2014-02-01 01:07:52.000000', 'consum', 0.0218, 'lps'),
	(530810, 131, '2014-02-01 01:07:53.000000', 'consum', 0.0221, 'lps'),
	(530811, 131, '2014-02-01 01:07:54.000000', 'consum', 0.0226, 'lps'),
	(530812, 131, '2014-02-01 01:07:55.000000', 'consum', 0.0221, 'lps'),
	(530813, 131, '2014-02-01 01:07:56.000000', 'consum', 0.0218, 'lps'),
	(530814, 131, '2014-02-01 01:07:57.000000', 'consum', 0.0218, 'lps'),
	(530815, 131, '2014-02-01 01:07:58.000000', 'consum', 0.0224, 'lps'),
	(530816, 131, '2014-02-01 01:07:59.000000', 'consum', 0.0223, 'lps'),
	(530817, 131, '2014-02-01 01:08:00.000000', 'consum', 0.0216, 'lps'),
	(530818, 131, '2014-02-01 01:08:01.000000', 'consum', 0.0218, 'lps'),
	(530819, 131, '2014-02-01 01:08:02.000000', 'consum', 0.0216, 'lps'),
	(530820, 131, '2014-02-01 01:08:03.000000', 'consum', 0.0216, 'lps'),
	(530821, 131, '2014-02-01 01:08:04.000000', 'consum', 0.0224, 'lps'),
	(530822, 131, '2014-02-01 01:08:05.000000', 'consum', 0.0225, 'lps'),
	(530823, 131, '2014-02-01 01:08:06.000000', 'consum', 0.0227, 'lps'),
	(530824, 131, '2014-02-01 01:08:07.000000', 'consum', 0.0214, 'lps'),
	(530825, 131, '2014-02-01 01:08:08.000000', 'consum', 0.0215, 'lps'),
	(530826, 131, '2014-02-01 01:08:09.000000', 'consum', 0.0226, 'lps'),
	(530827, 131, '2014-02-01 01:08:10.000000', 'consum', 0.0218, 'lps'),
	(530828, 131, '2014-02-01 01:08:11.000000', 'consum', 0.0222, 'lps'),
	(530829, 131, '2014-02-01 01:08:12.000000', 'consum', 0.0227, 'lps'),
	(530830, 131, '2014-02-01 01:08:13.000000', 'consum', 0.0225, 'lps'),
	(530831, 131, '2014-02-01 01:08:14.000000', 'consum', 0.0216, 'lps'),
	(530832, 131, '2014-02-01 01:08:15.000000', 'consum', 0.0213, 'lps'),
	(530833, 131, '2014-02-01 01:08:16.000000', 'consum', 0.0225, 'lps'),
	(530834, 131, '2014-02-01 01:08:17.000000', 'consum', 0.0223, 'lps'),
	(530835, 131, '2014-02-01 01:08:18.000000', 'consum', 0.0214, 'lps'),
	(530836, 131, '2014-02-01 01:08:19.000000', 'consum', 0.0225, 'lps'),
	(530837, 131, '2014-02-01 01:08:20.000000', 'consum', 0.0220, 'lps'),
	(530838, 131, '2014-02-01 01:08:21.000000', 'consum', 0.0214, 'lps'),
	(530839, 131, '2014-02-01 01:08:22.000000', 'consum', 0.0221, 'lps'),
	(530840, 131, '2014-02-01 01:08:23.000000', 'consum', 0.0217, 'lps'),
	(530841, 131, '2014-02-01 01:08:24.000000', 'consum', 0.0214, 'lps'),
	(530842, 131, '2014-02-01 01:08:25.000000', 'consum', 0.0225, 'lps'),
	(530843, 131, '2014-02-01 01:08:26.000000', 'consum', 0.0220, 'lps'),
	(530844, 131, '2014-02-01 01:08:27.000000', 'consum', 0.0216, 'lps'),
	(530845, 131, '2014-02-01 01:08:28.000000', 'consum', 0.0211, 'lps'),
	(530846, 131, '2014-02-01 01:08:29.000000', 'consum', 0.0216, 'lps'),
	(530847, 131, '2014-02-01 01:08:30.000000', 'consum', 0.0218, 'lps'),
	(530848, 131, '2014-02-01 01:08:31.000000', 'consum', 0.0213, 'lps'),
	(530849, 131, '2014-02-01 01:08:32.000000', 'consum', 0.0222, 'lps'),
	(530850, 131, '2014-02-01 01:08:33.000000', 'consum', 0.0225, 'lps'),
	(530851, 131, '2014-02-01 01:08:34.000000', 'consum', 0.0214, 'lps'),
	(530852, 131, '2014-02-01 01:08:35.000000', 'consum', 0.0223, 'lps'),
	(530853, 131, '2014-02-01 01:08:36.000000', 'consum', 0.0225, 'lps'),
	(530854, 131, '2014-02-01 01:08:37.000000', 'consum', 0.0211, 'lps'),
	(530855, 131, '2014-02-01 01:08:38.000000', 'consum', 0.0223, 'lps'),
	(530856, 131, '2014-02-01 01:08:39.000000', 'consum', 0.0219, 'lps'),
	(530857, 131, '2014-02-01 01:08:40.000000', 'consum', 0.0219, 'lps'),
	(530858, 131, '2014-02-01 01:08:41.000000', 'consum', 0.0226, 'lps'),
	(530859, 131, '2014-02-01 01:08:42.000000', 'consum', 0.0227, 'lps'),
	(530860, 131, '2014-02-01 01:08:43.000000', 'consum', 0.0212, 'lps'),
	(530861, 131, '2014-02-01 01:08:44.000000', 'consum', 0.0222, 'lps'),
	(530862, 131, '2014-02-01 01:08:45.000000', 'consum', 0.0214, 'lps'),
	(530863, 131, '2014-02-01 01:08:46.000000', 'consum', 0.0210, 'lps'),
	(530864, 131, '2014-02-01 01:08:47.000000', 'consum', 0.0218, 'lps'),
	(530865, 131, '2014-02-01 01:08:48.000000', 'consum', 0.0215, 'lps'),
	(530866, 131, '2014-02-01 01:08:49.000000', 'consum', 0.0211, 'lps'),
	(530867, 131, '2014-02-01 01:08:50.000000', 'consum', 0.0218, 'lps'),
	(530868, 131, '2014-02-01 01:08:51.000000', 'consum', 0.0213, 'lps'),
	(530869, 131, '2014-02-01 01:08:52.000000', 'consum', 0.0218, 'lps'),
	(530870, 131, '2014-02-01 01:08:53.000000', 'consum', 0.0224, 'lps'),
	(530871, 131, '2014-02-01 01:08:54.000000', 'consum', 0.0219, 'lps'),
	(530872, 131, '2014-02-01 01:08:55.000000', 'consum', 0.0213, 'lps'),
	(530873, 131, '2014-02-01 01:08:56.000000', 'consum', 0.0218, 'lps'),
	(530874, 131, '2014-02-01 01:08:57.000000', 'consum', 0.0225, 'lps'),
	(530875, 131, '2014-02-01 01:08:58.000000', 'consum', 0.0225, 'lps'),
	(530876, 131, '2014-02-01 01:08:59.000000', 'consum', 0.0222, 'lps'),
	(530877, 131, '2014-02-01 01:09:00.000000', 'consum', 0.0225, 'lps'),
	(530878, 131, '2014-02-01 01:09:01.000000', 'consum', 0.0215, 'lps'),
	(530879, 131, '2014-02-01 01:09:02.000000', 'consum', 0.0224, 'lps'),
	(530880, 131, '2014-02-01 01:09:03.000000', 'consum', 0.0211, 'lps'),
	(530881, 131, '2014-02-01 01:09:04.000000', 'consum', 0.0210, 'lps'),
	(530882, 131, '2014-02-01 01:09:05.000000', 'consum', 0.0226, 'lps'),
	(530883, 131, '2014-02-01 01:09:06.000000', 'consum', 0.0221, 'lps'),
	(530884, 131, '2014-02-01 01:09:07.000000', 'consum', 0.0214, 'lps'),
	(530885, 131, '2014-02-01 01:09:08.000000', 'consum', 0.0215, 'lps'),
	(530886, 131, '2014-02-01 01:09:09.000000', 'consum', 0.0226, 'lps'),
	(530887, 131, '2014-02-01 01:09:10.000000', 'consum', 0.0221, 'lps'),
	(530888, 131, '2014-02-01 01:09:11.000000', 'consum', 0.0215, 'lps'),
	(530889, 131, '2014-02-01 01:09:12.000000', 'consum', 0.0224, 'lps'),
	(530890, 131, '2014-02-01 01:09:13.000000', 'consum', 0.0227, 'lps'),
	(530891, 131, '2014-02-01 01:09:14.000000', 'consum', 0.0219, 'lps'),
	(530892, 131, '2014-02-01 01:09:15.000000', 'consum', 0.0222, 'lps'),
	(530893, 131, '2014-02-01 01:09:16.000000', 'consum', 0.0224, 'lps'),
	(530894, 131, '2014-02-01 01:09:17.000000', 'consum', 0.0212, 'lps'),
	(530895, 131, '2014-02-01 01:09:18.000000', 'consum', 0.0211, 'lps'),
	(530896, 131, '2014-02-01 01:09:19.000000', 'consum', 0.0213, 'lps'),
	(530897, 131, '2014-02-01 01:09:20.000000', 'consum', 0.0220, 'lps'),
	(530898, 131, '2014-02-01 01:09:21.000000', 'consum', 0.0216, 'lps'),
	(530899, 131, '2014-02-01 01:09:22.000000', 'consum', 0.0213, 'lps'),
	(530900, 131, '2014-02-01 01:09:23.000000', 'consum', 0.0223, 'lps'),
	(530901, 131, '2014-02-01 01:09:24.000000', 'consum', 0.0212, 'lps'),
	(530902, 131, '2014-02-01 01:09:25.000000', 'consum', 0.0217, 'lps'),
	(530903, 131, '2014-02-01 01:09:26.000000', 'consum', 0.0222, 'lps'),
	(530904, 131, '2014-02-01 01:09:27.000000', 'consum', 0.0215, 'lps'),
	(530905, 131, '2014-02-01 01:09:28.000000', 'consum', 0.0217, 'lps'),
	(530906, 131, '2014-02-01 01:09:29.000000', 'consum', 0.0211, 'lps'),
	(530907, 131, '2014-02-01 01:09:30.000000', 'consum', 0.0215, 'lps'),
	(530908, 131, '2014-02-01 01:09:31.000000', 'consum', 0.0214, 'lps'),
	(530909, 131, '2014-02-01 01:09:32.000000', 'consum', 0.0217, 'lps'),
	(530910, 131, '2014-02-01 01:09:33.000000', 'consum', 0.0213, 'lps'),
	(530911, 131, '2014-02-01 01:09:34.000000', 'consum', 0.0221, 'lps'),
	(530912, 131, '2014-02-01 01:09:35.000000', 'consum', 0.0223, 'lps'),
	(530913, 131, '2014-02-01 01:09:36.000000', 'consum', 0.0226, 'lps'),
	(530914, 131, '2014-02-01 01:09:37.000000', 'consum', 0.0212, 'lps'),
	(530915, 131, '2014-02-01 01:09:38.000000', 'consum', 0.0210, 'lps'),
	(530916, 131, '2014-02-01 01:09:39.000000', 'consum', 0.0220, 'lps'),
	(530917, 131, '2014-02-01 01:09:40.000000', 'consum', 0.0210, 'lps'),
	(530918, 131, '2014-02-01 01:09:41.000000', 'consum', 0.0215, 'lps'),
	(530919, 131, '2014-02-01 01:09:42.000000', 'consum', 0.0216, 'lps'),
	(530920, 131, '2014-02-01 01:09:43.000000', 'consum', 0.0227, 'lps'),
	(530921, 131, '2014-02-01 01:09:44.000000', 'consum', 0.0223, 'lps'),
	(530922, 131, '2014-02-01 01:09:45.000000', 'consum', 0.0224, 'lps'),
	(530923, 131, '2014-02-01 01:09:46.000000', 'consum', 0.0226, 'lps'),
	(530924, 131, '2014-02-01 01:09:47.000000', 'consum', 0.0211, 'lps'),
	(530925, 131, '2014-02-01 01:09:48.000000', 'consum', 0.0220, 'lps'),
	(530926, 131, '2014-02-01 01:09:49.000000', 'consum', 0.0223, 'lps'),
	(530927, 131, '2014-02-01 01:09:50.000000', 'consum', 0.0226, 'lps'),
	(530928, 131, '2014-02-01 01:09:51.000000', 'consum', 0.0218, 'lps'),
	(530929, 131, '2014-02-01 01:09:52.000000', 'consum', 0.0221, 'lps'),
	(530930, 131, '2014-02-01 01:09:53.000000', 'consum', 0.0220, 'lps'),
	(530931, 131, '2014-02-01 01:09:54.000000', 'consum', 0.0212, 'lps'),
	(530932, 131, '2014-02-01 01:09:55.000000', 'consum', 0.0210, 'lps'),
	(530933, 131, '2014-02-01 01:09:56.000000', 'consum', 0.0220, 'lps'),
	(530934, 131, '2014-02-01 01:09:57.000000', 'consum', 0.0226, 'lps'),
	(530935, 131, '2014-02-01 01:09:58.000000', 'consum', 0.0225, 'lps'),
	(530936, 131, '2014-02-01 01:09:59.000000', 'consum', 0.0219, 'lps'),
	(530937, 131, '2014-02-01 01:10:00.000000', 'consum', 0.0210, 'lps'),
	(530938, 131, '2014-02-01 01:10:01.000000', 'consum', 0.0218, 'lps'),
	(530939, 131, '2014-02-01 01:10:02.000000', 'consum', 0.0215, 'lps'),
	(530940, 131, '2014-02-01 01:10:03.000000', 'consum', 0.0213, 'lps'),
	(530941, 131, '2014-02-01 01:10:04.000000', 'consum', 0.0210, 'lps'),
	(530942, 131, '2014-02-01 01:10:05.000000', 'consum', 0.0220, 'lps'),
	(530943, 131, '2014-02-01 01:10:06.000000', 'consum', 0.0224, 'lps'),
	(530944, 131, '2014-02-01 01:10:07.000000', 'consum', 0.0217, 'lps'),
	(530945, 131, '2014-02-01 01:10:08.000000', 'consum', 0.0218, 'lps'),
	(530946, 131, '2014-02-01 01:10:09.000000', 'consum', 0.0213, 'lps'),
	(530947, 131, '2014-02-01 01:10:10.000000', 'consum', 0.0218, 'lps'),
	(530948, 131, '2014-02-01 01:10:11.000000', 'consum', 0.0224, 'lps'),
	(530949, 131, '2014-02-01 01:10:12.000000', 'consum', 0.0223, 'lps'),
	(530950, 131, '2014-02-01 01:10:13.000000', 'consum', 0.0214, 'lps'),
	(530951, 131, '2014-02-01 01:10:14.000000', 'consum', 0.0225, 'lps'),
	(530952, 131, '2014-02-01 01:10:15.000000', 'consum', 0.0223, 'lps'),
	(530953, 131, '2014-02-01 01:10:16.000000', 'consum', 0.0212, 'lps'),
	(530954, 131, '2014-02-01 01:10:17.000000', 'consum', 0.0217, 'lps'),
	(530955, 131, '2014-02-01 01:10:18.000000', 'consum', 0.0223, 'lps'),
	(530956, 131, '2014-02-01 01:10:19.000000', 'consum', 0.0219, 'lps'),
	(530957, 131, '2014-02-01 01:10:20.000000', 'consum', 0.0215, 'lps'),
	(530958, 131, '2014-02-01 01:10:21.000000', 'consum', 0.0227, 'lps'),
	(530959, 131, '2014-02-01 01:10:22.000000', 'consum', 0.0226, 'lps'),
	(530960, 131, '2014-02-01 01:10:23.000000', 'consum', 0.0221, 'lps'),
	(530961, 131, '2014-02-01 01:10:24.000000', 'consum', 0.0217, 'lps'),
	(530962, 131, '2014-02-01 01:10:25.000000', 'consum', 0.0213, 'lps'),
	(530963, 131, '2014-02-01 01:10:26.000000', 'consum', 0.0223, 'lps'),
	(530964, 131, '2014-02-01 01:10:27.000000', 'consum', 0.0212, 'lps'),
	(530965, 131, '2014-02-01 01:10:28.000000', 'consum', 0.0216, 'lps'),
	(530966, 131, '2014-02-01 01:10:29.000000', 'consum', 0.0218, 'lps'),
	(530967, 131, '2014-02-01 01:10:30.000000', 'consum', 0.0215, 'lps'),
	(530968, 131, '2014-02-01 01:10:31.000000', 'consum', 0.0210, 'lps'),
	(530969, 131, '2014-02-01 01:10:32.000000', 'consum', 0.0216, 'lps'),
	(530970, 131, '2014-02-01 01:10:33.000000', 'consum', 0.0221, 'lps'),
	(530971, 131, '2014-02-01 01:10:34.000000', 'consum', 0.0211, 'lps'),
	(530972, 131, '2014-02-01 01:10:35.000000', 'consum', 0.0218, 'lps'),
	(530973, 131, '2014-02-01 01:10:36.000000', 'consum', 0.0210, 'lps'),
	(530974, 131, '2014-02-01 01:10:37.000000', 'consum', 0.0226, 'lps'),
	(530975, 131, '2014-02-01 01:10:38.000000', 'consum', 0.0217, 'lps'),
	(530976, 131, '2014-02-01 01:10:39.000000', 'consum', 0.0217, 'lps'),
	(530977, 131, '2014-02-01 01:10:40.000000', 'consum', 0.0222, 'lps'),
	(530978, 131, '2014-02-01 01:10:41.000000', 'consum', 0.0215, 'lps'),
	(530979, 131, '2014-02-01 01:10:42.000000', 'consum', 0.0219, 'lps'),
	(530980, 131, '2014-02-01 01:10:43.000000', 'consum', 0.0220, 'lps'),
	(530981, 131, '2014-02-01 01:10:44.000000', 'consum', 0.0217, 'lps'),
	(530982, 131, '2014-02-01 01:10:45.000000', 'consum', 0.0215, 'lps'),
	(530983, 131, '2014-02-01 01:10:46.000000', 'consum', 0.0215, 'lps'),
	(530984, 131, '2014-02-01 01:10:47.000000', 'consum', 0.0222, 'lps'),
	(530985, 131, '2014-02-01 01:10:48.000000', 'consum', 0.0219, 'lps'),
	(530986, 131, '2014-02-01 01:10:49.000000', 'consum', 0.0220, 'lps'),
	(530987, 131, '2014-02-01 01:10:50.000000', 'consum', 0.0217, 'lps'),
	(530988, 131, '2014-02-01 01:10:51.000000', 'consum', 0.0213, 'lps'),
	(530989, 131, '2014-02-01 01:10:52.000000', 'consum', 0.0224, 'lps'),
	(530990, 131, '2014-02-01 01:10:53.000000', 'consum', 0.0218, 'lps'),
	(530991, 131, '2014-02-01 01:10:54.000000', 'consum', 0.0226, 'lps'),
	(530992, 131, '2014-02-01 01:10:55.000000', 'consum', 0.0214, 'lps'),
	(530993, 131, '2014-02-01 01:10:56.000000', 'consum', 0.0217, 'lps'),
	(530994, 131, '2014-02-01 01:10:57.000000', 'consum', 0.0216, 'lps'),
	(530995, 131, '2014-02-01 01:10:58.000000', 'consum', 0.0221, 'lps'),
	(530996, 131, '2014-02-01 01:10:59.000000', 'consum', 0.0226, 'lps'),
	(530997, 131, '2014-02-01 01:11:00.000000', 'consum', 0.0225, 'lps'),
	(530998, 131, '2014-02-01 01:11:01.000000', 'consum', 0.0216, 'lps'),
	(530999, 131, '2014-02-01 01:11:02.000000', 'consum', 0.0215, 'lps'),
	(531000, 131, '2014-02-01 01:11:03.000000', 'consum', 0.0219, 'lps'),
	(531001, 131, '2014-02-01 01:11:04.000000', 'consum', 0.0221, 'lps'),
	(531002, 131, '2014-02-01 01:11:05.000000', 'consum', 0.0222, 'lps'),
	(531003, 131, '2014-02-01 01:11:06.000000', 'consum', 0.0218, 'lps'),
	(531004, 131, '2014-02-01 01:11:07.000000', 'consum', 0.0214, 'lps'),
	(531005, 131, '2014-02-01 01:11:08.000000', 'consum', 0.0225, 'lps'),
	(531006, 131, '2014-02-01 01:11:09.000000', 'consum', 0.0219, 'lps'),
	(531007, 131, '2014-02-01 01:11:10.000000', 'consum', 0.0212, 'lps'),
	(531008, 131, '2014-02-01 01:11:11.000000', 'consum', 0.0211, 'lps'),
	(531009, 131, '2014-02-01 01:11:12.000000', 'consum', 0.0210, 'lps'),
	(531010, 131, '2014-02-01 01:11:13.000000', 'consum', 0.0224, 'lps'),
	(531011, 131, '2014-02-01 01:11:14.000000', 'consum', 0.0211, 'lps'),
	(531012, 131, '2014-02-01 01:11:15.000000', 'consum', 0.0225, 'lps'),
	(531013, 131, '2014-02-01 01:11:16.000000', 'consum', 0.0212, 'lps'),
	(531014, 131, '2014-02-01 01:11:17.000000', 'consum', 0.0212, 'lps'),
	(531015, 131, '2014-02-01 01:11:18.000000', 'consum', 0.0214, 'lps'),
	(531016, 131, '2014-02-01 01:11:19.000000', 'consum', 0.0225, 'lps'),
	(531017, 131, '2014-02-01 01:11:20.000000', 'consum', 0.0220, 'lps'),
	(531018, 131, '2014-02-01 01:11:21.000000', 'consum', 0.0214, 'lps'),
	(531019, 131, '2014-02-01 01:11:22.000000', 'consum', 0.0221, 'lps'),
	(531020, 131, '2014-02-01 01:11:23.000000', 'consum', 0.0214, 'lps'),
	(531021, 131, '2014-02-01 01:11:24.000000', 'consum', 0.0218, 'lps'),
	(531022, 131, '2014-02-01 01:11:25.000000', 'consum', 0.0219, 'lps'),
	(531023, 131, '2014-02-01 01:11:26.000000', 'consum', 0.0212, 'lps'),
	(531024, 131, '2014-02-01 01:11:27.000000', 'consum', 0.0215, 'lps'),
	(531025, 131, '2014-02-01 01:11:28.000000', 'consum', 0.0226, 'lps'),
	(531026, 131, '2014-02-01 01:11:29.000000', 'consum', 0.0224, 'lps'),
	(531027, 131, '2014-02-01 01:11:30.000000', 'consum', 0.0212, 'lps'),
	(531028, 131, '2014-02-01 01:11:31.000000', 'consum', 0.0216, 'lps'),
	(531029, 131, '2014-02-01 01:11:32.000000', 'consum', 0.0216, 'lps'),
	(531030, 131, '2014-02-01 01:11:33.000000', 'consum', 0.0224, 'lps'),
	(531031, 131, '2014-02-01 01:11:34.000000', 'consum', 0.0225, 'lps'),
	(531032, 131, '2014-02-01 01:11:35.000000', 'consum', 0.0225, 'lps'),
	(531033, 131, '2014-02-01 01:11:36.000000', 'consum', 0.0222, 'lps'),
	(531034, 131, '2014-02-01 01:11:37.000000', 'consum', 0.0210, 'lps'),
	(531035, 131, '2014-02-01 01:11:38.000000', 'consum', 0.0210, 'lps'),
	(531036, 131, '2014-02-01 01:11:39.000000', 'consum', 0.0210, 'lps'),
	(531037, 131, '2014-02-01 01:11:40.000000', 'consum', 0.0210, 'lps'),
	(531038, 131, '2014-02-01 01:11:41.000000', 'consum', 0.0210, 'lps'),
	(531039, 131, '2014-02-01 01:11:42.000000', 'consum', 0.0210, 'lps'),
	(531040, 131, '2014-02-01 01:11:43.000000', 'consum', 0.0211, 'lps'),
	(531041, 131, '2014-02-01 01:11:44.000000', 'consum', 0.0215, 'lps'),
	(531042, 131, '2014-02-01 01:11:45.000000', 'consum', 0.0217, 'lps'),
	(531043, 131, '2014-02-01 01:11:46.000000', 'consum', 0.0210, 'lps'),
	(531044, 131, '2014-02-01 01:11:47.000000', 'consum', 0.0227, 'lps'),
	(531045, 131, '2014-02-01 01:11:48.000000', 'consum', 0.0223, 'lps'),
	(531046, 131, '2014-02-01 01:11:49.000000', 'consum', 0.0224, 'lps'),
	(531047, 131, '2014-02-01 01:11:50.000000', 'consum', 0.0225, 'lps'),
	(531048, 131, '2014-02-01 01:11:51.000000', 'consum', 0.0226, 'lps'),
	(531049, 131, '2014-02-01 01:11:52.000000', 'consum', 0.0226, 'lps'),
	(531050, 131, '2014-02-01 01:11:53.000000', 'consum', 0.0225, 'lps'),
	(531051, 131, '2014-02-01 01:11:54.000000', 'consum', 0.0221, 'lps'),
	(531052, 131, '2014-02-01 01:11:55.000000', 'consum', 0.0218, 'lps'),
	(531053, 131, '2014-02-01 01:11:56.000000', 'consum', 0.0217, 'lps'),
	(531054, 131, '2014-02-01 01:11:57.000000', 'consum', 0.0222, 'lps'),
	(531055, 131, '2014-02-01 01:11:58.000000', 'consum', 0.0214, 'lps'),
	(531056, 131, '2014-02-01 01:11:59.000000', 'consum', 0.0212, 'lps'),
	(531057, 131, '2014-02-01 01:12:00.000000', 'consum', 0.0225, 'lps'),
	(531058, 131, '2014-02-01 01:12:01.000000', 'consum', 0.0227, 'lps'),
	(531059, 131, '2014-02-01 01:12:02.000000', 'consum', 0.0216, 'lps'),
	(531060, 131, '2014-02-01 01:12:03.000000', 'consum', 0.0225, 'lps'),
	(531061, 131, '2014-02-01 01:12:04.000000', 'consum', 0.0215, 'lps'),
	(531062, 131, '2014-02-01 01:12:05.000000', 'consum', 0.0224, 'lps'),
	(531063, 131, '2014-02-01 01:12:06.000000', 'consum', 0.0212, 'lps'),
	(531064, 131, '2014-02-01 01:12:07.000000', 'consum', 0.0216, 'lps'),
	(531065, 131, '2014-02-01 01:12:08.000000', 'consum', 0.0214, 'lps'),
	(531066, 131, '2014-02-01 01:12:09.000000', 'consum', 0.0212, 'lps'),
	(531067, 131, '2014-02-01 01:12:10.000000', 'consum', 0.0226, 'lps'),
	(531068, 131, '2014-02-01 01:12:11.000000', 'consum', 0.0215, 'lps'),
	(531069, 131, '2014-02-01 01:12:12.000000', 'consum', 0.0224, 'lps'),
	(531070, 131, '2014-02-01 01:12:13.000000', 'consum', 0.0210, 'lps'),
	(531071, 131, '2014-02-01 01:12:14.000000', 'consum', 0.0224, 'lps'),
	(531072, 131, '2014-02-01 01:12:15.000000', 'consum', 0.0224, 'lps'),
	(531073, 131, '2014-02-01 01:12:16.000000', 'consum', 0.0223, 'lps'),
	(531074, 131, '2014-02-01 01:12:17.000000', 'consum', 0.0216, 'lps'),
	(531075, 131, '2014-02-01 01:12:18.000000', 'consum', 0.0219, 'lps'),
	(531076, 131, '2014-02-01 01:12:19.000000', 'consum', 0.0219, 'lps'),
	(531077, 131, '2014-02-01 01:12:20.000000', 'consum', 0.0213, 'lps'),
	(531078, 131, '2014-02-01 01:12:21.000000', 'consum', 0.0213, 'lps'),
	(531079, 131, '2014-02-01 01:12:22.000000', 'consum', 0.0220, 'lps'),
	(531080, 131, '2014-02-01 01:12:23.000000', 'consum', 0.0213, 'lps'),
	(531081, 131, '2014-02-01 01:12:24.000000', 'consum', 0.0215, 'lps'),
	(531082, 131, '2014-02-01 01:12:25.000000', 'consum', 0.0226, 'lps'),
	(531083, 131, '2014-02-01 01:12:26.000000', 'consum', 0.0221, 'lps'),
	(531084, 131, '2014-02-01 01:12:27.000000', 'consum', 0.0216, 'lps'),
	(531085, 131, '2014-02-01 01:12:28.000000', 'consum', 0.0211, 'lps'),
	(531086, 131, '2014-02-01 01:12:29.000000', 'consum', 0.0212, 'lps'),
	(531087, 131, '2014-02-01 01:12:30.000000', 'consum', 0.0219, 'lps'),
	(531088, 131, '2014-02-01 01:12:31.000000', 'consum', 0.0213, 'lps'),
	(531089, 131, '2014-02-01 01:12:32.000000', 'consum', 0.0216, 'lps'),
	(531090, 131, '2014-02-01 01:12:33.000000', 'consum', 0.0213, 'lps'),
	(531091, 131, '2014-02-01 01:12:34.000000', 'consum', 0.0225, 'lps'),
	(531092, 131, '2014-02-01 01:12:35.000000', 'consum', 0.0225, 'lps'),
	(531093, 131, '2014-02-01 01:12:36.000000', 'consum', 0.0221, 'lps'),
	(531094, 131, '2014-02-01 01:12:37.000000', 'consum', 0.0221, 'lps'),
	(531095, 131, '2014-02-01 01:12:38.000000', 'consum', 0.0214, 'lps'),
	(531096, 131, '2014-02-01 01:12:39.000000', 'consum', 0.0216, 'lps'),
	(531097, 131, '2014-02-01 01:12:40.000000', 'consum', 0.0210, 'lps'),
	(531098, 131, '2014-02-01 01:12:41.000000', 'consum', 0.0211, 'lps'),
	(531099, 131, '2014-02-01 01:12:42.000000', 'consum', 0.0214, 'lps'),
	(531100, 131, '2014-02-01 01:12:43.000000', 'consum', 0.0212, 'lps'),
	(531101, 131, '2014-02-01 01:12:44.000000', 'consum', 0.0227, 'lps'),
	(531102, 131, '2014-02-01 01:12:45.000000', 'consum', 0.0215, 'lps'),
	(531103, 131, '2014-02-01 01:12:46.000000', 'consum', 0.0221, 'lps'),
	(531104, 131, '2014-02-01 01:12:47.000000', 'consum', 0.0216, 'lps'),
	(531105, 131, '2014-02-01 01:12:48.000000', 'consum', 0.0225, 'lps'),
	(531106, 131, '2014-02-01 01:12:49.000000', 'consum', 0.0215, 'lps'),
	(531107, 131, '2014-02-01 01:12:50.000000', 'consum', 0.0227, 'lps'),
	(531108, 131, '2014-02-01 01:12:51.000000', 'consum', 0.0224, 'lps'),
	(531109, 131, '2014-02-01 01:12:52.000000', 'consum', 0.0211, 'lps'),
	(531110, 131, '2014-02-01 01:12:53.000000', 'consum', 0.0210, 'lps'),
	(531111, 131, '2014-02-01 01:12:54.000000', 'consum', 0.0227, 'lps'),
	(531112, 131, '2014-02-01 01:12:55.000000', 'consum', 0.0225, 'lps'),
	(531113, 131, '2014-02-01 01:12:56.000000', 'consum', 0.0213, 'lps'),
	(531114, 131, '2014-02-01 01:12:57.000000', 'consum', 0.0218, 'lps'),
	(531115, 131, '2014-02-01 01:12:58.000000', 'consum', 0.0224, 'lps'),
	(531116, 131, '2014-02-01 01:12:59.000000', 'consum', 0.0220, 'lps'),
	(531117, 131, '2014-02-01 01:13:00.000000', 'consum', 0.0219, 'lps'),
	(531118, 131, '2014-02-01 01:13:01.000000', 'consum', 0.0226, 'lps'),
	(531119, 131, '2014-02-01 01:13:02.000000', 'consum', 0.0227, 'lps'),
	(531120, 131, '2014-02-01 01:13:03.000000', 'consum', 0.0212, 'lps'),
	(531121, 131, '2014-02-01 01:13:04.000000', 'consum', 0.0225, 'lps'),
	(531122, 131, '2014-02-01 01:13:05.000000', 'consum', 0.0223, 'lps'),
	(531123, 131, '2014-02-01 01:13:06.000000', 'consum', 0.0213, 'lps'),
	(531124, 131, '2014-02-01 01:13:07.000000', 'consum', 0.0222, 'lps'),
	(531125, 131, '2014-02-01 01:13:08.000000', 'consum', 0.0225, 'lps'),
	(531126, 131, '2014-02-01 01:13:09.000000', 'consum', 0.0215, 'lps'),
	(531127, 131, '2014-02-01 01:13:10.000000', 'consum', 0.0224, 'lps'),
	(531128, 131, '2014-02-01 01:13:11.000000', 'consum', 0.0213, 'lps'),
	(531129, 131, '2014-02-01 01:13:12.000000', 'consum', 0.0221, 'lps'),
	(531130, 131, '2014-02-01 01:13:13.000000', 'consum', 0.0218, 'lps'),
	(531131, 131, '2014-02-01 01:13:14.000000', 'consum', 0.0219, 'lps'),
	(531132, 131, '2014-02-01 01:13:15.000000', 'consum', 0.0211, 'lps'),
	(531133, 131, '2014-02-01 01:13:16.000000', 'consum', 0.0210, 'lps'),
	(531134, 131, '2014-02-01 01:13:17.000000', 'consum', 0.0224, 'lps'),
	(531135, 131, '2014-02-01 01:13:18.000000', 'consum', 0.0210, 'lps'),
	(531136, 131, '2014-02-01 01:13:19.000000', 'consum', 0.0220, 'lps'),
	(531137, 131, '2014-02-01 01:13:20.000000', 'consum', 0.0227, 'lps'),
	(531138, 131, '2014-02-01 01:13:21.000000', 'consum', 0.0211, 'lps'),
	(531139, 131, '2014-02-01 01:13:22.000000', 'consum', 0.0220, 'lps'),
	(531140, 131, '2014-02-01 01:13:23.000000', 'consum', 0.0219, 'lps'),
	(531141, 131, '2014-02-01 01:13:24.000000', 'consum', 0.0210, 'lps'),
	(531142, 131, '2014-02-01 01:13:25.000000', 'consum', 0.0218, 'lps'),
	(531143, 131, '2014-02-01 01:13:26.000000', 'consum', 0.0216, 'lps'),
	(531144, 131, '2014-02-01 01:13:27.000000', 'consum', 0.0214, 'lps'),
	(531145, 131, '2014-02-01 01:13:28.000000', 'consum', 0.0215, 'lps'),
	(531146, 131, '2014-02-01 01:13:29.000000', 'consum', 0.0222, 'lps'),
	(531147, 131, '2014-02-01 01:13:30.000000', 'consum', 0.0219, 'lps'),
	(531148, 131, '2014-02-01 01:13:31.000000', 'consum', 0.0222, 'lps'),
	(531149, 131, '2014-02-01 01:13:32.000000', 'consum', 0.0224, 'lps'),
	(531150, 131, '2014-02-01 01:13:33.000000', 'consum', 0.0226, 'lps'),
	(531151, 131, '2014-02-01 01:13:34.000000', 'consum', 0.0215, 'lps'),
	(531152, 131, '2014-02-01 01:13:35.000000', 'consum', 0.0221, 'lps'),
	(531153, 131, '2014-02-01 01:13:36.000000', 'consum', 0.0216, 'lps'),
	(531154, 131, '2014-02-01 01:13:37.000000', 'consum', 0.0225, 'lps'),
	(531155, 131, '2014-02-01 01:13:38.000000', 'consum', 0.0215, 'lps'),
	(531156, 131, '2014-02-01 01:13:39.000000', 'consum', 0.0225, 'lps'),
	(531157, 131, '2014-02-01 01:13:40.000000', 'consum', 0.0218, 'lps'),
	(531158, 131, '2014-02-01 01:13:41.000000', 'consum', 0.0221, 'lps'),
	(531159, 131, '2014-02-01 01:13:42.000000', 'consum', 0.0225, 'lps'),
	(531160, 131, '2014-02-01 01:13:43.000000', 'consum', 0.0218, 'lps'),
	(531161, 131, '2014-02-01 01:13:44.000000', 'consum', 0.0223, 'lps'),
	(531162, 131, '2014-02-01 01:13:45.000000', 'consum', 0.0215, 'lps'),
	(531163, 131, '2014-02-01 01:13:46.000000', 'consum', 0.0215, 'lps'),
	(531164, 131, '2014-02-01 01:13:47.000000', 'consum', 0.0219, 'lps'),
	(531165, 131, '2014-02-01 01:13:48.000000', 'consum', 0.0223, 'lps'),
	(531166, 131, '2014-02-01 01:13:49.000000', 'consum', 0.0213, 'lps'),
	(531167, 131, '2014-02-01 01:13:50.000000', 'consum', 0.0220, 'lps'),
	(531168, 131, '2014-02-01 01:13:51.000000', 'consum', 0.0219, 'lps'),
	(531169, 131, '2014-02-01 01:13:52.000000', 'consum', 0.0225, 'lps'),
	(531170, 131, '2014-02-01 01:13:53.000000', 'consum', 0.0223, 'lps'),
	(531171, 131, '2014-02-01 01:13:54.000000', 'consum', 0.0211, 'lps'),
	(531172, 131, '2014-02-01 01:13:55.000000', 'consum', 0.0212, 'lps'),
	(531173, 131, '2014-02-01 01:13:56.000000', 'consum', 0.0219, 'lps'),
	(531174, 131, '2014-02-01 01:13:57.000000', 'consum', 0.0214, 'lps'),
	(531175, 131, '2014-02-01 01:13:58.000000', 'consum', 0.0223, 'lps'),
	(531176, 131, '2014-02-01 01:13:59.000000', 'consum', 0.0224, 'lps'),
	(531177, 131, '2014-02-01 01:14:00.000000', 'consum', 0.0225, 'lps'),
	(531178, 131, '2014-02-01 01:14:01.000000', 'consum', 0.0224, 'lps'),
	(531179, 131, '2014-02-01 01:14:02.000000', 'consum', 0.0217, 'lps'),
	(531180, 131, '2014-02-01 01:14:03.000000', 'consum', 0.0222, 'lps'),
	(531181, 131, '2014-02-01 01:14:04.000000', 'consum', 0.0213, 'lps'),
	(531182, 131, '2014-02-01 01:14:05.000000', 'consum', 0.0226, 'lps'),
	(531183, 131, '2014-02-01 01:14:06.000000', 'consum', 0.0227, 'lps'),
	(531184, 131, '2014-02-01 01:14:07.000000', 'consum', 0.0211, 'lps'),
	(531185, 131, '2014-02-01 01:14:08.000000', 'consum', 0.0217, 'lps'),
	(531186, 131, '2014-02-01 01:14:09.000000', 'consum', 0.0210, 'lps'),
	(531187, 131, '2014-02-01 01:14:10.000000', 'consum', 0.0224, 'lps'),
	(531188, 131, '2014-02-01 01:14:11.000000', 'consum', 0.0210, 'lps'),
	(531189, 131, '2014-02-01 01:14:12.000000', 'consum', 0.0223, 'lps'),
	(531190, 131, '2014-02-01 01:14:13.000000', 'consum', 0.0221, 'lps'),
	(531191, 131, '2014-02-01 01:14:14.000000', 'consum', 0.0227, 'lps'),
	(531192, 131, '2014-02-01 01:14:15.000000', 'consum', 0.0226, 'lps'),
	(531193, 131, '2014-02-01 01:14:16.000000', 'consum', 0.0222, 'lps'),
	(531194, 131, '2014-02-01 01:14:17.000000', 'consum', 0.0221, 'lps'),
	(531195, 131, '2014-02-01 01:14:18.000000', 'consum', 0.0211, 'lps'),
	(531196, 131, '2014-02-01 01:14:19.000000', 'consum', 0.0218, 'lps'),
	(531197, 131, '2014-02-01 01:14:20.000000', 'consum', 0.0214, 'lps'),
	(531198, 131, '2014-02-01 01:14:21.000000', 'consum', 0.0225, 'lps'),
	(531199, 131, '2014-02-01 01:14:22.000000', 'consum', 0.0220, 'lps'),
	(531200, 131, '2014-02-01 01:14:23.000000', 'consum', 0.0214, 'lps'),
	(531201, 131, '2014-02-01 01:14:24.000000', 'consum', 0.0220, 'lps'),
	(531202, 131, '2014-02-01 01:14:25.000000', 'consum', 0.0211, 'lps'),
	(531203, 131, '2014-02-01 01:14:26.000000', 'consum', 0.0223, 'lps'),
	(531204, 131, '2014-02-01 01:14:27.000000', 'consum', 0.0216, 'lps'),
	(531205, 131, '2014-02-01 01:14:28.000000', 'consum', 0.0222, 'lps'),
	(531206, 131, '2014-02-01 01:14:29.000000', 'consum', 0.0216, 'lps'),
	(531207, 131, '2014-02-01 01:14:30.000000', 'consum', 0.0224, 'lps'),
	(531208, 131, '2014-02-01 01:14:31.000000', 'consum', 0.0225, 'lps'),
	(531209, 131, '2014-02-01 01:14:32.000000', 'consum', 0.0210, 'lps'),
	(531210, 131, '2014-02-01 01:14:33.000000', 'consum', 0.0216, 'lps'),
	(531211, 131, '2014-02-01 01:14:34.000000', 'consum', 0.0225, 'lps'),
	(531212, 131, '2014-02-01 01:14:35.000000', 'consum', 0.0212, 'lps'),
	(531213, 131, '2014-02-01 01:14:36.000000', 'consum', 0.0212, 'lps'),
	(531214, 131, '2014-02-01 01:14:37.000000', 'consum', 0.0216, 'lps'),
	(531215, 131, '2014-02-01 01:14:38.000000', 'consum', 0.0217, 'lps'),
	(531216, 131, '2014-02-01 01:14:39.000000', 'consum', 0.0227, 'lps'),
	(531217, 131, '2014-02-01 01:14:40.000000', 'consum', 0.0222, 'lps'),
	(531218, 131, '2014-02-01 01:14:41.000000', 'consum', 0.0219, 'lps'),
	(531219, 131, '2014-02-01 01:14:42.000000', 'consum', 0.0218, 'lps'),
	(531220, 131, '2014-02-01 01:14:43.000000', 'consum', 0.0224, 'lps'),
	(531221, 131, '2014-02-01 01:14:44.000000', 'consum', 0.0222, 'lps'),
	(531222, 131, '2014-02-01 01:14:45.000000', 'consum', 0.0210, 'lps'),
	(531223, 131, '2014-02-01 01:14:46.000000', 'consum', 0.0211, 'lps'),
	(531224, 131, '2014-02-01 01:14:47.000000', 'consum', 0.0215, 'lps'),
	(531225, 131, '2014-02-01 01:14:48.000000', 'consum', 0.0216, 'lps'),
	(531226, 131, '2014-02-01 01:14:49.000000', 'consum', 0.0223, 'lps'),
	(531227, 131, '2014-02-01 01:14:50.000000', 'consum', 0.0223, 'lps'),
	(531228, 131, '2014-02-01 01:14:51.000000', 'consum', 0.0220, 'lps'),
	(531229, 131, '2014-02-01 01:14:52.000000', 'consum', 0.0221, 'lps'),
	(531230, 131, '2014-02-01 01:14:53.000000', 'consum', 0.0217, 'lps'),
	(531231, 131, '2014-02-01 01:14:54.000000', 'consum', 0.0213, 'lps'),
	(531232, 131, '2014-02-01 01:14:55.000000', 'consum', 0.0222, 'lps'),
	(531233, 131, '2014-02-01 01:14:56.000000', 'consum', 0.0226, 'lps'),
	(531234, 131, '2014-02-01 01:14:57.000000', 'consum', 0.0216, 'lps'),
	(531235, 131, '2014-02-01 01:14:58.000000', 'consum', 0.0214, 'lps'),
	(531236, 131, '2014-02-01 01:14:59.000000', 'consum', 0.0227, 'lps'),
	(531237, 131, '2014-02-01 01:15:00.000000', 'consum', 0.0214, 'lps'),
	(531238, 131, '2014-02-01 01:15:01.000000', 'consum', 0.0214, 'lps'),
	(531239, 131, '2014-02-01 01:15:02.000000', 'consum', 0.0220, 'lps'),
	(531240, 131, '2014-02-01 01:15:03.000000', 'consum', 0.0214, 'lps'),
	(531241, 131, '2014-02-01 01:15:04.000000', 'consum', 0.0216, 'lps'),
	(531242, 131, '2014-02-01 01:15:05.000000', 'consum', 0.0227, 'lps'),
	(531243, 131, '2014-02-01 01:15:06.000000', 'consum', 0.0226, 'lps'),
	(531244, 131, '2014-02-01 01:15:07.000000', 'consum', 0.0220, 'lps'),
	(531245, 131, '2014-02-01 01:15:08.000000', 'consum', 0.0213, 'lps'),
	(531246, 131, '2014-02-01 01:15:09.000000', 'consum', 0.0212, 'lps'),
	(531247, 131, '2014-02-01 01:15:10.000000', 'consum', 0.0211, 'lps'),
	(531248, 131, '2014-02-01 01:15:11.000000', 'consum', 0.0210, 'lps'),
	(531249, 131, '2014-02-01 01:15:12.000000', 'consum', 0.0227, 'lps'),
	(531250, 131, '2014-02-01 01:15:13.000000', 'consum', 0.0222, 'lps'),
	(531251, 131, '2014-02-01 01:15:14.000000', 'consum', 0.0218, 'lps'),
	(531252, 131, '2014-02-01 01:15:15.000000', 'consum', 0.0216, 'lps'),
	(531253, 131, '2014-02-01 01:15:16.000000', 'consum', 0.0216, 'lps'),
	(531254, 131, '2014-02-01 01:15:17.000000', 'consum', 0.0221, 'lps'),
	(531255, 131, '2014-02-01 01:15:18.000000', 'consum', 0.0211, 'lps'),
	(531256, 131, '2014-02-01 01:15:19.000000', 'consum', 0.0222, 'lps'),
	(531257, 131, '2014-02-01 01:15:20.000000', 'consum', 0.0211, 'lps'),
	(531258, 131, '2014-02-01 01:15:21.000000', 'consum', 0.0215, 'lps'),
	(531259, 131, '2014-02-01 01:15:22.000000', 'consum', 0.0217, 'lps'),
	(531260, 131, '2014-02-01 01:15:23.000000', 'consum', 0.0211, 'lps'),
	(531261, 131, '2014-02-01 01:15:24.000000', 'consum', 0.0214, 'lps'),
	(531262, 131, '2014-02-01 01:15:25.000000', 'consum', 0.0224, 'lps'),
	(531263, 131, '2014-02-01 01:15:26.000000', 'consum', 0.0218, 'lps'),
	(531264, 131, '2014-02-01 01:15:27.000000', 'consum', 0.0227, 'lps'),
	(531265, 131, '2014-02-01 01:15:28.000000', 'consum', 0.0216, 'lps'),
	(531266, 131, '2014-02-01 01:15:29.000000', 'consum', 0.0226, 'lps'),
	(531267, 131, '2014-02-01 01:15:30.000000', 'consum', 0.0218, 'lps'),
	(531268, 131, '2014-02-01 01:15:31.000000', 'consum', 0.0220, 'lps'),
	(531269, 131, '2014-02-01 01:15:32.000000', 'consum', 0.0220, 'lps'),
	(531270, 131, '2014-02-01 01:15:33.000000', 'consum', 0.0211, 'lps'),
	(531271, 131, '2014-02-01 01:15:34.000000', 'consum', 0.0223, 'lps'),
	(531272, 131, '2014-02-01 01:15:35.000000', 'consum', 0.0216, 'lps'),
	(531273, 131, '2014-02-01 01:15:36.000000', 'consum', 0.0220, 'lps'),
	(531274, 131, '2014-02-01 01:15:37.000000', 'consum', 0.0223, 'lps'),
	(531275, 131, '2014-02-01 01:15:38.000000', 'consum', 0.0212, 'lps'),
	(531276, 131, '2014-02-01 01:15:39.000000', 'consum', 0.0219, 'lps'),
	(531277, 131, '2014-02-01 01:15:40.000000', 'consum', 0.0211, 'lps'),
	(531278, 131, '2014-02-01 01:15:41.000000', 'consum', 0.0226, 'lps'),
	(531279, 131, '2014-02-01 01:15:42.000000', 'consum', 0.0213, 'lps'),
	(531280, 131, '2014-02-01 01:15:43.000000', 'consum', 0.0216, 'lps'),
	(531281, 131, '2014-02-01 01:15:44.000000', 'consum', 0.0211, 'lps'),
	(531282, 131, '2014-02-01 01:15:45.000000', 'consum', 0.0215, 'lps'),
	(531283, 131, '2014-02-01 01:15:46.000000', 'consum', 0.0215, 'lps'),
	(531284, 131, '2014-02-01 01:15:47.000000', 'consum', 0.0223, 'lps'),
	(531285, 131, '2014-02-01 01:15:48.000000', 'consum', 0.0222, 'lps'),
	(531286, 131, '2014-02-01 01:15:49.000000', 'consum', 0.0212, 'lps'),
	(531287, 131, '2014-02-01 01:15:50.000000', 'consum', 0.0223, 'lps'),
	(531288, 131, '2014-02-01 01:15:51.000000', 'consum', 0.0214, 'lps'),
	(531289, 131, '2014-02-01 01:15:52.000000', 'consum', 0.0211, 'lps'),
	(531290, 131, '2014-02-01 01:15:53.000000', 'consum', 0.0219, 'lps'),
	(531291, 131, '2014-02-01 01:15:54.000000', 'consum', 0.0219, 'lps'),
	(531292, 131, '2014-02-01 01:15:55.000000', 'consum', 0.0226, 'lps'),
	(531293, 131, '2014-02-01 01:15:56.000000', 'consum', 0.0213, 'lps'),
	(531294, 131, '2014-02-01 01:15:57.000000', 'consum', 0.0211, 'lps'),
	(531295, 131, '2014-02-01 01:15:58.000000', 'consum', 0.0225, 'lps'),
	(531296, 131, '2014-02-01 01:15:59.000000', 'consum', 0.0212, 'lps'),
	(531297, 131, '2014-02-01 01:16:00.000000', 'consum', 0.0227, 'lps'),
	(531298, 131, '2014-02-01 01:16:01.000000', 'consum', 0.0217, 'lps'),
	(531299, 131, '2014-02-01 01:16:02.000000', 'consum', 0.0212, 'lps'),
	(531300, 131, '2014-02-01 01:16:03.000000', 'consum', 0.0220, 'lps'),
	(531301, 131, '2014-02-01 01:16:04.000000', 'consum', 0.0216, 'lps'),
	(531302, 131, '2014-02-01 01:16:05.000000', 'consum', 0.0213, 'lps'),
	(531303, 131, '2014-02-01 01:16:06.000000', 'consum', 0.0224, 'lps'),
	(531304, 131, '2014-02-01 01:16:07.000000', 'consum', 0.0219, 'lps'),
	(531305, 131, '2014-02-01 01:16:08.000000', 'consum', 0.0211, 'lps'),
	(531306, 131, '2014-02-01 01:16:09.000000', 'consum', 0.0210, 'lps'),
	(531307, 131, '2014-02-01 01:16:10.000000', 'consum', 0.0223, 'lps'),
	(531308, 131, '2014-02-01 01:16:11.000000', 'consum', 0.0222, 'lps'),
	(531309, 131, '2014-02-01 01:16:12.000000', 'consum', 0.0214, 'lps'),
	(531310, 131, '2014-02-01 01:16:13.000000', 'consum', 0.0214, 'lps'),
	(531311, 131, '2014-02-01 01:16:14.000000', 'consum', 0.0218, 'lps'),
	(531312, 131, '2014-02-01 01:16:15.000000', 'consum', 0.0219, 'lps'),
	(531313, 131, '2014-02-01 01:16:16.000000', 'consum', 0.0213, 'lps'),
	(531314, 131, '2014-02-01 01:16:17.000000', 'consum', 0.0217, 'lps'),
	(531315, 131, '2014-02-01 01:16:18.000000', 'consum', 0.0218, 'lps'),
	(531316, 131, '2014-02-01 01:16:19.000000', 'consum', 0.0210, 'lps'),
	(531317, 131, '2014-02-01 01:16:20.000000', 'consum', 0.0225, 'lps'),
	(531318, 131, '2014-02-01 01:16:21.000000', 'consum', 0.0214, 'lps'),
	(531319, 131, '2014-02-01 01:16:22.000000', 'consum', 0.0220, 'lps'),
	(531320, 131, '2014-02-01 01:16:23.000000', 'consum', 0.0215, 'lps'),
	(531321, 131, '2014-02-01 01:16:24.000000', 'consum', 0.0220, 'lps'),
	(531322, 131, '2014-02-01 01:16:25.000000', 'consum', 0.0211, 'lps'),
	(531323, 131, '2014-02-01 01:16:26.000000', 'consum', 0.0220, 'lps'),
	(531324, 131, '2014-02-01 01:16:27.000000', 'consum', 0.0221, 'lps'),
	(531325, 131, '2014-02-01 01:16:28.000000', 'consum', 0.0217, 'lps'),
	(531326, 131, '2014-02-01 01:16:29.000000', 'consum', 0.0212, 'lps'),
	(531327, 131, '2014-02-01 01:16:30.000000', 'consum', 0.0218, 'lps'),
	(531328, 131, '2014-02-01 01:16:31.000000', 'consum', 0.0225, 'lps'),
	(531329, 131, '2014-02-01 01:16:32.000000', 'consum', 0.0227, 'lps'),
	(531330, 131, '2014-02-01 01:16:33.000000', 'consum', 0.0215, 'lps'),
	(531331, 131, '2014-02-01 01:16:34.000000', 'consum', 0.0220, 'lps'),
	(531332, 131, '2014-02-01 01:16:35.000000', 'consum', 0.0212, 'lps'),
	(531333, 131, '2014-02-01 01:16:36.000000', 'consum', 0.0223, 'lps'),
	(531334, 131, '2014-02-01 01:16:37.000000', 'consum', 0.0216, 'lps'),
	(531335, 131, '2014-02-01 01:16:38.000000', 'consum', 0.0220, 'lps'),
	(531336, 131, '2014-02-01 01:16:39.000000', 'consum', 0.0224, 'lps'),
	(531337, 131, '2014-02-01 01:16:40.000000', 'consum', 0.0217, 'lps'),
	(531338, 131, '2014-02-01 01:16:41.000000', 'consum', 0.0218, 'lps'),
	(531339, 131, '2014-02-01 01:16:42.000000', 'consum', 0.0213, 'lps'),
	(531340, 131, '2014-02-01 01:16:43.000000', 'consum', 0.0220, 'lps'),
	(531341, 131, '2014-02-01 01:16:44.000000', 'consum', 0.0215, 'lps'),
	(531342, 131, '2014-02-01 01:16:45.000000', 'consum', 0.0222, 'lps'),
	(531343, 131, '2014-02-01 01:16:46.000000', 'consum', 0.0219, 'lps'),
	(531344, 131, '2014-02-01 01:16:47.000000', 'consum', 0.0220, 'lps'),
	(531345, 131, '2014-02-01 01:16:48.000000', 'consum', 0.0218, 'lps'),
	(531346, 131, '2014-02-01 01:16:49.000000', 'consum', 0.0219, 'lps'),
	(531347, 131, '2014-02-01 01:16:50.000000', 'consum', 0.0214, 'lps'),
	(531348, 131, '2014-02-01 01:16:51.000000', 'consum', 0.0220, 'lps'),
	(531349, 131, '2014-02-01 01:16:52.000000', 'consum', 0.0214, 'lps'),
	(531350, 131, '2014-02-01 01:16:53.000000', 'consum', 0.0217, 'lps'),
	(531351, 131, '2014-02-01 01:16:54.000000', 'consum', 0.0218, 'lps'),
	(531352, 131, '2014-02-01 01:16:55.000000', 'consum', 0.0211, 'lps'),
	(531353, 131, '2014-02-01 01:16:56.000000', 'consum', 0.0225, 'lps'),
	(531354, 131, '2014-02-01 01:16:57.000000', 'consum', 0.0214, 'lps'),
	(531355, 131, '2014-02-01 01:16:58.000000', 'consum', 0.0219, 'lps'),
	(531356, 131, '2014-02-01 01:16:59.000000', 'consum', 0.0225, 'lps'),
	(531357, 131, '2014-02-01 01:17:00.000000', 'consum', 0.0225, 'lps'),
	(531358, 131, '2014-02-01 01:17:01.000000', 'consum', 0.0223, 'lps'),
	(531359, 131, '2014-02-01 01:17:02.000000', 'consum', 0.0212, 'lps'),
	(531360, 131, '2014-02-01 01:17:03.000000', 'consum', 0.0218, 'lps'),
	(531361, 131, '2014-02-01 01:17:04.000000', 'consum', 0.0227, 'lps'),
	(531362, 131, '2014-02-01 01:17:05.000000', 'consum', 0.0219, 'lps'),
	(531363, 131, '2014-02-01 01:17:06.000000', 'consum', 0.0219, 'lps'),
	(531364, 131, '2014-02-01 01:17:07.000000', 'consum', 0.0214, 'lps'),
	(531365, 131, '2014-02-01 01:17:08.000000', 'consum', 0.0218, 'lps'),
	(531366, 131, '2014-02-01 01:17:09.000000', 'consum', 0.0222, 'lps'),
	(531367, 131, '2014-02-01 01:17:10.000000', 'consum', 0.0210, 'lps'),
	(531368, 131, '2014-02-01 01:17:11.000000', 'consum', 0.0212, 'lps'),
	(531369, 131, '2014-02-01 01:17:12.000000', 'consum', 0.0221, 'lps'),
	(531370, 131, '2014-02-01 01:17:13.000000', 'consum', 0.0224, 'lps'),
	(531371, 131, '2014-02-01 01:17:14.000000', 'consum', 0.0212, 'lps'),
	(531372, 131, '2014-02-01 01:17:15.000000', 'consum', 0.0215, 'lps'),
	(531373, 131, '2014-02-01 01:17:16.000000', 'consum', 0.0212, 'lps'),
	(531374, 131, '2014-02-01 01:17:17.000000', 'consum', 0.0221, 'lps'),
	(531375, 131, '2014-02-01 01:17:18.000000', 'consum', 0.0225, 'lps'),
	(531376, 131, '2014-02-01 01:17:19.000000', 'consum', 0.0218, 'lps'),
	(531377, 131, '2014-02-01 01:17:20.000000', 'consum', 0.0221, 'lps'),
	(531378, 131, '2014-02-01 01:17:21.000000', 'consum', 0.0224, 'lps'),
	(531379, 131, '2014-02-01 01:17:22.000000', 'consum', 0.0210, 'lps'),
	(531380, 131, '2014-02-01 01:17:23.000000', 'consum', 0.0225, 'lps'),
	(531381, 131, '2014-02-01 01:17:24.000000', 'consum', 0.0215, 'lps'),
	(531382, 131, '2014-02-01 01:17:25.000000', 'consum', 0.0223, 'lps'),
	(531383, 131, '2014-02-01 01:17:26.000000', 'consum', 0.0226, 'lps'),
	(531384, 131, '2014-02-01 01:17:27.000000', 'consum', 0.0217, 'lps'),
	(531385, 131, '2014-02-01 01:17:28.000000', 'consum', 0.0213, 'lps'),
	(531386, 131, '2014-02-01 01:17:29.000000', 'consum', 0.0223, 'lps'),
	(531387, 131, '2014-02-01 01:17:30.000000', 'consum', 0.0211, 'lps'),
	(531388, 131, '2014-02-01 01:17:31.000000', 'consum', 0.0214, 'lps'),
	(531389, 131, '2014-02-01 01:17:32.000000', 'consum', 0.0227, 'lps'),
	(531390, 131, '2014-02-01 01:17:33.000000', 'consum', 0.0211, 'lps'),
	(531391, 131, '2014-02-01 01:17:34.000000', 'consum', 0.0219, 'lps'),
	(531392, 131, '2014-02-01 01:17:35.000000', 'consum', 0.0217, 'lps'),
	(531393, 131, '2014-02-01 01:17:36.000000', 'consum', 0.0218, 'lps'),
	(531394, 131, '2014-02-01 01:17:37.000000', 'consum', 0.0212, 'lps'),
	(531395, 131, '2014-02-01 01:17:38.000000', 'consum', 0.0215, 'lps'),
	(531396, 131, '2014-02-01 01:17:39.000000', 'consum', 0.0211, 'lps'),
	(531397, 131, '2014-02-01 01:17:40.000000', 'consum', 0.0217, 'lps'),
	(531398, 131, '2014-02-01 01:17:41.000000', 'consum', 0.0227, 'lps'),
	(531399, 131, '2014-02-01 01:17:42.000000', 'consum', 0.0219, 'lps'),
	(531400, 131, '2014-02-01 01:17:43.000000', 'consum', 0.0225, 'lps'),
	(531401, 131, '2014-02-01 01:17:44.000000', 'consum', 0.0220, 'lps'),
	(531402, 131, '2014-02-01 01:17:45.000000', 'consum', 0.0214, 'lps'),
	(531403, 131, '2014-02-01 01:17:46.000000', 'consum', 0.0222, 'lps'),
	(531404, 131, '2014-02-01 01:17:47.000000', 'consum', 0.0221, 'lps'),
	(531405, 131, '2014-02-01 01:17:48.000000', 'consum', 0.0211, 'lps'),
	(531406, 131, '2014-02-01 01:17:49.000000', 'consum', 0.0221, 'lps'),
	(531407, 131, '2014-02-01 01:17:50.000000', 'consum', 0.0224, 'lps'),
	(531408, 131, '2014-02-01 01:17:51.000000', 'consum', 0.0212, 'lps'),
	(531409, 131, '2014-02-01 01:17:52.000000', 'consum', 0.0214, 'lps'),
	(531410, 131, '2014-02-01 01:17:53.000000', 'consum', 0.0224, 'lps'),
	(531411, 131, '2014-02-01 01:17:54.000000', 'consum', 0.0213, 'lps'),
	(531412, 131, '2014-02-01 01:17:55.000000', 'consum', 0.0223, 'lps'),
	(531413, 131, '2014-02-01 01:17:56.000000', 'consum', 0.0210, 'lps'),
	(531414, 131, '2014-02-01 01:17:57.000000', 'consum', 0.0227, 'lps'),
	(531415, 131, '2014-02-01 01:17:58.000000', 'consum', 0.0221, 'lps'),
	(531416, 131, '2014-02-01 01:17:59.000000', 'consum', 0.0216, 'lps'),
	(531417, 131, '2014-02-01 01:18:00.000000', 'consum', 0.0224, 'lps'),
	(531418, 131, '2014-02-01 01:18:01.000000', 'consum', 0.0226, 'lps'),
	(531419, 131, '2014-02-01 01:18:02.000000', 'consum', 0.0215, 'lps'),
	(531420, 131, '2014-02-01 01:18:03.000000', 'consum', 0.0223, 'lps'),
	(531421, 131, '2014-02-01 01:18:04.000000', 'consum', 0.0225, 'lps'),
	(531422, 131, '2014-02-01 01:18:05.000000', 'consum', 0.0227, 'lps'),
	(531423, 131, '2014-02-01 01:18:06.000000', 'consum', 0.0217, 'lps'),
	(531424, 131, '2014-02-01 01:18:07.000000', 'consum', 0.0212, 'lps'),
	(531425, 131, '2014-02-01 01:18:08.000000', 'consum', 0.0216, 'lps'),
	(531426, 131, '2014-02-01 01:18:09.000000', 'consum', 0.0216, 'lps'),
	(531427, 131, '2014-02-01 01:18:10.000000', 'consum', 0.0223, 'lps'),
	(531428, 131, '2014-02-01 01:18:11.000000', 'consum', 0.0220, 'lps'),
	(531429, 131, '2014-02-01 01:18:12.000000', 'consum', 0.0224, 'lps'),
	(531430, 131, '2014-02-01 01:18:13.000000', 'consum', 0.0214, 'lps'),
	(531431, 131, '2014-02-01 01:18:14.000000', 'consum', 0.0226, 'lps'),
	(531432, 131, '2014-02-01 01:18:15.000000', 'consum', 0.0224, 'lps'),
	(531433, 131, '2014-02-01 01:18:16.000000', 'consum', 0.0215, 'lps'),
	(531434, 131, '2014-02-01 01:18:17.000000', 'consum', 0.0211, 'lps'),
	(531435, 131, '2014-02-01 01:18:18.000000', 'consum', 0.0220, 'lps'),
	(531436, 131, '2014-02-01 01:18:19.000000', 'consum', 0.0221, 'lps'),
	(531437, 131, '2014-02-01 01:18:20.000000', 'consum', 0.0215, 'lps'),
	(531438, 131, '2014-02-01 01:18:21.000000', 'consum', 0.0222, 'lps'),
	(531439, 131, '2014-02-01 01:18:22.000000', 'consum', 0.0220, 'lps'),
	(531440, 131, '2014-02-01 01:18:23.000000', 'consum', 0.0225, 'lps'),
	(531441, 131, '2014-02-01 01:18:24.000000', 'consum', 0.0217, 'lps'),
	(531442, 131, '2014-02-01 01:18:25.000000', 'consum', 0.0221, 'lps'),
	(531443, 131, '2014-02-01 01:18:26.000000', 'consum', 0.0225, 'lps'),
	(531444, 131, '2014-02-01 01:18:27.000000', 'consum', 0.0218, 'lps'),
	(531445, 131, '2014-02-01 01:18:28.000000', 'consum', 0.0222, 'lps'),
	(531446, 131, '2014-02-01 01:18:29.000000', 'consum', 0.0211, 'lps'),
	(531447, 131, '2014-02-01 01:18:30.000000', 'consum', 0.0217, 'lps'),
	(531448, 131, '2014-02-01 01:18:31.000000', 'consum', 0.0224, 'lps'),
	(531449, 131, '2014-02-01 01:18:32.000000', 'consum', 0.0222, 'lps'),
	(531450, 131, '2014-02-01 01:18:33.000000', 'consum', 0.0211, 'lps'),
	(531451, 131, '2014-02-01 01:18:34.000000', 'consum', 0.0216, 'lps'),
	(531452, 131, '2014-02-01 01:18:35.000000', 'consum', 0.0221, 'lps'),
	(531453, 131, '2014-02-01 01:18:36.000000', 'consum', 0.0227, 'lps'),
	(531454, 131, '2014-02-01 01:18:37.000000', 'consum', 0.0211, 'lps'),
	(531455, 131, '2014-02-01 01:18:38.000000', 'consum', 0.0218, 'lps'),
	(531456, 131, '2014-02-01 01:18:39.000000', 'consum', 0.0227, 'lps'),
	(531457, 131, '2014-02-01 01:18:40.000000', 'consum', 0.0219, 'lps'),
	(531458, 131, '2014-02-01 01:18:41.000000', 'consum', 0.0221, 'lps'),
	(531459, 131, '2014-02-01 01:18:42.000000', 'consum', 0.0221, 'lps'),
	(531460, 131, '2014-02-01 01:18:43.000000', 'consum', 0.0215, 'lps'),
	(531461, 131, '2014-02-01 01:18:44.000000', 'consum', 0.0222, 'lps'),
	(531462, 131, '2014-02-01 01:18:45.000000', 'consum', 0.0217, 'lps'),
	(531463, 131, '2014-02-01 01:18:46.000000', 'consum', 0.0211, 'lps'),
	(531464, 131, '2014-02-01 01:18:47.000000', 'consum', 0.0214, 'lps'),
	(531465, 131, '2014-02-01 01:18:48.000000', 'consum', 0.0224, 'lps'),
	(531466, 131, '2014-02-01 01:18:49.000000', 'consum', 0.0217, 'lps'),
	(531467, 131, '2014-02-01 01:18:50.000000', 'consum', 0.0221, 'lps'),
	(531468, 131, '2014-02-01 01:18:51.000000', 'consum', 0.0226, 'lps'),
	(531469, 131, '2014-02-01 01:18:52.000000', 'consum', 0.0222, 'lps'),
	(531470, 131, '2014-02-01 01:18:53.000000', 'consum', 0.0223, 'lps'),
	(531471, 131, '2014-02-01 01:18:54.000000', 'consum', 0.0221, 'lps'),
	(531472, 131, '2014-02-01 01:18:55.000000', 'consum', 0.0227, 'lps'),
	(531473, 131, '2014-02-01 01:18:56.000000', 'consum', 0.0227, 'lps'),
	(531474, 131, '2014-02-01 01:18:57.000000', 'consum', 0.0210, 'lps'),
	(531475, 131, '2014-02-01 01:18:58.000000', 'consum', 0.0211, 'lps'),
	(531476, 131, '2014-02-01 01:18:59.000000', 'consum', 0.0217, 'lps'),
	(531477, 131, '2014-02-01 01:19:00.000000', 'consum', 0.0225, 'lps'),
	(531478, 131, '2014-02-01 01:19:01.000000', 'consum', 0.0210, 'lps'),
	(531479, 131, '2014-02-01 01:19:02.000000', 'consum', 0.0219, 'lps'),
	(531480, 131, '2014-02-01 01:19:03.000000', 'consum', 0.0218, 'lps'),
	(531481, 131, '2014-02-01 01:19:04.000000', 'consum', 0.0223, 'lps'),
	(531482, 131, '2014-02-01 01:19:05.000000', 'consum', 0.0217, 'lps'),
	(531483, 131, '2014-02-01 01:19:06.000000', 'consum', 0.0225, 'lps'),
	(531484, 131, '2014-02-01 01:19:07.000000', 'consum', 0.0210, 'lps'),
	(531485, 131, '2014-02-01 01:19:08.000000', 'consum', 0.0220, 'lps'),
	(531486, 131, '2014-02-01 01:19:09.000000', 'consum', 0.0225, 'lps'),
	(531487, 131, '2014-02-01 01:19:10.000000', 'consum', 0.0218, 'lps'),
	(531488, 131, '2014-02-01 01:19:11.000000', 'consum', 0.0225, 'lps'),
	(531489, 131, '2014-02-01 01:19:12.000000', 'consum', 0.0227, 'lps'),
	(531490, 131, '2014-02-01 01:19:13.000000', 'consum', 0.0211, 'lps'),
	(531491, 131, '2014-02-01 01:19:14.000000', 'consum', 0.0222, 'lps'),
	(531492, 131, '2014-02-01 01:19:15.000000', 'consum', 0.0212, 'lps'),
	(531493, 131, '2014-02-01 01:19:16.000000', 'consum', 0.0219, 'lps'),
	(531494, 131, '2014-02-01 01:19:17.000000', 'consum', 0.0213, 'lps'),
	(531495, 131, '2014-02-01 01:19:18.000000', 'consum', 0.0216, 'lps'),
	(531496, 131, '2014-02-01 01:19:19.000000', 'consum', 0.0215, 'lps'),
	(531497, 131, '2014-02-01 01:19:20.000000', 'consum', 0.0218, 'lps'),
	(531498, 131, '2014-02-01 01:19:21.000000', 'consum', 0.0219, 'lps'),
	(531499, 131, '2014-02-01 01:19:22.000000', 'consum', 0.0212, 'lps'),
	(531500, 131, '2014-02-01 01:19:23.000000', 'consum', 0.0210, 'lps'),
	(531501, 131, '2014-02-01 01:19:24.000000', 'consum', 0.0224, 'lps'),
	(531502, 131, '2014-02-01 01:19:25.000000', 'consum', 0.0224, 'lps'),
	(531503, 131, '2014-02-01 01:19:26.000000', 'consum', 0.0224, 'lps'),
	(531504, 131, '2014-02-01 01:19:27.000000', 'consum', 0.0219, 'lps'),
	(531505, 131, '2014-02-01 01:19:28.000000', 'consum', 0.0215, 'lps'),
	(531506, 131, '2014-02-01 01:19:29.000000', 'consum', 0.0226, 'lps'),
	(531507, 131, '2014-02-01 01:19:30.000000', 'consum', 0.0219, 'lps'),
	(531508, 131, '2014-02-01 01:19:31.000000', 'consum', 0.0210, 'lps'),
	(531509, 131, '2014-02-01 01:19:32.000000', 'consum', 0.0219, 'lps'),
	(531510, 131, '2014-02-01 01:19:33.000000', 'consum', 0.0218, 'lps'),
	(531511, 131, '2014-02-01 01:19:34.000000', 'consum', 0.0223, 'lps'),
	(531512, 131, '2014-02-01 01:19:35.000000', 'consum', 0.0218, 'lps'),
	(531513, 131, '2014-02-01 01:19:36.000000', 'consum', 0.0210, 'lps'),
	(531514, 131, '2014-02-01 01:19:37.000000', 'consum', 0.0223, 'lps'),
	(531515, 131, '2014-02-01 01:19:38.000000', 'consum', 0.0222, 'lps'),
	(531516, 131, '2014-02-01 01:19:39.000000', 'consum', 0.0212, 'lps'),
	(531517, 131, '2014-02-01 01:19:40.000000', 'consum', 0.0219, 'lps'),
	(531518, 131, '2014-02-01 01:19:41.000000', 'consum', 0.0216, 'lps'),
	(531519, 131, '2014-02-01 01:19:42.000000', 'consum', 0.0214, 'lps'),
	(531520, 131, '2014-02-01 01:19:43.000000', 'consum', 0.0211, 'lps'),
	(531521, 131, '2014-02-01 01:19:44.000000', 'consum', 0.0223, 'lps'),
	(531522, 131, '2014-02-01 01:19:45.000000', 'consum', 0.0217, 'lps'),
	(531523, 131, '2014-02-01 01:19:46.000000', 'consum', 0.0226, 'lps'),
	(531524, 131, '2014-02-01 01:19:47.000000', 'consum', 0.0217, 'lps'),
	(531525, 131, '2014-02-01 01:19:48.000000', 'consum', 0.0213, 'lps'),
	(531526, 131, '2014-02-01 01:19:49.000000', 'consum', 0.0225, 'lps'),
	(531527, 131, '2014-02-01 01:19:50.000000', 'consum', 0.0220, 'lps'),
	(531528, 131, '2014-02-01 01:19:51.000000', 'consum', 0.0215, 'lps'),
	(531529, 131, '2014-02-01 01:19:52.000000', 'consum', 0.0224, 'lps'),
	(531530, 131, '2014-02-01 01:19:53.000000', 'consum', 0.0212, 'lps'),
	(531531, 131, '2014-02-01 01:19:54.000000', 'consum', 0.0214, 'lps'),
	(531532, 131, '2014-02-01 01:19:55.000000', 'consum', 0.0225, 'lps'),
	(531533, 131, '2014-02-01 01:19:56.000000', 'consum', 0.0218, 'lps'),
	(531534, 131, '2014-02-01 01:19:57.000000', 'consum', 0.0225, 'lps'),
	(531535, 131, '2014-02-01 01:19:58.000000', 'consum', 0.0225, 'lps'),
	(531536, 131, '2014-02-01 01:19:59.000000', 'consum', 0.0223, 'lps'),
	(531537, 131, '2014-02-01 01:20:00.000000', 'consum', 0.0211, 'lps'),
	(531538, 131, '2014-02-01 01:20:01.000000', 'consum', 0.0215, 'lps'),
	(531539, 131, '2014-02-01 01:20:02.000000', 'consum', 0.0212, 'lps'),
	(531540, 131, '2014-02-01 01:20:03.000000', 'consum', 0.0223, 'lps'),
	(531541, 131, '2014-02-01 01:20:04.000000', 'consum', 0.0216, 'lps'),
	(531542, 131, '2014-02-01 01:20:05.000000', 'consum', 0.0221, 'lps'),
	(531543, 131, '2014-02-01 01:20:06.000000', 'consum', 0.0227, 'lps'),
	(531544, 131, '2014-02-01 01:20:07.000000', 'consum', 0.0211, 'lps'),
	(531545, 131, '2014-02-01 01:20:08.000000', 'consum', 0.0217, 'lps'),
	(531546, 131, '2014-02-01 01:20:09.000000', 'consum', 0.0225, 'lps'),
	(531547, 131, '2014-02-01 01:20:10.000000', 'consum', 0.0210, 'lps'),
	(531548, 131, '2014-02-01 01:20:11.000000', 'consum', 0.0221, 'lps'),
	(531549, 131, '2014-02-01 01:20:12.000000', 'consum', 0.0211, 'lps'),
	(531550, 131, '2014-02-01 01:20:13.000000', 'consum', 0.0219, 'lps'),
	(531551, 131, '2014-02-01 01:20:14.000000', 'consum', 0.0216, 'lps'),
	(531552, 131, '2014-02-01 01:20:15.000000', 'consum', 0.0213, 'lps'),
	(531553, 131, '2014-02-01 01:20:16.000000', 'consum', 0.0226, 'lps'),
	(531554, 131, '2014-02-01 01:20:17.000000', 'consum', 0.0211, 'lps'),
	(531555, 131, '2014-02-01 01:20:18.000000', 'consum', 0.0219, 'lps'),
	(531556, 131, '2014-02-01 01:20:19.000000', 'consum', 0.0215, 'lps'),
	(531557, 131, '2014-02-01 01:20:20.000000', 'consum', 0.0212, 'lps'),
	(531558, 131, '2014-02-01 01:20:21.000000', 'consum', 0.0223, 'lps'),
	(531559, 131, '2014-02-01 01:20:22.000000', 'consum', 0.0215, 'lps'),
	(531560, 131, '2014-02-01 01:20:23.000000', 'consum', 0.0212, 'lps'),
	(531561, 131, '2014-02-01 01:20:24.000000', 'consum', 0.0227, 'lps'),
	(531562, 131, '2014-02-01 01:20:25.000000', 'consum', 0.0217, 'lps'),
	(531563, 131, '2014-02-01 01:20:26.000000', 'consum', 0.0211, 'lps'),
	(531564, 131, '2014-02-01 01:20:27.000000', 'consum', 0.0214, 'lps'),
	(531565, 131, '2014-02-01 01:20:28.000000', 'consum', 0.0227, 'lps'),
	(531566, 131, '2014-02-01 01:20:29.000000', 'consum', 0.0213, 'lps'),
	(531567, 131, '2014-02-01 01:20:30.000000', 'consum', 0.0227, 'lps'),
	(531568, 131, '2014-02-01 01:20:31.000000', 'consum', 0.0216, 'lps'),
	(531569, 131, '2014-02-01 01:20:32.000000', 'consum', 0.0224, 'lps'),
	(531570, 131, '2014-02-01 01:20:33.000000', 'consum', 0.0226, 'lps'),
	(531571, 131, '2014-02-01 01:20:34.000000', 'consum', 0.0213, 'lps'),
	(531572, 131, '2014-02-01 01:20:35.000000', 'consum', 0.0213, 'lps'),
	(531573, 131, '2014-02-01 01:20:36.000000', 'consum', 0.0218, 'lps'),
	(531574, 131, '2014-02-01 01:20:37.000000', 'consum', 0.0223, 'lps'),
	(531575, 131, '2014-02-01 01:20:38.000000', 'consum', 0.0213, 'lps'),
	(531576, 131, '2014-02-01 01:20:39.000000', 'consum', 0.0226, 'lps'),
	(531577, 131, '2014-02-01 01:20:40.000000', 'consum', 0.0226, 'lps'),
	(531578, 131, '2014-02-01 01:20:41.000000', 'consum', 0.0226, 'lps'),
	(531579, 131, '2014-02-01 01:20:42.000000', 'consum', 0.0222, 'lps'),
	(531580, 131, '2014-02-01 01:20:43.000000', 'consum', 0.0222, 'lps'),
	(531581, 131, '2014-02-01 01:20:44.000000', 'consum', 0.0217, 'lps'),
	(531582, 131, '2014-02-01 01:20:45.000000', 'consum', 0.0226, 'lps'),
	(531583, 131, '2014-02-01 01:20:46.000000', 'consum', 0.0218, 'lps'),
	(531584, 131, '2014-02-01 01:20:47.000000', 'consum', 0.0220, 'lps'),
	(531585, 131, '2014-02-01 01:20:48.000000', 'consum', 0.0218, 'lps'),
	(531586, 131, '2014-02-01 01:20:49.000000', 'consum', 0.0219, 'lps'),
	(531587, 131, '2014-02-01 01:20:50.000000', 'consum', 0.0216, 'lps'),
	(531588, 131, '2014-02-01 01:20:51.000000', 'consum', 0.0212, 'lps'),
	(531589, 131, '2014-02-01 01:20:52.000000', 'consum', 0.0219, 'lps'),
	(531590, 131, '2014-02-01 01:20:53.000000', 'consum', 0.0215, 'lps'),
	(531591, 131, '2014-02-01 01:20:54.000000', 'consum', 0.0227, 'lps'),
	(531592, 131, '2014-02-01 01:20:55.000000', 'consum', 0.0225, 'lps'),
	(531593, 131, '2014-02-01 01:20:56.000000', 'consum', 0.0216, 'lps'),
	(531594, 131, '2014-02-01 01:20:57.000000', 'consum', 0.0216, 'lps'),
	(531595, 131, '2014-02-01 01:20:58.000000', 'consum', 0.0220, 'lps'),
	(531596, 131, '2014-02-01 01:20:59.000000', 'consum', 0.0227, 'lps'),
	(531597, 131, '2014-02-01 01:21:00.000000', 'consum', 0.0210, 'lps'),
	(531598, 131, '2014-02-01 01:21:01.000000', 'consum', 0.0214, 'lps'),
	(531599, 131, '2014-02-01 01:21:02.000000', 'consum', 0.0213, 'lps'),
	(531600, 131, '2014-02-01 01:21:03.000000', 'consum', 0.0215, 'lps'),
	(531601, 131, '2014-02-01 01:21:04.000000', 'consum', 0.0225, 'lps'),
	(531602, 131, '2014-02-01 01:21:05.000000', 'consum', 0.0219, 'lps'),
	(531603, 131, '2014-02-01 01:21:06.000000', 'consum', 0.0225, 'lps'),
	(531604, 131, '2014-02-01 01:21:07.000000', 'consum', 0.0225, 'lps'),
	(531605, 131, '2014-02-01 01:21:08.000000', 'consum', 0.0221, 'lps'),
	(531606, 131, '2014-02-01 01:21:09.000000', 'consum', 0.0222, 'lps'),
	(531607, 131, '2014-02-01 01:21:10.000000', 'consum', 0.0219, 'lps'),
	(531608, 131, '2014-02-01 01:21:11.000000', 'consum', 0.0220, 'lps'),
	(531609, 131, '2014-02-01 01:21:12.000000', 'consum', 0.0217, 'lps'),
	(531610, 131, '2014-02-01 01:21:13.000000', 'consum', 0.0214, 'lps'),
	(531611, 131, '2014-02-01 01:21:14.000000', 'consum', 0.0227, 'lps'),
	(531612, 131, '2014-02-01 01:21:15.000000', 'consum', 0.0214, 'lps'),
	(531613, 131, '2014-02-01 01:21:16.000000', 'consum', 0.0213, 'lps'),
	(531614, 131, '2014-02-01 01:21:17.000000', 'consum', 0.0215, 'lps'),
	(531615, 131, '2014-02-01 01:21:18.000000', 'consum', 0.0227, 'lps'),
	(531616, 131, '2014-02-01 01:21:19.000000', 'consum', 0.0227, 'lps'),
	(531617, 131, '2014-02-01 01:21:20.000000', 'consum', 0.0225, 'lps'),
	(531618, 131, '2014-02-01 01:21:21.000000', 'consum', 0.0218, 'lps'),
	(531619, 131, '2014-02-01 01:21:22.000000', 'consum', 0.0223, 'lps'),
	(531620, 131, '2014-02-01 01:21:23.000000', 'consum', 0.0214, 'lps'),
	(531621, 131, '2014-02-01 01:21:24.000000', 'consum', 0.0210, 'lps'),
	(531622, 131, '2014-02-01 01:21:25.000000', 'consum', 0.0218, 'lps'),
	(531623, 131, '2014-02-01 01:21:26.000000', 'consum', 0.0212, 'lps'),
	(531624, 131, '2014-02-01 01:21:27.000000', 'consum', 0.0215, 'lps'),
	(531625, 131, '2014-02-01 01:21:28.000000', 'consum', 0.0213, 'lps'),
	(531626, 131, '2014-02-01 01:21:29.000000', 'consum', 0.0226, 'lps'),
	(531627, 131, '2014-02-01 01:21:30.000000', 'consum', 0.0210, 'lps'),
	(531628, 131, '2014-02-01 01:21:31.000000', 'consum', 0.0215, 'lps'),
	(531629, 131, '2014-02-01 01:21:32.000000', 'consum', 0.0219, 'lps'),
	(531630, 131, '2014-02-01 01:21:33.000000', 'consum', 0.0221, 'lps'),
	(531631, 131, '2014-02-01 01:21:34.000000', 'consum', 0.0223, 'lps'),
	(531632, 131, '2014-02-01 01:21:35.000000', 'consum', 0.0226, 'lps'),
	(531633, 131, '2014-02-01 01:21:36.000000', 'consum', 0.0212, 'lps'),
	(531634, 131, '2014-02-01 01:21:37.000000', 'consum', 0.0226, 'lps'),
	(531635, 131, '2014-02-01 01:21:38.000000', 'consum', 0.0214, 'lps'),
	(531636, 131, '2014-02-01 01:21:39.000000', 'consum', 0.0217, 'lps'),
	(531637, 131, '2014-02-01 01:21:40.000000', 'consum', 0.0217, 'lps'),
	(531638, 131, '2014-02-01 01:21:41.000000', 'consum', 0.0225, 'lps'),
	(531639, 131, '2014-02-01 01:21:42.000000', 'consum', 0.0227, 'lps'),
	(531640, 131, '2014-02-01 01:21:43.000000', 'consum', 0.0217, 'lps'),
	(531641, 131, '2014-02-01 01:21:44.000000', 'consum', 0.0211, 'lps'),
	(531642, 131, '2014-02-01 01:21:45.000000', 'consum', 0.0211, 'lps'),
	(531643, 131, '2014-02-01 01:21:46.000000', 'consum', 0.0215, 'lps'),
	(531644, 131, '2014-02-01 01:21:47.000000', 'consum', 0.0213, 'lps'),
	(531645, 131, '2014-02-01 01:21:48.000000', 'consum', 0.0211, 'lps'),
	(531646, 131, '2014-02-01 01:21:49.000000', 'consum', 0.0225, 'lps'),
	(531647, 131, '2014-02-01 01:21:50.000000', 'consum', 0.0210, 'lps'),
	(531648, 131, '2014-02-01 01:21:51.000000', 'consum', 0.0219, 'lps'),
	(531649, 131, '2014-02-01 01:21:52.000000', 'consum', 0.0221, 'lps'),
	(531650, 131, '2014-02-01 01:21:53.000000', 'consum', 0.0221, 'lps'),
	(531651, 131, '2014-02-01 01:21:54.000000', 'consum', 0.0215, 'lps'),
	(531652, 131, '2014-02-01 01:21:55.000000', 'consum', 0.0221, 'lps'),
	(531653, 131, '2014-02-01 01:21:56.000000', 'consum', 0.0215, 'lps'),
	(531654, 131, '2014-02-01 01:21:57.000000', 'consum', 0.0221, 'lps'),
	(531655, 131, '2014-02-01 01:21:58.000000', 'consum', 0.0214, 'lps'),
	(531656, 131, '2014-02-01 01:21:59.000000', 'consum', 0.0214, 'lps'),
	(531657, 131, '2014-02-01 01:22:00.000000', 'consum', 0.0219, 'lps'),
	(531658, 131, '2014-02-01 01:22:01.000000', 'consum', 0.0225, 'lps'),
	(531659, 131, '2014-02-01 01:22:02.000000', 'consum', 0.0225, 'lps'),
	(531660, 131, '2014-02-01 01:22:03.000000', 'consum', 0.0221, 'lps'),
	(531661, 131, '2014-02-01 01:22:04.000000', 'consum', 0.0219, 'lps'),
	(531662, 131, '2014-02-01 01:22:05.000000', 'consum', 0.0222, 'lps'),
	(531663, 131, '2014-02-01 01:22:06.000000', 'consum', 0.0226, 'lps'),
	(531664, 131, '2014-02-01 01:22:07.000000', 'consum', 0.0219, 'lps'),
	(531665, 131, '2014-02-01 01:22:08.000000', 'consum', 0.0227, 'lps'),
	(531666, 131, '2014-02-01 01:22:09.000000', 'consum', 0.0215, 'lps'),
	(531667, 131, '2014-02-01 01:22:10.000000', 'consum', 0.0219, 'lps'),
	(531668, 131, '2014-02-01 01:22:11.000000', 'consum', 0.0225, 'lps'),
	(531669, 131, '2014-02-01 01:22:12.000000', 'consum', 0.0220, 'lps'),
	(531670, 131, '2014-02-01 01:22:13.000000', 'consum', 0.0216, 'lps'),
	(531671, 131, '2014-02-01 01:22:14.000000', 'consum', 0.0211, 'lps'),
	(531672, 131, '2014-02-01 01:22:15.000000', 'consum', 0.0215, 'lps'),
	(531673, 131, '2014-02-01 01:22:16.000000', 'consum', 0.0213, 'lps'),
	(531674, 131, '2014-02-01 01:22:17.000000', 'consum', 0.0212, 'lps'),
	(531675, 131, '2014-02-01 01:22:18.000000', 'consum', 0.0213, 'lps'),
	(531676, 131, '2014-02-01 01:22:19.000000', 'consum', 0.0218, 'lps'),
	(531677, 131, '2014-02-01 01:22:20.000000', 'consum', 0.0222, 'lps'),
	(531678, 131, '2014-02-01 01:22:21.000000', 'consum', 0.0212, 'lps'),
	(531679, 131, '2014-02-01 01:22:22.000000', 'consum', 0.0218, 'lps'),
	(531680, 131, '2014-02-01 01:22:23.000000', 'consum', 0.0211, 'lps'),
	(531681, 131, '2014-02-01 01:22:24.000000', 'consum', 0.0227, 'lps'),
	(531682, 131, '2014-02-01 01:22:25.000000', 'consum', 0.0221, 'lps'),
	(531683, 131, '2014-02-01 01:22:26.000000', 'consum', 0.0214, 'lps'),
	(531684, 131, '2014-02-01 01:22:27.000000', 'consum', 0.0214, 'lps'),
	(531685, 131, '2014-02-01 01:22:28.000000', 'consum', 0.0220, 'lps'),
	(531686, 131, '2014-02-01 01:22:29.000000', 'consum', 0.0211, 'lps'),
	(531687, 131, '2014-02-01 01:22:30.000000', 'consum', 0.0222, 'lps'),
	(531688, 131, '2014-02-01 01:22:31.000000', 'consum', 0.0215, 'lps'),
	(531689, 131, '2014-02-01 01:22:32.000000', 'consum', 0.0219, 'lps'),
	(531690, 131, '2014-02-01 01:22:33.000000', 'consum', 0.0219, 'lps'),
	(531691, 131, '2014-02-01 01:22:34.000000', 'consum', 0.0211, 'lps'),
	(531692, 131, '2014-02-01 01:22:35.000000', 'consum', 0.0224, 'lps'),
	(531693, 131, '2014-02-01 01:22:36.000000', 'consum', 0.0226, 'lps'),
	(531694, 131, '2014-02-01 01:22:37.000000', 'consum', 0.0212, 'lps'),
	(531695, 131, '2014-02-01 01:22:38.000000', 'consum', 0.0225, 'lps'),
	(531696, 131, '2014-02-01 01:22:39.000000', 'consum', 0.0227, 'lps'),
	(531697, 131, '2014-02-01 01:22:40.000000', 'consum', 0.0214, 'lps'),
	(531698, 131, '2014-02-01 01:22:41.000000', 'consum', 0.0214, 'lps'),
	(531699, 131, '2014-02-01 01:22:42.000000', 'consum', 0.0219, 'lps'),
	(531700, 131, '2014-02-01 01:22:43.000000', 'consum', 0.0224, 'lps'),
	(531701, 131, '2014-02-01 01:22:44.000000', 'consum', 0.0218, 'lps'),
	(531702, 131, '2014-02-01 01:22:45.000000', 'consum', 0.0227, 'lps'),
	(531703, 131, '2014-02-01 01:22:46.000000', 'consum', 0.0218, 'lps'),
	(531704, 131, '2014-02-01 01:22:47.000000', 'consum', 0.0217, 'lps'),
	(531705, 131, '2014-02-01 01:22:48.000000', 'consum', 0.0223, 'lps'),
	(531706, 131, '2014-02-01 01:22:49.000000', 'consum', 0.0219, 'lps'),
	(531707, 131, '2014-02-01 01:22:50.000000', 'consum', 0.0217, 'lps'),
	(531708, 131, '2014-02-01 01:22:51.000000', 'consum', 0.0216, 'lps'),
	(531709, 131, '2014-02-01 01:22:52.000000', 'consum', 0.0220, 'lps'),
	(531710, 131, '2014-02-01 01:22:53.000000', 'consum', 0.0225, 'lps'),
	(531711, 131, '2014-02-01 01:22:54.000000', 'consum', 0.0221, 'lps'),
	(531712, 131, '2014-02-01 01:22:55.000000', 'consum', 0.0221, 'lps'),
	(531713, 131, '2014-02-01 01:22:56.000000', 'consum', 0.0214, 'lps'),
	(531714, 131, '2014-02-01 01:22:57.000000', 'consum', 0.0214, 'lps'),
	(531715, 131, '2014-02-01 01:22:58.000000', 'consum', 0.0220, 'lps'),
	(531716, 131, '2014-02-01 01:22:59.000000', 'consum', 0.0213, 'lps'),
	(531717, 131, '2014-02-01 01:23:00.000000', 'consum', 0.0214, 'lps'),
	(531718, 131, '2014-02-01 01:23:01.000000', 'consum', 0.0221, 'lps'),
	(531719, 131, '2014-02-01 01:23:02.000000', 'consum', 0.0218, 'lps'),
	(531720, 131, '2014-02-01 01:23:03.000000', 'consum', 0.0219, 'lps'),
	(531721, 131, '2014-02-01 01:23:04.000000', 'consum', 0.0210, 'lps'),
	(531722, 131, '2014-02-01 01:23:05.000000', 'consum', 0.0222, 'lps'),
	(531723, 131, '2014-02-01 01:23:06.000000', 'consum', 0.0217, 'lps'),
	(531724, 131, '2014-02-01 01:23:07.000000', 'consum', 0.0225, 'lps'),
	(531725, 131, '2014-02-01 01:23:08.000000', 'consum', 0.0210, 'lps'),
	(531726, 131, '2014-02-01 01:23:09.000000', 'consum', 0.0221, 'lps'),
	(531727, 131, '2014-02-01 01:23:10.000000', 'consum', 0.0211, 'lps'),
	(531728, 131, '2014-02-01 01:23:11.000000', 'consum', 0.0220, 'lps'),
	(531729, 131, '2014-02-01 01:23:12.000000', 'consum', 0.0220, 'lps'),
	(531730, 131, '2014-02-01 01:23:13.000000', 'consum', 0.0214, 'lps'),
	(531731, 131, '2014-02-01 01:23:14.000000', 'consum', 0.0218, 'lps'),
	(531732, 131, '2014-02-01 01:23:15.000000', 'consum', 0.0220, 'lps'),
	(531733, 131, '2014-02-01 01:23:16.000000', 'consum', 0.0217, 'lps'),
	(531734, 131, '2014-02-01 01:23:17.000000', 'consum', 0.0217, 'lps'),
	(531735, 131, '2014-02-01 01:23:18.000000', 'consum', 0.0225, 'lps'),
	(531736, 131, '2014-02-01 01:23:19.000000', 'consum', 0.0211, 'lps'),
	(531737, 131, '2014-02-01 01:23:20.000000', 'consum', 0.0225, 'lps'),
	(531738, 131, '2014-02-01 01:23:21.000000', 'consum', 0.0211, 'lps'),
	(531739, 131, '2014-02-01 01:23:22.000000', 'consum', 0.0224, 'lps'),
	(531740, 131, '2014-02-01 01:23:23.000000', 'consum', 0.0223, 'lps'),
	(531741, 131, '2014-02-01 01:23:24.000000', 'consum', 0.0214, 'lps'),
	(531742, 131, '2014-02-01 01:23:25.000000', 'consum', 0.0227, 'lps'),
	(531743, 131, '2014-02-01 01:23:26.000000', 'consum', 0.0211, 'lps'),
	(531744, 131, '2014-02-01 01:23:27.000000', 'consum', 0.0218, 'lps'),
	(531745, 131, '2014-02-01 01:23:28.000000', 'consum', 0.0215, 'lps'),
	(531746, 131, '2014-02-01 01:23:29.000000', 'consum', 0.0226, 'lps'),
	(531747, 131, '2014-02-01 01:23:30.000000', 'consum', 0.0224, 'lps'),
	(531748, 131, '2014-02-01 01:23:31.000000', 'consum', 0.0212, 'lps'),
	(531749, 131, '2014-02-01 01:23:32.000000', 'consum', 0.0216, 'lps'),
	(531750, 131, '2014-02-01 01:23:33.000000', 'consum', 0.0216, 'lps'),
	(531751, 131, '2014-02-01 01:23:34.000000', 'consum', 0.0221, 'lps'),
	(531752, 131, '2014-02-01 01:23:35.000000', 'consum', 0.0213, 'lps'),
	(531753, 131, '2014-02-01 01:23:36.000000', 'consum', 0.0211, 'lps'),
	(531754, 131, '2014-02-01 01:23:37.000000', 'consum', 0.0225, 'lps'),
	(531755, 131, '2014-02-01 01:23:38.000000', 'consum', 0.0210, 'lps'),
	(531756, 131, '2014-02-01 01:23:39.000000', 'consum', 0.0218, 'lps'),
	(531757, 131, '2014-02-01 01:23:40.000000', 'consum', 0.0217, 'lps'),
	(531758, 131, '2014-02-01 01:23:41.000000', 'consum', 0.0218, 'lps'),
	(531759, 131, '2014-02-01 01:23:42.000000', 'consum', 0.0215, 'lps'),
	(531760, 127, '2014-02-15 00:00:00.000000', 'consum', 0.0219, 'lps'),
	(531761, 127, '2014-02-15 00:00:01.000000', 'consum', 0.0210, 'lps'),
	(531762, 127, '2014-02-15 00:00:02.000000', 'consum', 0.0213, 'lps'),
	(531763, 127, '2014-02-15 00:00:03.000000', 'consum', 0.0215, 'lps'),
	(531764, 127, '2014-02-15 00:00:04.000000', 'consum', 0.0217, 'lps'),
	(531765, 127, '2014-02-15 00:00:05.000000', 'consum', 0.0210, 'lps'),
	(531766, 127, '2014-02-15 00:00:06.000000', 'consum', 0.0218, 'lps'),
	(531767, 127, '2014-02-15 00:00:07.000000', 'consum', 0.0213, 'lps'),
	(531768, 127, '2014-02-15 00:00:08.000000', 'consum', 0.0211, 'lps'),
	(531769, 127, '2014-02-15 00:00:09.000000', 'consum', 0.0217, 'lps'),
	(531770, 127, '2014-02-15 00:00:10.000000', 'consum', 0.0214, 'lps'),
	(531771, 127, '2014-02-15 00:00:11.000000', 'consum', 0.0219, 'lps'),
	(531772, 127, '2014-02-15 00:00:12.000000', 'consum', 0.0212, 'lps'),
	(531773, 127, '2014-02-15 00:00:13.000000', 'consum', 0.0216, 'lps'),
	(531774, 127, '2014-02-15 00:00:14.000000', 'consum', 0.0213, 'lps'),
	(531775, 127, '2014-02-15 00:00:15.000000', 'consum', 0.0218, 'lps'),
	(531776, 127, '2014-02-15 00:00:16.000000', 'consum', 0.0212, 'lps'),
	(531777, 127, '2014-02-15 00:00:17.000000', 'consum', 0.0217, 'lps'),
	(531778, 127, '2014-02-15 00:00:18.000000', 'consum', 0.0210, 'lps'),
	(531779, 127, '2014-02-15 00:00:19.000000', 'consum', 0.0218, 'lps'),
	(531780, 127, '2014-02-15 00:00:20.000000', 'consum', 0.0210, 'lps'),
	(531781, 127, '2014-02-15 00:00:21.000000', 'consum', 0.0219, 'lps'),
	(531782, 127, '2014-02-15 00:00:22.000000', 'consum', 0.0212, 'lps'),
	(531783, 127, '2014-02-15 00:00:23.000000', 'consum', 0.0216, 'lps'),
	(531784, 127, '2014-02-15 00:00:24.000000', 'consum', 0.0212, 'lps'),
	(531785, 127, '2014-02-15 00:00:25.000000', 'consum', 0.0213, 'lps'),
	(531786, 127, '2014-02-15 00:00:26.000000', 'consum', 0.0212, 'lps'),
	(531787, 127, '2014-02-15 00:00:27.000000', 'consum', 0.0210, 'lps'),
	(531788, 127, '2014-02-15 00:00:28.000000', 'consum', 0.0217, 'lps'),
	(531789, 127, '2014-02-15 00:00:29.000000', 'consum', 0.0212, 'lps'),
	(531790, 127, '2014-02-15 00:00:30.000000', 'consum', 0.0212, 'lps'),
	(531791, 127, '2014-02-15 00:00:31.000000', 'consum', 0.0212, 'lps'),
	(531792, 127, '2014-02-15 00:00:32.000000', 'consum', 0.0216, 'lps'),
	(531793, 127, '2014-02-15 00:00:33.000000', 'consum', 0.0213, 'lps'),
	(531794, 127, '2014-02-15 00:00:34.000000', 'consum', 0.0217, 'lps'),
	(531795, 127, '2014-02-15 00:00:35.000000', 'consum', 0.0219, 'lps'),
	(531796, 127, '2014-02-15 00:00:36.000000', 'consum', 0.0215, 'lps'),
	(531797, 127, '2014-02-15 00:00:37.000000', 'consum', 0.0218, 'lps'),
	(531798, 127, '2014-02-15 00:00:38.000000', 'consum', 0.0215, 'lps'),
	(531799, 127, '2014-02-15 00:00:39.000000', 'consum', 0.0211, 'lps'),
	(531800, 127, '2014-02-15 00:00:40.000000', 'consum', 0.0211, 'lps'),
	(531801, 127, '2014-02-15 00:00:41.000000', 'consum', 0.0213, 'lps'),
	(531802, 127, '2014-02-15 00:00:42.000000', 'consum', 0.0210, 'lps'),
	(531803, 127, '2014-02-15 00:00:43.000000', 'consum', 0.0214, 'lps'),
	(531804, 127, '2014-02-15 00:00:44.000000', 'consum', 0.0219, 'lps'),
	(531805, 127, '2014-02-15 00:00:45.000000', 'consum', 0.0214, 'lps'),
	(531806, 127, '2014-02-15 00:00:46.000000', 'consum', 0.0215, 'lps'),
	(531807, 127, '2014-02-15 00:00:47.000000', 'consum', 0.0212, 'lps'),
	(531808, 127, '2014-02-15 00:00:48.000000', 'consum', 0.0216, 'lps'),
	(531809, 127, '2014-02-15 00:00:49.000000', 'consum', 0.0214, 'lps'),
	(531810, 127, '2014-02-15 00:00:50.000000', 'consum', 0.0213, 'lps'),
	(531811, 127, '2014-02-15 00:00:51.000000', 'consum', 0.0213, 'lps'),
	(531812, 127, '2014-02-15 00:00:52.000000', 'consum', 0.0215, 'lps'),
	(531813, 127, '2014-02-15 00:00:53.000000', 'consum', 0.0218, 'lps'),
	(531814, 127, '2014-02-15 00:00:54.000000', 'consum', 0.0217, 'lps'),
	(531815, 127, '2014-02-15 00:00:55.000000', 'consum', 0.0219, 'lps'),
	(531816, 127, '2014-02-15 00:00:56.000000', 'consum', 0.0217, 'lps'),
	(531817, 127, '2014-02-15 00:00:57.000000', 'consum', 0.0219, 'lps'),
	(531818, 127, '2014-02-15 00:00:58.000000', 'consum', 0.0214, 'lps'),
	(531819, 127, '2014-02-15 00:00:59.000000', 'consum', 0.0211, 'lps'),
	(531820, 127, '2014-02-15 00:01:00.000000', 'consum', 0.0215, 'lps'),
	(531821, 127, '2014-02-15 00:01:01.000000', 'consum', 0.0213, 'lps'),
	(531822, 127, '2014-02-15 00:01:02.000000', 'consum', 0.0212, 'lps'),
	(531823, 127, '2014-02-15 00:01:03.000000', 'consum', 0.0210, 'lps'),
	(531824, 127, '2014-02-15 00:01:04.000000', 'consum', 0.0216, 'lps'),
	(531825, 127, '2014-02-15 00:01:05.000000', 'consum', 0.0210, 'lps'),
	(531826, 127, '2014-02-15 00:01:06.000000', 'consum', 0.0210, 'lps'),
	(531827, 127, '2014-02-15 00:01:07.000000', 'consum', 0.0213, 'lps'),
	(531828, 127, '2014-02-15 00:01:08.000000', 'consum', 0.0216, 'lps'),
	(531829, 127, '2014-02-15 00:01:09.000000', 'consum', 0.0219, 'lps'),
	(531830, 127, '2014-02-15 00:01:10.000000', 'consum', 0.0218, 'lps'),
	(531831, 127, '2014-02-15 00:01:11.000000', 'consum', 0.0212, 'lps'),
	(531832, 127, '2014-02-15 00:01:12.000000', 'consum', 0.0218, 'lps'),
	(531833, 127, '2014-02-15 00:01:13.000000', 'consum', 0.0216, 'lps'),
	(531834, 127, '2014-02-15 00:01:14.000000', 'consum', 0.0214, 'lps'),
	(531835, 127, '2014-02-15 00:01:15.000000', 'consum', 0.0214, 'lps'),
	(531836, 127, '2014-02-15 00:01:16.000000', 'consum', 0.0217, 'lps'),
	(531837, 127, '2014-02-15 00:01:17.000000', 'consum', 0.0214, 'lps'),
	(531838, 127, '2014-02-15 00:01:18.000000', 'consum', 0.0211, 'lps'),
	(531839, 127, '2014-02-15 00:01:19.000000', 'consum', 0.0212, 'lps'),
	(531840, 127, '2014-02-15 00:01:20.000000', 'consum', 0.0218, 'lps'),
	(531841, 127, '2014-02-15 00:01:21.000000', 'consum', 0.0215, 'lps'),
	(531842, 127, '2014-02-15 00:01:22.000000', 'consum', 0.0210, 'lps'),
	(531843, 127, '2014-02-15 00:01:23.000000', 'consum', 0.0215, 'lps'),
	(531844, 127, '2014-02-15 00:01:24.000000', 'consum', 0.0216, 'lps'),
	(531845, 127, '2014-02-15 00:01:25.000000', 'consum', 0.0215, 'lps'),
	(531846, 127, '2014-02-15 00:01:26.000000', 'consum', 0.0218, 'lps'),
	(531847, 127, '2014-02-15 00:01:27.000000', 'consum', 0.0216, 'lps'),
	(531848, 127, '2014-02-15 00:01:28.000000', 'consum', 0.0218, 'lps'),
	(531849, 127, '2014-02-15 00:01:29.000000', 'consum', 0.0211, 'lps'),
	(531850, 127, '2014-02-15 00:01:30.000000', 'consum', 0.0214, 'lps'),
	(531851, 127, '2014-02-15 00:01:31.000000', 'consum', 0.0214, 'lps'),
	(531852, 127, '2014-02-15 00:01:32.000000', 'consum', 0.0211, 'lps'),
	(531853, 127, '2014-02-15 00:01:33.000000', 'consum', 0.0215, 'lps'),
	(531854, 127, '2014-02-15 00:01:34.000000', 'consum', 0.0210, 'lps'),
	(531855, 127, '2014-02-15 00:01:35.000000', 'consum', 0.0216, 'lps'),
	(531856, 127, '2014-02-15 00:01:36.000000', 'consum', 0.0212, 'lps'),
	(531857, 127, '2014-02-15 00:01:37.000000', 'consum', 0.0213, 'lps'),
	(531858, 127, '2014-02-15 00:01:38.000000', 'consum', 0.0210, 'lps'),
	(531859, 127, '2014-02-15 00:01:39.000000', 'consum', 0.0211, 'lps'),
	(531860, 127, '2014-02-15 00:01:40.000000', 'consum', 0.0215, 'lps'),
	(531861, 127, '2014-02-15 00:01:41.000000', 'consum', 0.0213, 'lps'),
	(531862, 127, '2014-02-15 00:01:42.000000', 'consum', 0.0218, 'lps'),
	(531863, 127, '2014-02-15 00:01:43.000000', 'consum', 0.0214, 'lps'),
	(531864, 127, '2014-02-15 00:01:44.000000', 'consum', 0.0217, 'lps'),
	(531865, 127, '2014-02-15 00:01:45.000000', 'consum', 0.0211, 'lps'),
	(531866, 127, '2014-02-15 00:01:46.000000', 'consum', 0.0216, 'lps'),
	(531867, 127, '2014-02-15 00:01:47.000000', 'consum', 0.0215, 'lps'),
	(531868, 127, '2014-02-15 00:01:48.000000', 'consum', 0.0210, 'lps'),
	(531869, 127, '2014-02-15 00:01:49.000000', 'consum', 0.0214, 'lps'),
	(531870, 127, '2014-02-15 00:01:50.000000', 'consum', 0.0213, 'lps'),
	(531871, 127, '2014-02-15 00:01:51.000000', 'consum', 0.0212, 'lps'),
	(531872, 127, '2014-02-15 00:01:52.000000', 'consum', 0.0213, 'lps'),
	(531873, 127, '2014-02-15 00:01:53.000000', 'consum', 0.0210, 'lps'),
	(531874, 127, '2014-02-15 00:01:54.000000', 'consum', 0.0212, 'lps'),
	(531875, 127, '2014-02-15 00:01:55.000000', 'consum', 0.0218, 'lps'),
	(531876, 127, '2014-02-15 00:01:56.000000', 'consum', 0.0215, 'lps'),
	(531877, 127, '2014-02-15 00:01:57.000000', 'consum', 0.0212, 'lps'),
	(531878, 127, '2014-02-15 00:01:58.000000', 'consum', 0.0216, 'lps'),
	(531879, 127, '2014-02-15 00:01:59.000000', 'consum', 0.0212, 'lps'),
	(531880, 127, '2014-02-15 00:02:00.000000', 'consum', 0.0216, 'lps'),
	(531881, 127, '2014-02-15 00:02:01.000000', 'consum', 0.0212, 'lps'),
	(531882, 127, '2014-02-15 00:02:02.000000', 'consum', 0.0214, 'lps'),
	(531883, 127, '2014-02-15 00:02:03.000000', 'consum', 0.0214, 'lps'),
	(531884, 127, '2014-02-15 00:02:04.000000', 'consum', 0.0219, 'lps'),
	(531885, 127, '2014-02-15 00:02:05.000000', 'consum', 0.0215, 'lps'),
	(531886, 127, '2014-02-15 00:02:06.000000', 'consum', 0.0216, 'lps'),
	(531887, 127, '2014-02-15 00:02:07.000000', 'consum', 0.0218, 'lps'),
	(531888, 127, '2014-02-15 00:02:08.000000', 'consum', 0.0212, 'lps'),
	(531889, 127, '2014-02-15 00:02:09.000000', 'consum', 0.0218, 'lps'),
	(531890, 127, '2014-02-15 00:02:10.000000', 'consum', 0.0212, 'lps'),
	(531891, 127, '2014-02-15 00:02:11.000000', 'consum', 0.0217, 'lps'),
	(531892, 127, '2014-02-15 00:02:12.000000', 'consum', 0.0218, 'lps'),
	(531893, 127, '2014-02-15 00:02:13.000000', 'consum', 0.0210, 'lps'),
	(531894, 127, '2014-02-15 00:02:14.000000', 'consum', 0.0215, 'lps'),
	(531895, 127, '2014-02-15 00:02:15.000000', 'consum', 0.0218, 'lps'),
	(531896, 127, '2014-02-15 00:02:16.000000', 'consum', 0.0217, 'lps'),
	(531897, 127, '2014-02-15 00:02:17.000000', 'consum', 0.0219, 'lps'),
	(531898, 127, '2014-02-15 00:02:18.000000', 'consum', 0.0213, 'lps'),
	(531899, 127, '2014-02-15 00:02:19.000000', 'consum', 0.0210, 'lps'),
	(531900, 127, '2014-02-15 00:02:20.000000', 'consum', 0.0212, 'lps'),
	(531901, 127, '2014-02-15 00:02:21.000000', 'consum', 0.0210, 'lps'),
	(531902, 127, '2014-02-15 00:02:22.000000', 'consum', 0.0215, 'lps'),
	(531903, 127, '2014-02-15 00:02:23.000000', 'consum', 0.0217, 'lps'),
	(531904, 127, '2014-02-15 00:02:24.000000', 'consum', 0.0218, 'lps'),
	(531905, 127, '2014-02-15 00:02:25.000000', 'consum', 0.0219, 'lps'),
	(531906, 127, '2014-02-15 00:02:26.000000', 'consum', 0.0214, 'lps'),
	(531907, 127, '2014-02-15 00:02:27.000000', 'consum', 0.0212, 'lps'),
	(531908, 127, '2014-02-15 00:02:28.000000', 'consum', 0.0217, 'lps'),
	(531909, 127, '2014-02-15 00:02:29.000000', 'consum', 0.0211, 'lps'),
	(531910, 127, '2014-02-15 00:02:30.000000', 'consum', 0.0215, 'lps'),
	(531911, 127, '2014-02-15 00:02:31.000000', 'consum', 0.0214, 'lps'),
	(531912, 127, '2014-02-15 00:02:32.000000', 'consum', 0.0213, 'lps'),
	(531913, 127, '2014-02-15 00:02:33.000000', 'consum', 0.0214, 'lps'),
	(531914, 127, '2014-02-15 00:02:34.000000', 'consum', 0.0212, 'lps'),
	(531915, 127, '2014-02-15 00:02:35.000000', 'consum', 0.0218, 'lps'),
	(531916, 127, '2014-02-15 00:02:36.000000', 'consum', 0.0217, 'lps'),
	(531917, 127, '2014-02-15 00:02:37.000000', 'consum', 0.0218, 'lps'),
	(531918, 127, '2014-02-15 00:02:38.000000', 'consum', 0.0212, 'lps'),
	(531919, 127, '2014-02-15 00:02:39.000000', 'consum', 0.0216, 'lps'),
	(531920, 127, '2014-02-15 00:02:40.000000', 'consum', 0.0215, 'lps'),
	(531921, 127, '2014-02-15 00:02:41.000000', 'consum', 0.0216, 'lps'),
	(531922, 127, '2014-02-15 00:02:42.000000', 'consum', 0.0215, 'lps'),
	(531923, 127, '2014-02-15 00:02:43.000000', 'consum', 0.0210, 'lps'),
	(531924, 127, '2014-02-15 00:02:44.000000', 'consum', 0.0214, 'lps'),
	(531925, 127, '2014-02-15 00:02:45.000000', 'consum', 0.0210, 'lps'),
	(531926, 127, '2014-02-15 00:02:46.000000', 'consum', 0.0211, 'lps'),
	(531927, 127, '2014-02-15 00:02:47.000000', 'consum', 0.0213, 'lps'),
	(531928, 127, '2014-02-15 00:02:48.000000', 'consum', 0.0212, 'lps'),
	(531929, 127, '2014-02-15 00:02:49.000000', 'consum', 0.0214, 'lps'),
	(531930, 127, '2014-02-15 00:02:50.000000', 'consum', 0.0213, 'lps'),
	(531931, 127, '2014-02-15 00:02:51.000000', 'consum', 0.0212, 'lps'),
	(531932, 127, '2014-02-15 00:02:52.000000', 'consum', 0.0215, 'lps'),
	(531933, 127, '2014-02-15 00:02:53.000000', 'consum', 0.0216, 'lps'),
	(531934, 127, '2014-02-15 00:02:54.000000', 'consum', 0.0217, 'lps'),
	(531935, 127, '2014-02-15 00:02:55.000000', 'consum', 0.0218, 'lps'),
	(531936, 127, '2014-02-15 00:02:56.000000', 'consum', 0.0219, 'lps'),
	(531937, 127, '2014-02-15 00:02:57.000000', 'consum', 0.0210, 'lps'),
	(531938, 127, '2014-02-15 00:02:58.000000', 'consum', 0.0214, 'lps'),
	(531939, 127, '2014-02-15 00:02:59.000000', 'consum', 0.0212, 'lps'),
	(531940, 127, '2014-02-15 00:03:00.000000', 'consum', 0.0217, 'lps'),
	(531941, 127, '2014-02-15 00:03:01.000000', 'consum', 0.0211, 'lps'),
	(531942, 127, '2014-02-15 00:03:02.000000', 'consum', 0.0213, 'lps'),
	(531943, 127, '2014-02-15 00:03:03.000000', 'consum', 0.0212, 'lps'),
	(531944, 127, '2014-02-15 00:03:04.000000', 'consum', 0.0214, 'lps'),
	(531945, 127, '2014-02-15 00:03:05.000000', 'consum', 0.0214, 'lps'),
	(531946, 127, '2014-02-15 00:03:06.000000', 'consum', 0.0210, 'lps'),
	(531947, 127, '2014-02-15 00:03:07.000000', 'consum', 0.0216, 'lps'),
	(531948, 127, '2014-02-15 00:03:08.000000', 'consum', 0.0213, 'lps'),
	(531949, 127, '2014-02-15 00:03:09.000000', 'consum', 0.0217, 'lps'),
	(531950, 127, '2014-02-15 00:03:10.000000', 'consum', 0.0216, 'lps'),
	(531951, 127, '2014-02-15 00:03:11.000000', 'consum', 0.0218, 'lps'),
	(531952, 127, '2014-02-15 00:03:12.000000', 'consum', 0.0212, 'lps'),
	(531953, 127, '2014-02-15 00:03:13.000000', 'consum', 0.0218, 'lps'),
	(531954, 127, '2014-02-15 00:03:14.000000', 'consum', 0.0216, 'lps'),
	(531955, 127, '2014-02-15 00:03:15.000000', 'consum', 0.0214, 'lps'),
	(531956, 127, '2014-02-15 00:03:16.000000', 'consum', 0.0214, 'lps'),
	(531957, 127, '2014-02-15 00:03:17.000000', 'consum', 0.0219, 'lps'),
	(531958, 127, '2014-02-15 00:03:18.000000', 'consum', 0.0214, 'lps'),
	(531959, 127, '2014-02-15 00:03:19.000000', 'consum', 0.0215, 'lps'),
	(531960, 127, '2014-02-15 00:03:20.000000', 'consum', 0.0211, 'lps'),
	(531961, 127, '2014-02-15 00:03:21.000000', 'consum', 0.0219, 'lps'),
	(531962, 127, '2014-02-15 00:03:22.000000', 'consum', 0.0216, 'lps'),
	(531963, 127, '2014-02-15 00:03:23.000000', 'consum', 0.0211, 'lps'),
	(531964, 127, '2014-02-15 00:03:24.000000', 'consum', 0.0218, 'lps'),
	(531965, 127, '2014-02-15 00:03:25.000000', 'consum', 0.0216, 'lps'),
	(531966, 127, '2014-02-15 00:03:26.000000', 'consum', 0.0219, 'lps'),
	(531967, 127, '2014-02-15 00:03:27.000000', 'consum', 0.0218, 'lps'),
	(531968, 127, '2014-02-15 00:03:28.000000', 'consum', 0.0213, 'lps'),
	(531969, 127, '2014-02-15 00:03:29.000000', 'consum', 0.0213, 'lps'),
	(531970, 127, '2014-02-15 00:03:30.000000', 'consum', 0.0214, 'lps'),
	(531971, 127, '2014-02-15 00:03:31.000000', 'consum', 0.0214, 'lps'),
	(531972, 127, '2014-02-15 00:03:32.000000', 'consum', 0.0219, 'lps'),
	(531973, 127, '2014-02-15 00:03:33.000000', 'consum', 0.0213, 'lps'),
	(531974, 127, '2014-02-15 00:03:34.000000', 'consum', 0.0216, 'lps'),
	(531975, 127, '2014-02-15 00:03:35.000000', 'consum', 0.0214, 'lps'),
	(531976, 127, '2014-02-15 00:03:36.000000', 'consum', 0.0213, 'lps'),
	(531977, 127, '2014-02-15 00:03:37.000000', 'consum', 0.0213, 'lps'),
	(531978, 127, '2014-02-15 00:03:38.000000', 'consum', 0.0217, 'lps'),
	(531979, 127, '2014-02-15 00:03:39.000000', 'consum', 0.0214, 'lps'),
	(531980, 127, '2014-02-15 00:03:40.000000', 'consum', 0.0213, 'lps'),
	(531981, 127, '2014-02-15 00:03:41.000000', 'consum', 0.0211, 'lps'),
	(531982, 127, '2014-02-15 00:03:42.000000', 'consum', 0.0218, 'lps'),
	(531983, 127, '2014-02-15 00:03:43.000000', 'consum', 0.0218, 'lps'),
	(531984, 127, '2014-02-15 00:03:44.000000', 'consum', 0.0215, 'lps'),
	(531985, 127, '2014-02-15 00:03:45.000000', 'consum', 0.0212, 'lps'),
	(531986, 127, '2014-02-15 00:03:46.000000', 'consum', 0.0217, 'lps'),
	(531987, 127, '2014-02-15 00:03:47.000000', 'consum', 0.0218, 'lps'),
	(531988, 127, '2014-02-15 00:03:48.000000', 'consum', 0.0210, 'lps'),
	(531989, 127, '2014-02-15 00:03:49.000000', 'consum', 0.0216, 'lps'),
	(531990, 127, '2014-02-15 00:03:50.000000', 'consum', 0.0211, 'lps'),
	(531991, 127, '2014-02-15 00:03:51.000000', 'consum', 0.0217, 'lps'),
	(531992, 127, '2014-02-15 00:03:52.000000', 'consum', 0.0213, 'lps'),
	(531993, 127, '2014-02-15 00:03:53.000000', 'consum', 0.0214, 'lps'),
	(531994, 127, '2014-02-15 00:03:54.000000', 'consum', 0.0210, 'lps'),
	(531995, 127, '2014-02-15 00:03:55.000000', 'consum', 0.0211, 'lps'),
	(531996, 127, '2014-02-15 00:03:56.000000', 'consum', 0.0213, 'lps'),
	(531997, 127, '2014-02-15 00:03:57.000000', 'consum', 0.0214, 'lps'),
	(531998, 127, '2014-02-15 00:03:58.000000', 'consum', 0.0212, 'lps'),
	(531999, 127, '2014-02-15 00:03:59.000000', 'consum', 0.0219, 'lps'),
	(532000, 127, '2014-02-15 00:04:00.000000', 'consum', 0.0219, 'lps'),
	(532001, 127, '2014-02-15 00:04:01.000000', 'consum', 0.0218, 'lps'),
	(532002, 127, '2014-02-15 00:04:02.000000', 'consum', 0.0214, 'lps'),
	(532003, 127, '2014-02-15 00:04:03.000000', 'consum', 0.0215, 'lps'),
	(532004, 127, '2014-02-15 00:04:04.000000', 'consum', 0.0216, 'lps'),
	(532005, 127, '2014-02-15 00:04:05.000000', 'consum', 0.0213, 'lps'),
	(532006, 127, '2014-02-15 00:04:06.000000', 'consum', 0.0217, 'lps'),
	(532007, 127, '2014-02-15 00:04:07.000000', 'consum', 0.0219, 'lps'),
	(532008, 127, '2014-02-15 00:04:08.000000', 'consum', 0.0213, 'lps'),
	(532009, 127, '2014-02-15 00:04:09.000000', 'consum', 0.0218, 'lps'),
	(532010, 127, '2014-02-15 00:04:10.000000', 'consum', 0.0211, 'lps'),
	(532011, 127, '2014-02-15 00:04:11.000000', 'consum', 0.0210, 'lps'),
	(532012, 127, '2014-02-15 00:04:12.000000', 'consum', 0.0210, 'lps'),
	(532013, 127, '2014-02-15 00:04:13.000000', 'consum', 0.0211, 'lps'),
	(532014, 127, '2014-02-15 00:04:14.000000', 'consum', 0.0216, 'lps'),
	(532015, 127, '2014-02-15 00:04:15.000000', 'consum', 0.0219, 'lps'),
	(532016, 127, '2014-02-15 00:04:16.000000', 'consum', 0.0214, 'lps'),
	(532017, 127, '2014-02-15 00:04:17.000000', 'consum', 0.0216, 'lps'),
	(532018, 127, '2014-02-15 00:04:18.000000', 'consum', 0.0217, 'lps'),
	(532019, 127, '2014-02-15 00:04:19.000000', 'consum', 0.0218, 'lps'),
	(532020, 127, '2014-02-15 00:04:20.000000', 'consum', 0.0212, 'lps'),
	(532021, 127, '2014-02-15 00:04:21.000000', 'consum', 0.0213, 'lps'),
	(532022, 127, '2014-02-15 00:04:22.000000', 'consum', 0.0219, 'lps'),
	(532023, 127, '2014-02-15 00:04:23.000000', 'consum', 0.0219, 'lps'),
	(532024, 127, '2014-02-15 00:04:24.000000', 'consum', 0.0219, 'lps'),
	(532025, 127, '2014-02-15 00:04:25.000000', 'consum', 0.0218, 'lps'),
	(532026, 127, '2014-02-15 00:04:26.000000', 'consum', 0.0212, 'lps'),
	(532027, 127, '2014-02-15 00:04:27.000000', 'consum', 0.0217, 'lps'),
	(532028, 127, '2014-02-15 00:04:28.000000', 'consum', 0.0212, 'lps'),
	(532029, 127, '2014-02-15 00:04:29.000000', 'consum', 0.0217, 'lps'),
	(532030, 127, '2014-02-15 00:04:30.000000', 'consum', 0.0210, 'lps'),
	(532031, 127, '2014-02-15 00:04:31.000000', 'consum', 0.0210, 'lps'),
	(532032, 127, '2014-02-15 00:04:32.000000', 'consum', 0.0211, 'lps'),
	(532033, 127, '2014-02-15 00:04:33.000000', 'consum', 0.0217, 'lps'),
	(532034, 127, '2014-02-15 00:04:34.000000', 'consum', 0.0211, 'lps'),
	(532035, 127, '2014-02-15 00:04:35.000000', 'consum', 0.0213, 'lps'),
	(532036, 127, '2014-02-15 00:04:36.000000', 'consum', 0.0212, 'lps'),
	(532037, 127, '2014-02-15 00:04:37.000000', 'consum', 0.0214, 'lps'),
	(532038, 127, '2014-02-15 00:04:38.000000', 'consum', 0.0213, 'lps'),
	(532039, 127, '2014-02-15 00:04:39.000000', 'consum', 0.0216, 'lps'),
	(532040, 127, '2014-02-15 00:04:40.000000', 'consum', 0.0219, 'lps'),
	(532041, 127, '2014-02-15 00:04:41.000000', 'consum', 0.0210, 'lps'),
	(532042, 127, '2014-02-15 00:04:42.000000', 'consum', 0.0212, 'lps'),
	(532043, 127, '2014-02-15 00:04:43.000000', 'consum', 0.0213, 'lps'),
	(532044, 127, '2014-02-15 00:04:44.000000', 'consum', 0.0216, 'lps'),
	(532045, 127, '2014-02-15 00:04:45.000000', 'consum', 0.0212, 'lps'),
	(532046, 127, '2014-02-15 00:04:46.000000', 'consum', 0.0212, 'lps'),
	(532047, 127, '2014-02-15 00:04:47.000000', 'consum', 0.0217, 'lps'),
	(532048, 127, '2014-02-15 00:04:48.000000', 'consum', 0.0218, 'lps'),
	(532049, 127, '2014-02-15 00:04:49.000000', 'consum', 0.0210, 'lps'),
	(532050, 127, '2014-02-15 00:04:50.000000', 'consum', 0.0218, 'lps'),
	(532051, 127, '2014-02-15 00:04:51.000000', 'consum', 0.0210, 'lps'),
	(532052, 127, '2014-02-15 00:04:52.000000', 'consum', 0.0216, 'lps'),
	(532053, 127, '2014-02-15 00:04:53.000000', 'consum', 0.0212, 'lps'),
	(532054, 127, '2014-02-15 00:04:54.000000', 'consum', 0.0213, 'lps'),
	(532055, 127, '2014-02-15 00:04:55.000000', 'consum', 0.0219, 'lps'),
	(532056, 127, '2014-02-15 00:04:56.000000', 'consum', 0.0215, 'lps'),
	(532057, 127, '2014-02-15 00:04:57.000000', 'consum', 0.0218, 'lps'),
	(532058, 127, '2014-02-15 00:04:58.000000', 'consum', 0.0215, 'lps'),
	(532059, 127, '2014-02-15 00:04:59.000000', 'consum', 0.0213, 'lps'),
	(532060, 127, '2014-02-15 00:05:00.000000', 'consum', 0.0210, 'lps'),
	(532061, 127, '2014-02-15 00:05:01.000000', 'consum', 0.0211, 'lps'),
	(532062, 127, '2014-02-15 00:05:02.000000', 'consum', 0.0214, 'lps'),
	(532063, 127, '2014-02-15 00:05:03.000000', 'consum', 0.0218, 'lps'),
	(532064, 127, '2014-02-15 00:05:04.000000', 'consum', 0.0219, 'lps'),
	(532065, 127, '2014-02-15 00:05:05.000000', 'consum', 0.0212, 'lps'),
	(532066, 127, '2014-02-15 00:05:06.000000', 'consum', 0.0214, 'lps'),
	(532067, 127, '2014-02-15 00:05:07.000000', 'consum', 0.0213, 'lps'),
	(532068, 127, '2014-02-15 00:05:08.000000', 'consum', 0.0216, 'lps'),
	(532069, 127, '2014-02-15 00:05:09.000000', 'consum', 0.0219, 'lps'),
	(532070, 127, '2014-02-15 00:05:10.000000', 'consum', 0.0217, 'lps'),
	(532071, 127, '2014-02-15 00:05:11.000000', 'consum', 0.0218, 'lps'),
	(532072, 127, '2014-02-15 00:05:12.000000', 'consum', 0.0211, 'lps'),
	(532073, 127, '2014-02-15 00:05:13.000000', 'consum', 0.0212, 'lps'),
	(532074, 127, '2014-02-15 00:05:14.000000', 'consum', 0.0217, 'lps'),
	(532075, 127, '2014-02-15 00:05:15.000000', 'consum', 0.0211, 'lps'),
	(532076, 127, '2014-02-15 00:05:16.000000', 'consum', 0.0214, 'lps'),
	(532077, 127, '2014-02-15 00:05:17.000000', 'consum', 0.0217, 'lps'),
	(532078, 127, '2014-02-15 00:05:18.000000', 'consum', 0.0216, 'lps'),
	(532079, 127, '2014-02-15 00:05:19.000000', 'consum', 0.0216, 'lps'),
	(532080, 127, '2014-02-15 00:05:20.000000', 'consum', 0.0215, 'lps'),
	(532081, 127, '2014-02-15 00:05:21.000000', 'consum', 0.0217, 'lps'),
	(532082, 127, '2014-02-15 00:05:22.000000', 'consum', 0.0219, 'lps'),
	(532083, 127, '2014-02-15 00:05:23.000000', 'consum', 0.0213, 'lps'),
	(532084, 127, '2014-02-15 00:05:24.000000', 'consum', 0.0211, 'lps'),
	(532085, 127, '2014-02-15 00:05:25.000000', 'consum', 0.0218, 'lps'),
	(532086, 127, '2014-02-15 00:05:26.000000', 'consum', 0.0215, 'lps'),
	(532087, 127, '2014-02-15 00:05:27.000000', 'consum', 0.0214, 'lps'),
	(532088, 127, '2014-02-15 00:05:28.000000', 'consum', 0.0214, 'lps'),
	(532089, 127, '2014-02-15 00:05:29.000000', 'consum', 0.0219, 'lps'),
	(532090, 127, '2014-02-15 00:05:30.000000', 'consum', 0.0215, 'lps'),
	(532091, 127, '2014-02-15 00:05:31.000000', 'consum', 0.0219, 'lps'),
	(532092, 127, '2014-02-15 00:05:32.000000', 'consum', 0.0210, 'lps'),
	(532093, 127, '2014-02-15 00:05:33.000000', 'consum', 0.0211, 'lps'),
	(532094, 127, '2014-02-15 00:05:34.000000', 'consum', 0.0218, 'lps'),
	(532095, 127, '2014-02-15 00:05:35.000000', 'consum', 0.0216, 'lps'),
	(532096, 127, '2014-02-15 00:05:36.000000', 'consum', 0.0216, 'lps'),
	(532097, 127, '2014-02-15 00:05:37.000000', 'consum', 0.0214, 'lps'),
	(532098, 127, '2014-02-15 00:05:38.000000', 'consum', 0.0210, 'lps'),
	(532099, 127, '2014-02-15 00:05:39.000000', 'consum', 0.0212, 'lps'),
	(532100, 127, '2014-02-15 00:05:40.000000', 'consum', 0.0218, 'lps'),
	(532101, 127, '2014-02-15 00:05:41.000000', 'consum', 0.0213, 'lps'),
	(532102, 127, '2014-02-15 00:05:42.000000', 'consum', 0.0214, 'lps'),
	(532103, 127, '2014-02-15 00:05:43.000000', 'consum', 0.0213, 'lps'),
	(532104, 127, '2014-02-15 00:05:44.000000', 'consum', 0.0210, 'lps'),
	(532105, 127, '2014-02-15 00:05:45.000000', 'consum', 0.0214, 'lps'),
	(532106, 127, '2014-02-15 00:05:46.000000', 'consum', 0.0211, 'lps'),
	(532107, 127, '2014-02-15 00:05:47.000000', 'consum', 0.0211, 'lps'),
	(532108, 127, '2014-02-15 00:05:48.000000', 'consum', 0.0215, 'lps'),
	(532109, 127, '2014-02-15 00:05:49.000000', 'consum', 0.0213, 'lps'),
	(532110, 127, '2014-02-15 00:05:50.000000', 'consum', 0.0210, 'lps'),
	(532111, 127, '2014-02-15 00:05:51.000000', 'consum', 0.0213, 'lps'),
	(532112, 127, '2014-02-15 00:05:52.000000', 'consum', 0.0215, 'lps'),
	(532113, 127, '2014-02-15 00:05:53.000000', 'consum', 0.0216, 'lps'),
	(532114, 127, '2014-02-15 00:05:54.000000', 'consum', 0.0215, 'lps'),
	(532115, 127, '2014-02-15 00:05:55.000000', 'consum', 0.0216, 'lps'),
	(532116, 127, '2014-02-15 00:05:56.000000', 'consum', 0.0216, 'lps'),
	(532117, 127, '2014-02-15 00:05:57.000000', 'consum', 0.0212, 'lps'),
	(532118, 127, '2014-02-15 00:05:58.000000', 'consum', 0.0211, 'lps'),
	(532119, 127, '2014-02-15 00:05:59.000000', 'consum', 0.0211, 'lps'),
	(532120, 127, '2014-02-15 00:06:00.000000', 'consum', 0.0215, 'lps'),
	(532121, 127, '2014-02-15 00:06:01.000000', 'consum', 0.0219, 'lps'),
	(532122, 127, '2014-02-15 00:06:02.000000', 'consum', 0.0213, 'lps'),
	(532123, 127, '2014-02-15 00:06:03.000000', 'consum', 0.0218, 'lps'),
	(532124, 127, '2014-02-15 00:06:04.000000', 'consum', 0.0210, 'lps'),
	(532125, 127, '2014-02-15 00:06:05.000000', 'consum', 0.0217, 'lps'),
	(532126, 127, '2014-02-15 00:06:06.000000', 'consum', 0.0216, 'lps'),
	(532127, 127, '2014-02-15 00:06:07.000000', 'consum', 0.0218, 'lps'),
	(532128, 127, '2014-02-15 00:06:08.000000', 'consum', 0.0213, 'lps'),
	(532129, 127, '2014-02-15 00:06:09.000000', 'consum', 0.0212, 'lps'),
	(532130, 127, '2014-02-15 00:06:10.000000', 'consum', 0.0211, 'lps'),
	(532131, 127, '2014-02-15 00:06:11.000000', 'consum', 0.0210, 'lps'),
	(532132, 127, '2014-02-15 00:06:12.000000', 'consum', 0.0218, 'lps'),
	(532133, 127, '2014-02-15 00:06:13.000000', 'consum', 0.0219, 'lps'),
	(532134, 127, '2014-02-15 00:06:14.000000', 'consum', 0.0210, 'lps'),
	(532135, 127, '2014-02-15 00:06:15.000000', 'consum', 0.0217, 'lps'),
	(532136, 127, '2014-02-15 00:06:16.000000', 'consum', 0.0214, 'lps'),
	(532137, 127, '2014-02-15 00:06:17.000000', 'consum', 0.0211, 'lps'),
	(532138, 127, '2014-02-15 00:06:18.000000', 'consum', 0.0214, 'lps'),
	(532139, 127, '2014-02-15 00:06:19.000000', 'consum', 0.0218, 'lps'),
	(532140, 127, '2014-02-15 00:06:20.000000', 'consum', 0.0219, 'lps'),
	(532141, 127, '2014-02-15 00:06:21.000000', 'consum', 0.0210, 'lps'),
	(532142, 127, '2014-02-15 00:06:22.000000', 'consum', 0.0214, 'lps'),
	(532143, 127, '2014-02-15 00:06:23.000000', 'consum', 0.0210, 'lps'),
	(532144, 127, '2014-02-15 00:06:24.000000', 'consum', 0.0218, 'lps'),
	(532145, 127, '2014-02-15 00:06:25.000000', 'consum', 0.0212, 'lps'),
	(532146, 127, '2014-02-15 00:06:26.000000', 'consum', 0.0216, 'lps'),
	(532147, 127, '2014-02-15 00:06:27.000000', 'consum', 0.0216, 'lps'),
	(532148, 127, '2014-02-15 00:06:28.000000', 'consum', 0.0213, 'lps'),
	(532149, 127, '2014-02-15 00:06:29.000000', 'consum', 0.0216, 'lps'),
	(532150, 127, '2014-02-15 00:06:30.000000', 'consum', 0.0214, 'lps'),
	(532151, 127, '2014-02-15 00:06:31.000000', 'consum', 0.0210, 'lps'),
	(532152, 127, '2014-02-15 00:06:32.000000', 'consum', 0.0211, 'lps'),
	(532153, 127, '2014-02-15 00:06:33.000000', 'consum', 0.0214, 'lps'),
	(532154, 127, '2014-02-15 00:06:34.000000', 'consum', 0.0219, 'lps'),
	(532155, 127, '2014-02-15 00:06:35.000000', 'consum', 0.0211, 'lps'),
	(532156, 127, '2014-02-15 00:06:36.000000', 'consum', 0.0218, 'lps'),
	(532157, 127, '2014-02-15 00:06:37.000000', 'consum', 0.0211, 'lps'),
	(532158, 127, '2014-02-15 00:06:38.000000', 'consum', 0.0218, 'lps'),
	(532159, 127, '2014-02-15 00:06:39.000000', 'consum', 0.0218, 'lps'),
	(532160, 127, '2014-02-15 00:06:40.000000', 'consum', 0.0218, 'lps'),
	(532161, 127, '2014-02-15 00:06:41.000000', 'consum', 0.0217, 'lps'),
	(532162, 127, '2014-02-15 00:06:42.000000', 'consum', 0.0219, 'lps'),
	(532163, 127, '2014-02-15 00:06:43.000000', 'consum', 0.0217, 'lps'),
	(532164, 127, '2014-02-15 00:06:44.000000', 'consum', 0.0219, 'lps'),
	(532165, 127, '2014-02-15 00:06:45.000000', 'consum', 0.0214, 'lps'),
	(532166, 127, '2014-02-15 00:06:46.000000', 'consum', 0.0213, 'lps'),
	(532167, 127, '2014-02-15 00:06:47.000000', 'consum', 0.0214, 'lps'),
	(532168, 127, '2014-02-15 00:06:48.000000', 'consum', 0.0211, 'lps'),
	(532169, 127, '2014-02-15 00:06:49.000000', 'consum', 0.0212, 'lps'),
	(532170, 127, '2014-02-15 00:06:50.000000', 'consum', 0.0219, 'lps'),
	(532171, 127, '2014-02-15 00:06:51.000000', 'consum', 0.0219, 'lps'),
	(532172, 127, '2014-02-15 00:06:52.000000', 'consum', 0.0219, 'lps'),
	(532173, 127, '2014-02-15 00:06:53.000000', 'consum', 0.0216, 'lps'),
	(532174, 127, '2014-02-15 00:06:54.000000', 'consum', 0.0216, 'lps'),
	(532175, 127, '2014-02-15 00:06:55.000000', 'consum', 0.0212, 'lps'),
	(532176, 127, '2014-02-15 00:06:56.000000', 'consum', 0.0214, 'lps'),
	(532177, 127, '2014-02-15 00:06:57.000000', 'consum', 0.0212, 'lps'),
	(532178, 127, '2014-02-15 00:06:58.000000', 'consum', 0.0210, 'lps'),
	(532179, 127, '2014-02-15 00:06:59.000000', 'consum', 0.0214, 'lps'),
	(532180, 127, '2014-02-15 00:07:00.000000', 'consum', 0.0213, 'lps'),
	(532181, 127, '2014-02-15 00:07:01.000000', 'consum', 0.0211, 'lps'),
	(532182, 127, '2014-02-15 00:07:02.000000', 'consum', 0.0215, 'lps'),
	(532183, 127, '2014-02-15 00:07:03.000000', 'consum', 0.0214, 'lps'),
	(532184, 127, '2014-02-15 00:07:04.000000', 'consum', 0.0217, 'lps'),
	(532185, 127, '2014-02-15 00:07:05.000000', 'consum', 0.0211, 'lps'),
	(532186, 127, '2014-02-15 00:07:06.000000', 'consum', 0.0217, 'lps'),
	(532187, 127, '2014-02-15 00:07:07.000000', 'consum', 0.0212, 'lps'),
	(532188, 127, '2014-02-15 00:07:08.000000', 'consum', 0.0219, 'lps'),
	(532189, 127, '2014-02-15 00:07:09.000000', 'consum', 0.0217, 'lps'),
	(532190, 127, '2014-02-15 00:07:10.000000', 'consum', 0.0212, 'lps'),
	(532191, 127, '2014-02-15 00:07:11.000000', 'consum', 0.0219, 'lps'),
	(532192, 127, '2014-02-15 00:07:12.000000', 'consum', 0.0210, 'lps'),
	(532193, 127, '2014-02-15 00:07:13.000000', 'consum', 0.0211, 'lps'),
	(532194, 127, '2014-02-15 00:07:14.000000', 'consum', 0.0215, 'lps'),
	(532195, 127, '2014-02-15 00:07:15.000000', 'consum', 0.0216, 'lps'),
	(532196, 127, '2014-02-15 00:07:16.000000', 'consum', 0.0213, 'lps'),
	(532197, 127, '2014-02-15 00:07:17.000000', 'consum', 0.0218, 'lps'),
	(532198, 127, '2014-02-15 00:07:18.000000', 'consum', 0.0212, 'lps'),
	(532199, 127, '2014-02-15 00:07:19.000000', 'consum', 0.0215, 'lps'),
	(532200, 127, '2014-02-15 00:07:20.000000', 'consum', 0.0210, 'lps'),
	(532201, 127, '2014-02-15 00:07:21.000000', 'consum', 0.0215, 'lps'),
	(532202, 127, '2014-02-15 00:07:22.000000', 'consum', 0.0215, 'lps'),
	(532203, 127, '2014-02-15 00:07:23.000000', 'consum', 0.0212, 'lps'),
	(532204, 127, '2014-02-15 00:07:24.000000', 'consum', 0.0215, 'lps'),
	(532205, 127, '2014-02-15 00:07:25.000000', 'consum', 0.0219, 'lps'),
	(532206, 127, '2014-02-15 00:07:26.000000', 'consum', 0.0211, 'lps'),
	(532207, 127, '2014-02-15 00:07:27.000000', 'consum', 0.0210, 'lps'),
	(532208, 127, '2014-02-15 00:07:28.000000', 'consum', 0.0214, 'lps'),
	(532209, 127, '2014-02-15 00:07:29.000000', 'consum', 0.0214, 'lps'),
	(532210, 127, '2014-02-15 00:07:30.000000', 'consum', 0.0217, 'lps'),
	(532211, 127, '2014-02-15 00:07:31.000000', 'consum', 0.0213, 'lps'),
	(532212, 127, '2014-02-15 00:07:32.000000', 'consum', 0.0214, 'lps'),
	(532213, 127, '2014-02-15 00:07:33.000000', 'consum', 0.0212, 'lps'),
	(532214, 127, '2014-02-15 00:07:34.000000', 'consum', 0.0211, 'lps'),
	(532215, 127, '2014-02-15 00:07:35.000000', 'consum', 0.0216, 'lps'),
	(532216, 127, '2014-02-15 00:07:36.000000', 'consum', 0.0219, 'lps'),
	(532217, 127, '2014-02-15 00:07:37.000000', 'consum', 0.0216, 'lps'),
	(532218, 127, '2014-02-15 00:07:38.000000', 'consum', 0.0215, 'lps'),
	(532219, 127, '2014-02-15 00:07:39.000000', 'consum', 0.0217, 'lps'),
	(532220, 127, '2014-02-15 00:07:40.000000', 'consum', 0.0212, 'lps'),
	(532221, 127, '2014-02-15 00:07:41.000000', 'consum', 0.0218, 'lps'),
	(532222, 127, '2014-02-15 00:07:42.000000', 'consum', 0.0217, 'lps'),
	(532223, 127, '2014-02-15 00:07:43.000000', 'consum', 0.0218, 'lps'),
	(532224, 127, '2014-02-15 00:07:44.000000', 'consum', 0.0213, 'lps'),
	(532225, 127, '2014-02-15 00:07:45.000000', 'consum', 0.0219, 'lps'),
	(532226, 127, '2014-02-15 00:07:46.000000', 'consum', 0.0217, 'lps'),
	(532227, 127, '2014-02-15 00:07:47.000000', 'consum', 0.0219, 'lps'),
	(532228, 127, '2014-02-15 00:07:48.000000', 'consum', 0.0212, 'lps'),
	(532229, 127, '2014-02-15 00:07:49.000000', 'consum', 0.0216, 'lps'),
	(532230, 127, '2014-02-15 00:07:50.000000', 'consum', 0.0215, 'lps'),
	(532231, 127, '2014-02-15 00:07:51.000000', 'consum', 0.0218, 'lps'),
	(532232, 127, '2014-02-15 00:07:52.000000', 'consum', 0.0216, 'lps'),
	(532233, 127, '2014-02-15 00:07:53.000000', 'consum', 0.0216, 'lps'),
	(532234, 127, '2014-02-15 00:07:54.000000', 'consum', 0.0214, 'lps'),
	(532235, 127, '2014-02-15 00:07:55.000000', 'consum', 0.0210, 'lps'),
	(532236, 127, '2014-02-15 00:07:56.000000', 'consum', 0.0219, 'lps'),
	(532237, 127, '2014-02-15 00:07:57.000000', 'consum', 0.0214, 'lps'),
	(532238, 127, '2014-02-15 00:07:58.000000', 'consum', 0.0214, 'lps'),
	(532239, 127, '2014-02-15 00:07:59.000000', 'consum', 0.0217, 'lps'),
	(532240, 127, '2014-02-15 00:08:00.000000', 'consum', 0.0216, 'lps'),
	(532241, 127, '2014-02-15 00:08:01.000000', 'consum', 0.0217, 'lps'),
	(532242, 127, '2014-02-15 00:08:02.000000', 'consum', 0.0217, 'lps'),
	(532243, 127, '2014-02-15 00:08:03.000000', 'consum', 0.0218, 'lps'),
	(532244, 127, '2014-02-15 00:08:04.000000', 'consum', 0.0217, 'lps'),
	(532245, 127, '2014-02-15 00:08:05.000000', 'consum', 0.0212, 'lps'),
	(532246, 127, '2014-02-15 00:08:06.000000', 'consum', 0.0218, 'lps'),
	(532247, 127, '2014-02-15 00:08:07.000000', 'consum', 0.0214, 'lps'),
	(532248, 127, '2014-02-15 00:08:08.000000', 'consum', 0.0218, 'lps'),
	(532249, 127, '2014-02-15 00:08:09.000000', 'consum', 0.0218, 'lps'),
	(532250, 127, '2014-02-15 00:08:10.000000', 'consum', 0.0215, 'lps'),
	(532251, 127, '2014-02-15 00:08:11.000000', 'consum', 0.0214, 'lps'),
	(532252, 127, '2014-02-15 00:08:12.000000', 'consum', 0.0214, 'lps'),
	(532253, 127, '2014-02-15 00:08:13.000000', 'consum', 0.0218, 'lps'),
	(532254, 127, '2014-02-15 00:08:14.000000', 'consum', 0.0218, 'lps'),
	(532255, 127, '2014-02-15 00:08:15.000000', 'consum', 0.0219, 'lps'),
	(532256, 127, '2014-02-15 00:08:16.000000', 'consum', 0.0219, 'lps'),
	(532257, 127, '2014-02-15 00:08:17.000000', 'consum', 0.0218, 'lps'),
	(532258, 127, '2014-02-15 00:08:18.000000', 'consum', 0.0217, 'lps'),
	(532259, 127, '2014-02-15 00:08:19.000000', 'consum', 0.0218, 'lps'),
	(532260, 127, '2014-02-15 00:08:20.000000', 'consum', 0.0219, 'lps'),
	(532261, 127, '2014-02-15 00:08:21.000000', 'consum', 0.0215, 'lps'),
	(532262, 127, '2014-02-15 00:08:22.000000', 'consum', 0.0216, 'lps'),
	(532263, 127, '2014-02-15 00:08:23.000000', 'consum', 0.0215, 'lps'),
	(532264, 127, '2014-02-15 00:08:24.000000', 'consum', 0.0219, 'lps'),
	(532265, 127, '2014-02-15 00:08:25.000000', 'consum', 0.0210, 'lps'),
	(532266, 127, '2014-02-15 00:08:26.000000', 'consum', 0.0216, 'lps'),
	(532267, 127, '2014-02-15 00:08:27.000000', 'consum', 0.0217, 'lps'),
	(532268, 127, '2014-02-15 00:08:28.000000', 'consum', 0.0217, 'lps'),
	(532269, 127, '2014-02-15 00:08:29.000000', 'consum', 0.0216, 'lps'),
	(532270, 127, '2014-02-15 00:08:30.000000', 'consum', 0.0219, 'lps'),
	(532271, 127, '2014-02-15 00:08:31.000000', 'consum', 0.0219, 'lps'),
	(532272, 127, '2014-02-15 00:08:32.000000', 'consum', 0.0216, 'lps'),
	(532273, 127, '2014-02-15 00:08:33.000000', 'consum', 0.0216, 'lps'),
	(532274, 127, '2014-02-15 00:08:34.000000', 'consum', 0.0211, 'lps'),
	(532275, 127, '2014-02-15 00:08:35.000000', 'consum', 0.0218, 'lps'),
	(532276, 127, '2014-02-15 00:08:36.000000', 'consum', 0.0217, 'lps'),
	(532277, 127, '2014-02-15 00:08:37.000000', 'consum', 0.0213, 'lps'),
	(532278, 127, '2014-02-15 00:08:38.000000', 'consum', 0.0214, 'lps'),
	(532279, 127, '2014-02-15 00:08:39.000000', 'consum', 0.0212, 'lps'),
	(532280, 127, '2014-02-15 00:08:40.000000', 'consum', 0.0218, 'lps'),
	(532281, 127, '2014-02-15 00:08:41.000000', 'consum', 0.0216, 'lps'),
	(532282, 127, '2014-02-15 00:08:42.000000', 'consum', 0.0217, 'lps'),
	(532283, 127, '2014-02-15 00:08:43.000000', 'consum', 0.0218, 'lps'),
	(532284, 127, '2014-02-15 00:08:44.000000', 'consum', 0.0217, 'lps'),
	(532285, 127, '2014-02-15 00:08:45.000000', 'consum', 0.0213, 'lps'),
	(532286, 127, '2014-02-15 00:08:46.000000', 'consum', 0.0215, 'lps'),
	(532287, 127, '2014-02-15 00:08:47.000000', 'consum', 0.0215, 'lps'),
	(532288, 127, '2014-02-15 00:08:48.000000', 'consum', 0.0212, 'lps'),
	(532289, 127, '2014-02-15 00:08:49.000000', 'consum', 0.0216, 'lps'),
	(532290, 127, '2014-02-15 00:08:50.000000', 'consum', 0.0214, 'lps'),
	(532291, 127, '2014-02-15 00:08:51.000000', 'consum', 0.0214, 'lps'),
	(532292, 127, '2014-02-15 00:08:52.000000', 'consum', 0.0218, 'lps'),
	(532293, 127, '2014-02-15 00:08:53.000000', 'consum', 0.0218, 'lps'),
	(532294, 127, '2014-02-15 00:08:54.000000', 'consum', 0.0216, 'lps'),
	(532295, 127, '2014-02-15 00:08:55.000000', 'consum', 0.0218, 'lps'),
	(532296, 127, '2014-02-15 00:08:56.000000', 'consum', 0.0213, 'lps'),
	(532297, 127, '2014-02-15 00:08:57.000000', 'consum', 0.0218, 'lps'),
	(532298, 127, '2014-02-15 00:08:58.000000', 'consum', 0.0215, 'lps'),
	(532299, 127, '2014-02-15 00:08:59.000000', 'consum', 0.0212, 'lps'),
	(532300, 127, '2014-02-15 00:09:00.000000', 'consum', 0.0214, 'lps'),
	(532301, 127, '2014-02-15 00:09:01.000000', 'consum', 0.0215, 'lps'),
	(532302, 127, '2014-02-15 00:09:02.000000', 'consum', 0.0215, 'lps'),
	(532303, 127, '2014-02-15 00:09:03.000000', 'consum', 0.0218, 'lps'),
	(532304, 127, '2014-02-15 00:09:04.000000', 'consum', 0.0215, 'lps'),
	(532305, 127, '2014-02-15 00:09:05.000000', 'consum', 0.0214, 'lps'),
	(532306, 127, '2014-02-15 00:09:06.000000', 'consum', 0.0213, 'lps'),
	(532307, 127, '2014-02-15 00:09:07.000000', 'consum', 0.0215, 'lps'),
	(532308, 127, '2014-02-15 00:09:08.000000', 'consum', 0.0216, 'lps'),
	(532309, 127, '2014-02-15 00:09:09.000000', 'consum', 0.0216, 'lps'),
	(532310, 127, '2014-02-15 00:09:10.000000', 'consum', 0.0211, 'lps'),
	(532311, 127, '2014-02-15 00:09:11.000000', 'consum', 0.0218, 'lps'),
	(532312, 127, '2014-02-15 00:09:12.000000', 'consum', 0.0216, 'lps'),
	(532313, 127, '2014-02-15 00:09:13.000000', 'consum', 0.0218, 'lps'),
	(532314, 127, '2014-02-15 00:09:14.000000', 'consum', 0.0210, 'lps'),
	(532315, 127, '2014-02-15 00:09:15.000000', 'consum', 0.0219, 'lps'),
	(532316, 127, '2014-02-15 00:09:16.000000', 'consum', 0.0217, 'lps'),
	(532317, 127, '2014-02-15 00:09:17.000000', 'consum', 0.0216, 'lps'),
	(532318, 127, '2014-02-15 00:09:18.000000', 'consum', 0.0211, 'lps'),
	(532319, 127, '2014-02-15 00:09:19.000000', 'consum', 0.0217, 'lps'),
	(532320, 127, '2014-02-15 00:09:20.000000', 'consum', 0.0212, 'lps'),
	(532321, 127, '2014-02-15 00:09:21.000000', 'consum', 0.0219, 'lps'),
	(532322, 127, '2014-02-15 00:09:22.000000', 'consum', 0.0219, 'lps'),
	(532323, 127, '2014-02-15 00:09:23.000000', 'consum', 0.0219, 'lps'),
	(532324, 127, '2014-02-15 00:09:24.000000', 'consum', 0.0219, 'lps'),
	(532325, 127, '2014-02-15 00:09:25.000000', 'consum', 0.0218, 'lps'),
	(532326, 127, '2014-02-15 00:09:26.000000', 'consum', 0.0212, 'lps'),
	(532327, 127, '2014-02-15 00:09:27.000000', 'consum', 0.0217, 'lps'),
	(532328, 127, '2014-02-15 00:09:28.000000', 'consum', 0.0211, 'lps'),
	(532329, 127, '2014-02-15 00:09:29.000000', 'consum', 0.0214, 'lps'),
	(532330, 127, '2014-02-15 00:09:30.000000', 'consum', 0.0217, 'lps'),
	(532331, 127, '2014-02-15 00:09:31.000000', 'consum', 0.0212, 'lps'),
	(532332, 127, '2014-02-15 00:09:32.000000', 'consum', 0.0212, 'lps'),
	(532333, 127, '2014-02-15 00:09:33.000000', 'consum', 0.0213, 'lps'),
	(532334, 127, '2014-02-15 00:09:34.000000', 'consum', 0.0219, 'lps'),
	(532335, 127, '2014-02-15 00:09:35.000000', 'consum', 0.0216, 'lps'),
	(532336, 127, '2014-02-15 00:09:36.000000', 'consum', 0.0213, 'lps'),
	(532337, 127, '2014-02-15 00:09:37.000000', 'consum', 0.0218, 'lps'),
	(532338, 127, '2014-02-15 00:09:38.000000', 'consum', 0.0211, 'lps'),
	(532339, 127, '2014-02-15 00:09:39.000000', 'consum', 0.0211, 'lps'),
	(532340, 127, '2014-02-15 00:09:40.000000', 'consum', 0.0213, 'lps'),
	(532341, 127, '2014-02-15 00:09:41.000000', 'consum', 0.0214, 'lps'),
	(532342, 127, '2014-02-15 00:09:42.000000', 'consum', 0.0211, 'lps'),
	(532343, 127, '2014-02-15 00:09:43.000000', 'consum', 0.0211, 'lps'),
	(532344, 127, '2014-02-15 00:09:44.000000', 'consum', 0.0215, 'lps'),
	(532345, 127, '2014-02-15 00:09:45.000000', 'consum', 0.0212, 'lps'),
	(532346, 127, '2014-02-15 00:09:46.000000', 'consum', 0.0217, 'lps'),
	(532347, 127, '2014-02-15 00:09:47.000000', 'consum', 0.0216, 'lps'),
	(532348, 127, '2014-02-15 00:09:48.000000', 'consum', 0.0213, 'lps'),
	(532349, 127, '2014-02-15 00:09:49.000000', 'consum', 0.0216, 'lps'),
	(532350, 127, '2014-02-15 00:09:50.000000', 'consum', 0.0210, 'lps'),
	(532351, 127, '2014-02-15 00:09:51.000000', 'consum', 0.0213, 'lps'),
	(532352, 127, '2014-02-15 00:09:52.000000', 'consum', 0.0216, 'lps'),
	(532353, 127, '2014-02-15 00:09:53.000000', 'consum', 0.0211, 'lps'),
	(532354, 127, '2014-02-15 00:09:54.000000', 'consum', 0.0217, 'lps'),
	(532355, 127, '2014-02-15 00:09:55.000000', 'consum', 0.0213, 'lps'),
	(532356, 127, '2014-02-15 00:09:56.000000', 'consum', 0.0214, 'lps'),
	(532357, 127, '2014-02-15 00:09:57.000000', 'consum', 0.0211, 'lps'),
	(532358, 127, '2014-02-15 00:09:58.000000', 'consum', 0.0215, 'lps'),
	(532359, 127, '2014-02-15 00:09:59.000000', 'consum', 0.0213, 'lps'),
	(532360, 127, '2014-02-15 00:10:00.000000', 'consum', 0.0218, 'lps'),
	(532361, 127, '2014-02-15 00:10:01.000000', 'consum', 0.0214, 'lps'),
	(532362, 127, '2014-02-15 00:10:02.000000', 'consum', 0.0217, 'lps'),
	(532363, 127, '2014-02-15 00:10:03.000000', 'consum', 0.0211, 'lps'),
	(532364, 127, '2014-02-15 00:10:04.000000', 'consum', 0.0214, 'lps'),
	(532365, 127, '2014-02-15 00:10:05.000000', 'consum', 0.0217, 'lps'),
	(532366, 127, '2014-02-15 00:10:06.000000', 'consum', 0.0215, 'lps'),
	(532367, 127, '2014-02-15 00:10:07.000000', 'consum', 0.0214, 'lps'),
	(532368, 127, '2014-02-15 00:10:08.000000', 'consum', 0.0215, 'lps'),
	(532369, 127, '2014-02-15 00:10:09.000000', 'consum', 0.0212, 'lps'),
	(532370, 127, '2014-02-15 00:10:10.000000', 'consum', 0.0218, 'lps'),
	(532371, 127, '2014-02-15 00:10:11.000000', 'consum', 0.0213, 'lps'),
	(532372, 127, '2014-02-15 00:10:12.000000', 'consum', 0.0212, 'lps'),
	(532373, 127, '2014-02-15 00:10:13.000000', 'consum', 0.0212, 'lps'),
	(532374, 127, '2014-02-15 00:10:14.000000', 'consum', 0.0213, 'lps'),
	(532375, 127, '2014-02-15 00:10:15.000000', 'consum', 0.0211, 'lps'),
	(532376, 127, '2014-02-15 00:10:16.000000', 'consum', 0.0215, 'lps'),
	(532377, 127, '2014-02-15 00:10:17.000000', 'consum', 0.0215, 'lps'),
	(532378, 127, '2014-02-15 00:10:18.000000', 'consum', 0.0219, 'lps'),
	(532379, 127, '2014-02-15 00:10:19.000000', 'consum', 0.0210, 'lps'),
	(532380, 127, '2014-02-15 00:10:20.000000', 'consum', 0.0213, 'lps'),
	(532381, 127, '2014-02-15 00:10:21.000000', 'consum', 0.0217, 'lps'),
	(532382, 127, '2014-02-15 00:10:22.000000', 'consum', 0.0215, 'lps'),
	(532383, 127, '2014-02-15 00:10:23.000000', 'consum', 0.0213, 'lps'),
	(532384, 127, '2014-02-15 00:10:24.000000', 'consum', 0.0212, 'lps'),
	(532385, 127, '2014-02-15 00:10:25.000000', 'consum', 0.0212, 'lps'),
	(532386, 127, '2014-02-15 00:10:26.000000', 'consum', 0.0215, 'lps'),
	(532387, 127, '2014-02-15 00:10:27.000000', 'consum', 0.0211, 'lps'),
	(532388, 127, '2014-02-15 00:10:28.000000', 'consum', 0.0217, 'lps'),
	(532389, 127, '2014-02-15 00:10:29.000000', 'consum', 0.0216, 'lps'),
	(532390, 127, '2014-02-15 00:10:30.000000', 'consum', 0.0218, 'lps'),
	(532391, 127, '2014-02-15 00:10:31.000000', 'consum', 0.0213, 'lps'),
	(532392, 127, '2014-02-15 00:10:32.000000', 'consum', 0.0213, 'lps'),
	(532393, 127, '2014-02-15 00:10:33.000000', 'consum', 0.0215, 'lps'),
	(532394, 127, '2014-02-15 00:10:34.000000', 'consum', 0.0215, 'lps'),
	(532395, 127, '2014-02-15 00:10:35.000000', 'consum', 0.0211, 'lps'),
	(532396, 127, '2014-02-15 00:10:36.000000', 'consum', 0.0212, 'lps'),
	(532397, 127, '2014-02-15 00:10:37.000000', 'consum', 0.0217, 'lps'),
	(532398, 127, '2014-02-15 00:10:38.000000', 'consum', 0.0218, 'lps'),
	(532399, 127, '2014-02-15 00:10:39.000000', 'consum', 0.0212, 'lps'),
	(532400, 127, '2014-02-15 00:10:40.000000', 'consum', 0.0214, 'lps'),
	(532401, 127, '2014-02-15 00:10:41.000000', 'consum', 0.0217, 'lps'),
	(532402, 127, '2014-02-15 00:10:42.000000', 'consum', 0.0212, 'lps'),
	(532403, 127, '2014-02-15 00:10:43.000000', 'consum', 0.0212, 'lps'),
	(532404, 127, '2014-02-15 00:10:44.000000', 'consum', 0.0212, 'lps'),
	(532405, 127, '2014-02-15 00:10:45.000000', 'consum', 0.0216, 'lps'),
	(532406, 127, '2014-02-15 00:10:46.000000', 'consum', 0.0214, 'lps'),
	(532407, 127, '2014-02-15 00:10:47.000000', 'consum', 0.0214, 'lps'),
	(532408, 127, '2014-02-15 00:10:48.000000', 'consum', 0.0216, 'lps'),
	(532409, 127, '2014-02-15 00:10:49.000000', 'consum', 0.0219, 'lps'),
	(532410, 127, '2014-02-15 00:10:50.000000', 'consum', 0.0217, 'lps'),
	(532411, 127, '2014-02-15 00:10:51.000000', 'consum', 0.0210, 'lps'),
	(532412, 127, '2014-02-15 00:10:52.000000', 'consum', 0.0210, 'lps'),
	(532413, 127, '2014-02-15 00:10:53.000000', 'consum', 0.0218, 'lps'),
	(532414, 127, '2014-02-15 00:10:54.000000', 'consum', 0.0211, 'lps'),
	(532415, 127, '2014-02-15 00:10:55.000000', 'consum', 0.0212, 'lps'),
	(532416, 127, '2014-02-15 00:10:56.000000', 'consum', 0.0219, 'lps'),
	(532417, 127, '2014-02-15 00:10:57.000000', 'consum', 0.0217, 'lps'),
	(532418, 127, '2014-02-15 00:10:58.000000', 'consum', 0.0218, 'lps'),
	(532419, 127, '2014-02-15 00:10:59.000000', 'consum', 0.0212, 'lps'),
	(532420, 127, '2014-02-15 00:11:00.000000', 'consum', 0.0216, 'lps'),
	(532421, 127, '2014-02-15 00:11:01.000000', 'consum', 0.0214, 'lps'),
	(532422, 127, '2014-02-15 00:11:02.000000', 'consum', 0.0211, 'lps'),
	(532423, 127, '2014-02-15 00:11:03.000000', 'consum', 0.0214, 'lps'),
	(532424, 127, '2014-02-15 00:11:04.000000', 'consum', 0.0217, 'lps'),
	(532425, 127, '2014-02-15 00:11:05.000000', 'consum', 0.0215, 'lps'),
	(532426, 127, '2014-02-15 00:11:06.000000', 'consum', 0.0212, 'lps'),
	(532427, 127, '2014-02-15 00:11:07.000000', 'consum', 0.0218, 'lps'),
	(532428, 127, '2014-02-15 00:11:08.000000', 'consum', 0.0212, 'lps'),
	(532429, 127, '2014-02-15 00:11:09.000000', 'consum', 0.0216, 'lps'),
	(532430, 127, '2014-02-15 00:11:10.000000', 'consum', 0.0217, 'lps'),
	(532431, 127, '2014-02-15 00:11:11.000000', 'consum', 0.0217, 'lps'),
	(532432, 127, '2014-02-15 00:11:12.000000', 'consum', 0.0215, 'lps'),
	(532433, 127, '2014-02-15 00:11:13.000000', 'consum', 0.0213, 'lps'),
	(532434, 127, '2014-02-15 00:11:14.000000', 'consum', 0.0213, 'lps'),
	(532435, 127, '2014-02-15 00:11:15.000000', 'consum', 0.0216, 'lps'),
	(532436, 127, '2014-02-15 00:11:16.000000', 'consum', 0.0210, 'lps'),
	(532437, 127, '2014-02-15 00:11:17.000000', 'consum', 0.0215, 'lps'),
	(532438, 127, '2014-02-15 00:11:18.000000', 'consum', 0.0215, 'lps'),
	(532439, 127, '2014-02-15 00:11:19.000000', 'consum', 0.0219, 'lps'),
	(532440, 127, '2014-02-15 00:11:20.000000', 'consum', 0.0212, 'lps'),
	(532441, 127, '2014-02-15 00:11:21.000000', 'consum', 0.0212, 'lps'),
	(532442, 127, '2014-02-15 00:11:22.000000', 'consum', 0.0217, 'lps'),
	(532443, 127, '2014-02-15 00:11:23.000000', 'consum', 0.0219, 'lps'),
	(532444, 127, '2014-02-15 00:11:24.000000', 'consum', 0.0214, 'lps'),
	(532445, 127, '2014-02-15 00:11:25.000000', 'consum', 0.0214, 'lps'),
	(532446, 127, '2014-02-15 00:11:26.000000', 'consum', 0.0219, 'lps'),
	(532447, 127, '2014-02-15 00:11:27.000000', 'consum', 0.0213, 'lps'),
	(532448, 127, '2014-02-15 00:11:28.000000', 'consum', 0.0219, 'lps'),
	(532449, 127, '2014-02-15 00:11:29.000000', 'consum', 0.0218, 'lps'),
	(532450, 127, '2014-02-15 00:11:30.000000', 'consum', 0.0211, 'lps'),
	(532451, 127, '2014-02-15 00:11:31.000000', 'consum', 0.0210, 'lps'),
	(532452, 127, '2014-02-15 00:11:32.000000', 'consum', 0.0210, 'lps'),
	(532453, 127, '2014-02-15 00:11:33.000000', 'consum', 0.0212, 'lps'),
	(532454, 127, '2014-02-15 00:11:34.000000', 'consum', 0.0218, 'lps'),
	(532455, 127, '2014-02-15 00:11:35.000000', 'consum', 0.0217, 'lps'),
	(532456, 127, '2014-02-15 00:11:36.000000', 'consum', 0.0219, 'lps'),
	(532457, 127, '2014-02-15 00:11:37.000000', 'consum', 0.0216, 'lps'),
	(532458, 127, '2014-02-15 00:11:38.000000', 'consum', 0.0212, 'lps'),
	(532459, 127, '2014-02-15 00:11:39.000000', 'consum', 0.0214, 'lps'),
	(532460, 127, '2014-02-15 00:11:40.000000', 'consum', 0.0214, 'lps'),
	(532461, 127, '2014-02-15 00:11:41.000000', 'consum', 0.0210, 'lps'),
	(532462, 127, '2014-02-15 00:11:42.000000', 'consum', 0.0216, 'lps'),
	(532463, 127, '2014-02-15 00:11:43.000000', 'consum', 0.0212, 'lps'),
	(532464, 127, '2014-02-15 00:11:44.000000', 'consum', 0.0213, 'lps'),
	(532465, 127, '2014-02-15 00:11:45.000000', 'consum', 0.0218, 'lps'),
	(532466, 127, '2014-02-15 00:11:46.000000', 'consum', 0.0211, 'lps'),
	(532467, 127, '2014-02-15 00:11:47.000000', 'consum', 0.0214, 'lps'),
	(532468, 127, '2014-02-15 00:11:48.000000', 'consum', 0.0215, 'lps'),
	(532469, 127, '2014-02-15 00:11:49.000000', 'consum', 0.0214, 'lps'),
	(532470, 127, '2014-02-15 00:11:50.000000', 'consum', 0.0214, 'lps'),
	(532471, 127, '2014-02-15 00:11:51.000000', 'consum', 0.0210, 'lps'),
	(532472, 127, '2014-02-15 00:11:52.000000', 'consum', 0.0217, 'lps'),
	(532473, 127, '2014-02-15 00:11:53.000000', 'consum', 0.0218, 'lps'),
	(532474, 127, '2014-02-15 00:11:54.000000', 'consum', 0.0217, 'lps'),
	(532475, 127, '2014-02-15 00:11:55.000000', 'consum', 0.0214, 'lps'),
	(532476, 127, '2014-02-15 00:11:56.000000', 'consum', 0.0219, 'lps'),
	(532477, 127, '2014-02-15 00:11:57.000000', 'consum', 0.0213, 'lps'),
	(532478, 127, '2014-02-15 00:11:58.000000', 'consum', 0.0217, 'lps'),
	(532479, 127, '2014-02-15 00:11:59.000000', 'consum', 0.0219, 'lps'),
	(532480, 127, '2014-02-15 00:12:00.000000', 'consum', 0.0213, 'lps'),
	(532481, 127, '2014-02-15 00:12:01.000000', 'consum', 0.0218, 'lps'),
	(532482, 127, '2014-02-15 00:12:02.000000', 'consum', 0.0213, 'lps'),
	(532483, 127, '2014-02-15 00:12:03.000000', 'consum', 0.0212, 'lps'),
	(532484, 127, '2014-02-15 00:12:04.000000', 'consum', 0.0213, 'lps'),
	(532485, 127, '2014-02-15 00:12:05.000000', 'consum', 0.0217, 'lps'),
	(532486, 127, '2014-02-15 00:12:06.000000', 'consum', 0.0218, 'lps'),
	(532487, 127, '2014-02-15 00:12:07.000000', 'consum', 0.0218, 'lps'),
	(532488, 127, '2014-02-15 00:12:08.000000', 'consum', 0.0217, 'lps'),
	(532489, 127, '2014-02-15 00:12:09.000000', 'consum', 0.0211, 'lps'),
	(532490, 127, '2014-02-15 00:12:10.000000', 'consum', 0.0214, 'lps'),
	(532491, 127, '2014-02-15 00:12:11.000000', 'consum', 0.0218, 'lps'),
	(532492, 127, '2014-02-15 00:12:12.000000', 'consum', 0.0210, 'lps'),
	(532493, 127, '2014-02-15 00:12:13.000000', 'consum', 0.0215, 'lps'),
	(532494, 127, '2014-02-15 00:12:14.000000', 'consum', 0.0218, 'lps'),
	(532495, 127, '2014-02-15 00:12:15.000000', 'consum', 0.0212, 'lps'),
	(532496, 127, '2014-02-15 00:12:16.000000', 'consum', 0.0219, 'lps'),
	(532497, 127, '2014-02-15 00:12:17.000000', 'consum', 0.0210, 'lps'),
	(532498, 127, '2014-02-15 00:12:18.000000', 'consum', 0.0213, 'lps'),
	(532499, 127, '2014-02-15 00:12:19.000000', 'consum', 0.0214, 'lps'),
	(532500, 127, '2014-02-15 00:12:20.000000', 'consum', 0.0212, 'lps'),
	(532501, 127, '2014-02-15 00:12:21.000000', 'consum', 0.0210, 'lps'),
	(532502, 127, '2014-02-15 00:12:22.000000', 'consum', 0.0214, 'lps'),
	(532503, 127, '2014-02-15 00:12:23.000000', 'consum', 0.0219, 'lps'),
	(532504, 127, '2014-02-15 00:12:24.000000', 'consum', 0.0212, 'lps'),
	(532505, 127, '2014-02-15 00:12:25.000000', 'consum', 0.0217, 'lps'),
	(532506, 127, '2014-02-15 00:12:26.000000', 'consum', 0.0217, 'lps'),
	(532507, 127, '2014-02-15 00:12:27.000000', 'consum', 0.0216, 'lps'),
	(532508, 127, '2014-02-15 00:12:28.000000', 'consum', 0.0211, 'lps'),
	(532509, 127, '2014-02-15 00:12:29.000000', 'consum', 0.0216, 'lps'),
	(532510, 127, '2014-02-15 00:12:30.000000', 'consum', 0.0216, 'lps'),
	(532511, 127, '2014-02-15 00:12:31.000000', 'consum', 0.0216, 'lps'),
	(532512, 127, '2014-02-15 00:12:32.000000', 'consum', 0.0210, 'lps'),
	(532513, 127, '2014-02-15 00:12:33.000000', 'consum', 0.0212, 'lps'),
	(532514, 127, '2014-02-15 00:12:34.000000', 'consum', 0.0210, 'lps'),
	(532515, 127, '2014-02-15 00:12:35.000000', 'consum', 0.0217, 'lps'),
	(532516, 127, '2014-02-15 00:12:36.000000', 'consum', 0.0215, 'lps'),
	(532517, 127, '2014-02-15 00:12:37.000000', 'consum', 0.0215, 'lps'),
	(532518, 127, '2014-02-15 00:12:38.000000', 'consum', 0.0219, 'lps'),
	(532519, 127, '2014-02-15 00:12:39.000000', 'consum', 0.0210, 'lps'),
	(532520, 127, '2014-02-15 00:12:40.000000', 'consum', 0.0214, 'lps'),
	(532521, 127, '2014-02-15 00:12:41.000000', 'consum', 0.0211, 'lps'),
	(532522, 127, '2014-02-15 00:12:42.000000', 'consum', 0.0215, 'lps'),
	(532523, 127, '2014-02-15 00:12:43.000000', 'consum', 0.0211, 'lps'),
	(532524, 127, '2014-02-15 00:12:44.000000', 'consum', 0.0212, 'lps'),
	(532525, 127, '2014-02-15 00:12:45.000000', 'consum', 0.0215, 'lps'),
	(532526, 127, '2014-02-15 00:12:46.000000', 'consum', 0.0210, 'lps'),
	(532527, 127, '2014-02-15 00:12:47.000000', 'consum', 0.0217, 'lps'),
	(532528, 127, '2014-02-15 00:12:48.000000', 'consum', 0.0217, 'lps'),
	(532529, 127, '2014-02-15 00:12:49.000000', 'consum', 0.0211, 'lps'),
	(532530, 127, '2014-02-15 00:12:50.000000', 'consum', 0.0216, 'lps'),
	(532531, 127, '2014-02-15 00:12:51.000000', 'consum', 0.0219, 'lps'),
	(532532, 127, '2014-02-15 00:12:52.000000', 'consum', 0.0217, 'lps'),
	(532533, 127, '2014-02-15 00:12:53.000000', 'consum', 0.0210, 'lps'),
	(532534, 127, '2014-02-15 00:12:54.000000', 'consum', 0.0219, 'lps'),
	(532535, 127, '2014-02-15 00:12:55.000000', 'consum', 0.0214, 'lps'),
	(532536, 127, '2014-02-15 00:12:56.000000', 'consum', 0.0213, 'lps'),
	(532537, 127, '2014-02-15 00:12:57.000000', 'consum', 0.0216, 'lps'),
	(532538, 127, '2014-02-15 00:12:58.000000', 'consum', 0.0210, 'lps'),
	(532539, 127, '2014-02-15 00:12:59.000000', 'consum', 0.0214, 'lps'),
	(532540, 127, '2014-02-15 00:13:00.000000', 'consum', 0.0219, 'lps'),
	(532541, 127, '2014-02-15 00:13:01.000000', 'consum', 0.0216, 'lps'),
	(532542, 127, '2014-02-15 00:13:02.000000', 'consum', 0.0212, 'lps'),
	(532543, 127, '2014-02-15 00:13:03.000000', 'consum', 0.0211, 'lps'),
	(532544, 127, '2014-02-15 00:13:04.000000', 'consum', 0.0212, 'lps'),
	(532545, 127, '2014-02-15 00:13:05.000000', 'consum', 0.0216, 'lps'),
	(532546, 127, '2014-02-15 00:13:06.000000', 'consum', 0.0216, 'lps'),
	(532547, 127, '2014-02-15 00:13:07.000000', 'consum', 0.0211, 'lps'),
	(532548, 127, '2014-02-15 00:13:08.000000', 'consum', 0.0219, 'lps'),
	(532549, 127, '2014-02-15 00:13:09.000000', 'consum', 0.0212, 'lps'),
	(532550, 127, '2014-02-15 00:13:10.000000', 'consum', 0.0215, 'lps'),
	(532551, 127, '2014-02-15 00:13:11.000000', 'consum', 0.0217, 'lps'),
	(532552, 127, '2014-02-15 00:13:12.000000', 'consum', 0.0210, 'lps'),
	(532553, 127, '2014-02-15 00:13:13.000000', 'consum', 0.0211, 'lps'),
	(532554, 127, '2014-02-15 00:13:14.000000', 'consum', 0.0217, 'lps'),
	(532555, 127, '2014-02-15 00:13:15.000000', 'consum', 0.0212, 'lps'),
	(532556, 127, '2014-02-15 00:13:16.000000', 'consum', 0.0217, 'lps'),
	(532557, 127, '2014-02-15 00:13:17.000000', 'consum', 0.0212, 'lps'),
	(532558, 127, '2014-02-15 00:13:18.000000', 'consum', 0.0210, 'lps'),
	(532559, 127, '2014-02-15 00:13:19.000000', 'consum', 0.0214, 'lps'),
	(532560, 127, '2014-02-15 00:13:20.000000', 'consum', 0.0218, 'lps'),
	(532561, 127, '2014-02-15 00:13:21.000000', 'consum', 0.0211, 'lps'),
	(532562, 127, '2014-02-15 00:13:22.000000', 'consum', 0.0219, 'lps'),
	(532563, 127, '2014-02-15 00:13:23.000000', 'consum', 0.0213, 'lps'),
	(532564, 127, '2014-02-15 00:13:24.000000', 'consum', 0.0219, 'lps'),
	(532565, 127, '2014-02-15 00:13:25.000000', 'consum', 0.0215, 'lps'),
	(532566, 127, '2014-02-15 00:13:26.000000', 'consum', 0.0218, 'lps'),
	(532567, 127, '2014-02-15 00:13:27.000000', 'consum', 0.0219, 'lps'),
	(532568, 127, '2014-02-15 00:13:28.000000', 'consum', 0.0218, 'lps'),
	(532569, 127, '2014-02-15 00:13:29.000000', 'consum', 0.0216, 'lps'),
	(532570, 127, '2014-02-15 00:13:30.000000', 'consum', 0.0217, 'lps'),
	(532571, 127, '2014-02-15 00:13:31.000000', 'consum', 0.0216, 'lps'),
	(532572, 127, '2014-02-15 00:13:32.000000', 'consum', 0.0219, 'lps'),
	(532573, 127, '2014-02-15 00:13:33.000000', 'consum', 0.0216, 'lps'),
	(532574, 127, '2014-02-15 00:13:34.000000', 'consum', 0.0215, 'lps'),
	(532575, 127, '2014-02-15 00:13:35.000000', 'consum', 0.0218, 'lps'),
	(532576, 127, '2014-02-15 00:13:36.000000', 'consum', 0.0215, 'lps'),
	(532577, 127, '2014-02-15 00:13:37.000000', 'consum', 0.0213, 'lps'),
	(532578, 127, '2014-02-15 00:13:38.000000', 'consum', 0.0219, 'lps'),
	(532579, 127, '2014-02-15 00:13:39.000000', 'consum', 0.0217, 'lps'),
	(532580, 127, '2014-02-15 00:13:40.000000', 'consum', 0.0217, 'lps'),
	(532581, 127, '2014-02-15 00:13:41.000000', 'consum', 0.0215, 'lps'),
	(532582, 127, '2014-02-15 00:13:42.000000', 'consum', 0.0216, 'lps'),
	(532583, 127, '2014-02-15 00:13:43.000000', 'consum', 0.0215, 'lps'),
	(532584, 127, '2014-02-15 00:13:44.000000', 'consum', 0.0215, 'lps'),
	(532585, 127, '2014-02-15 00:13:45.000000', 'consum', 0.0214, 'lps'),
	(532586, 127, '2014-02-15 00:13:46.000000', 'consum', 0.0213, 'lps'),
	(532587, 127, '2014-02-15 00:13:47.000000', 'consum', 0.0216, 'lps'),
	(532588, 127, '2014-02-15 00:13:48.000000', 'consum', 0.0219, 'lps'),
	(532589, 127, '2014-02-15 00:13:49.000000', 'consum', 0.0219, 'lps'),
	(532590, 127, '2014-02-15 00:13:50.000000', 'consum', 0.0216, 'lps'),
	(532591, 127, '2014-02-15 00:13:51.000000', 'consum', 0.0215, 'lps'),
	(532592, 127, '2014-02-15 00:13:52.000000', 'consum', 0.0219, 'lps'),
	(532593, 127, '2014-02-15 00:13:53.000000', 'consum', 0.0219, 'lps'),
	(532594, 127, '2014-02-15 00:13:54.000000', 'consum', 0.0219, 'lps'),
	(532595, 127, '2014-02-15 00:13:55.000000', 'consum', 0.0218, 'lps'),
	(532596, 127, '2014-02-15 00:13:56.000000', 'consum', 0.0215, 'lps'),
	(532597, 127, '2014-02-15 00:13:57.000000', 'consum', 0.0210, 'lps'),
	(532598, 127, '2014-02-15 00:13:58.000000', 'consum', 0.0216, 'lps'),
	(532599, 127, '2014-02-15 00:13:59.000000', 'consum', 0.0210, 'lps'),
	(532600, 127, '2014-02-15 00:14:00.000000', 'consum', 0.0215, 'lps'),
	(532601, 127, '2014-02-15 00:14:01.000000', 'consum', 0.0214, 'lps'),
	(532602, 127, '2014-02-15 00:14:02.000000', 'consum', 0.0214, 'lps'),
	(532603, 127, '2014-02-15 00:14:03.000000', 'consum', 0.0219, 'lps'),
	(532604, 127, '2014-02-15 00:14:04.000000', 'consum', 0.0215, 'lps'),
	(532605, 127, '2014-02-15 00:14:05.000000', 'consum', 0.0219, 'lps'),
	(532606, 127, '2014-02-15 00:14:06.000000', 'consum', 0.0211, 'lps'),
	(532607, 127, '2014-02-15 00:14:07.000000', 'consum', 0.0216, 'lps'),
	(532608, 127, '2014-02-15 00:14:08.000000', 'consum', 0.0217, 'lps'),
	(532609, 127, '2014-02-15 00:14:09.000000', 'consum', 0.0219, 'lps'),
	(532610, 127, '2014-02-15 00:14:10.000000', 'consum', 0.0212, 'lps'),
	(532611, 127, '2014-02-15 00:14:11.000000', 'consum', 0.0216, 'lps'),
	(532612, 127, '2014-02-15 00:14:12.000000', 'consum', 0.0215, 'lps'),
	(532613, 127, '2014-02-15 00:14:13.000000', 'consum', 0.0217, 'lps'),
	(532614, 127, '2014-02-15 00:14:14.000000', 'consum', 0.0210, 'lps'),
	(532615, 127, '2014-02-15 00:14:15.000000', 'consum', 0.0210, 'lps'),
	(532616, 127, '2014-02-15 00:14:16.000000', 'consum', 0.0212, 'lps'),
	(532617, 127, '2014-02-15 00:14:17.000000', 'consum', 0.0218, 'lps'),
	(532618, 127, '2014-02-15 00:14:18.000000', 'consum', 0.0214, 'lps'),
	(532619, 127, '2014-02-15 00:14:19.000000', 'consum', 0.0217, 'lps'),
	(532620, 127, '2014-02-15 00:14:20.000000', 'consum', 0.0214, 'lps'),
	(532621, 127, '2014-02-15 00:14:21.000000', 'consum', 0.0219, 'lps'),
	(532622, 127, '2014-02-15 00:14:22.000000', 'consum', 0.0213, 'lps'),
	(532623, 127, '2014-02-15 00:14:23.000000', 'consum', 0.0219, 'lps'),
	(532624, 127, '2014-02-15 00:14:24.000000', 'consum', 0.0215, 'lps'),
	(532625, 127, '2014-02-15 00:14:25.000000', 'consum', 0.0219, 'lps'),
	(532626, 127, '2014-02-15 00:14:26.000000', 'consum', 0.0210, 'lps'),
	(532627, 127, '2014-02-15 00:14:27.000000', 'consum', 0.0214, 'lps'),
	(532628, 127, '2014-02-15 00:14:28.000000', 'consum', 0.0219, 'lps'),
	(532629, 127, '2014-02-15 00:14:29.000000', 'consum', 0.0214, 'lps'),
	(532630, 127, '2014-02-15 00:14:30.000000', 'consum', 0.0215, 'lps'),
	(532631, 127, '2014-02-15 00:14:31.000000', 'consum', 0.0213, 'lps'),
	(532632, 127, '2014-02-15 00:14:32.000000', 'consum', 0.0219, 'lps'),
	(532633, 127, '2014-02-15 00:14:33.000000', 'consum', 0.0216, 'lps'),
	(532634, 127, '2014-02-15 00:14:34.000000', 'consum', 0.0214, 'lps'),
	(532635, 127, '2014-02-15 00:14:35.000000', 'consum', 0.0212, 'lps'),
	(532636, 127, '2014-02-15 00:14:36.000000', 'consum', 0.0219, 'lps'),
	(532637, 127, '2014-02-15 00:14:37.000000', 'consum', 0.0210, 'lps'),
	(532638, 127, '2014-02-15 00:14:38.000000', 'consum', 0.0212, 'lps'),
	(532639, 127, '2014-02-15 00:14:39.000000', 'consum', 0.0213, 'lps'),
	(532640, 127, '2014-02-15 00:14:40.000000', 'consum', 0.0219, 'lps'),
	(532641, 127, '2014-02-15 00:14:41.000000', 'consum', 0.0215, 'lps'),
	(532642, 127, '2014-02-15 00:14:42.000000', 'consum', 0.0211, 'lps'),
	(532643, 127, '2014-02-15 00:14:43.000000', 'consum', 0.0218, 'lps'),
	(532644, 127, '2014-02-15 00:14:44.000000', 'consum', 0.0218, 'lps'),
	(532645, 127, '2014-02-15 00:14:45.000000', 'consum', 0.0218, 'lps'),
	(532646, 127, '2014-02-15 00:14:46.000000', 'consum', 0.0216, 'lps'),
	(532647, 127, '2014-02-15 00:14:47.000000', 'consum', 0.0216, 'lps'),
	(532648, 127, '2014-02-15 00:14:48.000000', 'consum', 0.0213, 'lps'),
	(532649, 127, '2014-02-15 00:14:49.000000', 'consum', 0.0216, 'lps'),
	(532650, 127, '2014-02-15 00:14:50.000000', 'consum', 0.0212, 'lps'),
	(532651, 127, '2014-02-15 00:14:51.000000', 'consum', 0.0214, 'lps'),
	(532652, 127, '2014-02-15 00:14:52.000000', 'consum', 0.0216, 'lps'),
	(532653, 127, '2014-02-15 00:14:53.000000', 'consum', 0.0215, 'lps'),
	(532654, 127, '2014-02-15 00:14:54.000000', 'consum', 0.0219, 'lps'),
	(532655, 127, '2014-02-15 00:14:55.000000', 'consum', 0.0210, 'lps'),
	(532656, 127, '2014-02-15 00:14:56.000000', 'consum', 0.0215, 'lps'),
	(532657, 127, '2014-02-15 00:14:57.000000', 'consum', 0.0216, 'lps'),
	(532658, 127, '2014-02-15 00:14:58.000000', 'consum', 0.0214, 'lps'),
	(532659, 127, '2014-02-15 00:14:59.000000', 'consum', 0.0214, 'lps'),
	(532660, 127, '2014-02-15 00:15:00.000000', 'consum', 0.0216, 'lps'),
	(532661, 127, '2014-02-15 00:15:01.000000', 'consum', 0.0219, 'lps'),
	(532662, 127, '2014-02-15 00:15:02.000000', 'consum', 0.0210, 'lps'),
	(532663, 127, '2014-02-15 00:15:03.000000', 'consum', 0.0211, 'lps'),
	(532664, 127, '2014-02-15 00:15:04.000000', 'consum', 0.0216, 'lps'),
	(532665, 127, '2014-02-15 00:15:05.000000', 'consum', 0.0217, 'lps'),
	(532666, 127, '2014-02-15 00:15:06.000000', 'consum', 0.0218, 'lps'),
	(532667, 127, '2014-02-15 00:15:07.000000', 'consum', 0.0212, 'lps'),
	(532668, 127, '2014-02-15 00:15:08.000000', 'consum', 0.0213, 'lps'),
	(532669, 127, '2014-02-15 00:15:09.000000', 'consum', 0.0210, 'lps'),
	(532670, 127, '2014-02-15 00:15:10.000000', 'consum', 0.0211, 'lps'),
	(532671, 127, '2014-02-15 00:15:11.000000', 'consum', 0.0216, 'lps'),
	(532672, 127, '2014-02-15 00:15:12.000000', 'consum', 0.0210, 'lps'),
	(532673, 127, '2014-02-15 00:15:13.000000', 'consum', 0.0210, 'lps'),
	(532674, 127, '2014-02-15 00:15:14.000000', 'consum', 0.0210, 'lps'),
	(532675, 127, '2014-02-15 00:15:15.000000', 'consum', 0.0211, 'lps'),
	(532676, 127, '2014-02-15 00:15:16.000000', 'consum', 0.0216, 'lps'),
	(532677, 127, '2014-02-15 00:15:17.000000', 'consum', 0.0216, 'lps'),
	(532678, 127, '2014-02-15 00:15:18.000000', 'consum', 0.0215, 'lps'),
	(532679, 127, '2014-02-15 00:15:19.000000', 'consum', 0.0217, 'lps'),
	(532680, 127, '2014-02-15 00:15:20.000000', 'consum', 0.0211, 'lps'),
	(532681, 127, '2014-02-15 00:15:21.000000', 'consum', 0.0213, 'lps'),
	(532682, 127, '2014-02-15 00:15:22.000000', 'consum', 0.0212, 'lps'),
	(532683, 127, '2014-02-15 00:15:23.000000', 'consum', 0.0213, 'lps'),
	(532684, 127, '2014-02-15 00:15:24.000000', 'consum', 0.0218, 'lps'),
	(532685, 127, '2014-02-15 00:15:25.000000', 'consum', 0.0214, 'lps'),
	(532686, 127, '2014-02-15 00:15:26.000000', 'consum', 0.0217, 'lps'),
	(532687, 127, '2014-02-15 00:15:27.000000', 'consum', 0.0210, 'lps'),
	(532688, 127, '2014-02-15 00:15:28.000000', 'consum', 0.0213, 'lps'),
	(532689, 127, '2014-02-15 00:15:29.000000', 'consum', 0.0213, 'lps'),
	(532690, 127, '2014-02-15 00:15:30.000000', 'consum', 0.0216, 'lps'),
	(532691, 127, '2014-02-15 00:15:31.000000', 'consum', 0.0214, 'lps'),
	(532692, 127, '2014-02-15 00:15:32.000000', 'consum', 0.0210, 'lps'),
	(532693, 127, '2014-02-15 00:15:33.000000', 'consum', 0.0219, 'lps'),
	(532694, 127, '2014-02-15 00:15:34.000000', 'consum', 0.0218, 'lps'),
	(532695, 127, '2014-02-15 00:15:35.000000', 'consum', 0.0211, 'lps'),
	(532696, 127, '2014-02-15 00:15:36.000000', 'consum', 0.0210, 'lps'),
	(532697, 127, '2014-02-15 00:15:37.000000', 'consum', 0.0219, 'lps'),
	(532698, 127, '2014-02-15 00:15:38.000000', 'consum', 0.0216, 'lps'),
	(532699, 127, '2014-02-15 00:15:39.000000', 'consum', 0.0215, 'lps'),
	(532700, 127, '2014-02-15 00:15:40.000000', 'consum', 0.0217, 'lps'),
	(532701, 127, '2014-02-15 00:15:41.000000', 'consum', 0.0219, 'lps'),
	(532702, 127, '2014-02-15 00:15:42.000000', 'consum', 0.0216, 'lps'),
	(532703, 127, '2014-02-15 00:15:43.000000', 'consum', 0.0212, 'lps'),
	(532704, 127, '2014-02-15 00:15:44.000000', 'consum', 0.0212, 'lps'),
	(532705, 127, '2014-02-15 00:15:45.000000', 'consum', 0.0217, 'lps'),
	(532706, 127, '2014-02-15 00:15:46.000000', 'consum', 0.0218, 'lps'),
	(532707, 127, '2014-02-15 00:15:47.000000', 'consum', 0.0211, 'lps'),
	(532708, 127, '2014-02-15 00:15:48.000000', 'consum', 0.0211, 'lps'),
	(532709, 127, '2014-02-15 00:15:49.000000', 'consum', 0.0211, 'lps'),
	(532710, 127, '2014-02-15 00:15:50.000000', 'consum', 0.0215, 'lps'),
	(532711, 127, '2014-02-15 00:15:51.000000', 'consum', 0.0211, 'lps'),
	(532712, 127, '2014-02-15 00:15:52.000000', 'consum', 0.0212, 'lps'),
	(532713, 127, '2014-02-15 00:15:53.000000', 'consum', 0.0219, 'lps'),
	(532714, 127, '2014-02-15 00:15:54.000000', 'consum', 0.0216, 'lps'),
	(532715, 127, '2014-02-15 00:15:55.000000', 'consum', 0.0215, 'lps'),
	(532716, 127, '2014-02-15 00:15:56.000000', 'consum', 0.0217, 'lps'),
	(532717, 127, '2014-02-15 00:15:57.000000', 'consum', 0.0212, 'lps'),
	(532718, 127, '2014-02-15 00:15:58.000000', 'consum', 0.0217, 'lps'),
	(532719, 127, '2014-02-15 00:15:59.000000', 'consum', 0.0211, 'lps'),
	(532720, 127, '2014-02-15 00:16:00.000000', 'consum', 0.0213, 'lps'),
	(532721, 127, '2014-02-15 00:16:01.000000', 'consum', 0.0212, 'lps'),
	(532722, 127, '2014-02-15 00:16:02.000000', 'consum', 0.0212, 'lps'),
	(532723, 127, '2014-02-15 00:16:03.000000', 'consum', 0.0216, 'lps'),
	(532724, 127, '2014-02-15 00:16:04.000000', 'consum', 0.0214, 'lps'),
	(532725, 127, '2014-02-15 00:16:05.000000', 'consum', 0.0212, 'lps'),
	(532726, 127, '2014-02-15 00:16:06.000000', 'consum', 0.0218, 'lps'),
	(532727, 127, '2014-02-15 00:16:07.000000', 'consum', 0.0214, 'lps'),
	(532728, 127, '2014-02-15 00:16:08.000000', 'consum', 0.0218, 'lps'),
	(532729, 127, '2014-02-15 00:16:09.000000', 'consum', 0.0218, 'lps'),
	(532730, 127, '2014-02-15 00:16:10.000000', 'consum', 0.0216, 'lps'),
	(532731, 127, '2014-02-15 00:16:11.000000', 'consum', 0.0218, 'lps'),
	(532732, 127, '2014-02-15 00:16:12.000000', 'consum', 0.0210, 'lps'),
	(532733, 127, '2014-02-15 00:16:13.000000', 'consum', 0.0218, 'lps'),
	(532734, 127, '2014-02-15 00:16:14.000000', 'consum', 0.0211, 'lps'),
	(532735, 127, '2014-02-15 00:16:15.000000', 'consum', 0.0212, 'lps'),
	(532736, 127, '2014-02-15 00:16:16.000000', 'consum', 0.0217, 'lps'),
	(532737, 127, '2014-02-15 00:16:17.000000', 'consum', 0.0211, 'lps'),
	(532738, 127, '2014-02-15 00:16:18.000000', 'consum', 0.0214, 'lps'),
	(532739, 127, '2014-02-15 00:16:19.000000', 'consum', 0.0216, 'lps'),
	(532740, 127, '2014-02-15 00:16:20.000000', 'consum', 0.0218, 'lps'),
	(532741, 127, '2014-02-15 00:16:21.000000', 'consum', 0.0212, 'lps'),
	(532742, 127, '2014-02-15 00:16:22.000000', 'consum', 0.0217, 'lps'),
	(532743, 127, '2014-02-15 00:16:23.000000', 'consum', 0.0212, 'lps'),
	(532744, 127, '2014-02-15 00:16:24.000000', 'consum', 0.0218, 'lps'),
	(532745, 127, '2014-02-15 00:16:25.000000', 'consum', 0.0213, 'lps'),
	(532746, 127, '2014-02-15 00:16:26.000000', 'consum', 0.0213, 'lps'),
	(532747, 127, '2014-02-15 00:16:27.000000', 'consum', 0.0216, 'lps'),
	(532748, 127, '2014-02-15 00:16:28.000000', 'consum', 0.0210, 'lps'),
	(532749, 127, '2014-02-15 00:16:29.000000', 'consum', 0.0215, 'lps'),
	(532750, 127, '2014-02-15 00:16:30.000000', 'consum', 0.0215, 'lps'),
	(532751, 127, '2014-02-15 00:16:31.000000', 'consum', 0.0211, 'lps'),
	(532752, 127, '2014-02-15 00:16:32.000000', 'consum', 0.0210, 'lps'),
	(532753, 127, '2014-02-15 00:16:33.000000', 'consum', 0.0218, 'lps'),
	(532754, 127, '2014-02-15 00:16:34.000000', 'consum', 0.0210, 'lps'),
	(532755, 127, '2014-02-15 00:16:35.000000', 'consum', 0.0219, 'lps'),
	(532756, 127, '2014-02-15 00:16:36.000000', 'consum', 0.0212, 'lps'),
	(532757, 127, '2014-02-15 00:16:37.000000', 'consum', 0.0216, 'lps'),
	(532758, 127, '2014-02-15 00:16:38.000000', 'consum', 0.0212, 'lps'),
	(532759, 127, '2014-02-15 00:16:39.000000', 'consum', 0.0215, 'lps'),
	(532760, 127, '2014-02-15 00:16:40.000000', 'consum', 0.0210, 'lps'),
	(532761, 127, '2014-02-15 00:16:41.000000', 'consum', 0.0213, 'lps'),
	(532762, 127, '2014-02-15 00:16:42.000000', 'consum', 0.0215, 'lps'),
	(532763, 127, '2014-02-15 00:16:43.000000', 'consum', 0.0216, 'lps'),
	(532764, 127, '2014-02-15 00:16:44.000000', 'consum', 0.0217, 'lps'),
	(532765, 127, '2014-02-15 00:16:45.000000', 'consum', 0.0216, 'lps'),
	(532766, 127, '2014-02-15 00:16:46.000000', 'consum', 0.0212, 'lps'),
	(532767, 127, '2014-02-15 00:16:47.000000', 'consum', 0.0213, 'lps'),
	(532768, 127, '2014-02-15 00:16:48.000000', 'consum', 0.0210, 'lps'),
	(532769, 127, '2014-02-15 00:16:49.000000', 'consum', 0.0212, 'lps'),
	(532770, 127, '2014-02-15 00:16:50.000000', 'consum', 0.0210, 'lps'),
	(532771, 127, '2014-02-15 00:16:51.000000', 'consum', 0.0213, 'lps'),
	(532772, 127, '2014-02-15 00:16:52.000000', 'consum', 0.0215, 'lps'),
	(532773, 127, '2014-02-15 00:16:53.000000', 'consum', 0.0216, 'lps'),
	(532774, 127, '2014-02-15 00:16:54.000000', 'consum', 0.0218, 'lps'),
	(532775, 127, '2014-02-15 00:16:55.000000', 'consum', 0.0213, 'lps'),
	(532776, 127, '2014-02-15 00:16:56.000000', 'consum', 0.0219, 'lps'),
	(532777, 127, '2014-02-15 00:16:57.000000', 'consum', 0.0216, 'lps'),
	(532778, 127, '2014-02-15 00:16:58.000000', 'consum', 0.0215, 'lps'),
	(532779, 127, '2014-02-15 00:16:59.000000', 'consum', 0.0216, 'lps'),
	(532780, 127, '2014-02-15 00:17:00.000000', 'consum', 0.0215, 'lps'),
	(532781, 127, '2014-02-15 00:17:01.000000', 'consum', 0.0216, 'lps'),
	(532782, 127, '2014-02-15 00:17:02.000000', 'consum', 0.0218, 'lps'),
	(532783, 127, '2014-02-15 00:17:03.000000', 'consum', 0.0214, 'lps'),
	(532784, 127, '2014-02-15 00:17:04.000000', 'consum', 0.0215, 'lps'),
	(532785, 127, '2014-02-15 00:17:05.000000', 'consum', 0.0214, 'lps'),
	(532786, 127, '2014-02-15 00:17:06.000000', 'consum', 0.0215, 'lps'),
	(532787, 127, '2014-02-15 00:17:07.000000', 'consum', 0.0215, 'lps'),
	(532788, 127, '2014-02-15 00:17:08.000000', 'consum', 0.0210, 'lps'),
	(532789, 127, '2014-02-15 00:17:09.000000', 'consum', 0.0214, 'lps'),
	(532790, 127, '2014-02-15 00:17:10.000000', 'consum', 0.0212, 'lps'),
	(532791, 127, '2014-02-15 00:17:11.000000', 'consum', 0.0216, 'lps'),
	(532792, 127, '2014-02-15 00:17:12.000000', 'consum', 0.0218, 'lps'),
	(532793, 127, '2014-02-15 00:17:13.000000', 'consum', 0.0210, 'lps'),
	(532794, 127, '2014-02-15 00:17:14.000000', 'consum', 0.0217, 'lps'),
	(532795, 127, '2014-02-15 00:17:15.000000', 'consum', 0.0218, 'lps'),
	(532796, 127, '2014-02-15 00:17:16.000000', 'consum', 0.0217, 'lps'),
	(532797, 127, '2014-02-15 00:17:17.000000', 'consum', 0.0212, 'lps'),
	(532798, 127, '2014-02-15 00:17:18.000000', 'consum', 0.0218, 'lps'),
	(532799, 127, '2014-02-15 00:17:19.000000', 'consum', 0.0214, 'lps'),
	(532800, 127, '2014-02-15 00:17:20.000000', 'consum', 0.0217, 'lps'),
	(532801, 127, '2014-02-15 00:17:21.000000', 'consum', 0.0215, 'lps'),
	(532802, 127, '2014-02-15 00:17:22.000000', 'consum', 0.0214, 'lps'),
	(532803, 127, '2014-02-15 00:17:23.000000', 'consum', 0.0216, 'lps'),
	(532804, 127, '2014-02-15 00:17:24.000000', 'consum', 0.0217, 'lps'),
	(532805, 127, '2014-02-15 00:17:25.000000', 'consum', 0.0216, 'lps'),
	(532806, 127, '2014-02-15 00:17:26.000000', 'consum', 0.0213, 'lps'),
	(532807, 127, '2014-02-15 00:17:27.000000', 'consum', 0.0216, 'lps'),
	(532808, 127, '2014-02-15 00:17:28.000000', 'consum', 0.0214, 'lps'),
	(532809, 127, '2014-02-15 00:17:29.000000', 'consum', 0.0210, 'lps'),
	(532810, 127, '2014-02-15 00:17:30.000000', 'consum', 0.0217, 'lps'),
	(532811, 127, '2014-02-15 00:17:31.000000', 'consum', 0.0218, 'lps'),
	(532812, 127, '2014-02-15 00:17:32.000000', 'consum', 0.0210, 'lps'),
	(532813, 127, '2014-02-15 00:17:33.000000', 'consum', 0.0214, 'lps'),
	(532814, 127, '2014-02-15 00:17:34.000000', 'consum', 0.0212, 'lps'),
	(532815, 127, '2014-02-15 00:17:35.000000', 'consum', 0.0216, 'lps'),
	(532816, 127, '2014-02-15 00:17:36.000000', 'consum', 0.0218, 'lps'),
	(532817, 127, '2014-02-15 00:17:37.000000', 'consum', 0.0211, 'lps'),
	(532818, 127, '2014-02-15 00:17:38.000000', 'consum', 0.0211, 'lps'),
	(532819, 127, '2014-02-15 00:17:39.000000', 'consum', 0.0212, 'lps'),
	(532820, 127, '2014-02-15 00:17:40.000000', 'consum', 0.0217, 'lps'),
	(532821, 127, '2014-02-15 00:17:41.000000', 'consum', 0.0210, 'lps'),
	(532822, 127, '2014-02-15 00:17:42.000000', 'consum', 0.0210, 'lps'),
	(532823, 127, '2014-02-15 00:17:43.000000', 'consum', 0.0212, 'lps'),
	(532824, 127, '2014-02-15 00:17:44.000000', 'consum', 0.0219, 'lps'),
	(532825, 127, '2014-02-15 00:17:45.000000', 'consum', 0.0219, 'lps'),
	(532826, 127, '2014-02-15 00:17:46.000000', 'consum', 0.0219, 'lps'),
	(532827, 127, '2014-02-15 00:17:47.000000', 'consum', 0.0218, 'lps'),
	(532828, 127, '2014-02-15 00:17:48.000000', 'consum', 0.0215, 'lps'),
	(532829, 127, '2014-02-15 00:17:49.000000', 'consum', 0.0211, 'lps'),
	(532830, 127, '2014-02-15 00:17:50.000000', 'consum', 0.0211, 'lps'),
	(532831, 127, '2014-02-15 00:17:51.000000', 'consum', 0.0211, 'lps'),
	(532832, 127, '2014-02-15 00:17:52.000000', 'consum', 0.0213, 'lps'),
	(532833, 127, '2014-02-15 00:17:53.000000', 'consum', 0.0214, 'lps'),
	(532834, 127, '2014-02-15 00:17:54.000000', 'consum', 0.0219, 'lps'),
	(532835, 127, '2014-02-15 00:17:55.000000', 'consum', 0.0214, 'lps'),
	(532836, 127, '2014-02-15 00:17:56.000000', 'consum', 0.0212, 'lps'),
	(532837, 127, '2014-02-15 00:17:57.000000', 'consum', 0.0210, 'lps'),
	(532838, 127, '2014-02-15 00:17:58.000000', 'consum', 0.0212, 'lps'),
	(532839, 127, '2014-02-15 00:17:59.000000', 'consum', 0.0214, 'lps'),
	(532840, 127, '2014-02-15 00:18:00.000000', 'consum', 0.0214, 'lps'),
	(532841, 127, '2014-02-15 00:18:01.000000', 'consum', 0.0210, 'lps'),
	(532842, 127, '2014-02-15 00:18:02.000000', 'consum', 0.0217, 'lps'),
	(532843, 127, '2014-02-15 00:18:03.000000', 'consum', 0.0217, 'lps'),
	(532844, 127, '2014-02-15 00:18:04.000000', 'consum', 0.0212, 'lps'),
	(532845, 127, '2014-02-15 00:18:05.000000', 'consum', 0.0210, 'lps'),
	(532846, 127, '2014-02-15 00:18:06.000000', 'consum', 0.0215, 'lps'),
	(532847, 127, '2014-02-15 00:18:07.000000', 'consum', 0.0214, 'lps'),
	(532848, 127, '2014-02-15 00:18:08.000000', 'consum', 0.0215, 'lps'),
	(532849, 127, '2014-02-15 00:18:09.000000', 'consum', 0.0214, 'lps'),
	(532850, 127, '2014-02-15 00:18:10.000000', 'consum', 0.0217, 'lps'),
	(532851, 127, '2014-02-15 00:18:11.000000', 'consum', 0.0211, 'lps'),
	(532852, 127, '2014-02-15 00:18:12.000000', 'consum', 0.0218, 'lps'),
	(532853, 127, '2014-02-15 00:18:13.000000', 'consum', 0.0214, 'lps'),
	(532854, 127, '2014-02-15 00:18:14.000000', 'consum', 0.0219, 'lps'),
	(532855, 127, '2014-02-15 00:18:15.000000', 'consum', 0.0213, 'lps'),
	(532856, 127, '2014-02-15 00:18:16.000000', 'consum', 0.0210, 'lps'),
	(532857, 127, '2014-02-15 00:18:17.000000', 'consum', 0.0211, 'lps'),
	(532858, 127, '2014-02-15 00:18:18.000000', 'consum', 0.0215, 'lps'),
	(532859, 127, '2014-02-15 00:18:19.000000', 'consum', 0.0213, 'lps'),
	(532860, 127, '2014-02-15 00:18:20.000000', 'consum', 0.0211, 'lps'),
	(532861, 127, '2014-02-15 00:18:21.000000', 'consum', 0.0215, 'lps'),
	(532862, 127, '2014-02-15 00:18:22.000000', 'consum', 0.0215, 'lps'),
	(532863, 127, '2014-02-15 00:18:23.000000', 'consum', 0.0219, 'lps'),
	(532864, 127, '2014-02-15 00:18:24.000000', 'consum', 0.0210, 'lps'),
	(532865, 127, '2014-02-15 00:18:25.000000', 'consum', 0.0215, 'lps'),
	(532866, 127, '2014-02-15 00:18:26.000000', 'consum', 0.0215, 'lps'),
	(532867, 127, '2014-02-15 00:18:27.000000', 'consum', 0.0211, 'lps'),
	(532868, 127, '2014-02-15 00:18:28.000000', 'consum', 0.0218, 'lps'),
	(532869, 127, '2014-02-15 00:18:29.000000', 'consum', 0.0219, 'lps'),
	(532870, 127, '2014-02-15 00:18:30.000000', 'consum', 0.0210, 'lps'),
	(532871, 127, '2014-02-15 00:18:31.000000', 'consum', 0.0216, 'lps'),
	(532872, 127, '2014-02-15 00:18:32.000000', 'consum', 0.0210, 'lps'),
	(532873, 127, '2014-02-15 00:18:33.000000', 'consum', 0.0211, 'lps'),
	(532874, 127, '2014-02-15 00:18:34.000000', 'consum', 0.0216, 'lps'),
	(532875, 127, '2014-02-15 00:18:35.000000', 'consum', 0.0217, 'lps'),
	(532876, 127, '2014-02-15 00:18:36.000000', 'consum', 0.0218, 'lps'),
	(532877, 127, '2014-02-15 00:18:37.000000', 'consum', 0.0212, 'lps'),
	(532878, 127, '2014-02-15 00:18:38.000000', 'consum', 0.0213, 'lps'),
	(532879, 127, '2014-02-15 00:18:39.000000', 'consum', 0.0211, 'lps'),
	(532880, 127, '2014-02-15 00:18:40.000000', 'consum', 0.0215, 'lps'),
	(532881, 127, '2014-02-15 00:18:41.000000', 'consum', 0.0215, 'lps'),
	(532882, 127, '2014-02-15 00:18:42.000000', 'consum', 0.0218, 'lps'),
	(532883, 127, '2014-02-15 00:18:43.000000', 'consum', 0.0215, 'lps'),
	(532884, 127, '2014-02-15 00:18:44.000000', 'consum', 0.0212, 'lps'),
	(532885, 127, '2014-02-15 00:18:45.000000', 'consum', 0.0216, 'lps'),
	(532886, 127, '2014-02-15 00:18:46.000000', 'consum', 0.0214, 'lps'),
	(532887, 127, '2014-02-15 00:18:47.000000', 'consum', 0.0212, 'lps'),
	(532888, 127, '2014-02-15 00:18:48.000000', 'consum', 0.0218, 'lps'),
	(532889, 127, '2014-02-15 00:18:49.000000', 'consum', 0.0216, 'lps'),
	(532890, 127, '2014-02-15 00:18:50.000000', 'consum', 0.0215, 'lps'),
	(532891, 127, '2014-02-15 00:18:51.000000', 'consum', 0.0216, 'lps'),
	(532892, 127, '2014-02-15 00:18:52.000000', 'consum', 0.0218, 'lps'),
	(532893, 127, '2014-02-15 00:18:53.000000', 'consum', 0.0213, 'lps'),
	(532894, 127, '2014-02-15 00:18:54.000000', 'consum', 0.0212, 'lps'),
	(532895, 127, '2014-02-15 00:18:55.000000', 'consum', 0.0211, 'lps'),
	(532896, 127, '2014-02-15 00:18:56.000000', 'consum', 0.0219, 'lps'),
	(532897, 127, '2014-02-15 00:18:57.000000', 'consum', 0.0213, 'lps'),
	(532898, 127, '2014-02-15 00:18:58.000000', 'consum', 0.0218, 'lps'),
	(532899, 127, '2014-02-15 00:18:59.000000', 'consum', 0.0213, 'lps'),
	(532900, 127, '2014-02-15 00:19:00.000000', 'consum', 0.0213, 'lps'),
	(532901, 127, '2014-02-15 00:19:01.000000', 'consum', 0.0213, 'lps'),
	(532902, 127, '2014-02-15 00:19:02.000000', 'consum', 0.0218, 'lps'),
	(532903, 127, '2014-02-15 00:19:03.000000', 'consum', 0.0210, 'lps'),
	(532904, 127, '2014-02-15 00:19:04.000000', 'consum', 0.0216, 'lps'),
	(532905, 127, '2014-02-15 00:19:05.000000', 'consum', 0.0213, 'lps'),
	(532906, 127, '2014-02-15 00:19:06.000000', 'consum', 0.0215, 'lps'),
	(532907, 127, '2014-02-15 00:19:07.000000', 'consum', 0.0218, 'lps'),
	(532908, 127, '2014-02-15 00:19:08.000000', 'consum', 0.0217, 'lps'),
	(532909, 127, '2014-02-15 00:19:09.000000', 'consum', 0.0210, 'lps'),
	(532910, 127, '2014-02-15 00:19:10.000000', 'consum', 0.0218, 'lps'),
	(532911, 127, '2014-02-15 00:19:11.000000', 'consum', 0.0212, 'lps'),
	(532912, 127, '2014-02-15 00:19:12.000000', 'consum', 0.0215, 'lps'),
	(532913, 127, '2014-02-15 00:19:13.000000', 'consum', 0.0219, 'lps'),
	(532914, 127, '2014-02-15 00:19:14.000000', 'consum', 0.0219, 'lps'),
	(532915, 127, '2014-02-15 00:19:15.000000', 'consum', 0.0212, 'lps'),
	(532916, 127, '2014-02-15 00:19:16.000000', 'consum', 0.0211, 'lps'),
	(532917, 127, '2014-02-15 00:19:17.000000', 'consum', 0.0212, 'lps'),
	(532918, 127, '2014-02-15 00:19:18.000000', 'consum', 0.0215, 'lps'),
	(532919, 127, '2014-02-15 00:19:19.000000', 'consum', 0.0212, 'lps'),
	(532920, 127, '2014-02-15 00:19:20.000000', 'consum', 0.0216, 'lps'),
	(532921, 127, '2014-02-15 00:19:21.000000', 'consum', 0.0212, 'lps'),
	(532922, 127, '2014-02-15 00:19:22.000000', 'consum', 0.0212, 'lps'),
	(532923, 127, '2014-02-15 00:19:23.000000', 'consum', 0.0216, 'lps'),
	(532924, 127, '2014-02-15 00:19:24.000000', 'consum', 0.0214, 'lps'),
	(532925, 127, '2014-02-15 00:19:25.000000', 'consum', 0.0213, 'lps'),
	(532926, 127, '2014-02-15 00:19:26.000000', 'consum', 0.0213, 'lps'),
	(532927, 127, '2014-02-15 00:19:27.000000', 'consum', 0.0218, 'lps'),
	(532928, 127, '2014-02-15 00:19:28.000000', 'consum', 0.0212, 'lps'),
	(532929, 127, '2014-02-15 00:19:29.000000', 'consum', 0.0217, 'lps'),
	(532930, 127, '2014-02-15 00:19:30.000000', 'consum', 0.0218, 'lps'),
	(532931, 127, '2014-02-15 00:19:31.000000', 'consum', 0.0211, 'lps'),
	(532932, 127, '2014-02-15 00:19:32.000000', 'consum', 0.0211, 'lps'),
	(532933, 127, '2014-02-15 00:19:33.000000', 'consum', 0.0213, 'lps'),
	(532934, 127, '2014-02-15 00:19:34.000000', 'consum', 0.0214, 'lps'),
	(532935, 127, '2014-02-15 00:19:35.000000', 'consum', 0.0210, 'lps'),
	(532936, 127, '2014-02-15 00:19:36.000000', 'consum', 0.0219, 'lps'),
	(532937, 127, '2014-02-15 00:19:37.000000', 'consum', 0.0217, 'lps'),
	(532938, 127, '2014-02-15 00:19:38.000000', 'consum', 0.0218, 'lps'),
	(532939, 127, '2014-02-15 00:19:39.000000', 'consum', 0.0218, 'lps'),
	(532940, 127, '2014-02-15 00:19:40.000000', 'consum', 0.0219, 'lps'),
	(532941, 127, '2014-02-15 00:19:41.000000', 'consum', 0.0218, 'lps'),
	(532942, 127, '2014-02-15 00:19:42.000000', 'consum', 0.0217, 'lps'),
	(532943, 127, '2014-02-15 00:19:43.000000', 'consum', 0.0211, 'lps'),
	(532944, 127, '2014-02-15 00:19:44.000000', 'consum', 0.0213, 'lps'),
	(532945, 127, '2014-02-15 00:19:45.000000', 'consum', 0.0212, 'lps'),
	(532946, 127, '2014-02-15 00:19:46.000000', 'consum', 0.0211, 'lps'),
	(532947, 127, '2014-02-15 00:19:47.000000', 'consum', 0.0211, 'lps'),
	(532948, 127, '2014-02-15 00:19:48.000000', 'consum', 0.0210, 'lps'),
	(532949, 127, '2014-02-15 00:19:49.000000', 'consum', 0.0210, 'lps'),
	(532950, 127, '2014-02-15 00:19:50.000000', 'consum', 0.0212, 'lps'),
	(532951, 127, '2014-02-15 00:19:51.000000', 'consum', 0.0218, 'lps'),
	(532952, 127, '2014-02-15 00:19:52.000000', 'consum', 0.0216, 'lps'),
	(532953, 127, '2014-02-15 00:19:53.000000', 'consum', 0.0217, 'lps'),
	(532954, 127, '2014-02-15 00:19:54.000000', 'consum', 0.0219, 'lps'),
	(532955, 127, '2014-02-15 00:19:55.000000', 'consum', 0.0211, 'lps'),
	(532956, 127, '2014-02-15 00:19:56.000000', 'consum', 0.0210, 'lps'),
	(532957, 127, '2014-02-15 00:19:57.000000', 'consum', 0.0216, 'lps'),
	(532958, 127, '2014-02-15 00:19:58.000000', 'consum', 0.0212, 'lps'),
	(532959, 127, '2014-02-15 00:19:59.000000', 'consum', 0.0211, 'lps'),
	(532960, 127, '2014-02-15 00:20:00.000000', 'consum', 0.0212, 'lps'),
	(532961, 127, '2014-02-15 00:20:01.000000', 'consum', 0.0217, 'lps'),
	(532962, 127, '2014-02-15 00:20:02.000000', 'consum', 0.0211, 'lps'),
	(532963, 127, '2014-02-15 00:20:03.000000', 'consum', 0.0213, 'lps'),
	(532964, 127, '2014-02-15 00:20:04.000000', 'consum', 0.0211, 'lps'),
	(532965, 127, '2014-02-15 00:20:05.000000', 'consum', 0.0219, 'lps'),
	(532966, 127, '2014-02-15 00:20:06.000000', 'consum', 0.0213, 'lps'),
	(532967, 127, '2014-02-15 00:20:07.000000', 'consum', 0.0218, 'lps'),
	(532968, 127, '2014-02-15 00:20:08.000000', 'consum', 0.0210, 'lps'),
	(532969, 127, '2014-02-15 00:20:09.000000', 'consum', 0.0218, 'lps'),
	(532970, 127, '2014-02-15 00:20:10.000000', 'consum', 0.0211, 'lps'),
	(532971, 127, '2014-02-15 00:20:11.000000', 'consum', 0.0211, 'lps'),
	(532972, 127, '2014-02-15 00:20:12.000000', 'consum', 0.0212, 'lps'),
	(532973, 127, '2014-02-15 00:20:13.000000', 'consum', 0.0216, 'lps'),
	(532974, 127, '2014-02-15 00:20:14.000000', 'consum', 0.0214, 'lps'),
	(532975, 127, '2014-02-15 00:20:15.000000', 'consum', 0.0214, 'lps'),
	(532976, 127, '2014-02-15 00:20:16.000000', 'consum', 0.0218, 'lps'),
	(532977, 127, '2014-02-15 00:20:17.000000', 'consum', 0.0219, 'lps'),
	(532978, 127, '2014-02-15 00:20:18.000000', 'consum', 0.0210, 'lps'),
	(532979, 127, '2014-02-15 00:20:19.000000', 'consum', 0.0216, 'lps'),
	(532980, 127, '2014-02-15 00:20:20.000000', 'consum', 0.0219, 'lps'),
	(532981, 127, '2014-02-15 00:20:21.000000', 'consum', 0.0216, 'lps'),
	(532982, 127, '2014-02-15 00:20:22.000000', 'consum', 0.0215, 'lps'),
	(532983, 127, '2014-02-15 00:20:23.000000', 'consum', 0.0215, 'lps'),
	(532984, 127, '2014-02-15 00:20:24.000000', 'consum', 0.0214, 'lps'),
	(532985, 127, '2014-02-15 00:20:25.000000', 'consum', 0.0213, 'lps'),
	(532986, 127, '2014-02-15 00:20:26.000000', 'consum', 0.0213, 'lps'),
	(532987, 127, '2014-02-15 00:20:27.000000', 'consum', 0.0216, 'lps'),
	(532988, 127, '2014-02-15 00:20:28.000000', 'consum', 0.0214, 'lps'),
	(532989, 127, '2014-02-15 00:20:29.000000', 'consum', 0.0212, 'lps'),
	(532990, 127, '2014-02-15 00:20:30.000000', 'consum', 0.0219, 'lps'),
	(532991, 127, '2014-02-15 00:20:31.000000', 'consum', 0.0210, 'lps'),
	(532992, 127, '2014-02-15 00:20:32.000000', 'consum', 0.0212, 'lps'),
	(532993, 127, '2014-02-15 00:20:33.000000', 'consum', 0.0212, 'lps'),
	(532994, 127, '2014-02-15 00:20:34.000000', 'consum', 0.0213, 'lps'),
	(532995, 127, '2014-02-15 00:20:35.000000', 'consum', 0.0219, 'lps'),
	(532996, 127, '2014-02-15 00:20:36.000000', 'consum', 0.0216, 'lps'),
	(532997, 127, '2014-02-15 00:20:37.000000', 'consum', 0.0215, 'lps'),
	(532998, 127, '2014-02-15 00:20:38.000000', 'consum', 0.0216, 'lps'),
	(532999, 127, '2014-02-15 00:20:39.000000', 'consum', 0.0215, 'lps'),
	(533000, 127, '2014-02-15 00:20:40.000000', 'consum', 0.0216, 'lps'),
	(533001, 127, '2014-02-15 00:20:41.000000', 'consum', 0.0218, 'lps'),
	(533002, 127, '2014-02-15 00:20:42.000000', 'consum', 0.0214, 'lps'),
	(533003, 127, '2014-02-15 00:20:43.000000', 'consum', 0.0215, 'lps'),
	(533004, 127, '2014-02-15 00:20:44.000000', 'consum', 0.0213, 'lps'),
	(533005, 127, '2014-02-15 00:20:45.000000', 'consum', 0.0210, 'lps'),
	(533006, 127, '2014-02-15 00:20:46.000000', 'consum', 0.0212, 'lps'),
	(533007, 127, '2014-02-15 00:20:47.000000', 'consum', 0.0213, 'lps'),
	(533008, 127, '2014-02-15 00:20:48.000000', 'consum', 0.0216, 'lps'),
	(533009, 127, '2014-02-15 00:20:49.000000', 'consum', 0.0214, 'lps'),
	(533010, 127, '2014-02-15 00:20:50.000000', 'consum', 0.0210, 'lps'),
	(533011, 127, '2014-02-15 00:20:51.000000', 'consum', 0.0211, 'lps'),
	(533012, 127, '2014-02-15 00:20:52.000000', 'consum', 0.0214, 'lps'),
	(533013, 127, '2014-02-15 00:20:53.000000', 'consum', 0.0219, 'lps'),
	(533014, 127, '2014-02-15 00:20:54.000000', 'consum', 0.0211, 'lps'),
	(533015, 127, '2014-02-15 00:20:55.000000', 'consum', 0.0219, 'lps'),
	(533016, 127, '2014-02-15 00:20:56.000000', 'consum', 0.0213, 'lps'),
	(533017, 127, '2014-02-15 00:20:57.000000', 'consum', 0.0210, 'lps'),
	(533018, 127, '2014-02-15 00:20:58.000000', 'consum', 0.0212, 'lps'),
	(533019, 127, '2014-02-15 00:20:59.000000', 'consum', 0.0219, 'lps'),
	(533020, 127, '2014-02-15 00:21:00.000000', 'consum', 0.0219, 'lps'),
	(533021, 127, '2014-02-15 00:21:01.000000', 'consum', 0.0211, 'lps'),
	(533022, 127, '2014-02-15 00:21:02.000000', 'consum', 0.0216, 'lps'),
	(533023, 127, '2014-02-15 00:21:03.000000', 'consum', 0.0210, 'lps'),
	(533024, 127, '2014-02-15 00:21:04.000000', 'consum', 0.0212, 'lps'),
	(533025, 127, '2014-02-15 00:21:05.000000', 'consum', 0.0211, 'lps'),
	(533026, 127, '2014-02-15 00:21:06.000000', 'consum', 0.0219, 'lps'),
	(533027, 127, '2014-02-15 00:21:07.000000', 'consum', 0.0210, 'lps'),
	(533028, 127, '2014-02-15 00:21:08.000000', 'consum', 0.0217, 'lps'),
	(533029, 127, '2014-02-15 00:21:09.000000', 'consum', 0.0214, 'lps'),
	(533030, 127, '2014-02-15 00:21:10.000000', 'consum', 0.0211, 'lps'),
	(533031, 127, '2014-02-15 00:21:11.000000', 'consum', 0.0214, 'lps'),
	(533032, 127, '2014-02-15 00:21:12.000000', 'consum', 0.0218, 'lps'),
	(533033, 127, '2014-02-15 00:21:13.000000', 'consum', 0.0216, 'lps'),
	(533034, 127, '2014-02-15 00:21:14.000000', 'consum', 0.0218, 'lps'),
	(533035, 127, '2014-02-15 00:21:15.000000', 'consum', 0.0214, 'lps'),
	(533036, 127, '2014-02-15 00:21:16.000000', 'consum', 0.0214, 'lps'),
	(533037, 127, '2014-02-15 00:21:17.000000', 'consum', 0.0219, 'lps'),
	(533038, 127, '2014-02-15 00:21:18.000000', 'consum', 0.0216, 'lps'),
	(533039, 127, '2014-02-15 00:21:19.000000', 'consum', 0.0211, 'lps'),
	(533040, 127, '2014-02-15 00:21:20.000000', 'consum', 0.0219, 'lps'),
	(533041, 127, '2014-02-15 00:21:21.000000', 'consum', 0.0213, 'lps'),
	(533042, 127, '2014-02-15 00:21:22.000000', 'consum', 0.0218, 'lps'),
	(533043, 127, '2014-02-15 00:21:23.000000', 'consum', 0.0212, 'lps'),
	(533044, 127, '2014-02-15 00:21:24.000000', 'consum', 0.0214, 'lps'),
	(533045, 127, '2014-02-15 00:21:25.000000', 'consum', 0.0216, 'lps'),
	(533046, 127, '2014-02-15 00:21:26.000000', 'consum', 0.0219, 'lps'),
	(533047, 127, '2014-02-15 00:21:27.000000', 'consum', 0.0216, 'lps'),
	(533048, 127, '2014-02-15 00:21:28.000000', 'consum', 0.0215, 'lps'),
	(533049, 127, '2014-02-15 00:21:29.000000', 'consum', 0.0218, 'lps'),
	(533050, 127, '2014-02-15 00:21:30.000000', 'consum', 0.0214, 'lps'),
	(533051, 127, '2014-02-15 00:21:31.000000', 'consum', 0.0216, 'lps'),
	(533052, 127, '2014-02-15 00:21:32.000000', 'consum', 0.0210, 'lps'),
	(533053, 127, '2014-02-15 00:21:33.000000', 'consum', 0.0213, 'lps'),
	(533054, 127, '2014-02-15 00:21:34.000000', 'consum', 0.0217, 'lps'),
	(533055, 127, '2014-02-15 00:21:35.000000', 'consum', 0.0214, 'lps'),
	(533056, 127, '2014-02-15 00:21:36.000000', 'consum', 0.0212, 'lps'),
	(533057, 127, '2014-02-15 00:21:37.000000', 'consum', 0.0215, 'lps'),
	(533058, 127, '2014-02-15 00:21:38.000000', 'consum', 0.0211, 'lps'),
	(533059, 127, '2014-02-15 00:21:39.000000', 'consum', 0.0213, 'lps'),
	(533060, 127, '2014-02-15 00:21:40.000000', 'consum', 0.0219, 'lps'),
	(533061, 127, '2014-02-15 00:21:41.000000', 'consum', 0.0218, 'lps'),
	(533062, 127, '2014-02-15 00:21:42.000000', 'consum', 0.0215, 'lps'),
	(533063, 127, '2014-02-15 00:21:43.000000', 'consum', 0.0210, 'lps'),
	(533064, 127, '2014-02-15 00:21:44.000000', 'consum', 0.0214, 'lps'),
	(533065, 127, '2014-02-15 00:21:45.000000', 'consum', 0.0211, 'lps'),
	(533066, 127, '2014-02-15 00:21:46.000000', 'consum', 0.0216, 'lps'),
	(533067, 127, '2014-02-15 00:21:47.000000', 'consum', 0.0215, 'lps'),
	(533068, 127, '2014-02-15 00:21:48.000000', 'consum', 0.0210, 'lps'),
	(533069, 127, '2014-02-15 00:21:49.000000', 'consum', 0.0213, 'lps'),
	(533070, 127, '2014-02-15 00:21:50.000000', 'consum', 0.0218, 'lps'),
	(533071, 127, '2014-02-15 00:21:51.000000', 'consum', 0.0210, 'lps'),
	(533072, 127, '2014-02-15 00:21:52.000000', 'consum', 0.0216, 'lps'),
	(533073, 127, '2014-02-15 00:21:53.000000', 'consum', 0.0212, 'lps'),
	(533074, 127, '2014-02-15 00:21:54.000000', 'consum', 0.0211, 'lps'),
	(533075, 127, '2014-02-15 00:21:55.000000', 'consum', 0.0218, 'lps'),
	(533076, 127, '2014-02-15 00:21:56.000000', 'consum', 0.0210, 'lps'),
	(533077, 127, '2014-02-15 00:21:57.000000', 'consum', 0.0216, 'lps'),
	(533078, 127, '2014-02-15 00:21:58.000000', 'consum', 0.0219, 'lps'),
	(533079, 127, '2014-02-15 00:21:59.000000', 'consum', 0.0217, 'lps'),
	(533080, 127, '2014-02-15 00:22:00.000000', 'consum', 0.0211, 'lps'),
	(533081, 127, '2014-02-15 00:22:01.000000', 'consum', 0.0216, 'lps'),
	(533082, 127, '2014-02-15 00:22:02.000000', 'consum', 0.0214, 'lps'),
	(533083, 127, '2014-02-15 00:22:03.000000', 'consum', 0.0212, 'lps'),
	(533084, 127, '2014-02-15 00:22:04.000000', 'consum', 0.0210, 'lps'),
	(533085, 127, '2014-02-15 00:22:05.000000', 'consum', 0.0215, 'lps'),
	(533086, 127, '2014-02-15 00:22:06.000000', 'consum', 0.0216, 'lps'),
	(533087, 127, '2014-02-15 00:22:07.000000', 'consum', 0.0213, 'lps'),
	(533088, 127, '2014-02-15 00:22:08.000000', 'consum', 0.0218, 'lps'),
	(533089, 127, '2014-02-15 00:22:09.000000', 'consum', 0.0212, 'lps'),
	(533090, 127, '2014-02-15 00:22:10.000000', 'consum', 0.0217, 'lps'),
	(533091, 127, '2014-02-15 00:22:11.000000', 'consum', 0.0219, 'lps'),
	(533092, 127, '2014-02-15 00:22:12.000000', 'consum', 0.0213, 'lps'),
	(533093, 127, '2014-02-15 00:22:13.000000', 'consum', 0.0219, 'lps'),
	(533094, 127, '2014-02-15 00:22:14.000000', 'consum', 0.0215, 'lps'),
	(533095, 127, '2014-02-15 00:22:15.000000', 'consum', 0.0211, 'lps'),
	(533096, 127, '2014-02-15 00:22:16.000000', 'consum', 0.0218, 'lps'),
	(533097, 127, '2014-02-15 00:22:17.000000', 'consum', 0.0210, 'lps'),
	(533098, 127, '2014-02-15 00:22:18.000000', 'consum', 0.0216, 'lps'),
	(533099, 127, '2014-02-15 00:22:19.000000', 'consum', 0.0210, 'lps'),
	(533100, 127, '2014-02-15 00:22:20.000000', 'consum', 0.0214, 'lps'),
	(533101, 127, '2014-02-15 00:22:21.000000', 'consum', 0.0211, 'lps'),
	(533102, 127, '2014-02-15 00:22:22.000000', 'consum', 0.0213, 'lps'),
	(533103, 127, '2014-02-15 00:22:23.000000', 'consum', 0.0212, 'lps'),
	(533104, 127, '2014-02-15 00:22:24.000000', 'consum', 0.0210, 'lps'),
	(533105, 127, '2014-02-15 00:22:25.000000', 'consum', 0.0217, 'lps'),
	(533106, 127, '2014-02-15 00:22:26.000000', 'consum', 0.0215, 'lps'),
	(533107, 127, '2014-02-15 00:22:27.000000', 'consum', 0.0214, 'lps'),
	(533108, 127, '2014-02-15 00:22:28.000000', 'consum', 0.0216, 'lps'),
	(533109, 127, '2014-02-15 00:22:29.000000', 'consum', 0.0219, 'lps'),
	(533110, 127, '2014-02-15 00:22:30.000000', 'consum', 0.0219, 'lps'),
	(533111, 127, '2014-02-15 00:22:31.000000', 'consum', 0.0217, 'lps'),
	(533112, 127, '2014-02-15 00:22:32.000000', 'consum', 0.0217, 'lps'),
	(533113, 127, '2014-02-15 00:22:33.000000', 'consum', 0.0215, 'lps'),
	(533114, 127, '2014-02-15 00:22:34.000000', 'consum', 0.0216, 'lps'),
	(533115, 127, '2014-02-15 00:22:35.000000', 'consum', 0.0215, 'lps'),
	(533116, 127, '2014-02-15 00:22:36.000000', 'consum', 0.0215, 'lps'),
	(533117, 127, '2014-02-15 00:22:37.000000', 'consum', 0.0214, 'lps'),
	(533118, 127, '2014-02-15 00:22:38.000000', 'consum', 0.0212, 'lps'),
	(533119, 127, '2014-02-15 00:22:39.000000', 'consum', 0.0211, 'lps'),
	(533120, 127, '2014-02-15 00:22:40.000000', 'consum', 0.0217, 'lps'),
	(533121, 127, '2014-02-15 00:22:41.000000', 'consum', 0.0215, 'lps'),
	(533122, 127, '2014-02-15 00:22:42.000000', 'consum', 0.0214, 'lps'),
	(533123, 127, '2014-02-15 00:22:43.000000', 'consum', 0.0217, 'lps'),
	(533124, 127, '2014-02-15 00:22:44.000000', 'consum', 0.0214, 'lps'),
	(533125, 127, '2014-02-15 00:22:45.000000', 'consum', 0.0218, 'lps'),
	(533126, 127, '2014-02-15 00:22:46.000000', 'consum', 0.0218, 'lps'),
	(533127, 127, '2014-02-15 00:22:47.000000', 'consum', 0.0217, 'lps'),
	(533128, 127, '2014-02-15 00:22:48.000000', 'consum', 0.0210, 'lps'),
	(533129, 127, '2014-02-15 00:22:49.000000', 'consum', 0.0210, 'lps'),
	(533130, 127, '2014-02-15 00:22:50.000000', 'consum', 0.0210, 'lps'),
	(533131, 127, '2014-02-15 00:22:51.000000', 'consum', 0.0213, 'lps'),
	(533132, 127, '2014-02-15 00:22:52.000000', 'consum', 0.0215, 'lps'),
	(533133, 127, '2014-02-15 00:22:53.000000', 'consum', 0.0216, 'lps'),
	(533134, 127, '2014-02-15 00:22:54.000000', 'consum', 0.0213, 'lps'),
	(533135, 127, '2014-02-15 00:22:55.000000', 'consum', 0.0211, 'lps'),
	(533136, 127, '2014-02-15 00:22:56.000000', 'consum', 0.0217, 'lps'),
	(533137, 127, '2014-02-15 00:22:57.000000', 'consum', 0.0210, 'lps'),
	(533138, 127, '2014-02-15 00:22:58.000000', 'consum', 0.0218, 'lps'),
	(533139, 127, '2014-02-15 00:22:59.000000', 'consum', 0.0214, 'lps'),
	(533140, 127, '2014-02-15 00:23:00.000000', 'consum', 0.0216, 'lps'),
	(533141, 127, '2014-02-15 00:23:01.000000', 'consum', 0.0218, 'lps'),
	(533142, 127, '2014-02-15 00:23:02.000000', 'consum', 0.0213, 'lps'),
	(533143, 127, '2014-02-15 00:23:03.000000', 'consum', 0.0210, 'lps'),
	(533144, 127, '2014-02-15 00:23:04.000000', 'consum', 0.0213, 'lps'),
	(533145, 127, '2014-02-15 00:23:05.000000', 'consum', 0.0217, 'lps'),
	(533146, 127, '2014-02-15 00:23:06.000000', 'consum', 0.0216, 'lps'),
	(533147, 127, '2014-02-15 00:23:07.000000', 'consum', 0.0217, 'lps'),
	(533148, 127, '2014-02-15 00:23:08.000000', 'consum', 0.0218, 'lps'),
	(533149, 127, '2014-02-15 00:23:09.000000', 'consum', 0.0219, 'lps'),
	(533150, 127, '2014-02-15 00:23:10.000000', 'consum', 0.0212, 'lps'),
	(533151, 127, '2014-02-15 00:23:11.000000', 'consum', 0.0212, 'lps'),
	(533152, 127, '2014-02-15 00:23:12.000000', 'consum', 0.0216, 'lps'),
	(533153, 127, '2014-02-15 00:23:13.000000', 'consum', 0.0216, 'lps'),
	(533154, 127, '2014-02-15 00:23:14.000000', 'consum', 0.0210, 'lps'),
	(533155, 127, '2014-02-15 00:23:15.000000', 'consum', 0.0215, 'lps'),
	(533156, 127, '2014-02-15 00:23:16.000000', 'consum', 0.0212, 'lps'),
	(533157, 127, '2014-02-15 00:23:17.000000', 'consum', 0.0219, 'lps'),
	(533158, 127, '2014-02-15 00:23:18.000000', 'consum', 0.0217, 'lps'),
	(533159, 127, '2014-02-15 00:23:19.000000', 'consum', 0.0211, 'lps'),
	(533160, 127, '2014-02-15 00:23:20.000000', 'consum', 0.0212, 'lps'),
	(533161, 127, '2014-02-15 00:23:21.000000', 'consum', 0.0217, 'lps'),
	(533162, 127, '2014-02-15 00:23:22.000000', 'consum', 0.0219, 'lps'),
	(533163, 127, '2014-02-15 00:23:23.000000', 'consum', 0.0215, 'lps'),
	(533164, 127, '2014-02-15 00:23:24.000000', 'consum', 0.0210, 'lps'),
	(533165, 127, '2014-02-15 00:23:25.000000', 'consum', 0.0213, 'lps'),
	(533166, 127, '2014-02-15 00:23:26.000000', 'consum', 0.0218, 'lps'),
	(533167, 127, '2014-02-15 00:23:27.000000', 'consum', 0.0210, 'lps'),
	(533168, 127, '2014-02-15 00:23:28.000000', 'consum', 0.0218, 'lps'),
	(533169, 127, '2014-02-15 00:23:29.000000', 'consum', 0.0210, 'lps'),
	(533170, 127, '2014-02-15 00:23:30.000000', 'consum', 0.0216, 'lps'),
	(533171, 127, '2014-02-15 00:23:31.000000', 'consum', 0.0212, 'lps'),
	(533172, 127, '2014-02-15 00:23:32.000000', 'consum', 0.0213, 'lps'),
	(533173, 127, '2014-02-15 00:23:33.000000', 'consum', 0.0219, 'lps'),
	(533174, 127, '2014-02-15 00:23:34.000000', 'consum', 0.0218, 'lps'),
	(533175, 127, '2014-02-15 00:23:35.000000', 'consum', 0.0210, 'lps'),
	(533176, 127, '2014-02-15 00:23:36.000000', 'consum', 0.0210, 'lps'),
	(533177, 127, '2014-02-15 00:23:37.000000', 'consum', 0.0218, 'lps'),
	(533178, 127, '2014-02-15 00:23:38.000000', 'consum', 0.0219, 'lps'),
	(533179, 127, '2014-02-15 00:23:39.000000', 'consum', 0.0215, 'lps'),
	(533180, 127, '2014-02-15 00:23:40.000000', 'consum', 0.0217, 'lps'),
	(533181, 127, '2014-02-15 00:23:41.000000', 'consum', 0.0219, 'lps'),
	(533182, 127, '2014-02-15 00:23:42.000000', 'consum', 0.0218, 'lps'),
	(533183, 127, '2014-02-15 00:23:43.000000', 'consum', 0.0211, 'lps'),
	(533184, 127, '2014-02-15 00:23:44.000000', 'consum', 0.0211, 'lps'),
	(533185, 127, '2014-02-15 00:23:45.000000', 'consum', 0.0215, 'lps'),
	(533186, 127, '2014-02-15 00:23:46.000000', 'consum', 0.0210, 'lps'),
	(533187, 127, '2014-02-15 00:23:47.000000', 'consum', 0.0216, 'lps'),
	(533188, 127, '2014-02-15 00:23:48.000000', 'consum', 0.0210, 'lps'),
	(533189, 127, '2014-02-15 00:23:49.000000', 'consum', 0.0213, 'lps'),
	(533190, 127, '2014-02-15 00:23:50.000000', 'consum', 0.0216, 'lps'),
	(533191, 127, '2014-02-15 00:23:51.000000', 'consum', 0.0210, 'lps'),
	(533192, 127, '2014-02-15 00:23:52.000000', 'consum', 0.0215, 'lps'),
	(533193, 127, '2014-02-15 00:23:53.000000', 'consum', 0.0213, 'lps'),
	(533194, 127, '2014-02-15 00:23:54.000000', 'consum', 0.0210, 'lps'),
	(533195, 127, '2014-02-15 00:23:55.000000', 'consum', 0.0213, 'lps'),
	(533196, 127, '2014-02-15 00:23:56.000000', 'consum', 0.0215, 'lps'),
	(533197, 127, '2014-02-15 00:23:57.000000', 'consum', 0.0215, 'lps'),
	(533198, 127, '2014-02-15 00:23:58.000000', 'consum', 0.0212, 'lps'),
	(533199, 127, '2014-02-15 00:23:59.000000', 'consum', 0.0217, 'lps'),
	(533200, 127, '2014-02-15 00:24:00.000000', 'consum', 0.0216, 'lps'),
	(533201, 127, '2014-02-15 00:24:01.000000', 'consum', 0.0212, 'lps'),
	(533202, 127, '2014-02-15 00:24:02.000000', 'consum', 0.0212, 'lps'),
	(533203, 127, '2014-02-15 00:24:03.000000', 'consum', 0.0214, 'lps'),
	(533204, 127, '2014-02-15 00:24:04.000000', 'consum', 0.0214, 'lps'),
	(533205, 127, '2014-02-15 00:24:05.000000', 'consum', 0.0218, 'lps'),
	(533206, 127, '2014-02-15 00:24:06.000000', 'consum', 0.0210, 'lps'),
	(533207, 127, '2014-02-15 00:24:07.000000', 'consum', 0.0215, 'lps'),
	(533208, 127, '2014-02-15 00:24:08.000000', 'consum', 0.0215, 'lps'),
	(533209, 127, '2014-02-15 00:24:09.000000', 'consum', 0.0212, 'lps'),
	(533210, 127, '2014-02-15 00:24:10.000000', 'consum', 0.0215, 'lps'),
	(533211, 127, '2014-02-15 00:24:11.000000', 'consum', 0.0211, 'lps'),
	(533212, 127, '2014-02-15 00:24:12.000000', 'consum', 0.0210, 'lps'),
	(533213, 127, '2014-02-15 00:24:13.000000', 'consum', 0.0215, 'lps'),
	(533214, 127, '2014-02-15 00:24:14.000000', 'consum', 0.0218, 'lps'),
	(533215, 127, '2014-02-15 00:24:15.000000', 'consum', 0.0216, 'lps'),
	(533216, 127, '2014-02-15 00:24:16.000000', 'consum', 0.0215, 'lps'),
	(533217, 127, '2014-02-15 00:24:17.000000', 'consum', 0.0216, 'lps'),
	(533218, 127, '2014-02-15 00:24:18.000000', 'consum', 0.0218, 'lps'),
	(533219, 127, '2014-02-15 00:24:19.000000', 'consum', 0.0211, 'lps'),
	(533220, 127, '2014-02-15 00:24:20.000000', 'consum', 0.0214, 'lps'),
	(533221, 127, '2014-02-15 00:24:21.000000', 'consum', 0.0216, 'lps'),
	(533222, 127, '2014-02-15 00:24:22.000000', 'consum', 0.0219, 'lps'),
	(533223, 127, '2014-02-15 00:24:23.000000', 'consum', 0.0217, 'lps'),
	(533224, 127, '2014-02-15 00:24:24.000000', 'consum', 0.0218, 'lps'),
	(533225, 127, '2014-02-15 00:24:25.000000', 'consum', 0.0219, 'lps'),
	(533226, 127, '2014-02-15 00:24:26.000000', 'consum', 0.0210, 'lps'),
	(533227, 127, '2014-02-15 00:24:27.000000', 'consum', 0.0216, 'lps'),
	(533228, 127, '2014-02-15 00:24:28.000000', 'consum', 0.0210, 'lps'),
	(533229, 127, '2014-02-15 00:24:29.000000', 'consum', 0.0211, 'lps'),
	(533230, 127, '2014-02-15 00:24:30.000000', 'consum', 0.0218, 'lps'),
	(533231, 127, '2014-02-15 00:24:31.000000', 'consum', 0.0214, 'lps'),
	(533232, 127, '2014-02-15 00:24:32.000000', 'consum', 0.0219, 'lps'),
	(533233, 127, '2014-02-15 00:24:33.000000', 'consum', 0.0215, 'lps'),
	(533234, 127, '2014-02-15 00:24:34.000000', 'consum', 0.0215, 'lps'),
	(533235, 127, '2014-02-15 00:24:35.000000', 'consum', 0.0212, 'lps'),
	(533236, 127, '2014-02-15 00:24:36.000000', 'consum', 0.0214, 'lps'),
	(533237, 127, '2014-02-15 00:24:37.000000', 'consum', 0.0215, 'lps'),
	(533238, 127, '2014-02-15 00:24:38.000000', 'consum', 0.0213, 'lps'),
	(533239, 127, '2014-02-15 00:24:39.000000', 'consum', 0.0210, 'lps'),
	(533240, 127, '2014-02-15 00:24:40.000000', 'consum', 0.0211, 'lps'),
	(533241, 127, '2014-02-15 00:24:41.000000', 'consum', 0.0215, 'lps'),
	(533242, 127, '2014-02-15 00:24:42.000000', 'consum', 0.0214, 'lps'),
	(533243, 127, '2014-02-15 00:24:43.000000', 'consum', 0.0217, 'lps'),
	(533244, 127, '2014-02-15 00:24:44.000000', 'consum', 0.0213, 'lps'),
	(533245, 127, '2014-02-15 00:24:45.000000', 'consum', 0.0214, 'lps'),
	(533246, 127, '2014-02-15 00:24:46.000000', 'consum', 0.0210, 'lps'),
	(533247, 127, '2014-02-15 00:24:47.000000', 'consum', 0.0219, 'lps'),
	(533248, 127, '2014-02-15 00:24:48.000000', 'consum', 0.0215, 'lps'),
	(533249, 127, '2014-02-15 00:24:49.000000', 'consum', 0.0210, 'lps'),
	(533250, 127, '2014-02-15 00:24:50.000000', 'consum', 0.0214, 'lps'),
	(533251, 127, '2014-02-15 00:24:51.000000', 'consum', 0.0210, 'lps'),
	(533252, 127, '2014-02-15 00:24:52.000000', 'consum', 0.0219, 'lps'),
	(533253, 127, '2014-02-15 00:24:53.000000', 'consum', 0.0215, 'lps'),
	(533254, 127, '2014-02-15 00:24:54.000000', 'consum', 0.0211, 'lps'),
	(533255, 127, '2014-02-15 00:24:55.000000', 'consum', 0.0219, 'lps'),
	(533256, 127, '2014-02-15 00:24:56.000000', 'consum', 0.0211, 'lps'),
	(533257, 127, '2014-02-15 00:24:57.000000', 'consum', 0.0211, 'lps'),
	(533258, 127, '2014-02-15 00:24:58.000000', 'consum', 0.0210, 'lps'),
	(533259, 127, '2014-02-15 00:24:59.000000', 'consum', 0.0218, 'lps'),
	(533260, 127, '2014-02-15 00:25:00.000000', 'consum', 0.0219, 'lps'),
	(533261, 127, '2014-02-15 00:25:01.000000', 'consum', 0.0214, 'lps'),
	(533262, 127, '2014-02-15 00:25:02.000000', 'consum', 0.0211, 'lps'),
	(533263, 127, '2014-02-15 00:25:03.000000', 'consum', 0.0216, 'lps'),
	(533264, 127, '2014-02-15 00:25:04.000000', 'consum', 0.0216, 'lps'),
	(533265, 127, '2014-02-15 00:25:05.000000', 'consum', 0.0214, 'lps'),
	(533266, 127, '2014-02-15 00:25:06.000000', 'consum', 0.0210, 'lps'),
	(533267, 127, '2014-02-15 00:25:07.000000', 'consum', 0.0211, 'lps'),
	(533268, 127, '2014-02-15 00:25:08.000000', 'consum', 0.0214, 'lps'),
	(533269, 127, '2014-02-15 00:25:09.000000', 'consum', 0.0216, 'lps'),
	(533270, 127, '2014-02-15 00:25:10.000000', 'consum', 0.0212, 'lps'),
	(533271, 127, '2014-02-15 00:25:11.000000', 'consum', 0.0219, 'lps'),
	(533272, 127, '2014-02-15 00:25:12.000000', 'consum', 0.0213, 'lps'),
	(533273, 127, '2014-02-15 00:25:13.000000', 'consum', 0.0217, 'lps'),
	(533274, 127, '2014-02-15 00:25:14.000000', 'consum', 0.0216, 'lps'),
	(533275, 127, '2014-02-15 00:25:15.000000', 'consum', 0.0219, 'lps'),
	(533276, 127, '2014-02-15 00:25:16.000000', 'consum', 0.0219, 'lps'),
	(533277, 127, '2014-02-15 00:25:17.000000', 'consum', 0.0217, 'lps'),
	(533278, 127, '2014-02-15 00:25:18.000000', 'consum', 0.0217, 'lps'),
	(533279, 127, '2014-02-15 00:25:19.000000', 'consum', 0.0217, 'lps'),
	(533280, 127, '2014-02-15 00:25:20.000000', 'consum', 0.0212, 'lps'),
	(533281, 127, '2014-02-15 00:25:21.000000', 'consum', 0.0210, 'lps'),
	(533282, 127, '2014-02-15 00:25:22.000000', 'consum', 0.0216, 'lps'),
	(533283, 127, '2014-02-15 00:25:23.000000', 'consum', 0.0218, 'lps'),
	(533284, 127, '2014-02-15 00:25:24.000000', 'consum', 0.0216, 'lps'),
	(533285, 127, '2014-02-15 00:25:25.000000', 'consum', 0.0213, 'lps'),
	(533286, 127, '2014-02-15 00:25:26.000000', 'consum', 0.0219, 'lps'),
	(533287, 127, '2014-02-15 00:25:27.000000', 'consum', 0.0218, 'lps'),
	(533288, 127, '2014-02-15 00:25:28.000000', 'consum', 0.0212, 'lps'),
	(533289, 127, '2014-02-15 00:25:29.000000', 'consum', 0.0219, 'lps'),
	(533290, 127, '2014-02-15 00:25:30.000000', 'consum', 0.0217, 'lps'),
	(533291, 127, '2014-02-15 00:25:31.000000', 'consum', 0.0218, 'lps'),
	(533292, 127, '2014-02-15 00:25:32.000000', 'consum', 0.0211, 'lps'),
	(533293, 127, '2014-02-15 00:25:33.000000', 'consum', 0.0211, 'lps'),
	(533294, 127, '2014-02-15 00:25:34.000000', 'consum', 0.0211, 'lps'),
	(533295, 127, '2014-02-15 00:25:35.000000', 'consum', 0.0212, 'lps'),
	(533296, 127, '2014-02-15 00:25:36.000000', 'consum', 0.0217, 'lps'),
	(533297, 127, '2014-02-15 00:25:37.000000', 'consum', 0.0212, 'lps'),
	(533298, 127, '2014-02-15 00:25:38.000000', 'consum', 0.0210, 'lps'),
	(533299, 127, '2014-02-15 00:25:39.000000', 'consum', 0.0213, 'lps'),
	(533300, 127, '2014-02-15 00:25:40.000000', 'consum', 0.0214, 'lps'),
	(533301, 127, '2014-02-15 00:25:41.000000', 'consum', 0.0213, 'lps'),
	(533302, 127, '2014-02-15 00:25:42.000000', 'consum', 0.0215, 'lps'),
	(533303, 127, '2014-02-15 00:25:43.000000', 'consum', 0.0215, 'lps'),
	(533304, 127, '2014-02-15 00:25:44.000000', 'consum', 0.0211, 'lps'),
	(533305, 127, '2014-02-15 00:25:45.000000', 'consum', 0.0212, 'lps'),
	(533306, 127, '2014-02-15 00:25:46.000000', 'consum', 0.0215, 'lps'),
	(533307, 127, '2014-02-15 00:25:47.000000', 'consum', 0.0219, 'lps'),
	(533308, 127, '2014-02-15 00:25:48.000000', 'consum', 0.0212, 'lps'),
	(533309, 127, '2014-02-15 00:25:49.000000', 'consum', 0.0214, 'lps'),
	(533310, 127, '2014-02-15 00:25:50.000000', 'consum', 0.0215, 'lps'),
	(533311, 127, '2014-02-15 00:25:51.000000', 'consum', 0.0214, 'lps'),
	(533312, 127, '2014-02-15 00:25:52.000000', 'consum', 0.0216, 'lps'),
	(533313, 127, '2014-02-15 00:25:53.000000', 'consum', 0.0216, 'lps'),
	(533314, 127, '2014-02-15 00:25:54.000000', 'consum', 0.0214, 'lps'),
	(533315, 127, '2014-02-15 00:25:55.000000', 'consum', 0.0213, 'lps'),
	(533316, 127, '2014-02-15 00:25:56.000000', 'consum', 0.0214, 'lps'),
	(533317, 127, '2014-02-15 00:25:57.000000', 'consum', 0.0219, 'lps'),
	(533318, 127, '2014-02-15 00:25:58.000000', 'consum', 0.0213, 'lps'),
	(533319, 127, '2014-02-15 00:25:59.000000', 'consum', 0.0211, 'lps'),
	(533320, 127, '2014-02-15 00:26:00.000000', 'consum', 0.0214, 'lps'),
	(533321, 127, '2014-02-15 00:26:01.000000', 'consum', 0.0211, 'lps'),
	(533322, 127, '2014-02-15 00:26:02.000000', 'consum', 0.0211, 'lps'),
	(533323, 127, '2014-02-15 00:26:03.000000', 'consum', 0.0211, 'lps'),
	(533324, 127, '2014-02-15 00:26:04.000000', 'consum', 0.0215, 'lps'),
	(533325, 127, '2014-02-15 00:26:05.000000', 'consum', 0.0212, 'lps'),
	(533326, 127, '2014-02-15 00:26:06.000000', 'consum', 0.0213, 'lps'),
	(533327, 127, '2014-02-15 00:26:07.000000', 'consum', 0.0213, 'lps'),
	(533328, 127, '2014-02-15 00:26:08.000000', 'consum', 0.0216, 'lps'),
	(533329, 127, '2014-02-15 00:26:09.000000', 'consum', 0.0213, 'lps'),
	(533330, 127, '2014-02-15 00:26:10.000000', 'consum', 0.0214, 'lps'),
	(533331, 127, '2014-02-15 00:26:11.000000', 'consum', 0.0213, 'lps'),
	(533332, 127, '2014-02-15 00:26:12.000000', 'consum', 0.0214, 'lps'),
	(533333, 127, '2014-02-15 00:26:13.000000', 'consum', 0.0212, 'lps'),
	(533334, 127, '2014-02-15 00:26:14.000000', 'consum', 0.0217, 'lps'),
	(533335, 127, '2014-02-15 00:26:15.000000', 'consum', 0.0211, 'lps'),
	(533336, 127, '2014-02-15 00:26:16.000000', 'consum', 0.0213, 'lps'),
	(533337, 127, '2014-02-15 00:26:17.000000', 'consum', 0.0215, 'lps'),
	(533338, 127, '2014-02-15 00:26:18.000000', 'consum', 0.0213, 'lps'),
	(533339, 127, '2014-02-15 00:26:19.000000', 'consum', 0.0214, 'lps'),
	(533340, 127, '2014-02-15 00:26:20.000000', 'consum', 0.0219, 'lps'),
	(533341, 127, '2014-02-15 00:26:21.000000', 'consum', 0.0214, 'lps'),
	(533342, 127, '2014-02-15 00:26:22.000000', 'consum', 0.0213, 'lps'),
	(533343, 127, '2014-02-15 00:26:23.000000', 'consum', 0.0214, 'lps'),
	(533344, 127, '2014-02-15 00:26:24.000000', 'consum', 0.0211, 'lps'),
	(533345, 127, '2014-02-15 00:26:25.000000', 'consum', 0.0213, 'lps'),
	(533346, 127, '2014-02-15 00:26:26.000000', 'consum', 0.0212, 'lps'),
	(533347, 127, '2014-02-15 00:26:27.000000', 'consum', 0.0211, 'lps'),
	(533348, 127, '2014-02-15 00:26:28.000000', 'consum', 0.0210, 'lps'),
	(533349, 127, '2014-02-15 00:26:29.000000', 'consum', 0.0216, 'lps'),
	(533350, 127, '2014-02-15 00:26:30.000000', 'consum', 0.0214, 'lps'),
	(533351, 127, '2014-02-15 00:26:31.000000', 'consum', 0.0219, 'lps'),
	(533352, 127, '2014-02-15 00:26:32.000000', 'consum', 0.0216, 'lps'),
	(533353, 127, '2014-02-15 00:26:33.000000', 'consum', 0.0214, 'lps'),
	(533354, 127, '2014-02-15 00:26:34.000000', 'consum', 0.0211, 'lps'),
	(533355, 127, '2014-02-15 00:26:35.000000', 'consum', 0.0215, 'lps'),
	(533356, 127, '2014-02-15 00:26:36.000000', 'consum', 0.0211, 'lps'),
	(533357, 127, '2014-02-15 00:26:37.000000', 'consum', 0.0211, 'lps'),
	(533358, 127, '2014-02-15 00:26:38.000000', 'consum', 0.0214, 'lps'),
	(533359, 127, '2014-02-15 00:26:39.000000', 'consum', 0.0217, 'lps'),
	(533360, 127, '2014-02-15 00:26:40.000000', 'consum', 0.0214, 'lps'),
	(533361, 127, '2014-02-15 00:26:41.000000', 'consum', 0.0218, 'lps'),
	(533362, 127, '2014-02-15 00:26:42.000000', 'consum', 0.0219, 'lps'),
	(533363, 127, '2014-02-15 00:26:43.000000', 'consum', 0.0210, 'lps'),
	(533364, 127, '2014-02-15 00:26:44.000000', 'consum', 0.0214, 'lps'),
	(533365, 127, '2014-02-15 00:26:45.000000', 'consum', 0.0212, 'lps'),
	(533366, 127, '2014-02-15 00:26:46.000000', 'consum', 0.0217, 'lps'),
	(533367, 127, '2014-02-15 00:26:47.000000', 'consum', 0.0218, 'lps'),
	(533368, 127, '2014-02-15 00:26:48.000000', 'consum', 0.0210, 'lps'),
	(533369, 127, '2014-02-15 00:26:49.000000', 'consum', 0.0219, 'lps'),
	(533370, 127, '2014-02-15 00:26:50.000000', 'consum', 0.0214, 'lps'),
	(533371, 127, '2014-02-15 00:26:51.000000', 'consum', 0.0215, 'lps'),
	(533372, 127, '2014-02-15 00:26:52.000000', 'consum', 0.0214, 'lps'),
	(533373, 127, '2014-02-15 00:26:53.000000', 'consum', 0.0215, 'lps'),
	(533374, 127, '2014-02-15 00:26:54.000000', 'consum', 0.0212, 'lps'),
	(533375, 127, '2014-02-15 00:26:55.000000', 'consum', 0.0217, 'lps'),
	(533376, 127, '2014-02-15 00:26:56.000000', 'consum', 0.0218, 'lps'),
	(533377, 127, '2014-02-15 00:26:57.000000', 'consum', 0.0210, 'lps'),
	(533378, 127, '2014-02-15 00:26:58.000000', 'consum', 0.0218, 'lps'),
	(533379, 127, '2014-02-15 00:26:59.000000', 'consum', 0.0219, 'lps'),
	(533380, 127, '2014-02-15 00:27:00.000000', 'consum', 0.0213, 'lps'),
	(533381, 127, '2014-02-15 00:27:01.000000', 'consum', 0.0216, 'lps'),
	(533382, 127, '2014-02-15 00:27:02.000000', 'consum', 0.0213, 'lps'),
	(533383, 127, '2014-02-15 00:27:03.000000', 'consum', 0.0218, 'lps'),
	(533384, 127, '2014-02-15 00:27:04.000000', 'consum', 0.0210, 'lps'),
	(533385, 127, '2014-02-15 00:27:05.000000', 'consum', 0.0218, 'lps'),
	(533386, 127, '2014-02-15 00:27:06.000000', 'consum', 0.0218, 'lps'),
	(533387, 127, '2014-02-15 00:27:07.000000', 'consum', 0.0219, 'lps'),
	(533388, 127, '2014-02-15 00:27:08.000000', 'consum', 0.0219, 'lps'),
	(533389, 127, '2014-02-15 00:27:09.000000', 'consum', 0.0211, 'lps'),
	(533390, 127, '2014-02-15 00:27:10.000000', 'consum', 0.0217, 'lps'),
	(533391, 127, '2014-02-15 00:27:11.000000', 'consum', 0.0215, 'lps'),
	(533392, 127, '2014-02-15 00:27:12.000000', 'consum', 0.0213, 'lps'),
	(533393, 127, '2014-02-15 00:27:13.000000', 'consum', 0.0211, 'lps'),
	(533394, 127, '2014-02-15 00:27:14.000000', 'consum', 0.0214, 'lps'),
	(533395, 127, '2014-02-15 00:27:15.000000', 'consum', 0.0210, 'lps'),
	(533396, 127, '2014-02-15 00:27:16.000000', 'consum', 0.0217, 'lps'),
	(533397, 127, '2014-02-15 00:27:17.000000', 'consum', 0.0217, 'lps'),
	(533398, 127, '2014-02-15 00:27:18.000000', 'consum', 0.0213, 'lps'),
	(533399, 127, '2014-02-15 00:27:19.000000', 'consum', 0.0214, 'lps'),
	(533400, 127, '2014-02-15 00:27:20.000000', 'consum', 0.0210, 'lps'),
	(533401, 127, '2014-02-15 00:27:21.000000', 'consum', 0.0212, 'lps'),
	(533402, 127, '2014-02-15 00:27:22.000000', 'consum', 0.0219, 'lps'),
	(533403, 127, '2014-02-15 00:27:23.000000', 'consum', 0.0218, 'lps'),
	(533404, 127, '2014-02-15 00:27:24.000000', 'consum', 0.0216, 'lps'),
	(533405, 127, '2014-02-15 00:27:25.000000', 'consum', 0.0214, 'lps'),
	(533406, 127, '2014-02-15 00:27:26.000000', 'consum', 0.0214, 'lps'),
	(533407, 127, '2014-02-15 00:27:27.000000', 'consum', 0.0216, 'lps'),
	(533408, 127, '2014-02-15 00:27:28.000000', 'consum', 0.0211, 'lps'),
	(533409, 127, '2014-02-15 00:27:29.000000', 'consum', 0.0217, 'lps'),
	(533410, 127, '2014-02-15 00:27:30.000000', 'consum', 0.0211, 'lps'),
	(533411, 127, '2014-02-15 00:27:31.000000', 'consum', 0.0213, 'lps'),
	(533412, 127, '2014-02-15 00:27:32.000000', 'consum', 0.0216, 'lps'),
	(533413, 127, '2014-02-15 00:27:33.000000', 'consum', 0.0218, 'lps'),
	(533414, 127, '2014-02-15 00:27:34.000000', 'consum', 0.0216, 'lps'),
	(533415, 127, '2014-02-15 00:27:35.000000', 'consum', 0.0214, 'lps'),
	(533416, 127, '2014-02-15 00:27:36.000000', 'consum', 0.0213, 'lps'),
	(533417, 127, '2014-02-15 00:27:37.000000', 'consum', 0.0212, 'lps'),
	(533418, 127, '2014-02-15 00:27:38.000000', 'consum', 0.0214, 'lps'),
	(533419, 127, '2014-02-15 00:27:39.000000', 'consum', 0.0213, 'lps'),
	(533420, 127, '2014-02-15 00:27:40.000000', 'consum', 0.0215, 'lps'),
	(533421, 127, '2014-02-15 00:27:41.000000', 'consum', 0.0216, 'lps'),
	(533422, 127, '2014-02-15 00:27:42.000000', 'consum', 0.0215, 'lps'),
	(533423, 127, '2014-02-15 00:27:43.000000', 'consum', 0.0218, 'lps'),
	(533424, 127, '2014-02-15 00:27:44.000000', 'consum', 0.0217, 'lps'),
	(533425, 127, '2014-02-15 00:27:45.000000', 'consum', 0.0210, 'lps'),
	(533426, 127, '2014-02-15 00:27:46.000000', 'consum', 0.0212, 'lps'),
	(533427, 127, '2014-02-15 00:27:47.000000', 'consum', 0.0218, 'lps'),
	(533428, 127, '2014-02-15 00:27:48.000000', 'consum', 0.0214, 'lps'),
	(533429, 127, '2014-02-15 00:27:49.000000', 'consum', 0.0216, 'lps'),
	(533430, 127, '2014-02-15 00:27:50.000000', 'consum', 0.0210, 'lps'),
	(533431, 127, '2014-02-15 00:27:51.000000', 'consum', 0.0212, 'lps'),
	(533432, 127, '2014-02-15 00:27:52.000000', 'consum', 0.0210, 'lps'),
	(533433, 127, '2014-02-15 00:27:53.000000', 'consum', 0.0215, 'lps'),
	(533434, 127, '2014-02-15 00:27:54.000000', 'consum', 0.0216, 'lps'),
	(533435, 127, '2014-02-15 00:27:55.000000', 'consum', 0.0216, 'lps'),
	(533436, 127, '2014-02-15 00:27:56.000000', 'consum', 0.0214, 'lps'),
	(533437, 127, '2014-02-15 00:27:57.000000', 'consum', 0.0210, 'lps'),
	(533438, 127, '2014-02-15 00:27:58.000000', 'consum', 0.0210, 'lps'),
	(533439, 127, '2014-02-15 00:27:59.000000', 'consum', 0.0212, 'lps'),
	(533440, 127, '2014-02-15 00:28:00.000000', 'consum', 0.0218, 'lps'),
	(533441, 127, '2014-02-15 00:28:01.000000', 'consum', 0.0215, 'lps'),
	(533442, 127, '2014-02-15 00:28:02.000000', 'consum', 0.0212, 'lps'),
	(533443, 127, '2014-02-15 00:28:03.000000', 'consum', 0.0217, 'lps'),
	(533444, 127, '2014-02-15 00:28:04.000000', 'consum', 0.0218, 'lps'),
	(533445, 127, '2014-02-15 00:28:05.000000', 'consum', 0.0219, 'lps'),
	(533446, 127, '2014-02-15 00:28:06.000000', 'consum', 0.0211, 'lps'),
	(533447, 127, '2014-02-15 00:28:07.000000', 'consum', 0.0210, 'lps'),
	(533448, 127, '2014-02-15 00:28:08.000000', 'consum', 0.0219, 'lps'),
	(533449, 127, '2014-02-15 00:28:09.000000', 'consum', 0.0214, 'lps'),
	(533450, 127, '2014-02-15 00:28:10.000000', 'consum', 0.0212, 'lps'),
	(533451, 127, '2014-02-15 00:28:11.000000', 'consum', 0.0210, 'lps'),
	(533452, 127, '2014-02-15 00:28:12.000000', 'consum', 0.0212, 'lps'),
	(533453, 127, '2014-02-15 00:28:13.000000', 'consum', 0.0214, 'lps'),
	(533454, 127, '2014-02-15 00:28:14.000000', 'consum', 0.0212, 'lps'),
	(533455, 127, '2014-02-15 00:28:15.000000', 'consum', 0.0210, 'lps'),
	(533456, 127, '2014-02-15 00:28:16.000000', 'consum', 0.0212, 'lps'),
	(533457, 127, '2014-02-15 00:28:17.000000', 'consum', 0.0212, 'lps'),
	(533458, 127, '2014-02-15 00:28:18.000000', 'consum', 0.0214, 'lps'),
	(533459, 127, '2014-02-15 00:28:19.000000', 'consum', 0.0213, 'lps'),
	(533460, 127, '2014-02-15 00:28:20.000000', 'consum', 0.0214, 'lps'),
	(533461, 127, '2014-02-15 00:28:21.000000', 'consum', 0.0214, 'lps'),
	(533462, 127, '2014-02-15 00:28:22.000000', 'consum', 0.0216, 'lps'),
	(533463, 127, '2014-02-15 00:28:23.000000', 'consum', 0.0219, 'lps'),
	(533464, 127, '2014-02-15 00:28:24.000000', 'consum', 0.0218, 'lps'),
	(533465, 127, '2014-02-15 00:28:25.000000', 'consum', 0.0211, 'lps'),
	(533466, 127, '2014-02-15 00:28:26.000000', 'consum', 0.0215, 'lps'),
	(533467, 127, '2014-02-15 00:28:27.000000', 'consum', 0.0210, 'lps'),
	(533468, 127, '2014-02-15 00:28:28.000000', 'consum', 0.0217, 'lps'),
	(533469, 127, '2014-02-15 00:28:29.000000', 'consum', 0.0216, 'lps'),
	(533470, 127, '2014-02-15 00:28:30.000000', 'consum', 0.0219, 'lps'),
	(533471, 127, '2014-02-15 00:28:31.000000', 'consum', 0.0219, 'lps'),
	(533472, 127, '2014-02-15 00:28:32.000000', 'consum', 0.0217, 'lps'),
	(533473, 127, '2014-02-15 00:28:33.000000', 'consum', 0.0217, 'lps'),
	(533474, 127, '2014-02-15 00:28:34.000000', 'consum', 0.0214, 'lps'),
	(533475, 127, '2014-02-15 00:28:35.000000', 'consum', 0.0211, 'lps'),
	(533476, 127, '2014-02-15 00:28:36.000000', 'consum', 0.0213, 'lps'),
	(533477, 127, '2014-02-15 00:28:37.000000', 'consum', 0.0212, 'lps'),
	(533478, 127, '2014-02-15 00:28:38.000000', 'consum', 0.0211, 'lps'),
	(533479, 127, '2014-02-15 00:28:39.000000', 'consum', 0.0219, 'lps'),
	(533480, 127, '2014-02-15 00:28:40.000000', 'consum', 0.0213, 'lps'),
	(533481, 127, '2014-02-15 00:28:41.000000', 'consum', 0.0211, 'lps'),
	(533482, 127, '2014-02-15 00:28:42.000000', 'consum', 0.0213, 'lps'),
	(533483, 127, '2014-02-15 00:28:43.000000', 'consum', 0.0213, 'lps'),
	(533484, 127, '2014-02-15 00:28:44.000000', 'consum', 0.0217, 'lps'),
	(533485, 127, '2014-02-15 00:28:45.000000', 'consum', 0.0214, 'lps'),
	(533486, 127, '2014-02-15 00:28:46.000000', 'consum', 0.0213, 'lps'),
	(533487, 127, '2014-02-15 00:28:47.000000', 'consum', 0.0213, 'lps'),
	(533488, 127, '2014-02-15 00:28:48.000000', 'consum', 0.0215, 'lps'),
	(533489, 127, '2014-02-15 00:28:49.000000', 'consum', 0.0218, 'lps'),
	(533490, 127, '2014-02-15 00:28:50.000000', 'consum', 0.0216, 'lps'),
	(533491, 127, '2014-02-15 00:28:51.000000', 'consum', 0.0217, 'lps'),
	(533492, 127, '2014-02-15 00:28:52.000000', 'consum', 0.0218, 'lps'),
	(533493, 127, '2014-02-15 00:28:53.000000', 'consum', 0.0218, 'lps'),
	(533494, 127, '2014-02-15 00:28:54.000000', 'consum', 0.0216, 'lps'),
	(533495, 127, '2014-02-15 00:28:55.000000', 'consum', 0.0218, 'lps'),
	(533496, 127, '2014-02-15 00:28:56.000000', 'consum', 0.0214, 'lps'),
	(533497, 127, '2014-02-15 00:28:57.000000', 'consum', 0.0214, 'lps'),
	(533498, 127, '2014-02-15 00:28:58.000000', 'consum', 0.0219, 'lps'),
	(533499, 127, '2014-02-15 00:28:59.000000', 'consum', 0.0213, 'lps'),
	(533500, 127, '2014-02-15 00:29:00.000000', 'consum', 0.0218, 'lps'),
	(533501, 127, '2014-02-15 00:29:01.000000', 'consum', 0.0212, 'lps'),
	(533502, 127, '2014-02-15 00:29:02.000000', 'consum', 0.0216, 'lps'),
	(533503, 127, '2014-02-15 00:29:03.000000', 'consum', 0.0214, 'lps'),
	(533504, 127, '2014-02-15 00:29:04.000000', 'consum', 0.0213, 'lps'),
	(533505, 127, '2014-02-15 00:29:05.000000', 'consum', 0.0212, 'lps'),
	(533506, 127, '2014-02-15 00:29:06.000000', 'consum', 0.0212, 'lps'),
	(533507, 127, '2014-02-15 00:29:07.000000', 'consum', 0.0215, 'lps'),
	(533508, 127, '2014-02-15 00:29:08.000000', 'consum', 0.0211, 'lps'),
	(533509, 127, '2014-02-15 00:29:09.000000', 'consum', 0.0211, 'lps'),
	(533510, 127, '2014-02-15 00:29:10.000000', 'consum', 0.0213, 'lps'),
	(533511, 127, '2014-02-15 00:29:11.000000', 'consum', 0.0212, 'lps'),
	(533512, 127, '2014-02-15 00:29:12.000000', 'consum', 0.0210, 'lps'),
	(533513, 127, '2014-02-15 00:29:13.000000', 'consum', 0.0215, 'lps'),
	(533514, 127, '2014-02-15 00:29:14.000000', 'consum', 0.0217, 'lps'),
	(533515, 127, '2014-02-15 00:29:15.000000', 'consum', 0.0218, 'lps'),
	(533516, 127, '2014-02-15 00:29:16.000000', 'consum', 0.0211, 'lps'),
	(533517, 127, '2014-02-15 00:29:17.000000', 'consum', 0.0210, 'lps'),
	(533518, 127, '2014-02-15 00:29:18.000000', 'consum', 0.0217, 'lps'),
	(533519, 127, '2014-02-15 00:29:19.000000', 'consum', 0.0215, 'lps'),
	(533520, 127, '2014-02-15 00:29:20.000000', 'consum', 0.0216, 'lps'),
	(533521, 127, '2014-02-15 00:29:21.000000', 'consum', 0.0213, 'lps'),
	(533522, 127, '2014-02-15 00:29:22.000000', 'consum', 0.0210, 'lps'),
	(533523, 127, '2014-02-15 00:29:23.000000', 'consum', 0.0219, 'lps'),
	(533524, 127, '2014-02-15 00:29:24.000000', 'consum', 0.0219, 'lps'),
	(533525, 127, '2014-02-15 00:29:25.000000', 'consum', 0.0216, 'lps'),
	(533526, 127, '2014-02-15 00:29:26.000000', 'consum', 0.0215, 'lps'),
	(533527, 127, '2014-02-15 00:29:27.000000', 'consum', 0.0217, 'lps'),
	(533528, 127, '2014-02-15 00:29:28.000000', 'consum', 0.0212, 'lps'),
	(533529, 127, '2014-02-15 00:29:29.000000', 'consum', 0.0217, 'lps'),
	(533530, 127, '2014-02-15 00:29:30.000000', 'consum', 0.0211, 'lps'),
	(533531, 127, '2014-02-15 00:29:31.000000', 'consum', 0.0215, 'lps'),
	(533532, 127, '2014-02-15 00:29:32.000000', 'consum', 0.0212, 'lps'),
	(533533, 127, '2014-02-15 00:29:33.000000', 'consum', 0.0215, 'lps'),
	(533534, 127, '2014-02-15 00:29:34.000000', 'consum', 0.0219, 'lps'),
	(533535, 127, '2014-02-15 00:29:35.000000', 'consum', 0.0213, 'lps'),
	(533536, 127, '2014-02-15 00:29:36.000000', 'consum', 0.0218, 'lps'),
	(533537, 127, '2014-02-15 00:29:37.000000', 'consum', 0.0211, 'lps'),
	(533538, 127, '2014-02-15 00:29:38.000000', 'consum', 0.0212, 'lps'),
	(533539, 127, '2014-02-15 00:29:39.000000', 'consum', 0.0215, 'lps'),
	(533540, 127, '2014-02-15 00:29:40.000000', 'consum', 0.0213, 'lps'),
	(533541, 127, '2014-02-15 00:29:41.000000', 'consum', 0.0219, 'lps'),
	(533542, 127, '2014-02-15 00:29:42.000000', 'consum', 0.0218, 'lps'),
	(533543, 127, '2014-02-15 00:29:43.000000', 'consum', 0.0211, 'lps'),
	(533544, 127, '2014-02-15 00:29:44.000000', 'consum', 0.0213, 'lps'),
	(533545, 127, '2014-02-15 00:29:45.000000', 'consum', 0.0212, 'lps'),
	(533546, 127, '2014-02-15 00:29:46.000000', 'consum', 0.0212, 'lps'),
	(533547, 127, '2014-02-15 00:29:47.000000', 'consum', 0.0216, 'lps'),
	(533548, 127, '2014-02-15 00:29:48.000000', 'consum', 0.0214, 'lps'),
	(533549, 127, '2014-02-15 00:29:49.000000', 'consum', 0.0212, 'lps'),
	(533550, 127, '2014-02-15 00:29:50.000000', 'consum', 0.0218, 'lps'),
	(533551, 127, '2014-02-15 00:29:51.000000', 'consum', 0.0214, 'lps'),
	(533552, 127, '2014-02-15 00:29:52.000000', 'consum', 0.0219, 'lps'),
	(533553, 127, '2014-02-15 00:29:53.000000', 'consum', 0.0210, 'lps'),
	(533554, 127, '2014-02-15 00:29:54.000000', 'consum', 0.0216, 'lps'),
	(533555, 127, '2014-02-15 00:29:55.000000', 'consum', 0.0210, 'lps'),
	(533556, 127, '2014-02-15 00:29:56.000000', 'consum', 0.0214, 'lps'),
	(533557, 127, '2014-02-15 00:29:57.000000', 'consum', 0.0210, 'lps'),
	(533558, 127, '2014-02-15 00:29:58.000000', 'consum', 0.0219, 'lps'),
	(533559, 127, '2014-02-15 00:29:59.000000', 'consum', 0.0215, 'lps'),
	(533560, 127, '2014-02-15 00:30:00.000000', 'consum', 0.0219, 'lps'),
	(533561, 127, '2014-02-15 00:30:01.000000', 'consum', 0.0219, 'lps'),
	(533562, 127, '2014-02-15 00:30:02.000000', 'consum', 0.0210, 'lps'),
	(533563, 127, '2014-02-15 00:30:03.000000', 'consum', 0.0211, 'lps'),
	(533564, 127, '2014-02-15 00:30:04.000000', 'consum', 0.0218, 'lps'),
	(533565, 127, '2014-02-15 00:30:05.000000', 'consum', 0.0219, 'lps'),
	(533566, 127, '2014-02-15 00:30:06.000000', 'consum', 0.0219, 'lps'),
	(533567, 127, '2014-02-15 00:30:07.000000', 'consum', 0.0218, 'lps'),
	(533568, 127, '2014-02-15 00:30:08.000000', 'consum', 0.0215, 'lps'),
	(533569, 127, '2014-02-15 00:30:09.000000', 'consum', 0.0219, 'lps'),
	(533570, 127, '2014-02-15 00:30:10.000000', 'consum', 0.0214, 'lps'),
	(533571, 127, '2014-02-15 00:30:11.000000', 'consum', 0.0212, 'lps'),
	(533572, 127, '2014-02-15 00:30:12.000000', 'consum', 0.0219, 'lps'),
	(533573, 127, '2014-02-15 00:30:13.000000', 'consum', 0.0211, 'lps'),
	(533574, 127, '2014-02-15 00:30:14.000000', 'consum', 0.0217, 'lps'),
	(533575, 127, '2014-02-15 00:30:15.000000', 'consum', 0.0211, 'lps'),
	(533576, 127, '2014-02-15 00:30:16.000000', 'consum', 0.0216, 'lps'),
	(533577, 127, '2014-02-15 00:30:17.000000', 'consum', 0.0217, 'lps'),
	(533578, 127, '2014-02-15 00:30:18.000000', 'consum', 0.0218, 'lps'),
	(533579, 127, '2014-02-15 00:30:19.000000', 'consum', 0.0217, 'lps'),
	(533580, 127, '2014-02-15 00:30:20.000000', 'consum', 0.0214, 'lps'),
	(533581, 127, '2014-02-15 00:30:21.000000', 'consum', 0.0219, 'lps'),
	(533582, 127, '2014-02-15 00:30:22.000000', 'consum', 0.0214, 'lps'),
	(533583, 127, '2014-02-15 00:30:23.000000', 'consum', 0.0214, 'lps'),
	(533584, 127, '2014-02-15 00:30:24.000000', 'consum', 0.0217, 'lps'),
	(533585, 127, '2014-02-15 00:30:25.000000', 'consum', 0.0214, 'lps'),
	(533586, 127, '2014-02-15 00:30:26.000000', 'consum', 0.0219, 'lps'),
	(533587, 127, '2014-02-15 00:30:27.000000', 'consum', 0.0216, 'lps'),
	(533588, 127, '2014-02-15 00:30:28.000000', 'consum', 0.0211, 'lps'),
	(533589, 127, '2014-02-15 00:30:29.000000', 'consum', 0.0219, 'lps'),
	(533590, 127, '2014-02-15 00:30:30.000000', 'consum', 0.0211, 'lps'),
	(533591, 127, '2014-02-15 00:30:31.000000', 'consum', 0.0218, 'lps'),
	(533592, 127, '2014-02-15 00:30:32.000000', 'consum', 0.0210, 'lps'),
	(533593, 127, '2014-02-15 00:30:33.000000', 'consum', 0.0215, 'lps'),
	(533594, 127, '2014-02-15 00:30:34.000000', 'consum', 0.0216, 'lps'),
	(533595, 127, '2014-02-15 00:30:35.000000', 'consum', 0.0214, 'lps'),
	(533596, 127, '2014-02-15 00:30:36.000000', 'consum', 0.0213, 'lps'),
	(533597, 127, '2014-02-15 00:30:37.000000', 'consum', 0.0216, 'lps'),
	(533598, 127, '2014-02-15 00:30:38.000000', 'consum', 0.0218, 'lps'),
	(533599, 127, '2014-02-15 00:30:39.000000', 'consum', 0.0214, 'lps'),
	(533600, 127, '2014-02-15 00:30:40.000000', 'consum', 0.0216, 'lps'),
	(533601, 127, '2014-02-15 00:30:41.000000', 'consum', 0.0219, 'lps'),
	(533602, 127, '2014-02-15 00:30:42.000000', 'consum', 0.0219, 'lps'),
	(533603, 127, '2014-02-15 00:30:43.000000', 'consum', 0.0216, 'lps'),
	(533604, 127, '2014-02-15 00:30:44.000000', 'consum', 0.0214, 'lps'),
	(533605, 127, '2014-02-15 00:30:45.000000', 'consum', 0.0215, 'lps'),
	(533606, 127, '2014-02-15 00:30:46.000000', 'consum', 0.0210, 'lps'),
	(533607, 127, '2014-02-15 00:30:47.000000', 'consum', 0.0217, 'lps'),
	(533608, 127, '2014-02-15 00:30:48.000000', 'consum', 0.0213, 'lps'),
	(533609, 127, '2014-02-15 00:30:49.000000', 'consum', 0.0218, 'lps'),
	(533610, 127, '2014-02-15 00:30:50.000000', 'consum', 0.0210, 'lps'),
	(533611, 127, '2014-02-15 00:30:51.000000', 'consum', 0.0216, 'lps'),
	(533612, 127, '2014-02-15 00:30:52.000000', 'consum', 0.0219, 'lps'),
	(533613, 127, '2014-02-15 00:30:53.000000', 'consum', 0.0210, 'lps'),
	(533614, 127, '2014-02-15 00:30:54.000000', 'consum', 0.0212, 'lps'),
	(533615, 127, '2014-02-15 00:30:55.000000', 'consum', 0.0212, 'lps'),
	(533616, 127, '2014-02-15 00:30:56.000000', 'consum', 0.0214, 'lps'),
	(533617, 127, '2014-02-15 00:30:57.000000', 'consum', 0.0213, 'lps'),
	(533618, 127, '2014-02-15 00:30:58.000000', 'consum', 0.0213, 'lps'),
	(533619, 127, '2014-02-15 00:30:59.000000', 'consum', 0.0216, 'lps'),
	(533620, 127, '2014-02-15 00:31:00.000000', 'consum', 0.0213, 'lps'),
	(533621, 127, '2014-02-15 00:31:01.000000', 'consum', 0.0219, 'lps'),
	(533622, 127, '2014-02-15 00:31:02.000000', 'consum', 0.0213, 'lps'),
	(533623, 127, '2014-02-15 00:31:03.000000', 'consum', 0.0210, 'lps'),
	(533624, 127, '2014-02-15 00:31:04.000000', 'consum', 0.0214, 'lps'),
	(533625, 127, '2014-02-15 00:31:05.000000', 'consum', 0.0217, 'lps'),
	(533626, 127, '2014-02-15 00:31:06.000000', 'consum', 0.0216, 'lps'),
	(533627, 127, '2014-02-15 00:31:07.000000', 'consum', 0.0217, 'lps'),
	(533628, 127, '2014-02-15 00:31:08.000000', 'consum', 0.0219, 'lps'),
	(533629, 127, '2014-02-15 00:31:09.000000', 'consum', 0.0213, 'lps'),
	(533630, 127, '2014-02-15 00:31:10.000000', 'consum', 0.0218, 'lps'),
	(533631, 127, '2014-02-15 00:31:11.000000', 'consum', 0.0214, 'lps'),
	(533632, 127, '2014-02-15 00:31:12.000000', 'consum', 0.0217, 'lps'),
	(533633, 127, '2014-02-15 00:31:13.000000', 'consum', 0.0212, 'lps'),
	(533634, 127, '2014-02-15 00:31:14.000000', 'consum', 0.0211, 'lps'),
	(533635, 127, '2014-02-15 00:31:15.000000', 'consum', 0.0210, 'lps'),
	(533636, 127, '2014-02-15 00:31:16.000000', 'consum', 0.0218, 'lps'),
	(533637, 127, '2014-02-15 00:31:17.000000', 'consum', 0.0217, 'lps'),
	(533638, 127, '2014-02-15 00:31:18.000000', 'consum', 0.0215, 'lps'),
	(533639, 127, '2014-02-15 00:31:19.000000', 'consum', 0.0213, 'lps'),
	(533640, 127, '2014-02-15 00:31:20.000000', 'consum', 0.0210, 'lps'),
	(533641, 127, '2014-02-15 00:31:21.000000', 'consum', 0.0214, 'lps'),
	(533642, 127, '2014-02-15 00:31:22.000000', 'consum', 0.0218, 'lps'),
	(533643, 127, '2014-02-15 00:31:23.000000', 'consum', 0.0219, 'lps'),
	(533644, 127, '2014-02-15 00:31:24.000000', 'consum', 0.0213, 'lps'),
	(533645, 127, '2014-02-15 00:31:25.000000', 'consum', 0.0217, 'lps'),
	(533646, 127, '2014-02-15 00:31:26.000000', 'consum', 0.0217, 'lps'),
	(533647, 127, '2014-02-15 00:31:27.000000', 'consum', 0.0216, 'lps'),
	(533648, 127, '2014-02-15 00:31:28.000000', 'consum', 0.0210, 'lps'),
	(533649, 127, '2014-02-15 00:31:29.000000', 'consum', 0.0211, 'lps'),
	(533650, 127, '2014-02-15 00:31:30.000000', 'consum', 0.0216, 'lps'),
	(533651, 127, '2014-02-15 00:31:31.000000', 'consum', 0.0218, 'lps'),
	(533652, 127, '2014-02-15 00:31:32.000000', 'consum', 0.0211, 'lps'),
	(533653, 127, '2014-02-15 00:31:33.000000', 'consum', 0.0212, 'lps'),
	(533654, 127, '2014-02-15 00:31:34.000000', 'consum', 0.0216, 'lps'),
	(533655, 127, '2014-02-15 00:31:35.000000', 'consum', 0.0214, 'lps'),
	(533656, 127, '2014-02-15 00:31:36.000000', 'consum', 0.0214, 'lps'),
	(533657, 127, '2014-02-15 00:31:37.000000', 'consum', 0.0218, 'lps'),
	(533658, 127, '2014-02-15 00:31:38.000000', 'consum', 0.0218, 'lps'),
	(533659, 127, '2014-02-15 00:31:39.000000', 'consum', 0.0217, 'lps'),
	(533660, 127, '2014-02-15 00:31:40.000000', 'consum', 0.0211, 'lps'),
	(533661, 127, '2014-02-15 00:31:41.000000', 'consum', 0.0215, 'lps'),
	(533662, 127, '2014-02-15 00:31:42.000000', 'consum', 0.0210, 'lps'),
	(533663, 127, '2014-02-15 00:31:43.000000', 'consum', 0.0219, 'lps'),
	(533664, 127, '2014-02-15 00:31:44.000000', 'consum', 0.0215, 'lps'),
	(533665, 127, '2014-02-15 00:31:45.000000', 'consum', 0.0219, 'lps'),
	(533666, 127, '2014-02-15 00:31:46.000000', 'consum', 0.0219, 'lps'),
	(533667, 127, '2014-02-15 00:31:47.000000', 'consum', 0.0219, 'lps'),
	(533668, 127, '2014-02-15 00:31:48.000000', 'consum', 0.0217, 'lps'),
	(533669, 127, '2014-02-15 00:31:49.000000', 'consum', 0.0211, 'lps'),
	(533670, 127, '2014-02-15 00:31:50.000000', 'consum', 0.0213, 'lps'),
	(533671, 127, '2014-02-15 00:31:51.000000', 'consum', 0.0212, 'lps'),
	(533672, 127, '2014-02-15 00:31:52.000000', 'consum', 0.0213, 'lps'),
	(533673, 127, '2014-02-15 00:31:53.000000', 'consum', 0.0218, 'lps'),
	(533674, 127, '2014-02-15 00:31:54.000000', 'consum', 0.0210, 'lps'),
	(533675, 127, '2014-02-15 00:31:55.000000', 'consum', 0.0210, 'lps'),
	(533676, 127, '2014-02-15 00:31:56.000000', 'consum', 0.0218, 'lps'),
	(533677, 127, '2014-02-15 00:31:57.000000', 'consum', 0.0210, 'lps'),
	(533678, 127, '2014-02-15 00:31:58.000000', 'consum', 0.0218, 'lps'),
	(533679, 127, '2014-02-15 00:31:59.000000', 'consum', 0.0219, 'lps'),
	(533680, 127, '2014-02-15 00:32:00.000000', 'consum', 0.0214, 'lps'),
	(533681, 127, '2014-02-15 00:32:01.000000', 'consum', 0.0213, 'lps'),
	(533682, 127, '2014-02-15 00:32:02.000000', 'consum', 0.0213, 'lps'),
	(533683, 127, '2014-02-15 00:32:03.000000', 'consum', 0.0217, 'lps'),
	(533684, 127, '2014-02-15 00:32:04.000000', 'consum', 0.0218, 'lps'),
	(533685, 127, '2014-02-15 00:32:05.000000', 'consum', 0.0219, 'lps'),
	(533686, 127, '2014-02-15 00:32:06.000000', 'consum', 0.0211, 'lps'),
	(533687, 127, '2014-02-15 00:32:07.000000', 'consum', 0.0216, 'lps'),
	(533688, 127, '2014-02-15 00:32:08.000000', 'consum', 0.0211, 'lps'),
	(533689, 127, '2014-02-15 00:32:09.000000', 'consum', 0.0217, 'lps'),
	(533690, 127, '2014-02-15 00:32:10.000000', 'consum', 0.0213, 'lps'),
	(533691, 127, '2014-02-15 00:32:11.000000', 'consum', 0.0214, 'lps'),
	(533692, 127, '2014-02-15 00:32:12.000000', 'consum', 0.0211, 'lps'),
	(533693, 127, '2014-02-15 00:32:13.000000', 'consum', 0.0213, 'lps'),
	(533694, 127, '2014-02-15 00:32:14.000000', 'consum', 0.0214, 'lps'),
	(533695, 127, '2014-02-15 00:32:15.000000', 'consum', 0.0211, 'lps'),
	(533696, 127, '2014-02-15 00:32:16.000000', 'consum', 0.0214, 'lps'),
	(533697, 127, '2014-02-15 00:32:17.000000', 'consum', 0.0216, 'lps'),
	(533698, 127, '2014-02-15 00:32:18.000000', 'consum', 0.0219, 'lps'),
	(533699, 127, '2014-02-15 00:32:19.000000', 'consum', 0.0216, 'lps'),
	(533700, 127, '2014-02-15 00:32:20.000000', 'consum', 0.0214, 'lps'),
	(533701, 127, '2014-02-15 00:32:21.000000', 'consum', 0.0213, 'lps'),
	(533702, 127, '2014-02-15 00:32:22.000000', 'consum', 0.0212, 'lps'),
	(533703, 127, '2014-02-15 00:32:23.000000', 'consum', 0.0211, 'lps'),
	(533704, 127, '2014-02-15 00:32:24.000000', 'consum', 0.0219, 'lps'),
	(533705, 127, '2014-02-15 00:32:25.000000', 'consum', 0.0215, 'lps'),
	(533706, 127, '2014-02-15 00:32:26.000000', 'consum', 0.0219, 'lps'),
	(533707, 127, '2014-02-15 00:32:27.000000', 'consum', 0.0211, 'lps'),
	(533708, 127, '2014-02-15 00:32:28.000000', 'consum', 0.0210, 'lps'),
	(533709, 127, '2014-02-15 00:32:29.000000', 'consum', 0.0214, 'lps'),
	(533710, 127, '2014-02-15 00:32:30.000000', 'consum', 0.0210, 'lps'),
	(533711, 127, '2014-02-15 00:32:31.000000', 'consum', 0.0212, 'lps'),
	(533712, 127, '2014-02-15 00:32:32.000000', 'consum', 0.0218, 'lps'),
	(533713, 127, '2014-02-15 00:32:33.000000', 'consum', 0.0215, 'lps'),
	(533714, 127, '2014-02-15 00:32:34.000000', 'consum', 0.0210, 'lps'),
	(533715, 127, '2014-02-15 00:32:35.000000', 'consum', 0.0216, 'lps'),
	(533716, 127, '2014-02-15 00:32:36.000000', 'consum', 0.0213, 'lps'),
	(533717, 127, '2014-02-15 00:32:37.000000', 'consum', 0.0216, 'lps'),
	(533718, 127, '2014-02-15 00:32:38.000000', 'consum', 0.0210, 'lps'),
	(533719, 127, '2014-02-15 00:32:39.000000', 'consum', 0.0213, 'lps'),
	(533720, 127, '2014-02-15 00:32:40.000000', 'consum', 0.0217, 'lps'),
	(533721, 127, '2014-02-15 00:32:41.000000', 'consum', 0.0215, 'lps'),
	(533722, 127, '2014-02-15 00:32:42.000000', 'consum', 0.0215, 'lps'),
	(533723, 127, '2014-02-15 00:32:43.000000', 'consum', 0.0219, 'lps'),
	(533724, 127, '2014-02-15 00:32:44.000000', 'consum', 0.0214, 'lps'),
	(533725, 127, '2014-02-15 00:32:45.000000', 'consum', 0.0210, 'lps'),
	(533726, 127, '2014-02-15 00:32:46.000000', 'consum', 0.0211, 'lps'),
	(533727, 127, '2014-02-15 00:32:47.000000', 'consum', 0.0213, 'lps'),
	(533728, 127, '2014-02-15 00:32:48.000000', 'consum', 0.0212, 'lps'),
	(533729, 127, '2014-02-15 00:32:49.000000', 'consum', 0.0211, 'lps'),
	(533730, 127, '2014-02-15 00:32:50.000000', 'consum', 0.0219, 'lps'),
	(533731, 127, '2014-02-15 00:32:51.000000', 'consum', 0.0214, 'lps'),
	(533732, 127, '2014-02-15 00:32:52.000000', 'consum', 0.0215, 'lps'),
	(533733, 127, '2014-02-15 00:32:53.000000', 'consum', 0.0214, 'lps'),
	(533734, 127, '2014-02-15 00:32:54.000000', 'consum', 0.0213, 'lps'),
	(533735, 127, '2014-02-15 00:32:55.000000', 'consum', 0.0214, 'lps'),
	(533736, 127, '2014-02-15 00:32:56.000000', 'consum', 0.0211, 'lps'),
	(533737, 127, '2014-02-15 00:32:57.000000', 'consum', 0.0213, 'lps'),
	(533738, 127, '2014-02-15 00:32:58.000000', 'consum', 0.0215, 'lps'),
	(533739, 127, '2014-02-15 00:32:59.000000', 'consum', 0.0217, 'lps'),
	(533740, 127, '2014-02-15 00:33:00.000000', 'consum', 0.0217, 'lps'),
	(533741, 127, '2014-02-15 00:33:01.000000', 'consum', 0.0218, 'lps'),
	(533742, 127, '2014-02-15 00:33:02.000000', 'consum', 0.0216, 'lps'),
	(533743, 127, '2014-02-15 00:33:03.000000', 'consum', 0.0219, 'lps'),
	(533744, 127, '2014-02-15 00:33:04.000000', 'consum', 0.0219, 'lps'),
	(533745, 127, '2014-02-15 00:33:05.000000', 'consum', 0.0216, 'lps'),
	(533746, 127, '2014-02-15 00:33:06.000000', 'consum', 0.0213, 'lps'),
	(533747, 127, '2014-02-15 00:33:07.000000', 'consum', 0.0219, 'lps'),
	(533748, 127, '2014-02-15 00:33:08.000000', 'consum', 0.0215, 'lps'),
	(533749, 127, '2014-02-15 00:33:09.000000', 'consum', 0.0211, 'lps'),
	(533750, 127, '2014-02-15 00:33:10.000000', 'consum', 0.0219, 'lps'),
	(533751, 127, '2014-02-15 00:33:11.000000', 'consum', 0.0214, 'lps'),
	(533752, 127, '2014-02-15 00:33:12.000000', 'consum', 0.0213, 'lps'),
	(533753, 127, '2014-02-15 00:33:13.000000', 'consum', 0.0214, 'lps'),
	(533754, 127, '2014-02-15 00:33:14.000000', 'consum', 0.0211, 'lps'),
	(533755, 127, '2014-02-15 00:33:15.000000', 'consum', 0.0214, 'lps'),
	(533756, 127, '2014-02-15 00:33:16.000000', 'consum', 0.0215, 'lps'),
	(533757, 127, '2014-02-15 00:33:17.000000', 'consum', 0.0215, 'lps'),
	(533758, 127, '2014-02-15 00:33:18.000000', 'consum', 0.0211, 'lps'),
	(533759, 127, '2014-02-15 00:33:19.000000', 'consum', 0.0210, 'lps'),
	(533760, 127, '2014-02-15 00:33:20.000000', 'consum', 0.0219, 'lps'),
	(533761, 127, '2014-02-15 00:33:21.000000', 'consum', 0.0215, 'lps'),
	(533762, 127, '2014-02-15 00:33:22.000000', 'consum', 0.0219, 'lps'),
	(533763, 127, '2014-02-15 00:33:23.000000', 'consum', 0.0218, 'lps'),
	(533764, 127, '2014-02-15 00:33:24.000000', 'consum', 0.0215, 'lps'),
	(533765, 127, '2014-02-15 00:33:25.000000', 'consum', 0.0211, 'lps'),
	(533766, 127, '2014-02-15 00:33:26.000000', 'consum', 0.0219, 'lps'),
	(533767, 127, '2014-02-15 00:33:27.000000', 'consum', 0.0214, 'lps'),
	(533768, 127, '2014-02-15 00:33:28.000000', 'consum', 0.0213, 'lps'),
	(533769, 127, '2014-02-15 00:33:29.000000', 'consum', 0.0213, 'lps'),
	(533770, 127, '2014-02-15 00:33:30.000000', 'consum', 0.0215, 'lps'),
	(533771, 127, '2014-02-15 00:33:31.000000', 'consum', 0.0218, 'lps'),
	(533772, 127, '2014-02-15 00:33:32.000000', 'consum', 0.0214, 'lps'),
	(533773, 127, '2014-02-15 00:33:33.000000', 'consum', 0.0218, 'lps'),
	(533774, 127, '2014-02-15 00:33:34.000000', 'consum', 0.0218, 'lps'),
	(533775, 127, '2014-02-15 00:33:35.000000', 'consum', 0.0215, 'lps'),
	(533776, 127, '2014-02-15 00:33:36.000000', 'consum', 0.0214, 'lps'),
	(533777, 127, '2014-02-15 00:33:37.000000', 'consum', 0.0216, 'lps'),
	(533778, 127, '2014-02-15 00:33:38.000000', 'consum', 0.0215, 'lps'),
	(533779, 127, '2014-02-15 00:33:39.000000', 'consum', 0.0211, 'lps'),
	(533780, 127, '2014-02-15 00:33:40.000000', 'consum', 0.0210, 'lps'),
	(533781, 127, '2014-02-15 00:33:41.000000', 'consum', 0.0217, 'lps'),
	(533782, 127, '2014-02-15 00:33:42.000000', 'consum', 0.0215, 'lps'),
	(533783, 127, '2014-02-15 00:33:43.000000', 'consum', 0.0215, 'lps'),
	(533784, 127, '2014-02-15 00:33:44.000000', 'consum', 0.0210, 'lps'),
	(533785, 127, '2014-02-15 00:33:45.000000', 'consum', 0.0218, 'lps'),
	(533786, 127, '2014-02-15 00:33:46.000000', 'consum', 0.0217, 'lps'),
	(533787, 127, '2014-02-15 00:33:47.000000', 'consum', 0.0213, 'lps'),
	(533788, 127, '2014-02-15 00:33:48.000000', 'consum', 0.0212, 'lps'),
	(533789, 127, '2014-02-15 00:33:49.000000', 'consum', 0.0215, 'lps'),
	(533790, 127, '2014-02-15 00:33:50.000000', 'consum', 0.0219, 'lps'),
	(533791, 127, '2014-02-15 00:33:51.000000', 'consum', 0.0210, 'lps'),
	(533792, 127, '2014-02-15 00:33:52.000000', 'consum', 0.0214, 'lps'),
	(533793, 127, '2014-02-15 00:33:53.000000', 'consum', 0.0219, 'lps'),
	(533794, 127, '2014-02-15 00:33:54.000000', 'consum', 0.0214, 'lps'),
	(533795, 127, '2014-02-15 00:33:55.000000', 'consum', 0.0213, 'lps'),
	(533796, 127, '2014-02-15 00:33:56.000000', 'consum', 0.0212, 'lps'),
	(533797, 127, '2014-02-15 00:33:57.000000', 'consum', 0.0214, 'lps'),
	(533798, 127, '2014-02-15 00:33:58.000000', 'consum', 0.0212, 'lps'),
	(533799, 127, '2014-02-15 00:33:59.000000', 'consum', 0.0211, 'lps'),
	(533800, 127, '2014-02-15 00:34:00.000000', 'consum', 0.0218, 'lps'),
	(533801, 127, '2014-02-15 00:34:01.000000', 'consum', 0.0219, 'lps'),
	(533802, 127, '2014-02-15 00:34:02.000000', 'consum', 0.0213, 'lps'),
	(533803, 127, '2014-02-15 00:34:03.000000', 'consum', 0.0215, 'lps'),
	(533804, 127, '2014-02-15 00:34:04.000000', 'consum', 0.0210, 'lps'),
	(533805, 127, '2014-02-15 00:34:05.000000', 'consum', 0.0212, 'lps'),
	(533806, 127, '2014-02-15 00:34:06.000000', 'consum', 0.0213, 'lps'),
	(533807, 127, '2014-02-15 00:34:07.000000', 'consum', 0.0219, 'lps'),
	(533808, 127, '2014-02-15 00:34:08.000000', 'consum', 0.0218, 'lps'),
	(533809, 127, '2014-02-15 00:34:09.000000', 'consum', 0.0210, 'lps'),
	(533810, 127, '2014-02-15 00:34:10.000000', 'consum', 0.0210, 'lps'),
	(533811, 127, '2014-02-15 00:34:11.000000', 'consum', 0.0218, 'lps'),
	(533812, 127, '2014-02-15 00:34:12.000000', 'consum', 0.0212, 'lps'),
	(533813, 127, '2014-02-15 00:34:13.000000', 'consum', 0.0215, 'lps'),
	(533814, 127, '2014-02-15 00:34:14.000000', 'consum', 0.0211, 'lps'),
	(533815, 127, '2014-02-15 00:34:15.000000', 'consum', 0.0219, 'lps'),
	(533816, 127, '2014-02-15 00:34:16.000000', 'consum', 0.0214, 'lps'),
	(533817, 127, '2014-02-15 00:34:17.000000', 'consum', 0.0214, 'lps'),
	(533818, 127, '2014-02-15 00:34:18.000000', 'consum', 0.0219, 'lps'),
	(533819, 127, '2014-02-15 00:34:19.000000', 'consum', 0.0212, 'lps'),
	(533820, 127, '2014-02-15 00:34:20.000000', 'consum', 0.0215, 'lps'),
	(533821, 127, '2014-02-15 00:34:21.000000', 'consum', 0.0218, 'lps'),
	(533822, 127, '2014-02-15 00:34:22.000000', 'consum', 0.0217, 'lps'),
	(533823, 127, '2014-02-15 00:34:23.000000', 'consum', 0.0210, 'lps'),
	(533824, 127, '2014-02-15 00:34:24.000000', 'consum', 0.0210, 'lps'),
	(533825, 127, '2014-02-15 00:34:25.000000', 'consum', 0.0211, 'lps'),
	(533826, 127, '2014-02-15 00:34:26.000000', 'consum', 0.0215, 'lps'),
	(533827, 127, '2014-02-15 00:34:27.000000', 'consum', 0.0211, 'lps'),
	(533828, 127, '2014-02-15 00:34:28.000000', 'consum', 0.0214, 'lps'),
	(533829, 127, '2014-02-15 00:34:29.000000', 'consum', 0.0215, 'lps'),
	(533830, 127, '2014-02-15 00:34:30.000000', 'consum', 0.0212, 'lps'),
	(533831, 127, '2014-02-15 00:34:31.000000', 'consum', 0.0217, 'lps'),
	(533832, 127, '2014-02-15 00:34:32.000000', 'consum', 0.0210, 'lps'),
	(533833, 127, '2014-02-15 00:34:33.000000', 'consum', 0.0218, 'lps'),
	(533834, 127, '2014-02-15 00:34:34.000000', 'consum', 0.0212, 'lps'),
	(533835, 127, '2014-02-15 00:34:35.000000', 'consum', 0.0216, 'lps'),
	(533836, 127, '2014-02-15 00:34:36.000000', 'consum', 0.0212, 'lps'),
	(533837, 127, '2014-02-15 00:34:37.000000', 'consum', 0.0216, 'lps'),
	(533838, 127, '2014-02-15 00:34:38.000000', 'consum', 0.0213, 'lps'),
	(533839, 127, '2014-02-15 00:34:39.000000', 'consum', 0.0218, 'lps'),
	(533840, 127, '2014-02-15 00:34:40.000000', 'consum', 0.0210, 'lps'),
	(533841, 127, '2014-02-15 00:34:41.000000', 'consum', 0.0218, 'lps'),
	(533842, 127, '2014-02-15 00:34:42.000000', 'consum', 0.0211, 'lps'),
	(533843, 127, '2014-02-15 00:34:43.000000', 'consum', 0.0210, 'lps'),
	(533844, 127, '2014-02-15 00:34:44.000000', 'consum', 0.0219, 'lps'),
	(533845, 127, '2014-02-15 00:34:45.000000', 'consum', 0.0214, 'lps'),
	(533846, 127, '2014-02-15 00:34:46.000000', 'consum', 0.0216, 'lps'),
	(533847, 127, '2014-02-15 00:34:47.000000', 'consum', 0.0215, 'lps'),
	(533848, 127, '2014-02-15 00:34:48.000000', 'consum', 0.0219, 'lps'),
	(533849, 127, '2014-02-15 00:34:49.000000', 'consum', 0.0211, 'lps'),
	(533850, 127, '2014-02-15 00:34:50.000000', 'consum', 0.0219, 'lps'),
	(533851, 127, '2014-02-15 00:34:51.000000', 'consum', 0.0213, 'lps'),
	(533852, 127, '2014-02-15 00:34:52.000000', 'consum', 0.0218, 'lps'),
	(533853, 127, '2014-02-15 00:34:53.000000', 'consum', 0.0211, 'lps'),
	(533854, 127, '2014-02-15 00:34:54.000000', 'consum', 0.0213, 'lps'),
	(533855, 127, '2014-02-15 00:34:55.000000', 'consum', 0.0210, 'lps'),
	(533856, 127, '2014-02-15 00:34:56.000000', 'consum', 0.0215, 'lps'),
	(533857, 127, '2014-02-15 00:34:57.000000', 'consum', 0.0212, 'lps'),
	(533858, 127, '2014-02-15 00:34:58.000000', 'consum', 0.0219, 'lps'),
	(533859, 127, '2014-02-15 00:34:59.000000', 'consum', 0.0216, 'lps'),
	(533860, 127, '2014-02-15 00:35:00.000000', 'consum', 0.0215, 'lps'),
	(533861, 127, '2014-02-15 00:35:01.000000', 'consum', 0.0219, 'lps'),
	(533862, 127, '2014-02-15 00:35:02.000000', 'consum', 0.0211, 'lps'),
	(533863, 127, '2014-02-15 00:35:03.000000', 'consum', 0.0216, 'lps'),
	(533864, 127, '2014-02-15 00:35:04.000000', 'consum', 0.0219, 'lps'),
	(533865, 127, '2014-02-15 00:35:05.000000', 'consum', 0.0216, 'lps'),
	(533866, 127, '2014-02-15 00:35:06.000000', 'consum', 0.0216, 'lps'),
	(533867, 127, '2014-02-15 00:35:07.000000', 'consum', 0.0212, 'lps'),
	(533868, 127, '2014-02-15 00:35:08.000000', 'consum', 0.0210, 'lps'),
	(533869, 127, '2014-02-15 00:35:09.000000', 'consum', 0.0217, 'lps'),
	(533870, 127, '2014-02-15 00:35:10.000000', 'consum', 0.0214, 'lps'),
	(533871, 127, '2014-02-15 00:35:11.000000', 'consum', 0.0212, 'lps'),
	(533872, 127, '2014-02-15 00:35:12.000000', 'consum', 0.0216, 'lps'),
	(533873, 127, '2014-02-15 00:35:13.000000', 'consum', 0.0216, 'lps'),
	(533874, 127, '2014-02-15 00:35:14.000000', 'consum', 0.0212, 'lps'),
	(533875, 127, '2014-02-15 00:35:15.000000', 'consum', 0.0211, 'lps'),
	(533876, 127, '2014-02-15 00:35:16.000000', 'consum', 0.0211, 'lps'),
	(533877, 127, '2014-02-15 00:35:17.000000', 'consum', 0.0214, 'lps'),
	(533878, 127, '2014-02-15 00:35:18.000000', 'consum', 0.0218, 'lps'),
	(533879, 127, '2014-02-15 00:35:19.000000', 'consum', 0.0215, 'lps'),
	(533880, 127, '2014-02-15 00:35:20.000000', 'consum', 0.0214, 'lps'),
	(533881, 127, '2014-02-15 00:35:21.000000', 'consum', 0.0213, 'lps'),
	(533882, 127, '2014-02-15 00:35:22.000000', 'consum', 0.0216, 'lps'),
	(533883, 127, '2014-02-15 00:35:23.000000', 'consum', 0.0219, 'lps'),
	(533884, 127, '2014-02-15 00:35:24.000000', 'consum', 0.0218, 'lps'),
	(533885, 127, '2014-02-15 00:35:25.000000', 'consum', 0.0214, 'lps'),
	(533886, 127, '2014-02-15 00:35:26.000000', 'consum', 0.0215, 'lps'),
	(533887, 127, '2014-02-15 00:35:27.000000', 'consum', 0.0216, 'lps'),
	(533888, 127, '2014-02-15 00:35:28.000000', 'consum', 0.0214, 'lps'),
	(533889, 127, '2014-02-15 00:35:29.000000', 'consum', 0.0212, 'lps'),
	(533890, 127, '2014-02-15 00:35:30.000000', 'consum', 0.0219, 'lps'),
	(533891, 127, '2014-02-15 00:35:31.000000', 'consum', 0.0211, 'lps'),
	(533892, 127, '2014-02-15 00:35:32.000000', 'consum', 0.0217, 'lps'),
	(533893, 127, '2014-02-15 00:35:33.000000', 'consum', 0.0213, 'lps'),
	(533894, 127, '2014-02-15 00:35:34.000000', 'consum', 0.0215, 'lps'),
	(533895, 127, '2014-02-15 00:35:35.000000', 'consum', 0.0216, 'lps'),
	(533896, 127, '2014-02-15 00:35:36.000000', 'consum', 0.0214, 'lps'),
	(533897, 127, '2014-02-15 00:35:37.000000', 'consum', 0.0212, 'lps'),
	(533898, 127, '2014-02-15 00:35:38.000000', 'consum', 0.0210, 'lps'),
	(533899, 127, '2014-02-15 00:35:39.000000', 'consum', 0.0213, 'lps'),
	(533900, 127, '2014-02-15 00:35:40.000000', 'consum', 0.0216, 'lps'),
	(533901, 127, '2014-02-15 00:35:41.000000', 'consum', 0.0214, 'lps'),
	(533902, 127, '2014-02-15 00:35:42.000000', 'consum', 0.0210, 'lps'),
	(533903, 127, '2014-02-15 00:35:43.000000', 'consum', 0.0219, 'lps'),
	(533904, 127, '2014-02-15 00:35:44.000000', 'consum', 0.0215, 'lps'),
	(533905, 127, '2014-02-15 00:35:45.000000', 'consum', 0.0219, 'lps'),
	(533906, 127, '2014-02-15 00:35:46.000000', 'consum', 0.0210, 'lps'),
	(533907, 127, '2014-02-15 00:35:47.000000', 'consum', 0.0214, 'lps'),
	(533908, 127, '2014-02-15 00:35:48.000000', 'consum', 0.0219, 'lps'),
	(533909, 127, '2014-02-15 00:35:49.000000', 'consum', 0.0215, 'lps'),
	(533910, 127, '2014-02-15 00:35:50.000000', 'consum', 0.0210, 'lps'),
	(533911, 127, '2014-02-15 00:35:51.000000', 'consum', 0.0212, 'lps'),
	(533912, 127, '2014-02-15 00:35:52.000000', 'consum', 0.0212, 'lps'),
	(533913, 127, '2014-02-15 00:35:53.000000', 'consum', 0.0216, 'lps'),
	(533914, 127, '2014-02-15 00:35:54.000000', 'consum', 0.0212, 'lps'),
	(533915, 127, '2014-02-15 00:35:55.000000', 'consum', 0.0214, 'lps'),
	(533916, 127, '2014-02-15 00:35:56.000000', 'consum', 0.0216, 'lps'),
	(533917, 127, '2014-02-15 00:35:57.000000', 'consum', 0.0217, 'lps'),
	(533918, 127, '2014-02-15 00:35:58.000000', 'consum', 0.0218, 'lps'),
	(533919, 127, '2014-02-15 00:35:59.000000', 'consum', 0.0219, 'lps'),
	(533920, 127, '2014-02-15 00:36:00.000000', 'consum', 0.0212, 'lps'),
	(533921, 127, '2014-02-15 00:36:01.000000', 'consum', 0.0212, 'lps'),
	(533922, 127, '2014-02-15 00:36:02.000000', 'consum', 0.0213, 'lps'),
	(533923, 127, '2014-02-15 00:36:03.000000', 'consum', 0.0212, 'lps'),
	(533924, 127, '2014-02-15 00:36:04.000000', 'consum', 0.0213, 'lps'),
	(533925, 127, '2014-02-15 00:36:05.000000', 'consum', 0.0217, 'lps'),
	(533926, 127, '2014-02-15 00:36:06.000000', 'consum', 0.0216, 'lps'),
	(533927, 127, '2014-02-15 00:36:07.000000', 'consum', 0.0211, 'lps'),
	(533928, 127, '2014-02-15 00:36:08.000000', 'consum', 0.0217, 'lps'),
	(533929, 127, '2014-02-15 00:36:09.000000', 'consum', 0.0214, 'lps'),
	(533930, 127, '2014-02-15 00:36:10.000000', 'consum', 0.0210, 'lps'),
	(533931, 127, '2014-02-15 00:36:11.000000', 'consum', 0.0219, 'lps'),
	(533932, 127, '2014-02-15 00:36:12.000000', 'consum', 0.0214, 'lps'),
	(533933, 127, '2014-02-15 00:36:13.000000', 'consum', 0.0212, 'lps'),
	(533934, 127, '2014-02-15 00:36:14.000000', 'consum', 0.0210, 'lps'),
	(533935, 127, '2014-02-15 00:36:15.000000', 'consum', 0.0216, 'lps'),
	(533936, 127, '2014-02-15 00:36:16.000000', 'consum', 0.0219, 'lps'),
	(533937, 127, '2014-02-15 00:36:17.000000', 'consum', 0.0219, 'lps'),
	(533938, 127, '2014-02-15 00:36:18.000000', 'consum', 0.0216, 'lps'),
	(533939, 127, '2014-02-15 00:36:19.000000', 'consum', 0.0215, 'lps'),
	(533940, 127, '2014-02-15 00:36:20.000000', 'consum', 0.0219, 'lps'),
	(533941, 127, '2014-02-15 00:36:21.000000', 'consum', 0.0218, 'lps'),
	(533942, 127, '2014-02-15 00:36:22.000000', 'consum', 0.0214, 'lps'),
	(533943, 127, '2014-02-15 00:36:23.000000', 'consum', 0.0216, 'lps'),
	(533944, 127, '2014-02-15 00:36:24.000000', 'consum', 0.0217, 'lps'),
	(533945, 127, '2014-02-15 00:36:25.000000', 'consum', 0.0219, 'lps'),
	(533946, 127, '2014-02-15 00:36:26.000000', 'consum', 0.0216, 'lps'),
	(533947, 127, '2014-02-15 00:36:27.000000', 'consum', 0.0214, 'lps'),
	(533948, 127, '2014-02-15 00:36:28.000000', 'consum', 0.0213, 'lps'),
	(533949, 127, '2014-02-15 00:36:29.000000', 'consum', 0.0213, 'lps'),
	(533950, 127, '2014-02-15 00:36:30.000000', 'consum', 0.0216, 'lps'),
	(533951, 127, '2014-02-15 00:36:31.000000', 'consum', 0.0214, 'lps'),
	(533952, 127, '2014-02-15 00:36:32.000000', 'consum', 0.0219, 'lps'),
	(533953, 127, '2014-02-15 00:36:33.000000', 'consum', 0.0214, 'lps'),
	(533954, 127, '2014-02-15 00:36:34.000000', 'consum', 0.0213, 'lps'),
	(533955, 127, '2014-02-15 00:36:35.000000', 'consum', 0.0216, 'lps'),
	(533956, 127, '2014-02-15 00:36:36.000000', 'consum', 0.0211, 'lps'),
	(533957, 127, '2014-02-15 00:36:37.000000', 'consum', 0.0219, 'lps'),
	(533958, 127, '2014-02-15 00:36:38.000000', 'consum', 0.0210, 'lps'),
	(533959, 127, '2014-02-15 00:36:39.000000', 'consum', 0.0215, 'lps'),
	(533960, 127, '2014-02-15 00:36:40.000000', 'consum', 0.0213, 'lps'),
	(533961, 127, '2014-02-15 00:36:41.000000', 'consum', 0.0213, 'lps'),
	(533962, 127, '2014-02-15 00:36:42.000000', 'consum', 0.0217, 'lps'),
	(533963, 127, '2014-02-15 00:36:43.000000', 'consum', 0.0217, 'lps'),
	(533964, 127, '2014-02-15 00:36:44.000000', 'consum', 0.0214, 'lps'),
	(533965, 127, '2014-02-15 00:36:45.000000', 'consum', 0.0219, 'lps'),
	(533966, 127, '2014-02-15 00:36:46.000000', 'consum', 0.0212, 'lps'),
	(533967, 127, '2014-02-15 00:36:47.000000', 'consum', 0.0213, 'lps'),
	(533968, 127, '2014-02-15 00:36:48.000000', 'consum', 0.0210, 'lps'),
	(533969, 127, '2014-02-15 00:36:49.000000', 'consum', 0.0211, 'lps'),
	(533970, 127, '2014-02-15 00:36:50.000000', 'consum', 0.0216, 'lps'),
	(533971, 127, '2014-02-15 00:36:51.000000', 'consum', 0.0217, 'lps'),
	(533972, 127, '2014-02-15 00:36:52.000000', 'consum', 0.0217, 'lps'),
	(533973, 127, '2014-02-15 00:36:53.000000', 'consum', 0.0215, 'lps'),
	(533974, 127, '2014-02-15 00:36:54.000000', 'consum', 0.0215, 'lps'),
	(533975, 127, '2014-02-15 00:36:55.000000', 'consum', 0.0219, 'lps'),
	(533976, 127, '2014-02-15 00:36:56.000000', 'consum', 0.0213, 'lps'),
	(533977, 127, '2014-02-15 00:36:57.000000', 'consum', 0.0217, 'lps'),
	(533978, 127, '2014-02-15 00:36:58.000000', 'consum', 0.0216, 'lps'),
	(533979, 127, '2014-02-15 00:36:59.000000', 'consum', 0.0218, 'lps'),
	(533980, 127, '2014-02-15 00:37:00.000000', 'consum', 0.0215, 'lps'),
	(533981, 127, '2014-02-15 00:37:01.000000', 'consum', 0.0212, 'lps'),
	(533982, 127, '2014-02-15 00:37:02.000000', 'consum', 0.0214, 'lps'),
	(533983, 127, '2014-02-15 00:37:03.000000', 'consum', 0.0216, 'lps'),
	(533984, 127, '2014-02-15 00:37:04.000000', 'consum', 0.0219, 'lps'),
	(533985, 127, '2014-02-15 00:37:05.000000', 'consum', 0.0216, 'lps'),
	(533986, 127, '2014-02-15 00:37:06.000000', 'consum', 0.0214, 'lps'),
	(533987, 127, '2014-02-15 00:37:07.000000', 'consum', 0.0213, 'lps'),
	(533988, 127, '2014-02-15 00:37:08.000000', 'consum', 0.0214, 'lps'),
	(533989, 127, '2014-02-15 00:37:09.000000', 'consum', 0.0213, 'lps'),
	(533990, 127, '2014-02-15 00:37:10.000000', 'consum', 0.0210, 'lps'),
	(533991, 127, '2014-02-15 00:37:11.000000', 'consum', 0.0213, 'lps'),
	(533992, 127, '2014-02-15 00:37:12.000000', 'consum', 0.0214, 'lps'),
	(533993, 127, '2014-02-15 00:37:13.000000', 'consum', 0.0211, 'lps'),
	(533994, 127, '2014-02-15 00:37:14.000000', 'consum', 0.0216, 'lps'),
	(533995, 127, '2014-02-15 00:37:15.000000', 'consum', 0.0217, 'lps'),
	(533996, 127, '2014-02-15 00:37:16.000000', 'consum', 0.0215, 'lps'),
	(533997, 127, '2014-02-15 00:37:17.000000', 'consum', 0.0216, 'lps'),
	(533998, 127, '2014-02-15 00:37:18.000000', 'consum', 0.0217, 'lps'),
	(533999, 127, '2014-02-15 00:37:19.000000', 'consum', 0.0217, 'lps'),
	(534000, 127, '2014-02-15 00:37:20.000000', 'consum', 0.0212, 'lps'),
	(534001, 127, '2014-02-15 00:37:21.000000', 'consum', 0.0212, 'lps'),
	(534002, 127, '2014-02-15 00:37:22.000000', 'consum', 0.0215, 'lps'),
	(534003, 127, '2014-02-15 00:37:23.000000', 'consum', 0.0211, 'lps'),
	(534004, 127, '2014-02-15 00:37:24.000000', 'consum', 0.0217, 'lps'),
	(534005, 127, '2014-02-15 00:37:25.000000', 'consum', 0.0213, 'lps'),
	(534006, 127, '2014-02-15 00:37:26.000000', 'consum', 0.0216, 'lps'),
	(534007, 127, '2014-02-15 00:37:27.000000', 'consum', 0.0210, 'lps'),
	(534008, 127, '2014-02-15 00:37:28.000000', 'consum', 0.0211, 'lps'),
	(534009, 127, '2014-02-15 00:37:29.000000', 'consum', 0.0218, 'lps'),
	(534010, 127, '2014-02-15 00:37:30.000000', 'consum', 0.0217, 'lps'),
	(534011, 127, '2014-02-15 00:37:31.000000', 'consum', 0.0213, 'lps'),
	(534012, 127, '2014-02-15 00:37:32.000000', 'consum', 0.0213, 'lps'),
	(534013, 127, '2014-02-15 00:37:33.000000', 'consum', 0.0218, 'lps'),
	(534014, 127, '2014-02-15 00:37:34.000000', 'consum', 0.0219, 'lps'),
	(534015, 127, '2014-02-15 00:37:35.000000', 'consum', 0.0214, 'lps'),
	(534016, 127, '2014-02-15 00:37:36.000000', 'consum', 0.0212, 'lps'),
	(534017, 127, '2014-02-15 00:37:37.000000', 'consum', 0.0217, 'lps'),
	(534018, 127, '2014-02-15 00:37:38.000000', 'consum', 0.0213, 'lps'),
	(534019, 127, '2014-02-15 00:37:39.000000', 'consum', 0.0212, 'lps'),
	(534020, 127, '2014-02-15 00:37:40.000000', 'consum', 0.0214, 'lps'),
	(534021, 127, '2014-02-15 00:37:41.000000', 'consum', 0.0215, 'lps'),
	(534022, 127, '2014-02-15 00:37:42.000000', 'consum', 0.0211, 'lps'),
	(534023, 127, '2014-02-15 00:37:43.000000', 'consum', 0.0219, 'lps'),
	(534024, 127, '2014-02-15 00:37:44.000000', 'consum', 0.0216, 'lps'),
	(534025, 127, '2014-02-15 00:37:45.000000', 'consum', 0.0213, 'lps'),
	(534026, 127, '2014-02-15 00:37:46.000000', 'consum', 0.0216, 'lps'),
	(534027, 127, '2014-02-15 00:37:47.000000', 'consum', 0.0212, 'lps'),
	(534028, 127, '2014-02-15 00:37:48.000000', 'consum', 0.0211, 'lps'),
	(534029, 127, '2014-02-15 00:37:49.000000', 'consum', 0.0210, 'lps'),
	(534030, 127, '2014-02-15 00:37:50.000000', 'consum', 0.0217, 'lps'),
	(534031, 127, '2014-02-15 00:37:51.000000', 'consum', 0.0215, 'lps'),
	(534032, 127, '2014-02-15 00:37:52.000000', 'consum', 0.0214, 'lps'),
	(534033, 127, '2014-02-15 00:37:53.000000', 'consum', 0.0218, 'lps'),
	(534034, 127, '2014-02-15 00:37:54.000000', 'consum', 0.0217, 'lps'),
	(534035, 127, '2014-02-15 00:37:55.000000', 'consum', 0.0212, 'lps'),
	(534036, 127, '2014-02-15 00:37:56.000000', 'consum', 0.0210, 'lps'),
	(534037, 127, '2014-02-15 00:37:57.000000', 'consum', 0.0214, 'lps'),
	(534038, 127, '2014-02-15 00:37:58.000000', 'consum', 0.0210, 'lps'),
	(534039, 127, '2014-02-15 00:37:59.000000', 'consum', 0.0218, 'lps'),
	(534040, 127, '2014-02-15 00:38:00.000000', 'consum', 0.0219, 'lps'),
	(534041, 127, '2014-02-15 00:38:01.000000', 'consum', 0.0215, 'lps'),
	(534042, 127, '2014-02-15 00:38:02.000000', 'consum', 0.0215, 'lps'),
	(534043, 127, '2014-02-15 00:38:03.000000', 'consum', 0.0212, 'lps'),
	(534044, 127, '2014-02-15 00:38:04.000000', 'consum', 0.0216, 'lps'),
	(534045, 127, '2014-02-15 00:38:05.000000', 'consum', 0.0215, 'lps'),
	(534046, 127, '2014-02-15 00:38:06.000000', 'consum', 0.0216, 'lps'),
	(534047, 127, '2014-02-15 00:38:07.000000', 'consum', 0.0214, 'lps'),
	(534048, 127, '2014-02-15 00:38:08.000000', 'consum', 0.0215, 'lps'),
	(534049, 127, '2014-02-15 00:38:09.000000', 'consum', 0.0211, 'lps'),
	(534050, 127, '2014-02-15 00:38:10.000000', 'consum', 0.0211, 'lps'),
	(534051, 127, '2014-02-15 00:38:11.000000', 'consum', 0.0215, 'lps'),
	(534052, 127, '2014-02-15 00:38:12.000000', 'consum', 0.0219, 'lps'),
	(534053, 127, '2014-02-15 00:38:13.000000', 'consum', 0.0213, 'lps'),
	(534054, 127, '2014-02-15 00:38:14.000000', 'consum', 0.0218, 'lps'),
	(534055, 127, '2014-02-15 00:38:15.000000', 'consum', 0.0212, 'lps'),
	(534056, 127, '2014-02-15 00:38:16.000000', 'consum', 0.0217, 'lps'),
	(534057, 127, '2014-02-15 00:38:17.000000', 'consum', 0.0218, 'lps'),
	(534058, 127, '2014-02-15 00:38:18.000000', 'consum', 0.0218, 'lps'),
	(534059, 127, '2014-02-15 00:38:19.000000', 'consum', 0.0210, 'lps'),
	(534060, 127, '2014-02-15 00:38:20.000000', 'consum', 0.0215, 'lps'),
	(534061, 127, '2014-02-15 00:38:21.000000', 'consum', 0.0218, 'lps'),
	(534062, 127, '2014-02-15 00:38:22.000000', 'consum', 0.0212, 'lps'),
	(534063, 127, '2014-02-15 00:38:23.000000', 'consum', 0.0216, 'lps'),
	(534064, 127, '2014-02-15 00:38:24.000000', 'consum', 0.0218, 'lps'),
	(534065, 127, '2014-02-15 00:38:25.000000', 'consum', 0.0210, 'lps'),
	(534066, 127, '2014-02-15 00:38:26.000000', 'consum', 0.0218, 'lps'),
	(534067, 127, '2014-02-15 00:38:27.000000', 'consum', 0.0211, 'lps'),
	(534068, 127, '2014-02-15 00:38:28.000000', 'consum', 0.0212, 'lps'),
	(534069, 127, '2014-02-15 00:38:29.000000', 'consum', 0.0218, 'lps'),
	(534070, 127, '2014-02-15 00:38:30.000000', 'consum', 0.0213, 'lps'),
	(534071, 127, '2014-02-15 00:38:31.000000', 'consum', 0.0213, 'lps'),
	(534072, 127, '2014-02-15 00:38:32.000000', 'consum', 0.0214, 'lps'),
	(534073, 127, '2014-02-15 00:38:33.000000', 'consum', 0.0211, 'lps'),
	(534074, 127, '2014-02-15 00:38:34.000000', 'consum', 0.0214, 'lps'),
	(534075, 127, '2014-02-15 00:38:35.000000', 'consum', 0.0218, 'lps'),
	(534076, 127, '2014-02-15 00:38:36.000000', 'consum', 0.0218, 'lps'),
	(534077, 127, '2014-02-15 00:38:37.000000', 'consum', 0.0218, 'lps'),
	(534078, 127, '2014-02-15 00:38:38.000000', 'consum', 0.0218, 'lps'),
	(534079, 127, '2014-02-15 00:38:39.000000', 'consum', 0.0214, 'lps'),
	(534080, 127, '2014-02-15 00:38:40.000000', 'consum', 0.0217, 'lps'),
	(534081, 127, '2014-02-15 00:38:41.000000', 'consum', 0.0213, 'lps'),
	(534082, 127, '2014-02-15 00:38:42.000000', 'consum', 0.0215, 'lps'),
	(534083, 127, '2014-02-15 00:38:43.000000', 'consum', 0.0217, 'lps'),
	(534084, 127, '2014-02-15 00:38:44.000000', 'consum', 0.0211, 'lps'),
	(534085, 127, '2014-02-15 00:38:45.000000', 'consum', 0.0214, 'lps'),
	(534086, 127, '2014-02-15 00:38:46.000000', 'consum', 0.0216, 'lps'),
	(534087, 127, '2014-02-15 00:38:47.000000', 'consum', 0.0218, 'lps'),
	(534088, 127, '2014-02-15 00:38:48.000000', 'consum', 0.0213, 'lps'),
	(534089, 127, '2014-02-15 00:38:49.000000', 'consum', 0.0212, 'lps'),
	(534090, 127, '2014-02-15 00:38:50.000000', 'consum', 0.0213, 'lps'),
	(534091, 127, '2014-02-15 00:38:51.000000', 'consum', 0.0216, 'lps'),
	(534092, 127, '2014-02-15 00:38:52.000000', 'consum', 0.0215, 'lps'),
	(534093, 127, '2014-02-15 00:38:53.000000', 'consum', 0.0214, 'lps'),
	(534094, 127, '2014-02-15 00:38:54.000000', 'consum', 0.0218, 'lps'),
	(534095, 127, '2014-02-15 00:38:55.000000', 'consum', 0.0219, 'lps'),
	(534096, 127, '2014-02-15 00:38:56.000000', 'consum', 0.0219, 'lps'),
	(534097, 127, '2014-02-15 00:38:57.000000', 'consum', 0.0219, 'lps'),
	(534098, 127, '2014-02-15 00:38:58.000000', 'consum', 0.0218, 'lps'),
	(534099, 127, '2014-02-15 00:38:59.000000', 'consum', 0.0216, 'lps'),
	(534100, 127, '2014-02-15 00:39:00.000000', 'consum', 0.0215, 'lps'),
	(534101, 127, '2014-02-15 00:39:01.000000', 'consum', 0.0219, 'lps'),
	(534102, 127, '2014-02-15 00:39:02.000000', 'consum', 0.0211, 'lps'),
	(534103, 127, '2014-02-15 00:39:03.000000', 'consum', 0.0216, 'lps'),
	(534104, 127, '2014-02-15 00:39:04.000000', 'consum', 0.0210, 'lps'),
	(534105, 127, '2014-02-15 00:39:05.000000', 'consum', 0.0213, 'lps'),
	(534106, 127, '2014-02-15 00:39:06.000000', 'consum', 0.0216, 'lps'),
	(534107, 127, '2014-02-15 00:39:07.000000', 'consum', 0.0210, 'lps'),
	(534108, 127, '2014-02-15 00:39:08.000000', 'consum', 0.0213, 'lps'),
	(534109, 127, '2014-02-15 00:39:09.000000', 'consum', 0.0215, 'lps'),
	(534110, 127, '2014-02-15 00:39:10.000000', 'consum', 0.0215, 'lps'),
	(534111, 127, '2014-02-15 00:39:11.000000', 'consum', 0.0212, 'lps'),
	(534112, 127, '2014-02-15 00:39:12.000000', 'consum', 0.0214, 'lps'),
	(534113, 127, '2014-02-15 00:39:13.000000', 'consum', 0.0214, 'lps'),
	(534114, 127, '2014-02-15 00:39:14.000000', 'consum', 0.0218, 'lps'),
	(534115, 127, '2014-02-15 00:39:15.000000', 'consum', 0.0210, 'lps'),
	(534116, 127, '2014-02-15 00:39:16.000000', 'consum', 0.0215, 'lps'),
	(534117, 127, '2014-02-15 00:39:17.000000', 'consum', 0.0216, 'lps'),
	(534118, 127, '2014-02-15 00:39:18.000000', 'consum', 0.0216, 'lps'),
	(534119, 127, '2014-02-15 00:39:19.000000', 'consum', 0.0211, 'lps'),
	(534120, 127, '2014-02-15 00:39:20.000000', 'consum', 0.0219, 'lps'),
	(534121, 127, '2014-02-15 00:39:21.000000', 'consum', 0.0212, 'lps'),
	(534122, 127, '2014-02-15 00:39:22.000000', 'consum', 0.0213, 'lps'),
	(534123, 127, '2014-02-15 00:39:23.000000', 'consum', 0.0218, 'lps'),
	(534124, 127, '2014-02-15 00:39:24.000000', 'consum', 0.0213, 'lps'),
	(534125, 127, '2014-02-15 00:39:25.000000', 'consum', 0.0210, 'lps'),
	(534126, 127, '2014-02-15 00:39:26.000000', 'consum', 0.0212, 'lps'),
	(534127, 127, '2014-02-15 00:39:27.000000', 'consum', 0.0211, 'lps'),
	(534128, 127, '2014-02-15 00:39:28.000000', 'consum', 0.0217, 'lps'),
	(534129, 127, '2014-02-15 00:39:29.000000', 'consum', 0.0216, 'lps'),
	(534130, 127, '2014-02-15 00:39:30.000000', 'consum', 0.0219, 'lps'),
	(534131, 127, '2014-02-15 00:39:31.000000', 'consum', 0.0217, 'lps'),
	(534132, 127, '2014-02-15 00:39:32.000000', 'consum', 0.0217, 'lps'),
	(534133, 127, '2014-02-15 00:39:33.000000', 'consum', 0.0216, 'lps'),
	(534134, 127, '2014-02-15 00:39:34.000000', 'consum', 0.0219, 'lps'),
	(534135, 127, '2014-02-15 00:39:35.000000', 'consum', 0.0218, 'lps'),
	(534136, 127, '2014-02-15 00:39:36.000000', 'consum', 0.0215, 'lps'),
	(534137, 127, '2014-02-15 00:39:37.000000', 'consum', 0.0211, 'lps'),
	(534138, 127, '2014-02-15 00:39:38.000000', 'consum', 0.0210, 'lps'),
	(534139, 127, '2014-02-15 00:39:39.000000', 'consum', 0.0218, 'lps'),
	(534140, 127, '2014-02-15 00:39:40.000000', 'consum', 0.0212, 'lps'),
	(534141, 127, '2014-02-15 00:39:41.000000', 'consum', 0.0215, 'lps'),
	(534142, 127, '2014-02-15 00:39:42.000000', 'consum', 0.0219, 'lps'),
	(534143, 127, '2014-02-15 00:39:43.000000', 'consum', 0.0210, 'lps'),
	(534144, 127, '2014-02-15 00:39:44.000000', 'consum', 0.0215, 'lps'),
	(534145, 127, '2014-02-15 00:39:45.000000', 'consum', 0.0214, 'lps'),
	(534146, 127, '2014-02-15 00:39:46.000000', 'consum', 0.0215, 'lps'),
	(534147, 127, '2014-02-15 00:39:47.000000', 'consum', 0.0215, 'lps'),
	(534148, 127, '2014-02-15 00:39:48.000000', 'consum', 0.0210, 'lps'),
	(534149, 127, '2014-02-15 00:39:49.000000', 'consum', 0.0217, 'lps'),
	(534150, 127, '2014-02-15 00:39:50.000000', 'consum', 0.0215, 'lps'),
	(534151, 127, '2014-02-15 00:39:51.000000', 'consum', 0.0214, 'lps'),
	(534152, 127, '2014-02-15 00:39:52.000000', 'consum', 0.0217, 'lps'),
	(534153, 127, '2014-02-15 00:39:53.000000', 'consum', 0.0214, 'lps'),
	(534154, 127, '2014-02-15 00:39:54.000000', 'consum', 0.0217, 'lps'),
	(534155, 127, '2014-02-15 00:39:55.000000', 'consum', 0.0216, 'lps'),
	(534156, 127, '2014-02-15 00:39:56.000000', 'consum', 0.0210, 'lps'),
	(534157, 127, '2014-02-15 00:39:57.000000', 'consum', 0.0213, 'lps'),
	(534158, 127, '2014-02-15 00:39:58.000000', 'consum', 0.0213, 'lps'),
	(534159, 127, '2014-02-15 00:39:59.000000', 'consum', 0.0217, 'lps'),
	(534160, 127, '2014-02-15 00:40:00.000000', 'consum', 0.0217, 'lps'),
	(534161, 127, '2014-02-15 00:40:01.000000', 'consum', 0.0214, 'lps'),
	(534162, 127, '2014-02-15 00:40:02.000000', 'consum', 0.0210, 'lps'),
	(534163, 127, '2014-02-15 00:40:03.000000', 'consum', 0.0218, 'lps'),
	(534164, 127, '2014-02-15 00:40:04.000000', 'consum', 0.0219, 'lps'),
	(534165, 127, '2014-02-15 00:40:05.000000', 'consum', 0.0213, 'lps'),
	(534166, 127, '2014-02-15 00:40:06.000000', 'consum', 0.0217, 'lps'),
	(534167, 127, '2014-02-15 00:40:07.000000', 'consum', 0.0216, 'lps'),
	(534168, 127, '2014-02-15 00:40:08.000000', 'consum', 0.0219, 'lps'),
	(534169, 127, '2014-02-15 00:40:09.000000', 'consum', 0.0218, 'lps'),
	(534170, 127, '2014-02-15 00:40:10.000000', 'consum', 0.0215, 'lps'),
	(534171, 127, '2014-02-15 00:40:11.000000', 'consum', 0.0211, 'lps'),
	(534172, 127, '2014-02-15 00:40:12.000000', 'consum', 0.0211, 'lps'),
	(534173, 127, '2014-02-15 00:40:13.000000', 'consum', 0.0211, 'lps'),
	(534174, 127, '2014-02-15 00:40:14.000000', 'consum', 0.0214, 'lps'),
	(534175, 127, '2014-02-15 00:40:15.000000', 'consum', 0.0215, 'lps'),
	(534176, 127, '2014-02-15 00:40:16.000000', 'consum', 0.0215, 'lps'),
	(534177, 127, '2014-02-15 00:40:17.000000', 'consum', 0.0211, 'lps'),
	(534178, 127, '2014-02-15 00:40:18.000000', 'consum', 0.0218, 'lps'),
	(534179, 127, '2014-02-15 00:40:19.000000', 'consum', 0.0219, 'lps'),
	(534180, 127, '2014-02-15 00:40:20.000000', 'consum', 0.0213, 'lps'),
	(534181, 127, '2014-02-15 00:40:21.000000', 'consum', 0.0219, 'lps'),
	(534182, 127, '2014-02-15 00:40:22.000000', 'consum', 0.0215, 'lps'),
	(534183, 127, '2014-02-15 00:40:23.000000', 'consum', 0.0210, 'lps'),
	(534184, 127, '2014-02-15 00:40:24.000000', 'consum', 0.0215, 'lps'),
	(534185, 127, '2014-02-15 00:40:25.000000', 'consum', 0.0216, 'lps'),
	(534186, 127, '2014-02-15 00:40:26.000000', 'consum', 0.0215, 'lps'),
	(534187, 127, '2014-02-15 00:40:27.000000', 'consum', 0.0217, 'lps'),
	(534188, 127, '2014-02-15 00:40:28.000000', 'consum', 0.0211, 'lps'),
	(534189, 127, '2014-02-15 00:40:29.000000', 'consum', 0.0213, 'lps'),
	(534190, 127, '2014-02-15 00:40:30.000000', 'consum', 0.0212, 'lps'),
	(534191, 127, '2014-02-15 00:40:31.000000', 'consum', 0.0211, 'lps'),
	(534192, 127, '2014-02-15 00:40:32.000000', 'consum', 0.0219, 'lps'),
	(534193, 127, '2014-02-15 00:40:33.000000', 'consum', 0.0213, 'lps'),
	(534194, 127, '2014-02-15 00:40:34.000000', 'consum', 0.0211, 'lps'),
	(534195, 127, '2014-02-15 00:40:35.000000', 'consum', 0.0214, 'lps'),
	(534196, 127, '2014-02-15 00:40:36.000000', 'consum', 0.0210, 'lps'),
	(534197, 127, '2014-02-15 00:40:37.000000', 'consum', 0.0216, 'lps'),
	(534198, 127, '2014-02-15 00:40:38.000000', 'consum', 0.0210, 'lps'),
	(534199, 127, '2014-02-15 00:40:39.000000', 'consum', 0.0213, 'lps'),
	(534200, 127, '2014-02-15 00:40:40.000000', 'consum', 0.0214, 'lps'),
	(534201, 127, '2014-02-15 00:40:41.000000', 'consum', 0.0214, 'lps'),
	(534202, 127, '2014-02-15 00:40:42.000000', 'consum', 0.0219, 'lps'),
	(534203, 127, '2014-02-15 00:40:43.000000', 'consum', 0.0214, 'lps'),
	(534204, 127, '2014-02-15 00:40:44.000000', 'consum', 0.0212, 'lps'),
	(534205, 127, '2014-02-15 00:40:45.000000', 'consum', 0.0218, 'lps'),
	(534206, 127, '2014-02-15 00:40:46.000000', 'consum', 0.0215, 'lps'),
	(534207, 127, '2014-02-15 00:40:47.000000', 'consum', 0.0211, 'lps'),
	(534208, 127, '2014-02-15 00:40:48.000000', 'consum', 0.0210, 'lps'),
	(534209, 127, '2014-02-15 00:40:49.000000', 'consum', 0.0217, 'lps'),
	(534210, 127, '2014-02-15 00:40:50.000000', 'consum', 0.0215, 'lps'),
	(534211, 127, '2014-02-15 00:40:51.000000', 'consum', 0.0216, 'lps'),
	(534212, 127, '2014-02-15 00:40:52.000000', 'consum', 0.0216, 'lps'),
	(534213, 127, '2014-02-15 00:40:53.000000', 'consum', 0.0212, 'lps'),
	(534214, 127, '2014-02-15 00:40:54.000000', 'consum', 0.0212, 'lps'),
	(534215, 127, '2014-02-15 00:40:55.000000', 'consum', 0.0215, 'lps'),
	(534216, 127, '2014-02-15 00:40:56.000000', 'consum', 0.0210, 'lps'),
	(534217, 127, '2014-02-15 00:40:57.000000', 'consum', 0.0217, 'lps'),
	(534218, 127, '2014-02-15 00:40:58.000000', 'consum', 0.0214, 'lps'),
	(534219, 127, '2014-02-15 00:40:59.000000', 'consum', 0.0211, 'lps'),
	(534220, 127, '2014-02-15 00:41:00.000000', 'consum', 0.0212, 'lps'),
	(534221, 127, '2014-02-15 00:41:01.000000', 'consum', 0.0217, 'lps'),
	(534222, 127, '2014-02-15 00:41:02.000000', 'consum', 0.0211, 'lps'),
	(534223, 127, '2014-02-15 00:41:03.000000', 'consum', 0.0214, 'lps'),
	(534224, 127, '2014-02-15 00:41:04.000000', 'consum', 0.0218, 'lps'),
	(534225, 127, '2014-02-15 00:41:05.000000', 'consum', 0.0218, 'lps'),
	(534226, 127, '2014-02-15 00:41:06.000000', 'consum', 0.0216, 'lps'),
	(534227, 127, '2014-02-15 00:41:07.000000', 'consum', 0.0218, 'lps'),
	(534228, 127, '2014-02-15 00:41:08.000000', 'consum', 0.0213, 'lps'),
	(534229, 127, '2014-02-15 00:41:09.000000', 'consum', 0.0210, 'lps'),
	(534230, 127, '2014-02-15 00:41:10.000000', 'consum', 0.0214, 'lps'),
	(534231, 127, '2014-02-15 00:41:11.000000', 'consum', 0.0219, 'lps'),
	(534232, 127, '2014-02-15 00:41:12.000000', 'consum', 0.0214, 'lps'),
	(534233, 127, '2014-02-15 00:41:13.000000', 'consum', 0.0214, 'lps'),
	(534234, 127, '2014-02-15 00:41:14.000000', 'consum', 0.0217, 'lps'),
	(534235, 127, '2014-02-15 00:41:15.000000', 'consum', 0.0214, 'lps'),
	(534236, 127, '2014-02-15 00:41:16.000000', 'consum', 0.0218, 'lps'),
	(534237, 127, '2014-02-15 00:41:17.000000', 'consum', 0.0210, 'lps'),
	(534238, 127, '2014-02-15 00:41:18.000000', 'consum', 0.0215, 'lps'),
	(534239, 127, '2014-02-15 00:41:19.000000', 'consum', 0.0218, 'lps'),
	(534240, 127, '2014-02-15 00:41:20.000000', 'consum', 0.0215, 'lps'),
	(534241, 127, '2014-02-15 00:41:21.000000', 'consum', 0.0219, 'lps'),
	(534242, 127, '2014-02-15 00:41:22.000000', 'consum', 0.0214, 'lps'),
	(534243, 127, '2014-02-15 00:41:23.000000', 'consum', 0.0211, 'lps'),
	(534244, 127, '2014-02-15 00:41:24.000000', 'consum', 0.0215, 'lps'),
	(534245, 127, '2014-02-15 00:41:25.000000', 'consum', 0.0214, 'lps'),
	(534246, 127, '2014-02-15 00:41:26.000000', 'consum', 0.0214, 'lps'),
	(534247, 127, '2014-02-15 00:41:27.000000', 'consum', 0.0219, 'lps'),
	(534248, 127, '2014-02-15 00:41:28.000000', 'consum', 0.0214, 'lps'),
	(534249, 127, '2014-02-15 00:41:29.000000', 'consum', 0.0213, 'lps'),
	(534250, 127, '2014-02-15 00:41:30.000000', 'consum', 0.0211, 'lps'),
	(534251, 127, '2014-02-15 00:41:31.000000', 'consum', 0.0210, 'lps'),
	(534252, 127, '2014-02-15 00:41:32.000000', 'consum', 0.0216, 'lps'),
	(534253, 127, '2014-02-15 00:41:33.000000', 'consum', 0.0210, 'lps'),
	(534254, 127, '2014-02-15 00:41:34.000000', 'consum', 0.0213, 'lps'),
	(534255, 127, '2014-02-15 00:41:35.000000', 'consum', 0.0214, 'lps'),
	(534256, 127, '2014-02-15 00:41:36.000000', 'consum', 0.0212, 'lps'),
	(534257, 127, '2014-02-15 00:41:37.000000', 'consum', 0.0218, 'lps'),
	(534258, 127, '2014-02-15 00:41:38.000000', 'consum', 0.0215, 'lps'),
	(534259, 127, '2014-02-15 00:41:39.000000', 'consum', 0.0212, 'lps'),
	(534260, 127, '2014-02-15 00:41:40.000000', 'consum', 0.0214, 'lps'),
	(534261, 127, '2014-02-15 00:41:41.000000', 'consum', 0.0217, 'lps'),
	(534262, 127, '2014-02-15 00:41:42.000000', 'consum', 0.0210, 'lps'),
	(534263, 127, '2014-02-15 00:41:43.000000', 'consum', 0.0213, 'lps'),
	(534264, 127, '2014-02-15 00:41:44.000000', 'consum', 0.0212, 'lps'),
	(534265, 127, '2014-02-15 00:41:45.000000', 'consum', 0.0214, 'lps'),
	(534266, 127, '2014-02-15 00:41:46.000000', 'consum', 0.0215, 'lps'),
	(534267, 127, '2014-02-15 00:41:47.000000', 'consum', 0.0213, 'lps'),
	(534268, 127, '2014-02-15 00:41:48.000000', 'consum', 0.0219, 'lps'),
	(534269, 127, '2014-02-15 00:41:49.000000', 'consum', 0.0219, 'lps'),
	(534270, 127, '2014-02-15 00:41:50.000000', 'consum', 0.0216, 'lps'),
	(534271, 127, '2014-02-15 00:41:51.000000', 'consum', 0.0216, 'lps'),
	(534272, 127, '2014-02-15 00:41:52.000000', 'consum', 0.0212, 'lps'),
	(534273, 127, '2014-02-15 00:41:53.000000', 'consum', 0.0211, 'lps'),
	(534274, 127, '2014-02-15 00:41:54.000000', 'consum', 0.0218, 'lps'),
	(534275, 127, '2014-02-15 00:41:55.000000', 'consum', 0.0211, 'lps'),
	(534276, 127, '2014-02-15 00:41:56.000000', 'consum', 0.0219, 'lps'),
	(534277, 127, '2014-02-15 00:41:57.000000', 'consum', 0.0211, 'lps'),
	(534278, 127, '2014-02-15 00:41:58.000000', 'consum', 0.0212, 'lps'),
	(534279, 127, '2014-02-15 00:41:59.000000', 'consum', 0.0214, 'lps'),
	(534280, 127, '2014-02-15 00:42:00.000000', 'consum', 0.0217, 'lps'),
	(534281, 127, '2014-02-15 00:42:01.000000', 'consum', 0.0215, 'lps'),
	(534282, 127, '2014-02-15 00:42:02.000000', 'consum', 0.0212, 'lps'),
	(534283, 127, '2014-02-15 00:42:03.000000', 'consum', 0.0215, 'lps'),
	(534284, 127, '2014-02-15 00:42:04.000000', 'consum', 0.0212, 'lps'),
	(534285, 127, '2014-02-15 00:42:05.000000', 'consum', 0.0213, 'lps'),
	(534286, 127, '2014-02-15 00:42:06.000000', 'consum', 0.0212, 'lps'),
	(534287, 127, '2014-02-15 00:42:07.000000', 'consum', 0.0211, 'lps'),
	(534288, 127, '2014-02-15 00:42:08.000000', 'consum', 0.0219, 'lps'),
	(534289, 127, '2014-02-15 00:42:09.000000', 'consum', 0.0214, 'lps'),
	(534290, 127, '2014-02-15 00:42:10.000000', 'consum', 0.0213, 'lps'),
	(534291, 127, '2014-02-15 00:42:11.000000', 'consum', 0.0213, 'lps'),
	(534292, 127, '2014-02-15 00:42:12.000000', 'consum', 0.0217, 'lps'),
	(534293, 127, '2014-02-15 00:42:13.000000', 'consum', 0.0217, 'lps'),
	(534294, 127, '2014-02-15 00:42:14.000000', 'consum', 0.0213, 'lps'),
	(534295, 127, '2014-02-15 00:42:15.000000', 'consum', 0.0216, 'lps'),
	(534296, 127, '2014-02-15 00:42:16.000000', 'consum', 0.0219, 'lps'),
	(534297, 127, '2014-02-15 00:42:17.000000', 'consum', 0.0210, 'lps'),
	(534298, 127, '2014-02-15 00:42:18.000000', 'consum', 0.0212, 'lps'),
	(534299, 127, '2014-02-15 00:42:19.000000', 'consum', 0.0210, 'lps'),
	(534300, 127, '2014-02-15 00:42:20.000000', 'consum', 0.0213, 'lps'),
	(534301, 127, '2014-02-15 00:42:21.000000', 'consum', 0.0219, 'lps'),
	(534302, 127, '2014-02-15 00:42:22.000000', 'consum', 0.0214, 'lps'),
	(534303, 127, '2014-02-15 00:42:23.000000', 'consum', 0.0212, 'lps'),
	(534304, 127, '2014-02-15 00:42:24.000000', 'consum', 0.0211, 'lps'),
	(534305, 127, '2014-02-15 00:42:25.000000', 'consum', 0.0210, 'lps'),
	(534306, 127, '2014-02-15 00:42:26.000000', 'consum', 0.0219, 'lps'),
	(534307, 127, '2014-02-15 00:42:27.000000', 'consum', 0.0212, 'lps'),
	(534308, 127, '2014-02-15 00:42:28.000000', 'consum', 0.0216, 'lps'),
	(534309, 127, '2014-02-15 00:42:29.000000', 'consum', 0.0216, 'lps'),
	(534310, 127, '2014-02-15 00:42:30.000000', 'consum', 0.0219, 'lps'),
	(534311, 127, '2014-02-15 00:42:31.000000', 'consum', 0.0210, 'lps'),
	(534312, 127, '2014-02-15 00:42:32.000000', 'consum', 0.0214, 'lps'),
	(534313, 127, '2014-02-15 00:42:33.000000', 'consum', 0.0211, 'lps'),
	(534314, 127, '2014-02-15 00:42:34.000000', 'consum', 0.0214, 'lps'),
	(534315, 127, '2014-02-15 00:42:35.000000', 'consum', 0.0215, 'lps'),
	(534316, 127, '2014-02-15 00:42:36.000000', 'consum', 0.0216, 'lps'),
	(534317, 127, '2014-02-15 00:42:37.000000', 'consum', 0.0215, 'lps'),
	(534318, 127, '2014-02-15 00:42:38.000000', 'consum', 0.0218, 'lps'),
	(534319, 127, '2014-02-15 00:42:39.000000', 'consum', 0.0213, 'lps'),
	(534320, 127, '2014-02-15 00:42:40.000000', 'consum', 0.0212, 'lps'),
	(534321, 127, '2014-02-15 00:42:41.000000', 'consum', 0.0212, 'lps'),
	(534322, 127, '2014-02-15 00:42:42.000000', 'consum', 0.0213, 'lps'),
	(534323, 127, '2014-02-15 00:42:43.000000', 'consum', 0.0212, 'lps'),
	(534324, 127, '2014-02-15 00:42:44.000000', 'consum', 0.0212, 'lps'),
	(534325, 127, '2014-02-15 00:42:45.000000', 'consum', 0.0212, 'lps'),
	(534326, 127, '2014-02-15 00:42:46.000000', 'consum', 0.0217, 'lps'),
	(534327, 127, '2014-02-15 00:42:47.000000', 'consum', 0.0216, 'lps'),
	(534328, 127, '2014-02-15 00:42:48.000000', 'consum', 0.0213, 'lps'),
	(534329, 127, '2014-02-15 00:42:49.000000', 'consum', 0.0216, 'lps'),
	(534330, 127, '2014-02-15 00:42:50.000000', 'consum', 0.0213, 'lps'),
	(534331, 127, '2014-02-15 00:42:51.000000', 'consum', 0.0216, 'lps'),
	(534332, 127, '2014-02-15 00:42:52.000000', 'consum', 0.0212, 'lps'),
	(534333, 127, '2014-02-15 00:42:53.000000', 'consum', 0.0211, 'lps'),
	(534334, 127, '2014-02-15 00:42:54.000000', 'consum', 0.0211, 'lps'),
	(534335, 127, '2014-02-15 00:42:55.000000', 'consum', 0.0213, 'lps'),
	(534336, 127, '2014-02-15 00:42:56.000000', 'consum', 0.0212, 'lps'),
	(534337, 127, '2014-02-15 00:42:57.000000', 'consum', 0.0213, 'lps'),
	(534338, 127, '2014-02-15 00:42:58.000000', 'consum', 0.0217, 'lps'),
	(534339, 127, '2014-02-15 00:42:59.000000', 'consum', 0.0217, 'lps'),
	(534340, 127, '2014-02-15 00:43:00.000000', 'consum', 0.0213, 'lps'),
	(534341, 127, '2014-02-15 00:43:01.000000', 'consum', 0.0217, 'lps'),
	(534342, 127, '2014-02-15 00:43:02.000000', 'consum', 0.0215, 'lps'),
	(534343, 127, '2014-02-15 00:43:03.000000', 'consum', 0.0213, 'lps'),
	(534344, 127, '2014-02-15 00:43:04.000000', 'consum', 0.0212, 'lps'),
	(534345, 127, '2014-02-15 00:43:05.000000', 'consum', 0.0210, 'lps'),
	(534346, 127, '2014-02-15 00:43:06.000000', 'consum', 0.0216, 'lps'),
	(534347, 127, '2014-02-15 00:43:07.000000', 'consum', 0.0218, 'lps'),
	(534348, 127, '2014-02-15 00:43:08.000000', 'consum', 0.0214, 'lps'),
	(534349, 127, '2014-02-15 00:43:09.000000', 'consum', 0.0218, 'lps'),
	(534350, 127, '2014-02-15 00:43:10.000000', 'consum', 0.0215, 'lps'),
	(534351, 127, '2014-02-15 00:43:11.000000', 'consum', 0.0215, 'lps'),
	(534352, 127, '2014-02-15 00:43:12.000000', 'consum', 0.0219, 'lps'),
	(534353, 127, '2014-02-15 00:43:13.000000', 'consum', 0.0211, 'lps'),
	(534354, 127, '2014-02-15 00:43:14.000000', 'consum', 0.0218, 'lps'),
	(534355, 127, '2014-02-15 00:43:15.000000', 'consum', 0.0218, 'lps'),
	(534356, 127, '2014-02-15 00:43:16.000000', 'consum', 0.0216, 'lps'),
	(534357, 127, '2014-02-15 00:43:17.000000', 'consum', 0.0217, 'lps'),
	(534358, 127, '2014-02-15 00:43:18.000000', 'consum', 0.0217, 'lps'),
	(534359, 127, '2014-02-15 00:43:19.000000', 'consum', 0.0213, 'lps'),
	(534360, 127, '2014-02-15 00:43:20.000000', 'consum', 0.0216, 'lps'),
	(534361, 127, '2014-02-15 00:43:21.000000', 'consum', 0.0219, 'lps'),
	(534362, 127, '2014-02-15 00:43:22.000000', 'consum', 0.0211, 'lps'),
	(534363, 127, '2014-02-15 00:43:23.000000', 'consum', 0.0216, 'lps'),
	(534364, 127, '2014-02-15 00:43:24.000000', 'consum', 0.0219, 'lps'),
	(534365, 127, '2014-02-15 00:43:25.000000', 'consum', 0.0219, 'lps'),
	(534366, 127, '2014-02-15 00:43:26.000000', 'consum', 0.0215, 'lps'),
	(534367, 127, '2014-02-15 00:43:27.000000', 'consum', 0.0212, 'lps'),
	(534368, 127, '2014-02-15 00:43:28.000000', 'consum', 0.0214, 'lps'),
	(534369, 127, '2014-02-15 00:43:29.000000', 'consum', 0.0214, 'lps'),
	(534370, 127, '2014-02-15 00:43:30.000000', 'consum', 0.0210, 'lps'),
	(534371, 127, '2014-02-15 00:43:31.000000', 'consum', 0.0216, 'lps'),
	(534372, 127, '2014-02-15 00:43:32.000000', 'consum', 0.0214, 'lps'),
	(534373, 127, '2014-02-15 00:43:33.000000', 'consum', 0.0210, 'lps'),
	(534374, 127, '2014-02-15 00:43:34.000000', 'consum', 0.0210, 'lps'),
	(534375, 127, '2014-02-15 00:43:35.000000', 'consum', 0.0211, 'lps'),
	(534376, 127, '2014-02-15 00:43:36.000000', 'consum', 0.0214, 'lps'),
	(534377, 127, '2014-02-15 00:43:37.000000', 'consum', 0.0217, 'lps'),
	(534378, 127, '2014-02-15 00:43:38.000000', 'consum', 0.0214, 'lps'),
	(534379, 127, '2014-02-15 00:43:39.000000', 'consum', 0.0212, 'lps'),
	(534380, 127, '2014-02-15 00:43:40.000000', 'consum', 0.0215, 'lps'),
	(534381, 127, '2014-02-15 00:43:41.000000', 'consum', 0.0211, 'lps'),
	(534382, 127, '2014-02-15 00:43:42.000000', 'consum', 0.0219, 'lps'),
	(534383, 127, '2014-02-15 00:43:43.000000', 'consum', 0.0213, 'lps'),
	(534384, 127, '2014-02-15 00:43:44.000000', 'consum', 0.0219, 'lps'),
	(534385, 127, '2014-02-15 00:43:45.000000', 'consum', 0.0217, 'lps'),
	(534386, 127, '2014-02-15 00:43:46.000000', 'consum', 0.0219, 'lps'),
	(534387, 127, '2014-02-15 00:43:47.000000', 'consum', 0.0212, 'lps'),
	(534388, 127, '2014-02-15 00:43:48.000000', 'consum', 0.0216, 'lps'),
	(534389, 127, '2014-02-15 00:43:49.000000', 'consum', 0.0214, 'lps'),
	(534390, 127, '2014-02-15 00:43:50.000000', 'consum', 0.0212, 'lps'),
	(534391, 127, '2014-02-15 00:43:51.000000', 'consum', 0.0217, 'lps'),
	(534392, 127, '2014-02-15 00:43:52.000000', 'consum', 0.0212, 'lps'),
	(534393, 127, '2014-02-15 00:43:53.000000', 'consum', 0.0219, 'lps'),
	(534394, 127, '2014-02-15 00:43:54.000000', 'consum', 0.0218, 'lps'),
	(534395, 127, '2014-02-15 00:43:55.000000', 'consum', 0.0215, 'lps'),
	(534396, 127, '2014-02-15 00:43:56.000000', 'consum', 0.0213, 'lps'),
	(534397, 127, '2014-02-15 00:43:57.000000', 'consum', 0.0218, 'lps'),
	(534398, 127, '2014-02-15 00:43:58.000000', 'consum', 0.0212, 'lps'),
	(534399, 127, '2014-02-15 00:43:59.000000', 'consum', 0.0216, 'lps'),
	(534400, 127, '2014-02-15 00:44:00.000000', 'consum', 0.0214, 'lps'),
	(534401, 127, '2014-02-15 00:44:01.000000', 'consum', 0.0213, 'lps'),
	(534402, 127, '2014-02-15 00:44:02.000000', 'consum', 0.0214, 'lps'),
	(534403, 127, '2014-02-15 00:44:03.000000', 'consum', 0.0212, 'lps'),
	(534404, 127, '2014-02-15 00:44:04.000000', 'consum', 0.0219, 'lps'),
	(534405, 127, '2014-02-15 00:44:05.000000', 'consum', 0.0217, 'lps'),
	(534406, 127, '2014-02-15 00:44:06.000000', 'consum', 0.0210, 'lps'),
	(534407, 127, '2014-02-15 00:44:07.000000', 'consum', 0.0210, 'lps'),
	(534408, 127, '2014-02-15 00:44:08.000000', 'consum', 0.0210, 'lps'),
	(534409, 127, '2014-02-15 00:44:09.000000', 'consum', 0.0219, 'lps'),
	(534410, 127, '2014-02-15 00:44:10.000000', 'consum', 0.0217, 'lps'),
	(534411, 127, '2014-02-15 00:44:11.000000', 'consum', 0.0217, 'lps'),
	(534412, 127, '2014-02-15 00:44:12.000000', 'consum', 0.0216, 'lps'),
	(534413, 127, '2014-02-15 00:44:13.000000', 'consum', 0.0211, 'lps'),
	(534414, 127, '2014-02-15 00:44:14.000000', 'consum', 0.0216, 'lps'),
	(534415, 127, '2014-02-15 00:44:15.000000', 'consum', 0.0219, 'lps'),
	(534416, 127, '2014-02-15 00:44:16.000000', 'consum', 0.0217, 'lps'),
	(534417, 127, '2014-02-15 00:44:17.000000', 'consum', 0.0218, 'lps'),
	(534418, 127, '2014-02-15 00:44:18.000000', 'consum', 0.0211, 'lps'),
	(534419, 127, '2014-02-15 00:44:19.000000', 'consum', 0.0219, 'lps'),
	(534420, 127, '2014-02-15 00:44:20.000000', 'consum', 0.0214, 'lps'),
	(534421, 127, '2014-02-15 00:44:21.000000', 'consum', 0.0215, 'lps'),
	(534422, 127, '2014-02-15 00:44:22.000000', 'consum', 0.0213, 'lps'),
	(534423, 127, '2014-02-15 00:44:23.000000', 'consum', 0.0218, 'lps'),
	(534424, 127, '2014-02-15 00:44:24.000000', 'consum', 0.0214, 'lps'),
	(534425, 127, '2014-02-15 00:44:25.000000', 'consum', 0.0214, 'lps'),
	(534426, 127, '2014-02-15 00:44:26.000000', 'consum', 0.0219, 'lps'),
	(534427, 127, '2014-02-15 00:44:27.000000', 'consum', 0.0213, 'lps'),
	(534428, 127, '2014-02-15 00:44:28.000000', 'consum', 0.0218, 'lps'),
	(534429, 127, '2014-02-15 00:44:29.000000', 'consum', 0.0211, 'lps'),
	(534430, 127, '2014-02-15 00:44:30.000000', 'consum', 0.0211, 'lps'),
	(534431, 127, '2014-02-15 00:44:31.000000', 'consum', 0.0213, 'lps'),
	(534432, 127, '2014-02-15 00:44:32.000000', 'consum', 0.0213, 'lps'),
	(534433, 127, '2014-02-15 00:44:33.000000', 'consum', 0.0215, 'lps'),
	(534434, 127, '2014-02-15 00:44:34.000000', 'consum', 0.0217, 'lps'),
	(534435, 127, '2014-02-15 00:44:35.000000', 'consum', 0.0219, 'lps'),
	(534436, 127, '2014-02-15 00:44:36.000000', 'consum', 0.0214, 'lps'),
	(534437, 127, '2014-02-15 00:44:37.000000', 'consum', 0.0217, 'lps'),
	(534438, 127, '2014-02-15 00:44:38.000000', 'consum', 0.0211, 'lps'),
	(534439, 127, '2014-02-15 00:44:39.000000', 'consum', 0.0214, 'lps'),
	(534440, 127, '2014-02-15 00:44:40.000000', 'consum', 0.0210, 'lps'),
	(534441, 127, '2014-02-15 00:44:41.000000', 'consum', 0.0215, 'lps'),
	(534442, 127, '2014-02-15 00:44:42.000000', 'consum', 0.0219, 'lps'),
	(534443, 127, '2014-02-15 00:44:43.000000', 'consum', 0.0210, 'lps'),
	(534444, 127, '2014-02-15 00:44:44.000000', 'consum', 0.0214, 'lps'),
	(534445, 127, '2014-02-15 00:44:45.000000', 'consum', 0.0219, 'lps'),
	(534446, 127, '2014-02-15 00:44:46.000000', 'consum', 0.0214, 'lps'),
	(534447, 127, '2014-02-15 00:44:47.000000', 'consum', 0.0212, 'lps'),
	(534448, 127, '2014-02-15 00:44:48.000000', 'consum', 0.0211, 'lps'),
	(534449, 127, '2014-02-15 00:44:49.000000', 'consum', 0.0210, 'lps'),
	(534450, 127, '2014-02-15 00:44:50.000000', 'consum', 0.0215, 'lps'),
	(534451, 127, '2014-02-15 00:44:51.000000', 'consum', 0.0215, 'lps'),
	(534452, 127, '2014-02-15 00:44:52.000000', 'consum', 0.0211, 'lps'),
	(534453, 127, '2014-02-15 00:44:53.000000', 'consum', 0.0213, 'lps'),
	(534454, 127, '2014-02-15 00:44:54.000000', 'consum', 0.0219, 'lps'),
	(534455, 127, '2014-02-15 00:44:55.000000', 'consum', 0.0219, 'lps'),
	(534456, 127, '2014-02-15 00:44:56.000000', 'consum', 0.0219, 'lps'),
	(534457, 127, '2014-02-15 00:44:57.000000', 'consum', 0.0219, 'lps'),
	(534458, 127, '2014-02-15 00:44:58.000000', 'consum', 0.0216, 'lps'),
	(534459, 127, '2014-02-15 00:44:59.000000', 'consum', 0.0216, 'lps'),
	(534460, 127, '2014-02-15 00:45:00.000000', 'consum', 0.0212, 'lps'),
	(534461, 127, '2014-02-15 00:45:01.000000', 'consum', 0.0210, 'lps'),
	(534462, 127, '2014-02-15 00:45:02.000000', 'consum', 0.0217, 'lps'),
	(534463, 127, '2014-02-15 00:45:03.000000', 'consum', 0.0215, 'lps'),
	(534464, 127, '2014-02-15 00:45:04.000000', 'consum', 0.0216, 'lps'),
	(534465, 127, '2014-02-15 00:45:05.000000', 'consum', 0.0214, 'lps'),
	(534466, 127, '2014-02-15 00:45:06.000000', 'consum', 0.0214, 'lps'),
	(534467, 127, '2014-02-15 00:45:07.000000', 'consum', 0.0217, 'lps'),
	(534468, 127, '2014-02-15 00:45:08.000000', 'consum', 0.0213, 'lps'),
	(534469, 127, '2014-02-15 00:45:09.000000', 'consum', 0.0217, 'lps'),
	(534470, 127, '2014-02-15 00:45:10.000000', 'consum', 0.0215, 'lps'),
	(534471, 127, '2014-02-15 00:45:11.000000', 'consum', 0.0214, 'lps'),
	(534472, 127, '2014-02-15 00:45:12.000000', 'consum', 0.0214, 'lps'),
	(534473, 127, '2014-02-15 00:45:13.000000', 'consum', 0.0210, 'lps'),
	(534474, 127, '2014-02-15 00:45:14.000000', 'consum', 0.0217, 'lps'),
	(534475, 127, '2014-02-15 00:45:15.000000', 'consum', 0.0218, 'lps'),
	(534476, 127, '2014-02-15 00:45:16.000000', 'consum', 0.0219, 'lps'),
	(534477, 127, '2014-02-15 00:45:17.000000', 'consum', 0.0212, 'lps'),
	(534478, 127, '2014-02-15 00:45:18.000000', 'consum', 0.0214, 'lps'),
	(534479, 127, '2014-02-15 00:45:19.000000', 'consum', 0.0213, 'lps'),
	(534480, 127, '2014-02-15 00:45:20.000000', 'consum', 0.0215, 'lps'),
	(534481, 127, '2014-02-15 00:45:21.000000', 'consum', 0.0215, 'lps'),
	(534482, 127, '2014-02-15 00:45:22.000000', 'consum', 0.0212, 'lps'),
	(534483, 127, '2014-02-15 00:45:23.000000', 'consum', 0.0216, 'lps'),
	(534484, 127, '2014-02-15 00:45:24.000000', 'consum', 0.0212, 'lps'),
	(534485, 127, '2014-02-15 00:45:25.000000', 'consum', 0.0215, 'lps'),
	(534486, 127, '2014-02-15 00:45:26.000000', 'consum', 0.0218, 'lps'),
	(534487, 127, '2014-02-15 00:45:27.000000', 'consum', 0.0216, 'lps'),
	(534488, 127, '2014-02-15 00:45:28.000000', 'consum', 0.0216, 'lps'),
	(534489, 127, '2014-02-15 00:45:29.000000', 'consum', 0.0213, 'lps'),
	(534490, 127, '2014-02-15 00:45:30.000000', 'consum', 0.0217, 'lps'),
	(534491, 127, '2014-02-15 00:45:31.000000', 'consum', 0.0219, 'lps'),
	(534492, 127, '2014-02-15 00:45:32.000000', 'consum', 0.0211, 'lps'),
	(534493, 127, '2014-02-15 00:45:33.000000', 'consum', 0.0210, 'lps'),
	(534494, 127, '2014-02-15 00:45:34.000000', 'consum', 0.0216, 'lps'),
	(534495, 127, '2014-02-15 00:45:35.000000', 'consum', 0.0210, 'lps'),
	(534496, 127, '2014-02-15 00:45:36.000000', 'consum', 0.0213, 'lps'),
	(534497, 127, '2014-02-15 00:45:37.000000', 'consum', 0.0214, 'lps'),
	(534498, 127, '2014-02-15 00:45:38.000000', 'consum', 0.0212, 'lps'),
	(534499, 127, '2014-02-15 00:45:39.000000', 'consum', 0.0211, 'lps'),
	(534500, 127, '2014-02-15 00:45:40.000000', 'consum', 0.0218, 'lps'),
	(534501, 127, '2014-02-15 00:45:41.000000', 'consum', 0.0216, 'lps'),
	(534502, 127, '2014-02-15 00:45:42.000000', 'consum', 0.0218, 'lps'),
	(534503, 127, '2014-02-15 00:45:43.000000', 'consum', 0.0212, 'lps'),
	(534504, 127, '2014-02-15 00:45:44.000000', 'consum', 0.0218, 'lps'),
	(534505, 127, '2014-02-15 00:45:45.000000', 'consum', 0.0215, 'lps'),
	(534506, 127, '2014-02-15 00:45:46.000000', 'consum', 0.0219, 'lps'),
	(534507, 127, '2014-02-15 00:45:47.000000', 'consum', 0.0219, 'lps'),
	(534508, 127, '2014-02-15 00:45:48.000000', 'consum', 0.0212, 'lps'),
	(534509, 127, '2014-02-15 00:45:49.000000', 'consum', 0.0213, 'lps'),
	(534510, 127, '2014-02-15 00:45:50.000000', 'consum', 0.0210, 'lps'),
	(534511, 127, '2014-02-15 00:45:51.000000', 'consum', 0.0210, 'lps'),
	(534512, 127, '2014-02-15 00:45:52.000000', 'consum', 0.0213, 'lps'),
	(534513, 127, '2014-02-15 00:45:53.000000', 'consum', 0.0214, 'lps'),
	(534514, 127, '2014-02-15 00:45:54.000000', 'consum', 0.0212, 'lps'),
	(534515, 127, '2014-02-15 00:45:55.000000', 'consum', 0.0210, 'lps'),
	(534516, 127, '2014-02-15 00:45:56.000000', 'consum', 0.0214, 'lps'),
	(534517, 127, '2014-02-15 00:45:57.000000', 'consum', 0.0210, 'lps'),
	(534518, 127, '2014-02-15 00:45:58.000000', 'consum', 0.0210, 'lps'),
	(534519, 127, '2014-02-15 00:45:59.000000', 'consum', 0.0210, 'lps'),
	(534520, 127, '2014-02-15 00:46:00.000000', 'consum', 0.0210, 'lps'),
	(534521, 127, '2014-02-15 00:46:01.000000', 'consum', 0.0212, 'lps'),
	(534522, 127, '2014-02-15 00:46:02.000000', 'consum', 0.0211, 'lps'),
	(534523, 127, '2014-02-15 00:46:03.000000', 'consum', 0.0219, 'lps'),
	(534524, 127, '2014-02-15 00:46:04.000000', 'consum', 0.0211, 'lps'),
	(534525, 127, '2014-02-15 00:46:05.000000', 'consum', 0.0210, 'lps'),
	(534526, 127, '2014-02-15 00:46:06.000000', 'consum', 0.0217, 'lps'),
	(534527, 127, '2014-02-15 00:46:07.000000', 'consum', 0.0217, 'lps'),
	(534528, 127, '2014-02-15 00:46:08.000000', 'consum', 0.0212, 'lps'),
	(534529, 127, '2014-02-15 00:46:09.000000', 'consum', 0.0211, 'lps'),
	(534530, 127, '2014-02-15 00:46:10.000000', 'consum', 0.0217, 'lps'),
	(534531, 127, '2014-02-15 00:46:11.000000', 'consum', 0.0214, 'lps'),
	(534532, 127, '2014-02-15 00:46:12.000000', 'consum', 0.0211, 'lps'),
	(534533, 127, '2014-02-15 00:46:13.000000', 'consum', 0.0213, 'lps'),
	(534534, 127, '2014-02-15 00:46:14.000000', 'consum', 0.0212, 'lps'),
	(534535, 127, '2014-02-15 00:46:15.000000', 'consum', 0.0211, 'lps'),
	(534536, 127, '2014-02-15 00:46:16.000000', 'consum', 0.0210, 'lps'),
	(534537, 127, '2014-02-15 00:46:17.000000', 'consum', 0.0219, 'lps'),
	(534538, 127, '2014-02-15 00:46:18.000000', 'consum', 0.0216, 'lps'),
	(534539, 127, '2014-02-15 00:46:19.000000', 'consum', 0.0213, 'lps'),
	(534540, 127, '2014-02-15 00:46:20.000000', 'consum', 0.0219, 'lps'),
	(534541, 127, '2014-02-15 00:46:21.000000', 'consum', 0.0216, 'lps'),
	(534542, 127, '2014-02-15 00:46:22.000000', 'consum', 0.0212, 'lps'),
	(534543, 127, '2014-02-15 00:46:23.000000', 'consum', 0.0212, 'lps'),
	(534544, 127, '2014-02-15 00:46:24.000000', 'consum', 0.0214, 'lps'),
	(534545, 127, '2014-02-15 00:46:25.000000', 'consum', 0.0216, 'lps'),
	(534546, 127, '2014-02-15 00:46:26.000000', 'consum', 0.0210, 'lps'),
	(534547, 127, '2014-02-15 00:46:27.000000', 'consum', 0.0219, 'lps'),
	(534548, 127, '2014-02-15 00:46:28.000000', 'consum', 0.0218, 'lps'),
	(534549, 127, '2014-02-15 00:46:29.000000', 'consum', 0.0212, 'lps'),
	(534550, 127, '2014-02-15 00:46:30.000000', 'consum', 0.0218, 'lps'),
	(534551, 127, '2014-02-15 00:46:31.000000', 'consum', 0.0215, 'lps'),
	(534552, 127, '2014-02-15 00:46:32.000000', 'consum', 0.0212, 'lps'),
	(534553, 127, '2014-02-15 00:46:33.000000', 'consum', 0.0213, 'lps'),
	(534554, 127, '2014-02-15 00:46:34.000000', 'consum', 0.0212, 'lps'),
	(534555, 127, '2014-02-15 00:46:35.000000', 'consum', 0.0212, 'lps'),
	(534556, 127, '2014-02-15 00:46:36.000000', 'consum', 0.0211, 'lps'),
	(534557, 127, '2014-02-15 00:46:37.000000', 'consum', 0.0213, 'lps'),
	(534558, 127, '2014-02-15 00:46:38.000000', 'consum', 0.0210, 'lps'),
	(534559, 127, '2014-02-15 00:46:39.000000', 'consum', 0.0214, 'lps'),
	(534560, 127, '2014-02-15 00:46:40.000000', 'consum', 0.0219, 'lps'),
	(534561, 127, '2014-02-15 00:46:41.000000', 'consum', 0.0213, 'lps'),
	(534562, 127, '2014-02-15 00:46:42.000000', 'consum', 0.0219, 'lps'),
	(534563, 127, '2014-02-15 00:46:43.000000', 'consum', 0.0218, 'lps'),
	(534564, 127, '2014-02-15 00:46:44.000000', 'consum', 0.0214, 'lps'),
	(534565, 127, '2014-02-15 00:46:45.000000', 'consum', 0.0216, 'lps'),
	(534566, 127, '2014-02-15 00:46:46.000000', 'consum', 0.0210, 'lps'),
	(534567, 127, '2014-02-15 00:46:47.000000', 'consum', 0.0210, 'lps'),
	(534568, 127, '2014-02-15 00:46:48.000000', 'consum', 0.0213, 'lps'),
	(534569, 127, '2014-02-15 00:46:49.000000', 'consum', 0.0215, 'lps'),
	(534570, 127, '2014-02-15 00:46:50.000000', 'consum', 0.0216, 'lps'),
	(534571, 127, '2014-02-15 00:46:51.000000', 'consum', 0.0217, 'lps'),
	(534572, 127, '2014-02-15 00:46:52.000000', 'consum', 0.0219, 'lps'),
	(534573, 127, '2014-02-15 00:46:53.000000', 'consum', 0.0211, 'lps'),
	(534574, 127, '2014-02-15 00:46:54.000000', 'consum', 0.0218, 'lps'),
	(534575, 127, '2014-02-15 00:46:55.000000', 'consum', 0.0210, 'lps'),
	(534576, 127, '2014-02-15 00:46:56.000000', 'consum', 0.0215, 'lps'),
	(534577, 127, '2014-02-15 00:46:57.000000', 'consum', 0.0214, 'lps'),
	(534578, 127, '2014-02-15 00:46:58.000000', 'consum', 0.0217, 'lps'),
	(534579, 127, '2014-02-15 00:46:59.000000', 'consum', 0.0212, 'lps'),
	(534580, 127, '2014-02-15 00:47:00.000000', 'consum', 0.0219, 'lps'),
	(534581, 127, '2014-02-15 00:47:01.000000', 'consum', 0.0210, 'lps'),
	(534582, 127, '2014-02-15 00:47:02.000000', 'consum', 0.0212, 'lps'),
	(534583, 127, '2014-02-15 00:47:03.000000', 'consum', 0.0212, 'lps'),
	(534584, 127, '2014-02-15 00:47:04.000000', 'consum', 0.0213, 'lps'),
	(534585, 127, '2014-02-15 00:47:05.000000', 'consum', 0.0219, 'lps'),
	(534586, 127, '2014-02-15 00:47:06.000000', 'consum', 0.0218, 'lps'),
	(534587, 127, '2014-02-15 00:47:07.000000', 'consum', 0.0211, 'lps'),
	(534588, 127, '2014-02-15 00:47:08.000000', 'consum', 0.0214, 'lps'),
	(534589, 127, '2014-02-15 00:47:09.000000', 'consum', 0.0219, 'lps'),
	(534590, 127, '2014-02-15 00:47:10.000000', 'consum', 0.0211, 'lps'),
	(534591, 127, '2014-02-15 00:47:11.000000', 'consum', 0.0218, 'lps'),
	(534592, 127, '2014-02-15 00:47:12.000000', 'consum', 0.0210, 'lps'),
	(534593, 127, '2014-02-15 00:47:13.000000', 'consum', 0.0215, 'lps'),
	(534594, 127, '2014-02-15 00:47:14.000000', 'consum', 0.0217, 'lps'),
	(534595, 127, '2014-02-15 00:47:15.000000', 'consum', 0.0210, 'lps'),
	(534596, 127, '2014-02-15 00:47:16.000000', 'consum', 0.0217, 'lps'),
	(534597, 127, '2014-02-15 00:47:17.000000', 'consum', 0.0218, 'lps'),
	(534598, 127, '2014-02-15 00:47:18.000000', 'consum', 0.0218, 'lps'),
	(534599, 127, '2014-02-15 00:47:19.000000', 'consum', 0.0216, 'lps'),
	(534600, 127, '2014-02-15 00:47:20.000000', 'consum', 0.0217, 'lps'),
	(534601, 127, '2014-02-15 00:47:21.000000', 'consum', 0.0216, 'lps'),
	(534602, 127, '2014-02-15 00:47:22.000000', 'consum', 0.0210, 'lps'),
	(534603, 127, '2014-02-15 00:47:23.000000', 'consum', 0.0213, 'lps'),
	(534604, 127, '2014-02-15 00:47:24.000000', 'consum', 0.0215, 'lps'),
	(534605, 127, '2014-02-15 00:47:25.000000', 'consum', 0.0218, 'lps'),
	(534606, 127, '2014-02-15 00:47:26.000000', 'consum', 0.0216, 'lps'),
	(534607, 127, '2014-02-15 00:47:27.000000', 'consum', 0.0217, 'lps'),
	(534608, 127, '2014-02-15 00:47:28.000000', 'consum', 0.0215, 'lps'),
	(534609, 127, '2014-02-15 00:47:29.000000', 'consum', 0.0214, 'lps'),
	(534610, 127, '2014-02-15 00:47:30.000000', 'consum', 0.0218, 'lps'),
	(534611, 127, '2014-02-15 00:47:31.000000', 'consum', 0.0216, 'lps'),
	(534612, 127, '2014-02-15 00:47:32.000000', 'consum', 0.0216, 'lps'),
	(534613, 127, '2014-02-15 00:47:33.000000', 'consum', 0.0214, 'lps'),
	(534614, 127, '2014-02-15 00:47:34.000000', 'consum', 0.0210, 'lps'),
	(534615, 127, '2014-02-15 00:47:35.000000', 'consum', 0.0212, 'lps'),
	(534616, 127, '2014-02-15 00:47:36.000000', 'consum', 0.0219, 'lps'),
	(534617, 127, '2014-02-15 00:47:37.000000', 'consum', 0.0210, 'lps'),
	(534618, 127, '2014-02-15 00:47:38.000000', 'consum', 0.0214, 'lps'),
	(534619, 127, '2014-02-15 00:47:39.000000', 'consum', 0.0212, 'lps'),
	(534620, 127, '2014-02-15 00:47:40.000000', 'consum', 0.0216, 'lps'),
	(534621, 127, '2014-02-15 00:47:41.000000', 'consum', 0.0214, 'lps'),
	(534622, 127, '2014-02-15 00:47:42.000000', 'consum', 0.0215, 'lps'),
	(534623, 127, '2014-02-15 00:47:43.000000', 'consum', 0.0213, 'lps'),
	(534624, 127, '2014-02-15 00:47:44.000000', 'consum', 0.0210, 'lps'),
	(534625, 127, '2014-02-15 00:47:45.000000', 'consum', 0.0210, 'lps'),
	(534626, 127, '2014-02-15 00:47:46.000000', 'consum', 0.0210, 'lps'),
	(534627, 127, '2014-02-15 00:47:47.000000', 'consum', 0.0210, 'lps'),
	(534628, 127, '2014-02-15 00:47:48.000000', 'consum', 0.0210, 'lps'),
	(534629, 127, '2014-02-15 00:47:49.000000', 'consum', 0.0212, 'lps'),
	(534630, 127, '2014-02-15 00:47:50.000000', 'consum', 0.0211, 'lps'),
	(534631, 127, '2014-02-15 00:47:51.000000', 'consum', 0.0211, 'lps'),
	(534632, 127, '2014-02-15 00:47:52.000000', 'consum', 0.0211, 'lps'),
	(534633, 127, '2014-02-15 00:47:53.000000', 'consum', 0.0212, 'lps'),
	(534634, 127, '2014-02-15 00:47:54.000000', 'consum', 0.0216, 'lps'),
	(534635, 127, '2014-02-15 00:47:55.000000', 'consum', 0.0217, 'lps'),
	(534636, 127, '2014-02-15 00:47:56.000000', 'consum', 0.0216, 'lps'),
	(534637, 127, '2014-02-15 00:47:57.000000', 'consum', 0.0210, 'lps'),
	(534638, 127, '2014-02-15 00:47:58.000000', 'consum', 0.0211, 'lps'),
	(534639, 127, '2014-02-15 00:47:59.000000', 'consum', 0.0218, 'lps'),
	(534640, 127, '2014-02-15 00:48:00.000000', 'consum', 0.0217, 'lps'),
	(534641, 127, '2014-02-15 00:48:01.000000', 'consum', 0.0211, 'lps'),
	(534642, 127, '2014-02-15 00:48:02.000000', 'consum', 0.0214, 'lps'),
	(534643, 127, '2014-02-15 00:48:03.000000', 'consum', 0.0217, 'lps'),
	(534644, 127, '2014-02-15 00:48:04.000000', 'consum', 0.0213, 'lps'),
	(534645, 127, '2014-02-15 00:48:05.000000', 'consum', 0.0217, 'lps'),
	(534646, 127, '2014-02-15 00:48:06.000000', 'consum', 0.0215, 'lps'),
	(534647, 127, '2014-02-15 00:48:07.000000', 'consum', 0.0213, 'lps'),
	(534648, 127, '2014-02-15 00:48:08.000000', 'consum', 0.0213, 'lps'),
	(534649, 127, '2014-02-15 00:48:09.000000', 'consum', 0.0217, 'lps'),
	(534650, 127, '2014-02-15 00:48:10.000000', 'consum', 0.0214, 'lps'),
	(534651, 127, '2014-02-15 00:48:11.000000', 'consum', 0.0219, 'lps'),
	(534652, 127, '2014-02-15 00:48:12.000000', 'consum', 0.0215, 'lps'),
	(534653, 127, '2014-02-15 00:48:13.000000', 'consum', 0.0219, 'lps'),
	(534654, 127, '2014-02-15 00:48:14.000000', 'consum', 0.0212, 'lps'),
	(534655, 127, '2014-02-15 00:48:15.000000', 'consum', 0.0211, 'lps'),
	(534656, 127, '2014-02-15 00:48:16.000000', 'consum', 0.0211, 'lps'),
	(534657, 127, '2014-02-15 00:48:17.000000', 'consum', 0.0212, 'lps'),
	(534658, 127, '2014-02-15 00:48:18.000000', 'consum', 0.0219, 'lps'),
	(534659, 127, '2014-02-15 00:48:19.000000', 'consum', 0.0218, 'lps'),
	(534660, 127, '2014-02-15 00:48:20.000000', 'consum', 0.0212, 'lps'),
	(534661, 127, '2014-02-15 00:48:21.000000', 'consum', 0.0210, 'lps'),
	(534662, 127, '2014-02-15 00:48:22.000000', 'consum', 0.0212, 'lps'),
	(534663, 127, '2014-02-15 00:48:23.000000', 'consum', 0.0219, 'lps'),
	(534664, 127, '2014-02-15 00:48:24.000000', 'consum', 0.0211, 'lps'),
	(534665, 127, '2014-02-15 00:48:25.000000', 'consum', 0.0210, 'lps'),
	(534666, 127, '2014-02-15 00:48:26.000000', 'consum', 0.0218, 'lps'),
	(534667, 127, '2014-02-15 00:48:27.000000', 'consum', 0.0210, 'lps'),
	(534668, 127, '2014-02-15 00:48:28.000000', 'consum', 0.0215, 'lps'),
	(534669, 127, '2014-02-15 00:48:29.000000', 'consum', 0.0214, 'lps'),
	(534670, 127, '2014-02-15 00:48:30.000000', 'consum', 0.0219, 'lps'),
	(534671, 127, '2014-02-15 00:48:31.000000', 'consum', 0.0210, 'lps'),
	(534672, 127, '2014-02-15 00:48:32.000000', 'consum', 0.0217, 'lps'),
	(534673, 127, '2014-02-15 00:48:33.000000', 'consum', 0.0215, 'lps'),
	(534674, 127, '2014-02-15 00:48:34.000000', 'consum', 0.0212, 'lps'),
	(534675, 127, '2014-02-15 00:48:35.000000', 'consum', 0.0217, 'lps'),
	(534676, 127, '2014-02-15 00:48:36.000000', 'consum', 0.0219, 'lps'),
	(534677, 127, '2014-02-15 00:48:37.000000', 'consum', 0.0216, 'lps'),
	(534678, 127, '2014-02-15 00:48:38.000000', 'consum', 0.0214, 'lps'),
	(534679, 127, '2014-02-15 00:48:39.000000', 'consum', 0.0213, 'lps'),
	(534680, 127, '2014-02-15 00:48:40.000000', 'consum', 0.0211, 'lps'),
	(534681, 127, '2014-02-15 00:48:41.000000', 'consum', 0.0219, 'lps'),
	(534682, 127, '2014-02-15 00:48:42.000000', 'consum', 0.0213, 'lps'),
	(534683, 127, '2014-02-15 00:48:43.000000', 'consum', 0.0219, 'lps'),
	(534684, 127, '2014-02-15 00:48:44.000000', 'consum', 0.0214, 'lps'),
	(534685, 127, '2014-02-15 00:48:45.000000', 'consum', 0.0215, 'lps'),
	(534686, 127, '2014-02-15 00:48:46.000000', 'consum', 0.0214, 'lps'),
	(534687, 127, '2014-02-15 00:48:47.000000', 'consum', 0.0217, 'lps'),
	(534688, 127, '2014-02-15 00:48:48.000000', 'consum', 0.0212, 'lps'),
	(534689, 127, '2014-02-15 00:48:49.000000', 'consum', 0.0210, 'lps'),
	(534690, 127, '2014-02-15 00:48:50.000000', 'consum', 0.0213, 'lps'),
	(534691, 127, '2014-02-15 00:48:51.000000', 'consum', 0.0214, 'lps'),
	(534692, 127, '2014-02-15 00:48:52.000000', 'consum', 0.0215, 'lps'),
	(534693, 127, '2014-02-15 00:48:53.000000', 'consum', 0.0213, 'lps'),
	(534694, 127, '2014-02-15 00:48:54.000000', 'consum', 0.0219, 'lps'),
	(534695, 127, '2014-02-15 00:48:55.000000', 'consum', 0.0215, 'lps'),
	(534696, 127, '2014-02-15 00:48:56.000000', 'consum', 0.0210, 'lps'),
	(534697, 127, '2014-02-15 00:48:57.000000', 'consum', 0.0216, 'lps'),
	(534698, 127, '2014-02-15 00:48:58.000000', 'consum', 0.0211, 'lps'),
	(534699, 127, '2014-02-15 00:48:59.000000', 'consum', 0.0215, 'lps'),
	(534700, 127, '2014-02-15 00:49:00.000000', 'consum', 0.0213, 'lps'),
	(534701, 127, '2014-02-15 00:49:01.000000', 'consum', 0.0213, 'lps'),
	(534702, 127, '2014-02-15 00:49:02.000000', 'consum', 0.0216, 'lps'),
	(534703, 127, '2014-02-15 00:49:03.000000', 'consum', 0.0210, 'lps'),
	(534704, 127, '2014-02-15 00:49:04.000000', 'consum', 0.0215, 'lps'),
	(534705, 127, '2014-02-15 00:49:05.000000', 'consum', 0.0215, 'lps'),
	(534706, 127, '2014-02-15 00:49:06.000000', 'consum', 0.0218, 'lps'),
	(534707, 127, '2014-02-15 00:49:07.000000', 'consum', 0.0218, 'lps'),
	(534708, 127, '2014-02-15 00:49:08.000000', 'consum', 0.0217, 'lps'),
	(534709, 127, '2014-02-15 00:49:09.000000', 'consum', 0.0218, 'lps'),
	(534710, 127, '2014-02-15 00:49:10.000000', 'consum', 0.0213, 'lps'),
	(534711, 127, '2014-02-15 00:49:11.000000', 'consum', 0.0211, 'lps'),
	(534712, 127, '2014-02-15 00:49:12.000000', 'consum', 0.0217, 'lps'),
	(534713, 127, '2014-02-15 00:49:13.000000', 'consum', 0.0213, 'lps'),
	(534714, 127, '2014-02-15 00:49:14.000000', 'consum', 0.0213, 'lps'),
	(534715, 127, '2014-02-15 00:49:15.000000', 'consum', 0.0218, 'lps'),
	(534716, 127, '2014-02-15 00:49:16.000000', 'consum', 0.0210, 'lps'),
	(534717, 127, '2014-02-15 00:49:17.000000', 'consum', 0.0219, 'lps'),
	(534718, 127, '2014-02-15 00:49:18.000000', 'consum', 0.0212, 'lps'),
	(534719, 127, '2014-02-15 00:49:19.000000', 'consum', 0.0215, 'lps'),
	(534720, 127, '2014-02-15 00:49:20.000000', 'consum', 0.0211, 'lps'),
	(534721, 127, '2014-02-15 00:49:21.000000', 'consum', 0.0211, 'lps'),
	(534722, 127, '2014-02-15 00:49:22.000000', 'consum', 0.0210, 'lps'),
	(534723, 127, '2014-02-15 00:49:23.000000', 'consum', 0.0216, 'lps'),
	(534724, 127, '2014-02-15 00:49:24.000000', 'consum', 0.0214, 'lps'),
	(534725, 127, '2014-02-15 00:49:25.000000', 'consum', 0.0210, 'lps'),
	(534726, 127, '2014-02-15 00:49:26.000000', 'consum', 0.0210, 'lps'),
	(534727, 127, '2014-02-15 00:49:27.000000', 'consum', 0.0218, 'lps'),
	(534728, 127, '2014-02-15 00:49:28.000000', 'consum', 0.0213, 'lps'),
	(534729, 127, '2014-02-15 00:49:29.000000', 'consum', 0.0211, 'lps'),
	(534730, 127, '2014-02-15 00:49:30.000000', 'consum', 0.0218, 'lps'),
	(534731, 127, '2014-02-15 00:49:31.000000', 'consum', 0.0216, 'lps'),
	(534732, 127, '2014-02-15 00:49:32.000000', 'consum', 0.0215, 'lps'),
	(534733, 127, '2014-02-15 00:49:33.000000', 'consum', 0.0211, 'lps'),
	(534734, 127, '2014-02-15 00:49:34.000000', 'consum', 0.0218, 'lps'),
	(534735, 127, '2014-02-15 00:49:35.000000', 'consum', 0.0219, 'lps'),
	(534736, 127, '2014-02-15 00:49:36.000000', 'consum', 0.0219, 'lps'),
	(534737, 127, '2014-02-15 00:49:37.000000', 'consum', 0.0211, 'lps'),
	(534738, 127, '2014-02-15 00:49:38.000000', 'consum', 0.0219, 'lps'),
	(534739, 127, '2014-02-15 00:49:39.000000', 'consum', 0.0214, 'lps'),
	(534740, 127, '2014-02-15 00:49:40.000000', 'consum', 0.0210, 'lps'),
	(534741, 127, '2014-02-15 00:49:41.000000', 'consum', 0.0210, 'lps'),
	(534742, 127, '2014-02-15 00:49:42.000000', 'consum', 0.0219, 'lps'),
	(534743, 127, '2014-02-15 00:49:43.000000', 'consum', 0.0218, 'lps'),
	(534744, 127, '2014-02-15 00:49:44.000000', 'consum', 0.0210, 'lps'),
	(534745, 127, '2014-02-15 00:49:45.000000', 'consum', 0.0210, 'lps'),
	(534746, 127, '2014-02-15 00:49:46.000000', 'consum', 0.0218, 'lps'),
	(534747, 127, '2014-02-15 00:49:47.000000', 'consum', 0.0212, 'lps'),
	(534748, 127, '2014-02-15 00:49:48.000000', 'consum', 0.0218, 'lps'),
	(534749, 127, '2014-02-15 00:49:49.000000', 'consum', 0.0212, 'lps'),
	(534750, 127, '2014-02-15 00:49:50.000000', 'consum', 0.0216, 'lps'),
	(534751, 127, '2014-02-15 00:49:51.000000', 'consum', 0.0215, 'lps'),
	(534752, 127, '2014-02-15 00:49:52.000000', 'consum', 0.0219, 'lps'),
	(534753, 127, '2014-02-15 00:49:53.000000', 'consum', 0.0219, 'lps'),
	(534754, 127, '2014-02-15 00:49:54.000000', 'consum', 0.0211, 'lps'),
	(534755, 127, '2014-02-15 00:49:55.000000', 'consum', 0.0215, 'lps'),
	(534756, 127, '2014-02-15 00:49:56.000000', 'consum', 0.0214, 'lps'),
	(534757, 127, '2014-02-15 00:49:57.000000', 'consum', 0.0215, 'lps'),
	(534758, 127, '2014-02-15 00:49:58.000000', 'consum', 0.0213, 'lps'),
	(534759, 127, '2014-02-15 00:49:59.000000', 'consum', 0.0211, 'lps'),
	(534760, 127, '2014-02-15 00:50:00.000000', 'consum', 0.0218, 'lps'),
	(534761, 127, '2014-02-15 00:50:01.000000', 'consum', 0.0218, 'lps'),
	(534762, 127, '2014-02-15 00:50:02.000000', 'consum', 0.0217, 'lps'),
	(534763, 127, '2014-02-15 00:50:03.000000', 'consum', 0.0219, 'lps'),
	(534764, 127, '2014-02-15 00:50:04.000000', 'consum', 0.0217, 'lps'),
	(534765, 127, '2014-02-15 00:50:05.000000', 'consum', 0.0217, 'lps'),
	(534766, 127, '2014-02-15 00:50:06.000000', 'consum', 0.0214, 'lps'),
	(534767, 127, '2014-02-15 00:50:07.000000', 'consum', 0.0210, 'lps'),
	(534768, 127, '2014-02-15 00:50:08.000000', 'consum', 0.0217, 'lps'),
	(534769, 127, '2014-02-15 00:50:09.000000', 'consum', 0.0216, 'lps'),
	(534770, 127, '2014-02-15 00:50:10.000000', 'consum', 0.0211, 'lps'),
	(534771, 127, '2014-02-15 00:50:11.000000', 'consum', 0.0218, 'lps'),
	(534772, 127, '2014-02-15 00:50:12.000000', 'consum', 0.0218, 'lps'),
	(534773, 127, '2014-02-15 00:50:13.000000', 'consum', 0.0215, 'lps'),
	(534774, 127, '2014-02-15 00:50:14.000000', 'consum', 0.0214, 'lps'),
	(534775, 127, '2014-02-15 00:50:15.000000', 'consum', 0.0213, 'lps'),
	(534776, 127, '2014-02-15 00:50:16.000000', 'consum', 0.0213, 'lps'),
	(534777, 127, '2014-02-15 00:50:17.000000', 'consum', 0.0215, 'lps'),
	(534778, 127, '2014-02-15 00:50:18.000000', 'consum', 0.0219, 'lps'),
	(534779, 127, '2014-02-15 00:50:19.000000', 'consum', 0.0211, 'lps'),
	(534780, 127, '2014-02-15 00:50:20.000000', 'consum', 0.0219, 'lps'),
	(534781, 127, '2014-02-15 00:50:21.000000', 'consum', 0.0210, 'lps'),
	(534782, 127, '2014-02-15 00:50:22.000000', 'consum', 0.0213, 'lps'),
	(534783, 127, '2014-02-15 00:50:23.000000', 'consum', 0.0217, 'lps'),
	(534784, 127, '2014-02-15 00:50:24.000000', 'consum', 0.0215, 'lps'),
	(534785, 127, '2014-02-15 00:50:25.000000', 'consum', 0.0214, 'lps'),
	(534786, 127, '2014-02-15 00:50:26.000000', 'consum', 0.0216, 'lps'),
	(534787, 127, '2014-02-15 00:50:27.000000', 'consum', 0.0219, 'lps'),
	(534788, 127, '2014-02-15 00:50:28.000000', 'consum', 0.0219, 'lps'),
	(534789, 127, '2014-02-15 00:50:29.000000', 'consum', 0.0218, 'lps'),
	(534790, 127, '2014-02-15 00:50:30.000000', 'consum', 0.0212, 'lps'),
	(534791, 127, '2014-02-15 00:50:31.000000', 'consum', 0.0219, 'lps'),
	(534792, 127, '2014-02-15 00:50:32.000000', 'consum', 0.0218, 'lps'),
	(534793, 127, '2014-02-15 00:50:33.000000', 'consum', 0.0214, 'lps'),
	(534794, 127, '2014-02-15 00:50:34.000000', 'consum', 0.0216, 'lps'),
	(534795, 127, '2014-02-15 00:50:35.000000', 'consum', 0.0218, 'lps'),
	(534796, 127, '2014-02-15 00:50:36.000000', 'consum', 0.0215, 'lps'),
	(534797, 127, '2014-02-15 00:50:37.000000', 'consum', 0.0211, 'lps'),
	(534798, 127, '2014-02-15 00:50:38.000000', 'consum', 0.0218, 'lps'),
	(534799, 127, '2014-02-15 00:50:39.000000', 'consum', 0.0218, 'lps'),
	(534800, 127, '2014-02-15 00:50:40.000000', 'consum', 0.0216, 'lps'),
	(534801, 127, '2014-02-15 00:50:41.000000', 'consum', 0.0219, 'lps'),
	(534802, 127, '2014-02-15 00:50:42.000000', 'consum', 0.0218, 'lps'),
	(534803, 127, '2014-02-15 00:50:43.000000', 'consum', 0.0211, 'lps'),
	(534804, 127, '2014-02-15 00:50:44.000000', 'consum', 0.0211, 'lps'),
	(534805, 127, '2014-02-15 00:50:45.000000', 'consum', 0.0212, 'lps'),
	(534806, 127, '2014-02-15 00:50:46.000000', 'consum', 0.0218, 'lps'),
	(534807, 127, '2014-02-15 00:50:47.000000', 'consum', 0.0215, 'lps'),
	(534808, 127, '2014-02-15 00:50:48.000000', 'consum', 0.0219, 'lps'),
	(534809, 127, '2014-02-15 00:50:49.000000', 'consum', 0.0214, 'lps'),
	(534810, 127, '2014-02-15 00:50:50.000000', 'consum', 0.0212, 'lps'),
	(534811, 127, '2014-02-15 00:50:51.000000', 'consum', 0.0217, 'lps'),
	(534812, 127, '2014-02-15 00:50:52.000000', 'consum', 0.0219, 'lps'),
	(534813, 127, '2014-02-15 00:50:53.000000', 'consum', 0.0214, 'lps'),
	(534814, 127, '2014-02-15 00:50:54.000000', 'consum', 0.0214, 'lps'),
	(534815, 127, '2014-02-15 00:50:55.000000', 'consum', 0.0219, 'lps'),
	(534816, 127, '2014-02-15 00:50:56.000000', 'consum', 0.0212, 'lps'),
	(534817, 127, '2014-02-15 00:50:57.000000', 'consum', 0.0215, 'lps'),
	(534818, 127, '2014-02-15 00:50:58.000000', 'consum', 0.0211, 'lps'),
	(534819, 127, '2014-02-15 00:50:59.000000', 'consum', 0.0210, 'lps'),
	(534820, 127, '2014-02-15 00:51:00.000000', 'consum', 0.0215, 'lps'),
	(534821, 127, '2014-02-15 00:51:01.000000', 'consum', 0.0218, 'lps'),
	(534822, 127, '2014-02-15 00:51:02.000000', 'consum', 0.0214, 'lps'),
	(534823, 127, '2014-02-15 00:51:03.000000', 'consum', 0.0216, 'lps'),
	(534824, 127, '2014-02-15 00:51:04.000000', 'consum', 0.0218, 'lps'),
	(534825, 127, '2014-02-15 00:51:05.000000', 'consum', 0.0214, 'lps'),
	(534826, 127, '2014-02-15 00:51:06.000000', 'consum', 0.0218, 'lps'),
	(534827, 127, '2014-02-15 00:51:07.000000', 'consum', 0.0216, 'lps'),
	(534828, 127, '2014-02-15 00:51:08.000000', 'consum', 0.0219, 'lps'),
	(534829, 127, '2014-02-15 00:51:09.000000', 'consum', 0.0216, 'lps'),
	(534830, 127, '2014-02-15 00:51:10.000000', 'consum', 0.0214, 'lps'),
	(534831, 127, '2014-02-15 00:51:11.000000', 'consum', 0.0212, 'lps'),
	(534832, 127, '2014-02-15 00:51:12.000000', 'consum', 0.0219, 'lps'),
	(534833, 127, '2014-02-15 00:51:13.000000', 'consum', 0.0211, 'lps'),
	(534834, 127, '2014-02-15 00:51:14.000000', 'consum', 0.0217, 'lps'),
	(534835, 127, '2014-02-15 00:51:15.000000', 'consum', 0.0213, 'lps'),
	(534836, 127, '2014-02-15 00:51:16.000000', 'consum', 0.0214, 'lps'),
	(534837, 127, '2014-02-15 00:51:17.000000', 'consum', 0.0213, 'lps'),
	(534838, 127, '2014-02-15 00:51:18.000000', 'consum', 0.0213, 'lps'),
	(534839, 127, '2014-02-15 00:51:19.000000', 'consum', 0.0216, 'lps'),
	(534840, 127, '2014-02-15 00:51:20.000000', 'consum', 0.0210, 'lps'),
	(534841, 127, '2014-02-15 00:51:21.000000', 'consum', 0.0213, 'lps'),
	(534842, 127, '2014-02-15 00:51:22.000000', 'consum', 0.0216, 'lps'),
	(534843, 127, '2014-02-15 00:51:23.000000', 'consum', 0.0213, 'lps'),
	(534844, 127, '2014-02-15 00:51:24.000000', 'consum', 0.0214, 'lps'),
	(534845, 127, '2014-02-15 00:51:25.000000', 'consum', 0.0215, 'lps'),
	(534846, 127, '2014-02-15 00:51:26.000000', 'consum', 0.0212, 'lps'),
	(534847, 127, '2014-02-15 00:51:27.000000', 'consum', 0.0217, 'lps'),
	(534848, 127, '2014-02-15 00:51:28.000000', 'consum', 0.0218, 'lps'),
	(534849, 127, '2014-02-15 00:51:29.000000', 'consum', 0.0219, 'lps'),
	(534850, 127, '2014-02-15 00:51:30.000000', 'consum', 0.0211, 'lps'),
	(534851, 127, '2014-02-15 00:51:31.000000', 'consum', 0.0219, 'lps'),
	(534852, 127, '2014-02-15 00:51:32.000000', 'consum', 0.0214, 'lps'),
	(534853, 127, '2014-02-15 00:51:33.000000', 'consum', 0.0211, 'lps'),
	(534854, 127, '2014-02-15 00:51:34.000000', 'consum', 0.0215, 'lps'),
	(534855, 127, '2014-02-15 00:51:35.000000', 'consum', 0.0212, 'lps'),
	(534856, 127, '2014-02-15 00:51:36.000000', 'consum', 0.0216, 'lps'),
	(534857, 127, '2014-02-15 00:51:37.000000', 'consum', 0.0216, 'lps'),
	(534858, 127, '2014-02-15 00:51:38.000000', 'consum', 0.0210, 'lps'),
	(534859, 127, '2014-02-15 00:51:39.000000', 'consum', 0.0214, 'lps'),
	(534860, 127, '2014-02-15 00:51:40.000000', 'consum', 0.0212, 'lps'),
	(534861, 127, '2014-02-15 00:51:41.000000', 'consum', 0.0216, 'lps'),
	(534862, 127, '2014-02-15 00:51:42.000000', 'consum', 0.0216, 'lps'),
	(534863, 127, '2014-02-15 00:51:43.000000', 'consum', 0.0212, 'lps'),
	(534864, 127, '2014-02-15 00:51:44.000000', 'consum', 0.0213, 'lps'),
	(534865, 127, '2014-02-15 00:51:45.000000', 'consum', 0.0219, 'lps'),
	(534866, 127, '2014-02-15 00:51:46.000000', 'consum', 0.0219, 'lps'),
	(534867, 127, '2014-02-15 00:51:47.000000', 'consum', 0.0215, 'lps'),
	(534868, 127, '2014-02-15 00:51:48.000000', 'consum', 0.0219, 'lps'),
	(534869, 127, '2014-02-15 00:51:49.000000', 'consum', 0.0213, 'lps'),
	(534870, 127, '2014-02-15 00:51:50.000000', 'consum', 0.0216, 'lps'),
	(534871, 127, '2014-02-15 00:51:51.000000', 'consum', 0.0214, 'lps'),
	(534872, 127, '2014-02-15 00:51:52.000000', 'consum', 0.0213, 'lps'),
	(534873, 127, '2014-02-15 00:51:53.000000', 'consum', 0.0212, 'lps'),
	(534874, 127, '2014-02-15 00:51:54.000000', 'consum', 0.0212, 'lps'),
	(534875, 127, '2014-02-15 00:51:55.000000', 'consum', 0.0214, 'lps'),
	(534876, 127, '2014-02-15 00:51:56.000000', 'consum', 0.0217, 'lps'),
	(534877, 127, '2014-02-15 00:51:57.000000', 'consum', 0.0210, 'lps'),
	(534878, 127, '2014-02-15 00:51:58.000000', 'consum', 0.0213, 'lps'),
	(534879, 127, '2014-02-15 00:51:59.000000', 'consum', 0.0212, 'lps'),
	(534880, 127, '2014-02-15 00:52:00.000000', 'consum', 0.0213, 'lps'),
	(534881, 127, '2014-02-15 00:52:01.000000', 'consum', 0.0210, 'lps'),
	(534882, 127, '2014-02-15 00:52:02.000000', 'consum', 0.0212, 'lps'),
	(534883, 127, '2014-02-15 00:52:03.000000', 'consum', 0.0211, 'lps'),
	(534884, 127, '2014-02-15 00:52:04.000000', 'consum', 0.0218, 'lps'),
	(534885, 127, '2014-02-15 00:52:05.000000', 'consum', 0.0219, 'lps'),
	(534886, 127, '2014-02-15 00:52:06.000000', 'consum', 0.0210, 'lps'),
	(534887, 127, '2014-02-15 00:52:07.000000', 'consum', 0.0216, 'lps'),
	(534888, 127, '2014-02-15 00:52:08.000000', 'consum', 0.0219, 'lps'),
	(534889, 127, '2014-02-15 00:52:09.000000', 'consum', 0.0210, 'lps'),
	(534890, 127, '2014-02-15 00:52:10.000000', 'consum', 0.0210, 'lps'),
	(534891, 127, '2014-02-15 00:52:11.000000', 'consum', 0.0211, 'lps'),
	(534892, 127, '2014-02-15 00:52:12.000000', 'consum', 0.0215, 'lps'),
	(534893, 127, '2014-02-15 00:52:13.000000', 'consum', 0.0213, 'lps'),
	(534894, 127, '2014-02-15 00:52:14.000000', 'consum', 0.0212, 'lps'),
	(534895, 127, '2014-02-15 00:52:15.000000', 'consum', 0.0212, 'lps'),
	(534896, 127, '2014-02-15 00:52:16.000000', 'consum', 0.0212, 'lps'),
	(534897, 127, '2014-02-15 00:52:17.000000', 'consum', 0.0215, 'lps'),
	(534898, 127, '2014-02-15 00:52:18.000000', 'consum', 0.0211, 'lps'),
	(534899, 127, '2014-02-15 00:52:19.000000', 'consum', 0.0210, 'lps'),
	(534900, 127, '2014-02-15 00:52:20.000000', 'consum', 0.0218, 'lps'),
	(534901, 127, '2014-02-15 00:52:21.000000', 'consum', 0.0211, 'lps'),
	(534902, 127, '2014-02-15 00:52:22.000000', 'consum', 0.0211, 'lps'),
	(534903, 127, '2014-02-15 00:52:23.000000', 'consum', 0.0210, 'lps'),
	(534904, 127, '2014-02-15 00:52:24.000000', 'consum', 0.0210, 'lps'),
	(534905, 127, '2014-02-15 00:52:25.000000', 'consum', 0.0211, 'lps'),
	(534906, 127, '2014-02-15 00:52:26.000000', 'consum', 0.0215, 'lps'),
	(534907, 127, '2014-02-15 00:52:27.000000', 'consum', 0.0212, 'lps'),
	(534908, 127, '2014-02-15 00:52:28.000000', 'consum', 0.0217, 'lps'),
	(534909, 127, '2014-02-15 00:52:29.000000', 'consum', 0.0219, 'lps'),
	(534910, 127, '2014-02-15 00:52:30.000000', 'consum', 0.0215, 'lps'),
	(534911, 127, '2014-02-15 00:52:31.000000', 'consum', 0.0210, 'lps'),
	(534912, 127, '2014-02-15 00:52:32.000000', 'consum', 0.0212, 'lps'),
	(534913, 127, '2014-02-15 00:52:33.000000', 'consum', 0.0213, 'lps'),
	(534914, 127, '2014-02-15 00:52:34.000000', 'consum', 0.0218, 'lps'),
	(534915, 127, '2014-02-15 00:52:35.000000', 'consum', 0.0214, 'lps'),
	(534916, 127, '2014-02-15 00:52:36.000000', 'consum', 0.0215, 'lps'),
	(534917, 127, '2014-02-15 00:52:37.000000', 'consum', 0.0214, 'lps'),
	(534918, 127, '2014-02-15 00:52:38.000000', 'consum', 0.0216, 'lps'),
	(534919, 127, '2014-02-15 00:52:39.000000', 'consum', 0.0218, 'lps'),
	(534920, 127, '2014-02-15 00:52:40.000000', 'consum', 0.0214, 'lps'),
	(534921, 127, '2014-02-15 00:52:41.000000', 'consum', 0.0214, 'lps'),
	(534922, 127, '2014-02-15 00:52:42.000000', 'consum', 0.0219, 'lps'),
	(534923, 127, '2014-02-15 00:52:43.000000', 'consum', 0.0212, 'lps'),
	(534924, 127, '2014-02-15 00:52:44.000000', 'consum', 0.0216, 'lps'),
	(534925, 127, '2014-02-15 00:52:45.000000', 'consum', 0.0213, 'lps'),
	(534926, 127, '2014-02-15 00:52:46.000000', 'consum', 0.0219, 'lps'),
	(534927, 127, '2014-02-15 00:52:47.000000', 'consum', 0.0215, 'lps'),
	(534928, 127, '2014-02-15 00:52:48.000000', 'consum', 0.0218, 'lps'),
	(534929, 127, '2014-02-15 00:52:49.000000', 'consum', 0.0214, 'lps'),
	(534930, 127, '2014-02-15 00:52:50.000000', 'consum', 0.0210, 'lps'),
	(534931, 127, '2014-02-15 00:52:51.000000', 'consum', 0.0216, 'lps'),
	(534932, 127, '2014-02-15 00:52:52.000000', 'consum', 0.0213, 'lps'),
	(534933, 127, '2014-02-15 00:52:53.000000', 'consum', 0.0214, 'lps'),
	(534934, 127, '2014-02-15 00:52:54.000000', 'consum', 0.0215, 'lps'),
	(534935, 127, '2014-02-15 00:52:55.000000', 'consum', 0.0211, 'lps'),
	(534936, 127, '2014-02-15 00:52:56.000000', 'consum', 0.0212, 'lps'),
	(534937, 127, '2014-02-15 00:52:57.000000', 'consum', 0.0217, 'lps'),
	(534938, 127, '2014-02-15 00:52:58.000000', 'consum', 0.0219, 'lps'),
	(534939, 127, '2014-02-15 00:52:59.000000', 'consum', 0.0214, 'lps'),
	(534940, 127, '2014-02-15 00:53:00.000000', 'consum', 0.0216, 'lps'),
	(534941, 127, '2014-02-15 00:53:01.000000', 'consum', 0.0218, 'lps'),
	(534942, 127, '2014-02-15 00:53:02.000000', 'consum', 0.0212, 'lps'),
	(534943, 127, '2014-02-15 00:53:03.000000', 'consum', 0.0216, 'lps'),
	(534944, 127, '2014-02-15 00:53:04.000000', 'consum', 0.0216, 'lps'),
	(534945, 127, '2014-02-15 00:53:05.000000', 'consum', 0.0213, 'lps'),
	(534946, 127, '2014-02-15 00:53:06.000000', 'consum', 0.0218, 'lps'),
	(534947, 127, '2014-02-15 00:53:07.000000', 'consum', 0.0213, 'lps'),
	(534948, 127, '2014-02-15 00:53:08.000000', 'consum', 0.0218, 'lps'),
	(534949, 127, '2014-02-15 00:53:09.000000', 'consum', 0.0212, 'lps'),
	(534950, 127, '2014-02-15 00:53:10.000000', 'consum', 0.0218, 'lps'),
	(534951, 127, '2014-02-15 00:53:11.000000', 'consum', 0.0215, 'lps'),
	(534952, 127, '2014-02-15 00:53:12.000000', 'consum', 0.0210, 'lps'),
	(534953, 127, '2014-02-15 00:53:13.000000', 'consum', 0.0215, 'lps'),
	(534954, 127, '2014-02-15 00:53:14.000000', 'consum', 0.0215, 'lps'),
	(534955, 127, '2014-02-15 00:53:15.000000', 'consum', 0.0213, 'lps'),
	(534956, 127, '2014-02-15 00:53:16.000000', 'consum', 0.0217, 'lps'),
	(534957, 127, '2014-02-15 00:53:17.000000', 'consum', 0.0210, 'lps'),
	(534958, 127, '2014-02-15 00:53:18.000000', 'consum', 0.0219, 'lps'),
	(534959, 127, '2014-02-15 00:53:19.000000', 'consum', 0.0216, 'lps'),
	(534960, 127, '2014-02-15 00:53:20.000000', 'consum', 0.0214, 'lps'),
	(534961, 127, '2014-02-15 00:53:21.000000', 'consum', 0.0211, 'lps'),
	(534962, 127, '2014-02-15 00:53:22.000000', 'consum', 0.0213, 'lps'),
	(534963, 127, '2014-02-15 00:53:23.000000', 'consum', 0.0214, 'lps'),
	(534964, 127, '2014-02-15 00:53:24.000000', 'consum', 0.0219, 'lps'),
	(534965, 127, '2014-02-15 00:53:25.000000', 'consum', 0.0214, 'lps'),
	(534966, 127, '2014-02-15 00:53:26.000000', 'consum', 0.0214, 'lps'),
	(534967, 127, '2014-02-15 00:53:27.000000', 'consum', 0.0210, 'lps'),
	(534968, 127, '2014-02-15 00:53:28.000000', 'consum', 0.0218, 'lps'),
	(534969, 127, '2014-02-15 00:53:29.000000', 'consum', 0.0218, 'lps'),
	(534970, 127, '2014-02-15 00:53:30.000000', 'consum', 0.0219, 'lps'),
	(534971, 127, '2014-02-15 00:53:31.000000', 'consum', 0.0212, 'lps'),
	(534972, 127, '2014-02-15 00:53:32.000000', 'consum', 0.0212, 'lps'),
	(534973, 127, '2014-02-15 00:53:33.000000', 'consum', 0.0214, 'lps'),
	(534974, 127, '2014-02-15 00:53:34.000000', 'consum', 0.0214, 'lps'),
	(534975, 127, '2014-02-15 00:53:35.000000', 'consum', 0.0219, 'lps'),
	(534976, 127, '2014-02-15 00:53:36.000000', 'consum', 0.0214, 'lps'),
	(534977, 127, '2014-02-15 00:53:37.000000', 'consum', 0.0213, 'lps'),
	(534978, 127, '2014-02-15 00:53:38.000000', 'consum', 0.0216, 'lps'),
	(534979, 127, '2014-02-15 00:53:39.000000', 'consum', 0.0218, 'lps'),
	(534980, 127, '2014-02-15 00:53:40.000000', 'consum', 0.0216, 'lps'),
	(534981, 127, '2014-02-15 00:53:41.000000', 'consum', 0.0214, 'lps'),
	(534982, 127, '2014-02-15 00:53:42.000000', 'consum', 0.0214, 'lps'),
	(534983, 127, '2014-02-15 00:53:43.000000', 'consum', 0.0218, 'lps'),
	(534984, 127, '2014-02-15 00:53:44.000000', 'consum', 0.0218, 'lps'),
	(534985, 127, '2014-02-15 00:53:45.000000', 'consum', 0.0215, 'lps'),
	(534986, 127, '2014-02-15 00:53:46.000000', 'consum', 0.0212, 'lps'),
	(534987, 127, '2014-02-15 00:53:47.000000', 'consum', 0.0216, 'lps'),
	(534988, 127, '2014-02-15 00:53:48.000000', 'consum', 0.0214, 'lps'),
	(534989, 127, '2014-02-15 00:53:49.000000', 'consum', 0.0214, 'lps'),
	(534990, 127, '2014-02-15 00:53:50.000000', 'consum', 0.0219, 'lps'),
	(534991, 127, '2014-02-15 00:53:51.000000', 'consum', 0.0212, 'lps'),
	(534992, 127, '2014-02-15 00:53:52.000000', 'consum', 0.0215, 'lps'),
	(534993, 127, '2014-02-15 00:53:53.000000', 'consum', 0.0217, 'lps'),
	(534994, 127, '2014-02-15 00:53:54.000000', 'consum', 0.0211, 'lps'),
	(534995, 127, '2014-02-15 00:53:55.000000', 'consum', 0.0213, 'lps'),
	(534996, 127, '2014-02-15 00:53:56.000000', 'consum', 0.0215, 'lps'),
	(534997, 127, '2014-02-15 00:53:57.000000', 'consum', 0.0217, 'lps'),
	(534998, 127, '2014-02-15 00:53:58.000000', 'consum', 0.0219, 'lps'),
	(534999, 127, '2014-02-15 00:53:59.000000', 'consum', 0.0217, 'lps'),
	(535000, 127, '2014-02-15 00:54:00.000000', 'consum', 0.0217, 'lps'),
	(535001, 127, '2014-02-15 00:54:01.000000', 'consum', 0.0215, 'lps'),
	(535002, 127, '2014-02-15 00:54:02.000000', 'consum', 0.0215, 'lps'),
	(535003, 127, '2014-02-15 00:54:03.000000', 'consum', 0.0218, 'lps'),
	(535004, 127, '2014-02-15 00:54:04.000000', 'consum', 0.0219, 'lps'),
	(535005, 127, '2014-02-15 00:54:05.000000', 'consum', 0.0219, 'lps'),
	(535006, 127, '2014-02-15 00:54:06.000000', 'consum', 0.0219, 'lps'),
	(535007, 127, '2014-02-15 00:54:07.000000', 'consum', 0.0219, 'lps'),
	(535008, 127, '2014-02-15 00:54:08.000000', 'consum', 0.0218, 'lps'),
	(535009, 127, '2014-02-15 00:54:09.000000', 'consum', 0.0212, 'lps'),
	(535010, 127, '2014-02-15 00:54:10.000000', 'consum', 0.0219, 'lps'),
	(535011, 127, '2014-02-15 00:54:11.000000', 'consum', 0.0210, 'lps'),
	(535012, 127, '2014-02-15 00:54:12.000000', 'consum', 0.0213, 'lps'),
	(535013, 127, '2014-02-15 00:54:13.000000', 'consum', 0.0215, 'lps'),
	(535014, 127, '2014-02-15 00:54:14.000000', 'consum', 0.0215, 'lps'),
	(535015, 127, '2014-02-15 00:54:15.000000', 'consum', 0.0210, 'lps'),
	(535016, 127, '2014-02-15 00:54:16.000000', 'consum', 0.0217, 'lps'),
	(535017, 127, '2014-02-15 00:54:17.000000', 'consum', 0.0216, 'lps'),
	(535018, 127, '2014-02-15 00:54:18.000000', 'consum', 0.0219, 'lps'),
	(535019, 127, '2014-02-15 00:54:19.000000', 'consum', 0.0217, 'lps'),
	(535020, 127, '2014-02-15 00:54:20.000000', 'consum', 0.0217, 'lps'),
	(535021, 127, '2014-02-15 00:54:21.000000', 'consum', 0.0215, 'lps'),
	(535022, 127, '2014-02-15 00:54:22.000000', 'consum', 0.0214, 'lps'),
	(535023, 127, '2014-02-15 00:54:23.000000', 'consum', 0.0217, 'lps'),
	(535024, 127, '2014-02-15 00:54:24.000000', 'consum', 0.0214, 'lps'),
	(535025, 127, '2014-02-15 00:54:25.000000', 'consum', 0.0218, 'lps'),
	(535026, 127, '2014-02-15 00:54:26.000000', 'consum', 0.0217, 'lps'),
	(535027, 127, '2014-02-15 00:54:27.000000', 'consum', 0.0214, 'lps'),
	(535028, 127, '2014-02-15 00:54:28.000000', 'consum', 0.0217, 'lps'),
	(535029, 127, '2014-02-15 00:54:29.000000', 'consum', 0.0214, 'lps'),
	(535030, 127, '2014-02-15 00:54:30.000000', 'consum', 0.0212, 'lps'),
	(535031, 127, '2014-02-15 00:54:31.000000', 'consum', 0.0216, 'lps'),
	(535032, 127, '2014-02-15 00:54:32.000000', 'consum', 0.0216, 'lps'),
	(535033, 127, '2014-02-15 00:54:33.000000', 'consum', 0.0212, 'lps'),
	(535034, 127, '2014-02-15 00:54:34.000000', 'consum', 0.0212, 'lps'),
	(535035, 127, '2014-02-15 00:54:35.000000', 'consum', 0.0215, 'lps'),
	(535036, 127, '2014-02-15 00:54:36.000000', 'consum', 0.0218, 'lps'),
	(535037, 127, '2014-02-15 00:54:37.000000', 'consum', 0.0216, 'lps'),
	(535038, 127, '2014-02-15 00:54:38.000000', 'consum', 0.0217, 'lps'),
	(535039, 127, '2014-02-15 00:54:39.000000', 'consum', 0.0219, 'lps'),
	(535040, 127, '2014-02-15 00:54:40.000000', 'consum', 0.0215, 'lps'),
	(535041, 127, '2014-02-15 00:54:41.000000', 'consum', 0.0215, 'lps'),
	(535042, 127, '2014-02-15 00:54:42.000000', 'consum', 0.0214, 'lps'),
	(535043, 127, '2014-02-15 00:54:43.000000', 'consum', 0.0215, 'lps'),
	(535044, 127, '2014-02-15 00:54:44.000000', 'consum', 0.0213, 'lps'),
	(535045, 127, '2014-02-15 00:54:45.000000', 'consum', 0.0210, 'lps'),
	(535046, 127, '2014-02-15 00:54:46.000000', 'consum', 0.0211, 'lps'),
	(535047, 127, '2014-02-15 00:54:47.000000', 'consum', 0.0216, 'lps'),
	(535048, 127, '2014-02-15 00:54:48.000000', 'consum', 0.0219, 'lps'),
	(535049, 127, '2014-02-15 00:54:49.000000', 'consum', 0.0215, 'lps'),
	(535050, 127, '2014-02-15 00:54:50.000000', 'consum', 0.0211, 'lps'),
	(535051, 127, '2014-02-15 00:54:51.000000', 'consum', 0.0211, 'lps'),
	(535052, 127, '2014-02-15 00:54:52.000000', 'consum', 0.0212, 'lps'),
	(535053, 127, '2014-02-15 00:54:53.000000', 'consum', 0.0215, 'lps'),
	(535054, 127, '2014-02-15 00:54:54.000000', 'consum', 0.0211, 'lps'),
	(535055, 127, '2014-02-15 00:54:55.000000', 'consum', 0.0211, 'lps'),
	(535056, 127, '2014-02-15 00:54:56.000000', 'consum', 0.0211, 'lps'),
	(535057, 127, '2014-02-15 00:54:57.000000', 'consum', 0.0215, 'lps'),
	(535058, 127, '2014-02-15 00:54:58.000000', 'consum', 0.0211, 'lps'),
	(535059, 127, '2014-02-15 00:54:59.000000', 'consum', 0.0213, 'lps'),
	(535060, 127, '2014-02-15 00:55:00.000000', 'consum', 0.0210, 'lps'),
	(535061, 127, '2014-02-15 00:55:01.000000', 'consum', 0.0212, 'lps'),
	(535062, 127, '2014-02-15 00:55:02.000000', 'consum', 0.0211, 'lps'),
	(535063, 127, '2014-02-15 00:55:03.000000', 'consum', 0.0210, 'lps'),
	(535064, 127, '2014-02-15 00:55:04.000000', 'consum', 0.0216, 'lps'),
	(535065, 127, '2014-02-15 00:55:05.000000', 'consum', 0.0210, 'lps'),
	(535066, 127, '2014-02-15 00:55:06.000000', 'consum', 0.0212, 'lps'),
	(535067, 127, '2014-02-15 00:55:07.000000', 'consum', 0.0213, 'lps'),
	(535068, 127, '2014-02-15 00:55:08.000000', 'consum', 0.0218, 'lps'),
	(535069, 127, '2014-02-15 00:55:09.000000', 'consum', 0.0212, 'lps'),
	(535070, 127, '2014-02-15 00:55:10.000000', 'consum', 0.0217, 'lps'),
	(535071, 127, '2014-02-15 00:55:11.000000', 'consum', 0.0211, 'lps'),
	(535072, 127, '2014-02-15 00:55:12.000000', 'consum', 0.0212, 'lps'),
	(535073, 127, '2014-02-15 00:55:13.000000', 'consum', 0.0210, 'lps'),
	(535074, 127, '2014-02-15 00:55:14.000000', 'consum', 0.0213, 'lps'),
	(535075, 127, '2014-02-15 00:55:15.000000', 'consum', 0.0217, 'lps'),
	(535076, 127, '2014-02-15 00:55:16.000000', 'consum', 0.0214, 'lps'),
	(535077, 127, '2014-02-15 00:55:17.000000', 'consum', 0.0210, 'lps'),
	(535078, 127, '2014-02-15 00:55:18.000000', 'consum', 0.0211, 'lps'),
	(535079, 127, '2014-02-15 00:55:19.000000', 'consum', 0.0213, 'lps'),
	(535080, 127, '2014-02-15 00:55:20.000000', 'consum', 0.0211, 'lps'),
	(535081, 127, '2014-02-15 00:55:21.000000', 'consum', 0.0219, 'lps'),
	(535082, 127, '2014-02-15 00:55:22.000000', 'consum', 0.0210, 'lps'),
	(535083, 127, '2014-02-15 00:55:23.000000', 'consum', 0.0216, 'lps'),
	(535084, 127, '2014-02-15 00:55:24.000000', 'consum', 0.0210, 'lps'),
	(535085, 127, '2014-02-15 00:55:25.000000', 'consum', 0.0210, 'lps'),
	(535086, 127, '2014-02-15 00:55:26.000000', 'consum', 0.0214, 'lps'),
	(535087, 127, '2014-02-15 00:55:27.000000', 'consum', 0.0210, 'lps'),
	(535088, 127, '2014-02-15 00:55:28.000000', 'consum', 0.0218, 'lps'),
	(535089, 127, '2014-02-15 00:55:29.000000', 'consum', 0.0219, 'lps'),
	(535090, 127, '2014-02-15 00:55:30.000000', 'consum', 0.0212, 'lps'),
	(535091, 127, '2014-02-15 00:55:31.000000', 'consum', 0.0215, 'lps'),
	(535092, 127, '2014-02-15 00:55:32.000000', 'consum', 0.0217, 'lps'),
	(535093, 127, '2014-02-15 00:55:33.000000', 'consum', 0.0212, 'lps'),
	(535094, 127, '2014-02-15 00:55:34.000000', 'consum', 0.0211, 'lps'),
	(535095, 127, '2014-02-15 00:55:35.000000', 'consum', 0.0219, 'lps'),
	(535096, 127, '2014-02-15 00:55:36.000000', 'consum', 0.0213, 'lps'),
	(535097, 127, '2014-02-15 00:55:37.000000', 'consum', 0.0218, 'lps'),
	(535098, 127, '2014-02-15 00:55:38.000000', 'consum', 0.0212, 'lps'),
	(535099, 127, '2014-02-15 00:55:39.000000', 'consum', 0.0216, 'lps'),
	(535100, 127, '2014-02-15 00:55:40.000000', 'consum', 0.0213, 'lps'),
	(535101, 127, '2014-02-15 00:55:41.000000', 'consum', 0.0210, 'lps'),
	(535102, 127, '2014-02-15 00:55:42.000000', 'consum', 0.0211, 'lps'),
	(535103, 127, '2014-02-15 00:55:43.000000', 'consum', 0.0214, 'lps'),
	(535104, 127, '2014-02-15 00:55:44.000000', 'consum', 0.0217, 'lps'),
	(535105, 127, '2014-02-15 00:55:45.000000', 'consum', 0.0216, 'lps'),
	(535106, 127, '2014-02-15 00:55:46.000000', 'consum', 0.0210, 'lps'),
	(535107, 127, '2014-02-15 00:55:47.000000', 'consum', 0.0210, 'lps'),
	(535108, 127, '2014-02-15 00:55:48.000000', 'consum', 0.0213, 'lps'),
	(535109, 127, '2014-02-15 00:55:49.000000', 'consum', 0.0215, 'lps'),
	(535110, 127, '2014-02-15 00:55:50.000000', 'consum', 0.0217, 'lps'),
	(535111, 127, '2014-02-15 00:55:51.000000', 'consum', 0.0212, 'lps'),
	(535112, 127, '2014-02-15 00:55:52.000000', 'consum', 0.0217, 'lps'),
	(535113, 127, '2014-02-15 00:55:53.000000', 'consum', 0.0210, 'lps'),
	(535114, 127, '2014-02-15 00:55:54.000000', 'consum', 0.0211, 'lps'),
	(535115, 127, '2014-02-15 00:55:55.000000', 'consum', 0.0216, 'lps'),
	(535116, 127, '2014-02-15 00:55:56.000000', 'consum', 0.0217, 'lps'),
	(535117, 127, '2014-02-15 00:55:57.000000', 'consum', 0.0218, 'lps'),
	(535118, 127, '2014-02-15 00:55:58.000000', 'consum', 0.0210, 'lps'),
	(535119, 127, '2014-02-15 00:55:59.000000', 'consum', 0.0218, 'lps'),
	(535120, 127, '2014-02-15 00:56:00.000000', 'consum', 0.0218, 'lps'),
	(535121, 127, '2014-02-15 00:56:01.000000', 'consum', 0.0218, 'lps'),
	(535122, 127, '2014-02-15 00:56:02.000000', 'consum', 0.0215, 'lps'),
	(535123, 127, '2014-02-15 00:56:03.000000', 'consum', 0.0212, 'lps'),
	(535124, 127, '2014-02-15 00:56:04.000000', 'consum', 0.0215, 'lps'),
	(535125, 127, '2014-02-15 00:56:05.000000', 'consum', 0.0218, 'lps'),
	(535126, 127, '2014-02-15 00:56:06.000000', 'consum', 0.0218, 'lps'),
	(535127, 127, '2014-02-15 00:56:07.000000', 'consum', 0.0216, 'lps'),
	(535128, 127, '2014-02-15 00:56:08.000000', 'consum', 0.0217, 'lps'),
	(535129, 127, '2014-02-15 00:56:09.000000', 'consum', 0.0218, 'lps'),
	(535130, 127, '2014-02-15 00:56:10.000000', 'consum', 0.0210, 'lps'),
	(535131, 127, '2014-02-15 00:56:11.000000', 'consum', 0.0217, 'lps'),
	(535132, 127, '2014-02-15 00:56:12.000000', 'consum', 0.0216, 'lps'),
	(535133, 127, '2014-02-15 00:56:13.000000', 'consum', 0.0219, 'lps'),
	(535134, 127, '2014-02-15 00:56:14.000000', 'consum', 0.0218, 'lps'),
	(535135, 127, '2014-02-15 00:56:15.000000', 'consum', 0.0214, 'lps'),
	(535136, 127, '2014-02-15 00:56:16.000000', 'consum', 0.0215, 'lps'),
	(535137, 127, '2014-02-15 00:56:17.000000', 'consum', 0.0214, 'lps'),
	(535138, 127, '2014-02-15 00:56:18.000000', 'consum', 0.0214, 'lps'),
	(535139, 127, '2014-02-15 00:56:19.000000', 'consum', 0.0210, 'lps'),
	(535140, 127, '2014-02-15 00:56:20.000000', 'consum', 0.0218, 'lps'),
	(535141, 127, '2014-02-15 00:56:21.000000', 'consum', 0.0212, 'lps'),
	(535142, 127, '2014-02-15 00:56:22.000000', 'consum', 0.0216, 'lps'),
	(535143, 127, '2014-02-15 00:56:23.000000', 'consum', 0.0216, 'lps'),
	(535144, 127, '2014-02-15 00:56:24.000000', 'consum', 0.0211, 'lps'),
	(535145, 127, '2014-02-15 00:56:25.000000', 'consum', 0.0216, 'lps'),
	(535146, 127, '2014-02-15 00:56:26.000000', 'consum', 0.0210, 'lps'),
	(535147, 127, '2014-02-15 00:56:27.000000', 'consum', 0.0210, 'lps'),
	(535148, 127, '2014-02-15 00:56:28.000000', 'consum', 0.0211, 'lps'),
	(535149, 127, '2014-02-15 00:56:29.000000', 'consum', 0.0217, 'lps'),
	(535150, 127, '2014-02-15 00:56:30.000000', 'consum', 0.0211, 'lps'),
	(535151, 127, '2014-02-15 00:56:31.000000', 'consum', 0.0216, 'lps'),
	(535152, 127, '2014-02-15 00:56:32.000000', 'consum', 0.0216, 'lps'),
	(535153, 127, '2014-02-15 00:56:33.000000', 'consum', 0.0215, 'lps'),
	(535154, 127, '2014-02-15 00:56:34.000000', 'consum', 0.0216, 'lps'),
	(535155, 127, '2014-02-15 00:56:35.000000', 'consum', 0.0214, 'lps'),
	(535156, 127, '2014-02-15 00:56:36.000000', 'consum', 0.0213, 'lps'),
	(535157, 127, '2014-02-15 00:56:37.000000', 'consum', 0.0213, 'lps'),
	(535158, 127, '2014-02-15 00:56:38.000000', 'consum', 0.0217, 'lps'),
	(535159, 127, '2014-02-15 00:56:39.000000', 'consum', 0.0216, 'lps'),
	(535160, 127, '2014-02-15 00:56:40.000000', 'consum', 0.0212, 'lps'),
	(535161, 127, '2014-02-15 00:56:41.000000', 'consum', 0.0219, 'lps'),
	(535162, 127, '2014-02-15 00:56:42.000000', 'consum', 0.0213, 'lps'),
	(535163, 127, '2014-02-15 00:56:43.000000', 'consum', 0.0216, 'lps'),
	(535164, 127, '2014-02-15 00:56:44.000000', 'consum', 0.0211, 'lps'),
	(535165, 127, '2014-02-15 00:56:45.000000', 'consum', 0.0217, 'lps'),
	(535166, 127, '2014-02-15 00:56:46.000000', 'consum', 0.0213, 'lps'),
	(535167, 127, '2014-02-15 00:56:47.000000', 'consum', 0.0217, 'lps'),
	(535168, 127, '2014-02-15 00:56:48.000000', 'consum', 0.0214, 'lps'),
	(535169, 127, '2014-02-15 00:56:49.000000', 'consum', 0.0212, 'lps'),
	(535170, 127, '2014-02-15 00:56:50.000000', 'consum', 0.0216, 'lps'),
	(535171, 127, '2014-02-15 00:56:51.000000', 'consum', 0.0217, 'lps'),
	(535172, 127, '2014-02-15 00:56:52.000000', 'consum', 0.0214, 'lps'),
	(535173, 127, '2014-02-15 00:56:53.000000', 'consum', 0.0213, 'lps'),
	(535174, 127, '2014-02-15 00:56:54.000000', 'consum', 0.0211, 'lps'),
	(535175, 127, '2014-02-15 00:56:55.000000', 'consum', 0.0219, 'lps'),
	(535176, 127, '2014-02-15 00:56:56.000000', 'consum', 0.0219, 'lps'),
	(535177, 127, '2014-02-15 00:56:57.000000', 'consum', 0.0212, 'lps'),
	(535178, 127, '2014-02-15 00:56:58.000000', 'consum', 0.0211, 'lps'),
	(535179, 127, '2014-02-15 00:56:59.000000', 'consum', 0.0219, 'lps'),
	(535180, 127, '2014-02-15 00:57:00.000000', 'consum', 0.0214, 'lps'),
	(535181, 127, '2014-02-15 00:57:01.000000', 'consum', 0.0213, 'lps'),
	(535182, 127, '2014-02-15 00:57:02.000000', 'consum', 0.0215, 'lps'),
	(535183, 127, '2014-02-15 00:57:03.000000', 'consum', 0.0215, 'lps'),
	(535184, 127, '2014-02-15 00:57:04.000000', 'consum', 0.0210, 'lps'),
	(535185, 127, '2014-02-15 00:57:05.000000', 'consum', 0.0215, 'lps'),
	(535186, 127, '2014-02-15 00:57:06.000000', 'consum', 0.0214, 'lps'),
	(535187, 127, '2014-02-15 00:57:07.000000', 'consum', 0.0219, 'lps'),
	(535188, 127, '2014-02-15 00:57:08.000000', 'consum', 0.0212, 'lps'),
	(535189, 127, '2014-02-15 00:57:09.000000', 'consum', 0.0215, 'lps'),
	(535190, 127, '2014-02-15 00:57:10.000000', 'consum', 0.0218, 'lps'),
	(535191, 127, '2014-02-15 00:57:11.000000', 'consum', 0.0215, 'lps'),
	(535192, 127, '2014-02-15 00:57:12.000000', 'consum', 0.0213, 'lps'),
	(535193, 127, '2014-02-15 00:57:13.000000', 'consum', 0.0211, 'lps'),
	(535194, 127, '2014-02-15 00:57:14.000000', 'consum', 0.0217, 'lps'),
	(535195, 127, '2014-02-15 00:57:15.000000', 'consum', 0.0213, 'lps'),
	(535196, 127, '2014-02-15 00:57:16.000000', 'consum', 0.0211, 'lps'),
	(535197, 127, '2014-02-15 00:57:17.000000', 'consum', 0.0210, 'lps'),
	(535198, 127, '2014-02-15 00:57:18.000000', 'consum', 0.0218, 'lps'),
	(535199, 127, '2014-02-15 00:57:19.000000', 'consum', 0.0217, 'lps'),
	(535200, 127, '2014-02-15 00:57:20.000000', 'consum', 0.0214, 'lps'),
	(535201, 127, '2014-02-15 00:57:21.000000', 'consum', 0.0211, 'lps'),
	(535202, 127, '2014-02-15 00:57:22.000000', 'consum', 0.0212, 'lps'),
	(535203, 127, '2014-02-15 00:57:23.000000', 'consum', 0.0217, 'lps'),
	(535204, 127, '2014-02-15 00:57:24.000000', 'consum', 0.0219, 'lps'),
	(535205, 127, '2014-02-15 00:57:25.000000', 'consum', 0.0216, 'lps'),
	(535206, 127, '2014-02-15 00:57:26.000000', 'consum', 0.0214, 'lps'),
	(535207, 127, '2014-02-15 00:57:27.000000', 'consum', 0.0211, 'lps'),
	(535208, 127, '2014-02-15 00:57:28.000000', 'consum', 0.0214, 'lps'),
	(535209, 127, '2014-02-15 00:57:29.000000', 'consum', 0.0216, 'lps'),
	(535210, 127, '2014-02-15 00:57:30.000000', 'consum', 0.0219, 'lps'),
	(535211, 127, '2014-02-15 00:57:31.000000', 'consum', 0.0210, 'lps'),
	(535212, 127, '2014-02-15 00:57:32.000000', 'consum', 0.0211, 'lps'),
	(535213, 127, '2014-02-15 00:57:33.000000', 'consum', 0.0215, 'lps'),
	(535214, 127, '2014-02-15 00:57:34.000000', 'consum', 0.0214, 'lps'),
	(535215, 127, '2014-02-15 00:57:35.000000', 'consum', 0.0217, 'lps'),
	(535216, 127, '2014-02-15 00:57:36.000000', 'consum', 0.0212, 'lps'),
	(535217, 127, '2014-02-15 00:57:37.000000', 'consum', 0.0218, 'lps'),
	(535218, 127, '2014-02-15 00:57:38.000000', 'consum', 0.0214, 'lps'),
	(535219, 127, '2014-02-15 00:57:39.000000', 'consum', 0.0216, 'lps'),
	(535220, 127, '2014-02-15 00:57:40.000000', 'consum', 0.0210, 'lps'),
	(535221, 127, '2014-02-15 00:57:41.000000', 'consum', 0.0212, 'lps'),
	(535222, 127, '2014-02-15 00:57:42.000000', 'consum', 0.0210, 'lps'),
	(535223, 127, '2014-02-15 00:57:43.000000', 'consum', 0.0214, 'lps'),
	(535224, 127, '2014-02-15 00:57:44.000000', 'consum', 0.0213, 'lps'),
	(535225, 127, '2014-02-15 00:57:45.000000', 'consum', 0.0211, 'lps'),
	(535226, 127, '2014-02-15 00:57:46.000000', 'consum', 0.0218, 'lps'),
	(535227, 127, '2014-02-15 00:57:47.000000', 'consum', 0.0218, 'lps'),
	(535228, 127, '2014-02-15 00:57:48.000000', 'consum', 0.0215, 'lps'),
	(535229, 127, '2014-02-15 00:57:49.000000', 'consum', 0.0212, 'lps'),
	(535230, 127, '2014-02-15 00:57:50.000000', 'consum', 0.0214, 'lps'),
	(535231, 127, '2014-02-15 00:57:51.000000', 'consum', 0.0216, 'lps'),
	(535232, 127, '2014-02-15 00:57:52.000000', 'consum', 0.0210, 'lps'),
	(535233, 127, '2014-02-15 00:57:53.000000', 'consum', 0.0212, 'lps'),
	(535234, 127, '2014-02-15 00:57:54.000000', 'consum', 0.0219, 'lps'),
	(535235, 127, '2014-02-15 00:57:55.000000', 'consum', 0.0212, 'lps'),
	(535236, 127, '2014-02-15 00:57:56.000000', 'consum', 0.0212, 'lps'),
	(535237, 127, '2014-02-15 00:57:57.000000', 'consum', 0.0214, 'lps'),
	(535238, 127, '2014-02-15 00:57:58.000000', 'consum', 0.0213, 'lps'),
	(535239, 127, '2014-02-15 00:57:59.000000', 'consum', 0.0215, 'lps'),
	(535240, 127, '2014-02-15 00:58:00.000000', 'consum', 0.0215, 'lps'),
	(535241, 127, '2014-02-15 00:58:01.000000', 'consum', 0.0211, 'lps'),
	(535242, 127, '2014-02-15 00:58:02.000000', 'consum', 0.0211, 'lps'),
	(535243, 127, '2014-02-15 00:58:03.000000', 'consum', 0.0213, 'lps'),
	(535244, 127, '2014-02-15 00:58:04.000000', 'consum', 0.0212, 'lps'),
	(535245, 127, '2014-02-15 00:58:05.000000', 'consum', 0.0210, 'lps'),
	(535246, 127, '2014-02-15 00:58:06.000000', 'consum', 0.0216, 'lps'),
	(535247, 127, '2014-02-15 00:58:07.000000', 'consum', 0.0211, 'lps'),
	(535248, 127, '2014-02-15 00:58:08.000000', 'consum', 0.0219, 'lps'),
	(535249, 127, '2014-02-15 00:58:09.000000', 'consum', 0.0211, 'lps'),
	(535250, 127, '2014-02-15 00:58:10.000000', 'consum', 0.0219, 'lps'),
	(535251, 127, '2014-02-15 00:58:11.000000', 'consum', 0.0213, 'lps'),
	(535252, 127, '2014-02-15 00:58:12.000000', 'consum', 0.0218, 'lps'),
	(535253, 127, '2014-02-15 00:58:13.000000', 'consum', 0.0210, 'lps'),
	(535254, 127, '2014-02-15 00:58:14.000000', 'consum', 0.0218, 'lps'),
	(535255, 127, '2014-02-15 00:58:15.000000', 'consum', 0.0210, 'lps'),
	(535256, 127, '2014-02-15 00:58:16.000000', 'consum', 0.0218, 'lps'),
	(535257, 127, '2014-02-15 00:58:17.000000', 'consum', 0.0219, 'lps'),
	(535258, 127, '2014-02-15 00:58:18.000000', 'consum', 0.0211, 'lps'),
	(535259, 127, '2014-02-15 00:58:19.000000', 'consum', 0.0211, 'lps'),
	(535260, 127, '2014-02-15 00:58:20.000000', 'consum', 0.0211, 'lps'),
	(535261, 127, '2014-02-15 00:58:21.000000', 'consum', 0.0215, 'lps'),
	(535262, 127, '2014-02-15 00:58:22.000000', 'consum', 0.0219, 'lps'),
	(535263, 127, '2014-02-15 00:58:23.000000', 'consum', 0.0212, 'lps'),
	(535264, 127, '2014-02-15 00:58:24.000000', 'consum', 0.0214, 'lps'),
	(535265, 127, '2014-02-15 00:58:25.000000', 'consum', 0.0215, 'lps'),
	(535266, 127, '2014-02-15 00:58:26.000000', 'consum', 0.0215, 'lps'),
	(535267, 127, '2014-02-15 00:58:27.000000', 'consum', 0.0217, 'lps'),
	(535268, 127, '2014-02-15 00:58:28.000000', 'consum', 0.0214, 'lps'),
	(535269, 127, '2014-02-15 00:58:29.000000', 'consum', 0.0216, 'lps'),
	(535270, 127, '2014-02-15 00:58:30.000000', 'consum', 0.0219, 'lps'),
	(535271, 127, '2014-02-15 00:58:31.000000', 'consum', 0.0210, 'lps'),
	(535272, 127, '2014-02-15 00:58:32.000000', 'consum', 0.0212, 'lps'),
	(535273, 127, '2014-02-15 00:58:33.000000', 'consum', 0.0211, 'lps'),
	(535274, 127, '2014-02-15 00:58:34.000000', 'consum', 0.0219, 'lps'),
	(535275, 127, '2014-02-15 00:58:35.000000', 'consum', 0.0211, 'lps'),
	(535276, 127, '2014-02-15 00:58:36.000000', 'consum', 0.0211, 'lps'),
	(535277, 127, '2014-02-15 00:58:37.000000', 'consum', 0.0212, 'lps'),
	(535278, 127, '2014-02-15 00:58:38.000000', 'consum', 0.0218, 'lps'),
	(535279, 127, '2014-02-15 00:58:39.000000', 'consum', 0.0216, 'lps'),
	(535280, 127, '2014-02-15 00:58:40.000000', 'consum', 0.0213, 'lps'),
	(535281, 127, '2014-02-15 00:58:41.000000', 'consum', 0.0210, 'lps'),
	(535282, 127, '2014-02-15 00:58:42.000000', 'consum', 0.0211, 'lps'),
	(535283, 127, '2014-02-15 00:58:43.000000', 'consum', 0.0216, 'lps'),
	(535284, 127, '2014-02-15 00:58:44.000000', 'consum', 0.0219, 'lps'),
	(535285, 127, '2014-02-15 00:58:45.000000', 'consum', 0.0217, 'lps'),
	(535286, 127, '2014-02-15 00:58:46.000000', 'consum', 0.0217, 'lps'),
	(535287, 127, '2014-02-15 00:58:47.000000', 'consum', 0.0217, 'lps'),
	(535288, 127, '2014-02-15 00:58:48.000000', 'consum', 0.0214, 'lps'),
	(535289, 127, '2014-02-15 00:58:49.000000', 'consum', 0.0210, 'lps'),
	(535290, 127, '2014-02-15 00:58:50.000000', 'consum', 0.0216, 'lps'),
	(535291, 127, '2014-02-15 00:58:51.000000', 'consum', 0.0211, 'lps'),
	(535292, 127, '2014-02-15 00:58:52.000000', 'consum', 0.0219, 'lps'),
	(535293, 127, '2014-02-15 00:58:53.000000', 'consum', 0.0213, 'lps'),
	(535294, 127, '2014-02-15 00:58:54.000000', 'consum', 0.0217, 'lps'),
	(535295, 127, '2014-02-15 00:58:55.000000', 'consum', 0.0218, 'lps'),
	(535296, 127, '2014-02-15 00:58:56.000000', 'consum', 0.0219, 'lps'),
	(535297, 127, '2014-02-15 00:58:57.000000', 'consum', 0.0213, 'lps'),
	(535298, 127, '2014-02-15 00:58:58.000000', 'consum', 0.0216, 'lps'),
	(535299, 127, '2014-02-15 00:58:59.000000', 'consum', 0.0213, 'lps'),
	(535300, 127, '2014-02-15 00:59:00.000000', 'consum', 0.0216, 'lps'),
	(535301, 127, '2014-02-15 00:59:01.000000', 'consum', 0.0213, 'lps'),
	(535302, 127, '2014-02-15 00:59:02.000000', 'consum', 0.0216, 'lps'),
	(535303, 127, '2014-02-15 00:59:03.000000', 'consum', 0.0214, 'lps'),
	(535304, 127, '2014-02-15 00:59:04.000000', 'consum', 0.0212, 'lps'),
	(535305, 127, '2014-02-15 00:59:05.000000', 'consum', 0.0216, 'lps'),
	(535306, 127, '2014-02-15 00:59:06.000000', 'consum', 0.0217, 'lps'),
	(535307, 127, '2014-02-15 00:59:07.000000', 'consum', 0.0215, 'lps'),
	(535308, 127, '2014-02-15 00:59:08.000000', 'consum', 0.0216, 'lps'),
	(535309, 127, '2014-02-15 00:59:09.000000', 'consum', 0.0215, 'lps'),
	(535310, 127, '2014-02-15 00:59:10.000000', 'consum', 0.0219, 'lps'),
	(535311, 127, '2014-02-15 00:59:11.000000', 'consum', 0.0211, 'lps'),
	(535312, 127, '2014-02-15 00:59:12.000000', 'consum', 0.0217, 'lps'),
	(535313, 127, '2014-02-15 00:59:13.000000', 'consum', 0.0213, 'lps'),
	(535314, 127, '2014-02-15 00:59:14.000000', 'consum', 0.0212, 'lps'),
	(535315, 127, '2014-02-15 00:59:15.000000', 'consum', 0.0215, 'lps'),
	(535316, 127, '2014-02-15 00:59:16.000000', 'consum', 0.0218, 'lps'),
	(535317, 127, '2014-02-15 00:59:17.000000', 'consum', 0.0215, 'lps'),
	(535318, 127, '2014-02-15 00:59:18.000000', 'consum', 0.0213, 'lps'),
	(535319, 127, '2014-02-15 00:59:19.000000', 'consum', 0.0218, 'lps'),
	(535320, 127, '2014-02-15 00:59:20.000000', 'consum', 0.0215, 'lps'),
	(535321, 127, '2014-02-15 00:59:21.000000', 'consum', 0.0219, 'lps'),
	(535322, 127, '2014-02-15 00:59:22.000000', 'consum', 0.0213, 'lps'),
	(535323, 127, '2014-02-15 00:59:23.000000', 'consum', 0.0215, 'lps'),
	(535324, 127, '2014-02-15 00:59:24.000000', 'consum', 0.0219, 'lps'),
	(535325, 127, '2014-02-15 00:59:25.000000', 'consum', 0.0219, 'lps'),
	(535326, 127, '2014-02-15 00:59:26.000000', 'consum', 0.0217, 'lps'),
	(535327, 127, '2014-02-15 00:59:27.000000', 'consum', 0.0212, 'lps'),
	(535328, 127, '2014-02-15 00:59:28.000000', 'consum', 0.0218, 'lps'),
	(535329, 127, '2014-02-15 00:59:29.000000', 'consum', 0.0216, 'lps'),
	(535330, 127, '2014-02-15 00:59:30.000000', 'consum', 0.0216, 'lps'),
	(535331, 127, '2014-02-15 00:59:31.000000', 'consum', 0.0211, 'lps'),
	(535332, 127, '2014-02-15 00:59:32.000000', 'consum', 0.0219, 'lps'),
	(535333, 127, '2014-02-15 00:59:33.000000', 'consum', 0.0210, 'lps'),
	(535334, 127, '2014-02-15 00:59:34.000000', 'consum', 0.0215, 'lps'),
	(535335, 127, '2014-02-15 00:59:35.000000', 'consum', 0.0217, 'lps'),
	(535336, 127, '2014-02-15 00:59:36.000000', 'consum', 0.0217, 'lps'),
	(535337, 127, '2014-02-15 00:59:37.000000', 'consum', 0.0218, 'lps'),
	(535338, 127, '2014-02-15 00:59:38.000000', 'consum', 0.0218, 'lps'),
	(535339, 127, '2014-02-15 00:59:39.000000', 'consum', 0.0219, 'lps'),
	(535340, 127, '2014-02-15 00:59:40.000000', 'consum', 0.0218, 'lps'),
	(535341, 127, '2014-02-15 00:59:41.000000', 'consum', 0.0215, 'lps'),
	(535342, 127, '2014-02-15 00:59:42.000000', 'consum', 0.0210, 'lps'),
	(535343, 127, '2014-02-15 00:59:43.000000', 'consum', 0.0216, 'lps'),
	(535344, 127, '2014-02-15 00:59:44.000000', 'consum', 0.0210, 'lps'),
	(535345, 127, '2014-02-15 00:59:45.000000', 'consum', 0.0213, 'lps'),
	(535346, 127, '2014-02-15 00:59:46.000000', 'consum', 0.0214, 'lps'),
	(535347, 128, '2014-02-15 00:00:00.000000', 'consum', 0.0219, 'lps'),
	(535348, 128, '2014-02-15 00:00:01.000000', 'consum', 0.0213, 'lps'),
	(535349, 128, '2014-02-15 00:00:02.000000', 'consum', 0.0217, 'lps'),
	(535350, 128, '2014-02-15 00:00:03.000000', 'consum', 0.0216, 'lps'),
	(535351, 128, '2014-02-15 00:00:04.000000', 'consum', 0.0223, 'lps'),
	(535352, 128, '2014-02-15 00:00:05.000000', 'consum', 0.0222, 'lps'),
	(535353, 128, '2014-02-15 00:00:06.000000', 'consum', 0.0216, 'lps'),
	(535354, 128, '2014-02-15 00:00:07.000000', 'consum', 0.0220, 'lps'),
	(535355, 128, '2014-02-15 00:00:08.000000', 'consum', 0.0226, 'lps'),
	(535356, 128, '2014-02-15 00:00:09.000000', 'consum', 0.0225, 'lps'),
	(535357, 128, '2014-02-15 00:00:10.000000', 'consum', 0.0223, 'lps'),
	(535358, 128, '2014-02-15 00:00:11.000000', 'consum', 0.0212, 'lps'),
	(535359, 128, '2014-02-15 00:00:12.000000', 'consum', 0.0215, 'lps'),
	(535360, 128, '2014-02-15 00:00:13.000000', 'consum', 0.0215, 'lps'),
	(535361, 128, '2014-02-15 00:00:14.000000', 'consum', 0.0218, 'lps'),
	(535362, 128, '2014-02-15 00:00:15.000000', 'consum', 0.0221, 'lps'),
	(535363, 128, '2014-02-15 00:00:16.000000', 'consum', 0.0223, 'lps'),
	(535364, 128, '2014-02-15 00:00:17.000000', 'consum', 0.0225, 'lps'),
	(535365, 128, '2014-02-15 00:00:18.000000', 'consum', 0.0215, 'lps'),
	(535366, 128, '2014-02-15 00:00:19.000000', 'consum', 0.0224, 'lps'),
	(535367, 128, '2014-02-15 00:00:20.000000', 'consum', 0.0212, 'lps'),
	(535368, 128, '2014-02-15 00:00:21.000000', 'consum', 0.0215, 'lps'),
	(535369, 128, '2014-02-15 00:00:22.000000', 'consum', 0.0213, 'lps'),
	(535370, 128, '2014-02-15 00:00:23.000000', 'consum', 0.0224, 'lps'),
	(535371, 128, '2014-02-15 00:00:24.000000', 'consum', 0.0224, 'lps'),
	(535372, 128, '2014-02-15 00:00:25.000000', 'consum', 0.0222, 'lps'),
	(535373, 128, '2014-02-15 00:00:26.000000', 'consum', 0.0211, 'lps'),
	(535374, 128, '2014-02-15 00:00:27.000000', 'consum', 0.0213, 'lps'),
	(535375, 128, '2014-02-15 00:00:28.000000', 'consum', 0.0222, 'lps'),
	(535376, 128, '2014-02-15 00:00:29.000000', 'consum', 0.0210, 'lps'),
	(535377, 128, '2014-02-15 00:00:30.000000', 'consum', 0.0225, 'lps'),
	(535378, 128, '2014-02-15 00:00:31.000000', 'consum', 0.0217, 'lps'),
	(535379, 128, '2014-02-15 00:00:32.000000', 'consum', 0.0217, 'lps'),
	(535380, 128, '2014-02-15 00:00:33.000000', 'consum', 0.0224, 'lps'),
	(535381, 128, '2014-02-15 00:00:34.000000', 'consum', 0.0210, 'lps'),
	(535382, 128, '2014-02-15 00:00:35.000000', 'consum', 0.0217, 'lps'),
	(535383, 128, '2014-02-15 00:00:36.000000', 'consum', 0.0214, 'lps'),
	(535384, 128, '2014-02-15 00:00:37.000000', 'consum', 0.0226, 'lps'),
	(535385, 128, '2014-02-15 00:00:38.000000', 'consum', 0.0212, 'lps'),
	(535386, 128, '2014-02-15 00:00:39.000000', 'consum', 0.0222, 'lps'),
	(535387, 128, '2014-02-15 00:00:40.000000', 'consum', 0.0213, 'lps'),
	(535388, 128, '2014-02-15 00:00:41.000000', 'consum', 0.0223, 'lps'),
	(535389, 128, '2014-02-15 00:00:42.000000', 'consum', 0.0215, 'lps'),
	(535390, 128, '2014-02-15 00:00:43.000000', 'consum', 0.0215, 'lps'),
	(535391, 128, '2014-02-15 00:00:44.000000', 'consum', 0.0222, 'lps'),
	(535392, 128, '2014-02-15 00:00:45.000000', 'consum', 0.0219, 'lps'),
	(535393, 128, '2014-02-15 00:00:46.000000', 'consum', 0.0222, 'lps'),
	(535394, 128, '2014-02-15 00:00:47.000000', 'consum', 0.0226, 'lps'),
	(535395, 128, '2014-02-15 00:00:48.000000', 'consum', 0.0219, 'lps'),
	(535396, 128, '2014-02-15 00:00:49.000000', 'consum', 0.0224, 'lps'),
	(535397, 128, '2014-02-15 00:00:50.000000', 'consum', 0.0218, 'lps'),
	(535398, 128, '2014-02-15 00:00:51.000000', 'consum', 0.0212, 'lps'),
	(535399, 128, '2014-02-15 00:00:52.000000', 'consum', 0.0211, 'lps'),
	(535400, 128, '2014-02-15 00:00:53.000000', 'consum', 0.0212, 'lps'),
	(535401, 128, '2014-02-15 00:00:54.000000', 'consum', 0.0218, 'lps'),
	(535402, 128, '2014-02-15 00:00:55.000000', 'consum', 0.0226, 'lps'),
	(535403, 128, '2014-02-15 00:00:56.000000', 'consum', 0.0217, 'lps'),
	(535404, 128, '2014-02-15 00:00:57.000000', 'consum', 0.0214, 'lps'),
	(535405, 128, '2014-02-15 00:00:58.000000', 'consum', 0.0211, 'lps'),
	(535406, 128, '2014-02-15 00:00:59.000000', 'consum', 0.0220, 'lps'),
	(535407, 128, '2014-02-15 00:01:00.000000', 'consum', 0.0224, 'lps'),
	(535408, 128, '2014-02-15 00:01:01.000000', 'consum', 0.0218, 'lps'),
	(535409, 128, '2014-02-15 00:01:02.000000', 'consum', 0.0222, 'lps'),
	(535410, 128, '2014-02-15 00:01:03.000000', 'consum', 0.0214, 'lps'),
	(535411, 128, '2014-02-15 00:01:04.000000', 'consum', 0.0210, 'lps'),
	(535412, 128, '2014-02-15 00:01:05.000000', 'consum', 0.0216, 'lps'),
	(535413, 128, '2014-02-15 00:01:06.000000', 'consum', 0.0223, 'lps'),
	(535414, 128, '2014-02-15 00:01:07.000000', 'consum', 0.0225, 'lps'),
	(535415, 128, '2014-02-15 00:01:08.000000', 'consum', 0.0213, 'lps'),
	(535416, 128, '2014-02-15 00:01:09.000000', 'consum', 0.0213, 'lps'),
	(535417, 128, '2014-02-15 00:01:10.000000', 'consum', 0.0215, 'lps'),
	(535418, 128, '2014-02-15 00:01:11.000000', 'consum', 0.0213, 'lps'),
	(535419, 128, '2014-02-15 00:01:12.000000', 'consum', 0.0224, 'lps'),
	(535420, 128, '2014-02-15 00:01:13.000000', 'consum', 0.0223, 'lps'),
	(535421, 128, '2014-02-15 00:01:14.000000', 'consum', 0.0214, 'lps'),
	(535422, 128, '2014-02-15 00:01:15.000000', 'consum', 0.0212, 'lps'),
	(535423, 128, '2014-02-15 00:01:16.000000', 'consum', 0.0223, 'lps'),
	(535424, 128, '2014-02-15 00:01:17.000000', 'consum', 0.0220, 'lps'),
	(535425, 128, '2014-02-15 00:01:18.000000', 'consum', 0.0221, 'lps'),
	(535426, 128, '2014-02-15 00:01:19.000000', 'consum', 0.0218, 'lps'),
	(535427, 128, '2014-02-15 00:01:20.000000', 'consum', 0.0216, 'lps'),
	(535428, 128, '2014-02-15 00:01:21.000000', 'consum', 0.0217, 'lps'),
	(535429, 128, '2014-02-15 00:01:22.000000', 'consum', 0.0211, 'lps'),
	(535430, 128, '2014-02-15 00:01:23.000000', 'consum', 0.0211, 'lps'),
	(535431, 128, '2014-02-15 00:01:24.000000', 'consum', 0.0215, 'lps'),
	(535432, 128, '2014-02-15 00:01:25.000000', 'consum', 0.0214, 'lps'),
	(535433, 128, '2014-02-15 00:01:26.000000', 'consum', 0.0214, 'lps'),
	(535434, 128, '2014-02-15 00:01:27.000000', 'consum', 0.0220, 'lps'),
	(535435, 128, '2014-02-15 00:01:28.000000', 'consum', 0.0215, 'lps'),
	(535436, 128, '2014-02-15 00:01:29.000000', 'consum', 0.0222, 'lps'),
	(535437, 128, '2014-02-15 00:01:30.000000', 'consum', 0.0222, 'lps'),
	(535438, 128, '2014-02-15 00:01:31.000000', 'consum', 0.0219, 'lps'),
	(535439, 128, '2014-02-15 00:01:32.000000', 'consum', 0.0218, 'lps'),
	(535440, 128, '2014-02-15 00:01:33.000000', 'consum', 0.0224, 'lps'),
	(535441, 128, '2014-02-15 00:01:34.000000', 'consum', 0.0222, 'lps'),
	(535442, 128, '2014-02-15 00:01:35.000000', 'consum', 0.0212, 'lps'),
	(535443, 128, '2014-02-15 00:01:36.000000', 'consum', 0.0218, 'lps'),
	(535444, 128, '2014-02-15 00:01:37.000000', 'consum', 0.0226, 'lps'),
	(535445, 128, '2014-02-15 00:01:38.000000', 'consum', 0.0216, 'lps'),
	(535446, 128, '2014-02-15 00:01:39.000000', 'consum', 0.0211, 'lps'),
	(535447, 128, '2014-02-15 00:01:40.000000', 'consum', 0.0214, 'lps'),
	(535448, 128, '2014-02-15 00:01:41.000000', 'consum', 0.0211, 'lps'),
	(535449, 128, '2014-02-15 00:01:42.000000', 'consum', 0.0220, 'lps'),
	(535450, 128, '2014-02-15 00:01:43.000000', 'consum', 0.0222, 'lps'),
	(535451, 128, '2014-02-15 00:01:44.000000', 'consum', 0.0224, 'lps'),
	(535452, 128, '2014-02-15 00:01:45.000000', 'consum', 0.0210, 'lps'),
	(535453, 128, '2014-02-15 00:01:46.000000', 'consum', 0.0221, 'lps'),
	(535454, 128, '2014-02-15 00:01:47.000000', 'consum', 0.0215, 'lps'),
	(535455, 128, '2014-02-15 00:01:48.000000', 'consum', 0.0219, 'lps'),
	(535456, 128, '2014-02-15 00:01:49.000000', 'consum', 0.0224, 'lps'),
	(535457, 128, '2014-02-15 00:01:50.000000', 'consum', 0.0221, 'lps'),
	(535458, 128, '2014-02-15 00:01:51.000000', 'consum', 0.0222, 'lps'),
	(535459, 128, '2014-02-15 00:01:52.000000', 'consum', 0.0221, 'lps'),
	(535460, 128, '2014-02-15 00:01:53.000000', 'consum', 0.0211, 'lps'),
	(535461, 128, '2014-02-15 00:01:54.000000', 'consum', 0.0219, 'lps'),
	(535462, 128, '2014-02-15 00:01:55.000000', 'consum', 0.0218, 'lps'),
	(535463, 128, '2014-02-15 00:01:56.000000', 'consum', 0.0223, 'lps'),
	(535464, 128, '2014-02-15 00:01:57.000000', 'consum', 0.0218, 'lps'),
	(535465, 128, '2014-02-15 00:01:58.000000', 'consum', 0.0213, 'lps'),
	(535466, 128, '2014-02-15 00:01:59.000000', 'consum', 0.0218, 'lps'),
	(535467, 128, '2014-02-15 00:02:00.000000', 'consum', 0.0226, 'lps'),
	(535468, 128, '2014-02-15 00:02:01.000000', 'consum', 0.0212, 'lps'),
	(535469, 128, '2014-02-15 00:02:02.000000', 'consum', 0.0226, 'lps'),
	(535470, 128, '2014-02-15 00:02:03.000000', 'consum', 0.0217, 'lps'),
	(535471, 128, '2014-02-15 00:02:04.000000', 'consum', 0.0215, 'lps'),
	(535472, 128, '2014-02-15 00:02:05.000000', 'consum', 0.0212, 'lps'),
	(535473, 128, '2014-02-15 00:02:06.000000', 'consum', 0.0224, 'lps'),
	(535474, 128, '2014-02-15 00:02:07.000000', 'consum', 0.0222, 'lps'),
	(535475, 128, '2014-02-15 00:02:08.000000', 'consum', 0.0214, 'lps'),
	(535476, 128, '2014-02-15 00:02:09.000000', 'consum', 0.0225, 'lps'),
	(535477, 128, '2014-02-15 00:02:10.000000', 'consum', 0.0225, 'lps'),
	(535478, 128, '2014-02-15 00:02:11.000000', 'consum', 0.0223, 'lps'),
	(535479, 128, '2014-02-15 00:02:12.000000', 'consum', 0.0215, 'lps'),
	(535480, 128, '2014-02-15 00:02:13.000000', 'consum', 0.0210, 'lps'),
	(535481, 128, '2014-02-15 00:02:14.000000', 'consum', 0.0216, 'lps'),
	(535482, 128, '2014-02-15 00:02:15.000000', 'consum', 0.0223, 'lps'),
	(535483, 128, '2014-02-15 00:02:16.000000', 'consum', 0.0225, 'lps'),
	(535484, 128, '2014-02-15 00:02:17.000000', 'consum', 0.0211, 'lps'),
	(535485, 128, '2014-02-15 00:02:18.000000', 'consum', 0.0220, 'lps'),
	(535486, 128, '2014-02-15 00:02:19.000000', 'consum', 0.0225, 'lps'),
	(535487, 128, '2014-02-15 00:02:20.000000', 'consum', 0.0222, 'lps'),
	(535488, 128, '2014-02-15 00:02:21.000000', 'consum', 0.0225, 'lps'),
	(535489, 128, '2014-02-15 00:02:22.000000', 'consum', 0.0217, 'lps'),
	(535490, 128, '2014-02-15 00:02:23.000000', 'consum', 0.0216, 'lps'),
	(535491, 128, '2014-02-15 00:02:24.000000', 'consum', 0.0222, 'lps'),
	(535492, 128, '2014-02-15 00:02:25.000000', 'consum', 0.0215, 'lps'),
	(535493, 128, '2014-02-15 00:02:26.000000', 'consum', 0.0219, 'lps'),
	(535494, 128, '2014-02-15 00:02:27.000000', 'consum', 0.0222, 'lps'),
	(535495, 128, '2014-02-15 00:02:28.000000', 'consum', 0.0211, 'lps'),
	(535496, 128, '2014-02-15 00:02:29.000000', 'consum', 0.0212, 'lps'),
	(535497, 128, '2014-02-15 00:02:30.000000', 'consum', 0.0216, 'lps'),
	(535498, 128, '2014-02-15 00:02:31.000000', 'consum', 0.0221, 'lps'),
	(535499, 128, '2014-02-15 00:02:32.000000', 'consum', 0.0210, 'lps'),
	(535500, 128, '2014-02-15 00:02:33.000000', 'consum', 0.0215, 'lps'),
	(535501, 128, '2014-02-15 00:02:34.000000', 'consum', 0.0217, 'lps'),
	(535502, 128, '2014-02-15 00:02:35.000000', 'consum', 0.0214, 'lps'),
	(535503, 128, '2014-02-15 00:02:36.000000', 'consum', 0.0226, 'lps'),
	(535504, 128, '2014-02-15 00:02:37.000000', 'consum', 0.0212, 'lps'),
	(535505, 128, '2014-02-15 00:02:38.000000', 'consum', 0.0221, 'lps'),
	(535506, 128, '2014-02-15 00:02:39.000000', 'consum', 0.0211, 'lps'),
	(535507, 128, '2014-02-15 00:02:40.000000', 'consum', 0.0217, 'lps'),
	(535508, 128, '2014-02-15 00:02:41.000000', 'consum', 0.0226, 'lps'),
	(535509, 128, '2014-02-15 00:02:42.000000', 'consum', 0.0219, 'lps'),
	(535510, 128, '2014-02-15 00:02:43.000000', 'consum', 0.0223, 'lps'),
	(535511, 128, '2014-02-15 00:02:44.000000', 'consum', 0.0215, 'lps'),
	(535512, 128, '2014-02-15 00:02:45.000000', 'consum', 0.0212, 'lps'),
	(535513, 128, '2014-02-15 00:02:46.000000', 'consum', 0.0224, 'lps'),
	(535514, 128, '2014-02-15 00:02:47.000000', 'consum', 0.0223, 'lps'),
	(535515, 128, '2014-02-15 00:02:48.000000', 'consum', 0.0218, 'lps'),
	(535516, 128, '2014-02-15 00:02:49.000000', 'consum', 0.0226, 'lps'),
	(535517, 128, '2014-02-15 00:02:50.000000', 'consum', 0.0218, 'lps'),
	(535518, 128, '2014-02-15 00:02:51.000000', 'consum', 0.0220, 'lps'),
	(535519, 128, '2014-02-15 00:02:52.000000', 'consum', 0.0216, 'lps'),
	(535520, 128, '2014-02-15 00:02:53.000000', 'consum', 0.0214, 'lps'),
	(535521, 128, '2014-02-15 00:02:54.000000', 'consum', 0.0212, 'lps'),
	(535522, 128, '2014-02-15 00:02:55.000000', 'consum', 0.0224, 'lps'),
	(535523, 128, '2014-02-15 00:02:56.000000', 'consum', 0.0226, 'lps'),
	(535524, 128, '2014-02-15 00:02:57.000000', 'consum', 0.0213, 'lps'),
	(535525, 128, '2014-02-15 00:02:58.000000', 'consum', 0.0212, 'lps'),
	(535526, 128, '2014-02-15 00:02:59.000000', 'consum', 0.0226, 'lps'),
	(535527, 128, '2014-02-15 00:03:00.000000', 'consum', 0.0220, 'lps'),
	(535528, 128, '2014-02-15 00:03:01.000000', 'consum', 0.0212, 'lps'),
	(535529, 128, '2014-02-15 00:03:02.000000', 'consum', 0.0223, 'lps'),
	(535530, 128, '2014-02-15 00:03:03.000000', 'consum', 0.0219, 'lps'),
	(535531, 128, '2014-02-15 00:03:04.000000', 'consum', 0.0215, 'lps'),
	(535532, 128, '2014-02-15 00:03:05.000000', 'consum', 0.0226, 'lps'),
	(535533, 128, '2014-02-15 00:03:06.000000', 'consum', 0.0225, 'lps'),
	(535534, 128, '2014-02-15 00:03:07.000000', 'consum', 0.0218, 'lps'),
	(535535, 128, '2014-02-15 00:03:08.000000', 'consum', 0.0226, 'lps'),
	(535536, 128, '2014-02-15 00:03:09.000000', 'consum', 0.0213, 'lps'),
	(535537, 128, '2014-02-15 00:03:10.000000', 'consum', 0.0212, 'lps'),
	(535538, 128, '2014-02-15 00:03:11.000000', 'consum', 0.0214, 'lps'),
	(535539, 128, '2014-02-15 00:03:12.000000', 'consum', 0.0222, 'lps'),
	(535540, 128, '2014-02-15 00:03:13.000000', 'consum', 0.0224, 'lps'),
	(535541, 128, '2014-02-15 00:03:14.000000', 'consum', 0.0210, 'lps'),
	(535542, 128, '2014-02-15 00:03:15.000000', 'consum', 0.0222, 'lps'),
	(535543, 128, '2014-02-15 00:03:16.000000', 'consum', 0.0219, 'lps'),
	(535544, 128, '2014-02-15 00:03:17.000000', 'consum', 0.0221, 'lps'),
	(535545, 128, '2014-02-15 00:03:18.000000', 'consum', 0.0220, 'lps'),
	(535546, 128, '2014-02-15 00:03:19.000000', 'consum', 0.0210, 'lps'),
	(535547, 128, '2014-02-15 00:03:20.000000', 'consum', 0.0217, 'lps'),
	(535548, 128, '2014-02-15 00:03:21.000000', 'consum', 0.0226, 'lps'),
	(535549, 128, '2014-02-15 00:03:22.000000', 'consum', 0.0221, 'lps'),
	(535550, 128, '2014-02-15 00:03:23.000000', 'consum', 0.0216, 'lps'),
	(535551, 128, '2014-02-15 00:03:24.000000', 'consum', 0.0223, 'lps'),
	(535552, 128, '2014-02-15 00:03:25.000000', 'consum', 0.0226, 'lps'),
	(535553, 128, '2014-02-15 00:03:26.000000', 'consum', 0.0219, 'lps'),
	(535554, 128, '2014-02-15 00:03:27.000000', 'consum', 0.0221, 'lps'),
	(535555, 128, '2014-02-15 00:03:28.000000', 'consum', 0.0222, 'lps'),
	(535556, 128, '2014-02-15 00:03:29.000000', 'consum', 0.0222, 'lps'),
	(535557, 128, '2014-02-15 00:03:30.000000', 'consum', 0.0216, 'lps'),
	(535558, 128, '2014-02-15 00:03:31.000000', 'consum', 0.0221, 'lps'),
	(535559, 128, '2014-02-15 00:03:32.000000', 'consum', 0.0212, 'lps'),
	(535560, 128, '2014-02-15 00:03:33.000000', 'consum', 0.0224, 'lps'),
	(535561, 128, '2014-02-15 00:03:34.000000', 'consum', 0.0223, 'lps'),
	(535562, 128, '2014-02-15 00:03:35.000000', 'consum', 0.0215, 'lps'),
	(535563, 128, '2014-02-15 00:03:36.000000', 'consum', 0.0213, 'lps'),
	(535564, 128, '2014-02-15 00:03:37.000000', 'consum', 0.0213, 'lps'),
	(535565, 128, '2014-02-15 00:03:38.000000', 'consum', 0.0215, 'lps'),
	(535566, 128, '2014-02-15 00:03:39.000000', 'consum', 0.0211, 'lps'),
	(535567, 128, '2014-02-15 00:03:40.000000', 'consum', 0.0216, 'lps'),
	(535568, 128, '2014-02-15 00:03:41.000000', 'consum', 0.0221, 'lps'),
	(535569, 128, '2014-02-15 00:03:42.000000', 'consum', 0.0215, 'lps'),
	(535570, 128, '2014-02-15 00:03:43.000000', 'consum', 0.0221, 'lps'),
	(535571, 128, '2014-02-15 00:03:44.000000', 'consum', 0.0213, 'lps'),
	(535572, 128, '2014-02-15 00:03:45.000000', 'consum', 0.0210, 'lps'),
	(535573, 128, '2014-02-15 00:03:46.000000', 'consum', 0.0218, 'lps'),
	(535574, 128, '2014-02-15 00:03:47.000000', 'consum', 0.0215, 'lps'),
	(535575, 128, '2014-02-15 00:03:48.000000', 'consum', 0.0215, 'lps'),
	(535576, 128, '2014-02-15 00:03:49.000000', 'consum', 0.0217, 'lps'),
	(535577, 128, '2014-02-15 00:03:50.000000', 'consum', 0.0216, 'lps'),
	(535578, 128, '2014-02-15 00:03:51.000000', 'consum', 0.0221, 'lps'),
	(535579, 128, '2014-02-15 00:03:52.000000', 'consum', 0.0212, 'lps'),
	(535580, 128, '2014-02-15 00:03:53.000000', 'consum', 0.0220, 'lps'),
	(535581, 128, '2014-02-15 00:03:54.000000', 'consum', 0.0222, 'lps'),
	(535582, 128, '2014-02-15 00:03:55.000000', 'consum', 0.0225, 'lps'),
	(535583, 128, '2014-02-15 00:03:56.000000', 'consum', 0.0212, 'lps'),
	(535584, 128, '2014-02-15 00:03:57.000000', 'consum', 0.0212, 'lps'),
	(535585, 128, '2014-02-15 00:03:58.000000', 'consum', 0.0215, 'lps'),
	(535586, 128, '2014-02-15 00:03:59.000000', 'consum', 0.0213, 'lps'),
	(535587, 128, '2014-02-15 00:04:00.000000', 'consum', 0.0225, 'lps'),
	(535588, 128, '2014-02-15 00:04:01.000000', 'consum', 0.0225, 'lps'),
	(535589, 128, '2014-02-15 00:04:02.000000', 'consum', 0.0226, 'lps'),
	(535590, 128, '2014-02-15 00:04:03.000000', 'consum', 0.0211, 'lps'),
	(535591, 128, '2014-02-15 00:04:04.000000', 'consum', 0.0217, 'lps'),
	(535592, 128, '2014-02-15 00:04:05.000000', 'consum', 0.0226, 'lps'),
	(535593, 128, '2014-02-15 00:04:06.000000', 'consum', 0.0217, 'lps'),
	(535594, 128, '2014-02-15 00:04:07.000000', 'consum', 0.0215, 'lps'),
	(535595, 128, '2014-02-15 00:04:08.000000', 'consum', 0.0216, 'lps'),
	(535596, 128, '2014-02-15 00:04:09.000000', 'consum', 0.0223, 'lps'),
	(535597, 128, '2014-02-15 00:04:10.000000', 'consum', 0.0224, 'lps'),
	(535598, 128, '2014-02-15 00:04:11.000000', 'consum', 0.0224, 'lps'),
	(535599, 128, '2014-02-15 00:04:12.000000', 'consum', 0.0223, 'lps'),
	(535600, 128, '2014-02-15 00:04:13.000000', 'consum', 0.0218, 'lps'),
	(535601, 128, '2014-02-15 00:04:14.000000', 'consum', 0.0226, 'lps'),
	(535602, 128, '2014-02-15 00:04:15.000000', 'consum', 0.0215, 'lps'),
	(535603, 128, '2014-02-15 00:04:16.000000', 'consum', 0.0222, 'lps'),
	(535604, 128, '2014-02-15 00:04:17.000000', 'consum', 0.0222, 'lps'),
	(535605, 128, '2014-02-15 00:04:18.000000', 'consum', 0.0216, 'lps'),
	(535606, 128, '2014-02-15 00:04:19.000000', 'consum', 0.0224, 'lps'),
	(535607, 128, '2014-02-15 00:04:20.000000', 'consum', 0.0212, 'lps'),
	(535608, 128, '2014-02-15 00:04:21.000000', 'consum', 0.0210, 'lps'),
	(535609, 128, '2014-02-15 00:04:22.000000', 'consum', 0.0224, 'lps'),
	(535610, 128, '2014-02-15 00:04:23.000000', 'consum', 0.0213, 'lps'),
	(535611, 128, '2014-02-15 00:04:24.000000', 'consum', 0.0217, 'lps'),
	(535612, 128, '2014-02-15 00:04:25.000000', 'consum', 0.0220, 'lps'),
	(535613, 128, '2014-02-15 00:04:26.000000', 'consum', 0.0220, 'lps'),
	(535614, 128, '2014-02-15 00:04:27.000000', 'consum', 0.0217, 'lps'),
	(535615, 128, '2014-02-15 00:04:28.000000', 'consum', 0.0214, 'lps'),
	(535616, 128, '2014-02-15 00:04:29.000000', 'consum', 0.0225, 'lps'),
	(535617, 128, '2014-02-15 00:04:30.000000', 'consum', 0.0224, 'lps'),
	(535618, 128, '2014-02-15 00:04:31.000000', 'consum', 0.0218, 'lps'),
	(535619, 128, '2014-02-15 00:04:32.000000', 'consum', 0.0225, 'lps'),
	(535620, 128, '2014-02-15 00:04:33.000000', 'consum', 0.0211, 'lps'),
	(535621, 128, '2014-02-15 00:04:34.000000', 'consum', 0.0222, 'lps'),
	(535622, 128, '2014-02-15 00:04:35.000000', 'consum', 0.0214, 'lps'),
	(535623, 128, '2014-02-15 00:04:36.000000', 'consum', 0.0213, 'lps'),
	(535624, 128, '2014-02-15 00:04:37.000000', 'consum', 0.0214, 'lps'),
	(535625, 128, '2014-02-15 00:04:38.000000', 'consum', 0.0221, 'lps'),
	(535626, 128, '2014-02-15 00:04:39.000000', 'consum', 0.0219, 'lps'),
	(535627, 128, '2014-02-15 00:04:40.000000', 'consum', 0.0222, 'lps'),
	(535628, 128, '2014-02-15 00:04:41.000000', 'consum', 0.0210, 'lps'),
	(535629, 128, '2014-02-15 00:04:42.000000', 'consum', 0.0224, 'lps'),
	(535630, 128, '2014-02-15 00:04:43.000000', 'consum', 0.0213, 'lps'),
	(535631, 128, '2014-02-15 00:04:44.000000', 'consum', 0.0218, 'lps'),
	(535632, 128, '2014-02-15 00:04:45.000000', 'consum', 0.0224, 'lps'),
	(535633, 128, '2014-02-15 00:04:46.000000', 'consum', 0.0222, 'lps'),
	(535634, 128, '2014-02-15 00:04:47.000000', 'consum', 0.0213, 'lps'),
	(535635, 128, '2014-02-15 00:04:48.000000', 'consum', 0.0223, 'lps'),
	(535636, 128, '2014-02-15 00:04:49.000000', 'consum', 0.0216, 'lps'),
	(535637, 128, '2014-02-15 00:04:50.000000', 'consum', 0.0220, 'lps'),
	(535638, 128, '2014-02-15 00:04:51.000000', 'consum', 0.0225, 'lps'),
	(535639, 128, '2014-02-15 00:04:52.000000', 'consum', 0.0221, 'lps'),
	(535640, 128, '2014-02-15 00:04:53.000000', 'consum', 0.0220, 'lps'),
	(535641, 128, '2014-02-15 00:04:54.000000', 'consum', 0.0213, 'lps'),
	(535642, 128, '2014-02-15 00:04:55.000000', 'consum', 0.0210, 'lps'),
	(535643, 128, '2014-02-15 00:04:56.000000', 'consum', 0.0220, 'lps'),
	(535644, 128, '2014-02-15 00:04:57.000000', 'consum', 0.0211, 'lps'),
	(535645, 128, '2014-02-15 00:04:58.000000', 'consum', 0.0216, 'lps'),
	(535646, 128, '2014-02-15 00:04:59.000000', 'consum', 0.0222, 'lps'),
	(535647, 128, '2014-02-15 00:05:00.000000', 'consum', 0.0219, 'lps'),
	(535648, 128, '2014-02-15 00:05:01.000000', 'consum', 0.0221, 'lps'),
	(535649, 128, '2014-02-15 00:05:02.000000', 'consum', 0.0221, 'lps'),
	(535650, 128, '2014-02-15 00:05:03.000000', 'consum', 0.0213, 'lps'),
	(535651, 128, '2014-02-15 00:05:04.000000', 'consum', 0.0211, 'lps'),
	(535652, 128, '2014-02-15 00:05:05.000000', 'consum', 0.0223, 'lps'),
	(535653, 128, '2014-02-15 00:05:06.000000', 'consum', 0.0220, 'lps'),
	(535654, 128, '2014-02-15 00:05:07.000000', 'consum', 0.0222, 'lps'),
	(535655, 128, '2014-02-15 00:05:08.000000', 'consum', 0.0223, 'lps'),
	(535656, 128, '2014-02-15 00:05:09.000000', 'consum', 0.0224, 'lps'),
	(535657, 128, '2014-02-15 00:05:10.000000', 'consum', 0.0223, 'lps'),
	(535658, 128, '2014-02-15 00:05:11.000000', 'consum', 0.0219, 'lps'),
	(535659, 128, '2014-02-15 00:05:12.000000', 'consum', 0.0215, 'lps'),
	(535660, 128, '2014-02-15 00:05:13.000000', 'consum', 0.0226, 'lps'),
	(535661, 128, '2014-02-15 00:05:14.000000', 'consum', 0.0225, 'lps'),
	(535662, 128, '2014-02-15 00:05:15.000000', 'consum', 0.0222, 'lps'),
	(535663, 128, '2014-02-15 00:05:16.000000', 'consum', 0.0222, 'lps'),
	(535664, 128, '2014-02-15 00:05:17.000000', 'consum', 0.0221, 'lps'),
	(535665, 128, '2014-02-15 00:05:18.000000', 'consum', 0.0210, 'lps'),
	(535666, 128, '2014-02-15 00:05:19.000000', 'consum', 0.0212, 'lps'),
	(535667, 128, '2014-02-15 00:05:20.000000', 'consum', 0.0221, 'lps'),
	(535668, 128, '2014-02-15 00:05:21.000000', 'consum', 0.0226, 'lps'),
	(535669, 128, '2014-02-15 00:05:22.000000', 'consum', 0.0224, 'lps'),
	(535670, 128, '2014-02-15 00:05:23.000000', 'consum', 0.0214, 'lps'),
	(535671, 128, '2014-02-15 00:05:24.000000', 'consum', 0.0222, 'lps'),
	(535672, 128, '2014-02-15 00:05:25.000000', 'consum', 0.0210, 'lps'),
	(535673, 128, '2014-02-15 00:05:26.000000', 'consum', 0.0224, 'lps'),
	(535674, 128, '2014-02-15 00:05:27.000000', 'consum', 0.0213, 'lps'),
	(535675, 128, '2014-02-15 00:05:28.000000', 'consum', 0.0219, 'lps'),
	(535676, 128, '2014-02-15 00:05:29.000000', 'consum', 0.0212, 'lps'),
	(535677, 128, '2014-02-15 00:05:30.000000', 'consum', 0.0210, 'lps'),
	(535678, 128, '2014-02-15 00:05:31.000000', 'consum', 0.0221, 'lps'),
	(535679, 128, '2014-02-15 00:05:32.000000', 'consum', 0.0214, 'lps'),
	(535680, 128, '2014-02-15 00:05:33.000000', 'consum', 0.0217, 'lps'),
	(535681, 128, '2014-02-15 00:05:34.000000', 'consum', 0.0213, 'lps'),
	(535682, 128, '2014-02-15 00:05:35.000000', 'consum', 0.0225, 'lps'),
	(535683, 128, '2014-02-15 00:05:36.000000', 'consum', 0.0225, 'lps'),
	(535684, 128, '2014-02-15 00:05:37.000000', 'consum', 0.0221, 'lps'),
	(535685, 128, '2014-02-15 00:05:38.000000', 'consum', 0.0223, 'lps'),
	(535686, 128, '2014-02-15 00:05:39.000000', 'consum', 0.0225, 'lps'),
	(535687, 128, '2014-02-15 00:05:40.000000', 'consum', 0.0211, 'lps'),
	(535688, 128, '2014-02-15 00:05:41.000000', 'consum', 0.0222, 'lps'),
	(535689, 128, '2014-02-15 00:05:42.000000', 'consum', 0.0217, 'lps'),
	(535690, 128, '2014-02-15 00:05:43.000000', 'consum', 0.0224, 'lps'),
	(535691, 128, '2014-02-15 00:05:44.000000', 'consum', 0.0211, 'lps'),
	(535692, 128, '2014-02-15 00:05:45.000000', 'consum', 0.0226, 'lps'),
	(535693, 128, '2014-02-15 00:05:46.000000', 'consum', 0.0216, 'lps'),
	(535694, 128, '2014-02-15 00:05:47.000000', 'consum', 0.0211, 'lps'),
	(535695, 128, '2014-02-15 00:05:48.000000', 'consum', 0.0216, 'lps'),
	(535696, 128, '2014-02-15 00:05:49.000000', 'consum', 0.0220, 'lps'),
	(535697, 128, '2014-02-15 00:05:50.000000', 'consum', 0.0224, 'lps'),
	(535698, 128, '2014-02-15 00:05:51.000000', 'consum', 0.0217, 'lps'),
	(535699, 128, '2014-02-15 00:05:52.000000', 'consum', 0.0219, 'lps'),
	(535700, 128, '2014-02-15 00:05:53.000000', 'consum', 0.0221, 'lps'),
	(535701, 128, '2014-02-15 00:05:54.000000', 'consum', 0.0218, 'lps'),
	(535702, 128, '2014-02-15 00:05:55.000000', 'consum', 0.0219, 'lps'),
	(535703, 128, '2014-02-15 00:05:56.000000', 'consum', 0.0212, 'lps'),
	(535704, 128, '2014-02-15 00:05:57.000000', 'consum', 0.0213, 'lps'),
	(535705, 128, '2014-02-15 00:05:58.000000', 'consum', 0.0220, 'lps'),
	(535706, 128, '2014-02-15 00:05:59.000000', 'consum', 0.0217, 'lps'),
	(535707, 128, '2014-02-15 00:06:00.000000', 'consum', 0.0214, 'lps'),
	(535708, 128, '2014-02-15 00:06:01.000000', 'consum', 0.0213, 'lps'),
	(535709, 128, '2014-02-15 00:06:02.000000', 'consum', 0.0210, 'lps'),
	(535710, 128, '2014-02-15 00:06:03.000000', 'consum', 0.0218, 'lps'),
	(535711, 128, '2014-02-15 00:06:04.000000', 'consum', 0.0218, 'lps'),
	(535712, 128, '2014-02-15 00:06:05.000000', 'consum', 0.0211, 'lps'),
	(535713, 128, '2014-02-15 00:06:06.000000', 'consum', 0.0224, 'lps'),
	(535714, 128, '2014-02-15 00:06:07.000000', 'consum', 0.0211, 'lps'),
	(535715, 128, '2014-02-15 00:06:08.000000', 'consum', 0.0225, 'lps'),
	(535716, 128, '2014-02-15 00:06:09.000000', 'consum', 0.0213, 'lps'),
	(535717, 128, '2014-02-15 00:06:10.000000', 'consum', 0.0217, 'lps'),
	(535718, 128, '2014-02-15 00:06:11.000000', 'consum', 0.0217, 'lps'),
	(535719, 128, '2014-02-15 00:06:12.000000', 'consum', 0.0224, 'lps'),
	(535720, 128, '2014-02-15 00:06:13.000000', 'consum', 0.0211, 'lps'),
	(535721, 128, '2014-02-15 00:06:14.000000', 'consum', 0.0225, 'lps'),
	(535722, 128, '2014-02-15 00:06:15.000000', 'consum', 0.0212, 'lps'),
	(535723, 128, '2014-02-15 00:06:16.000000', 'consum', 0.0226, 'lps'),
	(535724, 128, '2014-02-15 00:06:17.000000', 'consum', 0.0217, 'lps'),
	(535725, 128, '2014-02-15 00:06:18.000000', 'consum', 0.0215, 'lps'),
	(535726, 128, '2014-02-15 00:06:19.000000', 'consum', 0.0215, 'lps'),
	(535727, 128, '2014-02-15 00:06:20.000000', 'consum', 0.0221, 'lps'),
	(535728, 128, '2014-02-15 00:06:21.000000', 'consum', 0.0217, 'lps'),
	(535729, 128, '2014-02-15 00:06:22.000000', 'consum', 0.0213, 'lps'),
	(535730, 128, '2014-02-15 00:06:23.000000', 'consum', 0.0221, 'lps'),
	(535731, 128, '2014-02-15 00:06:24.000000', 'consum', 0.0222, 'lps'),
	(535732, 128, '2014-02-15 00:06:25.000000', 'consum', 0.0220, 'lps'),
	(535733, 128, '2014-02-15 00:06:26.000000', 'consum', 0.0210, 'lps'),
	(535734, 128, '2014-02-15 00:06:27.000000', 'consum', 0.0212, 'lps'),
	(535735, 128, '2014-02-15 00:06:28.000000', 'consum', 0.0220, 'lps'),
	(535736, 128, '2014-02-15 00:06:29.000000', 'consum', 0.0220, 'lps'),
	(535737, 128, '2014-02-15 00:06:30.000000', 'consum', 0.0215, 'lps'),
	(535738, 128, '2014-02-15 00:06:31.000000', 'consum', 0.0224, 'lps'),
	(535739, 128, '2014-02-15 00:06:32.000000', 'consum', 0.0214, 'lps'),
	(535740, 128, '2014-02-15 00:06:33.000000', 'consum', 0.0220, 'lps'),
	(535741, 128, '2014-02-15 00:06:34.000000', 'consum', 0.0217, 'lps'),
	(535742, 128, '2014-02-15 00:06:35.000000', 'consum', 0.0213, 'lps'),
	(535743, 128, '2014-02-15 00:06:36.000000', 'consum', 0.0224, 'lps'),
	(535744, 128, '2014-02-15 00:06:37.000000', 'consum', 0.0220, 'lps'),
	(535745, 128, '2014-02-15 00:06:38.000000', 'consum', 0.0220, 'lps'),
	(535746, 128, '2014-02-15 00:06:39.000000', 'consum', 0.0213, 'lps'),
	(535747, 128, '2014-02-15 00:06:40.000000', 'consum', 0.0212, 'lps'),
	(535748, 128, '2014-02-15 00:06:41.000000', 'consum', 0.0213, 'lps'),
	(535749, 128, '2014-02-15 00:06:42.000000', 'consum', 0.0218, 'lps'),
	(535750, 128, '2014-02-15 00:06:43.000000', 'consum', 0.0223, 'lps'),
	(535751, 128, '2014-02-15 00:06:44.000000', 'consum', 0.0221, 'lps'),
	(535752, 128, '2014-02-15 00:06:45.000000', 'consum', 0.0223, 'lps'),
	(535753, 128, '2014-02-15 00:06:46.000000', 'consum', 0.0211, 'lps'),
	(535754, 128, '2014-02-15 00:06:47.000000', 'consum', 0.0225, 'lps'),
	(535755, 128, '2014-02-15 00:06:48.000000', 'consum', 0.0218, 'lps'),
	(535756, 128, '2014-02-15 00:06:49.000000', 'consum', 0.0219, 'lps'),
	(535757, 128, '2014-02-15 00:06:50.000000', 'consum', 0.0215, 'lps'),
	(535758, 128, '2014-02-15 00:06:51.000000', 'consum', 0.0225, 'lps'),
	(535759, 128, '2014-02-15 00:06:52.000000', 'consum', 0.0221, 'lps'),
	(535760, 128, '2014-02-15 00:06:53.000000', 'consum', 0.0221, 'lps'),
	(535761, 128, '2014-02-15 00:06:54.000000', 'consum', 0.0216, 'lps'),
	(535762, 128, '2014-02-15 00:06:55.000000', 'consum', 0.0223, 'lps'),
	(535763, 128, '2014-02-15 00:06:56.000000', 'consum', 0.0225, 'lps'),
	(535764, 128, '2014-02-15 00:06:57.000000', 'consum', 0.0213, 'lps'),
	(535765, 128, '2014-02-15 00:06:58.000000', 'consum', 0.0215, 'lps'),
	(535766, 128, '2014-02-15 00:06:59.000000', 'consum', 0.0211, 'lps'),
	(535767, 128, '2014-02-15 00:07:00.000000', 'consum', 0.0214, 'lps'),
	(535768, 128, '2014-02-15 00:07:01.000000', 'consum', 0.0213, 'lps'),
	(535769, 128, '2014-02-15 00:07:02.000000', 'consum', 0.0214, 'lps'),
	(535770, 128, '2014-02-15 00:07:03.000000', 'consum', 0.0219, 'lps'),
	(535771, 128, '2014-02-15 00:07:04.000000', 'consum', 0.0225, 'lps'),
	(535772, 128, '2014-02-15 00:07:05.000000', 'consum', 0.0211, 'lps'),
	(535773, 128, '2014-02-15 00:07:06.000000', 'consum', 0.0222, 'lps'),
	(535774, 128, '2014-02-15 00:07:07.000000', 'consum', 0.0214, 'lps'),
	(535775, 128, '2014-02-15 00:07:08.000000', 'consum', 0.0213, 'lps'),
	(535776, 128, '2014-02-15 00:07:09.000000', 'consum', 0.0214, 'lps'),
	(535777, 128, '2014-02-15 00:07:10.000000', 'consum', 0.0221, 'lps'),
	(535778, 128, '2014-02-15 00:07:11.000000', 'consum', 0.0221, 'lps'),
	(535779, 128, '2014-02-15 00:07:12.000000', 'consum', 0.0214, 'lps'),
	(535780, 128, '2014-02-15 00:07:13.000000', 'consum', 0.0213, 'lps'),
	(535781, 128, '2014-02-15 00:07:14.000000', 'consum', 0.0216, 'lps'),
	(535782, 128, '2014-02-15 00:07:15.000000', 'consum', 0.0215, 'lps'),
	(535783, 128, '2014-02-15 00:07:16.000000', 'consum', 0.0217, 'lps'),
	(535784, 128, '2014-02-15 00:07:17.000000', 'consum', 0.0213, 'lps'),
	(535785, 128, '2014-02-15 00:07:18.000000', 'consum', 0.0221, 'lps'),
	(535786, 128, '2014-02-15 00:07:19.000000', 'consum', 0.0223, 'lps'),
	(535787, 128, '2014-02-15 00:07:20.000000', 'consum', 0.0224, 'lps'),
	(535788, 128, '2014-02-15 00:07:21.000000', 'consum', 0.0210, 'lps'),
	(535789, 128, '2014-02-15 00:07:22.000000', 'consum', 0.0218, 'lps'),
	(535790, 128, '2014-02-15 00:07:23.000000', 'consum', 0.0215, 'lps'),
	(535791, 128, '2014-02-15 00:07:24.000000', 'consum', 0.0212, 'lps'),
	(535792, 128, '2014-02-15 00:07:25.000000', 'consum', 0.0224, 'lps'),
	(535793, 128, '2014-02-15 00:07:26.000000', 'consum', 0.0222, 'lps'),
	(535794, 128, '2014-02-15 00:07:27.000000', 'consum', 0.0210, 'lps'),
	(535795, 128, '2014-02-15 00:07:28.000000', 'consum', 0.0210, 'lps'),
	(535796, 128, '2014-02-15 00:07:29.000000', 'consum', 0.0226, 'lps'),
	(535797, 128, '2014-02-15 00:07:30.000000', 'consum', 0.0225, 'lps'),
	(535798, 128, '2014-02-15 00:07:31.000000', 'consum', 0.0220, 'lps'),
	(535799, 128, '2014-02-15 00:07:32.000000', 'consum', 0.0215, 'lps'),
	(535800, 128, '2014-02-15 00:07:33.000000', 'consum', 0.0221, 'lps'),
	(535801, 128, '2014-02-15 00:07:34.000000', 'consum', 0.0218, 'lps'),
	(535802, 128, '2014-02-15 00:07:35.000000', 'consum', 0.0216, 'lps'),
	(535803, 128, '2014-02-15 00:07:36.000000', 'consum', 0.0216, 'lps'),
	(535804, 128, '2014-02-15 00:07:37.000000', 'consum', 0.0224, 'lps'),
	(535805, 128, '2014-02-15 00:07:38.000000', 'consum', 0.0212, 'lps'),
	(535806, 128, '2014-02-15 00:07:39.000000', 'consum', 0.0214, 'lps'),
	(535807, 128, '2014-02-15 00:07:40.000000', 'consum', 0.0223, 'lps'),
	(535808, 128, '2014-02-15 00:07:41.000000', 'consum', 0.0212, 'lps'),
	(535809, 128, '2014-02-15 00:07:42.000000', 'consum', 0.0214, 'lps'),
	(535810, 128, '2014-02-15 00:07:43.000000', 'consum', 0.0210, 'lps'),
	(535811, 128, '2014-02-15 00:07:44.000000', 'consum', 0.0216, 'lps'),
	(535812, 128, '2014-02-15 00:07:45.000000', 'consum', 0.0224, 'lps'),
	(535813, 128, '2014-02-15 00:07:46.000000', 'consum', 0.0211, 'lps'),
	(535814, 128, '2014-02-15 00:07:47.000000', 'consum', 0.0224, 'lps'),
	(535815, 128, '2014-02-15 00:07:48.000000', 'consum', 0.0211, 'lps'),
	(535816, 128, '2014-02-15 00:07:49.000000', 'consum', 0.0222, 'lps'),
	(535817, 128, '2014-02-15 00:07:50.000000', 'consum', 0.0218, 'lps'),
	(535818, 128, '2014-02-15 00:07:51.000000', 'consum', 0.0215, 'lps'),
	(535819, 128, '2014-02-15 00:07:52.000000', 'consum', 0.0211, 'lps'),
	(535820, 128, '2014-02-15 00:07:53.000000', 'consum', 0.0216, 'lps'),
	(535821, 128, '2014-02-15 00:07:54.000000', 'consum', 0.0223, 'lps'),
	(535822, 128, '2014-02-15 00:07:55.000000', 'consum', 0.0224, 'lps'),
	(535823, 128, '2014-02-15 00:07:56.000000', 'consum', 0.0223, 'lps'),
	(535824, 128, '2014-02-15 00:07:57.000000', 'consum', 0.0215, 'lps'),
	(535825, 128, '2014-02-15 00:07:58.000000', 'consum', 0.0215, 'lps'),
	(535826, 128, '2014-02-15 00:07:59.000000', 'consum', 0.0222, 'lps'),
	(535827, 128, '2014-02-15 00:08:00.000000', 'consum', 0.0219, 'lps'),
	(535828, 128, '2014-02-15 00:08:01.000000', 'consum', 0.0221, 'lps'),
	(535829, 128, '2014-02-15 00:08:02.000000', 'consum', 0.0223, 'lps'),
	(535830, 128, '2014-02-15 00:08:03.000000', 'consum', 0.0224, 'lps'),
	(535831, 128, '2014-02-15 00:08:04.000000', 'consum', 0.0224, 'lps'),
	(535832, 128, '2014-02-15 00:08:05.000000', 'consum', 0.0222, 'lps'),
	(535833, 128, '2014-02-15 00:08:06.000000', 'consum', 0.0211, 'lps'),
	(535834, 128, '2014-02-15 00:08:07.000000', 'consum', 0.0212, 'lps'),
	(535835, 128, '2014-02-15 00:08:08.000000', 'consum', 0.0221, 'lps'),
	(535836, 128, '2014-02-15 00:08:09.000000', 'consum', 0.0224, 'lps'),
	(535837, 128, '2014-02-15 00:08:10.000000', 'consum', 0.0212, 'lps'),
	(535838, 128, '2014-02-15 00:08:11.000000', 'consum', 0.0212, 'lps'),
	(535839, 128, '2014-02-15 00:08:12.000000', 'consum', 0.0214, 'lps'),
	(535840, 128, '2014-02-15 00:08:13.000000', 'consum', 0.0226, 'lps'),
	(535841, 128, '2014-02-15 00:08:14.000000', 'consum', 0.0210, 'lps'),
	(535842, 128, '2014-02-15 00:08:15.000000', 'consum', 0.0212, 'lps'),
	(535843, 128, '2014-02-15 00:08:16.000000', 'consum', 0.0223, 'lps'),
	(535844, 128, '2014-02-15 00:08:17.000000', 'consum', 0.0217, 'lps'),
	(535845, 128, '2014-02-15 00:08:18.000000', 'consum', 0.0222, 'lps'),
	(535846, 128, '2014-02-15 00:08:19.000000', 'consum', 0.0216, 'lps'),
	(535847, 128, '2014-02-15 00:08:20.000000', 'consum', 0.0223, 'lps'),
	(535848, 128, '2014-02-15 00:08:21.000000', 'consum', 0.0221, 'lps'),
	(535849, 128, '2014-02-15 00:08:22.000000', 'consum', 0.0211, 'lps'),
	(535850, 128, '2014-02-15 00:08:23.000000', 'consum', 0.0215, 'lps'),
	(535851, 128, '2014-02-15 00:08:24.000000', 'consum', 0.0215, 'lps'),
	(535852, 128, '2014-02-15 00:08:25.000000', 'consum', 0.0221, 'lps'),
	(535853, 128, '2014-02-15 00:08:26.000000', 'consum', 0.0217, 'lps'),
	(535854, 128, '2014-02-15 00:08:27.000000', 'consum', 0.0212, 'lps'),
	(535855, 128, '2014-02-15 00:08:28.000000', 'consum', 0.0215, 'lps'),
	(535856, 128, '2014-02-15 00:08:29.000000', 'consum', 0.0213, 'lps'),
	(535857, 128, '2014-02-15 00:08:30.000000', 'consum', 0.0210, 'lps'),
	(535858, 128, '2014-02-15 00:08:31.000000', 'consum', 0.0220, 'lps'),
	(535859, 128, '2014-02-15 00:08:32.000000', 'consum', 0.0226, 'lps'),
	(535860, 128, '2014-02-15 00:08:33.000000', 'consum', 0.0226, 'lps'),
	(535861, 128, '2014-02-15 00:08:34.000000', 'consum', 0.0211, 'lps'),
	(535862, 128, '2014-02-15 00:08:35.000000', 'consum', 0.0216, 'lps'),
	(535863, 128, '2014-02-15 00:08:36.000000', 'consum', 0.0220, 'lps'),
	(535864, 128, '2014-02-15 00:08:37.000000', 'consum', 0.0224, 'lps'),
	(535865, 128, '2014-02-15 00:08:38.000000', 'consum', 0.0220, 'lps'),
	(535866, 128, '2014-02-15 00:08:39.000000', 'consum', 0.0216, 'lps'),
	(535867, 128, '2014-02-15 00:08:40.000000', 'consum', 0.0210, 'lps'),
	(535868, 128, '2014-02-15 00:08:41.000000', 'consum', 0.0210, 'lps'),
	(535869, 128, '2014-02-15 00:08:42.000000', 'consum', 0.0212, 'lps'),
	(535870, 128, '2014-02-15 00:08:43.000000', 'consum', 0.0221, 'lps'),
	(535871, 128, '2014-02-15 00:08:44.000000', 'consum', 0.0223, 'lps'),
	(535872, 128, '2014-02-15 00:08:45.000000', 'consum', 0.0210, 'lps'),
	(535873, 128, '2014-02-15 00:08:46.000000', 'consum', 0.0222, 'lps'),
	(535874, 128, '2014-02-15 00:08:47.000000', 'consum', 0.0222, 'lps'),
	(535875, 128, '2014-02-15 00:08:48.000000', 'consum', 0.0215, 'lps'),
	(535876, 128, '2014-02-15 00:08:49.000000', 'consum', 0.0215, 'lps'),
	(535877, 128, '2014-02-15 00:08:50.000000', 'consum', 0.0222, 'lps'),
	(535878, 128, '2014-02-15 00:08:51.000000', 'consum', 0.0223, 'lps'),
	(535879, 128, '2014-02-15 00:08:52.000000', 'consum', 0.0221, 'lps'),
	(535880, 128, '2014-02-15 00:08:53.000000', 'consum', 0.0210, 'lps'),
	(535881, 128, '2014-02-15 00:08:54.000000', 'consum', 0.0213, 'lps'),
	(535882, 128, '2014-02-15 00:08:55.000000', 'consum', 0.0225, 'lps'),
	(535883, 128, '2014-02-15 00:08:56.000000', 'consum', 0.0224, 'lps'),
	(535884, 128, '2014-02-15 00:08:57.000000', 'consum', 0.0219, 'lps'),
	(535885, 128, '2014-02-15 00:08:58.000000', 'consum', 0.0215, 'lps'),
	(535886, 128, '2014-02-15 00:08:59.000000', 'consum', 0.0226, 'lps'),
	(535887, 128, '2014-02-15 00:09:00.000000', 'consum', 0.0222, 'lps'),
	(535888, 128, '2014-02-15 00:09:01.000000', 'consum', 0.0224, 'lps'),
	(535889, 128, '2014-02-15 00:09:02.000000', 'consum', 0.0211, 'lps'),
	(535890, 128, '2014-02-15 00:09:03.000000', 'consum', 0.0224, 'lps'),
	(535891, 128, '2014-02-15 00:09:04.000000', 'consum', 0.0225, 'lps'),
	(535892, 128, '2014-02-15 00:09:05.000000', 'consum', 0.0212, 'lps'),
	(535893, 128, '2014-02-15 00:09:06.000000', 'consum', 0.0225, 'lps'),
	(535894, 128, '2014-02-15 00:09:07.000000', 'consum', 0.0211, 'lps'),
	(535895, 128, '2014-02-15 00:09:08.000000', 'consum', 0.0220, 'lps'),
	(535896, 128, '2014-02-15 00:09:09.000000', 'consum', 0.0226, 'lps'),
	(535897, 128, '2014-02-15 00:09:10.000000', 'consum', 0.0225, 'lps'),
	(535898, 128, '2014-02-15 00:09:11.000000', 'consum', 0.0219, 'lps'),
	(535899, 128, '2014-02-15 00:09:12.000000', 'consum', 0.0212, 'lps'),
	(535900, 128, '2014-02-15 00:09:13.000000', 'consum', 0.0212, 'lps'),
	(535901, 128, '2014-02-15 00:09:14.000000', 'consum', 0.0214, 'lps'),
	(535902, 128, '2014-02-15 00:09:15.000000', 'consum', 0.0223, 'lps'),
	(535903, 128, '2014-02-15 00:09:16.000000', 'consum', 0.0214, 'lps'),
	(535904, 128, '2014-02-15 00:09:17.000000', 'consum', 0.0226, 'lps'),
	(535905, 128, '2014-02-15 00:09:18.000000', 'consum', 0.0212, 'lps'),
	(535906, 128, '2014-02-15 00:09:19.000000', 'consum', 0.0221, 'lps'),
	(535907, 128, '2014-02-15 00:09:20.000000', 'consum', 0.0211, 'lps'),
	(535908, 128, '2014-02-15 00:09:21.000000', 'consum', 0.0214, 'lps'),
	(535909, 128, '2014-02-15 00:09:22.000000', 'consum', 0.0213, 'lps'),
	(535910, 128, '2014-02-15 00:09:23.000000', 'consum', 0.0211, 'lps'),
	(535911, 128, '2014-02-15 00:09:24.000000', 'consum', 0.0225, 'lps'),
	(535912, 128, '2014-02-15 00:09:25.000000', 'consum', 0.0212, 'lps'),
	(535913, 128, '2014-02-15 00:09:26.000000', 'consum', 0.0213, 'lps'),
	(535914, 128, '2014-02-15 00:09:27.000000', 'consum', 0.0219, 'lps'),
	(535915, 128, '2014-02-15 00:09:28.000000', 'consum', 0.0210, 'lps'),
	(535916, 128, '2014-02-15 00:09:29.000000', 'consum', 0.0218, 'lps'),
	(535917, 128, '2014-02-15 00:09:30.000000', 'consum', 0.0219, 'lps'),
	(535918, 128, '2014-02-15 00:09:31.000000', 'consum', 0.0212, 'lps'),
	(535919, 128, '2014-02-15 00:09:32.000000', 'consum', 0.0210, 'lps'),
	(535920, 128, '2014-02-15 00:09:33.000000', 'consum', 0.0223, 'lps'),
	(535921, 128, '2014-02-15 00:09:34.000000', 'consum', 0.0226, 'lps'),
	(535922, 128, '2014-02-15 00:09:35.000000', 'consum', 0.0217, 'lps'),
	(535923, 128, '2014-02-15 00:09:36.000000', 'consum', 0.0214, 'lps'),
	(535924, 128, '2014-02-15 00:09:37.000000', 'consum', 0.0211, 'lps'),
	(535925, 128, '2014-02-15 00:09:38.000000', 'consum', 0.0217, 'lps'),
	(535926, 128, '2014-02-15 00:09:39.000000', 'consum', 0.0212, 'lps'),
	(535927, 128, '2014-02-15 00:09:40.000000', 'consum', 0.0215, 'lps'),
	(535928, 128, '2014-02-15 00:09:41.000000', 'consum', 0.0211, 'lps'),
	(535929, 128, '2014-02-15 00:09:42.000000', 'consum', 0.0217, 'lps'),
	(535930, 128, '2014-02-15 00:09:43.000000', 'consum', 0.0226, 'lps'),
	(535931, 128, '2014-02-15 00:09:44.000000', 'consum', 0.0217, 'lps'),
	(535932, 128, '2014-02-15 00:09:45.000000', 'consum', 0.0217, 'lps'),
	(535933, 128, '2014-02-15 00:09:46.000000', 'consum', 0.0222, 'lps'),
	(535934, 128, '2014-02-15 00:09:47.000000', 'consum', 0.0216, 'lps'),
	(535935, 128, '2014-02-15 00:09:48.000000', 'consum', 0.0222, 'lps'),
	(535936, 128, '2014-02-15 00:09:49.000000', 'consum', 0.0216, 'lps'),
	(535937, 128, '2014-02-15 00:09:50.000000', 'consum', 0.0225, 'lps'),
	(535938, 128, '2014-02-15 00:09:51.000000', 'consum', 0.0216, 'lps'),
	(535939, 128, '2014-02-15 00:09:52.000000', 'consum', 0.0213, 'lps'),
	(535940, 128, '2014-02-15 00:09:53.000000', 'consum', 0.0223, 'lps'),
	(535941, 128, '2014-02-15 00:09:54.000000', 'consum', 0.0215, 'lps'),
	(535942, 128, '2014-02-15 00:09:55.000000', 'consum', 0.0216, 'lps'),
	(535943, 128, '2014-02-15 00:09:56.000000', 'consum', 0.0224, 'lps'),
	(535944, 128, '2014-02-15 00:09:57.000000', 'consum', 0.0214, 'lps'),
	(535945, 128, '2014-02-15 00:09:58.000000', 'consum', 0.0220, 'lps'),
	(535946, 128, '2014-02-15 00:09:59.000000', 'consum', 0.0214, 'lps'),
	(535947, 128, '2014-02-15 00:10:00.000000', 'consum', 0.0220, 'lps'),
	(535948, 128, '2014-02-15 00:10:01.000000', 'consum', 0.0213, 'lps'),
	(535949, 128, '2014-02-15 00:10:02.000000', 'consum', 0.0214, 'lps'),
	(535950, 128, '2014-02-15 00:10:03.000000', 'consum', 0.0219, 'lps'),
	(535951, 128, '2014-02-15 00:10:04.000000', 'consum', 0.0211, 'lps'),
	(535952, 128, '2014-02-15 00:10:05.000000', 'consum', 0.0221, 'lps'),
	(535953, 128, '2014-02-15 00:10:06.000000', 'consum', 0.0211, 'lps'),
	(535954, 128, '2014-02-15 00:10:07.000000', 'consum', 0.0218, 'lps'),
	(535955, 128, '2014-02-15 00:10:08.000000', 'consum', 0.0212, 'lps'),
	(535956, 128, '2014-02-15 00:10:09.000000', 'consum', 0.0215, 'lps'),
	(535957, 128, '2014-02-15 00:10:10.000000', 'consum', 0.0211, 'lps'),
	(535958, 128, '2014-02-15 00:10:11.000000', 'consum', 0.0219, 'lps'),
	(535959, 128, '2014-02-15 00:10:12.000000', 'consum', 0.0219, 'lps'),
	(535960, 128, '2014-02-15 00:10:13.000000', 'consum', 0.0226, 'lps'),
	(535961, 128, '2014-02-15 00:10:14.000000', 'consum', 0.0215, 'lps'),
	(535962, 128, '2014-02-15 00:10:15.000000', 'consum', 0.0222, 'lps'),
	(535963, 128, '2014-02-15 00:10:16.000000', 'consum', 0.0219, 'lps'),
	(535964, 128, '2014-02-15 00:10:17.000000', 'consum', 0.0219, 'lps'),
	(535965, 128, '2014-02-15 00:10:18.000000', 'consum', 0.0212, 'lps'),
	(535966, 128, '2014-02-15 00:10:19.000000', 'consum', 0.0212, 'lps'),
	(535967, 128, '2014-02-15 00:10:20.000000', 'consum', 0.0215, 'lps'),
	(535968, 128, '2014-02-15 00:10:21.000000', 'consum', 0.0212, 'lps'),
	(535969, 128, '2014-02-15 00:10:22.000000', 'consum', 0.0224, 'lps'),
	(535970, 128, '2014-02-15 00:10:23.000000', 'consum', 0.0222, 'lps'),
	(535971, 128, '2014-02-15 00:10:24.000000', 'consum', 0.0210, 'lps'),
	(535972, 128, '2014-02-15 00:10:25.000000', 'consum', 0.0210, 'lps'),
	(535973, 128, '2014-02-15 00:10:26.000000', 'consum', 0.0226, 'lps'),
	(535974, 128, '2014-02-15 00:10:27.000000', 'consum', 0.0222, 'lps'),
	(535975, 128, '2014-02-15 00:10:28.000000', 'consum', 0.0224, 'lps'),
	(535976, 128, '2014-02-15 00:10:29.000000', 'consum', 0.0210, 'lps'),
	(535977, 128, '2014-02-15 00:10:30.000000', 'consum', 0.0218, 'lps'),
	(535978, 128, '2014-02-15 00:10:31.000000', 'consum', 0.0219, 'lps'),
	(535979, 128, '2014-02-15 00:10:32.000000', 'consum', 0.0214, 'lps'),
	(535980, 128, '2014-02-15 00:10:33.000000', 'consum', 0.0219, 'lps'),
	(535981, 128, '2014-02-15 00:10:34.000000', 'consum', 0.0211, 'lps'),
	(535982, 128, '2014-02-15 00:10:35.000000', 'consum', 0.0220, 'lps'),
	(535983, 128, '2014-02-15 00:10:36.000000', 'consum', 0.0225, 'lps'),
	(535984, 128, '2014-02-15 00:10:37.000000', 'consum', 0.0223, 'lps'),
	(535985, 128, '2014-02-15 00:10:38.000000', 'consum', 0.0214, 'lps'),
	(535986, 128, '2014-02-15 00:10:39.000000', 'consum', 0.0226, 'lps'),
	(535987, 128, '2014-02-15 00:10:40.000000', 'consum', 0.0226, 'lps'),
	(535988, 128, '2014-02-15 00:10:41.000000', 'consum', 0.0224, 'lps'),
	(535989, 128, '2014-02-15 00:10:42.000000', 'consum', 0.0218, 'lps'),
	(535990, 128, '2014-02-15 00:10:43.000000', 'consum', 0.0225, 'lps'),
	(535991, 128, '2014-02-15 00:10:44.000000', 'consum', 0.0210, 'lps'),
	(535992, 128, '2014-02-15 00:10:45.000000', 'consum', 0.0216, 'lps'),
	(535993, 128, '2014-02-15 00:10:46.000000', 'consum', 0.0224, 'lps'),
	(535994, 128, '2014-02-15 00:10:47.000000', 'consum', 0.0210, 'lps'),
	(535995, 128, '2014-02-15 00:10:48.000000', 'consum', 0.0220, 'lps'),
	(535996, 128, '2014-02-15 00:10:49.000000', 'consum', 0.0212, 'lps'),
	(535997, 128, '2014-02-15 00:10:50.000000', 'consum', 0.0223, 'lps'),
	(535998, 128, '2014-02-15 00:10:51.000000', 'consum', 0.0217, 'lps'),
	(535999, 128, '2014-02-15 00:10:52.000000', 'consum', 0.0224, 'lps'),
	(536000, 128, '2014-02-15 00:10:53.000000', 'consum', 0.0210, 'lps'),
	(536001, 128, '2014-02-15 00:10:54.000000', 'consum', 0.0221, 'lps'),
	(536002, 128, '2014-02-15 00:10:55.000000', 'consum', 0.0212, 'lps'),
	(536003, 128, '2014-02-15 00:10:56.000000', 'consum', 0.0220, 'lps'),
	(536004, 128, '2014-02-15 00:10:57.000000', 'consum', 0.0223, 'lps'),
	(536005, 128, '2014-02-15 00:10:58.000000', 'consum', 0.0212, 'lps'),
	(536006, 128, '2014-02-15 00:10:59.000000', 'consum', 0.0216, 'lps'),
	(536007, 128, '2014-02-15 00:11:00.000000', 'consum', 0.0214, 'lps'),
	(536008, 128, '2014-02-15 00:11:01.000000', 'consum', 0.0216, 'lps'),
	(536009, 128, '2014-02-15 00:11:02.000000', 'consum', 0.0211, 'lps'),
	(536010, 128, '2014-02-15 00:11:03.000000', 'consum', 0.0214, 'lps'),
	(536011, 128, '2014-02-15 00:11:04.000000', 'consum', 0.0226, 'lps'),
	(536012, 128, '2014-02-15 00:11:05.000000', 'consum', 0.0212, 'lps'),
	(536013, 128, '2014-02-15 00:11:06.000000', 'consum', 0.0224, 'lps'),
	(536014, 128, '2014-02-15 00:11:07.000000', 'consum', 0.0224, 'lps'),
	(536015, 128, '2014-02-15 00:11:08.000000', 'consum', 0.0219, 'lps'),
	(536016, 128, '2014-02-15 00:11:09.000000', 'consum', 0.0216, 'lps'),
	(536017, 128, '2014-02-15 00:11:10.000000', 'consum', 0.0215, 'lps'),
	(536018, 128, '2014-02-15 00:11:11.000000', 'consum', 0.0214, 'lps'),
	(536019, 128, '2014-02-15 00:11:12.000000', 'consum', 0.0218, 'lps'),
	(536020, 128, '2014-02-15 00:11:13.000000', 'consum', 0.0222, 'lps'),
	(536021, 128, '2014-02-15 00:11:14.000000', 'consum', 0.0213, 'lps'),
	(536022, 128, '2014-02-15 00:11:15.000000', 'consum', 0.0221, 'lps'),
	(536023, 128, '2014-02-15 00:11:16.000000', 'consum', 0.0225, 'lps'),
	(536024, 128, '2014-02-15 00:11:17.000000', 'consum', 0.0219, 'lps'),
	(536025, 128, '2014-02-15 00:11:18.000000', 'consum', 0.0211, 'lps'),
	(536026, 128, '2014-02-15 00:11:19.000000', 'consum', 0.0223, 'lps'),
	(536027, 128, '2014-02-15 00:11:20.000000', 'consum', 0.0220, 'lps'),
	(536028, 128, '2014-02-15 00:11:21.000000', 'consum', 0.0223, 'lps'),
	(536029, 128, '2014-02-15 00:11:22.000000', 'consum', 0.0213, 'lps'),
	(536030, 128, '2014-02-15 00:11:23.000000', 'consum', 0.0218, 'lps'),
	(536031, 128, '2014-02-15 00:11:24.000000', 'consum', 0.0225, 'lps'),
	(536032, 128, '2014-02-15 00:11:25.000000', 'consum', 0.0211, 'lps'),
	(536033, 128, '2014-02-15 00:11:26.000000', 'consum', 0.0219, 'lps'),
	(536034, 128, '2014-02-15 00:11:27.000000', 'consum', 0.0222, 'lps'),
	(536035, 128, '2014-02-15 00:11:28.000000', 'consum', 0.0223, 'lps'),
	(536036, 128, '2014-02-15 00:11:29.000000', 'consum', 0.0224, 'lps'),
	(536037, 128, '2014-02-15 00:11:30.000000', 'consum', 0.0226, 'lps'),
	(536038, 128, '2014-02-15 00:11:31.000000', 'consum', 0.0215, 'lps'),
	(536039, 128, '2014-02-15 00:11:32.000000', 'consum', 0.0220, 'lps'),
	(536040, 128, '2014-02-15 00:11:33.000000', 'consum', 0.0211, 'lps'),
	(536041, 128, '2014-02-15 00:11:34.000000', 'consum', 0.0220, 'lps'),
	(536042, 128, '2014-02-15 00:11:35.000000', 'consum', 0.0224, 'lps'),
	(536043, 128, '2014-02-15 00:11:36.000000', 'consum', 0.0215, 'lps'),
	(536044, 128, '2014-02-15 00:11:37.000000', 'consum', 0.0211, 'lps'),
	(536045, 128, '2014-02-15 00:11:38.000000', 'consum', 0.0216, 'lps'),
	(536046, 128, '2014-02-15 00:11:39.000000', 'consum', 0.0223, 'lps'),
	(536047, 128, '2014-02-15 00:11:40.000000', 'consum', 0.0221, 'lps'),
	(536048, 128, '2014-02-15 00:11:41.000000', 'consum', 0.0212, 'lps'),
	(536049, 128, '2014-02-15 00:11:42.000000', 'consum', 0.0221, 'lps'),
	(536050, 128, '2014-02-15 00:11:43.000000', 'consum', 0.0210, 'lps'),
	(536051, 128, '2014-02-15 00:11:44.000000', 'consum', 0.0210, 'lps'),
	(536052, 128, '2014-02-15 00:11:45.000000', 'consum', 0.0226, 'lps'),
	(536053, 128, '2014-02-15 00:11:46.000000', 'consum', 0.0222, 'lps'),
	(536054, 128, '2014-02-15 00:11:47.000000', 'consum', 0.0225, 'lps'),
	(536055, 128, '2014-02-15 00:11:48.000000', 'consum', 0.0213, 'lps'),
	(536056, 128, '2014-02-15 00:11:49.000000', 'consum', 0.0215, 'lps'),
	(536057, 128, '2014-02-15 00:11:50.000000', 'consum', 0.0211, 'lps'),
	(536058, 128, '2014-02-15 00:11:51.000000', 'consum', 0.0215, 'lps'),
	(536059, 128, '2014-02-15 00:11:52.000000', 'consum', 0.0218, 'lps'),
	(536060, 128, '2014-02-15 00:11:53.000000', 'consum', 0.0217, 'lps'),
	(536061, 128, '2014-02-15 00:11:54.000000', 'consum', 0.0221, 'lps'),
	(536062, 128, '2014-02-15 00:11:55.000000', 'consum', 0.0211, 'lps'),
	(536063, 128, '2014-02-15 00:11:56.000000', 'consum', 0.0217, 'lps'),
	(536064, 128, '2014-02-15 00:11:57.000000', 'consum', 0.0225, 'lps'),
	(536065, 128, '2014-02-15 00:11:58.000000', 'consum', 0.0212, 'lps'),
	(536066, 128, '2014-02-15 00:11:59.000000', 'consum', 0.0211, 'lps'),
	(536067, 128, '2014-02-15 00:12:00.000000', 'consum', 0.0210, 'lps'),
	(536068, 128, '2014-02-15 00:12:01.000000', 'consum', 0.0225, 'lps'),
	(536069, 128, '2014-02-15 00:12:02.000000', 'consum', 0.0218, 'lps'),
	(536070, 128, '2014-02-15 00:12:03.000000', 'consum', 0.0221, 'lps'),
	(536071, 128, '2014-02-15 00:12:04.000000', 'consum', 0.0226, 'lps'),
	(536072, 128, '2014-02-15 00:12:05.000000', 'consum', 0.0223, 'lps'),
	(536073, 128, '2014-02-15 00:12:06.000000', 'consum', 0.0211, 'lps'),
	(536074, 128, '2014-02-15 00:12:07.000000', 'consum', 0.0226, 'lps'),
	(536075, 128, '2014-02-15 00:12:08.000000', 'consum', 0.0221, 'lps'),
	(536076, 128, '2014-02-15 00:12:09.000000', 'consum', 0.0215, 'lps'),
	(536077, 128, '2014-02-15 00:12:10.000000', 'consum', 0.0221, 'lps'),
	(536078, 128, '2014-02-15 00:12:11.000000', 'consum', 0.0217, 'lps'),
	(536079, 128, '2014-02-15 00:12:12.000000', 'consum', 0.0211, 'lps'),
	(536080, 128, '2014-02-15 00:12:13.000000', 'consum', 0.0212, 'lps'),
	(536081, 128, '2014-02-15 00:12:14.000000', 'consum', 0.0220, 'lps'),
	(536082, 128, '2014-02-15 00:12:15.000000', 'consum', 0.0217, 'lps'),
	(536083, 128, '2014-02-15 00:12:16.000000', 'consum', 0.0217, 'lps'),
	(536084, 128, '2014-02-15 00:12:17.000000', 'consum', 0.0222, 'lps'),
	(536085, 128, '2014-02-15 00:12:18.000000', 'consum', 0.0218, 'lps'),
	(536086, 128, '2014-02-15 00:12:19.000000', 'consum', 0.0214, 'lps'),
	(536087, 128, '2014-02-15 00:12:20.000000', 'consum', 0.0225, 'lps'),
	(536088, 128, '2014-02-15 00:12:21.000000', 'consum', 0.0223, 'lps'),
	(536089, 128, '2014-02-15 00:12:22.000000', 'consum', 0.0211, 'lps'),
	(536090, 128, '2014-02-15 00:12:23.000000', 'consum', 0.0212, 'lps'),
	(536091, 128, '2014-02-15 00:12:24.000000', 'consum', 0.0217, 'lps'),
	(536092, 128, '2014-02-15 00:12:25.000000', 'consum', 0.0223, 'lps'),
	(536093, 128, '2014-02-15 00:12:26.000000', 'consum', 0.0220, 'lps'),
	(536094, 128, '2014-02-15 00:12:27.000000', 'consum', 0.0221, 'lps'),
	(536095, 128, '2014-02-15 00:12:28.000000', 'consum', 0.0217, 'lps'),
	(536096, 128, '2014-02-15 00:12:29.000000', 'consum', 0.0215, 'lps'),
	(536097, 128, '2014-02-15 00:12:30.000000', 'consum', 0.0213, 'lps'),
	(536098, 128, '2014-02-15 00:12:31.000000', 'consum', 0.0210, 'lps'),
	(536099, 128, '2014-02-15 00:12:32.000000', 'consum', 0.0219, 'lps'),
	(536100, 128, '2014-02-15 00:12:33.000000', 'consum', 0.0222, 'lps'),
	(536101, 128, '2014-02-15 00:12:34.000000', 'consum', 0.0225, 'lps'),
	(536102, 128, '2014-02-15 00:12:35.000000', 'consum', 0.0216, 'lps'),
	(536103, 128, '2014-02-15 00:12:36.000000', 'consum', 0.0212, 'lps'),
	(536104, 128, '2014-02-15 00:12:37.000000', 'consum', 0.0221, 'lps'),
	(536105, 128, '2014-02-15 00:12:38.000000', 'consum', 0.0224, 'lps'),
	(536106, 128, '2014-02-15 00:12:39.000000', 'consum', 0.0214, 'lps'),
	(536107, 128, '2014-02-15 00:12:40.000000', 'consum', 0.0222, 'lps'),
	(536108, 128, '2014-02-15 00:12:41.000000', 'consum', 0.0223, 'lps'),
	(536109, 128, '2014-02-15 00:12:42.000000', 'consum', 0.0225, 'lps'),
	(536110, 128, '2014-02-15 00:12:43.000000', 'consum', 0.0210, 'lps'),
	(536111, 128, '2014-02-15 00:12:44.000000', 'consum', 0.0219, 'lps'),
	(536112, 128, '2014-02-15 00:12:45.000000', 'consum', 0.0220, 'lps'),
	(536113, 128, '2014-02-15 00:12:46.000000', 'consum', 0.0216, 'lps'),
	(536114, 128, '2014-02-15 00:12:47.000000', 'consum', 0.0210, 'lps'),
	(536115, 128, '2014-02-15 00:12:48.000000', 'consum', 0.0211, 'lps'),
	(536116, 128, '2014-02-15 00:12:49.000000', 'consum', 0.0215, 'lps'),
	(536117, 128, '2014-02-15 00:12:50.000000', 'consum', 0.0215, 'lps'),
	(536118, 128, '2014-02-15 00:12:51.000000', 'consum', 0.0222, 'lps'),
	(536119, 128, '2014-02-15 00:12:52.000000', 'consum', 0.0221, 'lps'),
	(536120, 128, '2014-02-15 00:12:53.000000', 'consum', 0.0213, 'lps'),
	(536121, 128, '2014-02-15 00:12:54.000000', 'consum', 0.0224, 'lps'),
	(536122, 128, '2014-02-15 00:12:55.000000', 'consum', 0.0222, 'lps'),
	(536123, 128, '2014-02-15 00:12:56.000000', 'consum', 0.0213, 'lps'),
	(536124, 128, '2014-02-15 00:12:57.000000', 'consum', 0.0222, 'lps'),
	(536125, 128, '2014-02-15 00:12:58.000000', 'consum', 0.0210, 'lps'),
	(536126, 128, '2014-02-15 00:12:59.000000', 'consum', 0.0224, 'lps'),
	(536127, 128, '2014-02-15 00:13:00.000000', 'consum', 0.0214, 'lps'),
	(536128, 128, '2014-02-15 00:13:01.000000', 'consum', 0.0224, 'lps'),
	(536129, 128, '2014-02-15 00:13:02.000000', 'consum', 0.0216, 'lps'),
	(536130, 128, '2014-02-15 00:13:03.000000', 'consum', 0.0214, 'lps'),
	(536131, 128, '2014-02-15 00:13:04.000000', 'consum', 0.0212, 'lps'),
	(536132, 128, '2014-02-15 00:13:05.000000', 'consum', 0.0211, 'lps'),
	(536133, 128, '2014-02-15 00:13:06.000000', 'consum', 0.0225, 'lps'),
	(536134, 128, '2014-02-15 00:13:07.000000', 'consum', 0.0217, 'lps'),
	(536135, 128, '2014-02-15 00:13:08.000000', 'consum', 0.0215, 'lps'),
	(536136, 128, '2014-02-15 00:13:09.000000', 'consum', 0.0214, 'lps'),
	(536137, 128, '2014-02-15 00:13:10.000000', 'consum', 0.0217, 'lps'),
	(536138, 128, '2014-02-15 00:13:11.000000', 'consum', 0.0218, 'lps'),
	(536139, 128, '2014-02-15 00:13:12.000000', 'consum', 0.0210, 'lps'),
	(536140, 128, '2014-02-15 00:13:13.000000', 'consum', 0.0222, 'lps'),
	(536141, 128, '2014-02-15 00:13:14.000000', 'consum', 0.0218, 'lps'),
	(536142, 128, '2014-02-15 00:13:15.000000', 'consum', 0.0214, 'lps'),
	(536143, 128, '2014-02-15 00:13:16.000000', 'consum', 0.0225, 'lps'),
	(536144, 128, '2014-02-15 00:13:17.000000', 'consum', 0.0222, 'lps'),
	(536145, 128, '2014-02-15 00:13:18.000000', 'consum', 0.0224, 'lps'),
	(536146, 128, '2014-02-15 00:13:19.000000', 'consum', 0.0210, 'lps'),
	(536147, 128, '2014-02-15 00:13:20.000000', 'consum', 0.0219, 'lps'),
	(536148, 128, '2014-02-15 00:13:21.000000', 'consum', 0.0224, 'lps'),
	(536149, 128, '2014-02-15 00:13:22.000000', 'consum', 0.0220, 'lps'),
	(536150, 128, '2014-02-15 00:13:23.000000', 'consum', 0.0216, 'lps'),
	(536151, 128, '2014-02-15 00:13:24.000000', 'consum', 0.0211, 'lps'),
	(536152, 128, '2014-02-15 00:13:25.000000', 'consum', 0.0215, 'lps'),
	(536153, 128, '2014-02-15 00:13:26.000000', 'consum', 0.0215, 'lps'),
	(536154, 128, '2014-02-15 00:13:27.000000', 'consum', 0.0221, 'lps'),
	(536155, 128, '2014-02-15 00:13:28.000000', 'consum', 0.0217, 'lps'),
	(536156, 128, '2014-02-15 00:13:29.000000', 'consum', 0.0212, 'lps'),
	(536157, 128, '2014-02-15 00:13:30.000000', 'consum', 0.0217, 'lps'),
	(536158, 128, '2014-02-15 00:13:31.000000', 'consum', 0.0220, 'lps'),
	(536159, 128, '2014-02-15 00:13:32.000000', 'consum', 0.0226, 'lps'),
	(536160, 128, '2014-02-15 00:13:33.000000', 'consum', 0.0225, 'lps'),
	(536161, 128, '2014-02-15 00:13:34.000000', 'consum', 0.0219, 'lps'),
	(536162, 128, '2014-02-15 00:13:35.000000', 'consum', 0.0212, 'lps'),
	(536163, 128, '2014-02-15 00:13:36.000000', 'consum', 0.0211, 'lps'),
	(536164, 128, '2014-02-15 00:13:37.000000', 'consum', 0.0211, 'lps'),
	(536165, 128, '2014-02-15 00:13:38.000000', 'consum', 0.0211, 'lps'),
	(536166, 128, '2014-02-15 00:13:39.000000', 'consum', 0.0214, 'lps'),
	(536167, 128, '2014-02-15 00:13:40.000000', 'consum', 0.0226, 'lps'),
	(536168, 128, '2014-02-15 00:13:41.000000', 'consum', 0.0210, 'lps'),
	(536169, 128, '2014-02-15 00:13:42.000000', 'consum', 0.0214, 'lps'),
	(536170, 128, '2014-02-15 00:13:43.000000', 'consum', 0.0215, 'lps'),
	(536171, 128, '2014-02-15 00:13:44.000000', 'consum', 0.0224, 'lps'),
	(536172, 128, '2014-02-15 00:13:45.000000', 'consum', 0.0214, 'lps'),
	(536173, 128, '2014-02-15 00:13:46.000000', 'consum', 0.0222, 'lps'),
	(536174, 128, '2014-02-15 00:13:47.000000', 'consum', 0.0225, 'lps'),
	(536175, 128, '2014-02-15 00:13:48.000000', 'consum', 0.0214, 'lps'),
	(536176, 128, '2014-02-15 00:13:49.000000', 'consum', 0.0218, 'lps'),
	(536177, 128, '2014-02-15 00:13:50.000000', 'consum', 0.0225, 'lps'),
	(536178, 128, '2014-02-15 00:13:51.000000', 'consum', 0.0225, 'lps'),
	(536179, 128, '2014-02-15 00:13:52.000000', 'consum', 0.0224, 'lps'),
	(536180, 128, '2014-02-15 00:13:53.000000', 'consum', 0.0220, 'lps'),
	(536181, 128, '2014-02-15 00:13:54.000000', 'consum', 0.0219, 'lps'),
	(536182, 128, '2014-02-15 00:13:55.000000', 'consum', 0.0224, 'lps'),
	(536183, 128, '2014-02-15 00:13:56.000000', 'consum', 0.0218, 'lps'),
	(536184, 128, '2014-02-15 00:13:57.000000', 'consum', 0.0211, 'lps'),
	(536185, 128, '2014-02-15 00:13:58.000000', 'consum', 0.0224, 'lps'),
	(536186, 128, '2014-02-15 00:13:59.000000', 'consum', 0.0226, 'lps'),
	(536187, 128, '2014-02-15 00:14:00.000000', 'consum', 0.0215, 'lps'),
	(536188, 128, '2014-02-15 00:14:01.000000', 'consum', 0.0222, 'lps'),
	(536189, 128, '2014-02-15 00:14:02.000000', 'consum', 0.0221, 'lps'),
	(536190, 128, '2014-02-15 00:14:03.000000', 'consum', 0.0214, 'lps'),
	(536191, 128, '2014-02-15 00:14:04.000000', 'consum', 0.0212, 'lps'),
	(536192, 128, '2014-02-15 00:14:05.000000', 'consum', 0.0225, 'lps'),
	(536193, 128, '2014-02-15 00:14:06.000000', 'consum', 0.0214, 'lps'),
	(536194, 128, '2014-02-15 00:14:07.000000', 'consum', 0.0217, 'lps'),
	(536195, 128, '2014-02-15 00:14:08.000000', 'consum', 0.0218, 'lps'),
	(536196, 128, '2014-02-15 00:14:09.000000', 'consum', 0.0213, 'lps'),
	(536197, 128, '2014-02-15 00:14:10.000000', 'consum', 0.0219, 'lps'),
	(536198, 128, '2014-02-15 00:14:11.000000', 'consum', 0.0213, 'lps'),
	(536199, 128, '2014-02-15 00:14:12.000000', 'consum', 0.0213, 'lps'),
	(536200, 128, '2014-02-15 00:14:13.000000', 'consum', 0.0216, 'lps'),
	(536201, 128, '2014-02-15 00:14:14.000000', 'consum', 0.0214, 'lps'),
	(536202, 128, '2014-02-15 00:14:15.000000', 'consum', 0.0214, 'lps'),
	(536203, 128, '2014-02-15 00:14:16.000000', 'consum', 0.0219, 'lps'),
	(536204, 128, '2014-02-15 00:14:17.000000', 'consum', 0.0226, 'lps'),
	(536205, 128, '2014-02-15 00:14:18.000000', 'consum', 0.0215, 'lps'),
	(536206, 128, '2014-02-15 00:14:19.000000', 'consum', 0.0218, 'lps'),
	(536207, 128, '2014-02-15 00:14:20.000000', 'consum', 0.0219, 'lps'),
	(536208, 128, '2014-02-15 00:14:21.000000', 'consum', 0.0213, 'lps'),
	(536209, 128, '2014-02-15 00:14:22.000000', 'consum', 0.0216, 'lps'),
	(536210, 128, '2014-02-15 00:14:23.000000', 'consum', 0.0217, 'lps'),
	(536211, 128, '2014-02-15 00:14:24.000000', 'consum', 0.0210, 'lps'),
	(536212, 128, '2014-02-15 00:14:25.000000', 'consum', 0.0222, 'lps'),
	(536213, 128, '2014-02-15 00:14:26.000000', 'consum', 0.0221, 'lps'),
	(536214, 128, '2014-02-15 00:14:27.000000', 'consum', 0.0211, 'lps'),
	(536215, 128, '2014-02-15 00:14:28.000000', 'consum', 0.0216, 'lps'),
	(536216, 128, '2014-02-15 00:14:29.000000', 'consum', 0.0222, 'lps'),
	(536217, 128, '2014-02-15 00:14:30.000000', 'consum', 0.0218, 'lps'),
	(536218, 128, '2014-02-15 00:14:31.000000', 'consum', 0.0216, 'lps'),
	(536219, 128, '2014-02-15 00:14:32.000000', 'consum', 0.0217, 'lps'),
	(536220, 128, '2014-02-15 00:14:33.000000', 'consum', 0.0226, 'lps'),
	(536221, 128, '2014-02-15 00:14:34.000000', 'consum', 0.0221, 'lps'),
	(536222, 128, '2014-02-15 00:14:35.000000', 'consum', 0.0215, 'lps'),
	(536223, 128, '2014-02-15 00:14:36.000000', 'consum', 0.0218, 'lps'),
	(536224, 128, '2014-02-15 00:14:37.000000', 'consum', 0.0221, 'lps'),
	(536225, 128, '2014-02-15 00:14:38.000000', 'consum', 0.0223, 'lps'),
	(536226, 128, '2014-02-15 00:14:39.000000', 'consum', 0.0210, 'lps'),
	(536227, 128, '2014-02-15 00:14:40.000000', 'consum', 0.0223, 'lps'),
	(536228, 128, '2014-02-15 00:14:41.000000', 'consum', 0.0225, 'lps'),
	(536229, 128, '2014-02-15 00:14:42.000000', 'consum', 0.0210, 'lps'),
	(536230, 128, '2014-02-15 00:14:43.000000', 'consum', 0.0216, 'lps'),
	(536231, 128, '2014-02-15 00:14:44.000000', 'consum', 0.0225, 'lps'),
	(536232, 128, '2014-02-15 00:14:45.000000', 'consum', 0.0216, 'lps'),
	(536233, 128, '2014-02-15 00:14:46.000000', 'consum', 0.0212, 'lps'),
	(536234, 128, '2014-02-15 00:14:47.000000', 'consum', 0.0220, 'lps'),
	(536235, 128, '2014-02-15 00:14:48.000000', 'consum', 0.0221, 'lps'),
	(536236, 128, '2014-02-15 00:14:49.000000', 'consum', 0.0216, 'lps'),
	(536237, 128, '2014-02-15 00:14:50.000000', 'consum', 0.0211, 'lps'),
	(536238, 128, '2014-02-15 00:14:51.000000', 'consum', 0.0211, 'lps'),
	(536239, 128, '2014-02-15 00:14:52.000000', 'consum', 0.0214, 'lps'),
	(536240, 128, '2014-02-15 00:14:53.000000', 'consum', 0.0210, 'lps'),
	(536241, 128, '2014-02-15 00:14:54.000000', 'consum', 0.0215, 'lps'),
	(536242, 128, '2014-02-15 00:14:55.000000', 'consum', 0.0219, 'lps'),
	(536243, 128, '2014-02-15 00:14:56.000000', 'consum', 0.0223, 'lps'),
	(536244, 128, '2014-02-15 00:14:57.000000', 'consum', 0.0216, 'lps'),
	(536245, 128, '2014-02-15 00:14:58.000000', 'consum', 0.0219, 'lps'),
	(536246, 128, '2014-02-15 00:14:59.000000', 'consum', 0.0221, 'lps'),
	(536247, 128, '2014-02-15 00:15:00.000000', 'consum', 0.0221, 'lps'),
	(536248, 128, '2014-02-15 00:15:01.000000', 'consum', 0.0215, 'lps'),
	(536249, 128, '2014-02-15 00:15:02.000000', 'consum', 0.0219, 'lps'),
	(536250, 128, '2014-02-15 00:15:03.000000', 'consum', 0.0223, 'lps'),
	(536251, 128, '2014-02-15 00:15:04.000000', 'consum', 0.0214, 'lps'),
	(536252, 128, '2014-02-15 00:15:05.000000', 'consum', 0.0211, 'lps'),
	(536253, 128, '2014-02-15 00:15:06.000000', 'consum', 0.0220, 'lps'),
	(536254, 128, '2014-02-15 00:15:07.000000', 'consum', 0.0221, 'lps'),
	(536255, 128, '2014-02-15 00:15:08.000000', 'consum', 0.0221, 'lps'),
	(536256, 128, '2014-02-15 00:15:09.000000', 'consum', 0.0216, 'lps'),
	(536257, 128, '2014-02-15 00:15:10.000000', 'consum', 0.0223, 'lps'),
	(536258, 128, '2014-02-15 00:15:11.000000', 'consum', 0.0224, 'lps'),
	(536259, 128, '2014-02-15 00:15:12.000000', 'consum', 0.0225, 'lps'),
	(536260, 128, '2014-02-15 00:15:13.000000', 'consum', 0.0224, 'lps'),
	(536261, 128, '2014-02-15 00:15:14.000000', 'consum', 0.0220, 'lps'),
	(536262, 128, '2014-02-15 00:15:15.000000', 'consum', 0.0219, 'lps'),
	(536263, 128, '2014-02-15 00:15:16.000000', 'consum', 0.0210, 'lps'),
	(536264, 128, '2014-02-15 00:15:17.000000', 'consum', 0.0216, 'lps'),
	(536265, 128, '2014-02-15 00:15:18.000000', 'consum', 0.0222, 'lps'),
	(536266, 128, '2014-02-15 00:15:19.000000', 'consum', 0.0218, 'lps'),
	(536267, 128, '2014-02-15 00:15:20.000000', 'consum', 0.0214, 'lps'),
	(536268, 128, '2014-02-15 00:15:21.000000', 'consum', 0.0223, 'lps'),
	(536269, 128, '2014-02-15 00:15:22.000000', 'consum', 0.0215, 'lps'),
	(536270, 128, '2014-02-15 00:15:23.000000', 'consum', 0.0211, 'lps'),
	(536271, 128, '2014-02-15 00:15:24.000000', 'consum', 0.0220, 'lps'),
	(536272, 128, '2014-02-15 00:15:25.000000', 'consum', 0.0222, 'lps'),
	(536273, 128, '2014-02-15 00:15:26.000000', 'consum', 0.0226, 'lps'),
	(536274, 128, '2014-02-15 00:15:27.000000', 'consum', 0.0219, 'lps'),
	(536275, 128, '2014-02-15 00:15:28.000000', 'consum', 0.0224, 'lps'),
	(536276, 128, '2014-02-15 00:15:29.000000', 'consum', 0.0219, 'lps'),
	(536277, 128, '2014-02-15 00:15:30.000000', 'consum', 0.0216, 'lps'),
	(536278, 128, '2014-02-15 00:15:31.000000', 'consum', 0.0212, 'lps'),
	(536279, 128, '2014-02-15 00:15:32.000000', 'consum', 0.0220, 'lps'),
	(536280, 128, '2014-02-15 00:15:33.000000', 'consum', 0.0222, 'lps'),
	(536281, 128, '2014-02-15 00:15:34.000000', 'consum', 0.0221, 'lps'),
	(536282, 128, '2014-02-15 00:15:35.000000', 'consum', 0.0213, 'lps'),
	(536283, 128, '2014-02-15 00:15:36.000000', 'consum', 0.0226, 'lps'),
	(536284, 128, '2014-02-15 00:15:37.000000', 'consum', 0.0212, 'lps'),
	(536285, 128, '2014-02-15 00:15:38.000000', 'consum', 0.0225, 'lps'),
	(536286, 128, '2014-02-15 00:15:39.000000', 'consum', 0.0210, 'lps'),
	(536287, 128, '2014-02-15 00:15:40.000000', 'consum', 0.0219, 'lps'),
	(536288, 128, '2014-02-15 00:15:41.000000', 'consum', 0.0221, 'lps'),
	(536289, 128, '2014-02-15 00:15:42.000000', 'consum', 0.0221, 'lps'),
	(536290, 128, '2014-02-15 00:15:43.000000', 'consum', 0.0217, 'lps'),
	(536291, 128, '2014-02-15 00:15:44.000000', 'consum', 0.0213, 'lps'),
	(536292, 128, '2014-02-15 00:15:45.000000', 'consum', 0.0222, 'lps'),
	(536293, 128, '2014-02-15 00:15:46.000000', 'consum', 0.0211, 'lps'),
	(536294, 128, '2014-02-15 00:15:47.000000', 'consum', 0.0212, 'lps'),
	(536295, 128, '2014-02-15 00:15:48.000000', 'consum', 0.0220, 'lps'),
	(536296, 128, '2014-02-15 00:15:49.000000', 'consum', 0.0218, 'lps'),
	(536297, 128, '2014-02-15 00:15:50.000000', 'consum', 0.0223, 'lps'),
	(536298, 128, '2014-02-15 00:15:51.000000', 'consum', 0.0217, 'lps'),
	(536299, 128, '2014-02-15 00:15:52.000000', 'consum', 0.0223, 'lps'),
	(536300, 128, '2014-02-15 00:15:53.000000', 'consum', 0.0220, 'lps'),
	(536301, 128, '2014-02-15 00:15:54.000000', 'consum', 0.0224, 'lps'),
	(536302, 128, '2014-02-15 00:15:55.000000', 'consum', 0.0215, 'lps'),
	(536303, 128, '2014-02-15 00:15:56.000000', 'consum', 0.0225, 'lps'),
	(536304, 128, '2014-02-15 00:15:57.000000', 'consum', 0.0223, 'lps'),
	(536305, 128, '2014-02-15 00:15:58.000000', 'consum', 0.0213, 'lps'),
	(536306, 128, '2014-02-15 00:15:59.000000', 'consum', 0.0219, 'lps'),
	(536307, 128, '2014-02-15 00:16:00.000000', 'consum', 0.0214, 'lps'),
	(536308, 128, '2014-02-15 00:16:01.000000', 'consum', 0.0221, 'lps'),
	(536309, 128, '2014-02-15 00:16:02.000000', 'consum', 0.0219, 'lps'),
	(536310, 128, '2014-02-15 00:16:03.000000', 'consum', 0.0223, 'lps'),
	(536311, 128, '2014-02-15 00:16:04.000000', 'consum', 0.0214, 'lps'),
	(536312, 128, '2014-02-15 00:16:05.000000', 'consum', 0.0226, 'lps'),
	(536313, 128, '2014-02-15 00:16:06.000000', 'consum', 0.0210, 'lps'),
	(536314, 128, '2014-02-15 00:16:07.000000', 'consum', 0.0214, 'lps'),
	(536315, 128, '2014-02-15 00:16:08.000000', 'consum', 0.0215, 'lps'),
	(536316, 128, '2014-02-15 00:16:09.000000', 'consum', 0.0224, 'lps'),
	(536317, 128, '2014-02-15 00:16:10.000000', 'consum', 0.0212, 'lps'),
	(536318, 128, '2014-02-15 00:16:11.000000', 'consum', 0.0212, 'lps'),
	(536319, 128, '2014-02-15 00:16:12.000000', 'consum', 0.0217, 'lps'),
	(536320, 128, '2014-02-15 00:16:13.000000', 'consum', 0.0221, 'lps'),
	(536321, 128, '2014-02-15 00:16:14.000000', 'consum', 0.0211, 'lps'),
	(536322, 128, '2014-02-15 00:16:15.000000', 'consum', 0.0214, 'lps'),
	(536323, 128, '2014-02-15 00:16:16.000000', 'consum', 0.0214, 'lps'),
	(536324, 128, '2014-02-15 00:16:17.000000', 'consum', 0.0217, 'lps'),
	(536325, 128, '2014-02-15 00:16:18.000000', 'consum', 0.0217, 'lps'),
	(536326, 128, '2014-02-15 00:16:19.000000', 'consum', 0.0224, 'lps'),
	(536327, 128, '2014-02-15 00:16:20.000000', 'consum', 0.0224, 'lps'),
	(536328, 128, '2014-02-15 00:16:21.000000', 'consum', 0.0224, 'lps'),
	(536329, 128, '2014-02-15 00:16:22.000000', 'consum', 0.0221, 'lps'),
	(536330, 128, '2014-02-15 00:16:23.000000', 'consum', 0.0222, 'lps'),
	(536331, 128, '2014-02-15 00:16:24.000000', 'consum', 0.0222, 'lps'),
	(536332, 128, '2014-02-15 00:16:25.000000', 'consum', 0.0218, 'lps'),
	(536333, 128, '2014-02-15 00:16:26.000000', 'consum', 0.0212, 'lps'),
	(536334, 128, '2014-02-15 00:16:27.000000', 'consum', 0.0215, 'lps'),
	(536335, 128, '2014-02-15 00:16:28.000000', 'consum', 0.0213, 'lps'),
	(536336, 128, '2014-02-15 00:16:29.000000', 'consum', 0.0210, 'lps'),
	(536337, 128, '2014-02-15 00:16:30.000000', 'consum', 0.0217, 'lps'),
	(536338, 128, '2014-02-15 00:16:31.000000', 'consum', 0.0211, 'lps'),
	(536339, 128, '2014-02-15 00:16:32.000000', 'consum', 0.0214, 'lps'),
	(536340, 128, '2014-02-15 00:16:33.000000', 'consum', 0.0226, 'lps'),
	(536341, 128, '2014-02-15 00:16:34.000000', 'consum', 0.0210, 'lps'),
	(536342, 128, '2014-02-15 00:16:35.000000', 'consum', 0.0216, 'lps'),
	(536343, 128, '2014-02-15 00:16:36.000000', 'consum', 0.0223, 'lps'),
	(536344, 128, '2014-02-15 00:16:37.000000', 'consum', 0.0222, 'lps'),
	(536345, 128, '2014-02-15 00:16:38.000000', 'consum', 0.0216, 'lps'),
	(536346, 128, '2014-02-15 00:16:39.000000', 'consum', 0.0223, 'lps'),
	(536347, 128, '2014-02-15 00:16:40.000000', 'consum', 0.0221, 'lps'),
	(536348, 128, '2014-02-15 00:16:41.000000', 'consum', 0.0212, 'lps'),
	(536349, 128, '2014-02-15 00:16:42.000000', 'consum', 0.0220, 'lps'),
	(536350, 128, '2014-02-15 00:16:43.000000', 'consum', 0.0219, 'lps'),
	(536351, 128, '2014-02-15 00:16:44.000000', 'consum', 0.0211, 'lps'),
	(536352, 128, '2014-02-15 00:16:45.000000', 'consum', 0.0223, 'lps'),
	(536353, 128, '2014-02-15 00:16:46.000000', 'consum', 0.0221, 'lps'),
	(536354, 128, '2014-02-15 00:16:47.000000', 'consum', 0.0225, 'lps'),
	(536355, 128, '2014-02-15 00:16:48.000000', 'consum', 0.0220, 'lps'),
	(536356, 128, '2014-02-15 00:16:49.000000', 'consum', 0.0217, 'lps'),
	(536357, 128, '2014-02-15 00:16:50.000000', 'consum', 0.0215, 'lps'),
	(536358, 128, '2014-02-15 00:16:51.000000', 'consum', 0.0212, 'lps'),
	(536359, 128, '2014-02-15 00:16:52.000000', 'consum', 0.0224, 'lps'),
	(536360, 128, '2014-02-15 00:16:53.000000', 'consum', 0.0225, 'lps'),
	(536361, 128, '2014-02-15 00:16:54.000000', 'consum', 0.0226, 'lps'),
	(536362, 128, '2014-02-15 00:16:55.000000', 'consum', 0.0211, 'lps'),
	(536363, 128, '2014-02-15 00:16:56.000000', 'consum', 0.0220, 'lps'),
	(536364, 128, '2014-02-15 00:16:57.000000', 'consum', 0.0223, 'lps'),
	(536365, 128, '2014-02-15 00:16:58.000000', 'consum', 0.0210, 'lps'),
	(536366, 128, '2014-02-15 00:16:59.000000', 'consum', 0.0223, 'lps'),
	(536367, 128, '2014-02-15 00:17:00.000000', 'consum', 0.0226, 'lps'),
	(536368, 128, '2014-02-15 00:17:01.000000', 'consum', 0.0218, 'lps'),
	(536369, 128, '2014-02-15 00:17:02.000000', 'consum', 0.0218, 'lps'),
	(536370, 128, '2014-02-15 00:17:03.000000', 'consum', 0.0210, 'lps'),
	(536371, 128, '2014-02-15 00:17:04.000000', 'consum', 0.0220, 'lps'),
	(536372, 128, '2014-02-15 00:17:05.000000', 'consum', 0.0210, 'lps'),
	(536373, 128, '2014-02-15 00:17:06.000000', 'consum', 0.0213, 'lps'),
	(536374, 128, '2014-02-15 00:17:07.000000', 'consum', 0.0210, 'lps'),
	(536375, 128, '2014-02-15 00:17:08.000000', 'consum', 0.0220, 'lps'),
	(536376, 128, '2014-02-15 00:17:09.000000', 'consum', 0.0226, 'lps'),
	(536377, 128, '2014-02-15 00:17:10.000000', 'consum', 0.0225, 'lps'),
	(536378, 128, '2014-02-15 00:17:11.000000', 'consum', 0.0221, 'lps'),
	(536379, 128, '2014-02-15 00:17:12.000000', 'consum', 0.0220, 'lps'),
	(536380, 128, '2014-02-15 00:17:13.000000', 'consum', 0.0210, 'lps'),
	(536381, 128, '2014-02-15 00:17:14.000000', 'consum', 0.0214, 'lps'),
	(536382, 128, '2014-02-15 00:17:15.000000', 'consum', 0.0213, 'lps'),
	(536383, 128, '2014-02-15 00:17:16.000000', 'consum', 0.0216, 'lps'),
	(536384, 128, '2014-02-15 00:17:17.000000', 'consum', 0.0213, 'lps'),
	(536385, 128, '2014-02-15 00:17:18.000000', 'consum', 0.0223, 'lps'),
	(536386, 128, '2014-02-15 00:17:19.000000', 'consum', 0.0216, 'lps'),
	(536387, 128, '2014-02-15 00:17:20.000000', 'consum', 0.0218, 'lps'),
	(536388, 128, '2014-02-15 00:17:21.000000', 'consum', 0.0215, 'lps'),
	(536389, 128, '2014-02-15 00:17:22.000000', 'consum', 0.0214, 'lps'),
	(536390, 128, '2014-02-15 00:17:23.000000', 'consum', 0.0216, 'lps'),
	(536391, 128, '2014-02-15 00:17:24.000000', 'consum', 0.0210, 'lps'),
	(536392, 128, '2014-02-15 00:17:25.000000', 'consum', 0.0210, 'lps'),
	(536393, 128, '2014-02-15 00:17:26.000000', 'consum', 0.0225, 'lps'),
	(536394, 128, '2014-02-15 00:17:27.000000', 'consum', 0.0221, 'lps'),
	(536395, 128, '2014-02-15 00:17:28.000000', 'consum', 0.0219, 'lps'),
	(536396, 128, '2014-02-15 00:17:29.000000', 'consum', 0.0223, 'lps'),
	(536397, 128, '2014-02-15 00:17:30.000000', 'consum', 0.0213, 'lps'),
	(536398, 128, '2014-02-15 00:17:31.000000', 'consum', 0.0223, 'lps'),
	(536399, 128, '2014-02-15 00:17:32.000000', 'consum', 0.0216, 'lps'),
	(536400, 128, '2014-02-15 00:17:33.000000', 'consum', 0.0216, 'lps'),
	(536401, 128, '2014-02-15 00:17:34.000000', 'consum', 0.0224, 'lps'),
	(536402, 128, '2014-02-15 00:17:35.000000', 'consum', 0.0210, 'lps'),
	(536403, 128, '2014-02-15 00:17:36.000000', 'consum', 0.0222, 'lps'),
	(536404, 128, '2014-02-15 00:17:37.000000', 'consum', 0.0219, 'lps'),
	(536405, 128, '2014-02-15 00:17:38.000000', 'consum', 0.0219, 'lps'),
	(536406, 128, '2014-02-15 00:17:39.000000', 'consum', 0.0213, 'lps'),
	(536407, 128, '2014-02-15 00:17:40.000000', 'consum', 0.0214, 'lps'),
	(536408, 128, '2014-02-15 00:17:41.000000', 'consum', 0.0222, 'lps'),
	(536409, 128, '2014-02-15 00:17:42.000000', 'consum', 0.0224, 'lps'),
	(536410, 128, '2014-02-15 00:17:43.000000', 'consum', 0.0210, 'lps'),
	(536411, 128, '2014-02-15 00:17:44.000000', 'consum', 0.0218, 'lps'),
	(536412, 128, '2014-02-15 00:17:45.000000', 'consum', 0.0220, 'lps'),
	(536413, 128, '2014-02-15 00:17:46.000000', 'consum', 0.0218, 'lps'),
	(536414, 128, '2014-02-15 00:17:47.000000', 'consum', 0.0221, 'lps'),
	(536415, 128, '2014-02-15 00:17:48.000000', 'consum', 0.0226, 'lps'),
	(536416, 128, '2014-02-15 00:17:49.000000', 'consum', 0.0222, 'lps'),
	(536417, 128, '2014-02-15 00:17:50.000000', 'consum', 0.0222, 'lps'),
	(536418, 128, '2014-02-15 00:17:51.000000', 'consum', 0.0217, 'lps'),
	(536419, 128, '2014-02-15 00:17:52.000000', 'consum', 0.0226, 'lps'),
	(536420, 128, '2014-02-15 00:17:53.000000', 'consum', 0.0218, 'lps'),
	(536421, 128, '2014-02-15 00:17:54.000000', 'consum', 0.0222, 'lps'),
	(536422, 128, '2014-02-15 00:17:55.000000', 'consum', 0.0213, 'lps'),
	(536423, 128, '2014-02-15 00:17:56.000000', 'consum', 0.0220, 'lps'),
	(536424, 128, '2014-02-15 00:17:57.000000', 'consum', 0.0221, 'lps'),
	(536425, 128, '2014-02-15 00:17:58.000000', 'consum', 0.0215, 'lps'),
	(536426, 128, '2014-02-15 00:17:59.000000', 'consum', 0.0222, 'lps'),
	(536427, 128, '2014-02-15 00:18:00.000000', 'consum', 0.0222, 'lps'),
	(536428, 128, '2014-02-15 00:18:01.000000', 'consum', 0.0218, 'lps'),
	(536429, 128, '2014-02-15 00:18:02.000000', 'consum', 0.0213, 'lps'),
	(536430, 128, '2014-02-15 00:18:03.000000', 'consum', 0.0218, 'lps'),
	(536431, 128, '2014-02-15 00:18:04.000000', 'consum', 0.0225, 'lps'),
	(536432, 128, '2014-02-15 00:18:05.000000', 'consum', 0.0226, 'lps'),
	(536433, 128, '2014-02-15 00:18:06.000000', 'consum', 0.0212, 'lps'),
	(536434, 128, '2014-02-15 00:18:07.000000', 'consum', 0.0223, 'lps'),
	(536435, 128, '2014-02-15 00:18:08.000000', 'consum', 0.0221, 'lps'),
	(536436, 128, '2014-02-15 00:18:09.000000', 'consum', 0.0226, 'lps'),
	(536437, 128, '2014-02-15 00:18:10.000000', 'consum', 0.0224, 'lps'),
	(536438, 128, '2014-02-15 00:18:11.000000', 'consum', 0.0216, 'lps'),
	(536439, 128, '2014-02-15 00:18:12.000000', 'consum', 0.0214, 'lps'),
	(536440, 128, '2014-02-15 00:18:13.000000', 'consum', 0.0215, 'lps'),
	(536441, 128, '2014-02-15 00:18:14.000000', 'consum', 0.0220, 'lps'),
	(536442, 128, '2014-02-15 00:18:15.000000', 'consum', 0.0215, 'lps'),
	(536443, 128, '2014-02-15 00:18:16.000000', 'consum', 0.0221, 'lps'),
	(536444, 128, '2014-02-15 00:18:17.000000', 'consum', 0.0215, 'lps'),
	(536445, 128, '2014-02-15 00:18:18.000000', 'consum', 0.0220, 'lps'),
	(536446, 128, '2014-02-15 00:18:19.000000', 'consum', 0.0212, 'lps'),
	(536447, 128, '2014-02-15 00:18:20.000000', 'consum', 0.0225, 'lps'),
	(536448, 128, '2014-02-15 00:18:21.000000', 'consum', 0.0212, 'lps'),
	(536449, 128, '2014-02-15 00:18:22.000000', 'consum', 0.0210, 'lps'),
	(536450, 128, '2014-02-15 00:18:23.000000', 'consum', 0.0221, 'lps'),
	(536451, 128, '2014-02-15 00:18:24.000000', 'consum', 0.0213, 'lps'),
	(536452, 128, '2014-02-15 00:18:25.000000', 'consum', 0.0211, 'lps'),
	(536453, 128, '2014-02-15 00:18:26.000000', 'consum', 0.0224, 'lps'),
	(536454, 128, '2014-02-15 00:18:27.000000', 'consum', 0.0210, 'lps'),
	(536455, 128, '2014-02-15 00:18:28.000000', 'consum', 0.0219, 'lps'),
	(536456, 128, '2014-02-15 00:18:29.000000', 'consum', 0.0221, 'lps'),
	(536457, 128, '2014-02-15 00:18:30.000000', 'consum', 0.0220, 'lps'),
	(536458, 128, '2014-02-15 00:18:31.000000', 'consum', 0.0211, 'lps'),
	(536459, 128, '2014-02-15 00:18:32.000000', 'consum', 0.0218, 'lps'),
	(536460, 128, '2014-02-15 00:18:33.000000', 'consum', 0.0216, 'lps'),
	(536461, 128, '2014-02-15 00:18:34.000000', 'consum', 0.0218, 'lps'),
	(536462, 128, '2014-02-15 00:18:35.000000', 'consum', 0.0213, 'lps'),
	(536463, 128, '2014-02-15 00:18:36.000000', 'consum', 0.0217, 'lps'),
	(536464, 128, '2014-02-15 00:18:37.000000', 'consum', 0.0221, 'lps'),
	(536465, 128, '2014-02-15 00:18:38.000000', 'consum', 0.0212, 'lps'),
	(536466, 128, '2014-02-15 00:18:39.000000', 'consum', 0.0220, 'lps'),
	(536467, 128, '2014-02-15 00:18:40.000000', 'consum', 0.0222, 'lps'),
	(536468, 128, '2014-02-15 00:18:41.000000', 'consum', 0.0221, 'lps'),
	(536469, 128, '2014-02-15 00:18:42.000000', 'consum', 0.0213, 'lps'),
	(536470, 128, '2014-02-15 00:18:43.000000', 'consum', 0.0226, 'lps'),
	(536471, 128, '2014-02-15 00:18:44.000000', 'consum', 0.0216, 'lps'),
	(536472, 128, '2014-02-15 00:18:45.000000', 'consum', 0.0210, 'lps'),
	(536473, 128, '2014-02-15 00:18:46.000000', 'consum', 0.0224, 'lps'),
	(536474, 128, '2014-02-15 00:18:47.000000', 'consum', 0.0211, 'lps'),
	(536475, 128, '2014-02-15 00:18:48.000000', 'consum', 0.0210, 'lps'),
	(536476, 128, '2014-02-15 00:18:49.000000', 'consum', 0.0226, 'lps'),
	(536477, 128, '2014-02-15 00:18:50.000000', 'consum', 0.0220, 'lps'),
	(536478, 128, '2014-02-15 00:18:51.000000', 'consum', 0.0212, 'lps'),
	(536479, 128, '2014-02-15 00:18:52.000000', 'consum', 0.0224, 'lps'),
	(536480, 128, '2014-02-15 00:18:53.000000', 'consum', 0.0223, 'lps'),
	(536481, 128, '2014-02-15 00:18:54.000000', 'consum', 0.0218, 'lps'),
	(536482, 128, '2014-02-15 00:18:55.000000', 'consum', 0.0210, 'lps'),
	(536483, 128, '2014-02-15 00:18:56.000000', 'consum', 0.0223, 'lps'),
	(536484, 128, '2014-02-15 00:18:57.000000', 'consum', 0.0222, 'lps'),
	(536485, 128, '2014-02-15 00:18:58.000000', 'consum', 0.0216, 'lps'),
	(536486, 128, '2014-02-15 00:18:59.000000', 'consum', 0.0223, 'lps'),
	(536487, 128, '2014-02-15 00:19:00.000000', 'consum', 0.0222, 'lps'),
	(536488, 128, '2014-02-15 00:19:01.000000', 'consum', 0.0213, 'lps'),
	(536489, 128, '2014-02-15 00:19:02.000000', 'consum', 0.0226, 'lps'),
	(536490, 128, '2014-02-15 00:19:03.000000', 'consum', 0.0213, 'lps'),
	(536491, 128, '2014-02-15 00:19:04.000000', 'consum', 0.0226, 'lps'),
	(536492, 128, '2014-02-15 00:19:05.000000', 'consum', 0.0217, 'lps'),
	(536493, 128, '2014-02-15 00:19:06.000000', 'consum', 0.0212, 'lps'),
	(536494, 128, '2014-02-15 00:19:07.000000', 'consum', 0.0218, 'lps'),
	(536495, 128, '2014-02-15 00:19:08.000000', 'consum', 0.0226, 'lps'),
	(536496, 128, '2014-02-15 00:19:09.000000', 'consum', 0.0217, 'lps'),
	(536497, 128, '2014-02-15 00:19:10.000000', 'consum', 0.0215, 'lps'),
	(536498, 128, '2014-02-15 00:19:11.000000', 'consum', 0.0212, 'lps'),
	(536499, 128, '2014-02-15 00:19:12.000000', 'consum', 0.0225, 'lps'),
	(536500, 128, '2014-02-15 00:19:13.000000', 'consum', 0.0212, 'lps'),
	(536501, 128, '2014-02-15 00:19:14.000000', 'consum', 0.0224, 'lps'),
	(536502, 128, '2014-02-15 00:19:15.000000', 'consum', 0.0226, 'lps'),
	(536503, 128, '2014-02-15 00:19:16.000000', 'consum', 0.0214, 'lps'),
	(536504, 128, '2014-02-15 00:19:17.000000', 'consum', 0.0215, 'lps'),
	(536505, 128, '2014-02-15 00:19:18.000000', 'consum', 0.0224, 'lps'),
	(536506, 128, '2014-02-15 00:19:19.000000', 'consum', 0.0214, 'lps'),
	(536507, 128, '2014-02-15 00:19:20.000000', 'consum', 0.0224, 'lps'),
	(536508, 128, '2014-02-15 00:19:21.000000', 'consum', 0.0218, 'lps'),
	(536509, 128, '2014-02-15 00:19:22.000000', 'consum', 0.0223, 'lps'),
	(536510, 128, '2014-02-15 00:19:23.000000', 'consum', 0.0220, 'lps'),
	(536511, 128, '2014-02-15 00:19:24.000000', 'consum', 0.0222, 'lps'),
	(536512, 128, '2014-02-15 00:19:25.000000', 'consum', 0.0222, 'lps'),
	(536513, 128, '2014-02-15 00:19:26.000000', 'consum', 0.0219, 'lps'),
	(536514, 128, '2014-02-15 00:19:27.000000', 'consum', 0.0221, 'lps'),
	(536515, 128, '2014-02-15 00:19:28.000000', 'consum', 0.0218, 'lps'),
	(536516, 128, '2014-02-15 00:19:29.000000', 'consum', 0.0219, 'lps'),
	(536517, 128, '2014-02-15 00:19:30.000000', 'consum', 0.0216, 'lps'),
	(536518, 128, '2014-02-15 00:19:31.000000', 'consum', 0.0211, 'lps'),
	(536519, 128, '2014-02-15 00:19:32.000000', 'consum', 0.0217, 'lps'),
	(536520, 128, '2014-02-15 00:19:33.000000', 'consum', 0.0224, 'lps'),
	(536521, 128, '2014-02-15 00:19:34.000000', 'consum', 0.0224, 'lps'),
	(536522, 128, '2014-02-15 00:19:35.000000', 'consum', 0.0223, 'lps'),
	(536523, 128, '2014-02-15 00:19:36.000000', 'consum', 0.0217, 'lps'),
	(536524, 128, '2014-02-15 00:19:37.000000', 'consum', 0.0224, 'lps'),
	(536525, 128, '2014-02-15 00:19:38.000000', 'consum', 0.0224, 'lps'),
	(536526, 128, '2014-02-15 00:19:39.000000', 'consum', 0.0222, 'lps'),
	(536527, 128, '2014-02-15 00:19:40.000000', 'consum', 0.0211, 'lps'),
	(536528, 128, '2014-02-15 00:19:41.000000', 'consum', 0.0214, 'lps'),
	(536529, 128, '2014-02-15 00:19:42.000000', 'consum', 0.0210, 'lps'),
	(536530, 128, '2014-02-15 00:19:43.000000', 'consum', 0.0215, 'lps'),
	(536531, 128, '2014-02-15 00:19:44.000000', 'consum', 0.0221, 'lps'),
	(536532, 128, '2014-02-15 00:19:45.000000', 'consum', 0.0215, 'lps'),
	(536533, 128, '2014-02-15 00:19:46.000000', 'consum', 0.0218, 'lps'),
	(536534, 128, '2014-02-15 00:19:47.000000', 'consum', 0.0218, 'lps'),
	(536535, 128, '2014-02-15 00:19:48.000000', 'consum', 0.0212, 'lps'),
	(536536, 128, '2014-02-15 00:19:49.000000', 'consum', 0.0211, 'lps'),
	(536537, 128, '2014-02-15 00:19:50.000000', 'consum', 0.0211, 'lps'),
	(536538, 128, '2014-02-15 00:19:51.000000', 'consum', 0.0212, 'lps'),
	(536539, 128, '2014-02-15 00:19:52.000000', 'consum', 0.0219, 'lps'),
	(536540, 128, '2014-02-15 00:19:53.000000', 'consum', 0.0213, 'lps'),
	(536541, 128, '2014-02-15 00:19:54.000000', 'consum', 0.0219, 'lps'),
	(536542, 128, '2014-02-15 00:19:55.000000', 'consum', 0.0226, 'lps'),
	(536543, 128, '2014-02-15 00:19:56.000000', 'consum', 0.0214, 'lps'),
	(536544, 128, '2014-02-15 00:19:57.000000', 'consum', 0.0215, 'lps'),
	(536545, 128, '2014-02-15 00:19:58.000000', 'consum', 0.0224, 'lps'),
	(536546, 128, '2014-02-15 00:19:59.000000', 'consum', 0.0216, 'lps'),
	(536547, 128, '2014-02-15 00:20:00.000000', 'consum', 0.0213, 'lps'),
	(536548, 128, '2014-02-15 00:20:01.000000', 'consum', 0.0225, 'lps'),
	(536549, 128, '2014-02-15 00:20:02.000000', 'consum', 0.0225, 'lps'),
	(536550, 128, '2014-02-15 00:20:03.000000', 'consum', 0.0224, 'lps'),
	(536551, 128, '2014-02-15 00:20:04.000000', 'consum', 0.0220, 'lps'),
	(536552, 128, '2014-02-15 00:20:05.000000', 'consum', 0.0217, 'lps'),
	(536553, 128, '2014-02-15 00:20:06.000000', 'consum', 0.0218, 'lps'),
	(536554, 128, '2014-02-15 00:20:07.000000', 'consum', 0.0211, 'lps'),
	(536555, 128, '2014-02-15 00:20:08.000000', 'consum', 0.0226, 'lps'),
	(536556, 128, '2014-02-15 00:20:09.000000', 'consum', 0.0219, 'lps'),
	(536557, 128, '2014-02-15 00:20:10.000000', 'consum', 0.0223, 'lps'),
	(536558, 128, '2014-02-15 00:20:11.000000', 'consum', 0.0216, 'lps'),
	(536559, 128, '2014-02-15 00:20:12.000000', 'consum', 0.0217, 'lps'),
	(536560, 128, '2014-02-15 00:20:13.000000', 'consum', 0.0210, 'lps'),
	(536561, 128, '2014-02-15 00:20:14.000000', 'consum', 0.0225, 'lps'),
	(536562, 128, '2014-02-15 00:20:15.000000', 'consum', 0.0218, 'lps'),
	(536563, 128, '2014-02-15 00:20:16.000000', 'consum', 0.0222, 'lps'),
	(536564, 128, '2014-02-15 00:20:17.000000', 'consum', 0.0212, 'lps'),
	(536565, 128, '2014-02-15 00:20:18.000000', 'consum', 0.0218, 'lps'),
	(536566, 128, '2014-02-15 00:20:19.000000', 'consum', 0.0210, 'lps'),
	(536567, 128, '2014-02-15 00:20:20.000000', 'consum', 0.0220, 'lps'),
	(536568, 128, '2014-02-15 00:20:21.000000', 'consum', 0.0212, 'lps'),
	(536569, 128, '2014-02-15 00:20:22.000000', 'consum', 0.0224, 'lps'),
	(536570, 128, '2014-02-15 00:20:23.000000', 'consum', 0.0223, 'lps'),
	(536571, 128, '2014-02-15 00:20:24.000000', 'consum', 0.0218, 'lps'),
	(536572, 128, '2014-02-15 00:20:25.000000', 'consum', 0.0212, 'lps'),
	(536573, 128, '2014-02-15 00:20:26.000000', 'consum', 0.0214, 'lps'),
	(536574, 128, '2014-02-15 00:20:27.000000', 'consum', 0.0225, 'lps'),
	(536575, 128, '2014-02-15 00:20:28.000000', 'consum', 0.0222, 'lps'),
	(536576, 128, '2014-02-15 00:20:29.000000', 'consum', 0.0224, 'lps'),
	(536577, 128, '2014-02-15 00:20:30.000000', 'consum', 0.0211, 'lps'),
	(536578, 128, '2014-02-15 00:20:31.000000', 'consum', 0.0224, 'lps'),
	(536579, 128, '2014-02-15 00:20:32.000000', 'consum', 0.0226, 'lps'),
	(536580, 128, '2014-02-15 00:20:33.000000', 'consum', 0.0217, 'lps'),
	(536581, 128, '2014-02-15 00:20:34.000000', 'consum', 0.0212, 'lps'),
	(536582, 128, '2014-02-15 00:20:35.000000', 'consum', 0.0219, 'lps'),
	(536583, 128, '2014-02-15 00:20:36.000000', 'consum', 0.0213, 'lps'),
	(536584, 128, '2014-02-15 00:20:37.000000', 'consum', 0.0216, 'lps'),
	(536585, 128, '2014-02-15 00:20:38.000000', 'consum', 0.0215, 'lps'),
	(536586, 128, '2014-02-15 00:20:39.000000', 'consum', 0.0219, 'lps'),
	(536587, 128, '2014-02-15 00:20:40.000000', 'consum', 0.0224, 'lps'),
	(536588, 128, '2014-02-15 00:20:41.000000', 'consum', 0.0218, 'lps'),
	(536589, 128, '2014-02-15 00:20:42.000000', 'consum', 0.0224, 'lps'),
	(536590, 128, '2014-02-15 00:20:43.000000', 'consum', 0.0223, 'lps'),
	(536591, 128, '2014-02-15 00:20:44.000000', 'consum', 0.0215, 'lps'),
	(536592, 128, '2014-02-15 00:20:45.000000', 'consum', 0.0215, 'lps'),
	(536593, 128, '2014-02-15 00:20:46.000000', 'consum', 0.0222, 'lps'),
	(536594, 128, '2014-02-15 00:20:47.000000', 'consum', 0.0220, 'lps'),
	(536595, 128, '2014-02-15 00:20:48.000000', 'consum', 0.0210, 'lps'),
	(536596, 128, '2014-02-15 00:20:49.000000', 'consum', 0.0212, 'lps'),
	(536597, 128, '2014-02-15 00:20:50.000000', 'consum', 0.0220, 'lps'),
	(536598, 128, '2014-02-15 00:20:51.000000', 'consum', 0.0221, 'lps'),
	(536599, 128, '2014-02-15 00:20:52.000000', 'consum', 0.0219, 'lps'),
	(536600, 128, '2014-02-15 00:20:53.000000', 'consum', 0.0220, 'lps'),
	(536601, 128, '2014-02-15 00:20:54.000000', 'consum', 0.0220, 'lps'),
	(536602, 128, '2014-02-15 00:20:55.000000', 'consum', 0.0212, 'lps'),
	(536603, 128, '2014-02-15 00:20:56.000000', 'consum', 0.0225, 'lps'),
	(536604, 128, '2014-02-15 00:20:57.000000', 'consum', 0.0210, 'lps'),
	(536605, 128, '2014-02-15 00:20:58.000000', 'consum', 0.0217, 'lps'),
	(536606, 128, '2014-02-15 00:20:59.000000', 'consum', 0.0210, 'lps'),
	(536607, 128, '2014-02-15 00:21:00.000000', 'consum', 0.0224, 'lps'),
	(536608, 128, '2014-02-15 00:21:01.000000', 'consum', 0.0212, 'lps'),
	(536609, 128, '2014-02-15 00:21:02.000000', 'consum', 0.0214, 'lps'),
	(536610, 128, '2014-02-15 00:21:03.000000', 'consum', 0.0226, 'lps'),
	(536611, 128, '2014-02-15 00:21:04.000000', 'consum', 0.0225, 'lps'),
	(536612, 128, '2014-02-15 00:21:05.000000', 'consum', 0.0223, 'lps'),
	(536613, 128, '2014-02-15 00:21:06.000000', 'consum', 0.0212, 'lps'),
	(536614, 128, '2014-02-15 00:21:07.000000', 'consum', 0.0217, 'lps'),
	(536615, 128, '2014-02-15 00:21:08.000000', 'consum', 0.0222, 'lps'),
	(536616, 128, '2014-02-15 00:21:09.000000', 'consum', 0.0216, 'lps'),
	(536617, 128, '2014-02-15 00:21:10.000000', 'consum', 0.0223, 'lps'),
	(536618, 128, '2014-02-15 00:21:11.000000', 'consum', 0.0221, 'lps'),
	(536619, 128, '2014-02-15 00:21:12.000000', 'consum', 0.0226, 'lps'),
	(536620, 128, '2014-02-15 00:21:13.000000', 'consum', 0.0223, 'lps'),
	(536621, 128, '2014-02-15 00:21:14.000000', 'consum', 0.0210, 'lps'),
	(536622, 128, '2014-02-15 00:21:15.000000', 'consum', 0.0222, 'lps'),
	(536623, 128, '2014-02-15 00:21:16.000000', 'consum', 0.0221, 'lps'),
	(536624, 128, '2014-02-15 00:21:17.000000', 'consum', 0.0211, 'lps'),
	(536625, 128, '2014-02-15 00:21:18.000000', 'consum', 0.0217, 'lps'),
	(536626, 128, '2014-02-15 00:21:19.000000', 'consum', 0.0224, 'lps'),
	(536627, 128, '2014-02-15 00:21:20.000000', 'consum', 0.0211, 'lps'),
	(536628, 128, '2014-02-15 00:21:21.000000', 'consum', 0.0224, 'lps'),
	(536629, 128, '2014-02-15 00:21:22.000000', 'consum', 0.0225, 'lps'),
	(536630, 128, '2014-02-15 00:21:23.000000', 'consum', 0.0210, 'lps'),
	(536631, 128, '2014-02-15 00:21:24.000000', 'consum', 0.0217, 'lps'),
	(536632, 128, '2014-02-15 00:21:25.000000', 'consum', 0.0212, 'lps'),
	(536633, 128, '2014-02-15 00:21:26.000000', 'consum', 0.0216, 'lps'),
	(536634, 128, '2014-02-15 00:21:27.000000', 'consum', 0.0220, 'lps'),
	(536635, 128, '2014-02-15 00:21:28.000000', 'consum', 0.0222, 'lps'),
	(536636, 128, '2014-02-15 00:21:29.000000', 'consum', 0.0224, 'lps'),
	(536637, 128, '2014-02-15 00:21:30.000000', 'consum', 0.0210, 'lps'),
	(536638, 128, '2014-02-15 00:21:31.000000', 'consum', 0.0222, 'lps'),
	(536639, 128, '2014-02-15 00:21:32.000000', 'consum', 0.0217, 'lps'),
	(536640, 128, '2014-02-15 00:21:33.000000', 'consum', 0.0226, 'lps'),
	(536641, 128, '2014-02-15 00:21:34.000000', 'consum', 0.0218, 'lps'),
	(536642, 128, '2014-02-15 00:21:35.000000', 'consum', 0.0221, 'lps'),
	(536643, 128, '2014-02-15 00:21:36.000000', 'consum', 0.0226, 'lps'),
	(536644, 128, '2014-02-15 00:21:37.000000', 'consum', 0.0223, 'lps'),
	(536645, 128, '2014-02-15 00:21:38.000000', 'consum', 0.0211, 'lps'),
	(536646, 128, '2014-02-15 00:21:39.000000', 'consum', 0.0212, 'lps'),
	(536647, 128, '2014-02-15 00:21:40.000000', 'consum', 0.0215, 'lps'),
	(536648, 128, '2014-02-15 00:21:41.000000', 'consum', 0.0213, 'lps'),
	(536649, 128, '2014-02-15 00:21:42.000000', 'consum', 0.0212, 'lps'),
	(536650, 128, '2014-02-15 00:21:43.000000', 'consum', 0.0212, 'lps'),
	(536651, 128, '2014-02-15 00:21:44.000000', 'consum', 0.0213, 'lps'),
	(536652, 128, '2014-02-15 00:21:45.000000', 'consum', 0.0218, 'lps'),
	(536653, 128, '2014-02-15 00:21:46.000000', 'consum', 0.0210, 'lps'),
	(536654, 128, '2014-02-15 00:21:47.000000', 'consum', 0.0221, 'lps'),
	(536655, 128, '2014-02-15 00:21:48.000000', 'consum', 0.0213, 'lps'),
	(536656, 128, '2014-02-15 00:21:49.000000', 'consum', 0.0211, 'lps'),
	(536657, 128, '2014-02-15 00:21:50.000000', 'consum', 0.0224, 'lps'),
	(536658, 128, '2014-02-15 00:21:51.000000', 'consum', 0.0225, 'lps'),
	(536659, 128, '2014-02-15 00:21:52.000000', 'consum', 0.0211, 'lps'),
	(536660, 128, '2014-02-15 00:21:53.000000', 'consum', 0.0222, 'lps'),
	(536661, 128, '2014-02-15 00:21:54.000000', 'consum', 0.0214, 'lps'),
	(536662, 128, '2014-02-15 00:21:55.000000', 'consum', 0.0211, 'lps'),
	(536663, 128, '2014-02-15 00:21:56.000000', 'consum', 0.0222, 'lps'),
	(536664, 128, '2014-02-15 00:21:57.000000', 'consum', 0.0215, 'lps'),
	(536665, 128, '2014-02-15 00:21:58.000000', 'consum', 0.0217, 'lps'),
	(536666, 128, '2014-02-15 00:21:59.000000', 'consum', 0.0214, 'lps'),
	(536667, 128, '2014-02-15 00:22:00.000000', 'consum', 0.0225, 'lps'),
	(536668, 128, '2014-02-15 00:22:01.000000', 'consum', 0.0224, 'lps'),
	(536669, 128, '2014-02-15 00:22:02.000000', 'consum', 0.0219, 'lps'),
	(536670, 128, '2014-02-15 00:22:03.000000', 'consum', 0.0211, 'lps'),
	(536671, 128, '2014-02-15 00:22:04.000000', 'consum', 0.0224, 'lps'),
	(536672, 128, '2014-02-15 00:22:05.000000', 'consum', 0.0226, 'lps'),
	(536673, 128, '2014-02-15 00:22:06.000000', 'consum', 0.0216, 'lps'),
	(536674, 128, '2014-02-15 00:22:07.000000', 'consum', 0.0224, 'lps'),
	(536675, 128, '2014-02-15 00:22:08.000000', 'consum', 0.0211, 'lps'),
	(536676, 128, '2014-02-15 00:22:09.000000', 'consum', 0.0210, 'lps'),
	(536677, 128, '2014-02-15 00:22:10.000000', 'consum', 0.0221, 'lps'),
	(536678, 128, '2014-02-15 00:22:11.000000', 'consum', 0.0218, 'lps'),
	(536679, 128, '2014-02-15 00:22:12.000000', 'consum', 0.0218, 'lps'),
	(536680, 128, '2014-02-15 00:22:13.000000', 'consum', 0.0226, 'lps'),
	(536681, 128, '2014-02-15 00:22:14.000000', 'consum', 0.0213, 'lps'),
	(536682, 128, '2014-02-15 00:22:15.000000', 'consum', 0.0213, 'lps'),
	(536683, 128, '2014-02-15 00:22:16.000000', 'consum', 0.0215, 'lps'),
	(536684, 128, '2014-02-15 00:22:17.000000', 'consum', 0.0212, 'lps'),
	(536685, 128, '2014-02-15 00:22:18.000000', 'consum', 0.0222, 'lps'),
	(536686, 128, '2014-02-15 00:22:19.000000', 'consum', 0.0214, 'lps'),
	(536687, 128, '2014-02-15 00:22:20.000000', 'consum', 0.0210, 'lps'),
	(536688, 128, '2014-02-15 00:22:21.000000', 'consum', 0.0215, 'lps'),
	(536689, 128, '2014-02-15 00:22:22.000000', 'consum', 0.0221, 'lps'),
	(536690, 128, '2014-02-15 00:22:23.000000', 'consum', 0.0216, 'lps'),
	(536691, 128, '2014-02-15 00:22:24.000000', 'consum', 0.0226, 'lps'),
	(536692, 128, '2014-02-15 00:22:25.000000', 'consum', 0.0220, 'lps'),
	(536693, 128, '2014-02-15 00:22:26.000000', 'consum', 0.0213, 'lps'),
	(536694, 128, '2014-02-15 00:22:27.000000', 'consum', 0.0210, 'lps'),
	(536695, 128, '2014-02-15 00:22:28.000000', 'consum', 0.0222, 'lps'),
	(536696, 128, '2014-02-15 00:22:29.000000', 'consum', 0.0219, 'lps'),
	(536697, 128, '2014-02-15 00:22:30.000000', 'consum', 0.0218, 'lps'),
	(536698, 128, '2014-02-15 00:22:31.000000', 'consum', 0.0223, 'lps'),
	(536699, 128, '2014-02-15 00:22:32.000000', 'consum', 0.0216, 'lps'),
	(536700, 128, '2014-02-15 00:22:33.000000', 'consum', 0.0221, 'lps'),
	(536701, 128, '2014-02-15 00:22:34.000000', 'consum', 0.0213, 'lps'),
	(536702, 128, '2014-02-15 00:22:35.000000', 'consum', 0.0211, 'lps'),
	(536703, 128, '2014-02-15 00:22:36.000000', 'consum', 0.0224, 'lps'),
	(536704, 128, '2014-02-15 00:22:37.000000', 'consum', 0.0223, 'lps'),
	(536705, 128, '2014-02-15 00:22:38.000000', 'consum', 0.0220, 'lps'),
	(536706, 128, '2014-02-15 00:22:39.000000', 'consum', 0.0219, 'lps'),
	(536707, 128, '2014-02-15 00:22:40.000000', 'consum', 0.0210, 'lps'),
	(536708, 128, '2014-02-15 00:22:41.000000', 'consum', 0.0216, 'lps'),
	(536709, 128, '2014-02-15 00:22:42.000000', 'consum', 0.0223, 'lps'),
	(536710, 128, '2014-02-15 00:22:43.000000', 'consum', 0.0225, 'lps'),
	(536711, 128, '2014-02-15 00:22:44.000000', 'consum', 0.0213, 'lps'),
	(536712, 128, '2014-02-15 00:22:45.000000', 'consum', 0.0212, 'lps'),
	(536713, 128, '2014-02-15 00:22:46.000000', 'consum', 0.0213, 'lps'),
	(536714, 128, '2014-02-15 00:22:47.000000', 'consum', 0.0219, 'lps'),
	(536715, 128, '2014-02-15 00:22:48.000000', 'consum', 0.0213, 'lps'),
	(536716, 128, '2014-02-15 00:22:49.000000', 'consum', 0.0216, 'lps'),
	(536717, 128, '2014-02-15 00:22:50.000000', 'consum', 0.0213, 'lps'),
	(536718, 128, '2014-02-15 00:22:51.000000', 'consum', 0.0226, 'lps'),
	(536719, 128, '2014-02-15 00:22:52.000000', 'consum', 0.0213, 'lps'),
	(536720, 128, '2014-02-15 00:22:53.000000', 'consum', 0.0211, 'lps'),
	(536721, 128, '2014-02-15 00:22:54.000000', 'consum', 0.0224, 'lps'),
	(536722, 128, '2014-02-15 00:22:55.000000', 'consum', 0.0210, 'lps'),
	(536723, 128, '2014-02-15 00:22:56.000000', 'consum', 0.0219, 'lps'),
	(536724, 128, '2014-02-15 00:22:57.000000', 'consum', 0.0221, 'lps'),
	(536725, 128, '2014-02-15 00:22:58.000000', 'consum', 0.0221, 'lps'),
	(536726, 128, '2014-02-15 00:22:59.000000', 'consum', 0.0215, 'lps'),
	(536727, 128, '2014-02-15 00:23:00.000000', 'consum', 0.0222, 'lps'),
	(536728, 128, '2014-02-15 00:23:01.000000', 'consum', 0.0221, 'lps'),
	(536729, 128, '2014-02-15 00:23:02.000000', 'consum', 0.0211, 'lps'),
	(536730, 128, '2014-02-15 00:23:03.000000', 'consum', 0.0216, 'lps'),
	(536731, 128, '2014-02-15 00:23:04.000000', 'consum', 0.0223, 'lps'),
	(536732, 128, '2014-02-15 00:23:05.000000', 'consum', 0.0221, 'lps'),
	(536733, 128, '2014-02-15 00:23:06.000000', 'consum', 0.0212, 'lps'),
	(536734, 128, '2014-02-15 00:23:07.000000', 'consum', 0.0219, 'lps'),
	(536735, 128, '2014-02-15 00:23:08.000000', 'consum', 0.0217, 'lps'),
	(536736, 128, '2014-02-15 00:23:09.000000', 'consum', 0.0220, 'lps'),
	(536737, 128, '2014-02-15 00:23:10.000000', 'consum', 0.0222, 'lps'),
	(536738, 128, '2014-02-15 00:23:11.000000', 'consum', 0.0221, 'lps'),
	(536739, 128, '2014-02-15 00:23:12.000000', 'consum', 0.0213, 'lps'),
	(536740, 128, '2014-02-15 00:23:13.000000', 'consum', 0.0211, 'lps'),
	(536741, 128, '2014-02-15 00:23:14.000000', 'consum', 0.0225, 'lps'),
	(536742, 128, '2014-02-15 00:23:15.000000', 'consum', 0.0212, 'lps'),
	(536743, 128, '2014-02-15 00:23:16.000000', 'consum', 0.0211, 'lps'),
	(536744, 128, '2014-02-15 00:23:17.000000', 'consum', 0.0226, 'lps'),
	(536745, 128, '2014-02-15 00:23:18.000000', 'consum', 0.0219, 'lps'),
	(536746, 128, '2014-02-15 00:23:19.000000', 'consum', 0.0223, 'lps'),
	(536747, 128, '2014-02-15 00:23:20.000000', 'consum', 0.0218, 'lps'),
	(536748, 128, '2014-02-15 00:23:21.000000', 'consum', 0.0225, 'lps'),
	(536749, 128, '2014-02-15 00:23:22.000000', 'consum', 0.0213, 'lps'),
	(536750, 128, '2014-02-15 00:23:23.000000', 'consum', 0.0214, 'lps'),
	(536751, 128, '2014-02-15 00:23:24.000000', 'consum', 0.0221, 'lps'),
	(536752, 128, '2014-02-15 00:23:25.000000', 'consum', 0.0220, 'lps'),
	(536753, 128, '2014-02-15 00:23:26.000000', 'consum', 0.0226, 'lps'),
	(536754, 128, '2014-02-15 00:23:27.000000', 'consum', 0.0211, 'lps'),
	(536755, 128, '2014-02-15 00:23:28.000000', 'consum', 0.0217, 'lps'),
	(536756, 128, '2014-02-15 00:23:29.000000', 'consum', 0.0226, 'lps'),
	(536757, 128, '2014-02-15 00:23:30.000000', 'consum', 0.0218, 'lps'),
	(536758, 128, '2014-02-15 00:23:31.000000', 'consum', 0.0221, 'lps'),
	(536759, 128, '2014-02-15 00:23:32.000000', 'consum', 0.0226, 'lps'),
	(536760, 128, '2014-02-15 00:23:33.000000', 'consum', 0.0222, 'lps'),
	(536761, 128, '2014-02-15 00:23:34.000000', 'consum', 0.0221, 'lps'),
	(536762, 128, '2014-02-15 00:23:35.000000', 'consum', 0.0212, 'lps'),
	(536763, 128, '2014-02-15 00:23:36.000000', 'consum', 0.0224, 'lps'),
	(536764, 128, '2014-02-15 00:23:37.000000', 'consum', 0.0221, 'lps'),
	(536765, 128, '2014-02-15 00:23:38.000000', 'consum', 0.0224, 'lps'),
	(536766, 128, '2014-02-15 00:23:39.000000', 'consum', 0.0214, 'lps'),
	(536767, 128, '2014-02-15 00:23:40.000000', 'consum', 0.0222, 'lps'),
	(536768, 128, '2014-02-15 00:23:41.000000', 'consum', 0.0225, 'lps'),
	(536769, 128, '2014-02-15 00:23:42.000000', 'consum', 0.0214, 'lps'),
	(536770, 128, '2014-02-15 00:23:43.000000', 'consum', 0.0219, 'lps'),
	(536771, 128, '2014-02-15 00:23:44.000000', 'consum', 0.0210, 'lps'),
	(536772, 128, '2014-02-15 00:23:45.000000', 'consum', 0.0217, 'lps'),
	(536773, 128, '2014-02-15 00:23:46.000000', 'consum', 0.0212, 'lps'),
	(536774, 128, '2014-02-15 00:23:47.000000', 'consum', 0.0216, 'lps'),
	(536775, 128, '2014-02-15 00:23:48.000000', 'consum', 0.0217, 'lps'),
	(536776, 128, '2014-02-15 00:23:49.000000', 'consum', 0.0211, 'lps'),
	(536777, 128, '2014-02-15 00:23:50.000000', 'consum', 0.0213, 'lps'),
	(536778, 128, '2014-02-15 00:23:51.000000', 'consum', 0.0222, 'lps'),
	(536779, 128, '2014-02-15 00:23:52.000000', 'consum', 0.0210, 'lps'),
	(536780, 128, '2014-02-15 00:23:53.000000', 'consum', 0.0226, 'lps'),
	(536781, 128, '2014-02-15 00:23:54.000000', 'consum', 0.0221, 'lps'),
	(536782, 128, '2014-02-15 00:23:55.000000', 'consum', 0.0219, 'lps'),
	(536783, 128, '2014-02-15 00:23:56.000000', 'consum', 0.0224, 'lps'),
	(536784, 128, '2014-02-15 00:23:57.000000', 'consum', 0.0218, 'lps'),
	(536785, 128, '2014-02-15 00:23:58.000000', 'consum', 0.0226, 'lps'),
	(536786, 128, '2014-02-15 00:23:59.000000', 'consum', 0.0216, 'lps'),
	(536787, 128, '2014-02-15 00:24:00.000000', 'consum', 0.0225, 'lps'),
	(536788, 128, '2014-02-15 00:24:01.000000', 'consum', 0.0216, 'lps'),
	(536789, 128, '2014-02-15 00:24:02.000000', 'consum', 0.0213, 'lps'),
	(536790, 128, '2014-02-15 00:24:03.000000', 'consum', 0.0226, 'lps'),
	(536791, 128, '2014-02-15 00:24:04.000000', 'consum', 0.0215, 'lps'),
	(536792, 128, '2014-02-15 00:24:05.000000', 'consum', 0.0218, 'lps'),
	(536793, 128, '2014-02-15 00:24:06.000000', 'consum', 0.0221, 'lps'),
	(536794, 128, '2014-02-15 00:24:07.000000', 'consum', 0.0223, 'lps'),
	(536795, 128, '2014-02-15 00:24:08.000000', 'consum', 0.0211, 'lps'),
	(536796, 128, '2014-02-15 00:24:09.000000', 'consum', 0.0225, 'lps'),
	(536797, 128, '2014-02-15 00:24:10.000000', 'consum', 0.0217, 'lps'),
	(536798, 128, '2014-02-15 00:24:11.000000', 'consum', 0.0215, 'lps'),
	(536799, 128, '2014-02-15 00:24:12.000000', 'consum', 0.0214, 'lps'),
	(536800, 128, '2014-02-15 00:24:13.000000', 'consum', 0.0216, 'lps'),
	(536801, 128, '2014-02-15 00:24:14.000000', 'consum', 0.0211, 'lps'),
	(536802, 128, '2014-02-15 00:24:15.000000', 'consum', 0.0216, 'lps'),
	(536803, 128, '2014-02-15 00:24:16.000000', 'consum', 0.0218, 'lps'),
	(536804, 128, '2014-02-15 00:24:17.000000', 'consum', 0.0217, 'lps'),
	(536805, 128, '2014-02-15 00:24:18.000000', 'consum', 0.0222, 'lps'),
	(536806, 128, '2014-02-15 00:24:19.000000', 'consum', 0.0216, 'lps'),
	(536807, 128, '2014-02-15 00:24:20.000000', 'consum', 0.0222, 'lps'),
	(536808, 128, '2014-02-15 00:24:21.000000', 'consum', 0.0218, 'lps'),
	(536809, 128, '2014-02-15 00:24:22.000000', 'consum', 0.0216, 'lps'),
	(536810, 128, '2014-02-15 00:24:23.000000', 'consum', 0.0216, 'lps'),
	(536811, 128, '2014-02-15 00:24:24.000000', 'consum', 0.0223, 'lps'),
	(536812, 128, '2014-02-15 00:24:25.000000', 'consum', 0.0222, 'lps'),
	(536813, 128, '2014-02-15 00:24:26.000000', 'consum', 0.0215, 'lps'),
	(536814, 128, '2014-02-15 00:24:27.000000', 'consum', 0.0219, 'lps'),
	(536815, 128, '2014-02-15 00:24:28.000000', 'consum', 0.0220, 'lps'),
	(536816, 128, '2014-02-15 00:24:29.000000', 'consum', 0.0218, 'lps'),
	(536817, 128, '2014-02-15 00:24:30.000000', 'consum', 0.0222, 'lps'),
	(536818, 128, '2014-02-15 00:24:31.000000', 'consum', 0.0213, 'lps'),
	(536819, 128, '2014-02-15 00:24:32.000000', 'consum', 0.0223, 'lps'),
	(536820, 128, '2014-02-15 00:24:33.000000', 'consum', 0.0216, 'lps'),
	(536821, 128, '2014-02-15 00:24:34.000000', 'consum', 0.0216, 'lps'),
	(536822, 128, '2014-02-15 00:24:35.000000', 'consum', 0.0224, 'lps'),
	(536823, 128, '2014-02-15 00:24:36.000000', 'consum', 0.0211, 'lps'),
	(536824, 128, '2014-02-15 00:24:37.000000', 'consum', 0.0225, 'lps'),
	(536825, 128, '2014-02-15 00:24:38.000000', 'consum', 0.0216, 'lps'),
	(536826, 128, '2014-02-15 00:24:39.000000', 'consum', 0.0210, 'lps'),
	(536827, 128, '2014-02-15 00:24:40.000000', 'consum', 0.0211, 'lps'),
	(536828, 128, '2014-02-15 00:24:41.000000', 'consum', 0.0213, 'lps'),
	(536829, 128, '2014-02-15 00:24:42.000000', 'consum', 0.0226, 'lps'),
	(536830, 128, '2014-02-15 00:24:43.000000', 'consum', 0.0212, 'lps'),
	(536831, 128, '2014-02-15 00:24:44.000000', 'consum', 0.0222, 'lps'),
	(536832, 128, '2014-02-15 00:24:45.000000', 'consum', 0.0213, 'lps'),
	(536833, 128, '2014-02-15 00:24:46.000000', 'consum', 0.0223, 'lps'),
	(536834, 128, '2014-02-15 00:24:47.000000', 'consum', 0.0218, 'lps'),
	(536835, 128, '2014-02-15 00:24:48.000000', 'consum', 0.0226, 'lps'),
	(536836, 128, '2014-02-15 00:24:49.000000', 'consum', 0.0217, 'lps'),
	(536837, 128, '2014-02-15 00:24:50.000000', 'consum', 0.0216, 'lps'),
	(536838, 128, '2014-02-15 00:24:51.000000', 'consum', 0.0216, 'lps'),
	(536839, 128, '2014-02-15 00:24:52.000000', 'consum', 0.0226, 'lps'),
	(536840, 128, '2014-02-15 00:24:53.000000', 'consum', 0.0220, 'lps'),
	(536841, 128, '2014-02-15 00:24:54.000000', 'consum', 0.0211, 'lps'),
	(536842, 128, '2014-02-15 00:24:55.000000', 'consum', 0.0222, 'lps'),
	(536843, 128, '2014-02-15 00:24:56.000000', 'consum', 0.0217, 'lps'),
	(536844, 128, '2014-02-15 00:24:57.000000', 'consum', 0.0210, 'lps'),
	(536845, 128, '2014-02-15 00:24:58.000000', 'consum', 0.0222, 'lps'),
	(536846, 128, '2014-02-15 00:24:59.000000', 'consum', 0.0220, 'lps'),
	(536847, 128, '2014-02-15 00:25:00.000000', 'consum', 0.0225, 'lps'),
	(536848, 128, '2014-02-15 00:25:01.000000', 'consum', 0.0223, 'lps'),
	(536849, 128, '2014-02-15 00:25:02.000000', 'consum', 0.0212, 'lps'),
	(536850, 128, '2014-02-15 00:25:03.000000', 'consum', 0.0215, 'lps'),
	(536851, 128, '2014-02-15 00:25:04.000000', 'consum', 0.0213, 'lps'),
	(536852, 128, '2014-02-15 00:25:05.000000', 'consum', 0.0210, 'lps'),
	(536853, 128, '2014-02-15 00:25:06.000000', 'consum', 0.0221, 'lps'),
	(536854, 128, '2014-02-15 00:25:07.000000', 'consum', 0.0212, 'lps'),
	(536855, 128, '2014-02-15 00:25:08.000000', 'consum', 0.0224, 'lps'),
	(536856, 128, '2014-02-15 00:25:09.000000', 'consum', 0.0220, 'lps'),
	(536857, 128, '2014-02-15 00:25:10.000000', 'consum', 0.0221, 'lps'),
	(536858, 128, '2014-02-15 00:25:11.000000', 'consum', 0.0216, 'lps'),
	(536859, 128, '2014-02-15 00:25:12.000000', 'consum', 0.0225, 'lps'),
	(536860, 128, '2014-02-15 00:25:13.000000', 'consum', 0.0216, 'lps'),
	(536861, 128, '2014-02-15 00:25:14.000000', 'consum', 0.0213, 'lps'),
	(536862, 128, '2014-02-15 00:25:15.000000', 'consum', 0.0224, 'lps'),
	(536863, 128, '2014-02-15 00:25:16.000000', 'consum', 0.0221, 'lps'),
	(536864, 128, '2014-02-15 00:25:17.000000', 'consum', 0.0223, 'lps'),
	(536865, 128, '2014-02-15 00:25:18.000000', 'consum', 0.0225, 'lps'),
	(536866, 128, '2014-02-15 00:25:19.000000', 'consum', 0.0215, 'lps'),
	(536867, 128, '2014-02-15 00:25:20.000000', 'consum', 0.0221, 'lps'),
	(536868, 128, '2014-02-15 00:25:21.000000', 'consum', 0.0220, 'lps'),
	(536869, 128, '2014-02-15 00:25:22.000000', 'consum', 0.0225, 'lps'),
	(536870, 128, '2014-02-15 00:25:23.000000', 'consum', 0.0221, 'lps'),
	(536871, 128, '2014-02-15 00:25:24.000000', 'consum', 0.0220, 'lps'),
	(536872, 128, '2014-02-15 00:25:25.000000', 'consum', 0.0226, 'lps'),
	(536873, 128, '2014-02-15 00:25:26.000000', 'consum', 0.0213, 'lps'),
	(536874, 128, '2014-02-15 00:25:27.000000', 'consum', 0.0211, 'lps'),
	(536875, 128, '2014-02-15 00:25:28.000000', 'consum', 0.0222, 'lps'),
	(536876, 128, '2014-02-15 00:25:29.000000', 'consum', 0.0217, 'lps'),
	(536877, 128, '2014-02-15 00:25:30.000000', 'consum', 0.0211, 'lps'),
	(536878, 128, '2014-02-15 00:25:31.000000', 'consum', 0.0211, 'lps'),
	(536879, 128, '2014-02-15 00:25:32.000000', 'consum', 0.0213, 'lps'),
	(536880, 128, '2014-02-15 00:25:33.000000', 'consum', 0.0222, 'lps'),
	(536881, 128, '2014-02-15 00:25:34.000000', 'consum', 0.0211, 'lps'),
	(536882, 128, '2014-02-15 00:25:35.000000', 'consum', 0.0212, 'lps'),
	(536883, 128, '2014-02-15 00:25:36.000000', 'consum', 0.0220, 'lps'),
	(536884, 128, '2014-02-15 00:25:37.000000', 'consum', 0.0219, 'lps'),
	(536885, 128, '2014-02-15 00:25:38.000000', 'consum', 0.0226, 'lps'),
	(536886, 128, '2014-02-15 00:25:39.000000', 'consum', 0.0210, 'lps'),
	(536887, 128, '2014-02-15 00:25:40.000000', 'consum', 0.0217, 'lps'),
	(536888, 128, '2014-02-15 00:25:41.000000', 'consum', 0.0226, 'lps'),
	(536889, 128, '2014-02-15 00:25:42.000000', 'consum', 0.0221, 'lps'),
	(536890, 128, '2014-02-15 00:25:43.000000', 'consum', 0.0217, 'lps'),
	(536891, 128, '2014-02-15 00:25:44.000000', 'consum', 0.0214, 'lps'),
	(536892, 128, '2014-02-15 00:25:45.000000', 'consum', 0.0226, 'lps'),
	(536893, 128, '2014-02-15 00:25:46.000000', 'consum', 0.0226, 'lps'),
	(536894, 128, '2014-02-15 00:25:47.000000', 'consum', 0.0224, 'lps'),
	(536895, 128, '2014-02-15 00:25:48.000000', 'consum', 0.0217, 'lps'),
	(536896, 128, '2014-02-15 00:25:49.000000', 'consum', 0.0222, 'lps'),
	(536897, 128, '2014-02-15 00:25:50.000000', 'consum', 0.0216, 'lps'),
	(536898, 128, '2014-02-15 00:25:51.000000', 'consum', 0.0220, 'lps'),
	(536899, 128, '2014-02-15 00:25:52.000000', 'consum', 0.0210, 'lps'),
	(536900, 128, '2014-02-15 00:25:53.000000', 'consum', 0.0214, 'lps'),
	(536901, 128, '2014-02-15 00:25:54.000000', 'consum', 0.0212, 'lps'),
	(536902, 128, '2014-02-15 00:25:55.000000', 'consum', 0.0224, 'lps'),
	(536903, 128, '2014-02-15 00:25:56.000000', 'consum', 0.0210, 'lps'),
	(536904, 128, '2014-02-15 00:25:57.000000', 'consum', 0.0219, 'lps'),
	(536905, 128, '2014-02-15 00:25:58.000000', 'consum', 0.0221, 'lps'),
	(536906, 128, '2014-02-15 00:25:59.000000', 'consum', 0.0223, 'lps'),
	(536907, 128, '2014-02-15 00:26:00.000000', 'consum', 0.0224, 'lps'),
	(536908, 128, '2014-02-15 00:26:01.000000', 'consum', 0.0224, 'lps'),
	(536909, 128, '2014-02-15 00:26:02.000000', 'consum', 0.0221, 'lps'),
	(536910, 128, '2014-02-15 00:26:03.000000', 'consum', 0.0223, 'lps'),
	(536911, 128, '2014-02-15 00:26:04.000000', 'consum', 0.0211, 'lps'),
	(536912, 128, '2014-02-15 00:26:05.000000', 'consum', 0.0224, 'lps'),
	(536913, 128, '2014-02-15 00:26:06.000000', 'consum', 0.0213, 'lps'),
	(536914, 128, '2014-02-15 00:26:07.000000', 'consum', 0.0215, 'lps'),
	(536915, 128, '2014-02-15 00:26:08.000000', 'consum', 0.0212, 'lps'),
	(536916, 128, '2014-02-15 00:26:09.000000', 'consum', 0.0223, 'lps'),
	(536917, 128, '2014-02-15 00:26:10.000000', 'consum', 0.0218, 'lps'),
	(536918, 128, '2014-02-15 00:26:11.000000', 'consum', 0.0210, 'lps'),
	(536919, 128, '2014-02-15 00:26:12.000000', 'consum', 0.0220, 'lps'),
	(536920, 128, '2014-02-15 00:26:13.000000', 'consum', 0.0211, 'lps'),
	(536921, 128, '2014-02-15 00:26:14.000000', 'consum', 0.0220, 'lps'),
	(536922, 128, '2014-02-15 00:26:15.000000', 'consum', 0.0222, 'lps'),
	(536923, 128, '2014-02-15 00:26:16.000000', 'consum', 0.0226, 'lps'),
	(536924, 128, '2014-02-15 00:26:17.000000', 'consum', 0.0220, 'lps'),
	(536925, 128, '2014-02-15 00:26:18.000000', 'consum', 0.0211, 'lps'),
	(536926, 128, '2014-02-15 00:26:19.000000', 'consum', 0.0218, 'lps'),
	(536927, 128, '2014-02-15 00:26:20.000000', 'consum', 0.0215, 'lps'),
	(536928, 128, '2014-02-15 00:26:21.000000', 'consum', 0.0213, 'lps'),
	(536929, 128, '2014-02-15 00:26:22.000000', 'consum', 0.0225, 'lps'),
	(536930, 128, '2014-02-15 00:26:23.000000', 'consum', 0.0212, 'lps'),
	(536931, 128, '2014-02-15 00:26:24.000000', 'consum', 0.0223, 'lps'),
	(536932, 128, '2014-02-15 00:26:25.000000', 'consum', 0.0219, 'lps'),
	(536933, 128, '2014-02-15 00:26:26.000000', 'consum', 0.0219, 'lps'),
	(536934, 128, '2014-02-15 00:26:27.000000', 'consum', 0.0226, 'lps'),
	(536935, 128, '2014-02-15 00:26:28.000000', 'consum', 0.0214, 'lps'),
	(536936, 128, '2014-02-15 00:26:29.000000', 'consum', 0.0218, 'lps'),
	(536937, 128, '2014-02-15 00:26:30.000000', 'consum', 0.0221, 'lps'),
	(536938, 128, '2014-02-15 00:26:31.000000', 'consum', 0.0222, 'lps'),
	(536939, 128, '2014-02-15 00:26:32.000000', 'consum', 0.0221, 'lps'),
	(536940, 128, '2014-02-15 00:26:33.000000', 'consum', 0.0215, 'lps'),
	(536941, 128, '2014-02-15 00:26:34.000000', 'consum', 0.0218, 'lps'),
	(536942, 128, '2014-02-15 00:26:35.000000', 'consum', 0.0221, 'lps'),
	(536943, 128, '2014-02-15 00:26:36.000000', 'consum', 0.0221, 'lps'),
	(536944, 128, '2014-02-15 00:26:37.000000', 'consum', 0.0218, 'lps'),
	(536945, 128, '2014-02-15 00:26:38.000000', 'consum', 0.0218, 'lps'),
	(536946, 128, '2014-02-15 00:26:39.000000', 'consum', 0.0224, 'lps'),
	(536947, 128, '2014-02-15 00:26:40.000000', 'consum', 0.0224, 'lps'),
	(536948, 128, '2014-02-15 00:26:41.000000', 'consum', 0.0223, 'lps'),
	(536949, 128, '2014-02-15 00:26:42.000000', 'consum', 0.0214, 'lps'),
	(536950, 128, '2014-02-15 00:26:43.000000', 'consum', 0.0211, 'lps'),
	(536951, 128, '2014-02-15 00:26:44.000000', 'consum', 0.0220, 'lps'),
	(536952, 128, '2014-02-15 00:26:45.000000', 'consum', 0.0224, 'lps'),
	(536953, 128, '2014-02-15 00:26:46.000000', 'consum', 0.0218, 'lps'),
	(536954, 128, '2014-02-15 00:26:47.000000', 'consum', 0.0224, 'lps'),
	(536955, 128, '2014-02-15 00:26:48.000000', 'consum', 0.0221, 'lps'),
	(536956, 128, '2014-02-15 00:26:49.000000', 'consum', 0.0224, 'lps'),
	(536957, 128, '2014-02-15 00:26:50.000000', 'consum', 0.0215, 'lps'),
	(536958, 128, '2014-02-15 00:26:51.000000', 'consum', 0.0226, 'lps'),
	(536959, 128, '2014-02-15 00:26:52.000000', 'consum', 0.0225, 'lps'),
	(536960, 128, '2014-02-15 00:26:53.000000', 'consum', 0.0219, 'lps'),
	(536961, 128, '2014-02-15 00:26:54.000000', 'consum', 0.0212, 'lps'),
	(536962, 128, '2014-02-15 00:26:55.000000', 'consum', 0.0225, 'lps'),
	(536963, 128, '2014-02-15 00:26:56.000000', 'consum', 0.0214, 'lps'),
	(536964, 128, '2014-02-15 00:26:57.000000', 'consum', 0.0221, 'lps'),
	(536965, 128, '2014-02-15 00:26:58.000000', 'consum', 0.0217, 'lps'),
	(536966, 128, '2014-02-15 00:26:59.000000', 'consum', 0.0212, 'lps'),
	(536967, 128, '2014-02-15 00:27:00.000000', 'consum', 0.0216, 'lps'),
	(536968, 128, '2014-02-15 00:27:01.000000', 'consum', 0.0220, 'lps'),
	(536969, 128, '2014-02-15 00:27:02.000000', 'consum', 0.0223, 'lps'),
	(536970, 128, '2014-02-15 00:27:03.000000', 'consum', 0.0211, 'lps'),
	(536971, 128, '2014-02-15 00:27:04.000000', 'consum', 0.0210, 'lps'),
	(536972, 128, '2014-02-15 00:27:05.000000', 'consum', 0.0210, 'lps'),
	(536973, 128, '2014-02-15 00:27:06.000000', 'consum', 0.0226, 'lps'),
	(536974, 128, '2014-02-15 00:27:07.000000', 'consum', 0.0224, 'lps'),
	(536975, 128, '2014-02-15 00:27:08.000000', 'consum', 0.0214, 'lps'),
	(536976, 128, '2014-02-15 00:27:09.000000', 'consum', 0.0223, 'lps'),
	(536977, 128, '2014-02-15 00:27:10.000000', 'consum', 0.0212, 'lps'),
	(536978, 128, '2014-02-15 00:27:11.000000', 'consum', 0.0215, 'lps'),
	(536979, 128, '2014-02-15 00:27:12.000000', 'consum', 0.0211, 'lps'),
	(536980, 128, '2014-02-15 00:27:13.000000', 'consum', 0.0220, 'lps'),
	(536981, 128, '2014-02-15 00:27:14.000000', 'consum', 0.0221, 'lps'),
	(536982, 128, '2014-02-15 00:27:15.000000', 'consum', 0.0220, 'lps'),
	(536983, 128, '2014-02-15 00:27:16.000000', 'consum', 0.0226, 'lps'),
	(536984, 128, '2014-02-15 00:27:17.000000', 'consum', 0.0212, 'lps'),
	(536985, 128, '2014-02-15 00:27:18.000000', 'consum', 0.0224, 'lps'),
	(536986, 128, '2014-02-15 00:27:19.000000', 'consum', 0.0222, 'lps'),
	(536987, 128, '2014-02-15 00:27:20.000000', 'consum', 0.0214, 'lps'),
	(536988, 128, '2014-02-15 00:27:21.000000', 'consum', 0.0225, 'lps'),
	(536989, 128, '2014-02-15 00:27:22.000000', 'consum', 0.0225, 'lps'),
	(536990, 128, '2014-02-15 00:27:23.000000', 'consum', 0.0224, 'lps'),
	(536991, 128, '2014-02-15 00:27:24.000000', 'consum', 0.0216, 'lps'),
	(536992, 128, '2014-02-15 00:27:25.000000', 'consum', 0.0218, 'lps'),
	(536993, 128, '2014-02-15 00:27:26.000000', 'consum', 0.0213, 'lps'),
	(536994, 128, '2014-02-15 00:27:27.000000', 'consum', 0.0218, 'lps'),
	(536995, 128, '2014-02-15 00:27:28.000000', 'consum', 0.0210, 'lps'),
	(536996, 128, '2014-02-15 00:27:29.000000', 'consum', 0.0221, 'lps'),
	(536997, 128, '2014-02-15 00:27:30.000000', 'consum', 0.0213, 'lps'),
	(536998, 128, '2014-02-15 00:27:31.000000', 'consum', 0.0226, 'lps'),
	(536999, 128, '2014-02-15 00:27:32.000000', 'consum', 0.0213, 'lps'),
	(537000, 128, '2014-02-15 00:27:33.000000', 'consum', 0.0213, 'lps'),
	(537001, 128, '2014-02-15 00:27:34.000000', 'consum', 0.0214, 'lps'),
	(537002, 128, '2014-02-15 00:27:35.000000', 'consum', 0.0225, 'lps'),
	(537003, 128, '2014-02-15 00:27:36.000000', 'consum', 0.0221, 'lps'),
	(537004, 128, '2014-02-15 00:27:37.000000', 'consum', 0.0221, 'lps'),
	(537005, 128, '2014-02-15 00:27:38.000000', 'consum', 0.0216, 'lps'),
	(537006, 128, '2014-02-15 00:27:39.000000', 'consum', 0.0223, 'lps'),
	(537007, 128, '2014-02-15 00:27:40.000000', 'consum', 0.0223, 'lps'),
	(537008, 128, '2014-02-15 00:27:41.000000', 'consum', 0.0222, 'lps'),
	(537009, 128, '2014-02-15 00:27:42.000000', 'consum', 0.0213, 'lps'),
	(537010, 128, '2014-02-15 00:27:43.000000', 'consum', 0.0224, 'lps'),
	(537011, 128, '2014-02-15 00:27:44.000000', 'consum', 0.0222, 'lps'),
	(537012, 128, '2014-02-15 00:27:45.000000', 'consum', 0.0212, 'lps'),
	(537013, 128, '2014-02-15 00:27:46.000000', 'consum', 0.0218, 'lps'),
	(537014, 128, '2014-02-15 00:27:47.000000', 'consum', 0.0225, 'lps'),
	(537015, 128, '2014-02-15 00:27:48.000000', 'consum', 0.0213, 'lps'),
	(537016, 128, '2014-02-15 00:27:49.000000', 'consum', 0.0214, 'lps'),
	(537017, 128, '2014-02-15 00:27:50.000000', 'consum', 0.0220, 'lps'),
	(537018, 128, '2014-02-15 00:27:51.000000', 'consum', 0.0215, 'lps'),
	(537019, 128, '2014-02-15 00:27:52.000000', 'consum', 0.0224, 'lps'),
	(537020, 128, '2014-02-15 00:27:53.000000', 'consum', 0.0215, 'lps'),
	(537021, 128, '2014-02-15 00:27:54.000000', 'consum', 0.0212, 'lps'),
	(537022, 128, '2014-02-15 00:27:55.000000', 'consum', 0.0219, 'lps'),
	(537023, 128, '2014-02-15 00:27:56.000000', 'consum', 0.0218, 'lps'),
	(537024, 128, '2014-02-15 00:27:57.000000', 'consum', 0.0224, 'lps'),
	(537025, 128, '2014-02-15 00:27:58.000000', 'consum', 0.0221, 'lps'),
	(537026, 128, '2014-02-15 00:27:59.000000', 'consum', 0.0223, 'lps'),
	(537027, 128, '2014-02-15 00:28:00.000000', 'consum', 0.0224, 'lps'),
	(537028, 128, '2014-02-15 00:28:01.000000', 'consum', 0.0211, 'lps'),
	(537029, 128, '2014-02-15 00:28:02.000000', 'consum', 0.0223, 'lps'),
	(537030, 128, '2014-02-15 00:28:03.000000', 'consum', 0.0222, 'lps'),
	(537031, 128, '2014-02-15 00:28:04.000000', 'consum', 0.0214, 'lps'),
	(537032, 128, '2014-02-15 00:28:05.000000', 'consum', 0.0210, 'lps'),
	(537033, 128, '2014-02-15 00:28:06.000000', 'consum', 0.0215, 'lps'),
	(537034, 128, '2014-02-15 00:28:07.000000', 'consum', 0.0219, 'lps'),
	(537035, 128, '2014-02-15 00:28:08.000000', 'consum', 0.0224, 'lps'),
	(537036, 128, '2014-02-15 00:28:09.000000', 'consum', 0.0220, 'lps'),
	(537037, 128, '2014-02-15 00:28:10.000000', 'consum', 0.0217, 'lps'),
	(537038, 128, '2014-02-15 00:28:11.000000', 'consum', 0.0216, 'lps'),
	(537039, 128, '2014-02-15 00:28:12.000000', 'consum', 0.0219, 'lps'),
	(537040, 128, '2014-02-15 00:28:13.000000', 'consum', 0.0221, 'lps'),
	(537041, 128, '2014-02-15 00:28:14.000000', 'consum', 0.0223, 'lps'),
	(537042, 128, '2014-02-15 00:28:15.000000', 'consum', 0.0224, 'lps'),
	(537043, 128, '2014-02-15 00:28:16.000000', 'consum', 0.0226, 'lps'),
	(537044, 128, '2014-02-15 00:28:17.000000', 'consum', 0.0216, 'lps'),
	(537045, 128, '2014-02-15 00:28:18.000000', 'consum', 0.0223, 'lps'),
	(537046, 128, '2014-02-15 00:28:19.000000', 'consum', 0.0226, 'lps'),
	(537047, 128, '2014-02-15 00:28:20.000000', 'consum', 0.0218, 'lps'),
	(537048, 128, '2014-02-15 00:28:21.000000', 'consum', 0.0220, 'lps'),
	(537049, 128, '2014-02-15 00:28:22.000000', 'consum', 0.0218, 'lps'),
	(537050, 128, '2014-02-15 00:28:23.000000', 'consum', 0.0221, 'lps'),
	(537051, 128, '2014-02-15 00:28:24.000000', 'consum', 0.0225, 'lps'),
	(537052, 128, '2014-02-15 00:28:25.000000', 'consum', 0.0217, 'lps'),
	(537053, 128, '2014-02-15 00:28:26.000000', 'consum', 0.0219, 'lps'),
	(537054, 128, '2014-02-15 00:28:27.000000', 'consum', 0.0215, 'lps'),
	(537055, 128, '2014-02-15 00:28:28.000000', 'consum', 0.0211, 'lps'),
	(537056, 128, '2014-02-15 00:28:29.000000', 'consum', 0.0216, 'lps'),
	(537057, 128, '2014-02-15 00:28:30.000000', 'consum', 0.0220, 'lps'),
	(537058, 128, '2014-02-15 00:28:31.000000', 'consum', 0.0210, 'lps'),
	(537059, 128, '2014-02-15 00:28:32.000000', 'consum', 0.0215, 'lps'),
	(537060, 128, '2014-02-15 00:28:33.000000', 'consum', 0.0218, 'lps'),
	(537061, 128, '2014-02-15 00:28:34.000000', 'consum', 0.0220, 'lps'),
	(537062, 128, '2014-02-15 00:28:35.000000', 'consum', 0.0219, 'lps'),
	(537063, 128, '2014-02-15 00:28:36.000000', 'consum', 0.0226, 'lps'),
	(537064, 128, '2014-02-15 00:28:37.000000', 'consum', 0.0210, 'lps'),
	(537065, 128, '2014-02-15 00:28:38.000000', 'consum', 0.0214, 'lps'),
	(537066, 128, '2014-02-15 00:28:39.000000', 'consum', 0.0214, 'lps'),
	(537067, 128, '2014-02-15 00:28:40.000000', 'consum', 0.0220, 'lps'),
	(537068, 128, '2014-02-15 00:28:41.000000', 'consum', 0.0212, 'lps'),
	(537069, 128, '2014-02-15 00:28:42.000000', 'consum', 0.0225, 'lps'),
	(537070, 128, '2014-02-15 00:28:43.000000', 'consum', 0.0211, 'lps'),
	(537071, 128, '2014-02-15 00:28:44.000000', 'consum', 0.0222, 'lps'),
	(537072, 128, '2014-02-15 00:28:45.000000', 'consum', 0.0216, 'lps'),
	(537073, 128, '2014-02-15 00:28:46.000000', 'consum', 0.0222, 'lps'),
	(537074, 128, '2014-02-15 00:28:47.000000', 'consum', 0.0220, 'lps'),
	(537075, 128, '2014-02-15 00:28:48.000000', 'consum', 0.0223, 'lps'),
	(537076, 128, '2014-02-15 00:28:49.000000', 'consum', 0.0214, 'lps'),
	(537077, 128, '2014-02-15 00:28:50.000000', 'consum', 0.0222, 'lps'),
	(537078, 128, '2014-02-15 00:28:51.000000', 'consum', 0.0226, 'lps'),
	(537079, 128, '2014-02-15 00:28:52.000000', 'consum', 0.0221, 'lps'),
	(537080, 128, '2014-02-15 00:28:53.000000', 'consum', 0.0218, 'lps'),
	(537081, 128, '2014-02-15 00:28:54.000000', 'consum', 0.0218, 'lps'),
	(537082, 128, '2014-02-15 00:28:55.000000', 'consum', 0.0226, 'lps'),
	(537083, 128, '2014-02-15 00:28:56.000000', 'consum', 0.0215, 'lps'),
	(537084, 128, '2014-02-15 00:28:57.000000', 'consum', 0.0223, 'lps'),
	(537085, 128, '2014-02-15 00:28:58.000000', 'consum', 0.0223, 'lps'),
	(537086, 128, '2014-02-15 00:28:59.000000', 'consum', 0.0223, 'lps'),
	(537087, 128, '2014-02-15 00:29:00.000000', 'consum', 0.0220, 'lps'),
	(537088, 128, '2014-02-15 00:29:01.000000', 'consum', 0.0220, 'lps'),
	(537089, 128, '2014-02-15 00:29:02.000000', 'consum', 0.0215, 'lps'),
	(537090, 128, '2014-02-15 00:29:03.000000', 'consum', 0.0220, 'lps'),
	(537091, 128, '2014-02-15 00:29:04.000000', 'consum', 0.0213, 'lps'),
	(537092, 128, '2014-02-15 00:29:05.000000', 'consum', 0.0212, 'lps'),
	(537093, 128, '2014-02-15 00:29:06.000000', 'consum', 0.0211, 'lps'),
	(537094, 128, '2014-02-15 00:29:07.000000', 'consum', 0.0211, 'lps'),
	(537095, 128, '2014-02-15 00:29:08.000000', 'consum', 0.0212, 'lps'),
	(537096, 128, '2014-02-15 00:29:09.000000', 'consum', 0.0218, 'lps'),
	(537097, 128, '2014-02-15 00:29:10.000000', 'consum', 0.0210, 'lps'),
	(537098, 128, '2014-02-15 00:29:11.000000', 'consum', 0.0220, 'lps'),
	(537099, 128, '2014-02-15 00:29:12.000000', 'consum', 0.0212, 'lps'),
	(537100, 128, '2014-02-15 00:29:13.000000', 'consum', 0.0221, 'lps'),
	(537101, 128, '2014-02-15 00:29:14.000000', 'consum', 0.0211, 'lps'),
	(537102, 128, '2014-02-15 00:29:15.000000', 'consum', 0.0218, 'lps'),
	(537103, 128, '2014-02-15 00:29:16.000000', 'consum', 0.0211, 'lps'),
	(537104, 128, '2014-02-15 00:29:17.000000', 'consum', 0.0225, 'lps'),
	(537105, 128, '2014-02-15 00:29:18.000000', 'consum', 0.0214, 'lps'),
	(537106, 128, '2014-02-15 00:29:19.000000', 'consum', 0.0222, 'lps'),
	(537107, 128, '2014-02-15 00:29:20.000000', 'consum', 0.0221, 'lps'),
	(537108, 128, '2014-02-15 00:29:21.000000', 'consum', 0.0216, 'lps'),
	(537109, 128, '2014-02-15 00:29:22.000000', 'consum', 0.0223, 'lps'),
	(537110, 128, '2014-02-15 00:29:23.000000', 'consum', 0.0222, 'lps'),
	(537111, 128, '2014-02-15 00:29:24.000000', 'consum', 0.0216, 'lps'),
	(537112, 128, '2014-02-15 00:29:25.000000', 'consum', 0.0223, 'lps'),
	(537113, 128, '2014-02-15 00:29:26.000000', 'consum', 0.0222, 'lps'),
	(537114, 128, '2014-02-15 00:29:27.000000', 'consum', 0.0215, 'lps'),
	(537115, 128, '2014-02-15 00:29:28.000000', 'consum', 0.0217, 'lps'),
	(537116, 128, '2014-02-15 00:29:29.000000', 'consum', 0.0211, 'lps'),
	(537117, 128, '2014-02-15 00:29:30.000000', 'consum', 0.0213, 'lps'),
	(537118, 128, '2014-02-15 00:29:31.000000', 'consum', 0.0221, 'lps'),
	(537119, 128, '2014-02-15 00:29:32.000000', 'consum', 0.0224, 'lps'),
	(537120, 128, '2014-02-15 00:29:33.000000', 'consum', 0.0214, 'lps'),
	(537121, 128, '2014-02-15 00:29:34.000000', 'consum', 0.0221, 'lps'),
	(537122, 128, '2014-02-15 00:29:35.000000', 'consum', 0.0222, 'lps'),
	(537123, 128, '2014-02-15 00:29:36.000000', 'consum', 0.0218, 'lps'),
	(537124, 128, '2014-02-15 00:29:37.000000', 'consum', 0.0214, 'lps'),
	(537125, 128, '2014-02-15 00:29:38.000000', 'consum', 0.0223, 'lps'),
	(537126, 128, '2014-02-15 00:29:39.000000', 'consum', 0.0212, 'lps'),
	(537127, 128, '2014-02-15 00:29:40.000000', 'consum', 0.0215, 'lps'),
	(537128, 128, '2014-02-15 00:29:41.000000', 'consum', 0.0216, 'lps'),
	(537129, 128, '2014-02-15 00:29:42.000000', 'consum', 0.0222, 'lps'),
	(537130, 128, '2014-02-15 00:29:43.000000', 'consum', 0.0222, 'lps'),
	(537131, 128, '2014-02-15 00:29:44.000000', 'consum', 0.0215, 'lps'),
	(537132, 128, '2014-02-15 00:29:45.000000', 'consum', 0.0219, 'lps'),
	(537133, 128, '2014-02-15 00:29:46.000000', 'consum', 0.0221, 'lps'),
	(537134, 128, '2014-02-15 00:29:47.000000', 'consum', 0.0223, 'lps'),
	(537135, 128, '2014-02-15 00:29:48.000000', 'consum', 0.0225, 'lps'),
	(537136, 128, '2014-02-15 00:29:49.000000', 'consum', 0.0213, 'lps'),
	(537137, 128, '2014-02-15 00:29:50.000000', 'consum', 0.0214, 'lps'),
	(537138, 128, '2014-02-15 00:29:51.000000', 'consum', 0.0223, 'lps'),
	(537139, 128, '2014-02-15 00:29:52.000000', 'consum', 0.0211, 'lps'),
	(537140, 128, '2014-02-15 00:29:53.000000', 'consum', 0.0226, 'lps'),
	(537141, 128, '2014-02-15 00:29:54.000000', 'consum', 0.0221, 'lps'),
	(537142, 128, '2014-02-15 00:29:55.000000', 'consum', 0.0219, 'lps'),
	(537143, 128, '2014-02-15 00:29:56.000000', 'consum', 0.0222, 'lps'),
	(537144, 128, '2014-02-15 00:29:57.000000', 'consum', 0.0226, 'lps'),
	(537145, 128, '2014-02-15 00:29:58.000000', 'consum', 0.0222, 'lps'),
	(537146, 128, '2014-02-15 00:29:59.000000', 'consum', 0.0220, 'lps'),
	(537147, 128, '2014-02-15 00:30:00.000000', 'consum', 0.0210, 'lps'),
	(537148, 128, '2014-02-15 00:30:01.000000', 'consum', 0.0213, 'lps'),
	(537149, 128, '2014-02-15 00:30:02.000000', 'consum', 0.0210, 'lps'),
	(537150, 128, '2014-02-15 00:30:03.000000', 'consum', 0.0220, 'lps'),
	(537151, 128, '2014-02-15 00:30:04.000000', 'consum', 0.0223, 'lps'),
	(537152, 128, '2014-02-15 00:30:05.000000', 'consum', 0.0212, 'lps'),
	(537153, 128, '2014-02-15 00:30:06.000000', 'consum', 0.0218, 'lps'),
	(537154, 128, '2014-02-15 00:30:07.000000', 'consum', 0.0225, 'lps'),
	(537155, 128, '2014-02-15 00:30:08.000000', 'consum', 0.0213, 'lps'),
	(537156, 128, '2014-02-15 00:30:09.000000', 'consum', 0.0213, 'lps'),
	(537157, 128, '2014-02-15 00:30:10.000000', 'consum', 0.0217, 'lps'),
	(537158, 128, '2014-02-15 00:30:11.000000', 'consum', 0.0221, 'lps'),
	(537159, 128, '2014-02-15 00:30:12.000000', 'consum', 0.0225, 'lps'),
	(537160, 128, '2014-02-15 00:30:13.000000', 'consum', 0.0221, 'lps'),
	(537161, 128, '2014-02-15 00:30:14.000000', 'consum', 0.0222, 'lps'),
	(537162, 128, '2014-02-15 00:30:15.000000', 'consum', 0.0217, 'lps'),
	(537163, 128, '2014-02-15 00:30:16.000000', 'consum', 0.0226, 'lps'),
	(537164, 128, '2014-02-15 00:30:17.000000', 'consum', 0.0218, 'lps'),
	(537165, 128, '2014-02-15 00:30:18.000000', 'consum', 0.0223, 'lps'),
	(537166, 128, '2014-02-15 00:30:19.000000', 'consum', 0.0215, 'lps'),
	(537167, 128, '2014-02-15 00:30:20.000000', 'consum', 0.0212, 'lps'),
	(537168, 128, '2014-02-15 00:30:21.000000', 'consum', 0.0225, 'lps'),
	(537169, 128, '2014-02-15 00:30:22.000000', 'consum', 0.0213, 'lps'),
	(537170, 128, '2014-02-15 00:30:23.000000', 'consum', 0.0212, 'lps'),
	(537171, 128, '2014-02-15 00:30:24.000000', 'consum', 0.0211, 'lps'),
	(537172, 128, '2014-02-15 00:30:25.000000', 'consum', 0.0212, 'lps'),
	(537173, 128, '2014-02-15 00:30:26.000000', 'consum', 0.0216, 'lps'),
	(537174, 128, '2014-02-15 00:30:27.000000', 'consum', 0.0218, 'lps'),
	(537175, 128, '2014-02-15 00:30:28.000000', 'consum', 0.0215, 'lps'),
	(537176, 128, '2014-02-15 00:30:29.000000', 'consum', 0.0212, 'lps'),
	(537177, 128, '2014-02-15 00:30:30.000000', 'consum', 0.0221, 'lps'),
	(537178, 128, '2014-02-15 00:30:31.000000', 'consum', 0.0211, 'lps'),
	(537179, 128, '2014-02-15 00:30:32.000000', 'consum', 0.0214, 'lps'),
	(537180, 128, '2014-02-15 00:30:33.000000', 'consum', 0.0211, 'lps'),
	(537181, 128, '2014-02-15 00:30:34.000000', 'consum', 0.0219, 'lps'),
	(537182, 128, '2014-02-15 00:30:35.000000', 'consum', 0.0221, 'lps'),
	(537183, 128, '2014-02-15 00:30:36.000000', 'consum', 0.0222, 'lps'),
	(537184, 128, '2014-02-15 00:30:37.000000', 'consum', 0.0219, 'lps'),
	(537185, 128, '2014-02-15 00:30:38.000000', 'consum', 0.0219, 'lps'),
	(537186, 128, '2014-02-15 00:30:39.000000', 'consum', 0.0213, 'lps'),
	(537187, 128, '2014-02-15 00:30:40.000000', 'consum', 0.0216, 'lps'),
	(537188, 128, '2014-02-15 00:30:41.000000', 'consum', 0.0213, 'lps'),
	(537189, 128, '2014-02-15 00:30:42.000000', 'consum', 0.0223, 'lps'),
	(537190, 128, '2014-02-15 00:30:43.000000', 'consum', 0.0217, 'lps'),
	(537191, 128, '2014-02-15 00:30:44.000000', 'consum', 0.0225, 'lps'),
	(537192, 128, '2014-02-15 00:30:45.000000', 'consum', 0.0211, 'lps'),
	(537193, 128, '2014-02-15 00:30:46.000000', 'consum', 0.0221, 'lps'),
	(537194, 128, '2014-02-15 00:30:47.000000', 'consum', 0.0212, 'lps'),
	(537195, 128, '2014-02-15 00:30:48.000000', 'consum', 0.0223, 'lps'),
	(537196, 128, '2014-02-15 00:30:49.000000', 'consum', 0.0218, 'lps'),
	(537197, 128, '2014-02-15 00:30:50.000000', 'consum', 0.0213, 'lps'),
	(537198, 128, '2014-02-15 00:30:51.000000', 'consum', 0.0215, 'lps'),
	(537199, 128, '2014-02-15 00:30:52.000000', 'consum', 0.0213, 'lps'),
	(537200, 128, '2014-02-15 00:30:53.000000', 'consum', 0.0210, 'lps'),
	(537201, 128, '2014-02-15 00:30:54.000000', 'consum', 0.0218, 'lps'),
	(537202, 128, '2014-02-15 00:30:55.000000', 'consum', 0.0217, 'lps'),
	(537203, 128, '2014-02-15 00:30:56.000000', 'consum', 0.0222, 'lps'),
	(537204, 128, '2014-02-15 00:30:57.000000', 'consum', 0.0214, 'lps'),
	(537205, 128, '2014-02-15 00:30:58.000000', 'consum', 0.0210, 'lps'),
	(537206, 128, '2014-02-15 00:30:59.000000', 'consum', 0.0217, 'lps'),
	(537207, 128, '2014-02-15 00:31:00.000000', 'consum', 0.0212, 'lps'),
	(537208, 128, '2014-02-15 00:31:01.000000', 'consum', 0.0217, 'lps'),
	(537209, 128, '2014-02-15 00:31:02.000000', 'consum', 0.0221, 'lps'),
	(537210, 128, '2014-02-15 00:31:03.000000', 'consum', 0.0213, 'lps'),
	(537211, 128, '2014-02-15 00:31:04.000000', 'consum', 0.0226, 'lps'),
	(537212, 128, '2014-02-15 00:31:05.000000', 'consum', 0.0215, 'lps'),
	(537213, 128, '2014-02-15 00:31:06.000000', 'consum', 0.0218, 'lps'),
	(537214, 128, '2014-02-15 00:31:07.000000', 'consum', 0.0220, 'lps'),
	(537215, 128, '2014-02-15 00:31:08.000000', 'consum', 0.0218, 'lps'),
	(537216, 128, '2014-02-15 00:31:09.000000', 'consum', 0.0221, 'lps'),
	(537217, 128, '2014-02-15 00:31:10.000000', 'consum', 0.0223, 'lps'),
	(537218, 128, '2014-02-15 00:31:11.000000', 'consum', 0.0210, 'lps'),
	(537219, 128, '2014-02-15 00:31:12.000000', 'consum', 0.0222, 'lps'),
	(537220, 128, '2014-02-15 00:31:13.000000', 'consum', 0.0218, 'lps'),
	(537221, 128, '2014-02-15 00:31:14.000000', 'consum', 0.0215, 'lps'),
	(537222, 128, '2014-02-15 00:31:15.000000', 'consum', 0.0214, 'lps'),
	(537223, 128, '2014-02-15 00:31:16.000000', 'consum', 0.0213, 'lps'),
	(537224, 128, '2014-02-15 00:31:17.000000', 'consum', 0.0215, 'lps'),
	(537225, 128, '2014-02-15 00:31:18.000000', 'consum', 0.0210, 'lps'),
	(537226, 128, '2014-02-15 00:31:19.000000', 'consum', 0.0213, 'lps'),
	(537227, 128, '2014-02-15 00:31:20.000000', 'consum', 0.0224, 'lps'),
	(537228, 128, '2014-02-15 00:31:21.000000', 'consum', 0.0222, 'lps'),
	(537229, 128, '2014-02-15 00:31:22.000000', 'consum', 0.0211, 'lps'),
	(537230, 128, '2014-02-15 00:31:23.000000', 'consum', 0.0213, 'lps'),
	(537231, 128, '2014-02-15 00:31:24.000000', 'consum', 0.0221, 'lps'),
	(537232, 128, '2014-02-15 00:31:25.000000', 'consum', 0.0225, 'lps'),
	(537233, 128, '2014-02-15 00:31:26.000000', 'consum', 0.0220, 'lps'),
	(537234, 128, '2014-02-15 00:31:27.000000', 'consum', 0.0212, 'lps'),
	(537235, 128, '2014-02-15 00:31:28.000000', 'consum', 0.0210, 'lps'),
	(537236, 128, '2014-02-15 00:31:29.000000', 'consum', 0.0223, 'lps'),
	(537237, 128, '2014-02-15 00:31:30.000000', 'consum', 0.0221, 'lps'),
	(537238, 128, '2014-02-15 00:31:31.000000', 'consum', 0.0211, 'lps'),
	(537239, 128, '2014-02-15 00:31:32.000000', 'consum', 0.0218, 'lps'),
	(537240, 128, '2014-02-15 00:31:33.000000', 'consum', 0.0212, 'lps'),
	(537241, 128, '2014-02-15 00:31:34.000000', 'consum', 0.0215, 'lps'),
	(537242, 128, '2014-02-15 00:31:35.000000', 'consum', 0.0213, 'lps'),
	(537243, 128, '2014-02-15 00:31:36.000000', 'consum', 0.0211, 'lps'),
	(537244, 128, '2014-02-15 00:31:37.000000', 'consum', 0.0221, 'lps'),
	(537245, 128, '2014-02-15 00:31:38.000000', 'consum', 0.0211, 'lps'),
	(537246, 128, '2014-02-15 00:31:39.000000', 'consum', 0.0218, 'lps'),
	(537247, 128, '2014-02-15 00:31:40.000000', 'consum', 0.0213, 'lps'),
	(537248, 128, '2014-02-15 00:31:41.000000', 'consum', 0.0220, 'lps'),
	(537249, 128, '2014-02-15 00:31:42.000000', 'consum', 0.0217, 'lps'),
	(537250, 128, '2014-02-15 00:31:43.000000', 'consum', 0.0215, 'lps'),
	(537251, 128, '2014-02-15 00:31:44.000000', 'consum', 0.0213, 'lps'),
	(537252, 128, '2014-02-15 00:31:45.000000', 'consum', 0.0212, 'lps'),
	(537253, 128, '2014-02-15 00:31:46.000000', 'consum', 0.0213, 'lps'),
	(537254, 128, '2014-02-15 00:31:47.000000', 'consum', 0.0218, 'lps'),
	(537255, 128, '2014-02-15 00:31:48.000000', 'consum', 0.0225, 'lps'),
	(537256, 128, '2014-02-15 00:31:49.000000', 'consum', 0.0210, 'lps'),
	(537257, 128, '2014-02-15 00:31:50.000000', 'consum', 0.0217, 'lps'),
	(537258, 128, '2014-02-15 00:31:51.000000', 'consum', 0.0210, 'lps'),
	(537259, 128, '2014-02-15 00:31:52.000000', 'consum', 0.0223, 'lps'),
	(537260, 128, '2014-02-15 00:31:53.000000', 'consum', 0.0226, 'lps'),
	(537261, 128, '2014-02-15 00:31:54.000000', 'consum', 0.0216, 'lps'),
	(537262, 128, '2014-02-15 00:31:55.000000', 'consum', 0.0225, 'lps'),
	(537263, 128, '2014-02-15 00:31:56.000000', 'consum', 0.0219, 'lps'),
	(537264, 128, '2014-02-15 00:31:57.000000', 'consum', 0.0226, 'lps'),
	(537265, 128, '2014-02-15 00:31:58.000000', 'consum', 0.0215, 'lps'),
	(537266, 128, '2014-02-15 00:31:59.000000', 'consum', 0.0219, 'lps'),
	(537267, 128, '2014-02-15 00:32:00.000000', 'consum', 0.0223, 'lps'),
	(537268, 128, '2014-02-15 00:32:01.000000', 'consum', 0.0216, 'lps'),
	(537269, 128, '2014-02-15 00:32:02.000000', 'consum', 0.0219, 'lps'),
	(537270, 128, '2014-02-15 00:32:03.000000', 'consum', 0.0220, 'lps'),
	(537271, 128, '2014-02-15 00:32:04.000000', 'consum', 0.0217, 'lps'),
	(537272, 128, '2014-02-15 00:32:05.000000', 'consum', 0.0213, 'lps'),
	(537273, 128, '2014-02-15 00:32:06.000000', 'consum', 0.0224, 'lps'),
	(537274, 128, '2014-02-15 00:32:07.000000', 'consum', 0.0220, 'lps'),
	(537275, 128, '2014-02-15 00:32:08.000000', 'consum', 0.0220, 'lps'),
	(537276, 128, '2014-02-15 00:32:09.000000', 'consum', 0.0214, 'lps'),
	(537277, 128, '2014-02-15 00:32:10.000000', 'consum', 0.0214, 'lps'),
	(537278, 128, '2014-02-15 00:32:11.000000', 'consum', 0.0222, 'lps'),
	(537279, 128, '2014-02-15 00:32:12.000000', 'consum', 0.0222, 'lps'),
	(537280, 128, '2014-02-15 00:32:13.000000', 'consum', 0.0217, 'lps'),
	(537281, 128, '2014-02-15 00:32:14.000000', 'consum', 0.0212, 'lps'),
	(537282, 128, '2014-02-15 00:32:15.000000', 'consum', 0.0217, 'lps'),
	(537283, 128, '2014-02-15 00:32:16.000000', 'consum', 0.0221, 'lps'),
	(537284, 128, '2014-02-15 00:32:17.000000', 'consum', 0.0211, 'lps'),
	(537285, 128, '2014-02-15 00:32:18.000000', 'consum', 0.0218, 'lps'),
	(537286, 128, '2014-02-15 00:32:19.000000', 'consum', 0.0213, 'lps'),
	(537287, 128, '2014-02-15 00:32:20.000000', 'consum', 0.0217, 'lps'),
	(537288, 128, '2014-02-15 00:32:21.000000', 'consum', 0.0222, 'lps'),
	(537289, 128, '2014-02-15 00:32:22.000000', 'consum', 0.0213, 'lps'),
	(537290, 128, '2014-02-15 00:32:23.000000', 'consum', 0.0224, 'lps'),
	(537291, 128, '2014-02-15 00:32:24.000000', 'consum', 0.0219, 'lps'),
	(537292, 128, '2014-02-15 00:32:25.000000', 'consum', 0.0215, 'lps'),
	(537293, 128, '2014-02-15 00:32:26.000000', 'consum', 0.0210, 'lps'),
	(537294, 128, '2014-02-15 00:32:27.000000', 'consum', 0.0212, 'lps'),
	(537295, 128, '2014-02-15 00:32:28.000000', 'consum', 0.0220, 'lps'),
	(537296, 128, '2014-02-15 00:32:29.000000', 'consum', 0.0221, 'lps'),
	(537297, 128, '2014-02-15 00:32:30.000000', 'consum', 0.0219, 'lps'),
	(537298, 128, '2014-02-15 00:32:31.000000', 'consum', 0.0221, 'lps'),
	(537299, 128, '2014-02-15 00:32:32.000000', 'consum', 0.0224, 'lps'),
	(537300, 128, '2014-02-15 00:32:33.000000', 'consum', 0.0210, 'lps'),
	(537301, 128, '2014-02-15 00:32:34.000000', 'consum', 0.0222, 'lps'),
	(537302, 128, '2014-02-15 00:32:35.000000', 'consum', 0.0219, 'lps'),
	(537303, 128, '2014-02-15 00:32:36.000000', 'consum', 0.0218, 'lps'),
	(537304, 128, '2014-02-15 00:32:37.000000', 'consum', 0.0224, 'lps'),
	(537305, 128, '2014-02-15 00:32:38.000000', 'consum', 0.0221, 'lps'),
	(537306, 128, '2014-02-15 00:32:39.000000', 'consum', 0.0224, 'lps'),
	(537307, 128, '2014-02-15 00:32:40.000000', 'consum', 0.0214, 'lps'),
	(537308, 128, '2014-02-15 00:32:41.000000', 'consum', 0.0222, 'lps'),
	(537309, 128, '2014-02-15 00:32:42.000000', 'consum', 0.0224, 'lps'),
	(537310, 128, '2014-02-15 00:32:43.000000', 'consum', 0.0211, 'lps'),
	(537311, 128, '2014-02-15 00:32:44.000000', 'consum', 0.0223, 'lps'),
	(537312, 128, '2014-02-15 00:32:45.000000', 'consum', 0.0222, 'lps'),
	(537313, 128, '2014-02-15 00:32:46.000000', 'consum', 0.0213, 'lps'),
	(537314, 128, '2014-02-15 00:32:47.000000', 'consum', 0.0225, 'lps'),
	(537315, 128, '2014-02-15 00:32:48.000000', 'consum', 0.0223, 'lps'),
	(537316, 128, '2014-02-15 00:32:49.000000', 'consum', 0.0216, 'lps'),
	(537317, 128, '2014-02-15 00:32:50.000000', 'consum', 0.0219, 'lps'),
	(537318, 128, '2014-02-15 00:32:51.000000', 'consum', 0.0220, 'lps'),
	(537319, 128, '2014-02-15 00:32:52.000000', 'consum', 0.0217, 'lps'),
	(537320, 128, '2014-02-15 00:32:53.000000', 'consum', 0.0214, 'lps'),
	(537321, 128, '2014-02-15 00:32:54.000000', 'consum', 0.0211, 'lps'),
	(537322, 128, '2014-02-15 00:32:55.000000', 'consum', 0.0220, 'lps'),
	(537323, 128, '2014-02-15 00:32:56.000000', 'consum', 0.0224, 'lps'),
	(537324, 128, '2014-02-15 00:32:57.000000', 'consum', 0.0214, 'lps'),
	(537325, 128, '2014-02-15 00:32:58.000000', 'consum', 0.0225, 'lps'),
	(537326, 128, '2014-02-15 00:32:59.000000', 'consum', 0.0223, 'lps'),
	(537327, 128, '2014-02-15 00:33:00.000000', 'consum', 0.0211, 'lps'),
	(537328, 128, '2014-02-15 00:33:01.000000', 'consum', 0.0210, 'lps'),
	(537329, 128, '2014-02-15 00:33:02.000000', 'consum', 0.0226, 'lps'),
	(537330, 128, '2014-02-15 00:33:03.000000', 'consum', 0.0223, 'lps'),
	(537331, 128, '2014-02-15 00:33:04.000000', 'consum', 0.0212, 'lps'),
	(537332, 128, '2014-02-15 00:33:05.000000', 'consum', 0.0213, 'lps'),
	(537333, 128, '2014-02-15 00:33:06.000000', 'consum', 0.0218, 'lps'),
	(537334, 128, '2014-02-15 00:33:07.000000', 'consum', 0.0211, 'lps'),
	(537335, 128, '2014-02-15 00:33:08.000000', 'consum', 0.0225, 'lps'),
	(537336, 128, '2014-02-15 00:33:09.000000', 'consum', 0.0212, 'lps'),
	(537337, 128, '2014-02-15 00:33:10.000000', 'consum', 0.0212, 'lps'),
	(537338, 128, '2014-02-15 00:33:11.000000', 'consum', 0.0214, 'lps'),
	(537339, 128, '2014-02-15 00:33:12.000000', 'consum', 0.0224, 'lps'),
	(537340, 128, '2014-02-15 00:33:13.000000', 'consum', 0.0220, 'lps'),
	(537341, 128, '2014-02-15 00:33:14.000000', 'consum', 0.0215, 'lps'),
	(537342, 128, '2014-02-15 00:33:15.000000', 'consum', 0.0223, 'lps'),
	(537343, 128, '2014-02-15 00:33:16.000000', 'consum', 0.0210, 'lps'),
	(537344, 128, '2014-02-15 00:33:17.000000', 'consum', 0.0224, 'lps'),
	(537345, 128, '2014-02-15 00:33:18.000000', 'consum', 0.0210, 'lps'),
	(537346, 128, '2014-02-15 00:33:19.000000', 'consum', 0.0222, 'lps'),
	(537347, 128, '2014-02-15 00:33:20.000000', 'consum', 0.0218, 'lps'),
	(537348, 128, '2014-02-15 00:33:21.000000', 'consum', 0.0215, 'lps'),
	(537349, 128, '2014-02-15 00:33:22.000000', 'consum', 0.0212, 'lps'),
	(537350, 128, '2014-02-15 00:33:23.000000', 'consum', 0.0223, 'lps'),
	(537351, 128, '2014-02-15 00:33:24.000000', 'consum', 0.0218, 'lps'),
	(537352, 128, '2014-02-15 00:33:25.000000', 'consum', 0.0226, 'lps'),
	(537353, 128, '2014-02-15 00:33:26.000000', 'consum', 0.0219, 'lps'),
	(537354, 128, '2014-02-15 00:33:27.000000', 'consum', 0.0223, 'lps'),
	(537355, 128, '2014-02-15 00:33:28.000000', 'consum', 0.0213, 'lps'),
	(537356, 128, '2014-02-15 00:33:29.000000', 'consum', 0.0222, 'lps'),
	(537357, 128, '2014-02-15 00:33:30.000000', 'consum', 0.0211, 'lps'),
	(537358, 128, '2014-02-15 00:33:31.000000', 'consum', 0.0214, 'lps'),
	(537359, 128, '2014-02-15 00:33:32.000000', 'consum', 0.0225, 'lps'),
	(537360, 128, '2014-02-15 00:33:33.000000', 'consum', 0.0223, 'lps'),
	(537361, 128, '2014-02-15 00:33:34.000000', 'consum', 0.0213, 'lps'),
	(537362, 128, '2014-02-15 00:33:35.000000', 'consum', 0.0223, 'lps'),
	(537363, 128, '2014-02-15 00:33:36.000000', 'consum', 0.0212, 'lps'),
	(537364, 128, '2014-02-15 00:33:37.000000', 'consum', 0.0218, 'lps'),
	(537365, 128, '2014-02-15 00:33:38.000000', 'consum', 0.0212, 'lps'),
	(537366, 128, '2014-02-15 00:33:39.000000', 'consum', 0.0212, 'lps'),
	(537367, 128, '2014-02-15 00:33:40.000000', 'consum', 0.0214, 'lps'),
	(537368, 128, '2014-02-15 00:33:41.000000', 'consum', 0.0225, 'lps'),
	(537369, 128, '2014-02-15 00:33:42.000000', 'consum', 0.0223, 'lps'),
	(537370, 128, '2014-02-15 00:33:43.000000', 'consum', 0.0211, 'lps'),
	(537371, 128, '2014-02-15 00:33:44.000000', 'consum', 0.0213, 'lps'),
	(537372, 128, '2014-02-15 00:33:45.000000', 'consum', 0.0221, 'lps'),
	(537373, 128, '2014-02-15 00:33:46.000000', 'consum', 0.0224, 'lps'),
	(537374, 128, '2014-02-15 00:33:47.000000', 'consum', 0.0215, 'lps'),
	(537375, 128, '2014-02-15 00:33:48.000000', 'consum', 0.0225, 'lps'),
	(537376, 128, '2014-02-15 00:33:49.000000', 'consum', 0.0221, 'lps'),
	(537377, 128, '2014-02-15 00:33:50.000000', 'consum', 0.0221, 'lps'),
	(537378, 128, '2014-02-15 00:33:51.000000', 'consum', 0.0216, 'lps'),
	(537379, 128, '2014-02-15 00:33:52.000000', 'consum', 0.0222, 'lps'),
	(537380, 128, '2014-02-15 00:33:53.000000', 'consum', 0.0221, 'lps'),
	(537381, 128, '2014-02-15 00:33:54.000000', 'consum', 0.0213, 'lps'),
	(537382, 128, '2014-02-15 00:33:55.000000', 'consum', 0.0224, 'lps'),
	(537383, 128, '2014-02-15 00:33:56.000000', 'consum', 0.0222, 'lps'),
	(537384, 128, '2014-02-15 00:33:57.000000', 'consum', 0.0210, 'lps'),
	(537385, 128, '2014-02-15 00:33:58.000000', 'consum', 0.0211, 'lps'),
	(537386, 128, '2014-02-15 00:33:59.000000', 'consum', 0.0213, 'lps'),
	(537387, 128, '2014-02-15 00:34:00.000000', 'consum', 0.0223, 'lps'),
	(537388, 128, '2014-02-15 00:34:01.000000', 'consum', 0.0216, 'lps'),
	(537389, 128, '2014-02-15 00:34:02.000000', 'consum', 0.0220, 'lps'),
	(537390, 128, '2014-02-15 00:34:03.000000', 'consum', 0.0225, 'lps'),
	(537391, 128, '2014-02-15 00:34:04.000000', 'consum', 0.0223, 'lps'),
	(537392, 128, '2014-02-15 00:34:05.000000', 'consum', 0.0213, 'lps'),
	(537393, 128, '2014-02-15 00:34:06.000000', 'consum', 0.0219, 'lps'),
	(537394, 128, '2014-02-15 00:34:07.000000', 'consum', 0.0213, 'lps'),
	(537395, 128, '2014-02-15 00:34:08.000000', 'consum', 0.0217, 'lps'),
	(537396, 128, '2014-02-15 00:34:09.000000', 'consum', 0.0220, 'lps'),
	(537397, 128, '2014-02-15 00:34:10.000000', 'consum', 0.0223, 'lps'),
	(537398, 128, '2014-02-15 00:34:11.000000', 'consum', 0.0210, 'lps'),
	(537399, 128, '2014-02-15 00:34:12.000000', 'consum', 0.0222, 'lps'),
	(537400, 128, '2014-02-15 00:34:13.000000', 'consum', 0.0222, 'lps'),
	(537401, 128, '2014-02-15 00:34:14.000000', 'consum', 0.0217, 'lps'),
	(537402, 128, '2014-02-15 00:34:15.000000', 'consum', 0.0225, 'lps'),
	(537403, 128, '2014-02-15 00:34:16.000000', 'consum', 0.0215, 'lps'),
	(537404, 128, '2014-02-15 00:34:17.000000', 'consum', 0.0225, 'lps'),
	(537405, 128, '2014-02-15 00:34:18.000000', 'consum', 0.0220, 'lps'),
	(537406, 128, '2014-02-15 00:34:19.000000', 'consum', 0.0216, 'lps'),
	(537407, 128, '2014-02-15 00:34:20.000000', 'consum', 0.0210, 'lps'),
	(537408, 128, '2014-02-15 00:34:21.000000', 'consum', 0.0210, 'lps'),
	(537409, 128, '2014-02-15 00:34:22.000000', 'consum', 0.0210, 'lps'),
	(537410, 128, '2014-02-15 00:34:23.000000', 'consum', 0.0210, 'lps'),
	(537411, 128, '2014-02-15 00:34:24.000000', 'consum', 0.0213, 'lps'),
	(537412, 128, '2014-02-15 00:34:25.000000', 'consum', 0.0223, 'lps'),
	(537413, 128, '2014-02-15 00:34:26.000000', 'consum', 0.0217, 'lps'),
	(537414, 128, '2014-02-15 00:34:27.000000', 'consum', 0.0224, 'lps'),
	(537415, 128, '2014-02-15 00:34:28.000000', 'consum', 0.0226, 'lps'),
	(537416, 128, '2014-02-15 00:34:29.000000', 'consum', 0.0213, 'lps'),
	(537417, 128, '2014-02-15 00:34:30.000000', 'consum', 0.0210, 'lps'),
	(537418, 128, '2014-02-15 00:34:31.000000', 'consum', 0.0220, 'lps'),
	(537419, 128, '2014-02-15 00:34:32.000000', 'consum', 0.0211, 'lps'),
	(537420, 128, '2014-02-15 00:34:33.000000', 'consum', 0.0218, 'lps'),
	(537421, 128, '2014-02-15 00:34:34.000000', 'consum', 0.0212, 'lps'),
	(537422, 128, '2014-02-15 00:34:35.000000', 'consum', 0.0214, 'lps'),
	(537423, 128, '2014-02-15 00:34:36.000000', 'consum', 0.0225, 'lps'),
	(537424, 128, '2014-02-15 00:34:37.000000', 'consum', 0.0222, 'lps'),
	(537425, 128, '2014-02-15 00:34:38.000000', 'consum', 0.0225, 'lps'),
	(537426, 128, '2014-02-15 00:34:39.000000', 'consum', 0.0217, 'lps'),
	(537427, 128, '2014-02-15 00:34:40.000000', 'consum', 0.0215, 'lps'),
	(537428, 128, '2014-02-15 00:34:41.000000', 'consum', 0.0215, 'lps'),
	(537429, 128, '2014-02-15 00:34:42.000000', 'consum', 0.0219, 'lps'),
	(537430, 128, '2014-02-15 00:34:43.000000', 'consum', 0.0226, 'lps'),
	(537431, 128, '2014-02-15 00:34:44.000000', 'consum', 0.0213, 'lps'),
	(537432, 128, '2014-02-15 00:34:45.000000', 'consum', 0.0212, 'lps'),
	(537433, 128, '2014-02-15 00:34:46.000000', 'consum', 0.0226, 'lps'),
	(537434, 128, '2014-02-15 00:34:47.000000', 'consum', 0.0217, 'lps'),
	(537435, 128, '2014-02-15 00:34:48.000000', 'consum', 0.0214, 'lps'),
	(537436, 128, '2014-02-15 00:34:49.000000', 'consum', 0.0226, 'lps'),
	(537437, 128, '2014-02-15 00:34:50.000000', 'consum', 0.0213, 'lps'),
	(537438, 128, '2014-02-15 00:34:51.000000', 'consum', 0.0211, 'lps'),
	(537439, 128, '2014-02-15 00:34:52.000000', 'consum', 0.0222, 'lps'),
	(537440, 128, '2014-02-15 00:34:53.000000', 'consum', 0.0216, 'lps'),
	(537441, 128, '2014-02-15 00:34:54.000000', 'consum', 0.0222, 'lps'),
	(537442, 128, '2014-02-15 00:34:55.000000', 'consum', 0.0221, 'lps'),
	(537443, 128, '2014-02-15 00:34:56.000000', 'consum', 0.0210, 'lps'),
	(537444, 128, '2014-02-15 00:34:57.000000', 'consum', 0.0214, 'lps'),
	(537445, 128, '2014-02-15 00:34:58.000000', 'consum', 0.0212, 'lps'),
	(537446, 128, '2014-02-15 00:34:59.000000', 'consum', 0.0225, 'lps'),
	(537447, 128, '2014-02-15 00:35:00.000000', 'consum', 0.0210, 'lps'),
	(537448, 128, '2014-02-15 00:35:01.000000', 'consum', 0.0218, 'lps'),
	(537449, 128, '2014-02-15 00:35:02.000000', 'consum', 0.0215, 'lps'),
	(537450, 128, '2014-02-15 00:35:03.000000', 'consum', 0.0211, 'lps'),
	(537451, 128, '2014-02-15 00:35:04.000000', 'consum', 0.0217, 'lps'),
	(537452, 128, '2014-02-15 00:35:05.000000', 'consum', 0.0225, 'lps'),
	(537453, 128, '2014-02-15 00:35:06.000000', 'consum', 0.0216, 'lps'),
	(537454, 128, '2014-02-15 00:35:07.000000', 'consum', 0.0212, 'lps'),
	(537455, 128, '2014-02-15 00:35:08.000000', 'consum', 0.0219, 'lps'),
	(537456, 128, '2014-02-15 00:35:09.000000', 'consum', 0.0215, 'lps'),
	(537457, 128, '2014-02-15 00:35:10.000000', 'consum', 0.0226, 'lps'),
	(537458, 128, '2014-02-15 00:35:11.000000', 'consum', 0.0225, 'lps'),
	(537459, 128, '2014-02-15 00:35:12.000000', 'consum', 0.0221, 'lps'),
	(537460, 128, '2014-02-15 00:35:13.000000', 'consum', 0.0218, 'lps'),
	(537461, 128, '2014-02-15 00:35:14.000000', 'consum', 0.0220, 'lps'),
	(537462, 128, '2014-02-15 00:35:15.000000', 'consum', 0.0217, 'lps'),
	(537463, 128, '2014-02-15 00:35:16.000000', 'consum', 0.0219, 'lps'),
	(537464, 128, '2014-02-15 00:35:17.000000', 'consum', 0.0215, 'lps'),
	(537465, 128, '2014-02-15 00:35:18.000000', 'consum', 0.0225, 'lps'),
	(537466, 128, '2014-02-15 00:35:19.000000', 'consum', 0.0222, 'lps'),
	(537467, 128, '2014-02-15 00:35:20.000000', 'consum', 0.0224, 'lps'),
	(537468, 128, '2014-02-15 00:35:21.000000', 'consum', 0.0212, 'lps'),
	(537469, 128, '2014-02-15 00:35:22.000000', 'consum', 0.0211, 'lps'),
	(537470, 128, '2014-02-15 00:35:23.000000', 'consum', 0.0226, 'lps'),
	(537471, 128, '2014-02-15 00:35:24.000000', 'consum', 0.0219, 'lps'),
	(537472, 128, '2014-02-15 00:35:25.000000', 'consum', 0.0225, 'lps'),
	(537473, 128, '2014-02-15 00:35:26.000000', 'consum', 0.0223, 'lps'),
	(537474, 128, '2014-02-15 00:35:27.000000', 'consum', 0.0216, 'lps'),
	(537475, 128, '2014-02-15 00:35:28.000000', 'consum', 0.0217, 'lps'),
	(537476, 128, '2014-02-15 00:35:29.000000', 'consum', 0.0211, 'lps'),
	(537477, 128, '2014-02-15 00:35:30.000000', 'consum', 0.0213, 'lps'),
	(537478, 128, '2014-02-15 00:35:31.000000', 'consum', 0.0220, 'lps'),
	(537479, 128, '2014-02-15 00:35:32.000000', 'consum', 0.0219, 'lps'),
	(537480, 128, '2014-02-15 00:35:33.000000', 'consum', 0.0224, 'lps'),
	(537481, 128, '2014-02-15 00:35:34.000000', 'consum', 0.0220, 'lps'),
	(537482, 128, '2014-02-15 00:35:35.000000', 'consum', 0.0217, 'lps'),
	(537483, 128, '2014-02-15 00:35:36.000000', 'consum', 0.0218, 'lps'),
	(537484, 128, '2014-02-15 00:35:37.000000', 'consum', 0.0213, 'lps'),
	(537485, 128, '2014-02-15 00:35:38.000000', 'consum', 0.0217, 'lps'),
	(537486, 128, '2014-02-15 00:35:39.000000', 'consum', 0.0219, 'lps'),
	(537487, 128, '2014-02-15 00:35:40.000000', 'consum', 0.0220, 'lps'),
	(537488, 128, '2014-02-15 00:35:41.000000', 'consum', 0.0215, 'lps'),
	(537489, 128, '2014-02-15 00:35:42.000000', 'consum', 0.0221, 'lps'),
	(537490, 128, '2014-02-15 00:35:43.000000', 'consum', 0.0219, 'lps'),
	(537491, 128, '2014-02-15 00:35:44.000000', 'consum', 0.0222, 'lps'),
	(537492, 128, '2014-02-15 00:35:45.000000', 'consum', 0.0225, 'lps'),
	(537493, 128, '2014-02-15 00:35:46.000000', 'consum', 0.0215, 'lps'),
	(537494, 128, '2014-02-15 00:35:47.000000', 'consum', 0.0225, 'lps'),
	(537495, 128, '2014-02-15 00:35:48.000000', 'consum', 0.0218, 'lps'),
	(537496, 128, '2014-02-15 00:35:49.000000', 'consum', 0.0224, 'lps'),
	(537497, 128, '2014-02-15 00:35:50.000000', 'consum', 0.0223, 'lps'),
	(537498, 128, '2014-02-15 00:35:51.000000', 'consum', 0.0216, 'lps'),
	(537499, 128, '2014-02-15 00:35:52.000000', 'consum', 0.0217, 'lps'),
	(537500, 128, '2014-02-15 00:35:53.000000', 'consum', 0.0213, 'lps'),
	(537501, 128, '2014-02-15 00:35:54.000000', 'consum', 0.0219, 'lps'),
	(537502, 128, '2014-02-15 00:35:55.000000', 'consum', 0.0213, 'lps'),
	(537503, 128, '2014-02-15 00:35:56.000000', 'consum', 0.0216, 'lps'),
	(537504, 128, '2014-02-15 00:35:57.000000', 'consum', 0.0212, 'lps'),
	(537505, 128, '2014-02-15 00:35:58.000000', 'consum', 0.0223, 'lps'),
	(537506, 128, '2014-02-15 00:35:59.000000', 'consum', 0.0218, 'lps'),
	(537507, 128, '2014-02-15 00:36:00.000000', 'consum', 0.0213, 'lps'),
	(537508, 128, '2014-02-15 00:36:01.000000', 'consum', 0.0217, 'lps'),
	(537509, 128, '2014-02-15 00:36:02.000000', 'consum', 0.0217, 'lps'),
	(537510, 128, '2014-02-15 00:36:03.000000', 'consum', 0.0211, 'lps'),
	(537511, 128, '2014-02-15 00:36:04.000000', 'consum', 0.0212, 'lps'),
	(537512, 128, '2014-02-15 00:36:05.000000', 'consum', 0.0217, 'lps'),
	(537513, 128, '2014-02-15 00:36:06.000000', 'consum', 0.0221, 'lps'),
	(537514, 128, '2014-02-15 00:36:07.000000', 'consum', 0.0211, 'lps'),
	(537515, 128, '2014-02-15 00:36:08.000000', 'consum', 0.0218, 'lps'),
	(537516, 128, '2014-02-15 00:36:09.000000', 'consum', 0.0213, 'lps'),
	(537517, 128, '2014-02-15 00:36:10.000000', 'consum', 0.0220, 'lps'),
	(537518, 128, '2014-02-15 00:36:11.000000', 'consum', 0.0217, 'lps'),
	(537519, 128, '2014-02-15 00:36:12.000000', 'consum', 0.0214, 'lps'),
	(537520, 128, '2014-02-15 00:36:13.000000', 'consum', 0.0210, 'lps'),
	(537521, 128, '2014-02-15 00:36:14.000000', 'consum', 0.0215, 'lps'),
	(537522, 128, '2014-02-15 00:36:15.000000', 'consum', 0.0217, 'lps'),
	(537523, 128, '2014-02-15 00:36:16.000000', 'consum', 0.0217, 'lps'),
	(537524, 128, '2014-02-15 00:36:17.000000', 'consum', 0.0222, 'lps'),
	(537525, 128, '2014-02-15 00:36:18.000000', 'consum', 0.0215, 'lps'),
	(537526, 128, '2014-02-15 00:36:19.000000', 'consum', 0.0219, 'lps'),
	(537527, 128, '2014-02-15 00:36:20.000000', 'consum', 0.0222, 'lps'),
	(537528, 128, '2014-02-15 00:36:21.000000', 'consum', 0.0225, 'lps'),
	(537529, 128, '2014-02-15 00:36:22.000000', 'consum', 0.0216, 'lps'),
	(537530, 128, '2014-02-15 00:36:23.000000', 'consum', 0.0212, 'lps'),
	(537531, 128, '2014-02-15 00:36:24.000000', 'consum', 0.0218, 'lps'),
	(537532, 128, '2014-02-15 00:36:25.000000', 'consum', 0.0213, 'lps'),
	(537533, 128, '2014-02-15 00:36:26.000000', 'consum', 0.0218, 'lps'),
	(537534, 128, '2014-02-15 00:36:27.000000', 'consum', 0.0223, 'lps'),
	(537535, 128, '2014-02-15 00:36:28.000000', 'consum', 0.0220, 'lps'),
	(537536, 128, '2014-02-15 00:36:29.000000', 'consum', 0.0220, 'lps'),
	(537537, 128, '2014-02-15 00:36:30.000000', 'consum', 0.0214, 'lps'),
	(537538, 128, '2014-02-15 00:36:31.000000', 'consum', 0.0215, 'lps'),
	(537539, 128, '2014-02-15 00:36:32.000000', 'consum', 0.0210, 'lps'),
	(537540, 128, '2014-02-15 00:36:33.000000', 'consum', 0.0210, 'lps'),
	(537541, 128, '2014-02-15 00:36:34.000000', 'consum', 0.0210, 'lps'),
	(537542, 128, '2014-02-15 00:36:35.000000', 'consum', 0.0210, 'lps'),
	(537543, 128, '2014-02-15 00:36:36.000000', 'consum', 0.0211, 'lps'),
	(537544, 128, '2014-02-15 00:36:37.000000', 'consum', 0.0217, 'lps'),
	(537545, 128, '2014-02-15 00:36:38.000000', 'consum', 0.0223, 'lps'),
	(537546, 128, '2014-02-15 00:36:39.000000', 'consum', 0.0223, 'lps'),
	(537547, 128, '2014-02-15 00:36:40.000000', 'consum', 0.0218, 'lps'),
	(537548, 128, '2014-02-15 00:36:41.000000', 'consum', 0.0210, 'lps'),
	(537549, 128, '2014-02-15 00:36:42.000000', 'consum', 0.0223, 'lps'),
	(537550, 128, '2014-02-15 00:36:43.000000', 'consum', 0.0226, 'lps'),
	(537551, 128, '2014-02-15 00:36:44.000000', 'consum', 0.0214, 'lps'),
	(537552, 128, '2014-02-15 00:36:45.000000', 'consum', 0.0220, 'lps'),
	(537553, 128, '2014-02-15 00:36:46.000000', 'consum', 0.0213, 'lps'),
	(537554, 128, '2014-02-15 00:36:47.000000', 'consum', 0.0212, 'lps'),
	(537555, 128, '2014-02-15 00:36:48.000000', 'consum', 0.0210, 'lps'),
	(537556, 128, '2014-02-15 00:36:49.000000', 'consum', 0.0224, 'lps'),
	(537557, 128, '2014-02-15 00:36:50.000000', 'consum', 0.0213, 'lps'),
	(537558, 128, '2014-02-15 00:36:51.000000', 'consum', 0.0215, 'lps'),
	(537559, 128, '2014-02-15 00:36:52.000000', 'consum', 0.0212, 'lps'),
	(537560, 128, '2014-02-15 00:36:53.000000', 'consum', 0.0222, 'lps'),
	(537561, 128, '2014-02-15 00:36:54.000000', 'consum', 0.0215, 'lps'),
	(537562, 128, '2014-02-15 00:36:55.000000', 'consum', 0.0216, 'lps'),
	(537563, 128, '2014-02-15 00:36:56.000000', 'consum', 0.0226, 'lps'),
	(537564, 128, '2014-02-15 00:36:57.000000', 'consum', 0.0220, 'lps'),
	(537565, 128, '2014-02-15 00:36:58.000000', 'consum', 0.0214, 'lps'),
	(537566, 128, '2014-02-15 00:36:59.000000', 'consum', 0.0217, 'lps'),
	(537567, 128, '2014-02-15 00:37:00.000000', 'consum', 0.0217, 'lps'),
	(537568, 128, '2014-02-15 00:37:01.000000', 'consum', 0.0225, 'lps'),
	(537569, 128, '2014-02-15 00:37:02.000000', 'consum', 0.0212, 'lps'),
	(537570, 128, '2014-02-15 00:37:03.000000', 'consum', 0.0225, 'lps'),
	(537571, 128, '2014-02-15 00:37:04.000000', 'consum', 0.0213, 'lps'),
	(537572, 128, '2014-02-15 00:37:05.000000', 'consum', 0.0214, 'lps'),
	(537573, 128, '2014-02-15 00:37:06.000000', 'consum', 0.0220, 'lps'),
	(537574, 128, '2014-02-15 00:37:07.000000', 'consum', 0.0216, 'lps'),
	(537575, 128, '2014-02-15 00:37:08.000000', 'consum', 0.0212, 'lps'),
	(537576, 128, '2014-02-15 00:37:09.000000', 'consum', 0.0218, 'lps'),
	(537577, 128, '2014-02-15 00:37:10.000000', 'consum', 0.0213, 'lps'),
	(537578, 128, '2014-02-15 00:37:11.000000', 'consum', 0.0215, 'lps'),
	(537579, 128, '2014-02-15 00:37:12.000000', 'consum', 0.0211, 'lps'),
	(537580, 128, '2014-02-15 00:37:13.000000', 'consum', 0.0218, 'lps'),
	(537581, 128, '2014-02-15 00:37:14.000000', 'consum', 0.0214, 'lps'),
	(537582, 128, '2014-02-15 00:37:15.000000', 'consum', 0.0223, 'lps'),
	(537583, 128, '2014-02-15 00:37:16.000000', 'consum', 0.0214, 'lps'),
	(537584, 128, '2014-02-15 00:37:17.000000', 'consum', 0.0224, 'lps'),
	(537585, 128, '2014-02-15 00:37:18.000000', 'consum', 0.0218, 'lps'),
	(537586, 128, '2014-02-15 00:37:19.000000', 'consum', 0.0225, 'lps'),
	(537587, 128, '2014-02-15 00:37:20.000000', 'consum', 0.0211, 'lps'),
	(537588, 128, '2014-02-15 00:37:21.000000', 'consum', 0.0223, 'lps'),
	(537589, 128, '2014-02-15 00:37:22.000000', 'consum', 0.0218, 'lps'),
	(537590, 128, '2014-02-15 00:37:23.000000', 'consum', 0.0215, 'lps'),
	(537591, 128, '2014-02-15 00:37:24.000000', 'consum', 0.0210, 'lps'),
	(537592, 128, '2014-02-15 00:37:25.000000', 'consum', 0.0214, 'lps'),
	(537593, 128, '2014-02-15 00:37:26.000000', 'consum', 0.0212, 'lps'),
	(537594, 128, '2014-02-15 00:37:27.000000', 'consum', 0.0210, 'lps'),
	(537595, 128, '2014-02-15 00:37:28.000000', 'consum', 0.0219, 'lps'),
	(537596, 128, '2014-02-15 00:37:29.000000', 'consum', 0.0221, 'lps'),
	(537597, 128, '2014-02-15 00:37:30.000000', 'consum', 0.0224, 'lps'),
	(537598, 128, '2014-02-15 00:37:31.000000', 'consum', 0.0212, 'lps'),
	(537599, 128, '2014-02-15 00:37:32.000000', 'consum', 0.0212, 'lps'),
	(537600, 128, '2014-02-15 00:37:33.000000', 'consum', 0.0216, 'lps'),
	(537601, 128, '2014-02-15 00:37:34.000000', 'consum', 0.0219, 'lps'),
	(537602, 128, '2014-02-15 00:37:35.000000', 'consum', 0.0217, 'lps'),
	(537603, 128, '2014-02-15 00:37:36.000000', 'consum', 0.0220, 'lps'),
	(537604, 128, '2014-02-15 00:37:37.000000', 'consum', 0.0223, 'lps'),
	(537605, 128, '2014-02-15 00:37:38.000000', 'consum', 0.0212, 'lps'),
	(537606, 128, '2014-02-15 00:37:39.000000', 'consum', 0.0213, 'lps'),
	(537607, 128, '2014-02-15 00:37:40.000000', 'consum', 0.0221, 'lps'),
	(537608, 128, '2014-02-15 00:37:41.000000', 'consum', 0.0222, 'lps'),
	(537609, 128, '2014-02-15 00:37:42.000000', 'consum', 0.0221, 'lps'),
	(537610, 128, '2014-02-15 00:37:43.000000', 'consum', 0.0212, 'lps'),
	(537611, 128, '2014-02-15 00:37:44.000000', 'consum', 0.0221, 'lps'),
	(537612, 128, '2014-02-15 00:37:45.000000', 'consum', 0.0211, 'lps'),
	(537613, 128, '2014-02-15 00:37:46.000000', 'consum', 0.0214, 'lps'),
	(537614, 128, '2014-02-15 00:37:47.000000', 'consum', 0.0212, 'lps'),
	(537615, 128, '2014-02-15 00:37:48.000000', 'consum', 0.0210, 'lps'),
	(537616, 128, '2014-02-15 00:37:49.000000', 'consum', 0.0219, 'lps'),
	(537617, 128, '2014-02-15 00:37:50.000000', 'consum', 0.0223, 'lps'),
	(537618, 128, '2014-02-15 00:37:51.000000', 'consum', 0.0213, 'lps'),
	(537619, 128, '2014-02-15 00:37:52.000000', 'consum', 0.0222, 'lps'),
	(537620, 128, '2014-02-15 00:37:53.000000', 'consum', 0.0211, 'lps'),
	(537621, 128, '2014-02-15 00:37:54.000000', 'consum', 0.0212, 'lps'),
	(537622, 128, '2014-02-15 00:37:55.000000', 'consum', 0.0217, 'lps'),
	(537623, 128, '2014-02-15 00:37:56.000000', 'consum', 0.0225, 'lps'),
	(537624, 128, '2014-02-15 00:37:57.000000', 'consum', 0.0213, 'lps'),
	(537625, 128, '2014-02-15 00:37:58.000000', 'consum', 0.0216, 'lps'),
	(537626, 128, '2014-02-15 00:37:59.000000', 'consum', 0.0213, 'lps'),
	(537627, 128, '2014-02-15 00:38:00.000000', 'consum', 0.0226, 'lps'),
	(537628, 128, '2014-02-15 00:38:01.000000', 'consum', 0.0214, 'lps'),
	(537629, 128, '2014-02-15 00:38:02.000000', 'consum', 0.0217, 'lps'),
	(537630, 128, '2014-02-15 00:38:03.000000', 'consum', 0.0216, 'lps'),
	(537631, 128, '2014-02-15 00:38:04.000000', 'consum', 0.0220, 'lps'),
	(537632, 128, '2014-02-15 00:38:05.000000', 'consum', 0.0223, 'lps'),
	(537633, 128, '2014-02-15 00:38:06.000000', 'consum', 0.0215, 'lps'),
	(537634, 128, '2014-02-15 00:38:07.000000', 'consum', 0.0211, 'lps'),
	(537635, 128, '2014-02-15 00:38:08.000000', 'consum', 0.0217, 'lps'),
	(537636, 128, '2014-02-15 00:38:09.000000', 'consum', 0.0211, 'lps'),
	(537637, 128, '2014-02-15 00:38:10.000000', 'consum', 0.0210, 'lps'),
	(537638, 128, '2014-02-15 00:38:11.000000', 'consum', 0.0225, 'lps'),
	(537639, 128, '2014-02-15 00:38:12.000000', 'consum', 0.0219, 'lps'),
	(537640, 128, '2014-02-15 00:38:13.000000', 'consum', 0.0225, 'lps'),
	(537641, 128, '2014-02-15 00:38:14.000000', 'consum', 0.0225, 'lps'),
	(537642, 128, '2014-02-15 00:38:15.000000', 'consum', 0.0224, 'lps'),
	(537643, 128, '2014-02-15 00:38:16.000000', 'consum', 0.0220, 'lps'),
	(537644, 128, '2014-02-15 00:38:17.000000', 'consum', 0.0219, 'lps'),
	(537645, 128, '2014-02-15 00:38:18.000000', 'consum', 0.0226, 'lps'),
	(537646, 128, '2014-02-15 00:38:19.000000', 'consum', 0.0226, 'lps'),
	(537647, 128, '2014-02-15 00:38:20.000000', 'consum', 0.0212, 'lps'),
	(537648, 128, '2014-02-15 00:38:21.000000', 'consum', 0.0222, 'lps'),
	(537649, 128, '2014-02-15 00:38:22.000000', 'consum', 0.0214, 'lps'),
	(537650, 128, '2014-02-15 00:38:23.000000', 'consum', 0.0211, 'lps'),
	(537651, 128, '2014-02-15 00:38:24.000000', 'consum', 0.0220, 'lps'),
	(537652, 128, '2014-02-15 00:38:25.000000', 'consum', 0.0225, 'lps'),
	(537653, 128, '2014-02-15 00:38:26.000000', 'consum', 0.0219, 'lps'),
	(537654, 128, '2014-02-15 00:38:27.000000', 'consum', 0.0211, 'lps'),
	(537655, 128, '2014-02-15 00:38:28.000000', 'consum', 0.0224, 'lps'),
	(537656, 128, '2014-02-15 00:38:29.000000', 'consum', 0.0210, 'lps'),
	(537657, 128, '2014-02-15 00:38:30.000000', 'consum', 0.0218, 'lps'),
	(537658, 128, '2014-02-15 00:38:31.000000', 'consum', 0.0215, 'lps'),
	(537659, 128, '2014-02-15 00:38:32.000000', 'consum', 0.0214, 'lps'),
	(537660, 128, '2014-02-15 00:38:33.000000', 'consum', 0.0215, 'lps'),
	(537661, 128, '2014-02-15 00:38:34.000000', 'consum', 0.0224, 'lps'),
	(537662, 128, '2014-02-15 00:38:35.000000', 'consum', 0.0214, 'lps'),
	(537663, 128, '2014-02-15 00:38:36.000000', 'consum', 0.0221, 'lps'),
	(537664, 128, '2014-02-15 00:38:37.000000', 'consum', 0.0219, 'lps'),
	(537665, 128, '2014-02-15 00:38:38.000000', 'consum', 0.0222, 'lps'),
	(537666, 128, '2014-02-15 00:38:39.000000', 'consum', 0.0212, 'lps'),
	(537667, 128, '2014-02-15 00:38:40.000000', 'consum', 0.0218, 'lps'),
	(537668, 128, '2014-02-15 00:38:41.000000', 'consum', 0.0212, 'lps'),
	(537669, 128, '2014-02-15 00:38:42.000000', 'consum', 0.0212, 'lps'),
	(537670, 128, '2014-02-15 00:38:43.000000', 'consum', 0.0216, 'lps'),
	(537671, 128, '2014-02-15 00:38:44.000000', 'consum', 0.0217, 'lps'),
	(537672, 128, '2014-02-15 00:38:45.000000', 'consum', 0.0212, 'lps'),
	(537673, 128, '2014-02-15 00:38:46.000000', 'consum', 0.0216, 'lps'),
	(537674, 128, '2014-02-15 00:38:47.000000', 'consum', 0.0219, 'lps'),
	(537675, 128, '2014-02-15 00:38:48.000000', 'consum', 0.0218, 'lps'),
	(537676, 128, '2014-02-15 00:38:49.000000', 'consum', 0.0224, 'lps'),
	(537677, 128, '2014-02-15 00:38:50.000000', 'consum', 0.0224, 'lps'),
	(537678, 128, '2014-02-15 00:38:51.000000', 'consum', 0.0222, 'lps'),
	(537679, 128, '2014-02-15 00:38:52.000000', 'consum', 0.0211, 'lps'),
	(537680, 128, '2014-02-15 00:38:53.000000', 'consum', 0.0213, 'lps'),
	(537681, 128, '2014-02-15 00:38:54.000000', 'consum', 0.0225, 'lps'),
	(537682, 128, '2014-02-15 00:38:55.000000', 'consum', 0.0223, 'lps'),
	(537683, 128, '2014-02-15 00:38:56.000000', 'consum', 0.0213, 'lps'),
	(537684, 128, '2014-02-15 00:38:57.000000', 'consum', 0.0220, 'lps'),
	(537685, 128, '2014-02-15 00:38:58.000000', 'consum', 0.0217, 'lps'),
	(537686, 128, '2014-02-15 00:38:59.000000', 'consum', 0.0215, 'lps'),
	(537687, 128, '2014-02-15 00:39:00.000000', 'consum', 0.0214, 'lps'),
	(537688, 128, '2014-02-15 00:39:01.000000', 'consum', 0.0216, 'lps'),
	(537689, 128, '2014-02-15 00:39:02.000000', 'consum', 0.0211, 'lps'),
	(537690, 128, '2014-02-15 00:39:03.000000', 'consum', 0.0214, 'lps'),
	(537691, 128, '2014-02-15 00:39:04.000000', 'consum', 0.0210, 'lps'),
	(537692, 128, '2014-02-15 00:39:05.000000', 'consum', 0.0218, 'lps'),
	(537693, 128, '2014-02-15 00:39:06.000000', 'consum', 0.0215, 'lps'),
	(537694, 128, '2014-02-15 00:39:07.000000', 'consum', 0.0213, 'lps'),
	(537695, 128, '2014-02-15 00:39:08.000000', 'consum', 0.0211, 'lps'),
	(537696, 128, '2014-02-15 00:39:09.000000', 'consum', 0.0223, 'lps'),
	(537697, 128, '2014-02-15 00:39:10.000000', 'consum', 0.0221, 'lps'),
	(537698, 128, '2014-02-15 00:39:11.000000', 'consum', 0.0210, 'lps'),
	(537699, 128, '2014-02-15 00:39:12.000000', 'consum', 0.0226, 'lps'),
	(537700, 128, '2014-02-15 00:39:13.000000', 'consum', 0.0225, 'lps'),
	(537701, 128, '2014-02-15 00:39:14.000000', 'consum', 0.0221, 'lps'),
	(537702, 128, '2014-02-15 00:39:15.000000', 'consum', 0.0218, 'lps'),
	(537703, 128, '2014-02-15 00:39:16.000000', 'consum', 0.0219, 'lps'),
	(537704, 128, '2014-02-15 00:39:17.000000', 'consum', 0.0214, 'lps'),
	(537705, 128, '2014-02-15 00:39:18.000000', 'consum', 0.0219, 'lps'),
	(537706, 128, '2014-02-15 00:39:19.000000', 'consum', 0.0211, 'lps'),
	(537707, 128, '2014-02-15 00:39:20.000000', 'consum', 0.0221, 'lps'),
	(537708, 128, '2014-02-15 00:39:21.000000', 'consum', 0.0212, 'lps'),
	(537709, 128, '2014-02-15 00:39:22.000000', 'consum', 0.0223, 'lps'),
	(537710, 128, '2014-02-15 00:39:23.000000', 'consum', 0.0219, 'lps'),
	(537711, 128, '2014-02-15 00:39:24.000000', 'consum', 0.0216, 'lps'),
	(537712, 128, '2014-02-15 00:39:25.000000', 'consum', 0.0211, 'lps'),
	(537713, 128, '2014-02-15 00:39:26.000000', 'consum', 0.0218, 'lps'),
	(537714, 128, '2014-02-15 00:39:27.000000', 'consum', 0.0212, 'lps'),
	(537715, 128, '2014-02-15 00:39:28.000000', 'consum', 0.0212, 'lps'),
	(537716, 128, '2014-02-15 00:39:29.000000', 'consum', 0.0217, 'lps'),
	(537717, 128, '2014-02-15 00:39:30.000000', 'consum', 0.0220, 'lps'),
	(537718, 128, '2014-02-15 00:39:31.000000', 'consum', 0.0223, 'lps'),
	(537719, 128, '2014-02-15 00:39:32.000000', 'consum', 0.0211, 'lps'),
	(537720, 128, '2014-02-15 00:39:33.000000', 'consum', 0.0226, 'lps'),
	(537721, 128, '2014-02-15 00:39:34.000000', 'consum', 0.0222, 'lps'),
	(537722, 128, '2014-02-15 00:39:35.000000', 'consum', 0.0222, 'lps'),
	(537723, 128, '2014-02-15 00:39:36.000000', 'consum', 0.0219, 'lps'),
	(537724, 128, '2014-02-15 00:39:37.000000', 'consum', 0.0220, 'lps'),
	(537725, 128, '2014-02-15 00:39:38.000000', 'consum', 0.0216, 'lps'),
	(537726, 128, '2014-02-15 00:39:39.000000', 'consum', 0.0211, 'lps'),
	(537727, 128, '2014-02-15 00:39:40.000000', 'consum', 0.0212, 'lps'),
	(537728, 128, '2014-02-15 00:39:41.000000', 'consum', 0.0219, 'lps'),
	(537729, 128, '2014-02-15 00:39:42.000000', 'consum', 0.0217, 'lps'),
	(537730, 128, '2014-02-15 00:39:43.000000', 'consum', 0.0217, 'lps'),
	(537731, 128, '2014-02-15 00:39:44.000000', 'consum', 0.0226, 'lps'),
	(537732, 128, '2014-02-15 00:39:45.000000', 'consum', 0.0219, 'lps'),
	(537733, 128, '2014-02-15 00:39:46.000000', 'consum', 0.0221, 'lps'),
	(537734, 128, '2014-02-15 00:39:47.000000', 'consum', 0.0225, 'lps'),
	(537735, 128, '2014-02-15 00:39:48.000000', 'consum', 0.0217, 'lps'),
	(537736, 128, '2014-02-15 00:39:49.000000', 'consum', 0.0219, 'lps'),
	(537737, 128, '2014-02-15 00:39:50.000000', 'consum', 0.0217, 'lps'),
	(537738, 128, '2014-02-15 00:39:51.000000', 'consum', 0.0220, 'lps'),
	(537739, 128, '2014-02-15 00:39:52.000000', 'consum', 0.0222, 'lps'),
	(537740, 128, '2014-02-15 00:39:53.000000', 'consum', 0.0224, 'lps'),
	(537741, 128, '2014-02-15 00:39:54.000000', 'consum', 0.0210, 'lps'),
	(537742, 128, '2014-02-15 00:39:55.000000', 'consum', 0.0218, 'lps'),
	(537743, 128, '2014-02-15 00:39:56.000000', 'consum', 0.0219, 'lps'),
	(537744, 128, '2014-02-15 00:39:57.000000', 'consum', 0.0213, 'lps'),
	(537745, 128, '2014-02-15 00:39:58.000000', 'consum', 0.0217, 'lps'),
	(537746, 128, '2014-02-15 00:39:59.000000', 'consum', 0.0217, 'lps'),
	(537747, 128, '2014-02-15 00:40:00.000000', 'consum', 0.0210, 'lps'),
	(537748, 128, '2014-02-15 00:40:01.000000', 'consum', 0.0223, 'lps'),
	(537749, 128, '2014-02-15 00:40:02.000000', 'consum', 0.0225, 'lps'),
	(537750, 128, '2014-02-15 00:40:03.000000', 'consum', 0.0214, 'lps'),
	(537751, 128, '2014-02-15 00:40:04.000000', 'consum', 0.0218, 'lps'),
	(537752, 128, '2014-02-15 00:40:05.000000', 'consum', 0.0220, 'lps'),
	(537753, 128, '2014-02-15 00:40:06.000000', 'consum', 0.0222, 'lps'),
	(537754, 128, '2014-02-15 00:40:07.000000', 'consum', 0.0224, 'lps'),
	(537755, 128, '2014-02-15 00:40:08.000000', 'consum', 0.0211, 'lps'),
	(537756, 128, '2014-02-15 00:40:09.000000', 'consum', 0.0222, 'lps'),
	(537757, 128, '2014-02-15 00:40:10.000000', 'consum', 0.0216, 'lps'),
	(537758, 128, '2014-02-15 00:40:11.000000', 'consum', 0.0222, 'lps'),
	(537759, 128, '2014-02-15 00:40:12.000000', 'consum', 0.0217, 'lps'),
	(537760, 128, '2014-02-15 00:40:13.000000', 'consum', 0.0212, 'lps'),
	(537761, 128, '2014-02-15 00:40:14.000000', 'consum', 0.0216, 'lps'),
	(537762, 128, '2014-02-15 00:40:15.000000', 'consum', 0.0216, 'lps'),
	(537763, 128, '2014-02-15 00:40:16.000000', 'consum', 0.0225, 'lps'),
	(537764, 128, '2014-02-15 00:40:17.000000', 'consum', 0.0215, 'lps'),
	(537765, 128, '2014-02-15 00:40:18.000000', 'consum', 0.0225, 'lps'),
	(537766, 128, '2014-02-15 00:40:19.000000', 'consum', 0.0218, 'lps'),
	(537767, 128, '2014-02-15 00:40:20.000000', 'consum', 0.0225, 'lps'),
	(537768, 128, '2014-02-15 00:40:21.000000', 'consum', 0.0210, 'lps'),
	(537769, 128, '2014-02-15 00:40:22.000000', 'consum', 0.0216, 'lps'),
	(537770, 128, '2014-02-15 00:40:23.000000', 'consum', 0.0224, 'lps'),
	(537771, 128, '2014-02-15 00:40:24.000000', 'consum', 0.0211, 'lps'),
	(537772, 128, '2014-02-15 00:40:25.000000', 'consum', 0.0224, 'lps'),
	(537773, 128, '2014-02-15 00:40:26.000000', 'consum', 0.0211, 'lps'),
	(537774, 128, '2014-02-15 00:40:27.000000', 'consum', 0.0223, 'lps'),
	(537775, 128, '2014-02-15 00:40:28.000000', 'consum', 0.0221, 'lps'),
	(537776, 128, '2014-02-15 00:40:29.000000', 'consum', 0.0226, 'lps'),
	(537777, 128, '2014-02-15 00:40:30.000000', 'consum', 0.0223, 'lps'),
	(537778, 128, '2014-02-15 00:40:31.000000', 'consum', 0.0211, 'lps'),
	(537779, 128, '2014-02-15 00:40:32.000000', 'consum', 0.0211, 'lps'),
	(537780, 128, '2014-02-15 00:40:33.000000', 'consum', 0.0214, 'lps'),
	(537781, 128, '2014-02-15 00:40:34.000000', 'consum', 0.0226, 'lps'),
	(537782, 128, '2014-02-15 00:40:35.000000', 'consum', 0.0211, 'lps'),
	(537783, 128, '2014-02-15 00:40:36.000000', 'consum', 0.0218, 'lps'),
	(537784, 128, '2014-02-15 00:40:37.000000', 'consum', 0.0214, 'lps'),
	(537785, 128, '2014-02-15 00:40:38.000000', 'consum', 0.0224, 'lps'),
	(537786, 128, '2014-02-15 00:40:39.000000', 'consum', 0.0217, 'lps'),
	(537787, 128, '2014-02-15 00:40:40.000000', 'consum', 0.0219, 'lps'),
	(537788, 128, '2014-02-15 00:40:41.000000', 'consum', 0.0217, 'lps'),
	(537789, 128, '2014-02-15 00:40:42.000000', 'consum', 0.0221, 'lps'),
	(537790, 128, '2014-02-15 00:40:43.000000', 'consum', 0.0210, 'lps'),
	(537791, 128, '2014-02-15 00:40:44.000000', 'consum', 0.0210, 'lps'),
	(537792, 128, '2014-02-15 00:40:45.000000', 'consum', 0.0226, 'lps'),
	(537793, 128, '2014-02-15 00:40:46.000000', 'consum', 0.0225, 'lps'),
	(537794, 128, '2014-02-15 00:40:47.000000', 'consum', 0.0221, 'lps'),
	(537795, 128, '2014-02-15 00:40:48.000000', 'consum', 0.0222, 'lps'),
	(537796, 128, '2014-02-15 00:40:49.000000', 'consum', 0.0218, 'lps'),
	(537797, 128, '2014-02-15 00:40:50.000000', 'consum', 0.0216, 'lps'),
	(537798, 128, '2014-02-15 00:40:51.000000', 'consum', 0.0216, 'lps'),
	(537799, 128, '2014-02-15 00:40:52.000000', 'consum', 0.0224, 'lps'),
	(537800, 128, '2014-02-15 00:40:53.000000', 'consum', 0.0212, 'lps'),
	(537801, 128, '2014-02-15 00:40:54.000000', 'consum', 0.0213, 'lps'),
	(537802, 128, '2014-02-15 00:40:55.000000', 'consum', 0.0218, 'lps'),
	(537803, 128, '2014-02-15 00:40:56.000000', 'consum', 0.0225, 'lps'),
	(537804, 128, '2014-02-15 00:40:57.000000', 'consum', 0.0210, 'lps'),
	(537805, 128, '2014-02-15 00:40:58.000000', 'consum', 0.0218, 'lps'),
	(537806, 128, '2014-02-15 00:40:59.000000', 'consum', 0.0215, 'lps'),
	(537807, 128, '2014-02-15 00:41:00.000000', 'consum', 0.0214, 'lps'),
	(537808, 128, '2014-02-15 00:41:01.000000', 'consum', 0.0214, 'lps'),
	(537809, 128, '2014-02-15 00:41:02.000000', 'consum', 0.0219, 'lps'),
	(537810, 128, '2014-02-15 00:41:03.000000', 'consum', 0.0210, 'lps'),
	(537811, 128, '2014-02-15 00:41:04.000000', 'consum', 0.0217, 'lps'),
	(537812, 128, '2014-02-15 00:41:05.000000', 'consum', 0.0212, 'lps'),
	(537813, 128, '2014-02-15 00:41:06.000000', 'consum', 0.0216, 'lps'),
	(537814, 128, '2014-02-15 00:41:07.000000', 'consum', 0.0216, 'lps'),
	(537815, 128, '2014-02-15 00:41:08.000000', 'consum', 0.0225, 'lps'),
	(537816, 128, '2014-02-15 00:41:09.000000', 'consum', 0.0216, 'lps'),
	(537817, 128, '2014-02-15 00:41:10.000000', 'consum', 0.0211, 'lps'),
	(537818, 128, '2014-02-15 00:41:11.000000', 'consum', 0.0216, 'lps'),
	(537819, 128, '2014-02-15 00:41:12.000000', 'consum', 0.0220, 'lps'),
	(537820, 128, '2014-02-15 00:41:13.000000', 'consum', 0.0226, 'lps'),
	(537821, 128, '2014-02-15 00:41:14.000000', 'consum', 0.0211, 'lps'),
	(537822, 128, '2014-02-15 00:41:15.000000', 'consum', 0.0218, 'lps'),
	(537823, 128, '2014-02-15 00:41:16.000000', 'consum', 0.0213, 'lps'),
	(537824, 128, '2014-02-15 00:41:17.000000', 'consum', 0.0216, 'lps'),
	(537825, 128, '2014-02-15 00:41:18.000000', 'consum', 0.0218, 'lps'),
	(537826, 128, '2014-02-15 00:41:19.000000', 'consum', 0.0213, 'lps'),
	(537827, 128, '2014-02-15 00:41:20.000000', 'consum', 0.0220, 'lps'),
	(537828, 128, '2014-02-15 00:41:21.000000', 'consum', 0.0218, 'lps'),
	(537829, 128, '2014-02-15 00:41:22.000000', 'consum', 0.0219, 'lps'),
	(537830, 128, '2014-02-15 00:41:23.000000', 'consum', 0.0215, 'lps'),
	(537831, 128, '2014-02-15 00:41:24.000000', 'consum', 0.0224, 'lps'),
	(537832, 128, '2014-02-15 00:41:25.000000', 'consum', 0.0217, 'lps'),
	(537833, 128, '2014-02-15 00:41:26.000000', 'consum', 0.0218, 'lps'),
	(537834, 128, '2014-02-15 00:41:27.000000', 'consum', 0.0215, 'lps'),
	(537835, 128, '2014-02-15 00:41:28.000000', 'consum', 0.0226, 'lps'),
	(537836, 128, '2014-02-15 00:41:29.000000', 'consum', 0.0225, 'lps'),
	(537837, 128, '2014-02-15 00:41:30.000000', 'consum', 0.0221, 'lps'),
	(537838, 128, '2014-02-15 00:41:31.000000', 'consum', 0.0219, 'lps'),
	(537839, 128, '2014-02-15 00:41:32.000000', 'consum', 0.0225, 'lps'),
	(537840, 128, '2014-02-15 00:41:33.000000', 'consum', 0.0222, 'lps'),
	(537841, 128, '2014-02-15 00:41:34.000000', 'consum', 0.0226, 'lps'),
	(537842, 128, '2014-02-15 00:41:35.000000', 'consum', 0.0220, 'lps'),
	(537843, 128, '2014-02-15 00:41:36.000000', 'consum', 0.0213, 'lps'),
	(537844, 128, '2014-02-15 00:41:37.000000', 'consum', 0.0214, 'lps'),
	(537845, 128, '2014-02-15 00:41:38.000000', 'consum', 0.0221, 'lps'),
	(537846, 128, '2014-02-15 00:41:39.000000', 'consum', 0.0221, 'lps'),
	(537847, 128, '2014-02-15 00:41:40.000000', 'consum', 0.0212, 'lps'),
	(537848, 128, '2014-02-15 00:41:41.000000', 'consum', 0.0225, 'lps'),
	(537849, 128, '2014-02-15 00:41:42.000000', 'consum', 0.0226, 'lps'),
	(537850, 128, '2014-02-15 00:41:43.000000', 'consum', 0.0213, 'lps'),
	(537851, 128, '2014-02-15 00:41:44.000000', 'consum', 0.0210, 'lps'),
	(537852, 128, '2014-02-15 00:41:45.000000', 'consum', 0.0220, 'lps'),
	(537853, 128, '2014-02-15 00:41:46.000000', 'consum', 0.0226, 'lps'),
	(537854, 128, '2014-02-15 00:41:47.000000', 'consum', 0.0226, 'lps'),
	(537855, 128, '2014-02-15 00:41:48.000000', 'consum', 0.0225, 'lps'),
	(537856, 128, '2014-02-15 00:41:49.000000', 'consum', 0.0221, 'lps'),
	(537857, 128, '2014-02-15 00:41:50.000000', 'consum', 0.0221, 'lps'),
	(537858, 128, '2014-02-15 00:41:51.000000', 'consum', 0.0217, 'lps'),
	(537859, 128, '2014-02-15 00:41:52.000000', 'consum', 0.0212, 'lps'),
	(537860, 128, '2014-02-15 00:41:53.000000', 'consum', 0.0217, 'lps'),
	(537861, 128, '2014-02-15 00:41:54.000000', 'consum', 0.0221, 'lps'),
	(537862, 128, '2014-02-15 00:41:55.000000', 'consum', 0.0213, 'lps'),
	(537863, 128, '2014-02-15 00:41:56.000000', 'consum', 0.0224, 'lps'),
	(537864, 128, '2014-02-15 00:41:57.000000', 'consum', 0.0221, 'lps'),
	(537865, 128, '2014-02-15 00:41:58.000000', 'consum', 0.0225, 'lps'),
	(537866, 128, '2014-02-15 00:41:59.000000', 'consum', 0.0219, 'lps'),
	(537867, 128, '2014-02-15 00:42:00.000000', 'consum', 0.0225, 'lps'),
	(537868, 128, '2014-02-15 00:42:01.000000', 'consum', 0.0225, 'lps'),
	(537869, 128, '2014-02-15 00:42:02.000000', 'consum', 0.0224, 'lps'),
	(537870, 128, '2014-02-15 00:42:03.000000', 'consum', 0.0218, 'lps'),
	(537871, 128, '2014-02-15 00:42:04.000000', 'consum', 0.0225, 'lps'),
	(537872, 128, '2014-02-15 00:42:05.000000', 'consum', 0.0212, 'lps'),
	(537873, 128, '2014-02-15 00:42:06.000000', 'consum', 0.0210, 'lps'),
	(537874, 128, '2014-02-15 00:42:07.000000', 'consum', 0.0219, 'lps'),
	(537875, 128, '2014-02-15 00:42:08.000000', 'consum', 0.0225, 'lps'),
	(537876, 128, '2014-02-15 00:42:09.000000', 'consum', 0.0221, 'lps'),
	(537877, 128, '2014-02-15 00:42:10.000000', 'consum', 0.0221, 'lps'),
	(537878, 128, '2014-02-15 00:42:11.000000', 'consum', 0.0216, 'lps'),
	(537879, 128, '2014-02-15 00:42:12.000000', 'consum', 0.0224, 'lps'),
	(537880, 128, '2014-02-15 00:42:13.000000', 'consum', 0.0211, 'lps'),
	(537881, 128, '2014-02-15 00:42:14.000000', 'consum', 0.0225, 'lps'),
	(537882, 128, '2014-02-15 00:42:15.000000', 'consum', 0.0213, 'lps'),
	(537883, 128, '2014-02-15 00:42:16.000000', 'consum', 0.0218, 'lps'),
	(537884, 128, '2014-02-15 00:42:17.000000', 'consum', 0.0221, 'lps'),
	(537885, 128, '2014-02-15 00:42:18.000000', 'consum', 0.0210, 'lps'),
	(537886, 128, '2014-02-15 00:42:19.000000', 'consum', 0.0211, 'lps'),
	(537887, 128, '2014-02-15 00:42:20.000000', 'consum', 0.0214, 'lps'),
	(537888, 128, '2014-02-15 00:42:21.000000', 'consum', 0.0213, 'lps'),
	(537889, 128, '2014-02-15 00:42:22.000000', 'consum', 0.0214, 'lps'),
	(537890, 128, '2014-02-15 00:42:23.000000', 'consum', 0.0222, 'lps'),
	(537891, 128, '2014-02-15 00:42:24.000000', 'consum', 0.0223, 'lps'),
	(537892, 128, '2014-02-15 00:42:25.000000', 'consum', 0.0223, 'lps'),
	(537893, 128, '2014-02-15 00:42:26.000000', 'consum', 0.0221, 'lps'),
	(537894, 128, '2014-02-15 00:42:27.000000', 'consum', 0.0226, 'lps'),
	(537895, 128, '2014-02-15 00:42:28.000000', 'consum', 0.0223, 'lps'),
	(537896, 128, '2014-02-15 00:42:29.000000', 'consum', 0.0212, 'lps'),
	(537897, 128, '2014-02-15 00:42:30.000000', 'consum', 0.0214, 'lps'),
	(537898, 128, '2014-02-15 00:42:31.000000', 'consum', 0.0223, 'lps'),
	(537899, 128, '2014-02-15 00:42:32.000000', 'consum', 0.0214, 'lps'),
	(537900, 128, '2014-02-15 00:42:33.000000', 'consum', 0.0210, 'lps'),
	(537901, 128, '2014-02-15 00:42:34.000000', 'consum', 0.0214, 'lps'),
	(537902, 128, '2014-02-15 00:42:35.000000', 'consum', 0.0212, 'lps'),
	(537903, 128, '2014-02-15 00:42:36.000000', 'consum', 0.0210, 'lps'),
	(537904, 128, '2014-02-15 00:42:37.000000', 'consum', 0.0221, 'lps'),
	(537905, 128, '2014-02-15 00:42:38.000000', 'consum', 0.0213, 'lps'),
	(537906, 128, '2014-02-15 00:42:39.000000', 'consum', 0.0211, 'lps'),
	(537907, 128, '2014-02-15 00:42:40.000000', 'consum', 0.0225, 'lps'),
	(537908, 128, '2014-02-15 00:42:41.000000', 'consum', 0.0213, 'lps'),
	(537909, 128, '2014-02-15 00:42:42.000000', 'consum', 0.0216, 'lps'),
	(537910, 128, '2014-02-15 00:42:43.000000', 'consum', 0.0215, 'lps'),
	(537911, 128, '2014-02-15 00:42:44.000000', 'consum', 0.0215, 'lps'),
	(537912, 128, '2014-02-15 00:42:45.000000', 'consum', 0.0222, 'lps'),
	(537913, 128, '2014-02-15 00:42:46.000000', 'consum', 0.0221, 'lps'),
	(537914, 128, '2014-02-15 00:42:47.000000', 'consum', 0.0214, 'lps'),
	(537915, 128, '2014-02-15 00:42:48.000000', 'consum', 0.0215, 'lps'),
	(537916, 128, '2014-02-15 00:42:49.000000', 'consum', 0.0222, 'lps'),
	(537917, 128, '2014-02-15 00:42:50.000000', 'consum', 0.0222, 'lps'),
	(537918, 128, '2014-02-15 00:42:51.000000', 'consum', 0.0219, 'lps'),
	(537919, 128, '2014-02-15 00:42:52.000000', 'consum', 0.0220, 'lps'),
	(537920, 128, '2014-02-15 00:42:53.000000', 'consum', 0.0217, 'lps'),
	(537921, 128, '2014-02-15 00:42:54.000000', 'consum', 0.0216, 'lps'),
	(537922, 128, '2014-02-15 00:42:55.000000', 'consum', 0.0221, 'lps'),
	(537923, 128, '2014-02-15 00:42:56.000000', 'consum', 0.0210, 'lps'),
	(537924, 128, '2014-02-15 00:42:57.000000', 'consum', 0.0211, 'lps'),
	(537925, 128, '2014-02-15 00:42:58.000000', 'consum', 0.0215, 'lps'),
	(537926, 128, '2014-02-15 00:42:59.000000', 'consum', 0.0218, 'lps'),
	(537927, 128, '2014-02-15 00:43:00.000000', 'consum', 0.0217, 'lps'),
	(537928, 128, '2014-02-15 00:43:01.000000', 'consum', 0.0223, 'lps'),
	(537929, 128, '2014-02-15 00:43:02.000000', 'consum', 0.0222, 'lps'),
	(537930, 128, '2014-02-15 00:43:03.000000', 'consum', 0.0211, 'lps'),
	(537931, 128, '2014-02-15 00:43:04.000000', 'consum', 0.0217, 'lps'),
	(537932, 128, '2014-02-15 00:43:05.000000', 'consum', 0.0224, 'lps'),
	(537933, 128, '2014-02-15 00:43:06.000000', 'consum', 0.0224, 'lps'),
	(537934, 128, '2014-02-15 00:43:07.000000', 'consum', 0.0224, 'lps'),
	(537935, 128, '2014-02-15 00:43:08.000000', 'consum', 0.0219, 'lps'),
	(537936, 128, '2014-02-15 00:43:09.000000', 'consum', 0.0213, 'lps'),
	(537937, 128, '2014-02-15 00:43:10.000000', 'consum', 0.0218, 'lps'),
	(537938, 128, '2014-02-15 00:43:11.000000', 'consum', 0.0223, 'lps'),
	(537939, 128, '2014-02-15 00:43:12.000000', 'consum', 0.0217, 'lps'),
	(537940, 128, '2014-02-15 00:43:13.000000', 'consum', 0.0225, 'lps'),
	(537941, 128, '2014-02-15 00:43:14.000000', 'consum', 0.0214, 'lps'),
	(537942, 128, '2014-02-15 00:43:15.000000', 'consum', 0.0219, 'lps'),
	(537943, 128, '2014-02-15 00:43:16.000000', 'consum', 0.0224, 'lps'),
	(537944, 128, '2014-02-15 00:43:17.000000', 'consum', 0.0223, 'lps'),
	(537945, 128, '2014-02-15 00:43:18.000000', 'consum', 0.0216, 'lps'),
	(537946, 128, '2014-02-15 00:43:19.000000', 'consum', 0.0217, 'lps'),
	(537947, 128, '2014-02-15 00:43:20.000000', 'consum', 0.0213, 'lps'),
	(537948, 128, '2014-02-15 00:43:21.000000', 'consum', 0.0218, 'lps'),
	(537949, 128, '2014-02-15 00:43:22.000000', 'consum', 0.0210, 'lps'),
	(537950, 128, '2014-02-15 00:43:23.000000', 'consum', 0.0220, 'lps'),
	(537951, 128, '2014-02-15 00:43:24.000000', 'consum', 0.0211, 'lps'),
	(537952, 128, '2014-02-15 00:43:25.000000', 'consum', 0.0216, 'lps'),
	(537953, 128, '2014-02-15 00:43:26.000000', 'consum', 0.0224, 'lps'),
	(537954, 128, '2014-02-15 00:43:27.000000', 'consum', 0.0210, 'lps'),
	(537955, 128, '2014-02-15 00:43:28.000000', 'consum', 0.0221, 'lps'),
	(537956, 128, '2014-02-15 00:43:29.000000', 'consum', 0.0214, 'lps'),
	(537957, 128, '2014-02-15 00:43:30.000000', 'consum', 0.0214, 'lps'),
	(537958, 128, '2014-02-15 00:43:31.000000', 'consum', 0.0219, 'lps'),
	(537959, 128, '2014-02-15 00:43:32.000000', 'consum', 0.0226, 'lps'),
	(537960, 128, '2014-02-15 00:43:33.000000', 'consum', 0.0212, 'lps'),
	(537961, 128, '2014-02-15 00:43:34.000000', 'consum', 0.0226, 'lps'),
	(537962, 128, '2014-02-15 00:43:35.000000', 'consum', 0.0215, 'lps'),
	(537963, 128, '2014-02-15 00:43:36.000000', 'consum', 0.0221, 'lps'),
	(537964, 128, '2014-02-15 00:43:37.000000', 'consum', 0.0215, 'lps'),
	(537965, 128, '2014-02-15 00:43:38.000000', 'consum', 0.0221, 'lps'),
	(537966, 128, '2014-02-15 00:43:39.000000', 'consum', 0.0215, 'lps'),
	(537967, 128, '2014-02-15 00:43:40.000000', 'consum', 0.0220, 'lps'),
	(537968, 128, '2014-02-15 00:43:41.000000', 'consum', 0.0210, 'lps'),
	(537969, 128, '2014-02-15 00:43:42.000000', 'consum', 0.0215, 'lps'),
	(537970, 128, '2014-02-15 00:43:43.000000', 'consum', 0.0217, 'lps'),
	(537971, 128, '2014-02-15 00:43:44.000000', 'consum', 0.0216, 'lps'),
	(537972, 128, '2014-02-15 00:43:45.000000', 'consum', 0.0218, 'lps'),
	(537973, 128, '2014-02-15 00:43:46.000000', 'consum', 0.0214, 'lps'),
	(537974, 128, '2014-02-15 00:43:47.000000', 'consum', 0.0210, 'lps'),
	(537975, 128, '2014-02-15 00:43:48.000000', 'consum', 0.0213, 'lps'),
	(537976, 128, '2014-02-15 00:43:49.000000', 'consum', 0.0210, 'lps'),
	(537977, 128, '2014-02-15 00:43:50.000000', 'consum', 0.0216, 'lps'),
	(537978, 128, '2014-02-15 00:43:51.000000', 'consum', 0.0226, 'lps'),
	(537979, 128, '2014-02-15 00:43:52.000000', 'consum', 0.0220, 'lps'),
	(537980, 128, '2014-02-15 00:43:53.000000', 'consum', 0.0214, 'lps'),
	(537981, 128, '2014-02-15 00:43:54.000000', 'consum', 0.0218, 'lps'),
	(537982, 128, '2014-02-15 00:43:55.000000', 'consum', 0.0222, 'lps'),
	(537983, 128, '2014-02-15 00:43:56.000000', 'consum', 0.0211, 'lps'),
	(537984, 128, '2014-02-15 00:43:57.000000', 'consum', 0.0216, 'lps'),
	(537985, 128, '2014-02-15 00:43:58.000000', 'consum', 0.0218, 'lps'),
	(537986, 128, '2014-02-15 00:43:59.000000', 'consum', 0.0218, 'lps'),
	(537987, 128, '2014-02-15 00:44:00.000000', 'consum', 0.0225, 'lps'),
	(537988, 128, '2014-02-15 00:44:01.000000', 'consum', 0.0212, 'lps'),
	(537989, 128, '2014-02-15 00:44:02.000000', 'consum', 0.0226, 'lps'),
	(537990, 128, '2014-02-15 00:44:03.000000', 'consum', 0.0215, 'lps'),
	(537991, 128, '2014-02-15 00:44:04.000000', 'consum', 0.0224, 'lps'),
	(537992, 128, '2014-02-15 00:44:05.000000', 'consum', 0.0214, 'lps'),
	(537993, 128, '2014-02-15 00:44:06.000000', 'consum', 0.0223, 'lps'),
	(537994, 128, '2014-02-15 00:44:07.000000', 'consum', 0.0212, 'lps'),
	(537995, 128, '2014-02-15 00:44:08.000000', 'consum', 0.0216, 'lps'),
	(537996, 128, '2014-02-15 00:44:09.000000', 'consum', 0.0215, 'lps'),
	(537997, 128, '2014-02-15 00:44:10.000000', 'consum', 0.0219, 'lps'),
	(537998, 128, '2014-02-15 00:44:11.000000', 'consum', 0.0223, 'lps'),
	(537999, 128, '2014-02-15 00:44:12.000000', 'consum', 0.0216, 'lps'),
	(538000, 128, '2014-02-15 00:44:13.000000', 'consum', 0.0218, 'lps'),
	(538001, 128, '2014-02-15 00:44:14.000000', 'consum', 0.0214, 'lps'),
	(538002, 128, '2014-02-15 00:44:15.000000', 'consum', 0.0225, 'lps'),
	(538003, 128, '2014-02-15 00:44:16.000000', 'consum', 0.0221, 'lps'),
	(538004, 128, '2014-02-15 00:44:17.000000', 'consum', 0.0220, 'lps'),
	(538005, 128, '2014-02-15 00:44:18.000000', 'consum', 0.0211, 'lps'),
	(538006, 128, '2014-02-15 00:44:19.000000', 'consum', 0.0219, 'lps'),
	(538007, 128, '2014-02-15 00:44:20.000000', 'consum', 0.0217, 'lps'),
	(538008, 128, '2014-02-15 00:44:21.000000', 'consum', 0.0220, 'lps'),
	(538009, 128, '2014-02-15 00:44:22.000000', 'consum', 0.0221, 'lps'),
	(538010, 128, '2014-02-15 00:44:23.000000', 'consum', 0.0221, 'lps'),
	(538011, 128, '2014-02-15 00:44:24.000000', 'consum', 0.0216, 'lps'),
	(538012, 128, '2014-02-15 00:44:25.000000', 'consum', 0.0223, 'lps'),
	(538013, 128, '2014-02-15 00:44:26.000000', 'consum', 0.0224, 'lps'),
	(538014, 128, '2014-02-15 00:44:27.000000', 'consum', 0.0223, 'lps'),
	(538015, 128, '2014-02-15 00:44:28.000000', 'consum', 0.0219, 'lps'),
	(538016, 128, '2014-02-15 00:44:29.000000', 'consum', 0.0214, 'lps'),
	(538017, 128, '2014-02-15 00:44:30.000000', 'consum', 0.0223, 'lps'),
	(538018, 128, '2014-02-15 00:44:31.000000', 'consum', 0.0211, 'lps'),
	(538019, 128, '2014-02-15 00:44:32.000000', 'consum', 0.0210, 'lps'),
	(538020, 128, '2014-02-15 00:44:33.000000', 'consum', 0.0226, 'lps'),
	(538021, 128, '2014-02-15 00:44:34.000000', 'consum', 0.0222, 'lps'),
	(538022, 128, '2014-02-15 00:44:35.000000', 'consum', 0.0221, 'lps'),
	(538023, 128, '2014-02-15 00:44:36.000000', 'consum', 0.0213, 'lps'),
	(538024, 128, '2014-02-15 00:44:37.000000', 'consum', 0.0211, 'lps'),
	(538025, 128, '2014-02-15 00:44:38.000000', 'consum', 0.0222, 'lps'),
	(538026, 128, '2014-02-15 00:44:39.000000', 'consum', 0.0219, 'lps'),
	(538027, 128, '2014-02-15 00:44:40.000000', 'consum', 0.0219, 'lps'),
	(538028, 128, '2014-02-15 00:44:41.000000', 'consum', 0.0226, 'lps'),
	(538029, 128, '2014-02-15 00:44:42.000000', 'consum', 0.0214, 'lps'),
	(538030, 128, '2014-02-15 00:44:43.000000', 'consum', 0.0215, 'lps'),
	(538031, 128, '2014-02-15 00:44:44.000000', 'consum', 0.0225, 'lps'),
	(538032, 128, '2014-02-15 00:44:45.000000', 'consum', 0.0219, 'lps'),
	(538033, 128, '2014-02-15 00:44:46.000000', 'consum', 0.0210, 'lps'),
	(538034, 128, '2014-02-15 00:44:47.000000', 'consum', 0.0217, 'lps'),
	(538035, 128, '2014-02-15 00:44:48.000000', 'consum', 0.0210, 'lps'),
	(538036, 128, '2014-02-15 00:44:49.000000', 'consum', 0.0225, 'lps'),
	(538037, 128, '2014-02-15 00:44:50.000000', 'consum', 0.0219, 'lps'),
	(538038, 128, '2014-02-15 00:44:51.000000', 'consum', 0.0211, 'lps'),
	(538039, 128, '2014-02-15 00:44:52.000000', 'consum', 0.0223, 'lps'),
	(538040, 128, '2014-02-15 00:44:53.000000', 'consum', 0.0222, 'lps'),
	(538041, 128, '2014-02-15 00:44:54.000000', 'consum', 0.0212, 'lps'),
	(538042, 128, '2014-02-15 00:44:55.000000', 'consum', 0.0221, 'lps'),
	(538043, 128, '2014-02-15 00:44:56.000000', 'consum', 0.0223, 'lps'),
	(538044, 128, '2014-02-15 00:44:57.000000', 'consum', 0.0225, 'lps'),
	(538045, 128, '2014-02-15 00:44:58.000000', 'consum', 0.0215, 'lps'),
	(538046, 128, '2014-02-15 00:44:59.000000', 'consum', 0.0222, 'lps'),
	(538047, 128, '2014-02-15 00:45:00.000000', 'consum', 0.0221, 'lps'),
	(538048, 128, '2014-02-15 00:45:01.000000', 'consum', 0.0215, 'lps'),
	(538049, 128, '2014-02-15 00:45:02.000000', 'consum', 0.0220, 'lps'),
	(538050, 128, '2014-02-15 00:45:03.000000', 'consum', 0.0212, 'lps'),
	(538051, 128, '2014-02-15 00:45:04.000000', 'consum', 0.0223, 'lps'),
	(538052, 128, '2014-02-15 00:45:05.000000', 'consum', 0.0218, 'lps'),
	(538053, 128, '2014-02-15 00:45:06.000000', 'consum', 0.0210, 'lps'),
	(538054, 128, '2014-02-15 00:45:07.000000', 'consum', 0.0224, 'lps'),
	(538055, 128, '2014-02-15 00:45:08.000000', 'consum', 0.0211, 'lps'),
	(538056, 128, '2014-02-15 00:45:09.000000', 'consum', 0.0223, 'lps'),
	(538057, 128, '2014-02-15 00:45:10.000000', 'consum', 0.0222, 'lps'),
	(538058, 128, '2014-02-15 00:45:11.000000', 'consum', 0.0213, 'lps'),
	(538059, 128, '2014-02-15 00:45:12.000000', 'consum', 0.0225, 'lps'),
	(538060, 128, '2014-02-15 00:45:13.000000', 'consum', 0.0210, 'lps'),
	(538061, 128, '2014-02-15 00:45:14.000000', 'consum', 0.0216, 'lps'),
	(538062, 128, '2014-02-15 00:45:15.000000', 'consum', 0.0222, 'lps'),
	(538063, 128, '2014-02-15 00:45:16.000000', 'consum', 0.0221, 'lps'),
	(538064, 128, '2014-02-15 00:45:17.000000', 'consum', 0.0210, 'lps'),
	(538065, 128, '2014-02-15 00:45:18.000000', 'consum', 0.0213, 'lps'),
	(538066, 128, '2014-02-15 00:45:19.000000', 'consum', 0.0226, 'lps'),
	(538067, 128, '2014-02-15 00:45:20.000000', 'consum', 0.0214, 'lps'),
	(538068, 128, '2014-02-15 00:45:21.000000', 'consum', 0.0216, 'lps'),
	(538069, 128, '2014-02-15 00:45:22.000000', 'consum', 0.0213, 'lps'),
	(538070, 128, '2014-02-15 00:45:23.000000', 'consum', 0.0224, 'lps'),
	(538071, 128, '2014-02-15 00:45:24.000000', 'consum', 0.0221, 'lps'),
	(538072, 128, '2014-02-15 00:45:25.000000', 'consum', 0.0223, 'lps'),
	(538073, 128, '2014-02-15 00:45:26.000000', 'consum', 0.0210, 'lps'),
	(538074, 128, '2014-02-15 00:45:27.000000', 'consum', 0.0221, 'lps'),
	(538075, 128, '2014-02-15 00:45:28.000000', 'consum', 0.0215, 'lps'),
	(538076, 128, '2014-02-15 00:45:29.000000', 'consum', 0.0218, 'lps'),
	(538077, 128, '2014-02-15 00:45:30.000000', 'consum', 0.0219, 'lps'),
	(538078, 128, '2014-02-15 00:45:31.000000', 'consum', 0.0216, 'lps'),
	(538079, 128, '2014-02-15 00:45:32.000000', 'consum', 0.0212, 'lps'),
	(538080, 128, '2014-02-15 00:45:33.000000', 'consum', 0.0219, 'lps'),
	(538081, 128, '2014-02-15 00:45:34.000000', 'consum', 0.0218, 'lps'),
	(538082, 128, '2014-02-15 00:45:35.000000', 'consum', 0.0223, 'lps'),
	(538083, 128, '2014-02-15 00:45:36.000000', 'consum', 0.0218, 'lps'),
	(538084, 128, '2014-02-15 00:45:37.000000', 'consum', 0.0226, 'lps'),
	(538085, 128, '2014-02-15 00:45:38.000000', 'consum', 0.0218, 'lps'),
	(538086, 128, '2014-02-15 00:45:39.000000', 'consum', 0.0219, 'lps'),
	(538087, 128, '2014-02-15 00:45:40.000000', 'consum', 0.0216, 'lps'),
	(538088, 128, '2014-02-15 00:45:41.000000', 'consum', 0.0212, 'lps'),
	(538089, 128, '2014-02-15 00:45:42.000000', 'consum', 0.0221, 'lps'),
	(538090, 128, '2014-02-15 00:45:43.000000', 'consum', 0.0223, 'lps'),
	(538091, 128, '2014-02-15 00:45:44.000000', 'consum', 0.0225, 'lps'),
	(538092, 128, '2014-02-15 00:45:45.000000', 'consum', 0.0215, 'lps'),
	(538093, 128, '2014-02-15 00:45:46.000000', 'consum', 0.0222, 'lps'),
	(538094, 128, '2014-02-15 00:45:47.000000', 'consum', 0.0221, 'lps'),
	(538095, 128, '2014-02-15 00:45:48.000000', 'consum', 0.0212, 'lps'),
	(538096, 128, '2014-02-15 00:45:49.000000', 'consum', 0.0222, 'lps'),
	(538097, 128, '2014-02-15 00:45:50.000000', 'consum', 0.0213, 'lps'),
	(538098, 128, '2014-02-15 00:45:51.000000', 'consum', 0.0223, 'lps'),
	(538099, 128, '2014-02-15 00:45:52.000000', 'consum', 0.0214, 'lps'),
	(538100, 128, '2014-02-15 00:45:53.000000', 'consum', 0.0211, 'lps'),
	(538101, 128, '2014-02-15 00:45:54.000000', 'consum', 0.0220, 'lps'),
	(538102, 128, '2014-02-15 00:45:55.000000', 'consum', 0.0222, 'lps'),
	(538103, 128, '2014-02-15 00:45:56.000000', 'consum', 0.0223, 'lps'),
	(538104, 128, '2014-02-15 00:45:57.000000', 'consum', 0.0224, 'lps'),
	(538105, 128, '2014-02-15 00:45:58.000000', 'consum', 0.0223, 'lps'),
	(538106, 128, '2014-02-15 00:45:59.000000', 'consum', 0.0218, 'lps'),
	(538107, 128, '2014-02-15 00:46:00.000000', 'consum', 0.0211, 'lps'),
	(538108, 128, '2014-02-15 00:46:01.000000', 'consum', 0.0210, 'lps'),
	(538109, 128, '2014-02-15 00:46:02.000000', 'consum', 0.0224, 'lps'),
	(538110, 128, '2014-02-15 00:46:03.000000', 'consum', 0.0212, 'lps'),
	(538111, 128, '2014-02-15 00:46:04.000000', 'consum', 0.0215, 'lps'),
	(538112, 128, '2014-02-15 00:46:05.000000', 'consum', 0.0226, 'lps'),
	(538113, 128, '2014-02-15 00:46:06.000000', 'consum', 0.0210, 'lps'),
	(538114, 128, '2014-02-15 00:46:07.000000', 'consum', 0.0212, 'lps'),
	(538115, 128, '2014-02-15 00:46:08.000000', 'consum', 0.0220, 'lps'),
	(538116, 128, '2014-02-15 00:46:09.000000', 'consum', 0.0220, 'lps'),
	(538117, 128, '2014-02-15 00:46:10.000000', 'consum', 0.0213, 'lps'),
	(538118, 128, '2014-02-15 00:46:11.000000', 'consum', 0.0213, 'lps'),
	(538119, 128, '2014-02-15 00:46:12.000000', 'consum', 0.0217, 'lps'),
	(538120, 128, '2014-02-15 00:46:13.000000', 'consum', 0.0218, 'lps'),
	(538121, 128, '2014-02-15 00:46:14.000000', 'consum', 0.0211, 'lps'),
	(538122, 128, '2014-02-15 00:46:15.000000', 'consum', 0.0212, 'lps'),
	(538123, 128, '2014-02-15 00:46:16.000000', 'consum', 0.0215, 'lps'),
	(538124, 128, '2014-02-15 00:46:17.000000', 'consum', 0.0213, 'lps'),
	(538125, 128, '2014-02-15 00:46:18.000000', 'consum', 0.0212, 'lps'),
	(538126, 128, '2014-02-15 00:46:19.000000', 'consum', 0.0210, 'lps'),
	(538127, 128, '2014-02-15 00:46:20.000000', 'consum', 0.0222, 'lps'),
	(538128, 128, '2014-02-15 00:46:21.000000', 'consum', 0.0220, 'lps'),
	(538129, 128, '2014-02-15 00:46:22.000000', 'consum', 0.0224, 'lps'),
	(538130, 128, '2014-02-15 00:46:23.000000', 'consum', 0.0215, 'lps'),
	(538131, 128, '2014-02-15 00:46:24.000000', 'consum', 0.0210, 'lps'),
	(538132, 128, '2014-02-15 00:46:25.000000', 'consum', 0.0212, 'lps'),
	(538133, 128, '2014-02-15 00:46:26.000000', 'consum', 0.0222, 'lps'),
	(538134, 128, '2014-02-15 00:46:27.000000', 'consum', 0.0212, 'lps'),
	(538135, 128, '2014-02-15 00:46:28.000000', 'consum', 0.0219, 'lps'),
	(538136, 128, '2014-02-15 00:46:29.000000', 'consum', 0.0216, 'lps'),
	(538137, 128, '2014-02-15 00:46:30.000000', 'consum', 0.0213, 'lps'),
	(538138, 128, '2014-02-15 00:46:31.000000', 'consum', 0.0226, 'lps'),
	(538139, 128, '2014-02-15 00:46:32.000000', 'consum', 0.0214, 'lps'),
	(538140, 128, '2014-02-15 00:46:33.000000', 'consum', 0.0217, 'lps'),
	(538141, 128, '2014-02-15 00:46:34.000000', 'consum', 0.0216, 'lps'),
	(538142, 128, '2014-02-15 00:46:35.000000', 'consum', 0.0218, 'lps'),
	(538143, 128, '2014-02-15 00:46:36.000000', 'consum', 0.0217, 'lps'),
	(538144, 128, '2014-02-15 00:46:37.000000', 'consum', 0.0223, 'lps'),
	(538145, 128, '2014-02-15 00:46:38.000000', 'consum', 0.0219, 'lps'),
	(538146, 128, '2014-02-15 00:46:39.000000', 'consum', 0.0218, 'lps'),
	(538147, 128, '2014-02-15 00:46:40.000000', 'consum', 0.0221, 'lps'),
	(538148, 128, '2014-02-15 00:46:41.000000', 'consum', 0.0210, 'lps'),
	(538149, 128, '2014-02-15 00:46:42.000000', 'consum', 0.0211, 'lps'),
	(538150, 128, '2014-02-15 00:46:43.000000', 'consum', 0.0217, 'lps'),
	(538151, 128, '2014-02-15 00:46:44.000000', 'consum', 0.0225, 'lps'),
	(538152, 128, '2014-02-15 00:46:45.000000', 'consum', 0.0214, 'lps'),
	(538153, 128, '2014-02-15 00:46:46.000000', 'consum', 0.0218, 'lps'),
	(538154, 128, '2014-02-15 00:46:47.000000', 'consum', 0.0224, 'lps'),
	(538155, 128, '2014-02-15 00:46:48.000000', 'consum', 0.0222, 'lps'),
	(538156, 128, '2014-02-15 00:46:49.000000', 'consum', 0.0226, 'lps'),
	(538157, 128, '2014-02-15 00:46:50.000000', 'consum', 0.0223, 'lps'),
	(538158, 128, '2014-02-15 00:46:51.000000', 'consum', 0.0225, 'lps'),
	(538159, 128, '2014-02-15 00:46:52.000000', 'consum', 0.0212, 'lps'),
	(538160, 128, '2014-02-15 00:46:53.000000', 'consum', 0.0212, 'lps'),
	(538161, 128, '2014-02-15 00:46:54.000000', 'consum', 0.0213, 'lps'),
	(538162, 128, '2014-02-15 00:46:55.000000', 'consum', 0.0218, 'lps'),
	(538163, 128, '2014-02-15 00:46:56.000000', 'consum', 0.0226, 'lps'),
	(538164, 128, '2014-02-15 00:46:57.000000', 'consum', 0.0214, 'lps'),
	(538165, 128, '2014-02-15 00:46:58.000000', 'consum', 0.0219, 'lps'),
	(538166, 128, '2014-02-15 00:46:59.000000', 'consum', 0.0224, 'lps'),
	(538167, 128, '2014-02-15 00:47:00.000000', 'consum', 0.0218, 'lps'),
	(538168, 128, '2014-02-15 00:47:01.000000', 'consum', 0.0212, 'lps'),
	(538169, 128, '2014-02-15 00:47:02.000000', 'consum', 0.0212, 'lps'),
	(538170, 128, '2014-02-15 00:47:03.000000', 'consum', 0.0213, 'lps'),
	(538171, 128, '2014-02-15 00:47:04.000000', 'consum', 0.0219, 'lps'),
	(538172, 128, '2014-02-15 00:47:05.000000', 'consum', 0.0213, 'lps'),
	(538173, 128, '2014-02-15 00:47:06.000000', 'consum', 0.0217, 'lps'),
	(538174, 128, '2014-02-15 00:47:07.000000', 'consum', 0.0220, 'lps'),
	(538175, 128, '2014-02-15 00:47:08.000000', 'consum', 0.0222, 'lps'),
	(538176, 128, '2014-02-15 00:47:09.000000', 'consum', 0.0222, 'lps'),
	(538177, 128, '2014-02-15 00:47:10.000000', 'consum', 0.0220, 'lps'),
	(538178, 128, '2014-02-15 00:47:11.000000', 'consum', 0.0223, 'lps'),
	(538179, 128, '2014-02-15 00:47:12.000000', 'consum', 0.0211, 'lps'),
	(538180, 128, '2014-02-15 00:47:13.000000', 'consum', 0.0212, 'lps'),
	(538181, 128, '2014-02-15 00:47:14.000000', 'consum', 0.0219, 'lps'),
	(538182, 128, '2014-02-15 00:47:15.000000', 'consum', 0.0212, 'lps'),
	(538183, 128, '2014-02-15 00:47:16.000000', 'consum', 0.0213, 'lps'),
	(538184, 128, '2014-02-15 00:47:17.000000', 'consum', 0.0219, 'lps'),
	(538185, 128, '2014-02-15 00:47:18.000000', 'consum', 0.0211, 'lps'),
	(538186, 128, '2014-02-15 00:47:19.000000', 'consum', 0.0223, 'lps'),
	(538187, 128, '2014-02-15 00:47:20.000000', 'consum', 0.0221, 'lps'),
	(538188, 128, '2014-02-15 00:47:21.000000', 'consum', 0.0211, 'lps'),
	(538189, 128, '2014-02-15 00:47:22.000000', 'consum', 0.0217, 'lps'),
	(538190, 128, '2014-02-15 00:47:23.000000', 'consum', 0.0223, 'lps'),
	(538191, 128, '2014-02-15 00:47:24.000000', 'consum', 0.0221, 'lps'),
	(538192, 128, '2014-02-15 00:47:25.000000', 'consum', 0.0226, 'lps'),
	(538193, 128, '2014-02-15 00:47:26.000000', 'consum', 0.0224, 'lps'),
	(538194, 128, '2014-02-15 00:47:27.000000', 'consum', 0.0217, 'lps'),
	(538195, 128, '2014-02-15 00:47:28.000000', 'consum', 0.0221, 'lps'),
	(538196, 128, '2014-02-15 00:47:29.000000', 'consum', 0.0210, 'lps'),
	(538197, 128, '2014-02-15 00:47:30.000000', 'consum', 0.0212, 'lps'),
	(538198, 128, '2014-02-15 00:47:31.000000', 'consum', 0.0219, 'lps'),
	(538199, 128, '2014-02-15 00:47:32.000000', 'consum', 0.0217, 'lps'),
	(538200, 128, '2014-02-15 00:47:33.000000', 'consum', 0.0218, 'lps'),
	(538201, 128, '2014-02-15 00:47:34.000000', 'consum', 0.0212, 'lps'),
	(538202, 128, '2014-02-15 00:47:35.000000', 'consum', 0.0213, 'lps'),
	(538203, 128, '2014-02-15 00:47:36.000000', 'consum', 0.0218, 'lps'),
	(538204, 128, '2014-02-15 00:47:37.000000', 'consum', 0.0210, 'lps'),
	(538205, 128, '2014-02-15 00:47:38.000000', 'consum', 0.0220, 'lps'),
	(538206, 128, '2014-02-15 00:47:39.000000', 'consum', 0.0210, 'lps'),
	(538207, 128, '2014-02-15 00:47:40.000000', 'consum', 0.0215, 'lps'),
	(538208, 128, '2014-02-15 00:47:41.000000', 'consum', 0.0217, 'lps'),
	(538209, 128, '2014-02-15 00:47:42.000000', 'consum', 0.0213, 'lps'),
	(538210, 128, '2014-02-15 00:47:43.000000', 'consum', 0.0224, 'lps'),
	(538211, 128, '2014-02-15 00:47:44.000000', 'consum', 0.0218, 'lps'),
	(538212, 128, '2014-02-15 00:47:45.000000', 'consum', 0.0225, 'lps'),
	(538213, 128, '2014-02-15 00:47:46.000000', 'consum', 0.0210, 'lps'),
	(538214, 128, '2014-02-15 00:47:47.000000', 'consum', 0.0218, 'lps'),
	(538215, 128, '2014-02-15 00:47:48.000000', 'consum', 0.0218, 'lps'),
	(538216, 128, '2014-02-15 00:47:49.000000', 'consum', 0.0225, 'lps'),
	(538217, 128, '2014-02-15 00:47:50.000000', 'consum', 0.0211, 'lps'),
	(538218, 128, '2014-02-15 00:47:51.000000', 'consum', 0.0221, 'lps'),
	(538219, 128, '2014-02-15 00:47:52.000000', 'consum', 0.0213, 'lps'),
	(538220, 128, '2014-02-15 00:47:53.000000', 'consum', 0.0210, 'lps'),
	(538221, 128, '2014-02-15 00:47:54.000000', 'consum', 0.0217, 'lps'),
	(538222, 128, '2014-02-15 00:47:55.000000', 'consum', 0.0210, 'lps'),
	(538223, 128, '2014-02-15 00:47:56.000000', 'consum', 0.0226, 'lps'),
	(538224, 128, '2014-02-15 00:47:57.000000', 'consum', 0.0222, 'lps'),
	(538225, 128, '2014-02-15 00:47:58.000000', 'consum', 0.0221, 'lps'),
	(538226, 128, '2014-02-15 00:47:59.000000', 'consum', 0.0212, 'lps'),
	(538227, 128, '2014-02-15 00:48:00.000000', 'consum', 0.0221, 'lps'),
	(538228, 128, '2014-02-15 00:48:01.000000', 'consum', 0.0211, 'lps'),
	(538229, 128, '2014-02-15 00:48:02.000000', 'consum', 0.0218, 'lps'),
	(538230, 128, '2014-02-15 00:48:03.000000', 'consum', 0.0210, 'lps'),
	(538231, 128, '2014-02-15 00:48:04.000000', 'consum', 0.0221, 'lps'),
	(538232, 128, '2014-02-15 00:48:05.000000', 'consum', 0.0217, 'lps'),
	(538233, 128, '2014-02-15 00:48:06.000000', 'consum', 0.0211, 'lps'),
	(538234, 128, '2014-02-15 00:48:07.000000', 'consum', 0.0210, 'lps'),
	(538235, 128, '2014-02-15 00:48:08.000000', 'consum', 0.0226, 'lps'),
	(538236, 128, '2014-02-15 00:48:09.000000', 'consum', 0.0223, 'lps'),
	(538237, 128, '2014-02-15 00:48:10.000000', 'consum', 0.0225, 'lps'),
	(538238, 128, '2014-02-15 00:48:11.000000', 'consum', 0.0216, 'lps'),
	(538239, 128, '2014-02-15 00:48:12.000000', 'consum', 0.0210, 'lps'),
	(538240, 128, '2014-02-15 00:48:13.000000', 'consum', 0.0212, 'lps'),
	(538241, 128, '2014-02-15 00:48:14.000000', 'consum', 0.0220, 'lps'),
	(538242, 128, '2014-02-15 00:48:15.000000', 'consum', 0.0218, 'lps'),
	(538243, 128, '2014-02-15 00:48:16.000000', 'consum', 0.0221, 'lps'),
	(538244, 128, '2014-02-15 00:48:17.000000', 'consum', 0.0226, 'lps'),
	(538245, 128, '2014-02-15 00:48:18.000000', 'consum', 0.0222, 'lps'),
	(538246, 128, '2014-02-15 00:48:19.000000', 'consum', 0.0222, 'lps'),
	(538247, 128, '2014-02-15 00:48:20.000000', 'consum', 0.0217, 'lps'),
	(538248, 128, '2014-02-15 00:48:21.000000', 'consum', 0.0210, 'lps'),
	(538249, 128, '2014-02-15 00:48:22.000000', 'consum', 0.0225, 'lps'),
	(538250, 128, '2014-02-15 00:48:23.000000', 'consum', 0.0219, 'lps'),
	(538251, 128, '2014-02-15 00:48:24.000000', 'consum', 0.0225, 'lps'),
	(538252, 128, '2014-02-15 00:48:25.000000', 'consum', 0.0224, 'lps'),
	(538253, 128, '2014-02-15 00:48:26.000000', 'consum', 0.0221, 'lps'),
	(538254, 128, '2014-02-15 00:48:27.000000', 'consum', 0.0220, 'lps'),
	(538255, 128, '2014-02-15 00:48:28.000000', 'consum', 0.0214, 'lps'),
	(538256, 128, '2014-02-15 00:48:29.000000', 'consum', 0.0216, 'lps'),
	(538257, 128, '2014-02-15 00:48:30.000000', 'consum', 0.0211, 'lps'),
	(538258, 128, '2014-02-15 00:48:31.000000', 'consum', 0.0214, 'lps'),
	(538259, 128, '2014-02-15 00:48:32.000000', 'consum', 0.0210, 'lps'),
	(538260, 128, '2014-02-15 00:48:33.000000', 'consum', 0.0216, 'lps'),
	(538261, 128, '2014-02-15 00:48:34.000000', 'consum', 0.0222, 'lps'),
	(538262, 128, '2014-02-15 00:48:35.000000', 'consum', 0.0218, 'lps'),
	(538263, 128, '2014-02-15 00:48:36.000000', 'consum', 0.0217, 'lps'),
	(538264, 128, '2014-02-15 00:48:37.000000', 'consum', 0.0219, 'lps'),
	(538265, 128, '2014-02-15 00:48:38.000000', 'consum', 0.0220, 'lps'),
	(538266, 128, '2014-02-15 00:48:39.000000', 'consum', 0.0214, 'lps'),
	(538267, 128, '2014-02-15 00:48:40.000000', 'consum', 0.0220, 'lps'),
	(538268, 128, '2014-02-15 00:48:41.000000', 'consum', 0.0211, 'lps'),
	(538269, 128, '2014-02-15 00:48:42.000000', 'consum', 0.0223, 'lps'),
	(538270, 128, '2014-02-15 00:48:43.000000', 'consum', 0.0221, 'lps'),
	(538271, 128, '2014-02-15 00:48:44.000000', 'consum', 0.0226, 'lps'),
	(538272, 128, '2014-02-15 00:48:45.000000', 'consum', 0.0226, 'lps'),
	(538273, 128, '2014-02-15 00:48:46.000000', 'consum', 0.0222, 'lps'),
	(538274, 128, '2014-02-15 00:48:47.000000', 'consum', 0.0224, 'lps'),
	(538275, 128, '2014-02-15 00:48:48.000000', 'consum', 0.0225, 'lps'),
	(538276, 128, '2014-02-15 00:48:49.000000', 'consum', 0.0212, 'lps'),
	(538277, 128, '2014-02-15 00:48:50.000000', 'consum', 0.0211, 'lps'),
	(538278, 128, '2014-02-15 00:48:51.000000', 'consum', 0.0225, 'lps'),
	(538279, 128, '2014-02-15 00:48:52.000000', 'consum', 0.0214, 'lps'),
	(538280, 128, '2014-02-15 00:48:53.000000', 'consum', 0.0219, 'lps'),
	(538281, 128, '2014-02-15 00:48:54.000000', 'consum', 0.0210, 'lps'),
	(538282, 128, '2014-02-15 00:48:55.000000', 'consum', 0.0218, 'lps'),
	(538283, 128, '2014-02-15 00:48:56.000000', 'consum', 0.0214, 'lps'),
	(538284, 128, '2014-02-15 00:48:57.000000', 'consum', 0.0226, 'lps'),
	(538285, 128, '2014-02-15 00:48:58.000000', 'consum', 0.0211, 'lps'),
	(538286, 128, '2014-02-15 00:48:59.000000', 'consum', 0.0220, 'lps'),
	(538287, 128, '2014-02-15 00:49:00.000000', 'consum', 0.0220, 'lps'),
	(538288, 128, '2014-02-15 00:49:01.000000', 'consum', 0.0216, 'lps'),
	(538289, 128, '2014-02-15 00:49:02.000000', 'consum', 0.0210, 'lps'),
	(538290, 128, '2014-02-15 00:49:03.000000', 'consum', 0.0225, 'lps'),
	(538291, 128, '2014-02-15 00:49:04.000000', 'consum', 0.0219, 'lps'),
	(538292, 128, '2014-02-15 00:49:05.000000', 'consum', 0.0225, 'lps'),
	(538293, 128, '2014-02-15 00:49:06.000000', 'consum', 0.0210, 'lps'),
	(538294, 128, '2014-02-15 00:49:07.000000', 'consum', 0.0216, 'lps'),
	(538295, 128, '2014-02-15 00:49:08.000000', 'consum', 0.0224, 'lps'),
	(538296, 128, '2014-02-15 00:49:09.000000', 'consum', 0.0210, 'lps'),
	(538297, 128, '2014-02-15 00:49:10.000000', 'consum', 0.0222, 'lps'),
	(538298, 128, '2014-02-15 00:49:11.000000', 'consum', 0.0218, 'lps'),
	(538299, 128, '2014-02-15 00:49:12.000000', 'consum', 0.0216, 'lps'),
	(538300, 128, '2014-02-15 00:49:13.000000', 'consum', 0.0215, 'lps'),
	(538301, 128, '2014-02-15 00:49:14.000000', 'consum', 0.0217, 'lps'),
	(538302, 128, '2014-02-15 00:49:15.000000', 'consum', 0.0215, 'lps'),
	(538303, 128, '2014-02-15 00:49:16.000000', 'consum', 0.0216, 'lps'),
	(538304, 128, '2014-02-15 00:49:17.000000', 'consum', 0.0223, 'lps'),
	(538305, 128, '2014-02-15 00:49:18.000000', 'consum', 0.0226, 'lps'),
	(538306, 128, '2014-02-15 00:49:19.000000', 'consum', 0.0215, 'lps'),
	(538307, 128, '2014-02-15 00:49:20.000000', 'consum', 0.0221, 'lps'),
	(538308, 128, '2014-02-15 00:49:21.000000', 'consum', 0.0217, 'lps'),
	(538309, 128, '2014-02-15 00:49:22.000000', 'consum', 0.0214, 'lps'),
	(538310, 128, '2014-02-15 00:49:23.000000', 'consum', 0.0210, 'lps'),
	(538311, 128, '2014-02-15 00:49:24.000000', 'consum', 0.0213, 'lps'),
	(538312, 128, '2014-02-15 00:49:25.000000', 'consum', 0.0211, 'lps'),
	(538313, 128, '2014-02-15 00:49:26.000000', 'consum', 0.0222, 'lps'),
	(538314, 128, '2014-02-15 00:49:27.000000', 'consum', 0.0218, 'lps'),
	(538315, 128, '2014-02-15 00:49:28.000000', 'consum', 0.0213, 'lps'),
	(538316, 128, '2014-02-15 00:49:29.000000', 'consum', 0.0220, 'lps'),
	(538317, 128, '2014-02-15 00:49:30.000000', 'consum', 0.0218, 'lps'),
	(538318, 128, '2014-02-15 00:49:31.000000', 'consum', 0.0218, 'lps'),
	(538319, 128, '2014-02-15 00:49:32.000000', 'consum', 0.0211, 'lps'),
	(538320, 128, '2014-02-15 00:49:33.000000', 'consum', 0.0210, 'lps'),
	(538321, 128, '2014-02-15 00:49:34.000000', 'consum', 0.0224, 'lps'),
	(538322, 128, '2014-02-15 00:49:35.000000', 'consum', 0.0214, 'lps'),
	(538323, 128, '2014-02-15 00:49:36.000000', 'consum', 0.0220, 'lps'),
	(538324, 128, '2014-02-15 00:49:37.000000', 'consum', 0.0214, 'lps'),
	(538325, 128, '2014-02-15 00:49:38.000000', 'consum', 0.0219, 'lps'),
	(538326, 128, '2014-02-15 00:49:39.000000', 'consum', 0.0225, 'lps'),
	(538327, 128, '2014-02-15 00:49:40.000000', 'consum', 0.0225, 'lps'),
	(538328, 128, '2014-02-15 00:49:41.000000', 'consum', 0.0225, 'lps'),
	(538329, 128, '2014-02-15 00:49:42.000000', 'consum', 0.0223, 'lps'),
	(538330, 128, '2014-02-15 00:49:43.000000', 'consum', 0.0215, 'lps'),
	(538331, 128, '2014-02-15 00:49:44.000000', 'consum', 0.0213, 'lps'),
	(538332, 128, '2014-02-15 00:49:45.000000', 'consum', 0.0226, 'lps'),
	(538333, 128, '2014-02-15 00:49:46.000000', 'consum', 0.0215, 'lps'),
	(538334, 128, '2014-02-15 00:49:47.000000', 'consum', 0.0219, 'lps'),
	(538335, 128, '2014-02-15 00:49:48.000000', 'consum', 0.0226, 'lps'),
	(538336, 128, '2014-02-15 00:49:49.000000', 'consum', 0.0210, 'lps'),
	(538337, 128, '2014-02-15 00:49:50.000000', 'consum', 0.0216, 'lps'),
	(538338, 128, '2014-02-15 00:49:51.000000', 'consum', 0.0224, 'lps'),
	(538339, 128, '2014-02-15 00:49:52.000000', 'consum', 0.0226, 'lps'),
	(538340, 128, '2014-02-15 00:49:53.000000', 'consum', 0.0216, 'lps'),
	(538341, 128, '2014-02-15 00:49:54.000000', 'consum', 0.0224, 'lps'),
	(538342, 128, '2014-02-15 00:49:55.000000', 'consum', 0.0215, 'lps'),
	(538343, 128, '2014-02-15 00:49:56.000000', 'consum', 0.0224, 'lps'),
	(538344, 128, '2014-02-15 00:49:57.000000', 'consum', 0.0217, 'lps'),
	(538345, 128, '2014-02-15 00:49:58.000000', 'consum', 0.0220, 'lps'),
	(538346, 128, '2014-02-15 00:49:59.000000', 'consum', 0.0222, 'lps'),
	(538347, 128, '2014-02-15 00:50:00.000000', 'consum', 0.0223, 'lps'),
	(538348, 128, '2014-02-15 00:50:01.000000', 'consum', 0.0222, 'lps'),
	(538349, 128, '2014-02-15 00:50:02.000000', 'consum', 0.0216, 'lps'),
	(538350, 128, '2014-02-15 00:50:03.000000', 'consum', 0.0221, 'lps'),
	(538351, 128, '2014-02-15 00:50:04.000000', 'consum', 0.0212, 'lps'),
	(538352, 128, '2014-02-15 00:50:05.000000', 'consum', 0.0223, 'lps'),
	(538353, 128, '2014-02-15 00:50:06.000000', 'consum', 0.0219, 'lps'),
	(538354, 128, '2014-02-15 00:50:07.000000', 'consum', 0.0215, 'lps'),
	(538355, 128, '2014-02-15 00:50:08.000000', 'consum', 0.0224, 'lps'),
	(538356, 128, '2014-02-15 00:50:09.000000', 'consum', 0.0217, 'lps'),
	(538357, 128, '2014-02-15 00:50:10.000000', 'consum', 0.0219, 'lps'),
	(538358, 128, '2014-02-15 00:50:11.000000', 'consum', 0.0216, 'lps'),
	(538359, 128, '2014-02-15 00:50:12.000000', 'consum', 0.0217, 'lps'),
	(538360, 128, '2014-02-15 00:50:13.000000', 'consum', 0.0224, 'lps'),
	(538361, 128, '2014-02-15 00:50:14.000000', 'consum', 0.0212, 'lps'),
	(538362, 128, '2014-02-15 00:50:15.000000', 'consum', 0.0210, 'lps'),
	(538363, 128, '2014-02-15 00:50:16.000000', 'consum', 0.0223, 'lps'),
	(538364, 128, '2014-02-15 00:50:17.000000', 'consum', 0.0222, 'lps'),
	(538365, 128, '2014-02-15 00:50:18.000000', 'consum', 0.0216, 'lps'),
	(538366, 128, '2014-02-15 00:50:19.000000', 'consum', 0.0220, 'lps'),
	(538367, 128, '2014-02-15 00:50:20.000000', 'consum', 0.0226, 'lps'),
	(538368, 128, '2014-02-15 00:50:21.000000', 'consum', 0.0225, 'lps'),
	(538369, 128, '2014-02-15 00:50:22.000000', 'consum', 0.0224, 'lps'),
	(538370, 128, '2014-02-15 00:50:23.000000', 'consum', 0.0215, 'lps'),
	(538371, 128, '2014-02-15 00:50:24.000000', 'consum', 0.0214, 'lps'),
	(538372, 128, '2014-02-15 00:50:25.000000', 'consum', 0.0214, 'lps'),
	(538373, 128, '2014-02-15 00:50:26.000000', 'consum', 0.0218, 'lps'),
	(538374, 128, '2014-02-15 00:50:27.000000', 'consum', 0.0223, 'lps'),
	(538375, 128, '2014-02-15 00:50:28.000000', 'consum', 0.0217, 'lps'),
	(538376, 128, '2014-02-15 00:50:29.000000', 'consum', 0.0221, 'lps'),
	(538377, 128, '2014-02-15 00:50:30.000000', 'consum', 0.0214, 'lps'),
	(538378, 128, '2014-02-15 00:50:31.000000', 'consum', 0.0213, 'lps'),
	(538379, 128, '2014-02-15 00:50:32.000000', 'consum', 0.0216, 'lps'),
	(538380, 128, '2014-02-15 00:50:33.000000', 'consum', 0.0212, 'lps'),
	(538381, 128, '2014-02-15 00:50:34.000000', 'consum', 0.0219, 'lps'),
	(538382, 128, '2014-02-15 00:50:35.000000', 'consum', 0.0216, 'lps'),
	(538383, 128, '2014-02-15 00:50:36.000000', 'consum', 0.0214, 'lps'),
	(538384, 128, '2014-02-15 00:50:37.000000', 'consum', 0.0212, 'lps'),
	(538385, 128, '2014-02-15 00:50:38.000000', 'consum', 0.0226, 'lps'),
	(538386, 128, '2014-02-15 00:50:39.000000', 'consum', 0.0217, 'lps'),
	(538387, 128, '2014-02-15 00:50:40.000000', 'consum', 0.0212, 'lps'),
	(538388, 128, '2014-02-15 00:50:41.000000', 'consum', 0.0218, 'lps'),
	(538389, 128, '2014-02-15 00:50:42.000000', 'consum', 0.0226, 'lps'),
	(538390, 128, '2014-02-15 00:50:43.000000', 'consum', 0.0217, 'lps'),
	(538391, 128, '2014-02-15 00:50:44.000000', 'consum', 0.0215, 'lps'),
	(538392, 128, '2014-02-15 00:50:45.000000', 'consum', 0.0213, 'lps'),
	(538393, 128, '2014-02-15 00:50:46.000000', 'consum', 0.0210, 'lps'),
	(538394, 128, '2014-02-15 00:50:47.000000', 'consum', 0.0219, 'lps'),
	(538395, 128, '2014-02-15 00:50:48.000000', 'consum', 0.0223, 'lps'),
	(538396, 128, '2014-02-15 00:50:49.000000', 'consum', 0.0214, 'lps'),
	(538397, 128, '2014-02-15 00:50:50.000000', 'consum', 0.0224, 'lps'),
	(538398, 128, '2014-02-15 00:50:51.000000', 'consum', 0.0216, 'lps'),
	(538399, 128, '2014-02-15 00:50:52.000000', 'consum', 0.0219, 'lps'),
	(538400, 128, '2014-02-15 00:50:53.000000', 'consum', 0.0220, 'lps'),
	(538401, 128, '2014-02-15 00:50:54.000000', 'consum', 0.0214, 'lps'),
	(538402, 128, '2014-02-15 00:50:55.000000', 'consum', 0.0219, 'lps'),
	(538403, 128, '2014-02-15 00:50:56.000000', 'consum', 0.0211, 'lps'),
	(538404, 128, '2014-02-15 00:50:57.000000', 'consum', 0.0221, 'lps'),
	(538405, 128, '2014-02-15 00:50:58.000000', 'consum', 0.0213, 'lps'),
	(538406, 128, '2014-02-15 00:50:59.000000', 'consum', 0.0226, 'lps'),
	(538407, 128, '2014-02-15 00:51:00.000000', 'consum', 0.0213, 'lps'),
	(538408, 128, '2014-02-15 00:51:01.000000', 'consum', 0.0211, 'lps'),
	(538409, 128, '2014-02-15 00:51:02.000000', 'consum', 0.0222, 'lps'),
	(538410, 128, '2014-02-15 00:51:03.000000', 'consum', 0.0218, 'lps'),
	(538411, 128, '2014-02-15 00:51:04.000000', 'consum', 0.0214, 'lps'),
	(538412, 128, '2014-02-15 00:51:05.000000', 'consum', 0.0223, 'lps'),
	(538413, 128, '2014-02-15 00:51:06.000000', 'consum', 0.0214, 'lps'),
	(538414, 128, '2014-02-15 00:51:07.000000', 'consum', 0.0225, 'lps'),
	(538415, 128, '2014-02-15 00:51:08.000000', 'consum', 0.0224, 'lps'),
	(538416, 128, '2014-02-15 00:51:09.000000', 'consum', 0.0219, 'lps'),
	(538417, 128, '2014-02-15 00:51:10.000000', 'consum', 0.0210, 'lps'),
	(538418, 128, '2014-02-15 00:51:11.000000', 'consum', 0.0221, 'lps'),
	(538419, 128, '2014-02-15 00:51:12.000000', 'consum', 0.0213, 'lps'),
	(538420, 128, '2014-02-15 00:51:13.000000', 'consum', 0.0211, 'lps'),
	(538421, 128, '2014-02-15 00:51:14.000000', 'consum', 0.0225, 'lps'),
	(538422, 128, '2014-02-15 00:51:15.000000', 'consum', 0.0211, 'lps'),
	(538423, 128, '2014-02-15 00:51:16.000000', 'consum', 0.0221, 'lps'),
	(538424, 128, '2014-02-15 00:51:17.000000', 'consum', 0.0214, 'lps'),
	(538425, 128, '2014-02-15 00:51:18.000000', 'consum', 0.0215, 'lps'),
	(538426, 128, '2014-02-15 00:51:19.000000', 'consum', 0.0223, 'lps'),
	(538427, 128, '2014-02-15 00:51:20.000000', 'consum', 0.0225, 'lps'),
	(538428, 128, '2014-02-15 00:51:21.000000', 'consum', 0.0214, 'lps'),
	(538429, 128, '2014-02-15 00:51:22.000000', 'consum', 0.0221, 'lps'),
	(538430, 128, '2014-02-15 00:51:23.000000', 'consum', 0.0217, 'lps'),
	(538431, 128, '2014-02-15 00:51:24.000000', 'consum', 0.0213, 'lps'),
	(538432, 128, '2014-02-15 00:51:25.000000', 'consum', 0.0223, 'lps'),
	(538433, 128, '2014-02-15 00:51:26.000000', 'consum', 0.0215, 'lps'),
	(538434, 128, '2014-02-15 00:51:27.000000', 'consum', 0.0213, 'lps'),
	(538435, 128, '2014-02-15 00:51:28.000000', 'consum', 0.0226, 'lps'),
	(538436, 128, '2014-02-15 00:51:29.000000', 'consum', 0.0216, 'lps'),
	(538437, 128, '2014-02-15 00:51:30.000000', 'consum', 0.0210, 'lps'),
	(538438, 128, '2014-02-15 00:51:31.000000', 'consum', 0.0226, 'lps'),
	(538439, 128, '2014-02-15 00:51:32.000000', 'consum', 0.0223, 'lps'),
	(538440, 128, '2014-02-15 00:51:33.000000', 'consum', 0.0226, 'lps'),
	(538441, 128, '2014-02-15 00:51:34.000000', 'consum', 0.0216, 'lps'),
	(538442, 128, '2014-02-15 00:51:35.000000', 'consum', 0.0212, 'lps'),
	(538443, 128, '2014-02-15 00:51:36.000000', 'consum', 0.0218, 'lps'),
	(538444, 128, '2014-02-15 00:51:37.000000', 'consum', 0.0226, 'lps'),
	(538445, 128, '2014-02-15 00:51:38.000000', 'consum', 0.0218, 'lps'),
	(538446, 128, '2014-02-15 00:51:39.000000', 'consum', 0.0218, 'lps'),
	(538447, 128, '2014-02-15 00:51:40.000000', 'consum', 0.0226, 'lps'),
	(538448, 128, '2014-02-15 00:51:41.000000', 'consum', 0.0216, 'lps'),
	(538449, 128, '2014-02-15 00:51:42.000000', 'consum', 0.0211, 'lps'),
	(538450, 128, '2014-02-15 00:51:43.000000', 'consum', 0.0213, 'lps'),
	(538451, 128, '2014-02-15 00:51:44.000000', 'consum', 0.0221, 'lps'),
	(538452, 128, '2014-02-15 00:51:45.000000', 'consum', 0.0224, 'lps'),
	(538453, 128, '2014-02-15 00:51:46.000000', 'consum', 0.0213, 'lps'),
	(538454, 128, '2014-02-15 00:51:47.000000', 'consum', 0.0219, 'lps'),
	(538455, 128, '2014-02-15 00:51:48.000000', 'consum', 0.0212, 'lps'),
	(538456, 128, '2014-02-15 00:51:49.000000', 'consum', 0.0225, 'lps'),
	(538457, 128, '2014-02-15 00:51:50.000000', 'consum', 0.0214, 'lps'),
	(538458, 128, '2014-02-15 00:51:51.000000', 'consum', 0.0218, 'lps'),
	(538459, 128, '2014-02-15 00:51:52.000000', 'consum', 0.0220, 'lps'),
	(538460, 128, '2014-02-15 00:51:53.000000', 'consum', 0.0222, 'lps'),
	(538461, 128, '2014-02-15 00:51:54.000000', 'consum', 0.0223, 'lps'),
	(538462, 128, '2014-02-15 00:51:55.000000', 'consum', 0.0223, 'lps'),
	(538463, 128, '2014-02-15 00:51:56.000000', 'consum', 0.0218, 'lps'),
	(538464, 128, '2014-02-15 00:51:57.000000', 'consum', 0.0211, 'lps'),
	(538465, 128, '2014-02-15 00:51:58.000000', 'consum', 0.0225, 'lps'),
	(538466, 128, '2014-02-15 00:51:59.000000', 'consum', 0.0214, 'lps'),
	(538467, 128, '2014-02-15 00:52:00.000000', 'consum', 0.0219, 'lps'),
	(538468, 128, '2014-02-15 00:52:01.000000', 'consum', 0.0210, 'lps'),
	(538469, 128, '2014-02-15 00:52:02.000000', 'consum', 0.0217, 'lps'),
	(538470, 128, '2014-02-15 00:52:03.000000', 'consum', 0.0212, 'lps'),
	(538471, 128, '2014-02-15 00:52:04.000000', 'consum', 0.0217, 'lps'),
	(538472, 128, '2014-02-15 00:52:05.000000', 'consum', 0.0223, 'lps'),
	(538473, 128, '2014-02-15 00:52:06.000000', 'consum', 0.0219, 'lps'),
	(538474, 128, '2014-02-15 00:52:07.000000', 'consum', 0.0216, 'lps'),
	(538475, 128, '2014-02-15 00:52:08.000000', 'consum', 0.0216, 'lps'),
	(538476, 128, '2014-02-15 00:52:09.000000', 'consum', 0.0222, 'lps'),
	(538477, 128, '2014-02-15 00:52:10.000000', 'consum', 0.0218, 'lps'),
	(538478, 128, '2014-02-15 00:52:11.000000', 'consum', 0.0214, 'lps'),
	(538479, 128, '2014-02-15 00:52:12.000000', 'consum', 0.0223, 'lps'),
	(538480, 128, '2014-02-15 00:52:13.000000', 'consum', 0.0212, 'lps'),
	(538481, 128, '2014-02-15 00:52:14.000000', 'consum', 0.0215, 'lps'),
	(538482, 128, '2014-02-15 00:52:15.000000', 'consum', 0.0213, 'lps'),
	(538483, 128, '2014-02-15 00:52:16.000000', 'consum', 0.0212, 'lps'),
	(538484, 128, '2014-02-15 00:52:17.000000', 'consum', 0.0211, 'lps'),
	(538485, 128, '2014-02-15 00:52:18.000000', 'consum', 0.0225, 'lps'),
	(538486, 128, '2014-02-15 00:52:19.000000', 'consum', 0.0214, 'lps'),
	(538487, 128, '2014-02-15 00:52:20.000000', 'consum', 0.0219, 'lps'),
	(538488, 128, '2014-02-15 00:52:21.000000', 'consum', 0.0212, 'lps'),
	(538489, 128, '2014-02-15 00:52:22.000000', 'consum', 0.0225, 'lps'),
	(538490, 128, '2014-02-15 00:52:23.000000', 'consum', 0.0215, 'lps'),
	(538491, 128, '2014-02-15 00:52:24.000000', 'consum', 0.0221, 'lps'),
	(538492, 128, '2014-02-15 00:52:25.000000', 'consum', 0.0219, 'lps'),
	(538493, 128, '2014-02-15 00:52:26.000000', 'consum', 0.0223, 'lps'),
	(538494, 128, '2014-02-15 00:52:27.000000', 'consum', 0.0212, 'lps'),
	(538495, 128, '2014-02-15 00:52:28.000000', 'consum', 0.0217, 'lps'),
	(538496, 128, '2014-02-15 00:52:29.000000', 'consum', 0.0223, 'lps'),
	(538497, 128, '2014-02-15 00:52:30.000000', 'consum', 0.0220, 'lps'),
	(538498, 128, '2014-02-15 00:52:31.000000', 'consum', 0.0222, 'lps'),
	(538499, 128, '2014-02-15 00:52:32.000000', 'consum', 0.0224, 'lps'),
	(538500, 128, '2014-02-15 00:52:33.000000', 'consum', 0.0225, 'lps'),
	(538501, 128, '2014-02-15 00:52:34.000000', 'consum', 0.0211, 'lps'),
	(538502, 128, '2014-02-15 00:52:35.000000', 'consum', 0.0222, 'lps'),
	(538503, 128, '2014-02-15 00:52:36.000000', 'consum', 0.0217, 'lps'),
	(538504, 128, '2014-02-15 00:52:37.000000', 'consum', 0.0210, 'lps'),
	(538505, 128, '2014-02-15 00:52:38.000000', 'consum', 0.0224, 'lps'),
	(538506, 128, '2014-02-15 00:52:39.000000', 'consum', 0.0211, 'lps'),
	(538507, 128, '2014-02-15 00:52:40.000000', 'consum', 0.0224, 'lps'),
	(538508, 128, '2014-02-15 00:52:41.000000', 'consum', 0.0212, 'lps'),
	(538509, 128, '2014-02-15 00:52:42.000000', 'consum', 0.0210, 'lps'),
	(538510, 128, '2014-02-15 00:52:43.000000', 'consum', 0.0224, 'lps'),
	(538511, 128, '2014-02-15 00:52:44.000000', 'consum', 0.0210, 'lps'),
	(538512, 128, '2014-02-15 00:52:45.000000', 'consum', 0.0219, 'lps'),
	(538513, 128, '2014-02-15 00:52:46.000000', 'consum', 0.0222, 'lps'),
	(538514, 128, '2014-02-15 00:52:47.000000', 'consum', 0.0226, 'lps'),
	(538515, 128, '2014-02-15 00:52:48.000000', 'consum', 0.0221, 'lps'),
	(538516, 128, '2014-02-15 00:52:49.000000', 'consum', 0.0217, 'lps'),
	(538517, 128, '2014-02-15 00:52:50.000000', 'consum', 0.0213, 'lps'),
	(538518, 128, '2014-02-15 00:52:51.000000', 'consum', 0.0220, 'lps'),
	(538519, 128, '2014-02-15 00:52:52.000000', 'consum', 0.0216, 'lps'),
	(538520, 128, '2014-02-15 00:52:53.000000', 'consum', 0.0214, 'lps'),
	(538521, 128, '2014-02-15 00:52:54.000000', 'consum', 0.0212, 'lps'),
	(538522, 128, '2014-02-15 00:52:55.000000', 'consum', 0.0224, 'lps'),
	(538523, 128, '2014-02-15 00:52:56.000000', 'consum', 0.0226, 'lps'),
	(538524, 128, '2014-02-15 00:52:57.000000', 'consum', 0.0214, 'lps'),
	(538525, 128, '2014-02-15 00:52:58.000000', 'consum', 0.0215, 'lps'),
	(538526, 128, '2014-02-15 00:52:59.000000', 'consum', 0.0226, 'lps'),
	(538527, 128, '2014-02-15 00:53:00.000000', 'consum', 0.0222, 'lps'),
	(538528, 128, '2014-02-15 00:53:01.000000', 'consum', 0.0223, 'lps'),
	(538529, 128, '2014-02-15 00:53:02.000000', 'consum', 0.0224, 'lps'),
	(538530, 128, '2014-02-15 00:53:03.000000', 'consum', 0.0226, 'lps'),
	(538531, 128, '2014-02-15 00:53:04.000000', 'consum', 0.0211, 'lps'),
	(538532, 128, '2014-02-15 00:53:05.000000', 'consum', 0.0222, 'lps'),
	(538533, 128, '2014-02-15 00:53:06.000000', 'consum', 0.0213, 'lps'),
	(538534, 128, '2014-02-15 00:53:07.000000', 'consum', 0.0210, 'lps'),
	(538535, 128, '2014-02-15 00:53:08.000000', 'consum', 0.0216, 'lps'),
	(538536, 128, '2014-02-15 00:53:09.000000', 'consum', 0.0225, 'lps'),
	(538537, 128, '2014-02-15 00:53:10.000000', 'consum', 0.0216, 'lps'),
	(538538, 128, '2014-02-15 00:53:11.000000', 'consum', 0.0212, 'lps'),
	(538539, 128, '2014-02-15 00:53:12.000000', 'consum', 0.0221, 'lps'),
	(538540, 128, '2014-02-15 00:53:13.000000', 'consum', 0.0226, 'lps'),
	(538541, 128, '2014-02-15 00:53:14.000000', 'consum', 0.0221, 'lps'),
	(538542, 128, '2014-02-15 00:53:15.000000', 'consum', 0.0220, 'lps'),
	(538543, 128, '2014-02-15 00:53:16.000000', 'consum', 0.0210, 'lps'),
	(538544, 128, '2014-02-15 00:53:17.000000', 'consum', 0.0213, 'lps'),
	(538545, 128, '2014-02-15 00:53:18.000000', 'consum', 0.0225, 'lps'),
	(538546, 128, '2014-02-15 00:53:19.000000', 'consum', 0.0226, 'lps'),
	(538547, 128, '2014-02-15 00:53:20.000000', 'consum', 0.0212, 'lps'),
	(538548, 128, '2014-02-15 00:53:21.000000', 'consum', 0.0224, 'lps'),
	(538549, 128, '2014-02-15 00:53:22.000000', 'consum', 0.0225, 'lps'),
	(538550, 128, '2014-02-15 00:53:23.000000', 'consum', 0.0224, 'lps'),
	(538551, 128, '2014-02-15 00:53:24.000000', 'consum', 0.0221, 'lps'),
	(538552, 128, '2014-02-15 00:53:25.000000', 'consum', 0.0223, 'lps'),
	(538553, 128, '2014-02-15 00:53:26.000000', 'consum', 0.0224, 'lps'),
	(538554, 128, '2014-02-15 00:53:27.000000', 'consum', 0.0210, 'lps'),
	(538555, 128, '2014-02-15 00:53:28.000000', 'consum', 0.0216, 'lps'),
	(538556, 128, '2014-02-15 00:53:29.000000', 'consum', 0.0226, 'lps'),
	(538557, 128, '2014-02-15 00:53:30.000000', 'consum', 0.0219, 'lps'),
	(538558, 128, '2014-02-15 00:53:31.000000', 'consum', 0.0210, 'lps'),
	(538559, 128, '2014-02-15 00:53:32.000000', 'consum', 0.0215, 'lps'),
	(538560, 128, '2014-02-15 00:53:33.000000', 'consum', 0.0220, 'lps'),
	(538561, 128, '2014-02-15 00:53:34.000000', 'consum', 0.0212, 'lps'),
	(538562, 128, '2014-02-15 00:53:35.000000', 'consum', 0.0223, 'lps'),
	(538563, 128, '2014-02-15 00:53:36.000000', 'consum', 0.0218, 'lps'),
	(538564, 128, '2014-02-15 00:53:37.000000', 'consum', 0.0211, 'lps'),
	(538565, 128, '2014-02-15 00:53:38.000000', 'consum', 0.0210, 'lps'),
	(538566, 128, '2014-02-15 00:53:39.000000', 'consum', 0.0226, 'lps'),
	(538567, 128, '2014-02-15 00:53:40.000000', 'consum', 0.0220, 'lps'),
	(538568, 128, '2014-02-15 00:53:41.000000', 'consum', 0.0213, 'lps'),
	(538569, 128, '2014-02-15 00:53:42.000000', 'consum', 0.0213, 'lps'),
	(538570, 128, '2014-02-15 00:53:43.000000', 'consum', 0.0215, 'lps'),
	(538571, 128, '2014-02-15 00:53:44.000000', 'consum', 0.0212, 'lps'),
	(538572, 128, '2014-02-15 00:53:45.000000', 'consum', 0.0223, 'lps'),
	(538573, 128, '2014-02-15 00:53:46.000000', 'consum', 0.0216, 'lps'),
	(538574, 128, '2014-02-15 00:53:47.000000', 'consum', 0.0221, 'lps'),
	(538575, 128, '2014-02-15 00:53:48.000000', 'consum', 0.0214, 'lps'),
	(538576, 128, '2014-02-15 00:53:49.000000', 'consum', 0.0214, 'lps'),
	(538577, 128, '2014-02-15 00:53:50.000000', 'consum', 0.0216, 'lps'),
	(538578, 128, '2014-02-15 00:53:51.000000', 'consum', 0.0213, 'lps'),
	(538579, 128, '2014-02-15 00:53:52.000000', 'consum', 0.0225, 'lps'),
	(538580, 128, '2014-02-15 00:53:53.000000', 'consum', 0.0226, 'lps'),
	(538581, 128, '2014-02-15 00:53:54.000000', 'consum', 0.0210, 'lps'),
	(538582, 128, '2014-02-15 00:53:55.000000', 'consum', 0.0213, 'lps'),
	(538583, 128, '2014-02-15 00:53:56.000000', 'consum', 0.0210, 'lps'),
	(538584, 128, '2014-02-15 00:53:57.000000', 'consum', 0.0219, 'lps'),
	(538585, 128, '2014-02-15 00:53:58.000000', 'consum', 0.0222, 'lps'),
	(538586, 128, '2014-02-15 00:53:59.000000', 'consum', 0.0224, 'lps'),
	(538587, 128, '2014-02-15 00:54:00.000000', 'consum', 0.0210, 'lps'),
	(538588, 128, '2014-02-15 00:54:01.000000', 'consum', 0.0219, 'lps'),
	(538589, 128, '2014-02-15 00:54:02.000000', 'consum', 0.0223, 'lps'),
	(538590, 128, '2014-02-15 00:54:03.000000', 'consum', 0.0215, 'lps'),
	(538591, 128, '2014-02-15 00:54:04.000000', 'consum', 0.0212, 'lps'),
	(538592, 128, '2014-02-15 00:54:05.000000', 'consum', 0.0222, 'lps'),
	(538593, 128, '2014-02-15 00:54:06.000000', 'consum', 0.0216, 'lps'),
	(538594, 128, '2014-02-15 00:54:07.000000', 'consum', 0.0222, 'lps'),
	(538595, 128, '2014-02-15 00:54:08.000000', 'consum', 0.0218, 'lps'),
	(538596, 128, '2014-02-15 00:54:09.000000', 'consum', 0.0216, 'lps'),
	(538597, 128, '2014-02-15 00:54:10.000000', 'consum', 0.0214, 'lps'),
	(538598, 128, '2014-02-15 00:54:11.000000', 'consum', 0.0212, 'lps'),
	(538599, 128, '2014-02-15 00:54:12.000000', 'consum', 0.0211, 'lps'),
	(538600, 128, '2014-02-15 00:54:13.000000', 'consum', 0.0225, 'lps'),
	(538601, 128, '2014-02-15 00:54:14.000000', 'consum', 0.0215, 'lps'),
	(538602, 128, '2014-02-15 00:54:15.000000', 'consum', 0.0222, 'lps'),
	(538603, 128, '2014-02-15 00:54:16.000000', 'consum', 0.0225, 'lps'),
	(538604, 128, '2014-02-15 00:54:17.000000', 'consum', 0.0214, 'lps'),
	(538605, 128, '2014-02-15 00:54:18.000000', 'consum', 0.0220, 'lps'),
	(538606, 128, '2014-02-15 00:54:19.000000', 'consum', 0.0216, 'lps'),
	(538607, 128, '2014-02-15 00:54:20.000000', 'consum', 0.0210, 'lps'),
	(538608, 128, '2014-02-15 00:54:21.000000', 'consum', 0.0210, 'lps'),
	(538609, 128, '2014-02-15 00:54:22.000000', 'consum', 0.0225, 'lps'),
	(538610, 128, '2014-02-15 00:54:23.000000', 'consum', 0.0221, 'lps'),
	(538611, 128, '2014-02-15 00:54:24.000000', 'consum', 0.0217, 'lps'),
	(538612, 128, '2014-02-15 00:54:25.000000', 'consum', 0.0216, 'lps'),
	(538613, 128, '2014-02-15 00:54:26.000000', 'consum', 0.0216, 'lps'),
	(538614, 128, '2014-02-15 00:54:27.000000', 'consum', 0.0226, 'lps'),
	(538615, 128, '2014-02-15 00:54:28.000000', 'consum', 0.0218, 'lps'),
	(538616, 128, '2014-02-15 00:54:29.000000', 'consum', 0.0223, 'lps'),
	(538617, 128, '2014-02-15 00:54:30.000000', 'consum', 0.0215, 'lps'),
	(538618, 128, '2014-02-15 00:54:31.000000', 'consum', 0.0212, 'lps'),
	(538619, 128, '2014-02-15 00:54:32.000000', 'consum', 0.0224, 'lps'),
	(538620, 128, '2014-02-15 00:54:33.000000', 'consum', 0.0225, 'lps'),
	(538621, 128, '2014-02-15 00:54:34.000000', 'consum', 0.0210, 'lps'),
	(538622, 128, '2014-02-15 00:54:35.000000', 'consum', 0.0215, 'lps'),
	(538623, 128, '2014-02-15 00:54:36.000000', 'consum', 0.0217, 'lps'),
	(538624, 128, '2014-02-15 00:54:37.000000', 'consum', 0.0217, 'lps'),
	(538625, 128, '2014-02-15 00:54:38.000000', 'consum', 0.0223, 'lps'),
	(538626, 128, '2014-02-15 00:54:39.000000', 'consum', 0.0218, 'lps'),
	(538627, 128, '2014-02-15 00:54:40.000000', 'consum', 0.0215, 'lps'),
	(538628, 128, '2014-02-15 00:54:41.000000', 'consum', 0.0211, 'lps'),
	(538629, 128, '2014-02-15 00:54:42.000000', 'consum', 0.0218, 'lps'),
	(538630, 128, '2014-02-15 00:54:43.000000', 'consum', 0.0213, 'lps'),
	(538631, 128, '2014-02-15 00:54:44.000000', 'consum', 0.0218, 'lps'),
	(538632, 128, '2014-02-15 00:54:45.000000', 'consum', 0.0225, 'lps'),
	(538633, 128, '2014-02-15 00:54:46.000000', 'consum', 0.0210, 'lps'),
	(538634, 128, '2014-02-15 00:54:47.000000', 'consum', 0.0218, 'lps'),
	(538635, 128, '2014-02-15 00:54:48.000000', 'consum', 0.0215, 'lps'),
	(538636, 128, '2014-02-15 00:54:49.000000', 'consum', 0.0211, 'lps'),
	(538637, 128, '2014-02-15 00:54:50.000000', 'consum', 0.0218, 'lps'),
	(538638, 128, '2014-02-15 00:54:51.000000', 'consum', 0.0215, 'lps'),
	(538639, 128, '2014-02-15 00:54:52.000000', 'consum', 0.0210, 'lps'),
	(538640, 128, '2014-02-15 00:54:53.000000', 'consum', 0.0212, 'lps'),
	(538641, 128, '2014-02-15 00:54:54.000000', 'consum', 0.0222, 'lps'),
	(538642, 128, '2014-02-15 00:54:55.000000', 'consum', 0.0212, 'lps'),
	(538643, 128, '2014-02-15 00:54:56.000000', 'consum', 0.0218, 'lps'),
	(538644, 128, '2014-02-15 00:54:57.000000', 'consum', 0.0211, 'lps'),
	(538645, 128, '2014-02-15 00:54:58.000000', 'consum', 0.0224, 'lps'),
	(538646, 128, '2014-02-15 00:54:59.000000', 'consum', 0.0210, 'lps'),
	(538647, 128, '2014-02-15 00:55:00.000000', 'consum', 0.0221, 'lps'),
	(538648, 128, '2014-02-15 00:55:01.000000', 'consum', 0.0212, 'lps'),
	(538649, 128, '2014-02-15 00:55:02.000000', 'consum', 0.0225, 'lps'),
	(538650, 128, '2014-02-15 00:55:03.000000', 'consum', 0.0225, 'lps'),
	(538651, 128, '2014-02-15 00:55:04.000000', 'consum', 0.0225, 'lps'),
	(538652, 128, '2014-02-15 00:55:05.000000', 'consum', 0.0221, 'lps'),
	(538653, 128, '2014-02-15 00:55:06.000000', 'consum', 0.0224, 'lps'),
	(538654, 128, '2014-02-15 00:55:07.000000', 'consum', 0.0213, 'lps'),
	(538655, 128, '2014-02-15 00:55:08.000000', 'consum', 0.0217, 'lps'),
	(538656, 128, '2014-02-15 00:55:09.000000', 'consum', 0.0218, 'lps'),
	(538657, 128, '2014-02-15 00:55:10.000000', 'consum', 0.0215, 'lps'),
	(538658, 128, '2014-02-15 00:55:11.000000', 'consum', 0.0226, 'lps'),
	(538659, 128, '2014-02-15 00:55:12.000000', 'consum', 0.0210, 'lps'),
	(538660, 128, '2014-02-15 00:55:13.000000', 'consum', 0.0214, 'lps'),
	(538661, 128, '2014-02-15 00:55:14.000000', 'consum', 0.0212, 'lps'),
	(538662, 128, '2014-02-15 00:55:15.000000', 'consum', 0.0225, 'lps'),
	(538663, 128, '2014-02-15 00:55:16.000000', 'consum', 0.0211, 'lps'),
	(538664, 128, '2014-02-15 00:55:17.000000', 'consum', 0.0223, 'lps'),
	(538665, 128, '2014-02-15 00:55:18.000000', 'consum', 0.0222, 'lps'),
	(538666, 128, '2014-02-15 00:55:19.000000', 'consum', 0.0213, 'lps'),
	(538667, 128, '2014-02-15 00:55:20.000000', 'consum', 0.0222, 'lps'),
	(538668, 128, '2014-02-15 00:55:21.000000', 'consum', 0.0212, 'lps'),
	(538669, 128, '2014-02-15 00:55:22.000000', 'consum', 0.0219, 'lps'),
	(538670, 128, '2014-02-15 00:55:23.000000', 'consum', 0.0216, 'lps'),
	(538671, 128, '2014-02-15 00:55:24.000000', 'consum', 0.0215, 'lps'),
	(538672, 128, '2014-02-15 00:55:25.000000', 'consum', 0.0216, 'lps'),
	(538673, 128, '2014-02-15 00:55:26.000000', 'consum', 0.0225, 'lps'),
	(538674, 128, '2014-02-15 00:55:27.000000', 'consum', 0.0219, 'lps'),
	(538675, 128, '2014-02-15 00:55:28.000000', 'consum', 0.0226, 'lps'),
	(538676, 128, '2014-02-15 00:55:29.000000', 'consum', 0.0212, 'lps'),
	(538677, 128, '2014-02-15 00:55:30.000000', 'consum', 0.0226, 'lps'),
	(538678, 128, '2014-02-15 00:55:31.000000', 'consum', 0.0213, 'lps'),
	(538679, 128, '2014-02-15 00:55:32.000000', 'consum', 0.0213, 'lps'),
	(538680, 128, '2014-02-15 00:55:33.000000', 'consum', 0.0216, 'lps'),
	(538681, 128, '2014-02-15 00:55:34.000000', 'consum', 0.0213, 'lps'),
	(538682, 128, '2014-02-15 00:55:35.000000', 'consum', 0.0225, 'lps'),
	(538683, 128, '2014-02-15 00:55:36.000000', 'consum', 0.0225, 'lps'),
	(538684, 128, '2014-02-15 00:55:37.000000', 'consum', 0.0226, 'lps'),
	(538685, 128, '2014-02-15 00:55:38.000000', 'consum', 0.0211, 'lps'),
	(538686, 128, '2014-02-15 00:55:39.000000', 'consum', 0.0217, 'lps'),
	(538687, 128, '2014-02-15 00:55:40.000000', 'consum', 0.0210, 'lps'),
	(538688, 128, '2014-02-15 00:55:41.000000', 'consum', 0.0221, 'lps'),
	(538689, 128, '2014-02-15 00:55:42.000000', 'consum', 0.0218, 'lps'),
	(538690, 128, '2014-02-15 00:55:43.000000', 'consum', 0.0214, 'lps'),
	(538691, 128, '2014-02-15 00:55:44.000000', 'consum', 0.0226, 'lps'),
	(538692, 128, '2014-02-15 00:55:45.000000', 'consum', 0.0226, 'lps'),
	(538693, 128, '2014-02-15 00:55:46.000000', 'consum', 0.0226, 'lps'),
	(538694, 128, '2014-02-15 00:55:47.000000', 'consum', 0.0225, 'lps'),
	(538695, 128, '2014-02-15 00:55:48.000000', 'consum', 0.0220, 'lps'),
	(538696, 128, '2014-02-15 00:55:49.000000', 'consum', 0.0217, 'lps'),
	(538697, 128, '2014-02-15 00:55:50.000000', 'consum', 0.0215, 'lps'),
	(538698, 128, '2014-02-15 00:55:51.000000', 'consum', 0.0214, 'lps'),
	(538699, 128, '2014-02-15 00:55:52.000000', 'consum', 0.0215, 'lps'),
	(538700, 128, '2014-02-15 00:55:53.000000', 'consum', 0.0225, 'lps'),
	(538701, 128, '2014-02-15 00:55:54.000000', 'consum', 0.0218, 'lps'),
	(538702, 128, '2014-02-15 00:55:55.000000', 'consum', 0.0224, 'lps'),
	(538703, 128, '2014-02-15 00:55:56.000000', 'consum', 0.0224, 'lps'),
	(538704, 128, '2014-02-15 00:55:57.000000', 'consum', 0.0218, 'lps'),
	(538705, 128, '2014-02-15 00:55:58.000000', 'consum', 0.0212, 'lps'),
	(538706, 128, '2014-02-15 00:55:59.000000', 'consum', 0.0212, 'lps'),
	(538707, 128, '2014-02-15 00:56:00.000000', 'consum', 0.0213, 'lps'),
	(538708, 128, '2014-02-15 00:56:01.000000', 'consum', 0.0221, 'lps'),
	(538709, 128, '2014-02-15 00:56:02.000000', 'consum', 0.0221, 'lps'),
	(538710, 128, '2014-02-15 00:56:03.000000', 'consum', 0.0215, 'lps'),
	(538711, 128, '2014-02-15 00:56:04.000000', 'consum', 0.0223, 'lps'),
	(538712, 128, '2014-02-15 00:56:05.000000', 'consum', 0.0223, 'lps'),
	(538713, 128, '2014-02-15 00:56:06.000000', 'consum', 0.0219, 'lps'),
	(538714, 128, '2014-02-15 00:56:07.000000', 'consum', 0.0219, 'lps'),
	(538715, 128, '2014-02-15 00:56:08.000000', 'consum', 0.0212, 'lps'),
	(538716, 128, '2014-02-15 00:56:09.000000', 'consum', 0.0226, 'lps'),
	(538717, 128, '2014-02-15 00:56:10.000000', 'consum', 0.0218, 'lps'),
	(538718, 128, '2014-02-15 00:56:11.000000', 'consum', 0.0217, 'lps'),
	(538719, 128, '2014-02-15 00:56:12.000000', 'consum', 0.0222, 'lps'),
	(538720, 128, '2014-02-15 00:56:13.000000', 'consum', 0.0214, 'lps'),
	(538721, 128, '2014-02-15 00:56:14.000000', 'consum', 0.0214, 'lps'),
	(538722, 128, '2014-02-15 00:56:15.000000', 'consum', 0.0218, 'lps'),
	(538723, 128, '2014-02-15 00:56:16.000000', 'consum', 0.0219, 'lps'),
	(538724, 128, '2014-02-15 00:56:17.000000', 'consum', 0.0218, 'lps'),
	(538725, 128, '2014-02-15 00:56:18.000000', 'consum', 0.0222, 'lps'),
	(538726, 128, '2014-02-15 00:56:19.000000', 'consum', 0.0211, 'lps'),
	(538727, 128, '2014-02-15 00:56:20.000000', 'consum', 0.0214, 'lps'),
	(538728, 128, '2014-02-15 00:56:21.000000', 'consum', 0.0213, 'lps'),
	(538729, 128, '2014-02-15 00:56:22.000000', 'consum', 0.0212, 'lps'),
	(538730, 128, '2014-02-15 00:56:23.000000', 'consum', 0.0212, 'lps'),
	(538731, 128, '2014-02-15 00:56:24.000000', 'consum', 0.0215, 'lps'),
	(538732, 128, '2014-02-15 00:56:25.000000', 'consum', 0.0211, 'lps'),
	(538733, 128, '2014-02-15 00:56:26.000000', 'consum', 0.0218, 'lps'),
	(538734, 128, '2014-02-15 00:56:27.000000', 'consum', 0.0215, 'lps'),
	(538735, 128, '2014-02-15 00:56:28.000000', 'consum', 0.0211, 'lps'),
	(538736, 128, '2014-02-15 00:56:29.000000', 'consum', 0.0219, 'lps'),
	(538737, 128, '2014-02-15 00:56:30.000000', 'consum', 0.0218, 'lps'),
	(538738, 128, '2014-02-15 00:56:31.000000', 'consum', 0.0221, 'lps'),
	(538739, 128, '2014-02-15 00:56:32.000000', 'consum', 0.0226, 'lps'),
	(538740, 128, '2014-02-15 00:56:33.000000', 'consum', 0.0221, 'lps'),
	(538741, 128, '2014-02-15 00:56:34.000000', 'consum', 0.0221, 'lps'),
	(538742, 128, '2014-02-15 00:56:35.000000', 'consum', 0.0212, 'lps'),
	(538743, 128, '2014-02-15 00:56:36.000000', 'consum', 0.0225, 'lps'),
	(538744, 128, '2014-02-15 00:56:37.000000', 'consum', 0.0225, 'lps'),
	(538745, 128, '2014-02-15 00:56:38.000000', 'consum', 0.0226, 'lps'),
	(538746, 128, '2014-02-15 00:56:39.000000', 'consum', 0.0210, 'lps'),
	(538747, 128, '2014-02-15 00:56:40.000000', 'consum', 0.0214, 'lps'),
	(538748, 128, '2014-02-15 00:56:41.000000', 'consum', 0.0213, 'lps'),
	(538749, 128, '2014-02-15 00:56:42.000000', 'consum', 0.0212, 'lps'),
	(538750, 128, '2014-02-15 00:56:43.000000', 'consum', 0.0212, 'lps'),
	(538751, 128, '2014-02-15 00:56:44.000000', 'consum', 0.0215, 'lps'),
	(538752, 128, '2014-02-15 00:56:45.000000', 'consum', 0.0214, 'lps'),
	(538753, 128, '2014-02-15 00:56:46.000000', 'consum', 0.0214, 'lps'),
	(538754, 128, '2014-02-15 00:56:47.000000', 'consum', 0.0219, 'lps'),
	(538755, 128, '2014-02-15 00:56:48.000000', 'consum', 0.0210, 'lps'),
	(538756, 128, '2014-02-15 00:56:49.000000', 'consum', 0.0216, 'lps'),
	(538757, 128, '2014-02-15 00:56:50.000000', 'consum', 0.0225, 'lps'),
	(538758, 128, '2014-02-15 00:56:51.000000', 'consum', 0.0214, 'lps'),
	(538759, 128, '2014-02-15 00:56:52.000000', 'consum', 0.0220, 'lps'),
	(538760, 128, '2014-02-15 00:56:53.000000', 'consum', 0.0217, 'lps'),
	(538761, 128, '2014-02-15 00:56:54.000000', 'consum', 0.0215, 'lps'),
	(538762, 128, '2014-02-15 00:56:55.000000', 'consum', 0.0213, 'lps'),
	(538763, 128, '2014-02-15 00:56:56.000000', 'consum', 0.0210, 'lps'),
	(538764, 128, '2014-02-15 00:56:57.000000', 'consum', 0.0221, 'lps'),
	(538765, 128, '2014-02-15 00:56:58.000000', 'consum', 0.0211, 'lps'),
	(538766, 128, '2014-02-15 00:56:59.000000', 'consum', 0.0220, 'lps'),
	(538767, 128, '2014-02-15 00:57:00.000000', 'consum', 0.0223, 'lps'),
	(538768, 128, '2014-02-15 00:57:01.000000', 'consum', 0.0210, 'lps'),
	(538769, 128, '2014-02-15 00:57:02.000000', 'consum', 0.0224, 'lps'),
	(538770, 128, '2014-02-15 00:57:03.000000', 'consum', 0.0211, 'lps'),
	(538771, 128, '2014-02-15 00:57:04.000000', 'consum', 0.0224, 'lps'),
	(538772, 128, '2014-02-15 00:57:05.000000', 'consum', 0.0212, 'lps'),
	(538773, 128, '2014-02-15 00:57:06.000000', 'consum', 0.0210, 'lps'),
	(538774, 128, '2014-02-15 00:57:07.000000', 'consum', 0.0222, 'lps'),
	(538775, 128, '2014-02-15 00:57:08.000000', 'consum', 0.0219, 'lps'),
	(538776, 128, '2014-02-15 00:57:09.000000', 'consum', 0.0221, 'lps'),
	(538777, 128, '2014-02-15 00:57:10.000000', 'consum', 0.0222, 'lps'),
	(538778, 128, '2014-02-15 00:57:11.000000', 'consum', 0.0219, 'lps'),
	(538779, 128, '2014-02-15 00:57:12.000000', 'consum', 0.0219, 'lps'),
	(538780, 128, '2014-02-15 00:57:13.000000', 'consum', 0.0212, 'lps'),
	(538781, 128, '2014-02-15 00:57:14.000000', 'consum', 0.0226, 'lps'),
	(538782, 128, '2014-02-15 00:57:15.000000', 'consum', 0.0219, 'lps'),
	(538783, 128, '2014-02-15 00:57:16.000000', 'consum', 0.0222, 'lps'),
	(538784, 128, '2014-02-15 00:57:17.000000', 'consum', 0.0226, 'lps'),
	(538785, 128, '2014-02-15 00:57:18.000000', 'consum', 0.0223, 'lps'),
	(538786, 128, '2014-02-15 00:57:19.000000', 'consum', 0.0211, 'lps'),
	(538787, 128, '2014-02-15 00:57:20.000000', 'consum', 0.0226, 'lps'),
	(538788, 128, '2014-02-15 00:57:21.000000', 'consum', 0.0218, 'lps'),
	(538789, 128, '2014-02-15 00:57:22.000000', 'consum', 0.0222, 'lps'),
	(538790, 128, '2014-02-15 00:57:23.000000', 'consum', 0.0213, 'lps'),
	(538791, 128, '2014-02-15 00:57:24.000000', 'consum', 0.0221, 'lps'),
	(538792, 128, '2014-02-15 00:57:25.000000', 'consum', 0.0222, 'lps'),
	(538793, 128, '2014-02-15 00:57:26.000000', 'consum', 0.0221, 'lps'),
	(538794, 128, '2014-02-15 00:57:27.000000', 'consum', 0.0211, 'lps'),
	(538795, 128, '2014-02-15 00:57:28.000000', 'consum', 0.0218, 'lps'),
	(538796, 128, '2014-02-15 00:57:29.000000', 'consum', 0.0212, 'lps'),
	(538797, 128, '2014-02-15 00:57:30.000000', 'consum', 0.0216, 'lps'),
	(538798, 128, '2014-02-15 00:57:31.000000', 'consum', 0.0217, 'lps'),
	(538799, 128, '2014-02-15 00:57:32.000000', 'consum', 0.0211, 'lps'),
	(538800, 128, '2014-02-15 00:57:33.000000', 'consum', 0.0210, 'lps'),
	(538801, 128, '2014-02-15 00:57:34.000000', 'consum', 0.0224, 'lps'),
	(538802, 128, '2014-02-15 00:57:35.000000', 'consum', 0.0214, 'lps'),
	(538803, 128, '2014-02-15 00:57:36.000000', 'consum', 0.0221, 'lps'),
	(538804, 128, '2014-02-15 00:57:37.000000', 'consum', 0.0220, 'lps'),
	(538805, 128, '2014-02-15 00:57:38.000000', 'consum', 0.0226, 'lps'),
	(538806, 128, '2014-02-15 00:57:39.000000', 'consum', 0.0212, 'lps'),
	(538807, 128, '2014-02-15 00:57:40.000000', 'consum', 0.0225, 'lps'),
	(538808, 128, '2014-02-15 00:57:41.000000', 'consum', 0.0225, 'lps'),
	(538809, 128, '2014-02-15 00:57:42.000000', 'consum', 0.0224, 'lps'),
	(538810, 128, '2014-02-15 00:57:43.000000', 'consum', 0.0221, 'lps'),
	(538811, 128, '2014-02-15 00:57:44.000000', 'consum', 0.0223, 'lps'),
	(538812, 128, '2014-02-15 00:57:45.000000', 'consum', 0.0224, 'lps'),
	(538813, 128, '2014-02-15 00:57:46.000000', 'consum', 0.0226, 'lps'),
	(538814, 128, '2014-02-15 00:57:47.000000', 'consum', 0.0216, 'lps'),
	(538815, 128, '2014-02-15 00:57:48.000000', 'consum', 0.0223, 'lps'),
	(538816, 128, '2014-02-15 00:57:49.000000', 'consum', 0.0224, 'lps'),
	(538817, 128, '2014-02-15 00:57:50.000000', 'consum', 0.0210, 'lps'),
	(538818, 128, '2014-02-15 00:57:51.000000', 'consum', 0.0219, 'lps'),
	(538819, 128, '2014-02-15 00:57:52.000000', 'consum', 0.0222, 'lps'),
	(538820, 128, '2014-02-15 00:57:53.000000', 'consum', 0.0225, 'lps'),
	(538821, 128, '2014-02-15 00:57:54.000000', 'consum', 0.0216, 'lps'),
	(538822, 128, '2014-02-15 00:57:55.000000', 'consum', 0.0211, 'lps'),
	(538823, 128, '2014-02-15 00:57:56.000000', 'consum', 0.0216, 'lps'),
	(538824, 128, '2014-02-15 00:57:57.000000', 'consum', 0.0220, 'lps'),
	(538825, 128, '2014-02-15 00:57:58.000000', 'consum', 0.0226, 'lps'),
	(538826, 128, '2014-02-15 00:57:59.000000', 'consum', 0.0224, 'lps'),
	(538827, 128, '2014-02-15 00:58:00.000000', 'consum', 0.0219, 'lps'),
	(538828, 128, '2014-02-15 00:58:01.000000', 'consum', 0.0212, 'lps'),
	(538829, 128, '2014-02-15 00:58:02.000000', 'consum', 0.0212, 'lps'),
	(538830, 128, '2014-02-15 00:58:03.000000', 'consum', 0.0214, 'lps'),
	(538831, 128, '2014-02-15 00:58:04.000000', 'consum', 0.0226, 'lps'),
	(538832, 128, '2014-02-15 00:58:05.000000', 'consum', 0.0226, 'lps'),
	(538833, 128, '2014-02-15 00:58:06.000000', 'consum', 0.0225, 'lps'),
	(538834, 128, '2014-02-15 00:58:07.000000', 'consum', 0.0222, 'lps'),
	(538835, 128, '2014-02-15 00:58:08.000000', 'consum', 0.0224, 'lps'),
	(538836, 128, '2014-02-15 00:58:09.000000', 'consum', 0.0212, 'lps'),
	(538837, 128, '2014-02-15 00:58:10.000000', 'consum', 0.0210, 'lps'),
	(538838, 128, '2014-02-15 00:58:11.000000', 'consum', 0.0224, 'lps'),
	(538839, 128, '2014-02-15 00:58:12.000000', 'consum', 0.0210, 'lps'),
	(538840, 128, '2014-02-15 00:58:13.000000', 'consum', 0.0220, 'lps'),
	(538841, 128, '2014-02-15 00:58:14.000000', 'consum', 0.0225, 'lps'),
	(538842, 128, '2014-02-15 00:58:15.000000', 'consum', 0.0225, 'lps'),
	(538843, 128, '2014-02-15 00:58:16.000000', 'consum', 0.0221, 'lps'),
	(538844, 128, '2014-02-15 00:58:17.000000', 'consum', 0.0220, 'lps'),
	(538845, 128, '2014-02-15 00:58:18.000000', 'consum', 0.0211, 'lps'),
	(538846, 128, '2014-02-15 00:58:19.000000', 'consum', 0.0220, 'lps'),
	(538847, 128, '2014-02-15 00:58:20.000000', 'consum', 0.0224, 'lps'),
	(538848, 128, '2014-02-15 00:58:21.000000', 'consum', 0.0216, 'lps'),
	(538849, 128, '2014-02-15 00:58:22.000000', 'consum', 0.0215, 'lps'),
	(538850, 128, '2014-02-15 00:58:23.000000', 'consum', 0.0216, 'lps'),
	(538851, 128, '2014-02-15 00:58:24.000000', 'consum', 0.0211, 'lps'),
	(538852, 128, '2014-02-15 00:58:25.000000', 'consum', 0.0215, 'lps'),
	(538853, 128, '2014-02-15 00:58:26.000000', 'consum', 0.0216, 'lps'),
	(538854, 128, '2014-02-15 00:58:27.000000', 'consum', 0.0224, 'lps'),
	(538855, 128, '2014-02-15 00:58:28.000000', 'consum', 0.0211, 'lps'),
	(538856, 128, '2014-02-15 00:58:29.000000', 'consum', 0.0224, 'lps'),
	(538857, 128, '2014-02-15 00:58:30.000000', 'consum', 0.0211, 'lps'),
	(538858, 128, '2014-02-15 00:58:31.000000', 'consum', 0.0226, 'lps'),
	(538859, 128, '2014-02-15 00:58:32.000000', 'consum', 0.0218, 'lps'),
	(538860, 128, '2014-02-15 00:58:33.000000', 'consum', 0.0220, 'lps'),
	(538861, 128, '2014-02-15 00:58:34.000000', 'consum', 0.0220, 'lps'),
	(538862, 128, '2014-02-15 00:58:35.000000', 'consum', 0.0212, 'lps'),
	(538863, 128, '2014-02-15 00:58:36.000000', 'consum', 0.0210, 'lps'),
	(538864, 128, '2014-02-15 00:58:37.000000', 'consum', 0.0219, 'lps'),
	(538865, 128, '2014-02-15 00:58:38.000000', 'consum', 0.0222, 'lps'),
	(538866, 128, '2014-02-15 00:58:39.000000', 'consum', 0.0226, 'lps'),
	(538867, 128, '2014-02-15 00:58:40.000000', 'consum', 0.0221, 'lps'),
	(538868, 128, '2014-02-15 00:58:41.000000', 'consum', 0.0215, 'lps'),
	(538869, 128, '2014-02-15 00:58:42.000000', 'consum', 0.0223, 'lps'),
	(538870, 128, '2014-02-15 00:58:43.000000', 'consum', 0.0226, 'lps'),
	(538871, 128, '2014-02-15 00:58:44.000000', 'consum', 0.0215, 'lps'),
	(538872, 128, '2014-02-15 00:58:45.000000', 'consum', 0.0223, 'lps'),
	(538873, 128, '2014-02-15 00:58:46.000000', 'consum', 0.0210, 'lps'),
	(538874, 128, '2014-02-15 00:58:47.000000', 'consum', 0.0223, 'lps'),
	(538875, 128, '2014-02-15 00:58:48.000000', 'consum', 0.0223, 'lps'),
	(538876, 128, '2014-02-15 00:58:49.000000', 'consum', 0.0220, 'lps'),
	(538877, 128, '2014-02-15 00:58:50.000000', 'consum', 0.0223, 'lps'),
	(538878, 128, '2014-02-15 00:58:51.000000', 'consum', 0.0211, 'lps'),
	(538879, 128, '2014-02-15 00:58:52.000000', 'consum', 0.0211, 'lps'),
	(538880, 128, '2014-02-15 00:58:53.000000', 'consum', 0.0211, 'lps'),
	(538881, 128, '2014-02-15 00:58:54.000000', 'consum', 0.0215, 'lps'),
	(538882, 128, '2014-02-15 00:58:55.000000', 'consum', 0.0213, 'lps'),
	(538883, 128, '2014-02-15 00:58:56.000000', 'consum', 0.0226, 'lps'),
	(538884, 128, '2014-02-15 00:58:57.000000', 'consum', 0.0217, 'lps'),
	(538885, 128, '2014-02-15 00:58:58.000000', 'consum', 0.0214, 'lps'),
	(538886, 128, '2014-02-15 00:58:59.000000', 'consum', 0.0226, 'lps'),
	(538887, 128, '2014-02-15 00:59:00.000000', 'consum', 0.0211, 'lps'),
	(538888, 128, '2014-02-15 00:59:01.000000', 'consum', 0.0218, 'lps'),
	(538889, 128, '2014-02-15 00:59:02.000000', 'consum', 0.0214, 'lps'),
	(538890, 128, '2014-02-15 00:59:03.000000', 'consum', 0.0222, 'lps'),
	(538891, 128, '2014-02-15 00:59:04.000000', 'consum', 0.0226, 'lps'),
	(538892, 128, '2014-02-15 00:59:05.000000', 'consum', 0.0218, 'lps'),
	(538893, 128, '2014-02-15 00:59:06.000000', 'consum', 0.0222, 'lps'),
	(538894, 128, '2014-02-15 00:59:07.000000', 'consum', 0.0213, 'lps'),
	(538895, 128, '2014-02-15 00:59:08.000000', 'consum', 0.0222, 'lps'),
	(538896, 128, '2014-02-15 00:59:09.000000', 'consum', 0.0213, 'lps'),
	(538897, 128, '2014-02-15 00:59:10.000000', 'consum', 0.0221, 'lps'),
	(538898, 128, '2014-02-15 00:59:11.000000', 'consum', 0.0221, 'lps'),
	(538899, 128, '2014-02-15 00:59:12.000000', 'consum', 0.0219, 'lps'),
	(538900, 128, '2014-02-15 00:59:13.000000', 'consum', 0.0220, 'lps'),
	(538901, 128, '2014-02-15 00:59:14.000000', 'consum', 0.0218, 'lps'),
	(538902, 128, '2014-02-15 00:59:15.000000', 'consum', 0.0222, 'lps'),
	(538903, 128, '2014-02-15 00:59:16.000000', 'consum', 0.0211, 'lps'),
	(538904, 128, '2014-02-15 00:59:17.000000', 'consum', 0.0215, 'lps'),
	(538905, 128, '2014-02-15 00:59:18.000000', 'consum', 0.0213, 'lps'),
	(538906, 128, '2014-02-15 00:59:19.000000', 'consum', 0.0213, 'lps'),
	(538907, 128, '2014-02-15 00:59:20.000000', 'consum', 0.0217, 'lps'),
	(538908, 128, '2014-02-15 00:59:21.000000', 'consum', 0.0216, 'lps'),
	(538909, 128, '2014-02-15 00:59:22.000000', 'consum', 0.0223, 'lps'),
	(538910, 128, '2014-02-15 00:59:23.000000', 'consum', 0.0222, 'lps'),
	(538911, 128, '2014-02-15 00:59:24.000000', 'consum', 0.0215, 'lps'),
	(538912, 128, '2014-02-15 00:59:25.000000', 'consum', 0.0218, 'lps'),
	(538913, 128, '2014-02-15 00:59:26.000000', 'consum', 0.0218, 'lps'),
	(538914, 128, '2014-02-15 00:59:27.000000', 'consum', 0.0226, 'lps'),
	(538915, 128, '2014-02-15 00:59:28.000000', 'consum', 0.0216, 'lps'),
	(538916, 128, '2014-02-15 00:59:29.000000', 'consum', 0.0225, 'lps'),
	(538917, 128, '2014-02-15 00:59:30.000000', 'consum', 0.0218, 'lps'),
	(538918, 128, '2014-02-15 00:59:31.000000', 'consum', 0.0224, 'lps'),
	(538919, 128, '2014-02-15 00:59:32.000000', 'consum', 0.0220, 'lps'),
	(538920, 128, '2014-02-15 00:59:33.000000', 'consum', 0.0220, 'lps'),
	(538921, 128, '2014-02-15 00:59:34.000000', 'consum', 0.0212, 'lps'),
	(538922, 128, '2014-02-15 00:59:35.000000', 'consum', 0.0226, 'lps'),
	(538923, 128, '2014-02-15 00:59:36.000000', 'consum', 0.0217, 'lps'),
	(538924, 128, '2014-02-15 00:59:37.000000', 'consum', 0.0213, 'lps'),
	(538925, 128, '2014-02-15 00:59:38.000000', 'consum', 0.0223, 'lps'),
	(538926, 128, '2014-02-15 00:59:39.000000', 'consum', 0.0215, 'lps'),
	(538927, 128, '2014-02-15 00:59:40.000000', 'consum', 0.0212, 'lps'),
	(538928, 128, '2014-02-15 00:59:41.000000', 'consum', 0.0222, 'lps'),
	(538929, 128, '2014-02-15 00:59:42.000000', 'consum', 0.0215, 'lps'),
	(538930, 128, '2014-02-15 00:59:43.000000', 'consum', 0.0218, 'lps'),
	(538931, 128, '2014-02-15 00:59:44.000000', 'consum', 0.0218, 'lps'),
	(538932, 128, '2014-02-15 00:59:45.000000', 'consum', 0.0210, 'lps'),
	(538933, 128, '2014-02-15 00:59:46.000000', 'consum', 0.0221, 'lps'),
	(538934, 128, '2014-02-15 00:59:47.000000', 'consum', 0.0213, 'lps'),
	(538935, 128, '2014-02-15 00:59:48.000000', 'consum', 0.0226, 'lps'),
	(538936, 128, '2014-02-15 00:59:49.000000', 'consum', 0.0213, 'lps'),
	(538937, 128, '2014-02-15 00:59:50.000000', 'consum', 0.0214, 'lps'),
	(538938, 128, '2014-02-15 00:59:51.000000', 'consum', 0.0222, 'lps'),
	(538939, 128, '2014-02-15 00:59:52.000000', 'consum', 0.0223, 'lps'),
	(538940, 128, '2014-02-15 00:59:53.000000', 'consum', 0.0221, 'lps'),
	(538941, 128, '2014-02-15 00:59:54.000000', 'consum', 0.0210, 'lps'),
	(538942, 128, '2014-02-15 00:59:55.000000', 'consum', 0.0211, 'lps'),
	(538943, 128, '2014-02-15 00:59:56.000000', 'consum', 0.0216, 'lps'),
	(538944, 128, '2014-02-15 00:59:57.000000', 'consum', 0.0221, 'lps'),
	(538945, 128, '2014-02-15 00:59:58.000000', 'consum', 0.0214, 'lps'),
	(538946, 128, '2014-02-15 00:59:59.000000', 'consum', 0.0213, 'lps'),
	(538947, 128, '2014-02-15 01:00:00.000000', 'consum', 0.0216, 'lps'),
	(538948, 128, '2014-02-15 01:00:01.000000', 'consum', 0.0213, 'lps'),
	(538949, 128, '2014-02-15 01:00:02.000000', 'consum', 0.0225, 'lps'),
	(538950, 128, '2014-02-15 01:00:03.000000', 'consum', 0.0226, 'lps'),
	(538951, 128, '2014-02-15 01:00:04.000000', 'consum', 0.0211, 'lps'),
	(538952, 128, '2014-02-15 01:00:05.000000', 'consum', 0.0218, 'lps'),
	(538953, 128, '2014-02-15 01:00:06.000000', 'consum', 0.0214, 'lps'),
	(538954, 128, '2014-02-15 01:00:07.000000', 'consum', 0.0224, 'lps'),
	(538955, 128, '2014-02-15 01:00:08.000000', 'consum', 0.0218, 'lps'),
	(538956, 128, '2014-02-15 01:00:09.000000', 'consum', 0.0223, 'lps'),
	(538957, 128, '2014-02-15 01:00:10.000000', 'consum', 0.0221, 'lps'),
	(538958, 128, '2014-02-15 01:00:11.000000', 'consum', 0.0223, 'lps'),
	(538959, 128, '2014-02-15 01:00:12.000000', 'consum', 0.0210, 'lps'),
	(538960, 128, '2014-02-15 01:00:13.000000', 'consum', 0.0224, 'lps'),
	(538961, 128, '2014-02-15 01:00:14.000000', 'consum', 0.0213, 'lps'),
	(538962, 128, '2014-02-15 01:00:15.000000', 'consum', 0.0216, 'lps'),
	(538963, 128, '2014-02-15 01:00:16.000000', 'consum', 0.0216, 'lps'),
	(538964, 128, '2014-02-15 01:00:17.000000', 'consum', 0.0220, 'lps'),
	(538965, 128, '2014-02-15 01:00:18.000000', 'consum', 0.0225, 'lps'),
	(538966, 128, '2014-02-15 01:00:19.000000', 'consum', 0.0222, 'lps'),
	(538967, 128, '2014-02-15 01:00:20.000000', 'consum', 0.0226, 'lps'),
	(538968, 128, '2014-02-15 01:00:21.000000', 'consum', 0.0222, 'lps'),
	(538969, 128, '2014-02-15 01:00:22.000000', 'consum', 0.0222, 'lps'),
	(538970, 128, '2014-02-15 01:00:23.000000', 'consum', 0.0217, 'lps'),
	(538971, 128, '2014-02-15 01:00:24.000000', 'consum', 0.0210, 'lps'),
	(538972, 128, '2014-02-15 01:00:25.000000', 'consum', 0.0224, 'lps'),
	(538973, 128, '2014-02-15 01:00:26.000000', 'consum', 0.0211, 'lps'),
	(538974, 128, '2014-02-15 01:00:27.000000', 'consum', 0.0225, 'lps'),
	(538975, 128, '2014-02-15 01:00:28.000000', 'consum', 0.0216, 'lps'),
	(538976, 128, '2014-02-15 01:00:29.000000', 'consum', 0.0212, 'lps'),
	(538977, 128, '2014-02-15 01:00:30.000000', 'consum', 0.0219, 'lps'),
	(538978, 128, '2014-02-15 01:00:31.000000', 'consum', 0.0214, 'lps'),
	(538979, 128, '2014-02-15 01:00:32.000000', 'consum', 0.0221, 'lps'),
	(538980, 128, '2014-02-15 01:00:33.000000', 'consum', 0.0218, 'lps'),
	(538981, 128, '2014-02-15 01:00:34.000000', 'consum', 0.0220, 'lps'),
	(538982, 128, '2014-02-15 01:00:35.000000', 'consum', 0.0217, 'lps'),
	(538983, 128, '2014-02-15 01:00:36.000000', 'consum', 0.0217, 'lps'),
	(538984, 128, '2014-02-15 01:00:37.000000', 'consum', 0.0225, 'lps'),
	(538985, 128, '2014-02-15 01:00:38.000000', 'consum', 0.0213, 'lps'),
	(538986, 128, '2014-02-15 01:00:39.000000', 'consum', 0.0216, 'lps'),
	(538987, 128, '2014-02-15 01:00:40.000000', 'consum', 0.0213, 'lps'),
	(538988, 128, '2014-02-15 01:00:41.000000', 'consum', 0.0225, 'lps'),
	(538989, 128, '2014-02-15 01:00:42.000000', 'consum', 0.0226, 'lps'),
	(538990, 128, '2014-02-15 01:00:43.000000', 'consum', 0.0226, 'lps'),
	(538991, 128, '2014-02-15 01:00:44.000000', 'consum', 0.0210, 'lps'),
	(538992, 128, '2014-02-15 01:00:45.000000', 'consum', 0.0215, 'lps'),
	(538993, 128, '2014-02-15 01:00:46.000000', 'consum', 0.0219, 'lps'),
	(538994, 128, '2014-02-15 01:00:47.000000', 'consum', 0.0221, 'lps'),
	(538995, 128, '2014-02-15 01:00:48.000000', 'consum', 0.0223, 'lps'),
	(538996, 128, '2014-02-15 01:00:49.000000', 'consum', 0.0226, 'lps'),
	(538997, 128, '2014-02-15 01:00:50.000000', 'consum', 0.0218, 'lps'),
	(538998, 128, '2014-02-15 01:00:51.000000', 'consum', 0.0218, 'lps'),
	(538999, 128, '2014-02-15 01:00:52.000000', 'consum', 0.0211, 'lps'),
	(539000, 128, '2014-02-15 01:00:53.000000', 'consum', 0.0226, 'lps'),
	(539001, 128, '2014-02-15 01:00:54.000000', 'consum', 0.0220, 'lps'),
	(539002, 128, '2014-02-15 01:00:55.000000', 'consum', 0.0210, 'lps'),
	(539003, 128, '2014-02-15 01:00:56.000000', 'consum', 0.0216, 'lps'),
	(539004, 128, '2014-02-15 01:00:57.000000', 'consum', 0.0222, 'lps'),
	(539005, 128, '2014-02-15 01:00:58.000000', 'consum', 0.0218, 'lps'),
	(539006, 128, '2014-02-15 01:00:59.000000', 'consum', 0.0214, 'lps'),
	(539007, 128, '2014-02-15 01:01:00.000000', 'consum', 0.0223, 'lps'),
	(539008, 128, '2014-02-15 01:01:01.000000', 'consum', 0.0213, 'lps'),
	(539009, 128, '2014-02-15 01:01:02.000000', 'consum', 0.0220, 'lps'),
	(539010, 128, '2014-02-15 01:01:03.000000', 'consum', 0.0216, 'lps'),
	(539011, 128, '2014-02-15 01:01:04.000000', 'consum', 0.0214, 'lps'),
	(539012, 128, '2014-02-15 01:01:05.000000', 'consum', 0.0211, 'lps'),
	(539013, 128, '2014-02-15 01:01:06.000000', 'consum', 0.0220, 'lps'),
	(539014, 128, '2014-02-15 01:01:07.000000', 'consum', 0.0226, 'lps'),
	(539015, 128, '2014-02-15 01:01:08.000000', 'consum', 0.0223, 'lps'),
	(539016, 128, '2014-02-15 01:01:09.000000', 'consum', 0.0214, 'lps'),
	(539017, 128, '2014-02-15 01:01:10.000000', 'consum', 0.0224, 'lps'),
	(539018, 128, '2014-02-15 01:01:11.000000', 'consum', 0.0216, 'lps'),
	(539019, 128, '2014-02-15 01:01:12.000000', 'consum', 0.0218, 'lps'),
	(539020, 128, '2014-02-15 01:01:13.000000', 'consum', 0.0214, 'lps'),
	(539021, 128, '2014-02-15 01:01:14.000000', 'consum', 0.0224, 'lps'),
	(539022, 128, '2014-02-15 01:01:15.000000', 'consum', 0.0219, 'lps'),
	(539023, 128, '2014-02-15 01:01:16.000000', 'consum', 0.0214, 'lps'),
	(539024, 128, '2014-02-15 01:01:17.000000', 'consum', 0.0220, 'lps'),
	(539025, 128, '2014-02-15 01:01:18.000000', 'consum', 0.0213, 'lps'),
	(539026, 128, '2014-02-15 01:01:19.000000', 'consum', 0.0213, 'lps'),
	(539027, 128, '2014-02-15 01:01:20.000000', 'consum', 0.0218, 'lps'),
	(539028, 128, '2014-02-15 01:01:21.000000', 'consum', 0.0222, 'lps'),
	(539029, 128, '2014-02-15 01:01:22.000000', 'consum', 0.0213, 'lps'),
	(539030, 128, '2014-02-15 01:01:23.000000', 'consum', 0.0222, 'lps'),
	(539031, 128, '2014-02-15 01:01:24.000000', 'consum', 0.0214, 'lps'),
	(539032, 128, '2014-02-15 01:01:25.000000', 'consum', 0.0225, 'lps'),
	(539033, 128, '2014-02-15 01:01:26.000000', 'consum', 0.0223, 'lps'),
	(539034, 128, '2014-02-15 01:01:27.000000', 'consum', 0.0216, 'lps'),
	(539035, 128, '2014-02-15 01:01:28.000000', 'consum', 0.0216, 'lps'),
	(539036, 128, '2014-02-15 01:01:29.000000', 'consum', 0.0224, 'lps'),
	(539037, 128, '2014-02-15 01:01:30.000000', 'consum', 0.0211, 'lps'),
	(539038, 128, '2014-02-15 01:01:31.000000', 'consum', 0.0223, 'lps'),
	(539039, 128, '2014-02-15 01:01:32.000000', 'consum', 0.0224, 'lps'),
	(539040, 128, '2014-02-15 01:01:33.000000', 'consum', 0.0224, 'lps'),
	(539041, 128, '2014-02-15 01:01:34.000000', 'consum', 0.0222, 'lps'),
	(539042, 128, '2014-02-15 01:01:35.000000', 'consum', 0.0212, 'lps'),
	(539043, 128, '2014-02-15 01:01:36.000000', 'consum', 0.0216, 'lps'),
	(539044, 128, '2014-02-15 01:01:37.000000', 'consum', 0.0217, 'lps'),
	(539045, 128, '2014-02-15 01:01:38.000000', 'consum', 0.0214, 'lps'),
	(539046, 128, '2014-02-15 01:01:39.000000', 'consum', 0.0224, 'lps'),
	(539047, 128, '2014-02-15 01:01:40.000000', 'consum', 0.0219, 'lps'),
	(539048, 128, '2014-02-15 01:01:41.000000', 'consum', 0.0212, 'lps'),
	(539049, 128, '2014-02-15 01:01:42.000000', 'consum', 0.0211, 'lps'),
	(539050, 128, '2014-02-15 01:01:43.000000', 'consum', 0.0225, 'lps'),
	(539051, 128, '2014-02-15 01:01:44.000000', 'consum', 0.0218, 'lps'),
	(539052, 128, '2014-02-15 01:01:45.000000', 'consum', 0.0219, 'lps'),
	(539053, 128, '2014-02-15 01:01:46.000000', 'consum', 0.0218, 'lps'),
	(539054, 128, '2014-02-15 01:01:47.000000', 'consum', 0.0220, 'lps'),
	(539055, 128, '2014-02-15 01:01:48.000000', 'consum', 0.0220, 'lps'),
	(539056, 128, '2014-02-15 01:01:49.000000', 'consum', 0.0216, 'lps'),
	(539057, 128, '2014-02-15 01:01:50.000000', 'consum', 0.0210, 'lps'),
	(539058, 128, '2014-02-15 01:01:51.000000', 'consum', 0.0226, 'lps'),
	(539059, 128, '2014-02-15 01:01:52.000000', 'consum', 0.0224, 'lps'),
	(539060, 128, '2014-02-15 01:01:53.000000', 'consum', 0.0214, 'lps'),
	(539061, 128, '2014-02-15 01:01:54.000000', 'consum', 0.0222, 'lps'),
	(539062, 128, '2014-02-15 01:01:55.000000', 'consum', 0.0210, 'lps'),
	(539063, 128, '2014-02-15 01:01:56.000000', 'consum', 0.0223, 'lps'),
	(539064, 128, '2014-02-15 01:01:57.000000', 'consum', 0.0225, 'lps'),
	(539065, 128, '2014-02-15 01:01:58.000000', 'consum', 0.0213, 'lps'),
	(539066, 128, '2014-02-15 01:01:59.000000', 'consum', 0.0213, 'lps'),
	(539067, 128, '2014-02-15 01:02:00.000000', 'consum', 0.0218, 'lps'),
	(539068, 128, '2014-02-15 01:02:01.000000', 'consum', 0.0224, 'lps'),
	(539069, 128, '2014-02-15 01:02:02.000000', 'consum', 0.0223, 'lps'),
	(539070, 128, '2014-02-15 01:02:03.000000', 'consum', 0.0217, 'lps'),
	(539071, 128, '2014-02-15 01:02:04.000000', 'consum', 0.0221, 'lps'),
	(539072, 128, '2014-02-15 01:02:05.000000', 'consum', 0.0211, 'lps'),
	(539073, 128, '2014-02-15 01:02:06.000000', 'consum', 0.0218, 'lps'),
	(539074, 128, '2014-02-15 01:02:07.000000', 'consum', 0.0212, 'lps'),
	(539075, 128, '2014-02-15 01:02:08.000000', 'consum', 0.0213, 'lps'),
	(539076, 128, '2014-02-15 01:02:09.000000', 'consum', 0.0222, 'lps'),
	(539077, 128, '2014-02-15 01:02:10.000000', 'consum', 0.0210, 'lps'),
	(539078, 128, '2014-02-15 01:02:11.000000', 'consum', 0.0226, 'lps'),
	(539079, 128, '2014-02-15 01:02:12.000000', 'consum', 0.0220, 'lps'),
	(539080, 128, '2014-02-15 01:02:13.000000', 'consum', 0.0215, 'lps'),
	(539081, 128, '2014-02-15 01:02:14.000000', 'consum', 0.0222, 'lps'),
	(539082, 128, '2014-02-15 01:02:15.000000', 'consum', 0.0220, 'lps'),
	(539083, 128, '2014-02-15 01:02:16.000000', 'consum', 0.0225, 'lps'),
	(539084, 128, '2014-02-15 01:02:17.000000', 'consum', 0.0222, 'lps'),
	(539085, 128, '2014-02-15 01:02:18.000000', 'consum', 0.0224, 'lps'),
	(539086, 128, '2014-02-15 01:02:19.000000', 'consum', 0.0213, 'lps'),
	(539087, 128, '2014-02-15 01:02:20.000000', 'consum', 0.0217, 'lps'),
	(539088, 128, '2014-02-15 01:02:21.000000', 'consum', 0.0220, 'lps'),
	(539089, 128, '2014-02-15 01:02:22.000000', 'consum', 0.0221, 'lps'),
	(539090, 128, '2014-02-15 01:02:23.000000', 'consum', 0.0219, 'lps'),
	(539091, 128, '2014-02-15 01:02:24.000000', 'consum', 0.0221, 'lps'),
	(539092, 128, '2014-02-15 01:02:25.000000', 'consum', 0.0221, 'lps'),
	(539093, 128, '2014-02-15 01:02:26.000000', 'consum', 0.0217, 'lps'),
	(539094, 128, '2014-02-15 01:02:27.000000', 'consum', 0.0211, 'lps'),
	(539095, 128, '2014-02-15 01:02:28.000000', 'consum', 0.0213, 'lps'),
	(539096, 128, '2014-02-15 01:02:29.000000', 'consum', 0.0224, 'lps'),
	(539097, 128, '2014-02-15 01:02:30.000000', 'consum', 0.0220, 'lps'),
	(539098, 128, '2014-02-15 01:02:31.000000', 'consum', 0.0217, 'lps'),
	(539099, 128, '2014-02-15 01:02:32.000000', 'consum', 0.0214, 'lps'),
	(539100, 128, '2014-02-15 01:02:33.000000', 'consum', 0.0211, 'lps'),
	(539101, 128, '2014-02-15 01:02:34.000000', 'consum', 0.0221, 'lps'),
	(539102, 128, '2014-02-15 01:02:35.000000', 'consum', 0.0213, 'lps'),
	(539103, 128, '2014-02-15 01:02:36.000000', 'consum', 0.0225, 'lps'),
	(539104, 128, '2014-02-15 01:02:37.000000', 'consum', 0.0210, 'lps'),
	(539105, 128, '2014-02-15 01:02:38.000000', 'consum', 0.0217, 'lps'),
	(539106, 128, '2014-02-15 01:02:39.000000', 'consum', 0.0226, 'lps'),
	(539107, 128, '2014-02-15 01:02:40.000000', 'consum', 0.0221, 'lps'),
	(539108, 128, '2014-02-15 01:02:41.000000', 'consum', 0.0217, 'lps'),
	(539109, 128, '2014-02-15 01:02:42.000000', 'consum', 0.0213, 'lps'),
	(539110, 128, '2014-02-15 01:02:43.000000', 'consum', 0.0220, 'lps'),
	(539111, 128, '2014-02-15 01:02:44.000000', 'consum', 0.0216, 'lps'),
	(539112, 128, '2014-02-15 01:02:45.000000', 'consum', 0.0214, 'lps'),
	(539113, 128, '2014-02-15 01:02:46.000000', 'consum', 0.0226, 'lps'),
	(539114, 128, '2014-02-15 01:02:47.000000', 'consum', 0.0213, 'lps'),
	(539115, 128, '2014-02-15 01:02:48.000000', 'consum', 0.0212, 'lps'),
	(539116, 128, '2014-02-15 01:02:49.000000', 'consum', 0.0226, 'lps'),
	(539117, 128, '2014-02-15 01:02:50.000000', 'consum', 0.0218, 'lps'),
	(539118, 128, '2014-02-15 01:02:51.000000', 'consum', 0.0220, 'lps'),
	(539119, 128, '2014-02-15 01:02:52.000000', 'consum', 0.0218, 'lps'),
	(539120, 128, '2014-02-15 01:02:53.000000', 'consum', 0.0222, 'lps'),
	(539121, 128, '2014-02-15 01:02:54.000000', 'consum', 0.0211, 'lps'),
	(539122, 128, '2014-02-15 01:02:55.000000', 'consum', 0.0214, 'lps'),
	(539123, 128, '2014-02-15 01:02:56.000000', 'consum', 0.0226, 'lps'),
	(539124, 128, '2014-02-15 01:02:57.000000', 'consum', 0.0210, 'lps'),
	(539125, 128, '2014-02-15 01:02:58.000000', 'consum', 0.0214, 'lps'),
	(539126, 128, '2014-02-15 01:02:59.000000', 'consum', 0.0215, 'lps'),
	(539127, 128, '2014-02-15 01:03:00.000000', 'consum', 0.0224, 'lps'),
	(539128, 128, '2014-02-15 01:03:01.000000', 'consum', 0.0214, 'lps'),
	(539129, 128, '2014-02-15 01:03:02.000000', 'consum', 0.0221, 'lps'),
	(539130, 128, '2014-02-15 01:03:03.000000', 'consum', 0.0221, 'lps'),
	(539131, 128, '2014-02-15 01:03:04.000000', 'consum', 0.0215, 'lps'),
	(539132, 128, '2014-02-15 01:03:05.000000', 'consum', 0.0218, 'lps'),
	(539133, 128, '2014-02-15 01:03:06.000000', 'consum', 0.0217, 'lps'),
	(539134, 128, '2014-02-15 01:03:07.000000', 'consum', 0.0225, 'lps'),
	(539135, 128, '2014-02-15 01:03:08.000000', 'consum', 0.0213, 'lps'),
	(539136, 128, '2014-02-15 01:03:09.000000', 'consum', 0.0216, 'lps'),
	(539137, 128, '2014-02-15 01:03:10.000000', 'consum', 0.0213, 'lps'),
	(539138, 128, '2014-02-15 01:03:11.000000', 'consum', 0.0226, 'lps'),
	(539139, 128, '2014-02-15 01:03:12.000000', 'consum', 0.0215, 'lps'),
	(539140, 128, '2014-02-15 01:03:13.000000', 'consum', 0.0218, 'lps'),
	(539141, 128, '2014-02-15 01:03:14.000000', 'consum', 0.0220, 'lps'),
	(539142, 128, '2014-02-15 01:03:15.000000', 'consum', 0.0220, 'lps'),
	(539143, 128, '2014-02-15 01:03:16.000000', 'consum', 0.0215, 'lps'),
	(539144, 128, '2014-02-15 01:03:17.000000', 'consum', 0.0221, 'lps'),
	(539145, 128, '2014-02-15 01:03:18.000000', 'consum', 0.0217, 'lps'),
	(539146, 128, '2014-02-15 01:03:19.000000', 'consum', 0.0213, 'lps'),
	(539147, 128, '2014-02-15 01:03:20.000000', 'consum', 0.0221, 'lps'),
	(539148, 128, '2014-02-15 01:03:21.000000', 'consum', 0.0222, 'lps'),
	(539149, 128, '2014-02-15 01:03:22.000000', 'consum', 0.0222, 'lps'),
	(539150, 128, '2014-02-15 01:03:23.000000', 'consum', 0.0216, 'lps'),
	(539151, 128, '2014-02-15 01:03:24.000000', 'consum', 0.0221, 'lps'),
	(539152, 128, '2014-02-15 01:03:25.000000', 'consum', 0.0214, 'lps'),
	(539153, 128, '2014-02-15 01:03:26.000000', 'consum', 0.0214, 'lps'),
	(539154, 128, '2014-02-15 01:03:27.000000', 'consum', 0.0220, 'lps'),
	(539155, 128, '2014-02-15 01:03:28.000000', 'consum', 0.0215, 'lps'),
	(539156, 128, '2014-02-15 01:03:29.000000', 'consum', 0.0222, 'lps'),
	(539157, 128, '2014-02-15 01:03:30.000000', 'consum', 0.0221, 'lps'),
	(539158, 128, '2014-02-15 01:03:31.000000', 'consum', 0.0215, 'lps'),
	(539159, 128, '2014-02-15 01:03:32.000000', 'consum', 0.0216, 'lps'),
	(539160, 128, '2014-02-15 01:03:33.000000', 'consum', 0.0210, 'lps'),
	(539161, 128, '2014-02-15 01:03:34.000000', 'consum', 0.0225, 'lps'),
	(539162, 128, '2014-02-15 01:03:35.000000', 'consum', 0.0219, 'lps'),
	(539163, 128, '2014-02-15 01:03:36.000000', 'consum', 0.0225, 'lps'),
	(539164, 128, '2014-02-15 01:03:37.000000', 'consum', 0.0226, 'lps'),
	(539165, 128, '2014-02-15 01:03:38.000000', 'consum', 0.0211, 'lps'),
	(539166, 128, '2014-02-15 01:03:39.000000', 'consum', 0.0218, 'lps'),
	(539167, 128, '2014-02-15 01:03:40.000000', 'consum', 0.0215, 'lps'),
	(539168, 128, '2014-02-15 01:03:41.000000', 'consum', 0.0211, 'lps'),
	(539169, 128, '2014-02-15 01:03:42.000000', 'consum', 0.0218, 'lps'),
	(539170, 128, '2014-02-15 01:03:43.000000', 'consum', 0.0215, 'lps'),
	(539171, 128, '2014-02-15 01:03:44.000000', 'consum', 0.0210, 'lps'),
	(539172, 128, '2014-02-15 01:03:45.000000', 'consum', 0.0211, 'lps'),
	(539173, 128, '2014-02-15 01:03:46.000000', 'consum', 0.0216, 'lps'),
	(539174, 128, '2014-02-15 01:03:47.000000', 'consum', 0.0220, 'lps'),
	(539175, 128, '2014-02-15 01:03:48.000000', 'consum', 0.0211, 'lps'),
	(539176, 128, '2014-02-15 01:03:49.000000', 'consum', 0.0217, 'lps'),
	(539177, 128, '2014-02-15 01:03:50.000000', 'consum', 0.0224, 'lps'),
	(539178, 128, '2014-02-15 01:03:51.000000', 'consum', 0.0212, 'lps'),
	(539179, 128, '2014-02-15 01:03:52.000000', 'consum', 0.0226, 'lps'),
	(539180, 128, '2014-02-15 01:03:53.000000', 'consum', 0.0219, 'lps'),
	(539181, 128, '2014-02-15 01:03:54.000000', 'consum', 0.0222, 'lps'),
	(539182, 128, '2014-02-15 01:03:55.000000', 'consum', 0.0211, 'lps'),
	(539183, 128, '2014-02-15 01:03:56.000000', 'consum', 0.0214, 'lps'),
	(539184, 128, '2014-02-15 01:03:57.000000', 'consum', 0.0211, 'lps'),
	(539185, 128, '2014-02-15 01:03:58.000000', 'consum', 0.0219, 'lps'),
	(539186, 128, '2014-02-15 01:03:59.000000', 'consum', 0.0220, 'lps'),
	(539187, 128, '2014-02-15 01:04:00.000000', 'consum', 0.0214, 'lps'),
	(539188, 128, '2014-02-15 01:04:01.000000', 'consum', 0.0220, 'lps'),
	(539189, 128, '2014-02-15 01:04:02.000000', 'consum', 0.0212, 'lps'),
	(539190, 128, '2014-02-15 01:04:03.000000', 'consum', 0.0225, 'lps'),
	(539191, 128, '2014-02-15 01:04:04.000000', 'consum', 0.0210, 'lps'),
	(539192, 128, '2014-02-15 01:04:05.000000', 'consum', 0.0218, 'lps'),
	(539193, 128, '2014-02-15 01:04:06.000000', 'consum', 0.0215, 'lps'),
	(539194, 128, '2014-02-15 01:04:07.000000', 'consum', 0.0213, 'lps'),
	(539195, 128, '2014-02-15 01:04:08.000000', 'consum', 0.0211, 'lps'),
	(539196, 128, '2014-02-15 01:04:09.000000', 'consum', 0.0221, 'lps'),
	(539197, 128, '2014-02-15 01:04:10.000000', 'consum', 0.0215, 'lps'),
	(539198, 128, '2014-02-15 01:04:11.000000', 'consum', 0.0216, 'lps'),
	(539199, 128, '2014-02-15 01:04:12.000000', 'consum', 0.0210, 'lps'),
	(539200, 128, '2014-02-15 01:04:13.000000', 'consum', 0.0210, 'lps'),
	(539201, 128, '2014-02-15 01:04:14.000000', 'consum', 0.0212, 'lps'),
	(539202, 128, '2014-02-15 01:04:15.000000', 'consum', 0.0218, 'lps'),
	(539203, 128, '2014-02-15 01:04:16.000000', 'consum', 0.0211, 'lps'),
	(539204, 128, '2014-02-15 01:04:17.000000', 'consum', 0.0224, 'lps'),
	(539205, 128, '2014-02-15 01:04:18.000000', 'consum', 0.0226, 'lps'),
	(539206, 128, '2014-02-15 01:04:19.000000', 'consum', 0.0217, 'lps'),
	(539207, 128, '2014-02-15 01:04:20.000000', 'consum', 0.0215, 'lps'),
	(539208, 128, '2014-02-15 01:04:21.000000', 'consum', 0.0214, 'lps'),
	(539209, 128, '2014-02-15 01:04:22.000000', 'consum', 0.0214, 'lps'),
	(539210, 128, '2014-02-15 01:04:23.000000', 'consum', 0.0221, 'lps'),
	(539211, 128, '2014-02-15 01:04:24.000000', 'consum', 0.0219, 'lps'),
	(539212, 128, '2014-02-15 01:04:25.000000', 'consum', 0.0222, 'lps'),
	(539213, 128, '2014-02-15 01:04:26.000000', 'consum', 0.0225, 'lps'),
	(539214, 128, '2014-02-15 01:04:27.000000', 'consum', 0.0216, 'lps'),
	(539215, 128, '2014-02-15 01:04:28.000000', 'consum', 0.0212, 'lps'),
	(539216, 128, '2014-02-15 01:04:29.000000', 'consum', 0.0221, 'lps'),
	(539217, 128, '2014-02-15 01:04:30.000000', 'consum', 0.0226, 'lps'),
	(539218, 128, '2014-02-15 01:04:31.000000', 'consum', 0.0223, 'lps'),
	(539219, 128, '2014-02-15 01:04:32.000000', 'consum', 0.0225, 'lps'),
	(539220, 128, '2014-02-15 01:04:33.000000', 'consum', 0.0216, 'lps'),
	(539221, 128, '2014-02-15 01:04:34.000000', 'consum', 0.0226, 'lps'),
	(539222, 128, '2014-02-15 01:04:35.000000', 'consum', 0.0225, 'lps'),
	(539223, 128, '2014-02-15 01:04:36.000000', 'consum', 0.0219, 'lps'),
	(539224, 128, '2014-02-15 01:04:37.000000', 'consum', 0.0210, 'lps'),
	(539225, 128, '2014-02-15 01:04:38.000000', 'consum', 0.0219, 'lps'),
	(539226, 128, '2014-02-15 01:04:39.000000', 'consum', 0.0221, 'lps'),
	(539227, 128, '2014-02-15 01:04:40.000000', 'consum', 0.0222, 'lps'),
	(539228, 128, '2014-02-15 01:04:41.000000', 'consum', 0.0220, 'lps'),
	(539229, 128, '2014-02-15 01:04:42.000000', 'consum', 0.0223, 'lps'),
	(539230, 128, '2014-02-15 01:04:43.000000', 'consum', 0.0213, 'lps'),
	(539231, 128, '2014-02-15 01:04:44.000000', 'consum', 0.0219, 'lps'),
	(539232, 128, '2014-02-15 01:04:45.000000', 'consum', 0.0212, 'lps'),
	(539233, 128, '2014-02-15 01:04:46.000000', 'consum', 0.0213, 'lps'),
	(539234, 128, '2014-02-15 01:04:47.000000', 'consum', 0.0220, 'lps'),
	(539235, 128, '2014-02-15 01:04:48.000000', 'consum', 0.0215, 'lps'),
	(539236, 128, '2014-02-15 01:04:49.000000', 'consum', 0.0222, 'lps'),
	(539237, 128, '2014-02-15 01:04:50.000000', 'consum', 0.0224, 'lps'),
	(539238, 128, '2014-02-15 01:04:51.000000', 'consum', 0.0210, 'lps'),
	(539239, 128, '2014-02-15 01:04:52.000000', 'consum', 0.0218, 'lps'),
	(539240, 128, '2014-02-15 01:04:53.000000', 'consum', 0.0216, 'lps'),
	(539241, 128, '2014-02-15 01:04:54.000000', 'consum', 0.0216, 'lps'),
	(539242, 128, '2014-02-15 01:04:55.000000', 'consum', 0.0224, 'lps'),
	(539243, 128, '2014-02-15 01:04:56.000000', 'consum', 0.0213, 'lps'),
	(539244, 128, '2014-02-15 01:04:57.000000', 'consum', 0.0216, 'lps'),
	(539245, 128, '2014-02-15 01:04:58.000000', 'consum', 0.0213, 'lps'),
	(539246, 128, '2014-02-15 01:04:59.000000', 'consum', 0.0210, 'lps'),
	(539247, 128, '2014-02-15 01:05:00.000000', 'consum', 0.0218, 'lps'),
	(539248, 128, '2014-02-15 01:05:01.000000', 'consum', 0.0216, 'lps'),
	(539249, 128, '2014-02-15 01:05:02.000000', 'consum', 0.0215, 'lps'),
	(539250, 128, '2014-02-15 01:05:03.000000', 'consum', 0.0219, 'lps'),
	(539251, 128, '2014-02-15 01:05:04.000000', 'consum', 0.0223, 'lps'),
	(539252, 128, '2014-02-15 01:05:05.000000', 'consum', 0.0215, 'lps'),
	(539253, 128, '2014-02-15 01:05:06.000000', 'consum', 0.0213, 'lps'),
	(539254, 128, '2014-02-15 01:05:07.000000', 'consum', 0.0211, 'lps'),
	(539255, 128, '2014-02-15 01:05:08.000000', 'consum', 0.0223, 'lps'),
	(539256, 128, '2014-02-15 01:05:09.000000', 'consum', 0.0220, 'lps'),
	(539257, 128, '2014-02-15 01:05:10.000000', 'consum', 0.0223, 'lps'),
	(539258, 128, '2014-02-15 01:05:11.000000', 'consum', 0.0211, 'lps'),
	(539259, 128, '2014-02-15 01:05:12.000000', 'consum', 0.0210, 'lps'),
	(539260, 128, '2014-02-15 01:05:13.000000', 'consum', 0.0224, 'lps'),
	(539261, 128, '2014-02-15 01:05:14.000000', 'consum', 0.0213, 'lps'),
	(539262, 128, '2014-02-15 01:05:15.000000', 'consum', 0.0218, 'lps'),
	(539263, 128, '2014-02-15 01:05:16.000000', 'consum', 0.0226, 'lps'),
	(539264, 128, '2014-02-15 01:05:17.000000', 'consum', 0.0214, 'lps'),
	(539265, 128, '2014-02-15 01:05:18.000000', 'consum', 0.0218, 'lps'),
	(539266, 128, '2014-02-15 01:05:19.000000', 'consum', 0.0219, 'lps'),
	(539267, 128, '2014-02-15 01:05:20.000000', 'consum', 0.0214, 'lps'),
	(539268, 128, '2014-02-15 01:05:21.000000', 'consum', 0.0223, 'lps'),
	(539269, 128, '2014-02-15 01:05:22.000000', 'consum', 0.0213, 'lps'),
	(539270, 128, '2014-02-15 01:05:23.000000', 'consum', 0.0221, 'lps'),
	(539271, 128, '2014-02-15 01:05:24.000000', 'consum', 0.0222, 'lps'),
	(539272, 128, '2014-02-15 01:05:25.000000', 'consum', 0.0221, 'lps'),
	(539273, 128, '2014-02-15 01:05:26.000000', 'consum', 0.0213, 'lps'),
	(539274, 128, '2014-02-15 01:05:27.000000', 'consum', 0.0225, 'lps'),
	(539275, 128, '2014-02-15 01:05:28.000000', 'consum', 0.0226, 'lps'),
	(539276, 128, '2014-02-15 01:05:29.000000', 'consum', 0.0212, 'lps'),
	(539277, 128, '2014-02-15 01:05:30.000000', 'consum', 0.0222, 'lps'),
	(539278, 128, '2014-02-15 01:05:31.000000', 'consum', 0.0213, 'lps'),
	(539279, 128, '2014-02-15 01:05:32.000000', 'consum', 0.0222, 'lps'),
	(539280, 128, '2014-02-15 01:05:33.000000', 'consum', 0.0213, 'lps'),
	(539281, 128, '2014-02-15 01:05:34.000000', 'consum', 0.0224, 'lps'),
	(539282, 128, '2014-02-15 01:05:35.000000', 'consum', 0.0221, 'lps'),
	(539283, 128, '2014-02-15 01:05:36.000000', 'consum', 0.0224, 'lps'),
	(539284, 128, '2014-02-15 01:05:37.000000', 'consum', 0.0211, 'lps'),
	(539285, 128, '2014-02-15 01:05:38.000000', 'consum', 0.0225, 'lps'),
	(539286, 128, '2014-02-15 01:05:39.000000', 'consum', 0.0215, 'lps'),
	(539287, 128, '2014-02-15 01:05:40.000000', 'consum', 0.0224, 'lps'),
	(539288, 128, '2014-02-15 01:05:41.000000', 'consum', 0.0216, 'lps'),
	(539289, 128, '2014-02-15 01:05:42.000000', 'consum', 0.0214, 'lps'),
	(539290, 128, '2014-02-15 01:05:43.000000', 'consum', 0.0213, 'lps'),
	(539291, 128, '2014-02-15 01:05:44.000000', 'consum', 0.0215, 'lps'),
	(539292, 128, '2014-02-15 01:05:45.000000', 'consum', 0.0211, 'lps'),
	(539293, 128, '2014-02-15 01:05:46.000000', 'consum', 0.0214, 'lps'),
	(539294, 128, '2014-02-15 01:05:47.000000', 'consum', 0.0211, 'lps'),
	(539295, 128, '2014-02-15 01:05:48.000000', 'consum', 0.0221, 'lps'),
	(539296, 128, '2014-02-15 01:05:49.000000', 'consum', 0.0212, 'lps'),
	(539297, 128, '2014-02-15 01:05:50.000000', 'consum', 0.0222, 'lps'),
	(539298, 128, '2014-02-15 01:05:51.000000', 'consum', 0.0213, 'lps'),
	(539299, 128, '2014-02-15 01:05:52.000000', 'consum', 0.0222, 'lps'),
	(539300, 128, '2014-02-15 01:05:53.000000', 'consum', 0.0226, 'lps'),
	(539301, 128, '2014-02-15 01:05:54.000000', 'consum', 0.0224, 'lps'),
	(539302, 128, '2014-02-15 01:05:55.000000', 'consum', 0.0214, 'lps'),
	(539303, 128, '2014-02-15 01:05:56.000000', 'consum', 0.0223, 'lps'),
	(539304, 128, '2014-02-15 01:05:57.000000', 'consum', 0.0213, 'lps'),
	(539305, 128, '2014-02-15 01:05:58.000000', 'consum', 0.0220, 'lps'),
	(539306, 128, '2014-02-15 01:05:59.000000', 'consum', 0.0218, 'lps'),
	(539307, 128, '2014-02-15 01:06:00.000000', 'consum', 0.0218, 'lps'),
	(539308, 128, '2014-02-15 01:06:01.000000', 'consum', 0.0212, 'lps'),
	(539309, 128, '2014-02-15 01:06:02.000000', 'consum', 0.0212, 'lps'),
	(539310, 128, '2014-02-15 01:06:03.000000', 'consum', 0.0214, 'lps'),
	(539311, 128, '2014-02-15 01:06:04.000000', 'consum', 0.0225, 'lps'),
	(539312, 128, '2014-02-15 01:06:05.000000', 'consum', 0.0221, 'lps'),
	(539313, 128, '2014-02-15 01:06:06.000000', 'consum', 0.0221, 'lps'),
	(539314, 128, '2014-02-15 01:06:07.000000', 'consum', 0.0218, 'lps'),
	(539315, 128, '2014-02-15 01:06:08.000000', 'consum', 0.0216, 'lps'),
	(539316, 128, '2014-02-15 01:06:09.000000', 'consum', 0.0217, 'lps'),
	(539317, 128, '2014-02-15 01:06:10.000000', 'consum', 0.0211, 'lps'),
	(539318, 128, '2014-02-15 01:06:11.000000', 'consum', 0.0226, 'lps'),
	(539319, 128, '2014-02-15 01:06:12.000000', 'consum', 0.0221, 'lps'),
	(539320, 128, '2014-02-15 01:06:13.000000', 'consum', 0.0219, 'lps'),
	(539321, 128, '2014-02-15 01:06:14.000000', 'consum', 0.0223, 'lps'),
	(539322, 128, '2014-02-15 01:06:15.000000', 'consum', 0.0215, 'lps'),
	(539323, 128, '2014-02-15 01:06:16.000000', 'consum', 0.0213, 'lps'),
	(539324, 128, '2014-02-15 01:06:17.000000', 'consum', 0.0210, 'lps'),
	(539325, 128, '2014-02-15 01:06:18.000000', 'consum', 0.0220, 'lps'),
	(539326, 128, '2014-02-15 01:06:19.000000', 'consum', 0.0224, 'lps'),
	(539327, 128, '2014-02-15 01:06:20.000000', 'consum', 0.0215, 'lps'),
	(539328, 128, '2014-02-15 01:06:21.000000', 'consum', 0.0214, 'lps'),
	(539329, 128, '2014-02-15 01:06:22.000000', 'consum', 0.0215, 'lps'),
	(539330, 128, '2014-02-15 01:06:23.000000', 'consum', 0.0225, 'lps'),
	(539331, 128, '2014-02-15 01:06:24.000000', 'consum', 0.0216, 'lps'),
	(539332, 128, '2014-02-15 01:06:25.000000', 'consum', 0.0216, 'lps'),
	(539333, 128, '2014-02-15 01:06:26.000000', 'consum', 0.0220, 'lps'),
	(539334, 128, '2014-02-15 01:06:27.000000', 'consum', 0.0210, 'lps'),
	(539335, 128, '2014-02-15 01:06:28.000000', 'consum', 0.0215, 'lps'),
	(539336, 128, '2014-02-15 01:06:29.000000', 'consum', 0.0217, 'lps'),
	(539337, 128, '2014-02-15 01:06:30.000000', 'consum', 0.0216, 'lps'),
	(539338, 128, '2014-02-15 01:06:31.000000', 'consum', 0.0216, 'lps'),
	(539339, 128, '2014-02-15 01:06:32.000000', 'consum', 0.0225, 'lps'),
	(539340, 128, '2014-02-15 01:06:33.000000', 'consum', 0.0217, 'lps'),
	(539341, 128, '2014-02-15 01:06:34.000000', 'consum', 0.0219, 'lps'),
	(539342, 128, '2014-02-15 01:06:35.000000', 'consum', 0.0214, 'lps'),
	(539343, 128, '2014-02-15 01:06:36.000000', 'consum', 0.0221, 'lps'),
	(539344, 128, '2014-02-15 01:06:37.000000', 'consum', 0.0221, 'lps'),
	(539345, 128, '2014-02-15 01:06:38.000000', 'consum', 0.0213, 'lps'),
	(539346, 128, '2014-02-15 01:06:39.000000', 'consum', 0.0211, 'lps'),
	(539347, 128, '2014-02-15 01:06:40.000000', 'consum', 0.0223, 'lps'),
	(539348, 128, '2014-02-15 01:06:41.000000', 'consum', 0.0220, 'lps'),
	(539349, 128, '2014-02-15 01:06:42.000000', 'consum', 0.0224, 'lps'),
	(539350, 128, '2014-02-15 01:06:43.000000', 'consum', 0.0216, 'lps'),
	(539351, 128, '2014-02-15 01:06:44.000000', 'consum', 0.0215, 'lps'),
	(539352, 128, '2014-02-15 01:06:45.000000', 'consum', 0.0218, 'lps'),
	(539353, 128, '2014-02-15 01:06:46.000000', 'consum', 0.0219, 'lps'),
	(539354, 128, '2014-02-15 01:06:47.000000', 'consum', 0.0214, 'lps'),
	(539355, 128, '2014-02-15 01:06:48.000000', 'consum', 0.0223, 'lps'),
	(539356, 128, '2014-02-15 01:06:49.000000', 'consum', 0.0226, 'lps'),
	(539357, 128, '2014-02-15 01:06:50.000000', 'consum', 0.0219, 'lps'),
	(539358, 128, '2014-02-15 01:06:51.000000', 'consum', 0.0224, 'lps'),
	(539359, 128, '2014-02-15 01:06:52.000000', 'consum', 0.0218, 'lps'),
	(539360, 128, '2014-02-15 01:06:53.000000', 'consum', 0.0211, 'lps'),
	(539361, 128, '2014-02-15 01:06:54.000000', 'consum', 0.0224, 'lps'),
	(539362, 128, '2014-02-15 01:06:55.000000', 'consum', 0.0211, 'lps'),
	(539363, 128, '2014-02-15 01:06:56.000000', 'consum', 0.0223, 'lps'),
	(539364, 128, '2014-02-15 01:06:57.000000', 'consum', 0.0222, 'lps'),
	(539365, 128, '2014-02-15 01:06:58.000000', 'consum', 0.0215, 'lps'),
	(539366, 128, '2014-02-15 01:06:59.000000', 'consum', 0.0217, 'lps'),
	(539367, 128, '2014-02-15 01:07:00.000000', 'consum', 0.0213, 'lps'),
	(539368, 128, '2014-02-15 01:07:01.000000', 'consum', 0.0220, 'lps'),
	(539369, 128, '2014-02-15 01:07:02.000000', 'consum', 0.0220, 'lps'),
	(539370, 128, '2014-02-15 01:07:03.000000', 'consum', 0.0211, 'lps'),
	(539371, 128, '2014-02-15 01:07:04.000000', 'consum', 0.0219, 'lps'),
	(539372, 128, '2014-02-15 01:07:05.000000', 'consum', 0.0218, 'lps'),
	(539373, 128, '2014-02-15 01:07:06.000000', 'consum', 0.0210, 'lps'),
	(539374, 128, '2014-02-15 01:07:07.000000', 'consum', 0.0218, 'lps'),
	(539375, 128, '2014-02-15 01:07:08.000000', 'consum', 0.0215, 'lps'),
	(539376, 128, '2014-02-15 01:07:09.000000', 'consum', 0.0214, 'lps'),
	(539377, 128, '2014-02-15 01:07:10.000000', 'consum', 0.0213, 'lps'),
	(539378, 128, '2014-02-15 01:07:11.000000', 'consum', 0.0216, 'lps'),
	(539379, 128, '2014-02-15 01:07:12.000000', 'consum', 0.0213, 'lps'),
	(539380, 128, '2014-02-15 01:07:13.000000', 'consum', 0.0224, 'lps'),
	(539381, 128, '2014-02-15 01:07:14.000000', 'consum', 0.0221, 'lps'),
	(539382, 128, '2014-02-15 01:07:15.000000', 'consum', 0.0224, 'lps'),
	(539383, 128, '2014-02-15 01:07:16.000000', 'consum', 0.0213, 'lps'),
	(539384, 128, '2014-02-15 01:07:17.000000', 'consum', 0.0217, 'lps'),
	(539385, 128, '2014-02-15 01:07:18.000000', 'consum', 0.0221, 'lps'),
	(539386, 128, '2014-02-15 01:07:19.000000', 'consum', 0.0212, 'lps'),
	(539387, 128, '2014-02-15 01:07:20.000000', 'consum', 0.0220, 'lps'),
	(539388, 128, '2014-02-15 01:07:21.000000', 'consum', 0.0218, 'lps'),
	(539389, 128, '2014-02-15 01:07:22.000000', 'consum', 0.0224, 'lps'),
	(539390, 128, '2014-02-15 01:07:23.000000', 'consum', 0.0220, 'lps'),
	(539391, 128, '2014-02-15 01:07:24.000000', 'consum', 0.0218, 'lps'),
	(539392, 128, '2014-02-15 01:07:25.000000', 'consum', 0.0222, 'lps'),
	(539393, 128, '2014-02-15 01:07:26.000000', 'consum', 0.0211, 'lps'),
	(539394, 128, '2014-02-15 01:07:27.000000', 'consum', 0.0214, 'lps'),
	(539395, 128, '2014-02-15 01:07:28.000000', 'consum', 0.0212, 'lps'),
	(539396, 128, '2014-02-15 01:07:29.000000', 'consum', 0.0223, 'lps'),
	(539397, 128, '2014-02-15 01:07:30.000000', 'consum', 0.0222, 'lps'),
	(539398, 128, '2014-02-15 01:07:31.000000', 'consum', 0.0211, 'lps'),
	(539399, 128, '2014-02-15 01:07:32.000000', 'consum', 0.0215, 'lps'),
	(539400, 128, '2014-02-15 01:07:33.000000', 'consum', 0.0216, 'lps'),
	(539401, 128, '2014-02-15 01:07:34.000000', 'consum', 0.0224, 'lps'),
	(539402, 128, '2014-02-15 01:07:35.000000', 'consum', 0.0213, 'lps'),
	(539403, 128, '2014-02-15 01:07:36.000000', 'consum', 0.0217, 'lps'),
	(539404, 128, '2014-02-15 01:07:37.000000', 'consum', 0.0220, 'lps'),
	(539405, 128, '2014-02-15 01:07:38.000000', 'consum', 0.0221, 'lps'),
	(539406, 128, '2014-02-15 01:07:39.000000', 'consum', 0.0218, 'lps'),
	(539407, 128, '2014-02-15 01:07:40.000000', 'consum', 0.0220, 'lps'),
	(539408, 128, '2014-02-15 01:07:41.000000', 'consum', 0.0217, 'lps'),
	(539409, 128, '2014-02-15 01:07:42.000000', 'consum', 0.0218, 'lps'),
	(539410, 128, '2014-02-15 01:07:43.000000', 'consum', 0.0213, 'lps'),
	(539411, 128, '2014-02-15 01:07:44.000000', 'consum', 0.0216, 'lps'),
	(539412, 128, '2014-02-15 01:07:45.000000', 'consum', 0.0216, 'lps'),
	(539413, 128, '2014-02-15 01:07:46.000000', 'consum', 0.0224, 'lps'),
	(539414, 128, '2014-02-15 01:07:47.000000', 'consum', 0.0226, 'lps'),
	(539415, 128, '2014-02-15 01:07:48.000000', 'consum', 0.0215, 'lps'),
	(539416, 128, '2014-02-15 01:07:49.000000', 'consum', 0.0222, 'lps'),
	(539417, 128, '2014-02-15 01:07:50.000000', 'consum', 0.0221, 'lps'),
	(539418, 128, '2014-02-15 01:07:51.000000', 'consum', 0.0212, 'lps'),
	(539419, 128, '2014-02-15 01:07:52.000000', 'consum', 0.0224, 'lps'),
	(539420, 128, '2014-02-15 01:07:53.000000', 'consum', 0.0222, 'lps'),
	(539421, 128, '2014-02-15 01:07:54.000000', 'consum', 0.0213, 'lps'),
	(539422, 128, '2014-02-15 01:07:55.000000', 'consum', 0.0221, 'lps'),
	(539423, 128, '2014-02-15 01:07:56.000000', 'consum', 0.0223, 'lps'),
	(539424, 128, '2014-02-15 01:07:57.000000', 'consum', 0.0211, 'lps'),
	(539425, 128, '2014-02-15 01:07:58.000000', 'consum', 0.0224, 'lps'),
	(539426, 128, '2014-02-15 01:07:59.000000', 'consum', 0.0213, 'lps'),
	(539427, 128, '2014-02-15 01:08:00.000000', 'consum', 0.0215, 'lps'),
	(539428, 128, '2014-02-15 01:08:01.000000', 'consum', 0.0212, 'lps'),
	(539429, 128, '2014-02-15 01:08:02.000000', 'consum', 0.0221, 'lps'),
	(539430, 128, '2014-02-15 01:08:03.000000', 'consum', 0.0224, 'lps'),
	(539431, 128, '2014-02-15 01:08:04.000000', 'consum', 0.0214, 'lps'),
	(539432, 128, '2014-02-15 01:08:05.000000', 'consum', 0.0222, 'lps'),
	(539433, 128, '2014-02-15 01:08:06.000000', 'consum', 0.0224, 'lps'),
	(539434, 128, '2014-02-15 01:08:07.000000', 'consum', 0.0213, 'lps'),
	(539435, 128, '2014-02-15 01:08:08.000000', 'consum', 0.0218, 'lps'),
	(539436, 128, '2014-02-15 01:08:09.000000', 'consum', 0.0224, 'lps'),
	(539437, 128, '2014-02-15 01:08:10.000000', 'consum', 0.0224, 'lps'),
	(539438, 128, '2014-02-15 01:08:11.000000', 'consum', 0.0219, 'lps'),
	(539439, 128, '2014-02-15 01:08:12.000000', 'consum', 0.0216, 'lps'),
	(539440, 128, '2014-02-15 01:08:13.000000', 'consum', 0.0214, 'lps'),
	(539441, 128, '2014-02-15 01:08:14.000000', 'consum', 0.0210, 'lps'),
	(539442, 128, '2014-02-15 01:08:15.000000', 'consum', 0.0217, 'lps'),
	(539443, 128, '2014-02-15 01:08:16.000000', 'consum', 0.0210, 'lps'),
	(539444, 128, '2014-02-15 01:08:17.000000', 'consum', 0.0222, 'lps'),
	(539445, 128, '2014-02-15 01:08:18.000000', 'consum', 0.0222, 'lps'),
	(539446, 128, '2014-02-15 01:08:19.000000', 'consum', 0.0216, 'lps'),
	(539447, 128, '2014-02-15 01:08:20.000000', 'consum', 0.0222, 'lps'),
	(539448, 128, '2014-02-15 01:08:21.000000', 'consum', 0.0219, 'lps'),
	(539449, 128, '2014-02-15 01:08:22.000000', 'consum', 0.0221, 'lps'),
	(539450, 128, '2014-02-15 01:08:23.000000', 'consum', 0.0220, 'lps'),
	(539451, 128, '2014-02-15 01:08:24.000000', 'consum', 0.0226, 'lps'),
	(539452, 128, '2014-02-15 01:08:25.000000', 'consum', 0.0226, 'lps'),
	(539453, 128, '2014-02-15 01:08:26.000000', 'consum', 0.0211, 'lps'),
	(539454, 128, '2014-02-15 01:08:27.000000', 'consum', 0.0218, 'lps'),
	(539455, 128, '2014-02-15 01:08:28.000000', 'consum', 0.0214, 'lps'),
	(539456, 128, '2014-02-15 01:08:29.000000', 'consum', 0.0225, 'lps'),
	(539457, 128, '2014-02-15 01:08:30.000000', 'consum', 0.0220, 'lps'),
	(539458, 128, '2014-02-15 01:08:31.000000', 'consum', 0.0217, 'lps'),
	(539459, 128, '2014-02-15 01:08:32.000000', 'consum', 0.0217, 'lps'),
	(539460, 128, '2014-02-15 01:08:33.000000', 'consum', 0.0222, 'lps'),
	(539461, 128, '2014-02-15 01:08:34.000000', 'consum', 0.0215, 'lps'),
	(539462, 128, '2014-02-15 01:08:35.000000', 'consum', 0.0218, 'lps'),
	(539463, 128, '2014-02-15 01:08:36.000000', 'consum', 0.0216, 'lps'),
	(539464, 128, '2014-02-15 01:08:37.000000', 'consum', 0.0218, 'lps'),
	(539465, 128, '2014-02-15 01:08:38.000000', 'consum', 0.0217, 'lps'),
	(539466, 128, '2014-02-15 01:08:39.000000', 'consum', 0.0221, 'lps'),
	(539467, 128, '2014-02-15 01:08:40.000000', 'consum', 0.0225, 'lps'),
	(539468, 128, '2014-02-15 01:08:41.000000', 'consum', 0.0220, 'lps'),
	(539469, 128, '2014-02-15 01:08:42.000000', 'consum', 0.0215, 'lps'),
	(539470, 128, '2014-02-15 01:08:43.000000', 'consum', 0.0224, 'lps'),
	(539471, 128, '2014-02-15 01:08:44.000000', 'consum', 0.0216, 'lps'),
	(539472, 128, '2014-02-15 01:08:45.000000', 'consum', 0.0213, 'lps'),
	(539473, 128, '2014-02-15 01:08:46.000000', 'consum', 0.0223, 'lps'),
	(539474, 128, '2014-02-15 01:08:47.000000', 'consum', 0.0218, 'lps'),
	(539475, 128, '2014-02-15 01:08:48.000000', 'consum', 0.0210, 'lps'),
	(539476, 128, '2014-02-15 01:08:49.000000', 'consum', 0.0221, 'lps'),
	(539477, 128, '2014-02-15 01:08:50.000000', 'consum', 0.0213, 'lps'),
	(539478, 128, '2014-02-15 01:08:51.000000', 'consum', 0.0210, 'lps'),
	(539479, 128, '2014-02-15 01:08:52.000000', 'consum', 0.0220, 'lps'),
	(539480, 128, '2014-02-15 01:08:53.000000', 'consum', 0.0224, 'lps'),
	(539481, 128, '2014-02-15 01:08:54.000000', 'consum', 0.0217, 'lps'),
	(539482, 128, '2014-02-15 01:08:55.000000', 'consum', 0.0220, 'lps'),
	(539483, 128, '2014-02-15 01:08:56.000000', 'consum', 0.0223, 'lps'),
	(539484, 128, '2014-02-15 01:08:57.000000', 'consum', 0.0211, 'lps'),
	(539485, 128, '2014-02-15 01:08:58.000000', 'consum', 0.0210, 'lps'),
	(539486, 128, '2014-02-15 01:08:59.000000', 'consum', 0.0224, 'lps'),
	(539487, 128, '2014-02-15 01:09:00.000000', 'consum', 0.0212, 'lps'),
	(539488, 128, '2014-02-15 01:09:01.000000', 'consum', 0.0212, 'lps'),
	(539489, 128, '2014-02-15 01:09:02.000000', 'consum', 0.0214, 'lps'),
	(539490, 128, '2014-02-15 01:09:03.000000', 'consum', 0.0225, 'lps'),
	(539491, 128, '2014-02-15 01:09:04.000000', 'consum', 0.0225, 'lps'),
	(539492, 128, '2014-02-15 01:09:05.000000', 'consum', 0.0222, 'lps'),
	(539493, 128, '2014-02-15 01:09:06.000000', 'consum', 0.0224, 'lps'),
	(539494, 128, '2014-02-15 01:09:07.000000', 'consum', 0.0213, 'lps'),
	(539495, 128, '2014-02-15 01:09:08.000000', 'consum', 0.0218, 'lps'),
	(539496, 128, '2014-02-15 01:09:09.000000', 'consum', 0.0222, 'lps'),
	(539497, 128, '2014-02-15 01:09:10.000000', 'consum', 0.0212, 'lps'),
	(539498, 128, '2014-02-15 01:09:11.000000', 'consum', 0.0221, 'lps'),
	(539499, 128, '2014-02-15 01:09:12.000000', 'consum', 0.0223, 'lps'),
	(539500, 128, '2014-02-15 01:09:13.000000', 'consum', 0.0211, 'lps'),
	(539501, 128, '2014-02-15 01:09:14.000000', 'consum', 0.0211, 'lps'),
	(539502, 128, '2014-02-15 01:09:15.000000', 'consum', 0.0213, 'lps'),
	(539503, 128, '2014-02-15 01:09:16.000000', 'consum', 0.0220, 'lps'),
	(539504, 128, '2014-02-15 01:09:17.000000', 'consum', 0.0219, 'lps'),
	(539505, 128, '2014-02-15 01:09:18.000000', 'consum', 0.0226, 'lps'),
	(539506, 128, '2014-02-15 01:09:19.000000', 'consum', 0.0210, 'lps'),
	(539507, 128, '2014-02-15 01:09:20.000000', 'consum', 0.0215, 'lps'),
	(539508, 128, '2014-02-15 01:09:21.000000', 'consum', 0.0218, 'lps'),
	(539509, 128, '2014-02-15 01:09:22.000000', 'consum', 0.0219, 'lps'),
	(539510, 128, '2014-02-15 01:09:23.000000', 'consum', 0.0215, 'lps'),
	(539511, 128, '2014-02-15 01:09:24.000000', 'consum', 0.0210, 'lps'),
	(539512, 128, '2014-02-15 01:09:25.000000', 'consum', 0.0226, 'lps'),
	(539513, 128, '2014-02-15 01:09:26.000000', 'consum', 0.0225, 'lps'),
	(539514, 128, '2014-02-15 01:09:27.000000', 'consum', 0.0220, 'lps'),
	(539515, 128, '2014-02-15 01:09:28.000000', 'consum', 0.0217, 'lps'),
	(539516, 128, '2014-02-15 01:09:29.000000', 'consum', 0.0216, 'lps'),
	(539517, 128, '2014-02-15 01:09:30.000000', 'consum', 0.0219, 'lps'),
	(539518, 128, '2014-02-15 01:09:31.000000', 'consum', 0.0219, 'lps'),
	(539519, 128, '2014-02-15 01:09:32.000000', 'consum', 0.0214, 'lps'),
	(539520, 128, '2014-02-15 01:09:33.000000', 'consum', 0.0220, 'lps'),
	(539521, 128, '2014-02-15 01:09:34.000000', 'consum', 0.0212, 'lps'),
	(539522, 128, '2014-02-15 01:09:35.000000', 'consum', 0.0211, 'lps'),
	(539523, 128, '2014-02-15 01:09:36.000000', 'consum', 0.0223, 'lps'),
	(539524, 128, '2014-02-15 01:09:37.000000', 'consum', 0.0225, 'lps'),
	(539525, 128, '2014-02-15 01:09:38.000000', 'consum', 0.0226, 'lps'),
	(539526, 128, '2014-02-15 01:09:39.000000', 'consum', 0.0214, 'lps'),
	(539527, 128, '2014-02-15 01:09:40.000000', 'consum', 0.0215, 'lps'),
	(539528, 128, '2014-02-15 01:09:41.000000', 'consum', 0.0223, 'lps'),
	(539529, 128, '2014-02-15 01:09:42.000000', 'consum', 0.0211, 'lps'),
	(539530, 128, '2014-02-15 01:09:43.000000', 'consum', 0.0226, 'lps'),
	(539531, 128, '2014-02-15 01:09:44.000000', 'consum', 0.0219, 'lps'),
	(539532, 128, '2014-02-15 01:09:45.000000', 'consum', 0.0224, 'lps'),
	(539533, 128, '2014-02-15 01:09:46.000000', 'consum', 0.0220, 'lps'),
	(539534, 128, '2014-02-15 01:09:47.000000', 'consum', 0.0219, 'lps'),
	(539535, 128, '2014-02-15 01:09:48.000000', 'consum', 0.0225, 'lps'),
	(539536, 128, '2014-02-15 01:09:49.000000', 'consum', 0.0224, 'lps'),
	(539537, 128, '2014-02-15 01:09:50.000000', 'consum', 0.0218, 'lps'),
	(539538, 128, '2014-02-15 01:09:51.000000', 'consum', 0.0224, 'lps'),
	(539539, 128, '2014-02-15 01:09:52.000000', 'consum', 0.0226, 'lps'),
	(539540, 128, '2014-02-15 01:09:53.000000', 'consum', 0.0212, 'lps'),
	(539541, 128, '2014-02-15 01:09:54.000000', 'consum', 0.0225, 'lps'),
	(539542, 128, '2014-02-15 01:09:55.000000', 'consum', 0.0211, 'lps'),
	(539543, 128, '2014-02-15 01:09:56.000000', 'consum', 0.0222, 'lps'),
	(539544, 128, '2014-02-15 01:09:57.000000', 'consum', 0.0214, 'lps'),
	(539545, 128, '2014-02-15 01:09:58.000000', 'consum', 0.0215, 'lps'),
	(539546, 128, '2014-02-15 01:09:59.000000', 'consum', 0.0220, 'lps'),
	(539547, 128, '2014-02-15 01:10:00.000000', 'consum', 0.0213, 'lps'),
	(539548, 128, '2014-02-15 01:10:01.000000', 'consum', 0.0212, 'lps'),
	(539549, 128, '2014-02-15 01:10:02.000000', 'consum', 0.0210, 'lps'),
	(539550, 128, '2014-02-15 01:10:03.000000', 'consum', 0.0224, 'lps'),
	(539551, 128, '2014-02-15 01:10:04.000000', 'consum', 0.0210, 'lps'),
	(539552, 128, '2014-02-15 01:10:05.000000', 'consum', 0.0221, 'lps'),
	(539553, 128, '2014-02-15 01:10:06.000000', 'consum', 0.0213, 'lps'),
	(539554, 128, '2014-02-15 01:10:07.000000', 'consum', 0.0210, 'lps'),
	(539555, 128, '2014-02-15 01:10:08.000000', 'consum', 0.0219, 'lps'),
	(539556, 128, '2014-02-15 01:10:09.000000', 'consum', 0.0220, 'lps'),
	(539557, 128, '2014-02-15 01:10:10.000000', 'consum', 0.0217, 'lps'),
	(539558, 128, '2014-02-15 01:10:11.000000', 'consum', 0.0216, 'lps'),
	(539559, 128, '2014-02-15 01:10:12.000000', 'consum', 0.0221, 'lps'),
	(539560, 128, '2014-02-15 01:10:13.000000', 'consum', 0.0213, 'lps'),
	(539561, 128, '2014-02-15 01:10:14.000000', 'consum', 0.0210, 'lps'),
	(539562, 128, '2014-02-15 01:10:15.000000', 'consum', 0.0219, 'lps'),
	(539563, 128, '2014-02-15 01:10:16.000000', 'consum', 0.0222, 'lps'),
	(539564, 128, '2014-02-15 01:10:17.000000', 'consum', 0.0225, 'lps'),
	(539565, 128, '2014-02-15 01:10:18.000000', 'consum', 0.0218, 'lps'),
	(539566, 128, '2014-02-15 01:10:19.000000', 'consum', 0.0219, 'lps'),
	(539567, 128, '2014-02-15 01:10:20.000000', 'consum', 0.0218, 'lps'),
	(539568, 128, '2014-02-15 01:10:21.000000', 'consum', 0.0221, 'lps'),
	(539569, 128, '2014-02-15 01:10:22.000000', 'consum', 0.0225, 'lps'),
	(539570, 128, '2014-02-15 01:10:23.000000', 'consum', 0.0217, 'lps'),
	(539571, 128, '2014-02-15 01:10:24.000000', 'consum', 0.0217, 'lps'),
	(539572, 128, '2014-02-15 01:10:25.000000', 'consum', 0.0224, 'lps'),
	(539573, 128, '2014-02-15 01:10:26.000000', 'consum', 0.0211, 'lps'),
	(539574, 128, '2014-02-15 01:10:27.000000', 'consum', 0.0222, 'lps'),
	(539575, 128, '2014-02-15 01:10:28.000000', 'consum', 0.0217, 'lps'),
	(539576, 128, '2014-02-15 01:10:29.000000', 'consum', 0.0212, 'lps'),
	(539577, 128, '2014-02-15 01:10:30.000000', 'consum', 0.0213, 'lps'),
	(539578, 128, '2014-02-15 01:10:31.000000', 'consum', 0.0221, 'lps'),
	(539579, 128, '2014-02-15 01:10:32.000000', 'consum', 0.0223, 'lps'),
	(539580, 128, '2014-02-15 01:10:33.000000', 'consum', 0.0225, 'lps'),
	(539581, 128, '2014-02-15 01:10:34.000000', 'consum', 0.0214, 'lps'),
	(539582, 128, '2014-02-15 01:10:35.000000', 'consum', 0.0218, 'lps'),
	(539583, 128, '2014-02-15 01:10:36.000000', 'consum', 0.0224, 'lps'),
	(539584, 128, '2014-02-15 01:10:37.000000', 'consum', 0.0219, 'lps'),
	(539585, 128, '2014-02-15 01:10:38.000000', 'consum', 0.0215, 'lps'),
	(539586, 128, '2014-02-15 01:10:39.000000', 'consum', 0.0224, 'lps'),
	(539587, 128, '2014-02-15 01:10:40.000000', 'consum', 0.0215, 'lps'),
	(539588, 128, '2014-02-15 01:10:41.000000', 'consum', 0.0226, 'lps'),
	(539589, 128, '2014-02-15 01:10:42.000000', 'consum', 0.0211, 'lps'),
	(539590, 128, '2014-02-15 01:10:43.000000', 'consum', 0.0215, 'lps'),
	(539591, 128, '2014-02-15 01:10:44.000000', 'consum', 0.0217, 'lps'),
	(539592, 128, '2014-02-15 01:10:45.000000', 'consum', 0.0213, 'lps'),
	(539593, 128, '2014-02-15 01:10:46.000000', 'consum', 0.0223, 'lps'),
	(539594, 128, '2014-02-15 01:10:47.000000', 'consum', 0.0216, 'lps'),
	(539595, 128, '2014-02-15 01:10:48.000000', 'consum', 0.0216, 'lps'),
	(539596, 128, '2014-02-15 01:10:49.000000', 'consum', 0.0221, 'lps'),
	(539597, 128, '2014-02-15 01:10:50.000000', 'consum', 0.0217, 'lps'),
	(539598, 128, '2014-02-15 01:10:51.000000', 'consum', 0.0213, 'lps'),
	(539599, 128, '2014-02-15 01:10:52.000000', 'consum', 0.0220, 'lps'),
	(539600, 128, '2014-02-15 01:10:53.000000', 'consum', 0.0220, 'lps'),
	(539601, 128, '2014-02-15 01:10:54.000000', 'consum', 0.0211, 'lps'),
	(539602, 128, '2014-02-15 01:10:55.000000', 'consum', 0.0220, 'lps'),
	(539603, 128, '2014-02-15 01:10:56.000000', 'consum', 0.0222, 'lps'),
	(539604, 128, '2014-02-15 01:10:57.000000', 'consum', 0.0224, 'lps'),
	(539605, 128, '2014-02-15 01:10:58.000000', 'consum', 0.0210, 'lps'),
	(539606, 128, '2014-02-15 01:10:59.000000', 'consum', 0.0222, 'lps'),
	(539607, 128, '2014-02-15 01:11:00.000000', 'consum', 0.0218, 'lps'),
	(539608, 128, '2014-02-15 01:11:01.000000', 'consum', 0.0214, 'lps'),
	(539609, 128, '2014-02-15 01:11:02.000000', 'consum', 0.0224, 'lps'),
	(539610, 128, '2014-02-15 01:11:03.000000', 'consum', 0.0217, 'lps'),
	(539611, 128, '2014-02-15 01:11:04.000000', 'consum', 0.0219, 'lps'),
	(539612, 128, '2014-02-15 01:11:05.000000', 'consum', 0.0220, 'lps'),
	(539613, 128, '2014-02-15 01:11:06.000000', 'consum', 0.0217, 'lps'),
	(539614, 128, '2014-02-15 01:11:07.000000', 'consum', 0.0215, 'lps'),
	(539615, 128, '2014-02-15 01:11:08.000000', 'consum', 0.0213, 'lps'),
	(539616, 128, '2014-02-15 01:11:09.000000', 'consum', 0.0212, 'lps'),
	(539617, 128, '2014-02-15 01:11:10.000000', 'consum', 0.0212, 'lps'),
	(539618, 128, '2014-02-15 01:11:11.000000', 'consum', 0.0212, 'lps'),
	(539619, 128, '2014-02-15 01:11:12.000000', 'consum', 0.0216, 'lps'),
	(539620, 128, '2014-02-15 01:11:13.000000', 'consum', 0.0216, 'lps'),
	(539621, 128, '2014-02-15 01:11:14.000000', 'consum', 0.0223, 'lps'),
	(539622, 128, '2014-02-15 01:11:15.000000', 'consum', 0.0224, 'lps'),
	(539623, 128, '2014-02-15 01:11:16.000000', 'consum', 0.0225, 'lps'),
	(539624, 128, '2014-02-15 01:11:17.000000', 'consum', 0.0225, 'lps'),
	(539625, 128, '2014-02-15 01:11:18.000000', 'consum', 0.0226, 'lps'),
	(539626, 128, '2014-02-15 01:11:19.000000', 'consum', 0.0226, 'lps'),
	(539627, 128, '2014-02-15 01:11:20.000000', 'consum', 0.0225, 'lps'),
	(539628, 128, '2014-02-15 01:11:21.000000', 'consum', 0.0224, 'lps'),
	(539629, 128, '2014-02-15 01:11:22.000000', 'consum', 0.0215, 'lps'),
	(539630, 128, '2014-02-15 01:11:23.000000', 'consum', 0.0210, 'lps'),
	(539631, 128, '2014-02-15 01:11:24.000000', 'consum', 0.0214, 'lps'),
	(539632, 128, '2014-02-15 01:11:25.000000', 'consum', 0.0212, 'lps'),
	(539633, 128, '2014-02-15 01:11:26.000000', 'consum', 0.0226, 'lps'),
	(539634, 128, '2014-02-15 01:11:27.000000', 'consum', 0.0216, 'lps'),
	(539635, 128, '2014-02-15 01:11:28.000000', 'consum', 0.0211, 'lps'),
	(539636, 128, '2014-02-15 01:11:29.000000', 'consum', 0.0215, 'lps'),
	(539637, 128, '2014-02-15 01:11:30.000000', 'consum', 0.0215, 'lps'),
	(539638, 128, '2014-02-15 01:11:31.000000', 'consum', 0.0218, 'lps'),
	(539639, 128, '2014-02-15 01:11:32.000000', 'consum', 0.0222, 'lps'),
	(539640, 128, '2014-02-15 01:11:33.000000', 'consum', 0.0212, 'lps'),
	(539641, 128, '2014-02-15 01:11:34.000000', 'consum', 0.0218, 'lps'),
	(539642, 128, '2014-02-15 01:11:35.000000', 'consum', 0.0212, 'lps'),
	(539643, 128, '2014-02-15 01:11:36.000000', 'consum', 0.0210, 'lps'),
	(539644, 128, '2014-02-15 01:11:37.000000', 'consum', 0.0225, 'lps'),
	(539645, 128, '2014-02-15 01:11:38.000000', 'consum', 0.0217, 'lps'),
	(539646, 128, '2014-02-15 01:11:39.000000', 'consum', 0.0219, 'lps'),
	(539647, 128, '2014-02-15 01:11:40.000000', 'consum', 0.0214, 'lps'),
	(539648, 128, '2014-02-15 01:11:41.000000', 'consum', 0.0224, 'lps'),
	(539649, 128, '2014-02-15 01:11:42.000000', 'consum', 0.0215, 'lps'),
	(539650, 128, '2014-02-15 01:11:43.000000', 'consum', 0.0213, 'lps'),
	(539651, 128, '2014-02-15 01:11:44.000000', 'consum', 0.0210, 'lps'),
	(539652, 128, '2014-02-15 01:11:45.000000', 'consum', 0.0219, 'lps'),
	(539653, 128, '2014-02-15 01:11:46.000000', 'consum', 0.0219, 'lps'),
	(539654, 128, '2014-02-15 01:11:47.000000', 'consum', 0.0212, 'lps'),
	(539655, 128, '2014-02-15 01:11:48.000000', 'consum', 0.0210, 'lps'),
	(539656, 128, '2014-02-15 01:11:49.000000', 'consum', 0.0224, 'lps'),
	(539657, 128, '2014-02-15 01:11:50.000000', 'consum', 0.0212, 'lps'),
	(539658, 128, '2014-02-15 01:11:51.000000', 'consum', 0.0210, 'lps'),
	(539659, 128, '2014-02-15 01:11:52.000000', 'consum', 0.0225, 'lps'),
	(539660, 128, '2014-02-15 01:11:53.000000', 'consum', 0.0215, 'lps'),
	(539661, 128, '2014-02-15 01:11:54.000000', 'consum', 0.0210, 'lps'),
	(539662, 128, '2014-02-15 01:11:55.000000', 'consum', 0.0211, 'lps'),
	(539663, 128, '2014-02-15 01:11:56.000000', 'consum', 0.0217, 'lps'),
	(539664, 128, '2014-02-15 01:11:57.000000', 'consum', 0.0223, 'lps'),
	(539665, 128, '2014-02-15 01:11:58.000000', 'consum', 0.0222, 'lps'),
	(539666, 128, '2014-02-15 01:11:59.000000', 'consum', 0.0215, 'lps'),
	(539667, 128, '2014-02-15 01:12:00.000000', 'consum', 0.0216, 'lps'),
	(539668, 128, '2014-02-15 01:12:01.000000', 'consum', 0.0226, 'lps'),
	(539669, 128, '2014-02-15 01:12:02.000000', 'consum', 0.0221, 'lps'),
	(539670, 128, '2014-02-15 01:12:03.000000', 'consum', 0.0217, 'lps'),
	(539671, 128, '2014-02-15 01:12:04.000000', 'consum', 0.0212, 'lps'),
	(539672, 128, '2014-02-15 01:12:05.000000', 'consum', 0.0217, 'lps'),
	(539673, 128, '2014-02-15 01:12:06.000000', 'consum', 0.0222, 'lps'),
	(539674, 128, '2014-02-15 01:12:07.000000', 'consum', 0.0215, 'lps'),
	(539675, 128, '2014-02-15 01:12:08.000000', 'consum', 0.0218, 'lps'),
	(539676, 128, '2014-02-15 01:12:09.000000', 'consum', 0.0216, 'lps'),
	(539677, 128, '2014-02-15 01:12:10.000000', 'consum', 0.0220, 'lps'),
	(539678, 128, '2014-02-15 01:12:11.000000', 'consum', 0.0222, 'lps'),
	(539679, 128, '2014-02-15 01:12:12.000000', 'consum', 0.0224, 'lps'),
	(539680, 128, '2014-02-15 01:12:13.000000', 'consum', 0.0213, 'lps'),
	(539681, 128, '2014-02-15 01:12:14.000000', 'consum', 0.0215, 'lps'),
	(539682, 128, '2014-02-15 01:12:15.000000', 'consum', 0.0226, 'lps'),
	(539683, 128, '2014-02-15 01:12:16.000000', 'consum', 0.0225, 'lps'),
	(539684, 128, '2014-02-15 01:12:17.000000', 'consum', 0.0219, 'lps'),
	(539685, 128, '2014-02-15 01:12:18.000000', 'consum', 0.0211, 'lps'),
	(539686, 128, '2014-02-15 01:12:19.000000', 'consum', 0.0223, 'lps'),
	(539687, 128, '2014-02-15 01:12:20.000000', 'consum', 0.0222, 'lps'),
	(539688, 128, '2014-02-15 01:12:21.000000', 'consum', 0.0214, 'lps'),
	(539689, 128, '2014-02-15 01:12:22.000000', 'consum', 0.0211, 'lps'),
	(539690, 128, '2014-02-15 01:12:23.000000', 'consum', 0.0222, 'lps'),
	(539691, 128, '2014-02-15 01:12:24.000000', 'consum', 0.0215, 'lps'),
	(539692, 128, '2014-02-15 01:12:25.000000', 'consum', 0.0215, 'lps'),
	(539693, 128, '2014-02-15 01:12:26.000000', 'consum', 0.0224, 'lps'),
	(539694, 128, '2014-02-15 01:12:27.000000', 'consum', 0.0213, 'lps'),
	(539695, 128, '2014-02-15 01:12:28.000000', 'consum', 0.0216, 'lps'),
	(539696, 128, '2014-02-15 01:12:29.000000', 'consum', 0.0214, 'lps'),
	(539697, 128, '2014-02-15 01:12:30.000000', 'consum', 0.0215, 'lps'),
	(539698, 128, '2014-02-15 01:12:31.000000', 'consum', 0.0225, 'lps'),
	(539699, 128, '2014-02-15 01:12:32.000000', 'consum', 0.0216, 'lps'),
	(539700, 128, '2014-02-15 01:12:33.000000', 'consum', 0.0213, 'lps'),
	(539701, 128, '2014-02-15 01:12:34.000000', 'consum', 0.0224, 'lps'),
	(539702, 128, '2014-02-15 01:12:35.000000', 'consum', 0.0222, 'lps'),
	(539703, 128, '2014-02-15 01:12:36.000000', 'consum', 0.0213, 'lps'),
	(539704, 128, '2014-02-15 01:12:37.000000', 'consum', 0.0222, 'lps'),
	(539705, 128, '2014-02-15 01:12:38.000000', 'consum', 0.0210, 'lps'),
	(539706, 128, '2014-02-15 01:12:39.000000', 'consum', 0.0225, 'lps'),
	(539707, 128, '2014-02-15 01:12:40.000000', 'consum', 0.0218, 'lps'),
	(539708, 128, '2014-02-15 01:12:41.000000', 'consum', 0.0223, 'lps'),
	(539709, 128, '2014-02-15 01:12:42.000000', 'consum', 0.0219, 'lps'),
	(539710, 128, '2014-02-15 01:12:43.000000', 'consum', 0.0214, 'lps'),
	(539711, 128, '2014-02-15 01:12:44.000000', 'consum', 0.0223, 'lps'),
	(539712, 128, '2014-02-15 01:12:45.000000', 'consum', 0.0211, 'lps'),
	(539713, 128, '2014-02-15 01:12:46.000000', 'consum', 0.0210, 'lps'),
	(539714, 128, '2014-02-15 01:12:47.000000', 'consum', 0.0223, 'lps'),
	(539715, 128, '2014-02-15 01:12:48.000000', 'consum', 0.0211, 'lps'),
	(539716, 128, '2014-02-15 01:12:49.000000', 'consum', 0.0224, 'lps'),
	(539717, 128, '2014-02-15 01:12:50.000000', 'consum', 0.0211, 'lps'),
	(539718, 128, '2014-02-15 01:12:51.000000', 'consum', 0.0226, 'lps'),
	(539719, 128, '2014-02-15 01:12:52.000000', 'consum', 0.0219, 'lps'),
	(539720, 128, '2014-02-15 01:12:53.000000', 'consum', 0.0225, 'lps'),
	(539721, 128, '2014-02-15 01:12:54.000000', 'consum', 0.0222, 'lps'),
	(539722, 128, '2014-02-15 01:12:55.000000', 'consum', 0.0226, 'lps'),
	(539723, 128, '2014-02-15 01:12:56.000000', 'consum', 0.0222, 'lps'),
	(539724, 128, '2014-02-15 01:12:57.000000', 'consum', 0.0221, 'lps'),
	(539725, 128, '2014-02-15 01:12:58.000000', 'consum', 0.0212, 'lps'),
	(539726, 128, '2014-02-15 01:12:59.000000', 'consum', 0.0220, 'lps'),
	(539727, 128, '2014-02-15 01:13:00.000000', 'consum', 0.0223, 'lps'),
	(539728, 128, '2014-02-15 01:13:01.000000', 'consum', 0.0226, 'lps'),
	(539729, 128, '2014-02-15 01:13:02.000000', 'consum', 0.0220, 'lps'),
	(539730, 128, '2014-02-15 01:13:03.000000', 'consum', 0.0211, 'lps'),
	(539731, 128, '2014-02-15 01:13:04.000000', 'consum', 0.0219, 'lps'),
	(539732, 128, '2014-02-15 01:13:05.000000', 'consum', 0.0220, 'lps'),
	(539733, 128, '2014-02-15 01:13:06.000000', 'consum', 0.0215, 'lps'),
	(539734, 128, '2014-02-15 01:13:07.000000', 'consum', 0.0224, 'lps'),
	(539735, 128, '2014-02-15 01:13:08.000000', 'consum', 0.0212, 'lps'),
	(539736, 128, '2014-02-15 01:13:09.000000', 'consum', 0.0216, 'lps'),
	(539737, 128, '2014-02-15 01:13:10.000000', 'consum', 0.0214, 'lps'),
	(539738, 128, '2014-02-15 01:13:11.000000', 'consum', 0.0216, 'lps'),
	(539739, 128, '2014-02-15 01:13:12.000000', 'consum', 0.0210, 'lps'),
	(539740, 128, '2014-02-15 01:13:13.000000', 'consum', 0.0225, 'lps'),
	(539741, 128, '2014-02-15 01:13:14.000000', 'consum', 0.0218, 'lps'),
	(539742, 128, '2014-02-15 01:13:15.000000', 'consum', 0.0225, 'lps'),
	(539743, 128, '2014-02-15 01:13:16.000000', 'consum', 0.0225, 'lps'),
	(539744, 128, '2014-02-15 01:13:17.000000', 'consum', 0.0222, 'lps'),
	(539745, 128, '2014-02-15 01:13:18.000000', 'consum', 0.0212, 'lps'),
	(539746, 128, '2014-02-15 01:13:19.000000', 'consum', 0.0215, 'lps'),
	(539747, 128, '2014-02-15 01:13:20.000000', 'consum', 0.0215, 'lps'),
	(539748, 128, '2014-02-15 01:13:21.000000', 'consum', 0.0220, 'lps'),
	(539749, 128, '2014-02-15 01:13:22.000000', 'consum', 0.0212, 'lps'),
	(539750, 128, '2014-02-15 01:13:23.000000', 'consum', 0.0223, 'lps'),
	(539751, 128, '2014-02-15 01:13:24.000000', 'consum', 0.0221, 'lps'),
	(539752, 128, '2014-02-15 01:13:25.000000', 'consum', 0.0224, 'lps'),
	(539753, 128, '2014-02-15 01:13:26.000000', 'consum', 0.0215, 'lps'),
	(539754, 128, '2014-02-15 01:13:27.000000', 'consum', 0.0211, 'lps'),
	(539755, 128, '2014-02-15 01:13:28.000000', 'consum', 0.0218, 'lps'),
	(539756, 128, '2014-02-15 01:13:29.000000', 'consum', 0.0211, 'lps'),
	(539757, 128, '2014-02-15 01:13:30.000000', 'consum', 0.0226, 'lps'),
	(539758, 128, '2014-02-15 01:13:31.000000', 'consum', 0.0220, 'lps'),
	(539759, 128, '2014-02-15 01:13:32.000000', 'consum', 0.0213, 'lps'),
	(539760, 128, '2014-02-15 01:13:33.000000', 'consum', 0.0213, 'lps'),
	(539761, 128, '2014-02-15 01:13:34.000000', 'consum', 0.0214, 'lps'),
	(539762, 128, '2014-02-15 01:13:35.000000', 'consum', 0.0224, 'lps'),
	(539763, 128, '2014-02-15 01:13:36.000000', 'consum', 0.0217, 'lps'),
	(539764, 128, '2014-02-15 01:13:37.000000', 'consum', 0.0220, 'lps'),
	(539765, 128, '2014-02-15 01:13:38.000000', 'consum', 0.0222, 'lps'),
	(539766, 128, '2014-02-15 01:13:39.000000', 'consum', 0.0226, 'lps'),
	(539767, 128, '2014-02-15 01:13:40.000000', 'consum', 0.0219, 'lps'),
	(539768, 128, '2014-02-15 01:13:41.000000', 'consum', 0.0226, 'lps'),
	(539769, 128, '2014-02-15 01:13:42.000000', 'consum', 0.0211, 'lps'),
	(539770, 128, '2014-02-15 01:13:43.000000', 'consum', 0.0218, 'lps'),
	(539771, 128, '2014-02-15 01:13:44.000000', 'consum', 0.0213, 'lps'),
	(539772, 128, '2014-02-15 01:13:45.000000', 'consum', 0.0218, 'lps'),
	(539773, 128, '2014-02-15 01:13:46.000000', 'consum', 0.0210, 'lps'),
	(539774, 128, '2014-02-15 01:13:47.000000', 'consum', 0.0221, 'lps'),
	(539775, 128, '2014-02-15 01:13:48.000000', 'consum', 0.0215, 'lps'),
	(539776, 128, '2014-02-15 01:13:49.000000', 'consum', 0.0218, 'lps'),
	(539777, 128, '2014-02-15 01:13:50.000000', 'consum', 0.0220, 'lps'),
	(539778, 128, '2014-02-15 01:13:51.000000', 'consum', 0.0220, 'lps'),
	(539779, 128, '2014-02-15 01:13:52.000000', 'consum', 0.0213, 'lps'),
	(539780, 128, '2014-02-15 01:13:53.000000', 'consum', 0.0214, 'lps'),
	(539781, 128, '2014-02-15 01:13:54.000000', 'consum', 0.0221, 'lps'),
	(539782, 128, '2014-02-15 01:13:55.000000', 'consum', 0.0221, 'lps'),
	(539783, 128, '2014-02-15 01:13:56.000000', 'consum', 0.0214, 'lps'),
	(539784, 128, '2014-02-15 01:13:57.000000', 'consum', 0.0217, 'lps'),
	(539785, 128, '2014-02-15 01:13:58.000000', 'consum', 0.0213, 'lps'),
	(539786, 128, '2014-02-15 01:13:59.000000', 'consum', 0.0222, 'lps'),
	(539787, 128, '2014-02-15 01:14:00.000000', 'consum', 0.0210, 'lps'),
	(539788, 128, '2014-02-15 01:14:01.000000', 'consum', 0.0211, 'lps'),
	(539789, 128, '2014-02-15 01:14:02.000000', 'consum', 0.0212, 'lps'),
	(539790, 128, '2014-02-15 01:14:03.000000', 'consum', 0.0221, 'lps'),
	(539791, 128, '2014-02-15 01:14:04.000000', 'consum', 0.0224, 'lps'),
	(539792, 128, '2014-02-15 01:14:05.000000', 'consum', 0.0214, 'lps'),
	(539793, 128, '2014-02-15 01:14:06.000000', 'consum', 0.0223, 'lps'),
	(539794, 128, '2014-02-15 01:14:07.000000', 'consum', 0.0212, 'lps'),
	(539795, 128, '2014-02-15 01:14:08.000000', 'consum', 0.0216, 'lps'),
	(539796, 128, '2014-02-15 01:14:09.000000', 'consum', 0.0219, 'lps'),
	(539797, 128, '2014-02-15 01:14:10.000000', 'consum', 0.0218, 'lps'),
	(539798, 128, '2014-02-15 01:14:11.000000', 'consum', 0.0226, 'lps'),
	(539799, 128, '2014-02-15 01:14:12.000000', 'consum', 0.0213, 'lps'),
	(539800, 128, '2014-02-15 01:14:13.000000', 'consum', 0.0214, 'lps'),
	(539801, 128, '2014-02-15 01:14:14.000000', 'consum', 0.0222, 'lps'),
	(539802, 128, '2014-02-15 01:14:15.000000', 'consum', 0.0221, 'lps'),
	(539803, 128, '2014-02-15 01:14:16.000000', 'consum', 0.0216, 'lps'),
	(539804, 128, '2014-02-15 01:14:17.000000', 'consum', 0.0223, 'lps'),
	(539805, 128, '2014-02-15 01:14:18.000000', 'consum', 0.0225, 'lps'),
	(539806, 128, '2014-02-15 01:14:19.000000', 'consum', 0.0213, 'lps'),
	(539807, 128, '2014-02-15 01:14:20.000000', 'consum', 0.0213, 'lps'),
	(539808, 128, '2014-02-15 01:14:21.000000', 'consum', 0.0218, 'lps'),
	(539809, 128, '2014-02-15 01:14:22.000000', 'consum', 0.0222, 'lps'),
	(539810, 128, '2014-02-15 01:14:23.000000', 'consum', 0.0213, 'lps'),
	(539811, 128, '2014-02-15 01:14:24.000000', 'consum', 0.0223, 'lps'),
	(539812, 128, '2014-02-15 01:14:25.000000', 'consum', 0.0214, 'lps'),
	(539813, 128, '2014-02-15 01:14:26.000000', 'consum', 0.0212, 'lps'),
	(539814, 128, '2014-02-15 01:14:27.000000', 'consum', 0.0225, 'lps'),
	(539815, 128, '2014-02-15 01:14:28.000000', 'consum', 0.0226, 'lps'),
	(539816, 128, '2014-02-15 01:14:29.000000', 'consum', 0.0212, 'lps'),
	(539817, 128, '2014-02-15 01:14:30.000000', 'consum', 0.0224, 'lps'),
	(539818, 128, '2014-02-15 01:14:31.000000', 'consum', 0.0226, 'lps'),
	(539819, 128, '2014-02-15 01:14:32.000000', 'consum', 0.0211, 'lps'),
	(539820, 128, '2014-02-15 01:14:33.000000', 'consum', 0.0221, 'lps'),
	(539821, 128, '2014-02-15 01:14:34.000000', 'consum', 0.0226, 'lps'),
	(539822, 128, '2014-02-15 01:14:35.000000', 'consum', 0.0224, 'lps'),
	(539823, 128, '2014-02-15 01:14:36.000000', 'consum', 0.0217, 'lps'),
	(539824, 128, '2014-02-15 01:14:37.000000', 'consum', 0.0218, 'lps'),
	(539825, 128, '2014-02-15 01:14:38.000000', 'consum', 0.0215, 'lps'),
	(539826, 128, '2014-02-15 01:14:39.000000', 'consum', 0.0210, 'lps'),
	(539827, 128, '2014-02-15 01:14:40.000000', 'consum', 0.0211, 'lps'),
	(539828, 128, '2014-02-15 01:14:41.000000', 'consum', 0.0219, 'lps'),
	(539829, 128, '2014-02-15 01:14:42.000000', 'consum', 0.0216, 'lps'),
	(539830, 128, '2014-02-15 01:14:43.000000', 'consum', 0.0215, 'lps'),
	(539831, 128, '2014-02-15 01:14:44.000000', 'consum', 0.0219, 'lps'),
	(539832, 128, '2014-02-15 01:14:45.000000', 'consum', 0.0220, 'lps'),
	(539833, 128, '2014-02-15 01:14:46.000000', 'consum', 0.0218, 'lps'),
	(539834, 128, '2014-02-15 01:14:47.000000', 'consum', 0.0219, 'lps'),
	(539835, 128, '2014-02-15 01:14:48.000000', 'consum', 0.0215, 'lps'),
	(539836, 128, '2014-02-15 01:14:49.000000', 'consum', 0.0210, 'lps'),
	(539837, 128, '2014-02-15 01:14:50.000000', 'consum', 0.0213, 'lps'),
	(539838, 128, '2014-02-15 01:14:51.000000', 'consum', 0.0226, 'lps'),
	(539839, 128, '2014-02-15 01:14:52.000000', 'consum', 0.0211, 'lps'),
	(539840, 128, '2014-02-15 01:14:53.000000', 'consum', 0.0219, 'lps'),
	(539841, 128, '2014-02-15 01:14:54.000000', 'consum', 0.0220, 'lps'),
	(539842, 128, '2014-02-15 01:14:55.000000', 'consum', 0.0217, 'lps'),
	(539843, 128, '2014-02-15 01:14:56.000000', 'consum', 0.0216, 'lps'),
	(539844, 128, '2014-02-15 01:14:57.000000', 'consum', 0.0217, 'lps'),
	(539845, 128, '2014-02-15 01:14:58.000000', 'consum', 0.0210, 'lps'),
	(539846, 128, '2014-02-15 01:14:59.000000', 'consum', 0.0226, 'lps'),
	(539847, 128, '2014-02-15 01:15:00.000000', 'consum', 0.0221, 'lps'),
	(539848, 128, '2014-02-15 01:15:01.000000', 'consum', 0.0219, 'lps'),
	(539849, 128, '2014-02-15 01:15:02.000000', 'consum', 0.0221, 'lps'),
	(539850, 128, '2014-02-15 01:15:03.000000', 'consum', 0.0224, 'lps'),
	(539851, 128, '2014-02-15 01:15:04.000000', 'consum', 0.0210, 'lps'),
	(539852, 128, '2014-02-15 01:15:05.000000', 'consum', 0.0223, 'lps'),
	(539853, 128, '2014-02-15 01:15:06.000000', 'consum', 0.0224, 'lps'),
	(539854, 128, '2014-02-15 01:15:07.000000', 'consum', 0.0222, 'lps'),
	(539855, 128, '2014-02-15 01:15:08.000000', 'consum', 0.0212, 'lps'),
	(539856, 128, '2014-02-15 01:15:09.000000', 'consum', 0.0217, 'lps'),
	(539857, 128, '2014-02-15 01:15:10.000000', 'consum', 0.0226, 'lps'),
	(539858, 128, '2014-02-15 01:15:11.000000', 'consum', 0.0217, 'lps'),
	(539859, 128, '2014-02-15 01:15:12.000000', 'consum', 0.0214, 'lps'),
	(539860, 128, '2014-02-15 01:15:13.000000', 'consum', 0.0225, 'lps'),
	(539861, 128, '2014-02-15 01:15:14.000000', 'consum', 0.0225, 'lps'),
	(539862, 128, '2014-02-15 01:15:15.000000', 'consum', 0.0222, 'lps'),
	(539863, 128, '2014-02-15 01:15:16.000000', 'consum', 0.0225, 'lps'),
	(539864, 128, '2014-02-15 01:15:17.000000', 'consum', 0.0215, 'lps'),
	(539865, 128, '2014-02-15 01:15:18.000000', 'consum', 0.0225, 'lps'),
	(539866, 128, '2014-02-15 01:15:19.000000', 'consum', 0.0218, 'lps'),
	(539867, 128, '2014-02-15 01:15:20.000000', 'consum', 0.0225, 'lps'),
	(539868, 128, '2014-02-15 01:15:21.000000', 'consum', 0.0210, 'lps'),
	(539869, 128, '2014-02-15 01:15:22.000000', 'consum', 0.0215, 'lps'),
	(539870, 128, '2014-02-15 01:15:23.000000', 'consum', 0.0221, 'lps'),
	(539871, 128, '2014-02-15 01:15:24.000000', 'consum', 0.0214, 'lps'),
	(539872, 128, '2014-02-15 01:15:25.000000', 'consum', 0.0215, 'lps'),
	(539873, 128, '2014-02-15 01:15:26.000000', 'consum', 0.0225, 'lps'),
	(539874, 128, '2014-02-15 01:15:27.000000', 'consum', 0.0218, 'lps'),
	(539875, 128, '2014-02-15 01:15:28.000000', 'consum', 0.0224, 'lps'),
	(539876, 128, '2014-02-15 01:15:29.000000', 'consum', 0.0223, 'lps'),
	(539877, 128, '2014-02-15 01:15:30.000000', 'consum', 0.0216, 'lps'),
	(539878, 128, '2014-02-15 01:15:31.000000', 'consum', 0.0216, 'lps'),
	(539879, 128, '2014-02-15 01:15:32.000000', 'consum', 0.0225, 'lps'),
	(539880, 128, '2014-02-15 01:15:33.000000', 'consum', 0.0216, 'lps'),
	(539881, 128, '2014-02-15 01:15:34.000000', 'consum', 0.0212, 'lps'),
	(539882, 128, '2014-02-15 01:15:35.000000', 'consum', 0.0218, 'lps'),
	(539883, 128, '2014-02-15 01:15:36.000000', 'consum', 0.0213, 'lps'),
	(539884, 128, '2014-02-15 01:15:37.000000', 'consum', 0.0218, 'lps'),
	(539885, 128, '2014-02-15 01:15:38.000000', 'consum', 0.0224, 'lps'),
	(539886, 128, '2014-02-15 01:15:39.000000', 'consum', 0.0222, 'lps'),
	(539887, 128, '2014-02-15 01:15:40.000000', 'consum', 0.0214, 'lps'),
	(539888, 128, '2014-02-15 01:15:41.000000', 'consum', 0.0226, 'lps'),
	(539889, 128, '2014-02-15 01:15:42.000000', 'consum', 0.0211, 'lps'),
	(539890, 128, '2014-02-15 01:15:43.000000', 'consum', 0.0217, 'lps'),
	(539891, 128, '2014-02-15 01:15:44.000000', 'consum', 0.0210, 'lps'),
	(539892, 128, '2014-02-15 01:15:45.000000', 'consum', 0.0222, 'lps'),
	(539893, 128, '2014-02-15 01:15:46.000000', 'consum', 0.0219, 'lps'),
	(539894, 128, '2014-02-15 01:15:47.000000', 'consum', 0.0220, 'lps'),
	(539895, 128, '2014-02-15 01:15:48.000000', 'consum', 0.0218, 'lps'),
	(539896, 128, '2014-02-15 01:15:49.000000', 'consum', 0.0219, 'lps'),
	(539897, 128, '2014-02-15 01:15:50.000000', 'consum', 0.0213, 'lps'),
	(539898, 128, '2014-02-15 01:15:51.000000', 'consum', 0.0216, 'lps'),
	(539899, 128, '2014-02-15 01:15:52.000000', 'consum', 0.0216, 'lps'),
	(539900, 128, '2014-02-15 01:15:53.000000', 'consum', 0.0221, 'lps'),
	(539901, 128, '2014-02-15 01:15:54.000000', 'consum', 0.0213, 'lps'),
	(539902, 128, '2014-02-15 01:15:55.000000', 'consum', 0.0226, 'lps'),
	(539903, 128, '2014-02-15 01:15:56.000000', 'consum', 0.0214, 'lps'),
	(539904, 128, '2014-02-15 01:15:57.000000', 'consum', 0.0219, 'lps'),
	(539905, 128, '2014-02-15 01:15:58.000000', 'consum', 0.0224, 'lps'),
	(539906, 128, '2014-02-15 01:15:59.000000', 'consum', 0.0218, 'lps'),
	(539907, 128, '2014-02-15 01:16:00.000000', 'consum', 0.0211, 'lps'),
	(539908, 128, '2014-02-15 01:16:01.000000', 'consum', 0.0226, 'lps'),
	(539909, 128, '2014-02-15 01:16:02.000000', 'consum', 0.0218, 'lps'),
	(539910, 128, '2014-02-15 01:16:03.000000', 'consum', 0.0218, 'lps'),
	(539911, 128, '2014-02-15 01:16:04.000000', 'consum', 0.0211, 'lps'),
	(539912, 128, '2014-02-15 01:16:05.000000', 'consum', 0.0225, 'lps'),
	(539913, 128, '2014-02-15 01:16:06.000000', 'consum', 0.0216, 'lps'),
	(539914, 128, '2014-02-15 01:16:07.000000', 'consum', 0.0212, 'lps'),
	(539915, 128, '2014-02-15 01:16:08.000000', 'consum', 0.0220, 'lps'),
	(539916, 128, '2014-02-15 01:16:09.000000', 'consum', 0.0221, 'lps'),
	(539917, 128, '2014-02-15 01:16:10.000000', 'consum', 0.0219, 'lps'),
	(539918, 128, '2014-02-15 01:16:11.000000', 'consum', 0.0222, 'lps'),
	(539919, 128, '2014-02-15 01:16:12.000000', 'consum', 0.0225, 'lps'),
	(539920, 128, '2014-02-15 01:16:13.000000', 'consum', 0.0216, 'lps'),
	(539921, 128, '2014-02-15 01:16:14.000000', 'consum', 0.0214, 'lps'),
	(539922, 128, '2014-02-15 01:16:15.000000', 'consum', 0.0211, 'lps'),
	(539923, 128, '2014-02-15 01:16:16.000000', 'consum', 0.0222, 'lps'),
	(539924, 128, '2014-02-15 01:16:17.000000', 'consum', 0.0217, 'lps'),
	(539925, 128, '2014-02-15 01:16:18.000000', 'consum', 0.0226, 'lps'),
	(539926, 128, '2014-02-15 01:16:19.000000', 'consum', 0.0220, 'lps'),
	(539927, 128, '2014-02-15 01:16:20.000000', 'consum', 0.0210, 'lps'),
	(539928, 128, '2014-02-15 01:16:21.000000', 'consum', 0.0216, 'lps'),
	(539929, 128, '2014-02-15 01:16:22.000000', 'consum', 0.0224, 'lps'),
	(539930, 128, '2014-02-15 01:16:23.000000', 'consum', 0.0211, 'lps'),
	(539931, 128, '2014-02-15 01:16:24.000000', 'consum', 0.0225, 'lps'),
	(539932, 128, '2014-02-15 01:16:25.000000', 'consum', 0.0214, 'lps'),
	(539933, 128, '2014-02-15 01:16:26.000000', 'consum', 0.0221, 'lps'),
	(539934, 128, '2014-02-15 01:16:27.000000', 'consum', 0.0218, 'lps'),
	(539935, 128, '2014-02-15 01:16:28.000000', 'consum', 0.0218, 'lps'),
	(539936, 128, '2014-02-15 01:16:29.000000', 'consum', 0.0211, 'lps'),
	(539937, 128, '2014-02-15 01:16:30.000000', 'consum', 0.0226, 'lps'),
	(539938, 128, '2014-02-15 01:16:31.000000', 'consum', 0.0220, 'lps'),
	(539939, 128, '2014-02-15 01:16:32.000000', 'consum', 0.0211, 'lps'),
	(539940, 128, '2014-02-15 01:16:33.000000', 'consum', 0.0219, 'lps'),
	(539941, 128, '2014-02-15 01:16:34.000000', 'consum', 0.0217, 'lps'),
	(539942, 128, '2014-02-15 01:16:35.000000', 'consum', 0.0220, 'lps'),
	(539943, 128, '2014-02-15 01:16:36.000000', 'consum', 0.0224, 'lps'),
	(539944, 128, '2014-02-15 01:16:37.000000', 'consum', 0.0217, 'lps'),
	(539945, 128, '2014-02-15 01:16:38.000000', 'consum', 0.0219, 'lps'),
	(539946, 128, '2014-02-15 01:16:39.000000', 'consum', 0.0218, 'lps'),
	(539947, 128, '2014-02-15 01:16:40.000000', 'consum', 0.0224, 'lps'),
	(539948, 128, '2014-02-15 01:16:41.000000', 'consum', 0.0223, 'lps'),
	(539949, 128, '2014-02-15 01:16:42.000000', 'consum', 0.0217, 'lps'),
	(539950, 128, '2014-02-15 01:16:43.000000', 'consum', 0.0222, 'lps'),
	(539951, 128, '2014-02-15 01:16:44.000000', 'consum', 0.0215, 'lps'),
	(539952, 128, '2014-02-15 01:16:45.000000', 'consum', 0.0217, 'lps'),
	(539953, 128, '2014-02-15 01:16:46.000000', 'consum', 0.0212, 'lps'),
	(539954, 128, '2014-02-15 01:16:47.000000', 'consum', 0.0219, 'lps'),
	(539955, 128, '2014-02-15 01:16:48.000000', 'consum', 0.0213, 'lps'),
	(539956, 128, '2014-02-15 01:16:49.000000', 'consum', 0.0215, 'lps'),
	(539957, 128, '2014-02-15 01:16:50.000000', 'consum', 0.0226, 'lps'),
	(539958, 128, '2014-02-15 01:16:51.000000', 'consum', 0.0225, 'lps'),
	(539959, 128, '2014-02-15 01:16:52.000000', 'consum', 0.0220, 'lps'),
	(539960, 128, '2014-02-15 01:16:53.000000', 'consum', 0.0215, 'lps'),
	(539961, 128, '2014-02-15 01:16:54.000000', 'consum', 0.0224, 'lps'),
	(539962, 128, '2014-02-15 01:16:55.000000', 'consum', 0.0213, 'lps'),
	(539963, 128, '2014-02-15 01:16:56.000000', 'consum', 0.0217, 'lps'),
	(539964, 128, '2014-02-15 01:16:57.000000', 'consum', 0.0222, 'lps'),
	(539965, 128, '2014-02-15 01:16:58.000000', 'consum', 0.0215, 'lps'),
	(539966, 128, '2014-02-15 01:16:59.000000', 'consum', 0.0215, 'lps'),
	(539967, 128, '2014-02-15 01:17:00.000000', 'consum', 0.0220, 'lps'),
	(539968, 128, '2014-02-15 01:17:01.000000', 'consum', 0.0212, 'lps'),
	(539969, 128, '2014-02-15 01:17:02.000000', 'consum', 0.0226, 'lps'),
	(539970, 128, '2014-02-15 01:17:03.000000', 'consum', 0.0217, 'lps'),
	(539971, 128, '2014-02-15 01:17:04.000000', 'consum', 0.0213, 'lps'),
	(539972, 128, '2014-02-15 01:17:05.000000', 'consum', 0.0223, 'lps'),
	(539973, 128, '2014-02-15 01:17:06.000000', 'consum', 0.0213, 'lps'),
	(539974, 128, '2014-02-15 01:17:07.000000', 'consum', 0.0223, 'lps'),
	(539975, 128, '2014-02-15 01:17:08.000000', 'consum', 0.0214, 'lps'),
	(539976, 128, '2014-02-15 01:17:09.000000', 'consum', 0.0226, 'lps'),
	(539977, 128, '2014-02-15 01:17:10.000000', 'consum', 0.0226, 'lps'),
	(539978, 128, '2014-02-15 01:17:11.000000', 'consum', 0.0226, 'lps'),
	(539979, 128, '2014-02-15 01:17:12.000000', 'consum', 0.0226, 'lps'),
	(539980, 128, '2014-02-15 01:17:13.000000', 'consum', 0.0210, 'lps'),
	(539981, 128, '2014-02-15 01:17:14.000000', 'consum', 0.0214, 'lps'),
	(539982, 128, '2014-02-15 01:17:15.000000', 'consum', 0.0212, 'lps'),
	(539983, 128, '2014-02-15 01:17:16.000000', 'consum', 0.0226, 'lps'),
	(539984, 128, '2014-02-15 01:17:17.000000', 'consum', 0.0214, 'lps'),
	(539985, 128, '2014-02-15 01:17:18.000000', 'consum', 0.0220, 'lps'),
	(539986, 128, '2014-02-15 01:17:19.000000', 'consum', 0.0212, 'lps'),
	(539987, 128, '2014-02-15 01:17:20.000000', 'consum', 0.0224, 'lps'),
	(539988, 128, '2014-02-15 01:17:21.000000', 'consum', 0.0223, 'lps'),
	(539989, 128, '2014-02-15 01:17:22.000000', 'consum', 0.0219, 'lps'),
	(539990, 128, '2014-02-15 01:17:23.000000', 'consum', 0.0213, 'lps'),
	(539991, 128, '2014-02-15 01:17:24.000000', 'consum', 0.0219, 'lps'),
	(539992, 128, '2014-02-15 01:17:25.000000', 'consum', 0.0226, 'lps'),
	(539993, 128, '2014-02-15 01:17:26.000000', 'consum', 0.0215, 'lps'),
	(539994, 128, '2014-02-15 01:17:27.000000', 'consum', 0.0221, 'lps'),
	(539995, 128, '2014-02-15 01:17:28.000000', 'consum', 0.0215, 'lps'),
	(539996, 128, '2014-02-15 01:17:29.000000', 'consum', 0.0223, 'lps'),
	(539997, 129, '2014-02-15 00:00:00.000000', 'consum', 0.0223, 'lps'),
	(539998, 129, '2014-02-15 00:00:01.000000', 'consum', 0.0234, 'lps'),
	(539999, 129, '2014-02-15 00:00:02.000000', 'consum', 0.0216, 'lps'),
	(540000, 129, '2014-02-15 00:00:03.000000', 'consum', 0.0220, 'lps'),
	(540001, 129, '2014-02-15 00:00:04.000000', 'consum', 0.0219, 'lps'),
	(540002, 129, '2014-02-15 00:00:05.000000', 'consum', 0.0223, 'lps'),
	(540003, 129, '2014-02-15 00:00:06.000000', 'consum', 0.0223, 'lps'),
	(540004, 129, '2014-02-15 00:00:07.000000', 'consum', 0.0211, 'lps'),
	(540005, 129, '2014-02-15 00:00:08.000000', 'consum', 0.0226, 'lps'),
	(540006, 129, '2014-02-15 00:00:09.000000', 'consum', 0.0214, 'lps'),
	(540007, 129, '2014-02-15 00:00:10.000000', 'consum', 0.0234, 'lps'),
	(540008, 129, '2014-02-15 00:00:11.000000', 'consum', 0.0218, 'lps'),
	(540009, 129, '2014-02-15 00:00:12.000000', 'consum', 0.0229, 'lps'),
	(540010, 129, '2014-02-15 00:00:13.000000', 'consum', 0.0230, 'lps'),
	(540011, 129, '2014-02-15 00:00:14.000000', 'consum', 0.0230, 'lps'),
	(540012, 129, '2014-02-15 00:00:15.000000', 'consum', 0.0225, 'lps'),
	(540013, 129, '2014-02-15 00:00:16.000000', 'consum', 0.0223, 'lps'),
	(540014, 129, '2014-02-15 00:00:17.000000', 'consum', 0.0234, 'lps'),
	(540015, 129, '2014-02-15 00:00:18.000000', 'consum', 0.0216, 'lps'),
	(540016, 129, '2014-02-15 00:00:19.000000', 'consum', 0.0218, 'lps'),
	(540017, 129, '2014-02-15 00:00:20.000000', 'consum', 0.0234, 'lps'),
	(540018, 129, '2014-02-15 00:00:21.000000', 'consum', 0.0231, 'lps'),
	(540019, 129, '2014-02-15 00:00:22.000000', 'consum', 0.0220, 'lps'),
	(540020, 129, '2014-02-15 00:00:23.000000', 'consum', 0.0222, 'lps'),
	(540021, 129, '2014-02-15 00:00:24.000000', 'consum', 0.0214, 'lps'),
	(540022, 129, '2014-02-15 00:00:25.000000', 'consum', 0.0219, 'lps'),
	(540023, 129, '2014-02-15 00:00:26.000000', 'consum', 0.0218, 'lps'),
	(540024, 129, '2014-02-15 00:00:27.000000', 'consum', 0.0223, 'lps'),
	(540025, 129, '2014-02-15 00:00:28.000000', 'consum', 0.0229, 'lps'),
	(540026, 129, '2014-02-15 00:00:29.000000', 'consum', 0.0214, 'lps'),
	(540027, 129, '2014-02-15 00:00:30.000000', 'consum', 0.0225, 'lps'),
	(540028, 129, '2014-02-15 00:00:31.000000', 'consum', 0.0225, 'lps'),
	(540029, 129, '2014-02-15 00:00:32.000000', 'consum', 0.0213, 'lps'),
	(540030, 129, '2014-02-15 00:00:33.000000', 'consum', 0.0231, 'lps'),
	(540031, 129, '2014-02-15 00:00:34.000000', 'consum', 0.0231, 'lps'),
	(540032, 129, '2014-02-15 00:00:35.000000', 'consum', 0.0230, 'lps'),
	(540033, 129, '2014-02-15 00:00:36.000000', 'consum', 0.0222, 'lps'),
	(540034, 129, '2014-02-15 00:00:37.000000', 'consum', 0.0233, 'lps'),
	(540035, 129, '2014-02-15 00:00:38.000000', 'consum', 0.0216, 'lps'),
	(540036, 129, '2014-02-15 00:00:39.000000', 'consum', 0.0221, 'lps'),
	(540037, 129, '2014-02-15 00:00:40.000000', 'consum', 0.0225, 'lps'),
	(540038, 129, '2014-02-15 00:00:41.000000', 'consum', 0.0225, 'lps'),
	(540039, 129, '2014-02-15 00:00:42.000000', 'consum', 0.0217, 'lps'),
	(540040, 129, '2014-02-15 00:00:43.000000', 'consum', 0.0225, 'lps'),
	(540041, 129, '2014-02-15 00:00:44.000000', 'consum', 0.0216, 'lps'),
	(540042, 129, '2014-02-15 00:00:45.000000', 'consum', 0.0218, 'lps'),
	(540043, 129, '2014-02-15 00:00:46.000000', 'consum', 0.0210, 'lps'),
	(540044, 129, '2014-02-15 00:00:47.000000', 'consum', 0.0233, 'lps'),
	(540045, 129, '2014-02-15 00:00:48.000000', 'consum', 0.0229, 'lps'),
	(540046, 129, '2014-02-15 00:00:49.000000', 'consum', 0.0234, 'lps'),
	(540047, 129, '2014-02-15 00:00:50.000000', 'consum', 0.0224, 'lps'),
	(540048, 129, '2014-02-15 00:00:51.000000', 'consum', 0.0234, 'lps'),
	(540049, 129, '2014-02-15 00:00:52.000000', 'consum', 0.0215, 'lps'),
	(540050, 129, '2014-02-15 00:00:53.000000', 'consum', 0.0211, 'lps'),
	(540051, 129, '2014-02-15 00:00:54.000000', 'consum', 0.0227, 'lps'),
	(540052, 129, '2014-02-15 00:00:55.000000', 'consum', 0.0217, 'lps'),
	(540053, 129, '2014-02-15 00:00:56.000000', 'consum', 0.0218, 'lps'),
	(540054, 129, '2014-02-15 00:00:57.000000', 'consum', 0.0232, 'lps'),
	(540055, 129, '2014-02-15 00:00:58.000000', 'consum', 0.0219, 'lps'),
	(540056, 129, '2014-02-15 00:00:59.000000', 'consum', 0.0215, 'lps'),
	(540057, 129, '2014-02-15 00:01:00.000000', 'consum', 0.0233, 'lps'),
	(540058, 129, '2014-02-15 00:01:01.000000', 'consum', 0.0211, 'lps'),
	(540059, 129, '2014-02-15 00:01:02.000000', 'consum', 0.0220, 'lps'),
	(540060, 129, '2014-02-15 00:01:03.000000', 'consum', 0.0210, 'lps'),
	(540061, 129, '2014-02-15 00:01:04.000000', 'consum', 0.0228, 'lps'),
	(540062, 129, '2014-02-15 00:01:05.000000', 'consum', 0.0228, 'lps'),
	(540063, 129, '2014-02-15 00:01:06.000000', 'consum', 0.0222, 'lps'),
	(540064, 129, '2014-02-15 00:01:07.000000', 'consum', 0.0216, 'lps'),
	(540065, 129, '2014-02-15 00:01:08.000000', 'consum', 0.0228, 'lps'),
	(540066, 129, '2014-02-15 00:01:09.000000', 'consum', 0.0210, 'lps'),
	(540067, 129, '2014-02-15 00:01:10.000000', 'consum', 0.0230, 'lps'),
	(540068, 129, '2014-02-15 00:01:11.000000', 'consum', 0.0210, 'lps'),
	(540069, 129, '2014-02-15 00:01:12.000000', 'consum', 0.0225, 'lps'),
	(540070, 129, '2014-02-15 00:01:13.000000', 'consum', 0.0213, 'lps'),
	(540071, 129, '2014-02-15 00:01:14.000000', 'consum', 0.0228, 'lps'),
	(540072, 129, '2014-02-15 00:01:15.000000', 'consum', 0.0218, 'lps'),
	(540073, 129, '2014-02-15 00:01:16.000000', 'consum', 0.0219, 'lps'),
	(540074, 129, '2014-02-15 00:01:17.000000', 'consum', 0.0210, 'lps'),
	(540075, 129, '2014-02-15 00:01:18.000000', 'consum', 0.0231, 'lps'),
	(540076, 129, '2014-02-15 00:01:19.000000', 'consum', 0.0214, 'lps'),
	(540077, 129, '2014-02-15 00:01:20.000000', 'consum', 0.0220, 'lps'),
	(540078, 129, '2014-02-15 00:01:21.000000', 'consum', 0.0221, 'lps'),
	(540079, 129, '2014-02-15 00:01:22.000000', 'consum', 0.0212, 'lps'),
	(540080, 129, '2014-02-15 00:01:23.000000', 'consum', 0.0211, 'lps'),
	(540081, 129, '2014-02-15 00:01:24.000000', 'consum', 0.0234, 'lps'),
	(540082, 129, '2014-02-15 00:01:25.000000', 'consum', 0.0228, 'lps'),
	(540083, 129, '2014-02-15 00:01:26.000000', 'consum', 0.0230, 'lps'),
	(540084, 129, '2014-02-15 00:01:27.000000', 'consum', 0.0233, 'lps'),
	(540085, 129, '2014-02-15 00:01:28.000000', 'consum', 0.0213, 'lps'),
	(540086, 129, '2014-02-15 00:01:29.000000', 'consum', 0.0231, 'lps'),
	(540087, 129, '2014-02-15 00:01:30.000000', 'consum', 0.0233, 'lps'),
	(540088, 129, '2014-02-15 00:01:31.000000', 'consum', 0.0211, 'lps'),
	(540089, 129, '2014-02-15 00:01:32.000000', 'consum', 0.0221, 'lps'),
	(540090, 129, '2014-02-15 00:01:33.000000', 'consum', 0.0215, 'lps'),
	(540091, 129, '2014-02-15 00:01:34.000000', 'consum', 0.0226, 'lps'),
	(540092, 129, '2014-02-15 00:01:35.000000', 'consum', 0.0227, 'lps'),
	(540093, 129, '2014-02-15 00:01:36.000000', 'consum', 0.0223, 'lps'),
	(540094, 129, '2014-02-15 00:01:37.000000', 'consum', 0.0224, 'lps'),
	(540095, 129, '2014-02-15 00:01:38.000000', 'consum', 0.0218, 'lps'),
	(540096, 129, '2014-02-15 00:01:39.000000', 'consum', 0.0230, 'lps'),
	(540097, 129, '2014-02-15 00:01:40.000000', 'consum', 0.0215, 'lps'),
	(540098, 129, '2014-02-15 00:01:41.000000', 'consum', 0.0225, 'lps'),
	(540099, 129, '2014-02-15 00:01:42.000000', 'consum', 0.0218, 'lps'),
	(540100, 129, '2014-02-15 00:01:43.000000', 'consum', 0.0232, 'lps'),
	(540101, 129, '2014-02-15 00:01:44.000000', 'consum', 0.0222, 'lps'),
	(540102, 129, '2014-02-15 00:01:45.000000', 'consum', 0.0230, 'lps'),
	(540103, 129, '2014-02-15 00:01:46.000000', 'consum', 0.0222, 'lps'),
	(540104, 129, '2014-02-15 00:01:47.000000', 'consum', 0.0213, 'lps'),
	(540105, 129, '2014-02-15 00:01:48.000000', 'consum', 0.0214, 'lps'),
	(540106, 129, '2014-02-15 00:01:49.000000', 'consum', 0.0221, 'lps'),
	(540107, 129, '2014-02-15 00:01:50.000000', 'consum', 0.0230, 'lps'),
	(540108, 129, '2014-02-15 00:01:51.000000', 'consum', 0.0226, 'lps'),
	(540109, 129, '2014-02-15 00:01:52.000000', 'consum', 0.0232, 'lps'),
	(540110, 129, '2014-02-15 00:01:53.000000', 'consum', 0.0220, 'lps'),
	(540111, 129, '2014-02-15 00:01:54.000000', 'consum', 0.0223, 'lps'),
	(540112, 129, '2014-02-15 00:01:55.000000', 'consum', 0.0218, 'lps'),
	(540113, 129, '2014-02-15 00:01:56.000000', 'consum', 0.0211, 'lps'),
	(540114, 129, '2014-02-15 00:01:57.000000', 'consum', 0.0219, 'lps'),
	(540115, 129, '2014-02-15 00:01:58.000000', 'consum', 0.0228, 'lps'),
	(540116, 129, '2014-02-15 00:01:59.000000', 'consum', 0.0221, 'lps'),
	(540117, 129, '2014-02-15 00:02:00.000000', 'consum', 0.0213, 'lps'),
	(540118, 129, '2014-02-15 00:02:01.000000', 'consum', 0.0216, 'lps'),
	(540119, 129, '2014-02-15 00:02:02.000000', 'consum', 0.0233, 'lps'),
	(540120, 129, '2014-02-15 00:02:03.000000', 'consum', 0.0231, 'lps'),
	(540121, 129, '2014-02-15 00:02:04.000000', 'consum', 0.0221, 'lps'),
	(540122, 129, '2014-02-15 00:02:05.000000', 'consum', 0.0229, 'lps'),
	(540123, 129, '2014-02-15 00:02:06.000000', 'consum', 0.0223, 'lps'),
	(540124, 129, '2014-02-15 00:02:07.000000', 'consum', 0.0219, 'lps'),
	(540125, 129, '2014-02-15 00:02:08.000000', 'consum', 0.0214, 'lps'),
	(540126, 129, '2014-02-15 00:02:09.000000', 'consum', 0.0232, 'lps'),
	(540127, 129, '2014-02-15 00:02:10.000000', 'consum', 0.0231, 'lps'),
	(540128, 129, '2014-02-15 00:02:11.000000', 'consum', 0.0226, 'lps'),
	(540129, 129, '2014-02-15 00:02:12.000000', 'consum', 0.0225, 'lps'),
	(540130, 129, '2014-02-15 00:02:13.000000', 'consum', 0.0214, 'lps'),
	(540131, 129, '2014-02-15 00:02:14.000000', 'consum', 0.0233, 'lps'),
	(540132, 129, '2014-02-15 00:02:15.000000', 'consum', 0.0217, 'lps'),
	(540133, 129, '2014-02-15 00:02:16.000000', 'consum', 0.0224, 'lps'),
	(540134, 129, '2014-02-15 00:02:17.000000', 'consum', 0.0210, 'lps'),
	(540135, 129, '2014-02-15 00:02:18.000000', 'consum', 0.0217, 'lps'),
	(540136, 129, '2014-02-15 00:02:19.000000', 'consum', 0.0220, 'lps'),
	(540137, 129, '2014-02-15 00:02:20.000000', 'consum', 0.0218, 'lps'),
	(540138, 129, '2014-02-15 00:02:21.000000', 'consum', 0.0218, 'lps'),
	(540139, 129, '2014-02-15 00:02:22.000000', 'consum', 0.0228, 'lps'),
	(540140, 129, '2014-02-15 00:02:23.000000', 'consum', 0.0226, 'lps'),
	(540141, 129, '2014-02-15 00:02:24.000000', 'consum', 0.0210, 'lps'),
	(540142, 129, '2014-02-15 00:02:25.000000', 'consum', 0.0214, 'lps'),
	(540143, 129, '2014-02-15 00:02:26.000000', 'consum', 0.0230, 'lps'),
	(540144, 129, '2014-02-15 00:02:27.000000', 'consum', 0.0224, 'lps'),
	(540145, 129, '2014-02-15 00:02:28.000000', 'consum', 0.0222, 'lps'),
	(540146, 129, '2014-02-15 00:02:29.000000', 'consum', 0.0227, 'lps'),
	(540147, 129, '2014-02-15 00:02:30.000000', 'consum', 0.0212, 'lps'),
	(540148, 129, '2014-02-15 00:02:31.000000', 'consum', 0.0217, 'lps'),
	(540149, 129, '2014-02-15 00:02:32.000000', 'consum', 0.0214, 'lps'),
	(540150, 129, '2014-02-15 00:02:33.000000', 'consum', 0.0212, 'lps'),
	(540151, 129, '2014-02-15 00:02:34.000000', 'consum', 0.0234, 'lps'),
	(540152, 129, '2014-02-15 00:02:35.000000', 'consum', 0.0224, 'lps'),
	(540153, 129, '2014-02-15 00:02:36.000000', 'consum', 0.0232, 'lps'),
	(540154, 129, '2014-02-15 00:02:37.000000', 'consum', 0.0231, 'lps'),
	(540155, 129, '2014-02-15 00:02:38.000000', 'consum', 0.0224, 'lps'),
	(540156, 129, '2014-02-15 00:02:39.000000', 'consum', 0.0217, 'lps'),
	(540157, 129, '2014-02-15 00:02:40.000000', 'consum', 0.0229, 'lps'),
	(540158, 129, '2014-02-15 00:02:41.000000', 'consum', 0.0234, 'lps'),
	(540159, 129, '2014-02-15 00:02:42.000000', 'consum', 0.0225, 'lps'),
	(540160, 129, '2014-02-15 00:02:43.000000', 'consum', 0.0215, 'lps'),
	(540161, 129, '2014-02-15 00:02:44.000000', 'consum', 0.0212, 'lps'),
	(540162, 129, '2014-02-15 00:02:45.000000', 'consum', 0.0231, 'lps'),
	(540163, 129, '2014-02-15 00:02:46.000000', 'consum', 0.0234, 'lps'),
	(540164, 129, '2014-02-15 00:02:47.000000', 'consum', 0.0219, 'lps'),
	(540165, 129, '2014-02-15 00:02:48.000000', 'consum', 0.0234, 'lps'),
	(540166, 129, '2014-02-15 00:02:49.000000', 'consum', 0.0228, 'lps'),
	(540167, 129, '2014-02-15 00:02:50.000000', 'consum', 0.0230, 'lps'),
	(540168, 129, '2014-02-15 00:02:51.000000', 'consum', 0.0232, 'lps'),
	(540169, 129, '2014-02-15 00:02:52.000000', 'consum', 0.0211, 'lps'),
	(540170, 129, '2014-02-15 00:02:53.000000', 'consum', 0.0222, 'lps'),
	(540171, 129, '2014-02-15 00:02:54.000000', 'consum', 0.0220, 'lps'),
	(540172, 129, '2014-02-15 00:02:55.000000', 'consum', 0.0223, 'lps'),
	(540173, 129, '2014-02-15 00:02:56.000000', 'consum', 0.0221, 'lps'),
	(540174, 129, '2014-02-15 00:02:57.000000', 'consum', 0.0225, 'lps'),
	(540175, 129, '2014-02-15 00:02:58.000000', 'consum', 0.0230, 'lps'),
	(540176, 129, '2014-02-15 00:02:59.000000', 'consum', 0.0213, 'lps'),
	(540177, 129, '2014-02-15 00:03:00.000000', 'consum', 0.0216, 'lps'),
	(540178, 129, '2014-02-15 00:03:01.000000', 'consum', 0.0233, 'lps'),
	(540179, 129, '2014-02-15 00:03:02.000000', 'consum', 0.0233, 'lps'),
	(540180, 129, '2014-02-15 00:03:03.000000', 'consum', 0.0231, 'lps'),
	(540181, 129, '2014-02-15 00:03:04.000000', 'consum', 0.0221, 'lps'),
	(540182, 129, '2014-02-15 00:03:05.000000', 'consum', 0.0226, 'lps'),
	(540183, 129, '2014-02-15 00:03:06.000000', 'consum', 0.0234, 'lps'),
	(540184, 129, '2014-02-15 00:03:07.000000', 'consum', 0.0233, 'lps'),
	(540185, 129, '2014-02-15 00:03:08.000000', 'consum', 0.0228, 'lps'),
	(540186, 129, '2014-02-15 00:03:09.000000', 'consum', 0.0230, 'lps'),
	(540187, 129, '2014-02-15 00:03:10.000000', 'consum', 0.0232, 'lps'),
	(540188, 129, '2014-02-15 00:03:11.000000', 'consum', 0.0234, 'lps'),
	(540189, 129, '2014-02-15 00:03:12.000000', 'consum', 0.0215, 'lps'),
	(540190, 129, '2014-02-15 00:03:13.000000', 'consum', 0.0215, 'lps'),
	(540191, 129, '2014-02-15 00:03:14.000000', 'consum', 0.0220, 'lps'),
	(540192, 129, '2014-02-15 00:03:15.000000', 'consum', 0.0219, 'lps'),
	(540193, 129, '2014-02-15 00:03:16.000000', 'consum', 0.0227, 'lps'),
	(540194, 129, '2014-02-15 00:03:17.000000', 'consum', 0.0218, 'lps'),
	(540195, 129, '2014-02-15 00:03:18.000000', 'consum', 0.0224, 'lps'),
	(540196, 129, '2014-02-15 00:03:19.000000', 'consum', 0.0231, 'lps'),
	(540197, 129, '2014-02-15 00:03:20.000000', 'consum', 0.0222, 'lps'),
	(540198, 129, '2014-02-15 00:03:21.000000', 'consum', 0.0211, 'lps'),
	(540199, 129, '2014-02-15 00:03:22.000000', 'consum', 0.0228, 'lps'),
	(540200, 129, '2014-02-15 00:03:23.000000', 'consum', 0.0222, 'lps'),
	(540201, 129, '2014-02-15 00:03:24.000000', 'consum', 0.0218, 'lps'),
	(540202, 129, '2014-02-15 00:03:25.000000', 'consum', 0.0212, 'lps'),
	(540203, 129, '2014-02-15 00:03:26.000000', 'consum', 0.0222, 'lps'),
	(540204, 129, '2014-02-15 00:03:27.000000', 'consum', 0.0213, 'lps'),
	(540205, 129, '2014-02-15 00:03:28.000000', 'consum', 0.0217, 'lps'),
	(540206, 129, '2014-02-15 00:03:29.000000', 'consum', 0.0234, 'lps'),
	(540207, 129, '2014-02-15 00:03:30.000000', 'consum', 0.0213, 'lps'),
	(540208, 129, '2014-02-15 00:03:31.000000', 'consum', 0.0225, 'lps'),
	(540209, 129, '2014-02-15 00:03:32.000000', 'consum', 0.0229, 'lps'),
	(540210, 129, '2014-02-15 00:03:33.000000', 'consum', 0.0233, 'lps'),
	(540211, 129, '2014-02-15 00:03:34.000000', 'consum', 0.0219, 'lps'),
	(540212, 129, '2014-02-15 00:03:35.000000', 'consum', 0.0212, 'lps'),
	(540213, 129, '2014-02-15 00:03:36.000000', 'consum', 0.0217, 'lps'),
	(540214, 129, '2014-02-15 00:03:37.000000', 'consum', 0.0216, 'lps'),
	(540215, 129, '2014-02-15 00:03:38.000000', 'consum', 0.0220, 'lps'),
	(540216, 129, '2014-02-15 00:03:39.000000', 'consum', 0.0217, 'lps'),
	(540217, 129, '2014-02-15 00:03:40.000000', 'consum', 0.0215, 'lps'),
	(540218, 129, '2014-02-15 00:03:41.000000', 'consum', 0.0213, 'lps'),
	(540219, 129, '2014-02-15 00:03:42.000000', 'consum', 0.0212, 'lps'),
	(540220, 129, '2014-02-15 00:03:43.000000', 'consum', 0.0211, 'lps'),
	(540221, 129, '2014-02-15 00:03:44.000000', 'consum', 0.0210, 'lps'),
	(540222, 129, '2014-02-15 00:03:45.000000', 'consum', 0.0233, 'lps'),
	(540223, 129, '2014-02-15 00:03:46.000000', 'consum', 0.0223, 'lps'),
	(540224, 129, '2014-02-15 00:03:47.000000', 'consum', 0.0233, 'lps'),
	(540225, 129, '2014-02-15 00:03:48.000000', 'consum', 0.0214, 'lps'),
	(540226, 129, '2014-02-15 00:03:49.000000', 'consum', 0.0233, 'lps'),
	(540227, 129, '2014-02-15 00:03:50.000000', 'consum', 0.0214, 'lps'),
	(540228, 129, '2014-02-15 00:03:51.000000', 'consum', 0.0211, 'lps'),
	(540229, 129, '2014-02-15 00:03:52.000000', 'consum', 0.0230, 'lps'),
	(540230, 129, '2014-02-15 00:03:53.000000', 'consum', 0.0233, 'lps'),
	(540231, 129, '2014-02-15 00:03:54.000000', 'consum', 0.0215, 'lps'),
	(540232, 129, '2014-02-15 00:03:55.000000', 'consum', 0.0216, 'lps'),
	(540233, 129, '2014-02-15 00:03:56.000000', 'consum', 0.0226, 'lps'),
	(540234, 129, '2014-02-15 00:03:57.000000', 'consum', 0.0224, 'lps'),
	(540235, 129, '2014-02-15 00:03:58.000000', 'consum', 0.0232, 'lps'),
	(540236, 129, '2014-02-15 00:03:59.000000', 'consum', 0.0227, 'lps'),
	(540237, 129, '2014-02-15 00:04:00.000000', 'consum', 0.0231, 'lps'),
	(540238, 129, '2014-02-15 00:04:01.000000', 'consum', 0.0212, 'lps'),
	(540239, 129, '2014-02-15 00:04:02.000000', 'consum', 0.0210, 'lps'),
	(540240, 129, '2014-02-15 00:04:03.000000', 'consum', 0.0231, 'lps'),
	(540241, 129, '2014-02-15 00:04:04.000000', 'consum', 0.0213, 'lps'),
	(540242, 129, '2014-02-15 00:04:05.000000', 'consum', 0.0212, 'lps'),
	(540243, 129, '2014-02-15 00:04:06.000000', 'consum', 0.0212, 'lps'),
	(540244, 129, '2014-02-15 00:04:07.000000', 'consum', 0.0213, 'lps'),
	(540245, 129, '2014-02-15 00:04:08.000000', 'consum', 0.0219, 'lps'),
	(540246, 129, '2014-02-15 00:04:09.000000', 'consum', 0.0222, 'lps'),
	(540247, 129, '2014-02-15 00:04:10.000000', 'consum', 0.0218, 'lps'),
	(540248, 129, '2014-02-15 00:04:11.000000', 'consum', 0.0217, 'lps'),
	(540249, 129, '2014-02-15 00:04:12.000000', 'consum', 0.0221, 'lps'),
	(540250, 129, '2014-02-15 00:04:13.000000', 'consum', 0.0221, 'lps'),
	(540251, 129, '2014-02-15 00:04:14.000000', 'consum', 0.0231, 'lps'),
	(540252, 129, '2014-02-15 00:04:15.000000', 'consum', 0.0231, 'lps'),
	(540253, 129, '2014-02-15 00:04:16.000000', 'consum', 0.0228, 'lps'),
	(540254, 129, '2014-02-15 00:04:17.000000', 'consum', 0.0214, 'lps'),
	(540255, 129, '2014-02-15 00:04:18.000000', 'consum', 0.0224, 'lps'),
	(540256, 129, '2014-02-15 00:04:19.000000', 'consum', 0.0221, 'lps'),
	(540257, 129, '2014-02-15 00:04:20.000000', 'consum', 0.0223, 'lps'),
	(540258, 129, '2014-02-15 00:04:21.000000', 'consum', 0.0218, 'lps'),
	(540259, 129, '2014-02-15 00:04:22.000000', 'consum', 0.0213, 'lps'),
	(540260, 129, '2014-02-15 00:04:23.000000', 'consum', 0.0224, 'lps'),
	(540261, 129, '2014-02-15 00:04:24.000000', 'consum', 0.0222, 'lps'),
	(540262, 129, '2014-02-15 00:04:25.000000', 'consum', 0.0227, 'lps'),
	(540263, 129, '2014-02-15 00:04:26.000000', 'consum', 0.0210, 'lps'),
	(540264, 129, '2014-02-15 00:04:27.000000', 'consum', 0.0210, 'lps'),
	(540265, 129, '2014-02-15 00:04:28.000000', 'consum', 0.0234, 'lps'),
	(540266, 129, '2014-02-15 00:04:29.000000', 'consum', 0.0231, 'lps'),
	(540267, 129, '2014-02-15 00:04:30.000000', 'consum', 0.0218, 'lps'),
	(540268, 129, '2014-02-15 00:04:31.000000', 'consum', 0.0215, 'lps'),
	(540269, 129, '2014-02-15 00:04:32.000000', 'consum', 0.0210, 'lps'),
	(540270, 129, '2014-02-15 00:04:33.000000', 'consum', 0.0221, 'lps'),
	(540271, 129, '2014-02-15 00:04:34.000000', 'consum', 0.0214, 'lps'),
	(540272, 129, '2014-02-15 00:04:35.000000', 'consum', 0.0224, 'lps'),
	(540273, 129, '2014-02-15 00:04:36.000000', 'consum', 0.0216, 'lps'),
	(540274, 129, '2014-02-15 00:04:37.000000', 'consum', 0.0227, 'lps'),
	(540275, 129, '2014-02-15 00:04:38.000000', 'consum', 0.0225, 'lps'),
	(540276, 129, '2014-02-15 00:04:39.000000', 'consum', 0.0211, 'lps'),
	(540277, 129, '2014-02-15 00:04:40.000000', 'consum', 0.0220, 'lps'),
	(540278, 129, '2014-02-15 00:04:41.000000', 'consum', 0.0230, 'lps'),
	(540279, 129, '2014-02-15 00:04:42.000000', 'consum', 0.0234, 'lps'),
	(540280, 129, '2014-02-15 00:04:43.000000', 'consum', 0.0219, 'lps'),
	(540281, 129, '2014-02-15 00:04:44.000000', 'consum', 0.0232, 'lps'),
	(540282, 129, '2014-02-15 00:04:45.000000', 'consum', 0.0219, 'lps'),
	(540283, 129, '2014-02-15 00:04:46.000000', 'consum', 0.0215, 'lps'),
	(540284, 129, '2014-02-15 00:04:47.000000', 'consum', 0.0210, 'lps'),
	(540285, 129, '2014-02-15 00:04:48.000000', 'consum', 0.0221, 'lps'),
	(540286, 129, '2014-02-15 00:04:49.000000', 'consum', 0.0214, 'lps'),
	(540287, 129, '2014-02-15 00:04:50.000000', 'consum', 0.0221, 'lps'),
	(540288, 129, '2014-02-15 00:04:51.000000', 'consum', 0.0230, 'lps'),
	(540289, 129, '2014-02-15 00:04:52.000000', 'consum', 0.0226, 'lps'),
	(540290, 129, '2014-02-15 00:04:53.000000', 'consum', 0.0232, 'lps'),
	(540291, 129, '2014-02-15 00:04:54.000000', 'consum', 0.0224, 'lps'),
	(540292, 129, '2014-02-15 00:04:55.000000', 'consum', 0.0213, 'lps'),
	(540293, 129, '2014-02-15 00:04:56.000000', 'consum', 0.0233, 'lps'),
	(540294, 129, '2014-02-15 00:04:57.000000', 'consum', 0.0217, 'lps'),
	(540295, 129, '2014-02-15 00:04:58.000000', 'consum', 0.0225, 'lps'),
	(540296, 129, '2014-02-15 00:04:59.000000', 'consum', 0.0214, 'lps'),
	(540297, 129, '2014-02-15 00:05:00.000000', 'consum', 0.0214, 'lps'),
	(540298, 129, '2014-02-15 00:05:01.000000', 'consum', 0.0216, 'lps'),
	(540299, 129, '2014-02-15 00:05:02.000000', 'consum', 0.0227, 'lps'),
	(540300, 129, '2014-02-15 00:05:03.000000', 'consum', 0.0229, 'lps'),
	(540301, 129, '2014-02-15 00:05:04.000000', 'consum', 0.0228, 'lps'),
	(540302, 129, '2014-02-15 00:05:05.000000', 'consum', 0.0219, 'lps'),
	(540303, 129, '2014-02-15 00:05:06.000000', 'consum', 0.0227, 'lps'),
	(540304, 129, '2014-02-15 00:05:07.000000', 'consum', 0.0220, 'lps'),
	(540305, 129, '2014-02-15 00:05:08.000000', 'consum', 0.0234, 'lps'),
	(540306, 129, '2014-02-15 00:05:09.000000', 'consum', 0.0223, 'lps'),
	(540307, 129, '2014-02-15 00:05:10.000000', 'consum', 0.0230, 'lps'),
	(540308, 129, '2014-02-15 00:05:11.000000', 'consum', 0.0221, 'lps'),
	(540309, 129, '2014-02-15 00:05:12.000000', 'consum', 0.0231, 'lps'),
	(540310, 129, '2014-02-15 00:05:13.000000', 'consum', 0.0231, 'lps'),
	(540311, 129, '2014-02-15 00:05:14.000000', 'consum', 0.0230, 'lps'),
	(540312, 129, '2014-02-15 00:05:15.000000', 'consum', 0.0222, 'lps'),
	(540313, 129, '2014-02-15 00:05:16.000000', 'consum', 0.0211, 'lps'),
	(540314, 129, '2014-02-15 00:05:17.000000', 'consum', 0.0229, 'lps'),
	(540315, 129, '2014-02-15 00:05:18.000000', 'consum', 0.0228, 'lps'),
	(540316, 129, '2014-02-15 00:05:19.000000', 'consum', 0.0219, 'lps'),
	(540317, 129, '2014-02-15 00:05:20.000000', 'consum', 0.0226, 'lps'),
	(540318, 129, '2014-02-15 00:05:21.000000', 'consum', 0.0213, 'lps'),
	(540319, 129, '2014-02-15 00:05:22.000000', 'consum', 0.0229, 'lps'),
	(540320, 129, '2014-02-15 00:05:23.000000', 'consum', 0.0222, 'lps'),
	(540321, 129, '2014-02-15 00:05:24.000000', 'consum', 0.0213, 'lps'),
	(540322, 129, '2014-02-15 00:05:25.000000', 'consum', 0.0213, 'lps'),
	(540323, 129, '2014-02-15 00:05:26.000000', 'consum', 0.0219, 'lps'),
	(540324, 129, '2014-02-15 00:05:27.000000', 'consum', 0.0218, 'lps'),
	(540325, 129, '2014-02-15 00:05:28.000000', 'consum', 0.0227, 'lps'),
	(540326, 129, '2014-02-15 00:05:29.000000', 'consum', 0.0221, 'lps'),
	(540327, 129, '2014-02-15 00:05:30.000000', 'consum', 0.0214, 'lps'),
	(540328, 129, '2014-02-15 00:05:31.000000', 'consum', 0.0223, 'lps'),
	(540329, 129, '2014-02-15 00:05:32.000000', 'consum', 0.0214, 'lps'),
	(540330, 129, '2014-02-15 00:05:33.000000', 'consum', 0.0214, 'lps'),
	(540331, 129, '2014-02-15 00:05:34.000000', 'consum', 0.0219, 'lps'),
	(540332, 129, '2014-02-15 00:05:35.000000', 'consum', 0.0220, 'lps'),
	(540333, 129, '2014-02-15 00:05:36.000000', 'consum', 0.0210, 'lps'),
	(540334, 129, '2014-02-15 00:05:37.000000', 'consum', 0.0228, 'lps'),
	(540335, 129, '2014-02-15 00:05:38.000000', 'consum', 0.0226, 'lps'),
	(540336, 129, '2014-02-15 00:05:39.000000', 'consum', 0.0210, 'lps'),
	(540337, 129, '2014-02-15 00:05:40.000000', 'consum', 0.0216, 'lps'),
	(540338, 129, '2014-02-15 00:05:41.000000', 'consum', 0.0212, 'lps'),
	(540339, 129, '2014-02-15 00:05:42.000000', 'consum', 0.0231, 'lps'),
	(540340, 129, '2014-02-15 00:05:43.000000', 'consum', 0.0232, 'lps'),
	(540341, 129, '2014-02-15 00:05:44.000000', 'consum', 0.0231, 'lps'),
	(540342, 129, '2014-02-15 00:05:45.000000', 'consum', 0.0227, 'lps'),
	(540343, 129, '2014-02-15 00:05:46.000000', 'consum', 0.0234, 'lps'),
	(540344, 129, '2014-02-15 00:05:47.000000', 'consum', 0.0226, 'lps'),
	(540345, 129, '2014-02-15 00:05:48.000000', 'consum', 0.0219, 'lps'),
	(540346, 129, '2014-02-15 00:05:49.000000', 'consum', 0.0234, 'lps'),
	(540347, 129, '2014-02-15 00:05:50.000000', 'consum', 0.0227, 'lps'),
	(540348, 129, '2014-02-15 00:05:51.000000', 'consum', 0.0222, 'lps'),
	(540349, 129, '2014-02-15 00:05:52.000000', 'consum', 0.0223, 'lps'),
	(540350, 129, '2014-02-15 00:05:53.000000', 'consum', 0.0214, 'lps'),
	(540351, 129, '2014-02-15 00:05:54.000000', 'consum', 0.0214, 'lps'),
	(540352, 129, '2014-02-15 00:05:55.000000', 'consum', 0.0219, 'lps'),
	(540353, 129, '2014-02-15 00:05:56.000000', 'consum', 0.0220, 'lps'),
	(540354, 129, '2014-02-15 00:05:57.000000', 'consum', 0.0232, 'lps'),
	(540355, 129, '2014-02-15 00:05:58.000000', 'consum', 0.0216, 'lps'),
	(540356, 129, '2014-02-15 00:05:59.000000', 'consum', 0.0223, 'lps'),
	(540357, 129, '2014-02-15 00:06:00.000000', 'consum', 0.0210, 'lps'),
	(540358, 129, '2014-02-15 00:06:01.000000', 'consum', 0.0221, 'lps'),
	(540359, 129, '2014-02-15 00:06:02.000000', 'consum', 0.0217, 'lps'),
	(540360, 129, '2014-02-15 00:06:03.000000', 'consum', 0.0210, 'lps'),
	(540361, 129, '2014-02-15 00:06:04.000000', 'consum', 0.0214, 'lps'),
	(540362, 129, '2014-02-15 00:06:05.000000', 'consum', 0.0230, 'lps'),
	(540363, 129, '2014-02-15 00:06:06.000000', 'consum', 0.0226, 'lps'),
	(540364, 129, '2014-02-15 00:06:07.000000', 'consum', 0.0229, 'lps'),
	(540365, 129, '2014-02-15 00:06:08.000000', 'consum', 0.0234, 'lps'),
	(540366, 129, '2014-02-15 00:06:09.000000', 'consum', 0.0222, 'lps'),
	(540367, 129, '2014-02-15 00:06:10.000000', 'consum', 0.0223, 'lps'),
	(540368, 129, '2014-02-15 00:06:11.000000', 'consum', 0.0217, 'lps'),
	(540369, 129, '2014-02-15 00:06:12.000000', 'consum', 0.0230, 'lps'),
	(540370, 129, '2014-02-15 00:06:13.000000', 'consum', 0.0216, 'lps'),
	(540371, 129, '2014-02-15 00:06:14.000000', 'consum', 0.0230, 'lps'),
	(540372, 129, '2014-02-15 00:06:15.000000', 'consum', 0.0217, 'lps'),
	(540373, 129, '2014-02-15 00:06:16.000000', 'consum', 0.0212, 'lps'),
	(540374, 129, '2014-02-15 00:06:17.000000', 'consum', 0.0222, 'lps'),
	(540375, 129, '2014-02-15 00:06:18.000000', 'consum', 0.0215, 'lps'),
	(540376, 129, '2014-02-15 00:06:19.000000', 'consum', 0.0227, 'lps'),
	(540377, 129, '2014-02-15 00:06:20.000000', 'consum', 0.0228, 'lps'),
	(540378, 129, '2014-02-15 00:06:21.000000', 'consum', 0.0223, 'lps'),
	(540379, 129, '2014-02-15 00:06:22.000000', 'consum', 0.0224, 'lps'),
	(540380, 129, '2014-02-15 00:06:23.000000', 'consum', 0.0215, 'lps'),
	(540381, 129, '2014-02-15 00:06:24.000000', 'consum', 0.0218, 'lps'),
	(540382, 129, '2014-02-15 00:06:25.000000', 'consum', 0.0210, 'lps'),
	(540383, 129, '2014-02-15 00:06:26.000000', 'consum', 0.0214, 'lps'),
	(540384, 129, '2014-02-15 00:06:27.000000', 'consum', 0.0231, 'lps'),
	(540385, 129, '2014-02-15 00:06:28.000000', 'consum', 0.0227, 'lps'),
	(540386, 129, '2014-02-15 00:06:29.000000', 'consum', 0.0232, 'lps'),
	(540387, 129, '2014-02-15 00:06:30.000000', 'consum', 0.0219, 'lps'),
	(540388, 129, '2014-02-15 00:06:31.000000', 'consum', 0.0216, 'lps'),
	(540389, 129, '2014-02-15 00:06:32.000000', 'consum', 0.0211, 'lps'),
	(540390, 129, '2014-02-15 00:06:33.000000', 'consum', 0.0223, 'lps'),
	(540391, 129, '2014-02-15 00:06:34.000000', 'consum', 0.0224, 'lps'),
	(540392, 129, '2014-02-15 00:06:35.000000', 'consum', 0.0218, 'lps'),
	(540393, 129, '2014-02-15 00:06:36.000000', 'consum', 0.0230, 'lps'),
	(540394, 129, '2014-02-15 00:06:37.000000', 'consum', 0.0215, 'lps'),
	(540395, 129, '2014-02-15 00:06:38.000000', 'consum', 0.0223, 'lps'),
	(540396, 129, '2014-02-15 00:06:39.000000', 'consum', 0.0211, 'lps'),
	(540397, 129, '2014-02-15 00:06:40.000000', 'consum', 0.0228, 'lps'),
	(540398, 129, '2014-02-15 00:06:41.000000', 'consum', 0.0220, 'lps'),
	(540399, 129, '2014-02-15 00:06:42.000000', 'consum', 0.0234, 'lps'),
	(540400, 129, '2014-02-15 00:06:43.000000', 'consum', 0.0226, 'lps'),
	(540401, 129, '2014-02-15 00:06:44.000000', 'consum', 0.0219, 'lps'),
	(540402, 129, '2014-02-15 00:06:45.000000', 'consum', 0.0231, 'lps'),
	(540403, 129, '2014-02-15 00:06:46.000000', 'consum', 0.0215, 'lps'),
	(540404, 129, '2014-02-15 00:06:47.000000', 'consum', 0.0224, 'lps'),
	(540405, 129, '2014-02-15 00:06:48.000000', 'consum', 0.0213, 'lps'),
	(540406, 129, '2014-02-15 00:06:49.000000', 'consum', 0.0234, 'lps'),
	(540407, 129, '2014-02-15 00:06:50.000000', 'consum', 0.0221, 'lps'),
	(540408, 129, '2014-02-15 00:06:51.000000', 'consum', 0.0220, 'lps'),
	(540409, 129, '2014-02-15 00:06:52.000000', 'consum', 0.0228, 'lps'),
	(540410, 129, '2014-02-15 00:06:53.000000', 'consum', 0.0220, 'lps'),
	(540411, 129, '2014-02-15 00:06:54.000000', 'consum', 0.0231, 'lps'),
	(540412, 129, '2014-02-15 00:06:55.000000', 'consum', 0.0210, 'lps'),
	(540413, 129, '2014-02-15 00:06:56.000000', 'consum', 0.0223, 'lps'),
	(540414, 129, '2014-02-15 00:06:57.000000', 'consum', 0.0224, 'lps'),
	(540415, 129, '2014-02-15 00:06:58.000000', 'consum', 0.0216, 'lps'),
	(540416, 129, '2014-02-15 00:06:59.000000', 'consum', 0.0225, 'lps'),
	(540417, 129, '2014-02-15 00:07:00.000000', 'consum', 0.0219, 'lps'),
	(540418, 129, '2014-02-15 00:07:01.000000', 'consum', 0.0233, 'lps'),
	(540419, 129, '2014-02-15 00:07:02.000000', 'consum', 0.0225, 'lps'),
	(540420, 129, '2014-02-15 00:07:03.000000', 'consum', 0.0217, 'lps'),
	(540421, 129, '2014-02-15 00:07:04.000000', 'consum', 0.0223, 'lps'),
	(540422, 129, '2014-02-15 00:07:05.000000', 'consum', 0.0232, 'lps'),
	(540423, 129, '2014-02-15 00:07:06.000000', 'consum', 0.0230, 'lps'),
	(540424, 129, '2014-02-15 00:07:07.000000', 'consum', 0.0220, 'lps'),
	(540425, 129, '2014-02-15 00:07:08.000000', 'consum', 0.0227, 'lps'),
	(540426, 129, '2014-02-15 00:07:09.000000', 'consum', 0.0217, 'lps'),
	(540427, 129, '2014-02-15 00:07:10.000000', 'consum', 0.0216, 'lps'),
	(540428, 129, '2014-02-15 00:07:11.000000', 'consum', 0.0220, 'lps'),
	(540429, 129, '2014-02-15 00:07:12.000000', 'consum', 0.0216, 'lps'),
	(540430, 129, '2014-02-15 00:07:13.000000', 'consum', 0.0214, 'lps'),
	(540431, 129, '2014-02-15 00:07:14.000000', 'consum', 0.0211, 'lps'),
	(540432, 129, '2014-02-15 00:07:15.000000', 'consum', 0.0226, 'lps'),
	(540433, 129, '2014-02-15 00:07:16.000000', 'consum', 0.0216, 'lps'),
	(540434, 129, '2014-02-15 00:07:17.000000', 'consum', 0.0217, 'lps'),
	(540435, 129, '2014-02-15 00:07:18.000000', 'consum', 0.0229, 'lps'),
	(540436, 129, '2014-02-15 00:07:19.000000', 'consum', 0.0231, 'lps'),
	(540437, 129, '2014-02-15 00:07:20.000000', 'consum', 0.0212, 'lps'),
	(540438, 129, '2014-02-15 00:07:21.000000', 'consum', 0.0230, 'lps'),
	(540439, 129, '2014-02-15 00:07:22.000000', 'consum', 0.0231, 'lps'),
	(540440, 129, '2014-02-15 00:07:23.000000', 'consum', 0.0231, 'lps'),
	(540441, 129, '2014-02-15 00:07:24.000000', 'consum', 0.0228, 'lps'),
	(540442, 129, '2014-02-15 00:07:25.000000', 'consum', 0.0213, 'lps'),
	(540443, 129, '2014-02-15 00:07:26.000000', 'consum', 0.0220, 'lps'),
	(540444, 129, '2014-02-15 00:07:27.000000', 'consum', 0.0227, 'lps'),
	(540445, 129, '2014-02-15 00:07:28.000000', 'consum', 0.0217, 'lps'),
	(540446, 129, '2014-02-15 00:07:29.000000', 'consum', 0.0217, 'lps'),
	(540447, 129, '2014-02-15 00:07:30.000000', 'consum', 0.0225, 'lps'),
	(540448, 129, '2014-02-15 00:07:31.000000', 'consum', 0.0216, 'lps'),
	(540449, 129, '2014-02-15 00:07:32.000000', 'consum', 0.0218, 'lps'),
	(540450, 129, '2014-02-15 00:07:33.000000', 'consum', 0.0234, 'lps'),
	(540451, 129, '2014-02-15 00:07:34.000000', 'consum', 0.0232, 'lps'),
	(540452, 129, '2014-02-15 00:07:35.000000', 'consum', 0.0221, 'lps'),
	(540453, 129, '2014-02-15 00:07:36.000000', 'consum', 0.0228, 'lps'),
	(540454, 129, '2014-02-15 00:07:37.000000', 'consum', 0.0215, 'lps'),
	(540455, 129, '2014-02-15 00:07:38.000000', 'consum', 0.0231, 'lps'),
	(540456, 129, '2014-02-15 00:07:39.000000', 'consum', 0.0228, 'lps'),
	(540457, 129, '2014-02-15 00:07:40.000000', 'consum', 0.0210, 'lps'),
	(540458, 129, '2014-02-15 00:07:41.000000', 'consum', 0.0234, 'lps'),
	(540459, 129, '2014-02-15 00:07:42.000000', 'consum', 0.0230, 'lps'),
	(540460, 129, '2014-02-15 00:07:43.000000', 'consum', 0.0215, 'lps'),
	(540461, 129, '2014-02-15 00:07:44.000000', 'consum', 0.0222, 'lps'),
	(540462, 129, '2014-02-15 00:07:45.000000', 'consum', 0.0232, 'lps'),
	(540463, 129, '2014-02-15 00:07:46.000000', 'consum', 0.0211, 'lps'),
	(540464, 129, '2014-02-15 00:07:47.000000', 'consum', 0.0224, 'lps'),
	(540465, 129, '2014-02-15 00:07:48.000000', 'consum', 0.0226, 'lps'),
	(540466, 129, '2014-02-15 00:07:49.000000', 'consum', 0.0224, 'lps'),
	(540467, 129, '2014-02-15 00:07:50.000000', 'consum', 0.0232, 'lps'),
	(540468, 129, '2014-02-15 00:07:51.000000', 'consum', 0.0229, 'lps'),
	(540469, 129, '2014-02-15 00:07:52.000000', 'consum', 0.0216, 'lps'),
	(540470, 129, '2014-02-15 00:07:53.000000', 'consum', 0.0231, 'lps'),
	(540471, 129, '2014-02-15 00:07:54.000000', 'consum', 0.0224, 'lps'),
	(540472, 129, '2014-02-15 00:07:55.000000', 'consum', 0.0219, 'lps'),
	(540473, 129, '2014-02-15 00:07:56.000000', 'consum', 0.0211, 'lps'),
	(540474, 129, '2014-02-15 00:07:57.000000', 'consum', 0.0215, 'lps'),
	(540475, 129, '2014-02-15 00:07:58.000000', 'consum', 0.0231, 'lps'),
	(540476, 129, '2014-02-15 00:07:59.000000', 'consum', 0.0227, 'lps'),
	(540477, 129, '2014-02-15 00:08:00.000000', 'consum', 0.0231, 'lps'),
	(540478, 129, '2014-02-15 00:08:01.000000', 'consum', 0.0215, 'lps'),
	(540479, 129, '2014-02-15 00:08:02.000000', 'consum', 0.0222, 'lps'),
	(540480, 129, '2014-02-15 00:08:03.000000', 'consum', 0.0233, 'lps'),
	(540481, 129, '2014-02-15 00:08:04.000000', 'consum', 0.0212, 'lps'),
	(540482, 129, '2014-02-15 00:08:05.000000', 'consum', 0.0228, 'lps'),
	(540483, 129, '2014-02-15 00:08:06.000000', 'consum', 0.0217, 'lps'),
	(540484, 129, '2014-02-15 00:08:07.000000', 'consum', 0.0218, 'lps'),
	(540485, 129, '2014-02-15 00:08:08.000000', 'consum', 0.0231, 'lps'),
	(540486, 129, '2014-02-15 00:08:09.000000', 'consum', 0.0216, 'lps'),
	(540487, 129, '2014-02-15 00:08:10.000000', 'consum', 0.0229, 'lps'),
	(540488, 129, '2014-02-15 00:08:11.000000', 'consum', 0.0210, 'lps'),
	(540489, 129, '2014-02-15 00:08:12.000000', 'consum', 0.0230, 'lps'),
	(540490, 129, '2014-02-15 00:08:13.000000', 'consum', 0.0234, 'lps'),
	(540491, 129, '2014-02-15 00:08:14.000000', 'consum', 0.0220, 'lps'),
	(540492, 129, '2014-02-15 00:08:15.000000', 'consum', 0.0212, 'lps'),
	(540493, 129, '2014-02-15 00:08:16.000000', 'consum', 0.0218, 'lps'),
	(540494, 129, '2014-02-15 00:08:17.000000', 'consum', 0.0220, 'lps'),
	(540495, 129, '2014-02-15 00:08:18.000000', 'consum', 0.0213, 'lps'),
	(540496, 129, '2014-02-15 00:08:19.000000', 'consum', 0.0217, 'lps'),
	(540497, 129, '2014-02-15 00:08:20.000000', 'consum', 0.0212, 'lps'),
	(540498, 129, '2014-02-15 00:08:21.000000', 'consum', 0.0226, 'lps'),
	(540499, 129, '2014-02-15 00:08:22.000000', 'consum', 0.0211, 'lps'),
	(540500, 129, '2014-02-15 00:08:23.000000', 'consum', 0.0215, 'lps'),
	(540501, 129, '2014-02-15 00:08:24.000000', 'consum', 0.0210, 'lps'),
	(540502, 129, '2014-02-15 00:08:25.000000', 'consum', 0.0220, 'lps'),
	(540503, 129, '2014-02-15 00:08:26.000000', 'consum', 0.0212, 'lps'),
	(540504, 129, '2014-02-15 00:08:27.000000', 'consum', 0.0213, 'lps'),
	(540505, 129, '2014-02-15 00:08:28.000000', 'consum', 0.0222, 'lps'),
	(540506, 129, '2014-02-15 00:08:29.000000', 'consum', 0.0212, 'lps'),
	(540507, 129, '2014-02-15 00:08:30.000000', 'consum', 0.0232, 'lps'),
	(540508, 129, '2014-02-15 00:08:31.000000', 'consum', 0.0217, 'lps'),
	(540509, 129, '2014-02-15 00:08:32.000000', 'consum', 0.0228, 'lps'),
	(540510, 129, '2014-02-15 00:08:33.000000', 'consum', 0.0229, 'lps'),
	(540511, 129, '2014-02-15 00:08:34.000000', 'consum', 0.0229, 'lps'),
	(540512, 129, '2014-02-15 00:08:35.000000', 'consum', 0.0222, 'lps'),
	(540513, 129, '2014-02-15 00:08:36.000000', 'consum', 0.0214, 'lps'),
	(540514, 129, '2014-02-15 00:08:37.000000', 'consum', 0.0218, 'lps'),
	(540515, 129, '2014-02-15 00:08:38.000000', 'consum', 0.0213, 'lps'),
	(540516, 129, '2014-02-15 00:08:39.000000', 'consum', 0.0229, 'lps'),
	(540517, 129, '2014-02-15 00:08:40.000000', 'consum', 0.0222, 'lps'),
	(540518, 129, '2014-02-15 00:08:41.000000', 'consum', 0.0214, 'lps'),
	(540519, 129, '2014-02-15 00:08:42.000000', 'consum', 0.0220, 'lps'),
	(540520, 129, '2014-02-15 00:08:43.000000', 'consum', 0.0222, 'lps'),
	(540521, 129, '2014-02-15 00:08:44.000000', 'consum', 0.0217, 'lps'),
	(540522, 129, '2014-02-15 00:08:45.000000', 'consum', 0.0232, 'lps'),
	(540523, 129, '2014-02-15 00:08:46.000000', 'consum', 0.0227, 'lps'),
	(540524, 129, '2014-02-15 00:08:47.000000', 'consum', 0.0230, 'lps'),
	(540525, 129, '2014-02-15 00:08:48.000000', 'consum', 0.0232, 'lps'),
	(540526, 129, '2014-02-15 00:08:49.000000', 'consum', 0.0211, 'lps'),
	(540527, 129, '2014-02-15 00:08:50.000000', 'consum', 0.0224, 'lps'),
	(540528, 129, '2014-02-15 00:08:51.000000', 'consum', 0.0230, 'lps'),
	(540529, 129, '2014-02-15 00:08:52.000000', 'consum', 0.0217, 'lps'),
	(540530, 129, '2014-02-15 00:08:53.000000', 'consum', 0.0234, 'lps'),
	(540531, 129, '2014-02-15 00:08:54.000000', 'consum', 0.0234, 'lps'),
	(540532, 129, '2014-02-15 00:08:55.000000', 'consum', 0.0211, 'lps'),
	(540533, 129, '2014-02-15 00:08:56.000000', 'consum', 0.0219, 'lps'),
	(540534, 129, '2014-02-15 00:08:57.000000', 'consum', 0.0228, 'lps'),
	(540535, 129, '2014-02-15 00:08:58.000000', 'consum', 0.0222, 'lps'),
	(540536, 129, '2014-02-15 00:08:59.000000', 'consum', 0.0218, 'lps'),
	(540537, 129, '2014-02-15 00:09:00.000000', 'consum', 0.0214, 'lps'),
	(540538, 129, '2014-02-15 00:09:01.000000', 'consum', 0.0232, 'lps'),
	(540539, 129, '2014-02-15 00:09:02.000000', 'consum', 0.0232, 'lps'),
	(540540, 129, '2014-02-15 00:09:03.000000', 'consum', 0.0228, 'lps'),
	(540541, 129, '2014-02-15 00:09:04.000000', 'consum', 0.0213, 'lps'),
	(540542, 129, '2014-02-15 00:09:05.000000', 'consum', 0.0218, 'lps'),
	(540543, 129, '2014-02-15 00:09:06.000000', 'consum', 0.0219, 'lps'),
	(540544, 129, '2014-02-15 00:09:07.000000', 'consum', 0.0233, 'lps'),
	(540545, 129, '2014-02-15 00:09:08.000000', 'consum', 0.0221, 'lps'),
	(540546, 129, '2014-02-15 00:09:09.000000', 'consum', 0.0223, 'lps'),
	(540547, 129, '2014-02-15 00:09:10.000000', 'consum', 0.0218, 'lps'),
	(540548, 129, '2014-02-15 00:09:11.000000', 'consum', 0.0212, 'lps'),
	(540549, 129, '2014-02-15 00:09:12.000000', 'consum', 0.0219, 'lps'),
	(540550, 129, '2014-02-15 00:09:13.000000', 'consum', 0.0224, 'lps'),
	(540551, 129, '2014-02-15 00:09:14.000000', 'consum', 0.0228, 'lps'),
	(540552, 129, '2014-02-15 00:09:15.000000', 'consum', 0.0233, 'lps'),
	(540553, 129, '2014-02-15 00:09:16.000000', 'consum', 0.0224, 'lps'),
	(540554, 129, '2014-02-15 00:09:17.000000', 'consum', 0.0210, 'lps'),
	(540555, 129, '2014-02-15 00:09:18.000000', 'consum', 0.0220, 'lps'),
	(540556, 129, '2014-02-15 00:09:19.000000', 'consum', 0.0211, 'lps'),
	(540557, 129, '2014-02-15 00:09:20.000000', 'consum', 0.0210, 'lps'),
	(540558, 129, '2014-02-15 00:09:21.000000', 'consum', 0.0231, 'lps'),
	(540559, 129, '2014-02-15 00:09:22.000000', 'consum', 0.0218, 'lps'),
	(540560, 129, '2014-02-15 00:09:23.000000', 'consum', 0.0211, 'lps'),
	(540561, 129, '2014-02-15 00:09:24.000000', 'consum', 0.0217, 'lps'),
	(540562, 129, '2014-02-15 00:09:25.000000', 'consum', 0.0215, 'lps'),
	(540563, 129, '2014-02-15 00:09:26.000000', 'consum', 0.0218, 'lps'),
	(540564, 129, '2014-02-15 00:09:27.000000', 'consum', 0.0210, 'lps'),
	(540565, 129, '2014-02-15 00:09:28.000000', 'consum', 0.0210, 'lps'),
	(540566, 129, '2014-02-15 00:09:29.000000', 'consum', 0.0211, 'lps'),
	(540567, 129, '2014-02-15 00:09:30.000000', 'consum', 0.0217, 'lps'),
	(540568, 129, '2014-02-15 00:09:31.000000', 'consum', 0.0215, 'lps'),
	(540569, 129, '2014-02-15 00:09:32.000000', 'consum', 0.0215, 'lps'),
	(540570, 129, '2014-02-15 00:09:33.000000', 'consum', 0.0221, 'lps'),
	(540571, 129, '2014-02-15 00:09:34.000000', 'consum', 0.0225, 'lps'),
	(540572, 129, '2014-02-15 00:09:35.000000', 'consum', 0.0229, 'lps'),
	(540573, 129, '2014-02-15 00:09:36.000000', 'consum', 0.0234, 'lps'),
	(540574, 129, '2014-02-15 00:09:37.000000', 'consum', 0.0224, 'lps'),
	(540575, 129, '2014-02-15 00:09:38.000000', 'consum', 0.0232, 'lps'),
	(540576, 129, '2014-02-15 00:09:39.000000', 'consum', 0.0231, 'lps'),
	(540577, 129, '2014-02-15 00:09:40.000000', 'consum', 0.0222, 'lps'),
	(540578, 129, '2014-02-15 00:09:41.000000', 'consum', 0.0231, 'lps'),
	(540579, 129, '2014-02-15 00:09:42.000000', 'consum', 0.0233, 'lps'),
	(540580, 129, '2014-02-15 00:09:43.000000', 'consum', 0.0212, 'lps'),
	(540581, 129, '2014-02-15 00:09:44.000000', 'consum', 0.0227, 'lps'),
	(540582, 129, '2014-02-15 00:09:45.000000', 'consum', 0.0215, 'lps'),
	(540583, 129, '2014-02-15 00:09:46.000000', 'consum', 0.0210, 'lps'),
	(540584, 129, '2014-02-15 00:09:47.000000', 'consum', 0.0221, 'lps'),
	(540585, 129, '2014-02-15 00:09:48.000000', 'consum', 0.0215, 'lps'),
	(540586, 129, '2014-02-15 00:09:49.000000', 'consum', 0.0228, 'lps'),
	(540587, 129, '2014-02-15 00:09:50.000000', 'consum', 0.0211, 'lps'),
	(540588, 129, '2014-02-15 00:09:51.000000', 'consum', 0.0234, 'lps'),
	(540589, 129, '2014-02-15 00:09:52.000000', 'consum', 0.0227, 'lps'),
	(540590, 129, '2014-02-15 00:09:53.000000', 'consum', 0.0227, 'lps'),
	(540591, 129, '2014-02-15 00:09:54.000000', 'consum', 0.0217, 'lps'),
	(540592, 129, '2014-02-15 00:09:55.000000', 'consum', 0.0219, 'lps'),
	(540593, 129, '2014-02-15 00:09:56.000000', 'consum', 0.0212, 'lps'),
	(540594, 129, '2014-02-15 00:09:57.000000', 'consum', 0.0219, 'lps'),
	(540595, 129, '2014-02-15 00:09:58.000000', 'consum', 0.0223, 'lps'),
	(540596, 129, '2014-02-15 00:09:59.000000', 'consum', 0.0222, 'lps'),
	(540597, 129, '2014-02-15 00:10:00.000000', 'consum', 0.0232, 'lps'),
	(540598, 129, '2014-02-15 00:10:01.000000', 'consum', 0.0233, 'lps'),
	(540599, 129, '2014-02-15 00:10:02.000000', 'consum', 0.0211, 'lps'),
	(540600, 129, '2014-02-15 00:10:03.000000', 'consum', 0.0220, 'lps'),
	(540601, 129, '2014-02-15 00:10:04.000000', 'consum', 0.0210, 'lps'),
	(540602, 129, '2014-02-15 00:10:05.000000', 'consum', 0.0229, 'lps'),
	(540603, 129, '2014-02-15 00:10:06.000000', 'consum', 0.0229, 'lps'),
	(540604, 129, '2014-02-15 00:10:07.000000', 'consum', 0.0225, 'lps'),
	(540605, 129, '2014-02-15 00:10:08.000000', 'consum', 0.0227, 'lps'),
	(540606, 129, '2014-02-15 00:10:09.000000', 'consum', 0.0224, 'lps'),
	(540607, 129, '2014-02-15 00:10:10.000000', 'consum', 0.0233, 'lps'),
	(540608, 129, '2014-02-15 00:10:11.000000', 'consum', 0.0233, 'lps'),
	(540609, 129, '2014-02-15 00:10:12.000000', 'consum', 0.0233, 'lps'),
	(540610, 129, '2014-02-15 00:10:13.000000', 'consum', 0.0229, 'lps'),
	(540611, 129, '2014-02-15 00:10:14.000000', 'consum', 0.0213, 'lps'),
	(540612, 129, '2014-02-15 00:10:15.000000', 'consum', 0.0218, 'lps'),
	(540613, 129, '2014-02-15 00:10:16.000000', 'consum', 0.0215, 'lps'),
	(540614, 129, '2014-02-15 00:10:17.000000', 'consum', 0.0214, 'lps'),
	(540615, 129, '2014-02-15 00:10:18.000000', 'consum', 0.0214, 'lps'),
	(540616, 129, '2014-02-15 00:10:19.000000', 'consum', 0.0221, 'lps'),
	(540617, 129, '2014-02-15 00:10:20.000000', 'consum', 0.0226, 'lps'),
	(540618, 129, '2014-02-15 00:10:21.000000', 'consum', 0.0232, 'lps'),
	(540619, 129, '2014-02-15 00:10:22.000000', 'consum', 0.0225, 'lps'),
	(540620, 129, '2014-02-15 00:10:23.000000', 'consum', 0.0217, 'lps'),
	(540621, 129, '2014-02-15 00:10:24.000000', 'consum', 0.0228, 'lps'),
	(540622, 129, '2014-02-15 00:10:25.000000', 'consum', 0.0229, 'lps'),
	(540623, 129, '2014-02-15 00:10:26.000000', 'consum', 0.0225, 'lps'),
	(540624, 129, '2014-02-15 00:10:27.000000', 'consum', 0.0230, 'lps'),
	(540625, 129, '2014-02-15 00:10:28.000000', 'consum', 0.0217, 'lps'),
	(540626, 129, '2014-02-15 00:10:29.000000', 'consum', 0.0234, 'lps'),
	(540627, 129, '2014-02-15 00:10:30.000000', 'consum', 0.0210, 'lps'),
	(540628, 129, '2014-02-15 00:10:31.000000', 'consum', 0.0213, 'lps'),
	(540629, 129, '2014-02-15 00:10:32.000000', 'consum', 0.0224, 'lps'),
	(540630, 129, '2014-02-15 00:10:33.000000', 'consum', 0.0221, 'lps'),
	(540631, 129, '2014-02-15 00:10:34.000000', 'consum', 0.0225, 'lps'),
	(540632, 129, '2014-02-15 00:10:35.000000', 'consum', 0.0229, 'lps'),
	(540633, 129, '2014-02-15 00:10:36.000000', 'consum', 0.0233, 'lps'),
	(540634, 129, '2014-02-15 00:10:37.000000', 'consum', 0.0220, 'lps'),
	(540635, 129, '2014-02-15 00:10:38.000000', 'consum', 0.0215, 'lps'),
	(540636, 129, '2014-02-15 00:10:39.000000', 'consum', 0.0230, 'lps'),
	(540637, 129, '2014-02-15 00:10:40.000000', 'consum', 0.0221, 'lps'),
	(540638, 129, '2014-02-15 00:10:41.000000', 'consum', 0.0230, 'lps'),
	(540639, 129, '2014-02-15 00:10:42.000000', 'consum', 0.0227, 'lps'),
	(540640, 129, '2014-02-15 00:10:43.000000', 'consum', 0.0213, 'lps'),
	(540641, 129, '2014-02-15 00:10:44.000000', 'consum', 0.0224, 'lps'),
	(540642, 129, '2014-02-15 00:10:45.000000', 'consum', 0.0221, 'lps'),
	(540643, 129, '2014-02-15 00:10:46.000000', 'consum', 0.0225, 'lps'),
	(540644, 129, '2014-02-15 00:10:47.000000', 'consum', 0.0227, 'lps'),
	(540645, 129, '2014-02-15 00:10:48.000000', 'consum', 0.0227, 'lps'),
	(540646, 129, '2014-02-15 00:10:49.000000', 'consum', 0.0218, 'lps'),
	(540647, 129, '2014-02-15 00:10:50.000000', 'consum', 0.0226, 'lps'),
	(540648, 129, '2014-02-15 00:10:51.000000', 'consum', 0.0216, 'lps'),
	(540649, 129, '2014-02-15 00:10:52.000000', 'consum', 0.0216, 'lps'),
	(540650, 129, '2014-02-15 00:10:53.000000', 'consum', 0.0224, 'lps'),
	(540651, 129, '2014-02-15 00:10:54.000000', 'consum', 0.0212, 'lps'),
	(540652, 129, '2014-02-15 00:10:55.000000', 'consum', 0.0231, 'lps'),
	(540653, 129, '2014-02-15 00:10:56.000000', 'consum', 0.0231, 'lps'),
	(540654, 129, '2014-02-15 00:10:57.000000', 'consum', 0.0228, 'lps'),
	(540655, 129, '2014-02-15 00:10:58.000000', 'consum', 0.0215, 'lps'),
	(540656, 129, '2014-02-15 00:10:59.000000', 'consum', 0.0229, 'lps'),
	(540657, 129, '2014-02-15 00:11:00.000000', 'consum', 0.0217, 'lps'),
	(540658, 129, '2014-02-15 00:11:01.000000', 'consum', 0.0213, 'lps'),
	(540659, 129, '2014-02-15 00:11:02.000000', 'consum', 0.0228, 'lps'),
	(540660, 129, '2014-02-15 00:11:03.000000', 'consum', 0.0216, 'lps'),
	(540661, 129, '2014-02-15 00:11:04.000000', 'consum', 0.0212, 'lps'),
	(540662, 129, '2014-02-15 00:11:05.000000', 'consum', 0.0228, 'lps'),
	(540663, 129, '2014-02-15 00:11:06.000000', 'consum', 0.0219, 'lps'),
	(540664, 129, '2014-02-15 00:11:07.000000', 'consum', 0.0227, 'lps'),
	(540665, 129, '2014-02-15 00:11:08.000000', 'consum', 0.0220, 'lps'),
	(540666, 129, '2014-02-15 00:11:09.000000', 'consum', 0.0231, 'lps'),
	(540667, 129, '2014-02-15 00:11:10.000000', 'consum', 0.0214, 'lps'),
	(540668, 129, '2014-02-15 00:11:11.000000', 'consum', 0.0214, 'lps'),
	(540669, 129, '2014-02-15 00:11:12.000000', 'consum', 0.0222, 'lps'),
	(540670, 129, '2014-02-15 00:11:13.000000', 'consum', 0.0231, 'lps'),
	(540671, 129, '2014-02-15 00:11:14.000000', 'consum', 0.0231, 'lps'),
	(540672, 129, '2014-02-15 00:11:15.000000', 'consum', 0.0225, 'lps'),
	(540673, 129, '2014-02-15 00:11:16.000000', 'consum', 0.0225, 'lps'),
	(540674, 129, '2014-02-15 00:11:17.000000', 'consum', 0.0213, 'lps'),
	(540675, 129, '2014-02-15 00:11:18.000000', 'consum', 0.0232, 'lps'),
	(540676, 129, '2014-02-15 00:11:19.000000', 'consum', 0.0211, 'lps'),
	(540677, 129, '2014-02-15 00:11:20.000000', 'consum', 0.0227, 'lps'),
	(540678, 129, '2014-02-15 00:11:21.000000', 'consum', 0.0215, 'lps'),
	(540679, 129, '2014-02-15 00:11:22.000000', 'consum', 0.0210, 'lps'),
	(540680, 129, '2014-02-15 00:11:23.000000', 'consum', 0.0220, 'lps'),
	(540681, 129, '2014-02-15 00:11:24.000000', 'consum', 0.0211, 'lps'),
	(540682, 129, '2014-02-15 00:11:25.000000', 'consum', 0.0211, 'lps'),
	(540683, 129, '2014-02-15 00:11:26.000000', 'consum', 0.0212, 'lps'),
	(540684, 129, '2014-02-15 00:11:27.000000', 'consum', 0.0217, 'lps'),
	(540685, 129, '2014-02-15 00:11:28.000000', 'consum', 0.0217, 'lps'),
	(540686, 129, '2014-02-15 00:11:29.000000', 'consum', 0.0223, 'lps'),
	(540687, 129, '2014-02-15 00:11:30.000000', 'consum', 0.0230, 'lps'),
	(540688, 129, '2014-02-15 00:11:31.000000', 'consum', 0.0220, 'lps'),
	(540689, 129, '2014-02-15 00:11:32.000000', 'consum', 0.0226, 'lps'),
	(540690, 129, '2014-02-15 00:11:33.000000', 'consum', 0.0211, 'lps'),
	(540691, 129, '2014-02-15 00:11:34.000000', 'consum', 0.0217, 'lps'),
	(540692, 129, '2014-02-15 00:11:35.000000', 'consum', 0.0217, 'lps'),
	(540693, 129, '2014-02-15 00:11:36.000000', 'consum', 0.0224, 'lps'),
	(540694, 129, '2014-02-15 00:11:37.000000', 'consum', 0.0233, 'lps'),
	(540695, 129, '2014-02-15 00:11:38.000000', 'consum', 0.0211, 'lps'),
	(540696, 129, '2014-02-15 00:11:39.000000', 'consum', 0.0219, 'lps'),
	(540697, 129, '2014-02-15 00:11:40.000000', 'consum', 0.0230, 'lps'),
	(540698, 129, '2014-02-15 00:11:41.000000', 'consum', 0.0231, 'lps'),
	(540699, 129, '2014-02-15 00:11:42.000000', 'consum', 0.0230, 'lps'),
	(540700, 129, '2014-02-15 00:11:43.000000', 'consum', 0.0223, 'lps'),
	(540701, 129, '2014-02-15 00:11:44.000000', 'consum', 0.0216, 'lps'),
	(540702, 129, '2014-02-15 00:11:45.000000', 'consum', 0.0228, 'lps'),
	(540703, 129, '2014-02-15 00:11:46.000000', 'consum', 0.0232, 'lps'),
	(540704, 129, '2014-02-15 00:11:47.000000', 'consum', 0.0217, 'lps'),
	(540705, 129, '2014-02-15 00:11:48.000000', 'consum', 0.0230, 'lps'),
	(540706, 129, '2014-02-15 00:11:49.000000', 'consum', 0.0212, 'lps'),
	(540707, 129, '2014-02-15 00:11:50.000000', 'consum', 0.0212, 'lps'),
	(540708, 129, '2014-02-15 00:11:51.000000', 'consum', 0.0213, 'lps'),
	(540709, 129, '2014-02-15 00:11:52.000000', 'consum', 0.0222, 'lps'),
	(540710, 129, '2014-02-15 00:11:53.000000', 'consum', 0.0211, 'lps'),
	(540711, 129, '2014-02-15 00:11:54.000000', 'consum', 0.0229, 'lps'),
	(540712, 129, '2014-02-15 00:11:55.000000', 'consum', 0.0226, 'lps'),
	(540713, 129, '2014-02-15 00:11:56.000000', 'consum', 0.0234, 'lps'),
	(540714, 129, '2014-02-15 00:11:57.000000', 'consum', 0.0232, 'lps'),
	(540715, 129, '2014-02-15 00:11:58.000000', 'consum', 0.0224, 'lps'),
	(540716, 129, '2014-02-15 00:11:59.000000', 'consum', 0.0216, 'lps'),
	(540717, 129, '2014-02-15 00:12:00.000000', 'consum', 0.0222, 'lps'),
	(540718, 129, '2014-02-15 00:12:01.000000', 'consum', 0.0228, 'lps'),
	(540719, 129, '2014-02-15 00:12:02.000000', 'consum', 0.0214, 'lps'),
	(540720, 129, '2014-02-15 00:12:03.000000', 'consum', 0.0227, 'lps'),
	(540721, 129, '2014-02-15 00:12:04.000000', 'consum', 0.0233, 'lps'),
	(540722, 129, '2014-02-15 00:12:05.000000', 'consum', 0.0223, 'lps'),
	(540723, 129, '2014-02-15 00:12:06.000000', 'consum', 0.0234, 'lps'),
	(540724, 129, '2014-02-15 00:12:07.000000', 'consum', 0.0215, 'lps'),
	(540725, 129, '2014-02-15 00:12:08.000000', 'consum', 0.0213, 'lps'),
	(540726, 129, '2014-02-15 00:12:09.000000', 'consum', 0.0212, 'lps'),
	(540727, 129, '2014-02-15 00:12:10.000000', 'consum', 0.0210, 'lps'),
	(540728, 129, '2014-02-15 00:12:11.000000', 'consum', 0.0230, 'lps'),
	(540729, 129, '2014-02-15 00:12:12.000000', 'consum', 0.0234, 'lps'),
	(540730, 129, '2014-02-15 00:12:13.000000', 'consum', 0.0222, 'lps'),
	(540731, 129, '2014-02-15 00:12:14.000000', 'consum', 0.0225, 'lps'),
	(540732, 129, '2014-02-15 00:12:15.000000', 'consum', 0.0223, 'lps'),
	(540733, 129, '2014-02-15 00:12:16.000000', 'consum', 0.0229, 'lps'),
	(540734, 129, '2014-02-15 00:12:17.000000', 'consum', 0.0217, 'lps'),
	(540735, 129, '2014-02-15 00:12:18.000000', 'consum', 0.0213, 'lps'),
	(540736, 129, '2014-02-15 00:12:19.000000', 'consum', 0.0230, 'lps'),
	(540737, 129, '2014-02-15 00:12:20.000000', 'consum', 0.0228, 'lps'),
	(540738, 129, '2014-02-15 00:12:21.000000', 'consum', 0.0213, 'lps'),
	(540739, 129, '2014-02-15 00:12:22.000000', 'consum', 0.0224, 'lps'),
	(540740, 129, '2014-02-15 00:12:23.000000', 'consum', 0.0221, 'lps'),
	(540741, 129, '2014-02-15 00:12:24.000000', 'consum', 0.0222, 'lps'),
	(540742, 129, '2014-02-15 00:12:25.000000', 'consum', 0.0211, 'lps'),
	(540743, 129, '2014-02-15 00:12:26.000000', 'consum', 0.0233, 'lps'),
	(540744, 129, '2014-02-15 00:12:27.000000', 'consum', 0.0222, 'lps'),
	(540745, 129, '2014-02-15 00:12:28.000000', 'consum', 0.0226, 'lps'),
	(540746, 129, '2014-02-15 00:12:29.000000', 'consum', 0.0230, 'lps'),
	(540747, 129, '2014-02-15 00:12:30.000000', 'consum', 0.0213, 'lps'),
	(540748, 129, '2014-02-15 00:12:31.000000', 'consum', 0.0216, 'lps'),
	(540749, 129, '2014-02-15 00:12:32.000000', 'consum', 0.0233, 'lps'),
	(540750, 129, '2014-02-15 00:12:33.000000', 'consum', 0.0230, 'lps'),
	(540751, 129, '2014-02-15 00:12:34.000000', 'consum', 0.0216, 'lps'),
	(540752, 129, '2014-02-15 00:12:35.000000', 'consum', 0.0231, 'lps'),
	(540753, 129, '2014-02-15 00:12:36.000000', 'consum', 0.0224, 'lps'),
	(540754, 129, '2014-02-15 00:12:37.000000', 'consum', 0.0214, 'lps'),
	(540755, 129, '2014-02-15 00:12:38.000000', 'consum', 0.0217, 'lps'),
	(540756, 129, '2014-02-15 00:12:39.000000', 'consum', 0.0233, 'lps'),
	(540757, 129, '2014-02-15 00:12:40.000000', 'consum', 0.0230, 'lps'),
	(540758, 129, '2014-02-15 00:12:41.000000', 'consum', 0.0218, 'lps'),
	(540759, 129, '2014-02-15 00:12:42.000000', 'consum', 0.0214, 'lps'),
	(540760, 129, '2014-02-15 00:12:43.000000', 'consum', 0.0230, 'lps'),
	(540761, 129, '2014-02-15 00:12:44.000000', 'consum', 0.0223, 'lps'),
	(540762, 129, '2014-02-15 00:12:45.000000', 'consum', 0.0218, 'lps'),
	(540763, 129, '2014-02-15 00:12:46.000000', 'consum', 0.0210, 'lps'),
	(540764, 129, '2014-02-15 00:12:47.000000', 'consum', 0.0211, 'lps'),
	(540765, 129, '2014-02-15 00:12:48.000000', 'consum', 0.0217, 'lps'),
	(540766, 129, '2014-02-15 00:12:49.000000', 'consum', 0.0218, 'lps'),
	(540767, 129, '2014-02-15 00:12:50.000000', 'consum', 0.0230, 'lps'),
	(540768, 129, '2014-02-15 00:12:51.000000', 'consum', 0.0210, 'lps'),
	(540769, 129, '2014-02-15 00:12:52.000000', 'consum', 0.0225, 'lps'),
	(540770, 129, '2014-02-15 00:12:53.000000', 'consum', 0.0210, 'lps'),
	(540771, 129, '2014-02-15 00:12:54.000000', 'consum', 0.0215, 'lps'),
	(540772, 129, '2014-02-15 00:12:55.000000', 'consum', 0.0210, 'lps'),
	(540773, 129, '2014-02-15 00:12:56.000000', 'consum', 0.0222, 'lps'),
	(540774, 129, '2014-02-15 00:12:57.000000', 'consum', 0.0218, 'lps'),
	(540775, 129, '2014-02-15 00:12:58.000000', 'consum', 0.0216, 'lps'),
	(540776, 129, '2014-02-15 00:12:59.000000', 'consum', 0.0217, 'lps'),
	(540777, 129, '2014-02-15 00:13:00.000000', 'consum', 0.0228, 'lps'),
	(540778, 129, '2014-02-15 00:13:01.000000', 'consum', 0.0230, 'lps'),
	(540779, 129, '2014-02-15 00:13:02.000000', 'consum', 0.0230, 'lps'),
	(540780, 129, '2014-02-15 00:13:03.000000', 'consum', 0.0226, 'lps'),
	(540781, 129, '2014-02-15 00:13:04.000000', 'consum', 0.0232, 'lps'),
	(540782, 129, '2014-02-15 00:13:05.000000', 'consum', 0.0221, 'lps'),
	(540783, 129, '2014-02-15 00:13:06.000000', 'consum', 0.0224, 'lps'),
	(540784, 129, '2014-02-15 00:13:07.000000', 'consum', 0.0222, 'lps'),
	(540785, 129, '2014-02-15 00:13:08.000000', 'consum', 0.0229, 'lps'),
	(540786, 129, '2014-02-15 00:13:09.000000', 'consum', 0.0220, 'lps'),
	(540787, 129, '2014-02-15 00:13:10.000000', 'consum', 0.0230, 'lps'),
	(540788, 129, '2014-02-15 00:13:11.000000', 'consum', 0.0228, 'lps'),
	(540789, 129, '2014-02-15 00:13:12.000000', 'consum', 0.0215, 'lps'),
	(540790, 129, '2014-02-15 00:13:13.000000', 'consum', 0.0210, 'lps'),
	(540791, 129, '2014-02-15 00:13:14.000000', 'consum', 0.0217, 'lps'),
	(540792, 129, '2014-02-15 00:13:15.000000', 'consum', 0.0221, 'lps'),
	(540793, 129, '2014-02-15 00:13:16.000000', 'consum', 0.0219, 'lps'),
	(540794, 129, '2014-02-15 00:13:17.000000', 'consum', 0.0225, 'lps'),
	(540795, 129, '2014-02-15 00:13:18.000000', 'consum', 0.0230, 'lps'),
	(540796, 129, '2014-02-15 00:13:19.000000', 'consum', 0.0219, 'lps'),
	(540797, 129, '2014-02-15 00:13:20.000000', 'consum', 0.0219, 'lps'),
	(540798, 129, '2014-02-15 00:13:21.000000', 'consum', 0.0228, 'lps'),
	(540799, 129, '2014-02-15 00:13:22.000000', 'consum', 0.0223, 'lps'),
	(540800, 129, '2014-02-15 00:13:23.000000', 'consum', 0.0221, 'lps'),
	(540801, 129, '2014-02-15 00:13:24.000000', 'consum', 0.0227, 'lps'),
	(540802, 129, '2014-02-15 00:13:25.000000', 'consum', 0.0213, 'lps'),
	(540803, 129, '2014-02-15 00:13:26.000000', 'consum', 0.0223, 'lps'),
	(540804, 129, '2014-02-15 00:13:27.000000', 'consum', 0.0217, 'lps'),
	(540805, 129, '2014-02-15 00:13:28.000000', 'consum', 0.0233, 'lps'),
	(540806, 129, '2014-02-15 00:13:29.000000', 'consum', 0.0228, 'lps'),
	(540807, 129, '2014-02-15 00:13:30.000000', 'consum', 0.0234, 'lps'),
	(540808, 129, '2014-02-15 00:13:31.000000', 'consum', 0.0224, 'lps'),
	(540809, 129, '2014-02-15 00:13:32.000000', 'consum', 0.0233, 'lps'),
	(540810, 129, '2014-02-15 00:13:33.000000', 'consum', 0.0234, 'lps'),
	(540811, 129, '2014-02-15 00:13:34.000000', 'consum', 0.0212, 'lps'),
	(540812, 129, '2014-02-15 00:13:35.000000', 'consum', 0.0221, 'lps'),
	(540813, 129, '2014-02-15 00:13:36.000000', 'consum', 0.0213, 'lps'),
	(540814, 129, '2014-02-15 00:13:37.000000', 'consum', 0.0214, 'lps'),
	(540815, 129, '2014-02-15 00:13:38.000000', 'consum', 0.0225, 'lps'),
	(540816, 129, '2014-02-15 00:13:39.000000', 'consum', 0.0221, 'lps'),
	(540817, 129, '2014-02-15 00:13:40.000000', 'consum', 0.0222, 'lps'),
	(540818, 129, '2014-02-15 00:13:41.000000', 'consum', 0.0212, 'lps'),
	(540819, 129, '2014-02-15 00:13:42.000000', 'consum', 0.0234, 'lps'),
	(540820, 129, '2014-02-15 00:13:43.000000', 'consum', 0.0226, 'lps'),
	(540821, 129, '2014-02-15 00:13:44.000000', 'consum', 0.0218, 'lps'),
	(540822, 129, '2014-02-15 00:13:45.000000', 'consum', 0.0226, 'lps'),
	(540823, 129, '2014-02-15 00:13:46.000000', 'consum', 0.0216, 'lps'),
	(540824, 129, '2014-02-15 00:13:47.000000', 'consum', 0.0218, 'lps'),
	(540825, 129, '2014-02-15 00:13:48.000000', 'consum', 0.0231, 'lps'),
	(540826, 129, '2014-02-15 00:13:49.000000', 'consum', 0.0219, 'lps'),
	(540827, 129, '2014-02-15 00:13:50.000000', 'consum', 0.0218, 'lps'),
	(540828, 129, '2014-02-15 00:13:51.000000', 'consum', 0.0225, 'lps'),
	(540829, 129, '2014-02-15 00:13:52.000000', 'consum', 0.0233, 'lps'),
	(540830, 129, '2014-02-15 00:13:53.000000', 'consum', 0.0231, 'lps'),
	(540831, 129, '2014-02-15 00:13:54.000000', 'consum', 0.0223, 'lps'),
	(540832, 129, '2014-02-15 00:13:55.000000', 'consum', 0.0210, 'lps'),
	(540833, 129, '2014-02-15 00:13:56.000000', 'consum', 0.0222, 'lps'),
	(540834, 129, '2014-02-15 00:13:57.000000', 'consum', 0.0222, 'lps'),
	(540835, 129, '2014-02-15 00:13:58.000000', 'consum', 0.0233, 'lps'),
	(540836, 129, '2014-02-15 00:13:59.000000', 'consum', 0.0213, 'lps'),
	(540837, 129, '2014-02-15 00:14:00.000000', 'consum', 0.0233, 'lps'),
	(540838, 129, '2014-02-15 00:14:01.000000', 'consum', 0.0216, 'lps'),
	(540839, 129, '2014-02-15 00:14:02.000000', 'consum', 0.0222, 'lps'),
	(540840, 129, '2014-02-15 00:14:03.000000', 'consum', 0.0229, 'lps'),
	(540841, 129, '2014-02-15 00:14:04.000000', 'consum', 0.0218, 'lps'),
	(540842, 129, '2014-02-15 00:14:05.000000', 'consum', 0.0218, 'lps'),
	(540843, 129, '2014-02-15 00:14:06.000000', 'consum', 0.0226, 'lps'),
	(540844, 129, '2014-02-15 00:14:07.000000', 'consum', 0.0218, 'lps'),
	(540845, 129, '2014-02-15 00:14:08.000000', 'consum', 0.0229, 'lps'),
	(540846, 129, '2014-02-15 00:14:09.000000', 'consum', 0.0228, 'lps'),
	(540847, 129, '2014-02-15 00:14:10.000000', 'consum', 0.0222, 'lps'),
	(540848, 129, '2014-02-15 00:14:11.000000', 'consum', 0.0215, 'lps'),
	(540849, 129, '2014-02-15 00:14:12.000000', 'consum', 0.0224, 'lps'),
	(540850, 129, '2014-02-15 00:14:13.000000', 'consum', 0.0214, 'lps'),
	(540851, 129, '2014-02-15 00:14:14.000000', 'consum', 0.0214, 'lps'),
	(540852, 129, '2014-02-15 00:14:15.000000', 'consum', 0.0219, 'lps'),
	(540853, 129, '2014-02-15 00:14:16.000000', 'consum', 0.0219, 'lps'),
	(540854, 129, '2014-02-15 00:14:17.000000', 'consum', 0.0227, 'lps'),
	(540855, 129, '2014-02-15 00:14:18.000000', 'consum', 0.0219, 'lps'),
	(540856, 129, '2014-02-15 00:14:19.000000', 'consum', 0.0231, 'lps'),
	(540857, 129, '2014-02-15 00:14:20.000000', 'consum', 0.0214, 'lps'),
	(540858, 129, '2014-02-15 00:14:21.000000', 'consum', 0.0218, 'lps'),
	(540859, 129, '2014-02-15 00:14:22.000000', 'consum', 0.0213, 'lps'),
	(540860, 129, '2014-02-15 00:14:23.000000', 'consum', 0.0224, 'lps'),
	(540861, 129, '2014-02-15 00:14:24.000000', 'consum', 0.0225, 'lps'),
	(540862, 129, '2014-02-15 00:14:25.000000', 'consum', 0.0216, 'lps'),
	(540863, 129, '2014-02-15 00:14:26.000000', 'consum', 0.0220, 'lps'),
	(540864, 129, '2014-02-15 00:14:27.000000', 'consum', 0.0220, 'lps'),
	(540865, 129, '2014-02-15 00:14:28.000000', 'consum', 0.0228, 'lps'),
	(540866, 129, '2014-02-15 00:14:29.000000', 'consum', 0.0223, 'lps'),
	(540867, 129, '2014-02-15 00:14:30.000000', 'consum', 0.0220, 'lps'),
	(540868, 129, '2014-02-15 00:14:31.000000', 'consum', 0.0221, 'lps'),
	(540869, 129, '2014-02-15 00:14:32.000000', 'consum', 0.0210, 'lps'),
	(540870, 129, '2014-02-15 00:14:33.000000', 'consum', 0.0226, 'lps'),
	(540871, 129, '2014-02-15 00:14:34.000000', 'consum', 0.0218, 'lps'),
	(540872, 129, '2014-02-15 00:14:35.000000', 'consum', 0.0229, 'lps'),
	(540873, 129, '2014-02-15 00:14:36.000000', 'consum', 0.0228, 'lps'),
	(540874, 129, '2014-02-15 00:14:37.000000', 'consum', 0.0221, 'lps'),
	(540875, 129, '2014-02-15 00:14:38.000000', 'consum', 0.0211, 'lps'),
	(540876, 129, '2014-02-15 00:14:39.000000', 'consum', 0.0231, 'lps'),
	(540877, 129, '2014-02-15 00:14:40.000000', 'consum', 0.0215, 'lps'),
	(540878, 129, '2014-02-15 00:14:41.000000', 'consum', 0.0221, 'lps'),
	(540879, 129, '2014-02-15 00:14:42.000000', 'consum', 0.0226, 'lps'),
	(540880, 129, '2014-02-15 00:14:43.000000', 'consum', 0.0234, 'lps'),
	(540881, 129, '2014-02-15 00:14:44.000000', 'consum', 0.0233, 'lps'),
	(540882, 129, '2014-02-15 00:14:45.000000', 'consum', 0.0227, 'lps'),
	(540883, 129, '2014-02-15 00:14:46.000000', 'consum', 0.0228, 'lps'),
	(540884, 129, '2014-02-15 00:14:47.000000', 'consum', 0.0224, 'lps'),
	(540885, 129, '2014-02-15 00:14:48.000000', 'consum', 0.0226, 'lps'),
	(540886, 129, '2014-02-15 00:14:49.000000', 'consum', 0.0222, 'lps'),
	(540887, 129, '2014-02-15 00:14:50.000000', 'consum', 0.0225, 'lps'),
	(540888, 129, '2014-02-15 00:14:51.000000', 'consum', 0.0224, 'lps'),
	(540889, 129, '2014-02-15 00:14:52.000000', 'consum', 0.0234, 'lps'),
	(540890, 129, '2014-02-15 00:14:53.000000', 'consum', 0.0213, 'lps'),
	(540891, 129, '2014-02-15 00:14:54.000000', 'consum', 0.0230, 'lps'),
	(540892, 129, '2014-02-15 00:14:55.000000', 'consum', 0.0225, 'lps'),
	(540893, 129, '2014-02-15 00:14:56.000000', 'consum', 0.0226, 'lps'),
	(540894, 129, '2014-02-15 00:14:57.000000', 'consum', 0.0221, 'lps'),
	(540895, 129, '2014-02-15 00:14:58.000000', 'consum', 0.0218, 'lps'),
	(540896, 129, '2014-02-15 00:14:59.000000', 'consum', 0.0217, 'lps'),
	(540897, 129, '2014-02-15 00:15:00.000000', 'consum', 0.0220, 'lps'),
	(540898, 129, '2014-02-15 00:15:01.000000', 'consum', 0.0216, 'lps'),
	(540899, 129, '2014-02-15 00:15:02.000000', 'consum', 0.0210, 'lps'),
	(540900, 129, '2014-02-15 00:15:03.000000', 'consum', 0.0217, 'lps'),
	(540901, 129, '2014-02-15 00:15:04.000000', 'consum', 0.0221, 'lps'),
	(540902, 129, '2014-02-15 00:15:05.000000', 'consum', 0.0221, 'lps'),
	(540903, 129, '2014-02-15 00:15:06.000000', 'consum', 0.0230, 'lps'),
	(540904, 129, '2014-02-15 00:15:07.000000', 'consum', 0.0227, 'lps'),
	(540905, 129, '2014-02-15 00:15:08.000000', 'consum', 0.0213, 'lps'),
	(540906, 129, '2014-02-15 00:15:09.000000', 'consum', 0.0225, 'lps'),
	(540907, 129, '2014-02-15 00:15:10.000000', 'consum', 0.0227, 'lps'),
	(540908, 129, '2014-02-15 00:15:11.000000', 'consum', 0.0226, 'lps'),
	(540909, 129, '2014-02-15 00:15:12.000000', 'consum', 0.0215, 'lps'),
	(540910, 129, '2014-02-15 00:15:13.000000', 'consum', 0.0212, 'lps'),
	(540911, 129, '2014-02-15 00:15:14.000000', 'consum', 0.0230, 'lps'),
	(540912, 129, '2014-02-15 00:15:15.000000', 'consum', 0.0232, 'lps'),
	(540913, 129, '2014-02-15 00:15:16.000000', 'consum', 0.0232, 'lps'),
	(540914, 129, '2014-02-15 00:15:17.000000', 'consum', 0.0230, 'lps'),
	(540915, 129, '2014-02-15 00:15:18.000000', 'consum', 0.0218, 'lps'),
	(540916, 129, '2014-02-15 00:15:19.000000', 'consum', 0.0217, 'lps'),
	(540917, 129, '2014-02-15 00:15:20.000000', 'consum', 0.0223, 'lps'),
	(540918, 129, '2014-02-15 00:15:21.000000', 'consum', 0.0229, 'lps'),
	(540919, 129, '2014-02-15 00:15:22.000000', 'consum', 0.0216, 'lps'),
	(540920, 129, '2014-02-15 00:15:23.000000', 'consum', 0.0233, 'lps'),
	(540921, 129, '2014-02-15 00:15:24.000000', 'consum', 0.0231, 'lps'),
	(540922, 129, '2014-02-15 00:15:25.000000', 'consum', 0.0225, 'lps'),
	(540923, 129, '2014-02-15 00:15:26.000000', 'consum', 0.0221, 'lps'),
	(540924, 129, '2014-02-15 00:15:27.000000', 'consum', 0.0219, 'lps'),
	(540925, 129, '2014-02-15 00:15:28.000000', 'consum', 0.0221, 'lps'),
	(540926, 129, '2014-02-15 00:15:29.000000', 'consum', 0.0217, 'lps'),
	(540927, 129, '2014-02-15 00:15:30.000000', 'consum', 0.0211, 'lps'),
	(540928, 129, '2014-02-15 00:15:31.000000', 'consum', 0.0221, 'lps'),
	(540929, 129, '2014-02-15 00:15:32.000000', 'consum', 0.0212, 'lps'),
	(540930, 129, '2014-02-15 00:15:33.000000', 'consum', 0.0212, 'lps'),
	(540931, 129, '2014-02-15 00:15:34.000000', 'consum', 0.0213, 'lps'),
	(540932, 129, '2014-02-15 00:15:35.000000', 'consum', 0.0220, 'lps'),
	(540933, 129, '2014-02-15 00:15:36.000000', 'consum', 0.0225, 'lps'),
	(540934, 129, '2014-02-15 00:15:37.000000', 'consum', 0.0232, 'lps'),
	(540935, 129, '2014-02-15 00:15:38.000000', 'consum', 0.0225, 'lps'),
	(540936, 129, '2014-02-15 00:15:39.000000', 'consum', 0.0218, 'lps'),
	(540937, 129, '2014-02-15 00:15:40.000000', 'consum', 0.0232, 'lps'),
	(540938, 129, '2014-02-15 00:15:41.000000', 'consum', 0.0223, 'lps'),
	(540939, 129, '2014-02-15 00:15:42.000000', 'consum', 0.0232, 'lps'),
	(540940, 129, '2014-02-15 00:15:43.000000', 'consum', 0.0232, 'lps'),
	(540941, 129, '2014-02-15 00:15:44.000000', 'consum', 0.0230, 'lps'),
	(540942, 129, '2014-02-15 00:15:45.000000', 'consum', 0.0218, 'lps'),
	(540943, 129, '2014-02-15 00:15:46.000000', 'consum', 0.0216, 'lps'),
	(540944, 129, '2014-02-15 00:15:47.000000', 'consum', 0.0216, 'lps'),
	(540945, 129, '2014-02-15 00:15:48.000000', 'consum', 0.0225, 'lps'),
	(540946, 129, '2014-02-15 00:15:49.000000', 'consum', 0.0217, 'lps'),
	(540947, 129, '2014-02-15 00:15:50.000000', 'consum', 0.0223, 'lps'),
	(540948, 129, '2014-02-15 00:15:51.000000', 'consum', 0.0231, 'lps'),
	(540949, 129, '2014-02-15 00:15:52.000000', 'consum', 0.0225, 'lps'),
	(540950, 129, '2014-02-15 00:15:53.000000', 'consum', 0.0223, 'lps'),
	(540951, 129, '2014-02-15 00:15:54.000000', 'consum', 0.0229, 'lps'),
	(540952, 129, '2014-02-15 00:15:55.000000', 'consum', 0.0217, 'lps'),
	(540953, 129, '2014-02-15 00:15:56.000000', 'consum', 0.0213, 'lps'),
	(540954, 129, '2014-02-15 00:15:57.000000', 'consum', 0.0231, 'lps'),
	(540955, 129, '2014-02-15 00:15:58.000000', 'consum', 0.0230, 'lps'),
	(540956, 129, '2014-02-15 00:15:59.000000', 'consum', 0.0225, 'lps'),
	(540957, 129, '2014-02-15 00:16:00.000000', 'consum', 0.0225, 'lps'),
	(540958, 129, '2014-02-15 00:16:01.000000', 'consum', 0.0215, 'lps'),
	(540959, 129, '2014-02-15 00:16:02.000000', 'consum', 0.0217, 'lps'),
	(540960, 129, '2014-02-15 00:16:03.000000', 'consum', 0.0229, 'lps'),
	(540961, 129, '2014-02-15 00:16:04.000000', 'consum', 0.0234, 'lps'),
	(540962, 129, '2014-02-15 00:16:05.000000', 'consum', 0.0224, 'lps'),
	(540963, 129, '2014-02-15 00:16:06.000000', 'consum', 0.0232, 'lps'),
	(540964, 129, '2014-02-15 00:16:07.000000', 'consum', 0.0231, 'lps'),
	(540965, 129, '2014-02-15 00:16:08.000000', 'consum', 0.0221, 'lps'),
	(540966, 129, '2014-02-15 00:16:09.000000', 'consum', 0.0231, 'lps'),
	(540967, 129, '2014-02-15 00:16:10.000000', 'consum', 0.0231, 'lps'),
	(540968, 129, '2014-02-15 00:16:11.000000', 'consum', 0.0229, 'lps'),
	(540969, 129, '2014-02-15 00:16:12.000000', 'consum', 0.0216, 'lps'),
	(540970, 129, '2014-02-15 00:16:13.000000', 'consum', 0.0234, 'lps'),
	(540971, 129, '2014-02-15 00:16:14.000000', 'consum', 0.0211, 'lps'),
	(540972, 129, '2014-02-15 00:16:15.000000', 'consum', 0.0218, 'lps'),
	(540973, 129, '2014-02-15 00:16:16.000000', 'consum', 0.0223, 'lps'),
	(540974, 129, '2014-02-15 00:16:17.000000', 'consum', 0.0227, 'lps'),
	(540975, 129, '2014-02-15 00:16:18.000000', 'consum', 0.0233, 'lps'),
	(540976, 129, '2014-02-15 00:16:19.000000', 'consum', 0.0222, 'lps'),
	(540977, 129, '2014-02-15 00:16:20.000000', 'consum', 0.0226, 'lps'),
	(540978, 129, '2014-02-15 00:16:21.000000', 'consum', 0.0231, 'lps'),
	(540979, 129, '2014-02-15 00:16:22.000000', 'consum', 0.0218, 'lps'),
	(540980, 129, '2014-02-15 00:16:23.000000', 'consum', 0.0213, 'lps'),
	(540981, 129, '2014-02-15 00:16:24.000000', 'consum', 0.0226, 'lps'),
	(540982, 129, '2014-02-15 00:16:25.000000', 'consum', 0.0233, 'lps'),
	(540983, 129, '2014-02-15 00:16:26.000000', 'consum', 0.0227, 'lps'),
	(540984, 129, '2014-02-15 00:16:27.000000', 'consum', 0.0226, 'lps'),
	(540985, 129, '2014-02-15 00:16:28.000000', 'consum', 0.0216, 'lps'),
	(540986, 129, '2014-02-15 00:16:29.000000', 'consum', 0.0217, 'lps'),
	(540987, 129, '2014-02-15 00:16:30.000000', 'consum', 0.0227, 'lps'),
	(540988, 129, '2014-02-15 00:16:31.000000', 'consum', 0.0226, 'lps'),
	(540989, 129, '2014-02-15 00:16:32.000000', 'consum', 0.0212, 'lps'),
	(540990, 129, '2014-02-15 00:16:33.000000', 'consum', 0.0225, 'lps'),
	(540991, 129, '2014-02-15 00:16:34.000000', 'consum', 0.0228, 'lps'),
	(540992, 129, '2014-02-15 00:16:35.000000', 'consum', 0.0232, 'lps'),
	(540993, 129, '2014-02-15 00:16:36.000000', 'consum', 0.0214, 'lps'),
	(540994, 129, '2014-02-15 00:16:37.000000', 'consum', 0.0215, 'lps'),
	(540995, 129, '2014-02-15 00:16:38.000000', 'consum', 0.0225, 'lps'),
	(540996, 129, '2014-02-15 00:16:39.000000', 'consum', 0.0220, 'lps'),
	(540997, 129, '2014-02-15 00:16:40.000000', 'consum', 0.0214, 'lps'),
	(540998, 129, '2014-02-15 00:16:41.000000', 'consum', 0.0228, 'lps'),
	(540999, 129, '2014-02-15 00:16:42.000000', 'consum', 0.0211, 'lps'),
	(541000, 129, '2014-02-15 00:16:43.000000', 'consum', 0.0213, 'lps'),
	(541001, 129, '2014-02-15 00:16:44.000000', 'consum', 0.0224, 'lps'),
	(541002, 129, '2014-02-15 00:16:45.000000', 'consum', 0.0218, 'lps'),
	(541003, 129, '2014-02-15 00:16:46.000000', 'consum', 0.0211, 'lps'),
	(541004, 129, '2014-02-15 00:16:47.000000', 'consum', 0.0216, 'lps'),
	(541005, 129, '2014-02-15 00:16:48.000000', 'consum', 0.0211, 'lps'),
	(541006, 129, '2014-02-15 00:16:49.000000', 'consum', 0.0223, 'lps'),
	(541007, 129, '2014-02-15 00:16:50.000000', 'consum', 0.0221, 'lps'),
	(541008, 129, '2014-02-15 00:16:51.000000', 'consum', 0.0228, 'lps'),
	(541009, 129, '2014-02-15 00:16:52.000000', 'consum', 0.0219, 'lps'),
	(541010, 129, '2014-02-15 00:16:53.000000', 'consum', 0.0225, 'lps'),
	(541011, 129, '2014-02-15 00:16:54.000000', 'consum', 0.0233, 'lps'),
	(541012, 129, '2014-02-15 00:16:55.000000', 'consum', 0.0232, 'lps'),
	(541013, 129, '2014-02-15 00:16:56.000000', 'consum', 0.0224, 'lps'),
	(541014, 129, '2014-02-15 00:16:57.000000', 'consum', 0.0217, 'lps'),
	(541015, 129, '2014-02-15 00:16:58.000000', 'consum', 0.0229, 'lps'),
	(541016, 129, '2014-02-15 00:16:59.000000', 'consum', 0.0231, 'lps'),
	(541017, 129, '2014-02-15 00:17:00.000000', 'consum', 0.0212, 'lps'),
	(541018, 129, '2014-02-15 00:17:01.000000', 'consum', 0.0232, 'lps'),
	(541019, 129, '2014-02-15 00:17:02.000000', 'consum', 0.0212, 'lps'),
	(541020, 129, '2014-02-15 00:17:03.000000', 'consum', 0.0233, 'lps'),
	(541021, 129, '2014-02-15 00:17:04.000000', 'consum', 0.0217, 'lps'),
	(541022, 129, '2014-02-15 00:17:05.000000', 'consum', 0.0228, 'lps'),
	(541023, 129, '2014-02-15 00:17:06.000000', 'consum', 0.0227, 'lps'),
	(541024, 129, '2014-02-15 00:17:07.000000', 'consum', 0.0218, 'lps'),
	(541025, 129, '2014-02-15 00:17:08.000000', 'consum', 0.0224, 'lps'),
	(541026, 129, '2014-02-15 00:17:09.000000', 'consum', 0.0231, 'lps'),
	(541027, 129, '2014-02-15 00:17:10.000000', 'consum', 0.0226, 'lps'),
	(541028, 129, '2014-02-15 00:17:11.000000', 'consum', 0.0227, 'lps'),
	(541029, 129, '2014-02-15 00:17:12.000000', 'consum', 0.0220, 'lps'),
	(541030, 129, '2014-02-15 00:17:13.000000', 'consum', 0.0213, 'lps'),
	(541031, 129, '2014-02-15 00:17:14.000000', 'consum', 0.0217, 'lps'),
	(541032, 129, '2014-02-15 00:17:15.000000', 'consum', 0.0213, 'lps'),
	(541033, 129, '2014-02-15 00:17:16.000000', 'consum', 0.0230, 'lps'),
	(541034, 129, '2014-02-15 00:17:17.000000', 'consum', 0.0228, 'lps'),
	(541035, 129, '2014-02-15 00:17:18.000000', 'consum', 0.0214, 'lps'),
	(541036, 129, '2014-02-15 00:17:19.000000', 'consum', 0.0225, 'lps'),
	(541037, 129, '2014-02-15 00:17:20.000000', 'consum', 0.0225, 'lps'),
	(541038, 129, '2014-02-15 00:17:21.000000', 'consum', 0.0217, 'lps'),
	(541039, 129, '2014-02-15 00:17:22.000000', 'consum', 0.0223, 'lps'),
	(541040, 129, '2014-02-15 00:17:23.000000', 'consum', 0.0229, 'lps'),
	(541041, 129, '2014-02-15 00:17:24.000000', 'consum', 0.0219, 'lps'),
	(541042, 129, '2014-02-15 00:17:25.000000', 'consum', 0.0221, 'lps'),
	(541043, 129, '2014-02-15 00:17:26.000000', 'consum', 0.0215, 'lps'),
	(541044, 129, '2014-02-15 00:17:27.000000', 'consum', 0.0228, 'lps'),
	(541045, 129, '2014-02-15 00:17:28.000000', 'consum', 0.0210, 'lps'),
	(541046, 129, '2014-02-15 00:17:29.000000', 'consum', 0.0231, 'lps'),
	(541047, 129, '2014-02-15 00:17:30.000000', 'consum', 0.0214, 'lps'),
	(541048, 129, '2014-02-15 00:17:31.000000', 'consum', 0.0221, 'lps'),
	(541049, 129, '2014-02-15 00:17:32.000000', 'consum', 0.0225, 'lps'),
	(541050, 129, '2014-02-15 00:17:33.000000', 'consum', 0.0229, 'lps'),
	(541051, 129, '2014-02-15 00:17:34.000000', 'consum', 0.0212, 'lps'),
	(541052, 129, '2014-02-15 00:17:35.000000', 'consum', 0.0211, 'lps'),
	(541053, 129, '2014-02-15 00:17:36.000000', 'consum', 0.0211, 'lps'),
	(541054, 129, '2014-02-15 00:17:37.000000', 'consum', 0.0210, 'lps'),
	(541055, 129, '2014-02-15 00:17:38.000000', 'consum', 0.0210, 'lps'),
	(541056, 129, '2014-02-15 00:17:39.000000', 'consum', 0.0210, 'lps'),
	(541057, 129, '2014-02-15 00:17:40.000000', 'consum', 0.0233, 'lps'),
	(541058, 129, '2014-02-15 00:17:41.000000', 'consum', 0.0229, 'lps'),
	(541059, 129, '2014-02-15 00:17:42.000000', 'consum', 0.0233, 'lps'),
	(541060, 129, '2014-02-15 00:17:43.000000', 'consum', 0.0222, 'lps'),
	(541061, 129, '2014-02-15 00:17:44.000000', 'consum', 0.0223, 'lps'),
	(541062, 129, '2014-02-15 00:17:45.000000', 'consum', 0.0217, 'lps'),
	(541063, 129, '2014-02-15 00:17:46.000000', 'consum', 0.0231, 'lps'),
	(541064, 129, '2014-02-15 00:17:47.000000', 'consum', 0.0219, 'lps'),
	(541065, 129, '2014-02-15 00:17:48.000000', 'consum', 0.0218, 'lps'),
	(541066, 129, '2014-02-15 00:17:49.000000', 'consum', 0.0223, 'lps'),
	(541067, 129, '2014-02-15 00:17:50.000000', 'consum', 0.0227, 'lps'),
	(541068, 129, '2014-02-15 00:17:51.000000', 'consum', 0.0233, 'lps'),
	(541069, 129, '2014-02-15 00:17:52.000000', 'consum', 0.0224, 'lps'),
	(541070, 129, '2014-02-15 00:17:53.000000', 'consum', 0.0212, 'lps'),
	(541071, 129, '2014-02-15 00:17:54.000000', 'consum', 0.0228, 'lps'),
	(541072, 129, '2014-02-15 00:17:55.000000', 'consum', 0.0219, 'lps'),
	(541073, 129, '2014-02-15 00:17:56.000000', 'consum', 0.0225, 'lps'),
	(541074, 129, '2014-02-15 00:17:57.000000', 'consum', 0.0211, 'lps'),
	(541075, 129, '2014-02-15 00:17:58.000000', 'consum', 0.0220, 'lps'),
	(541076, 129, '2014-02-15 00:17:59.000000', 'consum', 0.0233, 'lps'),
	(541077, 129, '2014-02-15 00:18:00.000000', 'consum', 0.0221, 'lps'),
	(541078, 129, '2014-02-15 00:18:01.000000', 'consum', 0.0222, 'lps'),
	(541079, 129, '2014-02-15 00:18:02.000000', 'consum', 0.0213, 'lps'),
	(541080, 129, '2014-02-15 00:18:03.000000', 'consum', 0.0212, 'lps'),
	(541081, 129, '2014-02-15 00:18:04.000000', 'consum', 0.0212, 'lps'),
	(541082, 129, '2014-02-15 00:18:05.000000', 'consum', 0.0215, 'lps'),
	(541083, 129, '2014-02-15 00:18:06.000000', 'consum', 0.0231, 'lps'),
	(541084, 129, '2014-02-15 00:18:07.000000', 'consum', 0.0223, 'lps'),
	(541085, 129, '2014-02-15 00:18:08.000000', 'consum', 0.0213, 'lps'),
	(541086, 129, '2014-02-15 00:18:09.000000', 'consum', 0.0213, 'lps'),
	(541087, 129, '2014-02-15 00:18:10.000000', 'consum', 0.0217, 'lps'),
	(541088, 129, '2014-02-15 00:18:11.000000', 'consum', 0.0213, 'lps'),
	(541089, 129, '2014-02-15 00:18:12.000000', 'consum', 0.0226, 'lps'),
	(541090, 129, '2014-02-15 00:18:13.000000', 'consum', 0.0234, 'lps'),
	(541091, 129, '2014-02-15 00:18:14.000000', 'consum', 0.0230, 'lps'),
	(541092, 129, '2014-02-15 00:18:15.000000', 'consum', 0.0215, 'lps'),
	(541093, 129, '2014-02-15 00:18:16.000000', 'consum', 0.0225, 'lps'),
	(541094, 129, '2014-02-15 00:18:17.000000', 'consum', 0.0220, 'lps'),
	(541095, 129, '2014-02-15 00:18:18.000000', 'consum', 0.0215, 'lps'),
	(541096, 129, '2014-02-15 00:18:19.000000', 'consum', 0.0229, 'lps'),
	(541097, 129, '2014-02-15 00:18:20.000000', 'consum', 0.0219, 'lps'),
	(541098, 129, '2014-02-15 00:18:21.000000', 'consum', 0.0222, 'lps'),
	(541099, 129, '2014-02-15 00:18:22.000000', 'consum', 0.0219, 'lps'),
	(541100, 129, '2014-02-15 00:18:23.000000', 'consum', 0.0221, 'lps'),
	(541101, 129, '2014-02-15 00:18:24.000000', 'consum', 0.0210, 'lps'),
	(541102, 129, '2014-02-15 00:18:25.000000', 'consum', 0.0230, 'lps'),
	(541103, 129, '2014-02-15 00:18:26.000000', 'consum', 0.0212, 'lps'),
	(541104, 129, '2014-02-15 00:18:27.000000', 'consum', 0.0234, 'lps'),
	(541105, 129, '2014-02-15 00:18:28.000000', 'consum', 0.0223, 'lps'),
	(541106, 129, '2014-02-15 00:18:29.000000', 'consum', 0.0230, 'lps'),
	(541107, 129, '2014-02-15 00:18:30.000000', 'consum', 0.0221, 'lps'),
	(541108, 129, '2014-02-15 00:18:31.000000', 'consum', 0.0233, 'lps'),
	(541109, 129, '2014-02-15 00:18:32.000000', 'consum', 0.0214, 'lps'),
	(541110, 129, '2014-02-15 00:18:33.000000', 'consum', 0.0215, 'lps'),
	(541111, 129, '2014-02-15 00:18:34.000000', 'consum', 0.0222, 'lps'),
	(541112, 129, '2014-02-15 00:18:35.000000', 'consum', 0.0228, 'lps'),
	(541113, 129, '2014-02-15 00:18:36.000000', 'consum', 0.0218, 'lps'),
	(541114, 129, '2014-02-15 00:18:37.000000', 'consum', 0.0221, 'lps'),
	(541115, 129, '2014-02-15 00:18:38.000000', 'consum', 0.0218, 'lps'),
	(541116, 129, '2014-02-15 00:18:39.000000', 'consum', 0.0215, 'lps'),
	(541117, 129, '2014-02-15 00:18:40.000000', 'consum', 0.0211, 'lps'),
	(541118, 129, '2014-02-15 00:18:41.000000', 'consum', 0.0225, 'lps'),
	(541119, 129, '2014-02-15 00:18:42.000000', 'consum', 0.0233, 'lps'),
	(541120, 129, '2014-02-15 00:18:43.000000', 'consum', 0.0231, 'lps'),
	(541121, 129, '2014-02-15 00:18:44.000000', 'consum', 0.0221, 'lps'),
	(541122, 129, '2014-02-15 00:18:45.000000', 'consum', 0.0228, 'lps'),
	(541123, 129, '2014-02-15 00:18:46.000000', 'consum', 0.0219, 'lps'),
	(541124, 129, '2014-02-15 00:18:47.000000', 'consum', 0.0224, 'lps'),
	(541125, 129, '2014-02-15 00:18:48.000000', 'consum', 0.0229, 'lps'),
	(541126, 129, '2014-02-15 00:18:49.000000', 'consum', 0.0215, 'lps'),
	(541127, 129, '2014-02-15 00:18:50.000000', 'consum', 0.0230, 'lps'),
	(541128, 129, '2014-02-15 00:18:51.000000', 'consum', 0.0218, 'lps'),
	(541129, 129, '2014-02-15 00:18:52.000000', 'consum', 0.0215, 'lps'),
	(541130, 129, '2014-02-15 00:18:53.000000', 'consum', 0.0212, 'lps'),
	(541131, 129, '2014-02-15 00:18:54.000000', 'consum', 0.0230, 'lps'),
	(541132, 129, '2014-02-15 00:18:55.000000', 'consum', 0.0228, 'lps'),
	(541133, 129, '2014-02-15 00:18:56.000000', 'consum', 0.0218, 'lps'),
	(541134, 129, '2014-02-15 00:18:57.000000', 'consum', 0.0219, 'lps'),
	(541135, 129, '2014-02-15 00:18:58.000000', 'consum', 0.0233, 'lps'),
	(541136, 129, '2014-02-15 00:18:59.000000', 'consum', 0.0224, 'lps'),
	(541137, 129, '2014-02-15 00:19:00.000000', 'consum', 0.0212, 'lps'),
	(541138, 129, '2014-02-15 00:19:01.000000', 'consum', 0.0227, 'lps'),
	(541139, 129, '2014-02-15 00:19:02.000000', 'consum', 0.0215, 'lps'),
	(541140, 129, '2014-02-15 00:19:03.000000', 'consum', 0.0211, 'lps'),
	(541141, 129, '2014-02-15 00:19:04.000000', 'consum', 0.0226, 'lps'),
	(541142, 129, '2014-02-15 00:19:05.000000', 'consum', 0.0213, 'lps'),
	(541143, 129, '2014-02-15 00:19:06.000000', 'consum', 0.0226, 'lps'),
	(541144, 129, '2014-02-15 00:19:07.000000', 'consum', 0.0233, 'lps'),
	(541145, 129, '2014-02-15 00:19:08.000000', 'consum', 0.0227, 'lps'),
	(541146, 129, '2014-02-15 00:19:09.000000', 'consum', 0.0228, 'lps'),
	(541147, 129, '2014-02-15 00:19:10.000000', 'consum', 0.0224, 'lps'),
	(541148, 129, '2014-02-15 00:19:11.000000', 'consum', 0.0227, 'lps'),
	(541149, 129, '2014-02-15 00:19:12.000000', 'consum', 0.0228, 'lps'),
	(541150, 129, '2014-02-15 00:19:13.000000', 'consum', 0.0222, 'lps'),
	(541151, 129, '2014-02-15 00:19:14.000000', 'consum', 0.0220, 'lps'),
	(541152, 129, '2014-02-15 00:19:15.000000', 'consum', 0.0224, 'lps'),
	(541153, 129, '2014-02-15 00:19:16.000000', 'consum', 0.0224, 'lps'),
	(541154, 129, '2014-02-15 00:19:17.000000', 'consum', 0.0215, 'lps'),
	(541155, 129, '2014-02-15 00:19:18.000000', 'consum', 0.0217, 'lps'),
	(541156, 129, '2014-02-15 00:19:19.000000', 'consum', 0.0231, 'lps'),
	(541157, 129, '2014-02-15 00:19:20.000000', 'consum', 0.0219, 'lps'),
	(541158, 129, '2014-02-15 00:19:21.000000', 'consum', 0.0217, 'lps'),
	(541159, 129, '2014-02-15 00:19:22.000000', 'consum', 0.0217, 'lps'),
	(541160, 129, '2014-02-15 00:19:23.000000', 'consum', 0.0228, 'lps'),
	(541161, 129, '2014-02-15 00:19:24.000000', 'consum', 0.0227, 'lps'),
	(541162, 129, '2014-02-15 00:19:25.000000', 'consum', 0.0217, 'lps'),
	(541163, 129, '2014-02-15 00:19:26.000000', 'consum', 0.0222, 'lps'),
	(541164, 129, '2014-02-15 00:19:27.000000', 'consum', 0.0221, 'lps'),
	(541165, 129, '2014-02-15 00:19:28.000000', 'consum', 0.0230, 'lps'),
	(541166, 129, '2014-02-15 00:19:29.000000', 'consum', 0.0227, 'lps'),
	(541167, 129, '2014-02-15 00:19:30.000000', 'consum', 0.0213, 'lps'),
	(541168, 129, '2014-02-15 00:19:31.000000', 'consum', 0.0225, 'lps'),
	(541169, 129, '2014-02-15 00:19:32.000000', 'consum', 0.0224, 'lps'),
	(541170, 129, '2014-02-15 00:19:33.000000', 'consum', 0.0212, 'lps'),
	(541171, 129, '2014-02-15 00:19:34.000000', 'consum', 0.0229, 'lps'),
	(541172, 129, '2014-02-15 00:19:35.000000', 'consum', 0.0223, 'lps'),
	(541173, 129, '2014-02-15 00:19:36.000000', 'consum', 0.0221, 'lps'),
	(541174, 129, '2014-02-15 00:19:37.000000', 'consum', 0.0226, 'lps'),
	(541175, 129, '2014-02-15 00:19:38.000000', 'consum', 0.0230, 'lps'),
	(541176, 129, '2014-02-15 00:19:39.000000', 'consum', 0.0216, 'lps'),
	(541177, 129, '2014-02-15 00:19:40.000000', 'consum', 0.0228, 'lps'),
	(541178, 129, '2014-02-15 00:19:41.000000', 'consum', 0.0231, 'lps'),
	(541179, 129, '2014-02-15 00:19:42.000000', 'consum', 0.0214, 'lps'),
	(541180, 129, '2014-02-15 00:19:43.000000', 'consum', 0.0217, 'lps'),
	(541181, 129, '2014-02-15 00:19:44.000000', 'consum', 0.0233, 'lps'),
	(541182, 129, '2014-02-15 00:19:45.000000', 'consum', 0.0231, 'lps'),
	(541183, 129, '2014-02-15 00:19:46.000000', 'consum', 0.0222, 'lps'),
	(541184, 129, '2014-02-15 00:19:47.000000', 'consum', 0.0230, 'lps'),
	(541185, 129, '2014-02-15 00:19:48.000000', 'consum', 0.0225, 'lps'),
	(541186, 129, '2014-02-15 00:19:49.000000', 'consum', 0.0227, 'lps'),
	(541187, 129, '2014-02-15 00:19:50.000000', 'consum', 0.0226, 'lps'),
	(541188, 129, '2014-02-15 00:19:51.000000', 'consum', 0.0213, 'lps'),
	(541189, 129, '2014-02-15 00:19:52.000000', 'consum', 0.0227, 'lps'),
	(541190, 129, '2014-02-15 00:19:53.000000', 'consum', 0.0214, 'lps'),
	(541191, 129, '2014-02-15 00:19:54.000000', 'consum', 0.0229, 'lps'),
	(541192, 129, '2014-02-15 00:19:55.000000', 'consum', 0.0217, 'lps'),
	(541193, 129, '2014-02-15 00:19:56.000000', 'consum', 0.0215, 'lps'),
	(541194, 129, '2014-02-15 00:19:57.000000', 'consum', 0.0213, 'lps'),
	(541195, 129, '2014-02-15 00:19:58.000000', 'consum', 0.0211, 'lps'),
	(541196, 129, '2014-02-15 00:19:59.000000', 'consum', 0.0230, 'lps'),
	(541197, 129, '2014-02-15 00:20:00.000000', 'consum', 0.0234, 'lps'),
	(541198, 129, '2014-02-15 00:20:01.000000', 'consum', 0.0219, 'lps'),
	(541199, 129, '2014-02-15 00:20:02.000000', 'consum', 0.0211, 'lps'),
	(541200, 129, '2014-02-15 00:20:03.000000', 'consum', 0.0214, 'lps'),
	(541201, 129, '2014-02-15 00:20:04.000000', 'consum', 0.0228, 'lps'),
	(541202, 129, '2014-02-15 00:20:05.000000', 'consum', 0.0211, 'lps'),
	(541203, 129, '2014-02-15 00:20:06.000000', 'consum', 0.0213, 'lps'),
	(541204, 129, '2014-02-15 00:20:07.000000', 'consum', 0.0220, 'lps'),
	(541205, 129, '2014-02-15 00:20:08.000000', 'consum', 0.0229, 'lps'),
	(541206, 129, '2014-02-15 00:20:09.000000', 'consum', 0.0227, 'lps'),
	(541207, 129, '2014-02-15 00:20:10.000000', 'consum', 0.0210, 'lps'),
	(541208, 129, '2014-02-15 00:20:11.000000', 'consum', 0.0212, 'lps'),
	(541209, 129, '2014-02-15 00:20:12.000000', 'consum', 0.0221, 'lps'),
	(541210, 129, '2014-02-15 00:20:13.000000', 'consum', 0.0234, 'lps'),
	(541211, 129, '2014-02-15 00:20:14.000000', 'consum', 0.0221, 'lps'),
	(541212, 129, '2014-02-15 00:20:15.000000', 'consum', 0.0218, 'lps'),
	(541213, 129, '2014-02-15 00:20:16.000000', 'consum', 0.0217, 'lps'),
	(541214, 129, '2014-02-15 00:20:17.000000', 'consum', 0.0224, 'lps'),
	(541215, 129, '2014-02-15 00:20:18.000000', 'consum', 0.0231, 'lps'),
	(541216, 129, '2014-02-15 00:20:19.000000', 'consum', 0.0227, 'lps'),
	(541217, 129, '2014-02-15 00:20:20.000000', 'consum', 0.0230, 'lps'),
	(541218, 129, '2014-02-15 00:20:21.000000', 'consum', 0.0210, 'lps'),
	(541219, 129, '2014-02-15 00:20:22.000000', 'consum', 0.0225, 'lps'),
	(541220, 129, '2014-02-15 00:20:23.000000', 'consum', 0.0210, 'lps'),
	(541221, 129, '2014-02-15 00:20:24.000000', 'consum', 0.0217, 'lps'),
	(541222, 129, '2014-02-15 00:20:25.000000', 'consum', 0.0220, 'lps'),
	(541223, 129, '2014-02-15 00:20:26.000000', 'consum', 0.0213, 'lps'),
	(541224, 129, '2014-02-15 00:20:27.000000', 'consum', 0.0223, 'lps'),
	(541225, 129, '2014-02-15 00:20:28.000000', 'consum', 0.0218, 'lps'),
	(541226, 129, '2014-02-15 00:20:29.000000', 'consum', 0.0233, 'lps'),
	(541227, 129, '2014-02-15 00:20:30.000000', 'consum', 0.0227, 'lps'),
	(541228, 129, '2014-02-15 00:20:31.000000', 'consum', 0.0228, 'lps'),
	(541229, 129, '2014-02-15 00:20:32.000000', 'consum', 0.0223, 'lps'),
	(541230, 129, '2014-02-15 00:20:33.000000', 'consum', 0.0221, 'lps'),
	(541231, 129, '2014-02-15 00:20:34.000000', 'consum', 0.0225, 'lps'),
	(541232, 129, '2014-02-15 00:20:35.000000', 'consum', 0.0231, 'lps'),
	(541233, 129, '2014-02-15 00:20:36.000000', 'consum', 0.0218, 'lps'),
	(541234, 129, '2014-02-15 00:20:37.000000', 'consum', 0.0215, 'lps'),
	(541235, 129, '2014-02-15 00:20:38.000000', 'consum', 0.0212, 'lps'),
	(541236, 129, '2014-02-15 00:20:39.000000', 'consum', 0.0230, 'lps'),
	(541237, 129, '2014-02-15 00:20:40.000000', 'consum', 0.0228, 'lps'),
	(541238, 129, '2014-02-15 00:20:41.000000', 'consum', 0.0216, 'lps'),
	(541239, 129, '2014-02-15 00:20:42.000000', 'consum', 0.0212, 'lps'),
	(541240, 129, '2014-02-15 00:20:43.000000', 'consum', 0.0228, 'lps'),
	(541241, 129, '2014-02-15 00:20:44.000000', 'consum', 0.0217, 'lps'),
	(541242, 129, '2014-02-15 00:20:45.000000', 'consum', 0.0218, 'lps'),
	(541243, 129, '2014-02-15 00:20:46.000000', 'consum', 0.0229, 'lps'),
	(541244, 129, '2014-02-15 00:20:47.000000', 'consum', 0.0232, 'lps'),
	(541245, 129, '2014-02-15 00:20:48.000000', 'consum', 0.0214, 'lps'),
	(541246, 129, '2014-02-15 00:20:49.000000', 'consum', 0.0215, 'lps'),
	(541247, 129, '2014-02-15 00:20:50.000000', 'consum', 0.0225, 'lps'),
	(541248, 129, '2014-02-15 00:20:51.000000', 'consum', 0.0217, 'lps'),
	(541249, 129, '2014-02-15 00:20:52.000000', 'consum', 0.0228, 'lps'),
	(541250, 129, '2014-02-15 00:20:53.000000', 'consum', 0.0231, 'lps'),
	(541251, 129, '2014-02-15 00:20:54.000000', 'consum', 0.0234, 'lps'),
	(541252, 129, '2014-02-15 00:20:55.000000', 'consum', 0.0218, 'lps'),
	(541253, 129, '2014-02-15 00:20:56.000000', 'consum', 0.0227, 'lps'),
	(541254, 129, '2014-02-15 00:20:57.000000', 'consum', 0.0222, 'lps'),
	(541255, 129, '2014-02-15 00:20:58.000000', 'consum', 0.0218, 'lps'),
	(541256, 129, '2014-02-15 00:20:59.000000', 'consum', 0.0216, 'lps'),
	(541257, 129, '2014-02-15 00:21:00.000000', 'consum', 0.0214, 'lps'),
	(541258, 129, '2014-02-15 00:21:01.000000', 'consum', 0.0216, 'lps'),
	(541259, 129, '2014-02-15 00:21:02.000000', 'consum', 0.0226, 'lps'),
	(541260, 129, '2014-02-15 00:21:03.000000', 'consum', 0.0222, 'lps'),
	(541261, 129, '2014-02-15 00:21:04.000000', 'consum', 0.0223, 'lps'),
	(541262, 129, '2014-02-15 00:21:05.000000', 'consum', 0.0213, 'lps'),
	(541263, 129, '2014-02-15 00:21:06.000000', 'consum', 0.0215, 'lps'),
	(541264, 129, '2014-02-15 00:21:07.000000', 'consum', 0.0223, 'lps'),
	(541265, 129, '2014-02-15 00:21:08.000000', 'consum', 0.0211, 'lps'),
	(541266, 129, '2014-02-15 00:21:09.000000', 'consum', 0.0229, 'lps'),
	(541267, 129, '2014-02-15 00:21:10.000000', 'consum', 0.0225, 'lps'),
	(541268, 129, '2014-02-15 00:21:11.000000', 'consum', 0.0231, 'lps'),
	(541269, 129, '2014-02-15 00:21:12.000000', 'consum', 0.0218, 'lps'),
	(541270, 129, '2014-02-15 00:21:13.000000', 'consum', 0.0215, 'lps'),
	(541271, 129, '2014-02-15 00:21:14.000000', 'consum', 0.0234, 'lps'),
	(541272, 129, '2014-02-15 00:21:15.000000', 'consum', 0.0216, 'lps'),
	(541273, 129, '2014-02-15 00:21:16.000000', 'consum', 0.0219, 'lps'),
	(541274, 129, '2014-02-15 00:21:17.000000', 'consum', 0.0213, 'lps'),
	(541275, 129, '2014-02-15 00:21:18.000000', 'consum', 0.0223, 'lps'),
	(541276, 129, '2014-02-15 00:21:19.000000', 'consum', 0.0218, 'lps'),
	(541277, 129, '2014-02-15 00:21:20.000000', 'consum', 0.0210, 'lps'),
	(541278, 129, '2014-02-15 00:21:21.000000', 'consum', 0.0210, 'lps'),
	(541279, 129, '2014-02-15 00:21:22.000000', 'consum', 0.0214, 'lps'),
	(541280, 129, '2014-02-15 00:21:23.000000', 'consum', 0.0229, 'lps'),
	(541281, 129, '2014-02-15 00:21:24.000000', 'consum', 0.0217, 'lps'),
	(541282, 129, '2014-02-15 00:21:25.000000', 'consum', 0.0213, 'lps'),
	(541283, 129, '2014-02-15 00:21:26.000000', 'consum', 0.0231, 'lps'),
	(541284, 129, '2014-02-15 00:21:27.000000', 'consum', 0.0230, 'lps'),
	(541285, 129, '2014-02-15 00:21:28.000000', 'consum', 0.0225, 'lps'),
	(541286, 129, '2014-02-15 00:21:29.000000', 'consum', 0.0226, 'lps'),
	(541287, 129, '2014-02-15 00:21:30.000000', 'consum', 0.0219, 'lps'),
	(541288, 129, '2014-02-15 00:21:31.000000', 'consum', 0.0234, 'lps'),
	(541289, 129, '2014-02-15 00:21:32.000000', 'consum', 0.0226, 'lps'),
	(541290, 129, '2014-02-15 00:21:33.000000', 'consum', 0.0219, 'lps'),
	(541291, 129, '2014-02-15 00:21:34.000000', 'consum', 0.0233, 'lps'),
	(541292, 129, '2014-02-15 00:21:35.000000', 'consum', 0.0221, 'lps'),
	(541293, 129, '2014-02-15 00:21:36.000000', 'consum', 0.0225, 'lps'),
	(541294, 129, '2014-02-15 00:21:37.000000', 'consum', 0.0227, 'lps'),
	(541295, 129, '2014-02-15 00:21:38.000000', 'consum', 0.0223, 'lps'),
	(541296, 129, '2014-02-15 00:21:39.000000', 'consum', 0.0226, 'lps'),
	(541297, 129, '2014-02-15 00:21:40.000000', 'consum', 0.0226, 'lps'),
	(541298, 129, '2014-02-15 00:21:41.000000', 'consum', 0.0219, 'lps'),
	(541299, 129, '2014-02-15 00:21:42.000000', 'consum', 0.0230, 'lps'),
	(541300, 129, '2014-02-15 00:21:43.000000', 'consum', 0.0234, 'lps'),
	(541301, 129, '2014-02-15 00:21:44.000000', 'consum', 0.0222, 'lps'),
	(541302, 129, '2014-02-15 00:21:45.000000', 'consum', 0.0221, 'lps'),
	(541303, 129, '2014-02-15 00:21:46.000000', 'consum', 0.0231, 'lps'),
	(541304, 129, '2014-02-15 00:21:47.000000', 'consum', 0.0233, 'lps'),
	(541305, 129, '2014-02-15 00:21:48.000000', 'consum', 0.0213, 'lps'),
	(541306, 129, '2014-02-15 00:21:49.000000', 'consum', 0.0229, 'lps'),
	(541307, 129, '2014-02-15 00:21:50.000000', 'consum', 0.0225, 'lps'),
	(541308, 129, '2014-02-15 00:21:51.000000', 'consum', 0.0226, 'lps'),
	(541309, 129, '2014-02-15 00:21:52.000000', 'consum', 0.0221, 'lps'),
	(541310, 129, '2014-02-15 00:21:53.000000', 'consum', 0.0219, 'lps'),
	(541311, 129, '2014-02-15 00:21:54.000000', 'consum', 0.0223, 'lps'),
	(541312, 129, '2014-02-15 00:21:55.000000', 'consum', 0.0223, 'lps'),
	(541313, 129, '2014-02-15 00:21:56.000000', 'consum', 0.0210, 'lps'),
	(541314, 129, '2014-02-15 00:21:57.000000', 'consum', 0.0224, 'lps'),
	(541315, 129, '2014-02-15 00:21:58.000000', 'consum', 0.0230, 'lps'),
	(541316, 129, '2014-02-15 00:21:59.000000', 'consum', 0.0219, 'lps'),
	(541317, 129, '2014-02-15 00:22:00.000000', 'consum', 0.0219, 'lps'),
	(541318, 129, '2014-02-15 00:22:01.000000', 'consum', 0.0228, 'lps'),
	(541319, 129, '2014-02-15 00:22:02.000000', 'consum', 0.0222, 'lps'),
	(541320, 129, '2014-02-15 00:22:03.000000', 'consum', 0.0219, 'lps'),
	(541321, 129, '2014-02-15 00:22:04.000000', 'consum', 0.0218, 'lps'),
	(541322, 129, '2014-02-15 00:22:05.000000', 'consum', 0.0225, 'lps'),
	(541323, 129, '2014-02-15 00:22:06.000000', 'consum', 0.0234, 'lps'),
	(541324, 129, '2014-02-15 00:22:07.000000', 'consum', 0.0211, 'lps'),
	(541325, 129, '2014-02-15 00:22:08.000000', 'consum', 0.0220, 'lps'),
	(541326, 129, '2014-02-15 00:22:09.000000', 'consum', 0.0234, 'lps'),
	(541327, 129, '2014-02-15 00:22:10.000000', 'consum', 0.0222, 'lps'),
	(541328, 129, '2014-02-15 00:22:11.000000', 'consum', 0.0224, 'lps'),
	(541329, 129, '2014-02-15 00:22:12.000000', 'consum', 0.0221, 'lps'),
	(541330, 129, '2014-02-15 00:22:13.000000', 'consum', 0.0224, 'lps'),
	(541331, 129, '2014-02-15 00:22:14.000000', 'consum', 0.0221, 'lps'),
	(541332, 129, '2014-02-15 00:22:15.000000', 'consum', 0.0226, 'lps'),
	(541333, 129, '2014-02-15 00:22:16.000000', 'consum', 0.0230, 'lps'),
	(541334, 129, '2014-02-15 00:22:17.000000', 'consum', 0.0215, 'lps'),
	(541335, 129, '2014-02-15 00:22:18.000000', 'consum', 0.0225, 'lps'),
	(541336, 129, '2014-02-15 00:22:19.000000', 'consum', 0.0219, 'lps'),
	(541337, 129, '2014-02-15 00:22:20.000000', 'consum', 0.0210, 'lps'),
	(541338, 129, '2014-02-15 00:22:21.000000', 'consum', 0.0234, 'lps'),
	(541339, 129, '2014-02-15 00:22:22.000000', 'consum', 0.0231, 'lps'),
	(541340, 129, '2014-02-15 00:22:23.000000', 'consum', 0.0218, 'lps'),
	(541341, 129, '2014-02-15 00:22:24.000000', 'consum', 0.0211, 'lps'),
	(541342, 129, '2014-02-15 00:22:25.000000', 'consum', 0.0216, 'lps'),
	(541343, 129, '2014-02-15 00:22:26.000000', 'consum', 0.0214, 'lps'),
	(541344, 129, '2014-02-15 00:22:27.000000', 'consum', 0.0213, 'lps'),
	(541345, 129, '2014-02-15 00:22:28.000000', 'consum', 0.0214, 'lps'),
	(541346, 129, '2014-02-15 00:22:29.000000', 'consum', 0.0220, 'lps'),
	(541347, 129, '2014-02-15 00:22:30.000000', 'consum', 0.0223, 'lps'),
	(541348, 129, '2014-02-15 00:22:31.000000', 'consum', 0.0223, 'lps'),
	(541349, 129, '2014-02-15 00:22:32.000000', 'consum', 0.0211, 'lps'),
	(541350, 129, '2014-02-15 00:22:33.000000', 'consum', 0.0227, 'lps'),
	(541351, 129, '2014-02-15 00:22:34.000000', 'consum', 0.0218, 'lps'),
	(541352, 129, '2014-02-15 00:22:35.000000', 'consum', 0.0225, 'lps'),
	(541353, 129, '2014-02-15 00:22:36.000000', 'consum', 0.0210, 'lps'),
	(541354, 129, '2014-02-15 00:22:37.000000', 'consum', 0.0218, 'lps'),
	(541355, 129, '2014-02-15 00:22:38.000000', 'consum', 0.0224, 'lps'),
	(541356, 129, '2014-02-15 00:22:39.000000', 'consum', 0.0230, 'lps'),
	(541357, 129, '2014-02-15 00:22:40.000000', 'consum', 0.0220, 'lps'),
	(541358, 129, '2014-02-15 00:22:41.000000', 'consum', 0.0227, 'lps'),
	(541359, 129, '2014-02-15 00:22:42.000000', 'consum', 0.0213, 'lps'),
	(541360, 129, '2014-02-15 00:22:43.000000', 'consum', 0.0227, 'lps'),
	(541361, 129, '2014-02-15 00:22:44.000000', 'consum', 0.0234, 'lps'),
	(541362, 129, '2014-02-15 00:22:45.000000', 'consum', 0.0229, 'lps'),
	(541363, 129, '2014-02-15 00:22:46.000000', 'consum', 0.0233, 'lps'),
	(541364, 129, '2014-02-15 00:22:47.000000', 'consum', 0.0221, 'lps'),
	(541365, 129, '2014-02-15 00:22:48.000000', 'consum', 0.0222, 'lps'),
	(541366, 129, '2014-02-15 00:22:49.000000', 'consum', 0.0234, 'lps'),
	(541367, 129, '2014-02-15 00:22:50.000000', 'consum', 0.0223, 'lps'),
	(541368, 129, '2014-02-15 00:22:51.000000', 'consum', 0.0226, 'lps'),
	(541369, 129, '2014-02-15 00:22:52.000000', 'consum', 0.0229, 'lps'),
	(541370, 129, '2014-02-15 00:22:53.000000', 'consum', 0.0230, 'lps'),
	(541371, 129, '2014-02-15 00:22:54.000000', 'consum', 0.0229, 'lps'),
	(541372, 129, '2014-02-15 00:22:55.000000', 'consum', 0.0219, 'lps'),
	(541373, 129, '2014-02-15 00:22:56.000000', 'consum', 0.0226, 'lps'),
	(541374, 129, '2014-02-15 00:22:57.000000', 'consum', 0.0212, 'lps'),
	(541375, 129, '2014-02-15 00:22:58.000000', 'consum', 0.0225, 'lps'),
	(541376, 129, '2014-02-15 00:22:59.000000', 'consum', 0.0228, 'lps'),
	(541377, 129, '2014-02-15 00:23:00.000000', 'consum', 0.0230, 'lps'),
	(541378, 129, '2014-02-15 00:23:01.000000', 'consum', 0.0234, 'lps'),
	(541379, 129, '2014-02-15 00:23:02.000000', 'consum', 0.0219, 'lps'),
	(541380, 129, '2014-02-15 00:23:03.000000', 'consum', 0.0232, 'lps'),
	(541381, 129, '2014-02-15 00:23:04.000000', 'consum', 0.0218, 'lps'),
	(541382, 129, '2014-02-15 00:23:05.000000', 'consum', 0.0211, 'lps'),
	(541383, 129, '2014-02-15 00:23:06.000000', 'consum', 0.0218, 'lps'),
	(541384, 129, '2014-02-15 00:23:07.000000', 'consum', 0.0220, 'lps'),
	(541385, 129, '2014-02-15 00:23:08.000000', 'consum', 0.0211, 'lps'),
	(541386, 129, '2014-02-15 00:23:09.000000', 'consum', 0.0213, 'lps'),
	(541387, 129, '2014-02-15 00:23:10.000000', 'consum', 0.0223, 'lps'),
	(541388, 129, '2014-02-15 00:23:11.000000', 'consum', 0.0217, 'lps'),
	(541389, 129, '2014-02-15 00:23:12.000000', 'consum', 0.0231, 'lps'),
	(541390, 129, '2014-02-15 00:23:13.000000', 'consum', 0.0221, 'lps'),
	(541391, 129, '2014-02-15 00:23:14.000000', 'consum', 0.0226, 'lps'),
	(541392, 129, '2014-02-15 00:23:15.000000', 'consum', 0.0231, 'lps'),
	(541393, 129, '2014-02-15 00:23:16.000000', 'consum', 0.0220, 'lps'),
	(541394, 129, '2014-02-15 00:23:17.000000', 'consum', 0.0223, 'lps'),
	(541395, 129, '2014-02-15 00:23:18.000000', 'consum', 0.0218, 'lps'),
	(541396, 129, '2014-02-15 00:23:19.000000', 'consum', 0.0211, 'lps'),
	(541397, 129, '2014-02-15 00:23:20.000000', 'consum', 0.0219, 'lps'),
	(541398, 129, '2014-02-15 00:23:21.000000', 'consum', 0.0228, 'lps'),
	(541399, 129, '2014-02-15 00:23:22.000000', 'consum', 0.0223, 'lps'),
	(541400, 129, '2014-02-15 00:23:23.000000', 'consum', 0.0221, 'lps'),
	(541401, 129, '2014-02-15 00:23:24.000000', 'consum', 0.0226, 'lps'),
	(541402, 129, '2014-02-15 00:23:25.000000', 'consum', 0.0232, 'lps'),
	(541403, 129, '2014-02-15 00:23:26.000000', 'consum', 0.0222, 'lps'),
	(541404, 129, '2014-02-15 00:23:27.000000', 'consum', 0.0229, 'lps'),
	(541405, 129, '2014-02-15 00:23:28.000000', 'consum', 0.0221, 'lps'),
	(541406, 129, '2014-02-15 00:23:29.000000', 'consum', 0.0210, 'lps'),
	(541407, 129, '2014-02-15 00:23:30.000000', 'consum', 0.0227, 'lps'),
	(541408, 129, '2014-02-15 00:23:31.000000', 'consum', 0.0218, 'lps'),
	(541409, 129, '2014-02-15 00:23:32.000000', 'consum', 0.0228, 'lps'),
	(541410, 129, '2014-02-15 00:23:33.000000', 'consum', 0.0223, 'lps'),
	(541411, 129, '2014-02-15 00:23:34.000000', 'consum', 0.0223, 'lps'),
	(541412, 129, '2014-02-15 00:23:35.000000', 'consum', 0.0213, 'lps'),
	(541413, 129, '2014-02-15 00:23:36.000000', 'consum', 0.0212, 'lps'),
	(541414, 129, '2014-02-15 00:23:37.000000', 'consum', 0.0211, 'lps'),
	(541415, 129, '2014-02-15 00:23:38.000000', 'consum', 0.0211, 'lps'),
	(541416, 129, '2014-02-15 00:23:39.000000', 'consum', 0.0210, 'lps'),
	(541417, 129, '2014-02-15 00:23:40.000000', 'consum', 0.0210, 'lps'),
	(541418, 129, '2014-02-15 00:23:41.000000', 'consum', 0.0234, 'lps'),
	(541419, 129, '2014-02-15 00:23:42.000000', 'consum', 0.0232, 'lps'),
	(541420, 129, '2014-02-15 00:23:43.000000', 'consum', 0.0223, 'lps'),
	(541421, 129, '2014-02-15 00:23:44.000000', 'consum', 0.0233, 'lps'),
	(541422, 129, '2014-02-15 00:23:45.000000', 'consum', 0.0210, 'lps'),
	(541423, 129, '2014-02-15 00:23:46.000000', 'consum', 0.0219, 'lps'),
	(541424, 129, '2014-02-15 00:23:47.000000', 'consum', 0.0230, 'lps'),
	(541425, 129, '2014-02-15 00:23:48.000000', 'consum', 0.0234, 'lps'),
	(541426, 129, '2014-02-15 00:23:49.000000', 'consum', 0.0220, 'lps'),
	(541427, 129, '2014-02-15 00:23:50.000000', 'consum', 0.0212, 'lps'),
	(541428, 129, '2014-02-15 00:23:51.000000', 'consum', 0.0218, 'lps'),
	(541429, 129, '2014-02-15 00:23:52.000000', 'consum', 0.0218, 'lps'),
	(541430, 129, '2014-02-15 00:23:53.000000', 'consum', 0.0228, 'lps'),
	(541431, 129, '2014-02-15 00:23:54.000000', 'consum', 0.0225, 'lps'),
	(541432, 129, '2014-02-15 00:23:55.000000', 'consum', 0.0233, 'lps'),
	(541433, 129, '2014-02-15 00:23:56.000000', 'consum', 0.0230, 'lps'),
	(541434, 129, '2014-02-15 00:23:57.000000', 'consum', 0.0218, 'lps'),
	(541435, 129, '2014-02-15 00:23:58.000000', 'consum', 0.0212, 'lps'),
	(541436, 129, '2014-02-15 00:23:59.000000', 'consum', 0.0224, 'lps'),
	(541437, 129, '2014-02-15 00:24:00.000000', 'consum', 0.0225, 'lps'),
	(541438, 129, '2014-02-15 00:24:01.000000', 'consum', 0.0217, 'lps'),
	(541439, 129, '2014-02-15 00:24:02.000000', 'consum', 0.0227, 'lps'),
	(541440, 129, '2014-02-15 00:24:03.000000', 'consum', 0.0224, 'lps'),
	(541441, 129, '2014-02-15 00:24:04.000000', 'consum', 0.0230, 'lps'),
	(541442, 129, '2014-02-15 00:24:05.000000', 'consum', 0.0218, 'lps'),
	(541443, 129, '2014-02-15 00:24:06.000000', 'consum', 0.0215, 'lps'),
	(541444, 129, '2014-02-15 00:24:07.000000', 'consum', 0.0210, 'lps'),
	(541445, 129, '2014-02-15 00:24:08.000000', 'consum', 0.0223, 'lps'),
	(541446, 129, '2014-02-15 00:24:09.000000', 'consum', 0.0224, 'lps'),
	(541447, 129, '2014-02-15 00:24:10.000000', 'consum', 0.0215, 'lps'),
	(541448, 129, '2014-02-15 00:24:11.000000', 'consum', 0.0221, 'lps'),
	(541449, 129, '2014-02-15 00:24:12.000000', 'consum', 0.0224, 'lps'),
	(541450, 129, '2014-02-15 00:24:13.000000', 'consum', 0.0225, 'lps'),
	(541451, 129, '2014-02-15 00:24:14.000000', 'consum', 0.0217, 'lps'),
	(541452, 129, '2014-02-15 00:24:15.000000', 'consum', 0.0224, 'lps'),
	(541453, 129, '2014-02-15 00:24:16.000000', 'consum', 0.0234, 'lps'),
	(541454, 129, '2014-02-15 00:24:17.000000', 'consum', 0.0214, 'lps'),
	(541455, 129, '2014-02-15 00:24:18.000000', 'consum', 0.0233, 'lps'),
	(541456, 129, '2014-02-15 00:24:19.000000', 'consum', 0.0213, 'lps'),
	(541457, 129, '2014-02-15 00:24:20.000000', 'consum', 0.0232, 'lps'),
	(541458, 129, '2014-02-15 00:24:21.000000', 'consum', 0.0212, 'lps'),
	(541459, 129, '2014-02-15 00:24:22.000000', 'consum', 0.0230, 'lps'),
	(541460, 129, '2014-02-15 00:24:23.000000', 'consum', 0.0228, 'lps'),
	(541461, 129, '2014-02-15 00:24:24.000000', 'consum', 0.0215, 'lps'),
	(541462, 129, '2014-02-15 00:24:25.000000', 'consum', 0.0233, 'lps'),
	(541463, 129, '2014-02-15 00:24:26.000000', 'consum', 0.0210, 'lps'),
	(541464, 129, '2014-02-15 00:24:27.000000', 'consum', 0.0217, 'lps'),
	(541465, 129, '2014-02-15 00:24:28.000000', 'consum', 0.0220, 'lps'),
	(541466, 129, '2014-02-15 00:24:29.000000', 'consum', 0.0214, 'lps'),
	(541467, 129, '2014-02-15 00:24:30.000000', 'consum', 0.0227, 'lps'),
	(541468, 129, '2014-02-15 00:24:31.000000', 'consum', 0.0234, 'lps'),
	(541469, 129, '2014-02-15 00:24:32.000000', 'consum', 0.0228, 'lps'),
	(541470, 129, '2014-02-15 00:24:33.000000', 'consum', 0.0229, 'lps'),
	(541471, 129, '2014-02-15 00:24:34.000000', 'consum', 0.0226, 'lps'),
	(541472, 129, '2014-02-15 00:24:35.000000', 'consum', 0.0232, 'lps'),
	(541473, 129, '2014-02-15 00:24:36.000000', 'consum', 0.0224, 'lps'),
	(541474, 129, '2014-02-15 00:24:37.000000', 'consum', 0.0215, 'lps'),
	(541475, 129, '2014-02-15 00:24:38.000000', 'consum', 0.0219, 'lps'),
	(541476, 129, '2014-02-15 00:24:39.000000', 'consum', 0.0213, 'lps'),
	(541477, 129, '2014-02-15 00:24:40.000000', 'consum', 0.0226, 'lps'),
	(541478, 129, '2014-02-15 00:24:41.000000', 'consum', 0.0230, 'lps'),
	(541479, 129, '2014-02-15 00:24:42.000000', 'consum', 0.0213, 'lps'),
	(541480, 129, '2014-02-15 00:24:43.000000', 'consum', 0.0214, 'lps'),
	(541481, 129, '2014-02-15 00:24:44.000000', 'consum', 0.0221, 'lps'),
	(541482, 129, '2014-02-15 00:24:45.000000', 'consum', 0.0231, 'lps'),
	(541483, 129, '2014-02-15 00:24:46.000000', 'consum', 0.0231, 'lps'),
	(541484, 129, '2014-02-15 00:24:47.000000', 'consum', 0.0227, 'lps'),
	(541485, 129, '2014-02-15 00:24:48.000000', 'consum', 0.0210, 'lps'),
	(541486, 129, '2014-02-15 00:24:49.000000', 'consum', 0.0231, 'lps'),
	(541487, 129, '2014-02-15 00:24:50.000000', 'consum', 0.0219, 'lps'),
	(541488, 129, '2014-02-15 00:24:51.000000', 'consum', 0.0216, 'lps'),
	(541489, 129, '2014-02-15 00:24:52.000000', 'consum', 0.0214, 'lps'),
	(541490, 129, '2014-02-15 00:24:53.000000', 'consum', 0.0210, 'lps'),
	(541491, 129, '2014-02-15 00:24:54.000000', 'consum', 0.0226, 'lps'),
	(541492, 129, '2014-02-15 00:24:55.000000', 'consum', 0.0215, 'lps'),
	(541493, 129, '2014-02-15 00:24:56.000000', 'consum', 0.0214, 'lps'),
	(541494, 129, '2014-02-15 00:24:57.000000', 'consum', 0.0213, 'lps'),
	(541495, 129, '2014-02-15 00:24:58.000000', 'consum', 0.0215, 'lps'),
	(541496, 129, '2014-02-15 00:24:59.000000', 'consum', 0.0228, 'lps'),
	(541497, 129, '2014-02-15 00:25:00.000000', 'consum', 0.0210, 'lps'),
	(541498, 129, '2014-02-15 00:25:01.000000', 'consum', 0.0230, 'lps'),
	(541499, 129, '2014-02-15 00:25:02.000000', 'consum', 0.0210, 'lps'),
	(541500, 129, '2014-02-15 00:25:03.000000', 'consum', 0.0225, 'lps'),
	(541501, 129, '2014-02-15 00:25:04.000000', 'consum', 0.0213, 'lps'),
	(541502, 129, '2014-02-15 00:25:05.000000', 'consum', 0.0230, 'lps'),
	(541503, 129, '2014-02-15 00:25:06.000000', 'consum', 0.0227, 'lps'),
	(541504, 129, '2014-02-15 00:25:07.000000', 'consum', 0.0233, 'lps'),
	(541505, 129, '2014-02-15 00:25:08.000000', 'consum', 0.0225, 'lps'),
	(541506, 129, '2014-02-15 00:25:09.000000', 'consum', 0.0219, 'lps'),
	(541507, 129, '2014-02-15 00:25:10.000000', 'consum', 0.0232, 'lps'),
	(541508, 129, '2014-02-15 00:25:11.000000', 'consum', 0.0221, 'lps'),
	(541509, 129, '2014-02-15 00:25:12.000000', 'consum', 0.0225, 'lps'),
	(541510, 129, '2014-02-15 00:25:13.000000', 'consum', 0.0228, 'lps'),
	(541511, 129, '2014-02-15 00:25:14.000000', 'consum', 0.0229, 'lps'),
	(541512, 129, '2014-02-15 00:25:15.000000', 'consum', 0.0226, 'lps'),
	(541513, 129, '2014-02-15 00:25:16.000000', 'consum', 0.0232, 'lps'),
	(541514, 129, '2014-02-15 00:25:17.000000', 'consum', 0.0225, 'lps'),
	(541515, 129, '2014-02-15 00:25:18.000000', 'consum', 0.0218, 'lps'),
	(541516, 129, '2014-02-15 00:25:19.000000', 'consum', 0.0232, 'lps'),
	(541517, 129, '2014-02-15 00:25:20.000000', 'consum', 0.0222, 'lps'),
	(541518, 129, '2014-02-15 00:25:21.000000', 'consum', 0.0227, 'lps'),
	(541519, 129, '2014-02-15 00:25:22.000000', 'consum', 0.0210, 'lps'),
	(541520, 129, '2014-02-15 00:25:23.000000', 'consum', 0.0234, 'lps'),
	(541521, 129, '2014-02-15 00:25:24.000000', 'consum', 0.0233, 'lps'),
	(541522, 129, '2014-02-15 00:25:25.000000', 'consum', 0.0227, 'lps'),
	(541523, 129, '2014-02-15 00:25:26.000000', 'consum', 0.0228, 'lps'),
	(541524, 129, '2014-02-15 00:25:27.000000', 'consum', 0.0223, 'lps'),
	(541525, 129, '2014-02-15 00:25:28.000000', 'consum', 0.0223, 'lps'),
	(541526, 129, '2014-02-15 00:25:29.000000', 'consum', 0.0234, 'lps'),
	(541527, 129, '2014-02-15 00:25:30.000000', 'consum', 0.0217, 'lps'),
	(541528, 129, '2014-02-15 00:25:31.000000', 'consum', 0.0224, 'lps'),
	(541529, 129, '2014-02-15 00:25:32.000000', 'consum', 0.0211, 'lps'),
	(541530, 129, '2014-02-15 00:25:33.000000', 'consum', 0.0223, 'lps'),
	(541531, 129, '2014-02-15 00:25:34.000000', 'consum', 0.0223, 'lps'),
	(541532, 129, '2014-02-15 00:25:35.000000', 'consum', 0.0212, 'lps'),
	(541533, 129, '2014-02-15 00:25:36.000000', 'consum', 0.0230, 'lps'),
	(541534, 129, '2014-02-15 00:25:37.000000', 'consum', 0.0231, 'lps'),
	(541535, 129, '2014-02-15 00:25:38.000000', 'consum', 0.0230, 'lps'),
	(541536, 129, '2014-02-15 00:25:39.000000', 'consum', 0.0224, 'lps'),
	(541537, 129, '2014-02-15 00:25:40.000000', 'consum', 0.0219, 'lps'),
	(541538, 129, '2014-02-15 00:25:41.000000', 'consum', 0.0213, 'lps'),
	(541539, 129, '2014-02-15 00:25:42.000000', 'consum', 0.0226, 'lps'),
	(541540, 129, '2014-02-15 00:25:43.000000', 'consum', 0.0229, 'lps'),
	(541541, 129, '2014-02-15 00:25:44.000000', 'consum', 0.0232, 'lps'),
	(541542, 129, '2014-02-15 00:25:45.000000', 'consum', 0.0214, 'lps'),
	(541543, 129, '2014-02-15 00:25:46.000000', 'consum', 0.0213, 'lps'),
	(541544, 129, '2014-02-15 00:25:47.000000', 'consum', 0.0217, 'lps'),
	(541545, 129, '2014-02-15 00:25:48.000000', 'consum', 0.0234, 'lps'),
	(541546, 129, '2014-02-15 00:25:49.000000', 'consum', 0.0212, 'lps'),
	(541547, 129, '2014-02-15 00:25:50.000000', 'consum', 0.0221, 'lps'),
	(541548, 129, '2014-02-15 00:25:51.000000', 'consum', 0.0212, 'lps'),
	(541549, 129, '2014-02-15 00:25:52.000000', 'consum', 0.0234, 'lps'),
	(541550, 129, '2014-02-15 00:25:53.000000', 'consum', 0.0228, 'lps'),
	(541551, 129, '2014-02-15 00:25:54.000000', 'consum', 0.0225, 'lps'),
	(541552, 129, '2014-02-15 00:25:55.000000', 'consum', 0.0234, 'lps'),
	(541553, 129, '2014-02-15 00:25:56.000000', 'consum', 0.0233, 'lps'),
	(541554, 129, '2014-02-15 00:25:57.000000', 'consum', 0.0230, 'lps'),
	(541555, 129, '2014-02-15 00:25:58.000000', 'consum', 0.0217, 'lps'),
	(541556, 129, '2014-02-15 00:25:59.000000', 'consum', 0.0212, 'lps'),
	(541557, 129, '2014-02-15 00:26:00.000000', 'consum', 0.0222, 'lps'),
	(541558, 129, '2014-02-15 00:26:01.000000', 'consum', 0.0217, 'lps'),
	(541559, 129, '2014-02-15 00:26:02.000000', 'consum', 0.0233, 'lps'),
	(541560, 129, '2014-02-15 00:26:03.000000', 'consum', 0.0232, 'lps'),
	(541561, 129, '2014-02-15 00:26:04.000000', 'consum', 0.0224, 'lps'),
	(541562, 129, '2014-02-15 00:26:05.000000', 'consum', 0.0215, 'lps'),
	(541563, 129, '2014-02-15 00:26:06.000000', 'consum', 0.0219, 'lps'),
	(541564, 129, '2014-02-15 00:26:07.000000', 'consum', 0.0217, 'lps'),
	(541565, 129, '2014-02-15 00:26:08.000000', 'consum', 0.0218, 'lps'),
	(541566, 129, '2014-02-15 00:26:09.000000', 'consum', 0.0231, 'lps'),
	(541567, 129, '2014-02-15 00:26:10.000000', 'consum', 0.0215, 'lps'),
	(541568, 129, '2014-02-15 00:26:11.000000', 'consum', 0.0225, 'lps'),
	(541569, 129, '2014-02-15 00:26:12.000000', 'consum', 0.0217, 'lps'),
	(541570, 129, '2014-02-15 00:26:13.000000', 'consum', 0.0227, 'lps'),
	(541571, 129, '2014-02-15 00:26:14.000000', 'consum', 0.0225, 'lps'),
	(541572, 129, '2014-02-15 00:26:15.000000', 'consum', 0.0210, 'lps'),
	(541573, 129, '2014-02-15 00:26:16.000000', 'consum', 0.0216, 'lps'),
	(541574, 129, '2014-02-15 00:26:17.000000', 'consum', 0.0213, 'lps'),
	(541575, 129, '2014-02-15 00:26:18.000000', 'consum', 0.0234, 'lps'),
	(541576, 129, '2014-02-15 00:26:19.000000', 'consum', 0.0222, 'lps'),
	(541577, 129, '2014-02-15 00:26:20.000000', 'consum', 0.0222, 'lps'),
	(541578, 129, '2014-02-15 00:26:21.000000', 'consum', 0.0234, 'lps'),
	(541579, 129, '2014-02-15 00:26:22.000000', 'consum', 0.0220, 'lps'),
	(541580, 129, '2014-02-15 00:26:23.000000', 'consum', 0.0216, 'lps'),
	(541581, 129, '2014-02-15 00:26:24.000000', 'consum', 0.0232, 'lps'),
	(541582, 129, '2014-02-15 00:26:25.000000', 'consum', 0.0228, 'lps'),
	(541583, 129, '2014-02-15 00:26:26.000000', 'consum', 0.0211, 'lps'),
	(541584, 129, '2014-02-15 00:26:27.000000', 'consum', 0.0234, 'lps'),
	(541585, 129, '2014-02-15 00:26:28.000000', 'consum', 0.0229, 'lps'),
	(541586, 129, '2014-02-15 00:26:29.000000', 'consum', 0.0234, 'lps'),
	(541587, 129, '2014-02-15 00:26:30.000000', 'consum', 0.0222, 'lps'),
	(541588, 129, '2014-02-15 00:26:31.000000', 'consum', 0.0225, 'lps'),
	(541589, 129, '2014-02-15 00:26:32.000000', 'consum', 0.0223, 'lps'),
	(541590, 129, '2014-02-15 00:26:33.000000', 'consum', 0.0230, 'lps'),
	(541591, 129, '2014-02-15 00:26:34.000000', 'consum', 0.0223, 'lps'),
	(541592, 129, '2014-02-15 00:26:35.000000', 'consum', 0.0215, 'lps'),
	(541593, 129, '2014-02-15 00:26:36.000000', 'consum', 0.0221, 'lps'),
	(541594, 129, '2014-02-15 00:26:37.000000', 'consum', 0.0226, 'lps'),
	(541595, 129, '2014-02-15 00:26:38.000000', 'consum', 0.0232, 'lps'),
	(541596, 129, '2014-02-15 00:26:39.000000', 'consum', 0.0222, 'lps'),
	(541597, 129, '2014-02-15 00:26:40.000000', 'consum', 0.0232, 'lps'),
	(541598, 129, '2014-02-15 00:26:41.000000', 'consum', 0.0232, 'lps'),
	(541599, 129, '2014-02-15 00:26:42.000000', 'consum', 0.0231, 'lps'),
	(541600, 129, '2014-02-15 00:26:43.000000', 'consum', 0.0223, 'lps'),
	(541601, 129, '2014-02-15 00:26:44.000000', 'consum', 0.0212, 'lps'),
	(541602, 129, '2014-02-15 00:26:45.000000', 'consum', 0.0231, 'lps'),
	(541603, 129, '2014-02-15 00:26:46.000000', 'consum', 0.0234, 'lps'),
	(541604, 129, '2014-02-15 00:26:47.000000', 'consum', 0.0220, 'lps'),
	(541605, 129, '2014-02-15 00:26:48.000000', 'consum', 0.0214, 'lps'),
	(541606, 129, '2014-02-15 00:26:49.000000', 'consum', 0.0222, 'lps'),
	(541607, 129, '2014-02-15 00:26:50.000000', 'consum', 0.0212, 'lps'),
	(541608, 129, '2014-02-15 00:26:51.000000', 'consum', 0.0233, 'lps'),
	(541609, 129, '2014-02-15 00:26:52.000000', 'consum', 0.0220, 'lps'),
	(541610, 129, '2014-02-15 00:26:53.000000', 'consum', 0.0215, 'lps'),
	(541611, 129, '2014-02-15 00:26:54.000000', 'consum', 0.0229, 'lps'),
	(541612, 129, '2014-02-15 00:26:55.000000', 'consum', 0.0219, 'lps'),
	(541613, 129, '2014-02-15 00:26:56.000000', 'consum', 0.0220, 'lps'),
	(541614, 129, '2014-02-15 00:26:57.000000', 'consum', 0.0211, 'lps'),
	(541615, 129, '2014-02-15 00:26:58.000000', 'consum', 0.0234, 'lps'),
	(541616, 129, '2014-02-15 00:26:59.000000', 'consum', 0.0229, 'lps'),
	(541617, 129, '2014-02-15 00:27:00.000000', 'consum', 0.0232, 'lps'),
	(541618, 129, '2014-02-15 00:27:01.000000', 'consum', 0.0215, 'lps'),
	(541619, 129, '2014-02-15 00:27:02.000000', 'consum', 0.0221, 'lps'),
	(541620, 129, '2014-02-15 00:27:03.000000', 'consum', 0.0222, 'lps'),
	(541621, 129, '2014-02-15 00:27:04.000000', 'consum', 0.0215, 'lps'),
	(541622, 129, '2014-02-15 00:27:05.000000', 'consum', 0.0222, 'lps'),
	(541623, 129, '2014-02-15 00:27:06.000000', 'consum', 0.0232, 'lps'),
	(541624, 129, '2014-02-15 00:27:07.000000', 'consum', 0.0210, 'lps'),
	(541625, 129, '2014-02-15 00:27:08.000000', 'consum', 0.0221, 'lps'),
	(541626, 129, '2014-02-15 00:27:09.000000', 'consum', 0.0213, 'lps'),
	(541627, 129, '2014-02-15 00:27:10.000000', 'consum', 0.0216, 'lps'),
	(541628, 129, '2014-02-15 00:27:11.000000', 'consum', 0.0210, 'lps'),
	(541629, 129, '2014-02-15 00:27:12.000000', 'consum', 0.0215, 'lps'),
	(541630, 129, '2014-02-15 00:27:13.000000', 'consum', 0.0210, 'lps'),
	(541631, 129, '2014-02-15 00:27:14.000000', 'consum', 0.0222, 'lps'),
	(541632, 129, '2014-02-15 00:27:15.000000', 'consum', 0.0220, 'lps'),
	(541633, 129, '2014-02-15 00:27:16.000000', 'consum', 0.0223, 'lps'),
	(541634, 129, '2014-02-15 00:27:17.000000', 'consum', 0.0222, 'lps'),
	(541635, 129, '2014-02-15 00:27:18.000000', 'consum', 0.0232, 'lps'),
	(541636, 129, '2014-02-15 00:27:19.000000', 'consum', 0.0234, 'lps'),
	(541637, 129, '2014-02-15 00:27:20.000000', 'consum', 0.0216, 'lps'),
	(541638, 129, '2014-02-15 00:27:21.000000', 'consum', 0.0216, 'lps'),
	(541639, 129, '2014-02-15 00:27:22.000000', 'consum', 0.0224, 'lps'),
	(541640, 129, '2014-02-15 00:27:23.000000', 'consum', 0.0213, 'lps'),
	(541641, 129, '2014-02-15 00:27:24.000000', 'consum', 0.0231, 'lps'),
	(541642, 129, '2014-02-15 00:27:25.000000', 'consum', 0.0232, 'lps'),
	(541643, 129, '2014-02-15 00:27:26.000000', 'consum', 0.0234, 'lps'),
	(541644, 129, '2014-02-15 00:27:27.000000', 'consum', 0.0215, 'lps'),
	(541645, 129, '2014-02-15 00:27:28.000000', 'consum', 0.0212, 'lps'),
	(541646, 129, '2014-02-15 00:27:29.000000', 'consum', 0.0230, 'lps'),
	(541647, 129, '2014-02-15 00:27:30.000000', 'consum', 0.0228, 'lps'),
	(541648, 129, '2014-02-15 00:27:31.000000', 'consum', 0.0218, 'lps'),
	(541649, 129, '2014-02-15 00:27:32.000000', 'consum', 0.0220, 'lps'),
	(541650, 129, '2014-02-15 00:27:33.000000', 'consum', 0.0211, 'lps'),
	(541651, 129, '2014-02-15 00:27:34.000000', 'consum', 0.0211, 'lps'),
	(541652, 129, '2014-02-15 00:27:35.000000', 'consum', 0.0214, 'lps'),
	(541653, 129, '2014-02-15 00:27:36.000000', 'consum', 0.0228, 'lps'),
	(541654, 129, '2014-02-15 00:27:37.000000', 'consum', 0.0212, 'lps'),
	(541655, 129, '2014-02-15 00:27:38.000000', 'consum', 0.0216, 'lps'),
	(541656, 129, '2014-02-15 00:27:39.000000', 'consum', 0.0210, 'lps'),
	(541657, 129, '2014-02-15 00:27:40.000000', 'consum', 0.0216, 'lps'),
	(541658, 129, '2014-02-15 00:27:41.000000', 'consum', 0.0216, 'lps'),
	(541659, 129, '2014-02-15 00:27:42.000000', 'consum', 0.0223, 'lps'),
	(541660, 129, '2014-02-15 00:27:43.000000', 'consum', 0.0210, 'lps'),
	(541661, 129, '2014-02-15 00:27:44.000000', 'consum', 0.0218, 'lps'),
	(541662, 129, '2014-02-15 00:27:45.000000', 'consum', 0.0226, 'lps'),
	(541663, 129, '2014-02-15 00:27:46.000000', 'consum', 0.0216, 'lps'),
	(541664, 129, '2014-02-15 00:27:47.000000', 'consum', 0.0217, 'lps'),
	(541665, 129, '2014-02-15 00:27:48.000000', 'consum', 0.0226, 'lps'),
	(541666, 129, '2014-02-15 00:27:49.000000', 'consum', 0.0222, 'lps'),
	(541667, 129, '2014-02-15 00:27:50.000000', 'consum', 0.0222, 'lps'),
	(541668, 129, '2014-02-15 00:27:51.000000', 'consum', 0.0210, 'lps'),
	(541669, 129, '2014-02-15 00:27:52.000000', 'consum', 0.0224, 'lps'),
	(541670, 129, '2014-02-15 00:27:53.000000', 'consum', 0.0230, 'lps'),
	(541671, 129, '2014-02-15 00:27:54.000000', 'consum', 0.0218, 'lps'),
	(541672, 129, '2014-02-15 00:27:55.000000', 'consum', 0.0215, 'lps'),
	(541673, 129, '2014-02-15 00:27:56.000000', 'consum', 0.0212, 'lps'),
	(541674, 129, '2014-02-15 00:27:57.000000', 'consum', 0.0230, 'lps'),
	(541675, 129, '2014-02-15 00:27:58.000000', 'consum', 0.0229, 'lps'),
	(541676, 129, '2014-02-15 00:27:59.000000', 'consum', 0.0219, 'lps'),
	(541677, 129, '2014-02-15 00:28:00.000000', 'consum', 0.0226, 'lps'),
	(541678, 129, '2014-02-15 00:28:01.000000', 'consum', 0.0211, 'lps'),
	(541679, 129, '2014-02-15 00:28:02.000000', 'consum', 0.0219, 'lps'),
	(541680, 129, '2014-02-15 00:28:03.000000', 'consum', 0.0227, 'lps'),
	(541681, 129, '2014-02-15 00:28:04.000000', 'consum', 0.0219, 'lps'),
	(541682, 129, '2014-02-15 00:28:05.000000', 'consum', 0.0228, 'lps'),
	(541683, 129, '2014-02-15 00:28:06.000000', 'consum', 0.0226, 'lps'),
	(541684, 129, '2014-02-15 00:28:07.000000', 'consum', 0.0234, 'lps'),
	(541685, 129, '2014-02-15 00:28:08.000000', 'consum', 0.0232, 'lps'),
	(541686, 129, '2014-02-15 00:28:09.000000', 'consum', 0.0226, 'lps'),
	(541687, 129, '2014-02-15 00:28:10.000000', 'consum', 0.0222, 'lps'),
	(541688, 129, '2014-02-15 00:28:11.000000', 'consum', 0.0222, 'lps'),
	(541689, 129, '2014-02-15 00:28:12.000000', 'consum', 0.0234, 'lps'),
	(541690, 129, '2014-02-15 00:28:13.000000', 'consum', 0.0220, 'lps'),
	(541691, 129, '2014-02-15 00:28:14.000000', 'consum', 0.0212, 'lps'),
	(541692, 129, '2014-02-15 00:28:15.000000', 'consum', 0.0217, 'lps'),
	(541693, 129, '2014-02-15 00:28:16.000000', 'consum', 0.0215, 'lps'),
	(541694, 129, '2014-02-15 00:28:17.000000', 'consum', 0.0214, 'lps'),
	(541695, 129, '2014-02-15 00:28:18.000000', 'consum', 0.0216, 'lps'),
	(541696, 129, '2014-02-15 00:28:19.000000', 'consum', 0.0228, 'lps'),
	(541697, 129, '2014-02-15 00:28:20.000000', 'consum', 0.0234, 'lps'),
	(541698, 129, '2014-02-15 00:28:21.000000', 'consum', 0.0227, 'lps'),
	(541699, 129, '2014-02-15 00:28:22.000000', 'consum', 0.0223, 'lps'),
	(541700, 129, '2014-02-15 00:28:23.000000', 'consum', 0.0222, 'lps'),
	(541701, 129, '2014-02-15 00:28:24.000000', 'consum', 0.0210, 'lps'),
	(541702, 129, '2014-02-15 00:28:25.000000', 'consum', 0.0221, 'lps'),
	(541703, 129, '2014-02-15 00:28:26.000000', 'consum', 0.0218, 'lps'),
	(541704, 129, '2014-02-15 00:28:27.000000', 'consum', 0.0216, 'lps'),
	(541705, 129, '2014-02-15 00:28:28.000000', 'consum', 0.0215, 'lps'),
	(541706, 129, '2014-02-15 00:28:29.000000', 'consum', 0.0219, 'lps'),
	(541707, 129, '2014-02-15 00:28:30.000000', 'consum', 0.0218, 'lps'),
	(541708, 129, '2014-02-15 00:28:31.000000', 'consum', 0.0220, 'lps'),
	(541709, 129, '2014-02-15 00:28:32.000000', 'consum', 0.0212, 'lps'),
	(541710, 129, '2014-02-15 00:28:33.000000', 'consum', 0.0216, 'lps'),
	(541711, 129, '2014-02-15 00:28:34.000000', 'consum', 0.0211, 'lps'),
	(541712, 129, '2014-02-15 00:28:35.000000', 'consum', 0.0221, 'lps'),
	(541713, 129, '2014-02-15 00:28:36.000000', 'consum', 0.0212, 'lps'),
	(541714, 129, '2014-02-15 00:28:37.000000', 'consum', 0.0214, 'lps'),
	(541715, 129, '2014-02-15 00:28:38.000000', 'consum', 0.0224, 'lps'),
	(541716, 129, '2014-02-15 00:28:39.000000', 'consum', 0.0219, 'lps'),
	(541717, 129, '2014-02-15 00:28:40.000000', 'consum', 0.0215, 'lps'),
	(541718, 129, '2014-02-15 00:28:41.000000', 'consum', 0.0231, 'lps'),
	(541719, 129, '2014-02-15 00:28:42.000000', 'consum', 0.0226, 'lps'),
	(541720, 129, '2014-02-15 00:28:43.000000', 'consum', 0.0226, 'lps'),
	(541721, 129, '2014-02-15 00:28:44.000000', 'consum', 0.0220, 'lps'),
	(541722, 129, '2014-02-15 00:28:45.000000', 'consum', 0.0212, 'lps'),
	(541723, 129, '2014-02-15 00:28:46.000000', 'consum', 0.0213, 'lps'),
	(541724, 129, '2014-02-15 00:28:47.000000', 'consum', 0.0223, 'lps'),
	(541725, 129, '2014-02-15 00:28:48.000000', 'consum', 0.0214, 'lps'),
	(541726, 129, '2014-02-15 00:28:49.000000', 'consum', 0.0217, 'lps'),
	(541727, 129, '2014-02-15 00:28:50.000000', 'consum', 0.0233, 'lps'),
	(541728, 129, '2014-02-15 00:28:51.000000', 'consum', 0.0230, 'lps'),
	(541729, 129, '2014-02-15 00:28:52.000000', 'consum', 0.0219, 'lps'),
	(541730, 129, '2014-02-15 00:28:53.000000', 'consum', 0.0217, 'lps'),
	(541731, 129, '2014-02-15 00:28:54.000000', 'consum', 0.0219, 'lps'),
	(541732, 129, '2014-02-15 00:28:55.000000', 'consum', 0.0234, 'lps'),
	(541733, 129, '2014-02-15 00:28:56.000000', 'consum', 0.0230, 'lps'),
	(541734, 129, '2014-02-15 00:28:57.000000', 'consum', 0.0212, 'lps'),
	(541735, 129, '2014-02-15 00:28:58.000000', 'consum', 0.0213, 'lps'),
	(541736, 129, '2014-02-15 00:28:59.000000', 'consum', 0.0216, 'lps'),
	(541737, 129, '2014-02-15 00:29:00.000000', 'consum', 0.0210, 'lps'),
	(541738, 129, '2014-02-15 00:29:01.000000', 'consum', 0.0214, 'lps'),
	(541739, 129, '2014-02-15 00:29:02.000000', 'consum', 0.0233, 'lps'),
	(541740, 129, '2014-02-15 00:29:03.000000', 'consum', 0.0212, 'lps'),
	(541741, 129, '2014-02-15 00:29:04.000000', 'consum', 0.0227, 'lps'),
	(541742, 129, '2014-02-15 00:29:05.000000', 'consum', 0.0214, 'lps'),
	(541743, 129, '2014-02-15 00:29:06.000000', 'consum', 0.0229, 'lps'),
	(541744, 129, '2014-02-15 00:29:07.000000', 'consum', 0.0218, 'lps'),
	(541745, 129, '2014-02-15 00:29:08.000000', 'consum', 0.0219, 'lps'),
	(541746, 129, '2014-02-15 00:29:09.000000', 'consum', 0.0230, 'lps'),
	(541747, 129, '2014-02-15 00:29:10.000000', 'consum', 0.0211, 'lps'),
	(541748, 129, '2014-02-15 00:29:11.000000', 'consum', 0.0227, 'lps'),
	(541749, 129, '2014-02-15 00:29:12.000000', 'consum', 0.0221, 'lps'),
	(541750, 129, '2014-02-15 00:29:13.000000', 'consum', 0.0214, 'lps'),
	(541751, 129, '2014-02-15 00:29:14.000000', 'consum', 0.0222, 'lps'),
	(541752, 129, '2014-02-15 00:29:15.000000', 'consum', 0.0210, 'lps'),
	(541753, 129, '2014-02-15 00:29:16.000000', 'consum', 0.0226, 'lps'),
	(541754, 129, '2014-02-15 00:29:17.000000', 'consum', 0.0212, 'lps'),
	(541755, 129, '2014-02-15 00:29:18.000000', 'consum', 0.0223, 'lps'),
	(541756, 129, '2014-02-15 00:29:19.000000', 'consum', 0.0222, 'lps'),
	(541757, 129, '2014-02-15 00:29:20.000000', 'consum', 0.0230, 'lps'),
	(541758, 129, '2014-02-15 00:29:21.000000', 'consum', 0.0223, 'lps'),
	(541759, 129, '2014-02-15 00:29:22.000000', 'consum', 0.0215, 'lps'),
	(541760, 129, '2014-02-15 00:29:23.000000', 'consum', 0.0224, 'lps'),
	(541761, 129, '2014-02-15 00:29:24.000000', 'consum', 0.0217, 'lps'),
	(541762, 129, '2014-02-15 00:29:25.000000', 'consum', 0.0225, 'lps'),
	(541763, 129, '2014-02-15 00:29:26.000000', 'consum', 0.0215, 'lps'),
	(541764, 129, '2014-02-15 00:29:27.000000', 'consum', 0.0216, 'lps'),
	(541765, 129, '2014-02-15 00:29:28.000000', 'consum', 0.0223, 'lps'),
	(541766, 129, '2014-02-15 00:29:29.000000', 'consum', 0.0211, 'lps'),
	(541767, 129, '2014-02-15 00:29:30.000000', 'consum', 0.0225, 'lps'),
	(541768, 129, '2014-02-15 00:29:31.000000', 'consum', 0.0232, 'lps'),
	(541769, 129, '2014-02-15 00:29:32.000000', 'consum', 0.0227, 'lps'),
	(541770, 129, '2014-02-15 00:29:33.000000', 'consum', 0.0230, 'lps'),
	(541771, 129, '2014-02-15 00:29:34.000000', 'consum', 0.0234, 'lps'),
	(541772, 129, '2014-02-15 00:29:35.000000', 'consum', 0.0220, 'lps'),
	(541773, 129, '2014-02-15 00:29:36.000000', 'consum', 0.0213, 'lps'),
	(541774, 129, '2014-02-15 00:29:37.000000', 'consum', 0.0222, 'lps'),
	(541775, 129, '2014-02-15 00:29:38.000000', 'consum', 0.0213, 'lps'),
	(541776, 129, '2014-02-15 00:29:39.000000', 'consum', 0.0212, 'lps'),
	(541777, 129, '2014-02-15 00:29:40.000000', 'consum', 0.0212, 'lps'),
	(541778, 129, '2014-02-15 00:29:41.000000', 'consum', 0.0214, 'lps'),
	(541779, 129, '2014-02-15 00:29:42.000000', 'consum', 0.0227, 'lps'),
	(541780, 129, '2014-02-15 00:29:43.000000', 'consum', 0.0230, 'lps'),
	(541781, 129, '2014-02-15 00:29:44.000000', 'consum', 0.0211, 'lps'),
	(541782, 129, '2014-02-15 00:29:45.000000', 'consum', 0.0231, 'lps'),
	(541783, 129, '2014-02-15 00:29:46.000000', 'consum', 0.0213, 'lps'),
	(541784, 129, '2014-02-15 00:29:47.000000', 'consum', 0.0212, 'lps'),
	(541785, 129, '2014-02-15 00:29:48.000000', 'consum', 0.0211, 'lps'),
	(541786, 129, '2014-02-15 00:29:49.000000', 'consum', 0.0233, 'lps'),
	(541787, 129, '2014-02-15 00:29:50.000000', 'consum', 0.0225, 'lps'),
	(541788, 129, '2014-02-15 00:29:51.000000', 'consum', 0.0215, 'lps'),
	(541789, 129, '2014-02-15 00:29:52.000000', 'consum', 0.0217, 'lps'),
	(541790, 129, '2014-02-15 00:29:53.000000', 'consum', 0.0230, 'lps'),
	(541791, 129, '2014-02-15 00:29:54.000000', 'consum', 0.0213, 'lps'),
	(541792, 129, '2014-02-15 00:29:55.000000', 'consum', 0.0217, 'lps'),
	(541793, 129, '2014-02-15 00:29:56.000000', 'consum', 0.0211, 'lps'),
	(541794, 129, '2014-02-15 00:29:57.000000', 'consum', 0.0221, 'lps'),
	(541795, 129, '2014-02-15 00:29:58.000000', 'consum', 0.0211, 'lps'),
	(541796, 129, '2014-02-15 00:29:59.000000', 'consum', 0.0232, 'lps'),
	(541797, 129, '2014-02-15 00:30:00.000000', 'consum', 0.0219, 'lps'),
	(541798, 129, '2014-02-15 00:30:01.000000', 'consum', 0.0213, 'lps'),
	(541799, 129, '2014-02-15 00:30:02.000000', 'consum', 0.0222, 'lps'),
	(541800, 129, '2014-02-15 00:30:03.000000', 'consum', 0.0215, 'lps'),
	(541801, 129, '2014-02-15 00:30:04.000000', 'consum', 0.0223, 'lps'),
	(541802, 129, '2014-02-15 00:30:05.000000', 'consum', 0.0211, 'lps'),
	(541803, 129, '2014-02-15 00:30:06.000000', 'consum', 0.0225, 'lps'),
	(541804, 129, '2014-02-15 00:30:07.000000', 'consum', 0.0234, 'lps'),
	(541805, 129, '2014-02-15 00:30:08.000000', 'consum', 0.0234, 'lps'),
	(541806, 129, '2014-02-15 00:30:09.000000', 'consum', 0.0234, 'lps'),
	(541807, 129, '2014-02-15 00:30:10.000000', 'consum', 0.0232, 'lps'),
	(541808, 129, '2014-02-15 00:30:11.000000', 'consum', 0.0224, 'lps'),
	(541809, 129, '2014-02-15 00:30:12.000000', 'consum', 0.0214, 'lps'),
	(541810, 129, '2014-02-15 00:30:13.000000', 'consum', 0.0212, 'lps'),
	(541811, 129, '2014-02-15 00:30:14.000000', 'consum', 0.0212, 'lps'),
	(541812, 129, '2014-02-15 00:30:15.000000', 'consum', 0.0213, 'lps'),
	(541813, 129, '2014-02-15 00:30:16.000000', 'consum', 0.0218, 'lps'),
	(541814, 129, '2014-02-15 00:30:17.000000', 'consum', 0.0219, 'lps'),
	(541815, 129, '2014-02-15 00:30:18.000000', 'consum', 0.0233, 'lps'),
	(541816, 129, '2014-02-15 00:30:19.000000', 'consum', 0.0220, 'lps'),
	(541817, 129, '2014-02-15 00:30:20.000000', 'consum', 0.0218, 'lps'),
	(541818, 129, '2014-02-15 00:30:21.000000', 'consum', 0.0222, 'lps'),
	(541819, 129, '2014-02-15 00:30:22.000000', 'consum', 0.0219, 'lps'),
	(541820, 129, '2014-02-15 00:30:23.000000', 'consum', 0.0219, 'lps'),
	(541821, 129, '2014-02-15 00:30:24.000000', 'consum', 0.0229, 'lps'),
	(541822, 129, '2014-02-15 00:30:25.000000', 'consum', 0.0229, 'lps'),
	(541823, 129, '2014-02-15 00:30:26.000000', 'consum', 0.0224, 'lps'),
	(541824, 129, '2014-02-15 00:30:27.000000', 'consum', 0.0223, 'lps'),
	(541825, 129, '2014-02-15 00:30:28.000000', 'consum', 0.0210, 'lps'),
	(541826, 129, '2014-02-15 00:30:29.000000', 'consum', 0.0221, 'lps'),
	(541827, 129, '2014-02-15 00:30:30.000000', 'consum', 0.0213, 'lps'),
	(541828, 129, '2014-02-15 00:30:31.000000', 'consum', 0.0220, 'lps'),
	(541829, 129, '2014-02-15 00:30:32.000000', 'consum', 0.0224, 'lps'),
	(541830, 129, '2014-02-15 00:30:33.000000', 'consum', 0.0227, 'lps'),
	(541831, 129, '2014-02-15 00:30:34.000000', 'consum', 0.0228, 'lps'),
	(541832, 129, '2014-02-15 00:30:35.000000', 'consum', 0.0226, 'lps'),
	(541833, 129, '2014-02-15 00:30:36.000000', 'consum', 0.0234, 'lps'),
	(541834, 129, '2014-02-15 00:30:37.000000', 'consum', 0.0210, 'lps'),
	(541835, 129, '2014-02-15 00:30:38.000000', 'consum', 0.0212, 'lps'),
	(541836, 129, '2014-02-15 00:30:39.000000', 'consum', 0.0222, 'lps'),
	(541837, 129, '2014-02-15 00:30:40.000000', 'consum', 0.0214, 'lps'),
	(541838, 129, '2014-02-15 00:30:41.000000', 'consum', 0.0220, 'lps'),
	(541839, 129, '2014-02-15 00:30:42.000000', 'consum', 0.0223, 'lps'),
	(541840, 129, '2014-02-15 00:30:43.000000', 'consum', 0.0219, 'lps'),
	(541841, 129, '2014-02-15 00:30:44.000000', 'consum', 0.0218, 'lps'),
	(541842, 129, '2014-02-15 00:30:45.000000', 'consum', 0.0224, 'lps'),
	(541843, 129, '2014-02-15 00:30:46.000000', 'consum', 0.0233, 'lps'),
	(541844, 129, '2014-02-15 00:30:47.000000', 'consum', 0.0232, 'lps'),
	(541845, 129, '2014-02-15 00:30:48.000000', 'consum', 0.0228, 'lps'),
	(541846, 129, '2014-02-15 00:30:49.000000', 'consum', 0.0232, 'lps'),
	(541847, 129, '2014-02-15 00:30:50.000000', 'consum', 0.0217, 'lps'),
	(541848, 129, '2014-02-15 00:30:51.000000', 'consum', 0.0229, 'lps'),
	(541849, 129, '2014-02-15 00:30:52.000000', 'consum', 0.0212, 'lps'),
	(541850, 129, '2014-02-15 00:30:53.000000', 'consum', 0.0212, 'lps'),
	(541851, 129, '2014-02-15 00:30:54.000000', 'consum', 0.0213, 'lps'),
	(541852, 129, '2014-02-15 00:30:55.000000', 'consum', 0.0222, 'lps'),
	(541853, 129, '2014-02-15 00:30:56.000000', 'consum', 0.0234, 'lps'),
	(541854, 129, '2014-02-15 00:30:57.000000', 'consum', 0.0222, 'lps'),
	(541855, 129, '2014-02-15 00:30:58.000000', 'consum', 0.0220, 'lps'),
	(541856, 129, '2014-02-15 00:30:59.000000', 'consum', 0.0228, 'lps'),
	(541857, 129, '2014-02-15 00:31:00.000000', 'consum', 0.0219, 'lps'),
	(541858, 129, '2014-02-15 00:31:01.000000', 'consum', 0.0227, 'lps'),
	(541859, 129, '2014-02-15 00:31:02.000000', 'consum', 0.0220, 'lps'),
	(541860, 129, '2014-02-15 00:31:03.000000', 'consum', 0.0232, 'lps'),
	(541861, 129, '2014-02-15 00:31:04.000000', 'consum', 0.0217, 'lps'),
	(541862, 129, '2014-02-15 00:31:05.000000', 'consum', 0.0231, 'lps'),
	(541863, 129, '2014-02-15 00:31:06.000000', 'consum', 0.0217, 'lps'),
	(541864, 129, '2014-02-15 00:31:07.000000', 'consum', 0.0210, 'lps'),
	(541865, 129, '2014-02-15 00:31:08.000000', 'consum', 0.0214, 'lps'),
	(541866, 129, '2014-02-15 00:31:09.000000', 'consum', 0.0231, 'lps'),
	(541867, 129, '2014-02-15 00:31:10.000000', 'consum', 0.0230, 'lps'),
	(541868, 129, '2014-02-15 00:31:11.000000', 'consum', 0.0221, 'lps'),
	(541869, 129, '2014-02-15 00:31:12.000000', 'consum', 0.0229, 'lps'),
	(541870, 129, '2014-02-15 00:31:13.000000', 'consum', 0.0224, 'lps'),
	(541871, 129, '2014-02-15 00:31:14.000000', 'consum', 0.0225, 'lps'),
	(541872, 129, '2014-02-15 00:31:15.000000', 'consum', 0.0217, 'lps'),
	(541873, 129, '2014-02-15 00:31:16.000000', 'consum', 0.0226, 'lps'),
	(541874, 129, '2014-02-15 00:31:17.000000', 'consum', 0.0218, 'lps'),
	(541875, 129, '2014-02-15 00:31:18.000000', 'consum', 0.0226, 'lps'),
	(541876, 129, '2014-02-15 00:31:19.000000', 'consum', 0.0220, 'lps'),
	(541877, 129, '2014-02-15 00:31:20.000000', 'consum', 0.0234, 'lps'),
	(541878, 129, '2014-02-15 00:31:21.000000', 'consum', 0.0229, 'lps'),
	(541879, 129, '2014-02-15 00:31:22.000000', 'consum', 0.0231, 'lps'),
	(541880, 129, '2014-02-15 00:31:23.000000', 'consum', 0.0234, 'lps'),
	(541881, 129, '2014-02-15 00:31:24.000000', 'consum', 0.0216, 'lps'),
	(541882, 129, '2014-02-15 00:31:25.000000', 'consum', 0.0218, 'lps'),
	(541883, 129, '2014-02-15 00:31:26.000000', 'consum', 0.0233, 'lps'),
	(541884, 129, '2014-02-15 00:31:27.000000', 'consum', 0.0228, 'lps'),
	(541885, 129, '2014-02-15 00:31:28.000000', 'consum', 0.0232, 'lps'),
	(541886, 129, '2014-02-15 00:31:29.000000', 'consum', 0.0215, 'lps'),
	(541887, 129, '2014-02-15 00:31:30.000000', 'consum', 0.0220, 'lps'),
	(541888, 129, '2014-02-15 00:31:31.000000', 'consum', 0.0221, 'lps'),
	(541889, 129, '2014-02-15 00:31:32.000000', 'consum', 0.0210, 'lps'),
	(541890, 129, '2014-02-15 00:31:33.000000', 'consum', 0.0228, 'lps'),
	(541891, 129, '2014-02-15 00:31:34.000000', 'consum', 0.0226, 'lps'),
	(541892, 129, '2014-02-15 00:31:35.000000', 'consum', 0.0211, 'lps'),
	(541893, 129, '2014-02-15 00:31:36.000000', 'consum', 0.0217, 'lps'),
	(541894, 129, '2014-02-15 00:31:37.000000', 'consum', 0.0219, 'lps'),
	(541895, 129, '2014-02-15 00:31:38.000000', 'consum', 0.0210, 'lps'),
	(541896, 129, '2014-02-15 00:31:39.000000', 'consum', 0.0231, 'lps'),
	(541897, 129, '2014-02-15 00:31:40.000000', 'consum', 0.0216, 'lps'),
	(541898, 129, '2014-02-15 00:31:41.000000', 'consum', 0.0228, 'lps'),
	(541899, 129, '2014-02-15 00:31:42.000000', 'consum', 0.0231, 'lps'),
	(541900, 129, '2014-02-15 00:31:43.000000', 'consum', 0.0211, 'lps'),
	(541901, 129, '2014-02-15 00:31:44.000000', 'consum', 0.0228, 'lps'),
	(541902, 129, '2014-02-15 00:31:45.000000', 'consum', 0.0225, 'lps'),
	(541903, 129, '2014-02-15 00:31:46.000000', 'consum', 0.0230, 'lps'),
	(541904, 129, '2014-02-15 00:31:47.000000', 'consum', 0.0215, 'lps'),
	(541905, 129, '2014-02-15 00:31:48.000000', 'consum', 0.0226, 'lps'),
	(541906, 129, '2014-02-15 00:31:49.000000', 'consum', 0.0225, 'lps'),
	(541907, 129, '2014-02-15 00:31:50.000000', 'consum', 0.0214, 'lps'),
	(541908, 129, '2014-02-15 00:31:51.000000', 'consum', 0.0210, 'lps'),
	(541909, 129, '2014-02-15 00:31:52.000000', 'consum', 0.0223, 'lps'),
	(541910, 129, '2014-02-15 00:31:53.000000', 'consum', 0.0225, 'lps'),
	(541911, 129, '2014-02-15 00:31:54.000000', 'consum', 0.0222, 'lps'),
	(541912, 129, '2014-02-15 00:31:55.000000', 'consum', 0.0224, 'lps'),
	(541913, 129, '2014-02-15 00:31:56.000000', 'consum', 0.0220, 'lps'),
	(541914, 129, '2014-02-15 00:31:57.000000', 'consum', 0.0220, 'lps'),
	(541915, 129, '2014-02-15 00:31:58.000000', 'consum', 0.0229, 'lps'),
	(541916, 129, '2014-02-15 00:31:59.000000', 'consum', 0.0226, 'lps'),
	(541917, 129, '2014-02-15 00:32:00.000000', 'consum', 0.0210, 'lps'),
	(541918, 129, '2014-02-15 00:32:01.000000', 'consum', 0.0212, 'lps'),
	(541919, 129, '2014-02-15 00:32:02.000000', 'consum', 0.0222, 'lps'),
	(541920, 129, '2014-02-15 00:32:03.000000', 'consum', 0.0214, 'lps'),
	(541921, 129, '2014-02-15 00:32:04.000000', 'consum', 0.0219, 'lps'),
	(541922, 129, '2014-02-15 00:32:05.000000', 'consum', 0.0218, 'lps'),
	(541923, 129, '2014-02-15 00:32:06.000000', 'consum', 0.0225, 'lps'),
	(541924, 129, '2014-02-15 00:32:07.000000', 'consum', 0.0213, 'lps'),
	(541925, 129, '2014-02-15 00:32:08.000000', 'consum', 0.0227, 'lps'),
	(541926, 129, '2014-02-15 00:32:09.000000', 'consum', 0.0212, 'lps'),
	(541927, 129, '2014-02-15 00:32:10.000000', 'consum', 0.0220, 'lps'),
	(541928, 129, '2014-02-15 00:32:11.000000', 'consum', 0.0228, 'lps'),
	(541929, 129, '2014-02-15 00:32:12.000000', 'consum', 0.0220, 'lps'),
	(541930, 129, '2014-02-15 00:32:13.000000', 'consum', 0.0233, 'lps'),
	(541931, 129, '2014-02-15 00:32:14.000000', 'consum', 0.0219, 'lps'),
	(541932, 129, '2014-02-15 00:32:15.000000', 'consum', 0.0211, 'lps'),
	(541933, 129, '2014-02-15 00:32:16.000000', 'consum', 0.0214, 'lps'),
	(541934, 129, '2014-02-15 00:32:17.000000', 'consum', 0.0226, 'lps'),
	(541935, 129, '2014-02-15 00:32:18.000000', 'consum', 0.0229, 'lps'),
	(541936, 129, '2014-02-15 00:32:19.000000', 'consum', 0.0231, 'lps'),
	(541937, 129, '2014-02-15 00:32:20.000000', 'consum', 0.0210, 'lps'),
	(541938, 129, '2014-02-15 00:32:21.000000', 'consum', 0.0220, 'lps'),
	(541939, 129, '2014-02-15 00:32:22.000000', 'consum', 0.0214, 'lps'),
	(541940, 129, '2014-02-15 00:32:23.000000', 'consum', 0.0222, 'lps'),
	(541941, 129, '2014-02-15 00:32:24.000000', 'consum', 0.0211, 'lps'),
	(541942, 129, '2014-02-15 00:32:25.000000', 'consum', 0.0230, 'lps'),
	(541943, 129, '2014-02-15 00:32:26.000000', 'consum', 0.0230, 'lps'),
	(541944, 129, '2014-02-15 00:32:27.000000', 'consum', 0.0226, 'lps'),
	(541945, 129, '2014-02-15 00:32:28.000000', 'consum', 0.0232, 'lps'),
	(541946, 129, '2014-02-15 00:32:29.000000', 'consum', 0.0224, 'lps'),
	(541947, 129, '2014-02-15 00:32:30.000000', 'consum', 0.0211, 'lps'),
	(541948, 129, '2014-02-15 00:32:31.000000', 'consum', 0.0226, 'lps'),
	(541949, 129, '2014-02-15 00:32:32.000000', 'consum', 0.0213, 'lps'),
	(541950, 129, '2014-02-15 00:32:33.000000', 'consum', 0.0225, 'lps'),
	(541951, 129, '2014-02-15 00:32:34.000000', 'consum', 0.0228, 'lps'),
	(541952, 129, '2014-02-15 00:32:35.000000', 'consum', 0.0231, 'lps'),
	(541953, 129, '2014-02-15 00:32:36.000000', 'consum', 0.0212, 'lps'),
	(541954, 129, '2014-02-15 00:32:37.000000', 'consum', 0.0232, 'lps'),
	(541955, 129, '2014-02-15 00:32:38.000000', 'consum', 0.0216, 'lps'),
	(541956, 129, '2014-02-15 00:32:39.000000', 'consum', 0.0224, 'lps'),
	(541957, 129, '2014-02-15 00:32:40.000000', 'consum', 0.0214, 'lps'),
	(541958, 129, '2014-02-15 00:32:41.000000', 'consum', 0.0211, 'lps'),
	(541959, 129, '2014-02-15 00:32:42.000000', 'consum', 0.0228, 'lps'),
	(541960, 129, '2014-02-15 00:32:43.000000', 'consum', 0.0222, 'lps'),
	(541961, 129, '2014-02-15 00:32:44.000000', 'consum', 0.0217, 'lps'),
	(541962, 129, '2014-02-15 00:32:45.000000', 'consum', 0.0211, 'lps'),
	(541963, 129, '2014-02-15 00:32:46.000000', 'consum', 0.0220, 'lps'),
	(541964, 129, '2014-02-15 00:32:47.000000', 'consum', 0.0232, 'lps'),
	(541965, 129, '2014-02-15 00:32:48.000000', 'consum', 0.0214, 'lps'),
	(541966, 129, '2014-02-15 00:32:49.000000', 'consum', 0.0216, 'lps'),
	(541967, 129, '2014-02-15 00:32:50.000000', 'consum', 0.0228, 'lps'),
	(541968, 129, '2014-02-15 00:32:51.000000', 'consum', 0.0233, 'lps'),
	(541969, 129, '2014-02-15 00:32:52.000000', 'consum', 0.0223, 'lps'),
	(541970, 129, '2014-02-15 00:32:53.000000', 'consum', 0.0229, 'lps'),
	(541971, 129, '2014-02-15 00:32:54.000000', 'consum', 0.0218, 'lps'),
	(541972, 129, '2014-02-15 00:32:55.000000', 'consum', 0.0217, 'lps'),
	(541973, 129, '2014-02-15 00:32:56.000000', 'consum', 0.0224, 'lps'),
	(541974, 129, '2014-02-15 00:32:57.000000', 'consum', 0.0232, 'lps'),
	(541975, 129, '2014-02-15 00:32:58.000000', 'consum', 0.0231, 'lps'),
	(541976, 129, '2014-02-15 00:32:59.000000', 'consum', 0.0224, 'lps'),
	(541977, 129, '2014-02-15 00:33:00.000000', 'consum', 0.0217, 'lps'),
	(541978, 129, '2014-02-15 00:33:01.000000', 'consum', 0.0227, 'lps'),
	(541979, 129, '2014-02-15 00:33:02.000000', 'consum', 0.0225, 'lps'),
	(541980, 129, '2014-02-15 00:33:03.000000', 'consum', 0.0233, 'lps'),
	(541981, 129, '2014-02-15 00:33:04.000000', 'consum', 0.0231, 'lps'),
	(541982, 129, '2014-02-15 00:33:05.000000', 'consum', 0.0223, 'lps'),
	(541983, 129, '2014-02-15 00:33:06.000000', 'consum', 0.0211, 'lps'),
	(541984, 129, '2014-02-15 00:33:07.000000', 'consum', 0.0229, 'lps'),
	(541985, 129, '2014-02-15 00:33:08.000000', 'consum', 0.0225, 'lps'),
	(541986, 129, '2014-02-15 00:33:09.000000', 'consum', 0.0228, 'lps'),
	(541987, 129, '2014-02-15 00:33:10.000000', 'consum', 0.0233, 'lps'),
	(541988, 129, '2014-02-15 00:33:11.000000', 'consum', 0.0220, 'lps'),
	(541989, 129, '2014-02-15 00:33:12.000000', 'consum', 0.0215, 'lps'),
	(541990, 129, '2014-02-15 00:33:13.000000', 'consum', 0.0233, 'lps'),
	(541991, 129, '2014-02-15 00:33:14.000000', 'consum', 0.0234, 'lps'),
	(541992, 129, '2014-02-15 00:33:15.000000', 'consum', 0.0213, 'lps'),
	(541993, 129, '2014-02-15 00:33:16.000000', 'consum', 0.0230, 'lps'),
	(541994, 129, '2014-02-15 00:33:17.000000', 'consum', 0.0224, 'lps'),
	(541995, 129, '2014-02-15 00:33:18.000000', 'consum', 0.0220, 'lps'),
	(541996, 129, '2014-02-15 00:33:19.000000', 'consum', 0.0218, 'lps'),
	(541997, 129, '2014-02-15 00:33:20.000000', 'consum', 0.0222, 'lps'),
	(541998, 129, '2014-02-15 00:33:21.000000', 'consum', 0.0219, 'lps'),
	(541999, 129, '2014-02-15 00:33:22.000000', 'consum', 0.0223, 'lps'),
	(542000, 129, '2014-02-15 00:33:23.000000', 'consum', 0.0221, 'lps'),
	(542001, 129, '2014-02-15 00:33:24.000000', 'consum', 0.0227, 'lps'),
	(542002, 129, '2014-02-15 00:33:25.000000', 'consum', 0.0214, 'lps'),
	(542003, 129, '2014-02-15 00:33:26.000000', 'consum', 0.0230, 'lps'),
	(542004, 129, '2014-02-15 00:33:27.000000', 'consum', 0.0224, 'lps'),
	(542005, 129, '2014-02-15 00:33:28.000000', 'consum', 0.0220, 'lps'),
	(542006, 129, '2014-02-15 00:33:29.000000', 'consum', 0.0218, 'lps'),
	(542007, 129, '2014-02-15 00:33:30.000000', 'consum', 0.0222, 'lps'),
	(542008, 129, '2014-02-15 00:33:31.000000', 'consum', 0.0219, 'lps'),
	(542009, 129, '2014-02-15 00:33:32.000000', 'consum', 0.0220, 'lps'),
	(542010, 129, '2014-02-15 00:33:33.000000', 'consum', 0.0234, 'lps'),
	(542011, 129, '2014-02-15 00:33:34.000000', 'consum', 0.0227, 'lps'),
	(542012, 129, '2014-02-15 00:33:35.000000', 'consum', 0.0221, 'lps'),
	(542013, 129, '2014-02-15 00:33:36.000000', 'consum', 0.0217, 'lps'),
	(542014, 129, '2014-02-15 00:33:37.000000', 'consum', 0.0210, 'lps'),
	(542015, 129, '2014-02-15 00:33:38.000000', 'consum', 0.0216, 'lps'),
	(542016, 129, '2014-02-15 00:33:39.000000', 'consum', 0.0217, 'lps'),
	(542017, 129, '2014-02-15 00:33:40.000000', 'consum', 0.0226, 'lps'),
	(542018, 129, '2014-02-15 00:33:41.000000', 'consum', 0.0221, 'lps'),
	(542019, 129, '2014-02-15 00:33:42.000000', 'consum', 0.0218, 'lps'),
	(542020, 129, '2014-02-15 00:33:43.000000', 'consum', 0.0215, 'lps'),
	(542021, 129, '2014-02-15 00:33:44.000000', 'consum', 0.0213, 'lps'),
	(542022, 129, '2014-02-15 00:33:45.000000', 'consum', 0.0233, 'lps'),
	(542023, 129, '2014-02-15 00:33:46.000000', 'consum', 0.0219, 'lps'),
	(542024, 129, '2014-02-15 00:33:47.000000', 'consum', 0.0212, 'lps'),
	(542025, 129, '2014-02-15 00:33:48.000000', 'consum', 0.0218, 'lps'),
	(542026, 129, '2014-02-15 00:33:49.000000', 'consum', 0.0219, 'lps'),
	(542027, 129, '2014-02-15 00:33:50.000000', 'consum', 0.0233, 'lps'),
	(542028, 129, '2014-02-15 00:33:51.000000', 'consum', 0.0223, 'lps'),
	(542029, 129, '2014-02-15 00:33:52.000000', 'consum', 0.0231, 'lps'),
	(542030, 129, '2014-02-15 00:33:53.000000', 'consum', 0.0225, 'lps'),
	(542031, 129, '2014-02-15 00:33:54.000000', 'consum', 0.0222, 'lps'),
	(542032, 129, '2014-02-15 00:33:55.000000', 'consum', 0.0226, 'lps'),
	(542033, 129, '2014-02-15 00:33:56.000000', 'consum', 0.0230, 'lps'),
	(542034, 129, '2014-02-15 00:33:57.000000', 'consum', 0.0212, 'lps'),
	(542035, 129, '2014-02-15 00:33:58.000000', 'consum', 0.0213, 'lps'),
	(542036, 129, '2014-02-15 00:33:59.000000', 'consum', 0.0216, 'lps'),
	(542037, 129, '2014-02-15 00:34:00.000000', 'consum', 0.0233, 'lps'),
	(542038, 129, '2014-02-15 00:34:01.000000', 'consum', 0.0231, 'lps'),
	(542039, 129, '2014-02-15 00:34:02.000000', 'consum', 0.0223, 'lps'),
	(542040, 129, '2014-02-15 00:34:03.000000', 'consum', 0.0211, 'lps'),
	(542041, 129, '2014-02-15 00:34:04.000000', 'consum', 0.0227, 'lps'),
	(542042, 129, '2014-02-15 00:34:05.000000', 'consum', 0.0218, 'lps'),
	(542043, 129, '2014-02-15 00:34:06.000000', 'consum', 0.0225, 'lps'),
	(542044, 129, '2014-02-15 00:34:07.000000', 'consum', 0.0213, 'lps'),
	(542045, 129, '2014-02-15 00:34:08.000000', 'consum', 0.0229, 'lps'),
	(542046, 129, '2014-02-15 00:34:09.000000', 'consum', 0.0220, 'lps'),
	(542047, 129, '2014-02-15 00:34:10.000000', 'consum', 0.0229, 'lps'),
	(542048, 129, '2014-02-15 00:34:11.000000', 'consum', 0.0225, 'lps'),
	(542049, 129, '2014-02-15 00:34:12.000000', 'consum', 0.0227, 'lps'),
	(542050, 129, '2014-02-15 00:34:13.000000', 'consum', 0.0228, 'lps'),
	(542051, 129, '2014-02-15 00:34:14.000000', 'consum', 0.0223, 'lps'),
	(542052, 129, '2014-02-15 00:34:15.000000', 'consum', 0.0221, 'lps'),
	(542053, 129, '2014-02-15 00:34:16.000000', 'consum', 0.0227, 'lps'),
	(542054, 129, '2014-02-15 00:34:17.000000', 'consum', 0.0215, 'lps'),
	(542055, 129, '2014-02-15 00:34:18.000000', 'consum', 0.0231, 'lps'),
	(542056, 129, '2014-02-15 00:34:19.000000', 'consum', 0.0227, 'lps'),
	(542057, 129, '2014-02-15 00:34:20.000000', 'consum', 0.0234, 'lps'),
	(542058, 129, '2014-02-15 00:34:21.000000', 'consum', 0.0227, 'lps'),
	(542059, 129, '2014-02-15 00:34:22.000000', 'consum', 0.0226, 'lps'),
	(542060, 129, '2014-02-15 00:34:23.000000', 'consum', 0.0212, 'lps'),
	(542061, 129, '2014-02-15 00:34:24.000000', 'consum', 0.0223, 'lps'),
	(542062, 129, '2014-02-15 00:34:25.000000', 'consum', 0.0219, 'lps'),
	(542063, 129, '2014-02-15 00:34:26.000000', 'consum', 0.0217, 'lps'),
	(542064, 129, '2014-02-15 00:34:27.000000', 'consum', 0.0219, 'lps'),
	(542065, 129, '2014-02-15 00:34:28.000000', 'consum', 0.0211, 'lps'),
	(542066, 129, '2014-02-15 00:34:29.000000', 'consum', 0.0211, 'lps'),
	(542067, 129, '2014-02-15 00:34:30.000000', 'consum', 0.0214, 'lps'),
	(542068, 129, '2014-02-15 00:34:31.000000', 'consum', 0.0226, 'lps'),
	(542069, 129, '2014-02-15 00:34:32.000000', 'consum', 0.0230, 'lps'),
	(542070, 129, '2014-02-15 00:34:33.000000', 'consum', 0.0212, 'lps'),
	(542071, 129, '2014-02-15 00:34:34.000000', 'consum', 0.0210, 'lps'),
	(542072, 129, '2014-02-15 00:34:35.000000', 'consum', 0.0231, 'lps'),
	(542073, 129, '2014-02-15 00:34:36.000000', 'consum', 0.0216, 'lps'),
	(542074, 129, '2014-02-15 00:34:37.000000', 'consum', 0.0228, 'lps'),
	(542075, 129, '2014-02-15 00:34:38.000000', 'consum', 0.0234, 'lps'),
	(542076, 129, '2014-02-15 00:34:39.000000', 'consum', 0.0223, 'lps'),
	(542077, 129, '2014-02-15 00:34:40.000000', 'consum', 0.0229, 'lps'),
	(542078, 129, '2014-02-15 00:34:41.000000', 'consum', 0.0216, 'lps'),
	(542079, 129, '2014-02-15 00:34:42.000000', 'consum', 0.0210, 'lps'),
	(542080, 129, '2014-02-15 00:34:43.000000', 'consum', 0.0218, 'lps'),
	(542081, 129, '2014-02-15 00:34:44.000000', 'consum', 0.0227, 'lps'),
	(542082, 129, '2014-02-15 00:34:45.000000', 'consum', 0.0219, 'lps'),
	(542083, 129, '2014-02-15 00:34:46.000000', 'consum', 0.0231, 'lps'),
	(542084, 129, '2014-02-15 00:34:47.000000', 'consum', 0.0212, 'lps'),
	(542085, 129, '2014-02-15 00:34:48.000000', 'consum', 0.0232, 'lps'),
	(542086, 129, '2014-02-15 00:34:49.000000', 'consum', 0.0214, 'lps'),
	(542087, 129, '2014-02-15 00:34:50.000000', 'consum', 0.0214, 'lps'),
	(542088, 129, '2014-02-15 00:34:51.000000', 'consum', 0.0219, 'lps'),
	(542089, 129, '2014-02-15 00:34:52.000000', 'consum', 0.0219, 'lps'),
	(542090, 129, '2014-02-15 00:34:53.000000', 'consum', 0.0227, 'lps'),
	(542091, 129, '2014-02-15 00:34:54.000000', 'consum', 0.0220, 'lps'),
	(542092, 129, '2014-02-15 00:34:55.000000', 'consum', 0.0211, 'lps'),
	(542093, 129, '2014-02-15 00:34:56.000000', 'consum', 0.0210, 'lps'),
	(542094, 129, '2014-02-15 00:34:57.000000', 'consum', 0.0231, 'lps'),
	(542095, 129, '2014-02-15 00:34:58.000000', 'consum', 0.0216, 'lps'),
	(542096, 129, '2014-02-15 00:34:59.000000', 'consum', 0.0227, 'lps'),
	(542097, 129, '2014-02-15 00:35:00.000000', 'consum', 0.0229, 'lps'),
	(542098, 129, '2014-02-15 00:35:01.000000', 'consum', 0.0227, 'lps'),
	(542099, 129, '2014-02-15 00:35:02.000000', 'consum', 0.0217, 'lps'),
	(542100, 129, '2014-02-15 00:35:03.000000', 'consum', 0.0216, 'lps'),
	(542101, 129, '2014-02-15 00:35:04.000000', 'consum', 0.0222, 'lps'),
	(542102, 129, '2014-02-15 00:35:05.000000', 'consum', 0.0226, 'lps'),
	(542103, 129, '2014-02-15 00:35:06.000000', 'consum', 0.0232, 'lps'),
	(542104, 129, '2014-02-15 00:35:07.000000', 'consum', 0.0221, 'lps'),
	(542105, 129, '2014-02-15 00:35:08.000000', 'consum', 0.0226, 'lps'),
	(542106, 129, '2014-02-15 00:35:09.000000', 'consum', 0.0231, 'lps'),
	(542107, 129, '2014-02-15 00:35:10.000000', 'consum', 0.0219, 'lps'),
	(542108, 129, '2014-02-15 00:35:11.000000', 'consum', 0.0215, 'lps'),
	(542109, 129, '2014-02-15 00:35:12.000000', 'consum', 0.0211, 'lps'),
	(542110, 129, '2014-02-15 00:35:13.000000', 'consum', 0.0222, 'lps'),
	(542111, 129, '2014-02-15 00:35:14.000000', 'consum', 0.0221, 'lps'),
	(542112, 129, '2014-02-15 00:35:15.000000', 'consum', 0.0230, 'lps'),
	(542113, 129, '2014-02-15 00:35:16.000000', 'consum', 0.0225, 'lps'),
	(542114, 129, '2014-02-15 00:35:17.000000', 'consum', 0.0224, 'lps'),
	(542115, 129, '2014-02-15 00:35:18.000000', 'consum', 0.0214, 'lps'),
	(542116, 129, '2014-02-15 00:35:19.000000', 'consum', 0.0211, 'lps'),
	(542117, 129, '2014-02-15 00:35:20.000000', 'consum', 0.0230, 'lps'),
	(542118, 129, '2014-02-15 00:35:21.000000', 'consum', 0.0231, 'lps'),
	(542119, 129, '2014-02-15 00:35:22.000000', 'consum', 0.0233, 'lps'),
	(542120, 129, '2014-02-15 00:35:23.000000', 'consum', 0.0210, 'lps'),
	(542121, 129, '2014-02-15 00:35:24.000000', 'consum', 0.0216, 'lps'),
	(542122, 129, '2014-02-15 00:35:25.000000', 'consum', 0.0215, 'lps'),
	(542123, 129, '2014-02-15 00:35:26.000000', 'consum', 0.0219, 'lps'),
	(542124, 129, '2014-02-15 00:35:27.000000', 'consum', 0.0217, 'lps'),
	(542125, 129, '2014-02-15 00:35:28.000000', 'consum', 0.0218, 'lps'),
	(542126, 129, '2014-02-15 00:35:29.000000', 'consum', 0.0229, 'lps'),
	(542127, 129, '2014-02-15 00:35:30.000000', 'consum', 0.0231, 'lps'),
	(542128, 129, '2014-02-15 00:35:31.000000', 'consum', 0.0234, 'lps'),
	(542129, 129, '2014-02-15 00:35:32.000000', 'consum', 0.0218, 'lps'),
	(542130, 129, '2014-02-15 00:35:33.000000', 'consum', 0.0229, 'lps'),
	(542131, 129, '2014-02-15 00:35:34.000000', 'consum', 0.0229, 'lps'),
	(542132, 129, '2014-02-15 00:35:35.000000', 'consum', 0.0227, 'lps'),
	(542133, 129, '2014-02-15 00:35:36.000000', 'consum', 0.0211, 'lps'),
	(542134, 129, '2014-02-15 00:35:37.000000', 'consum', 0.0214, 'lps'),
	(542135, 129, '2014-02-15 00:35:38.000000', 'consum', 0.0228, 'lps'),
	(542136, 129, '2014-02-15 00:35:39.000000', 'consum', 0.0215, 'lps'),
	(542137, 129, '2014-02-15 00:35:40.000000', 'consum', 0.0232, 'lps'),
	(542138, 129, '2014-02-15 00:35:41.000000', 'consum', 0.0229, 'lps'),
	(542139, 129, '2014-02-15 00:35:42.000000', 'consum', 0.0216, 'lps'),
	(542140, 129, '2014-02-15 00:35:43.000000', 'consum', 0.0234, 'lps'),
	(542141, 129, '2014-02-15 00:35:44.000000', 'consum', 0.0211, 'lps'),
	(542142, 129, '2014-02-15 00:35:45.000000', 'consum', 0.0218, 'lps'),
	(542143, 129, '2014-02-15 00:35:46.000000', 'consum', 0.0225, 'lps'),
	(542144, 129, '2014-02-15 00:35:47.000000', 'consum', 0.0234, 'lps'),
	(542145, 129, '2014-02-15 00:35:48.000000', 'consum', 0.0210, 'lps'),
	(542146, 129, '2014-02-15 00:35:49.000000', 'consum', 0.0215, 'lps'),
	(542147, 129, '2014-02-15 00:35:50.000000', 'consum', 0.0233, 'lps'),
	(542148, 129, '2014-02-15 00:35:51.000000', 'consum', 0.0214, 'lps'),
	(542149, 129, '2014-02-15 00:35:52.000000', 'consum', 0.0234, 'lps'),
	(542150, 129, '2014-02-15 00:35:53.000000', 'consum', 0.0218, 'lps'),
	(542151, 129, '2014-02-15 00:35:54.000000', 'consum', 0.0229, 'lps'),
	(542152, 129, '2014-02-15 00:35:55.000000', 'consum', 0.0232, 'lps'),
	(542153, 129, '2014-02-15 00:35:56.000000', 'consum', 0.0214, 'lps'),
	(542154, 129, '2014-02-15 00:35:57.000000', 'consum', 0.0213, 'lps'),
	(542155, 129, '2014-02-15 00:35:58.000000', 'consum', 0.0215, 'lps'),
	(542156, 129, '2014-02-15 00:35:59.000000', 'consum', 0.0228, 'lps'),
	(542157, 129, '2014-02-15 00:36:00.000000', 'consum', 0.0233, 'lps'),
	(542158, 129, '2014-02-15 00:36:01.000000', 'consum', 0.0222, 'lps'),
	(542159, 129, '2014-02-15 00:36:02.000000', 'consum', 0.0225, 'lps'),
	(542160, 129, '2014-02-15 00:36:03.000000', 'consum', 0.0227, 'lps'),
	(542161, 129, '2014-02-15 00:36:04.000000', 'consum', 0.0224, 'lps'),
	(542162, 129, '2014-02-15 00:36:05.000000', 'consum', 0.0230, 'lps'),
	(542163, 129, '2014-02-15 00:36:06.000000', 'consum', 0.0218, 'lps'),
	(542164, 129, '2014-02-15 00:36:07.000000', 'consum', 0.0216, 'lps'),
	(542165, 129, '2014-02-15 00:36:08.000000', 'consum', 0.0216, 'lps'),
	(542166, 129, '2014-02-15 00:36:09.000000', 'consum', 0.0223, 'lps'),
	(542167, 129, '2014-02-15 00:36:10.000000', 'consum', 0.0233, 'lps'),
	(542168, 129, '2014-02-15 00:36:11.000000', 'consum', 0.0212, 'lps'),
	(542169, 129, '2014-02-15 00:36:12.000000', 'consum', 0.0226, 'lps'),
	(542170, 129, '2014-02-15 00:36:13.000000', 'consum', 0.0234, 'lps'),
	(542171, 129, '2014-02-15 00:36:14.000000', 'consum', 0.0232, 'lps'),
	(542172, 129, '2014-02-15 00:36:15.000000', 'consum', 0.0225, 'lps'),
	(542173, 129, '2014-02-15 00:36:16.000000', 'consum', 0.0220, 'lps'),
	(542174, 129, '2014-02-15 00:36:17.000000', 'consum', 0.0214, 'lps'),
	(542175, 129, '2014-02-15 00:36:18.000000', 'consum', 0.0226, 'lps'),
	(542176, 129, '2014-02-15 00:36:19.000000', 'consum', 0.0230, 'lps'),
	(542177, 129, '2014-02-15 00:36:20.000000', 'consum', 0.0210, 'lps'),
	(542178, 129, '2014-02-15 00:36:21.000000', 'consum', 0.0226, 'lps'),
	(542179, 129, '2014-02-15 00:36:22.000000', 'consum', 0.0215, 'lps'),
	(542180, 129, '2014-02-15 00:36:23.000000', 'consum', 0.0213, 'lps'),
	(542181, 129, '2014-02-15 00:36:24.000000', 'consum', 0.0211, 'lps'),
	(542182, 129, '2014-02-15 00:36:25.000000', 'consum', 0.0230, 'lps'),
	(542183, 129, '2014-02-15 00:36:26.000000', 'consum', 0.0234, 'lps'),
	(542184, 129, '2014-02-15 00:36:27.000000', 'consum', 0.0220, 'lps'),
	(542185, 129, '2014-02-15 00:36:28.000000', 'consum', 0.0214, 'lps'),
	(542186, 129, '2014-02-15 00:36:29.000000', 'consum', 0.0226, 'lps'),
	(542187, 129, '2014-02-15 00:36:30.000000', 'consum', 0.0226, 'lps'),
	(542188, 129, '2014-02-15 00:36:31.000000', 'consum', 0.0218, 'lps'),
	(542189, 129, '2014-02-15 00:36:32.000000', 'consum', 0.0228, 'lps'),
	(542190, 129, '2014-02-15 00:36:33.000000', 'consum', 0.0228, 'lps'),
	(542191, 129, '2014-02-15 00:36:34.000000', 'consum', 0.0223, 'lps'),
	(542192, 129, '2014-02-15 00:36:35.000000', 'consum', 0.0218, 'lps'),
	(542193, 129, '2014-02-15 00:36:36.000000', 'consum', 0.0213, 'lps'),
	(542194, 129, '2014-02-15 00:36:37.000000', 'consum', 0.0226, 'lps'),
	(542195, 129, '2014-02-15 00:36:38.000000', 'consum', 0.0230, 'lps'),
	(542196, 129, '2014-02-15 00:36:39.000000', 'consum', 0.0216, 'lps'),
	(542197, 129, '2014-02-15 00:36:40.000000', 'consum', 0.0228, 'lps'),
	(542198, 129, '2014-02-15 00:36:41.000000', 'consum', 0.0232, 'lps'),
	(542199, 129, '2014-02-15 00:36:42.000000', 'consum', 0.0215, 'lps'),
	(542200, 129, '2014-02-15 00:36:43.000000', 'consum', 0.0222, 'lps'),
	(542201, 129, '2014-02-15 00:36:44.000000', 'consum', 0.0229, 'lps'),
	(542202, 129, '2014-02-15 00:36:45.000000', 'consum', 0.0221, 'lps'),
	(542203, 129, '2014-02-15 00:36:46.000000', 'consum', 0.0232, 'lps'),
	(542204, 129, '2014-02-15 00:36:47.000000', 'consum', 0.0213, 'lps'),
	(542205, 129, '2014-02-15 00:36:48.000000', 'consum', 0.0234, 'lps'),
	(542206, 129, '2014-02-15 00:36:49.000000', 'consum', 0.0221, 'lps'),
	(542207, 129, '2014-02-15 00:36:50.000000', 'consum', 0.0217, 'lps'),
	(542208, 129, '2014-02-15 00:36:51.000000', 'consum', 0.0215, 'lps'),
	(542209, 129, '2014-02-15 00:36:52.000000', 'consum', 0.0212, 'lps'),
	(542210, 129, '2014-02-15 00:36:53.000000', 'consum', 0.0233, 'lps'),
	(542211, 129, '2014-02-15 00:36:54.000000', 'consum', 0.0218, 'lps'),
	(542212, 129, '2014-02-15 00:36:55.000000', 'consum', 0.0232, 'lps'),
	(542213, 129, '2014-02-15 00:36:56.000000', 'consum', 0.0221, 'lps'),
	(542214, 129, '2014-02-15 00:36:57.000000', 'consum', 0.0227, 'lps'),
	(542215, 129, '2014-02-15 00:36:58.000000', 'consum', 0.0210, 'lps'),
	(542216, 129, '2014-02-15 00:36:59.000000', 'consum', 0.0234, 'lps'),
	(542217, 129, '2014-02-15 00:37:00.000000', 'consum', 0.0233, 'lps'),
	(542218, 129, '2014-02-15 00:37:01.000000', 'consum', 0.0229, 'lps'),
	(542219, 129, '2014-02-15 00:37:02.000000', 'consum', 0.0212, 'lps'),
	(542220, 129, '2014-02-15 00:37:03.000000', 'consum', 0.0210, 'lps'),
	(542221, 129, '2014-02-15 00:37:04.000000', 'consum', 0.0232, 'lps'),
	(542222, 129, '2014-02-15 00:37:05.000000', 'consum', 0.0220, 'lps'),
	(542223, 129, '2014-02-15 00:37:06.000000', 'consum', 0.0221, 'lps'),
	(542224, 129, '2014-02-15 00:37:07.000000', 'consum', 0.0210, 'lps'),
	(542225, 129, '2014-02-15 00:37:08.000000', 'consum', 0.0228, 'lps'),
	(542226, 129, '2014-02-15 00:37:09.000000', 'consum', 0.0225, 'lps'),
	(542227, 129, '2014-02-15 00:37:10.000000', 'consum', 0.0233, 'lps'),
	(542228, 129, '2014-02-15 00:37:11.000000', 'consum', 0.0230, 'lps'),
	(542229, 129, '2014-02-15 00:37:12.000000', 'consum', 0.0218, 'lps'),
	(542230, 129, '2014-02-15 00:37:13.000000', 'consum', 0.0215, 'lps'),
	(542231, 129, '2014-02-15 00:37:14.000000', 'consum', 0.0234, 'lps'),
	(542232, 129, '2014-02-15 00:37:15.000000', 'consum', 0.0219, 'lps'),
	(542233, 129, '2014-02-15 00:37:16.000000', 'consum', 0.0231, 'lps'),
	(542234, 129, '2014-02-15 00:37:17.000000', 'consum', 0.0216, 'lps'),
	(542235, 129, '2014-02-15 00:37:18.000000', 'consum', 0.0225, 'lps'),
	(542236, 129, '2014-02-15 00:37:19.000000', 'consum', 0.0220, 'lps'),
	(542237, 129, '2014-02-15 00:37:20.000000', 'consum', 0.0213, 'lps'),
	(542238, 129, '2014-02-15 00:37:21.000000', 'consum', 0.0220, 'lps'),
	(542239, 129, '2014-02-15 00:37:22.000000', 'consum', 0.0228, 'lps'),
	(542240, 129, '2014-02-15 00:37:23.000000', 'consum', 0.0219, 'lps'),
	(542241, 129, '2014-02-15 00:37:24.000000', 'consum', 0.0225, 'lps'),
	(542242, 129, '2014-02-15 00:37:25.000000', 'consum', 0.0212, 'lps'),
	(542243, 129, '2014-02-15 00:37:26.000000', 'consum', 0.0223, 'lps'),
	(542244, 129, '2014-02-15 00:37:27.000000', 'consum', 0.0219, 'lps'),
	(542245, 129, '2014-02-15 00:37:28.000000', 'consum', 0.0217, 'lps'),
	(542246, 129, '2014-02-15 00:37:29.000000', 'consum', 0.0219, 'lps'),
	(542247, 129, '2014-02-15 00:37:30.000000', 'consum', 0.0211, 'lps'),
	(542248, 129, '2014-02-15 00:37:31.000000', 'consum', 0.0212, 'lps'),
	(542249, 129, '2014-02-15 00:37:32.000000', 'consum', 0.0218, 'lps'),
	(542250, 129, '2014-02-15 00:37:33.000000', 'consum', 0.0219, 'lps'),
	(542251, 129, '2014-02-15 00:37:34.000000', 'consum', 0.0231, 'lps'),
	(542252, 129, '2014-02-15 00:37:35.000000', 'consum', 0.0214, 'lps'),
	(542253, 129, '2014-02-15 00:37:36.000000', 'consum', 0.0218, 'lps'),
	(542254, 129, '2014-02-15 00:37:37.000000', 'consum', 0.0211, 'lps'),
	(542255, 129, '2014-02-15 00:37:38.000000', 'consum', 0.0218, 'lps'),
	(542256, 129, '2014-02-15 00:37:39.000000', 'consum', 0.0224, 'lps'),
	(542257, 129, '2014-02-15 00:37:40.000000', 'consum', 0.0231, 'lps'),
	(542258, 129, '2014-02-15 00:37:41.000000', 'consum', 0.0223, 'lps'),
	(542259, 129, '2014-02-15 00:37:42.000000', 'consum', 0.0211, 'lps'),
	(542260, 129, '2014-02-15 00:37:43.000000', 'consum', 0.0228, 'lps'),
	(542261, 129, '2014-02-15 00:37:44.000000', 'consum', 0.0223, 'lps'),
	(542262, 129, '2014-02-15 00:37:45.000000', 'consum', 0.0221, 'lps'),
	(542263, 129, '2014-02-15 00:37:46.000000', 'consum', 0.0228, 'lps'),
	(542264, 129, '2014-02-15 00:37:47.000000', 'consum', 0.0217, 'lps'),
	(542265, 129, '2014-02-15 00:37:48.000000', 'consum', 0.0218, 'lps'),
	(542266, 129, '2014-02-15 00:37:49.000000', 'consum', 0.0228, 'lps'),
	(542267, 129, '2014-02-15 00:37:50.000000', 'consum', 0.0228, 'lps'),
	(542268, 129, '2014-02-15 00:37:51.000000', 'consum', 0.0222, 'lps'),
	(542269, 129, '2014-02-15 00:37:52.000000', 'consum', 0.0216, 'lps'),
	(542270, 129, '2014-02-15 00:37:53.000000', 'consum', 0.0231, 'lps'),
	(542271, 129, '2014-02-15 00:37:54.000000', 'consum', 0.0221, 'lps'),
	(542272, 129, '2014-02-15 00:37:55.000000', 'consum', 0.0229, 'lps'),
	(542273, 129, '2014-02-15 00:37:56.000000', 'consum', 0.0223, 'lps'),
	(542274, 129, '2014-02-15 00:37:57.000000', 'consum', 0.0219, 'lps'),
	(542275, 129, '2014-02-15 00:37:58.000000', 'consum', 0.0217, 'lps'),
	(542276, 129, '2014-02-15 00:37:59.000000', 'consum', 0.0218, 'lps'),
	(542277, 129, '2014-02-15 00:38:00.000000', 'consum', 0.0230, 'lps'),
	(542278, 129, '2014-02-15 00:38:01.000000', 'consum', 0.0234, 'lps'),
	(542279, 129, '2014-02-15 00:38:02.000000', 'consum', 0.0223, 'lps'),
	(542280, 129, '2014-02-15 00:38:03.000000', 'consum', 0.0226, 'lps'),
	(542281, 129, '2014-02-15 00:38:04.000000', 'consum', 0.0229, 'lps'),
	(542282, 129, '2014-02-15 00:38:05.000000', 'consum', 0.0231, 'lps'),
	(542283, 129, '2014-02-15 00:38:06.000000', 'consum', 0.0210, 'lps'),
	(542284, 129, '2014-02-15 00:38:07.000000', 'consum', 0.0220, 'lps'),
	(542285, 129, '2014-02-15 00:38:08.000000', 'consum', 0.0212, 'lps'),
	(542286, 129, '2014-02-15 00:38:09.000000', 'consum', 0.0214, 'lps'),
	(542287, 129, '2014-02-15 00:38:10.000000', 'consum', 0.0225, 'lps'),
	(542288, 129, '2014-02-15 00:38:11.000000', 'consum', 0.0224, 'lps'),
	(542289, 129, '2014-02-15 00:38:12.000000', 'consum', 0.0211, 'lps'),
	(542290, 129, '2014-02-15 00:38:13.000000', 'consum', 0.0221, 'lps'),
	(542291, 129, '2014-02-15 00:38:14.000000', 'consum', 0.0214, 'lps'),
	(542292, 129, '2014-02-15 00:38:15.000000', 'consum', 0.0222, 'lps'),
	(542293, 129, '2014-02-15 00:38:16.000000', 'consum', 0.0234, 'lps'),
	(542294, 129, '2014-02-15 00:38:17.000000', 'consum', 0.0218, 'lps'),
	(542295, 129, '2014-02-15 00:38:18.000000', 'consum', 0.0230, 'lps'),
	(542296, 129, '2014-02-15 00:38:19.000000', 'consum', 0.0210, 'lps'),
	(542297, 129, '2014-02-15 00:38:20.000000', 'consum', 0.0227, 'lps'),
	(542298, 129, '2014-02-15 00:38:21.000000', 'consum', 0.0219, 'lps'),
	(542299, 129, '2014-02-15 00:38:22.000000', 'consum', 0.0231, 'lps'),
	(542300, 129, '2014-02-15 00:38:23.000000', 'consum', 0.0211, 'lps'),
	(542301, 129, '2014-02-15 00:38:24.000000', 'consum', 0.0230, 'lps'),
	(542302, 129, '2014-02-15 00:38:25.000000', 'consum', 0.0233, 'lps'),
	(542303, 129, '2014-02-15 00:38:26.000000', 'consum', 0.0215, 'lps'),
	(542304, 129, '2014-02-15 00:38:27.000000', 'consum', 0.0215, 'lps'),
	(542305, 129, '2014-02-15 00:38:28.000000', 'consum', 0.0220, 'lps'),
	(542306, 129, '2014-02-15 00:38:29.000000', 'consum', 0.0221, 'lps'),
	(542307, 129, '2014-02-15 00:38:30.000000', 'consum', 0.0212, 'lps'),
	(542308, 129, '2014-02-15 00:38:31.000000', 'consum', 0.0211, 'lps'),
	(542309, 129, '2014-02-15 00:38:32.000000', 'consum', 0.0212, 'lps'),
	(542310, 129, '2014-02-15 00:38:33.000000', 'consum', 0.0215, 'lps'),
	(542311, 129, '2014-02-15 00:38:34.000000', 'consum', 0.0230, 'lps'),
	(542312, 129, '2014-02-15 00:38:35.000000', 'consum', 0.0222, 'lps'),
	(542313, 129, '2014-02-15 00:38:36.000000', 'consum', 0.0211, 'lps'),
	(542314, 129, '2014-02-15 00:38:37.000000', 'consum', 0.0230, 'lps'),
	(542315, 129, '2014-02-15 00:38:38.000000', 'consum', 0.0230, 'lps'),
	(542316, 129, '2014-02-15 00:38:39.000000', 'consum', 0.0225, 'lps'),
	(542317, 129, '2014-02-15 00:38:40.000000', 'consum', 0.0229, 'lps'),
	(542318, 129, '2014-02-15 00:38:41.000000', 'consum', 0.0232, 'lps'),
	(542319, 129, '2014-02-15 00:38:42.000000', 'consum', 0.0214, 'lps'),
	(542320, 129, '2014-02-15 00:38:43.000000', 'consum', 0.0213, 'lps'),
	(542321, 129, '2014-02-15 00:38:44.000000', 'consum', 0.0215, 'lps'),
	(542322, 129, '2014-02-15 00:38:45.000000', 'consum', 0.0227, 'lps'),
	(542323, 129, '2014-02-15 00:38:46.000000', 'consum', 0.0229, 'lps'),
	(542324, 129, '2014-02-15 00:38:47.000000', 'consum', 0.0231, 'lps'),
	(542325, 129, '2014-02-15 00:38:48.000000', 'consum', 0.0234, 'lps'),
	(542326, 129, '2014-02-15 00:38:49.000000', 'consum', 0.0219, 'lps'),
	(542327, 129, '2014-02-15 00:38:50.000000', 'consum', 0.0231, 'lps'),
	(542328, 129, '2014-02-15 00:38:51.000000', 'consum', 0.0213, 'lps'),
	(542329, 129, '2014-02-15 00:38:52.000000', 'consum', 0.0215, 'lps'),
	(542330, 129, '2014-02-15 00:38:53.000000', 'consum', 0.0225, 'lps'),
	(542331, 129, '2014-02-15 00:38:54.000000', 'consum', 0.0222, 'lps'),
	(542332, 129, '2014-02-15 00:38:55.000000', 'consum', 0.0226, 'lps'),
	(542333, 129, '2014-02-15 00:38:56.000000', 'consum', 0.0230, 'lps'),
	(542334, 129, '2014-02-15 00:38:57.000000', 'consum', 0.0211, 'lps'),
	(542335, 129, '2014-02-15 00:38:58.000000', 'consum', 0.0231, 'lps'),
	(542336, 129, '2014-02-15 00:38:59.000000', 'consum', 0.0211, 'lps'),
	(542337, 129, '2014-02-15 00:39:00.000000', 'consum', 0.0228, 'lps'),
	(542338, 129, '2014-02-15 00:39:01.000000', 'consum', 0.0221, 'lps'),
	(542339, 129, '2014-02-15 00:39:02.000000', 'consum', 0.0214, 'lps'),
	(542340, 129, '2014-02-15 00:39:03.000000', 'consum', 0.0221, 'lps'),
	(542341, 129, '2014-02-15 00:39:04.000000', 'consum', 0.0229, 'lps'),
	(542342, 129, '2014-02-15 00:39:05.000000', 'consum', 0.0222, 'lps'),
	(542343, 129, '2014-02-15 00:39:06.000000', 'consum', 0.0215, 'lps'),
	(542344, 129, '2014-02-15 00:39:07.000000', 'consum', 0.0226, 'lps'),
	(542345, 129, '2014-02-15 00:39:08.000000', 'consum', 0.0223, 'lps'),
	(542346, 129, '2014-02-15 00:39:09.000000', 'consum', 0.0227, 'lps'),
	(542347, 129, '2014-02-15 00:39:10.000000', 'consum', 0.0234, 'lps'),
	(542348, 129, '2014-02-15 00:39:11.000000', 'consum', 0.0228, 'lps'),
	(542349, 129, '2014-02-15 00:39:12.000000', 'consum', 0.0227, 'lps'),
	(542350, 129, '2014-02-15 00:39:13.000000', 'consum', 0.0216, 'lps'),
	(542351, 129, '2014-02-15 00:39:14.000000', 'consum', 0.0216, 'lps'),
	(542352, 129, '2014-02-15 00:39:15.000000', 'consum', 0.0221, 'lps'),
	(542353, 129, '2014-02-15 00:39:16.000000', 'consum', 0.0223, 'lps'),
	(542354, 129, '2014-02-15 00:39:17.000000', 'consum', 0.0219, 'lps'),
	(542355, 129, '2014-02-15 00:39:18.000000', 'consum', 0.0216, 'lps'),
	(542356, 129, '2014-02-15 00:39:19.000000', 'consum', 0.0213, 'lps'),
	(542357, 129, '2014-02-15 00:39:20.000000', 'consum', 0.0233, 'lps'),
	(542358, 129, '2014-02-15 00:39:21.000000', 'consum', 0.0215, 'lps'),
	(542359, 129, '2014-02-15 00:39:22.000000', 'consum', 0.0218, 'lps'),
	(542360, 129, '2014-02-15 00:39:23.000000', 'consum', 0.0212, 'lps'),
	(542361, 129, '2014-02-15 00:39:24.000000', 'consum', 0.0220, 'lps'),
	(542362, 129, '2014-02-15 00:39:25.000000', 'consum', 0.0228, 'lps'),
	(542363, 129, '2014-02-15 00:39:26.000000', 'consum', 0.0221, 'lps'),
	(542364, 129, '2014-02-15 00:39:27.000000', 'consum', 0.0212, 'lps'),
	(542365, 129, '2014-02-15 00:39:28.000000', 'consum', 0.0213, 'lps'),
	(542366, 129, '2014-02-15 00:39:29.000000', 'consum', 0.0217, 'lps'),
	(542367, 129, '2014-02-15 00:39:30.000000', 'consum', 0.0214, 'lps'),
	(542368, 129, '2014-02-15 00:39:31.000000', 'consum', 0.0211, 'lps'),
	(542369, 129, '2014-02-15 00:39:32.000000', 'consum', 0.0225, 'lps'),
	(542370, 129, '2014-02-15 00:39:33.000000', 'consum', 0.0233, 'lps'),
	(542371, 129, '2014-02-15 00:39:34.000000', 'consum', 0.0232, 'lps'),
	(542372, 129, '2014-02-15 00:39:35.000000', 'consum', 0.0226, 'lps'),
	(542373, 129, '2014-02-15 00:39:36.000000', 'consum', 0.0226, 'lps'),
	(542374, 129, '2014-02-15 00:39:37.000000', 'consum', 0.0217, 'lps'),
	(542375, 129, '2014-02-15 00:39:38.000000', 'consum', 0.0221, 'lps'),
	(542376, 129, '2014-02-15 00:39:39.000000', 'consum', 0.0219, 'lps'),
	(542377, 129, '2014-02-15 00:39:40.000000', 'consum', 0.0225, 'lps'),
	(542378, 129, '2014-02-15 00:39:41.000000', 'consum', 0.0232, 'lps'),
	(542379, 129, '2014-02-15 00:39:42.000000', 'consum', 0.0225, 'lps'),
	(542380, 129, '2014-02-15 00:39:43.000000', 'consum', 0.0218, 'lps'),
	(542381, 129, '2014-02-15 00:39:44.000000', 'consum', 0.0232, 'lps'),
	(542382, 129, '2014-02-15 00:39:45.000000', 'consum', 0.0223, 'lps'),
	(542383, 129, '2014-02-15 00:39:46.000000', 'consum', 0.0210, 'lps'),
	(542384, 129, '2014-02-15 00:39:47.000000', 'consum', 0.0221, 'lps'),
	(542385, 129, '2014-02-15 00:39:48.000000', 'consum', 0.0214, 'lps'),
	(542386, 129, '2014-02-15 00:39:49.000000', 'consum', 0.0224, 'lps'),
	(542387, 129, '2014-02-15 00:39:50.000000', 'consum', 0.0217, 'lps'),
	(542388, 129, '2014-02-15 00:39:51.000000', 'consum', 0.0230, 'lps'),
	(542389, 129, '2014-02-15 00:39:52.000000', 'consum', 0.0213, 'lps'),
	(542390, 129, '2014-02-15 00:39:53.000000', 'consum', 0.0218, 'lps'),
	(542391, 129, '2014-02-15 00:39:54.000000', 'consum', 0.0215, 'lps'),
	(542392, 129, '2014-02-15 00:39:55.000000', 'consum', 0.0213, 'lps'),
	(542393, 129, '2014-02-15 00:39:56.000000', 'consum', 0.0211, 'lps'),
	(542394, 129, '2014-02-15 00:39:57.000000', 'consum', 0.0232, 'lps'),
	(542395, 129, '2014-02-15 00:39:58.000000', 'consum', 0.0218, 'lps'),
	(542396, 129, '2014-02-15 00:39:59.000000', 'consum', 0.0232, 'lps'),
	(542397, 129, '2014-02-15 00:40:00.000000', 'consum', 0.0224, 'lps'),
	(542398, 129, '2014-02-15 00:40:01.000000', 'consum', 0.0215, 'lps'),
	(542399, 129, '2014-02-15 00:40:02.000000', 'consum', 0.0217, 'lps'),
	(542400, 129, '2014-02-15 00:40:03.000000', 'consum', 0.0229, 'lps'),
	(542401, 129, '2014-02-15 00:40:04.000000', 'consum', 0.0211, 'lps'),
	(542402, 129, '2014-02-15 00:40:05.000000', 'consum', 0.0234, 'lps'),
	(542403, 129, '2014-02-15 00:40:06.000000', 'consum', 0.0228, 'lps'),
	(542404, 129, '2014-02-15 00:40:07.000000', 'consum', 0.0230, 'lps'),
	(542405, 129, '2014-02-15 00:40:08.000000', 'consum', 0.0229, 'lps'),
	(542406, 129, '2014-02-15 00:40:09.000000', 'consum', 0.0221, 'lps'),
	(542407, 129, '2014-02-15 00:40:10.000000', 'consum', 0.0210, 'lps'),
	(542408, 129, '2014-02-15 00:40:11.000000', 'consum', 0.0227, 'lps'),
	(542409, 129, '2014-02-15 00:40:12.000000', 'consum', 0.0220, 'lps'),
	(542410, 129, '2014-02-15 00:40:13.000000', 'consum', 0.0233, 'lps'),
	(542411, 129, '2014-02-15 00:40:14.000000', 'consum', 0.0223, 'lps'),
	(542412, 129, '2014-02-15 00:40:15.000000', 'consum', 0.0229, 'lps'),
	(542413, 129, '2014-02-15 00:40:16.000000', 'consum', 0.0219, 'lps'),
	(542414, 129, '2014-02-15 00:40:17.000000', 'consum', 0.0221, 'lps'),
	(542415, 129, '2014-02-15 00:40:18.000000', 'consum', 0.0213, 'lps'),
	(542416, 129, '2014-02-15 00:40:19.000000', 'consum', 0.0218, 'lps'),
	(542417, 129, '2014-02-15 00:40:20.000000', 'consum', 0.0216, 'lps'),
	(542418, 129, '2014-02-15 00:40:21.000000', 'consum', 0.0218, 'lps'),
	(542419, 129, '2014-02-15 00:40:22.000000', 'consum', 0.0230, 'lps'),
	(542420, 129, '2014-02-15 00:40:23.000000', 'consum', 0.0212, 'lps'),
	(542421, 129, '2014-02-15 00:40:24.000000', 'consum', 0.0212, 'lps'),
	(542422, 129, '2014-02-15 00:40:25.000000', 'consum', 0.0213, 'lps'),
	(542423, 129, '2014-02-15 00:40:26.000000', 'consum', 0.0221, 'lps'),
	(542424, 129, '2014-02-15 00:40:27.000000', 'consum', 0.0229, 'lps'),
	(542425, 129, '2014-02-15 00:40:28.000000', 'consum', 0.0223, 'lps'),
	(542426, 129, '2014-02-15 00:40:29.000000', 'consum', 0.0218, 'lps'),
	(542427, 129, '2014-02-15 00:40:30.000000', 'consum', 0.0211, 'lps'),
	(542428, 129, '2014-02-15 00:40:31.000000', 'consum', 0.0216, 'lps'),
	(542429, 129, '2014-02-15 00:40:32.000000', 'consum', 0.0215, 'lps'),
	(542430, 129, '2014-02-15 00:40:33.000000', 'consum', 0.0216, 'lps'),
	(542431, 129, '2014-02-15 00:40:34.000000', 'consum', 0.0224, 'lps'),
	(542432, 129, '2014-02-15 00:40:35.000000', 'consum', 0.0214, 'lps'),
	(542433, 129, '2014-02-15 00:40:36.000000', 'consum', 0.0215, 'lps'),
	(542434, 129, '2014-02-15 00:40:37.000000', 'consum', 0.0224, 'lps'),
	(542435, 129, '2014-02-15 00:40:38.000000', 'consum', 0.0212, 'lps'),
	(542436, 129, '2014-02-15 00:40:39.000000', 'consum', 0.0231, 'lps'),
	(542437, 129, '2014-02-15 00:40:40.000000', 'consum', 0.0211, 'lps'),
	(542438, 129, '2014-02-15 00:40:41.000000', 'consum', 0.0225, 'lps'),
	(542439, 129, '2014-02-15 00:40:42.000000', 'consum', 0.0234, 'lps'),
	(542440, 129, '2014-02-15 00:40:43.000000', 'consum', 0.0211, 'lps'),
	(542441, 129, '2014-02-15 00:40:44.000000', 'consum', 0.0219, 'lps'),
	(542442, 129, '2014-02-15 00:40:45.000000', 'consum', 0.0226, 'lps'),
	(542443, 129, '2014-02-15 00:40:46.000000', 'consum', 0.0213, 'lps'),
	(542444, 129, '2014-02-15 00:40:47.000000', 'consum', 0.0230, 'lps'),
	(542445, 129, '2014-02-15 00:40:48.000000', 'consum', 0.0226, 'lps'),
	(542446, 129, '2014-02-15 00:40:49.000000', 'consum', 0.0231, 'lps'),
	(542447, 129, '2014-02-15 00:40:50.000000', 'consum', 0.0218, 'lps'),
	(542448, 129, '2014-02-15 00:40:51.000000', 'consum', 0.0211, 'lps'),
	(542449, 129, '2014-02-15 00:40:52.000000', 'consum', 0.0217, 'lps'),
	(542450, 129, '2014-02-15 00:40:53.000000', 'consum', 0.0219, 'lps'),
	(542451, 129, '2014-02-15 00:40:54.000000', 'consum', 0.0233, 'lps'),
	(542452, 129, '2014-02-15 00:40:55.000000', 'consum', 0.0222, 'lps'),
	(542453, 129, '2014-02-15 00:40:56.000000', 'consum', 0.0229, 'lps'),
	(542454, 129, '2014-02-15 00:40:57.000000', 'consum', 0.0219, 'lps'),
	(542455, 129, '2014-02-15 00:40:58.000000', 'consum', 0.0223, 'lps'),
	(542456, 129, '2014-02-15 00:40:59.000000', 'consum', 0.0225, 'lps'),
	(542457, 129, '2014-02-15 00:41:00.000000', 'consum', 0.0222, 'lps'),
	(542458, 129, '2014-02-15 00:41:01.000000', 'consum', 0.0226, 'lps'),
	(542459, 129, '2014-02-15 00:41:02.000000', 'consum', 0.0230, 'lps'),
	(542460, 129, '2014-02-15 00:41:03.000000', 'consum', 0.0211, 'lps'),
	(542461, 129, '2014-02-15 00:41:04.000000', 'consum', 0.0231, 'lps'),
	(542462, 129, '2014-02-15 00:41:05.000000', 'consum', 0.0212, 'lps'),
	(542463, 129, '2014-02-15 00:41:06.000000', 'consum', 0.0231, 'lps'),
	(542464, 129, '2014-02-15 00:41:07.000000', 'consum', 0.0234, 'lps'),
	(542465, 129, '2014-02-15 00:41:08.000000', 'consum', 0.0220, 'lps'),
	(542466, 129, '2014-02-15 00:41:09.000000', 'consum', 0.0211, 'lps'),
	(542467, 129, '2014-02-15 00:41:10.000000', 'consum', 0.0210, 'lps'),
	(542468, 129, '2014-02-15 00:41:11.000000', 'consum', 0.0234, 'lps'),
	(542469, 129, '2014-02-15 00:41:12.000000', 'consum', 0.0230, 'lps'),
	(542470, 129, '2014-02-15 00:41:13.000000', 'consum', 0.0215, 'lps'),
	(542471, 129, '2014-02-15 00:41:14.000000', 'consum', 0.0226, 'lps'),
	(542472, 129, '2014-02-15 00:41:15.000000', 'consum', 0.0223, 'lps'),
	(542473, 129, '2014-02-15 00:41:16.000000', 'consum', 0.0230, 'lps'),
	(542474, 129, '2014-02-15 00:41:17.000000', 'consum', 0.0222, 'lps'),
	(542475, 129, '2014-02-15 00:41:18.000000', 'consum', 0.0234, 'lps'),
	(542476, 129, '2014-02-15 00:41:19.000000', 'consum', 0.0222, 'lps'),
	(542477, 129, '2014-02-15 00:41:20.000000', 'consum', 0.0221, 'lps'),
	(542478, 129, '2014-02-15 00:41:21.000000', 'consum', 0.0230, 'lps'),
	(542479, 129, '2014-02-15 00:41:22.000000', 'consum', 0.0227, 'lps'),
	(542480, 129, '2014-02-15 00:41:23.000000', 'consum', 0.0212, 'lps'),
	(542481, 129, '2014-02-15 00:41:24.000000', 'consum', 0.0219, 'lps'),
	(542482, 129, '2014-02-15 00:41:25.000000', 'consum', 0.0225, 'lps'),
	(542483, 129, '2014-02-15 00:41:26.000000', 'consum', 0.0210, 'lps'),
	(542484, 129, '2014-02-15 00:41:27.000000', 'consum', 0.0213, 'lps'),
	(542485, 129, '2014-02-15 00:41:28.000000', 'consum', 0.0228, 'lps'),
	(542486, 129, '2014-02-15 00:41:29.000000', 'consum', 0.0216, 'lps'),
	(542487, 129, '2014-02-15 00:41:30.000000', 'consum', 0.0212, 'lps'),
	(542488, 129, '2014-02-15 00:41:31.000000', 'consum', 0.0226, 'lps'),
	(542489, 129, '2014-02-15 00:41:32.000000', 'consum', 0.0233, 'lps'),
	(542490, 129, '2014-02-15 00:41:33.000000', 'consum', 0.0229, 'lps'),
	(542491, 129, '2014-02-15 00:41:34.000000', 'consum', 0.0211, 'lps'),
	(542492, 129, '2014-02-15 00:41:35.000000', 'consum', 0.0233, 'lps'),
	(542493, 129, '2014-02-15 00:41:36.000000', 'consum', 0.0222, 'lps'),
	(542494, 129, '2014-02-15 00:41:37.000000', 'consum', 0.0226, 'lps'),
	(542495, 129, '2014-02-15 00:41:38.000000', 'consum', 0.0230, 'lps'),
	(542496, 129, '2014-02-15 00:41:39.000000', 'consum', 0.0211, 'lps'),
	(542497, 129, '2014-02-15 00:41:40.000000', 'consum', 0.0233, 'lps'),
	(542498, 129, '2014-02-15 00:41:41.000000', 'consum', 0.0220, 'lps'),
	(542499, 129, '2014-02-15 00:41:42.000000', 'consum', 0.0217, 'lps'),
	(542500, 129, '2014-02-15 00:41:43.000000', 'consum', 0.0216, 'lps'),
	(542501, 129, '2014-02-15 00:41:44.000000', 'consum', 0.0220, 'lps'),
	(542502, 129, '2014-02-15 00:41:45.000000', 'consum', 0.0216, 'lps'),
	(542503, 129, '2014-02-15 00:41:46.000000', 'consum', 0.0210, 'lps'),
	(542504, 129, '2014-02-15 00:41:47.000000', 'consum', 0.0217, 'lps'),
	(542505, 129, '2014-02-15 00:41:48.000000', 'consum', 0.0223, 'lps'),
	(542506, 129, '2014-02-15 00:41:49.000000', 'consum', 0.0227, 'lps'),
	(542507, 129, '2014-02-15 00:41:50.000000', 'consum', 0.0230, 'lps'),
	(542508, 129, '2014-02-15 00:41:51.000000', 'consum', 0.0213, 'lps'),
	(542509, 129, '2014-02-15 00:41:52.000000', 'consum', 0.0214, 'lps'),
	(542510, 129, '2014-02-15 00:41:53.000000', 'consum', 0.0222, 'lps'),
	(542511, 129, '2014-02-15 00:41:54.000000', 'consum', 0.0232, 'lps'),
	(542512, 129, '2014-02-15 00:41:55.000000', 'consum', 0.0234, 'lps'),
	(542513, 129, '2014-02-15 00:41:56.000000', 'consum', 0.0215, 'lps'),
	(542514, 129, '2014-02-15 00:41:57.000000', 'consum', 0.0212, 'lps'),
	(542515, 129, '2014-02-15 00:41:58.000000', 'consum', 0.0231, 'lps'),
	(542516, 129, '2014-02-15 00:41:59.000000', 'consum', 0.0234, 'lps'),
	(542517, 129, '2014-02-15 00:42:00.000000', 'consum', 0.0218, 'lps'),
	(542518, 129, '2014-02-15 00:42:01.000000', 'consum', 0.0230, 'lps'),
	(542519, 129, '2014-02-15 00:42:02.000000', 'consum', 0.0212, 'lps'),
	(542520, 129, '2014-02-15 00:42:03.000000', 'consum', 0.0210, 'lps'),
	(542521, 129, '2014-02-15 00:42:04.000000', 'consum', 0.0231, 'lps'),
	(542522, 129, '2014-02-15 00:42:05.000000', 'consum', 0.0215, 'lps'),
	(542523, 129, '2014-02-15 00:42:06.000000', 'consum', 0.0221, 'lps'),
	(542524, 129, '2014-02-15 00:42:07.000000', 'consum', 0.0226, 'lps'),
	(542525, 129, '2014-02-15 00:42:08.000000', 'consum', 0.0233, 'lps'),
	(542526, 129, '2014-02-15 00:42:09.000000', 'consum', 0.0226, 'lps'),
	(542527, 129, '2014-02-15 00:42:10.000000', 'consum', 0.0223, 'lps'),
	(542528, 129, '2014-02-15 00:42:11.000000', 'consum', 0.0225, 'lps'),
	(542529, 129, '2014-02-15 00:42:12.000000', 'consum', 0.0224, 'lps'),
	(542530, 129, '2014-02-15 00:42:13.000000', 'consum', 0.0233, 'lps'),
	(542531, 129, '2014-02-15 00:42:14.000000', 'consum', 0.0211, 'lps'),
	(542532, 129, '2014-02-15 00:42:15.000000', 'consum', 0.0222, 'lps'),
	(542533, 129, '2014-02-15 00:42:16.000000', 'consum', 0.0218, 'lps'),
	(542534, 129, '2014-02-15 00:42:17.000000', 'consum', 0.0214, 'lps'),
	(542535, 129, '2014-02-15 00:42:18.000000', 'consum', 0.0231, 'lps'),
	(542536, 129, '2014-02-15 00:42:19.000000', 'consum', 0.0230, 'lps'),
	(542537, 129, '2014-02-15 00:42:20.000000', 'consum', 0.0221, 'lps'),
	(542538, 129, '2014-02-15 00:42:21.000000', 'consum', 0.0233, 'lps'),
	(542539, 129, '2014-02-15 00:42:22.000000', 'consum', 0.0214, 'lps'),
	(542540, 129, '2014-02-15 00:42:23.000000', 'consum', 0.0212, 'lps'),
	(542541, 129, '2014-02-15 00:42:24.000000', 'consum', 0.0211, 'lps'),
	(542542, 129, '2014-02-15 00:42:25.000000', 'consum', 0.0234, 'lps'),
	(542543, 129, '2014-02-15 00:42:26.000000', 'consum', 0.0227, 'lps'),
	(542544, 129, '2014-02-15 00:42:27.000000', 'consum', 0.0222, 'lps'),
	(542545, 129, '2014-02-15 00:42:28.000000', 'consum', 0.0219, 'lps'),
	(542546, 129, '2014-02-15 00:42:29.000000', 'consum', 0.0222, 'lps'),
	(542547, 129, '2014-02-15 00:42:30.000000', 'consum', 0.0217, 'lps'),
	(542548, 129, '2014-02-15 00:42:31.000000', 'consum', 0.0210, 'lps'),
	(542549, 129, '2014-02-15 00:42:32.000000', 'consum', 0.0215, 'lps'),
	(542550, 129, '2014-02-15 00:42:33.000000', 'consum', 0.0234, 'lps'),
	(542551, 129, '2014-02-15 00:42:34.000000', 'consum', 0.0218, 'lps'),
	(542552, 129, '2014-02-15 00:42:35.000000', 'consum', 0.0229, 'lps'),
	(542553, 129, '2014-02-15 00:42:36.000000', 'consum', 0.0229, 'lps'),
	(542554, 129, '2014-02-15 00:42:37.000000', 'consum', 0.0223, 'lps'),
	(542555, 129, '2014-02-15 00:42:38.000000', 'consum', 0.0219, 'lps'),
	(542556, 129, '2014-02-15 00:42:39.000000', 'consum', 0.0217, 'lps'),
	(542557, 129, '2014-02-15 00:42:40.000000', 'consum', 0.0217, 'lps'),
	(542558, 129, '2014-02-15 00:42:41.000000', 'consum', 0.0226, 'lps'),
	(542559, 129, '2014-02-15 00:42:42.000000', 'consum', 0.0221, 'lps'),
	(542560, 129, '2014-02-15 00:42:43.000000', 'consum', 0.0216, 'lps'),
	(542561, 129, '2014-02-15 00:42:44.000000', 'consum', 0.0233, 'lps'),
	(542562, 129, '2014-02-15 00:42:45.000000', 'consum', 0.0234, 'lps'),
	(542563, 129, '2014-02-15 00:42:46.000000', 'consum', 0.0234, 'lps'),
	(542564, 129, '2014-02-15 00:42:47.000000', 'consum', 0.0233, 'lps'),
	(542565, 129, '2014-02-15 00:42:48.000000', 'consum', 0.0228, 'lps'),
	(542566, 129, '2014-02-15 00:42:49.000000', 'consum', 0.0234, 'lps'),
	(542567, 129, '2014-02-15 00:42:50.000000', 'consum', 0.0225, 'lps'),
	(542568, 129, '2014-02-15 00:42:51.000000', 'consum', 0.0214, 'lps'),
	(542569, 129, '2014-02-15 00:42:52.000000', 'consum', 0.0210, 'lps'),
	(542570, 129, '2014-02-15 00:42:53.000000', 'consum', 0.0226, 'lps'),
	(542571, 129, '2014-02-15 00:42:54.000000', 'consum', 0.0214, 'lps'),
	(542572, 129, '2014-02-15 00:42:55.000000', 'consum', 0.0230, 'lps'),
	(542573, 129, '2014-02-15 00:42:56.000000', 'consum', 0.0227, 'lps'),
	(542574, 129, '2014-02-15 00:42:57.000000', 'consum', 0.0232, 'lps'),
	(542575, 129, '2014-02-15 00:42:58.000000', 'consum', 0.0223, 'lps'),
	(542576, 129, '2014-02-15 00:42:59.000000', 'consum', 0.0233, 'lps'),
	(542577, 129, '2014-02-15 00:43:00.000000', 'consum', 0.0212, 'lps'),
	(542578, 129, '2014-02-15 00:43:01.000000', 'consum', 0.0224, 'lps'),
	(542579, 129, '2014-02-15 00:43:02.000000', 'consum', 0.0227, 'lps'),
	(542580, 129, '2014-02-15 00:43:03.000000', 'consum', 0.0228, 'lps'),
	(542581, 129, '2014-02-15 00:43:04.000000', 'consum', 0.0225, 'lps'),
	(542582, 129, '2014-02-15 00:43:05.000000', 'consum', 0.0229, 'lps'),
	(542583, 129, '2014-02-15 00:43:06.000000', 'consum', 0.0213, 'lps'),
	(542584, 129, '2014-02-15 00:43:07.000000', 'consum', 0.0217, 'lps'),
	(542585, 129, '2014-02-15 00:43:08.000000', 'consum', 0.0211, 'lps'),
	(542586, 129, '2014-02-15 00:43:09.000000', 'consum', 0.0220, 'lps'),
	(542587, 129, '2014-02-15 00:43:10.000000', 'consum', 0.0232, 'lps'),
	(542588, 129, '2014-02-15 00:43:11.000000', 'consum', 0.0216, 'lps'),
	(542589, 129, '2014-02-15 00:43:12.000000', 'consum', 0.0223, 'lps'),
	(542590, 129, '2014-02-15 00:43:13.000000', 'consum', 0.0232, 'lps'),
	(542591, 129, '2014-02-15 00:43:14.000000', 'consum', 0.0231, 'lps'),
	(542592, 129, '2014-02-15 00:43:15.000000', 'consum', 0.0225, 'lps'),
	(542593, 129, '2014-02-15 00:43:16.000000', 'consum', 0.0224, 'lps'),
	(542594, 129, '2014-02-15 00:43:17.000000', 'consum', 0.0233, 'lps'),
	(542595, 129, '2014-02-15 00:43:18.000000', 'consum', 0.0211, 'lps'),
	(542596, 129, '2014-02-15 00:43:19.000000', 'consum', 0.0219, 'lps'),
	(542597, 129, '2014-02-15 00:43:20.000000', 'consum', 0.0228, 'lps'),
	(542598, 129, '2014-02-15 00:43:21.000000', 'consum', 0.0226, 'lps'),
	(542599, 129, '2014-02-15 00:43:22.000000', 'consum', 0.0210, 'lps'),
	(542600, 129, '2014-02-15 00:43:23.000000', 'consum', 0.0213, 'lps'),
	(542601, 129, '2014-02-15 00:43:24.000000', 'consum', 0.0227, 'lps'),
	(542602, 129, '2014-02-15 00:43:25.000000', 'consum', 0.0211, 'lps'),
	(542603, 129, '2014-02-15 00:43:26.000000', 'consum', 0.0212, 'lps'),
	(542604, 129, '2014-02-15 00:43:27.000000', 'consum', 0.0219, 'lps'),
	(542605, 129, '2014-02-15 00:43:28.000000', 'consum', 0.0224, 'lps'),
	(542606, 129, '2014-02-15 00:43:29.000000', 'consum', 0.0227, 'lps'),
	(542607, 129, '2014-02-15 00:43:30.000000', 'consum', 0.0231, 'lps'),
	(542608, 129, '2014-02-15 00:43:31.000000', 'consum', 0.0215, 'lps'),
	(542609, 129, '2014-02-15 00:43:32.000000', 'consum', 0.0223, 'lps'),
	(542610, 129, '2014-02-15 00:43:33.000000', 'consum', 0.0233, 'lps'),
	(542611, 129, '2014-02-15 00:43:34.000000', 'consum', 0.0214, 'lps'),
	(542612, 129, '2014-02-15 00:43:35.000000', 'consum', 0.0234, 'lps'),
	(542613, 129, '2014-02-15 00:43:36.000000', 'consum', 0.0218, 'lps'),
	(542614, 129, '2014-02-15 00:43:37.000000', 'consum', 0.0228, 'lps'),
	(542615, 129, '2014-02-15 00:43:38.000000', 'consum', 0.0225, 'lps'),
	(542616, 129, '2014-02-15 00:43:39.000000', 'consum', 0.0210, 'lps'),
	(542617, 129, '2014-02-15 00:43:40.000000', 'consum', 0.0216, 'lps'),
	(542618, 129, '2014-02-15 00:43:41.000000', 'consum', 0.0213, 'lps'),
	(542619, 129, '2014-02-15 00:43:42.000000', 'consum', 0.0210, 'lps'),
	(542620, 129, '2014-02-15 00:43:43.000000', 'consum', 0.0225, 'lps'),
	(542621, 129, '2014-02-15 00:43:44.000000', 'consum', 0.0211, 'lps'),
	(542622, 129, '2014-02-15 00:43:45.000000', 'consum', 0.0221, 'lps'),
	(542623, 129, '2014-02-15 00:43:46.000000', 'consum', 0.0214, 'lps'),
	(542624, 129, '2014-02-15 00:43:47.000000', 'consum', 0.0222, 'lps'),
	(542625, 129, '2014-02-15 00:43:48.000000', 'consum', 0.0233, 'lps'),
	(542626, 129, '2014-02-15 00:43:49.000000', 'consum', 0.0213, 'lps'),
	(542627, 129, '2014-02-15 00:43:50.000000', 'consum', 0.0234, 'lps'),
	(542628, 129, '2014-02-15 00:43:51.000000', 'consum', 0.0219, 'lps'),
	(542629, 129, '2014-02-15 00:43:52.000000', 'consum', 0.0210, 'lps'),
	(542630, 129, '2014-02-15 00:43:53.000000', 'consum', 0.0233, 'lps'),
	(542631, 129, '2014-02-15 00:43:54.000000', 'consum', 0.0226, 'lps'),
	(542632, 129, '2014-02-15 00:43:55.000000', 'consum', 0.0222, 'lps'),
	(542633, 129, '2014-02-15 00:43:56.000000', 'consum', 0.0223, 'lps'),
	(542634, 129, '2014-02-15 00:43:57.000000', 'consum', 0.0216, 'lps'),
	(542635, 129, '2014-02-15 00:43:58.000000', 'consum', 0.0223, 'lps'),
	(542636, 129, '2014-02-15 00:43:59.000000', 'consum', 0.0210, 'lps'),
	(542637, 129, '2014-02-15 00:44:00.000000', 'consum', 0.0219, 'lps'),
	(542638, 129, '2014-02-15 00:44:01.000000', 'consum', 0.0234, 'lps'),
	(542639, 129, '2014-02-15 00:44:02.000000', 'consum', 0.0225, 'lps'),
	(542640, 129, '2014-02-15 00:44:03.000000', 'consum', 0.0216, 'lps'),
	(542641, 129, '2014-02-15 00:44:04.000000', 'consum', 0.0219, 'lps'),
	(542642, 129, '2014-02-15 00:44:05.000000', 'consum', 0.0213, 'lps'),
	(542643, 129, '2014-02-15 00:44:06.000000', 'consum', 0.0225, 'lps'),
	(542644, 129, '2014-02-15 00:44:07.000000', 'consum', 0.0225, 'lps'),
	(542645, 129, '2014-02-15 00:44:08.000000', 'consum', 0.0217, 'lps'),
	(542646, 129, '2014-02-15 00:44:09.000000', 'consum', 0.0225, 'lps'),
	(542647, 129, '2014-02-15 00:44:10.000000', 'consum', 0.0214, 'lps'),
	(542648, 129, '2014-02-15 00:44:11.000000', 'consum', 0.0234, 'lps'),
	(542649, 129, '2014-02-15 00:44:12.000000', 'consum', 0.0219, 'lps'),
	(542650, 129, '2014-02-15 00:44:13.000000', 'consum', 0.0210, 'lps'),
	(542651, 129, '2014-02-15 00:44:14.000000', 'consum', 0.0231, 'lps'),
	(542652, 129, '2014-02-15 00:44:15.000000', 'consum', 0.0216, 'lps'),
	(542653, 129, '2014-02-15 00:44:16.000000', 'consum', 0.0229, 'lps'),
	(542654, 129, '2014-02-15 00:44:17.000000', 'consum', 0.0212, 'lps'),
	(542655, 129, '2014-02-15 00:44:18.000000', 'consum', 0.0212, 'lps'),
	(542656, 129, '2014-02-15 00:44:19.000000', 'consum', 0.0217, 'lps'),
	(542657, 129, '2014-02-15 00:44:20.000000', 'consum', 0.0214, 'lps'),
	(542658, 129, '2014-02-15 00:44:21.000000', 'consum', 0.0234, 'lps'),
	(542659, 129, '2014-02-15 00:44:22.000000', 'consum', 0.0220, 'lps'),
	(542660, 129, '2014-02-15 00:44:23.000000', 'consum', 0.0211, 'lps'),
	(542661, 129, '2014-02-15 00:44:24.000000', 'consum', 0.0213, 'lps'),
	(542662, 129, '2014-02-15 00:44:25.000000', 'consum', 0.0221, 'lps'),
	(542663, 129, '2014-02-15 00:44:26.000000', 'consum', 0.0232, 'lps'),
	(542664, 129, '2014-02-15 00:44:27.000000', 'consum', 0.0211, 'lps'),
	(542665, 129, '2014-02-15 00:44:28.000000', 'consum', 0.0227, 'lps'),
	(542666, 129, '2014-02-15 00:44:29.000000', 'consum', 0.0216, 'lps'),
	(542667, 129, '2014-02-15 00:44:30.000000', 'consum', 0.0214, 'lps'),
	(542668, 129, '2014-02-15 00:44:31.000000', 'consum', 0.0215, 'lps'),
	(542669, 129, '2014-02-15 00:44:32.000000', 'consum', 0.0223, 'lps'),
	(542670, 129, '2014-02-15 00:44:33.000000', 'consum', 0.0210, 'lps'),
	(542671, 129, '2014-02-15 00:44:34.000000', 'consum', 0.0220, 'lps'),
	(542672, 129, '2014-02-15 00:44:35.000000', 'consum', 0.0212, 'lps'),
	(542673, 129, '2014-02-15 00:44:36.000000', 'consum', 0.0214, 'lps'),
	(542674, 129, '2014-02-15 00:44:37.000000', 'consum', 0.0225, 'lps'),
	(542675, 129, '2014-02-15 00:44:38.000000', 'consum', 0.0222, 'lps'),
	(542676, 129, '2014-02-15 00:44:39.000000', 'consum', 0.0229, 'lps'),
	(542677, 129, '2014-02-15 00:44:40.000000', 'consum', 0.0217, 'lps'),
	(542678, 129, '2014-02-15 00:44:41.000000', 'consum', 0.0215, 'lps'),
	(542679, 129, '2014-02-15 00:44:42.000000', 'consum', 0.0213, 'lps'),
	(542680, 129, '2014-02-15 00:44:43.000000', 'consum', 0.0210, 'lps'),
	(542681, 129, '2014-02-15 00:44:44.000000', 'consum', 0.0228, 'lps'),
	(542682, 129, '2014-02-15 00:44:45.000000', 'consum', 0.0227, 'lps'),
	(542683, 129, '2014-02-15 00:44:46.000000', 'consum', 0.0214, 'lps'),
	(542684, 129, '2014-02-15 00:44:47.000000', 'consum', 0.0229, 'lps'),
	(542685, 129, '2014-02-15 00:44:48.000000', 'consum', 0.0221, 'lps'),
	(542686, 129, '2014-02-15 00:44:49.000000', 'consum', 0.0233, 'lps'),
	(542687, 129, '2014-02-15 00:44:50.000000', 'consum', 0.0219, 'lps'),
	(542688, 129, '2014-02-15 00:44:51.000000', 'consum', 0.0210, 'lps'),
	(542689, 129, '2014-02-15 00:44:52.000000', 'consum', 0.0233, 'lps'),
	(542690, 129, '2014-02-15 00:44:53.000000', 'consum', 0.0228, 'lps'),
	(542691, 129, '2014-02-15 00:44:54.000000', 'consum', 0.0228, 'lps'),
	(542692, 129, '2014-02-15 00:44:55.000000', 'consum', 0.0223, 'lps'),
	(542693, 129, '2014-02-15 00:44:56.000000', 'consum', 0.0220, 'lps'),
	(542694, 129, '2014-02-15 00:44:57.000000', 'consum', 0.0224, 'lps'),
	(542695, 129, '2014-02-15 00:44:58.000000', 'consum', 0.0226, 'lps'),
	(542696, 129, '2014-02-15 00:44:59.000000', 'consum', 0.0223, 'lps'),
	(542697, 129, '2014-02-15 00:45:00.000000', 'consum', 0.0226, 'lps'),
	(542698, 129, '2014-02-15 00:45:01.000000', 'consum', 0.0228, 'lps'),
	(542699, 129, '2014-02-15 00:45:02.000000', 'consum', 0.0229, 'lps'),
	(542700, 129, '2014-02-15 00:45:03.000000', 'consum', 0.0224, 'lps'),
	(542701, 129, '2014-02-15 00:45:04.000000', 'consum', 0.0223, 'lps'),
	(542702, 129, '2014-02-15 00:45:05.000000', 'consum', 0.0234, 'lps'),
	(542703, 129, '2014-02-15 00:45:06.000000', 'consum', 0.0218, 'lps'),
	(542704, 129, '2014-02-15 00:45:07.000000', 'consum', 0.0227, 'lps'),
	(542705, 129, '2014-02-15 00:45:08.000000', 'consum', 0.0223, 'lps'),
	(542706, 129, '2014-02-15 00:45:09.000000', 'consum', 0.0224, 'lps'),
	(542707, 129, '2014-02-15 00:45:10.000000', 'consum', 0.0217, 'lps'),
	(542708, 129, '2014-02-15 00:45:11.000000', 'consum', 0.0226, 'lps'),
	(542709, 129, '2014-02-15 00:45:12.000000', 'consum', 0.0222, 'lps'),
	(542710, 129, '2014-02-15 00:45:13.000000', 'consum', 0.0220, 'lps'),
	(542711, 129, '2014-02-15 00:45:14.000000', 'consum', 0.0225, 'lps'),
	(542712, 129, '2014-02-15 00:45:15.000000', 'consum', 0.0230, 'lps'),
	(542713, 129, '2014-02-15 00:45:16.000000', 'consum', 0.0217, 'lps'),
	(542714, 129, '2014-02-15 00:45:17.000000', 'consum', 0.0210, 'lps'),
	(542715, 129, '2014-02-15 00:45:18.000000', 'consum', 0.0214, 'lps'),
	(542716, 129, '2014-02-15 00:45:19.000000', 'consum', 0.0231, 'lps'),
	(542717, 129, '2014-02-15 00:45:20.000000', 'consum', 0.0230, 'lps'),
	(542718, 129, '2014-02-15 00:45:21.000000', 'consum', 0.0220, 'lps'),
	(542719, 129, '2014-02-15 00:45:22.000000', 'consum', 0.0226, 'lps'),
	(542720, 129, '2014-02-15 00:45:23.000000', 'consum', 0.0212, 'lps'),
	(542721, 129, '2014-02-15 00:45:24.000000', 'consum', 0.0223, 'lps'),
	(542722, 129, '2014-02-15 00:45:25.000000', 'consum', 0.0219, 'lps'),
	(542723, 129, '2014-02-15 00:45:26.000000', 'consum', 0.0214, 'lps'),
	(542724, 129, '2014-02-15 00:45:27.000000', 'consum', 0.0232, 'lps'),
	(542725, 129, '2014-02-15 00:45:28.000000', 'consum', 0.0233, 'lps'),
	(542726, 129, '2014-02-15 00:45:29.000000', 'consum', 0.0233, 'lps'),
	(542727, 129, '2014-02-15 00:45:30.000000', 'consum', 0.0231, 'lps'),
	(542728, 129, '2014-02-15 00:45:31.000000', 'consum', 0.0223, 'lps'),
	(542729, 129, '2014-02-15 00:45:32.000000', 'consum', 0.0213, 'lps'),
	(542730, 129, '2014-02-15 00:45:33.000000', 'consum', 0.0234, 'lps'),
	(542731, 129, '2014-02-15 00:45:34.000000', 'consum', 0.0221, 'lps'),
	(542732, 129, '2014-02-15 00:45:35.000000', 'consum', 0.0221, 'lps'),
	(542733, 129, '2014-02-15 00:45:36.000000', 'consum', 0.0234, 'lps'),
	(542734, 129, '2014-02-15 00:45:37.000000', 'consum', 0.0219, 'lps'),
	(542735, 129, '2014-02-15 00:45:38.000000', 'consum', 0.0210, 'lps'),
	(542736, 129, '2014-02-15 00:45:39.000000', 'consum', 0.0232, 'lps'),
	(542737, 129, '2014-02-15 00:45:40.000000', 'consum', 0.0220, 'lps'),
	(542738, 129, '2014-02-15 00:45:41.000000', 'consum', 0.0219, 'lps'),
	(542739, 129, '2014-02-15 00:45:42.000000', 'consum', 0.0224, 'lps'),
	(542740, 129, '2014-02-15 00:45:43.000000', 'consum', 0.0232, 'lps'),
	(542741, 129, '2014-02-15 00:45:44.000000', 'consum', 0.0228, 'lps'),
	(542742, 129, '2014-02-15 00:45:45.000000', 'consum', 0.0234, 'lps'),
	(542743, 129, '2014-02-15 00:45:46.000000', 'consum', 0.0227, 'lps'),
	(542744, 129, '2014-02-15 00:45:47.000000', 'consum', 0.0224, 'lps'),
	(542745, 129, '2014-02-15 00:45:48.000000', 'consum', 0.0228, 'lps'),
	(542746, 129, '2014-02-15 00:45:49.000000', 'consum', 0.0234, 'lps'),
	(542747, 129, '2014-02-15 00:45:50.000000', 'consum', 0.0227, 'lps'),
	(542748, 129, '2014-02-15 00:45:51.000000', 'consum', 0.0225, 'lps'),
	(542749, 129, '2014-02-15 00:45:52.000000', 'consum', 0.0234, 'lps'),
	(542750, 129, '2014-02-15 00:45:53.000000', 'consum', 0.0210, 'lps'),
	(542751, 129, '2014-02-15 00:45:54.000000', 'consum', 0.0215, 'lps'),
	(542752, 129, '2014-02-15 00:45:55.000000', 'consum', 0.0233, 'lps'),
	(542753, 129, '2014-02-15 00:45:56.000000', 'consum', 0.0210, 'lps'),
	(542754, 129, '2014-02-15 00:45:57.000000', 'consum', 0.0216, 'lps'),
	(542755, 129, '2014-02-15 00:45:58.000000', 'consum', 0.0215, 'lps'),
	(542756, 129, '2014-02-15 00:45:59.000000', 'consum', 0.0220, 'lps'),
	(542757, 129, '2014-02-15 00:46:00.000000', 'consum', 0.0221, 'lps'),
	(542758, 129, '2014-02-15 00:46:01.000000', 'consum', 0.0234, 'lps'),
	(542759, 129, '2014-02-15 00:46:02.000000', 'consum', 0.0225, 'lps'),
	(542760, 129, '2014-02-15 00:46:03.000000', 'consum', 0.0210, 'lps'),
	(542761, 129, '2014-02-15 00:46:04.000000', 'consum', 0.0219, 'lps'),
	(542762, 129, '2014-02-15 00:46:05.000000', 'consum', 0.0228, 'lps'),
	(542763, 129, '2014-02-15 00:46:06.000000', 'consum', 0.0223, 'lps'),
	(542764, 129, '2014-02-15 00:46:07.000000', 'consum', 0.0221, 'lps'),
	(542765, 129, '2014-02-15 00:46:08.000000', 'consum', 0.0229, 'lps'),
	(542766, 129, '2014-02-15 00:46:09.000000', 'consum', 0.0221, 'lps'),
	(542767, 129, '2014-02-15 00:46:10.000000', 'consum', 0.0210, 'lps'),
	(542768, 129, '2014-02-15 00:46:11.000000', 'consum', 0.0227, 'lps'),
	(542769, 129, '2014-02-15 00:46:12.000000', 'consum', 0.0222, 'lps'),
	(542770, 129, '2014-02-15 00:46:13.000000', 'consum', 0.0216, 'lps'),
	(542771, 129, '2014-02-15 00:46:14.000000', 'consum', 0.0232, 'lps'),
	(542772, 129, '2014-02-15 00:46:15.000000', 'consum', 0.0229, 'lps'),
	(542773, 129, '2014-02-15 00:46:16.000000', 'consum', 0.0213, 'lps'),
	(542774, 129, '2014-02-15 00:46:17.000000', 'consum', 0.0218, 'lps'),
	(542775, 129, '2014-02-15 00:46:18.000000', 'consum', 0.0219, 'lps'),
	(542776, 129, '2014-02-15 00:46:19.000000', 'consum', 0.0230, 'lps'),
	(542777, 129, '2014-02-15 00:46:20.000000', 'consum', 0.0233, 'lps'),
	(542778, 129, '2014-02-15 00:46:21.000000', 'consum', 0.0218, 'lps'),
	(542779, 129, '2014-02-15 00:46:22.000000', 'consum', 0.0229, 'lps'),
	(542780, 129, '2014-02-15 00:46:23.000000', 'consum', 0.0234, 'lps'),
	(542781, 129, '2014-02-15 00:46:24.000000', 'consum', 0.0222, 'lps'),
	(542782, 129, '2014-02-15 00:46:25.000000', 'consum', 0.0224, 'lps'),
	(542783, 129, '2014-02-15 00:46:26.000000', 'consum', 0.0221, 'lps'),
	(542784, 129, '2014-02-15 00:46:27.000000', 'consum', 0.0222, 'lps'),
	(542785, 129, '2014-02-15 00:46:28.000000', 'consum', 0.0214, 'lps'),
	(542786, 129, '2014-02-15 00:46:29.000000', 'consum', 0.0219, 'lps'),
	(542787, 129, '2014-02-15 00:46:30.000000', 'consum', 0.0217, 'lps'),
	(542788, 129, '2014-02-15 00:46:31.000000', 'consum', 0.0220, 'lps'),
	(542789, 129, '2014-02-15 00:46:32.000000', 'consum', 0.0213, 'lps'),
	(542790, 129, '2014-02-15 00:46:33.000000', 'consum', 0.0222, 'lps'),
	(542791, 129, '2014-02-15 00:46:34.000000', 'consum', 0.0211, 'lps'),
	(542792, 129, '2014-02-15 00:46:35.000000', 'consum', 0.0230, 'lps'),
	(542793, 129, '2014-02-15 00:46:36.000000', 'consum', 0.0234, 'lps'),
	(542794, 129, '2014-02-15 00:46:37.000000', 'consum', 0.0220, 'lps'),
	(542795, 129, '2014-02-15 00:46:38.000000', 'consum', 0.0214, 'lps'),
	(542796, 129, '2014-02-15 00:46:39.000000', 'consum', 0.0224, 'lps'),
	(542797, 129, '2014-02-15 00:46:40.000000', 'consum', 0.0219, 'lps'),
	(542798, 129, '2014-02-15 00:46:41.000000', 'consum', 0.0214, 'lps'),
	(542799, 129, '2014-02-15 00:46:42.000000', 'consum', 0.0228, 'lps'),
	(542800, 129, '2014-02-15 00:46:43.000000', 'consum', 0.0212, 'lps'),
	(542801, 129, '2014-02-15 00:46:44.000000', 'consum', 0.0216, 'lps'),
	(542802, 129, '2014-02-15 00:46:45.000000', 'consum', 0.0212, 'lps'),
	(542803, 129, '2014-02-15 00:46:46.000000', 'consum', 0.0228, 'lps'),
	(542804, 129, '2014-02-15 00:46:47.000000', 'consum', 0.0220, 'lps'),
	(542805, 129, '2014-02-15 00:46:48.000000', 'consum', 0.0231, 'lps'),
	(542806, 129, '2014-02-15 00:46:49.000000', 'consum', 0.0234, 'lps'),
	(542807, 129, '2014-02-15 00:46:50.000000', 'consum', 0.0217, 'lps'),
	(542808, 129, '2014-02-15 00:46:51.000000', 'consum', 0.0224, 'lps'),
	(542809, 129, '2014-02-15 00:46:52.000000', 'consum', 0.0233, 'lps'),
	(542810, 129, '2014-02-15 00:46:53.000000', 'consum', 0.0233, 'lps'),
	(542811, 129, '2014-02-15 00:46:54.000000', 'consum', 0.0234, 'lps'),
	(542812, 129, '2014-02-15 00:46:55.000000', 'consum', 0.0213, 'lps'),
	(542813, 129, '2014-02-15 00:46:56.000000', 'consum', 0.0226, 'lps'),
	(542814, 129, '2014-02-15 00:46:57.000000', 'consum', 0.0230, 'lps'),
	(542815, 129, '2014-02-15 00:46:58.000000', 'consum', 0.0215, 'lps'),
	(542816, 129, '2014-02-15 00:46:59.000000', 'consum', 0.0223, 'lps'),
	(542817, 129, '2014-02-15 00:47:00.000000', 'consum', 0.0211, 'lps'),
	(542818, 129, '2014-02-15 00:47:01.000000', 'consum', 0.0227, 'lps'),
	(542819, 129, '2014-02-15 00:47:02.000000', 'consum', 0.0218, 'lps'),
	(542820, 129, '2014-02-15 00:47:03.000000', 'consum', 0.0226, 'lps'),
	(542821, 129, '2014-02-15 00:47:04.000000', 'consum', 0.0216, 'lps'),
	(542822, 129, '2014-02-15 00:47:05.000000', 'consum', 0.0216, 'lps'),
	(542823, 129, '2014-02-15 00:47:06.000000', 'consum', 0.0225, 'lps'),
	(542824, 129, '2014-02-15 00:47:07.000000', 'consum', 0.0216, 'lps'),
	(542825, 129, '2014-02-15 00:47:08.000000', 'consum', 0.0221, 'lps'),
	(542826, 129, '2014-02-15 00:47:09.000000', 'consum', 0.0223, 'lps'),
	(542827, 129, '2014-02-15 00:47:10.000000', 'consum', 0.0217, 'lps'),
	(542828, 129, '2014-02-15 00:47:11.000000', 'consum', 0.0232, 'lps'),
	(542829, 129, '2014-02-15 00:47:12.000000', 'consum', 0.0225, 'lps'),
	(542830, 129, '2014-02-15 00:47:13.000000', 'consum', 0.0221, 'lps'),
	(542831, 129, '2014-02-15 00:47:14.000000', 'consum', 0.0217, 'lps'),
	(542832, 129, '2014-02-15 00:47:15.000000', 'consum', 0.0214, 'lps'),
	(542833, 129, '2014-02-15 00:47:16.000000', 'consum', 0.0233, 'lps'),
	(542834, 129, '2014-02-15 00:47:17.000000', 'consum', 0.0213, 'lps'),
	(542835, 129, '2014-02-15 00:47:18.000000', 'consum', 0.0231, 'lps'),
	(542836, 129, '2014-02-15 00:47:19.000000', 'consum', 0.0234, 'lps'),
	(542837, 129, '2014-02-15 00:47:20.000000', 'consum', 0.0218, 'lps'),
	(542838, 129, '2014-02-15 00:47:21.000000', 'consum', 0.0229, 'lps'),
	(542839, 129, '2014-02-15 00:47:22.000000', 'consum', 0.0232, 'lps'),
	(542840, 129, '2014-02-15 00:47:23.000000', 'consum', 0.0212, 'lps'),
	(542841, 129, '2014-02-15 00:47:24.000000', 'consum', 0.0229, 'lps'),
	(542842, 129, '2014-02-15 00:47:25.000000', 'consum', 0.0223, 'lps'),
	(542843, 129, '2014-02-15 00:47:26.000000', 'consum', 0.0221, 'lps'),
	(542844, 129, '2014-02-15 00:47:27.000000', 'consum', 0.0225, 'lps'),
	(542845, 129, '2014-02-15 00:47:28.000000', 'consum', 0.0228, 'lps'),
	(542846, 129, '2014-02-15 00:47:29.000000', 'consum', 0.0230, 'lps'),
	(542847, 129, '2014-02-15 00:47:30.000000', 'consum', 0.0232, 'lps'),
	(542848, 129, '2014-02-15 00:47:31.000000', 'consum', 0.0212, 'lps'),
	(542849, 129, '2014-02-15 00:47:32.000000', 'consum', 0.0228, 'lps'),
	(542850, 129, '2014-02-15 00:47:33.000000', 'consum', 0.0221, 'lps'),
	(542851, 129, '2014-02-15 00:47:34.000000', 'consum', 0.0210, 'lps'),
	(542852, 129, '2014-02-15 00:47:35.000000', 'consum', 0.0228, 'lps'),
	(542853, 129, '2014-02-15 00:47:36.000000', 'consum', 0.0227, 'lps'),
	(542854, 129, '2014-02-15 00:47:37.000000', 'consum', 0.0214, 'lps'),
	(542855, 129, '2014-02-15 00:47:38.000000', 'consum', 0.0229, 'lps'),
	(542856, 129, '2014-02-15 00:47:39.000000', 'consum', 0.0219, 'lps'),
	(542857, 129, '2014-02-15 00:47:40.000000', 'consum', 0.0222, 'lps'),
	(542858, 129, '2014-02-15 00:47:41.000000', 'consum', 0.0221, 'lps'),
	(542859, 129, '2014-02-15 00:47:42.000000', 'consum', 0.0230, 'lps'),
	(542860, 129, '2014-02-15 00:47:43.000000', 'consum', 0.0228, 'lps'),
	(542861, 129, '2014-02-15 00:47:44.000000', 'consum', 0.0216, 'lps'),
	(542862, 129, '2014-02-15 00:47:45.000000', 'consum', 0.0234, 'lps'),
	(542863, 129, '2014-02-15 00:47:46.000000', 'consum', 0.0212, 'lps'),
	(542864, 129, '2014-02-15 00:47:47.000000', 'consum', 0.0226, 'lps'),
	(542865, 129, '2014-02-15 00:47:48.000000', 'consum', 0.0233, 'lps'),
	(542866, 129, '2014-02-15 00:47:49.000000', 'consum', 0.0228, 'lps'),
	(542867, 129, '2014-02-15 00:47:50.000000', 'consum', 0.0233, 'lps'),
	(542868, 129, '2014-02-15 00:47:51.000000', 'consum', 0.0222, 'lps'),
	(542869, 129, '2014-02-15 00:47:52.000000', 'consum', 0.0225, 'lps'),
	(542870, 129, '2014-02-15 00:47:53.000000', 'consum', 0.0225, 'lps'),
	(542871, 129, '2014-02-15 00:47:54.000000', 'consum', 0.0216, 'lps'),
	(542872, 129, '2014-02-15 00:47:55.000000', 'consum', 0.0221, 'lps'),
	(542873, 129, '2014-02-15 00:47:56.000000', 'consum', 0.0221, 'lps'),
	(542874, 129, '2014-02-15 00:47:57.000000', 'consum', 0.0232, 'lps'),
	(542875, 129, '2014-02-15 00:47:58.000000', 'consum', 0.0215, 'lps'),
	(542876, 129, '2014-02-15 00:47:59.000000', 'consum', 0.0216, 'lps'),
	(542877, 129, '2014-02-15 00:48:00.000000', 'consum', 0.0229, 'lps'),
	(542878, 129, '2014-02-15 00:48:01.000000', 'consum', 0.0234, 'lps'),
	(542879, 129, '2014-02-15 00:48:02.000000', 'consum', 0.0226, 'lps'),
	(542880, 129, '2014-02-15 00:48:03.000000', 'consum', 0.0219, 'lps'),
	(542881, 129, '2014-02-15 00:48:04.000000', 'consum', 0.0231, 'lps'),
	(542882, 129, '2014-02-15 00:48:05.000000', 'consum', 0.0214, 'lps'),
	(542883, 129, '2014-02-15 00:48:06.000000', 'consum', 0.0218, 'lps'),
	(542884, 129, '2014-02-15 00:48:07.000000', 'consum', 0.0213, 'lps'),
	(542885, 129, '2014-02-15 00:48:08.000000', 'consum', 0.0229, 'lps'),
	(542886, 129, '2014-02-15 00:48:09.000000', 'consum', 0.0218, 'lps'),
	(542887, 129, '2014-02-15 00:48:10.000000', 'consum', 0.0222, 'lps'),
	(542888, 129, '2014-02-15 00:48:11.000000', 'consum', 0.0218, 'lps'),
	(542889, 129, '2014-02-15 00:48:12.000000', 'consum', 0.0218, 'lps'),
	(542890, 129, '2014-02-15 00:48:13.000000', 'consum', 0.0223, 'lps'),
	(542891, 129, '2014-02-15 00:48:14.000000', 'consum', 0.0230, 'lps'),
	(542892, 129, '2014-02-15 00:48:15.000000', 'consum', 0.0219, 'lps'),
	(542893, 129, '2014-02-15 00:48:16.000000', 'consum', 0.0222, 'lps'),
	(542894, 129, '2014-02-15 00:48:17.000000', 'consum', 0.0218, 'lps'),
	(542895, 129, '2014-02-15 00:48:18.000000', 'consum', 0.0213, 'lps'),
	(542896, 129, '2014-02-15 00:48:19.000000', 'consum', 0.0228, 'lps'),
	(542897, 129, '2014-02-15 00:48:20.000000', 'consum', 0.0218, 'lps'),
	(542898, 129, '2014-02-15 00:48:21.000000', 'consum', 0.0221, 'lps'),
	(542899, 129, '2014-02-15 00:48:22.000000', 'consum', 0.0215, 'lps'),
	(542900, 129, '2014-02-15 00:48:23.000000', 'consum', 0.0226, 'lps'),
	(542901, 129, '2014-02-15 00:48:24.000000', 'consum', 0.0229, 'lps'),
	(542902, 129, '2014-02-15 00:48:25.000000', 'consum', 0.0231, 'lps'),
	(542903, 129, '2014-02-15 00:48:26.000000', 'consum', 0.0210, 'lps'),
	(542904, 129, '2014-02-15 00:48:27.000000', 'consum', 0.0223, 'lps'),
	(542905, 129, '2014-02-15 00:48:28.000000', 'consum', 0.0226, 'lps'),
	(542906, 129, '2014-02-15 00:48:29.000000', 'consum', 0.0227, 'lps'),
	(542907, 129, '2014-02-15 00:48:30.000000', 'consum', 0.0223, 'lps'),
	(542908, 129, '2014-02-15 00:48:31.000000', 'consum', 0.0222, 'lps'),
	(542909, 129, '2014-02-15 00:48:32.000000', 'consum', 0.0232, 'lps'),
	(542910, 129, '2014-02-15 00:48:33.000000', 'consum', 0.0212, 'lps'),
	(542911, 129, '2014-02-15 00:48:34.000000', 'consum', 0.0228, 'lps'),
	(542912, 129, '2014-02-15 00:48:35.000000', 'consum', 0.0218, 'lps'),
	(542913, 129, '2014-02-15 00:48:36.000000', 'consum', 0.0222, 'lps'),
	(542914, 129, '2014-02-15 00:48:37.000000', 'consum', 0.0223, 'lps'),
	(542915, 129, '2014-02-15 00:48:38.000000', 'consum', 0.0214, 'lps'),
	(542916, 129, '2014-02-15 00:48:39.000000', 'consum', 0.0215, 'lps'),
	(542917, 129, '2014-02-15 00:48:40.000000', 'consum', 0.0225, 'lps'),
	(542918, 129, '2014-02-15 00:48:41.000000', 'consum', 0.0220, 'lps'),
	(542919, 129, '2014-02-15 00:48:42.000000', 'consum', 0.0216, 'lps'),
	(542920, 129, '2014-02-15 00:48:43.000000', 'consum', 0.0212, 'lps'),
	(542921, 129, '2014-02-15 00:48:44.000000', 'consum', 0.0225, 'lps'),
	(542922, 129, '2014-02-15 00:48:45.000000', 'consum', 0.0229, 'lps'),
	(542923, 129, '2014-02-15 00:48:46.000000', 'consum', 0.0213, 'lps'),
	(542924, 129, '2014-02-15 00:48:47.000000', 'consum', 0.0219, 'lps'),
	(542925, 129, '2014-02-15 00:48:48.000000', 'consum', 0.0222, 'lps'),
	(542926, 129, '2014-02-15 00:48:49.000000', 'consum', 0.0216, 'lps'),
	(542927, 129, '2014-02-15 00:48:50.000000', 'consum', 0.0230, 'lps'),
	(542928, 129, '2014-02-15 00:48:51.000000', 'consum', 0.0216, 'lps'),
	(542929, 129, '2014-02-15 00:48:52.000000', 'consum', 0.0231, 'lps'),
	(542930, 129, '2014-02-15 00:48:53.000000', 'consum', 0.0224, 'lps'),
	(542931, 129, '2014-02-15 00:48:54.000000', 'consum', 0.0218, 'lps'),
	(542932, 129, '2014-02-15 00:48:55.000000', 'consum', 0.0210, 'lps'),
	(542933, 129, '2014-02-15 00:48:56.000000', 'consum', 0.0233, 'lps'),
	(542934, 129, '2014-02-15 00:48:57.000000', 'consum', 0.0226, 'lps'),
	(542935, 129, '2014-02-15 00:48:58.000000', 'consum', 0.0221, 'lps'),
	(542936, 129, '2014-02-15 00:48:59.000000', 'consum', 0.0220, 'lps'),
	(542937, 129, '2014-02-15 00:49:00.000000', 'consum', 0.0226, 'lps'),
	(542938, 129, '2014-02-15 00:49:01.000000', 'consum', 0.0213, 'lps'),
	(542939, 129, '2014-02-15 00:49:02.000000', 'consum', 0.0225, 'lps'),
	(542940, 129, '2014-02-15 00:49:03.000000', 'consum', 0.0225, 'lps'),
	(542941, 129, '2014-02-15 00:49:04.000000', 'consum', 0.0218, 'lps'),
	(542942, 129, '2014-02-15 00:49:05.000000', 'consum', 0.0230, 'lps'),
	(542943, 129, '2014-02-15 00:49:06.000000', 'consum', 0.0211, 'lps'),
	(542944, 129, '2014-02-15 00:49:07.000000', 'consum', 0.0230, 'lps'),
	(542945, 129, '2014-02-15 00:49:08.000000', 'consum', 0.0210, 'lps'),
	(542946, 129, '2014-02-15 00:49:09.000000', 'consum', 0.0224, 'lps'),
	(542947, 129, '2014-02-15 00:49:10.000000', 'consum', 0.0229, 'lps'),
	(542948, 129, '2014-02-15 00:49:11.000000', 'consum', 0.0216, 'lps'),
	(542949, 129, '2014-02-15 00:49:12.000000', 'consum', 0.0232, 'lps'),
	(542950, 129, '2014-02-15 00:49:13.000000', 'consum', 0.0228, 'lps'),
	(542951, 129, '2014-02-15 00:49:14.000000', 'consum', 0.0233, 'lps'),
	(542952, 129, '2014-02-15 00:49:15.000000', 'consum', 0.0224, 'lps'),
	(542953, 129, '2014-02-15 00:49:16.000000', 'consum', 0.0234, 'lps'),
	(542954, 129, '2014-02-15 00:49:17.000000', 'consum', 0.0213, 'lps'),
	(542955, 129, '2014-02-15 00:49:18.000000', 'consum', 0.0228, 'lps'),
	(542956, 129, '2014-02-15 00:49:19.000000', 'consum', 0.0217, 'lps'),
	(542957, 129, '2014-02-15 00:49:20.000000', 'consum', 0.0217, 'lps'),
	(542958, 129, '2014-02-15 00:49:21.000000', 'consum', 0.0224, 'lps'),
	(542959, 129, '2014-02-15 00:49:22.000000', 'consum', 0.0211, 'lps'),
	(542960, 129, '2014-02-15 00:49:23.000000', 'consum', 0.0225, 'lps'),
	(542961, 129, '2014-02-15 00:49:24.000000', 'consum', 0.0229, 'lps'),
	(542962, 129, '2014-02-15 00:49:25.000000', 'consum', 0.0212, 'lps'),
	(542963, 129, '2014-02-15 00:49:26.000000', 'consum', 0.0213, 'lps'),
	(542964, 129, '2014-02-15 00:49:27.000000', 'consum', 0.0220, 'lps'),
	(542965, 129, '2014-02-15 00:49:28.000000', 'consum', 0.0228, 'lps'),
	(542966, 129, '2014-02-15 00:49:29.000000', 'consum', 0.0219, 'lps'),
	(542967, 129, '2014-02-15 00:49:30.000000', 'consum', 0.0226, 'lps'),
	(542968, 129, '2014-02-15 00:49:31.000000', 'consum', 0.0213, 'lps'),
	(542969, 129, '2014-02-15 00:49:32.000000', 'consum', 0.0227, 'lps'),
	(542970, 129, '2014-02-15 00:49:33.000000', 'consum', 0.0211, 'lps'),
	(542971, 129, '2014-02-15 00:49:34.000000', 'consum', 0.0215, 'lps'),
	(542972, 129, '2014-02-15 00:49:35.000000', 'consum', 0.0210, 'lps'),
	(542973, 129, '2014-02-15 00:49:36.000000', 'consum', 0.0217, 'lps'),
	(542974, 129, '2014-02-15 00:49:37.000000', 'consum', 0.0222, 'lps'),
	(542975, 129, '2014-02-15 00:49:38.000000', 'consum', 0.0225, 'lps'),
	(542976, 129, '2014-02-15 00:49:39.000000', 'consum', 0.0222, 'lps'),
	(542977, 129, '2014-02-15 00:49:40.000000', 'consum', 0.0229, 'lps'),
	(542978, 129, '2014-02-15 00:49:41.000000', 'consum', 0.0216, 'lps'),
	(542979, 129, '2014-02-15 00:49:42.000000', 'consum', 0.0212, 'lps'),
	(542980, 129, '2014-02-15 00:49:43.000000', 'consum', 0.0226, 'lps'),
	(542981, 129, '2014-02-15 00:49:44.000000', 'consum', 0.0234, 'lps'),
	(542982, 129, '2014-02-15 00:49:45.000000', 'consum', 0.0233, 'lps'),
	(542983, 129, '2014-02-15 00:49:46.000000', 'consum', 0.0229, 'lps'),
	(542984, 129, '2014-02-15 00:49:47.000000', 'consum', 0.0213, 'lps'),
	(542985, 129, '2014-02-15 00:49:48.000000', 'consum', 0.0216, 'lps'),
	(542986, 129, '2014-02-15 00:49:49.000000', 'consum', 0.0230, 'lps'),
	(542987, 129, '2014-02-15 00:49:50.000000', 'consum', 0.0221, 'lps'),
	(542988, 129, '2014-02-15 00:49:51.000000', 'consum', 0.0230, 'lps'),
	(542989, 129, '2014-02-15 00:49:52.000000', 'consum', 0.0228, 'lps'),
	(542990, 129, '2014-02-15 00:49:53.000000', 'consum', 0.0216, 'lps'),
	(542991, 129, '2014-02-15 00:49:54.000000', 'consum', 0.0234, 'lps'),
	(542992, 129, '2014-02-15 00:49:55.000000', 'consum', 0.0215, 'lps'),
	(542993, 129, '2014-02-15 00:49:56.000000', 'consum', 0.0212, 'lps'),
	(542994, 129, '2014-02-15 00:49:57.000000', 'consum', 0.0231, 'lps'),
	(542995, 129, '2014-02-15 00:49:58.000000', 'consum', 0.0234, 'lps'),
	(542996, 129, '2014-02-15 00:49:59.000000', 'consum', 0.0217, 'lps'),
	(542997, 129, '2014-02-15 00:50:00.000000', 'consum', 0.0223, 'lps'),
	(542998, 129, '2014-02-15 00:50:01.000000', 'consum', 0.0232, 'lps'),
	(542999, 129, '2014-02-15 00:50:02.000000', 'consum', 0.0230, 'lps'),
	(543000, 129, '2014-02-15 00:50:03.000000', 'consum', 0.0220, 'lps'),
	(543001, 129, '2014-02-15 00:50:04.000000', 'consum', 0.0225, 'lps'),
	(543002, 129, '2014-02-15 00:50:05.000000', 'consum', 0.0231, 'lps'),
	(543003, 129, '2014-02-15 00:50:06.000000', 'consum', 0.0222, 'lps'),
	(543004, 129, '2014-02-15 00:50:07.000000', 'consum', 0.0229, 'lps'),
	(543005, 129, '2014-02-15 00:50:08.000000', 'consum', 0.0222, 'lps'),
	(543006, 129, '2014-02-15 00:50:09.000000', 'consum', 0.0214, 'lps'),
	(543007, 129, '2014-02-15 00:50:10.000000', 'consum', 0.0218, 'lps'),
	(543008, 129, '2014-02-15 00:50:11.000000', 'consum', 0.0213, 'lps'),
	(543009, 129, '2014-02-15 00:50:12.000000', 'consum', 0.0226, 'lps'),
	(543010, 129, '2014-02-15 00:50:13.000000', 'consum', 0.0231, 'lps'),
	(543011, 129, '2014-02-15 00:50:14.000000', 'consum', 0.0220, 'lps'),
	(543012, 129, '2014-02-15 00:50:15.000000', 'consum', 0.0220, 'lps'),
	(543013, 129, '2014-02-15 00:50:16.000000', 'consum', 0.0230, 'lps'),
	(543014, 129, '2014-02-15 00:50:17.000000', 'consum', 0.0231, 'lps'),
	(543015, 129, '2014-02-15 00:50:18.000000', 'consum', 0.0229, 'lps'),
	(543016, 129, '2014-02-15 00:50:19.000000', 'consum', 0.0220, 'lps'),
	(543017, 129, '2014-02-15 00:50:20.000000', 'consum', 0.0230, 'lps'),
	(543018, 129, '2014-02-15 00:50:21.000000', 'consum', 0.0228, 'lps'),
	(543019, 129, '2014-02-15 00:50:22.000000', 'consum', 0.0216, 'lps'),
	(543020, 129, '2014-02-15 00:50:23.000000', 'consum', 0.0212, 'lps'),
	(543021, 129, '2014-02-15 00:50:24.000000', 'consum', 0.0227, 'lps'),
	(543022, 129, '2014-02-15 00:50:25.000000', 'consum', 0.0216, 'lps'),
	(543023, 129, '2014-02-15 00:50:26.000000', 'consum', 0.0212, 'lps'),
	(543024, 129, '2014-02-15 00:50:27.000000', 'consum', 0.0228, 'lps'),
	(543025, 129, '2014-02-15 00:50:28.000000', 'consum', 0.0220, 'lps'),
	(543026, 129, '2014-02-15 00:50:29.000000', 'consum', 0.0232, 'lps'),
	(543027, 129, '2014-02-15 00:50:30.000000', 'consum', 0.0217, 'lps'),
	(543028, 129, '2014-02-15 00:50:31.000000', 'consum', 0.0227, 'lps'),
	(543029, 129, '2014-02-15 00:50:32.000000', 'consum', 0.0223, 'lps'),
	(543030, 129, '2014-02-15 00:50:33.000000', 'consum', 0.0227, 'lps'),
	(543031, 129, '2014-02-15 00:50:34.000000', 'consum', 0.0231, 'lps'),
	(543032, 129, '2014-02-15 00:50:35.000000', 'consum', 0.0213, 'lps'),
	(543033, 129, '2014-02-15 00:50:36.000000', 'consum', 0.0212, 'lps'),
	(543034, 129, '2014-02-15 00:50:37.000000', 'consum', 0.0213, 'lps'),
	(543035, 129, '2014-02-15 00:50:38.000000', 'consum', 0.0221, 'lps'),
	(543036, 129, '2014-02-15 00:50:39.000000', 'consum', 0.0230, 'lps'),
	(543037, 129, '2014-02-15 00:50:40.000000', 'consum', 0.0229, 'lps'),
	(543038, 129, '2014-02-15 00:50:41.000000', 'consum', 0.0220, 'lps'),
	(543039, 129, '2014-02-15 00:50:42.000000', 'consum', 0.0226, 'lps'),
	(543040, 129, '2014-02-15 00:50:43.000000', 'consum', 0.0213, 'lps'),
	(543041, 129, '2014-02-15 00:50:44.000000', 'consum', 0.0227, 'lps'),
	(543042, 129, '2014-02-15 00:50:45.000000', 'consum', 0.0210, 'lps'),
	(543043, 129, '2014-02-15 00:50:46.000000', 'consum', 0.0233, 'lps'),
	(543044, 129, '2014-02-15 00:50:47.000000', 'consum', 0.0229, 'lps'),
	(543045, 129, '2014-02-15 00:50:48.000000', 'consum', 0.0211, 'lps'),
	(543046, 129, '2014-02-15 00:50:49.000000', 'consum', 0.0233, 'lps'),
	(543047, 129, '2014-02-15 00:50:50.000000', 'consum', 0.0222, 'lps'),
	(543048, 129, '2014-02-15 00:50:51.000000', 'consum', 0.0228, 'lps'),
	(543049, 129, '2014-02-15 00:50:52.000000', 'consum', 0.0212, 'lps'),
	(543050, 129, '2014-02-15 00:50:53.000000', 'consum', 0.0217, 'lps'),
	(543051, 129, '2014-02-15 00:50:54.000000', 'consum', 0.0213, 'lps'),
	(543052, 129, '2014-02-15 00:50:55.000000', 'consum', 0.0233, 'lps'),
	(543053, 129, '2014-02-15 00:50:56.000000', 'consum', 0.0215, 'lps'),
	(543054, 129, '2014-02-15 00:50:57.000000', 'consum', 0.0215, 'lps'),
	(543055, 129, '2014-02-15 00:50:58.000000', 'consum', 0.0224, 'lps'),
	(543056, 129, '2014-02-15 00:50:59.000000', 'consum', 0.0212, 'lps'),
	(543057, 129, '2014-02-15 00:51:00.000000', 'consum', 0.0231, 'lps'),
	(543058, 129, '2014-02-15 00:51:01.000000', 'consum', 0.0210, 'lps'),
	(543059, 129, '2014-02-15 00:51:02.000000', 'consum', 0.0221, 'lps'),
	(543060, 129, '2014-02-15 00:51:03.000000', 'consum', 0.0214, 'lps'),
	(543061, 129, '2014-02-15 00:51:04.000000', 'consum', 0.0224, 'lps'),
	(543062, 129, '2014-02-15 00:51:05.000000', 'consum', 0.0218, 'lps'),
	(543063, 129, '2014-02-15 00:51:06.000000', 'consum', 0.0234, 'lps'),
	(543064, 129, '2014-02-15 00:51:07.000000', 'consum', 0.0233, 'lps'),
	(543065, 129, '2014-02-15 00:51:08.000000', 'consum', 0.0227, 'lps'),
	(543066, 129, '2014-02-15 00:51:09.000000', 'consum', 0.0229, 'lps'),
	(543067, 129, '2014-02-15 00:51:10.000000', 'consum', 0.0227, 'lps'),
	(543068, 129, '2014-02-15 00:51:11.000000', 'consum', 0.0214, 'lps'),
	(543069, 129, '2014-02-15 00:51:12.000000', 'consum', 0.0230, 'lps'),
	(543070, 129, '2014-02-15 00:51:13.000000', 'consum', 0.0223, 'lps'),
	(543071, 129, '2014-02-15 00:51:14.000000', 'consum', 0.0216, 'lps'),
	(543072, 129, '2014-02-15 00:51:15.000000', 'consum', 0.0227, 'lps'),
	(543073, 129, '2014-02-15 00:51:16.000000', 'consum', 0.0227, 'lps'),
	(543074, 129, '2014-02-15 00:51:17.000000', 'consum', 0.0219, 'lps'),
	(543075, 129, '2014-02-15 00:51:18.000000', 'consum', 0.0230, 'lps'),
	(543076, 129, '2014-02-15 00:51:19.000000', 'consum', 0.0210, 'lps'),
	(543077, 129, '2014-02-15 00:51:20.000000', 'consum', 0.0225, 'lps'),
	(543078, 129, '2014-02-15 00:51:21.000000', 'consum', 0.0234, 'lps'),
	(543079, 129, '2014-02-15 00:51:22.000000', 'consum', 0.0212, 'lps'),
	(543080, 129, '2014-02-15 00:51:23.000000', 'consum', 0.0225, 'lps'),
	(543081, 129, '2014-02-15 00:51:24.000000', 'consum', 0.0228, 'lps'),
	(543082, 129, '2014-02-15 00:51:25.000000', 'consum', 0.0228, 'lps'),
	(543083, 129, '2014-02-15 00:51:26.000000', 'consum', 0.0225, 'lps'),
	(543084, 129, '2014-02-15 00:51:27.000000', 'consum', 0.0232, 'lps'),
	(543085, 129, '2014-02-15 00:51:28.000000', 'consum', 0.0224, 'lps'),
	(543086, 129, '2014-02-15 00:51:29.000000', 'consum', 0.0214, 'lps'),
	(543087, 129, '2014-02-15 00:51:30.000000', 'consum', 0.0216, 'lps'),
	(543088, 129, '2014-02-15 00:51:31.000000', 'consum', 0.0226, 'lps'),
	(543089, 129, '2014-02-15 00:51:32.000000', 'consum', 0.0221, 'lps'),
	(543090, 129, '2014-02-15 00:51:33.000000', 'consum', 0.0221, 'lps'),
	(543091, 129, '2014-02-15 00:51:34.000000', 'consum', 0.0232, 'lps'),
	(543092, 129, '2014-02-15 00:51:35.000000', 'consum', 0.0212, 'lps'),
	(543093, 129, '2014-02-15 00:51:36.000000', 'consum', 0.0232, 'lps'),
	(543094, 129, '2014-02-15 00:51:37.000000', 'consum', 0.0211, 'lps'),
	(543095, 129, '2014-02-15 00:51:38.000000', 'consum', 0.0226, 'lps'),
	(543096, 129, '2014-02-15 00:51:39.000000', 'consum', 0.0210, 'lps'),
	(543097, 129, '2014-02-15 00:51:40.000000', 'consum', 0.0216, 'lps'),
	(543098, 129, '2014-02-15 00:51:41.000000', 'consum', 0.0212, 'lps'),
	(543099, 129, '2014-02-15 00:51:42.000000', 'consum', 0.0230, 'lps'),
	(543100, 129, '2014-02-15 00:51:43.000000', 'consum', 0.0227, 'lps'),
	(543101, 129, '2014-02-15 00:51:44.000000', 'consum', 0.0211, 'lps'),
	(543102, 129, '2014-02-15 00:51:45.000000', 'consum', 0.0214, 'lps'),
	(543103, 129, '2014-02-15 00:51:46.000000', 'consum', 0.0230, 'lps'),
	(543104, 129, '2014-02-15 00:51:47.000000', 'consum', 0.0223, 'lps'),
	(543105, 129, '2014-02-15 00:51:48.000000', 'consum', 0.0214, 'lps'),
	(543106, 129, '2014-02-15 00:51:49.000000', 'consum', 0.0216, 'lps'),
	(543107, 129, '2014-02-15 00:51:50.000000', 'consum', 0.0230, 'lps'),
	(543108, 129, '2014-02-15 00:51:51.000000', 'consum', 0.0216, 'lps'),
	(543109, 129, '2014-02-15 00:51:52.000000', 'consum', 0.0232, 'lps'),
	(543110, 129, '2014-02-15 00:51:53.000000', 'consum', 0.0226, 'lps'),
	(543111, 129, '2014-02-15 00:51:54.000000', 'consum', 0.0223, 'lps'),
	(543112, 129, '2014-02-15 00:51:55.000000', 'consum', 0.0230, 'lps'),
	(543113, 129, '2014-02-15 00:51:56.000000', 'consum', 0.0222, 'lps'),
	(543114, 129, '2014-02-15 00:51:57.000000', 'consum', 0.0211, 'lps'),
	(543115, 129, '2014-02-15 00:51:58.000000', 'consum', 0.0228, 'lps'),
	(543116, 129, '2014-02-15 00:51:59.000000', 'consum', 0.0221, 'lps'),
	(543117, 129, '2014-02-15 00:52:00.000000', 'consum', 0.0213, 'lps'),
	(543118, 129, '2014-02-15 00:52:01.000000', 'consum', 0.0219, 'lps'),
	(543119, 129, '2014-02-15 00:52:02.000000', 'consum', 0.0222, 'lps'),
	(543120, 129, '2014-02-15 00:52:03.000000', 'consum', 0.0219, 'lps'),
	(543121, 129, '2014-02-15 00:52:04.000000', 'consum', 0.0216, 'lps'),
	(543122, 129, '2014-02-15 00:52:05.000000', 'consum', 0.0217, 'lps'),
	(543123, 129, '2014-02-15 00:52:06.000000', 'consum', 0.0226, 'lps'),
	(543124, 129, '2014-02-15 00:52:07.000000', 'consum', 0.0220, 'lps'),
	(543125, 129, '2014-02-15 00:52:08.000000', 'consum', 0.0214, 'lps'),
	(543126, 129, '2014-02-15 00:52:09.000000', 'consum', 0.0224, 'lps'),
	(543127, 129, '2014-02-15 00:52:10.000000', 'consum', 0.0218, 'lps'),
	(543128, 129, '2014-02-15 00:52:11.000000', 'consum', 0.0210, 'lps'),
	(543129, 129, '2014-02-15 00:52:12.000000', 'consum', 0.0234, 'lps'),
	(543130, 129, '2014-02-15 00:52:13.000000', 'consum', 0.0233, 'lps'),
	(543131, 129, '2014-02-15 00:52:14.000000', 'consum', 0.0227, 'lps'),
	(543132, 129, '2014-02-15 00:52:15.000000', 'consum', 0.0225, 'lps'),
	(543133, 129, '2014-02-15 00:52:16.000000', 'consum', 0.0210, 'lps'),
	(543134, 129, '2014-02-15 00:52:17.000000', 'consum', 0.0218, 'lps'),
	(543135, 129, '2014-02-15 00:52:18.000000', 'consum', 0.0223, 'lps'),
	(543136, 129, '2014-02-15 00:52:19.000000', 'consum', 0.0228, 'lps'),
	(543137, 129, '2014-02-15 00:52:20.000000', 'consum', 0.0211, 'lps'),
	(543138, 129, '2014-02-15 00:52:21.000000', 'consum', 0.0211, 'lps'),
	(543139, 129, '2014-02-15 00:52:22.000000', 'consum', 0.0212, 'lps'),
	(543140, 129, '2014-02-15 00:52:23.000000', 'consum', 0.0219, 'lps'),
	(543141, 129, '2014-02-15 00:52:24.000000', 'consum', 0.0224, 'lps'),
	(543142, 129, '2014-02-15 00:52:25.000000', 'consum', 0.0228, 'lps'),
	(543143, 129, '2014-02-15 00:52:26.000000', 'consum', 0.0211, 'lps'),
	(543144, 129, '2014-02-15 00:52:27.000000', 'consum', 0.0234, 'lps'),
	(543145, 129, '2014-02-15 00:52:28.000000', 'consum', 0.0229, 'lps'),
	(543146, 129, '2014-02-15 00:52:29.000000', 'consum', 0.0234, 'lps'),
	(543147, 129, '2014-02-15 00:52:30.000000', 'consum', 0.0221, 'lps'),
	(543148, 129, '2014-02-15 00:52:31.000000', 'consum', 0.0218, 'lps'),
	(543149, 129, '2014-02-15 00:52:32.000000', 'consum', 0.0221, 'lps'),
	(543150, 129, '2014-02-15 00:52:33.000000', 'consum', 0.0213, 'lps'),
	(543151, 129, '2014-02-15 00:52:34.000000', 'consum', 0.0218, 'lps'),
	(543152, 129, '2014-02-15 00:52:35.000000', 'consum', 0.0219, 'lps'),
	(543153, 129, '2014-02-15 00:52:36.000000', 'consum', 0.0229, 'lps'),
	(543154, 129, '2014-02-15 00:52:37.000000', 'consum', 0.0231, 'lps'),
	(543155, 129, '2014-02-15 00:52:38.000000', 'consum', 0.0234, 'lps'),
	(543156, 129, '2014-02-15 00:52:39.000000', 'consum', 0.0215, 'lps'),
	(543157, 129, '2014-02-15 00:52:40.000000', 'consum', 0.0214, 'lps'),
	(543158, 129, '2014-02-15 00:52:41.000000', 'consum', 0.0217, 'lps'),
	(543159, 129, '2014-02-15 00:52:42.000000', 'consum', 0.0210, 'lps'),
	(543160, 129, '2014-02-15 00:52:43.000000', 'consum', 0.0211, 'lps'),
	(543161, 129, '2014-02-15 00:52:44.000000', 'consum', 0.0216, 'lps'),
	(543162, 129, '2014-02-15 00:52:45.000000', 'consum', 0.0215, 'lps'),
	(543163, 129, '2014-02-15 00:52:46.000000', 'consum', 0.0214, 'lps'),
	(543164, 129, '2014-02-15 00:52:47.000000', 'consum', 0.0218, 'lps'),
	(543165, 129, '2014-02-15 00:52:48.000000', 'consum', 0.0211, 'lps'),
	(543166, 129, '2014-02-15 00:52:49.000000', 'consum', 0.0218, 'lps'),
	(543167, 129, '2014-02-15 00:52:50.000000', 'consum', 0.0224, 'lps'),
	(543168, 129, '2014-02-15 00:52:51.000000', 'consum', 0.0228, 'lps'),
	(543169, 129, '2014-02-15 00:52:52.000000', 'consum', 0.0211, 'lps'),
	(543170, 129, '2014-02-15 00:52:53.000000', 'consum', 0.0213, 'lps'),
	(543171, 129, '2014-02-15 00:52:54.000000', 'consum', 0.0220, 'lps'),
	(543172, 129, '2014-02-15 00:52:55.000000', 'consum', 0.0227, 'lps'),
	(543173, 129, '2014-02-15 00:52:56.000000', 'consum', 0.0215, 'lps'),
	(543174, 129, '2014-02-15 00:52:57.000000', 'consum', 0.0211, 'lps'),
	(543175, 129, '2014-02-15 00:52:58.000000', 'consum', 0.0224, 'lps'),
	(543176, 129, '2014-02-15 00:52:59.000000', 'consum', 0.0228, 'lps'),
	(543177, 129, '2014-02-15 00:53:00.000000', 'consum', 0.0210, 'lps'),
	(543178, 129, '2014-02-15 00:53:01.000000', 'consum', 0.0230, 'lps'),
	(543179, 129, '2014-02-15 00:53:02.000000', 'consum', 0.0210, 'lps'),
	(543180, 129, '2014-02-15 00:53:03.000000', 'consum', 0.0226, 'lps'),
	(543181, 129, '2014-02-15 00:53:04.000000', 'consum', 0.0216, 'lps'),
	(543182, 129, '2014-02-15 00:53:05.000000', 'consum', 0.0216, 'lps'),
	(543183, 129, '2014-02-15 00:53:06.000000', 'consum', 0.0221, 'lps'),
	(543184, 129, '2014-02-15 00:53:07.000000', 'consum', 0.0225, 'lps'),
	(543185, 129, '2014-02-15 00:53:08.000000', 'consum', 0.0228, 'lps'),
	(543186, 129, '2014-02-15 00:53:09.000000', 'consum', 0.0229, 'lps'),
	(543187, 129, '2014-02-15 00:53:10.000000', 'consum', 0.0225, 'lps'),
	(543188, 129, '2014-02-15 00:53:11.000000', 'consum', 0.0232, 'lps'),
	(543189, 129, '2014-02-15 00:53:12.000000', 'consum', 0.0223, 'lps'),
	(543190, 129, '2014-02-15 00:53:13.000000', 'consum', 0.0211, 'lps'),
	(543191, 129, '2014-02-15 00:53:14.000000', 'consum', 0.0227, 'lps'),
	(543192, 129, '2014-02-15 00:53:15.000000', 'consum', 0.0216, 'lps'),
	(543193, 129, '2014-02-15 00:53:16.000000', 'consum', 0.0214, 'lps'),
	(543194, 129, '2014-02-15 00:53:17.000000', 'consum', 0.0212, 'lps'),
	(543195, 129, '2014-02-15 00:53:18.000000', 'consum', 0.0210, 'lps'),
	(543196, 129, '2014-02-15 00:53:19.000000', 'consum', 0.0228, 'lps'),
	(543197, 129, '2014-02-15 00:53:20.000000', 'consum', 0.0225, 'lps'),
	(543198, 129, '2014-02-15 00:53:21.000000', 'consum', 0.0231, 'lps'),
	(543199, 129, '2014-02-15 00:53:22.000000', 'consum', 0.0219, 'lps'),
	(543200, 129, '2014-02-15 00:53:23.000000', 'consum', 0.0221, 'lps'),
	(543201, 129, '2014-02-15 00:53:24.000000', 'consum', 0.0210, 'lps'),
	(543202, 129, '2014-02-15 00:53:25.000000', 'consum', 0.0231, 'lps'),
	(543203, 129, '2014-02-15 00:53:26.000000', 'consum', 0.0212, 'lps'),
	(543204, 129, '2014-02-15 00:53:27.000000', 'consum', 0.0234, 'lps'),
	(543205, 129, '2014-02-15 00:53:28.000000', 'consum', 0.0226, 'lps'),
	(543206, 129, '2014-02-15 00:53:29.000000', 'consum', 0.0216, 'lps'),
	(543207, 129, '2014-02-15 00:53:30.000000', 'consum', 0.0219, 'lps'),
	(543208, 129, '2014-02-15 00:53:31.000000', 'consum', 0.0213, 'lps'),
	(543209, 129, '2014-02-15 00:53:32.000000', 'consum', 0.0221, 'lps'),
	(543210, 129, '2014-02-15 00:53:33.000000', 'consum', 0.0234, 'lps'),
	(543211, 129, '2014-02-15 00:53:34.000000', 'consum', 0.0223, 'lps'),
	(543212, 129, '2014-02-15 00:53:35.000000', 'consum', 0.0230, 'lps'),
	(543213, 129, '2014-02-15 00:53:36.000000', 'consum', 0.0218, 'lps'),
	(543214, 129, '2014-02-15 00:53:37.000000', 'consum', 0.0216, 'lps'),
	(543215, 129, '2014-02-15 00:53:38.000000', 'consum', 0.0216, 'lps'),
	(543216, 129, '2014-02-15 00:53:39.000000', 'consum', 0.0223, 'lps'),
	(543217, 129, '2014-02-15 00:53:40.000000', 'consum', 0.0234, 'lps'),
	(543218, 129, '2014-02-15 00:53:41.000000', 'consum', 0.0217, 'lps'),
	(543219, 129, '2014-02-15 00:53:42.000000', 'consum', 0.0221, 'lps'),
	(543220, 129, '2014-02-15 00:53:43.000000', 'consum', 0.0221, 'lps'),
	(543221, 129, '2014-02-15 00:53:44.000000', 'consum', 0.0231, 'lps'),
	(543222, 129, '2014-02-15 00:53:45.000000', 'consum', 0.0234, 'lps'),
	(543223, 129, '2014-02-15 00:53:46.000000', 'consum', 0.0215, 'lps'),
	(543224, 129, '2014-02-15 00:53:47.000000', 'consum', 0.0216, 'lps'),
	(543225, 129, '2014-02-15 00:53:48.000000', 'consum', 0.0224, 'lps'),
	(543226, 129, '2014-02-15 00:53:49.000000', 'consum', 0.0212, 'lps'),
	(543227, 129, '2014-02-15 00:53:50.000000', 'consum', 0.0230, 'lps'),
	(543228, 129, '2014-02-15 00:53:51.000000', 'consum', 0.0229, 'lps'),
	(543229, 129, '2014-02-15 00:53:52.000000', 'consum', 0.0221, 'lps'),
	(543230, 129, '2014-02-15 00:53:53.000000', 'consum', 0.0233, 'lps'),
	(543231, 129, '2014-02-15 00:53:54.000000', 'consum', 0.0216, 'lps'),
	(543232, 129, '2014-02-15 00:53:55.000000', 'consum', 0.0223, 'lps'),
	(543233, 129, '2014-02-15 00:53:56.000000', 'consum', 0.0234, 'lps'),
	(543234, 129, '2014-02-15 00:53:57.000000', 'consum', 0.0215, 'lps'),
	(543235, 129, '2014-02-15 00:53:58.000000', 'consum', 0.0214, 'lps'),
	(543236, 129, '2014-02-15 00:53:59.000000', 'consum', 0.0214, 'lps'),
	(543237, 129, '2014-02-15 00:54:00.000000', 'consum', 0.0220, 'lps'),
	(543238, 129, '2014-02-15 00:54:01.000000', 'consum', 0.0223, 'lps'),
	(543239, 129, '2014-02-15 00:54:02.000000', 'consum', 0.0219, 'lps'),
	(543240, 129, '2014-02-15 00:54:03.000000', 'consum', 0.0219, 'lps'),
	(543241, 129, '2014-02-15 00:54:04.000000', 'consum', 0.0228, 'lps'),
	(543242, 129, '2014-02-15 00:54:05.000000', 'consum', 0.0223, 'lps'),
	(543243, 129, '2014-02-15 00:54:06.000000', 'consum', 0.0221, 'lps'),
	(543244, 129, '2014-02-15 00:54:07.000000', 'consum', 0.0228, 'lps'),
	(543245, 129, '2014-02-15 00:54:08.000000', 'consum', 0.0219, 'lps'),
	(543246, 129, '2014-02-15 00:54:09.000000', 'consum', 0.0224, 'lps'),
	(543247, 129, '2014-02-15 00:54:10.000000', 'consum', 0.0230, 'lps'),
	(543248, 129, '2014-02-15 00:54:11.000000', 'consum', 0.0218, 'lps'),
	(543249, 129, '2014-02-15 00:54:12.000000', 'consum', 0.0214, 'lps'),
	(543250, 129, '2014-02-15 00:54:13.000000', 'consum', 0.0233, 'lps'),
	(543251, 129, '2014-02-15 00:54:14.000000', 'consum', 0.0214, 'lps'),
	(543252, 129, '2014-02-15 00:54:15.000000', 'consum', 0.0212, 'lps'),
	(543253, 129, '2014-02-15 00:54:16.000000', 'consum', 0.0210, 'lps'),
	(543254, 129, '2014-02-15 00:54:17.000000', 'consum', 0.0226, 'lps'),
	(543255, 129, '2014-02-15 00:54:18.000000', 'consum', 0.0216, 'lps'),
	(543256, 129, '2014-02-15 00:54:19.000000', 'consum', 0.0218, 'lps'),
	(543257, 129, '2014-02-15 00:54:20.000000', 'consum', 0.0234, 'lps'),
	(543258, 129, '2014-02-15 00:54:21.000000', 'consum', 0.0232, 'lps'),
	(543259, 129, '2014-02-15 00:54:22.000000', 'consum', 0.0221, 'lps'),
	(543260, 129, '2014-02-15 00:54:23.000000', 'consum', 0.0227, 'lps'),
	(543261, 129, '2014-02-15 00:54:24.000000', 'consum', 0.0213, 'lps'),
	(543262, 129, '2014-02-15 00:54:25.000000', 'consum', 0.0225, 'lps'),
	(543263, 129, '2014-02-15 00:54:26.000000', 'consum', 0.0227, 'lps'),
	(543264, 129, '2014-02-15 00:54:27.000000', 'consum', 0.0225, 'lps'),
	(543265, 129, '2014-02-15 00:54:28.000000', 'consum', 0.0234, 'lps'),
	(543266, 129, '2014-02-15 00:54:29.000000', 'consum', 0.0212, 'lps'),
	(543267, 129, '2014-02-15 00:54:30.000000', 'consum', 0.0222, 'lps'),
	(543268, 129, '2014-02-15 00:54:31.000000', 'consum', 0.0214, 'lps'),
	(543269, 129, '2014-02-15 00:54:32.000000', 'consum', 0.0222, 'lps'),
	(543270, 129, '2014-02-15 00:54:33.000000', 'consum', 0.0232, 'lps'),
	(543271, 129, '2014-02-15 00:54:34.000000', 'consum', 0.0211, 'lps'),
	(543272, 129, '2014-02-15 00:54:35.000000', 'consum', 0.0223, 'lps'),
	(543273, 129, '2014-02-15 00:54:36.000000', 'consum', 0.0222, 'lps'),
	(543274, 129, '2014-02-15 00:54:37.000000', 'consum', 0.0231, 'lps'),
	(543275, 129, '2014-02-15 00:54:38.000000', 'consum', 0.0231, 'lps'),
	(543276, 129, '2014-02-15 00:54:39.000000', 'consum', 0.0226, 'lps'),
	(543277, 129, '2014-02-15 00:54:40.000000', 'consum', 0.0228, 'lps'),
	(543278, 129, '2014-02-15 00:54:41.000000', 'consum', 0.0227, 'lps'),
	(543279, 129, '2014-02-15 00:54:42.000000', 'consum', 0.0219, 'lps'),
	(543280, 129, '2014-02-15 00:54:43.000000', 'consum', 0.0227, 'lps'),
	(543281, 129, '2014-02-15 00:54:44.000000', 'consum', 0.0221, 'lps'),
	(543282, 129, '2014-02-15 00:54:45.000000', 'consum', 0.0212, 'lps'),
	(543283, 129, '2014-02-15 00:54:46.000000', 'consum', 0.0215, 'lps'),
	(543284, 129, '2014-02-15 00:54:47.000000', 'consum', 0.0228, 'lps'),
	(543285, 129, '2014-02-15 00:54:48.000000', 'consum', 0.0210, 'lps'),
	(543286, 129, '2014-02-15 00:54:49.000000', 'consum', 0.0230, 'lps'),
	(543287, 129, '2014-02-15 00:54:50.000000', 'consum', 0.0213, 'lps'),
	(543288, 129, '2014-02-15 00:54:51.000000', 'consum', 0.0215, 'lps'),
	(543289, 129, '2014-02-15 00:54:52.000000', 'consum', 0.0227, 'lps'),
	(543290, 129, '2014-02-15 00:54:53.000000', 'consum', 0.0229, 'lps'),
	(543291, 129, '2014-02-15 00:54:54.000000', 'consum', 0.0231, 'lps'),
	(543292, 129, '2014-02-15 00:54:55.000000', 'consum', 0.0233, 'lps'),
	(543293, 129, '2014-02-15 00:54:56.000000', 'consum', 0.0212, 'lps'),
	(543294, 129, '2014-02-15 00:54:57.000000', 'consum', 0.0228, 'lps'),
	(543295, 129, '2014-02-15 00:54:58.000000', 'consum', 0.0218, 'lps'),
	(543296, 129, '2014-02-15 00:54:59.000000', 'consum', 0.0223, 'lps'),
	(543297, 129, '2014-02-15 00:55:00.000000', 'consum', 0.0224, 'lps'),
	(543298, 129, '2014-02-15 00:55:01.000000', 'consum', 0.0219, 'lps'),
	(543299, 129, '2014-02-15 00:55:02.000000', 'consum', 0.0213, 'lps'),
	(543300, 129, '2014-02-15 00:55:03.000000', 'consum', 0.0224, 'lps'),
	(543301, 129, '2014-02-15 00:55:04.000000', 'consum', 0.0223, 'lps'),
	(543302, 129, '2014-02-15 00:55:05.000000', 'consum', 0.0232, 'lps'),
	(543303, 129, '2014-02-15 00:55:06.000000', 'consum', 0.0230, 'lps'),
	(543304, 129, '2014-02-15 00:55:07.000000', 'consum', 0.0223, 'lps'),
	(543305, 129, '2014-02-15 00:55:08.000000', 'consum', 0.0212, 'lps'),
	(543306, 129, '2014-02-15 00:55:09.000000', 'consum', 0.0234, 'lps'),
	(543307, 129, '2014-02-15 00:55:10.000000', 'consum', 0.0225, 'lps'),
	(543308, 129, '2014-02-15 00:55:11.000000', 'consum', 0.0213, 'lps'),
	(543309, 129, '2014-02-15 00:55:12.000000', 'consum', 0.0232, 'lps'),
	(543310, 129, '2014-02-15 00:55:13.000000', 'consum', 0.0210, 'lps'),
	(543311, 129, '2014-02-15 00:55:14.000000', 'consum', 0.0221, 'lps'),
	(543312, 129, '2014-02-15 00:55:15.000000', 'consum', 0.0217, 'lps'),
	(543313, 129, '2014-02-15 00:55:16.000000', 'consum', 0.0234, 'lps'),
	(543314, 129, '2014-02-15 00:55:17.000000', 'consum', 0.0210, 'lps'),
	(543315, 129, '2014-02-15 00:55:18.000000', 'consum', 0.0215, 'lps'),
	(543316, 129, '2014-02-15 00:55:19.000000', 'consum', 0.0210, 'lps'),
	(543317, 129, '2014-02-15 00:55:20.000000', 'consum', 0.0220, 'lps'),
	(543318, 129, '2014-02-15 00:55:21.000000', 'consum', 0.0210, 'lps'),
	(543319, 129, '2014-02-15 00:55:22.000000', 'consum', 0.0231, 'lps'),
	(543320, 129, '2014-02-15 00:55:23.000000', 'consum', 0.0216, 'lps'),
	(543321, 129, '2014-02-15 00:55:24.000000', 'consum', 0.0229, 'lps'),
	(543322, 129, '2014-02-15 00:55:25.000000', 'consum', 0.0210, 'lps'),
	(543323, 129, '2014-02-15 00:55:26.000000', 'consum', 0.0230, 'lps'),
	(543324, 129, '2014-02-15 00:55:27.000000', 'consum', 0.0234, 'lps'),
	(543325, 129, '2014-02-15 00:55:28.000000', 'consum', 0.0223, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(543326, 129, '2014-02-15 00:55:29.000000', 'consum', 0.0227, 'lps'),
	(543327, 129, '2014-02-15 00:55:30.000000', 'consum', 0.0233, 'lps'),
	(543328, 129, '2014-02-15 00:55:31.000000', 'consum', 0.0224, 'lps'),
	(543329, 129, '2014-02-15 00:55:32.000000', 'consum', 0.0212, 'lps'),
	(543330, 129, '2014-02-15 00:55:33.000000', 'consum', 0.0227, 'lps'),
	(543331, 129, '2014-02-15 00:55:34.000000', 'consum', 0.0214, 'lps'),
	(543332, 129, '2014-02-15 00:55:35.000000', 'consum', 0.0232, 'lps'),
	(543333, 129, '2014-02-15 00:55:36.000000', 'consum', 0.0233, 'lps'),
	(543334, 129, '2014-02-15 00:55:37.000000', 'consum', 0.0232, 'lps'),
	(543335, 129, '2014-02-15 00:55:38.000000', 'consum', 0.0228, 'lps'),
	(543336, 129, '2014-02-15 00:55:39.000000', 'consum', 0.0233, 'lps'),
	(543337, 129, '2014-02-15 00:55:40.000000', 'consum', 0.0221, 'lps'),
	(543338, 129, '2014-02-15 00:55:41.000000', 'consum', 0.0224, 'lps'),
	(543339, 129, '2014-02-15 00:55:42.000000', 'consum', 0.0220, 'lps'),
	(543340, 129, '2014-02-15 00:55:43.000000', 'consum', 0.0221, 'lps'),
	(543341, 129, '2014-02-15 00:55:44.000000', 'consum', 0.0210, 'lps'),
	(543342, 129, '2014-02-15 00:55:45.000000', 'consum', 0.0229, 'lps'),
	(543343, 129, '2014-02-15 00:55:46.000000', 'consum', 0.0230, 'lps'),
	(543344, 129, '2014-02-15 00:55:47.000000', 'consum', 0.0227, 'lps'),
	(543345, 129, '2014-02-15 00:55:48.000000', 'consum', 0.0234, 'lps'),
	(543346, 129, '2014-02-15 00:55:49.000000', 'consum', 0.0232, 'lps'),
	(543347, 129, '2014-02-15 00:55:50.000000', 'consum', 0.0223, 'lps'),
	(543348, 129, '2014-02-15 00:55:51.000000', 'consum', 0.0210, 'lps'),
	(543349, 129, '2014-02-15 00:55:52.000000', 'consum', 0.0223, 'lps'),
	(543350, 129, '2014-02-15 00:55:53.000000', 'consum', 0.0223, 'lps'),
	(543351, 129, '2014-02-15 00:55:54.000000', 'consum', 0.0213, 'lps'),
	(543352, 129, '2014-02-15 00:55:55.000000', 'consum', 0.0212, 'lps'),
	(543353, 129, '2014-02-15 00:55:56.000000', 'consum', 0.0234, 'lps'),
	(543354, 129, '2014-02-15 00:55:57.000000', 'consum', 0.0226, 'lps'),
	(543355, 129, '2014-02-15 00:55:58.000000', 'consum', 0.0219, 'lps'),
	(543356, 129, '2014-02-15 00:55:59.000000', 'consum', 0.0233, 'lps'),
	(543357, 129, '2014-02-15 00:56:00.000000', 'consum', 0.0223, 'lps'),
	(543358, 129, '2014-02-15 00:56:01.000000', 'consum', 0.0232, 'lps'),
	(543359, 129, '2014-02-15 00:56:02.000000', 'consum', 0.0231, 'lps'),
	(543360, 129, '2014-02-15 00:56:03.000000', 'consum', 0.0222, 'lps'),
	(543361, 129, '2014-02-15 00:56:04.000000', 'consum', 0.0211, 'lps'),
	(543362, 129, '2014-02-15 00:56:05.000000', 'consum', 0.0230, 'lps'),
	(543363, 129, '2014-02-15 00:56:06.000000', 'consum', 0.0230, 'lps'),
	(543364, 129, '2014-02-15 00:56:07.000000', 'consum', 0.0227, 'lps'),
	(543365, 129, '2014-02-15 00:56:08.000000', 'consum', 0.0234, 'lps'),
	(543366, 129, '2014-02-15 00:56:09.000000', 'consum', 0.0228, 'lps'),
	(543367, 129, '2014-02-15 00:56:10.000000', 'consum', 0.0232, 'lps'),
	(543368, 129, '2014-02-15 00:56:11.000000', 'consum', 0.0214, 'lps'),
	(543369, 129, '2014-02-15 00:56:12.000000', 'consum', 0.0213, 'lps'),
	(543370, 129, '2014-02-15 00:56:13.000000', 'consum', 0.0216, 'lps'),
	(543371, 129, '2014-02-15 00:56:14.000000', 'consum', 0.0231, 'lps'),
	(543372, 129, '2014-02-15 00:56:15.000000', 'consum', 0.0223, 'lps'),
	(543373, 129, '2014-02-15 00:56:16.000000', 'consum', 0.0213, 'lps'),
	(543374, 129, '2014-02-15 00:56:17.000000', 'consum', 0.0211, 'lps'),
	(543375, 129, '2014-02-15 00:56:18.000000', 'consum', 0.0231, 'lps'),
	(543376, 129, '2014-02-15 00:56:19.000000', 'consum', 0.0215, 'lps'),
	(543377, 129, '2014-02-15 00:56:20.000000', 'consum', 0.0221, 'lps'),
	(543378, 129, '2014-02-15 00:56:21.000000', 'consum', 0.0224, 'lps'),
	(543379, 129, '2014-02-15 00:56:22.000000', 'consum', 0.0222, 'lps'),
	(543380, 129, '2014-02-15 00:56:23.000000', 'consum', 0.0231, 'lps'),
	(543381, 129, '2014-02-15 00:56:24.000000', 'consum', 0.0227, 'lps'),
	(543382, 129, '2014-02-15 00:56:25.000000', 'consum', 0.0233, 'lps'),
	(543383, 129, '2014-02-15 00:56:26.000000', 'consum', 0.0224, 'lps'),
	(543384, 129, '2014-02-15 00:56:27.000000', 'consum', 0.0213, 'lps'),
	(543385, 129, '2014-02-15 00:56:28.000000', 'consum', 0.0233, 'lps'),
	(543386, 129, '2014-02-15 00:56:29.000000', 'consum', 0.0217, 'lps'),
	(543387, 129, '2014-02-15 00:56:30.000000', 'consum', 0.0224, 'lps'),
	(543388, 129, '2014-02-15 00:56:31.000000', 'consum', 0.0211, 'lps'),
	(543389, 129, '2014-02-15 00:56:32.000000', 'consum', 0.0222, 'lps'),
	(543390, 129, '2014-02-15 00:56:33.000000', 'consum', 0.0220, 'lps'),
	(543391, 129, '2014-02-15 00:56:34.000000', 'consum', 0.0224, 'lps'),
	(543392, 129, '2014-02-15 00:56:35.000000', 'consum', 0.0224, 'lps'),
	(543393, 129, '2014-02-15 00:56:36.000000', 'consum', 0.0215, 'lps'),
	(543394, 129, '2014-02-15 00:56:37.000000', 'consum', 0.0218, 'lps'),
	(543395, 129, '2014-02-15 00:56:38.000000', 'consum', 0.0210, 'lps'),
	(543396, 129, '2014-02-15 00:56:39.000000', 'consum', 0.0212, 'lps'),
	(543397, 129, '2014-02-15 00:56:40.000000', 'consum', 0.0221, 'lps'),
	(543398, 129, '2014-02-15 00:56:41.000000', 'consum', 0.0234, 'lps'),
	(543399, 129, '2014-02-15 00:56:42.000000', 'consum', 0.0222, 'lps'),
	(543400, 129, '2014-02-15 00:56:43.000000', 'consum', 0.0222, 'lps'),
	(543401, 129, '2014-02-15 00:56:44.000000', 'consum', 0.0211, 'lps'),
	(543402, 129, '2014-02-15 00:56:45.000000', 'consum', 0.0229, 'lps'),
	(543403, 129, '2014-02-15 00:56:46.000000', 'consum', 0.0226, 'lps'),
	(543404, 129, '2014-02-15 00:56:47.000000', 'consum', 0.0212, 'lps'),
	(543405, 129, '2014-02-15 00:56:48.000000', 'consum', 0.0219, 'lps'),
	(543406, 129, '2014-02-15 00:56:49.000000', 'consum', 0.0225, 'lps'),
	(543407, 129, '2014-02-15 00:56:50.000000', 'consum', 0.0211, 'lps'),
	(543408, 129, '2014-02-15 00:56:51.000000', 'consum', 0.0220, 'lps'),
	(543409, 129, '2014-02-15 00:56:52.000000', 'consum', 0.0233, 'lps'),
	(543410, 129, '2014-02-15 00:56:53.000000', 'consum', 0.0218, 'lps'),
	(543411, 129, '2014-02-15 00:56:54.000000', 'consum', 0.0232, 'lps'),
	(543412, 129, '2014-02-15 00:56:55.000000', 'consum', 0.0224, 'lps'),
	(543413, 129, '2014-02-15 00:56:56.000000', 'consum', 0.0212, 'lps'),
	(543414, 129, '2014-02-15 00:56:57.000000', 'consum', 0.0229, 'lps'),
	(543415, 129, '2014-02-15 00:56:58.000000', 'consum', 0.0223, 'lps'),
	(543416, 129, '2014-02-15 00:56:59.000000', 'consum', 0.0221, 'lps'),
	(543417, 129, '2014-02-15 00:57:00.000000', 'consum', 0.0227, 'lps'),
	(543418, 129, '2014-02-15 00:57:01.000000', 'consum', 0.0214, 'lps'),
	(543419, 129, '2014-02-15 00:57:02.000000', 'consum', 0.0226, 'lps'),
	(543420, 129, '2014-02-15 00:57:03.000000', 'consum', 0.0229, 'lps'),
	(543421, 129, '2014-02-15 00:57:04.000000', 'consum', 0.0233, 'lps'),
	(543422, 129, '2014-02-15 00:57:05.000000', 'consum', 0.0217, 'lps'),
	(543423, 129, '2014-02-15 00:57:06.000000', 'consum', 0.0230, 'lps'),
	(543424, 129, '2014-02-15 00:57:07.000000', 'consum', 0.0211, 'lps'),
	(543425, 129, '2014-02-15 00:57:08.000000', 'consum', 0.0232, 'lps'),
	(543426, 129, '2014-02-15 00:57:09.000000', 'consum', 0.0218, 'lps'),
	(543427, 129, '2014-02-15 00:57:10.000000', 'consum', 0.0234, 'lps'),
	(543428, 129, '2014-02-15 00:57:11.000000', 'consum', 0.0230, 'lps'),
	(543429, 129, '2014-02-15 00:57:12.000000', 'consum', 0.0213, 'lps'),
	(543430, 129, '2014-02-15 00:57:13.000000', 'consum', 0.0217, 'lps'),
	(543431, 129, '2014-02-15 00:57:14.000000', 'consum', 0.0213, 'lps'),
	(543432, 129, '2014-02-15 00:57:15.000000', 'consum', 0.0229, 'lps'),
	(543433, 129, '2014-02-15 00:57:16.000000', 'consum', 0.0222, 'lps'),
	(543434, 129, '2014-02-15 00:57:17.000000', 'consum', 0.0214, 'lps'),
	(543435, 129, '2014-02-15 00:57:18.000000', 'consum', 0.0218, 'lps'),
	(543436, 129, '2014-02-15 00:57:19.000000', 'consum', 0.0212, 'lps'),
	(543437, 129, '2014-02-15 00:57:20.000000', 'consum', 0.0223, 'lps'),
	(543438, 129, '2014-02-15 00:57:21.000000', 'consum', 0.0219, 'lps'),
	(543439, 129, '2014-02-15 00:57:22.000000', 'consum', 0.0215, 'lps'),
	(543440, 129, '2014-02-15 00:57:23.000000', 'consum', 0.0234, 'lps'),
	(543441, 129, '2014-02-15 00:57:24.000000', 'consum', 0.0215, 'lps'),
	(543442, 129, '2014-02-15 00:57:25.000000', 'consum', 0.0215, 'lps'),
	(543443, 129, '2014-02-15 00:57:26.000000', 'consum', 0.0220, 'lps'),
	(543444, 129, '2014-02-15 00:57:27.000000', 'consum', 0.0221, 'lps'),
	(543445, 129, '2014-02-15 00:57:28.000000', 'consum', 0.0211, 'lps'),
	(543446, 129, '2014-02-15 00:57:29.000000', 'consum', 0.0232, 'lps'),
	(543447, 129, '2014-02-15 00:57:30.000000', 'consum', 0.0216, 'lps'),
	(543448, 129, '2014-02-15 00:57:31.000000', 'consum', 0.0225, 'lps'),
	(543449, 129, '2014-02-15 00:57:32.000000', 'consum', 0.0219, 'lps'),
	(543450, 129, '2014-02-15 00:57:33.000000', 'consum', 0.0211, 'lps'),
	(543451, 129, '2014-02-15 00:57:34.000000', 'consum', 0.0213, 'lps'),
	(543452, 129, '2014-02-15 00:57:35.000000', 'consum', 0.0224, 'lps'),
	(543453, 129, '2014-02-15 00:57:36.000000', 'consum', 0.0221, 'lps'),
	(543454, 129, '2014-02-15 00:57:37.000000', 'consum', 0.0225, 'lps'),
	(543455, 129, '2014-02-15 00:57:38.000000', 'consum', 0.0226, 'lps'),
	(543456, 129, '2014-02-15 00:57:39.000000', 'consum', 0.0221, 'lps'),
	(543457, 129, '2014-02-15 00:57:40.000000', 'consum', 0.0217, 'lps'),
	(543458, 129, '2014-02-15 00:57:41.000000', 'consum', 0.0211, 'lps'),
	(543459, 129, '2014-02-15 00:57:42.000000', 'consum', 0.0222, 'lps'),
	(543460, 129, '2014-02-15 00:57:43.000000', 'consum', 0.0219, 'lps'),
	(543461, 129, '2014-02-15 00:57:44.000000', 'consum', 0.0216, 'lps'),
	(543462, 129, '2014-02-15 00:57:45.000000', 'consum', 0.0214, 'lps'),
	(543463, 129, '2014-02-15 00:57:46.000000', 'consum', 0.0211, 'lps'),
	(543464, 129, '2014-02-15 00:57:47.000000', 'consum', 0.0230, 'lps'),
	(543465, 129, '2014-02-15 00:57:48.000000', 'consum', 0.0232, 'lps'),
	(543466, 129, '2014-02-15 00:57:49.000000', 'consum', 0.0212, 'lps'),
	(543467, 129, '2014-02-15 00:57:50.000000', 'consum', 0.0228, 'lps'),
	(543468, 129, '2014-02-15 00:57:51.000000', 'consum', 0.0219, 'lps'),
	(543469, 129, '2014-02-15 00:57:52.000000', 'consum', 0.0225, 'lps'),
	(543470, 129, '2014-02-15 00:57:53.000000', 'consum', 0.0211, 'lps'),
	(543471, 129, '2014-02-15 00:57:54.000000', 'consum', 0.0218, 'lps'),
	(543472, 129, '2014-02-15 00:57:55.000000', 'consum', 0.0223, 'lps'),
	(543473, 129, '2014-02-15 00:57:56.000000', 'consum', 0.0227, 'lps'),
	(543474, 129, '2014-02-15 00:57:57.000000', 'consum', 0.0234, 'lps'),
	(543475, 129, '2014-02-15 00:57:58.000000', 'consum', 0.0226, 'lps'),
	(543476, 129, '2014-02-15 00:57:59.000000', 'consum', 0.0219, 'lps'),
	(543477, 129, '2014-02-15 00:58:00.000000', 'consum', 0.0232, 'lps'),
	(543478, 129, '2014-02-15 00:58:01.000000', 'consum', 0.0218, 'lps'),
	(543479, 129, '2014-02-15 00:58:02.000000', 'consum', 0.0212, 'lps'),
	(543480, 129, '2014-02-15 00:58:03.000000', 'consum', 0.0219, 'lps'),
	(543481, 129, '2014-02-15 00:58:04.000000', 'consum', 0.0227, 'lps'),
	(543482, 129, '2014-02-15 00:58:05.000000', 'consum', 0.0216, 'lps'),
	(543483, 129, '2014-02-15 00:58:06.000000', 'consum', 0.0214, 'lps'),
	(543484, 129, '2014-02-15 00:58:07.000000', 'consum', 0.0214, 'lps'),
	(543485, 129, '2014-02-15 00:58:08.000000', 'consum', 0.0220, 'lps'),
	(543486, 129, '2014-02-15 00:58:09.000000', 'consum', 0.0221, 'lps'),
	(543487, 129, '2014-02-15 00:58:10.000000', 'consum', 0.0213, 'lps'),
	(543488, 129, '2014-02-15 00:58:11.000000', 'consum', 0.0216, 'lps'),
	(543489, 129, '2014-02-15 00:58:12.000000', 'consum', 0.0231, 'lps'),
	(543490, 129, '2014-02-15 00:58:13.000000', 'consum', 0.0221, 'lps'),
	(543491, 129, '2014-02-15 00:58:14.000000', 'consum', 0.0231, 'lps'),
	(543492, 129, '2014-02-15 00:58:15.000000', 'consum', 0.0231, 'lps'),
	(543493, 129, '2014-02-15 00:58:16.000000', 'consum', 0.0227, 'lps'),
	(543494, 129, '2014-02-15 00:58:17.000000', 'consum', 0.0231, 'lps'),
	(543495, 129, '2014-02-15 00:58:18.000000', 'consum', 0.0215, 'lps'),
	(543496, 129, '2014-02-15 00:58:19.000000', 'consum', 0.0225, 'lps'),
	(543497, 129, '2014-02-15 00:58:20.000000', 'consum', 0.0218, 'lps'),
	(543498, 129, '2014-02-15 00:58:21.000000', 'consum', 0.0231, 'lps'),
	(543499, 129, '2014-02-15 00:58:22.000000', 'consum', 0.0217, 'lps'),
	(543500, 129, '2014-02-15 00:58:23.000000', 'consum', 0.0231, 'lps'),
	(543501, 129, '2014-02-15 00:58:24.000000', 'consum', 0.0222, 'lps'),
	(543502, 129, '2014-02-15 00:58:25.000000', 'consum', 0.0233, 'lps'),
	(543503, 129, '2014-02-15 00:58:26.000000', 'consum', 0.0211, 'lps'),
	(543504, 129, '2014-02-15 00:58:27.000000', 'consum', 0.0224, 'lps'),
	(543505, 129, '2014-02-15 00:58:28.000000', 'consum', 0.0229, 'lps'),
	(543506, 129, '2014-02-15 00:58:29.000000', 'consum', 0.0212, 'lps'),
	(543507, 129, '2014-02-15 00:58:30.000000', 'consum', 0.0212, 'lps'),
	(543508, 129, '2014-02-15 00:58:31.000000', 'consum', 0.0215, 'lps'),
	(543509, 129, '2014-02-15 00:58:32.000000', 'consum', 0.0230, 'lps'),
	(543510, 129, '2014-02-15 00:58:33.000000', 'consum', 0.0221, 'lps'),
	(543511, 129, '2014-02-15 00:58:34.000000', 'consum', 0.0230, 'lps'),
	(543512, 129, '2014-02-15 00:58:35.000000', 'consum', 0.0228, 'lps'),
	(543513, 129, '2014-02-15 00:58:36.000000', 'consum', 0.0216, 'lps'),
	(543514, 129, '2014-02-15 00:58:37.000000', 'consum', 0.0210, 'lps'),
	(543515, 129, '2014-02-15 00:58:38.000000', 'consum', 0.0217, 'lps'),
	(543516, 129, '2014-02-15 00:58:39.000000', 'consum', 0.0221, 'lps'),
	(543517, 129, '2014-02-15 00:58:40.000000', 'consum', 0.0218, 'lps'),
	(543518, 129, '2014-02-15 00:58:41.000000', 'consum', 0.0218, 'lps'),
	(543519, 129, '2014-02-15 00:58:42.000000', 'consum', 0.0225, 'lps'),
	(543520, 129, '2014-02-15 00:58:43.000000', 'consum', 0.0212, 'lps'),
	(543521, 129, '2014-02-15 00:58:44.000000', 'consum', 0.0228, 'lps'),
	(543522, 129, '2014-02-15 00:58:45.000000', 'consum', 0.0217, 'lps'),
	(543523, 129, '2014-02-15 00:58:46.000000', 'consum', 0.0218, 'lps'),
	(543524, 129, '2014-02-15 00:58:47.000000', 'consum', 0.0230, 'lps'),
	(543525, 129, '2014-02-15 00:58:48.000000', 'consum', 0.0211, 'lps'),
	(543526, 129, '2014-02-15 00:58:49.000000', 'consum', 0.0230, 'lps'),
	(543527, 129, '2014-02-15 00:58:50.000000', 'consum', 0.0234, 'lps'),
	(543528, 129, '2014-02-15 00:58:51.000000', 'consum', 0.0222, 'lps'),
	(543529, 129, '2014-02-15 00:58:52.000000', 'consum', 0.0220, 'lps'),
	(543530, 129, '2014-02-15 00:58:53.000000', 'consum', 0.0227, 'lps'),
	(543531, 129, '2014-02-15 00:58:54.000000', 'consum', 0.0216, 'lps'),
	(543532, 129, '2014-02-15 00:58:55.000000', 'consum', 0.0214, 'lps'),
	(543533, 129, '2014-02-15 00:58:56.000000', 'consum', 0.0214, 'lps'),
	(543534, 129, '2014-02-15 00:58:57.000000', 'consum', 0.0219, 'lps'),
	(543535, 129, '2014-02-15 00:58:58.000000', 'consum', 0.0215, 'lps'),
	(543536, 129, '2014-02-15 00:58:59.000000', 'consum', 0.0211, 'lps'),
	(543537, 129, '2014-02-15 00:59:00.000000', 'consum', 0.0223, 'lps'),
	(543538, 129, '2014-02-15 00:59:01.000000', 'consum', 0.0225, 'lps'),
	(543539, 129, '2014-02-15 00:59:02.000000', 'consum', 0.0221, 'lps'),
	(543540, 129, '2014-02-15 00:59:03.000000', 'consum', 0.0222, 'lps'),
	(543541, 129, '2014-02-15 00:59:04.000000', 'consum', 0.0210, 'lps'),
	(543542, 129, '2014-02-15 00:59:05.000000', 'consum', 0.0223, 'lps'),
	(543543, 129, '2014-02-15 00:59:06.000000', 'consum', 0.0228, 'lps'),
	(543544, 129, '2014-02-15 00:59:07.000000', 'consum', 0.0212, 'lps'),
	(543545, 129, '2014-02-15 00:59:08.000000', 'consum', 0.0218, 'lps'),
	(543546, 129, '2014-02-15 00:59:09.000000', 'consum', 0.0217, 'lps'),
	(543547, 129, '2014-02-15 00:59:10.000000', 'consum', 0.0222, 'lps'),
	(543548, 129, '2014-02-15 00:59:11.000000', 'consum', 0.0225, 'lps'),
	(543549, 129, '2014-02-15 00:59:12.000000', 'consum', 0.0224, 'lps'),
	(543550, 129, '2014-02-15 00:59:13.000000', 'consum', 0.0211, 'lps'),
	(543551, 129, '2014-02-15 00:59:14.000000', 'consum', 0.0222, 'lps'),
	(543552, 129, '2014-02-15 00:59:15.000000', 'consum', 0.0220, 'lps'),
	(543553, 129, '2014-02-15 00:59:16.000000', 'consum', 0.0223, 'lps'),
	(543554, 129, '2014-02-15 00:59:17.000000', 'consum', 0.0222, 'lps'),
	(543555, 129, '2014-02-15 00:59:18.000000', 'consum', 0.0231, 'lps'),
	(543556, 129, '2014-02-15 00:59:19.000000', 'consum', 0.0231, 'lps'),
	(543557, 129, '2014-02-15 00:59:20.000000', 'consum', 0.0227, 'lps'),
	(543558, 129, '2014-02-15 00:59:21.000000', 'consum', 0.0232, 'lps'),
	(543559, 129, '2014-02-15 00:59:22.000000', 'consum', 0.0220, 'lps'),
	(543560, 129, '2014-02-15 00:59:23.000000', 'consum', 0.0220, 'lps'),
	(543561, 129, '2014-02-15 00:59:24.000000', 'consum', 0.0231, 'lps'),
	(543562, 129, '2014-02-15 00:59:25.000000', 'consum', 0.0211, 'lps'),
	(543563, 129, '2014-02-15 00:59:26.000000', 'consum', 0.0227, 'lps'),
	(543564, 129, '2014-02-15 00:59:27.000000', 'consum', 0.0218, 'lps'),
	(543565, 129, '2014-02-15 00:59:28.000000', 'consum', 0.0222, 'lps'),
	(543566, 129, '2014-02-15 00:59:29.000000', 'consum', 0.0224, 'lps'),
	(543567, 129, '2014-02-15 00:59:30.000000', 'consum', 0.0218, 'lps'),
	(543568, 129, '2014-02-15 00:59:31.000000', 'consum', 0.0234, 'lps'),
	(543569, 129, '2014-02-15 00:59:32.000000', 'consum', 0.0230, 'lps'),
	(543570, 129, '2014-02-15 00:59:33.000000', 'consum', 0.0216, 'lps'),
	(543571, 129, '2014-02-15 00:59:34.000000', 'consum', 0.0230, 'lps'),
	(543572, 129, '2014-02-15 00:59:35.000000', 'consum', 0.0218, 'lps'),
	(543573, 129, '2014-02-15 00:59:36.000000', 'consum', 0.0215, 'lps'),
	(543574, 129, '2014-02-15 00:59:37.000000', 'consum', 0.0213, 'lps'),
	(543575, 129, '2014-02-15 00:59:38.000000', 'consum', 0.0233, 'lps'),
	(543576, 129, '2014-02-15 00:59:39.000000', 'consum', 0.0219, 'lps'),
	(543577, 129, '2014-02-15 00:59:40.000000', 'consum', 0.0212, 'lps'),
	(543578, 129, '2014-02-15 00:59:41.000000', 'consum', 0.0218, 'lps'),
	(543579, 129, '2014-02-15 00:59:42.000000', 'consum', 0.0220, 'lps'),
	(543580, 129, '2014-02-15 00:59:43.000000', 'consum', 0.0213, 'lps'),
	(543581, 129, '2014-02-15 00:59:44.000000', 'consum', 0.0219, 'lps'),
	(543582, 129, '2014-02-15 00:59:45.000000', 'consum', 0.0220, 'lps'),
	(543583, 129, '2014-02-15 00:59:46.000000', 'consum', 0.0234, 'lps'),
	(543584, 129, '2014-02-15 00:59:47.000000', 'consum', 0.0224, 'lps'),
	(543585, 129, '2014-02-15 00:59:48.000000', 'consum', 0.0211, 'lps'),
	(543586, 129, '2014-02-15 00:59:49.000000', 'consum', 0.0222, 'lps'),
	(543587, 129, '2014-02-15 00:59:50.000000', 'consum', 0.0218, 'lps'),
	(543588, 129, '2014-02-15 00:59:51.000000', 'consum', 0.0214, 'lps'),
	(543589, 129, '2014-02-15 00:59:52.000000', 'consum', 0.0230, 'lps'),
	(543590, 129, '2014-02-15 00:59:53.000000', 'consum', 0.0223, 'lps'),
	(543591, 129, '2014-02-15 00:59:54.000000', 'consum', 0.0219, 'lps'),
	(543592, 129, '2014-02-15 00:59:55.000000', 'consum', 0.0214, 'lps'),
	(543593, 129, '2014-02-15 00:59:56.000000', 'consum', 0.0229, 'lps'),
	(543594, 129, '2014-02-15 00:59:57.000000', 'consum', 0.0218, 'lps'),
	(543595, 129, '2014-02-15 00:59:58.000000', 'consum', 0.0219, 'lps'),
	(543596, 129, '2014-02-15 00:59:59.000000', 'consum', 0.0230, 'lps'),
	(543597, 129, '2014-02-15 01:00:00.000000', 'consum', 0.0210, 'lps'),
	(543598, 129, '2014-02-15 01:00:01.000000', 'consum', 0.0224, 'lps'),
	(543599, 129, '2014-02-15 01:00:02.000000', 'consum', 0.0233, 'lps'),
	(543600, 129, '2014-02-15 01:00:03.000000', 'consum', 0.0234, 'lps'),
	(543601, 129, '2014-02-15 01:00:04.000000', 'consum', 0.0234, 'lps'),
	(543602, 129, '2014-02-15 01:00:05.000000', 'consum', 0.0232, 'lps'),
	(543603, 129, '2014-02-15 01:00:06.000000', 'consum', 0.0226, 'lps'),
	(543604, 129, '2014-02-15 01:00:07.000000', 'consum', 0.0226, 'lps'),
	(543605, 129, '2014-02-15 01:00:08.000000', 'consum', 0.0216, 'lps'),
	(543606, 129, '2014-02-15 01:00:09.000000', 'consum', 0.0218, 'lps'),
	(543607, 129, '2014-02-15 01:00:10.000000', 'consum', 0.0233, 'lps'),
	(543608, 129, '2014-02-15 01:00:11.000000', 'consum', 0.0224, 'lps'),
	(543609, 129, '2014-02-15 01:00:12.000000', 'consum', 0.0215, 'lps'),
	(543610, 129, '2014-02-15 01:00:13.000000', 'consum', 0.0215, 'lps'),
	(543611, 129, '2014-02-15 01:00:14.000000', 'consum', 0.0224, 'lps'),
	(543612, 129, '2014-02-15 01:00:15.000000', 'consum', 0.0213, 'lps'),
	(543613, 129, '2014-02-15 01:00:16.000000', 'consum', 0.0234, 'lps'),
	(543614, 129, '2014-02-15 01:00:17.000000', 'consum', 0.0222, 'lps'),
	(543615, 129, '2014-02-15 01:00:18.000000', 'consum', 0.0225, 'lps'),
	(543616, 129, '2014-02-15 01:00:19.000000', 'consum', 0.0223, 'lps'),
	(543617, 129, '2014-02-15 01:00:20.000000', 'consum', 0.0229, 'lps'),
	(543618, 129, '2014-02-15 01:00:21.000000', 'consum', 0.0216, 'lps'),
	(543619, 129, '2014-02-15 01:00:22.000000', 'consum', 0.0211, 'lps'),
	(543620, 129, '2014-02-15 01:00:23.000000', 'consum', 0.0223, 'lps'),
	(543621, 129, '2014-02-15 01:00:24.000000', 'consum', 0.0223, 'lps'),
	(543622, 129, '2014-02-15 01:00:25.000000', 'consum', 0.0234, 'lps'),
	(543623, 129, '2014-02-15 01:00:26.000000', 'consum', 0.0216, 'lps'),
	(543624, 129, '2014-02-15 01:00:27.000000', 'consum', 0.0220, 'lps'),
	(543625, 129, '2014-02-15 01:00:28.000000', 'consum', 0.0219, 'lps'),
	(543626, 129, '2014-02-15 01:00:29.000000', 'consum', 0.0222, 'lps'),
	(543627, 129, '2014-02-15 01:00:30.000000', 'consum', 0.0221, 'lps'),
	(543628, 129, '2014-02-15 01:00:31.000000', 'consum', 0.0228, 'lps'),
	(543629, 129, '2014-02-15 01:00:32.000000', 'consum', 0.0218, 'lps'),
	(543630, 129, '2014-02-15 01:00:33.000000', 'consum', 0.0220, 'lps'),
	(543631, 129, '2014-02-15 01:00:34.000000', 'consum', 0.0213, 'lps'),
	(543632, 129, '2014-02-15 01:00:35.000000', 'consum', 0.0220, 'lps'),
	(543633, 129, '2014-02-15 01:00:36.000000', 'consum', 0.0228, 'lps'),
	(543634, 129, '2014-02-15 01:00:37.000000', 'consum', 0.0221, 'lps'),
	(543635, 129, '2014-02-15 01:00:38.000000', 'consum', 0.0210, 'lps'),
	(543636, 129, '2014-02-15 01:00:39.000000', 'consum', 0.0227, 'lps'),
	(543637, 129, '2014-02-15 01:00:40.000000', 'consum', 0.0223, 'lps'),
	(543638, 129, '2014-02-15 01:00:41.000000', 'consum', 0.0221, 'lps'),
	(543639, 129, '2014-02-15 01:00:42.000000', 'consum', 0.0229, 'lps'),
	(543640, 129, '2014-02-15 01:00:43.000000', 'consum', 0.0221, 'lps'),
	(543641, 129, '2014-02-15 01:00:44.000000', 'consum', 0.0210, 'lps'),
	(543642, 129, '2014-02-15 01:00:45.000000', 'consum', 0.0226, 'lps'),
	(543643, 129, '2014-02-15 01:00:46.000000', 'consum', 0.0215, 'lps'),
	(543644, 129, '2014-02-15 01:00:47.000000', 'consum', 0.0215, 'lps'),
	(543645, 129, '2014-02-15 01:00:48.000000', 'consum', 0.0219, 'lps'),
	(543646, 129, '2014-02-15 01:00:49.000000', 'consum', 0.0214, 'lps'),
	(543647, 129, '2014-02-15 01:00:50.000000', 'consum', 0.0228, 'lps'),
	(543648, 129, '2014-02-15 01:00:51.000000', 'consum', 0.0216, 'lps'),
	(543649, 129, '2014-02-15 01:00:52.000000', 'consum', 0.0212, 'lps'),
	(543650, 129, '2014-02-15 01:00:53.000000', 'consum', 0.0228, 'lps'),
	(543651, 129, '2014-02-15 01:00:54.000000', 'consum', 0.0218, 'lps'),
	(543652, 129, '2014-02-15 01:00:55.000000', 'consum', 0.0220, 'lps'),
	(543653, 129, '2014-02-15 01:00:56.000000', 'consum', 0.0214, 'lps'),
	(543654, 129, '2014-02-15 01:00:57.000000', 'consum', 0.0223, 'lps'),
	(543655, 129, '2014-02-15 01:00:58.000000', 'consum', 0.0214, 'lps'),
	(543656, 129, '2014-02-15 01:00:59.000000', 'consum', 0.0219, 'lps'),
	(543657, 129, '2014-02-15 01:01:00.000000', 'consum', 0.0217, 'lps'),
	(543658, 129, '2014-02-15 01:01:01.000000', 'consum', 0.0221, 'lps'),
	(543659, 129, '2014-02-15 01:01:02.000000', 'consum', 0.0216, 'lps'),
	(543660, 129, '2014-02-15 01:01:03.000000', 'consum', 0.0210, 'lps'),
	(543661, 129, '2014-02-15 01:01:04.000000', 'consum', 0.0217, 'lps'),
	(543662, 129, '2014-02-15 01:01:05.000000', 'consum', 0.0220, 'lps'),
	(543663, 129, '2014-02-15 01:01:06.000000', 'consum', 0.0214, 'lps'),
	(543664, 129, '2014-02-15 01:01:07.000000', 'consum', 0.0226, 'lps'),
	(543665, 129, '2014-02-15 01:01:08.000000', 'consum', 0.0227, 'lps'),
	(543666, 129, '2014-02-15 01:01:09.000000', 'consum', 0.0224, 'lps'),
	(543667, 129, '2014-02-15 01:01:10.000000', 'consum', 0.0230, 'lps'),
	(543668, 129, '2014-02-15 01:01:11.000000', 'consum', 0.0218, 'lps'),
	(543669, 129, '2014-02-15 01:01:12.000000', 'consum', 0.0216, 'lps'),
	(543670, 129, '2014-02-15 01:01:13.000000', 'consum', 0.0215, 'lps'),
	(543671, 129, '2014-02-15 01:01:14.000000', 'consum', 0.0219, 'lps'),
	(543672, 129, '2014-02-15 01:01:15.000000', 'consum', 0.0216, 'lps'),
	(543673, 129, '2014-02-15 01:01:16.000000', 'consum', 0.0213, 'lps'),
	(543674, 129, '2014-02-15 01:01:17.000000', 'consum', 0.0234, 'lps'),
	(543675, 129, '2014-02-15 01:01:18.000000', 'consum', 0.0221, 'lps'),
	(543676, 129, '2014-02-15 01:01:19.000000', 'consum', 0.0219, 'lps'),
	(543677, 129, '2014-02-15 01:01:20.000000', 'consum', 0.0222, 'lps'),
	(543678, 129, '2014-02-15 01:01:21.000000', 'consum', 0.0218, 'lps'),
	(543679, 129, '2014-02-15 01:01:22.000000', 'consum', 0.0213, 'lps'),
	(543680, 129, '2014-02-15 01:01:23.000000', 'consum', 0.0230, 'lps'),
	(543681, 129, '2014-02-15 01:01:24.000000', 'consum', 0.0224, 'lps'),
	(543682, 129, '2014-02-15 01:01:25.000000', 'consum', 0.0219, 'lps'),
	(543683, 129, '2014-02-15 01:01:26.000000', 'consum', 0.0216, 'lps'),
	(543684, 129, '2014-02-15 01:01:27.000000', 'consum', 0.0211, 'lps'),
	(543685, 129, '2014-02-15 01:01:28.000000', 'consum', 0.0224, 'lps'),
	(543686, 129, '2014-02-15 01:01:29.000000', 'consum', 0.0228, 'lps'),
	(543687, 129, '2014-02-15 01:01:30.000000', 'consum', 0.0233, 'lps'),
	(543688, 129, '2014-02-15 01:01:31.000000', 'consum', 0.0220, 'lps'),
	(543689, 129, '2014-02-15 01:01:32.000000', 'consum', 0.0217, 'lps'),
	(543690, 129, '2014-02-15 01:01:33.000000', 'consum', 0.0217, 'lps'),
	(543691, 129, '2014-02-15 01:01:34.000000', 'consum', 0.0222, 'lps'),
	(543692, 129, '2014-02-15 01:01:35.000000', 'consum', 0.0227, 'lps'),
	(543693, 129, '2014-02-15 01:01:36.000000', 'consum', 0.0232, 'lps'),
	(543694, 129, '2014-02-15 01:01:37.000000', 'consum', 0.0222, 'lps'),
	(543695, 129, '2014-02-15 01:01:38.000000', 'consum', 0.0229, 'lps'),
	(543696, 129, '2014-02-15 01:01:39.000000', 'consum', 0.0220, 'lps'),
	(543697, 129, '2014-02-15 01:01:40.000000', 'consum', 0.0226, 'lps'),
	(543698, 129, '2014-02-15 01:01:41.000000', 'consum', 0.0214, 'lps'),
	(543699, 129, '2014-02-15 01:01:42.000000', 'consum', 0.0231, 'lps'),
	(543700, 129, '2014-02-15 01:01:43.000000', 'consum', 0.0227, 'lps'),
	(543701, 129, '2014-02-15 01:01:44.000000', 'consum', 0.0233, 'lps'),
	(543702, 129, '2014-02-15 01:01:45.000000', 'consum', 0.0224, 'lps'),
	(543703, 129, '2014-02-15 01:01:46.000000', 'consum', 0.0213, 'lps'),
	(543704, 129, '2014-02-15 01:01:47.000000', 'consum', 0.0232, 'lps'),
	(543705, 129, '2014-02-15 01:01:48.000000', 'consum', 0.0214, 'lps'),
	(543706, 129, '2014-02-15 01:01:49.000000', 'consum', 0.0213, 'lps'),
	(543707, 129, '2014-02-15 01:01:50.000000', 'consum', 0.0213, 'lps'),
	(543708, 129, '2014-02-15 01:01:51.000000', 'consum', 0.0218, 'lps'),
	(543709, 129, '2014-02-15 01:01:52.000000', 'consum', 0.0216, 'lps'),
	(543710, 129, '2014-02-15 01:01:53.000000', 'consum', 0.0218, 'lps'),
	(543711, 129, '2014-02-15 01:01:54.000000', 'consum', 0.0232, 'lps'),
	(543712, 129, '2014-02-15 01:01:55.000000', 'consum', 0.0222, 'lps'),
	(543713, 129, '2014-02-15 01:01:56.000000', 'consum', 0.0227, 'lps'),
	(543714, 129, '2014-02-15 01:01:57.000000', 'consum', 0.0212, 'lps'),
	(543715, 129, '2014-02-15 01:01:58.000000', 'consum', 0.0219, 'lps'),
	(543716, 129, '2014-02-15 01:01:59.000000', 'consum', 0.0224, 'lps'),
	(543717, 129, '2014-02-15 01:02:00.000000', 'consum', 0.0228, 'lps'),
	(543718, 129, '2014-02-15 01:02:01.000000', 'consum', 0.0210, 'lps'),
	(543719, 129, '2014-02-15 01:02:02.000000', 'consum', 0.0230, 'lps'),
	(543720, 129, '2014-02-15 01:02:03.000000', 'consum', 0.0210, 'lps'),
	(543721, 129, '2014-02-15 01:02:04.000000', 'consum', 0.0227, 'lps'),
	(543722, 129, '2014-02-15 01:02:05.000000', 'consum', 0.0218, 'lps'),
	(543723, 129, '2014-02-15 01:02:06.000000', 'consum', 0.0227, 'lps'),
	(543724, 129, '2014-02-15 01:02:07.000000', 'consum', 0.0219, 'lps'),
	(543725, 129, '2014-02-15 01:02:08.000000', 'consum', 0.0230, 'lps'),
	(543726, 129, '2014-02-15 01:02:09.000000', 'consum', 0.0234, 'lps'),
	(543727, 129, '2014-02-15 01:02:10.000000', 'consum', 0.0221, 'lps'),
	(543728, 129, '2014-02-15 01:02:11.000000', 'consum', 0.0220, 'lps'),
	(543729, 129, '2014-02-15 01:02:12.000000', 'consum', 0.0227, 'lps'),
	(543730, 129, '2014-02-15 01:02:13.000000', 'consum', 0.0214, 'lps'),
	(543731, 129, '2014-02-15 01:02:14.000000', 'consum', 0.0232, 'lps'),
	(543732, 129, '2014-02-15 01:02:15.000000', 'consum', 0.0232, 'lps'),
	(543733, 129, '2014-02-15 01:02:16.000000', 'consum', 0.0228, 'lps'),
	(543734, 129, '2014-02-15 01:02:17.000000', 'consum', 0.0211, 'lps'),
	(543735, 129, '2014-02-15 01:02:18.000000', 'consum', 0.0212, 'lps'),
	(543736, 129, '2014-02-15 01:02:19.000000', 'consum', 0.0217, 'lps'),
	(543737, 129, '2014-02-15 01:02:20.000000', 'consum', 0.0213, 'lps'),
	(543738, 129, '2014-02-15 01:02:21.000000', 'consum', 0.0232, 'lps'),
	(543739, 129, '2014-02-15 01:02:22.000000', 'consum', 0.0210, 'lps'),
	(543740, 129, '2014-02-15 01:02:23.000000', 'consum', 0.0220, 'lps'),
	(543741, 129, '2014-02-15 01:02:24.000000', 'consum', 0.0210, 'lps'),
	(543742, 129, '2014-02-15 01:02:25.000000', 'consum', 0.0229, 'lps'),
	(543743, 129, '2014-02-15 01:02:26.000000', 'consum', 0.0230, 'lps'),
	(543744, 129, '2014-02-15 01:02:27.000000', 'consum', 0.0231, 'lps'),
	(543745, 129, '2014-02-15 01:02:28.000000', 'consum', 0.0230, 'lps'),
	(543746, 129, '2014-02-15 01:02:29.000000', 'consum', 0.0223, 'lps'),
	(543747, 129, '2014-02-15 01:02:30.000000', 'consum', 0.0216, 'lps'),
	(543748, 129, '2014-02-15 01:02:31.000000', 'consum', 0.0226, 'lps'),
	(543749, 129, '2014-02-15 01:02:32.000000', 'consum', 0.0220, 'lps'),
	(543750, 129, '2014-02-15 01:02:33.000000', 'consum', 0.0216, 'lps'),
	(543751, 129, '2014-02-15 01:02:34.000000', 'consum', 0.0233, 'lps'),
	(543752, 129, '2014-02-15 01:02:35.000000', 'consum', 0.0210, 'lps'),
	(543753, 129, '2014-02-15 01:02:36.000000', 'consum', 0.0216, 'lps'),
	(543754, 129, '2014-02-15 01:02:37.000000', 'consum', 0.0215, 'lps'),
	(543755, 129, '2014-02-15 01:02:38.000000', 'consum', 0.0216, 'lps'),
	(543756, 129, '2014-02-15 01:02:39.000000', 'consum', 0.0229, 'lps'),
	(543757, 129, '2014-02-15 01:02:40.000000', 'consum', 0.0234, 'lps'),
	(543758, 129, '2014-02-15 01:02:41.000000', 'consum', 0.0227, 'lps'),
	(543759, 129, '2014-02-15 01:02:42.000000', 'consum', 0.0221, 'lps'),
	(543760, 129, '2014-02-15 01:02:43.000000', 'consum', 0.0216, 'lps'),
	(543761, 129, '2014-02-15 01:02:44.000000', 'consum', 0.0231, 'lps'),
	(543762, 129, '2014-02-15 01:02:45.000000', 'consum', 0.0225, 'lps'),
	(543763, 129, '2014-02-15 01:02:46.000000', 'consum', 0.0222, 'lps'),
	(543764, 129, '2014-02-15 01:02:47.000000', 'consum', 0.0224, 'lps'),
	(543765, 129, '2014-02-15 01:02:48.000000', 'consum', 0.0221, 'lps'),
	(543766, 129, '2014-02-15 01:02:49.000000', 'consum', 0.0221, 'lps'),
	(543767, 129, '2014-02-15 01:02:50.000000', 'consum', 0.0233, 'lps'),
	(543768, 129, '2014-02-15 01:02:51.000000', 'consum', 0.0218, 'lps'),
	(543769, 129, '2014-02-15 01:02:52.000000', 'consum', 0.0231, 'lps'),
	(543770, 129, '2014-02-15 01:02:53.000000', 'consum', 0.0217, 'lps'),
	(543771, 129, '2014-02-15 01:02:54.000000', 'consum', 0.0232, 'lps'),
	(543772, 129, '2014-02-15 01:02:55.000000', 'consum', 0.0223, 'lps'),
	(543773, 129, '2014-02-15 01:02:56.000000', 'consum', 0.0211, 'lps'),
	(543774, 129, '2014-02-15 01:02:57.000000', 'consum', 0.0228, 'lps'),
	(543775, 129, '2014-02-15 01:02:58.000000', 'consum', 0.0221, 'lps'),
	(543776, 129, '2014-02-15 01:02:59.000000', 'consum', 0.0213, 'lps'),
	(543777, 129, '2014-02-15 01:03:00.000000', 'consum', 0.0218, 'lps'),
	(543778, 129, '2014-02-15 01:03:01.000000', 'consum', 0.0215, 'lps'),
	(543779, 129, '2014-02-15 01:03:02.000000', 'consum', 0.0212, 'lps'),
	(543780, 129, '2014-02-15 01:03:03.000000', 'consum', 0.0232, 'lps'),
	(543781, 129, '2014-02-15 01:03:04.000000', 'consum', 0.0214, 'lps'),
	(543782, 129, '2014-02-15 01:03:05.000000', 'consum', 0.0214, 'lps'),
	(543783, 129, '2014-02-15 01:03:06.000000', 'consum', 0.0217, 'lps'),
	(543784, 129, '2014-02-15 01:03:07.000000', 'consum', 0.0211, 'lps'),
	(543785, 129, '2014-02-15 01:03:08.000000', 'consum', 0.0218, 'lps'),
	(543786, 129, '2014-02-15 01:03:09.000000', 'consum', 0.0225, 'lps'),
	(543787, 129, '2014-02-15 01:03:10.000000', 'consum', 0.0234, 'lps'),
	(543788, 129, '2014-02-15 01:03:11.000000', 'consum', 0.0210, 'lps'),
	(543789, 129, '2014-02-15 01:03:12.000000', 'consum', 0.0213, 'lps'),
	(543790, 129, '2014-02-15 01:03:13.000000', 'consum', 0.0226, 'lps'),
	(543791, 129, '2014-02-15 01:03:14.000000', 'consum', 0.0234, 'lps'),
	(543792, 129, '2014-02-15 01:03:15.000000', 'consum', 0.0230, 'lps'),
	(543793, 129, '2014-02-15 01:03:16.000000', 'consum', 0.0216, 'lps'),
	(543794, 129, '2014-02-15 01:03:17.000000', 'consum', 0.0229, 'lps'),
	(543795, 129, '2014-02-15 01:03:18.000000', 'consum', 0.0213, 'lps'),
	(543796, 129, '2014-02-15 01:03:19.000000', 'consum', 0.0219, 'lps'),
	(543797, 129, '2014-02-15 01:03:20.000000', 'consum', 0.0219, 'lps'),
	(543798, 129, '2014-02-15 01:03:21.000000', 'consum', 0.0230, 'lps'),
	(543799, 129, '2014-02-15 01:03:22.000000', 'consum', 0.0210, 'lps'),
	(543800, 129, '2014-02-15 01:03:23.000000', 'consum', 0.0226, 'lps'),
	(543801, 129, '2014-02-15 01:03:24.000000', 'consum', 0.0215, 'lps'),
	(543802, 129, '2014-02-15 01:03:25.000000', 'consum', 0.0213, 'lps'),
	(543803, 129, '2014-02-15 01:03:26.000000', 'consum', 0.0233, 'lps'),
	(543804, 129, '2014-02-15 01:03:27.000000', 'consum', 0.0220, 'lps'),
	(543805, 129, '2014-02-15 01:03:28.000000', 'consum', 0.0214, 'lps'),
	(543806, 129, '2014-02-15 01:03:29.000000', 'consum', 0.0226, 'lps'),
	(543807, 129, '2014-02-15 01:03:30.000000', 'consum', 0.0228, 'lps'),
	(543808, 129, '2014-02-15 01:03:31.000000', 'consum', 0.0228, 'lps'),
	(543809, 129, '2014-02-15 01:03:32.000000', 'consum', 0.0223, 'lps'),
	(543810, 129, '2014-02-15 01:03:33.000000', 'consum', 0.0221, 'lps'),
	(543811, 129, '2014-02-15 01:03:34.000000', 'consum', 0.0228, 'lps'),
	(543812, 129, '2014-02-15 01:03:35.000000', 'consum', 0.0216, 'lps'),
	(543813, 129, '2014-02-15 01:03:36.000000', 'consum', 0.0213, 'lps'),
	(543814, 129, '2014-02-15 01:03:37.000000', 'consum', 0.0231, 'lps'),
	(543815, 129, '2014-02-15 01:03:38.000000', 'consum', 0.0231, 'lps'),
	(543816, 129, '2014-02-15 01:03:39.000000', 'consum', 0.0228, 'lps'),
	(543817, 129, '2014-02-15 01:03:40.000000', 'consum', 0.0213, 'lps'),
	(543818, 129, '2014-02-15 01:03:41.000000', 'consum', 0.0221, 'lps'),
	(543819, 129, '2014-02-15 01:03:42.000000', 'consum', 0.0230, 'lps'),
	(543820, 129, '2014-02-15 01:03:43.000000', 'consum', 0.0230, 'lps'),
	(543821, 129, '2014-02-15 01:03:44.000000', 'consum', 0.0226, 'lps'),
	(543822, 129, '2014-02-15 01:03:45.000000', 'consum', 0.0231, 'lps'),
	(543823, 129, '2014-02-15 01:03:46.000000', 'consum', 0.0217, 'lps'),
	(543824, 129, '2014-02-15 01:03:47.000000', 'consum', 0.0231, 'lps'),
	(543825, 129, '2014-02-15 01:03:48.000000', 'consum', 0.0221, 'lps'),
	(543826, 129, '2014-02-15 01:03:49.000000', 'consum', 0.0225, 'lps'),
	(543827, 129, '2014-02-15 01:03:50.000000', 'consum', 0.0231, 'lps'),
	(543828, 129, '2014-02-15 01:03:51.000000', 'consum', 0.0217, 'lps'),
	(543829, 129, '2014-02-15 01:03:52.000000', 'consum', 0.0210, 'lps'),
	(543830, 129, '2014-02-15 01:03:53.000000', 'consum', 0.0214, 'lps'),
	(543831, 129, '2014-02-15 01:03:54.000000', 'consum', 0.0231, 'lps'),
	(543832, 129, '2014-02-15 01:03:55.000000', 'consum', 0.0230, 'lps'),
	(543833, 129, '2014-02-15 01:03:56.000000', 'consum', 0.0222, 'lps'),
	(543834, 129, '2014-02-15 01:03:57.000000', 'consum', 0.0233, 'lps'),
	(543835, 129, '2014-02-15 01:03:58.000000', 'consum', 0.0218, 'lps'),
	(543836, 129, '2014-02-15 01:03:59.000000', 'consum', 0.0228, 'lps'),
	(543837, 129, '2014-02-15 01:04:00.000000', 'consum', 0.0227, 'lps'),
	(543838, 129, '2014-02-15 01:04:01.000000', 'consum', 0.0219, 'lps'),
	(543839, 129, '2014-02-15 01:04:02.000000', 'consum', 0.0227, 'lps'),
	(543840, 129, '2014-02-15 01:04:03.000000', 'consum', 0.0218, 'lps'),
	(543841, 129, '2014-02-15 01:04:04.000000', 'consum', 0.0227, 'lps'),
	(543842, 129, '2014-02-15 01:04:05.000000', 'consum', 0.0219, 'lps'),
	(543843, 129, '2014-02-15 01:04:06.000000', 'consum', 0.0231, 'lps'),
	(543844, 129, '2014-02-15 01:04:07.000000', 'consum', 0.0212, 'lps'),
	(543845, 129, '2014-02-15 01:04:08.000000', 'consum', 0.0210, 'lps'),
	(543846, 129, '2014-02-15 01:04:09.000000', 'consum', 0.0230, 'lps'),
	(543847, 129, '2014-02-15 01:04:10.000000', 'consum', 0.0234, 'lps'),
	(543848, 129, '2014-02-15 01:04:11.000000', 'consum', 0.0222, 'lps'),
	(543849, 129, '2014-02-15 01:04:12.000000', 'consum', 0.0224, 'lps'),
	(543850, 129, '2014-02-15 01:04:13.000000', 'consum', 0.0220, 'lps'),
	(543851, 129, '2014-02-15 01:04:14.000000', 'consum', 0.0216, 'lps'),
	(543852, 129, '2014-02-15 01:04:15.000000', 'consum', 0.0212, 'lps'),
	(543853, 129, '2014-02-15 01:04:16.000000', 'consum', 0.0228, 'lps'),
	(543854, 129, '2014-02-15 01:04:17.000000', 'consum', 0.0218, 'lps'),
	(543855, 129, '2014-02-15 01:04:18.000000', 'consum', 0.0223, 'lps'),
	(543856, 129, '2014-02-15 01:04:19.000000', 'consum', 0.0225, 'lps'),
	(543857, 129, '2014-02-15 01:04:20.000000', 'consum', 0.0224, 'lps'),
	(543858, 129, '2014-02-15 01:04:21.000000', 'consum', 0.0233, 'lps'),
	(543859, 129, '2014-02-15 01:04:22.000000', 'consum', 0.0232, 'lps'),
	(543860, 129, '2014-02-15 01:04:23.000000', 'consum', 0.0229, 'lps'),
	(543861, 129, '2014-02-15 01:04:24.000000', 'consum', 0.0215, 'lps'),
	(543862, 129, '2014-02-15 01:04:25.000000', 'consum', 0.0229, 'lps'),
	(543863, 129, '2014-02-15 01:04:26.000000', 'consum', 0.0215, 'lps'),
	(543864, 129, '2014-02-15 01:04:27.000000', 'consum', 0.0227, 'lps'),
	(543865, 129, '2014-02-15 01:04:28.000000', 'consum', 0.0233, 'lps'),
	(543866, 129, '2014-02-15 01:04:29.000000', 'consum', 0.0222, 'lps'),
	(543867, 129, '2014-02-15 01:04:30.000000', 'consum', 0.0226, 'lps'),
	(543868, 129, '2014-02-15 01:04:31.000000', 'consum', 0.0232, 'lps'),
	(543869, 129, '2014-02-15 01:04:32.000000', 'consum', 0.0221, 'lps'),
	(543870, 129, '2014-02-15 01:04:33.000000', 'consum', 0.0226, 'lps'),
	(543871, 129, '2014-02-15 01:04:34.000000', 'consum', 0.0232, 'lps'),
	(543872, 129, '2014-02-15 01:04:35.000000', 'consum', 0.0223, 'lps'),
	(543873, 129, '2014-02-15 01:04:36.000000', 'consum', 0.0233, 'lps'),
	(543874, 129, '2014-02-15 01:04:37.000000', 'consum', 0.0212, 'lps'),
	(543875, 129, '2014-02-15 01:04:38.000000', 'consum', 0.0225, 'lps'),
	(543876, 129, '2014-02-15 01:04:39.000000', 'consum', 0.0232, 'lps'),
	(543877, 129, '2014-02-15 01:04:40.000000', 'consum', 0.0227, 'lps'),
	(543878, 129, '2014-02-15 01:04:41.000000', 'consum', 0.0226, 'lps'),
	(543879, 129, '2014-02-15 01:04:42.000000', 'consum', 0.0216, 'lps'),
	(543880, 129, '2014-02-15 01:04:43.000000', 'consum', 0.0217, 'lps'),
	(543881, 129, '2014-02-15 01:04:44.000000', 'consum', 0.0229, 'lps'),
	(543882, 129, '2014-02-15 01:04:45.000000', 'consum', 0.0210, 'lps'),
	(543883, 129, '2014-02-15 01:04:46.000000', 'consum', 0.0226, 'lps'),
	(543884, 129, '2014-02-15 01:04:47.000000', 'consum', 0.0215, 'lps'),
	(543885, 129, '2014-02-15 01:04:48.000000', 'consum', 0.0213, 'lps'),
	(543886, 129, '2014-02-15 01:04:49.000000', 'consum', 0.0211, 'lps'),
	(543887, 129, '2014-02-15 01:04:50.000000', 'consum', 0.0229, 'lps'),
	(543888, 129, '2014-02-15 01:04:51.000000', 'consum', 0.0231, 'lps'),
	(543889, 129, '2014-02-15 01:04:52.000000', 'consum', 0.0233, 'lps'),
	(543890, 129, '2014-02-15 01:04:53.000000', 'consum', 0.0212, 'lps'),
	(543891, 129, '2014-02-15 01:04:54.000000', 'consum', 0.0225, 'lps'),
	(543892, 129, '2014-02-15 01:04:55.000000', 'consum', 0.0231, 'lps'),
	(543893, 129, '2014-02-15 01:04:56.000000', 'consum', 0.0220, 'lps'),
	(543894, 129, '2014-02-15 01:04:57.000000', 'consum', 0.0223, 'lps'),
	(543895, 129, '2014-02-15 01:04:58.000000', 'consum', 0.0222, 'lps'),
	(543896, 129, '2014-02-15 01:04:59.000000', 'consum', 0.0230, 'lps'),
	(543897, 129, '2014-02-15 01:05:00.000000', 'consum', 0.0226, 'lps'),
	(543898, 129, '2014-02-15 01:05:01.000000', 'consum', 0.0229, 'lps'),
	(543899, 129, '2014-02-15 01:05:02.000000', 'consum', 0.0231, 'lps'),
	(543900, 129, '2014-02-15 01:05:03.000000', 'consum', 0.0234, 'lps'),
	(543901, 129, '2014-02-15 01:05:04.000000', 'consum', 0.0217, 'lps'),
	(543902, 129, '2014-02-15 01:05:05.000000', 'consum', 0.0225, 'lps'),
	(543903, 129, '2014-02-15 01:05:06.000000', 'consum', 0.0214, 'lps'),
	(543904, 129, '2014-02-15 01:05:07.000000', 'consum', 0.0212, 'lps'),
	(543905, 129, '2014-02-15 01:05:08.000000', 'consum', 0.0231, 'lps'),
	(543906, 129, '2014-02-15 01:05:09.000000', 'consum', 0.0234, 'lps'),
	(543907, 129, '2014-02-15 01:05:10.000000', 'consum', 0.0221, 'lps'),
	(543908, 129, '2014-02-15 01:05:11.000000', 'consum', 0.0215, 'lps'),
	(543909, 129, '2014-02-15 01:05:12.000000', 'consum', 0.0229, 'lps'),
	(543910, 129, '2014-02-15 01:05:13.000000', 'consum', 0.0216, 'lps'),
	(543911, 129, '2014-02-15 01:05:14.000000', 'consum', 0.0234, 'lps'),
	(543912, 129, '2014-02-15 01:05:15.000000', 'consum', 0.0214, 'lps'),
	(543913, 129, '2014-02-15 01:05:16.000000', 'consum', 0.0230, 'lps'),
	(543914, 129, '2014-02-15 01:05:17.000000', 'consum', 0.0226, 'lps'),
	(543915, 129, '2014-02-15 01:05:18.000000', 'consum', 0.0229, 'lps'),
	(543916, 129, '2014-02-15 01:05:19.000000', 'consum', 0.0233, 'lps'),
	(543917, 129, '2014-02-15 01:05:20.000000', 'consum', 0.0219, 'lps'),
	(543918, 129, '2014-02-15 01:05:21.000000', 'consum', 0.0211, 'lps'),
	(543919, 129, '2014-02-15 01:05:22.000000', 'consum', 0.0214, 'lps'),
	(543920, 129, '2014-02-15 01:05:23.000000', 'consum', 0.0229, 'lps'),
	(543921, 129, '2014-02-15 01:05:24.000000', 'consum', 0.0216, 'lps'),
	(543922, 129, '2014-02-15 01:05:25.000000', 'consum', 0.0211, 'lps'),
	(543923, 129, '2014-02-15 01:05:26.000000', 'consum', 0.0219, 'lps'),
	(543924, 129, '2014-02-15 01:05:27.000000', 'consum', 0.0231, 'lps'),
	(543925, 129, '2014-02-15 01:05:28.000000', 'consum', 0.0213, 'lps'),
	(543926, 129, '2014-02-15 01:05:29.000000', 'consum', 0.0213, 'lps'),
	(543927, 129, '2014-02-15 01:05:30.000000', 'consum', 0.0215, 'lps'),
	(543928, 129, '2014-02-15 01:05:31.000000', 'consum', 0.0225, 'lps'),
	(543929, 129, '2014-02-15 01:05:32.000000', 'consum', 0.0224, 'lps'),
	(543930, 129, '2014-02-15 01:05:33.000000', 'consum', 0.0233, 'lps'),
	(543931, 129, '2014-02-15 01:05:34.000000', 'consum', 0.0233, 'lps'),
	(543932, 129, '2014-02-15 01:05:35.000000', 'consum', 0.0232, 'lps'),
	(543933, 129, '2014-02-15 01:05:36.000000', 'consum', 0.0227, 'lps'),
	(543934, 129, '2014-02-15 01:05:37.000000', 'consum', 0.0229, 'lps'),
	(543935, 129, '2014-02-15 01:05:38.000000', 'consum', 0.0231, 'lps'),
	(543936, 129, '2014-02-15 01:05:39.000000', 'consum', 0.0210, 'lps'),
	(543937, 129, '2014-02-15 01:05:40.000000', 'consum', 0.0219, 'lps'),
	(543938, 129, '2014-02-15 01:05:41.000000', 'consum', 0.0234, 'lps'),
	(543939, 129, '2014-02-15 01:05:42.000000', 'consum', 0.0226, 'lps'),
	(543940, 129, '2014-02-15 01:05:43.000000', 'consum', 0.0218, 'lps'),
	(543941, 129, '2014-02-15 01:05:44.000000', 'consum', 0.0226, 'lps'),
	(543942, 129, '2014-02-15 01:05:45.000000', 'consum', 0.0220, 'lps'),
	(543943, 129, '2014-02-15 01:05:46.000000', 'consum', 0.0210, 'lps'),
	(543944, 129, '2014-02-15 01:05:47.000000', 'consum', 0.0231, 'lps'),
	(543945, 129, '2014-02-15 01:05:48.000000', 'consum', 0.0217, 'lps'),
	(543946, 129, '2014-02-15 01:05:49.000000', 'consum', 0.0230, 'lps'),
	(543947, 129, '2014-02-15 01:05:50.000000', 'consum', 0.0217, 'lps'),
	(543948, 129, '2014-02-15 01:05:51.000000', 'consum', 0.0210, 'lps'),
	(543949, 129, '2014-02-15 01:05:52.000000', 'consum', 0.0212, 'lps'),
	(543950, 129, '2014-02-15 01:05:53.000000', 'consum', 0.0223, 'lps'),
	(543951, 129, '2014-02-15 01:05:54.000000', 'consum', 0.0220, 'lps'),
	(543952, 129, '2014-02-15 01:05:55.000000', 'consum', 0.0219, 'lps'),
	(543953, 129, '2014-02-15 01:05:56.000000', 'consum', 0.0226, 'lps'),
	(543954, 129, '2014-02-15 01:05:57.000000', 'consum', 0.0212, 'lps'),
	(543955, 129, '2014-02-15 01:05:58.000000', 'consum', 0.0224, 'lps'),
	(543956, 129, '2014-02-15 01:05:59.000000', 'consum', 0.0224, 'lps'),
	(543957, 129, '2014-02-15 01:06:00.000000', 'consum', 0.0215, 'lps'),
	(543958, 129, '2014-02-15 01:06:01.000000', 'consum', 0.0217, 'lps'),
	(543959, 129, '2014-02-15 01:06:02.000000', 'consum', 0.0231, 'lps'),
	(543960, 129, '2014-02-15 01:06:03.000000', 'consum', 0.0220, 'lps'),
	(543961, 129, '2014-02-15 01:06:04.000000', 'consum', 0.0224, 'lps'),
	(543962, 129, '2014-02-15 01:06:05.000000', 'consum', 0.0223, 'lps'),
	(543963, 129, '2014-02-15 01:06:06.000000', 'consum', 0.0234, 'lps'),
	(543964, 129, '2014-02-15 01:06:07.000000', 'consum', 0.0215, 'lps'),
	(543965, 129, '2014-02-15 01:06:08.000000', 'consum', 0.0215, 'lps'),
	(543966, 129, '2014-02-15 01:06:09.000000', 'consum', 0.0220, 'lps'),
	(543967, 129, '2014-02-15 01:06:10.000000', 'consum', 0.0222, 'lps'),
	(543968, 129, '2014-02-15 01:06:11.000000', 'consum', 0.0216, 'lps'),
	(543969, 129, '2014-02-15 01:06:12.000000', 'consum', 0.0230, 'lps'),
	(543970, 129, '2014-02-15 01:06:13.000000', 'consum', 0.0216, 'lps'),
	(543971, 129, '2014-02-15 01:06:14.000000', 'consum', 0.0230, 'lps'),
	(543972, 129, '2014-02-15 01:06:15.000000', 'consum', 0.0219, 'lps'),
	(543973, 129, '2014-02-15 01:06:16.000000', 'consum', 0.0219, 'lps'),
	(543974, 129, '2014-02-15 01:06:17.000000', 'consum', 0.0227, 'lps'),
	(543975, 129, '2014-02-15 01:06:18.000000', 'consum', 0.0222, 'lps'),
	(543976, 129, '2014-02-15 01:06:19.000000', 'consum', 0.0217, 'lps'),
	(543977, 129, '2014-02-15 01:06:20.000000', 'consum', 0.0233, 'lps'),
	(543978, 129, '2014-02-15 01:06:21.000000', 'consum', 0.0233, 'lps'),
	(543979, 129, '2014-02-15 01:06:22.000000', 'consum', 0.0230, 'lps'),
	(543980, 129, '2014-02-15 01:06:23.000000', 'consum', 0.0215, 'lps'),
	(543981, 129, '2014-02-15 01:06:24.000000', 'consum', 0.0225, 'lps'),
	(543982, 129, '2014-02-15 01:06:25.000000', 'consum', 0.0222, 'lps'),
	(543983, 129, '2014-02-15 01:06:26.000000', 'consum', 0.0226, 'lps'),
	(543984, 129, '2014-02-15 01:06:27.000000', 'consum', 0.0228, 'lps'),
	(543985, 129, '2014-02-15 01:06:28.000000', 'consum', 0.0227, 'lps'),
	(543986, 129, '2014-02-15 01:06:29.000000', 'consum', 0.0219, 'lps'),
	(543987, 129, '2014-02-15 01:06:30.000000', 'consum', 0.0228, 'lps'),
	(543988, 129, '2014-02-15 01:06:31.000000', 'consum', 0.0225, 'lps'),
	(543989, 129, '2014-02-15 01:06:32.000000', 'consum', 0.0232, 'lps'),
	(543990, 129, '2014-02-15 01:06:33.000000', 'consum', 0.0224, 'lps'),
	(543991, 129, '2014-02-15 01:06:34.000000', 'consum', 0.0217, 'lps'),
	(543992, 129, '2014-02-15 01:06:35.000000', 'consum', 0.0226, 'lps'),
	(543993, 129, '2014-02-15 01:06:36.000000', 'consum', 0.0219, 'lps'),
	(543994, 129, '2014-02-15 01:06:37.000000', 'consum', 0.0231, 'lps'),
	(543995, 129, '2014-02-15 01:06:38.000000', 'consum', 0.0216, 'lps'),
	(543996, 129, '2014-02-15 01:06:39.000000', 'consum', 0.0227, 'lps'),
	(543997, 129, '2014-02-15 01:06:40.000000', 'consum', 0.0228, 'lps'),
	(543998, 129, '2014-02-15 01:06:41.000000', 'consum', 0.0223, 'lps'),
	(543999, 129, '2014-02-15 01:06:42.000000', 'consum', 0.0224, 'lps'),
	(544000, 129, '2014-02-15 01:06:43.000000', 'consum', 0.0216, 'lps'),
	(544001, 129, '2014-02-15 01:06:44.000000', 'consum', 0.0225, 'lps'),
	(544002, 129, '2014-02-15 01:06:45.000000', 'consum', 0.0215, 'lps'),
	(544003, 129, '2014-02-15 01:06:46.000000', 'consum', 0.0216, 'lps'),
	(544004, 129, '2014-02-15 01:06:47.000000', 'consum', 0.0225, 'lps'),
	(544005, 129, '2014-02-15 01:06:48.000000', 'consum', 0.0218, 'lps'),
	(544006, 129, '2014-02-15 01:06:49.000000', 'consum', 0.0230, 'lps'),
	(544007, 129, '2014-02-15 01:06:50.000000', 'consum', 0.0211, 'lps'),
	(544008, 129, '2014-02-15 01:06:51.000000', 'consum', 0.0231, 'lps'),
	(544009, 129, '2014-02-15 01:06:52.000000', 'consum', 0.0211, 'lps'),
	(544010, 129, '2014-02-15 01:06:53.000000', 'consum', 0.0227, 'lps'),
	(544011, 129, '2014-02-15 01:06:54.000000', 'consum', 0.0218, 'lps'),
	(544012, 129, '2014-02-15 01:06:55.000000', 'consum', 0.0225, 'lps'),
	(544013, 129, '2014-02-15 01:06:56.000000', 'consum', 0.0211, 'lps'),
	(544014, 129, '2014-02-15 01:06:57.000000', 'consum', 0.0222, 'lps'),
	(544015, 129, '2014-02-15 01:06:58.000000', 'consum', 0.0216, 'lps'),
	(544016, 129, '2014-02-15 01:06:59.000000', 'consum', 0.0228, 'lps'),
	(544017, 129, '2014-02-15 01:07:00.000000', 'consum', 0.0210, 'lps'),
	(544018, 129, '2014-02-15 01:07:01.000000', 'consum', 0.0229, 'lps'),
	(544019, 129, '2014-02-15 01:07:02.000000', 'consum', 0.0231, 'lps'),
	(544020, 129, '2014-02-15 01:07:03.000000', 'consum', 0.0210, 'lps'),
	(544021, 129, '2014-02-15 01:07:04.000000', 'consum', 0.0223, 'lps'),
	(544022, 129, '2014-02-15 01:07:05.000000', 'consum', 0.0226, 'lps'),
	(544023, 129, '2014-02-15 01:07:06.000000', 'consum', 0.0227, 'lps'),
	(544024, 129, '2014-02-15 01:07:07.000000', 'consum', 0.0221, 'lps'),
	(544025, 129, '2014-02-15 01:07:08.000000', 'consum', 0.0216, 'lps'),
	(544026, 129, '2014-02-15 01:07:09.000000', 'consum', 0.0233, 'lps'),
	(544027, 129, '2014-02-15 01:07:10.000000', 'consum', 0.0230, 'lps'),
	(544028, 129, '2014-02-15 01:07:11.000000', 'consum', 0.0219, 'lps'),
	(544029, 129, '2014-02-15 01:07:12.000000', 'consum', 0.0219, 'lps'),
	(544030, 129, '2014-02-15 01:07:13.000000', 'consum', 0.0228, 'lps'),
	(544031, 129, '2014-02-15 01:07:14.000000', 'consum', 0.0222, 'lps'),
	(544032, 129, '2014-02-15 01:07:15.000000', 'consum', 0.0218, 'lps'),
	(544033, 129, '2014-02-15 01:07:16.000000', 'consum', 0.0216, 'lps'),
	(544034, 129, '2014-02-15 01:07:17.000000', 'consum', 0.0217, 'lps'),
	(544035, 129, '2014-02-15 01:07:18.000000', 'consum', 0.0226, 'lps'),
	(544036, 129, '2014-02-15 01:07:19.000000', 'consum', 0.0219, 'lps'),
	(544037, 129, '2014-02-15 01:07:20.000000', 'consum', 0.0234, 'lps'),
	(544038, 129, '2014-02-15 01:07:21.000000', 'consum', 0.0229, 'lps'),
	(544039, 129, '2014-02-15 01:07:22.000000', 'consum', 0.0232, 'lps'),
	(544040, 129, '2014-02-15 01:07:23.000000', 'consum', 0.0215, 'lps'),
	(544041, 129, '2014-02-15 01:07:24.000000', 'consum', 0.0218, 'lps'),
	(544042, 129, '2014-02-15 01:07:25.000000', 'consum', 0.0234, 'lps'),
	(544043, 129, '2014-02-15 01:07:26.000000', 'consum', 0.0233, 'lps'),
	(544044, 129, '2014-02-15 01:07:27.000000', 'consum', 0.0227, 'lps'),
	(544045, 129, '2014-02-15 01:07:28.000000', 'consum', 0.0226, 'lps'),
	(544046, 129, '2014-02-15 01:07:29.000000', 'consum', 0.0216, 'lps'),
	(544047, 129, '2014-02-15 01:07:30.000000', 'consum', 0.0217, 'lps'),
	(544048, 129, '2014-02-15 01:07:31.000000', 'consum', 0.0228, 'lps'),
	(544049, 129, '2014-02-15 01:07:32.000000', 'consum', 0.0229, 'lps'),
	(544050, 129, '2014-02-15 01:07:33.000000', 'consum', 0.0227, 'lps'),
	(544051, 129, '2014-02-15 01:07:34.000000', 'consum', 0.0212, 'lps'),
	(544052, 129, '2014-02-15 01:07:35.000000', 'consum', 0.0221, 'lps'),
	(544053, 129, '2014-02-15 01:07:36.000000', 'consum', 0.0234, 'lps'),
	(544054, 129, '2014-02-15 01:07:37.000000', 'consum', 0.0222, 'lps'),
	(544055, 129, '2014-02-15 01:07:38.000000', 'consum', 0.0222, 'lps'),
	(544056, 129, '2014-02-15 01:07:39.000000', 'consum', 0.0210, 'lps'),
	(544057, 129, '2014-02-15 01:07:40.000000', 'consum', 0.0226, 'lps'),
	(544058, 129, '2014-02-15 01:07:41.000000', 'consum', 0.0216, 'lps'),
	(544059, 129, '2014-02-15 01:07:42.000000', 'consum', 0.0216, 'lps'),
	(544060, 129, '2014-02-15 01:07:43.000000', 'consum', 0.0221, 'lps'),
	(544061, 129, '2014-02-15 01:07:44.000000', 'consum', 0.0226, 'lps'),
	(544062, 129, '2014-02-15 01:07:45.000000', 'consum', 0.0230, 'lps'),
	(544063, 129, '2014-02-15 01:07:46.000000', 'consum', 0.0212, 'lps'),
	(544064, 129, '2014-02-15 01:07:47.000000', 'consum', 0.0211, 'lps'),
	(544065, 129, '2014-02-15 01:07:48.000000', 'consum', 0.0233, 'lps'),
	(544066, 129, '2014-02-15 01:07:49.000000', 'consum', 0.0224, 'lps'),
	(544067, 129, '2014-02-15 01:07:50.000000', 'consum', 0.0212, 'lps'),
	(544068, 129, '2014-02-15 01:07:51.000000', 'consum', 0.0229, 'lps'),
	(544069, 129, '2014-02-15 01:07:52.000000', 'consum', 0.0224, 'lps'),
	(544070, 129, '2014-02-15 01:07:53.000000', 'consum', 0.0225, 'lps'),
	(544071, 129, '2014-02-15 01:07:54.000000', 'consum', 0.0217, 'lps'),
	(544072, 129, '2014-02-15 01:07:55.000000', 'consum', 0.0226, 'lps'),
	(544073, 129, '2014-02-15 01:07:56.000000', 'consum', 0.0219, 'lps'),
	(544074, 129, '2014-02-15 01:07:57.000000', 'consum', 0.0232, 'lps'),
	(544075, 129, '2014-02-15 01:07:58.000000', 'consum', 0.0217, 'lps'),
	(544076, 129, '2014-02-15 01:07:59.000000', 'consum', 0.0231, 'lps'),
	(544077, 129, '2014-02-15 01:08:00.000000', 'consum', 0.0219, 'lps'),
	(544078, 129, '2014-02-15 01:08:01.000000', 'consum', 0.0219, 'lps'),
	(544079, 129, '2014-02-15 01:08:02.000000', 'consum', 0.0226, 'lps'),
	(544080, 129, '2014-02-15 01:08:03.000000', 'consum', 0.0216, 'lps'),
	(544081, 129, '2014-02-15 01:08:04.000000', 'consum', 0.0216, 'lps'),
	(544082, 129, '2014-02-15 01:08:05.000000', 'consum', 0.0221, 'lps'),
	(544083, 129, '2014-02-15 01:08:06.000000', 'consum', 0.0223, 'lps'),
	(544084, 129, '2014-02-15 01:08:07.000000', 'consum', 0.0217, 'lps'),
	(544085, 129, '2014-02-15 01:08:08.000000', 'consum', 0.0234, 'lps'),
	(544086, 129, '2014-02-15 01:08:09.000000', 'consum', 0.0234, 'lps'),
	(544087, 129, '2014-02-15 01:08:10.000000', 'consum', 0.0233, 'lps'),
	(544088, 129, '2014-02-15 01:08:11.000000', 'consum', 0.0229, 'lps'),
	(544089, 129, '2014-02-15 01:08:12.000000', 'consum', 0.0211, 'lps'),
	(544090, 129, '2014-02-15 01:08:13.000000', 'consum', 0.0234, 'lps'),
	(544091, 129, '2014-02-15 01:08:14.000000', 'consum', 0.0227, 'lps'),
	(544092, 129, '2014-02-15 01:08:15.000000', 'consum', 0.0223, 'lps'),
	(544093, 129, '2014-02-15 01:08:16.000000', 'consum', 0.0223, 'lps'),
	(544094, 129, '2014-02-15 01:08:17.000000', 'consum', 0.0213, 'lps'),
	(544095, 129, '2014-02-15 01:08:18.000000', 'consum', 0.0234, 'lps'),
	(544096, 129, '2014-02-15 01:08:19.000000', 'consum', 0.0225, 'lps'),
	(544097, 129, '2014-02-15 01:08:20.000000', 'consum', 0.0212, 'lps'),
	(544098, 129, '2014-02-15 01:08:21.000000', 'consum', 0.0226, 'lps'),
	(544099, 129, '2014-02-15 01:08:22.000000', 'consum', 0.0211, 'lps'),
	(544100, 129, '2014-02-15 01:08:23.000000', 'consum', 0.0216, 'lps'),
	(544101, 129, '2014-02-15 01:08:24.000000', 'consum', 0.0214, 'lps'),
	(544102, 129, '2014-02-15 01:08:25.000000', 'consum', 0.0212, 'lps'),
	(544103, 129, '2014-02-15 01:08:26.000000', 'consum', 0.0233, 'lps'),
	(544104, 129, '2014-02-15 01:08:27.000000', 'consum', 0.0220, 'lps'),
	(544105, 129, '2014-02-15 01:08:28.000000', 'consum', 0.0215, 'lps'),
	(544106, 129, '2014-02-15 01:08:29.000000', 'consum', 0.0231, 'lps'),
	(544107, 129, '2014-02-15 01:08:30.000000', 'consum', 0.0227, 'lps'),
	(544108, 129, '2014-02-15 01:08:31.000000', 'consum', 0.0231, 'lps'),
	(544109, 129, '2014-02-15 01:08:32.000000', 'consum', 0.0216, 'lps'),
	(544110, 129, '2014-02-15 01:08:33.000000', 'consum', 0.0226, 'lps'),
	(544111, 129, '2014-02-15 01:08:34.000000', 'consum', 0.0222, 'lps'),
	(544112, 129, '2014-02-15 01:08:35.000000', 'consum', 0.0223, 'lps'),
	(544113, 129, '2014-02-15 01:08:36.000000', 'consum', 0.0217, 'lps'),
	(544114, 129, '2014-02-15 01:08:37.000000', 'consum', 0.0229, 'lps'),
	(544115, 129, '2014-02-15 01:08:38.000000', 'consum', 0.0210, 'lps'),
	(544116, 129, '2014-02-15 01:08:39.000000', 'consum', 0.0229, 'lps'),
	(544117, 129, '2014-02-15 01:08:40.000000', 'consum', 0.0230, 'lps'),
	(544118, 129, '2014-02-15 01:08:41.000000', 'consum', 0.0227, 'lps'),
	(544119, 129, '2014-02-15 01:08:42.000000', 'consum', 0.0212, 'lps'),
	(544120, 129, '2014-02-15 01:08:43.000000', 'consum', 0.0217, 'lps'),
	(544121, 129, '2014-02-15 01:08:44.000000', 'consum', 0.0218, 'lps'),
	(544122, 129, '2014-02-15 01:08:45.000000', 'consum', 0.0228, 'lps'),
	(544123, 129, '2014-02-15 01:08:46.000000', 'consum', 0.0227, 'lps'),
	(544124, 129, '2014-02-15 01:08:47.000000', 'consum', 0.0217, 'lps'),
	(544125, 129, '2014-02-15 01:08:48.000000', 'consum', 0.0220, 'lps'),
	(544126, 129, '2014-02-15 01:08:49.000000', 'consum', 0.0215, 'lps'),
	(544127, 129, '2014-02-15 01:08:50.000000', 'consum', 0.0231, 'lps'),
	(544128, 129, '2014-02-15 01:08:51.000000', 'consum', 0.0225, 'lps'),
	(544129, 129, '2014-02-15 01:08:52.000000', 'consum', 0.0224, 'lps'),
	(544130, 129, '2014-02-15 01:08:53.000000', 'consum', 0.0233, 'lps'),
	(544131, 129, '2014-02-15 01:08:54.000000', 'consum', 0.0211, 'lps'),
	(544132, 129, '2014-02-15 01:08:55.000000', 'consum', 0.0220, 'lps'),
	(544133, 129, '2014-02-15 01:08:56.000000', 'consum', 0.0233, 'lps'),
	(544134, 129, '2014-02-15 01:08:57.000000', 'consum', 0.0221, 'lps'),
	(544135, 129, '2014-02-15 01:08:58.000000', 'consum', 0.0222, 'lps'),
	(544136, 129, '2014-02-15 01:08:59.000000', 'consum', 0.0210, 'lps'),
	(544137, 129, '2014-02-15 01:09:00.000000', 'consum', 0.0226, 'lps'),
	(544138, 129, '2014-02-15 01:09:01.000000', 'consum', 0.0215, 'lps'),
	(544139, 129, '2014-02-15 01:09:02.000000', 'consum', 0.0212, 'lps'),
	(544140, 129, '2014-02-15 01:09:03.000000', 'consum', 0.0230, 'lps'),
	(544141, 129, '2014-02-15 01:09:04.000000', 'consum', 0.0231, 'lps'),
	(544142, 129, '2014-02-15 01:09:05.000000', 'consum', 0.0229, 'lps'),
	(544143, 129, '2014-02-15 01:09:06.000000', 'consum', 0.0220, 'lps'),
	(544144, 129, '2014-02-15 01:09:07.000000', 'consum', 0.0226, 'lps'),
	(544145, 129, '2014-02-15 01:09:08.000000', 'consum', 0.0210, 'lps'),
	(544146, 129, '2014-02-15 01:09:09.000000', 'consum', 0.0213, 'lps'),
	(544147, 129, '2014-02-15 01:09:10.000000', 'consum', 0.0228, 'lps'),
	(544148, 129, '2014-02-15 01:09:11.000000', 'consum', 0.0215, 'lps'),
	(544149, 129, '2014-02-15 01:09:12.000000', 'consum', 0.0230, 'lps'),
	(544150, 129, '2014-02-15 01:09:13.000000', 'consum', 0.0220, 'lps'),
	(544151, 129, '2014-02-15 01:09:14.000000', 'consum', 0.0225, 'lps'),
	(544152, 129, '2014-02-15 01:09:15.000000', 'consum', 0.0230, 'lps'),
	(544153, 129, '2014-02-15 01:09:16.000000', 'consum', 0.0217, 'lps'),
	(544154, 129, '2014-02-15 01:09:17.000000', 'consum', 0.0211, 'lps'),
	(544155, 129, '2014-02-15 01:09:18.000000', 'consum', 0.0220, 'lps'),
	(544156, 129, '2014-02-15 01:09:19.000000', 'consum', 0.0232, 'lps'),
	(544157, 129, '2014-02-15 01:09:20.000000', 'consum', 0.0215, 'lps'),
	(544158, 129, '2014-02-15 01:09:21.000000', 'consum', 0.0218, 'lps'),
	(544159, 129, '2014-02-15 01:09:22.000000', 'consum', 0.0213, 'lps'),
	(544160, 129, '2014-02-15 01:09:23.000000', 'consum', 0.0226, 'lps'),
	(544161, 129, '2014-02-15 01:09:24.000000', 'consum', 0.0232, 'lps'),
	(544162, 129, '2014-02-15 01:09:25.000000', 'consum', 0.0224, 'lps'),
	(544163, 129, '2014-02-15 01:09:26.000000', 'consum', 0.0213, 'lps'),
	(544164, 129, '2014-02-15 01:09:27.000000', 'consum', 0.0232, 'lps'),
	(544165, 129, '2014-02-15 01:09:28.000000', 'consum', 0.0213, 'lps'),
	(544166, 129, '2014-02-15 01:09:29.000000', 'consum', 0.0233, 'lps'),
	(544167, 129, '2014-02-15 01:09:30.000000', 'consum', 0.0219, 'lps'),
	(544168, 129, '2014-02-15 01:09:31.000000', 'consum', 0.0234, 'lps'),
	(544169, 129, '2014-02-15 01:09:32.000000', 'consum', 0.0230, 'lps'),
	(544170, 129, '2014-02-15 01:09:33.000000', 'consum', 0.0214, 'lps'),
	(544171, 129, '2014-02-15 01:09:34.000000', 'consum', 0.0219, 'lps'),
	(544172, 129, '2014-02-15 01:09:35.000000', 'consum', 0.0221, 'lps'),
	(544173, 129, '2014-02-15 01:09:36.000000', 'consum', 0.0211, 'lps'),
	(544174, 129, '2014-02-15 01:09:37.000000', 'consum', 0.0233, 'lps'),
	(544175, 129, '2014-02-15 01:09:38.000000', 'consum', 0.0225, 'lps'),
	(544176, 129, '2014-02-15 01:09:39.000000', 'consum', 0.0213, 'lps'),
	(544177, 129, '2014-02-15 01:09:40.000000', 'consum', 0.0232, 'lps'),
	(544178, 129, '2014-02-15 01:09:41.000000', 'consum', 0.0210, 'lps'),
	(544179, 129, '2014-02-15 01:09:42.000000', 'consum', 0.0218, 'lps'),
	(544180, 129, '2014-02-15 01:09:43.000000', 'consum', 0.0229, 'lps'),
	(544181, 129, '2014-02-15 01:09:44.000000', 'consum', 0.0230, 'lps'),
	(544182, 129, '2014-02-15 01:09:45.000000', 'consum', 0.0227, 'lps'),
	(544183, 129, '2014-02-15 01:09:46.000000', 'consum', 0.0211, 'lps'),
	(544184, 129, '2014-02-15 01:09:47.000000', 'consum', 0.0217, 'lps'),
	(544185, 129, '2014-02-15 01:09:48.000000', 'consum', 0.0216, 'lps'),
	(544186, 129, '2014-02-15 01:09:49.000000', 'consum', 0.0222, 'lps'),
	(544187, 129, '2014-02-15 01:09:50.000000', 'consum', 0.0224, 'lps'),
	(544188, 129, '2014-02-15 01:09:51.000000', 'consum', 0.0220, 'lps'),
	(544189, 129, '2014-02-15 01:09:52.000000', 'consum', 0.0217, 'lps'),
	(544190, 129, '2014-02-15 01:09:53.000000', 'consum', 0.0219, 'lps'),
	(544191, 129, '2014-02-15 01:09:54.000000', 'consum', 0.0231, 'lps'),
	(544192, 129, '2014-02-15 01:09:55.000000', 'consum', 0.0215, 'lps'),
	(544193, 129, '2014-02-15 01:09:56.000000', 'consum', 0.0221, 'lps'),
	(544194, 129, '2014-02-15 01:09:57.000000', 'consum', 0.0228, 'lps'),
	(544195, 129, '2014-02-15 01:09:58.000000', 'consum', 0.0215, 'lps'),
	(544196, 129, '2014-02-15 01:09:59.000000', 'consum', 0.0233, 'lps'),
	(544197, 129, '2014-02-15 01:10:00.000000', 'consum', 0.0211, 'lps'),
	(544198, 129, '2014-02-15 01:10:01.000000', 'consum', 0.0219, 'lps'),
	(544199, 129, '2014-02-15 01:10:02.000000', 'consum', 0.0228, 'lps'),
	(544200, 129, '2014-02-15 01:10:03.000000', 'consum', 0.0224, 'lps'),
	(544201, 129, '2014-02-15 01:10:04.000000', 'consum', 0.0227, 'lps'),
	(544202, 129, '2014-02-15 01:10:05.000000', 'consum', 0.0229, 'lps'),
	(544203, 129, '2014-02-15 01:10:06.000000', 'consum', 0.0228, 'lps'),
	(544204, 129, '2014-02-15 01:10:07.000000', 'consum', 0.0221, 'lps'),
	(544205, 129, '2014-02-15 01:10:08.000000', 'consum', 0.0211, 'lps'),
	(544206, 129, '2014-02-15 01:10:09.000000', 'consum', 0.0233, 'lps'),
	(544207, 129, '2014-02-15 01:10:10.000000', 'consum', 0.0220, 'lps'),
	(544208, 129, '2014-02-15 01:10:11.000000', 'consum', 0.0217, 'lps'),
	(544209, 129, '2014-02-15 01:10:12.000000', 'consum', 0.0216, 'lps'),
	(544210, 129, '2014-02-15 01:10:13.000000', 'consum', 0.0221, 'lps'),
	(544211, 129, '2014-02-15 01:10:14.000000', 'consum', 0.0220, 'lps'),
	(544212, 129, '2014-02-15 01:10:15.000000', 'consum', 0.0228, 'lps'),
	(544213, 129, '2014-02-15 01:10:16.000000', 'consum', 0.0219, 'lps'),
	(544214, 129, '2014-02-15 01:10:17.000000', 'consum', 0.0229, 'lps'),
	(544215, 129, '2014-02-15 01:10:18.000000', 'consum', 0.0228, 'lps'),
	(544216, 129, '2014-02-15 01:10:19.000000', 'consum', 0.0220, 'lps'),
	(544217, 129, '2014-02-15 01:10:20.000000', 'consum', 0.0230, 'lps'),
	(544218, 129, '2014-02-15 01:10:21.000000', 'consum', 0.0231, 'lps'),
	(544219, 129, '2014-02-15 01:10:22.000000', 'consum', 0.0232, 'lps'),
	(544220, 129, '2014-02-15 01:10:23.000000', 'consum', 0.0232, 'lps'),
	(544221, 129, '2014-02-15 01:10:24.000000', 'consum', 0.0228, 'lps'),
	(544222, 129, '2014-02-15 01:10:25.000000', 'consum', 0.0234, 'lps'),
	(544223, 129, '2014-02-15 01:10:26.000000', 'consum', 0.0228, 'lps'),
	(544224, 129, '2014-02-15 01:10:27.000000', 'consum', 0.0229, 'lps'),
	(544225, 129, '2014-02-15 01:10:28.000000', 'consum', 0.0225, 'lps'),
	(544226, 129, '2014-02-15 01:10:29.000000', 'consum', 0.0228, 'lps'),
	(544227, 129, '2014-02-15 01:10:30.000000', 'consum', 0.0233, 'lps'),
	(544228, 129, '2014-02-15 01:10:31.000000', 'consum', 0.0220, 'lps'),
	(544229, 129, '2014-02-15 01:10:32.000000', 'consum', 0.0216, 'lps'),
	(544230, 129, '2014-02-15 01:10:33.000000', 'consum', 0.0212, 'lps'),
	(544231, 129, '2014-02-15 01:10:34.000000', 'consum', 0.0227, 'lps'),
	(544232, 129, '2014-02-15 01:10:35.000000', 'consum', 0.0213, 'lps'),
	(544233, 129, '2014-02-15 01:10:36.000000', 'consum', 0.0227, 'lps'),
	(544234, 129, '2014-02-15 01:10:37.000000', 'consum', 0.0234, 'lps'),
	(544235, 129, '2014-02-15 01:10:38.000000', 'consum', 0.0231, 'lps'),
	(544236, 129, '2014-02-15 01:10:39.000000', 'consum', 0.0219, 'lps'),
	(544237, 129, '2014-02-15 01:10:40.000000', 'consum', 0.0216, 'lps'),
	(544238, 129, '2014-02-15 01:10:41.000000', 'consum', 0.0214, 'lps'),
	(544239, 129, '2014-02-15 01:10:42.000000', 'consum', 0.0214, 'lps'),
	(544240, 129, '2014-02-15 01:10:43.000000', 'consum', 0.0216, 'lps'),
	(544241, 129, '2014-02-15 01:10:44.000000', 'consum', 0.0229, 'lps'),
	(544242, 129, '2014-02-15 01:10:45.000000', 'consum', 0.0215, 'lps'),
	(544243, 129, '2014-02-15 01:10:46.000000', 'consum', 0.0226, 'lps'),
	(544244, 129, '2014-02-15 01:10:47.000000', 'consum', 0.0228, 'lps'),
	(544245, 129, '2014-02-15 01:10:48.000000', 'consum', 0.0227, 'lps'),
	(544246, 129, '2014-02-15 01:10:49.000000', 'consum', 0.0215, 'lps'),
	(544247, 129, '2014-02-15 01:10:50.000000', 'consum', 0.0234, 'lps'),
	(544248, 129, '2014-02-15 01:10:51.000000', 'consum', 0.0218, 'lps'),
	(544249, 129, '2014-02-15 01:10:52.000000', 'consum', 0.0228, 'lps'),
	(544250, 129, '2014-02-15 01:10:53.000000', 'consum', 0.0227, 'lps'),
	(544251, 129, '2014-02-15 01:10:54.000000', 'consum', 0.0216, 'lps'),
	(544252, 129, '2014-02-15 01:10:55.000000', 'consum', 0.0213, 'lps'),
	(544253, 129, '2014-02-15 01:10:56.000000', 'consum', 0.0210, 'lps'),
	(544254, 129, '2014-02-15 01:10:57.000000', 'consum', 0.0224, 'lps'),
	(544255, 129, '2014-02-15 01:10:58.000000', 'consum', 0.0230, 'lps'),
	(544256, 129, '2014-02-15 01:10:59.000000', 'consum', 0.0218, 'lps'),
	(544257, 129, '2014-02-15 01:11:00.000000', 'consum', 0.0215, 'lps'),
	(544258, 129, '2014-02-15 01:11:01.000000', 'consum', 0.0214, 'lps'),
	(544259, 129, '2014-02-15 01:11:02.000000', 'consum', 0.0212, 'lps'),
	(544260, 129, '2014-02-15 01:11:03.000000', 'consum', 0.0212, 'lps'),
	(544261, 129, '2014-02-15 01:11:04.000000', 'consum', 0.0213, 'lps'),
	(544262, 129, '2014-02-15 01:11:05.000000', 'consum', 0.0219, 'lps'),
	(544263, 129, '2014-02-15 01:11:06.000000', 'consum', 0.0224, 'lps'),
	(544264, 129, '2014-02-15 01:11:07.000000', 'consum', 0.0225, 'lps'),
	(544265, 129, '2014-02-15 01:11:08.000000', 'consum', 0.0222, 'lps'),
	(544266, 129, '2014-02-15 01:11:09.000000', 'consum', 0.0224, 'lps'),
	(544267, 129, '2014-02-15 01:11:10.000000', 'consum', 0.0219, 'lps'),
	(544268, 129, '2014-02-15 01:11:11.000000', 'consum', 0.0213, 'lps'),
	(544269, 129, '2014-02-15 01:11:12.000000', 'consum', 0.0225, 'lps'),
	(544270, 129, '2014-02-15 01:11:13.000000', 'consum', 0.0226, 'lps'),
	(544271, 129, '2014-02-15 01:11:14.000000', 'consum', 0.0220, 'lps'),
	(544272, 129, '2014-02-15 01:11:15.000000', 'consum', 0.0215, 'lps'),
	(544273, 129, '2014-02-15 01:11:16.000000', 'consum', 0.0227, 'lps'),
	(544274, 129, '2014-02-15 01:11:17.000000', 'consum', 0.0232, 'lps'),
	(544275, 129, '2014-02-15 01:11:18.000000', 'consum', 0.0219, 'lps'),
	(544276, 129, '2014-02-15 01:11:19.000000', 'consum', 0.0213, 'lps'),
	(544277, 129, '2014-02-15 01:11:20.000000', 'consum', 0.0226, 'lps'),
	(544278, 129, '2014-02-15 01:11:21.000000', 'consum', 0.0229, 'lps'),
	(544279, 129, '2014-02-15 01:11:22.000000', 'consum', 0.0232, 'lps'),
	(544280, 129, '2014-02-15 01:11:23.000000', 'consum', 0.0213, 'lps'),
	(544281, 129, '2014-02-15 01:11:24.000000', 'consum', 0.0212, 'lps'),
	(544282, 129, '2014-02-15 01:11:25.000000', 'consum', 0.0234, 'lps'),
	(544283, 129, '2014-02-15 01:11:26.000000', 'consum', 0.0227, 'lps'),
	(544284, 129, '2014-02-15 01:11:27.000000', 'consum', 0.0221, 'lps'),
	(544285, 129, '2014-02-15 01:11:28.000000', 'consum', 0.0214, 'lps'),
	(544286, 129, '2014-02-15 01:11:29.000000', 'consum', 0.0222, 'lps'),
	(544287, 129, '2014-02-15 01:11:30.000000', 'consum', 0.0232, 'lps'),
	(544288, 129, '2014-02-15 01:11:31.000000', 'consum', 0.0213, 'lps'),
	(544289, 129, '2014-02-15 01:11:32.000000', 'consum', 0.0210, 'lps'),
	(544290, 129, '2014-02-15 01:11:33.000000', 'consum', 0.0225, 'lps'),
	(544291, 129, '2014-02-15 01:11:34.000000', 'consum', 0.0212, 'lps'),
	(544292, 129, '2014-02-15 01:11:35.000000', 'consum', 0.0223, 'lps'),
	(544293, 129, '2014-02-15 01:11:36.000000', 'consum', 0.0219, 'lps'),
	(544294, 129, '2014-02-15 01:11:37.000000', 'consum', 0.0218, 'lps'),
	(544295, 129, '2014-02-15 01:11:38.000000', 'consum', 0.0222, 'lps'),
	(544296, 129, '2014-02-15 01:11:39.000000', 'consum', 0.0224, 'lps'),
	(544297, 129, '2014-02-15 01:11:40.000000', 'consum', 0.0220, 'lps'),
	(544298, 129, '2014-02-15 01:11:41.000000', 'consum', 0.0218, 'lps'),
	(544299, 129, '2014-02-15 01:11:42.000000', 'consum', 0.0222, 'lps'),
	(544300, 129, '2014-02-15 01:11:43.000000', 'consum', 0.0221, 'lps'),
	(544301, 129, '2014-02-15 01:11:44.000000', 'consum', 0.0227, 'lps'),
	(544302, 129, '2014-02-15 01:11:45.000000', 'consum', 0.0214, 'lps'),
	(544303, 129, '2014-02-15 01:11:46.000000', 'consum', 0.0230, 'lps'),
	(544304, 129, '2014-02-15 01:11:47.000000', 'consum', 0.0223, 'lps'),
	(544305, 129, '2014-02-15 01:11:48.000000', 'consum', 0.0214, 'lps'),
	(544306, 129, '2014-02-15 01:11:49.000000', 'consum', 0.0219, 'lps'),
	(544307, 129, '2014-02-15 01:11:50.000000', 'consum', 0.0216, 'lps'),
	(544308, 129, '2014-02-15 01:11:51.000000', 'consum', 0.0215, 'lps'),
	(544309, 129, '2014-02-15 01:11:52.000000', 'consum', 0.0217, 'lps'),
	(544310, 129, '2014-02-15 01:11:53.000000', 'consum', 0.0229, 'lps'),
	(544311, 129, '2014-02-15 01:11:54.000000', 'consum', 0.0210, 'lps'),
	(544312, 129, '2014-02-15 01:11:55.000000', 'consum', 0.0229, 'lps'),
	(544313, 129, '2014-02-15 01:11:56.000000', 'consum', 0.0229, 'lps'),
	(544314, 129, '2014-02-15 01:11:57.000000', 'consum', 0.0224, 'lps'),
	(544315, 129, '2014-02-15 01:11:58.000000', 'consum', 0.0225, 'lps'),
	(544316, 129, '2014-02-15 01:11:59.000000', 'consum', 0.0216, 'lps'),
	(544317, 129, '2014-02-15 01:12:00.000000', 'consum', 0.0223, 'lps'),
	(544318, 129, '2014-02-15 01:12:01.000000', 'consum', 0.0234, 'lps'),
	(544319, 129, '2014-02-15 01:12:02.000000', 'consum', 0.0213, 'lps'),
	(544320, 129, '2014-02-15 01:12:03.000000', 'consum', 0.0230, 'lps'),
	(544321, 129, '2014-02-15 01:12:04.000000', 'consum', 0.0225, 'lps'),
	(544322, 129, '2014-02-15 01:12:05.000000', 'consum', 0.0226, 'lps'),
	(544323, 129, '2014-02-15 01:12:06.000000', 'consum', 0.0221, 'lps'),
	(544324, 129, '2014-02-15 01:12:07.000000', 'consum', 0.0219, 'lps'),
	(544325, 129, '2014-02-15 01:12:08.000000', 'consum', 0.0221, 'lps'),
	(544326, 129, '2014-02-15 01:12:09.000000', 'consum', 0.0215, 'lps'),
	(544327, 129, '2014-02-15 01:12:10.000000', 'consum', 0.0227, 'lps'),
	(544328, 129, '2014-02-15 01:12:11.000000', 'consum', 0.0232, 'lps'),
	(544329, 129, '2014-02-15 01:12:12.000000', 'consum', 0.0216, 'lps'),
	(544330, 129, '2014-02-15 01:12:13.000000', 'consum', 0.0227, 'lps'),
	(544331, 129, '2014-02-15 01:12:14.000000', 'consum', 0.0228, 'lps'),
	(544332, 129, '2014-02-15 01:12:15.000000', 'consum', 0.0222, 'lps'),
	(544333, 129, '2014-02-15 01:12:16.000000', 'consum', 0.0218, 'lps'),
	(544334, 129, '2014-02-15 01:12:17.000000', 'consum', 0.0216, 'lps'),
	(544335, 129, '2014-02-15 01:12:18.000000', 'consum', 0.0215, 'lps'),
	(544336, 129, '2014-02-15 01:12:19.000000', 'consum', 0.0219, 'lps'),
	(544337, 129, '2014-02-15 01:12:20.000000', 'consum', 0.0216, 'lps'),
	(544338, 129, '2014-02-15 01:12:21.000000', 'consum', 0.0213, 'lps'),
	(544339, 129, '2014-02-15 01:12:22.000000', 'consum', 0.0233, 'lps'),
	(544340, 129, '2014-02-15 01:12:23.000000', 'consum', 0.0214, 'lps'),
	(544341, 129, '2014-02-15 01:12:24.000000', 'consum', 0.0213, 'lps'),
	(544342, 129, '2014-02-15 01:12:25.000000', 'consum', 0.0214, 'lps'),
	(544343, 129, '2014-02-15 01:12:26.000000', 'consum', 0.0223, 'lps'),
	(544344, 129, '2014-02-15 01:12:27.000000', 'consum', 0.0212, 'lps'),
	(544345, 129, '2014-02-15 01:12:28.000000', 'consum', 0.0233, 'lps'),
	(544346, 129, '2014-02-15 01:12:29.000000', 'consum', 0.0220, 'lps'),
	(544347, 129, '2014-02-15 01:12:30.000000', 'consum', 0.0215, 'lps'),
	(544348, 129, '2014-02-15 01:12:31.000000', 'consum', 0.0231, 'lps'),
	(544349, 129, '2014-02-15 01:12:32.000000', 'consum', 0.0223, 'lps'),
	(544350, 129, '2014-02-15 01:12:33.000000', 'consum', 0.0216, 'lps'),
	(544351, 129, '2014-02-15 01:12:34.000000', 'consum', 0.0224, 'lps'),
	(544352, 129, '2014-02-15 01:12:35.000000', 'consum', 0.0214, 'lps'),
	(544353, 129, '2014-02-15 01:12:36.000000', 'consum', 0.0212, 'lps'),
	(544354, 129, '2014-02-15 01:12:37.000000', 'consum', 0.0233, 'lps'),
	(544355, 129, '2014-02-15 01:12:38.000000', 'consum', 0.0219, 'lps'),
	(544356, 129, '2014-02-15 01:12:39.000000', 'consum', 0.0212, 'lps'),
	(544357, 129, '2014-02-15 01:12:40.000000', 'consum', 0.0218, 'lps'),
	(544358, 129, '2014-02-15 01:12:41.000000', 'consum', 0.0222, 'lps'),
	(544359, 129, '2014-02-15 01:12:42.000000', 'consum', 0.0221, 'lps'),
	(544360, 129, '2014-02-15 01:12:43.000000', 'consum', 0.0228, 'lps'),
	(544361, 129, '2014-02-15 01:12:44.000000', 'consum', 0.0219, 'lps'),
	(544362, 129, '2014-02-15 01:12:45.000000', 'consum', 0.0226, 'lps'),
	(544363, 129, '2014-02-15 01:12:46.000000', 'consum', 0.0214, 'lps'),
	(544364, 129, '2014-02-15 01:12:47.000000', 'consum', 0.0230, 'lps'),
	(544365, 129, '2014-02-15 01:12:48.000000', 'consum', 0.0227, 'lps'),
	(544366, 129, '2014-02-15 01:12:49.000000', 'consum', 0.0233, 'lps'),
	(544367, 129, '2014-02-15 01:12:50.000000', 'consum', 0.0225, 'lps'),
	(544368, 129, '2014-02-15 01:12:51.000000', 'consum', 0.0217, 'lps'),
	(544369, 129, '2014-02-15 01:12:52.000000', 'consum', 0.0227, 'lps'),
	(544370, 129, '2014-02-15 01:12:53.000000', 'consum', 0.0223, 'lps'),
	(544371, 129, '2014-02-15 01:12:54.000000', 'consum', 0.0224, 'lps'),
	(544372, 129, '2014-02-15 01:12:55.000000', 'consum', 0.0219, 'lps'),
	(544373, 129, '2014-02-15 01:12:56.000000', 'consum', 0.0210, 'lps'),
	(544374, 129, '2014-02-15 01:12:57.000000', 'consum', 0.0211, 'lps'),
	(544375, 129, '2014-02-15 01:12:58.000000', 'consum', 0.0213, 'lps'),
	(544376, 129, '2014-02-15 01:12:59.000000', 'consum', 0.0223, 'lps'),
	(544377, 129, '2014-02-15 01:13:00.000000', 'consum', 0.0219, 'lps'),
	(544378, 129, '2014-02-15 01:13:01.000000', 'consum', 0.0215, 'lps'),
	(544379, 129, '2014-02-15 01:13:02.000000', 'consum', 0.0233, 'lps'),
	(544380, 129, '2014-02-15 01:13:03.000000', 'consum', 0.0211, 'lps'),
	(544381, 129, '2014-02-15 01:13:04.000000', 'consum', 0.0219, 'lps'),
	(544382, 129, '2014-02-15 01:13:05.000000', 'consum', 0.0231, 'lps'),
	(544383, 129, '2014-02-15 01:13:06.000000', 'consum', 0.0212, 'lps'),
	(544384, 129, '2014-02-15 01:13:07.000000', 'consum', 0.0231, 'lps'),
	(544385, 129, '2014-02-15 01:13:08.000000', 'consum', 0.0211, 'lps'),
	(544386, 129, '2014-02-15 01:13:09.000000', 'consum', 0.0227, 'lps'),
	(544387, 129, '2014-02-15 01:13:10.000000', 'consum', 0.0219, 'lps'),
	(544388, 129, '2014-02-15 01:13:11.000000', 'consum', 0.0228, 'lps'),
	(544389, 129, '2014-02-15 01:13:12.000000', 'consum', 0.0222, 'lps'),
	(544390, 129, '2014-02-15 01:13:13.000000', 'consum', 0.0217, 'lps'),
	(544391, 129, '2014-02-15 01:13:14.000000', 'consum', 0.0234, 'lps'),
	(544392, 129, '2014-02-15 01:13:15.000000', 'consum', 0.0211, 'lps'),
	(544393, 129, '2014-02-15 01:13:16.000000', 'consum', 0.0217, 'lps'),
	(544394, 129, '2014-02-15 01:13:17.000000', 'consum', 0.0220, 'lps'),
	(544395, 129, '2014-02-15 01:13:18.000000', 'consum', 0.0212, 'lps'),
	(544396, 129, '2014-02-15 01:13:19.000000', 'consum', 0.0217, 'lps'),
	(544397, 129, '2014-02-15 01:13:20.000000', 'consum', 0.0212, 'lps'),
	(544398, 129, '2014-02-15 01:13:21.000000', 'consum', 0.0227, 'lps'),
	(544399, 129, '2014-02-15 01:13:22.000000', 'consum', 0.0216, 'lps'),
	(544400, 129, '2014-02-15 01:13:23.000000', 'consum', 0.0212, 'lps'),
	(544401, 129, '2014-02-15 01:13:24.000000', 'consum', 0.0229, 'lps'),
	(544402, 129, '2014-02-15 01:13:25.000000', 'consum', 0.0225, 'lps'),
	(544403, 129, '2014-02-15 01:13:26.000000', 'consum', 0.0229, 'lps'),
	(544404, 129, '2014-02-15 01:13:27.000000', 'consum', 0.0211, 'lps'),
	(544405, 129, '2014-02-15 01:13:28.000000', 'consum', 0.0232, 'lps'),
	(544406, 129, '2014-02-15 01:13:29.000000', 'consum', 0.0218, 'lps'),
	(544407, 129, '2014-02-15 01:13:30.000000', 'consum', 0.0211, 'lps'),
	(544408, 129, '2014-02-15 01:13:31.000000', 'consum', 0.0217, 'lps'),
	(544409, 129, '2014-02-15 01:13:32.000000', 'consum', 0.0216, 'lps'),
	(544410, 129, '2014-02-15 01:13:33.000000', 'consum', 0.0221, 'lps'),
	(544411, 129, '2014-02-15 01:13:34.000000', 'consum', 0.0222, 'lps'),
	(544412, 129, '2014-02-15 01:13:35.000000', 'consum', 0.0213, 'lps'),
	(544413, 129, '2014-02-15 01:13:36.000000', 'consum', 0.0216, 'lps'),
	(544414, 129, '2014-02-15 01:13:37.000000', 'consum', 0.0229, 'lps'),
	(544415, 129, '2014-02-15 01:13:38.000000', 'consum', 0.0213, 'lps'),
	(544416, 129, '2014-02-15 01:13:39.000000', 'consum', 0.0218, 'lps'),
	(544417, 129, '2014-02-15 01:13:40.000000', 'consum', 0.0216, 'lps'),
	(544418, 129, '2014-02-15 01:13:41.000000', 'consum', 0.0219, 'lps'),
	(544419, 129, '2014-02-15 01:13:42.000000', 'consum', 0.0211, 'lps'),
	(544420, 129, '2014-02-15 01:13:43.000000', 'consum', 0.0215, 'lps'),
	(544421, 129, '2014-02-15 01:13:44.000000', 'consum', 0.0233, 'lps'),
	(544422, 129, '2014-02-15 01:13:45.000000', 'consum', 0.0234, 'lps'),
	(544423, 129, '2014-02-15 01:13:46.000000', 'consum', 0.0210, 'lps'),
	(544424, 129, '2014-02-15 01:13:47.000000', 'consum', 0.0217, 'lps'),
	(544425, 129, '2014-02-15 01:13:48.000000', 'consum', 0.0219, 'lps'),
	(544426, 129, '2014-02-15 01:13:49.000000', 'consum', 0.0232, 'lps'),
	(544427, 129, '2014-02-15 01:13:50.000000', 'consum', 0.0222, 'lps'),
	(544428, 129, '2014-02-15 01:13:51.000000', 'consum', 0.0227, 'lps'),
	(544429, 129, '2014-02-15 01:13:52.000000', 'consum', 0.0211, 'lps'),
	(544430, 129, '2014-02-15 01:13:53.000000', 'consum', 0.0214, 'lps'),
	(544431, 129, '2014-02-15 01:13:54.000000', 'consum', 0.0229, 'lps'),
	(544432, 129, '2014-02-15 01:13:55.000000', 'consum', 0.0217, 'lps'),
	(544433, 129, '2014-02-15 01:13:56.000000', 'consum', 0.0215, 'lps'),
	(544434, 129, '2014-02-15 01:13:57.000000', 'consum', 0.0214, 'lps'),
	(544435, 129, '2014-02-15 01:13:58.000000', 'consum', 0.0215, 'lps'),
	(544436, 129, '2014-02-15 01:13:59.000000', 'consum', 0.0224, 'lps'),
	(544437, 129, '2014-02-15 01:14:00.000000', 'consum', 0.0214, 'lps'),
	(544438, 129, '2014-02-15 01:14:01.000000', 'consum', 0.0214, 'lps'),
	(544439, 129, '2014-02-15 01:14:02.000000', 'consum', 0.0217, 'lps'),
	(544440, 129, '2014-02-15 01:14:03.000000', 'consum', 0.0234, 'lps'),
	(544441, 129, '2014-02-15 01:14:04.000000', 'consum', 0.0234, 'lps'),
	(544442, 129, '2014-02-15 01:14:05.000000', 'consum', 0.0233, 'lps'),
	(544443, 129, '2014-02-15 01:14:06.000000', 'consum', 0.0231, 'lps'),
	(544444, 129, '2014-02-15 01:14:07.000000', 'consum', 0.0222, 'lps'),
	(544445, 129, '2014-02-15 01:14:08.000000', 'consum', 0.0229, 'lps'),
	(544446, 129, '2014-02-15 01:14:09.000000', 'consum', 0.0223, 'lps'),
	(544447, 129, '2014-02-15 01:14:10.000000', 'consum', 0.0218, 'lps'),
	(544448, 129, '2014-02-15 01:14:11.000000', 'consum', 0.0210, 'lps'),
	(544449, 129, '2014-02-15 01:14:12.000000', 'consum', 0.0213, 'lps'),
	(544450, 129, '2014-02-15 01:14:13.000000', 'consum', 0.0225, 'lps'),
	(544451, 129, '2014-02-15 01:14:14.000000', 'consum', 0.0225, 'lps'),
	(544452, 129, '2014-02-15 01:14:15.000000', 'consum', 0.0216, 'lps'),
	(544453, 129, '2014-02-15 01:14:16.000000', 'consum', 0.0219, 'lps'),
	(544454, 129, '2014-02-15 01:14:17.000000', 'consum', 0.0216, 'lps'),
	(544455, 129, '2014-02-15 01:14:18.000000', 'consum', 0.0210, 'lps'),
	(544456, 129, '2014-02-15 01:14:19.000000', 'consum', 0.0220, 'lps'),
	(544457, 129, '2014-02-15 01:14:20.000000', 'consum', 0.0211, 'lps'),
	(544458, 129, '2014-02-15 01:14:21.000000', 'consum', 0.0211, 'lps'),
	(544459, 129, '2014-02-15 01:14:22.000000', 'consum', 0.0213, 'lps'),
	(544460, 129, '2014-02-15 01:14:23.000000', 'consum', 0.0221, 'lps'),
	(544461, 129, '2014-02-15 01:14:24.000000', 'consum', 0.0233, 'lps'),
	(544462, 129, '2014-02-15 01:14:25.000000', 'consum', 0.0218, 'lps'),
	(544463, 129, '2014-02-15 01:14:26.000000', 'consum', 0.0229, 'lps'),
	(544464, 129, '2014-02-15 01:14:27.000000', 'consum', 0.0231, 'lps'),
	(544465, 129, '2014-02-15 01:14:28.000000', 'consum', 0.0211, 'lps'),
	(544466, 129, '2014-02-15 01:14:29.000000', 'consum', 0.0228, 'lps'),
	(544467, 129, '2014-02-15 01:14:30.000000', 'consum', 0.0221, 'lps'),
	(544468, 129, '2014-02-15 01:14:31.000000', 'consum', 0.0213, 'lps'),
	(544469, 129, '2014-02-15 01:14:32.000000', 'consum', 0.0215, 'lps'),
	(544470, 129, '2014-02-15 01:14:33.000000', 'consum', 0.0226, 'lps'),
	(544471, 129, '2014-02-15 01:14:34.000000', 'consum', 0.0227, 'lps'),
	(544472, 129, '2014-02-15 01:14:35.000000', 'consum', 0.0223, 'lps'),
	(544473, 129, '2014-02-15 01:14:36.000000', 'consum', 0.0223, 'lps'),
	(544474, 129, '2014-02-15 01:14:37.000000', 'consum', 0.0213, 'lps'),
	(544475, 129, '2014-02-15 01:14:38.000000', 'consum', 0.0211, 'lps'),
	(544476, 129, '2014-02-15 01:14:39.000000', 'consum', 0.0233, 'lps'),
	(544477, 129, '2014-02-15 01:14:40.000000', 'consum', 0.0221, 'lps'),
	(544478, 129, '2014-02-15 01:14:41.000000', 'consum', 0.0222, 'lps'),
	(544479, 129, '2014-02-15 01:14:42.000000', 'consum', 0.0214, 'lps'),
	(544480, 129, '2014-02-15 01:14:43.000000', 'consum', 0.0219, 'lps'),
	(544481, 129, '2014-02-15 01:14:44.000000', 'consum', 0.0216, 'lps'),
	(544482, 129, '2014-02-15 01:14:45.000000', 'consum', 0.0215, 'lps'),
	(544483, 129, '2014-02-15 01:14:46.000000', 'consum', 0.0219, 'lps'),
	(544484, 129, '2014-02-15 01:14:47.000000', 'consum', 0.0214, 'lps'),
	(544485, 129, '2014-02-15 01:14:48.000000', 'consum', 0.0229, 'lps'),
	(544486, 129, '2014-02-15 01:14:49.000000', 'consum', 0.0220, 'lps'),
	(544487, 129, '2014-02-15 01:14:50.000000', 'consum', 0.0226, 'lps'),
	(544488, 129, '2014-02-15 01:14:51.000000', 'consum', 0.0211, 'lps'),
	(544489, 129, '2014-02-15 01:14:52.000000', 'consum', 0.0216, 'lps'),
	(544490, 129, '2014-02-15 01:14:53.000000', 'consum', 0.0212, 'lps'),
	(544491, 129, '2014-02-15 01:14:54.000000', 'consum', 0.0230, 'lps'),
	(544492, 129, '2014-02-15 01:14:55.000000', 'consum', 0.0230, 'lps'),
	(544493, 129, '2014-02-15 01:14:56.000000', 'consum', 0.0225, 'lps'),
	(544494, 129, '2014-02-15 01:14:57.000000', 'consum', 0.0227, 'lps'),
	(544495, 129, '2014-02-15 01:14:58.000000', 'consum', 0.0223, 'lps'),
	(544496, 129, '2014-02-15 01:14:59.000000', 'consum', 0.0224, 'lps'),
	(544497, 129, '2014-02-15 01:15:00.000000', 'consum', 0.0217, 'lps'),
	(544498, 129, '2014-02-15 01:15:01.000000', 'consum', 0.0231, 'lps'),
	(544499, 129, '2014-02-15 01:15:02.000000', 'consum', 0.0216, 'lps'),
	(544500, 129, '2014-02-15 01:15:03.000000', 'consum', 0.0228, 'lps'),
	(544501, 129, '2014-02-15 01:15:04.000000', 'consum', 0.0234, 'lps'),
	(544502, 129, '2014-02-15 01:15:05.000000', 'consum', 0.0226, 'lps'),
	(544503, 129, '2014-02-15 01:15:06.000000', 'consum', 0.0220, 'lps'),
	(544504, 129, '2014-02-15 01:15:07.000000', 'consum', 0.0213, 'lps'),
	(544505, 129, '2014-02-15 01:15:08.000000', 'consum', 0.0218, 'lps'),
	(544506, 129, '2014-02-15 01:15:09.000000', 'consum', 0.0216, 'lps'),
	(544507, 129, '2014-02-15 01:15:10.000000', 'consum', 0.0216, 'lps'),
	(544508, 129, '2014-02-15 01:15:11.000000', 'consum', 0.0223, 'lps'),
	(544509, 129, '2014-02-15 01:15:12.000000', 'consum', 0.0210, 'lps'),
	(544510, 129, '2014-02-15 01:15:13.000000', 'consum', 0.0219, 'lps'),
	(544511, 129, '2014-02-15 01:15:14.000000', 'consum', 0.0233, 'lps'),
	(544512, 129, '2014-02-15 01:15:15.000000', 'consum', 0.0220, 'lps'),
	(544513, 129, '2014-02-15 01:15:16.000000', 'consum', 0.0220, 'lps'),
	(544514, 129, '2014-02-15 01:15:17.000000', 'consum', 0.0230, 'lps'),
	(544515, 129, '2014-02-15 01:15:18.000000', 'consum', 0.0228, 'lps'),
	(544516, 129, '2014-02-15 01:15:19.000000', 'consum', 0.0219, 'lps'),
	(544517, 129, '2014-02-15 01:15:20.000000', 'consum', 0.0224, 'lps'),
	(544518, 129, '2014-02-15 01:15:21.000000', 'consum', 0.0228, 'lps'),
	(544519, 129, '2014-02-15 01:15:22.000000', 'consum', 0.0234, 'lps'),
	(544520, 129, '2014-02-15 01:15:23.000000', 'consum', 0.0226, 'lps'),
	(544521, 129, '2014-02-15 01:15:24.000000', 'consum', 0.0219, 'lps'),
	(544522, 129, '2014-02-15 01:15:25.000000', 'consum', 0.0232, 'lps'),
	(544523, 129, '2014-02-15 01:15:26.000000', 'consum', 0.0220, 'lps'),
	(544524, 129, '2014-02-15 01:15:27.000000', 'consum', 0.0218, 'lps'),
	(544525, 129, '2014-02-15 01:15:28.000000', 'consum', 0.0219, 'lps'),
	(544526, 129, '2014-02-15 01:15:29.000000', 'consum', 0.0234, 'lps'),
	(544527, 129, '2014-02-15 01:15:30.000000', 'consum', 0.0226, 'lps'),
	(544528, 129, '2014-02-15 01:15:31.000000', 'consum', 0.0219, 'lps'),
	(544529, 129, '2014-02-15 01:15:32.000000', 'consum', 0.0232, 'lps'),
	(544530, 129, '2014-02-15 01:15:33.000000', 'consum', 0.0219, 'lps'),
	(544531, 129, '2014-02-15 01:15:34.000000', 'consum', 0.0215, 'lps'),
	(544532, 129, '2014-02-15 01:15:35.000000', 'consum', 0.0232, 'lps'),
	(544533, 129, '2014-02-15 01:15:36.000000', 'consum', 0.0230, 'lps'),
	(544534, 129, '2014-02-15 01:15:37.000000', 'consum', 0.0221, 'lps'),
	(544535, 129, '2014-02-15 01:15:38.000000', 'consum', 0.0231, 'lps'),
	(544536, 129, '2014-02-15 01:15:39.000000', 'consum', 0.0232, 'lps'),
	(544537, 129, '2014-02-15 01:15:40.000000', 'consum', 0.0231, 'lps'),
	(544538, 129, '2014-02-15 01:15:41.000000', 'consum', 0.0226, 'lps'),
	(544539, 129, '2014-02-15 01:15:42.000000', 'consum', 0.0229, 'lps'),
	(544540, 129, '2014-02-15 01:15:43.000000', 'consum', 0.0230, 'lps'),
	(544541, 129, '2014-02-15 01:15:44.000000', 'consum', 0.0229, 'lps'),
	(544542, 129, '2014-02-15 01:15:45.000000', 'consum', 0.0222, 'lps'),
	(544543, 129, '2014-02-15 01:15:46.000000', 'consum', 0.0213, 'lps'),
	(544544, 129, '2014-02-15 01:15:47.000000', 'consum', 0.0213, 'lps'),
	(544545, 129, '2014-02-15 01:15:48.000000', 'consum', 0.0217, 'lps'),
	(544546, 129, '2014-02-15 01:15:49.000000', 'consum', 0.0213, 'lps'),
	(544547, 129, '2014-02-15 01:15:50.000000', 'consum', 0.0228, 'lps'),
	(544548, 129, '2014-02-15 01:15:51.000000', 'consum', 0.0216, 'lps'),
	(544549, 129, '2014-02-15 01:15:52.000000', 'consum', 0.0212, 'lps'),
	(544550, 129, '2014-02-15 01:15:53.000000', 'consum', 0.0226, 'lps'),
	(544551, 129, '2014-02-15 01:15:54.000000', 'consum', 0.0212, 'lps'),
	(544552, 129, '2014-02-15 01:15:55.000000', 'consum', 0.0220, 'lps'),
	(544553, 129, '2014-02-15 01:15:56.000000', 'consum', 0.0230, 'lps'),
	(544554, 129, '2014-02-15 01:15:57.000000', 'consum', 0.0231, 'lps'),
	(544555, 129, '2014-02-15 01:15:58.000000', 'consum', 0.0231, 'lps'),
	(544556, 129, '2014-02-15 01:15:59.000000', 'consum', 0.0226, 'lps'),
	(544557, 129, '2014-02-15 01:16:00.000000', 'consum', 0.0227, 'lps'),
	(544558, 129, '2014-02-15 01:16:01.000000', 'consum', 0.0223, 'lps'),
	(544559, 129, '2014-02-15 01:16:02.000000', 'consum', 0.0223, 'lps'),
	(544560, 129, '2014-02-15 01:16:03.000000', 'consum', 0.0212, 'lps'),
	(544561, 129, '2014-02-15 01:16:04.000000', 'consum', 0.0231, 'lps'),
	(544562, 129, '2014-02-15 01:16:05.000000', 'consum', 0.0233, 'lps'),
	(544563, 129, '2014-02-15 01:16:06.000000', 'consum', 0.0215, 'lps'),
	(544564, 129, '2014-02-15 01:16:07.000000', 'consum', 0.0215, 'lps'),
	(544565, 129, '2014-02-15 01:16:08.000000', 'consum', 0.0222, 'lps'),
	(544566, 129, '2014-02-15 01:16:09.000000', 'consum', 0.0230, 'lps'),
	(544567, 129, '2014-02-15 01:16:10.000000', 'consum', 0.0224, 'lps'),
	(544568, 129, '2014-02-15 01:16:11.000000', 'consum', 0.0220, 'lps'),
	(544569, 129, '2014-02-15 01:16:12.000000', 'consum', 0.0221, 'lps'),
	(544570, 129, '2014-02-15 01:16:13.000000', 'consum', 0.0232, 'lps'),
	(544571, 129, '2014-02-15 01:16:14.000000', 'consum', 0.0215, 'lps'),
	(544572, 129, '2014-02-15 01:16:15.000000', 'consum', 0.0220, 'lps'),
	(544573, 129, '2014-02-15 01:16:16.000000', 'consum', 0.0220, 'lps'),
	(544574, 129, '2014-02-15 01:16:17.000000', 'consum', 0.0230, 'lps'),
	(544575, 129, '2014-02-15 01:16:18.000000', 'consum', 0.0231, 'lps'),
	(544576, 129, '2014-02-15 01:16:19.000000', 'consum', 0.0231, 'lps'),
	(544577, 129, '2014-02-15 01:16:20.000000', 'consum', 0.0226, 'lps'),
	(544578, 129, '2014-02-15 01:16:21.000000', 'consum', 0.0229, 'lps'),
	(544579, 129, '2014-02-15 01:16:22.000000', 'consum', 0.0231, 'lps'),
	(544580, 129, '2014-02-15 01:16:23.000000', 'consum', 0.0210, 'lps'),
	(544581, 129, '2014-02-15 01:16:24.000000', 'consum', 0.0223, 'lps'),
	(544582, 129, '2014-02-15 01:16:25.000000', 'consum', 0.0223, 'lps'),
	(544583, 129, '2014-02-15 01:16:26.000000', 'consum', 0.0215, 'lps'),
	(544584, 129, '2014-02-15 01:16:27.000000', 'consum', 0.0218, 'lps'),
	(544585, 129, '2014-02-15 01:16:28.000000', 'consum', 0.0213, 'lps'),
	(544586, 129, '2014-02-15 01:16:29.000000', 'consum', 0.0224, 'lps'),
	(544587, 129, '2014-02-15 01:16:30.000000', 'consum', 0.0223, 'lps'),
	(544588, 129, '2014-02-15 01:16:31.000000', 'consum', 0.0233, 'lps'),
	(544589, 129, '2014-02-15 01:16:32.000000', 'consum', 0.0214, 'lps'),
	(544590, 129, '2014-02-15 01:16:33.000000', 'consum', 0.0234, 'lps'),
	(544591, 129, '2014-02-15 01:16:34.000000', 'consum', 0.0220, 'lps'),
	(544592, 129, '2014-02-15 01:16:35.000000', 'consum', 0.0211, 'lps'),
	(544593, 129, '2014-02-15 01:16:36.000000', 'consum', 0.0213, 'lps'),
	(544594, 129, '2014-02-15 01:16:37.000000', 'consum', 0.0221, 'lps'),
	(544595, 129, '2014-02-15 01:16:38.000000', 'consum', 0.0233, 'lps'),
	(544596, 129, '2014-02-15 01:16:39.000000', 'consum', 0.0215, 'lps'),
	(544597, 129, '2014-02-15 01:16:40.000000', 'consum', 0.0219, 'lps'),
	(544598, 129, '2014-02-15 01:16:41.000000', 'consum', 0.0216, 'lps'),
	(544599, 129, '2014-02-15 01:16:42.000000', 'consum', 0.0212, 'lps'),
	(544600, 129, '2014-02-15 01:16:43.000000', 'consum', 0.0229, 'lps'),
	(544601, 129, '2014-02-15 01:16:44.000000', 'consum', 0.0223, 'lps'),
	(544602, 129, '2014-02-15 01:16:45.000000', 'consum', 0.0221, 'lps'),
	(544603, 129, '2014-02-15 01:16:46.000000', 'consum', 0.0225, 'lps'),
	(544604, 129, '2014-02-15 01:16:47.000000', 'consum', 0.0229, 'lps'),
	(544605, 129, '2014-02-15 01:16:48.000000', 'consum', 0.0212, 'lps'),
	(544606, 129, '2014-02-15 01:16:49.000000', 'consum', 0.0210, 'lps'),
	(544607, 129, '2014-02-15 01:16:50.000000', 'consum', 0.0231, 'lps'),
	(544608, 129, '2014-02-15 01:16:51.000000', 'consum', 0.0216, 'lps'),
	(544609, 129, '2014-02-15 01:16:52.000000', 'consum', 0.0227, 'lps'),
	(544610, 129, '2014-02-15 01:16:53.000000', 'consum', 0.0226, 'lps'),
	(544611, 129, '2014-02-15 01:16:54.000000', 'consum', 0.0214, 'lps'),
	(544612, 129, '2014-02-15 01:16:55.000000', 'consum', 0.0232, 'lps'),
	(544613, 129, '2014-02-15 01:16:56.000000', 'consum', 0.0234, 'lps'),
	(544614, 129, '2014-02-15 01:16:57.000000', 'consum', 0.0215, 'lps'),
	(544615, 129, '2014-02-15 01:16:58.000000', 'consum', 0.0213, 'lps'),
	(544616, 129, '2014-02-15 01:16:59.000000', 'consum', 0.0234, 'lps'),
	(544617, 129, '2014-02-15 01:17:00.000000', 'consum', 0.0224, 'lps'),
	(544618, 129, '2014-02-15 01:17:01.000000', 'consum', 0.0234, 'lps'),
	(544619, 129, '2014-02-15 01:17:02.000000', 'consum', 0.0215, 'lps'),
	(544620, 129, '2014-02-15 01:17:03.000000', 'consum', 0.0210, 'lps'),
	(544621, 129, '2014-02-15 01:17:04.000000', 'consum', 0.0221, 'lps'),
	(544622, 129, '2014-02-15 01:17:05.000000', 'consum', 0.0215, 'lps'),
	(544623, 129, '2014-02-15 01:17:06.000000', 'consum', 0.0230, 'lps'),
	(544624, 129, '2014-02-15 01:17:07.000000', 'consum', 0.0219, 'lps'),
	(544625, 129, '2014-02-15 01:17:08.000000', 'consum', 0.0222, 'lps'),
	(544626, 129, '2014-02-15 01:17:09.000000', 'consum', 0.0218, 'lps'),
	(544627, 129, '2014-02-15 01:17:10.000000', 'consum', 0.0213, 'lps'),
	(544628, 129, '2014-02-15 01:17:11.000000', 'consum', 0.0226, 'lps'),
	(544629, 129, '2014-02-15 01:17:12.000000', 'consum', 0.0233, 'lps'),
	(544630, 129, '2014-02-15 01:17:13.000000', 'consum', 0.0225, 'lps'),
	(544631, 129, '2014-02-15 01:17:14.000000', 'consum', 0.0220, 'lps'),
	(544632, 129, '2014-02-15 01:17:15.000000', 'consum', 0.0213, 'lps'),
	(544633, 129, '2014-02-15 01:17:16.000000', 'consum', 0.0221, 'lps'),
	(544634, 129, '2014-02-15 01:17:17.000000', 'consum', 0.0233, 'lps'),
	(544635, 129, '2014-02-15 01:17:18.000000', 'consum', 0.0218, 'lps'),
	(544636, 129, '2014-02-15 01:17:19.000000', 'consum', 0.0230, 'lps'),
	(544637, 129, '2014-02-15 01:17:20.000000', 'consum', 0.0210, 'lps'),
	(544638, 129, '2014-02-15 01:17:21.000000', 'consum', 0.0228, 'lps'),
	(544639, 129, '2014-02-15 01:17:22.000000', 'consum', 0.0223, 'lps'),
	(544640, 129, '2014-02-15 01:17:23.000000', 'consum', 0.0222, 'lps'),
	(544641, 129, '2014-02-15 01:17:24.000000', 'consum', 0.0230, 'lps'),
	(544642, 129, '2014-02-15 01:17:25.000000', 'consum', 0.0226, 'lps'),
	(544643, 129, '2014-02-15 01:17:26.000000', 'consum', 0.0229, 'lps'),
	(544644, 129, '2014-02-15 01:17:27.000000', 'consum', 0.0233, 'lps'),
	(544645, 129, '2014-02-15 01:17:28.000000', 'consum', 0.0218, 'lps'),
	(544646, 129, '2014-02-15 01:17:29.000000', 'consum', 0.0231, 'lps'),
	(544647, 129, '2014-02-15 01:17:30.000000', 'consum', 0.0216, 'lps'),
	(544648, 129, '2014-02-15 01:17:31.000000', 'consum', 0.0230, 'lps'),
	(544649, 129, '2014-02-15 01:17:32.000000', 'consum', 0.0217, 'lps'),
	(544650, 129, '2014-02-15 01:17:33.000000', 'consum', 0.0233, 'lps'),
	(544651, 129, '2014-02-15 01:17:34.000000', 'consum', 0.0232, 'lps'),
	(544652, 129, '2014-02-15 01:17:35.000000', 'consum', 0.0224, 'lps'),
	(544653, 129, '2014-02-15 01:17:36.000000', 'consum', 0.0218, 'lps'),
	(544654, 129, '2014-02-15 01:17:37.000000', 'consum', 0.0231, 'lps'),
	(544655, 129, '2014-02-15 01:17:38.000000', 'consum', 0.0216, 'lps'),
	(544656, 129, '2014-02-15 01:17:39.000000', 'consum', 0.0226, 'lps'),
	(544657, 129, '2014-02-15 01:17:40.000000', 'consum', 0.0225, 'lps'),
	(544658, 129, '2014-02-15 01:17:41.000000', 'consum', 0.0211, 'lps'),
	(544659, 129, '2014-02-15 01:17:42.000000', 'consum', 0.0223, 'lps'),
	(544660, 129, '2014-02-15 01:17:43.000000', 'consum', 0.0220, 'lps'),
	(544661, 129, '2014-02-15 01:17:44.000000', 'consum', 0.0224, 'lps'),
	(544662, 129, '2014-02-15 01:17:45.000000', 'consum', 0.0222, 'lps'),
	(544663, 129, '2014-02-15 01:17:46.000000', 'consum', 0.0232, 'lps'),
	(544664, 129, '2014-02-15 01:17:47.000000', 'consum', 0.0233, 'lps'),
	(544665, 129, '2014-02-15 01:17:48.000000', 'consum', 0.0234, 'lps'),
	(544666, 129, '2014-02-15 01:17:49.000000', 'consum', 0.0210, 'lps'),
	(544667, 129, '2014-02-15 01:17:50.000000', 'consum', 0.0214, 'lps'),
	(544668, 129, '2014-02-15 01:17:51.000000', 'consum', 0.0232, 'lps'),
	(544669, 129, '2014-02-15 01:17:52.000000', 'consum', 0.0234, 'lps'),
	(544670, 129, '2014-02-15 01:17:53.000000', 'consum', 0.0215, 'lps'),
	(544671, 129, '2014-02-15 01:17:54.000000', 'consum', 0.0210, 'lps'),
	(544672, 129, '2014-02-15 01:17:55.000000', 'consum', 0.0224, 'lps'),
	(544673, 129, '2014-02-15 01:17:56.000000', 'consum', 0.0231, 'lps'),
	(544674, 129, '2014-02-15 01:17:57.000000', 'consum', 0.0223, 'lps'),
	(544675, 129, '2014-02-15 01:17:58.000000', 'consum', 0.0210, 'lps'),
	(544676, 129, '2014-02-15 01:17:59.000000', 'consum', 0.0225, 'lps'),
	(544677, 129, '2014-02-15 01:18:00.000000', 'consum', 0.0234, 'lps'),
	(544678, 129, '2014-02-15 01:18:01.000000', 'consum', 0.0210, 'lps'),
	(544679, 129, '2014-02-15 01:18:02.000000', 'consum', 0.0214, 'lps'),
	(544680, 129, '2014-02-15 01:18:03.000000', 'consum', 0.0229, 'lps'),
	(544681, 129, '2014-02-15 01:18:04.000000', 'consum', 0.0219, 'lps'),
	(544682, 129, '2014-02-15 01:18:05.000000', 'consum', 0.0224, 'lps'),
	(544683, 129, '2014-02-15 01:18:06.000000', 'consum', 0.0228, 'lps'),
	(544684, 129, '2014-02-15 01:18:07.000000', 'consum', 0.0233, 'lps'),
	(544685, 129, '2014-02-15 01:18:08.000000', 'consum', 0.0222, 'lps'),
	(544686, 129, '2014-02-15 01:18:09.000000', 'consum', 0.0225, 'lps'),
	(544687, 129, '2014-02-15 01:18:10.000000', 'consum', 0.0226, 'lps'),
	(544688, 129, '2014-02-15 01:18:11.000000', 'consum', 0.0222, 'lps'),
	(544689, 129, '2014-02-15 01:18:12.000000', 'consum', 0.0221, 'lps'),
	(544690, 129, '2014-02-15 01:18:13.000000', 'consum', 0.0228, 'lps'),
	(544691, 129, '2014-02-15 01:18:14.000000', 'consum', 0.0220, 'lps'),
	(544692, 129, '2014-02-15 01:18:15.000000', 'consum', 0.0232, 'lps'),
	(544693, 129, '2014-02-15 01:18:16.000000', 'consum', 0.0216, 'lps'),
	(544694, 129, '2014-02-15 01:18:17.000000', 'consum', 0.0224, 'lps'),
	(544695, 129, '2014-02-15 01:18:18.000000', 'consum', 0.0212, 'lps'),
	(544696, 129, '2014-02-15 01:18:19.000000', 'consum', 0.0227, 'lps'),
	(544697, 129, '2014-02-15 01:18:20.000000', 'consum', 0.0218, 'lps'),
	(544698, 129, '2014-02-15 01:18:21.000000', 'consum', 0.0222, 'lps'),
	(544699, 129, '2014-02-15 01:18:22.000000', 'consum', 0.0221, 'lps'),
	(544700, 129, '2014-02-15 01:18:23.000000', 'consum', 0.0230, 'lps'),
	(544701, 129, '2014-02-15 01:18:24.000000', 'consum', 0.0226, 'lps'),
	(544702, 129, '2014-02-15 01:18:25.000000', 'consum', 0.0230, 'lps'),
	(544703, 129, '2014-02-15 01:18:26.000000', 'consum', 0.0214, 'lps'),
	(544704, 129, '2014-02-15 01:18:27.000000', 'consum', 0.0220, 'lps'),
	(544705, 129, '2014-02-15 01:18:28.000000', 'consum', 0.0225, 'lps'),
	(544706, 129, '2014-02-15 01:18:29.000000', 'consum', 0.0229, 'lps'),
	(544707, 129, '2014-02-15 01:18:30.000000', 'consum', 0.0211, 'lps'),
	(544708, 129, '2014-02-15 01:18:31.000000', 'consum', 0.0210, 'lps'),
	(544709, 129, '2014-02-15 01:18:32.000000', 'consum', 0.0231, 'lps'),
	(544710, 129, '2014-02-15 01:18:33.000000', 'consum', 0.0215, 'lps'),
	(544711, 129, '2014-02-15 01:18:34.000000', 'consum', 0.0224, 'lps'),
	(544712, 129, '2014-02-15 01:18:35.000000', 'consum', 0.0215, 'lps'),
	(544713, 130, '2014-02-15 00:00:00.000000', 'consum', 0.0226, 'lps'),
	(544714, 130, '2014-02-15 00:00:01.000000', 'consum', 0.0214, 'lps'),
	(544715, 130, '2014-02-15 00:00:02.000000', 'consum', 0.0216, 'lps'),
	(544716, 130, '2014-02-15 00:00:03.000000', 'consum', 0.0212, 'lps'),
	(544717, 130, '2014-02-15 00:00:04.000000', 'consum', 0.0218, 'lps'),
	(544718, 130, '2014-02-15 00:00:05.000000', 'consum', 0.0211, 'lps'),
	(544719, 130, '2014-02-15 00:00:06.000000', 'consum', 0.0225, 'lps'),
	(544720, 130, '2014-02-15 00:00:07.000000', 'consum', 0.0215, 'lps'),
	(544721, 130, '2014-02-15 00:00:08.000000', 'consum', 0.0224, 'lps'),
	(544722, 130, '2014-02-15 00:00:09.000000', 'consum', 0.0215, 'lps'),
	(544723, 130, '2014-02-15 00:00:10.000000', 'consum', 0.0210, 'lps'),
	(544724, 130, '2014-02-15 00:00:11.000000', 'consum', 0.0213, 'lps'),
	(544725, 130, '2014-02-15 00:00:12.000000', 'consum', 0.0224, 'lps'),
	(544726, 130, '2014-02-15 00:00:13.000000', 'consum', 0.0222, 'lps'),
	(544727, 130, '2014-02-15 00:00:14.000000', 'consum', 0.0212, 'lps'),
	(544728, 130, '2014-02-15 00:00:15.000000', 'consum', 0.0217, 'lps'),
	(544729, 130, '2014-02-15 00:00:16.000000', 'consum', 0.0222, 'lps'),
	(544730, 130, '2014-02-15 00:00:17.000000', 'consum', 0.0214, 'lps'),
	(544731, 130, '2014-02-15 00:00:18.000000', 'consum', 0.0214, 'lps'),
	(544732, 130, '2014-02-15 00:00:19.000000', 'consum', 0.0219, 'lps'),
	(544733, 130, '2014-02-15 00:00:20.000000', 'consum', 0.0224, 'lps'),
	(544734, 130, '2014-02-15 00:00:21.000000', 'consum', 0.0222, 'lps'),
	(544735, 130, '2014-02-15 00:00:22.000000', 'consum', 0.0212, 'lps'),
	(544736, 130, '2014-02-15 00:00:23.000000', 'consum', 0.0217, 'lps'),
	(544737, 130, '2014-02-15 00:00:24.000000', 'consum', 0.0222, 'lps'),
	(544738, 130, '2014-02-15 00:00:25.000000', 'consum', 0.0216, 'lps'),
	(544739, 130, '2014-02-15 00:00:26.000000', 'consum', 0.0220, 'lps'),
	(544740, 130, '2014-02-15 00:00:27.000000', 'consum', 0.0211, 'lps'),
	(544741, 130, '2014-02-15 00:00:28.000000', 'consum', 0.0218, 'lps'),
	(544742, 130, '2014-02-15 00:00:29.000000', 'consum', 0.0212, 'lps'),
	(544743, 130, '2014-02-15 00:00:30.000000', 'consum', 0.0217, 'lps'),
	(544744, 130, '2014-02-15 00:00:31.000000', 'consum', 0.0219, 'lps'),
	(544745, 130, '2014-02-15 00:00:32.000000', 'consum', 0.0219, 'lps'),
	(544746, 130, '2014-02-15 00:00:33.000000', 'consum', 0.0213, 'lps'),
	(544747, 130, '2014-02-15 00:00:34.000000', 'consum', 0.0214, 'lps'),
	(544748, 130, '2014-02-15 00:00:35.000000', 'consum', 0.0222, 'lps'),
	(544749, 130, '2014-02-15 00:00:36.000000', 'consum', 0.0226, 'lps'),
	(544750, 130, '2014-02-15 00:00:37.000000', 'consum', 0.0217, 'lps'),
	(544751, 130, '2014-02-15 00:00:38.000000', 'consum', 0.0218, 'lps'),
	(544752, 130, '2014-02-15 00:00:39.000000', 'consum', 0.0210, 'lps'),
	(544753, 130, '2014-02-15 00:00:40.000000', 'consum', 0.0221, 'lps'),
	(544754, 130, '2014-02-15 00:00:41.000000', 'consum', 0.0214, 'lps'),
	(544755, 130, '2014-02-15 00:00:42.000000', 'consum', 0.0216, 'lps'),
	(544756, 130, '2014-02-15 00:00:43.000000', 'consum', 0.0211, 'lps'),
	(544757, 130, '2014-02-15 00:00:44.000000', 'consum', 0.0215, 'lps'),
	(544758, 130, '2014-02-15 00:00:45.000000', 'consum', 0.0217, 'lps'),
	(544759, 130, '2014-02-15 00:00:46.000000', 'consum', 0.0213, 'lps'),
	(544760, 130, '2014-02-15 00:00:47.000000', 'consum', 0.0221, 'lps'),
	(544761, 130, '2014-02-15 00:00:48.000000', 'consum', 0.0220, 'lps'),
	(544762, 130, '2014-02-15 00:00:49.000000', 'consum', 0.0214, 'lps'),
	(544763, 130, '2014-02-15 00:00:50.000000', 'consum', 0.0214, 'lps'),
	(544764, 130, '2014-02-15 00:00:51.000000', 'consum', 0.0221, 'lps'),
	(544765, 130, '2014-02-15 00:00:52.000000', 'consum', 0.0217, 'lps'),
	(544766, 130, '2014-02-15 00:00:53.000000', 'consum', 0.0213, 'lps'),
	(544767, 130, '2014-02-15 00:00:54.000000', 'consum', 0.0220, 'lps'),
	(544768, 130, '2014-02-15 00:00:55.000000', 'consum', 0.0221, 'lps'),
	(544769, 130, '2014-02-15 00:00:56.000000', 'consum', 0.0216, 'lps'),
	(544770, 130, '2014-02-15 00:00:57.000000', 'consum', 0.0224, 'lps'),
	(544771, 130, '2014-02-15 00:00:58.000000', 'consum', 0.0211, 'lps'),
	(544772, 130, '2014-02-15 00:00:59.000000', 'consum', 0.0210, 'lps'),
	(544773, 130, '2014-02-15 00:01:00.000000', 'consum', 0.0224, 'lps'),
	(544774, 130, '2014-02-15 00:01:01.000000', 'consum', 0.0213, 'lps'),
	(544775, 130, '2014-02-15 00:01:02.000000', 'consum', 0.0218, 'lps'),
	(544776, 130, '2014-02-15 00:01:03.000000', 'consum', 0.0226, 'lps'),
	(544777, 130, '2014-02-15 00:01:04.000000', 'consum', 0.0213, 'lps'),
	(544778, 130, '2014-02-15 00:01:05.000000', 'consum', 0.0211, 'lps'),
	(544779, 130, '2014-02-15 00:01:06.000000', 'consum', 0.0225, 'lps'),
	(544780, 130, '2014-02-15 00:01:07.000000', 'consum', 0.0216, 'lps'),
	(544781, 130, '2014-02-15 00:01:08.000000', 'consum', 0.0226, 'lps'),
	(544782, 130, '2014-02-15 00:01:09.000000', 'consum', 0.0225, 'lps'),
	(544783, 130, '2014-02-15 00:01:10.000000', 'consum', 0.0219, 'lps'),
	(544784, 130, '2014-02-15 00:01:11.000000', 'consum', 0.0211, 'lps'),
	(544785, 130, '2014-02-15 00:01:12.000000', 'consum', 0.0222, 'lps'),
	(544786, 130, '2014-02-15 00:01:13.000000', 'consum', 0.0217, 'lps'),
	(544787, 130, '2014-02-15 00:01:14.000000', 'consum', 0.0210, 'lps'),
	(544788, 130, '2014-02-15 00:01:15.000000', 'consum', 0.0224, 'lps'),
	(544789, 130, '2014-02-15 00:01:16.000000', 'consum', 0.0211, 'lps'),
	(544790, 130, '2014-02-15 00:01:17.000000', 'consum', 0.0210, 'lps'),
	(544791, 130, '2014-02-15 00:01:18.000000', 'consum', 0.0223, 'lps'),
	(544792, 130, '2014-02-15 00:01:19.000000', 'consum', 0.0225, 'lps'),
	(544793, 130, '2014-02-15 00:01:20.000000', 'consum', 0.0212, 'lps'),
	(544794, 130, '2014-02-15 00:01:21.000000', 'consum', 0.0210, 'lps'),
	(544795, 130, '2014-02-15 00:01:22.000000', 'consum', 0.0221, 'lps'),
	(544796, 130, '2014-02-15 00:01:23.000000', 'consum', 0.0216, 'lps'),
	(544797, 130, '2014-02-15 00:01:24.000000', 'consum', 0.0225, 'lps'),
	(544798, 130, '2014-02-15 00:01:25.000000', 'consum', 0.0214, 'lps'),
	(544799, 130, '2014-02-15 00:01:26.000000', 'consum', 0.0220, 'lps'),
	(544800, 130, '2014-02-15 00:01:27.000000', 'consum', 0.0216, 'lps'),
	(544801, 130, '2014-02-15 00:01:28.000000', 'consum', 0.0226, 'lps'),
	(544802, 130, '2014-02-15 00:01:29.000000', 'consum', 0.0220, 'lps'),
	(544803, 130, '2014-02-15 00:01:30.000000', 'consum', 0.0214, 'lps'),
	(544804, 130, '2014-02-15 00:01:31.000000', 'consum', 0.0219, 'lps'),
	(544805, 130, '2014-02-15 00:01:32.000000', 'consum', 0.0224, 'lps'),
	(544806, 130, '2014-02-15 00:01:33.000000', 'consum', 0.0219, 'lps'),
	(544807, 130, '2014-02-15 00:01:34.000000', 'consum', 0.0213, 'lps'),
	(544808, 130, '2014-02-15 00:01:35.000000', 'consum', 0.0217, 'lps'),
	(544809, 130, '2014-02-15 00:01:36.000000', 'consum', 0.0219, 'lps'),
	(544810, 130, '2014-02-15 00:01:37.000000', 'consum', 0.0219, 'lps'),
	(544811, 130, '2014-02-15 00:01:38.000000', 'consum', 0.0212, 'lps'),
	(544812, 130, '2014-02-15 00:01:39.000000', 'consum', 0.0225, 'lps'),
	(544813, 130, '2014-02-15 00:01:40.000000', 'consum', 0.0212, 'lps'),
	(544814, 130, '2014-02-15 00:01:41.000000', 'consum', 0.0212, 'lps'),
	(544815, 130, '2014-02-15 00:01:42.000000', 'consum', 0.0213, 'lps'),
	(544816, 130, '2014-02-15 00:01:43.000000', 'consum', 0.0217, 'lps'),
	(544817, 130, '2014-02-15 00:01:44.000000', 'consum', 0.0223, 'lps'),
	(544818, 130, '2014-02-15 00:01:45.000000', 'consum', 0.0219, 'lps'),
	(544819, 130, '2014-02-15 00:01:46.000000', 'consum', 0.0216, 'lps'),
	(544820, 130, '2014-02-15 00:01:47.000000', 'consum', 0.0216, 'lps'),
	(544821, 130, '2014-02-15 00:01:48.000000', 'consum', 0.0220, 'lps'),
	(544822, 130, '2014-02-15 00:01:49.000000', 'consum', 0.0224, 'lps'),
	(544823, 130, '2014-02-15 00:01:50.000000', 'consum', 0.0220, 'lps'),
	(544824, 130, '2014-02-15 00:01:51.000000', 'consum', 0.0216, 'lps'),
	(544825, 130, '2014-02-15 00:01:52.000000', 'consum', 0.0226, 'lps'),
	(544826, 130, '2014-02-15 00:01:53.000000', 'consum', 0.0224, 'lps'),
	(544827, 130, '2014-02-15 00:01:54.000000', 'consum', 0.0215, 'lps'),
	(544828, 130, '2014-02-15 00:01:55.000000', 'consum', 0.0211, 'lps'),
	(544829, 130, '2014-02-15 00:01:56.000000', 'consum', 0.0219, 'lps'),
	(544830, 130, '2014-02-15 00:01:57.000000', 'consum', 0.0217, 'lps'),
	(544831, 130, '2014-02-15 00:01:58.000000', 'consum', 0.0220, 'lps'),
	(544832, 130, '2014-02-15 00:01:59.000000', 'consum', 0.0222, 'lps'),
	(544833, 130, '2014-02-15 00:02:00.000000', 'consum', 0.0222, 'lps'),
	(544834, 130, '2014-02-15 00:02:01.000000', 'consum', 0.0216, 'lps'),
	(544835, 130, '2014-02-15 00:02:02.000000', 'consum', 0.0224, 'lps'),
	(544836, 130, '2014-02-15 00:02:03.000000', 'consum', 0.0211, 'lps'),
	(544837, 130, '2014-02-15 00:02:04.000000', 'consum', 0.0226, 'lps'),
	(544838, 130, '2014-02-15 00:02:05.000000', 'consum', 0.0216, 'lps'),
	(544839, 130, '2014-02-15 00:02:06.000000', 'consum', 0.0213, 'lps'),
	(544840, 130, '2014-02-15 00:02:07.000000', 'consum', 0.0225, 'lps'),
	(544841, 130, '2014-02-15 00:02:08.000000', 'consum', 0.0222, 'lps'),
	(544842, 130, '2014-02-15 00:02:09.000000', 'consum', 0.0212, 'lps'),
	(544843, 130, '2014-02-15 00:02:10.000000', 'consum', 0.0216, 'lps'),
	(544844, 130, '2014-02-15 00:02:11.000000', 'consum', 0.0217, 'lps'),
	(544845, 130, '2014-02-15 00:02:12.000000', 'consum', 0.0210, 'lps'),
	(544846, 130, '2014-02-15 00:02:13.000000', 'consum', 0.0224, 'lps'),
	(544847, 130, '2014-02-15 00:02:14.000000', 'consum', 0.0214, 'lps'),
	(544848, 130, '2014-02-15 00:02:15.000000', 'consum', 0.0221, 'lps'),
	(544849, 130, '2014-02-15 00:02:16.000000', 'consum', 0.0219, 'lps'),
	(544850, 130, '2014-02-15 00:02:17.000000', 'consum', 0.0221, 'lps'),
	(544851, 130, '2014-02-15 00:02:18.000000', 'consum', 0.0225, 'lps'),
	(544852, 130, '2014-02-15 00:02:19.000000', 'consum', 0.0217, 'lps'),
	(544853, 130, '2014-02-15 00:02:20.000000', 'consum', 0.0219, 'lps'),
	(544854, 130, '2014-02-15 00:02:21.000000', 'consum', 0.0216, 'lps'),
	(544855, 130, '2014-02-15 00:02:22.000000', 'consum', 0.0214, 'lps'),
	(544856, 130, '2014-02-15 00:02:23.000000', 'consum', 0.0212, 'lps'),
	(544857, 130, '2014-02-15 00:02:24.000000', 'consum', 0.0210, 'lps'),
	(544858, 130, '2014-02-15 00:02:25.000000', 'consum', 0.0219, 'lps'),
	(544859, 130, '2014-02-15 00:02:26.000000', 'consum', 0.0224, 'lps'),
	(544860, 130, '2014-02-15 00:02:27.000000', 'consum', 0.0217, 'lps'),
	(544861, 130, '2014-02-15 00:02:28.000000', 'consum', 0.0220, 'lps'),
	(544862, 130, '2014-02-15 00:02:29.000000', 'consum', 0.0226, 'lps'),
	(544863, 130, '2014-02-15 00:02:30.000000', 'consum', 0.0223, 'lps'),
	(544864, 130, '2014-02-15 00:02:31.000000', 'consum', 0.0214, 'lps'),
	(544865, 130, '2014-02-15 00:02:32.000000', 'consum', 0.0222, 'lps'),
	(544866, 130, '2014-02-15 00:02:33.000000', 'consum', 0.0210, 'lps'),
	(544867, 130, '2014-02-15 00:02:34.000000', 'consum', 0.0224, 'lps'),
	(544868, 130, '2014-02-15 00:02:35.000000', 'consum', 0.0213, 'lps'),
	(544869, 130, '2014-02-15 00:02:36.000000', 'consum', 0.0216, 'lps'),
	(544870, 130, '2014-02-15 00:02:37.000000', 'consum', 0.0218, 'lps'),
	(544871, 130, '2014-02-15 00:02:38.000000', 'consum', 0.0212, 'lps'),
	(544872, 130, '2014-02-15 00:02:39.000000', 'consum', 0.0214, 'lps'),
	(544873, 130, '2014-02-15 00:02:40.000000', 'consum', 0.0224, 'lps'),
	(544874, 130, '2014-02-15 00:02:41.000000', 'consum', 0.0217, 'lps'),
	(544875, 130, '2014-02-15 00:02:42.000000', 'consum', 0.0221, 'lps'),
	(544876, 130, '2014-02-15 00:02:43.000000', 'consum', 0.0210, 'lps'),
	(544877, 130, '2014-02-15 00:02:44.000000', 'consum', 0.0212, 'lps'),
	(544878, 130, '2014-02-15 00:02:45.000000', 'consum', 0.0220, 'lps'),
	(544879, 130, '2014-02-15 00:02:46.000000', 'consum', 0.0221, 'lps'),
	(544880, 130, '2014-02-15 00:02:47.000000', 'consum', 0.0219, 'lps'),
	(544881, 130, '2014-02-15 00:02:48.000000', 'consum', 0.0220, 'lps'),
	(544882, 130, '2014-02-15 00:02:49.000000', 'consum', 0.0219, 'lps'),
	(544883, 130, '2014-02-15 00:02:50.000000', 'consum', 0.0223, 'lps'),
	(544884, 130, '2014-02-15 00:02:51.000000', 'consum', 0.0216, 'lps'),
	(544885, 130, '2014-02-15 00:02:52.000000', 'consum', 0.0219, 'lps'),
	(544886, 130, '2014-02-15 00:02:53.000000', 'consum', 0.0220, 'lps'),
	(544887, 130, '2014-02-15 00:02:54.000000', 'consum', 0.0216, 'lps'),
	(544888, 130, '2014-02-15 00:02:55.000000', 'consum', 0.0211, 'lps'),
	(544889, 130, '2014-02-15 00:02:56.000000', 'consum', 0.0212, 'lps'),
	(544890, 130, '2014-02-15 00:02:57.000000', 'consum', 0.0221, 'lps'),
	(544891, 130, '2014-02-15 00:02:58.000000', 'consum', 0.0223, 'lps'),
	(544892, 130, '2014-02-15 00:02:59.000000', 'consum', 0.0210, 'lps'),
	(544893, 130, '2014-02-15 00:03:00.000000', 'consum', 0.0223, 'lps'),
	(544894, 130, '2014-02-15 00:03:01.000000', 'consum', 0.0226, 'lps'),
	(544895, 130, '2014-02-15 00:03:02.000000', 'consum', 0.0215, 'lps'),
	(544896, 130, '2014-02-15 00:03:03.000000', 'consum', 0.0224, 'lps'),
	(544897, 130, '2014-02-15 00:03:04.000000', 'consum', 0.0213, 'lps'),
	(544898, 130, '2014-02-15 00:03:05.000000', 'consum', 0.0218, 'lps'),
	(544899, 130, '2014-02-15 00:03:06.000000', 'consum', 0.0225, 'lps'),
	(544900, 130, '2014-02-15 00:03:07.000000', 'consum', 0.0225, 'lps'),
	(544901, 130, '2014-02-15 00:03:08.000000', 'consum', 0.0225, 'lps'),
	(544902, 130, '2014-02-15 00:03:09.000000', 'consum', 0.0222, 'lps'),
	(544903, 130, '2014-02-15 00:03:10.000000', 'consum', 0.0211, 'lps'),
	(544904, 130, '2014-02-15 00:03:11.000000', 'consum', 0.0213, 'lps'),
	(544905, 130, '2014-02-15 00:03:12.000000', 'consum', 0.0224, 'lps'),
	(544906, 130, '2014-02-15 00:03:13.000000', 'consum', 0.0217, 'lps'),
	(544907, 130, '2014-02-15 00:03:14.000000', 'consum', 0.0222, 'lps'),
	(544908, 130, '2014-02-15 00:03:15.000000', 'consum', 0.0217, 'lps'),
	(544909, 130, '2014-02-15 00:03:16.000000', 'consum', 0.0224, 'lps'),
	(544910, 130, '2014-02-15 00:03:17.000000', 'consum', 0.0210, 'lps'),
	(544911, 130, '2014-02-15 00:03:18.000000', 'consum', 0.0220, 'lps'),
	(544912, 130, '2014-02-15 00:03:19.000000', 'consum', 0.0211, 'lps'),
	(544913, 130, '2014-02-15 00:03:20.000000', 'consum', 0.0217, 'lps'),
	(544914, 130, '2014-02-15 00:03:21.000000', 'consum', 0.0225, 'lps'),
	(544915, 130, '2014-02-15 00:03:22.000000', 'consum', 0.0214, 'lps'),
	(544916, 130, '2014-02-15 00:03:23.000000', 'consum', 0.0219, 'lps'),
	(544917, 130, '2014-02-15 00:03:24.000000', 'consum', 0.0211, 'lps'),
	(544918, 130, '2014-02-15 00:03:25.000000', 'consum', 0.0220, 'lps'),
	(544919, 130, '2014-02-15 00:03:26.000000', 'consum', 0.0224, 'lps'),
	(544920, 130, '2014-02-15 00:03:27.000000', 'consum', 0.0218, 'lps'),
	(544921, 130, '2014-02-15 00:03:28.000000', 'consum', 0.0223, 'lps'),
	(544922, 130, '2014-02-15 00:03:29.000000', 'consum', 0.0220, 'lps'),
	(544923, 130, '2014-02-15 00:03:30.000000', 'consum', 0.0222, 'lps'),
	(544924, 130, '2014-02-15 00:03:31.000000', 'consum', 0.0221, 'lps'),
	(544925, 130, '2014-02-15 00:03:32.000000', 'consum', 0.0212, 'lps'),
	(544926, 130, '2014-02-15 00:03:33.000000', 'consum', 0.0221, 'lps'),
	(544927, 130, '2014-02-15 00:03:34.000000', 'consum', 0.0212, 'lps'),
	(544928, 130, '2014-02-15 00:03:35.000000', 'consum', 0.0218, 'lps'),
	(544929, 130, '2014-02-15 00:03:36.000000', 'consum', 0.0212, 'lps'),
	(544930, 130, '2014-02-15 00:03:37.000000', 'consum', 0.0211, 'lps'),
	(544931, 130, '2014-02-15 00:03:38.000000', 'consum', 0.0212, 'lps'),
	(544932, 130, '2014-02-15 00:03:39.000000', 'consum', 0.0218, 'lps'),
	(544933, 130, '2014-02-15 00:03:40.000000', 'consum', 0.0210, 'lps'),
	(544934, 130, '2014-02-15 00:03:41.000000', 'consum', 0.0220, 'lps'),
	(544935, 130, '2014-02-15 00:03:42.000000', 'consum', 0.0210, 'lps'),
	(544936, 130, '2014-02-15 00:03:43.000000', 'consum', 0.0216, 'lps'),
	(544937, 130, '2014-02-15 00:03:44.000000', 'consum', 0.0220, 'lps'),
	(544938, 130, '2014-02-15 00:03:45.000000', 'consum', 0.0212, 'lps'),
	(544939, 130, '2014-02-15 00:03:46.000000', 'consum', 0.0222, 'lps'),
	(544940, 130, '2014-02-15 00:03:47.000000', 'consum', 0.0214, 'lps'),
	(544941, 130, '2014-02-15 00:03:48.000000', 'consum', 0.0214, 'lps'),
	(544942, 130, '2014-02-15 00:03:49.000000', 'consum', 0.0216, 'lps'),
	(544943, 130, '2014-02-15 00:03:50.000000', 'consum', 0.0212, 'lps'),
	(544944, 130, '2014-02-15 00:03:51.000000', 'consum', 0.0221, 'lps'),
	(544945, 130, '2014-02-15 00:03:52.000000', 'consum', 0.0222, 'lps'),
	(544946, 130, '2014-02-15 00:03:53.000000', 'consum', 0.0224, 'lps'),
	(544947, 130, '2014-02-15 00:03:54.000000', 'consum', 0.0210, 'lps'),
	(544948, 130, '2014-02-15 00:03:55.000000', 'consum', 0.0218, 'lps'),
	(544949, 130, '2014-02-15 00:03:56.000000', 'consum', 0.0215, 'lps'),
	(544950, 130, '2014-02-15 00:03:57.000000', 'consum', 0.0214, 'lps'),
	(544951, 130, '2014-02-15 00:03:58.000000', 'consum', 0.0214, 'lps'),
	(544952, 130, '2014-02-15 00:03:59.000000', 'consum', 0.0217, 'lps'),
	(544953, 130, '2014-02-15 00:04:00.000000', 'consum', 0.0219, 'lps'),
	(544954, 130, '2014-02-15 00:04:01.000000', 'consum', 0.0216, 'lps'),
	(544955, 130, '2014-02-15 00:04:02.000000', 'consum', 0.0212, 'lps'),
	(544956, 130, '2014-02-15 00:04:03.000000', 'consum', 0.0221, 'lps'),
	(544957, 130, '2014-02-15 00:04:04.000000', 'consum', 0.0226, 'lps'),
	(544958, 130, '2014-02-15 00:04:05.000000', 'consum', 0.0224, 'lps'),
	(544959, 130, '2014-02-15 00:04:06.000000', 'consum', 0.0214, 'lps'),
	(544960, 130, '2014-02-15 00:04:07.000000', 'consum', 0.0223, 'lps'),
	(544961, 130, '2014-02-15 00:04:08.000000', 'consum', 0.0212, 'lps'),
	(544962, 130, '2014-02-15 00:04:09.000000', 'consum', 0.0217, 'lps'),
	(544963, 130, '2014-02-15 00:04:10.000000', 'consum', 0.0221, 'lps'),
	(544964, 130, '2014-02-15 00:04:11.000000', 'consum', 0.0211, 'lps'),
	(544965, 130, '2014-02-15 00:04:12.000000', 'consum', 0.0215, 'lps'),
	(544966, 130, '2014-02-15 00:04:13.000000', 'consum', 0.0216, 'lps'),
	(544967, 130, '2014-02-15 00:04:14.000000', 'consum', 0.0225, 'lps'),
	(544968, 130, '2014-02-15 00:04:15.000000', 'consum', 0.0216, 'lps'),
	(544969, 130, '2014-02-15 00:04:16.000000', 'consum', 0.0213, 'lps'),
	(544970, 130, '2014-02-15 00:04:17.000000', 'consum', 0.0225, 'lps'),
	(544971, 130, '2014-02-15 00:04:18.000000', 'consum', 0.0210, 'lps'),
	(544972, 130, '2014-02-15 00:04:19.000000', 'consum', 0.0216, 'lps'),
	(544973, 130, '2014-02-15 00:04:20.000000', 'consum', 0.0224, 'lps'),
	(544974, 130, '2014-02-15 00:04:21.000000', 'consum', 0.0213, 'lps'),
	(544975, 130, '2014-02-15 00:04:22.000000', 'consum', 0.0214, 'lps'),
	(544976, 130, '2014-02-15 00:04:23.000000', 'consum', 0.0223, 'lps'),
	(544977, 130, '2014-02-15 00:04:24.000000', 'consum', 0.0212, 'lps'),
	(544978, 130, '2014-02-15 00:04:25.000000', 'consum', 0.0215, 'lps'),
	(544979, 130, '2014-02-15 00:04:26.000000', 'consum', 0.0213, 'lps'),
	(544980, 130, '2014-02-15 00:04:27.000000', 'consum', 0.0211, 'lps'),
	(544981, 130, '2014-02-15 00:04:28.000000', 'consum', 0.0223, 'lps'),
	(544982, 130, '2014-02-15 00:04:29.000000', 'consum', 0.0220, 'lps'),
	(544983, 130, '2014-02-15 00:04:30.000000', 'consum', 0.0221, 'lps'),
	(544984, 130, '2014-02-15 00:04:31.000000', 'consum', 0.0221, 'lps'),
	(544985, 130, '2014-02-15 00:04:32.000000', 'consum', 0.0215, 'lps'),
	(544986, 130, '2014-02-15 00:04:33.000000', 'consum', 0.0219, 'lps'),
	(544987, 130, '2014-02-15 00:04:34.000000', 'consum', 0.0223, 'lps'),
	(544988, 130, '2014-02-15 00:04:35.000000', 'consum', 0.0213, 'lps'),
	(544989, 130, '2014-02-15 00:04:36.000000', 'consum', 0.0223, 'lps'),
	(544990, 130, '2014-02-15 00:04:37.000000', 'consum', 0.0216, 'lps'),
	(544991, 130, '2014-02-15 00:04:38.000000', 'consum', 0.0219, 'lps'),
	(544992, 130, '2014-02-15 00:04:39.000000', 'consum', 0.0221, 'lps'),
	(544993, 130, '2014-02-15 00:04:40.000000', 'consum', 0.0220, 'lps'),
	(544994, 130, '2014-02-15 00:04:41.000000', 'consum', 0.0226, 'lps'),
	(544995, 130, '2014-02-15 00:04:42.000000', 'consum', 0.0212, 'lps'),
	(544996, 130, '2014-02-15 00:04:43.000000', 'consum', 0.0224, 'lps'),
	(544997, 130, '2014-02-15 00:04:44.000000', 'consum', 0.0223, 'lps'),
	(544998, 130, '2014-02-15 00:04:45.000000', 'consum', 0.0216, 'lps'),
	(544999, 130, '2014-02-15 00:04:46.000000', 'consum', 0.0220, 'lps'),
	(545000, 130, '2014-02-15 00:04:47.000000', 'consum', 0.0223, 'lps'),
	(545001, 130, '2014-02-15 00:04:48.000000', 'consum', 0.0213, 'lps'),
	(545002, 130, '2014-02-15 00:04:49.000000', 'consum', 0.0218, 'lps'),
	(545003, 130, '2014-02-15 00:04:50.000000', 'consum', 0.0210, 'lps'),
	(545004, 130, '2014-02-15 00:04:51.000000', 'consum', 0.0220, 'lps'),
	(545005, 130, '2014-02-15 00:04:52.000000', 'consum', 0.0211, 'lps'),
	(545006, 130, '2014-02-15 00:04:53.000000', 'consum', 0.0219, 'lps'),
	(545007, 130, '2014-02-15 00:04:54.000000', 'consum', 0.0216, 'lps'),
	(545008, 130, '2014-02-15 00:04:55.000000', 'consum', 0.0216, 'lps'),
	(545009, 130, '2014-02-15 00:04:56.000000', 'consum', 0.0224, 'lps'),
	(545010, 130, '2014-02-15 00:04:57.000000', 'consum', 0.0225, 'lps'),
	(545011, 130, '2014-02-15 00:04:58.000000', 'consum', 0.0210, 'lps'),
	(545012, 130, '2014-02-15 00:04:59.000000', 'consum', 0.0219, 'lps'),
	(545013, 130, '2014-02-15 00:05:00.000000', 'consum', 0.0220, 'lps'),
	(545014, 130, '2014-02-15 00:05:01.000000', 'consum', 0.0217, 'lps'),
	(545015, 130, '2014-02-15 00:05:02.000000', 'consum', 0.0213, 'lps'),
	(545016, 130, '2014-02-15 00:05:03.000000', 'consum', 0.0224, 'lps'),
	(545017, 130, '2014-02-15 00:05:04.000000', 'consum', 0.0220, 'lps'),
	(545018, 130, '2014-02-15 00:05:05.000000', 'consum', 0.0220, 'lps'),
	(545019, 130, '2014-02-15 00:05:06.000000', 'consum', 0.0214, 'lps'),
	(545020, 130, '2014-02-15 00:05:07.000000', 'consum', 0.0215, 'lps'),
	(545021, 130, '2014-02-15 00:05:08.000000', 'consum', 0.0226, 'lps'),
	(545022, 130, '2014-02-15 00:05:09.000000', 'consum', 0.0225, 'lps'),
	(545023, 130, '2014-02-15 00:05:10.000000', 'consum', 0.0219, 'lps'),
	(545024, 130, '2014-02-15 00:05:11.000000', 'consum', 0.0211, 'lps'),
	(545025, 130, '2014-02-15 00:05:12.000000', 'consum', 0.0223, 'lps'),
	(545026, 130, '2014-02-15 00:05:13.000000', 'consum', 0.0220, 'lps'),
	(545027, 130, '2014-02-15 00:05:14.000000', 'consum', 0.0221, 'lps'),
	(545028, 130, '2014-02-15 00:05:15.000000', 'consum', 0.0219, 'lps'),
	(545029, 130, '2014-02-15 00:05:16.000000', 'consum', 0.0224, 'lps'),
	(545030, 130, '2014-02-15 00:05:17.000000', 'consum', 0.0218, 'lps'),
	(545031, 130, '2014-02-15 00:05:18.000000', 'consum', 0.0210, 'lps'),
	(545032, 130, '2014-02-15 00:05:19.000000', 'consum', 0.0218, 'lps'),
	(545033, 130, '2014-02-15 00:05:20.000000', 'consum', 0.0220, 'lps'),
	(545034, 130, '2014-02-15 00:05:21.000000', 'consum', 0.0217, 'lps'),
	(545035, 130, '2014-02-15 00:05:22.000000', 'consum', 0.0214, 'lps'),
	(545036, 130, '2014-02-15 00:05:23.000000', 'consum', 0.0212, 'lps'),
	(545037, 130, '2014-02-15 00:05:24.000000', 'consum', 0.0224, 'lps'),
	(545038, 130, '2014-02-15 00:05:25.000000', 'consum', 0.0224, 'lps'),
	(545039, 130, '2014-02-15 00:05:26.000000', 'consum', 0.0223, 'lps'),
	(545040, 130, '2014-02-15 00:05:27.000000', 'consum', 0.0218, 'lps'),
	(545041, 130, '2014-02-15 00:05:28.000000', 'consum', 0.0225, 'lps'),
	(545042, 130, '2014-02-15 00:05:29.000000', 'consum', 0.0211, 'lps'),
	(545043, 130, '2014-02-15 00:05:30.000000', 'consum', 0.0222, 'lps'),
	(545044, 130, '2014-02-15 00:05:31.000000', 'consum', 0.0217, 'lps'),
	(545045, 130, '2014-02-15 00:05:32.000000', 'consum', 0.0211, 'lps'),
	(545046, 130, '2014-02-15 00:05:33.000000', 'consum', 0.0210, 'lps'),
	(545047, 130, '2014-02-15 00:05:34.000000', 'consum', 0.0226, 'lps'),
	(545048, 130, '2014-02-15 00:05:35.000000', 'consum', 0.0222, 'lps'),
	(545049, 130, '2014-02-15 00:05:36.000000', 'consum', 0.0220, 'lps'),
	(545050, 130, '2014-02-15 00:05:37.000000', 'consum', 0.0226, 'lps'),
	(545051, 130, '2014-02-15 00:05:38.000000', 'consum', 0.0212, 'lps'),
	(545052, 130, '2014-02-15 00:05:39.000000', 'consum', 0.0220, 'lps'),
	(545053, 130, '2014-02-15 00:05:40.000000', 'consum', 0.0223, 'lps'),
	(545054, 130, '2014-02-15 00:05:41.000000', 'consum', 0.0226, 'lps'),
	(545055, 130, '2014-02-15 00:05:42.000000', 'consum', 0.0217, 'lps'),
	(545056, 130, '2014-02-15 00:05:43.000000', 'consum', 0.0214, 'lps'),
	(545057, 130, '2014-02-15 00:05:44.000000', 'consum', 0.0212, 'lps'),
	(545058, 130, '2014-02-15 00:05:45.000000', 'consum', 0.0224, 'lps'),
	(545059, 130, '2014-02-15 00:05:46.000000', 'consum', 0.0224, 'lps'),
	(545060, 130, '2014-02-15 00:05:47.000000', 'consum', 0.0220, 'lps'),
	(545061, 130, '2014-02-15 00:05:48.000000', 'consum', 0.0221, 'lps'),
	(545062, 130, '2014-02-15 00:05:49.000000', 'consum', 0.0215, 'lps'),
	(545063, 130, '2014-02-15 00:05:50.000000', 'consum', 0.0223, 'lps'),
	(545064, 130, '2014-02-15 00:05:51.000000', 'consum', 0.0224, 'lps'),
	(545065, 130, '2014-02-15 00:05:52.000000', 'consum', 0.0226, 'lps'),
	(545066, 130, '2014-02-15 00:05:53.000000', 'consum', 0.0216, 'lps'),
	(545067, 130, '2014-02-15 00:05:54.000000', 'consum', 0.0225, 'lps'),
	(545068, 130, '2014-02-15 00:05:55.000000', 'consum', 0.0216, 'lps'),
	(545069, 130, '2014-02-15 00:05:56.000000', 'consum', 0.0211, 'lps'),
	(545070, 130, '2014-02-15 00:05:57.000000', 'consum', 0.0217, 'lps'),
	(545071, 130, '2014-02-15 00:05:58.000000', 'consum', 0.0225, 'lps'),
	(545072, 130, '2014-02-15 00:05:59.000000', 'consum', 0.0215, 'lps'),
	(545073, 130, '2014-02-15 00:06:00.000000', 'consum', 0.0221, 'lps'),
	(545074, 130, '2014-02-15 00:06:01.000000', 'consum', 0.0220, 'lps'),
	(545075, 130, '2014-02-15 00:06:02.000000', 'consum', 0.0226, 'lps'),
	(545076, 130, '2014-02-15 00:06:03.000000', 'consum', 0.0211, 'lps'),
	(545077, 130, '2014-02-15 00:06:04.000000', 'consum', 0.0219, 'lps'),
	(545078, 130, '2014-02-15 00:06:05.000000', 'consum', 0.0218, 'lps'),
	(545079, 130, '2014-02-15 00:06:06.000000', 'consum', 0.0223, 'lps'),
	(545080, 130, '2014-02-15 00:06:07.000000', 'consum', 0.0219, 'lps'),
	(545081, 130, '2014-02-15 00:06:08.000000', 'consum', 0.0217, 'lps'),
	(545082, 130, '2014-02-15 00:06:09.000000', 'consum', 0.0220, 'lps'),
	(545083, 130, '2014-02-15 00:06:10.000000', 'consum', 0.0219, 'lps'),
	(545084, 130, '2014-02-15 00:06:11.000000', 'consum', 0.0210, 'lps'),
	(545085, 130, '2014-02-15 00:06:12.000000', 'consum', 0.0217, 'lps'),
	(545086, 130, '2014-02-15 00:06:13.000000', 'consum', 0.0212, 'lps'),
	(545087, 130, '2014-02-15 00:06:14.000000', 'consum', 0.0215, 'lps'),
	(545088, 130, '2014-02-15 00:06:15.000000', 'consum', 0.0215, 'lps'),
	(545089, 130, '2014-02-15 00:06:16.000000', 'consum', 0.0219, 'lps'),
	(545090, 130, '2014-02-15 00:06:17.000000', 'consum', 0.0222, 'lps'),
	(545091, 130, '2014-02-15 00:06:18.000000', 'consum', 0.0211, 'lps'),
	(545092, 130, '2014-02-15 00:06:19.000000', 'consum', 0.0213, 'lps'),
	(545093, 130, '2014-02-15 00:06:20.000000', 'consum', 0.0223, 'lps'),
	(545094, 130, '2014-02-15 00:06:21.000000', 'consum', 0.0214, 'lps'),
	(545095, 130, '2014-02-15 00:06:22.000000', 'consum', 0.0225, 'lps'),
	(545096, 130, '2014-02-15 00:06:23.000000', 'consum', 0.0225, 'lps'),
	(545097, 130, '2014-02-15 00:06:24.000000', 'consum', 0.0223, 'lps'),
	(545098, 130, '2014-02-15 00:06:25.000000', 'consum', 0.0214, 'lps'),
	(545099, 130, '2014-02-15 00:06:26.000000', 'consum', 0.0226, 'lps'),
	(545100, 130, '2014-02-15 00:06:27.000000', 'consum', 0.0226, 'lps'),
	(545101, 130, '2014-02-15 00:06:28.000000', 'consum', 0.0210, 'lps'),
	(545102, 130, '2014-02-15 00:06:29.000000', 'consum', 0.0214, 'lps'),
	(545103, 130, '2014-02-15 00:06:30.000000', 'consum', 0.0212, 'lps'),
	(545104, 130, '2014-02-15 00:06:31.000000', 'consum', 0.0211, 'lps'),
	(545105, 130, '2014-02-15 00:06:32.000000', 'consum', 0.0223, 'lps'),
	(545106, 130, '2014-02-15 00:06:33.000000', 'consum', 0.0225, 'lps'),
	(545107, 130, '2014-02-15 00:06:34.000000', 'consum', 0.0211, 'lps'),
	(545108, 130, '2014-02-15 00:06:35.000000', 'consum', 0.0221, 'lps'),
	(545109, 130, '2014-02-15 00:06:36.000000', 'consum', 0.0211, 'lps'),
	(545110, 130, '2014-02-15 00:06:37.000000', 'consum', 0.0217, 'lps'),
	(545111, 130, '2014-02-15 00:06:38.000000', 'consum', 0.0226, 'lps'),
	(545112, 130, '2014-02-15 00:06:39.000000', 'consum', 0.0220, 'lps'),
	(545113, 130, '2014-02-15 00:06:40.000000', 'consum', 0.0211, 'lps'),
	(545114, 130, '2014-02-15 00:06:41.000000', 'consum', 0.0220, 'lps'),
	(545115, 130, '2014-02-15 00:06:42.000000', 'consum', 0.0222, 'lps'),
	(545116, 130, '2014-02-15 00:06:43.000000', 'consum', 0.0223, 'lps'),
	(545117, 130, '2014-02-15 00:06:44.000000', 'consum', 0.0224, 'lps'),
	(545118, 130, '2014-02-15 00:06:45.000000', 'consum', 0.0224, 'lps'),
	(545119, 130, '2014-02-15 00:06:46.000000', 'consum', 0.0222, 'lps'),
	(545120, 130, '2014-02-15 00:06:47.000000', 'consum', 0.0210, 'lps'),
	(545121, 130, '2014-02-15 00:06:48.000000', 'consum', 0.0211, 'lps'),
	(545122, 130, '2014-02-15 00:06:49.000000', 'consum', 0.0216, 'lps'),
	(545123, 130, '2014-02-15 00:06:50.000000', 'consum', 0.0221, 'lps'),
	(545124, 130, '2014-02-15 00:06:51.000000', 'consum', 0.0213, 'lps'),
	(545125, 130, '2014-02-15 00:06:52.000000', 'consum', 0.0210, 'lps'),
	(545126, 130, '2014-02-15 00:06:53.000000', 'consum', 0.0216, 'lps'),
	(545127, 130, '2014-02-15 00:06:54.000000', 'consum', 0.0224, 'lps'),
	(545128, 130, '2014-02-15 00:06:55.000000', 'consum', 0.0214, 'lps'),
	(545129, 130, '2014-02-15 00:06:56.000000', 'consum', 0.0220, 'lps'),
	(545130, 130, '2014-02-15 00:06:57.000000', 'consum', 0.0216, 'lps'),
	(545131, 130, '2014-02-15 00:06:58.000000', 'consum', 0.0211, 'lps'),
	(545132, 130, '2014-02-15 00:06:59.000000', 'consum', 0.0213, 'lps'),
	(545133, 130, '2014-02-15 00:07:00.000000', 'consum', 0.0221, 'lps'),
	(545134, 130, '2014-02-15 00:07:01.000000', 'consum', 0.0224, 'lps'),
	(545135, 130, '2014-02-15 00:07:02.000000', 'consum', 0.0212, 'lps'),
	(545136, 130, '2014-02-15 00:07:03.000000', 'consum', 0.0215, 'lps'),
	(545137, 130, '2014-02-15 00:07:04.000000', 'consum', 0.0213, 'lps'),
	(545138, 130, '2014-02-15 00:07:05.000000', 'consum', 0.0210, 'lps'),
	(545139, 130, '2014-02-15 00:07:06.000000', 'consum', 0.0217, 'lps'),
	(545140, 130, '2014-02-15 00:07:07.000000', 'consum', 0.0213, 'lps'),
	(545141, 130, '2014-02-15 00:07:08.000000', 'consum', 0.0223, 'lps'),
	(545142, 130, '2014-02-15 00:07:09.000000', 'consum', 0.0213, 'lps'),
	(545143, 130, '2014-02-15 00:07:10.000000', 'consum', 0.0222, 'lps'),
	(545144, 130, '2014-02-15 00:07:11.000000', 'consum', 0.0225, 'lps'),
	(545145, 130, '2014-02-15 00:07:12.000000', 'consum', 0.0218, 'lps'),
	(545146, 130, '2014-02-15 00:07:13.000000', 'consum', 0.0220, 'lps'),
	(545147, 130, '2014-02-15 00:07:14.000000', 'consum', 0.0220, 'lps'),
	(545148, 130, '2014-02-15 00:07:15.000000', 'consum', 0.0215, 'lps'),
	(545149, 130, '2014-02-15 00:07:16.000000', 'consum', 0.0223, 'lps'),
	(545150, 130, '2014-02-15 00:07:17.000000', 'consum', 0.0226, 'lps'),
	(545151, 130, '2014-02-15 00:07:18.000000', 'consum', 0.0217, 'lps'),
	(545152, 130, '2014-02-15 00:07:19.000000', 'consum', 0.0214, 'lps'),
	(545153, 130, '2014-02-15 00:07:20.000000', 'consum', 0.0225, 'lps'),
	(545154, 130, '2014-02-15 00:07:21.000000', 'consum', 0.0225, 'lps'),
	(545155, 130, '2014-02-15 00:07:22.000000', 'consum', 0.0223, 'lps'),
	(545156, 130, '2014-02-15 00:07:23.000000', 'consum', 0.0215, 'lps'),
	(545157, 130, '2014-02-15 00:07:24.000000', 'consum', 0.0211, 'lps'),
	(545158, 130, '2014-02-15 00:07:25.000000', 'consum', 0.0217, 'lps'),
	(545159, 130, '2014-02-15 00:07:26.000000', 'consum', 0.0212, 'lps'),
	(545160, 130, '2014-02-15 00:07:27.000000', 'consum', 0.0213, 'lps'),
	(545161, 130, '2014-02-15 00:07:28.000000', 'consum', 0.0221, 'lps'),
	(545162, 130, '2014-02-15 00:07:29.000000', 'consum', 0.0224, 'lps'),
	(545163, 130, '2014-02-15 00:07:30.000000', 'consum', 0.0211, 'lps'),
	(545164, 130, '2014-02-15 00:07:31.000000', 'consum', 0.0226, 'lps'),
	(545165, 130, '2014-02-15 00:07:32.000000', 'consum', 0.0219, 'lps'),
	(545166, 130, '2014-02-15 00:07:33.000000', 'consum', 0.0223, 'lps'),
	(545167, 130, '2014-02-15 00:07:34.000000', 'consum', 0.0217, 'lps'),
	(545168, 130, '2014-02-15 00:07:35.000000', 'consum', 0.0224, 'lps'),
	(545169, 130, '2014-02-15 00:07:36.000000', 'consum', 0.0225, 'lps'),
	(545170, 130, '2014-02-15 00:07:37.000000', 'consum', 0.0224, 'lps'),
	(545171, 130, '2014-02-15 00:07:38.000000', 'consum', 0.0222, 'lps'),
	(545172, 130, '2014-02-15 00:07:39.000000', 'consum', 0.0210, 'lps'),
	(545173, 130, '2014-02-15 00:07:40.000000', 'consum', 0.0225, 'lps'),
	(545174, 130, '2014-02-15 00:07:41.000000', 'consum', 0.0218, 'lps'),
	(545175, 130, '2014-02-15 00:07:42.000000', 'consum', 0.0221, 'lps'),
	(545176, 130, '2014-02-15 00:07:43.000000', 'consum', 0.0225, 'lps'),
	(545177, 130, '2014-02-15 00:07:44.000000', 'consum', 0.0221, 'lps'),
	(545178, 130, '2014-02-15 00:07:45.000000', 'consum', 0.0217, 'lps'),
	(545179, 130, '2014-02-15 00:07:46.000000', 'consum', 0.0215, 'lps'),
	(545180, 130, '2014-02-15 00:07:47.000000', 'consum', 0.0213, 'lps'),
	(545181, 130, '2014-02-15 00:07:48.000000', 'consum', 0.0213, 'lps'),
	(545182, 130, '2014-02-15 00:07:49.000000', 'consum', 0.0216, 'lps'),
	(545183, 130, '2014-02-15 00:07:50.000000', 'consum', 0.0213, 'lps'),
	(545184, 130, '2014-02-15 00:07:51.000000', 'consum', 0.0225, 'lps'),
	(545185, 130, '2014-02-15 00:07:52.000000', 'consum', 0.0224, 'lps'),
	(545186, 130, '2014-02-15 00:07:53.000000', 'consum', 0.0221, 'lps'),
	(545187, 130, '2014-02-15 00:07:54.000000', 'consum', 0.0221, 'lps'),
	(545188, 130, '2014-02-15 00:07:55.000000', 'consum', 0.0218, 'lps'),
	(545189, 130, '2014-02-15 00:07:56.000000', 'consum', 0.0216, 'lps'),
	(545190, 130, '2014-02-15 00:07:57.000000', 'consum', 0.0218, 'lps'),
	(545191, 130, '2014-02-15 00:07:58.000000', 'consum', 0.0213, 'lps'),
	(545192, 130, '2014-02-15 00:07:59.000000', 'consum', 0.0221, 'lps'),
	(545193, 130, '2014-02-15 00:08:00.000000', 'consum', 0.0221, 'lps'),
	(545194, 130, '2014-02-15 00:08:01.000000', 'consum', 0.0218, 'lps'),
	(545195, 130, '2014-02-15 00:08:02.000000', 'consum', 0.0215, 'lps'),
	(545196, 130, '2014-02-15 00:08:03.000000', 'consum', 0.0213, 'lps'),
	(545197, 130, '2014-02-15 00:08:04.000000', 'consum', 0.0212, 'lps'),
	(545198, 130, '2014-02-15 00:08:05.000000', 'consum', 0.0225, 'lps'),
	(545199, 130, '2014-02-15 00:08:06.000000', 'consum', 0.0213, 'lps'),
	(545200, 130, '2014-02-15 00:08:07.000000', 'consum', 0.0213, 'lps'),
	(545201, 130, '2014-02-15 00:08:08.000000', 'consum', 0.0217, 'lps'),
	(545202, 130, '2014-02-15 00:08:09.000000', 'consum', 0.0221, 'lps'),
	(545203, 130, '2014-02-15 00:08:10.000000', 'consum', 0.0211, 'lps'),
	(545204, 130, '2014-02-15 00:08:11.000000', 'consum', 0.0214, 'lps'),
	(545205, 130, '2014-02-15 00:08:12.000000', 'consum', 0.0213, 'lps'),
	(545206, 130, '2014-02-15 00:08:13.000000', 'consum', 0.0212, 'lps'),
	(545207, 130, '2014-02-15 00:08:14.000000', 'consum', 0.0214, 'lps'),
	(545208, 130, '2014-02-15 00:08:15.000000', 'consum', 0.0222, 'lps'),
	(545209, 130, '2014-02-15 00:08:16.000000', 'consum', 0.0210, 'lps'),
	(545210, 130, '2014-02-15 00:08:17.000000', 'consum', 0.0222, 'lps'),
	(545211, 130, '2014-02-15 00:08:18.000000', 'consum', 0.0222, 'lps'),
	(545212, 130, '2014-02-15 00:08:19.000000', 'consum', 0.0218, 'lps'),
	(545213, 130, '2014-02-15 00:08:20.000000', 'consum', 0.0213, 'lps'),
	(545214, 130, '2014-02-15 00:08:21.000000', 'consum', 0.0219, 'lps'),
	(545215, 130, '2014-02-15 00:08:22.000000', 'consum', 0.0211, 'lps'),
	(545216, 130, '2014-02-15 00:08:23.000000', 'consum', 0.0222, 'lps'),
	(545217, 130, '2014-02-15 00:08:24.000000', 'consum', 0.0217, 'lps'),
	(545218, 130, '2014-02-15 00:08:25.000000', 'consum', 0.0212, 'lps'),
	(545219, 130, '2014-02-15 00:08:26.000000', 'consum', 0.0215, 'lps'),
	(545220, 130, '2014-02-15 00:08:27.000000', 'consum', 0.0211, 'lps'),
	(545221, 130, '2014-02-15 00:08:28.000000', 'consum', 0.0219, 'lps'),
	(545222, 130, '2014-02-15 00:08:29.000000', 'consum', 0.0217, 'lps'),
	(545223, 130, '2014-02-15 00:08:30.000000', 'consum', 0.0220, 'lps'),
	(545224, 130, '2014-02-15 00:08:31.000000', 'consum', 0.0222, 'lps'),
	(545225, 130, '2014-02-15 00:08:32.000000', 'consum', 0.0222, 'lps'),
	(545226, 130, '2014-02-15 00:08:33.000000', 'consum', 0.0219, 'lps'),
	(545227, 130, '2014-02-15 00:08:34.000000', 'consum', 0.0218, 'lps'),
	(545228, 130, '2014-02-15 00:08:35.000000', 'consum', 0.0225, 'lps'),
	(545229, 130, '2014-02-15 00:08:36.000000', 'consum', 0.0211, 'lps'),
	(545230, 130, '2014-02-15 00:08:37.000000', 'consum', 0.0219, 'lps'),
	(545231, 130, '2014-02-15 00:08:38.000000', 'consum', 0.0219, 'lps'),
	(545232, 130, '2014-02-15 00:08:39.000000', 'consum', 0.0214, 'lps'),
	(545233, 130, '2014-02-15 00:08:40.000000', 'consum', 0.0219, 'lps'),
	(545234, 130, '2014-02-15 00:08:41.000000', 'consum', 0.0210, 'lps'),
	(545235, 130, '2014-02-15 00:08:42.000000', 'consum', 0.0217, 'lps'),
	(545236, 130, '2014-02-15 00:08:43.000000', 'consum', 0.0212, 'lps'),
	(545237, 130, '2014-02-15 00:08:44.000000', 'consum', 0.0217, 'lps'),
	(545238, 130, '2014-02-15 00:08:45.000000', 'consum', 0.0222, 'lps'),
	(545239, 130, '2014-02-15 00:08:46.000000', 'consum', 0.0215, 'lps'),
	(545240, 130, '2014-02-15 00:08:47.000000', 'consum', 0.0215, 'lps'),
	(545241, 130, '2014-02-15 00:08:48.000000', 'consum', 0.0221, 'lps'),
	(545242, 130, '2014-02-15 00:08:49.000000', 'consum', 0.0215, 'lps'),
	(545243, 130, '2014-02-15 00:08:50.000000', 'consum', 0.0223, 'lps'),
	(545244, 130, '2014-02-15 00:08:51.000000', 'consum', 0.0225, 'lps'),
	(545245, 130, '2014-02-15 00:08:52.000000', 'consum', 0.0213, 'lps'),
	(545246, 130, '2014-02-15 00:08:53.000000', 'consum', 0.0216, 'lps'),
	(545247, 130, '2014-02-15 00:08:54.000000', 'consum', 0.0212, 'lps'),
	(545248, 130, '2014-02-15 00:08:55.000000', 'consum', 0.0220, 'lps'),
	(545249, 130, '2014-02-15 00:08:56.000000', 'consum', 0.0221, 'lps'),
	(545250, 130, '2014-02-15 00:08:57.000000', 'consum', 0.0219, 'lps'),
	(545251, 130, '2014-02-15 00:08:58.000000', 'consum', 0.0223, 'lps'),
	(545252, 130, '2014-02-15 00:08:59.000000', 'consum', 0.0212, 'lps'),
	(545253, 130, '2014-02-15 00:09:00.000000', 'consum', 0.0216, 'lps'),
	(545254, 130, '2014-02-15 00:09:01.000000', 'consum', 0.0219, 'lps'),
	(545255, 130, '2014-02-15 00:09:02.000000', 'consum', 0.0218, 'lps'),
	(545256, 130, '2014-02-15 00:09:03.000000', 'consum', 0.0210, 'lps'),
	(545257, 130, '2014-02-15 00:09:04.000000', 'consum', 0.0218, 'lps'),
	(545258, 130, '2014-02-15 00:09:05.000000', 'consum', 0.0218, 'lps'),
	(545259, 130, '2014-02-15 00:09:06.000000', 'consum', 0.0225, 'lps'),
	(545260, 130, '2014-02-15 00:09:07.000000', 'consum', 0.0212, 'lps'),
	(545261, 130, '2014-02-15 00:09:08.000000', 'consum', 0.0225, 'lps'),
	(545262, 130, '2014-02-15 00:09:09.000000', 'consum', 0.0213, 'lps'),
	(545263, 130, '2014-02-15 00:09:10.000000', 'consum', 0.0215, 'lps'),
	(545264, 130, '2014-02-15 00:09:11.000000', 'consum', 0.0225, 'lps'),
	(545265, 130, '2014-02-15 00:09:12.000000', 'consum', 0.0218, 'lps'),
	(545266, 130, '2014-02-15 00:09:13.000000', 'consum', 0.0225, 'lps'),
	(545267, 130, '2014-02-15 00:09:14.000000', 'consum', 0.0210, 'lps'),
	(545268, 130, '2014-02-15 00:09:15.000000', 'consum', 0.0215, 'lps'),
	(545269, 130, '2014-02-15 00:09:16.000000', 'consum', 0.0219, 'lps'),
	(545270, 130, '2014-02-15 00:09:17.000000', 'consum', 0.0223, 'lps'),
	(545271, 130, '2014-02-15 00:09:18.000000', 'consum', 0.0216, 'lps'),
	(545272, 130, '2014-02-15 00:09:19.000000', 'consum', 0.0218, 'lps'),
	(545273, 130, '2014-02-15 00:09:20.000000', 'consum', 0.0214, 'lps'),
	(545274, 130, '2014-02-15 00:09:21.000000', 'consum', 0.0225, 'lps'),
	(545275, 130, '2014-02-15 00:09:22.000000', 'consum', 0.0222, 'lps'),
	(545276, 130, '2014-02-15 00:09:23.000000', 'consum', 0.0226, 'lps'),
	(545277, 130, '2014-02-15 00:09:24.000000', 'consum', 0.0219, 'lps'),
	(545278, 130, '2014-02-15 00:09:25.000000', 'consum', 0.0226, 'lps'),
	(545279, 130, '2014-02-15 00:09:26.000000', 'consum', 0.0214, 'lps'),
	(545280, 130, '2014-02-15 00:09:27.000000', 'consum', 0.0214, 'lps'),
	(545281, 130, '2014-02-15 00:09:28.000000', 'consum', 0.0218, 'lps'),
	(545282, 130, '2014-02-15 00:09:29.000000', 'consum', 0.0224, 'lps'),
	(545283, 130, '2014-02-15 00:09:30.000000', 'consum', 0.0221, 'lps'),
	(545284, 130, '2014-02-15 00:09:31.000000', 'consum', 0.0223, 'lps'),
	(545285, 130, '2014-02-15 00:09:32.000000', 'consum', 0.0226, 'lps'),
	(545286, 130, '2014-02-15 00:09:33.000000', 'consum', 0.0216, 'lps'),
	(545287, 130, '2014-02-15 00:09:34.000000', 'consum', 0.0213, 'lps'),
	(545288, 130, '2014-02-15 00:09:35.000000', 'consum', 0.0222, 'lps'),
	(545289, 130, '2014-02-15 00:09:36.000000', 'consum', 0.0226, 'lps'),
	(545290, 130, '2014-02-15 00:09:37.000000', 'consum', 0.0222, 'lps'),
	(545291, 130, '2014-02-15 00:09:38.000000', 'consum', 0.0221, 'lps'),
	(545292, 130, '2014-02-15 00:09:39.000000', 'consum', 0.0214, 'lps'),
	(545293, 130, '2014-02-15 00:09:40.000000', 'consum', 0.0213, 'lps'),
	(545294, 130, '2014-02-15 00:09:41.000000', 'consum', 0.0215, 'lps'),
	(545295, 130, '2014-02-15 00:09:42.000000', 'consum', 0.0210, 'lps'),
	(545296, 130, '2014-02-15 00:09:43.000000', 'consum', 0.0212, 'lps'),
	(545297, 130, '2014-02-15 00:09:44.000000', 'consum', 0.0221, 'lps'),
	(545298, 130, '2014-02-15 00:09:45.000000', 'consum', 0.0224, 'lps'),
	(545299, 130, '2014-02-15 00:09:46.000000', 'consum', 0.0212, 'lps'),
	(545300, 130, '2014-02-15 00:09:47.000000', 'consum', 0.0215, 'lps'),
	(545301, 130, '2014-02-15 00:09:48.000000', 'consum', 0.0211, 'lps'),
	(545302, 130, '2014-02-15 00:09:49.000000', 'consum', 0.0218, 'lps'),
	(545303, 130, '2014-02-15 00:09:50.000000', 'consum', 0.0213, 'lps'),
	(545304, 130, '2014-02-15 00:09:51.000000', 'consum', 0.0218, 'lps'),
	(545305, 130, '2014-02-15 00:09:52.000000', 'consum', 0.0223, 'lps'),
	(545306, 130, '2014-02-15 00:09:53.000000', 'consum', 0.0220, 'lps'),
	(545307, 130, '2014-02-15 00:09:54.000000', 'consum', 0.0220, 'lps'),
	(545308, 130, '2014-02-15 00:09:55.000000', 'consum', 0.0214, 'lps'),
	(545309, 130, '2014-02-15 00:09:56.000000', 'consum', 0.0219, 'lps'),
	(545310, 130, '2014-02-15 00:09:57.000000', 'consum', 0.0210, 'lps'),
	(545311, 130, '2014-02-15 00:09:58.000000', 'consum', 0.0218, 'lps'),
	(545312, 130, '2014-02-15 00:09:59.000000', 'consum', 0.0216, 'lps'),
	(545313, 130, '2014-02-15 00:10:00.000000', 'consum', 0.0218, 'lps'),
	(545314, 130, '2014-02-15 00:10:01.000000', 'consum', 0.0213, 'lps'),
	(545315, 130, '2014-02-15 00:10:02.000000', 'consum', 0.0219, 'lps'),
	(545316, 130, '2014-02-15 00:10:03.000000', 'consum', 0.0214, 'lps'),
	(545317, 130, '2014-02-15 00:10:04.000000', 'consum', 0.0221, 'lps'),
	(545318, 130, '2014-02-15 00:10:05.000000', 'consum', 0.0218, 'lps'),
	(545319, 130, '2014-02-15 00:10:06.000000', 'consum', 0.0220, 'lps'),
	(545320, 130, '2014-02-15 00:10:07.000000', 'consum', 0.0217, 'lps'),
	(545321, 130, '2014-02-15 00:10:08.000000', 'consum', 0.0216, 'lps'),
	(545322, 130, '2014-02-15 00:10:09.000000', 'consum', 0.0219, 'lps'),
	(545323, 130, '2014-02-15 00:10:10.000000', 'consum', 0.0221, 'lps'),
	(545324, 130, '2014-02-15 00:10:11.000000', 'consum', 0.0223, 'lps'),
	(545325, 130, '2014-02-15 00:10:12.000000', 'consum', 0.0225, 'lps'),
	(545326, 130, '2014-02-15 00:10:13.000000', 'consum', 0.0211, 'lps'),
	(545327, 130, '2014-02-15 00:10:14.000000', 'consum', 0.0223, 'lps'),
	(545328, 130, '2014-02-15 00:10:15.000000', 'consum', 0.0219, 'lps'),
	(545329, 130, '2014-02-15 00:10:16.000000', 'consum', 0.0217, 'lps'),
	(545330, 130, '2014-02-15 00:10:17.000000', 'consum', 0.0220, 'lps'),
	(545331, 130, '2014-02-15 00:10:18.000000', 'consum', 0.0223, 'lps'),
	(545332, 130, '2014-02-15 00:10:19.000000', 'consum', 0.0211, 'lps'),
	(545333, 130, '2014-02-15 00:10:20.000000', 'consum', 0.0211, 'lps'),
	(545334, 130, '2014-02-15 00:10:21.000000', 'consum', 0.0214, 'lps'),
	(545335, 130, '2014-02-15 00:10:22.000000', 'consum', 0.0224, 'lps'),
	(545336, 130, '2014-02-15 00:10:23.000000', 'consum', 0.0221, 'lps'),
	(545337, 130, '2014-02-15 00:10:24.000000', 'consum', 0.0220, 'lps'),
	(545338, 130, '2014-02-15 00:10:25.000000', 'consum', 0.0213, 'lps'),
	(545339, 130, '2014-02-15 00:10:26.000000', 'consum', 0.0210, 'lps'),
	(545340, 130, '2014-02-15 00:10:27.000000', 'consum', 0.0220, 'lps'),
	(545341, 130, '2014-02-15 00:10:28.000000', 'consum', 0.0225, 'lps'),
	(545342, 130, '2014-02-15 00:10:29.000000', 'consum', 0.0223, 'lps'),
	(545343, 130, '2014-02-15 00:10:30.000000', 'consum', 0.0213, 'lps'),
	(545344, 130, '2014-02-15 00:10:31.000000', 'consum', 0.0223, 'lps'),
	(545345, 130, '2014-02-15 00:10:32.000000', 'consum', 0.0212, 'lps'),
	(545346, 130, '2014-02-15 00:10:33.000000', 'consum', 0.0217, 'lps'),
	(545347, 130, '2014-02-15 00:10:34.000000', 'consum', 0.0221, 'lps'),
	(545348, 130, '2014-02-15 00:10:35.000000', 'consum', 0.0210, 'lps'),
	(545349, 130, '2014-02-15 00:10:36.000000', 'consum', 0.0215, 'lps'),
	(545350, 130, '2014-02-15 00:10:37.000000', 'consum', 0.0215, 'lps'),
	(545351, 130, '2014-02-15 00:10:38.000000', 'consum', 0.0222, 'lps'),
	(545352, 130, '2014-02-15 00:10:39.000000', 'consum', 0.0222, 'lps'),
	(545353, 130, '2014-02-15 00:10:40.000000', 'consum', 0.0217, 'lps'),
	(545354, 130, '2014-02-15 00:10:41.000000', 'consum', 0.0225, 'lps'),
	(545355, 130, '2014-02-15 00:10:42.000000', 'consum', 0.0216, 'lps'),
	(545356, 130, '2014-02-15 00:10:43.000000', 'consum', 0.0211, 'lps'),
	(545357, 130, '2014-02-15 00:10:44.000000', 'consum', 0.0216, 'lps'),
	(545358, 130, '2014-02-15 00:10:45.000000', 'consum', 0.0220, 'lps'),
	(545359, 130, '2014-02-15 00:10:46.000000', 'consum', 0.0226, 'lps'),
	(545360, 130, '2014-02-15 00:10:47.000000', 'consum', 0.0210, 'lps'),
	(545361, 130, '2014-02-15 00:10:48.000000', 'consum', 0.0212, 'lps'),
	(545362, 130, '2014-02-15 00:10:49.000000', 'consum', 0.0223, 'lps'),
	(545363, 130, '2014-02-15 00:10:50.000000', 'consum', 0.0216, 'lps'),
	(545364, 130, '2014-02-15 00:10:51.000000', 'consum', 0.0221, 'lps'),
	(545365, 130, '2014-02-15 00:10:52.000000', 'consum', 0.0211, 'lps'),
	(545366, 130, '2014-02-15 00:10:53.000000', 'consum', 0.0219, 'lps'),
	(545367, 130, '2014-02-15 00:10:54.000000', 'consum', 0.0219, 'lps'),
	(545368, 130, '2014-02-15 00:10:55.000000', 'consum', 0.0212, 'lps'),
	(545369, 130, '2014-02-15 00:10:56.000000', 'consum', 0.0226, 'lps'),
	(545370, 130, '2014-02-15 00:10:57.000000', 'consum', 0.0217, 'lps'),
	(545371, 130, '2014-02-15 00:10:58.000000', 'consum', 0.0213, 'lps'),
	(545372, 130, '2014-02-15 00:10:59.000000', 'consum', 0.0222, 'lps'),
	(545373, 130, '2014-02-15 00:11:00.000000', 'consum', 0.0211, 'lps'),
	(545374, 130, '2014-02-15 00:11:01.000000', 'consum', 0.0214, 'lps'),
	(545375, 130, '2014-02-15 00:11:02.000000', 'consum', 0.0226, 'lps'),
	(545376, 130, '2014-02-15 00:11:03.000000', 'consum', 0.0226, 'lps'),
	(545377, 130, '2014-02-15 00:11:04.000000', 'consum', 0.0212, 'lps'),
	(545378, 130, '2014-02-15 00:11:05.000000', 'consum', 0.0220, 'lps'),
	(545379, 130, '2014-02-15 00:11:06.000000', 'consum', 0.0223, 'lps'),
	(545380, 130, '2014-02-15 00:11:07.000000', 'consum', 0.0226, 'lps'),
	(545381, 130, '2014-02-15 00:11:08.000000', 'consum', 0.0220, 'lps'),
	(545382, 130, '2014-02-15 00:11:09.000000', 'consum', 0.0212, 'lps'),
	(545383, 130, '2014-02-15 00:11:10.000000', 'consum', 0.0225, 'lps'),
	(545384, 130, '2014-02-15 00:11:11.000000', 'consum', 0.0210, 'lps'),
	(545385, 130, '2014-02-15 00:11:12.000000', 'consum', 0.0218, 'lps'),
	(545386, 130, '2014-02-15 00:11:13.000000', 'consum', 0.0215, 'lps'),
	(545387, 130, '2014-02-15 00:11:14.000000', 'consum', 0.0212, 'lps'),
	(545388, 130, '2014-02-15 00:11:15.000000', 'consum', 0.0221, 'lps'),
	(545389, 130, '2014-02-15 00:11:16.000000', 'consum', 0.0226, 'lps'),
	(545390, 130, '2014-02-15 00:11:17.000000', 'consum', 0.0223, 'lps'),
	(545391, 130, '2014-02-15 00:11:18.000000', 'consum', 0.0210, 'lps'),
	(545392, 130, '2014-02-15 00:11:19.000000', 'consum', 0.0224, 'lps'),
	(545393, 130, '2014-02-15 00:11:20.000000', 'consum', 0.0211, 'lps'),
	(545394, 130, '2014-02-15 00:11:21.000000', 'consum', 0.0210, 'lps'),
	(545395, 130, '2014-02-15 00:11:22.000000', 'consum', 0.0222, 'lps'),
	(545396, 130, '2014-02-15 00:11:23.000000', 'consum', 0.0222, 'lps'),
	(545397, 130, '2014-02-15 00:11:24.000000', 'consum', 0.0218, 'lps'),
	(545398, 130, '2014-02-15 00:11:25.000000', 'consum', 0.0214, 'lps'),
	(545399, 130, '2014-02-15 00:11:26.000000', 'consum', 0.0225, 'lps'),
	(545400, 130, '2014-02-15 00:11:27.000000', 'consum', 0.0221, 'lps'),
	(545401, 130, '2014-02-15 00:11:28.000000', 'consum', 0.0222, 'lps'),
	(545402, 130, '2014-02-15 00:11:29.000000', 'consum', 0.0221, 'lps'),
	(545403, 130, '2014-02-15 00:11:30.000000', 'consum', 0.0213, 'lps'),
	(545404, 130, '2014-02-15 00:11:31.000000', 'consum', 0.0210, 'lps'),
	(545405, 130, '2014-02-15 00:11:32.000000', 'consum', 0.0215, 'lps'),
	(545406, 130, '2014-02-15 00:11:33.000000', 'consum', 0.0222, 'lps'),
	(545407, 130, '2014-02-15 00:11:34.000000', 'consum', 0.0220, 'lps'),
	(545408, 130, '2014-02-15 00:11:35.000000', 'consum', 0.0224, 'lps'),
	(545409, 130, '2014-02-15 00:11:36.000000', 'consum', 0.0219, 'lps'),
	(545410, 130, '2014-02-15 00:11:37.000000', 'consum', 0.0211, 'lps'),
	(545411, 130, '2014-02-15 00:11:38.000000', 'consum', 0.0222, 'lps'),
	(545412, 130, '2014-02-15 00:11:39.000000', 'consum', 0.0217, 'lps'),
	(545413, 130, '2014-02-15 00:11:40.000000', 'consum', 0.0210, 'lps'),
	(545414, 130, '2014-02-15 00:11:41.000000', 'consum', 0.0222, 'lps'),
	(545415, 130, '2014-02-15 00:11:42.000000', 'consum', 0.0220, 'lps'),
	(545416, 130, '2014-02-15 00:11:43.000000', 'consum', 0.0225, 'lps'),
	(545417, 130, '2014-02-15 00:11:44.000000', 'consum', 0.0222, 'lps'),
	(545418, 130, '2014-02-15 00:11:45.000000', 'consum', 0.0226, 'lps'),
	(545419, 130, '2014-02-15 00:11:46.000000', 'consum', 0.0220, 'lps'),
	(545420, 130, '2014-02-15 00:11:47.000000', 'consum', 0.0213, 'lps'),
	(545421, 130, '2014-02-15 00:11:48.000000', 'consum', 0.0214, 'lps'),
	(545422, 130, '2014-02-15 00:11:49.000000', 'consum', 0.0220, 'lps'),
	(545423, 130, '2014-02-15 00:11:50.000000', 'consum', 0.0214, 'lps'),
	(545424, 130, '2014-02-15 00:11:51.000000', 'consum', 0.0219, 'lps'),
	(545425, 130, '2014-02-15 00:11:52.000000', 'consum', 0.0225, 'lps'),
	(545426, 130, '2014-02-15 00:11:53.000000', 'consum', 0.0224, 'lps'),
	(545427, 130, '2014-02-15 00:11:54.000000', 'consum', 0.0220, 'lps'),
	(545428, 130, '2014-02-15 00:11:55.000000', 'consum', 0.0216, 'lps'),
	(545429, 130, '2014-02-15 00:11:56.000000', 'consum', 0.0211, 'lps'),
	(545430, 130, '2014-02-15 00:11:57.000000', 'consum', 0.0217, 'lps'),
	(545431, 130, '2014-02-15 00:11:58.000000', 'consum', 0.0223, 'lps'),
	(545432, 130, '2014-02-15 00:11:59.000000', 'consum', 0.0220, 'lps'),
	(545433, 130, '2014-02-15 00:12:00.000000', 'consum', 0.0222, 'lps'),
	(545434, 130, '2014-02-15 00:12:01.000000', 'consum', 0.0222, 'lps'),
	(545435, 130, '2014-02-15 00:12:02.000000', 'consum', 0.0219, 'lps'),
	(545436, 130, '2014-02-15 00:12:03.000000', 'consum', 0.0221, 'lps'),
	(545437, 130, '2014-02-15 00:12:04.000000', 'consum', 0.0221, 'lps'),
	(545438, 130, '2014-02-15 00:12:05.000000', 'consum', 0.0213, 'lps'),
	(545439, 130, '2014-02-15 00:12:06.000000', 'consum', 0.0211, 'lps'),
	(545440, 130, '2014-02-15 00:12:07.000000', 'consum', 0.0224, 'lps'),
	(545441, 130, '2014-02-15 00:12:08.000000', 'consum', 0.0210, 'lps'),
	(545442, 130, '2014-02-15 00:12:09.000000', 'consum', 0.0220, 'lps'),
	(545443, 130, '2014-02-15 00:12:10.000000', 'consum', 0.0225, 'lps'),
	(545444, 130, '2014-02-15 00:12:11.000000', 'consum', 0.0224, 'lps'),
	(545445, 130, '2014-02-15 00:12:12.000000', 'consum', 0.0217, 'lps'),
	(545446, 130, '2014-02-15 00:12:13.000000', 'consum', 0.0221, 'lps'),
	(545447, 130, '2014-02-15 00:12:14.000000', 'consum', 0.0210, 'lps'),
	(545448, 130, '2014-02-15 00:12:15.000000', 'consum', 0.0213, 'lps'),
	(545449, 130, '2014-02-15 00:12:16.000000', 'consum', 0.0224, 'lps'),
	(545450, 130, '2014-02-15 00:12:17.000000', 'consum', 0.0219, 'lps'),
	(545451, 130, '2014-02-15 00:12:18.000000', 'consum', 0.0216, 'lps'),
	(545452, 130, '2014-02-15 00:12:19.000000', 'consum', 0.0214, 'lps'),
	(545453, 130, '2014-02-15 00:12:20.000000', 'consum', 0.0214, 'lps'),
	(545454, 130, '2014-02-15 00:12:21.000000', 'consum', 0.0215, 'lps'),
	(545455, 130, '2014-02-15 00:12:22.000000', 'consum', 0.0225, 'lps'),
	(545456, 130, '2014-02-15 00:12:23.000000', 'consum', 0.0220, 'lps'),
	(545457, 130, '2014-02-15 00:12:24.000000', 'consum', 0.0213, 'lps'),
	(545458, 130, '2014-02-15 00:12:25.000000', 'consum', 0.0215, 'lps'),
	(545459, 130, '2014-02-15 00:12:26.000000', 'consum', 0.0226, 'lps'),
	(545460, 130, '2014-02-15 00:12:27.000000', 'consum', 0.0226, 'lps'),
	(545461, 130, '2014-02-15 00:12:28.000000', 'consum', 0.0223, 'lps'),
	(545462, 130, '2014-02-15 00:12:29.000000', 'consum', 0.0210, 'lps'),
	(545463, 130, '2014-02-15 00:12:30.000000', 'consum', 0.0222, 'lps'),
	(545464, 130, '2014-02-15 00:12:31.000000', 'consum', 0.0221, 'lps'),
	(545465, 130, '2014-02-15 00:12:32.000000', 'consum', 0.0213, 'lps'),
	(545466, 130, '2014-02-15 00:12:33.000000', 'consum', 0.0224, 'lps'),
	(545467, 130, '2014-02-15 00:12:34.000000', 'consum', 0.0221, 'lps'),
	(545468, 130, '2014-02-15 00:12:35.000000', 'consum', 0.0226, 'lps'),
	(545469, 130, '2014-02-15 00:12:36.000000', 'consum', 0.0223, 'lps'),
	(545470, 130, '2014-02-15 00:12:37.000000', 'consum', 0.0226, 'lps'),
	(545471, 130, '2014-02-15 00:12:38.000000', 'consum', 0.0216, 'lps'),
	(545472, 130, '2014-02-15 00:12:39.000000', 'consum', 0.0212, 'lps'),
	(545473, 130, '2014-02-15 00:12:40.000000', 'consum', 0.0221, 'lps'),
	(545474, 130, '2014-02-15 00:12:41.000000', 'consum', 0.0224, 'lps'),
	(545475, 130, '2014-02-15 00:12:42.000000', 'consum', 0.0212, 'lps'),
	(545476, 130, '2014-02-15 00:12:43.000000', 'consum', 0.0215, 'lps'),
	(545477, 130, '2014-02-15 00:12:44.000000', 'consum', 0.0210, 'lps'),
	(545478, 130, '2014-02-15 00:12:45.000000', 'consum', 0.0213, 'lps'),
	(545479, 130, '2014-02-15 00:12:46.000000', 'consum', 0.0226, 'lps'),
	(545480, 130, '2014-02-15 00:12:47.000000', 'consum', 0.0212, 'lps'),
	(545481, 130, '2014-02-15 00:12:48.000000', 'consum', 0.0223, 'lps'),
	(545482, 130, '2014-02-15 00:12:49.000000', 'consum', 0.0222, 'lps'),
	(545483, 130, '2014-02-15 00:12:50.000000', 'consum', 0.0211, 'lps'),
	(545484, 130, '2014-02-15 00:12:51.000000', 'consum', 0.0215, 'lps'),
	(545485, 130, '2014-02-15 00:12:52.000000', 'consum', 0.0216, 'lps'),
	(545486, 130, '2014-02-15 00:12:53.000000', 'consum', 0.0225, 'lps'),
	(545487, 130, '2014-02-15 00:12:54.000000', 'consum', 0.0215, 'lps'),
	(545488, 130, '2014-02-15 00:12:55.000000', 'consum', 0.0210, 'lps'),
	(545489, 130, '2014-02-15 00:12:56.000000', 'consum', 0.0213, 'lps'),
	(545490, 130, '2014-02-15 00:12:57.000000', 'consum', 0.0223, 'lps'),
	(545491, 130, '2014-02-15 00:12:58.000000', 'consum', 0.0216, 'lps'),
	(545492, 130, '2014-02-15 00:12:59.000000', 'consum', 0.0219, 'lps'),
	(545493, 130, '2014-02-15 00:13:00.000000', 'consum', 0.0221, 'lps'),
	(545494, 130, '2014-02-15 00:13:01.000000', 'consum', 0.0222, 'lps'),
	(545495, 130, '2014-02-15 00:13:02.000000', 'consum', 0.0222, 'lps'),
	(545496, 130, '2014-02-15 00:13:03.000000', 'consum', 0.0215, 'lps'),
	(545497, 130, '2014-02-15 00:13:04.000000', 'consum', 0.0216, 'lps'),
	(545498, 130, '2014-02-15 00:13:05.000000', 'consum', 0.0210, 'lps'),
	(545499, 130, '2014-02-15 00:13:06.000000', 'consum', 0.0225, 'lps'),
	(545500, 130, '2014-02-15 00:13:07.000000', 'consum', 0.0219, 'lps'),
	(545501, 130, '2014-02-15 00:13:08.000000', 'consum', 0.0225, 'lps'),
	(545502, 130, '2014-02-15 00:13:09.000000', 'consum', 0.0226, 'lps'),
	(545503, 130, '2014-02-15 00:13:10.000000', 'consum', 0.0212, 'lps'),
	(545504, 130, '2014-02-15 00:13:11.000000', 'consum', 0.0225, 'lps'),
	(545505, 130, '2014-02-15 00:13:12.000000', 'consum', 0.0211, 'lps'),
	(545506, 130, '2014-02-15 00:13:13.000000', 'consum', 0.0220, 'lps'),
	(545507, 130, '2014-02-15 00:13:14.000000', 'consum', 0.0224, 'lps'),
	(545508, 130, '2014-02-15 00:13:15.000000', 'consum', 0.0217, 'lps'),
	(545509, 130, '2014-02-15 00:13:16.000000', 'consum', 0.0222, 'lps'),
	(545510, 130, '2014-02-15 00:13:17.000000', 'consum', 0.0215, 'lps'),
	(545511, 130, '2014-02-15 00:13:18.000000', 'consum', 0.0217, 'lps'),
	(545512, 130, '2014-02-15 00:13:19.000000', 'consum', 0.0212, 'lps'),
	(545513, 130, '2014-02-15 00:13:20.000000', 'consum', 0.0218, 'lps'),
	(545514, 130, '2014-02-15 00:13:21.000000', 'consum', 0.0225, 'lps'),
	(545515, 130, '2014-02-15 00:13:22.000000', 'consum', 0.0212, 'lps'),
	(545516, 130, '2014-02-15 00:13:23.000000', 'consum', 0.0210, 'lps'),
	(545517, 130, '2014-02-15 00:13:24.000000', 'consum', 0.0222, 'lps'),
	(545518, 130, '2014-02-15 00:13:25.000000', 'consum', 0.0221, 'lps'),
	(545519, 130, '2014-02-15 00:13:26.000000', 'consum', 0.0210, 'lps'),
	(545520, 130, '2014-02-15 00:13:27.000000', 'consum', 0.0213, 'lps'),
	(545521, 130, '2014-02-15 00:13:28.000000', 'consum', 0.0210, 'lps'),
	(545522, 130, '2014-02-15 00:13:29.000000', 'consum', 0.0215, 'lps'),
	(545523, 130, '2014-02-15 00:13:30.000000', 'consum', 0.0222, 'lps'),
	(545524, 130, '2014-02-15 00:13:31.000000', 'consum', 0.0219, 'lps'),
	(545525, 130, '2014-02-15 00:13:32.000000', 'consum', 0.0221, 'lps'),
	(545526, 130, '2014-02-15 00:13:33.000000', 'consum', 0.0219, 'lps'),
	(545527, 130, '2014-02-15 00:13:34.000000', 'consum', 0.0224, 'lps'),
	(545528, 130, '2014-02-15 00:13:35.000000', 'consum', 0.0218, 'lps'),
	(545529, 130, '2014-02-15 00:13:36.000000', 'consum', 0.0225, 'lps'),
	(545530, 130, '2014-02-15 00:13:37.000000', 'consum', 0.0212, 'lps'),
	(545531, 130, '2014-02-15 00:13:38.000000', 'consum', 0.0225, 'lps'),
	(545532, 130, '2014-02-15 00:13:39.000000', 'consum', 0.0214, 'lps'),
	(545533, 130, '2014-02-15 00:13:40.000000', 'consum', 0.0219, 'lps'),
	(545534, 130, '2014-02-15 00:13:41.000000', 'consum', 0.0226, 'lps'),
	(545535, 130, '2014-02-15 00:13:42.000000', 'consum', 0.0212, 'lps'),
	(545536, 130, '2014-02-15 00:13:43.000000', 'consum', 0.0223, 'lps'),
	(545537, 130, '2014-02-15 00:13:44.000000', 'consum', 0.0219, 'lps'),
	(545538, 130, '2014-02-15 00:13:45.000000', 'consum', 0.0216, 'lps'),
	(545539, 130, '2014-02-15 00:13:46.000000', 'consum', 0.0216, 'lps'),
	(545540, 130, '2014-02-15 00:13:47.000000', 'consum', 0.0221, 'lps'),
	(545541, 130, '2014-02-15 00:13:48.000000', 'consum', 0.0214, 'lps'),
	(545542, 130, '2014-02-15 00:13:49.000000', 'consum', 0.0216, 'lps'),
	(545543, 130, '2014-02-15 00:13:50.000000', 'consum', 0.0225, 'lps'),
	(545544, 130, '2014-02-15 00:13:51.000000', 'consum', 0.0219, 'lps'),
	(545545, 130, '2014-02-15 00:13:52.000000', 'consum', 0.0210, 'lps'),
	(545546, 130, '2014-02-15 00:13:53.000000', 'consum', 0.0218, 'lps'),
	(545547, 130, '2014-02-15 00:13:54.000000', 'consum', 0.0216, 'lps'),
	(545548, 130, '2014-02-15 00:13:55.000000', 'consum', 0.0219, 'lps'),
	(545549, 130, '2014-02-15 00:13:56.000000', 'consum', 0.0217, 'lps'),
	(545550, 130, '2014-02-15 00:13:57.000000', 'consum', 0.0220, 'lps'),
	(545551, 130, '2014-02-15 00:13:58.000000', 'consum', 0.0220, 'lps'),
	(545552, 130, '2014-02-15 00:13:59.000000', 'consum', 0.0216, 'lps'),
	(545553, 130, '2014-02-15 00:14:00.000000', 'consum', 0.0211, 'lps'),
	(545554, 130, '2014-02-15 00:14:01.000000', 'consum', 0.0215, 'lps'),
	(545555, 130, '2014-02-15 00:14:02.000000', 'consum', 0.0214, 'lps'),
	(545556, 130, '2014-02-15 00:14:03.000000', 'consum', 0.0216, 'lps'),
	(545557, 130, '2014-02-15 00:14:04.000000', 'consum', 0.0212, 'lps'),
	(545558, 130, '2014-02-15 00:14:05.000000', 'consum', 0.0217, 'lps'),
	(545559, 130, '2014-02-15 00:14:06.000000', 'consum', 0.0226, 'lps'),
	(545560, 130, '2014-02-15 00:14:07.000000', 'consum', 0.0216, 'lps'),
	(545561, 130, '2014-02-15 00:14:08.000000', 'consum', 0.0226, 'lps'),
	(545562, 130, '2014-02-15 00:14:09.000000', 'consum', 0.0221, 'lps'),
	(545563, 130, '2014-02-15 00:14:10.000000', 'consum', 0.0217, 'lps'),
	(545564, 130, '2014-02-15 00:14:11.000000', 'consum', 0.0212, 'lps'),
	(545565, 130, '2014-02-15 00:14:12.000000', 'consum', 0.0219, 'lps'),
	(545566, 130, '2014-02-15 00:14:13.000000', 'consum', 0.0214, 'lps'),
	(545567, 130, '2014-02-15 00:14:14.000000', 'consum', 0.0220, 'lps'),
	(545568, 130, '2014-02-15 00:14:15.000000', 'consum', 0.0214, 'lps'),
	(545569, 130, '2014-02-15 00:14:16.000000', 'consum', 0.0218, 'lps'),
	(545570, 130, '2014-02-15 00:14:17.000000', 'consum', 0.0220, 'lps'),
	(545571, 130, '2014-02-15 00:14:18.000000', 'consum', 0.0222, 'lps'),
	(545572, 130, '2014-02-15 00:14:19.000000', 'consum', 0.0221, 'lps'),
	(545573, 130, '2014-02-15 00:14:20.000000', 'consum', 0.0213, 'lps'),
	(545574, 130, '2014-02-15 00:14:21.000000', 'consum', 0.0211, 'lps'),
	(545575, 130, '2014-02-15 00:14:22.000000', 'consum', 0.0225, 'lps'),
	(545576, 130, '2014-02-15 00:14:23.000000', 'consum', 0.0211, 'lps'),
	(545577, 130, '2014-02-15 00:14:24.000000', 'consum', 0.0223, 'lps'),
	(545578, 130, '2014-02-15 00:14:25.000000', 'consum', 0.0223, 'lps'),
	(545579, 130, '2014-02-15 00:14:26.000000', 'consum', 0.0217, 'lps'),
	(545580, 130, '2014-02-15 00:14:27.000000', 'consum', 0.0226, 'lps'),
	(545581, 130, '2014-02-15 00:14:28.000000', 'consum', 0.0216, 'lps'),
	(545582, 130, '2014-02-15 00:14:29.000000', 'consum', 0.0211, 'lps'),
	(545583, 130, '2014-02-15 00:14:30.000000', 'consum', 0.0215, 'lps'),
	(545584, 130, '2014-02-15 00:14:31.000000', 'consum', 0.0216, 'lps'),
	(545585, 130, '2014-02-15 00:14:32.000000', 'consum', 0.0225, 'lps'),
	(545586, 130, '2014-02-15 00:14:33.000000', 'consum', 0.0216, 'lps'),
	(545587, 130, '2014-02-15 00:14:34.000000', 'consum', 0.0213, 'lps'),
	(545588, 130, '2014-02-15 00:14:35.000000', 'consum', 0.0226, 'lps'),
	(545589, 130, '2014-02-15 00:14:36.000000', 'consum', 0.0211, 'lps'),
	(545590, 130, '2014-02-15 00:14:37.000000', 'consum', 0.0217, 'lps'),
	(545591, 130, '2014-02-15 00:14:38.000000', 'consum', 0.0212, 'lps'),
	(545592, 130, '2014-02-15 00:14:39.000000', 'consum', 0.0216, 'lps'),
	(545593, 130, '2014-02-15 00:14:40.000000', 'consum', 0.0215, 'lps'),
	(545594, 130, '2014-02-15 00:14:41.000000', 'consum', 0.0218, 'lps'),
	(545595, 130, '2014-02-15 00:14:42.000000', 'consum', 0.0221, 'lps'),
	(545596, 130, '2014-02-15 00:14:43.000000', 'consum', 0.0222, 'lps'),
	(545597, 130, '2014-02-15 00:14:44.000000', 'consum', 0.0221, 'lps'),
	(545598, 130, '2014-02-15 00:14:45.000000', 'consum', 0.0212, 'lps'),
	(545599, 130, '2014-02-15 00:14:46.000000', 'consum', 0.0223, 'lps'),
	(545600, 130, '2014-02-15 00:14:47.000000', 'consum', 0.0218, 'lps'),
	(545601, 130, '2014-02-15 00:14:48.000000', 'consum', 0.0210, 'lps'),
	(545602, 130, '2014-02-15 00:14:49.000000', 'consum', 0.0221, 'lps'),
	(545603, 130, '2014-02-15 00:14:50.000000', 'consum', 0.0213, 'lps'),
	(545604, 130, '2014-02-15 00:14:51.000000', 'consum', 0.0210, 'lps'),
	(545605, 130, '2014-02-15 00:14:52.000000', 'consum', 0.0218, 'lps'),
	(545606, 130, '2014-02-15 00:14:53.000000', 'consum', 0.0217, 'lps'),
	(545607, 130, '2014-02-15 00:14:54.000000', 'consum', 0.0220, 'lps'),
	(545608, 130, '2014-02-15 00:14:55.000000', 'consum', 0.0224, 'lps'),
	(545609, 130, '2014-02-15 00:14:56.000000', 'consum', 0.0216, 'lps'),
	(545610, 130, '2014-02-15 00:14:57.000000', 'consum', 0.0216, 'lps'),
	(545611, 130, '2014-02-15 00:14:58.000000', 'consum', 0.0223, 'lps'),
	(545612, 130, '2014-02-15 00:14:59.000000', 'consum', 0.0222, 'lps'),
	(545613, 130, '2014-02-15 00:15:00.000000', 'consum', 0.0214, 'lps'),
	(545614, 130, '2014-02-15 00:15:01.000000', 'consum', 0.0214, 'lps'),
	(545615, 130, '2014-02-15 00:15:02.000000', 'consum', 0.0216, 'lps'),
	(545616, 130, '2014-02-15 00:15:03.000000', 'consum', 0.0211, 'lps'),
	(545617, 130, '2014-02-15 00:15:04.000000', 'consum', 0.0216, 'lps'),
	(545618, 130, '2014-02-15 00:15:05.000000', 'consum', 0.0219, 'lps'),
	(545619, 130, '2014-02-15 00:15:06.000000', 'consum', 0.0223, 'lps'),
	(545620, 130, '2014-02-15 00:15:07.000000', 'consum', 0.0212, 'lps'),
	(545621, 130, '2014-02-15 00:15:08.000000', 'consum', 0.0218, 'lps'),
	(545622, 130, '2014-02-15 00:15:09.000000', 'consum', 0.0225, 'lps'),
	(545623, 130, '2014-02-15 00:15:10.000000', 'consum', 0.0226, 'lps'),
	(545624, 130, '2014-02-15 00:15:11.000000', 'consum', 0.0215, 'lps'),
	(545625, 130, '2014-02-15 00:15:12.000000', 'consum', 0.0219, 'lps'),
	(545626, 130, '2014-02-15 00:15:13.000000', 'consum', 0.0226, 'lps'),
	(545627, 130, '2014-02-15 00:15:14.000000', 'consum', 0.0213, 'lps'),
	(545628, 130, '2014-02-15 00:15:15.000000', 'consum', 0.0226, 'lps'),
	(545629, 130, '2014-02-15 00:15:16.000000', 'consum', 0.0213, 'lps'),
	(545630, 130, '2014-02-15 00:15:17.000000', 'consum', 0.0214, 'lps'),
	(545631, 130, '2014-02-15 00:15:18.000000', 'consum', 0.0222, 'lps'),
	(545632, 130, '2014-02-15 00:15:19.000000', 'consum', 0.0222, 'lps'),
	(545633, 130, '2014-02-15 00:15:20.000000', 'consum', 0.0217, 'lps'),
	(545634, 130, '2014-02-15 00:15:21.000000', 'consum', 0.0211, 'lps'),
	(545635, 130, '2014-02-15 00:15:22.000000', 'consum', 0.0213, 'lps'),
	(545636, 130, '2014-02-15 00:15:23.000000', 'consum', 0.0221, 'lps'),
	(545637, 130, '2014-02-15 00:15:24.000000', 'consum', 0.0223, 'lps'),
	(545638, 130, '2014-02-15 00:15:25.000000', 'consum', 0.0224, 'lps'),
	(545639, 130, '2014-02-15 00:15:26.000000', 'consum', 0.0226, 'lps'),
	(545640, 130, '2014-02-15 00:15:27.000000', 'consum', 0.0215, 'lps'),
	(545641, 130, '2014-02-15 00:15:28.000000', 'consum', 0.0221, 'lps'),
	(545642, 130, '2014-02-15 00:15:29.000000', 'consum', 0.0215, 'lps'),
	(545643, 130, '2014-02-15 00:15:30.000000', 'consum', 0.0221, 'lps'),
	(545644, 130, '2014-02-15 00:15:31.000000', 'consum', 0.0217, 'lps'),
	(545645, 130, '2014-02-15 00:15:32.000000', 'consum', 0.0211, 'lps'),
	(545646, 130, '2014-02-15 00:15:33.000000', 'consum', 0.0212, 'lps'),
	(545647, 130, '2014-02-15 00:15:34.000000', 'consum', 0.0216, 'lps'),
	(545648, 130, '2014-02-15 00:15:35.000000', 'consum', 0.0220, 'lps'),
	(545649, 130, '2014-02-15 00:15:36.000000', 'consum', 0.0223, 'lps'),
	(545650, 130, '2014-02-15 00:15:37.000000', 'consum', 0.0213, 'lps'),
	(545651, 130, '2014-02-15 00:15:38.000000', 'consum', 0.0219, 'lps'),
	(545652, 130, '2014-02-15 00:15:39.000000', 'consum', 0.0215, 'lps'),
	(545653, 130, '2014-02-15 00:15:40.000000', 'consum', 0.0223, 'lps'),
	(545654, 130, '2014-02-15 00:15:41.000000', 'consum', 0.0210, 'lps'),
	(545655, 130, '2014-02-15 00:15:42.000000', 'consum', 0.0225, 'lps'),
	(545656, 130, '2014-02-15 00:15:43.000000', 'consum', 0.0215, 'lps'),
	(545657, 130, '2014-02-15 00:15:44.000000', 'consum', 0.0225, 'lps'),
	(545658, 130, '2014-02-15 00:15:45.000000', 'consum', 0.0221, 'lps'),
	(545659, 130, '2014-02-15 00:15:46.000000', 'consum', 0.0219, 'lps'),
	(545660, 130, '2014-02-15 00:15:47.000000', 'consum', 0.0222, 'lps'),
	(545661, 130, '2014-02-15 00:15:48.000000', 'consum', 0.0210, 'lps'),
	(545662, 130, '2014-02-15 00:15:49.000000', 'consum', 0.0225, 'lps'),
	(545663, 130, '2014-02-15 00:15:50.000000', 'consum', 0.0217, 'lps'),
	(545664, 130, '2014-02-15 00:15:51.000000', 'consum', 0.0220, 'lps'),
	(545665, 130, '2014-02-15 00:15:52.000000', 'consum', 0.0221, 'lps'),
	(545666, 130, '2014-02-15 00:15:53.000000', 'consum', 0.0218, 'lps'),
	(545667, 130, '2014-02-15 00:15:54.000000', 'consum', 0.0218, 'lps'),
	(545668, 130, '2014-02-15 00:15:55.000000', 'consum', 0.0224, 'lps'),
	(545669, 130, '2014-02-15 00:15:56.000000', 'consum', 0.0226, 'lps'),
	(545670, 130, '2014-02-15 00:15:57.000000', 'consum', 0.0213, 'lps'),
	(545671, 130, '2014-02-15 00:15:58.000000', 'consum', 0.0211, 'lps'),
	(545672, 130, '2014-02-15 00:15:59.000000', 'consum', 0.0222, 'lps'),
	(545673, 130, '2014-02-15 00:16:00.000000', 'consum', 0.0219, 'lps'),
	(545674, 130, '2014-02-15 00:16:01.000000', 'consum', 0.0218, 'lps'),
	(545675, 130, '2014-02-15 00:16:02.000000', 'consum', 0.0222, 'lps'),
	(545676, 130, '2014-02-15 00:16:03.000000', 'consum', 0.0216, 'lps'),
	(545677, 130, '2014-02-15 00:16:04.000000', 'consum', 0.0218, 'lps'),
	(545678, 130, '2014-02-15 00:16:05.000000', 'consum', 0.0218, 'lps'),
	(545679, 130, '2014-02-15 00:16:06.000000', 'consum', 0.0225, 'lps'),
	(545680, 130, '2014-02-15 00:16:07.000000', 'consum', 0.0226, 'lps'),
	(545681, 130, '2014-02-15 00:16:08.000000', 'consum', 0.0214, 'lps'),
	(545682, 130, '2014-02-15 00:16:09.000000', 'consum', 0.0217, 'lps'),
	(545683, 130, '2014-02-15 00:16:10.000000', 'consum', 0.0216, 'lps'),
	(545684, 130, '2014-02-15 00:16:11.000000', 'consum', 0.0220, 'lps'),
	(545685, 130, '2014-02-15 00:16:12.000000', 'consum', 0.0224, 'lps'),
	(545686, 130, '2014-02-15 00:16:13.000000', 'consum', 0.0218, 'lps'),
	(545687, 130, '2014-02-15 00:16:14.000000', 'consum', 0.0225, 'lps'),
	(545688, 130, '2014-02-15 00:16:15.000000', 'consum', 0.0210, 'lps'),
	(545689, 130, '2014-02-15 00:16:16.000000', 'consum', 0.0215, 'lps'),
	(545690, 130, '2014-02-15 00:16:17.000000', 'consum', 0.0219, 'lps'),
	(545691, 130, '2014-02-15 00:16:18.000000', 'consum', 0.0224, 'lps'),
	(545692, 130, '2014-02-15 00:16:19.000000', 'consum', 0.0220, 'lps'),
	(545693, 130, '2014-02-15 00:16:20.000000', 'consum', 0.0218, 'lps'),
	(545694, 130, '2014-02-15 00:16:21.000000', 'consum', 0.0219, 'lps'),
	(545695, 130, '2014-02-15 00:16:22.000000', 'consum', 0.0215, 'lps'),
	(545696, 130, '2014-02-15 00:16:23.000000', 'consum', 0.0226, 'lps'),
	(545697, 130, '2014-02-15 00:16:24.000000', 'consum', 0.0223, 'lps'),
	(545698, 130, '2014-02-15 00:16:25.000000', 'consum', 0.0210, 'lps'),
	(545699, 130, '2014-02-15 00:16:26.000000', 'consum', 0.0222, 'lps'),
	(545700, 130, '2014-02-15 00:16:27.000000', 'consum', 0.0219, 'lps'),
	(545701, 130, '2014-02-15 00:16:28.000000', 'consum', 0.0223, 'lps'),
	(545702, 130, '2014-02-15 00:16:29.000000', 'consum', 0.0212, 'lps'),
	(545703, 130, '2014-02-15 00:16:30.000000', 'consum', 0.0214, 'lps'),
	(545704, 130, '2014-02-15 00:16:31.000000', 'consum', 0.0226, 'lps'),
	(545705, 130, '2014-02-15 00:16:32.000000', 'consum', 0.0212, 'lps'),
	(545706, 130, '2014-02-15 00:16:33.000000', 'consum', 0.0224, 'lps'),
	(545707, 130, '2014-02-15 00:16:34.000000', 'consum', 0.0224, 'lps'),
	(545708, 130, '2014-02-15 00:16:35.000000', 'consum', 0.0221, 'lps'),
	(545709, 130, '2014-02-15 00:16:36.000000', 'consum', 0.0224, 'lps'),
	(545710, 130, '2014-02-15 00:16:37.000000', 'consum', 0.0212, 'lps'),
	(545711, 130, '2014-02-15 00:16:38.000000', 'consum', 0.0212, 'lps'),
	(545712, 130, '2014-02-15 00:16:39.000000', 'consum', 0.0217, 'lps'),
	(545713, 130, '2014-02-15 00:16:40.000000', 'consum', 0.0222, 'lps'),
	(545714, 130, '2014-02-15 00:16:41.000000', 'consum', 0.0214, 'lps'),
	(545715, 130, '2014-02-15 00:16:42.000000', 'consum', 0.0210, 'lps'),
	(545716, 130, '2014-02-15 00:16:43.000000', 'consum', 0.0219, 'lps'),
	(545717, 130, '2014-02-15 00:16:44.000000', 'consum', 0.0220, 'lps'),
	(545718, 130, '2014-02-15 00:16:45.000000', 'consum', 0.0215, 'lps'),
	(545719, 130, '2014-02-15 00:16:46.000000', 'consum', 0.0224, 'lps'),
	(545720, 130, '2014-02-15 00:16:47.000000', 'consum', 0.0215, 'lps'),
	(545721, 130, '2014-02-15 00:16:48.000000', 'consum', 0.0212, 'lps'),
	(545722, 130, '2014-02-15 00:16:49.000000', 'consum', 0.0221, 'lps'),
	(545723, 130, '2014-02-15 00:16:50.000000', 'consum', 0.0210, 'lps'),
	(545724, 130, '2014-02-15 00:16:51.000000', 'consum', 0.0212, 'lps'),
	(545725, 130, '2014-02-15 00:16:52.000000', 'consum', 0.0220, 'lps'),
	(545726, 130, '2014-02-15 00:16:53.000000', 'consum', 0.0221, 'lps'),
	(545727, 130, '2014-02-15 00:16:54.000000', 'consum', 0.0219, 'lps'),
	(545728, 130, '2014-02-15 00:16:55.000000', 'consum', 0.0222, 'lps'),
	(545729, 130, '2014-02-15 00:16:56.000000', 'consum', 0.0211, 'lps'),
	(545730, 130, '2014-02-15 00:16:57.000000', 'consum', 0.0213, 'lps'),
	(545731, 130, '2014-02-15 00:16:58.000000', 'consum', 0.0224, 'lps'),
	(545732, 130, '2014-02-15 00:16:59.000000', 'consum', 0.0217, 'lps'),
	(545733, 130, '2014-02-15 00:17:00.000000', 'consum', 0.0223, 'lps'),
	(545734, 130, '2014-02-15 00:17:01.000000', 'consum', 0.0221, 'lps'),
	(545735, 130, '2014-02-15 00:17:02.000000', 'consum', 0.0224, 'lps'),
	(545736, 130, '2014-02-15 00:17:03.000000', 'consum', 0.0214, 'lps'),
	(545737, 130, '2014-02-15 00:17:04.000000', 'consum', 0.0222, 'lps'),
	(545738, 130, '2014-02-15 00:17:05.000000', 'consum', 0.0225, 'lps'),
	(545739, 130, '2014-02-15 00:17:06.000000', 'consum', 0.0216, 'lps'),
	(545740, 130, '2014-02-15 00:17:07.000000', 'consum', 0.0212, 'lps'),
	(545741, 130, '2014-02-15 00:17:08.000000', 'consum', 0.0221, 'lps'),
	(545742, 130, '2014-02-15 00:17:09.000000', 'consum', 0.0225, 'lps'),
	(545743, 130, '2014-02-15 00:17:10.000000', 'consum', 0.0220, 'lps'),
	(545744, 130, '2014-02-15 00:17:11.000000', 'consum', 0.0215, 'lps'),
	(545745, 130, '2014-02-15 00:17:12.000000', 'consum', 0.0220, 'lps'),
	(545746, 130, '2014-02-15 00:17:13.000000', 'consum', 0.0214, 'lps'),
	(545747, 130, '2014-02-15 00:17:14.000000', 'consum', 0.0218, 'lps'),
	(545748, 130, '2014-02-15 00:17:15.000000', 'consum', 0.0222, 'lps'),
	(545749, 130, '2014-02-15 00:17:16.000000', 'consum', 0.0211, 'lps'),
	(545750, 130, '2014-02-15 00:17:17.000000', 'consum', 0.0215, 'lps'),
	(545751, 130, '2014-02-15 00:17:18.000000', 'consum', 0.0213, 'lps'),
	(545752, 130, '2014-02-15 00:17:19.000000', 'consum', 0.0214, 'lps'),
	(545753, 130, '2014-02-15 00:17:20.000000', 'consum', 0.0219, 'lps'),
	(545754, 130, '2014-02-15 00:17:21.000000', 'consum', 0.0210, 'lps'),
	(545755, 130, '2014-02-15 00:17:22.000000', 'consum', 0.0217, 'lps'),
	(545756, 130, '2014-02-15 00:17:23.000000', 'consum', 0.0214, 'lps'),
	(545757, 130, '2014-02-15 00:17:24.000000', 'consum', 0.0224, 'lps'),
	(545758, 130, '2014-02-15 00:17:25.000000', 'consum', 0.0219, 'lps'),
	(545759, 130, '2014-02-15 00:17:26.000000', 'consum', 0.0213, 'lps'),
	(545760, 130, '2014-02-15 00:17:27.000000', 'consum', 0.0214, 'lps'),
	(545761, 130, '2014-02-15 00:17:28.000000', 'consum', 0.0222, 'lps'),
	(545762, 130, '2014-02-15 00:17:29.000000', 'consum', 0.0226, 'lps'),
	(545763, 130, '2014-02-15 00:17:30.000000', 'consum', 0.0220, 'lps'),
	(545764, 130, '2014-02-15 00:17:31.000000', 'consum', 0.0214, 'lps'),
	(545765, 130, '2014-02-15 00:17:32.000000', 'consum', 0.0217, 'lps'),
	(545766, 130, '2014-02-15 00:17:33.000000', 'consum', 0.0218, 'lps'),
	(545767, 130, '2014-02-15 00:17:34.000000', 'consum', 0.0211, 'lps'),
	(545768, 130, '2014-02-15 00:17:35.000000', 'consum', 0.0225, 'lps'),
	(545769, 130, '2014-02-15 00:17:36.000000', 'consum', 0.0215, 'lps'),
	(545770, 130, '2014-02-15 00:17:37.000000', 'consum', 0.0223, 'lps'),
	(545771, 130, '2014-02-15 00:17:38.000000', 'consum', 0.0210, 'lps'),
	(545772, 130, '2014-02-15 00:17:39.000000', 'consum', 0.0222, 'lps'),
	(545773, 130, '2014-02-15 00:17:40.000000', 'consum', 0.0222, 'lps'),
	(545774, 130, '2014-02-15 00:17:41.000000', 'consum', 0.0216, 'lps'),
	(545775, 130, '2014-02-15 00:17:42.000000', 'consum', 0.0223, 'lps'),
	(545776, 130, '2014-02-15 00:17:43.000000', 'consum', 0.0223, 'lps'),
	(545777, 130, '2014-02-15 00:17:44.000000', 'consum', 0.0218, 'lps'),
	(545778, 130, '2014-02-15 00:17:45.000000', 'consum', 0.0213, 'lps'),
	(545779, 130, '2014-02-15 00:17:46.000000', 'consum', 0.0218, 'lps'),
	(545780, 130, '2014-02-15 00:17:47.000000', 'consum', 0.0223, 'lps'),
	(545781, 130, '2014-02-15 00:17:48.000000', 'consum', 0.0219, 'lps'),
	(545782, 130, '2014-02-15 00:17:49.000000', 'consum', 0.0217, 'lps'),
	(545783, 130, '2014-02-15 00:17:50.000000', 'consum', 0.0216, 'lps'),
	(545784, 130, '2014-02-15 00:17:51.000000', 'consum', 0.0222, 'lps'),
	(545785, 130, '2014-02-15 00:17:52.000000', 'consum', 0.0218, 'lps'),
	(545786, 130, '2014-02-15 00:17:53.000000', 'consum', 0.0213, 'lps'),
	(545787, 130, '2014-02-15 00:17:54.000000', 'consum', 0.0221, 'lps'),
	(545788, 130, '2014-02-15 00:17:55.000000', 'consum', 0.0224, 'lps'),
	(545789, 130, '2014-02-15 00:17:56.000000', 'consum', 0.0210, 'lps'),
	(545790, 130, '2014-02-15 00:17:57.000000', 'consum', 0.0219, 'lps'),
	(545791, 130, '2014-02-15 00:17:58.000000', 'consum', 0.0223, 'lps'),
	(545792, 130, '2014-02-15 00:17:59.000000', 'consum', 0.0216, 'lps'),
	(545793, 130, '2014-02-15 00:18:00.000000', 'consum', 0.0218, 'lps'),
	(545794, 130, '2014-02-15 00:18:01.000000', 'consum', 0.0214, 'lps'),
	(545795, 130, '2014-02-15 00:18:02.000000', 'consum', 0.0224, 'lps'),
	(545796, 130, '2014-02-15 00:18:03.000000', 'consum', 0.0218, 'lps'),
	(545797, 130, '2014-02-15 00:18:04.000000', 'consum', 0.0225, 'lps'),
	(545798, 130, '2014-02-15 00:18:05.000000', 'consum', 0.0213, 'lps'),
	(545799, 130, '2014-02-15 00:18:06.000000', 'consum', 0.0212, 'lps'),
	(545800, 130, '2014-02-15 00:18:07.000000', 'consum', 0.0212, 'lps'),
	(545801, 130, '2014-02-15 00:18:08.000000', 'consum', 0.0216, 'lps'),
	(545802, 130, '2014-02-15 00:18:09.000000', 'consum', 0.0218, 'lps'),
	(545803, 130, '2014-02-15 00:18:10.000000', 'consum', 0.0214, 'lps'),
	(545804, 130, '2014-02-15 00:18:11.000000', 'consum', 0.0222, 'lps'),
	(545805, 130, '2014-02-15 00:18:12.000000', 'consum', 0.0226, 'lps'),
	(545806, 130, '2014-02-15 00:18:13.000000', 'consum', 0.0222, 'lps'),
	(545807, 130, '2014-02-15 00:18:14.000000', 'consum', 0.0221, 'lps'),
	(545808, 130, '2014-02-15 00:18:15.000000', 'consum', 0.0212, 'lps'),
	(545809, 130, '2014-02-15 00:18:16.000000', 'consum', 0.0221, 'lps'),
	(545810, 130, '2014-02-15 00:18:17.000000', 'consum', 0.0226, 'lps'),
	(545811, 130, '2014-02-15 00:18:18.000000', 'consum', 0.0222, 'lps'),
	(545812, 130, '2014-02-15 00:18:19.000000', 'consum', 0.0222, 'lps'),
	(545813, 130, '2014-02-15 00:18:20.000000', 'consum', 0.0219, 'lps'),
	(545814, 130, '2014-02-15 00:18:21.000000', 'consum', 0.0218, 'lps'),
	(545815, 130, '2014-02-15 00:18:22.000000', 'consum', 0.0226, 'lps'),
	(545816, 130, '2014-02-15 00:18:23.000000', 'consum', 0.0213, 'lps'),
	(545817, 130, '2014-02-15 00:18:24.000000', 'consum', 0.0213, 'lps'),
	(545818, 130, '2014-02-15 00:18:25.000000', 'consum', 0.0217, 'lps'),
	(545819, 130, '2014-02-15 00:18:26.000000', 'consum', 0.0219, 'lps'),
	(545820, 130, '2014-02-15 00:18:27.000000', 'consum', 0.0217, 'lps'),
	(545821, 130, '2014-02-15 00:18:28.000000', 'consum', 0.0218, 'lps'),
	(545822, 130, '2014-02-15 00:18:29.000000', 'consum', 0.0214, 'lps'),
	(545823, 130, '2014-02-15 00:18:30.000000', 'consum', 0.0224, 'lps'),
	(545824, 130, '2014-02-15 00:18:31.000000', 'consum', 0.0216, 'lps'),
	(545825, 130, '2014-02-15 00:18:32.000000', 'consum', 0.0216, 'lps'),
	(545826, 130, '2014-02-15 00:18:33.000000', 'consum', 0.0224, 'lps'),
	(545827, 130, '2014-02-15 00:18:34.000000', 'consum', 0.0226, 'lps'),
	(545828, 130, '2014-02-15 00:18:35.000000', 'consum', 0.0213, 'lps'),
	(545829, 130, '2014-02-15 00:18:36.000000', 'consum', 0.0215, 'lps'),
	(545830, 130, '2014-02-15 00:18:37.000000', 'consum', 0.0226, 'lps'),
	(545831, 130, '2014-02-15 00:18:38.000000', 'consum', 0.0224, 'lps'),
	(545832, 130, '2014-02-15 00:18:39.000000', 'consum', 0.0217, 'lps'),
	(545833, 130, '2014-02-15 00:18:40.000000', 'consum', 0.0221, 'lps'),
	(545834, 130, '2014-02-15 00:18:41.000000', 'consum', 0.0225, 'lps'),
	(545835, 130, '2014-02-15 00:18:42.000000', 'consum', 0.0218, 'lps'),
	(545836, 130, '2014-02-15 00:18:43.000000', 'consum', 0.0222, 'lps'),
	(545837, 130, '2014-02-15 00:18:44.000000', 'consum', 0.0214, 'lps'),
	(545838, 130, '2014-02-15 00:18:45.000000', 'consum', 0.0212, 'lps'),
	(545839, 130, '2014-02-15 00:18:46.000000', 'consum', 0.0225, 'lps'),
	(545840, 130, '2014-02-15 00:18:47.000000', 'consum', 0.0213, 'lps'),
	(545841, 130, '2014-02-15 00:18:48.000000', 'consum', 0.0213, 'lps'),
	(545842, 130, '2014-02-15 00:18:49.000000', 'consum', 0.0217, 'lps'),
	(545843, 130, '2014-02-15 00:18:50.000000', 'consum', 0.0221, 'lps'),
	(545844, 130, '2014-02-15 00:18:51.000000', 'consum', 0.0226, 'lps'),
	(545845, 130, '2014-02-15 00:18:52.000000', 'consum', 0.0224, 'lps'),
	(545846, 130, '2014-02-15 00:18:53.000000', 'consum', 0.0214, 'lps'),
	(545847, 130, '2014-02-15 00:18:54.000000', 'consum', 0.0224, 'lps'),
	(545848, 130, '2014-02-15 00:18:55.000000', 'consum', 0.0217, 'lps'),
	(545849, 130, '2014-02-15 00:18:56.000000', 'consum', 0.0220, 'lps'),
	(545850, 130, '2014-02-15 00:18:57.000000', 'consum', 0.0222, 'lps'),
	(545851, 130, '2014-02-15 00:18:58.000000', 'consum', 0.0225, 'lps'),
	(545852, 130, '2014-02-15 00:18:59.000000', 'consum', 0.0215, 'lps'),
	(545853, 130, '2014-02-15 00:19:00.000000', 'consum', 0.0226, 'lps'),
	(545854, 130, '2014-02-15 00:19:01.000000', 'consum', 0.0223, 'lps'),
	(545855, 130, '2014-02-15 00:19:02.000000', 'consum', 0.0210, 'lps'),
	(545856, 130, '2014-02-15 00:19:03.000000', 'consum', 0.0222, 'lps'),
	(545857, 130, '2014-02-15 00:19:04.000000', 'consum', 0.0219, 'lps'),
	(545858, 130, '2014-02-15 00:19:05.000000', 'consum', 0.0222, 'lps'),
	(545859, 130, '2014-02-15 00:19:06.000000', 'consum', 0.0223, 'lps'),
	(545860, 130, '2014-02-15 00:19:07.000000', 'consum', 0.0225, 'lps'),
	(545861, 130, '2014-02-15 00:19:08.000000', 'consum', 0.0213, 'lps'),
	(545862, 130, '2014-02-15 00:19:09.000000', 'consum', 0.0216, 'lps'),
	(545863, 130, '2014-02-15 00:19:10.000000', 'consum', 0.0212, 'lps'),
	(545864, 130, '2014-02-15 00:19:11.000000', 'consum', 0.0220, 'lps'),
	(545865, 130, '2014-02-15 00:19:12.000000', 'consum', 0.0223, 'lps'),
	(545866, 130, '2014-02-15 00:19:13.000000', 'consum', 0.0225, 'lps'),
	(545867, 130, '2014-02-15 00:19:14.000000', 'consum', 0.0215, 'lps'),
	(545868, 130, '2014-02-15 00:19:15.000000', 'consum', 0.0222, 'lps'),
	(545869, 130, '2014-02-15 00:19:16.000000', 'consum', 0.0221, 'lps'),
	(545870, 130, '2014-02-15 00:19:17.000000', 'consum', 0.0216, 'lps'),
	(545871, 130, '2014-02-15 00:19:18.000000', 'consum', 0.0221, 'lps'),
	(545872, 130, '2014-02-15 00:19:19.000000', 'consum', 0.0215, 'lps'),
	(545873, 130, '2014-02-15 00:19:20.000000', 'consum', 0.0220, 'lps'),
	(545874, 130, '2014-02-15 00:19:21.000000', 'consum', 0.0211, 'lps'),
	(545875, 130, '2014-02-15 00:19:22.000000', 'consum', 0.0221, 'lps'),
	(545876, 130, '2014-02-15 00:19:23.000000', 'consum', 0.0210, 'lps'),
	(545877, 130, '2014-02-15 00:19:24.000000', 'consum', 0.0212, 'lps'),
	(545878, 130, '2014-02-15 00:19:25.000000', 'consum', 0.0221, 'lps'),
	(545879, 130, '2014-02-15 00:19:26.000000', 'consum', 0.0210, 'lps'),
	(545880, 130, '2014-02-15 00:19:27.000000', 'consum', 0.0210, 'lps'),
	(545881, 130, '2014-02-15 00:19:28.000000', 'consum', 0.0211, 'lps'),
	(545882, 130, '2014-02-15 00:19:29.000000', 'consum', 0.0217, 'lps'),
	(545883, 130, '2014-02-15 00:19:30.000000', 'consum', 0.0224, 'lps'),
	(545884, 130, '2014-02-15 00:19:31.000000', 'consum', 0.0210, 'lps'),
	(545885, 130, '2014-02-15 00:19:32.000000', 'consum', 0.0217, 'lps'),
	(545886, 130, '2014-02-15 00:19:33.000000', 'consum', 0.0214, 'lps'),
	(545887, 130, '2014-02-15 00:19:34.000000', 'consum', 0.0224, 'lps'),
	(545888, 130, '2014-02-15 00:19:35.000000', 'consum', 0.0221, 'lps'),
	(545889, 130, '2014-02-15 00:19:36.000000', 'consum', 0.0221, 'lps'),
	(545890, 130, '2014-02-15 00:19:37.000000', 'consum', 0.0214, 'lps'),
	(545891, 130, '2014-02-15 00:19:38.000000', 'consum', 0.0216, 'lps'),
	(545892, 130, '2014-02-15 00:19:39.000000', 'consum', 0.0212, 'lps'),
	(545893, 130, '2014-02-15 00:19:40.000000', 'consum', 0.0221, 'lps'),
	(545894, 130, '2014-02-15 00:19:41.000000', 'consum', 0.0224, 'lps'),
	(545895, 130, '2014-02-15 00:19:42.000000', 'consum', 0.0214, 'lps'),
	(545896, 130, '2014-02-15 00:19:43.000000', 'consum', 0.0221, 'lps'),
	(545897, 130, '2014-02-15 00:19:44.000000', 'consum', 0.0220, 'lps'),
	(545898, 130, '2014-02-15 00:19:45.000000', 'consum', 0.0226, 'lps'),
	(545899, 130, '2014-02-15 00:19:46.000000', 'consum', 0.0226, 'lps'),
	(545900, 130, '2014-02-15 00:19:47.000000', 'consum', 0.0212, 'lps'),
	(545901, 130, '2014-02-15 00:19:48.000000', 'consum', 0.0221, 'lps'),
	(545902, 130, '2014-02-15 00:19:49.000000', 'consum', 0.0225, 'lps'),
	(545903, 130, '2014-02-15 00:19:50.000000', 'consum', 0.0218, 'lps'),
	(545904, 130, '2014-02-15 00:19:51.000000', 'consum', 0.0224, 'lps'),
	(545905, 130, '2014-02-15 00:19:52.000000', 'consum', 0.0224, 'lps'),
	(545906, 130, '2014-02-15 00:19:53.000000', 'consum', 0.0219, 'lps'),
	(545907, 130, '2014-02-15 00:19:54.000000', 'consum', 0.0216, 'lps'),
	(545908, 130, '2014-02-15 00:19:55.000000', 'consum', 0.0210, 'lps'),
	(545909, 130, '2014-02-15 00:19:56.000000', 'consum', 0.0213, 'lps'),
	(545910, 130, '2014-02-15 00:19:57.000000', 'consum', 0.0223, 'lps'),
	(545911, 130, '2014-02-15 00:19:58.000000', 'consum', 0.0217, 'lps'),
	(545912, 130, '2014-02-15 00:19:59.000000', 'consum', 0.0225, 'lps'),
	(545913, 130, '2014-02-15 00:20:00.000000', 'consum', 0.0210, 'lps'),
	(545914, 130, '2014-02-15 00:20:01.000000', 'consum', 0.0219, 'lps'),
	(545915, 130, '2014-02-15 00:20:02.000000', 'consum', 0.0222, 'lps'),
	(545916, 130, '2014-02-15 00:20:03.000000', 'consum', 0.0225, 'lps'),
	(545917, 130, '2014-02-15 00:20:04.000000', 'consum', 0.0218, 'lps'),
	(545918, 130, '2014-02-15 00:20:05.000000', 'consum', 0.0220, 'lps'),
	(545919, 130, '2014-02-15 00:20:06.000000', 'consum', 0.0222, 'lps'),
	(545920, 130, '2014-02-15 00:20:07.000000', 'consum', 0.0220, 'lps'),
	(545921, 130, '2014-02-15 00:20:08.000000', 'consum', 0.0211, 'lps'),
	(545922, 130, '2014-02-15 00:20:09.000000', 'consum', 0.0217, 'lps'),
	(545923, 130, '2014-02-15 00:20:10.000000', 'consum', 0.0224, 'lps'),
	(545924, 130, '2014-02-15 00:20:11.000000', 'consum', 0.0211, 'lps'),
	(545925, 130, '2014-02-15 00:20:12.000000', 'consum', 0.0226, 'lps'),
	(545926, 130, '2014-02-15 00:20:13.000000', 'consum', 0.0217, 'lps'),
	(545927, 130, '2014-02-15 00:20:14.000000', 'consum', 0.0215, 'lps'),
	(545928, 130, '2014-02-15 00:20:15.000000', 'consum', 0.0215, 'lps'),
	(545929, 130, '2014-02-15 00:20:16.000000', 'consum', 0.0220, 'lps'),
	(545930, 130, '2014-02-15 00:20:17.000000', 'consum', 0.0213, 'lps'),
	(545931, 130, '2014-02-15 00:20:18.000000', 'consum', 0.0210, 'lps'),
	(545932, 130, '2014-02-15 00:20:19.000000', 'consum', 0.0218, 'lps'),
	(545933, 130, '2014-02-15 00:20:20.000000', 'consum', 0.0219, 'lps'),
	(545934, 130, '2014-02-15 00:20:21.000000', 'consum', 0.0213, 'lps'),
	(545935, 130, '2014-02-15 00:20:22.000000', 'consum', 0.0215, 'lps'),
	(545936, 130, '2014-02-15 00:20:23.000000', 'consum', 0.0226, 'lps'),
	(545937, 130, '2014-02-15 00:20:24.000000', 'consum', 0.0224, 'lps'),
	(545938, 130, '2014-02-15 00:20:25.000000', 'consum', 0.0218, 'lps'),
	(545939, 130, '2014-02-15 00:20:26.000000', 'consum', 0.0225, 'lps'),
	(545940, 130, '2014-02-15 00:20:27.000000', 'consum', 0.0212, 'lps'),
	(545941, 130, '2014-02-15 00:20:28.000000', 'consum', 0.0225, 'lps'),
	(545942, 130, '2014-02-15 00:20:29.000000', 'consum', 0.0211, 'lps'),
	(545943, 130, '2014-02-15 00:20:30.000000', 'consum', 0.0220, 'lps'),
	(545944, 130, '2014-02-15 00:20:31.000000', 'consum', 0.0225, 'lps'),
	(545945, 130, '2014-02-15 00:20:32.000000', 'consum', 0.0222, 'lps'),
	(545946, 130, '2014-02-15 00:20:33.000000', 'consum', 0.0225, 'lps'),
	(545947, 130, '2014-02-15 00:20:34.000000', 'consum', 0.0214, 'lps'),
	(545948, 130, '2014-02-15 00:20:35.000000', 'consum', 0.0219, 'lps'),
	(545949, 130, '2014-02-15 00:20:36.000000', 'consum', 0.0210, 'lps'),
	(545950, 130, '2014-02-15 00:20:37.000000', 'consum', 0.0220, 'lps'),
	(545951, 130, '2014-02-15 00:20:38.000000', 'consum', 0.0223, 'lps'),
	(545952, 130, '2014-02-15 00:20:39.000000', 'consum', 0.0213, 'lps'),
	(545953, 130, '2014-02-15 00:20:40.000000', 'consum', 0.0220, 'lps'),
	(545954, 130, '2014-02-15 00:20:41.000000', 'consum', 0.0216, 'lps'),
	(545955, 130, '2014-02-15 00:20:42.000000', 'consum', 0.0211, 'lps'),
	(545956, 130, '2014-02-15 00:20:43.000000', 'consum', 0.0216, 'lps'),
	(545957, 130, '2014-02-15 00:20:44.000000', 'consum', 0.0220, 'lps'),
	(545958, 130, '2014-02-15 00:20:45.000000', 'consum', 0.0226, 'lps'),
	(545959, 130, '2014-02-15 00:20:46.000000', 'consum', 0.0211, 'lps'),
	(545960, 130, '2014-02-15 00:20:47.000000', 'consum', 0.0216, 'lps'),
	(545961, 130, '2014-02-15 00:20:48.000000', 'consum', 0.0222, 'lps'),
	(545962, 130, '2014-02-15 00:20:49.000000', 'consum', 0.0216, 'lps'),
	(545963, 130, '2014-02-15 00:20:50.000000', 'consum', 0.0224, 'lps'),
	(545964, 130, '2014-02-15 00:20:51.000000', 'consum', 0.0210, 'lps'),
	(545965, 130, '2014-02-15 00:20:52.000000', 'consum', 0.0220, 'lps'),
	(545966, 130, '2014-02-15 00:20:53.000000', 'consum', 0.0225, 'lps'),
	(545967, 130, '2014-02-15 00:20:54.000000', 'consum', 0.0223, 'lps'),
	(545968, 130, '2014-02-15 00:20:55.000000', 'consum', 0.0213, 'lps'),
	(545969, 130, '2014-02-15 00:20:56.000000', 'consum', 0.0222, 'lps'),
	(545970, 130, '2014-02-15 00:20:57.000000', 'consum', 0.0210, 'lps'),
	(545971, 130, '2014-02-15 00:20:58.000000', 'consum', 0.0226, 'lps'),
	(545972, 130, '2014-02-15 00:20:59.000000', 'consum', 0.0224, 'lps'),
	(545973, 130, '2014-02-15 00:21:00.000000', 'consum', 0.0213, 'lps'),
	(545974, 130, '2014-02-15 00:21:01.000000', 'consum', 0.0218, 'lps'),
	(545975, 130, '2014-02-15 00:21:02.000000', 'consum', 0.0224, 'lps'),
	(545976, 130, '2014-02-15 00:21:03.000000', 'consum', 0.0222, 'lps'),
	(545977, 130, '2014-02-15 00:21:04.000000', 'consum', 0.0214, 'lps'),
	(545978, 130, '2014-02-15 00:21:05.000000', 'consum', 0.0211, 'lps'),
	(545979, 130, '2014-02-15 00:21:06.000000', 'consum', 0.0222, 'lps'),
	(545980, 130, '2014-02-15 00:21:07.000000', 'consum', 0.0214, 'lps'),
	(545981, 130, '2014-02-15 00:21:08.000000', 'consum', 0.0214, 'lps'),
	(545982, 130, '2014-02-15 00:21:09.000000', 'consum', 0.0218, 'lps'),
	(545983, 130, '2014-02-15 00:21:10.000000', 'consum', 0.0220, 'lps'),
	(545984, 130, '2014-02-15 00:21:11.000000', 'consum', 0.0220, 'lps'),
	(545985, 130, '2014-02-15 00:21:12.000000', 'consum', 0.0214, 'lps'),
	(545986, 130, '2014-02-15 00:21:13.000000', 'consum', 0.0215, 'lps'),
	(545987, 130, '2014-02-15 00:21:14.000000', 'consum', 0.0210, 'lps'),
	(545988, 130, '2014-02-15 00:21:15.000000', 'consum', 0.0212, 'lps'),
	(545989, 130, '2014-02-15 00:21:16.000000', 'consum', 0.0219, 'lps'),
	(545990, 130, '2014-02-15 00:21:17.000000', 'consum', 0.0217, 'lps'),
	(545991, 130, '2014-02-15 00:21:18.000000', 'consum', 0.0218, 'lps'),
	(545992, 130, '2014-02-15 00:21:19.000000', 'consum', 0.0211, 'lps'),
	(545993, 130, '2014-02-15 00:21:20.000000', 'consum', 0.0225, 'lps'),
	(545994, 130, '2014-02-15 00:21:21.000000', 'consum', 0.0215, 'lps'),
	(545995, 130, '2014-02-15 00:21:22.000000', 'consum', 0.0226, 'lps'),
	(545996, 130, '2014-02-15 00:21:23.000000', 'consum', 0.0222, 'lps'),
	(545997, 130, '2014-02-15 00:21:24.000000', 'consum', 0.0223, 'lps'),
	(545998, 130, '2014-02-15 00:21:25.000000', 'consum', 0.0224, 'lps'),
	(545999, 130, '2014-02-15 00:21:26.000000', 'consum', 0.0224, 'lps'),
	(546000, 130, '2014-02-15 00:21:27.000000', 'consum', 0.0223, 'lps'),
	(546001, 130, '2014-02-15 00:21:28.000000', 'consum', 0.0214, 'lps'),
	(546002, 130, '2014-02-15 00:21:29.000000', 'consum', 0.0210, 'lps'),
	(546003, 130, '2014-02-15 00:21:30.000000', 'consum', 0.0214, 'lps'),
	(546004, 130, '2014-02-15 00:21:31.000000', 'consum', 0.0216, 'lps'),
	(546005, 130, '2014-02-15 00:21:32.000000', 'consum', 0.0210, 'lps'),
	(546006, 130, '2014-02-15 00:21:33.000000', 'consum', 0.0210, 'lps'),
	(546007, 130, '2014-02-15 00:21:34.000000', 'consum', 0.0211, 'lps'),
	(546008, 130, '2014-02-15 00:21:35.000000', 'consum', 0.0214, 'lps'),
	(546009, 130, '2014-02-15 00:21:36.000000', 'consum', 0.0211, 'lps'),
	(546010, 130, '2014-02-15 00:21:37.000000', 'consum', 0.0222, 'lps'),
	(546011, 130, '2014-02-15 00:21:38.000000', 'consum', 0.0216, 'lps'),
	(546012, 130, '2014-02-15 00:21:39.000000', 'consum', 0.0220, 'lps'),
	(546013, 130, '2014-02-15 00:21:40.000000', 'consum', 0.0225, 'lps'),
	(546014, 130, '2014-02-15 00:21:41.000000', 'consum', 0.0222, 'lps'),
	(546015, 130, '2014-02-15 00:21:42.000000', 'consum', 0.0226, 'lps'),
	(546016, 130, '2014-02-15 00:21:43.000000', 'consum', 0.0222, 'lps'),
	(546017, 130, '2014-02-15 00:21:44.000000', 'consum', 0.0223, 'lps'),
	(546018, 130, '2014-02-15 00:21:45.000000', 'consum', 0.0219, 'lps'),
	(546019, 130, '2014-02-15 00:21:46.000000', 'consum', 0.0219, 'lps'),
	(546020, 130, '2014-02-15 00:21:47.000000', 'consum', 0.0211, 'lps'),
	(546021, 130, '2014-02-15 00:21:48.000000', 'consum', 0.0223, 'lps'),
	(546022, 130, '2014-02-15 00:21:49.000000', 'consum', 0.0221, 'lps'),
	(546023, 130, '2014-02-15 00:21:50.000000', 'consum', 0.0225, 'lps'),
	(546024, 130, '2014-02-15 00:21:51.000000', 'consum', 0.0221, 'lps'),
	(546025, 130, '2014-02-15 00:21:52.000000', 'consum', 0.0221, 'lps'),
	(546026, 130, '2014-02-15 00:21:53.000000', 'consum', 0.0215, 'lps'),
	(546027, 130, '2014-02-15 00:21:54.000000', 'consum', 0.0218, 'lps'),
	(546028, 130, '2014-02-15 00:21:55.000000', 'consum', 0.0218, 'lps'),
	(546029, 130, '2014-02-15 00:21:56.000000', 'consum', 0.0210, 'lps'),
	(546030, 130, '2014-02-15 00:21:57.000000', 'consum', 0.0222, 'lps'),
	(546031, 130, '2014-02-15 00:21:58.000000', 'consum', 0.0219, 'lps'),
	(546032, 130, '2014-02-15 00:21:59.000000', 'consum', 0.0219, 'lps'),
	(546033, 130, '2014-02-15 00:22:00.000000', 'consum', 0.0213, 'lps'),
	(546034, 130, '2014-02-15 00:22:01.000000', 'consum', 0.0213, 'lps'),
	(546035, 130, '2014-02-15 00:22:02.000000', 'consum', 0.0219, 'lps'),
	(546036, 130, '2014-02-15 00:22:03.000000', 'consum', 0.0211, 'lps'),
	(546037, 130, '2014-02-15 00:22:04.000000', 'consum', 0.0222, 'lps'),
	(546038, 130, '2014-02-15 00:22:05.000000', 'consum', 0.0217, 'lps'),
	(546039, 130, '2014-02-15 00:22:06.000000', 'consum', 0.0210, 'lps'),
	(546040, 130, '2014-02-15 00:22:07.000000', 'consum', 0.0222, 'lps'),
	(546041, 130, '2014-02-15 00:22:08.000000', 'consum', 0.0220, 'lps'),
	(546042, 130, '2014-02-15 00:22:09.000000', 'consum', 0.0225, 'lps'),
	(546043, 130, '2014-02-15 00:22:10.000000', 'consum', 0.0223, 'lps'),
	(546044, 130, '2014-02-15 00:22:11.000000', 'consum', 0.0213, 'lps'),
	(546045, 130, '2014-02-15 00:22:12.000000', 'consum', 0.0222, 'lps'),
	(546046, 130, '2014-02-15 00:22:13.000000', 'consum', 0.0210, 'lps'),
	(546047, 130, '2014-02-15 00:22:14.000000', 'consum', 0.0224, 'lps'),
	(546048, 130, '2014-02-15 00:22:15.000000', 'consum', 0.0215, 'lps'),
	(546049, 130, '2014-02-15 00:22:16.000000', 'consum', 0.0226, 'lps'),
	(546050, 130, '2014-02-15 00:22:17.000000', 'consum', 0.0225, 'lps'),
	(546051, 130, '2014-02-15 00:22:18.000000', 'consum', 0.0220, 'lps'),
	(546052, 130, '2014-02-15 00:22:19.000000', 'consum', 0.0215, 'lps'),
	(546053, 130, '2014-02-15 00:22:20.000000', 'consum', 0.0221, 'lps'),
	(546054, 130, '2014-02-15 00:22:21.000000', 'consum', 0.0219, 'lps'),
	(546055, 130, '2014-02-15 00:22:22.000000', 'consum', 0.0222, 'lps'),
	(546056, 130, '2014-02-15 00:22:23.000000', 'consum', 0.0226, 'lps'),
	(546057, 130, '2014-02-15 00:22:24.000000', 'consum', 0.0223, 'lps'),
	(546058, 130, '2014-02-15 00:22:25.000000', 'consum', 0.0225, 'lps'),
	(546059, 130, '2014-02-15 00:22:26.000000', 'consum', 0.0213, 'lps'),
	(546060, 130, '2014-02-15 00:22:27.000000', 'consum', 0.0212, 'lps'),
	(546061, 130, '2014-02-15 00:22:28.000000', 'consum', 0.0215, 'lps'),
	(546062, 130, '2014-02-15 00:22:29.000000', 'consum', 0.0213, 'lps'),
	(546063, 130, '2014-02-15 00:22:30.000000', 'consum', 0.0226, 'lps'),
	(546064, 130, '2014-02-15 00:22:31.000000', 'consum', 0.0212, 'lps'),
	(546065, 130, '2014-02-15 00:22:32.000000', 'consum', 0.0226, 'lps'),
	(546066, 130, '2014-02-15 00:22:33.000000', 'consum', 0.0217, 'lps'),
	(546067, 130, '2014-02-15 00:22:34.000000', 'consum', 0.0213, 'lps'),
	(546068, 130, '2014-02-15 00:22:35.000000', 'consum', 0.0223, 'lps'),
	(546069, 130, '2014-02-15 00:22:36.000000', 'consum', 0.0213, 'lps'),
	(546070, 130, '2014-02-15 00:22:37.000000', 'consum', 0.0222, 'lps'),
	(546071, 130, '2014-02-15 00:22:38.000000', 'consum', 0.0226, 'lps'),
	(546072, 130, '2014-02-15 00:22:39.000000', 'consum', 0.0223, 'lps'),
	(546073, 130, '2014-02-15 00:22:40.000000', 'consum', 0.0210, 'lps'),
	(546074, 130, '2014-02-15 00:22:41.000000', 'consum', 0.0221, 'lps'),
	(546075, 130, '2014-02-15 00:22:42.000000', 'consum', 0.0216, 'lps'),
	(546076, 130, '2014-02-15 00:22:43.000000', 'consum', 0.0226, 'lps'),
	(546077, 130, '2014-02-15 00:22:44.000000', 'consum', 0.0220, 'lps'),
	(546078, 130, '2014-02-15 00:22:45.000000', 'consum', 0.0211, 'lps'),
	(546079, 130, '2014-02-15 00:22:46.000000', 'consum', 0.0222, 'lps'),
	(546080, 130, '2014-02-15 00:22:47.000000', 'consum', 0.0217, 'lps'),
	(546081, 130, '2014-02-15 00:22:48.000000', 'consum', 0.0210, 'lps'),
	(546082, 130, '2014-02-15 00:22:49.000000', 'consum', 0.0224, 'lps'),
	(546083, 130, '2014-02-15 00:22:50.000000', 'consum', 0.0212, 'lps'),
	(546084, 130, '2014-02-15 00:22:51.000000', 'consum', 0.0211, 'lps'),
	(546085, 130, '2014-02-15 00:22:52.000000', 'consum', 0.0210, 'lps'),
	(546086, 130, '2014-02-15 00:22:53.000000', 'consum', 0.0225, 'lps'),
	(546087, 130, '2014-02-15 00:22:54.000000', 'consum', 0.0219, 'lps'),
	(546088, 130, '2014-02-15 00:22:55.000000', 'consum', 0.0225, 'lps'),
	(546089, 130, '2014-02-15 00:22:56.000000', 'consum', 0.0224, 'lps'),
	(546090, 130, '2014-02-15 00:22:57.000000', 'consum', 0.0217, 'lps'),
	(546091, 130, '2014-02-15 00:22:58.000000', 'consum', 0.0224, 'lps'),
	(546092, 130, '2014-02-15 00:22:59.000000', 'consum', 0.0225, 'lps'),
	(546093, 130, '2014-02-15 00:23:00.000000', 'consum', 0.0226, 'lps'),
	(546094, 130, '2014-02-15 00:23:01.000000', 'consum', 0.0213, 'lps'),
	(546095, 130, '2014-02-15 00:23:02.000000', 'consum', 0.0226, 'lps'),
	(546096, 130, '2014-02-15 00:23:03.000000', 'consum', 0.0216, 'lps'),
	(546097, 130, '2014-02-15 00:23:04.000000', 'consum', 0.0226, 'lps'),
	(546098, 130, '2014-02-15 00:23:05.000000', 'consum', 0.0222, 'lps'),
	(546099, 130, '2014-02-15 00:23:06.000000', 'consum', 0.0222, 'lps'),
	(546100, 130, '2014-02-15 00:23:07.000000', 'consum', 0.0217, 'lps'),
	(546101, 130, '2014-02-15 00:23:08.000000', 'consum', 0.0211, 'lps'),
	(546102, 130, '2014-02-15 00:23:09.000000', 'consum', 0.0211, 'lps'),
	(546103, 130, '2014-02-15 00:23:10.000000', 'consum', 0.0211, 'lps'),
	(546104, 130, '2014-02-15 00:23:11.000000', 'consum', 0.0214, 'lps'),
	(546105, 130, '2014-02-15 00:23:12.000000', 'consum', 0.0225, 'lps'),
	(546106, 130, '2014-02-15 00:23:13.000000', 'consum', 0.0226, 'lps'),
	(546107, 130, '2014-02-15 00:23:14.000000', 'consum', 0.0210, 'lps'),
	(546108, 130, '2014-02-15 00:23:15.000000', 'consum', 0.0213, 'lps'),
	(546109, 130, '2014-02-15 00:23:16.000000', 'consum', 0.0225, 'lps'),
	(546110, 130, '2014-02-15 00:23:17.000000', 'consum', 0.0210, 'lps'),
	(546111, 130, '2014-02-15 00:23:18.000000', 'consum', 0.0215, 'lps'),
	(546112, 130, '2014-02-15 00:23:19.000000', 'consum', 0.0219, 'lps'),
	(546113, 130, '2014-02-15 00:23:20.000000', 'consum', 0.0222, 'lps'),
	(546114, 130, '2014-02-15 00:23:21.000000', 'consum', 0.0210, 'lps'),
	(546115, 130, '2014-02-15 00:23:22.000000', 'consum', 0.0226, 'lps'),
	(546116, 130, '2014-02-15 00:23:23.000000', 'consum', 0.0224, 'lps'),
	(546117, 130, '2014-02-15 00:23:24.000000', 'consum', 0.0216, 'lps'),
	(546118, 130, '2014-02-15 00:23:25.000000', 'consum', 0.0215, 'lps'),
	(546119, 130, '2014-02-15 00:23:26.000000', 'consum', 0.0216, 'lps'),
	(546120, 130, '2014-02-15 00:23:27.000000', 'consum', 0.0224, 'lps'),
	(546121, 130, '2014-02-15 00:23:28.000000', 'consum', 0.0214, 'lps'),
	(546122, 130, '2014-02-15 00:23:29.000000', 'consum', 0.0223, 'lps'),
	(546123, 130, '2014-02-15 00:23:30.000000', 'consum', 0.0211, 'lps'),
	(546124, 130, '2014-02-15 00:23:31.000000', 'consum', 0.0211, 'lps'),
	(546125, 130, '2014-02-15 00:23:32.000000', 'consum', 0.0214, 'lps'),
	(546126, 130, '2014-02-15 00:23:33.000000', 'consum', 0.0211, 'lps'),
	(546127, 130, '2014-02-15 00:23:34.000000', 'consum', 0.0219, 'lps'),
	(546128, 130, '2014-02-15 00:23:35.000000', 'consum', 0.0219, 'lps'),
	(546129, 130, '2014-02-15 00:23:36.000000', 'consum', 0.0212, 'lps'),
	(546130, 130, '2014-02-15 00:23:37.000000', 'consum', 0.0226, 'lps'),
	(546131, 130, '2014-02-15 00:23:38.000000', 'consum', 0.0216, 'lps'),
	(546132, 130, '2014-02-15 00:23:39.000000', 'consum', 0.0212, 'lps'),
	(546133, 130, '2014-02-15 00:23:40.000000', 'consum', 0.0217, 'lps'),
	(546134, 130, '2014-02-15 00:23:41.000000', 'consum', 0.0223, 'lps'),
	(546135, 130, '2014-02-15 00:23:42.000000', 'consum', 0.0221, 'lps'),
	(546136, 130, '2014-02-15 00:23:43.000000', 'consum', 0.0225, 'lps'),
	(546137, 130, '2014-02-15 00:23:44.000000', 'consum', 0.0220, 'lps'),
	(546138, 130, '2014-02-15 00:23:45.000000', 'consum', 0.0214, 'lps'),
	(546139, 130, '2014-02-15 00:23:46.000000', 'consum', 0.0218, 'lps'),
	(546140, 130, '2014-02-15 00:23:47.000000', 'consum', 0.0223, 'lps'),
	(546141, 130, '2014-02-15 00:23:48.000000', 'consum', 0.0218, 'lps'),
	(546142, 130, '2014-02-15 00:23:49.000000', 'consum', 0.0211, 'lps'),
	(546143, 130, '2014-02-15 00:23:50.000000', 'consum', 0.0224, 'lps'),
	(546144, 130, '2014-02-15 00:23:51.000000', 'consum', 0.0212, 'lps'),
	(546145, 130, '2014-02-15 00:23:52.000000', 'consum', 0.0213, 'lps'),
	(546146, 130, '2014-02-15 00:23:53.000000', 'consum', 0.0219, 'lps'),
	(546147, 130, '2014-02-15 00:23:54.000000', 'consum', 0.0212, 'lps'),
	(546148, 130, '2014-02-15 00:23:55.000000', 'consum', 0.0226, 'lps'),
	(546149, 130, '2014-02-15 00:23:56.000000', 'consum', 0.0219, 'lps'),
	(546150, 130, '2014-02-15 00:23:57.000000', 'consum', 0.0222, 'lps'),
	(546151, 130, '2014-02-15 00:23:58.000000', 'consum', 0.0226, 'lps'),
	(546152, 130, '2014-02-15 00:23:59.000000', 'consum', 0.0223, 'lps'),
	(546153, 130, '2014-02-15 00:24:00.000000', 'consum', 0.0226, 'lps'),
	(546154, 130, '2014-02-15 00:24:01.000000', 'consum', 0.0219, 'lps'),
	(546155, 130, '2014-02-15 00:24:02.000000', 'consum', 0.0225, 'lps'),
	(546156, 130, '2014-02-15 00:24:03.000000', 'consum', 0.0222, 'lps'),
	(546157, 130, '2014-02-15 00:24:04.000000', 'consum', 0.0225, 'lps'),
	(546158, 130, '2014-02-15 00:24:05.000000', 'consum', 0.0217, 'lps'),
	(546159, 130, '2014-02-15 00:24:06.000000', 'consum', 0.0217, 'lps'),
	(546160, 130, '2014-02-15 00:24:07.000000', 'consum', 0.0226, 'lps'),
	(546161, 130, '2014-02-15 00:24:08.000000', 'consum', 0.0219, 'lps'),
	(546162, 130, '2014-02-15 00:24:09.000000', 'consum', 0.0223, 'lps'),
	(546163, 130, '2014-02-15 00:24:10.000000', 'consum', 0.0213, 'lps'),
	(546164, 130, '2014-02-15 00:24:11.000000', 'consum', 0.0223, 'lps'),
	(546165, 130, '2014-02-15 00:24:12.000000', 'consum', 0.0213, 'lps'),
	(546166, 130, '2014-02-15 00:24:13.000000', 'consum', 0.0222, 'lps'),
	(546167, 130, '2014-02-15 00:24:14.000000', 'consum', 0.0212, 'lps'),
	(546168, 130, '2014-02-15 00:24:15.000000', 'consum', 0.0219, 'lps'),
	(546169, 130, '2014-02-15 00:24:16.000000', 'consum', 0.0214, 'lps'),
	(546170, 130, '2014-02-15 00:24:17.000000', 'consum', 0.0222, 'lps'),
	(546171, 130, '2014-02-15 00:24:18.000000', 'consum', 0.0222, 'lps'),
	(546172, 130, '2014-02-15 00:24:19.000000', 'consum', 0.0220, 'lps'),
	(546173, 130, '2014-02-15 00:24:20.000000', 'consum', 0.0225, 'lps'),
	(546174, 130, '2014-02-15 00:24:21.000000', 'consum', 0.0222, 'lps'),
	(546175, 130, '2014-02-15 00:24:22.000000', 'consum', 0.0225, 'lps'),
	(546176, 130, '2014-02-15 00:24:23.000000', 'consum', 0.0215, 'lps'),
	(546177, 130, '2014-02-15 00:24:24.000000', 'consum', 0.0226, 'lps'),
	(546178, 130, '2014-02-15 00:24:25.000000', 'consum', 0.0222, 'lps'),
	(546179, 130, '2014-02-15 00:24:26.000000', 'consum', 0.0224, 'lps'),
	(546180, 130, '2014-02-15 00:24:27.000000', 'consum', 0.0226, 'lps'),
	(546181, 130, '2014-02-15 00:24:28.000000', 'consum', 0.0215, 'lps'),
	(546182, 130, '2014-02-15 00:24:29.000000', 'consum', 0.0223, 'lps'),
	(546183, 130, '2014-02-15 00:24:30.000000', 'consum', 0.0210, 'lps'),
	(546184, 130, '2014-02-15 00:24:31.000000', 'consum', 0.0223, 'lps'),
	(546185, 130, '2014-02-15 00:24:32.000000', 'consum', 0.0226, 'lps'),
	(546186, 130, '2014-02-15 00:24:33.000000', 'consum', 0.0214, 'lps'),
	(546187, 130, '2014-02-15 00:24:34.000000', 'consum', 0.0217, 'lps'),
	(546188, 130, '2014-02-15 00:24:35.000000', 'consum', 0.0219, 'lps'),
	(546189, 130, '2014-02-15 00:24:36.000000', 'consum', 0.0215, 'lps'),
	(546190, 130, '2014-02-15 00:24:37.000000', 'consum', 0.0225, 'lps'),
	(546191, 130, '2014-02-15 00:24:38.000000', 'consum', 0.0220, 'lps'),
	(546192, 130, '2014-02-15 00:24:39.000000', 'consum', 0.0216, 'lps'),
	(546193, 130, '2014-02-15 00:24:40.000000', 'consum', 0.0226, 'lps'),
	(546194, 130, '2014-02-15 00:24:41.000000', 'consum', 0.0223, 'lps'),
	(546195, 130, '2014-02-15 00:24:42.000000', 'consum', 0.0212, 'lps'),
	(546196, 130, '2014-02-15 00:24:43.000000', 'consum', 0.0214, 'lps'),
	(546197, 130, '2014-02-15 00:24:44.000000', 'consum', 0.0223, 'lps'),
	(546198, 130, '2014-02-15 00:24:45.000000', 'consum', 0.0212, 'lps'),
	(546199, 130, '2014-02-15 00:24:46.000000', 'consum', 0.0219, 'lps'),
	(546200, 130, '2014-02-15 00:24:47.000000', 'consum', 0.0213, 'lps'),
	(546201, 130, '2014-02-15 00:24:48.000000', 'consum', 0.0214, 'lps'),
	(546202, 130, '2014-02-15 00:24:49.000000', 'consum', 0.0224, 'lps'),
	(546203, 130, '2014-02-15 00:24:50.000000', 'consum', 0.0217, 'lps'),
	(546204, 130, '2014-02-15 00:24:51.000000', 'consum', 0.0221, 'lps'),
	(546205, 130, '2014-02-15 00:24:52.000000', 'consum', 0.0225, 'lps'),
	(546206, 130, '2014-02-15 00:24:53.000000', 'consum', 0.0222, 'lps'),
	(546207, 130, '2014-02-15 00:24:54.000000', 'consum', 0.0222, 'lps'),
	(546208, 130, '2014-02-15 00:24:55.000000', 'consum', 0.0221, 'lps'),
	(546209, 130, '2014-02-15 00:24:56.000000', 'consum', 0.0210, 'lps'),
	(546210, 130, '2014-02-15 00:24:57.000000', 'consum', 0.0212, 'lps'),
	(546211, 130, '2014-02-15 00:24:58.000000', 'consum', 0.0219, 'lps'),
	(546212, 130, '2014-02-15 00:24:59.000000', 'consum', 0.0217, 'lps'),
	(546213, 130, '2014-02-15 00:25:00.000000', 'consum', 0.0218, 'lps'),
	(546214, 130, '2014-02-15 00:25:01.000000', 'consum', 0.0215, 'lps'),
	(546215, 130, '2014-02-15 00:25:02.000000', 'consum', 0.0225, 'lps'),
	(546216, 130, '2014-02-15 00:25:03.000000', 'consum', 0.0221, 'lps'),
	(546217, 130, '2014-02-15 00:25:04.000000', 'consum', 0.0219, 'lps'),
	(546218, 130, '2014-02-15 00:25:05.000000', 'consum', 0.0225, 'lps'),
	(546219, 130, '2014-02-15 00:25:06.000000', 'consum', 0.0223, 'lps'),
	(546220, 130, '2014-02-15 00:25:07.000000', 'consum', 0.0214, 'lps'),
	(546221, 130, '2014-02-15 00:25:08.000000', 'consum', 0.0210, 'lps'),
	(546222, 130, '2014-02-15 00:25:09.000000', 'consum', 0.0213, 'lps'),
	(546223, 130, '2014-02-15 00:25:10.000000', 'consum', 0.0226, 'lps'),
	(546224, 130, '2014-02-15 00:25:11.000000', 'consum', 0.0213, 'lps'),
	(546225, 130, '2014-02-15 00:25:12.000000', 'consum', 0.0210, 'lps'),
	(546226, 130, '2014-02-15 00:25:13.000000', 'consum', 0.0221, 'lps'),
	(546227, 130, '2014-02-15 00:25:14.000000', 'consum', 0.0212, 'lps'),
	(546228, 130, '2014-02-15 00:25:15.000000', 'consum', 0.0223, 'lps'),
	(546229, 130, '2014-02-15 00:25:16.000000', 'consum', 0.0220, 'lps'),
	(546230, 130, '2014-02-15 00:25:17.000000', 'consum', 0.0219, 'lps'),
	(546231, 130, '2014-02-15 00:25:18.000000', 'consum', 0.0226, 'lps'),
	(546232, 130, '2014-02-15 00:25:19.000000', 'consum', 0.0214, 'lps'),
	(546233, 130, '2014-02-15 00:25:20.000000', 'consum', 0.0217, 'lps'),
	(546234, 130, '2014-02-15 00:25:21.000000', 'consum', 0.0215, 'lps'),
	(546235, 130, '2014-02-15 00:25:22.000000', 'consum', 0.0213, 'lps'),
	(546236, 130, '2014-02-15 00:25:23.000000', 'consum', 0.0213, 'lps'),
	(546237, 130, '2014-02-15 00:25:24.000000', 'consum', 0.0214, 'lps'),
	(546238, 130, '2014-02-15 00:25:25.000000', 'consum', 0.0224, 'lps'),
	(546239, 130, '2014-02-15 00:25:26.000000', 'consum', 0.0215, 'lps'),
	(546240, 130, '2014-02-15 00:25:27.000000', 'consum', 0.0213, 'lps'),
	(546241, 130, '2014-02-15 00:25:28.000000', 'consum', 0.0225, 'lps'),
	(546242, 130, '2014-02-15 00:25:29.000000', 'consum', 0.0211, 'lps'),
	(546243, 130, '2014-02-15 00:25:30.000000', 'consum', 0.0222, 'lps'),
	(546244, 130, '2014-02-15 00:25:31.000000', 'consum', 0.0214, 'lps'),
	(546245, 130, '2014-02-15 00:25:32.000000', 'consum', 0.0212, 'lps'),
	(546246, 130, '2014-02-15 00:25:33.000000', 'consum', 0.0225, 'lps'),
	(546247, 130, '2014-02-15 00:25:34.000000', 'consum', 0.0212, 'lps'),
	(546248, 130, '2014-02-15 00:25:35.000000', 'consum', 0.0225, 'lps'),
	(546249, 130, '2014-02-15 00:25:36.000000', 'consum', 0.0211, 'lps'),
	(546250, 130, '2014-02-15 00:25:37.000000', 'consum', 0.0220, 'lps'),
	(546251, 130, '2014-02-15 00:25:38.000000', 'consum', 0.0210, 'lps'),
	(546252, 130, '2014-02-15 00:25:39.000000', 'consum', 0.0215, 'lps'),
	(546253, 130, '2014-02-15 00:25:40.000000', 'consum', 0.0216, 'lps'),
	(546254, 130, '2014-02-15 00:25:41.000000', 'consum', 0.0226, 'lps'),
	(546255, 130, '2014-02-15 00:25:42.000000', 'consum', 0.0221, 'lps'),
	(546256, 130, '2014-02-15 00:25:43.000000', 'consum', 0.0220, 'lps'),
	(546257, 130, '2014-02-15 00:25:44.000000', 'consum', 0.0225, 'lps'),
	(546258, 130, '2014-02-15 00:25:45.000000', 'consum', 0.0222, 'lps'),
	(546259, 130, '2014-02-15 00:25:46.000000', 'consum', 0.0210, 'lps'),
	(546260, 130, '2014-02-15 00:25:47.000000', 'consum', 0.0224, 'lps'),
	(546261, 130, '2014-02-15 00:25:48.000000', 'consum', 0.0213, 'lps'),
	(546262, 130, '2014-02-15 00:25:49.000000', 'consum', 0.0219, 'lps'),
	(546263, 130, '2014-02-15 00:25:50.000000', 'consum', 0.0211, 'lps'),
	(546264, 130, '2014-02-15 00:25:51.000000', 'consum', 0.0222, 'lps'),
	(546265, 130, '2014-02-15 00:25:52.000000', 'consum', 0.0217, 'lps'),
	(546266, 130, '2014-02-15 00:25:53.000000', 'consum', 0.0211, 'lps'),
	(546267, 130, '2014-02-15 00:25:54.000000', 'consum', 0.0211, 'lps'),
	(546268, 130, '2014-02-15 00:25:55.000000', 'consum', 0.0211, 'lps'),
	(546269, 130, '2014-02-15 00:25:56.000000', 'consum', 0.0213, 'lps'),
	(546270, 130, '2014-02-15 00:25:57.000000', 'consum', 0.0222, 'lps'),
	(546271, 130, '2014-02-15 00:25:58.000000', 'consum', 0.0211, 'lps'),
	(546272, 130, '2014-02-15 00:25:59.000000', 'consum', 0.0212, 'lps'),
	(546273, 130, '2014-02-15 00:26:00.000000', 'consum', 0.0220, 'lps'),
	(546274, 130, '2014-02-15 00:26:01.000000', 'consum', 0.0217, 'lps'),
	(546275, 130, '2014-02-15 00:26:02.000000', 'consum', 0.0219, 'lps'),
	(546276, 130, '2014-02-15 00:26:03.000000', 'consum', 0.0215, 'lps'),
	(546277, 130, '2014-02-15 00:26:04.000000', 'consum', 0.0212, 'lps'),
	(546278, 130, '2014-02-15 00:26:05.000000', 'consum', 0.0219, 'lps'),
	(546279, 130, '2014-02-15 00:26:06.000000', 'consum', 0.0215, 'lps'),
	(546280, 130, '2014-02-15 00:26:07.000000', 'consum', 0.0226, 'lps'),
	(546281, 130, '2014-02-15 00:26:08.000000', 'consum', 0.0224, 'lps'),
	(546282, 130, '2014-02-15 00:26:09.000000', 'consum', 0.0215, 'lps'),
	(546283, 130, '2014-02-15 00:26:10.000000', 'consum', 0.0210, 'lps'),
	(546284, 130, '2014-02-15 00:26:11.000000', 'consum', 0.0212, 'lps'),
	(546285, 130, '2014-02-15 00:26:12.000000', 'consum', 0.0221, 'lps'),
	(546286, 130, '2014-02-15 00:26:13.000000', 'consum', 0.0225, 'lps'),
	(546287, 130, '2014-02-15 00:26:14.000000', 'consum', 0.0219, 'lps'),
	(546288, 130, '2014-02-15 00:26:15.000000', 'consum', 0.0213, 'lps'),
	(546289, 130, '2014-02-15 00:26:16.000000', 'consum', 0.0212, 'lps'),
	(546290, 130, '2014-02-15 00:26:17.000000', 'consum', 0.0211, 'lps'),
	(546291, 130, '2014-02-15 00:26:18.000000', 'consum', 0.0212, 'lps'),
	(546292, 130, '2014-02-15 00:26:19.000000', 'consum', 0.0216, 'lps'),
	(546293, 130, '2014-02-15 00:26:20.000000', 'consum', 0.0216, 'lps'),
	(546294, 130, '2014-02-15 00:26:21.000000', 'consum', 0.0224, 'lps'),
	(546295, 130, '2014-02-15 00:26:22.000000', 'consum', 0.0212, 'lps'),
	(546296, 130, '2014-02-15 00:26:23.000000', 'consum', 0.0212, 'lps'),
	(546297, 130, '2014-02-15 00:26:24.000000', 'consum', 0.0214, 'lps'),
	(546298, 130, '2014-02-15 00:26:25.000000', 'consum', 0.0223, 'lps'),
	(546299, 130, '2014-02-15 00:26:26.000000', 'consum', 0.0214, 'lps'),
	(546300, 130, '2014-02-15 00:26:27.000000', 'consum', 0.0210, 'lps'),
	(546301, 130, '2014-02-15 00:26:28.000000', 'consum', 0.0213, 'lps'),
	(546302, 130, '2014-02-15 00:26:29.000000', 'consum', 0.0211, 'lps'),
	(546303, 130, '2014-02-15 00:26:30.000000', 'consum', 0.0224, 'lps'),
	(546304, 130, '2014-02-15 00:26:31.000000', 'consum', 0.0225, 'lps'),
	(546305, 130, '2014-02-15 00:26:32.000000', 'consum', 0.0225, 'lps'),
	(546306, 130, '2014-02-15 00:26:33.000000', 'consum', 0.0226, 'lps'),
	(546307, 130, '2014-02-15 00:26:34.000000', 'consum', 0.0226, 'lps'),
	(546308, 130, '2014-02-15 00:26:35.000000', 'consum', 0.0225, 'lps'),
	(546309, 130, '2014-02-15 00:26:36.000000', 'consum', 0.0223, 'lps'),
	(546310, 130, '2014-02-15 00:26:37.000000', 'consum', 0.0211, 'lps'),
	(546311, 130, '2014-02-15 00:26:38.000000', 'consum', 0.0212, 'lps'),
	(546312, 130, '2014-02-15 00:26:39.000000', 'consum', 0.0219, 'lps'),
	(546313, 130, '2014-02-15 00:26:40.000000', 'consum', 0.0213, 'lps'),
	(546314, 130, '2014-02-15 00:26:41.000000', 'consum', 0.0216, 'lps'),
	(546315, 130, '2014-02-15 00:26:42.000000', 'consum', 0.0214, 'lps'),
	(546316, 130, '2014-02-15 00:26:43.000000', 'consum', 0.0214, 'lps'),
	(546317, 130, '2014-02-15 00:26:44.000000', 'consum', 0.0218, 'lps'),
	(546318, 130, '2014-02-15 00:26:45.000000', 'consum', 0.0219, 'lps'),
	(546319, 130, '2014-02-15 00:26:46.000000', 'consum', 0.0218, 'lps'),
	(546320, 130, '2014-02-15 00:26:47.000000', 'consum', 0.0221, 'lps'),
	(546321, 130, '2014-02-15 00:26:48.000000', 'consum', 0.0226, 'lps'),
	(546322, 130, '2014-02-15 00:26:49.000000', 'consum', 0.0221, 'lps'),
	(546323, 130, '2014-02-15 00:26:50.000000', 'consum', 0.0219, 'lps'),
	(546324, 130, '2014-02-15 00:26:51.000000', 'consum', 0.0222, 'lps'),
	(546325, 130, '2014-02-15 00:26:52.000000', 'consum', 0.0226, 'lps'),
	(546326, 130, '2014-02-15 00:26:53.000000', 'consum', 0.0220, 'lps'),
	(546327, 130, '2014-02-15 00:26:54.000000', 'consum', 0.0214, 'lps'),
	(546328, 130, '2014-02-15 00:26:55.000000', 'consum', 0.0218, 'lps'),
	(546329, 130, '2014-02-15 00:26:56.000000', 'consum', 0.0222, 'lps'),
	(546330, 130, '2014-02-15 00:26:57.000000', 'consum', 0.0213, 'lps'),
	(546331, 130, '2014-02-15 00:26:58.000000', 'consum', 0.0221, 'lps'),
	(546332, 130, '2014-02-15 00:26:59.000000', 'consum', 0.0226, 'lps'),
	(546333, 130, '2014-02-15 00:27:00.000000', 'consum', 0.0220, 'lps'),
	(546334, 130, '2014-02-15 00:27:01.000000', 'consum', 0.0216, 'lps'),
	(546335, 130, '2014-02-15 00:27:02.000000', 'consum', 0.0225, 'lps'),
	(546336, 130, '2014-02-15 00:27:03.000000', 'consum', 0.0216, 'lps'),
	(546337, 130, '2014-02-15 00:27:04.000000', 'consum', 0.0215, 'lps'),
	(546338, 130, '2014-02-15 00:27:05.000000', 'consum', 0.0216, 'lps'),
	(546339, 130, '2014-02-15 00:27:06.000000', 'consum', 0.0226, 'lps'),
	(546340, 130, '2014-02-15 00:27:07.000000', 'consum', 0.0221, 'lps'),
	(546341, 130, '2014-02-15 00:27:08.000000', 'consum', 0.0219, 'lps'),
	(546342, 130, '2014-02-15 00:27:09.000000', 'consum', 0.0220, 'lps'),
	(546343, 130, '2014-02-15 00:27:10.000000', 'consum', 0.0216, 'lps'),
	(546344, 130, '2014-02-15 00:27:11.000000', 'consum', 0.0210, 'lps'),
	(546345, 130, '2014-02-15 00:27:12.000000', 'consum', 0.0212, 'lps'),
	(546346, 130, '2014-02-15 00:27:13.000000', 'consum', 0.0219, 'lps'),
	(546347, 130, '2014-02-15 00:27:14.000000', 'consum', 0.0217, 'lps'),
	(546348, 130, '2014-02-15 00:27:15.000000', 'consum', 0.0219, 'lps'),
	(546349, 130, '2014-02-15 00:27:16.000000', 'consum', 0.0215, 'lps'),
	(546350, 130, '2014-02-15 00:27:17.000000', 'consum', 0.0210, 'lps'),
	(546351, 130, '2014-02-15 00:27:18.000000', 'consum', 0.0210, 'lps'),
	(546352, 130, '2014-02-15 00:27:19.000000', 'consum', 0.0213, 'lps'),
	(546353, 130, '2014-02-15 00:27:20.000000', 'consum', 0.0224, 'lps'),
	(546354, 130, '2014-02-15 00:27:21.000000', 'consum', 0.0221, 'lps'),
	(546355, 130, '2014-02-15 00:27:22.000000', 'consum', 0.0223, 'lps'),
	(546356, 130, '2014-02-15 00:27:23.000000', 'consum', 0.0211, 'lps'),
	(546357, 130, '2014-02-15 00:27:24.000000', 'consum', 0.0225, 'lps'),
	(546358, 130, '2014-02-15 00:27:25.000000', 'consum', 0.0215, 'lps'),
	(546359, 130, '2014-02-15 00:27:26.000000', 'consum', 0.0223, 'lps'),
	(546360, 130, '2014-02-15 00:27:27.000000', 'consum', 0.0210, 'lps'),
	(546361, 130, '2014-02-15 00:27:28.000000', 'consum', 0.0221, 'lps'),
	(546362, 130, '2014-02-15 00:27:29.000000', 'consum', 0.0216, 'lps'),
	(546363, 130, '2014-02-15 00:27:30.000000', 'consum', 0.0226, 'lps'),
	(546364, 130, '2014-02-15 00:27:31.000000', 'consum', 0.0221, 'lps'),
	(546365, 130, '2014-02-15 00:27:32.000000', 'consum', 0.0218, 'lps'),
	(546366, 130, '2014-02-15 00:27:33.000000', 'consum', 0.0218, 'lps'),
	(546367, 130, '2014-02-15 00:27:34.000000', 'consum', 0.0226, 'lps'),
	(546368, 130, '2014-02-15 00:27:35.000000', 'consum', 0.0217, 'lps'),
	(546369, 130, '2014-02-15 00:27:36.000000', 'consum', 0.0215, 'lps'),
	(546370, 130, '2014-02-15 00:27:37.000000', 'consum', 0.0213, 'lps'),
	(546371, 130, '2014-02-15 00:27:38.000000', 'consum', 0.0211, 'lps'),
	(546372, 130, '2014-02-15 00:27:39.000000', 'consum', 0.0224, 'lps'),
	(546373, 130, '2014-02-15 00:27:40.000000', 'consum', 0.0226, 'lps'),
	(546374, 130, '2014-02-15 00:27:41.000000', 'consum', 0.0213, 'lps'),
	(546375, 130, '2014-02-15 00:27:42.000000', 'consum', 0.0213, 'lps'),
	(546376, 130, '2014-02-15 00:27:43.000000', 'consum', 0.0216, 'lps'),
	(546377, 130, '2014-02-15 00:27:44.000000', 'consum', 0.0216, 'lps'),
	(546378, 130, '2014-02-15 00:27:45.000000', 'consum', 0.0223, 'lps'),
	(546379, 130, '2014-02-15 00:27:46.000000', 'consum', 0.0225, 'lps'),
	(546380, 130, '2014-02-15 00:27:47.000000', 'consum', 0.0226, 'lps'),
	(546381, 130, '2014-02-15 00:27:48.000000', 'consum', 0.0212, 'lps'),
	(546382, 130, '2014-02-15 00:27:49.000000', 'consum', 0.0226, 'lps'),
	(546383, 130, '2014-02-15 00:27:50.000000', 'consum', 0.0215, 'lps'),
	(546384, 130, '2014-02-15 00:27:51.000000', 'consum', 0.0221, 'lps'),
	(546385, 130, '2014-02-15 00:27:52.000000', 'consum', 0.0218, 'lps'),
	(546386, 130, '2014-02-15 00:27:53.000000', 'consum', 0.0215, 'lps'),
	(546387, 130, '2014-02-15 00:27:54.000000', 'consum', 0.0214, 'lps'),
	(546388, 130, '2014-02-15 00:27:55.000000', 'consum', 0.0213, 'lps'),
	(546389, 130, '2014-02-15 00:27:56.000000', 'consum', 0.0216, 'lps'),
	(546390, 130, '2014-02-15 00:27:57.000000', 'consum', 0.0216, 'lps'),
	(546391, 130, '2014-02-15 00:27:58.000000', 'consum', 0.0219, 'lps'),
	(546392, 130, '2014-02-15 00:27:59.000000', 'consum', 0.0222, 'lps'),
	(546393, 130, '2014-02-15 00:28:00.000000', 'consum', 0.0211, 'lps'),
	(546394, 130, '2014-02-15 00:28:01.000000', 'consum', 0.0214, 'lps'),
	(546395, 130, '2014-02-15 00:28:02.000000', 'consum', 0.0211, 'lps'),
	(546396, 130, '2014-02-15 00:28:03.000000', 'consum', 0.0217, 'lps'),
	(546397, 130, '2014-02-15 00:28:04.000000', 'consum', 0.0212, 'lps'),
	(546398, 130, '2014-02-15 00:28:05.000000', 'consum', 0.0215, 'lps'),
	(546399, 130, '2014-02-15 00:28:06.000000', 'consum', 0.0211, 'lps'),
	(546400, 130, '2014-02-15 00:28:07.000000', 'consum', 0.0217, 'lps'),
	(546401, 130, '2014-02-15 00:28:08.000000', 'consum', 0.0211, 'lps'),
	(546402, 130, '2014-02-15 00:28:09.000000', 'consum', 0.0210, 'lps'),
	(546403, 130, '2014-02-15 00:28:10.000000', 'consum', 0.0210, 'lps'),
	(546404, 130, '2014-02-15 00:28:11.000000', 'consum', 0.0225, 'lps'),
	(546405, 130, '2014-02-15 00:28:12.000000', 'consum', 0.0219, 'lps'),
	(546406, 130, '2014-02-15 00:28:13.000000', 'consum', 0.0226, 'lps'),
	(546407, 130, '2014-02-15 00:28:14.000000', 'consum', 0.0215, 'lps'),
	(546408, 130, '2014-02-15 00:28:15.000000', 'consum', 0.0220, 'lps'),
	(546409, 130, '2014-02-15 00:28:16.000000', 'consum', 0.0210, 'lps'),
	(546410, 130, '2014-02-15 00:28:17.000000', 'consum', 0.0218, 'lps'),
	(546411, 130, '2014-02-15 00:28:18.000000', 'consum', 0.0213, 'lps'),
	(546412, 130, '2014-02-15 00:28:19.000000', 'consum', 0.0221, 'lps'),
	(546413, 130, '2014-02-15 00:28:20.000000', 'consum', 0.0222, 'lps'),
	(546414, 130, '2014-02-15 00:28:21.000000', 'consum', 0.0221, 'lps'),
	(546415, 130, '2014-02-15 00:28:22.000000', 'consum', 0.0213, 'lps'),
	(546416, 130, '2014-02-15 00:28:23.000000', 'consum', 0.0226, 'lps'),
	(546417, 130, '2014-02-15 00:28:24.000000', 'consum', 0.0214, 'lps'),
	(546418, 130, '2014-02-15 00:28:25.000000', 'consum', 0.0215, 'lps'),
	(546419, 130, '2014-02-15 00:28:26.000000', 'consum', 0.0225, 'lps'),
	(546420, 130, '2014-02-15 00:28:27.000000', 'consum', 0.0221, 'lps'),
	(546421, 130, '2014-02-15 00:28:28.000000', 'consum', 0.0218, 'lps'),
	(546422, 130, '2014-02-15 00:28:29.000000', 'consum', 0.0219, 'lps'),
	(546423, 130, '2014-02-15 00:28:30.000000', 'consum', 0.0214, 'lps'),
	(546424, 130, '2014-02-15 00:28:31.000000', 'consum', 0.0220, 'lps'),
	(546425, 130, '2014-02-15 00:28:32.000000', 'consum', 0.0214, 'lps'),
	(546426, 130, '2014-02-15 00:28:33.000000', 'consum', 0.0218, 'lps'),
	(546427, 130, '2014-02-15 00:28:34.000000', 'consum', 0.0222, 'lps'),
	(546428, 130, '2014-02-15 00:28:35.000000', 'consum', 0.0213, 'lps'),
	(546429, 130, '2014-02-15 00:28:36.000000', 'consum', 0.0222, 'lps'),
	(546430, 130, '2014-02-15 00:28:37.000000', 'consum', 0.0211, 'lps'),
	(546431, 130, '2014-02-15 00:28:38.000000', 'consum', 0.0212, 'lps'),
	(546432, 130, '2014-02-15 00:28:39.000000', 'consum', 0.0217, 'lps'),
	(546433, 130, '2014-02-15 00:28:40.000000', 'consum', 0.0224, 'lps'),
	(546434, 130, '2014-02-15 00:28:41.000000', 'consum', 0.0226, 'lps'),
	(546435, 130, '2014-02-15 00:28:42.000000', 'consum', 0.0214, 'lps'),
	(546436, 130, '2014-02-15 00:28:43.000000', 'consum', 0.0219, 'lps'),
	(546437, 130, '2014-02-15 00:28:44.000000', 'consum', 0.0223, 'lps'),
	(546438, 130, '2014-02-15 00:28:45.000000', 'consum', 0.0215, 'lps'),
	(546439, 130, '2014-02-15 00:28:46.000000', 'consum', 0.0212, 'lps'),
	(546440, 130, '2014-02-15 00:28:47.000000', 'consum', 0.0223, 'lps'),
	(546441, 130, '2014-02-15 00:28:48.000000', 'consum', 0.0221, 'lps'),
	(546442, 130, '2014-02-15 00:28:49.000000', 'consum', 0.0225, 'lps'),
	(546443, 130, '2014-02-15 00:28:50.000000', 'consum', 0.0217, 'lps'),
	(546444, 130, '2014-02-15 00:28:51.000000', 'consum', 0.0220, 'lps'),
	(546445, 130, '2014-02-15 00:28:52.000000', 'consum', 0.0224, 'lps'),
	(546446, 130, '2014-02-15 00:28:53.000000', 'consum', 0.0213, 'lps'),
	(546447, 130, '2014-02-15 00:28:54.000000', 'consum', 0.0217, 'lps'),
	(546448, 130, '2014-02-15 00:28:55.000000', 'consum', 0.0222, 'lps'),
	(546449, 130, '2014-02-15 00:28:56.000000', 'consum', 0.0216, 'lps'),
	(546450, 130, '2014-02-15 00:28:57.000000', 'consum', 0.0221, 'lps'),
	(546451, 130, '2014-02-15 00:28:58.000000', 'consum', 0.0215, 'lps'),
	(546452, 130, '2014-02-15 00:28:59.000000', 'consum', 0.0216, 'lps'),
	(546453, 130, '2014-02-15 00:29:00.000000', 'consum', 0.0211, 'lps'),
	(546454, 130, '2014-02-15 00:29:01.000000', 'consum', 0.0214, 'lps'),
	(546455, 130, '2014-02-15 00:29:02.000000', 'consum', 0.0211, 'lps'),
	(546456, 130, '2014-02-15 00:29:03.000000', 'consum', 0.0219, 'lps'),
	(546457, 130, '2014-02-15 00:29:04.000000', 'consum', 0.0221, 'lps'),
	(546458, 130, '2014-02-15 00:29:05.000000', 'consum', 0.0222, 'lps'),
	(546459, 130, '2014-02-15 00:29:06.000000', 'consum', 0.0217, 'lps'),
	(546460, 130, '2014-02-15 00:29:07.000000', 'consum', 0.0212, 'lps'),
	(546461, 130, '2014-02-15 00:29:08.000000', 'consum', 0.0215, 'lps'),
	(546462, 130, '2014-02-15 00:29:09.000000', 'consum', 0.0213, 'lps'),
	(546463, 130, '2014-02-15 00:29:10.000000', 'consum', 0.0213, 'lps'),
	(546464, 130, '2014-02-15 00:29:11.000000', 'consum', 0.0213, 'lps'),
	(546465, 130, '2014-02-15 00:29:12.000000', 'consum', 0.0217, 'lps'),
	(546466, 130, '2014-02-15 00:29:13.000000', 'consum', 0.0221, 'lps'),
	(546467, 130, '2014-02-15 00:29:14.000000', 'consum', 0.0210, 'lps'),
	(546468, 130, '2014-02-15 00:29:15.000000', 'consum', 0.0212, 'lps'),
	(546469, 130, '2014-02-15 00:29:16.000000', 'consum', 0.0221, 'lps'),
	(546470, 130, '2014-02-15 00:29:17.000000', 'consum', 0.0224, 'lps'),
	(546471, 130, '2014-02-15 00:29:18.000000', 'consum', 0.0214, 'lps'),
	(546472, 130, '2014-02-15 00:29:19.000000', 'consum', 0.0223, 'lps'),
	(546473, 130, '2014-02-15 00:29:20.000000', 'consum', 0.0212, 'lps'),
	(546474, 130, '2014-02-15 00:29:21.000000', 'consum', 0.0216, 'lps'),
	(546475, 130, '2014-02-15 00:29:22.000000', 'consum', 0.0217, 'lps'),
	(546476, 130, '2014-02-15 00:29:23.000000', 'consum', 0.0213, 'lps'),
	(546477, 130, '2014-02-15 00:29:24.000000', 'consum', 0.0219, 'lps'),
	(546478, 130, '2014-02-15 00:29:25.000000', 'consum', 0.0213, 'lps'),
	(546479, 130, '2014-02-15 00:29:26.000000', 'consum', 0.0217, 'lps'),
	(546480, 130, '2014-02-15 00:29:27.000000', 'consum', 0.0218, 'lps'),
	(546481, 130, '2014-02-15 00:29:28.000000', 'consum', 0.0213, 'lps'),
	(546482, 130, '2014-02-15 00:29:29.000000', 'consum', 0.0219, 'lps'),
	(546483, 130, '2014-02-15 00:29:30.000000', 'consum', 0.0211, 'lps'),
	(546484, 130, '2014-02-15 00:29:31.000000', 'consum', 0.0224, 'lps'),
	(546485, 130, '2014-02-15 00:29:32.000000', 'consum', 0.0224, 'lps'),
	(546486, 130, '2014-02-15 00:29:33.000000', 'consum', 0.0223, 'lps'),
	(546487, 130, '2014-02-15 00:29:34.000000', 'consum', 0.0218, 'lps'),
	(546488, 130, '2014-02-15 00:29:35.000000', 'consum', 0.0226, 'lps'),
	(546489, 130, '2014-02-15 00:29:36.000000', 'consum', 0.0216, 'lps'),
	(546490, 130, '2014-02-15 00:29:37.000000', 'consum', 0.0212, 'lps'),
	(546491, 130, '2014-02-15 00:29:38.000000', 'consum', 0.0217, 'lps'),
	(546492, 130, '2014-02-15 00:29:39.000000', 'consum', 0.0221, 'lps'),
	(546493, 130, '2014-02-15 00:29:40.000000', 'consum', 0.0213, 'lps'),
	(546494, 130, '2014-02-15 00:29:41.000000', 'consum', 0.0224, 'lps'),
	(546495, 130, '2014-02-15 00:29:42.000000', 'consum', 0.0224, 'lps'),
	(546496, 130, '2014-02-15 00:29:43.000000', 'consum', 0.0219, 'lps'),
	(546497, 130, '2014-02-15 00:29:44.000000', 'consum', 0.0214, 'lps'),
	(546498, 130, '2014-02-15 00:29:45.000000', 'consum', 0.0223, 'lps'),
	(546499, 130, '2014-02-15 00:29:46.000000', 'consum', 0.0226, 'lps'),
	(546500, 130, '2014-02-15 00:29:47.000000', 'consum', 0.0218, 'lps'),
	(546501, 130, '2014-02-15 00:29:48.000000', 'consum', 0.0219, 'lps'),
	(546502, 130, '2014-02-15 00:29:49.000000', 'consum', 0.0217, 'lps'),
	(546503, 130, '2014-02-15 00:29:50.000000', 'consum', 0.0217, 'lps'),
	(546504, 130, '2014-02-15 00:29:51.000000', 'consum', 0.0225, 'lps'),
	(546505, 130, '2014-02-15 00:29:52.000000', 'consum', 0.0213, 'lps'),
	(546506, 130, '2014-02-15 00:29:53.000000', 'consum', 0.0214, 'lps'),
	(546507, 130, '2014-02-15 00:29:54.000000', 'consum', 0.0222, 'lps'),
	(546508, 130, '2014-02-15 00:29:55.000000', 'consum', 0.0223, 'lps'),
	(546509, 130, '2014-02-15 00:29:56.000000', 'consum', 0.0225, 'lps'),
	(546510, 130, '2014-02-15 00:29:57.000000', 'consum', 0.0210, 'lps'),
	(546511, 130, '2014-02-15 00:29:58.000000', 'consum', 0.0219, 'lps'),
	(546512, 130, '2014-02-15 00:29:59.000000', 'consum', 0.0221, 'lps'),
	(546513, 130, '2014-02-15 00:30:00.000000', 'consum', 0.0223, 'lps'),
	(546514, 130, '2014-02-15 00:30:01.000000', 'consum', 0.0225, 'lps'),
	(546515, 130, '2014-02-15 00:30:02.000000', 'consum', 0.0213, 'lps'),
	(546516, 130, '2014-02-15 00:30:03.000000', 'consum', 0.0215, 'lps'),
	(546517, 130, '2014-02-15 00:30:04.000000', 'consum', 0.0225, 'lps'),
	(546518, 130, '2014-02-15 00:30:05.000000', 'consum', 0.0219, 'lps'),
	(546519, 130, '2014-02-15 00:30:06.000000', 'consum', 0.0226, 'lps'),
	(546520, 130, '2014-02-15 00:30:07.000000', 'consum', 0.0214, 'lps'),
	(546521, 130, '2014-02-15 00:30:08.000000', 'consum', 0.0218, 'lps'),
	(546522, 130, '2014-02-15 00:30:09.000000', 'consum', 0.0221, 'lps'),
	(546523, 130, '2014-02-15 00:30:10.000000', 'consum', 0.0225, 'lps'),
	(546524, 130, '2014-02-15 00:30:11.000000', 'consum', 0.0216, 'lps'),
	(546525, 130, '2014-02-15 00:30:12.000000', 'consum', 0.0213, 'lps'),
	(546526, 130, '2014-02-15 00:30:13.000000', 'consum', 0.0226, 'lps'),
	(546527, 130, '2014-02-15 00:30:14.000000', 'consum', 0.0213, 'lps'),
	(546528, 130, '2014-02-15 00:30:15.000000', 'consum', 0.0211, 'lps'),
	(546529, 130, '2014-02-15 00:30:16.000000', 'consum', 0.0222, 'lps'),
	(546530, 130, '2014-02-15 00:30:17.000000', 'consum', 0.0218, 'lps'),
	(546531, 130, '2014-02-15 00:30:18.000000', 'consum', 0.0216, 'lps'),
	(546532, 130, '2014-02-15 00:30:19.000000', 'consum', 0.0217, 'lps'),
	(546533, 130, '2014-02-15 00:30:20.000000', 'consum', 0.0225, 'lps'),
	(546534, 130, '2014-02-15 00:30:21.000000', 'consum', 0.0213, 'lps'),
	(546535, 130, '2014-02-15 00:30:22.000000', 'consum', 0.0214, 'lps'),
	(546536, 130, '2014-02-15 00:30:23.000000', 'consum', 0.0224, 'lps'),
	(546537, 130, '2014-02-15 00:30:24.000000', 'consum', 0.0216, 'lps'),
	(546538, 130, '2014-02-15 00:30:25.000000', 'consum', 0.0217, 'lps'),
	(546539, 130, '2014-02-15 00:30:26.000000', 'consum', 0.0211, 'lps'),
	(546540, 130, '2014-02-15 00:30:27.000000', 'consum', 0.0226, 'lps'),
	(546541, 130, '2014-02-15 00:30:28.000000', 'consum', 0.0219, 'lps'),
	(546542, 130, '2014-02-15 00:30:29.000000', 'consum', 0.0226, 'lps'),
	(546543, 130, '2014-02-15 00:30:30.000000', 'consum', 0.0213, 'lps'),
	(546544, 130, '2014-02-15 00:30:31.000000', 'consum', 0.0211, 'lps'),
	(546545, 130, '2014-02-15 00:30:32.000000', 'consum', 0.0223, 'lps'),
	(546546, 130, '2014-02-15 00:30:33.000000', 'consum', 0.0224, 'lps'),
	(546547, 130, '2014-02-15 00:30:34.000000', 'consum', 0.0223, 'lps'),
	(546548, 130, '2014-02-15 00:30:35.000000', 'consum', 0.0215, 'lps'),
	(546549, 130, '2014-02-15 00:30:36.000000', 'consum', 0.0213, 'lps'),
	(546550, 130, '2014-02-15 00:30:37.000000', 'consum', 0.0213, 'lps'),
	(546551, 130, '2014-02-15 00:30:38.000000', 'consum', 0.0217, 'lps'),
	(546552, 130, '2014-02-15 00:30:39.000000', 'consum', 0.0220, 'lps'),
	(546553, 130, '2014-02-15 00:30:40.000000', 'consum', 0.0220, 'lps'),
	(546554, 130, '2014-02-15 00:30:41.000000', 'consum', 0.0215, 'lps'),
	(546555, 130, '2014-02-15 00:30:42.000000', 'consum', 0.0224, 'lps'),
	(546556, 130, '2014-02-15 00:30:43.000000', 'consum', 0.0212, 'lps'),
	(546557, 130, '2014-02-15 00:30:44.000000', 'consum', 0.0212, 'lps'),
	(546558, 130, '2014-02-15 00:30:45.000000', 'consum', 0.0217, 'lps'),
	(546559, 130, '2014-02-15 00:30:46.000000', 'consum', 0.0224, 'lps'),
	(546560, 130, '2014-02-15 00:30:47.000000', 'consum', 0.0222, 'lps'),
	(546561, 130, '2014-02-15 00:30:48.000000', 'consum', 0.0211, 'lps'),
	(546562, 130, '2014-02-15 00:30:49.000000', 'consum', 0.0214, 'lps'),
	(546563, 130, '2014-02-15 00:30:50.000000', 'consum', 0.0212, 'lps'),
	(546564, 130, '2014-02-15 00:30:51.000000', 'consum', 0.0225, 'lps'),
	(546565, 130, '2014-02-15 00:30:52.000000', 'consum', 0.0211, 'lps'),
	(546566, 130, '2014-02-15 00:30:53.000000', 'consum', 0.0220, 'lps'),
	(546567, 130, '2014-02-15 00:30:54.000000', 'consum', 0.0226, 'lps'),
	(546568, 130, '2014-02-15 00:30:55.000000', 'consum', 0.0223, 'lps'),
	(546569, 130, '2014-02-15 00:30:56.000000', 'consum', 0.0214, 'lps'),
	(546570, 130, '2014-02-15 00:30:57.000000', 'consum', 0.0226, 'lps'),
	(546571, 130, '2014-02-15 00:30:58.000000', 'consum', 0.0226, 'lps'),
	(546572, 130, '2014-02-15 00:30:59.000000', 'consum', 0.0226, 'lps'),
	(546573, 130, '2014-02-15 00:31:00.000000', 'consum', 0.0226, 'lps'),
	(546574, 130, '2014-02-15 00:31:01.000000', 'consum', 0.0226, 'lps'),
	(546575, 130, '2014-02-15 00:31:02.000000', 'consum', 0.0225, 'lps'),
	(546576, 130, '2014-02-15 00:31:03.000000', 'consum', 0.0220, 'lps'),
	(546577, 130, '2014-02-15 00:31:04.000000', 'consum', 0.0215, 'lps'),
	(546578, 130, '2014-02-15 00:31:05.000000', 'consum', 0.0224, 'lps'),
	(546579, 130, '2014-02-15 00:31:06.000000', 'consum', 0.0215, 'lps'),
	(546580, 130, '2014-02-15 00:31:07.000000', 'consum', 0.0225, 'lps'),
	(546581, 130, '2014-02-15 00:31:08.000000', 'consum', 0.0221, 'lps'),
	(546582, 130, '2014-02-15 00:31:09.000000', 'consum', 0.0219, 'lps'),
	(546583, 130, '2014-02-15 00:31:10.000000', 'consum', 0.0223, 'lps'),
	(546584, 130, '2014-02-15 00:31:11.000000', 'consum', 0.0214, 'lps'),
	(546585, 130, '2014-02-15 00:31:12.000000', 'consum', 0.0224, 'lps'),
	(546586, 130, '2014-02-15 00:31:13.000000', 'consum', 0.0219, 'lps'),
	(546587, 130, '2014-02-15 00:31:14.000000', 'consum', 0.0212, 'lps'),
	(546588, 130, '2014-02-15 00:31:15.000000', 'consum', 0.0211, 'lps'),
	(546589, 130, '2014-02-15 00:31:16.000000', 'consum', 0.0211, 'lps'),
	(546590, 130, '2014-02-15 00:31:17.000000', 'consum', 0.0212, 'lps'),
	(546591, 130, '2014-02-15 00:31:18.000000', 'consum', 0.0217, 'lps'),
	(546592, 130, '2014-02-15 00:31:19.000000', 'consum', 0.0222, 'lps'),
	(546593, 130, '2014-02-15 00:31:20.000000', 'consum', 0.0215, 'lps'),
	(546594, 130, '2014-02-15 00:31:21.000000', 'consum', 0.0216, 'lps'),
	(546595, 130, '2014-02-15 00:31:22.000000', 'consum', 0.0226, 'lps'),
	(546596, 130, '2014-02-15 00:31:23.000000', 'consum', 0.0223, 'lps'),
	(546597, 130, '2014-02-15 00:31:24.000000', 'consum', 0.0225, 'lps'),
	(546598, 130, '2014-02-15 00:31:25.000000', 'consum', 0.0212, 'lps'),
	(546599, 130, '2014-02-15 00:31:26.000000', 'consum', 0.0210, 'lps'),
	(546600, 130, '2014-02-15 00:31:27.000000', 'consum', 0.0221, 'lps'),
	(546601, 130, '2014-02-15 00:31:28.000000', 'consum', 0.0215, 'lps'),
	(546602, 130, '2014-02-15 00:31:29.000000', 'consum', 0.0220, 'lps'),
	(546603, 130, '2014-02-15 00:31:30.000000', 'consum', 0.0210, 'lps'),
	(546604, 130, '2014-02-15 00:31:31.000000', 'consum', 0.0214, 'lps'),
	(546605, 130, '2014-02-15 00:31:32.000000', 'consum', 0.0215, 'lps'),
	(546606, 130, '2014-02-15 00:31:33.000000', 'consum', 0.0225, 'lps'),
	(546607, 130, '2014-02-15 00:31:34.000000', 'consum', 0.0216, 'lps'),
	(546608, 130, '2014-02-15 00:31:35.000000', 'consum', 0.0215, 'lps'),
	(546609, 130, '2014-02-15 00:31:36.000000', 'consum', 0.0216, 'lps'),
	(546610, 130, '2014-02-15 00:31:37.000000', 'consum', 0.0225, 'lps'),
	(546611, 130, '2014-02-15 00:31:38.000000', 'consum', 0.0216, 'lps'),
	(546612, 130, '2014-02-15 00:31:39.000000', 'consum', 0.0214, 'lps'),
	(546613, 130, '2014-02-15 00:31:40.000000', 'consum', 0.0213, 'lps'),
	(546614, 130, '2014-02-15 00:31:41.000000', 'consum', 0.0215, 'lps'),
	(546615, 130, '2014-02-15 00:31:42.000000', 'consum', 0.0224, 'lps'),
	(546616, 130, '2014-02-15 00:31:43.000000', 'consum', 0.0213, 'lps'),
	(546617, 130, '2014-02-15 00:31:44.000000', 'consum', 0.0220, 'lps'),
	(546618, 130, '2014-02-15 00:31:45.000000', 'consum', 0.0218, 'lps'),
	(546619, 130, '2014-02-15 00:31:46.000000', 'consum', 0.0221, 'lps'),
	(546620, 130, '2014-02-15 00:31:47.000000', 'consum', 0.0224, 'lps'),
	(546621, 130, '2014-02-15 00:31:48.000000', 'consum', 0.0213, 'lps'),
	(546622, 130, '2014-02-15 00:31:49.000000', 'consum', 0.0219, 'lps'),
	(546623, 130, '2014-02-15 00:31:50.000000', 'consum', 0.0212, 'lps'),
	(546624, 130, '2014-02-15 00:31:51.000000', 'consum', 0.0211, 'lps'),
	(546625, 130, '2014-02-15 00:31:52.000000', 'consum', 0.0225, 'lps'),
	(546626, 130, '2014-02-15 00:31:53.000000', 'consum', 0.0216, 'lps'),
	(546627, 130, '2014-02-15 00:31:54.000000', 'consum', 0.0211, 'lps'),
	(546628, 130, '2014-02-15 00:31:55.000000', 'consum', 0.0214, 'lps'),
	(546629, 130, '2014-02-15 00:31:56.000000', 'consum', 0.0211, 'lps'),
	(546630, 130, '2014-02-15 00:31:57.000000', 'consum', 0.0221, 'lps'),
	(546631, 130, '2014-02-15 00:31:58.000000', 'consum', 0.0211, 'lps'),
	(546632, 130, '2014-02-15 00:31:59.000000', 'consum', 0.0217, 'lps'),
	(546633, 130, '2014-02-15 00:32:00.000000', 'consum', 0.0223, 'lps'),
	(546634, 130, '2014-02-15 00:32:01.000000', 'consum', 0.0224, 'lps'),
	(546635, 130, '2014-02-15 00:32:02.000000', 'consum', 0.0223, 'lps'),
	(546636, 130, '2014-02-15 00:32:03.000000', 'consum', 0.0217, 'lps'),
	(546637, 130, '2014-02-15 00:32:04.000000', 'consum', 0.0225, 'lps'),
	(546638, 130, '2014-02-15 00:32:05.000000', 'consum', 0.0211, 'lps'),
	(546639, 130, '2014-02-15 00:32:06.000000', 'consum', 0.0223, 'lps'),
	(546640, 130, '2014-02-15 00:32:07.000000', 'consum', 0.0221, 'lps'),
	(546641, 130, '2014-02-15 00:32:08.000000', 'consum', 0.0226, 'lps'),
	(546642, 130, '2014-02-15 00:32:09.000000', 'consum', 0.0225, 'lps'),
	(546643, 130, '2014-02-15 00:32:10.000000', 'consum', 0.0219, 'lps'),
	(546644, 130, '2014-02-15 00:32:11.000000', 'consum', 0.0213, 'lps'),
	(546645, 130, '2014-02-15 00:32:12.000000', 'consum', 0.0215, 'lps'),
	(546646, 130, '2014-02-15 00:32:13.000000', 'consum', 0.0224, 'lps'),
	(546647, 130, '2014-02-15 00:32:14.000000', 'consum', 0.0216, 'lps'),
	(546648, 130, '2014-02-15 00:32:15.000000', 'consum', 0.0216, 'lps'),
	(546649, 130, '2014-02-15 00:32:16.000000', 'consum', 0.0221, 'lps'),
	(546650, 130, '2014-02-15 00:32:17.000000', 'consum', 0.0212, 'lps'),
	(546651, 130, '2014-02-15 00:32:18.000000', 'consum', 0.0224, 'lps'),
	(546652, 130, '2014-02-15 00:32:19.000000', 'consum', 0.0222, 'lps'),
	(546653, 130, '2014-02-15 00:32:20.000000', 'consum', 0.0213, 'lps'),
	(546654, 130, '2014-02-15 00:32:21.000000', 'consum', 0.0222, 'lps'),
	(546655, 130, '2014-02-15 00:32:22.000000', 'consum', 0.0213, 'lps'),
	(546656, 130, '2014-02-15 00:32:23.000000', 'consum', 0.0222, 'lps'),
	(546657, 130, '2014-02-15 00:32:24.000000', 'consum', 0.0212, 'lps'),
	(546658, 130, '2014-02-15 00:32:25.000000', 'consum', 0.0218, 'lps'),
	(546659, 130, '2014-02-15 00:32:26.000000', 'consum', 0.0212, 'lps'),
	(546660, 130, '2014-02-15 00:32:27.000000', 'consum', 0.0211, 'lps'),
	(546661, 130, '2014-02-15 00:32:28.000000', 'consum', 0.0212, 'lps'),
	(546662, 130, '2014-02-15 00:32:29.000000', 'consum', 0.0217, 'lps'),
	(546663, 130, '2014-02-15 00:32:30.000000', 'consum', 0.0223, 'lps'),
	(546664, 130, '2014-02-15 00:32:31.000000', 'consum', 0.0220, 'lps'),
	(546665, 130, '2014-02-15 00:32:32.000000', 'consum', 0.0222, 'lps'),
	(546666, 130, '2014-02-15 00:32:33.000000', 'consum', 0.0222, 'lps'),
	(546667, 130, '2014-02-15 00:32:34.000000', 'consum', 0.0220, 'lps'),
	(546668, 130, '2014-02-15 00:32:35.000000', 'consum', 0.0222, 'lps'),
	(546669, 130, '2014-02-15 00:32:36.000000', 'consum', 0.0224, 'lps'),
	(546670, 130, '2014-02-15 00:32:37.000000', 'consum', 0.0213, 'lps'),
	(546671, 130, '2014-02-15 00:32:38.000000', 'consum', 0.0214, 'lps'),
	(546672, 130, '2014-02-15 00:32:39.000000', 'consum', 0.0222, 'lps'),
	(546673, 130, '2014-02-15 00:32:40.000000', 'consum', 0.0225, 'lps'),
	(546674, 130, '2014-02-15 00:32:41.000000', 'consum', 0.0218, 'lps'),
	(546675, 130, '2014-02-15 00:32:42.000000', 'consum', 0.0219, 'lps'),
	(546676, 130, '2014-02-15 00:32:43.000000', 'consum', 0.0214, 'lps'),
	(546677, 130, '2014-02-15 00:32:44.000000', 'consum', 0.0223, 'lps'),
	(546678, 130, '2014-02-15 00:32:45.000000', 'consum', 0.0212, 'lps'),
	(546679, 130, '2014-02-15 00:32:46.000000', 'consum', 0.0217, 'lps'),
	(546680, 130, '2014-02-15 00:32:47.000000', 'consum', 0.0221, 'lps'),
	(546681, 130, '2014-02-15 00:32:48.000000', 'consum', 0.0226, 'lps'),
	(546682, 130, '2014-02-15 00:32:49.000000', 'consum', 0.0226, 'lps'),
	(546683, 130, '2014-02-15 00:32:50.000000', 'consum', 0.0225, 'lps'),
	(546684, 130, '2014-02-15 00:32:51.000000', 'consum', 0.0219, 'lps'),
	(546685, 130, '2014-02-15 00:32:52.000000', 'consum', 0.0213, 'lps'),
	(546686, 130, '2014-02-15 00:32:53.000000', 'consum', 0.0215, 'lps'),
	(546687, 130, '2014-02-15 00:32:54.000000', 'consum', 0.0211, 'lps'),
	(546688, 130, '2014-02-15 00:32:55.000000', 'consum', 0.0216, 'lps'),
	(546689, 130, '2014-02-15 00:32:56.000000', 'consum', 0.0221, 'lps'),
	(546690, 130, '2014-02-15 00:32:57.000000', 'consum', 0.0212, 'lps'),
	(546691, 130, '2014-02-15 00:32:58.000000', 'consum', 0.0221, 'lps'),
	(546692, 130, '2014-02-15 00:32:59.000000', 'consum', 0.0210, 'lps'),
	(546693, 130, '2014-02-15 00:33:00.000000', 'consum', 0.0211, 'lps'),
	(546694, 130, '2014-02-15 00:33:01.000000', 'consum', 0.0216, 'lps'),
	(546695, 130, '2014-02-15 00:33:02.000000', 'consum', 0.0219, 'lps'),
	(546696, 130, '2014-02-15 00:33:03.000000', 'consum', 0.0221, 'lps'),
	(546697, 130, '2014-02-15 00:33:04.000000', 'consum', 0.0223, 'lps'),
	(546698, 130, '2014-02-15 00:33:05.000000', 'consum', 0.0223, 'lps'),
	(546699, 130, '2014-02-15 00:33:06.000000', 'consum', 0.0222, 'lps'),
	(546700, 130, '2014-02-15 00:33:07.000000', 'consum', 0.0213, 'lps'),
	(546701, 130, '2014-02-15 00:33:08.000000', 'consum', 0.0225, 'lps'),
	(546702, 130, '2014-02-15 00:33:09.000000', 'consum', 0.0225, 'lps'),
	(546703, 130, '2014-02-15 00:33:10.000000', 'consum', 0.0222, 'lps'),
	(546704, 130, '2014-02-15 00:33:11.000000', 'consum', 0.0226, 'lps'),
	(546705, 130, '2014-02-15 00:33:12.000000', 'consum', 0.0221, 'lps'),
	(546706, 130, '2014-02-15 00:33:13.000000', 'consum', 0.0216, 'lps'),
	(546707, 130, '2014-02-15 00:33:14.000000', 'consum', 0.0226, 'lps'),
	(546708, 130, '2014-02-15 00:33:15.000000', 'consum', 0.0223, 'lps'),
	(546709, 130, '2014-02-15 00:33:16.000000', 'consum', 0.0224, 'lps'),
	(546710, 130, '2014-02-15 00:33:17.000000', 'consum', 0.0211, 'lps'),
	(546711, 130, '2014-02-15 00:33:18.000000', 'consum', 0.0223, 'lps'),
	(546712, 130, '2014-02-15 00:33:19.000000', 'consum', 0.0221, 'lps'),
	(546713, 130, '2014-02-15 00:33:20.000000', 'consum', 0.0210, 'lps'),
	(546714, 130, '2014-02-15 00:33:21.000000', 'consum', 0.0213, 'lps'),
	(546715, 130, '2014-02-15 00:33:22.000000', 'consum', 0.0226, 'lps'),
	(546716, 130, '2014-02-15 00:33:23.000000', 'consum', 0.0212, 'lps'),
	(546717, 130, '2014-02-15 00:33:24.000000', 'consum', 0.0225, 'lps'),
	(546718, 130, '2014-02-15 00:33:25.000000', 'consum', 0.0211, 'lps'),
	(546719, 130, '2014-02-15 00:33:26.000000', 'consum', 0.0223, 'lps'),
	(546720, 130, '2014-02-15 00:33:27.000000', 'consum', 0.0221, 'lps'),
	(546721, 130, '2014-02-15 00:33:28.000000', 'consum', 0.0210, 'lps'),
	(546722, 130, '2014-02-15 00:33:29.000000', 'consum', 0.0226, 'lps'),
	(546723, 130, '2014-02-15 00:33:30.000000', 'consum', 0.0223, 'lps'),
	(546724, 130, '2014-02-15 00:33:31.000000', 'consum', 0.0211, 'lps'),
	(546725, 130, '2014-02-15 00:33:32.000000', 'consum', 0.0210, 'lps'),
	(546726, 130, '2014-02-15 00:33:33.000000', 'consum', 0.0226, 'lps'),
	(546727, 130, '2014-02-15 00:33:34.000000', 'consum', 0.0222, 'lps'),
	(546728, 130, '2014-02-15 00:33:35.000000', 'consum', 0.0220, 'lps'),
	(546729, 130, '2014-02-15 00:33:36.000000', 'consum', 0.0211, 'lps'),
	(546730, 130, '2014-02-15 00:33:37.000000', 'consum', 0.0218, 'lps'),
	(546731, 130, '2014-02-15 00:33:38.000000', 'consum', 0.0212, 'lps'),
	(546732, 130, '2014-02-15 00:33:39.000000', 'consum', 0.0213, 'lps'),
	(546733, 130, '2014-02-15 00:33:40.000000', 'consum', 0.0219, 'lps'),
	(546734, 130, '2014-02-15 00:33:41.000000', 'consum', 0.0216, 'lps'),
	(546735, 130, '2014-02-15 00:33:42.000000', 'consum', 0.0211, 'lps'),
	(546736, 130, '2014-02-15 00:33:43.000000', 'consum', 0.0214, 'lps'),
	(546737, 130, '2014-02-15 00:33:44.000000', 'consum', 0.0213, 'lps'),
	(546738, 130, '2014-02-15 00:33:45.000000', 'consum', 0.0212, 'lps'),
	(546739, 130, '2014-02-15 00:33:46.000000', 'consum', 0.0213, 'lps'),
	(546740, 130, '2014-02-15 00:33:47.000000', 'consum', 0.0216, 'lps'),
	(546741, 130, '2014-02-15 00:33:48.000000', 'consum', 0.0218, 'lps'),
	(546742, 130, '2014-02-15 00:33:49.000000', 'consum', 0.0215, 'lps'),
	(546743, 130, '2014-02-15 00:33:50.000000', 'consum', 0.0213, 'lps'),
	(546744, 130, '2014-02-15 00:33:51.000000', 'consum', 0.0226, 'lps'),
	(546745, 130, '2014-02-15 00:33:52.000000', 'consum', 0.0215, 'lps'),
	(546746, 130, '2014-02-15 00:33:53.000000', 'consum', 0.0219, 'lps'),
	(546747, 130, '2014-02-15 00:33:54.000000', 'consum', 0.0225, 'lps'),
	(546748, 130, '2014-02-15 00:33:55.000000', 'consum', 0.0224, 'lps'),
	(546749, 130, '2014-02-15 00:33:56.000000', 'consum', 0.0218, 'lps'),
	(546750, 130, '2014-02-15 00:33:57.000000', 'consum', 0.0211, 'lps'),
	(546751, 130, '2014-02-15 00:33:58.000000', 'consum', 0.0222, 'lps'),
	(546752, 130, '2014-02-15 00:33:59.000000', 'consum', 0.0218, 'lps'),
	(546753, 130, '2014-02-15 00:34:00.000000', 'consum', 0.0213, 'lps'),
	(546754, 130, '2014-02-15 00:34:01.000000', 'consum', 0.0220, 'lps'),
	(546755, 130, '2014-02-15 00:34:02.000000', 'consum', 0.0216, 'lps'),
	(546756, 130, '2014-02-15 00:34:03.000000', 'consum', 0.0210, 'lps'),
	(546757, 130, '2014-02-15 00:34:04.000000', 'consum', 0.0210, 'lps'),
	(546758, 130, '2014-02-15 00:34:05.000000', 'consum', 0.0212, 'lps'),
	(546759, 130, '2014-02-15 00:34:06.000000', 'consum', 0.0219, 'lps'),
	(546760, 130, '2014-02-15 00:34:07.000000', 'consum', 0.0215, 'lps'),
	(546761, 130, '2014-02-15 00:34:08.000000', 'consum', 0.0226, 'lps'),
	(546762, 130, '2014-02-15 00:34:09.000000', 'consum', 0.0224, 'lps'),
	(546763, 130, '2014-02-15 00:34:10.000000', 'consum', 0.0218, 'lps'),
	(546764, 130, '2014-02-15 00:34:11.000000', 'consum', 0.0224, 'lps'),
	(546765, 130, '2014-02-15 00:34:12.000000', 'consum', 0.0223, 'lps'),
	(546766, 130, '2014-02-15 00:34:13.000000', 'consum', 0.0214, 'lps'),
	(546767, 130, '2014-02-15 00:34:14.000000', 'consum', 0.0210, 'lps'),
	(546768, 130, '2014-02-15 00:34:15.000000', 'consum', 0.0217, 'lps'),
	(546769, 130, '2014-02-15 00:34:16.000000', 'consum', 0.0212, 'lps'),
	(546770, 130, '2014-02-15 00:34:17.000000', 'consum', 0.0215, 'lps'),
	(546771, 130, '2014-02-15 00:34:18.000000', 'consum', 0.0215, 'lps'),
	(546772, 130, '2014-02-15 00:34:19.000000', 'consum', 0.0218, 'lps'),
	(546773, 130, '2014-02-15 00:34:20.000000', 'consum', 0.0221, 'lps'),
	(546774, 130, '2014-02-15 00:34:21.000000', 'consum', 0.0224, 'lps'),
	(546775, 130, '2014-02-15 00:34:22.000000', 'consum', 0.0212, 'lps'),
	(546776, 130, '2014-02-15 00:34:23.000000', 'consum', 0.0214, 'lps'),
	(546777, 130, '2014-02-15 00:34:24.000000', 'consum', 0.0224, 'lps'),
	(546778, 130, '2014-02-15 00:34:25.000000', 'consum', 0.0216, 'lps'),
	(546779, 130, '2014-02-15 00:34:26.000000', 'consum', 0.0214, 'lps'),
	(546780, 130, '2014-02-15 00:34:27.000000', 'consum', 0.0216, 'lps'),
	(546781, 130, '2014-02-15 00:34:28.000000', 'consum', 0.0226, 'lps'),
	(546782, 130, '2014-02-15 00:34:29.000000', 'consum', 0.0224, 'lps'),
	(546783, 130, '2014-02-15 00:34:30.000000', 'consum', 0.0215, 'lps'),
	(546784, 130, '2014-02-15 00:34:31.000000', 'consum', 0.0212, 'lps'),
	(546785, 130, '2014-02-15 00:34:32.000000', 'consum', 0.0220, 'lps'),
	(546786, 130, '2014-02-15 00:34:33.000000', 'consum', 0.0222, 'lps'),
	(546787, 130, '2014-02-15 00:34:34.000000', 'consum', 0.0221, 'lps'),
	(546788, 130, '2014-02-15 00:34:35.000000', 'consum', 0.0214, 'lps'),
	(546789, 130, '2014-02-15 00:34:36.000000', 'consum', 0.0216, 'lps'),
	(546790, 130, '2014-02-15 00:34:37.000000', 'consum', 0.0212, 'lps'),
	(546791, 130, '2014-02-15 00:34:38.000000', 'consum', 0.0220, 'lps'),
	(546792, 130, '2014-02-15 00:34:39.000000', 'consum', 0.0218, 'lps'),
	(546793, 130, '2014-02-15 00:34:40.000000', 'consum', 0.0222, 'lps'),
	(546794, 130, '2014-02-15 00:34:41.000000', 'consum', 0.0211, 'lps'),
	(546795, 130, '2014-02-15 00:34:42.000000', 'consum', 0.0214, 'lps'),
	(546796, 130, '2014-02-15 00:34:43.000000', 'consum', 0.0211, 'lps'),
	(546797, 130, '2014-02-15 00:34:44.000000', 'consum', 0.0222, 'lps'),
	(546798, 130, '2014-02-15 00:34:45.000000', 'consum', 0.0217, 'lps'),
	(546799, 130, '2014-02-15 00:34:46.000000', 'consum', 0.0224, 'lps'),
	(546800, 130, '2014-02-15 00:34:47.000000', 'consum', 0.0226, 'lps'),
	(546801, 130, '2014-02-15 00:34:48.000000', 'consum', 0.0213, 'lps'),
	(546802, 130, '2014-02-15 00:34:49.000000', 'consum', 0.0214, 'lps'),
	(546803, 130, '2014-02-15 00:34:50.000000', 'consum', 0.0220, 'lps'),
	(546804, 130, '2014-02-15 00:34:51.000000', 'consum', 0.0216, 'lps'),
	(546805, 130, '2014-02-15 00:34:52.000000', 'consum', 0.0211, 'lps'),
	(546806, 130, '2014-02-15 00:34:53.000000', 'consum', 0.0214, 'lps'),
	(546807, 130, '2014-02-15 00:34:54.000000', 'consum', 0.0212, 'lps'),
	(546808, 130, '2014-02-15 00:34:55.000000', 'consum', 0.0223, 'lps'),
	(546809, 130, '2014-02-15 00:34:56.000000', 'consum', 0.0219, 'lps'),
	(546810, 130, '2014-02-15 00:34:57.000000', 'consum', 0.0219, 'lps'),
	(546811, 130, '2014-02-15 00:34:58.000000', 'consum', 0.0226, 'lps'),
	(546812, 130, '2014-02-15 00:34:59.000000', 'consum', 0.0215, 'lps'),
	(546813, 130, '2014-02-15 00:35:00.000000', 'consum', 0.0221, 'lps'),
	(546814, 130, '2014-02-15 00:35:01.000000', 'consum', 0.0217, 'lps'),
	(546815, 130, '2014-02-15 00:35:02.000000', 'consum', 0.0212, 'lps'),
	(546816, 130, '2014-02-15 00:35:03.000000', 'consum', 0.0218, 'lps'),
	(546817, 130, '2014-02-15 00:35:04.000000', 'consum', 0.0225, 'lps'),
	(546818, 130, '2014-02-15 00:35:05.000000', 'consum', 0.0210, 'lps'),
	(546819, 130, '2014-02-15 00:35:06.000000', 'consum', 0.0216, 'lps'),
	(546820, 130, '2014-02-15 00:35:07.000000', 'consum', 0.0224, 'lps'),
	(546821, 130, '2014-02-15 00:35:08.000000', 'consum', 0.0210, 'lps'),
	(546822, 130, '2014-02-15 00:35:09.000000', 'consum', 0.0220, 'lps'),
	(546823, 130, '2014-02-15 00:35:10.000000', 'consum', 0.0211, 'lps'),
	(546824, 130, '2014-02-15 00:35:11.000000', 'consum', 0.0218, 'lps'),
	(546825, 130, '2014-02-15 00:35:12.000000', 'consum', 0.0212, 'lps'),
	(546826, 130, '2014-02-15 00:35:13.000000', 'consum', 0.0217, 'lps'),
	(546827, 130, '2014-02-15 00:35:14.000000', 'consum', 0.0221, 'lps'),
	(546828, 130, '2014-02-15 00:35:15.000000', 'consum', 0.0212, 'lps'),
	(546829, 130, '2014-02-15 00:35:16.000000', 'consum', 0.0220, 'lps'),
	(546830, 130, '2014-02-15 00:35:17.000000', 'consum', 0.0219, 'lps'),
	(546831, 130, '2014-02-15 00:35:18.000000', 'consum', 0.0211, 'lps'),
	(546832, 130, '2014-02-15 00:35:19.000000', 'consum', 0.0223, 'lps'),
	(546833, 130, '2014-02-15 00:35:20.000000', 'consum', 0.0222, 'lps'),
	(546834, 130, '2014-02-15 00:35:21.000000', 'consum', 0.0213, 'lps'),
	(546835, 130, '2014-02-15 00:35:22.000000', 'consum', 0.0222, 'lps'),
	(546836, 130, '2014-02-15 00:35:23.000000', 'consum', 0.0213, 'lps'),
	(546837, 130, '2014-02-15 00:35:24.000000', 'consum', 0.0222, 'lps'),
	(546838, 130, '2014-02-15 00:35:25.000000', 'consum', 0.0210, 'lps'),
	(546839, 130, '2014-02-15 00:35:26.000000', 'consum', 0.0210, 'lps'),
	(546840, 130, '2014-02-15 00:35:27.000000', 'consum', 0.0225, 'lps'),
	(546841, 130, '2014-02-15 00:35:28.000000', 'consum', 0.0221, 'lps'),
	(546842, 130, '2014-02-15 00:35:29.000000', 'consum', 0.0218, 'lps'),
	(546843, 130, '2014-02-15 00:35:30.000000', 'consum', 0.0218, 'lps'),
	(546844, 130, '2014-02-15 00:35:31.000000', 'consum', 0.0225, 'lps'),
	(546845, 130, '2014-02-15 00:35:32.000000', 'consum', 0.0212, 'lps'),
	(546846, 130, '2014-02-15 00:35:33.000000', 'consum', 0.0224, 'lps'),
	(546847, 130, '2014-02-15 00:35:34.000000', 'consum', 0.0210, 'lps'),
	(546848, 130, '2014-02-15 00:35:35.000000', 'consum', 0.0219, 'lps'),
	(546849, 130, '2014-02-15 00:35:36.000000', 'consum', 0.0219, 'lps'),
	(546850, 130, '2014-02-15 00:35:37.000000', 'consum', 0.0212, 'lps'),
	(546851, 130, '2014-02-15 00:35:38.000000', 'consum', 0.0210, 'lps'),
	(546852, 130, '2014-02-15 00:35:39.000000', 'consum', 0.0224, 'lps'),
	(546853, 130, '2014-02-15 00:35:40.000000', 'consum', 0.0210, 'lps'),
	(546854, 130, '2014-02-15 00:35:41.000000', 'consum', 0.0219, 'lps'),
	(546855, 130, '2014-02-15 00:35:42.000000', 'consum', 0.0220, 'lps'),
	(546856, 130, '2014-02-15 00:35:43.000000', 'consum', 0.0220, 'lps'),
	(546857, 130, '2014-02-15 00:35:44.000000', 'consum', 0.0213, 'lps'),
	(546858, 130, '2014-02-15 00:35:45.000000', 'consum', 0.0211, 'lps'),
	(546859, 130, '2014-02-15 00:35:46.000000', 'consum', 0.0225, 'lps'),
	(546860, 130, '2014-02-15 00:35:47.000000', 'consum', 0.0215, 'lps'),
	(546861, 130, '2014-02-15 00:35:48.000000', 'consum', 0.0224, 'lps'),
	(546862, 130, '2014-02-15 00:35:49.000000', 'consum', 0.0215, 'lps'),
	(546863, 130, '2014-02-15 00:35:50.000000', 'consum', 0.0225, 'lps'),
	(546864, 130, '2014-02-15 00:35:51.000000', 'consum', 0.0223, 'lps'),
	(546865, 130, '2014-02-15 00:35:52.000000', 'consum', 0.0211, 'lps'),
	(546866, 130, '2014-02-15 00:35:53.000000', 'consum', 0.0213, 'lps'),
	(546867, 130, '2014-02-15 00:35:54.000000', 'consum', 0.0221, 'lps'),
	(546868, 130, '2014-02-15 00:35:55.000000', 'consum', 0.0223, 'lps'),
	(546869, 130, '2014-02-15 00:35:56.000000', 'consum', 0.0225, 'lps'),
	(546870, 130, '2014-02-15 00:35:57.000000', 'consum', 0.0213, 'lps'),
	(546871, 130, '2014-02-15 00:35:58.000000', 'consum', 0.0213, 'lps'),
	(546872, 130, '2014-02-15 00:35:59.000000', 'consum', 0.0217, 'lps'),
	(546873, 130, '2014-02-15 00:36:00.000000', 'consum', 0.0220, 'lps'),
	(546874, 130, '2014-02-15 00:36:01.000000', 'consum', 0.0221, 'lps'),
	(546875, 130, '2014-02-15 00:36:02.000000', 'consum', 0.0220, 'lps'),
	(546876, 130, '2014-02-15 00:36:03.000000', 'consum', 0.0210, 'lps'),
	(546877, 130, '2014-02-15 00:36:04.000000', 'consum', 0.0215, 'lps'),
	(546878, 130, '2014-02-15 00:36:05.000000', 'consum', 0.0220, 'lps'),
	(546879, 130, '2014-02-15 00:36:06.000000', 'consum', 0.0225, 'lps'),
	(546880, 130, '2014-02-15 00:36:07.000000', 'consum', 0.0224, 'lps'),
	(546881, 130, '2014-02-15 00:36:08.000000', 'consum', 0.0218, 'lps'),
	(546882, 130, '2014-02-15 00:36:09.000000', 'consum', 0.0226, 'lps'),
	(546883, 130, '2014-02-15 00:36:10.000000', 'consum', 0.0215, 'lps'),
	(546884, 130, '2014-02-15 00:36:11.000000', 'consum', 0.0223, 'lps'),
	(546885, 130, '2014-02-15 00:36:12.000000', 'consum', 0.0211, 'lps'),
	(546886, 130, '2014-02-15 00:36:13.000000', 'consum', 0.0224, 'lps'),
	(546887, 130, '2014-02-15 00:36:14.000000', 'consum', 0.0226, 'lps'),
	(546888, 130, '2014-02-15 00:36:15.000000', 'consum', 0.0217, 'lps'),
	(546889, 130, '2014-02-15 00:36:16.000000', 'consum', 0.0215, 'lps'),
	(546890, 130, '2014-02-15 00:36:17.000000', 'consum', 0.0212, 'lps'),
	(546891, 130, '2014-02-15 00:36:18.000000', 'consum', 0.0222, 'lps'),
	(546892, 130, '2014-02-15 00:36:19.000000', 'consum', 0.0216, 'lps'),
	(546893, 130, '2014-02-15 00:36:20.000000', 'consum', 0.0219, 'lps'),
	(546894, 130, '2014-02-15 00:36:21.000000', 'consum', 0.0223, 'lps'),
	(546895, 130, '2014-02-15 00:36:22.000000', 'consum', 0.0214, 'lps'),
	(546896, 130, '2014-02-15 00:36:23.000000', 'consum', 0.0224, 'lps'),
	(546897, 130, '2014-02-15 00:36:24.000000', 'consum', 0.0218, 'lps'),
	(546898, 130, '2014-02-15 00:36:25.000000', 'consum', 0.0224, 'lps'),
	(546899, 130, '2014-02-15 00:36:26.000000', 'consum', 0.0224, 'lps'),
	(546900, 130, '2014-02-15 00:36:27.000000', 'consum', 0.0221, 'lps'),
	(546901, 130, '2014-02-15 00:36:28.000000', 'consum', 0.0224, 'lps'),
	(546902, 130, '2014-02-15 00:36:29.000000', 'consum', 0.0213, 'lps'),
	(546903, 130, '2014-02-15 00:36:30.000000', 'consum', 0.0217, 'lps'),
	(546904, 130, '2014-02-15 00:36:31.000000', 'consum', 0.0218, 'lps'),
	(546905, 130, '2014-02-15 00:36:32.000000', 'consum', 0.0215, 'lps'),
	(546906, 130, '2014-02-15 00:36:33.000000', 'consum', 0.0212, 'lps'),
	(546907, 130, '2014-02-15 00:36:34.000000', 'consum', 0.0223, 'lps'),
	(546908, 130, '2014-02-15 00:36:35.000000', 'consum', 0.0216, 'lps'),
	(546909, 130, '2014-02-15 00:36:36.000000', 'consum', 0.0218, 'lps'),
	(546910, 130, '2014-02-15 00:36:37.000000', 'consum', 0.0215, 'lps'),
	(546911, 130, '2014-02-15 00:36:38.000000', 'consum', 0.0213, 'lps'),
	(546912, 130, '2014-02-15 00:36:39.000000', 'consum', 0.0226, 'lps'),
	(546913, 130, '2014-02-15 00:36:40.000000', 'consum', 0.0214, 'lps'),
	(546914, 130, '2014-02-15 00:36:41.000000', 'consum', 0.0218, 'lps'),
	(546915, 130, '2014-02-15 00:36:42.000000', 'consum', 0.0222, 'lps'),
	(546916, 130, '2014-02-15 00:36:43.000000', 'consum', 0.0210, 'lps'),
	(546917, 130, '2014-02-15 00:36:44.000000', 'consum', 0.0210, 'lps'),
	(546918, 130, '2014-02-15 00:36:45.000000', 'consum', 0.0210, 'lps'),
	(546919, 130, '2014-02-15 00:36:46.000000', 'consum', 0.0226, 'lps'),
	(546920, 130, '2014-02-15 00:36:47.000000', 'consum', 0.0222, 'lps'),
	(546921, 130, '2014-02-15 00:36:48.000000', 'consum', 0.0225, 'lps'),
	(546922, 130, '2014-02-15 00:36:49.000000', 'consum', 0.0216, 'lps'),
	(546923, 130, '2014-02-15 00:36:50.000000', 'consum', 0.0211, 'lps'),
	(546924, 130, '2014-02-15 00:36:51.000000', 'consum', 0.0213, 'lps'),
	(546925, 130, '2014-02-15 00:36:52.000000', 'consum', 0.0226, 'lps'),
	(546926, 130, '2014-02-15 00:36:53.000000', 'consum', 0.0210, 'lps'),
	(546927, 130, '2014-02-15 00:36:54.000000', 'consum', 0.0216, 'lps'),
	(546928, 130, '2014-02-15 00:36:55.000000', 'consum', 0.0223, 'lps'),
	(546929, 130, '2014-02-15 00:36:56.000000', 'consum', 0.0224, 'lps'),
	(546930, 130, '2014-02-15 00:36:57.000000', 'consum', 0.0226, 'lps'),
	(546931, 130, '2014-02-15 00:36:58.000000', 'consum', 0.0214, 'lps'),
	(546932, 130, '2014-02-15 00:36:59.000000', 'consum', 0.0215, 'lps'),
	(546933, 130, '2014-02-15 00:37:00.000000', 'consum', 0.0222, 'lps'),
	(546934, 130, '2014-02-15 00:37:01.000000', 'consum', 0.0225, 'lps'),
	(546935, 130, '2014-02-15 00:37:02.000000', 'consum', 0.0212, 'lps'),
	(546936, 130, '2014-02-15 00:37:03.000000', 'consum', 0.0212, 'lps'),
	(546937, 130, '2014-02-15 00:37:04.000000', 'consum', 0.0212, 'lps'),
	(546938, 130, '2014-02-15 00:37:05.000000', 'consum', 0.0217, 'lps'),
	(546939, 130, '2014-02-15 00:37:06.000000', 'consum', 0.0221, 'lps'),
	(546940, 130, '2014-02-15 00:37:07.000000', 'consum', 0.0211, 'lps'),
	(546941, 130, '2014-02-15 00:37:08.000000', 'consum', 0.0217, 'lps'),
	(546942, 130, '2014-02-15 00:37:09.000000', 'consum', 0.0226, 'lps'),
	(546943, 130, '2014-02-15 00:37:10.000000', 'consum', 0.0217, 'lps'),
	(546944, 130, '2014-02-15 00:37:11.000000', 'consum', 0.0214, 'lps'),
	(546945, 130, '2014-02-15 00:37:12.000000', 'consum', 0.0210, 'lps'),
	(546946, 130, '2014-02-15 00:37:13.000000', 'consum', 0.0217, 'lps'),
	(546947, 130, '2014-02-15 00:37:14.000000', 'consum', 0.0212, 'lps'),
	(546948, 130, '2014-02-15 00:37:15.000000', 'consum', 0.0217, 'lps'),
	(546949, 130, '2014-02-15 00:37:16.000000', 'consum', 0.0222, 'lps'),
	(546950, 130, '2014-02-15 00:37:17.000000', 'consum', 0.0214, 'lps'),
	(546951, 130, '2014-02-15 00:37:18.000000', 'consum', 0.0210, 'lps'),
	(546952, 130, '2014-02-15 00:37:19.000000', 'consum', 0.0218, 'lps'),
	(546953, 130, '2014-02-15 00:37:20.000000', 'consum', 0.0215, 'lps'),
	(546954, 130, '2014-02-15 00:37:21.000000', 'consum', 0.0210, 'lps'),
	(546955, 130, '2014-02-15 00:37:22.000000', 'consum', 0.0216, 'lps'),
	(546956, 130, '2014-02-15 00:37:23.000000', 'consum', 0.0221, 'lps'),
	(546957, 130, '2014-02-15 00:37:24.000000', 'consum', 0.0214, 'lps'),
	(546958, 130, '2014-02-15 00:37:25.000000', 'consum', 0.0215, 'lps'),
	(546959, 130, '2014-02-15 00:37:26.000000', 'consum', 0.0222, 'lps'),
	(546960, 130, '2014-02-15 00:37:27.000000', 'consum', 0.0222, 'lps'),
	(546961, 130, '2014-02-15 00:37:28.000000', 'consum', 0.0216, 'lps'),
	(546962, 130, '2014-02-15 00:37:29.000000', 'consum', 0.0224, 'lps'),
	(546963, 130, '2014-02-15 00:37:30.000000', 'consum', 0.0211, 'lps'),
	(546964, 130, '2014-02-15 00:37:31.000000', 'consum', 0.0225, 'lps'),
	(546965, 130, '2014-02-15 00:37:32.000000', 'consum', 0.0213, 'lps'),
	(546966, 130, '2014-02-15 00:37:33.000000', 'consum', 0.0216, 'lps'),
	(546967, 130, '2014-02-15 00:37:34.000000', 'consum', 0.0215, 'lps'),
	(546968, 130, '2014-02-15 00:37:35.000000', 'consum', 0.0217, 'lps'),
	(546969, 130, '2014-02-15 00:37:36.000000', 'consum', 0.0215, 'lps'),
	(546970, 130, '2014-02-15 00:37:37.000000', 'consum', 0.0212, 'lps'),
	(546971, 130, '2014-02-15 00:37:38.000000', 'consum', 0.0224, 'lps'),
	(546972, 130, '2014-02-15 00:37:39.000000', 'consum', 0.0225, 'lps'),
	(546973, 130, '2014-02-15 00:37:40.000000', 'consum', 0.0226, 'lps'),
	(546974, 130, '2014-02-15 00:37:41.000000', 'consum', 0.0226, 'lps'),
	(546975, 130, '2014-02-15 00:37:42.000000', 'consum', 0.0210, 'lps'),
	(546976, 130, '2014-02-15 00:37:43.000000', 'consum', 0.0216, 'lps'),
	(546977, 130, '2014-02-15 00:37:44.000000', 'consum', 0.0220, 'lps'),
	(546978, 130, '2014-02-15 00:37:45.000000', 'consum', 0.0225, 'lps'),
	(546979, 130, '2014-02-15 00:37:46.000000', 'consum', 0.0224, 'lps'),
	(546980, 130, '2014-02-15 00:37:47.000000', 'consum', 0.0218, 'lps'),
	(546981, 130, '2014-02-15 00:37:48.000000', 'consum', 0.0224, 'lps'),
	(546982, 130, '2014-02-15 00:37:49.000000', 'consum', 0.0225, 'lps'),
	(546983, 130, '2014-02-15 00:37:50.000000', 'consum', 0.0210, 'lps'),
	(546984, 130, '2014-02-15 00:37:51.000000', 'consum', 0.0215, 'lps'),
	(546985, 130, '2014-02-15 00:37:52.000000', 'consum', 0.0217, 'lps'),
	(546986, 130, '2014-02-15 00:37:53.000000', 'consum', 0.0217, 'lps'),
	(546987, 130, '2014-02-15 00:37:54.000000', 'consum', 0.0222, 'lps'),
	(546988, 130, '2014-02-15 00:37:55.000000', 'consum', 0.0215, 'lps'),
	(546989, 130, '2014-02-15 00:37:56.000000', 'consum', 0.0218, 'lps'),
	(546990, 130, '2014-02-15 00:37:57.000000', 'consum', 0.0218, 'lps'),
	(546991, 130, '2014-02-15 00:37:58.000000', 'consum', 0.0226, 'lps'),
	(546992, 130, '2014-02-15 00:37:59.000000', 'consum', 0.0215, 'lps'),
	(546993, 130, '2014-02-15 00:38:00.000000', 'consum', 0.0224, 'lps'),
	(546994, 130, '2014-02-15 00:38:01.000000', 'consum', 0.0213, 'lps'),
	(546995, 130, '2014-02-15 00:38:02.000000', 'consum', 0.0218, 'lps'),
	(546996, 130, '2014-02-15 00:38:03.000000', 'consum', 0.0225, 'lps'),
	(546997, 130, '2014-02-15 00:38:04.000000', 'consum', 0.0210, 'lps'),
	(546998, 130, '2014-02-15 00:38:05.000000', 'consum', 0.0217, 'lps'),
	(546999, 130, '2014-02-15 00:38:06.000000', 'consum', 0.0211, 'lps'),
	(547000, 130, '2014-02-15 00:38:07.000000', 'consum', 0.0212, 'lps'),
	(547001, 130, '2014-02-15 00:38:08.000000', 'consum', 0.0218, 'lps'),
	(547002, 130, '2014-02-15 00:38:09.000000', 'consum', 0.0211, 'lps'),
	(547003, 130, '2014-02-15 00:38:10.000000', 'consum', 0.0223, 'lps'),
	(547004, 130, '2014-02-15 00:38:11.000000', 'consum', 0.0222, 'lps'),
	(547005, 130, '2014-02-15 00:38:12.000000', 'consum', 0.0215, 'lps'),
	(547006, 130, '2014-02-15 00:38:13.000000', 'consum', 0.0218, 'lps'),
	(547007, 130, '2014-02-15 00:38:14.000000', 'consum', 0.0216, 'lps'),
	(547008, 130, '2014-02-15 00:38:15.000000', 'consum', 0.0218, 'lps'),
	(547009, 130, '2014-02-15 00:38:16.000000', 'consum', 0.0216, 'lps'),
	(547010, 130, '2014-02-15 00:38:17.000000', 'consum', 0.0216, 'lps'),
	(547011, 130, '2014-02-15 00:38:18.000000', 'consum', 0.0222, 'lps'),
	(547012, 130, '2014-02-15 00:38:19.000000', 'consum', 0.0218, 'lps'),
	(547013, 130, '2014-02-15 00:38:20.000000', 'consum', 0.0217, 'lps'),
	(547014, 130, '2014-02-15 00:38:21.000000', 'consum', 0.0218, 'lps'),
	(547015, 130, '2014-02-15 00:38:22.000000', 'consum', 0.0216, 'lps'),
	(547016, 130, '2014-02-15 00:38:23.000000', 'consum', 0.0215, 'lps'),
	(547017, 130, '2014-02-15 00:38:24.000000', 'consum', 0.0216, 'lps'),
	(547018, 130, '2014-02-15 00:38:25.000000', 'consum', 0.0211, 'lps'),
	(547019, 130, '2014-02-15 00:38:26.000000', 'consum', 0.0212, 'lps'),
	(547020, 130, '2014-02-15 00:38:27.000000', 'consum', 0.0217, 'lps'),
	(547021, 130, '2014-02-15 00:38:28.000000', 'consum', 0.0224, 'lps'),
	(547022, 130, '2014-02-15 00:38:29.000000', 'consum', 0.0226, 'lps'),
	(547023, 130, '2014-02-15 00:38:30.000000', 'consum', 0.0215, 'lps'),
	(547024, 130, '2014-02-15 00:38:31.000000', 'consum', 0.0219, 'lps'),
	(547025, 130, '2014-02-15 00:38:32.000000', 'consum', 0.0226, 'lps'),
	(547026, 130, '2014-02-15 00:38:33.000000', 'consum', 0.0210, 'lps'),
	(547027, 130, '2014-02-15 00:38:34.000000', 'consum', 0.0213, 'lps'),
	(547028, 130, '2014-02-15 00:38:35.000000', 'consum', 0.0211, 'lps'),
	(547029, 130, '2014-02-15 00:38:36.000000', 'consum', 0.0221, 'lps'),
	(547030, 130, '2014-02-15 00:38:37.000000', 'consum', 0.0212, 'lps'),
	(547031, 130, '2014-02-15 00:38:38.000000', 'consum', 0.0222, 'lps'),
	(547032, 130, '2014-02-15 00:38:39.000000', 'consum', 0.0216, 'lps'),
	(547033, 130, '2014-02-15 00:38:40.000000', 'consum', 0.0218, 'lps'),
	(547034, 130, '2014-02-15 00:38:41.000000', 'consum', 0.0216, 'lps'),
	(547035, 130, '2014-02-15 00:38:42.000000', 'consum', 0.0216, 'lps'),
	(547036, 130, '2014-02-15 00:38:43.000000', 'consum', 0.0224, 'lps'),
	(547037, 130, '2014-02-15 00:38:44.000000', 'consum', 0.0212, 'lps'),
	(547038, 130, '2014-02-15 00:38:45.000000', 'consum', 0.0213, 'lps'),
	(547039, 130, '2014-02-15 00:38:46.000000', 'consum', 0.0220, 'lps'),
	(547040, 130, '2014-02-15 00:38:47.000000', 'consum', 0.0215, 'lps'),
	(547041, 130, '2014-02-15 00:38:48.000000', 'consum', 0.0224, 'lps'),
	(547042, 130, '2014-02-15 00:38:49.000000', 'consum', 0.0214, 'lps'),
	(547043, 130, '2014-02-15 00:38:50.000000', 'consum', 0.0222, 'lps'),
	(547044, 130, '2014-02-15 00:38:51.000000', 'consum', 0.0224, 'lps'),
	(547045, 130, '2014-02-15 00:38:52.000000', 'consum', 0.0210, 'lps'),
	(547046, 130, '2014-02-15 00:38:53.000000', 'consum', 0.0221, 'lps'),
	(547047, 130, '2014-02-15 00:38:54.000000', 'consum', 0.0214, 'lps'),
	(547048, 130, '2014-02-15 00:38:55.000000', 'consum', 0.0214, 'lps'),
	(547049, 130, '2014-02-15 00:38:56.000000', 'consum', 0.0220, 'lps'),
	(547050, 130, '2014-02-15 00:38:57.000000', 'consum', 0.0215, 'lps'),
	(547051, 130, '2014-02-15 00:38:58.000000', 'consum', 0.0219, 'lps'),
	(547052, 130, '2014-02-15 00:38:59.000000', 'consum', 0.0210, 'lps'),
	(547053, 130, '2014-02-15 00:39:00.000000', 'consum', 0.0218, 'lps'),
	(547054, 130, '2014-02-15 00:39:01.000000', 'consum', 0.0215, 'lps'),
	(547055, 130, '2014-02-15 00:39:02.000000', 'consum', 0.0210, 'lps'),
	(547056, 130, '2014-02-15 00:39:03.000000', 'consum', 0.0214, 'lps'),
	(547057, 130, '2014-02-15 00:39:04.000000', 'consum', 0.0214, 'lps'),
	(547058, 130, '2014-02-15 00:39:05.000000', 'consum', 0.0216, 'lps'),
	(547059, 130, '2014-02-15 00:39:06.000000', 'consum', 0.0215, 'lps'),
	(547060, 130, '2014-02-15 00:39:07.000000', 'consum', 0.0216, 'lps'),
	(547061, 130, '2014-02-15 00:39:08.000000', 'consum', 0.0226, 'lps'),
	(547062, 130, '2014-02-15 00:39:09.000000', 'consum', 0.0223, 'lps'),
	(547063, 130, '2014-02-15 00:39:10.000000', 'consum', 0.0225, 'lps'),
	(547064, 130, '2014-02-15 00:39:11.000000', 'consum', 0.0211, 'lps'),
	(547065, 130, '2014-02-15 00:39:12.000000', 'consum', 0.0225, 'lps'),
	(547066, 130, '2014-02-15 00:39:13.000000', 'consum', 0.0214, 'lps'),
	(547067, 130, '2014-02-15 00:39:14.000000', 'consum', 0.0220, 'lps'),
	(547068, 130, '2014-02-15 00:39:15.000000', 'consum', 0.0215, 'lps'),
	(547069, 130, '2014-02-15 00:39:16.000000', 'consum', 0.0223, 'lps'),
	(547070, 130, '2014-02-15 00:39:17.000000', 'consum', 0.0226, 'lps'),
	(547071, 130, '2014-02-15 00:39:18.000000', 'consum', 0.0216, 'lps'),
	(547072, 130, '2014-02-15 00:39:19.000000', 'consum', 0.0212, 'lps'),
	(547073, 130, '2014-02-15 00:39:20.000000', 'consum', 0.0218, 'lps'),
	(547074, 130, '2014-02-15 00:39:21.000000', 'consum', 0.0210, 'lps'),
	(547075, 130, '2014-02-15 00:39:22.000000', 'consum', 0.0221, 'lps'),
	(547076, 130, '2014-02-15 00:39:23.000000', 'consum', 0.0214, 'lps'),
	(547077, 130, '2014-02-15 00:39:24.000000', 'consum', 0.0213, 'lps'),
	(547078, 130, '2014-02-15 00:39:25.000000', 'consum', 0.0214, 'lps'),
	(547079, 130, '2014-02-15 00:39:26.000000', 'consum', 0.0222, 'lps'),
	(547080, 130, '2014-02-15 00:39:27.000000', 'consum', 0.0225, 'lps'),
	(547081, 130, '2014-02-15 00:39:28.000000', 'consum', 0.0214, 'lps'),
	(547082, 130, '2014-02-15 00:39:29.000000', 'consum', 0.0220, 'lps'),
	(547083, 130, '2014-02-15 00:39:30.000000', 'consum', 0.0214, 'lps'),
	(547084, 130, '2014-02-15 00:39:31.000000', 'consum', 0.0220, 'lps'),
	(547085, 130, '2014-02-15 00:39:32.000000', 'consum', 0.0212, 'lps'),
	(547086, 130, '2014-02-15 00:39:33.000000', 'consum', 0.0225, 'lps'),
	(547087, 130, '2014-02-15 00:39:34.000000', 'consum', 0.0210, 'lps'),
	(547088, 130, '2014-02-15 00:39:35.000000', 'consum', 0.0219, 'lps'),
	(547089, 130, '2014-02-15 00:39:36.000000', 'consum', 0.0222, 'lps'),
	(547090, 130, '2014-02-15 00:39:37.000000', 'consum', 0.0225, 'lps'),
	(547091, 130, '2014-02-15 00:39:38.000000', 'consum', 0.0218, 'lps'),
	(547092, 130, '2014-02-15 00:39:39.000000', 'consum', 0.0220, 'lps'),
	(547093, 130, '2014-02-15 00:39:40.000000', 'consum', 0.0219, 'lps'),
	(547094, 130, '2014-02-15 00:39:41.000000', 'consum', 0.0210, 'lps'),
	(547095, 130, '2014-02-15 00:39:42.000000', 'consum', 0.0218, 'lps'),
	(547096, 130, '2014-02-15 00:39:43.000000', 'consum', 0.0216, 'lps'),
	(547097, 130, '2014-02-15 00:39:44.000000', 'consum', 0.0217, 'lps'),
	(547098, 130, '2014-02-15 00:39:45.000000', 'consum', 0.0210, 'lps'),
	(547099, 130, '2014-02-15 00:39:46.000000', 'consum', 0.0222, 'lps'),
	(547100, 130, '2014-02-15 00:39:47.000000', 'consum', 0.0220, 'lps'),
	(547101, 130, '2014-02-15 00:39:48.000000', 'consum', 0.0226, 'lps'),
	(547102, 130, '2014-02-15 00:39:49.000000', 'consum', 0.0210, 'lps'),
	(547103, 130, '2014-02-15 00:39:50.000000', 'consum', 0.0212, 'lps'),
	(547104, 130, '2014-02-15 00:39:51.000000', 'consum', 0.0221, 'lps'),
	(547105, 130, '2014-02-15 00:39:52.000000', 'consum', 0.0226, 'lps'),
	(547106, 130, '2014-02-15 00:39:53.000000', 'consum', 0.0222, 'lps'),
	(547107, 130, '2014-02-15 00:39:54.000000', 'consum', 0.0223, 'lps'),
	(547108, 130, '2014-02-15 00:39:55.000000', 'consum', 0.0222, 'lps'),
	(547109, 130, '2014-02-15 00:39:56.000000', 'consum', 0.0217, 'lps'),
	(547110, 130, '2014-02-15 00:39:57.000000', 'consum', 0.0225, 'lps'),
	(547111, 130, '2014-02-15 00:39:58.000000', 'consum', 0.0215, 'lps'),
	(547112, 130, '2014-02-15 00:39:59.000000', 'consum', 0.0226, 'lps'),
	(547113, 130, '2014-02-15 00:40:00.000000', 'consum', 0.0221, 'lps'),
	(547114, 130, '2014-02-15 00:40:01.000000', 'consum', 0.0218, 'lps'),
	(547115, 130, '2014-02-15 00:40:02.000000', 'consum', 0.0220, 'lps'),
	(547116, 130, '2014-02-15 00:40:03.000000', 'consum', 0.0218, 'lps'),
	(547117, 130, '2014-02-15 00:40:04.000000', 'consum', 0.0221, 'lps'),
	(547118, 130, '2014-02-15 00:40:05.000000', 'consum', 0.0223, 'lps'),
	(547119, 130, '2014-02-15 00:40:06.000000', 'consum', 0.0210, 'lps'),
	(547120, 130, '2014-02-15 00:40:07.000000', 'consum', 0.0223, 'lps'),
	(547121, 130, '2014-02-15 00:40:08.000000', 'consum', 0.0225, 'lps'),
	(547122, 130, '2014-02-15 00:40:09.000000', 'consum', 0.0211, 'lps'),
	(547123, 130, '2014-02-15 00:40:10.000000', 'consum', 0.0223, 'lps'),
	(547124, 130, '2014-02-15 00:40:11.000000', 'consum', 0.0222, 'lps'),
	(547125, 130, '2014-02-15 00:40:12.000000', 'consum', 0.0213, 'lps'),
	(547126, 130, '2014-02-15 00:40:13.000000', 'consum', 0.0225, 'lps'),
	(547127, 130, '2014-02-15 00:40:14.000000', 'consum', 0.0226, 'lps'),
	(547128, 130, '2014-02-15 00:40:15.000000', 'consum', 0.0210, 'lps'),
	(547129, 130, '2014-02-15 00:40:16.000000', 'consum', 0.0215, 'lps'),
	(547130, 130, '2014-02-15 00:40:17.000000', 'consum', 0.0216, 'lps'),
	(547131, 130, '2014-02-15 00:40:18.000000', 'consum', 0.0226, 'lps'),
	(547132, 130, '2014-02-15 00:40:19.000000', 'consum', 0.0224, 'lps'),
	(547133, 130, '2014-02-15 00:40:20.000000', 'consum', 0.0213, 'lps'),
	(547134, 130, '2014-02-15 00:40:21.000000', 'consum', 0.0219, 'lps'),
	(547135, 130, '2014-02-15 00:40:22.000000', 'consum', 0.0213, 'lps'),
	(547136, 130, '2014-02-15 00:40:23.000000', 'consum', 0.0213, 'lps'),
	(547137, 130, '2014-02-15 00:40:24.000000', 'consum', 0.0219, 'lps'),
	(547138, 130, '2014-02-15 00:40:25.000000', 'consum', 0.0213, 'lps'),
	(547139, 130, '2014-02-15 00:40:26.000000', 'consum', 0.0216, 'lps'),
	(547140, 130, '2014-02-15 00:40:27.000000', 'consum', 0.0214, 'lps'),
	(547141, 130, '2014-02-15 00:40:28.000000', 'consum', 0.0212, 'lps'),
	(547142, 130, '2014-02-15 00:40:29.000000', 'consum', 0.0224, 'lps'),
	(547143, 130, '2014-02-15 00:40:30.000000', 'consum', 0.0223, 'lps'),
	(547144, 130, '2014-02-15 00:40:31.000000', 'consum', 0.0216, 'lps'),
	(547145, 130, '2014-02-15 00:40:32.000000', 'consum', 0.0221, 'lps'),
	(547146, 130, '2014-02-15 00:40:33.000000', 'consum', 0.0213, 'lps'),
	(547147, 130, '2014-02-15 00:40:34.000000', 'consum', 0.0211, 'lps'),
	(547148, 130, '2014-02-15 00:40:35.000000', 'consum', 0.0221, 'lps'),
	(547149, 130, '2014-02-15 00:40:36.000000', 'consum', 0.0213, 'lps'),
	(547150, 130, '2014-02-15 00:40:37.000000', 'consum', 0.0225, 'lps'),
	(547151, 130, '2014-02-15 00:40:38.000000', 'consum', 0.0225, 'lps'),
	(547152, 130, '2014-02-15 00:40:39.000000', 'consum', 0.0224, 'lps'),
	(547153, 130, '2014-02-15 00:40:40.000000', 'consum', 0.0221, 'lps'),
	(547154, 130, '2014-02-15 00:40:41.000000', 'consum', 0.0220, 'lps'),
	(547155, 130, '2014-02-15 00:40:42.000000', 'consum', 0.0211, 'lps'),
	(547156, 130, '2014-02-15 00:40:43.000000', 'consum', 0.0220, 'lps'),
	(547157, 130, '2014-02-15 00:40:44.000000', 'consum', 0.0223, 'lps'),
	(547158, 130, '2014-02-15 00:40:45.000000', 'consum', 0.0210, 'lps'),
	(547159, 130, '2014-02-15 00:40:46.000000', 'consum', 0.0225, 'lps'),
	(547160, 130, '2014-02-15 00:40:47.000000', 'consum', 0.0216, 'lps'),
	(547161, 130, '2014-02-15 00:40:48.000000', 'consum', 0.0215, 'lps'),
	(547162, 130, '2014-02-15 00:40:49.000000', 'consum', 0.0216, 'lps'),
	(547163, 130, '2014-02-15 00:40:50.000000', 'consum', 0.0210, 'lps'),
	(547164, 130, '2014-02-15 00:40:51.000000', 'consum', 0.0210, 'lps'),
	(547165, 130, '2014-02-15 00:40:52.000000', 'consum', 0.0224, 'lps'),
	(547166, 130, '2014-02-15 00:40:53.000000', 'consum', 0.0216, 'lps'),
	(547167, 130, '2014-02-15 00:40:54.000000', 'consum', 0.0214, 'lps'),
	(547168, 130, '2014-02-15 00:40:55.000000', 'consum', 0.0213, 'lps'),
	(547169, 130, '2014-02-15 00:40:56.000000', 'consum', 0.0214, 'lps'),
	(547170, 130, '2014-02-15 00:40:57.000000', 'consum', 0.0221, 'lps'),
	(547171, 130, '2014-02-15 00:40:58.000000', 'consum', 0.0221, 'lps'),
	(547172, 130, '2014-02-15 00:40:59.000000', 'consum', 0.0216, 'lps'),
	(547173, 130, '2014-02-15 00:41:00.000000', 'consum', 0.0222, 'lps'),
	(547174, 130, '2014-02-15 00:41:01.000000', 'consum', 0.0221, 'lps'),
	(547175, 130, '2014-02-15 00:41:02.000000', 'consum', 0.0211, 'lps'),
	(547176, 130, '2014-02-15 00:41:03.000000', 'consum', 0.0217, 'lps'),
	(547177, 130, '2014-02-15 00:41:04.000000', 'consum', 0.0224, 'lps'),
	(547178, 130, '2014-02-15 00:41:05.000000', 'consum', 0.0211, 'lps'),
	(547179, 130, '2014-02-15 00:41:06.000000', 'consum', 0.0223, 'lps'),
	(547180, 130, '2014-02-15 00:41:07.000000', 'consum', 0.0224, 'lps'),
	(547181, 130, '2014-02-15 00:41:08.000000', 'consum', 0.0222, 'lps'),
	(547182, 130, '2014-02-15 00:41:09.000000', 'consum', 0.0210, 'lps'),
	(547183, 130, '2014-02-15 00:41:10.000000', 'consum', 0.0211, 'lps'),
	(547184, 130, '2014-02-15 00:41:11.000000', 'consum', 0.0215, 'lps'),
	(547185, 130, '2014-02-15 00:41:12.000000', 'consum', 0.0217, 'lps'),
	(547186, 130, '2014-02-15 00:41:13.000000', 'consum', 0.0212, 'lps'),
	(547187, 130, '2014-02-15 00:41:14.000000', 'consum', 0.0216, 'lps'),
	(547188, 130, '2014-02-15 00:41:15.000000', 'consum', 0.0216, 'lps'),
	(547189, 130, '2014-02-15 00:41:16.000000', 'consum', 0.0225, 'lps'),
	(547190, 130, '2014-02-15 00:41:17.000000', 'consum', 0.0215, 'lps'),
	(547191, 130, '2014-02-15 00:41:18.000000', 'consum', 0.0210, 'lps'),
	(547192, 130, '2014-02-15 00:41:19.000000', 'consum', 0.0211, 'lps'),
	(547193, 130, '2014-02-15 00:41:20.000000', 'consum', 0.0216, 'lps'),
	(547194, 130, '2014-02-15 00:41:21.000000', 'consum', 0.0221, 'lps'),
	(547195, 130, '2014-02-15 00:41:22.000000', 'consum', 0.0214, 'lps'),
	(547196, 130, '2014-02-15 00:41:23.000000', 'consum', 0.0214, 'lps'),
	(547197, 130, '2014-02-15 00:41:24.000000', 'consum', 0.0220, 'lps'),
	(547198, 130, '2014-02-15 00:41:25.000000', 'consum', 0.0212, 'lps'),
	(547199, 130, '2014-02-15 00:41:26.000000', 'consum', 0.0226, 'lps'),
	(547200, 130, '2014-02-15 00:41:27.000000', 'consum', 0.0216, 'lps'),
	(547201, 130, '2014-02-15 00:41:28.000000', 'consum', 0.0226, 'lps'),
	(547202, 130, '2014-02-15 00:41:29.000000', 'consum', 0.0221, 'lps'),
	(547203, 130, '2014-02-15 00:41:30.000000', 'consum', 0.0218, 'lps'),
	(547204, 130, '2014-02-15 00:41:31.000000', 'consum', 0.0218, 'lps'),
	(547205, 130, '2014-02-15 00:41:32.000000', 'consum', 0.0211, 'lps'),
	(547206, 130, '2014-02-15 00:41:33.000000', 'consum', 0.0222, 'lps'),
	(547207, 130, '2014-02-15 00:41:34.000000', 'consum', 0.0219, 'lps'),
	(547208, 130, '2014-02-15 00:41:35.000000', 'consum', 0.0219, 'lps'),
	(547209, 130, '2014-02-15 00:41:36.000000', 'consum', 0.0213, 'lps'),
	(547210, 130, '2014-02-15 00:41:37.000000', 'consum', 0.0214, 'lps'),
	(547211, 130, '2014-02-15 00:41:38.000000', 'consum', 0.0223, 'lps'),
	(547212, 130, '2014-02-15 00:41:39.000000', 'consum', 0.0212, 'lps'),
	(547213, 130, '2014-02-15 00:41:40.000000', 'consum', 0.0217, 'lps'),
	(547214, 130, '2014-02-15 00:41:41.000000', 'consum', 0.0219, 'lps'),
	(547215, 130, '2014-02-15 00:41:42.000000', 'consum', 0.0220, 'lps'),
	(547216, 130, '2014-02-15 00:41:43.000000', 'consum', 0.0218, 'lps'),
	(547217, 130, '2014-02-15 00:41:44.000000', 'consum', 0.0219, 'lps'),
	(547218, 130, '2014-02-15 00:41:45.000000', 'consum', 0.0213, 'lps'),
	(547219, 130, '2014-02-15 00:41:46.000000', 'consum', 0.0215, 'lps'),
	(547220, 130, '2014-02-15 00:41:47.000000', 'consum', 0.0212, 'lps'),
	(547221, 130, '2014-02-15 00:41:48.000000', 'consum', 0.0220, 'lps'),
	(547222, 130, '2014-02-15 00:41:49.000000', 'consum', 0.0220, 'lps'),
	(547223, 130, '2014-02-15 00:41:50.000000', 'consum', 0.0215, 'lps'),
	(547224, 130, '2014-02-15 00:41:51.000000', 'consum', 0.0220, 'lps'),
	(547225, 130, '2014-02-15 00:41:52.000000', 'consum', 0.0214, 'lps'),
	(547226, 130, '2014-02-15 00:41:53.000000', 'consum', 0.0218, 'lps'),
	(547227, 130, '2014-02-15 00:41:54.000000', 'consum', 0.0220, 'lps'),
	(547228, 130, '2014-02-15 00:41:55.000000', 'consum', 0.0219, 'lps'),
	(547229, 130, '2014-02-15 00:41:56.000000', 'consum', 0.0211, 'lps'),
	(547230, 130, '2014-02-15 00:41:57.000000', 'consum', 0.0221, 'lps'),
	(547231, 130, '2014-02-15 00:41:58.000000', 'consum', 0.0212, 'lps'),
	(547232, 130, '2014-02-15 00:41:59.000000', 'consum', 0.0220, 'lps'),
	(547233, 130, '2014-02-15 00:42:00.000000', 'consum', 0.0222, 'lps'),
	(547234, 130, '2014-02-15 00:42:01.000000', 'consum', 0.0225, 'lps'),
	(547235, 130, '2014-02-15 00:42:02.000000', 'consum', 0.0215, 'lps'),
	(547236, 130, '2014-02-15 00:42:03.000000', 'consum', 0.0223, 'lps'),
	(547237, 130, '2014-02-15 00:42:04.000000', 'consum', 0.0210, 'lps'),
	(547238, 130, '2014-02-15 00:42:05.000000', 'consum', 0.0223, 'lps'),
	(547239, 130, '2014-02-15 00:42:06.000000', 'consum', 0.0223, 'lps'),
	(547240, 130, '2014-02-15 00:42:07.000000', 'consum', 0.0221, 'lps'),
	(547241, 130, '2014-02-15 00:42:08.000000', 'consum', 0.0210, 'lps'),
	(547242, 130, '2014-02-15 00:42:09.000000', 'consum', 0.0226, 'lps'),
	(547243, 130, '2014-02-15 00:42:10.000000', 'consum', 0.0225, 'lps'),
	(547244, 130, '2014-02-15 00:42:11.000000', 'consum', 0.0219, 'lps'),
	(547245, 130, '2014-02-15 00:42:12.000000', 'consum', 0.0210, 'lps'),
	(547246, 130, '2014-02-15 00:42:13.000000', 'consum', 0.0219, 'lps'),
	(547247, 130, '2014-02-15 00:42:14.000000', 'consum', 0.0220, 'lps'),
	(547248, 130, '2014-02-15 00:42:15.000000', 'consum', 0.0219, 'lps'),
	(547249, 130, '2014-02-15 00:42:16.000000', 'consum', 0.0223, 'lps'),
	(547250, 130, '2014-02-15 00:42:17.000000', 'consum', 0.0217, 'lps'),
	(547251, 130, '2014-02-15 00:42:18.000000', 'consum', 0.0224, 'lps'),
	(547252, 130, '2014-02-15 00:42:19.000000', 'consum', 0.0226, 'lps'),
	(547253, 130, '2014-02-15 00:42:20.000000', 'consum', 0.0212, 'lps'),
	(547254, 130, '2014-02-15 00:42:21.000000', 'consum', 0.0225, 'lps'),
	(547255, 130, '2014-02-15 00:42:22.000000', 'consum', 0.0213, 'lps'),
	(547256, 130, '2014-02-15 00:42:23.000000', 'consum', 0.0212, 'lps'),
	(547257, 130, '2014-02-15 00:42:24.000000', 'consum', 0.0214, 'lps'),
	(547258, 130, '2014-02-15 00:42:25.000000', 'consum', 0.0223, 'lps'),
	(547259, 130, '2014-02-15 00:42:26.000000', 'consum', 0.0213, 'lps'),
	(547260, 130, '2014-02-15 00:42:27.000000', 'consum', 0.0222, 'lps'),
	(547261, 130, '2014-02-15 00:42:28.000000', 'consum', 0.0225, 'lps'),
	(547262, 130, '2014-02-15 00:42:29.000000', 'consum', 0.0216, 'lps'),
	(547263, 130, '2014-02-15 00:42:30.000000', 'consum', 0.0211, 'lps'),
	(547264, 130, '2014-02-15 00:42:31.000000', 'consum', 0.0215, 'lps'),
	(547265, 130, '2014-02-15 00:42:32.000000', 'consum', 0.0215, 'lps'),
	(547266, 130, '2014-02-15 00:42:33.000000', 'consum', 0.0222, 'lps'),
	(547267, 130, '2014-02-15 00:42:34.000000', 'consum', 0.0219, 'lps'),
	(547268, 130, '2014-02-15 00:42:35.000000', 'consum', 0.0221, 'lps'),
	(547269, 130, '2014-02-15 00:42:36.000000', 'consum', 0.0220, 'lps'),
	(547270, 130, '2014-02-15 00:42:37.000000', 'consum', 0.0213, 'lps'),
	(547271, 130, '2014-02-15 00:42:38.000000', 'consum', 0.0211, 'lps'),
	(547272, 130, '2014-02-15 00:42:39.000000', 'consum', 0.0225, 'lps'),
	(547273, 130, '2014-02-15 00:42:40.000000', 'consum', 0.0212, 'lps'),
	(547274, 130, '2014-02-15 00:42:41.000000', 'consum', 0.0211, 'lps'),
	(547275, 130, '2014-02-15 00:42:42.000000', 'consum', 0.0226, 'lps'),
	(547276, 130, '2014-02-15 00:42:43.000000', 'consum', 0.0221, 'lps'),
	(547277, 130, '2014-02-15 00:42:44.000000', 'consum', 0.0215, 'lps'),
	(547278, 130, '2014-02-15 00:42:45.000000', 'consum', 0.0220, 'lps'),
	(547279, 130, '2014-02-15 00:42:46.000000', 'consum', 0.0211, 'lps'),
	(547280, 130, '2014-02-15 00:42:47.000000', 'consum', 0.0221, 'lps'),
	(547281, 130, '2014-02-15 00:42:48.000000', 'consum', 0.0212, 'lps'),
	(547282, 130, '2014-02-15 00:42:49.000000', 'consum', 0.0220, 'lps'),
	(547283, 130, '2014-02-15 00:42:50.000000', 'consum', 0.0222, 'lps'),
	(547284, 130, '2014-02-15 00:42:51.000000', 'consum', 0.0224, 'lps'),
	(547285, 130, '2014-02-15 00:42:52.000000', 'consum', 0.0225, 'lps'),
	(547286, 130, '2014-02-15 00:42:53.000000', 'consum', 0.0211, 'lps'),
	(547287, 130, '2014-02-15 00:42:54.000000', 'consum', 0.0221, 'lps'),
	(547288, 130, '2014-02-15 00:42:55.000000', 'consum', 0.0212, 'lps'),
	(547289, 130, '2014-02-15 00:42:56.000000', 'consum', 0.0221, 'lps'),
	(547290, 130, '2014-02-15 00:42:57.000000', 'consum', 0.0224, 'lps'),
	(547291, 130, '2014-02-15 00:42:58.000000', 'consum', 0.0216, 'lps'),
	(547292, 130, '2014-02-15 00:42:59.000000', 'consum', 0.0215, 'lps'),
	(547293, 130, '2014-02-15 00:43:00.000000', 'consum', 0.0219, 'lps'),
	(547294, 130, '2014-02-15 00:43:01.000000', 'consum', 0.0221, 'lps'),
	(547295, 130, '2014-02-15 00:43:02.000000', 'consum', 0.0222, 'lps'),
	(547296, 130, '2014-02-15 00:43:03.000000', 'consum', 0.0222, 'lps'),
	(547297, 130, '2014-02-15 00:43:04.000000', 'consum', 0.0218, 'lps'),
	(547298, 130, '2014-02-15 00:43:05.000000', 'consum', 0.0216, 'lps'),
	(547299, 130, '2014-02-15 00:43:06.000000', 'consum', 0.0213, 'lps'),
	(547300, 130, '2014-02-15 00:43:07.000000', 'consum', 0.0225, 'lps'),
	(547301, 130, '2014-02-15 00:43:08.000000', 'consum', 0.0226, 'lps'),
	(547302, 130, '2014-02-15 00:43:09.000000', 'consum', 0.0212, 'lps'),
	(547303, 130, '2014-02-15 00:43:10.000000', 'consum', 0.0223, 'lps'),
	(547304, 130, '2014-02-15 00:43:11.000000', 'consum', 0.0218, 'lps'),
	(547305, 130, '2014-02-15 00:43:12.000000', 'consum', 0.0212, 'lps'),
	(547306, 130, '2014-02-15 00:43:13.000000', 'consum', 0.0215, 'lps'),
	(547307, 130, '2014-02-15 00:43:14.000000', 'consum', 0.0213, 'lps'),
	(547308, 130, '2014-02-15 00:43:15.000000', 'consum', 0.0226, 'lps'),
	(547309, 130, '2014-02-15 00:43:16.000000', 'consum', 0.0212, 'lps'),
	(547310, 130, '2014-02-15 00:43:17.000000', 'consum', 0.0226, 'lps'),
	(547311, 130, '2014-02-15 00:43:18.000000', 'consum', 0.0217, 'lps'),
	(547312, 130, '2014-02-15 00:43:19.000000', 'consum', 0.0215, 'lps'),
	(547313, 130, '2014-02-15 00:43:20.000000', 'consum', 0.0213, 'lps'),
	(547314, 130, '2014-02-15 00:43:21.000000', 'consum', 0.0212, 'lps'),
	(547315, 130, '2014-02-15 00:43:22.000000', 'consum', 0.0210, 'lps'),
	(547316, 130, '2014-02-15 00:43:23.000000', 'consum', 0.0220, 'lps'),
	(547317, 130, '2014-02-15 00:43:24.000000', 'consum', 0.0213, 'lps'),
	(547318, 130, '2014-02-15 00:43:25.000000', 'consum', 0.0226, 'lps'),
	(547319, 130, '2014-02-15 00:43:26.000000', 'consum', 0.0215, 'lps'),
	(547320, 130, '2014-02-15 00:43:27.000000', 'consum', 0.0222, 'lps'),
	(547321, 130, '2014-02-15 00:43:28.000000', 'consum', 0.0222, 'lps'),
	(547322, 130, '2014-02-15 00:43:29.000000', 'consum', 0.0216, 'lps'),
	(547323, 130, '2014-02-15 00:43:30.000000', 'consum', 0.0223, 'lps'),
	(547324, 130, '2014-02-15 00:43:31.000000', 'consum', 0.0222, 'lps'),
	(547325, 130, '2014-02-15 00:43:32.000000', 'consum', 0.0214, 'lps'),
	(547326, 130, '2014-02-15 00:43:33.000000', 'consum', 0.0212, 'lps'),
	(547327, 130, '2014-02-15 00:43:34.000000', 'consum', 0.0225, 'lps'),
	(547328, 130, '2014-02-15 00:43:35.000000', 'consum', 0.0212, 'lps'),
	(547329, 130, '2014-02-15 00:43:36.000000', 'consum', 0.0212, 'lps'),
	(547330, 130, '2014-02-15 00:43:37.000000', 'consum', 0.0211, 'lps'),
	(547331, 130, '2014-02-15 00:43:38.000000', 'consum', 0.0210, 'lps'),
	(547332, 130, '2014-02-15 00:43:39.000000', 'consum', 0.0226, 'lps'),
	(547333, 130, '2014-02-15 00:43:40.000000', 'consum', 0.0220, 'lps'),
	(547334, 130, '2014-02-15 00:43:41.000000', 'consum', 0.0215, 'lps'),
	(547335, 130, '2014-02-15 00:43:42.000000', 'consum', 0.0221, 'lps'),
	(547336, 130, '2014-02-15 00:43:43.000000', 'consum', 0.0218, 'lps'),
	(547337, 130, '2014-02-15 00:43:44.000000', 'consum', 0.0216, 'lps'),
	(547338, 130, '2014-02-15 00:43:45.000000', 'consum', 0.0219, 'lps'),
	(547339, 130, '2014-02-15 00:43:46.000000', 'consum', 0.0217, 'lps'),
	(547340, 130, '2014-02-15 00:43:47.000000', 'consum', 0.0220, 'lps'),
	(547341, 130, '2014-02-15 00:43:48.000000', 'consum', 0.0224, 'lps'),
	(547342, 130, '2014-02-15 00:43:49.000000', 'consum', 0.0216, 'lps'),
	(547343, 130, '2014-02-15 00:43:50.000000', 'consum', 0.0217, 'lps'),
	(547344, 130, '2014-02-15 00:43:51.000000', 'consum', 0.0210, 'lps'),
	(547345, 130, '2014-02-15 00:43:52.000000', 'consum', 0.0223, 'lps'),
	(547346, 130, '2014-02-15 00:43:53.000000', 'consum', 0.0222, 'lps'),
	(547347, 130, '2014-02-15 00:43:54.000000', 'consum', 0.0218, 'lps'),
	(547348, 130, '2014-02-15 00:43:55.000000', 'consum', 0.0214, 'lps'),
	(547349, 130, '2014-02-15 00:43:56.000000', 'consum', 0.0223, 'lps'),
	(547350, 130, '2014-02-15 00:43:57.000000', 'consum', 0.0212, 'lps'),
	(547351, 130, '2014-02-15 00:43:58.000000', 'consum', 0.0216, 'lps'),
	(547352, 130, '2014-02-15 00:43:59.000000', 'consum', 0.0218, 'lps'),
	(547353, 130, '2014-02-15 00:44:00.000000', 'consum', 0.0214, 'lps'),
	(547354, 130, '2014-02-15 00:44:01.000000', 'consum', 0.0225, 'lps'),
	(547355, 130, '2014-02-15 00:44:02.000000', 'consum', 0.0224, 'lps'),
	(547356, 130, '2014-02-15 00:44:03.000000', 'consum', 0.0218, 'lps'),
	(547357, 130, '2014-02-15 00:44:04.000000', 'consum', 0.0223, 'lps'),
	(547358, 130, '2014-02-15 00:44:05.000000', 'consum', 0.0219, 'lps'),
	(547359, 130, '2014-02-15 00:44:06.000000', 'consum', 0.0217, 'lps'),
	(547360, 130, '2014-02-15 00:44:07.000000', 'consum', 0.0218, 'lps'),
	(547361, 130, '2014-02-15 00:44:08.000000', 'consum', 0.0214, 'lps'),
	(547362, 130, '2014-02-15 00:44:09.000000', 'consum', 0.0221, 'lps'),
	(547363, 130, '2014-02-15 00:44:10.000000', 'consum', 0.0220, 'lps'),
	(547364, 130, '2014-02-15 00:44:11.000000', 'consum', 0.0213, 'lps'),
	(547365, 130, '2014-02-15 00:44:12.000000', 'consum', 0.0211, 'lps'),
	(547366, 130, '2014-02-15 00:44:13.000000', 'consum', 0.0223, 'lps'),
	(547367, 130, '2014-02-15 00:44:14.000000', 'consum', 0.0223, 'lps'),
	(547368, 130, '2014-02-15 00:44:15.000000', 'consum', 0.0220, 'lps'),
	(547369, 130, '2014-02-15 00:44:16.000000', 'consum', 0.0221, 'lps'),
	(547370, 130, '2014-02-15 00:44:17.000000', 'consum', 0.0219, 'lps'),
	(547371, 130, '2014-02-15 00:44:18.000000', 'consum', 0.0221, 'lps'),
	(547372, 130, '2014-02-15 00:44:19.000000', 'consum', 0.0224, 'lps'),
	(547373, 130, '2014-02-15 00:44:20.000000', 'consum', 0.0213, 'lps'),
	(547374, 130, '2014-02-15 00:44:21.000000', 'consum', 0.0219, 'lps'),
	(547375, 130, '2014-02-15 00:44:22.000000', 'consum', 0.0226, 'lps'),
	(547376, 130, '2014-02-15 00:44:23.000000', 'consum', 0.0214, 'lps'),
	(547377, 130, '2014-02-15 00:44:24.000000', 'consum', 0.0217, 'lps'),
	(547378, 130, '2014-02-15 00:44:25.000000', 'consum', 0.0215, 'lps'),
	(547379, 130, '2014-02-15 00:44:26.000000', 'consum', 0.0214, 'lps'),
	(547380, 130, '2014-02-15 00:44:27.000000', 'consum', 0.0216, 'lps'),
	(547381, 130, '2014-02-15 00:44:28.000000', 'consum', 0.0213, 'lps'),
	(547382, 130, '2014-02-15 00:44:29.000000', 'consum', 0.0223, 'lps'),
	(547383, 130, '2014-02-15 00:44:30.000000', 'consum', 0.0216, 'lps'),
	(547384, 130, '2014-02-15 00:44:31.000000', 'consum', 0.0220, 'lps'),
	(547385, 130, '2014-02-15 00:44:32.000000', 'consum', 0.0223, 'lps'),
	(547386, 130, '2014-02-15 00:44:33.000000', 'consum', 0.0210, 'lps'),
	(547387, 130, '2014-02-15 00:44:34.000000', 'consum', 0.0226, 'lps'),
	(547388, 130, '2014-02-15 00:44:35.000000', 'consum', 0.0222, 'lps'),
	(547389, 130, '2014-02-15 00:44:36.000000', 'consum', 0.0222, 'lps'),
	(547390, 130, '2014-02-15 00:44:37.000000', 'consum', 0.0216, 'lps'),
	(547391, 130, '2014-02-15 00:44:38.000000', 'consum', 0.0221, 'lps'),
	(547392, 130, '2014-02-15 00:44:39.000000', 'consum', 0.0214, 'lps'),
	(547393, 130, '2014-02-15 00:44:40.000000', 'consum', 0.0214, 'lps'),
	(547394, 130, '2014-02-15 00:44:41.000000', 'consum', 0.0218, 'lps'),
	(547395, 130, '2014-02-15 00:44:42.000000', 'consum', 0.0223, 'lps'),
	(547396, 130, '2014-02-15 00:44:43.000000', 'consum', 0.0216, 'lps'),
	(547397, 130, '2014-02-15 00:44:44.000000', 'consum', 0.0220, 'lps'),
	(547398, 130, '2014-02-15 00:44:45.000000', 'consum', 0.0225, 'lps'),
	(547399, 130, '2014-02-15 00:44:46.000000', 'consum', 0.0221, 'lps'),
	(547400, 130, '2014-02-15 00:44:47.000000', 'consum', 0.0219, 'lps'),
	(547401, 130, '2014-02-15 00:44:48.000000', 'consum', 0.0225, 'lps'),
	(547402, 130, '2014-02-15 00:44:49.000000', 'consum', 0.0222, 'lps'),
	(547403, 130, '2014-02-15 00:44:50.000000', 'consum', 0.0210, 'lps'),
	(547404, 130, '2014-02-15 00:44:51.000000', 'consum', 0.0225, 'lps'),
	(547405, 130, '2014-02-15 00:44:52.000000', 'consum', 0.0217, 'lps'),
	(547406, 130, '2014-02-15 00:44:53.000000', 'consum', 0.0220, 'lps'),
	(547407, 130, '2014-02-15 00:44:54.000000', 'consum', 0.0219, 'lps'),
	(547408, 130, '2014-02-15 00:44:55.000000', 'consum', 0.0211, 'lps'),
	(547409, 130, '2014-02-15 00:44:56.000000', 'consum', 0.0222, 'lps'),
	(547410, 130, '2014-02-15 00:44:57.000000', 'consum', 0.0217, 'lps'),
	(547411, 130, '2014-02-15 00:44:58.000000', 'consum', 0.0225, 'lps'),
	(547412, 130, '2014-02-15 00:44:59.000000', 'consum', 0.0215, 'lps'),
	(547413, 130, '2014-02-15 00:45:00.000000', 'consum', 0.0223, 'lps'),
	(547414, 130, '2014-02-15 00:45:01.000000', 'consum', 0.0211, 'lps'),
	(547415, 130, '2014-02-15 00:45:02.000000', 'consum', 0.0211, 'lps'),
	(547416, 130, '2014-02-15 00:45:03.000000', 'consum', 0.0212, 'lps'),
	(547417, 130, '2014-02-15 00:45:04.000000', 'consum', 0.0217, 'lps'),
	(547418, 130, '2014-02-15 00:45:05.000000', 'consum', 0.0224, 'lps'),
	(547419, 130, '2014-02-15 00:45:06.000000', 'consum', 0.0226, 'lps'),
	(547420, 130, '2014-02-15 00:45:07.000000', 'consum', 0.0212, 'lps'),
	(547421, 130, '2014-02-15 00:45:08.000000', 'consum', 0.0223, 'lps'),
	(547422, 130, '2014-02-15 00:45:09.000000', 'consum', 0.0220, 'lps'),
	(547423, 130, '2014-02-15 00:45:10.000000', 'consum', 0.0220, 'lps'),
	(547424, 130, '2014-02-15 00:45:11.000000', 'consum', 0.0216, 'lps'),
	(547425, 130, '2014-02-15 00:45:12.000000', 'consum', 0.0211, 'lps'),
	(547426, 130, '2014-02-15 00:45:13.000000', 'consum', 0.0215, 'lps'),
	(547427, 130, '2014-02-15 00:45:14.000000', 'consum', 0.0216, 'lps'),
	(547428, 130, '2014-02-15 00:45:15.000000', 'consum', 0.0225, 'lps'),
	(547429, 130, '2014-02-15 00:45:16.000000', 'consum', 0.0216, 'lps'),
	(547430, 130, '2014-02-15 00:45:17.000000', 'consum', 0.0212, 'lps'),
	(547431, 130, '2014-02-15 00:45:18.000000', 'consum', 0.0220, 'lps'),
	(547432, 130, '2014-02-15 00:45:19.000000', 'consum', 0.0219, 'lps'),
	(547433, 130, '2014-02-15 00:45:20.000000', 'consum', 0.0225, 'lps'),
	(547434, 130, '2014-02-15 00:45:21.000000', 'consum', 0.0225, 'lps'),
	(547435, 130, '2014-02-15 00:45:22.000000', 'consum', 0.0223, 'lps'),
	(547436, 130, '2014-02-15 00:45:23.000000', 'consum', 0.0215, 'lps'),
	(547437, 130, '2014-02-15 00:45:24.000000', 'consum', 0.0211, 'lps'),
	(547438, 130, '2014-02-15 00:45:25.000000', 'consum', 0.0220, 'lps'),
	(547439, 130, '2014-02-15 00:45:26.000000', 'consum', 0.0223, 'lps'),
	(547440, 130, '2014-02-15 00:45:27.000000', 'consum', 0.0213, 'lps'),
	(547441, 130, '2014-02-15 00:45:28.000000', 'consum', 0.0219, 'lps'),
	(547442, 130, '2014-02-15 00:45:29.000000', 'consum', 0.0214, 'lps'),
	(547443, 130, '2014-02-15 00:45:30.000000', 'consum', 0.0219, 'lps'),
	(547444, 130, '2014-02-15 00:45:31.000000', 'consum', 0.0210, 'lps'),
	(547445, 130, '2014-02-15 00:45:32.000000', 'consum', 0.0217, 'lps'),
	(547446, 130, '2014-02-15 00:45:33.000000', 'consum', 0.0210, 'lps'),
	(547447, 130, '2014-02-15 00:45:34.000000', 'consum', 0.0226, 'lps'),
	(547448, 130, '2014-02-15 00:45:35.000000', 'consum', 0.0221, 'lps'),
	(547449, 130, '2014-02-15 00:45:36.000000', 'consum', 0.0220, 'lps'),
	(547450, 130, '2014-02-15 00:45:37.000000', 'consum', 0.0224, 'lps'),
	(547451, 130, '2014-02-15 00:45:38.000000', 'consum', 0.0219, 'lps'),
	(547452, 130, '2014-02-15 00:45:39.000000', 'consum', 0.0211, 'lps'),
	(547453, 130, '2014-02-15 00:45:40.000000', 'consum', 0.0223, 'lps'),
	(547454, 130, '2014-02-15 00:45:41.000000', 'consum', 0.0222, 'lps'),
	(547455, 130, '2014-02-15 00:45:42.000000', 'consum', 0.0213, 'lps'),
	(547456, 130, '2014-02-15 00:45:43.000000', 'consum', 0.0226, 'lps'),
	(547457, 130, '2014-02-15 00:45:44.000000', 'consum', 0.0210, 'lps'),
	(547458, 130, '2014-02-15 00:45:45.000000', 'consum', 0.0217, 'lps'),
	(547459, 130, '2014-02-15 00:45:46.000000', 'consum', 0.0210, 'lps'),
	(547460, 130, '2014-02-15 00:45:47.000000', 'consum', 0.0222, 'lps'),
	(547461, 130, '2014-02-15 00:45:48.000000', 'consum', 0.0221, 'lps'),
	(547462, 130, '2014-02-15 00:45:49.000000', 'consum', 0.0212, 'lps'),
	(547463, 130, '2014-02-15 00:45:50.000000', 'consum', 0.0222, 'lps'),
	(547464, 130, '2014-02-15 00:45:51.000000', 'consum', 0.0215, 'lps'),
	(547465, 130, '2014-02-15 00:45:52.000000', 'consum', 0.0215, 'lps'),
	(547466, 130, '2014-02-15 00:45:53.000000', 'consum', 0.0221, 'lps'),
	(547467, 130, '2014-02-15 00:45:54.000000', 'consum', 0.0215, 'lps'),
	(547468, 130, '2014-02-15 00:45:55.000000', 'consum', 0.0222, 'lps'),
	(547469, 130, '2014-02-15 00:45:56.000000', 'consum', 0.0218, 'lps'),
	(547470, 130, '2014-02-15 00:45:57.000000', 'consum', 0.0217, 'lps'),
	(547471, 130, '2014-02-15 00:45:58.000000', 'consum', 0.0222, 'lps'),
	(547472, 130, '2014-02-15 00:45:59.000000', 'consum', 0.0214, 'lps'),
	(547473, 130, '2014-02-15 00:46:00.000000', 'consum', 0.0213, 'lps'),
	(547474, 130, '2014-02-15 00:46:01.000000', 'consum', 0.0212, 'lps'),
	(547475, 130, '2014-02-15 00:46:02.000000', 'consum', 0.0211, 'lps'),
	(547476, 130, '2014-02-15 00:46:03.000000', 'consum', 0.0212, 'lps'),
	(547477, 130, '2014-02-15 00:46:04.000000', 'consum', 0.0216, 'lps'),
	(547478, 130, '2014-02-15 00:46:05.000000', 'consum', 0.0216, 'lps'),
	(547479, 130, '2014-02-15 00:46:06.000000', 'consum', 0.0225, 'lps'),
	(547480, 130, '2014-02-15 00:46:07.000000', 'consum', 0.0215, 'lps'),
	(547481, 130, '2014-02-15 00:46:08.000000', 'consum', 0.0224, 'lps'),
	(547482, 130, '2014-02-15 00:46:09.000000', 'consum', 0.0214, 'lps'),
	(547483, 130, '2014-02-15 00:46:10.000000', 'consum', 0.0224, 'lps'),
	(547484, 130, '2014-02-15 00:46:11.000000', 'consum', 0.0216, 'lps'),
	(547485, 130, '2014-02-15 00:46:12.000000', 'consum', 0.0215, 'lps'),
	(547486, 130, '2014-02-15 00:46:13.000000', 'consum', 0.0219, 'lps'),
	(547487, 130, '2014-02-15 00:46:14.000000', 'consum', 0.0221, 'lps'),
	(547488, 130, '2014-02-15 00:46:15.000000', 'consum', 0.0225, 'lps'),
	(547489, 130, '2014-02-15 00:46:16.000000', 'consum', 0.0216, 'lps'),
	(547490, 130, '2014-02-15 00:46:17.000000', 'consum', 0.0212, 'lps'),
	(547491, 130, '2014-02-15 00:46:18.000000', 'consum', 0.0219, 'lps'),
	(547492, 130, '2014-02-15 00:46:19.000000', 'consum', 0.0217, 'lps'),
	(547493, 130, '2014-02-15 00:46:20.000000', 'consum', 0.0217, 'lps'),
	(547494, 130, '2014-02-15 00:46:21.000000', 'consum', 0.0225, 'lps'),
	(547495, 130, '2014-02-15 00:46:22.000000', 'consum', 0.0215, 'lps'),
	(547496, 130, '2014-02-15 00:46:23.000000', 'consum', 0.0225, 'lps'),
	(547497, 130, '2014-02-15 00:46:24.000000', 'consum', 0.0219, 'lps'),
	(547498, 130, '2014-02-15 00:46:25.000000', 'consum', 0.0211, 'lps'),
	(547499, 130, '2014-02-15 00:46:26.000000', 'consum', 0.0220, 'lps'),
	(547500, 130, '2014-02-15 00:46:27.000000', 'consum', 0.0226, 'lps'),
	(547501, 130, '2014-02-15 00:46:28.000000', 'consum', 0.0225, 'lps'),
	(547502, 130, '2014-02-15 00:46:29.000000', 'consum', 0.0220, 'lps'),
	(547503, 130, '2014-02-15 00:46:30.000000', 'consum', 0.0218, 'lps'),
	(547504, 130, '2014-02-15 00:46:31.000000', 'consum', 0.0219, 'lps'),
	(547505, 130, '2014-02-15 00:46:32.000000', 'consum', 0.0215, 'lps'),
	(547506, 130, '2014-02-15 00:46:33.000000', 'consum', 0.0225, 'lps'),
	(547507, 130, '2014-02-15 00:46:34.000000', 'consum', 0.0219, 'lps'),
	(547508, 130, '2014-02-15 00:46:35.000000', 'consum', 0.0210, 'lps'),
	(547509, 130, '2014-02-15 00:46:36.000000', 'consum', 0.0218, 'lps'),
	(547510, 130, '2014-02-15 00:46:37.000000', 'consum', 0.0217, 'lps'),
	(547511, 130, '2014-02-15 00:46:38.000000', 'consum', 0.0220, 'lps'),
	(547512, 130, '2014-02-15 00:46:39.000000', 'consum', 0.0223, 'lps'),
	(547513, 130, '2014-02-15 00:46:40.000000', 'consum', 0.0210, 'lps'),
	(547514, 130, '2014-02-15 00:46:41.000000', 'consum', 0.0224, 'lps'),
	(547515, 130, '2014-02-15 00:46:42.000000', 'consum', 0.0213, 'lps'),
	(547516, 130, '2014-02-15 00:46:43.000000', 'consum', 0.0218, 'lps'),
	(547517, 130, '2014-02-15 00:46:44.000000', 'consum', 0.0222, 'lps'),
	(547518, 130, '2014-02-15 00:46:45.000000', 'consum', 0.0214, 'lps'),
	(547519, 130, '2014-02-15 00:46:46.000000', 'consum', 0.0210, 'lps'),
	(547520, 130, '2014-02-15 00:46:47.000000', 'consum', 0.0216, 'lps'),
	(547521, 130, '2014-02-15 00:46:48.000000', 'consum', 0.0223, 'lps'),
	(547522, 130, '2014-02-15 00:46:49.000000', 'consum', 0.0225, 'lps'),
	(547523, 130, '2014-02-15 00:46:50.000000', 'consum', 0.0213, 'lps'),
	(547524, 130, '2014-02-15 00:46:51.000000', 'consum', 0.0212, 'lps'),
	(547525, 130, '2014-02-15 00:46:52.000000', 'consum', 0.0214, 'lps'),
	(547526, 130, '2014-02-15 00:46:53.000000', 'consum', 0.0223, 'lps'),
	(547527, 130, '2014-02-15 00:46:54.000000', 'consum', 0.0211, 'lps'),
	(547528, 130, '2014-02-15 00:46:55.000000', 'consum', 0.0213, 'lps'),
	(547529, 130, '2014-02-15 00:46:56.000000', 'consum', 0.0222, 'lps'),
	(547530, 130, '2014-02-15 00:46:57.000000', 'consum', 0.0211, 'lps'),
	(547531, 130, '2014-02-15 00:46:58.000000', 'consum', 0.0215, 'lps'),
	(547532, 130, '2014-02-15 00:46:59.000000', 'consum', 0.0212, 'lps'),
	(547533, 130, '2014-02-15 00:47:00.000000', 'consum', 0.0225, 'lps'),
	(547534, 130, '2014-02-15 00:47:01.000000', 'consum', 0.0226, 'lps'),
	(547535, 130, '2014-02-15 00:47:02.000000', 'consum', 0.0213, 'lps'),
	(547536, 130, '2014-02-15 00:47:03.000000', 'consum', 0.0212, 'lps'),
	(547537, 130, '2014-02-15 00:47:04.000000', 'consum', 0.0211, 'lps'),
	(547538, 130, '2014-02-15 00:47:05.000000', 'consum', 0.0210, 'lps'),
	(547539, 130, '2014-02-15 00:47:06.000000', 'consum', 0.0226, 'lps'),
	(547540, 130, '2014-02-15 00:47:07.000000', 'consum', 0.0222, 'lps'),
	(547541, 130, '2014-02-15 00:47:08.000000', 'consum', 0.0221, 'lps'),
	(547542, 130, '2014-02-15 00:47:09.000000', 'consum', 0.0214, 'lps'),
	(547543, 130, '2014-02-15 00:47:10.000000', 'consum', 0.0215, 'lps'),
	(547544, 130, '2014-02-15 00:47:11.000000', 'consum', 0.0223, 'lps'),
	(547545, 130, '2014-02-15 00:47:12.000000', 'consum', 0.0210, 'lps'),
	(547546, 130, '2014-02-15 00:47:13.000000', 'consum', 0.0221, 'lps'),
	(547547, 130, '2014-02-15 00:47:14.000000', 'consum', 0.0215, 'lps'),
	(547548, 130, '2014-02-15 00:47:15.000000', 'consum', 0.0218, 'lps'),
	(547549, 130, '2014-02-15 00:47:16.000000', 'consum', 0.0219, 'lps'),
	(547550, 130, '2014-02-15 00:47:17.000000', 'consum', 0.0217, 'lps'),
	(547551, 130, '2014-02-15 00:47:18.000000', 'consum', 0.0215, 'lps'),
	(547552, 130, '2014-02-15 00:47:19.000000', 'consum', 0.0217, 'lps'),
	(547553, 130, '2014-02-15 00:47:20.000000', 'consum', 0.0213, 'lps'),
	(547554, 130, '2014-02-15 00:47:21.000000', 'consum', 0.0220, 'lps'),
	(547555, 130, '2014-02-15 00:47:22.000000', 'consum', 0.0219, 'lps'),
	(547556, 130, '2014-02-15 00:47:23.000000', 'consum', 0.0223, 'lps'),
	(547557, 130, '2014-02-15 00:47:24.000000', 'consum', 0.0216, 'lps'),
	(547558, 130, '2014-02-15 00:47:25.000000', 'consum', 0.0220, 'lps'),
	(547559, 130, '2014-02-15 00:47:26.000000', 'consum', 0.0226, 'lps'),
	(547560, 130, '2014-02-15 00:47:27.000000', 'consum', 0.0225, 'lps'),
	(547561, 130, '2014-02-15 00:47:28.000000', 'consum', 0.0222, 'lps'),
	(547562, 130, '2014-02-15 00:47:29.000000', 'consum', 0.0226, 'lps'),
	(547563, 130, '2014-02-15 00:47:30.000000', 'consum', 0.0220, 'lps'),
	(547564, 130, '2014-02-15 00:47:31.000000', 'consum', 0.0213, 'lps'),
	(547565, 130, '2014-02-15 00:47:32.000000', 'consum', 0.0213, 'lps'),
	(547566, 130, '2014-02-15 00:47:33.000000', 'consum', 0.0215, 'lps'),
	(547567, 130, '2014-02-15 00:47:34.000000', 'consum', 0.0226, 'lps'),
	(547568, 130, '2014-02-15 00:47:35.000000', 'consum', 0.0225, 'lps'),
	(547569, 130, '2014-02-15 00:47:36.000000', 'consum', 0.0222, 'lps'),
	(547570, 130, '2014-02-15 00:47:37.000000', 'consum', 0.0224, 'lps'),
	(547571, 130, '2014-02-15 00:47:38.000000', 'consum', 0.0226, 'lps'),
	(547572, 130, '2014-02-15 00:47:39.000000', 'consum', 0.0215, 'lps'),
	(547573, 130, '2014-02-15 00:47:40.000000', 'consum', 0.0222, 'lps'),
	(547574, 130, '2014-02-15 00:47:41.000000', 'consum', 0.0221, 'lps'),
	(547575, 130, '2014-02-15 00:47:42.000000', 'consum', 0.0212, 'lps'),
	(547576, 130, '2014-02-15 00:47:43.000000', 'consum', 0.0223, 'lps'),
	(547577, 130, '2014-02-15 00:47:44.000000', 'consum', 0.0218, 'lps'),
	(547578, 130, '2014-02-15 00:47:45.000000', 'consum', 0.0212, 'lps'),
	(547579, 130, '2014-02-15 00:47:46.000000', 'consum', 0.0214, 'lps'),
	(547580, 130, '2014-02-15 00:47:47.000000', 'consum', 0.0226, 'lps'),
	(547581, 130, '2014-02-15 00:47:48.000000', 'consum', 0.0226, 'lps'),
	(547582, 130, '2014-02-15 00:47:49.000000', 'consum', 0.0224, 'lps'),
	(547583, 130, '2014-02-15 00:47:50.000000', 'consum', 0.0217, 'lps'),
	(547584, 130, '2014-02-15 00:47:51.000000', 'consum', 0.0222, 'lps'),
	(547585, 130, '2014-02-15 00:47:52.000000', 'consum', 0.0212, 'lps'),
	(547586, 130, '2014-02-15 00:47:53.000000', 'consum', 0.0221, 'lps'),
	(547587, 130, '2014-02-15 00:47:54.000000', 'consum', 0.0223, 'lps'),
	(547588, 130, '2014-02-15 00:47:55.000000', 'consum', 0.0211, 'lps'),
	(547589, 130, '2014-02-15 00:47:56.000000', 'consum', 0.0212, 'lps'),
	(547590, 130, '2014-02-15 00:47:57.000000', 'consum', 0.0215, 'lps'),
	(547591, 130, '2014-02-15 00:47:58.000000', 'consum', 0.0211, 'lps'),
	(547592, 130, '2014-02-15 00:47:59.000000', 'consum', 0.0220, 'lps'),
	(547593, 130, '2014-02-15 00:48:00.000000', 'consum', 0.0222, 'lps'),
	(547594, 130, '2014-02-15 00:48:01.000000', 'consum', 0.0222, 'lps'),
	(547595, 130, '2014-02-15 00:48:02.000000', 'consum', 0.0220, 'lps'),
	(547596, 130, '2014-02-15 00:48:03.000000', 'consum', 0.0225, 'lps'),
	(547597, 130, '2014-02-15 00:48:04.000000', 'consum', 0.0220, 'lps'),
	(547598, 130, '2014-02-15 00:48:05.000000', 'consum', 0.0218, 'lps'),
	(547599, 130, '2014-02-15 00:48:06.000000', 'consum', 0.0218, 'lps'),
	(547600, 130, '2014-02-15 00:48:07.000000', 'consum', 0.0226, 'lps'),
	(547601, 130, '2014-02-15 00:48:08.000000', 'consum', 0.0217, 'lps'),
	(547602, 130, '2014-02-15 00:48:09.000000', 'consum', 0.0212, 'lps'),
	(547603, 130, '2014-02-15 00:48:10.000000', 'consum', 0.0218, 'lps'),
	(547604, 130, '2014-02-15 00:48:11.000000', 'consum', 0.0210, 'lps'),
	(547605, 130, '2014-02-15 00:48:12.000000', 'consum', 0.0222, 'lps'),
	(547606, 130, '2014-02-15 00:48:13.000000', 'consum', 0.0218, 'lps'),
	(547607, 130, '2014-02-15 00:48:14.000000', 'consum', 0.0215, 'lps'),
	(547608, 130, '2014-02-15 00:48:15.000000', 'consum', 0.0211, 'lps'),
	(547609, 130, '2014-02-15 00:48:16.000000', 'consum', 0.0216, 'lps'),
	(547610, 130, '2014-02-15 00:48:17.000000', 'consum', 0.0223, 'lps'),
	(547611, 130, '2014-02-15 00:48:18.000000', 'consum', 0.0222, 'lps'),
	(547612, 130, '2014-02-15 00:48:19.000000', 'consum', 0.0213, 'lps'),
	(547613, 130, '2014-02-15 00:48:20.000000', 'consum', 0.0225, 'lps'),
	(547614, 130, '2014-02-15 00:48:21.000000', 'consum', 0.0224, 'lps'),
	(547615, 130, '2014-02-15 00:48:22.000000', 'consum', 0.0220, 'lps'),
	(547616, 130, '2014-02-15 00:48:23.000000', 'consum', 0.0219, 'lps'),
	(547617, 130, '2014-02-15 00:48:24.000000', 'consum', 0.0224, 'lps'),
	(547618, 130, '2014-02-15 00:48:25.000000', 'consum', 0.0221, 'lps'),
	(547619, 130, '2014-02-15 00:48:26.000000', 'consum', 0.0222, 'lps'),
	(547620, 130, '2014-02-15 00:48:27.000000', 'consum', 0.0220, 'lps'),
	(547621, 130, '2014-02-15 00:48:28.000000', 'consum', 0.0210, 'lps'),
	(547622, 130, '2014-02-15 00:48:29.000000', 'consum', 0.0215, 'lps'),
	(547623, 130, '2014-02-15 00:48:30.000000', 'consum', 0.0216, 'lps'),
	(547624, 130, '2014-02-15 00:48:31.000000', 'consum', 0.0226, 'lps'),
	(547625, 130, '2014-02-15 00:48:32.000000', 'consum', 0.0220, 'lps'),
	(547626, 130, '2014-02-15 00:48:33.000000', 'consum', 0.0214, 'lps'),
	(547627, 130, '2014-02-15 00:48:34.000000', 'consum', 0.0216, 'lps'),
	(547628, 130, '2014-02-15 00:48:35.000000', 'consum', 0.0211, 'lps'),
	(547629, 130, '2014-02-15 00:48:36.000000', 'consum', 0.0213, 'lps'),
	(547630, 130, '2014-02-15 00:48:37.000000', 'consum', 0.0226, 'lps'),
	(547631, 130, '2014-02-15 00:48:38.000000', 'consum', 0.0213, 'lps'),
	(547632, 130, '2014-02-15 00:48:39.000000', 'consum', 0.0213, 'lps'),
	(547633, 130, '2014-02-15 00:48:40.000000', 'consum', 0.0215, 'lps'),
	(547634, 130, '2014-02-15 00:48:41.000000', 'consum', 0.0226, 'lps'),
	(547635, 130, '2014-02-15 00:48:42.000000', 'consum', 0.0210, 'lps'),
	(547636, 130, '2014-02-15 00:48:43.000000', 'consum', 0.0210, 'lps'),
	(547637, 130, '2014-02-15 00:48:44.000000', 'consum', 0.0214, 'lps'),
	(547638, 130, '2014-02-15 00:48:45.000000', 'consum', 0.0211, 'lps'),
	(547639, 130, '2014-02-15 00:48:46.000000', 'consum', 0.0221, 'lps'),
	(547640, 130, '2014-02-15 00:48:47.000000', 'consum', 0.0211, 'lps'),
	(547641, 130, '2014-02-15 00:48:48.000000', 'consum', 0.0217, 'lps'),
	(547642, 130, '2014-02-15 00:48:49.000000', 'consum', 0.0225, 'lps'),
	(547643, 130, '2014-02-15 00:48:50.000000', 'consum', 0.0215, 'lps'),
	(547644, 130, '2014-02-15 00:48:51.000000', 'consum', 0.0225, 'lps'),
	(547645, 130, '2014-02-15 00:48:52.000000', 'consum', 0.0219, 'lps'),
	(547646, 130, '2014-02-15 00:48:53.000000', 'consum', 0.0210, 'lps'),
	(547647, 130, '2014-02-15 00:48:54.000000', 'consum', 0.0217, 'lps'),
	(547648, 130, '2014-02-15 00:48:55.000000', 'consum', 0.0212, 'lps'),
	(547649, 130, '2014-02-15 00:48:56.000000', 'consum', 0.0218, 'lps'),
	(547650, 130, '2014-02-15 00:48:57.000000', 'consum', 0.0226, 'lps'),
	(547651, 130, '2014-02-15 00:48:58.000000', 'consum', 0.0217, 'lps'),
	(547652, 130, '2014-02-15 00:48:59.000000', 'consum', 0.0214, 'lps'),
	(547653, 130, '2014-02-15 00:49:00.000000', 'consum', 0.0226, 'lps'),
	(547654, 130, '2014-02-15 00:49:01.000000', 'consum', 0.0212, 'lps'),
	(547655, 130, '2014-02-15 00:49:02.000000', 'consum', 0.0220, 'lps'),
	(547656, 130, '2014-02-15 00:49:03.000000', 'consum', 0.0224, 'lps'),
	(547657, 130, '2014-02-15 00:49:04.000000', 'consum', 0.0217, 'lps'),
	(547658, 130, '2014-02-15 00:49:05.000000', 'consum', 0.0218, 'lps'),
	(547659, 130, '2014-02-15 00:49:06.000000', 'consum', 0.0213, 'lps'),
	(547660, 130, '2014-02-15 00:49:07.000000', 'consum', 0.0220, 'lps'),
	(547661, 130, '2014-02-15 00:49:08.000000', 'consum', 0.0217, 'lps'),
	(547662, 130, '2014-02-15 00:49:09.000000', 'consum', 0.0217, 'lps'),
	(547663, 130, '2014-02-15 00:49:10.000000', 'consum', 0.0224, 'lps'),
	(547664, 130, '2014-02-15 00:49:11.000000', 'consum', 0.0223, 'lps'),
	(547665, 130, '2014-02-15 00:49:12.000000', 'consum', 0.0220, 'lps'),
	(547666, 130, '2014-02-15 00:49:13.000000', 'consum', 0.0220, 'lps'),
	(547667, 130, '2014-02-15 00:49:14.000000', 'consum', 0.0214, 'lps'),
	(547668, 130, '2014-02-15 00:49:15.000000', 'consum', 0.0219, 'lps'),
	(547669, 130, '2014-02-15 00:49:16.000000', 'consum', 0.0226, 'lps'),
	(547670, 130, '2014-02-15 00:49:17.000000', 'consum', 0.0214, 'lps'),
	(547671, 130, '2014-02-15 00:49:18.000000', 'consum', 0.0214, 'lps'),
	(547672, 130, '2014-02-15 00:49:19.000000', 'consum', 0.0217, 'lps'),
	(547673, 130, '2014-02-15 00:49:20.000000', 'consum', 0.0219, 'lps'),
	(547674, 130, '2014-02-15 00:49:21.000000', 'consum', 0.0215, 'lps'),
	(547675, 130, '2014-02-15 00:49:22.000000', 'consum', 0.0212, 'lps'),
	(547676, 130, '2014-02-15 00:49:23.000000', 'consum', 0.0220, 'lps'),
	(547677, 130, '2014-02-15 00:49:24.000000', 'consum', 0.0220, 'lps'),
	(547678, 130, '2014-02-15 00:49:25.000000', 'consum', 0.0214, 'lps'),
	(547679, 130, '2014-02-15 00:49:26.000000', 'consum', 0.0220, 'lps'),
	(547680, 130, '2014-02-15 00:49:27.000000', 'consum', 0.0211, 'lps'),
	(547681, 130, '2014-02-15 00:49:28.000000', 'consum', 0.0220, 'lps'),
	(547682, 130, '2014-02-15 00:49:29.000000', 'consum', 0.0225, 'lps'),
	(547683, 130, '2014-02-15 00:49:30.000000', 'consum', 0.0219, 'lps'),
	(547684, 130, '2014-02-15 00:49:31.000000', 'consum', 0.0212, 'lps'),
	(547685, 130, '2014-02-15 00:49:32.000000', 'consum', 0.0210, 'lps'),
	(547686, 130, '2014-02-15 00:49:33.000000', 'consum', 0.0223, 'lps'),
	(547687, 130, '2014-02-15 00:49:34.000000', 'consum', 0.0224, 'lps'),
	(547688, 130, '2014-02-15 00:49:35.000000', 'consum', 0.0225, 'lps'),
	(547689, 130, '2014-02-15 00:49:36.000000', 'consum', 0.0210, 'lps'),
	(547690, 130, '2014-02-15 00:49:37.000000', 'consum', 0.0214, 'lps'),
	(547691, 130, '2014-02-15 00:49:38.000000', 'consum', 0.0214, 'lps'),
	(547692, 130, '2014-02-15 00:49:39.000000', 'consum', 0.0218, 'lps'),
	(547693, 130, '2014-02-15 00:49:40.000000', 'consum', 0.0224, 'lps'),
	(547694, 130, '2014-02-15 00:49:41.000000', 'consum', 0.0221, 'lps'),
	(547695, 130, '2014-02-15 00:49:42.000000', 'consum', 0.0223, 'lps'),
	(547696, 130, '2014-02-15 00:49:43.000000', 'consum', 0.0211, 'lps'),
	(547697, 130, '2014-02-15 00:49:44.000000', 'consum', 0.0226, 'lps'),
	(547698, 130, '2014-02-15 00:49:45.000000', 'consum', 0.0218, 'lps'),
	(547699, 130, '2014-02-15 00:49:46.000000', 'consum', 0.0220, 'lps'),
	(547700, 130, '2014-02-15 00:49:47.000000', 'consum', 0.0220, 'lps'),
	(547701, 130, '2014-02-15 00:49:48.000000', 'consum', 0.0214, 'lps'),
	(547702, 130, '2014-02-15 00:49:49.000000', 'consum', 0.0218, 'lps'),
	(547703, 130, '2014-02-15 00:49:50.000000', 'consum', 0.0219, 'lps'),
	(547704, 130, '2014-02-15 00:49:51.000000', 'consum', 0.0215, 'lps'),
	(547705, 130, '2014-02-15 00:49:52.000000', 'consum', 0.0210, 'lps'),
	(547706, 130, '2014-02-15 00:49:53.000000', 'consum', 0.0213, 'lps'),
	(547707, 130, '2014-02-15 00:49:54.000000', 'consum', 0.0224, 'lps'),
	(547708, 130, '2014-02-15 00:49:55.000000', 'consum', 0.0223, 'lps'),
	(547709, 130, '2014-02-15 00:49:56.000000', 'consum', 0.0214, 'lps'),
	(547710, 130, '2014-02-15 00:49:57.000000', 'consum', 0.0225, 'lps'),
	(547711, 130, '2014-02-15 00:49:58.000000', 'consum', 0.0222, 'lps'),
	(547712, 130, '2014-02-15 00:49:59.000000', 'consum', 0.0226, 'lps'),
	(547713, 130, '2014-02-15 00:50:00.000000', 'consum', 0.0219, 'lps'),
	(547714, 130, '2014-02-15 00:50:01.000000', 'consum', 0.0226, 'lps'),
	(547715, 130, '2014-02-15 00:50:02.000000', 'consum', 0.0211, 'lps'),
	(547716, 130, '2014-02-15 00:50:03.000000', 'consum', 0.0219, 'lps'),
	(547717, 130, '2014-02-15 00:50:04.000000', 'consum', 0.0218, 'lps'),
	(547718, 130, '2014-02-15 00:50:05.000000', 'consum', 0.0225, 'lps'),
	(547719, 130, '2014-02-15 00:50:06.000000', 'consum', 0.0212, 'lps'),
	(547720, 130, '2014-02-15 00:50:07.000000', 'consum', 0.0224, 'lps'),
	(547721, 130, '2014-02-15 00:50:08.000000', 'consum', 0.0222, 'lps'),
	(547722, 130, '2014-02-15 00:50:09.000000', 'consum', 0.0215, 'lps'),
	(547723, 130, '2014-02-15 00:50:10.000000', 'consum', 0.0215, 'lps'),
	(547724, 130, '2014-02-15 00:50:11.000000', 'consum', 0.0223, 'lps'),
	(547725, 130, '2014-02-15 00:50:12.000000', 'consum', 0.0224, 'lps'),
	(547726, 130, '2014-02-15 00:50:13.000000', 'consum', 0.0223, 'lps'),
	(547727, 130, '2014-02-15 00:50:14.000000', 'consum', 0.0218, 'lps'),
	(547728, 130, '2014-02-15 00:50:15.000000', 'consum', 0.0211, 'lps'),
	(547729, 130, '2014-02-15 00:50:16.000000', 'consum', 0.0225, 'lps'),
	(547730, 130, '2014-02-15 00:50:17.000000', 'consum', 0.0216, 'lps'),
	(547731, 130, '2014-02-15 00:50:18.000000', 'consum', 0.0213, 'lps'),
	(547732, 130, '2014-02-15 00:50:19.000000', 'consum', 0.0222, 'lps'),
	(547733, 130, '2014-02-15 00:50:20.000000', 'consum', 0.0214, 'lps'),
	(547734, 130, '2014-02-15 00:50:21.000000', 'consum', 0.0226, 'lps'),
	(547735, 130, '2014-02-15 00:50:22.000000', 'consum', 0.0211, 'lps'),
	(547736, 130, '2014-02-15 00:50:23.000000', 'consum', 0.0219, 'lps'),
	(547737, 130, '2014-02-15 00:50:24.000000', 'consum', 0.0218, 'lps'),
	(547738, 130, '2014-02-15 00:50:25.000000', 'consum', 0.0223, 'lps'),
	(547739, 130, '2014-02-15 00:50:26.000000', 'consum', 0.0216, 'lps'),
	(547740, 130, '2014-02-15 00:50:27.000000', 'consum', 0.0220, 'lps'),
	(547741, 130, '2014-02-15 00:50:28.000000', 'consum', 0.0226, 'lps'),
	(547742, 130, '2014-02-15 00:50:29.000000', 'consum', 0.0225, 'lps'),
	(547743, 130, '2014-02-15 00:50:30.000000', 'consum', 0.0223, 'lps'),
	(547744, 130, '2014-02-15 00:50:31.000000', 'consum', 0.0212, 'lps'),
	(547745, 130, '2014-02-15 00:50:32.000000', 'consum', 0.0217, 'lps'),
	(547746, 130, '2014-02-15 00:50:33.000000', 'consum', 0.0221, 'lps'),
	(547747, 130, '2014-02-15 00:50:34.000000', 'consum', 0.0211, 'lps'),
	(547748, 130, '2014-02-15 00:50:35.000000', 'consum', 0.0219, 'lps'),
	(547749, 130, '2014-02-15 00:50:36.000000', 'consum', 0.0215, 'lps'),
	(547750, 130, '2014-02-15 00:50:37.000000', 'consum', 0.0225, 'lps'),
	(547751, 130, '2014-02-15 00:50:38.000000', 'consum', 0.0221, 'lps'),
	(547752, 130, '2014-02-15 00:50:39.000000', 'consum', 0.0222, 'lps'),
	(547753, 130, '2014-02-15 00:50:40.000000', 'consum', 0.0221, 'lps'),
	(547754, 130, '2014-02-15 00:50:41.000000', 'consum', 0.0226, 'lps'),
	(547755, 130, '2014-02-15 00:50:42.000000', 'consum', 0.0210, 'lps'),
	(547756, 130, '2014-02-15 00:50:43.000000', 'consum', 0.0211, 'lps'),
	(547757, 130, '2014-02-15 00:50:44.000000', 'consum', 0.0217, 'lps'),
	(547758, 130, '2014-02-15 00:50:45.000000', 'consum', 0.0225, 'lps'),
	(547759, 130, '2014-02-15 00:50:46.000000', 'consum', 0.0215, 'lps'),
	(547760, 130, '2014-02-15 00:50:47.000000', 'consum', 0.0223, 'lps'),
	(547761, 130, '2014-02-15 00:50:48.000000', 'consum', 0.0210, 'lps'),
	(547762, 130, '2014-02-15 00:50:49.000000', 'consum', 0.0222, 'lps'),
	(547763, 130, '2014-02-15 00:50:50.000000', 'consum', 0.0220, 'lps'),
	(547764, 130, '2014-02-15 00:50:51.000000', 'consum', 0.0225, 'lps'),
	(547765, 130, '2014-02-15 00:50:52.000000', 'consum', 0.0220, 'lps'),
	(547766, 130, '2014-02-15 00:50:53.000000', 'consum', 0.0218, 'lps'),
	(547767, 130, '2014-02-15 00:50:54.000000', 'consum', 0.0220, 'lps'),
	(547768, 130, '2014-02-15 00:50:55.000000', 'consum', 0.0218, 'lps'),
	(547769, 130, '2014-02-15 00:50:56.000000', 'consum', 0.0222, 'lps'),
	(547770, 130, '2014-02-15 00:50:57.000000', 'consum', 0.0211, 'lps'),
	(547771, 130, '2014-02-15 00:50:58.000000', 'consum', 0.0216, 'lps'),
	(547772, 130, '2014-02-15 00:50:59.000000', 'consum', 0.0218, 'lps'),
	(547773, 130, '2014-02-15 00:51:00.000000', 'consum', 0.0214, 'lps'),
	(547774, 130, '2014-02-15 00:51:01.000000', 'consum', 0.0226, 'lps'),
	(547775, 130, '2014-02-15 00:51:02.000000', 'consum', 0.0211, 'lps'),
	(547776, 130, '2014-02-15 00:51:03.000000', 'consum', 0.0218, 'lps'),
	(547777, 130, '2014-02-15 00:51:04.000000', 'consum', 0.0212, 'lps'),
	(547778, 130, '2014-02-15 00:51:05.000000', 'consum', 0.0216, 'lps'),
	(547779, 130, '2014-02-15 00:51:06.000000', 'consum', 0.0216, 'lps'),
	(547780, 130, '2014-02-15 00:51:07.000000', 'consum', 0.0223, 'lps'),
	(547781, 130, '2014-02-15 00:51:08.000000', 'consum', 0.0223, 'lps'),
	(547782, 130, '2014-02-15 00:51:09.000000', 'consum', 0.0219, 'lps'),
	(547783, 130, '2014-02-15 00:51:10.000000', 'consum', 0.0215, 'lps'),
	(547784, 130, '2014-02-15 00:51:11.000000', 'consum', 0.0210, 'lps'),
	(547785, 130, '2014-02-15 00:51:12.000000', 'consum', 0.0212, 'lps'),
	(547786, 130, '2014-02-15 00:51:13.000000', 'consum', 0.0219, 'lps'),
	(547787, 130, '2014-02-15 00:51:14.000000', 'consum', 0.0217, 'lps'),
	(547788, 130, '2014-02-15 00:51:15.000000', 'consum', 0.0217, 'lps'),
	(547789, 130, '2014-02-15 00:51:16.000000', 'consum', 0.0226, 'lps'),
	(547790, 130, '2014-02-15 00:51:17.000000', 'consum', 0.0217, 'lps'),
	(547791, 130, '2014-02-15 00:51:18.000000', 'consum', 0.0214, 'lps'),
	(547792, 130, '2014-02-15 00:51:19.000000', 'consum', 0.0211, 'lps'),
	(547793, 130, '2014-02-15 00:51:20.000000', 'consum', 0.0222, 'lps'),
	(547794, 130, '2014-02-15 00:51:21.000000', 'consum', 0.0214, 'lps'),
	(547795, 130, '2014-02-15 00:51:22.000000', 'consum', 0.0213, 'lps'),
	(547796, 130, '2014-02-15 00:51:23.000000', 'consum', 0.0215, 'lps'),
	(547797, 130, '2014-02-15 00:51:24.000000', 'consum', 0.0223, 'lps'),
	(547798, 130, '2014-02-15 00:51:25.000000', 'consum', 0.0212, 'lps'),
	(547799, 130, '2014-02-15 00:51:26.000000', 'consum', 0.0214, 'lps'),
	(547800, 130, '2014-02-15 00:51:27.000000', 'consum', 0.0224, 'lps'),
	(547801, 130, '2014-02-15 00:51:28.000000', 'consum', 0.0219, 'lps'),
	(547802, 130, '2014-02-15 00:51:29.000000', 'consum', 0.0213, 'lps'),
	(547803, 130, '2014-02-15 00:51:30.000000', 'consum', 0.0214, 'lps'),
	(547804, 130, '2014-02-15 00:51:31.000000', 'consum', 0.0221, 'lps'),
	(547805, 130, '2014-02-15 00:51:32.000000', 'consum', 0.0219, 'lps'),
	(547806, 130, '2014-02-15 00:51:33.000000', 'consum', 0.0225, 'lps'),
	(547807, 130, '2014-02-15 00:51:34.000000', 'consum', 0.0223, 'lps'),
	(547808, 130, '2014-02-15 00:51:35.000000', 'consum', 0.0215, 'lps'),
	(547809, 130, '2014-02-15 00:51:36.000000', 'consum', 0.0213, 'lps'),
	(547810, 130, '2014-02-15 00:51:37.000000', 'consum', 0.0212, 'lps'),
	(547811, 130, '2014-02-15 00:51:38.000000', 'consum', 0.0210, 'lps'),
	(547812, 130, '2014-02-15 00:51:39.000000', 'consum', 0.0222, 'lps'),
	(547813, 130, '2014-02-15 00:51:40.000000', 'consum', 0.0217, 'lps'),
	(547814, 130, '2014-02-15 00:51:41.000000', 'consum', 0.0212, 'lps'),
	(547815, 130, '2014-02-15 00:51:42.000000', 'consum', 0.0215, 'lps'),
	(547816, 130, '2014-02-15 00:51:43.000000', 'consum', 0.0214, 'lps'),
	(547817, 130, '2014-02-15 00:51:44.000000', 'consum', 0.0214, 'lps'),
	(547818, 130, '2014-02-15 00:51:45.000000', 'consum', 0.0219, 'lps'),
	(547819, 130, '2014-02-15 00:51:46.000000', 'consum', 0.0210, 'lps'),
	(547820, 130, '2014-02-15 00:51:47.000000', 'consum', 0.0217, 'lps'),
	(547821, 130, '2014-02-15 00:51:48.000000', 'consum', 0.0211, 'lps'),
	(547822, 130, '2014-02-15 00:51:49.000000', 'consum', 0.0213, 'lps'),
	(547823, 130, '2014-02-15 00:51:50.000000', 'consum', 0.0222, 'lps'),
	(547824, 130, '2014-02-15 00:51:51.000000', 'consum', 0.0210, 'lps'),
	(547825, 130, '2014-02-15 00:51:52.000000', 'consum', 0.0226, 'lps'),
	(547826, 130, '2014-02-15 00:51:53.000000', 'consum', 0.0223, 'lps'),
	(547827, 130, '2014-02-15 00:51:54.000000', 'consum', 0.0212, 'lps'),
	(547828, 130, '2014-02-15 00:51:55.000000', 'consum', 0.0214, 'lps'),
	(547829, 130, '2014-02-15 00:51:56.000000', 'consum', 0.0225, 'lps'),
	(547830, 130, '2014-02-15 00:51:57.000000', 'consum', 0.0222, 'lps'),
	(547831, 130, '2014-02-15 00:51:58.000000', 'consum', 0.0225, 'lps'),
	(547832, 130, '2014-02-15 00:51:59.000000', 'consum', 0.0216, 'lps'),
	(547833, 130, '2014-02-15 00:52:00.000000', 'consum', 0.0211, 'lps'),
	(547834, 130, '2014-02-15 00:52:01.000000', 'consum', 0.0215, 'lps'),
	(547835, 130, '2014-02-15 00:52:02.000000', 'consum', 0.0217, 'lps'),
	(547836, 130, '2014-02-15 00:52:03.000000', 'consum', 0.0212, 'lps'),
	(547837, 130, '2014-02-15 00:52:04.000000', 'consum', 0.0215, 'lps'),
	(547838, 130, '2014-02-15 00:52:05.000000', 'consum', 0.0215, 'lps'),
	(547839, 130, '2014-02-15 00:52:06.000000', 'consum', 0.0219, 'lps'),
	(547840, 130, '2014-02-15 00:52:07.000000', 'consum', 0.0222, 'lps'),
	(547841, 130, '2014-02-15 00:52:08.000000', 'consum', 0.0212, 'lps'),
	(547842, 130, '2014-02-15 00:52:09.000000', 'consum', 0.0217, 'lps'),
	(547843, 130, '2014-02-15 00:52:10.000000', 'consum', 0.0224, 'lps'),
	(547844, 130, '2014-02-15 00:52:11.000000', 'consum', 0.0224, 'lps'),
	(547845, 130, '2014-02-15 00:52:12.000000', 'consum', 0.0220, 'lps'),
	(547846, 130, '2014-02-15 00:52:13.000000', 'consum', 0.0222, 'lps'),
	(547847, 130, '2014-02-15 00:52:14.000000', 'consum', 0.0221, 'lps'),
	(547848, 130, '2014-02-15 00:52:15.000000', 'consum', 0.0215, 'lps'),
	(547849, 130, '2014-02-15 00:52:16.000000', 'consum', 0.0216, 'lps'),
	(547850, 130, '2014-02-15 00:52:17.000000', 'consum', 0.0211, 'lps'),
	(547851, 130, '2014-02-15 00:52:18.000000', 'consum', 0.0213, 'lps'),
	(547852, 130, '2014-02-15 00:52:19.000000', 'consum', 0.0223, 'lps'),
	(547853, 130, '2014-02-15 00:52:20.000000', 'consum', 0.0216, 'lps'),
	(547854, 130, '2014-02-15 00:52:21.000000', 'consum', 0.0217, 'lps'),
	(547855, 130, '2014-02-15 00:52:22.000000', 'consum', 0.0211, 'lps'),
	(547856, 130, '2014-02-15 00:52:23.000000', 'consum', 0.0210, 'lps'),
	(547857, 130, '2014-02-15 00:52:24.000000', 'consum', 0.0226, 'lps'),
	(547858, 130, '2014-02-15 00:52:25.000000', 'consum', 0.0220, 'lps'),
	(547859, 130, '2014-02-15 00:52:26.000000', 'consum', 0.0216, 'lps'),
	(547860, 130, '2014-02-15 00:52:27.000000', 'consum', 0.0210, 'lps'),
	(547861, 130, '2014-02-15 00:52:28.000000', 'consum', 0.0225, 'lps'),
	(547862, 130, '2014-02-15 00:52:29.000000', 'consum', 0.0217, 'lps'),
	(547863, 130, '2014-02-15 00:52:30.000000', 'consum', 0.0217, 'lps'),
	(547864, 130, '2014-02-15 00:52:31.000000', 'consum', 0.0224, 'lps'),
	(547865, 130, '2014-02-15 00:52:32.000000', 'consum', 0.0225, 'lps'),
	(547866, 130, '2014-02-15 00:52:33.000000', 'consum', 0.0211, 'lps'),
	(547867, 130, '2014-02-15 00:52:34.000000', 'consum', 0.0219, 'lps'),
	(547868, 130, '2014-02-15 00:52:35.000000', 'consum', 0.0221, 'lps'),
	(547869, 130, '2014-02-15 00:52:36.000000', 'consum', 0.0221, 'lps'),
	(547870, 130, '2014-02-15 00:52:37.000000', 'consum', 0.0216, 'lps'),
	(547871, 130, '2014-02-15 00:52:38.000000', 'consum', 0.0224, 'lps'),
	(547872, 130, '2014-02-15 00:52:39.000000', 'consum', 0.0211, 'lps'),
	(547873, 130, '2014-02-15 00:52:40.000000', 'consum', 0.0225, 'lps'),
	(547874, 130, '2014-02-15 00:52:41.000000', 'consum', 0.0216, 'lps'),
	(547875, 130, '2014-02-15 00:52:42.000000', 'consum', 0.0211, 'lps'),
	(547876, 130, '2014-02-15 00:52:43.000000', 'consum', 0.0214, 'lps'),
	(547877, 130, '2014-02-15 00:52:44.000000', 'consum', 0.0213, 'lps'),
	(547878, 130, '2014-02-15 00:52:45.000000', 'consum', 0.0213, 'lps'),
	(547879, 130, '2014-02-15 00:52:46.000000', 'consum', 0.0215, 'lps'),
	(547880, 130, '2014-02-15 00:52:47.000000', 'consum', 0.0210, 'lps'),
	(547881, 130, '2014-02-15 00:52:48.000000', 'consum', 0.0213, 'lps'),
	(547882, 130, '2014-02-15 00:52:49.000000', 'consum', 0.0224, 'lps'),
	(547883, 130, '2014-02-15 00:52:50.000000', 'consum', 0.0223, 'lps'),
	(547884, 130, '2014-02-15 00:52:51.000000', 'consum', 0.0215, 'lps'),
	(547885, 130, '2014-02-15 00:52:52.000000', 'consum', 0.0215, 'lps'),
	(547886, 130, '2014-02-15 00:52:53.000000', 'consum', 0.0219, 'lps'),
	(547887, 130, '2014-02-15 00:52:54.000000', 'consum', 0.0223, 'lps'),
	(547888, 130, '2014-02-15 00:52:55.000000', 'consum', 0.0217, 'lps'),
	(547889, 130, '2014-02-15 00:52:56.000000', 'consum', 0.0221, 'lps'),
	(547890, 130, '2014-02-15 00:52:57.000000', 'consum', 0.0211, 'lps'),
	(547891, 130, '2014-02-15 00:52:58.000000', 'consum', 0.0217, 'lps'),
	(547892, 130, '2014-02-15 00:52:59.000000', 'consum', 0.0223, 'lps'),
	(547893, 130, '2014-02-15 00:53:00.000000', 'consum', 0.0223, 'lps'),
	(547894, 130, '2014-02-15 00:53:01.000000', 'consum', 0.0220, 'lps'),
	(547895, 130, '2014-02-15 00:53:02.000000', 'consum', 0.0222, 'lps'),
	(547896, 130, '2014-02-15 00:53:03.000000', 'consum', 0.0223, 'lps'),
	(547897, 130, '2014-02-15 00:53:04.000000', 'consum', 0.0221, 'lps'),
	(547898, 130, '2014-02-15 00:53:05.000000', 'consum', 0.0212, 'lps'),
	(547899, 130, '2014-02-15 00:53:06.000000', 'consum', 0.0220, 'lps'),
	(547900, 130, '2014-02-15 00:53:07.000000', 'consum', 0.0220, 'lps'),
	(547901, 130, '2014-02-15 00:53:08.000000', 'consum', 0.0214, 'lps'),
	(547902, 130, '2014-02-15 00:53:09.000000', 'consum', 0.0219, 'lps'),
	(547903, 130, '2014-02-15 00:53:10.000000', 'consum', 0.0226, 'lps'),
	(547904, 130, '2014-02-15 00:53:11.000000', 'consum', 0.0213, 'lps'),
	(547905, 130, '2014-02-15 00:53:12.000000', 'consum', 0.0211, 'lps'),
	(547906, 130, '2014-02-15 00:53:13.000000', 'consum', 0.0225, 'lps'),
	(547907, 130, '2014-02-15 00:53:14.000000', 'consum', 0.0213, 'lps'),
	(547908, 130, '2014-02-15 00:53:15.000000', 'consum', 0.0213, 'lps'),
	(547909, 130, '2014-02-15 00:53:16.000000', 'consum', 0.0217, 'lps'),
	(547910, 130, '2014-02-15 00:53:17.000000', 'consum', 0.0221, 'lps'),
	(547911, 130, '2014-02-15 00:53:18.000000', 'consum', 0.0212, 'lps'),
	(547912, 130, '2014-02-15 00:53:19.000000', 'consum', 0.0219, 'lps'),
	(547913, 130, '2014-02-15 00:53:20.000000', 'consum', 0.0218, 'lps'),
	(547914, 130, '2014-02-15 00:53:21.000000', 'consum', 0.0223, 'lps'),
	(547915, 130, '2014-02-15 00:53:22.000000', 'consum', 0.0215, 'lps'),
	(547916, 130, '2014-02-15 00:53:23.000000', 'consum', 0.0216, 'lps'),
	(547917, 130, '2014-02-15 00:53:24.000000', 'consum', 0.0224, 'lps'),
	(547918, 130, '2014-02-15 00:53:25.000000', 'consum', 0.0213, 'lps'),
	(547919, 130, '2014-02-15 00:53:26.000000', 'consum', 0.0216, 'lps'),
	(547920, 130, '2014-02-15 00:53:27.000000', 'consum', 0.0217, 'lps'),
	(547921, 130, '2014-02-15 00:53:28.000000', 'consum', 0.0210, 'lps'),
	(547922, 130, '2014-02-15 00:53:29.000000', 'consum', 0.0223, 'lps'),
	(547923, 130, '2014-02-15 00:53:30.000000', 'consum', 0.0223, 'lps'),
	(547924, 130, '2014-02-15 00:53:31.000000', 'consum', 0.0219, 'lps'),
	(547925, 130, '2014-02-15 00:53:32.000000', 'consum', 0.0216, 'lps'),
	(547926, 130, '2014-02-15 00:53:33.000000', 'consum', 0.0215, 'lps'),
	(547927, 130, '2014-02-15 00:53:34.000000', 'consum', 0.0216, 'lps'),
	(547928, 130, '2014-02-15 00:53:35.000000', 'consum', 0.0211, 'lps'),
	(547929, 130, '2014-02-15 00:53:36.000000', 'consum', 0.0215, 'lps'),
	(547930, 130, '2014-02-15 00:53:37.000000', 'consum', 0.0215, 'lps'),
	(547931, 130, '2014-02-15 00:53:38.000000', 'consum', 0.0220, 'lps'),
	(547932, 130, '2014-02-15 00:53:39.000000', 'consum', 0.0212, 'lps'),
	(547933, 130, '2014-02-15 00:53:40.000000', 'consum', 0.0224, 'lps'),
	(547934, 130, '2014-02-15 00:53:41.000000', 'consum', 0.0223, 'lps'),
	(547935, 130, '2014-02-15 00:53:42.000000', 'consum', 0.0217, 'lps'),
	(547936, 130, '2014-02-15 00:53:43.000000', 'consum', 0.0225, 'lps'),
	(547937, 130, '2014-02-15 00:53:44.000000', 'consum', 0.0215, 'lps'),
	(547938, 130, '2014-02-15 00:53:45.000000', 'consum', 0.0221, 'lps'),
	(547939, 130, '2014-02-15 00:53:46.000000', 'consum', 0.0217, 'lps'),
	(547940, 130, '2014-02-15 00:53:47.000000', 'consum', 0.0212, 'lps'),
	(547941, 130, '2014-02-15 00:53:48.000000', 'consum', 0.0215, 'lps'),
	(547942, 130, '2014-02-15 00:53:49.000000', 'consum', 0.0215, 'lps'),
	(547943, 130, '2014-02-15 00:53:50.000000', 'consum', 0.0221, 'lps'),
	(547944, 130, '2014-02-15 00:53:51.000000', 'consum', 0.0215, 'lps'),
	(547945, 130, '2014-02-15 00:53:52.000000', 'consum', 0.0222, 'lps'),
	(547946, 130, '2014-02-15 00:53:53.000000', 'consum', 0.0219, 'lps'),
	(547947, 130, '2014-02-15 00:53:54.000000', 'consum', 0.0219, 'lps'),
	(547948, 130, '2014-02-15 00:53:55.000000', 'consum', 0.0214, 'lps'),
	(547949, 130, '2014-02-15 00:53:56.000000', 'consum', 0.0221, 'lps'),
	(547950, 130, '2014-02-15 00:53:57.000000', 'consum', 0.0220, 'lps'),
	(547951, 130, '2014-02-15 00:53:58.000000', 'consum', 0.0225, 'lps'),
	(547952, 130, '2014-02-15 00:53:59.000000', 'consum', 0.0221, 'lps'),
	(547953, 130, '2014-02-15 00:54:00.000000', 'consum', 0.0220, 'lps'),
	(547954, 130, '2014-02-15 00:54:01.000000', 'consum', 0.0213, 'lps'),
	(547955, 130, '2014-02-15 00:54:02.000000', 'consum', 0.0212, 'lps'),
	(547956, 130, '2014-02-15 00:54:03.000000', 'consum', 0.0226, 'lps'),
	(547957, 130, '2014-02-15 00:54:04.000000', 'consum', 0.0220, 'lps'),
	(547958, 130, '2014-02-15 00:54:05.000000', 'consum', 0.0211, 'lps'),
	(547959, 130, '2014-02-15 00:54:06.000000', 'consum', 0.0221, 'lps'),
	(547960, 130, '2014-02-15 00:54:07.000000', 'consum', 0.0211, 'lps'),
	(547961, 130, '2014-02-15 00:54:08.000000', 'consum', 0.0216, 'lps'),
	(547962, 130, '2014-02-15 00:54:09.000000', 'consum', 0.0221, 'lps'),
	(547963, 130, '2014-02-15 00:54:10.000000', 'consum', 0.0215, 'lps'),
	(547964, 130, '2014-02-15 00:54:11.000000', 'consum', 0.0219, 'lps'),
	(547965, 130, '2014-02-15 00:54:12.000000', 'consum', 0.0224, 'lps'),
	(547966, 130, '2014-02-15 00:54:13.000000', 'consum', 0.0219, 'lps'),
	(547967, 130, '2014-02-15 00:54:14.000000', 'consum', 0.0215, 'lps'),
	(547968, 130, '2014-02-15 00:54:15.000000', 'consum', 0.0223, 'lps'),
	(547969, 130, '2014-02-15 00:54:16.000000', 'consum', 0.0225, 'lps'),
	(547970, 130, '2014-02-15 00:54:17.000000', 'consum', 0.0216, 'lps'),
	(547971, 130, '2014-02-15 00:54:18.000000', 'consum', 0.0213, 'lps'),
	(547972, 130, '2014-02-15 00:54:19.000000', 'consum', 0.0221, 'lps'),
	(547973, 130, '2014-02-15 00:54:20.000000', 'consum', 0.0226, 'lps'),
	(547974, 130, '2014-02-15 00:54:21.000000', 'consum', 0.0221, 'lps'),
	(547975, 130, '2014-02-15 00:54:22.000000', 'consum', 0.0220, 'lps'),
	(547976, 130, '2014-02-15 00:54:23.000000', 'consum', 0.0226, 'lps'),
	(547977, 130, '2014-02-15 00:54:24.000000', 'consum', 0.0210, 'lps'),
	(547978, 130, '2014-02-15 00:54:25.000000', 'consum', 0.0213, 'lps'),
	(547979, 130, '2014-02-15 00:54:26.000000', 'consum', 0.0211, 'lps'),
	(547980, 130, '2014-02-15 00:54:27.000000', 'consum', 0.0220, 'lps'),
	(547981, 130, '2014-02-15 00:54:28.000000', 'consum', 0.0225, 'lps'),
	(547982, 130, '2014-02-15 00:54:29.000000', 'consum', 0.0221, 'lps'),
	(547983, 130, '2014-02-15 00:54:30.000000', 'consum', 0.0219, 'lps'),
	(547984, 130, '2014-02-15 00:54:31.000000', 'consum', 0.0226, 'lps'),
	(547985, 130, '2014-02-15 00:54:32.000000', 'consum', 0.0210, 'lps'),
	(547986, 130, '2014-02-15 00:54:33.000000', 'consum', 0.0214, 'lps'),
	(547987, 130, '2014-02-15 00:54:34.000000', 'consum', 0.0214, 'lps'),
	(547988, 130, '2014-02-15 00:54:35.000000', 'consum', 0.0220, 'lps'),
	(547989, 130, '2014-02-15 00:54:36.000000', 'consum', 0.0212, 'lps'),
	(547990, 130, '2014-02-15 00:54:37.000000', 'consum', 0.0225, 'lps'),
	(547991, 130, '2014-02-15 00:54:38.000000', 'consum', 0.0211, 'lps'),
	(547992, 130, '2014-02-15 00:54:39.000000', 'consum', 0.0223, 'lps'),
	(547993, 130, '2014-02-15 00:54:40.000000', 'consum', 0.0220, 'lps'),
	(547994, 130, '2014-02-15 00:54:41.000000', 'consum', 0.0222, 'lps'),
	(547995, 130, '2014-02-15 00:54:42.000000', 'consum', 0.0224, 'lps'),
	(547996, 130, '2014-02-15 00:54:43.000000', 'consum', 0.0225, 'lps'),
	(547997, 130, '2014-02-15 00:54:44.000000', 'consum', 0.0212, 'lps'),
	(547998, 130, '2014-02-15 00:54:45.000000', 'consum', 0.0225, 'lps'),
	(547999, 130, '2014-02-15 00:54:46.000000', 'consum', 0.0213, 'lps'),
	(548000, 130, '2014-02-15 00:54:47.000000', 'consum', 0.0213, 'lps'),
	(548001, 130, '2014-02-15 00:54:48.000000', 'consum', 0.0217, 'lps'),
	(548002, 130, '2014-02-15 00:54:49.000000', 'consum', 0.0220, 'lps'),
	(548003, 130, '2014-02-15 00:54:50.000000', 'consum', 0.0220, 'lps'),
	(548004, 130, '2014-02-15 00:54:51.000000', 'consum', 0.0217, 'lps'),
	(548005, 130, '2014-02-15 00:54:52.000000', 'consum', 0.0215, 'lps'),
	(548006, 130, '2014-02-15 00:54:53.000000', 'consum', 0.0212, 'lps'),
	(548007, 130, '2014-02-15 00:54:54.000000', 'consum', 0.0224, 'lps'),
	(548008, 130, '2014-02-15 00:54:55.000000', 'consum', 0.0223, 'lps'),
	(548009, 130, '2014-02-15 00:54:56.000000', 'consum', 0.0217, 'lps'),
	(548010, 130, '2014-02-15 00:54:57.000000', 'consum', 0.0225, 'lps'),
	(548011, 130, '2014-02-15 00:54:58.000000', 'consum', 0.0211, 'lps'),
	(548012, 130, '2014-02-15 00:54:59.000000', 'consum', 0.0222, 'lps'),
	(548013, 130, '2014-02-15 00:55:00.000000', 'consum', 0.0215, 'lps'),
	(548014, 130, '2014-02-15 00:55:01.000000', 'consum', 0.0218, 'lps'),
	(548015, 130, '2014-02-15 00:55:02.000000', 'consum', 0.0217, 'lps'),
	(548016, 130, '2014-02-15 00:55:03.000000', 'consum', 0.0224, 'lps'),
	(548017, 130, '2014-02-15 00:55:04.000000', 'consum', 0.0223, 'lps'),
	(548018, 130, '2014-02-15 00:55:05.000000', 'consum', 0.0219, 'lps'),
	(548019, 130, '2014-02-15 00:55:06.000000', 'consum', 0.0217, 'lps'),
	(548020, 130, '2014-02-15 00:55:07.000000', 'consum', 0.0216, 'lps'),
	(548021, 130, '2014-02-15 00:55:08.000000', 'consum', 0.0218, 'lps'),
	(548022, 130, '2014-02-15 00:55:09.000000', 'consum', 0.0219, 'lps'),
	(548023, 130, '2014-02-15 00:55:10.000000', 'consum', 0.0212, 'lps'),
	(548024, 130, '2014-02-15 00:55:11.000000', 'consum', 0.0212, 'lps'),
	(548025, 130, '2014-02-15 00:55:12.000000', 'consum', 0.0215, 'lps'),
	(548026, 130, '2014-02-15 00:55:13.000000', 'consum', 0.0213, 'lps'),
	(548027, 130, '2014-02-15 00:55:14.000000', 'consum', 0.0210, 'lps'),
	(548028, 130, '2014-02-15 00:55:15.000000', 'consum', 0.0217, 'lps'),
	(548029, 130, '2014-02-15 00:55:16.000000', 'consum', 0.0212, 'lps'),
	(548030, 130, '2014-02-15 00:55:17.000000', 'consum', 0.0216, 'lps'),
	(548031, 130, '2014-02-15 00:55:18.000000', 'consum', 0.0217, 'lps'),
	(548032, 130, '2014-02-15 00:55:19.000000', 'consum', 0.0211, 'lps'),
	(548033, 130, '2014-02-15 00:55:20.000000', 'consum', 0.0212, 'lps'),
	(548034, 130, '2014-02-15 00:55:21.000000', 'consum', 0.0217, 'lps'),
	(548035, 130, '2014-02-15 00:55:22.000000', 'consum', 0.0221, 'lps'),
	(548036, 130, '2014-02-15 00:55:23.000000', 'consum', 0.0212, 'lps'),
	(548037, 130, '2014-02-15 00:55:24.000000', 'consum', 0.0219, 'lps'),
	(548038, 130, '2014-02-15 00:55:25.000000', 'consum', 0.0219, 'lps'),
	(548039, 130, '2014-02-15 00:55:26.000000', 'consum', 0.0226, 'lps'),
	(548040, 130, '2014-02-15 00:55:27.000000', 'consum', 0.0213, 'lps'),
	(548041, 130, '2014-02-15 00:55:28.000000', 'consum', 0.0211, 'lps'),
	(548042, 130, '2014-02-15 00:55:29.000000', 'consum', 0.0225, 'lps'),
	(548043, 130, '2014-02-15 00:55:30.000000', 'consum', 0.0212, 'lps'),
	(548044, 130, '2014-02-15 00:55:31.000000', 'consum', 0.0213, 'lps'),
	(548045, 130, '2014-02-15 00:55:32.000000', 'consum', 0.0218, 'lps'),
	(548046, 130, '2014-02-15 00:55:33.000000', 'consum', 0.0222, 'lps'),
	(548047, 130, '2014-02-15 00:55:34.000000', 'consum', 0.0216, 'lps'),
	(548048, 130, '2014-02-15 00:55:35.000000', 'consum', 0.0221, 'lps'),
	(548049, 130, '2014-02-15 00:55:36.000000', 'consum', 0.0212, 'lps'),
	(548050, 130, '2014-02-15 00:55:37.000000', 'consum', 0.0220, 'lps'),
	(548051, 130, '2014-02-15 00:55:38.000000', 'consum', 0.0223, 'lps'),
	(548052, 130, '2014-02-15 00:55:39.000000', 'consum', 0.0212, 'lps'),
	(548053, 130, '2014-02-15 00:55:40.000000', 'consum', 0.0214, 'lps'),
	(548054, 130, '2014-02-15 00:55:41.000000', 'consum', 0.0225, 'lps'),
	(548055, 130, '2014-02-15 00:55:42.000000', 'consum', 0.0221, 'lps'),
	(548056, 130, '2014-02-15 00:55:43.000000', 'consum', 0.0221, 'lps'),
	(548057, 130, '2014-02-15 00:55:44.000000', 'consum', 0.0215, 'lps'),
	(548058, 130, '2014-02-15 00:55:45.000000', 'consum', 0.0220, 'lps'),
	(548059, 130, '2014-02-15 00:55:46.000000', 'consum', 0.0211, 'lps'),
	(548060, 130, '2014-02-15 00:55:47.000000', 'consum', 0.0220, 'lps'),
	(548061, 130, '2014-02-15 00:55:48.000000', 'consum', 0.0221, 'lps'),
	(548062, 130, '2014-02-15 00:55:49.000000', 'consum', 0.0222, 'lps'),
	(548063, 130, '2014-02-15 00:55:50.000000', 'consum', 0.0219, 'lps'),
	(548064, 130, '2014-02-15 00:55:51.000000', 'consum', 0.0221, 'lps'),
	(548065, 130, '2014-02-15 00:55:52.000000', 'consum', 0.0222, 'lps'),
	(548066, 130, '2014-02-15 00:55:53.000000', 'consum', 0.0220, 'lps'),
	(548067, 130, '2014-02-15 00:55:54.000000', 'consum', 0.0223, 'lps'),
	(548068, 130, '2014-02-15 00:55:55.000000', 'consum', 0.0211, 'lps'),
	(548069, 130, '2014-02-15 00:55:56.000000', 'consum', 0.0211, 'lps'),
	(548070, 130, '2014-02-15 00:55:57.000000', 'consum', 0.0214, 'lps'),
	(548071, 130, '2014-02-15 00:55:58.000000', 'consum', 0.0210, 'lps'),
	(548072, 130, '2014-02-15 00:55:59.000000', 'consum', 0.0213, 'lps'),
	(548073, 130, '2014-02-15 00:56:00.000000', 'consum', 0.0211, 'lps'),
	(548074, 130, '2014-02-15 00:56:01.000000', 'consum', 0.0224, 'lps'),
	(548075, 130, '2014-02-15 00:56:02.000000', 'consum', 0.0224, 'lps'),
	(548076, 130, '2014-02-15 00:56:03.000000', 'consum', 0.0224, 'lps'),
	(548077, 130, '2014-02-15 00:56:04.000000', 'consum', 0.0219, 'lps'),
	(548078, 130, '2014-02-15 00:56:05.000000', 'consum', 0.0216, 'lps'),
	(548079, 130, '2014-02-15 00:56:06.000000', 'consum', 0.0211, 'lps'),
	(548080, 130, '2014-02-15 00:56:07.000000', 'consum', 0.0217, 'lps'),
	(548081, 130, '2014-02-15 00:56:08.000000', 'consum', 0.0226, 'lps'),
	(548082, 130, '2014-02-15 00:56:09.000000', 'consum', 0.0216, 'lps'),
	(548083, 130, '2014-02-15 00:56:10.000000', 'consum', 0.0212, 'lps'),
	(548084, 130, '2014-02-15 00:56:11.000000', 'consum', 0.0217, 'lps'),
	(548085, 130, '2014-02-15 00:56:12.000000', 'consum', 0.0224, 'lps'),
	(548086, 130, '2014-02-15 00:56:13.000000', 'consum', 0.0226, 'lps'),
	(548087, 130, '2014-02-15 00:56:14.000000', 'consum', 0.0213, 'lps'),
	(548088, 130, '2014-02-15 00:56:15.000000', 'consum', 0.0214, 'lps'),
	(548089, 130, '2014-02-15 00:56:16.000000', 'consum', 0.0220, 'lps'),
	(548090, 130, '2014-02-15 00:56:17.000000', 'consum', 0.0215, 'lps'),
	(548091, 130, '2014-02-15 00:56:18.000000', 'consum', 0.0223, 'lps'),
	(548092, 130, '2014-02-15 00:56:19.000000', 'consum', 0.0225, 'lps'),
	(548093, 130, '2014-02-15 00:56:20.000000', 'consum', 0.0214, 'lps'),
	(548094, 130, '2014-02-15 00:56:21.000000', 'consum', 0.0220, 'lps'),
	(548095, 130, '2014-02-15 00:56:22.000000', 'consum', 0.0215, 'lps'),
	(548096, 130, '2014-02-15 00:56:23.000000', 'consum', 0.0222, 'lps'),
	(548097, 130, '2014-02-15 00:56:24.000000', 'consum', 0.0222, 'lps'),
	(548098, 130, '2014-02-15 00:56:25.000000', 'consum', 0.0216, 'lps'),
	(548099, 130, '2014-02-15 00:56:26.000000', 'consum', 0.0220, 'lps'),
	(548100, 130, '2014-02-15 00:56:27.000000', 'consum', 0.0212, 'lps'),
	(548101, 130, '2014-02-15 00:56:28.000000', 'consum', 0.0223, 'lps'),
	(548102, 130, '2014-02-15 00:56:29.000000', 'consum', 0.0219, 'lps'),
	(548103, 130, '2014-02-15 00:56:30.000000', 'consum', 0.0215, 'lps'),
	(548104, 130, '2014-02-15 00:56:31.000000', 'consum', 0.0226, 'lps'),
	(548105, 130, '2014-02-15 00:56:32.000000', 'consum', 0.0223, 'lps'),
	(548106, 130, '2014-02-15 00:56:33.000000', 'consum', 0.0213, 'lps'),
	(548107, 130, '2014-02-15 00:56:34.000000', 'consum', 0.0218, 'lps'),
	(548108, 130, '2014-02-15 00:56:35.000000', 'consum', 0.0211, 'lps'),
	(548109, 130, '2014-02-15 00:56:36.000000', 'consum', 0.0223, 'lps'),
	(548110, 130, '2014-02-15 00:56:37.000000', 'consum', 0.0220, 'lps'),
	(548111, 130, '2014-02-15 00:56:38.000000', 'consum', 0.0225, 'lps'),
	(548112, 130, '2014-02-15 00:56:39.000000', 'consum', 0.0220, 'lps'),
	(548113, 130, '2014-02-15 00:56:40.000000', 'consum', 0.0216, 'lps'),
	(548114, 130, '2014-02-15 00:56:41.000000', 'consum', 0.0226, 'lps'),
	(548115, 130, '2014-02-15 00:56:42.000000', 'consum', 0.0221, 'lps'),
	(548116, 130, '2014-02-15 00:56:43.000000', 'consum', 0.0219, 'lps'),
	(548117, 130, '2014-02-15 00:56:44.000000', 'consum', 0.0222, 'lps'),
	(548118, 130, '2014-02-15 00:56:45.000000', 'consum', 0.0226, 'lps'),
	(548119, 130, '2014-02-15 00:56:46.000000', 'consum', 0.0220, 'lps'),
	(548120, 130, '2014-02-15 00:56:47.000000', 'consum', 0.0213, 'lps'),
	(548121, 130, '2014-02-15 00:56:48.000000', 'consum', 0.0211, 'lps'),
	(548122, 130, '2014-02-15 00:56:49.000000', 'consum', 0.0223, 'lps'),
	(548123, 130, '2014-02-15 00:56:50.000000', 'consum', 0.0223, 'lps'),
	(548124, 130, '2014-02-15 00:56:51.000000', 'consum', 0.0219, 'lps'),
	(548125, 130, '2014-02-15 00:56:52.000000', 'consum', 0.0217, 'lps'),
	(548126, 130, '2014-02-15 00:56:53.000000', 'consum', 0.0219, 'lps'),
	(548127, 130, '2014-02-15 00:56:54.000000', 'consum', 0.0217, 'lps'),
	(548128, 130, '2014-02-15 00:56:55.000000', 'consum', 0.0219, 'lps'),
	(548129, 130, '2014-02-15 00:56:56.000000', 'consum', 0.0217, 'lps'),
	(548130, 130, '2014-02-15 00:56:57.000000', 'consum', 0.0217, 'lps'),
	(548131, 130, '2014-02-15 00:56:58.000000', 'consum', 0.0226, 'lps'),
	(548132, 130, '2014-02-15 00:56:59.000000', 'consum', 0.0219, 'lps'),
	(548133, 130, '2014-02-15 00:57:00.000000', 'consum', 0.0226, 'lps'),
	(548134, 130, '2014-02-15 00:57:01.000000', 'consum', 0.0210, 'lps'),
	(548135, 130, '2014-02-15 00:57:02.000000', 'consum', 0.0216, 'lps'),
	(548136, 130, '2014-02-15 00:57:03.000000', 'consum', 0.0222, 'lps'),
	(548137, 130, '2014-02-15 00:57:04.000000', 'consum', 0.0217, 'lps'),
	(548138, 130, '2014-02-15 00:57:05.000000', 'consum', 0.0213, 'lps'),
	(548139, 130, '2014-02-15 00:57:06.000000', 'consum', 0.0219, 'lps'),
	(548140, 130, '2014-02-15 00:57:07.000000', 'consum', 0.0213, 'lps'),
	(548141, 130, '2014-02-15 00:57:08.000000', 'consum', 0.0215, 'lps'),
	(548142, 130, '2014-02-15 00:57:09.000000', 'consum', 0.0212, 'lps'),
	(548143, 130, '2014-02-15 00:57:10.000000', 'consum', 0.0220, 'lps'),
	(548144, 130, '2014-02-15 00:57:11.000000', 'consum', 0.0220, 'lps'),
	(548145, 130, '2014-02-15 00:57:12.000000', 'consum', 0.0212, 'lps'),
	(548146, 130, '2014-02-15 00:57:13.000000', 'consum', 0.0210, 'lps'),
	(548147, 130, '2014-02-15 00:57:14.000000', 'consum', 0.0223, 'lps'),
	(548148, 130, '2014-02-15 00:57:15.000000', 'consum', 0.0222, 'lps'),
	(548149, 130, '2014-02-15 00:57:16.000000', 'consum', 0.0216, 'lps'),
	(548150, 130, '2014-02-15 00:57:17.000000', 'consum', 0.0222, 'lps'),
	(548151, 130, '2014-02-15 00:57:18.000000', 'consum', 0.0216, 'lps'),
	(548152, 130, '2014-02-15 00:57:19.000000', 'consum', 0.0223, 'lps'),
	(548153, 130, '2014-02-15 00:57:20.000000', 'consum', 0.0225, 'lps'),
	(548154, 130, '2014-02-15 00:57:21.000000', 'consum', 0.0210, 'lps'),
	(548155, 130, '2014-02-15 00:57:22.000000', 'consum', 0.0216, 'lps'),
	(548156, 130, '2014-02-15 00:57:23.000000', 'consum', 0.0226, 'lps'),
	(548157, 130, '2014-02-15 00:57:24.000000', 'consum', 0.0221, 'lps'),
	(548158, 130, '2014-02-15 00:57:25.000000', 'consum', 0.0215, 'lps'),
	(548159, 130, '2014-02-15 00:57:26.000000', 'consum', 0.0221, 'lps'),
	(548160, 130, '2014-02-15 00:57:27.000000', 'consum', 0.0217, 'lps'),
	(548161, 130, '2014-02-15 00:57:28.000000', 'consum', 0.0212, 'lps'),
	(548162, 130, '2014-02-15 00:57:29.000000', 'consum', 0.0218, 'lps'),
	(548163, 130, '2014-02-15 00:57:30.000000', 'consum', 0.0210, 'lps'),
	(548164, 130, '2014-02-15 00:57:31.000000', 'consum', 0.0222, 'lps'),
	(548165, 130, '2014-02-15 00:57:32.000000', 'consum', 0.0216, 'lps'),
	(548166, 130, '2014-02-15 00:57:33.000000', 'consum', 0.0225, 'lps'),
	(548167, 130, '2014-02-15 00:57:34.000000', 'consum', 0.0215, 'lps'),
	(548168, 130, '2014-02-15 00:57:35.000000', 'consum', 0.0226, 'lps'),
	(548169, 130, '2014-02-15 00:57:36.000000', 'consum', 0.0224, 'lps'),
	(548170, 130, '2014-02-15 00:57:37.000000', 'consum', 0.0217, 'lps'),
	(548171, 130, '2014-02-15 00:57:38.000000', 'consum', 0.0218, 'lps'),
	(548172, 130, '2014-02-15 00:57:39.000000', 'consum', 0.0213, 'lps'),
	(548173, 130, '2014-02-15 00:57:40.000000', 'consum', 0.0220, 'lps'),
	(548174, 130, '2014-02-15 00:57:41.000000', 'consum', 0.0215, 'lps'),
	(548175, 130, '2014-02-15 00:57:42.000000', 'consum', 0.0222, 'lps'),
	(548176, 130, '2014-02-15 00:57:43.000000', 'consum', 0.0221, 'lps'),
	(548177, 130, '2014-02-15 00:57:44.000000', 'consum', 0.0212, 'lps'),
	(548178, 130, '2014-02-15 00:57:45.000000', 'consum', 0.0224, 'lps'),
	(548179, 130, '2014-02-15 00:57:46.000000', 'consum', 0.0224, 'lps'),
	(548180, 130, '2014-02-15 00:57:47.000000', 'consum', 0.0223, 'lps'),
	(548181, 130, '2014-02-15 00:57:48.000000', 'consum', 0.0213, 'lps'),
	(548182, 130, '2014-02-15 00:57:49.000000', 'consum', 0.0221, 'lps'),
	(548183, 130, '2014-02-15 00:57:50.000000', 'consum', 0.0223, 'lps'),
	(548184, 130, '2014-02-15 00:57:51.000000', 'consum', 0.0223, 'lps'),
	(548185, 130, '2014-02-15 00:57:52.000000', 'consum', 0.0223, 'lps'),
	(548186, 130, '2014-02-15 00:57:53.000000', 'consum', 0.0217, 'lps'),
	(548187, 130, '2014-02-15 00:57:54.000000', 'consum', 0.0210, 'lps'),
	(548188, 130, '2014-02-15 00:57:55.000000', 'consum', 0.0220, 'lps'),
	(548189, 130, '2014-02-15 00:57:56.000000', 'consum', 0.0226, 'lps'),
	(548190, 130, '2014-02-15 00:57:57.000000', 'consum', 0.0212, 'lps'),
	(548191, 130, '2014-02-15 00:57:58.000000', 'consum', 0.0222, 'lps'),
	(548192, 130, '2014-02-15 00:57:59.000000', 'consum', 0.0213, 'lps'),
	(548193, 130, '2014-02-15 00:58:00.000000', 'consum', 0.0225, 'lps'),
	(548194, 130, '2014-02-15 00:58:01.000000', 'consum', 0.0226, 'lps'),
	(548195, 130, '2014-02-15 00:58:02.000000', 'consum', 0.0210, 'lps'),
	(548196, 130, '2014-02-15 00:58:03.000000', 'consum', 0.0215, 'lps'),
	(548197, 130, '2014-02-15 00:58:04.000000', 'consum', 0.0220, 'lps'),
	(548198, 130, '2014-02-15 00:58:05.000000', 'consum', 0.0225, 'lps'),
	(548199, 130, '2014-02-15 00:58:06.000000', 'consum', 0.0223, 'lps'),
	(548200, 130, '2014-02-15 00:58:07.000000', 'consum', 0.0212, 'lps'),
	(548201, 130, '2014-02-15 00:58:08.000000', 'consum', 0.0218, 'lps'),
	(548202, 130, '2014-02-15 00:58:09.000000', 'consum', 0.0210, 'lps'),
	(548203, 130, '2014-02-15 00:58:10.000000', 'consum', 0.0220, 'lps'),
	(548204, 130, '2014-02-15 00:58:11.000000', 'consum', 0.0225, 'lps'),
	(548205, 130, '2014-02-15 00:58:12.000000', 'consum', 0.0225, 'lps'),
	(548206, 130, '2014-02-15 00:58:13.000000', 'consum', 0.0221, 'lps'),
	(548207, 130, '2014-02-15 00:58:14.000000', 'consum', 0.0219, 'lps'),
	(548208, 130, '2014-02-15 00:58:15.000000', 'consum', 0.0224, 'lps'),
	(548209, 130, '2014-02-15 00:58:16.000000', 'consum', 0.0219, 'lps'),
	(548210, 130, '2014-02-15 00:58:17.000000', 'consum', 0.0212, 'lps'),
	(548211, 130, '2014-02-15 00:58:18.000000', 'consum', 0.0211, 'lps'),
	(548212, 130, '2014-02-15 00:58:19.000000', 'consum', 0.0211, 'lps'),
	(548213, 130, '2014-02-15 00:58:20.000000', 'consum', 0.0211, 'lps'),
	(548214, 130, '2014-02-15 00:58:21.000000', 'consum', 0.0213, 'lps'),
	(548215, 130, '2014-02-15 00:58:22.000000', 'consum', 0.0223, 'lps'),
	(548216, 130, '2014-02-15 00:58:23.000000', 'consum', 0.0216, 'lps'),
	(548217, 130, '2014-02-15 00:58:24.000000', 'consum', 0.0220, 'lps'),
	(548218, 130, '2014-02-15 00:58:25.000000', 'consum', 0.0223, 'lps'),
	(548219, 130, '2014-02-15 00:58:26.000000', 'consum', 0.0210, 'lps'),
	(548220, 130, '2014-02-15 00:58:27.000000', 'consum', 0.0225, 'lps'),
	(548221, 130, '2014-02-15 00:58:28.000000', 'consum', 0.0215, 'lps'),
	(548222, 130, '2014-02-15 00:58:29.000000', 'consum', 0.0225, 'lps'),
	(548223, 130, '2014-02-15 00:58:30.000000', 'consum', 0.0220, 'lps'),
	(548224, 130, '2014-02-15 00:58:31.000000', 'consum', 0.0216, 'lps'),
	(548225, 130, '2014-02-15 00:58:32.000000', 'consum', 0.0211, 'lps'),
	(548226, 130, '2014-02-15 00:58:33.000000', 'consum', 0.0214, 'lps'),
	(548227, 130, '2014-02-15 00:58:34.000000', 'consum', 0.0210, 'lps'),
	(548228, 130, '2014-02-15 00:58:35.000000', 'consum', 0.0215, 'lps'),
	(548229, 130, '2014-02-15 00:58:36.000000', 'consum', 0.0221, 'lps'),
	(548230, 130, '2014-02-15 00:58:37.000000', 'consum', 0.0213, 'lps'),
	(548231, 130, '2014-02-15 00:58:38.000000', 'consum', 0.0213, 'lps'),
	(548232, 130, '2014-02-15 00:58:39.000000', 'consum', 0.0214, 'lps'),
	(548233, 130, '2014-02-15 00:58:40.000000', 'consum', 0.0222, 'lps'),
	(548234, 130, '2014-02-15 00:58:41.000000', 'consum', 0.0226, 'lps'),
	(548235, 130, '2014-02-15 00:58:42.000000', 'consum', 0.0221, 'lps'),
	(548236, 130, '2014-02-15 00:58:43.000000', 'consum', 0.0216, 'lps'),
	(548237, 130, '2014-02-15 00:58:44.000000', 'consum', 0.0210, 'lps'),
	(548238, 130, '2014-02-15 00:58:45.000000', 'consum', 0.0224, 'lps'),
	(548239, 130, '2014-02-15 00:58:46.000000', 'consum', 0.0214, 'lps'),
	(548240, 130, '2014-02-15 00:58:47.000000', 'consum', 0.0223, 'lps'),
	(548241, 130, '2014-02-15 00:58:48.000000', 'consum', 0.0212, 'lps'),
	(548242, 130, '2014-02-15 00:58:49.000000', 'consum', 0.0215, 'lps'),
	(548243, 130, '2014-02-15 00:58:50.000000', 'consum', 0.0212, 'lps'),
	(548244, 130, '2014-02-15 00:58:51.000000', 'consum', 0.0223, 'lps'),
	(548245, 130, '2014-02-15 00:58:52.000000', 'consum', 0.0218, 'lps'),
	(548246, 130, '2014-02-15 00:58:53.000000', 'consum', 0.0212, 'lps'),
	(548247, 130, '2014-02-15 00:58:54.000000', 'consum', 0.0212, 'lps'),
	(548248, 130, '2014-02-15 00:58:55.000000', 'consum', 0.0214, 'lps'),
	(548249, 130, '2014-02-15 00:58:56.000000', 'consum', 0.0226, 'lps'),
	(548250, 130, '2014-02-15 00:58:57.000000', 'consum', 0.0226, 'lps'),
	(548251, 130, '2014-02-15 00:58:58.000000', 'consum', 0.0225, 'lps'),
	(548252, 130, '2014-02-15 00:58:59.000000', 'consum', 0.0223, 'lps'),
	(548253, 130, '2014-02-15 00:59:00.000000', 'consum', 0.0213, 'lps'),
	(548254, 130, '2014-02-15 00:59:01.000000', 'consum', 0.0219, 'lps'),
	(548255, 130, '2014-02-15 00:59:02.000000', 'consum', 0.0212, 'lps'),
	(548256, 130, '2014-02-15 00:59:03.000000', 'consum', 0.0211, 'lps'),
	(548257, 130, '2014-02-15 00:59:04.000000', 'consum', 0.0211, 'lps'),
	(548258, 130, '2014-02-15 00:59:05.000000', 'consum', 0.0212, 'lps'),
	(548259, 130, '2014-02-15 00:59:06.000000', 'consum', 0.0218, 'lps'),
	(548260, 130, '2014-02-15 00:59:07.000000', 'consum', 0.0226, 'lps'),
	(548261, 130, '2014-02-15 00:59:08.000000', 'consum', 0.0214, 'lps'),
	(548262, 130, '2014-02-15 00:59:09.000000', 'consum', 0.0219, 'lps'),
	(548263, 130, '2014-02-15 00:59:10.000000', 'consum', 0.0224, 'lps'),
	(548264, 130, '2014-02-15 00:59:11.000000', 'consum', 0.0223, 'lps'),
	(548265, 130, '2014-02-15 00:59:12.000000', 'consum', 0.0213, 'lps'),
	(548266, 130, '2014-02-15 00:59:13.000000', 'consum', 0.0222, 'lps'),
	(548267, 130, '2014-02-15 00:59:14.000000', 'consum', 0.0226, 'lps'),
	(548268, 130, '2014-02-15 00:59:15.000000', 'consum', 0.0221, 'lps'),
	(548269, 130, '2014-02-15 00:59:16.000000', 'consum', 0.0220, 'lps'),
	(548270, 130, '2014-02-15 00:59:17.000000', 'consum', 0.0225, 'lps'),
	(548271, 130, '2014-02-15 00:59:18.000000', 'consum', 0.0221, 'lps'),
	(548272, 130, '2014-02-15 00:59:19.000000', 'consum', 0.0222, 'lps'),
	(548273, 130, '2014-02-15 00:59:20.000000', 'consum', 0.0220, 'lps'),
	(548274, 130, '2014-02-15 00:59:21.000000', 'consum', 0.0225, 'lps'),
	(548275, 130, '2014-02-15 00:59:22.000000', 'consum', 0.0221, 'lps'),
	(548276, 130, '2014-02-15 00:59:23.000000', 'consum', 0.0222, 'lps'),
	(548277, 130, '2014-02-15 00:59:24.000000', 'consum', 0.0221, 'lps'),
	(548278, 130, '2014-02-15 00:59:25.000000', 'consum', 0.0210, 'lps'),
	(548279, 130, '2014-02-15 00:59:26.000000', 'consum', 0.0212, 'lps'),
	(548280, 130, '2014-02-15 00:59:27.000000', 'consum', 0.0221, 'lps'),
	(548281, 130, '2014-02-15 00:59:28.000000', 'consum', 0.0210, 'lps'),
	(548282, 130, '2014-02-15 00:59:29.000000', 'consum', 0.0211, 'lps'),
	(548283, 130, '2014-02-15 00:59:30.000000', 'consum', 0.0214, 'lps'),
	(548284, 130, '2014-02-15 00:59:31.000000', 'consum', 0.0226, 'lps'),
	(548285, 130, '2014-02-15 00:59:32.000000', 'consum', 0.0213, 'lps'),
	(548286, 130, '2014-02-15 00:59:33.000000', 'consum', 0.0211, 'lps'),
	(548287, 130, '2014-02-15 00:59:34.000000', 'consum', 0.0222, 'lps'),
	(548288, 130, '2014-02-15 00:59:35.000000', 'consum', 0.0219, 'lps'),
	(548289, 130, '2014-02-15 00:59:36.000000', 'consum', 0.0219, 'lps'),
	(548290, 130, '2014-02-15 00:59:37.000000', 'consum', 0.0212, 'lps'),
	(548291, 130, '2014-02-15 00:59:38.000000', 'consum', 0.0210, 'lps'),
	(548292, 130, '2014-02-15 00:59:39.000000', 'consum', 0.0220, 'lps'),
	(548293, 130, '2014-02-15 00:59:40.000000', 'consum', 0.0211, 'lps'),
	(548294, 130, '2014-02-15 00:59:41.000000', 'consum', 0.0217, 'lps'),
	(548295, 130, '2014-02-15 00:59:42.000000', 'consum', 0.0210, 'lps'),
	(548296, 130, '2014-02-15 00:59:43.000000', 'consum', 0.0224, 'lps'),
	(548297, 130, '2014-02-15 00:59:44.000000', 'consum', 0.0212, 'lps'),
	(548298, 130, '2014-02-15 00:59:45.000000', 'consum', 0.0212, 'lps'),
	(548299, 130, '2014-02-15 00:59:46.000000', 'consum', 0.0214, 'lps'),
	(548300, 130, '2014-02-15 00:59:47.000000', 'consum', 0.0223, 'lps'),
	(548301, 130, '2014-02-15 00:59:48.000000', 'consum', 0.0216, 'lps'),
	(548302, 130, '2014-02-15 00:59:49.000000', 'consum', 0.0217, 'lps'),
	(548303, 130, '2014-02-15 00:59:50.000000', 'consum', 0.0210, 'lps'),
	(548304, 130, '2014-02-15 00:59:51.000000', 'consum', 0.0222, 'lps'),
	(548305, 130, '2014-02-15 00:59:52.000000', 'consum', 0.0221, 'lps'),
	(548306, 130, '2014-02-15 00:59:53.000000', 'consum', 0.0211, 'lps'),
	(548307, 130, '2014-02-15 00:59:54.000000', 'consum', 0.0217, 'lps'),
	(548308, 130, '2014-02-15 00:59:55.000000', 'consum', 0.0211, 'lps'),
	(548309, 130, '2014-02-15 00:59:56.000000', 'consum', 0.0226, 'lps'),
	(548310, 130, '2014-02-15 00:59:57.000000', 'consum', 0.0220, 'lps'),
	(548311, 130, '2014-02-15 00:59:58.000000', 'consum', 0.0212, 'lps'),
	(548312, 130, '2014-02-15 00:59:59.000000', 'consum', 0.0225, 'lps'),
	(548313, 130, '2014-02-15 01:00:00.000000', 'consum', 0.0211, 'lps'),
	(548314, 130, '2014-02-15 01:00:01.000000', 'consum', 0.0220, 'lps'),
	(548315, 130, '2014-02-15 01:00:02.000000', 'consum', 0.0226, 'lps'),
	(548316, 130, '2014-02-15 01:00:03.000000', 'consum', 0.0225, 'lps'),
	(548317, 130, '2014-02-15 01:00:04.000000', 'consum', 0.0222, 'lps'),
	(548318, 130, '2014-02-15 01:00:05.000000', 'consum', 0.0226, 'lps'),
	(548319, 130, '2014-02-15 01:00:06.000000', 'consum', 0.0222, 'lps'),
	(548320, 130, '2014-02-15 01:00:07.000000', 'consum', 0.0219, 'lps'),
	(548321, 130, '2014-02-15 01:00:08.000000', 'consum', 0.0222, 'lps'),
	(548322, 130, '2014-02-15 01:00:09.000000', 'consum', 0.0224, 'lps'),
	(548323, 130, '2014-02-15 01:00:10.000000', 'consum', 0.0214, 'lps'),
	(548324, 130, '2014-02-15 01:00:11.000000', 'consum', 0.0220, 'lps'),
	(548325, 130, '2014-02-15 01:00:12.000000', 'consum', 0.0215, 'lps'),
	(548326, 130, '2014-02-15 01:00:13.000000', 'consum', 0.0223, 'lps'),
	(548327, 130, '2014-02-15 01:00:14.000000', 'consum', 0.0225, 'lps'),
	(548328, 130, '2014-02-15 01:00:15.000000', 'consum', 0.0213, 'lps'),
	(548329, 130, '2014-02-15 01:00:16.000000', 'consum', 0.0214, 'lps'),
	(548330, 130, '2014-02-15 01:00:17.000000', 'consum', 0.0222, 'lps'),
	(548331, 130, '2014-02-15 01:00:18.000000', 'consum', 0.0223, 'lps'),
	(548332, 130, '2014-02-15 01:00:19.000000', 'consum', 0.0224, 'lps'),
	(548333, 130, '2014-02-15 01:00:20.000000', 'consum', 0.0226, 'lps'),
	(548334, 130, '2014-02-15 01:00:21.000000', 'consum', 0.0213, 'lps'),
	(548335, 130, '2014-02-15 01:00:22.000000', 'consum', 0.0211, 'lps'),
	(548336, 130, '2014-02-15 01:00:23.000000', 'consum', 0.0223, 'lps'),
	(548337, 130, '2014-02-15 01:00:24.000000', 'consum', 0.0221, 'lps'),
	(548338, 130, '2014-02-15 01:00:25.000000', 'consum', 0.0226, 'lps'),
	(548339, 130, '2014-02-15 01:00:26.000000', 'consum', 0.0224, 'lps'),
	(548340, 130, '2014-02-15 01:00:27.000000', 'consum', 0.0215, 'lps'),
	(548341, 130, '2014-02-15 01:00:28.000000', 'consum', 0.0213, 'lps'),
	(548342, 130, '2014-02-15 01:00:29.000000', 'consum', 0.0224, 'lps'),
	(548343, 130, '2014-02-15 01:00:30.000000', 'consum', 0.0223, 'lps'),
	(548344, 130, '2014-02-15 01:00:31.000000', 'consum', 0.0215, 'lps'),
	(548345, 130, '2014-02-15 01:00:32.000000', 'consum', 0.0215, 'lps'),
	(548346, 130, '2014-02-15 01:00:33.000000', 'consum', 0.0221, 'lps'),
	(548347, 130, '2014-02-15 01:00:34.000000', 'consum', 0.0218, 'lps'),
	(548348, 130, '2014-02-15 01:00:35.000000', 'consum', 0.0214, 'lps'),
	(548349, 130, '2014-02-15 01:00:36.000000', 'consum', 0.0226, 'lps'),
	(548350, 130, '2014-02-15 01:00:37.000000', 'consum', 0.0212, 'lps'),
	(548351, 130, '2014-02-15 01:00:38.000000', 'consum', 0.0220, 'lps'),
	(548352, 130, '2014-02-15 01:00:39.000000', 'consum', 0.0221, 'lps'),
	(548353, 130, '2014-02-15 01:00:40.000000', 'consum', 0.0218, 'lps'),
	(548354, 130, '2014-02-15 01:00:41.000000', 'consum', 0.0217, 'lps'),
	(548355, 130, '2014-02-15 01:00:42.000000', 'consum', 0.0223, 'lps'),
	(548356, 130, '2014-02-15 01:00:43.000000', 'consum', 0.0220, 'lps'),
	(548357, 130, '2014-02-15 01:00:44.000000', 'consum', 0.0220, 'lps'),
	(548358, 130, '2014-02-15 01:00:45.000000', 'consum', 0.0213, 'lps'),
	(548359, 130, '2014-02-15 01:00:46.000000', 'consum', 0.0213, 'lps'),
	(548360, 130, '2014-02-15 01:00:47.000000', 'consum', 0.0216, 'lps'),
	(548361, 130, '2014-02-15 01:00:48.000000', 'consum', 0.0214, 'lps'),
	(548362, 130, '2014-02-15 01:00:49.000000', 'consum', 0.0214, 'lps'),
	(548363, 130, '2014-02-15 01:00:50.000000', 'consum', 0.0218, 'lps'),
	(548364, 130, '2014-02-15 01:00:51.000000', 'consum', 0.0221, 'lps'),
	(548365, 130, '2014-02-15 01:00:52.000000', 'consum', 0.0223, 'lps'),
	(548366, 130, '2014-02-15 01:00:53.000000', 'consum', 0.0211, 'lps'),
	(548367, 130, '2014-02-15 01:00:54.000000', 'consum', 0.0225, 'lps'),
	(548368, 130, '2014-02-15 01:00:55.000000', 'consum', 0.0218, 'lps'),
	(548369, 130, '2014-02-15 01:00:56.000000', 'consum', 0.0220, 'lps'),
	(548370, 130, '2014-02-15 01:00:57.000000', 'consum', 0.0220, 'lps'),
	(548371, 130, '2014-02-15 01:00:58.000000', 'consum', 0.0213, 'lps'),
	(548372, 130, '2014-02-15 01:00:59.000000', 'consum', 0.0213, 'lps'),
	(548373, 130, '2014-02-15 01:01:00.000000', 'consum', 0.0217, 'lps'),
	(548374, 130, '2014-02-15 01:01:01.000000', 'consum', 0.0221, 'lps'),
	(548375, 130, '2014-02-15 01:01:02.000000', 'consum', 0.0225, 'lps'),
	(548376, 130, '2014-02-15 01:01:03.000000', 'consum', 0.0220, 'lps'),
	(548377, 130, '2014-02-15 01:01:04.000000', 'consum', 0.0213, 'lps'),
	(548378, 130, '2014-02-15 01:01:05.000000', 'consum', 0.0216, 'lps'),
	(548379, 130, '2014-02-15 01:01:06.000000', 'consum', 0.0212, 'lps'),
	(548380, 130, '2014-02-15 01:01:07.000000', 'consum', 0.0218, 'lps'),
	(548381, 130, '2014-02-15 01:01:08.000000', 'consum', 0.0213, 'lps'),
	(548382, 130, '2014-02-15 01:01:09.000000', 'consum', 0.0217, 'lps'),
	(548383, 130, '2014-02-15 01:01:10.000000', 'consum', 0.0219, 'lps'),
	(548384, 130, '2014-02-15 01:01:11.000000', 'consum', 0.0217, 'lps'),
	(548385, 130, '2014-02-15 01:01:12.000000', 'consum', 0.0217, 'lps'),
	(548386, 130, '2014-02-15 01:01:13.000000', 'consum', 0.0211, 'lps'),
	(548387, 130, '2014-02-15 01:01:14.000000', 'consum', 0.0225, 'lps'),
	(548388, 130, '2014-02-15 01:01:15.000000', 'consum', 0.0218, 'lps'),
	(548389, 130, '2014-02-15 01:01:16.000000', 'consum', 0.0221, 'lps'),
	(548390, 130, '2014-02-15 01:01:17.000000', 'consum', 0.0223, 'lps'),
	(548391, 130, '2014-02-15 01:01:18.000000', 'consum', 0.0211, 'lps'),
	(548392, 131, '2014-02-15 00:00:00.000000', 'consum', 0.0234, 'lps'),
	(548393, 131, '2014-02-15 00:00:01.000000', 'consum', 0.0220, 'lps'),
	(548394, 131, '2014-02-15 00:00:02.000000', 'consum', 0.0218, 'lps'),
	(548395, 131, '2014-02-15 00:00:03.000000', 'consum', 0.0219, 'lps'),
	(548396, 131, '2014-02-15 00:00:04.000000', 'consum', 0.0234, 'lps'),
	(548397, 131, '2014-02-15 00:00:05.000000', 'consum', 0.0220, 'lps'),
	(548398, 131, '2014-02-15 00:00:06.000000', 'consum', 0.0216, 'lps'),
	(548399, 131, '2014-02-15 00:00:07.000000', 'consum', 0.0210, 'lps'),
	(548400, 131, '2014-02-15 00:00:08.000000', 'consum', 0.0221, 'lps'),
	(548401, 131, '2014-02-15 00:00:09.000000', 'consum', 0.0236, 'lps'),
	(548402, 131, '2014-02-15 00:00:10.000000', 'consum', 0.0226, 'lps'),
	(548403, 131, '2014-02-15 00:00:11.000000', 'consum', 0.0210, 'lps'),
	(548404, 131, '2014-02-15 00:00:12.000000', 'consum', 0.0220, 'lps'),
	(548405, 131, '2014-02-15 00:00:13.000000', 'consum', 0.0233, 'lps'),
	(548406, 131, '2014-02-15 00:00:14.000000', 'consum', 0.0210, 'lps'),
	(548407, 131, '2014-02-15 00:00:15.000000', 'consum', 0.0225, 'lps'),
	(548408, 131, '2014-02-15 00:00:16.000000', 'consum', 0.0229, 'lps'),
	(548409, 131, '2014-02-15 00:00:17.000000', 'consum', 0.0234, 'lps'),
	(548410, 131, '2014-02-15 00:00:18.000000', 'consum', 0.0216, 'lps'),
	(548411, 131, '2014-02-15 00:00:19.000000', 'consum', 0.0227, 'lps'),
	(548412, 131, '2014-02-15 00:00:20.000000', 'consum', 0.0218, 'lps'),
	(548413, 131, '2014-02-15 00:00:21.000000', 'consum', 0.0231, 'lps'),
	(548414, 131, '2014-02-15 00:00:22.000000', 'consum', 0.0233, 'lps'),
	(548415, 131, '2014-02-15 00:00:23.000000', 'consum', 0.0236, 'lps'),
	(548416, 131, '2014-02-15 00:00:24.000000', 'consum', 0.0217, 'lps'),
	(548417, 131, '2014-02-15 00:00:25.000000', 'consum', 0.0222, 'lps'),
	(548418, 131, '2014-02-15 00:00:26.000000', 'consum', 0.0221, 'lps'),
	(548419, 131, '2014-02-15 00:00:27.000000', 'consum', 0.0228, 'lps'),
	(548420, 131, '2014-02-15 00:00:28.000000', 'consum', 0.0214, 'lps'),
	(548421, 131, '2014-02-15 00:00:29.000000', 'consum', 0.0230, 'lps'),
	(548422, 131, '2014-02-15 00:00:30.000000', 'consum', 0.0214, 'lps'),
	(548423, 131, '2014-02-15 00:00:31.000000', 'consum', 0.0226, 'lps'),
	(548424, 131, '2014-02-15 00:00:32.000000', 'consum', 0.0225, 'lps'),
	(548425, 131, '2014-02-15 00:00:33.000000', 'consum', 0.0237, 'lps'),
	(548426, 131, '2014-02-15 00:00:34.000000', 'consum', 0.0215, 'lps'),
	(548427, 131, '2014-02-15 00:00:35.000000', 'consum', 0.0212, 'lps'),
	(548428, 131, '2014-02-15 00:00:36.000000', 'consum', 0.0235, 'lps'),
	(548429, 131, '2014-02-15 00:00:37.000000', 'consum', 0.0214, 'lps'),
	(548430, 131, '2014-02-15 00:00:38.000000', 'consum', 0.0215, 'lps'),
	(548431, 131, '2014-02-15 00:00:39.000000', 'consum', 0.0220, 'lps'),
	(548432, 131, '2014-02-15 00:00:40.000000', 'consum', 0.0220, 'lps'),
	(548433, 131, '2014-02-15 00:00:41.000000', 'consum', 0.0232, 'lps'),
	(548434, 131, '2014-02-15 00:00:42.000000', 'consum', 0.0231, 'lps'),
	(548435, 131, '2014-02-15 00:00:43.000000', 'consum', 0.0223, 'lps'),
	(548436, 131, '2014-02-15 00:00:44.000000', 'consum', 0.0214, 'lps'),
	(548437, 131, '2014-02-15 00:00:45.000000', 'consum', 0.0217, 'lps'),
	(548438, 131, '2014-02-15 00:00:46.000000', 'consum', 0.0235, 'lps'),
	(548439, 131, '2014-02-15 00:00:47.000000', 'consum', 0.0228, 'lps'),
	(548440, 131, '2014-02-15 00:00:48.000000', 'consum', 0.0229, 'lps'),
	(548441, 131, '2014-02-15 00:00:49.000000', 'consum', 0.0223, 'lps'),
	(548442, 131, '2014-02-15 00:00:50.000000', 'consum', 0.0216, 'lps'),
	(548443, 131, '2014-02-15 00:00:51.000000', 'consum', 0.0231, 'lps'),
	(548444, 131, '2014-02-15 00:00:52.000000', 'consum', 0.0215, 'lps'),
	(548445, 131, '2014-02-15 00:00:53.000000', 'consum', 0.0225, 'lps'),
	(548446, 131, '2014-02-15 00:00:54.000000', 'consum', 0.0218, 'lps'),
	(548447, 131, '2014-02-15 00:00:55.000000', 'consum', 0.0230, 'lps'),
	(548448, 131, '2014-02-15 00:00:56.000000', 'consum', 0.0232, 'lps'),
	(548449, 131, '2014-02-15 00:00:57.000000', 'consum', 0.0234, 'lps'),
	(548450, 131, '2014-02-15 00:00:58.000000', 'consum', 0.0236, 'lps'),
	(548451, 131, '2014-02-15 00:00:59.000000', 'consum', 0.0214, 'lps'),
	(548452, 131, '2014-02-15 00:01:00.000000', 'consum', 0.0236, 'lps'),
	(548453, 131, '2014-02-15 00:01:01.000000', 'consum', 0.0215, 'lps'),
	(548454, 131, '2014-02-15 00:01:02.000000', 'consum', 0.0213, 'lps'),
	(548455, 131, '2014-02-15 00:01:03.000000', 'consum', 0.0212, 'lps'),
	(548456, 131, '2014-02-15 00:01:04.000000', 'consum', 0.0210, 'lps'),
	(548457, 131, '2014-02-15 00:01:05.000000', 'consum', 0.0234, 'lps'),
	(548458, 131, '2014-02-15 00:01:06.000000', 'consum', 0.0220, 'lps'),
	(548459, 131, '2014-02-15 00:01:07.000000', 'consum', 0.0214, 'lps'),
	(548460, 131, '2014-02-15 00:01:08.000000', 'consum', 0.0231, 'lps'),
	(548461, 131, '2014-02-15 00:01:09.000000', 'consum', 0.0216, 'lps'),
	(548462, 131, '2014-02-15 00:01:10.000000', 'consum', 0.0236, 'lps'),
	(548463, 131, '2014-02-15 00:01:11.000000', 'consum', 0.0236, 'lps'),
	(548464, 131, '2014-02-15 00:01:12.000000', 'consum', 0.0210, 'lps'),
	(548465, 131, '2014-02-15 00:01:13.000000', 'consum', 0.0214, 'lps'),
	(548466, 131, '2014-02-15 00:01:14.000000', 'consum', 0.0231, 'lps'),
	(548467, 131, '2014-02-15 00:01:15.000000', 'consum', 0.0221, 'lps'),
	(548468, 131, '2014-02-15 00:01:16.000000', 'consum', 0.0228, 'lps'),
	(548469, 131, '2014-02-15 00:01:17.000000', 'consum', 0.0211, 'lps'),
	(548470, 131, '2014-02-15 00:01:18.000000', 'consum', 0.0217, 'lps'),
	(548471, 131, '2014-02-15 00:01:19.000000', 'consum', 0.0214, 'lps'),
	(548472, 131, '2014-02-15 00:01:20.000000', 'consum', 0.0237, 'lps'),
	(548473, 131, '2014-02-15 00:01:21.000000', 'consum', 0.0224, 'lps'),
	(548474, 131, '2014-02-15 00:01:22.000000', 'consum', 0.0227, 'lps'),
	(548475, 131, '2014-02-15 00:01:23.000000', 'consum', 0.0223, 'lps'),
	(548476, 131, '2014-02-15 00:01:24.000000', 'consum', 0.0227, 'lps'),
	(548477, 131, '2014-02-15 00:01:25.000000', 'consum', 0.0230, 'lps'),
	(548478, 131, '2014-02-15 00:01:26.000000', 'consum', 0.0229, 'lps'),
	(548479, 131, '2014-02-15 00:01:27.000000', 'consum', 0.0216, 'lps'),
	(548480, 131, '2014-02-15 00:01:28.000000', 'consum', 0.0215, 'lps'),
	(548481, 131, '2014-02-15 00:01:29.000000', 'consum', 0.0215, 'lps'),
	(548482, 131, '2014-02-15 00:01:30.000000', 'consum', 0.0222, 'lps'),
	(548483, 131, '2014-02-15 00:01:31.000000', 'consum', 0.0226, 'lps'),
	(548484, 131, '2014-02-15 00:01:32.000000', 'consum', 0.0228, 'lps'),
	(548485, 131, '2014-02-15 00:01:33.000000', 'consum', 0.0222, 'lps'),
	(548486, 131, '2014-02-15 00:01:34.000000', 'consum', 0.0219, 'lps'),
	(548487, 131, '2014-02-15 00:01:35.000000', 'consum', 0.0217, 'lps'),
	(548488, 131, '2014-02-15 00:01:36.000000', 'consum', 0.0219, 'lps'),
	(548489, 131, '2014-02-15 00:01:37.000000', 'consum', 0.0235, 'lps'),
	(548490, 131, '2014-02-15 00:01:38.000000', 'consum', 0.0225, 'lps'),
	(548491, 131, '2014-02-15 00:01:39.000000', 'consum', 0.0237, 'lps'),
	(548492, 131, '2014-02-15 00:01:40.000000', 'consum', 0.0218, 'lps'),
	(548493, 131, '2014-02-15 00:01:41.000000', 'consum', 0.0226, 'lps'),
	(548494, 131, '2014-02-15 00:01:42.000000', 'consum', 0.0210, 'lps'),
	(548495, 131, '2014-02-15 00:01:43.000000', 'consum', 0.0220, 'lps'),
	(548496, 131, '2014-02-15 00:01:44.000000', 'consum', 0.0233, 'lps'),
	(548497, 131, '2014-02-15 00:01:45.000000', 'consum', 0.0237, 'lps'),
	(548498, 131, '2014-02-15 00:01:46.000000', 'consum', 0.0223, 'lps'),
	(548499, 131, '2014-02-15 00:01:47.000000', 'consum', 0.0220, 'lps'),
	(548500, 131, '2014-02-15 00:01:48.000000', 'consum', 0.0224, 'lps'),
	(548501, 131, '2014-02-15 00:01:49.000000', 'consum', 0.0221, 'lps'),
	(548502, 131, '2014-02-15 00:01:50.000000', 'consum', 0.0225, 'lps'),
	(548503, 131, '2014-02-15 00:01:51.000000', 'consum', 0.0222, 'lps'),
	(548504, 131, '2014-02-15 00:01:52.000000', 'consum', 0.0229, 'lps'),
	(548505, 131, '2014-02-15 00:01:53.000000', 'consum', 0.0211, 'lps'),
	(548506, 131, '2014-02-15 00:01:54.000000', 'consum', 0.0214, 'lps'),
	(548507, 131, '2014-02-15 00:01:55.000000', 'consum', 0.0230, 'lps'),
	(548508, 131, '2014-02-15 00:01:56.000000', 'consum', 0.0212, 'lps'),
	(548509, 131, '2014-02-15 00:01:57.000000', 'consum', 0.0216, 'lps'),
	(548510, 131, '2014-02-15 00:01:58.000000', 'consum', 0.0237, 'lps'),
	(548511, 131, '2014-02-15 00:01:59.000000', 'consum', 0.0213, 'lps'),
	(548512, 131, '2014-02-15 00:02:00.000000', 'consum', 0.0228, 'lps'),
	(548513, 131, '2014-02-15 00:02:01.000000', 'consum', 0.0210, 'lps'),
	(548514, 131, '2014-02-15 00:02:02.000000', 'consum', 0.0210, 'lps'),
	(548515, 131, '2014-02-15 00:02:03.000000', 'consum', 0.0213, 'lps'),
	(548516, 131, '2014-02-15 00:02:04.000000', 'consum', 0.0223, 'lps'),
	(548517, 131, '2014-02-15 00:02:05.000000', 'consum', 0.0213, 'lps'),
	(548518, 131, '2014-02-15 00:02:06.000000', 'consum', 0.0215, 'lps'),
	(548519, 131, '2014-02-15 00:02:07.000000', 'consum', 0.0226, 'lps'),
	(548520, 131, '2014-02-15 00:02:08.000000', 'consum', 0.0221, 'lps'),
	(548521, 131, '2014-02-15 00:02:09.000000', 'consum', 0.0216, 'lps'),
	(548522, 131, '2014-02-15 00:02:10.000000', 'consum', 0.0236, 'lps'),
	(548523, 131, '2014-02-15 00:02:11.000000', 'consum', 0.0212, 'lps'),
	(548524, 131, '2014-02-15 00:02:12.000000', 'consum', 0.0226, 'lps'),
	(548525, 131, '2014-02-15 00:02:13.000000', 'consum', 0.0228, 'lps'),
	(548526, 131, '2014-02-15 00:02:14.000000', 'consum', 0.0225, 'lps'),
	(548527, 131, '2014-02-15 00:02:15.000000', 'consum', 0.0229, 'lps'),
	(548528, 131, '2014-02-15 00:02:16.000000', 'consum', 0.0235, 'lps'),
	(548529, 131, '2014-02-15 00:02:17.000000', 'consum', 0.0220, 'lps'),
	(548530, 131, '2014-02-15 00:02:18.000000', 'consum', 0.0215, 'lps'),
	(548531, 131, '2014-02-15 00:02:19.000000', 'consum', 0.0235, 'lps'),
	(548532, 131, '2014-02-15 00:02:20.000000', 'consum', 0.0236, 'lps'),
	(548533, 131, '2014-02-15 00:02:21.000000', 'consum', 0.0210, 'lps'),
	(548534, 131, '2014-02-15 00:02:22.000000', 'consum', 0.0215, 'lps'),
	(548535, 131, '2014-02-15 00:02:23.000000', 'consum', 0.0235, 'lps'),
	(548536, 131, '2014-02-15 00:02:24.000000', 'consum', 0.0237, 'lps'),
	(548537, 131, '2014-02-15 00:02:25.000000', 'consum', 0.0216, 'lps'),
	(548538, 131, '2014-02-15 00:02:26.000000', 'consum', 0.0213, 'lps'),
	(548539, 131, '2014-02-15 00:02:27.000000', 'consum', 0.0237, 'lps'),
	(548540, 131, '2014-02-15 00:02:28.000000', 'consum', 0.0222, 'lps'),
	(548541, 131, '2014-02-15 00:02:29.000000', 'consum', 0.0220, 'lps'),
	(548542, 131, '2014-02-15 00:02:30.000000', 'consum', 0.0226, 'lps'),
	(548543, 131, '2014-02-15 00:02:31.000000', 'consum', 0.0230, 'lps'),
	(548544, 131, '2014-02-15 00:02:32.000000', 'consum', 0.0236, 'lps'),
	(548545, 131, '2014-02-15 00:02:33.000000', 'consum', 0.0223, 'lps'),
	(548546, 131, '2014-02-15 00:02:34.000000', 'consum', 0.0228, 'lps'),
	(548547, 131, '2014-02-15 00:02:35.000000', 'consum', 0.0233, 'lps'),
	(548548, 131, '2014-02-15 00:02:36.000000', 'consum', 0.0214, 'lps'),
	(548549, 131, '2014-02-15 00:02:37.000000', 'consum', 0.0220, 'lps'),
	(548550, 131, '2014-02-15 00:02:38.000000', 'consum', 0.0218, 'lps'),
	(548551, 131, '2014-02-15 00:02:39.000000', 'consum', 0.0220, 'lps'),
	(548552, 131, '2014-02-15 00:02:40.000000', 'consum', 0.0236, 'lps'),
	(548553, 131, '2014-02-15 00:02:41.000000', 'consum', 0.0227, 'lps'),
	(548554, 131, '2014-02-15 00:02:42.000000', 'consum', 0.0220, 'lps'),
	(548555, 131, '2014-02-15 00:02:43.000000', 'consum', 0.0235, 'lps'),
	(548556, 131, '2014-02-15 00:02:44.000000', 'consum', 0.0220, 'lps'),
	(548557, 131, '2014-02-15 00:02:45.000000', 'consum', 0.0216, 'lps'),
	(548558, 131, '2014-02-15 00:02:46.000000', 'consum', 0.0236, 'lps'),
	(548559, 131, '2014-02-15 00:02:47.000000', 'consum', 0.0213, 'lps'),
	(548560, 131, '2014-02-15 00:02:48.000000', 'consum', 0.0229, 'lps'),
	(548561, 131, '2014-02-15 00:02:49.000000', 'consum', 0.0215, 'lps'),
	(548562, 131, '2014-02-15 00:02:50.000000', 'consum', 0.0233, 'lps'),
	(548563, 131, '2014-02-15 00:02:51.000000', 'consum', 0.0225, 'lps'),
	(548564, 131, '2014-02-15 00:02:52.000000', 'consum', 0.0220, 'lps'),
	(548565, 131, '2014-02-15 00:02:53.000000', 'consum', 0.0213, 'lps'),
	(548566, 131, '2014-02-15 00:02:54.000000', 'consum', 0.0226, 'lps'),
	(548567, 131, '2014-02-15 00:02:55.000000', 'consum', 0.0223, 'lps'),
	(548568, 131, '2014-02-15 00:02:56.000000', 'consum', 0.0230, 'lps'),
	(548569, 131, '2014-02-15 00:02:57.000000', 'consum', 0.0213, 'lps'),
	(548570, 131, '2014-02-15 00:02:58.000000', 'consum', 0.0222, 'lps'),
	(548571, 131, '2014-02-15 00:02:59.000000', 'consum', 0.0236, 'lps'),
	(548572, 131, '2014-02-15 00:03:00.000000', 'consum', 0.0217, 'lps'),
	(548573, 131, '2014-02-15 00:03:01.000000', 'consum', 0.0226, 'lps'),
	(548574, 131, '2014-02-15 00:03:02.000000', 'consum', 0.0213, 'lps'),
	(548575, 131, '2014-02-15 00:03:03.000000', 'consum', 0.0233, 'lps'),
	(548576, 131, '2014-02-15 00:03:04.000000', 'consum', 0.0233, 'lps'),
	(548577, 131, '2014-02-15 00:03:05.000000', 'consum', 0.0229, 'lps'),
	(548578, 131, '2014-02-15 00:03:06.000000', 'consum', 0.0235, 'lps'),
	(548579, 131, '2014-02-15 00:03:07.000000', 'consum', 0.0223, 'lps'),
	(548580, 131, '2014-02-15 00:03:08.000000', 'consum', 0.0229, 'lps'),
	(548581, 131, '2014-02-15 00:03:09.000000', 'consum', 0.0210, 'lps'),
	(548582, 131, '2014-02-15 00:03:10.000000', 'consum', 0.0210, 'lps'),
	(548583, 131, '2014-02-15 00:03:11.000000', 'consum', 0.0211, 'lps'),
	(548584, 131, '2014-02-15 00:03:12.000000', 'consum', 0.0214, 'lps'),
	(548585, 131, '2014-02-15 00:03:13.000000', 'consum', 0.0230, 'lps'),
	(548586, 131, '2014-02-15 00:03:14.000000', 'consum', 0.0212, 'lps'),
	(548587, 131, '2014-02-15 00:03:15.000000', 'consum', 0.0216, 'lps'),
	(548588, 131, '2014-02-15 00:03:16.000000', 'consum', 0.0236, 'lps'),
	(548589, 131, '2014-02-15 00:03:17.000000', 'consum', 0.0212, 'lps'),
	(548590, 131, '2014-02-15 00:03:18.000000', 'consum', 0.0225, 'lps'),
	(548591, 131, '2014-02-15 00:03:19.000000', 'consum', 0.0223, 'lps'),
	(548592, 131, '2014-02-15 00:03:20.000000', 'consum', 0.0230, 'lps'),
	(548593, 131, '2014-02-15 00:03:21.000000', 'consum', 0.0215, 'lps'),
	(548594, 131, '2014-02-15 00:03:22.000000', 'consum', 0.0231, 'lps'),
	(548595, 131, '2014-02-15 00:03:23.000000', 'consum', 0.0217, 'lps'),
	(548596, 131, '2014-02-15 00:03:24.000000', 'consum', 0.0237, 'lps'),
	(548597, 131, '2014-02-15 00:03:25.000000', 'consum', 0.0215, 'lps'),
	(548598, 131, '2014-02-15 00:03:26.000000', 'consum', 0.0237, 'lps'),
	(548599, 131, '2014-02-15 00:03:27.000000', 'consum', 0.0217, 'lps'),
	(548600, 131, '2014-02-15 00:03:28.000000', 'consum', 0.0224, 'lps'),
	(548601, 131, '2014-02-15 00:03:29.000000', 'consum', 0.0228, 'lps'),
	(548602, 131, '2014-02-15 00:03:30.000000', 'consum', 0.0234, 'lps'),
	(548603, 131, '2014-02-15 00:03:31.000000', 'consum', 0.0217, 'lps'),
	(548604, 131, '2014-02-15 00:03:32.000000', 'consum', 0.0233, 'lps'),
	(548605, 131, '2014-02-15 00:03:33.000000', 'consum', 0.0218, 'lps'),
	(548606, 131, '2014-02-15 00:03:34.000000', 'consum', 0.0211, 'lps'),
	(548607, 131, '2014-02-15 00:03:35.000000', 'consum', 0.0218, 'lps'),
	(548608, 131, '2014-02-15 00:03:36.000000', 'consum', 0.0221, 'lps'),
	(548609, 131, '2014-02-15 00:03:37.000000', 'consum', 0.0213, 'lps'),
	(548610, 131, '2014-02-15 00:03:38.000000', 'consum', 0.0219, 'lps'),
	(548611, 131, '2014-02-15 00:03:39.000000', 'consum', 0.0219, 'lps'),
	(548612, 131, '2014-02-15 00:03:40.000000', 'consum', 0.0230, 'lps'),
	(548613, 131, '2014-02-15 00:03:41.000000', 'consum', 0.0226, 'lps'),
	(548614, 131, '2014-02-15 00:03:42.000000', 'consum', 0.0233, 'lps'),
	(548615, 131, '2014-02-15 00:03:43.000000', 'consum', 0.0219, 'lps'),
	(548616, 131, '2014-02-15 00:03:44.000000', 'consum', 0.0215, 'lps'),
	(548617, 131, '2014-02-15 00:03:45.000000', 'consum', 0.0210, 'lps'),
	(548618, 131, '2014-02-15 00:03:46.000000', 'consum', 0.0222, 'lps'),
	(548619, 131, '2014-02-15 00:03:47.000000', 'consum', 0.0213, 'lps'),
	(548620, 131, '2014-02-15 00:03:48.000000', 'consum', 0.0220, 'lps'),
	(548621, 131, '2014-02-15 00:03:49.000000', 'consum', 0.0221, 'lps'),
	(548622, 131, '2014-02-15 00:03:50.000000', 'consum', 0.0236, 'lps'),
	(548623, 131, '2014-02-15 00:03:51.000000', 'consum', 0.0223, 'lps'),
	(548624, 131, '2014-02-15 00:03:52.000000', 'consum', 0.0228, 'lps'),
	(548625, 131, '2014-02-15 00:03:53.000000', 'consum', 0.0231, 'lps'),
	(548626, 131, '2014-02-15 00:03:54.000000', 'consum', 0.0233, 'lps'),
	(548627, 131, '2014-02-15 00:03:55.000000', 'consum', 0.0234, 'lps'),
	(548628, 131, '2014-02-15 00:03:56.000000', 'consum', 0.0235, 'lps'),
	(548629, 131, '2014-02-15 00:03:57.000000', 'consum', 0.0234, 'lps'),
	(548630, 131, '2014-02-15 00:03:58.000000', 'consum', 0.0230, 'lps'),
	(548631, 131, '2014-02-15 00:03:59.000000', 'consum', 0.0210, 'lps'),
	(548632, 131, '2014-02-15 00:04:00.000000', 'consum', 0.0236, 'lps'),
	(548633, 131, '2014-02-15 00:04:01.000000', 'consum', 0.0226, 'lps'),
	(548634, 131, '2014-02-15 00:04:02.000000', 'consum', 0.0213, 'lps'),
	(548635, 131, '2014-02-15 00:04:03.000000', 'consum', 0.0234, 'lps'),
	(548636, 131, '2014-02-15 00:04:04.000000', 'consum', 0.0237, 'lps'),
	(548637, 131, '2014-02-15 00:04:05.000000', 'consum', 0.0219, 'lps'),
	(548638, 131, '2014-02-15 00:04:06.000000', 'consum', 0.0228, 'lps'),
	(548639, 131, '2014-02-15 00:04:07.000000', 'consum', 0.0217, 'lps'),
	(548640, 131, '2014-02-15 00:04:08.000000', 'consum', 0.0221, 'lps'),
	(548641, 131, '2014-02-15 00:04:09.000000', 'consum', 0.0216, 'lps'),
	(548642, 131, '2014-02-15 00:04:10.000000', 'consum', 0.0235, 'lps'),
	(548643, 131, '2014-02-15 00:04:11.000000', 'consum', 0.0232, 'lps'),
	(548644, 131, '2014-02-15 00:04:12.000000', 'consum', 0.0220, 'lps'),
	(548645, 131, '2014-02-15 00:04:13.000000', 'consum', 0.0223, 'lps'),
	(548646, 131, '2014-02-15 00:04:14.000000', 'consum', 0.0215, 'lps'),
	(548647, 131, '2014-02-15 00:04:15.000000', 'consum', 0.0226, 'lps'),
	(548648, 131, '2014-02-15 00:04:16.000000', 'consum', 0.0220, 'lps'),
	(548649, 131, '2014-02-15 00:04:17.000000', 'consum', 0.0212, 'lps'),
	(548650, 131, '2014-02-15 00:04:18.000000', 'consum', 0.0219, 'lps'),
	(548651, 131, '2014-02-15 00:04:19.000000', 'consum', 0.0219, 'lps'),
	(548652, 131, '2014-02-15 00:04:20.000000', 'consum', 0.0230, 'lps'),
	(548653, 131, '2014-02-15 00:04:21.000000', 'consum', 0.0228, 'lps'),
	(548654, 131, '2014-02-15 00:04:22.000000', 'consum', 0.0212, 'lps'),
	(548655, 131, '2014-02-15 00:04:23.000000', 'consum', 0.0222, 'lps'),
	(548656, 131, '2014-02-15 00:04:24.000000', 'consum', 0.0237, 'lps'),
	(548657, 131, '2014-02-15 00:04:25.000000', 'consum', 0.0225, 'lps'),
	(548658, 131, '2014-02-15 00:04:26.000000', 'consum', 0.0234, 'lps'),
	(548659, 131, '2014-02-15 00:04:27.000000', 'consum', 0.0228, 'lps'),
	(548660, 131, '2014-02-15 00:04:28.000000', 'consum', 0.0230, 'lps'),
	(548661, 131, '2014-02-15 00:04:29.000000', 'consum', 0.0228, 'lps'),
	(548662, 131, '2014-02-15 00:04:30.000000', 'consum', 0.0213, 'lps'),
	(548663, 131, '2014-02-15 00:04:31.000000', 'consum', 0.0228, 'lps'),
	(548664, 131, '2014-02-15 00:04:32.000000', 'consum', 0.0234, 'lps'),
	(548665, 131, '2014-02-15 00:04:33.000000', 'consum', 0.0220, 'lps'),
	(548666, 131, '2014-02-15 00:04:34.000000', 'consum', 0.0219, 'lps'),
	(548667, 131, '2014-02-15 00:04:35.000000', 'consum', 0.0224, 'lps'),
	(548668, 131, '2014-02-15 00:04:36.000000', 'consum', 0.0226, 'lps'),
	(548669, 131, '2014-02-15 00:04:37.000000', 'consum', 0.0222, 'lps'),
	(548670, 131, '2014-02-15 00:04:38.000000', 'consum', 0.0222, 'lps'),
	(548671, 131, '2014-02-15 00:04:39.000000', 'consum', 0.0236, 'lps'),
	(548672, 131, '2014-02-15 00:04:40.000000', 'consum', 0.0218, 'lps'),
	(548673, 131, '2014-02-15 00:04:41.000000', 'consum', 0.0230, 'lps'),
	(548674, 131, '2014-02-15 00:04:42.000000', 'consum', 0.0230, 'lps'),
	(548675, 131, '2014-02-15 00:04:43.000000', 'consum', 0.0224, 'lps'),
	(548676, 131, '2014-02-15 00:04:44.000000', 'consum', 0.0218, 'lps'),
	(548677, 131, '2014-02-15 00:04:45.000000', 'consum', 0.0211, 'lps'),
	(548678, 131, '2014-02-15 00:04:46.000000', 'consum', 0.0219, 'lps'),
	(548679, 131, '2014-02-15 00:04:47.000000', 'consum', 0.0225, 'lps'),
	(548680, 131, '2014-02-15 00:04:48.000000', 'consum', 0.0228, 'lps'),
	(548681, 131, '2014-02-15 00:04:49.000000', 'consum', 0.0228, 'lps'),
	(548682, 131, '2014-02-15 00:04:50.000000', 'consum', 0.0218, 'lps'),
	(548683, 131, '2014-02-15 00:04:51.000000', 'consum', 0.0227, 'lps'),
	(548684, 131, '2014-02-15 00:04:52.000000', 'consum', 0.0213, 'lps'),
	(548685, 131, '2014-02-15 00:04:53.000000', 'consum', 0.0230, 'lps'),
	(548686, 131, '2014-02-15 00:04:54.000000', 'consum', 0.0218, 'lps'),
	(548687, 131, '2014-02-15 00:04:55.000000', 'consum', 0.0220, 'lps'),
	(548688, 131, '2014-02-15 00:04:56.000000', 'consum', 0.0234, 'lps'),
	(548689, 131, '2014-02-15 00:04:57.000000', 'consum', 0.0219, 'lps'),
	(548690, 131, '2014-02-15 00:04:58.000000', 'consum', 0.0210, 'lps'),
	(548691, 131, '2014-02-15 00:04:59.000000', 'consum', 0.0211, 'lps'),
	(548692, 131, '2014-02-15 00:05:00.000000', 'consum', 0.0218, 'lps'),
	(548693, 131, '2014-02-15 00:05:01.000000', 'consum', 0.0216, 'lps'),
	(548694, 131, '2014-02-15 00:05:02.000000', 'consum', 0.0219, 'lps'),
	(548695, 131, '2014-02-15 00:05:03.000000', 'consum', 0.0235, 'lps'),
	(548696, 131, '2014-02-15 00:05:04.000000', 'consum', 0.0225, 'lps'),
	(548697, 131, '2014-02-15 00:05:05.000000', 'consum', 0.0237, 'lps'),
	(548698, 131, '2014-02-15 00:05:06.000000', 'consum', 0.0219, 'lps'),
	(548699, 131, '2014-02-15 00:05:07.000000', 'consum', 0.0229, 'lps'),
	(548700, 131, '2014-02-15 00:05:08.000000', 'consum', 0.0222, 'lps'),
	(548701, 131, '2014-02-15 00:05:09.000000', 'consum', 0.0214, 'lps'),
	(548702, 131, '2014-02-15 00:05:10.000000', 'consum', 0.0221, 'lps'),
	(548703, 131, '2014-02-15 00:05:11.000000', 'consum', 0.0227, 'lps'),
	(548704, 131, '2014-02-15 00:05:12.000000', 'consum', 0.0235, 'lps'),
	(548705, 131, '2014-02-15 00:05:13.000000', 'consum', 0.0227, 'lps'),
	(548706, 131, '2014-02-15 00:05:14.000000', 'consum', 0.0223, 'lps'),
	(548707, 131, '2014-02-15 00:05:15.000000', 'consum', 0.0224, 'lps'),
	(548708, 131, '2014-02-15 00:05:16.000000', 'consum', 0.0214, 'lps'),
	(548709, 131, '2014-02-15 00:05:17.000000', 'consum', 0.0216, 'lps'),
	(548710, 131, '2014-02-15 00:05:18.000000', 'consum', 0.0229, 'lps'),
	(548711, 131, '2014-02-15 00:05:19.000000', 'consum', 0.0232, 'lps'),
	(548712, 131, '2014-02-15 00:05:20.000000', 'consum', 0.0234, 'lps'),
	(548713, 131, '2014-02-15 00:05:21.000000', 'consum', 0.0236, 'lps'),
	(548714, 131, '2014-02-15 00:05:22.000000', 'consum', 0.0211, 'lps'),
	(548715, 131, '2014-02-15 00:05:23.000000', 'consum', 0.0225, 'lps'),
	(548716, 131, '2014-02-15 00:05:24.000000', 'consum', 0.0226, 'lps'),
	(548717, 131, '2014-02-15 00:05:25.000000', 'consum', 0.0215, 'lps'),
	(548718, 131, '2014-02-15 00:05:26.000000', 'consum', 0.0217, 'lps'),
	(548719, 131, '2014-02-15 00:05:27.000000', 'consum', 0.0232, 'lps'),
	(548720, 131, '2014-02-15 00:05:28.000000', 'consum', 0.0216, 'lps'),
	(548721, 131, '2014-02-15 00:05:29.000000', 'consum', 0.0229, 'lps'),
	(548722, 131, '2014-02-15 00:05:30.000000', 'consum', 0.0232, 'lps'),
	(548723, 131, '2014-02-15 00:05:31.000000', 'consum', 0.0237, 'lps'),
	(548724, 131, '2014-02-15 00:05:32.000000', 'consum', 0.0224, 'lps'),
	(548725, 131, '2014-02-15 00:05:33.000000', 'consum', 0.0227, 'lps'),
	(548726, 131, '2014-02-15 00:05:34.000000', 'consum', 0.0227, 'lps'),
	(548727, 131, '2014-02-15 00:05:35.000000', 'consum', 0.0215, 'lps'),
	(548728, 131, '2014-02-15 00:05:36.000000', 'consum', 0.0212, 'lps'),
	(548729, 131, '2014-02-15 00:05:37.000000', 'consum', 0.0235, 'lps'),
	(548730, 131, '2014-02-15 00:05:38.000000', 'consum', 0.0215, 'lps'),
	(548731, 131, '2014-02-15 00:05:39.000000', 'consum', 0.0218, 'lps'),
	(548732, 131, '2014-02-15 00:05:40.000000', 'consum', 0.0233, 'lps'),
	(548733, 131, '2014-02-15 00:05:41.000000', 'consum', 0.0220, 'lps'),
	(548734, 131, '2014-02-15 00:05:42.000000', 'consum', 0.0218, 'lps'),
	(548735, 131, '2014-02-15 00:05:43.000000', 'consum', 0.0223, 'lps'),
	(548736, 131, '2014-02-15 00:05:44.000000', 'consum', 0.0221, 'lps'),
	(548737, 131, '2014-02-15 00:05:45.000000', 'consum', 0.0225, 'lps'),
	(548738, 131, '2014-02-15 00:05:46.000000', 'consum', 0.0228, 'lps'),
	(548739, 131, '2014-02-15 00:05:47.000000', 'consum', 0.0225, 'lps'),
	(548740, 131, '2014-02-15 00:05:48.000000', 'consum', 0.0232, 'lps'),
	(548741, 131, '2014-02-15 00:05:49.000000', 'consum', 0.0219, 'lps'),
	(548742, 131, '2014-02-15 00:05:50.000000', 'consum', 0.0217, 'lps'),
	(548743, 131, '2014-02-15 00:05:51.000000', 'consum', 0.0219, 'lps'),
	(548744, 131, '2014-02-15 00:05:52.000000', 'consum', 0.0237, 'lps'),
	(548745, 131, '2014-02-15 00:05:53.000000', 'consum', 0.0231, 'lps'),
	(548746, 131, '2014-02-15 00:05:54.000000', 'consum', 0.0236, 'lps'),
	(548747, 131, '2014-02-15 00:05:55.000000', 'consum', 0.0221, 'lps'),
	(548748, 131, '2014-02-15 00:05:56.000000', 'consum', 0.0218, 'lps'),
	(548749, 131, '2014-02-15 00:05:57.000000', 'consum', 0.0214, 'lps'),
	(548750, 131, '2014-02-15 00:05:58.000000', 'consum', 0.0237, 'lps'),
	(548751, 131, '2014-02-15 00:05:59.000000', 'consum', 0.0219, 'lps'),
	(548752, 131, '2014-02-15 00:06:00.000000', 'consum', 0.0232, 'lps'),
	(548753, 131, '2014-02-15 00:06:01.000000', 'consum', 0.0211, 'lps'),
	(548754, 131, '2014-02-15 00:06:02.000000', 'consum', 0.0234, 'lps'),
	(548755, 131, '2014-02-15 00:06:03.000000', 'consum', 0.0214, 'lps'),
	(548756, 131, '2014-02-15 00:06:04.000000', 'consum', 0.0215, 'lps'),
	(548757, 131, '2014-02-15 00:06:05.000000', 'consum', 0.0224, 'lps'),
	(548758, 131, '2014-02-15 00:06:06.000000', 'consum', 0.0210, 'lps'),
	(548759, 131, '2014-02-15 00:06:07.000000', 'consum', 0.0223, 'lps'),
	(548760, 131, '2014-02-15 00:06:08.000000', 'consum', 0.0218, 'lps'),
	(548761, 131, '2014-02-15 00:06:09.000000', 'consum', 0.0215, 'lps'),
	(548762, 131, '2014-02-15 00:06:10.000000', 'consum', 0.0210, 'lps'),
	(548763, 131, '2014-02-15 00:06:11.000000', 'consum', 0.0223, 'lps'),
	(548764, 131, '2014-02-15 00:06:12.000000', 'consum', 0.0221, 'lps'),
	(548765, 131, '2014-02-15 00:06:13.000000', 'consum', 0.0226, 'lps'),
	(548766, 131, '2014-02-15 00:06:14.000000', 'consum', 0.0230, 'lps'),
	(548767, 131, '2014-02-15 00:06:15.000000', 'consum', 0.0233, 'lps'),
	(548768, 131, '2014-02-15 00:06:16.000000', 'consum', 0.0212, 'lps'),
	(548769, 131, '2014-02-15 00:06:17.000000', 'consum', 0.0235, 'lps'),
	(548770, 131, '2014-02-15 00:06:18.000000', 'consum', 0.0219, 'lps'),
	(548771, 131, '2014-02-15 00:06:19.000000', 'consum', 0.0235, 'lps'),
	(548772, 131, '2014-02-15 00:06:20.000000', 'consum', 0.0226, 'lps'),
	(548773, 131, '2014-02-15 00:06:21.000000', 'consum', 0.0215, 'lps'),
	(548774, 131, '2014-02-15 00:06:22.000000', 'consum', 0.0215, 'lps'),
	(548775, 131, '2014-02-15 00:06:23.000000', 'consum', 0.0221, 'lps'),
	(548776, 131, '2014-02-15 00:06:24.000000', 'consum', 0.0221, 'lps'),
	(548777, 131, '2014-02-15 00:06:25.000000', 'consum', 0.0234, 'lps'),
	(548778, 131, '2014-02-15 00:06:26.000000', 'consum', 0.0215, 'lps'),
	(548779, 131, '2014-02-15 00:06:27.000000', 'consum', 0.0218, 'lps'),
	(548780, 131, '2014-02-15 00:06:28.000000', 'consum', 0.0234, 'lps'),
	(548781, 131, '2014-02-15 00:06:29.000000', 'consum', 0.0224, 'lps'),
	(548782, 131, '2014-02-15 00:06:30.000000', 'consum', 0.0235, 'lps'),
	(548783, 131, '2014-02-15 00:06:31.000000', 'consum', 0.0210, 'lps'),
	(548784, 131, '2014-02-15 00:06:32.000000', 'consum', 0.0222, 'lps'),
	(548785, 131, '2014-02-15 00:06:33.000000', 'consum', 0.0212, 'lps'),
	(548786, 131, '2014-02-15 00:06:34.000000', 'consum', 0.0212, 'lps'),
	(548787, 131, '2014-02-15 00:06:35.000000', 'consum', 0.0215, 'lps'),
	(548788, 131, '2014-02-15 00:06:36.000000', 'consum', 0.0231, 'lps'),
	(548789, 131, '2014-02-15 00:06:37.000000', 'consum', 0.0217, 'lps'),
	(548790, 131, '2014-02-15 00:06:38.000000', 'consum', 0.0210, 'lps'),
	(548791, 131, '2014-02-15 00:06:39.000000', 'consum', 0.0216, 'lps'),
	(548792, 131, '2014-02-15 00:06:40.000000', 'consum', 0.0212, 'lps'),
	(548793, 131, '2014-02-15 00:06:41.000000', 'consum', 0.0232, 'lps'),
	(548794, 131, '2014-02-15 00:06:42.000000', 'consum', 0.0232, 'lps'),
	(548795, 131, '2014-02-15 00:06:43.000000', 'consum', 0.0224, 'lps'),
	(548796, 131, '2014-02-15 00:06:44.000000', 'consum', 0.0214, 'lps'),
	(548797, 131, '2014-02-15 00:06:45.000000', 'consum', 0.0216, 'lps'),
	(548798, 131, '2014-02-15 00:06:46.000000', 'consum', 0.0230, 'lps'),
	(548799, 131, '2014-02-15 00:06:47.000000', 'consum', 0.0237, 'lps'),
	(548800, 131, '2014-02-15 00:06:48.000000', 'consum', 0.0227, 'lps'),
	(548801, 131, '2014-02-15 00:06:49.000000', 'consum', 0.0215, 'lps'),
	(548802, 131, '2014-02-15 00:06:50.000000', 'consum', 0.0214, 'lps'),
	(548803, 131, '2014-02-15 00:06:51.000000', 'consum', 0.0215, 'lps'),
	(548804, 131, '2014-02-15 00:06:52.000000', 'consum', 0.0222, 'lps'),
	(548805, 131, '2014-02-15 00:06:53.000000', 'consum', 0.0228, 'lps'),
	(548806, 131, '2014-02-15 00:06:54.000000', 'consum', 0.0210, 'lps'),
	(548807, 131, '2014-02-15 00:06:55.000000', 'consum', 0.0210, 'lps'),
	(548808, 131, '2014-02-15 00:06:56.000000', 'consum', 0.0211, 'lps'),
	(548809, 131, '2014-02-15 00:06:57.000000', 'consum', 0.0218, 'lps'),
	(548810, 131, '2014-02-15 00:06:58.000000', 'consum', 0.0219, 'lps'),
	(548811, 131, '2014-02-15 00:06:59.000000', 'consum', 0.0229, 'lps'),
	(548812, 131, '2014-02-15 00:07:00.000000', 'consum', 0.0224, 'lps'),
	(548813, 131, '2014-02-15 00:07:01.000000', 'consum', 0.0225, 'lps'),
	(548814, 131, '2014-02-15 00:07:02.000000', 'consum', 0.0214, 'lps'),
	(548815, 131, '2014-02-15 00:07:03.000000', 'consum', 0.0214, 'lps'),
	(548816, 131, '2014-02-15 00:07:04.000000', 'consum', 0.0218, 'lps'),
	(548817, 131, '2014-02-15 00:07:05.000000', 'consum', 0.0212, 'lps'),
	(548818, 131, '2014-02-15 00:07:06.000000', 'consum', 0.0223, 'lps'),
	(548819, 131, '2014-02-15 00:07:07.000000', 'consum', 0.0214, 'lps'),
	(548820, 131, '2014-02-15 00:07:08.000000', 'consum', 0.0219, 'lps'),
	(548821, 131, '2014-02-15 00:07:09.000000', 'consum', 0.0215, 'lps'),
	(548822, 131, '2014-02-15 00:07:10.000000', 'consum', 0.0210, 'lps'),
	(548823, 131, '2014-02-15 00:07:11.000000', 'consum', 0.0224, 'lps'),
	(548824, 131, '2014-02-15 00:07:12.000000', 'consum', 0.0225, 'lps'),
	(548825, 131, '2014-02-15 00:07:13.000000', 'consum', 0.0214, 'lps'),
	(548826, 131, '2014-02-15 00:07:14.000000', 'consum', 0.0214, 'lps'),
	(548827, 131, '2014-02-15 00:07:15.000000', 'consum', 0.0218, 'lps'),
	(548828, 131, '2014-02-15 00:07:16.000000', 'consum', 0.0210, 'lps'),
	(548829, 131, '2014-02-15 00:07:17.000000', 'consum', 0.0215, 'lps'),
	(548830, 131, '2014-02-15 00:07:18.000000', 'consum', 0.0234, 'lps'),
	(548831, 131, '2014-02-15 00:07:19.000000', 'consum', 0.0231, 'lps'),
	(548832, 131, '2014-02-15 00:07:20.000000', 'consum', 0.0216, 'lps'),
	(548833, 131, '2014-02-15 00:07:21.000000', 'consum', 0.0233, 'lps'),
	(548834, 131, '2014-02-15 00:07:22.000000', 'consum', 0.0222, 'lps'),
	(548835, 131, '2014-02-15 00:07:23.000000', 'consum', 0.0233, 'lps'),
	(548836, 131, '2014-02-15 00:07:24.000000', 'consum', 0.0230, 'lps'),
	(548837, 131, '2014-02-15 00:07:25.000000', 'consum', 0.0216, 'lps'),
	(548838, 131, '2014-02-15 00:07:26.000000', 'consum', 0.0237, 'lps'),
	(548839, 131, '2014-02-15 00:07:27.000000', 'consum', 0.0213, 'lps'),
	(548840, 131, '2014-02-15 00:07:28.000000', 'consum', 0.0229, 'lps'),
	(548841, 131, '2014-02-15 00:07:29.000000', 'consum', 0.0213, 'lps'),
	(548842, 131, '2014-02-15 00:07:30.000000', 'consum', 0.0223, 'lps'),
	(548843, 131, '2014-02-15 00:07:31.000000', 'consum', 0.0212, 'lps'),
	(548844, 131, '2014-02-15 00:07:32.000000', 'consum', 0.0236, 'lps'),
	(548845, 131, '2014-02-15 00:07:33.000000', 'consum', 0.0224, 'lps'),
	(548846, 131, '2014-02-15 00:07:34.000000', 'consum', 0.0229, 'lps'),
	(548847, 131, '2014-02-15 00:07:35.000000', 'consum', 0.0236, 'lps'),
	(548848, 131, '2014-02-15 00:07:36.000000', 'consum', 0.0228, 'lps'),
	(548849, 131, '2014-02-15 00:07:37.000000', 'consum', 0.0222, 'lps'),
	(548850, 131, '2014-02-15 00:07:38.000000', 'consum', 0.0215, 'lps'),
	(548851, 131, '2014-02-15 00:07:39.000000', 'consum', 0.0229, 'lps'),
	(548852, 131, '2014-02-15 00:07:40.000000', 'consum', 0.0232, 'lps'),
	(548853, 131, '2014-02-15 00:07:41.000000', 'consum', 0.0210, 'lps'),
	(548854, 131, '2014-02-15 00:07:42.000000', 'consum', 0.0227, 'lps'),
	(548855, 131, '2014-02-15 00:07:43.000000', 'consum', 0.0212, 'lps'),
	(548856, 131, '2014-02-15 00:07:44.000000', 'consum', 0.0227, 'lps'),
	(548857, 131, '2014-02-15 00:07:45.000000', 'consum', 0.0233, 'lps'),
	(548858, 131, '2014-02-15 00:07:46.000000', 'consum', 0.0218, 'lps'),
	(548859, 131, '2014-02-15 00:07:47.000000', 'consum', 0.0237, 'lps'),
	(548860, 131, '2014-02-15 00:07:48.000000', 'consum', 0.0211, 'lps'),
	(548861, 131, '2014-02-15 00:07:49.000000', 'consum', 0.0218, 'lps'),
	(548862, 131, '2014-02-15 00:07:50.000000', 'consum', 0.0218, 'lps'),
	(548863, 131, '2014-02-15 00:07:51.000000', 'consum', 0.0226, 'lps'),
	(548864, 131, '2014-02-15 00:07:52.000000', 'consum', 0.0211, 'lps'),
	(548865, 131, '2014-02-15 00:07:53.000000', 'consum', 0.0223, 'lps'),
	(548866, 131, '2014-02-15 00:07:54.000000', 'consum', 0.0217, 'lps'),
	(548867, 131, '2014-02-15 00:07:55.000000', 'consum', 0.0235, 'lps'),
	(548868, 131, '2014-02-15 00:07:56.000000', 'consum', 0.0228, 'lps'),
	(548869, 131, '2014-02-15 00:07:57.000000', 'consum', 0.0228, 'lps'),
	(548870, 131, '2014-02-15 00:07:58.000000', 'consum', 0.0217, 'lps'),
	(548871, 131, '2014-02-15 00:07:59.000000', 'consum', 0.0220, 'lps'),
	(548872, 131, '2014-02-15 00:08:00.000000', 'consum', 0.0211, 'lps'),
	(548873, 131, '2014-02-15 00:08:01.000000', 'consum', 0.0213, 'lps'),
	(548874, 131, '2014-02-15 00:08:02.000000', 'consum', 0.0223, 'lps'),
	(548875, 131, '2014-02-15 00:08:03.000000', 'consum', 0.0237, 'lps'),
	(548876, 131, '2014-02-15 00:08:04.000000', 'consum', 0.0222, 'lps'),
	(548877, 131, '2014-02-15 00:08:05.000000', 'consum', 0.0220, 'lps'),
	(548878, 131, '2014-02-15 00:08:06.000000', 'consum', 0.0223, 'lps'),
	(548879, 131, '2014-02-15 00:08:07.000000', 'consum', 0.0218, 'lps'),
	(548880, 131, '2014-02-15 00:08:08.000000', 'consum', 0.0237, 'lps'),
	(548881, 131, '2014-02-15 00:08:09.000000', 'consum', 0.0212, 'lps'),
	(548882, 131, '2014-02-15 00:08:10.000000', 'consum', 0.0224, 'lps'),
	(548883, 131, '2014-02-15 00:08:11.000000', 'consum', 0.0219, 'lps'),
	(548884, 131, '2014-02-15 00:08:12.000000', 'consum', 0.0213, 'lps'),
	(548885, 131, '2014-02-15 00:08:13.000000', 'consum', 0.0228, 'lps'),
	(548886, 131, '2014-02-15 00:08:14.000000', 'consum', 0.0235, 'lps'),
	(548887, 131, '2014-02-15 00:08:15.000000', 'consum', 0.0225, 'lps'),
	(548888, 131, '2014-02-15 00:08:16.000000', 'consum', 0.0211, 'lps'),
	(548889, 131, '2014-02-15 00:08:17.000000', 'consum', 0.0227, 'lps'),
	(548890, 131, '2014-02-15 00:08:18.000000', 'consum', 0.0235, 'lps'),
	(548891, 131, '2014-02-15 00:08:19.000000', 'consum', 0.0229, 'lps'),
	(548892, 131, '2014-02-15 00:08:20.000000', 'consum', 0.0230, 'lps'),
	(548893, 131, '2014-02-15 00:08:21.000000', 'consum', 0.0225, 'lps'),
	(548894, 131, '2014-02-15 00:08:22.000000', 'consum', 0.0225, 'lps'),
	(548895, 131, '2014-02-15 00:08:23.000000', 'consum', 0.0214, 'lps'),
	(548896, 131, '2014-02-15 00:08:24.000000', 'consum', 0.0213, 'lps'),
	(548897, 131, '2014-02-15 00:08:25.000000', 'consum', 0.0211, 'lps'),
	(548898, 131, '2014-02-15 00:08:26.000000', 'consum', 0.0210, 'lps'),
	(548899, 131, '2014-02-15 00:08:27.000000', 'consum', 0.0234, 'lps'),
	(548900, 131, '2014-02-15 00:08:28.000000', 'consum', 0.0217, 'lps'),
	(548901, 131, '2014-02-15 00:08:29.000000', 'consum', 0.0229, 'lps'),
	(548902, 131, '2014-02-15 00:08:30.000000', 'consum', 0.0231, 'lps'),
	(548903, 131, '2014-02-15 00:08:31.000000', 'consum', 0.0231, 'lps'),
	(548904, 131, '2014-02-15 00:08:32.000000', 'consum', 0.0225, 'lps'),
	(548905, 131, '2014-02-15 00:08:33.000000', 'consum', 0.0220, 'lps'),
	(548906, 131, '2014-02-15 00:08:34.000000', 'consum', 0.0217, 'lps'),
	(548907, 131, '2014-02-15 00:08:35.000000', 'consum', 0.0216, 'lps'),
	(548908, 131, '2014-02-15 00:08:36.000000', 'consum', 0.0218, 'lps'),
	(548909, 131, '2014-02-15 00:08:37.000000', 'consum', 0.0234, 'lps'),
	(548910, 131, '2014-02-15 00:08:38.000000', 'consum', 0.0221, 'lps'),
	(548911, 131, '2014-02-15 00:08:39.000000', 'consum', 0.0221, 'lps'),
	(548912, 131, '2014-02-15 00:08:40.000000', 'consum', 0.0233, 'lps'),
	(548913, 131, '2014-02-15 00:08:41.000000', 'consum', 0.0235, 'lps'),
	(548914, 131, '2014-02-15 00:08:42.000000', 'consum', 0.0213, 'lps'),
	(548915, 131, '2014-02-15 00:08:43.000000', 'consum', 0.0235, 'lps'),
	(548916, 131, '2014-02-15 00:08:44.000000', 'consum', 0.0214, 'lps'),
	(548917, 131, '2014-02-15 00:08:45.000000', 'consum', 0.0210, 'lps'),
	(548918, 131, '2014-02-15 00:08:46.000000', 'consum', 0.0227, 'lps'),
	(548919, 131, '2014-02-15 00:08:47.000000', 'consum', 0.0213, 'lps'),
	(548920, 131, '2014-02-15 00:08:48.000000', 'consum', 0.0230, 'lps'),
	(548921, 131, '2014-02-15 00:08:49.000000', 'consum', 0.0217, 'lps'),
	(548922, 131, '2014-02-15 00:08:50.000000', 'consum', 0.0215, 'lps'),
	(548923, 131, '2014-02-15 00:08:51.000000', 'consum', 0.0214, 'lps'),
	(548924, 131, '2014-02-15 00:08:52.000000', 'consum', 0.0216, 'lps'),
	(548925, 131, '2014-02-15 00:08:53.000000', 'consum', 0.0230, 'lps'),
	(548926, 131, '2014-02-15 00:08:54.000000', 'consum', 0.0235, 'lps'),
	(548927, 131, '2014-02-15 00:08:55.000000', 'consum', 0.0219, 'lps'),
	(548928, 131, '2014-02-15 00:08:56.000000', 'consum', 0.0235, 'lps'),
	(548929, 131, '2014-02-15 00:08:57.000000', 'consum', 0.0225, 'lps'),
	(548930, 131, '2014-02-15 00:08:58.000000', 'consum', 0.0212, 'lps'),
	(548931, 131, '2014-02-15 00:08:59.000000', 'consum', 0.0229, 'lps'),
	(548932, 131, '2014-02-15 00:09:00.000000', 'consum', 0.0216, 'lps'),
	(548933, 131, '2014-02-15 00:09:01.000000', 'consum', 0.0211, 'lps'),
	(548934, 131, '2014-02-15 00:09:02.000000', 'consum', 0.0226, 'lps'),
	(548935, 131, '2014-02-15 00:09:03.000000', 'consum', 0.0234, 'lps'),
	(548936, 131, '2014-02-15 00:09:04.000000', 'consum', 0.0223, 'lps'),
	(548937, 131, '2014-02-15 00:09:05.000000', 'consum', 0.0234, 'lps'),
	(548938, 131, '2014-02-15 00:09:06.000000', 'consum', 0.0233, 'lps'),
	(548939, 131, '2014-02-15 00:09:07.000000', 'consum', 0.0226, 'lps'),
	(548940, 131, '2014-02-15 00:09:08.000000', 'consum', 0.0221, 'lps'),
	(548941, 131, '2014-02-15 00:09:09.000000', 'consum', 0.0219, 'lps'),
	(548942, 131, '2014-02-15 00:09:10.000000', 'consum', 0.0222, 'lps'),
	(548943, 131, '2014-02-15 00:09:11.000000', 'consum', 0.0213, 'lps'),
	(548944, 131, '2014-02-15 00:09:12.000000', 'consum', 0.0221, 'lps'),
	(548945, 131, '2014-02-15 00:09:13.000000', 'consum', 0.0228, 'lps'),
	(548946, 131, '2014-02-15 00:09:14.000000', 'consum', 0.0213, 'lps'),
	(548947, 131, '2014-02-15 00:09:15.000000', 'consum', 0.0226, 'lps'),
	(548948, 131, '2014-02-15 00:09:16.000000', 'consum', 0.0225, 'lps'),
	(548949, 131, '2014-02-15 00:09:17.000000', 'consum', 0.0210, 'lps'),
	(548950, 131, '2014-02-15 00:09:18.000000', 'consum', 0.0221, 'lps'),
	(548951, 131, '2014-02-15 00:09:19.000000', 'consum', 0.0211, 'lps'),
	(548952, 131, '2014-02-15 00:09:20.000000', 'consum', 0.0237, 'lps'),
	(548953, 131, '2014-02-15 00:09:21.000000', 'consum', 0.0231, 'lps'),
	(548954, 131, '2014-02-15 00:09:22.000000', 'consum', 0.0236, 'lps'),
	(548955, 131, '2014-02-15 00:09:23.000000', 'consum', 0.0219, 'lps'),
	(548956, 131, '2014-02-15 00:09:24.000000', 'consum', 0.0237, 'lps'),
	(548957, 131, '2014-02-15 00:09:25.000000', 'consum', 0.0231, 'lps'),
	(548958, 131, '2014-02-15 00:09:26.000000', 'consum', 0.0234, 'lps'),
	(548959, 131, '2014-02-15 00:09:27.000000', 'consum', 0.0213, 'lps'),
	(548960, 131, '2014-02-15 00:09:28.000000', 'consum', 0.0210, 'lps'),
	(548961, 131, '2014-02-15 00:09:29.000000', 'consum', 0.0227, 'lps'),
	(548962, 131, '2014-02-15 00:09:30.000000', 'consum', 0.0214, 'lps'),
	(548963, 131, '2014-02-15 00:09:31.000000', 'consum', 0.0233, 'lps'),
	(548964, 131, '2014-02-15 00:09:32.000000', 'consum', 0.0233, 'lps'),
	(548965, 131, '2014-02-15 00:09:33.000000', 'consum', 0.0225, 'lps'),
	(548966, 131, '2014-02-15 00:09:34.000000', 'consum', 0.0218, 'lps'),
	(548967, 131, '2014-02-15 00:09:35.000000', 'consum', 0.0232, 'lps'),
	(548968, 131, '2014-02-15 00:09:36.000000', 'consum', 0.0213, 'lps'),
	(548969, 131, '2014-02-15 00:09:37.000000', 'consum', 0.0216, 'lps'),
	(548970, 131, '2014-02-15 00:09:38.000000', 'consum', 0.0233, 'lps'),
	(548971, 131, '2014-02-15 00:09:39.000000', 'consum', 0.0222, 'lps'),
	(548972, 131, '2014-02-15 00:09:40.000000', 'consum', 0.0230, 'lps'),
	(548973, 131, '2014-02-15 00:09:41.000000', 'consum', 0.0217, 'lps'),
	(548974, 131, '2014-02-15 00:09:42.000000', 'consum', 0.0214, 'lps'),
	(548975, 131, '2014-02-15 00:09:43.000000', 'consum', 0.0211, 'lps'),
	(548976, 131, '2014-02-15 00:09:44.000000', 'consum', 0.0230, 'lps'),
	(548977, 131, '2014-02-15 00:09:45.000000', 'consum', 0.0226, 'lps'),
	(548978, 131, '2014-02-15 00:09:46.000000', 'consum', 0.0228, 'lps'),
	(548979, 131, '2014-02-15 00:09:47.000000', 'consum', 0.0225, 'lps'),
	(548980, 131, '2014-02-15 00:09:48.000000', 'consum', 0.0233, 'lps'),
	(548981, 131, '2014-02-15 00:09:49.000000', 'consum', 0.0224, 'lps'),
	(548982, 131, '2014-02-15 00:09:50.000000', 'consum', 0.0213, 'lps'),
	(548983, 131, '2014-02-15 00:09:51.000000', 'consum', 0.0211, 'lps'),
	(548984, 131, '2014-02-15 00:09:52.000000', 'consum', 0.0232, 'lps'),
	(548985, 131, '2014-02-15 00:09:53.000000', 'consum', 0.0236, 'lps'),
	(548986, 131, '2014-02-15 00:09:54.000000', 'consum', 0.0216, 'lps'),
	(548987, 131, '2014-02-15 00:09:55.000000', 'consum', 0.0221, 'lps'),
	(548988, 131, '2014-02-15 00:09:56.000000', 'consum', 0.0218, 'lps'),
	(548989, 131, '2014-02-15 00:09:57.000000', 'consum', 0.0218, 'lps'),
	(548990, 131, '2014-02-15 00:09:58.000000', 'consum', 0.0225, 'lps'),
	(548991, 131, '2014-02-15 00:09:59.000000', 'consum', 0.0234, 'lps'),
	(548992, 131, '2014-02-15 00:10:00.000000', 'consum', 0.0229, 'lps'),
	(548993, 131, '2014-02-15 00:10:01.000000', 'consum', 0.0233, 'lps'),
	(548994, 131, '2014-02-15 00:10:02.000000', 'consum', 0.0215, 'lps'),
	(548995, 131, '2014-02-15 00:10:03.000000', 'consum', 0.0220, 'lps'),
	(548996, 131, '2014-02-15 00:10:04.000000', 'consum', 0.0217, 'lps'),
	(548997, 131, '2014-02-15 00:10:05.000000', 'consum', 0.0218, 'lps'),
	(548998, 131, '2014-02-15 00:10:06.000000', 'consum', 0.0228, 'lps'),
	(548999, 131, '2014-02-15 00:10:07.000000', 'consum', 0.0221, 'lps'),
	(549000, 131, '2014-02-15 00:10:08.000000', 'consum', 0.0210, 'lps'),
	(549001, 131, '2014-02-15 00:10:09.000000', 'consum', 0.0235, 'lps'),
	(549002, 131, '2014-02-15 00:10:10.000000', 'consum', 0.0222, 'lps'),
	(549003, 131, '2014-02-15 00:10:11.000000', 'consum', 0.0225, 'lps'),
	(549004, 131, '2014-02-15 00:10:12.000000', 'consum', 0.0223, 'lps'),
	(549005, 131, '2014-02-15 00:10:13.000000', 'consum', 0.0229, 'lps'),
	(549006, 131, '2014-02-15 00:10:14.000000', 'consum', 0.0211, 'lps'),
	(549007, 131, '2014-02-15 00:10:15.000000', 'consum', 0.0214, 'lps'),
	(549008, 131, '2014-02-15 00:10:16.000000', 'consum', 0.0230, 'lps'),
	(549009, 131, '2014-02-15 00:10:17.000000', 'consum', 0.0212, 'lps'),
	(549010, 131, '2014-02-15 00:10:18.000000', 'consum', 0.0216, 'lps'),
	(549011, 131, '2014-02-15 00:10:19.000000', 'consum', 0.0234, 'lps'),
	(549012, 131, '2014-02-15 00:10:20.000000', 'consum', 0.0228, 'lps'),
	(549013, 131, '2014-02-15 00:10:21.000000', 'consum', 0.0229, 'lps'),
	(549014, 131, '2014-02-15 00:10:22.000000', 'consum', 0.0223, 'lps'),
	(549015, 131, '2014-02-15 00:10:23.000000', 'consum', 0.0220, 'lps'),
	(549016, 131, '2014-02-15 00:10:24.000000', 'consum', 0.0222, 'lps'),
	(549017, 131, '2014-02-15 00:10:25.000000', 'consum', 0.0211, 'lps'),
	(549018, 131, '2014-02-15 00:10:26.000000', 'consum', 0.0237, 'lps'),
	(549019, 131, '2014-02-15 00:10:27.000000', 'consum', 0.0230, 'lps'),
	(549020, 131, '2014-02-15 00:10:28.000000', 'consum', 0.0229, 'lps'),
	(549021, 131, '2014-02-15 00:10:29.000000', 'consum', 0.0216, 'lps'),
	(549022, 131, '2014-02-15 00:10:30.000000', 'consum', 0.0211, 'lps'),
	(549023, 131, '2014-02-15 00:10:31.000000', 'consum', 0.0227, 'lps'),
	(549024, 131, '2014-02-15 00:10:32.000000', 'consum', 0.0210, 'lps'),
	(549025, 131, '2014-02-15 00:10:33.000000', 'consum', 0.0214, 'lps'),
	(549026, 131, '2014-02-15 00:10:34.000000', 'consum', 0.0231, 'lps'),
	(549027, 131, '2014-02-15 00:10:35.000000', 'consum', 0.0221, 'lps'),
	(549028, 131, '2014-02-15 00:10:36.000000', 'consum', 0.0231, 'lps'),
	(549029, 131, '2014-02-15 00:10:37.000000', 'consum', 0.0225, 'lps'),
	(549030, 131, '2014-02-15 00:10:38.000000', 'consum', 0.0223, 'lps'),
	(549031, 131, '2014-02-15 00:10:39.000000', 'consum', 0.0229, 'lps'),
	(549032, 131, '2014-02-15 00:10:40.000000', 'consum', 0.0213, 'lps'),
	(549033, 131, '2014-02-15 00:10:41.000000', 'consum', 0.0225, 'lps'),
	(549034, 131, '2014-02-15 00:10:42.000000', 'consum', 0.0220, 'lps'),
	(549035, 131, '2014-02-15 00:10:43.000000', 'consum', 0.0215, 'lps'),
	(549036, 131, '2014-02-15 00:10:44.000000', 'consum', 0.0232, 'lps'),
	(549037, 131, '2014-02-15 00:10:45.000000', 'consum', 0.0221, 'lps'),
	(549038, 131, '2014-02-15 00:10:46.000000', 'consum', 0.0228, 'lps'),
	(549039, 131, '2014-02-15 00:10:47.000000', 'consum', 0.0211, 'lps'),
	(549040, 131, '2014-02-15 00:10:48.000000', 'consum', 0.0216, 'lps'),
	(549041, 131, '2014-02-15 00:10:49.000000', 'consum', 0.0212, 'lps'),
	(549042, 131, '2014-02-15 00:10:50.000000', 'consum', 0.0231, 'lps'),
	(549043, 131, '2014-02-15 00:10:51.000000', 'consum', 0.0224, 'lps'),
	(549044, 131, '2014-02-15 00:10:52.000000', 'consum', 0.0218, 'lps'),
	(549045, 131, '2014-02-15 00:10:53.000000', 'consum', 0.0237, 'lps'),
	(549046, 131, '2014-02-15 00:10:54.000000', 'consum', 0.0237, 'lps'),
	(549047, 131, '2014-02-15 00:10:55.000000', 'consum', 0.0236, 'lps'),
	(549048, 131, '2014-02-15 00:10:56.000000', 'consum', 0.0230, 'lps'),
	(549049, 131, '2014-02-15 00:10:57.000000', 'consum', 0.0236, 'lps'),
	(549050, 131, '2014-02-15 00:10:58.000000', 'consum', 0.0221, 'lps'),
	(549051, 131, '2014-02-15 00:10:59.000000', 'consum', 0.0219, 'lps'),
	(549052, 131, '2014-02-15 00:11:00.000000', 'consum', 0.0220, 'lps'),
	(549053, 131, '2014-02-15 00:11:01.000000', 'consum', 0.0235, 'lps'),
	(549054, 131, '2014-02-15 00:11:02.000000', 'consum', 0.0223, 'lps'),
	(549055, 131, '2014-02-15 00:11:03.000000', 'consum', 0.0227, 'lps'),
	(549056, 131, '2014-02-15 00:11:04.000000', 'consum', 0.0228, 'lps'),
	(549057, 131, '2014-02-15 00:11:05.000000', 'consum', 0.0222, 'lps'),
	(549058, 131, '2014-02-15 00:11:06.000000', 'consum', 0.0217, 'lps'),
	(549059, 131, '2014-02-15 00:11:07.000000', 'consum', 0.0236, 'lps'),
	(549060, 131, '2014-02-15 00:11:08.000000', 'consum', 0.0210, 'lps'),
	(549061, 131, '2014-02-15 00:11:09.000000', 'consum', 0.0215, 'lps'),
	(549062, 131, '2014-02-15 00:11:10.000000', 'consum', 0.0236, 'lps'),
	(549063, 131, '2014-02-15 00:11:11.000000', 'consum', 0.0215, 'lps'),
	(549064, 131, '2014-02-15 00:11:12.000000', 'consum', 0.0212, 'lps'),
	(549065, 131, '2014-02-15 00:11:13.000000', 'consum', 0.0235, 'lps'),
	(549066, 131, '2014-02-15 00:11:14.000000', 'consum', 0.0217, 'lps'),
	(549067, 131, '2014-02-15 00:11:15.000000', 'consum', 0.0228, 'lps'),
	(549068, 131, '2014-02-15 00:11:16.000000', 'consum', 0.0222, 'lps'),
	(549069, 131, '2014-02-15 00:11:17.000000', 'consum', 0.0215, 'lps'),
	(549070, 131, '2014-02-15 00:11:18.000000', 'consum', 0.0229, 'lps'),
	(549071, 131, '2014-02-15 00:11:19.000000', 'consum', 0.0233, 'lps'),
	(549072, 131, '2014-02-15 00:11:20.000000', 'consum', 0.0211, 'lps'),
	(549073, 131, '2014-02-15 00:11:21.000000', 'consum', 0.0234, 'lps'),
	(549074, 131, '2014-02-15 00:11:22.000000', 'consum', 0.0213, 'lps'),
	(549075, 131, '2014-02-15 00:11:23.000000', 'consum', 0.0210, 'lps'),
	(549076, 131, '2014-02-15 00:11:24.000000', 'consum', 0.0228, 'lps'),
	(549077, 131, '2014-02-15 00:11:25.000000', 'consum', 0.0219, 'lps'),
	(549078, 131, '2014-02-15 00:11:26.000000', 'consum', 0.0230, 'lps'),
	(549079, 131, '2014-02-15 00:11:27.000000', 'consum', 0.0226, 'lps'),
	(549080, 131, '2014-02-15 00:11:28.000000', 'consum', 0.0230, 'lps'),
	(549081, 131, '2014-02-15 00:11:29.000000', 'consum', 0.0235, 'lps'),
	(549082, 131, '2014-02-15 00:11:30.000000', 'consum', 0.0219, 'lps'),
	(549083, 131, '2014-02-15 00:11:31.000000', 'consum', 0.0235, 'lps'),
	(549084, 131, '2014-02-15 00:11:32.000000', 'consum', 0.0227, 'lps'),
	(549085, 131, '2014-02-15 00:11:33.000000', 'consum', 0.0218, 'lps'),
	(549086, 131, '2014-02-15 00:11:34.000000', 'consum', 0.0228, 'lps'),
	(549087, 131, '2014-02-15 00:11:35.000000', 'consum', 0.0221, 'lps'),
	(549088, 131, '2014-02-15 00:11:36.000000', 'consum', 0.0214, 'lps'),
	(549089, 131, '2014-02-15 00:11:37.000000', 'consum', 0.0222, 'lps'),
	(549090, 131, '2014-02-15 00:11:38.000000', 'consum', 0.0231, 'lps'),
	(549091, 131, '2014-02-15 00:11:39.000000', 'consum', 0.0222, 'lps'),
	(549092, 131, '2014-02-15 00:11:40.000000', 'consum', 0.0236, 'lps'),
	(549093, 131, '2014-02-15 00:11:41.000000', 'consum', 0.0223, 'lps'),
	(549094, 131, '2014-02-15 00:11:42.000000', 'consum', 0.0225, 'lps'),
	(549095, 131, '2014-02-15 00:11:43.000000', 'consum', 0.0217, 'lps'),
	(549096, 131, '2014-02-15 00:11:44.000000', 'consum', 0.0228, 'lps'),
	(549097, 131, '2014-02-15 00:11:45.000000', 'consum', 0.0222, 'lps'),
	(549098, 131, '2014-02-15 00:11:46.000000', 'consum', 0.0219, 'lps'),
	(549099, 131, '2014-02-15 00:11:47.000000', 'consum', 0.0218, 'lps'),
	(549100, 131, '2014-02-15 00:11:48.000000', 'consum', 0.0226, 'lps'),
	(549101, 131, '2014-02-15 00:11:49.000000', 'consum', 0.0237, 'lps'),
	(549102, 131, '2014-02-15 00:11:50.000000', 'consum', 0.0214, 'lps'),
	(549103, 131, '2014-02-15 00:11:51.000000', 'consum', 0.0235, 'lps'),
	(549104, 131, '2014-02-15 00:11:52.000000', 'consum', 0.0236, 'lps'),
	(549105, 131, '2014-02-15 00:11:53.000000', 'consum', 0.0212, 'lps'),
	(549106, 131, '2014-02-15 00:11:54.000000', 'consum', 0.0225, 'lps'),
	(549107, 131, '2014-02-15 00:11:55.000000', 'consum', 0.0226, 'lps'),
	(549108, 131, '2014-02-15 00:11:56.000000', 'consum', 0.0217, 'lps'),
	(549109, 131, '2014-02-15 00:11:57.000000', 'consum', 0.0224, 'lps'),
	(549110, 131, '2014-02-15 00:11:58.000000', 'consum', 0.0233, 'lps'),
	(549111, 131, '2014-02-15 00:11:59.000000', 'consum', 0.0225, 'lps'),
	(549112, 131, '2014-02-15 00:12:00.000000', 'consum', 0.0218, 'lps'),
	(549113, 131, '2014-02-15 00:12:01.000000', 'consum', 0.0232, 'lps'),
	(549114, 131, '2014-02-15 00:12:02.000000', 'consum', 0.0212, 'lps'),
	(549115, 131, '2014-02-15 00:12:03.000000', 'consum', 0.0210, 'lps'),
	(549116, 131, '2014-02-15 00:12:04.000000', 'consum', 0.0235, 'lps'),
	(549117, 131, '2014-02-15 00:12:05.000000', 'consum', 0.0223, 'lps'),
	(549118, 131, '2014-02-15 00:12:06.000000', 'consum', 0.0228, 'lps'),
	(549119, 131, '2014-02-15 00:12:07.000000', 'consum', 0.0232, 'lps'),
	(549120, 131, '2014-02-15 00:12:08.000000', 'consum', 0.0212, 'lps'),
	(549121, 131, '2014-02-15 00:12:09.000000', 'consum', 0.0210, 'lps'),
	(549122, 131, '2014-02-15 00:12:10.000000', 'consum', 0.0235, 'lps'),
	(549123, 131, '2014-02-15 00:12:11.000000', 'consum', 0.0220, 'lps'),
	(549124, 131, '2014-02-15 00:12:12.000000', 'consum', 0.0216, 'lps'),
	(549125, 131, '2014-02-15 00:12:13.000000', 'consum', 0.0237, 'lps'),
	(549126, 131, '2014-02-15 00:12:14.000000', 'consum', 0.0216, 'lps'),
	(549127, 131, '2014-02-15 00:12:15.000000', 'consum', 0.0215, 'lps'),
	(549128, 131, '2014-02-15 00:12:16.000000', 'consum', 0.0216, 'lps'),
	(549129, 131, '2014-02-15 00:12:17.000000', 'consum', 0.0228, 'lps'),
	(549130, 131, '2014-02-15 00:12:18.000000', 'consum', 0.0225, 'lps'),
	(549131, 131, '2014-02-15 00:12:19.000000', 'consum', 0.0234, 'lps'),
	(549132, 131, '2014-02-15 00:12:20.000000', 'consum', 0.0226, 'lps'),
	(549133, 131, '2014-02-15 00:12:21.000000', 'consum', 0.0222, 'lps'),
	(549134, 131, '2014-02-15 00:12:22.000000', 'consum', 0.0219, 'lps'),
	(549135, 131, '2014-02-15 00:12:23.000000', 'consum', 0.0223, 'lps'),
	(549136, 131, '2014-02-15 00:12:24.000000', 'consum', 0.0218, 'lps'),
	(549137, 131, '2014-02-15 00:12:25.000000', 'consum', 0.0210, 'lps'),
	(549138, 131, '2014-02-15 00:12:26.000000', 'consum', 0.0218, 'lps'),
	(549139, 131, '2014-02-15 00:12:27.000000', 'consum', 0.0220, 'lps'),
	(549140, 131, '2014-02-15 00:12:28.000000', 'consum', 0.0211, 'lps'),
	(549141, 131, '2014-02-15 00:12:29.000000', 'consum', 0.0214, 'lps'),
	(549142, 131, '2014-02-15 00:12:30.000000', 'consum', 0.0225, 'lps'),
	(549143, 131, '2014-02-15 00:12:31.000000', 'consum', 0.0220, 'lps'),
	(549144, 131, '2014-02-15 00:12:32.000000', 'consum', 0.0216, 'lps'),
	(549145, 131, '2014-02-15 00:12:33.000000', 'consum', 0.0236, 'lps'),
	(549146, 131, '2014-02-15 00:12:34.000000', 'consum', 0.0211, 'lps'),
	(549147, 131, '2014-02-15 00:12:35.000000', 'consum', 0.0224, 'lps'),
	(549148, 131, '2014-02-15 00:12:36.000000', 'consum', 0.0219, 'lps'),
	(549149, 131, '2014-02-15 00:12:37.000000', 'consum', 0.0215, 'lps'),
	(549150, 131, '2014-02-15 00:12:38.000000', 'consum', 0.0236, 'lps'),
	(549151, 131, '2014-02-15 00:12:39.000000', 'consum', 0.0212, 'lps'),
	(549152, 131, '2014-02-15 00:12:40.000000', 'consum', 0.0228, 'lps'),
	(549153, 131, '2014-02-15 00:12:41.000000', 'consum', 0.0210, 'lps'),
	(549154, 131, '2014-02-15 00:12:42.000000', 'consum', 0.0211, 'lps'),
	(549155, 131, '2014-02-15 00:12:43.000000', 'consum', 0.0218, 'lps'),
	(549156, 131, '2014-02-15 00:12:44.000000', 'consum', 0.0218, 'lps'),
	(549157, 131, '2014-02-15 00:12:45.000000', 'consum', 0.0226, 'lps'),
	(549158, 131, '2014-02-15 00:12:46.000000', 'consum', 0.0212, 'lps'),
	(549159, 131, '2014-02-15 00:12:47.000000', 'consum', 0.0226, 'lps'),
	(549160, 131, '2014-02-15 00:12:48.000000', 'consum', 0.0231, 'lps'),
	(549161, 131, '2014-02-15 00:12:49.000000', 'consum', 0.0210, 'lps'),
	(549162, 131, '2014-02-15 00:12:50.000000', 'consum', 0.0234, 'lps'),
	(549163, 131, '2014-02-15 00:12:51.000000', 'consum', 0.0216, 'lps'),
	(549164, 131, '2014-02-15 00:12:52.000000', 'consum', 0.0225, 'lps'),
	(549165, 131, '2014-02-15 00:12:53.000000', 'consum', 0.0213, 'lps'),
	(549166, 131, '2014-02-15 00:12:54.000000', 'consum', 0.0237, 'lps'),
	(549167, 131, '2014-02-15 00:12:55.000000', 'consum', 0.0223, 'lps'),
	(549168, 131, '2014-02-15 00:12:56.000000', 'consum', 0.0221, 'lps'),
	(549169, 131, '2014-02-15 00:12:57.000000', 'consum', 0.0227, 'lps'),
	(549170, 131, '2014-02-15 00:12:58.000000', 'consum', 0.0237, 'lps'),
	(549171, 131, '2014-02-15 00:12:59.000000', 'consum', 0.0210, 'lps'),
	(549172, 131, '2014-02-15 00:13:00.000000', 'consum', 0.0212, 'lps'),
	(549173, 131, '2014-02-15 00:13:01.000000', 'consum', 0.0220, 'lps'),
	(549174, 131, '2014-02-15 00:13:02.000000', 'consum', 0.0229, 'lps'),
	(549175, 131, '2014-02-15 00:13:03.000000', 'consum', 0.0218, 'lps'),
	(549176, 131, '2014-02-15 00:13:04.000000', 'consum', 0.0220, 'lps'),
	(549177, 131, '2014-02-15 00:13:05.000000', 'consum', 0.0237, 'lps'),
	(549178, 131, '2014-02-15 00:13:06.000000', 'consum', 0.0234, 'lps'),
	(549179, 131, '2014-02-15 00:13:07.000000', 'consum', 0.0220, 'lps'),
	(549180, 131, '2014-02-15 00:13:08.000000', 'consum', 0.0215, 'lps'),
	(549181, 131, '2014-02-15 00:13:09.000000', 'consum', 0.0235, 'lps'),
	(549182, 131, '2014-02-15 00:13:10.000000', 'consum', 0.0236, 'lps'),
	(549183, 131, '2014-02-15 00:13:11.000000', 'consum', 0.0237, 'lps'),
	(549184, 131, '2014-02-15 00:13:12.000000', 'consum', 0.0214, 'lps'),
	(549185, 131, '2014-02-15 00:13:13.000000', 'consum', 0.0230, 'lps'),
	(549186, 131, '2014-02-15 00:13:14.000000', 'consum', 0.0216, 'lps'),
	(549187, 131, '2014-02-15 00:13:15.000000', 'consum', 0.0235, 'lps'),
	(549188, 131, '2014-02-15 00:13:16.000000', 'consum', 0.0236, 'lps'),
	(549189, 131, '2014-02-15 00:13:17.000000', 'consum', 0.0210, 'lps'),
	(549190, 131, '2014-02-15 00:13:18.000000', 'consum', 0.0216, 'lps'),
	(549191, 131, '2014-02-15 00:13:19.000000', 'consum', 0.0212, 'lps'),
	(549192, 131, '2014-02-15 00:13:20.000000', 'consum', 0.0232, 'lps'),
	(549193, 131, '2014-02-15 00:13:21.000000', 'consum', 0.0229, 'lps'),
	(549194, 131, '2014-02-15 00:13:22.000000', 'consum', 0.0211, 'lps'),
	(549195, 131, '2014-02-15 00:13:23.000000', 'consum', 0.0213, 'lps'),
	(549196, 131, '2014-02-15 00:13:24.000000', 'consum', 0.0224, 'lps'),
	(549197, 131, '2014-02-15 00:13:25.000000', 'consum', 0.0215, 'lps'),
	(549198, 131, '2014-02-15 00:13:26.000000', 'consum', 0.0220, 'lps'),
	(549199, 131, '2014-02-15 00:13:27.000000', 'consum', 0.0220, 'lps'),
	(549200, 131, '2014-02-15 00:13:28.000000', 'consum', 0.0228, 'lps'),
	(549201, 131, '2014-02-15 00:13:29.000000', 'consum', 0.0214, 'lps'),
	(549202, 131, '2014-02-15 00:13:30.000000', 'consum', 0.0235, 'lps'),
	(549203, 131, '2014-02-15 00:13:31.000000', 'consum', 0.0213, 'lps'),
	(549204, 131, '2014-02-15 00:13:32.000000', 'consum', 0.0231, 'lps'),
	(549205, 131, '2014-02-15 00:13:33.000000', 'consum', 0.0225, 'lps'),
	(549206, 131, '2014-02-15 00:13:34.000000', 'consum', 0.0223, 'lps'),
	(549207, 131, '2014-02-15 00:13:35.000000', 'consum', 0.0232, 'lps'),
	(549208, 131, '2014-02-15 00:13:36.000000', 'consum', 0.0222, 'lps'),
	(549209, 131, '2014-02-15 00:13:37.000000', 'consum', 0.0235, 'lps'),
	(549210, 131, '2014-02-15 00:13:38.000000', 'consum', 0.0215, 'lps'),
	(549211, 131, '2014-02-15 00:13:39.000000', 'consum', 0.0217, 'lps'),
	(549212, 131, '2014-02-15 00:13:40.000000', 'consum', 0.0231, 'lps'),
	(549213, 131, '2014-02-15 00:13:41.000000', 'consum', 0.0237, 'lps'),
	(549214, 131, '2014-02-15 00:13:42.000000', 'consum', 0.0226, 'lps'),
	(549215, 131, '2014-02-15 00:13:43.000000', 'consum', 0.0212, 'lps'),
	(549216, 131, '2014-02-15 00:13:44.000000', 'consum', 0.0227, 'lps'),
	(549217, 131, '2014-02-15 00:13:45.000000', 'consum', 0.0234, 'lps'),
	(549218, 131, '2014-02-15 00:13:46.000000', 'consum', 0.0224, 'lps'),
	(549219, 131, '2014-02-15 00:13:47.000000', 'consum', 0.0235, 'lps'),
	(549220, 131, '2014-02-15 00:13:48.000000', 'consum', 0.0236, 'lps'),
	(549221, 131, '2014-02-15 00:13:49.000000', 'consum', 0.0211, 'lps'),
	(549222, 131, '2014-02-15 00:13:50.000000', 'consum', 0.0223, 'lps'),
	(549223, 131, '2014-02-15 00:13:51.000000', 'consum', 0.0214, 'lps'),
	(549224, 131, '2014-02-15 00:13:52.000000', 'consum', 0.0222, 'lps'),
	(549225, 131, '2014-02-15 00:13:53.000000', 'consum', 0.0228, 'lps'),
	(549226, 131, '2014-02-15 00:13:54.000000', 'consum', 0.0237, 'lps'),
	(549227, 131, '2014-02-15 00:13:55.000000', 'consum', 0.0235, 'lps'),
	(549228, 131, '2014-02-15 00:13:56.000000', 'consum', 0.0229, 'lps'),
	(549229, 131, '2014-02-15 00:13:57.000000', 'consum', 0.0230, 'lps'),
	(549230, 131, '2014-02-15 00:13:58.000000', 'consum', 0.0224, 'lps'),
	(549231, 131, '2014-02-15 00:13:59.000000', 'consum', 0.0222, 'lps'),
	(549232, 131, '2014-02-15 00:14:00.000000', 'consum', 0.0229, 'lps'),
	(549233, 131, '2014-02-15 00:14:01.000000', 'consum', 0.0214, 'lps'),
	(549234, 131, '2014-02-15 00:14:02.000000', 'consum', 0.0227, 'lps'),
	(549235, 131, '2014-02-15 00:14:03.000000', 'consum', 0.0227, 'lps'),
	(549236, 131, '2014-02-15 00:14:04.000000', 'consum', 0.0217, 'lps'),
	(549237, 131, '2014-02-15 00:14:05.000000', 'consum', 0.0224, 'lps'),
	(549238, 131, '2014-02-15 00:14:06.000000', 'consum', 0.0232, 'lps'),
	(549239, 131, '2014-02-15 00:14:07.000000', 'consum', 0.0221, 'lps'),
	(549240, 131, '2014-02-15 00:14:08.000000', 'consum', 0.0228, 'lps'),
	(549241, 131, '2014-02-15 00:14:09.000000', 'consum', 0.0212, 'lps'),
	(549242, 131, '2014-02-15 00:14:10.000000', 'consum', 0.0220, 'lps'),
	(549243, 131, '2014-02-15 00:14:11.000000', 'consum', 0.0229, 'lps'),
	(549244, 131, '2014-02-15 00:14:12.000000', 'consum', 0.0221, 'lps'),
	(549245, 131, '2014-02-15 00:14:13.000000', 'consum', 0.0235, 'lps'),
	(549246, 131, '2014-02-15 00:14:14.000000', 'consum', 0.0216, 'lps'),
	(549247, 131, '2014-02-15 00:14:15.000000', 'consum', 0.0225, 'lps'),
	(549248, 131, '2014-02-15 00:14:16.000000', 'consum', 0.0211, 'lps'),
	(549249, 131, '2014-02-15 00:14:17.000000', 'consum', 0.0228, 'lps'),
	(549250, 131, '2014-02-15 00:14:18.000000', 'consum', 0.0212, 'lps'),
	(549251, 131, '2014-02-15 00:14:19.000000', 'consum', 0.0224, 'lps'),
	(549252, 131, '2014-02-15 00:14:20.000000', 'consum', 0.0218, 'lps'),
	(549253, 131, '2014-02-15 00:14:21.000000', 'consum', 0.0236, 'lps'),
	(549254, 131, '2014-02-15 00:14:22.000000', 'consum', 0.0231, 'lps'),
	(549255, 131, '2014-02-15 00:14:23.000000', 'consum', 0.0210, 'lps'),
	(549256, 131, '2014-02-15 00:14:24.000000', 'consum', 0.0230, 'lps'),
	(549257, 131, '2014-02-15 00:14:25.000000', 'consum', 0.0229, 'lps'),
	(549258, 131, '2014-02-15 00:14:26.000000', 'consum', 0.0215, 'lps'),
	(549259, 131, '2014-02-15 00:14:27.000000', 'consum', 0.0234, 'lps'),
	(549260, 131, '2014-02-15 00:14:28.000000', 'consum', 0.0234, 'lps'),
	(549261, 131, '2014-02-15 00:14:29.000000', 'consum', 0.0230, 'lps'),
	(549262, 131, '2014-02-15 00:14:30.000000', 'consum', 0.0212, 'lps'),
	(549263, 131, '2014-02-15 00:14:31.000000', 'consum', 0.0213, 'lps'),
	(549264, 131, '2014-02-15 00:14:32.000000', 'consum', 0.0223, 'lps'),
	(549265, 131, '2014-02-15 00:14:33.000000', 'consum', 0.0237, 'lps'),
	(549266, 131, '2014-02-15 00:14:34.000000', 'consum', 0.0221, 'lps'),
	(549267, 131, '2014-02-15 00:14:35.000000', 'consum', 0.0214, 'lps'),
	(549268, 131, '2014-02-15 00:14:36.000000', 'consum', 0.0226, 'lps'),
	(549269, 131, '2014-02-15 00:14:37.000000', 'consum', 0.0224, 'lps'),
	(549270, 131, '2014-02-15 00:14:38.000000', 'consum', 0.0231, 'lps'),
	(549271, 131, '2014-02-15 00:14:39.000000', 'consum', 0.0218, 'lps'),
	(549272, 131, '2014-02-15 00:14:40.000000', 'consum', 0.0214, 'lps'),
	(549273, 131, '2014-02-15 00:14:41.000000', 'consum', 0.0235, 'lps'),
	(549274, 131, '2014-02-15 00:14:42.000000', 'consum', 0.0212, 'lps'),
	(549275, 131, '2014-02-15 00:14:43.000000', 'consum', 0.0231, 'lps'),
	(549276, 131, '2014-02-15 00:14:44.000000', 'consum', 0.0224, 'lps'),
	(549277, 131, '2014-02-15 00:14:45.000000', 'consum', 0.0217, 'lps'),
	(549278, 131, '2014-02-15 00:14:46.000000', 'consum', 0.0234, 'lps'),
	(549279, 131, '2014-02-15 00:14:47.000000', 'consum', 0.0222, 'lps'),
	(549280, 131, '2014-02-15 00:14:48.000000', 'consum', 0.0229, 'lps'),
	(549281, 131, '2014-02-15 00:14:49.000000', 'consum', 0.0214, 'lps'),
	(549282, 131, '2014-02-15 00:14:50.000000', 'consum', 0.0229, 'lps'),
	(549283, 131, '2014-02-15 00:14:51.000000', 'consum', 0.0210, 'lps'),
	(549284, 131, '2014-02-15 00:14:52.000000', 'consum', 0.0236, 'lps'),
	(549285, 131, '2014-02-15 00:14:53.000000', 'consum', 0.0227, 'lps'),
	(549286, 131, '2014-02-15 00:14:54.000000', 'consum', 0.0220, 'lps'),
	(549287, 131, '2014-02-15 00:14:55.000000', 'consum', 0.0236, 'lps'),
	(549288, 131, '2014-02-15 00:14:56.000000', 'consum', 0.0226, 'lps'),
	(549289, 131, '2014-02-15 00:14:57.000000', 'consum', 0.0215, 'lps'),
	(549290, 131, '2014-02-15 00:14:58.000000', 'consum', 0.0213, 'lps'),
	(549291, 131, '2014-02-15 00:14:59.000000', 'consum', 0.0237, 'lps'),
	(549292, 131, '2014-02-15 00:15:00.000000', 'consum', 0.0228, 'lps'),
	(549293, 131, '2014-02-15 00:15:01.000000', 'consum', 0.0217, 'lps'),
	(549294, 131, '2014-02-15 00:15:02.000000', 'consum', 0.0220, 'lps'),
	(549295, 131, '2014-02-15 00:15:03.000000', 'consum', 0.0212, 'lps'),
	(549296, 131, '2014-02-15 00:15:04.000000', 'consum', 0.0219, 'lps'),
	(549297, 131, '2014-02-15 00:15:05.000000', 'consum', 0.0221, 'lps'),
	(549298, 131, '2014-02-15 00:15:06.000000', 'consum', 0.0210, 'lps'),
	(549299, 131, '2014-02-15 00:15:07.000000', 'consum', 0.0233, 'lps'),
	(549300, 131, '2014-02-15 00:15:08.000000', 'consum', 0.0215, 'lps'),
	(549301, 131, '2014-02-15 00:15:09.000000', 'consum', 0.0222, 'lps'),
	(549302, 131, '2014-02-15 00:15:10.000000', 'consum', 0.0227, 'lps'),
	(549303, 131, '2014-02-15 00:15:11.000000', 'consum', 0.0233, 'lps'),
	(549304, 131, '2014-02-15 00:15:12.000000', 'consum', 0.0216, 'lps'),
	(549305, 131, '2014-02-15 00:15:13.000000', 'consum', 0.0228, 'lps'),
	(549306, 131, '2014-02-15 00:15:14.000000', 'consum', 0.0228, 'lps'),
	(549307, 131, '2014-02-15 00:15:15.000000', 'consum', 0.0217, 'lps'),
	(549308, 131, '2014-02-15 00:15:16.000000', 'consum', 0.0221, 'lps'),
	(549309, 131, '2014-02-15 00:15:17.000000', 'consum', 0.0217, 'lps'),
	(549310, 131, '2014-02-15 00:15:18.000000', 'consum', 0.0210, 'lps'),
	(549311, 131, '2014-02-15 00:15:19.000000', 'consum', 0.0221, 'lps'),
	(549312, 131, '2014-02-15 00:15:20.000000', 'consum', 0.0234, 'lps'),
	(549313, 131, '2014-02-15 00:15:21.000000', 'consum', 0.0215, 'lps'),
	(549314, 131, '2014-02-15 00:15:22.000000', 'consum', 0.0220, 'lps'),
	(549315, 131, '2014-02-15 00:15:23.000000', 'consum', 0.0217, 'lps'),
	(549316, 131, '2014-02-15 00:15:24.000000', 'consum', 0.0214, 'lps'),
	(549317, 131, '2014-02-15 00:15:25.000000', 'consum', 0.0211, 'lps'),
	(549318, 131, '2014-02-15 00:15:26.000000', 'consum', 0.0229, 'lps'),
	(549319, 131, '2014-02-15 00:15:27.000000', 'consum', 0.0221, 'lps'),
	(549320, 131, '2014-02-15 00:15:28.000000', 'consum', 0.0236, 'lps'),
	(549321, 131, '2014-02-15 00:15:29.000000', 'consum', 0.0221, 'lps'),
	(549322, 131, '2014-02-15 00:15:30.000000', 'consum', 0.0219, 'lps'),
	(549323, 131, '2014-02-15 00:15:31.000000', 'consum', 0.0222, 'lps'),
	(549324, 131, '2014-02-15 00:15:32.000000', 'consum', 0.0213, 'lps'),
	(549325, 131, '2014-02-15 00:15:33.000000', 'consum', 0.0218, 'lps'),
	(549326, 131, '2014-02-15 00:15:34.000000', 'consum', 0.0216, 'lps'),
	(549327, 131, '2014-02-15 00:15:35.000000', 'consum', 0.0213, 'lps'),
	(549328, 131, '2014-02-15 00:15:36.000000', 'consum', 0.0211, 'lps'),
	(549329, 131, '2014-02-15 00:15:37.000000', 'consum', 0.0234, 'lps'),
	(549330, 131, '2014-02-15 00:15:38.000000', 'consum', 0.0213, 'lps'),
	(549331, 131, '2014-02-15 00:15:39.000000', 'consum', 0.0210, 'lps'),
	(549332, 131, '2014-02-15 00:15:40.000000', 'consum', 0.0231, 'lps'),
	(549333, 131, '2014-02-15 00:15:41.000000', 'consum', 0.0231, 'lps'),
	(549334, 131, '2014-02-15 00:15:42.000000', 'consum', 0.0225, 'lps'),
	(549335, 131, '2014-02-15 00:15:43.000000', 'consum', 0.0222, 'lps'),
	(549336, 131, '2014-02-15 00:15:44.000000', 'consum', 0.0227, 'lps'),
	(549337, 131, '2014-02-15 00:15:45.000000', 'consum', 0.0230, 'lps'),
	(549338, 131, '2014-02-15 00:15:46.000000', 'consum', 0.0230, 'lps'),
	(549339, 131, '2014-02-15 00:15:47.000000', 'consum', 0.0225, 'lps'),
	(549340, 131, '2014-02-15 00:15:48.000000', 'consum', 0.0223, 'lps'),
	(549341, 131, '2014-02-15 00:15:49.000000', 'consum', 0.0231, 'lps'),
	(549342, 131, '2014-02-15 00:15:50.000000', 'consum', 0.0222, 'lps'),
	(549343, 131, '2014-02-15 00:15:51.000000', 'consum', 0.0236, 'lps'),
	(549344, 131, '2014-02-15 00:15:52.000000', 'consum', 0.0222, 'lps'),
	(549345, 131, '2014-02-15 00:15:53.000000', 'consum', 0.0218, 'lps'),
	(549346, 131, '2014-02-15 00:15:54.000000', 'consum', 0.0214, 'lps'),
	(549347, 131, '2014-02-15 00:15:55.000000', 'consum', 0.0234, 'lps'),
	(549348, 131, '2014-02-15 00:15:56.000000', 'consum', 0.0235, 'lps'),
	(549349, 131, '2014-02-15 00:15:57.000000', 'consum', 0.0210, 'lps'),
	(549350, 131, '2014-02-15 00:15:58.000000', 'consum', 0.0216, 'lps'),
	(549351, 131, '2014-02-15 00:15:59.000000', 'consum', 0.0214, 'lps'),
	(549352, 131, '2014-02-15 00:16:00.000000', 'consum', 0.0211, 'lps'),
	(549353, 131, '2014-02-15 00:16:01.000000', 'consum', 0.0231, 'lps'),
	(549354, 131, '2014-02-15 00:16:02.000000', 'consum', 0.0229, 'lps'),
	(549355, 131, '2014-02-15 00:16:03.000000', 'consum', 0.0213, 'lps'),
	(549356, 131, '2014-02-15 00:16:04.000000', 'consum', 0.0228, 'lps'),
	(549357, 131, '2014-02-15 00:16:05.000000', 'consum', 0.0233, 'lps'),
	(549358, 131, '2014-02-15 00:16:06.000000', 'consum', 0.0215, 'lps'),
	(549359, 131, '2014-02-15 00:16:07.000000', 'consum', 0.0225, 'lps'),
	(549360, 131, '2014-02-15 00:16:08.000000', 'consum', 0.0213, 'lps'),
	(549361, 131, '2014-02-15 00:16:09.000000', 'consum', 0.0236, 'lps'),
	(549362, 131, '2014-02-15 00:16:10.000000', 'consum', 0.0218, 'lps'),
	(549363, 131, '2014-02-15 00:16:11.000000', 'consum', 0.0231, 'lps'),
	(549364, 131, '2014-02-15 00:16:12.000000', 'consum', 0.0236, 'lps'),
	(549365, 131, '2014-02-15 00:16:13.000000', 'consum', 0.0221, 'lps'),
	(549366, 131, '2014-02-15 00:16:14.000000', 'consum', 0.0215, 'lps'),
	(549367, 131, '2014-02-15 00:16:15.000000', 'consum', 0.0229, 'lps'),
	(549368, 131, '2014-02-15 00:16:16.000000', 'consum', 0.0236, 'lps'),
	(549369, 131, '2014-02-15 00:16:17.000000', 'consum', 0.0227, 'lps'),
	(549370, 131, '2014-02-15 00:16:18.000000', 'consum', 0.0218, 'lps'),
	(549371, 131, '2014-02-15 00:16:19.000000', 'consum', 0.0229, 'lps'),
	(549372, 131, '2014-02-15 00:16:20.000000', 'consum', 0.0223, 'lps'),
	(549373, 131, '2014-02-15 00:16:21.000000', 'consum', 0.0217, 'lps'),
	(549374, 131, '2014-02-15 00:16:22.000000', 'consum', 0.0210, 'lps'),
	(549375, 131, '2014-02-15 00:16:23.000000', 'consum', 0.0216, 'lps'),
	(549376, 131, '2014-02-15 00:16:24.000000', 'consum', 0.0214, 'lps'),
	(549377, 131, '2014-02-15 00:16:25.000000', 'consum', 0.0211, 'lps'),
	(549378, 131, '2014-02-15 00:16:26.000000', 'consum', 0.0232, 'lps'),
	(549379, 131, '2014-02-15 00:16:27.000000', 'consum', 0.0233, 'lps'),
	(549380, 131, '2014-02-15 00:16:28.000000', 'consum', 0.0232, 'lps'),
	(549381, 131, '2014-02-15 00:16:29.000000', 'consum', 0.0223, 'lps'),
	(549382, 131, '2014-02-15 00:16:30.000000', 'consum', 0.0210, 'lps'),
	(549383, 131, '2014-02-15 00:16:31.000000', 'consum', 0.0226, 'lps'),
	(549384, 131, '2014-02-15 00:16:32.000000', 'consum', 0.0235, 'lps'),
	(549385, 131, '2014-02-15 00:16:33.000000', 'consum', 0.0231, 'lps'),
	(549386, 131, '2014-02-15 00:16:34.000000', 'consum', 0.0212, 'lps'),
	(549387, 131, '2014-02-15 00:16:35.000000', 'consum', 0.0215, 'lps'),
	(549388, 131, '2014-02-15 00:16:36.000000', 'consum', 0.0227, 'lps'),
	(549389, 131, '2014-02-15 00:16:37.000000', 'consum', 0.0225, 'lps'),
	(549390, 131, '2014-02-15 00:16:38.000000', 'consum', 0.0237, 'lps'),
	(549391, 131, '2014-02-15 00:16:39.000000', 'consum', 0.0216, 'lps'),
	(549392, 131, '2014-02-15 00:16:40.000000', 'consum', 0.0214, 'lps'),
	(549393, 131, '2014-02-15 00:16:41.000000', 'consum', 0.0214, 'lps'),
	(549394, 131, '2014-02-15 00:16:42.000000', 'consum', 0.0220, 'lps'),
	(549395, 131, '2014-02-15 00:16:43.000000', 'consum', 0.0217, 'lps'),
	(549396, 131, '2014-02-15 00:16:44.000000', 'consum', 0.0218, 'lps'),
	(549397, 131, '2014-02-15 00:16:45.000000', 'consum', 0.0227, 'lps'),
	(549398, 131, '2014-02-15 00:16:46.000000', 'consum', 0.0218, 'lps'),
	(549399, 131, '2014-02-15 00:16:47.000000', 'consum', 0.0229, 'lps'),
	(549400, 131, '2014-02-15 00:16:48.000000', 'consum', 0.0223, 'lps'),
	(549401, 131, '2014-02-15 00:16:49.000000', 'consum', 0.0217, 'lps'),
	(549402, 131, '2014-02-15 00:16:50.000000', 'consum', 0.0236, 'lps'),
	(549403, 131, '2014-02-15 00:16:51.000000', 'consum', 0.0236, 'lps'),
	(549404, 131, '2014-02-15 00:16:52.000000', 'consum', 0.0232, 'lps'),
	(549405, 131, '2014-02-15 00:16:53.000000', 'consum', 0.0218, 'lps'),
	(549406, 131, '2014-02-15 00:16:54.000000', 'consum', 0.0211, 'lps'),
	(549407, 131, '2014-02-15 00:16:55.000000', 'consum', 0.0220, 'lps'),
	(549408, 131, '2014-02-15 00:16:56.000000', 'consum', 0.0230, 'lps'),
	(549409, 131, '2014-02-15 00:16:57.000000', 'consum', 0.0225, 'lps'),
	(549410, 131, '2014-02-15 00:16:58.000000', 'consum', 0.0223, 'lps'),
	(549411, 131, '2014-02-15 00:16:59.000000', 'consum', 0.0232, 'lps'),
	(549412, 131, '2014-02-15 00:17:00.000000', 'consum', 0.0225, 'lps'),
	(549413, 131, '2014-02-15 00:17:01.000000', 'consum', 0.0219, 'lps'),
	(549414, 131, '2014-02-15 00:17:02.000000', 'consum', 0.0212, 'lps'),
	(549415, 131, '2014-02-15 00:17:03.000000', 'consum', 0.0220, 'lps'),
	(549416, 131, '2014-02-15 00:17:04.000000', 'consum', 0.0227, 'lps'),
	(549417, 131, '2014-02-15 00:17:05.000000', 'consum', 0.0237, 'lps'),
	(549418, 131, '2014-02-15 00:17:06.000000', 'consum', 0.0211, 'lps'),
	(549419, 131, '2014-02-15 00:17:07.000000', 'consum', 0.0219, 'lps'),
	(549420, 131, '2014-02-15 00:17:08.000000', 'consum', 0.0224, 'lps'),
	(549421, 131, '2014-02-15 00:17:09.000000', 'consum', 0.0224, 'lps'),
	(549422, 131, '2014-02-15 00:17:10.000000', 'consum', 0.0213, 'lps'),
	(549423, 131, '2014-02-15 00:17:11.000000', 'consum', 0.0237, 'lps'),
	(549424, 131, '2014-02-15 00:17:12.000000', 'consum', 0.0223, 'lps'),
	(549425, 131, '2014-02-15 00:17:13.000000', 'consum', 0.0226, 'lps'),
	(549426, 131, '2014-02-15 00:17:14.000000', 'consum', 0.0224, 'lps'),
	(549427, 131, '2014-02-15 00:17:15.000000', 'consum', 0.0231, 'lps'),
	(549428, 131, '2014-02-15 00:17:16.000000', 'consum', 0.0216, 'lps'),
	(549429, 131, '2014-02-15 00:17:17.000000', 'consum', 0.0235, 'lps'),
	(549430, 131, '2014-02-15 00:17:18.000000', 'consum', 0.0232, 'lps'),
	(549431, 131, '2014-02-15 00:17:19.000000', 'consum', 0.0217, 'lps'),
	(549432, 131, '2014-02-15 00:17:20.000000', 'consum', 0.0210, 'lps'),
	(549433, 131, '2014-02-15 00:17:21.000000', 'consum', 0.0214, 'lps'),
	(549434, 131, '2014-02-15 00:17:22.000000', 'consum', 0.0234, 'lps'),
	(549435, 131, '2014-02-15 00:17:23.000000', 'consum', 0.0233, 'lps'),
	(549436, 131, '2014-02-15 00:17:24.000000', 'consum', 0.0225, 'lps'),
	(549437, 131, '2014-02-15 00:17:25.000000', 'consum', 0.0216, 'lps'),
	(549438, 131, '2014-02-15 00:17:26.000000', 'consum', 0.0224, 'lps'),
	(549439, 131, '2014-02-15 00:17:27.000000', 'consum', 0.0236, 'lps'),
	(549440, 131, '2014-02-15 00:17:28.000000', 'consum', 0.0212, 'lps'),
	(549441, 131, '2014-02-15 00:17:29.000000', 'consum', 0.0229, 'lps'),
	(549442, 131, '2014-02-15 00:17:30.000000', 'consum', 0.0213, 'lps'),
	(549443, 131, '2014-02-15 00:17:31.000000', 'consum', 0.0223, 'lps'),
	(549444, 131, '2014-02-15 00:17:32.000000', 'consum', 0.0214, 'lps'),
	(549445, 131, '2014-02-15 00:17:33.000000', 'consum', 0.0219, 'lps'),
	(549446, 131, '2014-02-15 00:17:34.000000', 'consum', 0.0213, 'lps'),
	(549447, 131, '2014-02-15 00:17:35.000000', 'consum', 0.0230, 'lps'),
	(549448, 131, '2014-02-15 00:17:36.000000', 'consum', 0.0214, 'lps'),
	(549449, 131, '2014-02-15 00:17:37.000000', 'consum', 0.0228, 'lps'),
	(549450, 131, '2014-02-15 00:17:38.000000', 'consum', 0.0231, 'lps'),
	(549451, 131, '2014-02-15 00:17:39.000000', 'consum', 0.0233, 'lps'),
	(549452, 131, '2014-02-15 00:17:40.000000', 'consum', 0.0235, 'lps'),
	(549453, 131, '2014-02-15 00:17:41.000000', 'consum', 0.0210, 'lps'),
	(549454, 131, '2014-02-15 00:17:42.000000', 'consum', 0.0219, 'lps'),
	(549455, 131, '2014-02-15 00:17:43.000000', 'consum', 0.0228, 'lps'),
	(549456, 131, '2014-02-15 00:17:44.000000', 'consum', 0.0216, 'lps'),
	(549457, 131, '2014-02-15 00:17:45.000000', 'consum', 0.0215, 'lps'),
	(549458, 131, '2014-02-15 00:17:46.000000', 'consum', 0.0219, 'lps'),
	(549459, 131, '2014-02-15 00:17:47.000000', 'consum', 0.0211, 'lps'),
	(549460, 131, '2014-02-15 00:17:48.000000', 'consum', 0.0218, 'lps'),
	(549461, 131, '2014-02-15 00:17:49.000000', 'consum', 0.0220, 'lps'),
	(549462, 131, '2014-02-15 00:17:50.000000', 'consum', 0.0236, 'lps'),
	(549463, 131, '2014-02-15 00:17:51.000000', 'consum', 0.0226, 'lps'),
	(549464, 131, '2014-02-15 00:17:52.000000', 'consum', 0.0215, 'lps'),
	(549465, 131, '2014-02-15 00:17:53.000000', 'consum', 0.0212, 'lps'),
	(549466, 131, '2014-02-15 00:17:54.000000', 'consum', 0.0235, 'lps'),
	(549467, 131, '2014-02-15 00:17:55.000000', 'consum', 0.0218, 'lps'),
	(549468, 131, '2014-02-15 00:17:56.000000', 'consum', 0.0231, 'lps'),
	(549469, 131, '2014-02-15 00:17:57.000000', 'consum', 0.0235, 'lps'),
	(549470, 131, '2014-02-15 00:17:58.000000', 'consum', 0.0217, 'lps'),
	(549471, 131, '2014-02-15 00:17:59.000000', 'consum', 0.0228, 'lps'),
	(549472, 131, '2014-02-15 00:18:00.000000', 'consum', 0.0222, 'lps'),
	(549473, 131, '2014-02-15 00:18:01.000000', 'consum', 0.0219, 'lps'),
	(549474, 131, '2014-02-15 00:18:02.000000', 'consum', 0.0216, 'lps'),
	(549475, 131, '2014-02-15 00:18:03.000000', 'consum', 0.0216, 'lps'),
	(549476, 131, '2014-02-15 00:18:04.000000', 'consum', 0.0222, 'lps'),
	(549477, 131, '2014-02-15 00:18:05.000000', 'consum', 0.0224, 'lps'),
	(549478, 131, '2014-02-15 00:18:06.000000', 'consum', 0.0216, 'lps'),
	(549479, 131, '2014-02-15 00:18:07.000000', 'consum', 0.0229, 'lps'),
	(549480, 131, '2014-02-15 00:18:08.000000', 'consum', 0.0230, 'lps'),
	(549481, 131, '2014-02-15 00:18:09.000000', 'consum', 0.0225, 'lps'),
	(549482, 131, '2014-02-15 00:18:10.000000', 'consum', 0.0228, 'lps'),
	(549483, 131, '2014-02-15 00:18:11.000000', 'consum', 0.0225, 'lps'),
	(549484, 131, '2014-02-15 00:18:12.000000', 'consum', 0.0233, 'lps'),
	(549485, 131, '2014-02-15 00:18:13.000000', 'consum', 0.0225, 'lps'),
	(549486, 131, '2014-02-15 00:18:14.000000', 'consum', 0.0217, 'lps'),
	(549487, 131, '2014-02-15 00:18:15.000000', 'consum', 0.0227, 'lps'),
	(549488, 131, '2014-02-15 00:18:16.000000', 'consum', 0.0219, 'lps'),
	(549489, 131, '2014-02-15 00:18:17.000000', 'consum', 0.0232, 'lps'),
	(549490, 131, '2014-02-15 00:18:18.000000', 'consum', 0.0210, 'lps'),
	(549491, 131, '2014-02-15 00:18:19.000000', 'consum', 0.0230, 'lps'),
	(549492, 131, '2014-02-15 00:18:20.000000', 'consum', 0.0225, 'lps'),
	(549493, 131, '2014-02-15 00:18:21.000000', 'consum', 0.0227, 'lps'),
	(549494, 131, '2014-02-15 00:18:22.000000', 'consum', 0.0220, 'lps'),
	(549495, 131, '2014-02-15 00:18:23.000000', 'consum', 0.0210, 'lps'),
	(549496, 131, '2014-02-15 00:18:24.000000', 'consum', 0.0237, 'lps'),
	(549497, 131, '2014-02-15 00:18:25.000000', 'consum', 0.0232, 'lps'),
	(549498, 131, '2014-02-15 00:18:26.000000', 'consum', 0.0211, 'lps'),
	(549499, 131, '2014-02-15 00:18:27.000000', 'consum', 0.0233, 'lps'),
	(549500, 131, '2014-02-15 00:18:28.000000', 'consum', 0.0213, 'lps'),
	(549501, 131, '2014-02-15 00:18:29.000000', 'consum', 0.0210, 'lps'),
	(549502, 131, '2014-02-15 00:18:30.000000', 'consum', 0.0231, 'lps'),
	(549503, 131, '2014-02-15 00:18:31.000000', 'consum', 0.0231, 'lps'),
	(549504, 131, '2014-02-15 00:18:32.000000', 'consum', 0.0226, 'lps'),
	(549505, 131, '2014-02-15 00:18:33.000000', 'consum', 0.0227, 'lps'),
	(549506, 131, '2014-02-15 00:18:34.000000', 'consum', 0.0221, 'lps'),
	(549507, 131, '2014-02-15 00:18:35.000000', 'consum', 0.0214, 'lps'),
	(549508, 131, '2014-02-15 00:18:36.000000', 'consum', 0.0224, 'lps'),
	(549509, 131, '2014-02-15 00:18:37.000000', 'consum', 0.0212, 'lps'),
	(549510, 131, '2014-02-15 00:18:38.000000', 'consum', 0.0235, 'lps'),
	(549511, 131, '2014-02-15 00:18:39.000000', 'consum', 0.0216, 'lps'),
	(549512, 131, '2014-02-15 00:18:40.000000', 'consum', 0.0221, 'lps'),
	(549513, 131, '2014-02-15 00:18:41.000000', 'consum', 0.0222, 'lps'),
	(549514, 131, '2014-02-15 00:18:42.000000', 'consum', 0.0236, 'lps'),
	(549515, 131, '2014-02-15 00:18:43.000000', 'consum', 0.0220, 'lps'),
	(549516, 131, '2014-02-15 00:18:44.000000', 'consum', 0.0237, 'lps'),
	(549517, 131, '2014-02-15 00:18:45.000000', 'consum', 0.0233, 'lps'),
	(549518, 131, '2014-02-15 00:18:46.000000', 'consum', 0.0218, 'lps'),
	(549519, 131, '2014-02-15 00:18:47.000000', 'consum', 0.0236, 'lps'),
	(549520, 131, '2014-02-15 00:18:48.000000', 'consum', 0.0233, 'lps'),
	(549521, 131, '2014-02-15 00:18:49.000000', 'consum', 0.0219, 'lps'),
	(549522, 131, '2014-02-15 00:18:50.000000', 'consum', 0.0216, 'lps'),
	(549523, 131, '2014-02-15 00:18:51.000000', 'consum', 0.0211, 'lps'),
	(549524, 131, '2014-02-15 00:18:52.000000', 'consum', 0.0227, 'lps'),
	(549525, 131, '2014-02-15 00:18:53.000000', 'consum', 0.0210, 'lps'),
	(549526, 131, '2014-02-15 00:18:54.000000', 'consum', 0.0214, 'lps'),
	(549527, 131, '2014-02-15 00:18:55.000000', 'consum', 0.0230, 'lps'),
	(549528, 131, '2014-02-15 00:18:56.000000', 'consum', 0.0216, 'lps'),
	(549529, 131, '2014-02-15 00:18:57.000000', 'consum', 0.0236, 'lps'),
	(549530, 131, '2014-02-15 00:18:58.000000', 'consum', 0.0210, 'lps'),
	(549531, 131, '2014-02-15 00:18:59.000000', 'consum', 0.0219, 'lps'),
	(549532, 131, '2014-02-15 00:19:00.000000', 'consum', 0.0224, 'lps'),
	(549533, 131, '2014-02-15 00:19:01.000000', 'consum', 0.0227, 'lps'),
	(549534, 131, '2014-02-15 00:19:02.000000', 'consum', 0.0227, 'lps'),
	(549535, 131, '2014-02-15 00:19:03.000000', 'consum', 0.0215, 'lps'),
	(549536, 131, '2014-02-15 00:19:04.000000', 'consum', 0.0213, 'lps'),
	(549537, 131, '2014-02-15 00:19:05.000000', 'consum', 0.0237, 'lps'),
	(549538, 131, '2014-02-15 00:19:06.000000', 'consum', 0.0227, 'lps'),
	(549539, 131, '2014-02-15 00:19:07.000000', 'consum', 0.0212, 'lps'),
	(549540, 131, '2014-02-15 00:19:08.000000', 'consum', 0.0227, 'lps'),
	(549541, 131, '2014-02-15 00:19:09.000000', 'consum', 0.0235, 'lps'),
	(549542, 131, '2014-02-15 00:19:10.000000', 'consum', 0.0227, 'lps'),
	(549543, 131, '2014-02-15 00:19:11.000000', 'consum', 0.0219, 'lps'),
	(549544, 131, '2014-02-15 00:19:12.000000', 'consum', 0.0234, 'lps'),
	(549545, 131, '2014-02-15 00:19:13.000000', 'consum', 0.0220, 'lps'),
	(549546, 131, '2014-02-15 00:19:14.000000', 'consum', 0.0216, 'lps'),
	(549547, 131, '2014-02-15 00:19:15.000000', 'consum', 0.0211, 'lps'),
	(549548, 131, '2014-02-15 00:19:16.000000', 'consum', 0.0227, 'lps'),
	(549549, 131, '2014-02-15 00:19:17.000000', 'consum', 0.0235, 'lps'),
	(549550, 131, '2014-02-15 00:19:18.000000', 'consum', 0.0227, 'lps'),
	(549551, 131, '2014-02-15 00:19:19.000000', 'consum', 0.0221, 'lps'),
	(549552, 131, '2014-02-15 00:19:20.000000', 'consum', 0.0214, 'lps'),
	(549553, 131, '2014-02-15 00:19:21.000000', 'consum', 0.0226, 'lps'),
	(549554, 131, '2014-02-15 00:19:22.000000', 'consum', 0.0222, 'lps'),
	(549555, 131, '2014-02-15 00:19:23.000000', 'consum', 0.0223, 'lps'),
	(549556, 131, '2014-02-15 00:19:24.000000', 'consum', 0.0211, 'lps'),
	(549557, 131, '2014-02-15 00:19:25.000000', 'consum', 0.0233, 'lps'),
	(549558, 131, '2014-02-15 00:19:26.000000', 'consum', 0.0211, 'lps'),
	(549559, 131, '2014-02-15 00:19:27.000000', 'consum', 0.0228, 'lps'),
	(549560, 131, '2014-02-15 00:19:28.000000', 'consum', 0.0216, 'lps'),
	(549561, 131, '2014-02-15 00:19:29.000000', 'consum', 0.0213, 'lps'),
	(549562, 131, '2014-02-15 00:19:30.000000', 'consum', 0.0234, 'lps'),
	(549563, 131, '2014-02-15 00:19:31.000000', 'consum', 0.0211, 'lps'),
	(549564, 131, '2014-02-15 00:19:32.000000', 'consum', 0.0228, 'lps'),
	(549565, 131, '2014-02-15 00:19:33.000000', 'consum', 0.0213, 'lps'),
	(549566, 131, '2014-02-15 00:19:34.000000', 'consum', 0.0228, 'lps'),
	(549567, 131, '2014-02-15 00:19:35.000000', 'consum', 0.0235, 'lps'),
	(549568, 131, '2014-02-15 00:19:36.000000', 'consum', 0.0224, 'lps'),
	(549569, 131, '2014-02-15 00:19:37.000000', 'consum', 0.0233, 'lps'),
	(549570, 131, '2014-02-15 00:19:38.000000', 'consum', 0.0229, 'lps'),
	(549571, 131, '2014-02-15 00:19:39.000000', 'consum', 0.0235, 'lps'),
	(549572, 131, '2014-02-15 00:19:40.000000', 'consum', 0.0225, 'lps'),
	(549573, 131, '2014-02-15 00:19:41.000000', 'consum', 0.0236, 'lps'),
	(549574, 131, '2014-02-15 00:19:42.000000', 'consum', 0.0211, 'lps'),
	(549575, 131, '2014-02-15 00:19:43.000000', 'consum', 0.0224, 'lps'),
	(549576, 131, '2014-02-15 00:19:44.000000', 'consum', 0.0223, 'lps'),
	(549577, 131, '2014-02-15 00:19:45.000000', 'consum', 0.0230, 'lps'),
	(549578, 131, '2014-02-15 00:19:46.000000', 'consum', 0.0217, 'lps'),
	(549579, 131, '2014-02-15 00:19:47.000000', 'consum', 0.0213, 'lps'),
	(549580, 131, '2014-02-15 00:19:48.000000', 'consum', 0.0233, 'lps'),
	(549581, 131, '2014-02-15 00:19:49.000000', 'consum', 0.0234, 'lps'),
	(549582, 131, '2014-02-15 00:19:50.000000', 'consum', 0.0233, 'lps'),
	(549583, 131, '2014-02-15 00:19:51.000000', 'consum', 0.0224, 'lps'),
	(549584, 131, '2014-02-15 00:19:52.000000', 'consum', 0.0212, 'lps'),
	(549585, 131, '2014-02-15 00:19:53.000000', 'consum', 0.0234, 'lps'),
	(549586, 131, '2014-02-15 00:19:54.000000', 'consum', 0.0213, 'lps'),
	(549587, 131, '2014-02-15 00:19:55.000000', 'consum', 0.0236, 'lps'),
	(549588, 131, '2014-02-15 00:19:56.000000', 'consum', 0.0220, 'lps'),
	(549589, 131, '2014-02-15 00:19:57.000000', 'consum', 0.0210, 'lps'),
	(549590, 131, '2014-02-15 00:19:58.000000', 'consum', 0.0237, 'lps'),
	(549591, 131, '2014-02-15 00:19:59.000000', 'consum', 0.0232, 'lps'),
	(549592, 131, '2014-02-15 00:20:00.000000', 'consum', 0.0212, 'lps'),
	(549593, 131, '2014-02-15 00:20:01.000000', 'consum', 0.0211, 'lps'),
	(549594, 131, '2014-02-15 00:20:02.000000', 'consum', 0.0211, 'lps'),
	(549595, 131, '2014-02-15 00:20:03.000000', 'consum', 0.0212, 'lps'),
	(549596, 131, '2014-02-15 00:20:04.000000', 'consum', 0.0216, 'lps'),
	(549597, 131, '2014-02-15 00:20:05.000000', 'consum', 0.0237, 'lps'),
	(549598, 131, '2014-02-15 00:20:06.000000', 'consum', 0.0214, 'lps'),
	(549599, 131, '2014-02-15 00:20:07.000000', 'consum', 0.0232, 'lps'),
	(549600, 131, '2014-02-15 00:20:08.000000', 'consum', 0.0225, 'lps'),
	(549601, 131, '2014-02-15 00:20:09.000000', 'consum', 0.0221, 'lps'),
	(549602, 131, '2014-02-15 00:20:10.000000', 'consum', 0.0218, 'lps'),
	(549603, 131, '2014-02-15 00:20:11.000000', 'consum', 0.0217, 'lps'),
	(549604, 131, '2014-02-15 00:20:12.000000', 'consum', 0.0224, 'lps'),
	(549605, 131, '2014-02-15 00:20:13.000000', 'consum', 0.0229, 'lps'),
	(549606, 131, '2014-02-15 00:20:14.000000', 'consum', 0.0236, 'lps'),
	(549607, 131, '2014-02-15 00:20:15.000000', 'consum', 0.0227, 'lps'),
	(549608, 131, '2014-02-15 00:20:16.000000', 'consum', 0.0218, 'lps'),
	(549609, 131, '2014-02-15 00:20:17.000000', 'consum', 0.0229, 'lps'),
	(549610, 131, '2014-02-15 00:20:18.000000', 'consum', 0.0226, 'lps'),
	(549611, 131, '2014-02-15 00:20:19.000000', 'consum', 0.0232, 'lps'),
	(549612, 131, '2014-02-15 00:20:20.000000', 'consum', 0.0216, 'lps'),
	(549613, 131, '2014-02-15 00:20:21.000000', 'consum', 0.0233, 'lps'),
	(549614, 131, '2014-02-15 00:20:22.000000', 'consum', 0.0220, 'lps'),
	(549615, 131, '2014-02-15 00:20:23.000000', 'consum', 0.0222, 'lps'),
	(549616, 131, '2014-02-15 00:20:24.000000', 'consum', 0.0214, 'lps'),
	(549617, 131, '2014-02-15 00:20:25.000000', 'consum', 0.0220, 'lps'),
	(549618, 131, '2014-02-15 00:20:26.000000', 'consum', 0.0220, 'lps'),
	(549619, 131, '2014-02-15 00:20:27.000000', 'consum', 0.0231, 'lps'),
	(549620, 131, '2014-02-15 00:20:28.000000', 'consum', 0.0231, 'lps'),
	(549621, 131, '2014-02-15 00:20:29.000000', 'consum', 0.0222, 'lps'),
	(549622, 131, '2014-02-15 00:20:30.000000', 'consum', 0.0237, 'lps'),
	(549623, 131, '2014-02-15 00:20:31.000000', 'consum', 0.0226, 'lps'),
	(549624, 131, '2014-02-15 00:20:32.000000', 'consum', 0.0211, 'lps'),
	(549625, 131, '2014-02-15 00:20:33.000000', 'consum', 0.0222, 'lps'),
	(549626, 131, '2014-02-15 00:20:34.000000', 'consum', 0.0210, 'lps'),
	(549627, 131, '2014-02-15 00:20:35.000000', 'consum', 0.0231, 'lps'),
	(549628, 131, '2014-02-15 00:20:36.000000', 'consum', 0.0232, 'lps'),
	(549629, 131, '2014-02-15 00:20:37.000000', 'consum', 0.0231, 'lps'),
	(549630, 131, '2014-02-15 00:20:38.000000', 'consum', 0.0219, 'lps'),
	(549631, 131, '2014-02-15 00:20:39.000000', 'consum', 0.0223, 'lps'),
	(549632, 131, '2014-02-15 00:20:40.000000', 'consum', 0.0220, 'lps'),
	(549633, 131, '2014-02-15 00:20:41.000000', 'consum', 0.0223, 'lps'),
	(549634, 131, '2014-02-15 00:20:42.000000', 'consum', 0.0217, 'lps'),
	(549635, 131, '2014-02-15 00:20:43.000000', 'consum', 0.0233, 'lps'),
	(549636, 131, '2014-02-15 00:20:44.000000', 'consum', 0.0222, 'lps'),
	(549637, 131, '2014-02-15 00:20:45.000000', 'consum', 0.0229, 'lps'),
	(549638, 131, '2014-02-15 00:20:46.000000', 'consum', 0.0215, 'lps'),
	(549639, 131, '2014-02-15 00:20:47.000000', 'consum', 0.0232, 'lps'),
	(549640, 131, '2014-02-15 00:20:48.000000', 'consum', 0.0220, 'lps'),
	(549641, 131, '2014-02-15 00:20:49.000000', 'consum', 0.0226, 'lps'),
	(549642, 131, '2014-02-15 00:20:50.000000', 'consum', 0.0230, 'lps'),
	(549643, 131, '2014-02-15 00:20:51.000000', 'consum', 0.0236, 'lps'),
	(549644, 131, '2014-02-15 00:20:52.000000', 'consum', 0.0225, 'lps'),
	(549645, 131, '2014-02-15 00:20:53.000000', 'consum', 0.0235, 'lps'),
	(549646, 131, '2014-02-15 00:20:54.000000', 'consum', 0.0234, 'lps'),
	(549647, 131, '2014-02-15 00:20:55.000000', 'consum', 0.0226, 'lps'),
	(549648, 131, '2014-02-15 00:20:56.000000', 'consum', 0.0222, 'lps'),
	(549649, 131, '2014-02-15 00:20:57.000000', 'consum', 0.0220, 'lps'),
	(549650, 131, '2014-02-15 00:20:58.000000', 'consum', 0.0225, 'lps'),
	(549651, 131, '2014-02-15 00:20:59.000000', 'consum', 0.0229, 'lps'),
	(549652, 131, '2014-02-15 00:21:00.000000', 'consum', 0.0233, 'lps'),
	(549653, 131, '2014-02-15 00:21:01.000000', 'consum', 0.0211, 'lps'),
	(549654, 131, '2014-02-15 00:21:02.000000', 'consum', 0.0231, 'lps'),
	(549655, 131, '2014-02-15 00:21:03.000000', 'consum', 0.0227, 'lps'),
	(549656, 131, '2014-02-15 00:21:04.000000', 'consum', 0.0233, 'lps'),
	(549657, 131, '2014-02-15 00:21:05.000000', 'consum', 0.0219, 'lps'),
	(549658, 131, '2014-02-15 00:21:06.000000', 'consum', 0.0215, 'lps'),
	(549659, 131, '2014-02-15 00:21:07.000000', 'consum', 0.0237, 'lps'),
	(549660, 131, '2014-02-15 00:21:08.000000', 'consum', 0.0218, 'lps'),
	(549661, 131, '2014-02-15 00:21:09.000000', 'consum', 0.0226, 'lps'),
	(549662, 131, '2014-02-15 00:21:10.000000', 'consum', 0.0211, 'lps'),
	(549663, 131, '2014-02-15 00:21:11.000000', 'consum', 0.0222, 'lps'),
	(549664, 131, '2014-02-15 00:21:12.000000', 'consum', 0.0212, 'lps'),
	(549665, 131, '2014-02-15 00:21:13.000000', 'consum', 0.0212, 'lps'),
	(549666, 131, '2014-02-15 00:21:14.000000', 'consum', 0.0213, 'lps'),
	(549667, 131, '2014-02-15 00:21:15.000000', 'consum', 0.0222, 'lps'),
	(549668, 131, '2014-02-15 00:21:16.000000', 'consum', 0.0231, 'lps'),
	(549669, 131, '2014-02-15 00:21:17.000000', 'consum', 0.0225, 'lps'),
	(549670, 131, '2014-02-15 00:21:18.000000', 'consum', 0.0224, 'lps'),
	(549671, 131, '2014-02-15 00:21:19.000000', 'consum', 0.0234, 'lps'),
	(549672, 131, '2014-02-15 00:21:20.000000', 'consum', 0.0234, 'lps'),
	(549673, 131, '2014-02-15 00:21:21.000000', 'consum', 0.0228, 'lps'),
	(549674, 131, '2014-02-15 00:21:22.000000', 'consum', 0.0229, 'lps'),
	(549675, 131, '2014-02-15 00:21:23.000000', 'consum', 0.0222, 'lps'),
	(549676, 131, '2014-02-15 00:21:24.000000', 'consum', 0.0216, 'lps'),
	(549677, 131, '2014-02-15 00:21:25.000000', 'consum', 0.0232, 'lps'),
	(549678, 131, '2014-02-15 00:21:26.000000', 'consum', 0.0219, 'lps'),
	(549679, 131, '2014-02-15 00:21:27.000000', 'consum', 0.0217, 'lps'),
	(549680, 131, '2014-02-15 00:21:28.000000', 'consum', 0.0219, 'lps'),
	(549681, 131, '2014-02-15 00:21:29.000000', 'consum', 0.0233, 'lps'),
	(549682, 131, '2014-02-15 00:21:30.000000', 'consum', 0.0216, 'lps'),
	(549683, 131, '2014-02-15 00:21:31.000000', 'consum', 0.0229, 'lps'),
	(549684, 131, '2014-02-15 00:21:32.000000', 'consum', 0.0230, 'lps'),
	(549685, 131, '2014-02-15 00:21:33.000000', 'consum', 0.0228, 'lps'),
	(549686, 131, '2014-02-15 00:21:34.000000', 'consum', 0.0210, 'lps'),
	(549687, 131, '2014-02-15 00:21:35.000000', 'consum', 0.0211, 'lps'),
	(549688, 131, '2014-02-15 00:21:36.000000', 'consum', 0.0217, 'lps'),
	(549689, 131, '2014-02-15 00:21:37.000000', 'consum', 0.0215, 'lps'),
	(549690, 131, '2014-02-15 00:21:38.000000', 'consum', 0.0214, 'lps'),
	(549691, 131, '2014-02-15 00:21:39.000000', 'consum', 0.0214, 'lps'),
	(549692, 131, '2014-02-15 00:21:40.000000', 'consum', 0.0218, 'lps'),
	(549693, 131, '2014-02-15 00:21:41.000000', 'consum', 0.0213, 'lps'),
	(549694, 131, '2014-02-15 00:21:42.000000', 'consum', 0.0227, 'lps'),
	(549695, 131, '2014-02-15 00:21:43.000000', 'consum', 0.0233, 'lps'),
	(549696, 131, '2014-02-15 00:21:44.000000', 'consum', 0.0217, 'lps'),
	(549697, 131, '2014-02-15 00:21:45.000000', 'consum', 0.0232, 'lps'),
	(549698, 131, '2014-02-15 00:21:46.000000', 'consum', 0.0215, 'lps'),
	(549699, 131, '2014-02-15 00:21:47.000000', 'consum', 0.0225, 'lps'),
	(549700, 131, '2014-02-15 00:21:48.000000', 'consum', 0.0216, 'lps'),
	(549701, 131, '2014-02-15 00:21:49.000000', 'consum', 0.0222, 'lps'),
	(549702, 131, '2014-02-15 00:21:50.000000', 'consum', 0.0227, 'lps'),
	(549703, 131, '2014-02-15 00:21:51.000000', 'consum', 0.0232, 'lps'),
	(549704, 131, '2014-02-15 00:21:52.000000', 'consum', 0.0211, 'lps'),
	(549705, 131, '2014-02-15 00:21:53.000000', 'consum', 0.0234, 'lps'),
	(549706, 131, '2014-02-15 00:21:54.000000', 'consum', 0.0214, 'lps'),
	(549707, 131, '2014-02-15 00:21:55.000000', 'consum', 0.0216, 'lps'),
	(549708, 131, '2014-02-15 00:21:56.000000', 'consum', 0.0229, 'lps'),
	(549709, 131, '2014-02-15 00:21:57.000000', 'consum', 0.0232, 'lps'),
	(549710, 131, '2014-02-15 00:21:58.000000', 'consum', 0.0235, 'lps'),
	(549711, 131, '2014-02-15 00:21:59.000000', 'consum', 0.0212, 'lps'),
	(549712, 131, '2014-02-15 00:22:00.000000', 'consum', 0.0229, 'lps'),
	(549713, 131, '2014-02-15 00:22:01.000000', 'consum', 0.0218, 'lps'),
	(549714, 131, '2014-02-15 00:22:02.000000', 'consum', 0.0220, 'lps'),
	(549715, 131, '2014-02-15 00:22:03.000000', 'consum', 0.0236, 'lps'),
	(549716, 131, '2014-02-15 00:22:04.000000', 'consum', 0.0227, 'lps'),
	(549717, 131, '2014-02-15 00:22:05.000000', 'consum', 0.0219, 'lps'),
	(549718, 131, '2014-02-15 00:22:06.000000', 'consum', 0.0230, 'lps'),
	(549719, 131, '2014-02-15 00:22:07.000000', 'consum', 0.0230, 'lps'),
	(549720, 131, '2014-02-15 00:22:08.000000', 'consum', 0.0223, 'lps'),
	(549721, 131, '2014-02-15 00:22:09.000000', 'consum', 0.0215, 'lps'),
	(549722, 131, '2014-02-15 00:22:10.000000', 'consum', 0.0226, 'lps'),
	(549723, 131, '2014-02-15 00:22:11.000000', 'consum', 0.0219, 'lps'),
	(549724, 131, '2014-02-15 00:22:12.000000', 'consum', 0.0233, 'lps'),
	(549725, 131, '2014-02-15 00:22:13.000000', 'consum', 0.0216, 'lps'),
	(549726, 131, '2014-02-15 00:22:14.000000', 'consum', 0.0225, 'lps'),
	(549727, 131, '2014-02-15 00:22:15.000000', 'consum', 0.0215, 'lps'),
	(549728, 131, '2014-02-15 00:22:16.000000', 'consum', 0.0219, 'lps'),
	(549729, 131, '2014-02-15 00:22:17.000000', 'consum', 0.0237, 'lps'),
	(549730, 131, '2014-02-15 00:22:18.000000', 'consum', 0.0237, 'lps'),
	(549731, 131, '2014-02-15 00:22:19.000000', 'consum', 0.0210, 'lps'),
	(549732, 131, '2014-02-15 00:22:20.000000', 'consum', 0.0210, 'lps'),
	(549733, 131, '2014-02-15 00:22:21.000000', 'consum', 0.0214, 'lps'),
	(549734, 131, '2014-02-15 00:22:22.000000', 'consum', 0.0228, 'lps'),
	(549735, 131, '2014-02-15 00:22:23.000000', 'consum', 0.0231, 'lps'),
	(549736, 131, '2014-02-15 00:22:24.000000', 'consum', 0.0236, 'lps'),
	(549737, 131, '2014-02-15 00:22:25.000000', 'consum', 0.0221, 'lps'),
	(549738, 131, '2014-02-15 00:22:26.000000', 'consum', 0.0214, 'lps'),
	(549739, 131, '2014-02-15 00:22:27.000000', 'consum', 0.0226, 'lps'),
	(549740, 131, '2014-02-15 00:22:28.000000', 'consum', 0.0225, 'lps'),
	(549741, 131, '2014-02-15 00:22:29.000000', 'consum', 0.0235, 'lps'),
	(549742, 131, '2014-02-15 00:22:30.000000', 'consum', 0.0234, 'lps'),
	(549743, 131, '2014-02-15 00:22:31.000000', 'consum', 0.0228, 'lps'),
	(549744, 131, '2014-02-15 00:22:32.000000', 'consum', 0.0228, 'lps'),
	(549745, 131, '2014-02-15 00:22:33.000000', 'consum', 0.0219, 'lps'),
	(549746, 131, '2014-02-15 00:22:34.000000', 'consum', 0.0228, 'lps'),
	(549747, 131, '2014-02-15 00:22:35.000000', 'consum', 0.0220, 'lps'),
	(549748, 131, '2014-02-15 00:22:36.000000', 'consum', 0.0232, 'lps'),
	(549749, 131, '2014-02-15 00:22:37.000000', 'consum', 0.0237, 'lps'),
	(549750, 131, '2014-02-15 00:22:38.000000', 'consum', 0.0223, 'lps'),
	(549751, 131, '2014-02-15 00:22:39.000000', 'consum', 0.0222, 'lps'),
	(549752, 131, '2014-02-15 00:22:40.000000', 'consum', 0.0233, 'lps'),
	(549753, 131, '2014-02-15 00:22:41.000000', 'consum', 0.0233, 'lps'),
	(549754, 131, '2014-02-15 00:22:42.000000', 'consum', 0.0228, 'lps'),
	(549755, 131, '2014-02-15 00:22:43.000000', 'consum', 0.0233, 'lps'),
	(549756, 131, '2014-02-15 00:22:44.000000', 'consum', 0.0216, 'lps'),
	(549757, 131, '2014-02-15 00:22:45.000000', 'consum', 0.0228, 'lps'),
	(549758, 131, '2014-02-15 00:22:46.000000', 'consum', 0.0227, 'lps'),
	(549759, 131, '2014-02-15 00:22:47.000000', 'consum', 0.0212, 'lps'),
	(549760, 131, '2014-02-15 00:22:48.000000', 'consum', 0.0225, 'lps'),
	(549761, 131, '2014-02-15 00:22:49.000000', 'consum', 0.0224, 'lps'),
	(549762, 131, '2014-02-15 00:22:50.000000', 'consum', 0.0237, 'lps'),
	(549763, 131, '2014-02-15 00:22:51.000000', 'consum', 0.0218, 'lps'),
	(549764, 131, '2014-02-15 00:22:52.000000', 'consum', 0.0225, 'lps'),
	(549765, 131, '2014-02-15 00:22:53.000000', 'consum', 0.0236, 'lps'),
	(549766, 131, '2014-02-15 00:22:54.000000', 'consum', 0.0236, 'lps'),
	(549767, 131, '2014-02-15 00:22:55.000000', 'consum', 0.0236, 'lps'),
	(549768, 131, '2014-02-15 00:22:56.000000', 'consum', 0.0235, 'lps'),
	(549769, 131, '2014-02-15 00:22:57.000000', 'consum', 0.0229, 'lps'),
	(549770, 131, '2014-02-15 00:22:58.000000', 'consum', 0.0232, 'lps'),
	(549771, 131, '2014-02-15 00:22:59.000000', 'consum', 0.0237, 'lps'),
	(549772, 131, '2014-02-15 00:23:00.000000', 'consum', 0.0220, 'lps'),
	(549773, 131, '2014-02-15 00:23:01.000000', 'consum', 0.0236, 'lps'),
	(549774, 131, '2014-02-15 00:23:02.000000', 'consum', 0.0228, 'lps'),
	(549775, 131, '2014-02-15 00:23:03.000000', 'consum', 0.0222, 'lps'),
	(549776, 131, '2014-02-15 00:23:04.000000', 'consum', 0.0218, 'lps'),
	(549777, 131, '2014-02-15 00:23:05.000000', 'consum', 0.0212, 'lps'),
	(549778, 131, '2014-02-15 00:23:06.000000', 'consum', 0.0224, 'lps'),
	(549779, 131, '2014-02-15 00:23:07.000000', 'consum', 0.0218, 'lps'),
	(549780, 131, '2014-02-15 00:23:08.000000', 'consum', 0.0211, 'lps'),
	(549781, 131, '2014-02-15 00:23:09.000000', 'consum', 0.0218, 'lps'),
	(549782, 131, '2014-02-15 00:23:10.000000', 'consum', 0.0218, 'lps'),
	(549783, 131, '2014-02-15 00:23:11.000000', 'consum', 0.0229, 'lps'),
	(549784, 131, '2014-02-15 00:23:12.000000', 'consum', 0.0225, 'lps'),
	(549785, 131, '2014-02-15 00:23:13.000000', 'consum', 0.0230, 'lps'),
	(549786, 131, '2014-02-15 00:23:14.000000', 'consum', 0.0210, 'lps'),
	(549787, 131, '2014-02-15 00:23:15.000000', 'consum', 0.0231, 'lps'),
	(549788, 131, '2014-02-15 00:23:16.000000', 'consum', 0.0234, 'lps'),
	(549789, 131, '2014-02-15 00:23:17.000000', 'consum', 0.0211, 'lps'),
	(549790, 131, '2014-02-15 00:23:18.000000', 'consum', 0.0227, 'lps'),
	(549791, 131, '2014-02-15 00:23:19.000000', 'consum', 0.0210, 'lps'),
	(549792, 131, '2014-02-15 00:23:20.000000', 'consum', 0.0213, 'lps'),
	(549793, 131, '2014-02-15 00:23:21.000000', 'consum', 0.0226, 'lps'),
	(549794, 131, '2014-02-15 00:23:22.000000', 'consum', 0.0225, 'lps'),
	(549795, 131, '2014-02-15 00:23:23.000000', 'consum', 0.0212, 'lps'),
	(549796, 131, '2014-02-15 00:23:24.000000', 'consum', 0.0229, 'lps'),
	(549797, 131, '2014-02-15 00:23:25.000000', 'consum', 0.0214, 'lps'),
	(549798, 131, '2014-02-15 00:23:26.000000', 'consum', 0.0233, 'lps'),
	(549799, 131, '2014-02-15 00:23:27.000000', 'consum', 0.0228, 'lps'),
	(549800, 131, '2014-02-15 00:23:28.000000', 'consum', 0.0230, 'lps'),
	(549801, 131, '2014-02-15 00:23:29.000000', 'consum', 0.0228, 'lps'),
	(549802, 131, '2014-02-15 00:23:30.000000', 'consum', 0.0212, 'lps'),
	(549803, 131, '2014-02-15 00:23:31.000000', 'consum', 0.0222, 'lps'),
	(549804, 131, '2014-02-15 00:23:32.000000', 'consum', 0.0236, 'lps'),
	(549805, 131, '2014-02-15 00:23:33.000000', 'consum', 0.0222, 'lps'),
	(549806, 131, '2014-02-15 00:23:34.000000', 'consum', 0.0222, 'lps'),
	(549807, 131, '2014-02-15 00:23:35.000000', 'consum', 0.0234, 'lps'),
	(549808, 131, '2014-02-15 00:23:36.000000', 'consum', 0.0237, 'lps'),
	(549809, 131, '2014-02-15 00:23:37.000000', 'consum', 0.0217, 'lps'),
	(549810, 131, '2014-02-15 00:23:38.000000', 'consum', 0.0220, 'lps'),
	(549811, 131, '2014-02-15 00:23:39.000000', 'consum', 0.0212, 'lps'),
	(549812, 131, '2014-02-15 00:23:40.000000', 'consum', 0.0220, 'lps'),
	(549813, 131, '2014-02-15 00:23:41.000000', 'consum', 0.0224, 'lps'),
	(549814, 131, '2014-02-15 00:23:42.000000', 'consum', 0.0223, 'lps'),
	(549815, 131, '2014-02-15 00:23:43.000000', 'consum', 0.0234, 'lps'),
	(549816, 131, '2014-02-15 00:23:44.000000', 'consum', 0.0236, 'lps'),
	(549817, 131, '2014-02-15 00:23:45.000000', 'consum', 0.0213, 'lps'),
	(549818, 131, '2014-02-15 00:23:46.000000', 'consum', 0.0231, 'lps'),
	(549819, 131, '2014-02-15 00:23:47.000000', 'consum', 0.0222, 'lps'),
	(549820, 131, '2014-02-15 00:23:48.000000', 'consum', 0.0235, 'lps'),
	(549821, 131, '2014-02-15 00:23:49.000000', 'consum', 0.0214, 'lps'),
	(549822, 131, '2014-02-15 00:23:50.000000', 'consum', 0.0213, 'lps'),
	(549823, 131, '2014-02-15 00:23:51.000000', 'consum', 0.0213, 'lps'),
	(549824, 131, '2014-02-15 00:23:52.000000', 'consum', 0.0219, 'lps'),
	(549825, 131, '2014-02-15 00:23:53.000000', 'consum', 0.0216, 'lps'),
	(549826, 131, '2014-02-15 00:23:54.000000', 'consum', 0.0216, 'lps'),
	(549827, 131, '2014-02-15 00:23:55.000000', 'consum', 0.0220, 'lps'),
	(549828, 131, '2014-02-15 00:23:56.000000', 'consum', 0.0216, 'lps'),
	(549829, 131, '2014-02-15 00:23:57.000000', 'consum', 0.0237, 'lps'),
	(549830, 131, '2014-02-15 00:23:58.000000', 'consum', 0.0217, 'lps'),
	(549831, 131, '2014-02-15 00:23:59.000000', 'consum', 0.0221, 'lps'),
	(549832, 131, '2014-02-15 00:24:00.000000', 'consum', 0.0217, 'lps'),
	(549833, 131, '2014-02-15 00:24:01.000000', 'consum', 0.0210, 'lps'),
	(549834, 131, '2014-02-15 00:24:02.000000', 'consum', 0.0220, 'lps'),
	(549835, 131, '2014-02-15 00:24:03.000000', 'consum', 0.0230, 'lps'),
	(549836, 131, '2014-02-15 00:24:04.000000', 'consum', 0.0224, 'lps'),
	(549837, 131, '2014-02-15 00:24:05.000000', 'consum', 0.0220, 'lps'),
	(549838, 131, '2014-02-15 00:24:06.000000', 'consum', 0.0220, 'lps'),
	(549839, 131, '2014-02-15 00:24:07.000000', 'consum', 0.0231, 'lps'),
	(549840, 131, '2014-02-15 00:24:08.000000', 'consum', 0.0228, 'lps'),
	(549841, 131, '2014-02-15 00:24:09.000000', 'consum', 0.0212, 'lps'),
	(549842, 131, '2014-02-15 00:24:10.000000', 'consum', 0.0221, 'lps'),
	(549843, 131, '2014-02-15 00:24:11.000000', 'consum', 0.0231, 'lps'),
	(549844, 131, '2014-02-15 00:24:12.000000', 'consum', 0.0225, 'lps'),
	(549845, 131, '2014-02-15 00:24:13.000000', 'consum', 0.0224, 'lps'),
	(549846, 131, '2014-02-15 00:24:14.000000', 'consum', 0.0237, 'lps'),
	(549847, 131, '2014-02-15 00:24:15.000000', 'consum', 0.0217, 'lps'),
	(549848, 131, '2014-02-15 00:24:16.000000', 'consum', 0.0219, 'lps'),
	(549849, 131, '2014-02-15 00:24:17.000000', 'consum', 0.0210, 'lps'),
	(549850, 131, '2014-02-15 00:24:18.000000', 'consum', 0.0237, 'lps'),
	(549851, 131, '2014-02-15 00:24:19.000000', 'consum', 0.0232, 'lps'),
	(549852, 131, '2014-02-15 00:24:20.000000', 'consum', 0.0215, 'lps'),
	(549853, 131, '2014-02-15 00:24:21.000000', 'consum', 0.0225, 'lps'),
	(549854, 131, '2014-02-15 00:24:22.000000', 'consum', 0.0215, 'lps'),
	(549855, 131, '2014-02-15 00:24:23.000000', 'consum', 0.0217, 'lps'),
	(549856, 131, '2014-02-15 00:24:24.000000', 'consum', 0.0232, 'lps'),
	(549857, 131, '2014-02-15 00:24:25.000000', 'consum', 0.0217, 'lps'),
	(549858, 131, '2014-02-15 00:24:26.000000', 'consum', 0.0234, 'lps'),
	(549859, 131, '2014-02-15 00:24:27.000000', 'consum', 0.0224, 'lps'),
	(549860, 131, '2014-02-15 00:24:28.000000', 'consum', 0.0210, 'lps'),
	(549861, 131, '2014-02-15 00:24:29.000000', 'consum', 0.0225, 'lps'),
	(549862, 131, '2014-02-15 00:24:30.000000', 'consum', 0.0228, 'lps'),
	(549863, 131, '2014-02-15 00:24:31.000000', 'consum', 0.0226, 'lps'),
	(549864, 131, '2014-02-15 00:24:32.000000', 'consum', 0.0210, 'lps'),
	(549865, 131, '2014-02-15 00:24:33.000000', 'consum', 0.0218, 'lps'),
	(549866, 131, '2014-02-15 00:24:34.000000', 'consum', 0.0225, 'lps'),
	(549867, 131, '2014-02-15 00:24:35.000000', 'consum', 0.0232, 'lps'),
	(549868, 131, '2014-02-15 00:24:36.000000', 'consum', 0.0218, 'lps'),
	(549869, 131, '2014-02-15 00:24:37.000000', 'consum', 0.0213, 'lps'),
	(549870, 131, '2014-02-15 00:24:38.000000', 'consum', 0.0231, 'lps'),
	(549871, 131, '2014-02-15 00:24:39.000000', 'consum', 0.0220, 'lps'),
	(549872, 131, '2014-02-15 00:24:40.000000', 'consum', 0.0227, 'lps'),
	(549873, 131, '2014-02-15 00:24:41.000000', 'consum', 0.0211, 'lps'),
	(549874, 131, '2014-02-15 00:24:42.000000', 'consum', 0.0220, 'lps'),
	(549875, 131, '2014-02-15 00:24:43.000000', 'consum', 0.0230, 'lps'),
	(549876, 131, '2014-02-15 00:24:44.000000', 'consum', 0.0224, 'lps'),
	(549877, 131, '2014-02-15 00:24:45.000000', 'consum', 0.0220, 'lps'),
	(549878, 131, '2014-02-15 00:24:46.000000', 'consum', 0.0219, 'lps'),
	(549879, 131, '2014-02-15 00:24:47.000000', 'consum', 0.0227, 'lps'),
	(549880, 131, '2014-02-15 00:24:48.000000', 'consum', 0.0212, 'lps'),
	(549881, 131, '2014-02-15 00:24:49.000000', 'consum', 0.0225, 'lps'),
	(549882, 131, '2014-02-15 00:24:50.000000', 'consum', 0.0225, 'lps'),
	(549883, 131, '2014-02-15 00:24:51.000000', 'consum', 0.0213, 'lps'),
	(549884, 131, '2014-02-15 00:24:52.000000', 'consum', 0.0210, 'lps'),
	(549885, 131, '2014-02-15 00:24:53.000000', 'consum', 0.0226, 'lps'),
	(549886, 131, '2014-02-15 00:24:54.000000', 'consum', 0.0234, 'lps'),
	(549887, 131, '2014-02-15 00:24:55.000000', 'consum', 0.0230, 'lps'),
	(549888, 131, '2014-02-15 00:24:56.000000', 'consum', 0.0235, 'lps'),
	(549889, 131, '2014-02-15 00:24:57.000000', 'consum', 0.0220, 'lps'),
	(549890, 131, '2014-02-15 00:24:58.000000', 'consum', 0.0216, 'lps'),
	(549891, 131, '2014-02-15 00:24:59.000000', 'consum', 0.0236, 'lps'),
	(549892, 131, '2014-02-15 00:25:00.000000', 'consum', 0.0212, 'lps'),
	(549893, 131, '2014-02-15 00:25:01.000000', 'consum', 0.0227, 'lps'),
	(549894, 131, '2014-02-15 00:25:02.000000', 'consum', 0.0233, 'lps'),
	(549895, 131, '2014-02-15 00:25:03.000000', 'consum', 0.0219, 'lps'),
	(549896, 131, '2014-02-15 00:25:04.000000', 'consum', 0.0213, 'lps'),
	(549897, 131, '2014-02-15 00:25:05.000000', 'consum', 0.0227, 'lps'),
	(549898, 131, '2014-02-15 00:25:06.000000', 'consum', 0.0233, 'lps'),
	(549899, 131, '2014-02-15 00:25:07.000000', 'consum', 0.0215, 'lps'),
	(549900, 131, '2014-02-15 00:25:08.000000', 'consum', 0.0223, 'lps'),
	(549901, 131, '2014-02-15 00:25:09.000000', 'consum', 0.0233, 'lps'),
	(549902, 131, '2014-02-15 00:25:10.000000', 'consum', 0.0230, 'lps'),
	(549903, 131, '2014-02-15 00:25:11.000000', 'consum', 0.0212, 'lps'),
	(549904, 131, '2014-02-15 00:25:12.000000', 'consum', 0.0217, 'lps'),
	(549905, 131, '2014-02-15 00:25:13.000000', 'consum', 0.0214, 'lps'),
	(549906, 131, '2014-02-15 00:25:14.000000', 'consum', 0.0236, 'lps'),
	(549907, 131, '2014-02-15 00:25:15.000000', 'consum', 0.0215, 'lps'),
	(549908, 131, '2014-02-15 00:25:16.000000', 'consum', 0.0216, 'lps'),
	(549909, 131, '2014-02-15 00:25:17.000000', 'consum', 0.0224, 'lps'),
	(549910, 131, '2014-02-15 00:25:18.000000', 'consum', 0.0236, 'lps'),
	(549911, 131, '2014-02-15 00:25:19.000000', 'consum', 0.0214, 'lps'),
	(549912, 131, '2014-02-15 00:25:20.000000', 'consum', 0.0237, 'lps'),
	(549913, 131, '2014-02-15 00:25:21.000000', 'consum', 0.0221, 'lps'),
	(549914, 131, '2014-02-15 00:25:22.000000', 'consum', 0.0215, 'lps'),
	(549915, 131, '2014-02-15 00:25:23.000000', 'consum', 0.0227, 'lps'),
	(549916, 131, '2014-02-15 00:25:24.000000', 'consum', 0.0225, 'lps'),
	(549917, 131, '2014-02-15 00:25:25.000000', 'consum', 0.0237, 'lps'),
	(549918, 131, '2014-02-15 00:25:26.000000', 'consum', 0.0215, 'lps'),
	(549919, 131, '2014-02-15 00:25:27.000000', 'consum', 0.0212, 'lps'),
	(549920, 131, '2014-02-15 00:25:28.000000', 'consum', 0.0231, 'lps'),
	(549921, 131, '2014-02-15 00:25:29.000000', 'consum', 0.0226, 'lps'),
	(549922, 131, '2014-02-15 00:25:30.000000', 'consum', 0.0229, 'lps'),
	(549923, 131, '2014-02-15 00:25:31.000000', 'consum', 0.0231, 'lps'),
	(549924, 131, '2014-02-15 00:25:32.000000', 'consum', 0.0227, 'lps'),
	(549925, 131, '2014-02-15 00:25:33.000000', 'consum', 0.0234, 'lps'),
	(549926, 131, '2014-02-15 00:25:34.000000', 'consum', 0.0225, 'lps'),
	(549927, 131, '2014-02-15 00:25:35.000000', 'consum', 0.0214, 'lps'),
	(549928, 131, '2014-02-15 00:25:36.000000', 'consum', 0.0214, 'lps'),
	(549929, 131, '2014-02-15 00:25:37.000000', 'consum', 0.0218, 'lps'),
	(549930, 131, '2014-02-15 00:25:38.000000', 'consum', 0.0212, 'lps'),
	(549931, 131, '2014-02-15 00:25:39.000000', 'consum', 0.0222, 'lps'),
	(549932, 131, '2014-02-15 00:25:40.000000', 'consum', 0.0236, 'lps'),
	(549933, 131, '2014-02-15 00:25:41.000000', 'consum', 0.0222, 'lps'),
	(549934, 131, '2014-02-15 00:25:42.000000', 'consum', 0.0219, 'lps'),
	(549935, 131, '2014-02-15 00:25:43.000000', 'consum', 0.0220, 'lps'),
	(549936, 131, '2014-02-15 00:25:44.000000', 'consum', 0.0234, 'lps'),
	(549937, 131, '2014-02-15 00:25:45.000000', 'consum', 0.0217, 'lps'),
	(549938, 131, '2014-02-15 00:25:46.000000', 'consum', 0.0230, 'lps'),
	(549939, 131, '2014-02-15 00:25:47.000000', 'consum', 0.0231, 'lps'),
	(549940, 131, '2014-02-15 00:25:48.000000', 'consum', 0.0229, 'lps'),
	(549941, 131, '2014-02-15 00:25:49.000000', 'consum', 0.0212, 'lps'),
	(549942, 131, '2014-02-15 00:25:50.000000', 'consum', 0.0223, 'lps'),
	(549943, 131, '2014-02-15 00:25:51.000000', 'consum', 0.0211, 'lps'),
	(549944, 131, '2014-02-15 00:25:52.000000', 'consum', 0.0233, 'lps'),
	(549945, 131, '2014-02-15 00:25:53.000000', 'consum', 0.0212, 'lps'),
	(549946, 131, '2014-02-15 00:25:54.000000', 'consum', 0.0233, 'lps'),
	(549947, 131, '2014-02-15 00:25:55.000000', 'consum', 0.0236, 'lps'),
	(549948, 131, '2014-02-15 00:25:56.000000', 'consum', 0.0215, 'lps'),
	(549949, 131, '2014-02-15 00:25:57.000000', 'consum', 0.0212, 'lps'),
	(549950, 131, '2014-02-15 00:25:58.000000', 'consum', 0.0236, 'lps'),
	(549951, 131, '2014-02-15 00:25:59.000000', 'consum', 0.0224, 'lps'),
	(549952, 131, '2014-02-15 00:26:00.000000', 'consum', 0.0228, 'lps'),
	(549953, 131, '2014-02-15 00:26:01.000000', 'consum', 0.0230, 'lps'),
	(549954, 131, '2014-02-15 00:26:02.000000', 'consum', 0.0229, 'lps'),
	(549955, 131, '2014-02-15 00:26:03.000000', 'consum', 0.0220, 'lps'),
	(549956, 131, '2014-02-15 00:26:04.000000', 'consum', 0.0229, 'lps'),
	(549957, 131, '2014-02-15 00:26:05.000000', 'consum', 0.0222, 'lps'),
	(549958, 131, '2014-02-15 00:26:06.000000', 'consum', 0.0210, 'lps'),
	(549959, 131, '2014-02-15 00:26:07.000000', 'consum', 0.0233, 'lps'),
	(549960, 131, '2014-02-15 00:26:08.000000', 'consum', 0.0212, 'lps'),
	(549961, 131, '2014-02-15 00:26:09.000000', 'consum', 0.0235, 'lps'),
	(549962, 131, '2014-02-15 00:26:10.000000', 'consum', 0.0217, 'lps'),
	(549963, 131, '2014-02-15 00:26:11.000000', 'consum', 0.0228, 'lps'),
	(549964, 131, '2014-02-15 00:26:12.000000', 'consum', 0.0223, 'lps'),
	(549965, 131, '2014-02-15 00:26:13.000000', 'consum', 0.0223, 'lps'),
	(549966, 131, '2014-02-15 00:26:14.000000', 'consum', 0.0236, 'lps'),
	(549967, 131, '2014-02-15 00:26:15.000000', 'consum', 0.0219, 'lps'),
	(549968, 131, '2014-02-15 00:26:16.000000', 'consum', 0.0230, 'lps'),
	(549969, 131, '2014-02-15 00:26:17.000000', 'consum', 0.0231, 'lps'),
	(549970, 131, '2014-02-15 00:26:18.000000', 'consum', 0.0226, 'lps'),
	(549971, 131, '2014-02-15 00:26:19.000000', 'consum', 0.0227, 'lps'),
	(549972, 131, '2014-02-15 00:26:20.000000', 'consum', 0.0222, 'lps'),
	(549973, 131, '2014-02-15 00:26:21.000000', 'consum', 0.0216, 'lps'),
	(549974, 131, '2014-02-15 00:26:22.000000', 'consum', 0.0235, 'lps'),
	(549975, 131, '2014-02-15 00:26:23.000000', 'consum', 0.0231, 'lps'),
	(549976, 131, '2014-02-15 00:26:24.000000', 'consum', 0.0214, 'lps'),
	(549977, 131, '2014-02-15 00:26:25.000000', 'consum', 0.0223, 'lps'),
	(549978, 131, '2014-02-15 00:26:26.000000', 'consum', 0.0234, 'lps'),
	(549979, 131, '2014-02-15 00:26:27.000000', 'consum', 0.0237, 'lps'),
	(549980, 131, '2014-02-15 00:26:28.000000', 'consum', 0.0216, 'lps'),
	(549981, 131, '2014-02-15 00:26:29.000000', 'consum', 0.0216, 'lps'),
	(549982, 131, '2014-02-15 00:26:30.000000', 'consum', 0.0223, 'lps'),
	(549983, 131, '2014-02-15 00:26:31.000000', 'consum', 0.0231, 'lps'),
	(549984, 131, '2014-02-15 00:26:32.000000', 'consum', 0.0221, 'lps'),
	(549985, 131, '2014-02-15 00:26:33.000000', 'consum', 0.0228, 'lps'),
	(549986, 131, '2014-02-15 00:26:34.000000', 'consum', 0.0212, 'lps'),
	(549987, 131, '2014-02-15 00:26:35.000000', 'consum', 0.0222, 'lps'),
	(549988, 131, '2014-02-15 00:26:36.000000', 'consum', 0.0236, 'lps'),
	(549989, 131, '2014-02-15 00:26:37.000000', 'consum', 0.0220, 'lps'),
	(549990, 131, '2014-02-15 00:26:38.000000', 'consum', 0.0211, 'lps'),
	(549991, 131, '2014-02-15 00:26:39.000000', 'consum', 0.0215, 'lps'),
	(549992, 131, '2014-02-15 00:26:40.000000', 'consum', 0.0232, 'lps'),
	(549993, 131, '2014-02-15 00:26:41.000000', 'consum', 0.0220, 'lps'),
	(549994, 131, '2014-02-15 00:26:42.000000', 'consum', 0.0222, 'lps'),
	(549995, 131, '2014-02-15 00:26:43.000000', 'consum', 0.0213, 'lps'),
	(549996, 131, '2014-02-15 00:26:44.000000', 'consum', 0.0218, 'lps'),
	(549997, 131, '2014-02-15 00:26:45.000000', 'consum', 0.0212, 'lps'),
	(549998, 131, '2014-02-15 00:26:46.000000', 'consum', 0.0226, 'lps'),
	(549999, 131, '2014-02-15 00:26:47.000000', 'consum', 0.0228, 'lps'),
	(550000, 131, '2014-02-15 00:26:48.000000', 'consum', 0.0224, 'lps'),
	(550001, 131, '2014-02-15 00:26:49.000000', 'consum', 0.0225, 'lps'),
	(550002, 131, '2014-02-15 00:26:50.000000', 'consum', 0.0217, 'lps'),
	(550003, 131, '2014-02-15 00:26:51.000000', 'consum', 0.0228, 'lps'),
	(550004, 131, '2014-02-15 00:26:52.000000', 'consum', 0.0225, 'lps'),
	(550005, 131, '2014-02-15 00:26:53.000000', 'consum', 0.0231, 'lps'),
	(550006, 131, '2014-02-15 00:26:54.000000', 'consum', 0.0215, 'lps'),
	(550007, 131, '2014-02-15 00:26:55.000000', 'consum', 0.0226, 'lps'),
	(550008, 131, '2014-02-15 00:26:56.000000', 'consum', 0.0222, 'lps'),
	(550009, 131, '2014-02-15 00:26:57.000000', 'consum', 0.0223, 'lps'),
	(550010, 131, '2014-02-15 00:26:58.000000', 'consum', 0.0237, 'lps'),
	(550011, 131, '2014-02-15 00:26:59.000000', 'consum', 0.0222, 'lps'),
	(550012, 131, '2014-02-15 00:27:00.000000', 'consum', 0.0220, 'lps'),
	(550013, 131, '2014-02-15 00:27:01.000000', 'consum', 0.0222, 'lps'),
	(550014, 131, '2014-02-15 00:27:02.000000', 'consum', 0.0215, 'lps'),
	(550015, 131, '2014-02-15 00:27:03.000000', 'consum', 0.0227, 'lps'),
	(550016, 131, '2014-02-15 00:27:04.000000', 'consum', 0.0225, 'lps'),
	(550017, 131, '2014-02-15 00:27:05.000000', 'consum', 0.0234, 'lps'),
	(550018, 131, '2014-02-15 00:27:06.000000', 'consum', 0.0230, 'lps'),
	(550019, 131, '2014-02-15 00:27:07.000000', 'consum', 0.0211, 'lps'),
	(550020, 131, '2014-02-15 00:27:08.000000', 'consum', 0.0211, 'lps'),
	(550021, 131, '2014-02-15 00:27:09.000000', 'consum', 0.0214, 'lps'),
	(550022, 131, '2014-02-15 00:27:10.000000', 'consum', 0.0224, 'lps'),
	(550023, 131, '2014-02-15 00:27:11.000000', 'consum', 0.0215, 'lps'),
	(550024, 131, '2014-02-15 00:27:12.000000', 'consum', 0.0222, 'lps'),
	(550025, 131, '2014-02-15 00:27:13.000000', 'consum', 0.0226, 'lps'),
	(550026, 131, '2014-02-15 00:27:14.000000', 'consum', 0.0228, 'lps'),
	(550027, 131, '2014-02-15 00:27:15.000000', 'consum', 0.0225, 'lps'),
	(550028, 131, '2014-02-15 00:27:16.000000', 'consum', 0.0230, 'lps'),
	(550029, 131, '2014-02-15 00:27:17.000000', 'consum', 0.0211, 'lps'),
	(550030, 131, '2014-02-15 00:27:18.000000', 'consum', 0.0210, 'lps'),
	(550031, 131, '2014-02-15 00:27:19.000000', 'consum', 0.0235, 'lps'),
	(550032, 131, '2014-02-15 00:27:20.000000', 'consum', 0.0224, 'lps'),
	(550033, 131, '2014-02-15 00:27:21.000000', 'consum', 0.0233, 'lps'),
	(550034, 131, '2014-02-15 00:27:22.000000', 'consum', 0.0228, 'lps'),
	(550035, 131, '2014-02-15 00:27:23.000000', 'consum', 0.0233, 'lps'),
	(550036, 131, '2014-02-15 00:27:24.000000', 'consum', 0.0216, 'lps'),
	(550037, 131, '2014-02-15 00:27:25.000000', 'consum', 0.0225, 'lps'),
	(550038, 131, '2014-02-15 00:27:26.000000', 'consum', 0.0215, 'lps'),
	(550039, 131, '2014-02-15 00:27:27.000000', 'consum', 0.0215, 'lps'),
	(550040, 131, '2014-02-15 00:27:28.000000', 'consum', 0.0221, 'lps'),
	(550041, 131, '2014-02-15 00:27:29.000000', 'consum', 0.0222, 'lps'),
	(550042, 131, '2014-02-15 00:27:30.000000', 'consum', 0.0236, 'lps'),
	(550043, 131, '2014-02-15 00:27:31.000000', 'consum', 0.0222, 'lps'),
	(550044, 131, '2014-02-15 00:27:32.000000', 'consum', 0.0222, 'lps'),
	(550045, 131, '2014-02-15 00:27:33.000000', 'consum', 0.0232, 'lps'),
	(550046, 131, '2014-02-15 00:27:34.000000', 'consum', 0.0230, 'lps'),
	(550047, 131, '2014-02-15 00:27:35.000000', 'consum', 0.0216, 'lps'),
	(550048, 131, '2014-02-15 00:27:36.000000', 'consum', 0.0235, 'lps'),
	(550049, 131, '2014-02-15 00:27:37.000000', 'consum', 0.0233, 'lps'),
	(550050, 131, '2014-02-15 00:27:38.000000', 'consum', 0.0223, 'lps'),
	(550051, 131, '2014-02-15 00:27:39.000000', 'consum', 0.0233, 'lps'),
	(550052, 131, '2014-02-15 00:27:40.000000', 'consum', 0.0232, 'lps'),
	(550053, 131, '2014-02-15 00:27:41.000000', 'consum', 0.0223, 'lps'),
	(550054, 131, '2014-02-15 00:27:42.000000', 'consum', 0.0237, 'lps'),
	(550055, 131, '2014-02-15 00:27:43.000000', 'consum', 0.0221, 'lps'),
	(550056, 131, '2014-02-15 00:27:44.000000', 'consum', 0.0215, 'lps'),
	(550057, 131, '2014-02-15 00:27:45.000000', 'consum', 0.0231, 'lps'),
	(550058, 131, '2014-02-15 00:27:46.000000', 'consum', 0.0214, 'lps'),
	(550059, 131, '2014-02-15 00:27:47.000000', 'consum', 0.0223, 'lps'),
	(550060, 131, '2014-02-15 00:27:48.000000', 'consum', 0.0235, 'lps'),
	(550061, 131, '2014-02-15 00:27:49.000000', 'consum', 0.0215, 'lps'),
	(550062, 131, '2014-02-15 00:27:50.000000', 'consum', 0.0216, 'lps'),
	(550063, 131, '2014-02-15 00:27:51.000000', 'consum', 0.0223, 'lps'),
	(550064, 131, '2014-02-15 00:27:52.000000', 'consum', 0.0232, 'lps'),
	(550065, 131, '2014-02-15 00:27:53.000000', 'consum', 0.0227, 'lps'),
	(550066, 131, '2014-02-15 00:27:54.000000', 'consum', 0.0227, 'lps'),
	(550067, 131, '2014-02-15 00:27:55.000000', 'consum', 0.0219, 'lps'),
	(550068, 131, '2014-02-15 00:27:56.000000', 'consum', 0.0230, 'lps'),
	(550069, 131, '2014-02-15 00:27:57.000000', 'consum', 0.0228, 'lps'),
	(550070, 131, '2014-02-15 00:27:58.000000', 'consum', 0.0214, 'lps'),
	(550071, 131, '2014-02-15 00:27:59.000000', 'consum', 0.0231, 'lps'),
	(550072, 131, '2014-02-15 00:28:00.000000', 'consum', 0.0221, 'lps'),
	(550073, 131, '2014-02-15 00:28:01.000000', 'consum', 0.0231, 'lps'),
	(550074, 131, '2014-02-15 00:28:02.000000', 'consum', 0.0226, 'lps'),
	(550075, 131, '2014-02-15 00:28:03.000000', 'consum', 0.0228, 'lps'),
	(550076, 131, '2014-02-15 00:28:04.000000', 'consum', 0.0226, 'lps'),
	(550077, 131, '2014-02-15 00:28:05.000000', 'consum', 0.0235, 'lps'),
	(550078, 131, '2014-02-15 00:28:06.000000', 'consum', 0.0234, 'lps'),
	(550079, 131, '2014-02-15 00:28:07.000000', 'consum', 0.0224, 'lps'),
	(550080, 131, '2014-02-15 00:28:08.000000', 'consum', 0.0210, 'lps'),
	(550081, 131, '2014-02-15 00:28:09.000000', 'consum', 0.0224, 'lps'),
	(550082, 131, '2014-02-15 00:28:10.000000', 'consum', 0.0226, 'lps'),
	(550083, 131, '2014-02-15 00:28:11.000000', 'consum', 0.0218, 'lps'),
	(550084, 131, '2014-02-15 00:28:12.000000', 'consum', 0.0232, 'lps'),
	(550085, 131, '2014-02-15 00:28:13.000000', 'consum', 0.0211, 'lps'),
	(550086, 131, '2014-02-15 00:28:14.000000', 'consum', 0.0233, 'lps'),
	(550087, 131, '2014-02-15 00:28:15.000000', 'consum', 0.0212, 'lps'),
	(550088, 131, '2014-02-15 00:28:16.000000', 'consum', 0.0234, 'lps'),
	(550089, 131, '2014-02-15 00:28:17.000000', 'consum', 0.0211, 'lps'),
	(550090, 131, '2014-02-15 00:28:18.000000', 'consum', 0.0230, 'lps'),
	(550091, 131, '2014-02-15 00:28:19.000000', 'consum', 0.0224, 'lps'),
	(550092, 131, '2014-02-15 00:28:20.000000', 'consum', 0.0222, 'lps'),
	(550093, 131, '2014-02-15 00:28:21.000000', 'consum', 0.0225, 'lps'),
	(550094, 131, '2014-02-15 00:28:22.000000', 'consum', 0.0223, 'lps'),
	(550095, 131, '2014-02-15 00:28:23.000000', 'consum', 0.0230, 'lps'),
	(550096, 131, '2014-02-15 00:28:24.000000', 'consum', 0.0215, 'lps'),
	(550097, 131, '2014-02-15 00:28:25.000000', 'consum', 0.0230, 'lps'),
	(550098, 131, '2014-02-15 00:28:26.000000', 'consum', 0.0214, 'lps'),
	(550099, 131, '2014-02-15 00:28:27.000000', 'consum', 0.0228, 'lps'),
	(550100, 131, '2014-02-15 00:28:28.000000', 'consum', 0.0229, 'lps'),
	(550101, 131, '2014-02-15 00:28:29.000000', 'consum', 0.0226, 'lps'),
	(550102, 131, '2014-02-15 00:28:30.000000', 'consum', 0.0231, 'lps'),
	(550103, 131, '2014-02-15 00:28:31.000000', 'consum', 0.0214, 'lps'),
	(550104, 131, '2014-02-15 00:28:32.000000', 'consum', 0.0222, 'lps'),
	(550105, 131, '2014-02-15 00:28:33.000000', 'consum', 0.0230, 'lps'),
	(550106, 131, '2014-02-15 00:28:34.000000', 'consum', 0.0221, 'lps'),
	(550107, 131, '2014-02-15 00:28:35.000000', 'consum', 0.0233, 'lps'),
	(550108, 131, '2014-02-15 00:28:36.000000', 'consum', 0.0236, 'lps'),
	(550109, 131, '2014-02-15 00:28:37.000000', 'consum', 0.0214, 'lps'),
	(550110, 131, '2014-02-15 00:28:38.000000', 'consum', 0.0210, 'lps'),
	(550111, 131, '2014-02-15 00:28:39.000000', 'consum', 0.0227, 'lps'),
	(550112, 131, '2014-02-15 00:28:40.000000', 'consum', 0.0212, 'lps'),
	(550113, 131, '2014-02-15 00:28:41.000000', 'consum', 0.0224, 'lps'),
	(550114, 131, '2014-02-15 00:28:42.000000', 'consum', 0.0219, 'lps'),
	(550115, 131, '2014-02-15 00:28:43.000000', 'consum', 0.0213, 'lps'),
	(550116, 131, '2014-02-15 00:28:44.000000', 'consum', 0.0228, 'lps'),
	(550117, 131, '2014-02-15 00:28:45.000000', 'consum', 0.0236, 'lps'),
	(550118, 131, '2014-02-15 00:28:46.000000', 'consum', 0.0228, 'lps'),
	(550119, 131, '2014-02-15 00:28:47.000000', 'consum', 0.0222, 'lps'),
	(550120, 131, '2014-02-15 00:28:48.000000', 'consum', 0.0216, 'lps'),
	(550121, 131, '2014-02-15 00:28:49.000000', 'consum', 0.0234, 'lps'),
	(550122, 131, '2014-02-15 00:28:50.000000', 'consum', 0.0230, 'lps'),
	(550123, 131, '2014-02-15 00:28:51.000000', 'consum', 0.0211, 'lps'),
	(550124, 131, '2014-02-15 00:28:52.000000', 'consum', 0.0237, 'lps'),
	(550125, 131, '2014-02-15 00:28:53.000000', 'consum', 0.0230, 'lps'),
	(550126, 131, '2014-02-15 00:28:54.000000', 'consum', 0.0229, 'lps'),
	(550127, 131, '2014-02-15 00:28:55.000000', 'consum', 0.0218, 'lps'),
	(550128, 131, '2014-02-15 00:28:56.000000', 'consum', 0.0221, 'lps'),
	(550129, 131, '2014-02-15 00:28:57.000000', 'consum', 0.0212, 'lps'),
	(550130, 131, '2014-02-15 00:28:58.000000', 'consum', 0.0217, 'lps'),
	(550131, 131, '2014-02-15 00:28:59.000000', 'consum', 0.0213, 'lps'),
	(550132, 131, '2014-02-15 00:29:00.000000', 'consum', 0.0232, 'lps'),
	(550133, 131, '2014-02-15 00:29:01.000000', 'consum', 0.0227, 'lps'),
	(550134, 131, '2014-02-15 00:29:02.000000', 'consum', 0.0231, 'lps'),
	(550135, 131, '2014-02-15 00:29:03.000000', 'consum', 0.0237, 'lps'),
	(550136, 131, '2014-02-15 00:29:04.000000', 'consum', 0.0226, 'lps'),
	(550137, 131, '2014-02-15 00:29:05.000000', 'consum', 0.0237, 'lps'),
	(550138, 131, '2014-02-15 00:29:06.000000', 'consum', 0.0213, 'lps'),
	(550139, 131, '2014-02-15 00:29:07.000000', 'consum', 0.0228, 'lps'),
	(550140, 131, '2014-02-15 00:29:08.000000', 'consum', 0.0235, 'lps'),
	(550141, 131, '2014-02-15 00:29:09.000000', 'consum', 0.0227, 'lps'),
	(550142, 131, '2014-02-15 00:29:10.000000', 'consum', 0.0220, 'lps'),
	(550143, 131, '2014-02-15 00:29:11.000000', 'consum', 0.0210, 'lps'),
	(550144, 131, '2014-02-15 00:29:12.000000', 'consum', 0.0236, 'lps'),
	(550145, 131, '2014-02-15 00:29:13.000000', 'consum', 0.0227, 'lps'),
	(550146, 131, '2014-02-15 00:29:14.000000', 'consum', 0.0219, 'lps'),
	(550147, 131, '2014-02-15 00:29:15.000000', 'consum', 0.0231, 'lps'),
	(550148, 131, '2014-02-15 00:29:16.000000', 'consum', 0.0234, 'lps'),
	(550149, 131, '2014-02-15 00:29:17.000000', 'consum', 0.0211, 'lps'),
	(550150, 131, '2014-02-15 00:29:18.000000', 'consum', 0.0228, 'lps'),
	(550151, 131, '2014-02-15 00:29:19.000000', 'consum', 0.0213, 'lps'),
	(550152, 131, '2014-02-15 00:29:20.000000', 'consum', 0.0227, 'lps'),
	(550153, 131, '2014-02-15 00:29:21.000000', 'consum', 0.0229, 'lps'),
	(550154, 131, '2014-02-15 00:29:22.000000', 'consum', 0.0230, 'lps'),
	(550155, 131, '2014-02-15 00:29:23.000000', 'consum', 0.0222, 'lps'),
	(550156, 131, '2014-02-15 00:29:24.000000', 'consum', 0.0214, 'lps'),
	(550157, 131, '2014-02-15 00:29:25.000000', 'consum', 0.0220, 'lps'),
	(550158, 131, '2014-02-15 00:29:26.000000', 'consum', 0.0220, 'lps'),
	(550159, 131, '2014-02-15 00:29:27.000000', 'consum', 0.0229, 'lps'),
	(550160, 131, '2014-02-15 00:29:28.000000', 'consum', 0.0223, 'lps'),
	(550161, 131, '2014-02-15 00:29:29.000000', 'consum', 0.0218, 'lps'),
	(550162, 131, '2014-02-15 00:29:30.000000', 'consum', 0.0212, 'lps'),
	(550163, 131, '2014-02-15 00:29:31.000000', 'consum', 0.0225, 'lps'),
	(550164, 131, '2014-02-15 00:29:32.000000', 'consum', 0.0222, 'lps'),
	(550165, 131, '2014-02-15 00:29:33.000000', 'consum', 0.0225, 'lps'),
	(550166, 131, '2014-02-15 00:29:34.000000', 'consum', 0.0223, 'lps'),
	(550167, 131, '2014-02-15 00:29:35.000000', 'consum', 0.0230, 'lps'),
	(550168, 131, '2014-02-15 00:29:36.000000', 'consum', 0.0217, 'lps'),
	(550169, 131, '2014-02-15 00:29:37.000000', 'consum', 0.0214, 'lps'),
	(550170, 131, '2014-02-15 00:29:38.000000', 'consum', 0.0236, 'lps'),
	(550171, 131, '2014-02-15 00:29:39.000000', 'consum', 0.0216, 'lps'),
	(550172, 131, '2014-02-15 00:29:40.000000', 'consum', 0.0220, 'lps'),
	(550173, 131, '2014-02-15 00:29:41.000000', 'consum', 0.0212, 'lps'),
	(550174, 131, '2014-02-15 00:29:42.000000', 'consum', 0.0220, 'lps'),
	(550175, 131, '2014-02-15 00:29:43.000000', 'consum', 0.0225, 'lps'),
	(550176, 131, '2014-02-15 00:29:44.000000', 'consum', 0.0229, 'lps'),
	(550177, 131, '2014-02-15 00:29:45.000000', 'consum', 0.0232, 'lps'),
	(550178, 131, '2014-02-15 00:29:46.000000', 'consum', 0.0236, 'lps'),
	(550179, 131, '2014-02-15 00:29:47.000000', 'consum', 0.0220, 'lps'),
	(550180, 131, '2014-02-15 00:29:48.000000', 'consum', 0.0237, 'lps'),
	(550181, 131, '2014-02-15 00:29:49.000000', 'consum', 0.0230, 'lps'),
	(550182, 131, '2014-02-15 00:29:50.000000', 'consum', 0.0232, 'lps'),
	(550183, 131, '2014-02-15 00:29:51.000000', 'consum', 0.0230, 'lps'),
	(550184, 131, '2014-02-15 00:29:52.000000', 'consum', 0.0219, 'lps'),
	(550185, 131, '2014-02-15 00:29:53.000000', 'consum', 0.0222, 'lps'),
	(550186, 131, '2014-02-15 00:29:54.000000', 'consum', 0.0217, 'lps'),
	(550187, 131, '2014-02-15 00:29:55.000000', 'consum', 0.0235, 'lps'),
	(550188, 131, '2014-02-15 00:29:56.000000', 'consum', 0.0231, 'lps'),
	(550189, 131, '2014-02-15 00:29:57.000000', 'consum', 0.0214, 'lps'),
	(550190, 131, '2014-02-15 00:29:58.000000', 'consum', 0.0223, 'lps'),
	(550191, 131, '2014-02-15 00:29:59.000000', 'consum', 0.0236, 'lps'),
	(550192, 131, '2014-02-15 00:30:00.000000', 'consum', 0.0217, 'lps'),
	(550193, 131, '2014-02-15 00:30:01.000000', 'consum', 0.0224, 'lps'),
	(550194, 131, '2014-02-15 00:30:02.000000', 'consum', 0.0230, 'lps'),
	(550195, 131, '2014-02-15 00:30:03.000000', 'consum', 0.0211, 'lps'),
	(550196, 131, '2014-02-15 00:30:04.000000', 'consum', 0.0215, 'lps'),
	(550197, 131, '2014-02-15 00:30:05.000000', 'consum', 0.0232, 'lps'),
	(550198, 131, '2014-02-15 00:30:06.000000', 'consum', 0.0220, 'lps'),
	(550199, 131, '2014-02-15 00:30:07.000000', 'consum', 0.0221, 'lps'),
	(550200, 131, '2014-02-15 00:30:08.000000', 'consum', 0.0210, 'lps'),
	(550201, 131, '2014-02-15 00:30:09.000000', 'consum', 0.0232, 'lps'),
	(550202, 131, '2014-02-15 00:30:10.000000', 'consum', 0.0236, 'lps'),
	(550203, 131, '2014-02-15 00:30:11.000000', 'consum', 0.0219, 'lps'),
	(550204, 131, '2014-02-15 00:30:12.000000', 'consum', 0.0232, 'lps'),
	(550205, 131, '2014-02-15 00:30:13.000000', 'consum', 0.0212, 'lps'),
	(550206, 131, '2014-02-15 00:30:14.000000', 'consum', 0.0212, 'lps'),
	(550207, 131, '2014-02-15 00:30:15.000000', 'consum', 0.0211, 'lps'),
	(550208, 131, '2014-02-15 00:30:16.000000', 'consum', 0.0211, 'lps'),
	(550209, 131, '2014-02-15 00:30:17.000000', 'consum', 0.0211, 'lps'),
	(550210, 131, '2014-02-15 00:30:18.000000', 'consum', 0.0212, 'lps'),
	(550211, 131, '2014-02-15 00:30:19.000000', 'consum', 0.0219, 'lps'),
	(550212, 131, '2014-02-15 00:30:20.000000', 'consum', 0.0220, 'lps'),
	(550213, 131, '2014-02-15 00:30:21.000000', 'consum', 0.0233, 'lps'),
	(550214, 131, '2014-02-15 00:30:22.000000', 'consum', 0.0212, 'lps'),
	(550215, 131, '2014-02-15 00:30:23.000000', 'consum', 0.0237, 'lps'),
	(550216, 131, '2014-02-15 00:30:24.000000', 'consum', 0.0228, 'lps'),
	(550217, 131, '2014-02-15 00:30:25.000000', 'consum', 0.0217, 'lps'),
	(550218, 131, '2014-02-15 00:30:26.000000', 'consum', 0.0219, 'lps'),
	(550219, 131, '2014-02-15 00:30:27.000000', 'consum', 0.0235, 'lps'),
	(550220, 131, '2014-02-15 00:30:28.000000', 'consum', 0.0225, 'lps'),
	(550221, 131, '2014-02-15 00:30:29.000000', 'consum', 0.0212, 'lps'),
	(550222, 131, '2014-02-15 00:30:30.000000', 'consum', 0.0233, 'lps'),
	(550223, 131, '2014-02-15 00:30:31.000000', 'consum', 0.0232, 'lps'),
	(550224, 131, '2014-02-15 00:30:32.000000', 'consum', 0.0223, 'lps'),
	(550225, 131, '2014-02-15 00:30:33.000000', 'consum', 0.0213, 'lps'),
	(550226, 131, '2014-02-15 00:30:34.000000', 'consum', 0.0211, 'lps'),
	(550227, 131, '2014-02-15 00:30:35.000000', 'consum', 0.0236, 'lps'),
	(550228, 131, '2014-02-15 00:30:36.000000', 'consum', 0.0225, 'lps'),
	(550229, 131, '2014-02-15 00:30:37.000000', 'consum', 0.0237, 'lps'),
	(550230, 131, '2014-02-15 00:30:38.000000', 'consum', 0.0214, 'lps'),
	(550231, 131, '2014-02-15 00:30:39.000000', 'consum', 0.0233, 'lps'),
	(550232, 131, '2014-02-15 00:30:40.000000', 'consum', 0.0232, 'lps'),
	(550233, 131, '2014-02-15 00:30:41.000000', 'consum', 0.0221, 'lps'),
	(550234, 131, '2014-02-15 00:30:42.000000', 'consum', 0.0229, 'lps'),
	(550235, 131, '2014-02-15 00:30:43.000000', 'consum', 0.0216, 'lps'),
	(550236, 131, '2014-02-15 00:30:44.000000', 'consum', 0.0212, 'lps'),
	(550237, 131, '2014-02-15 00:30:45.000000', 'consum', 0.0229, 'lps'),
	(550238, 131, '2014-02-15 00:30:46.000000', 'consum', 0.0214, 'lps'),
	(550239, 131, '2014-02-15 00:30:47.000000', 'consum', 0.0233, 'lps'),
	(550240, 131, '2014-02-15 00:30:48.000000', 'consum', 0.0229, 'lps'),
	(550241, 131, '2014-02-15 00:30:49.000000', 'consum', 0.0237, 'lps'),
	(550242, 131, '2014-02-15 00:30:50.000000', 'consum', 0.0234, 'lps'),
	(550243, 131, '2014-02-15 00:30:51.000000', 'consum', 0.0218, 'lps'),
	(550244, 131, '2014-02-15 00:30:52.000000', 'consum', 0.0237, 'lps'),
	(550245, 131, '2014-02-15 00:30:53.000000', 'consum', 0.0210, 'lps'),
	(550246, 131, '2014-02-15 00:30:54.000000', 'consum', 0.0212, 'lps'),
	(550247, 131, '2014-02-15 00:30:55.000000', 'consum', 0.0222, 'lps'),
	(550248, 131, '2014-02-15 00:30:56.000000', 'consum', 0.0210, 'lps'),
	(550249, 131, '2014-02-15 00:30:57.000000', 'consum', 0.0228, 'lps'),
	(550250, 131, '2014-02-15 00:30:58.000000', 'consum', 0.0216, 'lps'),
	(550251, 131, '2014-02-15 00:30:59.000000', 'consum', 0.0215, 'lps'),
	(550252, 131, '2014-02-15 00:31:00.000000', 'consum', 0.0217, 'lps'),
	(550253, 131, '2014-02-15 00:31:01.000000', 'consum', 0.0232, 'lps'),
	(550254, 131, '2014-02-15 00:31:02.000000', 'consum', 0.0216, 'lps'),
	(550255, 131, '2014-02-15 00:31:03.000000', 'consum', 0.0229, 'lps'),
	(550256, 131, '2014-02-15 00:31:04.000000', 'consum', 0.0234, 'lps'),
	(550257, 131, '2014-02-15 00:31:05.000000', 'consum', 0.0215, 'lps'),
	(550258, 131, '2014-02-15 00:31:06.000000', 'consum', 0.0220, 'lps'),
	(550259, 131, '2014-02-15 00:31:07.000000', 'consum', 0.0217, 'lps'),
	(550260, 131, '2014-02-15 00:31:08.000000', 'consum', 0.0218, 'lps'),
	(550261, 131, '2014-02-15 00:31:09.000000', 'consum', 0.0228, 'lps'),
	(550262, 131, '2014-02-15 00:31:10.000000', 'consum', 0.0221, 'lps'),
	(550263, 131, '2014-02-15 00:31:11.000000', 'consum', 0.0237, 'lps'),
	(550264, 131, '2014-02-15 00:31:12.000000', 'consum', 0.0232, 'lps'),
	(550265, 131, '2014-02-15 00:31:13.000000', 'consum', 0.0236, 'lps'),
	(550266, 131, '2014-02-15 00:31:14.000000', 'consum', 0.0221, 'lps'),
	(550267, 131, '2014-02-15 00:31:15.000000', 'consum', 0.0215, 'lps'),
	(550268, 131, '2014-02-15 00:31:16.000000', 'consum', 0.0230, 'lps'),
	(550269, 131, '2014-02-15 00:31:17.000000', 'consum', 0.0212, 'lps'),
	(550270, 131, '2014-02-15 00:31:18.000000', 'consum', 0.0218, 'lps'),
	(550271, 131, '2014-02-15 00:31:19.000000', 'consum', 0.0215, 'lps'),
	(550272, 131, '2014-02-15 00:31:20.000000', 'consum', 0.0211, 'lps'),
	(550273, 131, '2014-02-15 00:31:21.000000', 'consum', 0.0228, 'lps'),
	(550274, 131, '2014-02-15 00:31:22.000000', 'consum', 0.0212, 'lps'),
	(550275, 131, '2014-02-15 00:31:23.000000', 'consum', 0.0224, 'lps'),
	(550276, 131, '2014-02-15 00:31:24.000000', 'consum', 0.0221, 'lps'),
	(550277, 131, '2014-02-15 00:31:25.000000', 'consum', 0.0220, 'lps'),
	(550278, 131, '2014-02-15 00:31:26.000000', 'consum', 0.0228, 'lps'),
	(550279, 131, '2014-02-15 00:31:27.000000', 'consum', 0.0216, 'lps'),
	(550280, 131, '2014-02-15 00:31:28.000000', 'consum', 0.0212, 'lps'),
	(550281, 131, '2014-02-15 00:31:29.000000', 'consum', 0.0232, 'lps'),
	(550282, 131, '2014-02-15 00:31:30.000000', 'consum', 0.0228, 'lps'),
	(550283, 131, '2014-02-15 00:31:31.000000', 'consum', 0.0210, 'lps'),
	(550284, 131, '2014-02-15 00:31:32.000000', 'consum', 0.0237, 'lps'),
	(550285, 131, '2014-02-15 00:31:33.000000', 'consum', 0.0236, 'lps'),
	(550286, 131, '2014-02-15 00:31:34.000000', 'consum', 0.0231, 'lps'),
	(550287, 131, '2014-02-15 00:31:35.000000', 'consum', 0.0211, 'lps'),
	(550288, 131, '2014-02-15 00:31:36.000000', 'consum', 0.0236, 'lps'),
	(550289, 131, '2014-02-15 00:31:37.000000', 'consum', 0.0226, 'lps'),
	(550290, 131, '2014-02-15 00:31:38.000000', 'consum', 0.0214, 'lps'),
	(550291, 131, '2014-02-15 00:31:39.000000', 'consum', 0.0236, 'lps'),
	(550292, 131, '2014-02-15 00:31:40.000000', 'consum', 0.0217, 'lps'),
	(550293, 131, '2014-02-15 00:31:41.000000', 'consum', 0.0224, 'lps'),
	(550294, 131, '2014-02-15 00:31:42.000000', 'consum', 0.0229, 'lps'),
	(550295, 131, '2014-02-15 00:31:43.000000', 'consum', 0.0211, 'lps'),
	(550296, 131, '2014-02-15 00:31:44.000000', 'consum', 0.0212, 'lps'),
	(550297, 131, '2014-02-15 00:31:45.000000', 'consum', 0.0217, 'lps'),
	(550298, 131, '2014-02-15 00:31:46.000000', 'consum', 0.0211, 'lps'),
	(550299, 131, '2014-02-15 00:31:47.000000', 'consum', 0.0224, 'lps'),
	(550300, 131, '2014-02-15 00:31:48.000000', 'consum', 0.0220, 'lps'),
	(550301, 131, '2014-02-15 00:31:49.000000', 'consum', 0.0220, 'lps'),
	(550302, 131, '2014-02-15 00:31:50.000000', 'consum', 0.0229, 'lps'),
	(550303, 131, '2014-02-15 00:31:51.000000', 'consum', 0.0219, 'lps'),
	(550304, 131, '2014-02-15 00:31:52.000000', 'consum', 0.0227, 'lps'),
	(550305, 131, '2014-02-15 00:31:53.000000', 'consum', 0.0214, 'lps'),
	(550306, 131, '2014-02-15 00:31:54.000000', 'consum', 0.0235, 'lps'),
	(550307, 131, '2014-02-15 00:31:55.000000', 'consum', 0.0210, 'lps'),
	(550308, 131, '2014-02-15 00:31:56.000000', 'consum', 0.0220, 'lps'),
	(550309, 131, '2014-02-15 00:31:57.000000', 'consum', 0.0234, 'lps'),
	(550310, 131, '2014-02-15 00:31:58.000000', 'consum', 0.0216, 'lps'),
	(550311, 131, '2014-02-15 00:31:59.000000', 'consum', 0.0226, 'lps'),
	(550312, 131, '2014-02-15 00:32:00.000000', 'consum', 0.0215, 'lps'),
	(550313, 131, '2014-02-15 00:32:01.000000', 'consum', 0.0215, 'lps'),
	(550314, 131, '2014-02-15 00:32:02.000000', 'consum', 0.0221, 'lps'),
	(550315, 131, '2014-02-15 00:32:03.000000', 'consum', 0.0221, 'lps'),
	(550316, 131, '2014-02-15 00:32:04.000000', 'consum', 0.0234, 'lps'),
	(550317, 131, '2014-02-15 00:32:05.000000', 'consum', 0.0213, 'lps'),
	(550318, 131, '2014-02-15 00:32:06.000000', 'consum', 0.0210, 'lps'),
	(550319, 131, '2014-02-15 00:32:07.000000', 'consum', 0.0230, 'lps'),
	(550320, 131, '2014-02-15 00:32:08.000000', 'consum', 0.0228, 'lps'),
	(550321, 131, '2014-02-15 00:32:09.000000', 'consum', 0.0210, 'lps'),
	(550322, 131, '2014-02-15 00:32:10.000000', 'consum', 0.0215, 'lps'),
	(550323, 131, '2014-02-15 00:32:11.000000', 'consum', 0.0232, 'lps'),
	(550324, 131, '2014-02-15 00:32:12.000000', 'consum', 0.0225, 'lps'),
	(550325, 131, '2014-02-15 00:32:13.000000', 'consum', 0.0218, 'lps'),
	(550326, 131, '2014-02-15 00:32:14.000000', 'consum', 0.0233, 'lps'),
	(550327, 131, '2014-02-15 00:32:15.000000', 'consum', 0.0218, 'lps'),
	(550328, 131, '2014-02-15 00:32:16.000000', 'consum', 0.0235, 'lps'),
	(550329, 131, '2014-02-15 00:32:17.000000', 'consum', 0.0231, 'lps'),
	(550330, 131, '2014-02-15 00:32:18.000000', 'consum', 0.0237, 'lps'),
	(550331, 131, '2014-02-15 00:32:19.000000', 'consum', 0.0230, 'lps'),
	(550332, 131, '2014-02-15 00:32:20.000000', 'consum', 0.0229, 'lps'),
	(550333, 131, '2014-02-15 00:32:21.000000', 'consum', 0.0215, 'lps'),
	(550334, 131, '2014-02-15 00:32:22.000000', 'consum', 0.0237, 'lps'),
	(550335, 131, '2014-02-15 00:32:23.000000', 'consum', 0.0216, 'lps'),
	(550336, 131, '2014-02-15 00:32:24.000000', 'consum', 0.0217, 'lps'),
	(550337, 131, '2014-02-15 00:32:25.000000', 'consum', 0.0228, 'lps'),
	(550338, 131, '2014-02-15 00:32:26.000000', 'consum', 0.0225, 'lps'),
	(550339, 131, '2014-02-15 00:32:27.000000', 'consum', 0.0228, 'lps'),
	(550340, 131, '2014-02-15 00:32:28.000000', 'consum', 0.0230, 'lps'),
	(550341, 131, '2014-02-15 00:32:29.000000', 'consum', 0.0226, 'lps'),
	(550342, 131, '2014-02-15 00:32:30.000000', 'consum', 0.0233, 'lps'),
	(550343, 131, '2014-02-15 00:32:31.000000', 'consum', 0.0222, 'lps'),
	(550344, 131, '2014-02-15 00:32:32.000000', 'consum', 0.0228, 'lps'),
	(550345, 131, '2014-02-15 00:32:33.000000', 'consum', 0.0236, 'lps'),
	(550346, 131, '2014-02-15 00:32:34.000000', 'consum', 0.0233, 'lps'),
	(550347, 131, '2014-02-15 00:32:35.000000', 'consum', 0.0217, 'lps'),
	(550348, 131, '2014-02-15 00:32:36.000000', 'consum', 0.0232, 'lps'),
	(550349, 131, '2014-02-15 00:32:37.000000', 'consum', 0.0215, 'lps'),
	(550350, 131, '2014-02-15 00:32:38.000000', 'consum', 0.0227, 'lps'),
	(550351, 131, '2014-02-15 00:32:39.000000', 'consum', 0.0222, 'lps'),
	(550352, 131, '2014-02-15 00:32:40.000000', 'consum', 0.0221, 'lps'),
	(550353, 131, '2014-02-15 00:32:41.000000', 'consum', 0.0231, 'lps'),
	(550354, 131, '2014-02-15 00:32:42.000000', 'consum', 0.0224, 'lps'),
	(550355, 131, '2014-02-15 00:32:43.000000', 'consum', 0.0220, 'lps'),
	(550356, 131, '2014-02-15 00:32:44.000000', 'consum', 0.0216, 'lps'),
	(550357, 131, '2014-02-15 00:32:45.000000', 'consum', 0.0212, 'lps'),
	(550358, 131, '2014-02-15 00:32:46.000000', 'consum', 0.0230, 'lps'),
	(550359, 131, '2014-02-15 00:32:47.000000', 'consum', 0.0222, 'lps'),
	(550360, 131, '2014-02-15 00:32:48.000000', 'consum', 0.0210, 'lps'),
	(550361, 131, '2014-02-15 00:32:49.000000', 'consum', 0.0229, 'lps'),
	(550362, 131, '2014-02-15 00:32:50.000000', 'consum', 0.0222, 'lps'),
	(550363, 131, '2014-02-15 00:32:51.000000', 'consum', 0.0212, 'lps'),
	(550364, 131, '2014-02-15 00:32:52.000000', 'consum', 0.0213, 'lps'),
	(550365, 131, '2014-02-15 00:32:53.000000', 'consum', 0.0220, 'lps'),
	(550366, 131, '2014-02-15 00:32:54.000000', 'consum', 0.0222, 'lps'),
	(550367, 131, '2014-02-15 00:32:55.000000', 'consum', 0.0213, 'lps'),
	(550368, 131, '2014-02-15 00:32:56.000000', 'consum', 0.0219, 'lps'),
	(550369, 131, '2014-02-15 00:32:57.000000', 'consum', 0.0217, 'lps'),
	(550370, 131, '2014-02-15 00:32:58.000000', 'consum', 0.0221, 'lps'),
	(550371, 131, '2014-02-15 00:32:59.000000', 'consum', 0.0214, 'lps'),
	(550372, 131, '2014-02-15 00:33:00.000000', 'consum', 0.0226, 'lps'),
	(550373, 131, '2014-02-15 00:33:01.000000', 'consum', 0.0224, 'lps'),
	(550374, 131, '2014-02-15 00:33:02.000000', 'consum', 0.0233, 'lps'),
	(550375, 131, '2014-02-15 00:33:03.000000', 'consum', 0.0225, 'lps'),
	(550376, 131, '2014-02-15 00:33:04.000000', 'consum', 0.0218, 'lps'),
	(550377, 131, '2014-02-15 00:33:05.000000', 'consum', 0.0231, 'lps'),
	(550378, 131, '2014-02-15 00:33:06.000000', 'consum', 0.0210, 'lps'),
	(550379, 131, '2014-02-15 00:33:07.000000', 'consum', 0.0232, 'lps'),
	(550380, 131, '2014-02-15 00:33:08.000000', 'consum', 0.0234, 'lps'),
	(550381, 131, '2014-02-15 00:33:09.000000', 'consum', 0.0210, 'lps'),
	(550382, 131, '2014-02-15 00:33:10.000000', 'consum', 0.0223, 'lps'),
	(550383, 131, '2014-02-15 00:33:11.000000', 'consum', 0.0220, 'lps'),
	(550384, 131, '2014-02-15 00:33:12.000000', 'consum', 0.0219, 'lps'),
	(550385, 131, '2014-02-15 00:33:13.000000', 'consum', 0.0226, 'lps'),
	(550386, 131, '2014-02-15 00:33:14.000000', 'consum', 0.0237, 'lps'),
	(550387, 131, '2014-02-15 00:33:15.000000', 'consum', 0.0214, 'lps'),
	(550388, 131, '2014-02-15 00:33:16.000000', 'consum', 0.0233, 'lps'),
	(550389, 131, '2014-02-15 00:33:17.000000', 'consum', 0.0228, 'lps'),
	(550390, 131, '2014-02-15 00:33:18.000000', 'consum', 0.0234, 'lps'),
	(550391, 131, '2014-02-15 00:33:19.000000', 'consum', 0.0218, 'lps'),
	(550392, 131, '2014-02-15 00:33:20.000000', 'consum', 0.0235, 'lps'),
	(550393, 131, '2014-02-15 00:33:21.000000', 'consum', 0.0229, 'lps'),
	(550394, 131, '2014-02-15 00:33:22.000000', 'consum', 0.0230, 'lps'),
	(550395, 131, '2014-02-15 00:33:23.000000', 'consum', 0.0223, 'lps'),
	(550396, 131, '2014-02-15 00:33:24.000000', 'consum', 0.0219, 'lps'),
	(550397, 131, '2014-02-15 00:33:25.000000', 'consum', 0.0214, 'lps'),
	(550398, 131, '2014-02-15 00:33:26.000000', 'consum', 0.0230, 'lps'),
	(550399, 131, '2014-02-15 00:33:27.000000', 'consum', 0.0218, 'lps'),
	(550400, 131, '2014-02-15 00:33:28.000000', 'consum', 0.0217, 'lps'),
	(550401, 131, '2014-02-15 00:33:29.000000', 'consum', 0.0223, 'lps'),
	(550402, 131, '2014-02-15 00:33:30.000000', 'consum', 0.0224, 'lps'),
	(550403, 131, '2014-02-15 00:33:31.000000', 'consum', 0.0216, 'lps'),
	(550404, 131, '2014-02-15 00:33:32.000000', 'consum', 0.0226, 'lps'),
	(550405, 131, '2014-02-15 00:33:33.000000', 'consum', 0.0215, 'lps'),
	(550406, 131, '2014-02-15 00:33:34.000000', 'consum', 0.0215, 'lps'),
	(550407, 131, '2014-02-15 00:33:35.000000', 'consum', 0.0221, 'lps'),
	(550408, 131, '2014-02-15 00:33:36.000000', 'consum', 0.0224, 'lps'),
	(550409, 131, '2014-02-15 00:33:37.000000', 'consum', 0.0218, 'lps'),
	(550410, 131, '2014-02-15 00:33:38.000000', 'consum', 0.0236, 'lps'),
	(550411, 131, '2014-02-15 00:33:39.000000', 'consum', 0.0235, 'lps'),
	(550412, 131, '2014-02-15 00:33:40.000000', 'consum', 0.0227, 'lps'),
	(550413, 131, '2014-02-15 00:33:41.000000', 'consum', 0.0223, 'lps'),
	(550414, 131, '2014-02-15 00:33:42.000000', 'consum', 0.0223, 'lps'),
	(550415, 131, '2014-02-15 00:33:43.000000', 'consum', 0.0210, 'lps'),
	(550416, 131, '2014-02-15 00:33:44.000000', 'consum', 0.0225, 'lps'),
	(550417, 131, '2014-02-15 00:33:45.000000', 'consum', 0.0229, 'lps'),
	(550418, 131, '2014-02-15 00:33:46.000000', 'consum', 0.0236, 'lps'),
	(550419, 131, '2014-02-15 00:33:47.000000', 'consum', 0.0225, 'lps'),
	(550420, 131, '2014-02-15 00:33:48.000000', 'consum', 0.0235, 'lps'),
	(550421, 131, '2014-02-15 00:33:49.000000', 'consum', 0.0235, 'lps'),
	(550422, 131, '2014-02-15 00:33:50.000000', 'consum', 0.0231, 'lps'),
	(550423, 131, '2014-02-15 00:33:51.000000', 'consum', 0.0215, 'lps'),
	(550424, 131, '2014-02-15 00:33:52.000000', 'consum', 0.0228, 'lps'),
	(550425, 131, '2014-02-15 00:33:53.000000', 'consum', 0.0228, 'lps'),
	(550426, 131, '2014-02-15 00:33:54.000000', 'consum', 0.0219, 'lps'),
	(550427, 131, '2014-02-15 00:33:55.000000', 'consum', 0.0231, 'lps'),
	(550428, 131, '2014-02-15 00:33:56.000000', 'consum', 0.0233, 'lps'),
	(550429, 131, '2014-02-15 00:33:57.000000', 'consum', 0.0232, 'lps'),
	(550430, 131, '2014-02-15 00:33:58.000000', 'consum', 0.0223, 'lps'),
	(550431, 131, '2014-02-15 00:33:59.000000', 'consum', 0.0212, 'lps'),
	(550432, 131, '2014-02-15 00:34:00.000000', 'consum', 0.0235, 'lps'),
	(550433, 131, '2014-02-15 00:34:01.000000', 'consum', 0.0220, 'lps'),
	(550434, 131, '2014-02-15 00:34:02.000000', 'consum', 0.0213, 'lps'),
	(550435, 131, '2014-02-15 00:34:03.000000', 'consum', 0.0223, 'lps'),
	(550436, 131, '2014-02-15 00:34:04.000000', 'consum', 0.0211, 'lps'),
	(550437, 131, '2014-02-15 00:34:05.000000', 'consum', 0.0234, 'lps'),
	(550438, 131, '2014-02-15 00:34:06.000000', 'consum', 0.0215, 'lps'),
	(550439, 131, '2014-02-15 00:34:07.000000', 'consum', 0.0221, 'lps'),
	(550440, 131, '2014-02-15 00:34:08.000000', 'consum', 0.0219, 'lps'),
	(550441, 131, '2014-02-15 00:34:09.000000', 'consum', 0.0225, 'lps'),
	(550442, 131, '2014-02-15 00:34:10.000000', 'consum', 0.0230, 'lps'),
	(550443, 131, '2014-02-15 00:34:11.000000', 'consum', 0.0211, 'lps'),
	(550444, 131, '2014-02-15 00:34:12.000000', 'consum', 0.0212, 'lps'),
	(550445, 131, '2014-02-15 00:34:13.000000', 'consum', 0.0218, 'lps'),
	(550446, 131, '2014-02-15 00:34:14.000000', 'consum', 0.0215, 'lps'),
	(550447, 131, '2014-02-15 00:34:15.000000', 'consum', 0.0211, 'lps'),
	(550448, 131, '2014-02-15 00:34:16.000000', 'consum', 0.0229, 'lps'),
	(550449, 131, '2014-02-15 00:34:17.000000', 'consum', 0.0219, 'lps'),
	(550450, 131, '2014-02-15 00:34:18.000000', 'consum', 0.0225, 'lps'),
	(550451, 131, '2014-02-15 00:34:19.000000', 'consum', 0.0233, 'lps'),
	(550452, 131, '2014-02-15 00:34:20.000000', 'consum', 0.0222, 'lps'),
	(550453, 131, '2014-02-15 00:34:21.000000', 'consum', 0.0230, 'lps'),
	(550454, 131, '2014-02-15 00:34:22.000000', 'consum', 0.0220, 'lps'),
	(550455, 131, '2014-02-15 00:34:23.000000', 'consum', 0.0226, 'lps'),
	(550456, 131, '2014-02-15 00:34:24.000000', 'consum', 0.0232, 'lps'),
	(550457, 131, '2014-02-15 00:34:25.000000', 'consum', 0.0216, 'lps'),
	(550458, 131, '2014-02-15 00:34:26.000000', 'consum', 0.0232, 'lps'),
	(550459, 131, '2014-02-15 00:34:27.000000', 'consum', 0.0218, 'lps'),
	(550460, 131, '2014-02-15 00:34:28.000000', 'consum', 0.0211, 'lps'),
	(550461, 131, '2014-02-15 00:34:29.000000', 'consum', 0.0220, 'lps'),
	(550462, 131, '2014-02-15 00:34:30.000000', 'consum', 0.0228, 'lps'),
	(550463, 131, '2014-02-15 00:34:31.000000', 'consum', 0.0217, 'lps'),
	(550464, 131, '2014-02-15 00:34:32.000000', 'consum', 0.0217, 'lps'),
	(550465, 131, '2014-02-15 00:34:33.000000', 'consum', 0.0224, 'lps'),
	(550466, 131, '2014-02-15 00:34:34.000000', 'consum', 0.0234, 'lps'),
	(550467, 131, '2014-02-15 00:34:35.000000', 'consum', 0.0232, 'lps'),
	(550468, 131, '2014-02-15 00:34:36.000000', 'consum', 0.0220, 'lps'),
	(550469, 131, '2014-02-15 00:34:37.000000', 'consum', 0.0224, 'lps'),
	(550470, 131, '2014-02-15 00:34:38.000000', 'consum', 0.0221, 'lps'),
	(550471, 131, '2014-02-15 00:34:39.000000', 'consum', 0.0226, 'lps'),
	(550472, 131, '2014-02-15 00:34:40.000000', 'consum', 0.0228, 'lps'),
	(550473, 131, '2014-02-15 00:34:41.000000', 'consum', 0.0223, 'lps'),
	(550474, 131, '2014-02-15 00:34:42.000000', 'consum', 0.0224, 'lps'),
	(550475, 131, '2014-02-15 00:34:43.000000', 'consum', 0.0215, 'lps'),
	(550476, 131, '2014-02-15 00:34:44.000000', 'consum', 0.0218, 'lps'),
	(550477, 131, '2014-02-15 00:34:45.000000', 'consum', 0.0237, 'lps'),
	(550478, 131, '2014-02-15 00:34:46.000000', 'consum', 0.0236, 'lps'),
	(550479, 131, '2014-02-15 00:34:47.000000', 'consum', 0.0231, 'lps'),
	(550480, 131, '2014-02-15 00:34:48.000000', 'consum', 0.0237, 'lps'),
	(550481, 131, '2014-02-15 00:34:49.000000', 'consum', 0.0226, 'lps'),
	(550482, 131, '2014-02-15 00:34:50.000000', 'consum', 0.0213, 'lps'),
	(550483, 131, '2014-02-15 00:34:51.000000', 'consum', 0.0230, 'lps'),
	(550484, 131, '2014-02-15 00:34:52.000000', 'consum', 0.0221, 'lps'),
	(550485, 131, '2014-02-15 00:34:53.000000', 'consum', 0.0230, 'lps'),
	(550486, 131, '2014-02-15 00:34:54.000000', 'consum', 0.0224, 'lps'),
	(550487, 131, '2014-02-15 00:34:55.000000', 'consum', 0.0220, 'lps'),
	(550488, 131, '2014-02-15 00:34:56.000000', 'consum', 0.0217, 'lps'),
	(550489, 131, '2014-02-15 00:34:57.000000', 'consum', 0.0216, 'lps'),
	(550490, 131, '2014-02-15 00:34:58.000000', 'consum', 0.0218, 'lps'),
	(550491, 131, '2014-02-15 00:34:59.000000', 'consum', 0.0234, 'lps'),
	(550492, 131, '2014-02-15 00:35:00.000000', 'consum', 0.0222, 'lps'),
	(550493, 131, '2014-02-15 00:35:01.000000', 'consum', 0.0227, 'lps'),
	(550494, 131, '2014-02-15 00:35:02.000000', 'consum', 0.0231, 'lps'),
	(550495, 131, '2014-02-15 00:35:03.000000', 'consum', 0.0237, 'lps'),
	(550496, 131, '2014-02-15 00:35:04.000000', 'consum', 0.0225, 'lps'),
	(550497, 131, '2014-02-15 00:35:05.000000', 'consum', 0.0231, 'lps'),
	(550498, 131, '2014-02-15 00:35:06.000000', 'consum', 0.0217, 'lps'),
	(550499, 131, '2014-02-15 00:35:07.000000', 'consum', 0.0212, 'lps'),
	(550500, 131, '2014-02-15 00:35:08.000000', 'consum', 0.0226, 'lps'),
	(550501, 131, '2014-02-15 00:35:09.000000', 'consum', 0.0227, 'lps'),
	(550502, 131, '2014-02-15 00:35:10.000000', 'consum', 0.0220, 'lps'),
	(550503, 131, '2014-02-15 00:35:11.000000', 'consum', 0.0210, 'lps'),
	(550504, 131, '2014-02-15 00:35:12.000000', 'consum', 0.0210, 'lps'),
	(550505, 131, '2014-02-15 00:35:13.000000', 'consum', 0.0237, 'lps'),
	(550506, 131, '2014-02-15 00:35:14.000000', 'consum', 0.0236, 'lps'),
	(550507, 131, '2014-02-15 00:35:15.000000', 'consum', 0.0228, 'lps'),
	(550508, 131, '2014-02-15 00:35:16.000000', 'consum', 0.0226, 'lps'),
	(550509, 131, '2014-02-15 00:35:17.000000', 'consum', 0.0235, 'lps'),
	(550510, 131, '2014-02-15 00:35:18.000000', 'consum', 0.0231, 'lps'),
	(550511, 131, '2014-02-15 00:35:19.000000', 'consum', 0.0212, 'lps'),
	(550512, 131, '2014-02-15 00:35:20.000000', 'consum', 0.0212, 'lps'),
	(550513, 131, '2014-02-15 00:35:21.000000', 'consum', 0.0216, 'lps'),
	(550514, 131, '2014-02-15 00:35:22.000000', 'consum', 0.0235, 'lps'),
	(550515, 131, '2014-02-15 00:35:23.000000', 'consum', 0.0234, 'lps'),
	(550516, 131, '2014-02-15 00:35:24.000000', 'consum', 0.0228, 'lps'),
	(550517, 131, '2014-02-15 00:35:25.000000', 'consum', 0.0226, 'lps'),
	(550518, 131, '2014-02-15 00:35:26.000000', 'consum', 0.0210, 'lps'),
	(550519, 131, '2014-02-15 00:35:27.000000', 'consum', 0.0217, 'lps'),
	(550520, 131, '2014-02-15 00:35:28.000000', 'consum', 0.0218, 'lps'),
	(550521, 131, '2014-02-15 00:35:29.000000', 'consum', 0.0228, 'lps'),
	(550522, 131, '2014-02-15 00:35:30.000000', 'consum', 0.0221, 'lps'),
	(550523, 131, '2014-02-15 00:35:31.000000', 'consum', 0.0214, 'lps'),
	(550524, 131, '2014-02-15 00:35:32.000000', 'consum', 0.0223, 'lps'),
	(550525, 131, '2014-02-15 00:35:33.000000', 'consum', 0.0210, 'lps'),
	(550526, 131, '2014-02-15 00:35:34.000000', 'consum', 0.0226, 'lps'),
	(550527, 131, '2014-02-15 00:35:35.000000', 'consum', 0.0235, 'lps'),
	(550528, 131, '2014-02-15 00:35:36.000000', 'consum', 0.0233, 'lps'),
	(550529, 131, '2014-02-15 00:35:37.000000', 'consum', 0.0222, 'lps'),
	(550530, 131, '2014-02-15 00:35:38.000000', 'consum', 0.0229, 'lps'),
	(550531, 131, '2014-02-15 00:35:39.000000', 'consum', 0.0216, 'lps'),
	(550532, 131, '2014-02-15 00:35:40.000000', 'consum', 0.0236, 'lps'),
	(550533, 131, '2014-02-15 00:35:41.000000', 'consum', 0.0211, 'lps'),
	(550534, 131, '2014-02-15 00:35:42.000000', 'consum', 0.0222, 'lps'),
	(550535, 131, '2014-02-15 00:35:43.000000', 'consum', 0.0237, 'lps'),
	(550536, 131, '2014-02-15 00:35:44.000000', 'consum', 0.0229, 'lps'),
	(550537, 131, '2014-02-15 00:35:45.000000', 'consum', 0.0223, 'lps'),
	(550538, 131, '2014-02-15 00:35:46.000000', 'consum', 0.0219, 'lps'),
	(550539, 131, '2014-02-15 00:35:47.000000', 'consum', 0.0218, 'lps'),
	(550540, 131, '2014-02-15 00:35:48.000000', 'consum', 0.0224, 'lps'),
	(550541, 131, '2014-02-15 00:35:49.000000', 'consum', 0.0228, 'lps'),
	(550542, 131, '2014-02-15 00:35:50.000000', 'consum', 0.0230, 'lps'),
	(550543, 131, '2014-02-15 00:35:51.000000', 'consum', 0.0227, 'lps'),
	(550544, 131, '2014-02-15 00:35:52.000000', 'consum', 0.0211, 'lps'),
	(550545, 131, '2014-02-15 00:35:53.000000', 'consum', 0.0217, 'lps'),
	(550546, 131, '2014-02-15 00:35:54.000000', 'consum', 0.0217, 'lps'),
	(550547, 131, '2014-02-15 00:35:55.000000', 'consum', 0.0223, 'lps'),
	(550548, 131, '2014-02-15 00:35:56.000000', 'consum', 0.0227, 'lps'),
	(550549, 131, '2014-02-15 00:35:57.000000', 'consum', 0.0228, 'lps'),
	(550550, 131, '2014-02-15 00:35:58.000000', 'consum', 0.0223, 'lps'),
	(550551, 131, '2014-02-15 00:35:59.000000', 'consum', 0.0220, 'lps'),
	(550552, 131, '2014-02-15 00:36:00.000000', 'consum', 0.0223, 'lps'),
	(550553, 131, '2014-02-15 00:36:01.000000', 'consum', 0.0215, 'lps'),
	(550554, 131, '2014-02-15 00:36:02.000000', 'consum', 0.0225, 'lps'),
	(550555, 131, '2014-02-15 00:36:03.000000', 'consum', 0.0215, 'lps'),
	(550556, 131, '2014-02-15 00:36:04.000000', 'consum', 0.0219, 'lps'),
	(550557, 131, '2014-02-15 00:36:05.000000', 'consum', 0.0213, 'lps'),
	(550558, 131, '2014-02-15 00:36:06.000000', 'consum', 0.0225, 'lps'),
	(550559, 131, '2014-02-15 00:36:07.000000', 'consum', 0.0221, 'lps'),
	(550560, 131, '2014-02-15 00:36:08.000000', 'consum', 0.0220, 'lps'),
	(550561, 131, '2014-02-15 00:36:09.000000', 'consum', 0.0228, 'lps'),
	(550562, 131, '2014-02-15 00:36:10.000000', 'consum', 0.0213, 'lps'),
	(550563, 131, '2014-02-15 00:36:11.000000', 'consum', 0.0230, 'lps'),
	(550564, 131, '2014-02-15 00:36:12.000000', 'consum', 0.0217, 'lps'),
	(550565, 131, '2014-02-15 00:36:13.000000', 'consum', 0.0215, 'lps'),
	(550566, 131, '2014-02-15 00:36:14.000000', 'consum', 0.0212, 'lps'),
	(550567, 131, '2014-02-15 00:36:15.000000', 'consum', 0.0232, 'lps'),
	(550568, 131, '2014-02-15 00:36:16.000000', 'consum', 0.0234, 'lps'),
	(550569, 131, '2014-02-15 00:36:17.000000', 'consum', 0.0234, 'lps'),
	(550570, 131, '2014-02-15 00:36:18.000000', 'consum', 0.0232, 'lps'),
	(550571, 131, '2014-02-15 00:36:19.000000', 'consum', 0.0220, 'lps'),
	(550572, 131, '2014-02-15 00:36:20.000000', 'consum', 0.0223, 'lps'),
	(550573, 131, '2014-02-15 00:36:21.000000', 'consum', 0.0216, 'lps'),
	(550574, 131, '2014-02-15 00:36:22.000000', 'consum', 0.0231, 'lps'),
	(550575, 131, '2014-02-15 00:36:23.000000', 'consum', 0.0213, 'lps'),
	(550576, 131, '2014-02-15 00:36:24.000000', 'consum', 0.0218, 'lps'),
	(550577, 131, '2014-02-15 00:36:25.000000', 'consum', 0.0213, 'lps'),
	(550578, 131, '2014-02-15 00:36:26.000000', 'consum', 0.0231, 'lps'),
	(550579, 131, '2014-02-15 00:36:27.000000', 'consum', 0.0223, 'lps'),
	(550580, 131, '2014-02-15 00:36:28.000000', 'consum', 0.0213, 'lps'),
	(550581, 131, '2014-02-15 00:36:29.000000', 'consum', 0.0212, 'lps'),
	(550582, 131, '2014-02-15 00:36:30.000000', 'consum', 0.0212, 'lps'),
	(550583, 131, '2014-02-15 00:36:31.000000', 'consum', 0.0214, 'lps'),
	(550584, 131, '2014-02-15 00:36:32.000000', 'consum', 0.0226, 'lps'),
	(550585, 131, '2014-02-15 00:36:33.000000', 'consum', 0.0221, 'lps'),
	(550586, 131, '2014-02-15 00:36:34.000000', 'consum', 0.0219, 'lps'),
	(550587, 131, '2014-02-15 00:36:35.000000', 'consum', 0.0222, 'lps'),
	(550588, 131, '2014-02-15 00:36:36.000000', 'consum', 0.0217, 'lps'),
	(550589, 131, '2014-02-15 00:36:37.000000', 'consum', 0.0210, 'lps'),
	(550590, 131, '2014-02-15 00:36:38.000000', 'consum', 0.0215, 'lps'),
	(550591, 131, '2014-02-15 00:36:39.000000', 'consum', 0.0237, 'lps'),
	(550592, 131, '2014-02-15 00:36:40.000000', 'consum', 0.0217, 'lps'),
	(550593, 131, '2014-02-15 00:36:41.000000', 'consum', 0.0219, 'lps'),
	(550594, 131, '2014-02-15 00:36:42.000000', 'consum', 0.0210, 'lps'),
	(550595, 131, '2014-02-15 00:36:43.000000', 'consum', 0.0210, 'lps'),
	(550596, 131, '2014-02-15 00:36:44.000000', 'consum', 0.0211, 'lps'),
	(550597, 131, '2014-02-15 00:36:45.000000', 'consum', 0.0215, 'lps'),
	(550598, 131, '2014-02-15 00:36:46.000000', 'consum', 0.0231, 'lps'),
	(550599, 131, '2014-02-15 00:36:47.000000', 'consum', 0.0217, 'lps'),
	(550600, 131, '2014-02-15 00:36:48.000000', 'consum', 0.0212, 'lps'),
	(550601, 131, '2014-02-15 00:36:49.000000', 'consum', 0.0228, 'lps'),
	(550602, 131, '2014-02-15 00:36:50.000000', 'consum', 0.0210, 'lps'),
	(550603, 131, '2014-02-15 00:36:51.000000', 'consum', 0.0212, 'lps'),
	(550604, 131, '2014-02-15 00:36:52.000000', 'consum', 0.0222, 'lps'),
	(550605, 131, '2014-02-15 00:36:53.000000', 'consum', 0.0234, 'lps'),
	(550606, 131, '2014-02-15 00:36:54.000000', 'consum', 0.0212, 'lps'),
	(550607, 131, '2014-02-15 00:36:55.000000', 'consum', 0.0234, 'lps'),
	(550608, 131, '2014-02-15 00:36:56.000000', 'consum', 0.0210, 'lps'),
	(550609, 131, '2014-02-15 00:36:57.000000', 'consum', 0.0222, 'lps'),
	(550610, 131, '2014-02-15 00:36:58.000000', 'consum', 0.0217, 'lps'),
	(550611, 131, '2014-02-15 00:36:59.000000', 'consum', 0.0210, 'lps'),
	(550612, 131, '2014-02-15 00:37:00.000000', 'consum', 0.0216, 'lps'),
	(550613, 131, '2014-02-15 00:37:01.000000', 'consum', 0.0212, 'lps'),
	(550614, 131, '2014-02-15 00:37:02.000000', 'consum', 0.0232, 'lps'),
	(550615, 131, '2014-02-15 00:37:03.000000', 'consum', 0.0228, 'lps'),
	(550616, 131, '2014-02-15 00:37:04.000000', 'consum', 0.0235, 'lps'),
	(550617, 131, '2014-02-15 00:37:05.000000', 'consum', 0.0228, 'lps'),
	(550618, 131, '2014-02-15 00:37:06.000000', 'consum', 0.0223, 'lps'),
	(550619, 131, '2014-02-15 00:37:07.000000', 'consum', 0.0222, 'lps'),
	(550620, 131, '2014-02-15 00:37:08.000000', 'consum', 0.0230, 'lps'),
	(550621, 131, '2014-02-15 00:37:09.000000', 'consum', 0.0219, 'lps'),
	(550622, 131, '2014-02-15 00:37:10.000000', 'consum', 0.0225, 'lps'),
	(550623, 131, '2014-02-15 00:37:11.000000', 'consum', 0.0229, 'lps'),
	(550624, 131, '2014-02-15 00:37:12.000000', 'consum', 0.0232, 'lps'),
	(550625, 131, '2014-02-15 00:37:13.000000', 'consum', 0.0237, 'lps'),
	(550626, 131, '2014-02-15 00:37:14.000000', 'consum', 0.0223, 'lps'),
	(550627, 131, '2014-02-15 00:37:15.000000', 'consum', 0.0223, 'lps'),
	(550628, 131, '2014-02-15 00:37:16.000000', 'consum', 0.0237, 'lps'),
	(550629, 131, '2014-02-15 00:37:17.000000', 'consum', 0.0223, 'lps'),
	(550630, 131, '2014-02-15 00:37:18.000000', 'consum', 0.0221, 'lps'),
	(550631, 131, '2014-02-15 00:37:19.000000', 'consum', 0.0226, 'lps'),
	(550632, 131, '2014-02-15 00:37:20.000000', 'consum', 0.0230, 'lps'),
	(550633, 131, '2014-02-15 00:37:21.000000', 'consum', 0.0234, 'lps'),
	(550634, 131, '2014-02-15 00:37:22.000000', 'consum', 0.0216, 'lps'),
	(550635, 131, '2014-02-15 00:37:23.000000', 'consum', 0.0223, 'lps'),
	(550636, 131, '2014-02-15 00:37:24.000000', 'consum', 0.0231, 'lps'),
	(550637, 131, '2014-02-15 00:37:25.000000', 'consum', 0.0220, 'lps'),
	(550638, 131, '2014-02-15 00:37:26.000000', 'consum', 0.0224, 'lps'),
	(550639, 131, '2014-02-15 00:37:27.000000', 'consum', 0.0224, 'lps'),
	(550640, 131, '2014-02-15 00:37:28.000000', 'consum', 0.0211, 'lps'),
	(550641, 131, '2014-02-15 00:37:29.000000', 'consum', 0.0229, 'lps'),
	(550642, 131, '2014-02-15 00:37:30.000000', 'consum', 0.0218, 'lps'),
	(550643, 131, '2014-02-15 00:37:31.000000', 'consum', 0.0223, 'lps'),
	(550644, 131, '2014-02-15 00:37:32.000000', 'consum', 0.0221, 'lps'),
	(550645, 131, '2014-02-15 00:37:33.000000', 'consum', 0.0228, 'lps'),
	(550646, 131, '2014-02-15 00:37:34.000000', 'consum', 0.0211, 'lps'),
	(550647, 131, '2014-02-15 00:37:35.000000', 'consum', 0.0218, 'lps'),
	(550648, 131, '2014-02-15 00:37:36.000000', 'consum', 0.0217, 'lps'),
	(550649, 131, '2014-02-15 00:37:37.000000', 'consum', 0.0224, 'lps'),
	(550650, 131, '2014-02-15 00:37:38.000000', 'consum', 0.0230, 'lps'),
	(550651, 131, '2014-02-15 00:37:39.000000', 'consum', 0.0212, 'lps'),
	(550652, 131, '2014-02-15 00:37:40.000000', 'consum', 0.0219, 'lps'),
	(550653, 131, '2014-02-15 00:37:41.000000', 'consum', 0.0220, 'lps'),
	(550654, 131, '2014-02-15 00:37:42.000000', 'consum', 0.0235, 'lps'),
	(550655, 131, '2014-02-15 00:37:43.000000', 'consum', 0.0219, 'lps'),
	(550656, 131, '2014-02-15 00:37:44.000000', 'consum', 0.0212, 'lps'),
	(550657, 131, '2014-02-15 00:37:45.000000', 'consum', 0.0219, 'lps'),
	(550658, 131, '2014-02-15 00:37:46.000000', 'consum', 0.0220, 'lps'),
	(550659, 131, '2014-02-15 00:37:47.000000', 'consum', 0.0235, 'lps'),
	(550660, 131, '2014-02-15 00:37:48.000000', 'consum', 0.0222, 'lps'),
	(550661, 131, '2014-02-15 00:37:49.000000', 'consum', 0.0223, 'lps'),
	(550662, 131, '2014-02-15 00:37:50.000000', 'consum', 0.0210, 'lps'),
	(550663, 131, '2014-02-15 00:37:51.000000', 'consum', 0.0228, 'lps'),
	(550664, 131, '2014-02-15 00:37:52.000000', 'consum', 0.0218, 'lps'),
	(550665, 131, '2014-02-15 00:37:53.000000', 'consum', 0.0223, 'lps'),
	(550666, 131, '2014-02-15 00:37:54.000000', 'consum', 0.0225, 'lps'),
	(550667, 131, '2014-02-15 00:37:55.000000', 'consum', 0.0217, 'lps'),
	(550668, 131, '2014-02-15 00:37:56.000000', 'consum', 0.0229, 'lps'),
	(550669, 131, '2014-02-15 00:37:57.000000', 'consum', 0.0230, 'lps'),
	(550670, 131, '2014-02-15 00:37:58.000000', 'consum', 0.0225, 'lps'),
	(550671, 131, '2014-02-15 00:37:59.000000', 'consum', 0.0224, 'lps'),
	(550672, 131, '2014-02-15 00:38:00.000000', 'consum', 0.0237, 'lps'),
	(550673, 131, '2014-02-15 00:38:01.000000', 'consum', 0.0220, 'lps'),
	(550674, 131, '2014-02-15 00:38:02.000000', 'consum', 0.0235, 'lps'),
	(550675, 131, '2014-02-15 00:38:03.000000', 'consum', 0.0221, 'lps'),
	(550676, 131, '2014-02-15 00:38:04.000000', 'consum', 0.0218, 'lps'),
	(550677, 131, '2014-02-15 00:38:05.000000', 'consum', 0.0219, 'lps'),
	(550678, 131, '2014-02-15 00:38:06.000000', 'consum', 0.0232, 'lps'),
	(550679, 131, '2014-02-15 00:38:07.000000', 'consum', 0.0211, 'lps'),
	(550680, 131, '2014-02-15 00:38:08.000000', 'consum', 0.0230, 'lps'),
	(550681, 131, '2014-02-15 00:38:09.000000', 'consum', 0.0224, 'lps'),
	(550682, 131, '2014-02-15 00:38:10.000000', 'consum', 0.0223, 'lps'),
	(550683, 131, '2014-02-15 00:38:11.000000', 'consum', 0.0233, 'lps'),
	(550684, 131, '2014-02-15 00:38:12.000000', 'consum', 0.0228, 'lps'),
	(550685, 131, '2014-02-15 00:38:13.000000', 'consum', 0.0233, 'lps'),
	(550686, 131, '2014-02-15 00:38:14.000000', 'consum', 0.0214, 'lps'),
	(550687, 131, '2014-02-15 00:38:15.000000', 'consum', 0.0219, 'lps'),
	(550688, 131, '2014-02-15 00:38:16.000000', 'consum', 0.0213, 'lps'),
	(550689, 131, '2014-02-15 00:38:17.000000', 'consum', 0.0229, 'lps'),
	(550690, 131, '2014-02-15 00:38:18.000000', 'consum', 0.0213, 'lps'),
	(550691, 131, '2014-02-15 00:38:19.000000', 'consum', 0.0222, 'lps'),
	(550692, 131, '2014-02-15 00:38:20.000000', 'consum', 0.0236, 'lps'),
	(550693, 131, '2014-02-15 00:38:21.000000', 'consum', 0.0219, 'lps'),
	(550694, 131, '2014-02-15 00:38:22.000000', 'consum', 0.0234, 'lps'),
	(550695, 131, '2014-02-15 00:38:23.000000', 'consum', 0.0219, 'lps'),
	(550696, 131, '2014-02-15 00:38:24.000000', 'consum', 0.0213, 'lps'),
	(550697, 131, '2014-02-15 00:38:25.000000', 'consum', 0.0227, 'lps'),
	(550698, 131, '2014-02-15 00:38:26.000000', 'consum', 0.0229, 'lps'),
	(550699, 131, '2014-02-15 00:38:27.000000', 'consum', 0.0226, 'lps'),
	(550700, 131, '2014-02-15 00:38:28.000000', 'consum', 0.0236, 'lps'),
	(550701, 131, '2014-02-15 00:38:29.000000', 'consum', 0.0236, 'lps'),
	(550702, 131, '2014-02-15 00:38:30.000000', 'consum', 0.0232, 'lps'),
	(550703, 131, '2014-02-15 00:38:31.000000', 'consum', 0.0216, 'lps'),
	(550704, 131, '2014-02-15 00:38:32.000000', 'consum', 0.0230, 'lps'),
	(550705, 131, '2014-02-15 00:38:33.000000', 'consum', 0.0237, 'lps'),
	(550706, 131, '2014-02-15 00:38:34.000000', 'consum', 0.0228, 'lps'),
	(550707, 131, '2014-02-15 00:38:35.000000', 'consum', 0.0220, 'lps'),
	(550708, 131, '2014-02-15 00:38:36.000000', 'consum', 0.0236, 'lps'),
	(550709, 131, '2014-02-15 00:38:37.000000', 'consum', 0.0224, 'lps'),
	(550710, 131, '2014-02-15 00:38:38.000000', 'consum', 0.0233, 'lps'),
	(550711, 131, '2014-02-15 00:38:39.000000', 'consum', 0.0228, 'lps'),
	(550712, 131, '2014-02-15 00:38:40.000000', 'consum', 0.0233, 'lps'),
	(550713, 131, '2014-02-15 00:38:41.000000', 'consum', 0.0212, 'lps'),
	(550714, 131, '2014-02-15 00:38:42.000000', 'consum', 0.0236, 'lps'),
	(550715, 131, '2014-02-15 00:38:43.000000', 'consum', 0.0222, 'lps'),
	(550716, 131, '2014-02-15 00:38:44.000000', 'consum', 0.0221, 'lps'),
	(550717, 131, '2014-02-15 00:38:45.000000', 'consum', 0.0228, 'lps'),
	(550718, 131, '2014-02-15 00:38:46.000000', 'consum', 0.0213, 'lps'),
	(550719, 131, '2014-02-15 00:38:47.000000', 'consum', 0.0228, 'lps'),
	(550720, 131, '2014-02-15 00:38:48.000000', 'consum', 0.0236, 'lps'),
	(550721, 131, '2014-02-15 00:38:49.000000', 'consum', 0.0231, 'lps'),
	(550722, 131, '2014-02-15 00:38:50.000000', 'consum', 0.0237, 'lps'),
	(550723, 131, '2014-02-15 00:38:51.000000', 'consum', 0.0226, 'lps'),
	(550724, 131, '2014-02-15 00:38:52.000000', 'consum', 0.0237, 'lps'),
	(550725, 131, '2014-02-15 00:38:53.000000', 'consum', 0.0216, 'lps'),
	(550726, 131, '2014-02-15 00:38:54.000000', 'consum', 0.0214, 'lps'),
	(550727, 131, '2014-02-15 00:38:55.000000', 'consum', 0.0213, 'lps'),
	(550728, 131, '2014-02-15 00:38:56.000000', 'consum', 0.0213, 'lps'),
	(550729, 131, '2014-02-15 00:38:57.000000', 'consum', 0.0218, 'lps'),
	(550730, 131, '2014-02-15 00:38:58.000000', 'consum', 0.0212, 'lps'),
	(550731, 131, '2014-02-15 00:38:59.000000', 'consum', 0.0224, 'lps'),
	(550732, 131, '2014-02-15 00:39:00.000000', 'consum', 0.0218, 'lps'),
	(550733, 131, '2014-02-15 00:39:01.000000', 'consum', 0.0210, 'lps'),
	(550734, 131, '2014-02-15 00:39:02.000000', 'consum', 0.0213, 'lps'),
	(550735, 131, '2014-02-15 00:39:03.000000', 'consum', 0.0225, 'lps'),
	(550736, 131, '2014-02-15 00:39:04.000000', 'consum', 0.0223, 'lps'),
	(550737, 131, '2014-02-15 00:39:05.000000', 'consum', 0.0229, 'lps'),
	(550738, 131, '2014-02-15 00:39:06.000000', 'consum', 0.0210, 'lps'),
	(550739, 131, '2014-02-15 00:39:07.000000', 'consum', 0.0236, 'lps'),
	(550740, 131, '2014-02-15 00:39:08.000000', 'consum', 0.0230, 'lps'),
	(550741, 131, '2014-02-15 00:39:09.000000', 'consum', 0.0235, 'lps'),
	(550742, 131, '2014-02-15 00:39:10.000000', 'consum', 0.0216, 'lps'),
	(550743, 131, '2014-02-15 00:39:11.000000', 'consum', 0.0221, 'lps'),
	(550744, 131, '2014-02-15 00:39:12.000000', 'consum', 0.0221, 'lps'),
	(550745, 131, '2014-02-15 00:39:13.000000', 'consum', 0.0232, 'lps'),
	(550746, 131, '2014-02-15 00:39:14.000000', 'consum', 0.0234, 'lps'),
	(550747, 131, '2014-02-15 00:39:15.000000', 'consum', 0.0233, 'lps'),
	(550748, 131, '2014-02-15 00:39:16.000000', 'consum', 0.0226, 'lps'),
	(550749, 131, '2014-02-15 00:39:17.000000', 'consum', 0.0222, 'lps'),
	(550750, 131, '2014-02-15 00:39:18.000000', 'consum', 0.0220, 'lps'),
	(550751, 131, '2014-02-15 00:39:19.000000', 'consum', 0.0228, 'lps'),
	(550752, 131, '2014-02-15 00:39:20.000000', 'consum', 0.0214, 'lps'),
	(550753, 131, '2014-02-15 00:39:21.000000', 'consum', 0.0232, 'lps'),
	(550754, 131, '2014-02-15 00:39:22.000000', 'consum', 0.0224, 'lps'),
	(550755, 131, '2014-02-15 00:39:23.000000', 'consum', 0.0214, 'lps'),
	(550756, 131, '2014-02-15 00:39:24.000000', 'consum', 0.0217, 'lps'),
	(550757, 131, '2014-02-15 00:39:25.000000', 'consum', 0.0233, 'lps'),
	(550758, 131, '2014-02-15 00:39:26.000000', 'consum', 0.0220, 'lps'),
	(550759, 131, '2014-02-15 00:39:27.000000', 'consum', 0.0218, 'lps'),
	(550760, 131, '2014-02-15 00:39:28.000000', 'consum', 0.0223, 'lps'),
	(550761, 131, '2014-02-15 00:39:29.000000', 'consum', 0.0224, 'lps'),
	(550762, 131, '2014-02-15 00:39:30.000000', 'consum', 0.0215, 'lps'),
	(550763, 131, '2014-02-15 00:39:31.000000', 'consum', 0.0219, 'lps'),
	(550764, 131, '2014-02-15 00:39:32.000000', 'consum', 0.0212, 'lps'),
	(550765, 131, '2014-02-15 00:39:33.000000', 'consum', 0.0224, 'lps'),
	(550766, 131, '2014-02-15 00:39:34.000000', 'consum', 0.0216, 'lps'),
	(550767, 131, '2014-02-15 00:39:35.000000', 'consum', 0.0226, 'lps'),
	(550768, 131, '2014-02-15 00:39:36.000000', 'consum', 0.0217, 'lps'),
	(550769, 131, '2014-02-15 00:39:37.000000', 'consum', 0.0225, 'lps'),
	(550770, 131, '2014-02-15 00:39:38.000000', 'consum', 0.0237, 'lps'),
	(550771, 131, '2014-02-15 00:39:39.000000', 'consum', 0.0217, 'lps'),
	(550772, 131, '2014-02-15 00:39:40.000000', 'consum', 0.0220, 'lps'),
	(550773, 131, '2014-02-15 00:39:41.000000', 'consum', 0.0210, 'lps'),
	(550774, 131, '2014-02-15 00:39:42.000000', 'consum', 0.0237, 'lps'),
	(550775, 131, '2014-02-15 00:39:43.000000', 'consum', 0.0234, 'lps'),
	(550776, 131, '2014-02-15 00:39:44.000000', 'consum', 0.0221, 'lps'),
	(550777, 131, '2014-02-15 00:39:45.000000', 'consum', 0.0224, 'lps'),
	(550778, 131, '2014-02-15 00:39:46.000000', 'consum', 0.0216, 'lps'),
	(550779, 131, '2014-02-15 00:39:47.000000', 'consum', 0.0227, 'lps'),
	(550780, 131, '2014-02-15 00:39:48.000000', 'consum', 0.0224, 'lps'),
	(550781, 131, '2014-02-15 00:39:49.000000', 'consum', 0.0227, 'lps'),
	(550782, 131, '2014-02-15 00:39:50.000000', 'consum', 0.0224, 'lps'),
	(550783, 131, '2014-02-15 00:39:51.000000', 'consum', 0.0232, 'lps'),
	(550784, 131, '2014-02-15 00:39:52.000000', 'consum', 0.0224, 'lps'),
	(550785, 131, '2014-02-15 00:39:53.000000', 'consum', 0.0211, 'lps'),
	(550786, 131, '2014-02-15 00:39:54.000000', 'consum', 0.0232, 'lps'),
	(550787, 131, '2014-02-15 00:39:55.000000', 'consum', 0.0231, 'lps'),
	(550788, 131, '2014-02-15 00:39:56.000000', 'consum', 0.0223, 'lps'),
	(550789, 131, '2014-02-15 00:39:57.000000', 'consum', 0.0214, 'lps'),
	(550790, 131, '2014-02-15 00:39:58.000000', 'consum', 0.0219, 'lps'),
	(550791, 131, '2014-02-15 00:39:59.000000', 'consum', 0.0216, 'lps'),
	(550792, 131, '2014-02-15 00:40:00.000000', 'consum', 0.0211, 'lps'),
	(550793, 131, '2014-02-15 00:40:01.000000', 'consum', 0.0228, 'lps'),
	(550794, 131, '2014-02-15 00:40:02.000000', 'consum', 0.0212, 'lps'),
	(550795, 131, '2014-02-15 00:40:03.000000', 'consum', 0.0223, 'lps'),
	(550796, 131, '2014-02-15 00:40:04.000000', 'consum', 0.0213, 'lps'),
	(550797, 131, '2014-02-15 00:40:05.000000', 'consum', 0.0214, 'lps'),
	(550798, 131, '2014-02-15 00:40:06.000000', 'consum', 0.0223, 'lps'),
	(550799, 131, '2014-02-15 00:40:07.000000', 'consum', 0.0236, 'lps'),
	(550800, 131, '2014-02-15 00:40:08.000000', 'consum', 0.0218, 'lps'),
	(550801, 131, '2014-02-15 00:40:09.000000', 'consum', 0.0228, 'lps'),
	(550802, 131, '2014-02-15 00:40:10.000000', 'consum', 0.0220, 'lps'),
	(550803, 131, '2014-02-15 00:40:11.000000', 'consum', 0.0235, 'lps'),
	(550804, 131, '2014-02-15 00:40:12.000000', 'consum', 0.0223, 'lps'),
	(550805, 131, '2014-02-15 00:40:13.000000', 'consum', 0.0228, 'lps'),
	(550806, 131, '2014-02-15 00:40:14.000000', 'consum', 0.0231, 'lps'),
	(550807, 131, '2014-02-15 00:40:15.000000', 'consum', 0.0236, 'lps'),
	(550808, 131, '2014-02-15 00:40:16.000000', 'consum', 0.0219, 'lps'),
	(550809, 131, '2014-02-15 00:40:17.000000', 'consum', 0.0235, 'lps'),
	(550810, 131, '2014-02-15 00:40:18.000000', 'consum', 0.0225, 'lps'),
	(550811, 131, '2014-02-15 00:40:19.000000', 'consum', 0.0210, 'lps'),
	(550812, 131, '2014-02-15 00:40:20.000000', 'consum', 0.0223, 'lps'),
	(550813, 131, '2014-02-15 00:40:21.000000', 'consum', 0.0216, 'lps'),
	(550814, 131, '2014-02-15 00:40:22.000000', 'consum', 0.0233, 'lps'),
	(550815, 131, '2014-02-15 00:40:23.000000', 'consum', 0.0223, 'lps'),
	(550816, 131, '2014-02-15 00:40:24.000000', 'consum', 0.0235, 'lps'),
	(550817, 131, '2014-02-15 00:40:25.000000', 'consum', 0.0211, 'lps'),
	(550818, 131, '2014-02-15 00:40:26.000000', 'consum', 0.0224, 'lps'),
	(550819, 131, '2014-02-15 00:40:27.000000', 'consum', 0.0224, 'lps'),
	(550820, 131, '2014-02-15 00:40:28.000000', 'consum', 0.0210, 'lps'),
	(550821, 131, '2014-02-15 00:40:29.000000', 'consum', 0.0226, 'lps'),
	(550822, 131, '2014-02-15 00:40:30.000000', 'consum', 0.0231, 'lps'),
	(550823, 131, '2014-02-15 00:40:31.000000', 'consum', 0.0213, 'lps'),
	(550824, 131, '2014-02-15 00:40:32.000000', 'consum', 0.0220, 'lps'),
	(550825, 131, '2014-02-15 00:40:33.000000', 'consum', 0.0221, 'lps'),
	(550826, 131, '2014-02-15 00:40:34.000000', 'consum', 0.0210, 'lps'),
	(550827, 131, '2014-02-15 00:40:35.000000', 'consum', 0.0231, 'lps'),
	(550828, 131, '2014-02-15 00:40:36.000000', 'consum', 0.0232, 'lps'),
	(550829, 131, '2014-02-15 00:40:37.000000', 'consum', 0.0231, 'lps'),
	(550830, 131, '2014-02-15 00:40:38.000000', 'consum', 0.0220, 'lps'),
	(550831, 131, '2014-02-15 00:40:39.000000', 'consum', 0.0225, 'lps'),
	(550832, 131, '2014-02-15 00:40:40.000000', 'consum', 0.0227, 'lps'),
	(550833, 131, '2014-02-15 00:40:41.000000', 'consum', 0.0225, 'lps'),
	(550834, 131, '2014-02-15 00:40:42.000000', 'consum', 0.0231, 'lps'),
	(550835, 131, '2014-02-15 00:40:43.000000', 'consum', 0.0218, 'lps'),
	(550836, 131, '2014-02-15 00:40:44.000000', 'consum', 0.0214, 'lps'),
	(550837, 131, '2014-02-15 00:40:45.000000', 'consum', 0.0233, 'lps'),
	(550838, 131, '2014-02-15 00:40:46.000000', 'consum', 0.0229, 'lps'),
	(550839, 131, '2014-02-15 00:40:47.000000', 'consum', 0.0210, 'lps'),
	(550840, 131, '2014-02-15 00:40:48.000000', 'consum', 0.0236, 'lps'),
	(550841, 131, '2014-02-15 00:40:49.000000', 'consum', 0.0228, 'lps'),
	(550842, 131, '2014-02-15 00:40:50.000000', 'consum', 0.0224, 'lps'),
	(550843, 131, '2014-02-15 00:40:51.000000', 'consum', 0.0228, 'lps'),
	(550844, 131, '2014-02-15 00:40:52.000000', 'consum', 0.0228, 'lps'),
	(550845, 131, '2014-02-15 00:40:53.000000', 'consum', 0.0219, 'lps'),
	(550846, 131, '2014-02-15 00:40:54.000000', 'consum', 0.0228, 'lps'),
	(550847, 131, '2014-02-15 00:40:55.000000', 'consum', 0.0218, 'lps'),
	(550848, 131, '2014-02-15 00:40:56.000000', 'consum', 0.0224, 'lps'),
	(550849, 131, '2014-02-15 00:40:57.000000', 'consum', 0.0231, 'lps'),
	(550850, 131, '2014-02-15 00:40:58.000000', 'consum', 0.0217, 'lps'),
	(550851, 131, '2014-02-15 00:40:59.000000', 'consum', 0.0237, 'lps'),
	(550852, 131, '2014-02-15 00:41:00.000000', 'consum', 0.0213, 'lps'),
	(550853, 131, '2014-02-15 00:41:01.000000', 'consum', 0.0229, 'lps'),
	(550854, 131, '2014-02-15 00:41:02.000000', 'consum', 0.0210, 'lps'),
	(550855, 131, '2014-02-15 00:41:03.000000', 'consum', 0.0212, 'lps'),
	(550856, 131, '2014-02-15 00:41:04.000000', 'consum', 0.0220, 'lps'),
	(550857, 131, '2014-02-15 00:41:05.000000', 'consum', 0.0226, 'lps'),
	(550858, 131, '2014-02-15 00:41:06.000000', 'consum', 0.0235, 'lps'),
	(550859, 131, '2014-02-15 00:41:07.000000', 'consum', 0.0230, 'lps'),
	(550860, 131, '2014-02-15 00:41:08.000000', 'consum', 0.0234, 'lps'),
	(550861, 131, '2014-02-15 00:41:09.000000', 'consum', 0.0214, 'lps'),
	(550862, 131, '2014-02-15 00:41:10.000000', 'consum', 0.0215, 'lps'),
	(550863, 131, '2014-02-15 00:41:11.000000', 'consum', 0.0224, 'lps'),
	(550864, 131, '2014-02-15 00:41:12.000000', 'consum', 0.0211, 'lps'),
	(550865, 131, '2014-02-15 00:41:13.000000', 'consum', 0.0230, 'lps'),
	(550866, 131, '2014-02-15 00:41:14.000000', 'consum', 0.0220, 'lps'),
	(550867, 131, '2014-02-15 00:41:15.000000', 'consum', 0.0232, 'lps'),
	(550868, 131, '2014-02-15 00:41:16.000000', 'consum', 0.0233, 'lps'),
	(550869, 131, '2014-02-15 00:41:17.000000', 'consum', 0.0232, 'lps'),
	(550870, 131, '2014-02-15 00:41:18.000000', 'consum', 0.0222, 'lps'),
	(550871, 131, '2014-02-15 00:41:19.000000', 'consum', 0.0233, 'lps'),
	(550872, 131, '2014-02-15 00:41:20.000000', 'consum', 0.0232, 'lps'),
	(550873, 131, '2014-02-15 00:41:21.000000', 'consum', 0.0224, 'lps'),
	(550874, 131, '2014-02-15 00:41:22.000000', 'consum', 0.0216, 'lps'),
	(550875, 131, '2014-02-15 00:41:23.000000', 'consum', 0.0227, 'lps'),
	(550876, 131, '2014-02-15 00:41:24.000000', 'consum', 0.0223, 'lps'),
	(550877, 131, '2014-02-15 00:41:25.000000', 'consum', 0.0221, 'lps'),
	(550878, 131, '2014-02-15 00:41:26.000000', 'consum', 0.0229, 'lps'),
	(550879, 131, '2014-02-15 00:41:27.000000', 'consum', 0.0217, 'lps'),
	(550880, 131, '2014-02-15 00:41:28.000000', 'consum', 0.0214, 'lps'),
	(550881, 131, '2014-02-15 00:41:29.000000', 'consum', 0.0213, 'lps'),
	(550882, 131, '2014-02-15 00:41:30.000000', 'consum', 0.0210, 'lps'),
	(550883, 131, '2014-02-15 00:41:31.000000', 'consum', 0.0232, 'lps'),
	(550884, 131, '2014-02-15 00:41:32.000000', 'consum', 0.0236, 'lps'),
	(550885, 131, '2014-02-15 00:41:33.000000', 'consum', 0.0218, 'lps'),
	(550886, 131, '2014-02-15 00:41:34.000000', 'consum', 0.0227, 'lps'),
	(550887, 131, '2014-02-15 00:41:35.000000', 'consum', 0.0216, 'lps'),
	(550888, 131, '2014-02-15 00:41:36.000000', 'consum', 0.0218, 'lps'),
	(550889, 131, '2014-02-15 00:41:37.000000', 'consum', 0.0233, 'lps'),
	(550890, 131, '2014-02-15 00:41:38.000000', 'consum', 0.0217, 'lps'),
	(550891, 131, '2014-02-15 00:41:39.000000', 'consum', 0.0233, 'lps'),
	(550892, 131, '2014-02-15 00:41:40.000000', 'consum', 0.0219, 'lps'),
	(550893, 131, '2014-02-15 00:41:41.000000', 'consum', 0.0213, 'lps'),
	(550894, 131, '2014-02-15 00:41:42.000000', 'consum', 0.0230, 'lps'),
	(550895, 131, '2014-02-15 00:41:43.000000', 'consum', 0.0217, 'lps'),
	(550896, 131, '2014-02-15 00:41:44.000000', 'consum', 0.0212, 'lps'),
	(550897, 131, '2014-02-15 00:41:45.000000', 'consum', 0.0230, 'lps'),
	(550898, 131, '2014-02-15 00:41:46.000000', 'consum', 0.0218, 'lps'),
	(550899, 131, '2014-02-15 00:41:47.000000', 'consum', 0.0218, 'lps'),
	(550900, 131, '2014-02-15 00:41:48.000000', 'consum', 0.0227, 'lps'),
	(550901, 131, '2014-02-15 00:41:49.000000', 'consum', 0.0214, 'lps'),
	(550902, 131, '2014-02-15 00:41:50.000000', 'consum', 0.0237, 'lps'),
	(550903, 131, '2014-02-15 00:41:51.000000', 'consum', 0.0222, 'lps'),
	(550904, 131, '2014-02-15 00:41:52.000000', 'consum', 0.0219, 'lps'),
	(550905, 131, '2014-02-15 00:41:53.000000', 'consum', 0.0217, 'lps'),
	(550906, 131, '2014-02-15 00:41:54.000000', 'consum', 0.0218, 'lps'),
	(550907, 131, '2014-02-15 00:41:55.000000', 'consum', 0.0232, 'lps'),
	(550908, 131, '2014-02-15 00:41:56.000000', 'consum', 0.0214, 'lps'),
	(550909, 131, '2014-02-15 00:41:57.000000', 'consum', 0.0217, 'lps'),
	(550910, 131, '2014-02-15 00:41:58.000000', 'consum', 0.0233, 'lps'),
	(550911, 131, '2014-02-15 00:41:59.000000', 'consum', 0.0221, 'lps'),
	(550912, 131, '2014-02-15 00:42:00.000000', 'consum', 0.0224, 'lps'),
	(550913, 131, '2014-02-15 00:42:01.000000', 'consum', 0.0221, 'lps'),
	(550914, 131, '2014-02-15 00:42:02.000000', 'consum', 0.0222, 'lps'),
	(550915, 131, '2014-02-15 00:42:03.000000', 'consum', 0.0237, 'lps'),
	(550916, 131, '2014-02-15 00:42:04.000000', 'consum', 0.0226, 'lps'),
	(550917, 131, '2014-02-15 00:42:05.000000', 'consum', 0.0210, 'lps'),
	(550918, 131, '2014-02-15 00:42:06.000000', 'consum', 0.0220, 'lps'),
	(550919, 131, '2014-02-15 00:42:07.000000', 'consum', 0.0231, 'lps'),
	(550920, 131, '2014-02-15 00:42:08.000000', 'consum', 0.0229, 'lps'),
	(550921, 131, '2014-02-15 00:42:09.000000', 'consum', 0.0216, 'lps'),
	(550922, 131, '2014-02-15 00:42:10.000000', 'consum', 0.0237, 'lps'),
	(550923, 131, '2014-02-15 00:42:11.000000', 'consum', 0.0218, 'lps'),
	(550924, 131, '2014-02-15 00:42:12.000000', 'consum', 0.0224, 'lps'),
	(550925, 131, '2014-02-15 00:42:13.000000', 'consum', 0.0229, 'lps'),
	(550926, 131, '2014-02-15 00:42:14.000000', 'consum', 0.0234, 'lps'),
	(550927, 131, '2014-02-15 00:42:15.000000', 'consum', 0.0217, 'lps'),
	(550928, 131, '2014-02-15 00:42:16.000000', 'consum', 0.0229, 'lps'),
	(550929, 131, '2014-02-15 00:42:17.000000', 'consum', 0.0229, 'lps'),
	(550930, 131, '2014-02-15 00:42:18.000000', 'consum', 0.0220, 'lps'),
	(550931, 131, '2014-02-15 00:42:19.000000', 'consum', 0.0234, 'lps'),
	(550932, 131, '2014-02-15 00:42:20.000000', 'consum', 0.0213, 'lps'),
	(550933, 131, '2014-02-15 00:42:21.000000', 'consum', 0.0213, 'lps'),
	(550934, 131, '2014-02-15 00:42:22.000000', 'consum', 0.0213, 'lps'),
	(550935, 131, '2014-02-15 00:42:23.000000', 'consum', 0.0219, 'lps'),
	(550936, 131, '2014-02-15 00:42:24.000000', 'consum', 0.0219, 'lps'),
	(550937, 131, '2014-02-15 00:42:25.000000', 'consum', 0.0229, 'lps'),
	(550938, 131, '2014-02-15 00:42:26.000000', 'consum', 0.0221, 'lps'),
	(550939, 131, '2014-02-15 00:42:27.000000', 'consum', 0.0235, 'lps'),
	(550940, 131, '2014-02-15 00:42:28.000000', 'consum', 0.0219, 'lps'),
	(550941, 131, '2014-02-15 00:42:29.000000', 'consum', 0.0210, 'lps'),
	(550942, 131, '2014-02-15 00:42:30.000000', 'consum', 0.0211, 'lps'),
	(550943, 131, '2014-02-15 00:42:31.000000', 'consum', 0.0214, 'lps'),
	(550944, 131, '2014-02-15 00:42:32.000000', 'consum', 0.0227, 'lps'),
	(550945, 131, '2014-02-15 00:42:33.000000', 'consum', 0.0227, 'lps'),
	(550946, 131, '2014-02-15 00:42:34.000000', 'consum', 0.0218, 'lps'),
	(550947, 131, '2014-02-15 00:42:35.000000', 'consum', 0.0226, 'lps'),
	(550948, 131, '2014-02-15 00:42:36.000000', 'consum', 0.0212, 'lps'),
	(550949, 131, '2014-02-15 00:42:37.000000', 'consum', 0.0228, 'lps'),
	(550950, 131, '2014-02-15 00:42:38.000000', 'consum', 0.0211, 'lps'),
	(550951, 131, '2014-02-15 00:42:39.000000', 'consum', 0.0216, 'lps'),
	(550952, 131, '2014-02-15 00:42:40.000000', 'consum', 0.0210, 'lps'),
	(550953, 131, '2014-02-15 00:42:41.000000', 'consum', 0.0222, 'lps'),
	(550954, 131, '2014-02-15 00:42:42.000000', 'consum', 0.0212, 'lps'),
	(550955, 131, '2014-02-15 00:42:43.000000', 'consum', 0.0212, 'lps'),
	(550956, 131, '2014-02-15 00:42:44.000000', 'consum', 0.0214, 'lps'),
	(550957, 131, '2014-02-15 00:42:45.000000', 'consum', 0.0227, 'lps'),
	(550958, 131, '2014-02-15 00:42:46.000000', 'consum', 0.0228, 'lps'),
	(550959, 131, '2014-02-15 00:42:47.000000', 'consum', 0.0222, 'lps'),
	(550960, 131, '2014-02-15 00:42:48.000000', 'consum', 0.0217, 'lps'),
	(550961, 131, '2014-02-15 00:42:49.000000', 'consum', 0.0236, 'lps'),
	(550962, 131, '2014-02-15 00:42:50.000000', 'consum', 0.0210, 'lps'),
	(550963, 131, '2014-02-15 00:42:51.000000', 'consum', 0.0214, 'lps'),
	(550964, 131, '2014-02-15 00:42:52.000000', 'consum', 0.0230, 'lps'),
	(550965, 131, '2014-02-15 00:42:53.000000', 'consum', 0.0215, 'lps'),
	(550966, 131, '2014-02-15 00:42:54.000000', 'consum', 0.0230, 'lps'),
	(550967, 131, '2014-02-15 00:42:55.000000', 'consum', 0.0213, 'lps'),
	(550968, 131, '2014-02-15 00:42:56.000000', 'consum', 0.0223, 'lps'),
	(550969, 131, '2014-02-15 00:42:57.000000', 'consum', 0.0236, 'lps'),
	(550970, 131, '2014-02-15 00:42:58.000000', 'consum', 0.0218, 'lps'),
	(550971, 131, '2014-02-15 00:42:59.000000', 'consum', 0.0227, 'lps'),
	(550972, 131, '2014-02-15 00:43:00.000000', 'consum', 0.0218, 'lps'),
	(550973, 131, '2014-02-15 00:43:01.000000', 'consum', 0.0228, 'lps'),
	(550974, 131, '2014-02-15 00:43:02.000000', 'consum', 0.0218, 'lps'),
	(550975, 131, '2014-02-15 00:43:03.000000', 'consum', 0.0227, 'lps'),
	(550976, 131, '2014-02-15 00:43:04.000000', 'consum', 0.0217, 'lps'),
	(550977, 131, '2014-02-15 00:43:05.000000', 'consum', 0.0219, 'lps'),
	(550978, 131, '2014-02-15 00:43:06.000000', 'consum', 0.0236, 'lps'),
	(550979, 131, '2014-02-15 00:43:07.000000', 'consum', 0.0230, 'lps'),
	(550980, 131, '2014-02-15 00:43:08.000000', 'consum', 0.0233, 'lps'),
	(550981, 131, '2014-02-15 00:43:09.000000', 'consum', 0.0235, 'lps'),
	(550982, 131, '2014-02-15 00:43:10.000000', 'consum', 0.0212, 'lps'),
	(550983, 131, '2014-02-15 00:43:11.000000', 'consum', 0.0228, 'lps'),
	(550984, 131, '2014-02-15 00:43:12.000000', 'consum', 0.0212, 'lps'),
	(550985, 131, '2014-02-15 00:43:13.000000', 'consum', 0.0221, 'lps'),
	(550986, 131, '2014-02-15 00:43:14.000000', 'consum', 0.0231, 'lps'),
	(550987, 131, '2014-02-15 00:43:15.000000', 'consum', 0.0227, 'lps'),
	(550988, 131, '2014-02-15 00:43:16.000000', 'consum', 0.0233, 'lps'),
	(550989, 131, '2014-02-15 00:43:17.000000', 'consum', 0.0220, 'lps'),
	(550990, 131, '2014-02-15 00:43:18.000000', 'consum', 0.0219, 'lps'),
	(550991, 131, '2014-02-15 00:43:19.000000', 'consum', 0.0226, 'lps'),
	(550992, 131, '2014-02-15 00:43:20.000000', 'consum', 0.0237, 'lps'),
	(550993, 131, '2014-02-15 00:43:21.000000', 'consum', 0.0212, 'lps'),
	(550994, 131, '2014-02-15 00:43:22.000000', 'consum', 0.0222, 'lps'),
	(550995, 131, '2014-02-15 00:43:23.000000', 'consum', 0.0237, 'lps'),
	(550996, 131, '2014-02-15 00:43:24.000000', 'consum', 0.0225, 'lps'),
	(550997, 131, '2014-02-15 00:43:25.000000', 'consum', 0.0232, 'lps'),
	(550998, 131, '2014-02-15 00:43:26.000000', 'consum', 0.0220, 'lps'),
	(550999, 131, '2014-02-15 00:43:27.000000', 'consum', 0.0221, 'lps'),
	(551000, 131, '2014-02-15 00:43:28.000000', 'consum', 0.0237, 'lps'),
	(551001, 131, '2014-02-15 00:43:29.000000', 'consum', 0.0228, 'lps'),
	(551002, 131, '2014-02-15 00:43:30.000000', 'consum', 0.0218, 'lps'),
	(551003, 131, '2014-02-15 00:43:31.000000', 'consum', 0.0224, 'lps'),
	(551004, 131, '2014-02-15 00:43:32.000000', 'consum', 0.0231, 'lps'),
	(551005, 131, '2014-02-15 00:43:33.000000', 'consum', 0.0217, 'lps'),
	(551006, 131, '2014-02-15 00:43:34.000000', 'consum', 0.0236, 'lps'),
	(551007, 131, '2014-02-15 00:43:35.000000', 'consum', 0.0210, 'lps'),
	(551008, 131, '2014-02-15 00:43:36.000000', 'consum', 0.0214, 'lps'),
	(551009, 131, '2014-02-15 00:43:37.000000', 'consum', 0.0232, 'lps'),
	(551010, 131, '2014-02-15 00:43:38.000000', 'consum', 0.0223, 'lps'),
	(551011, 131, '2014-02-15 00:43:39.000000', 'consum', 0.0210, 'lps'),
	(551012, 131, '2014-02-15 00:43:40.000000', 'consum', 0.0226, 'lps'),
	(551013, 131, '2014-02-15 00:43:41.000000', 'consum', 0.0235, 'lps'),
	(551014, 131, '2014-02-15 00:43:42.000000', 'consum', 0.0234, 'lps'),
	(551015, 131, '2014-02-15 00:43:43.000000', 'consum', 0.0227, 'lps'),
	(551016, 131, '2014-02-15 00:43:44.000000', 'consum', 0.0221, 'lps'),
	(551017, 131, '2014-02-15 00:43:45.000000', 'consum', 0.0217, 'lps'),
	(551018, 131, '2014-02-15 00:43:46.000000', 'consum', 0.0211, 'lps'),
	(551019, 131, '2014-02-15 00:43:47.000000', 'consum', 0.0222, 'lps'),
	(551020, 131, '2014-02-15 00:43:48.000000', 'consum', 0.0213, 'lps'),
	(551021, 131, '2014-02-15 00:43:49.000000', 'consum', 0.0219, 'lps'),
	(551022, 131, '2014-02-15 00:43:50.000000', 'consum', 0.0216, 'lps'),
	(551023, 131, '2014-02-15 00:43:51.000000', 'consum', 0.0213, 'lps'),
	(551024, 131, '2014-02-15 00:43:52.000000', 'consum', 0.0237, 'lps'),
	(551025, 131, '2014-02-15 00:43:53.000000', 'consum', 0.0223, 'lps'),
	(551026, 131, '2014-02-15 00:43:54.000000', 'consum', 0.0223, 'lps'),
	(551027, 131, '2014-02-15 00:43:55.000000', 'consum', 0.0237, 'lps'),
	(551028, 131, '2014-02-15 00:43:56.000000', 'consum', 0.0220, 'lps'),
	(551029, 131, '2014-02-15 00:43:57.000000', 'consum', 0.0210, 'lps'),
	(551030, 131, '2014-02-15 00:43:58.000000', 'consum', 0.0235, 'lps'),
	(551031, 131, '2014-02-15 00:43:59.000000', 'consum', 0.0222, 'lps'),
	(551032, 131, '2014-02-15 00:44:00.000000', 'consum', 0.0225, 'lps'),
	(551033, 131, '2014-02-15 00:44:01.000000', 'consum', 0.0223, 'lps'),
	(551034, 131, '2014-02-15 00:44:02.000000', 'consum', 0.0231, 'lps'),
	(551035, 131, '2014-02-15 00:44:03.000000', 'consum', 0.0219, 'lps'),
	(551036, 131, '2014-02-15 00:44:04.000000', 'consum', 0.0220, 'lps'),
	(551037, 131, '2014-02-15 00:44:05.000000', 'consum', 0.0236, 'lps'),
	(551038, 131, '2014-02-15 00:44:06.000000', 'consum', 0.0223, 'lps'),
	(551039, 131, '2014-02-15 00:44:07.000000', 'consum', 0.0228, 'lps'),
	(551040, 131, '2014-02-15 00:44:08.000000', 'consum', 0.0235, 'lps'),
	(551041, 131, '2014-02-15 00:44:09.000000', 'consum', 0.0222, 'lps'),
	(551042, 131, '2014-02-15 00:44:10.000000', 'consum', 0.0227, 'lps'),
	(551043, 131, '2014-02-15 00:44:11.000000', 'consum', 0.0228, 'lps'),
	(551044, 131, '2014-02-15 00:44:12.000000', 'consum', 0.0224, 'lps'),
	(551045, 131, '2014-02-15 00:44:13.000000', 'consum', 0.0225, 'lps'),
	(551046, 131, '2014-02-15 00:44:14.000000', 'consum', 0.0215, 'lps'),
	(551047, 131, '2014-02-15 00:44:15.000000', 'consum', 0.0218, 'lps'),
	(551048, 131, '2014-02-15 00:44:16.000000', 'consum', 0.0237, 'lps'),
	(551049, 131, '2014-02-15 00:44:17.000000', 'consum', 0.0236, 'lps'),
	(551050, 131, '2014-02-15 00:44:18.000000', 'consum', 0.0232, 'lps'),
	(551051, 131, '2014-02-15 00:44:19.000000', 'consum', 0.0215, 'lps'),
	(551052, 131, '2014-02-15 00:44:20.000000', 'consum', 0.0223, 'lps'),
	(551053, 131, '2014-02-15 00:44:21.000000', 'consum', 0.0235, 'lps'),
	(551054, 131, '2014-02-15 00:44:22.000000', 'consum', 0.0211, 'lps'),
	(551055, 131, '2014-02-15 00:44:23.000000', 'consum', 0.0227, 'lps'),
	(551056, 131, '2014-02-15 00:44:24.000000', 'consum', 0.0234, 'lps'),
	(551057, 131, '2014-02-15 00:44:25.000000', 'consum', 0.0223, 'lps'),
	(551058, 131, '2014-02-15 00:44:26.000000', 'consum', 0.0234, 'lps'),
	(551059, 131, '2014-02-15 00:44:27.000000', 'consum', 0.0235, 'lps'),
	(551060, 131, '2014-02-15 00:44:28.000000', 'consum', 0.0235, 'lps'),
	(551061, 131, '2014-02-15 00:44:29.000000', 'consum', 0.0233, 'lps'),
	(551062, 131, '2014-02-15 00:44:30.000000', 'consum', 0.0224, 'lps'),
	(551063, 131, '2014-02-15 00:44:31.000000', 'consum', 0.0211, 'lps'),
	(551064, 131, '2014-02-15 00:44:32.000000', 'consum', 0.0228, 'lps'),
	(551065, 131, '2014-02-15 00:44:33.000000', 'consum', 0.0216, 'lps'),
	(551066, 131, '2014-02-15 00:44:34.000000', 'consum', 0.0213, 'lps'),
	(551067, 131, '2014-02-15 00:44:35.000000', 'consum', 0.0236, 'lps'),
	(551068, 131, '2014-02-15 00:44:36.000000', 'consum', 0.0219, 'lps'),
	(551069, 131, '2014-02-15 00:44:37.000000', 'consum', 0.0236, 'lps'),
	(551070, 131, '2014-02-15 00:44:38.000000', 'consum', 0.0226, 'lps'),
	(551071, 131, '2014-02-15 00:44:39.000000', 'consum', 0.0213, 'lps'),
	(551072, 131, '2014-02-15 00:44:40.000000', 'consum', 0.0234, 'lps'),
	(551073, 131, '2014-02-15 00:44:41.000000', 'consum', 0.0211, 'lps'),
	(551074, 131, '2014-02-15 00:44:42.000000', 'consum', 0.0226, 'lps'),
	(551075, 131, '2014-02-15 00:44:43.000000', 'consum', 0.0234, 'lps'),
	(551076, 131, '2014-02-15 00:44:44.000000', 'consum', 0.0224, 'lps'),
	(551077, 131, '2014-02-15 00:44:45.000000', 'consum', 0.0235, 'lps'),
	(551078, 131, '2014-02-15 00:44:46.000000', 'consum', 0.0213, 'lps'),
	(551079, 131, '2014-02-15 00:44:47.000000', 'consum', 0.0233, 'lps'),
	(551080, 131, '2014-02-15 00:44:48.000000', 'consum', 0.0232, 'lps'),
	(551081, 131, '2014-02-15 00:44:49.000000', 'consum', 0.0224, 'lps'),
	(551082, 131, '2014-02-15 00:44:50.000000', 'consum', 0.0214, 'lps'),
	(551083, 131, '2014-02-15 00:44:51.000000', 'consum', 0.0217, 'lps'),
	(551084, 131, '2014-02-15 00:44:52.000000', 'consum', 0.0232, 'lps'),
	(551085, 131, '2014-02-15 00:44:53.000000', 'consum', 0.0216, 'lps'),
	(551086, 131, '2014-02-15 00:44:54.000000', 'consum', 0.0230, 'lps'),
	(551087, 131, '2014-02-15 00:44:55.000000', 'consum', 0.0237, 'lps'),
	(551088, 131, '2014-02-15 00:44:56.000000', 'consum', 0.0231, 'lps'),
	(551089, 131, '2014-02-15 00:44:57.000000', 'consum', 0.0235, 'lps'),
	(551090, 131, '2014-02-15 00:44:58.000000', 'consum', 0.0217, 'lps'),
	(551091, 131, '2014-02-15 00:44:59.000000', 'consum', 0.0228, 'lps'),
	(551092, 131, '2014-02-15 00:45:00.000000', 'consum', 0.0220, 'lps'),
	(551093, 131, '2014-02-15 00:45:01.000000', 'consum', 0.0234, 'lps'),
	(551094, 131, '2014-02-15 00:45:02.000000', 'consum', 0.0219, 'lps'),
	(551095, 131, '2014-02-15 00:45:03.000000', 'consum', 0.0210, 'lps'),
	(551096, 131, '2014-02-15 00:45:04.000000', 'consum', 0.0214, 'lps'),
	(551097, 131, '2014-02-15 00:45:05.000000', 'consum', 0.0228, 'lps'),
	(551098, 131, '2014-02-15 00:45:06.000000', 'consum', 0.0231, 'lps'),
	(551099, 131, '2014-02-15 00:45:07.000000', 'consum', 0.0237, 'lps'),
	(551100, 131, '2014-02-15 00:45:08.000000', 'consum', 0.0224, 'lps'),
	(551101, 131, '2014-02-15 00:45:09.000000', 'consum', 0.0228, 'lps'),
	(551102, 131, '2014-02-15 00:45:10.000000', 'consum', 0.0229, 'lps'),
	(551103, 131, '2014-02-15 00:45:11.000000', 'consum', 0.0226, 'lps'),
	(551104, 131, '2014-02-15 00:45:12.000000', 'consum', 0.0234, 'lps'),
	(551105, 131, '2014-02-15 00:45:13.000000', 'consum', 0.0225, 'lps'),
	(551106, 131, '2014-02-15 00:45:14.000000', 'consum', 0.0216, 'lps'),
	(551107, 131, '2014-02-15 00:45:15.000000', 'consum', 0.0221, 'lps'),
	(551108, 131, '2014-02-15 00:45:16.000000', 'consum', 0.0220, 'lps'),
	(551109, 131, '2014-02-15 00:45:17.000000', 'consum', 0.0228, 'lps'),
	(551110, 131, '2014-02-15 00:45:18.000000', 'consum', 0.0213, 'lps'),
	(551111, 131, '2014-02-15 00:45:19.000000', 'consum', 0.0227, 'lps'),
	(551112, 131, '2014-02-15 00:45:20.000000', 'consum', 0.0232, 'lps'),
	(551113, 131, '2014-02-15 00:45:21.000000', 'consum', 0.0213, 'lps'),
	(551114, 131, '2014-02-15 00:45:22.000000', 'consum', 0.0215, 'lps'),
	(551115, 131, '2014-02-15 00:45:23.000000', 'consum', 0.0226, 'lps'),
	(551116, 131, '2014-02-15 00:45:24.000000', 'consum', 0.0219, 'lps'),
	(551117, 131, '2014-02-15 00:45:25.000000', 'consum', 0.0237, 'lps'),
	(551118, 131, '2014-02-15 00:45:26.000000', 'consum', 0.0233, 'lps'),
	(551119, 131, '2014-02-15 00:45:27.000000', 'consum', 0.0215, 'lps'),
	(551120, 131, '2014-02-15 00:45:28.000000', 'consum', 0.0226, 'lps'),
	(551121, 131, '2014-02-15 00:45:29.000000', 'consum', 0.0217, 'lps'),
	(551122, 131, '2014-02-15 00:45:30.000000', 'consum', 0.0226, 'lps'),
	(551123, 131, '2014-02-15 00:45:31.000000', 'consum', 0.0215, 'lps'),
	(551124, 131, '2014-02-15 00:45:32.000000', 'consum', 0.0215, 'lps'),
	(551125, 131, '2014-02-15 00:45:33.000000', 'consum', 0.0221, 'lps'),
	(551126, 131, '2014-02-15 00:45:34.000000', 'consum', 0.0223, 'lps'),
	(551127, 131, '2014-02-15 00:45:35.000000', 'consum', 0.0213, 'lps'),
	(551128, 131, '2014-02-15 00:45:36.000000', 'consum', 0.0217, 'lps'),
	(551129, 131, '2014-02-15 00:45:37.000000', 'consum', 0.0233, 'lps'),
	(551130, 131, '2014-02-15 00:45:38.000000', 'consum', 0.0222, 'lps'),
	(551131, 131, '2014-02-15 00:45:39.000000', 'consum', 0.0231, 'lps'),
	(551132, 131, '2014-02-15 00:45:40.000000', 'consum', 0.0224, 'lps'),
	(551133, 131, '2014-02-15 00:45:41.000000', 'consum', 0.0217, 'lps'),
	(551134, 131, '2014-02-15 00:45:42.000000', 'consum', 0.0230, 'lps'),
	(551135, 131, '2014-02-15 00:45:43.000000', 'consum', 0.0234, 'lps'),
	(551136, 131, '2014-02-15 00:45:44.000000', 'consum', 0.0214, 'lps'),
	(551137, 131, '2014-02-15 00:45:45.000000', 'consum', 0.0214, 'lps'),
	(551138, 131, '2014-02-15 00:45:46.000000', 'consum', 0.0217, 'lps'),
	(551139, 131, '2014-02-15 00:45:47.000000', 'consum', 0.0236, 'lps'),
	(551140, 131, '2014-02-15 00:45:48.000000', 'consum', 0.0235, 'lps'),
	(551141, 131, '2014-02-15 00:45:49.000000', 'consum', 0.0230, 'lps'),
	(551142, 131, '2014-02-15 00:45:50.000000', 'consum', 0.0234, 'lps'),
	(551143, 131, '2014-02-15 00:45:51.000000', 'consum', 0.0216, 'lps'),
	(551144, 131, '2014-02-15 00:45:52.000000', 'consum', 0.0226, 'lps'),
	(551145, 131, '2014-02-15 00:45:53.000000', 'consum', 0.0214, 'lps'),
	(551146, 131, '2014-02-15 00:45:54.000000', 'consum', 0.0212, 'lps'),
	(551147, 131, '2014-02-15 00:45:55.000000', 'consum', 0.0210, 'lps'),
	(551148, 131, '2014-02-15 00:45:56.000000', 'consum', 0.0229, 'lps'),
	(551149, 131, '2014-02-15 00:45:57.000000', 'consum', 0.0225, 'lps'),
	(551150, 131, '2014-02-15 00:45:58.000000', 'consum', 0.0226, 'lps'),
	(551151, 131, '2014-02-15 00:45:59.000000', 'consum', 0.0219, 'lps'),
	(551152, 131, '2014-02-15 00:46:00.000000', 'consum', 0.0237, 'lps'),
	(551153, 131, '2014-02-15 00:46:01.000000', 'consum', 0.0233, 'lps'),
	(551154, 131, '2014-02-15 00:46:02.000000', 'consum', 0.0218, 'lps'),
	(551155, 131, '2014-02-15 00:46:03.000000', 'consum', 0.0235, 'lps'),
	(551156, 131, '2014-02-15 00:46:04.000000', 'consum', 0.0229, 'lps'),
	(551157, 131, '2014-02-15 00:46:05.000000', 'consum', 0.0230, 'lps'),
	(551158, 131, '2014-02-15 00:46:06.000000', 'consum', 0.0225, 'lps'),
	(551159, 131, '2014-02-15 00:46:07.000000', 'consum', 0.0226, 'lps'),
	(551160, 131, '2014-02-15 00:46:08.000000', 'consum', 0.0216, 'lps'),
	(551161, 131, '2014-02-15 00:46:09.000000', 'consum', 0.0220, 'lps'),
	(551162, 131, '2014-02-15 00:46:10.000000', 'consum', 0.0214, 'lps'),
	(551163, 131, '2014-02-15 00:46:11.000000', 'consum', 0.0229, 'lps'),
	(551164, 131, '2014-02-15 00:46:12.000000', 'consum', 0.0210, 'lps'),
	(551165, 131, '2014-02-15 00:46:13.000000', 'consum', 0.0210, 'lps'),
	(551166, 131, '2014-02-15 00:46:14.000000', 'consum', 0.0237, 'lps'),
	(551167, 131, '2014-02-15 00:46:15.000000', 'consum', 0.0232, 'lps'),
	(551168, 131, '2014-02-15 00:46:16.000000', 'consum', 0.0214, 'lps'),
	(551169, 131, '2014-02-15 00:46:17.000000', 'consum', 0.0221, 'lps'),
	(551170, 131, '2014-02-15 00:46:18.000000', 'consum', 0.0224, 'lps'),
	(551171, 131, '2014-02-15 00:46:19.000000', 'consum', 0.0219, 'lps'),
	(551172, 131, '2014-02-15 00:46:20.000000', 'consum', 0.0216, 'lps'),
	(551173, 131, '2014-02-15 00:46:21.000000', 'consum', 0.0213, 'lps'),
	(551174, 131, '2014-02-15 00:46:22.000000', 'consum', 0.0236, 'lps'),
	(551175, 131, '2014-02-15 00:46:23.000000', 'consum', 0.0219, 'lps'),
	(551176, 131, '2014-02-15 00:46:24.000000', 'consum', 0.0234, 'lps'),
	(551177, 131, '2014-02-15 00:46:25.000000', 'consum', 0.0219, 'lps'),
	(551178, 131, '2014-02-15 00:46:26.000000', 'consum', 0.0212, 'lps'),
	(551179, 131, '2014-02-15 00:46:27.000000', 'consum', 0.0220, 'lps'),
	(551180, 131, '2014-02-15 00:46:28.000000', 'consum', 0.0229, 'lps'),
	(551181, 131, '2014-02-15 00:46:29.000000', 'consum', 0.0217, 'lps'),
	(551182, 131, '2014-02-15 00:46:30.000000', 'consum', 0.0219, 'lps'),
	(551183, 131, '2014-02-15 00:46:31.000000', 'consum', 0.0234, 'lps'),
	(551184, 131, '2014-02-15 00:46:32.000000', 'consum', 0.0220, 'lps'),
	(551185, 131, '2014-02-15 00:46:33.000000', 'consum', 0.0214, 'lps'),
	(551186, 131, '2014-02-15 00:46:34.000000', 'consum', 0.0229, 'lps'),
	(551187, 131, '2014-02-15 00:46:35.000000', 'consum', 0.0210, 'lps'),
	(551188, 131, '2014-02-15 00:46:36.000000', 'consum', 0.0211, 'lps'),
	(551189, 131, '2014-02-15 00:46:37.000000', 'consum', 0.0212, 'lps'),
	(551190, 131, '2014-02-15 00:46:38.000000', 'consum', 0.0221, 'lps'),
	(551191, 131, '2014-02-15 00:46:39.000000', 'consum', 0.0230, 'lps'),
	(551192, 131, '2014-02-15 00:46:40.000000', 'consum', 0.0224, 'lps'),
	(551193, 131, '2014-02-15 00:46:41.000000', 'consum', 0.0218, 'lps'),
	(551194, 131, '2014-02-15 00:46:42.000000', 'consum', 0.0235, 'lps'),
	(551195, 131, '2014-02-15 00:46:43.000000', 'consum', 0.0229, 'lps'),
	(551196, 131, '2014-02-15 00:46:44.000000', 'consum', 0.0231, 'lps'),
	(551197, 131, '2014-02-15 00:46:45.000000', 'consum', 0.0229, 'lps'),
	(551198, 131, '2014-02-15 00:46:46.000000', 'consum', 0.0216, 'lps'),
	(551199, 131, '2014-02-15 00:46:47.000000', 'consum', 0.0211, 'lps'),
	(551200, 131, '2014-02-15 00:46:48.000000', 'consum', 0.0224, 'lps'),
	(551201, 131, '2014-02-15 00:46:49.000000', 'consum', 0.0223, 'lps'),
	(551202, 131, '2014-02-15 00:46:50.000000', 'consum', 0.0234, 'lps'),
	(551203, 131, '2014-02-15 00:46:51.000000', 'consum', 0.0235, 'lps'),
	(551204, 131, '2014-02-15 00:46:52.000000', 'consum', 0.0237, 'lps'),
	(551205, 131, '2014-02-15 00:46:53.000000', 'consum', 0.0215, 'lps'),
	(551206, 131, '2014-02-15 00:46:54.000000', 'consum', 0.0211, 'lps'),
	(551207, 131, '2014-02-15 00:46:55.000000', 'consum', 0.0226, 'lps'),
	(551208, 131, '2014-02-15 00:46:56.000000', 'consum', 0.0233, 'lps'),
	(551209, 131, '2014-02-15 00:46:57.000000', 'consum', 0.0223, 'lps'),
	(551210, 131, '2014-02-15 00:46:58.000000', 'consum', 0.0234, 'lps'),
	(551211, 131, '2014-02-15 00:46:59.000000', 'consum', 0.0237, 'lps'),
	(551212, 131, '2014-02-15 00:47:00.000000', 'consum', 0.0214, 'lps'),
	(551213, 131, '2014-02-15 00:47:01.000000', 'consum', 0.0235, 'lps'),
	(551214, 131, '2014-02-15 00:47:02.000000', 'consum', 0.0212, 'lps'),
	(551215, 131, '2014-02-15 00:47:03.000000', 'consum', 0.0228, 'lps'),
	(551216, 131, '2014-02-15 00:47:04.000000', 'consum', 0.0211, 'lps'),
	(551217, 131, '2014-02-15 00:47:05.000000', 'consum', 0.0219, 'lps'),
	(551218, 131, '2014-02-15 00:47:06.000000', 'consum', 0.0226, 'lps'),
	(551219, 131, '2014-02-15 00:47:07.000000', 'consum', 0.0232, 'lps'),
	(551220, 131, '2014-02-15 00:47:08.000000', 'consum', 0.0217, 'lps'),
	(551221, 131, '2014-02-15 00:47:09.000000', 'consum', 0.0210, 'lps'),
	(551222, 131, '2014-02-15 00:47:10.000000', 'consum', 0.0215, 'lps'),
	(551223, 131, '2014-02-15 00:47:11.000000', 'consum', 0.0235, 'lps'),
	(551224, 131, '2014-02-15 00:47:12.000000', 'consum', 0.0237, 'lps'),
	(551225, 131, '2014-02-15 00:47:13.000000', 'consum', 0.0217, 'lps'),
	(551226, 131, '2014-02-15 00:47:14.000000', 'consum', 0.0217, 'lps'),
	(551227, 131, '2014-02-15 00:47:15.000000', 'consum', 0.0227, 'lps'),
	(551228, 131, '2014-02-15 00:47:16.000000', 'consum', 0.0219, 'lps'),
	(551229, 131, '2014-02-15 00:47:17.000000', 'consum', 0.0230, 'lps'),
	(551230, 131, '2014-02-15 00:47:18.000000', 'consum', 0.0230, 'lps'),
	(551231, 131, '2014-02-15 00:47:19.000000', 'consum', 0.0223, 'lps'),
	(551232, 131, '2014-02-15 00:47:20.000000', 'consum', 0.0214, 'lps'),
	(551233, 131, '2014-02-15 00:47:21.000000', 'consum', 0.0218, 'lps'),
	(551234, 131, '2014-02-15 00:47:22.000000', 'consum', 0.0211, 'lps'),
	(551235, 131, '2014-02-15 00:47:23.000000', 'consum', 0.0222, 'lps'),
	(551236, 131, '2014-02-15 00:47:24.000000', 'consum', 0.0237, 'lps'),
	(551237, 131, '2014-02-15 00:47:25.000000', 'consum', 0.0224, 'lps'),
	(551238, 131, '2014-02-15 00:47:26.000000', 'consum', 0.0231, 'lps'),
	(551239, 131, '2014-02-15 00:47:27.000000', 'consum', 0.0216, 'lps'),
	(551240, 131, '2014-02-15 00:47:28.000000', 'consum', 0.0235, 'lps'),
	(551241, 131, '2014-02-15 00:47:29.000000', 'consum', 0.0234, 'lps'),
	(551242, 131, '2014-02-15 00:47:30.000000', 'consum', 0.0225, 'lps'),
	(551243, 131, '2014-02-15 00:47:31.000000', 'consum', 0.0215, 'lps'),
	(551244, 131, '2014-02-15 00:47:32.000000', 'consum', 0.0216, 'lps'),
	(551245, 131, '2014-02-15 00:47:33.000000', 'consum', 0.0228, 'lps'),
	(551246, 131, '2014-02-15 00:47:34.000000', 'consum', 0.0226, 'lps'),
	(551247, 131, '2014-02-15 00:47:35.000000', 'consum', 0.0236, 'lps'),
	(551248, 131, '2014-02-15 00:47:36.000000', 'consum', 0.0237, 'lps'),
	(551249, 131, '2014-02-15 00:47:37.000000', 'consum', 0.0211, 'lps'),
	(551250, 131, '2014-02-15 00:47:38.000000', 'consum', 0.0217, 'lps'),
	(551251, 131, '2014-02-15 00:47:39.000000', 'consum', 0.0216, 'lps'),
	(551252, 131, '2014-02-15 00:47:40.000000', 'consum', 0.0218, 'lps'),
	(551253, 131, '2014-02-15 00:47:41.000000', 'consum', 0.0233, 'lps'),
	(551254, 131, '2014-02-15 00:47:42.000000', 'consum', 0.0219, 'lps'),
	(551255, 131, '2014-02-15 00:47:43.000000', 'consum', 0.0215, 'lps'),
	(551256, 131, '2014-02-15 00:47:44.000000', 'consum', 0.0236, 'lps'),
	(551257, 131, '2014-02-15 00:47:45.000000', 'consum', 0.0214, 'lps'),
	(551258, 131, '2014-02-15 00:47:46.000000', 'consum', 0.0236, 'lps'),
	(551259, 131, '2014-02-15 00:47:47.000000', 'consum', 0.0217, 'lps'),
	(551260, 131, '2014-02-15 00:47:48.000000', 'consum', 0.0222, 'lps'),
	(551261, 131, '2014-02-15 00:47:49.000000', 'consum', 0.0224, 'lps'),
	(551262, 131, '2014-02-15 00:47:50.000000', 'consum', 0.0217, 'lps'),
	(551263, 131, '2014-02-15 00:47:51.000000', 'consum', 0.0230, 'lps'),
	(551264, 131, '2014-02-15 00:47:52.000000', 'consum', 0.0233, 'lps'),
	(551265, 131, '2014-02-15 00:47:53.000000', 'consum', 0.0237, 'lps'),
	(551266, 131, '2014-02-15 00:47:54.000000', 'consum', 0.0221, 'lps'),
	(551267, 131, '2014-02-15 00:47:55.000000', 'consum', 0.0211, 'lps'),
	(551268, 131, '2014-02-15 00:47:56.000000', 'consum', 0.0210, 'lps'),
	(551269, 131, '2014-02-15 00:47:57.000000', 'consum', 0.0211, 'lps'),
	(551270, 131, '2014-02-15 00:47:58.000000', 'consum', 0.0212, 'lps'),
	(551271, 131, '2014-02-15 00:47:59.000000', 'consum', 0.0219, 'lps'),
	(551272, 131, '2014-02-15 00:48:00.000000', 'consum', 0.0219, 'lps'),
	(551273, 131, '2014-02-15 00:48:01.000000', 'consum', 0.0232, 'lps'),
	(551274, 131, '2014-02-15 00:48:02.000000', 'consum', 0.0236, 'lps'),
	(551275, 131, '2014-02-15 00:48:03.000000', 'consum', 0.0217, 'lps'),
	(551276, 131, '2014-02-15 00:48:04.000000', 'consum', 0.0225, 'lps'),
	(551277, 131, '2014-02-15 00:48:05.000000', 'consum', 0.0236, 'lps'),
	(551278, 131, '2014-02-15 00:48:06.000000', 'consum', 0.0212, 'lps'),
	(551279, 131, '2014-02-15 00:48:07.000000', 'consum', 0.0225, 'lps'),
	(551280, 131, '2014-02-15 00:48:08.000000', 'consum', 0.0223, 'lps'),
	(551281, 131, '2014-02-15 00:48:09.000000', 'consum', 0.0233, 'lps'),
	(551282, 131, '2014-02-15 00:48:10.000000', 'consum', 0.0228, 'lps'),
	(551283, 131, '2014-02-15 00:48:11.000000', 'consum', 0.0232, 'lps'),
	(551284, 131, '2014-02-15 00:48:12.000000', 'consum', 0.0211, 'lps'),
	(551285, 131, '2014-02-15 00:48:13.000000', 'consum', 0.0233, 'lps'),
	(551286, 131, '2014-02-15 00:48:14.000000', 'consum', 0.0210, 'lps'),
	(551287, 131, '2014-02-15 00:48:15.000000', 'consum', 0.0224, 'lps'),
	(551288, 131, '2014-02-15 00:48:16.000000', 'consum', 0.0226, 'lps'),
	(551289, 131, '2014-02-15 00:48:17.000000', 'consum', 0.0219, 'lps'),
	(551290, 131, '2014-02-15 00:48:18.000000', 'consum', 0.0236, 'lps'),
	(551291, 131, '2014-02-15 00:48:19.000000', 'consum', 0.0230, 'lps'),
	(551292, 131, '2014-02-15 00:48:20.000000', 'consum', 0.0234, 'lps'),
	(551293, 131, '2014-02-15 00:48:21.000000', 'consum', 0.0214, 'lps'),
	(551294, 131, '2014-02-15 00:48:22.000000', 'consum', 0.0214, 'lps'),
	(551295, 131, '2014-02-15 00:48:23.000000', 'consum', 0.0219, 'lps'),
	(551296, 131, '2014-02-15 00:48:24.000000', 'consum', 0.0214, 'lps'),
	(551297, 131, '2014-02-15 00:48:25.000000', 'consum', 0.0234, 'lps'),
	(551298, 131, '2014-02-15 00:48:26.000000', 'consum', 0.0234, 'lps'),
	(551299, 131, '2014-02-15 00:48:27.000000', 'consum', 0.0229, 'lps'),
	(551300, 131, '2014-02-15 00:48:28.000000', 'consum', 0.0233, 'lps'),
	(551301, 131, '2014-02-15 00:48:29.000000', 'consum', 0.0213, 'lps'),
	(551302, 131, '2014-02-15 00:48:30.000000', 'consum', 0.0213, 'lps'),
	(551303, 131, '2014-02-15 00:48:31.000000', 'consum', 0.0215, 'lps'),
	(551304, 131, '2014-02-15 00:48:32.000000', 'consum', 0.0225, 'lps'),
	(551305, 131, '2014-02-15 00:48:33.000000', 'consum', 0.0218, 'lps'),
	(551306, 131, '2014-02-15 00:48:34.000000', 'consum', 0.0231, 'lps'),
	(551307, 131, '2014-02-15 00:48:35.000000', 'consum', 0.0235, 'lps'),
	(551308, 131, '2014-02-15 00:48:36.000000', 'consum', 0.0216, 'lps'),
	(551309, 131, '2014-02-15 00:48:37.000000', 'consum', 0.0223, 'lps'),
	(551310, 131, '2014-02-15 00:48:38.000000', 'consum', 0.0230, 'lps'),
	(551311, 131, '2014-02-15 00:48:39.000000', 'consum', 0.0215, 'lps'),
	(551312, 131, '2014-02-15 00:48:40.000000', 'consum', 0.0230, 'lps'),
	(551313, 131, '2014-02-15 00:48:41.000000', 'consum', 0.0212, 'lps'),
	(551314, 131, '2014-02-15 00:48:42.000000', 'consum', 0.0219, 'lps'),
	(551315, 131, '2014-02-15 00:48:43.000000', 'consum', 0.0220, 'lps'),
	(551316, 131, '2014-02-15 00:48:44.000000', 'consum', 0.0232, 'lps'),
	(551317, 131, '2014-02-15 00:48:45.000000', 'consum', 0.0235, 'lps'),
	(551318, 131, '2014-02-15 00:48:46.000000', 'consum', 0.0213, 'lps'),
	(551319, 131, '2014-02-15 00:48:47.000000', 'consum', 0.0234, 'lps'),
	(551320, 131, '2014-02-15 00:48:48.000000', 'consum', 0.0212, 'lps'),
	(551321, 131, '2014-02-15 00:48:49.000000', 'consum', 0.0231, 'lps'),
	(551322, 131, '2014-02-15 00:48:50.000000', 'consum', 0.0228, 'lps'),
	(551323, 131, '2014-02-15 00:48:51.000000', 'consum', 0.0235, 'lps'),
	(551324, 131, '2014-02-15 00:48:52.000000', 'consum', 0.0225, 'lps'),
	(551325, 131, '2014-02-15 00:48:53.000000', 'consum', 0.0211, 'lps'),
	(551326, 131, '2014-02-15 00:48:54.000000', 'consum', 0.0227, 'lps'),
	(551327, 131, '2014-02-15 00:48:55.000000', 'consum', 0.0210, 'lps'),
	(551328, 131, '2014-02-15 00:48:56.000000', 'consum', 0.0213, 'lps'),
	(551329, 131, '2014-02-15 00:48:57.000000', 'consum', 0.0224, 'lps'),
	(551330, 131, '2014-02-15 00:48:58.000000', 'consum', 0.0218, 'lps'),
	(551331, 131, '2014-02-15 00:48:59.000000', 'consum', 0.0210, 'lps'),
	(551332, 131, '2014-02-15 00:49:00.000000', 'consum', 0.0211, 'lps'),
	(551333, 131, '2014-02-15 00:49:01.000000', 'consum', 0.0217, 'lps'),
	(551334, 131, '2014-02-15 00:49:02.000000', 'consum', 0.0213, 'lps'),
	(551335, 131, '2014-02-15 00:49:03.000000', 'consum', 0.0232, 'lps'),
	(551336, 131, '2014-02-15 00:49:04.000000', 'consum', 0.0227, 'lps'),
	(551337, 131, '2014-02-15 00:49:05.000000', 'consum', 0.0231, 'lps'),
	(551338, 131, '2014-02-15 00:49:06.000000', 'consum', 0.0237, 'lps'),
	(551339, 131, '2014-02-15 00:49:07.000000', 'consum', 0.0225, 'lps'),
	(551340, 131, '2014-02-15 00:49:08.000000', 'consum', 0.0234, 'lps'),
	(551341, 131, '2014-02-15 00:49:09.000000', 'consum', 0.0227, 'lps'),
	(551342, 131, '2014-02-15 00:49:10.000000', 'consum', 0.0224, 'lps'),
	(551343, 131, '2014-02-15 00:49:11.000000', 'consum', 0.0232, 'lps'),
	(551344, 131, '2014-02-15 00:49:12.000000', 'consum', 0.0221, 'lps'),
	(551345, 131, '2014-02-15 00:49:13.000000', 'consum', 0.0228, 'lps'),
	(551346, 131, '2014-02-15 00:49:14.000000', 'consum', 0.0210, 'lps'),
	(551347, 131, '2014-02-15 00:49:15.000000', 'consum', 0.0213, 'lps'),
	(551348, 131, '2014-02-15 00:49:16.000000', 'consum', 0.0224, 'lps'),
	(551349, 131, '2014-02-15 00:49:17.000000', 'consum', 0.0216, 'lps'),
	(551350, 131, '2014-02-15 00:49:18.000000', 'consum', 0.0227, 'lps'),
	(551351, 131, '2014-02-15 00:49:19.000000', 'consum', 0.0223, 'lps'),
	(551352, 131, '2014-02-15 00:49:20.000000', 'consum', 0.0224, 'lps'),
	(551353, 131, '2014-02-15 00:49:21.000000', 'consum', 0.0215, 'lps'),
	(551354, 131, '2014-02-15 00:49:22.000000', 'consum', 0.0220, 'lps'),
	(551355, 131, '2014-02-15 00:49:23.000000', 'consum', 0.0219, 'lps'),
	(551356, 131, '2014-02-15 00:49:24.000000', 'consum', 0.0223, 'lps'),
	(551357, 131, '2014-02-15 00:49:25.000000', 'consum', 0.0220, 'lps'),
	(551358, 131, '2014-02-15 00:49:26.000000', 'consum', 0.0224, 'lps'),
	(551359, 131, '2014-02-15 00:49:27.000000', 'consum', 0.0222, 'lps'),
	(551360, 131, '2014-02-15 00:49:28.000000', 'consum', 0.0229, 'lps'),
	(551361, 131, '2014-02-15 00:49:29.000000', 'consum', 0.0211, 'lps'),
	(551362, 131, '2014-02-15 00:49:30.000000', 'consum', 0.0216, 'lps'),
	(551363, 131, '2014-02-15 00:49:31.000000', 'consum', 0.0235, 'lps'),
	(551364, 131, '2014-02-15 00:49:32.000000', 'consum', 0.0237, 'lps'),
	(551365, 131, '2014-02-15 00:49:33.000000', 'consum', 0.0211, 'lps'),
	(551366, 131, '2014-02-15 00:49:34.000000', 'consum', 0.0220, 'lps'),
	(551367, 131, '2014-02-15 00:49:35.000000', 'consum', 0.0231, 'lps'),
	(551368, 131, '2014-02-15 00:49:36.000000', 'consum', 0.0229, 'lps'),
	(551369, 131, '2014-02-15 00:49:37.000000', 'consum', 0.0216, 'lps'),
	(551370, 131, '2014-02-15 00:49:38.000000', 'consum', 0.0210, 'lps'),
	(551371, 131, '2014-02-15 00:49:39.000000', 'consum', 0.0221, 'lps'),
	(551372, 131, '2014-02-15 00:49:40.000000', 'consum', 0.0237, 'lps'),
	(551373, 131, '2014-02-15 00:49:41.000000', 'consum', 0.0227, 'lps'),
	(551374, 131, '2014-02-15 00:49:42.000000', 'consum', 0.0216, 'lps'),
	(551375, 131, '2014-02-15 00:49:43.000000', 'consum', 0.0219, 'lps'),
	(551376, 131, '2014-02-15 00:49:44.000000', 'consum', 0.0236, 'lps'),
	(551377, 131, '2014-02-15 00:49:45.000000', 'consum', 0.0231, 'lps'),
	(551378, 131, '2014-02-15 00:49:46.000000', 'consum', 0.0237, 'lps'),
	(551379, 131, '2014-02-15 00:49:47.000000', 'consum', 0.0226, 'lps'),
	(551380, 131, '2014-02-15 00:49:48.000000', 'consum', 0.0211, 'lps'),
	(551381, 131, '2014-02-15 00:49:49.000000', 'consum', 0.0222, 'lps'),
	(551382, 131, '2014-02-15 00:49:50.000000', 'consum', 0.0213, 'lps'),
	(551383, 131, '2014-02-15 00:49:51.000000', 'consum', 0.0216, 'lps'),
	(551384, 131, '2014-02-15 00:49:52.000000', 'consum', 0.0231, 'lps'),
	(551385, 131, '2014-02-15 00:49:53.000000', 'consum', 0.0213, 'lps'),
	(551386, 131, '2014-02-15 00:49:54.000000', 'consum', 0.0220, 'lps'),
	(551387, 131, '2014-02-15 00:49:55.000000', 'consum', 0.0223, 'lps'),
	(551388, 131, '2014-02-15 00:49:56.000000', 'consum', 0.0217, 'lps'),
	(551389, 131, '2014-02-15 00:49:57.000000', 'consum', 0.0233, 'lps'),
	(551390, 131, '2014-02-15 00:49:58.000000', 'consum', 0.0224, 'lps'),
	(551391, 131, '2014-02-15 00:49:59.000000', 'consum', 0.0237, 'lps'),
	(551392, 131, '2014-02-15 00:50:00.000000', 'consum', 0.0221, 'lps'),
	(551393, 131, '2014-02-15 00:50:01.000000', 'consum', 0.0212, 'lps'),
	(551394, 131, '2014-02-15 00:50:02.000000', 'consum', 0.0214, 'lps'),
	(551395, 131, '2014-02-15 00:50:03.000000', 'consum', 0.0227, 'lps'),
	(551396, 131, '2014-02-15 00:50:04.000000', 'consum', 0.0228, 'lps'),
	(551397, 131, '2014-02-15 00:50:05.000000', 'consum', 0.0222, 'lps'),
	(551398, 131, '2014-02-15 00:50:06.000000', 'consum', 0.0217, 'lps'),
	(551399, 131, '2014-02-15 00:50:07.000000', 'consum', 0.0234, 'lps'),
	(551400, 131, '2014-02-15 00:50:08.000000', 'consum', 0.0229, 'lps'),
	(551401, 131, '2014-02-15 00:50:09.000000', 'consum', 0.0230, 'lps'),
	(551402, 131, '2014-02-15 00:50:10.000000', 'consum', 0.0227, 'lps'),
	(551403, 131, '2014-02-15 00:50:11.000000', 'consum', 0.0237, 'lps'),
	(551404, 131, '2014-02-15 00:50:12.000000', 'consum', 0.0210, 'lps'),
	(551405, 131, '2014-02-15 00:50:13.000000', 'consum', 0.0212, 'lps'),
	(551406, 131, '2014-02-15 00:50:14.000000', 'consum', 0.0222, 'lps'),
	(551407, 131, '2014-02-15 00:50:15.000000', 'consum', 0.0210, 'lps'),
	(551408, 131, '2014-02-15 00:50:16.000000', 'consum', 0.0228, 'lps'),
	(551409, 131, '2014-02-15 00:50:17.000000', 'consum', 0.0218, 'lps'),
	(551410, 131, '2014-02-15 00:50:18.000000', 'consum', 0.0226, 'lps'),
	(551411, 131, '2014-02-15 00:50:19.000000', 'consum', 0.0235, 'lps'),
	(551412, 131, '2014-02-15 00:50:20.000000', 'consum', 0.0235, 'lps'),
	(551413, 131, '2014-02-15 00:50:21.000000', 'consum', 0.0231, 'lps'),
	(551414, 131, '2014-02-15 00:50:22.000000', 'consum', 0.0213, 'lps'),
	(551415, 131, '2014-02-15 00:50:23.000000', 'consum', 0.0220, 'lps'),
	(551416, 131, '2014-02-15 00:50:24.000000', 'consum', 0.0224, 'lps'),
	(551417, 131, '2014-02-15 00:50:25.000000', 'consum', 0.0219, 'lps'),
	(551418, 131, '2014-02-15 00:50:26.000000', 'consum', 0.0217, 'lps'),
	(551419, 131, '2014-02-15 00:50:27.000000', 'consum', 0.0216, 'lps'),
	(551420, 131, '2014-02-15 00:50:28.000000', 'consum', 0.0221, 'lps'),
	(551421, 131, '2014-02-15 00:50:29.000000', 'consum', 0.0219, 'lps'),
	(551422, 131, '2014-02-15 00:50:30.000000', 'consum', 0.0224, 'lps'),
	(551423, 131, '2014-02-15 00:50:31.000000', 'consum', 0.0226, 'lps'),
	(551424, 131, '2014-02-15 00:50:32.000000', 'consum', 0.0220, 'lps'),
	(551425, 131, '2014-02-15 00:50:33.000000', 'consum', 0.0212, 'lps'),
	(551426, 131, '2014-02-15 00:50:34.000000', 'consum', 0.0218, 'lps'),
	(551427, 131, '2014-02-15 00:50:35.000000', 'consum', 0.0215, 'lps'),
	(551428, 131, '2014-02-15 00:50:36.000000', 'consum', 0.0214, 'lps'),
	(551429, 131, '2014-02-15 00:50:37.000000', 'consum', 0.0216, 'lps'),
	(551430, 131, '2014-02-15 00:50:38.000000', 'consum', 0.0227, 'lps'),
	(551431, 131, '2014-02-15 00:50:39.000000', 'consum', 0.0223, 'lps'),
	(551432, 131, '2014-02-15 00:50:40.000000', 'consum', 0.0226, 'lps'),
	(551433, 131, '2014-02-15 00:50:41.000000', 'consum', 0.0220, 'lps'),
	(551434, 131, '2014-02-15 00:50:42.000000', 'consum', 0.0213, 'lps'),
	(551435, 131, '2014-02-15 00:50:43.000000', 'consum', 0.0226, 'lps'),
	(551436, 131, '2014-02-15 00:50:44.000000', 'consum', 0.0224, 'lps'),
	(551437, 131, '2014-02-15 00:50:45.000000', 'consum', 0.0232, 'lps'),
	(551438, 131, '2014-02-15 00:50:46.000000', 'consum', 0.0221, 'lps'),
	(551439, 131, '2014-02-15 00:50:47.000000', 'consum', 0.0231, 'lps'),
	(551440, 131, '2014-02-15 00:50:48.000000', 'consum', 0.0223, 'lps'),
	(551441, 131, '2014-02-15 00:50:49.000000', 'consum', 0.0215, 'lps'),
	(551442, 131, '2014-02-15 00:50:50.000000', 'consum', 0.0224, 'lps'),
	(551443, 131, '2014-02-15 00:50:51.000000', 'consum', 0.0211, 'lps'),
	(551444, 131, '2014-02-15 00:50:52.000000', 'consum', 0.0228, 'lps'),
	(551445, 131, '2014-02-15 00:50:53.000000', 'consum', 0.0214, 'lps'),
	(551446, 131, '2014-02-15 00:50:54.000000', 'consum', 0.0233, 'lps'),
	(551447, 131, '2014-02-15 00:50:55.000000', 'consum', 0.0229, 'lps'),
	(551448, 131, '2014-02-15 00:50:56.000000', 'consum', 0.0210, 'lps'),
	(551449, 131, '2014-02-15 00:50:57.000000', 'consum', 0.0236, 'lps'),
	(551450, 131, '2014-02-15 00:50:58.000000', 'consum', 0.0229, 'lps'),
	(551451, 131, '2014-02-15 00:50:59.000000', 'consum', 0.0226, 'lps'),
	(551452, 131, '2014-02-15 00:51:00.000000', 'consum', 0.0235, 'lps'),
	(551453, 131, '2014-02-15 00:51:01.000000', 'consum', 0.0231, 'lps'),
	(551454, 131, '2014-02-15 00:51:02.000000', 'consum', 0.0214, 'lps'),
	(551455, 131, '2014-02-15 00:51:03.000000', 'consum', 0.0224, 'lps'),
	(551456, 131, '2014-02-15 00:51:04.000000', 'consum', 0.0210, 'lps'),
	(551457, 131, '2014-02-15 00:51:05.000000', 'consum', 0.0227, 'lps'),
	(551458, 131, '2014-02-15 00:51:06.000000', 'consum', 0.0237, 'lps'),
	(551459, 131, '2014-02-15 00:51:07.000000', 'consum', 0.0212, 'lps'),
	(551460, 131, '2014-02-15 00:51:08.000000', 'consum', 0.0225, 'lps'),
	(551461, 131, '2014-02-15 00:51:09.000000', 'consum', 0.0221, 'lps'),
	(551462, 131, '2014-02-15 00:51:10.000000', 'consum', 0.0220, 'lps'),
	(551463, 131, '2014-02-15 00:51:11.000000', 'consum', 0.0231, 'lps'),
	(551464, 131, '2014-02-15 00:51:12.000000', 'consum', 0.0226, 'lps'),
	(551465, 131, '2014-02-15 00:51:13.000000', 'consum', 0.0228, 'lps'),
	(551466, 131, '2014-02-15 00:51:14.000000', 'consum', 0.0223, 'lps'),
	(551467, 131, '2014-02-15 00:51:15.000000', 'consum', 0.0223, 'lps'),
	(551468, 131, '2014-02-15 00:51:16.000000', 'consum', 0.0235, 'lps'),
	(551469, 131, '2014-02-15 00:51:17.000000', 'consum', 0.0213, 'lps'),
	(551470, 131, '2014-02-15 00:51:18.000000', 'consum', 0.0236, 'lps'),
	(551471, 131, '2014-02-15 00:51:19.000000', 'consum', 0.0221, 'lps'),
	(551472, 131, '2014-02-15 00:51:20.000000', 'consum', 0.0213, 'lps'),
	(551473, 131, '2014-02-15 00:51:21.000000', 'consum', 0.0222, 'lps'),
	(551474, 131, '2014-02-15 00:51:22.000000', 'consum', 0.0231, 'lps'),
	(551475, 131, '2014-02-15 00:51:23.000000', 'consum', 0.0225, 'lps'),
	(551476, 131, '2014-02-15 00:51:24.000000', 'consum', 0.0223, 'lps'),
	(551477, 131, '2014-02-15 00:51:25.000000', 'consum', 0.0230, 'lps'),
	(551478, 131, '2014-02-15 00:51:26.000000', 'consum', 0.0217, 'lps'),
	(551479, 131, '2014-02-15 00:51:27.000000', 'consum', 0.0211, 'lps'),
	(551480, 131, '2014-02-15 00:51:28.000000', 'consum', 0.0225, 'lps'),
	(551481, 131, '2014-02-15 00:51:29.000000', 'consum', 0.0223, 'lps'),
	(551482, 131, '2014-02-15 00:51:30.000000', 'consum', 0.0234, 'lps'),
	(551483, 131, '2014-02-15 00:51:31.000000', 'consum', 0.0234, 'lps'),
	(551484, 131, '2014-02-15 00:51:32.000000', 'consum', 0.0232, 'lps'),
	(551485, 131, '2014-02-15 00:51:33.000000', 'consum', 0.0218, 'lps'),
	(551486, 131, '2014-02-15 00:51:34.000000', 'consum', 0.0212, 'lps'),
	(551487, 131, '2014-02-15 00:51:35.000000', 'consum', 0.0224, 'lps'),
	(551488, 131, '2014-02-15 00:51:36.000000', 'consum', 0.0220, 'lps'),
	(551489, 131, '2014-02-15 00:51:37.000000', 'consum', 0.0216, 'lps'),
	(551490, 131, '2014-02-15 00:51:38.000000', 'consum', 0.0213, 'lps'),
	(551491, 131, '2014-02-15 00:51:39.000000', 'consum', 0.0235, 'lps'),
	(551492, 131, '2014-02-15 00:51:40.000000', 'consum', 0.0213, 'lps'),
	(551493, 131, '2014-02-15 00:51:41.000000', 'consum', 0.0235, 'lps'),
	(551494, 131, '2014-02-15 00:51:42.000000', 'consum', 0.0213, 'lps'),
	(551495, 131, '2014-02-15 00:51:43.000000', 'consum', 0.0236, 'lps'),
	(551496, 131, '2014-02-15 00:51:44.000000', 'consum', 0.0221, 'lps'),
	(551497, 131, '2014-02-15 00:51:45.000000', 'consum', 0.0216, 'lps'),
	(551498, 131, '2014-02-15 00:51:46.000000', 'consum', 0.0234, 'lps'),
	(551499, 131, '2014-02-15 00:51:47.000000', 'consum', 0.0230, 'lps'),
	(551500, 131, '2014-02-15 00:51:48.000000', 'consum', 0.0210, 'lps'),
	(551501, 131, '2014-02-15 00:51:49.000000', 'consum', 0.0233, 'lps'),
	(551502, 131, '2014-02-15 00:51:50.000000', 'consum', 0.0215, 'lps'),
	(551503, 131, '2014-02-15 00:51:51.000000', 'consum', 0.0221, 'lps'),
	(551504, 131, '2014-02-15 00:51:52.000000', 'consum', 0.0225, 'lps'),
	(551505, 131, '2014-02-15 00:51:53.000000', 'consum', 0.0223, 'lps'),
	(551506, 131, '2014-02-15 00:51:54.000000', 'consum', 0.0231, 'lps'),
	(551507, 131, '2014-02-15 00:51:55.000000', 'consum', 0.0219, 'lps'),
	(551508, 131, '2014-02-15 00:51:56.000000', 'consum', 0.0220, 'lps'),
	(551509, 131, '2014-02-15 00:51:57.000000', 'consum', 0.0235, 'lps'),
	(551510, 131, '2014-02-15 00:51:58.000000', 'consum', 0.0222, 'lps'),
	(551511, 131, '2014-02-15 00:51:59.000000', 'consum', 0.0224, 'lps'),
	(551512, 131, '2014-02-15 00:52:00.000000', 'consum', 0.0215, 'lps'),
	(551513, 131, '2014-02-15 00:52:01.000000', 'consum', 0.0221, 'lps'),
	(551514, 131, '2014-02-15 00:52:02.000000', 'consum', 0.0225, 'lps'),
	(551515, 131, '2014-02-15 00:52:03.000000', 'consum', 0.0223, 'lps'),
	(551516, 131, '2014-02-15 00:52:04.000000', 'consum', 0.0231, 'lps'),
	(551517, 131, '2014-02-15 00:52:05.000000', 'consum', 0.0220, 'lps'),
	(551518, 131, '2014-02-15 00:52:06.000000', 'consum', 0.0226, 'lps'),
	(551519, 131, '2014-02-15 00:52:07.000000', 'consum', 0.0232, 'lps'),
	(551520, 131, '2014-02-15 00:52:08.000000', 'consum', 0.0216, 'lps'),
	(551521, 131, '2014-02-15 00:52:09.000000', 'consum', 0.0233, 'lps'),
	(551522, 131, '2014-02-15 00:52:10.000000', 'consum', 0.0221, 'lps'),
	(551523, 131, '2014-02-15 00:52:11.000000', 'consum', 0.0225, 'lps'),
	(551524, 131, '2014-02-15 00:52:12.000000', 'consum', 0.0223, 'lps'),
	(551525, 131, '2014-02-15 00:52:13.000000', 'consum', 0.0233, 'lps'),
	(551526, 131, '2014-02-15 00:52:14.000000', 'consum', 0.0229, 'lps'),
	(551527, 131, '2014-02-15 00:52:15.000000', 'consum', 0.0236, 'lps'),
	(551528, 131, '2014-02-15 00:52:16.000000', 'consum', 0.0229, 'lps'),
	(551529, 131, '2014-02-15 00:52:17.000000', 'consum', 0.0227, 'lps'),
	(551530, 131, '2014-02-15 00:52:18.000000', 'consum', 0.0237, 'lps'),
	(551531, 131, '2014-02-15 00:52:19.000000', 'consum', 0.0211, 'lps'),
	(551532, 131, '2014-02-15 00:52:20.000000', 'consum', 0.0219, 'lps'),
	(551533, 131, '2014-02-15 00:52:21.000000', 'consum', 0.0222, 'lps'),
	(551534, 131, '2014-02-15 00:52:22.000000', 'consum', 0.0218, 'lps'),
	(551535, 131, '2014-02-15 00:52:23.000000', 'consum', 0.0215, 'lps'),
	(551536, 131, '2014-02-15 00:52:24.000000', 'consum', 0.0213, 'lps'),
	(551537, 131, '2014-02-15 00:52:25.000000', 'consum', 0.0236, 'lps'),
	(551538, 131, '2014-02-15 00:52:26.000000', 'consum', 0.0220, 'lps'),
	(551539, 131, '2014-02-15 00:52:27.000000', 'consum', 0.0237, 'lps'),
	(551540, 131, '2014-02-15 00:52:28.000000', 'consum', 0.0232, 'lps'),
	(551541, 131, '2014-02-15 00:52:29.000000', 'consum', 0.0210, 'lps'),
	(551542, 131, '2014-02-15 00:52:30.000000', 'consum', 0.0231, 'lps'),
	(551543, 131, '2014-02-15 00:52:31.000000', 'consum', 0.0232, 'lps'),
	(551544, 131, '2014-02-15 00:52:32.000000', 'consum', 0.0231, 'lps'),
	(551545, 131, '2014-02-15 00:52:33.000000', 'consum', 0.0219, 'lps'),
	(551546, 131, '2014-02-15 00:52:34.000000', 'consum', 0.0219, 'lps'),
	(551547, 131, '2014-02-15 00:52:35.000000', 'consum', 0.0230, 'lps'),
	(551548, 131, '2014-02-15 00:52:36.000000', 'consum', 0.0227, 'lps'),
	(551549, 131, '2014-02-15 00:52:37.000000', 'consum', 0.0234, 'lps'),
	(551550, 131, '2014-02-15 00:52:38.000000', 'consum', 0.0224, 'lps'),
	(551551, 131, '2014-02-15 00:52:39.000000', 'consum', 0.0237, 'lps'),
	(551552, 131, '2014-02-15 00:52:40.000000', 'consum', 0.0221, 'lps'),
	(551553, 131, '2014-02-15 00:52:41.000000', 'consum', 0.0211, 'lps'),
	(551554, 131, '2014-02-15 00:52:42.000000', 'consum', 0.0211, 'lps'),
	(551555, 131, '2014-02-15 00:52:43.000000', 'consum', 0.0211, 'lps'),
	(551556, 131, '2014-02-15 00:52:44.000000', 'consum', 0.0214, 'lps'),
	(551557, 131, '2014-02-15 00:52:45.000000', 'consum', 0.0228, 'lps'),
	(551558, 131, '2014-02-15 00:52:46.000000', 'consum', 0.0231, 'lps'),
	(551559, 131, '2014-02-15 00:52:47.000000', 'consum', 0.0235, 'lps'),
	(551560, 131, '2014-02-15 00:52:48.000000', 'consum', 0.0217, 'lps'),
	(551561, 131, '2014-02-15 00:52:49.000000', 'consum', 0.0226, 'lps'),
	(551562, 131, '2014-02-15 00:52:50.000000', 'consum', 0.0212, 'lps'),
	(551563, 131, '2014-02-15 00:52:51.000000', 'consum', 0.0228, 'lps'),
	(551564, 131, '2014-02-15 00:52:52.000000', 'consum', 0.0211, 'lps'),
	(551565, 131, '2014-02-15 00:52:53.000000', 'consum', 0.0220, 'lps'),
	(551566, 131, '2014-02-15 00:52:54.000000', 'consum', 0.0227, 'lps'),
	(551567, 131, '2014-02-15 00:52:55.000000', 'consum', 0.0211, 'lps'),
	(551568, 131, '2014-02-15 00:52:56.000000', 'consum', 0.0220, 'lps'),
	(551569, 131, '2014-02-15 00:52:57.000000', 'consum', 0.0230, 'lps'),
	(551570, 131, '2014-02-15 00:52:58.000000', 'consum', 0.0225, 'lps'),
	(551571, 131, '2014-02-15 00:52:59.000000', 'consum', 0.0226, 'lps'),
	(551572, 131, '2014-02-15 00:53:00.000000', 'consum', 0.0218, 'lps'),
	(551573, 131, '2014-02-15 00:53:01.000000', 'consum', 0.0232, 'lps'),
	(551574, 131, '2014-02-15 00:53:02.000000', 'consum', 0.0237, 'lps'),
	(551575, 131, '2014-02-15 00:53:03.000000', 'consum', 0.0226, 'lps'),
	(551576, 131, '2014-02-15 00:53:04.000000', 'consum', 0.0210, 'lps'),
	(551577, 131, '2014-02-15 00:53:05.000000', 'consum', 0.0216, 'lps'),
	(551578, 131, '2014-02-15 00:53:06.000000', 'consum', 0.0213, 'lps'),
	(551579, 131, '2014-02-15 00:53:07.000000', 'consum', 0.0234, 'lps'),
	(551580, 131, '2014-02-15 00:53:08.000000', 'consum', 0.0212, 'lps'),
	(551581, 131, '2014-02-15 00:53:09.000000', 'consum', 0.0231, 'lps'),
	(551582, 131, '2014-02-15 00:53:10.000000', 'consum', 0.0224, 'lps'),
	(551583, 131, '2014-02-15 00:53:11.000000', 'consum', 0.0220, 'lps'),
	(551584, 131, '2014-02-15 00:53:12.000000', 'consum', 0.0218, 'lps'),
	(551585, 131, '2014-02-15 00:53:13.000000', 'consum', 0.0222, 'lps'),
	(551586, 131, '2014-02-15 00:53:14.000000', 'consum', 0.0216, 'lps'),
	(551587, 131, '2014-02-15 00:53:15.000000', 'consum', 0.0235, 'lps'),
	(551588, 131, '2014-02-15 00:53:16.000000', 'consum', 0.0231, 'lps'),
	(551589, 131, '2014-02-15 00:53:17.000000', 'consum', 0.0214, 'lps'),
	(551590, 131, '2014-02-15 00:53:18.000000', 'consum', 0.0224, 'lps'),
	(551591, 131, '2014-02-15 00:53:19.000000', 'consum', 0.0213, 'lps'),
	(551592, 131, '2014-02-15 00:53:20.000000', 'consum', 0.0211, 'lps'),
	(551593, 131, '2014-02-15 00:53:21.000000', 'consum', 0.0233, 'lps'),
	(551594, 131, '2014-02-15 00:53:22.000000', 'consum', 0.0212, 'lps'),
	(551595, 131, '2014-02-15 00:53:23.000000', 'consum', 0.0236, 'lps'),
	(551596, 131, '2014-02-15 00:53:24.000000', 'consum', 0.0222, 'lps'),
	(551597, 131, '2014-02-15 00:53:25.000000', 'consum', 0.0221, 'lps'),
	(551598, 131, '2014-02-15 00:53:26.000000', 'consum', 0.0231, 'lps'),
	(551599, 131, '2014-02-15 00:53:27.000000', 'consum', 0.0225, 'lps'),
	(551600, 131, '2014-02-15 00:53:28.000000', 'consum', 0.0224, 'lps'),
	(551601, 131, '2014-02-15 00:53:29.000000', 'consum', 0.0234, 'lps'),
	(551602, 131, '2014-02-15 00:53:30.000000', 'consum', 0.0232, 'lps'),
	(551603, 131, '2014-02-15 00:53:31.000000', 'consum', 0.0220, 'lps'),
	(551604, 131, '2014-02-15 00:53:32.000000', 'consum', 0.0223, 'lps'),
	(551605, 131, '2014-02-15 00:53:33.000000', 'consum', 0.0220, 'lps'),
	(551606, 131, '2014-02-15 00:53:34.000000', 'consum', 0.0219, 'lps'),
	(551607, 131, '2014-02-15 00:53:35.000000', 'consum', 0.0226, 'lps'),
	(551608, 131, '2014-02-15 00:53:36.000000', 'consum', 0.0235, 'lps'),
	(551609, 131, '2014-02-15 00:53:37.000000', 'consum', 0.0231, 'lps'),
	(551610, 131, '2014-02-15 00:53:38.000000', 'consum', 0.0211, 'lps'),
	(551611, 131, '2014-02-15 00:53:39.000000', 'consum', 0.0211, 'lps'),
	(551612, 131, '2014-02-15 00:53:40.000000', 'consum', 0.0210, 'lps'),
	(551613, 131, '2014-02-15 00:53:41.000000', 'consum', 0.0236, 'lps'),
	(551614, 131, '2014-02-15 00:53:42.000000', 'consum', 0.0229, 'lps'),
	(551615, 131, '2014-02-15 00:53:43.000000', 'consum', 0.0225, 'lps'),
	(551616, 131, '2014-02-15 00:53:44.000000', 'consum', 0.0232, 'lps'),
	(551617, 131, '2014-02-15 00:53:45.000000', 'consum', 0.0219, 'lps'),
	(551618, 131, '2014-02-15 00:53:46.000000', 'consum', 0.0216, 'lps'),
	(551619, 131, '2014-02-15 00:53:47.000000', 'consum', 0.0215, 'lps'),
	(551620, 131, '2014-02-15 00:53:48.000000', 'consum', 0.0218, 'lps'),
	(551621, 131, '2014-02-15 00:53:49.000000', 'consum', 0.0235, 'lps'),
	(551622, 131, '2014-02-15 00:53:50.000000', 'consum', 0.0228, 'lps'),
	(551623, 131, '2014-02-15 00:53:51.000000', 'consum', 0.0223, 'lps'),
	(551624, 131, '2014-02-15 00:53:52.000000', 'consum', 0.0224, 'lps'),
	(551625, 131, '2014-02-15 00:53:53.000000', 'consum', 0.0212, 'lps'),
	(551626, 131, '2014-02-15 00:53:54.000000', 'consum', 0.0233, 'lps'),
	(551627, 131, '2014-02-15 00:53:55.000000', 'consum', 0.0211, 'lps'),
	(551628, 131, '2014-02-15 00:53:56.000000', 'consum', 0.0229, 'lps'),
	(551629, 131, '2014-02-15 00:53:57.000000', 'consum', 0.0219, 'lps'),
	(551630, 131, '2014-02-15 00:53:58.000000', 'consum', 0.0227, 'lps'),
	(551631, 131, '2014-02-15 00:53:59.000000', 'consum', 0.0213, 'lps'),
	(551632, 131, '2014-02-15 00:54:00.000000', 'consum', 0.0228, 'lps'),
	(551633, 131, '2014-02-15 00:54:01.000000', 'consum', 0.0210, 'lps'),
	(551634, 131, '2014-02-15 00:54:02.000000', 'consum', 0.0210, 'lps'),
	(551635, 131, '2014-02-15 00:54:03.000000', 'consum', 0.0213, 'lps'),
	(551636, 131, '2014-02-15 00:54:04.000000', 'consum', 0.0223, 'lps'),
	(551637, 131, '2014-02-15 00:54:05.000000', 'consum', 0.0211, 'lps'),
	(551638, 131, '2014-02-15 00:54:06.000000', 'consum', 0.0234, 'lps'),
	(551639, 131, '2014-02-15 00:54:07.000000', 'consum', 0.0214, 'lps'),
	(551640, 131, '2014-02-15 00:54:08.000000', 'consum', 0.0214, 'lps'),
	(551641, 131, '2014-02-15 00:54:09.000000', 'consum', 0.0220, 'lps'),
	(551642, 131, '2014-02-15 00:54:10.000000', 'consum', 0.0219, 'lps'),
	(551643, 131, '2014-02-15 00:54:11.000000', 'consum', 0.0228, 'lps'),
	(551644, 131, '2014-02-15 00:54:12.000000', 'consum', 0.0217, 'lps'),
	(551645, 131, '2014-02-15 00:54:13.000000', 'consum', 0.0218, 'lps'),
	(551646, 131, '2014-02-15 00:54:14.000000', 'consum', 0.0231, 'lps'),
	(551647, 131, '2014-02-15 00:54:15.000000', 'consum', 0.0235, 'lps'),
	(551648, 131, '2014-02-15 00:54:16.000000', 'consum', 0.0215, 'lps'),
	(551649, 131, '2014-02-15 00:54:17.000000', 'consum', 0.0217, 'lps'),
	(551650, 131, '2014-02-15 00:54:18.000000', 'consum', 0.0232, 'lps'),
	(551651, 131, '2014-02-15 00:54:19.000000', 'consum', 0.0215, 'lps'),
	(551652, 131, '2014-02-15 00:54:20.000000', 'consum', 0.0223, 'lps'),
	(551653, 131, '2014-02-15 00:54:21.000000', 'consum', 0.0235, 'lps'),
	(551654, 131, '2014-02-15 00:54:22.000000', 'consum', 0.0213, 'lps'),
	(551655, 131, '2014-02-15 00:54:23.000000', 'consum', 0.0234, 'lps'),
	(551656, 131, '2014-02-15 00:54:24.000000', 'consum', 0.0211, 'lps'),
	(551657, 131, '2014-02-15 00:54:25.000000', 'consum', 0.0228, 'lps'),
	(551658, 131, '2014-02-15 00:54:26.000000', 'consum', 0.0213, 'lps'),
	(551659, 131, '2014-02-15 00:54:27.000000', 'consum', 0.0225, 'lps'),
	(551660, 131, '2014-02-15 00:54:28.000000', 'consum', 0.0222, 'lps'),
	(551661, 131, '2014-02-15 00:54:29.000000', 'consum', 0.0227, 'lps'),
	(551662, 131, '2014-02-15 00:54:30.000000', 'consum', 0.0231, 'lps'),
	(551663, 131, '2014-02-15 00:54:31.000000', 'consum', 0.0234, 'lps'),
	(551664, 131, '2014-02-15 00:54:32.000000', 'consum', 0.0215, 'lps'),
	(551665, 131, '2014-02-15 00:54:33.000000', 'consum', 0.0217, 'lps'),
	(551666, 131, '2014-02-15 00:54:34.000000', 'consum', 0.0232, 'lps'),
	(551667, 131, '2014-02-15 00:54:35.000000', 'consum', 0.0214, 'lps'),
	(551668, 131, '2014-02-15 00:54:36.000000', 'consum', 0.0223, 'lps'),
	(551669, 131, '2014-02-15 00:54:37.000000', 'consum', 0.0235, 'lps'),
	(551670, 131, '2014-02-15 00:54:38.000000', 'consum', 0.0210, 'lps'),
	(551671, 131, '2014-02-15 00:54:39.000000', 'consum', 0.0222, 'lps'),
	(551672, 131, '2014-02-15 00:54:40.000000', 'consum', 0.0212, 'lps'),
	(551673, 131, '2014-02-15 00:54:41.000000', 'consum', 0.0214, 'lps'),
	(551674, 131, '2014-02-15 00:54:42.000000', 'consum', 0.0224, 'lps'),
	(551675, 131, '2014-02-15 00:54:43.000000', 'consum', 0.0211, 'lps'),
	(551676, 131, '2014-02-15 00:54:44.000000', 'consum', 0.0233, 'lps'),
	(551677, 131, '2014-02-15 00:54:45.000000', 'consum', 0.0235, 'lps'),
	(551678, 131, '2014-02-15 00:54:46.000000', 'consum', 0.0212, 'lps'),
	(551679, 131, '2014-02-15 00:54:47.000000', 'consum', 0.0230, 'lps'),
	(551680, 131, '2014-02-15 00:54:48.000000', 'consum', 0.0219, 'lps'),
	(551681, 131, '2014-02-15 00:54:49.000000', 'consum', 0.0223, 'lps'),
	(551682, 131, '2014-02-15 00:54:50.000000', 'consum', 0.0220, 'lps'),
	(551683, 131, '2014-02-15 00:54:51.000000', 'consum', 0.0222, 'lps'),
	(551684, 131, '2014-02-15 00:54:52.000000', 'consum', 0.0211, 'lps'),
	(551685, 131, '2014-02-15 00:54:53.000000', 'consum', 0.0236, 'lps'),
	(551686, 131, '2014-02-15 00:54:54.000000', 'consum', 0.0228, 'lps'),
	(551687, 131, '2014-02-15 00:54:55.000000', 'consum', 0.0220, 'lps'),
	(551688, 131, '2014-02-15 00:54:56.000000', 'consum', 0.0237, 'lps'),
	(551689, 131, '2014-02-15 00:54:57.000000', 'consum', 0.0230, 'lps'),
	(551690, 131, '2014-02-15 00:54:58.000000', 'consum', 0.0228, 'lps'),
	(551691, 131, '2014-02-15 00:54:59.000000', 'consum', 0.0215, 'lps'),
	(551692, 131, '2014-02-15 00:55:00.000000', 'consum', 0.0235, 'lps'),
	(551693, 131, '2014-02-15 00:55:01.000000', 'consum', 0.0210, 'lps'),
	(551694, 131, '2014-02-15 00:55:02.000000', 'consum', 0.0219, 'lps'),
	(551695, 131, '2014-02-15 00:55:03.000000', 'consum', 0.0228, 'lps'),
	(551696, 131, '2014-02-15 00:55:04.000000', 'consum', 0.0215, 'lps'),
	(551697, 131, '2014-02-15 00:55:05.000000', 'consum', 0.0213, 'lps'),
	(551698, 131, '2014-02-15 00:55:06.000000', 'consum', 0.0235, 'lps'),
	(551699, 131, '2014-02-15 00:55:07.000000', 'consum', 0.0217, 'lps'),
	(551700, 131, '2014-02-15 00:55:08.000000', 'consum', 0.0224, 'lps'),
	(551701, 131, '2014-02-15 00:55:09.000000', 'consum', 0.0233, 'lps'),
	(551702, 131, '2014-02-15 00:55:10.000000', 'consum', 0.0225, 'lps'),
	(551703, 131, '2014-02-15 00:55:11.000000', 'consum', 0.0219, 'lps'),
	(551704, 131, '2014-02-15 00:55:12.000000', 'consum', 0.0211, 'lps'),
	(551705, 131, '2014-02-15 00:55:13.000000', 'consum', 0.0217, 'lps'),
	(551706, 131, '2014-02-15 00:55:14.000000', 'consum', 0.0212, 'lps'),
	(551707, 131, '2014-02-15 00:55:15.000000', 'consum', 0.0230, 'lps'),
	(551708, 131, '2014-02-15 00:55:16.000000', 'consum', 0.0218, 'lps'),
	(551709, 131, '2014-02-15 00:55:17.000000', 'consum', 0.0219, 'lps'),
	(551710, 131, '2014-02-15 00:55:18.000000', 'consum', 0.0231, 'lps'),
	(551711, 131, '2014-02-15 00:55:19.000000', 'consum', 0.0232, 'lps'),
	(551712, 131, '2014-02-15 00:55:20.000000', 'consum', 0.0231, 'lps'),
	(551713, 131, '2014-02-15 00:55:21.000000', 'consum', 0.0221, 'lps'),
	(551714, 131, '2014-02-15 00:55:22.000000', 'consum', 0.0229, 'lps'),
	(551715, 131, '2014-02-15 00:55:23.000000', 'consum', 0.0219, 'lps'),
	(551716, 131, '2014-02-15 00:55:24.000000', 'consum', 0.0225, 'lps'),
	(551717, 131, '2014-02-15 00:55:25.000000', 'consum', 0.0232, 'lps'),
	(551718, 131, '2014-02-15 00:55:26.000000', 'consum', 0.0217, 'lps'),
	(551719, 131, '2014-02-15 00:55:27.000000', 'consum', 0.0235, 'lps'),
	(551720, 131, '2014-02-15 00:55:28.000000', 'consum', 0.0231, 'lps'),
	(551721, 131, '2014-02-15 00:55:29.000000', 'consum', 0.0212, 'lps'),
	(551722, 131, '2014-02-15 00:55:30.000000', 'consum', 0.0214, 'lps'),
	(551723, 131, '2014-02-15 00:55:31.000000', 'consum', 0.0225, 'lps'),
	(551724, 131, '2014-02-15 00:55:32.000000', 'consum', 0.0219, 'lps'),
	(551725, 131, '2014-02-15 00:55:33.000000', 'consum', 0.0210, 'lps'),
	(551726, 131, '2014-02-15 00:55:34.000000', 'consum', 0.0211, 'lps'),
	(551727, 131, '2014-02-15 00:55:35.000000', 'consum', 0.0217, 'lps'),
	(551728, 131, '2014-02-15 00:55:36.000000', 'consum', 0.0211, 'lps'),
	(551729, 131, '2014-02-15 00:55:37.000000', 'consum', 0.0226, 'lps'),
	(551730, 131, '2014-02-15 00:55:38.000000', 'consum', 0.0231, 'lps'),
	(551731, 131, '2014-02-15 00:55:39.000000', 'consum', 0.0213, 'lps'),
	(551732, 131, '2014-02-15 00:55:40.000000', 'consum', 0.0216, 'lps'),
	(551733, 131, '2014-02-15 00:55:41.000000', 'consum', 0.0233, 'lps'),
	(551734, 131, '2014-02-15 00:55:42.000000', 'consum', 0.0225, 'lps'),
	(551735, 131, '2014-02-15 00:55:43.000000', 'consum', 0.0215, 'lps'),
	(551736, 131, '2014-02-15 00:55:44.000000', 'consum', 0.0219, 'lps'),
	(551737, 131, '2014-02-15 00:55:45.000000', 'consum', 0.0213, 'lps'),
	(551738, 131, '2014-02-15 00:55:46.000000', 'consum', 0.0224, 'lps'),
	(551739, 131, '2014-02-15 00:55:47.000000', 'consum', 0.0218, 'lps'),
	(551740, 131, '2014-02-15 00:55:48.000000', 'consum', 0.0234, 'lps'),
	(551741, 131, '2014-02-15 00:55:49.000000', 'consum', 0.0224, 'lps'),
	(551742, 131, '2014-02-15 00:55:50.000000', 'consum', 0.0234, 'lps'),
	(551743, 131, '2014-02-15 00:55:51.000000', 'consum', 0.0236, 'lps'),
	(551744, 131, '2014-02-15 00:55:52.000000', 'consum', 0.0212, 'lps'),
	(551745, 131, '2014-02-15 00:55:53.000000', 'consum', 0.0225, 'lps'),
	(551746, 131, '2014-02-15 00:55:54.000000', 'consum', 0.0225, 'lps'),
	(551747, 131, '2014-02-15 00:55:55.000000', 'consum', 0.0213, 'lps'),
	(551748, 131, '2014-02-15 00:55:56.000000', 'consum', 0.0236, 'lps'),
	(551749, 131, '2014-02-15 00:55:57.000000', 'consum', 0.0220, 'lps'),
	(551750, 131, '2014-02-15 00:55:58.000000', 'consum', 0.0210, 'lps'),
	(551751, 131, '2014-02-15 00:55:59.000000', 'consum', 0.0236, 'lps'),
	(551752, 131, '2014-02-15 00:56:00.000000', 'consum', 0.0230, 'lps'),
	(551753, 131, '2014-02-15 00:56:01.000000', 'consum', 0.0230, 'lps'),
	(551754, 131, '2014-02-15 00:56:02.000000', 'consum', 0.0225, 'lps'),
	(551755, 131, '2014-02-15 00:56:03.000000', 'consum', 0.0226, 'lps'),
	(551756, 131, '2014-02-15 00:56:04.000000', 'consum', 0.0217, 'lps'),
	(551757, 131, '2014-02-15 00:56:05.000000', 'consum', 0.0224, 'lps'),
	(551758, 131, '2014-02-15 00:56:06.000000', 'consum', 0.0231, 'lps'),
	(551759, 131, '2014-02-15 00:56:07.000000', 'consum', 0.0219, 'lps'),
	(551760, 131, '2014-02-15 00:56:08.000000', 'consum', 0.0222, 'lps'),
	(551761, 131, '2014-02-15 00:56:09.000000', 'consum', 0.0215, 'lps'),
	(551762, 131, '2014-02-15 00:56:10.000000', 'consum', 0.0225, 'lps'),
	(551763, 131, '2014-02-15 00:56:11.000000', 'consum', 0.0217, 'lps'),
	(551764, 131, '2014-02-15 00:56:12.000000', 'consum', 0.0230, 'lps'),
	(551765, 131, '2014-02-15 00:56:13.000000', 'consum', 0.0231, 'lps'),
	(551766, 131, '2014-02-15 00:56:14.000000', 'consum', 0.0227, 'lps'),
	(551767, 131, '2014-02-15 00:56:15.000000', 'consum', 0.0235, 'lps'),
	(551768, 131, '2014-02-15 00:56:16.000000', 'consum', 0.0229, 'lps'),
	(551769, 131, '2014-02-15 00:56:17.000000', 'consum', 0.0227, 'lps'),
	(551770, 131, '2014-02-15 00:56:18.000000', 'consum', 0.0214, 'lps'),
	(551771, 131, '2014-02-15 00:56:19.000000', 'consum', 0.0233, 'lps'),
	(551772, 131, '2014-02-15 00:56:20.000000', 'consum', 0.0230, 'lps'),
	(551773, 131, '2014-02-15 00:56:21.000000', 'consum', 0.0213, 'lps'),
	(551774, 131, '2014-02-15 00:56:22.000000', 'consum', 0.0221, 'lps'),
	(551775, 131, '2014-02-15 00:56:23.000000', 'consum', 0.0231, 'lps'),
	(551776, 131, '2014-02-15 00:56:24.000000', 'consum', 0.0225, 'lps'),
	(551777, 131, '2014-02-15 00:56:25.000000', 'consum', 0.0223, 'lps'),
	(551778, 131, '2014-02-15 00:56:26.000000', 'consum', 0.0229, 'lps'),
	(551779, 131, '2014-02-15 00:56:27.000000', 'consum', 0.0211, 'lps'),
	(551780, 131, '2014-02-15 00:56:28.000000', 'consum', 0.0215, 'lps'),
	(551781, 131, '2014-02-15 00:56:29.000000', 'consum', 0.0231, 'lps'),
	(551782, 131, '2014-02-15 00:56:30.000000', 'consum', 0.0216, 'lps'),
	(551783, 131, '2014-02-15 00:56:31.000000', 'consum', 0.0234, 'lps'),
	(551784, 131, '2014-02-15 00:56:32.000000', 'consum', 0.0231, 'lps'),
	(551785, 131, '2014-02-15 00:56:33.000000', 'consum', 0.0212, 'lps'),
	(551786, 131, '2014-02-15 00:56:34.000000', 'consum', 0.0216, 'lps'),
	(551787, 131, '2014-02-15 00:56:35.000000', 'consum', 0.0234, 'lps'),
	(551788, 131, '2014-02-15 00:56:36.000000', 'consum', 0.0226, 'lps'),
	(551789, 131, '2014-02-15 00:56:37.000000', 'consum', 0.0221, 'lps'),
	(551790, 131, '2014-02-15 00:56:38.000000', 'consum', 0.0217, 'lps'),
	(551791, 131, '2014-02-15 00:56:39.000000', 'consum', 0.0213, 'lps'),
	(551792, 131, '2014-02-15 00:56:40.000000', 'consum', 0.0233, 'lps'),
	(551793, 131, '2014-02-15 00:56:41.000000', 'consum', 0.0231, 'lps'),
	(551794, 131, '2014-02-15 00:56:42.000000', 'consum', 0.0219, 'lps'),
	(551795, 131, '2014-02-15 00:56:43.000000', 'consum', 0.0220, 'lps'),
	(551796, 131, '2014-02-15 00:56:44.000000', 'consum', 0.0233, 'lps'),
	(551797, 131, '2014-02-15 00:56:45.000000', 'consum', 0.0212, 'lps'),
	(551798, 131, '2014-02-15 00:56:46.000000', 'consum', 0.0234, 'lps'),
	(551799, 131, '2014-02-15 00:56:47.000000', 'consum', 0.0213, 'lps'),
	(551800, 131, '2014-02-15 00:56:48.000000', 'consum', 0.0211, 'lps'),
	(551801, 131, '2014-02-15 00:56:49.000000', 'consum', 0.0232, 'lps'),
	(551802, 131, '2014-02-15 00:56:50.000000', 'consum', 0.0233, 'lps'),
	(551803, 131, '2014-02-15 00:56:51.000000', 'consum', 0.0233, 'lps'),
	(551804, 131, '2014-02-15 00:56:52.000000', 'consum', 0.0228, 'lps'),
	(551805, 131, '2014-02-15 00:56:53.000000', 'consum', 0.0232, 'lps'),
	(551806, 131, '2014-02-15 00:56:54.000000', 'consum', 0.0237, 'lps'),
	(551807, 131, '2014-02-15 00:56:55.000000', 'consum', 0.0226, 'lps'),
	(551808, 131, '2014-02-15 00:56:56.000000', 'consum', 0.0237, 'lps'),
	(551809, 131, '2014-02-15 00:56:57.000000', 'consum', 0.0212, 'lps'),
	(551810, 131, '2014-02-15 00:56:58.000000', 'consum', 0.0225, 'lps'),
	(551811, 131, '2014-02-15 00:56:59.000000', 'consum', 0.0221, 'lps'),
	(551812, 131, '2014-02-15 00:57:00.000000', 'consum', 0.0223, 'lps'),
	(551813, 131, '2014-02-15 00:57:01.000000', 'consum', 0.0212, 'lps'),
	(551814, 131, '2014-02-15 00:57:02.000000', 'consum', 0.0237, 'lps'),
	(551815, 131, '2014-02-15 00:57:03.000000', 'consum', 0.0229, 'lps'),
	(551816, 131, '2014-02-15 00:57:04.000000', 'consum', 0.0226, 'lps'),
	(551817, 131, '2014-02-15 00:57:05.000000', 'consum', 0.0232, 'lps'),
	(551818, 131, '2014-02-15 00:57:06.000000', 'consum', 0.0216, 'lps'),
	(551819, 131, '2014-02-15 00:57:07.000000', 'consum', 0.0230, 'lps'),
	(551820, 131, '2014-02-15 00:57:08.000000', 'consum', 0.0237, 'lps'),
	(551821, 131, '2014-02-15 00:57:09.000000', 'consum', 0.0228, 'lps'),
	(551822, 131, '2014-02-15 00:57:10.000000', 'consum', 0.0220, 'lps'),
	(551823, 131, '2014-02-15 00:57:11.000000', 'consum', 0.0236, 'lps'),
	(551824, 131, '2014-02-15 00:57:12.000000', 'consum', 0.0226, 'lps'),
	(551825, 131, '2014-02-15 00:57:13.000000', 'consum', 0.0213, 'lps'),
	(551826, 131, '2014-02-15 00:57:14.000000', 'consum', 0.0232, 'lps'),
	(551827, 131, '2014-02-15 00:57:15.000000', 'consum', 0.0226, 'lps'),
	(551828, 131, '2014-02-15 00:57:16.000000', 'consum', 0.0227, 'lps'),
	(551829, 131, '2014-02-15 00:57:17.000000', 'consum', 0.0218, 'lps'),
	(551830, 131, '2014-02-15 00:57:18.000000', 'consum', 0.0230, 'lps'),
	(551831, 131, '2014-02-15 00:57:19.000000', 'consum', 0.0229, 'lps'),
	(551832, 131, '2014-02-15 00:57:20.000000', 'consum', 0.0216, 'lps'),
	(551833, 131, '2014-02-15 00:57:21.000000', 'consum', 0.0212, 'lps'),
	(551834, 131, '2014-02-15 00:57:22.000000', 'consum', 0.0233, 'lps'),
	(551835, 131, '2014-02-15 00:57:23.000000', 'consum', 0.0233, 'lps'),
	(551836, 131, '2014-02-15 00:57:24.000000', 'consum', 0.0227, 'lps'),
	(551837, 131, '2014-02-15 00:57:25.000000', 'consum', 0.0229, 'lps'),
	(551838, 131, '2014-02-15 00:57:26.000000', 'consum', 0.0228, 'lps'),
	(551839, 131, '2014-02-15 00:57:27.000000', 'consum', 0.0213, 'lps'),
	(551840, 131, '2014-02-15 00:57:28.000000', 'consum', 0.0228, 'lps'),
	(551841, 131, '2014-02-15 00:57:29.000000', 'consum', 0.0236, 'lps'),
	(551842, 131, '2014-02-15 00:57:30.000000', 'consum', 0.0231, 'lps'),
	(551843, 131, '2014-02-15 00:57:31.000000', 'consum', 0.0235, 'lps'),
	(551844, 131, '2014-02-15 00:57:32.000000', 'consum', 0.0218, 'lps'),
	(551845, 131, '2014-02-15 00:57:33.000000', 'consum', 0.0232, 'lps'),
	(551846, 131, '2014-02-15 00:57:34.000000', 'consum', 0.0213, 'lps'),
	(551847, 131, '2014-02-15 00:57:35.000000', 'consum', 0.0213, 'lps'),
	(551848, 131, '2014-02-15 00:57:36.000000', 'consum', 0.0217, 'lps'),
	(551849, 131, '2014-02-15 00:57:37.000000', 'consum', 0.0211, 'lps'),
	(551850, 131, '2014-02-15 00:57:38.000000', 'consum', 0.0220, 'lps'),
	(551851, 131, '2014-02-15 00:57:39.000000', 'consum', 0.0229, 'lps'),
	(551852, 131, '2014-02-15 00:57:40.000000', 'consum', 0.0222, 'lps'),
	(551853, 131, '2014-02-15 00:57:41.000000', 'consum', 0.0211, 'lps'),
	(551854, 131, '2014-02-15 00:57:42.000000', 'consum', 0.0210, 'lps'),
	(551855, 131, '2014-02-15 00:57:43.000000', 'consum', 0.0236, 'lps'),
	(551856, 131, '2014-02-15 00:57:44.000000', 'consum', 0.0229, 'lps'),
	(551857, 131, '2014-02-15 00:57:45.000000', 'consum', 0.0227, 'lps'),
	(551858, 131, '2014-02-15 00:57:46.000000', 'consum', 0.0211, 'lps'),
	(551859, 131, '2014-02-15 00:57:47.000000', 'consum', 0.0219, 'lps'),
	(551860, 131, '2014-02-15 00:57:48.000000', 'consum', 0.0224, 'lps'),
	(551861, 131, '2014-02-15 00:57:49.000000', 'consum', 0.0225, 'lps'),
	(551862, 131, '2014-02-15 00:57:50.000000', 'consum', 0.0215, 'lps'),
	(551863, 131, '2014-02-15 00:57:51.000000', 'consum', 0.0221, 'lps'),
	(551864, 131, '2014-02-15 00:57:52.000000', 'consum', 0.0220, 'lps'),
	(551865, 131, '2014-02-15 00:57:53.000000', 'consum', 0.0230, 'lps'),
	(551866, 131, '2014-02-15 00:57:54.000000', 'consum', 0.0224, 'lps'),
	(551867, 131, '2014-02-15 00:57:55.000000', 'consum', 0.0221, 'lps'),
	(551868, 131, '2014-02-15 00:57:56.000000', 'consum', 0.0224, 'lps'),
	(551869, 131, '2014-02-15 00:57:57.000000', 'consum', 0.0218, 'lps'),
	(551870, 131, '2014-02-15 00:57:58.000000', 'consum', 0.0211, 'lps'),
	(551871, 131, '2014-02-15 00:57:59.000000', 'consum', 0.0219, 'lps'),
	(551872, 131, '2014-02-15 00:58:00.000000', 'consum', 0.0223, 'lps'),
	(551873, 131, '2014-02-15 00:58:01.000000', 'consum', 0.0219, 'lps'),
	(551874, 131, '2014-02-15 00:58:02.000000', 'consum', 0.0218, 'lps'),
	(551875, 131, '2014-02-15 00:58:03.000000', 'consum', 0.0223, 'lps'),
	(551876, 131, '2014-02-15 00:58:04.000000', 'consum', 0.0223, 'lps'),
	(551877, 131, '2014-02-15 00:58:05.000000', 'consum', 0.0237, 'lps'),
	(551878, 131, '2014-02-15 00:58:06.000000', 'consum', 0.0221, 'lps'),
	(551879, 131, '2014-02-15 00:58:07.000000', 'consum', 0.0215, 'lps'),
	(551880, 131, '2014-02-15 00:58:08.000000', 'consum', 0.0228, 'lps'),
	(551881, 131, '2014-02-15 00:58:09.000000', 'consum', 0.0232, 'lps'),
	(551882, 131, '2014-02-15 00:58:10.000000', 'consum', 0.0237, 'lps'),
	(551883, 131, '2014-02-15 00:58:11.000000', 'consum', 0.0224, 'lps'),
	(551884, 131, '2014-02-15 00:58:12.000000', 'consum', 0.0228, 'lps'),
	(551885, 131, '2014-02-15 00:58:13.000000', 'consum', 0.0230, 'lps'),
	(551886, 131, '2014-02-15 00:58:14.000000', 'consum', 0.0228, 'lps'),
	(551887, 131, '2014-02-15 00:58:15.000000', 'consum', 0.0213, 'lps'),
	(551888, 131, '2014-02-15 00:58:16.000000', 'consum', 0.0227, 'lps'),
	(551889, 131, '2014-02-15 00:58:17.000000', 'consum', 0.0230, 'lps'),
	(551890, 131, '2014-02-15 00:58:18.000000', 'consum', 0.0234, 'lps'),
	(551891, 131, '2014-02-15 00:58:19.000000', 'consum', 0.0213, 'lps'),
	(551892, 131, '2014-02-15 00:58:20.000000', 'consum', 0.0210, 'lps'),
	(551893, 131, '2014-02-15 00:58:21.000000', 'consum', 0.0228, 'lps'),
	(551894, 131, '2014-02-15 00:58:22.000000', 'consum', 0.0218, 'lps'),
	(551895, 131, '2014-02-15 00:58:23.000000', 'consum', 0.0225, 'lps'),
	(551896, 131, '2014-02-15 00:58:24.000000', 'consum', 0.0232, 'lps'),
	(551897, 131, '2014-02-15 00:58:25.000000', 'consum', 0.0219, 'lps'),
	(551898, 131, '2014-02-15 00:58:26.000000', 'consum', 0.0216, 'lps'),
	(551899, 131, '2014-02-15 00:58:27.000000', 'consum', 0.0216, 'lps'),
	(551900, 131, '2014-02-15 00:58:28.000000', 'consum', 0.0221, 'lps'),
	(551901, 131, '2014-02-15 00:58:29.000000', 'consum', 0.0221, 'lps'),
	(551902, 131, '2014-02-15 00:58:30.000000', 'consum', 0.0231, 'lps'),
	(551903, 131, '2014-02-15 00:58:31.000000', 'consum', 0.0225, 'lps'),
	(551904, 131, '2014-02-15 00:58:32.000000', 'consum', 0.0225, 'lps'),
	(551905, 131, '2014-02-15 00:58:33.000000', 'consum', 0.0211, 'lps'),
	(551906, 131, '2014-02-15 00:58:34.000000', 'consum', 0.0225, 'lps'),
	(551907, 131, '2014-02-15 00:58:35.000000', 'consum', 0.0228, 'lps'),
	(551908, 131, '2014-02-15 00:58:36.000000', 'consum', 0.0229, 'lps'),
	(551909, 131, '2014-02-15 00:58:37.000000', 'consum', 0.0222, 'lps'),
	(551910, 131, '2014-02-15 00:58:38.000000', 'consum', 0.0212, 'lps'),
	(551911, 131, '2014-02-15 00:58:39.000000', 'consum', 0.0213, 'lps'),
	(551912, 131, '2014-02-15 00:58:40.000000', 'consum', 0.0222, 'lps'),
	(551913, 131, '2014-02-15 00:58:41.000000', 'consum', 0.0232, 'lps'),
	(551914, 131, '2014-02-15 00:58:42.000000', 'consum', 0.0229, 'lps'),
	(551915, 131, '2014-02-15 00:58:43.000000', 'consum', 0.0211, 'lps'),
	(551916, 131, '2014-02-15 00:58:44.000000', 'consum', 0.0213, 'lps'),
	(551917, 131, '2014-02-15 00:58:45.000000', 'consum', 0.0223, 'lps'),
	(551918, 131, '2014-02-15 00:58:46.000000', 'consum', 0.0212, 'lps'),
	(551919, 131, '2014-02-15 00:58:47.000000', 'consum', 0.0210, 'lps'),
	(551920, 131, '2014-02-15 00:58:48.000000', 'consum', 0.0231, 'lps'),
	(551921, 131, '2014-02-15 00:58:49.000000', 'consum', 0.0232, 'lps'),
	(551922, 131, '2014-02-15 00:58:50.000000', 'consum', 0.0230, 'lps'),
	(551923, 131, '2014-02-15 00:58:51.000000', 'consum', 0.0215, 'lps'),
	(551924, 131, '2014-02-15 00:58:52.000000', 'consum', 0.0231, 'lps'),
	(551925, 131, '2014-02-15 00:58:53.000000', 'consum', 0.0219, 'lps'),
	(551926, 131, '2014-02-15 00:58:54.000000', 'consum', 0.0218, 'lps'),
	(551927, 131, '2014-02-15 00:58:55.000000', 'consum', 0.0227, 'lps'),
	(551928, 131, '2014-02-15 00:58:56.000000', 'consum', 0.0212, 'lps'),
	(551929, 131, '2014-02-15 00:58:57.000000', 'consum', 0.0225, 'lps'),
	(551930, 131, '2014-02-15 00:58:58.000000', 'consum', 0.0226, 'lps'),
	(551931, 131, '2014-02-15 00:58:59.000000', 'consum', 0.0216, 'lps'),
	(551932, 131, '2014-02-15 00:59:00.000000', 'consum', 0.0220, 'lps'),
	(551933, 131, '2014-02-15 00:59:01.000000', 'consum', 0.0214, 'lps'),
	(551934, 131, '2014-02-15 00:59:02.000000', 'consum', 0.0230, 'lps'),
	(551935, 131, '2014-02-15 00:59:03.000000', 'consum', 0.0213, 'lps'),
	(551936, 131, '2014-02-15 00:59:04.000000', 'consum', 0.0223, 'lps'),
	(551937, 131, '2014-02-15 00:59:05.000000', 'consum', 0.0211, 'lps'),
	(551938, 131, '2014-02-15 00:59:06.000000', 'consum', 0.0233, 'lps'),
	(551939, 131, '2014-02-15 00:59:07.000000', 'consum', 0.0210, 'lps'),
	(551940, 131, '2014-02-15 00:59:08.000000', 'consum', 0.0227, 'lps'),
	(551941, 131, '2014-02-15 00:59:09.000000', 'consum', 0.0212, 'lps'),
	(551942, 131, '2014-02-15 00:59:10.000000', 'consum', 0.0222, 'lps'),
	(551943, 131, '2014-02-15 00:59:11.000000', 'consum', 0.0212, 'lps'),
	(551944, 131, '2014-02-15 00:59:12.000000', 'consum', 0.0237, 'lps'),
	(551945, 131, '2014-02-15 00:59:13.000000', 'consum', 0.0230, 'lps'),
	(551946, 131, '2014-02-15 00:59:14.000000', 'consum', 0.0227, 'lps'),
	(551947, 131, '2014-02-15 00:59:15.000000', 'consum', 0.0237, 'lps'),
	(551948, 131, '2014-02-15 00:59:16.000000', 'consum', 0.0211, 'lps'),
	(551949, 131, '2014-02-15 00:59:17.000000', 'consum', 0.0219, 'lps'),
	(551950, 131, '2014-02-15 00:59:18.000000', 'consum', 0.0225, 'lps'),
	(551951, 131, '2014-02-15 00:59:19.000000', 'consum', 0.0230, 'lps'),
	(551952, 131, '2014-02-15 00:59:20.000000', 'consum', 0.0237, 'lps'),
	(551953, 131, '2014-02-15 00:59:21.000000', 'consum', 0.0228, 'lps'),
	(551954, 131, '2014-02-15 00:59:22.000000', 'consum', 0.0221, 'lps'),
	(551955, 131, '2014-02-15 00:59:23.000000', 'consum', 0.0210, 'lps'),
	(551956, 131, '2014-02-15 00:59:24.000000', 'consum', 0.0233, 'lps'),
	(551957, 131, '2014-02-15 00:59:25.000000', 'consum', 0.0216, 'lps'),
	(551958, 131, '2014-02-15 00:59:26.000000', 'consum', 0.0228, 'lps'),
	(551959, 131, '2014-02-15 00:59:27.000000', 'consum', 0.0225, 'lps'),
	(551960, 131, '2014-02-15 00:59:28.000000', 'consum', 0.0230, 'lps'),
	(551961, 131, '2014-02-15 00:59:29.000000', 'consum', 0.0211, 'lps'),
	(551962, 131, '2014-02-15 00:59:30.000000', 'consum', 0.0213, 'lps'),
	(551963, 131, '2014-02-15 00:59:31.000000', 'consum', 0.0220, 'lps'),
	(551964, 131, '2014-02-15 00:59:32.000000', 'consum', 0.0226, 'lps'),
	(551965, 131, '2014-02-15 00:59:33.000000', 'consum', 0.0231, 'lps'),
	(551966, 131, '2014-02-15 00:59:34.000000', 'consum', 0.0214, 'lps'),
	(551967, 131, '2014-02-15 00:59:35.000000', 'consum', 0.0221, 'lps'),
	(551968, 131, '2014-02-15 00:59:36.000000', 'consum', 0.0228, 'lps'),
	(551969, 131, '2014-02-15 00:59:37.000000', 'consum', 0.0211, 'lps'),
	(551970, 131, '2014-02-15 00:59:38.000000', 'consum', 0.0216, 'lps'),
	(551971, 131, '2014-02-15 00:59:39.000000', 'consum', 0.0211, 'lps'),
	(551972, 131, '2014-02-15 00:59:40.000000', 'consum', 0.0226, 'lps'),
	(551973, 131, '2014-02-15 00:59:41.000000', 'consum', 0.0233, 'lps'),
	(551974, 131, '2014-02-15 00:59:42.000000', 'consum', 0.0219, 'lps'),
	(551975, 131, '2014-02-15 00:59:43.000000', 'consum', 0.0217, 'lps'),
	(551976, 131, '2014-02-15 00:59:44.000000', 'consum', 0.0215, 'lps'),
	(551977, 131, '2014-02-15 00:59:45.000000', 'consum', 0.0217, 'lps'),
	(551978, 131, '2014-02-15 00:59:46.000000', 'consum', 0.0230, 'lps'),
	(551979, 131, '2014-02-15 00:59:47.000000', 'consum', 0.0234, 'lps'),
	(551980, 131, '2014-02-15 00:59:48.000000', 'consum', 0.0212, 'lps'),
	(551981, 131, '2014-02-15 00:59:49.000000', 'consum', 0.0236, 'lps'),
	(551982, 131, '2014-02-15 00:59:50.000000', 'consum', 0.0221, 'lps'),
	(551983, 131, '2014-02-15 00:59:51.000000', 'consum', 0.0214, 'lps'),
	(551984, 131, '2014-02-15 00:59:52.000000', 'consum', 0.0225, 'lps'),
	(551985, 131, '2014-02-15 00:59:53.000000', 'consum', 0.0217, 'lps'),
	(551986, 131, '2014-02-15 00:59:54.000000', 'consum', 0.0232, 'lps'),
	(551987, 131, '2014-02-15 00:59:55.000000', 'consum', 0.0212, 'lps'),
	(551988, 131, '2014-02-15 00:59:56.000000', 'consum', 0.0212, 'lps'),
	(551989, 131, '2014-02-15 00:59:57.000000', 'consum', 0.0214, 'lps'),
	(551990, 131, '2014-02-15 00:59:58.000000', 'consum', 0.0225, 'lps'),
	(551991, 131, '2014-02-15 00:59:59.000000', 'consum', 0.0217, 'lps'),
	(551992, 131, '2014-02-15 01:00:00.000000', 'consum', 0.0230, 'lps'),
	(551993, 131, '2014-02-15 01:00:01.000000', 'consum', 0.0233, 'lps'),
	(551994, 131, '2014-02-15 01:00:02.000000', 'consum', 0.0237, 'lps'),
	(551995, 131, '2014-02-15 01:00:03.000000', 'consum', 0.0223, 'lps'),
	(551996, 131, '2014-02-15 01:00:04.000000', 'consum', 0.0219, 'lps'),
	(551997, 131, '2014-02-15 01:00:05.000000', 'consum', 0.0217, 'lps'),
	(551998, 131, '2014-02-15 01:00:06.000000', 'consum', 0.0221, 'lps'),
	(551999, 131, '2014-02-15 01:00:07.000000', 'consum', 0.0214, 'lps'),
	(552000, 131, '2014-02-15 01:00:08.000000', 'consum', 0.0228, 'lps'),
	(552001, 131, '2014-02-15 01:00:09.000000', 'consum', 0.0233, 'lps'),
	(552002, 131, '2014-02-15 01:00:10.000000', 'consum', 0.0212, 'lps'),
	(552003, 131, '2014-02-15 01:00:11.000000', 'consum', 0.0210, 'lps'),
	(552004, 131, '2014-02-15 01:00:12.000000', 'consum', 0.0232, 'lps'),
	(552005, 131, '2014-02-15 01:00:13.000000', 'consum', 0.0236, 'lps'),
	(552006, 131, '2014-02-15 01:00:14.000000', 'consum', 0.0220, 'lps'),
	(552007, 131, '2014-02-15 01:00:15.000000', 'consum', 0.0211, 'lps'),
	(552008, 131, '2014-02-15 01:00:16.000000', 'consum', 0.0214, 'lps'),
	(552009, 131, '2014-02-15 01:00:17.000000', 'consum', 0.0225, 'lps'),
	(552010, 131, '2014-02-15 01:00:18.000000', 'consum', 0.0220, 'lps'),
	(552011, 131, '2014-02-15 01:00:19.000000', 'consum', 0.0215, 'lps'),
	(552012, 131, '2014-02-15 01:00:20.000000', 'consum', 0.0233, 'lps'),
	(552013, 131, '2014-02-15 01:00:21.000000', 'consum', 0.0225, 'lps'),
	(552014, 131, '2014-02-15 01:00:22.000000', 'consum', 0.0218, 'lps'),
	(552015, 131, '2014-02-15 01:00:23.000000', 'consum', 0.0235, 'lps'),
	(552016, 131, '2014-02-15 01:00:24.000000', 'consum', 0.0226, 'lps'),
	(552017, 131, '2014-02-15 01:00:25.000000', 'consum', 0.0214, 'lps'),
	(552018, 131, '2014-02-15 01:00:26.000000', 'consum', 0.0210, 'lps'),
	(552019, 131, '2014-02-15 01:00:27.000000', 'consum', 0.0228, 'lps'),
	(552020, 131, '2014-02-15 01:00:28.000000', 'consum', 0.0215, 'lps'),
	(552021, 131, '2014-02-15 01:00:29.000000', 'consum', 0.0211, 'lps'),
	(552022, 131, '2014-02-15 01:00:30.000000', 'consum', 0.0230, 'lps'),
	(552023, 131, '2014-02-15 01:00:31.000000', 'consum', 0.0223, 'lps'),
	(552024, 131, '2014-02-15 01:00:32.000000', 'consum', 0.0215, 'lps'),
	(552025, 131, '2014-02-15 01:00:33.000000', 'consum', 0.0224, 'lps'),
	(552026, 131, '2014-02-15 01:00:34.000000', 'consum', 0.0212, 'lps'),
	(552027, 131, '2014-02-15 01:00:35.000000', 'consum', 0.0231, 'lps'),
	(552028, 131, '2014-02-15 01:00:36.000000', 'consum', 0.0227, 'lps'),
	(552029, 131, '2014-02-15 01:00:37.000000', 'consum', 0.0234, 'lps'),
	(552030, 131, '2014-02-15 01:00:38.000000', 'consum', 0.0224, 'lps'),
	(552031, 131, '2014-02-15 01:00:39.000000', 'consum', 0.0236, 'lps'),
	(552032, 131, '2014-02-15 01:00:40.000000', 'consum', 0.0213, 'lps'),
	(552033, 131, '2014-02-15 01:00:41.000000', 'consum', 0.0232, 'lps'),
	(552034, 131, '2014-02-15 01:00:42.000000', 'consum', 0.0230, 'lps'),
	(552035, 131, '2014-02-15 01:00:43.000000', 'consum', 0.0213, 'lps'),
	(552036, 131, '2014-02-15 01:00:44.000000', 'consum', 0.0223, 'lps'),
	(552037, 131, '2014-02-15 01:00:45.000000', 'consum', 0.0212, 'lps'),
	(552038, 131, '2014-02-15 01:00:46.000000', 'consum', 0.0210, 'lps'),
	(552039, 131, '2014-02-15 01:00:47.000000', 'consum', 0.0230, 'lps'),
	(552040, 131, '2014-02-15 01:00:48.000000', 'consum', 0.0228, 'lps'),
	(552041, 131, '2014-02-15 01:00:49.000000', 'consum', 0.0213, 'lps'),
	(552042, 131, '2014-02-15 01:00:50.000000', 'consum', 0.0227, 'lps'),
	(552043, 131, '2014-02-15 01:00:51.000000', 'consum', 0.0230, 'lps'),
	(552044, 131, '2014-02-15 01:00:52.000000', 'consum', 0.0230, 'lps'),
	(552045, 131, '2014-02-15 01:00:53.000000', 'consum', 0.0223, 'lps'),
	(552046, 131, '2014-02-15 01:00:54.000000', 'consum', 0.0218, 'lps'),
	(552047, 131, '2014-02-15 01:00:55.000000', 'consum', 0.0211, 'lps'),
	(552048, 131, '2014-02-15 01:00:56.000000', 'consum', 0.0218, 'lps'),
	(552049, 131, '2014-02-15 01:00:57.000000', 'consum', 0.0218, 'lps'),
	(552050, 131, '2014-02-15 01:00:58.000000', 'consum', 0.0230, 'lps'),
	(552051, 131, '2014-02-15 01:00:59.000000', 'consum', 0.0227, 'lps'),
	(552052, 131, '2014-02-15 01:01:00.000000', 'consum', 0.0210, 'lps'),
	(552053, 131, '2014-02-15 01:01:01.000000', 'consum', 0.0214, 'lps'),
	(552054, 131, '2014-02-15 01:01:02.000000', 'consum', 0.0233, 'lps'),
	(552055, 131, '2014-02-15 01:01:03.000000', 'consum', 0.0228, 'lps'),
	(552056, 131, '2014-02-15 01:01:04.000000', 'consum', 0.0233, 'lps'),
	(552057, 131, '2014-02-15 01:01:05.000000', 'consum', 0.0214, 'lps'),
	(552058, 131, '2014-02-15 01:01:06.000000', 'consum', 0.0216, 'lps'),
	(552059, 131, '2014-02-15 01:01:07.000000', 'consum', 0.0230, 'lps'),
	(552060, 131, '2014-02-15 01:01:08.000000', 'consum', 0.0210, 'lps'),
	(552061, 131, '2014-02-15 01:01:09.000000', 'consum', 0.0235, 'lps'),
	(552062, 131, '2014-02-15 01:01:10.000000', 'consum', 0.0224, 'lps'),
	(552063, 131, '2014-02-15 01:01:11.000000', 'consum', 0.0233, 'lps'),
	(552064, 131, '2014-02-15 01:01:12.000000', 'consum', 0.0227, 'lps'),
	(552065, 131, '2014-02-15 01:01:13.000000', 'consum', 0.0225, 'lps'),
	(552066, 131, '2014-02-15 01:01:14.000000', 'consum', 0.0236, 'lps'),
	(552067, 131, '2014-02-15 01:01:15.000000', 'consum', 0.0211, 'lps'),
	(552068, 131, '2014-02-15 01:01:16.000000', 'consum', 0.0221, 'lps'),
	(552069, 131, '2014-02-15 01:01:17.000000', 'consum', 0.0236, 'lps'),
	(552070, 131, '2014-02-15 01:01:18.000000', 'consum', 0.0223, 'lps'),
	(552071, 131, '2014-02-15 01:01:19.000000', 'consum', 0.0225, 'lps'),
	(552072, 131, '2014-02-15 01:01:20.000000', 'consum', 0.0219, 'lps'),
	(552073, 131, '2014-02-15 01:01:21.000000', 'consum', 0.0211, 'lps'),
	(552074, 131, '2014-02-15 01:01:22.000000', 'consum', 0.0218, 'lps'),
	(552075, 131, '2014-02-15 01:01:23.000000', 'consum', 0.0217, 'lps'),
	(552076, 131, '2014-02-15 01:01:24.000000', 'consum', 0.0221, 'lps'),
	(552077, 131, '2014-02-15 01:01:25.000000', 'consum', 0.0217, 'lps'),
	(552078, 131, '2014-02-15 01:01:26.000000', 'consum', 0.0211, 'lps'),
	(552079, 131, '2014-02-15 01:01:27.000000', 'consum', 0.0225, 'lps'),
	(552080, 131, '2014-02-15 01:01:28.000000', 'consum', 0.0225, 'lps'),
	(552081, 131, '2014-02-15 01:01:29.000000', 'consum', 0.0215, 'lps'),
	(552082, 131, '2014-02-15 01:01:30.000000', 'consum', 0.0217, 'lps'),
	(552083, 131, '2014-02-15 01:01:31.000000', 'consum', 0.0232, 'lps'),
	(552084, 131, '2014-02-15 01:01:32.000000', 'consum', 0.0216, 'lps'),
	(552085, 131, '2014-02-15 01:01:33.000000', 'consum', 0.0229, 'lps'),
	(552086, 131, '2014-02-15 01:01:34.000000', 'consum', 0.0231, 'lps'),
	(552087, 131, '2014-02-15 01:01:35.000000', 'consum', 0.0231, 'lps'),
	(552088, 131, '2014-02-15 01:01:36.000000', 'consum', 0.0226, 'lps'),
	(552089, 131, '2014-02-15 01:01:37.000000', 'consum', 0.0228, 'lps'),
	(552090, 131, '2014-02-15 01:01:38.000000', 'consum', 0.0221, 'lps'),
	(552091, 131, '2014-02-15 01:01:39.000000', 'consum', 0.0215, 'lps'),
	(552092, 131, '2014-02-15 01:01:40.000000', 'consum', 0.0231, 'lps'),
	(552093, 131, '2014-02-15 01:01:41.000000', 'consum', 0.0213, 'lps'),
	(552094, 131, '2014-02-15 01:01:42.000000', 'consum', 0.0222, 'lps'),
	(552095, 131, '2014-02-15 01:01:43.000000', 'consum', 0.0231, 'lps'),
	(552096, 131, '2014-02-15 01:01:44.000000', 'consum', 0.0225, 'lps'),
	(552097, 131, '2014-02-15 01:01:45.000000', 'consum', 0.0221, 'lps'),
	(552098, 131, '2014-02-15 01:01:46.000000', 'consum', 0.0223, 'lps'),
	(552099, 131, '2014-02-15 01:01:47.000000', 'consum', 0.0212, 'lps'),
	(552100, 131, '2014-02-15 01:01:48.000000', 'consum', 0.0237, 'lps'),
	(552101, 131, '2014-02-15 01:01:49.000000', 'consum', 0.0229, 'lps'),
	(552102, 131, '2014-02-15 01:01:50.000000', 'consum', 0.0223, 'lps'),
	(552103, 131, '2014-02-15 01:01:51.000000', 'consum', 0.0221, 'lps'),
	(552104, 131, '2014-02-15 01:01:52.000000', 'consum', 0.0225, 'lps'),
	(552105, 131, '2014-02-15 01:01:53.000000', 'consum', 0.0225, 'lps'),
	(552106, 131, '2014-02-15 01:01:54.000000', 'consum', 0.0211, 'lps'),
	(552107, 131, '2014-02-15 01:01:55.000000', 'consum', 0.0225, 'lps'),
	(552108, 131, '2014-02-15 01:01:56.000000', 'consum', 0.0229, 'lps'),
	(552109, 131, '2014-02-15 01:01:57.000000', 'consum', 0.0234, 'lps'),
	(552110, 131, '2014-02-15 01:01:58.000000', 'consum', 0.0214, 'lps'),
	(552111, 131, '2014-02-15 01:01:59.000000', 'consum', 0.0217, 'lps'),
	(552112, 131, '2014-02-15 01:02:00.000000', 'consum', 0.0231, 'lps'),
	(552113, 131, '2014-02-15 01:02:01.000000', 'consum', 0.0214, 'lps'),
	(552114, 131, '2014-02-15 01:02:02.000000', 'consum', 0.0220, 'lps'),
	(552115, 131, '2014-02-15 01:02:03.000000', 'consum', 0.0223, 'lps'),
	(552116, 131, '2014-02-15 01:02:04.000000', 'consum', 0.0216, 'lps'),
	(552117, 131, '2014-02-15 01:02:05.000000', 'consum', 0.0229, 'lps'),
	(552118, 131, '2014-02-15 01:02:06.000000', 'consum', 0.0231, 'lps'),
	(552119, 131, '2014-02-15 01:02:07.000000', 'consum', 0.0231, 'lps'),
	(552120, 131, '2014-02-15 01:02:08.000000', 'consum', 0.0227, 'lps'),
	(552121, 131, '2014-02-15 01:02:09.000000', 'consum', 0.0230, 'lps'),
	(552122, 131, '2014-02-15 01:02:10.000000', 'consum', 0.0231, 'lps'),
	(552123, 131, '2014-02-15 01:02:11.000000', 'consum', 0.0226, 'lps'),
	(552124, 131, '2014-02-15 01:02:12.000000', 'consum', 0.0230, 'lps'),
	(552125, 131, '2014-02-15 01:02:13.000000', 'consum', 0.0234, 'lps'),
	(552126, 131, '2014-02-15 01:02:14.000000', 'consum', 0.0215, 'lps'),
	(552127, 131, '2014-02-15 01:02:15.000000', 'consum', 0.0219, 'lps'),
	(552128, 131, '2014-02-15 01:02:16.000000', 'consum', 0.0215, 'lps'),
	(552129, 131, '2014-02-15 01:02:17.000000', 'consum', 0.0233, 'lps'),
	(552130, 131, '2014-02-15 01:02:18.000000', 'consum', 0.0228, 'lps'),
	(552131, 131, '2014-02-15 01:02:19.000000', 'consum', 0.0231, 'lps'),
	(552132, 131, '2014-02-15 01:02:20.000000', 'consum', 0.0235, 'lps'),
	(552133, 131, '2014-02-15 01:02:21.000000', 'consum', 0.0215, 'lps'),
	(552134, 131, '2014-02-15 01:02:22.000000', 'consum', 0.0215, 'lps'),
	(552135, 131, '2014-02-15 01:02:23.000000', 'consum', 0.0222, 'lps'),
	(552136, 131, '2014-02-15 01:02:24.000000', 'consum', 0.0228, 'lps'),
	(552137, 131, '2014-02-15 01:02:25.000000', 'consum', 0.0236, 'lps'),
	(552138, 131, '2014-02-15 01:02:26.000000', 'consum', 0.0230, 'lps'),
	(552139, 131, '2014-02-15 01:02:27.000000', 'consum', 0.0231, 'lps'),
	(552140, 131, '2014-02-15 01:02:28.000000', 'consum', 0.0230, 'lps'),
	(552141, 131, '2014-02-15 01:02:29.000000', 'consum', 0.0218, 'lps'),
	(552142, 131, '2014-02-15 01:02:30.000000', 'consum', 0.0221, 'lps'),
	(552143, 131, '2014-02-15 01:02:31.000000', 'consum', 0.0212, 'lps'),
	(552144, 131, '2014-02-15 01:02:32.000000', 'consum', 0.0218, 'lps'),
	(552145, 131, '2014-02-15 01:02:33.000000', 'consum', 0.0213, 'lps'),
	(552146, 131, '2014-02-15 01:02:34.000000', 'consum', 0.0230, 'lps'),
	(552147, 131, '2014-02-15 01:02:35.000000', 'consum', 0.0218, 'lps'),
	(552148, 131, '2014-02-15 01:02:36.000000', 'consum', 0.0220, 'lps'),
	(552149, 131, '2014-02-15 01:02:37.000000', 'consum', 0.0210, 'lps'),
	(552150, 131, '2014-02-15 01:02:38.000000', 'consum', 0.0233, 'lps'),
	(552151, 131, '2014-02-15 01:02:39.000000', 'consum', 0.0213, 'lps'),
	(552152, 131, '2014-02-15 01:02:40.000000', 'consum', 0.0215, 'lps'),
	(552153, 131, '2014-02-15 01:02:41.000000', 'consum', 0.0226, 'lps'),
	(552154, 131, '2014-02-15 01:02:42.000000', 'consum', 0.0221, 'lps'),
	(552155, 131, '2014-02-15 01:02:43.000000', 'consum', 0.0215, 'lps'),
	(552156, 131, '2014-02-15 01:02:44.000000', 'consum', 0.0232, 'lps'),
	(552157, 131, '2014-02-15 01:02:45.000000', 'consum', 0.0223, 'lps'),
	(552158, 131, '2014-02-15 01:02:46.000000', 'consum', 0.0234, 'lps'),
	(552159, 131, '2014-02-15 01:02:47.000000', 'consum', 0.0211, 'lps'),
	(552160, 131, '2014-02-15 01:02:48.000000', 'consum', 0.0226, 'lps'),
	(552161, 131, '2014-02-15 01:02:49.000000', 'consum', 0.0229, 'lps'),
	(552162, 131, '2014-02-15 01:02:50.000000', 'consum', 0.0233, 'lps'),
	(552163, 131, '2014-02-15 01:02:51.000000', 'consum', 0.0212, 'lps'),
	(552164, 131, '2014-02-15 01:02:52.000000', 'consum', 0.0237, 'lps'),
	(552165, 131, '2014-02-15 01:02:53.000000', 'consum', 0.0226, 'lps'),
	(552166, 131, '2014-02-15 01:02:54.000000', 'consum', 0.0211, 'lps'),
	(552167, 131, '2014-02-15 01:02:55.000000', 'consum', 0.0222, 'lps'),
	(552168, 131, '2014-02-15 01:02:56.000000', 'consum', 0.0210, 'lps'),
	(552169, 131, '2014-02-15 01:02:57.000000', 'consum', 0.0231, 'lps'),
	(552170, 131, '2014-02-15 01:02:58.000000', 'consum', 0.0230, 'lps'),
	(552171, 131, '2014-02-15 01:02:59.000000', 'consum', 0.0221, 'lps'),
	(552172, 131, '2014-02-15 01:03:00.000000', 'consum', 0.0235, 'lps'),
	(552173, 131, '2014-02-15 01:03:01.000000', 'consum', 0.0217, 'lps'),
	(552174, 131, '2014-02-15 01:03:02.000000', 'consum', 0.0226, 'lps'),
	(552175, 131, '2014-02-15 01:03:03.000000', 'consum', 0.0216, 'lps'),
	(552176, 131, '2014-02-15 01:03:04.000000', 'consum', 0.0217, 'lps'),
	(552177, 131, '2014-02-15 01:03:05.000000', 'consum', 0.0230, 'lps'),
	(552178, 131, '2014-02-15 01:03:06.000000', 'consum', 0.0235, 'lps'),
	(552179, 131, '2014-02-15 01:03:07.000000', 'consum', 0.0216, 'lps'),
	(552180, 131, '2014-02-15 01:03:08.000000', 'consum', 0.0223, 'lps'),
	(552181, 131, '2014-02-15 01:03:09.000000', 'consum', 0.0229, 'lps'),
	(552182, 131, '2014-02-15 01:03:10.000000', 'consum', 0.0212, 'lps'),
	(552183, 131, '2014-02-15 01:03:11.000000', 'consum', 0.0217, 'lps'),
	(552184, 131, '2014-02-15 01:03:12.000000', 'consum', 0.0214, 'lps'),
	(552185, 131, '2014-02-15 01:03:13.000000', 'consum', 0.0237, 'lps'),
	(552186, 131, '2014-02-15 01:03:14.000000', 'consum', 0.0221, 'lps'),
	(552187, 131, '2014-02-15 01:03:15.000000', 'consum', 0.0212, 'lps'),
	(552188, 131, '2014-02-15 01:03:16.000000', 'consum', 0.0217, 'lps'),
	(552189, 131, '2014-02-15 01:03:17.000000', 'consum', 0.0211, 'lps'),
	(552190, 131, '2014-02-15 01:03:18.000000', 'consum', 0.0223, 'lps'),
	(552191, 131, '2014-02-15 01:03:19.000000', 'consum', 0.0218, 'lps'),
	(552192, 131, '2014-02-15 01:03:20.000000', 'consum', 0.0210, 'lps'),
	(552193, 131, '2014-02-15 01:03:21.000000', 'consum', 0.0214, 'lps'),
	(552194, 131, '2014-02-15 01:03:22.000000', 'consum', 0.0231, 'lps'),
	(552195, 131, '2014-02-15 01:03:23.000000', 'consum', 0.0220, 'lps'),
	(552196, 131, '2014-02-15 01:03:24.000000', 'consum', 0.0223, 'lps'),
	(552197, 131, '2014-02-15 01:03:25.000000', 'consum', 0.0220, 'lps'),
	(552198, 131, '2014-02-15 01:03:26.000000', 'consum', 0.0219, 'lps'),
	(552199, 131, '2014-02-15 01:03:27.000000', 'consum', 0.0225, 'lps'),
	(552200, 131, '2014-02-15 01:03:28.000000', 'consum', 0.0234, 'lps'),
	(552201, 131, '2014-02-15 01:03:29.000000', 'consum', 0.0227, 'lps'),
	(552202, 131, '2014-02-15 01:03:30.000000', 'consum', 0.0223, 'lps'),
	(552203, 131, '2014-02-15 01:03:31.000000', 'consum', 0.0227, 'lps'),
	(552204, 131, '2014-02-15 01:03:32.000000', 'consum', 0.0228, 'lps'),
	(552205, 131, '2014-02-15 01:03:33.000000', 'consum', 0.0220, 'lps'),
	(552206, 131, '2014-02-15 01:03:34.000000', 'consum', 0.0234, 'lps'),
	(552207, 131, '2014-02-15 01:03:35.000000', 'consum', 0.0215, 'lps'),
	(552208, 131, '2014-02-15 01:03:36.000000', 'consum', 0.0223, 'lps'),
	(552209, 131, '2014-02-15 01:03:37.000000', 'consum', 0.0230, 'lps'),
	(552210, 131, '2014-02-15 01:03:38.000000', 'consum', 0.0215, 'lps'),
	(552211, 131, '2014-02-15 01:03:39.000000', 'consum', 0.0232, 'lps'),
	(552212, 131, '2014-02-15 01:03:40.000000', 'consum', 0.0223, 'lps'),
	(552213, 131, '2014-02-15 01:03:41.000000', 'consum', 0.0210, 'lps'),
	(552214, 131, '2014-02-15 01:03:42.000000', 'consum', 0.0226, 'lps'),
	(552215, 131, '2014-02-15 01:03:43.000000', 'consum', 0.0234, 'lps'),
	(552216, 131, '2014-02-15 01:03:44.000000', 'consum', 0.0228, 'lps'),
	(552217, 131, '2014-02-15 01:03:45.000000', 'consum', 0.0228, 'lps'),
	(552218, 131, '2014-02-15 01:03:46.000000', 'consum', 0.0220, 'lps'),
	(552219, 131, '2014-02-15 01:03:47.000000', 'consum', 0.0233, 'lps'),
	(552220, 131, '2014-02-15 01:03:48.000000', 'consum', 0.0213, 'lps'),
	(552221, 131, '2014-02-15 01:03:49.000000', 'consum', 0.0213, 'lps'),
	(552222, 131, '2014-02-15 01:03:50.000000', 'consum', 0.0214, 'lps'),
	(552223, 131, '2014-02-15 01:03:51.000000', 'consum', 0.0222, 'lps'),
	(552224, 131, '2014-02-15 01:03:52.000000', 'consum', 0.0231, 'lps'),
	(552225, 131, '2014-02-15 01:03:53.000000', 'consum', 0.0222, 'lps'),
	(552226, 131, '2014-02-15 01:03:54.000000', 'consum', 0.0236, 'lps'),
	(552227, 131, '2014-02-15 01:03:55.000000', 'consum', 0.0222, 'lps'),
	(552228, 131, '2014-02-15 01:03:56.000000', 'consum', 0.0218, 'lps'),
	(552229, 131, '2014-02-15 01:03:57.000000', 'consum', 0.0217, 'lps'),
	(552230, 131, '2014-02-15 01:03:58.000000', 'consum', 0.0220, 'lps'),
	(552231, 131, '2014-02-15 01:03:59.000000', 'consum', 0.0213, 'lps'),
	(552232, 131, '2014-02-15 01:04:00.000000', 'consum', 0.0222, 'lps'),
	(552233, 131, '2014-02-15 01:04:01.000000', 'consum', 0.0234, 'lps'),
	(552234, 131, '2014-02-15 01:04:02.000000', 'consum', 0.0212, 'lps'),
	(552235, 131, '2014-02-15 01:04:03.000000', 'consum', 0.0230, 'lps'),
	(552236, 131, '2014-02-15 01:04:04.000000', 'consum', 0.0223, 'lps'),
	(552237, 131, '2014-02-15 01:04:05.000000', 'consum', 0.0214, 'lps'),
	(552238, 131, '2014-02-15 01:04:06.000000', 'consum', 0.0222, 'lps'),
	(552239, 131, '2014-02-15 01:04:07.000000', 'consum', 0.0229, 'lps'),
	(552240, 131, '2014-02-15 01:04:08.000000', 'consum', 0.0213, 'lps'),
	(552241, 131, '2014-02-15 01:04:09.000000', 'consum', 0.0223, 'lps'),
	(552242, 131, '2014-02-15 01:04:10.000000', 'consum', 0.0214, 'lps'),
	(552243, 131, '2014-02-15 01:04:11.000000', 'consum', 0.0216, 'lps'),
	(552244, 131, '2014-02-15 01:04:12.000000', 'consum', 0.0230, 'lps'),
	(552245, 131, '2014-02-15 01:04:13.000000', 'consum', 0.0234, 'lps'),
	(552246, 131, '2014-02-15 01:04:14.000000', 'consum', 0.0218, 'lps'),
	(552247, 131, '2014-02-15 01:04:15.000000', 'consum', 0.0234, 'lps'),
	(552248, 131, '2014-02-15 01:04:16.000000', 'consum', 0.0222, 'lps'),
	(552249, 131, '2014-02-15 01:04:17.000000', 'consum', 0.0228, 'lps'),
	(552250, 131, '2014-02-15 01:04:18.000000', 'consum', 0.0237, 'lps'),
	(552251, 131, '2014-02-15 01:04:19.000000', 'consum', 0.0235, 'lps'),
	(552252, 131, '2014-02-15 01:04:20.000000', 'consum', 0.0225, 'lps'),
	(552253, 131, '2014-02-15 01:04:21.000000', 'consum', 0.0212, 'lps'),
	(552254, 131, '2014-02-15 01:04:22.000000', 'consum', 0.0232, 'lps'),
	(552255, 131, '2014-02-15 01:04:23.000000', 'consum', 0.0228, 'lps'),
	(552256, 131, '2014-02-15 01:04:24.000000', 'consum', 0.0235, 'lps'),
	(552257, 131, '2014-02-15 01:04:25.000000', 'consum', 0.0226, 'lps'),
	(552258, 131, '2014-02-15 01:04:26.000000', 'consum', 0.0215, 'lps'),
	(552259, 131, '2014-02-15 01:04:27.000000', 'consum', 0.0217, 'lps'),
	(552260, 131, '2014-02-15 01:04:28.000000', 'consum', 0.0232, 'lps'),
	(552261, 131, '2014-02-15 01:04:29.000000', 'consum', 0.0213, 'lps'),
	(552262, 131, '2014-02-15 01:04:30.000000', 'consum', 0.0217, 'lps'),
	(552263, 131, '2014-02-15 01:04:31.000000', 'consum', 0.0235, 'lps'),
	(552264, 131, '2014-02-15 01:04:32.000000', 'consum', 0.0231, 'lps'),
	(552265, 131, '2014-02-15 01:04:33.000000', 'consum', 0.0212, 'lps'),
	(552266, 131, '2014-02-15 01:04:34.000000', 'consum', 0.0212, 'lps'),
	(552267, 131, '2014-02-15 01:04:35.000000', 'consum', 0.0217, 'lps'),
	(552268, 131, '2014-02-15 01:04:36.000000', 'consum', 0.0211, 'lps'),
	(552269, 131, '2014-02-15 01:04:37.000000', 'consum', 0.0222, 'lps'),
	(552270, 131, '2014-02-15 01:04:38.000000', 'consum', 0.0211, 'lps'),
	(552271, 131, '2014-02-15 01:04:39.000000', 'consum', 0.0234, 'lps'),
	(552272, 131, '2014-02-15 01:04:40.000000', 'consum', 0.0217, 'lps'),
	(552273, 131, '2014-02-15 01:04:41.000000', 'consum', 0.0232, 'lps'),
	(552274, 131, '2014-02-15 01:04:42.000000', 'consum', 0.0212, 'lps'),
	(552275, 131, '2014-02-15 01:04:43.000000', 'consum', 0.0210, 'lps'),
	(552276, 131, '2014-02-15 01:04:44.000000', 'consum', 0.0235, 'lps'),
	(552277, 131, '2014-02-15 01:04:45.000000', 'consum', 0.0222, 'lps'),
	(552278, 131, '2014-02-15 01:04:46.000000', 'consum', 0.0222, 'lps'),
	(552279, 131, '2014-02-15 01:04:47.000000', 'consum', 0.0237, 'lps'),
	(552280, 131, '2014-02-15 01:04:48.000000', 'consum', 0.0225, 'lps'),
	(552281, 131, '2014-02-15 01:04:49.000000', 'consum', 0.0230, 'lps'),
	(552282, 131, '2014-02-15 01:04:50.000000', 'consum', 0.0213, 'lps'),
	(552283, 131, '2014-02-15 01:04:51.000000', 'consum', 0.0221, 'lps'),
	(552284, 131, '2014-02-15 01:04:52.000000', 'consum', 0.0227, 'lps'),
	(552285, 131, '2014-02-15 01:04:53.000000', 'consum', 0.0234, 'lps'),
	(552286, 131, '2014-02-15 01:04:54.000000', 'consum', 0.0223, 'lps'),
	(552287, 131, '2014-02-15 01:04:55.000000', 'consum', 0.0230, 'lps'),
	(552288, 131, '2014-02-15 01:04:56.000000', 'consum', 0.0219, 'lps'),
	(552289, 131, '2014-02-15 01:04:57.000000', 'consum', 0.0221, 'lps'),
	(552290, 131, '2014-02-15 01:04:58.000000', 'consum', 0.0210, 'lps'),
	(552291, 131, '2014-02-15 01:04:59.000000', 'consum', 0.0235, 'lps'),
	(552292, 131, '2014-02-15 01:05:00.000000', 'consum', 0.0223, 'lps'),
	(552293, 131, '2014-02-15 01:05:01.000000', 'consum', 0.0231, 'lps'),
	(552294, 131, '2014-02-15 01:05:02.000000', 'consum', 0.0217, 'lps'),
	(552295, 131, '2014-02-15 01:05:03.000000', 'consum', 0.0213, 'lps'),
	(552296, 131, '2014-02-15 01:05:04.000000', 'consum', 0.0232, 'lps'),
	(552297, 131, '2014-02-15 01:05:05.000000', 'consum', 0.0229, 'lps'),
	(552298, 131, '2014-02-15 01:05:06.000000', 'consum', 0.0211, 'lps'),
	(552299, 131, '2014-02-15 01:05:07.000000', 'consum', 0.0213, 'lps'),
	(552300, 131, '2014-02-15 01:05:08.000000', 'consum', 0.0225, 'lps'),
	(552301, 131, '2014-02-15 01:05:09.000000', 'consum', 0.0220, 'lps'),
	(552302, 131, '2014-02-15 01:05:10.000000', 'consum', 0.0216, 'lps'),
	(552303, 131, '2014-02-15 01:05:11.000000', 'consum', 0.0211, 'lps'),
	(552304, 131, '2014-02-15 01:05:12.000000', 'consum', 0.0226, 'lps'),
	(552305, 131, '2014-02-15 01:05:13.000000', 'consum', 0.0232, 'lps'),
	(552306, 131, '2014-02-15 01:05:14.000000', 'consum', 0.0216, 'lps'),
	(552307, 131, '2014-02-15 01:05:15.000000', 'consum', 0.0232, 'lps'),
	(552308, 131, '2014-02-15 01:05:16.000000', 'consum', 0.0217, 'lps'),
	(552309, 131, '2014-02-15 01:05:17.000000', 'consum', 0.0237, 'lps'),
	(552310, 131, '2014-02-15 01:05:18.000000', 'consum', 0.0213, 'lps'),
	(552311, 131, '2014-02-15 01:05:19.000000', 'consum', 0.0226, 'lps'),
	(552312, 131, '2014-02-15 01:05:20.000000', 'consum', 0.0225, 'lps'),
	(552313, 131, '2014-02-15 01:05:21.000000', 'consum', 0.0237, 'lps'),
	(552314, 131, '2014-02-15 01:05:22.000000', 'consum', 0.0216, 'lps'),
	(552315, 131, '2014-02-15 01:05:23.000000', 'consum', 0.0215, 'lps'),
	(552316, 131, '2014-02-15 01:05:24.000000', 'consum', 0.0217, 'lps'),
	(552317, 131, '2014-02-15 01:05:25.000000', 'consum', 0.0232, 'lps'),
	(552318, 131, '2014-02-15 01:05:26.000000', 'consum', 0.0216, 'lps'),
	(552319, 131, '2014-02-15 01:05:27.000000', 'consum', 0.0229, 'lps'),
	(552320, 131, '2014-02-15 01:05:28.000000', 'consum', 0.0230, 'lps'),
	(552321, 131, '2014-02-15 01:05:29.000000', 'consum', 0.0229, 'lps'),
	(552322, 131, '2014-02-15 01:05:30.000000', 'consum', 0.0215, 'lps'),
	(552323, 131, '2014-02-15 01:05:31.000000', 'consum', 0.0237, 'lps'),
	(552324, 131, '2014-02-15 01:05:32.000000', 'consum', 0.0218, 'lps'),
	(552325, 131, '2014-02-15 01:05:33.000000', 'consum', 0.0227, 'lps'),
	(552326, 131, '2014-02-15 01:05:34.000000', 'consum', 0.0214, 'lps'),
	(552327, 131, '2014-02-15 01:05:35.000000', 'consum', 0.0234, 'lps'),
	(552328, 131, '2014-02-15 01:05:36.000000', 'consum', 0.0234, 'lps'),
	(552329, 131, '2014-02-15 01:05:37.000000', 'consum', 0.0232, 'lps'),
	(552330, 131, '2014-02-15 01:05:38.000000', 'consum', 0.0218, 'lps'),
	(552331, 131, '2014-02-15 01:05:39.000000', 'consum', 0.0215, 'lps'),
	(552332, 131, '2014-02-15 01:05:40.000000', 'consum', 0.0213, 'lps'),
	(552333, 127, '2014-03-01 00:00:00.000000', 'consum', 0.0226, 'lps'),
	(552334, 127, '2014-03-01 00:00:01.000000', 'consum', 0.0218, 'lps'),
	(552335, 127, '2014-03-01 00:00:02.000000', 'consum', 0.0234, 'lps'),
	(552336, 127, '2014-03-01 00:00:03.000000', 'consum', 0.0218, 'lps'),
	(552337, 127, '2014-03-01 00:00:04.000000', 'consum', 0.0238, 'lps'),
	(552338, 127, '2014-03-01 00:00:05.000000', 'consum', 0.0210, 'lps'),
	(552339, 127, '2014-03-01 00:00:06.000000', 'consum', 0.0211, 'lps'),
	(552340, 127, '2014-03-01 00:00:07.000000', 'consum', 0.0219, 'lps'),
	(552341, 127, '2014-03-01 00:00:08.000000', 'consum', 0.0223, 'lps'),
	(552342, 127, '2014-03-01 00:00:09.000000', 'consum', 0.0219, 'lps'),
	(552343, 127, '2014-03-01 00:00:10.000000', 'consum', 0.0217, 'lps'),
	(552344, 127, '2014-03-01 00:00:11.000000', 'consum', 0.0218, 'lps'),
	(552345, 127, '2014-03-01 00:00:12.000000', 'consum', 0.0228, 'lps'),
	(552346, 127, '2014-03-01 00:00:13.000000', 'consum', 0.0221, 'lps'),
	(552347, 127, '2014-03-01 00:00:14.000000', 'consum', 0.0238, 'lps'),
	(552348, 127, '2014-03-01 00:00:15.000000', 'consum', 0.0231, 'lps'),
	(552349, 127, '2014-03-01 00:00:16.000000', 'consum', 0.0233, 'lps'),
	(552350, 127, '2014-03-01 00:00:17.000000', 'consum', 0.0231, 'lps'),
	(552351, 127, '2014-03-01 00:00:18.000000', 'consum', 0.0220, 'lps'),
	(552352, 127, '2014-03-01 00:00:19.000000', 'consum', 0.0227, 'lps'),
	(552353, 127, '2014-03-01 00:00:20.000000', 'consum', 0.0238, 'lps'),
	(552354, 127, '2014-03-01 00:00:21.000000', 'consum', 0.0238, 'lps'),
	(552355, 127, '2014-03-01 00:00:22.000000', 'consum', 0.0210, 'lps'),
	(552356, 127, '2014-03-01 00:00:23.000000', 'consum', 0.0214, 'lps'),
	(552357, 127, '2014-03-01 00:00:24.000000', 'consum', 0.0230, 'lps'),
	(552358, 127, '2014-03-01 00:00:25.000000', 'consum', 0.0211, 'lps'),
	(552359, 127, '2014-03-01 00:00:26.000000', 'consum', 0.0215, 'lps'),
	(552360, 127, '2014-03-01 00:00:27.000000', 'consum', 0.0233, 'lps'),
	(552361, 127, '2014-03-01 00:00:28.000000', 'consum', 0.0221, 'lps'),
	(552362, 127, '2014-03-01 00:00:29.000000', 'consum', 0.0226, 'lps'),
	(552363, 127, '2014-03-01 00:00:30.000000', 'consum', 0.0228, 'lps'),
	(552364, 127, '2014-03-01 00:00:31.000000', 'consum', 0.0226, 'lps'),
	(552365, 127, '2014-03-01 00:00:32.000000', 'consum', 0.0234, 'lps'),
	(552366, 127, '2014-03-01 00:00:33.000000', 'consum', 0.0224, 'lps'),
	(552367, 127, '2014-03-01 00:00:34.000000', 'consum', 0.0237, 'lps'),
	(552368, 127, '2014-03-01 00:00:35.000000', 'consum', 0.0218, 'lps'),
	(552369, 127, '2014-03-01 00:00:36.000000', 'consum', 0.0227, 'lps'),
	(552370, 127, '2014-03-01 00:00:37.000000', 'consum', 0.0213, 'lps'),
	(552371, 127, '2014-03-01 00:00:38.000000', 'consum', 0.0234, 'lps'),
	(552372, 127, '2014-03-01 00:00:39.000000', 'consum', 0.0233, 'lps'),
	(552373, 127, '2014-03-01 00:00:40.000000', 'consum', 0.0225, 'lps'),
	(552374, 127, '2014-03-01 00:00:41.000000', 'consum', 0.0216, 'lps'),
	(552375, 127, '2014-03-01 00:00:42.000000', 'consum', 0.0226, 'lps'),
	(552376, 127, '2014-03-01 00:00:43.000000', 'consum', 0.0212, 'lps'),
	(552377, 127, '2014-03-01 00:00:44.000000', 'consum', 0.0233, 'lps'),
	(552378, 127, '2014-03-01 00:00:45.000000', 'consum', 0.0232, 'lps'),
	(552379, 127, '2014-03-01 00:00:46.000000', 'consum', 0.0224, 'lps'),
	(552380, 127, '2014-03-01 00:00:47.000000', 'consum', 0.0213, 'lps'),
	(552381, 127, '2014-03-01 00:00:48.000000', 'consum', 0.0211, 'lps'),
	(552382, 127, '2014-03-01 00:00:49.000000', 'consum', 0.0238, 'lps'),
	(552383, 127, '2014-03-01 00:00:50.000000', 'consum', 0.0231, 'lps'),
	(552384, 127, '2014-03-01 00:00:51.000000', 'consum', 0.0233, 'lps'),
	(552385, 127, '2014-03-01 00:00:52.000000', 'consum', 0.0233, 'lps'),
	(552386, 127, '2014-03-01 00:00:53.000000', 'consum', 0.0228, 'lps'),
	(552387, 127, '2014-03-01 00:00:54.000000', 'consum', 0.0231, 'lps'),
	(552388, 127, '2014-03-01 00:00:55.000000', 'consum', 0.0231, 'lps'),
	(552389, 127, '2014-03-01 00:00:56.000000', 'consum', 0.0226, 'lps'),
	(552390, 127, '2014-03-01 00:00:57.000000', 'consum', 0.0227, 'lps'),
	(552391, 127, '2014-03-01 00:00:58.000000', 'consum', 0.0218, 'lps'),
	(552392, 127, '2014-03-01 00:00:59.000000', 'consum', 0.0228, 'lps'),
	(552393, 127, '2014-03-01 00:01:00.000000', 'consum', 0.0220, 'lps'),
	(552394, 127, '2014-03-01 00:01:01.000000', 'consum', 0.0237, 'lps'),
	(552395, 127, '2014-03-01 00:01:02.000000', 'consum', 0.0226, 'lps'),
	(552396, 127, '2014-03-01 00:01:03.000000', 'consum', 0.0237, 'lps'),
	(552397, 127, '2014-03-01 00:01:04.000000', 'consum', 0.0213, 'lps'),
	(552398, 127, '2014-03-01 00:01:05.000000', 'consum', 0.0232, 'lps'),
	(552399, 127, '2014-03-01 00:01:06.000000', 'consum', 0.0222, 'lps'),
	(552400, 127, '2014-03-01 00:01:07.000000', 'consum', 0.0237, 'lps'),
	(552401, 127, '2014-03-01 00:01:08.000000', 'consum', 0.0219, 'lps'),
	(552402, 127, '2014-03-01 00:01:09.000000', 'consum', 0.0234, 'lps'),
	(552403, 127, '2014-03-01 00:01:10.000000', 'consum', 0.0216, 'lps'),
	(552404, 127, '2014-03-01 00:01:11.000000', 'consum', 0.0227, 'lps'),
	(552405, 127, '2014-03-01 00:01:12.000000', 'consum', 0.0220, 'lps'),
	(552406, 127, '2014-03-01 00:01:13.000000', 'consum', 0.0236, 'lps'),
	(552407, 127, '2014-03-01 00:01:14.000000', 'consum', 0.0227, 'lps'),
	(552408, 127, '2014-03-01 00:01:15.000000', 'consum', 0.0215, 'lps'),
	(552409, 127, '2014-03-01 00:01:16.000000', 'consum', 0.0215, 'lps'),
	(552410, 127, '2014-03-01 00:01:17.000000', 'consum', 0.0218, 'lps'),
	(552411, 127, '2014-03-01 00:01:18.000000', 'consum', 0.0238, 'lps'),
	(552412, 127, '2014-03-01 00:01:19.000000', 'consum', 0.0211, 'lps'),
	(552413, 127, '2014-03-01 00:01:20.000000', 'consum', 0.0217, 'lps'),
	(552414, 127, '2014-03-01 00:01:21.000000', 'consum', 0.0215, 'lps'),
	(552415, 127, '2014-03-01 00:01:22.000000', 'consum', 0.0214, 'lps'),
	(552416, 127, '2014-03-01 00:01:23.000000', 'consum', 0.0217, 'lps'),
	(552417, 127, '2014-03-01 00:01:24.000000', 'consum', 0.0230, 'lps'),
	(552418, 127, '2014-03-01 00:01:25.000000', 'consum', 0.0234, 'lps'),
	(552419, 127, '2014-03-01 00:01:26.000000', 'consum', 0.0214, 'lps'),
	(552420, 127, '2014-03-01 00:01:27.000000', 'consum', 0.0215, 'lps'),
	(552421, 127, '2014-03-01 00:01:28.000000', 'consum', 0.0222, 'lps'),
	(552422, 127, '2014-03-01 00:01:29.000000', 'consum', 0.0228, 'lps'),
	(552423, 127, '2014-03-01 00:01:30.000000', 'consum', 0.0235, 'lps'),
	(552424, 127, '2014-03-01 00:01:31.000000', 'consum', 0.0222, 'lps'),
	(552425, 127, '2014-03-01 00:01:32.000000', 'consum', 0.0224, 'lps'),
	(552426, 127, '2014-03-01 00:01:33.000000', 'consum', 0.0216, 'lps'),
	(552427, 127, '2014-03-01 00:01:34.000000', 'consum', 0.0230, 'lps'),
	(552428, 127, '2014-03-01 00:01:35.000000', 'consum', 0.0232, 'lps'),
	(552429, 127, '2014-03-01 00:01:36.000000', 'consum', 0.0234, 'lps'),
	(552430, 127, '2014-03-01 00:01:37.000000', 'consum', 0.0233, 'lps'),
	(552431, 127, '2014-03-01 00:01:38.000000', 'consum', 0.0225, 'lps'),
	(552432, 127, '2014-03-01 00:01:39.000000', 'consum', 0.0215, 'lps'),
	(552433, 127, '2014-03-01 00:01:40.000000', 'consum', 0.0223, 'lps'),
	(552434, 127, '2014-03-01 00:01:41.000000', 'consum', 0.0229, 'lps'),
	(552435, 127, '2014-03-01 00:01:42.000000', 'consum', 0.0238, 'lps'),
	(552436, 127, '2014-03-01 00:01:43.000000', 'consum', 0.0236, 'lps'),
	(552437, 127, '2014-03-01 00:01:44.000000', 'consum', 0.0228, 'lps'),
	(552438, 127, '2014-03-01 00:01:45.000000', 'consum', 0.0221, 'lps'),
	(552439, 127, '2014-03-01 00:01:46.000000', 'consum', 0.0211, 'lps'),
	(552440, 127, '2014-03-01 00:01:47.000000', 'consum', 0.0211, 'lps'),
	(552441, 127, '2014-03-01 00:01:48.000000', 'consum', 0.0215, 'lps'),
	(552442, 127, '2014-03-01 00:01:49.000000', 'consum', 0.0229, 'lps'),
	(552443, 127, '2014-03-01 00:01:50.000000', 'consum', 0.0236, 'lps'),
	(552444, 127, '2014-03-01 00:01:51.000000', 'consum', 0.0222, 'lps'),
	(552445, 127, '2014-03-01 00:01:52.000000', 'consum', 0.0223, 'lps'),
	(552446, 127, '2014-03-01 00:01:53.000000', 'consum', 0.0213, 'lps'),
	(552447, 127, '2014-03-01 00:01:54.000000', 'consum', 0.0212, 'lps'),
	(552448, 127, '2014-03-01 00:01:55.000000', 'consum', 0.0214, 'lps'),
	(552449, 127, '2014-03-01 00:01:56.000000', 'consum', 0.0223, 'lps'),
	(552450, 127, '2014-03-01 00:01:57.000000', 'consum', 0.0235, 'lps'),
	(552451, 127, '2014-03-01 00:01:58.000000', 'consum', 0.0237, 'lps'),
	(552452, 127, '2014-03-01 00:01:59.000000', 'consum', 0.0214, 'lps'),
	(552453, 127, '2014-03-01 00:02:00.000000', 'consum', 0.0235, 'lps'),
	(552454, 127, '2014-03-01 00:02:01.000000', 'consum', 0.0238, 'lps'),
	(552455, 127, '2014-03-01 00:02:02.000000', 'consum', 0.0215, 'lps'),
	(552456, 127, '2014-03-01 00:02:03.000000', 'consum', 0.0211, 'lps'),
	(552457, 127, '2014-03-01 00:02:04.000000', 'consum', 0.0229, 'lps'),
	(552458, 127, '2014-03-01 00:02:05.000000', 'consum', 0.0218, 'lps'),
	(552459, 127, '2014-03-01 00:02:06.000000', 'consum', 0.0219, 'lps'),
	(552460, 127, '2014-03-01 00:02:07.000000', 'consum', 0.0234, 'lps'),
	(552461, 127, '2014-03-01 00:02:08.000000', 'consum', 0.0218, 'lps'),
	(552462, 127, '2014-03-01 00:02:09.000000', 'consum', 0.0234, 'lps'),
	(552463, 127, '2014-03-01 00:02:10.000000', 'consum', 0.0221, 'lps'),
	(552464, 127, '2014-03-01 00:02:11.000000', 'consum', 0.0223, 'lps'),
	(552465, 127, '2014-03-01 00:02:12.000000', 'consum', 0.0212, 'lps'),
	(552466, 127, '2014-03-01 00:02:13.000000', 'consum', 0.0238, 'lps'),
	(552467, 127, '2014-03-01 00:02:14.000000', 'consum', 0.0231, 'lps'),
	(552468, 127, '2014-03-01 00:02:15.000000', 'consum', 0.0229, 'lps'),
	(552469, 127, '2014-03-01 00:02:16.000000', 'consum', 0.0217, 'lps'),
	(552470, 127, '2014-03-01 00:02:17.000000', 'consum', 0.0214, 'lps'),
	(552471, 127, '2014-03-01 00:02:18.000000', 'consum', 0.0211, 'lps'),
	(552472, 127, '2014-03-01 00:02:19.000000', 'consum', 0.0233, 'lps'),
	(552473, 127, '2014-03-01 00:02:20.000000', 'consum', 0.0236, 'lps'),
	(552474, 127, '2014-03-01 00:02:21.000000', 'consum', 0.0213, 'lps'),
	(552475, 127, '2014-03-01 00:02:22.000000', 'consum', 0.0234, 'lps'),
	(552476, 127, '2014-03-01 00:02:23.000000', 'consum', 0.0234, 'lps'),
	(552477, 127, '2014-03-01 00:02:24.000000', 'consum', 0.0232, 'lps'),
	(552478, 127, '2014-03-01 00:02:25.000000', 'consum', 0.0217, 'lps'),
	(552479, 127, '2014-03-01 00:02:26.000000', 'consum', 0.0210, 'lps'),
	(552480, 127, '2014-03-01 00:02:27.000000', 'consum', 0.0219, 'lps'),
	(552481, 127, '2014-03-01 00:02:28.000000', 'consum', 0.0228, 'lps'),
	(552482, 127, '2014-03-01 00:02:29.000000', 'consum', 0.0212, 'lps'),
	(552483, 127, '2014-03-01 00:02:30.000000', 'consum', 0.0226, 'lps'),
	(552484, 127, '2014-03-01 00:02:31.000000', 'consum', 0.0225, 'lps'),
	(552485, 127, '2014-03-01 00:02:32.000000', 'consum', 0.0238, 'lps'),
	(552486, 127, '2014-03-01 00:02:33.000000', 'consum', 0.0217, 'lps'),
	(552487, 127, '2014-03-01 00:02:34.000000', 'consum', 0.0220, 'lps'),
	(552488, 127, '2014-03-01 00:02:35.000000', 'consum', 0.0213, 'lps'),
	(552489, 127, '2014-03-01 00:02:36.000000', 'consum', 0.0221, 'lps'),
	(552490, 127, '2014-03-01 00:02:37.000000', 'consum', 0.0230, 'lps'),
	(552491, 127, '2014-03-01 00:02:38.000000', 'consum', 0.0220, 'lps'),
	(552492, 127, '2014-03-01 00:02:39.000000', 'consum', 0.0230, 'lps'),
	(552493, 127, '2014-03-01 00:02:40.000000', 'consum', 0.0220, 'lps'),
	(552494, 127, '2014-03-01 00:02:41.000000', 'consum', 0.0231, 'lps'),
	(552495, 127, '2014-03-01 00:02:42.000000', 'consum', 0.0227, 'lps'),
	(552496, 127, '2014-03-01 00:02:43.000000', 'consum', 0.0234, 'lps'),
	(552497, 127, '2014-03-01 00:02:44.000000', 'consum', 0.0220, 'lps'),
	(552498, 127, '2014-03-01 00:02:45.000000', 'consum', 0.0218, 'lps'),
	(552499, 127, '2014-03-01 00:02:46.000000', 'consum', 0.0219, 'lps'),
	(552500, 127, '2014-03-01 00:02:47.000000', 'consum', 0.0232, 'lps'),
	(552501, 127, '2014-03-01 00:02:48.000000', 'consum', 0.0237, 'lps'),
	(552502, 127, '2014-03-01 00:02:49.000000', 'consum', 0.0222, 'lps'),
	(552503, 127, '2014-03-01 00:02:50.000000', 'consum', 0.0219, 'lps'),
	(552504, 127, '2014-03-01 00:02:51.000000', 'consum', 0.0218, 'lps'),
	(552505, 127, '2014-03-01 00:02:52.000000', 'consum', 0.0223, 'lps'),
	(552506, 127, '2014-03-01 00:02:53.000000', 'consum', 0.0224, 'lps'),
	(552507, 127, '2014-03-01 00:02:54.000000', 'consum', 0.0210, 'lps'),
	(552508, 127, '2014-03-01 00:02:55.000000', 'consum', 0.0229, 'lps'),
	(552509, 127, '2014-03-01 00:02:56.000000', 'consum', 0.0219, 'lps'),
	(552510, 127, '2014-03-01 00:02:57.000000', 'consum', 0.0226, 'lps'),
	(552511, 127, '2014-03-01 00:02:58.000000', 'consum', 0.0235, 'lps'),
	(552512, 127, '2014-03-01 00:02:59.000000', 'consum', 0.0231, 'lps'),
	(552513, 127, '2014-03-01 00:03:00.000000', 'consum', 0.0212, 'lps'),
	(552514, 127, '2014-03-01 00:03:01.000000', 'consum', 0.0214, 'lps'),
	(552515, 127, '2014-03-01 00:03:02.000000', 'consum', 0.0227, 'lps'),
	(552516, 127, '2014-03-01 00:03:03.000000', 'consum', 0.0222, 'lps'),
	(552517, 127, '2014-03-01 00:03:04.000000', 'consum', 0.0220, 'lps'),
	(552518, 127, '2014-03-01 00:03:05.000000', 'consum', 0.0227, 'lps'),
	(552519, 127, '2014-03-01 00:03:06.000000', 'consum', 0.0235, 'lps'),
	(552520, 127, '2014-03-01 00:03:07.000000', 'consum', 0.0225, 'lps'),
	(552521, 127, '2014-03-01 00:03:08.000000', 'consum', 0.0210, 'lps'),
	(552522, 127, '2014-03-01 00:03:09.000000', 'consum', 0.0225, 'lps'),
	(552523, 127, '2014-03-01 00:03:10.000000', 'consum', 0.0228, 'lps'),
	(552524, 127, '2014-03-01 00:03:11.000000', 'consum', 0.0227, 'lps'),
	(552525, 127, '2014-03-01 00:03:12.000000', 'consum', 0.0213, 'lps'),
	(552526, 127, '2014-03-01 00:03:13.000000', 'consum', 0.0231, 'lps'),
	(552527, 127, '2014-03-01 00:03:14.000000', 'consum', 0.0220, 'lps'),
	(552528, 127, '2014-03-01 00:03:15.000000', 'consum', 0.0227, 'lps'),
	(552529, 127, '2014-03-01 00:03:16.000000', 'consum', 0.0236, 'lps'),
	(552530, 127, '2014-03-01 00:03:17.000000', 'consum', 0.0231, 'lps'),
	(552531, 127, '2014-03-01 00:03:18.000000', 'consum', 0.0238, 'lps'),
	(552532, 127, '2014-03-01 00:03:19.000000', 'consum', 0.0229, 'lps'),
	(552533, 127, '2014-03-01 00:03:20.000000', 'consum', 0.0223, 'lps'),
	(552534, 127, '2014-03-01 00:03:21.000000', 'consum', 0.0216, 'lps'),
	(552535, 127, '2014-03-01 00:03:22.000000', 'consum', 0.0231, 'lps'),
	(552536, 127, '2014-03-01 00:03:23.000000', 'consum', 0.0238, 'lps'),
	(552537, 127, '2014-03-01 00:03:24.000000', 'consum', 0.0231, 'lps'),
	(552538, 127, '2014-03-01 00:03:25.000000', 'consum', 0.0233, 'lps'),
	(552539, 127, '2014-03-01 00:03:26.000000', 'consum', 0.0233, 'lps'),
	(552540, 127, '2014-03-01 00:03:27.000000', 'consum', 0.0226, 'lps'),
	(552541, 127, '2014-03-01 00:03:28.000000', 'consum', 0.0221, 'lps'),
	(552542, 127, '2014-03-01 00:03:29.000000', 'consum', 0.0217, 'lps'),
	(552543, 127, '2014-03-01 00:03:30.000000', 'consum', 0.0215, 'lps'),
	(552544, 127, '2014-03-01 00:03:31.000000', 'consum', 0.0214, 'lps'),
	(552545, 127, '2014-03-01 00:03:32.000000', 'consum', 0.0215, 'lps'),
	(552546, 127, '2014-03-01 00:03:33.000000', 'consum', 0.0225, 'lps'),
	(552547, 127, '2014-03-01 00:03:34.000000', 'consum', 0.0213, 'lps'),
	(552548, 127, '2014-03-01 00:03:35.000000', 'consum', 0.0236, 'lps'),
	(552549, 127, '2014-03-01 00:03:36.000000', 'consum', 0.0217, 'lps'),
	(552550, 127, '2014-03-01 00:03:37.000000', 'consum', 0.0223, 'lps'),
	(552551, 127, '2014-03-01 00:03:38.000000', 'consum', 0.0227, 'lps'),
	(552552, 127, '2014-03-01 00:03:39.000000', 'consum', 0.0229, 'lps'),
	(552553, 127, '2014-03-01 00:03:40.000000', 'consum', 0.0226, 'lps'),
	(552554, 127, '2014-03-01 00:03:41.000000', 'consum', 0.0234, 'lps'),
	(552555, 127, '2014-03-01 00:03:42.000000', 'consum', 0.0223, 'lps'),
	(552556, 127, '2014-03-01 00:03:43.000000', 'consum', 0.0233, 'lps'),
	(552557, 127, '2014-03-01 00:03:44.000000', 'consum', 0.0226, 'lps'),
	(552558, 127, '2014-03-01 00:03:45.000000', 'consum', 0.0225, 'lps'),
	(552559, 127, '2014-03-01 00:03:46.000000', 'consum', 0.0237, 'lps'),
	(552560, 127, '2014-03-01 00:03:47.000000', 'consum', 0.0211, 'lps'),
	(552561, 127, '2014-03-01 00:03:48.000000', 'consum', 0.0222, 'lps'),
	(552562, 127, '2014-03-01 00:03:49.000000', 'consum', 0.0211, 'lps'),
	(552563, 127, '2014-03-01 00:03:50.000000', 'consum', 0.0235, 'lps'),
	(552564, 127, '2014-03-01 00:03:51.000000', 'consum', 0.0218, 'lps'),
	(552565, 127, '2014-03-01 00:03:52.000000', 'consum', 0.0232, 'lps'),
	(552566, 127, '2014-03-01 00:03:53.000000', 'consum', 0.0238, 'lps'),
	(552567, 127, '2014-03-01 00:03:54.000000', 'consum', 0.0228, 'lps'),
	(552568, 127, '2014-03-01 00:03:55.000000', 'consum', 0.0218, 'lps'),
	(552569, 127, '2014-03-01 00:03:56.000000', 'consum', 0.0225, 'lps'),
	(552570, 127, '2014-03-01 00:03:57.000000', 'consum', 0.0230, 'lps'),
	(552571, 127, '2014-03-01 00:03:58.000000', 'consum', 0.0238, 'lps'),
	(552572, 127, '2014-03-01 00:03:59.000000', 'consum', 0.0233, 'lps'),
	(552573, 127, '2014-03-01 00:04:00.000000', 'consum', 0.0211, 'lps'),
	(552574, 127, '2014-03-01 00:04:01.000000', 'consum', 0.0235, 'lps'),
	(552575, 127, '2014-03-01 00:04:02.000000', 'consum', 0.0217, 'lps'),
	(552576, 127, '2014-03-01 00:04:03.000000', 'consum', 0.0227, 'lps'),
	(552577, 127, '2014-03-01 00:04:04.000000', 'consum', 0.0216, 'lps'),
	(552578, 127, '2014-03-01 00:04:05.000000', 'consum', 0.0220, 'lps'),
	(552579, 127, '2014-03-01 00:04:06.000000', 'consum', 0.0213, 'lps'),
	(552580, 127, '2014-03-01 00:04:07.000000', 'consum', 0.0224, 'lps'),
	(552581, 127, '2014-03-01 00:04:08.000000', 'consum', 0.0212, 'lps'),
	(552582, 127, '2014-03-01 00:04:09.000000', 'consum', 0.0237, 'lps'),
	(552583, 127, '2014-03-01 00:04:10.000000', 'consum', 0.0223, 'lps'),
	(552584, 127, '2014-03-01 00:04:11.000000', 'consum', 0.0225, 'lps'),
	(552585, 127, '2014-03-01 00:04:12.000000', 'consum', 0.0217, 'lps'),
	(552586, 127, '2014-03-01 00:04:13.000000', 'consum', 0.0231, 'lps'),
	(552587, 127, '2014-03-01 00:04:14.000000', 'consum', 0.0235, 'lps'),
	(552588, 127, '2014-03-01 00:04:15.000000', 'consum', 0.0217, 'lps'),
	(552589, 127, '2014-03-01 00:04:16.000000', 'consum', 0.0226, 'lps'),
	(552590, 127, '2014-03-01 00:04:17.000000', 'consum', 0.0213, 'lps'),
	(552591, 127, '2014-03-01 00:04:18.000000', 'consum', 0.0234, 'lps'),
	(552592, 127, '2014-03-01 00:04:19.000000', 'consum', 0.0236, 'lps'),
	(552593, 127, '2014-03-01 00:04:20.000000', 'consum', 0.0211, 'lps'),
	(552594, 127, '2014-03-01 00:04:21.000000', 'consum', 0.0226, 'lps'),
	(552595, 127, '2014-03-01 00:04:22.000000', 'consum', 0.0226, 'lps'),
	(552596, 127, '2014-03-01 00:04:23.000000', 'consum', 0.0214, 'lps'),
	(552597, 127, '2014-03-01 00:04:24.000000', 'consum', 0.0213, 'lps'),
	(552598, 127, '2014-03-01 00:04:25.000000', 'consum', 0.0212, 'lps'),
	(552599, 127, '2014-03-01 00:04:26.000000', 'consum', 0.0213, 'lps'),
	(552600, 127, '2014-03-01 00:04:27.000000', 'consum', 0.0221, 'lps'),
	(552601, 127, '2014-03-01 00:04:28.000000', 'consum', 0.0226, 'lps'),
	(552602, 127, '2014-03-01 00:04:29.000000', 'consum', 0.0227, 'lps'),
	(552603, 127, '2014-03-01 00:04:30.000000', 'consum', 0.0218, 'lps'),
	(552604, 127, '2014-03-01 00:04:31.000000', 'consum', 0.0229, 'lps'),
	(552605, 127, '2014-03-01 00:04:32.000000', 'consum', 0.0226, 'lps'),
	(552606, 127, '2014-03-01 00:04:33.000000', 'consum', 0.0230, 'lps'),
	(552607, 127, '2014-03-01 00:04:34.000000', 'consum', 0.0235, 'lps'),
	(552608, 127, '2014-03-01 00:04:35.000000', 'consum', 0.0215, 'lps'),
	(552609, 127, '2014-03-01 00:04:36.000000', 'consum', 0.0222, 'lps'),
	(552610, 127, '2014-03-01 00:04:37.000000', 'consum', 0.0225, 'lps'),
	(552611, 127, '2014-03-01 00:04:38.000000', 'consum', 0.0220, 'lps'),
	(552612, 127, '2014-03-01 00:04:39.000000', 'consum', 0.0217, 'lps'),
	(552613, 127, '2014-03-01 00:04:40.000000', 'consum', 0.0215, 'lps'),
	(552614, 127, '2014-03-01 00:04:41.000000', 'consum', 0.0215, 'lps'),
	(552615, 127, '2014-03-01 00:04:42.000000', 'consum', 0.0221, 'lps'),
	(552616, 127, '2014-03-01 00:04:43.000000', 'consum', 0.0223, 'lps'),
	(552617, 127, '2014-03-01 00:04:44.000000', 'consum', 0.0211, 'lps'),
	(552618, 127, '2014-03-01 00:04:45.000000', 'consum', 0.0235, 'lps'),
	(552619, 127, '2014-03-01 00:04:46.000000', 'consum', 0.0218, 'lps'),
	(552620, 127, '2014-03-01 00:04:47.000000', 'consum', 0.0234, 'lps'),
	(552621, 127, '2014-03-01 00:04:48.000000', 'consum', 0.0219, 'lps'),
	(552622, 127, '2014-03-01 00:04:49.000000', 'consum', 0.0211, 'lps'),
	(552623, 127, '2014-03-01 00:04:50.000000', 'consum', 0.0219, 'lps'),
	(552624, 127, '2014-03-01 00:04:51.000000', 'consum', 0.0224, 'lps'),
	(552625, 127, '2014-03-01 00:04:52.000000', 'consum', 0.0222, 'lps'),
	(552626, 127, '2014-03-01 00:04:53.000000', 'consum', 0.0231, 'lps'),
	(552627, 127, '2014-03-01 00:04:54.000000', 'consum', 0.0221, 'lps'),
	(552628, 127, '2014-03-01 00:04:55.000000', 'consum', 0.0230, 'lps'),
	(552629, 127, '2014-03-01 00:04:56.000000', 'consum', 0.0222, 'lps'),
	(552630, 127, '2014-03-01 00:04:57.000000', 'consum', 0.0211, 'lps'),
	(552631, 127, '2014-03-01 00:04:58.000000', 'consum', 0.0238, 'lps'),
	(552632, 127, '2014-03-01 00:04:59.000000', 'consum', 0.0230, 'lps'),
	(552633, 127, '2014-03-01 00:05:00.000000', 'consum', 0.0227, 'lps'),
	(552634, 127, '2014-03-01 00:05:01.000000', 'consum', 0.0236, 'lps'),
	(552635, 127, '2014-03-01 00:05:02.000000', 'consum', 0.0231, 'lps'),
	(552636, 127, '2014-03-01 00:05:03.000000', 'consum', 0.0235, 'lps'),
	(552637, 127, '2014-03-01 00:05:04.000000', 'consum', 0.0218, 'lps'),
	(552638, 127, '2014-03-01 00:05:05.000000', 'consum', 0.0233, 'lps'),
	(552639, 127, '2014-03-01 00:05:06.000000', 'consum', 0.0213, 'lps'),
	(552640, 127, '2014-03-01 00:05:07.000000', 'consum', 0.0216, 'lps'),
	(552641, 127, '2014-03-01 00:05:08.000000', 'consum', 0.0230, 'lps'),
	(552642, 127, '2014-03-01 00:05:09.000000', 'consum', 0.0233, 'lps'),
	(552643, 127, '2014-03-01 00:05:10.000000', 'consum', 0.0210, 'lps'),
	(552644, 127, '2014-03-01 00:05:11.000000', 'consum', 0.0226, 'lps'),
	(552645, 127, '2014-03-01 00:05:12.000000', 'consum', 0.0233, 'lps'),
	(552646, 127, '2014-03-01 00:05:13.000000', 'consum', 0.0221, 'lps'),
	(552647, 127, '2014-03-01 00:05:14.000000', 'consum', 0.0223, 'lps'),
	(552648, 127, '2014-03-01 00:05:15.000000', 'consum', 0.0215, 'lps'),
	(552649, 127, '2014-03-01 00:05:16.000000', 'consum', 0.0226, 'lps'),
	(552650, 127, '2014-03-01 00:05:17.000000', 'consum', 0.0216, 'lps'),
	(552651, 127, '2014-03-01 00:05:18.000000', 'consum', 0.0224, 'lps'),
	(552652, 127, '2014-03-01 00:05:19.000000', 'consum', 0.0230, 'lps'),
	(552653, 127, '2014-03-01 00:05:20.000000', 'consum', 0.0214, 'lps'),
	(552654, 127, '2014-03-01 00:05:21.000000', 'consum', 0.0228, 'lps'),
	(552655, 127, '2014-03-01 00:05:22.000000', 'consum', 0.0228, 'lps'),
	(552656, 127, '2014-03-01 00:05:23.000000', 'consum', 0.0219, 'lps'),
	(552657, 127, '2014-03-01 00:05:24.000000', 'consum', 0.0231, 'lps'),
	(552658, 127, '2014-03-01 00:05:25.000000', 'consum', 0.0231, 'lps'),
	(552659, 127, '2014-03-01 00:05:26.000000', 'consum', 0.0223, 'lps'),
	(552660, 127, '2014-03-01 00:05:27.000000', 'consum', 0.0211, 'lps'),
	(552661, 127, '2014-03-01 00:05:28.000000', 'consum', 0.0235, 'lps'),
	(552662, 127, '2014-03-01 00:05:29.000000', 'consum', 0.0216, 'lps'),
	(552663, 127, '2014-03-01 00:05:30.000000', 'consum', 0.0225, 'lps'),
	(552664, 127, '2014-03-01 00:05:31.000000', 'consum', 0.0237, 'lps'),
	(552665, 127, '2014-03-01 00:05:32.000000', 'consum', 0.0213, 'lps'),
	(552666, 127, '2014-03-01 00:05:33.000000', 'consum', 0.0234, 'lps'),
	(552667, 127, '2014-03-01 00:05:34.000000', 'consum', 0.0233, 'lps'),
	(552668, 127, '2014-03-01 00:05:35.000000', 'consum', 0.0224, 'lps'),
	(552669, 127, '2014-03-01 00:05:36.000000', 'consum', 0.0213, 'lps'),
	(552670, 127, '2014-03-01 00:05:37.000000', 'consum', 0.0213, 'lps'),
	(552671, 127, '2014-03-01 00:05:38.000000', 'consum', 0.0217, 'lps'),
	(552672, 127, '2014-03-01 00:05:39.000000', 'consum', 0.0236, 'lps'),
	(552673, 127, '2014-03-01 00:05:40.000000', 'consum', 0.0230, 'lps'),
	(552674, 127, '2014-03-01 00:05:41.000000', 'consum', 0.0235, 'lps'),
	(552675, 127, '2014-03-01 00:05:42.000000', 'consum', 0.0217, 'lps'),
	(552676, 127, '2014-03-01 00:05:43.000000', 'consum', 0.0227, 'lps'),
	(552677, 127, '2014-03-01 00:05:44.000000', 'consum', 0.0217, 'lps'),
	(552678, 127, '2014-03-01 00:05:45.000000', 'consum', 0.0225, 'lps'),
	(552679, 127, '2014-03-01 00:05:46.000000', 'consum', 0.0236, 'lps'),
	(552680, 127, '2014-03-01 00:05:47.000000', 'consum', 0.0237, 'lps'),
	(552681, 127, '2014-03-01 00:05:48.000000', 'consum', 0.0238, 'lps'),
	(552682, 127, '2014-03-01 00:05:49.000000', 'consum', 0.0213, 'lps'),
	(552683, 127, '2014-03-01 00:05:50.000000', 'consum', 0.0229, 'lps'),
	(552684, 127, '2014-03-01 00:05:51.000000', 'consum', 0.0237, 'lps'),
	(552685, 127, '2014-03-01 00:05:52.000000', 'consum', 0.0232, 'lps'),
	(552686, 127, '2014-03-01 00:05:53.000000', 'consum', 0.0237, 'lps'),
	(552687, 127, '2014-03-01 00:05:54.000000', 'consum', 0.0224, 'lps'),
	(552688, 127, '2014-03-01 00:05:55.000000', 'consum', 0.0229, 'lps'),
	(552689, 127, '2014-03-01 00:05:56.000000', 'consum', 0.0234, 'lps'),
	(552690, 127, '2014-03-01 00:05:57.000000', 'consum', 0.0214, 'lps'),
	(552691, 127, '2014-03-01 00:05:58.000000', 'consum', 0.0217, 'lps'),
	(552692, 127, '2014-03-01 00:05:59.000000', 'consum', 0.0232, 'lps'),
	(552693, 127, '2014-03-01 00:06:00.000000', 'consum', 0.0212, 'lps'),
	(552694, 127, '2014-03-01 00:06:01.000000', 'consum', 0.0215, 'lps'),
	(552695, 127, '2014-03-01 00:06:02.000000', 'consum', 0.0227, 'lps'),
	(552696, 127, '2014-03-01 00:06:03.000000', 'consum', 0.0223, 'lps'),
	(552697, 127, '2014-03-01 00:06:04.000000', 'consum', 0.0225, 'lps'),
	(552698, 127, '2014-03-01 00:06:05.000000', 'consum', 0.0216, 'lps'),
	(552699, 127, '2014-03-01 00:06:06.000000', 'consum', 0.0227, 'lps'),
	(552700, 127, '2014-03-01 00:06:07.000000', 'consum', 0.0220, 'lps'),
	(552701, 127, '2014-03-01 00:06:08.000000', 'consum', 0.0210, 'lps'),
	(552702, 127, '2014-03-01 00:06:09.000000', 'consum', 0.0238, 'lps'),
	(552703, 127, '2014-03-01 00:06:10.000000', 'consum', 0.0234, 'lps'),
	(552704, 127, '2014-03-01 00:06:11.000000', 'consum', 0.0218, 'lps'),
	(552705, 127, '2014-03-01 00:06:12.000000', 'consum', 0.0238, 'lps'),
	(552706, 127, '2014-03-01 00:06:13.000000', 'consum', 0.0237, 'lps'),
	(552707, 127, '2014-03-01 00:06:14.000000', 'consum', 0.0235, 'lps'),
	(552708, 127, '2014-03-01 00:06:15.000000', 'consum', 0.0226, 'lps'),
	(552709, 127, '2014-03-01 00:06:16.000000', 'consum', 0.0216, 'lps'),
	(552710, 127, '2014-03-01 00:06:17.000000', 'consum', 0.0221, 'lps'),
	(552711, 127, '2014-03-01 00:06:18.000000', 'consum', 0.0219, 'lps'),
	(552712, 127, '2014-03-01 00:06:19.000000', 'consum', 0.0221, 'lps'),
	(552713, 127, '2014-03-01 00:06:20.000000', 'consum', 0.0210, 'lps'),
	(552714, 127, '2014-03-01 00:06:21.000000', 'consum', 0.0235, 'lps'),
	(552715, 127, '2014-03-01 00:06:22.000000', 'consum', 0.0218, 'lps'),
	(552716, 127, '2014-03-01 00:06:23.000000', 'consum', 0.0235, 'lps'),
	(552717, 127, '2014-03-01 00:06:24.000000', 'consum', 0.0223, 'lps'),
	(552718, 127, '2014-03-01 00:06:25.000000', 'consum', 0.0231, 'lps'),
	(552719, 127, '2014-03-01 00:06:26.000000', 'consum', 0.0218, 'lps'),
	(552720, 127, '2014-03-01 00:06:27.000000', 'consum', 0.0219, 'lps'),
	(552721, 127, '2014-03-01 00:06:28.000000', 'consum', 0.0228, 'lps'),
	(552722, 127, '2014-03-01 00:06:29.000000', 'consum', 0.0219, 'lps'),
	(552723, 127, '2014-03-01 00:06:30.000000', 'consum', 0.0228, 'lps'),
	(552724, 127, '2014-03-01 00:06:31.000000', 'consum', 0.0214, 'lps'),
	(552725, 127, '2014-03-01 00:06:32.000000', 'consum', 0.0237, 'lps'),
	(552726, 127, '2014-03-01 00:06:33.000000', 'consum', 0.0215, 'lps'),
	(552727, 127, '2014-03-01 00:06:34.000000', 'consum', 0.0213, 'lps'),
	(552728, 127, '2014-03-01 00:06:35.000000', 'consum', 0.0210, 'lps'),
	(552729, 127, '2014-03-01 00:06:36.000000', 'consum', 0.0232, 'lps'),
	(552730, 127, '2014-03-01 00:06:37.000000', 'consum', 0.0231, 'lps'),
	(552731, 127, '2014-03-01 00:06:38.000000', 'consum', 0.0221, 'lps'),
	(552732, 127, '2014-03-01 00:06:39.000000', 'consum', 0.0234, 'lps'),
	(552733, 127, '2014-03-01 00:06:40.000000', 'consum', 0.0237, 'lps'),
	(552734, 127, '2014-03-01 00:06:41.000000', 'consum', 0.0217, 'lps'),
	(552735, 127, '2014-03-01 00:06:42.000000', 'consum', 0.0222, 'lps'),
	(552736, 127, '2014-03-01 00:06:43.000000', 'consum', 0.0221, 'lps'),
	(552737, 127, '2014-03-01 00:06:44.000000', 'consum', 0.0231, 'lps'),
	(552738, 127, '2014-03-01 00:06:45.000000', 'consum', 0.0222, 'lps'),
	(552739, 127, '2014-03-01 00:06:46.000000', 'consum', 0.0237, 'lps'),
	(552740, 127, '2014-03-01 00:06:47.000000', 'consum', 0.0224, 'lps'),
	(552741, 127, '2014-03-01 00:06:48.000000', 'consum', 0.0228, 'lps'),
	(552742, 127, '2014-03-01 00:06:49.000000', 'consum', 0.0227, 'lps'),
	(552743, 127, '2014-03-01 00:06:50.000000', 'consum', 0.0216, 'lps'),
	(552744, 127, '2014-03-01 00:06:51.000000', 'consum', 0.0216, 'lps'),
	(552745, 127, '2014-03-01 00:06:52.000000', 'consum', 0.0222, 'lps'),
	(552746, 127, '2014-03-01 00:06:53.000000', 'consum', 0.0226, 'lps'),
	(552747, 127, '2014-03-01 00:06:54.000000', 'consum', 0.0224, 'lps'),
	(552748, 127, '2014-03-01 00:06:55.000000', 'consum', 0.0233, 'lps'),
	(552749, 127, '2014-03-01 00:06:56.000000', 'consum', 0.0225, 'lps'),
	(552750, 127, '2014-03-01 00:06:57.000000', 'consum', 0.0218, 'lps'),
	(552751, 127, '2014-03-01 00:06:58.000000', 'consum', 0.0232, 'lps'),
	(552752, 127, '2014-03-01 00:06:59.000000', 'consum', 0.0210, 'lps'),
	(552753, 127, '2014-03-01 00:07:00.000000', 'consum', 0.0233, 'lps'),
	(552754, 127, '2014-03-01 00:07:01.000000', 'consum', 0.0210, 'lps'),
	(552755, 127, '2014-03-01 00:07:02.000000', 'consum', 0.0226, 'lps'),
	(552756, 127, '2014-03-01 00:07:03.000000', 'consum', 0.0232, 'lps'),
	(552757, 127, '2014-03-01 00:07:04.000000', 'consum', 0.0215, 'lps'),
	(552758, 127, '2014-03-01 00:07:05.000000', 'consum', 0.0227, 'lps'),
	(552759, 127, '2014-03-01 00:07:06.000000', 'consum', 0.0223, 'lps'),
	(552760, 127, '2014-03-01 00:07:07.000000', 'consum', 0.0224, 'lps'),
	(552761, 127, '2014-03-01 00:07:08.000000', 'consum', 0.0211, 'lps'),
	(552762, 127, '2014-03-01 00:07:09.000000', 'consum', 0.0232, 'lps'),
	(552763, 127, '2014-03-01 00:07:10.000000', 'consum', 0.0231, 'lps'),
	(552764, 127, '2014-03-01 00:07:11.000000', 'consum', 0.0221, 'lps'),
	(552765, 127, '2014-03-01 00:07:12.000000', 'consum', 0.0230, 'lps'),
	(552766, 127, '2014-03-01 00:07:13.000000', 'consum', 0.0221, 'lps'),
	(552767, 127, '2014-03-01 00:07:14.000000', 'consum', 0.0234, 'lps'),
	(552768, 127, '2014-03-01 00:07:15.000000', 'consum', 0.0212, 'lps'),
	(552769, 127, '2014-03-01 00:07:16.000000', 'consum', 0.0236, 'lps'),
	(552770, 127, '2014-03-01 00:07:17.000000', 'consum', 0.0219, 'lps'),
	(552771, 127, '2014-03-01 00:07:18.000000', 'consum', 0.0235, 'lps'),
	(552772, 127, '2014-03-01 00:07:19.000000', 'consum', 0.0223, 'lps'),
	(552773, 127, '2014-03-01 00:07:20.000000', 'consum', 0.0228, 'lps'),
	(552774, 127, '2014-03-01 00:07:21.000000', 'consum', 0.0234, 'lps'),
	(552775, 127, '2014-03-01 00:07:22.000000', 'consum', 0.0217, 'lps'),
	(552776, 127, '2014-03-01 00:07:23.000000', 'consum', 0.0234, 'lps'),
	(552777, 127, '2014-03-01 00:07:24.000000', 'consum', 0.0220, 'lps'),
	(552778, 127, '2014-03-01 00:07:25.000000', 'consum', 0.0218, 'lps'),
	(552779, 127, '2014-03-01 00:07:26.000000', 'consum', 0.0220, 'lps'),
	(552780, 127, '2014-03-01 00:07:27.000000', 'consum', 0.0235, 'lps'),
	(552781, 127, '2014-03-01 00:07:28.000000', 'consum', 0.0222, 'lps'),
	(552782, 127, '2014-03-01 00:07:29.000000', 'consum', 0.0222, 'lps'),
	(552783, 127, '2014-03-01 00:07:30.000000', 'consum', 0.0234, 'lps'),
	(552784, 127, '2014-03-01 00:07:31.000000', 'consum', 0.0210, 'lps'),
	(552785, 127, '2014-03-01 00:07:32.000000', 'consum', 0.0226, 'lps'),
	(552786, 127, '2014-03-01 00:07:33.000000', 'consum', 0.0232, 'lps'),
	(552787, 127, '2014-03-01 00:07:34.000000', 'consum', 0.0214, 'lps'),
	(552788, 127, '2014-03-01 00:07:35.000000', 'consum', 0.0224, 'lps'),
	(552789, 127, '2014-03-01 00:07:36.000000', 'consum', 0.0210, 'lps'),
	(552790, 127, '2014-03-01 00:07:37.000000', 'consum', 0.0226, 'lps'),
	(552791, 127, '2014-03-01 00:07:38.000000', 'consum', 0.0232, 'lps'),
	(552792, 127, '2014-03-01 00:07:39.000000', 'consum', 0.0214, 'lps'),
	(552793, 127, '2014-03-01 00:07:40.000000', 'consum', 0.0223, 'lps'),
	(552794, 127, '2014-03-01 00:07:41.000000', 'consum', 0.0233, 'lps'),
	(552795, 127, '2014-03-01 00:07:42.000000', 'consum', 0.0229, 'lps'),
	(552796, 127, '2014-03-01 00:07:43.000000', 'consum', 0.0238, 'lps'),
	(552797, 127, '2014-03-01 00:07:44.000000', 'consum', 0.0235, 'lps'),
	(552798, 127, '2014-03-01 00:07:45.000000', 'consum', 0.0224, 'lps'),
	(552799, 127, '2014-03-01 00:07:46.000000', 'consum', 0.0234, 'lps'),
	(552800, 127, '2014-03-01 00:07:47.000000', 'consum', 0.0231, 'lps'),
	(552801, 127, '2014-03-01 00:07:48.000000', 'consum', 0.0214, 'lps'),
	(552802, 127, '2014-03-01 00:07:49.000000', 'consum', 0.0226, 'lps'),
	(552803, 127, '2014-03-01 00:07:50.000000', 'consum', 0.0220, 'lps'),
	(552804, 127, '2014-03-01 00:07:51.000000', 'consum', 0.0212, 'lps'),
	(552805, 127, '2014-03-01 00:07:52.000000', 'consum', 0.0219, 'lps'),
	(552806, 127, '2014-03-01 00:07:53.000000', 'consum', 0.0221, 'lps'),
	(552807, 127, '2014-03-01 00:07:54.000000', 'consum', 0.0237, 'lps'),
	(552808, 127, '2014-03-01 00:07:55.000000', 'consum', 0.0228, 'lps'),
	(552809, 127, '2014-03-01 00:07:56.000000', 'consum', 0.0219, 'lps'),
	(552810, 127, '2014-03-01 00:07:57.000000', 'consum', 0.0230, 'lps'),
	(552811, 127, '2014-03-01 00:07:58.000000', 'consum', 0.0225, 'lps'),
	(552812, 127, '2014-03-01 00:07:59.000000', 'consum', 0.0228, 'lps'),
	(552813, 127, '2014-03-01 00:08:00.000000', 'consum', 0.0224, 'lps'),
	(552814, 127, '2014-03-01 00:08:01.000000', 'consum', 0.0227, 'lps'),
	(552815, 127, '2014-03-01 00:08:02.000000', 'consum', 0.0225, 'lps'),
	(552816, 127, '2014-03-01 00:08:03.000000', 'consum', 0.0234, 'lps'),
	(552817, 127, '2014-03-01 00:08:04.000000', 'consum', 0.0228, 'lps'),
	(552818, 127, '2014-03-01 00:08:05.000000', 'consum', 0.0230, 'lps'),
	(552819, 127, '2014-03-01 00:08:06.000000', 'consum', 0.0228, 'lps'),
	(552820, 127, '2014-03-01 00:08:07.000000', 'consum', 0.0238, 'lps'),
	(552821, 127, '2014-03-01 00:08:08.000000', 'consum', 0.0210, 'lps'),
	(552822, 127, '2014-03-01 00:08:09.000000', 'consum', 0.0213, 'lps'),
	(552823, 127, '2014-03-01 00:08:10.000000', 'consum', 0.0225, 'lps'),
	(552824, 127, '2014-03-01 00:08:11.000000', 'consum', 0.0217, 'lps'),
	(552825, 127, '2014-03-01 00:08:12.000000', 'consum', 0.0233, 'lps'),
	(552826, 127, '2014-03-01 00:08:13.000000', 'consum', 0.0215, 'lps'),
	(552827, 127, '2014-03-01 00:08:14.000000', 'consum', 0.0227, 'lps'),
	(552828, 127, '2014-03-01 00:08:15.000000', 'consum', 0.0220, 'lps'),
	(552829, 127, '2014-03-01 00:08:16.000000', 'consum', 0.0211, 'lps'),
	(552830, 127, '2014-03-01 00:08:17.000000', 'consum', 0.0214, 'lps'),
	(552831, 127, '2014-03-01 00:08:18.000000', 'consum', 0.0227, 'lps'),
	(552832, 127, '2014-03-01 00:08:19.000000', 'consum', 0.0225, 'lps'),
	(552833, 127, '2014-03-01 00:08:20.000000', 'consum', 0.0235, 'lps'),
	(552834, 127, '2014-03-01 00:08:21.000000', 'consum', 0.0232, 'lps'),
	(552835, 127, '2014-03-01 00:08:22.000000', 'consum', 0.0217, 'lps'),
	(552836, 127, '2014-03-01 00:08:23.000000', 'consum', 0.0237, 'lps'),
	(552837, 127, '2014-03-01 00:08:24.000000', 'consum', 0.0210, 'lps'),
	(552838, 127, '2014-03-01 00:08:25.000000', 'consum', 0.0215, 'lps'),
	(552839, 127, '2014-03-01 00:08:26.000000', 'consum', 0.0236, 'lps'),
	(552840, 127, '2014-03-01 00:08:27.000000', 'consum', 0.0210, 'lps'),
	(552841, 127, '2014-03-01 00:08:28.000000', 'consum', 0.0218, 'lps'),
	(552842, 127, '2014-03-01 00:08:29.000000', 'consum', 0.0222, 'lps'),
	(552843, 127, '2014-03-01 00:08:30.000000', 'consum', 0.0217, 'lps'),
	(552844, 127, '2014-03-01 00:08:31.000000', 'consum', 0.0238, 'lps'),
	(552845, 127, '2014-03-01 00:08:32.000000', 'consum', 0.0216, 'lps'),
	(552846, 127, '2014-03-01 00:08:33.000000', 'consum', 0.0214, 'lps'),
	(552847, 127, '2014-03-01 00:08:34.000000', 'consum', 0.0211, 'lps'),
	(552848, 127, '2014-03-01 00:08:35.000000', 'consum', 0.0232, 'lps'),
	(552849, 127, '2014-03-01 00:08:36.000000', 'consum', 0.0233, 'lps'),
	(552850, 127, '2014-03-01 00:08:37.000000', 'consum', 0.0231, 'lps'),
	(552851, 127, '2014-03-01 00:08:38.000000', 'consum', 0.0214, 'lps'),
	(552852, 127, '2014-03-01 00:08:39.000000', 'consum', 0.0229, 'lps'),
	(552853, 127, '2014-03-01 00:08:40.000000', 'consum', 0.0232, 'lps'),
	(552854, 127, '2014-03-01 00:08:41.000000', 'consum', 0.0237, 'lps'),
	(552855, 127, '2014-03-01 00:08:42.000000', 'consum', 0.0223, 'lps'),
	(552856, 127, '2014-03-01 00:08:43.000000', 'consum', 0.0221, 'lps'),
	(552857, 127, '2014-03-01 00:08:44.000000', 'consum', 0.0228, 'lps'),
	(552858, 127, '2014-03-01 00:08:45.000000', 'consum', 0.0238, 'lps'),
	(552859, 127, '2014-03-01 00:08:46.000000', 'consum', 0.0238, 'lps'),
	(552860, 127, '2014-03-01 00:08:47.000000', 'consum', 0.0210, 'lps'),
	(552861, 127, '2014-03-01 00:08:48.000000', 'consum', 0.0213, 'lps'),
	(552862, 127, '2014-03-01 00:08:49.000000', 'consum', 0.0223, 'lps'),
	(552863, 127, '2014-03-01 00:08:50.000000', 'consum', 0.0211, 'lps'),
	(552864, 127, '2014-03-01 00:08:51.000000', 'consum', 0.0235, 'lps'),
	(552865, 127, '2014-03-01 00:08:52.000000', 'consum', 0.0217, 'lps'),
	(552866, 127, '2014-03-01 00:08:53.000000', 'consum', 0.0227, 'lps'),
	(552867, 127, '2014-03-01 00:08:54.000000', 'consum', 0.0215, 'lps'),
	(552868, 127, '2014-03-01 00:08:55.000000', 'consum', 0.0217, 'lps'),
	(552869, 127, '2014-03-01 00:08:56.000000', 'consum', 0.0227, 'lps'),
	(552870, 127, '2014-03-01 00:08:57.000000', 'consum', 0.0219, 'lps'),
	(552871, 127, '2014-03-01 00:08:58.000000', 'consum', 0.0232, 'lps'),
	(552872, 127, '2014-03-01 00:08:59.000000', 'consum', 0.0238, 'lps'),
	(552873, 127, '2014-03-01 00:09:00.000000', 'consum', 0.0223, 'lps'),
	(552874, 127, '2014-03-01 00:09:01.000000', 'consum', 0.0224, 'lps'),
	(552875, 127, '2014-03-01 00:09:02.000000', 'consum', 0.0211, 'lps'),
	(552876, 127, '2014-03-01 00:09:03.000000', 'consum', 0.0233, 'lps'),
	(552877, 127, '2014-03-01 00:09:04.000000', 'consum', 0.0234, 'lps'),
	(552878, 127, '2014-03-01 00:09:05.000000', 'consum', 0.0231, 'lps'),
	(552879, 127, '2014-03-01 00:09:06.000000', 'consum', 0.0215, 'lps'),
	(552880, 127, '2014-03-01 00:09:07.000000', 'consum', 0.0230, 'lps'),
	(552881, 127, '2014-03-01 00:09:08.000000', 'consum', 0.0237, 'lps'),
	(552882, 127, '2014-03-01 00:09:09.000000', 'consum', 0.0228, 'lps'),
	(552883, 127, '2014-03-01 00:09:10.000000', 'consum', 0.0219, 'lps'),
	(552884, 127, '2014-03-01 00:09:11.000000', 'consum', 0.0230, 'lps'),
	(552885, 127, '2014-03-01 00:09:12.000000', 'consum', 0.0226, 'lps'),
	(552886, 127, '2014-03-01 00:09:13.000000', 'consum', 0.0231, 'lps'),
	(552887, 127, '2014-03-01 00:09:14.000000', 'consum', 0.0211, 'lps'),
	(552888, 127, '2014-03-01 00:09:15.000000', 'consum', 0.0237, 'lps'),
	(552889, 127, '2014-03-01 00:09:16.000000', 'consum', 0.0225, 'lps'),
	(552890, 127, '2014-03-01 00:09:17.000000', 'consum', 0.0237, 'lps'),
	(552891, 127, '2014-03-01 00:09:18.000000', 'consum', 0.0213, 'lps'),
	(552892, 127, '2014-03-01 00:09:19.000000', 'consum', 0.0230, 'lps'),
	(552893, 127, '2014-03-01 00:09:20.000000', 'consum', 0.0217, 'lps'),
	(552894, 127, '2014-03-01 00:09:21.000000', 'consum', 0.0214, 'lps'),
	(552895, 127, '2014-03-01 00:09:22.000000', 'consum', 0.0211, 'lps'),
	(552896, 127, '2014-03-01 00:09:23.000000', 'consum', 0.0231, 'lps'),
	(552897, 127, '2014-03-01 00:09:24.000000', 'consum', 0.0224, 'lps'),
	(552898, 127, '2014-03-01 00:09:25.000000', 'consum', 0.0219, 'lps'),
	(552899, 127, '2014-03-01 00:09:26.000000', 'consum', 0.0212, 'lps'),
	(552900, 127, '2014-03-01 00:09:27.000000', 'consum', 0.0224, 'lps'),
	(552901, 127, '2014-03-01 00:09:28.000000', 'consum', 0.0216, 'lps'),
	(552902, 127, '2014-03-01 00:09:29.000000', 'consum', 0.0225, 'lps'),
	(552903, 127, '2014-03-01 00:09:30.000000', 'consum', 0.0213, 'lps'),
	(552904, 127, '2014-03-01 00:09:31.000000', 'consum', 0.0210, 'lps'),
	(552905, 127, '2014-03-01 00:09:32.000000', 'consum', 0.0229, 'lps'),
	(552906, 127, '2014-03-01 00:09:33.000000', 'consum', 0.0219, 'lps'),
	(552907, 127, '2014-03-01 00:09:34.000000', 'consum', 0.0226, 'lps'),
	(552908, 127, '2014-03-01 00:09:35.000000', 'consum', 0.0235, 'lps'),
	(552909, 127, '2014-03-01 00:09:36.000000', 'consum', 0.0230, 'lps'),
	(552910, 127, '2014-03-01 00:09:37.000000', 'consum', 0.0234, 'lps'),
	(552911, 127, '2014-03-01 00:09:38.000000', 'consum', 0.0215, 'lps'),
	(552912, 127, '2014-03-01 00:09:39.000000', 'consum', 0.0222, 'lps'),
	(552913, 127, '2014-03-01 00:09:40.000000', 'consum', 0.0225, 'lps'),
	(552914, 127, '2014-03-01 00:09:41.000000', 'consum', 0.0221, 'lps'),
	(552915, 127, '2014-03-01 00:09:42.000000', 'consum', 0.0222, 'lps'),
	(552916, 127, '2014-03-01 00:09:43.000000', 'consum', 0.0237, 'lps'),
	(552917, 127, '2014-03-01 00:09:44.000000', 'consum', 0.0223, 'lps'),
	(552918, 127, '2014-03-01 00:09:45.000000', 'consum', 0.0222, 'lps'),
	(552919, 127, '2014-03-01 00:09:46.000000', 'consum', 0.0233, 'lps'),
	(552920, 127, '2014-03-01 00:09:47.000000', 'consum', 0.0231, 'lps'),
	(552921, 127, '2014-03-01 00:09:48.000000', 'consum', 0.0216, 'lps'),
	(552922, 127, '2014-03-01 00:09:49.000000', 'consum', 0.0236, 'lps'),
	(552923, 127, '2014-03-01 00:09:50.000000', 'consum', 0.0235, 'lps'),
	(552924, 127, '2014-03-01 00:09:51.000000', 'consum', 0.0227, 'lps'),
	(552925, 127, '2014-03-01 00:09:52.000000', 'consum', 0.0224, 'lps'),
	(552926, 127, '2014-03-01 00:09:53.000000', 'consum', 0.0227, 'lps'),
	(552927, 127, '2014-03-01 00:09:54.000000', 'consum', 0.0224, 'lps'),
	(552928, 127, '2014-03-01 00:09:55.000000', 'consum', 0.0231, 'lps'),
	(552929, 127, '2014-03-01 00:09:56.000000', 'consum', 0.0214, 'lps'),
	(552930, 127, '2014-03-01 00:09:57.000000', 'consum', 0.0227, 'lps'),
	(552931, 127, '2014-03-01 00:09:58.000000', 'consum', 0.0224, 'lps'),
	(552932, 127, '2014-03-01 00:09:59.000000', 'consum', 0.0231, 'lps'),
	(552933, 127, '2014-03-01 00:10:00.000000', 'consum', 0.0216, 'lps'),
	(552934, 127, '2014-03-01 00:10:01.000000', 'consum', 0.0237, 'lps'),
	(552935, 127, '2014-03-01 00:10:02.000000', 'consum', 0.0238, 'lps'),
	(552936, 127, '2014-03-01 00:10:03.000000', 'consum', 0.0212, 'lps'),
	(552937, 127, '2014-03-01 00:10:04.000000', 'consum', 0.0224, 'lps'),
	(552938, 127, '2014-03-01 00:10:05.000000', 'consum', 0.0216, 'lps'),
	(552939, 127, '2014-03-01 00:10:06.000000', 'consum', 0.0227, 'lps'),
	(552940, 127, '2014-03-01 00:10:07.000000', 'consum', 0.0222, 'lps'),
	(552941, 127, '2014-03-01 00:10:08.000000', 'consum', 0.0218, 'lps'),
	(552942, 127, '2014-03-01 00:10:09.000000', 'consum', 0.0216, 'lps'),
	(552943, 127, '2014-03-01 00:10:10.000000', 'consum', 0.0214, 'lps'),
	(552944, 127, '2014-03-01 00:10:11.000000', 'consum', 0.0213, 'lps'),
	(552945, 127, '2014-03-01 00:10:12.000000', 'consum', 0.0213, 'lps'),
	(552946, 127, '2014-03-01 00:10:13.000000', 'consum', 0.0218, 'lps'),
	(552947, 127, '2014-03-01 00:10:14.000000', 'consum', 0.0210, 'lps'),
	(552948, 127, '2014-03-01 00:10:15.000000', 'consum', 0.0218, 'lps'),
	(552949, 127, '2014-03-01 00:10:16.000000', 'consum', 0.0221, 'lps'),
	(552950, 127, '2014-03-01 00:10:17.000000', 'consum', 0.0212, 'lps'),
	(552951, 127, '2014-03-01 00:10:18.000000', 'consum', 0.0218, 'lps'),
	(552952, 127, '2014-03-01 00:10:19.000000', 'consum', 0.0214, 'lps'),
	(552953, 127, '2014-03-01 00:10:20.000000', 'consum', 0.0235, 'lps'),
	(552954, 127, '2014-03-01 00:10:21.000000', 'consum', 0.0210, 'lps'),
	(552955, 127, '2014-03-01 00:10:22.000000', 'consum', 0.0221, 'lps'),
	(552956, 127, '2014-03-01 00:10:23.000000', 'consum', 0.0238, 'lps'),
	(552957, 127, '2014-03-01 00:10:24.000000', 'consum', 0.0230, 'lps'),
	(552958, 127, '2014-03-01 00:10:25.000000', 'consum', 0.0227, 'lps'),
	(552959, 127, '2014-03-01 00:10:26.000000', 'consum', 0.0235, 'lps'),
	(552960, 127, '2014-03-01 00:10:27.000000', 'consum', 0.0226, 'lps'),
	(552961, 127, '2014-03-01 00:10:28.000000', 'consum', 0.0216, 'lps'),
	(552962, 127, '2014-03-01 00:10:29.000000', 'consum', 0.0219, 'lps'),
	(552963, 127, '2014-03-01 00:10:30.000000', 'consum', 0.0212, 'lps'),
	(552964, 127, '2014-03-01 00:10:31.000000', 'consum', 0.0220, 'lps'),
	(552965, 127, '2014-03-01 00:10:32.000000', 'consum', 0.0226, 'lps'),
	(552966, 127, '2014-03-01 00:10:33.000000', 'consum', 0.0232, 'lps'),
	(552967, 127, '2014-03-01 00:10:34.000000', 'consum', 0.0216, 'lps'),
	(552968, 127, '2014-03-01 00:10:35.000000', 'consum', 0.0229, 'lps'),
	(552969, 127, '2014-03-01 00:10:36.000000', 'consum', 0.0232, 'lps'),
	(552970, 127, '2014-03-01 00:10:37.000000', 'consum', 0.0234, 'lps'),
	(552971, 127, '2014-03-01 00:10:38.000000', 'consum', 0.0236, 'lps'),
	(552972, 127, '2014-03-01 00:10:39.000000', 'consum', 0.0210, 'lps'),
	(552973, 127, '2014-03-01 00:10:40.000000', 'consum', 0.0218, 'lps'),
	(552974, 127, '2014-03-01 00:10:41.000000', 'consum', 0.0223, 'lps'),
	(552975, 127, '2014-03-01 00:10:42.000000', 'consum', 0.0221, 'lps'),
	(552976, 127, '2014-03-01 00:10:43.000000', 'consum', 0.0226, 'lps'),
	(552977, 127, '2014-03-01 00:10:44.000000', 'consum', 0.0230, 'lps'),
	(552978, 127, '2014-03-01 00:10:45.000000', 'consum', 0.0234, 'lps'),
	(552979, 127, '2014-03-01 00:10:46.000000', 'consum', 0.0212, 'lps'),
	(552980, 127, '2014-03-01 00:10:47.000000', 'consum', 0.0236, 'lps'),
	(552981, 127, '2014-03-01 00:10:48.000000', 'consum', 0.0218, 'lps'),
	(552982, 127, '2014-03-01 00:10:49.000000', 'consum', 0.0233, 'lps'),
	(552983, 127, '2014-03-01 00:10:50.000000', 'consum', 0.0211, 'lps'),
	(552984, 127, '2014-03-01 00:10:51.000000', 'consum', 0.0235, 'lps'),
	(552985, 127, '2014-03-01 00:10:52.000000', 'consum', 0.0217, 'lps'),
	(552986, 127, '2014-03-01 00:10:53.000000', 'consum', 0.0228, 'lps'),
	(552987, 127, '2014-03-01 00:10:54.000000', 'consum', 0.0219, 'lps'),
	(552988, 127, '2014-03-01 00:10:55.000000', 'consum', 0.0234, 'lps'),
	(552989, 127, '2014-03-01 00:10:56.000000', 'consum', 0.0215, 'lps'),
	(552990, 127, '2014-03-01 00:10:57.000000', 'consum', 0.0222, 'lps'),
	(552991, 127, '2014-03-01 00:10:58.000000', 'consum', 0.0227, 'lps'),
	(552992, 127, '2014-03-01 00:10:59.000000', 'consum', 0.0232, 'lps'),
	(552993, 127, '2014-03-01 00:11:00.000000', 'consum', 0.0210, 'lps'),
	(552994, 127, '2014-03-01 00:11:01.000000', 'consum', 0.0233, 'lps'),
	(552995, 127, '2014-03-01 00:11:02.000000', 'consum', 0.0236, 'lps'),
	(552996, 127, '2014-03-01 00:11:03.000000', 'consum', 0.0214, 'lps'),
	(552997, 127, '2014-03-01 00:11:04.000000', 'consum', 0.0211, 'lps'),
	(552998, 127, '2014-03-01 00:11:05.000000', 'consum', 0.0234, 'lps'),
	(552999, 127, '2014-03-01 00:11:06.000000', 'consum', 0.0211, 'lps'),
	(553000, 127, '2014-03-01 00:11:07.000000', 'consum', 0.0232, 'lps'),
	(553001, 127, '2014-03-01 00:11:08.000000', 'consum', 0.0229, 'lps'),
	(553002, 127, '2014-03-01 00:11:09.000000', 'consum', 0.0238, 'lps'),
	(553003, 127, '2014-03-01 00:11:10.000000', 'consum', 0.0238, 'lps'),
	(553004, 127, '2014-03-01 00:11:11.000000', 'consum', 0.0236, 'lps'),
	(553005, 127, '2014-03-01 00:11:12.000000', 'consum', 0.0228, 'lps'),
	(553006, 127, '2014-03-01 00:11:13.000000', 'consum', 0.0224, 'lps'),
	(553007, 127, '2014-03-01 00:11:14.000000', 'consum', 0.0227, 'lps'),
	(553008, 127, '2014-03-01 00:11:15.000000', 'consum', 0.0222, 'lps'),
	(553009, 127, '2014-03-01 00:11:16.000000', 'consum', 0.0222, 'lps'),
	(553010, 127, '2014-03-01 00:11:17.000000', 'consum', 0.0233, 'lps'),
	(553011, 127, '2014-03-01 00:11:18.000000', 'consum', 0.0233, 'lps'),
	(553012, 127, '2014-03-01 00:11:19.000000', 'consum', 0.0229, 'lps'),
	(553013, 127, '2014-03-01 00:11:20.000000', 'consum', 0.0234, 'lps'),
	(553014, 127, '2014-03-01 00:11:21.000000', 'consum', 0.0215, 'lps'),
	(553015, 127, '2014-03-01 00:11:22.000000', 'consum', 0.0223, 'lps'),
	(553016, 127, '2014-03-01 00:11:23.000000', 'consum', 0.0231, 'lps'),
	(553017, 127, '2014-03-01 00:11:24.000000', 'consum', 0.0220, 'lps'),
	(553018, 127, '2014-03-01 00:11:25.000000', 'consum', 0.0224, 'lps'),
	(553019, 127, '2014-03-01 00:11:26.000000', 'consum', 0.0223, 'lps'),
	(553020, 127, '2014-03-01 00:11:27.000000', 'consum', 0.0232, 'lps'),
	(553021, 127, '2014-03-01 00:11:28.000000', 'consum', 0.0225, 'lps'),
	(553022, 127, '2014-03-01 00:11:29.000000', 'consum', 0.0221, 'lps'),
	(553023, 127, '2014-03-01 00:11:30.000000', 'consum', 0.0217, 'lps'),
	(553024, 127, '2014-03-01 00:11:31.000000', 'consum', 0.0214, 'lps'),
	(553025, 127, '2014-03-01 00:11:32.000000', 'consum', 0.0238, 'lps'),
	(553026, 127, '2014-03-01 00:11:33.000000', 'consum', 0.0223, 'lps'),
	(553027, 127, '2014-03-01 00:11:34.000000', 'consum', 0.0218, 'lps'),
	(553028, 127, '2014-03-01 00:11:35.000000', 'consum', 0.0215, 'lps'),
	(553029, 127, '2014-03-01 00:11:36.000000', 'consum', 0.0238, 'lps'),
	(553030, 127, '2014-03-01 00:11:37.000000', 'consum', 0.0221, 'lps'),
	(553031, 127, '2014-03-01 00:11:38.000000', 'consum', 0.0212, 'lps'),
	(553032, 127, '2014-03-01 00:11:39.000000', 'consum', 0.0215, 'lps'),
	(553033, 127, '2014-03-01 00:11:40.000000', 'consum', 0.0229, 'lps'),
	(553034, 127, '2014-03-01 00:11:41.000000', 'consum', 0.0234, 'lps'),
	(553035, 127, '2014-03-01 00:11:42.000000', 'consum', 0.0213, 'lps'),
	(553036, 127, '2014-03-01 00:11:43.000000', 'consum', 0.0214, 'lps'),
	(553037, 127, '2014-03-01 00:11:44.000000', 'consum', 0.0219, 'lps'),
	(553038, 127, '2014-03-01 00:11:45.000000', 'consum', 0.0214, 'lps'),
	(553039, 127, '2014-03-01 00:11:46.000000', 'consum', 0.0234, 'lps'),
	(553040, 127, '2014-03-01 00:11:47.000000', 'consum', 0.0233, 'lps'),
	(553041, 127, '2014-03-01 00:11:48.000000', 'consum', 0.0222, 'lps'),
	(553042, 127, '2014-03-01 00:11:49.000000', 'consum', 0.0233, 'lps'),
	(553043, 127, '2014-03-01 00:11:50.000000', 'consum', 0.0229, 'lps'),
	(553044, 127, '2014-03-01 00:11:51.000000', 'consum', 0.0238, 'lps'),
	(553045, 127, '2014-03-01 00:11:52.000000', 'consum', 0.0236, 'lps'),
	(553046, 127, '2014-03-01 00:11:53.000000', 'consum', 0.0227, 'lps'),
	(553047, 127, '2014-03-01 00:11:54.000000', 'consum', 0.0220, 'lps'),
	(553048, 127, '2014-03-01 00:11:55.000000', 'consum', 0.0235, 'lps'),
	(553049, 127, '2014-03-01 00:11:56.000000', 'consum', 0.0218, 'lps'),
	(553050, 127, '2014-03-01 00:11:57.000000', 'consum', 0.0235, 'lps'),
	(553051, 127, '2014-03-01 00:11:58.000000', 'consum', 0.0223, 'lps'),
	(553052, 127, '2014-03-01 00:11:59.000000', 'consum', 0.0229, 'lps'),
	(553053, 127, '2014-03-01 00:12:00.000000', 'consum', 0.0237, 'lps'),
	(553054, 127, '2014-03-01 00:12:01.000000', 'consum', 0.0231, 'lps'),
	(553055, 127, '2014-03-01 00:12:02.000000', 'consum', 0.0234, 'lps'),
	(553056, 127, '2014-03-01 00:12:03.000000', 'consum', 0.0211, 'lps'),
	(553057, 127, '2014-03-01 00:12:04.000000', 'consum', 0.0231, 'lps'),
	(553058, 127, '2014-03-01 00:12:05.000000', 'consum', 0.0225, 'lps'),
	(553059, 127, '2014-03-01 00:12:06.000000', 'consum', 0.0224, 'lps'),
	(553060, 127, '2014-03-01 00:12:07.000000', 'consum', 0.0235, 'lps'),
	(553061, 127, '2014-03-01 00:12:08.000000', 'consum', 0.0235, 'lps'),
	(553062, 127, '2014-03-01 00:12:09.000000', 'consum', 0.0232, 'lps'),
	(553063, 127, '2014-03-01 00:12:10.000000', 'consum', 0.0216, 'lps'),
	(553064, 127, '2014-03-01 00:12:11.000000', 'consum', 0.0233, 'lps'),
	(553065, 127, '2014-03-01 00:12:12.000000', 'consum', 0.0221, 'lps'),
	(553066, 127, '2014-03-01 00:12:13.000000', 'consum', 0.0227, 'lps'),
	(553067, 127, '2014-03-01 00:12:14.000000', 'consum', 0.0232, 'lps'),
	(553068, 127, '2014-03-01 00:12:15.000000', 'consum', 0.0212, 'lps'),
	(553069, 127, '2014-03-01 00:12:16.000000', 'consum', 0.0213, 'lps'),
	(553070, 127, '2014-03-01 00:12:17.000000', 'consum', 0.0218, 'lps'),
	(553071, 127, '2014-03-01 00:12:18.000000', 'consum', 0.0211, 'lps'),
	(553072, 127, '2014-03-01 00:12:19.000000', 'consum', 0.0222, 'lps'),
	(553073, 127, '2014-03-01 00:12:20.000000', 'consum', 0.0210, 'lps'),
	(553074, 127, '2014-03-01 00:12:21.000000', 'consum', 0.0231, 'lps'),
	(553075, 127, '2014-03-01 00:12:22.000000', 'consum', 0.0228, 'lps'),
	(553076, 127, '2014-03-01 00:12:23.000000', 'consum', 0.0210, 'lps'),
	(553077, 127, '2014-03-01 00:12:24.000000', 'consum', 0.0213, 'lps'),
	(553078, 127, '2014-03-01 00:12:25.000000', 'consum', 0.0228, 'lps'),
	(553079, 127, '2014-03-01 00:12:26.000000', 'consum', 0.0233, 'lps'),
	(553080, 127, '2014-03-01 00:12:27.000000', 'consum', 0.0215, 'lps'),
	(553081, 127, '2014-03-01 00:12:28.000000', 'consum', 0.0222, 'lps'),
	(553082, 127, '2014-03-01 00:12:29.000000', 'consum', 0.0229, 'lps'),
	(553083, 127, '2014-03-01 00:12:30.000000', 'consum', 0.0211, 'lps'),
	(553084, 127, '2014-03-01 00:12:31.000000', 'consum', 0.0214, 'lps'),
	(553085, 127, '2014-03-01 00:12:32.000000', 'consum', 0.0229, 'lps'),
	(553086, 127, '2014-03-01 00:12:33.000000', 'consum', 0.0236, 'lps'),
	(553087, 127, '2014-03-01 00:12:34.000000', 'consum', 0.0226, 'lps'),
	(553088, 127, '2014-03-01 00:12:35.000000', 'consum', 0.0214, 'lps'),
	(553089, 127, '2014-03-01 00:12:36.000000', 'consum', 0.0237, 'lps'),
	(553090, 127, '2014-03-01 00:12:37.000000', 'consum', 0.0220, 'lps'),
	(553091, 127, '2014-03-01 00:12:38.000000', 'consum', 0.0237, 'lps'),
	(553092, 127, '2014-03-01 00:12:39.000000', 'consum', 0.0228, 'lps'),
	(553093, 127, '2014-03-01 00:12:40.000000', 'consum', 0.0218, 'lps'),
	(553094, 127, '2014-03-01 00:12:41.000000', 'consum', 0.0228, 'lps'),
	(553095, 127, '2014-03-01 00:12:42.000000', 'consum', 0.0219, 'lps'),
	(553096, 127, '2014-03-01 00:12:43.000000', 'consum', 0.0230, 'lps'),
	(553097, 127, '2014-03-01 00:12:44.000000', 'consum', 0.0224, 'lps'),
	(553098, 127, '2014-03-01 00:12:45.000000', 'consum', 0.0221, 'lps'),
	(553099, 127, '2014-03-01 00:12:46.000000', 'consum', 0.0223, 'lps'),
	(553100, 127, '2014-03-01 00:12:47.000000', 'consum', 0.0215, 'lps'),
	(553101, 127, '2014-03-01 00:12:48.000000', 'consum', 0.0225, 'lps'),
	(553102, 127, '2014-03-01 00:12:49.000000', 'consum', 0.0212, 'lps'),
	(553103, 127, '2014-03-01 00:12:50.000000', 'consum', 0.0233, 'lps'),
	(553104, 127, '2014-03-01 00:12:51.000000', 'consum', 0.0233, 'lps'),
	(553105, 127, '2014-03-01 00:12:52.000000', 'consum', 0.0226, 'lps'),
	(553106, 127, '2014-03-01 00:12:53.000000', 'consum', 0.0221, 'lps'),
	(553107, 127, '2014-03-01 00:12:54.000000', 'consum', 0.0218, 'lps'),
	(553108, 127, '2014-03-01 00:12:55.000000', 'consum', 0.0216, 'lps'),
	(553109, 127, '2014-03-01 00:12:56.000000', 'consum', 0.0217, 'lps'),
	(553110, 127, '2014-03-01 00:12:57.000000', 'consum', 0.0228, 'lps'),
	(553111, 127, '2014-03-01 00:12:58.000000', 'consum', 0.0221, 'lps'),
	(553112, 127, '2014-03-01 00:12:59.000000', 'consum', 0.0211, 'lps'),
	(553113, 127, '2014-03-01 00:13:00.000000', 'consum', 0.0211, 'lps'),
	(553114, 127, '2014-03-01 00:13:01.000000', 'consum', 0.0214, 'lps'),
	(553115, 127, '2014-03-01 00:13:02.000000', 'consum', 0.0228, 'lps'),
	(553116, 127, '2014-03-01 00:13:03.000000', 'consum', 0.0230, 'lps'),
	(553117, 127, '2014-03-01 00:13:04.000000', 'consum', 0.0229, 'lps'),
	(553118, 127, '2014-03-01 00:13:05.000000', 'consum', 0.0215, 'lps'),
	(553119, 127, '2014-03-01 00:13:06.000000', 'consum', 0.0235, 'lps'),
	(553120, 127, '2014-03-01 00:13:07.000000', 'consum', 0.0234, 'lps'),
	(553121, 127, '2014-03-01 00:13:08.000000', 'consum', 0.0229, 'lps'),
	(553122, 127, '2014-03-01 00:13:09.000000', 'consum', 0.0231, 'lps'),
	(553123, 127, '2014-03-01 00:13:10.000000', 'consum', 0.0231, 'lps'),
	(553124, 127, '2014-03-01 00:13:11.000000', 'consum', 0.0223, 'lps'),
	(553125, 127, '2014-03-01 00:13:12.000000', 'consum', 0.0214, 'lps'),
	(553126, 127, '2014-03-01 00:13:13.000000', 'consum', 0.0218, 'lps'),
	(553127, 127, '2014-03-01 00:13:14.000000', 'consum', 0.0210, 'lps'),
	(553128, 127, '2014-03-01 00:13:15.000000', 'consum', 0.0216, 'lps'),
	(553129, 127, '2014-03-01 00:13:16.000000', 'consum', 0.0212, 'lps'),
	(553130, 127, '2014-03-01 00:13:17.000000', 'consum', 0.0230, 'lps'),
	(553131, 127, '2014-03-01 00:13:18.000000', 'consum', 0.0218, 'lps'),
	(553132, 127, '2014-03-01 00:13:19.000000', 'consum', 0.0221, 'lps'),
	(553133, 127, '2014-03-01 00:13:20.000000', 'consum', 0.0210, 'lps'),
	(553134, 127, '2014-03-01 00:13:21.000000', 'consum', 0.0237, 'lps'),
	(553135, 127, '2014-03-01 00:13:22.000000', 'consum', 0.0231, 'lps'),
	(553136, 127, '2014-03-01 00:13:23.000000', 'consum', 0.0232, 'lps'),
	(553137, 127, '2014-03-01 00:13:24.000000', 'consum', 0.0229, 'lps'),
	(553138, 127, '2014-03-01 00:13:25.000000', 'consum', 0.0210, 'lps'),
	(553139, 127, '2014-03-01 00:13:26.000000', 'consum', 0.0210, 'lps'),
	(553140, 127, '2014-03-01 00:13:27.000000', 'consum', 0.0212, 'lps'),
	(553141, 127, '2014-03-01 00:13:28.000000', 'consum', 0.0222, 'lps'),
	(553142, 127, '2014-03-01 00:13:29.000000', 'consum', 0.0235, 'lps'),
	(553143, 127, '2014-03-01 00:13:30.000000', 'consum', 0.0214, 'lps'),
	(553144, 127, '2014-03-01 00:13:31.000000', 'consum', 0.0210, 'lps'),
	(553145, 127, '2014-03-01 00:13:32.000000', 'consum', 0.0229, 'lps'),
	(553146, 127, '2014-03-01 00:13:33.000000', 'consum', 0.0220, 'lps'),
	(553147, 127, '2014-03-01 00:13:34.000000', 'consum', 0.0232, 'lps'),
	(553148, 127, '2014-03-01 00:13:35.000000', 'consum', 0.0232, 'lps'),
	(553149, 127, '2014-03-01 00:13:36.000000', 'consum', 0.0225, 'lps'),
	(553150, 127, '2014-03-01 00:13:37.000000', 'consum', 0.0218, 'lps'),
	(553151, 127, '2014-03-01 00:13:38.000000', 'consum', 0.0237, 'lps'),
	(553152, 127, '2014-03-01 00:13:39.000000', 'consum', 0.0232, 'lps'),
	(553153, 127, '2014-03-01 00:13:40.000000', 'consum', 0.0212, 'lps'),
	(553154, 127, '2014-03-01 00:13:41.000000', 'consum', 0.0214, 'lps'),
	(553155, 127, '2014-03-01 00:13:42.000000', 'consum', 0.0222, 'lps'),
	(553156, 127, '2014-03-01 00:13:43.000000', 'consum', 0.0229, 'lps'),
	(553157, 127, '2014-03-01 00:13:44.000000', 'consum', 0.0214, 'lps'),
	(553158, 127, '2014-03-01 00:13:45.000000', 'consum', 0.0230, 'lps'),
	(553159, 127, '2014-03-01 00:13:46.000000', 'consum', 0.0213, 'lps'),
	(553160, 127, '2014-03-01 00:13:47.000000', 'consum', 0.0222, 'lps'),
	(553161, 127, '2014-03-01 00:13:48.000000', 'consum', 0.0235, 'lps'),
	(553162, 127, '2014-03-01 00:13:49.000000', 'consum', 0.0211, 'lps'),
	(553163, 127, '2014-03-01 00:13:50.000000', 'consum', 0.0228, 'lps'),
	(553164, 127, '2014-03-01 00:13:51.000000', 'consum', 0.0238, 'lps'),
	(553165, 127, '2014-03-01 00:13:52.000000', 'consum', 0.0212, 'lps'),
	(553166, 127, '2014-03-01 00:13:53.000000', 'consum', 0.0221, 'lps'),
	(553167, 127, '2014-03-01 00:13:54.000000', 'consum', 0.0230, 'lps'),
	(553168, 127, '2014-03-01 00:13:55.000000', 'consum', 0.0218, 'lps'),
	(553169, 127, '2014-03-01 00:13:56.000000', 'consum', 0.0223, 'lps'),
	(553170, 127, '2014-03-01 00:13:57.000000', 'consum', 0.0222, 'lps'),
	(553171, 127, '2014-03-01 00:13:58.000000', 'consum', 0.0231, 'lps'),
	(553172, 127, '2014-03-01 00:13:59.000000', 'consum', 0.0222, 'lps'),
	(553173, 127, '2014-03-01 00:14:00.000000', 'consum', 0.0235, 'lps'),
	(553174, 127, '2014-03-01 00:14:01.000000', 'consum', 0.0212, 'lps'),
	(553175, 127, '2014-03-01 00:14:02.000000', 'consum', 0.0235, 'lps'),
	(553176, 127, '2014-03-01 00:14:03.000000', 'consum', 0.0213, 'lps'),
	(553177, 127, '2014-03-01 00:14:04.000000', 'consum', 0.0236, 'lps'),
	(553178, 127, '2014-03-01 00:14:05.000000', 'consum', 0.0218, 'lps'),
	(553179, 127, '2014-03-01 00:14:06.000000', 'consum', 0.0229, 'lps'),
	(553180, 127, '2014-03-01 00:14:07.000000', 'consum', 0.0225, 'lps'),
	(553181, 127, '2014-03-01 00:14:08.000000', 'consum', 0.0230, 'lps'),
	(553182, 127, '2014-03-01 00:14:09.000000', 'consum', 0.0233, 'lps'),
	(553183, 127, '2014-03-01 00:14:10.000000', 'consum', 0.0237, 'lps'),
	(553184, 127, '2014-03-01 00:14:11.000000', 'consum', 0.0219, 'lps'),
	(553185, 127, '2014-03-01 00:14:12.000000', 'consum', 0.0233, 'lps'),
	(553186, 127, '2014-03-01 00:14:13.000000', 'consum', 0.0210, 'lps'),
	(553187, 127, '2014-03-01 00:14:14.000000', 'consum', 0.0230, 'lps'),
	(553188, 127, '2014-03-01 00:14:15.000000', 'consum', 0.0222, 'lps'),
	(553189, 127, '2014-03-01 00:14:16.000000', 'consum', 0.0210, 'lps'),
	(553190, 127, '2014-03-01 00:14:17.000000', 'consum', 0.0233, 'lps'),
	(553191, 127, '2014-03-01 00:14:18.000000', 'consum', 0.0237, 'lps'),
	(553192, 127, '2014-03-01 00:14:19.000000', 'consum', 0.0219, 'lps'),
	(553193, 127, '2014-03-01 00:14:20.000000', 'consum', 0.0232, 'lps'),
	(553194, 127, '2014-03-01 00:14:21.000000', 'consum', 0.0235, 'lps'),
	(553195, 127, '2014-03-01 00:14:22.000000', 'consum', 0.0211, 'lps'),
	(553196, 127, '2014-03-01 00:14:23.000000', 'consum', 0.0228, 'lps'),
	(553197, 127, '2014-03-01 00:14:24.000000', 'consum', 0.0212, 'lps'),
	(553198, 127, '2014-03-01 00:14:25.000000', 'consum', 0.0222, 'lps'),
	(553199, 127, '2014-03-01 00:14:26.000000', 'consum', 0.0235, 'lps'),
	(553200, 127, '2014-03-01 00:14:27.000000', 'consum', 0.0212, 'lps'),
	(553201, 127, '2014-03-01 00:14:28.000000', 'consum', 0.0235, 'lps'),
	(553202, 127, '2014-03-01 00:14:29.000000', 'consum', 0.0211, 'lps'),
	(553203, 127, '2014-03-01 00:14:30.000000', 'consum', 0.0228, 'lps'),
	(553204, 127, '2014-03-01 00:14:31.000000', 'consum', 0.0211, 'lps'),
	(553205, 127, '2014-03-01 00:14:32.000000', 'consum', 0.0221, 'lps'),
	(553206, 127, '2014-03-01 00:14:33.000000', 'consum', 0.0234, 'lps'),
	(553207, 127, '2014-03-01 00:14:34.000000', 'consum', 0.0237, 'lps'),
	(553208, 127, '2014-03-01 00:14:35.000000', 'consum', 0.0216, 'lps'),
	(553209, 127, '2014-03-01 00:14:36.000000', 'consum', 0.0217, 'lps'),
	(553210, 127, '2014-03-01 00:14:37.000000', 'consum', 0.0228, 'lps'),
	(553211, 127, '2014-03-01 00:14:38.000000', 'consum', 0.0221, 'lps'),
	(553212, 127, '2014-03-01 00:14:39.000000', 'consum', 0.0211, 'lps'),
	(553213, 127, '2014-03-01 00:14:40.000000', 'consum', 0.0210, 'lps'),
	(553214, 127, '2014-03-01 00:14:41.000000', 'consum', 0.0210, 'lps'),
	(553215, 127, '2014-03-01 00:14:42.000000', 'consum', 0.0210, 'lps'),
	(553216, 127, '2014-03-01 00:14:43.000000', 'consum', 0.0210, 'lps'),
	(553217, 127, '2014-03-01 00:14:44.000000', 'consum', 0.0211, 'lps'),
	(553218, 127, '2014-03-01 00:14:45.000000', 'consum', 0.0214, 'lps'),
	(553219, 127, '2014-03-01 00:14:46.000000', 'consum', 0.0227, 'lps'),
	(553220, 127, '2014-03-01 00:14:47.000000', 'consum', 0.0228, 'lps'),
	(553221, 127, '2014-03-01 00:14:48.000000', 'consum', 0.0219, 'lps'),
	(553222, 127, '2014-03-01 00:14:49.000000', 'consum', 0.0232, 'lps'),
	(553223, 127, '2014-03-01 00:14:50.000000', 'consum', 0.0233, 'lps'),
	(553224, 127, '2014-03-01 00:14:51.000000', 'consum', 0.0234, 'lps'),
	(553225, 127, '2014-03-01 00:14:52.000000', 'consum', 0.0229, 'lps'),
	(553226, 127, '2014-03-01 00:14:53.000000', 'consum', 0.0234, 'lps'),
	(553227, 127, '2014-03-01 00:14:54.000000', 'consum', 0.0216, 'lps'),
	(553228, 127, '2014-03-01 00:14:55.000000', 'consum', 0.0225, 'lps'),
	(553229, 127, '2014-03-01 00:14:56.000000', 'consum', 0.0211, 'lps'),
	(553230, 127, '2014-03-01 00:14:57.000000', 'consum', 0.0230, 'lps'),
	(553231, 127, '2014-03-01 00:14:58.000000', 'consum', 0.0220, 'lps'),
	(553232, 127, '2014-03-01 00:14:59.000000', 'consum', 0.0229, 'lps'),
	(553233, 127, '2014-03-01 00:15:00.000000', 'consum', 0.0218, 'lps'),
	(553234, 127, '2014-03-01 00:15:01.000000', 'consum', 0.0221, 'lps'),
	(553235, 127, '2014-03-01 00:15:02.000000', 'consum', 0.0212, 'lps'),
	(553236, 127, '2014-03-01 00:15:03.000000', 'consum', 0.0216, 'lps'),
	(553237, 127, '2014-03-01 00:15:04.000000', 'consum', 0.0237, 'lps'),
	(553238, 127, '2014-03-01 00:15:05.000000', 'consum', 0.0210, 'lps'),
	(553239, 127, '2014-03-01 00:15:06.000000', 'consum', 0.0219, 'lps'),
	(553240, 127, '2014-03-01 00:15:07.000000', 'consum', 0.0223, 'lps'),
	(553241, 127, '2014-03-01 00:15:08.000000', 'consum', 0.0221, 'lps'),
	(553242, 127, '2014-03-01 00:15:09.000000', 'consum', 0.0227, 'lps'),
	(553243, 127, '2014-03-01 00:15:10.000000', 'consum', 0.0232, 'lps'),
	(553244, 127, '2014-03-01 00:15:11.000000', 'consum', 0.0211, 'lps'),
	(553245, 127, '2014-03-01 00:15:12.000000', 'consum', 0.0210, 'lps'),
	(553246, 127, '2014-03-01 00:15:13.000000', 'consum', 0.0237, 'lps'),
	(553247, 127, '2014-03-01 00:15:14.000000', 'consum', 0.0228, 'lps'),
	(553248, 127, '2014-03-01 00:15:15.000000', 'consum', 0.0219, 'lps'),
	(553249, 127, '2014-03-01 00:15:16.000000', 'consum', 0.0231, 'lps'),
	(553250, 127, '2014-03-01 00:15:17.000000', 'consum', 0.0231, 'lps'),
	(553251, 127, '2014-03-01 00:15:18.000000', 'consum', 0.0225, 'lps'),
	(553252, 127, '2014-03-01 00:15:19.000000', 'consum', 0.0220, 'lps'),
	(553253, 127, '2014-03-01 00:15:20.000000', 'consum', 0.0218, 'lps'),
	(553254, 127, '2014-03-01 00:15:21.000000', 'consum', 0.0218, 'lps'),
	(553255, 127, '2014-03-01 00:15:22.000000', 'consum', 0.0228, 'lps'),
	(553256, 127, '2014-03-01 00:15:23.000000', 'consum', 0.0218, 'lps'),
	(553257, 127, '2014-03-01 00:15:24.000000', 'consum', 0.0226, 'lps'),
	(553258, 127, '2014-03-01 00:15:25.000000', 'consum', 0.0210, 'lps'),
	(553259, 127, '2014-03-01 00:15:26.000000', 'consum', 0.0218, 'lps'),
	(553260, 127, '2014-03-01 00:15:27.000000', 'consum', 0.0220, 'lps'),
	(553261, 127, '2014-03-01 00:15:28.000000', 'consum', 0.0210, 'lps'),
	(553262, 127, '2014-03-01 00:15:29.000000', 'consum', 0.0210, 'lps'),
	(553263, 127, '2014-03-01 00:15:30.000000', 'consum', 0.0237, 'lps'),
	(553264, 127, '2014-03-01 00:15:31.000000', 'consum', 0.0233, 'lps'),
	(553265, 127, '2014-03-01 00:15:32.000000', 'consum', 0.0212, 'lps'),
	(553266, 127, '2014-03-01 00:15:33.000000', 'consum', 0.0210, 'lps'),
	(553267, 127, '2014-03-01 00:15:34.000000', 'consum', 0.0236, 'lps'),
	(553268, 127, '2014-03-01 00:15:35.000000', 'consum', 0.0223, 'lps'),
	(553269, 127, '2014-03-01 00:15:36.000000', 'consum', 0.0225, 'lps'),
	(553270, 127, '2014-03-01 00:15:37.000000', 'consum', 0.0218, 'lps'),
	(553271, 127, '2014-03-01 00:15:38.000000', 'consum', 0.0234, 'lps'),
	(553272, 127, '2014-03-01 00:15:39.000000', 'consum', 0.0220, 'lps'),
	(553273, 127, '2014-03-01 00:15:40.000000', 'consum', 0.0219, 'lps'),
	(553274, 127, '2014-03-01 00:15:41.000000', 'consum', 0.0226, 'lps'),
	(553275, 127, '2014-03-01 00:15:42.000000', 'consum', 0.0234, 'lps'),
	(553276, 127, '2014-03-01 00:15:43.000000', 'consum', 0.0226, 'lps'),
	(553277, 127, '2014-03-01 00:15:44.000000', 'consum', 0.0217, 'lps'),
	(553278, 127, '2014-03-01 00:15:45.000000', 'consum', 0.0228, 'lps'),
	(553279, 127, '2014-03-01 00:15:46.000000', 'consum', 0.0220, 'lps'),
	(553280, 127, '2014-03-01 00:15:47.000000', 'consum', 0.0235, 'lps'),
	(553281, 127, '2014-03-01 00:15:48.000000', 'consum', 0.0220, 'lps'),
	(553282, 127, '2014-03-01 00:15:49.000000', 'consum', 0.0216, 'lps'),
	(553283, 127, '2014-03-01 00:15:50.000000', 'consum', 0.0237, 'lps'),
	(553284, 127, '2014-03-01 00:15:51.000000', 'consum', 0.0210, 'lps'),
	(553285, 127, '2014-03-01 00:15:52.000000', 'consum', 0.0220, 'lps'),
	(553286, 127, '2014-03-01 00:15:53.000000', 'consum', 0.0228, 'lps'),
	(553287, 127, '2014-03-01 00:15:54.000000', 'consum', 0.0215, 'lps'),
	(553288, 127, '2014-03-01 00:15:55.000000', 'consum', 0.0237, 'lps'),
	(553289, 127, '2014-03-01 00:15:56.000000', 'consum', 0.0218, 'lps'),
	(553290, 127, '2014-03-01 00:15:57.000000', 'consum', 0.0225, 'lps'),
	(553291, 127, '2014-03-01 00:15:58.000000', 'consum', 0.0233, 'lps'),
	(553292, 127, '2014-03-01 00:15:59.000000', 'consum', 0.0224, 'lps'),
	(553293, 127, '2014-03-01 00:16:00.000000', 'consum', 0.0211, 'lps'),
	(553294, 127, '2014-03-01 00:16:01.000000', 'consum', 0.0230, 'lps'),
	(553295, 127, '2014-03-01 00:16:02.000000', 'consum', 0.0220, 'lps'),
	(553296, 127, '2014-03-01 00:16:03.000000', 'consum', 0.0230, 'lps'),
	(553297, 127, '2014-03-01 00:16:04.000000', 'consum', 0.0222, 'lps'),
	(553298, 127, '2014-03-01 00:16:05.000000', 'consum', 0.0211, 'lps'),
	(553299, 127, '2014-03-01 00:16:06.000000', 'consum', 0.0238, 'lps'),
	(553300, 127, '2014-03-01 00:16:07.000000', 'consum', 0.0232, 'lps'),
	(553301, 127, '2014-03-01 00:16:08.000000', 'consum', 0.0237, 'lps'),
	(553302, 127, '2014-03-01 00:16:09.000000', 'consum', 0.0219, 'lps'),
	(553303, 127, '2014-03-01 00:16:10.000000', 'consum', 0.0235, 'lps'),
	(553304, 127, '2014-03-01 00:16:11.000000', 'consum', 0.0223, 'lps'),
	(553305, 127, '2014-03-01 00:16:12.000000', 'consum', 0.0226, 'lps'),
	(553306, 127, '2014-03-01 00:16:13.000000', 'consum', 0.0225, 'lps'),
	(553307, 127, '2014-03-01 00:16:14.000000', 'consum', 0.0235, 'lps'),
	(553308, 127, '2014-03-01 00:16:15.000000', 'consum', 0.0232, 'lps'),
	(553309, 127, '2014-03-01 00:16:16.000000', 'consum', 0.0218, 'lps'),
	(553310, 127, '2014-03-01 00:16:17.000000', 'consum', 0.0211, 'lps'),
	(553311, 127, '2014-03-01 00:16:18.000000', 'consum', 0.0224, 'lps'),
	(553312, 127, '2014-03-01 00:16:19.000000', 'consum', 0.0216, 'lps'),
	(553313, 127, '2014-03-01 00:16:20.000000', 'consum', 0.0230, 'lps'),
	(553314, 127, '2014-03-01 00:16:21.000000', 'consum', 0.0234, 'lps'),
	(553315, 127, '2014-03-01 00:16:22.000000', 'consum', 0.0212, 'lps'),
	(553316, 127, '2014-03-01 00:16:23.000000', 'consum', 0.0235, 'lps'),
	(553317, 127, '2014-03-01 00:16:24.000000', 'consum', 0.0213, 'lps'),
	(553318, 127, '2014-03-01 00:16:25.000000', 'consum', 0.0211, 'lps'),
	(553319, 127, '2014-03-01 00:16:26.000000', 'consum', 0.0235, 'lps'),
	(553320, 127, '2014-03-01 00:16:27.000000', 'consum', 0.0217, 'lps'),
	(553321, 127, '2014-03-01 00:16:28.000000', 'consum', 0.0230, 'lps'),
	(553322, 127, '2014-03-01 00:16:29.000000', 'consum', 0.0229, 'lps'),
	(553323, 127, '2014-03-01 00:16:30.000000', 'consum', 0.0215, 'lps'),
	(553324, 127, '2014-03-01 00:16:31.000000', 'consum', 0.0211, 'lps'),
	(553325, 127, '2014-03-01 00:16:32.000000', 'consum', 0.0226, 'lps'),
	(553326, 127, '2014-03-01 00:16:33.000000', 'consum', 0.0233, 'lps'),
	(553327, 127, '2014-03-01 00:16:34.000000', 'consum', 0.0217, 'lps'),
	(553328, 127, '2014-03-01 00:16:35.000000', 'consum', 0.0236, 'lps'),
	(553329, 127, '2014-03-01 00:16:36.000000', 'consum', 0.0234, 'lps'),
	(553330, 127, '2014-03-01 00:16:37.000000', 'consum', 0.0223, 'lps'),
	(553331, 127, '2014-03-01 00:16:38.000000', 'consum', 0.0230, 'lps'),
	(553332, 127, '2014-03-01 00:16:39.000000', 'consum', 0.0215, 'lps'),
	(553333, 127, '2014-03-01 00:16:40.000000', 'consum', 0.0235, 'lps'),
	(553334, 127, '2014-03-01 00:16:41.000000', 'consum', 0.0230, 'lps'),
	(553335, 127, '2014-03-01 00:16:42.000000', 'consum', 0.0210, 'lps'),
	(553336, 127, '2014-03-01 00:16:43.000000', 'consum', 0.0236, 'lps'),
	(553337, 127, '2014-03-01 00:16:44.000000', 'consum', 0.0226, 'lps'),
	(553338, 127, '2014-03-01 00:16:45.000000', 'consum', 0.0210, 'lps'),
	(553339, 127, '2014-03-01 00:16:46.000000', 'consum', 0.0221, 'lps'),
	(553340, 127, '2014-03-01 00:16:47.000000', 'consum', 0.0236, 'lps'),
	(553341, 127, '2014-03-01 00:16:48.000000', 'consum', 0.0222, 'lps'),
	(553342, 127, '2014-03-01 00:16:49.000000', 'consum', 0.0220, 'lps'),
	(553343, 127, '2014-03-01 00:16:50.000000', 'consum', 0.0225, 'lps'),
	(553344, 127, '2014-03-01 00:16:51.000000', 'consum', 0.0227, 'lps'),
	(553345, 127, '2014-03-01 00:16:52.000000', 'consum', 0.0223, 'lps'),
	(553346, 127, '2014-03-01 00:16:53.000000', 'consum', 0.0224, 'lps'),
	(553347, 127, '2014-03-01 00:16:54.000000', 'consum', 0.0212, 'lps'),
	(553348, 127, '2014-03-01 00:16:55.000000', 'consum', 0.0236, 'lps'),
	(553349, 127, '2014-03-01 00:16:56.000000', 'consum', 0.0218, 'lps'),
	(553350, 127, '2014-03-01 00:16:57.000000', 'consum', 0.0232, 'lps'),
	(553351, 127, '2014-03-01 00:16:58.000000', 'consum', 0.0211, 'lps'),
	(553352, 127, '2014-03-01 00:16:59.000000', 'consum', 0.0235, 'lps'),
	(553353, 127, '2014-03-01 00:17:00.000000', 'consum', 0.0215, 'lps'),
	(553354, 127, '2014-03-01 00:17:01.000000', 'consum', 0.0219, 'lps'),
	(553355, 127, '2014-03-01 00:17:02.000000', 'consum', 0.0211, 'lps'),
	(553356, 127, '2014-03-01 00:17:03.000000', 'consum', 0.0219, 'lps'),
	(553357, 127, '2014-03-01 00:17:04.000000', 'consum', 0.0224, 'lps'),
	(553358, 127, '2014-03-01 00:17:05.000000', 'consum', 0.0225, 'lps'),
	(553359, 127, '2014-03-01 00:17:06.000000', 'consum', 0.0216, 'lps'),
	(553360, 127, '2014-03-01 00:17:07.000000', 'consum', 0.0221, 'lps'),
	(553361, 127, '2014-03-01 00:17:08.000000', 'consum', 0.0220, 'lps'),
	(553362, 127, '2014-03-01 00:17:09.000000', 'consum', 0.0226, 'lps'),
	(553363, 127, '2014-03-01 00:17:10.000000', 'consum', 0.0233, 'lps'),
	(553364, 127, '2014-03-01 00:17:11.000000', 'consum', 0.0217, 'lps'),
	(553365, 127, '2014-03-01 00:17:12.000000', 'consum', 0.0237, 'lps'),
	(553366, 127, '2014-03-01 00:17:13.000000', 'consum', 0.0235, 'lps'),
	(553367, 127, '2014-03-01 00:17:14.000000', 'consum', 0.0227, 'lps'),
	(553368, 127, '2014-03-01 00:17:15.000000', 'consum', 0.0220, 'lps'),
	(553369, 127, '2014-03-01 00:17:16.000000', 'consum', 0.0210, 'lps'),
	(553370, 127, '2014-03-01 00:17:17.000000', 'consum', 0.0211, 'lps'),
	(553371, 127, '2014-03-01 00:17:18.000000', 'consum', 0.0214, 'lps'),
	(553372, 127, '2014-03-01 00:17:19.000000', 'consum', 0.0226, 'lps'),
	(553373, 127, '2014-03-01 00:17:20.000000', 'consum', 0.0223, 'lps'),
	(553374, 127, '2014-03-01 00:17:21.000000', 'consum', 0.0228, 'lps'),
	(553375, 127, '2014-03-01 00:17:22.000000', 'consum', 0.0233, 'lps'),
	(553376, 127, '2014-03-01 00:17:23.000000', 'consum', 0.0213, 'lps'),
	(553377, 127, '2014-03-01 00:17:24.000000', 'consum', 0.0213, 'lps'),
	(553378, 127, '2014-03-01 00:17:25.000000', 'consum', 0.0216, 'lps'),
	(553379, 127, '2014-03-01 00:17:26.000000', 'consum', 0.0231, 'lps'),
	(553380, 127, '2014-03-01 00:17:27.000000', 'consum', 0.0211, 'lps'),
	(553381, 127, '2014-03-01 00:17:28.000000', 'consum', 0.0211, 'lps'),
	(553382, 127, '2014-03-01 00:17:29.000000', 'consum', 0.0213, 'lps'),
	(553383, 127, '2014-03-01 00:17:30.000000', 'consum', 0.0220, 'lps'),
	(553384, 127, '2014-03-01 00:17:31.000000', 'consum', 0.0225, 'lps'),
	(553385, 127, '2014-03-01 00:17:32.000000', 'consum', 0.0226, 'lps'),
	(553386, 127, '2014-03-01 00:17:33.000000', 'consum', 0.0214, 'lps'),
	(553387, 127, '2014-03-01 00:17:34.000000', 'consum', 0.0215, 'lps'),
	(553388, 127, '2014-03-01 00:17:35.000000', 'consum', 0.0222, 'lps'),
	(553389, 127, '2014-03-01 00:17:36.000000', 'consum', 0.0227, 'lps'),
	(553390, 127, '2014-03-01 00:17:37.000000', 'consum', 0.0230, 'lps'),
	(553391, 127, '2014-03-01 00:17:38.000000', 'consum', 0.0230, 'lps'),
	(553392, 127, '2014-03-01 00:17:39.000000', 'consum', 0.0223, 'lps'),
	(553393, 127, '2014-03-01 00:17:40.000000', 'consum', 0.0213, 'lps'),
	(553394, 127, '2014-03-01 00:17:41.000000', 'consum', 0.0217, 'lps'),
	(553395, 127, '2014-03-01 00:17:42.000000', 'consum', 0.0236, 'lps'),
	(553396, 127, '2014-03-01 00:17:43.000000', 'consum', 0.0233, 'lps'),
	(553397, 127, '2014-03-01 00:17:44.000000', 'consum', 0.0217, 'lps'),
	(553398, 127, '2014-03-01 00:17:45.000000', 'consum', 0.0236, 'lps'),
	(553399, 127, '2014-03-01 00:17:46.000000', 'consum', 0.0231, 'lps'),
	(553400, 127, '2014-03-01 00:17:47.000000', 'consum', 0.0211, 'lps'),
	(553401, 127, '2014-03-01 00:17:48.000000', 'consum', 0.0237, 'lps'),
	(553402, 127, '2014-03-01 00:17:49.000000', 'consum', 0.0227, 'lps'),
	(553403, 127, '2014-03-01 00:17:50.000000', 'consum', 0.0217, 'lps'),
	(553404, 127, '2014-03-01 00:17:51.000000', 'consum', 0.0220, 'lps'),
	(553405, 127, '2014-03-01 00:17:52.000000', 'consum', 0.0211, 'lps'),
	(553406, 127, '2014-03-01 00:17:53.000000', 'consum', 0.0217, 'lps'),
	(553407, 127, '2014-03-01 00:17:54.000000', 'consum', 0.0211, 'lps'),
	(553408, 127, '2014-03-01 00:17:55.000000', 'consum', 0.0223, 'lps'),
	(553409, 127, '2014-03-01 00:17:56.000000', 'consum', 0.0218, 'lps'),
	(553410, 127, '2014-03-01 00:17:57.000000', 'consum', 0.0237, 'lps'),
	(553411, 127, '2014-03-01 00:17:58.000000', 'consum', 0.0234, 'lps'),
	(553412, 127, '2014-03-01 00:17:59.000000', 'consum', 0.0221, 'lps'),
	(553413, 127, '2014-03-01 00:18:00.000000', 'consum', 0.0223, 'lps'),
	(553414, 127, '2014-03-01 00:18:01.000000', 'consum', 0.0212, 'lps'),
	(553415, 127, '2014-03-01 00:18:02.000000', 'consum', 0.0211, 'lps'),
	(553416, 127, '2014-03-01 00:18:03.000000', 'consum', 0.0237, 'lps'),
	(553417, 127, '2014-03-01 00:18:04.000000', 'consum', 0.0227, 'lps'),
	(553418, 127, '2014-03-01 00:18:05.000000', 'consum', 0.0213, 'lps'),
	(553419, 127, '2014-03-01 00:18:06.000000', 'consum', 0.0236, 'lps'),
	(553420, 127, '2014-03-01 00:18:07.000000', 'consum', 0.0214, 'lps'),
	(553421, 127, '2014-03-01 00:18:08.000000', 'consum', 0.0238, 'lps'),
	(553422, 127, '2014-03-01 00:18:09.000000', 'consum', 0.0222, 'lps'),
	(553423, 127, '2014-03-01 00:18:10.000000', 'consum', 0.0216, 'lps'),
	(553424, 127, '2014-03-01 00:18:11.000000', 'consum', 0.0235, 'lps'),
	(553425, 127, '2014-03-01 00:18:12.000000', 'consum', 0.0230, 'lps'),
	(553426, 127, '2014-03-01 00:18:13.000000', 'consum', 0.0235, 'lps'),
	(553427, 127, '2014-03-01 00:18:14.000000', 'consum', 0.0217, 'lps'),
	(553428, 127, '2014-03-01 00:18:15.000000', 'consum', 0.0231, 'lps'),
	(553429, 127, '2014-03-01 00:18:16.000000', 'consum', 0.0234, 'lps'),
	(553430, 127, '2014-03-01 00:18:17.000000', 'consum', 0.0211, 'lps'),
	(553431, 127, '2014-03-01 00:18:18.000000', 'consum', 0.0231, 'lps'),
	(553432, 127, '2014-03-01 00:18:19.000000', 'consum', 0.0224, 'lps'),
	(553433, 127, '2014-03-01 00:18:20.000000', 'consum', 0.0218, 'lps'),
	(553434, 127, '2014-03-01 00:18:21.000000', 'consum', 0.0237, 'lps'),
	(553435, 127, '2014-03-01 00:18:22.000000', 'consum', 0.0233, 'lps'),
	(553436, 127, '2014-03-01 00:18:23.000000', 'consum', 0.0218, 'lps'),
	(553437, 127, '2014-03-01 00:18:24.000000', 'consum', 0.0211, 'lps'),
	(553438, 127, '2014-03-01 00:18:25.000000', 'consum', 0.0222, 'lps'),
	(553439, 127, '2014-03-01 00:18:26.000000', 'consum', 0.0235, 'lps'),
	(553440, 127, '2014-03-01 00:18:27.000000', 'consum', 0.0216, 'lps'),
	(553441, 127, '2014-03-01 00:18:28.000000', 'consum', 0.0220, 'lps'),
	(553442, 127, '2014-03-01 00:18:29.000000', 'consum', 0.0216, 'lps'),
	(553443, 127, '2014-03-01 00:18:30.000000', 'consum', 0.0238, 'lps'),
	(553444, 127, '2014-03-01 00:18:31.000000', 'consum', 0.0217, 'lps'),
	(553445, 127, '2014-03-01 00:18:32.000000', 'consum', 0.0217, 'lps'),
	(553446, 127, '2014-03-01 00:18:33.000000', 'consum', 0.0228, 'lps'),
	(553447, 127, '2014-03-01 00:18:34.000000', 'consum', 0.0221, 'lps'),
	(553448, 127, '2014-03-01 00:18:35.000000', 'consum', 0.0211, 'lps'),
	(553449, 127, '2014-03-01 00:18:36.000000', 'consum', 0.0210, 'lps'),
	(553450, 127, '2014-03-01 00:18:37.000000', 'consum', 0.0238, 'lps'),
	(553451, 127, '2014-03-01 00:18:38.000000', 'consum', 0.0235, 'lps'),
	(553452, 127, '2014-03-01 00:18:39.000000', 'consum', 0.0220, 'lps'),
	(553453, 127, '2014-03-01 00:18:40.000000', 'consum', 0.0215, 'lps'),
	(553454, 127, '2014-03-01 00:18:41.000000', 'consum', 0.0235, 'lps'),
	(553455, 127, '2014-03-01 00:18:42.000000', 'consum', 0.0233, 'lps'),
	(553456, 127, '2014-03-01 00:18:43.000000', 'consum', 0.0222, 'lps'),
	(553457, 127, '2014-03-01 00:18:44.000000', 'consum', 0.0232, 'lps'),
	(553458, 127, '2014-03-01 00:18:45.000000', 'consum', 0.0227, 'lps'),
	(553459, 127, '2014-03-01 00:18:46.000000', 'consum', 0.0228, 'lps'),
	(553460, 127, '2014-03-01 00:18:47.000000', 'consum', 0.0219, 'lps'),
	(553461, 127, '2014-03-01 00:18:48.000000', 'consum', 0.0233, 'lps'),
	(553462, 127, '2014-03-01 00:18:49.000000', 'consum', 0.0238, 'lps'),
	(553463, 127, '2014-03-01 00:18:50.000000', 'consum', 0.0226, 'lps'),
	(553464, 127, '2014-03-01 00:18:51.000000', 'consum', 0.0235, 'lps'),
	(553465, 127, '2014-03-01 00:18:52.000000', 'consum', 0.0229, 'lps'),
	(553466, 127, '2014-03-01 00:18:53.000000', 'consum', 0.0229, 'lps'),
	(553467, 127, '2014-03-01 00:18:54.000000', 'consum', 0.0223, 'lps'),
	(553468, 127, '2014-03-01 00:18:55.000000', 'consum', 0.0215, 'lps'),
	(553469, 127, '2014-03-01 00:18:56.000000', 'consum', 0.0226, 'lps'),
	(553470, 127, '2014-03-01 00:18:57.000000', 'consum', 0.0219, 'lps'),
	(553471, 127, '2014-03-01 00:18:58.000000', 'consum', 0.0234, 'lps'),
	(553472, 127, '2014-03-01 00:18:59.000000', 'consum', 0.0220, 'lps'),
	(553473, 127, '2014-03-01 00:19:00.000000', 'consum', 0.0214, 'lps'),
	(553474, 127, '2014-03-01 00:19:01.000000', 'consum', 0.0233, 'lps'),
	(553475, 127, '2014-03-01 00:19:02.000000', 'consum', 0.0225, 'lps'),
	(553476, 127, '2014-03-01 00:19:03.000000', 'consum', 0.0215, 'lps'),
	(553477, 127, '2014-03-01 00:19:04.000000', 'consum', 0.0219, 'lps'),
	(553478, 127, '2014-03-01 00:19:05.000000', 'consum', 0.0213, 'lps'),
	(553479, 127, '2014-03-01 00:19:06.000000', 'consum', 0.0229, 'lps'),
	(553480, 127, '2014-03-01 00:19:07.000000', 'consum', 0.0235, 'lps'),
	(553481, 127, '2014-03-01 00:19:08.000000', 'consum', 0.0223, 'lps'),
	(553482, 127, '2014-03-01 00:19:09.000000', 'consum', 0.0230, 'lps'),
	(553483, 127, '2014-03-01 00:19:10.000000', 'consum', 0.0213, 'lps'),
	(553484, 127, '2014-03-01 00:19:11.000000', 'consum', 0.0222, 'lps'),
	(553485, 127, '2014-03-01 00:19:12.000000', 'consum', 0.0233, 'lps'),
	(553486, 127, '2014-03-01 00:19:13.000000', 'consum', 0.0233, 'lps'),
	(553487, 127, '2014-03-01 00:19:14.000000', 'consum', 0.0227, 'lps'),
	(553488, 127, '2014-03-01 00:19:15.000000', 'consum', 0.0228, 'lps'),
	(553489, 127, '2014-03-01 00:19:16.000000', 'consum', 0.0221, 'lps'),
	(553490, 127, '2014-03-01 00:19:17.000000', 'consum', 0.0237, 'lps'),
	(553491, 127, '2014-03-01 00:19:18.000000', 'consum', 0.0229, 'lps'),
	(553492, 127, '2014-03-01 00:19:19.000000', 'consum', 0.0222, 'lps'),
	(553493, 127, '2014-03-01 00:19:20.000000', 'consum', 0.0213, 'lps'),
	(553494, 127, '2014-03-01 00:19:21.000000', 'consum', 0.0217, 'lps'),
	(553495, 127, '2014-03-01 00:19:22.000000', 'consum', 0.0211, 'lps'),
	(553496, 127, '2014-03-01 00:19:23.000000', 'consum', 0.0221, 'lps'),
	(553497, 127, '2014-03-01 00:19:24.000000', 'consum', 0.0233, 'lps'),
	(553498, 127, '2014-03-01 00:19:25.000000', 'consum', 0.0234, 'lps'),
	(553499, 127, '2014-03-01 00:19:26.000000', 'consum', 0.0234, 'lps'),
	(553500, 127, '2014-03-01 00:19:27.000000', 'consum', 0.0231, 'lps'),
	(553501, 127, '2014-03-01 00:19:28.000000', 'consum', 0.0213, 'lps'),
	(553502, 127, '2014-03-01 00:19:29.000000', 'consum', 0.0223, 'lps'),
	(553503, 127, '2014-03-01 00:19:30.000000', 'consum', 0.0235, 'lps'),
	(553504, 127, '2014-03-01 00:19:31.000000', 'consum', 0.0237, 'lps'),
	(553505, 127, '2014-03-01 00:19:32.000000', 'consum', 0.0215, 'lps'),
	(553506, 127, '2014-03-01 00:19:33.000000', 'consum', 0.0213, 'lps'),
	(553507, 127, '2014-03-01 00:19:34.000000', 'consum', 0.0237, 'lps'),
	(553508, 127, '2014-03-01 00:19:35.000000', 'consum', 0.0222, 'lps'),
	(553509, 127, '2014-03-01 00:19:36.000000', 'consum', 0.0217, 'lps'),
	(553510, 127, '2014-03-01 00:19:37.000000', 'consum', 0.0211, 'lps'),
	(553511, 127, '2014-03-01 00:19:38.000000', 'consum', 0.0221, 'lps'),
	(553512, 127, '2014-03-01 00:19:39.000000', 'consum', 0.0237, 'lps'),
	(553513, 127, '2014-03-01 00:19:40.000000', 'consum', 0.0224, 'lps'),
	(553514, 127, '2014-03-01 00:19:41.000000', 'consum', 0.0227, 'lps'),
	(553515, 127, '2014-03-01 00:19:42.000000', 'consum', 0.0225, 'lps'),
	(553516, 127, '2014-03-01 00:19:43.000000', 'consum', 0.0234, 'lps'),
	(553517, 127, '2014-03-01 00:19:44.000000', 'consum', 0.0228, 'lps'),
	(553518, 127, '2014-03-01 00:19:45.000000', 'consum', 0.0229, 'lps'),
	(553519, 127, '2014-03-01 00:19:46.000000', 'consum', 0.0221, 'lps'),
	(553520, 127, '2014-03-01 00:19:47.000000', 'consum', 0.0238, 'lps'),
	(553521, 127, '2014-03-01 00:19:48.000000', 'consum', 0.0233, 'lps'),
	(553522, 127, '2014-03-01 00:19:49.000000', 'consum', 0.0238, 'lps'),
	(553523, 127, '2014-03-01 00:19:50.000000', 'consum', 0.0226, 'lps'),
	(553524, 127, '2014-03-01 00:19:51.000000', 'consum', 0.0236, 'lps'),
	(553525, 127, '2014-03-01 00:19:52.000000', 'consum', 0.0233, 'lps'),
	(553526, 127, '2014-03-01 00:19:53.000000', 'consum', 0.0220, 'lps'),
	(553527, 127, '2014-03-01 00:19:54.000000', 'consum', 0.0219, 'lps'),
	(553528, 127, '2014-03-01 00:19:55.000000', 'consum', 0.0224, 'lps'),
	(553529, 127, '2014-03-01 00:19:56.000000', 'consum', 0.0227, 'lps'),
	(553530, 127, '2014-03-01 00:19:57.000000', 'consum', 0.0223, 'lps'),
	(553531, 127, '2014-03-01 00:19:58.000000', 'consum', 0.0225, 'lps'),
	(553532, 127, '2014-03-01 00:19:59.000000', 'consum', 0.0219, 'lps'),
	(553533, 127, '2014-03-01 00:20:00.000000', 'consum', 0.0211, 'lps'),
	(553534, 127, '2014-03-01 00:20:01.000000', 'consum', 0.0218, 'lps'),
	(553535, 127, '2014-03-01 00:20:02.000000', 'consum', 0.0216, 'lps'),
	(553536, 127, '2014-03-01 00:20:03.000000', 'consum', 0.0216, 'lps'),
	(553537, 127, '2014-03-01 00:20:04.000000', 'consum', 0.0222, 'lps'),
	(553538, 127, '2014-03-01 00:20:05.000000', 'consum', 0.0226, 'lps'),
	(553539, 127, '2014-03-01 00:20:06.000000', 'consum', 0.0224, 'lps'),
	(553540, 127, '2014-03-01 00:20:07.000000', 'consum', 0.0232, 'lps'),
	(553541, 127, '2014-03-01 00:20:08.000000', 'consum', 0.0222, 'lps'),
	(553542, 127, '2014-03-01 00:20:09.000000', 'consum', 0.0232, 'lps'),
	(553543, 127, '2014-03-01 00:20:10.000000', 'consum', 0.0226, 'lps'),
	(553544, 127, '2014-03-01 00:20:11.000000', 'consum', 0.0226, 'lps'),
	(553545, 127, '2014-03-01 00:20:12.000000', 'consum', 0.0212, 'lps'),
	(553546, 127, '2014-03-01 00:20:13.000000', 'consum', 0.0233, 'lps'),
	(553547, 127, '2014-03-01 00:20:14.000000', 'consum', 0.0231, 'lps'),
	(553548, 127, '2014-03-01 00:20:15.000000', 'consum', 0.0217, 'lps'),
	(553549, 127, '2014-03-01 00:20:16.000000', 'consum', 0.0212, 'lps'),
	(553550, 127, '2014-03-01 00:20:17.000000', 'consum', 0.0229, 'lps'),
	(553551, 127, '2014-03-01 00:20:18.000000', 'consum', 0.0214, 'lps'),
	(553552, 127, '2014-03-01 00:20:19.000000', 'consum', 0.0230, 'lps'),
	(553553, 127, '2014-03-01 00:20:20.000000', 'consum', 0.0210, 'lps'),
	(553554, 127, '2014-03-01 00:20:21.000000', 'consum', 0.0237, 'lps'),
	(553555, 127, '2014-03-01 00:20:22.000000', 'consum', 0.0230, 'lps'),
	(553556, 127, '2014-03-01 00:20:23.000000', 'consum', 0.0229, 'lps'),
	(553557, 127, '2014-03-01 00:20:24.000000', 'consum', 0.0217, 'lps'),
	(553558, 127, '2014-03-01 00:20:25.000000', 'consum', 0.0218, 'lps'),
	(553559, 127, '2014-03-01 00:20:26.000000', 'consum', 0.0230, 'lps'),
	(553560, 127, '2014-03-01 00:20:27.000000', 'consum', 0.0230, 'lps'),
	(553561, 127, '2014-03-01 00:20:28.000000', 'consum', 0.0221, 'lps'),
	(553562, 127, '2014-03-01 00:20:29.000000', 'consum', 0.0232, 'lps'),
	(553563, 127, '2014-03-01 00:20:30.000000', 'consum', 0.0231, 'lps'),
	(553564, 127, '2014-03-01 00:20:31.000000', 'consum', 0.0219, 'lps'),
	(553565, 127, '2014-03-01 00:20:32.000000', 'consum', 0.0221, 'lps'),
	(553566, 127, '2014-03-01 00:20:33.000000', 'consum', 0.0210, 'lps'),
	(553567, 127, '2014-03-01 00:20:34.000000', 'consum', 0.0236, 'lps'),
	(553568, 127, '2014-03-01 00:20:35.000000', 'consum', 0.0226, 'lps'),
	(553569, 127, '2014-03-01 00:20:36.000000', 'consum', 0.0213, 'lps'),
	(553570, 127, '2014-03-01 00:20:37.000000', 'consum', 0.0236, 'lps'),
	(553571, 127, '2014-03-01 00:20:38.000000', 'consum', 0.0212, 'lps'),
	(553572, 127, '2014-03-01 00:20:39.000000', 'consum', 0.0232, 'lps'),
	(553573, 127, '2014-03-01 00:20:40.000000', 'consum', 0.0227, 'lps'),
	(553574, 127, '2014-03-01 00:20:41.000000', 'consum', 0.0230, 'lps'),
	(553575, 127, '2014-03-01 00:20:42.000000', 'consum', 0.0232, 'lps'),
	(553576, 127, '2014-03-01 00:20:43.000000', 'consum', 0.0229, 'lps'),
	(553577, 127, '2014-03-01 00:20:44.000000', 'consum', 0.0213, 'lps'),
	(553578, 127, '2014-03-01 00:20:45.000000', 'consum', 0.0224, 'lps'),
	(553579, 127, '2014-03-01 00:20:46.000000', 'consum', 0.0213, 'lps'),
	(553580, 127, '2014-03-01 00:20:47.000000', 'consum', 0.0212, 'lps'),
	(553581, 127, '2014-03-01 00:20:48.000000', 'consum', 0.0215, 'lps'),
	(553582, 127, '2014-03-01 00:20:49.000000', 'consum', 0.0226, 'lps'),
	(553583, 127, '2014-03-01 00:20:50.000000', 'consum', 0.0218, 'lps'),
	(553584, 127, '2014-03-01 00:20:51.000000', 'consum', 0.0233, 'lps'),
	(553585, 127, '2014-03-01 00:20:52.000000', 'consum', 0.0215, 'lps'),
	(553586, 127, '2014-03-01 00:20:53.000000', 'consum', 0.0224, 'lps'),
	(553587, 127, '2014-03-01 00:20:54.000000', 'consum', 0.0237, 'lps'),
	(553588, 127, '2014-03-01 00:20:55.000000', 'consum', 0.0218, 'lps'),
	(553589, 127, '2014-03-01 00:20:56.000000', 'consum', 0.0225, 'lps'),
	(553590, 127, '2014-03-01 00:20:57.000000', 'consum', 0.0235, 'lps'),
	(553591, 127, '2014-03-01 00:20:58.000000', 'consum', 0.0232, 'lps'),
	(553592, 127, '2014-03-01 00:20:59.000000', 'consum', 0.0215, 'lps'),
	(553593, 127, '2014-03-01 00:21:00.000000', 'consum', 0.0228, 'lps'),
	(553594, 127, '2014-03-01 00:21:01.000000', 'consum', 0.0229, 'lps'),
	(553595, 127, '2014-03-01 00:21:02.000000', 'consum', 0.0220, 'lps'),
	(553596, 127, '2014-03-01 00:21:03.000000', 'consum', 0.0236, 'lps'),
	(553597, 127, '2014-03-01 00:21:04.000000', 'consum', 0.0220, 'lps'),
	(553598, 127, '2014-03-01 00:21:05.000000', 'consum', 0.0212, 'lps'),
	(553599, 127, '2014-03-01 00:21:06.000000', 'consum', 0.0220, 'lps'),
	(553600, 127, '2014-03-01 00:21:07.000000', 'consum', 0.0227, 'lps'),
	(553601, 127, '2014-03-01 00:21:08.000000', 'consum', 0.0234, 'lps'),
	(553602, 127, '2014-03-01 00:21:09.000000', 'consum', 0.0222, 'lps'),
	(553603, 127, '2014-03-01 00:21:10.000000', 'consum', 0.0228, 'lps'),
	(553604, 127, '2014-03-01 00:21:11.000000', 'consum', 0.0237, 'lps'),
	(553605, 127, '2014-03-01 00:21:12.000000', 'consum', 0.0230, 'lps'),
	(553606, 127, '2014-03-01 00:21:13.000000', 'consum', 0.0233, 'lps'),
	(553607, 127, '2014-03-01 00:21:14.000000', 'consum', 0.0237, 'lps'),
	(553608, 127, '2014-03-01 00:21:15.000000', 'consum', 0.0215, 'lps'),
	(553609, 127, '2014-03-01 00:21:16.000000', 'consum', 0.0215, 'lps'),
	(553610, 127, '2014-03-01 00:21:17.000000', 'consum', 0.0218, 'lps'),
	(553611, 127, '2014-03-01 00:21:18.000000', 'consum', 0.0238, 'lps'),
	(553612, 127, '2014-03-01 00:21:19.000000', 'consum', 0.0238, 'lps'),
	(553613, 127, '2014-03-01 00:21:20.000000', 'consum', 0.0237, 'lps'),
	(553614, 127, '2014-03-01 00:21:21.000000', 'consum', 0.0232, 'lps'),
	(553615, 127, '2014-03-01 00:21:22.000000', 'consum', 0.0238, 'lps'),
	(553616, 127, '2014-03-01 00:21:23.000000', 'consum', 0.0230, 'lps'),
	(553617, 127, '2014-03-01 00:21:24.000000', 'consum', 0.0225, 'lps'),
	(553618, 127, '2014-03-01 00:21:25.000000', 'consum', 0.0225, 'lps'),
	(553619, 127, '2014-03-01 00:21:26.000000', 'consum', 0.0211, 'lps'),
	(553620, 127, '2014-03-01 00:21:27.000000', 'consum', 0.0227, 'lps'),
	(553621, 127, '2014-03-01 00:21:28.000000', 'consum', 0.0238, 'lps'),
	(553622, 127, '2014-03-01 00:21:29.000000', 'consum', 0.0210, 'lps'),
	(553623, 127, '2014-03-01 00:21:30.000000', 'consum', 0.0213, 'lps'),
	(553624, 127, '2014-03-01 00:21:31.000000', 'consum', 0.0225, 'lps'),
	(553625, 127, '2014-03-01 00:21:32.000000', 'consum', 0.0221, 'lps'),
	(553626, 127, '2014-03-01 00:21:33.000000', 'consum', 0.0221, 'lps'),
	(553627, 127, '2014-03-01 00:21:34.000000', 'consum', 0.0230, 'lps'),
	(553628, 127, '2014-03-01 00:21:35.000000', 'consum', 0.0223, 'lps'),
	(553629, 127, '2014-03-01 00:21:36.000000', 'consum', 0.0212, 'lps'),
	(553630, 127, '2014-03-01 00:21:37.000000', 'consum', 0.0211, 'lps'),
	(553631, 127, '2014-03-01 00:21:38.000000', 'consum', 0.0210, 'lps'),
	(553632, 127, '2014-03-01 00:21:39.000000', 'consum', 0.0236, 'lps'),
	(553633, 127, '2014-03-01 00:21:40.000000', 'consum', 0.0224, 'lps'),
	(553634, 127, '2014-03-01 00:21:41.000000', 'consum', 0.0233, 'lps'),
	(553635, 127, '2014-03-01 00:21:42.000000', 'consum', 0.0226, 'lps'),
	(553636, 127, '2014-03-01 00:21:43.000000', 'consum', 0.0223, 'lps'),
	(553637, 127, '2014-03-01 00:21:44.000000', 'consum', 0.0225, 'lps'),
	(553638, 127, '2014-03-01 00:21:45.000000', 'consum', 0.0217, 'lps'),
	(553639, 127, '2014-03-01 00:21:46.000000', 'consum', 0.0231, 'lps'),
	(553640, 127, '2014-03-01 00:21:47.000000', 'consum', 0.0238, 'lps'),
	(553641, 127, '2014-03-01 00:21:48.000000', 'consum', 0.0227, 'lps'),
	(553642, 127, '2014-03-01 00:21:49.000000', 'consum', 0.0211, 'lps'),
	(553643, 127, '2014-03-01 00:21:50.000000', 'consum', 0.0225, 'lps'),
	(553644, 127, '2014-03-01 00:21:51.000000', 'consum', 0.0223, 'lps'),
	(553645, 127, '2014-03-01 00:21:52.000000', 'consum', 0.0229, 'lps'),
	(553646, 127, '2014-03-01 00:21:53.000000', 'consum', 0.0211, 'lps'),
	(553647, 127, '2014-03-01 00:21:54.000000', 'consum', 0.0215, 'lps'),
	(553648, 127, '2014-03-01 00:21:55.000000', 'consum', 0.0233, 'lps'),
	(553649, 127, '2014-03-01 00:21:56.000000', 'consum', 0.0224, 'lps'),
	(553650, 127, '2014-03-01 00:21:57.000000', 'consum', 0.0211, 'lps'),
	(553651, 127, '2014-03-01 00:21:58.000000', 'consum', 0.0232, 'lps'),
	(553652, 127, '2014-03-01 00:21:59.000000', 'consum', 0.0231, 'lps'),
	(553653, 127, '2014-03-01 00:22:00.000000', 'consum', 0.0220, 'lps'),
	(553654, 127, '2014-03-01 00:22:01.000000', 'consum', 0.0225, 'lps'),
	(553655, 127, '2014-03-01 00:22:02.000000', 'consum', 0.0229, 'lps'),
	(553656, 127, '2014-03-01 00:22:03.000000', 'consum', 0.0232, 'lps'),
	(553657, 127, '2014-03-01 00:22:04.000000', 'consum', 0.0235, 'lps'),
	(553658, 127, '2014-03-01 00:22:05.000000', 'consum', 0.0237, 'lps'),
	(553659, 127, '2014-03-01 00:22:06.000000', 'consum', 0.0215, 'lps'),
	(553660, 127, '2014-03-01 00:22:07.000000', 'consum', 0.0214, 'lps'),
	(553661, 127, '2014-03-01 00:22:08.000000', 'consum', 0.0213, 'lps'),
	(553662, 127, '2014-03-01 00:22:09.000000', 'consum', 0.0216, 'lps'),
	(553663, 127, '2014-03-01 00:22:10.000000', 'consum', 0.0229, 'lps'),
	(553664, 127, '2014-03-01 00:22:11.000000', 'consum', 0.0230, 'lps'),
	(553665, 127, '2014-03-01 00:22:12.000000', 'consum', 0.0223, 'lps'),
	(553666, 127, '2014-03-01 00:22:13.000000', 'consum', 0.0217, 'lps'),
	(553667, 127, '2014-03-01 00:22:14.000000', 'consum', 0.0236, 'lps'),
	(553668, 127, '2014-03-01 00:22:15.000000', 'consum', 0.0233, 'lps'),
	(553669, 127, '2014-03-01 00:22:16.000000', 'consum', 0.0218, 'lps'),
	(553670, 127, '2014-03-01 00:22:17.000000', 'consum', 0.0212, 'lps'),
	(553671, 127, '2014-03-01 00:22:18.000000', 'consum', 0.0225, 'lps'),
	(553672, 127, '2014-03-01 00:22:19.000000', 'consum', 0.0219, 'lps'),
	(553673, 127, '2014-03-01 00:22:20.000000', 'consum', 0.0214, 'lps'),
	(553674, 127, '2014-03-01 00:22:21.000000', 'consum', 0.0231, 'lps'),
	(553675, 127, '2014-03-01 00:22:22.000000', 'consum', 0.0217, 'lps'),
	(553676, 127, '2014-03-01 00:22:23.000000', 'consum', 0.0210, 'lps'),
	(553677, 127, '2014-03-01 00:22:24.000000', 'consum', 0.0221, 'lps'),
	(553678, 127, '2014-03-01 00:22:25.000000', 'consum', 0.0237, 'lps'),
	(553679, 127, '2014-03-01 00:22:26.000000', 'consum', 0.0224, 'lps'),
	(553680, 127, '2014-03-01 00:22:27.000000', 'consum', 0.0228, 'lps'),
	(553681, 127, '2014-03-01 00:22:28.000000', 'consum', 0.0229, 'lps'),
	(553682, 127, '2014-03-01 00:22:29.000000', 'consum', 0.0223, 'lps'),
	(553683, 127, '2014-03-01 00:22:30.000000', 'consum', 0.0217, 'lps'),
	(553684, 127, '2014-03-01 00:22:31.000000', 'consum', 0.0235, 'lps'),
	(553685, 127, '2014-03-01 00:22:32.000000', 'consum', 0.0228, 'lps'),
	(553686, 127, '2014-03-01 00:22:33.000000', 'consum', 0.0225, 'lps'),
	(553687, 127, '2014-03-01 00:22:34.000000', 'consum', 0.0232, 'lps'),
	(553688, 127, '2014-03-01 00:22:35.000000', 'consum', 0.0216, 'lps'),
	(553689, 127, '2014-03-01 00:22:36.000000', 'consum', 0.0233, 'lps'),
	(553690, 127, '2014-03-01 00:22:37.000000', 'consum', 0.0220, 'lps'),
	(553691, 127, '2014-03-01 00:22:38.000000', 'consum', 0.0222, 'lps'),
	(553692, 127, '2014-03-01 00:22:39.000000', 'consum', 0.0210, 'lps'),
	(553693, 127, '2014-03-01 00:22:40.000000', 'consum', 0.0235, 'lps'),
	(553694, 127, '2014-03-01 00:22:41.000000', 'consum', 0.0218, 'lps'),
	(553695, 127, '2014-03-01 00:22:42.000000', 'consum', 0.0233, 'lps'),
	(553696, 127, '2014-03-01 00:22:43.000000', 'consum', 0.0216, 'lps'),
	(553697, 127, '2014-03-01 00:22:44.000000', 'consum', 0.0228, 'lps'),
	(553698, 127, '2014-03-01 00:22:45.000000', 'consum', 0.0224, 'lps'),
	(553699, 127, '2014-03-01 00:22:46.000000', 'consum', 0.0229, 'lps'),
	(553700, 127, '2014-03-01 00:22:47.000000', 'consum', 0.0232, 'lps'),
	(553701, 127, '2014-03-01 00:22:48.000000', 'consum', 0.0237, 'lps'),
	(553702, 127, '2014-03-01 00:22:49.000000', 'consum', 0.0221, 'lps'),
	(553703, 127, '2014-03-01 00:22:50.000000', 'consum', 0.0215, 'lps'),
	(553704, 127, '2014-03-01 00:22:51.000000', 'consum', 0.0231, 'lps'),
	(553705, 127, '2014-03-01 00:22:52.000000', 'consum', 0.0211, 'lps'),
	(553706, 127, '2014-03-01 00:22:53.000000', 'consum', 0.0211, 'lps'),
	(553707, 127, '2014-03-01 00:22:54.000000', 'consum', 0.0213, 'lps'),
	(553708, 127, '2014-03-01 00:22:55.000000', 'consum', 0.0221, 'lps'),
	(553709, 127, '2014-03-01 00:22:56.000000', 'consum', 0.0227, 'lps'),
	(553710, 127, '2014-03-01 00:22:57.000000', 'consum', 0.0233, 'lps'),
	(553711, 127, '2014-03-01 00:22:58.000000', 'consum', 0.0218, 'lps'),
	(553712, 127, '2014-03-01 00:22:59.000000', 'consum', 0.0212, 'lps'),
	(553713, 127, '2014-03-01 00:23:00.000000', 'consum', 0.0223, 'lps'),
	(553714, 127, '2014-03-01 00:23:01.000000', 'consum', 0.0213, 'lps'),
	(553715, 127, '2014-03-01 00:23:02.000000', 'consum', 0.0215, 'lps'),
	(553716, 127, '2014-03-01 00:23:03.000000', 'consum', 0.0228, 'lps'),
	(553717, 127, '2014-03-01 00:23:04.000000', 'consum', 0.0226, 'lps'),
	(553718, 127, '2014-03-01 00:23:05.000000', 'consum', 0.0210, 'lps'),
	(553719, 127, '2014-03-01 00:23:06.000000', 'consum', 0.0219, 'lps'),
	(553720, 127, '2014-03-01 00:23:07.000000', 'consum', 0.0225, 'lps'),
	(553721, 127, '2014-03-01 00:23:08.000000', 'consum', 0.0231, 'lps'),
	(553722, 127, '2014-03-01 00:23:09.000000', 'consum', 0.0213, 'lps'),
	(553723, 127, '2014-03-01 00:23:10.000000', 'consum', 0.0221, 'lps'),
	(553724, 127, '2014-03-01 00:23:11.000000', 'consum', 0.0228, 'lps'),
	(553725, 127, '2014-03-01 00:23:12.000000', 'consum', 0.0237, 'lps'),
	(553726, 127, '2014-03-01 00:23:13.000000', 'consum', 0.0235, 'lps'),
	(553727, 127, '2014-03-01 00:23:14.000000', 'consum', 0.0225, 'lps'),
	(553728, 127, '2014-03-01 00:23:15.000000', 'consum', 0.0210, 'lps'),
	(553729, 127, '2014-03-01 00:23:16.000000', 'consum', 0.0222, 'lps'),
	(553730, 127, '2014-03-01 00:23:17.000000', 'consum', 0.0213, 'lps'),
	(553731, 127, '2014-03-01 00:23:18.000000', 'consum', 0.0220, 'lps'),
	(553732, 127, '2014-03-01 00:23:19.000000', 'consum', 0.0222, 'lps'),
	(553733, 127, '2014-03-01 00:23:20.000000', 'consum', 0.0210, 'lps'),
	(553734, 127, '2014-03-01 00:23:21.000000', 'consum', 0.0235, 'lps'),
	(553735, 127, '2014-03-01 00:23:22.000000', 'consum', 0.0218, 'lps'),
	(553736, 127, '2014-03-01 00:23:23.000000', 'consum', 0.0232, 'lps'),
	(553737, 127, '2014-03-01 00:23:24.000000', 'consum', 0.0238, 'lps'),
	(553738, 127, '2014-03-01 00:23:25.000000', 'consum', 0.0230, 'lps'),
	(553739, 127, '2014-03-01 00:23:26.000000', 'consum', 0.0224, 'lps'),
	(553740, 127, '2014-03-01 00:23:27.000000', 'consum', 0.0219, 'lps'),
	(553741, 127, '2014-03-01 00:23:28.000000', 'consum', 0.0216, 'lps'),
	(553742, 127, '2014-03-01 00:23:29.000000', 'consum', 0.0213, 'lps'),
	(553743, 127, '2014-03-01 00:23:30.000000', 'consum', 0.0235, 'lps'),
	(553744, 127, '2014-03-01 00:23:31.000000', 'consum', 0.0212, 'lps'),
	(553745, 127, '2014-03-01 00:23:32.000000', 'consum', 0.0233, 'lps'),
	(553746, 127, '2014-03-01 00:23:33.000000', 'consum', 0.0231, 'lps'),
	(553747, 127, '2014-03-01 00:23:34.000000', 'consum', 0.0218, 'lps'),
	(553748, 127, '2014-03-01 00:23:35.000000', 'consum', 0.0217, 'lps'),
	(553749, 127, '2014-03-01 00:23:36.000000', 'consum', 0.0221, 'lps'),
	(553750, 127, '2014-03-01 00:23:37.000000', 'consum', 0.0216, 'lps'),
	(553751, 127, '2014-03-01 00:23:38.000000', 'consum', 0.0237, 'lps'),
	(553752, 127, '2014-03-01 00:23:39.000000', 'consum', 0.0211, 'lps'),
	(553753, 127, '2014-03-01 00:23:40.000000', 'consum', 0.0220, 'lps'),
	(553754, 127, '2014-03-01 00:23:41.000000', 'consum', 0.0228, 'lps'),
	(553755, 127, '2014-03-01 00:23:42.000000', 'consum', 0.0214, 'lps'),
	(553756, 127, '2014-03-01 00:23:43.000000', 'consum', 0.0236, 'lps'),
	(553757, 127, '2014-03-01 00:23:44.000000', 'consum', 0.0212, 'lps'),
	(553758, 127, '2014-03-01 00:23:45.000000', 'consum', 0.0231, 'lps'),
	(553759, 127, '2014-03-01 00:23:46.000000', 'consum', 0.0221, 'lps'),
	(553760, 127, '2014-03-01 00:23:47.000000', 'consum', 0.0231, 'lps'),
	(553761, 127, '2014-03-01 00:23:48.000000', 'consum', 0.0225, 'lps'),
	(553762, 127, '2014-03-01 00:23:49.000000', 'consum', 0.0224, 'lps'),
	(553763, 127, '2014-03-01 00:23:50.000000', 'consum', 0.0234, 'lps'),
	(553764, 127, '2014-03-01 00:23:51.000000', 'consum', 0.0232, 'lps'),
	(553765, 127, '2014-03-01 00:23:52.000000', 'consum', 0.0218, 'lps'),
	(553766, 127, '2014-03-01 00:23:53.000000', 'consum', 0.0216, 'lps'),
	(553767, 127, '2014-03-01 00:23:54.000000', 'consum', 0.0214, 'lps'),
	(553768, 127, '2014-03-01 00:23:55.000000', 'consum', 0.0213, 'lps'),
	(553769, 127, '2014-03-01 00:23:56.000000', 'consum', 0.0215, 'lps'),
	(553770, 127, '2014-03-01 00:23:57.000000', 'consum', 0.0227, 'lps'),
	(553771, 127, '2014-03-01 00:23:58.000000', 'consum', 0.0220, 'lps'),
	(553772, 127, '2014-03-01 00:23:59.000000', 'consum', 0.0213, 'lps'),
	(553773, 127, '2014-03-01 00:24:00.000000', 'consum', 0.0221, 'lps'),
	(553774, 127, '2014-03-01 00:24:01.000000', 'consum', 0.0227, 'lps'),
	(553775, 127, '2014-03-01 00:24:02.000000', 'consum', 0.0236, 'lps'),
	(553776, 127, '2014-03-01 00:24:03.000000', 'consum', 0.0232, 'lps'),
	(553777, 127, '2014-03-01 00:24:04.000000', 'consum', 0.0211, 'lps'),
	(553778, 127, '2014-03-01 00:24:05.000000', 'consum', 0.0238, 'lps'),
	(553779, 127, '2014-03-01 00:24:06.000000', 'consum', 0.0233, 'lps'),
	(553780, 127, '2014-03-01 00:24:07.000000', 'consum', 0.0210, 'lps'),
	(553781, 127, '2014-03-01 00:24:08.000000', 'consum', 0.0228, 'lps'),
	(553782, 127, '2014-03-01 00:24:09.000000', 'consum', 0.0215, 'lps'),
	(553783, 127, '2014-03-01 00:24:10.000000', 'consum', 0.0237, 'lps'),
	(553784, 127, '2014-03-01 00:24:11.000000', 'consum', 0.0217, 'lps'),
	(553785, 127, '2014-03-01 00:24:12.000000', 'consum', 0.0222, 'lps'),
	(553786, 127, '2014-03-01 00:24:13.000000', 'consum', 0.0219, 'lps'),
	(553787, 127, '2014-03-01 00:24:14.000000', 'consum', 0.0223, 'lps'),
	(553788, 127, '2014-03-01 00:24:15.000000', 'consum', 0.0216, 'lps'),
	(553789, 127, '2014-03-01 00:24:16.000000', 'consum', 0.0231, 'lps'),
	(553790, 127, '2014-03-01 00:24:17.000000', 'consum', 0.0211, 'lps'),
	(553791, 127, '2014-03-01 00:24:18.000000', 'consum', 0.0210, 'lps'),
	(553792, 127, '2014-03-01 00:24:19.000000', 'consum', 0.0238, 'lps'),
	(553793, 127, '2014-03-01 00:24:20.000000', 'consum', 0.0235, 'lps'),
	(553794, 127, '2014-03-01 00:24:21.000000', 'consum', 0.0223, 'lps'),
	(553795, 127, '2014-03-01 00:24:22.000000', 'consum', 0.0227, 'lps'),
	(553796, 127, '2014-03-01 00:24:23.000000', 'consum', 0.0230, 'lps'),
	(553797, 127, '2014-03-01 00:24:24.000000', 'consum', 0.0230, 'lps'),
	(553798, 127, '2014-03-01 00:24:25.000000', 'consum', 0.0220, 'lps'),
	(553799, 127, '2014-03-01 00:24:26.000000', 'consum', 0.0230, 'lps'),
	(553800, 127, '2014-03-01 00:24:27.000000', 'consum', 0.0223, 'lps'),
	(553801, 127, '2014-03-01 00:24:28.000000', 'consum', 0.0214, 'lps'),
	(553802, 127, '2014-03-01 00:24:29.000000', 'consum', 0.0221, 'lps'),
	(553803, 127, '2014-03-01 00:24:30.000000', 'consum', 0.0225, 'lps'),
	(553804, 127, '2014-03-01 00:24:31.000000', 'consum', 0.0222, 'lps'),
	(553805, 127, '2014-03-01 00:24:32.000000', 'consum', 0.0224, 'lps'),
	(553806, 127, '2014-03-01 00:24:33.000000', 'consum', 0.0219, 'lps'),
	(553807, 127, '2014-03-01 00:24:34.000000', 'consum', 0.0213, 'lps'),
	(553808, 127, '2014-03-01 00:24:35.000000', 'consum', 0.0229, 'lps'),
	(553809, 127, '2014-03-01 00:24:36.000000', 'consum', 0.0236, 'lps'),
	(553810, 127, '2014-03-01 00:24:37.000000', 'consum', 0.0228, 'lps'),
	(553811, 127, '2014-03-01 00:24:38.000000', 'consum', 0.0223, 'lps'),
	(553812, 127, '2014-03-01 00:24:39.000000', 'consum', 0.0219, 'lps'),
	(553813, 127, '2014-03-01 00:24:40.000000', 'consum', 0.0216, 'lps'),
	(553814, 127, '2014-03-01 00:24:41.000000', 'consum', 0.0216, 'lps'),
	(553815, 127, '2014-03-01 00:24:42.000000', 'consum', 0.0222, 'lps'),
	(553816, 127, '2014-03-01 00:24:43.000000', 'consum', 0.0224, 'lps'),
	(553817, 127, '2014-03-01 00:24:44.000000', 'consum', 0.0217, 'lps'),
	(553818, 127, '2014-03-01 00:24:45.000000', 'consum', 0.0229, 'lps'),
	(553819, 127, '2014-03-01 00:24:46.000000', 'consum', 0.0230, 'lps'),
	(553820, 127, '2014-03-01 00:24:47.000000', 'consum', 0.0222, 'lps'),
	(553821, 127, '2014-03-01 00:24:48.000000', 'consum', 0.0212, 'lps'),
	(553822, 127, '2014-03-01 00:24:49.000000', 'consum', 0.0215, 'lps'),
	(553823, 127, '2014-03-01 00:24:50.000000', 'consum', 0.0228, 'lps'),
	(553824, 127, '2014-03-01 00:24:51.000000', 'consum', 0.0229, 'lps'),
	(553825, 127, '2014-03-01 00:24:52.000000', 'consum', 0.0221, 'lps'),
	(553826, 127, '2014-03-01 00:24:53.000000', 'consum', 0.0211, 'lps'),
	(553827, 127, '2014-03-01 00:24:54.000000', 'consum', 0.0238, 'lps'),
	(553828, 127, '2014-03-01 00:24:55.000000', 'consum', 0.0230, 'lps'),
	(553829, 127, '2014-03-01 00:24:56.000000', 'consum', 0.0229, 'lps'),
	(553830, 127, '2014-03-01 00:24:57.000000', 'consum', 0.0218, 'lps'),
	(553831, 127, '2014-03-01 00:24:58.000000', 'consum', 0.0221, 'lps'),
	(553832, 127, '2014-03-01 00:24:59.000000', 'consum', 0.0212, 'lps'),
	(553833, 127, '2014-03-01 00:25:00.000000', 'consum', 0.0215, 'lps'),
	(553834, 127, '2014-03-01 00:25:01.000000', 'consum', 0.0231, 'lps'),
	(553835, 127, '2014-03-01 00:25:02.000000', 'consum', 0.0213, 'lps'),
	(553836, 127, '2014-03-01 00:25:03.000000', 'consum', 0.0221, 'lps'),
	(553837, 127, '2014-03-01 00:25:04.000000', 'consum', 0.0228, 'lps'),
	(553838, 127, '2014-03-01 00:25:05.000000', 'consum', 0.0210, 'lps'),
	(553839, 127, '2014-03-01 00:25:06.000000', 'consum', 0.0212, 'lps'),
	(553840, 127, '2014-03-01 00:25:07.000000', 'consum', 0.0220, 'lps'),
	(553841, 127, '2014-03-01 00:25:08.000000', 'consum', 0.0229, 'lps'),
	(553842, 127, '2014-03-01 00:25:09.000000', 'consum', 0.0215, 'lps'),
	(553843, 127, '2014-03-01 00:25:10.000000', 'consum', 0.0235, 'lps'),
	(553844, 127, '2014-03-01 00:25:11.000000', 'consum', 0.0236, 'lps'),
	(553845, 127, '2014-03-01 00:25:12.000000', 'consum', 0.0234, 'lps'),
	(553846, 127, '2014-03-01 00:25:13.000000', 'consum', 0.0226, 'lps'),
	(553847, 127, '2014-03-01 00:25:14.000000', 'consum', 0.0217, 'lps'),
	(553848, 127, '2014-03-01 00:25:15.000000', 'consum', 0.0226, 'lps'),
	(553849, 127, '2014-03-01 00:25:16.000000', 'consum', 0.0214, 'lps'),
	(553850, 127, '2014-03-01 00:25:17.000000', 'consum', 0.0210, 'lps'),
	(553851, 127, '2014-03-01 00:25:18.000000', 'consum', 0.0226, 'lps'),
	(553852, 127, '2014-03-01 00:25:19.000000', 'consum', 0.0235, 'lps'),
	(553853, 127, '2014-03-01 00:25:20.000000', 'consum', 0.0229, 'lps'),
	(553854, 127, '2014-03-01 00:25:21.000000', 'consum', 0.0231, 'lps'),
	(553855, 127, '2014-03-01 00:25:22.000000', 'consum', 0.0230, 'lps'),
	(553856, 127, '2014-03-01 00:25:23.000000', 'consum', 0.0219, 'lps'),
	(553857, 127, '2014-03-01 00:25:24.000000', 'consum', 0.0226, 'lps'),
	(553858, 127, '2014-03-01 00:25:25.000000', 'consum', 0.0231, 'lps'),
	(553859, 127, '2014-03-01 00:25:26.000000', 'consum', 0.0211, 'lps'),
	(553860, 127, '2014-03-01 00:25:27.000000', 'consum', 0.0211, 'lps'),
	(553861, 127, '2014-03-01 00:25:28.000000', 'consum', 0.0212, 'lps'),
	(553862, 127, '2014-03-01 00:25:29.000000', 'consum', 0.0218, 'lps'),
	(553863, 127, '2014-03-01 00:25:30.000000', 'consum', 0.0214, 'lps'),
	(553864, 127, '2014-03-01 00:25:31.000000', 'consum', 0.0236, 'lps'),
	(553865, 127, '2014-03-01 00:25:32.000000', 'consum', 0.0211, 'lps'),
	(553866, 127, '2014-03-01 00:25:33.000000', 'consum', 0.0227, 'lps'),
	(553867, 127, '2014-03-01 00:25:34.000000', 'consum', 0.0233, 'lps'),
	(553868, 127, '2014-03-01 00:25:35.000000', 'consum', 0.0218, 'lps'),
	(553869, 127, '2014-03-01 00:25:36.000000', 'consum', 0.0211, 'lps'),
	(553870, 127, '2014-03-01 00:25:37.000000', 'consum', 0.0219, 'lps'),
	(553871, 127, '2014-03-01 00:25:38.000000', 'consum', 0.0225, 'lps'),
	(553872, 127, '2014-03-01 00:25:39.000000', 'consum', 0.0229, 'lps'),
	(553873, 127, '2014-03-01 00:25:40.000000', 'consum', 0.0232, 'lps'),
	(553874, 127, '2014-03-01 00:25:41.000000', 'consum', 0.0235, 'lps'),
	(553875, 127, '2014-03-01 00:25:42.000000', 'consum', 0.0211, 'lps'),
	(553876, 127, '2014-03-01 00:25:43.000000', 'consum', 0.0226, 'lps'),
	(553877, 127, '2014-03-01 00:25:44.000000', 'consum', 0.0230, 'lps'),
	(553878, 127, '2014-03-01 00:25:45.000000', 'consum', 0.0233, 'lps'),
	(553879, 127, '2014-03-01 00:25:46.000000', 'consum', 0.0238, 'lps'),
	(553880, 127, '2014-03-01 00:25:47.000000', 'consum', 0.0224, 'lps'),
	(553881, 127, '2014-03-01 00:25:48.000000', 'consum', 0.0226, 'lps'),
	(553882, 127, '2014-03-01 00:25:49.000000', 'consum', 0.0218, 'lps'),
	(553883, 127, '2014-03-01 00:25:50.000000', 'consum', 0.0232, 'lps'),
	(553884, 127, '2014-03-01 00:25:51.000000', 'consum', 0.0237, 'lps'),
	(553885, 127, '2014-03-01 00:25:52.000000', 'consum', 0.0223, 'lps'),
	(553886, 127, '2014-03-01 00:25:53.000000', 'consum', 0.0222, 'lps'),
	(553887, 127, '2014-03-01 00:25:54.000000', 'consum', 0.0233, 'lps'),
	(553888, 127, '2014-03-01 00:25:55.000000', 'consum', 0.0231, 'lps'),
	(553889, 127, '2014-03-01 00:25:56.000000', 'consum', 0.0218, 'lps'),
	(553890, 127, '2014-03-01 00:25:57.000000', 'consum', 0.0215, 'lps'),
	(553891, 127, '2014-03-01 00:25:58.000000', 'consum', 0.0213, 'lps'),
	(553892, 127, '2014-03-01 00:25:59.000000', 'consum', 0.0211, 'lps'),
	(553893, 127, '2014-03-01 00:26:00.000000', 'consum', 0.0233, 'lps'),
	(553894, 127, '2014-03-01 00:26:01.000000', 'consum', 0.0237, 'lps'),
	(553895, 127, '2014-03-01 00:26:02.000000', 'consum', 0.0220, 'lps'),
	(553896, 127, '2014-03-01 00:26:03.000000', 'consum', 0.0237, 'lps'),
	(553897, 127, '2014-03-01 00:26:04.000000', 'consum', 0.0226, 'lps'),
	(553898, 127, '2014-03-01 00:26:05.000000', 'consum', 0.0211, 'lps'),
	(553899, 127, '2014-03-01 00:26:06.000000', 'consum', 0.0227, 'lps'),
	(553900, 127, '2014-03-01 00:26:07.000000', 'consum', 0.0234, 'lps'),
	(553901, 127, '2014-03-01 00:26:08.000000', 'consum', 0.0222, 'lps'),
	(553902, 127, '2014-03-01 00:26:09.000000', 'consum', 0.0227, 'lps'),
	(553903, 127, '2014-03-01 00:26:10.000000', 'consum', 0.0231, 'lps'),
	(553904, 127, '2014-03-01 00:26:11.000000', 'consum', 0.0233, 'lps'),
	(553905, 127, '2014-03-01 00:26:12.000000', 'consum', 0.0236, 'lps'),
	(553906, 127, '2014-03-01 00:26:13.000000', 'consum', 0.0215, 'lps'),
	(553907, 127, '2014-03-01 00:26:14.000000', 'consum', 0.0212, 'lps'),
	(553908, 127, '2014-03-01 00:26:15.000000', 'consum', 0.0237, 'lps'),
	(553909, 127, '2014-03-01 00:26:16.000000', 'consum', 0.0224, 'lps'),
	(553910, 127, '2014-03-01 00:26:17.000000', 'consum', 0.0226, 'lps'),
	(553911, 127, '2014-03-01 00:26:18.000000', 'consum', 0.0223, 'lps'),
	(553912, 127, '2014-03-01 00:26:19.000000', 'consum', 0.0224, 'lps'),
	(553913, 127, '2014-03-01 00:26:20.000000', 'consum', 0.0214, 'lps'),
	(553914, 127, '2014-03-01 00:26:21.000000', 'consum', 0.0216, 'lps'),
	(553915, 127, '2014-03-01 00:26:22.000000', 'consum', 0.0231, 'lps'),
	(553916, 127, '2014-03-01 00:26:23.000000', 'consum', 0.0237, 'lps'),
	(553917, 127, '2014-03-01 00:26:24.000000', 'consum', 0.0226, 'lps'),
	(553918, 127, '2014-03-01 00:26:25.000000', 'consum', 0.0210, 'lps'),
	(553919, 127, '2014-03-01 00:26:26.000000', 'consum', 0.0220, 'lps'),
	(553920, 127, '2014-03-01 00:26:27.000000', 'consum', 0.0230, 'lps'),
	(553921, 127, '2014-03-01 00:26:28.000000', 'consum', 0.0222, 'lps'),
	(553922, 127, '2014-03-01 00:26:29.000000', 'consum', 0.0212, 'lps'),
	(553923, 127, '2014-03-01 00:26:30.000000', 'consum', 0.0213, 'lps'),
	(553924, 127, '2014-03-01 00:26:31.000000', 'consum', 0.0221, 'lps'),
	(553925, 127, '2014-03-01 00:26:32.000000', 'consum', 0.0227, 'lps'),
	(553926, 127, '2014-03-01 00:26:33.000000', 'consum', 0.0235, 'lps'),
	(553927, 127, '2014-03-01 00:26:34.000000', 'consum', 0.0225, 'lps'),
	(553928, 127, '2014-03-01 00:26:35.000000', 'consum', 0.0238, 'lps'),
	(553929, 127, '2014-03-01 00:26:36.000000', 'consum', 0.0221, 'lps'),
	(553930, 127, '2014-03-01 00:26:37.000000', 'consum', 0.0211, 'lps'),
	(553931, 127, '2014-03-01 00:26:38.000000', 'consum', 0.0238, 'lps'),
	(553932, 127, '2014-03-01 00:26:39.000000', 'consum', 0.0233, 'lps'),
	(553933, 127, '2014-03-01 00:26:40.000000', 'consum', 0.0213, 'lps'),
	(553934, 127, '2014-03-01 00:26:41.000000', 'consum', 0.0213, 'lps'),
	(553935, 127, '2014-03-01 00:26:42.000000', 'consum', 0.0215, 'lps'),
	(553936, 127, '2014-03-01 00:26:43.000000', 'consum', 0.0230, 'lps'),
	(553937, 127, '2014-03-01 00:26:44.000000', 'consum', 0.0236, 'lps'),
	(553938, 127, '2014-03-01 00:26:45.000000', 'consum', 0.0221, 'lps'),
	(553939, 127, '2014-03-01 00:26:46.000000', 'consum', 0.0216, 'lps'),
	(553940, 127, '2014-03-01 00:26:47.000000', 'consum', 0.0210, 'lps'),
	(553941, 127, '2014-03-01 00:26:48.000000', 'consum', 0.0221, 'lps'),
	(553942, 127, '2014-03-01 00:26:49.000000', 'consum', 0.0234, 'lps'),
	(553943, 127, '2014-03-01 00:26:50.000000', 'consum', 0.0213, 'lps'),
	(553944, 127, '2014-03-01 00:26:51.000000', 'consum', 0.0212, 'lps'),
	(553945, 127, '2014-03-01 00:26:52.000000', 'consum', 0.0212, 'lps'),
	(553946, 127, '2014-03-01 00:26:53.000000', 'consum', 0.0212, 'lps'),
	(553947, 127, '2014-03-01 00:26:54.000000', 'consum', 0.0216, 'lps'),
	(553948, 127, '2014-03-01 00:26:55.000000', 'consum', 0.0236, 'lps'),
	(553949, 127, '2014-03-01 00:26:56.000000', 'consum', 0.0234, 'lps'),
	(553950, 127, '2014-03-01 00:26:57.000000', 'consum', 0.0224, 'lps'),
	(553951, 127, '2014-03-01 00:26:58.000000', 'consum', 0.0237, 'lps'),
	(553952, 127, '2014-03-01 00:26:59.000000', 'consum', 0.0218, 'lps'),
	(553953, 127, '2014-03-01 00:27:00.000000', 'consum', 0.0228, 'lps'),
	(553954, 127, '2014-03-01 00:27:01.000000', 'consum', 0.0220, 'lps'),
	(553955, 127, '2014-03-01 00:27:02.000000', 'consum', 0.0232, 'lps'),
	(553956, 127, '2014-03-01 00:27:03.000000', 'consum', 0.0235, 'lps'),
	(553957, 127, '2014-03-01 00:27:04.000000', 'consum', 0.0238, 'lps'),
	(553958, 127, '2014-03-01 00:27:05.000000', 'consum', 0.0219, 'lps'),
	(553959, 127, '2014-03-01 00:27:06.000000', 'consum', 0.0229, 'lps'),
	(553960, 127, '2014-03-01 00:27:07.000000', 'consum', 0.0223, 'lps'),
	(553961, 127, '2014-03-01 00:27:08.000000', 'consum', 0.0216, 'lps'),
	(553962, 127, '2014-03-01 00:27:09.000000', 'consum', 0.0230, 'lps'),
	(553963, 127, '2014-03-01 00:27:10.000000', 'consum', 0.0237, 'lps'),
	(553964, 127, '2014-03-01 00:27:11.000000', 'consum', 0.0228, 'lps'),
	(553965, 127, '2014-03-01 00:27:12.000000', 'consum', 0.0219, 'lps'),
	(553966, 127, '2014-03-01 00:27:13.000000', 'consum', 0.0229, 'lps'),
	(553967, 127, '2014-03-01 00:27:14.000000', 'consum', 0.0221, 'lps'),
	(553968, 127, '2014-03-01 00:27:15.000000', 'consum', 0.0238, 'lps'),
	(553969, 127, '2014-03-01 00:27:16.000000', 'consum', 0.0229, 'lps'),
	(553970, 127, '2014-03-01 00:27:17.000000', 'consum', 0.0222, 'lps'),
	(553971, 127, '2014-03-01 00:27:18.000000', 'consum', 0.0215, 'lps'),
	(553972, 127, '2014-03-01 00:27:19.000000', 'consum', 0.0226, 'lps'),
	(553973, 127, '2014-03-01 00:27:20.000000', 'consum', 0.0221, 'lps'),
	(553974, 127, '2014-03-01 00:27:21.000000', 'consum', 0.0214, 'lps'),
	(553975, 127, '2014-03-01 00:27:22.000000', 'consum', 0.0230, 'lps'),
	(553976, 127, '2014-03-01 00:27:23.000000', 'consum', 0.0237, 'lps'),
	(553977, 127, '2014-03-01 00:27:24.000000', 'consum', 0.0230, 'lps'),
	(553978, 127, '2014-03-01 00:27:25.000000', 'consum', 0.0227, 'lps'),
	(553979, 127, '2014-03-01 00:27:26.000000', 'consum', 0.0238, 'lps'),
	(553980, 127, '2014-03-01 00:27:27.000000', 'consum', 0.0211, 'lps'),
	(553981, 127, '2014-03-01 00:27:28.000000', 'consum', 0.0220, 'lps'),
	(553982, 127, '2014-03-01 00:27:29.000000', 'consum', 0.0228, 'lps'),
	(553983, 127, '2014-03-01 00:27:30.000000', 'consum', 0.0213, 'lps'),
	(553984, 127, '2014-03-01 00:27:31.000000', 'consum', 0.0230, 'lps'),
	(553985, 127, '2014-03-01 00:27:32.000000', 'consum', 0.0214, 'lps'),
	(553986, 127, '2014-03-01 00:27:33.000000', 'consum', 0.0228, 'lps'),
	(553987, 127, '2014-03-01 00:27:34.000000', 'consum', 0.0231, 'lps'),
	(553988, 127, '2014-03-01 00:27:35.000000', 'consum', 0.0231, 'lps'),
	(553989, 127, '2014-03-01 00:27:36.000000', 'consum', 0.0224, 'lps'),
	(553990, 127, '2014-03-01 00:27:37.000000', 'consum', 0.0218, 'lps'),
	(553991, 127, '2014-03-01 00:27:38.000000', 'consum', 0.0238, 'lps'),
	(553992, 127, '2014-03-01 00:27:39.000000', 'consum', 0.0238, 'lps'),
	(553993, 127, '2014-03-01 00:27:40.000000', 'consum', 0.0238, 'lps'),
	(553994, 127, '2014-03-01 00:27:41.000000', 'consum', 0.0210, 'lps'),
	(553995, 127, '2014-03-01 00:27:42.000000', 'consum', 0.0213, 'lps'),
	(553996, 127, '2014-03-01 00:27:43.000000', 'consum', 0.0226, 'lps'),
	(553997, 127, '2014-03-01 00:27:44.000000', 'consum', 0.0223, 'lps'),
	(553998, 127, '2014-03-01 00:27:45.000000', 'consum', 0.0230, 'lps'),
	(553999, 127, '2014-03-01 00:27:46.000000', 'consum', 0.0210, 'lps'),
	(554000, 127, '2014-03-01 00:27:47.000000', 'consum', 0.0210, 'lps'),
	(554001, 127, '2014-03-01 00:27:48.000000', 'consum', 0.0238, 'lps'),
	(554002, 127, '2014-03-01 00:27:49.000000', 'consum', 0.0235, 'lps'),
	(554003, 127, '2014-03-01 00:27:50.000000', 'consum', 0.0223, 'lps'),
	(554004, 127, '2014-03-01 00:27:51.000000', 'consum', 0.0231, 'lps'),
	(554005, 127, '2014-03-01 00:27:52.000000', 'consum', 0.0219, 'lps'),
	(554006, 127, '2014-03-01 00:27:53.000000', 'consum', 0.0221, 'lps'),
	(554007, 127, '2014-03-01 00:27:54.000000', 'consum', 0.0237, 'lps'),
	(554008, 127, '2014-03-01 00:27:55.000000', 'consum', 0.0225, 'lps'),
	(554009, 127, '2014-03-01 00:27:56.000000', 'consum', 0.0233, 'lps'),
	(554010, 127, '2014-03-01 00:27:57.000000', 'consum', 0.0223, 'lps'),
	(554011, 127, '2014-03-01 00:27:58.000000', 'consum', 0.0237, 'lps'),
	(554012, 127, '2014-03-01 00:27:59.000000', 'consum', 0.0220, 'lps'),
	(554013, 127, '2014-03-01 00:28:00.000000', 'consum', 0.0236, 'lps'),
	(554014, 127, '2014-03-01 00:28:01.000000', 'consum', 0.0224, 'lps'),
	(554015, 127, '2014-03-01 00:28:02.000000', 'consum', 0.0230, 'lps'),
	(554016, 127, '2014-03-01 00:28:03.000000', 'consum', 0.0210, 'lps'),
	(554017, 127, '2014-03-01 00:28:04.000000', 'consum', 0.0238, 'lps'),
	(554018, 127, '2014-03-01 00:28:05.000000', 'consum', 0.0236, 'lps'),
	(554019, 127, '2014-03-01 00:28:06.000000', 'consum', 0.0226, 'lps'),
	(554020, 127, '2014-03-01 00:28:07.000000', 'consum', 0.0215, 'lps'),
	(554021, 127, '2014-03-01 00:28:08.000000', 'consum', 0.0214, 'lps'),
	(554022, 127, '2014-03-01 00:28:09.000000', 'consum', 0.0217, 'lps'),
	(554023, 127, '2014-03-01 00:28:10.000000', 'consum', 0.0234, 'lps'),
	(554024, 127, '2014-03-01 00:28:11.000000', 'consum', 0.0223, 'lps'),
	(554025, 127, '2014-03-01 00:28:12.000000', 'consum', 0.0233, 'lps'),
	(554026, 127, '2014-03-01 00:28:13.000000', 'consum', 0.0228, 'lps'),
	(554027, 127, '2014-03-01 00:28:14.000000', 'consum', 0.0233, 'lps'),
	(554028, 127, '2014-03-01 00:28:15.000000', 'consum', 0.0212, 'lps'),
	(554029, 127, '2014-03-01 00:28:16.000000', 'consum', 0.0212, 'lps'),
	(554030, 127, '2014-03-01 00:28:17.000000', 'consum', 0.0212, 'lps'),
	(554031, 127, '2014-03-01 00:28:18.000000', 'consum', 0.0214, 'lps'),
	(554032, 127, '2014-03-01 00:28:19.000000', 'consum', 0.0226, 'lps'),
	(554033, 127, '2014-03-01 00:28:20.000000', 'consum', 0.0220, 'lps'),
	(554034, 127, '2014-03-01 00:28:21.000000', 'consum', 0.0214, 'lps'),
	(554035, 127, '2014-03-01 00:28:22.000000', 'consum', 0.0227, 'lps'),
	(554036, 127, '2014-03-01 00:28:23.000000', 'consum', 0.0228, 'lps'),
	(554037, 127, '2014-03-01 00:28:24.000000', 'consum', 0.0222, 'lps'),
	(554038, 127, '2014-03-01 00:28:25.000000', 'consum', 0.0213, 'lps'),
	(554039, 127, '2014-03-01 00:28:26.000000', 'consum', 0.0219, 'lps'),
	(554040, 127, '2014-03-01 00:28:27.000000', 'consum', 0.0219, 'lps'),
	(554041, 127, '2014-03-01 00:28:28.000000', 'consum', 0.0228, 'lps'),
	(554042, 127, '2014-03-01 00:28:29.000000', 'consum', 0.0216, 'lps'),
	(554043, 127, '2014-03-01 00:28:30.000000', 'consum', 0.0215, 'lps'),
	(554044, 127, '2014-03-01 00:28:31.000000', 'consum', 0.0218, 'lps'),
	(554045, 127, '2014-03-01 00:28:32.000000', 'consum', 0.0236, 'lps'),
	(554046, 127, '2014-03-01 00:28:33.000000', 'consum', 0.0230, 'lps'),
	(554047, 127, '2014-03-01 00:28:34.000000', 'consum', 0.0231, 'lps'),
	(554048, 127, '2014-03-01 00:28:35.000000', 'consum', 0.0227, 'lps'),
	(554049, 127, '2014-03-01 00:28:36.000000', 'consum', 0.0233, 'lps'),
	(554050, 127, '2014-03-01 00:28:37.000000', 'consum', 0.0217, 'lps'),
	(554051, 127, '2014-03-01 00:28:38.000000', 'consum', 0.0235, 'lps'),
	(554052, 127, '2014-03-01 00:28:39.000000', 'consum', 0.0228, 'lps'),
	(554053, 127, '2014-03-01 00:28:40.000000', 'consum', 0.0224, 'lps'),
	(554054, 127, '2014-03-01 00:28:41.000000', 'consum', 0.0227, 'lps'),
	(554055, 127, '2014-03-01 00:28:42.000000', 'consum', 0.0225, 'lps'),
	(554056, 127, '2014-03-01 00:28:43.000000', 'consum', 0.0236, 'lps'),
	(554057, 127, '2014-03-01 00:28:44.000000', 'consum', 0.0236, 'lps'),
	(554058, 127, '2014-03-01 00:28:45.000000', 'consum', 0.0234, 'lps'),
	(554059, 127, '2014-03-01 00:28:46.000000', 'consum', 0.0223, 'lps'),
	(554060, 127, '2014-03-01 00:28:47.000000', 'consum', 0.0234, 'lps'),
	(554061, 127, '2014-03-01 00:28:48.000000', 'consum', 0.0234, 'lps'),
	(554062, 127, '2014-03-01 00:28:49.000000', 'consum', 0.0226, 'lps'),
	(554063, 127, '2014-03-01 00:28:50.000000', 'consum', 0.0222, 'lps'),
	(554064, 127, '2014-03-01 00:28:51.000000', 'consum', 0.0221, 'lps'),
	(554065, 127, '2014-03-01 00:28:52.000000', 'consum', 0.0231, 'lps'),
	(554066, 127, '2014-03-01 00:28:53.000000', 'consum', 0.0226, 'lps'),
	(554067, 127, '2014-03-01 00:28:54.000000', 'consum', 0.0224, 'lps'),
	(554068, 127, '2014-03-01 00:28:55.000000', 'consum', 0.0236, 'lps'),
	(554069, 127, '2014-03-01 00:28:56.000000', 'consum', 0.0238, 'lps'),
	(554070, 127, '2014-03-01 00:28:57.000000', 'consum', 0.0215, 'lps'),
	(554071, 127, '2014-03-01 00:28:58.000000', 'consum', 0.0211, 'lps'),
	(554072, 127, '2014-03-01 00:28:59.000000', 'consum', 0.0229, 'lps'),
	(554073, 127, '2014-03-01 00:29:00.000000', 'consum', 0.0216, 'lps'),
	(554074, 127, '2014-03-01 00:29:01.000000', 'consum', 0.0212, 'lps'),
	(554075, 127, '2014-03-01 00:29:02.000000', 'consum', 0.0233, 'lps'),
	(554076, 127, '2014-03-01 00:29:03.000000', 'consum', 0.0230, 'lps'),
	(554077, 127, '2014-03-01 00:29:04.000000', 'consum', 0.0213, 'lps'),
	(554078, 127, '2014-03-01 00:29:05.000000', 'consum', 0.0225, 'lps'),
	(554079, 127, '2014-03-01 00:29:06.000000', 'consum', 0.0219, 'lps'),
	(554080, 127, '2014-03-01 00:29:07.000000', 'consum', 0.0211, 'lps'),
	(554081, 127, '2014-03-01 00:29:08.000000', 'consum', 0.0215, 'lps'),
	(554082, 127, '2014-03-01 00:29:09.000000', 'consum', 0.0232, 'lps'),
	(554083, 127, '2014-03-01 00:29:10.000000', 'consum', 0.0218, 'lps'),
	(554084, 127, '2014-03-01 00:29:11.000000', 'consum', 0.0214, 'lps'),
	(554085, 127, '2014-03-01 00:29:12.000000', 'consum', 0.0237, 'lps'),
	(554086, 127, '2014-03-01 00:29:13.000000', 'consum', 0.0215, 'lps'),
	(554087, 127, '2014-03-01 00:29:14.000000', 'consum', 0.0213, 'lps'),
	(554088, 127, '2014-03-01 00:29:15.000000', 'consum', 0.0212, 'lps'),
	(554089, 127, '2014-03-01 00:29:16.000000', 'consum', 0.0212, 'lps'),
	(554090, 127, '2014-03-01 00:29:17.000000', 'consum', 0.0212, 'lps'),
	(554091, 127, '2014-03-01 00:29:18.000000', 'consum', 0.0215, 'lps'),
	(554092, 127, '2014-03-01 00:29:19.000000', 'consum', 0.0229, 'lps'),
	(554093, 127, '2014-03-01 00:29:20.000000', 'consum', 0.0235, 'lps'),
	(554094, 127, '2014-03-01 00:29:21.000000', 'consum', 0.0219, 'lps'),
	(554095, 127, '2014-03-01 00:29:22.000000', 'consum', 0.0211, 'lps'),
	(554096, 127, '2014-03-01 00:29:23.000000', 'consum', 0.0217, 'lps'),
	(554097, 127, '2014-03-01 00:29:24.000000', 'consum', 0.0212, 'lps'),
	(554098, 127, '2014-03-01 00:29:25.000000', 'consum', 0.0229, 'lps'),
	(554099, 127, '2014-03-01 00:29:26.000000', 'consum', 0.0212, 'lps'),
	(554100, 127, '2014-03-01 00:29:27.000000', 'consum', 0.0223, 'lps'),
	(554101, 127, '2014-03-01 00:29:28.000000', 'consum', 0.0210, 'lps'),
	(554102, 127, '2014-03-01 00:29:29.000000', 'consum', 0.0229, 'lps'),
	(554103, 127, '2014-03-01 00:29:30.000000', 'consum', 0.0221, 'lps'),
	(554104, 127, '2014-03-01 00:29:31.000000', 'consum', 0.0236, 'lps'),
	(554105, 127, '2014-03-01 00:29:32.000000', 'consum', 0.0220, 'lps'),
	(554106, 127, '2014-03-01 00:29:33.000000', 'consum', 0.0212, 'lps'),
	(554107, 127, '2014-03-01 00:29:34.000000', 'consum', 0.0218, 'lps'),
	(554108, 127, '2014-03-01 00:29:35.000000', 'consum', 0.0214, 'lps'),
	(554109, 127, '2014-03-01 00:29:36.000000', 'consum', 0.0210, 'lps'),
	(554110, 127, '2014-03-01 00:29:37.000000', 'consum', 0.0228, 'lps'),
	(554111, 127, '2014-03-01 00:29:38.000000', 'consum', 0.0212, 'lps'),
	(554112, 127, '2014-03-01 00:29:39.000000', 'consum', 0.0223, 'lps'),
	(554113, 127, '2014-03-01 00:29:40.000000', 'consum', 0.0213, 'lps'),
	(554114, 127, '2014-03-01 00:29:41.000000', 'consum', 0.0217, 'lps'),
	(554115, 127, '2014-03-01 00:29:42.000000', 'consum', 0.0236, 'lps'),
	(554116, 127, '2014-03-01 00:29:43.000000', 'consum', 0.0230, 'lps'),
	(554117, 127, '2014-03-01 00:29:44.000000', 'consum', 0.0234, 'lps'),
	(554118, 127, '2014-03-01 00:29:45.000000', 'consum', 0.0213, 'lps'),
	(554119, 127, '2014-03-01 00:29:46.000000', 'consum', 0.0211, 'lps'),
	(554120, 127, '2014-03-01 00:29:47.000000', 'consum', 0.0236, 'lps'),
	(554121, 127, '2014-03-01 00:29:48.000000', 'consum', 0.0220, 'lps'),
	(554122, 127, '2014-03-01 00:29:49.000000', 'consum', 0.0213, 'lps'),
	(554123, 127, '2014-03-01 00:29:50.000000', 'consum', 0.0223, 'lps'),
	(554124, 127, '2014-03-01 00:29:51.000000', 'consum', 0.0237, 'lps'),
	(554125, 127, '2014-03-01 00:29:52.000000', 'consum', 0.0220, 'lps'),
	(554126, 127, '2014-03-01 00:29:53.000000', 'consum', 0.0237, 'lps'),
	(554127, 127, '2014-03-01 00:29:54.000000', 'consum', 0.0230, 'lps'),
	(554128, 127, '2014-03-01 00:29:55.000000', 'consum', 0.0230, 'lps'),
	(554129, 127, '2014-03-01 00:29:56.000000', 'consum', 0.0219, 'lps'),
	(554130, 127, '2014-03-01 00:29:57.000000', 'consum', 0.0224, 'lps'),
	(554131, 127, '2014-03-01 00:29:58.000000', 'consum', 0.0226, 'lps'),
	(554132, 127, '2014-03-01 00:29:59.000000', 'consum', 0.0219, 'lps'),
	(554133, 127, '2014-03-01 00:30:00.000000', 'consum', 0.0236, 'lps'),
	(554134, 127, '2014-03-01 00:30:01.000000', 'consum', 0.0228, 'lps'),
	(554135, 127, '2014-03-01 00:30:02.000000', 'consum', 0.0222, 'lps'),
	(554136, 127, '2014-03-01 00:30:03.000000', 'consum', 0.0217, 'lps'),
	(554137, 127, '2014-03-01 00:30:04.000000', 'consum', 0.0238, 'lps'),
	(554138, 127, '2014-03-01 00:30:05.000000', 'consum', 0.0211, 'lps'),
	(554139, 127, '2014-03-01 00:30:06.000000', 'consum', 0.0222, 'lps'),
	(554140, 127, '2014-03-01 00:30:07.000000', 'consum', 0.0238, 'lps'),
	(554141, 127, '2014-03-01 00:30:08.000000', 'consum', 0.0225, 'lps'),
	(554142, 127, '2014-03-01 00:30:09.000000', 'consum', 0.0232, 'lps'),
	(554143, 127, '2014-03-01 00:30:10.000000', 'consum', 0.0215, 'lps'),
	(554144, 127, '2014-03-01 00:30:11.000000', 'consum', 0.0231, 'lps'),
	(554145, 127, '2014-03-01 00:30:12.000000', 'consum', 0.0213, 'lps'),
	(554146, 127, '2014-03-01 00:30:13.000000', 'consum', 0.0219, 'lps'),
	(554147, 127, '2014-03-01 00:30:14.000000', 'consum', 0.0219, 'lps'),
	(554148, 127, '2014-03-01 00:30:15.000000', 'consum', 0.0226, 'lps'),
	(554149, 127, '2014-03-01 00:30:16.000000', 'consum', 0.0236, 'lps'),
	(554150, 127, '2014-03-01 00:30:17.000000', 'consum', 0.0233, 'lps'),
	(554151, 127, '2014-03-01 00:30:18.000000', 'consum', 0.0218, 'lps'),
	(554152, 127, '2014-03-01 00:30:19.000000', 'consum', 0.0213, 'lps'),
	(554153, 127, '2014-03-01 00:30:20.000000', 'consum', 0.0230, 'lps'),
	(554154, 127, '2014-03-01 00:30:21.000000', 'consum', 0.0212, 'lps'),
	(554155, 127, '2014-03-01 00:30:22.000000', 'consum', 0.0221, 'lps'),
	(554156, 127, '2014-03-01 00:30:23.000000', 'consum', 0.0231, 'lps'),
	(554157, 127, '2014-03-01 00:30:24.000000', 'consum', 0.0223, 'lps'),
	(554158, 127, '2014-03-01 00:30:25.000000', 'consum', 0.0214, 'lps'),
	(554159, 127, '2014-03-01 00:30:26.000000', 'consum', 0.0218, 'lps'),
	(554160, 127, '2014-03-01 00:30:27.000000', 'consum', 0.0210, 'lps'),
	(554161, 127, '2014-03-01 00:30:28.000000', 'consum', 0.0215, 'lps'),
	(554162, 127, '2014-03-01 00:30:29.000000', 'consum', 0.0238, 'lps'),
	(554163, 127, '2014-03-01 00:30:30.000000', 'consum', 0.0219, 'lps'),
	(554164, 127, '2014-03-01 00:30:31.000000', 'consum', 0.0229, 'lps'),
	(554165, 127, '2014-03-01 00:30:32.000000', 'consum', 0.0219, 'lps'),
	(554166, 127, '2014-03-01 00:30:33.000000', 'consum', 0.0227, 'lps'),
	(554167, 127, '2014-03-01 00:30:34.000000', 'consum', 0.0211, 'lps'),
	(554168, 127, '2014-03-01 00:30:35.000000', 'consum', 0.0223, 'lps'),
	(554169, 127, '2014-03-01 00:30:36.000000', 'consum', 0.0214, 'lps'),
	(554170, 127, '2014-03-01 00:30:37.000000', 'consum', 0.0221, 'lps'),
	(554171, 127, '2014-03-01 00:30:38.000000', 'consum', 0.0223, 'lps'),
	(554172, 127, '2014-03-01 00:30:39.000000', 'consum', 0.0216, 'lps'),
	(554173, 127, '2014-03-01 00:30:40.000000', 'consum', 0.0227, 'lps'),
	(554174, 127, '2014-03-01 00:30:41.000000', 'consum', 0.0223, 'lps'),
	(554175, 127, '2014-03-01 00:30:42.000000', 'consum', 0.0222, 'lps'),
	(554176, 127, '2014-03-01 00:30:43.000000', 'consum', 0.0233, 'lps'),
	(554177, 127, '2014-03-01 00:30:44.000000', 'consum', 0.0232, 'lps'),
	(554178, 127, '2014-03-01 00:30:45.000000', 'consum', 0.0223, 'lps'),
	(554179, 127, '2014-03-01 00:30:46.000000', 'consum', 0.0237, 'lps'),
	(554180, 127, '2014-03-01 00:30:47.000000', 'consum', 0.0220, 'lps'),
	(554181, 127, '2014-03-01 00:30:48.000000', 'consum', 0.0237, 'lps'),
	(554182, 127, '2014-03-01 00:30:49.000000', 'consum', 0.0227, 'lps'),
	(554183, 127, '2014-03-01 00:30:50.000000', 'consum', 0.0215, 'lps'),
	(554184, 127, '2014-03-01 00:30:51.000000', 'consum', 0.0213, 'lps'),
	(554185, 127, '2014-03-01 00:30:52.000000', 'consum', 0.0238, 'lps'),
	(554186, 127, '2014-03-01 00:30:53.000000', 'consum', 0.0229, 'lps'),
	(554187, 127, '2014-03-01 00:30:54.000000', 'consum', 0.0220, 'lps'),
	(554188, 127, '2014-03-01 00:30:55.000000', 'consum', 0.0231, 'lps'),
	(554189, 127, '2014-03-01 00:30:56.000000', 'consum', 0.0229, 'lps'),
	(554190, 127, '2014-03-01 00:30:57.000000', 'consum', 0.0211, 'lps'),
	(554191, 127, '2014-03-01 00:30:58.000000', 'consum', 0.0220, 'lps'),
	(554192, 127, '2014-03-01 00:30:59.000000', 'consum', 0.0228, 'lps'),
	(554193, 127, '2014-03-01 00:31:00.000000', 'consum', 0.0211, 'lps'),
	(554194, 127, '2014-03-01 00:31:01.000000', 'consum', 0.0221, 'lps'),
	(554195, 127, '2014-03-01 00:31:02.000000', 'consum', 0.0233, 'lps'),
	(554196, 127, '2014-03-01 00:31:03.000000', 'consum', 0.0235, 'lps'),
	(554197, 127, '2014-03-01 00:31:04.000000', 'consum', 0.0237, 'lps'),
	(554198, 127, '2014-03-01 00:31:05.000000', 'consum', 0.0213, 'lps'),
	(554199, 127, '2014-03-01 00:31:06.000000', 'consum', 0.0231, 'lps'),
	(554200, 127, '2014-03-01 00:31:07.000000', 'consum', 0.0219, 'lps'),
	(554201, 127, '2014-03-01 00:31:08.000000', 'consum', 0.0221, 'lps'),
	(554202, 127, '2014-03-01 00:31:09.000000', 'consum', 0.0210, 'lps'),
	(554203, 127, '2014-03-01 00:31:10.000000', 'consum', 0.0235, 'lps'),
	(554204, 127, '2014-03-01 00:31:11.000000', 'consum', 0.0219, 'lps'),
	(554205, 127, '2014-03-01 00:31:12.000000', 'consum', 0.0238, 'lps'),
	(554206, 127, '2014-03-01 00:31:13.000000', 'consum', 0.0210, 'lps'),
	(554207, 127, '2014-03-01 00:31:14.000000', 'consum', 0.0213, 'lps'),
	(554208, 127, '2014-03-01 00:31:15.000000', 'consum', 0.0227, 'lps'),
	(554209, 127, '2014-03-01 00:31:16.000000', 'consum', 0.0225, 'lps'),
	(554210, 127, '2014-03-01 00:31:17.000000', 'consum', 0.0237, 'lps'),
	(554211, 127, '2014-03-01 00:31:18.000000', 'consum', 0.0212, 'lps'),
	(554212, 127, '2014-03-01 00:31:19.000000', 'consum', 0.0227, 'lps'),
	(554213, 127, '2014-03-01 00:31:20.000000', 'consum', 0.0231, 'lps'),
	(554214, 127, '2014-03-01 00:31:21.000000', 'consum', 0.0234, 'lps'),
	(554215, 127, '2014-03-01 00:31:22.000000', 'consum', 0.0210, 'lps'),
	(554216, 127, '2014-03-01 00:31:23.000000', 'consum', 0.0225, 'lps'),
	(554217, 127, '2014-03-01 00:31:24.000000', 'consum', 0.0229, 'lps'),
	(554218, 127, '2014-03-01 00:31:25.000000', 'consum', 0.0232, 'lps'),
	(554219, 127, '2014-03-01 00:31:26.000000', 'consum', 0.0235, 'lps'),
	(554220, 127, '2014-03-01 00:31:27.000000', 'consum', 0.0212, 'lps'),
	(554221, 127, '2014-03-01 00:31:28.000000', 'consum', 0.0233, 'lps'),
	(554222, 127, '2014-03-01 00:31:29.000000', 'consum', 0.0233, 'lps'),
	(554223, 127, '2014-03-01 00:31:30.000000', 'consum', 0.0227, 'lps'),
	(554224, 127, '2014-03-01 00:31:31.000000', 'consum', 0.0226, 'lps'),
	(554225, 127, '2014-03-01 00:31:32.000000', 'consum', 0.0212, 'lps'),
	(554226, 127, '2014-03-01 00:31:33.000000', 'consum', 0.0230, 'lps'),
	(554227, 127, '2014-03-01 00:31:34.000000', 'consum', 0.0219, 'lps'),
	(554228, 127, '2014-03-01 00:31:35.000000', 'consum', 0.0221, 'lps'),
	(554229, 127, '2014-03-01 00:31:36.000000', 'consum', 0.0212, 'lps'),
	(554230, 127, '2014-03-01 00:31:37.000000', 'consum', 0.0217, 'lps'),
	(554231, 127, '2014-03-01 00:31:38.000000', 'consum', 0.0211, 'lps'),
	(554232, 127, '2014-03-01 00:31:39.000000', 'consum', 0.0220, 'lps'),
	(554233, 127, '2014-03-01 00:31:40.000000', 'consum', 0.0232, 'lps'),
	(554234, 127, '2014-03-01 00:31:41.000000', 'consum', 0.0233, 'lps'),
	(554235, 127, '2014-03-01 00:31:42.000000', 'consum', 0.0228, 'lps'),
	(554236, 127, '2014-03-01 00:31:43.000000', 'consum', 0.0232, 'lps'),
	(554237, 127, '2014-03-01 00:31:44.000000', 'consum', 0.0237, 'lps'),
	(554238, 127, '2014-03-01 00:31:45.000000', 'consum', 0.0223, 'lps'),
	(554239, 127, '2014-03-01 00:31:46.000000', 'consum', 0.0224, 'lps'),
	(554240, 127, '2014-03-01 00:31:47.000000', 'consum', 0.0211, 'lps'),
	(554241, 127, '2014-03-01 00:31:48.000000', 'consum', 0.0232, 'lps'),
	(554242, 127, '2014-03-01 00:31:49.000000', 'consum', 0.0230, 'lps'),
	(554243, 127, '2014-03-01 00:31:50.000000', 'consum', 0.0216, 'lps'),
	(554244, 127, '2014-03-01 00:31:51.000000', 'consum', 0.0238, 'lps'),
	(554245, 127, '2014-03-01 00:31:52.000000', 'consum', 0.0215, 'lps'),
	(554246, 127, '2014-03-01 00:31:53.000000', 'consum', 0.0211, 'lps'),
	(554247, 127, '2014-03-01 00:31:54.000000', 'consum', 0.0228, 'lps'),
	(554248, 127, '2014-03-01 00:31:55.000000', 'consum', 0.0211, 'lps'),
	(554249, 127, '2014-03-01 00:31:56.000000', 'consum', 0.0218, 'lps'),
	(554250, 127, '2014-03-01 00:31:57.000000', 'consum', 0.0218, 'lps'),
	(554251, 127, '2014-03-01 00:31:58.000000', 'consum', 0.0230, 'lps'),
	(554252, 127, '2014-03-01 00:31:59.000000', 'consum', 0.0225, 'lps'),
	(554253, 127, '2014-03-01 00:32:00.000000', 'consum', 0.0226, 'lps'),
	(554254, 127, '2014-03-01 00:32:01.000000', 'consum', 0.0219, 'lps'),
	(554255, 127, '2014-03-01 00:32:02.000000', 'consum', 0.0234, 'lps'),
	(554256, 127, '2014-03-01 00:32:03.000000', 'consum', 0.0216, 'lps'),
	(554257, 127, '2014-03-01 00:32:04.000000', 'consum', 0.0227, 'lps'),
	(554258, 127, '2014-03-01 00:32:05.000000', 'consum', 0.0220, 'lps'),
	(554259, 127, '2014-03-01 00:32:06.000000', 'consum', 0.0237, 'lps'),
	(554260, 127, '2014-03-01 00:32:07.000000', 'consum', 0.0230, 'lps'),
	(554261, 127, '2014-03-01 00:32:08.000000', 'consum', 0.0230, 'lps'),
	(554262, 127, '2014-03-01 00:32:09.000000', 'consum', 0.0222, 'lps'),
	(554263, 127, '2014-03-01 00:32:10.000000', 'consum', 0.0238, 'lps'),
	(554264, 127, '2014-03-01 00:32:11.000000', 'consum', 0.0229, 'lps'),
	(554265, 127, '2014-03-01 00:32:12.000000', 'consum', 0.0223, 'lps'),
	(554266, 127, '2014-03-01 00:32:13.000000', 'consum', 0.0216, 'lps'),
	(554267, 127, '2014-03-01 00:32:14.000000', 'consum', 0.0233, 'lps'),
	(554268, 127, '2014-03-01 00:32:15.000000', 'consum', 0.0220, 'lps'),
	(554269, 127, '2014-03-01 00:32:16.000000', 'consum', 0.0219, 'lps'),
	(554270, 127, '2014-03-01 00:32:17.000000', 'consum', 0.0227, 'lps'),
	(554271, 127, '2014-03-01 00:32:18.000000', 'consum', 0.0210, 'lps'),
	(554272, 127, '2014-03-01 00:32:19.000000', 'consum', 0.0216, 'lps'),
	(554273, 127, '2014-03-01 00:32:20.000000', 'consum', 0.0214, 'lps'),
	(554274, 127, '2014-03-01 00:32:21.000000', 'consum', 0.0212, 'lps'),
	(554275, 127, '2014-03-01 00:32:22.000000', 'consum', 0.0235, 'lps'),
	(554276, 127, '2014-03-01 00:32:23.000000', 'consum', 0.0215, 'lps'),
	(554277, 127, '2014-03-01 00:32:24.000000', 'consum', 0.0219, 'lps'),
	(554278, 127, '2014-03-01 00:32:25.000000', 'consum', 0.0212, 'lps'),
	(554279, 127, '2014-03-01 00:32:26.000000', 'consum', 0.0222, 'lps'),
	(554280, 127, '2014-03-01 00:32:27.000000', 'consum', 0.0234, 'lps'),
	(554281, 127, '2014-03-01 00:32:28.000000', 'consum', 0.0210, 'lps'),
	(554282, 127, '2014-03-01 00:32:29.000000', 'consum', 0.0225, 'lps'),
	(554283, 127, '2014-03-01 00:32:30.000000', 'consum', 0.0226, 'lps'),
	(554284, 127, '2014-03-01 00:32:31.000000', 'consum', 0.0219, 'lps'),
	(554285, 127, '2014-03-01 00:32:32.000000', 'consum', 0.0235, 'lps'),
	(554286, 127, '2014-03-01 00:32:33.000000', 'consum', 0.0220, 'lps'),
	(554287, 127, '2014-03-01 00:32:34.000000', 'consum', 0.0214, 'lps'),
	(554288, 127, '2014-03-01 00:32:35.000000', 'consum', 0.0230, 'lps'),
	(554289, 127, '2014-03-01 00:32:36.000000', 'consum', 0.0213, 'lps'),
	(554290, 127, '2014-03-01 00:32:37.000000', 'consum', 0.0223, 'lps'),
	(554291, 127, '2014-03-01 00:32:38.000000', 'consum', 0.0210, 'lps'),
	(554292, 127, '2014-03-01 00:32:39.000000', 'consum', 0.0227, 'lps'),
	(554293, 127, '2014-03-01 00:32:40.000000', 'consum', 0.0211, 'lps'),
	(554294, 127, '2014-03-01 00:32:41.000000', 'consum', 0.0223, 'lps'),
	(554295, 127, '2014-03-01 00:32:42.000000', 'consum', 0.0214, 'lps'),
	(554296, 127, '2014-03-01 00:32:43.000000', 'consum', 0.0221, 'lps'),
	(554297, 127, '2014-03-01 00:32:44.000000', 'consum', 0.0222, 'lps'),
	(554298, 127, '2014-03-01 00:32:45.000000', 'consum', 0.0210, 'lps'),
	(554299, 127, '2014-03-01 00:32:46.000000', 'consum', 0.0233, 'lps'),
	(554300, 127, '2014-03-01 00:32:47.000000', 'consum', 0.0237, 'lps'),
	(554301, 127, '2014-03-01 00:32:48.000000', 'consum', 0.0219, 'lps'),
	(554302, 127, '2014-03-01 00:32:49.000000', 'consum', 0.0235, 'lps'),
	(554303, 127, '2014-03-01 00:32:50.000000', 'consum', 0.0219, 'lps'),
	(554304, 127, '2014-03-01 00:32:51.000000', 'consum', 0.0238, 'lps'),
	(554305, 127, '2014-03-01 00:32:52.000000', 'consum', 0.0236, 'lps'),
	(554306, 127, '2014-03-01 00:32:53.000000', 'consum', 0.0229, 'lps'),
	(554307, 127, '2014-03-01 00:32:54.000000', 'consum', 0.0225, 'lps'),
	(554308, 127, '2014-03-01 00:32:55.000000', 'consum', 0.0231, 'lps'),
	(554309, 127, '2014-03-01 00:32:56.000000', 'consum', 0.0212, 'lps'),
	(554310, 127, '2014-03-01 00:32:57.000000', 'consum', 0.0217, 'lps'),
	(554311, 127, '2014-03-01 00:32:58.000000', 'consum', 0.0238, 'lps'),
	(554312, 127, '2014-03-01 00:32:59.000000', 'consum', 0.0215, 'lps'),
	(554313, 127, '2014-03-01 00:33:00.000000', 'consum', 0.0237, 'lps'),
	(554314, 127, '2014-03-01 00:33:01.000000', 'consum', 0.0216, 'lps'),
	(554315, 127, '2014-03-01 00:33:02.000000', 'consum', 0.0219, 'lps'),
	(554316, 127, '2014-03-01 00:33:03.000000', 'consum', 0.0235, 'lps'),
	(554317, 127, '2014-03-01 00:33:04.000000', 'consum', 0.0220, 'lps'),
	(554318, 127, '2014-03-01 00:33:05.000000', 'consum', 0.0217, 'lps'),
	(554319, 127, '2014-03-01 00:33:06.000000', 'consum', 0.0217, 'lps'),
	(554320, 127, '2014-03-01 00:33:07.000000', 'consum', 0.0221, 'lps'),
	(554321, 127, '2014-03-01 00:33:08.000000', 'consum', 0.0217, 'lps'),
	(554322, 127, '2014-03-01 00:33:09.000000', 'consum', 0.0212, 'lps'),
	(554323, 127, '2014-03-01 00:33:10.000000', 'consum', 0.0229, 'lps'),
	(554324, 127, '2014-03-01 00:33:11.000000', 'consum', 0.0210, 'lps'),
	(554325, 127, '2014-03-01 00:33:12.000000', 'consum', 0.0215, 'lps'),
	(554326, 127, '2014-03-01 00:33:13.000000', 'consum', 0.0235, 'lps'),
	(554327, 127, '2014-03-01 00:33:14.000000', 'consum', 0.0232, 'lps'),
	(554328, 127, '2014-03-01 00:33:15.000000', 'consum', 0.0219, 'lps'),
	(554329, 127, '2014-03-01 00:33:16.000000', 'consum', 0.0217, 'lps'),
	(554330, 127, '2014-03-01 00:33:17.000000', 'consum', 0.0218, 'lps'),
	(554331, 127, '2014-03-01 00:33:18.000000', 'consum', 0.0229, 'lps'),
	(554332, 127, '2014-03-01 00:33:19.000000', 'consum', 0.0224, 'lps'),
	(554333, 127, '2014-03-01 00:33:20.000000', 'consum', 0.0223, 'lps'),
	(554334, 127, '2014-03-01 00:33:21.000000', 'consum', 0.0236, 'lps'),
	(554335, 127, '2014-03-01 00:33:22.000000', 'consum', 0.0212, 'lps'),
	(554336, 127, '2014-03-01 00:33:23.000000', 'consum', 0.0232, 'lps'),
	(554337, 127, '2014-03-01 00:33:24.000000', 'consum', 0.0227, 'lps'),
	(554338, 127, '2014-03-01 00:33:25.000000', 'consum', 0.0231, 'lps'),
	(554339, 127, '2014-03-01 00:33:26.000000', 'consum', 0.0235, 'lps'),
	(554340, 127, '2014-03-01 00:33:27.000000', 'consum', 0.0212, 'lps'),
	(554341, 127, '2014-03-01 00:33:28.000000', 'consum', 0.0235, 'lps'),
	(554342, 127, '2014-03-01 00:33:29.000000', 'consum', 0.0215, 'lps'),
	(554343, 127, '2014-03-01 00:33:30.000000', 'consum', 0.0216, 'lps'),
	(554344, 127, '2014-03-01 00:33:31.000000', 'consum', 0.0224, 'lps'),
	(554345, 127, '2014-03-01 00:33:32.000000', 'consum', 0.0235, 'lps'),
	(554346, 127, '2014-03-01 00:33:33.000000', 'consum', 0.0235, 'lps'),
	(554347, 127, '2014-03-01 00:33:34.000000', 'consum', 0.0232, 'lps'),
	(554348, 127, '2014-03-01 00:33:35.000000', 'consum', 0.0216, 'lps'),
	(554349, 127, '2014-03-01 00:33:36.000000', 'consum', 0.0234, 'lps'),
	(554350, 127, '2014-03-01 00:33:37.000000', 'consum', 0.0224, 'lps'),
	(554351, 127, '2014-03-01 00:33:38.000000', 'consum', 0.0236, 'lps'),
	(554352, 127, '2014-03-01 00:33:39.000000', 'consum', 0.0213, 'lps'),
	(554353, 127, '2014-03-01 00:33:40.000000', 'consum', 0.0233, 'lps'),
	(554354, 127, '2014-03-01 00:33:41.000000', 'consum', 0.0230, 'lps'),
	(554355, 127, '2014-03-01 00:33:42.000000', 'consum', 0.0212, 'lps'),
	(554356, 127, '2014-03-01 00:33:43.000000', 'consum', 0.0218, 'lps'),
	(554357, 127, '2014-03-01 00:33:44.000000', 'consum', 0.0215, 'lps'),
	(554358, 127, '2014-03-01 00:33:45.000000', 'consum', 0.0212, 'lps'),
	(554359, 127, '2014-03-01 00:33:46.000000', 'consum', 0.0237, 'lps'),
	(554360, 127, '2014-03-01 00:33:47.000000', 'consum', 0.0220, 'lps'),
	(554361, 127, '2014-03-01 00:33:48.000000', 'consum', 0.0211, 'lps'),
	(554362, 127, '2014-03-01 00:33:49.000000', 'consum', 0.0214, 'lps'),
	(554363, 127, '2014-03-01 00:33:50.000000', 'consum', 0.0226, 'lps'),
	(554364, 127, '2014-03-01 00:33:51.000000', 'consum', 0.0222, 'lps'),
	(554365, 127, '2014-03-01 00:33:52.000000', 'consum', 0.0220, 'lps'),
	(554366, 127, '2014-03-01 00:33:53.000000', 'consum', 0.0228, 'lps'),
	(554367, 127, '2014-03-01 00:33:54.000000', 'consum', 0.0210, 'lps'),
	(554368, 127, '2014-03-01 00:33:55.000000', 'consum', 0.0214, 'lps'),
	(554369, 127, '2014-03-01 00:33:56.000000', 'consum', 0.0230, 'lps'),
	(554370, 127, '2014-03-01 00:33:57.000000', 'consum', 0.0213, 'lps'),
	(554371, 127, '2014-03-01 00:33:58.000000', 'consum', 0.0223, 'lps'),
	(554372, 127, '2014-03-01 00:33:59.000000', 'consum', 0.0237, 'lps'),
	(554373, 127, '2014-03-01 00:34:00.000000', 'consum', 0.0219, 'lps'),
	(554374, 127, '2014-03-01 00:34:01.000000', 'consum', 0.0232, 'lps'),
	(554375, 127, '2014-03-01 00:34:02.000000', 'consum', 0.0235, 'lps'),
	(554376, 127, '2014-03-01 00:34:03.000000', 'consum', 0.0214, 'lps'),
	(554377, 127, '2014-03-01 00:34:04.000000', 'consum', 0.0214, 'lps'),
	(554378, 127, '2014-03-01 00:34:05.000000', 'consum', 0.0219, 'lps'),
	(554379, 127, '2014-03-01 00:34:06.000000', 'consum', 0.0214, 'lps'),
	(554380, 127, '2014-03-01 00:34:07.000000', 'consum', 0.0233, 'lps'),
	(554381, 127, '2014-03-01 00:34:08.000000', 'consum', 0.0227, 'lps'),
	(554382, 127, '2014-03-01 00:34:09.000000', 'consum', 0.0224, 'lps'),
	(554383, 127, '2014-03-01 00:34:10.000000', 'consum', 0.0230, 'lps'),
	(554384, 127, '2014-03-01 00:34:11.000000', 'consum', 0.0213, 'lps'),
	(554385, 127, '2014-03-01 00:34:12.000000', 'consum', 0.0223, 'lps'),
	(554386, 127, '2014-03-01 00:34:13.000000', 'consum', 0.0235, 'lps'),
	(554387, 127, '2014-03-01 00:34:14.000000', 'consum', 0.0211, 'lps'),
	(554388, 127, '2014-03-01 00:34:15.000000', 'consum', 0.0228, 'lps'),
	(554389, 127, '2014-03-01 00:34:16.000000', 'consum', 0.0237, 'lps'),
	(554390, 127, '2014-03-01 00:34:17.000000', 'consum', 0.0235, 'lps'),
	(554391, 127, '2014-03-01 00:34:18.000000', 'consum', 0.0225, 'lps'),
	(554392, 127, '2014-03-01 00:34:19.000000', 'consum', 0.0210, 'lps'),
	(554393, 127, '2014-03-01 00:34:20.000000', 'consum', 0.0225, 'lps'),
	(554394, 127, '2014-03-01 00:34:21.000000', 'consum', 0.0225, 'lps'),
	(554395, 127, '2014-03-01 00:34:22.000000', 'consum', 0.0212, 'lps'),
	(554396, 127, '2014-03-01 00:34:23.000000', 'consum', 0.0234, 'lps'),
	(554397, 127, '2014-03-01 00:34:24.000000', 'consum', 0.0237, 'lps'),
	(554398, 127, '2014-03-01 00:34:25.000000', 'consum', 0.0215, 'lps'),
	(554399, 127, '2014-03-01 00:34:26.000000', 'consum', 0.0211, 'lps'),
	(554400, 127, '2014-03-01 00:34:27.000000', 'consum', 0.0233, 'lps'),
	(554401, 127, '2014-03-01 00:34:28.000000', 'consum', 0.0232, 'lps'),
	(554402, 127, '2014-03-01 00:34:29.000000', 'consum', 0.0225, 'lps'),
	(554403, 127, '2014-03-01 00:34:30.000000', 'consum', 0.0219, 'lps'),
	(554404, 127, '2014-03-01 00:34:31.000000', 'consum', 0.0212, 'lps'),
	(554405, 127, '2014-03-01 00:34:32.000000', 'consum', 0.0220, 'lps'),
	(554406, 127, '2014-03-01 00:34:33.000000', 'consum', 0.0226, 'lps'),
	(554407, 127, '2014-03-01 00:34:34.000000', 'consum', 0.0232, 'lps'),
	(554408, 127, '2014-03-01 00:34:35.000000', 'consum', 0.0215, 'lps'),
	(554409, 127, '2014-03-01 00:34:36.000000', 'consum', 0.0225, 'lps'),
	(554410, 127, '2014-03-01 00:34:37.000000', 'consum', 0.0215, 'lps'),
	(554411, 127, '2014-03-01 00:34:38.000000', 'consum', 0.0218, 'lps'),
	(554412, 127, '2014-03-01 00:34:39.000000', 'consum', 0.0234, 'lps'),
	(554413, 127, '2014-03-01 00:34:40.000000', 'consum', 0.0221, 'lps'),
	(554414, 127, '2014-03-01 00:34:41.000000', 'consum', 0.0223, 'lps'),
	(554415, 127, '2014-03-01 00:34:42.000000', 'consum', 0.0211, 'lps'),
	(554416, 127, '2014-03-01 00:34:43.000000', 'consum', 0.0236, 'lps'),
	(554417, 127, '2014-03-01 00:34:44.000000', 'consum', 0.0223, 'lps'),
	(554418, 127, '2014-03-01 00:34:45.000000', 'consum', 0.0226, 'lps'),
	(554419, 127, '2014-03-01 00:34:46.000000', 'consum', 0.0223, 'lps'),
	(554420, 127, '2014-03-01 00:34:47.000000', 'consum', 0.0225, 'lps'),
	(554421, 127, '2014-03-01 00:34:48.000000', 'consum', 0.0218, 'lps'),
	(554422, 127, '2014-03-01 00:34:49.000000', 'consum', 0.0235, 'lps'),
	(554423, 127, '2014-03-01 00:34:50.000000', 'consum', 0.0224, 'lps'),
	(554424, 127, '2014-03-01 00:34:51.000000', 'consum', 0.0235, 'lps'),
	(554425, 127, '2014-03-01 00:34:52.000000', 'consum', 0.0236, 'lps'),
	(554426, 127, '2014-03-01 00:34:53.000000', 'consum', 0.0238, 'lps'),
	(554427, 127, '2014-03-01 00:34:54.000000', 'consum', 0.0213, 'lps'),
	(554428, 127, '2014-03-01 00:34:55.000000', 'consum', 0.0229, 'lps'),
	(554429, 127, '2014-03-01 00:34:56.000000', 'consum', 0.0211, 'lps'),
	(554430, 127, '2014-03-01 00:34:57.000000', 'consum', 0.0214, 'lps'),
	(554431, 127, '2014-03-01 00:34:58.000000', 'consum', 0.0227, 'lps'),
	(554432, 127, '2014-03-01 00:34:59.000000', 'consum', 0.0226, 'lps'),
	(554433, 127, '2014-03-01 00:35:00.000000', 'consum', 0.0238, 'lps'),
	(554434, 127, '2014-03-01 00:35:01.000000', 'consum', 0.0217, 'lps'),
	(554435, 127, '2014-03-01 00:35:02.000000', 'consum', 0.0219, 'lps'),
	(554436, 127, '2014-03-01 00:35:03.000000', 'consum', 0.0236, 'lps'),
	(554437, 127, '2014-03-01 00:35:04.000000', 'consum', 0.0225, 'lps'),
	(554438, 127, '2014-03-01 00:35:05.000000', 'consum', 0.0236, 'lps'),
	(554439, 127, '2014-03-01 00:35:06.000000', 'consum', 0.0237, 'lps'),
	(554440, 127, '2014-03-01 00:35:07.000000', 'consum', 0.0212, 'lps'),
	(554441, 127, '2014-03-01 00:35:08.000000', 'consum', 0.0225, 'lps'),
	(554442, 127, '2014-03-01 00:35:09.000000', 'consum', 0.0224, 'lps'),
	(554443, 127, '2014-03-01 00:35:10.000000', 'consum', 0.0233, 'lps'),
	(554444, 127, '2014-03-01 00:35:11.000000', 'consum', 0.0227, 'lps'),
	(554445, 127, '2014-03-01 00:35:12.000000', 'consum', 0.0225, 'lps'),
	(554446, 127, '2014-03-01 00:35:13.000000', 'consum', 0.0234, 'lps'),
	(554447, 127, '2014-03-01 00:35:14.000000', 'consum', 0.0228, 'lps'),
	(554448, 127, '2014-03-01 00:35:15.000000', 'consum', 0.0227, 'lps'),
	(554449, 127, '2014-03-01 00:35:16.000000', 'consum', 0.0213, 'lps'),
	(554450, 127, '2014-03-01 00:35:17.000000', 'consum', 0.0232, 'lps'),
	(554451, 127, '2014-03-01 00:35:18.000000', 'consum', 0.0223, 'lps'),
	(554452, 127, '2014-03-01 00:35:19.000000', 'consum', 0.0213, 'lps'),
	(554453, 127, '2014-03-01 00:35:20.000000', 'consum', 0.0214, 'lps'),
	(554454, 127, '2014-03-01 00:35:21.000000', 'consum', 0.0222, 'lps'),
	(554455, 127, '2014-03-01 00:35:22.000000', 'consum', 0.0229, 'lps'),
	(554456, 127, '2014-03-01 00:35:23.000000', 'consum', 0.0210, 'lps'),
	(554457, 127, '2014-03-01 00:35:24.000000', 'consum', 0.0211, 'lps'),
	(554458, 127, '2014-03-01 00:35:25.000000', 'consum', 0.0218, 'lps'),
	(554459, 127, '2014-03-01 00:35:26.000000', 'consum', 0.0218, 'lps'),
	(554460, 127, '2014-03-01 00:35:27.000000', 'consum', 0.0226, 'lps'),
	(554461, 127, '2014-03-01 00:35:28.000000', 'consum', 0.0237, 'lps'),
	(554462, 127, '2014-03-01 00:35:29.000000', 'consum', 0.0211, 'lps'),
	(554463, 127, '2014-03-01 00:35:30.000000', 'consum', 0.0223, 'lps'),
	(554464, 127, '2014-03-01 00:35:31.000000', 'consum', 0.0214, 'lps'),
	(554465, 127, '2014-03-01 00:35:32.000000', 'consum', 0.0218, 'lps'),
	(554466, 127, '2014-03-01 00:35:33.000000', 'consum', 0.0212, 'lps'),
	(554467, 127, '2014-03-01 00:35:34.000000', 'consum', 0.0225, 'lps'),
	(554468, 127, '2014-03-01 00:35:35.000000', 'consum', 0.0221, 'lps'),
	(554469, 127, '2014-03-01 00:35:36.000000', 'consum', 0.0221, 'lps'),
	(554470, 127, '2014-03-01 00:35:37.000000', 'consum', 0.0234, 'lps'),
	(554471, 127, '2014-03-01 00:35:38.000000', 'consum', 0.0237, 'lps'),
	(554472, 127, '2014-03-01 00:35:39.000000', 'consum', 0.0215, 'lps'),
	(554473, 127, '2014-03-01 00:35:40.000000', 'consum', 0.0213, 'lps'),
	(554474, 127, '2014-03-01 00:35:41.000000', 'consum', 0.0211, 'lps'),
	(554475, 127, '2014-03-01 00:35:42.000000', 'consum', 0.0235, 'lps'),
	(554476, 127, '2014-03-01 00:35:43.000000', 'consum', 0.0216, 'lps'),
	(554477, 127, '2014-03-01 00:35:44.000000', 'consum', 0.0224, 'lps'),
	(554478, 127, '2014-03-01 00:35:45.000000', 'consum', 0.0235, 'lps'),
	(554479, 127, '2014-03-01 00:35:46.000000', 'consum', 0.0233, 'lps'),
	(554480, 127, '2014-03-01 00:35:47.000000', 'consum', 0.0221, 'lps'),
	(554481, 127, '2014-03-01 00:35:48.000000', 'consum', 0.0228, 'lps'),
	(554482, 127, '2014-03-01 00:35:49.000000', 'consum', 0.0237, 'lps'),
	(554483, 127, '2014-03-01 00:35:50.000000', 'consum', 0.0233, 'lps'),
	(554484, 127, '2014-03-01 00:35:51.000000', 'consum', 0.0216, 'lps'),
	(554485, 127, '2014-03-01 00:35:52.000000', 'consum', 0.0231, 'lps'),
	(554486, 127, '2014-03-01 00:35:53.000000', 'consum', 0.0211, 'lps'),
	(554487, 127, '2014-03-01 00:35:54.000000', 'consum', 0.0210, 'lps'),
	(554488, 127, '2014-03-01 00:35:55.000000', 'consum', 0.0237, 'lps'),
	(554489, 127, '2014-03-01 00:35:56.000000', 'consum', 0.0228, 'lps'),
	(554490, 127, '2014-03-01 00:35:57.000000', 'consum', 0.0220, 'lps'),
	(554491, 127, '2014-03-01 00:35:58.000000', 'consum', 0.0235, 'lps'),
	(554492, 127, '2014-03-01 00:35:59.000000', 'consum', 0.0219, 'lps'),
	(554493, 127, '2014-03-01 00:36:00.000000', 'consum', 0.0237, 'lps'),
	(554494, 127, '2014-03-01 00:36:01.000000', 'consum', 0.0233, 'lps'),
	(554495, 127, '2014-03-01 00:36:02.000000', 'consum', 0.0216, 'lps'),
	(554496, 127, '2014-03-01 00:36:03.000000', 'consum', 0.0227, 'lps'),
	(554497, 127, '2014-03-01 00:36:04.000000', 'consum', 0.0222, 'lps'),
	(554498, 127, '2014-03-01 00:36:05.000000', 'consum', 0.0217, 'lps'),
	(554499, 127, '2014-03-01 00:36:06.000000', 'consum', 0.0210, 'lps'),
	(554500, 127, '2014-03-01 00:36:07.000000', 'consum', 0.0219, 'lps'),
	(554501, 127, '2014-03-01 00:36:08.000000', 'consum', 0.0228, 'lps'),
	(554502, 127, '2014-03-01 00:36:09.000000', 'consum', 0.0213, 'lps'),
	(554503, 127, '2014-03-01 00:36:10.000000', 'consum', 0.0231, 'lps'),
	(554504, 127, '2014-03-01 00:36:11.000000', 'consum', 0.0219, 'lps'),
	(554505, 127, '2014-03-01 00:36:12.000000', 'consum', 0.0221, 'lps'),
	(554506, 127, '2014-03-01 00:36:13.000000', 'consum', 0.0210, 'lps'),
	(554507, 127, '2014-03-01 00:36:14.000000', 'consum', 0.0234, 'lps'),
	(554508, 127, '2014-03-01 00:36:15.000000', 'consum', 0.0215, 'lps'),
	(554509, 127, '2014-03-01 00:36:16.000000', 'consum', 0.0223, 'lps'),
	(554510, 127, '2014-03-01 00:36:17.000000', 'consum', 0.0232, 'lps'),
	(554511, 127, '2014-03-01 00:36:18.000000', 'consum', 0.0221, 'lps'),
	(554512, 127, '2014-03-01 00:36:19.000000', 'consum', 0.0230, 'lps'),
	(554513, 127, '2014-03-01 00:36:20.000000', 'consum', 0.0221, 'lps'),
	(554514, 127, '2014-03-01 00:36:21.000000', 'consum', 0.0232, 'lps'),
	(554515, 127, '2014-03-01 00:36:22.000000', 'consum', 0.0231, 'lps'),
	(554516, 127, '2014-03-01 00:36:23.000000', 'consum', 0.0222, 'lps'),
	(554517, 127, '2014-03-01 00:36:24.000000', 'consum', 0.0235, 'lps'),
	(554518, 127, '2014-03-01 00:36:25.000000', 'consum', 0.0215, 'lps'),
	(554519, 127, '2014-03-01 00:36:26.000000', 'consum', 0.0216, 'lps'),
	(554520, 127, '2014-03-01 00:36:27.000000', 'consum', 0.0224, 'lps'),
	(554521, 127, '2014-03-01 00:36:28.000000', 'consum', 0.0237, 'lps'),
	(554522, 127, '2014-03-01 00:36:29.000000', 'consum', 0.0214, 'lps'),
	(554523, 127, '2014-03-01 00:36:30.000000', 'consum', 0.0210, 'lps'),
	(554524, 127, '2014-03-01 00:36:31.000000', 'consum', 0.0224, 'lps'),
	(554525, 127, '2014-03-01 00:36:32.000000', 'consum', 0.0225, 'lps'),
	(554526, 127, '2014-03-01 00:36:33.000000', 'consum', 0.0215, 'lps'),
	(554527, 127, '2014-03-01 00:36:34.000000', 'consum', 0.0218, 'lps'),
	(554528, 127, '2014-03-01 00:36:35.000000', 'consum', 0.0236, 'lps'),
	(554529, 127, '2014-03-01 00:36:36.000000', 'consum', 0.0230, 'lps'),
	(554530, 127, '2014-03-01 00:36:37.000000', 'consum', 0.0231, 'lps'),
	(554531, 127, '2014-03-01 00:36:38.000000', 'consum', 0.0229, 'lps'),
	(554532, 127, '2014-03-01 00:36:39.000000', 'consum', 0.0214, 'lps'),
	(554533, 127, '2014-03-01 00:36:40.000000', 'consum', 0.0230, 'lps'),
	(554534, 127, '2014-03-01 00:36:41.000000', 'consum', 0.0210, 'lps'),
	(554535, 127, '2014-03-01 00:36:42.000000', 'consum', 0.0211, 'lps'),
	(554536, 127, '2014-03-01 00:36:43.000000', 'consum', 0.0213, 'lps'),
	(554537, 127, '2014-03-01 00:36:44.000000', 'consum', 0.0224, 'lps'),
	(554538, 127, '2014-03-01 00:36:45.000000', 'consum', 0.0212, 'lps'),
	(554539, 127, '2014-03-01 00:36:46.000000', 'consum', 0.0238, 'lps'),
	(554540, 127, '2014-03-01 00:36:47.000000', 'consum', 0.0227, 'lps'),
	(554541, 127, '2014-03-01 00:36:48.000000', 'consum', 0.0211, 'lps'),
	(554542, 127, '2014-03-01 00:36:49.000000', 'consum', 0.0224, 'lps'),
	(554543, 127, '2014-03-01 00:36:50.000000', 'consum', 0.0219, 'lps'),
	(554544, 127, '2014-03-01 00:36:51.000000', 'consum', 0.0212, 'lps'),
	(554545, 127, '2014-03-01 00:36:52.000000', 'consum', 0.0225, 'lps'),
	(554546, 127, '2014-03-01 00:36:53.000000', 'consum', 0.0220, 'lps'),
	(554547, 127, '2014-03-01 00:36:54.000000', 'consum', 0.0216, 'lps'),
	(554548, 127, '2014-03-01 00:36:55.000000', 'consum', 0.0211, 'lps'),
	(554549, 127, '2014-03-01 00:36:56.000000', 'consum', 0.0228, 'lps'),
	(554550, 127, '2014-03-01 00:36:57.000000', 'consum', 0.0238, 'lps'),
	(554551, 127, '2014-03-01 00:36:58.000000', 'consum', 0.0238, 'lps'),
	(554552, 127, '2014-03-01 00:36:59.000000', 'consum', 0.0237, 'lps'),
	(554553, 127, '2014-03-01 00:37:00.000000', 'consum', 0.0231, 'lps'),
	(554554, 127, '2014-03-01 00:37:01.000000', 'consum', 0.0236, 'lps'),
	(554555, 127, '2014-03-01 00:37:02.000000', 'consum', 0.0220, 'lps'),
	(554556, 127, '2014-03-01 00:37:03.000000', 'consum', 0.0211, 'lps'),
	(554557, 127, '2014-03-01 00:37:04.000000', 'consum', 0.0213, 'lps'),
	(554558, 127, '2014-03-01 00:37:05.000000', 'consum', 0.0225, 'lps'),
	(554559, 127, '2014-03-01 00:37:06.000000', 'consum', 0.0219, 'lps'),
	(554560, 127, '2014-03-01 00:37:07.000000', 'consum', 0.0238, 'lps'),
	(554561, 127, '2014-03-01 00:37:08.000000', 'consum', 0.0236, 'lps'),
	(554562, 127, '2014-03-01 00:37:09.000000', 'consum', 0.0227, 'lps'),
	(554563, 127, '2014-03-01 00:37:10.000000', 'consum', 0.0219, 'lps'),
	(554564, 127, '2014-03-01 00:37:11.000000', 'consum', 0.0233, 'lps'),
	(554565, 127, '2014-03-01 00:37:12.000000', 'consum', 0.0213, 'lps'),
	(554566, 127, '2014-03-01 00:37:13.000000', 'consum', 0.0212, 'lps'),
	(554567, 127, '2014-03-01 00:37:14.000000', 'consum', 0.0211, 'lps'),
	(554568, 127, '2014-03-01 00:37:15.000000', 'consum', 0.0212, 'lps'),
	(554569, 127, '2014-03-01 00:37:16.000000', 'consum', 0.0215, 'lps'),
	(554570, 127, '2014-03-01 00:37:17.000000', 'consum', 0.0229, 'lps'),
	(554571, 127, '2014-03-01 00:37:18.000000', 'consum', 0.0234, 'lps'),
	(554572, 127, '2014-03-01 00:37:19.000000', 'consum', 0.0217, 'lps'),
	(554573, 127, '2014-03-01 00:37:20.000000', 'consum', 0.0228, 'lps'),
	(554574, 127, '2014-03-01 00:37:21.000000', 'consum', 0.0225, 'lps'),
	(554575, 127, '2014-03-01 00:37:22.000000', 'consum', 0.0229, 'lps'),
	(554576, 127, '2014-03-01 00:37:23.000000', 'consum', 0.0234, 'lps'),
	(554577, 127, '2014-03-01 00:37:24.000000', 'consum', 0.0214, 'lps'),
	(554578, 127, '2014-03-01 00:37:25.000000', 'consum', 0.0215, 'lps'),
	(554579, 127, '2014-03-01 00:37:26.000000', 'consum', 0.0225, 'lps'),
	(554580, 127, '2014-03-01 00:37:27.000000', 'consum', 0.0210, 'lps'),
	(554581, 127, '2014-03-01 00:37:28.000000', 'consum', 0.0226, 'lps'),
	(554582, 127, '2014-03-01 00:37:29.000000', 'consum', 0.0233, 'lps'),
	(554583, 127, '2014-03-01 00:37:30.000000', 'consum', 0.0218, 'lps'),
	(554584, 127, '2014-03-01 00:37:31.000000', 'consum', 0.0211, 'lps'),
	(554585, 127, '2014-03-01 00:37:32.000000', 'consum', 0.0219, 'lps'),
	(554586, 127, '2014-03-01 00:37:33.000000', 'consum', 0.0223, 'lps'),
	(554587, 127, '2014-03-01 00:37:34.000000', 'consum', 0.0219, 'lps'),
	(554588, 127, '2014-03-01 00:37:35.000000', 'consum', 0.0216, 'lps'),
	(554589, 127, '2014-03-01 00:37:36.000000', 'consum', 0.0213, 'lps'),
	(554590, 127, '2014-03-01 00:37:37.000000', 'consum', 0.0236, 'lps'),
	(554591, 127, '2014-03-01 00:37:38.000000', 'consum', 0.0218, 'lps'),
	(554592, 127, '2014-03-01 00:37:39.000000', 'consum', 0.0229, 'lps'),
	(554593, 127, '2014-03-01 00:37:40.000000', 'consum', 0.0224, 'lps'),
	(554594, 127, '2014-03-01 00:37:41.000000', 'consum', 0.0222, 'lps'),
	(554595, 127, '2014-03-01 00:37:42.000000', 'consum', 0.0231, 'lps'),
	(554596, 127, '2014-03-01 00:37:43.000000', 'consum', 0.0222, 'lps'),
	(554597, 127, '2014-03-01 00:37:44.000000', 'consum', 0.0237, 'lps'),
	(554598, 127, '2014-03-01 00:37:45.000000', 'consum', 0.0222, 'lps'),
	(554599, 127, '2014-03-01 00:37:46.000000', 'consum', 0.0219, 'lps'),
	(554600, 127, '2014-03-01 00:37:47.000000', 'consum', 0.0219, 'lps'),
	(554601, 127, '2014-03-01 00:37:48.000000', 'consum', 0.0230, 'lps'),
	(554602, 127, '2014-03-01 00:37:49.000000', 'consum', 0.0222, 'lps'),
	(554603, 127, '2014-03-01 00:37:50.000000', 'consum', 0.0214, 'lps'),
	(554604, 127, '2014-03-01 00:37:51.000000', 'consum', 0.0223, 'lps'),
	(554605, 127, '2014-03-01 00:37:52.000000', 'consum', 0.0233, 'lps'),
	(554606, 127, '2014-03-01 00:37:53.000000', 'consum', 0.0230, 'lps'),
	(554607, 127, '2014-03-01 00:37:54.000000', 'consum', 0.0210, 'lps'),
	(554608, 127, '2014-03-01 00:37:55.000000', 'consum', 0.0212, 'lps'),
	(554609, 127, '2014-03-01 00:37:56.000000', 'consum', 0.0218, 'lps'),
	(554610, 127, '2014-03-01 00:37:57.000000', 'consum', 0.0218, 'lps'),
	(554611, 127, '2014-03-01 00:37:58.000000', 'consum', 0.0223, 'lps'),
	(554612, 127, '2014-03-01 00:37:59.000000', 'consum', 0.0225, 'lps'),
	(554613, 127, '2014-03-01 00:38:00.000000', 'consum', 0.0215, 'lps'),
	(554614, 127, '2014-03-01 00:38:01.000000', 'consum', 0.0220, 'lps'),
	(554615, 127, '2014-03-01 00:38:02.000000', 'consum', 0.0216, 'lps'),
	(554616, 127, '2014-03-01 00:38:03.000000', 'consum', 0.0211, 'lps'),
	(554617, 127, '2014-03-01 00:38:04.000000', 'consum', 0.0226, 'lps'),
	(554618, 127, '2014-03-01 00:38:05.000000', 'consum', 0.0229, 'lps'),
	(554619, 127, '2014-03-01 00:38:06.000000', 'consum', 0.0228, 'lps'),
	(554620, 127, '2014-03-01 00:38:07.000000', 'consum', 0.0215, 'lps'),
	(554621, 127, '2014-03-01 00:38:08.000000', 'consum', 0.0211, 'lps'),
	(554622, 127, '2014-03-01 00:38:09.000000', 'consum', 0.0230, 'lps'),
	(554623, 127, '2014-03-01 00:38:10.000000', 'consum', 0.0222, 'lps'),
	(554624, 127, '2014-03-01 00:38:11.000000', 'consum', 0.0237, 'lps'),
	(554625, 127, '2014-03-01 00:38:12.000000', 'consum', 0.0221, 'lps'),
	(554626, 127, '2014-03-01 00:38:13.000000', 'consum', 0.0217, 'lps'),
	(554627, 127, '2014-03-01 00:38:14.000000', 'consum', 0.0212, 'lps'),
	(554628, 127, '2014-03-01 00:38:15.000000', 'consum', 0.0227, 'lps'),
	(554629, 127, '2014-03-01 00:38:16.000000', 'consum', 0.0231, 'lps'),
	(554630, 127, '2014-03-01 00:38:17.000000', 'consum', 0.0237, 'lps'),
	(554631, 127, '2014-03-01 00:38:18.000000', 'consum', 0.0222, 'lps'),
	(554632, 127, '2014-03-01 00:38:19.000000', 'consum', 0.0219, 'lps'),
	(554633, 127, '2014-03-01 00:38:20.000000', 'consum', 0.0221, 'lps'),
	(554634, 127, '2014-03-01 00:38:21.000000', 'consum', 0.0211, 'lps'),
	(554635, 127, '2014-03-01 00:38:22.000000', 'consum', 0.0238, 'lps'),
	(554636, 127, '2014-03-01 00:38:23.000000', 'consum', 0.0234, 'lps'),
	(554637, 127, '2014-03-01 00:38:24.000000', 'consum', 0.0215, 'lps'),
	(554638, 127, '2014-03-01 00:38:25.000000', 'consum', 0.0223, 'lps'),
	(554639, 127, '2014-03-01 00:38:26.000000', 'consum', 0.0233, 'lps'),
	(554640, 127, '2014-03-01 00:38:27.000000', 'consum', 0.0227, 'lps'),
	(554641, 127, '2014-03-01 00:38:28.000000', 'consum', 0.0226, 'lps'),
	(554642, 127, '2014-03-01 00:38:29.000000', 'consum', 0.0238, 'lps'),
	(554643, 127, '2014-03-01 00:38:30.000000', 'consum', 0.0218, 'lps'),
	(554644, 127, '2014-03-01 00:38:31.000000', 'consum', 0.0224, 'lps'),
	(554645, 127, '2014-03-01 00:38:32.000000', 'consum', 0.0226, 'lps'),
	(554646, 127, '2014-03-01 00:38:33.000000', 'consum', 0.0222, 'lps'),
	(554647, 127, '2014-03-01 00:38:34.000000', 'consum', 0.0221, 'lps'),
	(554648, 127, '2014-03-01 00:38:35.000000', 'consum', 0.0229, 'lps'),
	(554649, 127, '2014-03-01 00:38:36.000000', 'consum', 0.0213, 'lps'),
	(554650, 127, '2014-03-01 00:38:37.000000', 'consum', 0.0230, 'lps'),
	(554651, 127, '2014-03-01 00:38:38.000000', 'consum', 0.0213, 'lps'),
	(554652, 127, '2014-03-01 00:38:39.000000', 'consum', 0.0224, 'lps'),
	(554653, 127, '2014-03-01 00:38:40.000000', 'consum', 0.0213, 'lps'),
	(554654, 127, '2014-03-01 00:38:41.000000', 'consum', 0.0212, 'lps'),
	(554655, 127, '2014-03-01 00:38:42.000000', 'consum', 0.0213, 'lps'),
	(554656, 127, '2014-03-01 00:38:43.000000', 'consum', 0.0217, 'lps'),
	(554657, 127, '2014-03-01 00:38:44.000000', 'consum', 0.0238, 'lps'),
	(554658, 127, '2014-03-01 00:38:45.000000', 'consum', 0.0213, 'lps'),
	(554659, 127, '2014-03-01 00:38:46.000000', 'consum', 0.0231, 'lps'),
	(554660, 127, '2014-03-01 00:38:47.000000', 'consum', 0.0217, 'lps'),
	(554661, 127, '2014-03-01 00:38:48.000000', 'consum', 0.0211, 'lps'),
	(554662, 127, '2014-03-01 00:38:49.000000', 'consum', 0.0225, 'lps'),
	(554663, 127, '2014-03-01 00:38:50.000000', 'consum', 0.0225, 'lps'),
	(554664, 127, '2014-03-01 00:38:51.000000', 'consum', 0.0212, 'lps'),
	(554665, 127, '2014-03-01 00:38:52.000000', 'consum', 0.0234, 'lps'),
	(554666, 127, '2014-03-01 00:38:53.000000', 'consum', 0.0236, 'lps'),
	(554667, 127, '2014-03-01 00:38:54.000000', 'consum', 0.0238, 'lps'),
	(554668, 127, '2014-03-01 00:38:55.000000', 'consum', 0.0215, 'lps'),
	(554669, 127, '2014-03-01 00:38:56.000000', 'consum', 0.0211, 'lps'),
	(554670, 127, '2014-03-01 00:38:57.000000', 'consum', 0.0227, 'lps'),
	(554671, 127, '2014-03-01 00:38:58.000000', 'consum', 0.0237, 'lps'),
	(554672, 127, '2014-03-01 00:38:59.000000', 'consum', 0.0234, 'lps'),
	(554673, 127, '2014-03-01 00:39:00.000000', 'consum', 0.0220, 'lps'),
	(554674, 127, '2014-03-01 00:39:01.000000', 'consum', 0.0219, 'lps'),
	(554675, 127, '2014-03-01 00:39:02.000000', 'consum', 0.0224, 'lps'),
	(554676, 127, '2014-03-01 00:39:03.000000', 'consum', 0.0224, 'lps'),
	(554677, 127, '2014-03-01 00:39:04.000000', 'consum', 0.0238, 'lps'),
	(554678, 127, '2014-03-01 00:39:05.000000', 'consum', 0.0224, 'lps'),
	(554679, 127, '2014-03-01 00:39:06.000000', 'consum', 0.0225, 'lps'),
	(554680, 127, '2014-03-01 00:39:07.000000', 'consum', 0.0214, 'lps'),
	(554681, 127, '2014-03-01 00:39:08.000000', 'consum', 0.0214, 'lps'),
	(554682, 127, '2014-03-01 00:39:09.000000', 'consum', 0.0218, 'lps'),
	(554683, 127, '2014-03-01 00:39:10.000000', 'consum', 0.0238, 'lps'),
	(554684, 127, '2014-03-01 00:39:11.000000', 'consum', 0.0211, 'lps'),
	(554685, 127, '2014-03-01 00:39:12.000000', 'consum', 0.0218, 'lps'),
	(554686, 127, '2014-03-01 00:39:13.000000', 'consum', 0.0220, 'lps'),
	(554687, 127, '2014-03-01 00:39:14.000000', 'consum', 0.0236, 'lps'),
	(554688, 127, '2014-03-01 00:39:15.000000', 'consum', 0.0223, 'lps'),
	(554689, 127, '2014-03-01 00:39:16.000000', 'consum', 0.0228, 'lps'),
	(554690, 127, '2014-03-01 00:39:17.000000', 'consum', 0.0232, 'lps'),
	(554691, 127, '2014-03-01 00:39:18.000000', 'consum', 0.0238, 'lps'),
	(554692, 127, '2014-03-01 00:39:19.000000', 'consum', 0.0226, 'lps'),
	(554693, 127, '2014-03-01 00:39:20.000000', 'consum', 0.0234, 'lps'),
	(554694, 127, '2014-03-01 00:39:21.000000', 'consum', 0.0226, 'lps'),
	(554695, 127, '2014-03-01 00:39:22.000000', 'consum', 0.0218, 'lps'),
	(554696, 127, '2014-03-01 00:39:23.000000', 'consum', 0.0232, 'lps'),
	(554697, 127, '2014-03-01 00:39:24.000000', 'consum', 0.0238, 'lps'),
	(554698, 127, '2014-03-01 00:39:25.000000', 'consum', 0.0225, 'lps'),
	(554699, 127, '2014-03-01 00:39:26.000000', 'consum', 0.0233, 'lps'),
	(554700, 127, '2014-03-01 00:39:27.000000', 'consum', 0.0223, 'lps'),
	(554701, 127, '2014-03-01 00:39:28.000000', 'consum', 0.0234, 'lps'),
	(554702, 127, '2014-03-01 00:39:29.000000', 'consum', 0.0235, 'lps'),
	(554703, 127, '2014-03-01 00:39:30.000000', 'consum', 0.0233, 'lps'),
	(554704, 127, '2014-03-01 00:39:31.000000', 'consum', 0.0220, 'lps'),
	(554705, 127, '2014-03-01 00:39:32.000000', 'consum', 0.0224, 'lps'),
	(554706, 127, '2014-03-01 00:39:33.000000', 'consum', 0.0218, 'lps'),
	(554707, 127, '2014-03-01 00:39:34.000000', 'consum', 0.0211, 'lps'),
	(554708, 127, '2014-03-01 00:39:35.000000', 'consum', 0.0218, 'lps'),
	(554709, 127, '2014-03-01 00:39:36.000000', 'consum', 0.0221, 'lps'),
	(554710, 127, '2014-03-01 00:39:37.000000', 'consum', 0.0210, 'lps'),
	(554711, 127, '2014-03-01 00:39:38.000000', 'consum', 0.0237, 'lps'),
	(554712, 127, '2014-03-01 00:39:39.000000', 'consum', 0.0227, 'lps'),
	(554713, 127, '2014-03-01 00:39:40.000000', 'consum', 0.0218, 'lps'),
	(554714, 127, '2014-03-01 00:39:41.000000', 'consum', 0.0226, 'lps'),
	(554715, 127, '2014-03-01 00:39:42.000000', 'consum', 0.0210, 'lps'),
	(554716, 127, '2014-03-01 00:39:43.000000', 'consum', 0.0218, 'lps'),
	(554717, 127, '2014-03-01 00:39:44.000000', 'consum', 0.0224, 'lps'),
	(554718, 127, '2014-03-01 00:39:45.000000', 'consum', 0.0225, 'lps'),
	(554719, 127, '2014-03-01 00:39:46.000000', 'consum', 0.0214, 'lps'),
	(554720, 127, '2014-03-01 00:39:47.000000', 'consum', 0.0216, 'lps'),
	(554721, 127, '2014-03-01 00:39:48.000000', 'consum', 0.0228, 'lps'),
	(554722, 127, '2014-03-01 00:39:49.000000', 'consum', 0.0224, 'lps'),
	(554723, 127, '2014-03-01 00:39:50.000000', 'consum', 0.0228, 'lps'),
	(554724, 127, '2014-03-01 00:39:51.000000', 'consum', 0.0230, 'lps'),
	(554725, 127, '2014-03-01 00:39:52.000000', 'consum', 0.0227, 'lps'),
	(554726, 127, '2014-03-01 00:39:53.000000', 'consum', 0.0234, 'lps'),
	(554727, 127, '2014-03-01 00:39:54.000000', 'consum', 0.0222, 'lps'),
	(554728, 127, '2014-03-01 00:39:55.000000', 'consum', 0.0229, 'lps'),
	(554729, 127, '2014-03-01 00:39:56.000000', 'consum', 0.0211, 'lps'),
	(554730, 127, '2014-03-01 00:39:57.000000', 'consum', 0.0218, 'lps'),
	(554731, 127, '2014-03-01 00:39:58.000000', 'consum', 0.0217, 'lps'),
	(554732, 127, '2014-03-01 00:39:59.000000', 'consum', 0.0223, 'lps'),
	(554733, 127, '2014-03-01 00:40:00.000000', 'consum', 0.0223, 'lps'),
	(554734, 127, '2014-03-01 00:40:01.000000', 'consum', 0.0210, 'lps'),
	(554735, 127, '2014-03-01 00:40:02.000000', 'consum', 0.0230, 'lps'),
	(554736, 127, '2014-03-01 00:40:03.000000', 'consum', 0.0223, 'lps'),
	(554737, 127, '2014-03-01 00:40:04.000000', 'consum', 0.0214, 'lps'),
	(554738, 127, '2014-03-01 00:40:05.000000', 'consum', 0.0220, 'lps'),
	(554739, 127, '2014-03-01 00:40:06.000000', 'consum', 0.0222, 'lps'),
	(554740, 127, '2014-03-01 00:40:07.000000', 'consum', 0.0210, 'lps'),
	(554741, 127, '2014-03-01 00:40:08.000000', 'consum', 0.0231, 'lps'),
	(554742, 127, '2014-03-01 00:40:09.000000', 'consum', 0.0230, 'lps'),
	(554743, 127, '2014-03-01 00:40:10.000000', 'consum', 0.0220, 'lps'),
	(554744, 127, '2014-03-01 00:40:11.000000', 'consum', 0.0227, 'lps'),
	(554745, 127, '2014-03-01 00:40:12.000000', 'consum', 0.0238, 'lps'),
	(554746, 127, '2014-03-01 00:40:13.000000', 'consum', 0.0214, 'lps'),
	(554747, 127, '2014-03-01 00:40:14.000000', 'consum', 0.0233, 'lps'),
	(554748, 127, '2014-03-01 00:40:15.000000', 'consum', 0.0224, 'lps'),
	(554749, 127, '2014-03-01 00:40:16.000000', 'consum', 0.0212, 'lps'),
	(554750, 127, '2014-03-01 00:40:17.000000', 'consum', 0.0238, 'lps'),
	(554751, 127, '2014-03-01 00:40:18.000000', 'consum', 0.0229, 'lps'),
	(554752, 127, '2014-03-01 00:40:19.000000', 'consum', 0.0222, 'lps'),
	(554753, 127, '2014-03-01 00:40:20.000000', 'consum', 0.0214, 'lps'),
	(554754, 127, '2014-03-01 00:40:21.000000', 'consum', 0.0221, 'lps'),
	(554755, 127, '2014-03-01 00:40:22.000000', 'consum', 0.0227, 'lps'),
	(554756, 127, '2014-03-01 00:40:23.000000', 'consum', 0.0231, 'lps'),
	(554757, 127, '2014-03-01 00:40:24.000000', 'consum', 0.0234, 'lps'),
	(554758, 127, '2014-03-01 00:40:25.000000', 'consum', 0.0213, 'lps'),
	(554759, 127, '2014-03-01 00:40:26.000000', 'consum', 0.0211, 'lps'),
	(554760, 127, '2014-03-01 00:40:27.000000', 'consum', 0.0235, 'lps'),
	(554761, 127, '2014-03-01 00:40:28.000000', 'consum', 0.0215, 'lps'),
	(554762, 127, '2014-03-01 00:40:29.000000', 'consum', 0.0218, 'lps'),
	(554763, 127, '2014-03-01 00:40:30.000000', 'consum', 0.0210, 'lps'),
	(554764, 127, '2014-03-01 00:40:31.000000', 'consum', 0.0213, 'lps'),
	(554765, 127, '2014-03-01 00:40:32.000000', 'consum', 0.0225, 'lps'),
	(554766, 127, '2014-03-01 00:40:33.000000', 'consum', 0.0217, 'lps'),
	(554767, 127, '2014-03-01 00:40:34.000000', 'consum', 0.0232, 'lps'),
	(554768, 127, '2014-03-01 00:40:35.000000', 'consum', 0.0212, 'lps'),
	(554769, 127, '2014-03-01 00:40:36.000000', 'consum', 0.0212, 'lps'),
	(554770, 127, '2014-03-01 00:40:37.000000', 'consum', 0.0215, 'lps'),
	(554771, 127, '2014-03-01 00:40:38.000000', 'consum', 0.0230, 'lps'),
	(554772, 127, '2014-03-01 00:40:39.000000', 'consum', 0.0238, 'lps'),
	(554773, 127, '2014-03-01 00:40:40.000000', 'consum', 0.0232, 'lps'),
	(554774, 127, '2014-03-01 00:40:41.000000', 'consum', 0.0235, 'lps'),
	(554775, 127, '2014-03-01 00:40:42.000000', 'consum', 0.0213, 'lps'),
	(554776, 127, '2014-03-01 00:40:43.000000', 'consum', 0.0237, 'lps'),
	(554777, 127, '2014-03-01 00:40:44.000000', 'consum', 0.0220, 'lps'),
	(554778, 127, '2014-03-01 00:40:45.000000', 'consum', 0.0238, 'lps'),
	(554779, 127, '2014-03-01 00:40:46.000000', 'consum', 0.0235, 'lps'),
	(554780, 127, '2014-03-01 00:40:47.000000', 'consum', 0.0223, 'lps'),
	(554781, 127, '2014-03-01 00:40:48.000000', 'consum', 0.0230, 'lps'),
	(554782, 127, '2014-03-01 00:40:49.000000', 'consum', 0.0211, 'lps'),
	(554783, 127, '2014-03-01 00:40:50.000000', 'consum', 0.0213, 'lps'),
	(554784, 127, '2014-03-01 00:40:51.000000', 'consum', 0.0224, 'lps'),
	(554785, 127, '2014-03-01 00:40:52.000000', 'consum', 0.0211, 'lps'),
	(554786, 127, '2014-03-01 00:40:53.000000', 'consum', 0.0234, 'lps'),
	(554787, 127, '2014-03-01 00:40:54.000000', 'consum', 0.0212, 'lps'),
	(554788, 127, '2014-03-01 00:40:55.000000', 'consum', 0.0233, 'lps'),
	(554789, 127, '2014-03-01 00:40:56.000000', 'consum', 0.0234, 'lps'),
	(554790, 127, '2014-03-01 00:40:57.000000', 'consum', 0.0233, 'lps'),
	(554791, 127, '2014-03-01 00:40:58.000000', 'consum', 0.0223, 'lps'),
	(554792, 127, '2014-03-01 00:40:59.000000', 'consum', 0.0236, 'lps'),
	(554793, 127, '2014-03-01 00:41:00.000000', 'consum', 0.0214, 'lps'),
	(554794, 127, '2014-03-01 00:41:01.000000', 'consum', 0.0210, 'lps'),
	(554795, 127, '2014-03-01 00:41:02.000000', 'consum', 0.0226, 'lps'),
	(554796, 127, '2014-03-01 00:41:03.000000', 'consum', 0.0236, 'lps'),
	(554797, 127, '2014-03-01 00:41:04.000000', 'consum', 0.0233, 'lps'),
	(554798, 127, '2014-03-01 00:41:05.000000', 'consum', 0.0220, 'lps'),
	(554799, 127, '2014-03-01 00:41:06.000000', 'consum', 0.0221, 'lps'),
	(554800, 127, '2014-03-01 00:41:07.000000', 'consum', 0.0236, 'lps'),
	(554801, 127, '2014-03-01 00:41:08.000000', 'consum', 0.0220, 'lps'),
	(554802, 127, '2014-03-01 00:41:09.000000', 'consum', 0.0211, 'lps'),
	(554803, 127, '2014-03-01 00:41:10.000000', 'consum', 0.0217, 'lps'),
	(554804, 127, '2014-03-01 00:41:11.000000', 'consum', 0.0210, 'lps'),
	(554805, 127, '2014-03-01 00:41:12.000000', 'consum', 0.0220, 'lps'),
	(554806, 127, '2014-03-01 00:41:13.000000', 'consum', 0.0229, 'lps'),
	(554807, 127, '2014-03-01 00:41:14.000000', 'consum', 0.0221, 'lps'),
	(554808, 127, '2014-03-01 00:41:15.000000', 'consum', 0.0237, 'lps'),
	(554809, 127, '2014-03-01 00:41:16.000000', 'consum', 0.0223, 'lps'),
	(554810, 127, '2014-03-01 00:41:17.000000', 'consum', 0.0225, 'lps'),
	(554811, 127, '2014-03-01 00:41:18.000000', 'consum', 0.0218, 'lps'),
	(554812, 127, '2014-03-01 00:41:19.000000', 'consum', 0.0235, 'lps'),
	(554813, 127, '2014-03-01 00:41:20.000000', 'consum', 0.0224, 'lps'),
	(554814, 127, '2014-03-01 00:41:21.000000', 'consum', 0.0234, 'lps'),
	(554815, 127, '2014-03-01 00:41:22.000000', 'consum', 0.0231, 'lps'),
	(554816, 127, '2014-03-01 00:41:23.000000', 'consum', 0.0215, 'lps'),
	(554817, 127, '2014-03-01 00:41:24.000000', 'consum', 0.0231, 'lps'),
	(554818, 127, '2014-03-01 00:41:25.000000', 'consum', 0.0212, 'lps'),
	(554819, 127, '2014-03-01 00:41:26.000000', 'consum', 0.0215, 'lps'),
	(554820, 127, '2014-03-01 00:41:27.000000', 'consum', 0.0230, 'lps'),
	(554821, 127, '2014-03-01 00:41:28.000000', 'consum', 0.0236, 'lps'),
	(554822, 127, '2014-03-01 00:41:29.000000', 'consum', 0.0225, 'lps'),
	(554823, 127, '2014-03-01 00:41:30.000000', 'consum', 0.0234, 'lps'),
	(554824, 127, '2014-03-01 00:41:31.000000', 'consum', 0.0229, 'lps'),
	(554825, 127, '2014-03-01 00:41:32.000000', 'consum', 0.0234, 'lps'),
	(554826, 127, '2014-03-01 00:41:33.000000', 'consum', 0.0213, 'lps'),
	(554827, 127, '2014-03-01 00:41:34.000000', 'consum', 0.0214, 'lps'),
	(554828, 127, '2014-03-01 00:41:35.000000', 'consum', 0.0220, 'lps'),
	(554829, 127, '2014-03-01 00:41:36.000000', 'consum', 0.0218, 'lps'),
	(554830, 127, '2014-03-01 00:41:37.000000', 'consum', 0.0223, 'lps'),
	(554831, 127, '2014-03-01 00:41:38.000000', 'consum', 0.0224, 'lps'),
	(554832, 127, '2014-03-01 00:41:39.000000', 'consum', 0.0238, 'lps'),
	(554833, 127, '2014-03-01 00:41:40.000000', 'consum', 0.0223, 'lps'),
	(554834, 127, '2014-03-01 00:41:41.000000', 'consum', 0.0220, 'lps'),
	(554835, 127, '2014-03-01 00:41:42.000000', 'consum', 0.0223, 'lps'),
	(554836, 127, '2014-03-01 00:41:43.000000', 'consum', 0.0214, 'lps'),
	(554837, 127, '2014-03-01 00:41:44.000000', 'consum', 0.0223, 'lps'),
	(554838, 127, '2014-03-01 00:41:45.000000', 'consum', 0.0235, 'lps'),
	(554839, 127, '2014-03-01 00:41:46.000000', 'consum', 0.0210, 'lps'),
	(554840, 127, '2014-03-01 00:41:47.000000', 'consum', 0.0221, 'lps'),
	(554841, 127, '2014-03-01 00:41:48.000000', 'consum', 0.0238, 'lps'),
	(554842, 127, '2014-03-01 00:41:49.000000', 'consum', 0.0231, 'lps'),
	(554843, 127, '2014-03-01 00:41:50.000000', 'consum', 0.0231, 'lps'),
	(554844, 127, '2014-03-01 00:41:51.000000', 'consum', 0.0223, 'lps'),
	(554845, 127, '2014-03-01 00:41:52.000000', 'consum', 0.0214, 'lps'),
	(554846, 127, '2014-03-01 00:41:53.000000', 'consum', 0.0218, 'lps'),
	(554847, 127, '2014-03-01 00:41:54.000000', 'consum', 0.0212, 'lps'),
	(554848, 127, '2014-03-01 00:41:55.000000', 'consum', 0.0224, 'lps'),
	(554849, 127, '2014-03-01 00:41:56.000000', 'consum', 0.0218, 'lps'),
	(554850, 127, '2014-03-01 00:41:57.000000', 'consum', 0.0238, 'lps'),
	(554851, 127, '2014-03-01 00:41:58.000000', 'consum', 0.0237, 'lps'),
	(554852, 127, '2014-03-01 00:41:59.000000', 'consum', 0.0235, 'lps'),
	(554853, 127, '2014-03-01 00:42:00.000000', 'consum', 0.0223, 'lps'),
	(554854, 127, '2014-03-01 00:42:01.000000', 'consum', 0.0231, 'lps'),
	(554855, 127, '2014-03-01 00:42:02.000000', 'consum', 0.0219, 'lps'),
	(554856, 127, '2014-03-01 00:42:03.000000', 'consum', 0.0223, 'lps'),
	(554857, 127, '2014-03-01 00:42:04.000000', 'consum', 0.0218, 'lps'),
	(554858, 127, '2014-03-01 00:42:05.000000', 'consum', 0.0210, 'lps'),
	(554859, 127, '2014-03-01 00:42:06.000000', 'consum', 0.0215, 'lps'),
	(554860, 127, '2014-03-01 00:42:07.000000', 'consum', 0.0235, 'lps'),
	(554861, 127, '2014-03-01 00:42:08.000000', 'consum', 0.0235, 'lps'),
	(554862, 127, '2014-03-01 00:42:09.000000', 'consum', 0.0232, 'lps'),
	(554863, 127, '2014-03-01 00:42:10.000000', 'consum', 0.0215, 'lps'),
	(554864, 127, '2014-03-01 00:42:11.000000', 'consum', 0.0226, 'lps'),
	(554865, 127, '2014-03-01 00:42:12.000000', 'consum', 0.0221, 'lps'),
	(554866, 127, '2014-03-01 00:42:13.000000', 'consum', 0.0216, 'lps'),
	(554867, 127, '2014-03-01 00:42:14.000000', 'consum', 0.0238, 'lps'),
	(554868, 127, '2014-03-01 00:42:15.000000', 'consum', 0.0215, 'lps'),
	(554869, 127, '2014-03-01 00:42:16.000000', 'consum', 0.0211, 'lps'),
	(554870, 127, '2014-03-01 00:42:17.000000', 'consum', 0.0230, 'lps'),
	(554871, 127, '2014-03-01 00:42:18.000000', 'consum', 0.0218, 'lps'),
	(554872, 127, '2014-03-01 00:42:19.000000', 'consum', 0.0222, 'lps'),
	(554873, 127, '2014-03-01 00:42:20.000000', 'consum', 0.0215, 'lps'),
	(554874, 127, '2014-03-01 00:42:21.000000', 'consum', 0.0230, 'lps'),
	(554875, 127, '2014-03-01 00:42:22.000000', 'consum', 0.0210, 'lps'),
	(554876, 127, '2014-03-01 00:42:23.000000', 'consum', 0.0235, 'lps'),
	(554877, 127, '2014-03-01 00:42:24.000000', 'consum', 0.0220, 'lps'),
	(554878, 127, '2014-03-01 00:42:25.000000', 'consum', 0.0214, 'lps'),
	(554879, 127, '2014-03-01 00:42:26.000000', 'consum', 0.0229, 'lps'),
	(554880, 127, '2014-03-01 00:42:27.000000', 'consum', 0.0235, 'lps'),
	(554881, 127, '2014-03-01 00:42:28.000000', 'consum', 0.0223, 'lps'),
	(554882, 127, '2014-03-01 00:42:29.000000', 'consum', 0.0229, 'lps'),
	(554883, 127, '2014-03-01 00:42:30.000000', 'consum', 0.0235, 'lps'),
	(554884, 127, '2014-03-01 00:42:31.000000', 'consum', 0.0222, 'lps'),
	(554885, 127, '2014-03-01 00:42:32.000000', 'consum', 0.0222, 'lps'),
	(554886, 127, '2014-03-01 00:42:33.000000', 'consum', 0.0238, 'lps'),
	(554887, 127, '2014-03-01 00:42:34.000000', 'consum', 0.0227, 'lps'),
	(554888, 127, '2014-03-01 00:42:35.000000', 'consum', 0.0210, 'lps'),
	(554889, 127, '2014-03-01 00:42:36.000000', 'consum', 0.0217, 'lps'),
	(554890, 127, '2014-03-01 00:42:37.000000', 'consum', 0.0215, 'lps'),
	(554891, 127, '2014-03-01 00:42:38.000000', 'consum', 0.0217, 'lps'),
	(554892, 127, '2014-03-01 00:42:39.000000', 'consum', 0.0231, 'lps'),
	(554893, 127, '2014-03-01 00:42:40.000000', 'consum', 0.0237, 'lps'),
	(554894, 127, '2014-03-01 00:42:41.000000', 'consum', 0.0224, 'lps'),
	(554895, 127, '2014-03-01 00:42:42.000000', 'consum', 0.0230, 'lps'),
	(554896, 127, '2014-03-01 00:42:43.000000', 'consum', 0.0210, 'lps'),
	(554897, 127, '2014-03-01 00:42:44.000000', 'consum', 0.0235, 'lps'),
	(554898, 127, '2014-03-01 00:42:45.000000', 'consum', 0.0222, 'lps'),
	(554899, 127, '2014-03-01 00:42:46.000000', 'consum', 0.0224, 'lps'),
	(554900, 127, '2014-03-01 00:42:47.000000', 'consum', 0.0214, 'lps'),
	(554901, 127, '2014-03-01 00:42:48.000000', 'consum', 0.0218, 'lps'),
	(554902, 127, '2014-03-01 00:42:49.000000', 'consum', 0.0211, 'lps'),
	(554903, 127, '2014-03-01 00:42:50.000000', 'consum', 0.0219, 'lps'),
	(554904, 127, '2014-03-01 00:42:51.000000', 'consum', 0.0224, 'lps'),
	(554905, 127, '2014-03-01 00:42:52.000000', 'consum', 0.0226, 'lps'),
	(554906, 127, '2014-03-01 00:42:53.000000', 'consum', 0.0218, 'lps'),
	(554907, 127, '2014-03-01 00:42:54.000000', 'consum', 0.0234, 'lps'),
	(554908, 127, '2014-03-01 00:42:55.000000', 'consum', 0.0217, 'lps'),
	(554909, 127, '2014-03-01 00:42:56.000000', 'consum', 0.0232, 'lps'),
	(554910, 127, '2014-03-01 00:42:57.000000', 'consum', 0.0213, 'lps'),
	(554911, 127, '2014-03-01 00:42:58.000000', 'consum', 0.0219, 'lps'),
	(554912, 127, '2014-03-01 00:42:59.000000', 'consum', 0.0218, 'lps'),
	(554913, 127, '2014-03-01 00:43:00.000000', 'consum', 0.0220, 'lps'),
	(554914, 127, '2014-03-01 00:43:01.000000', 'consum', 0.0211, 'lps'),
	(554915, 127, '2014-03-01 00:43:02.000000', 'consum', 0.0214, 'lps'),
	(554916, 127, '2014-03-01 00:43:03.000000', 'consum', 0.0226, 'lps'),
	(554917, 127, '2014-03-01 00:43:04.000000', 'consum', 0.0221, 'lps'),
	(554918, 127, '2014-03-01 00:43:05.000000', 'consum', 0.0216, 'lps'),
	(554919, 127, '2014-03-01 00:43:06.000000', 'consum', 0.0210, 'lps'),
	(554920, 127, '2014-03-01 00:43:07.000000', 'consum', 0.0222, 'lps'),
	(554921, 127, '2014-03-01 00:43:08.000000', 'consum', 0.0211, 'lps'),
	(554922, 127, '2014-03-01 00:43:09.000000', 'consum', 0.0238, 'lps'),
	(554923, 127, '2014-03-01 00:43:10.000000', 'consum', 0.0233, 'lps'),
	(554924, 127, '2014-03-01 00:43:11.000000', 'consum', 0.0213, 'lps'),
	(554925, 127, '2014-03-01 00:43:12.000000', 'consum', 0.0214, 'lps'),
	(554926, 127, '2014-03-01 00:43:13.000000', 'consum', 0.0222, 'lps'),
	(554927, 127, '2014-03-01 00:43:14.000000', 'consum', 0.0227, 'lps'),
	(554928, 127, '2014-03-01 00:43:15.000000', 'consum', 0.0232, 'lps'),
	(554929, 127, '2014-03-01 00:43:16.000000', 'consum', 0.0238, 'lps'),
	(554930, 127, '2014-03-01 00:43:17.000000', 'consum', 0.0229, 'lps'),
	(554931, 127, '2014-03-01 00:43:18.000000', 'consum', 0.0223, 'lps'),
	(554932, 127, '2014-03-01 00:43:19.000000', 'consum', 0.0217, 'lps'),
	(554933, 127, '2014-03-01 00:43:20.000000', 'consum', 0.0235, 'lps'),
	(554934, 127, '2014-03-01 00:43:21.000000', 'consum', 0.0228, 'lps'),
	(554935, 127, '2014-03-01 00:43:22.000000', 'consum', 0.0227, 'lps'),
	(554936, 127, '2014-03-01 00:43:23.000000', 'consum', 0.0212, 'lps'),
	(554937, 127, '2014-03-01 00:43:24.000000', 'consum', 0.0226, 'lps'),
	(554938, 127, '2014-03-01 00:43:25.000000', 'consum', 0.0227, 'lps'),
	(554939, 127, '2014-03-01 00:43:26.000000', 'consum', 0.0217, 'lps'),
	(554940, 127, '2014-03-01 00:43:27.000000', 'consum', 0.0225, 'lps'),
	(554941, 127, '2014-03-01 00:43:28.000000', 'consum', 0.0235, 'lps'),
	(554942, 127, '2014-03-01 00:43:29.000000', 'consum', 0.0234, 'lps'),
	(554943, 127, '2014-03-01 00:43:30.000000', 'consum', 0.0225, 'lps'),
	(554944, 127, '2014-03-01 00:43:31.000000', 'consum', 0.0214, 'lps'),
	(554945, 127, '2014-03-01 00:43:32.000000', 'consum', 0.0214, 'lps'),
	(554946, 127, '2014-03-01 00:43:33.000000', 'consum', 0.0220, 'lps'),
	(554947, 127, '2014-03-01 00:43:34.000000', 'consum', 0.0218, 'lps'),
	(554948, 127, '2014-03-01 00:43:35.000000', 'consum', 0.0222, 'lps'),
	(554949, 127, '2014-03-01 00:43:36.000000', 'consum', 0.0215, 'lps'),
	(554950, 127, '2014-03-01 00:43:37.000000', 'consum', 0.0230, 'lps'),
	(554951, 127, '2014-03-01 00:43:38.000000', 'consum', 0.0210, 'lps'),
	(554952, 127, '2014-03-01 00:43:39.000000', 'consum', 0.0236, 'lps'),
	(554953, 127, '2014-03-01 00:43:40.000000', 'consum', 0.0226, 'lps'),
	(554954, 127, '2014-03-01 00:43:41.000000', 'consum', 0.0212, 'lps'),
	(554955, 127, '2014-03-01 00:43:42.000000', 'consum', 0.0231, 'lps'),
	(554956, 127, '2014-03-01 00:43:43.000000', 'consum', 0.0223, 'lps'),
	(554957, 127, '2014-03-01 00:43:44.000000', 'consum', 0.0212, 'lps'),
	(554958, 127, '2014-03-01 00:43:45.000000', 'consum', 0.0210, 'lps'),
	(554959, 127, '2014-03-01 00:43:46.000000', 'consum', 0.0233, 'lps'),
	(554960, 127, '2014-03-01 00:43:47.000000', 'consum', 0.0237, 'lps'),
	(554961, 127, '2014-03-01 00:43:48.000000', 'consum', 0.0222, 'lps'),
	(554962, 127, '2014-03-01 00:43:49.000000', 'consum', 0.0215, 'lps'),
	(554963, 127, '2014-03-01 00:43:50.000000', 'consum', 0.0231, 'lps'),
	(554964, 127, '2014-03-01 00:43:51.000000', 'consum', 0.0211, 'lps'),
	(554965, 127, '2014-03-01 00:43:52.000000', 'consum', 0.0211, 'lps'),
	(554966, 127, '2014-03-01 00:43:53.000000', 'consum', 0.0211, 'lps'),
	(554967, 127, '2014-03-01 00:43:54.000000', 'consum', 0.0213, 'lps'),
	(554968, 127, '2014-03-01 00:43:55.000000', 'consum', 0.0225, 'lps'),
	(554969, 127, '2014-03-01 00:43:56.000000', 'consum', 0.0217, 'lps'),
	(554970, 127, '2014-03-01 00:43:57.000000', 'consum', 0.0231, 'lps'),
	(554971, 127, '2014-03-01 00:43:58.000000', 'consum', 0.0236, 'lps'),
	(554972, 127, '2014-03-01 00:43:59.000000', 'consum', 0.0218, 'lps'),
	(554973, 127, '2014-03-01 00:44:00.000000', 'consum', 0.0231, 'lps'),
	(554974, 127, '2014-03-01 00:44:01.000000', 'consum', 0.0234, 'lps'),
	(554975, 127, '2014-03-01 00:44:02.000000', 'consum', 0.0238, 'lps'),
	(554976, 127, '2014-03-01 00:44:03.000000', 'consum', 0.0222, 'lps'),
	(554977, 127, '2014-03-01 00:44:04.000000', 'consum', 0.0213, 'lps'),
	(554978, 127, '2014-03-01 00:44:05.000000', 'consum', 0.0220, 'lps'),
	(554979, 127, '2014-03-01 00:44:06.000000', 'consum', 0.0222, 'lps'),
	(554980, 127, '2014-03-01 00:44:07.000000', 'consum', 0.0212, 'lps'),
	(554981, 127, '2014-03-01 00:44:08.000000', 'consum', 0.0214, 'lps'),
	(554982, 127, '2014-03-01 00:44:09.000000', 'consum', 0.0224, 'lps'),
	(554983, 127, '2014-03-01 00:44:10.000000', 'consum', 0.0211, 'lps'),
	(554984, 127, '2014-03-01 00:44:11.000000', 'consum', 0.0232, 'lps'),
	(554985, 127, '2014-03-01 00:44:12.000000', 'consum', 0.0231, 'lps'),
	(554986, 127, '2014-03-01 00:44:13.000000', 'consum', 0.0219, 'lps'),
	(554987, 127, '2014-03-01 00:44:14.000000', 'consum', 0.0222, 'lps'),
	(554988, 127, '2014-03-01 00:44:15.000000', 'consum', 0.0216, 'lps'),
	(554989, 127, '2014-03-01 00:44:16.000000', 'consum', 0.0233, 'lps'),
	(554990, 127, '2014-03-01 00:44:17.000000', 'consum', 0.0221, 'lps'),
	(554991, 127, '2014-03-01 00:44:18.000000', 'consum', 0.0223, 'lps'),
	(554992, 127, '2014-03-01 00:44:19.000000', 'consum', 0.0215, 'lps'),
	(554993, 127, '2014-03-01 00:44:20.000000', 'consum', 0.0226, 'lps'),
	(554994, 127, '2014-03-01 00:44:21.000000', 'consum', 0.0215, 'lps'),
	(554995, 127, '2014-03-01 00:44:22.000000', 'consum', 0.0219, 'lps'),
	(554996, 127, '2014-03-01 00:44:23.000000', 'consum', 0.0212, 'lps'),
	(554997, 127, '2014-03-01 00:44:24.000000', 'consum', 0.0221, 'lps'),
	(554998, 127, '2014-03-01 00:44:25.000000', 'consum', 0.0229, 'lps'),
	(554999, 127, '2014-03-01 00:44:26.000000', 'consum', 0.0217, 'lps'),
	(555000, 127, '2014-03-01 00:44:27.000000', 'consum', 0.0216, 'lps'),
	(555001, 127, '2014-03-01 00:44:28.000000', 'consum', 0.0219, 'lps'),
	(555002, 127, '2014-03-01 00:44:29.000000', 'consum', 0.0211, 'lps'),
	(555003, 127, '2014-03-01 00:44:30.000000', 'consum', 0.0215, 'lps'),
	(555004, 127, '2014-03-01 00:44:31.000000', 'consum', 0.0233, 'lps'),
	(555005, 127, '2014-03-01 00:44:32.000000', 'consum', 0.0224, 'lps'),
	(555006, 127, '2014-03-01 00:44:33.000000', 'consum', 0.0213, 'lps'),
	(555007, 127, '2014-03-01 00:44:34.000000', 'consum', 0.0212, 'lps'),
	(555008, 127, '2014-03-01 00:44:35.000000', 'consum', 0.0210, 'lps'),
	(555009, 127, '2014-03-01 00:44:36.000000', 'consum', 0.0233, 'lps'),
	(555010, 127, '2014-03-01 00:44:37.000000', 'consum', 0.0212, 'lps'),
	(555011, 127, '2014-03-01 00:44:38.000000', 'consum', 0.0237, 'lps'),
	(555012, 127, '2014-03-01 00:44:39.000000', 'consum', 0.0226, 'lps'),
	(555013, 127, '2014-03-01 00:44:40.000000', 'consum', 0.0235, 'lps'),
	(555014, 127, '2014-03-01 00:44:41.000000', 'consum', 0.0233, 'lps'),
	(555015, 127, '2014-03-01 00:44:42.000000', 'consum', 0.0218, 'lps'),
	(555016, 127, '2014-03-01 00:44:43.000000', 'consum', 0.0212, 'lps'),
	(555017, 127, '2014-03-01 00:44:44.000000', 'consum', 0.0227, 'lps'),
	(555018, 127, '2014-03-01 00:44:45.000000', 'consum', 0.0231, 'lps'),
	(555019, 127, '2014-03-01 00:44:46.000000', 'consum', 0.0234, 'lps'),
	(555020, 127, '2014-03-01 00:44:47.000000', 'consum', 0.0211, 'lps'),
	(555021, 127, '2014-03-01 00:44:48.000000', 'consum', 0.0231, 'lps'),
	(555022, 127, '2014-03-01 00:44:49.000000', 'consum', 0.0223, 'lps'),
	(555023, 127, '2014-03-01 00:44:50.000000', 'consum', 0.0212, 'lps'),
	(555024, 127, '2014-03-01 00:44:51.000000', 'consum', 0.0214, 'lps'),
	(555025, 127, '2014-03-01 00:44:52.000000', 'consum', 0.0222, 'lps'),
	(555026, 127, '2014-03-01 00:44:53.000000', 'consum', 0.0230, 'lps'),
	(555027, 127, '2014-03-01 00:44:54.000000', 'consum', 0.0217, 'lps'),
	(555028, 127, '2014-03-01 00:44:55.000000', 'consum', 0.0215, 'lps'),
	(555029, 127, '2014-03-01 00:44:56.000000', 'consum', 0.0216, 'lps'),
	(555030, 127, '2014-03-01 00:44:57.000000', 'consum', 0.0222, 'lps'),
	(555031, 127, '2014-03-01 00:44:58.000000', 'consum', 0.0227, 'lps'),
	(555032, 127, '2014-03-01 00:44:59.000000', 'consum', 0.0228, 'lps'),
	(555033, 127, '2014-03-01 00:45:00.000000', 'consum', 0.0222, 'lps'),
	(555034, 127, '2014-03-01 00:45:01.000000', 'consum', 0.0217, 'lps'),
	(555035, 127, '2014-03-01 00:45:02.000000', 'consum', 0.0237, 'lps'),
	(555036, 127, '2014-03-01 00:45:03.000000', 'consum', 0.0236, 'lps'),
	(555037, 127, '2014-03-01 00:45:04.000000', 'consum', 0.0233, 'lps'),
	(555038, 127, '2014-03-01 00:45:05.000000', 'consum', 0.0217, 'lps'),
	(555039, 127, '2014-03-01 00:45:06.000000', 'consum', 0.0237, 'lps'),
	(555040, 127, '2014-03-01 00:45:07.000000', 'consum', 0.0235, 'lps'),
	(555041, 127, '2014-03-01 00:45:08.000000', 'consum', 0.0228, 'lps'),
	(555042, 127, '2014-03-01 00:45:09.000000', 'consum', 0.0224, 'lps'),
	(555043, 127, '2014-03-01 00:45:10.000000', 'consum', 0.0225, 'lps'),
	(555044, 127, '2014-03-01 00:45:11.000000', 'consum', 0.0217, 'lps'),
	(555045, 127, '2014-03-01 00:45:12.000000', 'consum', 0.0229, 'lps'),
	(555046, 127, '2014-03-01 00:45:13.000000', 'consum', 0.0227, 'lps'),
	(555047, 127, '2014-03-01 00:45:14.000000', 'consum', 0.0238, 'lps'),
	(555048, 127, '2014-03-01 00:45:15.000000', 'consum', 0.0214, 'lps'),
	(555049, 127, '2014-03-01 00:45:16.000000', 'consum', 0.0231, 'lps'),
	(555050, 127, '2014-03-01 00:45:17.000000', 'consum', 0.0217, 'lps'),
	(555051, 127, '2014-03-01 00:45:18.000000', 'consum', 0.0212, 'lps'),
	(555052, 127, '2014-03-01 00:45:19.000000', 'consum', 0.0228, 'lps'),
	(555053, 127, '2014-03-01 00:45:20.000000', 'consum', 0.0235, 'lps'),
	(555054, 127, '2014-03-01 00:45:21.000000', 'consum', 0.0225, 'lps'),
	(555055, 127, '2014-03-01 00:45:22.000000', 'consum', 0.0212, 'lps'),
	(555056, 127, '2014-03-01 00:45:23.000000', 'consum', 0.0234, 'lps'),
	(555057, 127, '2014-03-01 00:45:24.000000', 'consum', 0.0238, 'lps'),
	(555058, 127, '2014-03-01 00:45:25.000000', 'consum', 0.0218, 'lps'),
	(555059, 127, '2014-03-01 00:45:26.000000', 'consum', 0.0226, 'lps'),
	(555060, 127, '2014-03-01 00:45:27.000000', 'consum', 0.0236, 'lps'),
	(555061, 127, '2014-03-01 00:45:28.000000', 'consum', 0.0235, 'lps'),
	(555062, 127, '2014-03-01 00:45:29.000000', 'consum', 0.0230, 'lps'),
	(555063, 127, '2014-03-01 00:45:30.000000', 'consum', 0.0234, 'lps'),
	(555064, 127, '2014-03-01 00:45:31.000000', 'consum', 0.0215, 'lps'),
	(555065, 127, '2014-03-01 00:45:32.000000', 'consum', 0.0220, 'lps'),
	(555066, 127, '2014-03-01 00:45:33.000000', 'consum', 0.0217, 'lps'),
	(555067, 127, '2014-03-01 00:45:34.000000', 'consum', 0.0214, 'lps'),
	(555068, 127, '2014-03-01 00:45:35.000000', 'consum', 0.0237, 'lps'),
	(555069, 127, '2014-03-01 00:45:36.000000', 'consum', 0.0220, 'lps'),
	(555070, 127, '2014-03-01 00:45:37.000000', 'consum', 0.0237, 'lps'),
	(555071, 127, '2014-03-01 00:45:38.000000', 'consum', 0.0229, 'lps'),
	(555072, 127, '2014-03-01 00:45:39.000000', 'consum', 0.0225, 'lps'),
	(555073, 127, '2014-03-01 00:45:40.000000', 'consum', 0.0230, 'lps'),
	(555074, 127, '2014-03-01 00:45:41.000000', 'consum', 0.0234, 'lps'),
	(555075, 127, '2014-03-01 00:45:42.000000', 'consum', 0.0215, 'lps'),
	(555076, 127, '2014-03-01 00:45:43.000000', 'consum', 0.0220, 'lps'),
	(555077, 127, '2014-03-01 00:45:44.000000', 'consum', 0.0217, 'lps'),
	(555078, 127, '2014-03-01 00:45:45.000000', 'consum', 0.0215, 'lps'),
	(555079, 127, '2014-03-01 00:45:46.000000', 'consum', 0.0214, 'lps'),
	(555080, 127, '2014-03-01 00:45:47.000000', 'consum', 0.0215, 'lps'),
	(555081, 127, '2014-03-01 00:45:48.000000', 'consum', 0.0225, 'lps'),
	(555082, 127, '2014-03-01 00:45:49.000000', 'consum', 0.0214, 'lps'),
	(555083, 127, '2014-03-01 00:45:50.000000', 'consum', 0.0212, 'lps'),
	(555084, 127, '2014-03-01 00:45:51.000000', 'consum', 0.0210, 'lps'),
	(555085, 127, '2014-03-01 00:45:52.000000', 'consum', 0.0232, 'lps'),
	(555086, 127, '2014-03-01 00:45:53.000000', 'consum', 0.0233, 'lps'),
	(555087, 127, '2014-03-01 00:45:54.000000', 'consum', 0.0229, 'lps'),
	(555088, 127, '2014-03-01 00:45:55.000000', 'consum', 0.0211, 'lps'),
	(555089, 127, '2014-03-01 00:45:56.000000', 'consum', 0.0216, 'lps'),
	(555090, 127, '2014-03-01 00:45:57.000000', 'consum', 0.0236, 'lps'),
	(555091, 127, '2014-03-01 00:45:58.000000', 'consum', 0.0234, 'lps'),
	(555092, 127, '2014-03-01 00:45:59.000000', 'consum', 0.0226, 'lps'),
	(555093, 127, '2014-03-01 00:46:00.000000', 'consum', 0.0220, 'lps'),
	(555094, 127, '2014-03-01 00:46:01.000000', 'consum', 0.0238, 'lps'),
	(555095, 127, '2014-03-01 00:46:02.000000', 'consum', 0.0237, 'lps'),
	(555096, 127, '2014-03-01 00:46:03.000000', 'consum', 0.0229, 'lps'),
	(555097, 127, '2014-03-01 00:46:04.000000', 'consum', 0.0226, 'lps'),
	(555098, 127, '2014-03-01 00:46:05.000000', 'consum', 0.0232, 'lps'),
	(555099, 127, '2014-03-01 00:46:06.000000', 'consum', 0.0217, 'lps'),
	(555100, 127, '2014-03-01 00:46:07.000000', 'consum', 0.0236, 'lps'),
	(555101, 127, '2014-03-01 00:46:08.000000', 'consum', 0.0233, 'lps'),
	(555102, 127, '2014-03-01 00:46:09.000000', 'consum', 0.0219, 'lps'),
	(555103, 127, '2014-03-01 00:46:10.000000', 'consum', 0.0216, 'lps'),
	(555104, 127, '2014-03-01 00:46:11.000000', 'consum', 0.0214, 'lps'),
	(555105, 127, '2014-03-01 00:46:12.000000', 'consum', 0.0212, 'lps'),
	(555106, 127, '2014-03-01 00:46:13.000000', 'consum', 0.0237, 'lps'),
	(555107, 127, '2014-03-01 00:46:14.000000', 'consum', 0.0222, 'lps'),
	(555108, 127, '2014-03-01 00:46:15.000000', 'consum', 0.0220, 'lps'),
	(555109, 127, '2014-03-01 00:46:16.000000', 'consum', 0.0226, 'lps'),
	(555110, 127, '2014-03-01 00:46:17.000000', 'consum', 0.0230, 'lps'),
	(555111, 127, '2014-03-01 00:46:18.000000', 'consum', 0.0234, 'lps'),
	(555112, 127, '2014-03-01 00:46:19.000000', 'consum', 0.0212, 'lps'),
	(555113, 127, '2014-03-01 00:46:20.000000', 'consum', 0.0234, 'lps'),
	(555114, 127, '2014-03-01 00:46:21.000000', 'consum', 0.0238, 'lps'),
	(555115, 127, '2014-03-01 00:46:22.000000', 'consum', 0.0221, 'lps'),
	(555116, 127, '2014-03-01 00:46:23.000000', 'consum', 0.0212, 'lps'),
	(555117, 127, '2014-03-01 00:46:24.000000', 'consum', 0.0216, 'lps'),
	(555118, 127, '2014-03-01 00:46:25.000000', 'consum', 0.0234, 'lps'),
	(555119, 127, '2014-03-01 00:46:26.000000', 'consum', 0.0225, 'lps'),
	(555120, 127, '2014-03-01 00:46:27.000000', 'consum', 0.0213, 'lps'),
	(555121, 127, '2014-03-01 00:46:28.000000', 'consum', 0.0237, 'lps'),
	(555122, 127, '2014-03-01 00:46:29.000000', 'consum', 0.0224, 'lps'),
	(555123, 127, '2014-03-01 00:46:30.000000', 'consum', 0.0225, 'lps'),
	(555124, 127, '2014-03-01 00:46:31.000000', 'consum', 0.0217, 'lps'),
	(555125, 127, '2014-03-01 00:46:32.000000', 'consum', 0.0229, 'lps'),
	(555126, 127, '2014-03-01 00:46:33.000000', 'consum', 0.0226, 'lps'),
	(555127, 127, '2014-03-01 00:46:34.000000', 'consum', 0.0235, 'lps'),
	(555128, 127, '2014-03-01 00:46:35.000000', 'consum', 0.0228, 'lps'),
	(555129, 127, '2014-03-01 00:46:36.000000', 'consum', 0.0225, 'lps'),
	(555130, 127, '2014-03-01 00:46:37.000000', 'consum', 0.0233, 'lps'),
	(555131, 127, '2014-03-01 00:46:38.000000', 'consum', 0.0221, 'lps'),
	(555132, 127, '2014-03-01 00:46:39.000000', 'consum', 0.0226, 'lps'),
	(555133, 127, '2014-03-01 00:46:40.000000', 'consum', 0.0230, 'lps'),
	(555134, 127, '2014-03-01 00:46:41.000000', 'consum', 0.0233, 'lps'),
	(555135, 127, '2014-03-01 00:46:42.000000', 'consum', 0.0234, 'lps'),
	(555136, 127, '2014-03-01 00:46:43.000000', 'consum', 0.0235, 'lps'),
	(555137, 127, '2014-03-01 00:46:44.000000', 'consum', 0.0234, 'lps'),
	(555138, 127, '2014-03-01 00:46:45.000000', 'consum', 0.0228, 'lps'),
	(555139, 127, '2014-03-01 00:46:46.000000', 'consum', 0.0229, 'lps'),
	(555140, 127, '2014-03-01 00:46:47.000000', 'consum', 0.0221, 'lps'),
	(555141, 127, '2014-03-01 00:46:48.000000', 'consum', 0.0236, 'lps'),
	(555142, 127, '2014-03-01 00:46:49.000000', 'consum', 0.0224, 'lps'),
	(555143, 127, '2014-03-01 00:46:50.000000', 'consum', 0.0228, 'lps'),
	(555144, 127, '2014-03-01 00:46:51.000000', 'consum', 0.0233, 'lps'),
	(555145, 127, '2014-03-01 00:46:52.000000', 'consum', 0.0211, 'lps'),
	(555146, 127, '2014-03-01 00:46:53.000000', 'consum', 0.0236, 'lps'),
	(555147, 127, '2014-03-01 00:46:54.000000', 'consum', 0.0221, 'lps'),
	(555148, 127, '2014-03-01 00:46:55.000000', 'consum', 0.0216, 'lps'),
	(555149, 127, '2014-03-01 00:46:56.000000', 'consum', 0.0237, 'lps'),
	(555150, 127, '2014-03-01 00:46:57.000000', 'consum', 0.0213, 'lps'),
	(555151, 127, '2014-03-01 00:46:58.000000', 'consum', 0.0228, 'lps'),
	(555152, 127, '2014-03-01 00:46:59.000000', 'consum', 0.0236, 'lps'),
	(555153, 127, '2014-03-01 00:47:00.000000', 'consum', 0.0228, 'lps'),
	(555154, 127, '2014-03-01 00:47:01.000000', 'consum', 0.0222, 'lps'),
	(555155, 127, '2014-03-01 00:47:02.000000', 'consum', 0.0217, 'lps'),
	(555156, 127, '2014-03-01 00:47:03.000000', 'consum', 0.0237, 'lps'),
	(555157, 127, '2014-03-01 00:47:04.000000', 'consum', 0.0210, 'lps'),
	(555158, 127, '2014-03-01 00:47:05.000000', 'consum', 0.0216, 'lps'),
	(555159, 127, '2014-03-01 00:47:06.000000', 'consum', 0.0214, 'lps'),
	(555160, 127, '2014-03-01 00:47:07.000000', 'consum', 0.0238, 'lps'),
	(555161, 127, '2014-03-01 00:47:08.000000', 'consum', 0.0224, 'lps'),
	(555162, 127, '2014-03-01 00:47:09.000000', 'consum', 0.0224, 'lps'),
	(555163, 127, '2014-03-01 00:47:10.000000', 'consum', 0.0210, 'lps'),
	(555164, 127, '2014-03-01 00:47:11.000000', 'consum', 0.0225, 'lps'),
	(555165, 127, '2014-03-01 00:47:12.000000', 'consum', 0.0229, 'lps'),
	(555166, 127, '2014-03-01 00:47:13.000000', 'consum', 0.0229, 'lps'),
	(555167, 127, '2014-03-01 00:47:14.000000', 'consum', 0.0223, 'lps'),
	(555168, 127, '2014-03-01 00:47:15.000000', 'consum', 0.0217, 'lps'),
	(555169, 127, '2014-03-01 00:47:16.000000', 'consum', 0.0234, 'lps'),
	(555170, 127, '2014-03-01 00:47:17.000000', 'consum', 0.0223, 'lps'),
	(555171, 127, '2014-03-01 00:47:18.000000', 'consum', 0.0233, 'lps'),
	(555172, 127, '2014-03-01 00:47:19.000000', 'consum', 0.0228, 'lps'),
	(555173, 127, '2014-03-01 00:47:20.000000', 'consum', 0.0232, 'lps'),
	(555174, 127, '2014-03-01 00:47:21.000000', 'consum', 0.0237, 'lps'),
	(555175, 127, '2014-03-01 00:47:22.000000', 'consum', 0.0221, 'lps'),
	(555176, 127, '2014-03-01 00:47:23.000000', 'consum', 0.0213, 'lps'),
	(555177, 127, '2014-03-01 00:47:24.000000', 'consum', 0.0221, 'lps'),
	(555178, 127, '2014-03-01 00:47:25.000000', 'consum', 0.0227, 'lps'),
	(555179, 127, '2014-03-01 00:47:26.000000', 'consum', 0.0233, 'lps'),
	(555180, 127, '2014-03-01 00:47:27.000000', 'consum', 0.0216, 'lps'),
	(555181, 127, '2014-03-01 00:47:28.000000', 'consum', 0.0232, 'lps'),
	(555182, 127, '2014-03-01 00:47:29.000000', 'consum', 0.0216, 'lps'),
	(555183, 127, '2014-03-01 00:47:30.000000', 'consum', 0.0229, 'lps'),
	(555184, 127, '2014-03-01 00:47:31.000000', 'consum', 0.0233, 'lps'),
	(555185, 127, '2014-03-01 00:47:32.000000', 'consum', 0.0210, 'lps'),
	(555186, 127, '2014-03-01 00:47:33.000000', 'consum', 0.0230, 'lps'),
	(555187, 127, '2014-03-01 00:47:34.000000', 'consum', 0.0222, 'lps'),
	(555188, 127, '2014-03-01 00:47:35.000000', 'consum', 0.0212, 'lps'),
	(555189, 127, '2014-03-01 00:47:36.000000', 'consum', 0.0212, 'lps'),
	(555190, 127, '2014-03-01 00:47:37.000000', 'consum', 0.0216, 'lps'),
	(555191, 127, '2014-03-01 00:47:38.000000', 'consum', 0.0235, 'lps'),
	(555192, 127, '2014-03-01 00:47:39.000000', 'consum', 0.0229, 'lps'),
	(555193, 127, '2014-03-01 00:47:40.000000', 'consum', 0.0229, 'lps'),
	(555194, 127, '2014-03-01 00:47:41.000000', 'consum', 0.0220, 'lps'),
	(555195, 127, '2014-03-01 00:47:42.000000', 'consum', 0.0234, 'lps'),
	(555196, 127, '2014-03-01 00:47:43.000000', 'consum', 0.0214, 'lps'),
	(555197, 127, '2014-03-01 00:47:44.000000', 'consum', 0.0216, 'lps'),
	(555198, 127, '2014-03-01 00:47:45.000000', 'consum', 0.0226, 'lps'),
	(555199, 127, '2014-03-01 00:47:46.000000', 'consum', 0.0217, 'lps'),
	(555200, 127, '2014-03-01 00:47:47.000000', 'consum', 0.0226, 'lps'),
	(555201, 127, '2014-03-01 00:47:48.000000', 'consum', 0.0211, 'lps'),
	(555202, 127, '2014-03-01 00:47:49.000000', 'consum', 0.0225, 'lps'),
	(555203, 127, '2014-03-01 00:47:50.000000', 'consum', 0.0226, 'lps'),
	(555204, 127, '2014-03-01 00:47:51.000000', 'consum', 0.0217, 'lps'),
	(555205, 127, '2014-03-01 00:47:52.000000', 'consum', 0.0226, 'lps'),
	(555206, 127, '2014-03-01 00:47:53.000000', 'consum', 0.0210, 'lps'),
	(555207, 127, '2014-03-01 00:47:54.000000', 'consum', 0.0223, 'lps'),
	(555208, 127, '2014-03-01 00:47:55.000000', 'consum', 0.0216, 'lps'),
	(555209, 127, '2014-03-01 00:47:56.000000', 'consum', 0.0230, 'lps'),
	(555210, 127, '2014-03-01 00:47:57.000000', 'consum', 0.0236, 'lps'),
	(555211, 127, '2014-03-01 00:47:58.000000', 'consum', 0.0223, 'lps'),
	(555212, 127, '2014-03-01 00:47:59.000000', 'consum', 0.0226, 'lps'),
	(555213, 127, '2014-03-01 00:48:00.000000', 'consum', 0.0224, 'lps'),
	(555214, 127, '2014-03-01 00:48:01.000000', 'consum', 0.0233, 'lps'),
	(555215, 127, '2014-03-01 00:48:02.000000', 'consum', 0.0223, 'lps'),
	(555216, 127, '2014-03-01 00:48:03.000000', 'consum', 0.0236, 'lps'),
	(555217, 127, '2014-03-01 00:48:04.000000', 'consum', 0.0217, 'lps'),
	(555218, 127, '2014-03-01 00:48:05.000000', 'consum', 0.0224, 'lps'),
	(555219, 127, '2014-03-01 00:48:06.000000', 'consum', 0.0229, 'lps'),
	(555220, 127, '2014-03-01 00:48:07.000000', 'consum', 0.0235, 'lps'),
	(555221, 127, '2014-03-01 00:48:08.000000', 'consum', 0.0222, 'lps'),
	(555222, 127, '2014-03-01 00:48:09.000000', 'consum', 0.0223, 'lps'),
	(555223, 127, '2014-03-01 00:48:10.000000', 'consum', 0.0210, 'lps'),
	(555224, 127, '2014-03-01 00:48:11.000000', 'consum', 0.0232, 'lps'),
	(555225, 127, '2014-03-01 00:48:12.000000', 'consum', 0.0231, 'lps'),
	(555226, 127, '2014-03-01 00:48:13.000000', 'consum', 0.0220, 'lps'),
	(555227, 127, '2014-03-01 00:48:14.000000', 'consum', 0.0228, 'lps'),
	(555228, 127, '2014-03-01 00:48:15.000000', 'consum', 0.0211, 'lps'),
	(555229, 127, '2014-03-01 00:48:16.000000', 'consum', 0.0220, 'lps'),
	(555230, 127, '2014-03-01 00:48:17.000000', 'consum', 0.0227, 'lps'),
	(555231, 127, '2014-03-01 00:48:18.000000', 'consum', 0.0238, 'lps'),
	(555232, 127, '2014-03-01 00:48:19.000000', 'consum', 0.0211, 'lps'),
	(555233, 127, '2014-03-01 00:48:20.000000', 'consum', 0.0217, 'lps'),
	(555234, 127, '2014-03-01 00:48:21.000000', 'consum', 0.0217, 'lps'),
	(555235, 127, '2014-03-01 00:48:22.000000', 'consum', 0.0224, 'lps'),
	(555236, 127, '2014-03-01 00:48:23.000000', 'consum', 0.0228, 'lps'),
	(555237, 127, '2014-03-01 00:48:24.000000', 'consum', 0.0230, 'lps'),
	(555238, 127, '2014-03-01 00:48:25.000000', 'consum', 0.0230, 'lps'),
	(555239, 127, '2014-03-01 00:48:26.000000', 'consum', 0.0221, 'lps'),
	(555240, 127, '2014-03-01 00:48:27.000000', 'consum', 0.0234, 'lps'),
	(555241, 127, '2014-03-01 00:48:28.000000', 'consum', 0.0211, 'lps'),
	(555242, 127, '2014-03-01 00:48:29.000000', 'consum', 0.0231, 'lps'),
	(555243, 127, '2014-03-01 00:48:30.000000', 'consum', 0.0224, 'lps'),
	(555244, 127, '2014-03-01 00:48:31.000000', 'consum', 0.0219, 'lps'),
	(555245, 127, '2014-03-01 00:48:32.000000', 'consum', 0.0211, 'lps'),
	(555246, 127, '2014-03-01 00:48:33.000000', 'consum', 0.0218, 'lps'),
	(555247, 127, '2014-03-01 00:48:34.000000', 'consum', 0.0219, 'lps'),
	(555248, 127, '2014-03-01 00:48:35.000000', 'consum', 0.0233, 'lps'),
	(555249, 127, '2014-03-01 00:48:36.000000', 'consum', 0.0212, 'lps'),
	(555250, 127, '2014-03-01 00:48:37.000000', 'consum', 0.0210, 'lps'),
	(555251, 127, '2014-03-01 00:48:38.000000', 'consum', 0.0231, 'lps'),
	(555252, 127, '2014-03-01 00:48:39.000000', 'consum', 0.0228, 'lps'),
	(555253, 127, '2014-03-01 00:48:40.000000', 'consum', 0.0210, 'lps'),
	(555254, 127, '2014-03-01 00:48:41.000000', 'consum', 0.0212, 'lps'),
	(555255, 127, '2014-03-01 00:48:42.000000', 'consum', 0.0223, 'lps'),
	(555256, 127, '2014-03-01 00:48:43.000000', 'consum', 0.0213, 'lps'),
	(555257, 127, '2014-03-01 00:48:44.000000', 'consum', 0.0213, 'lps'),
	(555258, 127, '2014-03-01 00:48:45.000000', 'consum', 0.0215, 'lps'),
	(555259, 127, '2014-03-01 00:48:46.000000', 'consum', 0.0230, 'lps'),
	(555260, 127, '2014-03-01 00:48:47.000000', 'consum', 0.0234, 'lps'),
	(555261, 127, '2014-03-01 00:48:48.000000', 'consum', 0.0216, 'lps'),
	(555262, 127, '2014-03-01 00:48:49.000000', 'consum', 0.0225, 'lps'),
	(555263, 127, '2014-03-01 00:48:50.000000', 'consum', 0.0210, 'lps'),
	(555264, 127, '2014-03-01 00:48:51.000000', 'consum', 0.0225, 'lps'),
	(555265, 127, '2014-03-01 00:48:52.000000', 'consum', 0.0225, 'lps'),
	(555266, 127, '2014-03-01 00:48:53.000000', 'consum', 0.0213, 'lps'),
	(555267, 127, '2014-03-01 00:48:54.000000', 'consum', 0.0211, 'lps'),
	(555268, 127, '2014-03-01 00:48:55.000000', 'consum', 0.0234, 'lps'),
	(555269, 127, '2014-03-01 00:48:56.000000', 'consum', 0.0213, 'lps'),
	(555270, 127, '2014-03-01 00:48:57.000000', 'consum', 0.0238, 'lps'),
	(555271, 127, '2014-03-01 00:48:58.000000', 'consum', 0.0227, 'lps'),
	(555272, 127, '2014-03-01 00:48:59.000000', 'consum', 0.0210, 'lps'),
	(555273, 127, '2014-03-01 00:49:00.000000', 'consum', 0.0220, 'lps'),
	(555274, 127, '2014-03-01 00:49:01.000000', 'consum', 0.0231, 'lps'),
	(555275, 127, '2014-03-01 00:49:02.000000', 'consum', 0.0225, 'lps'),
	(555276, 127, '2014-03-01 00:49:03.000000', 'consum', 0.0224, 'lps'),
	(555277, 127, '2014-03-01 00:49:04.000000', 'consum', 0.0236, 'lps'),
	(555278, 127, '2014-03-01 00:49:05.000000', 'consum', 0.0238, 'lps'),
	(555279, 127, '2014-03-01 00:49:06.000000', 'consum', 0.0217, 'lps'),
	(555280, 127, '2014-03-01 00:49:07.000000', 'consum', 0.0219, 'lps'),
	(555281, 127, '2014-03-01 00:49:08.000000', 'consum', 0.0234, 'lps'),
	(555282, 127, '2014-03-01 00:49:09.000000', 'consum', 0.0216, 'lps'),
	(555283, 127, '2014-03-01 00:49:10.000000', 'consum', 0.0225, 'lps'),
	(555284, 127, '2014-03-01 00:49:11.000000', 'consum', 0.0212, 'lps'),
	(555285, 127, '2014-03-01 00:49:12.000000', 'consum', 0.0235, 'lps'),
	(555286, 127, '2014-03-01 00:49:13.000000', 'consum', 0.0211, 'lps'),
	(555287, 127, '2014-03-01 00:49:14.000000', 'consum', 0.0229, 'lps'),
	(555288, 127, '2014-03-01 00:49:15.000000', 'consum', 0.0214, 'lps'),
	(555289, 127, '2014-03-01 00:49:16.000000', 'consum', 0.0234, 'lps'),
	(555290, 127, '2014-03-01 00:49:17.000000', 'consum', 0.0229, 'lps'),
	(555291, 127, '2014-03-01 00:49:18.000000', 'consum', 0.0235, 'lps'),
	(555292, 127, '2014-03-01 00:49:19.000000', 'consum', 0.0218, 'lps'),
	(555293, 127, '2014-03-01 00:49:20.000000', 'consum', 0.0236, 'lps'),
	(555294, 127, '2014-03-01 00:49:21.000000', 'consum', 0.0230, 'lps'),
	(555295, 127, '2014-03-01 00:49:22.000000', 'consum', 0.0232, 'lps'),
	(555296, 127, '2014-03-01 00:49:23.000000', 'consum', 0.0232, 'lps'),
	(555297, 127, '2014-03-01 00:49:24.000000', 'consum', 0.0227, 'lps'),
	(555298, 127, '2014-03-01 00:49:25.000000', 'consum', 0.0228, 'lps'),
	(555299, 127, '2014-03-01 00:49:26.000000', 'consum', 0.0220, 'lps'),
	(555300, 127, '2014-03-01 00:49:27.000000', 'consum', 0.0237, 'lps'),
	(555301, 127, '2014-03-01 00:49:28.000000', 'consum', 0.0226, 'lps'),
	(555302, 127, '2014-03-01 00:49:29.000000', 'consum', 0.0212, 'lps'),
	(555303, 127, '2014-03-01 00:49:30.000000', 'consum', 0.0231, 'lps'),
	(555304, 127, '2014-03-01 00:49:31.000000', 'consum', 0.0220, 'lps'),
	(555305, 127, '2014-03-01 00:49:32.000000', 'consum', 0.0227, 'lps'),
	(555306, 127, '2014-03-01 00:49:33.000000', 'consum', 0.0235, 'lps'),
	(555307, 127, '2014-03-01 00:49:34.000000', 'consum', 0.0229, 'lps'),
	(555308, 127, '2014-03-01 00:49:35.000000', 'consum', 0.0230, 'lps'),
	(555309, 127, '2014-03-01 00:49:36.000000', 'consum', 0.0225, 'lps'),
	(555310, 127, '2014-03-01 00:49:37.000000', 'consum', 0.0223, 'lps'),
	(555311, 127, '2014-03-01 00:49:38.000000', 'consum', 0.0232, 'lps'),
	(555312, 127, '2014-03-01 00:49:39.000000', 'consum', 0.0221, 'lps'),
	(555313, 127, '2014-03-01 00:49:40.000000', 'consum', 0.0231, 'lps'),
	(555314, 127, '2014-03-01 00:49:41.000000', 'consum', 0.0226, 'lps'),
	(555315, 127, '2014-03-01 00:49:42.000000', 'consum', 0.0226, 'lps'),
	(555316, 127, '2014-03-01 00:49:43.000000', 'consum', 0.0212, 'lps'),
	(555317, 127, '2014-03-01 00:49:44.000000', 'consum', 0.0233, 'lps'),
	(555318, 127, '2014-03-01 00:49:45.000000', 'consum', 0.0230, 'lps'),
	(555319, 127, '2014-03-01 00:49:46.000000', 'consum', 0.0212, 'lps'),
	(555320, 127, '2014-03-01 00:49:47.000000', 'consum', 0.0217, 'lps'),
	(555321, 127, '2014-03-01 00:49:48.000000', 'consum', 0.0214, 'lps'),
	(555322, 127, '2014-03-01 00:49:49.000000', 'consum', 0.0238, 'lps'),
	(555323, 127, '2014-03-01 00:49:50.000000', 'consum', 0.0223, 'lps'),
	(555324, 127, '2014-03-01 00:49:51.000000', 'consum', 0.0219, 'lps'),
	(555325, 127, '2014-03-01 00:49:52.000000', 'consum', 0.0215, 'lps'),
	(555326, 127, '2014-03-01 00:49:53.000000', 'consum', 0.0210, 'lps'),
	(555327, 127, '2014-03-01 00:49:54.000000', 'consum', 0.0224, 'lps'),
	(555328, 127, '2014-03-01 00:49:55.000000', 'consum', 0.0221, 'lps'),
	(555329, 127, '2014-03-01 00:49:56.000000', 'consum', 0.0224, 'lps'),
	(555330, 127, '2014-03-01 00:49:57.000000', 'consum', 0.0221, 'lps'),
	(555331, 127, '2014-03-01 00:49:58.000000', 'consum', 0.0223, 'lps'),
	(555332, 127, '2014-03-01 00:49:59.000000', 'consum', 0.0213, 'lps'),
	(555333, 127, '2014-03-01 00:50:00.000000', 'consum', 0.0214, 'lps'),
	(555334, 127, '2014-03-01 00:50:01.000000', 'consum', 0.0222, 'lps'),
	(555335, 127, '2014-03-01 00:50:02.000000', 'consum', 0.0228, 'lps'),
	(555336, 127, '2014-03-01 00:50:03.000000', 'consum', 0.0237, 'lps'),
	(555337, 127, '2014-03-01 00:50:04.000000', 'consum', 0.0235, 'lps'),
	(555338, 127, '2014-03-01 00:50:05.000000', 'consum', 0.0223, 'lps'),
	(555339, 127, '2014-03-01 00:50:06.000000', 'consum', 0.0231, 'lps'),
	(555340, 127, '2014-03-01 00:50:07.000000', 'consum', 0.0218, 'lps'),
	(555341, 127, '2014-03-01 00:50:08.000000', 'consum', 0.0217, 'lps'),
	(555342, 127, '2014-03-01 00:50:09.000000', 'consum', 0.0222, 'lps'),
	(555343, 127, '2014-03-01 00:50:10.000000', 'consum', 0.0220, 'lps'),
	(555344, 127, '2014-03-01 00:50:11.000000', 'consum', 0.0223, 'lps'),
	(555345, 127, '2014-03-01 00:50:12.000000', 'consum', 0.0216, 'lps'),
	(555346, 127, '2014-03-01 00:50:13.000000', 'consum', 0.0230, 'lps'),
	(555347, 127, '2014-03-01 00:50:14.000000', 'consum', 0.0236, 'lps'),
	(555348, 127, '2014-03-01 00:50:15.000000', 'consum', 0.0223, 'lps'),
	(555349, 127, '2014-03-01 00:50:16.000000', 'consum', 0.0225, 'lps'),
	(555350, 127, '2014-03-01 00:50:17.000000', 'consum', 0.0219, 'lps'),
	(555351, 127, '2014-03-01 00:50:18.000000', 'consum', 0.0238, 'lps'),
	(555352, 127, '2014-03-01 00:50:19.000000', 'consum', 0.0238, 'lps'),
	(555353, 127, '2014-03-01 00:50:20.000000', 'consum', 0.0236, 'lps'),
	(555354, 127, '2014-03-01 00:50:21.000000', 'consum', 0.0228, 'lps'),
	(555355, 127, '2014-03-01 00:50:22.000000', 'consum', 0.0225, 'lps'),
	(555356, 127, '2014-03-01 00:50:23.000000', 'consum', 0.0228, 'lps'),
	(555357, 127, '2014-03-01 00:50:24.000000', 'consum', 0.0228, 'lps'),
	(555358, 127, '2014-03-01 00:50:25.000000', 'consum', 0.0217, 'lps'),
	(555359, 127, '2014-03-01 00:50:26.000000', 'consum', 0.0219, 'lps'),
	(555360, 127, '2014-03-01 00:50:27.000000', 'consum', 0.0237, 'lps'),
	(555361, 127, '2014-03-01 00:50:28.000000', 'consum', 0.0232, 'lps'),
	(555362, 127, '2014-03-01 00:50:29.000000', 'consum', 0.0237, 'lps'),
	(555363, 127, '2014-03-01 00:50:30.000000', 'consum', 0.0222, 'lps'),
	(555364, 127, '2014-03-01 00:50:31.000000', 'consum', 0.0220, 'lps'),
	(555365, 127, '2014-03-01 00:50:32.000000', 'consum', 0.0224, 'lps'),
	(555366, 127, '2014-03-01 00:50:33.000000', 'consum', 0.0220, 'lps'),
	(555367, 127, '2014-03-01 00:50:34.000000', 'consum', 0.0221, 'lps'),
	(555368, 127, '2014-03-01 00:50:35.000000', 'consum', 0.0234, 'lps'),
	(555369, 127, '2014-03-01 00:50:36.000000', 'consum', 0.0211, 'lps'),
	(555370, 127, '2014-03-01 00:50:37.000000', 'consum', 0.0232, 'lps'),
	(555371, 127, '2014-03-01 00:50:38.000000', 'consum', 0.0228, 'lps'),
	(555372, 127, '2014-03-01 00:50:39.000000', 'consum', 0.0234, 'lps'),
	(555373, 127, '2014-03-01 00:50:40.000000', 'consum', 0.0220, 'lps'),
	(555374, 127, '2014-03-01 00:50:41.000000', 'consum', 0.0218, 'lps'),
	(555375, 127, '2014-03-01 00:50:42.000000', 'consum', 0.0221, 'lps'),
	(555376, 127, '2014-03-01 00:50:43.000000', 'consum', 0.0210, 'lps'),
	(555377, 127, '2014-03-01 00:50:44.000000', 'consum', 0.0236, 'lps'),
	(555378, 127, '2014-03-01 00:50:45.000000', 'consum', 0.0225, 'lps'),
	(555379, 127, '2014-03-01 00:50:46.000000', 'consum', 0.0236, 'lps'),
	(555380, 127, '2014-03-01 00:50:47.000000', 'consum', 0.0211, 'lps'),
	(555381, 127, '2014-03-01 00:50:48.000000', 'consum', 0.0222, 'lps'),
	(555382, 127, '2014-03-01 00:50:49.000000', 'consum', 0.0210, 'lps'),
	(555383, 127, '2014-03-01 00:50:50.000000', 'consum', 0.0232, 'lps'),
	(555384, 127, '2014-03-01 00:50:51.000000', 'consum', 0.0235, 'lps'),
	(555385, 127, '2014-03-01 00:50:52.000000', 'consum', 0.0210, 'lps'),
	(555386, 127, '2014-03-01 00:50:53.000000', 'consum', 0.0223, 'lps'),
	(555387, 127, '2014-03-01 00:50:54.000000', 'consum', 0.0218, 'lps'),
	(555388, 127, '2014-03-01 00:50:55.000000', 'consum', 0.0211, 'lps'),
	(555389, 127, '2014-03-01 00:50:56.000000', 'consum', 0.0222, 'lps'),
	(555390, 127, '2014-03-01 00:50:57.000000', 'consum', 0.0238, 'lps'),
	(555391, 127, '2014-03-01 00:50:58.000000', 'consum', 0.0225, 'lps'),
	(555392, 127, '2014-03-01 00:50:59.000000', 'consum', 0.0232, 'lps'),
	(555393, 127, '2014-03-01 00:51:00.000000', 'consum', 0.0219, 'lps'),
	(555394, 127, '2014-03-01 00:51:01.000000', 'consum', 0.0216, 'lps'),
	(555395, 127, '2014-03-01 00:51:02.000000', 'consum', 0.0213, 'lps'),
	(555396, 127, '2014-03-01 00:51:03.000000', 'consum', 0.0238, 'lps'),
	(555397, 127, '2014-03-01 00:51:04.000000', 'consum', 0.0226, 'lps'),
	(555398, 127, '2014-03-01 00:51:05.000000', 'consum', 0.0236, 'lps'),
	(555399, 127, '2014-03-01 00:51:06.000000', 'consum', 0.0234, 'lps'),
	(555400, 127, '2014-03-01 00:51:07.000000', 'consum', 0.0223, 'lps'),
	(555401, 127, '2014-03-01 00:51:08.000000', 'consum', 0.0234, 'lps'),
	(555402, 127, '2014-03-01 00:51:09.000000', 'consum', 0.0235, 'lps'),
	(555403, 127, '2014-03-01 00:51:10.000000', 'consum', 0.0231, 'lps'),
	(555404, 127, '2014-03-01 00:51:11.000000', 'consum', 0.0214, 'lps'),
	(555405, 127, '2014-03-01 00:51:12.000000', 'consum', 0.0224, 'lps'),
	(555406, 127, '2014-03-01 00:51:13.000000', 'consum', 0.0211, 'lps'),
	(555407, 127, '2014-03-01 00:51:14.000000', 'consum', 0.0230, 'lps'),
	(555408, 127, '2014-03-01 00:51:15.000000', 'consum', 0.0220, 'lps'),
	(555409, 127, '2014-03-01 00:51:16.000000', 'consum', 0.0232, 'lps'),
	(555410, 127, '2014-03-01 00:51:17.000000', 'consum', 0.0232, 'lps'),
	(555411, 127, '2014-03-01 00:51:18.000000', 'consum', 0.0227, 'lps'),
	(555412, 127, '2014-03-01 00:51:19.000000', 'consum', 0.0228, 'lps'),
	(555413, 127, '2014-03-01 00:51:20.000000', 'consum', 0.0223, 'lps'),
	(555414, 127, '2014-03-01 00:51:21.000000', 'consum', 0.0218, 'lps'),
	(555415, 127, '2014-03-01 00:51:22.000000', 'consum', 0.0214, 'lps'),
	(555416, 127, '2014-03-01 00:51:23.000000', 'consum', 0.0233, 'lps'),
	(555417, 127, '2014-03-01 00:51:24.000000', 'consum', 0.0229, 'lps'),
	(555418, 127, '2014-03-01 00:51:25.000000', 'consum', 0.0236, 'lps'),
	(555419, 127, '2014-03-01 00:51:26.000000', 'consum', 0.0225, 'lps'),
	(555420, 127, '2014-03-01 00:51:27.000000', 'consum', 0.0235, 'lps'),
	(555421, 127, '2014-03-01 00:51:28.000000', 'consum', 0.0234, 'lps'),
	(555422, 127, '2014-03-01 00:51:29.000000', 'consum', 0.0228, 'lps'),
	(555423, 127, '2014-03-01 00:51:30.000000', 'consum', 0.0228, 'lps'),
	(555424, 127, '2014-03-01 00:51:31.000000', 'consum', 0.0215, 'lps'),
	(555425, 127, '2014-03-01 00:51:32.000000', 'consum', 0.0212, 'lps'),
	(555426, 127, '2014-03-01 00:51:33.000000', 'consum', 0.0234, 'lps'),
	(555427, 127, '2014-03-01 00:51:34.000000', 'consum', 0.0210, 'lps'),
	(555428, 127, '2014-03-01 00:51:35.000000', 'consum', 0.0225, 'lps'),
	(555429, 127, '2014-03-01 00:51:36.000000', 'consum', 0.0229, 'lps'),
	(555430, 127, '2014-03-01 00:51:37.000000', 'consum', 0.0229, 'lps'),
	(555431, 127, '2014-03-01 00:51:38.000000', 'consum', 0.0219, 'lps'),
	(555432, 127, '2014-03-01 00:51:39.000000', 'consum', 0.0230, 'lps'),
	(555433, 127, '2014-03-01 00:51:40.000000', 'consum', 0.0224, 'lps'),
	(555434, 127, '2014-03-01 00:51:41.000000', 'consum', 0.0219, 'lps'),
	(555435, 127, '2014-03-01 00:51:42.000000', 'consum', 0.0217, 'lps'),
	(555436, 127, '2014-03-01 00:51:43.000000', 'consum', 0.0215, 'lps'),
	(555437, 127, '2014-03-01 00:51:44.000000', 'consum', 0.0216, 'lps'),
	(555438, 127, '2014-03-01 00:51:45.000000', 'consum', 0.0226, 'lps'),
	(555439, 127, '2014-03-01 00:51:46.000000', 'consum', 0.0216, 'lps'),
	(555440, 127, '2014-03-01 00:51:47.000000', 'consum', 0.0219, 'lps'),
	(555441, 127, '2014-03-01 00:51:48.000000', 'consum', 0.0238, 'lps'),
	(555442, 127, '2014-03-01 00:51:49.000000', 'consum', 0.0238, 'lps'),
	(555443, 127, '2014-03-01 00:51:50.000000', 'consum', 0.0238, 'lps'),
	(555444, 127, '2014-03-01 00:51:51.000000', 'consum', 0.0236, 'lps'),
	(555445, 127, '2014-03-01 00:51:52.000000', 'consum', 0.0227, 'lps'),
	(555446, 127, '2014-03-01 00:51:53.000000', 'consum', 0.0220, 'lps'),
	(555447, 127, '2014-03-01 00:51:54.000000', 'consum', 0.0235, 'lps'),
	(555448, 127, '2014-03-01 00:51:55.000000', 'consum', 0.0222, 'lps'),
	(555449, 127, '2014-03-01 00:51:56.000000', 'consum', 0.0224, 'lps'),
	(555450, 127, '2014-03-01 00:51:57.000000', 'consum', 0.0214, 'lps'),
	(555451, 127, '2014-03-01 00:51:58.000000', 'consum', 0.0218, 'lps'),
	(555452, 127, '2014-03-01 00:51:59.000000', 'consum', 0.0210, 'lps'),
	(555453, 127, '2014-03-01 00:52:00.000000', 'consum', 0.0213, 'lps'),
	(555454, 127, '2014-03-01 00:52:01.000000', 'consum', 0.0229, 'lps'),
	(555455, 127, '2014-03-01 00:52:02.000000', 'consum', 0.0236, 'lps'),
	(555456, 127, '2014-03-01 00:52:03.000000', 'consum', 0.0226, 'lps'),
	(555457, 127, '2014-03-01 00:52:04.000000', 'consum', 0.0214, 'lps'),
	(555458, 127, '2014-03-01 00:52:05.000000', 'consum', 0.0238, 'lps'),
	(555459, 127, '2014-03-01 00:52:06.000000', 'consum', 0.0225, 'lps'),
	(555460, 127, '2014-03-01 00:52:07.000000', 'consum', 0.0228, 'lps'),
	(555461, 127, '2014-03-01 00:52:08.000000', 'consum', 0.0228, 'lps'),
	(555462, 127, '2014-03-01 00:52:09.000000', 'consum', 0.0217, 'lps'),
	(555463, 127, '2014-03-01 00:52:10.000000', 'consum', 0.0221, 'lps'),
	(555464, 127, '2014-03-01 00:52:11.000000', 'consum', 0.0214, 'lps'),
	(555465, 127, '2014-03-01 00:52:12.000000', 'consum', 0.0227, 'lps'),
	(555466, 127, '2014-03-01 00:52:13.000000', 'consum', 0.0224, 'lps'),
	(555467, 127, '2014-03-01 00:52:14.000000', 'consum', 0.0230, 'lps'),
	(555468, 127, '2014-03-01 00:52:15.000000', 'consum', 0.0212, 'lps'),
	(555469, 127, '2014-03-01 00:52:16.000000', 'consum', 0.0217, 'lps'),
	(555470, 127, '2014-03-01 00:52:17.000000', 'consum', 0.0210, 'lps'),
	(555471, 127, '2014-03-01 00:52:18.000000', 'consum', 0.0218, 'lps'),
	(555472, 127, '2014-03-01 00:52:19.000000', 'consum', 0.0221, 'lps'),
	(555473, 127, '2014-03-01 00:52:20.000000', 'consum', 0.0212, 'lps'),
	(555474, 127, '2014-03-01 00:52:21.000000', 'consum', 0.0217, 'lps'),
	(555475, 127, '2014-03-01 00:52:22.000000', 'consum', 0.0212, 'lps'),
	(555476, 127, '2014-03-01 00:52:23.000000', 'consum', 0.0228, 'lps'),
	(555477, 127, '2014-03-01 00:52:24.000000', 'consum', 0.0236, 'lps'),
	(555478, 127, '2014-03-01 00:52:25.000000', 'consum', 0.0227, 'lps'),
	(555479, 127, '2014-03-01 00:52:26.000000', 'consum', 0.0220, 'lps'),
	(555480, 127, '2014-03-01 00:52:27.000000', 'consum', 0.0236, 'lps'),
	(555481, 127, '2014-03-01 00:52:28.000000', 'consum', 0.0226, 'lps'),
	(555482, 127, '2014-03-01 00:52:29.000000', 'consum', 0.0211, 'lps'),
	(555483, 127, '2014-03-01 00:52:30.000000', 'consum', 0.0227, 'lps'),
	(555484, 127, '2014-03-01 00:52:31.000000', 'consum', 0.0235, 'lps'),
	(555485, 127, '2014-03-01 00:52:32.000000', 'consum', 0.0224, 'lps'),
	(555486, 127, '2014-03-01 00:52:33.000000', 'consum', 0.0235, 'lps'),
	(555487, 127, '2014-03-01 00:52:34.000000', 'consum', 0.0236, 'lps'),
	(555488, 127, '2014-03-01 00:52:35.000000', 'consum', 0.0235, 'lps'),
	(555489, 127, '2014-03-01 00:52:36.000000', 'consum', 0.0229, 'lps'),
	(555490, 127, '2014-03-01 00:52:37.000000', 'consum', 0.0231, 'lps'),
	(555491, 127, '2014-03-01 00:52:38.000000', 'consum', 0.0228, 'lps'),
	(555492, 127, '2014-03-01 00:52:39.000000', 'consum', 0.0238, 'lps'),
	(555493, 127, '2014-03-01 00:52:40.000000', 'consum', 0.0237, 'lps'),
	(555494, 127, '2014-03-01 00:52:41.000000', 'consum', 0.0236, 'lps'),
	(555495, 127, '2014-03-01 00:52:42.000000', 'consum', 0.0228, 'lps'),
	(555496, 127, '2014-03-01 00:52:43.000000', 'consum', 0.0222, 'lps'),
	(555497, 127, '2014-03-01 00:52:44.000000', 'consum', 0.0216, 'lps'),
	(555498, 127, '2014-03-01 00:52:45.000000', 'consum', 0.0236, 'lps'),
	(555499, 127, '2014-03-01 00:52:46.000000', 'consum', 0.0233, 'lps'),
	(555500, 127, '2014-03-01 00:52:47.000000', 'consum', 0.0221, 'lps'),
	(555501, 127, '2014-03-01 00:52:48.000000', 'consum', 0.0225, 'lps'),
	(555502, 127, '2014-03-01 00:52:49.000000', 'consum', 0.0221, 'lps'),
	(555503, 127, '2014-03-01 00:52:50.000000', 'consum', 0.0224, 'lps'),
	(555504, 127, '2014-03-01 00:52:51.000000', 'consum', 0.0217, 'lps'),
	(555505, 127, '2014-03-01 00:52:52.000000', 'consum', 0.0233, 'lps'),
	(555506, 127, '2014-03-01 00:52:53.000000', 'consum', 0.0215, 'lps'),
	(555507, 127, '2014-03-01 00:52:54.000000', 'consum', 0.0228, 'lps'),
	(555508, 127, '2014-03-01 00:52:55.000000', 'consum', 0.0225, 'lps'),
	(555509, 127, '2014-03-01 00:52:56.000000', 'consum', 0.0231, 'lps'),
	(555510, 127, '2014-03-01 00:52:57.000000', 'consum', 0.0215, 'lps'),
	(555511, 127, '2014-03-01 00:52:58.000000', 'consum', 0.0231, 'lps'),
	(555512, 127, '2014-03-01 00:52:59.000000', 'consum', 0.0214, 'lps'),
	(555513, 127, '2014-03-01 00:53:00.000000', 'consum', 0.0225, 'lps'),
	(555514, 127, '2014-03-01 00:53:01.000000', 'consum', 0.0213, 'lps'),
	(555515, 127, '2014-03-01 00:53:02.000000', 'consum', 0.0211, 'lps'),
	(555516, 127, '2014-03-01 00:53:03.000000', 'consum', 0.0236, 'lps'),
	(555517, 127, '2014-03-01 00:53:04.000000', 'consum', 0.0223, 'lps'),
	(555518, 127, '2014-03-01 00:53:05.000000', 'consum', 0.0225, 'lps'),
	(555519, 127, '2014-03-01 00:53:06.000000', 'consum', 0.0220, 'lps'),
	(555520, 127, '2014-03-01 00:53:07.000000', 'consum', 0.0212, 'lps'),
	(555521, 127, '2014-03-01 00:53:08.000000', 'consum', 0.0221, 'lps'),
	(555522, 127, '2014-03-01 00:53:09.000000', 'consum', 0.0230, 'lps'),
	(555523, 127, '2014-03-01 00:53:10.000000', 'consum', 0.0222, 'lps'),
	(555524, 127, '2014-03-01 00:53:11.000000', 'consum', 0.0237, 'lps'),
	(555525, 127, '2014-03-01 00:53:12.000000', 'consum', 0.0225, 'lps'),
	(555526, 127, '2014-03-01 00:53:13.000000', 'consum', 0.0233, 'lps'),
	(555527, 127, '2014-03-01 00:53:14.000000', 'consum', 0.0221, 'lps'),
	(555528, 127, '2014-03-01 00:53:15.000000', 'consum', 0.0225, 'lps'),
	(555529, 127, '2014-03-01 00:53:16.000000', 'consum', 0.0225, 'lps'),
	(555530, 127, '2014-03-01 00:53:17.000000', 'consum', 0.0212, 'lps'),
	(555531, 127, '2014-03-01 00:53:18.000000', 'consum', 0.0234, 'lps'),
	(555532, 127, '2014-03-01 00:53:19.000000', 'consum', 0.0235, 'lps'),
	(555533, 127, '2014-03-01 00:53:20.000000', 'consum', 0.0236, 'lps'),
	(555534, 127, '2014-03-01 00:53:21.000000', 'consum', 0.0234, 'lps'),
	(555535, 127, '2014-03-01 00:53:22.000000', 'consum', 0.0226, 'lps'),
	(555536, 127, '2014-03-01 00:53:23.000000', 'consum', 0.0216, 'lps'),
	(555537, 127, '2014-03-01 00:53:24.000000', 'consum', 0.0223, 'lps'),
	(555538, 127, '2014-03-01 00:53:25.000000', 'consum', 0.0230, 'lps'),
	(555539, 127, '2014-03-01 00:53:26.000000', 'consum', 0.0212, 'lps'),
	(555540, 127, '2014-03-01 00:53:27.000000', 'consum', 0.0217, 'lps'),
	(555541, 127, '2014-03-01 00:53:28.000000', 'consum', 0.0211, 'lps'),
	(555542, 127, '2014-03-01 00:53:29.000000', 'consum', 0.0223, 'lps'),
	(555543, 127, '2014-03-01 00:53:30.000000', 'consum', 0.0217, 'lps'),
	(555544, 127, '2014-03-01 00:53:31.000000', 'consum', 0.0232, 'lps'),
	(555545, 127, '2014-03-01 00:53:32.000000', 'consum', 0.0215, 'lps'),
	(555546, 127, '2014-03-01 00:53:33.000000', 'consum', 0.0226, 'lps'),
	(555547, 127, '2014-03-01 00:53:34.000000', 'consum', 0.0220, 'lps'),
	(555548, 127, '2014-03-01 00:53:35.000000', 'consum', 0.0211, 'lps'),
	(555549, 127, '2014-03-01 00:53:36.000000', 'consum', 0.0215, 'lps'),
	(555550, 127, '2014-03-01 00:53:37.000000', 'consum', 0.0232, 'lps'),
	(555551, 127, '2014-03-01 00:53:38.000000', 'consum', 0.0219, 'lps'),
	(555552, 127, '2014-03-01 00:53:39.000000', 'consum', 0.0218, 'lps'),
	(555553, 127, '2014-03-01 00:53:40.000000', 'consum', 0.0225, 'lps'),
	(555554, 127, '2014-03-01 00:53:41.000000', 'consum', 0.0231, 'lps'),
	(555555, 127, '2014-03-01 00:53:42.000000', 'consum', 0.0215, 'lps'),
	(555556, 127, '2014-03-01 00:53:43.000000', 'consum', 0.0228, 'lps'),
	(555557, 127, '2014-03-01 00:53:44.000000', 'consum', 0.0226, 'lps'),
	(555558, 127, '2014-03-01 00:53:45.000000', 'consum', 0.0210, 'lps'),
	(555559, 127, '2014-03-01 00:53:46.000000', 'consum', 0.0221, 'lps'),
	(555560, 127, '2014-03-01 00:53:47.000000', 'consum', 0.0234, 'lps'),
	(555561, 127, '2014-03-01 00:53:48.000000', 'consum', 0.0213, 'lps'),
	(555562, 127, '2014-03-01 00:53:49.000000', 'consum', 0.0238, 'lps'),
	(555563, 127, '2014-03-01 00:53:50.000000', 'consum', 0.0225, 'lps'),
	(555564, 127, '2014-03-01 00:53:51.000000', 'consum', 0.0233, 'lps'),
	(555565, 127, '2014-03-01 00:53:52.000000', 'consum', 0.0221, 'lps'),
	(555566, 127, '2014-03-01 00:53:53.000000', 'consum', 0.0226, 'lps'),
	(555567, 127, '2014-03-01 00:53:54.000000', 'consum', 0.0227, 'lps'),
	(555568, 127, '2014-03-01 00:53:55.000000', 'consum', 0.0218, 'lps'),
	(555569, 127, '2014-03-01 00:53:56.000000', 'consum', 0.0229, 'lps'),
	(555570, 127, '2014-03-01 00:53:57.000000', 'consum', 0.0223, 'lps'),
	(555571, 127, '2014-03-01 00:53:58.000000', 'consum', 0.0219, 'lps'),
	(555572, 127, '2014-03-01 00:53:59.000000', 'consum', 0.0214, 'lps'),
	(555573, 127, '2014-03-01 00:54:00.000000', 'consum', 0.0236, 'lps'),
	(555574, 127, '2014-03-01 00:54:01.000000', 'consum', 0.0213, 'lps'),
	(555575, 127, '2014-03-01 00:54:02.000000', 'consum', 0.0234, 'lps'),
	(555576, 127, '2014-03-01 00:54:03.000000', 'consum', 0.0234, 'lps'),
	(555577, 127, '2014-03-01 00:54:04.000000', 'consum', 0.0227, 'lps'),
	(555578, 127, '2014-03-01 00:54:05.000000', 'consum', 0.0227, 'lps'),
	(555579, 127, '2014-03-01 00:54:06.000000', 'consum', 0.0216, 'lps'),
	(555580, 127, '2014-03-01 00:54:07.000000', 'consum', 0.0215, 'lps'),
	(555581, 127, '2014-03-01 00:54:08.000000', 'consum', 0.0221, 'lps'),
	(555582, 127, '2014-03-01 00:54:09.000000', 'consum', 0.0218, 'lps'),
	(555583, 127, '2014-03-01 00:54:10.000000', 'consum', 0.0220, 'lps'),
	(555584, 127, '2014-03-01 00:54:11.000000', 'consum', 0.0238, 'lps'),
	(555585, 127, '2014-03-01 00:54:12.000000', 'consum', 0.0231, 'lps'),
	(555586, 127, '2014-03-01 00:54:13.000000', 'consum', 0.0234, 'lps'),
	(555587, 127, '2014-03-01 00:54:14.000000', 'consum', 0.0235, 'lps'),
	(555588, 127, '2014-03-01 00:54:15.000000', 'consum', 0.0238, 'lps'),
	(555589, 127, '2014-03-01 00:54:16.000000', 'consum', 0.0216, 'lps'),
	(555590, 127, '2014-03-01 00:54:17.000000', 'consum', 0.0215, 'lps'),
	(555591, 127, '2014-03-01 00:54:18.000000', 'consum', 0.0216, 'lps'),
	(555592, 127, '2014-03-01 00:54:19.000000', 'consum', 0.0226, 'lps'),
	(555593, 127, '2014-03-01 00:54:20.000000', 'consum', 0.0214, 'lps'),
	(555594, 127, '2014-03-01 00:54:21.000000', 'consum', 0.0211, 'lps'),
	(555595, 127, '2014-03-01 00:54:22.000000', 'consum', 0.0233, 'lps'),
	(555596, 127, '2014-03-01 00:54:23.000000', 'consum', 0.0237, 'lps'),
	(555597, 127, '2014-03-01 00:54:24.000000', 'consum', 0.0219, 'lps'),
	(555598, 127, '2014-03-01 00:54:25.000000', 'consum', 0.0232, 'lps'),
	(555599, 127, '2014-03-01 00:54:26.000000', 'consum', 0.0236, 'lps'),
	(555600, 127, '2014-03-01 00:54:27.000000', 'consum', 0.0216, 'lps'),
	(555601, 127, '2014-03-01 00:54:28.000000', 'consum', 0.0221, 'lps'),
	(555602, 127, '2014-03-01 00:54:29.000000', 'consum', 0.0218, 'lps'),
	(555603, 127, '2014-03-01 00:54:30.000000', 'consum', 0.0216, 'lps'),
	(555604, 127, '2014-03-01 00:54:31.000000', 'consum', 0.0216, 'lps'),
	(555605, 127, '2014-03-01 00:54:32.000000', 'consum', 0.0225, 'lps'),
	(555606, 127, '2014-03-01 00:54:33.000000', 'consum', 0.0237, 'lps'),
	(555607, 127, '2014-03-01 00:54:34.000000', 'consum', 0.0215, 'lps'),
	(555608, 127, '2014-03-01 00:54:35.000000', 'consum', 0.0211, 'lps'),
	(555609, 127, '2014-03-01 00:54:36.000000', 'consum', 0.0229, 'lps'),
	(555610, 127, '2014-03-01 00:54:37.000000', 'consum', 0.0217, 'lps'),
	(555611, 127, '2014-03-01 00:54:38.000000', 'consum', 0.0218, 'lps'),
	(555612, 127, '2014-03-01 00:54:39.000000', 'consum', 0.0229, 'lps'),
	(555613, 127, '2014-03-01 00:54:40.000000', 'consum', 0.0222, 'lps'),
	(555614, 127, '2014-03-01 00:54:41.000000', 'consum', 0.0213, 'lps'),
	(555615, 127, '2014-03-01 00:54:42.000000', 'consum', 0.0221, 'lps'),
	(555616, 127, '2014-03-01 00:54:43.000000', 'consum', 0.0227, 'lps'),
	(555617, 127, '2014-03-01 00:54:44.000000', 'consum', 0.0232, 'lps'),
	(555618, 127, '2014-03-01 00:54:45.000000', 'consum', 0.0213, 'lps'),
	(555619, 127, '2014-03-01 00:54:46.000000', 'consum', 0.0216, 'lps'),
	(555620, 127, '2014-03-01 00:54:47.000000', 'consum', 0.0234, 'lps'),
	(555621, 127, '2014-03-01 00:54:48.000000', 'consum', 0.0222, 'lps'),
	(555622, 127, '2014-03-01 00:54:49.000000', 'consum', 0.0230, 'lps'),
	(555623, 127, '2014-03-01 00:54:50.000000', 'consum', 0.0218, 'lps'),
	(555624, 127, '2014-03-01 00:54:51.000000', 'consum', 0.0216, 'lps'),
	(555625, 127, '2014-03-01 00:54:52.000000', 'consum', 0.0217, 'lps'),
	(555626, 127, '2014-03-01 00:54:53.000000', 'consum', 0.0230, 'lps'),
	(555627, 127, '2014-03-01 00:54:54.000000', 'consum', 0.0231, 'lps'),
	(555628, 127, '2014-03-01 00:54:55.000000', 'consum', 0.0224, 'lps'),
	(555629, 127, '2014-03-01 00:54:56.000000', 'consum', 0.0220, 'lps'),
	(555630, 127, '2014-03-01 00:54:57.000000', 'consum', 0.0218, 'lps'),
	(555631, 127, '2014-03-01 00:54:58.000000', 'consum', 0.0222, 'lps'),
	(555632, 127, '2014-03-01 00:54:59.000000', 'consum', 0.0214, 'lps'),
	(555633, 127, '2014-03-01 00:55:00.000000', 'consum', 0.0226, 'lps'),
	(555634, 127, '2014-03-01 00:55:01.000000', 'consum', 0.0222, 'lps'),
	(555635, 127, '2014-03-01 00:55:02.000000', 'consum', 0.0220, 'lps'),
	(555636, 127, '2014-03-01 00:55:03.000000', 'consum', 0.0227, 'lps'),
	(555637, 127, '2014-03-01 00:55:04.000000', 'consum', 0.0233, 'lps'),
	(555638, 127, '2014-03-01 00:55:05.000000', 'consum', 0.0219, 'lps'),
	(555639, 127, '2014-03-01 00:55:06.000000', 'consum', 0.0214, 'lps'),
	(555640, 127, '2014-03-01 00:55:07.000000', 'consum', 0.0232, 'lps'),
	(555641, 127, '2014-03-01 00:55:08.000000', 'consum', 0.0223, 'lps'),
	(555642, 127, '2014-03-01 00:55:09.000000', 'consum', 0.0210, 'lps'),
	(555643, 127, '2014-03-01 00:55:10.000000', 'consum', 0.0230, 'lps'),
	(555644, 127, '2014-03-01 00:55:11.000000', 'consum', 0.0222, 'lps'),
	(555645, 127, '2014-03-01 00:55:12.000000', 'consum', 0.0213, 'lps'),
	(555646, 127, '2014-03-01 00:55:13.000000', 'consum', 0.0217, 'lps'),
	(555647, 127, '2014-03-01 00:55:14.000000', 'consum', 0.0237, 'lps'),
	(555648, 127, '2014-03-01 00:55:15.000000', 'consum', 0.0236, 'lps'),
	(555649, 127, '2014-03-01 00:55:16.000000', 'consum', 0.0232, 'lps'),
	(555650, 127, '2014-03-01 00:55:17.000000', 'consum', 0.0211, 'lps'),
	(555651, 127, '2014-03-01 00:55:18.000000', 'consum', 0.0238, 'lps'),
	(555652, 127, '2014-03-01 00:55:19.000000', 'consum', 0.0232, 'lps'),
	(555653, 127, '2014-03-01 00:55:20.000000', 'consum', 0.0235, 'lps'),
	(555654, 127, '2014-03-01 00:55:21.000000', 'consum', 0.0213, 'lps'),
	(555655, 127, '2014-03-01 00:55:22.000000', 'consum', 0.0238, 'lps'),
	(555656, 127, '2014-03-01 00:55:23.000000', 'consum', 0.0225, 'lps'),
	(555657, 127, '2014-03-01 00:55:24.000000', 'consum', 0.0232, 'lps'),
	(555658, 127, '2014-03-01 00:55:25.000000', 'consum', 0.0218, 'lps'),
	(555659, 127, '2014-03-01 00:55:26.000000', 'consum', 0.0212, 'lps'),
	(555660, 127, '2014-03-01 00:55:27.000000', 'consum', 0.0224, 'lps'),
	(555661, 127, '2014-03-01 00:55:28.000000', 'consum', 0.0220, 'lps'),
	(555662, 127, '2014-03-01 00:55:29.000000', 'consum', 0.0216, 'lps'),
	(555663, 127, '2014-03-01 00:55:30.000000', 'consum', 0.0238, 'lps'),
	(555664, 127, '2014-03-01 00:55:31.000000', 'consum', 0.0219, 'lps'),
	(555665, 127, '2014-03-01 00:55:32.000000', 'consum', 0.0229, 'lps'),
	(555666, 127, '2014-03-01 00:55:33.000000', 'consum', 0.0219, 'lps'),
	(555667, 127, '2014-03-01 00:55:34.000000', 'consum', 0.0228, 'lps'),
	(555668, 127, '2014-03-01 00:55:35.000000', 'consum', 0.0215, 'lps'),
	(555669, 127, '2014-03-01 00:55:36.000000', 'consum', 0.0210, 'lps'),
	(555670, 127, '2014-03-01 00:55:37.000000', 'consum', 0.0225, 'lps'),
	(555671, 127, '2014-03-01 00:55:38.000000', 'consum', 0.0226, 'lps'),
	(555672, 127, '2014-03-01 00:55:39.000000', 'consum', 0.0218, 'lps'),
	(555673, 127, '2014-03-01 00:55:40.000000', 'consum', 0.0232, 'lps'),
	(555674, 127, '2014-03-01 00:55:41.000000', 'consum', 0.0238, 'lps'),
	(555675, 127, '2014-03-01 00:55:42.000000', 'consum', 0.0228, 'lps'),
	(555676, 127, '2014-03-01 00:55:43.000000', 'consum', 0.0216, 'lps'),
	(555677, 127, '2014-03-01 00:55:44.000000', 'consum', 0.0213, 'lps'),
	(555678, 127, '2014-03-01 00:55:45.000000', 'consum', 0.0210, 'lps'),
	(555679, 127, '2014-03-01 00:55:46.000000', 'consum', 0.0232, 'lps'),
	(555680, 127, '2014-03-01 00:55:47.000000', 'consum', 0.0230, 'lps'),
	(555681, 127, '2014-03-01 00:55:48.000000', 'consum', 0.0217, 'lps'),
	(555682, 127, '2014-03-01 00:55:49.000000', 'consum', 0.0214, 'lps'),
	(555683, 127, '2014-03-01 00:55:50.000000', 'consum', 0.0212, 'lps'),
	(555684, 127, '2014-03-01 00:55:51.000000', 'consum', 0.0234, 'lps'),
	(555685, 127, '2014-03-01 00:55:52.000000', 'consum', 0.0211, 'lps'),
	(555686, 127, '2014-03-01 00:55:53.000000', 'consum', 0.0228, 'lps'),
	(555687, 127, '2014-03-01 00:55:54.000000', 'consum', 0.0213, 'lps'),
	(555688, 127, '2014-03-01 00:55:55.000000', 'consum', 0.0228, 'lps'),
	(555689, 127, '2014-03-01 00:55:56.000000', 'consum', 0.0233, 'lps'),
	(555690, 127, '2014-03-01 00:55:57.000000', 'consum', 0.0213, 'lps'),
	(555691, 127, '2014-03-01 00:55:58.000000', 'consum', 0.0217, 'lps'),
	(555692, 127, '2014-03-01 00:55:59.000000', 'consum', 0.0237, 'lps'),
	(555693, 127, '2014-03-01 00:56:00.000000', 'consum', 0.0236, 'lps'),
	(555694, 127, '2014-03-01 00:56:01.000000', 'consum', 0.0230, 'lps'),
	(555695, 127, '2014-03-01 00:56:02.000000', 'consum', 0.0234, 'lps'),
	(555696, 127, '2014-03-01 00:56:03.000000', 'consum', 0.0211, 'lps'),
	(555697, 127, '2014-03-01 00:56:04.000000', 'consum', 0.0233, 'lps'),
	(555698, 127, '2014-03-01 00:56:05.000000', 'consum', 0.0234, 'lps'),
	(555699, 127, '2014-03-01 00:56:06.000000', 'consum', 0.0231, 'lps'),
	(555700, 127, '2014-03-01 00:56:07.000000', 'consum', 0.0215, 'lps'),
	(555701, 127, '2014-03-01 00:56:08.000000', 'consum', 0.0229, 'lps'),
	(555702, 127, '2014-03-01 00:56:09.000000', 'consum', 0.0233, 'lps'),
	(555703, 127, '2014-03-01 00:56:10.000000', 'consum', 0.0212, 'lps'),
	(555704, 127, '2014-03-01 00:56:11.000000', 'consum', 0.0238, 'lps'),
	(555705, 127, '2014-03-01 00:56:12.000000', 'consum', 0.0229, 'lps'),
	(555706, 127, '2014-03-01 00:56:13.000000', 'consum', 0.0219, 'lps'),
	(555707, 127, '2014-03-01 00:56:14.000000', 'consum', 0.0231, 'lps'),
	(555708, 127, '2014-03-01 00:56:15.000000', 'consum', 0.0227, 'lps'),
	(555709, 127, '2014-03-01 00:56:16.000000', 'consum', 0.0235, 'lps'),
	(555710, 127, '2014-03-01 00:56:17.000000', 'consum', 0.0224, 'lps'),
	(555711, 127, '2014-03-01 00:56:18.000000', 'consum', 0.0238, 'lps'),
	(555712, 127, '2014-03-01 00:56:19.000000', 'consum', 0.0219, 'lps'),
	(555713, 127, '2014-03-01 00:56:20.000000', 'consum', 0.0229, 'lps'),
	(555714, 127, '2014-03-01 00:56:21.000000', 'consum', 0.0221, 'lps'),
	(555715, 127, '2014-03-01 00:56:22.000000', 'consum', 0.0237, 'lps'),
	(555716, 127, '2014-03-01 00:56:23.000000', 'consum', 0.0225, 'lps'),
	(555717, 127, '2014-03-01 00:56:24.000000', 'consum', 0.0233, 'lps'),
	(555718, 127, '2014-03-01 00:56:25.000000', 'consum', 0.0222, 'lps'),
	(555719, 127, '2014-03-01 00:56:26.000000', 'consum', 0.0233, 'lps'),
	(555720, 127, '2014-03-01 00:56:27.000000', 'consum', 0.0229, 'lps'),
	(555721, 127, '2014-03-01 00:56:28.000000', 'consum', 0.0237, 'lps'),
	(555722, 127, '2014-03-01 00:56:29.000000', 'consum', 0.0229, 'lps'),
	(555723, 127, '2014-03-01 00:56:30.000000', 'consum', 0.0226, 'lps'),
	(555724, 127, '2014-03-01 00:56:31.000000', 'consum', 0.0233, 'lps'),
	(555725, 127, '2014-03-01 00:56:32.000000', 'consum', 0.0221, 'lps'),
	(555726, 127, '2014-03-01 00:56:33.000000', 'consum', 0.0227, 'lps'),
	(555727, 127, '2014-03-01 00:56:34.000000', 'consum', 0.0230, 'lps'),
	(555728, 127, '2014-03-01 00:56:35.000000', 'consum', 0.0232, 'lps'),
	(555729, 127, '2014-03-01 00:56:36.000000', 'consum', 0.0232, 'lps'),
	(555730, 127, '2014-03-01 00:56:37.000000', 'consum', 0.0225, 'lps'),
	(555731, 127, '2014-03-01 00:56:38.000000', 'consum', 0.0220, 'lps'),
	(555732, 127, '2014-03-01 00:56:39.000000', 'consum', 0.0215, 'lps'),
	(555733, 127, '2014-03-01 00:56:40.000000', 'consum', 0.0236, 'lps'),
	(555734, 127, '2014-03-01 00:56:41.000000', 'consum', 0.0210, 'lps'),
	(555735, 127, '2014-03-01 00:56:42.000000', 'consum', 0.0219, 'lps'),
	(555736, 127, '2014-03-01 00:56:43.000000', 'consum', 0.0226, 'lps'),
	(555737, 127, '2014-03-01 00:56:44.000000', 'consum', 0.0235, 'lps'),
	(555738, 127, '2014-03-01 00:56:45.000000', 'consum', 0.0229, 'lps'),
	(555739, 127, '2014-03-01 00:56:46.000000', 'consum', 0.0229, 'lps'),
	(555740, 127, '2014-03-01 00:56:47.000000', 'consum', 0.0222, 'lps'),
	(555741, 127, '2014-03-01 00:56:48.000000', 'consum', 0.0213, 'lps'),
	(555742, 127, '2014-03-01 00:56:49.000000', 'consum', 0.0216, 'lps'),
	(555743, 127, '2014-03-01 00:56:50.000000', 'consum', 0.0234, 'lps'),
	(555744, 127, '2014-03-01 00:56:51.000000', 'consum', 0.0226, 'lps'),
	(555745, 127, '2014-03-01 00:56:52.000000', 'consum', 0.0216, 'lps'),
	(555746, 127, '2014-03-01 00:56:53.000000', 'consum', 0.0223, 'lps'),
	(555747, 127, '2014-03-01 00:56:54.000000', 'consum', 0.0227, 'lps'),
	(555748, 127, '2014-03-01 00:56:55.000000', 'consum', 0.0228, 'lps'),
	(555749, 127, '2014-03-01 00:56:56.000000', 'consum', 0.0222, 'lps'),
	(555750, 127, '2014-03-01 00:56:57.000000', 'consum', 0.0217, 'lps'),
	(555751, 127, '2014-03-01 00:56:58.000000', 'consum', 0.0236, 'lps'),
	(555752, 127, '2014-03-01 00:56:59.000000', 'consum', 0.0233, 'lps'),
	(555753, 127, '2014-03-01 00:57:00.000000', 'consum', 0.0218, 'lps'),
	(555754, 127, '2014-03-01 00:57:01.000000', 'consum', 0.0211, 'lps'),
	(555755, 127, '2014-03-01 00:57:02.000000', 'consum', 0.0220, 'lps'),
	(555756, 127, '2014-03-01 00:57:03.000000', 'consum', 0.0230, 'lps'),
	(555757, 127, '2014-03-01 00:57:04.000000', 'consum', 0.0221, 'lps'),
	(555758, 127, '2014-03-01 00:57:05.000000', 'consum', 0.0236, 'lps'),
	(555759, 127, '2014-03-01 00:57:06.000000', 'consum', 0.0218, 'lps'),
	(555760, 127, '2014-03-01 00:57:07.000000', 'consum', 0.0232, 'lps'),
	(555761, 127, '2014-03-01 00:57:08.000000', 'consum', 0.0210, 'lps'),
	(555762, 127, '2014-03-01 00:57:09.000000', 'consum', 0.0232, 'lps'),
	(555763, 127, '2014-03-01 00:57:10.000000', 'consum', 0.0233, 'lps'),
	(555764, 127, '2014-03-01 00:57:11.000000', 'consum', 0.0230, 'lps'),
	(555765, 127, '2014-03-01 00:57:12.000000', 'consum', 0.0214, 'lps'),
	(555766, 127, '2014-03-01 00:57:13.000000', 'consum', 0.0226, 'lps'),
	(555767, 127, '2014-03-01 00:57:14.000000', 'consum', 0.0220, 'lps'),
	(555768, 127, '2014-03-01 00:57:15.000000', 'consum', 0.0216, 'lps'),
	(555769, 127, '2014-03-01 00:57:16.000000', 'consum', 0.0236, 'lps'),
	(555770, 127, '2014-03-01 00:57:17.000000', 'consum', 0.0238, 'lps'),
	(555771, 127, '2014-03-01 00:57:18.000000', 'consum', 0.0214, 'lps'),
	(555772, 127, '2014-03-01 00:57:19.000000', 'consum', 0.0232, 'lps'),
	(555773, 127, '2014-03-01 00:57:20.000000', 'consum', 0.0223, 'lps'),
	(555774, 127, '2014-03-01 00:57:21.000000', 'consum', 0.0210, 'lps'),
	(555775, 127, '2014-03-01 00:57:22.000000', 'consum', 0.0229, 'lps'),
	(555776, 127, '2014-03-01 00:57:23.000000', 'consum', 0.0219, 'lps'),
	(555777, 127, '2014-03-01 00:57:24.000000', 'consum', 0.0228, 'lps'),
	(555778, 127, '2014-03-01 00:57:25.000000', 'consum', 0.0214, 'lps'),
	(555779, 127, '2014-03-01 00:57:26.000000', 'consum', 0.0236, 'lps'),
	(555780, 127, '2014-03-01 00:57:27.000000', 'consum', 0.0212, 'lps'),
	(555781, 127, '2014-03-01 00:57:28.000000', 'consum', 0.0228, 'lps'),
	(555782, 127, '2014-03-01 00:57:29.000000', 'consum', 0.0238, 'lps'),
	(555783, 127, '2014-03-01 00:57:30.000000', 'consum', 0.0211, 'lps'),
	(555784, 127, '2014-03-01 00:57:31.000000', 'consum', 0.0215, 'lps'),
	(555785, 127, '2014-03-01 00:57:32.000000', 'consum', 0.0235, 'lps'),
	(555786, 127, '2014-03-01 00:57:33.000000', 'consum', 0.0232, 'lps'),
	(555787, 127, '2014-03-01 00:57:34.000000', 'consum', 0.0216, 'lps'),
	(555788, 127, '2014-03-01 00:57:35.000000', 'consum', 0.0234, 'lps'),
	(555789, 127, '2014-03-01 00:57:36.000000', 'consum', 0.0224, 'lps'),
	(555790, 127, '2014-03-01 00:57:37.000000', 'consum', 0.0211, 'lps'),
	(555791, 127, '2014-03-01 00:57:38.000000', 'consum', 0.0231, 'lps'),
	(555792, 127, '2014-03-01 00:57:39.000000', 'consum', 0.0224, 'lps'),
	(555793, 127, '2014-03-01 00:57:40.000000', 'consum', 0.0220, 'lps'),
	(555794, 127, '2014-03-01 00:57:41.000000', 'consum', 0.0215, 'lps'),
	(555795, 127, '2014-03-01 00:57:42.000000', 'consum', 0.0237, 'lps'),
	(555796, 127, '2014-03-01 00:57:43.000000', 'consum', 0.0214, 'lps'),
	(555797, 127, '2014-03-01 00:57:44.000000', 'consum', 0.0237, 'lps'),
	(555798, 127, '2014-03-01 00:57:45.000000', 'consum', 0.0216, 'lps'),
	(555799, 127, '2014-03-01 00:57:46.000000', 'consum', 0.0220, 'lps'),
	(555800, 127, '2014-03-01 00:57:47.000000', 'consum', 0.0211, 'lps'),
	(555801, 127, '2014-03-01 00:57:48.000000', 'consum', 0.0216, 'lps'),
	(555802, 127, '2014-03-01 00:57:49.000000', 'consum', 0.0238, 'lps'),
	(555803, 127, '2014-03-01 00:57:50.000000', 'consum', 0.0215, 'lps'),
	(555804, 127, '2014-03-01 00:57:51.000000', 'consum', 0.0238, 'lps'),
	(555805, 127, '2014-03-01 00:57:52.000000', 'consum', 0.0220, 'lps'),
	(555806, 127, '2014-03-01 00:57:53.000000', 'consum', 0.0234, 'lps'),
	(555807, 127, '2014-03-01 00:57:54.000000', 'consum', 0.0215, 'lps'),
	(555808, 127, '2014-03-01 00:57:55.000000', 'consum', 0.0221, 'lps'),
	(555809, 127, '2014-03-01 00:57:56.000000', 'consum', 0.0223, 'lps'),
	(555810, 127, '2014-03-01 00:57:57.000000', 'consum', 0.0211, 'lps'),
	(555811, 127, '2014-03-01 00:57:58.000000', 'consum', 0.0233, 'lps'),
	(555812, 127, '2014-03-01 00:57:59.000000', 'consum', 0.0210, 'lps'),
	(555813, 127, '2014-03-01 00:58:00.000000', 'consum', 0.0226, 'lps'),
	(555814, 127, '2014-03-01 00:58:01.000000', 'consum', 0.0235, 'lps'),
	(555815, 127, '2014-03-01 00:58:02.000000', 'consum', 0.0230, 'lps'),
	(555816, 127, '2014-03-01 00:58:03.000000', 'consum', 0.0234, 'lps'),
	(555817, 127, '2014-03-01 00:58:04.000000', 'consum', 0.0215, 'lps'),
	(555818, 127, '2014-03-01 00:58:05.000000', 'consum', 0.0219, 'lps'),
	(555819, 127, '2014-03-01 00:58:06.000000', 'consum', 0.0211, 'lps'),
	(555820, 127, '2014-03-01 00:58:07.000000', 'consum', 0.0218, 'lps'),
	(555821, 127, '2014-03-01 00:58:08.000000', 'consum', 0.0221, 'lps'),
	(555822, 127, '2014-03-01 00:58:09.000000', 'consum', 0.0238, 'lps'),
	(555823, 127, '2014-03-01 00:58:10.000000', 'consum', 0.0231, 'lps'),
	(555824, 127, '2014-03-01 00:58:11.000000', 'consum', 0.0232, 'lps'),
	(555825, 127, '2014-03-01 00:58:12.000000', 'consum', 0.0227, 'lps'),
	(555826, 127, '2014-03-01 00:58:13.000000', 'consum', 0.0232, 'lps'),
	(555827, 127, '2014-03-01 00:58:14.000000', 'consum', 0.0211, 'lps'),
	(555828, 127, '2014-03-01 00:58:15.000000', 'consum', 0.0236, 'lps'),
	(555829, 127, '2014-03-01 00:58:16.000000', 'consum', 0.0221, 'lps'),
	(555830, 127, '2014-03-01 00:58:17.000000', 'consum', 0.0215, 'lps'),
	(555831, 127, '2014-03-01 00:58:18.000000', 'consum', 0.0235, 'lps'),
	(555832, 127, '2014-03-01 00:58:19.000000', 'consum', 0.0231, 'lps'),
	(555833, 127, '2014-03-01 00:58:20.000000', 'consum', 0.0213, 'lps'),
	(555834, 127, '2014-03-01 00:58:21.000000', 'consum', 0.0222, 'lps'),
	(555835, 127, '2014-03-01 00:58:22.000000', 'consum', 0.0230, 'lps'),
	(555836, 127, '2014-03-01 00:58:23.000000', 'consum', 0.0215, 'lps'),
	(555837, 127, '2014-03-01 00:58:24.000000', 'consum', 0.0236, 'lps'),
	(555838, 127, '2014-03-01 00:58:25.000000', 'consum', 0.0236, 'lps'),
	(555839, 127, '2014-03-01 00:58:26.000000', 'consum', 0.0237, 'lps'),
	(555840, 127, '2014-03-01 00:58:27.000000', 'consum', 0.0236, 'lps'),
	(555841, 127, '2014-03-01 00:58:28.000000', 'consum', 0.0233, 'lps'),
	(555842, 127, '2014-03-01 00:58:29.000000', 'consum', 0.0216, 'lps'),
	(555843, 127, '2014-03-01 00:58:30.000000', 'consum', 0.0232, 'lps'),
	(555844, 127, '2014-03-01 00:58:31.000000', 'consum', 0.0213, 'lps'),
	(555845, 127, '2014-03-01 00:58:32.000000', 'consum', 0.0217, 'lps'),
	(555846, 127, '2014-03-01 00:58:33.000000', 'consum', 0.0238, 'lps'),
	(555847, 127, '2014-03-01 00:58:34.000000', 'consum', 0.0215, 'lps'),
	(555848, 127, '2014-03-01 00:58:35.000000', 'consum', 0.0236, 'lps'),
	(555849, 127, '2014-03-01 00:58:36.000000', 'consum', 0.0210, 'lps'),
	(555850, 127, '2014-03-01 00:58:37.000000', 'consum', 0.0220, 'lps'),
	(555851, 127, '2014-03-01 00:58:38.000000', 'consum', 0.0230, 'lps'),
	(555852, 127, '2014-03-01 00:58:39.000000', 'consum', 0.0225, 'lps'),
	(555853, 127, '2014-03-01 00:58:40.000000', 'consum', 0.0224, 'lps'),
	(555854, 127, '2014-03-01 00:58:41.000000', 'consum', 0.0236, 'lps'),
	(555855, 127, '2014-03-01 00:58:42.000000', 'consum', 0.0211, 'lps'),
	(555856, 127, '2014-03-01 00:58:43.000000', 'consum', 0.0224, 'lps'),
	(555857, 127, '2014-03-01 00:58:44.000000', 'consum', 0.0221, 'lps'),
	(555858, 127, '2014-03-01 00:58:45.000000', 'consum', 0.0224, 'lps'),
	(555859, 127, '2014-03-01 00:58:46.000000', 'consum', 0.0219, 'lps'),
	(555860, 127, '2014-03-01 00:58:47.000000', 'consum', 0.0214, 'lps'),
	(555861, 127, '2014-03-01 00:58:48.000000', 'consum', 0.0231, 'lps'),
	(555862, 127, '2014-03-01 00:58:49.000000', 'consum', 0.0215, 'lps'),
	(555863, 127, '2014-03-01 00:58:50.000000', 'consum', 0.0233, 'lps'),
	(555864, 127, '2014-03-01 00:58:51.000000', 'consum', 0.0221, 'lps'),
	(555865, 127, '2014-03-01 00:58:52.000000', 'consum', 0.0228, 'lps'),
	(555866, 127, '2014-03-01 00:58:53.000000', 'consum', 0.0238, 'lps'),
	(555867, 127, '2014-03-01 00:58:54.000000', 'consum', 0.0238, 'lps'),
	(555868, 127, '2014-03-01 00:58:55.000000', 'consum', 0.0237, 'lps'),
	(555869, 127, '2014-03-01 00:58:56.000000', 'consum', 0.0233, 'lps'),
	(555870, 127, '2014-03-01 00:58:57.000000', 'consum', 0.0216, 'lps'),
	(555871, 127, '2014-03-01 00:58:58.000000', 'consum', 0.0231, 'lps'),
	(555872, 127, '2014-03-01 00:58:59.000000', 'consum', 0.0237, 'lps'),
	(555873, 127, '2014-03-01 00:59:00.000000', 'consum', 0.0224, 'lps'),
	(555874, 127, '2014-03-01 00:59:01.000000', 'consum', 0.0231, 'lps'),
	(555875, 127, '2014-03-01 00:59:02.000000', 'consum', 0.0216, 'lps'),
	(555876, 127, '2014-03-01 00:59:03.000000', 'consum', 0.0235, 'lps'),
	(555877, 127, '2014-03-01 00:59:04.000000', 'consum', 0.0231, 'lps'),
	(555878, 127, '2014-03-01 00:59:05.000000', 'consum', 0.0210, 'lps'),
	(555879, 127, '2014-03-01 00:59:06.000000', 'consum', 0.0235, 'lps'),
	(555880, 127, '2014-03-01 00:59:07.000000', 'consum', 0.0218, 'lps'),
	(555881, 127, '2014-03-01 00:59:08.000000', 'consum', 0.0235, 'lps'),
	(555882, 127, '2014-03-01 00:59:09.000000', 'consum', 0.0225, 'lps'),
	(555883, 127, '2014-03-01 00:59:10.000000', 'consum', 0.0237, 'lps'),
	(555884, 127, '2014-03-01 00:59:11.000000', 'consum', 0.0214, 'lps'),
	(555885, 127, '2014-03-01 00:59:12.000000', 'consum', 0.0238, 'lps'),
	(555886, 127, '2014-03-01 00:59:13.000000', 'consum', 0.0221, 'lps'),
	(555887, 127, '2014-03-01 00:59:14.000000', 'consum', 0.0212, 'lps'),
	(555888, 127, '2014-03-01 00:59:15.000000', 'consum', 0.0214, 'lps'),
	(555889, 127, '2014-03-01 00:59:16.000000', 'consum', 0.0228, 'lps'),
	(555890, 127, '2014-03-01 00:59:17.000000', 'consum', 0.0228, 'lps'),
	(555891, 127, '2014-03-01 00:59:18.000000', 'consum', 0.0219, 'lps'),
	(555892, 127, '2014-03-01 00:59:19.000000', 'consum', 0.0228, 'lps'),
	(555893, 127, '2014-03-01 00:59:20.000000', 'consum', 0.0218, 'lps'),
	(555894, 127, '2014-03-01 00:59:21.000000', 'consum', 0.0225, 'lps'),
	(555895, 127, '2014-03-01 00:59:22.000000', 'consum', 0.0234, 'lps'),
	(555896, 127, '2014-03-01 00:59:23.000000', 'consum', 0.0225, 'lps'),
	(555897, 127, '2014-03-01 00:59:24.000000', 'consum', 0.0214, 'lps'),
	(555898, 127, '2014-03-01 00:59:25.000000', 'consum', 0.0213, 'lps'),
	(555899, 127, '2014-03-01 00:59:26.000000', 'consum', 0.0213, 'lps'),
	(555900, 127, '2014-03-01 00:59:27.000000', 'consum', 0.0219, 'lps'),
	(555901, 127, '2014-03-01 00:59:28.000000', 'consum', 0.0216, 'lps'),
	(555902, 127, '2014-03-01 00:59:29.000000', 'consum', 0.0215, 'lps'),
	(555903, 127, '2014-03-01 00:59:30.000000', 'consum', 0.0218, 'lps'),
	(555904, 127, '2014-03-01 00:59:31.000000', 'consum', 0.0236, 'lps'),
	(555905, 127, '2014-03-01 00:59:32.000000', 'consum', 0.0229, 'lps'),
	(555906, 127, '2014-03-01 00:59:33.000000', 'consum', 0.0228, 'lps'),
	(555907, 127, '2014-03-01 00:59:34.000000', 'consum', 0.0213, 'lps'),
	(555908, 127, '2014-03-01 00:59:35.000000', 'consum', 0.0229, 'lps'),
	(555909, 127, '2014-03-01 00:59:36.000000', 'consum', 0.0211, 'lps'),
	(555910, 127, '2014-03-01 00:59:37.000000', 'consum', 0.0216, 'lps'),
	(555911, 127, '2014-03-01 00:59:38.000000', 'consum', 0.0238, 'lps'),
	(555912, 127, '2014-03-01 00:59:39.000000', 'consum', 0.0216, 'lps'),
	(555913, 127, '2014-03-01 00:59:40.000000', 'consum', 0.0216, 'lps'),
	(555914, 127, '2014-03-01 00:59:41.000000', 'consum', 0.0224, 'lps'),
	(555915, 127, '2014-03-01 00:59:42.000000', 'consum', 0.0230, 'lps'),
	(555916, 127, '2014-03-01 00:59:43.000000', 'consum', 0.0211, 'lps'),
	(555917, 127, '2014-03-01 00:59:44.000000', 'consum', 0.0214, 'lps'),
	(555918, 127, '2014-03-01 00:59:45.000000', 'consum', 0.0229, 'lps'),
	(555919, 127, '2014-03-01 00:59:46.000000', 'consum', 0.0234, 'lps'),
	(555920, 127, '2014-03-01 00:59:47.000000', 'consum', 0.0217, 'lps'),
	(555921, 127, '2014-03-01 00:59:48.000000', 'consum', 0.0230, 'lps'),
	(555922, 127, '2014-03-01 00:59:49.000000', 'consum', 0.0233, 'lps'),
	(555923, 127, '2014-03-01 00:59:50.000000', 'consum', 0.0236, 'lps'),
	(555924, 127, '2014-03-01 00:59:51.000000', 'consum', 0.0213, 'lps'),
	(555925, 127, '2014-03-01 00:59:52.000000', 'consum', 0.0236, 'lps'),
	(555926, 127, '2014-03-01 00:59:53.000000', 'consum', 0.0213, 'lps'),
	(555927, 127, '2014-03-01 00:59:54.000000', 'consum', 0.0237, 'lps'),
	(555928, 127, '2014-03-01 00:59:55.000000', 'consum', 0.0218, 'lps'),
	(555929, 127, '2014-03-01 00:59:56.000000', 'consum', 0.0228, 'lps'),
	(555930, 127, '2014-03-01 00:59:57.000000', 'consum', 0.0218, 'lps'),
	(555931, 127, '2014-03-01 00:59:58.000000', 'consum', 0.0225, 'lps'),
	(555932, 127, '2014-03-01 00:59:59.000000', 'consum', 0.0235, 'lps'),
	(555933, 127, '2014-03-01 01:00:00.000000', 'consum', 0.0230, 'lps'),
	(555934, 127, '2014-03-01 01:00:01.000000', 'consum', 0.0237, 'lps'),
	(555935, 127, '2014-03-01 01:00:02.000000', 'consum', 0.0226, 'lps'),
	(555936, 127, '2014-03-01 01:00:03.000000', 'consum', 0.0211, 'lps'),
	(555937, 127, '2014-03-01 01:00:04.000000', 'consum', 0.0223, 'lps'),
	(555938, 127, '2014-03-01 01:00:05.000000', 'consum', 0.0216, 'lps'),
	(555939, 127, '2014-03-01 01:00:06.000000', 'consum', 0.0231, 'lps'),
	(555940, 127, '2014-03-01 01:00:07.000000', 'consum', 0.0210, 'lps'),
	(555941, 127, '2014-03-01 01:00:08.000000', 'consum', 0.0235, 'lps'),
	(555942, 127, '2014-03-01 01:00:09.000000', 'consum', 0.0218, 'lps'),
	(555943, 127, '2014-03-01 01:00:10.000000', 'consum', 0.0232, 'lps'),
	(555944, 127, '2014-03-01 01:00:11.000000', 'consum', 0.0213, 'lps'),
	(555945, 127, '2014-03-01 01:00:12.000000', 'consum', 0.0216, 'lps'),
	(555946, 127, '2014-03-01 01:00:13.000000', 'consum', 0.0231, 'lps'),
	(555947, 127, '2014-03-01 01:00:14.000000', 'consum', 0.0238, 'lps'),
	(555948, 127, '2014-03-01 01:00:15.000000', 'consum', 0.0232, 'lps'),
	(555949, 127, '2014-03-01 01:00:16.000000', 'consum', 0.0234, 'lps'),
	(555950, 127, '2014-03-01 01:00:17.000000', 'consum', 0.0237, 'lps'),
	(555951, 127, '2014-03-01 01:00:18.000000', 'consum', 0.0214, 'lps'),
	(555952, 127, '2014-03-01 01:00:19.000000', 'consum', 0.0238, 'lps'),
	(555953, 127, '2014-03-01 01:00:20.000000', 'consum', 0.0222, 'lps'),
	(555954, 127, '2014-03-01 01:00:21.000000', 'consum', 0.0217, 'lps'),
	(555955, 127, '2014-03-01 01:00:22.000000', 'consum', 0.0237, 'lps'),
	(555956, 127, '2014-03-01 01:00:23.000000', 'consum', 0.0238, 'lps'),
	(555957, 127, '2014-03-01 01:00:24.000000', 'consum', 0.0212, 'lps'),
	(555958, 127, '2014-03-01 01:00:25.000000', 'consum', 0.0222, 'lps'),
	(555959, 127, '2014-03-01 01:00:26.000000', 'consum', 0.0235, 'lps'),
	(555960, 127, '2014-03-01 01:00:27.000000', 'consum', 0.0211, 'lps'),
	(555961, 127, '2014-03-01 01:00:28.000000', 'consum', 0.0230, 'lps'),
	(555962, 127, '2014-03-01 01:00:29.000000', 'consum', 0.0222, 'lps'),
	(555963, 127, '2014-03-01 01:00:30.000000', 'consum', 0.0238, 'lps'),
	(555964, 127, '2014-03-01 01:00:31.000000', 'consum', 0.0226, 'lps'),
	(555965, 127, '2014-03-01 01:00:32.000000', 'consum', 0.0236, 'lps'),
	(555966, 127, '2014-03-01 01:00:33.000000', 'consum', 0.0233, 'lps'),
	(555967, 127, '2014-03-01 01:00:34.000000', 'consum', 0.0219, 'lps'),
	(555968, 127, '2014-03-01 01:00:35.000000', 'consum', 0.0218, 'lps'),
	(555969, 127, '2014-03-01 01:00:36.000000', 'consum', 0.0222, 'lps'),
	(555970, 127, '2014-03-01 01:00:37.000000', 'consum', 0.0217, 'lps'),
	(555971, 127, '2014-03-01 01:00:38.000000', 'consum', 0.0238, 'lps'),
	(555972, 127, '2014-03-01 01:00:39.000000', 'consum', 0.0213, 'lps'),
	(555973, 127, '2014-03-01 01:00:40.000000', 'consum', 0.0228, 'lps'),
	(555974, 127, '2014-03-01 01:00:41.000000', 'consum', 0.0236, 'lps'),
	(555975, 127, '2014-03-01 01:00:42.000000', 'consum', 0.0228, 'lps'),
	(555976, 127, '2014-03-01 01:00:43.000000', 'consum', 0.0222, 'lps'),
	(555977, 127, '2014-03-01 01:00:44.000000', 'consum', 0.0218, 'lps'),
	(555978, 127, '2014-03-01 01:00:45.000000', 'consum', 0.0214, 'lps'),
	(555979, 127, '2014-03-01 01:00:46.000000', 'consum', 0.0234, 'lps'),
	(555980, 127, '2014-03-01 01:00:47.000000', 'consum', 0.0232, 'lps'),
	(555981, 127, '2014-03-01 01:00:48.000000', 'consum', 0.0220, 'lps'),
	(555982, 127, '2014-03-01 01:00:49.000000', 'consum', 0.0223, 'lps'),
	(555983, 127, '2014-03-01 01:00:50.000000', 'consum', 0.0215, 'lps'),
	(555984, 127, '2014-03-01 01:00:51.000000', 'consum', 0.0225, 'lps'),
	(555985, 127, '2014-03-01 01:00:52.000000', 'consum', 0.0215, 'lps'),
	(555986, 127, '2014-03-01 01:00:53.000000', 'consum', 0.0217, 'lps'),
	(555987, 127, '2014-03-01 01:00:54.000000', 'consum', 0.0232, 'lps'),
	(555988, 127, '2014-03-01 01:00:55.000000', 'consum', 0.0211, 'lps'),
	(555989, 127, '2014-03-01 01:00:56.000000', 'consum', 0.0236, 'lps'),
	(555990, 127, '2014-03-01 01:00:57.000000', 'consum', 0.0223, 'lps'),
	(555991, 127, '2014-03-01 01:00:58.000000', 'consum', 0.0228, 'lps'),
	(555992, 127, '2014-03-01 01:00:59.000000', 'consum', 0.0231, 'lps'),
	(555993, 127, '2014-03-01 01:01:00.000000', 'consum', 0.0234, 'lps'),
	(555994, 127, '2014-03-01 01:01:01.000000', 'consum', 0.0236, 'lps'),
	(555995, 127, '2014-03-01 01:01:02.000000', 'consum', 0.0213, 'lps'),
	(555996, 127, '2014-03-01 01:01:03.000000', 'consum', 0.0234, 'lps'),
	(555997, 127, '2014-03-01 01:01:04.000000', 'consum', 0.0233, 'lps'),
	(555998, 127, '2014-03-01 01:01:05.000000', 'consum', 0.0224, 'lps'),
	(555999, 127, '2014-03-01 01:01:06.000000', 'consum', 0.0214, 'lps'),
	(556000, 127, '2014-03-01 01:01:07.000000', 'consum', 0.0217, 'lps'),
	(556001, 127, '2014-03-01 01:01:08.000000', 'consum', 0.0234, 'lps'),
	(556002, 127, '2014-03-01 01:01:09.000000', 'consum', 0.0222, 'lps'),
	(556003, 127, '2014-03-01 01:01:10.000000', 'consum', 0.0226, 'lps'),
	(556004, 127, '2014-03-01 01:01:11.000000', 'consum', 0.0228, 'lps'),
	(556005, 127, '2014-03-01 01:01:12.000000', 'consum', 0.0221, 'lps'),
	(556006, 127, '2014-03-01 01:01:13.000000', 'consum', 0.0211, 'lps'),
	(556007, 127, '2014-03-01 01:01:14.000000', 'consum', 0.0211, 'lps'),
	(556008, 127, '2014-03-01 01:01:15.000000', 'consum', 0.0212, 'lps'),
	(556009, 127, '2014-03-01 01:01:16.000000', 'consum', 0.0220, 'lps'),
	(556010, 127, '2014-03-01 01:01:17.000000', 'consum', 0.0224, 'lps'),
	(556011, 127, '2014-03-01 01:01:18.000000', 'consum', 0.0223, 'lps'),
	(556012, 127, '2014-03-01 01:01:19.000000', 'consum', 0.0234, 'lps'),
	(556013, 127, '2014-03-01 01:01:20.000000', 'consum', 0.0231, 'lps'),
	(556014, 127, '2014-03-01 01:01:21.000000', 'consum', 0.0217, 'lps'),
	(556015, 127, '2014-03-01 01:01:22.000000', 'consum', 0.0210, 'lps'),
	(556016, 127, '2014-03-01 01:01:23.000000', 'consum', 0.0217, 'lps'),
	(556017, 127, '2014-03-01 01:01:24.000000', 'consum', 0.0219, 'lps'),
	(556018, 127, '2014-03-01 01:01:25.000000', 'consum', 0.0234, 'lps'),
	(556019, 127, '2014-03-01 01:01:26.000000', 'consum', 0.0214, 'lps'),
	(556020, 127, '2014-03-01 01:01:27.000000', 'consum', 0.0219, 'lps'),
	(556021, 127, '2014-03-01 01:01:28.000000', 'consum', 0.0215, 'lps'),
	(556022, 127, '2014-03-01 01:01:29.000000', 'consum', 0.0236, 'lps'),
	(556023, 127, '2014-03-01 01:01:30.000000', 'consum', 0.0212, 'lps'),
	(556024, 127, '2014-03-01 01:01:31.000000', 'consum', 0.0227, 'lps'),
	(556025, 127, '2014-03-01 01:01:32.000000', 'consum', 0.0234, 'lps'),
	(556026, 127, '2014-03-01 01:01:33.000000', 'consum', 0.0220, 'lps'),
	(556027, 127, '2014-03-01 01:01:34.000000', 'consum', 0.0216, 'lps'),
	(556028, 127, '2014-03-01 01:01:35.000000', 'consum', 0.0210, 'lps'),
	(556029, 127, '2014-03-01 01:01:36.000000', 'consum', 0.0224, 'lps'),
	(556030, 127, '2014-03-01 01:01:37.000000', 'consum', 0.0222, 'lps'),
	(556031, 127, '2014-03-01 01:01:38.000000', 'consum', 0.0229, 'lps'),
	(556032, 127, '2014-03-01 01:01:39.000000', 'consum', 0.0211, 'lps'),
	(556033, 127, '2014-03-01 01:01:40.000000', 'consum', 0.0216, 'lps'),
	(556034, 127, '2014-03-01 01:01:41.000000', 'consum', 0.0210, 'lps'),
	(556035, 127, '2014-03-01 01:01:42.000000', 'consum', 0.0221, 'lps'),
	(556036, 127, '2014-03-01 01:01:43.000000', 'consum', 0.0236, 'lps'),
	(556037, 127, '2014-03-01 01:01:44.000000', 'consum', 0.0219, 'lps'),
	(556038, 127, '2014-03-01 01:01:45.000000', 'consum', 0.0236, 'lps'),
	(556039, 127, '2014-03-01 01:01:46.000000', 'consum', 0.0226, 'lps'),
	(556040, 127, '2014-03-01 01:01:47.000000', 'consum', 0.0215, 'lps'),
	(556041, 127, '2014-03-01 01:01:48.000000', 'consum', 0.0214, 'lps'),
	(556042, 127, '2014-03-01 01:01:49.000000', 'consum', 0.0218, 'lps'),
	(556043, 127, '2014-03-01 01:01:50.000000', 'consum', 0.0210, 'lps'),
	(556044, 127, '2014-03-01 01:01:51.000000', 'consum', 0.0215, 'lps'),
	(556045, 127, '2014-03-01 01:01:52.000000', 'consum', 0.0234, 'lps'),
	(556046, 127, '2014-03-01 01:01:53.000000', 'consum', 0.0230, 'lps'),
	(556047, 127, '2014-03-01 01:01:54.000000', 'consum', 0.0237, 'lps'),
	(556048, 127, '2014-03-01 01:01:55.000000', 'consum', 0.0229, 'lps'),
	(556049, 127, '2014-03-01 01:01:56.000000', 'consum', 0.0225, 'lps'),
	(556050, 127, '2014-03-01 01:01:57.000000', 'consum', 0.0229, 'lps'),
	(556051, 127, '2014-03-01 01:01:58.000000', 'consum', 0.0230, 'lps'),
	(556052, 127, '2014-03-01 01:01:59.000000', 'consum', 0.0224, 'lps'),
	(556053, 127, '2014-03-01 01:02:00.000000', 'consum', 0.0221, 'lps'),
	(556054, 127, '2014-03-01 01:02:01.000000', 'consum', 0.0224, 'lps'),
	(556055, 127, '2014-03-01 01:02:02.000000', 'consum', 0.0220, 'lps'),
	(556056, 127, '2014-03-01 01:02:03.000000', 'consum', 0.0216, 'lps'),
	(556057, 127, '2014-03-01 01:02:04.000000', 'consum', 0.0211, 'lps'),
	(556058, 127, '2014-03-01 01:02:05.000000', 'consum', 0.0227, 'lps'),
	(556059, 127, '2014-03-01 01:02:06.000000', 'consum', 0.0236, 'lps'),
	(556060, 127, '2014-03-01 01:02:07.000000', 'consum', 0.0231, 'lps'),
	(556061, 127, '2014-03-01 01:02:08.000000', 'consum', 0.0236, 'lps'),
	(556062, 127, '2014-03-01 01:02:09.000000', 'consum', 0.0219, 'lps'),
	(556063, 127, '2014-03-01 01:02:10.000000', 'consum', 0.0237, 'lps'),
	(556064, 127, '2014-03-01 01:02:11.000000', 'consum', 0.0230, 'lps'),
	(556065, 127, '2014-03-01 01:02:12.000000', 'consum', 0.0229, 'lps'),
	(556066, 127, '2014-03-01 01:02:13.000000', 'consum', 0.0217, 'lps'),
	(556067, 127, '2014-03-01 01:02:14.000000', 'consum', 0.0218, 'lps'),
	(556068, 127, '2014-03-01 01:02:15.000000', 'consum', 0.0228, 'lps'),
	(556069, 127, '2014-03-01 01:02:16.000000', 'consum', 0.0218, 'lps'),
	(556070, 127, '2014-03-01 01:02:17.000000', 'consum', 0.0226, 'lps'),
	(556071, 127, '2014-03-01 01:02:18.000000', 'consum', 0.0210, 'lps'),
	(556072, 127, '2014-03-01 01:02:19.000000', 'consum', 0.0219, 'lps'),
	(556073, 127, '2014-03-01 01:02:20.000000', 'consum', 0.0228, 'lps'),
	(556074, 127, '2014-03-01 01:02:21.000000', 'consum', 0.0215, 'lps'),
	(556075, 127, '2014-03-01 01:02:22.000000', 'consum', 0.0210, 'lps'),
	(556076, 127, '2014-03-01 01:02:23.000000', 'consum', 0.0226, 'lps'),
	(556077, 127, '2014-03-01 01:02:24.000000', 'consum', 0.0230, 'lps'),
	(556078, 127, '2014-03-01 01:02:25.000000', 'consum', 0.0234, 'lps'),
	(556079, 127, '2014-03-01 01:02:26.000000', 'consum', 0.0211, 'lps'),
	(556080, 127, '2014-03-01 01:02:27.000000', 'consum', 0.0231, 'lps'),
	(556081, 127, '2014-03-01 01:02:28.000000', 'consum', 0.0227, 'lps'),
	(556082, 127, '2014-03-01 01:02:29.000000', 'consum', 0.0230, 'lps'),
	(556083, 127, '2014-03-01 01:02:30.000000', 'consum', 0.0234, 'lps'),
	(556084, 127, '2014-03-01 01:02:31.000000', 'consum', 0.0238, 'lps'),
	(556085, 127, '2014-03-01 01:02:32.000000', 'consum', 0.0224, 'lps'),
	(556086, 127, '2014-03-01 01:02:33.000000', 'consum', 0.0222, 'lps'),
	(556087, 127, '2014-03-01 01:02:34.000000', 'consum', 0.0229, 'lps'),
	(556088, 127, '2014-03-01 01:02:35.000000', 'consum', 0.0214, 'lps'),
	(556089, 127, '2014-03-01 01:02:36.000000', 'consum', 0.0231, 'lps'),
	(556090, 127, '2014-03-01 01:02:37.000000', 'consum', 0.0215, 'lps'),
	(556091, 127, '2014-03-01 01:02:38.000000', 'consum', 0.0233, 'lps'),
	(556092, 127, '2014-03-01 01:02:39.000000', 'consum', 0.0223, 'lps'),
	(556093, 127, '2014-03-01 01:02:40.000000', 'consum', 0.0236, 'lps'),
	(556094, 127, '2014-03-01 01:02:41.000000', 'consum', 0.0215, 'lps'),
	(556095, 127, '2014-03-01 01:02:42.000000', 'consum', 0.0216, 'lps'),
	(556096, 127, '2014-03-01 01:02:43.000000', 'consum', 0.0225, 'lps'),
	(556097, 127, '2014-03-01 01:02:44.000000', 'consum', 0.0236, 'lps'),
	(556098, 127, '2014-03-01 01:02:45.000000', 'consum', 0.0212, 'lps'),
	(556099, 127, '2014-03-01 01:02:46.000000', 'consum', 0.0227, 'lps'),
	(556100, 127, '2014-03-01 01:02:47.000000', 'consum', 0.0233, 'lps'),
	(556101, 127, '2014-03-01 01:02:48.000000', 'consum', 0.0216, 'lps'),
	(556102, 127, '2014-03-01 01:02:49.000000', 'consum', 0.0229, 'lps'),
	(556103, 127, '2014-03-01 01:02:50.000000', 'consum', 0.0231, 'lps'),
	(556104, 127, '2014-03-01 01:02:51.000000', 'consum', 0.0230, 'lps'),
	(556105, 127, '2014-03-01 01:02:52.000000', 'consum', 0.0216, 'lps'),
	(556106, 127, '2014-03-01 01:02:53.000000', 'consum', 0.0210, 'lps'),
	(556107, 127, '2014-03-01 01:02:54.000000', 'consum', 0.0223, 'lps'),
	(556108, 127, '2014-03-01 01:02:55.000000', 'consum', 0.0216, 'lps'),
	(556109, 127, '2014-03-01 01:02:56.000000', 'consum', 0.0232, 'lps'),
	(556110, 127, '2014-03-01 01:02:57.000000', 'consum', 0.0217, 'lps'),
	(556111, 127, '2014-03-01 01:02:58.000000', 'consum', 0.0236, 'lps'),
	(556112, 127, '2014-03-01 01:02:59.000000', 'consum', 0.0231, 'lps'),
	(556113, 127, '2014-03-01 01:03:00.000000', 'consum', 0.0238, 'lps'),
	(556114, 127, '2014-03-01 01:03:01.000000', 'consum', 0.0231, 'lps'),
	(556115, 127, '2014-03-01 01:03:02.000000', 'consum', 0.0233, 'lps'),
	(556116, 127, '2014-03-01 01:03:03.000000', 'consum', 0.0231, 'lps'),
	(556117, 127, '2014-03-01 01:03:04.000000', 'consum', 0.0218, 'lps'),
	(556118, 127, '2014-03-01 01:03:05.000000', 'consum', 0.0216, 'lps'),
	(556119, 127, '2014-03-01 01:03:06.000000', 'consum', 0.0216, 'lps'),
	(556120, 127, '2014-03-01 01:03:07.000000', 'consum', 0.0222, 'lps'),
	(556121, 127, '2014-03-01 01:03:08.000000', 'consum', 0.0225, 'lps'),
	(556122, 127, '2014-03-01 01:03:09.000000', 'consum', 0.0220, 'lps'),
	(556123, 127, '2014-03-01 01:03:10.000000', 'consum', 0.0216, 'lps'),
	(556124, 127, '2014-03-01 01:03:11.000000', 'consum', 0.0211, 'lps'),
	(556125, 127, '2014-03-01 01:03:12.000000', 'consum', 0.0227, 'lps'),
	(556126, 127, '2014-03-01 01:03:13.000000', 'consum', 0.0234, 'lps'),
	(556127, 127, '2014-03-01 01:03:14.000000', 'consum', 0.0222, 'lps'),
	(556128, 127, '2014-03-01 01:03:15.000000', 'consum', 0.0228, 'lps'),
	(556129, 127, '2014-03-01 01:03:16.000000', 'consum', 0.0236, 'lps'),
	(556130, 127, '2014-03-01 01:03:17.000000', 'consum', 0.0229, 'lps'),
	(556131, 127, '2014-03-01 01:03:18.000000', 'consum', 0.0226, 'lps'),
	(556132, 127, '2014-03-01 01:03:19.000000', 'consum', 0.0233, 'lps'),
	(556133, 127, '2014-03-01 01:03:20.000000', 'consum', 0.0219, 'lps'),
	(556134, 127, '2014-03-01 01:03:21.000000', 'consum', 0.0214, 'lps'),
	(556135, 127, '2014-03-01 01:03:22.000000', 'consum', 0.0235, 'lps'),
	(556136, 127, '2014-03-01 01:03:23.000000', 'consum', 0.0236, 'lps'),
	(556137, 127, '2014-03-01 01:03:24.000000', 'consum', 0.0236, 'lps'),
	(556138, 127, '2014-03-01 01:03:25.000000', 'consum', 0.0233, 'lps'),
	(556139, 127, '2014-03-01 01:03:26.000000', 'consum', 0.0221, 'lps'),
	(556140, 127, '2014-03-01 01:03:27.000000', 'consum', 0.0222, 'lps'),
	(556141, 127, '2014-03-01 01:03:28.000000', 'consum', 0.0210, 'lps'),
	(556142, 127, '2014-03-01 01:03:29.000000', 'consum', 0.0234, 'lps'),
	(556143, 127, '2014-03-01 01:03:30.000000', 'consum', 0.0213, 'lps'),
	(556144, 127, '2014-03-01 01:03:31.000000', 'consum', 0.0212, 'lps'),
	(556145, 127, '2014-03-01 01:03:32.000000', 'consum', 0.0212, 'lps'),
	(556146, 127, '2014-03-01 01:03:33.000000', 'consum', 0.0213, 'lps'),
	(556147, 127, '2014-03-01 01:03:34.000000', 'consum', 0.0220, 'lps'),
	(556148, 127, '2014-03-01 01:03:35.000000', 'consum', 0.0223, 'lps'),
	(556149, 127, '2014-03-01 01:03:36.000000', 'consum', 0.0216, 'lps'),
	(556150, 127, '2014-03-01 01:03:37.000000', 'consum', 0.0230, 'lps'),
	(556151, 127, '2014-03-01 01:03:38.000000', 'consum', 0.0234, 'lps'),
	(556152, 127, '2014-03-01 01:03:39.000000', 'consum', 0.0213, 'lps'),
	(556153, 127, '2014-03-01 01:03:40.000000', 'consum', 0.0213, 'lps'),
	(556154, 127, '2014-03-01 01:03:41.000000', 'consum', 0.0217, 'lps'),
	(556155, 127, '2014-03-01 01:03:42.000000', 'consum', 0.0235, 'lps'),
	(556156, 127, '2014-03-01 01:03:43.000000', 'consum', 0.0228, 'lps'),
	(556157, 127, '2014-03-01 01:03:44.000000', 'consum', 0.0224, 'lps'),
	(556158, 127, '2014-03-01 01:03:45.000000', 'consum', 0.0229, 'lps'),
	(556159, 127, '2014-03-01 01:03:46.000000', 'consum', 0.0235, 'lps'),
	(556160, 127, '2014-03-01 01:03:47.000000', 'consum', 0.0219, 'lps'),
	(556161, 127, '2014-03-01 01:03:48.000000', 'consum', 0.0211, 'lps'),
	(556162, 127, '2014-03-01 01:03:49.000000', 'consum', 0.0216, 'lps'),
	(556163, 127, '2014-03-01 01:03:50.000000', 'consum', 0.0211, 'lps'),
	(556164, 127, '2014-03-01 01:03:51.000000', 'consum', 0.0224, 'lps'),
	(556165, 127, '2014-03-01 01:03:52.000000', 'consum', 0.0220, 'lps'),
	(556166, 127, '2014-03-01 01:03:53.000000', 'consum', 0.0218, 'lps'),
	(556167, 127, '2014-03-01 01:03:54.000000', 'consum', 0.0221, 'lps'),
	(556168, 127, '2014-03-01 01:03:55.000000', 'consum', 0.0213, 'lps'),
	(556169, 127, '2014-03-01 01:03:56.000000', 'consum', 0.0221, 'lps'),
	(556170, 127, '2014-03-01 01:03:57.000000', 'consum', 0.0229, 'lps'),
	(556171, 127, '2014-03-01 01:03:58.000000', 'consum', 0.0212, 'lps'),
	(556172, 127, '2014-03-01 01:03:59.000000', 'consum', 0.0221, 'lps'),
	(556173, 127, '2014-03-01 01:04:00.000000', 'consum', 0.0231, 'lps'),
	(556174, 127, '2014-03-01 01:04:01.000000', 'consum', 0.0227, 'lps'),
	(556175, 127, '2014-03-01 01:04:02.000000', 'consum', 0.0231, 'lps'),
	(556176, 127, '2014-03-01 01:04:03.000000', 'consum', 0.0236, 'lps'),
	(556177, 127, '2014-03-01 01:04:04.000000', 'consum', 0.0217, 'lps'),
	(556178, 127, '2014-03-01 01:04:05.000000', 'consum', 0.0228, 'lps'),
	(556179, 127, '2014-03-01 01:04:06.000000', 'consum', 0.0223, 'lps'),
	(556180, 127, '2014-03-01 01:04:07.000000', 'consum', 0.0219, 'lps'),
	(556181, 127, '2014-03-01 01:04:08.000000', 'consum', 0.0217, 'lps'),
	(556182, 127, '2014-03-01 01:04:09.000000', 'consum', 0.0217, 'lps'),
	(556183, 127, '2014-03-01 01:04:10.000000', 'consum', 0.0226, 'lps'),
	(556184, 127, '2014-03-01 01:04:11.000000', 'consum', 0.0212, 'lps'),
	(556185, 127, '2014-03-01 01:04:12.000000', 'consum', 0.0229, 'lps'),
	(556186, 127, '2014-03-01 01:04:13.000000', 'consum', 0.0213, 'lps'),
	(556187, 127, '2014-03-01 01:04:14.000000', 'consum', 0.0228, 'lps'),
	(556188, 127, '2014-03-01 01:04:15.000000', 'consum', 0.0233, 'lps'),
	(556189, 127, '2014-03-01 01:04:16.000000', 'consum', 0.0214, 'lps'),
	(556190, 127, '2014-03-01 01:04:17.000000', 'consum', 0.0221, 'lps'),
	(556191, 127, '2014-03-01 01:04:18.000000', 'consum', 0.0222, 'lps'),
	(556192, 127, '2014-03-01 01:04:19.000000', 'consum', 0.0237, 'lps'),
	(556193, 127, '2014-03-01 01:04:20.000000', 'consum', 0.0223, 'lps'),
	(556194, 127, '2014-03-01 01:04:21.000000', 'consum', 0.0224, 'lps'),
	(556195, 127, '2014-03-01 01:04:22.000000', 'consum', 0.0212, 'lps'),
	(556196, 127, '2014-03-01 01:04:23.000000', 'consum', 0.0237, 'lps'),
	(556197, 127, '2014-03-01 01:04:24.000000', 'consum', 0.0224, 'lps'),
	(556198, 127, '2014-03-01 01:04:25.000000', 'consum', 0.0227, 'lps'),
	(556199, 127, '2014-03-01 01:04:26.000000', 'consum', 0.0223, 'lps'),
	(556200, 127, '2014-03-01 01:04:27.000000', 'consum', 0.0227, 'lps'),
	(556201, 127, '2014-03-01 01:04:28.000000', 'consum', 0.0229, 'lps'),
	(556202, 127, '2014-03-01 01:04:29.000000', 'consum', 0.0224, 'lps'),
	(556203, 127, '2014-03-01 01:04:30.000000', 'consum', 0.0223, 'lps'),
	(556204, 127, '2014-03-01 01:04:31.000000', 'consum', 0.0234, 'lps'),
	(556205, 127, '2014-03-01 01:04:32.000000', 'consum', 0.0234, 'lps'),
	(556206, 127, '2014-03-01 01:04:33.000000', 'consum', 0.0229, 'lps'),
	(556207, 127, '2014-03-01 01:04:34.000000', 'consum', 0.0233, 'lps'),
	(556208, 127, '2014-03-01 01:04:35.000000', 'consum', 0.0238, 'lps'),
	(556209, 127, '2014-03-01 01:04:36.000000', 'consum', 0.0226, 'lps'),
	(556210, 127, '2014-03-01 01:04:37.000000', 'consum', 0.0236, 'lps'),
	(556211, 127, '2014-03-01 01:04:38.000000', 'consum', 0.0234, 'lps'),
	(556212, 127, '2014-03-01 01:04:39.000000', 'consum', 0.0221, 'lps'),
	(556213, 127, '2014-03-01 01:04:40.000000', 'consum', 0.0226, 'lps'),
	(556214, 127, '2014-03-01 01:04:41.000000', 'consum', 0.0226, 'lps'),
	(556215, 127, '2014-03-01 01:04:42.000000', 'consum', 0.0212, 'lps'),
	(556216, 127, '2014-03-01 01:04:43.000000', 'consum', 0.0234, 'lps'),
	(556217, 127, '2014-03-01 01:04:44.000000', 'consum', 0.0235, 'lps'),
	(556218, 127, '2014-03-01 01:04:45.000000', 'consum', 0.0235, 'lps'),
	(556219, 127, '2014-03-01 01:04:46.000000', 'consum', 0.0232, 'lps'),
	(556220, 127, '2014-03-01 01:04:47.000000', 'consum', 0.0216, 'lps'),
	(556221, 127, '2014-03-01 01:04:48.000000', 'consum', 0.0231, 'lps'),
	(556222, 127, '2014-03-01 01:04:49.000000', 'consum', 0.0211, 'lps'),
	(556223, 127, '2014-03-01 01:04:50.000000', 'consum', 0.0210, 'lps'),
	(556224, 127, '2014-03-01 01:04:51.000000', 'consum', 0.0236, 'lps'),
	(556225, 127, '2014-03-01 01:04:52.000000', 'consum', 0.0223, 'lps'),
	(556226, 127, '2014-03-01 01:04:53.000000', 'consum', 0.0229, 'lps'),
	(556227, 127, '2014-03-01 01:04:54.000000', 'consum', 0.0210, 'lps'),
	(556228, 127, '2014-03-01 01:04:55.000000', 'consum', 0.0237, 'lps'),
	(556229, 127, '2014-03-01 01:04:56.000000', 'consum', 0.0232, 'lps'),
	(556230, 127, '2014-03-01 01:04:57.000000', 'consum', 0.0212, 'lps'),
	(556231, 127, '2014-03-01 01:04:58.000000', 'consum', 0.0210, 'lps'),
	(556232, 127, '2014-03-01 01:04:59.000000', 'consum', 0.0233, 'lps'),
	(556233, 127, '2014-03-01 01:05:00.000000', 'consum', 0.0238, 'lps'),
	(556234, 127, '2014-03-01 01:05:01.000000', 'consum', 0.0225, 'lps'),
	(556235, 127, '2014-03-01 01:05:02.000000', 'consum', 0.0230, 'lps'),
	(556236, 127, '2014-03-01 01:05:03.000000', 'consum', 0.0237, 'lps'),
	(556237, 127, '2014-03-01 01:05:04.000000', 'consum', 0.0225, 'lps'),
	(556238, 127, '2014-03-01 01:05:05.000000', 'consum', 0.0237, 'lps'),
	(556239, 127, '2014-03-01 01:05:06.000000', 'consum', 0.0212, 'lps'),
	(556240, 127, '2014-03-01 01:05:07.000000', 'consum', 0.0227, 'lps'),
	(556241, 127, '2014-03-01 01:05:08.000000', 'consum', 0.0233, 'lps'),
	(556242, 127, '2014-03-01 01:05:09.000000', 'consum', 0.0216, 'lps'),
	(556243, 127, '2014-03-01 01:05:10.000000', 'consum', 0.0231, 'lps'),
	(556244, 127, '2014-03-01 01:05:11.000000', 'consum', 0.0237, 'lps'),
	(556245, 127, '2014-03-01 01:05:12.000000', 'consum', 0.0227, 'lps'),
	(556246, 127, '2014-03-01 01:05:13.000000', 'consum', 0.0211, 'lps'),
	(556247, 127, '2014-03-01 01:05:14.000000', 'consum', 0.0225, 'lps'),
	(556248, 127, '2014-03-01 01:05:15.000000', 'consum', 0.0226, 'lps'),
	(556249, 127, '2014-03-01 01:05:16.000000', 'consum', 0.0214, 'lps'),
	(556250, 127, '2014-03-01 01:05:17.000000', 'consum', 0.0213, 'lps'),
	(556251, 127, '2014-03-01 01:05:18.000000', 'consum', 0.0211, 'lps'),
	(556252, 127, '2014-03-01 01:05:19.000000', 'consum', 0.0237, 'lps'),
	(556253, 127, '2014-03-01 01:05:20.000000', 'consum', 0.0227, 'lps'),
	(556254, 127, '2014-03-01 01:05:21.000000', 'consum', 0.0214, 'lps'),
	(556255, 127, '2014-03-01 01:05:22.000000', 'consum', 0.0210, 'lps'),
	(556256, 127, '2014-03-01 01:05:23.000000', 'consum', 0.0227, 'lps'),
	(556257, 127, '2014-03-01 01:05:24.000000', 'consum', 0.0235, 'lps'),
	(556258, 127, '2014-03-01 01:05:25.000000', 'consum', 0.0228, 'lps'),
	(556259, 127, '2014-03-01 01:05:26.000000', 'consum', 0.0226, 'lps'),
	(556260, 127, '2014-03-01 01:05:27.000000', 'consum', 0.0237, 'lps'),
	(556261, 127, '2014-03-01 01:05:28.000000', 'consum', 0.0211, 'lps'),
	(556262, 127, '2014-03-01 01:05:29.000000', 'consum', 0.0221, 'lps'),
	(556263, 127, '2014-03-01 01:05:30.000000', 'consum', 0.0235, 'lps'),
	(556264, 127, '2014-03-01 01:05:31.000000', 'consum', 0.0213, 'lps'),
	(556265, 127, '2014-03-01 01:05:32.000000', 'consum', 0.0211, 'lps'),
	(556266, 127, '2014-03-01 01:05:33.000000', 'consum', 0.0236, 'lps'),
	(556267, 127, '2014-03-01 01:05:34.000000', 'consum', 0.0221, 'lps'),
	(556268, 127, '2014-03-01 01:05:35.000000', 'consum', 0.0216, 'lps'),
	(556269, 127, '2014-03-01 01:05:36.000000', 'consum', 0.0238, 'lps'),
	(556270, 127, '2014-03-01 01:05:37.000000', 'consum', 0.0216, 'lps'),
	(556271, 127, '2014-03-01 01:05:38.000000', 'consum', 0.0214, 'lps'),
	(556272, 127, '2014-03-01 01:05:39.000000', 'consum', 0.0213, 'lps'),
	(556273, 127, '2014-03-01 01:05:40.000000', 'consum', 0.0213, 'lps'),
	(556274, 127, '2014-03-01 01:05:41.000000', 'consum', 0.0219, 'lps'),
	(556275, 127, '2014-03-01 01:05:42.000000', 'consum', 0.0215, 'lps'),
	(556276, 127, '2014-03-01 01:05:43.000000', 'consum', 0.0237, 'lps'),
	(556277, 127, '2014-03-01 01:05:44.000000', 'consum', 0.0214, 'lps'),
	(556278, 127, '2014-03-01 01:05:45.000000', 'consum', 0.0236, 'lps'),
	(556279, 127, '2014-03-01 01:05:46.000000', 'consum', 0.0215, 'lps'),
	(556280, 127, '2014-03-01 01:05:47.000000', 'consum', 0.0215, 'lps'),
	(556281, 127, '2014-03-01 01:05:48.000000', 'consum', 0.0219, 'lps'),
	(556282, 127, '2014-03-01 01:05:49.000000', 'consum', 0.0214, 'lps'),
	(556283, 127, '2014-03-01 01:05:50.000000', 'consum', 0.0232, 'lps'),
	(556284, 127, '2014-03-01 01:05:51.000000', 'consum', 0.0219, 'lps'),
	(556285, 127, '2014-03-01 01:05:52.000000', 'consum', 0.0220, 'lps'),
	(556286, 127, '2014-03-01 01:05:53.000000', 'consum', 0.0232, 'lps'),
	(556287, 127, '2014-03-01 01:05:54.000000', 'consum', 0.0235, 'lps'),
	(556288, 127, '2014-03-01 01:05:55.000000', 'consum', 0.0238, 'lps'),
	(556289, 127, '2014-03-01 01:05:56.000000', 'consum', 0.0217, 'lps'),
	(556290, 127, '2014-03-01 01:05:57.000000', 'consum', 0.0220, 'lps'),
	(556291, 127, '2014-03-01 01:05:58.000000', 'consum', 0.0211, 'lps'),
	(556292, 127, '2014-03-01 01:05:59.000000', 'consum', 0.0214, 'lps'),
	(556293, 127, '2014-03-01 01:06:00.000000', 'consum', 0.0229, 'lps'),
	(556294, 127, '2014-03-01 01:06:01.000000', 'consum', 0.0236, 'lps'),
	(556295, 127, '2014-03-01 01:06:02.000000', 'consum', 0.0224, 'lps'),
	(556296, 127, '2014-03-01 01:06:03.000000', 'consum', 0.0230, 'lps'),
	(556297, 127, '2014-03-01 01:06:04.000000', 'consum', 0.0213, 'lps'),
	(556298, 127, '2014-03-01 01:06:05.000000', 'consum', 0.0223, 'lps'),
	(556299, 127, '2014-03-01 01:06:06.000000', 'consum', 0.0210, 'lps'),
	(556300, 127, '2014-03-01 01:06:07.000000', 'consum', 0.0229, 'lps'),
	(556301, 127, '2014-03-01 01:06:08.000000', 'consum', 0.0218, 'lps'),
	(556302, 127, '2014-03-01 01:06:09.000000', 'consum', 0.0223, 'lps'),
	(556303, 127, '2014-03-01 01:06:10.000000', 'consum', 0.0222, 'lps'),
	(556304, 127, '2014-03-01 01:06:11.000000', 'consum', 0.0231, 'lps'),
	(556305, 127, '2014-03-01 01:06:12.000000', 'consum', 0.0221, 'lps'),
	(556306, 127, '2014-03-01 01:06:13.000000', 'consum', 0.0234, 'lps'),
	(556307, 127, '2014-03-01 01:06:14.000000', 'consum', 0.0237, 'lps'),
	(556308, 127, '2014-03-01 01:06:15.000000', 'consum', 0.0218, 'lps'),
	(556309, 127, '2014-03-01 01:06:16.000000', 'consum', 0.0226, 'lps'),
	(556310, 127, '2014-03-01 01:06:17.000000', 'consum', 0.0238, 'lps'),
	(556311, 127, '2014-03-01 01:06:18.000000', 'consum', 0.0216, 'lps'),
	(556312, 127, '2014-03-01 01:06:19.000000', 'consum', 0.0213, 'lps'),
	(556313, 127, '2014-03-01 01:06:20.000000', 'consum', 0.0235, 'lps'),
	(556314, 127, '2014-03-01 01:06:21.000000', 'consum', 0.0213, 'lps'),
	(556315, 127, '2014-03-01 01:06:22.000000', 'consum', 0.0238, 'lps'),
	(556316, 127, '2014-03-01 01:06:23.000000', 'consum', 0.0226, 'lps'),
	(556317, 127, '2014-03-01 01:06:24.000000', 'consum', 0.0233, 'lps'),
	(556318, 127, '2014-03-01 01:06:25.000000', 'consum', 0.0221, 'lps'),
	(556319, 127, '2014-03-01 01:06:26.000000', 'consum', 0.0224, 'lps'),
	(556320, 127, '2014-03-01 01:06:27.000000', 'consum', 0.0218, 'lps'),
	(556321, 127, '2014-03-01 01:06:28.000000', 'consum', 0.0210, 'lps'),
	(556322, 127, '2014-03-01 01:06:29.000000', 'consum', 0.0215, 'lps'),
	(556323, 127, '2014-03-01 01:06:30.000000', 'consum', 0.0235, 'lps'),
	(556324, 127, '2014-03-01 01:06:31.000000', 'consum', 0.0233, 'lps'),
	(556325, 127, '2014-03-01 01:06:32.000000', 'consum', 0.0221, 'lps'),
	(556326, 127, '2014-03-01 01:06:33.000000', 'consum', 0.0227, 'lps'),
	(556327, 127, '2014-03-01 01:06:34.000000', 'consum', 0.0233, 'lps'),
	(556328, 127, '2014-03-01 01:06:35.000000', 'consum', 0.0216, 'lps'),
	(556329, 127, '2014-03-01 01:06:36.000000', 'consum', 0.0230, 'lps'),
	(556330, 127, '2014-03-01 01:06:37.000000', 'consum', 0.0236, 'lps'),
	(556331, 127, '2014-03-01 01:06:38.000000', 'consum', 0.0220, 'lps'),
	(556332, 127, '2014-03-01 01:06:39.000000', 'consum', 0.0213, 'lps'),
	(556333, 127, '2014-03-01 01:06:40.000000', 'consum', 0.0224, 'lps'),
	(556334, 127, '2014-03-01 01:06:41.000000', 'consum', 0.0213, 'lps'),
	(556335, 127, '2014-03-01 01:06:42.000000', 'consum', 0.0212, 'lps'),
	(556336, 127, '2014-03-01 01:06:43.000000', 'consum', 0.0210, 'lps'),
	(556337, 127, '2014-03-01 01:06:44.000000', 'consum', 0.0237, 'lps'),
	(556338, 127, '2014-03-01 01:06:45.000000', 'consum', 0.0226, 'lps'),
	(556339, 127, '2014-03-01 01:06:46.000000', 'consum', 0.0212, 'lps'),
	(556340, 127, '2014-03-01 01:06:47.000000', 'consum', 0.0229, 'lps'),
	(556341, 127, '2014-03-01 01:06:48.000000', 'consum', 0.0212, 'lps'),
	(556342, 127, '2014-03-01 01:06:49.000000', 'consum', 0.0221, 'lps'),
	(556343, 127, '2014-03-01 01:06:50.000000', 'consum', 0.0229, 'lps'),
	(556344, 127, '2014-03-01 01:06:51.000000', 'consum', 0.0218, 'lps'),
	(556345, 127, '2014-03-01 01:06:52.000000', 'consum', 0.0220, 'lps'),
	(556346, 127, '2014-03-01 01:06:53.000000', 'consum', 0.0237, 'lps'),
	(556347, 127, '2014-03-01 01:06:54.000000', 'consum', 0.0227, 'lps'),
	(556348, 127, '2014-03-01 01:06:55.000000', 'consum', 0.0215, 'lps'),
	(556349, 127, '2014-03-01 01:06:56.000000', 'consum', 0.0214, 'lps'),
	(556350, 127, '2014-03-01 01:06:57.000000', 'consum', 0.0214, 'lps'),
	(556351, 127, '2014-03-01 01:06:58.000000', 'consum', 0.0219, 'lps'),
	(556352, 127, '2014-03-01 01:06:59.000000', 'consum', 0.0213, 'lps'),
	(556353, 127, '2014-03-01 01:07:00.000000', 'consum', 0.0231, 'lps'),
	(556354, 127, '2014-03-01 01:07:01.000000', 'consum', 0.0217, 'lps'),
	(556355, 127, '2014-03-01 01:07:02.000000', 'consum', 0.0214, 'lps'),
	(556356, 127, '2014-03-01 01:07:03.000000', 'consum', 0.0236, 'lps'),
	(556357, 127, '2014-03-01 01:07:04.000000', 'consum', 0.0214, 'lps'),
	(556358, 127, '2014-03-01 01:07:05.000000', 'consum', 0.0210, 'lps'),
	(556359, 127, '2014-03-01 01:07:06.000000', 'consum', 0.0229, 'lps'),
	(556360, 127, '2014-03-01 01:07:07.000000', 'consum', 0.0219, 'lps'),
	(556361, 127, '2014-03-01 01:07:08.000000', 'consum', 0.0227, 'lps'),
	(556362, 127, '2014-03-01 01:07:09.000000', 'consum', 0.0211, 'lps'),
	(556363, 127, '2014-03-01 01:07:10.000000', 'consum', 0.0223, 'lps'),
	(556364, 127, '2014-03-01 01:07:11.000000', 'consum', 0.0214, 'lps'),
	(556365, 127, '2014-03-01 01:07:12.000000', 'consum', 0.0219, 'lps'),
	(556366, 127, '2014-03-01 01:07:13.000000', 'consum', 0.0216, 'lps'),
	(556367, 127, '2014-03-01 01:07:14.000000', 'consum', 0.0212, 'lps'),
	(556368, 127, '2014-03-01 01:07:15.000000', 'consum', 0.0234, 'lps'),
	(556369, 127, '2014-03-01 01:07:16.000000', 'consum', 0.0237, 'lps'),
	(556370, 127, '2014-03-01 01:07:17.000000', 'consum', 0.0213, 'lps'),
	(556371, 127, '2014-03-01 01:07:18.000000', 'consum', 0.0235, 'lps'),
	(556372, 127, '2014-03-01 01:07:19.000000', 'consum', 0.0237, 'lps'),
	(556373, 127, '2014-03-01 01:07:20.000000', 'consum', 0.0213, 'lps'),
	(556374, 127, '2014-03-01 01:07:21.000000', 'consum', 0.0230, 'lps'),
	(556375, 127, '2014-03-01 01:07:22.000000', 'consum', 0.0216, 'lps'),
	(556376, 127, '2014-03-01 01:07:23.000000', 'consum', 0.0236, 'lps'),
	(556377, 127, '2014-03-01 01:07:24.000000', 'consum', 0.0210, 'lps'),
	(556378, 127, '2014-03-01 01:07:25.000000', 'consum', 0.0216, 'lps'),
	(556379, 127, '2014-03-01 01:07:26.000000', 'consum', 0.0214, 'lps'),
	(556380, 127, '2014-03-01 01:07:27.000000', 'consum', 0.0210, 'lps'),
	(556381, 127, '2014-03-01 01:07:28.000000', 'consum', 0.0231, 'lps'),
	(556382, 127, '2014-03-01 01:07:29.000000', 'consum', 0.0225, 'lps'),
	(556383, 127, '2014-03-01 01:07:30.000000', 'consum', 0.0226, 'lps'),
	(556384, 127, '2014-03-01 01:07:31.000000', 'consum', 0.0213, 'lps'),
	(556385, 127, '2014-03-01 01:07:32.000000', 'consum', 0.0238, 'lps'),
	(556386, 127, '2014-03-01 01:07:33.000000', 'consum', 0.0226, 'lps'),
	(556387, 127, '2014-03-01 01:07:34.000000', 'consum', 0.0235, 'lps'),
	(556388, 127, '2014-03-01 01:07:35.000000', 'consum', 0.0227, 'lps'),
	(556389, 127, '2014-03-01 01:07:36.000000', 'consum', 0.0224, 'lps'),
	(556390, 127, '2014-03-01 01:07:37.000000', 'consum', 0.0227, 'lps'),
	(556391, 127, '2014-03-01 01:07:38.000000', 'consum', 0.0224, 'lps'),
	(556392, 127, '2014-03-01 01:07:39.000000', 'consum', 0.0230, 'lps'),
	(556393, 127, '2014-03-01 01:07:40.000000', 'consum', 0.0238, 'lps'),
	(556394, 127, '2014-03-01 01:07:41.000000', 'consum', 0.0234, 'lps'),
	(556395, 127, '2014-03-01 01:07:42.000000', 'consum', 0.0216, 'lps'),
	(556396, 127, '2014-03-01 01:07:43.000000', 'consum', 0.0226, 'lps'),
	(556397, 127, '2014-03-01 01:07:44.000000', 'consum', 0.0214, 'lps'),
	(556398, 127, '2014-03-01 01:07:45.000000', 'consum', 0.0211, 'lps'),
	(556399, 127, '2014-03-01 01:07:46.000000', 'consum', 0.0233, 'lps'),
	(556400, 127, '2014-03-01 01:07:47.000000', 'consum', 0.0238, 'lps'),
	(556401, 127, '2014-03-01 01:07:48.000000', 'consum', 0.0220, 'lps'),
	(556402, 127, '2014-03-01 01:07:49.000000', 'consum', 0.0237, 'lps'),
	(556403, 127, '2014-03-01 01:07:50.000000', 'consum', 0.0226, 'lps'),
	(556404, 127, '2014-03-01 01:07:51.000000', 'consum', 0.0210, 'lps'),
	(556405, 127, '2014-03-01 01:07:52.000000', 'consum', 0.0220, 'lps'),
	(556406, 127, '2014-03-01 01:07:53.000000', 'consum', 0.0232, 'lps'),
	(556407, 127, '2014-03-01 01:07:54.000000', 'consum', 0.0231, 'lps'),
	(556408, 127, '2014-03-01 01:07:55.000000', 'consum', 0.0222, 'lps'),
	(556409, 127, '2014-03-01 01:07:56.000000', 'consum', 0.0237, 'lps'),
	(556410, 127, '2014-03-01 01:07:57.000000', 'consum', 0.0222, 'lps'),
	(556411, 127, '2014-03-01 01:07:58.000000', 'consum', 0.0218, 'lps'),
	(556412, 127, '2014-03-01 01:07:59.000000', 'consum', 0.0216, 'lps'),
	(556413, 127, '2014-03-01 01:08:00.000000', 'consum', 0.0216, 'lps'),
	(556414, 127, '2014-03-01 01:08:01.000000', 'consum', 0.0222, 'lps'),
	(556415, 127, '2014-03-01 01:08:02.000000', 'consum', 0.0222, 'lps'),
	(556416, 127, '2014-03-01 01:08:03.000000', 'consum', 0.0236, 'lps'),
	(556417, 127, '2014-03-01 01:08:04.000000', 'consum', 0.0218, 'lps'),
	(556418, 127, '2014-03-01 01:08:05.000000', 'consum', 0.0232, 'lps'),
	(556419, 127, '2014-03-01 01:08:06.000000', 'consum', 0.0236, 'lps'),
	(556420, 127, '2014-03-01 01:08:07.000000', 'consum', 0.0217, 'lps'),
	(556421, 127, '2014-03-01 01:08:08.000000', 'consum', 0.0225, 'lps'),
	(556422, 127, '2014-03-01 01:08:09.000000', 'consum', 0.0237, 'lps'),
	(556423, 127, '2014-03-01 01:08:10.000000', 'consum', 0.0212, 'lps'),
	(556424, 127, '2014-03-01 01:08:11.000000', 'consum', 0.0229, 'lps'),
	(556425, 127, '2014-03-01 01:08:12.000000', 'consum', 0.0210, 'lps'),
	(556426, 127, '2014-03-01 01:08:13.000000', 'consum', 0.0210, 'lps'),
	(556427, 127, '2014-03-01 01:08:14.000000', 'consum', 0.0213, 'lps'),
	(556428, 127, '2014-03-01 01:08:15.000000', 'consum', 0.0224, 'lps'),
	(556429, 127, '2014-03-01 01:08:16.000000', 'consum', 0.0215, 'lps'),
	(556430, 127, '2014-03-01 01:08:17.000000', 'consum', 0.0222, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(556431, 127, '2014-03-01 01:08:18.000000', 'consum', 0.0226, 'lps'),
	(556432, 127, '2014-03-01 01:08:19.000000', 'consum', 0.0227, 'lps'),
	(556433, 127, '2014-03-01 01:08:20.000000', 'consum', 0.0216, 'lps'),
	(556434, 127, '2014-03-01 01:08:21.000000', 'consum', 0.0219, 'lps'),
	(556435, 127, '2014-03-01 01:08:22.000000', 'consum', 0.0211, 'lps'),
	(556436, 127, '2014-03-01 01:08:23.000000', 'consum', 0.0215, 'lps'),
	(556437, 127, '2014-03-01 01:08:24.000000', 'consum', 0.0235, 'lps'),
	(556438, 127, '2014-03-01 01:08:25.000000', 'consum', 0.0231, 'lps'),
	(556439, 127, '2014-03-01 01:08:26.000000', 'consum', 0.0214, 'lps'),
	(556440, 127, '2014-03-01 01:08:27.000000', 'consum', 0.0224, 'lps'),
	(556441, 127, '2014-03-01 01:08:28.000000', 'consum', 0.0211, 'lps'),
	(556442, 127, '2014-03-01 01:08:29.000000', 'consum', 0.0232, 'lps'),
	(556443, 127, '2014-03-01 01:08:30.000000', 'consum', 0.0228, 'lps'),
	(556444, 127, '2014-03-01 01:08:31.000000', 'consum', 0.0237, 'lps'),
	(556445, 127, '2014-03-01 01:08:32.000000', 'consum', 0.0231, 'lps'),
	(556446, 127, '2014-03-01 01:08:33.000000', 'consum', 0.0234, 'lps'),
	(556447, 127, '2014-03-01 01:08:34.000000', 'consum', 0.0212, 'lps'),
	(556448, 127, '2014-03-01 01:08:35.000000', 'consum', 0.0233, 'lps'),
	(556449, 127, '2014-03-01 01:08:36.000000', 'consum', 0.0232, 'lps'),
	(556450, 127, '2014-03-01 01:08:37.000000', 'consum', 0.0225, 'lps'),
	(556451, 127, '2014-03-01 01:08:38.000000', 'consum', 0.0218, 'lps'),
	(556452, 127, '2014-03-01 01:08:39.000000', 'consum', 0.0237, 'lps'),
	(556453, 127, '2014-03-01 01:08:40.000000', 'consum', 0.0233, 'lps'),
	(556454, 127, '2014-03-01 01:08:41.000000', 'consum', 0.0215, 'lps'),
	(556455, 127, '2014-03-01 01:08:42.000000', 'consum', 0.0223, 'lps'),
	(556456, 127, '2014-03-01 01:08:43.000000', 'consum', 0.0234, 'lps'),
	(556457, 127, '2014-03-01 01:08:44.000000', 'consum', 0.0234, 'lps'),
	(556458, 127, '2014-03-01 01:08:45.000000', 'consum', 0.0229, 'lps'),
	(556459, 127, '2014-03-01 01:08:46.000000', 'consum', 0.0233, 'lps'),
	(556460, 127, '2014-03-01 01:08:47.000000', 'consum', 0.0210, 'lps'),
	(556461, 127, '2014-03-01 01:08:48.000000', 'consum', 0.0229, 'lps'),
	(556462, 127, '2014-03-01 01:08:49.000000', 'consum', 0.0218, 'lps'),
	(556463, 127, '2014-03-01 01:08:50.000000', 'consum', 0.0224, 'lps'),
	(556464, 127, '2014-03-01 01:08:51.000000', 'consum', 0.0228, 'lps'),
	(556465, 127, '2014-03-01 01:08:52.000000', 'consum', 0.0228, 'lps'),
	(556466, 127, '2014-03-01 01:08:53.000000', 'consum', 0.0220, 'lps'),
	(556467, 127, '2014-03-01 01:08:54.000000', 'consum', 0.0234, 'lps'),
	(556468, 127, '2014-03-01 01:08:55.000000', 'consum', 0.0214, 'lps'),
	(556469, 127, '2014-03-01 01:08:56.000000', 'consum', 0.0214, 'lps'),
	(556470, 127, '2014-03-01 01:08:57.000000', 'consum', 0.0221, 'lps'),
	(556471, 127, '2014-03-01 01:08:58.000000', 'consum', 0.0223, 'lps'),
	(556472, 127, '2014-03-01 01:08:59.000000', 'consum', 0.0216, 'lps'),
	(556473, 127, '2014-03-01 01:09:00.000000', 'consum', 0.0227, 'lps'),
	(556474, 127, '2014-03-01 01:09:01.000000', 'consum', 0.0222, 'lps'),
	(556475, 127, '2014-03-01 01:09:02.000000', 'consum', 0.0217, 'lps'),
	(556476, 127, '2014-03-01 01:09:03.000000', 'consum', 0.0213, 'lps'),
	(556477, 127, '2014-03-01 01:09:04.000000', 'consum', 0.0231, 'lps'),
	(556478, 127, '2014-03-01 01:09:05.000000', 'consum', 0.0220, 'lps'),
	(556479, 127, '2014-03-01 01:09:06.000000', 'consum', 0.0229, 'lps'),
	(556480, 127, '2014-03-01 01:09:07.000000', 'consum', 0.0214, 'lps'),
	(556481, 127, '2014-03-01 01:09:08.000000', 'consum', 0.0232, 'lps'),
	(556482, 127, '2014-03-01 01:09:09.000000', 'consum', 0.0220, 'lps'),
	(556483, 127, '2014-03-01 01:09:10.000000', 'consum', 0.0227, 'lps'),
	(556484, 127, '2014-03-01 01:09:11.000000', 'consum', 0.0234, 'lps'),
	(556485, 127, '2014-03-01 01:09:12.000000', 'consum', 0.0221, 'lps'),
	(556486, 127, '2014-03-01 01:09:13.000000', 'consum', 0.0224, 'lps'),
	(556487, 127, '2014-03-01 01:09:14.000000', 'consum', 0.0217, 'lps'),
	(556488, 127, '2014-03-01 01:09:15.000000', 'consum', 0.0233, 'lps'),
	(556489, 127, '2014-03-01 01:09:16.000000', 'consum', 0.0216, 'lps'),
	(556490, 127, '2014-03-01 01:09:17.000000', 'consum', 0.0229, 'lps'),
	(556491, 127, '2014-03-01 01:09:18.000000', 'consum', 0.0230, 'lps'),
	(556492, 127, '2014-03-01 01:09:19.000000', 'consum', 0.0223, 'lps'),
	(556493, 127, '2014-03-01 01:09:20.000000', 'consum', 0.0216, 'lps'),
	(556494, 127, '2014-03-01 01:09:21.000000', 'consum', 0.0232, 'lps'),
	(556495, 127, '2014-03-01 01:09:22.000000', 'consum', 0.0213, 'lps'),
	(556496, 127, '2014-03-01 01:09:23.000000', 'consum', 0.0218, 'lps'),
	(556497, 127, '2014-03-01 01:09:24.000000', 'consum', 0.0212, 'lps'),
	(556498, 127, '2014-03-01 01:09:25.000000', 'consum', 0.0227, 'lps'),
	(556499, 127, '2014-03-01 01:09:26.000000', 'consum', 0.0229, 'lps'),
	(556500, 127, '2014-03-01 01:09:27.000000', 'consum', 0.0227, 'lps'),
	(556501, 127, '2014-03-01 01:09:28.000000', 'consum', 0.0211, 'lps'),
	(556502, 127, '2014-03-01 01:09:29.000000', 'consum', 0.0222, 'lps'),
	(556503, 127, '2014-03-01 01:09:30.000000', 'consum', 0.0237, 'lps'),
	(556504, 127, '2014-03-01 01:09:31.000000', 'consum', 0.0223, 'lps'),
	(556505, 127, '2014-03-01 01:09:32.000000', 'consum', 0.0224, 'lps'),
	(556506, 127, '2014-03-01 01:09:33.000000', 'consum', 0.0214, 'lps'),
	(556507, 127, '2014-03-01 01:09:34.000000', 'consum', 0.0218, 'lps'),
	(556508, 127, '2014-03-01 01:09:35.000000', 'consum', 0.0236, 'lps'),
	(556509, 127, '2014-03-01 01:09:36.000000', 'consum', 0.0229, 'lps'),
	(556510, 127, '2014-03-01 01:09:37.000000', 'consum', 0.0230, 'lps'),
	(556511, 127, '2014-03-01 01:09:38.000000', 'consum', 0.0225, 'lps'),
	(556512, 127, '2014-03-01 01:09:39.000000', 'consum', 0.0225, 'lps'),
	(556513, 127, '2014-03-01 01:09:40.000000', 'consum', 0.0238, 'lps'),
	(556514, 127, '2014-03-01 01:09:41.000000', 'consum', 0.0221, 'lps'),
	(556515, 127, '2014-03-01 01:09:42.000000', 'consum', 0.0211, 'lps'),
	(556516, 127, '2014-03-01 01:09:43.000000', 'consum', 0.0211, 'lps'),
	(556517, 127, '2014-03-01 01:09:44.000000', 'consum', 0.0213, 'lps'),
	(556518, 127, '2014-03-01 01:09:45.000000', 'consum', 0.0222, 'lps'),
	(556519, 127, '2014-03-01 01:09:46.000000', 'consum', 0.0233, 'lps'),
	(556520, 127, '2014-03-01 01:09:47.000000', 'consum', 0.0232, 'lps'),
	(556521, 127, '2014-03-01 01:09:48.000000', 'consum', 0.0222, 'lps'),
	(556522, 127, '2014-03-01 01:09:49.000000', 'consum', 0.0233, 'lps'),
	(556523, 127, '2014-03-01 01:09:50.000000', 'consum', 0.0233, 'lps'),
	(556524, 127, '2014-03-01 01:09:51.000000', 'consum', 0.0225, 'lps'),
	(556525, 127, '2014-03-01 01:09:52.000000', 'consum', 0.0219, 'lps'),
	(556526, 127, '2014-03-01 01:09:53.000000', 'consum', 0.0211, 'lps'),
	(556527, 127, '2014-03-01 01:09:54.000000', 'consum', 0.0216, 'lps'),
	(556528, 127, '2014-03-01 01:09:55.000000', 'consum', 0.0237, 'lps'),
	(556529, 127, '2014-03-01 01:09:56.000000', 'consum', 0.0214, 'lps'),
	(556530, 127, '2014-03-01 01:09:57.000000', 'consum', 0.0235, 'lps'),
	(556531, 127, '2014-03-01 01:09:58.000000', 'consum', 0.0238, 'lps'),
	(556532, 127, '2014-03-01 01:09:59.000000', 'consum', 0.0218, 'lps'),
	(556533, 127, '2014-03-01 01:10:00.000000', 'consum', 0.0222, 'lps'),
	(556534, 127, '2014-03-01 01:10:01.000000', 'consum', 0.0216, 'lps'),
	(556535, 127, '2014-03-01 01:10:02.000000', 'consum', 0.0237, 'lps'),
	(556536, 127, '2014-03-01 01:10:03.000000', 'consum', 0.0210, 'lps'),
	(556537, 127, '2014-03-01 01:10:04.000000', 'consum', 0.0217, 'lps'),
	(556538, 127, '2014-03-01 01:10:05.000000', 'consum', 0.0216, 'lps'),
	(556539, 127, '2014-03-01 01:10:06.000000', 'consum', 0.0219, 'lps'),
	(556540, 127, '2014-03-01 01:10:07.000000', 'consum', 0.0237, 'lps'),
	(556541, 127, '2014-03-01 01:10:08.000000', 'consum', 0.0234, 'lps'),
	(556542, 127, '2014-03-01 01:10:09.000000', 'consum', 0.0220, 'lps'),
	(556543, 127, '2014-03-01 01:10:10.000000', 'consum', 0.0215, 'lps'),
	(556544, 127, '2014-03-01 01:10:11.000000', 'consum', 0.0237, 'lps'),
	(556545, 127, '2014-03-01 01:10:12.000000', 'consum', 0.0213, 'lps'),
	(556546, 127, '2014-03-01 01:10:13.000000', 'consum', 0.0231, 'lps'),
	(556547, 127, '2014-03-01 01:10:14.000000', 'consum', 0.0219, 'lps'),
	(556548, 127, '2014-03-01 01:10:15.000000', 'consum', 0.0221, 'lps'),
	(556549, 127, '2014-03-01 01:10:16.000000', 'consum', 0.0238, 'lps'),
	(556550, 127, '2014-03-01 01:10:17.000000', 'consum', 0.0230, 'lps'),
	(556551, 127, '2014-03-01 01:10:18.000000', 'consum', 0.0229, 'lps'),
	(556552, 127, '2014-03-01 01:10:19.000000', 'consum', 0.0217, 'lps'),
	(556553, 127, '2014-03-01 01:10:20.000000', 'consum', 0.0217, 'lps'),
	(556554, 127, '2014-03-01 01:10:21.000000', 'consum', 0.0225, 'lps'),
	(556555, 127, '2014-03-01 01:10:22.000000', 'consum', 0.0236, 'lps'),
	(556556, 127, '2014-03-01 01:10:23.000000', 'consum', 0.0238, 'lps'),
	(556557, 127, '2014-03-01 01:10:24.000000', 'consum', 0.0214, 'lps'),
	(556558, 127, '2014-03-01 01:10:25.000000', 'consum', 0.0234, 'lps'),
	(556559, 127, '2014-03-01 01:10:26.000000', 'consum', 0.0232, 'lps'),
	(556560, 127, '2014-03-01 01:10:27.000000', 'consum', 0.0220, 'lps'),
	(556561, 127, '2014-03-01 01:10:28.000000', 'consum', 0.0225, 'lps'),
	(556562, 127, '2014-03-01 01:10:29.000000', 'consum', 0.0223, 'lps'),
	(556563, 127, '2014-03-01 01:10:30.000000', 'consum', 0.0232, 'lps'),
	(556564, 127, '2014-03-01 01:10:31.000000', 'consum', 0.0223, 'lps'),
	(556565, 127, '2014-03-01 01:10:32.000000', 'consum', 0.0238, 'lps'),
	(556566, 127, '2014-03-01 01:10:33.000000', 'consum', 0.0225, 'lps'),
	(556567, 127, '2014-03-01 01:10:34.000000', 'consum', 0.0229, 'lps'),
	(556568, 127, '2014-03-01 01:10:35.000000', 'consum', 0.0232, 'lps'),
	(556569, 127, '2014-03-01 01:10:36.000000', 'consum', 0.0233, 'lps'),
	(556570, 127, '2014-03-01 01:10:37.000000', 'consum', 0.0233, 'lps'),
	(556571, 127, '2014-03-01 01:10:38.000000', 'consum', 0.0227, 'lps'),
	(556572, 127, '2014-03-01 01:10:39.000000', 'consum', 0.0228, 'lps'),
	(556573, 127, '2014-03-01 01:10:40.000000', 'consum', 0.0218, 'lps'),
	(556574, 127, '2014-03-01 01:10:41.000000', 'consum', 0.0228, 'lps'),
	(556575, 127, '2014-03-01 01:10:42.000000', 'consum', 0.0219, 'lps'),
	(556576, 127, '2014-03-01 01:10:43.000000', 'consum', 0.0228, 'lps'),
	(556577, 127, '2014-03-01 01:10:44.000000', 'consum', 0.0215, 'lps'),
	(556578, 127, '2014-03-01 01:10:45.000000', 'consum', 0.0211, 'lps'),
	(556579, 127, '2014-03-01 01:10:46.000000', 'consum', 0.0231, 'lps'),
	(556580, 127, '2014-03-01 01:10:47.000000', 'consum', 0.0226, 'lps'),
	(556581, 127, '2014-03-01 01:10:48.000000', 'consum', 0.0228, 'lps'),
	(556582, 127, '2014-03-01 01:10:49.000000', 'consum', 0.0222, 'lps'),
	(556583, 127, '2014-03-01 01:10:50.000000', 'consum', 0.0217, 'lps'),
	(556584, 127, '2014-03-01 01:10:51.000000', 'consum', 0.0238, 'lps'),
	(556585, 127, '2014-03-01 01:10:52.000000', 'consum', 0.0212, 'lps'),
	(556586, 127, '2014-03-01 01:10:53.000000', 'consum', 0.0225, 'lps'),
	(556587, 127, '2014-03-01 01:10:54.000000', 'consum', 0.0223, 'lps'),
	(556588, 127, '2014-03-01 01:10:55.000000', 'consum', 0.0227, 'lps'),
	(556589, 127, '2014-03-01 01:10:56.000000', 'consum', 0.0231, 'lps'),
	(556590, 127, '2014-03-01 01:10:57.000000', 'consum', 0.0233, 'lps'),
	(556591, 127, '2014-03-01 01:10:58.000000', 'consum', 0.0235, 'lps'),
	(556592, 127, '2014-03-01 01:10:59.000000', 'consum', 0.0236, 'lps'),
	(556593, 127, '2014-03-01 01:11:00.000000', 'consum', 0.0238, 'lps'),
	(556594, 127, '2014-03-01 01:11:01.000000', 'consum', 0.0212, 'lps'),
	(556595, 127, '2014-03-01 01:11:02.000000', 'consum', 0.0227, 'lps'),
	(556596, 127, '2014-03-01 01:11:03.000000', 'consum', 0.0230, 'lps'),
	(556597, 127, '2014-03-01 01:11:04.000000', 'consum', 0.0230, 'lps'),
	(556598, 127, '2014-03-01 01:11:05.000000', 'consum', 0.0221, 'lps'),
	(556599, 127, '2014-03-01 01:11:06.000000', 'consum', 0.0234, 'lps'),
	(556600, 127, '2014-03-01 01:11:07.000000', 'consum', 0.0212, 'lps'),
	(556601, 127, '2014-03-01 01:11:08.000000', 'consum', 0.0234, 'lps'),
	(556602, 127, '2014-03-01 01:11:09.000000', 'consum', 0.0237, 'lps'),
	(556603, 127, '2014-03-01 01:11:10.000000', 'consum', 0.0217, 'lps'),
	(556604, 127, '2014-03-01 01:11:11.000000', 'consum', 0.0222, 'lps'),
	(556605, 127, '2014-03-01 01:11:12.000000', 'consum', 0.0220, 'lps'),
	(556606, 127, '2014-03-01 01:11:13.000000', 'consum', 0.0223, 'lps'),
	(556607, 127, '2014-03-01 01:11:14.000000', 'consum', 0.0217, 'lps'),
	(556608, 127, '2014-03-01 01:11:15.000000', 'consum', 0.0238, 'lps'),
	(556609, 127, '2014-03-01 01:11:16.000000', 'consum', 0.0212, 'lps'),
	(556610, 127, '2014-03-01 01:11:17.000000', 'consum', 0.0226, 'lps'),
	(556611, 127, '2014-03-01 01:11:18.000000', 'consum', 0.0223, 'lps'),
	(556612, 127, '2014-03-01 01:11:19.000000', 'consum', 0.0230, 'lps'),
	(556613, 127, '2014-03-01 01:11:20.000000', 'consum', 0.0213, 'lps'),
	(556614, 127, '2014-03-01 01:11:21.000000', 'consum', 0.0224, 'lps'),
	(556615, 127, '2014-03-01 01:11:22.000000', 'consum', 0.0214, 'lps'),
	(556616, 127, '2014-03-01 01:11:23.000000', 'consum', 0.0218, 'lps'),
	(556617, 127, '2014-03-01 01:11:24.000000', 'consum', 0.0238, 'lps'),
	(556618, 127, '2014-03-01 01:11:25.000000', 'consum', 0.0212, 'lps'),
	(556619, 127, '2014-03-01 01:11:26.000000', 'consum', 0.0222, 'lps'),
	(556620, 127, '2014-03-01 01:11:27.000000', 'consum', 0.0234, 'lps'),
	(556621, 127, '2014-03-01 01:11:28.000000', 'consum', 0.0210, 'lps'),
	(556622, 127, '2014-03-01 01:11:29.000000', 'consum', 0.0226, 'lps'),
	(556623, 127, '2014-03-01 01:11:30.000000', 'consum', 0.0230, 'lps'),
	(556624, 127, '2014-03-01 01:11:31.000000', 'consum', 0.0235, 'lps'),
	(556625, 127, '2014-03-01 01:11:32.000000', 'consum', 0.0219, 'lps'),
	(556626, 127, '2014-03-01 01:11:33.000000', 'consum', 0.0238, 'lps'),
	(556627, 127, '2014-03-01 01:11:34.000000', 'consum', 0.0236, 'lps'),
	(556628, 127, '2014-03-01 01:11:35.000000', 'consum', 0.0227, 'lps'),
	(556629, 127, '2014-03-01 01:11:36.000000', 'consum', 0.0216, 'lps'),
	(556630, 127, '2014-03-01 01:11:37.000000', 'consum', 0.0219, 'lps'),
	(556631, 127, '2014-03-01 01:11:38.000000', 'consum', 0.0211, 'lps'),
	(556632, 127, '2014-03-01 01:11:39.000000', 'consum', 0.0216, 'lps'),
	(556633, 127, '2014-03-01 01:11:40.000000', 'consum', 0.0235, 'lps'),
	(556634, 127, '2014-03-01 01:11:41.000000', 'consum', 0.0234, 'lps'),
	(556635, 127, '2014-03-01 01:11:42.000000', 'consum', 0.0227, 'lps'),
	(556636, 127, '2014-03-01 01:11:43.000000', 'consum', 0.0221, 'lps'),
	(556637, 127, '2014-03-01 01:11:44.000000', 'consum', 0.0213, 'lps'),
	(556638, 127, '2014-03-01 01:11:45.000000', 'consum', 0.0225, 'lps'),
	(556639, 127, '2014-03-01 01:11:46.000000', 'consum', 0.0217, 'lps'),
	(556640, 127, '2014-03-01 01:11:47.000000', 'consum', 0.0229, 'lps'),
	(556641, 127, '2014-03-01 01:11:48.000000', 'consum', 0.0226, 'lps'),
	(556642, 127, '2014-03-01 01:11:49.000000', 'consum', 0.0236, 'lps'),
	(556643, 127, '2014-03-01 01:11:50.000000', 'consum', 0.0231, 'lps'),
	(556644, 127, '2014-03-01 01:11:51.000000', 'consum', 0.0210, 'lps'),
	(556645, 127, '2014-03-01 01:11:52.000000', 'consum', 0.0237, 'lps'),
	(556646, 127, '2014-03-01 01:11:53.000000', 'consum', 0.0226, 'lps'),
	(556647, 127, '2014-03-01 01:11:54.000000', 'consum', 0.0210, 'lps'),
	(556648, 127, '2014-03-01 01:11:55.000000', 'consum', 0.0222, 'lps'),
	(556649, 127, '2014-03-01 01:11:56.000000', 'consum', 0.0210, 'lps'),
	(556650, 127, '2014-03-01 01:11:57.000000', 'consum', 0.0233, 'lps'),
	(556651, 127, '2014-03-01 01:11:58.000000', 'consum', 0.0212, 'lps'),
	(556652, 127, '2014-03-01 01:11:59.000000', 'consum', 0.0237, 'lps'),
	(556653, 127, '2014-03-01 01:12:00.000000', 'consum', 0.0224, 'lps'),
	(556654, 127, '2014-03-01 01:12:01.000000', 'consum', 0.0229, 'lps'),
	(556655, 127, '2014-03-01 01:12:02.000000', 'consum', 0.0234, 'lps'),
	(556656, 127, '2014-03-01 01:12:03.000000', 'consum', 0.0214, 'lps'),
	(556657, 127, '2014-03-01 01:12:04.000000', 'consum', 0.0218, 'lps'),
	(556658, 127, '2014-03-01 01:12:05.000000', 'consum', 0.0210, 'lps'),
	(556659, 127, '2014-03-01 01:12:06.000000', 'consum', 0.0217, 'lps'),
	(556660, 127, '2014-03-01 01:12:07.000000', 'consum', 0.0214, 'lps'),
	(556661, 127, '2014-03-01 01:12:08.000000', 'consum', 0.0210, 'lps'),
	(556662, 127, '2014-03-01 01:12:09.000000', 'consum', 0.0226, 'lps'),
	(556663, 127, '2014-03-01 01:12:10.000000', 'consum', 0.0234, 'lps'),
	(556664, 127, '2014-03-01 01:12:11.000000', 'consum', 0.0224, 'lps'),
	(556665, 127, '2014-03-01 01:12:12.000000', 'consum', 0.0210, 'lps'),
	(556666, 127, '2014-03-01 01:12:13.000000', 'consum', 0.0224, 'lps'),
	(556667, 127, '2014-03-01 01:12:14.000000', 'consum', 0.0225, 'lps'),
	(556668, 127, '2014-03-01 01:12:15.000000', 'consum', 0.0213, 'lps'),
	(556669, 127, '2014-03-01 01:12:16.000000', 'consum', 0.0212, 'lps'),
	(556670, 127, '2014-03-01 01:12:17.000000', 'consum', 0.0237, 'lps'),
	(556671, 127, '2014-03-01 01:12:18.000000', 'consum', 0.0226, 'lps'),
	(556672, 127, '2014-03-01 01:12:19.000000', 'consum', 0.0238, 'lps'),
	(556673, 127, '2014-03-01 01:12:20.000000', 'consum', 0.0215, 'lps'),
	(556674, 127, '2014-03-01 01:12:21.000000', 'consum', 0.0238, 'lps'),
	(556675, 127, '2014-03-01 01:12:22.000000', 'consum', 0.0220, 'lps'),
	(556676, 127, '2014-03-01 01:12:23.000000', 'consum', 0.0232, 'lps'),
	(556677, 127, '2014-03-01 01:12:24.000000', 'consum', 0.0236, 'lps'),
	(556678, 127, '2014-03-01 01:12:25.000000', 'consum', 0.0215, 'lps'),
	(556679, 127, '2014-03-01 01:12:26.000000', 'consum', 0.0214, 'lps'),
	(556680, 127, '2014-03-01 01:12:27.000000', 'consum', 0.0216, 'lps'),
	(556681, 127, '2014-03-01 01:12:28.000000', 'consum', 0.0229, 'lps'),
	(556682, 127, '2014-03-01 01:12:29.000000', 'consum', 0.0228, 'lps'),
	(556683, 127, '2014-03-01 01:12:30.000000', 'consum', 0.0216, 'lps'),
	(556684, 127, '2014-03-01 01:12:31.000000', 'consum', 0.0217, 'lps'),
	(556685, 127, '2014-03-01 01:12:32.000000', 'consum', 0.0227, 'lps'),
	(556686, 127, '2014-03-01 01:12:33.000000', 'consum', 0.0217, 'lps'),
	(556687, 127, '2014-03-01 01:12:34.000000', 'consum', 0.0221, 'lps'),
	(556688, 127, '2014-03-01 01:12:35.000000', 'consum', 0.0218, 'lps'),
	(556689, 127, '2014-03-01 01:12:36.000000', 'consum', 0.0217, 'lps'),
	(556690, 127, '2014-03-01 01:12:37.000000', 'consum', 0.0220, 'lps'),
	(556691, 127, '2014-03-01 01:12:38.000000', 'consum', 0.0213, 'lps'),
	(556692, 127, '2014-03-01 01:12:39.000000', 'consum', 0.0225, 'lps'),
	(556693, 127, '2014-03-01 01:12:40.000000', 'consum', 0.0216, 'lps'),
	(556694, 127, '2014-03-01 01:12:41.000000', 'consum', 0.0225, 'lps'),
	(556695, 127, '2014-03-01 01:12:42.000000', 'consum', 0.0210, 'lps'),
	(556696, 127, '2014-03-01 01:12:43.000000', 'consum', 0.0224, 'lps'),
	(556697, 127, '2014-03-01 01:12:44.000000', 'consum', 0.0223, 'lps'),
	(556698, 127, '2014-03-01 01:12:45.000000', 'consum', 0.0233, 'lps'),
	(556699, 127, '2014-03-01 01:12:46.000000', 'consum', 0.0226, 'lps'),
	(556700, 127, '2014-03-01 01:12:47.000000', 'consum', 0.0225, 'lps'),
	(556701, 127, '2014-03-01 01:12:48.000000', 'consum', 0.0235, 'lps'),
	(556702, 127, '2014-03-01 01:12:49.000000', 'consum', 0.0233, 'lps'),
	(556703, 127, '2014-03-01 01:12:50.000000', 'consum', 0.0220, 'lps'),
	(556704, 127, '2014-03-01 01:12:51.000000', 'consum', 0.0221, 'lps'),
	(556705, 127, '2014-03-01 01:12:52.000000', 'consum', 0.0238, 'lps'),
	(556706, 127, '2014-03-01 01:12:53.000000', 'consum', 0.0228, 'lps'),
	(556707, 127, '2014-03-01 01:12:54.000000', 'consum', 0.0219, 'lps'),
	(556708, 127, '2014-03-01 01:12:55.000000', 'consum', 0.0230, 'lps'),
	(556709, 127, '2014-03-01 01:12:56.000000', 'consum', 0.0224, 'lps'),
	(556710, 127, '2014-03-01 01:12:57.000000', 'consum', 0.0223, 'lps'),
	(556711, 127, '2014-03-01 01:12:58.000000', 'consum', 0.0234, 'lps'),
	(556712, 127, '2014-03-01 01:12:59.000000', 'consum', 0.0231, 'lps'),
	(556713, 127, '2014-03-01 01:13:00.000000', 'consum', 0.0214, 'lps'),
	(556714, 127, '2014-03-01 01:13:01.000000', 'consum', 0.0224, 'lps'),
	(556715, 127, '2014-03-01 01:13:02.000000', 'consum', 0.0214, 'lps'),
	(556716, 127, '2014-03-01 01:13:03.000000', 'consum', 0.0217, 'lps'),
	(556717, 127, '2014-03-01 01:13:04.000000', 'consum', 0.0234, 'lps'),
	(556718, 127, '2014-03-01 01:13:05.000000', 'consum', 0.0223, 'lps'),
	(556719, 127, '2014-03-01 01:13:06.000000', 'consum', 0.0230, 'lps'),
	(556720, 127, '2014-03-01 01:13:07.000000', 'consum', 0.0217, 'lps'),
	(556721, 127, '2014-03-01 01:13:08.000000', 'consum', 0.0211, 'lps'),
	(556722, 127, '2014-03-01 01:13:09.000000', 'consum', 0.0227, 'lps'),
	(556723, 127, '2014-03-01 01:13:10.000000', 'consum', 0.0231, 'lps'),
	(556724, 127, '2014-03-01 01:13:11.000000', 'consum', 0.0236, 'lps'),
	(556725, 127, '2014-03-01 01:13:12.000000', 'consum', 0.0222, 'lps'),
	(556726, 127, '2014-03-01 01:13:13.000000', 'consum', 0.0219, 'lps'),
	(556727, 127, '2014-03-01 01:13:14.000000', 'consum', 0.0219, 'lps'),
	(556728, 127, '2014-03-01 01:13:15.000000', 'consum', 0.0229, 'lps'),
	(556729, 127, '2014-03-01 01:13:16.000000', 'consum', 0.0223, 'lps'),
	(556730, 127, '2014-03-01 01:13:17.000000', 'consum', 0.0215, 'lps'),
	(556731, 127, '2014-03-01 01:13:18.000000', 'consum', 0.0227, 'lps'),
	(556732, 127, '2014-03-01 01:13:19.000000', 'consum', 0.0221, 'lps'),
	(556733, 127, '2014-03-01 01:13:20.000000', 'consum', 0.0217, 'lps'),
	(556734, 127, '2014-03-01 01:13:21.000000', 'consum', 0.0212, 'lps'),
	(556735, 127, '2014-03-01 01:13:22.000000', 'consum', 0.0229, 'lps'),
	(556736, 127, '2014-03-01 01:13:23.000000', 'consum', 0.0210, 'lps'),
	(556737, 127, '2014-03-01 01:13:24.000000', 'consum', 0.0215, 'lps'),
	(556738, 127, '2014-03-01 01:13:25.000000', 'consum', 0.0233, 'lps'),
	(556739, 127, '2014-03-01 01:13:26.000000', 'consum', 0.0225, 'lps'),
	(556740, 127, '2014-03-01 01:13:27.000000', 'consum', 0.0217, 'lps'),
	(556741, 127, '2014-03-01 01:13:28.000000', 'consum', 0.0227, 'lps'),
	(556742, 127, '2014-03-01 01:13:29.000000', 'consum', 0.0217, 'lps'),
	(556743, 127, '2014-03-01 01:13:30.000000', 'consum', 0.0225, 'lps'),
	(556744, 127, '2014-03-01 01:13:31.000000', 'consum', 0.0236, 'lps'),
	(556745, 127, '2014-03-01 01:13:32.000000', 'consum', 0.0210, 'lps'),
	(556746, 127, '2014-03-01 01:13:33.000000', 'consum', 0.0216, 'lps'),
	(556747, 127, '2014-03-01 01:13:34.000000', 'consum', 0.0215, 'lps'),
	(556748, 127, '2014-03-01 01:13:35.000000', 'consum', 0.0215, 'lps'),
	(556749, 127, '2014-03-01 01:13:36.000000', 'consum', 0.0220, 'lps'),
	(556750, 127, '2014-03-01 01:13:37.000000', 'consum', 0.0219, 'lps'),
	(556751, 127, '2014-03-01 01:13:38.000000', 'consum', 0.0224, 'lps'),
	(556752, 127, '2014-03-01 01:13:39.000000', 'consum', 0.0223, 'lps'),
	(556753, 127, '2014-03-01 01:13:40.000000', 'consum', 0.0236, 'lps'),
	(556754, 127, '2014-03-01 01:13:41.000000', 'consum', 0.0215, 'lps'),
	(556755, 127, '2014-03-01 01:13:42.000000', 'consum', 0.0214, 'lps'),
	(556756, 127, '2014-03-01 01:13:43.000000', 'consum', 0.0215, 'lps'),
	(556757, 127, '2014-03-01 01:13:44.000000', 'consum', 0.0222, 'lps'),
	(556758, 127, '2014-03-01 01:13:45.000000', 'consum', 0.0229, 'lps'),
	(556759, 127, '2014-03-01 01:13:46.000000', 'consum', 0.0238, 'lps'),
	(556760, 127, '2014-03-01 01:13:47.000000', 'consum', 0.0238, 'lps'),
	(556761, 127, '2014-03-01 01:13:48.000000', 'consum', 0.0236, 'lps'),
	(556762, 127, '2014-03-01 01:13:49.000000', 'consum', 0.0228, 'lps'),
	(556763, 127, '2014-03-01 01:13:50.000000', 'consum', 0.0222, 'lps'),
	(556764, 127, '2014-03-01 01:13:51.000000', 'consum', 0.0216, 'lps'),
	(556765, 127, '2014-03-01 01:13:52.000000', 'consum', 0.0235, 'lps'),
	(556766, 127, '2014-03-01 01:13:53.000000', 'consum', 0.0230, 'lps'),
	(556767, 127, '2014-03-01 01:13:54.000000', 'consum', 0.0235, 'lps'),
	(556768, 127, '2014-03-01 01:13:55.000000', 'consum', 0.0216, 'lps'),
	(556769, 127, '2014-03-01 01:13:56.000000', 'consum', 0.0224, 'lps'),
	(556770, 127, '2014-03-01 01:13:57.000000', 'consum', 0.0235, 'lps'),
	(556771, 127, '2014-03-01 01:13:58.000000', 'consum', 0.0234, 'lps'),
	(556772, 127, '2014-03-01 01:13:59.000000', 'consum', 0.0227, 'lps'),
	(556773, 127, '2014-03-01 01:14:00.000000', 'consum', 0.0222, 'lps'),
	(556774, 127, '2014-03-01 01:14:01.000000', 'consum', 0.0221, 'lps'),
	(556775, 127, '2014-03-01 01:14:02.000000', 'consum', 0.0229, 'lps'),
	(556776, 127, '2014-03-01 01:14:03.000000', 'consum', 0.0216, 'lps'),
	(556777, 127, '2014-03-01 01:14:04.000000', 'consum', 0.0212, 'lps'),
	(556778, 127, '2014-03-01 01:14:05.000000', 'consum', 0.0233, 'lps'),
	(556779, 127, '2014-03-01 01:14:06.000000', 'consum', 0.0232, 'lps'),
	(556780, 127, '2014-03-01 01:14:07.000000', 'consum', 0.0223, 'lps'),
	(556781, 127, '2014-03-01 01:14:08.000000', 'consum', 0.0211, 'lps'),
	(556782, 127, '2014-03-01 01:14:09.000000', 'consum', 0.0231, 'lps'),
	(556783, 127, '2014-03-01 01:14:10.000000', 'consum', 0.0229, 'lps'),
	(556784, 127, '2014-03-01 01:14:11.000000', 'consum', 0.0211, 'lps'),
	(556785, 127, '2014-03-01 01:14:12.000000', 'consum', 0.0215, 'lps'),
	(556786, 127, '2014-03-01 01:14:13.000000', 'consum', 0.0235, 'lps'),
	(556787, 127, '2014-03-01 01:14:14.000000', 'consum', 0.0231, 'lps'),
	(556788, 127, '2014-03-01 01:14:15.000000', 'consum', 0.0214, 'lps'),
	(556789, 127, '2014-03-01 01:14:16.000000', 'consum', 0.0223, 'lps'),
	(556790, 127, '2014-03-01 01:14:17.000000', 'consum', 0.0234, 'lps'),
	(556791, 127, '2014-03-01 01:14:18.000000', 'consum', 0.0236, 'lps'),
	(556792, 127, '2014-03-01 01:14:19.000000', 'consum', 0.0210, 'lps'),
	(556793, 127, '2014-03-01 01:14:20.000000', 'consum', 0.0217, 'lps'),
	(556794, 127, '2014-03-01 01:14:21.000000', 'consum', 0.0218, 'lps'),
	(556795, 127, '2014-03-01 01:14:22.000000', 'consum', 0.0230, 'lps'),
	(556796, 127, '2014-03-01 01:14:23.000000', 'consum', 0.0230, 'lps'),
	(556797, 127, '2014-03-01 01:14:24.000000', 'consum', 0.0221, 'lps'),
	(556798, 127, '2014-03-01 01:14:25.000000', 'consum', 0.0234, 'lps'),
	(556799, 127, '2014-03-01 01:14:26.000000', 'consum', 0.0212, 'lps'),
	(556800, 127, '2014-03-01 01:14:27.000000', 'consum', 0.0234, 'lps'),
	(556801, 127, '2014-03-01 01:14:28.000000', 'consum', 0.0211, 'lps'),
	(556802, 127, '2014-03-01 01:14:29.000000', 'consum', 0.0228, 'lps'),
	(556803, 127, '2014-03-01 01:14:30.000000', 'consum', 0.0210, 'lps'),
	(556804, 127, '2014-03-01 01:14:31.000000', 'consum', 0.0216, 'lps'),
	(556805, 127, '2014-03-01 01:14:32.000000', 'consum', 0.0211, 'lps'),
	(556806, 127, '2014-03-01 01:14:33.000000', 'consum', 0.0228, 'lps'),
	(556807, 127, '2014-03-01 01:14:34.000000', 'consum', 0.0237, 'lps'),
	(556808, 127, '2014-03-01 01:14:35.000000', 'consum', 0.0232, 'lps'),
	(556809, 127, '2014-03-01 01:14:36.000000', 'consum', 0.0214, 'lps'),
	(556810, 127, '2014-03-01 01:14:37.000000', 'consum', 0.0221, 'lps'),
	(556811, 127, '2014-03-01 01:14:38.000000', 'consum', 0.0223, 'lps'),
	(556812, 127, '2014-03-01 01:14:39.000000', 'consum', 0.0216, 'lps'),
	(556813, 127, '2014-03-01 01:14:40.000000', 'consum', 0.0230, 'lps'),
	(556814, 127, '2014-03-01 01:14:41.000000', 'consum', 0.0234, 'lps'),
	(556815, 127, '2014-03-01 01:14:42.000000', 'consum', 0.0215, 'lps'),
	(556816, 127, '2014-03-01 01:14:43.000000', 'consum', 0.0218, 'lps'),
	(556817, 127, '2014-03-01 01:14:44.000000', 'consum', 0.0237, 'lps'),
	(556818, 128, '2014-03-01 00:00:00.000000', 'consum', 0.0217, 'lps'),
	(556819, 128, '2014-03-01 00:00:01.000000', 'consum', 0.0213, 'lps'),
	(556820, 128, '2014-03-01 00:00:02.000000', 'consum', 0.0231, 'lps'),
	(556821, 128, '2014-03-01 00:00:03.000000', 'consum', 0.0230, 'lps'),
	(556822, 128, '2014-03-01 00:00:04.000000', 'consum', 0.0224, 'lps'),
	(556823, 128, '2014-03-01 00:00:05.000000', 'consum', 0.0219, 'lps'),
	(556824, 128, '2014-03-01 00:00:06.000000', 'consum', 0.0214, 'lps'),
	(556825, 128, '2014-03-01 00:00:07.000000', 'consum', 0.0228, 'lps'),
	(556826, 128, '2014-03-01 00:00:08.000000', 'consum', 0.0215, 'lps'),
	(556827, 128, '2014-03-01 00:00:09.000000', 'consum', 0.0233, 'lps'),
	(556828, 128, '2014-03-01 00:00:10.000000', 'consum', 0.0233, 'lps'),
	(556829, 128, '2014-03-01 00:00:11.000000', 'consum', 0.0231, 'lps'),
	(556830, 128, '2014-03-01 00:00:12.000000', 'consum', 0.0224, 'lps'),
	(556831, 128, '2014-03-01 00:00:13.000000', 'consum', 0.0218, 'lps'),
	(556832, 128, '2014-03-01 00:00:14.000000', 'consum', 0.0231, 'lps'),
	(556833, 128, '2014-03-01 00:00:15.000000', 'consum', 0.0218, 'lps'),
	(556834, 128, '2014-03-01 00:00:16.000000', 'consum', 0.0212, 'lps'),
	(556835, 128, '2014-03-01 00:00:17.000000', 'consum', 0.0222, 'lps'),
	(556836, 128, '2014-03-01 00:00:18.000000', 'consum', 0.0215, 'lps'),
	(556837, 128, '2014-03-01 00:00:19.000000', 'consum', 0.0223, 'lps'),
	(556838, 128, '2014-03-01 00:00:20.000000', 'consum', 0.0210, 'lps'),
	(556839, 128, '2014-03-01 00:00:21.000000', 'consum', 0.0224, 'lps'),
	(556840, 128, '2014-03-01 00:00:22.000000', 'consum', 0.0230, 'lps'),
	(556841, 128, '2014-03-01 00:00:23.000000', 'consum', 0.0217, 'lps'),
	(556842, 128, '2014-03-01 00:00:24.000000', 'consum', 0.0211, 'lps'),
	(556843, 128, '2014-03-01 00:00:25.000000', 'consum', 0.0221, 'lps'),
	(556844, 128, '2014-03-01 00:00:26.000000', 'consum', 0.0213, 'lps'),
	(556845, 128, '2014-03-01 00:00:27.000000', 'consum', 0.0218, 'lps'),
	(556846, 128, '2014-03-01 00:00:28.000000', 'consum', 0.0217, 'lps'),
	(556847, 128, '2014-03-01 00:00:29.000000', 'consum', 0.0223, 'lps'),
	(556848, 128, '2014-03-01 00:00:30.000000', 'consum', 0.0226, 'lps'),
	(556849, 128, '2014-03-01 00:00:31.000000', 'consum', 0.0226, 'lps'),
	(556850, 128, '2014-03-01 00:00:32.000000', 'consum', 0.0221, 'lps'),
	(556851, 128, '2014-03-01 00:00:33.000000', 'consum', 0.0215, 'lps'),
	(556852, 128, '2014-03-01 00:00:34.000000', 'consum', 0.0226, 'lps'),
	(556853, 128, '2014-03-01 00:00:35.000000', 'consum', 0.0228, 'lps'),
	(556854, 128, '2014-03-01 00:00:36.000000', 'consum', 0.0227, 'lps'),
	(556855, 128, '2014-03-01 00:00:37.000000', 'consum', 0.0218, 'lps'),
	(556856, 128, '2014-03-01 00:00:38.000000', 'consum', 0.0223, 'lps'),
	(556857, 128, '2014-03-01 00:00:39.000000', 'consum', 0.0225, 'lps'),
	(556858, 128, '2014-03-01 00:00:40.000000', 'consum', 0.0224, 'lps'),
	(556859, 128, '2014-03-01 00:00:41.000000', 'consum', 0.0210, 'lps'),
	(556860, 128, '2014-03-01 00:00:42.000000', 'consum', 0.0217, 'lps'),
	(556861, 128, '2014-03-01 00:00:43.000000', 'consum', 0.0223, 'lps'),
	(556862, 128, '2014-03-01 00:00:44.000000', 'consum', 0.0227, 'lps'),
	(556863, 128, '2014-03-01 00:00:45.000000', 'consum', 0.0231, 'lps'),
	(556864, 128, '2014-03-01 00:00:46.000000', 'consum', 0.0214, 'lps'),
	(556865, 128, '2014-03-01 00:00:47.000000', 'consum', 0.0220, 'lps'),
	(556866, 128, '2014-03-01 00:00:48.000000', 'consum', 0.0221, 'lps'),
	(556867, 128, '2014-03-01 00:00:49.000000', 'consum', 0.0213, 'lps'),
	(556868, 128, '2014-03-01 00:00:50.000000', 'consum', 0.0217, 'lps'),
	(556869, 128, '2014-03-01 00:00:51.000000', 'consum', 0.0210, 'lps'),
	(556870, 128, '2014-03-01 00:00:52.000000', 'consum', 0.0217, 'lps'),
	(556871, 128, '2014-03-01 00:00:53.000000', 'consum', 0.0217, 'lps'),
	(556872, 128, '2014-03-01 00:00:54.000000', 'consum', 0.0227, 'lps'),
	(556873, 128, '2014-03-01 00:00:55.000000', 'consum', 0.0223, 'lps'),
	(556874, 128, '2014-03-01 00:00:56.000000', 'consum', 0.0226, 'lps'),
	(556875, 128, '2014-03-01 00:00:57.000000', 'consum', 0.0226, 'lps'),
	(556876, 128, '2014-03-01 00:00:58.000000', 'consum', 0.0215, 'lps'),
	(556877, 128, '2014-03-01 00:00:59.000000', 'consum', 0.0216, 'lps'),
	(556878, 128, '2014-03-01 00:01:00.000000', 'consum', 0.0225, 'lps'),
	(556879, 128, '2014-03-01 00:01:01.000000', 'consum', 0.0218, 'lps'),
	(556880, 128, '2014-03-01 00:01:02.000000', 'consum', 0.0231, 'lps'),
	(556881, 128, '2014-03-01 00:01:03.000000', 'consum', 0.0214, 'lps'),
	(556882, 128, '2014-03-01 00:01:04.000000', 'consum', 0.0219, 'lps'),
	(556883, 128, '2014-03-01 00:01:05.000000', 'consum', 0.0217, 'lps'),
	(556884, 128, '2014-03-01 00:01:06.000000', 'consum', 0.0219, 'lps'),
	(556885, 128, '2014-03-01 00:01:07.000000', 'consum', 0.0233, 'lps'),
	(556886, 128, '2014-03-01 00:01:08.000000', 'consum', 0.0224, 'lps'),
	(556887, 128, '2014-03-01 00:01:09.000000', 'consum', 0.0212, 'lps'),
	(556888, 128, '2014-03-01 00:01:10.000000', 'consum', 0.0228, 'lps'),
	(556889, 128, '2014-03-01 00:01:11.000000', 'consum', 0.0220, 'lps'),
	(556890, 128, '2014-03-01 00:01:12.000000', 'consum', 0.0230, 'lps'),
	(556891, 128, '2014-03-01 00:01:13.000000', 'consum', 0.0231, 'lps'),
	(556892, 128, '2014-03-01 00:01:14.000000', 'consum', 0.0231, 'lps'),
	(556893, 128, '2014-03-01 00:01:15.000000', 'consum', 0.0227, 'lps'),
	(556894, 128, '2014-03-01 00:01:16.000000', 'consum', 0.0232, 'lps'),
	(556895, 128, '2014-03-01 00:01:17.000000', 'consum', 0.0221, 'lps'),
	(556896, 128, '2014-03-01 00:01:18.000000', 'consum', 0.0223, 'lps'),
	(556897, 128, '2014-03-01 00:01:19.000000', 'consum', 0.0218, 'lps'),
	(556898, 128, '2014-03-01 00:01:20.000000', 'consum', 0.0212, 'lps'),
	(556899, 128, '2014-03-01 00:01:21.000000', 'consum', 0.0219, 'lps'),
	(556900, 128, '2014-03-01 00:01:22.000000', 'consum', 0.0228, 'lps'),
	(556901, 128, '2014-03-01 00:01:23.000000', 'consum', 0.0223, 'lps'),
	(556902, 128, '2014-03-01 00:01:24.000000', 'consum', 0.0220, 'lps'),
	(556903, 128, '2014-03-01 00:01:25.000000', 'consum', 0.0221, 'lps'),
	(556904, 128, '2014-03-01 00:01:26.000000', 'consum', 0.0211, 'lps'),
	(556905, 128, '2014-03-01 00:01:27.000000', 'consum', 0.0232, 'lps'),
	(556906, 128, '2014-03-01 00:01:28.000000', 'consum', 0.0217, 'lps'),
	(556907, 128, '2014-03-01 00:01:29.000000', 'consum', 0.0231, 'lps'),
	(556908, 128, '2014-03-01 00:01:30.000000', 'consum', 0.0217, 'lps'),
	(556909, 128, '2014-03-01 00:01:31.000000', 'consum', 0.0210, 'lps'),
	(556910, 128, '2014-03-01 00:01:32.000000', 'consum', 0.0213, 'lps'),
	(556911, 128, '2014-03-01 00:01:33.000000', 'consum', 0.0224, 'lps'),
	(556912, 128, '2014-03-01 00:01:34.000000', 'consum', 0.0223, 'lps'),
	(556913, 128, '2014-03-01 00:01:35.000000', 'consum', 0.0233, 'lps'),
	(556914, 128, '2014-03-01 00:01:36.000000', 'consum', 0.0213, 'lps'),
	(556915, 128, '2014-03-01 00:01:37.000000', 'consum', 0.0231, 'lps'),
	(556916, 128, '2014-03-01 00:01:38.000000', 'consum', 0.0229, 'lps'),
	(556917, 128, '2014-03-01 00:01:39.000000', 'consum', 0.0220, 'lps'),
	(556918, 128, '2014-03-01 00:01:40.000000', 'consum', 0.0227, 'lps'),
	(556919, 128, '2014-03-01 00:01:41.000000', 'consum', 0.0216, 'lps'),
	(556920, 128, '2014-03-01 00:01:42.000000', 'consum', 0.0214, 'lps'),
	(556921, 128, '2014-03-01 00:01:43.000000', 'consum', 0.0214, 'lps'),
	(556922, 128, '2014-03-01 00:01:44.000000', 'consum', 0.0218, 'lps'),
	(556923, 128, '2014-03-01 00:01:45.000000', 'consum', 0.0215, 'lps'),
	(556924, 128, '2014-03-01 00:01:46.000000', 'consum', 0.0211, 'lps'),
	(556925, 128, '2014-03-01 00:01:47.000000', 'consum', 0.0226, 'lps'),
	(556926, 128, '2014-03-01 00:01:48.000000', 'consum', 0.0213, 'lps'),
	(556927, 128, '2014-03-01 00:01:49.000000', 'consum', 0.0228, 'lps'),
	(556928, 128, '2014-03-01 00:01:50.000000', 'consum', 0.0214, 'lps'),
	(556929, 128, '2014-03-01 00:01:51.000000', 'consum', 0.0228, 'lps'),
	(556930, 128, '2014-03-01 00:01:52.000000', 'consum', 0.0214, 'lps'),
	(556931, 128, '2014-03-01 00:01:53.000000', 'consum', 0.0226, 'lps'),
	(556932, 128, '2014-03-01 00:01:54.000000', 'consum', 0.0229, 'lps'),
	(556933, 128, '2014-03-01 00:01:55.000000', 'consum', 0.0233, 'lps'),
	(556934, 128, '2014-03-01 00:01:56.000000', 'consum', 0.0220, 'lps'),
	(556935, 128, '2014-03-01 00:01:57.000000', 'consum', 0.0213, 'lps'),
	(556936, 128, '2014-03-01 00:01:58.000000', 'consum', 0.0223, 'lps'),
	(556937, 128, '2014-03-01 00:01:59.000000', 'consum', 0.0217, 'lps'),
	(556938, 128, '2014-03-01 00:02:00.000000', 'consum', 0.0229, 'lps'),
	(556939, 128, '2014-03-01 00:02:01.000000', 'consum', 0.0211, 'lps'),
	(556940, 128, '2014-03-01 00:02:02.000000', 'consum', 0.0210, 'lps'),
	(556941, 128, '2014-03-01 00:02:03.000000', 'consum', 0.0233, 'lps'),
	(556942, 128, '2014-03-01 00:02:04.000000', 'consum', 0.0223, 'lps'),
	(556943, 128, '2014-03-01 00:02:05.000000', 'consum', 0.0233, 'lps'),
	(556944, 128, '2014-03-01 00:02:06.000000', 'consum', 0.0210, 'lps'),
	(556945, 128, '2014-03-01 00:02:07.000000', 'consum', 0.0217, 'lps'),
	(556946, 128, '2014-03-01 00:02:08.000000', 'consum', 0.0221, 'lps'),
	(556947, 128, '2014-03-01 00:02:09.000000', 'consum', 0.0217, 'lps'),
	(556948, 128, '2014-03-01 00:02:10.000000', 'consum', 0.0215, 'lps'),
	(556949, 128, '2014-03-01 00:02:11.000000', 'consum', 0.0213, 'lps'),
	(556950, 128, '2014-03-01 00:02:12.000000', 'consum', 0.0211, 'lps'),
	(556951, 128, '2014-03-01 00:02:13.000000', 'consum', 0.0233, 'lps'),
	(556952, 128, '2014-03-01 00:02:14.000000', 'consum', 0.0221, 'lps'),
	(556953, 128, '2014-03-01 00:02:15.000000', 'consum', 0.0224, 'lps'),
	(556954, 128, '2014-03-01 00:02:16.000000', 'consum', 0.0220, 'lps'),
	(556955, 128, '2014-03-01 00:02:17.000000', 'consum', 0.0219, 'lps'),
	(556956, 128, '2014-03-01 00:02:18.000000', 'consum', 0.0227, 'lps'),
	(556957, 128, '2014-03-01 00:02:19.000000', 'consum', 0.0217, 'lps'),
	(556958, 128, '2014-03-01 00:02:20.000000', 'consum', 0.0221, 'lps'),
	(556959, 128, '2014-03-01 00:02:21.000000', 'consum', 0.0219, 'lps'),
	(556960, 128, '2014-03-01 00:02:22.000000', 'consum', 0.0223, 'lps'),
	(556961, 128, '2014-03-01 00:02:23.000000', 'consum', 0.0222, 'lps'),
	(556962, 128, '2014-03-01 00:02:24.000000', 'consum', 0.0232, 'lps'),
	(556963, 128, '2014-03-01 00:02:25.000000', 'consum', 0.0211, 'lps'),
	(556964, 128, '2014-03-01 00:02:26.000000', 'consum', 0.0224, 'lps'),
	(556965, 128, '2014-03-01 00:02:27.000000', 'consum', 0.0229, 'lps'),
	(556966, 128, '2014-03-01 00:02:28.000000', 'consum', 0.0212, 'lps'),
	(556967, 128, '2014-03-01 00:02:29.000000', 'consum', 0.0214, 'lps'),
	(556968, 128, '2014-03-01 00:02:30.000000', 'consum', 0.0225, 'lps'),
	(556969, 128, '2014-03-01 00:02:31.000000', 'consum', 0.0224, 'lps'),
	(556970, 128, '2014-03-01 00:02:32.000000', 'consum', 0.0233, 'lps'),
	(556971, 128, '2014-03-01 00:02:33.000000', 'consum', 0.0210, 'lps'),
	(556972, 128, '2014-03-01 00:02:34.000000', 'consum', 0.0217, 'lps'),
	(556973, 128, '2014-03-01 00:02:35.000000', 'consum', 0.0219, 'lps'),
	(556974, 128, '2014-03-01 00:02:36.000000', 'consum', 0.0212, 'lps'),
	(556975, 128, '2014-03-01 00:02:37.000000', 'consum', 0.0216, 'lps'),
	(556976, 128, '2014-03-01 00:02:38.000000', 'consum', 0.0234, 'lps'),
	(556977, 128, '2014-03-01 00:02:39.000000', 'consum', 0.0215, 'lps'),
	(556978, 128, '2014-03-01 00:02:40.000000', 'consum', 0.0211, 'lps'),
	(556979, 128, '2014-03-01 00:02:41.000000', 'consum', 0.0226, 'lps'),
	(556980, 128, '2014-03-01 00:02:42.000000', 'consum', 0.0212, 'lps'),
	(556981, 128, '2014-03-01 00:02:43.000000', 'consum', 0.0222, 'lps'),
	(556982, 128, '2014-03-01 00:02:44.000000', 'consum', 0.0217, 'lps'),
	(556983, 128, '2014-03-01 00:02:45.000000', 'consum', 0.0234, 'lps'),
	(556984, 128, '2014-03-01 00:02:46.000000', 'consum', 0.0210, 'lps'),
	(556985, 128, '2014-03-01 00:02:47.000000', 'consum', 0.0214, 'lps'),
	(556986, 128, '2014-03-01 00:02:48.000000', 'consum', 0.0229, 'lps'),
	(556987, 128, '2014-03-01 00:02:49.000000', 'consum', 0.0218, 'lps'),
	(556988, 128, '2014-03-01 00:02:50.000000', 'consum', 0.0219, 'lps'),
	(556989, 128, '2014-03-01 00:02:51.000000', 'consum', 0.0233, 'lps'),
	(556990, 128, '2014-03-01 00:02:52.000000', 'consum', 0.0223, 'lps'),
	(556991, 128, '2014-03-01 00:02:53.000000', 'consum', 0.0231, 'lps'),
	(556992, 128, '2014-03-01 00:02:54.000000', 'consum', 0.0227, 'lps'),
	(556993, 128, '2014-03-01 00:02:55.000000', 'consum', 0.0231, 'lps'),
	(556994, 128, '2014-03-01 00:02:56.000000', 'consum', 0.0216, 'lps'),
	(556995, 128, '2014-03-01 00:02:57.000000', 'consum', 0.0228, 'lps'),
	(556996, 128, '2014-03-01 00:02:58.000000', 'consum', 0.0230, 'lps'),
	(556997, 128, '2014-03-01 00:02:59.000000', 'consum', 0.0233, 'lps'),
	(556998, 128, '2014-03-01 00:03:00.000000', 'consum', 0.0217, 'lps'),
	(556999, 128, '2014-03-01 00:03:01.000000', 'consum', 0.0223, 'lps'),
	(557000, 128, '2014-03-01 00:03:02.000000', 'consum', 0.0233, 'lps'),
	(557001, 128, '2014-03-01 00:03:03.000000', 'consum', 0.0210, 'lps'),
	(557002, 128, '2014-03-01 00:03:04.000000', 'consum', 0.0216, 'lps'),
	(557003, 128, '2014-03-01 00:03:05.000000', 'consum', 0.0214, 'lps'),
	(557004, 128, '2014-03-01 00:03:06.000000', 'consum', 0.0216, 'lps'),
	(557005, 128, '2014-03-01 00:03:07.000000', 'consum', 0.0225, 'lps'),
	(557006, 128, '2014-03-01 00:03:08.000000', 'consum', 0.0219, 'lps'),
	(557007, 128, '2014-03-01 00:03:09.000000', 'consum', 0.0233, 'lps'),
	(557008, 128, '2014-03-01 00:03:10.000000', 'consum', 0.0227, 'lps'),
	(557009, 128, '2014-03-01 00:03:11.000000', 'consum', 0.0224, 'lps'),
	(557010, 128, '2014-03-01 00:03:12.000000', 'consum', 0.0231, 'lps'),
	(557011, 128, '2014-03-01 00:03:13.000000', 'consum', 0.0222, 'lps'),
	(557012, 128, '2014-03-01 00:03:14.000000', 'consum', 0.0231, 'lps'),
	(557013, 128, '2014-03-01 00:03:15.000000', 'consum', 0.0232, 'lps'),
	(557014, 128, '2014-03-01 00:03:16.000000', 'consum', 0.0232, 'lps'),
	(557015, 128, '2014-03-01 00:03:17.000000', 'consum', 0.0229, 'lps'),
	(557016, 128, '2014-03-01 00:03:18.000000', 'consum', 0.0216, 'lps'),
	(557017, 128, '2014-03-01 00:03:19.000000', 'consum', 0.0233, 'lps'),
	(557018, 128, '2014-03-01 00:03:20.000000', 'consum', 0.0233, 'lps'),
	(557019, 128, '2014-03-01 00:03:21.000000', 'consum', 0.0232, 'lps'),
	(557020, 128, '2014-03-01 00:03:22.000000', 'consum', 0.0225, 'lps'),
	(557021, 128, '2014-03-01 00:03:23.000000', 'consum', 0.0218, 'lps'),
	(557022, 128, '2014-03-01 00:03:24.000000', 'consum', 0.0232, 'lps'),
	(557023, 128, '2014-03-01 00:03:25.000000', 'consum', 0.0224, 'lps'),
	(557024, 128, '2014-03-01 00:03:26.000000', 'consum', 0.0211, 'lps'),
	(557025, 128, '2014-03-01 00:03:27.000000', 'consum', 0.0223, 'lps'),
	(557026, 128, '2014-03-01 00:03:28.000000', 'consum', 0.0224, 'lps'),
	(557027, 128, '2014-03-01 00:03:29.000000', 'consum', 0.0216, 'lps'),
	(557028, 128, '2014-03-01 00:03:30.000000', 'consum', 0.0224, 'lps'),
	(557029, 128, '2014-03-01 00:03:31.000000', 'consum', 0.0214, 'lps'),
	(557030, 128, '2014-03-01 00:03:32.000000', 'consum', 0.0213, 'lps'),
	(557031, 128, '2014-03-01 00:03:33.000000', 'consum', 0.0212, 'lps'),
	(557032, 128, '2014-03-01 00:03:34.000000', 'consum', 0.0212, 'lps'),
	(557033, 128, '2014-03-01 00:03:35.000000', 'consum', 0.0213, 'lps'),
	(557034, 128, '2014-03-01 00:03:36.000000', 'consum', 0.0222, 'lps'),
	(557035, 128, '2014-03-01 00:03:37.000000', 'consum', 0.0210, 'lps'),
	(557036, 128, '2014-03-01 00:03:38.000000', 'consum', 0.0227, 'lps'),
	(557037, 128, '2014-03-01 00:03:39.000000', 'consum', 0.0217, 'lps'),
	(557038, 128, '2014-03-01 00:03:40.000000', 'consum', 0.0223, 'lps'),
	(557039, 128, '2014-03-01 00:03:41.000000', 'consum', 0.0228, 'lps'),
	(557040, 128, '2014-03-01 00:03:42.000000', 'consum', 0.0212, 'lps'),
	(557041, 128, '2014-03-01 00:03:43.000000', 'consum', 0.0217, 'lps'),
	(557042, 128, '2014-03-01 00:03:44.000000', 'consum', 0.0216, 'lps'),
	(557043, 128, '2014-03-01 00:03:45.000000', 'consum', 0.0218, 'lps'),
	(557044, 128, '2014-03-01 00:03:46.000000', 'consum', 0.0232, 'lps'),
	(557045, 128, '2014-03-01 00:03:47.000000', 'consum', 0.0220, 'lps'),
	(557046, 128, '2014-03-01 00:03:48.000000', 'consum', 0.0221, 'lps'),
	(557047, 128, '2014-03-01 00:03:49.000000', 'consum', 0.0210, 'lps'),
	(557048, 128, '2014-03-01 00:03:50.000000', 'consum', 0.0228, 'lps'),
	(557049, 128, '2014-03-01 00:03:51.000000', 'consum', 0.0223, 'lps'),
	(557050, 128, '2014-03-01 00:03:52.000000', 'consum', 0.0225, 'lps'),
	(557051, 128, '2014-03-01 00:03:53.000000', 'consum', 0.0219, 'lps'),
	(557052, 128, '2014-03-01 00:03:54.000000', 'consum', 0.0212, 'lps'),
	(557053, 128, '2014-03-01 00:03:55.000000', 'consum', 0.0217, 'lps'),
	(557054, 128, '2014-03-01 00:03:56.000000', 'consum', 0.0217, 'lps'),
	(557055, 128, '2014-03-01 00:03:57.000000', 'consum', 0.0222, 'lps'),
	(557056, 128, '2014-03-01 00:03:58.000000', 'consum', 0.0227, 'lps'),
	(557057, 128, '2014-03-01 00:03:59.000000', 'consum', 0.0233, 'lps'),
	(557058, 128, '2014-03-01 00:04:00.000000', 'consum', 0.0224, 'lps'),
	(557059, 128, '2014-03-01 00:04:01.000000', 'consum', 0.0213, 'lps'),
	(557060, 128, '2014-03-01 00:04:02.000000', 'consum', 0.0231, 'lps'),
	(557061, 128, '2014-03-01 00:04:03.000000', 'consum', 0.0234, 'lps'),
	(557062, 128, '2014-03-01 00:04:04.000000', 'consum', 0.0215, 'lps'),
	(557063, 128, '2014-03-01 00:04:05.000000', 'consum', 0.0217, 'lps'),
	(557064, 128, '2014-03-01 00:04:06.000000', 'consum', 0.0227, 'lps'),
	(557065, 128, '2014-03-01 00:04:07.000000', 'consum', 0.0225, 'lps'),
	(557066, 128, '2014-03-01 00:04:08.000000', 'consum', 0.0211, 'lps'),
	(557067, 128, '2014-03-01 00:04:09.000000', 'consum', 0.0219, 'lps'),
	(557068, 128, '2014-03-01 00:04:10.000000', 'consum', 0.0230, 'lps'),
	(557069, 128, '2014-03-01 00:04:11.000000', 'consum', 0.0233, 'lps'),
	(557070, 128, '2014-03-01 00:04:12.000000', 'consum', 0.0214, 'lps'),
	(557071, 128, '2014-03-01 00:04:13.000000', 'consum', 0.0214, 'lps'),
	(557072, 128, '2014-03-01 00:04:14.000000', 'consum', 0.0217, 'lps'),
	(557073, 128, '2014-03-01 00:04:15.000000', 'consum', 0.0232, 'lps'),
	(557074, 128, '2014-03-01 00:04:16.000000', 'consum', 0.0224, 'lps'),
	(557075, 128, '2014-03-01 00:04:17.000000', 'consum', 0.0215, 'lps'),
	(557076, 128, '2014-03-01 00:04:18.000000', 'consum', 0.0218, 'lps'),
	(557077, 128, '2014-03-01 00:04:19.000000', 'consum', 0.0234, 'lps'),
	(557078, 128, '2014-03-01 00:04:20.000000', 'consum', 0.0210, 'lps'),
	(557079, 128, '2014-03-01 00:04:21.000000', 'consum', 0.0211, 'lps'),
	(557080, 128, '2014-03-01 00:04:22.000000', 'consum', 0.0218, 'lps'),
	(557081, 128, '2014-03-01 00:04:23.000000', 'consum', 0.0222, 'lps'),
	(557082, 128, '2014-03-01 00:04:24.000000', 'consum', 0.0223, 'lps'),
	(557083, 128, '2014-03-01 00:04:25.000000', 'consum', 0.0213, 'lps'),
	(557084, 128, '2014-03-01 00:04:26.000000', 'consum', 0.0212, 'lps'),
	(557085, 128, '2014-03-01 00:04:27.000000', 'consum', 0.0210, 'lps'),
	(557086, 128, '2014-03-01 00:04:28.000000', 'consum', 0.0229, 'lps'),
	(557087, 128, '2014-03-01 00:04:29.000000', 'consum', 0.0233, 'lps'),
	(557088, 128, '2014-03-01 00:04:30.000000', 'consum', 0.0218, 'lps'),
	(557089, 128, '2014-03-01 00:04:31.000000', 'consum', 0.0229, 'lps'),
	(557090, 128, '2014-03-01 00:04:32.000000', 'consum', 0.0234, 'lps'),
	(557091, 128, '2014-03-01 00:04:33.000000', 'consum', 0.0221, 'lps'),
	(557092, 128, '2014-03-01 00:04:34.000000', 'consum', 0.0218, 'lps'),
	(557093, 128, '2014-03-01 00:04:35.000000', 'consum', 0.0221, 'lps'),
	(557094, 128, '2014-03-01 00:04:36.000000', 'consum', 0.0214, 'lps'),
	(557095, 128, '2014-03-01 00:04:37.000000', 'consum', 0.0223, 'lps'),
	(557096, 128, '2014-03-01 00:04:38.000000', 'consum', 0.0215, 'lps'),
	(557097, 128, '2014-03-01 00:04:39.000000', 'consum', 0.0219, 'lps'),
	(557098, 128, '2014-03-01 00:04:40.000000', 'consum', 0.0218, 'lps'),
	(557099, 128, '2014-03-01 00:04:41.000000', 'consum', 0.0221, 'lps'),
	(557100, 128, '2014-03-01 00:04:42.000000', 'consum', 0.0220, 'lps'),
	(557101, 128, '2014-03-01 00:04:43.000000', 'consum', 0.0224, 'lps'),
	(557102, 128, '2014-03-01 00:04:44.000000', 'consum', 0.0228, 'lps'),
	(557103, 128, '2014-03-01 00:04:45.000000', 'consum', 0.0231, 'lps'),
	(557104, 128, '2014-03-01 00:04:46.000000', 'consum', 0.0213, 'lps'),
	(557105, 128, '2014-03-01 00:04:47.000000', 'consum', 0.0213, 'lps'),
	(557106, 128, '2014-03-01 00:04:48.000000', 'consum', 0.0215, 'lps'),
	(557107, 128, '2014-03-01 00:04:49.000000', 'consum', 0.0227, 'lps'),
	(557108, 128, '2014-03-01 00:04:50.000000', 'consum', 0.0230, 'lps'),
	(557109, 128, '2014-03-01 00:04:51.000000', 'consum', 0.0210, 'lps'),
	(557110, 128, '2014-03-01 00:04:52.000000', 'consum', 0.0224, 'lps'),
	(557111, 128, '2014-03-01 00:04:53.000000', 'consum', 0.0231, 'lps'),
	(557112, 128, '2014-03-01 00:04:54.000000', 'consum', 0.0223, 'lps'),
	(557113, 128, '2014-03-01 00:04:55.000000', 'consum', 0.0213, 'lps'),
	(557114, 128, '2014-03-01 00:04:56.000000', 'consum', 0.0213, 'lps'),
	(557115, 128, '2014-03-01 00:04:57.000000', 'consum', 0.0216, 'lps'),
	(557116, 128, '2014-03-01 00:04:58.000000', 'consum', 0.0232, 'lps'),
	(557117, 128, '2014-03-01 00:04:59.000000', 'consum', 0.0225, 'lps'),
	(557118, 128, '2014-03-01 00:05:00.000000', 'consum', 0.0223, 'lps'),
	(557119, 128, '2014-03-01 00:05:01.000000', 'consum', 0.0228, 'lps'),
	(557120, 128, '2014-03-01 00:05:02.000000', 'consum', 0.0210, 'lps'),
	(557121, 128, '2014-03-01 00:05:03.000000', 'consum', 0.0210, 'lps'),
	(557122, 128, '2014-03-01 00:05:04.000000', 'consum', 0.0233, 'lps'),
	(557123, 128, '2014-03-01 00:05:05.000000', 'consum', 0.0226, 'lps'),
	(557124, 128, '2014-03-01 00:05:06.000000', 'consum', 0.0223, 'lps'),
	(557125, 128, '2014-03-01 00:05:07.000000', 'consum', 0.0225, 'lps'),
	(557126, 128, '2014-03-01 00:05:08.000000', 'consum', 0.0222, 'lps'),
	(557127, 128, '2014-03-01 00:05:09.000000', 'consum', 0.0225, 'lps'),
	(557128, 128, '2014-03-01 00:05:10.000000', 'consum', 0.0226, 'lps'),
	(557129, 128, '2014-03-01 00:05:11.000000', 'consum', 0.0221, 'lps'),
	(557130, 128, '2014-03-01 00:05:12.000000', 'consum', 0.0216, 'lps'),
	(557131, 128, '2014-03-01 00:05:13.000000', 'consum', 0.0234, 'lps'),
	(557132, 128, '2014-03-01 00:05:14.000000', 'consum', 0.0212, 'lps'),
	(557133, 128, '2014-03-01 00:05:15.000000', 'consum', 0.0222, 'lps'),
	(557134, 128, '2014-03-01 00:05:16.000000', 'consum', 0.0216, 'lps'),
	(557135, 128, '2014-03-01 00:05:17.000000', 'consum', 0.0228, 'lps'),
	(557136, 128, '2014-03-01 00:05:18.000000', 'consum', 0.0234, 'lps'),
	(557137, 128, '2014-03-01 00:05:19.000000', 'consum', 0.0226, 'lps'),
	(557138, 128, '2014-03-01 00:05:20.000000', 'consum', 0.0218, 'lps'),
	(557139, 128, '2014-03-01 00:05:21.000000', 'consum', 0.0226, 'lps'),
	(557140, 128, '2014-03-01 00:05:22.000000', 'consum', 0.0220, 'lps'),
	(557141, 128, '2014-03-01 00:05:23.000000', 'consum', 0.0210, 'lps'),
	(557142, 128, '2014-03-01 00:05:24.000000', 'consum', 0.0230, 'lps'),
	(557143, 128, '2014-03-01 00:05:25.000000', 'consum', 0.0213, 'lps'),
	(557144, 128, '2014-03-01 00:05:26.000000', 'consum', 0.0215, 'lps'),
	(557145, 128, '2014-03-01 00:05:27.000000', 'consum', 0.0225, 'lps'),
	(557146, 128, '2014-03-01 00:05:28.000000', 'consum', 0.0223, 'lps'),
	(557147, 128, '2014-03-01 00:05:29.000000', 'consum', 0.0230, 'lps'),
	(557148, 128, '2014-03-01 00:05:30.000000', 'consum', 0.0220, 'lps'),
	(557149, 128, '2014-03-01 00:05:31.000000', 'consum', 0.0226, 'lps'),
	(557150, 128, '2014-03-01 00:05:32.000000', 'consum', 0.0210, 'lps'),
	(557151, 128, '2014-03-01 00:05:33.000000', 'consum', 0.0212, 'lps'),
	(557152, 128, '2014-03-01 00:05:34.000000', 'consum', 0.0220, 'lps'),
	(557153, 128, '2014-03-01 00:05:35.000000', 'consum', 0.0229, 'lps'),
	(557154, 128, '2014-03-01 00:05:36.000000', 'consum', 0.0227, 'lps'),
	(557155, 128, '2014-03-01 00:05:37.000000', 'consum', 0.0212, 'lps'),
	(557156, 128, '2014-03-01 00:05:38.000000', 'consum', 0.0222, 'lps'),
	(557157, 128, '2014-03-01 00:05:39.000000', 'consum', 0.0213, 'lps'),
	(557158, 128, '2014-03-01 00:05:40.000000', 'consum', 0.0213, 'lps'),
	(557159, 128, '2014-03-01 00:05:41.000000', 'consum', 0.0217, 'lps'),
	(557160, 128, '2014-03-01 00:05:42.000000', 'consum', 0.0211, 'lps'),
	(557161, 128, '2014-03-01 00:05:43.000000', 'consum', 0.0219, 'lps'),
	(557162, 128, '2014-03-01 00:05:44.000000', 'consum', 0.0230, 'lps'),
	(557163, 128, '2014-03-01 00:05:45.000000', 'consum', 0.0234, 'lps'),
	(557164, 128, '2014-03-01 00:05:46.000000', 'consum', 0.0218, 'lps'),
	(557165, 128, '2014-03-01 00:05:47.000000', 'consum', 0.0228, 'lps'),
	(557166, 128, '2014-03-01 00:05:48.000000', 'consum', 0.0227, 'lps'),
	(557167, 128, '2014-03-01 00:05:49.000000', 'consum', 0.0218, 'lps'),
	(557168, 128, '2014-03-01 00:05:50.000000', 'consum', 0.0223, 'lps'),
	(557169, 128, '2014-03-01 00:05:51.000000', 'consum', 0.0226, 'lps'),
	(557170, 128, '2014-03-01 00:05:52.000000', 'consum', 0.0226, 'lps'),
	(557171, 128, '2014-03-01 00:05:53.000000', 'consum', 0.0218, 'lps'),
	(557172, 128, '2014-03-01 00:05:54.000000', 'consum', 0.0227, 'lps'),
	(557173, 128, '2014-03-01 00:05:55.000000', 'consum', 0.0222, 'lps'),
	(557174, 128, '2014-03-01 00:05:56.000000', 'consum', 0.0219, 'lps'),
	(557175, 128, '2014-03-01 00:05:57.000000', 'consum', 0.0219, 'lps'),
	(557176, 128, '2014-03-01 00:05:58.000000', 'consum', 0.0231, 'lps'),
	(557177, 128, '2014-03-01 00:05:59.000000', 'consum', 0.0213, 'lps'),
	(557178, 128, '2014-03-01 00:06:00.000000', 'consum', 0.0212, 'lps'),
	(557179, 128, '2014-03-01 00:06:01.000000', 'consum', 0.0211, 'lps'),
	(557180, 128, '2014-03-01 00:06:02.000000', 'consum', 0.0233, 'lps'),
	(557181, 128, '2014-03-01 00:06:03.000000', 'consum', 0.0223, 'lps'),
	(557182, 128, '2014-03-01 00:06:04.000000', 'consum', 0.0231, 'lps'),
	(557183, 128, '2014-03-01 00:06:05.000000', 'consum', 0.0226, 'lps'),
	(557184, 128, '2014-03-01 00:06:06.000000', 'consum', 0.0227, 'lps'),
	(557185, 128, '2014-03-01 00:06:07.000000', 'consum', 0.0223, 'lps'),
	(557186, 128, '2014-03-01 00:06:08.000000', 'consum', 0.0226, 'lps'),
	(557187, 128, '2014-03-01 00:06:09.000000', 'consum', 0.0225, 'lps'),
	(557188, 128, '2014-03-01 00:06:10.000000', 'consum', 0.0213, 'lps'),
	(557189, 128, '2014-03-01 00:06:11.000000', 'consum', 0.0229, 'lps'),
	(557190, 128, '2014-03-01 00:06:12.000000', 'consum', 0.0221, 'lps'),
	(557191, 128, '2014-03-01 00:06:13.000000', 'consum', 0.0211, 'lps'),
	(557192, 128, '2014-03-01 00:06:14.000000', 'consum', 0.0233, 'lps'),
	(557193, 128, '2014-03-01 00:06:15.000000', 'consum', 0.0222, 'lps'),
	(557194, 128, '2014-03-01 00:06:16.000000', 'consum', 0.0227, 'lps'),
	(557195, 128, '2014-03-01 00:06:17.000000', 'consum', 0.0234, 'lps'),
	(557196, 128, '2014-03-01 00:06:18.000000', 'consum', 0.0229, 'lps'),
	(557197, 128, '2014-03-01 00:06:19.000000', 'consum', 0.0210, 'lps'),
	(557198, 128, '2014-03-01 00:06:20.000000', 'consum', 0.0229, 'lps'),
	(557199, 128, '2014-03-01 00:06:21.000000', 'consum', 0.0231, 'lps'),
	(557200, 128, '2014-03-01 00:06:22.000000', 'consum', 0.0234, 'lps'),
	(557201, 128, '2014-03-01 00:06:23.000000', 'consum', 0.0216, 'lps'),
	(557202, 128, '2014-03-01 00:06:24.000000', 'consum', 0.0217, 'lps'),
	(557203, 128, '2014-03-01 00:06:25.000000', 'consum', 0.0230, 'lps'),
	(557204, 128, '2014-03-01 00:06:26.000000', 'consum', 0.0212, 'lps'),
	(557205, 128, '2014-03-01 00:06:27.000000', 'consum', 0.0210, 'lps'),
	(557206, 128, '2014-03-01 00:06:28.000000', 'consum', 0.0229, 'lps'),
	(557207, 128, '2014-03-01 00:06:29.000000', 'consum', 0.0230, 'lps'),
	(557208, 128, '2014-03-01 00:06:30.000000', 'consum', 0.0231, 'lps'),
	(557209, 128, '2014-03-01 00:06:31.000000', 'consum', 0.0228, 'lps'),
	(557210, 128, '2014-03-01 00:06:32.000000', 'consum', 0.0213, 'lps'),
	(557211, 128, '2014-03-01 00:06:33.000000', 'consum', 0.0221, 'lps'),
	(557212, 128, '2014-03-01 00:06:34.000000', 'consum', 0.0234, 'lps'),
	(557213, 128, '2014-03-01 00:06:35.000000', 'consum', 0.0221, 'lps'),
	(557214, 128, '2014-03-01 00:06:36.000000', 'consum', 0.0217, 'lps'),
	(557215, 128, '2014-03-01 00:06:37.000000', 'consum', 0.0212, 'lps'),
	(557216, 128, '2014-03-01 00:06:38.000000', 'consum', 0.0227, 'lps'),
	(557217, 128, '2014-03-01 00:06:39.000000', 'consum', 0.0215, 'lps'),
	(557218, 128, '2014-03-01 00:06:40.000000', 'consum', 0.0210, 'lps'),
	(557219, 128, '2014-03-01 00:06:41.000000', 'consum', 0.0217, 'lps'),
	(557220, 128, '2014-03-01 00:06:42.000000', 'consum', 0.0224, 'lps'),
	(557221, 128, '2014-03-01 00:06:43.000000', 'consum', 0.0232, 'lps'),
	(557222, 128, '2014-03-01 00:06:44.000000', 'consum', 0.0230, 'lps'),
	(557223, 128, '2014-03-01 00:06:45.000000', 'consum', 0.0221, 'lps'),
	(557224, 128, '2014-03-01 00:06:46.000000', 'consum', 0.0228, 'lps'),
	(557225, 128, '2014-03-01 00:06:47.000000', 'consum', 0.0219, 'lps'),
	(557226, 128, '2014-03-01 00:06:48.000000', 'consum', 0.0228, 'lps'),
	(557227, 128, '2014-03-01 00:06:49.000000', 'consum', 0.0222, 'lps'),
	(557228, 128, '2014-03-01 00:06:50.000000', 'consum', 0.0216, 'lps'),
	(557229, 128, '2014-03-01 00:06:51.000000', 'consum', 0.0228, 'lps'),
	(557230, 128, '2014-03-01 00:06:52.000000', 'consum', 0.0234, 'lps'),
	(557231, 128, '2014-03-01 00:06:53.000000', 'consum', 0.0225, 'lps'),
	(557232, 128, '2014-03-01 00:06:54.000000', 'consum', 0.0216, 'lps'),
	(557233, 128, '2014-03-01 00:06:55.000000', 'consum', 0.0221, 'lps'),
	(557234, 128, '2014-03-01 00:06:56.000000', 'consum', 0.0223, 'lps'),
	(557235, 128, '2014-03-01 00:06:57.000000', 'consum', 0.0216, 'lps'),
	(557236, 128, '2014-03-01 00:06:58.000000', 'consum', 0.0228, 'lps'),
	(557237, 128, '2014-03-01 00:06:59.000000', 'consum', 0.0231, 'lps'),
	(557238, 128, '2014-03-01 00:07:00.000000', 'consum', 0.0212, 'lps'),
	(557239, 128, '2014-03-01 00:07:01.000000', 'consum', 0.0233, 'lps'),
	(557240, 128, '2014-03-01 00:07:02.000000', 'consum', 0.0220, 'lps'),
	(557241, 128, '2014-03-01 00:07:03.000000', 'consum', 0.0215, 'lps'),
	(557242, 128, '2014-03-01 00:07:04.000000', 'consum', 0.0233, 'lps'),
	(557243, 128, '2014-03-01 00:07:05.000000', 'consum', 0.0210, 'lps'),
	(557244, 128, '2014-03-01 00:07:06.000000', 'consum', 0.0217, 'lps'),
	(557245, 128, '2014-03-01 00:07:07.000000', 'consum', 0.0219, 'lps'),
	(557246, 128, '2014-03-01 00:07:08.000000', 'consum', 0.0234, 'lps'),
	(557247, 128, '2014-03-01 00:07:09.000000', 'consum', 0.0229, 'lps'),
	(557248, 128, '2014-03-01 00:07:10.000000', 'consum', 0.0210, 'lps'),
	(557249, 128, '2014-03-01 00:07:11.000000', 'consum', 0.0227, 'lps'),
	(557250, 128, '2014-03-01 00:07:12.000000', 'consum', 0.0221, 'lps'),
	(557251, 128, '2014-03-01 00:07:13.000000', 'consum', 0.0213, 'lps'),
	(557252, 128, '2014-03-01 00:07:14.000000', 'consum', 0.0218, 'lps'),
	(557253, 128, '2014-03-01 00:07:15.000000', 'consum', 0.0219, 'lps'),
	(557254, 128, '2014-03-01 00:07:16.000000', 'consum', 0.0229, 'lps'),
	(557255, 128, '2014-03-01 00:07:17.000000', 'consum', 0.0230, 'lps'),
	(557256, 128, '2014-03-01 00:07:18.000000', 'consum', 0.0230, 'lps'),
	(557257, 128, '2014-03-01 00:07:19.000000', 'consum', 0.0222, 'lps'),
	(557258, 128, '2014-03-01 00:07:20.000000', 'consum', 0.0214, 'lps'),
	(557259, 128, '2014-03-01 00:07:21.000000', 'consum', 0.0218, 'lps'),
	(557260, 128, '2014-03-01 00:07:22.000000', 'consum', 0.0213, 'lps'),
	(557261, 128, '2014-03-01 00:07:23.000000', 'consum', 0.0225, 'lps'),
	(557262, 128, '2014-03-01 00:07:24.000000', 'consum', 0.0227, 'lps'),
	(557263, 128, '2014-03-01 00:07:25.000000', 'consum', 0.0227, 'lps'),
	(557264, 128, '2014-03-01 00:07:26.000000', 'consum', 0.0217, 'lps'),
	(557265, 128, '2014-03-01 00:07:27.000000', 'consum', 0.0220, 'lps'),
	(557266, 128, '2014-03-01 00:07:28.000000', 'consum', 0.0217, 'lps'),
	(557267, 128, '2014-03-01 00:07:29.000000', 'consum', 0.0214, 'lps'),
	(557268, 128, '2014-03-01 00:07:30.000000', 'consum', 0.0210, 'lps'),
	(557269, 128, '2014-03-01 00:07:31.000000', 'consum', 0.0223, 'lps'),
	(557270, 128, '2014-03-01 00:07:32.000000', 'consum', 0.0225, 'lps'),
	(557271, 128, '2014-03-01 00:07:33.000000', 'consum', 0.0221, 'lps'),
	(557272, 128, '2014-03-01 00:07:34.000000', 'consum', 0.0220, 'lps'),
	(557273, 128, '2014-03-01 00:07:35.000000', 'consum', 0.0229, 'lps'),
	(557274, 128, '2014-03-01 00:07:36.000000', 'consum', 0.0226, 'lps'),
	(557275, 128, '2014-03-01 00:07:37.000000', 'consum', 0.0231, 'lps'),
	(557276, 128, '2014-03-01 00:07:38.000000', 'consum', 0.0220, 'lps'),
	(557277, 128, '2014-03-01 00:07:39.000000', 'consum', 0.0220, 'lps'),
	(557278, 128, '2014-03-01 00:07:40.000000', 'consum', 0.0233, 'lps'),
	(557279, 128, '2014-03-01 00:07:41.000000', 'consum', 0.0219, 'lps'),
	(557280, 128, '2014-03-01 00:07:42.000000', 'consum', 0.0211, 'lps'),
	(557281, 128, '2014-03-01 00:07:43.000000', 'consum', 0.0216, 'lps'),
	(557282, 128, '2014-03-01 00:07:44.000000', 'consum', 0.0234, 'lps'),
	(557283, 128, '2014-03-01 00:07:45.000000', 'consum', 0.0215, 'lps'),
	(557284, 128, '2014-03-01 00:07:46.000000', 'consum', 0.0213, 'lps'),
	(557285, 128, '2014-03-01 00:07:47.000000', 'consum', 0.0212, 'lps'),
	(557286, 128, '2014-03-01 00:07:48.000000', 'consum', 0.0210, 'lps'),
	(557287, 128, '2014-03-01 00:07:49.000000', 'consum', 0.0229, 'lps'),
	(557288, 128, '2014-03-01 00:07:50.000000', 'consum', 0.0229, 'lps'),
	(557289, 128, '2014-03-01 00:07:51.000000', 'consum', 0.0225, 'lps'),
	(557290, 128, '2014-03-01 00:07:52.000000', 'consum', 0.0230, 'lps'),
	(557291, 128, '2014-03-01 00:07:53.000000', 'consum', 0.0215, 'lps'),
	(557292, 128, '2014-03-01 00:07:54.000000', 'consum', 0.0224, 'lps'),
	(557293, 128, '2014-03-01 00:07:55.000000', 'consum', 0.0218, 'lps'),
	(557294, 128, '2014-03-01 00:07:56.000000', 'consum', 0.0232, 'lps'),
	(557295, 128, '2014-03-01 00:07:57.000000', 'consum', 0.0223, 'lps'),
	(557296, 128, '2014-03-01 00:07:58.000000', 'consum', 0.0233, 'lps'),
	(557297, 128, '2014-03-01 00:07:59.000000', 'consum', 0.0213, 'lps'),
	(557298, 128, '2014-03-01 00:08:00.000000', 'consum', 0.0230, 'lps'),
	(557299, 128, '2014-03-01 00:08:01.000000', 'consum', 0.0229, 'lps'),
	(557300, 128, '2014-03-01 00:08:02.000000', 'consum', 0.0219, 'lps'),
	(557301, 128, '2014-03-01 00:08:03.000000', 'consum', 0.0222, 'lps'),
	(557302, 128, '2014-03-01 00:08:04.000000', 'consum', 0.0217, 'lps'),
	(557303, 128, '2014-03-01 00:08:05.000000', 'consum', 0.0213, 'lps'),
	(557304, 128, '2014-03-01 00:08:06.000000', 'consum', 0.0230, 'lps'),
	(557305, 128, '2014-03-01 00:08:07.000000', 'consum', 0.0223, 'lps'),
	(557306, 128, '2014-03-01 00:08:08.000000', 'consum', 0.0218, 'lps'),
	(557307, 128, '2014-03-01 00:08:09.000000', 'consum', 0.0213, 'lps'),
	(557308, 128, '2014-03-01 00:08:10.000000', 'consum', 0.0223, 'lps'),
	(557309, 128, '2014-03-01 00:08:11.000000', 'consum', 0.0219, 'lps'),
	(557310, 128, '2014-03-01 00:08:12.000000', 'consum', 0.0215, 'lps'),
	(557311, 128, '2014-03-01 00:08:13.000000', 'consum', 0.0234, 'lps'),
	(557312, 128, '2014-03-01 00:08:14.000000', 'consum', 0.0213, 'lps'),
	(557313, 128, '2014-03-01 00:08:15.000000', 'consum', 0.0232, 'lps'),
	(557314, 128, '2014-03-01 00:08:16.000000', 'consum', 0.0211, 'lps'),
	(557315, 128, '2014-03-01 00:08:17.000000', 'consum', 0.0226, 'lps'),
	(557316, 128, '2014-03-01 00:08:18.000000', 'consum', 0.0211, 'lps'),
	(557317, 128, '2014-03-01 00:08:19.000000', 'consum', 0.0219, 'lps'),
	(557318, 128, '2014-03-01 00:08:20.000000', 'consum', 0.0228, 'lps'),
	(557319, 128, '2014-03-01 00:08:21.000000', 'consum', 0.0220, 'lps'),
	(557320, 128, '2014-03-01 00:08:22.000000', 'consum', 0.0210, 'lps'),
	(557321, 128, '2014-03-01 00:08:23.000000', 'consum', 0.0228, 'lps'),
	(557322, 128, '2014-03-01 00:08:24.000000', 'consum', 0.0227, 'lps'),
	(557323, 128, '2014-03-01 00:08:25.000000', 'consum', 0.0215, 'lps'),
	(557324, 128, '2014-03-01 00:08:26.000000', 'consum', 0.0210, 'lps'),
	(557325, 128, '2014-03-01 00:08:27.000000', 'consum', 0.0222, 'lps'),
	(557326, 128, '2014-03-01 00:08:28.000000', 'consum', 0.0218, 'lps'),
	(557327, 128, '2014-03-01 00:08:29.000000', 'consum', 0.0215, 'lps'),
	(557328, 128, '2014-03-01 00:08:30.000000', 'consum', 0.0210, 'lps'),
	(557329, 128, '2014-03-01 00:08:31.000000', 'consum', 0.0223, 'lps'),
	(557330, 128, '2014-03-01 00:08:32.000000', 'consum', 0.0223, 'lps'),
	(557331, 128, '2014-03-01 00:08:33.000000', 'consum', 0.0214, 'lps'),
	(557332, 128, '2014-03-01 00:08:34.000000', 'consum', 0.0214, 'lps'),
	(557333, 128, '2014-03-01 00:08:35.000000', 'consum', 0.0221, 'lps'),
	(557334, 128, '2014-03-01 00:08:36.000000', 'consum', 0.0229, 'lps'),
	(557335, 128, '2014-03-01 00:08:37.000000', 'consum', 0.0220, 'lps'),
	(557336, 128, '2014-03-01 00:08:38.000000', 'consum', 0.0228, 'lps'),
	(557337, 128, '2014-03-01 00:08:39.000000', 'consum', 0.0223, 'lps'),
	(557338, 128, '2014-03-01 00:08:40.000000', 'consum', 0.0221, 'lps'),
	(557339, 128, '2014-03-01 00:08:41.000000', 'consum', 0.0226, 'lps'),
	(557340, 128, '2014-03-01 00:08:42.000000', 'consum', 0.0210, 'lps'),
	(557341, 128, '2014-03-01 00:08:43.000000', 'consum', 0.0234, 'lps'),
	(557342, 128, '2014-03-01 00:08:44.000000', 'consum', 0.0232, 'lps'),
	(557343, 128, '2014-03-01 00:08:45.000000', 'consum', 0.0222, 'lps'),
	(557344, 128, '2014-03-01 00:08:46.000000', 'consum', 0.0232, 'lps'),
	(557345, 128, '2014-03-01 00:08:47.000000', 'consum', 0.0233, 'lps'),
	(557346, 128, '2014-03-01 00:08:48.000000', 'consum', 0.0211, 'lps'),
	(557347, 128, '2014-03-01 00:08:49.000000', 'consum', 0.0220, 'lps'),
	(557348, 128, '2014-03-01 00:08:50.000000', 'consum', 0.0210, 'lps'),
	(557349, 128, '2014-03-01 00:08:51.000000', 'consum', 0.0228, 'lps'),
	(557350, 128, '2014-03-01 00:08:52.000000', 'consum', 0.0227, 'lps'),
	(557351, 128, '2014-03-01 00:08:53.000000', 'consum', 0.0216, 'lps'),
	(557352, 128, '2014-03-01 00:08:54.000000', 'consum', 0.0216, 'lps'),
	(557353, 128, '2014-03-01 00:08:55.000000', 'consum', 0.0223, 'lps'),
	(557354, 128, '2014-03-01 00:08:56.000000', 'consum', 0.0232, 'lps'),
	(557355, 128, '2014-03-01 00:08:57.000000', 'consum', 0.0231, 'lps'),
	(557356, 128, '2014-03-01 00:08:58.000000', 'consum', 0.0224, 'lps'),
	(557357, 128, '2014-03-01 00:08:59.000000', 'consum', 0.0218, 'lps'),
	(557358, 128, '2014-03-01 00:09:00.000000', 'consum', 0.0210, 'lps'),
	(557359, 128, '2014-03-01 00:09:01.000000', 'consum', 0.0210, 'lps'),
	(557360, 128, '2014-03-01 00:09:02.000000', 'consum', 0.0212, 'lps'),
	(557361, 128, '2014-03-01 00:09:03.000000', 'consum', 0.0219, 'lps'),
	(557362, 128, '2014-03-01 00:09:04.000000', 'consum', 0.0223, 'lps'),
	(557363, 128, '2014-03-01 00:09:05.000000', 'consum', 0.0226, 'lps'),
	(557364, 128, '2014-03-01 00:09:06.000000', 'consum', 0.0224, 'lps'),
	(557365, 128, '2014-03-01 00:09:07.000000', 'consum', 0.0234, 'lps'),
	(557366, 128, '2014-03-01 00:09:08.000000', 'consum', 0.0215, 'lps'),
	(557367, 128, '2014-03-01 00:09:09.000000', 'consum', 0.0214, 'lps'),
	(557368, 128, '2014-03-01 00:09:10.000000', 'consum', 0.0212, 'lps'),
	(557369, 128, '2014-03-01 00:09:11.000000', 'consum', 0.0212, 'lps'),
	(557370, 128, '2014-03-01 00:09:12.000000', 'consum', 0.0212, 'lps'),
	(557371, 128, '2014-03-01 00:09:13.000000', 'consum', 0.0216, 'lps'),
	(557372, 128, '2014-03-01 00:09:14.000000', 'consum', 0.0210, 'lps'),
	(557373, 128, '2014-03-01 00:09:15.000000', 'consum', 0.0216, 'lps'),
	(557374, 128, '2014-03-01 00:09:16.000000', 'consum', 0.0217, 'lps'),
	(557375, 128, '2014-03-01 00:09:17.000000', 'consum', 0.0226, 'lps'),
	(557376, 128, '2014-03-01 00:09:18.000000', 'consum', 0.0219, 'lps'),
	(557377, 128, '2014-03-01 00:09:19.000000', 'consum', 0.0234, 'lps'),
	(557378, 128, '2014-03-01 00:09:20.000000', 'consum', 0.0230, 'lps'),
	(557379, 128, '2014-03-01 00:09:21.000000', 'consum', 0.0210, 'lps'),
	(557380, 128, '2014-03-01 00:09:22.000000', 'consum', 0.0228, 'lps'),
	(557381, 128, '2014-03-01 00:09:23.000000', 'consum', 0.0226, 'lps'),
	(557382, 128, '2014-03-01 00:09:24.000000', 'consum', 0.0210, 'lps'),
	(557383, 128, '2014-03-01 00:09:25.000000', 'consum', 0.0211, 'lps'),
	(557384, 128, '2014-03-01 00:09:26.000000', 'consum', 0.0219, 'lps'),
	(557385, 128, '2014-03-01 00:09:27.000000', 'consum', 0.0225, 'lps'),
	(557386, 128, '2014-03-01 00:09:28.000000', 'consum', 0.0210, 'lps'),
	(557387, 128, '2014-03-01 00:09:29.000000', 'consum', 0.0214, 'lps'),
	(557388, 128, '2014-03-01 00:09:30.000000', 'consum', 0.0229, 'lps'),
	(557389, 128, '2014-03-01 00:09:31.000000', 'consum', 0.0220, 'lps'),
	(557390, 128, '2014-03-01 00:09:32.000000', 'consum', 0.0230, 'lps'),
	(557391, 128, '2014-03-01 00:09:33.000000', 'consum', 0.0228, 'lps'),
	(557392, 128, '2014-03-01 00:09:34.000000', 'consum', 0.0218, 'lps'),
	(557393, 128, '2014-03-01 00:09:35.000000', 'consum', 0.0222, 'lps'),
	(557394, 128, '2014-03-01 00:09:36.000000', 'consum', 0.0221, 'lps'),
	(557395, 128, '2014-03-01 00:09:37.000000', 'consum', 0.0230, 'lps'),
	(557396, 128, '2014-03-01 00:09:38.000000', 'consum', 0.0228, 'lps'),
	(557397, 128, '2014-03-01 00:09:39.000000', 'consum', 0.0213, 'lps'),
	(557398, 128, '2014-03-01 00:09:40.000000', 'consum', 0.0225, 'lps'),
	(557399, 128, '2014-03-01 00:09:41.000000', 'consum', 0.0224, 'lps'),
	(557400, 128, '2014-03-01 00:09:42.000000', 'consum', 0.0212, 'lps'),
	(557401, 128, '2014-03-01 00:09:43.000000', 'consum', 0.0228, 'lps'),
	(557402, 128, '2014-03-01 00:09:44.000000', 'consum', 0.0220, 'lps'),
	(557403, 128, '2014-03-01 00:09:45.000000', 'consum', 0.0230, 'lps'),
	(557404, 128, '2014-03-01 00:09:46.000000', 'consum', 0.0232, 'lps'),
	(557405, 128, '2014-03-01 00:09:47.000000', 'consum', 0.0210, 'lps'),
	(557406, 128, '2014-03-01 00:09:48.000000', 'consum', 0.0218, 'lps'),
	(557407, 128, '2014-03-01 00:09:49.000000', 'consum', 0.0227, 'lps'),
	(557408, 128, '2014-03-01 00:09:50.000000', 'consum', 0.0221, 'lps'),
	(557409, 128, '2014-03-01 00:09:51.000000', 'consum', 0.0214, 'lps'),
	(557410, 128, '2014-03-01 00:09:52.000000', 'consum', 0.0221, 'lps'),
	(557411, 128, '2014-03-01 00:09:53.000000', 'consum', 0.0230, 'lps'),
	(557412, 128, '2014-03-01 00:09:54.000000', 'consum', 0.0226, 'lps'),
	(557413, 128, '2014-03-01 00:09:55.000000', 'consum', 0.0232, 'lps'),
	(557414, 128, '2014-03-01 00:09:56.000000', 'consum', 0.0224, 'lps'),
	(557415, 128, '2014-03-01 00:09:57.000000', 'consum', 0.0213, 'lps'),
	(557416, 128, '2014-03-01 00:09:58.000000', 'consum', 0.0232, 'lps'),
	(557417, 128, '2014-03-01 00:09:59.000000', 'consum', 0.0212, 'lps'),
	(557418, 128, '2014-03-01 00:10:00.000000', 'consum', 0.0230, 'lps'),
	(557419, 128, '2014-03-01 00:10:01.000000', 'consum', 0.0231, 'lps'),
	(557420, 128, '2014-03-01 00:10:02.000000', 'consum', 0.0228, 'lps'),
	(557421, 128, '2014-03-01 00:10:03.000000', 'consum', 0.0213, 'lps'),
	(557422, 128, '2014-03-01 00:10:04.000000', 'consum', 0.0223, 'lps'),
	(557423, 128, '2014-03-01 00:10:05.000000', 'consum', 0.0215, 'lps'),
	(557424, 128, '2014-03-01 00:10:06.000000', 'consum', 0.0224, 'lps'),
	(557425, 128, '2014-03-01 00:10:07.000000', 'consum', 0.0214, 'lps'),
	(557426, 128, '2014-03-01 00:10:08.000000', 'consum', 0.0215, 'lps'),
	(557427, 128, '2014-03-01 00:10:09.000000', 'consum', 0.0222, 'lps'),
	(557428, 128, '2014-03-01 00:10:10.000000', 'consum', 0.0229, 'lps'),
	(557429, 128, '2014-03-01 00:10:11.000000', 'consum', 0.0223, 'lps'),
	(557430, 128, '2014-03-01 00:10:12.000000', 'consum', 0.0215, 'lps'),
	(557431, 128, '2014-03-01 00:10:13.000000', 'consum', 0.0224, 'lps'),
	(557432, 128, '2014-03-01 00:10:14.000000', 'consum', 0.0214, 'lps'),
	(557433, 128, '2014-03-01 00:10:15.000000', 'consum', 0.0216, 'lps'),
	(557434, 128, '2014-03-01 00:10:16.000000', 'consum', 0.0226, 'lps'),
	(557435, 128, '2014-03-01 00:10:17.000000', 'consum', 0.0225, 'lps'),
	(557436, 128, '2014-03-01 00:10:18.000000', 'consum', 0.0213, 'lps'),
	(557437, 128, '2014-03-01 00:10:19.000000', 'consum', 0.0229, 'lps'),
	(557438, 128, '2014-03-01 00:10:20.000000', 'consum', 0.0221, 'lps'),
	(557439, 128, '2014-03-01 00:10:21.000000', 'consum', 0.0210, 'lps'),
	(557440, 128, '2014-03-01 00:10:22.000000', 'consum', 0.0228, 'lps'),
	(557441, 128, '2014-03-01 00:10:23.000000', 'consum', 0.0223, 'lps'),
	(557442, 128, '2014-03-01 00:10:24.000000', 'consum', 0.0222, 'lps'),
	(557443, 128, '2014-03-01 00:10:25.000000', 'consum', 0.0231, 'lps'),
	(557444, 128, '2014-03-01 00:10:26.000000', 'consum', 0.0230, 'lps'),
	(557445, 128, '2014-03-01 00:10:27.000000', 'consum', 0.0224, 'lps'),
	(557446, 128, '2014-03-01 00:10:28.000000', 'consum', 0.0218, 'lps'),
	(557447, 128, '2014-03-01 00:10:29.000000', 'consum', 0.0212, 'lps'),
	(557448, 128, '2014-03-01 00:10:30.000000', 'consum', 0.0218, 'lps'),
	(557449, 128, '2014-03-01 00:10:31.000000', 'consum', 0.0222, 'lps'),
	(557450, 128, '2014-03-01 00:10:32.000000', 'consum', 0.0222, 'lps'),
	(557451, 128, '2014-03-01 00:10:33.000000', 'consum', 0.0232, 'lps'),
	(557452, 128, '2014-03-01 00:10:34.000000', 'consum', 0.0211, 'lps'),
	(557453, 128, '2014-03-01 00:10:35.000000', 'consum', 0.0224, 'lps'),
	(557454, 128, '2014-03-01 00:10:36.000000', 'consum', 0.0228, 'lps'),
	(557455, 128, '2014-03-01 00:10:37.000000', 'consum', 0.0233, 'lps'),
	(557456, 128, '2014-03-01 00:10:38.000000', 'consum', 0.0222, 'lps'),
	(557457, 128, '2014-03-01 00:10:39.000000', 'consum', 0.0226, 'lps'),
	(557458, 128, '2014-03-01 00:10:40.000000', 'consum', 0.0231, 'lps'),
	(557459, 128, '2014-03-01 00:10:41.000000', 'consum', 0.0219, 'lps'),
	(557460, 128, '2014-03-01 00:10:42.000000', 'consum', 0.0214, 'lps'),
	(557461, 128, '2014-03-01 00:10:43.000000', 'consum', 0.0232, 'lps'),
	(557462, 128, '2014-03-01 00:10:44.000000', 'consum', 0.0231, 'lps'),
	(557463, 128, '2014-03-01 00:10:45.000000', 'consum', 0.0227, 'lps'),
	(557464, 128, '2014-03-01 00:10:46.000000', 'consum', 0.0229, 'lps'),
	(557465, 128, '2014-03-01 00:10:47.000000', 'consum', 0.0232, 'lps'),
	(557466, 128, '2014-03-01 00:10:48.000000', 'consum', 0.0215, 'lps'),
	(557467, 128, '2014-03-01 00:10:49.000000', 'consum', 0.0216, 'lps'),
	(557468, 128, '2014-03-01 00:10:50.000000', 'consum', 0.0226, 'lps'),
	(557469, 128, '2014-03-01 00:10:51.000000', 'consum', 0.0225, 'lps'),
	(557470, 128, '2014-03-01 00:10:52.000000', 'consum', 0.0210, 'lps'),
	(557471, 128, '2014-03-01 00:10:53.000000', 'consum', 0.0215, 'lps'),
	(557472, 128, '2014-03-01 00:10:54.000000', 'consum', 0.0212, 'lps'),
	(557473, 128, '2014-03-01 00:10:55.000000', 'consum', 0.0229, 'lps'),
	(557474, 128, '2014-03-01 00:10:56.000000', 'consum', 0.0224, 'lps'),
	(557475, 128, '2014-03-01 00:10:57.000000', 'consum', 0.0223, 'lps'),
	(557476, 128, '2014-03-01 00:10:58.000000', 'consum', 0.0211, 'lps'),
	(557477, 128, '2014-03-01 00:10:59.000000', 'consum', 0.0226, 'lps'),
	(557478, 128, '2014-03-01 00:11:00.000000', 'consum', 0.0212, 'lps'),
	(557479, 128, '2014-03-01 00:11:01.000000', 'consum', 0.0223, 'lps'),
	(557480, 128, '2014-03-01 00:11:02.000000', 'consum', 0.0218, 'lps'),
	(557481, 128, '2014-03-01 00:11:03.000000', 'consum', 0.0213, 'lps'),
	(557482, 128, '2014-03-01 00:11:04.000000', 'consum', 0.0226, 'lps'),
	(557483, 128, '2014-03-01 00:11:05.000000', 'consum', 0.0232, 'lps'),
	(557484, 128, '2014-03-01 00:11:06.000000', 'consum', 0.0224, 'lps'),
	(557485, 128, '2014-03-01 00:11:07.000000', 'consum', 0.0214, 'lps'),
	(557486, 128, '2014-03-01 00:11:08.000000', 'consum', 0.0213, 'lps'),
	(557487, 128, '2014-03-01 00:11:09.000000', 'consum', 0.0213, 'lps'),
	(557488, 128, '2014-03-01 00:11:10.000000', 'consum', 0.0218, 'lps'),
	(557489, 128, '2014-03-01 00:11:11.000000', 'consum', 0.0214, 'lps'),
	(557490, 128, '2014-03-01 00:11:12.000000', 'consum', 0.0210, 'lps'),
	(557491, 128, '2014-03-01 00:11:13.000000', 'consum', 0.0220, 'lps'),
	(557492, 128, '2014-03-01 00:11:14.000000', 'consum', 0.0211, 'lps'),
	(557493, 128, '2014-03-01 00:11:15.000000', 'consum', 0.0211, 'lps'),
	(557494, 128, '2014-03-01 00:11:16.000000', 'consum', 0.0213, 'lps'),
	(557495, 128, '2014-03-01 00:11:17.000000', 'consum', 0.0221, 'lps'),
	(557496, 128, '2014-03-01 00:11:18.000000', 'consum', 0.0234, 'lps'),
	(557497, 128, '2014-03-01 00:11:19.000000', 'consum', 0.0221, 'lps'),
	(557498, 128, '2014-03-01 00:11:20.000000', 'consum', 0.0218, 'lps'),
	(557499, 128, '2014-03-01 00:11:21.000000', 'consum', 0.0218, 'lps'),
	(557500, 128, '2014-03-01 00:11:22.000000', 'consum', 0.0225, 'lps'),
	(557501, 128, '2014-03-01 00:11:23.000000', 'consum', 0.0213, 'lps'),
	(557502, 128, '2014-03-01 00:11:24.000000', 'consum', 0.0229, 'lps'),
	(557503, 128, '2014-03-01 00:11:25.000000', 'consum', 0.0221, 'lps'),
	(557504, 128, '2014-03-01 00:11:26.000000', 'consum', 0.0211, 'lps'),
	(557505, 128, '2014-03-01 00:11:27.000000', 'consum', 0.0230, 'lps'),
	(557506, 128, '2014-03-01 00:11:28.000000', 'consum', 0.0210, 'lps'),
	(557507, 128, '2014-03-01 00:11:29.000000', 'consum', 0.0226, 'lps'),
	(557508, 128, '2014-03-01 00:11:30.000000', 'consum', 0.0215, 'lps'),
	(557509, 128, '2014-03-01 00:11:31.000000', 'consum', 0.0210, 'lps'),
	(557510, 128, '2014-03-01 00:11:32.000000', 'consum', 0.0222, 'lps'),
	(557511, 128, '2014-03-01 00:11:33.000000', 'consum', 0.0219, 'lps'),
	(557512, 128, '2014-03-01 00:11:34.000000', 'consum', 0.0222, 'lps'),
	(557513, 128, '2014-03-01 00:11:35.000000', 'consum', 0.0219, 'lps'),
	(557514, 128, '2014-03-01 00:11:36.000000', 'consum', 0.0217, 'lps'),
	(557515, 128, '2014-03-01 00:11:37.000000', 'consum', 0.0220, 'lps'),
	(557516, 128, '2014-03-01 00:11:38.000000', 'consum', 0.0216, 'lps'),
	(557517, 128, '2014-03-01 00:11:39.000000', 'consum', 0.0210, 'lps'),
	(557518, 128, '2014-03-01 00:11:40.000000', 'consum', 0.0218, 'lps'),
	(557519, 128, '2014-03-01 00:11:41.000000', 'consum', 0.0224, 'lps'),
	(557520, 128, '2014-03-01 00:11:42.000000', 'consum', 0.0233, 'lps'),
	(557521, 128, '2014-03-01 00:11:43.000000', 'consum', 0.0234, 'lps'),
	(557522, 128, '2014-03-01 00:11:44.000000', 'consum', 0.0234, 'lps'),
	(557523, 128, '2014-03-01 00:11:45.000000', 'consum', 0.0234, 'lps'),
	(557524, 128, '2014-03-01 00:11:46.000000', 'consum', 0.0210, 'lps'),
	(557525, 128, '2014-03-01 00:11:47.000000', 'consum', 0.0214, 'lps'),
	(557526, 128, '2014-03-01 00:11:48.000000', 'consum', 0.0230, 'lps'),
	(557527, 128, '2014-03-01 00:11:49.000000', 'consum', 0.0222, 'lps'),
	(557528, 128, '2014-03-01 00:11:50.000000', 'consum', 0.0213, 'lps'),
	(557529, 128, '2014-03-01 00:11:51.000000', 'consum', 0.0212, 'lps'),
	(557530, 128, '2014-03-01 00:11:52.000000', 'consum', 0.0213, 'lps'),
	(557531, 128, '2014-03-01 00:11:53.000000', 'consum', 0.0220, 'lps'),
	(557532, 128, '2014-03-01 00:11:54.000000', 'consum', 0.0225, 'lps'),
	(557533, 128, '2014-03-01 00:11:55.000000', 'consum', 0.0231, 'lps'),
	(557534, 128, '2014-03-01 00:11:56.000000', 'consum', 0.0222, 'lps'),
	(557535, 128, '2014-03-01 00:11:57.000000', 'consum', 0.0233, 'lps'),
	(557536, 128, '2014-03-01 00:11:58.000000', 'consum', 0.0213, 'lps'),
	(557537, 128, '2014-03-01 00:11:59.000000', 'consum', 0.0230, 'lps'),
	(557538, 128, '2014-03-01 00:12:00.000000', 'consum', 0.0228, 'lps'),
	(557539, 128, '2014-03-01 00:12:01.000000', 'consum', 0.0217, 'lps'),
	(557540, 128, '2014-03-01 00:12:02.000000', 'consum', 0.0213, 'lps'),
	(557541, 128, '2014-03-01 00:12:03.000000', 'consum', 0.0233, 'lps'),
	(557542, 128, '2014-03-01 00:12:04.000000', 'consum', 0.0214, 'lps'),
	(557543, 128, '2014-03-01 00:12:05.000000', 'consum', 0.0214, 'lps'),
	(557544, 128, '2014-03-01 00:12:06.000000', 'consum', 0.0218, 'lps'),
	(557545, 128, '2014-03-01 00:12:07.000000', 'consum', 0.0213, 'lps'),
	(557546, 128, '2014-03-01 00:12:08.000000', 'consum', 0.0225, 'lps'),
	(557547, 128, '2014-03-01 00:12:09.000000', 'consum', 0.0229, 'lps'),
	(557548, 128, '2014-03-01 00:12:10.000000', 'consum', 0.0233, 'lps'),
	(557549, 128, '2014-03-01 00:12:11.000000', 'consum', 0.0218, 'lps'),
	(557550, 128, '2014-03-01 00:12:12.000000', 'consum', 0.0234, 'lps'),
	(557551, 128, '2014-03-01 00:12:13.000000', 'consum', 0.0232, 'lps'),
	(557552, 128, '2014-03-01 00:12:14.000000', 'consum', 0.0221, 'lps'),
	(557553, 128, '2014-03-01 00:12:15.000000', 'consum', 0.0227, 'lps'),
	(557554, 128, '2014-03-01 00:12:16.000000', 'consum', 0.0213, 'lps'),
	(557555, 128, '2014-03-01 00:12:17.000000', 'consum', 0.0223, 'lps'),
	(557556, 128, '2014-03-01 00:12:18.000000', 'consum', 0.0217, 'lps'),
	(557557, 128, '2014-03-01 00:12:19.000000', 'consum', 0.0233, 'lps'),
	(557558, 128, '2014-03-01 00:12:20.000000', 'consum', 0.0227, 'lps'),
	(557559, 128, '2014-03-01 00:12:21.000000', 'consum', 0.0229, 'lps'),
	(557560, 128, '2014-03-01 00:12:22.000000', 'consum', 0.0229, 'lps'),
	(557561, 128, '2014-03-01 00:12:23.000000', 'consum', 0.0223, 'lps'),
	(557562, 128, '2014-03-01 00:12:24.000000', 'consum', 0.0217, 'lps'),
	(557563, 128, '2014-03-01 00:12:25.000000', 'consum', 0.0234, 'lps'),
	(557564, 128, '2014-03-01 00:12:26.000000', 'consum', 0.0234, 'lps'),
	(557565, 128, '2014-03-01 00:12:27.000000', 'consum', 0.0232, 'lps'),
	(557566, 128, '2014-03-01 00:12:28.000000', 'consum', 0.0226, 'lps'),
	(557567, 128, '2014-03-01 00:12:29.000000', 'consum', 0.0222, 'lps'),
	(557568, 128, '2014-03-01 00:12:30.000000', 'consum', 0.0223, 'lps'),
	(557569, 128, '2014-03-01 00:12:31.000000', 'consum', 0.0216, 'lps'),
	(557570, 128, '2014-03-01 00:12:32.000000', 'consum', 0.0225, 'lps'),
	(557571, 128, '2014-03-01 00:12:33.000000', 'consum', 0.0217, 'lps'),
	(557572, 128, '2014-03-01 00:12:34.000000', 'consum', 0.0226, 'lps'),
	(557573, 128, '2014-03-01 00:12:35.000000', 'consum', 0.0222, 'lps'),
	(557574, 128, '2014-03-01 00:12:36.000000', 'consum', 0.0220, 'lps'),
	(557575, 128, '2014-03-01 00:12:37.000000', 'consum', 0.0223, 'lps'),
	(557576, 128, '2014-03-01 00:12:38.000000', 'consum', 0.0222, 'lps'),
	(557577, 128, '2014-03-01 00:12:39.000000', 'consum', 0.0230, 'lps'),
	(557578, 128, '2014-03-01 00:12:40.000000', 'consum', 0.0226, 'lps'),
	(557579, 128, '2014-03-01 00:12:41.000000', 'consum', 0.0231, 'lps'),
	(557580, 128, '2014-03-01 00:12:42.000000', 'consum', 0.0216, 'lps'),
	(557581, 128, '2014-03-01 00:12:43.000000', 'consum', 0.0227, 'lps'),
	(557582, 128, '2014-03-01 00:12:44.000000', 'consum', 0.0228, 'lps'),
	(557583, 128, '2014-03-01 00:12:45.000000', 'consum', 0.0223, 'lps'),
	(557584, 128, '2014-03-01 00:12:46.000000', 'consum', 0.0224, 'lps'),
	(557585, 128, '2014-03-01 00:12:47.000000', 'consum', 0.0217, 'lps'),
	(557586, 128, '2014-03-01 00:12:48.000000', 'consum', 0.0229, 'lps'),
	(557587, 128, '2014-03-01 00:12:49.000000', 'consum', 0.0233, 'lps'),
	(557588, 128, '2014-03-01 00:12:50.000000', 'consum', 0.0219, 'lps'),
	(557589, 128, '2014-03-01 00:12:51.000000', 'consum', 0.0234, 'lps'),
	(557590, 128, '2014-03-01 00:12:52.000000', 'consum', 0.0232, 'lps'),
	(557591, 128, '2014-03-01 00:12:53.000000', 'consum', 0.0222, 'lps'),
	(557592, 128, '2014-03-01 00:12:54.000000', 'consum', 0.0230, 'lps'),
	(557593, 128, '2014-03-01 00:12:55.000000', 'consum', 0.0223, 'lps'),
	(557594, 128, '2014-03-01 00:12:56.000000', 'consum', 0.0217, 'lps'),
	(557595, 128, '2014-03-01 00:12:57.000000', 'consum', 0.0231, 'lps'),
	(557596, 128, '2014-03-01 00:12:58.000000', 'consum', 0.0218, 'lps'),
	(557597, 128, '2014-03-01 00:12:59.000000', 'consum', 0.0213, 'lps'),
	(557598, 128, '2014-03-01 00:13:00.000000', 'consum', 0.0228, 'lps'),
	(557599, 128, '2014-03-01 00:13:01.000000', 'consum', 0.0217, 'lps'),
	(557600, 128, '2014-03-01 00:13:02.000000', 'consum', 0.0216, 'lps'),
	(557601, 128, '2014-03-01 00:13:03.000000', 'consum', 0.0218, 'lps'),
	(557602, 128, '2014-03-01 00:13:04.000000', 'consum', 0.0232, 'lps'),
	(557603, 128, '2014-03-01 00:13:05.000000', 'consum', 0.0224, 'lps'),
	(557604, 128, '2014-03-01 00:13:06.000000', 'consum', 0.0214, 'lps'),
	(557605, 128, '2014-03-01 00:13:07.000000', 'consum', 0.0212, 'lps'),
	(557606, 128, '2014-03-01 00:13:08.000000', 'consum', 0.0211, 'lps'),
	(557607, 128, '2014-03-01 00:13:09.000000', 'consum', 0.0233, 'lps'),
	(557608, 128, '2014-03-01 00:13:10.000000', 'consum', 0.0224, 'lps'),
	(557609, 128, '2014-03-01 00:13:11.000000', 'consum', 0.0210, 'lps'),
	(557610, 128, '2014-03-01 00:13:12.000000', 'consum', 0.0217, 'lps'),
	(557611, 128, '2014-03-01 00:13:13.000000', 'consum', 0.0222, 'lps'),
	(557612, 128, '2014-03-01 00:13:14.000000', 'consum', 0.0224, 'lps'),
	(557613, 128, '2014-03-01 00:13:15.000000', 'consum', 0.0218, 'lps'),
	(557614, 128, '2014-03-01 00:13:16.000000', 'consum', 0.0211, 'lps'),
	(557615, 128, '2014-03-01 00:13:17.000000', 'consum', 0.0217, 'lps'),
	(557616, 128, '2014-03-01 00:13:18.000000', 'consum', 0.0215, 'lps'),
	(557617, 128, '2014-03-01 00:13:19.000000', 'consum', 0.0214, 'lps'),
	(557618, 128, '2014-03-01 00:13:20.000000', 'consum', 0.0215, 'lps'),
	(557619, 128, '2014-03-01 00:13:21.000000', 'consum', 0.0223, 'lps'),
	(557620, 128, '2014-03-01 00:13:22.000000', 'consum', 0.0213, 'lps'),
	(557621, 128, '2014-03-01 00:13:23.000000', 'consum', 0.0212, 'lps'),
	(557622, 128, '2014-03-01 00:13:24.000000', 'consum', 0.0211, 'lps'),
	(557623, 128, '2014-03-01 00:13:25.000000', 'consum', 0.0234, 'lps'),
	(557624, 128, '2014-03-01 00:13:26.000000', 'consum', 0.0227, 'lps'),
	(557625, 128, '2014-03-01 00:13:27.000000', 'consum', 0.0222, 'lps'),
	(557626, 128, '2014-03-01 00:13:28.000000', 'consum', 0.0222, 'lps'),
	(557627, 128, '2014-03-01 00:13:29.000000', 'consum', 0.0233, 'lps'),
	(557628, 128, '2014-03-01 00:13:30.000000', 'consum', 0.0215, 'lps'),
	(557629, 128, '2014-03-01 00:13:31.000000', 'consum', 0.0218, 'lps'),
	(557630, 128, '2014-03-01 00:13:32.000000', 'consum', 0.0234, 'lps'),
	(557631, 128, '2014-03-01 00:13:33.000000', 'consum', 0.0230, 'lps'),
	(557632, 128, '2014-03-01 00:13:34.000000', 'consum', 0.0215, 'lps'),
	(557633, 128, '2014-03-01 00:13:35.000000', 'consum', 0.0226, 'lps'),
	(557634, 128, '2014-03-01 00:13:36.000000', 'consum', 0.0227, 'lps'),
	(557635, 128, '2014-03-01 00:13:37.000000', 'consum', 0.0221, 'lps'),
	(557636, 128, '2014-03-01 00:13:38.000000', 'consum', 0.0215, 'lps'),
	(557637, 128, '2014-03-01 00:13:39.000000', 'consum', 0.0225, 'lps'),
	(557638, 128, '2014-03-01 00:13:40.000000', 'consum', 0.0224, 'lps'),
	(557639, 128, '2014-03-01 00:13:41.000000', 'consum', 0.0233, 'lps'),
	(557640, 128, '2014-03-01 00:13:42.000000', 'consum', 0.0210, 'lps'),
	(557641, 128, '2014-03-01 00:13:43.000000', 'consum', 0.0215, 'lps'),
	(557642, 128, '2014-03-01 00:13:44.000000', 'consum', 0.0211, 'lps'),
	(557643, 128, '2014-03-01 00:13:45.000000', 'consum', 0.0227, 'lps'),
	(557644, 128, '2014-03-01 00:13:46.000000', 'consum', 0.0219, 'lps'),
	(557645, 128, '2014-03-01 00:13:47.000000', 'consum', 0.0226, 'lps'),
	(557646, 128, '2014-03-01 00:13:48.000000', 'consum', 0.0216, 'lps'),
	(557647, 128, '2014-03-01 00:13:49.000000', 'consum', 0.0218, 'lps'),
	(557648, 128, '2014-03-01 00:13:50.000000', 'consum', 0.0230, 'lps'),
	(557649, 128, '2014-03-01 00:13:51.000000', 'consum', 0.0214, 'lps'),
	(557650, 128, '2014-03-01 00:13:52.000000', 'consum', 0.0219, 'lps'),
	(557651, 128, '2014-03-01 00:13:53.000000', 'consum', 0.0219, 'lps'),
	(557652, 128, '2014-03-01 00:13:54.000000', 'consum', 0.0226, 'lps'),
	(557653, 128, '2014-03-01 00:13:55.000000', 'consum', 0.0217, 'lps'),
	(557654, 128, '2014-03-01 00:13:56.000000', 'consum', 0.0220, 'lps'),
	(557655, 128, '2014-03-01 00:13:57.000000', 'consum', 0.0215, 'lps'),
	(557656, 128, '2014-03-01 00:13:58.000000', 'consum', 0.0232, 'lps'),
	(557657, 128, '2014-03-01 00:13:59.000000', 'consum', 0.0228, 'lps'),
	(557658, 128, '2014-03-01 00:14:00.000000', 'consum', 0.0211, 'lps'),
	(557659, 128, '2014-03-01 00:14:01.000000', 'consum', 0.0210, 'lps'),
	(557660, 128, '2014-03-01 00:14:02.000000', 'consum', 0.0210, 'lps'),
	(557661, 128, '2014-03-01 00:14:03.000000', 'consum', 0.0210, 'lps'),
	(557662, 128, '2014-03-01 00:14:04.000000', 'consum', 0.0233, 'lps'),
	(557663, 128, '2014-03-01 00:14:05.000000', 'consum', 0.0229, 'lps'),
	(557664, 128, '2014-03-01 00:14:06.000000', 'consum', 0.0210, 'lps'),
	(557665, 128, '2014-03-01 00:14:07.000000', 'consum', 0.0228, 'lps'),
	(557666, 128, '2014-03-01 00:14:08.000000', 'consum', 0.0226, 'lps'),
	(557667, 128, '2014-03-01 00:14:09.000000', 'consum', 0.0210, 'lps'),
	(557668, 128, '2014-03-01 00:14:10.000000', 'consum', 0.0214, 'lps'),
	(557669, 128, '2014-03-01 00:14:11.000000', 'consum', 0.0231, 'lps'),
	(557670, 128, '2014-03-01 00:14:12.000000', 'consum', 0.0226, 'lps'),
	(557671, 128, '2014-03-01 00:14:13.000000', 'consum', 0.0229, 'lps'),
	(557672, 128, '2014-03-01 00:14:14.000000', 'consum', 0.0232, 'lps'),
	(557673, 128, '2014-03-01 00:14:15.000000', 'consum', 0.0213, 'lps'),
	(557674, 128, '2014-03-01 00:14:16.000000', 'consum', 0.0210, 'lps'),
	(557675, 128, '2014-03-01 00:14:17.000000', 'consum', 0.0226, 'lps'),
	(557676, 128, '2014-03-01 00:14:18.000000', 'consum', 0.0216, 'lps'),
	(557677, 128, '2014-03-01 00:14:19.000000', 'consum', 0.0217, 'lps'),
	(557678, 128, '2014-03-01 00:14:20.000000', 'consum', 0.0230, 'lps'),
	(557679, 128, '2014-03-01 00:14:21.000000', 'consum', 0.0213, 'lps'),
	(557680, 128, '2014-03-01 00:14:22.000000', 'consum', 0.0214, 'lps'),
	(557681, 128, '2014-03-01 00:14:23.000000', 'consum', 0.0222, 'lps'),
	(557682, 128, '2014-03-01 00:14:24.000000', 'consum', 0.0233, 'lps'),
	(557683, 128, '2014-03-01 00:14:25.000000', 'consum', 0.0213, 'lps'),
	(557684, 128, '2014-03-01 00:14:26.000000', 'consum', 0.0234, 'lps'),
	(557685, 128, '2014-03-01 00:14:27.000000', 'consum', 0.0220, 'lps'),
	(557686, 128, '2014-03-01 00:14:28.000000', 'consum', 0.0216, 'lps'),
	(557687, 128, '2014-03-01 00:14:29.000000', 'consum', 0.0232, 'lps'),
	(557688, 128, '2014-03-01 00:14:30.000000', 'consum', 0.0230, 'lps'),
	(557689, 128, '2014-03-01 00:14:31.000000', 'consum', 0.0218, 'lps'),
	(557690, 128, '2014-03-01 00:14:32.000000', 'consum', 0.0215, 'lps'),
	(557691, 128, '2014-03-01 00:14:33.000000', 'consum', 0.0213, 'lps'),
	(557692, 128, '2014-03-01 00:14:34.000000', 'consum', 0.0212, 'lps'),
	(557693, 128, '2014-03-01 00:14:35.000000', 'consum', 0.0234, 'lps'),
	(557694, 128, '2014-03-01 00:14:36.000000', 'consum', 0.0227, 'lps'),
	(557695, 128, '2014-03-01 00:14:37.000000', 'consum', 0.0222, 'lps'),
	(557696, 128, '2014-03-01 00:14:38.000000', 'consum', 0.0220, 'lps'),
	(557697, 128, '2014-03-01 00:14:39.000000', 'consum', 0.0222, 'lps'),
	(557698, 128, '2014-03-01 00:14:40.000000', 'consum', 0.0218, 'lps'),
	(557699, 128, '2014-03-01 00:14:41.000000', 'consum', 0.0215, 'lps'),
	(557700, 128, '2014-03-01 00:14:42.000000', 'consum', 0.0210, 'lps'),
	(557701, 128, '2014-03-01 00:14:43.000000', 'consum', 0.0222, 'lps'),
	(557702, 128, '2014-03-01 00:14:44.000000', 'consum', 0.0220, 'lps'),
	(557703, 128, '2014-03-01 00:14:45.000000', 'consum', 0.0224, 'lps'),
	(557704, 128, '2014-03-01 00:14:46.000000', 'consum', 0.0227, 'lps'),
	(557705, 128, '2014-03-01 00:14:47.000000', 'consum', 0.0226, 'lps'),
	(557706, 128, '2014-03-01 00:14:48.000000', 'consum', 0.0217, 'lps'),
	(557707, 128, '2014-03-01 00:14:49.000000', 'consum', 0.0221, 'lps'),
	(557708, 128, '2014-03-01 00:14:50.000000', 'consum', 0.0222, 'lps'),
	(557709, 128, '2014-03-01 00:14:51.000000', 'consum', 0.0234, 'lps'),
	(557710, 128, '2014-03-01 00:14:52.000000', 'consum', 0.0223, 'lps'),
	(557711, 128, '2014-03-01 00:14:53.000000', 'consum', 0.0227, 'lps'),
	(557712, 128, '2014-03-01 00:14:54.000000', 'consum', 0.0232, 'lps'),
	(557713, 128, '2014-03-01 00:14:55.000000', 'consum', 0.0219, 'lps'),
	(557714, 128, '2014-03-01 00:14:56.000000', 'consum', 0.0216, 'lps'),
	(557715, 128, '2014-03-01 00:14:57.000000', 'consum', 0.0211, 'lps'),
	(557716, 128, '2014-03-01 00:14:58.000000', 'consum', 0.0224, 'lps'),
	(557717, 128, '2014-03-01 00:14:59.000000', 'consum', 0.0229, 'lps'),
	(557718, 128, '2014-03-01 00:15:00.000000', 'consum', 0.0210, 'lps'),
	(557719, 128, '2014-03-01 00:15:01.000000', 'consum', 0.0232, 'lps'),
	(557720, 128, '2014-03-01 00:15:02.000000', 'consum', 0.0220, 'lps'),
	(557721, 128, '2014-03-01 00:15:03.000000', 'consum', 0.0217, 'lps'),
	(557722, 128, '2014-03-01 00:15:04.000000', 'consum', 0.0217, 'lps'),
	(557723, 128, '2014-03-01 00:15:05.000000', 'consum', 0.0223, 'lps'),
	(557724, 128, '2014-03-01 00:15:06.000000', 'consum', 0.0232, 'lps'),
	(557725, 128, '2014-03-01 00:15:07.000000', 'consum', 0.0232, 'lps'),
	(557726, 128, '2014-03-01 00:15:08.000000', 'consum', 0.0227, 'lps'),
	(557727, 128, '2014-03-01 00:15:09.000000', 'consum', 0.0233, 'lps'),
	(557728, 128, '2014-03-01 00:15:10.000000', 'consum', 0.0221, 'lps'),
	(557729, 128, '2014-03-01 00:15:11.000000', 'consum', 0.0223, 'lps'),
	(557730, 128, '2014-03-01 00:15:12.000000', 'consum', 0.0216, 'lps'),
	(557731, 128, '2014-03-01 00:15:13.000000', 'consum', 0.0226, 'lps'),
	(557732, 128, '2014-03-01 00:15:14.000000', 'consum', 0.0225, 'lps'),
	(557733, 128, '2014-03-01 00:15:15.000000', 'consum', 0.0212, 'lps'),
	(557734, 128, '2014-03-01 00:15:16.000000', 'consum', 0.0226, 'lps'),
	(557735, 128, '2014-03-01 00:15:17.000000', 'consum', 0.0233, 'lps'),
	(557736, 128, '2014-03-01 00:15:18.000000', 'consum', 0.0228, 'lps'),
	(557737, 128, '2014-03-01 00:15:19.000000', 'consum', 0.0231, 'lps'),
	(557738, 128, '2014-03-01 00:15:20.000000', 'consum', 0.0210, 'lps'),
	(557739, 128, '2014-03-01 00:15:21.000000', 'consum', 0.0223, 'lps'),
	(557740, 128, '2014-03-01 00:15:22.000000', 'consum', 0.0226, 'lps'),
	(557741, 128, '2014-03-01 00:15:23.000000', 'consum', 0.0225, 'lps'),
	(557742, 128, '2014-03-01 00:15:24.000000', 'consum', 0.0212, 'lps'),
	(557743, 128, '2014-03-01 00:15:25.000000', 'consum', 0.0228, 'lps'),
	(557744, 128, '2014-03-01 00:15:26.000000', 'consum', 0.0216, 'lps'),
	(557745, 128, '2014-03-01 00:15:27.000000', 'consum', 0.0215, 'lps'),
	(557746, 128, '2014-03-01 00:15:28.000000', 'consum', 0.0218, 'lps'),
	(557747, 128, '2014-03-01 00:15:29.000000', 'consum', 0.0234, 'lps'),
	(557748, 128, '2014-03-01 00:15:30.000000', 'consum', 0.0230, 'lps'),
	(557749, 128, '2014-03-01 00:15:31.000000', 'consum', 0.0215, 'lps'),
	(557750, 128, '2014-03-01 00:15:32.000000', 'consum', 0.0225, 'lps'),
	(557751, 128, '2014-03-01 00:15:33.000000', 'consum', 0.0221, 'lps'),
	(557752, 128, '2014-03-01 00:15:34.000000', 'consum', 0.0219, 'lps'),
	(557753, 128, '2014-03-01 00:15:35.000000', 'consum', 0.0223, 'lps'),
	(557754, 128, '2014-03-01 00:15:36.000000', 'consum', 0.0223, 'lps'),
	(557755, 128, '2014-03-01 00:15:37.000000', 'consum', 0.0211, 'lps'),
	(557756, 128, '2014-03-01 00:15:38.000000', 'consum', 0.0227, 'lps'),
	(557757, 128, '2014-03-01 00:15:39.000000', 'consum', 0.0216, 'lps'),
	(557758, 128, '2014-03-01 00:15:40.000000', 'consum', 0.0215, 'lps'),
	(557759, 128, '2014-03-01 00:15:41.000000', 'consum', 0.0217, 'lps'),
	(557760, 128, '2014-03-01 00:15:42.000000', 'consum', 0.0231, 'lps'),
	(557761, 128, '2014-03-01 00:15:43.000000', 'consum', 0.0221, 'lps'),
	(557762, 128, '2014-03-01 00:15:44.000000', 'consum', 0.0225, 'lps'),
	(557763, 128, '2014-03-01 00:15:45.000000', 'consum', 0.0227, 'lps'),
	(557764, 128, '2014-03-01 00:15:46.000000', 'consum', 0.0225, 'lps'),
	(557765, 128, '2014-03-01 00:15:47.000000', 'consum', 0.0212, 'lps'),
	(557766, 128, '2014-03-01 00:15:48.000000', 'consum', 0.0222, 'lps'),
	(557767, 128, '2014-03-01 00:15:49.000000', 'consum', 0.0218, 'lps'),
	(557768, 128, '2014-03-01 00:15:50.000000', 'consum', 0.0215, 'lps'),
	(557769, 128, '2014-03-01 00:15:51.000000', 'consum', 0.0234, 'lps'),
	(557770, 128, '2014-03-01 00:15:52.000000', 'consum', 0.0218, 'lps'),
	(557771, 128, '2014-03-01 00:15:53.000000', 'consum', 0.0228, 'lps'),
	(557772, 128, '2014-03-01 00:15:54.000000', 'consum', 0.0228, 'lps'),
	(557773, 128, '2014-03-01 00:15:55.000000', 'consum', 0.0218, 'lps'),
	(557774, 128, '2014-03-01 00:15:56.000000', 'consum', 0.0223, 'lps'),
	(557775, 128, '2014-03-01 00:15:57.000000', 'consum', 0.0228, 'lps'),
	(557776, 128, '2014-03-01 00:15:58.000000', 'consum', 0.0233, 'lps'),
	(557777, 128, '2014-03-01 00:15:59.000000', 'consum', 0.0225, 'lps'),
	(557778, 128, '2014-03-01 00:16:00.000000', 'consum', 0.0213, 'lps'),
	(557779, 128, '2014-03-01 00:16:01.000000', 'consum', 0.0234, 'lps'),
	(557780, 128, '2014-03-01 00:16:02.000000', 'consum', 0.0219, 'lps'),
	(557781, 128, '2014-03-01 00:16:03.000000', 'consum', 0.0211, 'lps'),
	(557782, 128, '2014-03-01 00:16:04.000000', 'consum', 0.0210, 'lps'),
	(557783, 128, '2014-03-01 00:16:05.000000', 'consum', 0.0210, 'lps'),
	(557784, 128, '2014-03-01 00:16:06.000000', 'consum', 0.0210, 'lps'),
	(557785, 128, '2014-03-01 00:16:07.000000', 'consum', 0.0210, 'lps'),
	(557786, 128, '2014-03-01 00:16:08.000000', 'consum', 0.0210, 'lps'),
	(557787, 128, '2014-03-01 00:16:09.000000', 'consum', 0.0234, 'lps'),
	(557788, 128, '2014-03-01 00:16:10.000000', 'consum', 0.0233, 'lps'),
	(557789, 128, '2014-03-01 00:16:11.000000', 'consum', 0.0228, 'lps'),
	(557790, 128, '2014-03-01 00:16:12.000000', 'consum', 0.0232, 'lps'),
	(557791, 128, '2014-03-01 00:16:13.000000', 'consum', 0.0217, 'lps'),
	(557792, 128, '2014-03-01 00:16:14.000000', 'consum', 0.0227, 'lps'),
	(557793, 128, '2014-03-01 00:16:15.000000', 'consum', 0.0225, 'lps'),
	(557794, 128, '2014-03-01 00:16:16.000000', 'consum', 0.0210, 'lps'),
	(557795, 128, '2014-03-01 00:16:17.000000', 'consum', 0.0217, 'lps'),
	(557796, 128, '2014-03-01 00:16:18.000000', 'consum', 0.0221, 'lps'),
	(557797, 128, '2014-03-01 00:16:19.000000', 'consum', 0.0218, 'lps'),
	(557798, 128, '2014-03-01 00:16:20.000000', 'consum', 0.0220, 'lps'),
	(557799, 128, '2014-03-01 00:16:21.000000', 'consum', 0.0234, 'lps'),
	(557800, 128, '2014-03-01 00:16:22.000000', 'consum', 0.0226, 'lps'),
	(557801, 128, '2014-03-01 00:16:23.000000', 'consum', 0.0217, 'lps'),
	(557802, 128, '2014-03-01 00:16:24.000000', 'consum', 0.0225, 'lps'),
	(557803, 128, '2014-03-01 00:16:25.000000', 'consum', 0.0214, 'lps'),
	(557804, 128, '2014-03-01 00:16:26.000000', 'consum', 0.0211, 'lps'),
	(557805, 128, '2014-03-01 00:16:27.000000', 'consum', 0.0229, 'lps'),
	(557806, 128, '2014-03-01 00:16:28.000000', 'consum', 0.0227, 'lps'),
	(557807, 128, '2014-03-01 00:16:29.000000', 'consum', 0.0212, 'lps'),
	(557808, 128, '2014-03-01 00:16:30.000000', 'consum', 0.0223, 'lps'),
	(557809, 128, '2014-03-01 00:16:31.000000', 'consum', 0.0216, 'lps'),
	(557810, 128, '2014-03-01 00:16:32.000000', 'consum', 0.0226, 'lps'),
	(557811, 128, '2014-03-01 00:16:33.000000', 'consum', 0.0224, 'lps'),
	(557812, 128, '2014-03-01 00:16:34.000000', 'consum', 0.0232, 'lps'),
	(557813, 128, '2014-03-01 00:16:35.000000', 'consum', 0.0229, 'lps'),
	(557814, 128, '2014-03-01 00:16:36.000000', 'consum', 0.0216, 'lps'),
	(557815, 128, '2014-03-01 00:16:37.000000', 'consum', 0.0233, 'lps'),
	(557816, 128, '2014-03-01 00:16:38.000000', 'consum', 0.0230, 'lps'),
	(557817, 128, '2014-03-01 00:16:39.000000', 'consum', 0.0219, 'lps'),
	(557818, 128, '2014-03-01 00:16:40.000000', 'consum', 0.0219, 'lps'),
	(557819, 128, '2014-03-01 00:16:41.000000', 'consum', 0.0230, 'lps'),
	(557820, 128, '2014-03-01 00:16:42.000000', 'consum', 0.0210, 'lps'),
	(557821, 128, '2014-03-01 00:16:43.000000', 'consum', 0.0224, 'lps'),
	(557822, 128, '2014-03-01 00:16:44.000000', 'consum', 0.0229, 'lps'),
	(557823, 128, '2014-03-01 00:16:45.000000', 'consum', 0.0215, 'lps'),
	(557824, 128, '2014-03-01 00:16:46.000000', 'consum', 0.0227, 'lps'),
	(557825, 128, '2014-03-01 00:16:47.000000', 'consum', 0.0231, 'lps'),
	(557826, 128, '2014-03-01 00:16:48.000000', 'consum', 0.0215, 'lps'),
	(557827, 128, '2014-03-01 00:16:49.000000', 'consum', 0.0223, 'lps'),
	(557828, 128, '2014-03-01 00:16:50.000000', 'consum', 0.0210, 'lps'),
	(557829, 128, '2014-03-01 00:16:51.000000', 'consum', 0.0220, 'lps'),
	(557830, 128, '2014-03-01 00:16:52.000000', 'consum', 0.0213, 'lps'),
	(557831, 128, '2014-03-01 00:16:53.000000', 'consum', 0.0219, 'lps'),
	(557832, 128, '2014-03-01 00:16:54.000000', 'consum', 0.0222, 'lps'),
	(557833, 128, '2014-03-01 00:16:55.000000', 'consum', 0.0217, 'lps'),
	(557834, 128, '2014-03-01 00:16:56.000000', 'consum', 0.0210, 'lps'),
	(557835, 128, '2014-03-01 00:16:57.000000', 'consum', 0.0216, 'lps'),
	(557836, 128, '2014-03-01 00:16:58.000000', 'consum', 0.0214, 'lps'),
	(557837, 128, '2014-03-01 00:16:59.000000', 'consum', 0.0213, 'lps'),
	(557838, 128, '2014-03-01 00:17:00.000000', 'consum', 0.0213, 'lps'),
	(557839, 128, '2014-03-01 00:17:01.000000', 'consum', 0.0219, 'lps'),
	(557840, 128, '2014-03-01 00:17:02.000000', 'consum', 0.0218, 'lps'),
	(557841, 128, '2014-03-01 00:17:03.000000', 'consum', 0.0225, 'lps'),
	(557842, 128, '2014-03-01 00:17:04.000000', 'consum', 0.0211, 'lps'),
	(557843, 128, '2014-03-01 00:17:05.000000', 'consum', 0.0219, 'lps'),
	(557844, 128, '2014-03-01 00:17:06.000000', 'consum', 0.0231, 'lps'),
	(557845, 128, '2014-03-01 00:17:07.000000', 'consum', 0.0211, 'lps'),
	(557846, 128, '2014-03-01 00:17:08.000000', 'consum', 0.0227, 'lps'),
	(557847, 128, '2014-03-01 00:17:09.000000', 'consum', 0.0216, 'lps'),
	(557848, 128, '2014-03-01 00:17:10.000000', 'consum', 0.0217, 'lps'),
	(557849, 128, '2014-03-01 00:17:11.000000', 'consum', 0.0229, 'lps'),
	(557850, 128, '2014-03-01 00:17:12.000000', 'consum', 0.0231, 'lps'),
	(557851, 128, '2014-03-01 00:17:13.000000', 'consum', 0.0234, 'lps'),
	(557852, 128, '2014-03-01 00:17:14.000000', 'consum', 0.0220, 'lps'),
	(557853, 128, '2014-03-01 00:17:15.000000', 'consum', 0.0210, 'lps'),
	(557854, 128, '2014-03-01 00:17:16.000000', 'consum', 0.0234, 'lps'),
	(557855, 128, '2014-03-01 00:17:17.000000', 'consum', 0.0230, 'lps'),
	(557856, 128, '2014-03-01 00:17:18.000000', 'consum', 0.0211, 'lps'),
	(557857, 128, '2014-03-01 00:17:19.000000', 'consum', 0.0232, 'lps'),
	(557858, 128, '2014-03-01 00:17:20.000000', 'consum', 0.0216, 'lps'),
	(557859, 128, '2014-03-01 00:17:21.000000', 'consum', 0.0226, 'lps'),
	(557860, 128, '2014-03-01 00:17:22.000000', 'consum', 0.0223, 'lps'),
	(557861, 128, '2014-03-01 00:17:23.000000', 'consum', 0.0229, 'lps'),
	(557862, 128, '2014-03-01 00:17:24.000000', 'consum', 0.0215, 'lps'),
	(557863, 128, '2014-03-01 00:17:25.000000', 'consum', 0.0227, 'lps'),
	(557864, 128, '2014-03-01 00:17:26.000000', 'consum', 0.0232, 'lps'),
	(557865, 128, '2014-03-01 00:17:27.000000', 'consum', 0.0218, 'lps'),
	(557866, 128, '2014-03-01 00:17:28.000000', 'consum', 0.0211, 'lps'),
	(557867, 128, '2014-03-01 00:17:29.000000', 'consum', 0.0216, 'lps'),
	(557868, 128, '2014-03-01 00:17:30.000000', 'consum', 0.0213, 'lps'),
	(557869, 128, '2014-03-01 00:17:31.000000', 'consum', 0.0233, 'lps'),
	(557870, 128, '2014-03-01 00:17:32.000000', 'consum', 0.0218, 'lps'),
	(557871, 128, '2014-03-01 00:17:33.000000', 'consum', 0.0229, 'lps'),
	(557872, 128, '2014-03-01 00:17:34.000000', 'consum', 0.0230, 'lps'),
	(557873, 128, '2014-03-01 00:17:35.000000', 'consum', 0.0232, 'lps'),
	(557874, 128, '2014-03-01 00:17:36.000000', 'consum', 0.0210, 'lps'),
	(557875, 128, '2014-03-01 00:17:37.000000', 'consum', 0.0218, 'lps'),
	(557876, 128, '2014-03-01 00:17:38.000000', 'consum', 0.0227, 'lps'),
	(557877, 128, '2014-03-01 00:17:39.000000', 'consum', 0.0219, 'lps'),
	(557878, 128, '2014-03-01 00:17:40.000000', 'consum', 0.0230, 'lps'),
	(557879, 128, '2014-03-01 00:17:41.000000', 'consum', 0.0234, 'lps'),
	(557880, 128, '2014-03-01 00:17:42.000000', 'consum', 0.0223, 'lps'),
	(557881, 128, '2014-03-01 00:17:43.000000', 'consum', 0.0225, 'lps'),
	(557882, 128, '2014-03-01 00:17:44.000000', 'consum', 0.0223, 'lps'),
	(557883, 128, '2014-03-01 00:17:45.000000', 'consum', 0.0232, 'lps'),
	(557884, 128, '2014-03-01 00:17:46.000000', 'consum', 0.0230, 'lps'),
	(557885, 128, '2014-03-01 00:17:47.000000', 'consum', 0.0219, 'lps'),
	(557886, 128, '2014-03-01 00:17:48.000000', 'consum', 0.0219, 'lps'),
	(557887, 128, '2014-03-01 00:17:49.000000', 'consum', 0.0232, 'lps'),
	(557888, 128, '2014-03-01 00:17:50.000000', 'consum', 0.0217, 'lps'),
	(557889, 128, '2014-03-01 00:17:51.000000', 'consum', 0.0228, 'lps'),
	(557890, 128, '2014-03-01 00:17:52.000000', 'consum', 0.0230, 'lps'),
	(557891, 128, '2014-03-01 00:17:53.000000', 'consum', 0.0230, 'lps'),
	(557892, 128, '2014-03-01 00:17:54.000000', 'consum', 0.0226, 'lps'),
	(557893, 128, '2014-03-01 00:17:55.000000', 'consum', 0.0233, 'lps'),
	(557894, 128, '2014-03-01 00:17:56.000000', 'consum', 0.0227, 'lps'),
	(557895, 128, '2014-03-01 00:17:57.000000', 'consum', 0.0224, 'lps'),
	(557896, 128, '2014-03-01 00:17:58.000000', 'consum', 0.0232, 'lps'),
	(557897, 128, '2014-03-01 00:17:59.000000', 'consum', 0.0227, 'lps'),
	(557898, 128, '2014-03-01 00:18:00.000000', 'consum', 0.0232, 'lps'),
	(557899, 128, '2014-03-01 00:18:01.000000', 'consum', 0.0217, 'lps'),
	(557900, 128, '2014-03-01 00:18:02.000000', 'consum', 0.0232, 'lps'),
	(557901, 128, '2014-03-01 00:18:03.000000', 'consum', 0.0222, 'lps'),
	(557902, 128, '2014-03-01 00:18:04.000000', 'consum', 0.0229, 'lps'),
	(557903, 128, '2014-03-01 00:18:05.000000', 'consum', 0.0220, 'lps'),
	(557904, 128, '2014-03-01 00:18:06.000000', 'consum', 0.0231, 'lps'),
	(557905, 128, '2014-03-01 00:18:07.000000', 'consum', 0.0233, 'lps'),
	(557906, 128, '2014-03-01 00:18:08.000000', 'consum', 0.0212, 'lps'),
	(557907, 128, '2014-03-01 00:18:09.000000', 'consum', 0.0225, 'lps'),
	(557908, 128, '2014-03-01 00:18:10.000000', 'consum', 0.0233, 'lps'),
	(557909, 128, '2014-03-01 00:18:11.000000', 'consum', 0.0228, 'lps'),
	(557910, 128, '2014-03-01 00:18:12.000000', 'consum', 0.0232, 'lps'),
	(557911, 128, '2014-03-01 00:18:13.000000', 'consum', 0.0216, 'lps'),
	(557912, 128, '2014-03-01 00:18:14.000000', 'consum', 0.0225, 'lps'),
	(557913, 128, '2014-03-01 00:18:15.000000', 'consum', 0.0218, 'lps'),
	(557914, 128, '2014-03-01 00:18:16.000000', 'consum', 0.0231, 'lps'),
	(557915, 128, '2014-03-01 00:18:17.000000', 'consum', 0.0215, 'lps'),
	(557916, 128, '2014-03-01 00:18:18.000000', 'consum', 0.0224, 'lps'),
	(557917, 128, '2014-03-01 00:18:19.000000', 'consum', 0.0214, 'lps'),
	(557918, 128, '2014-03-01 00:18:20.000000', 'consum', 0.0213, 'lps'),
	(557919, 128, '2014-03-01 00:18:21.000000', 'consum', 0.0213, 'lps'),
	(557920, 128, '2014-03-01 00:18:22.000000', 'consum', 0.0215, 'lps'),
	(557921, 128, '2014-03-01 00:18:23.000000', 'consum', 0.0230, 'lps'),
	(557922, 128, '2014-03-01 00:18:24.000000', 'consum', 0.0220, 'lps'),
	(557923, 128, '2014-03-01 00:18:25.000000', 'consum', 0.0225, 'lps'),
	(557924, 128, '2014-03-01 00:18:26.000000', 'consum', 0.0233, 'lps'),
	(557925, 128, '2014-03-01 00:18:27.000000', 'consum', 0.0227, 'lps'),
	(557926, 128, '2014-03-01 00:18:28.000000', 'consum', 0.0228, 'lps'),
	(557927, 128, '2014-03-01 00:18:29.000000', 'consum', 0.0223, 'lps'),
	(557928, 128, '2014-03-01 00:18:30.000000', 'consum', 0.0222, 'lps'),
	(557929, 128, '2014-03-01 00:18:31.000000', 'consum', 0.0230, 'lps'),
	(557930, 128, '2014-03-01 00:18:32.000000', 'consum', 0.0225, 'lps'),
	(557931, 128, '2014-03-01 00:18:33.000000', 'consum', 0.0228, 'lps'),
	(557932, 128, '2014-03-01 00:18:34.000000', 'consum', 0.0227, 'lps'),
	(557933, 128, '2014-03-01 00:18:35.000000', 'consum', 0.0219, 'lps'),
	(557934, 128, '2014-03-01 00:18:36.000000', 'consum', 0.0231, 'lps'),
	(557935, 128, '2014-03-01 00:18:37.000000', 'consum', 0.0210, 'lps'),
	(557936, 128, '2014-03-01 00:18:38.000000', 'consum', 0.0225, 'lps'),
	(557937, 128, '2014-03-01 00:18:39.000000', 'consum', 0.0210, 'lps'),
	(557938, 128, '2014-03-01 00:18:40.000000', 'consum', 0.0214, 'lps'),
	(557939, 128, '2014-03-01 00:18:41.000000', 'consum', 0.0233, 'lps'),
	(557940, 128, '2014-03-01 00:18:42.000000', 'consum', 0.0213, 'lps'),
	(557941, 128, '2014-03-01 00:18:43.000000', 'consum', 0.0231, 'lps'),
	(557942, 128, '2014-03-01 00:18:44.000000', 'consum', 0.0233, 'lps'),
	(557943, 128, '2014-03-01 00:18:45.000000', 'consum', 0.0234, 'lps'),
	(557944, 128, '2014-03-01 00:18:46.000000', 'consum', 0.0215, 'lps'),
	(557945, 128, '2014-03-01 00:18:47.000000', 'consum', 0.0211, 'lps'),
	(557946, 128, '2014-03-01 00:18:48.000000', 'consum', 0.0226, 'lps'),
	(557947, 128, '2014-03-01 00:18:49.000000', 'consum', 0.0215, 'lps'),
	(557948, 128, '2014-03-01 00:18:50.000000', 'consum', 0.0210, 'lps'),
	(557949, 128, '2014-03-01 00:18:51.000000', 'consum', 0.0221, 'lps'),
	(557950, 128, '2014-03-01 00:18:52.000000', 'consum', 0.0214, 'lps'),
	(557951, 128, '2014-03-01 00:18:53.000000', 'consum', 0.0224, 'lps'),
	(557952, 128, '2014-03-01 00:18:54.000000', 'consum', 0.0218, 'lps'),
	(557953, 128, '2014-03-01 00:18:55.000000', 'consum', 0.0211, 'lps'),
	(557954, 128, '2014-03-01 00:18:56.000000', 'consum', 0.0214, 'lps'),
	(557955, 128, '2014-03-01 00:18:57.000000', 'consum', 0.0227, 'lps'),
	(557956, 128, '2014-03-01 00:18:58.000000', 'consum', 0.0234, 'lps'),
	(557957, 128, '2014-03-01 00:18:59.000000', 'consum', 0.0228, 'lps'),
	(557958, 128, '2014-03-01 00:19:00.000000', 'consum', 0.0231, 'lps'),
	(557959, 128, '2014-03-01 00:19:01.000000', 'consum', 0.0211, 'lps'),
	(557960, 128, '2014-03-01 00:19:02.000000', 'consum', 0.0228, 'lps'),
	(557961, 128, '2014-03-01 00:19:03.000000', 'consum', 0.0220, 'lps'),
	(557962, 128, '2014-03-01 00:19:04.000000', 'consum', 0.0232, 'lps'),
	(557963, 128, '2014-03-01 00:19:05.000000', 'consum', 0.0218, 'lps'),
	(557964, 128, '2014-03-01 00:19:06.000000', 'consum', 0.0233, 'lps'),
	(557965, 128, '2014-03-01 00:19:07.000000', 'consum', 0.0227, 'lps'),
	(557966, 128, '2014-03-01 00:19:08.000000', 'consum', 0.0226, 'lps'),
	(557967, 128, '2014-03-01 00:19:09.000000', 'consum', 0.0213, 'lps'),
	(557968, 128, '2014-03-01 00:19:10.000000', 'consum', 0.0230, 'lps'),
	(557969, 128, '2014-03-01 00:19:11.000000', 'consum', 0.0226, 'lps'),
	(557970, 128, '2014-03-01 00:19:12.000000', 'consum', 0.0229, 'lps'),
	(557971, 128, '2014-03-01 00:19:13.000000', 'consum', 0.0232, 'lps'),
	(557972, 128, '2014-03-01 00:19:14.000000', 'consum', 0.0213, 'lps'),
	(557973, 128, '2014-03-01 00:19:15.000000', 'consum', 0.0212, 'lps'),
	(557974, 128, '2014-03-01 00:19:16.000000', 'consum', 0.0212, 'lps'),
	(557975, 128, '2014-03-01 00:19:17.000000', 'consum', 0.0215, 'lps'),
	(557976, 128, '2014-03-01 00:19:18.000000', 'consum', 0.0228, 'lps'),
	(557977, 128, '2014-03-01 00:19:19.000000', 'consum', 0.0211, 'lps'),
	(557978, 128, '2014-03-01 00:19:20.000000', 'consum', 0.0212, 'lps'),
	(557979, 128, '2014-03-01 00:19:21.000000', 'consum', 0.0218, 'lps'),
	(557980, 128, '2014-03-01 00:19:22.000000', 'consum', 0.0217, 'lps'),
	(557981, 128, '2014-03-01 00:19:23.000000', 'consum', 0.0222, 'lps'),
	(557982, 128, '2014-03-01 00:19:24.000000', 'consum', 0.0227, 'lps'),
	(557983, 128, '2014-03-01 00:19:25.000000', 'consum', 0.0232, 'lps'),
	(557984, 128, '2014-03-01 00:19:26.000000', 'consum', 0.0219, 'lps'),
	(557985, 128, '2014-03-01 00:19:27.000000', 'consum', 0.0215, 'lps'),
	(557986, 128, '2014-03-01 00:19:28.000000', 'consum', 0.0233, 'lps'),
	(557987, 128, '2014-03-01 00:19:29.000000', 'consum', 0.0213, 'lps'),
	(557988, 128, '2014-03-01 00:19:30.000000', 'consum', 0.0229, 'lps'),
	(557989, 128, '2014-03-01 00:19:31.000000', 'consum', 0.0223, 'lps'),
	(557990, 128, '2014-03-01 00:19:32.000000', 'consum', 0.0220, 'lps'),
	(557991, 128, '2014-03-01 00:19:33.000000', 'consum', 0.0221, 'lps'),
	(557992, 128, '2014-03-01 00:19:34.000000', 'consum', 0.0233, 'lps'),
	(557993, 128, '2014-03-01 00:19:35.000000', 'consum', 0.0220, 'lps'),
	(557994, 128, '2014-03-01 00:19:36.000000', 'consum', 0.0214, 'lps'),
	(557995, 128, '2014-03-01 00:19:37.000000', 'consum', 0.0225, 'lps'),
	(557996, 128, '2014-03-01 00:19:38.000000', 'consum', 0.0223, 'lps'),
	(557997, 128, '2014-03-01 00:19:39.000000', 'consum', 0.0232, 'lps'),
	(557998, 128, '2014-03-01 00:19:40.000000', 'consum', 0.0229, 'lps'),
	(557999, 128, '2014-03-01 00:19:41.000000', 'consum', 0.0218, 'lps'),
	(558000, 128, '2014-03-01 00:19:42.000000', 'consum', 0.0216, 'lps'),
	(558001, 128, '2014-03-01 00:19:43.000000', 'consum', 0.0216, 'lps'),
	(558002, 128, '2014-03-01 00:19:44.000000', 'consum', 0.0223, 'lps'),
	(558003, 128, '2014-03-01 00:19:45.000000', 'consum', 0.0234, 'lps'),
	(558004, 128, '2014-03-01 00:19:46.000000', 'consum', 0.0218, 'lps'),
	(558005, 128, '2014-03-01 00:19:47.000000', 'consum', 0.0226, 'lps'),
	(558006, 128, '2014-03-01 00:19:48.000000', 'consum', 0.0216, 'lps'),
	(558007, 128, '2014-03-01 00:19:49.000000', 'consum', 0.0219, 'lps'),
	(558008, 128, '2014-03-01 00:19:50.000000', 'consum', 0.0212, 'lps'),
	(558009, 128, '2014-03-01 00:19:51.000000', 'consum', 0.0218, 'lps'),
	(558010, 128, '2014-03-01 00:19:52.000000', 'consum', 0.0220, 'lps'),
	(558011, 128, '2014-03-01 00:19:53.000000', 'consum', 0.0213, 'lps'),
	(558012, 128, '2014-03-01 00:19:54.000000', 'consum', 0.0221, 'lps'),
	(558013, 128, '2014-03-01 00:19:55.000000', 'consum', 0.0232, 'lps'),
	(558014, 128, '2014-03-01 00:19:56.000000', 'consum', 0.0210, 'lps'),
	(558015, 128, '2014-03-01 00:19:57.000000', 'consum', 0.0222, 'lps'),
	(558016, 128, '2014-03-01 00:19:58.000000', 'consum', 0.0220, 'lps'),
	(558017, 128, '2014-03-01 00:19:59.000000', 'consum', 0.0223, 'lps'),
	(558018, 128, '2014-03-01 00:20:00.000000', 'consum', 0.0223, 'lps'),
	(558019, 128, '2014-03-01 00:20:01.000000', 'consum', 0.0211, 'lps'),
	(558020, 128, '2014-03-01 00:20:02.000000', 'consum', 0.0228, 'lps'),
	(558021, 128, '2014-03-01 00:20:03.000000', 'consum', 0.0219, 'lps'),
	(558022, 128, '2014-03-01 00:20:04.000000', 'consum', 0.0229, 'lps'),
	(558023, 128, '2014-03-01 00:20:05.000000', 'consum', 0.0226, 'lps'),
	(558024, 128, '2014-03-01 00:20:06.000000', 'consum', 0.0212, 'lps'),
	(558025, 128, '2014-03-01 00:20:07.000000', 'consum', 0.0219, 'lps'),
	(558026, 128, '2014-03-01 00:20:08.000000', 'consum', 0.0225, 'lps'),
	(558027, 128, '2014-03-01 00:20:09.000000', 'consum', 0.0234, 'lps'),
	(558028, 128, '2014-03-01 00:20:10.000000', 'consum', 0.0213, 'lps'),
	(558029, 128, '2014-03-01 00:20:11.000000', 'consum', 0.0225, 'lps'),
	(558030, 128, '2014-03-01 00:20:12.000000', 'consum', 0.0229, 'lps'),
	(558031, 128, '2014-03-01 00:20:13.000000', 'consum', 0.0234, 'lps'),
	(558032, 128, '2014-03-01 00:20:14.000000', 'consum', 0.0223, 'lps'),
	(558033, 128, '2014-03-01 00:20:15.000000', 'consum', 0.0227, 'lps'),
	(558034, 128, '2014-03-01 00:20:16.000000', 'consum', 0.0233, 'lps'),
	(558035, 128, '2014-03-01 00:20:17.000000', 'consum', 0.0226, 'lps'),
	(558036, 128, '2014-03-01 00:20:18.000000', 'consum', 0.0222, 'lps'),
	(558037, 128, '2014-03-01 00:20:19.000000', 'consum', 0.0223, 'lps'),
	(558038, 128, '2014-03-01 00:20:20.000000', 'consum', 0.0214, 'lps'),
	(558039, 128, '2014-03-01 00:20:21.000000', 'consum', 0.0216, 'lps'),
	(558040, 128, '2014-03-01 00:20:22.000000', 'consum', 0.0230, 'lps'),
	(558041, 128, '2014-03-01 00:20:23.000000', 'consum', 0.0216, 'lps'),
	(558042, 128, '2014-03-01 00:20:24.000000', 'consum', 0.0230, 'lps'),
	(558043, 128, '2014-03-01 00:20:25.000000', 'consum', 0.0219, 'lps'),
	(558044, 128, '2014-03-01 00:20:26.000000', 'consum', 0.0222, 'lps'),
	(558045, 128, '2014-03-01 00:20:27.000000', 'consum', 0.0216, 'lps'),
	(558046, 128, '2014-03-01 00:20:28.000000', 'consum', 0.0231, 'lps'),
	(558047, 128, '2014-03-01 00:20:29.000000', 'consum', 0.0220, 'lps'),
	(558048, 128, '2014-03-01 00:20:30.000000', 'consum', 0.0224, 'lps'),
	(558049, 128, '2014-03-01 00:20:31.000000', 'consum', 0.0226, 'lps'),
	(558050, 128, '2014-03-01 00:20:32.000000', 'consum', 0.0222, 'lps'),
	(558051, 128, '2014-03-01 00:20:33.000000', 'consum', 0.0223, 'lps'),
	(558052, 128, '2014-03-01 00:20:34.000000', 'consum', 0.0217, 'lps'),
	(558053, 128, '2014-03-01 00:20:35.000000', 'consum', 0.0229, 'lps'),
	(558054, 128, '2014-03-01 00:20:36.000000', 'consum', 0.0234, 'lps'),
	(558055, 128, '2014-03-01 00:20:37.000000', 'consum', 0.0223, 'lps'),
	(558056, 128, '2014-03-01 00:20:38.000000', 'consum', 0.0230, 'lps'),
	(558057, 128, '2014-03-01 00:20:39.000000', 'consum', 0.0221, 'lps'),
	(558058, 128, '2014-03-01 00:20:40.000000', 'consum', 0.0231, 'lps'),
	(558059, 128, '2014-03-01 00:20:41.000000', 'consum', 0.0230, 'lps'),
	(558060, 128, '2014-03-01 00:20:42.000000', 'consum', 0.0226, 'lps'),
	(558061, 128, '2014-03-01 00:20:43.000000', 'consum', 0.0229, 'lps'),
	(558062, 128, '2014-03-01 00:20:44.000000', 'consum', 0.0232, 'lps'),
	(558063, 128, '2014-03-01 00:20:45.000000', 'consum', 0.0213, 'lps'),
	(558064, 128, '2014-03-01 00:20:46.000000', 'consum', 0.0211, 'lps'),
	(558065, 128, '2014-03-01 00:20:47.000000', 'consum', 0.0232, 'lps'),
	(558066, 128, '2014-03-01 00:20:48.000000', 'consum', 0.0216, 'lps'),
	(558067, 128, '2014-03-01 00:20:49.000000', 'consum', 0.0227, 'lps'),
	(558068, 128, '2014-03-01 00:20:50.000000', 'consum', 0.0225, 'lps'),
	(558069, 128, '2014-03-01 00:20:51.000000', 'consum', 0.0211, 'lps'),
	(558070, 128, '2014-03-01 00:20:52.000000', 'consum', 0.0221, 'lps'),
	(558071, 128, '2014-03-01 00:20:53.000000', 'consum', 0.0212, 'lps'),
	(558072, 128, '2014-03-01 00:20:54.000000', 'consum', 0.0213, 'lps'),
	(558073, 128, '2014-03-01 00:20:55.000000', 'consum', 0.0220, 'lps'),
	(558074, 128, '2014-03-01 00:20:56.000000', 'consum', 0.0226, 'lps'),
	(558075, 128, '2014-03-01 00:20:57.000000', 'consum', 0.0212, 'lps'),
	(558076, 128, '2014-03-01 00:20:58.000000', 'consum', 0.0222, 'lps'),
	(558077, 128, '2014-03-01 00:20:59.000000', 'consum', 0.0216, 'lps'),
	(558078, 128, '2014-03-01 00:21:00.000000', 'consum', 0.0228, 'lps'),
	(558079, 128, '2014-03-01 00:21:01.000000', 'consum', 0.0232, 'lps'),
	(558080, 128, '2014-03-01 00:21:02.000000', 'consum', 0.0216, 'lps'),
	(558081, 128, '2014-03-01 00:21:03.000000', 'consum', 0.0224, 'lps'),
	(558082, 128, '2014-03-01 00:21:04.000000', 'consum', 0.0212, 'lps'),
	(558083, 128, '2014-03-01 00:21:05.000000', 'consum', 0.0230, 'lps'),
	(558084, 128, '2014-03-01 00:21:06.000000', 'consum', 0.0231, 'lps'),
	(558085, 128, '2014-03-01 00:21:07.000000', 'consum', 0.0229, 'lps'),
	(558086, 128, '2014-03-01 00:21:08.000000', 'consum', 0.0216, 'lps'),
	(558087, 128, '2014-03-01 00:21:09.000000', 'consum', 0.0211, 'lps'),
	(558088, 128, '2014-03-01 00:21:10.000000', 'consum', 0.0223, 'lps'),
	(558089, 128, '2014-03-01 00:21:11.000000', 'consum', 0.0223, 'lps'),
	(558090, 128, '2014-03-01 00:21:12.000000', 'consum', 0.0233, 'lps'),
	(558091, 128, '2014-03-01 00:21:13.000000', 'consum', 0.0215, 'lps'),
	(558092, 128, '2014-03-01 00:21:14.000000', 'consum', 0.0216, 'lps'),
	(558093, 128, '2014-03-01 00:21:15.000000', 'consum', 0.0224, 'lps'),
	(558094, 128, '2014-03-01 00:21:16.000000', 'consum', 0.0212, 'lps'),
	(558095, 128, '2014-03-01 00:21:17.000000', 'consum', 0.0228, 'lps'),
	(558096, 128, '2014-03-01 00:21:18.000000', 'consum', 0.0221, 'lps'),
	(558097, 128, '2014-03-01 00:21:19.000000', 'consum', 0.0212, 'lps'),
	(558098, 128, '2014-03-01 00:21:20.000000', 'consum', 0.0211, 'lps'),
	(558099, 128, '2014-03-01 00:21:21.000000', 'consum', 0.0212, 'lps'),
	(558100, 128, '2014-03-01 00:21:22.000000', 'consum', 0.0215, 'lps'),
	(558101, 128, '2014-03-01 00:21:23.000000', 'consum', 0.0231, 'lps'),
	(558102, 128, '2014-03-01 00:21:24.000000', 'consum', 0.0225, 'lps'),
	(558103, 128, '2014-03-01 00:21:25.000000', 'consum', 0.0221, 'lps'),
	(558104, 128, '2014-03-01 00:21:26.000000', 'consum', 0.0223, 'lps'),
	(558105, 128, '2014-03-01 00:21:27.000000', 'consum', 0.0218, 'lps'),
	(558106, 128, '2014-03-01 00:21:28.000000', 'consum', 0.0212, 'lps'),
	(558107, 128, '2014-03-01 00:21:29.000000', 'consum', 0.0220, 'lps'),
	(558108, 128, '2014-03-01 00:21:30.000000', 'consum', 0.0229, 'lps'),
	(558109, 128, '2014-03-01 00:21:31.000000', 'consum', 0.0227, 'lps'),
	(558110, 128, '2014-03-01 00:21:32.000000', 'consum', 0.0211, 'lps'),
	(558111, 128, '2014-03-01 00:21:33.000000', 'consum', 0.0215, 'lps'),
	(558112, 128, '2014-03-01 00:21:34.000000', 'consum', 0.0231, 'lps'),
	(558113, 128, '2014-03-01 00:21:35.000000', 'consum', 0.0229, 'lps'),
	(558114, 128, '2014-03-01 00:21:36.000000', 'consum', 0.0214, 'lps'),
	(558115, 128, '2014-03-01 00:21:37.000000', 'consum', 0.0227, 'lps'),
	(558116, 128, '2014-03-01 00:21:38.000000', 'consum', 0.0230, 'lps'),
	(558117, 128, '2014-03-01 00:21:39.000000', 'consum', 0.0212, 'lps'),
	(558118, 128, '2014-03-01 00:21:40.000000', 'consum', 0.0212, 'lps'),
	(558119, 128, '2014-03-01 00:21:41.000000', 'consum', 0.0212, 'lps'),
	(558120, 128, '2014-03-01 00:21:42.000000', 'consum', 0.0215, 'lps'),
	(558121, 128, '2014-03-01 00:21:43.000000', 'consum', 0.0230, 'lps'),
	(558122, 128, '2014-03-01 00:21:44.000000', 'consum', 0.0219, 'lps'),
	(558123, 128, '2014-03-01 00:21:45.000000', 'consum', 0.0222, 'lps'),
	(558124, 128, '2014-03-01 00:21:46.000000', 'consum', 0.0219, 'lps'),
	(558125, 128, '2014-03-01 00:21:47.000000', 'consum', 0.0220, 'lps'),
	(558126, 128, '2014-03-01 00:21:48.000000', 'consum', 0.0231, 'lps'),
	(558127, 128, '2014-03-01 00:21:49.000000', 'consum', 0.0210, 'lps'),
	(558128, 128, '2014-03-01 00:21:50.000000', 'consum', 0.0225, 'lps'),
	(558129, 128, '2014-03-01 00:21:51.000000', 'consum', 0.0211, 'lps'),
	(558130, 128, '2014-03-01 00:21:52.000000', 'consum', 0.0221, 'lps'),
	(558131, 128, '2014-03-01 00:21:53.000000', 'consum', 0.0213, 'lps'),
	(558132, 128, '2014-03-01 00:21:54.000000', 'consum', 0.0215, 'lps'),
	(558133, 128, '2014-03-01 00:21:55.000000', 'consum', 0.0226, 'lps'),
	(558134, 128, '2014-03-01 00:21:56.000000', 'consum', 0.0226, 'lps'),
	(558135, 128, '2014-03-01 00:21:57.000000', 'consum', 0.0216, 'lps'),
	(558136, 128, '2014-03-01 00:21:58.000000', 'consum', 0.0219, 'lps'),
	(558137, 128, '2014-03-01 00:21:59.000000', 'consum', 0.0211, 'lps'),
	(558138, 128, '2014-03-01 00:22:00.000000', 'consum', 0.0213, 'lps'),
	(558139, 128, '2014-03-01 00:22:01.000000', 'consum', 0.0223, 'lps'),
	(558140, 128, '2014-03-01 00:22:02.000000', 'consum', 0.0217, 'lps'),
	(558141, 128, '2014-03-01 00:22:03.000000', 'consum', 0.0232, 'lps'),
	(558142, 128, '2014-03-01 00:22:04.000000', 'consum', 0.0225, 'lps'),
	(558143, 128, '2014-03-01 00:22:05.000000', 'consum', 0.0218, 'lps'),
	(558144, 128, '2014-03-01 00:22:06.000000', 'consum', 0.0233, 'lps'),
	(558145, 128, '2014-03-01 00:22:07.000000', 'consum', 0.0225, 'lps'),
	(558146, 128, '2014-03-01 00:22:08.000000', 'consum', 0.0218, 'lps'),
	(558147, 128, '2014-03-01 00:22:09.000000', 'consum', 0.0232, 'lps'),
	(558148, 128, '2014-03-01 00:22:10.000000', 'consum', 0.0218, 'lps'),
	(558149, 128, '2014-03-01 00:22:11.000000', 'consum', 0.0210, 'lps'),
	(558150, 128, '2014-03-01 00:22:12.000000', 'consum', 0.0214, 'lps'),
	(558151, 128, '2014-03-01 00:22:13.000000', 'consum', 0.0227, 'lps'),
	(558152, 128, '2014-03-01 00:22:14.000000', 'consum', 0.0212, 'lps'),
	(558153, 128, '2014-03-01 00:22:15.000000', 'consum', 0.0218, 'lps'),
	(558154, 128, '2014-03-01 00:22:16.000000', 'consum', 0.0222, 'lps'),
	(558155, 128, '2014-03-01 00:22:17.000000', 'consum', 0.0218, 'lps'),
	(558156, 128, '2014-03-01 00:22:18.000000', 'consum', 0.0216, 'lps'),
	(558157, 128, '2014-03-01 00:22:19.000000', 'consum', 0.0217, 'lps'),
	(558158, 128, '2014-03-01 00:22:20.000000', 'consum', 0.0228, 'lps'),
	(558159, 128, '2014-03-01 00:22:21.000000', 'consum', 0.0231, 'lps'),
	(558160, 128, '2014-03-01 00:22:22.000000', 'consum', 0.0210, 'lps'),
	(558161, 128, '2014-03-01 00:22:23.000000', 'consum', 0.0221, 'lps'),
	(558162, 128, '2014-03-01 00:22:24.000000', 'consum', 0.0215, 'lps'),
	(558163, 128, '2014-03-01 00:22:25.000000', 'consum', 0.0230, 'lps'),
	(558164, 128, '2014-03-01 00:22:26.000000', 'consum', 0.0218, 'lps'),
	(558165, 128, '2014-03-01 00:22:27.000000', 'consum', 0.0215, 'lps'),
	(558166, 128, '2014-03-01 00:22:28.000000', 'consum', 0.0213, 'lps'),
	(558167, 128, '2014-03-01 00:22:29.000000', 'consum', 0.0211, 'lps'),
	(558168, 128, '2014-03-01 00:22:30.000000', 'consum', 0.0232, 'lps'),
	(558169, 128, '2014-03-01 00:22:31.000000', 'consum', 0.0216, 'lps'),
	(558170, 128, '2014-03-01 00:22:32.000000', 'consum', 0.0225, 'lps'),
	(558171, 128, '2014-03-01 00:22:33.000000', 'consum', 0.0216, 'lps'),
	(558172, 128, '2014-03-01 00:22:34.000000', 'consum', 0.0220, 'lps'),
	(558173, 128, '2014-03-01 00:22:35.000000', 'consum', 0.0218, 'lps'),
	(558174, 128, '2014-03-01 00:22:36.000000', 'consum', 0.0223, 'lps'),
	(558175, 128, '2014-03-01 00:22:37.000000', 'consum', 0.0224, 'lps'),
	(558176, 128, '2014-03-01 00:22:38.000000', 'consum', 0.0217, 'lps'),
	(558177, 128, '2014-03-01 00:22:39.000000', 'consum', 0.0229, 'lps'),
	(558178, 128, '2014-03-01 00:22:40.000000', 'consum', 0.0210, 'lps'),
	(558179, 128, '2014-03-01 00:22:41.000000', 'consum', 0.0230, 'lps'),
	(558180, 128, '2014-03-01 00:22:42.000000', 'consum', 0.0233, 'lps'),
	(558181, 128, '2014-03-01 00:22:43.000000', 'consum', 0.0217, 'lps'),
	(558182, 128, '2014-03-01 00:22:44.000000', 'consum', 0.0228, 'lps'),
	(558183, 128, '2014-03-01 00:22:45.000000', 'consum', 0.0227, 'lps'),
	(558184, 128, '2014-03-01 00:22:46.000000', 'consum', 0.0216, 'lps'),
	(558185, 128, '2014-03-01 00:22:47.000000', 'consum', 0.0217, 'lps'),
	(558186, 128, '2014-03-01 00:22:48.000000', 'consum', 0.0228, 'lps'),
	(558187, 128, '2014-03-01 00:22:49.000000', 'consum', 0.0227, 'lps'),
	(558188, 128, '2014-03-01 00:22:50.000000', 'consum', 0.0218, 'lps'),
	(558189, 128, '2014-03-01 00:22:51.000000', 'consum', 0.0225, 'lps'),
	(558190, 128, '2014-03-01 00:22:52.000000', 'consum', 0.0234, 'lps'),
	(558191, 128, '2014-03-01 00:22:53.000000', 'consum', 0.0212, 'lps'),
	(558192, 128, '2014-03-01 00:22:54.000000', 'consum', 0.0225, 'lps'),
	(558193, 128, '2014-03-01 00:22:55.000000', 'consum', 0.0230, 'lps'),
	(558194, 128, '2014-03-01 00:22:56.000000', 'consum', 0.0216, 'lps'),
	(558195, 128, '2014-03-01 00:22:57.000000', 'consum', 0.0228, 'lps'),
	(558196, 128, '2014-03-01 00:22:58.000000', 'consum', 0.0210, 'lps'),
	(558197, 128, '2014-03-01 00:22:59.000000', 'consum', 0.0229, 'lps'),
	(558198, 128, '2014-03-01 00:23:00.000000', 'consum', 0.0231, 'lps'),
	(558199, 128, '2014-03-01 00:23:01.000000', 'consum', 0.0234, 'lps'),
	(558200, 128, '2014-03-01 00:23:02.000000', 'consum', 0.0218, 'lps'),
	(558201, 128, '2014-03-01 00:23:03.000000', 'consum', 0.0228, 'lps'),
	(558202, 128, '2014-03-01 00:23:04.000000', 'consum', 0.0225, 'lps'),
	(558203, 128, '2014-03-01 00:23:05.000000', 'consum', 0.0234, 'lps'),
	(558204, 128, '2014-03-01 00:23:06.000000', 'consum', 0.0211, 'lps'),
	(558205, 128, '2014-03-01 00:23:07.000000', 'consum', 0.0218, 'lps'),
	(558206, 128, '2014-03-01 00:23:08.000000', 'consum', 0.0220, 'lps'),
	(558207, 128, '2014-03-01 00:23:09.000000', 'consum', 0.0214, 'lps'),
	(558208, 128, '2014-03-01 00:23:10.000000', 'consum', 0.0225, 'lps'),
	(558209, 128, '2014-03-01 00:23:11.000000', 'consum', 0.0223, 'lps'),
	(558210, 128, '2014-03-01 00:23:12.000000', 'consum', 0.0231, 'lps'),
	(558211, 128, '2014-03-01 00:23:13.000000', 'consum', 0.0227, 'lps'),
	(558212, 128, '2014-03-01 00:23:14.000000', 'consum', 0.0230, 'lps'),
	(558213, 128, '2014-03-01 00:23:15.000000', 'consum', 0.0212, 'lps'),
	(558214, 128, '2014-03-01 00:23:16.000000', 'consum', 0.0233, 'lps'),
	(558215, 128, '2014-03-01 00:23:17.000000', 'consum', 0.0223, 'lps'),
	(558216, 128, '2014-03-01 00:23:18.000000', 'consum', 0.0228, 'lps'),
	(558217, 128, '2014-03-01 00:23:19.000000', 'consum', 0.0212, 'lps'),
	(558218, 128, '2014-03-01 00:23:20.000000', 'consum', 0.0218, 'lps'),
	(558219, 128, '2014-03-01 00:23:21.000000', 'consum', 0.0218, 'lps'),
	(558220, 128, '2014-03-01 00:23:22.000000', 'consum', 0.0226, 'lps'),
	(558221, 128, '2014-03-01 00:23:23.000000', 'consum', 0.0217, 'lps'),
	(558222, 128, '2014-03-01 00:23:24.000000', 'consum', 0.0221, 'lps'),
	(558223, 128, '2014-03-01 00:23:25.000000', 'consum', 0.0220, 'lps'),
	(558224, 128, '2014-03-01 00:23:26.000000', 'consum', 0.0229, 'lps'),
	(558225, 128, '2014-03-01 00:23:27.000000', 'consum', 0.0227, 'lps'),
	(558226, 128, '2014-03-01 00:23:28.000000', 'consum', 0.0211, 'lps'),
	(558227, 128, '2014-03-01 00:23:29.000000', 'consum', 0.0217, 'lps'),
	(558228, 128, '2014-03-01 00:23:30.000000', 'consum', 0.0215, 'lps'),
	(558229, 128, '2014-03-01 00:23:31.000000', 'consum', 0.0217, 'lps'),
	(558230, 128, '2014-03-01 00:23:32.000000', 'consum', 0.0229, 'lps'),
	(558231, 128, '2014-03-01 00:23:33.000000', 'consum', 0.0211, 'lps'),
	(558232, 128, '2014-03-01 00:23:34.000000', 'consum', 0.0232, 'lps'),
	(558233, 128, '2014-03-01 00:23:35.000000', 'consum', 0.0220, 'lps'),
	(558234, 128, '2014-03-01 00:23:36.000000', 'consum', 0.0217, 'lps'),
	(558235, 128, '2014-03-01 00:23:37.000000', 'consum', 0.0215, 'lps'),
	(558236, 128, '2014-03-01 00:23:38.000000', 'consum', 0.0215, 'lps'),
	(558237, 128, '2014-03-01 00:23:39.000000', 'consum', 0.0222, 'lps'),
	(558238, 128, '2014-03-01 00:23:40.000000', 'consum', 0.0231, 'lps'),
	(558239, 128, '2014-03-01 00:23:41.000000', 'consum', 0.0230, 'lps'),
	(558240, 128, '2014-03-01 00:23:42.000000', 'consum', 0.0220, 'lps'),
	(558241, 128, '2014-03-01 00:23:43.000000', 'consum', 0.0228, 'lps'),
	(558242, 128, '2014-03-01 00:23:44.000000', 'consum', 0.0218, 'lps'),
	(558243, 128, '2014-03-01 00:23:45.000000', 'consum', 0.0225, 'lps'),
	(558244, 128, '2014-03-01 00:23:46.000000', 'consum', 0.0233, 'lps'),
	(558245, 128, '2014-03-01 00:23:47.000000', 'consum', 0.0231, 'lps'),
	(558246, 128, '2014-03-01 00:23:48.000000', 'consum', 0.0220, 'lps'),
	(558247, 128, '2014-03-01 00:23:49.000000', 'consum', 0.0225, 'lps'),
	(558248, 128, '2014-03-01 00:23:50.000000', 'consum', 0.0230, 'lps'),
	(558249, 128, '2014-03-01 00:23:51.000000', 'consum', 0.0214, 'lps'),
	(558250, 128, '2014-03-01 00:23:52.000000', 'consum', 0.0221, 'lps'),
	(558251, 128, '2014-03-01 00:23:53.000000', 'consum', 0.0230, 'lps'),
	(558252, 128, '2014-03-01 00:23:54.000000', 'consum', 0.0228, 'lps'),
	(558253, 128, '2014-03-01 00:23:55.000000', 'consum', 0.0214, 'lps'),
	(558254, 128, '2014-03-01 00:23:56.000000', 'consum', 0.0226, 'lps'),
	(558255, 128, '2014-03-01 00:23:57.000000', 'consum', 0.0231, 'lps'),
	(558256, 128, '2014-03-01 00:23:58.000000', 'consum', 0.0215, 'lps'),
	(558257, 128, '2014-03-01 00:23:59.000000', 'consum', 0.0223, 'lps'),
	(558258, 128, '2014-03-01 00:24:00.000000', 'consum', 0.0210, 'lps'),
	(558259, 128, '2014-03-01 00:24:01.000000', 'consum', 0.0223, 'lps'),
	(558260, 128, '2014-03-01 00:24:02.000000', 'consum', 0.0223, 'lps'),
	(558261, 128, '2014-03-01 00:24:03.000000', 'consum', 0.0212, 'lps'),
	(558262, 128, '2014-03-01 00:24:04.000000', 'consum', 0.0233, 'lps'),
	(558263, 128, '2014-03-01 00:24:05.000000', 'consum', 0.0217, 'lps'),
	(558264, 128, '2014-03-01 00:24:06.000000', 'consum', 0.0227, 'lps'),
	(558265, 128, '2014-03-01 00:24:07.000000', 'consum', 0.0225, 'lps'),
	(558266, 128, '2014-03-01 00:24:08.000000', 'consum', 0.0211, 'lps'),
	(558267, 128, '2014-03-01 00:24:09.000000', 'consum', 0.0220, 'lps'),
	(558268, 128, '2014-03-01 00:24:10.000000', 'consum', 0.0234, 'lps'),
	(558269, 128, '2014-03-01 00:24:11.000000', 'consum', 0.0222, 'lps'),
	(558270, 128, '2014-03-01 00:24:12.000000', 'consum', 0.0226, 'lps'),
	(558271, 128, '2014-03-01 00:24:13.000000', 'consum', 0.0228, 'lps'),
	(558272, 128, '2014-03-01 00:24:14.000000', 'consum', 0.0227, 'lps'),
	(558273, 128, '2014-03-01 00:24:15.000000', 'consum', 0.0219, 'lps'),
	(558274, 128, '2014-03-01 00:24:16.000000', 'consum', 0.0229, 'lps'),
	(558275, 128, '2014-03-01 00:24:17.000000', 'consum', 0.0228, 'lps'),
	(558276, 128, '2014-03-01 00:24:18.000000', 'consum', 0.0218, 'lps'),
	(558277, 128, '2014-03-01 00:24:19.000000', 'consum', 0.0222, 'lps'),
	(558278, 128, '2014-03-01 00:24:20.000000', 'consum', 0.0221, 'lps'),
	(558279, 128, '2014-03-01 00:24:21.000000', 'consum', 0.0231, 'lps'),
	(558280, 128, '2014-03-01 00:24:22.000000', 'consum', 0.0233, 'lps'),
	(558281, 128, '2014-03-01 00:24:23.000000', 'consum', 0.0212, 'lps'),
	(558282, 128, '2014-03-01 00:24:24.000000', 'consum', 0.0227, 'lps'),
	(558283, 128, '2014-03-01 00:24:25.000000', 'consum', 0.0215, 'lps'),
	(558284, 128, '2014-03-01 00:24:26.000000', 'consum', 0.0210, 'lps'),
	(558285, 128, '2014-03-01 00:24:27.000000', 'consum', 0.0219, 'lps'),
	(558286, 128, '2014-03-01 00:24:28.000000', 'consum', 0.0232, 'lps'),
	(558287, 128, '2014-03-01 00:24:29.000000', 'consum', 0.0217, 'lps'),
	(558288, 128, '2014-03-01 00:24:30.000000', 'consum', 0.0228, 'lps'),
	(558289, 128, '2014-03-01 00:24:31.000000', 'consum', 0.0231, 'lps'),
	(558290, 128, '2014-03-01 00:24:32.000000', 'consum', 0.0211, 'lps'),
	(558291, 128, '2014-03-01 00:24:33.000000', 'consum', 0.0230, 'lps'),
	(558292, 128, '2014-03-01 00:24:34.000000', 'consum', 0.0230, 'lps'),
	(558293, 128, '2014-03-01 00:24:35.000000', 'consum', 0.0228, 'lps'),
	(558294, 128, '2014-03-01 00:24:36.000000', 'consum', 0.0213, 'lps'),
	(558295, 128, '2014-03-01 00:24:37.000000', 'consum', 0.0224, 'lps'),
	(558296, 128, '2014-03-01 00:24:38.000000', 'consum', 0.0221, 'lps'),
	(558297, 128, '2014-03-01 00:24:39.000000', 'consum', 0.0224, 'lps'),
	(558298, 128, '2014-03-01 00:24:40.000000', 'consum', 0.0222, 'lps'),
	(558299, 128, '2014-03-01 00:24:41.000000', 'consum', 0.0229, 'lps'),
	(558300, 128, '2014-03-01 00:24:42.000000', 'consum', 0.0217, 'lps'),
	(558301, 128, '2014-03-01 00:24:43.000000', 'consum', 0.0216, 'lps'),
	(558302, 128, '2014-03-01 00:24:44.000000', 'consum', 0.0220, 'lps'),
	(558303, 128, '2014-03-01 00:24:45.000000', 'consum', 0.0215, 'lps'),
	(558304, 128, '2014-03-01 00:24:46.000000', 'consum', 0.0232, 'lps'),
	(558305, 128, '2014-03-01 00:24:47.000000', 'consum', 0.0229, 'lps'),
	(558306, 128, '2014-03-01 00:24:48.000000', 'consum', 0.0214, 'lps'),
	(558307, 128, '2014-03-01 00:24:49.000000', 'consum', 0.0224, 'lps'),
	(558308, 128, '2014-03-01 00:24:50.000000', 'consum', 0.0217, 'lps'),
	(558309, 128, '2014-03-01 00:24:51.000000', 'consum', 0.0231, 'lps'),
	(558310, 128, '2014-03-01 00:24:52.000000', 'consum', 0.0217, 'lps'),
	(558311, 128, '2014-03-01 00:24:53.000000', 'consum', 0.0234, 'lps'),
	(558312, 128, '2014-03-01 00:24:54.000000', 'consum', 0.0210, 'lps'),
	(558313, 128, '2014-03-01 00:24:55.000000', 'consum', 0.0211, 'lps'),
	(558314, 128, '2014-03-01 00:24:56.000000', 'consum', 0.0216, 'lps'),
	(558315, 128, '2014-03-01 00:24:57.000000', 'consum', 0.0214, 'lps'),
	(558316, 128, '2014-03-01 00:24:58.000000', 'consum', 0.0214, 'lps'),
	(558317, 128, '2014-03-01 00:24:59.000000', 'consum', 0.0217, 'lps'),
	(558318, 128, '2014-03-01 00:25:00.000000', 'consum', 0.0233, 'lps'),
	(558319, 128, '2014-03-01 00:25:01.000000', 'consum', 0.0230, 'lps'),
	(558320, 128, '2014-03-01 00:25:02.000000', 'consum', 0.0218, 'lps'),
	(558321, 128, '2014-03-01 00:25:03.000000', 'consum', 0.0215, 'lps'),
	(558322, 128, '2014-03-01 00:25:04.000000', 'consum', 0.0212, 'lps'),
	(558323, 128, '2014-03-01 00:25:05.000000', 'consum', 0.0231, 'lps'),
	(558324, 128, '2014-03-01 00:25:06.000000', 'consum', 0.0211, 'lps'),
	(558325, 128, '2014-03-01 00:25:07.000000', 'consum', 0.0224, 'lps'),
	(558326, 128, '2014-03-01 00:25:08.000000', 'consum', 0.0230, 'lps'),
	(558327, 128, '2014-03-01 00:25:09.000000', 'consum', 0.0217, 'lps'),
	(558328, 128, '2014-03-01 00:25:10.000000', 'consum', 0.0211, 'lps'),
	(558329, 128, '2014-03-01 00:25:11.000000', 'consum', 0.0221, 'lps'),
	(558330, 128, '2014-03-01 00:25:12.000000', 'consum', 0.0211, 'lps'),
	(558331, 128, '2014-03-01 00:25:13.000000', 'consum', 0.0232, 'lps'),
	(558332, 128, '2014-03-01 00:25:14.000000', 'consum', 0.0219, 'lps'),
	(558333, 128, '2014-03-01 00:25:15.000000', 'consum', 0.0213, 'lps'),
	(558334, 128, '2014-03-01 00:25:16.000000', 'consum', 0.0222, 'lps'),
	(558335, 128, '2014-03-01 00:25:17.000000', 'consum', 0.0214, 'lps'),
	(558336, 128, '2014-03-01 00:25:18.000000', 'consum', 0.0219, 'lps'),
	(558337, 128, '2014-03-01 00:25:19.000000', 'consum', 0.0218, 'lps'),
	(558338, 128, '2014-03-01 00:25:20.000000', 'consum', 0.0222, 'lps'),
	(558339, 128, '2014-03-01 00:25:21.000000', 'consum', 0.0225, 'lps'),
	(558340, 128, '2014-03-01 00:25:22.000000', 'consum', 0.0222, 'lps'),
	(558341, 128, '2014-03-01 00:25:23.000000', 'consum', 0.0226, 'lps'),
	(558342, 128, '2014-03-01 00:25:24.000000', 'consum', 0.0232, 'lps'),
	(558343, 128, '2014-03-01 00:25:25.000000', 'consum', 0.0219, 'lps'),
	(558344, 128, '2014-03-01 00:25:26.000000', 'consum', 0.0216, 'lps'),
	(558345, 128, '2014-03-01 00:25:27.000000', 'consum', 0.0215, 'lps'),
	(558346, 128, '2014-03-01 00:25:28.000000', 'consum', 0.0214, 'lps'),
	(558347, 128, '2014-03-01 00:25:29.000000', 'consum', 0.0218, 'lps'),
	(558348, 128, '2014-03-01 00:25:30.000000', 'consum', 0.0215, 'lps'),
	(558349, 128, '2014-03-01 00:25:31.000000', 'consum', 0.0233, 'lps'),
	(558350, 128, '2014-03-01 00:25:32.000000', 'consum', 0.0213, 'lps'),
	(558351, 128, '2014-03-01 00:25:33.000000', 'consum', 0.0232, 'lps'),
	(558352, 128, '2014-03-01 00:25:34.000000', 'consum', 0.0212, 'lps'),
	(558353, 128, '2014-03-01 00:25:35.000000', 'consum', 0.0227, 'lps'),
	(558354, 128, '2014-03-01 00:25:36.000000', 'consum', 0.0216, 'lps'),
	(558355, 128, '2014-03-01 00:25:37.000000', 'consum', 0.0216, 'lps'),
	(558356, 128, '2014-03-01 00:25:38.000000', 'consum', 0.0222, 'lps'),
	(558357, 128, '2014-03-01 00:25:39.000000', 'consum', 0.0226, 'lps'),
	(558358, 128, '2014-03-01 00:25:40.000000', 'consum', 0.0229, 'lps'),
	(558359, 128, '2014-03-01 00:25:41.000000', 'consum', 0.0210, 'lps'),
	(558360, 128, '2014-03-01 00:25:42.000000', 'consum', 0.0228, 'lps'),
	(558361, 128, '2014-03-01 00:25:43.000000', 'consum', 0.0227, 'lps'),
	(558362, 128, '2014-03-01 00:25:44.000000', 'consum', 0.0216, 'lps'),
	(558363, 128, '2014-03-01 00:25:45.000000', 'consum', 0.0213, 'lps'),
	(558364, 128, '2014-03-01 00:25:46.000000', 'consum', 0.0210, 'lps'),
	(558365, 128, '2014-03-01 00:25:47.000000', 'consum', 0.0226, 'lps'),
	(558366, 128, '2014-03-01 00:25:48.000000', 'consum', 0.0215, 'lps'),
	(558367, 128, '2014-03-01 00:25:49.000000', 'consum', 0.0214, 'lps'),
	(558368, 128, '2014-03-01 00:25:50.000000', 'consum', 0.0214, 'lps'),
	(558369, 128, '2014-03-01 00:25:51.000000', 'consum', 0.0218, 'lps'),
	(558370, 128, '2014-03-01 00:25:52.000000', 'consum', 0.0214, 'lps'),
	(558371, 128, '2014-03-01 00:25:53.000000', 'consum', 0.0231, 'lps'),
	(558372, 128, '2014-03-01 00:25:54.000000', 'consum', 0.0229, 'lps'),
	(558373, 128, '2014-03-01 00:25:55.000000', 'consum', 0.0217, 'lps'),
	(558374, 128, '2014-03-01 00:25:56.000000', 'consum', 0.0213, 'lps'),
	(558375, 128, '2014-03-01 00:25:57.000000', 'consum', 0.0230, 'lps'),
	(558376, 128, '2014-03-01 00:25:58.000000', 'consum', 0.0225, 'lps'),
	(558377, 128, '2014-03-01 00:25:59.000000', 'consum', 0.0228, 'lps'),
	(558378, 128, '2014-03-01 00:26:00.000000', 'consum', 0.0229, 'lps'),
	(558379, 128, '2014-03-01 00:26:01.000000', 'consum', 0.0226, 'lps'),
	(558380, 128, '2014-03-01 00:26:02.000000', 'consum', 0.0210, 'lps'),
	(558381, 128, '2014-03-01 00:26:03.000000', 'consum', 0.0214, 'lps'),
	(558382, 128, '2014-03-01 00:26:04.000000', 'consum', 0.0229, 'lps'),
	(558383, 128, '2014-03-01 00:26:05.000000', 'consum', 0.0217, 'lps'),
	(558384, 128, '2014-03-01 00:26:06.000000', 'consum', 0.0214, 'lps'),
	(558385, 128, '2014-03-01 00:26:07.000000', 'consum', 0.0234, 'lps'),
	(558386, 128, '2014-03-01 00:26:08.000000', 'consum', 0.0219, 'lps'),
	(558387, 128, '2014-03-01 00:26:09.000000', 'consum', 0.0233, 'lps'),
	(558388, 128, '2014-03-01 00:26:10.000000', 'consum', 0.0226, 'lps'),
	(558389, 128, '2014-03-01 00:26:11.000000', 'consum', 0.0218, 'lps'),
	(558390, 128, '2014-03-01 00:26:12.000000', 'consum', 0.0230, 'lps'),
	(558391, 128, '2014-03-01 00:26:13.000000', 'consum', 0.0210, 'lps'),
	(558392, 128, '2014-03-01 00:26:14.000000', 'consum', 0.0224, 'lps'),
	(558393, 128, '2014-03-01 00:26:15.000000', 'consum', 0.0233, 'lps'),
	(558394, 128, '2014-03-01 00:26:16.000000', 'consum', 0.0232, 'lps'),
	(558395, 128, '2014-03-01 00:26:17.000000', 'consum', 0.0228, 'lps'),
	(558396, 128, '2014-03-01 00:26:18.000000', 'consum', 0.0232, 'lps'),
	(558397, 128, '2014-03-01 00:26:19.000000', 'consum', 0.0218, 'lps'),
	(558398, 128, '2014-03-01 00:26:20.000000', 'consum', 0.0210, 'lps'),
	(558399, 128, '2014-03-01 00:26:21.000000', 'consum', 0.0212, 'lps'),
	(558400, 128, '2014-03-01 00:26:22.000000', 'consum', 0.0219, 'lps'),
	(558401, 128, '2014-03-01 00:26:23.000000', 'consum', 0.0226, 'lps'),
	(558402, 128, '2014-03-01 00:26:24.000000', 'consum', 0.0214, 'lps'),
	(558403, 128, '2014-03-01 00:26:25.000000', 'consum', 0.0230, 'lps'),
	(558404, 128, '2014-03-01 00:26:26.000000', 'consum', 0.0227, 'lps'),
	(558405, 128, '2014-03-01 00:26:27.000000', 'consum', 0.0233, 'lps'),
	(558406, 128, '2014-03-01 00:26:28.000000', 'consum', 0.0226, 'lps'),
	(558407, 128, '2014-03-01 00:26:29.000000', 'consum', 0.0220, 'lps'),
	(558408, 128, '2014-03-01 00:26:30.000000', 'consum', 0.0212, 'lps'),
	(558409, 128, '2014-03-01 00:26:31.000000', 'consum', 0.0216, 'lps'),
	(558410, 128, '2014-03-01 00:26:32.000000', 'consum', 0.0211, 'lps'),
	(558411, 128, '2014-03-01 00:26:33.000000', 'consum', 0.0223, 'lps'),
	(558412, 128, '2014-03-01 00:26:34.000000', 'consum', 0.0222, 'lps'),
	(558413, 128, '2014-03-01 00:26:35.000000', 'consum', 0.0231, 'lps'),
	(558414, 128, '2014-03-01 00:26:36.000000', 'consum', 0.0230, 'lps'),
	(558415, 128, '2014-03-01 00:26:37.000000', 'consum', 0.0224, 'lps'),
	(558416, 128, '2014-03-01 00:26:38.000000', 'consum', 0.0220, 'lps'),
	(558417, 128, '2014-03-01 00:26:39.000000', 'consum', 0.0219, 'lps'),
	(558418, 128, '2014-03-01 00:26:40.000000', 'consum', 0.0223, 'lps'),
	(558419, 128, '2014-03-01 00:26:41.000000', 'consum', 0.0225, 'lps'),
	(558420, 128, '2014-03-01 00:26:42.000000', 'consum', 0.0220, 'lps'),
	(558421, 128, '2014-03-01 00:26:43.000000', 'consum', 0.0215, 'lps'),
	(558422, 128, '2014-03-01 00:26:44.000000', 'consum', 0.0233, 'lps'),
	(558423, 128, '2014-03-01 00:26:45.000000', 'consum', 0.0212, 'lps'),
	(558424, 128, '2014-03-01 00:26:46.000000', 'consum', 0.0223, 'lps'),
	(558425, 128, '2014-03-01 00:26:47.000000', 'consum', 0.0219, 'lps'),
	(558426, 128, '2014-03-01 00:26:48.000000', 'consum', 0.0217, 'lps'),
	(558427, 128, '2014-03-01 00:26:49.000000', 'consum', 0.0221, 'lps'),
	(558428, 128, '2014-03-01 00:26:50.000000', 'consum', 0.0218, 'lps'),
	(558429, 128, '2014-03-01 00:26:51.000000', 'consum', 0.0216, 'lps'),
	(558430, 128, '2014-03-01 00:26:52.000000', 'consum', 0.0218, 'lps'),
	(558431, 128, '2014-03-01 00:26:53.000000', 'consum', 0.0234, 'lps'),
	(558432, 128, '2014-03-01 00:26:54.000000', 'consum', 0.0228, 'lps'),
	(558433, 128, '2014-03-01 00:26:55.000000', 'consum', 0.0232, 'lps'),
	(558434, 128, '2014-03-01 00:26:56.000000', 'consum', 0.0213, 'lps'),
	(558435, 128, '2014-03-01 00:26:57.000000', 'consum', 0.0212, 'lps'),
	(558436, 128, '2014-03-01 00:26:58.000000', 'consum', 0.0210, 'lps'),
	(558437, 128, '2014-03-01 00:26:59.000000', 'consum', 0.0231, 'lps'),
	(558438, 128, '2014-03-01 00:27:00.000000', 'consum', 0.0217, 'lps'),
	(558439, 128, '2014-03-01 00:27:01.000000', 'consum', 0.0230, 'lps'),
	(558440, 128, '2014-03-01 00:27:02.000000', 'consum', 0.0217, 'lps'),
	(558441, 128, '2014-03-01 00:27:03.000000', 'consum', 0.0210, 'lps'),
	(558442, 128, '2014-03-01 00:27:04.000000', 'consum', 0.0213, 'lps'),
	(558443, 128, '2014-03-01 00:27:05.000000', 'consum', 0.0226, 'lps'),
	(558444, 128, '2014-03-01 00:27:06.000000', 'consum', 0.0231, 'lps'),
	(558445, 128, '2014-03-01 00:27:07.000000', 'consum', 0.0216, 'lps'),
	(558446, 128, '2014-03-01 00:27:08.000000', 'consum', 0.0229, 'lps'),
	(558447, 128, '2014-03-01 00:27:09.000000', 'consum', 0.0212, 'lps'),
	(558448, 128, '2014-03-01 00:27:10.000000', 'consum', 0.0214, 'lps'),
	(558449, 128, '2014-03-01 00:27:11.000000', 'consum', 0.0224, 'lps'),
	(558450, 128, '2014-03-01 00:27:12.000000', 'consum', 0.0220, 'lps'),
	(558451, 128, '2014-03-01 00:27:13.000000', 'consum', 0.0217, 'lps'),
	(558452, 128, '2014-03-01 00:27:14.000000', 'consum', 0.0217, 'lps'),
	(558453, 128, '2014-03-01 00:27:15.000000', 'consum', 0.0224, 'lps'),
	(558454, 128, '2014-03-01 00:27:16.000000', 'consum', 0.0211, 'lps'),
	(558455, 128, '2014-03-01 00:27:17.000000', 'consum', 0.0223, 'lps'),
	(558456, 128, '2014-03-01 00:27:18.000000', 'consum', 0.0222, 'lps'),
	(558457, 128, '2014-03-01 00:27:19.000000', 'consum', 0.0233, 'lps'),
	(558458, 128, '2014-03-01 00:27:20.000000', 'consum', 0.0214, 'lps'),
	(558459, 128, '2014-03-01 00:27:21.000000', 'consum', 0.0210, 'lps'),
	(558460, 128, '2014-03-01 00:27:22.000000', 'consum', 0.0223, 'lps'),
	(558461, 128, '2014-03-01 00:27:23.000000', 'consum', 0.0225, 'lps'),
	(558462, 128, '2014-03-01 00:27:24.000000', 'consum', 0.0224, 'lps'),
	(558463, 128, '2014-03-01 00:27:25.000000', 'consum', 0.0211, 'lps'),
	(558464, 128, '2014-03-01 00:27:26.000000', 'consum', 0.0222, 'lps'),
	(558465, 128, '2014-03-01 00:27:27.000000', 'consum', 0.0217, 'lps'),
	(558466, 128, '2014-03-01 00:27:28.000000', 'consum', 0.0211, 'lps'),
	(558467, 128, '2014-03-01 00:27:29.000000', 'consum', 0.0218, 'lps'),
	(558468, 128, '2014-03-01 00:27:30.000000', 'consum', 0.0222, 'lps'),
	(558469, 128, '2014-03-01 00:27:31.000000', 'consum', 0.0222, 'lps'),
	(558470, 128, '2014-03-01 00:27:32.000000', 'consum', 0.0210, 'lps'),
	(558471, 128, '2014-03-01 00:27:33.000000', 'consum', 0.0223, 'lps'),
	(558472, 128, '2014-03-01 00:27:34.000000', 'consum', 0.0226, 'lps'),
	(558473, 128, '2014-03-01 00:27:35.000000', 'consum', 0.0228, 'lps'),
	(558474, 128, '2014-03-01 00:27:36.000000', 'consum', 0.0226, 'lps'),
	(558475, 128, '2014-03-01 00:27:37.000000', 'consum', 0.0213, 'lps'),
	(558476, 128, '2014-03-01 00:27:38.000000', 'consum', 0.0226, 'lps'),
	(558477, 128, '2014-03-01 00:27:39.000000', 'consum', 0.0230, 'lps'),
	(558478, 128, '2014-03-01 00:27:40.000000', 'consum', 0.0216, 'lps'),
	(558479, 128, '2014-03-01 00:27:41.000000', 'consum', 0.0227, 'lps'),
	(558480, 128, '2014-03-01 00:27:42.000000', 'consum', 0.0229, 'lps'),
	(558481, 128, '2014-03-01 00:27:43.000000', 'consum', 0.0229, 'lps'),
	(558482, 128, '2014-03-01 00:27:44.000000', 'consum', 0.0224, 'lps'),
	(558483, 128, '2014-03-01 00:27:45.000000', 'consum', 0.0225, 'lps'),
	(558484, 128, '2014-03-01 00:27:46.000000', 'consum', 0.0218, 'lps'),
	(558485, 128, '2014-03-01 00:27:47.000000', 'consum', 0.0230, 'lps'),
	(558486, 128, '2014-03-01 00:27:48.000000', 'consum', 0.0213, 'lps'),
	(558487, 128, '2014-03-01 00:27:49.000000', 'consum', 0.0214, 'lps'),
	(558488, 128, '2014-03-01 00:27:50.000000', 'consum', 0.0221, 'lps'),
	(558489, 128, '2014-03-01 00:27:51.000000', 'consum', 0.0231, 'lps'),
	(558490, 128, '2014-03-01 00:27:52.000000', 'consum', 0.0232, 'lps'),
	(558491, 128, '2014-03-01 00:27:53.000000', 'consum', 0.0231, 'lps'),
	(558492, 128, '2014-03-01 00:27:54.000000', 'consum', 0.0225, 'lps'),
	(558493, 128, '2014-03-01 00:27:55.000000', 'consum', 0.0221, 'lps'),
	(558494, 128, '2014-03-01 00:27:56.000000', 'consum', 0.0221, 'lps'),
	(558495, 128, '2014-03-01 00:27:57.000000', 'consum', 0.0232, 'lps'),
	(558496, 128, '2014-03-01 00:27:58.000000', 'consum', 0.0213, 'lps'),
	(558497, 128, '2014-03-01 00:27:59.000000', 'consum', 0.0211, 'lps'),
	(558498, 128, '2014-03-01 00:28:00.000000', 'consum', 0.0228, 'lps'),
	(558499, 128, '2014-03-01 00:28:01.000000', 'consum', 0.0226, 'lps'),
	(558500, 128, '2014-03-01 00:28:02.000000', 'consum', 0.0212, 'lps'),
	(558501, 128, '2014-03-01 00:28:03.000000', 'consum', 0.0221, 'lps'),
	(558502, 128, '2014-03-01 00:28:04.000000', 'consum', 0.0233, 'lps'),
	(558503, 128, '2014-03-01 00:28:05.000000', 'consum', 0.0220, 'lps'),
	(558504, 128, '2014-03-01 00:28:06.000000', 'consum', 0.0214, 'lps'),
	(558505, 128, '2014-03-01 00:28:07.000000', 'consum', 0.0227, 'lps'),
	(558506, 128, '2014-03-01 00:28:08.000000', 'consum', 0.0210, 'lps'),
	(558507, 128, '2014-03-01 00:28:09.000000', 'consum', 0.0232, 'lps'),
	(558508, 128, '2014-03-01 00:28:10.000000', 'consum', 0.0222, 'lps'),
	(558509, 128, '2014-03-01 00:28:11.000000', 'consum', 0.0230, 'lps'),
	(558510, 128, '2014-03-01 00:28:12.000000', 'consum', 0.0223, 'lps'),
	(558511, 128, '2014-03-01 00:28:13.000000', 'consum', 0.0217, 'lps'),
	(558512, 128, '2014-03-01 00:28:14.000000', 'consum', 0.0232, 'lps'),
	(558513, 128, '2014-03-01 00:28:15.000000', 'consum', 0.0224, 'lps'),
	(558514, 128, '2014-03-01 00:28:16.000000', 'consum', 0.0214, 'lps'),
	(558515, 128, '2014-03-01 00:28:17.000000', 'consum', 0.0213, 'lps'),
	(558516, 128, '2014-03-01 00:28:18.000000', 'consum', 0.0213, 'lps'),
	(558517, 128, '2014-03-01 00:28:19.000000', 'consum', 0.0216, 'lps'),
	(558518, 128, '2014-03-01 00:28:20.000000', 'consum', 0.0231, 'lps'),
	(558519, 128, '2014-03-01 00:28:21.000000', 'consum', 0.0225, 'lps'),
	(558520, 128, '2014-03-01 00:28:22.000000', 'consum', 0.0223, 'lps'),
	(558521, 128, '2014-03-01 00:28:23.000000', 'consum', 0.0227, 'lps'),
	(558522, 128, '2014-03-01 00:28:24.000000', 'consum', 0.0234, 'lps'),
	(558523, 128, '2014-03-01 00:28:25.000000', 'consum', 0.0230, 'lps'),
	(558524, 128, '2014-03-01 00:28:26.000000', 'consum', 0.0214, 'lps'),
	(558525, 128, '2014-03-01 00:28:27.000000', 'consum', 0.0222, 'lps'),
	(558526, 128, '2014-03-01 00:28:28.000000', 'consum', 0.0230, 'lps'),
	(558527, 128, '2014-03-01 00:28:29.000000', 'consum', 0.0227, 'lps'),
	(558528, 128, '2014-03-01 00:28:30.000000', 'consum', 0.0233, 'lps'),
	(558529, 128, '2014-03-01 00:28:31.000000', 'consum', 0.0225, 'lps'),
	(558530, 128, '2014-03-01 00:28:32.000000', 'consum', 0.0217, 'lps'),
	(558531, 128, '2014-03-01 00:28:33.000000', 'consum', 0.0224, 'lps'),
	(558532, 128, '2014-03-01 00:28:34.000000', 'consum', 0.0234, 'lps'),
	(558533, 128, '2014-03-01 00:28:35.000000', 'consum', 0.0216, 'lps'),
	(558534, 128, '2014-03-01 00:28:36.000000', 'consum', 0.0216, 'lps'),
	(558535, 128, '2014-03-01 00:28:37.000000', 'consum', 0.0225, 'lps'),
	(558536, 128, '2014-03-01 00:28:38.000000', 'consum', 0.0215, 'lps'),
	(558537, 128, '2014-03-01 00:28:39.000000', 'consum', 0.0215, 'lps'),
	(558538, 128, '2014-03-01 00:28:40.000000', 'consum', 0.0220, 'lps'),
	(558539, 128, '2014-03-01 00:28:41.000000', 'consum', 0.0221, 'lps'),
	(558540, 128, '2014-03-01 00:28:42.000000', 'consum', 0.0212, 'lps'),
	(558541, 128, '2014-03-01 00:28:43.000000', 'consum', 0.0211, 'lps'),
	(558542, 128, '2014-03-01 00:28:44.000000', 'consum', 0.0212, 'lps'),
	(558543, 128, '2014-03-01 00:28:45.000000', 'consum', 0.0215, 'lps'),
	(558544, 128, '2014-03-01 00:28:46.000000', 'consum', 0.0232, 'lps'),
	(558545, 128, '2014-03-01 00:28:47.000000', 'consum', 0.0230, 'lps'),
	(558546, 128, '2014-03-01 00:28:48.000000', 'consum', 0.0220, 'lps'),
	(558547, 128, '2014-03-01 00:28:49.000000', 'consum', 0.0227, 'lps'),
	(558548, 128, '2014-03-01 00:28:50.000000', 'consum', 0.0213, 'lps'),
	(558549, 128, '2014-03-01 00:28:51.000000', 'consum', 0.0224, 'lps'),
	(558550, 128, '2014-03-01 00:28:52.000000', 'consum', 0.0222, 'lps'),
	(558551, 128, '2014-03-01 00:28:53.000000', 'consum', 0.0227, 'lps'),
	(558552, 128, '2014-03-01 00:28:54.000000', 'consum', 0.0212, 'lps'),
	(558553, 128, '2014-03-01 00:28:55.000000', 'consum', 0.0219, 'lps'),
	(558554, 128, '2014-03-01 00:28:56.000000', 'consum', 0.0224, 'lps'),
	(558555, 128, '2014-03-01 00:28:57.000000', 'consum', 0.0228, 'lps'),
	(558556, 128, '2014-03-01 00:28:58.000000', 'consum', 0.0234, 'lps'),
	(558557, 128, '2014-03-01 00:28:59.000000', 'consum', 0.0225, 'lps'),
	(558558, 128, '2014-03-01 00:29:00.000000', 'consum', 0.0214, 'lps'),
	(558559, 128, '2014-03-01 00:29:01.000000', 'consum', 0.0234, 'lps'),
	(558560, 128, '2014-03-01 00:29:02.000000', 'consum', 0.0221, 'lps'),
	(558561, 128, '2014-03-01 00:29:03.000000', 'consum', 0.0218, 'lps'),
	(558562, 128, '2014-03-01 00:29:04.000000', 'consum', 0.0219, 'lps'),
	(558563, 128, '2014-03-01 00:29:05.000000', 'consum', 0.0231, 'lps'),
	(558564, 128, '2014-03-01 00:29:06.000000', 'consum', 0.0211, 'lps'),
	(558565, 128, '2014-03-01 00:29:07.000000', 'consum', 0.0229, 'lps'),
	(558566, 128, '2014-03-01 00:29:08.000000', 'consum', 0.0228, 'lps'),
	(558567, 128, '2014-03-01 00:29:09.000000', 'consum', 0.0220, 'lps'),
	(558568, 128, '2014-03-01 00:29:10.000000', 'consum', 0.0230, 'lps'),
	(558569, 128, '2014-03-01 00:29:11.000000', 'consum', 0.0232, 'lps'),
	(558570, 128, '2014-03-01 00:29:12.000000', 'consum', 0.0211, 'lps'),
	(558571, 128, '2014-03-01 00:29:13.000000', 'consum', 0.0222, 'lps'),
	(558572, 128, '2014-03-01 00:29:14.000000', 'consum', 0.0218, 'lps'),
	(558573, 128, '2014-03-01 00:29:15.000000', 'consum', 0.0216, 'lps'),
	(558574, 128, '2014-03-01 00:29:16.000000', 'consum', 0.0215, 'lps'),
	(558575, 128, '2014-03-01 00:29:17.000000', 'consum', 0.0219, 'lps'),
	(558576, 128, '2014-03-01 00:29:18.000000', 'consum', 0.0217, 'lps'),
	(558577, 128, '2014-03-01 00:29:19.000000', 'consum', 0.0215, 'lps'),
	(558578, 128, '2014-03-01 00:29:20.000000', 'consum', 0.0217, 'lps'),
	(558579, 128, '2014-03-01 00:29:21.000000', 'consum', 0.0228, 'lps'),
	(558580, 128, '2014-03-01 00:29:22.000000', 'consum', 0.0229, 'lps'),
	(558581, 128, '2014-03-01 00:29:23.000000', 'consum', 0.0228, 'lps'),
	(558582, 128, '2014-03-01 00:29:24.000000', 'consum', 0.0217, 'lps'),
	(558583, 128, '2014-03-01 00:29:25.000000', 'consum', 0.0218, 'lps'),
	(558584, 128, '2014-03-01 00:29:26.000000', 'consum', 0.0228, 'lps'),
	(558585, 128, '2014-03-01 00:29:27.000000', 'consum', 0.0229, 'lps'),
	(558586, 128, '2014-03-01 00:29:28.000000', 'consum', 0.0223, 'lps'),
	(558587, 128, '2014-03-01 00:29:29.000000', 'consum', 0.0222, 'lps'),
	(558588, 128, '2014-03-01 00:29:30.000000', 'consum', 0.0231, 'lps'),
	(558589, 128, '2014-03-01 00:29:31.000000', 'consum', 0.0228, 'lps'),
	(558590, 128, '2014-03-01 00:29:32.000000', 'consum', 0.0213, 'lps'),
	(558591, 128, '2014-03-01 00:29:33.000000', 'consum', 0.0223, 'lps'),
	(558592, 128, '2014-03-01 00:29:34.000000', 'consum', 0.0217, 'lps'),
	(558593, 128, '2014-03-01 00:29:35.000000', 'consum', 0.0232, 'lps'),
	(558594, 128, '2014-03-01 00:29:36.000000', 'consum', 0.0223, 'lps'),
	(558595, 128, '2014-03-01 00:29:37.000000', 'consum', 0.0210, 'lps'),
	(558596, 128, '2014-03-01 00:29:38.000000', 'consum', 0.0221, 'lps'),
	(558597, 128, '2014-03-01 00:29:39.000000', 'consum', 0.0217, 'lps'),
	(558598, 128, '2014-03-01 00:29:40.000000', 'consum', 0.0212, 'lps'),
	(558599, 128, '2014-03-01 00:29:41.000000', 'consum', 0.0225, 'lps'),
	(558600, 128, '2014-03-01 00:29:42.000000', 'consum', 0.0228, 'lps'),
	(558601, 128, '2014-03-01 00:29:43.000000', 'consum', 0.0230, 'lps'),
	(558602, 128, '2014-03-01 00:29:44.000000', 'consum', 0.0234, 'lps'),
	(558603, 128, '2014-03-01 00:29:45.000000', 'consum', 0.0221, 'lps'),
	(558604, 128, '2014-03-01 00:29:46.000000', 'consum', 0.0216, 'lps'),
	(558605, 128, '2014-03-01 00:29:47.000000', 'consum', 0.0234, 'lps'),
	(558606, 128, '2014-03-01 00:29:48.000000', 'consum', 0.0214, 'lps'),
	(558607, 128, '2014-03-01 00:29:49.000000', 'consum', 0.0230, 'lps'),
	(558608, 128, '2014-03-01 00:29:50.000000', 'consum', 0.0227, 'lps'),
	(558609, 128, '2014-03-01 00:29:51.000000', 'consum', 0.0234, 'lps'),
	(558610, 128, '2014-03-01 00:29:52.000000', 'consum', 0.0231, 'lps'),
	(558611, 128, '2014-03-01 00:29:53.000000', 'consum', 0.0219, 'lps'),
	(558612, 128, '2014-03-01 00:29:54.000000', 'consum', 0.0215, 'lps'),
	(558613, 128, '2014-03-01 00:29:55.000000', 'consum', 0.0211, 'lps'),
	(558614, 128, '2014-03-01 00:29:56.000000', 'consum', 0.0225, 'lps'),
	(558615, 128, '2014-03-01 00:29:57.000000', 'consum', 0.0232, 'lps'),
	(558616, 128, '2014-03-01 00:29:58.000000', 'consum', 0.0225, 'lps'),
	(558617, 128, '2014-03-01 00:29:59.000000', 'consum', 0.0221, 'lps'),
	(558618, 128, '2014-03-01 00:30:00.000000', 'consum', 0.0219, 'lps'),
	(558619, 128, '2014-03-01 00:30:01.000000', 'consum', 0.0223, 'lps'),
	(558620, 128, '2014-03-01 00:30:02.000000', 'consum', 0.0224, 'lps'),
	(558621, 128, '2014-03-01 00:30:03.000000', 'consum', 0.0217, 'lps'),
	(558622, 128, '2014-03-01 00:30:04.000000', 'consum', 0.0227, 'lps'),
	(558623, 128, '2014-03-01 00:30:05.000000', 'consum', 0.0225, 'lps'),
	(558624, 128, '2014-03-01 00:30:06.000000', 'consum', 0.0210, 'lps'),
	(558625, 128, '2014-03-01 00:30:07.000000', 'consum', 0.0215, 'lps'),
	(558626, 128, '2014-03-01 00:30:08.000000', 'consum', 0.0234, 'lps'),
	(558627, 128, '2014-03-01 00:30:09.000000', 'consum', 0.0215, 'lps'),
	(558628, 128, '2014-03-01 00:30:10.000000', 'consum', 0.0216, 'lps'),
	(558629, 128, '2014-03-01 00:30:11.000000', 'consum', 0.0224, 'lps'),
	(558630, 128, '2014-03-01 00:30:12.000000', 'consum', 0.0213, 'lps'),
	(558631, 128, '2014-03-01 00:30:13.000000', 'consum', 0.0234, 'lps'),
	(558632, 128, '2014-03-01 00:30:14.000000', 'consum', 0.0219, 'lps'),
	(558633, 128, '2014-03-01 00:30:15.000000', 'consum', 0.0212, 'lps'),
	(558634, 128, '2014-03-01 00:30:16.000000', 'consum', 0.0215, 'lps'),
	(558635, 128, '2014-03-01 00:30:17.000000', 'consum', 0.0232, 'lps'),
	(558636, 128, '2014-03-01 00:30:18.000000', 'consum', 0.0228, 'lps'),
	(558637, 128, '2014-03-01 00:30:19.000000', 'consum', 0.0211, 'lps'),
	(558638, 128, '2014-03-01 00:30:20.000000', 'consum', 0.0212, 'lps'),
	(558639, 128, '2014-03-01 00:30:21.000000', 'consum', 0.0215, 'lps'),
	(558640, 128, '2014-03-01 00:30:22.000000', 'consum', 0.0231, 'lps'),
	(558641, 128, '2014-03-01 00:30:23.000000', 'consum', 0.0224, 'lps'),
	(558642, 128, '2014-03-01 00:30:24.000000', 'consum', 0.0217, 'lps'),
	(558643, 128, '2014-03-01 00:30:25.000000', 'consum', 0.0228, 'lps'),
	(558644, 128, '2014-03-01 00:30:26.000000', 'consum', 0.0230, 'lps'),
	(558645, 128, '2014-03-01 00:30:27.000000', 'consum', 0.0231, 'lps'),
	(558646, 128, '2014-03-01 00:30:28.000000', 'consum', 0.0232, 'lps'),
	(558647, 128, '2014-03-01 00:30:29.000000', 'consum', 0.0230, 'lps'),
	(558648, 128, '2014-03-01 00:30:30.000000', 'consum', 0.0221, 'lps'),
	(558649, 128, '2014-03-01 00:30:31.000000', 'consum', 0.0229, 'lps'),
	(558650, 128, '2014-03-01 00:30:32.000000', 'consum', 0.0224, 'lps'),
	(558651, 128, '2014-03-01 00:30:33.000000', 'consum', 0.0225, 'lps'),
	(558652, 128, '2014-03-01 00:30:34.000000', 'consum', 0.0216, 'lps'),
	(558653, 128, '2014-03-01 00:30:35.000000', 'consum', 0.0221, 'lps'),
	(558654, 128, '2014-03-01 00:30:36.000000', 'consum', 0.0221, 'lps'),
	(558655, 128, '2014-03-01 00:30:37.000000', 'consum', 0.0233, 'lps'),
	(558656, 128, '2014-03-01 00:30:38.000000', 'consum', 0.0218, 'lps'),
	(558657, 128, '2014-03-01 00:30:39.000000', 'consum', 0.0230, 'lps'),
	(558658, 128, '2014-03-01 00:30:40.000000', 'consum', 0.0211, 'lps'),
	(558659, 128, '2014-03-01 00:30:41.000000', 'consum', 0.0232, 'lps'),
	(558660, 128, '2014-03-01 00:30:42.000000', 'consum', 0.0218, 'lps'),
	(558661, 128, '2014-03-01 00:30:43.000000', 'consum', 0.0232, 'lps'),
	(558662, 128, '2014-03-01 00:30:44.000000', 'consum', 0.0225, 'lps'),
	(558663, 128, '2014-03-01 00:30:45.000000', 'consum', 0.0217, 'lps'),
	(558664, 128, '2014-03-01 00:30:46.000000', 'consum', 0.0225, 'lps'),
	(558665, 128, '2014-03-01 00:30:47.000000', 'consum', 0.0214, 'lps'),
	(558666, 128, '2014-03-01 00:30:48.000000', 'consum', 0.0210, 'lps'),
	(558667, 128, '2014-03-01 00:30:49.000000', 'consum', 0.0226, 'lps'),
	(558668, 128, '2014-03-01 00:30:50.000000', 'consum', 0.0213, 'lps'),
	(558669, 128, '2014-03-01 00:30:51.000000', 'consum', 0.0228, 'lps'),
	(558670, 128, '2014-03-01 00:30:52.000000', 'consum', 0.0216, 'lps'),
	(558671, 128, '2014-03-01 00:30:53.000000', 'consum', 0.0211, 'lps'),
	(558672, 128, '2014-03-01 00:30:54.000000', 'consum', 0.0221, 'lps'),
	(558673, 128, '2014-03-01 00:30:55.000000', 'consum', 0.0216, 'lps'),
	(558674, 128, '2014-03-01 00:30:56.000000', 'consum', 0.0229, 'lps'),
	(558675, 128, '2014-03-01 00:30:57.000000', 'consum', 0.0215, 'lps'),
	(558676, 128, '2014-03-01 00:30:58.000000', 'consum', 0.0228, 'lps'),
	(558677, 128, '2014-03-01 00:30:59.000000', 'consum', 0.0234, 'lps'),
	(558678, 128, '2014-03-01 00:31:00.000000', 'consum', 0.0228, 'lps'),
	(558679, 128, '2014-03-01 00:31:01.000000', 'consum', 0.0227, 'lps'),
	(558680, 128, '2014-03-01 00:31:02.000000', 'consum', 0.0219, 'lps'),
	(558681, 128, '2014-03-01 00:31:03.000000', 'consum', 0.0228, 'lps'),
	(558682, 128, '2014-03-01 00:31:04.000000', 'consum', 0.0223, 'lps'),
	(558683, 128, '2014-03-01 00:31:05.000000', 'consum', 0.0221, 'lps'),
	(558684, 128, '2014-03-01 00:31:06.000000', 'consum', 0.0228, 'lps'),
	(558685, 128, '2014-03-01 00:31:07.000000', 'consum', 0.0219, 'lps'),
	(558686, 128, '2014-03-01 00:31:08.000000', 'consum', 0.0224, 'lps'),
	(558687, 128, '2014-03-01 00:31:09.000000', 'consum', 0.0228, 'lps'),
	(558688, 128, '2014-03-01 00:31:10.000000', 'consum', 0.0233, 'lps'),
	(558689, 128, '2014-03-01 00:31:11.000000', 'consum', 0.0224, 'lps'),
	(558690, 128, '2014-03-01 00:31:12.000000', 'consum', 0.0210, 'lps'),
	(558691, 128, '2014-03-01 00:31:13.000000', 'consum', 0.0218, 'lps'),
	(558692, 128, '2014-03-01 00:31:14.000000', 'consum', 0.0228, 'lps'),
	(558693, 128, '2014-03-01 00:31:15.000000', 'consum', 0.0223, 'lps'),
	(558694, 128, '2014-03-01 00:31:16.000000', 'consum', 0.0223, 'lps'),
	(558695, 128, '2014-03-01 00:31:17.000000', 'consum', 0.0212, 'lps'),
	(558696, 128, '2014-03-01 00:31:18.000000', 'consum', 0.0231, 'lps'),
	(558697, 128, '2014-03-01 00:31:19.000000', 'consum', 0.0233, 'lps'),
	(558698, 128, '2014-03-01 00:31:20.000000', 'consum', 0.0214, 'lps'),
	(558699, 128, '2014-03-01 00:31:21.000000', 'consum', 0.0211, 'lps'),
	(558700, 128, '2014-03-01 00:31:22.000000', 'consum', 0.0228, 'lps'),
	(558701, 128, '2014-03-01 00:31:23.000000', 'consum', 0.0224, 'lps'),
	(558702, 128, '2014-03-01 00:31:24.000000', 'consum', 0.0226, 'lps'),
	(558703, 128, '2014-03-01 00:31:25.000000', 'consum', 0.0223, 'lps'),
	(558704, 128, '2014-03-01 00:31:26.000000', 'consum', 0.0227, 'lps'),
	(558705, 128, '2014-03-01 00:31:27.000000', 'consum', 0.0230, 'lps'),
	(558706, 128, '2014-03-01 00:31:28.000000', 'consum', 0.0212, 'lps'),
	(558707, 128, '2014-03-01 00:31:29.000000', 'consum', 0.0233, 'lps'),
	(558708, 128, '2014-03-01 00:31:30.000000', 'consum', 0.0219, 'lps'),
	(558709, 128, '2014-03-01 00:31:31.000000', 'consum', 0.0214, 'lps'),
	(558710, 128, '2014-03-01 00:31:32.000000', 'consum', 0.0227, 'lps'),
	(558711, 128, '2014-03-01 00:31:33.000000', 'consum', 0.0210, 'lps'),
	(558712, 128, '2014-03-01 00:31:34.000000', 'consum', 0.0234, 'lps'),
	(558713, 128, '2014-03-01 00:31:35.000000', 'consum', 0.0229, 'lps'),
	(558714, 128, '2014-03-01 00:31:36.000000', 'consum', 0.0234, 'lps'),
	(558715, 128, '2014-03-01 00:31:37.000000', 'consum', 0.0223, 'lps'),
	(558716, 128, '2014-03-01 00:31:38.000000', 'consum', 0.0228, 'lps'),
	(558717, 128, '2014-03-01 00:31:39.000000', 'consum', 0.0210, 'lps'),
	(558718, 128, '2014-03-01 00:31:40.000000', 'consum', 0.0210, 'lps'),
	(558719, 128, '2014-03-01 00:31:41.000000', 'consum', 0.0233, 'lps'),
	(558720, 128, '2014-03-01 00:31:42.000000', 'consum', 0.0228, 'lps'),
	(558721, 128, '2014-03-01 00:31:43.000000', 'consum', 0.0231, 'lps'),
	(558722, 128, '2014-03-01 00:31:44.000000', 'consum', 0.0213, 'lps'),
	(558723, 128, '2014-03-01 00:31:45.000000', 'consum', 0.0211, 'lps'),
	(558724, 128, '2014-03-01 00:31:46.000000', 'consum', 0.0233, 'lps'),
	(558725, 128, '2014-03-01 00:31:47.000000', 'consum', 0.0220, 'lps'),
	(558726, 128, '2014-03-01 00:31:48.000000', 'consum', 0.0219, 'lps'),
	(558727, 128, '2014-03-01 00:31:49.000000', 'consum', 0.0224, 'lps'),
	(558728, 128, '2014-03-01 00:31:50.000000', 'consum', 0.0229, 'lps'),
	(558729, 128, '2014-03-01 00:31:51.000000', 'consum', 0.0213, 'lps'),
	(558730, 128, '2014-03-01 00:31:52.000000', 'consum', 0.0221, 'lps'),
	(558731, 128, '2014-03-01 00:31:53.000000', 'consum', 0.0228, 'lps'),
	(558732, 128, '2014-03-01 00:31:54.000000', 'consum', 0.0219, 'lps'),
	(558733, 128, '2014-03-01 00:31:55.000000', 'consum', 0.0228, 'lps'),
	(558734, 128, '2014-03-01 00:31:56.000000', 'consum', 0.0221, 'lps'),
	(558735, 128, '2014-03-01 00:31:57.000000', 'consum', 0.0214, 'lps'),
	(558736, 128, '2014-03-01 00:31:58.000000', 'consum', 0.0222, 'lps'),
	(558737, 128, '2014-03-01 00:31:59.000000', 'consum', 0.0234, 'lps'),
	(558738, 128, '2014-03-01 00:32:00.000000', 'consum', 0.0218, 'lps'),
	(558739, 128, '2014-03-01 00:32:01.000000', 'consum', 0.0230, 'lps'),
	(558740, 128, '2014-03-01 00:32:02.000000', 'consum', 0.0212, 'lps'),
	(558741, 128, '2014-03-01 00:32:03.000000', 'consum', 0.0234, 'lps'),
	(558742, 128, '2014-03-01 00:32:04.000000', 'consum', 0.0226, 'lps'),
	(558743, 128, '2014-03-01 00:32:05.000000', 'consum', 0.0220, 'lps'),
	(558744, 128, '2014-03-01 00:32:06.000000', 'consum', 0.0210, 'lps'),
	(558745, 128, '2014-03-01 00:32:07.000000', 'consum', 0.0232, 'lps'),
	(558746, 128, '2014-03-01 00:32:08.000000', 'consum', 0.0220, 'lps'),
	(558747, 128, '2014-03-01 00:32:09.000000', 'consum', 0.0218, 'lps'),
	(558748, 128, '2014-03-01 00:32:10.000000', 'consum', 0.0220, 'lps'),
	(558749, 128, '2014-03-01 00:32:11.000000', 'consum', 0.0211, 'lps'),
	(558750, 128, '2014-03-01 00:32:12.000000', 'consum', 0.0211, 'lps'),
	(558751, 128, '2014-03-01 00:32:13.000000', 'consum', 0.0215, 'lps'),
	(558752, 128, '2014-03-01 00:32:14.000000', 'consum', 0.0229, 'lps'),
	(558753, 128, '2014-03-01 00:32:15.000000', 'consum', 0.0217, 'lps'),
	(558754, 128, '2014-03-01 00:32:16.000000', 'consum', 0.0213, 'lps'),
	(558755, 128, '2014-03-01 00:32:17.000000', 'consum', 0.0228, 'lps'),
	(558756, 128, '2014-03-01 00:32:18.000000', 'consum', 0.0218, 'lps'),
	(558757, 128, '2014-03-01 00:32:19.000000', 'consum', 0.0220, 'lps'),
	(558758, 128, '2014-03-01 00:32:20.000000', 'consum', 0.0213, 'lps'),
	(558759, 128, '2014-03-01 00:32:21.000000', 'consum', 0.0221, 'lps'),
	(558760, 128, '2014-03-01 00:32:22.000000', 'consum', 0.0230, 'lps'),
	(558761, 128, '2014-03-01 00:32:23.000000', 'consum', 0.0229, 'lps'),
	(558762, 128, '2014-03-01 00:32:24.000000', 'consum', 0.0218, 'lps'),
	(558763, 128, '2014-03-01 00:32:25.000000', 'consum', 0.0221, 'lps'),
	(558764, 128, '2014-03-01 00:32:26.000000', 'consum', 0.0217, 'lps'),
	(558765, 128, '2014-03-01 00:32:27.000000', 'consum', 0.0213, 'lps'),
	(558766, 128, '2014-03-01 00:32:28.000000', 'consum', 0.0230, 'lps'),
	(558767, 128, '2014-03-01 00:32:29.000000', 'consum', 0.0226, 'lps'),
	(558768, 128, '2014-03-01 00:32:30.000000', 'consum', 0.0229, 'lps'),
	(558769, 128, '2014-03-01 00:32:31.000000', 'consum', 0.0232, 'lps'),
	(558770, 128, '2014-03-01 00:32:32.000000', 'consum', 0.0215, 'lps'),
	(558771, 128, '2014-03-01 00:32:33.000000', 'consum', 0.0218, 'lps'),
	(558772, 128, '2014-03-01 00:32:34.000000', 'consum', 0.0211, 'lps'),
	(558773, 128, '2014-03-01 00:32:35.000000', 'consum', 0.0216, 'lps'),
	(558774, 128, '2014-03-01 00:32:36.000000', 'consum', 0.0213, 'lps'),
	(558775, 128, '2014-03-01 00:32:37.000000', 'consum', 0.0230, 'lps'),
	(558776, 128, '2014-03-01 00:32:38.000000', 'consum', 0.0230, 'lps'),
	(558777, 128, '2014-03-01 00:32:39.000000', 'consum', 0.0226, 'lps'),
	(558778, 128, '2014-03-01 00:32:40.000000', 'consum', 0.0228, 'lps'),
	(558779, 128, '2014-03-01 00:32:41.000000', 'consum', 0.0227, 'lps'),
	(558780, 128, '2014-03-01 00:32:42.000000', 'consum', 0.0218, 'lps'),
	(558781, 128, '2014-03-01 00:32:43.000000', 'consum', 0.0225, 'lps'),
	(558782, 128, '2014-03-01 00:32:44.000000', 'consum', 0.0213, 'lps'),
	(558783, 128, '2014-03-01 00:32:45.000000', 'consum', 0.0227, 'lps'),
	(558784, 128, '2014-03-01 00:32:46.000000', 'consum', 0.0214, 'lps'),
	(558785, 128, '2014-03-01 00:32:47.000000', 'consum', 0.0227, 'lps'),
	(558786, 128, '2014-03-01 00:32:48.000000', 'consum', 0.0210, 'lps'),
	(558787, 128, '2014-03-01 00:32:49.000000', 'consum', 0.0211, 'lps'),
	(558788, 128, '2014-03-01 00:32:50.000000', 'consum', 0.0214, 'lps'),
	(558789, 128, '2014-03-01 00:32:51.000000', 'consum', 0.0229, 'lps'),
	(558790, 128, '2014-03-01 00:32:52.000000', 'consum', 0.0219, 'lps'),
	(558791, 128, '2014-03-01 00:32:53.000000', 'consum', 0.0223, 'lps'),
	(558792, 128, '2014-03-01 00:32:54.000000', 'consum', 0.0224, 'lps'),
	(558793, 128, '2014-03-01 00:32:55.000000', 'consum', 0.0214, 'lps'),
	(558794, 128, '2014-03-01 00:32:56.000000', 'consum', 0.0214, 'lps'),
	(558795, 128, '2014-03-01 00:32:57.000000', 'consum', 0.0220, 'lps'),
	(558796, 128, '2014-03-01 00:32:58.000000', 'consum', 0.0222, 'lps'),
	(558797, 128, '2014-03-01 00:32:59.000000', 'consum', 0.0216, 'lps'),
	(558798, 128, '2014-03-01 00:33:00.000000', 'consum', 0.0228, 'lps'),
	(558799, 128, '2014-03-01 00:33:01.000000', 'consum', 0.0210, 'lps'),
	(558800, 128, '2014-03-01 00:33:02.000000', 'consum', 0.0229, 'lps'),
	(558801, 128, '2014-03-01 00:33:03.000000', 'consum', 0.0233, 'lps'),
	(558802, 128, '2014-03-01 00:33:04.000000', 'consum', 0.0218, 'lps'),
	(558803, 128, '2014-03-01 00:33:05.000000', 'consum', 0.0232, 'lps'),
	(558804, 128, '2014-03-01 00:33:06.000000', 'consum', 0.0221, 'lps'),
	(558805, 128, '2014-03-01 00:33:07.000000', 'consum', 0.0226, 'lps'),
	(558806, 128, '2014-03-01 00:33:08.000000', 'consum', 0.0232, 'lps'),
	(558807, 128, '2014-03-01 00:33:09.000000', 'consum', 0.0224, 'lps'),
	(558808, 128, '2014-03-01 00:33:10.000000', 'consum', 0.0212, 'lps'),
	(558809, 128, '2014-03-01 00:33:11.000000', 'consum', 0.0228, 'lps'),
	(558810, 128, '2014-03-01 00:33:12.000000', 'consum', 0.0221, 'lps'),
	(558811, 128, '2014-03-01 00:33:13.000000', 'consum', 0.0212, 'lps'),
	(558812, 128, '2014-03-01 00:33:14.000000', 'consum', 0.0214, 'lps'),
	(558813, 128, '2014-03-01 00:33:15.000000', 'consum', 0.0221, 'lps'),
	(558814, 128, '2014-03-01 00:33:16.000000', 'consum', 0.0232, 'lps'),
	(558815, 128, '2014-03-01 00:33:17.000000', 'consum', 0.0211, 'lps'),
	(558816, 128, '2014-03-01 00:33:18.000000', 'consum', 0.0223, 'lps'),
	(558817, 128, '2014-03-01 00:33:19.000000', 'consum', 0.0225, 'lps'),
	(558818, 128, '2014-03-01 00:33:20.000000', 'consum', 0.0221, 'lps'),
	(558819, 128, '2014-03-01 00:33:21.000000', 'consum', 0.0220, 'lps'),
	(558820, 128, '2014-03-01 00:33:22.000000', 'consum', 0.0227, 'lps'),
	(558821, 128, '2014-03-01 00:33:23.000000', 'consum', 0.0215, 'lps'),
	(558822, 128, '2014-03-01 00:33:24.000000', 'consum', 0.0212, 'lps'),
	(558823, 128, '2014-03-01 00:33:25.000000', 'consum', 0.0230, 'lps'),
	(558824, 128, '2014-03-01 00:33:26.000000', 'consum', 0.0229, 'lps'),
	(558825, 128, '2014-03-01 00:33:27.000000', 'consum', 0.0219, 'lps'),
	(558826, 128, '2014-03-01 00:33:28.000000', 'consum', 0.0225, 'lps'),
	(558827, 128, '2014-03-01 00:33:29.000000', 'consum', 0.0231, 'lps'),
	(558828, 128, '2014-03-01 00:33:30.000000', 'consum', 0.0223, 'lps'),
	(558829, 128, '2014-03-01 00:33:31.000000', 'consum', 0.0211, 'lps'),
	(558830, 128, '2014-03-01 00:33:32.000000', 'consum', 0.0229, 'lps'),
	(558831, 128, '2014-03-01 00:33:33.000000', 'consum', 0.0225, 'lps'),
	(558832, 128, '2014-03-01 00:33:34.000000', 'consum', 0.0229, 'lps'),
	(558833, 128, '2014-03-01 00:33:35.000000', 'consum', 0.0211, 'lps'),
	(558834, 128, '2014-03-01 00:33:36.000000', 'consum', 0.0232, 'lps'),
	(558835, 128, '2014-03-01 00:33:37.000000', 'consum', 0.0219, 'lps'),
	(558836, 128, '2014-03-01 00:33:38.000000', 'consum', 0.0214, 'lps'),
	(558837, 128, '2014-03-01 00:33:39.000000', 'consum', 0.0228, 'lps'),
	(558838, 128, '2014-03-01 00:33:40.000000', 'consum', 0.0215, 'lps'),
	(558839, 128, '2014-03-01 00:33:41.000000', 'consum', 0.0233, 'lps'),
	(558840, 128, '2014-03-01 00:33:42.000000', 'consum', 0.0232, 'lps'),
	(558841, 128, '2014-03-01 00:33:43.000000', 'consum', 0.0227, 'lps'),
	(558842, 128, '2014-03-01 00:33:44.000000', 'consum', 0.0231, 'lps'),
	(558843, 128, '2014-03-01 00:33:45.000000', 'consum', 0.0215, 'lps'),
	(558844, 128, '2014-03-01 00:33:46.000000', 'consum', 0.0221, 'lps'),
	(558845, 128, '2014-03-01 00:33:47.000000', 'consum', 0.0224, 'lps'),
	(558846, 128, '2014-03-01 00:33:48.000000', 'consum', 0.0224, 'lps'),
	(558847, 128, '2014-03-01 00:33:49.000000', 'consum', 0.0213, 'lps'),
	(558848, 128, '2014-03-01 00:33:50.000000', 'consum', 0.0232, 'lps'),
	(558849, 128, '2014-03-01 00:33:51.000000', 'consum', 0.0212, 'lps'),
	(558850, 128, '2014-03-01 00:33:52.000000', 'consum', 0.0229, 'lps'),
	(558851, 128, '2014-03-01 00:33:53.000000', 'consum', 0.0225, 'lps'),
	(558852, 128, '2014-03-01 00:33:54.000000', 'consum', 0.0228, 'lps'),
	(558853, 128, '2014-03-01 00:33:55.000000', 'consum', 0.0230, 'lps'),
	(558854, 128, '2014-03-01 00:33:56.000000', 'consum', 0.0232, 'lps'),
	(558855, 128, '2014-03-01 00:33:57.000000', 'consum', 0.0212, 'lps'),
	(558856, 128, '2014-03-01 00:33:58.000000', 'consum', 0.0230, 'lps'),
	(558857, 128, '2014-03-01 00:33:59.000000', 'consum', 0.0230, 'lps'),
	(558858, 128, '2014-03-01 00:34:00.000000', 'consum', 0.0225, 'lps'),
	(558859, 128, '2014-03-01 00:34:01.000000', 'consum', 0.0224, 'lps'),
	(558860, 128, '2014-03-01 00:34:02.000000', 'consum', 0.0212, 'lps'),
	(558861, 128, '2014-03-01 00:34:03.000000', 'consum', 0.0229, 'lps'),
	(558862, 128, '2014-03-01 00:34:04.000000', 'consum', 0.0224, 'lps'),
	(558863, 128, '2014-03-01 00:34:05.000000', 'consum', 0.0222, 'lps'),
	(558864, 128, '2014-03-01 00:34:06.000000', 'consum', 0.0231, 'lps'),
	(558865, 128, '2014-03-01 00:34:07.000000', 'consum', 0.0227, 'lps'),
	(558866, 128, '2014-03-01 00:34:08.000000', 'consum', 0.0234, 'lps'),
	(558867, 128, '2014-03-01 00:34:09.000000', 'consum', 0.0229, 'lps'),
	(558868, 128, '2014-03-01 00:34:10.000000', 'consum', 0.0232, 'lps'),
	(558869, 128, '2014-03-01 00:34:11.000000', 'consum', 0.0213, 'lps'),
	(558870, 128, '2014-03-01 00:34:12.000000', 'consum', 0.0211, 'lps'),
	(558871, 128, '2014-03-01 00:34:13.000000', 'consum', 0.0231, 'lps'),
	(558872, 128, '2014-03-01 00:34:14.000000', 'consum', 0.0215, 'lps'),
	(558873, 128, '2014-03-01 00:34:15.000000', 'consum', 0.0219, 'lps'),
	(558874, 128, '2014-03-01 00:34:16.000000', 'consum', 0.0218, 'lps'),
	(558875, 128, '2014-03-01 00:34:17.000000', 'consum', 0.0224, 'lps'),
	(558876, 128, '2014-03-01 00:34:18.000000', 'consum', 0.0232, 'lps'),
	(558877, 128, '2014-03-01 00:34:19.000000', 'consum', 0.0226, 'lps'),
	(558878, 128, '2014-03-01 00:34:20.000000', 'consum', 0.0226, 'lps'),
	(558879, 128, '2014-03-01 00:34:21.000000', 'consum', 0.0216, 'lps'),
	(558880, 128, '2014-03-01 00:34:22.000000', 'consum', 0.0218, 'lps'),
	(558881, 128, '2014-03-01 00:34:23.000000', 'consum', 0.0232, 'lps'),
	(558882, 128, '2014-03-01 00:34:24.000000', 'consum', 0.0221, 'lps'),
	(558883, 128, '2014-03-01 00:34:25.000000', 'consum', 0.0225, 'lps'),
	(558884, 128, '2014-03-01 00:34:26.000000', 'consum', 0.0230, 'lps'),
	(558885, 128, '2014-03-01 00:34:27.000000', 'consum', 0.0213, 'lps'),
	(558886, 128, '2014-03-01 00:34:28.000000', 'consum', 0.0216, 'lps'),
	(558887, 128, '2014-03-01 00:34:29.000000', 'consum', 0.0229, 'lps'),
	(558888, 128, '2014-03-01 00:34:30.000000', 'consum', 0.0216, 'lps'),
	(558889, 128, '2014-03-01 00:34:31.000000', 'consum', 0.0233, 'lps'),
	(558890, 128, '2014-03-01 00:34:32.000000', 'consum', 0.0231, 'lps'),
	(558891, 128, '2014-03-01 00:34:33.000000', 'consum', 0.0221, 'lps'),
	(558892, 128, '2014-03-01 00:34:34.000000', 'consum', 0.0229, 'lps'),
	(558893, 128, '2014-03-01 00:34:35.000000', 'consum', 0.0221, 'lps'),
	(558894, 128, '2014-03-01 00:34:36.000000', 'consum', 0.0232, 'lps'),
	(558895, 128, '2014-03-01 00:34:37.000000', 'consum', 0.0215, 'lps'),
	(558896, 128, '2014-03-01 00:34:38.000000', 'consum', 0.0218, 'lps'),
	(558897, 128, '2014-03-01 00:34:39.000000', 'consum', 0.0213, 'lps'),
	(558898, 128, '2014-03-01 00:34:40.000000', 'consum', 0.0224, 'lps'),
	(558899, 128, '2014-03-01 00:34:41.000000', 'consum', 0.0223, 'lps'),
	(558900, 128, '2014-03-01 00:34:42.000000', 'consum', 0.0210, 'lps'),
	(558901, 128, '2014-03-01 00:34:43.000000', 'consum', 0.0218, 'lps'),
	(558902, 128, '2014-03-01 00:34:44.000000', 'consum', 0.0228, 'lps'),
	(558903, 128, '2014-03-01 00:34:45.000000', 'consum', 0.0225, 'lps'),
	(558904, 128, '2014-03-01 00:34:46.000000', 'consum', 0.0232, 'lps'),
	(558905, 128, '2014-03-01 00:34:47.000000', 'consum', 0.0226, 'lps'),
	(558906, 128, '2014-03-01 00:34:48.000000', 'consum', 0.0226, 'lps'),
	(558907, 128, '2014-03-01 00:34:49.000000', 'consum', 0.0216, 'lps'),
	(558908, 128, '2014-03-01 00:34:50.000000', 'consum', 0.0217, 'lps'),
	(558909, 128, '2014-03-01 00:34:51.000000', 'consum', 0.0227, 'lps'),
	(558910, 128, '2014-03-01 00:34:52.000000', 'consum', 0.0223, 'lps'),
	(558911, 128, '2014-03-01 00:34:53.000000', 'consum', 0.0227, 'lps'),
	(558912, 128, '2014-03-01 00:34:54.000000', 'consum', 0.0232, 'lps'),
	(558913, 128, '2014-03-01 00:34:55.000000', 'consum', 0.0218, 'lps'),
	(558914, 128, '2014-03-01 00:34:56.000000', 'consum', 0.0234, 'lps'),
	(558915, 128, '2014-03-01 00:34:57.000000', 'consum', 0.0234, 'lps'),
	(558916, 128, '2014-03-01 00:34:58.000000', 'consum', 0.0232, 'lps'),
	(558917, 128, '2014-03-01 00:34:59.000000', 'consum', 0.0224, 'lps'),
	(558918, 128, '2014-03-01 00:35:00.000000', 'consum', 0.0216, 'lps'),
	(558919, 128, '2014-03-01 00:35:01.000000', 'consum', 0.0221, 'lps'),
	(558920, 128, '2014-03-01 00:35:02.000000', 'consum', 0.0225, 'lps'),
	(558921, 128, '2014-03-01 00:35:03.000000', 'consum', 0.0226, 'lps'),
	(558922, 128, '2014-03-01 00:35:04.000000', 'consum', 0.0219, 'lps'),
	(558923, 128, '2014-03-01 00:35:05.000000', 'consum', 0.0210, 'lps'),
	(558924, 128, '2014-03-01 00:35:06.000000', 'consum', 0.0210, 'lps'),
	(558925, 128, '2014-03-01 00:35:07.000000', 'consum', 0.0232, 'lps'),
	(558926, 128, '2014-03-01 00:35:08.000000', 'consum', 0.0223, 'lps'),
	(558927, 128, '2014-03-01 00:35:09.000000', 'consum', 0.0234, 'lps'),
	(558928, 128, '2014-03-01 00:35:10.000000', 'consum', 0.0218, 'lps'),
	(558929, 128, '2014-03-01 00:35:11.000000', 'consum', 0.0228, 'lps'),
	(558930, 128, '2014-03-01 00:35:12.000000', 'consum', 0.0225, 'lps'),
	(558931, 128, '2014-03-01 00:35:13.000000', 'consum', 0.0232, 'lps'),
	(558932, 128, '2014-03-01 00:35:14.000000', 'consum', 0.0226, 'lps'),
	(558933, 128, '2014-03-01 00:35:15.000000', 'consum', 0.0225, 'lps'),
	(558934, 128, '2014-03-01 00:35:16.000000', 'consum', 0.0213, 'lps'),
	(558935, 128, '2014-03-01 00:35:17.000000', 'consum', 0.0230, 'lps'),
	(558936, 128, '2014-03-01 00:35:18.000000', 'consum', 0.0225, 'lps'),
	(558937, 128, '2014-03-01 00:35:19.000000', 'consum', 0.0228, 'lps'),
	(558938, 128, '2014-03-01 00:35:20.000000', 'consum', 0.0230, 'lps'),
	(558939, 128, '2014-03-01 00:35:21.000000', 'consum', 0.0230, 'lps'),
	(558940, 128, '2014-03-01 00:35:22.000000', 'consum', 0.0225, 'lps'),
	(558941, 128, '2014-03-01 00:35:23.000000', 'consum', 0.0226, 'lps'),
	(558942, 128, '2014-03-01 00:35:24.000000', 'consum', 0.0221, 'lps'),
	(558943, 128, '2014-03-01 00:35:25.000000', 'consum', 0.0217, 'lps'),
	(558944, 128, '2014-03-01 00:35:26.000000', 'consum', 0.0212, 'lps'),
	(558945, 128, '2014-03-01 00:35:27.000000', 'consum', 0.0224, 'lps'),
	(558946, 128, '2014-03-01 00:35:28.000000', 'consum', 0.0225, 'lps'),
	(558947, 128, '2014-03-01 00:35:29.000000', 'consum', 0.0219, 'lps'),
	(558948, 128, '2014-03-01 00:35:30.000000', 'consum', 0.0234, 'lps'),
	(558949, 128, '2014-03-01 00:35:31.000000', 'consum', 0.0230, 'lps'),
	(558950, 128, '2014-03-01 00:35:32.000000', 'consum', 0.0211, 'lps'),
	(558951, 128, '2014-03-01 00:35:33.000000', 'consum', 0.0232, 'lps'),
	(558952, 128, '2014-03-01 00:35:34.000000', 'consum', 0.0218, 'lps'),
	(558953, 128, '2014-03-01 00:35:35.000000', 'consum', 0.0233, 'lps'),
	(558954, 128, '2014-03-01 00:35:36.000000', 'consum', 0.0225, 'lps'),
	(558955, 128, '2014-03-01 00:35:37.000000', 'consum', 0.0219, 'lps'),
	(558956, 128, '2014-03-01 00:35:38.000000', 'consum', 0.0234, 'lps'),
	(558957, 128, '2014-03-01 00:35:39.000000', 'consum', 0.0231, 'lps'),
	(558958, 128, '2014-03-01 00:35:40.000000', 'consum', 0.0215, 'lps'),
	(558959, 128, '2014-03-01 00:35:41.000000', 'consum', 0.0225, 'lps'),
	(558960, 128, '2014-03-01 00:35:42.000000', 'consum', 0.0220, 'lps'),
	(558961, 128, '2014-03-01 00:35:43.000000', 'consum', 0.0214, 'lps'),
	(558962, 128, '2014-03-01 00:35:44.000000', 'consum', 0.0227, 'lps'),
	(558963, 128, '2014-03-01 00:35:45.000000', 'consum', 0.0233, 'lps'),
	(558964, 128, '2014-03-01 00:35:46.000000', 'consum', 0.0226, 'lps'),
	(558965, 128, '2014-03-01 00:35:47.000000', 'consum', 0.0220, 'lps'),
	(558966, 128, '2014-03-01 00:35:48.000000', 'consum', 0.0211, 'lps'),
	(558967, 128, '2014-03-01 00:35:49.000000', 'consum', 0.0212, 'lps'),
	(558968, 128, '2014-03-01 00:35:50.000000', 'consum', 0.0215, 'lps'),
	(558969, 128, '2014-03-01 00:35:51.000000', 'consum', 0.0232, 'lps'),
	(558970, 128, '2014-03-01 00:35:52.000000', 'consum', 0.0232, 'lps'),
	(558971, 128, '2014-03-01 00:35:53.000000', 'consum', 0.0226, 'lps'),
	(558972, 128, '2014-03-01 00:35:54.000000', 'consum', 0.0228, 'lps'),
	(558973, 128, '2014-03-01 00:35:55.000000', 'consum', 0.0226, 'lps'),
	(558974, 128, '2014-03-01 00:35:56.000000', 'consum', 0.0213, 'lps'),
	(558975, 128, '2014-03-01 00:35:57.000000', 'consum', 0.0225, 'lps'),
	(558976, 128, '2014-03-01 00:35:58.000000', 'consum', 0.0228, 'lps'),
	(558977, 128, '2014-03-01 00:35:59.000000', 'consum', 0.0229, 'lps'),
	(558978, 128, '2014-03-01 00:36:00.000000', 'consum', 0.0225, 'lps'),
	(558979, 128, '2014-03-01 00:36:01.000000', 'consum', 0.0232, 'lps'),
	(558980, 128, '2014-03-01 00:36:02.000000', 'consum', 0.0224, 'lps'),
	(558981, 128, '2014-03-01 00:36:03.000000', 'consum', 0.0214, 'lps'),
	(558982, 128, '2014-03-01 00:36:04.000000', 'consum', 0.0212, 'lps'),
	(558983, 128, '2014-03-01 00:36:05.000000', 'consum', 0.0211, 'lps'),
	(558984, 128, '2014-03-01 00:36:06.000000', 'consum', 0.0233, 'lps'),
	(558985, 128, '2014-03-01 00:36:07.000000', 'consum', 0.0223, 'lps'),
	(558986, 128, '2014-03-01 00:36:08.000000', 'consum', 0.0229, 'lps'),
	(558987, 128, '2014-03-01 00:36:09.000000', 'consum', 0.0220, 'lps'),
	(558988, 128, '2014-03-01 00:36:10.000000', 'consum', 0.0228, 'lps'),
	(558989, 128, '2014-03-01 00:36:11.000000', 'consum', 0.0219, 'lps'),
	(558990, 128, '2014-03-01 00:36:12.000000', 'consum', 0.0228, 'lps'),
	(558991, 128, '2014-03-01 00:36:13.000000', 'consum', 0.0222, 'lps'),
	(558992, 128, '2014-03-01 00:36:14.000000', 'consum', 0.0217, 'lps'),
	(558993, 128, '2014-03-01 00:36:15.000000', 'consum', 0.0211, 'lps'),
	(558994, 128, '2014-03-01 00:36:16.000000', 'consum', 0.0220, 'lps'),
	(558995, 128, '2014-03-01 00:36:17.000000', 'consum', 0.0233, 'lps'),
	(558996, 128, '2014-03-01 00:36:18.000000', 'consum', 0.0218, 'lps'),
	(558997, 128, '2014-03-01 00:36:19.000000', 'consum', 0.0233, 'lps'),
	(558998, 128, '2014-03-01 00:36:20.000000', 'consum', 0.0224, 'lps'),
	(558999, 128, '2014-03-01 00:36:21.000000', 'consum', 0.0215, 'lps'),
	(559000, 128, '2014-03-01 00:36:22.000000', 'consum', 0.0216, 'lps'),
	(559001, 128, '2014-03-01 00:36:23.000000', 'consum', 0.0225, 'lps'),
	(559002, 128, '2014-03-01 00:36:24.000000', 'consum', 0.0220, 'lps'),
	(559003, 128, '2014-03-01 00:36:25.000000', 'consum', 0.0214, 'lps'),
	(559004, 128, '2014-03-01 00:36:26.000000', 'consum', 0.0226, 'lps'),
	(559005, 128, '2014-03-01 00:36:27.000000', 'consum', 0.0230, 'lps'),
	(559006, 128, '2014-03-01 00:36:28.000000', 'consum', 0.0211, 'lps'),
	(559007, 128, '2014-03-01 00:36:29.000000', 'consum', 0.0229, 'lps'),
	(559008, 128, '2014-03-01 00:36:30.000000', 'consum', 0.0229, 'lps'),
	(559009, 128, '2014-03-01 00:36:31.000000', 'consum', 0.0222, 'lps'),
	(559010, 128, '2014-03-01 00:36:32.000000', 'consum', 0.0213, 'lps'),
	(559011, 128, '2014-03-01 00:36:33.000000', 'consum', 0.0213, 'lps'),
	(559012, 128, '2014-03-01 00:36:34.000000', 'consum', 0.0220, 'lps'),
	(559013, 128, '2014-03-01 00:36:35.000000', 'consum', 0.0226, 'lps'),
	(559014, 128, '2014-03-01 00:36:36.000000', 'consum', 0.0210, 'lps'),
	(559015, 128, '2014-03-01 00:36:37.000000', 'consum', 0.0213, 'lps'),
	(559016, 128, '2014-03-01 00:36:38.000000', 'consum', 0.0223, 'lps'),
	(559017, 128, '2014-03-01 00:36:39.000000', 'consum', 0.0219, 'lps'),
	(559018, 128, '2014-03-01 00:36:40.000000', 'consum', 0.0215, 'lps'),
	(559019, 128, '2014-03-01 00:36:41.000000', 'consum', 0.0211, 'lps'),
	(559020, 128, '2014-03-01 00:36:42.000000', 'consum', 0.0224, 'lps'),
	(559021, 128, '2014-03-01 00:36:43.000000', 'consum', 0.0228, 'lps'),
	(559022, 128, '2014-03-01 00:36:44.000000', 'consum', 0.0233, 'lps'),
	(559023, 128, '2014-03-01 00:36:45.000000', 'consum', 0.0221, 'lps'),
	(559024, 128, '2014-03-01 00:36:46.000000', 'consum', 0.0221, 'lps'),
	(559025, 128, '2014-03-01 00:36:47.000000', 'consum', 0.0232, 'lps'),
	(559026, 128, '2014-03-01 00:36:48.000000', 'consum', 0.0214, 'lps'),
	(559027, 128, '2014-03-01 00:36:49.000000', 'consum', 0.0213, 'lps'),
	(559028, 128, '2014-03-01 00:36:50.000000', 'consum', 0.0212, 'lps'),
	(559029, 128, '2014-03-01 00:36:51.000000', 'consum', 0.0214, 'lps'),
	(559030, 128, '2014-03-01 00:36:52.000000', 'consum', 0.0224, 'lps'),
	(559031, 128, '2014-03-01 00:36:53.000000', 'consum', 0.0217, 'lps'),
	(559032, 128, '2014-03-01 00:36:54.000000', 'consum', 0.0231, 'lps'),
	(559033, 128, '2014-03-01 00:36:55.000000', 'consum', 0.0218, 'lps'),
	(559034, 128, '2014-03-01 00:36:56.000000', 'consum', 0.0213, 'lps'),
	(559035, 128, '2014-03-01 00:36:57.000000', 'consum', 0.0225, 'lps'),
	(559036, 128, '2014-03-01 00:36:58.000000', 'consum', 0.0228, 'lps'),
	(559037, 128, '2014-03-01 00:36:59.000000', 'consum', 0.0231, 'lps'),
	(559038, 128, '2014-03-01 00:37:00.000000', 'consum', 0.0210, 'lps'),
	(559039, 128, '2014-03-01 00:37:01.000000', 'consum', 0.0223, 'lps'),
	(559040, 128, '2014-03-01 00:37:02.000000', 'consum', 0.0226, 'lps'),
	(559041, 128, '2014-03-01 00:37:03.000000', 'consum', 0.0226, 'lps'),
	(559042, 128, '2014-03-01 00:37:04.000000', 'consum', 0.0217, 'lps'),
	(559043, 128, '2014-03-01 00:37:05.000000', 'consum', 0.0223, 'lps'),
	(559044, 128, '2014-03-01 00:37:06.000000', 'consum', 0.0230, 'lps'),
	(559045, 128, '2014-03-01 00:37:07.000000', 'consum', 0.0219, 'lps'),
	(559046, 128, '2014-03-01 00:37:08.000000', 'consum', 0.0224, 'lps'),
	(559047, 128, '2014-03-01 00:37:09.000000', 'consum', 0.0228, 'lps'),
	(559048, 128, '2014-03-01 00:37:10.000000', 'consum', 0.0231, 'lps'),
	(559049, 128, '2014-03-01 00:37:11.000000', 'consum', 0.0214, 'lps'),
	(559050, 128, '2014-03-01 00:37:12.000000', 'consum', 0.0216, 'lps'),
	(559051, 128, '2014-03-01 00:37:13.000000', 'consum', 0.0229, 'lps'),
	(559052, 128, '2014-03-01 00:37:14.000000', 'consum', 0.0212, 'lps'),
	(559053, 128, '2014-03-01 00:37:15.000000', 'consum', 0.0213, 'lps'),
	(559054, 128, '2014-03-01 00:37:16.000000', 'consum', 0.0220, 'lps'),
	(559055, 128, '2014-03-01 00:37:17.000000', 'consum', 0.0228, 'lps'),
	(559056, 128, '2014-03-01 00:37:18.000000', 'consum', 0.0220, 'lps'),
	(559057, 128, '2014-03-01 00:37:19.000000', 'consum', 0.0231, 'lps'),
	(559058, 128, '2014-03-01 00:37:20.000000', 'consum', 0.0212, 'lps'),
	(559059, 128, '2014-03-01 00:37:21.000000', 'consum', 0.0231, 'lps'),
	(559060, 128, '2014-03-01 00:37:22.000000', 'consum', 0.0210, 'lps'),
	(559061, 128, '2014-03-01 00:37:23.000000', 'consum', 0.0221, 'lps'),
	(559062, 128, '2014-03-01 00:37:24.000000', 'consum', 0.0218, 'lps'),
	(559063, 128, '2014-03-01 00:37:25.000000', 'consum', 0.0217, 'lps'),
	(559064, 128, '2014-03-01 00:37:26.000000', 'consum', 0.0223, 'lps'),
	(559065, 128, '2014-03-01 00:37:27.000000', 'consum', 0.0228, 'lps'),
	(559066, 128, '2014-03-01 00:37:28.000000', 'consum', 0.0213, 'lps'),
	(559067, 128, '2014-03-01 00:37:29.000000', 'consum', 0.0220, 'lps'),
	(559068, 128, '2014-03-01 00:37:30.000000', 'consum', 0.0226, 'lps'),
	(559069, 128, '2014-03-01 00:37:31.000000', 'consum', 0.0210, 'lps'),
	(559070, 128, '2014-03-01 00:37:32.000000', 'consum', 0.0215, 'lps'),
	(559071, 128, '2014-03-01 00:37:33.000000', 'consum', 0.0233, 'lps'),
	(559072, 128, '2014-03-01 00:37:34.000000', 'consum', 0.0212, 'lps'),
	(559073, 128, '2014-03-01 00:37:35.000000', 'consum', 0.0225, 'lps'),
	(559074, 128, '2014-03-01 00:37:36.000000', 'consum', 0.0231, 'lps'),
	(559075, 128, '2014-03-01 00:37:37.000000', 'consum', 0.0219, 'lps'),
	(559076, 128, '2014-03-01 00:37:38.000000', 'consum', 0.0217, 'lps'),
	(559077, 128, '2014-03-01 00:37:39.000000', 'consum', 0.0221, 'lps'),
	(559078, 128, '2014-03-01 00:37:40.000000', 'consum', 0.0220, 'lps'),
	(559079, 128, '2014-03-01 00:37:41.000000', 'consum', 0.0224, 'lps'),
	(559080, 128, '2014-03-01 00:37:42.000000', 'consum', 0.0228, 'lps'),
	(559081, 128, '2014-03-01 00:37:43.000000', 'consum', 0.0234, 'lps'),
	(559082, 128, '2014-03-01 00:37:44.000000', 'consum', 0.0226, 'lps'),
	(559083, 128, '2014-03-01 00:37:45.000000', 'consum', 0.0218, 'lps'),
	(559084, 128, '2014-03-01 00:37:46.000000', 'consum', 0.0226, 'lps'),
	(559085, 128, '2014-03-01 00:37:47.000000', 'consum', 0.0219, 'lps'),
	(559086, 128, '2014-03-01 00:37:48.000000', 'consum', 0.0233, 'lps'),
	(559087, 128, '2014-03-01 00:37:49.000000', 'consum', 0.0223, 'lps'),
	(559088, 128, '2014-03-01 00:37:50.000000', 'consum', 0.0230, 'lps'),
	(559089, 128, '2014-03-01 00:37:51.000000', 'consum', 0.0220, 'lps'),
	(559090, 128, '2014-03-01 00:37:52.000000', 'consum', 0.0228, 'lps'),
	(559091, 128, '2014-03-01 00:37:53.000000', 'consum', 0.0220, 'lps'),
	(559092, 128, '2014-03-01 00:37:54.000000', 'consum', 0.0231, 'lps'),
	(559093, 128, '2014-03-01 00:37:55.000000', 'consum', 0.0211, 'lps'),
	(559094, 128, '2014-03-01 00:37:56.000000', 'consum', 0.0227, 'lps'),
	(559095, 128, '2014-03-01 00:37:57.000000', 'consum', 0.0216, 'lps'),
	(559096, 128, '2014-03-01 00:37:58.000000', 'consum', 0.0215, 'lps'),
	(559097, 128, '2014-03-01 00:37:59.000000', 'consum', 0.0216, 'lps'),
	(559098, 128, '2014-03-01 00:38:00.000000', 'consum', 0.0228, 'lps'),
	(559099, 128, '2014-03-01 00:38:01.000000', 'consum', 0.0230, 'lps'),
	(559100, 128, '2014-03-01 00:38:02.000000', 'consum', 0.0233, 'lps'),
	(559101, 128, '2014-03-01 00:38:03.000000', 'consum', 0.0214, 'lps'),
	(559102, 128, '2014-03-01 00:38:04.000000', 'consum', 0.0215, 'lps'),
	(559103, 128, '2014-03-01 00:38:05.000000', 'consum', 0.0220, 'lps'),
	(559104, 128, '2014-03-01 00:38:06.000000', 'consum', 0.0221, 'lps'),
	(559105, 128, '2014-03-01 00:38:07.000000', 'consum', 0.0210, 'lps'),
	(559106, 128, '2014-03-01 00:38:08.000000', 'consum', 0.0226, 'lps'),
	(559107, 128, '2014-03-01 00:38:09.000000', 'consum', 0.0218, 'lps'),
	(559108, 128, '2014-03-01 00:38:10.000000', 'consum', 0.0227, 'lps'),
	(559109, 128, '2014-03-01 00:38:11.000000', 'consum', 0.0223, 'lps'),
	(559110, 128, '2014-03-01 00:38:12.000000', 'consum', 0.0225, 'lps'),
	(559111, 128, '2014-03-01 00:38:13.000000', 'consum', 0.0218, 'lps'),
	(559112, 128, '2014-03-01 00:38:14.000000', 'consum', 0.0233, 'lps'),
	(559113, 128, '2014-03-01 00:38:15.000000', 'consum', 0.0227, 'lps'),
	(559114, 128, '2014-03-01 00:38:16.000000', 'consum', 0.0225, 'lps'),
	(559115, 128, '2014-03-01 00:38:17.000000', 'consum', 0.0234, 'lps'),
	(559116, 128, '2014-03-01 00:38:18.000000', 'consum', 0.0212, 'lps'),
	(559117, 128, '2014-03-01 00:38:19.000000', 'consum', 0.0225, 'lps'),
	(559118, 128, '2014-03-01 00:38:20.000000', 'consum', 0.0226, 'lps'),
	(559119, 128, '2014-03-01 00:38:21.000000', 'consum', 0.0223, 'lps'),
	(559120, 128, '2014-03-01 00:38:22.000000', 'consum', 0.0225, 'lps'),
	(559121, 128, '2014-03-01 00:38:23.000000', 'consum', 0.0224, 'lps'),
	(559122, 128, '2014-03-01 00:38:24.000000', 'consum', 0.0233, 'lps'),
	(559123, 128, '2014-03-01 00:38:25.000000', 'consum', 0.0210, 'lps'),
	(559124, 128, '2014-03-01 00:38:26.000000', 'consum', 0.0218, 'lps'),
	(559125, 128, '2014-03-01 00:38:27.000000', 'consum', 0.0223, 'lps'),
	(559126, 128, '2014-03-01 00:38:28.000000', 'consum', 0.0226, 'lps'),
	(559127, 128, '2014-03-01 00:38:29.000000', 'consum', 0.0225, 'lps'),
	(559128, 128, '2014-03-01 00:38:30.000000', 'consum', 0.0216, 'lps'),
	(559129, 128, '2014-03-01 00:38:31.000000', 'consum', 0.0218, 'lps'),
	(559130, 128, '2014-03-01 00:38:32.000000', 'consum', 0.0232, 'lps'),
	(559131, 128, '2014-03-01 00:38:33.000000', 'consum', 0.0221, 'lps'),
	(559132, 128, '2014-03-01 00:38:34.000000', 'consum', 0.0224, 'lps'),
	(559133, 128, '2014-03-01 00:38:35.000000', 'consum', 0.0224, 'lps'),
	(559134, 128, '2014-03-01 00:38:36.000000', 'consum', 0.0214, 'lps'),
	(559135, 128, '2014-03-01 00:38:37.000000', 'consum', 0.0214, 'lps'),
	(559136, 128, '2014-03-01 00:38:38.000000', 'consum', 0.0218, 'lps'),
	(559137, 128, '2014-03-01 00:38:39.000000', 'consum', 0.0212, 'lps'),
	(559138, 128, '2014-03-01 00:38:40.000000', 'consum', 0.0221, 'lps'),
	(559139, 128, '2014-03-01 00:38:41.000000', 'consum', 0.0210, 'lps'),
	(559140, 128, '2014-03-01 00:38:42.000000', 'consum', 0.0229, 'lps'),
	(559141, 128, '2014-03-01 00:38:43.000000', 'consum', 0.0232, 'lps'),
	(559142, 128, '2014-03-01 00:38:44.000000', 'consum', 0.0210, 'lps'),
	(559143, 128, '2014-03-01 00:38:45.000000', 'consum', 0.0221, 'lps'),
	(559144, 128, '2014-03-01 00:38:46.000000', 'consum', 0.0217, 'lps'),
	(559145, 128, '2014-03-01 00:38:47.000000', 'consum', 0.0210, 'lps'),
	(559146, 128, '2014-03-01 00:38:48.000000', 'consum', 0.0214, 'lps'),
	(559147, 128, '2014-03-01 00:38:49.000000', 'consum', 0.0233, 'lps'),
	(559148, 128, '2014-03-01 00:38:50.000000', 'consum', 0.0211, 'lps'),
	(559149, 128, '2014-03-01 00:38:51.000000', 'consum', 0.0221, 'lps'),
	(559150, 128, '2014-03-01 00:38:52.000000', 'consum', 0.0215, 'lps'),
	(559151, 128, '2014-03-01 00:38:53.000000', 'consum', 0.0225, 'lps'),
	(559152, 128, '2014-03-01 00:38:54.000000', 'consum', 0.0223, 'lps'),
	(559153, 128, '2014-03-01 00:38:55.000000', 'consum', 0.0229, 'lps'),
	(559154, 128, '2014-03-01 00:38:56.000000', 'consum', 0.0219, 'lps'),
	(559155, 128, '2014-03-01 00:38:57.000000', 'consum', 0.0220, 'lps'),
	(559156, 128, '2014-03-01 00:38:58.000000', 'consum', 0.0210, 'lps'),
	(559157, 128, '2014-03-01 00:38:59.000000', 'consum', 0.0231, 'lps'),
	(559158, 128, '2014-03-01 00:39:00.000000', 'consum', 0.0215, 'lps'),
	(559159, 128, '2014-03-01 00:39:01.000000', 'consum', 0.0222, 'lps'),
	(559160, 128, '2014-03-01 00:39:02.000000', 'consum', 0.0230, 'lps'),
	(559161, 128, '2014-03-01 00:39:03.000000', 'consum', 0.0225, 'lps'),
	(559162, 128, '2014-03-01 00:39:04.000000', 'consum', 0.0224, 'lps'),
	(559163, 128, '2014-03-01 00:39:05.000000', 'consum', 0.0211, 'lps'),
	(559164, 128, '2014-03-01 00:39:06.000000', 'consum', 0.0223, 'lps'),
	(559165, 128, '2014-03-01 00:39:07.000000', 'consum', 0.0223, 'lps'),
	(559166, 128, '2014-03-01 00:39:08.000000', 'consum', 0.0212, 'lps'),
	(559167, 128, '2014-03-01 00:39:09.000000', 'consum', 0.0229, 'lps'),
	(559168, 128, '2014-03-01 00:39:10.000000', 'consum', 0.0227, 'lps'),
	(559169, 128, '2014-03-01 00:39:11.000000', 'consum', 0.0213, 'lps'),
	(559170, 128, '2014-03-01 00:39:12.000000', 'consum', 0.0226, 'lps'),
	(559171, 128, '2014-03-01 00:39:13.000000', 'consum', 0.0231, 'lps'),
	(559172, 128, '2014-03-01 00:39:14.000000', 'consum', 0.0216, 'lps'),
	(559173, 128, '2014-03-01 00:39:15.000000', 'consum', 0.0229, 'lps'),
	(559174, 128, '2014-03-01 00:39:16.000000', 'consum', 0.0213, 'lps'),
	(559175, 128, '2014-03-01 00:39:17.000000', 'consum', 0.0216, 'lps'),
	(559176, 128, '2014-03-01 00:39:18.000000', 'consum', 0.0233, 'lps'),
	(559177, 128, '2014-03-01 00:39:19.000000', 'consum', 0.0231, 'lps'),
	(559178, 128, '2014-03-01 00:39:20.000000', 'consum', 0.0222, 'lps'),
	(559179, 128, '2014-03-01 00:39:21.000000', 'consum', 0.0231, 'lps'),
	(559180, 128, '2014-03-01 00:39:22.000000', 'consum', 0.0231, 'lps'),
	(559181, 128, '2014-03-01 00:39:23.000000', 'consum', 0.0229, 'lps'),
	(559182, 128, '2014-03-01 00:39:24.000000', 'consum', 0.0215, 'lps'),
	(559183, 128, '2014-03-01 00:39:25.000000', 'consum', 0.0228, 'lps'),
	(559184, 128, '2014-03-01 00:39:26.000000', 'consum', 0.0212, 'lps'),
	(559185, 128, '2014-03-01 00:39:27.000000', 'consum', 0.0217, 'lps'),
	(559186, 128, '2014-03-01 00:39:28.000000', 'consum', 0.0215, 'lps'),
	(559187, 128, '2014-03-01 00:39:29.000000', 'consum', 0.0213, 'lps'),
	(559188, 128, '2014-03-01 00:39:30.000000', 'consum', 0.0212, 'lps'),
	(559189, 128, '2014-03-01 00:39:31.000000', 'consum', 0.0212, 'lps'),
	(559190, 128, '2014-03-01 00:39:32.000000', 'consum', 0.0212, 'lps'),
	(559191, 128, '2014-03-01 00:39:33.000000', 'consum', 0.0214, 'lps'),
	(559192, 128, '2014-03-01 00:39:34.000000', 'consum', 0.0227, 'lps'),
	(559193, 128, '2014-03-01 00:39:35.000000', 'consum', 0.0232, 'lps'),
	(559194, 128, '2014-03-01 00:39:36.000000', 'consum', 0.0220, 'lps'),
	(559195, 128, '2014-03-01 00:39:37.000000', 'consum', 0.0220, 'lps'),
	(559196, 128, '2014-03-01 00:39:38.000000', 'consum', 0.0228, 'lps'),
	(559197, 128, '2014-03-01 00:39:39.000000', 'consum', 0.0223, 'lps'),
	(559198, 128, '2014-03-01 00:39:40.000000', 'consum', 0.0222, 'lps'),
	(559199, 128, '2014-03-01 00:39:41.000000', 'consum', 0.0232, 'lps'),
	(559200, 128, '2014-03-01 00:39:42.000000', 'consum', 0.0232, 'lps'),
	(559201, 128, '2014-03-01 00:39:43.000000', 'consum', 0.0231, 'lps'),
	(559202, 128, '2014-03-01 00:39:44.000000', 'consum', 0.0223, 'lps'),
	(559203, 128, '2014-03-01 00:39:45.000000', 'consum', 0.0214, 'lps'),
	(559204, 128, '2014-03-01 00:39:46.000000', 'consum', 0.0216, 'lps'),
	(559205, 128, '2014-03-01 00:39:47.000000', 'consum', 0.0229, 'lps'),
	(559206, 128, '2014-03-01 00:39:48.000000', 'consum', 0.0213, 'lps'),
	(559207, 128, '2014-03-01 00:39:49.000000', 'consum', 0.0216, 'lps'),
	(559208, 128, '2014-03-01 00:39:50.000000', 'consum', 0.0233, 'lps'),
	(559209, 128, '2014-03-01 00:39:51.000000', 'consum', 0.0230, 'lps'),
	(559210, 128, '2014-03-01 00:39:52.000000', 'consum', 0.0219, 'lps'),
	(559211, 128, '2014-03-01 00:39:53.000000', 'consum', 0.0222, 'lps'),
	(559212, 128, '2014-03-01 00:39:54.000000', 'consum', 0.0216, 'lps'),
	(559213, 128, '2014-03-01 00:39:55.000000', 'consum', 0.0229, 'lps'),
	(559214, 128, '2014-03-01 00:39:56.000000', 'consum', 0.0213, 'lps'),
	(559215, 128, '2014-03-01 00:39:57.000000', 'consum', 0.0221, 'lps'),
	(559216, 128, '2014-03-01 00:39:58.000000', 'consum', 0.0229, 'lps'),
	(559217, 128, '2014-03-01 00:39:59.000000', 'consum', 0.0223, 'lps'),
	(559218, 128, '2014-03-01 00:40:00.000000', 'consum', 0.0218, 'lps'),
	(559219, 128, '2014-03-01 00:40:01.000000', 'consum', 0.0212, 'lps'),
	(559220, 128, '2014-03-01 00:40:02.000000', 'consum', 0.0222, 'lps'),
	(559221, 128, '2014-03-01 00:40:03.000000', 'consum', 0.0213, 'lps'),
	(559222, 128, '2014-03-01 00:40:04.000000', 'consum', 0.0217, 'lps'),
	(559223, 128, '2014-03-01 00:40:05.000000', 'consum', 0.0210, 'lps'),
	(559224, 128, '2014-03-01 00:40:06.000000', 'consum', 0.0213, 'lps'),
	(559225, 128, '2014-03-01 00:40:07.000000', 'consum', 0.0229, 'lps'),
	(559226, 128, '2014-03-01 00:40:08.000000', 'consum', 0.0219, 'lps'),
	(559227, 128, '2014-03-01 00:40:09.000000', 'consum', 0.0222, 'lps'),
	(559228, 128, '2014-03-01 00:40:10.000000', 'consum', 0.0222, 'lps'),
	(559229, 128, '2014-03-01 00:40:11.000000', 'consum', 0.0233, 'lps'),
	(559230, 128, '2014-03-01 00:40:12.000000', 'consum', 0.0214, 'lps'),
	(559231, 128, '2014-03-01 00:40:13.000000', 'consum', 0.0211, 'lps'),
	(559232, 128, '2014-03-01 00:40:14.000000', 'consum', 0.0228, 'lps'),
	(559233, 128, '2014-03-01 00:40:15.000000', 'consum', 0.0223, 'lps'),
	(559234, 128, '2014-03-01 00:40:16.000000', 'consum', 0.0222, 'lps'),
	(559235, 128, '2014-03-01 00:40:17.000000', 'consum', 0.0229, 'lps'),
	(559236, 128, '2014-03-01 00:40:18.000000', 'consum', 0.0223, 'lps'),
	(559237, 128, '2014-03-01 00:40:19.000000', 'consum', 0.0217, 'lps'),
	(559238, 128, '2014-03-01 00:40:20.000000', 'consum', 0.0232, 'lps'),
	(559239, 128, '2014-03-01 00:40:21.000000', 'consum', 0.0225, 'lps'),
	(559240, 128, '2014-03-01 00:40:22.000000', 'consum', 0.0220, 'lps'),
	(559241, 128, '2014-03-01 00:40:23.000000', 'consum', 0.0216, 'lps'),
	(559242, 128, '2014-03-01 00:40:24.000000', 'consum', 0.0234, 'lps'),
	(559243, 128, '2014-03-01 00:40:25.000000', 'consum', 0.0214, 'lps'),
	(559244, 128, '2014-03-01 00:40:26.000000', 'consum', 0.0234, 'lps'),
	(559245, 128, '2014-03-01 00:40:27.000000', 'consum', 0.0219, 'lps'),
	(559246, 128, '2014-03-01 00:40:28.000000', 'consum', 0.0233, 'lps'),
	(559247, 128, '2014-03-01 00:40:29.000000', 'consum', 0.0223, 'lps'),
	(559248, 128, '2014-03-01 00:40:30.000000', 'consum', 0.0231, 'lps'),
	(559249, 128, '2014-03-01 00:40:31.000000', 'consum', 0.0227, 'lps'),
	(559250, 128, '2014-03-01 00:40:32.000000', 'consum', 0.0230, 'lps'),
	(559251, 128, '2014-03-01 00:40:33.000000', 'consum', 0.0213, 'lps'),
	(559252, 128, '2014-03-01 00:40:34.000000', 'consum', 0.0213, 'lps'),
	(559253, 128, '2014-03-01 00:40:35.000000', 'consum', 0.0219, 'lps'),
	(559254, 128, '2014-03-01 00:40:36.000000', 'consum', 0.0220, 'lps'),
	(559255, 128, '2014-03-01 00:40:37.000000', 'consum', 0.0210, 'lps'),
	(559256, 128, '2014-03-01 00:40:38.000000', 'consum', 0.0231, 'lps'),
	(559257, 128, '2014-03-01 00:40:39.000000', 'consum', 0.0214, 'lps'),
	(559258, 128, '2014-03-01 00:40:40.000000', 'consum', 0.0220, 'lps'),
	(559259, 128, '2014-03-01 00:40:41.000000', 'consum', 0.0221, 'lps'),
	(559260, 128, '2014-03-01 00:40:42.000000', 'consum', 0.0234, 'lps'),
	(559261, 128, '2014-03-01 00:40:43.000000', 'consum', 0.0226, 'lps'),
	(559262, 128, '2014-03-01 00:40:44.000000', 'consum', 0.0216, 'lps'),
	(559263, 128, '2014-03-01 00:40:45.000000', 'consum', 0.0218, 'lps'),
	(559264, 128, '2014-03-01 00:40:46.000000', 'consum', 0.0233, 'lps'),
	(559265, 128, '2014-03-01 00:40:47.000000', 'consum', 0.0226, 'lps'),
	(559266, 128, '2014-03-01 00:40:48.000000', 'consum', 0.0224, 'lps'),
	(559267, 128, '2014-03-01 00:40:49.000000', 'consum', 0.0230, 'lps'),
	(559268, 128, '2014-03-01 00:40:50.000000', 'consum', 0.0217, 'lps'),
	(559269, 128, '2014-03-01 00:40:51.000000', 'consum', 0.0213, 'lps'),
	(559270, 128, '2014-03-01 00:40:52.000000', 'consum', 0.0231, 'lps'),
	(559271, 128, '2014-03-01 00:40:53.000000', 'consum', 0.0228, 'lps'),
	(559272, 128, '2014-03-01 00:40:54.000000', 'consum', 0.0214, 'lps'),
	(559273, 128, '2014-03-01 00:40:55.000000', 'consum', 0.0224, 'lps'),
	(559274, 128, '2014-03-01 00:40:56.000000', 'consum', 0.0221, 'lps'),
	(559275, 128, '2014-03-01 00:40:57.000000', 'consum', 0.0225, 'lps'),
	(559276, 128, '2014-03-01 00:40:58.000000', 'consum', 0.0226, 'lps'),
	(559277, 128, '2014-03-01 00:40:59.000000', 'consum', 0.0219, 'lps'),
	(559278, 128, '2014-03-01 00:41:00.000000', 'consum', 0.0234, 'lps'),
	(559279, 128, '2014-03-01 00:41:01.000000', 'consum', 0.0230, 'lps'),
	(559280, 128, '2014-03-01 00:41:02.000000', 'consum', 0.0213, 'lps'),
	(559281, 128, '2014-03-01 00:41:03.000000', 'consum', 0.0214, 'lps'),
	(559282, 128, '2014-03-01 00:41:04.000000', 'consum', 0.0222, 'lps'),
	(559283, 128, '2014-03-01 00:41:05.000000', 'consum', 0.0210, 'lps'),
	(559284, 128, '2014-03-01 00:41:06.000000', 'consum', 0.0224, 'lps'),
	(559285, 128, '2014-03-01 00:41:07.000000', 'consum', 0.0231, 'lps'),
	(559286, 128, '2014-03-01 00:41:08.000000', 'consum', 0.0221, 'lps'),
	(559287, 128, '2014-03-01 00:41:09.000000', 'consum', 0.0231, 'lps'),
	(559288, 128, '2014-03-01 00:41:10.000000', 'consum', 0.0230, 'lps'),
	(559289, 128, '2014-03-01 00:41:11.000000', 'consum', 0.0225, 'lps'),
	(559290, 128, '2014-03-01 00:41:12.000000', 'consum', 0.0223, 'lps'),
	(559291, 128, '2014-03-01 00:41:13.000000', 'consum', 0.0229, 'lps'),
	(559292, 128, '2014-03-01 00:41:14.000000', 'consum', 0.0220, 'lps'),
	(559293, 128, '2014-03-01 00:41:15.000000', 'consum', 0.0227, 'lps'),
	(559294, 128, '2014-03-01 00:41:16.000000', 'consum', 0.0216, 'lps'),
	(559295, 128, '2014-03-01 00:41:17.000000', 'consum', 0.0216, 'lps'),
	(559296, 128, '2014-03-01 00:41:18.000000', 'consum', 0.0222, 'lps'),
	(559297, 128, '2014-03-01 00:41:19.000000', 'consum', 0.0227, 'lps'),
	(559298, 128, '2014-03-01 00:41:20.000000', 'consum', 0.0211, 'lps'),
	(559299, 128, '2014-03-01 00:41:21.000000', 'consum', 0.0213, 'lps'),
	(559300, 128, '2014-03-01 00:41:22.000000', 'consum', 0.0224, 'lps'),
	(559301, 128, '2014-03-01 00:41:23.000000', 'consum', 0.0219, 'lps'),
	(559302, 128, '2014-03-01 00:41:24.000000', 'consum', 0.0214, 'lps'),
	(559303, 128, '2014-03-01 00:41:25.000000', 'consum', 0.0230, 'lps'),
	(559304, 128, '2014-03-01 00:41:26.000000', 'consum', 0.0223, 'lps'),
	(559305, 128, '2014-03-01 00:41:27.000000', 'consum', 0.0216, 'lps'),
	(559306, 128, '2014-03-01 00:41:28.000000', 'consum', 0.0227, 'lps'),
	(559307, 128, '2014-03-01 00:41:29.000000', 'consum', 0.0226, 'lps'),
	(559308, 128, '2014-03-01 00:41:30.000000', 'consum', 0.0217, 'lps'),
	(559309, 128, '2014-03-01 00:41:31.000000', 'consum', 0.0222, 'lps'),
	(559310, 128, '2014-03-01 00:41:32.000000', 'consum', 0.0224, 'lps'),
	(559311, 128, '2014-03-01 00:41:33.000000', 'consum', 0.0222, 'lps'),
	(559312, 128, '2014-03-01 00:41:34.000000', 'consum', 0.0225, 'lps'),
	(559313, 128, '2014-03-01 00:41:35.000000', 'consum', 0.0224, 'lps'),
	(559314, 128, '2014-03-01 00:41:36.000000', 'consum', 0.0213, 'lps'),
	(559315, 128, '2014-03-01 00:41:37.000000', 'consum', 0.0232, 'lps'),
	(559316, 128, '2014-03-01 00:41:38.000000', 'consum', 0.0210, 'lps'),
	(559317, 128, '2014-03-01 00:41:39.000000', 'consum', 0.0221, 'lps'),
	(559318, 128, '2014-03-01 00:41:40.000000', 'consum', 0.0216, 'lps'),
	(559319, 128, '2014-03-01 00:41:41.000000', 'consum', 0.0230, 'lps'),
	(559320, 128, '2014-03-01 00:41:42.000000', 'consum', 0.0219, 'lps'),
	(559321, 128, '2014-03-01 00:41:43.000000', 'consum', 0.0219, 'lps'),
	(559322, 128, '2014-03-01 00:41:44.000000', 'consum', 0.0230, 'lps'),
	(559323, 128, '2014-03-01 00:41:45.000000', 'consum', 0.0234, 'lps'),
	(559324, 128, '2014-03-01 00:41:46.000000', 'consum', 0.0220, 'lps'),
	(559325, 128, '2014-03-01 00:41:47.000000', 'consum', 0.0212, 'lps'),
	(559326, 128, '2014-03-01 00:41:48.000000', 'consum', 0.0218, 'lps'),
	(559327, 128, '2014-03-01 00:41:49.000000', 'consum', 0.0217, 'lps'),
	(559328, 128, '2014-03-01 00:41:50.000000', 'consum', 0.0223, 'lps'),
	(559329, 128, '2014-03-01 00:41:51.000000', 'consum', 0.0229, 'lps'),
	(559330, 128, '2014-03-01 00:41:52.000000', 'consum', 0.0218, 'lps'),
	(559331, 128, '2014-03-01 00:41:53.000000', 'consum', 0.0216, 'lps'),
	(559332, 128, '2014-03-01 00:41:54.000000', 'consum', 0.0216, 'lps'),
	(559333, 128, '2014-03-01 00:41:55.000000', 'consum', 0.0226, 'lps'),
	(559334, 128, '2014-03-01 00:41:56.000000', 'consum', 0.0219, 'lps'),
	(559335, 128, '2014-03-01 00:41:57.000000', 'consum', 0.0233, 'lps'),
	(559336, 128, '2014-03-01 00:41:58.000000', 'consum', 0.0225, 'lps'),
	(559337, 128, '2014-03-01 00:41:59.000000', 'consum', 0.0218, 'lps'),
	(559338, 128, '2014-03-01 00:42:00.000000', 'consum', 0.0227, 'lps'),
	(559339, 128, '2014-03-01 00:42:01.000000', 'consum', 0.0224, 'lps'),
	(559340, 128, '2014-03-01 00:42:02.000000', 'consum', 0.0228, 'lps'),
	(559341, 128, '2014-03-01 00:42:03.000000', 'consum', 0.0211, 'lps'),
	(559342, 128, '2014-03-01 00:42:04.000000', 'consum', 0.0210, 'lps'),
	(559343, 128, '2014-03-01 00:42:05.000000', 'consum', 0.0210, 'lps'),
	(559344, 128, '2014-03-01 00:42:06.000000', 'consum', 0.0232, 'lps'),
	(559345, 128, '2014-03-01 00:42:07.000000', 'consum', 0.0222, 'lps'),
	(559346, 128, '2014-03-01 00:42:08.000000', 'consum', 0.0230, 'lps'),
	(559347, 128, '2014-03-01 00:42:09.000000', 'consum', 0.0224, 'lps'),
	(559348, 128, '2014-03-01 00:42:10.000000', 'consum', 0.0219, 'lps'),
	(559349, 128, '2014-03-01 00:42:11.000000', 'consum', 0.0215, 'lps'),
	(559350, 128, '2014-03-01 00:42:12.000000', 'consum', 0.0231, 'lps'),
	(559351, 128, '2014-03-01 00:42:13.000000', 'consum', 0.0228, 'lps'),
	(559352, 128, '2014-03-01 00:42:14.000000', 'consum', 0.0213, 'lps'),
	(559353, 128, '2014-03-01 00:42:15.000000', 'consum', 0.0222, 'lps'),
	(559354, 128, '2014-03-01 00:42:16.000000', 'consum', 0.0211, 'lps'),
	(559355, 128, '2014-03-01 00:42:17.000000', 'consum', 0.0230, 'lps'),
	(559356, 128, '2014-03-01 00:42:18.000000', 'consum', 0.0230, 'lps'),
	(559357, 128, '2014-03-01 00:42:19.000000', 'consum', 0.0228, 'lps'),
	(559358, 128, '2014-03-01 00:42:20.000000', 'consum', 0.0216, 'lps'),
	(559359, 128, '2014-03-01 00:42:21.000000', 'consum', 0.0210, 'lps'),
	(559360, 128, '2014-03-01 00:42:22.000000', 'consum', 0.0217, 'lps'),
	(559361, 128, '2014-03-01 00:42:23.000000', 'consum', 0.0222, 'lps'),
	(559362, 128, '2014-03-01 00:42:24.000000', 'consum', 0.0223, 'lps'),
	(559363, 128, '2014-03-01 00:42:25.000000', 'consum', 0.0215, 'lps'),
	(559364, 128, '2014-03-01 00:42:26.000000', 'consum', 0.0223, 'lps'),
	(559365, 128, '2014-03-01 00:42:27.000000', 'consum', 0.0233, 'lps'),
	(559366, 128, '2014-03-01 00:42:28.000000', 'consum', 0.0212, 'lps'),
	(559367, 128, '2014-03-01 00:42:29.000000', 'consum', 0.0229, 'lps'),
	(559368, 128, '2014-03-01 00:42:30.000000', 'consum', 0.0222, 'lps'),
	(559369, 128, '2014-03-01 00:42:31.000000', 'consum', 0.0213, 'lps'),
	(559370, 128, '2014-03-01 00:42:32.000000', 'consum', 0.0216, 'lps'),
	(559371, 128, '2014-03-01 00:42:33.000000', 'consum', 0.0231, 'lps'),
	(559372, 128, '2014-03-01 00:42:34.000000', 'consum', 0.0224, 'lps'),
	(559373, 128, '2014-03-01 00:42:35.000000', 'consum', 0.0216, 'lps'),
	(559374, 128, '2014-03-01 00:42:36.000000', 'consum', 0.0224, 'lps'),
	(559375, 128, '2014-03-01 00:42:37.000000', 'consum', 0.0214, 'lps'),
	(559376, 128, '2014-03-01 00:42:38.000000', 'consum', 0.0214, 'lps'),
	(559377, 128, '2014-03-01 00:42:39.000000', 'consum', 0.0216, 'lps'),
	(559378, 128, '2014-03-01 00:42:40.000000', 'consum', 0.0229, 'lps'),
	(559379, 128, '2014-03-01 00:42:41.000000', 'consum', 0.0213, 'lps'),
	(559380, 128, '2014-03-01 00:42:42.000000', 'consum', 0.0219, 'lps'),
	(559381, 128, '2014-03-01 00:42:43.000000', 'consum', 0.0219, 'lps'),
	(559382, 128, '2014-03-01 00:42:44.000000', 'consum', 0.0231, 'lps'),
	(559383, 128, '2014-03-01 00:42:45.000000', 'consum', 0.0214, 'lps'),
	(559384, 128, '2014-03-01 00:42:46.000000', 'consum', 0.0219, 'lps'),
	(559385, 128, '2014-03-01 00:42:47.000000', 'consum', 0.0216, 'lps'),
	(559386, 128, '2014-03-01 00:42:48.000000', 'consum', 0.0213, 'lps'),
	(559387, 128, '2014-03-01 00:42:49.000000', 'consum', 0.0234, 'lps'),
	(559388, 128, '2014-03-01 00:42:50.000000', 'consum', 0.0222, 'lps'),
	(559389, 128, '2014-03-01 00:42:51.000000', 'consum', 0.0221, 'lps'),
	(559390, 128, '2014-03-01 00:42:52.000000', 'consum', 0.0233, 'lps'),
	(559391, 128, '2014-03-01 00:42:53.000000', 'consum', 0.0214, 'lps'),
	(559392, 128, '2014-03-01 00:42:54.000000', 'consum', 0.0212, 'lps'),
	(559393, 128, '2014-03-01 00:42:55.000000', 'consum', 0.0211, 'lps'),
	(559394, 128, '2014-03-01 00:42:56.000000', 'consum', 0.0232, 'lps'),
	(559395, 128, '2014-03-01 00:42:57.000000', 'consum', 0.0219, 'lps'),
	(559396, 128, '2014-03-01 00:42:58.000000', 'consum', 0.0212, 'lps'),
	(559397, 128, '2014-03-01 00:42:59.000000', 'consum', 0.0222, 'lps'),
	(559398, 128, '2014-03-01 00:43:00.000000', 'consum', 0.0212, 'lps'),
	(559399, 128, '2014-03-01 00:43:01.000000', 'consum', 0.0210, 'lps'),
	(559400, 128, '2014-03-01 00:43:02.000000', 'consum', 0.0230, 'lps'),
	(559401, 128, '2014-03-01 00:43:03.000000', 'consum', 0.0234, 'lps'),
	(559402, 128, '2014-03-01 00:43:04.000000', 'consum', 0.0220, 'lps'),
	(559403, 128, '2014-03-01 00:43:05.000000', 'consum', 0.0213, 'lps'),
	(559404, 128, '2014-03-01 00:43:06.000000', 'consum', 0.0220, 'lps'),
	(559405, 128, '2014-03-01 00:43:07.000000', 'consum', 0.0227, 'lps'),
	(559406, 128, '2014-03-01 00:43:08.000000', 'consum', 0.0216, 'lps'),
	(559407, 128, '2014-03-01 00:43:09.000000', 'consum', 0.0215, 'lps'),
	(559408, 128, '2014-03-01 00:43:10.000000', 'consum', 0.0215, 'lps'),
	(559409, 128, '2014-03-01 00:43:11.000000', 'consum', 0.0223, 'lps'),
	(559410, 128, '2014-03-01 00:43:12.000000', 'consum', 0.0234, 'lps'),
	(559411, 128, '2014-03-01 00:43:13.000000', 'consum', 0.0215, 'lps'),
	(559412, 128, '2014-03-01 00:43:14.000000', 'consum', 0.0215, 'lps'),
	(559413, 128, '2014-03-01 00:43:15.000000', 'consum', 0.0222, 'lps'),
	(559414, 128, '2014-03-01 00:43:16.000000', 'consum', 0.0228, 'lps'),
	(559415, 128, '2014-03-01 00:43:17.000000', 'consum', 0.0215, 'lps'),
	(559416, 128, '2014-03-01 00:43:18.000000', 'consum', 0.0233, 'lps'),
	(559417, 128, '2014-03-01 00:43:19.000000', 'consum', 0.0211, 'lps'),
	(559418, 128, '2014-03-01 00:43:20.000000', 'consum', 0.0219, 'lps'),
	(559419, 128, '2014-03-01 00:43:21.000000', 'consum', 0.0231, 'lps'),
	(559420, 128, '2014-03-01 00:43:22.000000', 'consum', 0.0210, 'lps'),
	(559421, 128, '2014-03-01 00:43:23.000000', 'consum', 0.0223, 'lps'),
	(559422, 128, '2014-03-01 00:43:24.000000', 'consum', 0.0227, 'lps'),
	(559423, 128, '2014-03-01 00:43:25.000000', 'consum', 0.0230, 'lps'),
	(559424, 128, '2014-03-01 00:43:26.000000', 'consum', 0.0211, 'lps'),
	(559425, 128, '2014-03-01 00:43:27.000000', 'consum', 0.0230, 'lps'),
	(559426, 128, '2014-03-01 00:43:28.000000', 'consum', 0.0231, 'lps'),
	(559427, 128, '2014-03-01 00:43:29.000000', 'consum', 0.0232, 'lps'),
	(559428, 128, '2014-03-01 00:43:30.000000', 'consum', 0.0234, 'lps'),
	(559429, 128, '2014-03-01 00:43:31.000000', 'consum', 0.0214, 'lps'),
	(559430, 128, '2014-03-01 00:43:32.000000', 'consum', 0.0233, 'lps'),
	(559431, 128, '2014-03-01 00:43:33.000000', 'consum', 0.0215, 'lps'),
	(559432, 128, '2014-03-01 00:43:34.000000', 'consum', 0.0214, 'lps'),
	(559433, 128, '2014-03-01 00:43:35.000000', 'consum', 0.0217, 'lps'),
	(559434, 128, '2014-03-01 00:43:36.000000', 'consum', 0.0232, 'lps'),
	(559435, 128, '2014-03-01 00:43:37.000000', 'consum', 0.0225, 'lps'),
	(559436, 128, '2014-03-01 00:43:38.000000', 'consum', 0.0219, 'lps'),
	(559437, 128, '2014-03-01 00:43:39.000000', 'consum', 0.0210, 'lps'),
	(559438, 128, '2014-03-01 00:43:40.000000', 'consum', 0.0234, 'lps'),
	(559439, 128, '2014-03-01 00:43:41.000000', 'consum', 0.0230, 'lps'),
	(559440, 128, '2014-03-01 00:43:42.000000', 'consum', 0.0212, 'lps'),
	(559441, 128, '2014-03-01 00:43:43.000000', 'consum', 0.0213, 'lps'),
	(559442, 128, '2014-03-01 00:43:44.000000', 'consum', 0.0219, 'lps'),
	(559443, 128, '2014-03-01 00:43:45.000000', 'consum', 0.0223, 'lps'),
	(559444, 128, '2014-03-01 00:43:46.000000', 'consum', 0.0224, 'lps'),
	(559445, 128, '2014-03-01 00:43:47.000000', 'consum', 0.0216, 'lps'),
	(559446, 128, '2014-03-01 00:43:48.000000', 'consum', 0.0222, 'lps'),
	(559447, 128, '2014-03-01 00:43:49.000000', 'consum', 0.0230, 'lps'),
	(559448, 128, '2014-03-01 00:43:50.000000', 'consum', 0.0222, 'lps'),
	(559449, 128, '2014-03-01 00:43:51.000000', 'consum', 0.0213, 'lps'),
	(559450, 128, '2014-03-01 00:43:52.000000', 'consum', 0.0212, 'lps'),
	(559451, 128, '2014-03-01 00:43:53.000000', 'consum', 0.0213, 'lps'),
	(559452, 128, '2014-03-01 00:43:54.000000', 'consum', 0.0221, 'lps'),
	(559453, 128, '2014-03-01 00:43:55.000000', 'consum', 0.0229, 'lps'),
	(559454, 128, '2014-03-01 00:43:56.000000', 'consum', 0.0222, 'lps'),
	(559455, 128, '2014-03-01 00:43:57.000000', 'consum', 0.0215, 'lps'),
	(559456, 128, '2014-03-01 00:43:58.000000', 'consum', 0.0223, 'lps'),
	(559457, 128, '2014-03-01 00:43:59.000000', 'consum', 0.0212, 'lps'),
	(559458, 128, '2014-03-01 00:44:00.000000', 'consum', 0.0233, 'lps'),
	(559459, 128, '2014-03-01 00:44:01.000000', 'consum', 0.0217, 'lps'),
	(559460, 128, '2014-03-01 00:44:02.000000', 'consum', 0.0226, 'lps'),
	(559461, 128, '2014-03-01 00:44:03.000000', 'consum', 0.0221, 'lps'),
	(559462, 128, '2014-03-01 00:44:04.000000', 'consum', 0.0218, 'lps'),
	(559463, 128, '2014-03-01 00:44:05.000000', 'consum', 0.0218, 'lps'),
	(559464, 128, '2014-03-01 00:44:06.000000', 'consum', 0.0225, 'lps'),
	(559465, 128, '2014-03-01 00:44:07.000000', 'consum', 0.0211, 'lps'),
	(559466, 128, '2014-03-01 00:44:08.000000', 'consum', 0.0221, 'lps'),
	(559467, 128, '2014-03-01 00:44:09.000000', 'consum', 0.0214, 'lps'),
	(559468, 128, '2014-03-01 00:44:10.000000', 'consum', 0.0221, 'lps'),
	(559469, 128, '2014-03-01 00:44:11.000000', 'consum', 0.0229, 'lps'),
	(559470, 128, '2014-03-01 00:44:12.000000', 'consum', 0.0224, 'lps'),
	(559471, 128, '2014-03-01 00:44:13.000000', 'consum', 0.0222, 'lps'),
	(559472, 128, '2014-03-01 00:44:14.000000', 'consum', 0.0230, 'lps'),
	(559473, 128, '2014-03-01 00:44:15.000000', 'consum', 0.0222, 'lps'),
	(559474, 128, '2014-03-01 00:44:16.000000', 'consum', 0.0213, 'lps'),
	(559475, 128, '2014-03-01 00:44:17.000000', 'consum', 0.0212, 'lps'),
	(559476, 128, '2014-03-01 00:44:18.000000', 'consum', 0.0213, 'lps'),
	(559477, 128, '2014-03-01 00:44:19.000000', 'consum', 0.0218, 'lps'),
	(559478, 128, '2014-03-01 00:44:20.000000', 'consum', 0.0217, 'lps'),
	(559479, 128, '2014-03-01 00:44:21.000000', 'consum', 0.0220, 'lps'),
	(559480, 128, '2014-03-01 00:44:22.000000', 'consum', 0.0217, 'lps'),
	(559481, 128, '2014-03-01 00:44:23.000000', 'consum', 0.0216, 'lps'),
	(559482, 128, '2014-03-01 00:44:24.000000', 'consum', 0.0219, 'lps'),
	(559483, 128, '2014-03-01 00:44:25.000000', 'consum', 0.0213, 'lps'),
	(559484, 128, '2014-03-01 00:44:26.000000', 'consum', 0.0221, 'lps'),
	(559485, 128, '2014-03-01 00:44:27.000000', 'consum', 0.0210, 'lps'),
	(559486, 128, '2014-03-01 00:44:28.000000', 'consum', 0.0225, 'lps'),
	(559487, 128, '2014-03-01 00:44:29.000000', 'consum', 0.0211, 'lps'),
	(559488, 128, '2014-03-01 00:44:30.000000', 'consum', 0.0219, 'lps'),
	(559489, 128, '2014-03-01 00:44:31.000000', 'consum', 0.0227, 'lps'),
	(559490, 128, '2014-03-01 00:44:32.000000', 'consum', 0.0218, 'lps'),
	(559491, 128, '2014-03-01 00:44:33.000000', 'consum', 0.0224, 'lps'),
	(559492, 128, '2014-03-01 00:44:34.000000', 'consum', 0.0234, 'lps'),
	(559493, 128, '2014-03-01 00:44:35.000000', 'consum', 0.0211, 'lps'),
	(559494, 128, '2014-03-01 00:44:36.000000', 'consum', 0.0218, 'lps'),
	(559495, 128, '2014-03-01 00:44:37.000000', 'consum', 0.0222, 'lps'),
	(559496, 128, '2014-03-01 00:44:38.000000', 'consum', 0.0224, 'lps'),
	(559497, 128, '2014-03-01 00:44:39.000000', 'consum', 0.0219, 'lps'),
	(559498, 128, '2014-03-01 00:44:40.000000', 'consum', 0.0215, 'lps'),
	(559499, 128, '2014-03-01 00:44:41.000000', 'consum', 0.0233, 'lps'),
	(559500, 128, '2014-03-01 00:44:42.000000', 'consum', 0.0210, 'lps'),
	(559501, 128, '2014-03-01 00:44:43.000000', 'consum', 0.0215, 'lps'),
	(559502, 128, '2014-03-01 00:44:44.000000', 'consum', 0.0213, 'lps'),
	(559503, 128, '2014-03-01 00:44:45.000000', 'consum', 0.0210, 'lps'),
	(559504, 128, '2014-03-01 00:44:46.000000', 'consum', 0.0224, 'lps'),
	(559505, 128, '2014-03-01 00:44:47.000000', 'consum', 0.0234, 'lps'),
	(559506, 128, '2014-03-01 00:44:48.000000', 'consum', 0.0211, 'lps'),
	(559507, 128, '2014-03-01 00:44:49.000000', 'consum', 0.0221, 'lps'),
	(559508, 128, '2014-03-01 00:44:50.000000', 'consum', 0.0211, 'lps'),
	(559509, 128, '2014-03-01 00:44:51.000000', 'consum', 0.0234, 'lps'),
	(559510, 128, '2014-03-01 00:44:52.000000', 'consum', 0.0225, 'lps'),
	(559511, 128, '2014-03-01 00:44:53.000000', 'consum', 0.0215, 'lps'),
	(559512, 128, '2014-03-01 00:44:54.000000', 'consum', 0.0214, 'lps'),
	(559513, 128, '2014-03-01 00:44:55.000000', 'consum', 0.0217, 'lps'),
	(559514, 128, '2014-03-01 00:44:56.000000', 'consum', 0.0234, 'lps'),
	(559515, 128, '2014-03-01 00:44:57.000000', 'consum', 0.0210, 'lps'),
	(559516, 128, '2014-03-01 00:44:58.000000', 'consum', 0.0211, 'lps'),
	(559517, 128, '2014-03-01 00:44:59.000000', 'consum', 0.0215, 'lps'),
	(559518, 128, '2014-03-01 00:45:00.000000', 'consum', 0.0233, 'lps'),
	(559519, 128, '2014-03-01 00:45:01.000000', 'consum', 0.0234, 'lps'),
	(559520, 128, '2014-03-01 00:45:02.000000', 'consum', 0.0214, 'lps'),
	(559521, 128, '2014-03-01 00:45:03.000000', 'consum', 0.0234, 'lps'),
	(559522, 128, '2014-03-01 00:45:04.000000', 'consum', 0.0216, 'lps'),
	(559523, 128, '2014-03-01 00:45:05.000000', 'consum', 0.0218, 'lps'),
	(559524, 128, '2014-03-01 00:45:06.000000', 'consum', 0.0233, 'lps'),
	(559525, 128, '2014-03-01 00:45:07.000000', 'consum', 0.0227, 'lps'),
	(559526, 128, '2014-03-01 00:45:08.000000', 'consum', 0.0227, 'lps'),
	(559527, 128, '2014-03-01 00:45:09.000000', 'consum', 0.0221, 'lps'),
	(559528, 128, '2014-03-01 00:45:10.000000', 'consum', 0.0211, 'lps'),
	(559529, 128, '2014-03-01 00:45:11.000000', 'consum', 0.0210, 'lps'),
	(559530, 128, '2014-03-01 00:45:12.000000', 'consum', 0.0232, 'lps'),
	(559531, 128, '2014-03-01 00:45:13.000000', 'consum', 0.0222, 'lps'),
	(559532, 128, '2014-03-01 00:45:14.000000', 'consum', 0.0228, 'lps'),
	(559533, 128, '2014-03-01 00:45:15.000000', 'consum', 0.0215, 'lps'),
	(559534, 128, '2014-03-01 00:45:16.000000', 'consum', 0.0230, 'lps'),
	(559535, 128, '2014-03-01 00:45:17.000000', 'consum', 0.0223, 'lps'),
	(559536, 128, '2014-03-01 00:45:18.000000', 'consum', 0.0215, 'lps'),
	(559537, 128, '2014-03-01 00:45:19.000000', 'consum', 0.0222, 'lps'),
	(559538, 128, '2014-03-01 00:45:20.000000', 'consum', 0.0228, 'lps'),
	(559539, 128, '2014-03-01 00:45:21.000000', 'consum', 0.0216, 'lps'),
	(559540, 128, '2014-03-01 00:45:22.000000', 'consum', 0.0210, 'lps'),
	(559541, 128, '2014-03-01 00:45:23.000000', 'consum', 0.0218, 'lps'),
	(559542, 128, '2014-03-01 00:45:24.000000', 'consum', 0.0225, 'lps'),
	(559543, 128, '2014-03-01 00:45:25.000000', 'consum', 0.0210, 'lps'),
	(559544, 128, '2014-03-01 00:45:26.000000', 'consum', 0.0217, 'lps'),
	(559545, 128, '2014-03-01 00:45:27.000000', 'consum', 0.0222, 'lps'),
	(559546, 128, '2014-03-01 00:45:28.000000', 'consum', 0.0225, 'lps'),
	(559547, 128, '2014-03-01 00:45:29.000000', 'consum', 0.0223, 'lps'),
	(559548, 128, '2014-03-01 00:45:30.000000', 'consum', 0.0233, 'lps'),
	(559549, 128, '2014-03-01 00:45:31.000000', 'consum', 0.0234, 'lps'),
	(559550, 128, '2014-03-01 00:45:32.000000', 'consum', 0.0214, 'lps'),
	(559551, 128, '2014-03-01 00:45:33.000000', 'consum', 0.0231, 'lps'),
	(559552, 128, '2014-03-01 00:45:34.000000', 'consum', 0.0231, 'lps'),
	(559553, 128, '2014-03-01 00:45:35.000000', 'consum', 0.0228, 'lps'),
	(559554, 128, '2014-03-01 00:45:36.000000', 'consum', 0.0210, 'lps'),
	(559555, 128, '2014-03-01 00:45:37.000000', 'consum', 0.0233, 'lps'),
	(559556, 128, '2014-03-01 00:45:38.000000', 'consum', 0.0225, 'lps'),
	(559557, 128, '2014-03-01 00:45:39.000000', 'consum', 0.0217, 'lps'),
	(559558, 128, '2014-03-01 00:45:40.000000', 'consum', 0.0224, 'lps'),
	(559559, 128, '2014-03-01 00:45:41.000000', 'consum', 0.0234, 'lps'),
	(559560, 128, '2014-03-01 00:45:42.000000', 'consum', 0.0213, 'lps'),
	(559561, 128, '2014-03-01 00:45:43.000000', 'consum', 0.0228, 'lps'),
	(559562, 128, '2014-03-01 00:45:44.000000', 'consum', 0.0219, 'lps'),
	(559563, 128, '2014-03-01 00:45:45.000000', 'consum', 0.0227, 'lps'),
	(559564, 128, '2014-03-01 00:45:46.000000', 'consum', 0.0218, 'lps'),
	(559565, 128, '2014-03-01 00:45:47.000000', 'consum', 0.0224, 'lps'),
	(559566, 128, '2014-03-01 00:45:48.000000', 'consum', 0.0232, 'lps'),
	(559567, 128, '2014-03-01 00:45:49.000000', 'consum', 0.0228, 'lps'),
	(559568, 128, '2014-03-01 00:45:50.000000', 'consum', 0.0210, 'lps'),
	(559569, 128, '2014-03-01 00:45:51.000000', 'consum', 0.0230, 'lps'),
	(559570, 128, '2014-03-01 00:45:52.000000', 'consum', 0.0210, 'lps'),
	(559571, 128, '2014-03-01 00:45:53.000000', 'consum', 0.0228, 'lps'),
	(559572, 128, '2014-03-01 00:45:54.000000', 'consum', 0.0226, 'lps'),
	(559573, 128, '2014-03-01 00:45:55.000000', 'consum', 0.0211, 'lps'),
	(559574, 128, '2014-03-01 00:45:56.000000', 'consum', 0.0218, 'lps'),
	(559575, 128, '2014-03-01 00:45:57.000000', 'consum', 0.0221, 'lps'),
	(559576, 128, '2014-03-01 00:45:58.000000', 'consum', 0.0218, 'lps'),
	(559577, 128, '2014-03-01 00:45:59.000000', 'consum', 0.0218, 'lps'),
	(559578, 128, '2014-03-01 00:46:00.000000', 'consum', 0.0225, 'lps'),
	(559579, 128, '2014-03-01 00:46:01.000000', 'consum', 0.0213, 'lps'),
	(559580, 128, '2014-03-01 00:46:02.000000', 'consum', 0.0231, 'lps'),
	(559581, 128, '2014-03-01 00:46:03.000000', 'consum', 0.0230, 'lps'),
	(559582, 128, '2014-03-01 00:46:04.000000', 'consum', 0.0222, 'lps'),
	(559583, 128, '2014-03-01 00:46:05.000000', 'consum', 0.0211, 'lps'),
	(559584, 128, '2014-03-01 00:46:06.000000', 'consum', 0.0232, 'lps'),
	(559585, 128, '2014-03-01 00:46:07.000000', 'consum', 0.0214, 'lps'),
	(559586, 128, '2014-03-01 00:46:08.000000', 'consum', 0.0215, 'lps'),
	(559587, 128, '2014-03-01 00:46:09.000000', 'consum', 0.0223, 'lps'),
	(559588, 128, '2014-03-01 00:46:10.000000', 'consum', 0.0211, 'lps'),
	(559589, 128, '2014-03-01 00:46:11.000000', 'consum', 0.0227, 'lps'),
	(559590, 128, '2014-03-01 00:46:12.000000', 'consum', 0.0215, 'lps'),
	(559591, 128, '2014-03-01 00:46:13.000000', 'consum', 0.0213, 'lps'),
	(559592, 128, '2014-03-01 00:46:14.000000', 'consum', 0.0210, 'lps'),
	(559593, 128, '2014-03-01 00:46:15.000000', 'consum', 0.0226, 'lps'),
	(559594, 128, '2014-03-01 00:46:16.000000', 'consum', 0.0216, 'lps'),
	(559595, 128, '2014-03-01 00:46:17.000000', 'consum', 0.0219, 'lps'),
	(559596, 128, '2014-03-01 00:46:18.000000', 'consum', 0.0210, 'lps'),
	(559597, 128, '2014-03-01 00:46:19.000000', 'consum', 0.0211, 'lps'),
	(559598, 128, '2014-03-01 00:46:20.000000', 'consum', 0.0216, 'lps'),
	(559599, 128, '2014-03-01 00:46:21.000000', 'consum', 0.0210, 'lps'),
	(559600, 128, '2014-03-01 00:46:22.000000', 'consum', 0.0218, 'lps'),
	(559601, 128, '2014-03-01 00:46:23.000000', 'consum', 0.0227, 'lps'),
	(559602, 128, '2014-03-01 00:46:24.000000', 'consum', 0.0219, 'lps'),
	(559603, 128, '2014-03-01 00:46:25.000000', 'consum', 0.0231, 'lps'),
	(559604, 128, '2014-03-01 00:46:26.000000', 'consum', 0.0214, 'lps'),
	(559605, 128, '2014-03-01 00:46:27.000000', 'consum', 0.0218, 'lps'),
	(559606, 128, '2014-03-01 00:46:28.000000', 'consum', 0.0215, 'lps'),
	(559607, 128, '2014-03-01 00:46:29.000000', 'consum', 0.0233, 'lps'),
	(559608, 128, '2014-03-01 00:46:30.000000', 'consum', 0.0212, 'lps'),
	(559609, 128, '2014-03-01 00:46:31.000000', 'consum', 0.0225, 'lps'),
	(559610, 128, '2014-03-01 00:46:32.000000', 'consum', 0.0230, 'lps'),
	(559611, 128, '2014-03-01 00:46:33.000000', 'consum', 0.0218, 'lps'),
	(559612, 128, '2014-03-01 00:46:34.000000', 'consum', 0.0213, 'lps'),
	(559613, 128, '2014-03-01 00:46:35.000000', 'consum', 0.0228, 'lps'),
	(559614, 128, '2014-03-01 00:46:36.000000', 'consum', 0.0217, 'lps'),
	(559615, 128, '2014-03-01 00:46:37.000000', 'consum', 0.0218, 'lps'),
	(559616, 128, '2014-03-01 00:46:38.000000', 'consum', 0.0227, 'lps'),
	(559617, 128, '2014-03-01 00:46:39.000000', 'consum', 0.0223, 'lps'),
	(559618, 128, '2014-03-01 00:46:40.000000', 'consum', 0.0222, 'lps'),
	(559619, 128, '2014-03-01 00:46:41.000000', 'consum', 0.0234, 'lps'),
	(559620, 128, '2014-03-01 00:46:42.000000', 'consum', 0.0217, 'lps'),
	(559621, 128, '2014-03-01 00:46:43.000000', 'consum', 0.0226, 'lps'),
	(559622, 128, '2014-03-01 00:46:44.000000', 'consum', 0.0217, 'lps'),
	(559623, 128, '2014-03-01 00:46:45.000000', 'consum', 0.0223, 'lps'),
	(559624, 128, '2014-03-01 00:46:46.000000', 'consum', 0.0231, 'lps'),
	(559625, 128, '2014-03-01 00:46:47.000000', 'consum', 0.0225, 'lps'),
	(559626, 128, '2014-03-01 00:46:48.000000', 'consum', 0.0223, 'lps'),
	(559627, 128, '2014-03-01 00:46:49.000000', 'consum', 0.0230, 'lps'),
	(559628, 128, '2014-03-01 00:46:50.000000', 'consum', 0.0221, 'lps'),
	(559629, 128, '2014-03-01 00:46:51.000000', 'consum', 0.0231, 'lps'),
	(559630, 128, '2014-03-01 00:46:52.000000', 'consum', 0.0233, 'lps'),
	(559631, 128, '2014-03-01 00:46:53.000000', 'consum', 0.0212, 'lps'),
	(559632, 128, '2014-03-01 00:46:54.000000', 'consum', 0.0227, 'lps'),
	(559633, 128, '2014-03-01 00:46:55.000000', 'consum', 0.0214, 'lps'),
	(559634, 128, '2014-03-01 00:46:56.000000', 'consum', 0.0231, 'lps'),
	(559635, 128, '2014-03-01 00:46:57.000000', 'consum', 0.0229, 'lps'),
	(559636, 128, '2014-03-01 00:46:58.000000', 'consum', 0.0217, 'lps'),
	(559637, 128, '2014-03-01 00:46:59.000000', 'consum', 0.0212, 'lps'),
	(559638, 128, '2014-03-01 00:47:00.000000', 'consum', 0.0224, 'lps'),
	(559639, 128, '2014-03-01 00:47:01.000000', 'consum', 0.0228, 'lps'),
	(559640, 128, '2014-03-01 00:47:02.000000', 'consum', 0.0230, 'lps'),
	(559641, 128, '2014-03-01 00:47:03.000000', 'consum', 0.0231, 'lps'),
	(559642, 128, '2014-03-01 00:47:04.000000', 'consum', 0.0231, 'lps'),
	(559643, 128, '2014-03-01 00:47:05.000000', 'consum', 0.0227, 'lps'),
	(559644, 128, '2014-03-01 00:47:06.000000', 'consum', 0.0233, 'lps'),
	(559645, 128, '2014-03-01 00:47:07.000000', 'consum', 0.0223, 'lps'),
	(559646, 128, '2014-03-01 00:47:08.000000', 'consum', 0.0231, 'lps'),
	(559647, 128, '2014-03-01 00:47:09.000000', 'consum', 0.0230, 'lps'),
	(559648, 128, '2014-03-01 00:47:10.000000', 'consum', 0.0220, 'lps'),
	(559649, 128, '2014-03-01 00:47:11.000000', 'consum', 0.0225, 'lps'),
	(559650, 128, '2014-03-01 00:47:12.000000', 'consum', 0.0232, 'lps'),
	(559651, 128, '2014-03-01 00:47:13.000000', 'consum', 0.0226, 'lps'),
	(559652, 128, '2014-03-01 00:47:14.000000', 'consum', 0.0222, 'lps'),
	(559653, 128, '2014-03-01 00:47:15.000000', 'consum', 0.0223, 'lps'),
	(559654, 128, '2014-03-01 00:47:16.000000', 'consum', 0.0214, 'lps'),
	(559655, 128, '2014-03-01 00:47:17.000000', 'consum', 0.0218, 'lps'),
	(559656, 128, '2014-03-01 00:47:18.000000', 'consum', 0.0212, 'lps'),
	(559657, 128, '2014-03-01 00:47:19.000000', 'consum', 0.0220, 'lps'),
	(559658, 128, '2014-03-01 00:47:20.000000', 'consum', 0.0231, 'lps'),
	(559659, 128, '2014-03-01 00:47:21.000000', 'consum', 0.0212, 'lps'),
	(559660, 128, '2014-03-01 00:47:22.000000', 'consum', 0.0233, 'lps'),
	(559661, 128, '2014-03-01 00:47:23.000000', 'consum', 0.0219, 'lps'),
	(559662, 128, '2014-03-01 00:47:24.000000', 'consum', 0.0212, 'lps'),
	(559663, 128, '2014-03-01 00:47:25.000000', 'consum', 0.0219, 'lps'),
	(559664, 128, '2014-03-01 00:47:26.000000', 'consum', 0.0222, 'lps'),
	(559665, 128, '2014-03-01 00:47:27.000000', 'consum', 0.0218, 'lps'),
	(559666, 128, '2014-03-01 00:47:28.000000', 'consum', 0.0216, 'lps'),
	(559667, 128, '2014-03-01 00:47:29.000000', 'consum', 0.0218, 'lps'),
	(559668, 128, '2014-03-01 00:47:30.000000', 'consum', 0.0231, 'lps'),
	(559669, 128, '2014-03-01 00:47:31.000000', 'consum', 0.0215, 'lps'),
	(559670, 128, '2014-03-01 00:47:32.000000', 'consum', 0.0223, 'lps'),
	(559671, 128, '2014-03-01 00:47:33.000000', 'consum', 0.0210, 'lps'),
	(559672, 128, '2014-03-01 00:47:34.000000', 'consum', 0.0221, 'lps'),
	(559673, 128, '2014-03-01 00:47:35.000000', 'consum', 0.0215, 'lps'),
	(559674, 128, '2014-03-01 00:47:36.000000', 'consum', 0.0227, 'lps'),
	(559675, 128, '2014-03-01 00:47:37.000000', 'consum', 0.0233, 'lps'),
	(559676, 128, '2014-03-01 00:47:38.000000', 'consum', 0.0223, 'lps'),
	(559677, 128, '2014-03-01 00:47:39.000000', 'consum', 0.0233, 'lps'),
	(559678, 128, '2014-03-01 00:47:40.000000', 'consum', 0.0234, 'lps'),
	(559679, 128, '2014-03-01 00:47:41.000000', 'consum', 0.0214, 'lps'),
	(559680, 128, '2014-03-01 00:47:42.000000', 'consum', 0.0210, 'lps'),
	(559681, 128, '2014-03-01 00:47:43.000000', 'consum', 0.0221, 'lps'),
	(559682, 128, '2014-03-01 00:47:44.000000', 'consum', 0.0214, 'lps'),
	(559683, 128, '2014-03-01 00:47:45.000000', 'consum', 0.0225, 'lps'),
	(559684, 128, '2014-03-01 00:47:46.000000', 'consum', 0.0224, 'lps'),
	(559685, 128, '2014-03-01 00:47:47.000000', 'consum', 0.0233, 'lps'),
	(559686, 128, '2014-03-01 00:47:48.000000', 'consum', 0.0234, 'lps'),
	(559687, 128, '2014-03-01 00:47:49.000000', 'consum', 0.0211, 'lps'),
	(559688, 128, '2014-03-01 00:47:50.000000', 'consum', 0.0219, 'lps'),
	(559689, 128, '2014-03-01 00:47:51.000000', 'consum', 0.0226, 'lps'),
	(559690, 128, '2014-03-01 00:47:52.000000', 'consum', 0.0216, 'lps'),
	(559691, 128, '2014-03-01 00:47:53.000000', 'consum', 0.0218, 'lps'),
	(559692, 128, '2014-03-01 00:47:54.000000', 'consum', 0.0230, 'lps'),
	(559693, 128, '2014-03-01 00:47:55.000000', 'consum', 0.0213, 'lps'),
	(559694, 128, '2014-03-01 00:47:56.000000', 'consum', 0.0214, 'lps'),
	(559695, 128, '2014-03-01 00:47:57.000000', 'consum', 0.0223, 'lps'),
	(559696, 128, '2014-03-01 00:47:58.000000', 'consum', 0.0211, 'lps'),
	(559697, 128, '2014-03-01 00:47:59.000000', 'consum', 0.0228, 'lps'),
	(559698, 128, '2014-03-01 00:48:00.000000', 'consum', 0.0224, 'lps'),
	(559699, 128, '2014-03-01 00:48:01.000000', 'consum', 0.0225, 'lps'),
	(559700, 128, '2014-03-01 00:48:02.000000', 'consum', 0.0221, 'lps'),
	(559701, 128, '2014-03-01 00:48:03.000000', 'consum', 0.0219, 'lps'),
	(559702, 128, '2014-03-01 00:48:04.000000', 'consum', 0.0221, 'lps'),
	(559703, 128, '2014-03-01 00:48:05.000000', 'consum', 0.0213, 'lps'),
	(559704, 128, '2014-03-01 00:48:06.000000', 'consum', 0.0217, 'lps'),
	(559705, 128, '2014-03-01 00:48:07.000000', 'consum', 0.0213, 'lps'),
	(559706, 128, '2014-03-01 00:48:08.000000', 'consum', 0.0229, 'lps'),
	(559707, 128, '2014-03-01 00:48:09.000000', 'consum', 0.0221, 'lps'),
	(559708, 128, '2014-03-01 00:48:10.000000', 'consum', 0.0234, 'lps'),
	(559709, 128, '2014-03-01 00:48:11.000000', 'consum', 0.0222, 'lps'),
	(559710, 128, '2014-03-01 00:48:12.000000', 'consum', 0.0222, 'lps'),
	(559711, 128, '2014-03-01 00:48:13.000000', 'consum', 0.0212, 'lps'),
	(559712, 128, '2014-03-01 00:48:14.000000', 'consum', 0.0210, 'lps'),
	(559713, 128, '2014-03-01 00:48:15.000000', 'consum', 0.0227, 'lps'),
	(559714, 128, '2014-03-01 00:48:16.000000', 'consum', 0.0220, 'lps'),
	(559715, 128, '2014-03-01 00:48:17.000000', 'consum', 0.0210, 'lps'),
	(559716, 128, '2014-03-01 00:48:18.000000', 'consum', 0.0232, 'lps'),
	(559717, 128, '2014-03-01 00:48:19.000000', 'consum', 0.0221, 'lps'),
	(559718, 128, '2014-03-01 00:48:20.000000', 'consum', 0.0222, 'lps'),
	(559719, 128, '2014-03-01 00:48:21.000000', 'consum', 0.0214, 'lps'),
	(559720, 128, '2014-03-01 00:48:22.000000', 'consum', 0.0220, 'lps'),
	(559721, 128, '2014-03-01 00:48:23.000000', 'consum', 0.0224, 'lps'),
	(559722, 128, '2014-03-01 00:48:24.000000', 'consum', 0.0226, 'lps'),
	(559723, 128, '2014-03-01 00:48:25.000000', 'consum', 0.0221, 'lps'),
	(559724, 128, '2014-03-01 00:48:26.000000', 'consum', 0.0218, 'lps'),
	(559725, 128, '2014-03-01 00:48:27.000000', 'consum', 0.0218, 'lps'),
	(559726, 128, '2014-03-01 00:48:28.000000', 'consum', 0.0227, 'lps'),
	(559727, 128, '2014-03-01 00:48:29.000000', 'consum', 0.0222, 'lps'),
	(559728, 128, '2014-03-01 00:48:30.000000', 'consum', 0.0219, 'lps'),
	(559729, 128, '2014-03-01 00:48:31.000000', 'consum', 0.0220, 'lps'),
	(559730, 128, '2014-03-01 00:48:32.000000', 'consum', 0.0233, 'lps'),
	(559731, 128, '2014-03-01 00:48:33.000000', 'consum', 0.0220, 'lps'),
	(559732, 128, '2014-03-01 00:48:34.000000', 'consum', 0.0217, 'lps'),
	(559733, 128, '2014-03-01 00:48:35.000000', 'consum', 0.0217, 'lps'),
	(559734, 128, '2014-03-01 00:48:36.000000', 'consum', 0.0223, 'lps'),
	(559735, 128, '2014-03-01 00:48:37.000000', 'consum', 0.0229, 'lps'),
	(559736, 128, '2014-03-01 00:48:38.000000', 'consum', 0.0216, 'lps'),
	(559737, 128, '2014-03-01 00:48:39.000000', 'consum', 0.0211, 'lps'),
	(559738, 128, '2014-03-01 00:48:40.000000', 'consum', 0.0220, 'lps'),
	(559739, 128, '2014-03-01 00:48:41.000000', 'consum', 0.0233, 'lps'),
	(559740, 128, '2014-03-01 00:48:42.000000', 'consum', 0.0220, 'lps'),
	(559741, 128, '2014-03-01 00:48:43.000000', 'consum', 0.0215, 'lps'),
	(559742, 128, '2014-03-01 00:48:44.000000', 'consum', 0.0232, 'lps'),
	(559743, 128, '2014-03-01 00:48:45.000000', 'consum', 0.0231, 'lps'),
	(559744, 128, '2014-03-01 00:48:46.000000', 'consum', 0.0226, 'lps'),
	(559745, 128, '2014-03-01 00:48:47.000000', 'consum', 0.0227, 'lps'),
	(559746, 128, '2014-03-01 00:48:48.000000', 'consum', 0.0223, 'lps'),
	(559747, 128, '2014-03-01 00:48:49.000000', 'consum', 0.0222, 'lps'),
	(559748, 128, '2014-03-01 00:48:50.000000', 'consum', 0.0231, 'lps'),
	(559749, 128, '2014-03-01 00:48:51.000000', 'consum', 0.0233, 'lps'),
	(559750, 128, '2014-03-01 00:48:52.000000', 'consum', 0.0210, 'lps'),
	(559751, 128, '2014-03-01 00:48:53.000000', 'consum', 0.0217, 'lps'),
	(559752, 128, '2014-03-01 00:48:54.000000', 'consum', 0.0222, 'lps'),
	(559753, 128, '2014-03-01 00:48:55.000000', 'consum', 0.0222, 'lps'),
	(559754, 128, '2014-03-01 00:48:56.000000', 'consum', 0.0233, 'lps'),
	(559755, 128, '2014-03-01 00:48:57.000000', 'consum', 0.0218, 'lps'),
	(559756, 128, '2014-03-01 00:48:58.000000', 'consum', 0.0232, 'lps'),
	(559757, 128, '2014-03-01 00:48:59.000000', 'consum', 0.0219, 'lps'),
	(559758, 128, '2014-03-01 00:49:00.000000', 'consum', 0.0217, 'lps'),
	(559759, 128, '2014-03-01 00:49:01.000000', 'consum', 0.0219, 'lps'),
	(559760, 128, '2014-03-01 00:49:02.000000', 'consum', 0.0234, 'lps'),
	(559761, 128, '2014-03-01 00:49:03.000000', 'consum', 0.0226, 'lps'),
	(559762, 128, '2014-03-01 00:49:04.000000', 'consum', 0.0220, 'lps'),
	(559763, 128, '2014-03-01 00:49:05.000000', 'consum', 0.0214, 'lps'),
	(559764, 128, '2014-03-01 00:49:06.000000', 'consum', 0.0226, 'lps'),
	(559765, 128, '2014-03-01 00:49:07.000000', 'consum', 0.0227, 'lps'),
	(559766, 128, '2014-03-01 00:49:08.000000', 'consum', 0.0225, 'lps'),
	(559767, 128, '2014-03-01 00:49:09.000000', 'consum', 0.0231, 'lps'),
	(559768, 128, '2014-03-01 00:49:10.000000', 'consum', 0.0223, 'lps'),
	(559769, 128, '2014-03-01 00:49:11.000000', 'consum', 0.0213, 'lps'),
	(559770, 128, '2014-03-01 00:49:12.000000', 'consum', 0.0210, 'lps'),
	(559771, 128, '2014-03-01 00:49:13.000000', 'consum', 0.0226, 'lps'),
	(559772, 128, '2014-03-01 00:49:14.000000', 'consum', 0.0216, 'lps'),
	(559773, 128, '2014-03-01 00:49:15.000000', 'consum', 0.0219, 'lps'),
	(559774, 128, '2014-03-01 00:49:16.000000', 'consum', 0.0214, 'lps'),
	(559775, 128, '2014-03-01 00:49:17.000000', 'consum', 0.0225, 'lps'),
	(559776, 128, '2014-03-01 00:49:18.000000', 'consum', 0.0224, 'lps'),
	(559777, 128, '2014-03-01 00:49:19.000000', 'consum', 0.0234, 'lps'),
	(559778, 128, '2014-03-01 00:49:20.000000', 'consum', 0.0214, 'lps'),
	(559779, 128, '2014-03-01 00:49:21.000000', 'consum', 0.0210, 'lps'),
	(559780, 128, '2014-03-01 00:49:22.000000', 'consum', 0.0225, 'lps'),
	(559781, 128, '2014-03-01 00:49:23.000000', 'consum', 0.0234, 'lps'),
	(559782, 128, '2014-03-01 00:49:24.000000', 'consum', 0.0234, 'lps'),
	(559783, 128, '2014-03-01 00:49:25.000000', 'consum', 0.0212, 'lps'),
	(559784, 128, '2014-03-01 00:49:26.000000', 'consum', 0.0220, 'lps'),
	(559785, 128, '2014-03-01 00:49:27.000000', 'consum', 0.0232, 'lps'),
	(559786, 128, '2014-03-01 00:49:28.000000', 'consum', 0.0216, 'lps'),
	(559787, 128, '2014-03-01 00:49:29.000000', 'consum', 0.0223, 'lps'),
	(559788, 128, '2014-03-01 00:49:30.000000', 'consum', 0.0233, 'lps'),
	(559789, 128, '2014-03-01 00:49:31.000000', 'consum', 0.0210, 'lps'),
	(559790, 128, '2014-03-01 00:49:32.000000', 'consum', 0.0218, 'lps'),
	(559791, 128, '2014-03-01 00:49:33.000000', 'consum', 0.0224, 'lps'),
	(559792, 128, '2014-03-01 00:49:34.000000', 'consum', 0.0231, 'lps'),
	(559793, 128, '2014-03-01 00:49:35.000000', 'consum', 0.0222, 'lps'),
	(559794, 128, '2014-03-01 00:49:36.000000', 'consum', 0.0211, 'lps'),
	(559795, 128, '2014-03-01 00:49:37.000000', 'consum', 0.0227, 'lps'),
	(559796, 128, '2014-03-01 00:49:38.000000', 'consum', 0.0216, 'lps'),
	(559797, 128, '2014-03-01 00:49:39.000000', 'consum', 0.0218, 'lps'),
	(559798, 128, '2014-03-01 00:49:40.000000', 'consum', 0.0232, 'lps'),
	(559799, 128, '2014-03-01 00:49:41.000000', 'consum', 0.0220, 'lps'),
	(559800, 128, '2014-03-01 00:49:42.000000', 'consum', 0.0218, 'lps'),
	(559801, 128, '2014-03-01 00:49:43.000000', 'consum', 0.0223, 'lps'),
	(559802, 128, '2014-03-01 00:49:44.000000', 'consum', 0.0225, 'lps'),
	(559803, 128, '2014-03-01 00:49:45.000000', 'consum', 0.0224, 'lps'),
	(559804, 128, '2014-03-01 00:49:46.000000', 'consum', 0.0234, 'lps'),
	(559805, 128, '2014-03-01 00:49:47.000000', 'consum', 0.0216, 'lps'),
	(559806, 128, '2014-03-01 00:49:48.000000', 'consum', 0.0215, 'lps'),
	(559807, 128, '2014-03-01 00:49:49.000000', 'consum', 0.0219, 'lps'),
	(559808, 128, '2014-03-01 00:49:50.000000', 'consum', 0.0214, 'lps'),
	(559809, 128, '2014-03-01 00:49:51.000000', 'consum', 0.0228, 'lps'),
	(559810, 128, '2014-03-01 00:49:52.000000', 'consum', 0.0216, 'lps'),
	(559811, 128, '2014-03-01 00:49:53.000000', 'consum', 0.0210, 'lps'),
	(559812, 128, '2014-03-01 00:49:54.000000', 'consum', 0.0219, 'lps'),
	(559813, 128, '2014-03-01 00:49:55.000000', 'consum', 0.0231, 'lps'),
	(559814, 128, '2014-03-01 00:49:56.000000', 'consum', 0.0212, 'lps'),
	(559815, 128, '2014-03-01 00:49:57.000000', 'consum', 0.0234, 'lps'),
	(559816, 128, '2014-03-01 00:49:58.000000', 'consum', 0.0223, 'lps'),
	(559817, 128, '2014-03-01 00:49:59.000000', 'consum', 0.0230, 'lps'),
	(559818, 128, '2014-03-01 00:50:00.000000', 'consum', 0.0220, 'lps'),
	(559819, 128, '2014-03-01 00:50:01.000000', 'consum', 0.0224, 'lps'),
	(559820, 128, '2014-03-01 00:50:02.000000', 'consum', 0.0227, 'lps'),
	(559821, 128, '2014-03-01 00:50:03.000000', 'consum', 0.0229, 'lps'),
	(559822, 128, '2014-03-01 00:50:04.000000', 'consum', 0.0228, 'lps'),
	(559823, 128, '2014-03-01 00:50:05.000000', 'consum', 0.0219, 'lps'),
	(559824, 128, '2014-03-01 00:50:06.000000', 'consum', 0.0227, 'lps'),
	(559825, 128, '2014-03-01 00:50:07.000000', 'consum', 0.0220, 'lps'),
	(559826, 128, '2014-03-01 00:50:08.000000', 'consum', 0.0232, 'lps'),
	(559827, 128, '2014-03-01 00:50:09.000000', 'consum', 0.0218, 'lps'),
	(559828, 128, '2014-03-01 00:50:10.000000', 'consum', 0.0233, 'lps'),
	(559829, 128, '2014-03-01 00:50:11.000000', 'consum', 0.0226, 'lps'),
	(559830, 128, '2014-03-01 00:50:12.000000', 'consum', 0.0222, 'lps'),
	(559831, 128, '2014-03-01 00:50:13.000000', 'consum', 0.0222, 'lps'),
	(559832, 128, '2014-03-01 00:50:14.000000', 'consum', 0.0212, 'lps'),
	(559833, 128, '2014-03-01 00:50:15.000000', 'consum', 0.0231, 'lps'),
	(559834, 128, '2014-03-01 00:50:16.000000', 'consum', 0.0211, 'lps'),
	(559835, 128, '2014-03-01 00:50:17.000000', 'consum', 0.0230, 'lps'),
	(559836, 128, '2014-03-01 00:50:18.000000', 'consum', 0.0229, 'lps'),
	(559837, 128, '2014-03-01 00:50:19.000000', 'consum', 0.0221, 'lps'),
	(559838, 128, '2014-03-01 00:50:20.000000', 'consum', 0.0233, 'lps'),
	(559839, 128, '2014-03-01 00:50:21.000000', 'consum', 0.0216, 'lps'),
	(559840, 128, '2014-03-01 00:50:22.000000', 'consum', 0.0223, 'lps'),
	(559841, 128, '2014-03-01 00:50:23.000000', 'consum', 0.0234, 'lps'),
	(559842, 128, '2014-03-01 00:50:24.000000', 'consum', 0.0218, 'lps'),
	(559843, 128, '2014-03-01 00:50:25.000000', 'consum', 0.0225, 'lps'),
	(559844, 128, '2014-03-01 00:50:26.000000', 'consum', 0.0212, 'lps'),
	(559845, 128, '2014-03-01 00:50:27.000000', 'consum', 0.0227, 'lps'),
	(559846, 128, '2014-03-01 00:50:28.000000', 'consum', 0.0216, 'lps'),
	(559847, 128, '2014-03-01 00:50:29.000000', 'consum', 0.0212, 'lps'),
	(559848, 128, '2014-03-01 00:50:30.000000', 'consum', 0.0226, 'lps'),
	(559849, 128, '2014-03-01 00:50:31.000000', 'consum', 0.0213, 'lps'),
	(559850, 128, '2014-03-01 00:50:32.000000', 'consum', 0.0225, 'lps'),
	(559851, 128, '2014-03-01 00:50:33.000000', 'consum', 0.0226, 'lps'),
	(559852, 128, '2014-03-01 00:50:34.000000', 'consum', 0.0222, 'lps'),
	(559853, 128, '2014-03-01 00:50:35.000000', 'consum', 0.0222, 'lps'),
	(559854, 128, '2014-03-01 00:50:36.000000', 'consum', 0.0212, 'lps'),
	(559855, 128, '2014-03-01 00:50:37.000000', 'consum', 0.0231, 'lps'),
	(559856, 128, '2014-03-01 00:50:38.000000', 'consum', 0.0213, 'lps'),
	(559857, 128, '2014-03-01 00:50:39.000000', 'consum', 0.0210, 'lps'),
	(559858, 128, '2014-03-01 00:50:40.000000', 'consum', 0.0228, 'lps'),
	(559859, 128, '2014-03-01 00:50:41.000000', 'consum', 0.0224, 'lps'),
	(559860, 128, '2014-03-01 00:50:42.000000', 'consum', 0.0228, 'lps'),
	(559861, 128, '2014-03-01 00:50:43.000000', 'consum', 0.0233, 'lps'),
	(559862, 128, '2014-03-01 00:50:44.000000', 'consum', 0.0221, 'lps'),
	(559863, 128, '2014-03-01 00:50:45.000000', 'consum', 0.0222, 'lps'),
	(559864, 128, '2014-03-01 00:50:46.000000', 'consum', 0.0214, 'lps'),
	(559865, 128, '2014-03-01 00:50:47.000000', 'consum', 0.0218, 'lps'),
	(559866, 128, '2014-03-01 00:50:48.000000', 'consum', 0.0212, 'lps'),
	(559867, 128, '2014-03-01 00:50:49.000000', 'consum', 0.0222, 'lps'),
	(559868, 128, '2014-03-01 00:50:50.000000', 'consum', 0.0215, 'lps'),
	(559869, 128, '2014-03-01 00:50:51.000000', 'consum', 0.0226, 'lps'),
	(559870, 128, '2014-03-01 00:50:52.000000', 'consum', 0.0223, 'lps'),
	(559871, 128, '2014-03-01 00:50:53.000000', 'consum', 0.0227, 'lps'),
	(559872, 128, '2014-03-01 00:50:54.000000', 'consum', 0.0234, 'lps'),
	(559873, 128, '2014-03-01 00:50:55.000000', 'consum', 0.0227, 'lps'),
	(559874, 128, '2014-03-01 00:50:56.000000', 'consum', 0.0225, 'lps'),
	(559875, 128, '2014-03-01 00:50:57.000000', 'consum', 0.0211, 'lps'),
	(559876, 128, '2014-03-01 00:50:58.000000', 'consum', 0.0220, 'lps'),
	(559877, 128, '2014-03-01 00:50:59.000000', 'consum', 0.0232, 'lps'),
	(559878, 128, '2014-03-01 00:51:00.000000', 'consum', 0.0217, 'lps'),
	(559879, 128, '2014-03-01 00:51:01.000000', 'consum', 0.0229, 'lps'),
	(559880, 128, '2014-03-01 00:51:02.000000', 'consum', 0.0233, 'lps'),
	(559881, 128, '2014-03-01 00:51:03.000000', 'consum', 0.0221, 'lps'),
	(559882, 128, '2014-03-01 00:51:04.000000', 'consum', 0.0219, 'lps'),
	(559883, 128, '2014-03-01 00:51:05.000000', 'consum', 0.0225, 'lps'),
	(559884, 128, '2014-03-01 00:51:06.000000', 'consum', 0.0234, 'lps'),
	(559885, 128, '2014-03-01 00:51:07.000000', 'consum', 0.0233, 'lps'),
	(559886, 128, '2014-03-01 00:51:08.000000', 'consum', 0.0230, 'lps'),
	(559887, 128, '2014-03-01 00:51:09.000000', 'consum', 0.0217, 'lps'),
	(559888, 128, '2014-03-01 00:51:10.000000', 'consum', 0.0233, 'lps'),
	(559889, 128, '2014-03-01 00:51:11.000000', 'consum', 0.0232, 'lps'),
	(559890, 128, '2014-03-01 00:51:12.000000', 'consum', 0.0227, 'lps'),
	(559891, 128, '2014-03-01 00:51:13.000000', 'consum', 0.0228, 'lps'),
	(559892, 128, '2014-03-01 00:51:14.000000', 'consum', 0.0224, 'lps'),
	(559893, 128, '2014-03-01 00:51:15.000000', 'consum', 0.0227, 'lps'),
	(559894, 128, '2014-03-01 00:51:16.000000', 'consum', 0.0230, 'lps'),
	(559895, 128, '2014-03-01 00:51:17.000000', 'consum', 0.0232, 'lps'),
	(559896, 128, '2014-03-01 00:51:18.000000', 'consum', 0.0210, 'lps'),
	(559897, 128, '2014-03-01 00:51:19.000000', 'consum', 0.0222, 'lps'),
	(559898, 128, '2014-03-01 00:51:20.000000', 'consum', 0.0220, 'lps'),
	(559899, 128, '2014-03-01 00:51:21.000000', 'consum', 0.0224, 'lps'),
	(559900, 128, '2014-03-01 00:51:22.000000', 'consum', 0.0226, 'lps'),
	(559901, 128, '2014-03-01 00:51:23.000000', 'consum', 0.0223, 'lps'),
	(559902, 128, '2014-03-01 00:51:24.000000', 'consum', 0.0229, 'lps'),
	(559903, 128, '2014-03-01 00:51:25.000000', 'consum', 0.0215, 'lps'),
	(559904, 128, '2014-03-01 00:51:26.000000', 'consum', 0.0229, 'lps'),
	(559905, 128, '2014-03-01 00:51:27.000000', 'consum', 0.0217, 'lps'),
	(559906, 128, '2014-03-01 00:51:28.000000', 'consum', 0.0214, 'lps'),
	(559907, 128, '2014-03-01 00:51:29.000000', 'consum', 0.0233, 'lps'),
	(559908, 128, '2014-03-01 00:51:30.000000', 'consum', 0.0216, 'lps'),
	(559909, 128, '2014-03-01 00:51:31.000000', 'consum', 0.0219, 'lps'),
	(559910, 128, '2014-03-01 00:51:32.000000', 'consum', 0.0213, 'lps'),
	(559911, 128, '2014-03-01 00:51:33.000000', 'consum', 0.0222, 'lps'),
	(559912, 128, '2014-03-01 00:51:34.000000', 'consum', 0.0215, 'lps'),
	(559913, 128, '2014-03-01 00:51:35.000000', 'consum', 0.0222, 'lps'),
	(559914, 128, '2014-03-01 00:51:36.000000', 'consum', 0.0230, 'lps'),
	(559915, 128, '2014-03-01 00:51:37.000000', 'consum', 0.0224, 'lps'),
	(559916, 128, '2014-03-01 00:51:38.000000', 'consum', 0.0223, 'lps'),
	(559917, 128, '2014-03-01 00:51:39.000000', 'consum', 0.0232, 'lps'),
	(559918, 128, '2014-03-01 00:51:40.000000', 'consum', 0.0234, 'lps'),
	(559919, 128, '2014-03-01 00:51:41.000000', 'consum', 0.0213, 'lps'),
	(559920, 128, '2014-03-01 00:51:42.000000', 'consum', 0.0226, 'lps'),
	(559921, 128, '2014-03-01 00:51:43.000000', 'consum', 0.0210, 'lps'),
	(559922, 128, '2014-03-01 00:51:44.000000', 'consum', 0.0211, 'lps'),
	(559923, 128, '2014-03-01 00:51:45.000000', 'consum', 0.0215, 'lps'),
	(559924, 128, '2014-03-01 00:51:46.000000', 'consum', 0.0231, 'lps'),
	(559925, 128, '2014-03-01 00:51:47.000000', 'consum', 0.0226, 'lps'),
	(559926, 128, '2014-03-01 00:51:48.000000', 'consum', 0.0229, 'lps'),
	(559927, 128, '2014-03-01 00:51:49.000000', 'consum', 0.0231, 'lps'),
	(559928, 128, '2014-03-01 00:51:50.000000', 'consum', 0.0233, 'lps'),
	(559929, 128, '2014-03-01 00:51:51.000000', 'consum', 0.0215, 'lps'),
	(559930, 128, '2014-03-01 00:51:52.000000', 'consum', 0.0214, 'lps'),
	(559931, 128, '2014-03-01 00:51:53.000000', 'consum', 0.0216, 'lps'),
	(559932, 128, '2014-03-01 00:51:54.000000', 'consum', 0.0228, 'lps'),
	(559933, 128, '2014-03-01 00:51:55.000000', 'consum', 0.0231, 'lps'),
	(559934, 128, '2014-03-01 00:51:56.000000', 'consum', 0.0213, 'lps'),
	(559935, 128, '2014-03-01 00:51:57.000000', 'consum', 0.0213, 'lps'),
	(559936, 128, '2014-03-01 00:51:58.000000', 'consum', 0.0217, 'lps'),
	(559937, 128, '2014-03-01 00:51:59.000000', 'consum', 0.0234, 'lps'),
	(559938, 128, '2014-03-01 00:52:00.000000', 'consum', 0.0212, 'lps'),
	(559939, 128, '2014-03-01 00:52:01.000000', 'consum', 0.0221, 'lps'),
	(559940, 128, '2014-03-01 00:52:02.000000', 'consum', 0.0210, 'lps'),
	(559941, 128, '2014-03-01 00:52:03.000000', 'consum', 0.0230, 'lps'),
	(559942, 128, '2014-03-01 00:52:04.000000', 'consum', 0.0210, 'lps'),
	(559943, 128, '2014-03-01 00:52:05.000000', 'consum', 0.0223, 'lps'),
	(559944, 128, '2014-03-01 00:52:06.000000', 'consum', 0.0226, 'lps'),
	(559945, 128, '2014-03-01 00:52:07.000000', 'consum', 0.0225, 'lps'),
	(559946, 128, '2014-03-01 00:52:08.000000', 'consum', 0.0215, 'lps'),
	(559947, 128, '2014-03-01 00:52:09.000000', 'consum', 0.0215, 'lps'),
	(559948, 128, '2014-03-01 00:52:10.000000', 'consum', 0.0218, 'lps'),
	(559949, 128, '2014-03-01 00:52:11.000000', 'consum', 0.0214, 'lps'),
	(559950, 128, '2014-03-01 00:52:12.000000', 'consum', 0.0231, 'lps'),
	(559951, 128, '2014-03-01 00:52:13.000000', 'consum', 0.0227, 'lps'),
	(559952, 128, '2014-03-01 00:52:14.000000', 'consum', 0.0210, 'lps'),
	(559953, 128, '2014-03-01 00:52:15.000000', 'consum', 0.0233, 'lps'),
	(559954, 128, '2014-03-01 00:52:16.000000', 'consum', 0.0224, 'lps'),
	(559955, 128, '2014-03-01 00:52:17.000000', 'consum', 0.0211, 'lps'),
	(559956, 128, '2014-03-01 00:52:18.000000', 'consum', 0.0225, 'lps'),
	(559957, 128, '2014-03-01 00:52:19.000000', 'consum', 0.0231, 'lps'),
	(559958, 128, '2014-03-01 00:52:20.000000', 'consum', 0.0221, 'lps'),
	(559959, 128, '2014-03-01 00:52:21.000000', 'consum', 0.0227, 'lps'),
	(559960, 128, '2014-03-01 00:52:22.000000', 'consum', 0.0211, 'lps'),
	(559961, 128, '2014-03-01 00:52:23.000000', 'consum', 0.0217, 'lps'),
	(559962, 128, '2014-03-01 00:52:24.000000', 'consum', 0.0216, 'lps'),
	(559963, 128, '2014-03-01 00:52:25.000000', 'consum', 0.0219, 'lps'),
	(559964, 128, '2014-03-01 00:52:26.000000', 'consum', 0.0214, 'lps'),
	(559965, 128, '2014-03-01 00:52:27.000000', 'consum', 0.0229, 'lps'),
	(559966, 128, '2014-03-01 00:52:28.000000', 'consum', 0.0218, 'lps'),
	(559967, 128, '2014-03-01 00:52:29.000000', 'consum', 0.0220, 'lps'),
	(559968, 128, '2014-03-01 00:52:30.000000', 'consum', 0.0211, 'lps'),
	(559969, 128, '2014-03-01 00:52:31.000000', 'consum', 0.0211, 'lps'),
	(559970, 128, '2014-03-01 00:52:32.000000', 'consum', 0.0210, 'lps'),
	(559971, 128, '2014-03-01 00:52:33.000000', 'consum', 0.0233, 'lps'),
	(559972, 128, '2014-03-01 00:52:34.000000', 'consum', 0.0226, 'lps'),
	(559973, 128, '2014-03-01 00:52:35.000000', 'consum', 0.0220, 'lps'),
	(559974, 128, '2014-03-01 00:52:36.000000', 'consum', 0.0212, 'lps'),
	(559975, 128, '2014-03-01 00:52:37.000000', 'consum', 0.0215, 'lps'),
	(559976, 128, '2014-03-01 00:52:38.000000', 'consum', 0.0232, 'lps'),
	(559977, 128, '2014-03-01 00:52:39.000000', 'consum', 0.0230, 'lps'),
	(559978, 128, '2014-03-01 00:52:40.000000', 'consum', 0.0221, 'lps'),
	(559979, 128, '2014-03-01 00:52:41.000000', 'consum', 0.0230, 'lps'),
	(559980, 128, '2014-03-01 00:52:42.000000', 'consum', 0.0225, 'lps'),
	(559981, 128, '2014-03-01 00:52:43.000000', 'consum', 0.0227, 'lps'),
	(559982, 128, '2014-03-01 00:52:44.000000', 'consum', 0.0225, 'lps'),
	(559983, 128, '2014-03-01 00:52:45.000000', 'consum', 0.0210, 'lps'),
	(559984, 128, '2014-03-01 00:52:46.000000', 'consum', 0.0214, 'lps'),
	(559985, 128, '2014-03-01 00:52:47.000000', 'consum', 0.0231, 'lps'),
	(559986, 128, '2014-03-01 00:52:48.000000', 'consum', 0.0230, 'lps'),
	(559987, 128, '2014-03-01 00:52:49.000000', 'consum', 0.0223, 'lps'),
	(559988, 128, '2014-03-01 00:52:50.000000', 'consum', 0.0216, 'lps'),
	(559989, 128, '2014-03-01 00:52:51.000000', 'consum', 0.0227, 'lps'),
	(559990, 128, '2014-03-01 00:52:52.000000', 'consum', 0.0228, 'lps'),
	(559991, 128, '2014-03-01 00:52:53.000000', 'consum', 0.0224, 'lps'),
	(559992, 128, '2014-03-01 00:52:54.000000', 'consum', 0.0226, 'lps'),
	(559993, 128, '2014-03-01 00:52:55.000000', 'consum', 0.0224, 'lps'),
	(559994, 128, '2014-03-01 00:52:56.000000', 'consum', 0.0231, 'lps'),
	(559995, 128, '2014-03-01 00:52:57.000000', 'consum', 0.0224, 'lps'),
	(559996, 128, '2014-03-01 00:52:58.000000', 'consum', 0.0217, 'lps'),
	(559997, 128, '2014-03-01 00:52:59.000000', 'consum', 0.0228, 'lps'),
	(559998, 128, '2014-03-01 00:53:00.000000', 'consum', 0.0232, 'lps'),
	(559999, 128, '2014-03-01 00:53:01.000000', 'consum', 0.0216, 'lps'),
	(560000, 128, '2014-03-01 00:53:02.000000', 'consum', 0.0223, 'lps'),
	(560001, 128, '2014-03-01 00:53:03.000000', 'consum', 0.0234, 'lps'),
	(560002, 128, '2014-03-01 00:53:04.000000', 'consum', 0.0215, 'lps'),
	(560003, 128, '2014-03-01 00:53:05.000000', 'consum', 0.0212, 'lps'),
	(560004, 128, '2014-03-01 00:53:06.000000', 'consum', 0.0234, 'lps'),
	(560005, 128, '2014-03-01 00:53:07.000000', 'consum', 0.0222, 'lps'),
	(560006, 128, '2014-03-01 00:53:08.000000', 'consum', 0.0225, 'lps'),
	(560007, 128, '2014-03-01 00:53:09.000000', 'consum', 0.0222, 'lps'),
	(560008, 128, '2014-03-01 00:53:10.000000', 'consum', 0.0229, 'lps'),
	(560009, 128, '2014-03-01 00:53:11.000000', 'consum', 0.0216, 'lps'),
	(560010, 128, '2014-03-01 00:53:12.000000', 'consum', 0.0211, 'lps'),
	(560011, 128, '2014-03-01 00:53:13.000000', 'consum', 0.0220, 'lps'),
	(560012, 128, '2014-03-01 00:53:14.000000', 'consum', 0.0234, 'lps'),
	(560013, 128, '2014-03-01 00:53:15.000000', 'consum', 0.0224, 'lps'),
	(560014, 128, '2014-03-01 00:53:16.000000', 'consum', 0.0234, 'lps'),
	(560015, 128, '2014-03-01 00:53:17.000000', 'consum', 0.0212, 'lps'),
	(560016, 128, '2014-03-01 00:53:18.000000', 'consum', 0.0225, 'lps'),
	(560017, 128, '2014-03-01 00:53:19.000000', 'consum', 0.0227, 'lps'),
	(560018, 128, '2014-03-01 00:53:20.000000', 'consum', 0.0229, 'lps'),
	(560019, 128, '2014-03-01 00:53:21.000000', 'consum', 0.0227, 'lps'),
	(560020, 128, '2014-03-01 00:53:22.000000', 'consum', 0.0213, 'lps'),
	(560021, 128, '2014-03-01 00:53:23.000000', 'consum', 0.0225, 'lps'),
	(560022, 128, '2014-03-01 00:53:24.000000', 'consum', 0.0225, 'lps'),
	(560023, 128, '2014-03-01 00:53:25.000000', 'consum', 0.0219, 'lps'),
	(560024, 128, '2014-03-01 00:53:26.000000', 'consum', 0.0234, 'lps'),
	(560025, 128, '2014-03-01 00:53:27.000000', 'consum', 0.0226, 'lps'),
	(560026, 128, '2014-03-01 00:53:28.000000', 'consum', 0.0222, 'lps'),
	(560027, 128, '2014-03-01 00:53:29.000000', 'consum', 0.0221, 'lps'),
	(560028, 128, '2014-03-01 00:53:30.000000', 'consum', 0.0229, 'lps'),
	(560029, 128, '2014-03-01 00:53:31.000000', 'consum', 0.0224, 'lps'),
	(560030, 128, '2014-03-01 00:53:32.000000', 'consum', 0.0222, 'lps'),
	(560031, 128, '2014-03-01 00:53:33.000000', 'consum', 0.0229, 'lps'),
	(560032, 128, '2014-03-01 00:53:34.000000', 'consum', 0.0221, 'lps'),
	(560033, 128, '2014-03-01 00:53:35.000000', 'consum', 0.0231, 'lps'),
	(560034, 128, '2014-03-01 00:53:36.000000', 'consum', 0.0210, 'lps'),
	(560035, 128, '2014-03-01 00:53:37.000000', 'consum', 0.0220, 'lps'),
	(560036, 128, '2014-03-01 00:53:38.000000', 'consum', 0.0210, 'lps'),
	(560037, 128, '2014-03-01 00:53:39.000000', 'consum', 0.0230, 'lps'),
	(560038, 128, '2014-03-01 00:53:40.000000', 'consum', 0.0234, 'lps'),
	(560039, 128, '2014-03-01 00:53:41.000000', 'consum', 0.0224, 'lps'),
	(560040, 128, '2014-03-01 00:53:42.000000', 'consum', 0.0233, 'lps'),
	(560041, 128, '2014-03-01 00:53:43.000000', 'consum', 0.0234, 'lps'),
	(560042, 128, '2014-03-01 00:53:44.000000', 'consum', 0.0211, 'lps'),
	(560043, 128, '2014-03-01 00:53:45.000000', 'consum', 0.0218, 'lps'),
	(560044, 128, '2014-03-01 00:53:46.000000', 'consum', 0.0222, 'lps'),
	(560045, 128, '2014-03-01 00:53:47.000000', 'consum', 0.0223, 'lps'),
	(560046, 128, '2014-03-01 00:53:48.000000', 'consum', 0.0214, 'lps'),
	(560047, 128, '2014-03-01 00:53:49.000000', 'consum', 0.0218, 'lps'),
	(560048, 128, '2014-03-01 00:53:50.000000', 'consum', 0.0212, 'lps'),
	(560049, 128, '2014-03-01 00:53:51.000000', 'consum', 0.0221, 'lps'),
	(560050, 128, '2014-03-01 00:53:52.000000', 'consum', 0.0211, 'lps'),
	(560051, 128, '2014-03-01 00:53:53.000000', 'consum', 0.0231, 'lps'),
	(560052, 128, '2014-03-01 00:53:54.000000', 'consum', 0.0211, 'lps'),
	(560053, 128, '2014-03-01 00:53:55.000000', 'consum', 0.0231, 'lps'),
	(560054, 128, '2014-03-01 00:53:56.000000', 'consum', 0.0210, 'lps'),
	(560055, 128, '2014-03-01 00:53:57.000000', 'consum', 0.0222, 'lps'),
	(560056, 128, '2014-03-01 00:53:58.000000', 'consum', 0.0222, 'lps'),
	(560057, 128, '2014-03-01 00:53:59.000000', 'consum', 0.0210, 'lps'),
	(560058, 128, '2014-03-01 00:54:00.000000', 'consum', 0.0225, 'lps'),
	(560059, 128, '2014-03-01 00:54:01.000000', 'consum', 0.0234, 'lps'),
	(560060, 128, '2014-03-01 00:54:02.000000', 'consum', 0.0212, 'lps'),
	(560061, 128, '2014-03-01 00:54:03.000000', 'consum', 0.0223, 'lps'),
	(560062, 128, '2014-03-01 00:54:04.000000', 'consum', 0.0218, 'lps'),
	(560063, 128, '2014-03-01 00:54:05.000000', 'consum', 0.0212, 'lps'),
	(560064, 128, '2014-03-01 00:54:06.000000', 'consum', 0.0222, 'lps'),
	(560065, 128, '2014-03-01 00:54:07.000000', 'consum', 0.0213, 'lps'),
	(560066, 128, '2014-03-01 00:54:08.000000', 'consum', 0.0215, 'lps'),
	(560067, 128, '2014-03-01 00:54:09.000000', 'consum', 0.0227, 'lps'),
	(560068, 128, '2014-03-01 00:54:10.000000', 'consum', 0.0232, 'lps'),
	(560069, 128, '2014-03-01 00:54:11.000000', 'consum', 0.0216, 'lps'),
	(560070, 128, '2014-03-01 00:54:12.000000', 'consum', 0.0227, 'lps'),
	(560071, 128, '2014-03-01 00:54:13.000000', 'consum', 0.0229, 'lps'),
	(560072, 128, '2014-03-01 00:54:14.000000', 'consum', 0.0226, 'lps'),
	(560073, 128, '2014-03-01 00:54:15.000000', 'consum', 0.0210, 'lps'),
	(560074, 128, '2014-03-01 00:54:16.000000', 'consum', 0.0213, 'lps'),
	(560075, 128, '2014-03-01 00:54:17.000000', 'consum', 0.0224, 'lps'),
	(560076, 128, '2014-03-01 00:54:18.000000', 'consum', 0.0224, 'lps'),
	(560077, 128, '2014-03-01 00:54:19.000000', 'consum', 0.0212, 'lps'),
	(560078, 128, '2014-03-01 00:54:20.000000', 'consum', 0.0230, 'lps'),
	(560079, 128, '2014-03-01 00:54:21.000000', 'consum', 0.0228, 'lps'),
	(560080, 128, '2014-03-01 00:54:22.000000', 'consum', 0.0214, 'lps'),
	(560081, 128, '2014-03-01 00:54:23.000000', 'consum', 0.0228, 'lps'),
	(560082, 128, '2014-03-01 00:54:24.000000', 'consum', 0.0215, 'lps'),
	(560083, 128, '2014-03-01 00:54:25.000000', 'consum', 0.0230, 'lps'),
	(560084, 128, '2014-03-01 00:54:26.000000', 'consum', 0.0221, 'lps'),
	(560085, 128, '2014-03-01 00:54:27.000000', 'consum', 0.0232, 'lps'),
	(560086, 128, '2014-03-01 00:54:28.000000', 'consum', 0.0212, 'lps'),
	(560087, 128, '2014-03-01 00:54:29.000000', 'consum', 0.0229, 'lps'),
	(560088, 128, '2014-03-01 00:54:30.000000', 'consum', 0.0227, 'lps'),
	(560089, 128, '2014-03-01 00:54:31.000000', 'consum', 0.0210, 'lps'),
	(560090, 128, '2014-03-01 00:54:32.000000', 'consum', 0.0211, 'lps'),
	(560091, 128, '2014-03-01 00:54:33.000000', 'consum', 0.0214, 'lps'),
	(560092, 128, '2014-03-01 00:54:34.000000', 'consum', 0.0228, 'lps'),
	(560093, 128, '2014-03-01 00:54:35.000000', 'consum', 0.0216, 'lps'),
	(560094, 128, '2014-03-01 00:54:36.000000', 'consum', 0.0233, 'lps'),
	(560095, 128, '2014-03-01 00:54:37.000000', 'consum', 0.0233, 'lps'),
	(560096, 128, '2014-03-01 00:54:38.000000', 'consum', 0.0232, 'lps'),
	(560097, 128, '2014-03-01 00:54:39.000000', 'consum', 0.0228, 'lps'),
	(560098, 128, '2014-03-01 00:54:40.000000', 'consum', 0.0234, 'lps'),
	(560099, 128, '2014-03-01 00:54:41.000000', 'consum', 0.0228, 'lps'),
	(560100, 128, '2014-03-01 00:54:42.000000', 'consum', 0.0225, 'lps'),
	(560101, 128, '2014-03-01 00:54:43.000000', 'consum', 0.0234, 'lps'),
	(560102, 128, '2014-03-01 00:54:44.000000', 'consum', 0.0210, 'lps'),
	(560103, 128, '2014-03-01 00:54:45.000000', 'consum', 0.0214, 'lps'),
	(560104, 128, '2014-03-01 00:54:46.000000', 'consum', 0.0231, 'lps'),
	(560105, 128, '2014-03-01 00:54:47.000000', 'consum', 0.0228, 'lps'),
	(560106, 128, '2014-03-01 00:54:48.000000', 'consum', 0.0214, 'lps'),
	(560107, 128, '2014-03-01 00:54:49.000000', 'consum', 0.0225, 'lps'),
	(560108, 128, '2014-03-01 00:54:50.000000', 'consum', 0.0225, 'lps'),
	(560109, 128, '2014-03-01 00:54:51.000000', 'consum', 0.0216, 'lps'),
	(560110, 128, '2014-03-01 00:54:52.000000', 'consum', 0.0221, 'lps'),
	(560111, 128, '2014-03-01 00:54:53.000000', 'consum', 0.0220, 'lps'),
	(560112, 128, '2014-03-01 00:54:54.000000', 'consum', 0.0230, 'lps'),
	(560113, 128, '2014-03-01 00:54:55.000000', 'consum', 0.0228, 'lps'),
	(560114, 128, '2014-03-01 00:54:56.000000', 'consum', 0.0217, 'lps'),
	(560115, 128, '2014-03-01 00:54:57.000000', 'consum', 0.0217, 'lps'),
	(560116, 128, '2014-03-01 00:54:58.000000', 'consum', 0.0223, 'lps'),
	(560117, 128, '2014-03-01 00:54:59.000000', 'consum', 0.0229, 'lps'),
	(560118, 128, '2014-03-01 00:55:00.000000', 'consum', 0.0218, 'lps'),
	(560119, 128, '2014-03-01 00:55:01.000000', 'consum', 0.0219, 'lps'),
	(560120, 128, '2014-03-01 00:55:02.000000', 'consum', 0.0231, 'lps'),
	(560121, 128, '2014-03-01 00:55:03.000000', 'consum', 0.0213, 'lps'),
	(560122, 128, '2014-03-01 00:55:04.000000', 'consum', 0.0212, 'lps'),
	(560123, 128, '2014-03-01 00:55:05.000000', 'consum', 0.0214, 'lps'),
	(560124, 128, '2014-03-01 00:55:06.000000', 'consum', 0.0223, 'lps'),
	(560125, 128, '2014-03-01 00:55:07.000000', 'consum', 0.0212, 'lps'),
	(560126, 128, '2014-03-01 00:55:08.000000', 'consum', 0.0231, 'lps'),
	(560127, 128, '2014-03-01 00:55:09.000000', 'consum', 0.0210, 'lps'),
	(560128, 128, '2014-03-01 00:55:10.000000', 'consum', 0.0224, 'lps'),
	(560129, 128, '2014-03-01 00:55:11.000000', 'consum', 0.0231, 'lps'),
	(560130, 128, '2014-03-01 00:55:12.000000', 'consum', 0.0221, 'lps'),
	(560131, 128, '2014-03-01 00:55:13.000000', 'consum', 0.0230, 'lps'),
	(560132, 128, '2014-03-01 00:55:14.000000', 'consum', 0.0225, 'lps'),
	(560133, 128, '2014-03-01 00:55:15.000000', 'consum', 0.0226, 'lps'),
	(560134, 128, '2014-03-01 00:55:16.000000', 'consum', 0.0222, 'lps'),
	(560135, 128, '2014-03-01 00:55:17.000000', 'consum', 0.0221, 'lps'),
	(560136, 128, '2014-03-01 00:55:18.000000', 'consum', 0.0231, 'lps'),
	(560137, 128, '2014-03-01 00:55:19.000000', 'consum', 0.0231, 'lps'),
	(560138, 128, '2014-03-01 00:55:20.000000', 'consum', 0.0226, 'lps'),
	(560139, 128, '2014-03-01 00:55:21.000000', 'consum', 0.0230, 'lps'),
	(560140, 128, '2014-03-01 00:55:22.000000', 'consum', 0.0212, 'lps'),
	(560141, 128, '2014-03-01 00:55:23.000000', 'consum', 0.0210, 'lps'),
	(560142, 128, '2014-03-01 00:55:24.000000', 'consum', 0.0231, 'lps'),
	(560143, 128, '2014-03-01 00:55:25.000000', 'consum', 0.0216, 'lps'),
	(560144, 128, '2014-03-01 00:55:26.000000', 'consum', 0.0228, 'lps'),
	(560145, 128, '2014-03-01 00:55:27.000000', 'consum', 0.0230, 'lps'),
	(560146, 128, '2014-03-01 00:55:28.000000', 'consum', 0.0232, 'lps'),
	(560147, 128, '2014-03-01 00:55:29.000000', 'consum', 0.0211, 'lps'),
	(560148, 128, '2014-03-01 00:55:30.000000', 'consum', 0.0226, 'lps'),
	(560149, 128, '2014-03-01 00:55:31.000000', 'consum', 0.0211, 'lps'),
	(560150, 128, '2014-03-01 00:55:32.000000', 'consum', 0.0219, 'lps'),
	(560151, 128, '2014-03-01 00:55:33.000000', 'consum', 0.0225, 'lps'),
	(560152, 128, '2014-03-01 00:55:34.000000', 'consum', 0.0212, 'lps'),
	(560153, 128, '2014-03-01 00:55:35.000000', 'consum', 0.0222, 'lps'),
	(560154, 128, '2014-03-01 00:55:36.000000', 'consum', 0.0216, 'lps'),
	(560155, 128, '2014-03-01 00:55:37.000000', 'consum', 0.0231, 'lps'),
	(560156, 128, '2014-03-01 00:55:38.000000', 'consum', 0.0223, 'lps'),
	(560157, 128, '2014-03-01 00:55:39.000000', 'consum', 0.0211, 'lps'),
	(560158, 128, '2014-03-01 00:55:40.000000', 'consum', 0.0227, 'lps'),
	(560159, 128, '2014-03-01 00:55:41.000000', 'consum', 0.0216, 'lps'),
	(560160, 128, '2014-03-01 00:55:42.000000', 'consum', 0.0217, 'lps'),
	(560161, 128, '2014-03-01 00:55:43.000000', 'consum', 0.0226, 'lps'),
	(560162, 128, '2014-03-01 00:55:44.000000', 'consum', 0.0218, 'lps'),
	(560163, 128, '2014-03-01 00:55:45.000000', 'consum', 0.0231, 'lps'),
	(560164, 128, '2014-03-01 00:55:46.000000', 'consum', 0.0214, 'lps'),
	(560165, 128, '2014-03-01 00:55:47.000000', 'consum', 0.0220, 'lps'),
	(560166, 128, '2014-03-01 00:55:48.000000', 'consum', 0.0220, 'lps'),
	(560167, 128, '2014-03-01 00:55:49.000000', 'consum', 0.0233, 'lps'),
	(560168, 128, '2014-03-01 00:55:50.000000', 'consum', 0.0220, 'lps'),
	(560169, 128, '2014-03-01 00:55:51.000000', 'consum', 0.0215, 'lps'),
	(560170, 128, '2014-03-01 00:55:52.000000', 'consum', 0.0231, 'lps'),
	(560171, 128, '2014-03-01 00:55:53.000000', 'consum', 0.0228, 'lps'),
	(560172, 128, '2014-03-01 00:55:54.000000', 'consum', 0.0210, 'lps'),
	(560173, 128, '2014-03-01 00:55:55.000000', 'consum', 0.0230, 'lps'),
	(560174, 128, '2014-03-01 00:55:56.000000', 'consum', 0.0214, 'lps'),
	(560175, 128, '2014-03-01 00:55:57.000000', 'consum', 0.0217, 'lps'),
	(560176, 128, '2014-03-01 00:55:58.000000', 'consum', 0.0212, 'lps'),
	(560177, 128, '2014-03-01 00:55:59.000000', 'consum', 0.0221, 'lps'),
	(560178, 128, '2014-03-01 00:56:00.000000', 'consum', 0.0212, 'lps'),
	(560179, 128, '2014-03-01 00:56:01.000000', 'consum', 0.0212, 'lps'),
	(560180, 128, '2014-03-01 00:56:02.000000', 'consum', 0.0212, 'lps'),
	(560181, 128, '2014-03-01 00:56:03.000000', 'consum', 0.0218, 'lps'),
	(560182, 128, '2014-03-01 00:56:04.000000', 'consum', 0.0219, 'lps'),
	(560183, 128, '2014-03-01 00:56:05.000000', 'consum', 0.0231, 'lps'),
	(560184, 128, '2014-03-01 00:56:06.000000', 'consum', 0.0215, 'lps'),
	(560185, 128, '2014-03-01 00:56:07.000000', 'consum', 0.0220, 'lps'),
	(560186, 128, '2014-03-01 00:56:08.000000', 'consum', 0.0222, 'lps'),
	(560187, 128, '2014-03-01 00:56:09.000000', 'consum', 0.0214, 'lps'),
	(560188, 128, '2014-03-01 00:56:10.000000', 'consum', 0.0219, 'lps'),
	(560189, 128, '2014-03-01 00:56:11.000000', 'consum', 0.0221, 'lps'),
	(560190, 128, '2014-03-01 00:56:12.000000', 'consum', 0.0211, 'lps'),
	(560191, 128, '2014-03-01 00:56:13.000000', 'consum', 0.0232, 'lps'),
	(560192, 128, '2014-03-01 00:56:14.000000', 'consum', 0.0221, 'lps'),
	(560193, 128, '2014-03-01 00:56:15.000000', 'consum', 0.0221, 'lps'),
	(560194, 128, '2014-03-01 00:56:16.000000', 'consum', 0.0233, 'lps'),
	(560195, 128, '2014-03-01 00:56:17.000000', 'consum', 0.0218, 'lps'),
	(560196, 128, '2014-03-01 00:56:18.000000', 'consum', 0.0230, 'lps'),
	(560197, 128, '2014-03-01 00:56:19.000000', 'consum', 0.0214, 'lps'),
	(560198, 128, '2014-03-01 00:56:20.000000', 'consum', 0.0218, 'lps'),
	(560199, 128, '2014-03-01 00:56:21.000000', 'consum', 0.0214, 'lps'),
	(560200, 128, '2014-03-01 00:56:22.000000', 'consum', 0.0233, 'lps'),
	(560201, 128, '2014-03-01 00:56:23.000000', 'consum', 0.0212, 'lps'),
	(560202, 128, '2014-03-01 00:56:24.000000', 'consum', 0.0225, 'lps'),
	(560203, 128, '2014-03-01 00:56:25.000000', 'consum', 0.0231, 'lps'),
	(560204, 128, '2014-03-01 00:56:26.000000', 'consum', 0.0220, 'lps'),
	(560205, 128, '2014-03-01 00:56:27.000000', 'consum', 0.0222, 'lps'),
	(560206, 128, '2014-03-01 00:56:28.000000', 'consum', 0.0216, 'lps'),
	(560207, 128, '2014-03-01 00:56:29.000000', 'consum', 0.0229, 'lps'),
	(560208, 128, '2014-03-01 00:56:30.000000', 'consum', 0.0212, 'lps'),
	(560209, 128, '2014-03-01 00:56:31.000000', 'consum', 0.0214, 'lps'),
	(560210, 128, '2014-03-01 00:56:32.000000', 'consum', 0.0227, 'lps'),
	(560211, 128, '2014-03-01 00:56:33.000000', 'consum', 0.0230, 'lps'),
	(560212, 128, '2014-03-01 00:56:34.000000', 'consum', 0.0213, 'lps'),
	(560213, 128, '2014-03-01 00:56:35.000000', 'consum', 0.0213, 'lps'),
	(560214, 128, '2014-03-01 00:56:36.000000', 'consum', 0.0217, 'lps'),
	(560215, 128, '2014-03-01 00:56:37.000000', 'consum', 0.0212, 'lps'),
	(560216, 128, '2014-03-01 00:56:38.000000', 'consum', 0.0223, 'lps'),
	(560217, 128, '2014-03-01 00:56:39.000000', 'consum', 0.0218, 'lps'),
	(560218, 128, '2014-03-01 00:56:40.000000', 'consum', 0.0215, 'lps'),
	(560219, 129, '2014-03-01 00:00:00.000000', 'consum', 0.0231, 'lps'),
	(560220, 129, '2014-03-01 00:00:01.000000', 'consum', 0.0229, 'lps'),
	(560221, 129, '2014-03-01 00:00:02.000000', 'consum', 0.0211, 'lps'),
	(560222, 129, '2014-03-01 00:00:03.000000', 'consum', 0.0220, 'lps'),
	(560223, 129, '2014-03-01 00:00:04.000000', 'consum', 0.0228, 'lps'),
	(560224, 129, '2014-03-01 00:00:05.000000', 'consum', 0.0211, 'lps'),
	(560225, 129, '2014-03-01 00:00:06.000000', 'consum', 0.0218, 'lps'),
	(560226, 129, '2014-03-01 00:00:07.000000', 'consum', 0.0220, 'lps'),
	(560227, 129, '2014-03-01 00:00:08.000000', 'consum', 0.0238, 'lps'),
	(560228, 129, '2014-03-01 00:00:09.000000', 'consum', 0.0231, 'lps'),
	(560229, 129, '2014-03-01 00:00:10.000000', 'consum', 0.0233, 'lps'),
	(560230, 129, '2014-03-01 00:00:11.000000', 'consum', 0.0233, 'lps'),
	(560231, 129, '2014-03-01 00:00:12.000000', 'consum', 0.0227, 'lps'),
	(560232, 129, '2014-03-01 00:00:13.000000', 'consum', 0.0225, 'lps'),
	(560233, 129, '2014-03-01 00:00:14.000000', 'consum', 0.0236, 'lps'),
	(560234, 129, '2014-03-01 00:00:15.000000', 'consum', 0.0237, 'lps'),
	(560235, 129, '2014-03-01 00:00:16.000000', 'consum', 0.0238, 'lps'),
	(560236, 129, '2014-03-01 00:00:17.000000', 'consum', 0.0213, 'lps'),
	(560237, 129, '2014-03-01 00:00:18.000000', 'consum', 0.0227, 'lps'),
	(560238, 129, '2014-03-01 00:00:19.000000', 'consum', 0.0230, 'lps'),
	(560239, 129, '2014-03-01 00:00:20.000000', 'consum', 0.0228, 'lps'),
	(560240, 129, '2014-03-01 00:00:21.000000', 'consum', 0.0213, 'lps'),
	(560241, 129, '2014-03-01 00:00:22.000000', 'consum', 0.0231, 'lps'),
	(560242, 129, '2014-03-01 00:00:23.000000', 'consum', 0.0217, 'lps'),
	(560243, 129, '2014-03-01 00:00:24.000000', 'consum', 0.0211, 'lps'),
	(560244, 129, '2014-03-01 00:00:25.000000', 'consum', 0.0223, 'lps'),
	(560245, 129, '2014-03-01 00:00:26.000000', 'consum', 0.0215, 'lps'),
	(560246, 129, '2014-03-01 00:00:27.000000', 'consum', 0.0227, 'lps'),
	(560247, 129, '2014-03-01 00:00:28.000000', 'consum', 0.0221, 'lps'),
	(560248, 129, '2014-03-01 00:00:29.000000', 'consum', 0.0214, 'lps'),
	(560249, 129, '2014-03-01 00:00:30.000000', 'consum', 0.0227, 'lps'),
	(560250, 129, '2014-03-01 00:00:31.000000', 'consum', 0.0226, 'lps'),
	(560251, 129, '2014-03-01 00:00:32.000000', 'consum', 0.0211, 'lps'),
	(560252, 129, '2014-03-01 00:00:33.000000', 'consum', 0.0223, 'lps'),
	(560253, 129, '2014-03-01 00:00:34.000000', 'consum', 0.0217, 'lps'),
	(560254, 129, '2014-03-01 00:00:35.000000', 'consum', 0.0234, 'lps'),
	(560255, 129, '2014-03-01 00:00:36.000000', 'consum', 0.0223, 'lps'),
	(560256, 129, '2014-03-01 00:00:37.000000', 'consum', 0.0232, 'lps'),
	(560257, 129, '2014-03-01 00:00:38.000000', 'consum', 0.0226, 'lps'),
	(560258, 129, '2014-03-01 00:00:39.000000', 'consum', 0.0222, 'lps'),
	(560259, 129, '2014-03-01 00:00:40.000000', 'consum', 0.0224, 'lps'),
	(560260, 129, '2014-03-01 00:00:41.000000', 'consum', 0.0214, 'lps'),
	(560261, 129, '2014-03-01 00:00:42.000000', 'consum', 0.0218, 'lps'),
	(560262, 129, '2014-03-01 00:00:43.000000', 'consum', 0.0238, 'lps'),
	(560263, 129, '2014-03-01 00:00:44.000000', 'consum', 0.0213, 'lps'),
	(560264, 129, '2014-03-01 00:00:45.000000', 'consum', 0.0225, 'lps'),
	(560265, 129, '2014-03-01 00:00:46.000000', 'consum', 0.0222, 'lps'),
	(560266, 129, '2014-03-01 00:00:47.000000', 'consum', 0.0224, 'lps'),
	(560267, 129, '2014-03-01 00:00:48.000000', 'consum', 0.0215, 'lps'),
	(560268, 129, '2014-03-01 00:00:49.000000', 'consum', 0.0223, 'lps'),
	(560269, 129, '2014-03-01 00:00:50.000000', 'consum', 0.0233, 'lps'),
	(560270, 129, '2014-03-01 00:00:51.000000', 'consum', 0.0227, 'lps'),
	(560271, 129, '2014-03-01 00:00:52.000000', 'consum', 0.0229, 'lps'),
	(560272, 129, '2014-03-01 00:00:53.000000', 'consum', 0.0222, 'lps'),
	(560273, 129, '2014-03-01 00:00:54.000000', 'consum', 0.0214, 'lps'),
	(560274, 129, '2014-03-01 00:00:55.000000', 'consum', 0.0225, 'lps'),
	(560275, 129, '2014-03-01 00:00:56.000000', 'consum', 0.0217, 'lps'),
	(560276, 129, '2014-03-01 00:00:57.000000', 'consum', 0.0226, 'lps'),
	(560277, 129, '2014-03-01 00:00:58.000000', 'consum', 0.0214, 'lps'),
	(560278, 129, '2014-03-01 00:00:59.000000', 'consum', 0.0238, 'lps'),
	(560279, 129, '2014-03-01 00:01:00.000000', 'consum', 0.0225, 'lps'),
	(560280, 129, '2014-03-01 00:01:01.000000', 'consum', 0.0232, 'lps'),
	(560281, 129, '2014-03-01 00:01:02.000000', 'consum', 0.0214, 'lps'),
	(560282, 129, '2014-03-01 00:01:03.000000', 'consum', 0.0223, 'lps'),
	(560283, 129, '2014-03-01 00:01:04.000000', 'consum', 0.0234, 'lps'),
	(560284, 129, '2014-03-01 00:01:05.000000', 'consum', 0.0236, 'lps'),
	(560285, 129, '2014-03-01 00:01:06.000000', 'consum', 0.0237, 'lps'),
	(560286, 129, '2014-03-01 00:01:07.000000', 'consum', 0.0212, 'lps'),
	(560287, 129, '2014-03-01 00:01:08.000000', 'consum', 0.0226, 'lps'),
	(560288, 129, '2014-03-01 00:01:09.000000', 'consum', 0.0227, 'lps'),
	(560289, 129, '2014-03-01 00:01:10.000000', 'consum', 0.0220, 'lps'),
	(560290, 129, '2014-03-01 00:01:11.000000', 'consum', 0.0236, 'lps'),
	(560291, 129, '2014-03-01 00:01:12.000000', 'consum', 0.0222, 'lps'),
	(560292, 129, '2014-03-01 00:01:13.000000', 'consum', 0.0225, 'lps'),
	(560293, 129, '2014-03-01 00:01:14.000000', 'consum', 0.0219, 'lps'),
	(560294, 129, '2014-03-01 00:01:15.000000', 'consum', 0.0212, 'lps'),
	(560295, 129, '2014-03-01 00:01:16.000000', 'consum', 0.0223, 'lps'),
	(560296, 129, '2014-03-01 00:01:17.000000', 'consum', 0.0238, 'lps'),
	(560297, 129, '2014-03-01 00:01:18.000000', 'consum', 0.0226, 'lps'),
	(560298, 129, '2014-03-01 00:01:19.000000', 'consum', 0.0236, 'lps'),
	(560299, 129, '2014-03-01 00:01:20.000000', 'consum', 0.0234, 'lps'),
	(560300, 129, '2014-03-01 00:01:21.000000', 'consum', 0.0223, 'lps'),
	(560301, 129, '2014-03-01 00:01:22.000000', 'consum', 0.0231, 'lps'),
	(560302, 129, '2014-03-01 00:01:23.000000', 'consum', 0.0220, 'lps'),
	(560303, 129, '2014-03-01 00:01:24.000000', 'consum', 0.0228, 'lps'),
	(560304, 129, '2014-03-01 00:01:25.000000', 'consum', 0.0212, 'lps'),
	(560305, 129, '2014-03-01 00:01:26.000000', 'consum', 0.0222, 'lps'),
	(560306, 129, '2014-03-01 00:01:27.000000', 'consum', 0.0210, 'lps'),
	(560307, 129, '2014-03-01 00:01:28.000000', 'consum', 0.0231, 'lps'),
	(560308, 129, '2014-03-01 00:01:29.000000', 'consum', 0.0228, 'lps'),
	(560309, 129, '2014-03-01 00:01:30.000000', 'consum', 0.0238, 'lps'),
	(560310, 129, '2014-03-01 00:01:31.000000', 'consum', 0.0210, 'lps'),
	(560311, 129, '2014-03-01 00:01:32.000000', 'consum', 0.0214, 'lps'),
	(560312, 129, '2014-03-01 00:01:33.000000', 'consum', 0.0228, 'lps'),
	(560313, 129, '2014-03-01 00:01:34.000000', 'consum', 0.0232, 'lps'),
	(560314, 129, '2014-03-01 00:01:35.000000', 'consum', 0.0236, 'lps'),
	(560315, 129, '2014-03-01 00:01:36.000000', 'consum', 0.0218, 'lps'),
	(560316, 129, '2014-03-01 00:01:37.000000', 'consum', 0.0229, 'lps'),
	(560317, 129, '2014-03-01 00:01:38.000000', 'consum', 0.0223, 'lps'),
	(560318, 129, '2014-03-01 00:01:39.000000', 'consum', 0.0219, 'lps'),
	(560319, 129, '2014-03-01 00:01:40.000000', 'consum', 0.0215, 'lps'),
	(560320, 129, '2014-03-01 00:01:41.000000', 'consum', 0.0211, 'lps'),
	(560321, 129, '2014-03-01 00:01:42.000000', 'consum', 0.0229, 'lps'),
	(560322, 129, '2014-03-01 00:01:43.000000', 'consum', 0.0214, 'lps'),
	(560323, 129, '2014-03-01 00:01:44.000000', 'consum', 0.0233, 'lps'),
	(560324, 129, '2014-03-01 00:01:45.000000', 'consum', 0.0226, 'lps'),
	(560325, 129, '2014-03-01 00:01:46.000000', 'consum', 0.0221, 'lps'),
	(560326, 129, '2014-03-01 00:01:47.000000', 'consum', 0.0219, 'lps'),
	(560327, 129, '2014-03-01 00:01:48.000000', 'consum', 0.0222, 'lps'),
	(560328, 129, '2014-03-01 00:01:49.000000', 'consum', 0.0213, 'lps'),
	(560329, 129, '2014-03-01 00:01:50.000000', 'consum', 0.0220, 'lps'),
	(560330, 129, '2014-03-01 00:01:51.000000', 'consum', 0.0221, 'lps'),
	(560331, 129, '2014-03-01 00:01:52.000000', 'consum', 0.0238, 'lps'),
	(560332, 129, '2014-03-01 00:01:53.000000', 'consum', 0.0231, 'lps'),
	(560333, 129, '2014-03-01 00:01:54.000000', 'consum', 0.0229, 'lps'),
	(560334, 129, '2014-03-01 00:01:55.000000', 'consum', 0.0214, 'lps'),
	(560335, 129, '2014-03-01 00:01:56.000000', 'consum', 0.0233, 'lps'),
	(560336, 129, '2014-03-01 00:01:57.000000', 'consum', 0.0227, 'lps'),
	(560337, 129, '2014-03-01 00:01:58.000000', 'consum', 0.0224, 'lps'),
	(560338, 129, '2014-03-01 00:01:59.000000', 'consum', 0.0231, 'lps'),
	(560339, 129, '2014-03-01 00:02:00.000000', 'consum', 0.0214, 'lps'),
	(560340, 129, '2014-03-01 00:02:01.000000', 'consum', 0.0226, 'lps'),
	(560341, 129, '2014-03-01 00:02:02.000000', 'consum', 0.0222, 'lps'),
	(560342, 129, '2014-03-01 00:02:03.000000', 'consum', 0.0223, 'lps'),
	(560343, 129, '2014-03-01 00:02:04.000000', 'consum', 0.0238, 'lps'),
	(560344, 129, '2014-03-01 00:02:05.000000', 'consum', 0.0224, 'lps'),
	(560345, 129, '2014-03-01 00:02:06.000000', 'consum', 0.0227, 'lps'),
	(560346, 129, '2014-03-01 00:02:07.000000', 'consum', 0.0225, 'lps'),
	(560347, 129, '2014-03-01 00:02:08.000000', 'consum', 0.0232, 'lps'),
	(560348, 129, '2014-03-01 00:02:09.000000', 'consum', 0.0217, 'lps'),
	(560349, 129, '2014-03-01 00:02:10.000000', 'consum', 0.0211, 'lps'),
	(560350, 129, '2014-03-01 00:02:11.000000', 'consum', 0.0224, 'lps'),
	(560351, 129, '2014-03-01 00:02:12.000000', 'consum', 0.0217, 'lps'),
	(560352, 129, '2014-03-01 00:02:13.000000', 'consum', 0.0234, 'lps'),
	(560353, 129, '2014-03-01 00:02:14.000000', 'consum', 0.0224, 'lps'),
	(560354, 129, '2014-03-01 00:02:15.000000', 'consum', 0.0237, 'lps'),
	(560355, 129, '2014-03-01 00:02:16.000000', 'consum', 0.0217, 'lps'),
	(560356, 129, '2014-03-01 00:02:17.000000', 'consum', 0.0220, 'lps'),
	(560357, 129, '2014-03-01 00:02:18.000000', 'consum', 0.0212, 'lps'),
	(560358, 129, '2014-03-01 00:02:19.000000', 'consum', 0.0218, 'lps'),
	(560359, 129, '2014-03-01 00:02:20.000000', 'consum', 0.0217, 'lps'),
	(560360, 129, '2014-03-01 00:02:21.000000', 'consum', 0.0220, 'lps'),
	(560361, 129, '2014-03-01 00:02:22.000000', 'consum', 0.0212, 'lps'),
	(560362, 129, '2014-03-01 00:02:23.000000', 'consum', 0.0220, 'lps'),
	(560363, 129, '2014-03-01 00:02:24.000000', 'consum', 0.0223, 'lps'),
	(560364, 129, '2014-03-01 00:02:25.000000', 'consum', 0.0218, 'lps'),
	(560365, 129, '2014-03-01 00:02:26.000000', 'consum', 0.0212, 'lps'),
	(560366, 129, '2014-03-01 00:02:27.000000', 'consum', 0.0227, 'lps'),
	(560367, 129, '2014-03-01 00:02:28.000000', 'consum', 0.0230, 'lps'),
	(560368, 129, '2014-03-01 00:02:29.000000', 'consum', 0.0229, 'lps'),
	(560369, 129, '2014-03-01 00:02:30.000000', 'consum', 0.0218, 'lps'),
	(560370, 129, '2014-03-01 00:02:31.000000', 'consum', 0.0221, 'lps'),
	(560371, 129, '2014-03-01 00:02:32.000000', 'consum', 0.0213, 'lps'),
	(560372, 129, '2014-03-01 00:02:33.000000', 'consum', 0.0223, 'lps'),
	(560373, 129, '2014-03-01 00:02:34.000000', 'consum', 0.0238, 'lps'),
	(560374, 129, '2014-03-01 00:02:35.000000', 'consum', 0.0225, 'lps'),
	(560375, 129, '2014-03-01 00:02:36.000000', 'consum', 0.0228, 'lps'),
	(560376, 129, '2014-03-01 00:02:37.000000', 'consum', 0.0227, 'lps'),
	(560377, 129, '2014-03-01 00:02:38.000000', 'consum', 0.0211, 'lps'),
	(560378, 129, '2014-03-01 00:02:39.000000', 'consum', 0.0223, 'lps'),
	(560379, 129, '2014-03-01 00:02:40.000000', 'consum', 0.0217, 'lps'),
	(560380, 129, '2014-03-01 00:02:41.000000', 'consum', 0.0233, 'lps'),
	(560381, 129, '2014-03-01 00:02:42.000000', 'consum', 0.0219, 'lps'),
	(560382, 129, '2014-03-01 00:02:43.000000', 'consum', 0.0216, 'lps'),
	(560383, 129, '2014-03-01 00:02:44.000000', 'consum', 0.0214, 'lps'),
	(560384, 129, '2014-03-01 00:02:45.000000', 'consum', 0.0213, 'lps'),
	(560385, 129, '2014-03-01 00:02:46.000000', 'consum', 0.0214, 'lps'),
	(560386, 129, '2014-03-01 00:02:47.000000', 'consum', 0.0222, 'lps'),
	(560387, 129, '2014-03-01 00:02:48.000000', 'consum', 0.0228, 'lps'),
	(560388, 129, '2014-03-01 00:02:49.000000', 'consum', 0.0237, 'lps'),
	(560389, 129, '2014-03-01 00:02:50.000000', 'consum', 0.0231, 'lps'),
	(560390, 129, '2014-03-01 00:02:51.000000', 'consum', 0.0237, 'lps'),
	(560391, 129, '2014-03-01 00:02:52.000000', 'consum', 0.0223, 'lps'),
	(560392, 129, '2014-03-01 00:02:53.000000', 'consum', 0.0225, 'lps'),
	(560393, 129, '2014-03-01 00:02:54.000000', 'consum', 0.0216, 'lps'),
	(560394, 129, '2014-03-01 00:02:55.000000', 'consum', 0.0224, 'lps'),
	(560395, 129, '2014-03-01 00:02:56.000000', 'consum', 0.0235, 'lps'),
	(560396, 129, '2014-03-01 00:02:57.000000', 'consum', 0.0236, 'lps'),
	(560397, 129, '2014-03-01 00:02:58.000000', 'consum', 0.0237, 'lps'),
	(560398, 129, '2014-03-01 00:02:59.000000', 'consum', 0.0237, 'lps'),
	(560399, 129, '2014-03-01 00:03:00.000000', 'consum', 0.0237, 'lps'),
	(560400, 129, '2014-03-01 00:03:01.000000', 'consum', 0.0236, 'lps'),
	(560401, 129, '2014-03-01 00:03:02.000000', 'consum', 0.0230, 'lps'),
	(560402, 129, '2014-03-01 00:03:03.000000', 'consum', 0.0232, 'lps'),
	(560403, 129, '2014-03-01 00:03:04.000000', 'consum', 0.0232, 'lps'),
	(560404, 129, '2014-03-01 00:03:05.000000', 'consum', 0.0225, 'lps'),
	(560405, 129, '2014-03-01 00:03:06.000000', 'consum', 0.0219, 'lps'),
	(560406, 129, '2014-03-01 00:03:07.000000', 'consum', 0.0213, 'lps'),
	(560407, 129, '2014-03-01 00:03:08.000000', 'consum', 0.0225, 'lps'),
	(560408, 129, '2014-03-01 00:03:09.000000', 'consum', 0.0219, 'lps'),
	(560409, 129, '2014-03-01 00:03:10.000000', 'consum', 0.0211, 'lps'),
	(560410, 129, '2014-03-01 00:03:11.000000', 'consum', 0.0216, 'lps'),
	(560411, 129, '2014-03-01 00:03:12.000000', 'consum', 0.0211, 'lps'),
	(560412, 129, '2014-03-01 00:03:13.000000', 'consum', 0.0227, 'lps'),
	(560413, 129, '2014-03-01 00:03:14.000000', 'consum', 0.0235, 'lps'),
	(560414, 129, '2014-03-01 00:03:15.000000', 'consum', 0.0225, 'lps'),
	(560415, 129, '2014-03-01 00:03:16.000000', 'consum', 0.0211, 'lps'),
	(560416, 129, '2014-03-01 00:03:17.000000', 'consum', 0.0230, 'lps'),
	(560417, 129, '2014-03-01 00:03:18.000000', 'consum', 0.0219, 'lps'),
	(560418, 129, '2014-03-01 00:03:19.000000', 'consum', 0.0224, 'lps'),
	(560419, 129, '2014-03-01 00:03:20.000000', 'consum', 0.0227, 'lps'),
	(560420, 129, '2014-03-01 00:03:21.000000', 'consum', 0.0223, 'lps'),
	(560421, 129, '2014-03-01 00:03:22.000000', 'consum', 0.0223, 'lps'),
	(560422, 129, '2014-03-01 00:03:23.000000', 'consum', 0.0236, 'lps'),
	(560423, 129, '2014-03-01 00:03:24.000000', 'consum', 0.0217, 'lps'),
	(560424, 129, '2014-03-01 00:03:25.000000', 'consum', 0.0226, 'lps'),
	(560425, 129, '2014-03-01 00:03:26.000000', 'consum', 0.0210, 'lps'),
	(560426, 129, '2014-03-01 00:03:27.000000', 'consum', 0.0222, 'lps'),
	(560427, 129, '2014-03-01 00:03:28.000000', 'consum', 0.0214, 'lps'),
	(560428, 129, '2014-03-01 00:03:29.000000', 'consum', 0.0221, 'lps'),
	(560429, 129, '2014-03-01 00:03:30.000000', 'consum', 0.0225, 'lps'),
	(560430, 129, '2014-03-01 00:03:31.000000', 'consum', 0.0225, 'lps'),
	(560431, 129, '2014-03-01 00:03:32.000000', 'consum', 0.0212, 'lps'),
	(560432, 129, '2014-03-01 00:03:33.000000', 'consum', 0.0233, 'lps'),
	(560433, 129, '2014-03-01 00:03:34.000000', 'consum', 0.0234, 'lps'),
	(560434, 129, '2014-03-01 00:03:35.000000', 'consum', 0.0231, 'lps'),
	(560435, 129, '2014-03-01 00:03:36.000000', 'consum', 0.0216, 'lps'),
	(560436, 129, '2014-03-01 00:03:37.000000', 'consum', 0.0233, 'lps'),
	(560437, 129, '2014-03-01 00:03:38.000000', 'consum', 0.0219, 'lps'),
	(560438, 129, '2014-03-01 00:03:39.000000', 'consum', 0.0219, 'lps'),
	(560439, 129, '2014-03-01 00:03:40.000000', 'consum', 0.0229, 'lps'),
	(560440, 129, '2014-03-01 00:03:41.000000', 'consum', 0.0218, 'lps'),
	(560441, 129, '2014-03-01 00:03:42.000000', 'consum', 0.0225, 'lps'),
	(560442, 129, '2014-03-01 00:03:43.000000', 'consum', 0.0233, 'lps'),
	(560443, 129, '2014-03-01 00:03:44.000000', 'consum', 0.0220, 'lps'),
	(560444, 129, '2014-03-01 00:03:45.000000', 'consum', 0.0221, 'lps'),
	(560445, 129, '2014-03-01 00:03:46.000000', 'consum', 0.0238, 'lps'),
	(560446, 129, '2014-03-01 00:03:47.000000', 'consum', 0.0227, 'lps'),
	(560447, 129, '2014-03-01 00:03:48.000000', 'consum', 0.0213, 'lps'),
	(560448, 129, '2014-03-01 00:03:49.000000', 'consum', 0.0231, 'lps'),
	(560449, 129, '2014-03-01 00:03:50.000000', 'consum', 0.0222, 'lps'),
	(560450, 129, '2014-03-01 00:03:51.000000', 'consum', 0.0234, 'lps'),
	(560451, 129, '2014-03-01 00:03:52.000000', 'consum', 0.0237, 'lps'),
	(560452, 129, '2014-03-01 00:03:53.000000', 'consum', 0.0215, 'lps'),
	(560453, 129, '2014-03-01 00:03:54.000000', 'consum', 0.0213, 'lps'),
	(560454, 129, '2014-03-01 00:03:55.000000', 'consum', 0.0210, 'lps'),
	(560455, 129, '2014-03-01 00:03:56.000000', 'consum', 0.0231, 'lps'),
	(560456, 129, '2014-03-01 00:03:57.000000', 'consum', 0.0230, 'lps'),
	(560457, 129, '2014-03-01 00:03:58.000000', 'consum', 0.0218, 'lps'),
	(560458, 129, '2014-03-01 00:03:59.000000', 'consum', 0.0219, 'lps'),
	(560459, 129, '2014-03-01 00:04:00.000000', 'consum', 0.0232, 'lps'),
	(560460, 129, '2014-03-01 00:04:01.000000', 'consum', 0.0234, 'lps'),
	(560461, 129, '2014-03-01 00:04:02.000000', 'consum', 0.0235, 'lps'),
	(560462, 129, '2014-03-01 00:04:03.000000', 'consum', 0.0236, 'lps'),
	(560463, 129, '2014-03-01 00:04:04.000000', 'consum', 0.0235, 'lps'),
	(560464, 129, '2014-03-01 00:04:05.000000', 'consum', 0.0230, 'lps'),
	(560465, 129, '2014-03-01 00:04:06.000000', 'consum', 0.0237, 'lps'),
	(560466, 129, '2014-03-01 00:04:07.000000', 'consum', 0.0225, 'lps'),
	(560467, 129, '2014-03-01 00:04:08.000000', 'consum', 0.0232, 'lps'),
	(560468, 129, '2014-03-01 00:04:09.000000', 'consum', 0.0220, 'lps'),
	(560469, 129, '2014-03-01 00:04:10.000000', 'consum', 0.0224, 'lps'),
	(560470, 129, '2014-03-01 00:04:11.000000', 'consum', 0.0221, 'lps'),
	(560471, 129, '2014-03-01 00:04:12.000000', 'consum', 0.0222, 'lps'),
	(560472, 129, '2014-03-01 00:04:13.000000', 'consum', 0.0237, 'lps'),
	(560473, 129, '2014-03-01 00:04:14.000000', 'consum', 0.0223, 'lps'),
	(560474, 129, '2014-03-01 00:04:15.000000', 'consum', 0.0225, 'lps'),
	(560475, 129, '2014-03-01 00:04:16.000000', 'consum', 0.0218, 'lps'),
	(560476, 129, '2014-03-01 00:04:17.000000', 'consum', 0.0233, 'lps'),
	(560477, 129, '2014-03-01 00:04:18.000000', 'consum', 0.0214, 'lps'),
	(560478, 129, '2014-03-01 00:04:19.000000', 'consum', 0.0222, 'lps'),
	(560479, 129, '2014-03-01 00:04:20.000000', 'consum', 0.0227, 'lps'),
	(560480, 129, '2014-03-01 00:04:21.000000', 'consum', 0.0230, 'lps'),
	(560481, 129, '2014-03-01 00:04:22.000000', 'consum', 0.0231, 'lps'),
	(560482, 129, '2014-03-01 00:04:23.000000', 'consum', 0.0228, 'lps'),
	(560483, 129, '2014-03-01 00:04:24.000000', 'consum', 0.0235, 'lps'),
	(560484, 129, '2014-03-01 00:04:25.000000', 'consum', 0.0226, 'lps'),
	(560485, 129, '2014-03-01 00:04:26.000000', 'consum', 0.0213, 'lps'),
	(560486, 129, '2014-03-01 00:04:27.000000', 'consum', 0.0237, 'lps'),
	(560487, 129, '2014-03-01 00:04:28.000000', 'consum', 0.0218, 'lps'),
	(560488, 129, '2014-03-01 00:04:29.000000', 'consum', 0.0230, 'lps'),
	(560489, 129, '2014-03-01 00:04:30.000000', 'consum', 0.0227, 'lps'),
	(560490, 129, '2014-03-01 00:04:31.000000', 'consum', 0.0238, 'lps'),
	(560491, 129, '2014-03-01 00:04:32.000000', 'consum', 0.0211, 'lps'),
	(560492, 129, '2014-03-01 00:04:33.000000', 'consum', 0.0219, 'lps'),
	(560493, 129, '2014-03-01 00:04:34.000000', 'consum', 0.0223, 'lps'),
	(560494, 129, '2014-03-01 00:04:35.000000', 'consum', 0.0222, 'lps'),
	(560495, 129, '2014-03-01 00:04:36.000000', 'consum', 0.0228, 'lps'),
	(560496, 129, '2014-03-01 00:04:37.000000', 'consum', 0.0238, 'lps'),
	(560497, 129, '2014-03-01 00:04:38.000000', 'consum', 0.0238, 'lps'),
	(560498, 129, '2014-03-01 00:04:39.000000', 'consum', 0.0237, 'lps'),
	(560499, 129, '2014-03-01 00:04:40.000000', 'consum', 0.0232, 'lps'),
	(560500, 129, '2014-03-01 00:04:41.000000', 'consum', 0.0211, 'lps'),
	(560501, 129, '2014-03-01 00:04:42.000000', 'consum', 0.0237, 'lps'),
	(560502, 129, '2014-03-01 00:04:43.000000', 'consum', 0.0227, 'lps'),
	(560503, 129, '2014-03-01 00:04:44.000000', 'consum', 0.0214, 'lps'),
	(560504, 129, '2014-03-01 00:04:45.000000', 'consum', 0.0235, 'lps'),
	(560505, 129, '2014-03-01 00:04:46.000000', 'consum', 0.0211, 'lps'),
	(560506, 129, '2014-03-01 00:04:47.000000', 'consum', 0.0226, 'lps'),
	(560507, 129, '2014-03-01 00:04:48.000000', 'consum', 0.0231, 'lps'),
	(560508, 129, '2014-03-01 00:04:49.000000', 'consum', 0.0237, 'lps'),
	(560509, 129, '2014-03-01 00:04:50.000000', 'consum', 0.0226, 'lps'),
	(560510, 129, '2014-03-01 00:04:51.000000', 'consum', 0.0210, 'lps'),
	(560511, 129, '2014-03-01 00:04:52.000000', 'consum', 0.0219, 'lps'),
	(560512, 129, '2014-03-01 00:04:53.000000', 'consum', 0.0225, 'lps'),
	(560513, 129, '2014-03-01 00:04:54.000000', 'consum', 0.0233, 'lps'),
	(560514, 129, '2014-03-01 00:04:55.000000', 'consum', 0.0220, 'lps'),
	(560515, 129, '2014-03-01 00:04:56.000000', 'consum', 0.0220, 'lps'),
	(560516, 129, '2014-03-01 00:04:57.000000', 'consum', 0.0229, 'lps'),
	(560517, 129, '2014-03-01 00:04:58.000000', 'consum', 0.0220, 'lps'),
	(560518, 129, '2014-03-01 00:04:59.000000', 'consum', 0.0232, 'lps'),
	(560519, 129, '2014-03-01 00:05:00.000000', 'consum', 0.0234, 'lps'),
	(560520, 129, '2014-03-01 00:05:01.000000', 'consum', 0.0233, 'lps'),
	(560521, 129, '2014-03-01 00:05:02.000000', 'consum', 0.0224, 'lps'),
	(560522, 129, '2014-03-01 00:05:03.000000', 'consum', 0.0214, 'lps'),
	(560523, 129, '2014-03-01 00:05:04.000000', 'consum', 0.0217, 'lps'),
	(560524, 129, '2014-03-01 00:05:05.000000', 'consum', 0.0235, 'lps'),
	(560525, 129, '2014-03-01 00:05:06.000000', 'consum', 0.0225, 'lps'),
	(560526, 129, '2014-03-01 00:05:07.000000', 'consum', 0.0212, 'lps'),
	(560527, 129, '2014-03-01 00:05:08.000000', 'consum', 0.0232, 'lps'),
	(560528, 129, '2014-03-01 00:05:09.000000', 'consum', 0.0227, 'lps'),
	(560529, 129, '2014-03-01 00:05:10.000000', 'consum', 0.0231, 'lps'),
	(560530, 129, '2014-03-01 00:05:11.000000', 'consum', 0.0236, 'lps'),
	(560531, 129, '2014-03-01 00:05:12.000000', 'consum', 0.0218, 'lps'),
	(560532, 129, '2014-03-01 00:05:13.000000', 'consum', 0.0233, 'lps'),
	(560533, 129, '2014-03-01 00:05:14.000000', 'consum', 0.0213, 'lps'),
	(560534, 129, '2014-03-01 00:05:15.000000', 'consum', 0.0215, 'lps'),
	(560535, 129, '2014-03-01 00:05:16.000000', 'consum', 0.0227, 'lps'),
	(560536, 129, '2014-03-01 00:05:17.000000', 'consum', 0.0222, 'lps'),
	(560537, 129, '2014-03-01 00:05:18.000000', 'consum', 0.0218, 'lps'),
	(560538, 129, '2014-03-01 00:05:19.000000', 'consum', 0.0214, 'lps'),
	(560539, 129, '2014-03-01 00:05:20.000000', 'consum', 0.0235, 'lps'),
	(560540, 129, '2014-03-01 00:05:21.000000', 'consum', 0.0238, 'lps'),
	(560541, 129, '2014-03-01 00:05:22.000000', 'consum', 0.0219, 'lps'),
	(560542, 129, '2014-03-01 00:05:23.000000', 'consum', 0.0227, 'lps'),
	(560543, 129, '2014-03-01 00:05:24.000000', 'consum', 0.0211, 'lps'),
	(560544, 129, '2014-03-01 00:05:25.000000', 'consum', 0.0224, 'lps'),
	(560545, 129, '2014-03-01 00:05:26.000000', 'consum', 0.0219, 'lps'),
	(560546, 129, '2014-03-01 00:05:27.000000', 'consum', 0.0213, 'lps'),
	(560547, 129, '2014-03-01 00:05:28.000000', 'consum', 0.0226, 'lps'),
	(560548, 129, '2014-03-01 00:05:29.000000', 'consum', 0.0225, 'lps'),
	(560549, 129, '2014-03-01 00:05:30.000000', 'consum', 0.0237, 'lps'),
	(560550, 129, '2014-03-01 00:05:31.000000', 'consum', 0.0214, 'lps'),
	(560551, 129, '2014-03-01 00:05:32.000000', 'consum', 0.0235, 'lps'),
	(560552, 129, '2014-03-01 00:05:33.000000', 'consum', 0.0238, 'lps'),
	(560553, 129, '2014-03-01 00:05:34.000000', 'consum', 0.0218, 'lps'),
	(560554, 129, '2014-03-01 00:05:35.000000', 'consum', 0.0223, 'lps'),
	(560555, 129, '2014-03-01 00:05:36.000000', 'consum', 0.0224, 'lps'),
	(560556, 129, '2014-03-01 00:05:37.000000', 'consum', 0.0210, 'lps'),
	(560557, 129, '2014-03-01 00:05:38.000000', 'consum', 0.0228, 'lps'),
	(560558, 129, '2014-03-01 00:05:39.000000', 'consum', 0.0214, 'lps'),
	(560559, 129, '2014-03-01 00:05:40.000000', 'consum', 0.0232, 'lps'),
	(560560, 129, '2014-03-01 00:05:41.000000', 'consum', 0.0223, 'lps'),
	(560561, 129, '2014-03-01 00:05:42.000000', 'consum', 0.0238, 'lps'),
	(560562, 129, '2014-03-01 00:05:43.000000', 'consum', 0.0224, 'lps'),
	(560563, 129, '2014-03-01 00:05:44.000000', 'consum', 0.0225, 'lps'),
	(560564, 129, '2014-03-01 00:05:45.000000', 'consum', 0.0217, 'lps'),
	(560565, 129, '2014-03-01 00:05:46.000000', 'consum', 0.0229, 'lps'),
	(560566, 129, '2014-03-01 00:05:47.000000', 'consum', 0.0226, 'lps'),
	(560567, 129, '2014-03-01 00:05:48.000000', 'consum', 0.0233, 'lps'),
	(560568, 129, '2014-03-01 00:05:49.000000', 'consum', 0.0219, 'lps'),
	(560569, 129, '2014-03-01 00:05:50.000000', 'consum', 0.0218, 'lps'),
	(560570, 129, '2014-03-01 00:05:51.000000', 'consum', 0.0222, 'lps'),
	(560571, 129, '2014-03-01 00:05:52.000000', 'consum', 0.0217, 'lps'),
	(560572, 129, '2014-03-01 00:05:53.000000', 'consum', 0.0238, 'lps'),
	(560573, 129, '2014-03-01 00:05:54.000000', 'consum', 0.0216, 'lps'),
	(560574, 129, '2014-03-01 00:05:55.000000', 'consum', 0.0213, 'lps'),
	(560575, 129, '2014-03-01 00:05:56.000000', 'consum', 0.0235, 'lps'),
	(560576, 129, '2014-03-01 00:05:57.000000', 'consum', 0.0211, 'lps'),
	(560577, 129, '2014-03-01 00:05:58.000000', 'consum', 0.0229, 'lps'),
	(560578, 129, '2014-03-01 00:05:59.000000', 'consum', 0.0216, 'lps'),
	(560579, 129, '2014-03-01 00:06:00.000000', 'consum', 0.0213, 'lps'),
	(560580, 129, '2014-03-01 00:06:01.000000', 'consum', 0.0234, 'lps'),
	(560581, 129, '2014-03-01 00:06:02.000000', 'consum', 0.0236, 'lps'),
	(560582, 129, '2014-03-01 00:06:03.000000', 'consum', 0.0211, 'lps'),
	(560583, 129, '2014-03-01 00:06:04.000000', 'consum', 0.0223, 'lps'),
	(560584, 129, '2014-03-01 00:06:05.000000', 'consum', 0.0215, 'lps'),
	(560585, 129, '2014-03-01 00:06:06.000000', 'consum', 0.0225, 'lps'),
	(560586, 129, '2014-03-01 00:06:07.000000', 'consum', 0.0213, 'lps'),
	(560587, 129, '2014-03-01 00:06:08.000000', 'consum', 0.0210, 'lps'),
	(560588, 129, '2014-03-01 00:06:09.000000', 'consum', 0.0231, 'lps'),
	(560589, 129, '2014-03-01 00:06:10.000000', 'consum', 0.0229, 'lps'),
	(560590, 129, '2014-03-01 00:06:11.000000', 'consum', 0.0213, 'lps'),
	(560591, 129, '2014-03-01 00:06:12.000000', 'consum', 0.0225, 'lps'),
	(560592, 129, '2014-03-01 00:06:13.000000', 'consum', 0.0220, 'lps'),
	(560593, 129, '2014-03-01 00:06:14.000000', 'consum', 0.0217, 'lps'),
	(560594, 129, '2014-03-01 00:06:15.000000', 'consum', 0.0215, 'lps'),
	(560595, 129, '2014-03-01 00:06:16.000000', 'consum', 0.0213, 'lps'),
	(560596, 129, '2014-03-01 00:06:17.000000', 'consum', 0.0211, 'lps'),
	(560597, 129, '2014-03-01 00:06:18.000000', 'consum', 0.0237, 'lps'),
	(560598, 129, '2014-03-01 00:06:19.000000', 'consum', 0.0225, 'lps'),
	(560599, 129, '2014-03-01 00:06:20.000000', 'consum', 0.0233, 'lps'),
	(560600, 129, '2014-03-01 00:06:21.000000', 'consum', 0.0225, 'lps'),
	(560601, 129, '2014-03-01 00:06:22.000000', 'consum', 0.0214, 'lps'),
	(560602, 129, '2014-03-01 00:06:23.000000', 'consum', 0.0216, 'lps'),
	(560603, 129, '2014-03-01 00:06:24.000000', 'consum', 0.0227, 'lps'),
	(560604, 129, '2014-03-01 00:06:25.000000', 'consum', 0.0222, 'lps'),
	(560605, 129, '2014-03-01 00:06:26.000000', 'consum', 0.0220, 'lps'),
	(560606, 129, '2014-03-01 00:06:27.000000', 'consum', 0.0222, 'lps'),
	(560607, 129, '2014-03-01 00:06:28.000000', 'consum', 0.0214, 'lps'),
	(560608, 129, '2014-03-01 00:06:29.000000', 'consum', 0.0221, 'lps'),
	(560609, 129, '2014-03-01 00:06:30.000000', 'consum', 0.0224, 'lps'),
	(560610, 129, '2014-03-01 00:06:31.000000', 'consum', 0.0221, 'lps'),
	(560611, 129, '2014-03-01 00:06:32.000000', 'consum', 0.0221, 'lps'),
	(560612, 129, '2014-03-01 00:06:33.000000', 'consum', 0.0233, 'lps'),
	(560613, 129, '2014-03-01 00:06:34.000000', 'consum', 0.0235, 'lps'),
	(560614, 129, '2014-03-01 00:06:35.000000', 'consum', 0.0210, 'lps'),
	(560615, 129, '2014-03-01 00:06:36.000000', 'consum', 0.0223, 'lps'),
	(560616, 129, '2014-03-01 00:06:37.000000', 'consum', 0.0215, 'lps'),
	(560617, 129, '2014-03-01 00:06:38.000000', 'consum', 0.0228, 'lps'),
	(560618, 129, '2014-03-01 00:06:39.000000', 'consum', 0.0228, 'lps'),
	(560619, 129, '2014-03-01 00:06:40.000000', 'consum', 0.0218, 'lps'),
	(560620, 129, '2014-03-01 00:06:41.000000', 'consum', 0.0226, 'lps'),
	(560621, 129, '2014-03-01 00:06:42.000000', 'consum', 0.0236, 'lps'),
	(560622, 129, '2014-03-01 00:06:43.000000', 'consum', 0.0235, 'lps'),
	(560623, 129, '2014-03-01 00:06:44.000000', 'consum', 0.0229, 'lps'),
	(560624, 129, '2014-03-01 00:06:45.000000', 'consum', 0.0228, 'lps'),
	(560625, 129, '2014-03-01 00:06:46.000000', 'consum', 0.0216, 'lps'),
	(560626, 129, '2014-03-01 00:06:47.000000', 'consum', 0.0215, 'lps'),
	(560627, 129, '2014-03-01 00:06:48.000000', 'consum', 0.0217, 'lps'),
	(560628, 129, '2014-03-01 00:06:49.000000', 'consum', 0.0233, 'lps'),
	(560629, 129, '2014-03-01 00:06:50.000000', 'consum', 0.0216, 'lps'),
	(560630, 129, '2014-03-01 00:06:51.000000', 'consum', 0.0228, 'lps'),
	(560631, 129, '2014-03-01 00:06:52.000000', 'consum', 0.0225, 'lps'),
	(560632, 129, '2014-03-01 00:06:53.000000', 'consum', 0.0233, 'lps'),
	(560633, 129, '2014-03-01 00:06:54.000000', 'consum', 0.0221, 'lps'),
	(560634, 129, '2014-03-01 00:06:55.000000', 'consum', 0.0224, 'lps'),
	(560635, 129, '2014-03-01 00:06:56.000000', 'consum', 0.0222, 'lps'),
	(560636, 129, '2014-03-01 00:06:57.000000', 'consum', 0.0226, 'lps'),
	(560637, 129, '2014-03-01 00:06:58.000000', 'consum', 0.0228, 'lps'),
	(560638, 129, '2014-03-01 00:06:59.000000', 'consum', 0.0222, 'lps'),
	(560639, 129, '2014-03-01 00:07:00.000000', 'consum', 0.0219, 'lps'),
	(560640, 129, '2014-03-01 00:07:01.000000', 'consum', 0.0216, 'lps'),
	(560641, 129, '2014-03-01 00:07:02.000000', 'consum', 0.0216, 'lps'),
	(560642, 129, '2014-03-01 00:07:03.000000', 'consum', 0.0220, 'lps'),
	(560643, 129, '2014-03-01 00:07:04.000000', 'consum', 0.0215, 'lps'),
	(560644, 129, '2014-03-01 00:07:05.000000', 'consum', 0.0234, 'lps'),
	(560645, 129, '2014-03-01 00:07:06.000000', 'consum', 0.0229, 'lps'),
	(560646, 129, '2014-03-01 00:07:07.000000', 'consum', 0.0234, 'lps'),
	(560647, 129, '2014-03-01 00:07:08.000000', 'consum', 0.0215, 'lps'),
	(560648, 129, '2014-03-01 00:07:09.000000', 'consum', 0.0223, 'lps'),
	(560649, 129, '2014-03-01 00:07:10.000000', 'consum', 0.0231, 'lps'),
	(560650, 129, '2014-03-01 00:07:11.000000', 'consum', 0.0217, 'lps'),
	(560651, 129, '2014-03-01 00:07:12.000000', 'consum', 0.0213, 'lps'),
	(560652, 129, '2014-03-01 00:07:13.000000', 'consum', 0.0231, 'lps'),
	(560653, 129, '2014-03-01 00:07:14.000000', 'consum', 0.0223, 'lps'),
	(560654, 129, '2014-03-01 00:07:15.000000', 'consum', 0.0210, 'lps'),
	(560655, 129, '2014-03-01 00:07:16.000000', 'consum', 0.0231, 'lps'),
	(560656, 129, '2014-03-01 00:07:17.000000', 'consum', 0.0230, 'lps'),
	(560657, 129, '2014-03-01 00:07:18.000000', 'consum', 0.0217, 'lps'),
	(560658, 129, '2014-03-01 00:07:19.000000', 'consum', 0.0214, 'lps'),
	(560659, 129, '2014-03-01 00:07:20.000000', 'consum', 0.0210, 'lps'),
	(560660, 129, '2014-03-01 00:07:21.000000', 'consum', 0.0226, 'lps'),
	(560661, 129, '2014-03-01 00:07:22.000000', 'consum', 0.0235, 'lps'),
	(560662, 129, '2014-03-01 00:07:23.000000', 'consum', 0.0227, 'lps'),
	(560663, 129, '2014-03-01 00:07:24.000000', 'consum', 0.0219, 'lps'),
	(560664, 129, '2014-03-01 00:07:25.000000', 'consum', 0.0237, 'lps'),
	(560665, 129, '2014-03-01 00:07:26.000000', 'consum', 0.0230, 'lps'),
	(560666, 129, '2014-03-01 00:07:27.000000', 'consum', 0.0230, 'lps'),
	(560667, 129, '2014-03-01 00:07:28.000000', 'consum', 0.0223, 'lps'),
	(560668, 129, '2014-03-01 00:07:29.000000', 'consum', 0.0215, 'lps'),
	(560669, 129, '2014-03-01 00:07:30.000000', 'consum', 0.0224, 'lps'),
	(560670, 129, '2014-03-01 00:07:31.000000', 'consum', 0.0210, 'lps'),
	(560671, 129, '2014-03-01 00:07:32.000000', 'consum', 0.0226, 'lps'),
	(560672, 129, '2014-03-01 00:07:33.000000', 'consum', 0.0233, 'lps'),
	(560673, 129, '2014-03-01 00:07:34.000000', 'consum', 0.0220, 'lps'),
	(560674, 129, '2014-03-01 00:07:35.000000', 'consum', 0.0218, 'lps'),
	(560675, 129, '2014-03-01 00:07:36.000000', 'consum', 0.0223, 'lps'),
	(560676, 129, '2014-03-01 00:07:37.000000', 'consum', 0.0221, 'lps'),
	(560677, 129, '2014-03-01 00:07:38.000000', 'consum', 0.0229, 'lps'),
	(560678, 129, '2014-03-01 00:07:39.000000', 'consum', 0.0213, 'lps'),
	(560679, 129, '2014-03-01 00:07:40.000000', 'consum', 0.0226, 'lps'),
	(560680, 129, '2014-03-01 00:07:41.000000', 'consum', 0.0226, 'lps'),
	(560681, 129, '2014-03-01 00:07:42.000000', 'consum', 0.0212, 'lps'),
	(560682, 129, '2014-03-01 00:07:43.000000', 'consum', 0.0230, 'lps'),
	(560683, 129, '2014-03-01 00:07:44.000000', 'consum', 0.0218, 'lps'),
	(560684, 129, '2014-03-01 00:07:45.000000', 'consum', 0.0220, 'lps'),
	(560685, 129, '2014-03-01 00:07:46.000000', 'consum', 0.0237, 'lps'),
	(560686, 129, '2014-03-01 00:07:47.000000', 'consum', 0.0229, 'lps'),
	(560687, 129, '2014-03-01 00:07:48.000000', 'consum', 0.0222, 'lps'),
	(560688, 129, '2014-03-01 00:07:49.000000', 'consum', 0.0216, 'lps'),
	(560689, 129, '2014-03-01 00:07:50.000000', 'consum', 0.0233, 'lps'),
	(560690, 129, '2014-03-01 00:07:51.000000', 'consum', 0.0222, 'lps'),
	(560691, 129, '2014-03-01 00:07:52.000000', 'consum', 0.0230, 'lps'),
	(560692, 129, '2014-03-01 00:07:53.000000', 'consum', 0.0216, 'lps'),
	(560693, 129, '2014-03-01 00:07:54.000000', 'consum', 0.0210, 'lps'),
	(560694, 129, '2014-03-01 00:07:55.000000', 'consum', 0.0223, 'lps'),
	(560695, 129, '2014-03-01 00:07:56.000000', 'consum', 0.0215, 'lps'),
	(560696, 129, '2014-03-01 00:07:57.000000', 'consum', 0.0228, 'lps'),
	(560697, 129, '2014-03-01 00:07:58.000000', 'consum', 0.0224, 'lps'),
	(560698, 129, '2014-03-01 00:07:59.000000', 'consum', 0.0230, 'lps'),
	(560699, 129, '2014-03-01 00:08:00.000000', 'consum', 0.0237, 'lps'),
	(560700, 129, '2014-03-01 00:08:01.000000', 'consum', 0.0229, 'lps'),
	(560701, 129, '2014-03-01 00:08:02.000000', 'consum', 0.0223, 'lps'),
	(560702, 129, '2014-03-01 00:08:03.000000', 'consum', 0.0221, 'lps'),
	(560703, 129, '2014-03-01 00:08:04.000000', 'consum', 0.0224, 'lps'),
	(560704, 129, '2014-03-01 00:08:05.000000', 'consum', 0.0218, 'lps'),
	(560705, 129, '2014-03-01 00:08:06.000000', 'consum', 0.0238, 'lps'),
	(560706, 129, '2014-03-01 00:08:07.000000', 'consum', 0.0212, 'lps'),
	(560707, 129, '2014-03-01 00:08:08.000000', 'consum', 0.0221, 'lps'),
	(560708, 129, '2014-03-01 00:08:09.000000', 'consum', 0.0230, 'lps'),
	(560709, 129, '2014-03-01 00:08:10.000000', 'consum', 0.0220, 'lps'),
	(560710, 129, '2014-03-01 00:08:11.000000', 'consum', 0.0230, 'lps'),
	(560711, 129, '2014-03-01 00:08:12.000000', 'consum', 0.0225, 'lps'),
	(560712, 129, '2014-03-01 00:08:13.000000', 'consum', 0.0222, 'lps'),
	(560713, 129, '2014-03-01 00:08:14.000000', 'consum', 0.0226, 'lps'),
	(560714, 129, '2014-03-01 00:08:15.000000', 'consum', 0.0226, 'lps'),
	(560715, 129, '2014-03-01 00:08:16.000000', 'consum', 0.0212, 'lps'),
	(560716, 129, '2014-03-01 00:08:17.000000', 'consum', 0.0233, 'lps'),
	(560717, 129, '2014-03-01 00:08:18.000000', 'consum', 0.0229, 'lps'),
	(560718, 129, '2014-03-01 00:08:19.000000', 'consum', 0.0211, 'lps'),
	(560719, 129, '2014-03-01 00:08:20.000000', 'consum', 0.0215, 'lps'),
	(560720, 129, '2014-03-01 00:08:21.000000', 'consum', 0.0234, 'lps'),
	(560721, 129, '2014-03-01 00:08:22.000000', 'consum', 0.0228, 'lps'),
	(560722, 129, '2014-03-01 00:08:23.000000', 'consum', 0.0230, 'lps'),
	(560723, 129, '2014-03-01 00:08:24.000000', 'consum', 0.0228, 'lps'),
	(560724, 129, '2014-03-01 00:08:25.000000', 'consum', 0.0238, 'lps'),
	(560725, 129, '2014-03-01 00:08:26.000000', 'consum', 0.0211, 'lps'),
	(560726, 129, '2014-03-01 00:08:27.000000', 'consum', 0.0216, 'lps'),
	(560727, 129, '2014-03-01 00:08:28.000000', 'consum', 0.0212, 'lps'),
	(560728, 129, '2014-03-01 00:08:29.000000', 'consum', 0.0229, 'lps'),
	(560729, 129, '2014-03-01 00:08:30.000000', 'consum', 0.0214, 'lps'),
	(560730, 129, '2014-03-01 00:08:31.000000', 'consum', 0.0231, 'lps'),
	(560731, 129, '2014-03-01 00:08:32.000000', 'consum', 0.0214, 'lps'),
	(560732, 129, '2014-03-01 00:08:33.000000', 'consum', 0.0229, 'lps'),
	(560733, 129, '2014-03-01 00:08:34.000000', 'consum', 0.0235, 'lps'),
	(560734, 129, '2014-03-01 00:08:35.000000', 'consum', 0.0219, 'lps'),
	(560735, 129, '2014-03-01 00:08:36.000000', 'consum', 0.0212, 'lps'),
	(560736, 129, '2014-03-01 00:08:37.000000', 'consum', 0.0222, 'lps'),
	(560737, 129, '2014-03-01 00:08:38.000000', 'consum', 0.0237, 'lps'),
	(560738, 129, '2014-03-01 00:08:39.000000', 'consum', 0.0219, 'lps'),
	(560739, 129, '2014-03-01 00:08:40.000000', 'consum', 0.0236, 'lps'),
	(560740, 129, '2014-03-01 00:08:41.000000', 'consum', 0.0224, 'lps'),
	(560741, 129, '2014-03-01 00:08:42.000000', 'consum', 0.0231, 'lps'),
	(560742, 129, '2014-03-01 00:08:43.000000', 'consum', 0.0215, 'lps'),
	(560743, 129, '2014-03-01 00:08:44.000000', 'consum', 0.0233, 'lps'),
	(560744, 129, '2014-03-01 00:08:45.000000', 'consum', 0.0222, 'lps'),
	(560745, 129, '2014-03-01 00:08:46.000000', 'consum', 0.0232, 'lps'),
	(560746, 129, '2014-03-01 00:08:47.000000', 'consum', 0.0225, 'lps'),
	(560747, 129, '2014-03-01 00:08:48.000000', 'consum', 0.0221, 'lps'),
	(560748, 129, '2014-03-01 00:08:49.000000', 'consum', 0.0220, 'lps'),
	(560749, 129, '2014-03-01 00:08:50.000000', 'consum', 0.0227, 'lps'),
	(560750, 129, '2014-03-01 00:08:51.000000', 'consum', 0.0235, 'lps'),
	(560751, 129, '2014-03-01 00:08:52.000000', 'consum', 0.0227, 'lps'),
	(560752, 129, '2014-03-01 00:08:53.000000', 'consum', 0.0223, 'lps'),
	(560753, 129, '2014-03-01 00:08:54.000000', 'consum', 0.0224, 'lps'),
	(560754, 129, '2014-03-01 00:08:55.000000', 'consum', 0.0210, 'lps'),
	(560755, 129, '2014-03-01 00:08:56.000000', 'consum', 0.0228, 'lps'),
	(560756, 129, '2014-03-01 00:08:57.000000', 'consum', 0.0215, 'lps'),
	(560757, 129, '2014-03-01 00:08:58.000000', 'consum', 0.0211, 'lps'),
	(560758, 129, '2014-03-01 00:08:59.000000', 'consum', 0.0228, 'lps'),
	(560759, 129, '2014-03-01 00:09:00.000000', 'consum', 0.0212, 'lps'),
	(560760, 129, '2014-03-01 00:09:01.000000', 'consum', 0.0225, 'lps'),
	(560761, 129, '2014-03-01 00:09:02.000000', 'consum', 0.0220, 'lps'),
	(560762, 129, '2014-03-01 00:09:03.000000', 'consum', 0.0217, 'lps'),
	(560763, 129, '2014-03-01 00:09:04.000000', 'consum', 0.0213, 'lps'),
	(560764, 129, '2014-03-01 00:09:05.000000', 'consum', 0.0233, 'lps'),
	(560765, 129, '2014-03-01 00:09:06.000000', 'consum', 0.0232, 'lps'),
	(560766, 129, '2014-03-01 00:09:07.000000', 'consum', 0.0222, 'lps'),
	(560767, 129, '2014-03-01 00:09:08.000000', 'consum', 0.0232, 'lps'),
	(560768, 129, '2014-03-01 00:09:09.000000', 'consum', 0.0225, 'lps'),
	(560769, 129, '2014-03-01 00:09:10.000000', 'consum', 0.0223, 'lps'),
	(560770, 129, '2014-03-01 00:09:11.000000', 'consum', 0.0227, 'lps'),
	(560771, 129, '2014-03-01 00:09:12.000000', 'consum', 0.0229, 'lps'),
	(560772, 129, '2014-03-01 00:09:13.000000', 'consum', 0.0227, 'lps'),
	(560773, 129, '2014-03-01 00:09:14.000000', 'consum', 0.0238, 'lps'),
	(560774, 129, '2014-03-01 00:09:15.000000', 'consum', 0.0212, 'lps'),
	(560775, 129, '2014-03-01 00:09:16.000000', 'consum', 0.0225, 'lps'),
	(560776, 129, '2014-03-01 00:09:17.000000', 'consum', 0.0222, 'lps'),
	(560777, 129, '2014-03-01 00:09:18.000000', 'consum', 0.0225, 'lps'),
	(560778, 129, '2014-03-01 00:09:19.000000', 'consum', 0.0219, 'lps'),
	(560779, 129, '2014-03-01 00:09:20.000000', 'consum', 0.0211, 'lps'),
	(560780, 129, '2014-03-01 00:09:21.000000', 'consum', 0.0219, 'lps'),
	(560781, 129, '2014-03-01 00:09:22.000000', 'consum', 0.0224, 'lps'),
	(560782, 129, '2014-03-01 00:09:23.000000', 'consum', 0.0225, 'lps'),
	(560783, 129, '2014-03-01 00:09:24.000000', 'consum', 0.0213, 'lps'),
	(560784, 129, '2014-03-01 00:09:25.000000', 'consum', 0.0211, 'lps'),
	(560785, 129, '2014-03-01 00:09:26.000000', 'consum', 0.0233, 'lps'),
	(560786, 129, '2014-03-01 00:09:27.000000', 'consum', 0.0235, 'lps'),
	(560787, 129, '2014-03-01 00:09:28.000000', 'consum', 0.0210, 'lps'),
	(560788, 129, '2014-03-01 00:09:29.000000', 'consum', 0.0221, 'lps'),
	(560789, 129, '2014-03-01 00:09:30.000000', 'consum', 0.0237, 'lps'),
	(560790, 129, '2014-03-01 00:09:31.000000', 'consum', 0.0228, 'lps'),
	(560791, 129, '2014-03-01 00:09:32.000000', 'consum', 0.0217, 'lps'),
	(560792, 129, '2014-03-01 00:09:33.000000', 'consum', 0.0220, 'lps'),
	(560793, 129, '2014-03-01 00:09:34.000000', 'consum', 0.0212, 'lps'),
	(560794, 129, '2014-03-01 00:09:35.000000', 'consum', 0.0218, 'lps'),
	(560795, 129, '2014-03-01 00:09:36.000000', 'consum', 0.0217, 'lps'),
	(560796, 129, '2014-03-01 00:09:37.000000', 'consum', 0.0219, 'lps'),
	(560797, 129, '2014-03-01 00:09:38.000000', 'consum', 0.0236, 'lps'),
	(560798, 129, '2014-03-01 00:09:39.000000', 'consum', 0.0227, 'lps'),
	(560799, 129, '2014-03-01 00:09:40.000000', 'consum', 0.0217, 'lps'),
	(560800, 129, '2014-03-01 00:09:41.000000', 'consum', 0.0224, 'lps'),
	(560801, 129, '2014-03-01 00:09:42.000000', 'consum', 0.0229, 'lps'),
	(560802, 129, '2014-03-01 00:09:43.000000', 'consum', 0.0236, 'lps'),
	(560803, 129, '2014-03-01 00:09:44.000000', 'consum', 0.0227, 'lps'),
	(560804, 129, '2014-03-01 00:09:45.000000', 'consum', 0.0217, 'lps'),
	(560805, 129, '2014-03-01 00:09:46.000000', 'consum', 0.0222, 'lps'),
	(560806, 129, '2014-03-01 00:09:47.000000', 'consum', 0.0220, 'lps'),
	(560807, 129, '2014-03-01 00:09:48.000000', 'consum', 0.0225, 'lps'),
	(560808, 129, '2014-03-01 00:09:49.000000', 'consum', 0.0226, 'lps'),
	(560809, 129, '2014-03-01 00:09:50.000000', 'consum', 0.0218, 'lps'),
	(560810, 129, '2014-03-01 00:09:51.000000', 'consum', 0.0231, 'lps'),
	(560811, 129, '2014-03-01 00:09:52.000000', 'consum', 0.0235, 'lps'),
	(560812, 129, '2014-03-01 00:09:53.000000', 'consum', 0.0213, 'lps'),
	(560813, 129, '2014-03-01 00:09:54.000000', 'consum', 0.0238, 'lps'),
	(560814, 129, '2014-03-01 00:09:55.000000', 'consum', 0.0224, 'lps'),
	(560815, 129, '2014-03-01 00:09:56.000000', 'consum', 0.0228, 'lps'),
	(560816, 129, '2014-03-01 00:09:57.000000', 'consum', 0.0227, 'lps'),
	(560817, 129, '2014-03-01 00:09:58.000000', 'consum', 0.0211, 'lps'),
	(560818, 129, '2014-03-01 00:09:59.000000', 'consum', 0.0226, 'lps'),
	(560819, 129, '2014-03-01 00:10:00.000000', 'consum', 0.0229, 'lps'),
	(560820, 129, '2014-03-01 00:10:01.000000', 'consum', 0.0226, 'lps'),
	(560821, 129, '2014-03-01 00:10:02.000000', 'consum', 0.0235, 'lps'),
	(560822, 129, '2014-03-01 00:10:03.000000', 'consum', 0.0229, 'lps'),
	(560823, 129, '2014-03-01 00:10:04.000000', 'consum', 0.0229, 'lps'),
	(560824, 129, '2014-03-01 00:10:05.000000', 'consum', 0.0222, 'lps'),
	(560825, 129, '2014-03-01 00:10:06.000000', 'consum', 0.0212, 'lps'),
	(560826, 129, '2014-03-01 00:10:07.000000', 'consum', 0.0215, 'lps'),
	(560827, 129, '2014-03-01 00:10:08.000000', 'consum', 0.0229, 'lps'),
	(560828, 129, '2014-03-01 00:10:09.000000', 'consum', 0.0231, 'lps'),
	(560829, 129, '2014-03-01 00:10:10.000000', 'consum', 0.0232, 'lps'),
	(560830, 129, '2014-03-01 00:10:11.000000', 'consum', 0.0225, 'lps'),
	(560831, 129, '2014-03-01 00:10:12.000000', 'consum', 0.0223, 'lps'),
	(560832, 129, '2014-03-01 00:10:13.000000', 'consum', 0.0228, 'lps'),
	(560833, 129, '2014-03-01 00:10:14.000000', 'consum', 0.0232, 'lps'),
	(560834, 129, '2014-03-01 00:10:15.000000', 'consum', 0.0210, 'lps'),
	(560835, 129, '2014-03-01 00:10:16.000000', 'consum', 0.0230, 'lps'),
	(560836, 129, '2014-03-01 00:10:17.000000', 'consum', 0.0224, 'lps'),
	(560837, 129, '2014-03-01 00:10:18.000000', 'consum', 0.0219, 'lps'),
	(560838, 129, '2014-03-01 00:10:19.000000', 'consum', 0.0215, 'lps'),
	(560839, 129, '2014-03-01 00:10:20.000000', 'consum', 0.0238, 'lps'),
	(560840, 129, '2014-03-01 00:10:21.000000', 'consum', 0.0217, 'lps'),
	(560841, 129, '2014-03-01 00:10:22.000000', 'consum', 0.0222, 'lps'),
	(560842, 129, '2014-03-01 00:10:23.000000', 'consum', 0.0219, 'lps'),
	(560843, 129, '2014-03-01 00:10:24.000000', 'consum', 0.0220, 'lps'),
	(560844, 129, '2014-03-01 00:10:25.000000', 'consum', 0.0233, 'lps'),
	(560845, 129, '2014-03-01 00:10:26.000000', 'consum', 0.0237, 'lps'),
	(560846, 129, '2014-03-01 00:10:27.000000', 'consum', 0.0218, 'lps'),
	(560847, 129, '2014-03-01 00:10:28.000000', 'consum', 0.0228, 'lps'),
	(560848, 129, '2014-03-01 00:10:29.000000', 'consum', 0.0218, 'lps'),
	(560849, 129, '2014-03-01 00:10:30.000000', 'consum', 0.0227, 'lps'),
	(560850, 129, '2014-03-01 00:10:31.000000', 'consum', 0.0212, 'lps'),
	(560851, 129, '2014-03-01 00:10:32.000000', 'consum', 0.0228, 'lps'),
	(560852, 129, '2014-03-01 00:10:33.000000', 'consum', 0.0235, 'lps'),
	(560853, 129, '2014-03-01 00:10:34.000000', 'consum', 0.0226, 'lps'),
	(560854, 129, '2014-03-01 00:10:35.000000', 'consum', 0.0214, 'lps'),
	(560855, 129, '2014-03-01 00:10:36.000000', 'consum', 0.0212, 'lps'),
	(560856, 129, '2014-03-01 00:10:37.000000', 'consum', 0.0238, 'lps'),
	(560857, 129, '2014-03-01 00:10:38.000000', 'consum', 0.0228, 'lps'),
	(560858, 129, '2014-03-01 00:10:39.000000', 'consum', 0.0218, 'lps'),
	(560859, 129, '2014-03-01 00:10:40.000000', 'consum', 0.0225, 'lps'),
	(560860, 129, '2014-03-01 00:10:41.000000', 'consum', 0.0234, 'lps'),
	(560861, 129, '2014-03-01 00:10:42.000000', 'consum', 0.0224, 'lps'),
	(560862, 129, '2014-03-01 00:10:43.000000', 'consum', 0.0212, 'lps'),
	(560863, 129, '2014-03-01 00:10:44.000000', 'consum', 0.0233, 'lps'),
	(560864, 129, '2014-03-01 00:10:45.000000', 'consum', 0.0235, 'lps'),
	(560865, 129, '2014-03-01 00:10:46.000000', 'consum', 0.0238, 'lps'),
	(560866, 129, '2014-03-01 00:10:47.000000', 'consum', 0.0215, 'lps'),
	(560867, 129, '2014-03-01 00:10:48.000000', 'consum', 0.0210, 'lps'),
	(560868, 129, '2014-03-01 00:10:49.000000', 'consum', 0.0225, 'lps'),
	(560869, 129, '2014-03-01 00:10:50.000000', 'consum', 0.0227, 'lps'),
	(560870, 129, '2014-03-01 00:10:51.000000', 'consum', 0.0221, 'lps'),
	(560871, 129, '2014-03-01 00:10:52.000000', 'consum', 0.0214, 'lps'),
	(560872, 129, '2014-03-01 00:10:53.000000', 'consum', 0.0229, 'lps'),
	(560873, 129, '2014-03-01 00:10:54.000000', 'consum', 0.0233, 'lps'),
	(560874, 129, '2014-03-01 00:10:55.000000', 'consum', 0.0210, 'lps'),
	(560875, 129, '2014-03-01 00:10:56.000000', 'consum', 0.0229, 'lps'),
	(560876, 129, '2014-03-01 00:10:57.000000', 'consum', 0.0218, 'lps'),
	(560877, 129, '2014-03-01 00:10:58.000000', 'consum', 0.0224, 'lps'),
	(560878, 129, '2014-03-01 00:10:59.000000', 'consum', 0.0228, 'lps'),
	(560879, 129, '2014-03-01 00:11:00.000000', 'consum', 0.0228, 'lps'),
	(560880, 129, '2014-03-01 00:11:01.000000', 'consum', 0.0220, 'lps'),
	(560881, 129, '2014-03-01 00:11:02.000000', 'consum', 0.0233, 'lps'),
	(560882, 129, '2014-03-01 00:11:03.000000', 'consum', 0.0237, 'lps'),
	(560883, 129, '2014-03-01 00:11:04.000000', 'consum', 0.0219, 'lps'),
	(560884, 129, '2014-03-01 00:11:05.000000', 'consum', 0.0233, 'lps'),
	(560885, 129, '2014-03-01 00:11:06.000000', 'consum', 0.0211, 'lps'),
	(560886, 129, '2014-03-01 00:11:07.000000', 'consum', 0.0234, 'lps'),
	(560887, 129, '2014-03-01 00:11:08.000000', 'consum', 0.0213, 'lps'),
	(560888, 129, '2014-03-01 00:11:09.000000', 'consum', 0.0212, 'lps'),
	(560889, 129, '2014-03-01 00:11:10.000000', 'consum', 0.0210, 'lps'),
	(560890, 129, '2014-03-01 00:11:11.000000', 'consum', 0.0235, 'lps'),
	(560891, 129, '2014-03-01 00:11:12.000000', 'consum', 0.0218, 'lps'),
	(560892, 129, '2014-03-01 00:11:13.000000', 'consum', 0.0234, 'lps'),
	(560893, 129, '2014-03-01 00:11:14.000000', 'consum', 0.0221, 'lps'),
	(560894, 129, '2014-03-01 00:11:15.000000', 'consum', 0.0219, 'lps'),
	(560895, 129, '2014-03-01 00:11:16.000000', 'consum', 0.0226, 'lps'),
	(560896, 129, '2014-03-01 00:11:17.000000', 'consum', 0.0233, 'lps'),
	(560897, 129, '2014-03-01 00:11:18.000000', 'consum', 0.0220, 'lps'),
	(560898, 129, '2014-03-01 00:11:19.000000', 'consum', 0.0222, 'lps'),
	(560899, 129, '2014-03-01 00:11:20.000000', 'consum', 0.0238, 'lps'),
	(560900, 129, '2014-03-01 00:11:21.000000', 'consum', 0.0227, 'lps'),
	(560901, 129, '2014-03-01 00:11:22.000000', 'consum', 0.0214, 'lps'),
	(560902, 129, '2014-03-01 00:11:23.000000', 'consum', 0.0237, 'lps'),
	(560903, 129, '2014-03-01 00:11:24.000000', 'consum', 0.0218, 'lps'),
	(560904, 129, '2014-03-01 00:11:25.000000', 'consum', 0.0227, 'lps'),
	(560905, 129, '2014-03-01 00:11:26.000000', 'consum', 0.0214, 'lps'),
	(560906, 129, '2014-03-01 00:11:27.000000', 'consum', 0.0237, 'lps'),
	(560907, 129, '2014-03-01 00:11:28.000000', 'consum', 0.0218, 'lps'),
	(560908, 129, '2014-03-01 00:11:29.000000', 'consum', 0.0227, 'lps'),
	(560909, 129, '2014-03-01 00:11:30.000000', 'consum', 0.0213, 'lps'),
	(560910, 129, '2014-03-01 00:11:31.000000', 'consum', 0.0234, 'lps'),
	(560911, 129, '2014-03-01 00:11:32.000000', 'consum', 0.0233, 'lps'),
	(560912, 129, '2014-03-01 00:11:33.000000', 'consum', 0.0224, 'lps'),
	(560913, 129, '2014-03-01 00:11:34.000000', 'consum', 0.0214, 'lps'),
	(560914, 129, '2014-03-01 00:11:35.000000', 'consum', 0.0216, 'lps'),
	(560915, 129, '2014-03-01 00:11:36.000000', 'consum', 0.0231, 'lps'),
	(560916, 129, '2014-03-01 00:11:37.000000', 'consum', 0.0236, 'lps'),
	(560917, 129, '2014-03-01 00:11:38.000000', 'consum', 0.0221, 'lps'),
	(560918, 129, '2014-03-01 00:11:39.000000', 'consum', 0.0216, 'lps'),
	(560919, 129, '2014-03-01 00:11:40.000000', 'consum', 0.0237, 'lps'),
	(560920, 129, '2014-03-01 00:11:41.000000', 'consum', 0.0238, 'lps'),
	(560921, 129, '2014-03-01 00:11:42.000000', 'consum', 0.0214, 'lps'),
	(560922, 129, '2014-03-01 00:11:43.000000', 'consum', 0.0234, 'lps'),
	(560923, 129, '2014-03-01 00:11:44.000000', 'consum', 0.0230, 'lps'),
	(560924, 129, '2014-03-01 00:11:45.000000', 'consum', 0.0211, 'lps'),
	(560925, 129, '2014-03-01 00:11:46.000000', 'consum', 0.0214, 'lps'),
	(560926, 129, '2014-03-01 00:11:47.000000', 'consum', 0.0225, 'lps'),
	(560927, 129, '2014-03-01 00:11:48.000000', 'consum', 0.0215, 'lps'),
	(560928, 129, '2014-03-01 00:11:49.000000', 'consum', 0.0219, 'lps'),
	(560929, 129, '2014-03-01 00:11:50.000000', 'consum', 0.0212, 'lps'),
	(560930, 129, '2014-03-01 00:11:51.000000', 'consum', 0.0225, 'lps'),
	(560931, 129, '2014-03-01 00:11:52.000000', 'consum', 0.0219, 'lps'),
	(560932, 129, '2014-03-01 00:11:53.000000', 'consum', 0.0213, 'lps'),
	(560933, 129, '2014-03-01 00:11:54.000000', 'consum', 0.0225, 'lps'),
	(560934, 129, '2014-03-01 00:11:55.000000', 'consum', 0.0220, 'lps'),
	(560935, 129, '2014-03-01 00:11:56.000000', 'consum', 0.0214, 'lps'),
	(560936, 129, '2014-03-01 00:11:57.000000', 'consum', 0.0232, 'lps'),
	(560937, 129, '2014-03-01 00:11:58.000000', 'consum', 0.0221, 'lps'),
	(560938, 129, '2014-03-01 00:11:59.000000', 'consum', 0.0228, 'lps'),
	(560939, 129, '2014-03-01 00:12:00.000000', 'consum', 0.0212, 'lps'),
	(560940, 129, '2014-03-01 00:12:01.000000', 'consum', 0.0221, 'lps'),
	(560941, 129, '2014-03-01 00:12:02.000000', 'consum', 0.0232, 'lps'),
	(560942, 129, '2014-03-01 00:12:03.000000', 'consum', 0.0228, 'lps'),
	(560943, 129, '2014-03-01 00:12:04.000000', 'consum', 0.0234, 'lps'),
	(560944, 129, '2014-03-01 00:12:05.000000', 'consum', 0.0219, 'lps'),
	(560945, 129, '2014-03-01 00:12:06.000000', 'consum', 0.0215, 'lps'),
	(560946, 129, '2014-03-01 00:12:07.000000', 'consum', 0.0236, 'lps'),
	(560947, 129, '2014-03-01 00:12:08.000000', 'consum', 0.0238, 'lps'),
	(560948, 129, '2014-03-01 00:12:09.000000', 'consum', 0.0214, 'lps'),
	(560949, 129, '2014-03-01 00:12:10.000000', 'consum', 0.0235, 'lps'),
	(560950, 129, '2014-03-01 00:12:11.000000', 'consum', 0.0235, 'lps'),
	(560951, 129, '2014-03-01 00:12:12.000000', 'consum', 0.0230, 'lps'),
	(560952, 129, '2014-03-01 00:12:13.000000', 'consum', 0.0238, 'lps'),
	(560953, 129, '2014-03-01 00:12:14.000000', 'consum', 0.0234, 'lps'),
	(560954, 129, '2014-03-01 00:12:15.000000', 'consum', 0.0215, 'lps'),
	(560955, 129, '2014-03-01 00:12:16.000000', 'consum', 0.0220, 'lps'),
	(560956, 129, '2014-03-01 00:12:17.000000', 'consum', 0.0220, 'lps'),
	(560957, 129, '2014-03-01 00:12:18.000000', 'consum', 0.0228, 'lps'),
	(560958, 129, '2014-03-01 00:12:19.000000', 'consum', 0.0213, 'lps'),
	(560959, 129, '2014-03-01 00:12:20.000000', 'consum', 0.0229, 'lps'),
	(560960, 129, '2014-03-01 00:12:21.000000', 'consum', 0.0210, 'lps'),
	(560961, 129, '2014-03-01 00:12:22.000000', 'consum', 0.0211, 'lps'),
	(560962, 129, '2014-03-01 00:12:23.000000', 'consum', 0.0215, 'lps'),
	(560963, 129, '2014-03-01 00:12:24.000000', 'consum', 0.0235, 'lps'),
	(560964, 129, '2014-03-01 00:12:25.000000', 'consum', 0.0233, 'lps'),
	(560965, 129, '2014-03-01 00:12:26.000000', 'consum', 0.0222, 'lps'),
	(560966, 129, '2014-03-01 00:12:27.000000', 'consum', 0.0228, 'lps'),
	(560967, 129, '2014-03-01 00:12:28.000000', 'consum', 0.0237, 'lps'),
	(560968, 129, '2014-03-01 00:12:29.000000', 'consum', 0.0232, 'lps'),
	(560969, 129, '2014-03-01 00:12:30.000000', 'consum', 0.0211, 'lps'),
	(560970, 129, '2014-03-01 00:12:31.000000', 'consum', 0.0210, 'lps'),
	(560971, 129, '2014-03-01 00:12:32.000000', 'consum', 0.0235, 'lps'),
	(560972, 129, '2014-03-01 00:12:33.000000', 'consum', 0.0218, 'lps'),
	(560973, 129, '2014-03-01 00:12:34.000000', 'consum', 0.0234, 'lps'),
	(560974, 129, '2014-03-01 00:12:35.000000', 'consum', 0.0218, 'lps'),
	(560975, 129, '2014-03-01 00:12:36.000000', 'consum', 0.0238, 'lps'),
	(560976, 129, '2014-03-01 00:12:37.000000', 'consum', 0.0237, 'lps'),
	(560977, 129, '2014-03-01 00:12:38.000000', 'consum', 0.0236, 'lps'),
	(560978, 129, '2014-03-01 00:12:39.000000', 'consum', 0.0230, 'lps'),
	(560979, 129, '2014-03-01 00:12:40.000000', 'consum', 0.0231, 'lps'),
	(560980, 129, '2014-03-01 00:12:41.000000', 'consum', 0.0229, 'lps'),
	(560981, 129, '2014-03-01 00:12:42.000000', 'consum', 0.0214, 'lps'),
	(560982, 129, '2014-03-01 00:12:43.000000', 'consum', 0.0228, 'lps'),
	(560983, 129, '2014-03-01 00:12:44.000000', 'consum', 0.0233, 'lps'),
	(560984, 129, '2014-03-01 00:12:45.000000', 'consum', 0.0212, 'lps'),
	(560985, 129, '2014-03-01 00:12:46.000000', 'consum', 0.0210, 'lps'),
	(560986, 129, '2014-03-01 00:12:47.000000', 'consum', 0.0235, 'lps'),
	(560987, 129, '2014-03-01 00:12:48.000000', 'consum', 0.0219, 'lps'),
	(560988, 129, '2014-03-01 00:12:49.000000', 'consum', 0.0238, 'lps'),
	(560989, 129, '2014-03-01 00:12:50.000000', 'consum', 0.0235, 'lps'),
	(560990, 129, '2014-03-01 00:12:51.000000', 'consum', 0.0223, 'lps'),
	(560991, 129, '2014-03-01 00:12:52.000000', 'consum', 0.0229, 'lps'),
	(560992, 129, '2014-03-01 00:12:53.000000', 'consum', 0.0237, 'lps'),
	(560993, 129, '2014-03-01 00:12:54.000000', 'consum', 0.0230, 'lps'),
	(560994, 129, '2014-03-01 00:12:55.000000', 'consum', 0.0230, 'lps'),
	(560995, 129, '2014-03-01 00:12:56.000000', 'consum', 0.0220, 'lps'),
	(560996, 129, '2014-03-01 00:12:57.000000', 'consum', 0.0231, 'lps'),
	(560997, 129, '2014-03-01 00:12:58.000000', 'consum', 0.0226, 'lps'),
	(560998, 129, '2014-03-01 00:12:59.000000', 'consum', 0.0228, 'lps'),
	(560999, 129, '2014-03-01 00:13:00.000000', 'consum', 0.0226, 'lps'),
	(561000, 129, '2014-03-01 00:13:01.000000', 'consum', 0.0234, 'lps'),
	(561001, 129, '2014-03-01 00:13:02.000000', 'consum', 0.0225, 'lps'),
	(561002, 129, '2014-03-01 00:13:03.000000', 'consum', 0.0215, 'lps'),
	(561003, 129, '2014-03-01 00:13:04.000000', 'consum', 0.0219, 'lps'),
	(561004, 129, '2014-03-01 00:13:05.000000', 'consum', 0.0238, 'lps'),
	(561005, 129, '2014-03-01 00:13:06.000000', 'consum', 0.0211, 'lps'),
	(561006, 129, '2014-03-01 00:13:07.000000', 'consum', 0.0217, 'lps'),
	(561007, 129, '2014-03-01 00:13:08.000000', 'consum', 0.0212, 'lps'),
	(561008, 129, '2014-03-01 00:13:09.000000', 'consum', 0.0230, 'lps'),
	(561009, 129, '2014-03-01 00:13:10.000000', 'consum', 0.0219, 'lps'),
	(561010, 129, '2014-03-01 00:13:11.000000', 'consum', 0.0222, 'lps'),
	(561011, 129, '2014-03-01 00:13:12.000000', 'consum', 0.0216, 'lps'),
	(561012, 129, '2014-03-01 00:13:13.000000', 'consum', 0.0233, 'lps'),
	(561013, 129, '2014-03-01 00:13:14.000000', 'consum', 0.0219, 'lps'),
	(561014, 129, '2014-03-01 00:13:15.000000', 'consum', 0.0217, 'lps'),
	(561015, 129, '2014-03-01 00:13:16.000000', 'consum', 0.0216, 'lps'),
	(561016, 129, '2014-03-01 00:13:17.000000', 'consum', 0.0222, 'lps'),
	(561017, 129, '2014-03-01 00:13:18.000000', 'consum', 0.0224, 'lps'),
	(561018, 129, '2014-03-01 00:13:19.000000', 'consum', 0.0213, 'lps'),
	(561019, 129, '2014-03-01 00:13:20.000000', 'consum', 0.0214, 'lps'),
	(561020, 129, '2014-03-01 00:13:21.000000', 'consum', 0.0220, 'lps'),
	(561021, 129, '2014-03-01 00:13:22.000000', 'consum', 0.0220, 'lps'),
	(561022, 129, '2014-03-01 00:13:23.000000', 'consum', 0.0232, 'lps'),
	(561023, 129, '2014-03-01 00:13:24.000000', 'consum', 0.0231, 'lps'),
	(561024, 129, '2014-03-01 00:13:25.000000', 'consum', 0.0222, 'lps'),
	(561025, 129, '2014-03-01 00:13:26.000000', 'consum', 0.0237, 'lps'),
	(561026, 129, '2014-03-01 00:13:27.000000', 'consum', 0.0220, 'lps'),
	(561027, 129, '2014-03-01 00:13:28.000000', 'consum', 0.0237, 'lps'),
	(561028, 129, '2014-03-01 00:13:29.000000', 'consum', 0.0230, 'lps'),
	(561029, 129, '2014-03-01 00:13:30.000000', 'consum', 0.0227, 'lps'),
	(561030, 129, '2014-03-01 00:13:31.000000', 'consum', 0.0238, 'lps'),
	(561031, 129, '2014-03-01 00:13:32.000000', 'consum', 0.0213, 'lps'),
	(561032, 129, '2014-03-01 00:13:33.000000', 'consum', 0.0229, 'lps'),
	(561033, 129, '2014-03-01 00:13:34.000000', 'consum', 0.0238, 'lps'),
	(561034, 129, '2014-03-01 00:13:35.000000', 'consum', 0.0235, 'lps'),
	(561035, 129, '2014-03-01 00:13:36.000000', 'consum', 0.0224, 'lps'),
	(561036, 129, '2014-03-01 00:13:37.000000', 'consum', 0.0233, 'lps'),
	(561037, 129, '2014-03-01 00:13:38.000000', 'consum', 0.0227, 'lps'),
	(561038, 129, '2014-03-01 00:13:39.000000', 'consum', 0.0227, 'lps'),
	(561039, 129, '2014-03-01 00:13:40.000000', 'consum', 0.0214, 'lps'),
	(561040, 129, '2014-03-01 00:13:41.000000', 'consum', 0.0211, 'lps'),
	(561041, 129, '2014-03-01 00:13:42.000000', 'consum', 0.0231, 'lps'),
	(561042, 129, '2014-03-01 00:13:43.000000', 'consum', 0.0225, 'lps'),
	(561043, 129, '2014-03-01 00:13:44.000000', 'consum', 0.0225, 'lps'),
	(561044, 129, '2014-03-01 00:13:45.000000', 'consum', 0.0237, 'lps'),
	(561045, 129, '2014-03-01 00:13:46.000000', 'consum', 0.0215, 'lps'),
	(561046, 129, '2014-03-01 00:13:47.000000', 'consum', 0.0214, 'lps'),
	(561047, 129, '2014-03-01 00:13:48.000000', 'consum', 0.0213, 'lps'),
	(561048, 129, '2014-03-01 00:13:49.000000', 'consum', 0.0213, 'lps'),
	(561049, 129, '2014-03-01 00:13:50.000000', 'consum', 0.0216, 'lps'),
	(561050, 129, '2014-03-01 00:13:51.000000', 'consum', 0.0235, 'lps'),
	(561051, 129, '2014-03-01 00:13:52.000000', 'consum', 0.0227, 'lps'),
	(561052, 129, '2014-03-01 00:13:53.000000', 'consum', 0.0224, 'lps'),
	(561053, 129, '2014-03-01 00:13:54.000000', 'consum', 0.0227, 'lps'),
	(561054, 129, '2014-03-01 00:13:55.000000', 'consum', 0.0226, 'lps'),
	(561055, 129, '2014-03-01 00:13:56.000000', 'consum', 0.0238, 'lps'),
	(561056, 129, '2014-03-01 00:13:57.000000', 'consum', 0.0215, 'lps'),
	(561057, 129, '2014-03-01 00:13:58.000000', 'consum', 0.0212, 'lps'),
	(561058, 129, '2014-03-01 00:13:59.000000', 'consum', 0.0234, 'lps'),
	(561059, 129, '2014-03-01 00:14:00.000000', 'consum', 0.0237, 'lps'),
	(561060, 129, '2014-03-01 00:14:01.000000', 'consum', 0.0217, 'lps'),
	(561061, 129, '2014-03-01 00:14:02.000000', 'consum', 0.0222, 'lps'),
	(561062, 129, '2014-03-01 00:14:03.000000', 'consum', 0.0220, 'lps'),
	(561063, 129, '2014-03-01 00:14:04.000000', 'consum', 0.0225, 'lps'),
	(561064, 129, '2014-03-01 00:14:05.000000', 'consum', 0.0227, 'lps'),
	(561065, 129, '2014-03-01 00:14:06.000000', 'consum', 0.0221, 'lps'),
	(561066, 129, '2014-03-01 00:14:07.000000', 'consum', 0.0214, 'lps'),
	(561067, 129, '2014-03-01 00:14:08.000000', 'consum', 0.0228, 'lps'),
	(561068, 129, '2014-03-01 00:14:09.000000', 'consum', 0.0231, 'lps'),
	(561069, 129, '2014-03-01 00:14:10.000000', 'consum', 0.0231, 'lps'),
	(561070, 129, '2014-03-01 00:14:11.000000', 'consum', 0.0222, 'lps'),
	(561071, 129, '2014-03-01 00:14:12.000000', 'consum', 0.0238, 'lps'),
	(561072, 129, '2014-03-01 00:14:13.000000', 'consum', 0.0229, 'lps'),
	(561073, 129, '2014-03-01 00:14:14.000000', 'consum', 0.0222, 'lps'),
	(561074, 129, '2014-03-01 00:14:15.000000', 'consum', 0.0212, 'lps'),
	(561075, 129, '2014-03-01 00:14:16.000000', 'consum', 0.0214, 'lps'),
	(561076, 129, '2014-03-01 00:14:17.000000', 'consum', 0.0223, 'lps'),
	(561077, 129, '2014-03-01 00:14:18.000000', 'consum', 0.0235, 'lps'),
	(561078, 129, '2014-03-01 00:14:19.000000', 'consum', 0.0210, 'lps'),
	(561079, 129, '2014-03-01 00:14:20.000000', 'consum', 0.0221, 'lps'),
	(561080, 129, '2014-03-01 00:14:21.000000', 'consum', 0.0238, 'lps'),
	(561081, 129, '2014-03-01 00:14:22.000000', 'consum', 0.0231, 'lps'),
	(561082, 129, '2014-03-01 00:14:23.000000', 'consum', 0.0231, 'lps'),
	(561083, 129, '2014-03-01 00:14:24.000000', 'consum', 0.0223, 'lps'),
	(561084, 129, '2014-03-01 00:14:25.000000', 'consum', 0.0213, 'lps'),
	(561085, 129, '2014-03-01 00:14:26.000000', 'consum', 0.0214, 'lps'),
	(561086, 129, '2014-03-01 00:14:27.000000', 'consum', 0.0224, 'lps'),
	(561087, 129, '2014-03-01 00:14:28.000000', 'consum', 0.0237, 'lps'),
	(561088, 129, '2014-03-01 00:14:29.000000', 'consum', 0.0218, 'lps'),
	(561089, 129, '2014-03-01 00:14:30.000000', 'consum', 0.0228, 'lps'),
	(561090, 129, '2014-03-01 00:14:31.000000', 'consum', 0.0220, 'lps'),
	(561091, 129, '2014-03-01 00:14:32.000000', 'consum', 0.0234, 'lps'),
	(561092, 129, '2014-03-01 00:14:33.000000', 'consum', 0.0214, 'lps'),
	(561093, 129, '2014-03-01 00:14:34.000000', 'consum', 0.0218, 'lps'),
	(561094, 129, '2014-03-01 00:14:35.000000', 'consum', 0.0235, 'lps'),
	(561095, 129, '2014-03-01 00:14:36.000000', 'consum', 0.0227, 'lps'),
	(561096, 129, '2014-03-01 00:14:37.000000', 'consum', 0.0219, 'lps'),
	(561097, 129, '2014-03-01 00:14:38.000000', 'consum', 0.0234, 'lps'),
	(561098, 129, '2014-03-01 00:14:39.000000', 'consum', 0.0216, 'lps'),
	(561099, 129, '2014-03-01 00:14:40.000000', 'consum', 0.0225, 'lps'),
	(561100, 129, '2014-03-01 00:14:41.000000', 'consum', 0.0210, 'lps'),
	(561101, 129, '2014-03-01 00:14:42.000000', 'consum', 0.0225, 'lps'),
	(561102, 129, '2014-03-01 00:14:43.000000', 'consum', 0.0228, 'lps'),
	(561103, 129, '2014-03-01 00:14:44.000000', 'consum', 0.0224, 'lps'),
	(561104, 129, '2014-03-01 00:14:45.000000', 'consum', 0.0229, 'lps'),
	(561105, 129, '2014-03-01 00:14:46.000000', 'consum', 0.0235, 'lps'),
	(561106, 129, '2014-03-01 00:14:47.000000', 'consum', 0.0221, 'lps'),
	(561107, 129, '2014-03-01 00:14:48.000000', 'consum', 0.0220, 'lps'),
	(561108, 129, '2014-03-01 00:14:49.000000', 'consum', 0.0225, 'lps'),
	(561109, 129, '2014-03-01 00:14:50.000000', 'consum', 0.0228, 'lps'),
	(561110, 129, '2014-03-01 00:14:51.000000', 'consum', 0.0226, 'lps'),
	(561111, 129, '2014-03-01 00:14:52.000000', 'consum', 0.0237, 'lps'),
	(561112, 129, '2014-03-01 00:14:53.000000', 'consum', 0.0210, 'lps'),
	(561113, 129, '2014-03-01 00:14:54.000000', 'consum', 0.0215, 'lps'),
	(561114, 129, '2014-03-01 00:14:55.000000', 'consum', 0.0238, 'lps'),
	(561115, 129, '2014-03-01 00:14:56.000000', 'consum', 0.0220, 'lps'),
	(561116, 129, '2014-03-01 00:14:57.000000', 'consum', 0.0236, 'lps'),
	(561117, 129, '2014-03-01 00:14:58.000000', 'consum', 0.0220, 'lps'),
	(561118, 129, '2014-03-01 00:14:59.000000', 'consum', 0.0211, 'lps'),
	(561119, 129, '2014-03-01 00:15:00.000000', 'consum', 0.0216, 'lps'),
	(561120, 129, '2014-03-01 00:15:01.000000', 'consum', 0.0238, 'lps'),
	(561121, 129, '2014-03-01 00:15:02.000000', 'consum', 0.0215, 'lps'),
	(561122, 129, '2014-03-01 00:15:03.000000', 'consum', 0.0211, 'lps'),
	(561123, 129, '2014-03-01 00:15:04.000000', 'consum', 0.0227, 'lps'),
	(561124, 129, '2014-03-01 00:15:05.000000', 'consum', 0.0236, 'lps'),
	(561125, 129, '2014-03-01 00:15:06.000000', 'consum', 0.0230, 'lps'),
	(561126, 129, '2014-03-01 00:15:07.000000', 'consum', 0.0234, 'lps'),
	(561127, 129, '2014-03-01 00:15:08.000000', 'consum', 0.0211, 'lps'),
	(561128, 129, '2014-03-01 00:15:09.000000', 'consum', 0.0233, 'lps'),
	(561129, 129, '2014-03-01 00:15:10.000000', 'consum', 0.0232, 'lps'),
	(561130, 129, '2014-03-01 00:15:11.000000', 'consum', 0.0225, 'lps'),
	(561131, 129, '2014-03-01 00:15:12.000000', 'consum', 0.0219, 'lps'),
	(561132, 129, '2014-03-01 00:15:13.000000', 'consum', 0.0210, 'lps'),
	(561133, 129, '2014-03-01 00:15:14.000000', 'consum', 0.0214, 'lps'),
	(561134, 129, '2014-03-01 00:15:15.000000', 'consum', 0.0228, 'lps'),
	(561135, 129, '2014-03-01 00:15:16.000000', 'consum', 0.0230, 'lps'),
	(561136, 129, '2014-03-01 00:15:17.000000', 'consum', 0.0230, 'lps'),
	(561137, 129, '2014-03-01 00:15:18.000000', 'consum', 0.0221, 'lps'),
	(561138, 129, '2014-03-01 00:15:19.000000', 'consum', 0.0232, 'lps'),
	(561139, 129, '2014-03-01 00:15:20.000000', 'consum', 0.0232, 'lps'),
	(561140, 129, '2014-03-01 00:15:21.000000', 'consum', 0.0226, 'lps'),
	(561141, 129, '2014-03-01 00:15:22.000000', 'consum', 0.0223, 'lps'),
	(561142, 129, '2014-03-01 00:15:23.000000', 'consum', 0.0230, 'lps'),
	(561143, 129, '2014-03-01 00:15:24.000000', 'consum', 0.0211, 'lps'),
	(561144, 129, '2014-03-01 00:15:25.000000', 'consum', 0.0215, 'lps'),
	(561145, 129, '2014-03-01 00:15:26.000000', 'consum', 0.0230, 'lps'),
	(561146, 129, '2014-03-01 00:15:27.000000', 'consum', 0.0211, 'lps'),
	(561147, 129, '2014-03-01 00:15:28.000000', 'consum', 0.0212, 'lps'),
	(561148, 129, '2014-03-01 00:15:29.000000', 'consum', 0.0217, 'lps'),
	(561149, 129, '2014-03-01 00:15:30.000000', 'consum', 0.0210, 'lps'),
	(561150, 129, '2014-03-01 00:15:31.000000', 'consum', 0.0218, 'lps'),
	(561151, 129, '2014-03-01 00:15:32.000000', 'consum', 0.0224, 'lps'),
	(561152, 129, '2014-03-01 00:15:33.000000', 'consum', 0.0226, 'lps'),
	(561153, 129, '2014-03-01 00:15:34.000000', 'consum', 0.0220, 'lps'),
	(561154, 129, '2014-03-01 00:15:35.000000', 'consum', 0.0213, 'lps'),
	(561155, 129, '2014-03-01 00:15:36.000000', 'consum', 0.0224, 'lps'),
	(561156, 129, '2014-03-01 00:15:37.000000', 'consum', 0.0214, 'lps'),
	(561157, 129, '2014-03-01 00:15:38.000000', 'consum', 0.0216, 'lps'),
	(561158, 129, '2014-03-01 00:15:39.000000', 'consum', 0.0230, 'lps'),
	(561159, 129, '2014-03-01 00:15:40.000000', 'consum', 0.0234, 'lps'),
	(561160, 129, '2014-03-01 00:15:41.000000', 'consum', 0.0213, 'lps'),
	(561161, 129, '2014-03-01 00:15:42.000000', 'consum', 0.0212, 'lps'),
	(561162, 129, '2014-03-01 00:15:43.000000', 'consum', 0.0210, 'lps'),
	(561163, 129, '2014-03-01 00:15:44.000000', 'consum', 0.0235, 'lps'),
	(561164, 129, '2014-03-01 00:15:45.000000', 'consum', 0.0217, 'lps'),
	(561165, 129, '2014-03-01 00:15:46.000000', 'consum', 0.0230, 'lps'),
	(561166, 129, '2014-03-01 00:15:47.000000', 'consum', 0.0231, 'lps'),
	(561167, 129, '2014-03-01 00:15:48.000000', 'consum', 0.0227, 'lps'),
	(561168, 129, '2014-03-01 00:15:49.000000', 'consum', 0.0231, 'lps'),
	(561169, 129, '2014-03-01 00:15:50.000000', 'consum', 0.0236, 'lps'),
	(561170, 129, '2014-03-01 00:15:51.000000', 'consum', 0.0222, 'lps'),
	(561171, 129, '2014-03-01 00:15:52.000000', 'consum', 0.0219, 'lps'),
	(561172, 129, '2014-03-01 00:15:53.000000', 'consum', 0.0219, 'lps'),
	(561173, 129, '2014-03-01 00:15:54.000000', 'consum', 0.0229, 'lps'),
	(561174, 129, '2014-03-01 00:15:55.000000', 'consum', 0.0219, 'lps'),
	(561175, 129, '2014-03-01 00:15:56.000000', 'consum', 0.0230, 'lps'),
	(561176, 129, '2014-03-01 00:15:57.000000', 'consum', 0.0223, 'lps'),
	(561177, 129, '2014-03-01 00:15:58.000000', 'consum', 0.0218, 'lps'),
	(561178, 129, '2014-03-01 00:15:59.000000', 'consum', 0.0212, 'lps'),
	(561179, 129, '2014-03-01 00:16:00.000000', 'consum', 0.0226, 'lps'),
	(561180, 129, '2014-03-01 00:16:01.000000', 'consum', 0.0225, 'lps'),
	(561181, 129, '2014-03-01 00:16:02.000000', 'consum', 0.0237, 'lps'),
	(561182, 129, '2014-03-01 00:16:03.000000', 'consum', 0.0215, 'lps'),
	(561183, 129, '2014-03-01 00:16:04.000000', 'consum', 0.0214, 'lps'),
	(561184, 129, '2014-03-01 00:16:05.000000', 'consum', 0.0213, 'lps'),
	(561185, 129, '2014-03-01 00:16:06.000000', 'consum', 0.0213, 'lps'),
	(561186, 129, '2014-03-01 00:16:07.000000', 'consum', 0.0216, 'lps'),
	(561187, 129, '2014-03-01 00:16:08.000000', 'consum', 0.0234, 'lps'),
	(561188, 129, '2014-03-01 00:16:09.000000', 'consum', 0.0225, 'lps'),
	(561189, 129, '2014-03-01 00:16:10.000000', 'consum', 0.0215, 'lps'),
	(561190, 129, '2014-03-01 00:16:11.000000', 'consum', 0.0217, 'lps'),
	(561191, 129, '2014-03-01 00:16:12.000000', 'consum', 0.0232, 'lps'),
	(561192, 129, '2014-03-01 00:16:13.000000', 'consum', 0.0211, 'lps'),
	(561193, 129, '2014-03-01 00:16:14.000000', 'consum', 0.0238, 'lps'),
	(561194, 129, '2014-03-01 00:16:15.000000', 'consum', 0.0233, 'lps'),
	(561195, 129, '2014-03-01 00:16:16.000000', 'consum', 0.0238, 'lps'),
	(561196, 129, '2014-03-01 00:16:17.000000', 'consum', 0.0226, 'lps'),
	(561197, 129, '2014-03-01 00:16:18.000000', 'consum', 0.0236, 'lps'),
	(561198, 129, '2014-03-01 00:16:19.000000', 'consum', 0.0235, 'lps'),
	(561199, 129, '2014-03-01 00:16:20.000000', 'consum', 0.0226, 'lps'),
	(561200, 129, '2014-03-01 00:16:21.000000', 'consum', 0.0216, 'lps'),
	(561201, 129, '2014-03-01 00:16:22.000000', 'consum', 0.0221, 'lps'),
	(561202, 129, '2014-03-01 00:16:23.000000', 'consum', 0.0219, 'lps'),
	(561203, 129, '2014-03-01 00:16:24.000000', 'consum', 0.0220, 'lps'),
	(561204, 129, '2014-03-01 00:16:25.000000', 'consum', 0.0237, 'lps'),
	(561205, 129, '2014-03-01 00:16:26.000000', 'consum', 0.0229, 'lps'),
	(561206, 129, '2014-03-01 00:16:27.000000', 'consum', 0.0222, 'lps'),
	(561207, 129, '2014-03-01 00:16:28.000000', 'consum', 0.0213, 'lps'),
	(561208, 129, '2014-03-01 00:16:29.000000', 'consum', 0.0220, 'lps'),
	(561209, 129, '2014-03-01 00:16:30.000000', 'consum', 0.0221, 'lps'),
	(561210, 129, '2014-03-01 00:16:31.000000', 'consum', 0.0236, 'lps'),
	(561211, 129, '2014-03-01 00:16:32.000000', 'consum', 0.0220, 'lps'),
	(561212, 129, '2014-03-01 00:16:33.000000', 'consum', 0.0212, 'lps'),
	(561213, 129, '2014-03-01 00:16:34.000000', 'consum', 0.0220, 'lps'),
	(561214, 129, '2014-03-01 00:16:35.000000', 'consum', 0.0227, 'lps'),
	(561215, 129, '2014-03-01 00:16:36.000000', 'consum', 0.0235, 'lps'),
	(561216, 129, '2014-03-01 00:16:37.000000', 'consum', 0.0225, 'lps'),
	(561217, 129, '2014-03-01 00:16:38.000000', 'consum', 0.0211, 'lps'),
	(561218, 129, '2014-03-01 00:16:39.000000', 'consum', 0.0230, 'lps'),
	(561219, 129, '2014-03-01 00:16:40.000000', 'consum', 0.0219, 'lps'),
	(561220, 129, '2014-03-01 00:16:41.000000', 'consum', 0.0223, 'lps'),
	(561221, 129, '2014-03-01 00:16:42.000000', 'consum', 0.0223, 'lps'),
	(561222, 129, '2014-03-01 00:16:43.000000', 'consum', 0.0234, 'lps'),
	(561223, 129, '2014-03-01 00:16:44.000000', 'consum', 0.0232, 'lps'),
	(561224, 129, '2014-03-01 00:16:45.000000', 'consum', 0.0222, 'lps'),
	(561225, 129, '2014-03-01 00:16:46.000000', 'consum', 0.0231, 'lps'),
	(561226, 129, '2014-03-01 00:16:47.000000', 'consum', 0.0222, 'lps'),
	(561227, 129, '2014-03-01 00:16:48.000000', 'consum', 0.0236, 'lps'),
	(561228, 129, '2014-03-01 00:16:49.000000', 'consum', 0.0219, 'lps'),
	(561229, 129, '2014-03-01 00:16:50.000000', 'consum', 0.0237, 'lps'),
	(561230, 129, '2014-03-01 00:16:51.000000', 'consum', 0.0229, 'lps'),
	(561231, 129, '2014-03-01 00:16:52.000000', 'consum', 0.0225, 'lps'),
	(561232, 129, '2014-03-01 00:16:53.000000', 'consum', 0.0228, 'lps'),
	(561233, 129, '2014-03-01 00:16:54.000000', 'consum', 0.0225, 'lps'),
	(561234, 129, '2014-03-01 00:16:55.000000', 'consum', 0.0233, 'lps'),
	(561235, 129, '2014-03-01 00:16:56.000000', 'consum', 0.0222, 'lps'),
	(561236, 129, '2014-03-01 00:16:57.000000', 'consum', 0.0229, 'lps'),
	(561237, 129, '2014-03-01 00:16:58.000000', 'consum', 0.0214, 'lps'),
	(561238, 129, '2014-03-01 00:16:59.000000', 'consum', 0.0232, 'lps'),
	(561239, 129, '2014-03-01 00:17:00.000000', 'consum', 0.0221, 'lps'),
	(561240, 129, '2014-03-01 00:17:01.000000', 'consum', 0.0229, 'lps'),
	(561241, 129, '2014-03-01 00:17:02.000000', 'consum', 0.0212, 'lps'),
	(561242, 129, '2014-03-01 00:17:03.000000', 'consum', 0.0223, 'lps'),
	(561243, 129, '2014-03-01 00:17:04.000000', 'consum', 0.0210, 'lps'),
	(561244, 129, '2014-03-01 00:17:05.000000', 'consum', 0.0231, 'lps'),
	(561245, 129, '2014-03-01 00:17:06.000000', 'consum', 0.0228, 'lps'),
	(561246, 129, '2014-03-01 00:17:07.000000', 'consum', 0.0236, 'lps'),
	(561247, 129, '2014-03-01 00:17:08.000000', 'consum', 0.0228, 'lps'),
	(561248, 129, '2014-03-01 00:17:09.000000', 'consum', 0.0226, 'lps'),
	(561249, 129, '2014-03-01 00:17:10.000000', 'consum', 0.0233, 'lps'),
	(561250, 129, '2014-03-01 00:17:11.000000', 'consum', 0.0223, 'lps'),
	(561251, 129, '2014-03-01 00:17:12.000000', 'consum', 0.0233, 'lps'),
	(561252, 129, '2014-03-01 00:17:13.000000', 'consum', 0.0228, 'lps'),
	(561253, 129, '2014-03-01 00:17:14.000000', 'consum', 0.0231, 'lps'),
	(561254, 129, '2014-03-01 00:17:15.000000', 'consum', 0.0233, 'lps'),
	(561255, 129, '2014-03-01 00:17:16.000000', 'consum', 0.0235, 'lps'),
	(561256, 129, '2014-03-01 00:17:17.000000', 'consum', 0.0237, 'lps'),
	(561257, 129, '2014-03-01 00:17:18.000000', 'consum', 0.0212, 'lps'),
	(561258, 129, '2014-03-01 00:17:19.000000', 'consum', 0.0225, 'lps'),
	(561259, 129, '2014-03-01 00:17:20.000000', 'consum', 0.0222, 'lps'),
	(561260, 129, '2014-03-01 00:17:21.000000', 'consum', 0.0227, 'lps'),
	(561261, 129, '2014-03-01 00:17:22.000000', 'consum', 0.0231, 'lps'),
	(561262, 129, '2014-03-01 00:17:23.000000', 'consum', 0.0235, 'lps'),
	(561263, 129, '2014-03-01 00:17:24.000000', 'consum', 0.0212, 'lps'),
	(561264, 129, '2014-03-01 00:17:25.000000', 'consum', 0.0236, 'lps'),
	(561265, 129, '2014-03-01 00:17:26.000000', 'consum', 0.0216, 'lps'),
	(561266, 129, '2014-03-01 00:17:27.000000', 'consum', 0.0221, 'lps'),
	(561267, 129, '2014-03-01 00:17:28.000000', 'consum', 0.0217, 'lps'),
	(561268, 129, '2014-03-01 00:17:29.000000', 'consum', 0.0213, 'lps'),
	(561269, 129, '2014-03-01 00:17:30.000000', 'consum', 0.0234, 'lps'),
	(561270, 129, '2014-03-01 00:17:31.000000', 'consum', 0.0235, 'lps'),
	(561271, 129, '2014-03-01 00:17:32.000000', 'consum', 0.0235, 'lps'),
	(561272, 129, '2014-03-01 00:17:33.000000', 'consum', 0.0231, 'lps'),
	(561273, 129, '2014-03-01 00:17:34.000000', 'consum', 0.0210, 'lps'),
	(561274, 129, '2014-03-01 00:17:35.000000', 'consum', 0.0235, 'lps'),
	(561275, 129, '2014-03-01 00:17:36.000000', 'consum', 0.0219, 'lps'),
	(561276, 129, '2014-03-01 00:17:37.000000', 'consum', 0.0210, 'lps'),
	(561277, 129, '2014-03-01 00:17:38.000000', 'consum', 0.0215, 'lps'),
	(561278, 129, '2014-03-01 00:17:39.000000', 'consum', 0.0232, 'lps'),
	(561279, 129, '2014-03-01 00:17:40.000000', 'consum', 0.0219, 'lps'),
	(561280, 129, '2014-03-01 00:17:41.000000', 'consum', 0.0220, 'lps'),
	(561281, 129, '2014-03-01 00:17:42.000000', 'consum', 0.0233, 'lps'),
	(561282, 129, '2014-03-01 00:17:43.000000', 'consum', 0.0237, 'lps'),
	(561283, 129, '2014-03-01 00:17:44.000000', 'consum', 0.0221, 'lps'),
	(561284, 129, '2014-03-01 00:17:45.000000', 'consum', 0.0211, 'lps'),
	(561285, 129, '2014-03-01 00:17:46.000000', 'consum', 0.0212, 'lps'),
	(561286, 129, '2014-03-01 00:17:47.000000', 'consum', 0.0217, 'lps'),
	(561287, 129, '2014-03-01 00:17:48.000000', 'consum', 0.0210, 'lps'),
	(561288, 129, '2014-03-01 00:17:49.000000', 'consum', 0.0217, 'lps'),
	(561289, 129, '2014-03-01 00:17:50.000000', 'consum', 0.0220, 'lps'),
	(561290, 129, '2014-03-01 00:17:51.000000', 'consum', 0.0238, 'lps'),
	(561291, 129, '2014-03-01 00:17:52.000000', 'consum', 0.0232, 'lps'),
	(561292, 129, '2014-03-01 00:17:53.000000', 'consum', 0.0238, 'lps'),
	(561293, 129, '2014-03-01 00:17:54.000000', 'consum', 0.0227, 'lps'),
	(561294, 129, '2014-03-01 00:17:55.000000', 'consum', 0.0212, 'lps'),
	(561295, 129, '2014-03-01 00:17:56.000000', 'consum', 0.0229, 'lps'),
	(561296, 129, '2014-03-01 00:17:57.000000', 'consum', 0.0238, 'lps'),
	(561297, 129, '2014-03-01 00:17:58.000000', 'consum', 0.0238, 'lps'),
	(561298, 129, '2014-03-01 00:17:59.000000', 'consum', 0.0236, 'lps'),
	(561299, 129, '2014-03-01 00:18:00.000000', 'consum', 0.0230, 'lps'),
	(561300, 129, '2014-03-01 00:18:01.000000', 'consum', 0.0229, 'lps'),
	(561301, 129, '2014-03-01 00:18:02.000000', 'consum', 0.0220, 'lps'),
	(561302, 129, '2014-03-01 00:18:03.000000', 'consum', 0.0230, 'lps'),
	(561303, 129, '2014-03-01 00:18:04.000000', 'consum', 0.0225, 'lps'),
	(561304, 129, '2014-03-01 00:18:05.000000', 'consum', 0.0223, 'lps'),
	(561305, 129, '2014-03-01 00:18:06.000000', 'consum', 0.0229, 'lps'),
	(561306, 129, '2014-03-01 00:18:07.000000', 'consum', 0.0212, 'lps'),
	(561307, 129, '2014-03-01 00:18:08.000000', 'consum', 0.0218, 'lps'),
	(561308, 129, '2014-03-01 00:18:09.000000', 'consum', 0.0218, 'lps'),
	(561309, 129, '2014-03-01 00:18:10.000000', 'consum', 0.0226, 'lps'),
	(561310, 129, '2014-03-01 00:18:11.000000', 'consum', 0.0236, 'lps'),
	(561311, 129, '2014-03-01 00:18:12.000000', 'consum', 0.0234, 'lps'),
	(561312, 129, '2014-03-01 00:18:13.000000', 'consum', 0.0224, 'lps'),
	(561313, 129, '2014-03-01 00:18:14.000000', 'consum', 0.0210, 'lps'),
	(561314, 129, '2014-03-01 00:18:15.000000', 'consum', 0.0228, 'lps'),
	(561315, 129, '2014-03-01 00:18:16.000000', 'consum', 0.0210, 'lps'),
	(561316, 129, '2014-03-01 00:18:17.000000', 'consum', 0.0217, 'lps'),
	(561317, 129, '2014-03-01 00:18:18.000000', 'consum', 0.0215, 'lps'),
	(561318, 129, '2014-03-01 00:18:19.000000', 'consum', 0.0216, 'lps'),
	(561319, 129, '2014-03-01 00:18:20.000000', 'consum', 0.0227, 'lps'),
	(561320, 129, '2014-03-01 00:18:21.000000', 'consum', 0.0218, 'lps'),
	(561321, 129, '2014-03-01 00:18:22.000000', 'consum', 0.0226, 'lps'),
	(561322, 129, '2014-03-01 00:18:23.000000', 'consum', 0.0212, 'lps'),
	(561323, 129, '2014-03-01 00:18:24.000000', 'consum', 0.0231, 'lps'),
	(561324, 129, '2014-03-01 00:18:25.000000', 'consum', 0.0220, 'lps'),
	(561325, 129, '2014-03-01 00:18:26.000000', 'consum', 0.0227, 'lps'),
	(561326, 129, '2014-03-01 00:18:27.000000', 'consum', 0.0236, 'lps'),
	(561327, 129, '2014-03-01 00:18:28.000000', 'consum', 0.0230, 'lps'),
	(561328, 129, '2014-03-01 00:18:29.000000', 'consum', 0.0235, 'lps'),
	(561329, 129, '2014-03-01 00:18:30.000000', 'consum', 0.0218, 'lps'),
	(561330, 129, '2014-03-01 00:18:31.000000', 'consum', 0.0231, 'lps'),
	(561331, 129, '2014-03-01 00:18:32.000000', 'consum', 0.0234, 'lps'),
	(561332, 129, '2014-03-01 00:18:33.000000', 'consum', 0.0210, 'lps'),
	(561333, 129, '2014-03-01 00:18:34.000000', 'consum', 0.0224, 'lps'),
	(561334, 129, '2014-03-01 00:18:35.000000', 'consum', 0.0226, 'lps'),
	(561335, 129, '2014-03-01 00:18:36.000000', 'consum', 0.0216, 'lps'),
	(561336, 129, '2014-03-01 00:18:37.000000', 'consum', 0.0222, 'lps'),
	(561337, 129, '2014-03-01 00:18:38.000000', 'consum', 0.0225, 'lps'),
	(561338, 129, '2014-03-01 00:18:39.000000', 'consum', 0.0222, 'lps'),
	(561339, 129, '2014-03-01 00:18:40.000000', 'consum', 0.0224, 'lps'),
	(561340, 129, '2014-03-01 00:18:41.000000', 'consum', 0.0214, 'lps'),
	(561341, 129, '2014-03-01 00:18:42.000000', 'consum', 0.0218, 'lps'),
	(561342, 129, '2014-03-01 00:18:43.000000', 'consum', 0.0237, 'lps'),
	(561343, 129, '2014-03-01 00:18:44.000000', 'consum', 0.0235, 'lps'),
	(561344, 129, '2014-03-01 00:18:45.000000', 'consum', 0.0227, 'lps'),
	(561345, 129, '2014-03-01 00:18:46.000000', 'consum', 0.0218, 'lps'),
	(561346, 129, '2014-03-01 00:18:47.000000', 'consum', 0.0231, 'lps'),
	(561347, 129, '2014-03-01 00:18:48.000000', 'consum', 0.0231, 'lps'),
	(561348, 129, '2014-03-01 00:18:49.000000', 'consum', 0.0223, 'lps'),
	(561349, 129, '2014-03-01 00:18:50.000000', 'consum', 0.0212, 'lps'),
	(561350, 129, '2014-03-01 00:18:51.000000', 'consum', 0.0213, 'lps'),
	(561351, 129, '2014-03-01 00:18:52.000000', 'consum', 0.0219, 'lps'),
	(561352, 129, '2014-03-01 00:18:53.000000', 'consum', 0.0217, 'lps'),
	(561353, 129, '2014-03-01 00:18:54.000000', 'consum', 0.0220, 'lps'),
	(561354, 129, '2014-03-01 00:18:55.000000', 'consum', 0.0237, 'lps'),
	(561355, 129, '2014-03-01 00:18:56.000000', 'consum', 0.0228, 'lps'),
	(561356, 129, '2014-03-01 00:18:57.000000', 'consum', 0.0222, 'lps'),
	(561357, 129, '2014-03-01 00:18:58.000000', 'consum', 0.0215, 'lps'),
	(561358, 129, '2014-03-01 00:18:59.000000', 'consum', 0.0227, 'lps'),
	(561359, 129, '2014-03-01 00:19:00.000000', 'consum', 0.0223, 'lps'),
	(561360, 129, '2014-03-01 00:19:01.000000', 'consum', 0.0224, 'lps'),
	(561361, 129, '2014-03-01 00:19:02.000000', 'consum', 0.0213, 'lps'),
	(561362, 129, '2014-03-01 00:19:03.000000', 'consum', 0.0214, 'lps'),
	(561363, 129, '2014-03-01 00:19:04.000000', 'consum', 0.0220, 'lps'),
	(561364, 129, '2014-03-01 00:19:05.000000', 'consum', 0.0218, 'lps'),
	(561365, 129, '2014-03-01 00:19:06.000000', 'consum', 0.0223, 'lps'),
	(561366, 129, '2014-03-01 00:19:07.000000', 'consum', 0.0223, 'lps'),
	(561367, 129, '2014-03-01 00:19:08.000000', 'consum', 0.0236, 'lps'),
	(561368, 129, '2014-03-01 00:19:09.000000', 'consum', 0.0216, 'lps'),
	(561369, 129, '2014-03-01 00:19:10.000000', 'consum', 0.0220, 'lps'),
	(561370, 129, '2014-03-01 00:19:11.000000', 'consum', 0.0212, 'lps'),
	(561371, 129, '2014-03-01 00:19:12.000000', 'consum', 0.0222, 'lps'),
	(561372, 129, '2014-03-01 00:19:13.000000', 'consum', 0.0235, 'lps'),
	(561373, 129, '2014-03-01 00:19:14.000000', 'consum', 0.0212, 'lps'),
	(561374, 129, '2014-03-01 00:19:15.000000', 'consum', 0.0235, 'lps'),
	(561375, 129, '2014-03-01 00:19:16.000000', 'consum', 0.0210, 'lps'),
	(561376, 129, '2014-03-01 00:19:17.000000', 'consum', 0.0223, 'lps'),
	(561377, 129, '2014-03-01 00:19:18.000000', 'consum', 0.0219, 'lps'),
	(561378, 129, '2014-03-01 00:19:19.000000', 'consum', 0.0214, 'lps'),
	(561379, 129, '2014-03-01 00:19:20.000000', 'consum', 0.0233, 'lps'),
	(561380, 129, '2014-03-01 00:19:21.000000', 'consum', 0.0228, 'lps'),
	(561381, 129, '2014-03-01 00:19:22.000000', 'consum', 0.0232, 'lps'),
	(561382, 129, '2014-03-01 00:19:23.000000', 'consum', 0.0210, 'lps'),
	(561383, 129, '2014-03-01 00:19:24.000000', 'consum', 0.0229, 'lps'),
	(561384, 129, '2014-03-01 00:19:25.000000', 'consum', 0.0218, 'lps'),
	(561385, 129, '2014-03-01 00:19:26.000000', 'consum', 0.0222, 'lps'),
	(561386, 129, '2014-03-01 00:19:27.000000', 'consum', 0.0219, 'lps'),
	(561387, 129, '2014-03-01 00:19:28.000000', 'consum', 0.0220, 'lps'),
	(561388, 129, '2014-03-01 00:19:29.000000', 'consum', 0.0234, 'lps'),
	(561389, 129, '2014-03-01 00:19:30.000000', 'consum', 0.0214, 'lps'),
	(561390, 129, '2014-03-01 00:19:31.000000', 'consum', 0.0216, 'lps'),
	(561391, 129, '2014-03-01 00:19:32.000000', 'consum', 0.0228, 'lps'),
	(561392, 129, '2014-03-01 00:19:33.000000', 'consum', 0.0224, 'lps'),
	(561393, 129, '2014-03-01 00:19:34.000000', 'consum', 0.0229, 'lps'),
	(561394, 129, '2014-03-01 00:19:35.000000', 'consum', 0.0233, 'lps'),
	(561395, 129, '2014-03-01 00:19:36.000000', 'consum', 0.0212, 'lps'),
	(561396, 129, '2014-03-01 00:19:37.000000', 'consum', 0.0210, 'lps'),
	(561397, 129, '2014-03-01 00:19:38.000000', 'consum', 0.0231, 'lps'),
	(561398, 129, '2014-03-01 00:19:39.000000', 'consum', 0.0229, 'lps'),
	(561399, 129, '2014-03-01 00:19:40.000000', 'consum', 0.0214, 'lps'),
	(561400, 129, '2014-03-01 00:19:41.000000', 'consum', 0.0232, 'lps'),
	(561401, 129, '2014-03-01 00:19:42.000000', 'consum', 0.0223, 'lps'),
	(561402, 129, '2014-03-01 00:19:43.000000', 'consum', 0.0237, 'lps'),
	(561403, 129, '2014-03-01 00:19:44.000000', 'consum', 0.0221, 'lps'),
	(561404, 129, '2014-03-01 00:19:45.000000', 'consum', 0.0214, 'lps'),
	(561405, 129, '2014-03-01 00:19:46.000000', 'consum', 0.0227, 'lps'),
	(561406, 129, '2014-03-01 00:19:47.000000', 'consum', 0.0227, 'lps'),
	(561407, 129, '2014-03-01 00:19:48.000000', 'consum', 0.0212, 'lps'),
	(561408, 129, '2014-03-01 00:19:49.000000', 'consum', 0.0228, 'lps'),
	(561409, 129, '2014-03-01 00:19:50.000000', 'consum', 0.0210, 'lps'),
	(561410, 129, '2014-03-01 00:19:51.000000', 'consum', 0.0212, 'lps'),
	(561411, 129, '2014-03-01 00:19:52.000000', 'consum', 0.0219, 'lps'),
	(561412, 129, '2014-03-01 00:19:53.000000', 'consum', 0.0223, 'lps'),
	(561413, 129, '2014-03-01 00:19:54.000000', 'consum', 0.0218, 'lps'),
	(561414, 129, '2014-03-01 00:19:55.000000', 'consum', 0.0214, 'lps'),
	(561415, 129, '2014-03-01 00:19:56.000000', 'consum', 0.0234, 'lps'),
	(561416, 129, '2014-03-01 00:19:57.000000', 'consum', 0.0232, 'lps'),
	(561417, 129, '2014-03-01 00:19:58.000000', 'consum', 0.0217, 'lps'),
	(561418, 129, '2014-03-01 00:19:59.000000', 'consum', 0.0212, 'lps'),
	(561419, 129, '2014-03-01 00:20:00.000000', 'consum', 0.0228, 'lps'),
	(561420, 129, '2014-03-01 00:20:01.000000', 'consum', 0.0236, 'lps'),
	(561421, 129, '2014-03-01 00:20:02.000000', 'consum', 0.0228, 'lps'),
	(561422, 129, '2014-03-01 00:20:03.000000', 'consum', 0.0222, 'lps'),
	(561423, 129, '2014-03-01 00:20:04.000000', 'consum', 0.0217, 'lps'),
	(561424, 129, '2014-03-01 00:20:05.000000', 'consum', 0.0210, 'lps'),
	(561425, 129, '2014-03-01 00:20:06.000000', 'consum', 0.0218, 'lps'),
	(561426, 129, '2014-03-01 00:20:07.000000', 'consum', 0.0223, 'lps'),
	(561427, 129, '2014-03-01 00:20:08.000000', 'consum', 0.0223, 'lps'),
	(561428, 129, '2014-03-01 00:20:09.000000', 'consum', 0.0235, 'lps'),
	(561429, 129, '2014-03-01 00:20:10.000000', 'consum', 0.0210, 'lps'),
	(561430, 129, '2014-03-01 00:20:11.000000', 'consum', 0.0221, 'lps'),
	(561431, 129, '2014-03-01 00:20:12.000000', 'consum', 0.0237, 'lps'),
	(561432, 129, '2014-03-01 00:20:13.000000', 'consum', 0.0227, 'lps'),
	(561433, 129, '2014-03-01 00:20:14.000000', 'consum', 0.0213, 'lps'),
	(561434, 129, '2014-03-01 00:20:15.000000', 'consum', 0.0233, 'lps'),
	(561435, 129, '2014-03-01 00:20:16.000000', 'consum', 0.0231, 'lps'),
	(561436, 129, '2014-03-01 00:20:17.000000', 'consum', 0.0219, 'lps'),
	(561437, 129, '2014-03-01 00:20:18.000000', 'consum', 0.0218, 'lps'),
	(561438, 129, '2014-03-01 00:20:19.000000', 'consum', 0.0224, 'lps'),
	(561439, 129, '2014-03-01 00:20:20.000000', 'consum', 0.0228, 'lps'),
	(561440, 129, '2014-03-01 00:20:21.000000', 'consum', 0.0228, 'lps'),
	(561441, 129, '2014-03-01 00:20:22.000000', 'consum', 0.0218, 'lps'),
	(561442, 129, '2014-03-01 00:20:23.000000', 'consum', 0.0228, 'lps'),
	(561443, 129, '2014-03-01 00:20:24.000000', 'consum', 0.0216, 'lps'),
	(561444, 129, '2014-03-01 00:20:25.000000', 'consum', 0.0217, 'lps'),
	(561445, 129, '2014-03-01 00:20:26.000000', 'consum', 0.0225, 'lps'),
	(561446, 129, '2014-03-01 00:20:27.000000', 'consum', 0.0238, 'lps'),
	(561447, 129, '2014-03-01 00:20:28.000000', 'consum', 0.0219, 'lps'),
	(561448, 129, '2014-03-01 00:20:29.000000', 'consum', 0.0228, 'lps'),
	(561449, 129, '2014-03-01 00:20:30.000000', 'consum', 0.0214, 'lps'),
	(561450, 129, '2014-03-01 00:20:31.000000', 'consum', 0.0238, 'lps'),
	(561451, 129, '2014-03-01 00:20:32.000000', 'consum', 0.0220, 'lps'),
	(561452, 129, '2014-03-01 00:20:33.000000', 'consum', 0.0236, 'lps'),
	(561453, 129, '2014-03-01 00:20:34.000000', 'consum', 0.0221, 'lps'),
	(561454, 129, '2014-03-01 00:20:35.000000', 'consum', 0.0218, 'lps'),
	(561455, 129, '2014-03-01 00:20:36.000000', 'consum', 0.0216, 'lps'),
	(561456, 129, '2014-03-01 00:20:37.000000', 'consum', 0.0219, 'lps'),
	(561457, 129, '2014-03-01 00:20:38.000000', 'consum', 0.0237, 'lps'),
	(561458, 129, '2014-03-01 00:20:39.000000', 'consum', 0.0229, 'lps'),
	(561459, 129, '2014-03-01 00:20:40.000000', 'consum', 0.0228, 'lps'),
	(561460, 129, '2014-03-01 00:20:41.000000', 'consum', 0.0212, 'lps'),
	(561461, 129, '2014-03-01 00:20:42.000000', 'consum', 0.0224, 'lps'),
	(561462, 129, '2014-03-01 00:20:43.000000', 'consum', 0.0218, 'lps'),
	(561463, 129, '2014-03-01 00:20:44.000000', 'consum', 0.0238, 'lps'),
	(561464, 129, '2014-03-01 00:20:45.000000', 'consum', 0.0211, 'lps'),
	(561465, 129, '2014-03-01 00:20:46.000000', 'consum', 0.0216, 'lps'),
	(561466, 129, '2014-03-01 00:20:47.000000', 'consum', 0.0212, 'lps'),
	(561467, 129, '2014-03-01 00:20:48.000000', 'consum', 0.0229, 'lps'),
	(561468, 129, '2014-03-01 00:20:49.000000', 'consum', 0.0214, 'lps'),
	(561469, 129, '2014-03-01 00:20:50.000000', 'consum', 0.0229, 'lps'),
	(561470, 129, '2014-03-01 00:20:51.000000', 'consum', 0.0238, 'lps'),
	(561471, 129, '2014-03-01 00:20:52.000000', 'consum', 0.0236, 'lps'),
	(561472, 129, '2014-03-01 00:20:53.000000', 'consum', 0.0228, 'lps'),
	(561473, 129, '2014-03-01 00:20:54.000000', 'consum', 0.0221, 'lps'),
	(561474, 129, '2014-03-01 00:20:55.000000', 'consum', 0.0210, 'lps'),
	(561475, 129, '2014-03-01 00:20:56.000000', 'consum', 0.0236, 'lps'),
	(561476, 129, '2014-03-01 00:20:57.000000', 'consum', 0.0224, 'lps'),
	(561477, 129, '2014-03-01 00:20:58.000000', 'consum', 0.0232, 'lps'),
	(561478, 129, '2014-03-01 00:20:59.000000', 'consum', 0.0222, 'lps'),
	(561479, 129, '2014-03-01 00:21:00.000000', 'consum', 0.0231, 'lps'),
	(561480, 129, '2014-03-01 00:21:01.000000', 'consum', 0.0222, 'lps'),
	(561481, 129, '2014-03-01 00:21:02.000000', 'consum', 0.0237, 'lps'),
	(561482, 129, '2014-03-01 00:21:03.000000', 'consum', 0.0222, 'lps'),
	(561483, 129, '2014-03-01 00:21:04.000000', 'consum', 0.0218, 'lps'),
	(561484, 129, '2014-03-01 00:21:05.000000', 'consum', 0.0217, 'lps'),
	(561485, 129, '2014-03-01 00:21:06.000000', 'consum', 0.0219, 'lps'),
	(561486, 129, '2014-03-01 00:21:07.000000', 'consum', 0.0236, 'lps'),
	(561487, 129, '2014-03-01 00:21:08.000000', 'consum', 0.0228, 'lps'),
	(561488, 129, '2014-03-01 00:21:09.000000', 'consum', 0.0220, 'lps'),
	(561489, 129, '2014-03-01 00:21:10.000000', 'consum', 0.0238, 'lps'),
	(561490, 129, '2014-03-01 00:21:11.000000', 'consum', 0.0230, 'lps'),
	(561491, 129, '2014-03-01 00:21:12.000000', 'consum', 0.0229, 'lps'),
	(561492, 129, '2014-03-01 00:21:13.000000', 'consum', 0.0218, 'lps'),
	(561493, 129, '2014-03-01 00:21:14.000000', 'consum', 0.0220, 'lps'),
	(561494, 129, '2014-03-01 00:21:15.000000', 'consum', 0.0236, 'lps'),
	(561495, 129, '2014-03-01 00:21:16.000000', 'consum', 0.0224, 'lps'),
	(561496, 129, '2014-03-01 00:21:17.000000', 'consum', 0.0230, 'lps'),
	(561497, 129, '2014-03-01 00:21:18.000000', 'consum', 0.0212, 'lps'),
	(561498, 129, '2014-03-01 00:21:19.000000', 'consum', 0.0220, 'lps'),
	(561499, 129, '2014-03-01 00:21:20.000000', 'consum', 0.0223, 'lps'),
	(561500, 129, '2014-03-01 00:21:21.000000', 'consum', 0.0219, 'lps'),
	(561501, 129, '2014-03-01 00:21:22.000000', 'consum', 0.0214, 'lps'),
	(561502, 129, '2014-03-01 00:21:23.000000', 'consum', 0.0233, 'lps'),
	(561503, 129, '2014-03-01 00:21:24.000000', 'consum', 0.0227, 'lps'),
	(561504, 129, '2014-03-01 00:21:25.000000', 'consum', 0.0226, 'lps'),
	(561505, 129, '2014-03-01 00:21:26.000000', 'consum', 0.0238, 'lps'),
	(561506, 129, '2014-03-01 00:21:27.000000', 'consum', 0.0217, 'lps'),
	(561507, 129, '2014-03-01 00:21:28.000000', 'consum', 0.0219, 'lps'),
	(561508, 129, '2014-03-01 00:21:29.000000', 'consum', 0.0236, 'lps'),
	(561509, 129, '2014-03-01 00:21:30.000000', 'consum', 0.0226, 'lps'),
	(561510, 129, '2014-03-01 00:21:31.000000', 'consum', 0.0212, 'lps'),
	(561511, 129, '2014-03-01 00:21:32.000000', 'consum', 0.0232, 'lps'),
	(561512, 129, '2014-03-01 00:21:33.000000', 'consum', 0.0226, 'lps'),
	(561513, 129, '2014-03-01 00:21:34.000000', 'consum', 0.0226, 'lps'),
	(561514, 129, '2014-03-01 00:21:35.000000', 'consum', 0.0212, 'lps'),
	(561515, 129, '2014-03-01 00:21:36.000000', 'consum', 0.0233, 'lps'),
	(561516, 129, '2014-03-01 00:21:37.000000', 'consum', 0.0229, 'lps'),
	(561517, 129, '2014-03-01 00:21:38.000000', 'consum', 0.0210, 'lps'),
	(561518, 129, '2014-03-01 00:21:39.000000', 'consum', 0.0210, 'lps'),
	(561519, 129, '2014-03-01 00:21:40.000000', 'consum', 0.0213, 'lps'),
	(561520, 129, '2014-03-01 00:21:41.000000', 'consum', 0.0223, 'lps'),
	(561521, 129, '2014-03-01 00:21:42.000000', 'consum', 0.0210, 'lps'),
	(561522, 129, '2014-03-01 00:21:43.000000', 'consum', 0.0230, 'lps'),
	(561523, 129, '2014-03-01 00:21:44.000000', 'consum', 0.0223, 'lps'),
	(561524, 129, '2014-03-01 00:21:45.000000', 'consum', 0.0214, 'lps'),
	(561525, 129, '2014-03-01 00:21:46.000000', 'consum', 0.0221, 'lps'),
	(561526, 129, '2014-03-01 00:21:47.000000', 'consum', 0.0223, 'lps'),
	(561527, 129, '2014-03-01 00:21:48.000000', 'consum', 0.0214, 'lps'),
	(561528, 129, '2014-03-01 00:21:49.000000', 'consum', 0.0222, 'lps'),
	(561529, 129, '2014-03-01 00:21:50.000000', 'consum', 0.0227, 'lps'),
	(561530, 129, '2014-03-01 00:21:51.000000', 'consum', 0.0231, 'lps'),
	(561531, 129, '2014-03-01 00:21:52.000000', 'consum', 0.0236, 'lps'),
	(561532, 129, '2014-03-01 00:21:53.000000', 'consum', 0.0217, 'lps'),
	(561533, 129, '2014-03-01 00:21:54.000000', 'consum', 0.0229, 'lps'),
	(561534, 129, '2014-03-01 00:21:55.000000', 'consum', 0.0225, 'lps'),
	(561535, 129, '2014-03-01 00:21:56.000000', 'consum', 0.0228, 'lps'),
	(561536, 129, '2014-03-01 00:21:57.000000', 'consum', 0.0228, 'lps'),
	(561537, 129, '2014-03-01 00:21:58.000000', 'consum', 0.0218, 'lps'),
	(561538, 129, '2014-03-01 00:21:59.000000', 'consum', 0.0226, 'lps'),
	(561539, 129, '2014-03-01 00:22:00.000000', 'consum', 0.0236, 'lps'),
	(561540, 129, '2014-03-01 00:22:01.000000', 'consum', 0.0236, 'lps'),
	(561541, 129, '2014-03-01 00:22:02.000000', 'consum', 0.0232, 'lps'),
	(561542, 129, '2014-03-01 00:22:03.000000', 'consum', 0.0213, 'lps'),
	(561543, 129, '2014-03-01 00:22:04.000000', 'consum', 0.0217, 'lps'),
	(561544, 129, '2014-03-01 00:22:05.000000', 'consum', 0.0210, 'lps'),
	(561545, 129, '2014-03-01 00:22:06.000000', 'consum', 0.0216, 'lps'),
	(561546, 129, '2014-03-01 00:22:07.000000', 'consum', 0.0212, 'lps'),
	(561547, 129, '2014-03-01 00:22:08.000000', 'consum', 0.0233, 'lps'),
	(561548, 129, '2014-03-01 00:22:09.000000', 'consum', 0.0232, 'lps'),
	(561549, 129, '2014-03-01 00:22:10.000000', 'consum', 0.0224, 'lps'),
	(561550, 129, '2014-03-01 00:22:11.000000', 'consum', 0.0213, 'lps'),
	(561551, 129, '2014-03-01 00:22:12.000000', 'consum', 0.0213, 'lps'),
	(561552, 129, '2014-03-01 00:22:13.000000', 'consum', 0.0217, 'lps'),
	(561553, 129, '2014-03-01 00:22:14.000000', 'consum', 0.0234, 'lps'),
	(561554, 129, '2014-03-01 00:22:15.000000', 'consum', 0.0224, 'lps'),
	(561555, 129, '2014-03-01 00:22:16.000000', 'consum', 0.0210, 'lps'),
	(561556, 129, '2014-03-01 00:22:17.000000', 'consum', 0.0225, 'lps'),
	(561557, 129, '2014-03-01 00:22:18.000000', 'consum', 0.0226, 'lps'),
	(561558, 129, '2014-03-01 00:22:19.000000', 'consum', 0.0218, 'lps'),
	(561559, 129, '2014-03-01 00:22:20.000000', 'consum', 0.0231, 'lps'),
	(561560, 129, '2014-03-01 00:22:21.000000', 'consum', 0.0233, 'lps'),
	(561561, 129, '2014-03-01 00:22:22.000000', 'consum', 0.0233, 'lps'),
	(561562, 129, '2014-03-01 00:22:23.000000', 'consum', 0.0230, 'lps'),
	(561563, 129, '2014-03-01 00:22:24.000000', 'consum', 0.0210, 'lps'),
	(561564, 129, '2014-03-01 00:22:25.000000', 'consum', 0.0238, 'lps'),
	(561565, 129, '2014-03-01 00:22:26.000000', 'consum', 0.0236, 'lps'),
	(561566, 129, '2014-03-01 00:22:27.000000', 'consum', 0.0229, 'lps'),
	(561567, 129, '2014-03-01 00:22:28.000000', 'consum', 0.0224, 'lps'),
	(561568, 129, '2014-03-01 00:22:29.000000', 'consum', 0.0226, 'lps'),
	(561569, 129, '2014-03-01 00:22:30.000000', 'consum', 0.0219, 'lps'),
	(561570, 129, '2014-03-01 00:22:31.000000', 'consum', 0.0236, 'lps'),
	(561571, 129, '2014-03-01 00:22:32.000000', 'consum', 0.0227, 'lps'),
	(561572, 129, '2014-03-01 00:22:33.000000', 'consum', 0.0216, 'lps'),
	(561573, 129, '2014-03-01 00:22:34.000000', 'consum', 0.0218, 'lps'),
	(561574, 129, '2014-03-01 00:22:35.000000', 'consum', 0.0235, 'lps'),
	(561575, 129, '2014-03-01 00:22:36.000000', 'consum', 0.0222, 'lps'),
	(561576, 129, '2014-03-01 00:22:37.000000', 'consum', 0.0225, 'lps'),
	(561577, 129, '2014-03-01 00:22:38.000000', 'consum', 0.0223, 'lps'),
	(561578, 129, '2014-03-01 00:22:39.000000', 'consum', 0.0228, 'lps'),
	(561579, 129, '2014-03-01 00:22:40.000000', 'consum', 0.0232, 'lps'),
	(561580, 129, '2014-03-01 00:22:41.000000', 'consum', 0.0210, 'lps'),
	(561581, 129, '2014-03-01 00:22:42.000000', 'consum', 0.0231, 'lps'),
	(561582, 129, '2014-03-01 00:22:43.000000', 'consum', 0.0227, 'lps'),
	(561583, 129, '2014-03-01 00:22:44.000000', 'consum', 0.0235, 'lps'),
	(561584, 129, '2014-03-01 00:22:45.000000', 'consum', 0.0224, 'lps'),
	(561585, 129, '2014-03-01 00:22:46.000000', 'consum', 0.0236, 'lps'),
	(561586, 129, '2014-03-01 00:22:47.000000', 'consum', 0.0212, 'lps'),
	(561587, 129, '2014-03-01 00:22:48.000000', 'consum', 0.0229, 'lps'),
	(561588, 129, '2014-03-01 00:22:49.000000', 'consum', 0.0214, 'lps'),
	(561589, 129, '2014-03-01 00:22:50.000000', 'consum', 0.0229, 'lps'),
	(561590, 129, '2014-03-01 00:22:51.000000', 'consum', 0.0238, 'lps'),
	(561591, 129, '2014-03-01 00:22:52.000000', 'consum', 0.0236, 'lps'),
	(561592, 129, '2014-03-01 00:22:53.000000', 'consum', 0.0226, 'lps'),
	(561593, 129, '2014-03-01 00:22:54.000000', 'consum', 0.0211, 'lps'),
	(561594, 129, '2014-03-01 00:22:55.000000', 'consum', 0.0227, 'lps'),
	(561595, 129, '2014-03-01 00:22:56.000000', 'consum', 0.0235, 'lps'),
	(561596, 129, '2014-03-01 00:22:57.000000', 'consum', 0.0226, 'lps'),
	(561597, 129, '2014-03-01 00:22:58.000000', 'consum', 0.0217, 'lps'),
	(561598, 129, '2014-03-01 00:22:59.000000', 'consum', 0.0226, 'lps'),
	(561599, 129, '2014-03-01 00:23:00.000000', 'consum', 0.0211, 'lps'),
	(561600, 129, '2014-03-01 00:23:01.000000', 'consum', 0.0227, 'lps'),
	(561601, 129, '2014-03-01 00:23:02.000000', 'consum', 0.0232, 'lps'),
	(561602, 129, '2014-03-01 00:23:03.000000', 'consum', 0.0212, 'lps'),
	(561603, 129, '2014-03-01 00:23:04.000000', 'consum', 0.0213, 'lps'),
	(561604, 129, '2014-03-01 00:23:05.000000', 'consum', 0.0218, 'lps'),
	(561605, 129, '2014-03-01 00:23:06.000000', 'consum', 0.0213, 'lps'),
	(561606, 129, '2014-03-01 00:23:07.000000', 'consum', 0.0231, 'lps'),
	(561607, 129, '2014-03-01 00:23:08.000000', 'consum', 0.0218, 'lps'),
	(561608, 129, '2014-03-01 00:23:09.000000', 'consum', 0.0220, 'lps'),
	(561609, 129, '2014-03-01 00:23:10.000000', 'consum', 0.0233, 'lps'),
	(561610, 129, '2014-03-01 00:23:11.000000', 'consum', 0.0238, 'lps'),
	(561611, 129, '2014-03-01 00:23:12.000000', 'consum', 0.0224, 'lps'),
	(561612, 129, '2014-03-01 00:23:13.000000', 'consum', 0.0224, 'lps'),
	(561613, 129, '2014-03-01 00:23:14.000000', 'consum', 0.0211, 'lps'),
	(561614, 129, '2014-03-01 00:23:15.000000', 'consum', 0.0231, 'lps'),
	(561615, 129, '2014-03-01 00:23:16.000000', 'consum', 0.0228, 'lps'),
	(561616, 129, '2014-03-01 00:23:17.000000', 'consum', 0.0234, 'lps'),
	(561617, 129, '2014-03-01 00:23:18.000000', 'consum', 0.0222, 'lps'),
	(561618, 129, '2014-03-01 00:23:19.000000', 'consum', 0.0225, 'lps'),
	(561619, 129, '2014-03-01 00:23:20.000000', 'consum', 0.0219, 'lps'),
	(561620, 129, '2014-03-01 00:23:21.000000', 'consum', 0.0212, 'lps'),
	(561621, 129, '2014-03-01 00:23:22.000000', 'consum', 0.0224, 'lps'),
	(561622, 129, '2014-03-01 00:23:23.000000', 'consum', 0.0216, 'lps'),
	(561623, 129, '2014-03-01 00:23:24.000000', 'consum', 0.0227, 'lps'),
	(561624, 129, '2014-03-01 00:23:25.000000', 'consum', 0.0219, 'lps'),
	(561625, 129, '2014-03-01 00:23:26.000000', 'consum', 0.0233, 'lps'),
	(561626, 129, '2014-03-01 00:23:27.000000', 'consum', 0.0212, 'lps'),
	(561627, 129, '2014-03-01 00:23:28.000000', 'consum', 0.0238, 'lps'),
	(561628, 129, '2014-03-01 00:23:29.000000', 'consum', 0.0228, 'lps'),
	(561629, 129, '2014-03-01 00:23:30.000000', 'consum', 0.0219, 'lps'),
	(561630, 129, '2014-03-01 00:23:31.000000', 'consum', 0.0228, 'lps'),
	(561631, 129, '2014-03-01 00:23:32.000000', 'consum', 0.0216, 'lps'),
	(561632, 129, '2014-03-01 00:23:33.000000', 'consum', 0.0217, 'lps'),
	(561633, 129, '2014-03-01 00:23:34.000000', 'consum', 0.0226, 'lps'),
	(561634, 129, '2014-03-01 00:23:35.000000', 'consum', 0.0212, 'lps'),
	(561635, 129, '2014-03-01 00:23:36.000000', 'consum', 0.0233, 'lps'),
	(561636, 129, '2014-03-01 00:23:37.000000', 'consum', 0.0229, 'lps'),
	(561637, 129, '2014-03-01 00:23:38.000000', 'consum', 0.0237, 'lps'),
	(561638, 129, '2014-03-01 00:23:39.000000', 'consum', 0.0230, 'lps'),
	(561639, 129, '2014-03-01 00:23:40.000000', 'consum', 0.0231, 'lps'),
	(561640, 129, '2014-03-01 00:23:41.000000', 'consum', 0.0228, 'lps'),
	(561641, 129, '2014-03-01 00:23:42.000000', 'consum', 0.0234, 'lps'),
	(561642, 129, '2014-03-01 00:23:43.000000', 'consum', 0.0220, 'lps'),
	(561643, 129, '2014-03-01 00:23:44.000000', 'consum', 0.0217, 'lps'),
	(561644, 129, '2014-03-01 00:23:45.000000', 'consum', 0.0215, 'lps'),
	(561645, 129, '2014-03-01 00:23:46.000000', 'consum', 0.0215, 'lps'),
	(561646, 129, '2014-03-01 00:23:47.000000', 'consum', 0.0219, 'lps'),
	(561647, 129, '2014-03-01 00:23:48.000000', 'consum', 0.0214, 'lps'),
	(561648, 129, '2014-03-01 00:23:49.000000', 'consum', 0.0231, 'lps'),
	(561649, 129, '2014-03-01 00:23:50.000000', 'consum', 0.0218, 'lps'),
	(561650, 129, '2014-03-01 00:23:51.000000', 'consum', 0.0214, 'lps'),
	(561651, 129, '2014-03-01 00:23:52.000000', 'consum', 0.0238, 'lps'),
	(561652, 129, '2014-03-01 00:23:53.000000', 'consum', 0.0222, 'lps'),
	(561653, 129, '2014-03-01 00:23:54.000000', 'consum', 0.0215, 'lps'),
	(561654, 129, '2014-03-01 00:23:55.000000', 'consum', 0.0230, 'lps'),
	(561655, 129, '2014-03-01 00:23:56.000000', 'consum', 0.0238, 'lps'),
	(561656, 129, '2014-03-01 00:23:57.000000', 'consum', 0.0231, 'lps'),
	(561657, 129, '2014-03-01 00:23:58.000000', 'consum', 0.0232, 'lps'),
	(561658, 129, '2014-03-01 00:23:59.000000', 'consum', 0.0231, 'lps'),
	(561659, 129, '2014-03-01 00:24:00.000000', 'consum', 0.0217, 'lps'),
	(561660, 129, '2014-03-01 00:24:01.000000', 'consum', 0.0211, 'lps'),
	(561661, 129, '2014-03-01 00:24:02.000000', 'consum', 0.0225, 'lps'),
	(561662, 129, '2014-03-01 00:24:03.000000', 'consum', 0.0224, 'lps'),
	(561663, 129, '2014-03-01 00:24:04.000000', 'consum', 0.0234, 'lps'),
	(561664, 129, '2014-03-01 00:24:05.000000', 'consum', 0.0232, 'lps'),
	(561665, 129, '2014-03-01 00:24:06.000000', 'consum', 0.0220, 'lps'),
	(561666, 129, '2014-03-01 00:24:07.000000', 'consum', 0.0224, 'lps'),
	(561667, 129, '2014-03-01 00:24:08.000000', 'consum', 0.0222, 'lps'),
	(561668, 129, '2014-03-01 00:24:09.000000', 'consum', 0.0226, 'lps'),
	(561669, 129, '2014-03-01 00:24:10.000000', 'consum', 0.0228, 'lps'),
	(561670, 129, '2014-03-01 00:24:11.000000', 'consum', 0.0222, 'lps'),
	(561671, 129, '2014-03-01 00:24:12.000000', 'consum', 0.0218, 'lps'),
	(561672, 129, '2014-03-01 00:24:13.000000', 'consum', 0.0216, 'lps'),
	(561673, 129, '2014-03-01 00:24:14.000000', 'consum', 0.0214, 'lps'),
	(561674, 129, '2014-03-01 00:24:15.000000', 'consum', 0.0214, 'lps'),
	(561675, 129, '2014-03-01 00:24:16.000000', 'consum', 0.0219, 'lps'),
	(561676, 129, '2014-03-01 00:24:17.000000', 'consum', 0.0212, 'lps'),
	(561677, 129, '2014-03-01 00:24:18.000000', 'consum', 0.0222, 'lps'),
	(561678, 129, '2014-03-01 00:24:19.000000', 'consum', 0.0237, 'lps'),
	(561679, 129, '2014-03-01 00:24:20.000000', 'consum', 0.0223, 'lps'),
	(561680, 129, '2014-03-01 00:24:21.000000', 'consum', 0.0222, 'lps'),
	(561681, 129, '2014-03-01 00:24:22.000000', 'consum', 0.0232, 'lps'),
	(561682, 129, '2014-03-01 00:24:23.000000', 'consum', 0.0228, 'lps'),
	(561683, 129, '2014-03-01 00:24:24.000000', 'consum', 0.0234, 'lps'),
	(561684, 129, '2014-03-01 00:24:25.000000', 'consum', 0.0217, 'lps'),
	(561685, 129, '2014-03-01 00:24:26.000000', 'consum', 0.0233, 'lps'),
	(561686, 129, '2014-03-01 00:24:27.000000', 'consum', 0.0215, 'lps'),
	(561687, 129, '2014-03-01 00:24:28.000000', 'consum', 0.0227, 'lps'),
	(561688, 129, '2014-03-01 00:24:29.000000', 'consum', 0.0223, 'lps'),
	(561689, 129, '2014-03-01 00:24:30.000000', 'consum', 0.0225, 'lps'),
	(561690, 129, '2014-03-01 00:24:31.000000', 'consum', 0.0216, 'lps'),
	(561691, 129, '2014-03-01 00:24:32.000000', 'consum', 0.0224, 'lps'),
	(561692, 129, '2014-03-01 00:24:33.000000', 'consum', 0.0233, 'lps'),
	(561693, 129, '2014-03-01 00:24:34.000000', 'consum', 0.0227, 'lps'),
	(561694, 129, '2014-03-01 00:24:35.000000', 'consum', 0.0228, 'lps'),
	(561695, 129, '2014-03-01 00:24:36.000000', 'consum', 0.0218, 'lps'),
	(561696, 129, '2014-03-01 00:24:37.000000', 'consum', 0.0228, 'lps'),
	(561697, 129, '2014-03-01 00:24:38.000000', 'consum', 0.0218, 'lps'),
	(561698, 129, '2014-03-01 00:24:39.000000', 'consum', 0.0225, 'lps'),
	(561699, 129, '2014-03-01 00:24:40.000000', 'consum', 0.0234, 'lps'),
	(561700, 129, '2014-03-01 00:24:41.000000', 'consum', 0.0228, 'lps'),
	(561701, 129, '2014-03-01 00:24:42.000000', 'consum', 0.0229, 'lps'),
	(561702, 129, '2014-03-01 00:24:43.000000', 'consum', 0.0223, 'lps'),
	(561703, 129, '2014-03-01 00:24:44.000000', 'consum', 0.0217, 'lps'),
	(561704, 129, '2014-03-01 00:24:45.000000', 'consum', 0.0236, 'lps'),
	(561705, 129, '2014-03-01 00:24:46.000000', 'consum', 0.0231, 'lps'),
	(561706, 129, '2014-03-01 00:24:47.000000', 'consum', 0.0210, 'lps'),
	(561707, 129, '2014-03-01 00:24:48.000000', 'consum', 0.0235, 'lps'),
	(561708, 129, '2014-03-01 00:24:49.000000', 'consum', 0.0217, 'lps'),
	(561709, 129, '2014-03-01 00:24:50.000000', 'consum', 0.0230, 'lps'),
	(561710, 129, '2014-03-01 00:24:51.000000', 'consum', 0.0230, 'lps'),
	(561711, 129, '2014-03-01 00:24:52.000000', 'consum', 0.0223, 'lps'),
	(561712, 129, '2014-03-01 00:24:53.000000', 'consum', 0.0213, 'lps'),
	(561713, 129, '2014-03-01 00:24:54.000000', 'consum', 0.0219, 'lps'),
	(561714, 129, '2014-03-01 00:24:55.000000', 'consum', 0.0216, 'lps'),
	(561715, 129, '2014-03-01 00:24:56.000000', 'consum', 0.0215, 'lps'),
	(561716, 129, '2014-03-01 00:24:57.000000', 'consum', 0.0217, 'lps'),
	(561717, 129, '2014-03-01 00:24:58.000000', 'consum', 0.0229, 'lps'),
	(561718, 129, '2014-03-01 00:24:59.000000', 'consum', 0.0229, 'lps'),
	(561719, 129, '2014-03-01 00:25:00.000000', 'consum', 0.0218, 'lps'),
	(561720, 129, '2014-03-01 00:25:01.000000', 'consum', 0.0223, 'lps'),
	(561721, 129, '2014-03-01 00:25:02.000000', 'consum', 0.0222, 'lps'),
	(561722, 129, '2014-03-01 00:25:03.000000', 'consum', 0.0233, 'lps'),
	(561723, 129, '2014-03-01 00:25:04.000000', 'consum', 0.0229, 'lps'),
	(561724, 129, '2014-03-01 00:25:05.000000', 'consum', 0.0210, 'lps'),
	(561725, 129, '2014-03-01 00:25:06.000000', 'consum', 0.0211, 'lps'),
	(561726, 129, '2014-03-01 00:25:07.000000', 'consum', 0.0216, 'lps'),
	(561727, 129, '2014-03-01 00:25:08.000000', 'consum', 0.0235, 'lps'),
	(561728, 129, '2014-03-01 00:25:09.000000', 'consum', 0.0231, 'lps'),
	(561729, 129, '2014-03-01 00:25:10.000000', 'consum', 0.0212, 'lps'),
	(561730, 129, '2014-03-01 00:25:11.000000', 'consum', 0.0217, 'lps'),
	(561731, 129, '2014-03-01 00:25:12.000000', 'consum', 0.0237, 'lps'),
	(561732, 129, '2014-03-01 00:25:13.000000', 'consum', 0.0237, 'lps'),
	(561733, 129, '2014-03-01 00:25:14.000000', 'consum', 0.0236, 'lps'),
	(561734, 129, '2014-03-01 00:25:15.000000', 'consum', 0.0232, 'lps'),
	(561735, 129, '2014-03-01 00:25:16.000000', 'consum', 0.0215, 'lps'),
	(561736, 129, '2014-03-01 00:25:17.000000', 'consum', 0.0224, 'lps'),
	(561737, 129, '2014-03-01 00:25:18.000000', 'consum', 0.0238, 'lps'),
	(561738, 129, '2014-03-01 00:25:19.000000', 'consum', 0.0223, 'lps'),
	(561739, 129, '2014-03-01 00:25:20.000000', 'consum', 0.0221, 'lps'),
	(561740, 129, '2014-03-01 00:25:21.000000', 'consum', 0.0223, 'lps'),
	(561741, 129, '2014-03-01 00:25:22.000000', 'consum', 0.0216, 'lps'),
	(561742, 129, '2014-03-01 00:25:23.000000', 'consum', 0.0231, 'lps'),
	(561743, 129, '2014-03-01 00:25:24.000000', 'consum', 0.0238, 'lps'),
	(561744, 129, '2014-03-01 00:25:25.000000', 'consum', 0.0229, 'lps'),
	(561745, 129, '2014-03-01 00:25:26.000000', 'consum', 0.0222, 'lps'),
	(561746, 129, '2014-03-01 00:25:27.000000', 'consum', 0.0214, 'lps'),
	(561747, 129, '2014-03-01 00:25:28.000000', 'consum', 0.0224, 'lps'),
	(561748, 129, '2014-03-01 00:25:29.000000', 'consum', 0.0212, 'lps'),
	(561749, 129, '2014-03-01 00:25:30.000000', 'consum', 0.0234, 'lps'),
	(561750, 129, '2014-03-01 00:25:31.000000', 'consum', 0.0210, 'lps'),
	(561751, 129, '2014-03-01 00:25:32.000000', 'consum', 0.0223, 'lps'),
	(561752, 129, '2014-03-01 00:25:33.000000', 'consum', 0.0219, 'lps'),
	(561753, 129, '2014-03-01 00:25:34.000000', 'consum', 0.0217, 'lps'),
	(561754, 129, '2014-03-01 00:25:35.000000', 'consum', 0.0217, 'lps'),
	(561755, 129, '2014-03-01 00:25:36.000000', 'consum', 0.0224, 'lps'),
	(561756, 129, '2014-03-01 00:25:37.000000', 'consum', 0.0230, 'lps'),
	(561757, 129, '2014-03-01 00:25:38.000000', 'consum', 0.0213, 'lps'),
	(561758, 129, '2014-03-01 00:25:39.000000', 'consum', 0.0224, 'lps'),
	(561759, 129, '2014-03-01 00:25:40.000000', 'consum', 0.0214, 'lps'),
	(561760, 129, '2014-03-01 00:25:41.000000', 'consum', 0.0218, 'lps'),
	(561761, 129, '2014-03-01 00:25:42.000000', 'consum', 0.0238, 'lps'),
	(561762, 129, '2014-03-01 00:25:43.000000', 'consum', 0.0210, 'lps'),
	(561763, 129, '2014-03-01 00:25:44.000000', 'consum', 0.0214, 'lps'),
	(561764, 129, '2014-03-01 00:25:45.000000', 'consum', 0.0228, 'lps'),
	(561765, 129, '2014-03-01 00:25:46.000000', 'consum', 0.0233, 'lps'),
	(561766, 129, '2014-03-01 00:25:47.000000', 'consum', 0.0214, 'lps'),
	(561767, 129, '2014-03-01 00:25:48.000000', 'consum', 0.0219, 'lps'),
	(561768, 129, '2014-03-01 00:25:49.000000', 'consum', 0.0216, 'lps'),
	(561769, 129, '2014-03-01 00:25:50.000000', 'consum', 0.0212, 'lps'),
	(561770, 129, '2014-03-01 00:25:51.000000', 'consum', 0.0233, 'lps'),
	(561771, 129, '2014-03-01 00:25:52.000000', 'consum', 0.0230, 'lps'),
	(561772, 129, '2014-03-01 00:25:53.000000', 'consum', 0.0213, 'lps'),
	(561773, 129, '2014-03-01 00:25:54.000000', 'consum', 0.0226, 'lps'),
	(561774, 129, '2014-03-01 00:25:55.000000', 'consum', 0.0221, 'lps'),
	(561775, 129, '2014-03-01 00:25:56.000000', 'consum', 0.0219, 'lps'),
	(561776, 129, '2014-03-01 00:25:57.000000', 'consum', 0.0222, 'lps'),
	(561777, 129, '2014-03-01 00:25:58.000000', 'consum', 0.0213, 'lps'),
	(561778, 129, '2014-03-01 00:25:59.000000', 'consum', 0.0222, 'lps'),
	(561779, 129, '2014-03-01 00:26:00.000000', 'consum', 0.0229, 'lps'),
	(561780, 129, '2014-03-01 00:26:01.000000', 'consum', 0.0213, 'lps'),
	(561781, 129, '2014-03-01 00:26:02.000000', 'consum', 0.0228, 'lps'),
	(561782, 129, '2014-03-01 00:26:03.000000', 'consum', 0.0230, 'lps'),
	(561783, 129, '2014-03-01 00:26:04.000000', 'consum', 0.0231, 'lps'),
	(561784, 129, '2014-03-01 00:26:05.000000', 'consum', 0.0224, 'lps'),
	(561785, 129, '2014-03-01 00:26:06.000000', 'consum', 0.0217, 'lps'),
	(561786, 129, '2014-03-01 00:26:07.000000', 'consum', 0.0235, 'lps'),
	(561787, 129, '2014-03-01 00:26:08.000000', 'consum', 0.0225, 'lps'),
	(561788, 129, '2014-03-01 00:26:09.000000', 'consum', 0.0212, 'lps'),
	(561789, 129, '2014-03-01 00:26:10.000000', 'consum', 0.0232, 'lps'),
	(561790, 129, '2014-03-01 00:26:11.000000', 'consum', 0.0227, 'lps'),
	(561791, 129, '2014-03-01 00:26:12.000000', 'consum', 0.0230, 'lps'),
	(561792, 129, '2014-03-01 00:26:13.000000', 'consum', 0.0229, 'lps'),
	(561793, 129, '2014-03-01 00:26:14.000000', 'consum', 0.0217, 'lps'),
	(561794, 129, '2014-03-01 00:26:15.000000', 'consum', 0.0219, 'lps'),
	(561795, 129, '2014-03-01 00:26:16.000000', 'consum', 0.0236, 'lps'),
	(561796, 129, '2014-03-01 00:26:17.000000', 'consum', 0.0224, 'lps'),
	(561797, 129, '2014-03-01 00:26:18.000000', 'consum', 0.0234, 'lps'),
	(561798, 129, '2014-03-01 00:26:19.000000', 'consum', 0.0229, 'lps'),
	(561799, 129, '2014-03-01 00:26:20.000000', 'consum', 0.0235, 'lps'),
	(561800, 129, '2014-03-01 00:26:21.000000', 'consum', 0.0219, 'lps'),
	(561801, 129, '2014-03-01 00:26:22.000000', 'consum', 0.0238, 'lps'),
	(561802, 129, '2014-03-01 00:26:23.000000', 'consum', 0.0238, 'lps'),
	(561803, 129, '2014-03-01 00:26:24.000000', 'consum', 0.0235, 'lps'),
	(561804, 129, '2014-03-01 00:26:25.000000', 'consum', 0.0223, 'lps'),
	(561805, 129, '2014-03-01 00:26:26.000000', 'consum', 0.0231, 'lps'),
	(561806, 129, '2014-03-01 00:26:27.000000', 'consum', 0.0219, 'lps'),
	(561807, 129, '2014-03-01 00:26:28.000000', 'consum', 0.0219, 'lps'),
	(561808, 129, '2014-03-01 00:26:29.000000', 'consum', 0.0228, 'lps'),
	(561809, 129, '2014-03-01 00:26:30.000000', 'consum', 0.0217, 'lps'),
	(561810, 129, '2014-03-01 00:26:31.000000', 'consum', 0.0220, 'lps'),
	(561811, 129, '2014-03-01 00:26:32.000000', 'consum', 0.0210, 'lps'),
	(561812, 129, '2014-03-01 00:26:33.000000', 'consum', 0.0210, 'lps'),
	(561813, 129, '2014-03-01 00:26:34.000000', 'consum', 0.0211, 'lps'),
	(561814, 129, '2014-03-01 00:26:35.000000', 'consum', 0.0216, 'lps'),
	(561815, 129, '2014-03-01 00:26:36.000000', 'consum', 0.0235, 'lps'),
	(561816, 129, '2014-03-01 00:26:37.000000', 'consum', 0.0234, 'lps'),
	(561817, 129, '2014-03-01 00:26:38.000000', 'consum', 0.0223, 'lps'),
	(561818, 129, '2014-03-01 00:26:39.000000', 'consum', 0.0235, 'lps'),
	(561819, 129, '2014-03-01 00:26:40.000000', 'consum', 0.0237, 'lps'),
	(561820, 129, '2014-03-01 00:26:41.000000', 'consum', 0.0211, 'lps'),
	(561821, 129, '2014-03-01 00:26:42.000000', 'consum', 0.0223, 'lps'),
	(561822, 129, '2014-03-01 00:26:43.000000', 'consum', 0.0213, 'lps'),
	(561823, 129, '2014-03-01 00:26:44.000000', 'consum', 0.0216, 'lps'),
	(561824, 129, '2014-03-01 00:26:45.000000', 'consum', 0.0231, 'lps'),
	(561825, 129, '2014-03-01 00:26:46.000000', 'consum', 0.0238, 'lps'),
	(561826, 129, '2014-03-01 00:26:47.000000', 'consum', 0.0232, 'lps'),
	(561827, 129, '2014-03-01 00:26:48.000000', 'consum', 0.0235, 'lps'),
	(561828, 129, '2014-03-01 00:26:49.000000', 'consum', 0.0214, 'lps'),
	(561829, 129, '2014-03-01 00:26:50.000000', 'consum', 0.0213, 'lps'),
	(561830, 129, '2014-03-01 00:26:51.000000', 'consum', 0.0211, 'lps'),
	(561831, 129, '2014-03-01 00:26:52.000000', 'consum', 0.0238, 'lps'),
	(561832, 129, '2014-03-01 00:26:53.000000', 'consum', 0.0230, 'lps'),
	(561833, 129, '2014-03-01 00:26:54.000000', 'consum', 0.0226, 'lps'),
	(561834, 129, '2014-03-01 00:26:55.000000', 'consum', 0.0232, 'lps'),
	(561835, 129, '2014-03-01 00:26:56.000000', 'consum', 0.0215, 'lps'),
	(561836, 129, '2014-03-01 00:26:57.000000', 'consum', 0.0228, 'lps'),
	(561837, 129, '2014-03-01 00:26:58.000000', 'consum', 0.0227, 'lps'),
	(561838, 129, '2014-03-01 00:26:59.000000', 'consum', 0.0213, 'lps'),
	(561839, 129, '2014-03-01 00:27:00.000000', 'consum', 0.0231, 'lps'),
	(561840, 129, '2014-03-01 00:27:01.000000', 'consum', 0.0221, 'lps'),
	(561841, 129, '2014-03-01 00:27:02.000000', 'consum', 0.0231, 'lps'),
	(561842, 129, '2014-03-01 00:27:03.000000', 'consum', 0.0225, 'lps'),
	(561843, 129, '2014-03-01 00:27:04.000000', 'consum', 0.0223, 'lps'),
	(561844, 129, '2014-03-01 00:27:05.000000', 'consum', 0.0231, 'lps'),
	(561845, 129, '2014-03-01 00:27:06.000000', 'consum', 0.0218, 'lps'),
	(561846, 129, '2014-03-01 00:27:07.000000', 'consum', 0.0218, 'lps'),
	(561847, 129, '2014-03-01 00:27:08.000000', 'consum', 0.0224, 'lps'),
	(561848, 129, '2014-03-01 00:27:09.000000', 'consum', 0.0230, 'lps'),
	(561849, 129, '2014-03-01 00:27:10.000000', 'consum', 0.0210, 'lps'),
	(561850, 129, '2014-03-01 00:27:11.000000', 'consum', 0.0236, 'lps'),
	(561851, 129, '2014-03-01 00:27:12.000000', 'consum', 0.0227, 'lps'),
	(561852, 129, '2014-03-01 00:27:13.000000', 'consum', 0.0218, 'lps'),
	(561853, 129, '2014-03-01 00:27:14.000000', 'consum', 0.0226, 'lps'),
	(561854, 129, '2014-03-01 00:27:15.000000', 'consum', 0.0238, 'lps'),
	(561855, 129, '2014-03-01 00:27:16.000000', 'consum', 0.0218, 'lps'),
	(561856, 129, '2014-03-01 00:27:17.000000', 'consum', 0.0223, 'lps'),
	(561857, 129, '2014-03-01 00:27:18.000000', 'consum', 0.0221, 'lps'),
	(561858, 129, '2014-03-01 00:27:19.000000', 'consum', 0.0227, 'lps'),
	(561859, 129, '2014-03-01 00:27:20.000000', 'consum', 0.0236, 'lps'),
	(561860, 129, '2014-03-01 00:27:21.000000', 'consum', 0.0228, 'lps'),
	(561861, 129, '2014-03-01 00:27:22.000000', 'consum', 0.0224, 'lps'),
	(561862, 129, '2014-03-01 00:27:23.000000', 'consum', 0.0228, 'lps'),
	(561863, 129, '2014-03-01 00:27:24.000000', 'consum', 0.0230, 'lps'),
	(561864, 129, '2014-03-01 00:27:25.000000', 'consum', 0.0228, 'lps'),
	(561865, 129, '2014-03-01 00:27:26.000000', 'consum', 0.0210, 'lps'),
	(561866, 129, '2014-03-01 00:27:27.000000', 'consum', 0.0214, 'lps'),
	(561867, 129, '2014-03-01 00:27:28.000000', 'consum', 0.0230, 'lps'),
	(561868, 129, '2014-03-01 00:27:29.000000', 'consum', 0.0211, 'lps'),
	(561869, 129, '2014-03-01 00:27:30.000000', 'consum', 0.0216, 'lps'),
	(561870, 129, '2014-03-01 00:27:31.000000', 'consum', 0.0235, 'lps'),
	(561871, 129, '2014-03-01 00:27:32.000000', 'consum', 0.0233, 'lps'),
	(561872, 129, '2014-03-01 00:27:33.000000', 'consum', 0.0220, 'lps'),
	(561873, 129, '2014-03-01 00:27:34.000000', 'consum', 0.0222, 'lps'),
	(561874, 129, '2014-03-01 00:27:35.000000', 'consum', 0.0211, 'lps'),
	(561875, 129, '2014-03-01 00:27:36.000000', 'consum', 0.0238, 'lps'),
	(561876, 129, '2014-03-01 00:27:37.000000', 'consum', 0.0231, 'lps'),
	(561877, 129, '2014-03-01 00:27:38.000000', 'consum', 0.0233, 'lps'),
	(561878, 129, '2014-03-01 00:27:39.000000', 'consum', 0.0233, 'lps'),
	(561879, 129, '2014-03-01 00:27:40.000000', 'consum', 0.0228, 'lps'),
	(561880, 129, '2014-03-01 00:27:41.000000', 'consum', 0.0233, 'lps'),
	(561881, 129, '2014-03-01 00:27:42.000000', 'consum', 0.0210, 'lps'),
	(561882, 129, '2014-03-01 00:27:43.000000', 'consum', 0.0232, 'lps'),
	(561883, 129, '2014-03-01 00:27:44.000000', 'consum', 0.0230, 'lps'),
	(561884, 129, '2014-03-01 00:27:45.000000', 'consum', 0.0219, 'lps'),
	(561885, 129, '2014-03-01 00:27:46.000000', 'consum', 0.0221, 'lps'),
	(561886, 129, '2014-03-01 00:27:47.000000', 'consum', 0.0212, 'lps'),
	(561887, 129, '2014-03-01 00:27:48.000000', 'consum', 0.0217, 'lps'),
	(561888, 129, '2014-03-01 00:27:49.000000', 'consum', 0.0211, 'lps'),
	(561889, 129, '2014-03-01 00:27:50.000000', 'consum', 0.0224, 'lps'),
	(561890, 129, '2014-03-01 00:27:51.000000', 'consum', 0.0220, 'lps'),
	(561891, 129, '2014-03-01 00:27:52.000000', 'consum', 0.0217, 'lps'),
	(561892, 129, '2014-03-01 00:27:53.000000', 'consum', 0.0216, 'lps'),
	(561893, 129, '2014-03-01 00:27:54.000000', 'consum', 0.0221, 'lps'),
	(561894, 129, '2014-03-01 00:27:55.000000', 'consum', 0.0219, 'lps'),
	(561895, 129, '2014-03-01 00:27:56.000000', 'consum', 0.0220, 'lps'),
	(561896, 129, '2014-03-01 00:27:57.000000', 'consum', 0.0235, 'lps'),
	(561897, 129, '2014-03-01 00:27:58.000000', 'consum', 0.0219, 'lps'),
	(561898, 129, '2014-03-01 00:27:59.000000', 'consum', 0.0238, 'lps'),
	(561899, 129, '2014-03-01 00:28:00.000000', 'consum', 0.0235, 'lps'),
	(561900, 129, '2014-03-01 00:28:01.000000', 'consum', 0.0225, 'lps'),
	(561901, 129, '2014-03-01 00:28:02.000000', 'consum', 0.0210, 'lps'),
	(561902, 129, '2014-03-01 00:28:03.000000', 'consum', 0.0223, 'lps'),
	(561903, 129, '2014-03-01 00:28:04.000000', 'consum', 0.0216, 'lps'),
	(561904, 129, '2014-03-01 00:28:05.000000', 'consum', 0.0232, 'lps'),
	(561905, 129, '2014-03-01 00:28:06.000000', 'consum', 0.0215, 'lps'),
	(561906, 129, '2014-03-01 00:28:07.000000', 'consum', 0.0226, 'lps'),
	(561907, 129, '2014-03-01 00:28:08.000000', 'consum', 0.0217, 'lps'),
	(561908, 129, '2014-03-01 00:28:09.000000', 'consum', 0.0229, 'lps'),
	(561909, 129, '2014-03-01 00:28:10.000000', 'consum', 0.0227, 'lps'),
	(561910, 129, '2014-03-01 00:28:11.000000', 'consum', 0.0236, 'lps'),
	(561911, 129, '2014-03-01 00:28:12.000000', 'consum', 0.0232, 'lps'),
	(561912, 129, '2014-03-01 00:28:13.000000', 'consum', 0.0215, 'lps'),
	(561913, 129, '2014-03-01 00:28:14.000000', 'consum', 0.0228, 'lps'),
	(561914, 129, '2014-03-01 00:28:15.000000', 'consum', 0.0225, 'lps'),
	(561915, 129, '2014-03-01 00:28:16.000000', 'consum', 0.0232, 'lps'),
	(561916, 129, '2014-03-01 00:28:17.000000', 'consum', 0.0218, 'lps'),
	(561917, 129, '2014-03-01 00:28:18.000000', 'consum', 0.0213, 'lps'),
	(561918, 129, '2014-03-01 00:28:19.000000', 'consum', 0.0229, 'lps'),
	(561919, 129, '2014-03-01 00:28:20.000000', 'consum', 0.0212, 'lps'),
	(561920, 129, '2014-03-01 00:28:21.000000', 'consum', 0.0222, 'lps'),
	(561921, 129, '2014-03-01 00:28:22.000000', 'consum', 0.0232, 'lps'),
	(561922, 129, '2014-03-01 00:28:23.000000', 'consum', 0.0230, 'lps'),
	(561923, 129, '2014-03-01 00:28:24.000000', 'consum', 0.0214, 'lps'),
	(561924, 129, '2014-03-01 00:28:25.000000', 'consum', 0.0231, 'lps'),
	(561925, 129, '2014-03-01 00:28:26.000000', 'consum', 0.0214, 'lps'),
	(561926, 129, '2014-03-01 00:28:27.000000', 'consum', 0.0226, 'lps'),
	(561927, 129, '2014-03-01 00:28:28.000000', 'consum', 0.0220, 'lps'),
	(561928, 129, '2014-03-01 00:28:29.000000', 'consum', 0.0212, 'lps'),
	(561929, 129, '2014-03-01 00:28:30.000000', 'consum', 0.0219, 'lps'),
	(561930, 129, '2014-03-01 00:28:31.000000', 'consum', 0.0221, 'lps'),
	(561931, 129, '2014-03-01 00:28:32.000000', 'consum', 0.0238, 'lps'),
	(561932, 129, '2014-03-01 00:28:33.000000', 'consum', 0.0231, 'lps'),
	(561933, 129, '2014-03-01 00:28:34.000000', 'consum', 0.0232, 'lps'),
	(561934, 129, '2014-03-01 00:28:35.000000', 'consum', 0.0229, 'lps'),
	(561935, 129, '2014-03-01 00:28:36.000000', 'consum', 0.0212, 'lps'),
	(561936, 129, '2014-03-01 00:28:37.000000', 'consum', 0.0220, 'lps'),
	(561937, 129, '2014-03-01 00:28:38.000000', 'consum', 0.0225, 'lps'),
	(561938, 129, '2014-03-01 00:28:39.000000', 'consum', 0.0227, 'lps'),
	(561939, 129, '2014-03-01 00:28:40.000000', 'consum', 0.0221, 'lps'),
	(561940, 129, '2014-03-01 00:28:41.000000', 'consum', 0.0215, 'lps'),
	(561941, 129, '2014-03-01 00:28:42.000000', 'consum', 0.0232, 'lps'),
	(561942, 129, '2014-03-01 00:28:43.000000', 'consum', 0.0217, 'lps'),
	(561943, 129, '2014-03-01 00:28:44.000000', 'consum', 0.0210, 'lps'),
	(561944, 129, '2014-03-01 00:28:45.000000', 'consum', 0.0217, 'lps'),
	(561945, 129, '2014-03-01 00:28:46.000000', 'consum', 0.0219, 'lps'),
	(561946, 129, '2014-03-01 00:28:47.000000', 'consum', 0.0232, 'lps'),
	(561947, 129, '2014-03-01 00:28:48.000000', 'consum', 0.0236, 'lps'),
	(561948, 129, '2014-03-01 00:28:49.000000', 'consum', 0.0215, 'lps'),
	(561949, 129, '2014-03-01 00:28:50.000000', 'consum', 0.0216, 'lps'),
	(561950, 129, '2014-03-01 00:28:51.000000', 'consum', 0.0224, 'lps'),
	(561951, 129, '2014-03-01 00:28:52.000000', 'consum', 0.0236, 'lps'),
	(561952, 129, '2014-03-01 00:28:53.000000', 'consum', 0.0210, 'lps'),
	(561953, 129, '2014-03-01 00:28:54.000000', 'consum', 0.0219, 'lps'),
	(561954, 129, '2014-03-01 00:28:55.000000', 'consum', 0.0228, 'lps'),
	(561955, 129, '2014-03-01 00:28:56.000000', 'consum', 0.0216, 'lps'),
	(561956, 129, '2014-03-01 00:28:57.000000', 'consum', 0.0214, 'lps'),
	(561957, 129, '2014-03-01 00:28:58.000000', 'consum', 0.0211, 'lps'),
	(561958, 129, '2014-03-01 00:28:59.000000', 'consum', 0.0234, 'lps'),
	(561959, 129, '2014-03-01 00:29:00.000000', 'consum', 0.0212, 'lps'),
	(561960, 129, '2014-03-01 00:29:01.000000', 'consum', 0.0235, 'lps'),
	(561961, 129, '2014-03-01 00:29:02.000000', 'consum', 0.0214, 'lps'),
	(561962, 129, '2014-03-01 00:29:03.000000', 'consum', 0.0214, 'lps'),
	(561963, 129, '2014-03-01 00:29:04.000000', 'consum', 0.0218, 'lps'),
	(561964, 129, '2014-03-01 00:29:05.000000', 'consum', 0.0211, 'lps'),
	(561965, 129, '2014-03-01 00:29:06.000000', 'consum', 0.0219, 'lps'),
	(561966, 129, '2014-03-01 00:29:07.000000', 'consum', 0.0222, 'lps'),
	(561967, 129, '2014-03-01 00:29:08.000000', 'consum', 0.0214, 'lps'),
	(561968, 129, '2014-03-01 00:29:09.000000', 'consum', 0.0226, 'lps'),
	(561969, 129, '2014-03-01 00:29:10.000000', 'consum', 0.0221, 'lps'),
	(561970, 129, '2014-03-01 00:29:11.000000', 'consum', 0.0217, 'lps'),
	(561971, 129, '2014-03-01 00:29:12.000000', 'consum', 0.0213, 'lps'),
	(561972, 129, '2014-03-01 00:29:13.000000', 'consum', 0.0232, 'lps'),
	(561973, 129, '2014-03-01 00:29:14.000000', 'consum', 0.0223, 'lps'),
	(561974, 129, '2014-03-01 00:29:15.000000', 'consum', 0.0211, 'lps'),
	(561975, 129, '2014-03-01 00:29:16.000000', 'consum', 0.0235, 'lps'),
	(561976, 129, '2014-03-01 00:29:17.000000', 'consum', 0.0214, 'lps'),
	(561977, 129, '2014-03-01 00:29:18.000000', 'consum', 0.0215, 'lps'),
	(561978, 129, '2014-03-01 00:29:19.000000', 'consum', 0.0224, 'lps'),
	(561979, 129, '2014-03-01 00:29:20.000000', 'consum', 0.0236, 'lps'),
	(561980, 129, '2014-03-01 00:29:21.000000', 'consum', 0.0213, 'lps'),
	(561981, 129, '2014-03-01 00:29:22.000000', 'consum', 0.0236, 'lps'),
	(561982, 129, '2014-03-01 00:29:23.000000', 'consum', 0.0212, 'lps'),
	(561983, 129, '2014-03-01 00:29:24.000000', 'consum', 0.0230, 'lps'),
	(561984, 129, '2014-03-01 00:29:25.000000', 'consum', 0.0218, 'lps'),
	(561985, 129, '2014-03-01 00:29:26.000000', 'consum', 0.0218, 'lps'),
	(561986, 129, '2014-03-01 00:29:27.000000', 'consum', 0.0226, 'lps'),
	(561987, 129, '2014-03-01 00:29:28.000000', 'consum', 0.0212, 'lps'),
	(561988, 129, '2014-03-01 00:29:29.000000', 'consum', 0.0227, 'lps'),
	(561989, 129, '2014-03-01 00:29:30.000000', 'consum', 0.0232, 'lps'),
	(561990, 129, '2014-03-01 00:29:31.000000', 'consum', 0.0214, 'lps'),
	(561991, 129, '2014-03-01 00:29:32.000000', 'consum', 0.0221, 'lps'),
	(561992, 129, '2014-03-01 00:29:33.000000', 'consum', 0.0225, 'lps'),
	(561993, 129, '2014-03-01 00:29:34.000000', 'consum', 0.0221, 'lps'),
	(561994, 129, '2014-03-01 00:29:35.000000', 'consum', 0.0222, 'lps'),
	(561995, 129, '2014-03-01 00:29:36.000000', 'consum', 0.0210, 'lps'),
	(561996, 129, '2014-03-01 00:29:37.000000', 'consum', 0.0233, 'lps'),
	(561997, 129, '2014-03-01 00:29:38.000000', 'consum', 0.0238, 'lps'),
	(561998, 129, '2014-03-01 00:29:39.000000', 'consum', 0.0225, 'lps'),
	(561999, 129, '2014-03-01 00:29:40.000000', 'consum', 0.0228, 'lps'),
	(562000, 129, '2014-03-01 00:29:41.000000', 'consum', 0.0227, 'lps'),
	(562001, 129, '2014-03-01 00:29:42.000000', 'consum', 0.0213, 'lps'),
	(562002, 129, '2014-03-01 00:29:43.000000', 'consum', 0.0234, 'lps'),
	(562003, 129, '2014-03-01 00:29:44.000000', 'consum', 0.0233, 'lps'),
	(562004, 129, '2014-03-01 00:29:45.000000', 'consum', 0.0224, 'lps'),
	(562005, 129, '2014-03-01 00:29:46.000000', 'consum', 0.0213, 'lps'),
	(562006, 129, '2014-03-01 00:29:47.000000', 'consum', 0.0210, 'lps'),
	(562007, 129, '2014-03-01 00:29:48.000000', 'consum', 0.0233, 'lps'),
	(562008, 129, '2014-03-01 00:29:49.000000', 'consum', 0.0236, 'lps'),
	(562009, 129, '2014-03-01 00:29:50.000000', 'consum', 0.0214, 'lps'),
	(562010, 129, '2014-03-01 00:29:51.000000', 'consum', 0.0212, 'lps'),
	(562011, 129, '2014-03-01 00:29:52.000000', 'consum', 0.0238, 'lps'),
	(562012, 129, '2014-03-01 00:29:53.000000', 'consum', 0.0229, 'lps'),
	(562013, 129, '2014-03-01 00:29:54.000000', 'consum', 0.0219, 'lps'),
	(562014, 129, '2014-03-01 00:29:55.000000', 'consum', 0.0227, 'lps'),
	(562015, 129, '2014-03-01 00:29:56.000000', 'consum', 0.0212, 'lps'),
	(562016, 129, '2014-03-01 00:29:57.000000', 'consum', 0.0228, 'lps'),
	(562017, 129, '2014-03-01 00:29:58.000000', 'consum', 0.0235, 'lps'),
	(562018, 129, '2014-03-01 00:29:59.000000', 'consum', 0.0224, 'lps'),
	(562019, 129, '2014-03-01 00:30:00.000000', 'consum', 0.0234, 'lps'),
	(562020, 129, '2014-03-01 00:30:01.000000', 'consum', 0.0232, 'lps'),
	(562021, 129, '2014-03-01 00:30:02.000000', 'consum', 0.0217, 'lps'),
	(562022, 129, '2014-03-01 00:30:03.000000', 'consum', 0.0238, 'lps'),
	(562023, 129, '2014-03-01 00:30:04.000000', 'consum', 0.0216, 'lps'),
	(562024, 129, '2014-03-01 00:30:05.000000', 'consum', 0.0212, 'lps'),
	(562025, 129, '2014-03-01 00:30:06.000000', 'consum', 0.0234, 'lps'),
	(562026, 129, '2014-03-01 00:30:07.000000', 'consum', 0.0234, 'lps'),
	(562027, 129, '2014-03-01 00:30:08.000000', 'consum', 0.0233, 'lps'),
	(562028, 129, '2014-03-01 00:30:09.000000', 'consum', 0.0223, 'lps'),
	(562029, 129, '2014-03-01 00:30:10.000000', 'consum', 0.0236, 'lps'),
	(562030, 129, '2014-03-01 00:30:11.000000', 'consum', 0.0213, 'lps'),
	(562031, 129, '2014-03-01 00:30:12.000000', 'consum', 0.0236, 'lps'),
	(562032, 129, '2014-03-01 00:30:13.000000', 'consum', 0.0217, 'lps'),
	(562033, 129, '2014-03-01 00:30:14.000000', 'consum', 0.0223, 'lps'),
	(562034, 129, '2014-03-01 00:30:15.000000', 'consum', 0.0225, 'lps'),
	(562035, 129, '2014-03-01 00:30:16.000000', 'consum', 0.0218, 'lps'),
	(562036, 129, '2014-03-01 00:30:17.000000', 'consum', 0.0234, 'lps'),
	(562037, 129, '2014-03-01 00:30:18.000000', 'consum', 0.0220, 'lps'),
	(562038, 129, '2014-03-01 00:30:19.000000', 'consum', 0.0216, 'lps'),
	(562039, 129, '2014-03-01 00:30:20.000000', 'consum', 0.0212, 'lps'),
	(562040, 129, '2014-03-01 00:30:21.000000', 'consum', 0.0232, 'lps'),
	(562041, 129, '2014-03-01 00:30:22.000000', 'consum', 0.0228, 'lps'),
	(562042, 129, '2014-03-01 00:30:23.000000', 'consum', 0.0236, 'lps'),
	(562043, 129, '2014-03-01 00:30:24.000000', 'consum', 0.0225, 'lps'),
	(562044, 129, '2014-03-01 00:30:25.000000', 'consum', 0.0238, 'lps'),
	(562045, 129, '2014-03-01 00:30:26.000000', 'consum', 0.0219, 'lps'),
	(562046, 129, '2014-03-01 00:30:27.000000', 'consum', 0.0230, 'lps'),
	(562047, 129, '2014-03-01 00:30:28.000000', 'consum', 0.0227, 'lps'),
	(562048, 129, '2014-03-01 00:30:29.000000', 'consum', 0.0232, 'lps'),
	(562049, 129, '2014-03-01 00:30:30.000000', 'consum', 0.0214, 'lps'),
	(562050, 129, '2014-03-01 00:30:31.000000', 'consum', 0.0221, 'lps'),
	(562051, 129, '2014-03-01 00:30:32.000000', 'consum', 0.0227, 'lps'),
	(562052, 129, '2014-03-01 00:30:33.000000', 'consum', 0.0231, 'lps'),
	(562053, 129, '2014-03-01 00:30:34.000000', 'consum', 0.0235, 'lps'),
	(562054, 129, '2014-03-01 00:30:35.000000', 'consum', 0.0217, 'lps'),
	(562055, 129, '2014-03-01 00:30:36.000000', 'consum', 0.0229, 'lps'),
	(562056, 129, '2014-03-01 00:30:37.000000', 'consum', 0.0227, 'lps'),
	(562057, 129, '2014-03-01 00:30:38.000000', 'consum', 0.0237, 'lps'),
	(562058, 129, '2014-03-01 00:30:39.000000', 'consum', 0.0238, 'lps'),
	(562059, 129, '2014-03-01 00:30:40.000000', 'consum', 0.0210, 'lps'),
	(562060, 129, '2014-03-01 00:30:41.000000', 'consum', 0.0212, 'lps'),
	(562061, 129, '2014-03-01 00:30:42.000000', 'consum', 0.0222, 'lps'),
	(562062, 129, '2014-03-01 00:30:43.000000', 'consum', 0.0236, 'lps'),
	(562063, 129, '2014-03-01 00:30:44.000000', 'consum', 0.0215, 'lps'),
	(562064, 129, '2014-03-01 00:30:45.000000', 'consum', 0.0217, 'lps'),
	(562065, 129, '2014-03-01 00:30:46.000000', 'consum', 0.0231, 'lps'),
	(562066, 129, '2014-03-01 00:30:47.000000', 'consum', 0.0237, 'lps'),
	(562067, 129, '2014-03-01 00:30:48.000000', 'consum', 0.0225, 'lps'),
	(562068, 129, '2014-03-01 00:30:49.000000', 'consum', 0.0231, 'lps'),
	(562069, 129, '2014-03-01 00:30:50.000000', 'consum', 0.0214, 'lps'),
	(562070, 129, '2014-03-01 00:30:51.000000', 'consum', 0.0227, 'lps'),
	(562071, 129, '2014-03-01 00:30:52.000000', 'consum', 0.0223, 'lps'),
	(562072, 129, '2014-03-01 00:30:53.000000', 'consum', 0.0225, 'lps'),
	(562073, 129, '2014-03-01 00:30:54.000000', 'consum', 0.0218, 'lps'),
	(562074, 129, '2014-03-01 00:30:55.000000', 'consum', 0.0235, 'lps'),
	(562075, 129, '2014-03-01 00:30:56.000000', 'consum', 0.0223, 'lps'),
	(562076, 129, '2014-03-01 00:30:57.000000', 'consum', 0.0232, 'lps'),
	(562077, 129, '2014-03-01 00:30:58.000000', 'consum', 0.0222, 'lps'),
	(562078, 129, '2014-03-01 00:30:59.000000', 'consum', 0.0234, 'lps'),
	(562079, 129, '2014-03-01 00:31:00.000000', 'consum', 0.0235, 'lps'),
	(562080, 129, '2014-03-01 00:31:01.000000', 'consum', 0.0237, 'lps'),
	(562081, 129, '2014-03-01 00:31:02.000000', 'consum', 0.0238, 'lps'),
	(562082, 129, '2014-03-01 00:31:03.000000', 'consum', 0.0215, 'lps'),
	(562083, 129, '2014-03-01 00:31:04.000000', 'consum', 0.0235, 'lps'),
	(562084, 129, '2014-03-01 00:31:05.000000', 'consum', 0.0237, 'lps'),
	(562085, 129, '2014-03-01 00:31:06.000000', 'consum', 0.0211, 'lps'),
	(562086, 129, '2014-03-01 00:31:07.000000', 'consum', 0.0221, 'lps'),
	(562087, 129, '2014-03-01 00:31:08.000000', 'consum', 0.0235, 'lps'),
	(562088, 129, '2014-03-01 00:31:09.000000', 'consum', 0.0215, 'lps'),
	(562089, 129, '2014-03-01 00:31:10.000000', 'consum', 0.0219, 'lps'),
	(562090, 129, '2014-03-01 00:31:11.000000', 'consum', 0.0238, 'lps'),
	(562091, 129, '2014-03-01 00:31:12.000000', 'consum', 0.0210, 'lps'),
	(562092, 129, '2014-03-01 00:31:13.000000', 'consum', 0.0211, 'lps'),
	(562093, 129, '2014-03-01 00:31:14.000000', 'consum', 0.0218, 'lps'),
	(562094, 129, '2014-03-01 00:31:15.000000', 'consum', 0.0218, 'lps'),
	(562095, 129, '2014-03-01 00:31:16.000000', 'consum', 0.0224, 'lps'),
	(562096, 129, '2014-03-01 00:31:17.000000', 'consum', 0.0231, 'lps'),
	(562097, 129, '2014-03-01 00:31:18.000000', 'consum', 0.0212, 'lps'),
	(562098, 129, '2014-03-01 00:31:19.000000', 'consum', 0.0218, 'lps'),
	(562099, 129, '2014-03-01 00:31:20.000000', 'consum', 0.0213, 'lps'),
	(562100, 129, '2014-03-01 00:31:21.000000', 'consum', 0.0231, 'lps'),
	(562101, 129, '2014-03-01 00:31:22.000000', 'consum', 0.0221, 'lps'),
	(562102, 129, '2014-03-01 00:31:23.000000', 'consum', 0.0230, 'lps'),
	(562103, 129, '2014-03-01 00:31:24.000000', 'consum', 0.0220, 'lps'),
	(562104, 129, '2014-03-01 00:31:25.000000', 'consum', 0.0231, 'lps'),
	(562105, 129, '2014-03-01 00:31:26.000000', 'consum', 0.0228, 'lps'),
	(562106, 129, '2014-03-01 00:31:27.000000', 'consum', 0.0234, 'lps'),
	(562107, 129, '2014-03-01 00:31:28.000000', 'consum', 0.0222, 'lps'),
	(562108, 129, '2014-03-01 00:31:29.000000', 'consum', 0.0228, 'lps'),
	(562109, 129, '2014-03-01 00:31:30.000000', 'consum', 0.0233, 'lps'),
	(562110, 129, '2014-03-01 00:31:31.000000', 'consum', 0.0215, 'lps'),
	(562111, 129, '2014-03-01 00:31:32.000000', 'consum', 0.0226, 'lps'),
	(562112, 129, '2014-03-01 00:31:33.000000', 'consum', 0.0215, 'lps'),
	(562113, 129, '2014-03-01 00:31:34.000000', 'consum', 0.0217, 'lps'),
	(562114, 129, '2014-03-01 00:31:35.000000', 'consum', 0.0230, 'lps'),
	(562115, 129, '2014-03-01 00:31:36.000000', 'consum', 0.0231, 'lps'),
	(562116, 129, '2014-03-01 00:31:37.000000', 'consum', 0.0225, 'lps'),
	(562117, 129, '2014-03-01 00:31:38.000000', 'consum', 0.0225, 'lps'),
	(562118, 129, '2014-03-01 00:31:39.000000', 'consum', 0.0211, 'lps'),
	(562119, 129, '2014-03-01 00:31:40.000000', 'consum', 0.0231, 'lps'),
	(562120, 129, '2014-03-01 00:31:41.000000', 'consum', 0.0222, 'lps'),
	(562121, 129, '2014-03-01 00:31:42.000000', 'consum', 0.0236, 'lps'),
	(562122, 129, '2014-03-01 00:31:43.000000', 'consum', 0.0218, 'lps'),
	(562123, 129, '2014-03-01 00:31:44.000000', 'consum', 0.0231, 'lps'),
	(562124, 129, '2014-03-01 00:31:45.000000', 'consum', 0.0232, 'lps'),
	(562125, 129, '2014-03-01 00:31:46.000000', 'consum', 0.0231, 'lps'),
	(562126, 129, '2014-03-01 00:31:47.000000', 'consum', 0.0220, 'lps'),
	(562127, 129, '2014-03-01 00:31:48.000000', 'consum', 0.0225, 'lps'),
	(562128, 129, '2014-03-01 00:31:49.000000', 'consum', 0.0228, 'lps'),
	(562129, 129, '2014-03-01 00:31:50.000000', 'consum', 0.0226, 'lps'),
	(562130, 129, '2014-03-01 00:31:51.000000', 'consum', 0.0237, 'lps'),
	(562131, 129, '2014-03-01 00:31:52.000000', 'consum', 0.0238, 'lps'),
	(562132, 129, '2014-03-01 00:31:53.000000', 'consum', 0.0214, 'lps'),
	(562133, 129, '2014-03-01 00:31:54.000000', 'consum', 0.0233, 'lps'),
	(562134, 129, '2014-03-01 00:31:55.000000', 'consum', 0.0227, 'lps'),
	(562135, 129, '2014-03-01 00:31:56.000000', 'consum', 0.0227, 'lps'),
	(562136, 129, '2014-03-01 00:31:57.000000', 'consum', 0.0216, 'lps'),
	(562137, 129, '2014-03-01 00:31:58.000000', 'consum', 0.0216, 'lps'),
	(562138, 129, '2014-03-01 00:31:59.000000', 'consum', 0.0225, 'lps'),
	(562139, 129, '2014-03-01 00:32:00.000000', 'consum', 0.0237, 'lps'),
	(562140, 129, '2014-03-01 00:32:01.000000', 'consum', 0.0214, 'lps'),
	(562141, 129, '2014-03-01 00:32:02.000000', 'consum', 0.0237, 'lps'),
	(562142, 129, '2014-03-01 00:32:03.000000', 'consum', 0.0217, 'lps'),
	(562143, 129, '2014-03-01 00:32:04.000000', 'consum', 0.0223, 'lps'),
	(562144, 129, '2014-03-01 00:32:05.000000', 'consum', 0.0226, 'lps'),
	(562145, 129, '2014-03-01 00:32:06.000000', 'consum', 0.0220, 'lps'),
	(562146, 129, '2014-03-01 00:32:07.000000', 'consum', 0.0213, 'lps'),
	(562147, 129, '2014-03-01 00:32:08.000000', 'consum', 0.0227, 'lps'),
	(562148, 129, '2014-03-01 00:32:09.000000', 'consum', 0.0228, 'lps'),
	(562149, 129, '2014-03-01 00:32:10.000000', 'consum', 0.0219, 'lps'),
	(562150, 129, '2014-03-01 00:32:11.000000', 'consum', 0.0233, 'lps'),
	(562151, 129, '2014-03-01 00:32:12.000000', 'consum', 0.0238, 'lps'),
	(562152, 129, '2014-03-01 00:32:13.000000', 'consum', 0.0224, 'lps'),
	(562153, 129, '2014-03-01 00:32:14.000000', 'consum', 0.0226, 'lps'),
	(562154, 129, '2014-03-01 00:32:15.000000', 'consum', 0.0219, 'lps'),
	(562155, 129, '2014-03-01 00:32:16.000000', 'consum', 0.0236, 'lps'),
	(562156, 129, '2014-03-01 00:32:17.000000', 'consum', 0.0227, 'lps'),
	(562157, 129, '2014-03-01 00:32:18.000000', 'consum', 0.0220, 'lps'),
	(562158, 129, '2014-03-01 00:32:19.000000', 'consum', 0.0235, 'lps'),
	(562159, 129, '2014-03-01 00:32:20.000000', 'consum', 0.0219, 'lps'),
	(562160, 129, '2014-03-01 00:32:21.000000', 'consum', 0.0238, 'lps'),
	(562161, 129, '2014-03-01 00:32:22.000000', 'consum', 0.0238, 'lps'),
	(562162, 129, '2014-03-01 00:32:23.000000', 'consum', 0.0236, 'lps'),
	(562163, 129, '2014-03-01 00:32:24.000000', 'consum', 0.0227, 'lps'),
	(562164, 129, '2014-03-01 00:32:25.000000', 'consum', 0.0220, 'lps'),
	(562165, 129, '2014-03-01 00:32:26.000000', 'consum', 0.0237, 'lps'),
	(562166, 129, '2014-03-01 00:32:27.000000', 'consum', 0.0227, 'lps'),
	(562167, 129, '2014-03-01 00:32:28.000000', 'consum', 0.0215, 'lps'),
	(562168, 129, '2014-03-01 00:32:29.000000', 'consum', 0.0214, 'lps'),
	(562169, 129, '2014-03-01 00:32:30.000000', 'consum', 0.0216, 'lps'),
	(562170, 129, '2014-03-01 00:32:31.000000', 'consum', 0.0228, 'lps'),
	(562171, 129, '2014-03-01 00:32:32.000000', 'consum', 0.0224, 'lps'),
	(562172, 129, '2014-03-01 00:32:33.000000', 'consum', 0.0226, 'lps'),
	(562173, 129, '2014-03-01 00:32:34.000000', 'consum', 0.0218, 'lps'),
	(562174, 129, '2014-03-01 00:32:35.000000', 'consum', 0.0235, 'lps'),
	(562175, 129, '2014-03-01 00:32:36.000000', 'consum', 0.0222, 'lps'),
	(562176, 129, '2014-03-01 00:32:37.000000', 'consum', 0.0225, 'lps'),
	(562177, 129, '2014-03-01 00:32:38.000000', 'consum', 0.0222, 'lps'),
	(562178, 129, '2014-03-01 00:32:39.000000', 'consum', 0.0223, 'lps'),
	(562179, 129, '2014-03-01 00:32:40.000000', 'consum', 0.0210, 'lps'),
	(562180, 129, '2014-03-01 00:32:41.000000', 'consum', 0.0231, 'lps'),
	(562181, 129, '2014-03-01 00:32:42.000000', 'consum', 0.0229, 'lps'),
	(562182, 129, '2014-03-01 00:32:43.000000', 'consum', 0.0215, 'lps'),
	(562183, 129, '2014-03-01 00:32:44.000000', 'consum', 0.0235, 'lps'),
	(562184, 129, '2014-03-01 00:32:45.000000', 'consum', 0.0236, 'lps'),
	(562185, 129, '2014-03-01 00:32:46.000000', 'consum', 0.0233, 'lps'),
	(562186, 129, '2014-03-01 00:32:47.000000', 'consum', 0.0221, 'lps'),
	(562187, 129, '2014-03-01 00:32:48.000000', 'consum', 0.0223, 'lps'),
	(562188, 129, '2014-03-01 00:32:49.000000', 'consum', 0.0216, 'lps'),
	(562189, 129, '2014-03-01 00:32:50.000000', 'consum', 0.0228, 'lps'),
	(562190, 129, '2014-03-01 00:32:51.000000', 'consum', 0.0228, 'lps'),
	(562191, 129, '2014-03-01 00:32:52.000000', 'consum', 0.0214, 'lps'),
	(562192, 129, '2014-03-01 00:32:53.000000', 'consum', 0.0238, 'lps'),
	(562193, 129, '2014-03-01 00:32:54.000000', 'consum', 0.0220, 'lps'),
	(562194, 129, '2014-03-01 00:32:55.000000', 'consum', 0.0236, 'lps'),
	(562195, 129, '2014-03-01 00:32:56.000000', 'consum', 0.0222, 'lps'),
	(562196, 129, '2014-03-01 00:32:57.000000', 'consum', 0.0221, 'lps'),
	(562197, 129, '2014-03-01 00:32:58.000000', 'consum', 0.0229, 'lps'),
	(562198, 129, '2014-03-01 00:32:59.000000', 'consum', 0.0213, 'lps'),
	(562199, 129, '2014-03-01 00:33:00.000000', 'consum', 0.0229, 'lps'),
	(562200, 129, '2014-03-01 00:33:01.000000', 'consum', 0.0211, 'lps'),
	(562201, 129, '2014-03-01 00:33:02.000000', 'consum', 0.0214, 'lps'),
	(562202, 129, '2014-03-01 00:33:03.000000', 'consum', 0.0226, 'lps'),
	(562203, 129, '2014-03-01 00:33:04.000000', 'consum', 0.0223, 'lps'),
	(562204, 129, '2014-03-01 00:33:05.000000', 'consum', 0.0227, 'lps'),
	(562205, 129, '2014-03-01 00:33:06.000000', 'consum', 0.0229, 'lps'),
	(562206, 129, '2014-03-01 00:33:07.000000', 'consum', 0.0224, 'lps'),
	(562207, 129, '2014-03-01 00:33:08.000000', 'consum', 0.0225, 'lps'),
	(562208, 129, '2014-03-01 00:33:09.000000', 'consum', 0.0213, 'lps'),
	(562209, 129, '2014-03-01 00:33:10.000000', 'consum', 0.0237, 'lps'),
	(562210, 129, '2014-03-01 00:33:11.000000', 'consum', 0.0222, 'lps'),
	(562211, 129, '2014-03-01 00:33:12.000000', 'consum', 0.0220, 'lps'),
	(562212, 129, '2014-03-01 00:33:13.000000', 'consum', 0.0223, 'lps'),
	(562213, 129, '2014-03-01 00:33:14.000000', 'consum', 0.0215, 'lps'),
	(562214, 129, '2014-03-01 00:33:15.000000', 'consum', 0.0229, 'lps'),
	(562215, 129, '2014-03-01 00:33:16.000000', 'consum', 0.0229, 'lps'),
	(562216, 129, '2014-03-01 00:33:17.000000', 'consum', 0.0221, 'lps'),
	(562217, 129, '2014-03-01 00:33:18.000000', 'consum', 0.0238, 'lps'),
	(562218, 129, '2014-03-01 00:33:19.000000', 'consum', 0.0230, 'lps'),
	(562219, 129, '2014-03-01 00:33:20.000000', 'consum', 0.0227, 'lps'),
	(562220, 129, '2014-03-01 00:33:21.000000', 'consum', 0.0233, 'lps'),
	(562221, 129, '2014-03-01 00:33:22.000000', 'consum', 0.0218, 'lps'),
	(562222, 129, '2014-03-01 00:33:23.000000', 'consum', 0.0213, 'lps'),
	(562223, 129, '2014-03-01 00:33:24.000000', 'consum', 0.0227, 'lps'),
	(562224, 129, '2014-03-01 00:33:25.000000', 'consum', 0.0229, 'lps'),
	(562225, 129, '2014-03-01 00:33:26.000000', 'consum', 0.0228, 'lps'),
	(562226, 129, '2014-03-01 00:33:27.000000', 'consum', 0.0212, 'lps'),
	(562227, 129, '2014-03-01 00:33:28.000000', 'consum', 0.0224, 'lps'),
	(562228, 129, '2014-03-01 00:33:29.000000', 'consum', 0.0219, 'lps'),
	(562229, 129, '2014-03-01 00:33:30.000000', 'consum', 0.0213, 'lps'),
	(562230, 129, '2014-03-01 00:33:31.000000', 'consum', 0.0228, 'lps'),
	(562231, 129, '2014-03-01 00:33:32.000000', 'consum', 0.0231, 'lps'),
	(562232, 129, '2014-03-01 00:33:33.000000', 'consum', 0.0236, 'lps'),
	(562233, 129, '2014-03-01 00:33:34.000000', 'consum', 0.0216, 'lps'),
	(562234, 129, '2014-03-01 00:33:35.000000', 'consum', 0.0221, 'lps'),
	(562235, 129, '2014-03-01 00:33:36.000000', 'consum', 0.0221, 'lps'),
	(562236, 129, '2014-03-01 00:33:37.000000', 'consum', 0.0232, 'lps'),
	(562237, 129, '2014-03-01 00:33:38.000000', 'consum', 0.0228, 'lps'),
	(562238, 129, '2014-03-01 00:33:39.000000', 'consum', 0.0235, 'lps'),
	(562239, 129, '2014-03-01 00:33:40.000000', 'consum', 0.0222, 'lps'),
	(562240, 129, '2014-03-01 00:33:41.000000', 'consum', 0.0226, 'lps'),
	(562241, 129, '2014-03-01 00:33:42.000000', 'consum', 0.0227, 'lps'),
	(562242, 129, '2014-03-01 00:33:43.000000', 'consum', 0.0217, 'lps'),
	(562243, 129, '2014-03-01 00:33:44.000000', 'consum', 0.0223, 'lps'),
	(562244, 129, '2014-03-01 00:33:45.000000', 'consum', 0.0224, 'lps'),
	(562245, 129, '2014-03-01 00:33:46.000000', 'consum', 0.0215, 'lps'),
	(562246, 129, '2014-03-01 00:33:47.000000', 'consum', 0.0223, 'lps'),
	(562247, 129, '2014-03-01 00:33:48.000000', 'consum', 0.0233, 'lps'),
	(562248, 129, '2014-03-01 00:33:49.000000', 'consum', 0.0225, 'lps'),
	(562249, 129, '2014-03-01 00:33:50.000000', 'consum', 0.0219, 'lps'),
	(562250, 129, '2014-03-01 00:33:51.000000', 'consum', 0.0237, 'lps'),
	(562251, 129, '2014-03-01 00:33:52.000000', 'consum', 0.0231, 'lps'),
	(562252, 129, '2014-03-01 00:33:53.000000', 'consum', 0.0236, 'lps'),
	(562253, 129, '2014-03-01 00:33:54.000000', 'consum', 0.0221, 'lps'),
	(562254, 129, '2014-03-01 00:33:55.000000', 'consum', 0.0217, 'lps'),
	(562255, 129, '2014-03-01 00:33:56.000000', 'consum', 0.0210, 'lps'),
	(562256, 129, '2014-03-01 00:33:57.000000', 'consum', 0.0219, 'lps'),
	(562257, 129, '2014-03-01 00:33:58.000000', 'consum', 0.0228, 'lps'),
	(562258, 129, '2014-03-01 00:33:59.000000', 'consum', 0.0213, 'lps'),
	(562259, 129, '2014-03-01 00:34:00.000000', 'consum', 0.0230, 'lps'),
	(562260, 129, '2014-03-01 00:34:01.000000', 'consum', 0.0216, 'lps'),
	(562261, 129, '2014-03-01 00:34:02.000000', 'consum', 0.0236, 'lps'),
	(562262, 129, '2014-03-01 00:34:03.000000', 'consum', 0.0236, 'lps'),
	(562263, 129, '2014-03-01 00:34:04.000000', 'consum', 0.0235, 'lps'),
	(562264, 129, '2014-03-01 00:34:05.000000', 'consum', 0.0227, 'lps'),
	(562265, 129, '2014-03-01 00:34:06.000000', 'consum', 0.0223, 'lps'),
	(562266, 129, '2014-03-01 00:34:07.000000', 'consum', 0.0223, 'lps'),
	(562267, 129, '2014-03-01 00:34:08.000000', 'consum', 0.0235, 'lps'),
	(562268, 129, '2014-03-01 00:34:09.000000', 'consum', 0.0212, 'lps'),
	(562269, 129, '2014-03-01 00:34:10.000000', 'consum', 0.0232, 'lps'),
	(562270, 129, '2014-03-01 00:34:11.000000', 'consum', 0.0226, 'lps'),
	(562271, 129, '2014-03-01 00:34:12.000000', 'consum', 0.0225, 'lps'),
	(562272, 129, '2014-03-01 00:34:13.000000', 'consum', 0.0238, 'lps'),
	(562273, 129, '2014-03-01 00:34:14.000000', 'consum', 0.0220, 'lps'),
	(562274, 129, '2014-03-01 00:34:15.000000', 'consum', 0.0234, 'lps'),
	(562275, 129, '2014-03-01 00:34:16.000000', 'consum', 0.0213, 'lps'),
	(562276, 129, '2014-03-01 00:34:17.000000', 'consum', 0.0210, 'lps'),
	(562277, 129, '2014-03-01 00:34:18.000000', 'consum', 0.0231, 'lps'),
	(562278, 129, '2014-03-01 00:34:19.000000', 'consum', 0.0230, 'lps'),
	(562279, 129, '2014-03-01 00:34:20.000000', 'consum', 0.0218, 'lps'),
	(562280, 129, '2014-03-01 00:34:21.000000', 'consum', 0.0220, 'lps'),
	(562281, 129, '2014-03-01 00:34:22.000000', 'consum', 0.0236, 'lps'),
	(562282, 129, '2014-03-01 00:34:23.000000', 'consum', 0.0221, 'lps'),
	(562283, 129, '2014-03-01 00:34:24.000000', 'consum', 0.0220, 'lps'),
	(562284, 129, '2014-03-01 00:34:25.000000', 'consum', 0.0227, 'lps'),
	(562285, 129, '2014-03-01 00:34:26.000000', 'consum', 0.0236, 'lps'),
	(562286, 129, '2014-03-01 00:34:27.000000', 'consum', 0.0233, 'lps'),
	(562287, 129, '2014-03-01 00:34:28.000000', 'consum', 0.0220, 'lps'),
	(562288, 129, '2014-03-01 00:34:29.000000', 'consum', 0.0217, 'lps'),
	(562289, 129, '2014-03-01 00:34:30.000000', 'consum', 0.0216, 'lps'),
	(562290, 129, '2014-03-01 00:34:31.000000', 'consum', 0.0222, 'lps'),
	(562291, 129, '2014-03-01 00:34:32.000000', 'consum', 0.0223, 'lps'),
	(562292, 129, '2014-03-01 00:34:33.000000', 'consum', 0.0237, 'lps'),
	(562293, 129, '2014-03-01 00:34:34.000000', 'consum', 0.0221, 'lps'),
	(562294, 129, '2014-03-01 00:34:35.000000', 'consum', 0.0215, 'lps'),
	(562295, 129, '2014-03-01 00:34:36.000000', 'consum', 0.0228, 'lps'),
	(562296, 129, '2014-03-01 00:34:37.000000', 'consum', 0.0230, 'lps'),
	(562297, 129, '2014-03-01 00:34:38.000000', 'consum', 0.0229, 'lps'),
	(562298, 129, '2014-03-01 00:34:39.000000', 'consum', 0.0214, 'lps'),
	(562299, 129, '2014-03-01 00:34:40.000000', 'consum', 0.0232, 'lps'),
	(562300, 129, '2014-03-01 00:34:41.000000', 'consum', 0.0221, 'lps'),
	(562301, 129, '2014-03-01 00:34:42.000000', 'consum', 0.0227, 'lps'),
	(562302, 129, '2014-03-01 00:34:43.000000', 'consum', 0.0236, 'lps'),
	(562303, 129, '2014-03-01 00:34:44.000000', 'consum', 0.0230, 'lps'),
	(562304, 129, '2014-03-01 00:34:45.000000', 'consum', 0.0233, 'lps'),
	(562305, 129, '2014-03-01 00:34:46.000000', 'consum', 0.0237, 'lps'),
	(562306, 129, '2014-03-01 00:34:47.000000', 'consum', 0.0219, 'lps'),
	(562307, 129, '2014-03-01 00:34:48.000000', 'consum', 0.0234, 'lps'),
	(562308, 129, '2014-03-01 00:34:49.000000', 'consum', 0.0214, 'lps'),
	(562309, 129, '2014-03-01 00:34:50.000000', 'consum', 0.0218, 'lps'),
	(562310, 129, '2014-03-01 00:34:51.000000', 'consum', 0.0238, 'lps'),
	(562311, 129, '2014-03-01 00:34:52.000000', 'consum', 0.0211, 'lps'),
	(562312, 129, '2014-03-01 00:34:53.000000', 'consum', 0.0216, 'lps'),
	(562313, 129, '2014-03-01 00:34:54.000000', 'consum', 0.0211, 'lps'),
	(562314, 129, '2014-03-01 00:34:55.000000', 'consum', 0.0228, 'lps'),
	(562315, 129, '2014-03-01 00:34:56.000000', 'consum', 0.0236, 'lps'),
	(562316, 129, '2014-03-01 00:34:57.000000', 'consum', 0.0232, 'lps'),
	(562317, 129, '2014-03-01 00:34:58.000000', 'consum', 0.0210, 'lps'),
	(562318, 129, '2014-03-01 00:34:59.000000', 'consum', 0.0235, 'lps'),
	(562319, 129, '2014-03-01 00:35:00.000000', 'consum', 0.0216, 'lps'),
	(562320, 129, '2014-03-01 00:35:01.000000', 'consum', 0.0227, 'lps'),
	(562321, 129, '2014-03-01 00:35:02.000000', 'consum', 0.0217, 'lps'),
	(562322, 129, '2014-03-01 00:35:03.000000', 'consum', 0.0223, 'lps'),
	(562323, 129, '2014-03-01 00:35:04.000000', 'consum', 0.0228, 'lps'),
	(562324, 129, '2014-03-01 00:35:05.000000', 'consum', 0.0232, 'lps'),
	(562325, 129, '2014-03-01 00:35:06.000000', 'consum', 0.0238, 'lps'),
	(562326, 129, '2014-03-01 00:35:07.000000', 'consum', 0.0226, 'lps'),
	(562327, 129, '2014-03-01 00:35:08.000000', 'consum', 0.0236, 'lps'),
	(562328, 129, '2014-03-01 00:35:09.000000', 'consum', 0.0233, 'lps'),
	(562329, 129, '2014-03-01 00:35:10.000000', 'consum', 0.0220, 'lps'),
	(562330, 129, '2014-03-01 00:35:11.000000', 'consum', 0.0219, 'lps'),
	(562331, 129, '2014-03-01 00:35:12.000000', 'consum', 0.0225, 'lps'),
	(562332, 129, '2014-03-01 00:35:13.000000', 'consum', 0.0231, 'lps'),
	(562333, 129, '2014-03-01 00:35:14.000000', 'consum', 0.0213, 'lps'),
	(562334, 129, '2014-03-01 00:35:15.000000', 'consum', 0.0219, 'lps'),
	(562335, 129, '2014-03-01 00:35:16.000000', 'consum', 0.0220, 'lps'),
	(562336, 129, '2014-03-01 00:35:17.000000', 'consum', 0.0231, 'lps'),
	(562337, 129, '2014-03-01 00:35:18.000000', 'consum', 0.0227, 'lps'),
	(562338, 129, '2014-03-01 00:35:19.000000', 'consum', 0.0232, 'lps'),
	(562339, 129, '2014-03-01 00:35:20.000000', 'consum', 0.0211, 'lps'),
	(562340, 129, '2014-03-01 00:35:21.000000', 'consum', 0.0236, 'lps'),
	(562341, 129, '2014-03-01 00:35:22.000000', 'consum', 0.0224, 'lps'),
	(562342, 129, '2014-03-01 00:35:23.000000', 'consum', 0.0232, 'lps'),
	(562343, 129, '2014-03-01 00:35:24.000000', 'consum', 0.0221, 'lps'),
	(562344, 129, '2014-03-01 00:35:25.000000', 'consum', 0.0227, 'lps'),
	(562345, 129, '2014-03-01 00:35:26.000000', 'consum', 0.0235, 'lps'),
	(562346, 129, '2014-03-01 00:35:27.000000', 'consum', 0.0224, 'lps'),
	(562347, 129, '2014-03-01 00:35:28.000000', 'consum', 0.0236, 'lps'),
	(562348, 129, '2014-03-01 00:35:29.000000', 'consum', 0.0238, 'lps'),
	(562349, 129, '2014-03-01 00:35:30.000000', 'consum', 0.0218, 'lps'),
	(562350, 129, '2014-03-01 00:35:31.000000', 'consum', 0.0223, 'lps'),
	(562351, 129, '2014-03-01 00:35:32.000000', 'consum', 0.0223, 'lps'),
	(562352, 129, '2014-03-01 00:35:33.000000', 'consum', 0.0238, 'lps'),
	(562353, 129, '2014-03-01 00:35:34.000000', 'consum', 0.0224, 'lps'),
	(562354, 129, '2014-03-01 00:35:35.000000', 'consum', 0.0227, 'lps'),
	(562355, 129, '2014-03-01 00:35:36.000000', 'consum', 0.0222, 'lps'),
	(562356, 129, '2014-03-01 00:35:37.000000', 'consum', 0.0221, 'lps'),
	(562357, 129, '2014-03-01 00:35:38.000000', 'consum', 0.0229, 'lps'),
	(562358, 129, '2014-03-01 00:35:39.000000', 'consum', 0.0215, 'lps'),
	(562359, 129, '2014-03-01 00:35:40.000000', 'consum', 0.0236, 'lps'),
	(562360, 129, '2014-03-01 00:35:41.000000', 'consum', 0.0212, 'lps'),
	(562361, 129, '2014-03-01 00:35:42.000000', 'consum', 0.0226, 'lps'),
	(562362, 129, '2014-03-01 00:35:43.000000', 'consum', 0.0227, 'lps'),
	(562363, 129, '2014-03-01 00:35:44.000000', 'consum', 0.0221, 'lps'),
	(562364, 129, '2014-03-01 00:35:45.000000', 'consum', 0.0212, 'lps'),
	(562365, 129, '2014-03-01 00:35:46.000000', 'consum', 0.0218, 'lps'),
	(562366, 129, '2014-03-01 00:35:47.000000', 'consum', 0.0214, 'lps'),
	(562367, 129, '2014-03-01 00:35:48.000000', 'consum', 0.0234, 'lps'),
	(562368, 129, '2014-03-01 00:35:49.000000', 'consum', 0.0234, 'lps'),
	(562369, 129, '2014-03-01 00:35:50.000000', 'consum', 0.0230, 'lps'),
	(562370, 129, '2014-03-01 00:35:51.000000', 'consum', 0.0210, 'lps'),
	(562371, 129, '2014-03-01 00:35:52.000000', 'consum', 0.0238, 'lps'),
	(562372, 129, '2014-03-01 00:35:53.000000', 'consum', 0.0233, 'lps'),
	(562373, 129, '2014-03-01 00:35:54.000000', 'consum', 0.0211, 'lps'),
	(562374, 129, '2014-03-01 00:35:55.000000', 'consum', 0.0235, 'lps'),
	(562375, 129, '2014-03-01 00:35:56.000000', 'consum', 0.0217, 'lps'),
	(562376, 129, '2014-03-01 00:35:57.000000', 'consum', 0.0227, 'lps'),
	(562377, 129, '2014-03-01 00:35:58.000000', 'consum', 0.0215, 'lps'),
	(562378, 129, '2014-03-01 00:35:59.000000', 'consum', 0.0216, 'lps'),
	(562379, 129, '2014-03-01 00:36:00.000000', 'consum', 0.0225, 'lps'),
	(562380, 129, '2014-03-01 00:36:01.000000', 'consum', 0.0211, 'lps'),
	(562381, 129, '2014-03-01 00:36:02.000000', 'consum', 0.0227, 'lps'),
	(562382, 129, '2014-03-01 00:36:03.000000', 'consum', 0.0236, 'lps'),
	(562383, 129, '2014-03-01 00:36:04.000000', 'consum', 0.0231, 'lps'),
	(562384, 129, '2014-03-01 00:36:05.000000', 'consum', 0.0237, 'lps'),
	(562385, 129, '2014-03-01 00:36:06.000000', 'consum', 0.0225, 'lps'),
	(562386, 129, '2014-03-01 00:36:07.000000', 'consum', 0.0233, 'lps'),
	(562387, 129, '2014-03-01 00:36:08.000000', 'consum', 0.0224, 'lps'),
	(562388, 129, '2014-03-01 00:36:09.000000', 'consum', 0.0212, 'lps'),
	(562389, 129, '2014-03-01 00:36:10.000000', 'consum', 0.0235, 'lps'),
	(562390, 129, '2014-03-01 00:36:11.000000', 'consum', 0.0213, 'lps'),
	(562391, 129, '2014-03-01 00:36:12.000000', 'consum', 0.0210, 'lps'),
	(562392, 129, '2014-03-01 00:36:13.000000', 'consum', 0.0231, 'lps'),
	(562393, 129, '2014-03-01 00:36:14.000000', 'consum', 0.0229, 'lps'),
	(562394, 129, '2014-03-01 00:36:15.000000', 'consum', 0.0212, 'lps'),
	(562395, 129, '2014-03-01 00:36:16.000000', 'consum', 0.0220, 'lps'),
	(562396, 129, '2014-03-01 00:36:17.000000', 'consum', 0.0228, 'lps'),
	(562397, 129, '2014-03-01 00:36:18.000000', 'consum', 0.0213, 'lps'),
	(562398, 129, '2014-03-01 00:36:19.000000', 'consum', 0.0229, 'lps'),
	(562399, 129, '2014-03-01 00:36:20.000000', 'consum', 0.0236, 'lps'),
	(562400, 129, '2014-03-01 00:36:21.000000', 'consum', 0.0228, 'lps'),
	(562401, 129, '2014-03-01 00:36:22.000000', 'consum', 0.0224, 'lps'),
	(562402, 129, '2014-03-01 00:36:23.000000', 'consum', 0.0223, 'lps'),
	(562403, 129, '2014-03-01 00:36:24.000000', 'consum', 0.0235, 'lps'),
	(562404, 129, '2014-03-01 00:36:25.000000', 'consum', 0.0211, 'lps'),
	(562405, 129, '2014-03-01 00:36:26.000000', 'consum', 0.0225, 'lps'),
	(562406, 129, '2014-03-01 00:36:27.000000', 'consum', 0.0225, 'lps'),
	(562407, 129, '2014-03-01 00:36:28.000000', 'consum', 0.0213, 'lps'),
	(562408, 129, '2014-03-01 00:36:29.000000', 'consum', 0.0210, 'lps'),
	(562409, 129, '2014-03-01 00:36:30.000000', 'consum', 0.0231, 'lps'),
	(562410, 129, '2014-03-01 00:36:31.000000', 'consum', 0.0226, 'lps'),
	(562411, 129, '2014-03-01 00:36:32.000000', 'consum', 0.0229, 'lps'),
	(562412, 129, '2014-03-01 00:36:33.000000', 'consum', 0.0228, 'lps'),
	(562413, 129, '2014-03-01 00:36:34.000000', 'consum', 0.0214, 'lps'),
	(562414, 129, '2014-03-01 00:36:35.000000', 'consum', 0.0236, 'lps'),
	(562415, 129, '2014-03-01 00:36:36.000000', 'consum', 0.0213, 'lps'),
	(562416, 129, '2014-03-01 00:36:37.000000', 'consum', 0.0233, 'lps'),
	(562417, 129, '2014-03-01 00:36:38.000000', 'consum', 0.0229, 'lps'),
	(562418, 129, '2014-03-01 00:36:39.000000', 'consum', 0.0238, 'lps'),
	(562419, 129, '2014-03-01 00:36:40.000000', 'consum', 0.0233, 'lps'),
	(562420, 129, '2014-03-01 00:36:41.000000', 'consum', 0.0213, 'lps'),
	(562421, 129, '2014-03-01 00:36:42.000000', 'consum', 0.0215, 'lps'),
	(562422, 129, '2014-03-01 00:36:43.000000', 'consum', 0.0226, 'lps'),
	(562423, 129, '2014-03-01 00:36:44.000000', 'consum', 0.0220, 'lps'),
	(562424, 129, '2014-03-01 00:36:45.000000', 'consum', 0.0210, 'lps'),
	(562425, 129, '2014-03-01 00:36:46.000000', 'consum', 0.0210, 'lps'),
	(562426, 129, '2014-03-01 00:36:47.000000', 'consum', 0.0213, 'lps'),
	(562427, 129, '2014-03-01 00:36:48.000000', 'consum', 0.0222, 'lps'),
	(562428, 129, '2014-03-01 00:36:49.000000', 'consum', 0.0234, 'lps'),
	(562429, 129, '2014-03-01 00:36:50.000000', 'consum', 0.0235, 'lps'),
	(562430, 129, '2014-03-01 00:36:51.000000', 'consum', 0.0235, 'lps'),
	(562431, 129, '2014-03-01 00:36:52.000000', 'consum', 0.0234, 'lps'),
	(562432, 129, '2014-03-01 00:36:53.000000', 'consum', 0.0224, 'lps'),
	(562433, 129, '2014-03-01 00:36:54.000000', 'consum', 0.0210, 'lps'),
	(562434, 129, '2014-03-01 00:36:55.000000', 'consum', 0.0225, 'lps'),
	(562435, 129, '2014-03-01 00:36:56.000000', 'consum', 0.0226, 'lps'),
	(562436, 129, '2014-03-01 00:36:57.000000', 'consum', 0.0218, 'lps'),
	(562437, 129, '2014-03-01 00:36:58.000000', 'consum', 0.0233, 'lps'),
	(562438, 129, '2014-03-01 00:36:59.000000', 'consum', 0.0212, 'lps'),
	(562439, 129, '2014-03-01 00:37:00.000000', 'consum', 0.0211, 'lps'),
	(562440, 129, '2014-03-01 00:37:01.000000', 'consum', 0.0210, 'lps'),
	(562441, 129, '2014-03-01 00:37:02.000000', 'consum', 0.0236, 'lps'),
	(562442, 129, '2014-03-01 00:37:03.000000', 'consum', 0.0223, 'lps'),
	(562443, 129, '2014-03-01 00:37:04.000000', 'consum', 0.0227, 'lps'),
	(562444, 129, '2014-03-01 00:37:05.000000', 'consum', 0.0226, 'lps'),
	(562445, 129, '2014-03-01 00:37:06.000000', 'consum', 0.0213, 'lps'),
	(562446, 129, '2014-03-01 00:37:07.000000', 'consum', 0.0233, 'lps'),
	(562447, 129, '2014-03-01 00:37:08.000000', 'consum', 0.0229, 'lps'),
	(562448, 129, '2014-03-01 00:37:09.000000', 'consum', 0.0238, 'lps'),
	(562449, 129, '2014-03-01 00:37:10.000000', 'consum', 0.0235, 'lps'),
	(562450, 129, '2014-03-01 00:37:11.000000', 'consum', 0.0222, 'lps'),
	(562451, 129, '2014-03-01 00:37:12.000000', 'consum', 0.0223, 'lps'),
	(562452, 129, '2014-03-01 00:37:13.000000', 'consum', 0.0212, 'lps'),
	(562453, 129, '2014-03-01 00:37:14.000000', 'consum', 0.0212, 'lps'),
	(562454, 129, '2014-03-01 00:37:15.000000', 'consum', 0.0214, 'lps'),
	(562455, 129, '2014-03-01 00:37:16.000000', 'consum', 0.0226, 'lps'),
	(562456, 129, '2014-03-01 00:37:17.000000', 'consum', 0.0219, 'lps'),
	(562457, 129, '2014-03-01 00:37:18.000000', 'consum', 0.0237, 'lps'),
	(562458, 129, '2014-03-01 00:37:19.000000', 'consum', 0.0232, 'lps'),
	(562459, 129, '2014-03-01 00:37:20.000000', 'consum', 0.0238, 'lps'),
	(562460, 129, '2014-03-01 00:37:21.000000', 'consum', 0.0229, 'lps'),
	(562461, 129, '2014-03-01 00:37:22.000000', 'consum', 0.0218, 'lps'),
	(562462, 129, '2014-03-01 00:37:23.000000', 'consum', 0.0225, 'lps'),
	(562463, 129, '2014-03-01 00:37:24.000000', 'consum', 0.0230, 'lps'),
	(562464, 129, '2014-03-01 00:37:25.000000', 'consum', 0.0210, 'lps'),
	(562465, 129, '2014-03-01 00:37:26.000000', 'consum', 0.0235, 'lps'),
	(562466, 129, '2014-03-01 00:37:27.000000', 'consum', 0.0221, 'lps'),
	(562467, 129, '2014-03-01 00:37:28.000000', 'consum', 0.0220, 'lps'),
	(562468, 129, '2014-03-01 00:37:29.000000', 'consum', 0.0226, 'lps'),
	(562469, 129, '2014-03-01 00:37:30.000000', 'consum', 0.0231, 'lps'),
	(562470, 129, '2014-03-01 00:37:31.000000', 'consum', 0.0212, 'lps'),
	(562471, 129, '2014-03-01 00:37:32.000000', 'consum', 0.0214, 'lps'),
	(562472, 129, '2014-03-01 00:37:33.000000', 'consum', 0.0226, 'lps'),
	(562473, 129, '2014-03-01 00:37:34.000000', 'consum', 0.0218, 'lps'),
	(562474, 129, '2014-03-01 00:37:35.000000', 'consum', 0.0234, 'lps'),
	(562475, 129, '2014-03-01 00:37:36.000000', 'consum', 0.0218, 'lps'),
	(562476, 129, '2014-03-01 00:37:37.000000', 'consum', 0.0235, 'lps'),
	(562477, 129, '2014-03-01 00:37:38.000000', 'consum', 0.0225, 'lps'),
	(562478, 129, '2014-03-01 00:37:39.000000', 'consum', 0.0210, 'lps'),
	(562479, 129, '2014-03-01 00:37:40.000000', 'consum', 0.0224, 'lps'),
	(562480, 129, '2014-03-01 00:37:41.000000', 'consum', 0.0225, 'lps'),
	(562481, 129, '2014-03-01 00:37:42.000000', 'consum', 0.0211, 'lps'),
	(562482, 129, '2014-03-01 00:37:43.000000', 'consum', 0.0229, 'lps'),
	(562483, 129, '2014-03-01 00:37:44.000000', 'consum', 0.0216, 'lps'),
	(562484, 129, '2014-03-01 00:37:45.000000', 'consum', 0.0211, 'lps'),
	(562485, 129, '2014-03-01 00:37:46.000000', 'consum', 0.0227, 'lps'),
	(562486, 129, '2014-03-01 00:37:47.000000', 'consum', 0.0233, 'lps'),
	(562487, 129, '2014-03-01 00:37:48.000000', 'consum', 0.0220, 'lps'),
	(562488, 129, '2014-03-01 00:37:49.000000', 'consum', 0.0219, 'lps'),
	(562489, 129, '2014-03-01 00:37:50.000000', 'consum', 0.0225, 'lps'),
	(562490, 129, '2014-03-01 00:37:51.000000', 'consum', 0.0228, 'lps'),
	(562491, 129, '2014-03-01 00:37:52.000000', 'consum', 0.0228, 'lps'),
	(562492, 129, '2014-03-01 00:37:53.000000', 'consum', 0.0216, 'lps'),
	(562493, 129, '2014-03-01 00:37:54.000000', 'consum', 0.0217, 'lps'),
	(562494, 129, '2014-03-01 00:37:55.000000', 'consum', 0.0227, 'lps'),
	(562495, 129, '2014-03-01 00:37:56.000000', 'consum', 0.0216, 'lps'),
	(562496, 129, '2014-03-01 00:37:57.000000', 'consum', 0.0220, 'lps'),
	(562497, 129, '2014-03-01 00:37:58.000000', 'consum', 0.0211, 'lps'),
	(562498, 129, '2014-03-01 00:37:59.000000', 'consum', 0.0214, 'lps'),
	(562499, 129, '2014-03-01 00:38:00.000000', 'consum', 0.0229, 'lps'),
	(562500, 129, '2014-03-01 00:38:01.000000', 'consum', 0.0236, 'lps'),
	(562501, 129, '2014-03-01 00:38:02.000000', 'consum', 0.0227, 'lps'),
	(562502, 129, '2014-03-01 00:38:03.000000', 'consum', 0.0215, 'lps'),
	(562503, 129, '2014-03-01 00:38:04.000000', 'consum', 0.0215, 'lps'),
	(562504, 129, '2014-03-01 00:38:05.000000', 'consum', 0.0219, 'lps'),
	(562505, 129, '2014-03-01 00:38:06.000000', 'consum', 0.0213, 'lps'),
	(562506, 129, '2014-03-01 00:38:07.000000', 'consum', 0.0226, 'lps'),
	(562507, 129, '2014-03-01 00:38:08.000000', 'consum', 0.0222, 'lps'),
	(562508, 129, '2014-03-01 00:38:09.000000', 'consum', 0.0226, 'lps'),
	(562509, 129, '2014-03-01 00:38:10.000000', 'consum', 0.0223, 'lps'),
	(562510, 129, '2014-03-01 00:38:11.000000', 'consum', 0.0230, 'lps'),
	(562511, 129, '2014-03-01 00:38:12.000000', 'consum', 0.0212, 'lps'),
	(562512, 129, '2014-03-01 00:38:13.000000', 'consum', 0.0218, 'lps'),
	(562513, 129, '2014-03-01 00:38:14.000000', 'consum', 0.0217, 'lps'),
	(562514, 129, '2014-03-01 00:38:15.000000', 'consum', 0.0219, 'lps'),
	(562515, 129, '2014-03-01 00:38:16.000000', 'consum', 0.0237, 'lps'),
	(562516, 129, '2014-03-01 00:38:17.000000', 'consum', 0.0229, 'lps'),
	(562517, 129, '2014-03-01 00:38:18.000000', 'consum', 0.0226, 'lps'),
	(562518, 129, '2014-03-01 00:38:19.000000', 'consum', 0.0233, 'lps'),
	(562519, 129, '2014-03-01 00:38:20.000000', 'consum', 0.0222, 'lps'),
	(562520, 129, '2014-03-01 00:38:21.000000', 'consum', 0.0228, 'lps'),
	(562521, 129, '2014-03-01 00:38:22.000000', 'consum', 0.0235, 'lps'),
	(562522, 129, '2014-03-01 00:38:23.000000', 'consum', 0.0222, 'lps'),
	(562523, 129, '2014-03-01 00:38:24.000000', 'consum', 0.0228, 'lps'),
	(562524, 129, '2014-03-01 00:38:25.000000', 'consum', 0.0235, 'lps'),
	(562525, 129, '2014-03-01 00:38:26.000000', 'consum', 0.0223, 'lps'),
	(562526, 129, '2014-03-01 00:38:27.000000', 'consum', 0.0230, 'lps'),
	(562527, 129, '2014-03-01 00:38:28.000000', 'consum', 0.0211, 'lps'),
	(562528, 129, '2014-03-01 00:38:29.000000', 'consum', 0.0216, 'lps'),
	(562529, 129, '2014-03-01 00:38:30.000000', 'consum', 0.0210, 'lps'),
	(562530, 129, '2014-03-01 00:38:31.000000', 'consum', 0.0218, 'lps'),
	(562531, 129, '2014-03-01 00:38:32.000000', 'consum', 0.0223, 'lps'),
	(562532, 129, '2014-03-01 00:38:33.000000', 'consum', 0.0223, 'lps'),
	(562533, 129, '2014-03-01 00:38:34.000000', 'consum', 0.0237, 'lps'),
	(562534, 129, '2014-03-01 00:38:35.000000', 'consum', 0.0217, 'lps'),
	(562535, 129, '2014-03-01 00:38:36.000000', 'consum', 0.0225, 'lps'),
	(562536, 129, '2014-03-01 00:38:37.000000', 'consum', 0.0235, 'lps'),
	(562537, 129, '2014-03-01 00:38:38.000000', 'consum', 0.0230, 'lps'),
	(562538, 129, '2014-03-01 00:38:39.000000', 'consum', 0.0238, 'lps'),
	(562539, 129, '2014-03-01 00:38:40.000000', 'consum', 0.0231, 'lps'),
	(562540, 129, '2014-03-01 00:38:41.000000', 'consum', 0.0232, 'lps'),
	(562541, 129, '2014-03-01 00:38:42.000000', 'consum', 0.0228, 'lps'),
	(562542, 129, '2014-03-01 00:38:43.000000', 'consum', 0.0235, 'lps'),
	(562543, 129, '2014-03-01 00:38:44.000000', 'consum', 0.0224, 'lps'),
	(562544, 129, '2014-03-01 00:38:45.000000', 'consum', 0.0235, 'lps'),
	(562545, 129, '2014-03-01 00:38:46.000000', 'consum', 0.0236, 'lps'),
	(562546, 129, '2014-03-01 00:38:47.000000', 'consum', 0.0236, 'lps'),
	(562547, 129, '2014-03-01 00:38:48.000000', 'consum', 0.0233, 'lps'),
	(562548, 129, '2014-03-01 00:38:49.000000', 'consum', 0.0219, 'lps'),
	(562549, 129, '2014-03-01 00:38:50.000000', 'consum', 0.0216, 'lps'),
	(562550, 129, '2014-03-01 00:38:51.000000', 'consum', 0.0211, 'lps'),
	(562551, 129, '2014-03-01 00:38:52.000000', 'consum', 0.0230, 'lps'),
	(562552, 129, '2014-03-01 00:38:53.000000', 'consum', 0.0219, 'lps'),
	(562553, 129, '2014-03-01 00:38:54.000000', 'consum', 0.0225, 'lps'),
	(562554, 129, '2014-03-01 00:38:55.000000', 'consum', 0.0229, 'lps'),
	(562555, 129, '2014-03-01 00:38:56.000000', 'consum', 0.0230, 'lps'),
	(562556, 129, '2014-03-01 00:38:57.000000', 'consum', 0.0225, 'lps'),
	(562557, 129, '2014-03-01 00:38:58.000000', 'consum', 0.0227, 'lps'),
	(562558, 129, '2014-03-01 00:38:59.000000', 'consum', 0.0222, 'lps'),
	(562559, 129, '2014-03-01 00:39:00.000000', 'consum', 0.0220, 'lps'),
	(562560, 129, '2014-03-01 00:39:01.000000', 'consum', 0.0225, 'lps'),
	(562561, 129, '2014-03-01 00:39:02.000000', 'consum', 0.0225, 'lps'),
	(562562, 129, '2014-03-01 00:39:03.000000', 'consum', 0.0211, 'lps'),
	(562563, 129, '2014-03-01 00:39:04.000000', 'consum', 0.0230, 'lps'),
	(562564, 129, '2014-03-01 00:39:05.000000', 'consum', 0.0221, 'lps'),
	(562565, 129, '2014-03-01 00:39:06.000000', 'consum', 0.0234, 'lps'),
	(562566, 129, '2014-03-01 00:39:07.000000', 'consum', 0.0210, 'lps'),
	(562567, 129, '2014-03-01 00:39:08.000000', 'consum', 0.0225, 'lps'),
	(562568, 129, '2014-03-01 00:39:09.000000', 'consum', 0.0226, 'lps'),
	(562569, 129, '2014-03-01 00:39:10.000000', 'consum', 0.0220, 'lps'),
	(562570, 129, '2014-03-01 00:39:11.000000', 'consum', 0.0238, 'lps'),
	(562571, 129, '2014-03-01 00:39:12.000000', 'consum', 0.0237, 'lps'),
	(562572, 129, '2014-03-01 00:39:13.000000', 'consum', 0.0230, 'lps'),
	(562573, 129, '2014-03-01 00:39:14.000000', 'consum', 0.0230, 'lps'),
	(562574, 129, '2014-03-01 00:39:15.000000', 'consum', 0.0220, 'lps'),
	(562575, 129, '2014-03-01 00:39:16.000000', 'consum', 0.0232, 'lps'),
	(562576, 129, '2014-03-01 00:39:17.000000', 'consum', 0.0234, 'lps'),
	(562577, 129, '2014-03-01 00:39:18.000000', 'consum', 0.0232, 'lps'),
	(562578, 129, '2014-03-01 00:39:19.000000', 'consum', 0.0222, 'lps'),
	(562579, 129, '2014-03-01 00:39:20.000000', 'consum', 0.0233, 'lps'),
	(562580, 129, '2014-03-01 00:39:21.000000', 'consum', 0.0233, 'lps'),
	(562581, 129, '2014-03-01 00:39:22.000000', 'consum', 0.0226, 'lps'),
	(562582, 129, '2014-03-01 00:39:23.000000', 'consum', 0.0221, 'lps'),
	(562583, 129, '2014-03-01 00:39:24.000000', 'consum', 0.0217, 'lps'),
	(562584, 129, '2014-03-01 00:39:25.000000', 'consum', 0.0213, 'lps'),
	(562585, 129, '2014-03-01 00:39:26.000000', 'consum', 0.0235, 'lps'),
	(562586, 129, '2014-03-01 00:39:27.000000', 'consum', 0.0237, 'lps'),
	(562587, 129, '2014-03-01 00:39:28.000000', 'consum', 0.0214, 'lps'),
	(562588, 129, '2014-03-01 00:39:29.000000', 'consum', 0.0236, 'lps'),
	(562589, 129, '2014-03-01 00:39:30.000000', 'consum', 0.0213, 'lps'),
	(562590, 129, '2014-03-01 00:39:31.000000', 'consum', 0.0235, 'lps'),
	(562591, 129, '2014-03-01 00:39:32.000000', 'consum', 0.0237, 'lps'),
	(562592, 129, '2014-03-01 00:39:33.000000', 'consum', 0.0213, 'lps'),
	(562593, 129, '2014-03-01 00:39:34.000000', 'consum', 0.0233, 'lps'),
	(562594, 129, '2014-03-01 00:39:35.000000', 'consum', 0.0231, 'lps'),
	(562595, 129, '2014-03-01 00:39:36.000000', 'consum', 0.0214, 'lps'),
	(562596, 129, '2014-03-01 00:39:37.000000', 'consum', 0.0228, 'lps'),
	(562597, 129, '2014-03-01 00:39:38.000000', 'consum', 0.0228, 'lps'),
	(562598, 129, '2014-03-01 00:39:39.000000', 'consum', 0.0218, 'lps'),
	(562599, 129, '2014-03-01 00:39:40.000000', 'consum', 0.0228, 'lps'),
	(562600, 129, '2014-03-01 00:39:41.000000', 'consum', 0.0217, 'lps'),
	(562601, 129, '2014-03-01 00:39:42.000000', 'consum', 0.0221, 'lps'),
	(562602, 129, '2014-03-01 00:39:43.000000', 'consum', 0.0215, 'lps'),
	(562603, 129, '2014-03-01 00:39:44.000000', 'consum', 0.0233, 'lps'),
	(562604, 129, '2014-03-01 00:39:45.000000', 'consum', 0.0223, 'lps'),
	(562605, 129, '2014-03-01 00:39:46.000000', 'consum', 0.0237, 'lps'),
	(562606, 129, '2014-03-01 00:39:47.000000', 'consum', 0.0219, 'lps'),
	(562607, 129, '2014-03-01 00:39:48.000000', 'consum', 0.0234, 'lps'),
	(562608, 129, '2014-03-01 00:39:49.000000', 'consum', 0.0213, 'lps'),
	(562609, 129, '2014-03-01 00:39:50.000000', 'consum', 0.0213, 'lps'),
	(562610, 129, '2014-03-01 00:39:51.000000', 'consum', 0.0218, 'lps'),
	(562611, 129, '2014-03-01 00:39:52.000000', 'consum', 0.0213, 'lps'),
	(562612, 129, '2014-03-01 00:39:53.000000', 'consum', 0.0228, 'lps'),
	(562613, 129, '2014-03-01 00:39:54.000000', 'consum', 0.0232, 'lps'),
	(562614, 129, '2014-03-01 00:39:55.000000', 'consum', 0.0212, 'lps'),
	(562615, 129, '2014-03-01 00:39:56.000000', 'consum', 0.0213, 'lps'),
	(562616, 129, '2014-03-01 00:39:57.000000', 'consum', 0.0218, 'lps'),
	(562617, 129, '2014-03-01 00:39:58.000000', 'consum', 0.0211, 'lps'),
	(562618, 129, '2014-03-01 00:39:59.000000', 'consum', 0.0222, 'lps'),
	(562619, 129, '2014-03-01 00:40:00.000000', 'consum', 0.0237, 'lps'),
	(562620, 129, '2014-03-01 00:40:01.000000', 'consum', 0.0224, 'lps'),
	(562621, 129, '2014-03-01 00:40:02.000000', 'consum', 0.0228, 'lps'),
	(562622, 129, '2014-03-01 00:40:03.000000', 'consum', 0.0228, 'lps'),
	(562623, 129, '2014-03-01 00:40:04.000000', 'consum', 0.0220, 'lps'),
	(562624, 129, '2014-03-01 00:40:05.000000', 'consum', 0.0235, 'lps'),
	(562625, 129, '2014-03-01 00:40:06.000000', 'consum', 0.0219, 'lps'),
	(562626, 129, '2014-03-01 00:40:07.000000', 'consum', 0.0211, 'lps'),
	(562627, 129, '2014-03-01 00:40:08.000000', 'consum', 0.0216, 'lps'),
	(562628, 129, '2014-03-01 00:40:09.000000', 'consum', 0.0238, 'lps'),
	(562629, 129, '2014-03-01 00:40:10.000000', 'consum', 0.0218, 'lps'),
	(562630, 129, '2014-03-01 00:40:11.000000', 'consum', 0.0224, 'lps'),
	(562631, 129, '2014-03-01 00:40:12.000000', 'consum', 0.0225, 'lps'),
	(562632, 129, '2014-03-01 00:40:13.000000', 'consum', 0.0218, 'lps'),
	(562633, 129, '2014-03-01 00:40:14.000000', 'consum', 0.0233, 'lps'),
	(562634, 129, '2014-03-01 00:40:15.000000', 'consum', 0.0213, 'lps'),
	(562635, 129, '2014-03-01 00:40:16.000000', 'consum', 0.0214, 'lps'),
	(562636, 129, '2014-03-01 00:40:17.000000', 'consum', 0.0223, 'lps'),
	(562637, 129, '2014-03-01 00:40:18.000000', 'consum', 0.0236, 'lps'),
	(562638, 129, '2014-03-01 00:40:19.000000', 'consum', 0.0214, 'lps'),
	(562639, 129, '2014-03-01 00:40:20.000000', 'consum', 0.0212, 'lps'),
	(562640, 129, '2014-03-01 00:40:21.000000', 'consum', 0.0236, 'lps'),
	(562641, 129, '2014-03-01 00:40:22.000000', 'consum', 0.0219, 'lps'),
	(562642, 129, '2014-03-01 00:40:23.000000', 'consum', 0.0234, 'lps'),
	(562643, 129, '2014-03-01 00:40:24.000000', 'consum', 0.0219, 'lps'),
	(562644, 129, '2014-03-01 00:40:25.000000', 'consum', 0.0212, 'lps'),
	(562645, 129, '2014-03-01 00:40:26.000000', 'consum', 0.0223, 'lps'),
	(562646, 129, '2014-03-01 00:40:27.000000', 'consum', 0.0212, 'lps'),
	(562647, 129, '2014-03-01 00:40:28.000000', 'consum', 0.0211, 'lps'),
	(562648, 129, '2014-03-01 00:40:29.000000', 'consum', 0.0210, 'lps'),
	(562649, 129, '2014-03-01 00:40:30.000000', 'consum', 0.0234, 'lps'),
	(562650, 129, '2014-03-01 00:40:31.000000', 'consum', 0.0216, 'lps'),
	(562651, 129, '2014-03-01 00:40:32.000000', 'consum', 0.0224, 'lps'),
	(562652, 129, '2014-03-01 00:40:33.000000', 'consum', 0.0236, 'lps'),
	(562653, 129, '2014-03-01 00:40:34.000000', 'consum', 0.0210, 'lps'),
	(562654, 129, '2014-03-01 00:40:35.000000', 'consum', 0.0220, 'lps'),
	(562655, 129, '2014-03-01 00:40:36.000000', 'consum', 0.0233, 'lps'),
	(562656, 129, '2014-03-01 00:40:37.000000', 'consum', 0.0236, 'lps'),
	(562657, 129, '2014-03-01 00:40:38.000000', 'consum', 0.0212, 'lps'),
	(562658, 129, '2014-03-01 00:40:39.000000', 'consum', 0.0232, 'lps'),
	(562659, 129, '2014-03-01 00:40:40.000000', 'consum', 0.0227, 'lps'),
	(562660, 129, '2014-03-01 00:40:41.000000', 'consum', 0.0228, 'lps'),
	(562661, 129, '2014-03-01 00:40:42.000000', 'consum', 0.0221, 'lps'),
	(562662, 129, '2014-03-01 00:40:43.000000', 'consum', 0.0211, 'lps'),
	(562663, 129, '2014-03-01 00:40:44.000000', 'consum', 0.0212, 'lps'),
	(562664, 129, '2014-03-01 00:40:45.000000', 'consum', 0.0216, 'lps'),
	(562665, 129, '2014-03-01 00:40:46.000000', 'consum', 0.0234, 'lps'),
	(562666, 129, '2014-03-01 00:40:47.000000', 'consum', 0.0228, 'lps'),
	(562667, 129, '2014-03-01 00:40:48.000000', 'consum', 0.0227, 'lps'),
	(562668, 129, '2014-03-01 00:40:49.000000', 'consum', 0.0213, 'lps'),
	(562669, 129, '2014-03-01 00:40:50.000000', 'consum', 0.0232, 'lps'),
	(562670, 129, '2014-03-01 00:40:51.000000', 'consum', 0.0224, 'lps'),
	(562671, 129, '2014-03-01 00:40:52.000000', 'consum', 0.0216, 'lps'),
	(562672, 129, '2014-03-01 00:40:53.000000', 'consum', 0.0226, 'lps'),
	(562673, 129, '2014-03-01 00:40:54.000000', 'consum', 0.0215, 'lps'),
	(562674, 129, '2014-03-01 00:40:55.000000', 'consum', 0.0215, 'lps'),
	(562675, 129, '2014-03-01 00:40:56.000000', 'consum', 0.0223, 'lps'),
	(562676, 129, '2014-03-01 00:40:57.000000', 'consum', 0.0230, 'lps'),
	(562677, 129, '2014-03-01 00:40:58.000000', 'consum', 0.0212, 'lps'),
	(562678, 129, '2014-03-01 00:40:59.000000', 'consum', 0.0220, 'lps'),
	(562679, 129, '2014-03-01 00:41:00.000000', 'consum', 0.0225, 'lps'),
	(562680, 129, '2014-03-01 00:41:01.000000', 'consum', 0.0227, 'lps'),
	(562681, 129, '2014-03-01 00:41:02.000000', 'consum', 0.0223, 'lps'),
	(562682, 129, '2014-03-01 00:41:03.000000', 'consum', 0.0225, 'lps'),
	(562683, 129, '2014-03-01 00:41:04.000000', 'consum', 0.0218, 'lps'),
	(562684, 129, '2014-03-01 00:41:05.000000', 'consum', 0.0232, 'lps'),
	(562685, 129, '2014-03-01 00:41:06.000000', 'consum', 0.0238, 'lps'),
	(562686, 129, '2014-03-01 00:41:07.000000', 'consum', 0.0228, 'lps'),
	(562687, 129, '2014-03-01 00:41:08.000000', 'consum', 0.0214, 'lps'),
	(562688, 129, '2014-03-01 00:41:09.000000', 'consum', 0.0237, 'lps'),
	(562689, 129, '2014-03-01 00:41:10.000000', 'consum', 0.0217, 'lps'),
	(562690, 129, '2014-03-01 00:41:11.000000', 'consum', 0.0221, 'lps'),
	(562691, 129, '2014-03-01 00:41:12.000000', 'consum', 0.0217, 'lps'),
	(562692, 129, '2014-03-01 00:41:13.000000', 'consum', 0.0213, 'lps'),
	(562693, 129, '2014-03-01 00:41:14.000000', 'consum', 0.0233, 'lps'),
	(562694, 129, '2014-03-01 00:41:15.000000', 'consum', 0.0229, 'lps'),
	(562695, 129, '2014-03-01 00:41:16.000000', 'consum', 0.0210, 'lps'),
	(562696, 129, '2014-03-01 00:41:17.000000', 'consum', 0.0237, 'lps'),
	(562697, 129, '2014-03-01 00:41:18.000000', 'consum', 0.0232, 'lps'),
	(562698, 129, '2014-03-01 00:41:19.000000', 'consum', 0.0211, 'lps'),
	(562699, 129, '2014-03-01 00:41:20.000000', 'consum', 0.0237, 'lps'),
	(562700, 129, '2014-03-01 00:41:21.000000', 'consum', 0.0224, 'lps'),
	(562701, 129, '2014-03-01 00:41:22.000000', 'consum', 0.0232, 'lps'),
	(562702, 129, '2014-03-01 00:41:23.000000', 'consum', 0.0217, 'lps'),
	(562703, 129, '2014-03-01 00:41:24.000000', 'consum', 0.0238, 'lps'),
	(562704, 129, '2014-03-01 00:41:25.000000', 'consum', 0.0215, 'lps'),
	(562705, 129, '2014-03-01 00:41:26.000000', 'consum', 0.0238, 'lps'),
	(562706, 129, '2014-03-01 00:41:27.000000', 'consum', 0.0219, 'lps'),
	(562707, 129, '2014-03-01 00:41:28.000000', 'consum', 0.0229, 'lps'),
	(562708, 129, '2014-03-01 00:41:29.000000', 'consum', 0.0221, 'lps'),
	(562709, 129, '2014-03-01 00:41:30.000000', 'consum', 0.0238, 'lps'),
	(562710, 129, '2014-03-01 00:41:31.000000', 'consum', 0.0231, 'lps'),
	(562711, 129, '2014-03-01 00:41:32.000000', 'consum', 0.0232, 'lps'),
	(562712, 129, '2014-03-01 00:41:33.000000', 'consum', 0.0229, 'lps'),
	(562713, 129, '2014-03-01 00:41:34.000000', 'consum', 0.0238, 'lps'),
	(562714, 129, '2014-03-01 00:41:35.000000', 'consum', 0.0238, 'lps'),
	(562715, 129, '2014-03-01 00:41:36.000000', 'consum', 0.0234, 'lps'),
	(562716, 129, '2014-03-01 00:41:37.000000', 'consum', 0.0219, 'lps'),
	(562717, 129, '2014-03-01 00:41:38.000000', 'consum', 0.0212, 'lps'),
	(562718, 129, '2014-03-01 00:41:39.000000', 'consum', 0.0225, 'lps'),
	(562719, 129, '2014-03-01 00:41:40.000000', 'consum', 0.0219, 'lps'),
	(562720, 129, '2014-03-01 00:41:41.000000', 'consum', 0.0210, 'lps'),
	(562721, 129, '2014-03-01 00:41:42.000000', 'consum', 0.0212, 'lps'),
	(562722, 129, '2014-03-01 00:41:43.000000', 'consum', 0.0221, 'lps'),
	(562723, 129, '2014-03-01 00:41:44.000000', 'consum', 0.0232, 'lps'),
	(562724, 129, '2014-03-01 00:41:45.000000', 'consum', 0.0231, 'lps'),
	(562725, 129, '2014-03-01 00:41:46.000000', 'consum', 0.0217, 'lps'),
	(562726, 129, '2014-03-01 00:41:47.000000', 'consum', 0.0215, 'lps'),
	(562727, 129, '2014-03-01 00:41:48.000000', 'consum', 0.0213, 'lps'),
	(562728, 129, '2014-03-01 00:41:49.000000', 'consum', 0.0238, 'lps'),
	(562729, 129, '2014-03-01 00:41:50.000000', 'consum', 0.0226, 'lps'),
	(562730, 129, '2014-03-01 00:41:51.000000', 'consum', 0.0237, 'lps'),
	(562731, 129, '2014-03-01 00:41:52.000000', 'consum', 0.0237, 'lps'),
	(562732, 129, '2014-03-01 00:41:53.000000', 'consum', 0.0236, 'lps'),
	(562733, 129, '2014-03-01 00:41:54.000000', 'consum', 0.0229, 'lps'),
	(562734, 129, '2014-03-01 00:41:55.000000', 'consum', 0.0231, 'lps'),
	(562735, 129, '2014-03-01 00:41:56.000000', 'consum', 0.0227, 'lps'),
	(562736, 129, '2014-03-01 00:41:57.000000', 'consum', 0.0232, 'lps'),
	(562737, 129, '2014-03-01 00:41:58.000000', 'consum', 0.0214, 'lps'),
	(562738, 129, '2014-03-01 00:41:59.000000', 'consum', 0.0220, 'lps'),
	(562739, 129, '2014-03-01 00:42:00.000000', 'consum', 0.0222, 'lps'),
	(562740, 129, '2014-03-01 00:42:01.000000', 'consum', 0.0211, 'lps'),
	(562741, 129, '2014-03-01 00:42:02.000000', 'consum', 0.0236, 'lps'),
	(562742, 129, '2014-03-01 00:42:03.000000', 'consum', 0.0223, 'lps'),
	(562743, 129, '2014-03-01 00:42:04.000000', 'consum', 0.0227, 'lps'),
	(562744, 129, '2014-03-01 00:42:05.000000', 'consum', 0.0228, 'lps'),
	(562745, 129, '2014-03-01 00:42:06.000000', 'consum', 0.0220, 'lps'),
	(562746, 129, '2014-03-01 00:42:07.000000', 'consum', 0.0233, 'lps'),
	(562747, 129, '2014-03-01 00:42:08.000000', 'consum', 0.0211, 'lps'),
	(562748, 129, '2014-03-01 00:42:09.000000', 'consum', 0.0234, 'lps'),
	(562749, 129, '2014-03-01 00:42:10.000000', 'consum', 0.0211, 'lps'),
	(562750, 129, '2014-03-01 00:42:11.000000', 'consum', 0.0231, 'lps'),
	(562751, 129, '2014-03-01 00:42:12.000000', 'consum', 0.0226, 'lps'),
	(562752, 129, '2014-03-01 00:42:13.000000', 'consum', 0.0225, 'lps'),
	(562753, 129, '2014-03-01 00:42:14.000000', 'consum', 0.0212, 'lps'),
	(562754, 129, '2014-03-01 00:42:15.000000', 'consum', 0.0231, 'lps'),
	(562755, 129, '2014-03-01 00:42:16.000000', 'consum', 0.0222, 'lps'),
	(562756, 129, '2014-03-01 00:42:17.000000', 'consum', 0.0238, 'lps'),
	(562757, 129, '2014-03-01 00:42:18.000000', 'consum', 0.0225, 'lps'),
	(562758, 129, '2014-03-01 00:42:19.000000', 'consum', 0.0233, 'lps'),
	(562759, 129, '2014-03-01 00:42:20.000000', 'consum', 0.0222, 'lps'),
	(562760, 129, '2014-03-01 00:42:21.000000', 'consum', 0.0230, 'lps'),
	(562761, 129, '2014-03-01 00:42:22.000000', 'consum', 0.0215, 'lps'),
	(562762, 129, '2014-03-01 00:42:23.000000', 'consum', 0.0234, 'lps'),
	(562763, 129, '2014-03-01 00:42:24.000000', 'consum', 0.0230, 'lps'),
	(562764, 129, '2014-03-01 00:42:25.000000', 'consum', 0.0237, 'lps'),
	(562765, 129, '2014-03-01 00:42:26.000000', 'consum', 0.0227, 'lps'),
	(562766, 129, '2014-03-01 00:42:27.000000', 'consum', 0.0214, 'lps'),
	(562767, 129, '2014-03-01 00:42:28.000000', 'consum', 0.0238, 'lps'),
	(562768, 129, '2014-03-01 00:42:29.000000', 'consum', 0.0221, 'lps'),
	(562769, 129, '2014-03-01 00:42:30.000000', 'consum', 0.0211, 'lps'),
	(562770, 129, '2014-03-01 00:42:31.000000', 'consum', 0.0213, 'lps'),
	(562771, 129, '2014-03-01 00:42:32.000000', 'consum', 0.0222, 'lps'),
	(562772, 129, '2014-03-01 00:42:33.000000', 'consum', 0.0232, 'lps'),
	(562773, 129, '2014-03-01 00:42:34.000000', 'consum', 0.0226, 'lps'),
	(562774, 129, '2014-03-01 00:42:35.000000', 'consum', 0.0224, 'lps'),
	(562775, 129, '2014-03-01 00:42:36.000000', 'consum', 0.0234, 'lps'),
	(562776, 129, '2014-03-01 00:42:37.000000', 'consum', 0.0228, 'lps'),
	(562777, 129, '2014-03-01 00:42:38.000000', 'consum', 0.0230, 'lps'),
	(562778, 129, '2014-03-01 00:42:39.000000', 'consum', 0.0225, 'lps'),
	(562779, 129, '2014-03-01 00:42:40.000000', 'consum', 0.0228, 'lps'),
	(562780, 129, '2014-03-01 00:42:41.000000', 'consum', 0.0227, 'lps'),
	(562781, 129, '2014-03-01 00:42:42.000000', 'consum', 0.0213, 'lps'),
	(562782, 129, '2014-03-01 00:42:43.000000', 'consum', 0.0234, 'lps'),
	(562783, 129, '2014-03-01 00:42:44.000000', 'consum', 0.0231, 'lps'),
	(562784, 129, '2014-03-01 00:42:45.000000', 'consum', 0.0217, 'lps'),
	(562785, 129, '2014-03-01 00:42:46.000000', 'consum', 0.0213, 'lps'),
	(562786, 129, '2014-03-01 00:42:47.000000', 'consum', 0.0230, 'lps'),
	(562787, 129, '2014-03-01 00:42:48.000000', 'consum', 0.0217, 'lps'),
	(562788, 129, '2014-03-01 00:42:49.000000', 'consum', 0.0215, 'lps'),
	(562789, 129, '2014-03-01 00:42:50.000000', 'consum', 0.0215, 'lps'),
	(562790, 129, '2014-03-01 00:42:51.000000', 'consum', 0.0221, 'lps'),
	(562791, 129, '2014-03-01 00:42:52.000000', 'consum', 0.0221, 'lps'),
	(562792, 129, '2014-03-01 00:42:53.000000', 'consum', 0.0233, 'lps'),
	(562793, 129, '2014-03-01 00:42:54.000000', 'consum', 0.0234, 'lps'),
	(562794, 129, '2014-03-01 00:42:55.000000', 'consum', 0.0234, 'lps'),
	(562795, 129, '2014-03-01 00:42:56.000000', 'consum', 0.0229, 'lps'),
	(562796, 129, '2014-03-01 00:42:57.000000', 'consum', 0.0232, 'lps'),
	(562797, 129, '2014-03-01 00:42:58.000000', 'consum', 0.0235, 'lps'),
	(562798, 129, '2014-03-01 00:42:59.000000', 'consum', 0.0211, 'lps'),
	(562799, 129, '2014-03-01 00:43:00.000000', 'consum', 0.0227, 'lps'),
	(562800, 129, '2014-03-01 00:43:01.000000', 'consum', 0.0235, 'lps'),
	(562801, 129, '2014-03-01 00:43:02.000000', 'consum', 0.0225, 'lps'),
	(562802, 129, '2014-03-01 00:43:03.000000', 'consum', 0.0211, 'lps'),
	(562803, 129, '2014-03-01 00:43:04.000000', 'consum', 0.0228, 'lps'),
	(562804, 129, '2014-03-01 00:43:05.000000', 'consum', 0.0213, 'lps'),
	(562805, 129, '2014-03-01 00:43:06.000000', 'consum', 0.0227, 'lps'),
	(562806, 129, '2014-03-01 00:43:07.000000', 'consum', 0.0231, 'lps'),
	(562807, 129, '2014-03-01 00:43:08.000000', 'consum', 0.0232, 'lps'),
	(562808, 129, '2014-03-01 00:43:09.000000', 'consum', 0.0231, 'lps'),
	(562809, 129, '2014-03-01 00:43:10.000000', 'consum', 0.0221, 'lps'),
	(562810, 129, '2014-03-01 00:43:11.000000', 'consum', 0.0229, 'lps'),
	(562811, 129, '2014-03-01 00:43:12.000000', 'consum', 0.0216, 'lps'),
	(562812, 129, '2014-03-01 00:43:13.000000', 'consum', 0.0212, 'lps'),
	(562813, 129, '2014-03-01 00:43:14.000000', 'consum', 0.0233, 'lps'),
	(562814, 129, '2014-03-01 00:43:15.000000', 'consum', 0.0230, 'lps'),
	(562815, 129, '2014-03-01 00:43:16.000000', 'consum', 0.0212, 'lps'),
	(562816, 129, '2014-03-01 00:43:17.000000', 'consum', 0.0218, 'lps'),
	(562817, 129, '2014-03-01 00:43:18.000000', 'consum', 0.0216, 'lps'),
	(562818, 129, '2014-03-01 00:43:19.000000', 'consum', 0.0217, 'lps'),
	(562819, 129, '2014-03-01 00:43:20.000000', 'consum', 0.0229, 'lps'),
	(562820, 129, '2014-03-01 00:43:21.000000', 'consum', 0.0227, 'lps'),
	(562821, 129, '2014-03-01 00:43:22.000000', 'consum', 0.0210, 'lps'),
	(562822, 129, '2014-03-01 00:43:23.000000', 'consum', 0.0217, 'lps'),
	(562823, 129, '2014-03-01 00:43:24.000000', 'consum', 0.0216, 'lps'),
	(562824, 129, '2014-03-01 00:43:25.000000', 'consum', 0.0218, 'lps'),
	(562825, 129, '2014-03-01 00:43:26.000000', 'consum', 0.0233, 'lps'),
	(562826, 129, '2014-03-01 00:43:27.000000', 'consum', 0.0216, 'lps'),
	(562827, 129, '2014-03-01 00:43:28.000000', 'consum', 0.0228, 'lps'),
	(562828, 129, '2014-03-01 00:43:29.000000', 'consum', 0.0225, 'lps'),
	(562829, 129, '2014-03-01 00:43:30.000000', 'consum', 0.0232, 'lps'),
	(562830, 129, '2014-03-01 00:43:31.000000', 'consum', 0.0218, 'lps'),
	(562831, 129, '2014-03-01 00:43:32.000000', 'consum', 0.0212, 'lps'),
	(562832, 129, '2014-03-01 00:43:33.000000', 'consum', 0.0228, 'lps'),
	(562833, 129, '2014-03-01 00:43:34.000000', 'consum', 0.0234, 'lps'),
	(562834, 129, '2014-03-01 00:43:35.000000', 'consum', 0.0218, 'lps'),
	(562835, 129, '2014-03-01 00:43:36.000000', 'consum', 0.0236, 'lps'),
	(562836, 129, '2014-03-01 00:43:37.000000', 'consum', 0.0229, 'lps'),
	(562837, 129, '2014-03-01 00:43:38.000000', 'consum', 0.0230, 'lps'),
	(562838, 129, '2014-03-01 00:43:39.000000', 'consum', 0.0224, 'lps'),
	(562839, 129, '2014-03-01 00:43:40.000000', 'consum', 0.0219, 'lps'),
	(562840, 129, '2014-03-01 00:43:41.000000', 'consum', 0.0215, 'lps'),
	(562841, 129, '2014-03-01 00:43:42.000000', 'consum', 0.0238, 'lps'),
	(562842, 129, '2014-03-01 00:43:43.000000', 'consum', 0.0219, 'lps'),
	(562843, 129, '2014-03-01 00:43:44.000000', 'consum', 0.0230, 'lps'),
	(562844, 129, '2014-03-01 00:43:45.000000', 'consum', 0.0224, 'lps'),
	(562845, 129, '2014-03-01 00:43:46.000000', 'consum', 0.0220, 'lps'),
	(562846, 129, '2014-03-01 00:43:47.000000', 'consum', 0.0220, 'lps'),
	(562847, 129, '2014-03-01 00:43:48.000000', 'consum', 0.0231, 'lps'),
	(562848, 129, '2014-03-01 00:43:49.000000', 'consum', 0.0228, 'lps'),
	(562849, 129, '2014-03-01 00:43:50.000000', 'consum', 0.0237, 'lps'),
	(562850, 129, '2014-03-01 00:43:51.000000', 'consum', 0.0232, 'lps'),
	(562851, 129, '2014-03-01 00:43:52.000000', 'consum', 0.0211, 'lps'),
	(562852, 129, '2014-03-01 00:43:53.000000', 'consum', 0.0238, 'lps'),
	(562853, 129, '2014-03-01 00:43:54.000000', 'consum', 0.0229, 'lps'),
	(562854, 129, '2014-03-01 00:43:55.000000', 'consum', 0.0225, 'lps'),
	(562855, 129, '2014-03-01 00:43:56.000000', 'consum', 0.0225, 'lps'),
	(562856, 129, '2014-03-01 00:43:57.000000', 'consum', 0.0212, 'lps'),
	(562857, 129, '2014-03-01 00:43:58.000000', 'consum', 0.0234, 'lps'),
	(562858, 129, '2014-03-01 00:43:59.000000', 'consum', 0.0238, 'lps'),
	(562859, 129, '2014-03-01 00:44:00.000000', 'consum', 0.0221, 'lps'),
	(562860, 129, '2014-03-01 00:44:01.000000', 'consum', 0.0212, 'lps'),
	(562861, 129, '2014-03-01 00:44:02.000000', 'consum', 0.0215, 'lps'),
	(562862, 129, '2014-03-01 00:44:03.000000', 'consum', 0.0228, 'lps'),
	(562863, 129, '2014-03-01 00:44:04.000000', 'consum', 0.0228, 'lps'),
	(562864, 129, '2014-03-01 00:44:05.000000', 'consum', 0.0218, 'lps'),
	(562865, 129, '2014-03-01 00:44:06.000000', 'consum', 0.0223, 'lps'),
	(562866, 129, '2014-03-01 00:44:07.000000', 'consum', 0.0226, 'lps'),
	(562867, 129, '2014-03-01 00:44:08.000000', 'consum', 0.0219, 'lps'),
	(562868, 129, '2014-03-01 00:44:09.000000', 'consum', 0.0211, 'lps'),
	(562869, 129, '2014-03-01 00:44:10.000000', 'consum', 0.0215, 'lps'),
	(562870, 129, '2014-03-01 00:44:11.000000', 'consum', 0.0234, 'lps'),
	(562871, 129, '2014-03-01 00:44:12.000000', 'consum', 0.0229, 'lps'),
	(562872, 129, '2014-03-01 00:44:13.000000', 'consum', 0.0232, 'lps'),
	(562873, 129, '2014-03-01 00:44:14.000000', 'consum', 0.0234, 'lps'),
	(562874, 129, '2014-03-01 00:44:15.000000', 'consum', 0.0236, 'lps'),
	(562875, 129, '2014-03-01 00:44:16.000000', 'consum', 0.0210, 'lps'),
	(562876, 129, '2014-03-01 00:44:17.000000', 'consum', 0.0219, 'lps'),
	(562877, 129, '2014-03-01 00:44:18.000000', 'consum', 0.0227, 'lps'),
	(562878, 129, '2014-03-01 00:44:19.000000', 'consum', 0.0210, 'lps'),
	(562879, 129, '2014-03-01 00:44:20.000000', 'consum', 0.0217, 'lps'),
	(562880, 129, '2014-03-01 00:44:21.000000', 'consum', 0.0216, 'lps'),
	(562881, 129, '2014-03-01 00:44:22.000000', 'consum', 0.0218, 'lps'),
	(562882, 129, '2014-03-01 00:44:23.000000', 'consum', 0.0236, 'lps'),
	(562883, 129, '2014-03-01 00:44:24.000000', 'consum', 0.0226, 'lps'),
	(562884, 129, '2014-03-01 00:44:25.000000', 'consum', 0.0216, 'lps'),
	(562885, 129, '2014-03-01 00:44:26.000000', 'consum', 0.0220, 'lps'),
	(562886, 129, '2014-03-01 00:44:27.000000', 'consum', 0.0214, 'lps'),
	(562887, 129, '2014-03-01 00:44:28.000000', 'consum', 0.0229, 'lps'),
	(562888, 129, '2014-03-01 00:44:29.000000', 'consum', 0.0236, 'lps'),
	(562889, 129, '2014-03-01 00:44:30.000000', 'consum', 0.0225, 'lps'),
	(562890, 129, '2014-03-01 00:44:31.000000', 'consum', 0.0235, 'lps'),
	(562891, 129, '2014-03-01 00:44:32.000000', 'consum', 0.0235, 'lps'),
	(562892, 129, '2014-03-01 00:44:33.000000', 'consum', 0.0230, 'lps'),
	(562893, 129, '2014-03-01 00:44:34.000000', 'consum', 0.0237, 'lps'),
	(562894, 129, '2014-03-01 00:44:35.000000', 'consum', 0.0225, 'lps'),
	(562895, 129, '2014-03-01 00:44:36.000000', 'consum', 0.0233, 'lps'),
	(562896, 129, '2014-03-01 00:44:37.000000', 'consum', 0.0224, 'lps'),
	(562897, 129, '2014-03-01 00:44:38.000000', 'consum', 0.0210, 'lps'),
	(562898, 129, '2014-03-01 00:44:39.000000', 'consum', 0.0225, 'lps'),
	(562899, 129, '2014-03-01 00:44:40.000000', 'consum', 0.0230, 'lps'),
	(562900, 129, '2014-03-01 00:44:41.000000', 'consum', 0.0237, 'lps'),
	(562901, 129, '2014-03-01 00:44:42.000000', 'consum', 0.0228, 'lps'),
	(562902, 129, '2014-03-01 00:44:43.000000', 'consum', 0.0217, 'lps'),
	(562903, 129, '2014-03-01 00:44:44.000000', 'consum', 0.0220, 'lps'),
	(562904, 129, '2014-03-01 00:44:45.000000', 'consum', 0.0213, 'lps'),
	(562905, 129, '2014-03-01 00:44:46.000000', 'consum', 0.0225, 'lps'),
	(562906, 129, '2014-03-01 00:44:47.000000', 'consum', 0.0217, 'lps'),
	(562907, 129, '2014-03-01 00:44:48.000000', 'consum', 0.0229, 'lps'),
	(562908, 129, '2014-03-01 00:44:49.000000', 'consum', 0.0229, 'lps'),
	(562909, 129, '2014-03-01 00:44:50.000000', 'consum', 0.0218, 'lps'),
	(562910, 129, '2014-03-01 00:44:51.000000', 'consum', 0.0222, 'lps'),
	(562911, 129, '2014-03-01 00:44:52.000000', 'consum', 0.0217, 'lps'),
	(562912, 129, '2014-03-01 00:44:53.000000', 'consum', 0.0210, 'lps'),
	(562913, 129, '2014-03-01 00:44:54.000000', 'consum', 0.0220, 'lps'),
	(562914, 129, '2014-03-01 00:44:55.000000', 'consum', 0.0230, 'lps'),
	(562915, 129, '2014-03-01 00:44:56.000000', 'consum', 0.0222, 'lps'),
	(562916, 129, '2014-03-01 00:44:57.000000', 'consum', 0.0212, 'lps'),
	(562917, 129, '2014-03-01 00:44:58.000000', 'consum', 0.0213, 'lps'),
	(562918, 129, '2014-03-01 00:44:59.000000', 'consum', 0.0221, 'lps'),
	(562919, 129, '2014-03-01 00:45:00.000000', 'consum', 0.0226, 'lps'),
	(562920, 129, '2014-03-01 00:45:01.000000', 'consum', 0.0230, 'lps'),
	(562921, 129, '2014-03-01 00:45:02.000000', 'consum', 0.0234, 'lps'),
	(562922, 129, '2014-03-01 00:45:03.000000', 'consum', 0.0211, 'lps'),
	(562923, 129, '2014-03-01 00:45:04.000000', 'consum', 0.0232, 'lps'),
	(562924, 129, '2014-03-01 00:45:05.000000', 'consum', 0.0228, 'lps'),
	(562925, 129, '2014-03-01 00:45:06.000000', 'consum', 0.0238, 'lps'),
	(562926, 129, '2014-03-01 00:45:07.000000', 'consum', 0.0235, 'lps'),
	(562927, 129, '2014-03-01 00:45:08.000000', 'consum', 0.0225, 'lps'),
	(562928, 129, '2014-03-01 00:45:09.000000', 'consum', 0.0237, 'lps'),
	(562929, 129, '2014-03-01 00:45:10.000000', 'consum', 0.0216, 'lps'),
	(562930, 129, '2014-03-01 00:45:11.000000', 'consum', 0.0216, 'lps'),
	(562931, 129, '2014-03-01 00:45:12.000000', 'consum', 0.0225, 'lps'),
	(562932, 129, '2014-03-01 00:45:13.000000', 'consum', 0.0236, 'lps'),
	(562933, 129, '2014-03-01 00:45:14.000000', 'consum', 0.0211, 'lps'),
	(562934, 129, '2014-03-01 00:45:15.000000', 'consum', 0.0223, 'lps'),
	(562935, 129, '2014-03-01 00:45:16.000000', 'consum', 0.0213, 'lps'),
	(562936, 129, '2014-03-01 00:45:17.000000', 'consum', 0.0219, 'lps'),
	(562937, 129, '2014-03-01 00:45:18.000000', 'consum', 0.0215, 'lps'),
	(562938, 129, '2014-03-01 00:45:19.000000', 'consum', 0.0238, 'lps'),
	(562939, 129, '2014-03-01 00:45:20.000000', 'consum', 0.0220, 'lps'),
	(562940, 129, '2014-03-01 00:45:21.000000', 'consum', 0.0233, 'lps'),
	(562941, 129, '2014-03-01 00:45:22.000000', 'consum', 0.0211, 'lps'),
	(562942, 129, '2014-03-01 00:45:23.000000', 'consum', 0.0232, 'lps'),
	(562943, 129, '2014-03-01 00:45:24.000000', 'consum', 0.0229, 'lps'),
	(562944, 129, '2014-03-01 00:45:25.000000', 'consum', 0.0213, 'lps'),
	(562945, 129, '2014-03-01 00:45:26.000000', 'consum', 0.0226, 'lps'),
	(562946, 129, '2014-03-01 00:45:27.000000', 'consum', 0.0224, 'lps'),
	(562947, 129, '2014-03-01 00:45:28.000000', 'consum', 0.0233, 'lps'),
	(562948, 129, '2014-03-01 00:45:29.000000', 'consum', 0.0225, 'lps'),
	(562949, 129, '2014-03-01 00:45:30.000000', 'consum', 0.0218, 'lps'),
	(562950, 129, '2014-03-01 00:45:31.000000', 'consum', 0.0231, 'lps'),
	(562951, 129, '2014-03-01 00:45:32.000000', 'consum', 0.0237, 'lps'),
	(562952, 129, '2014-03-01 00:45:33.000000', 'consum', 0.0222, 'lps'),
	(562953, 129, '2014-03-01 00:45:34.000000', 'consum', 0.0220, 'lps'),
	(562954, 129, '2014-03-01 00:45:35.000000', 'consum', 0.0225, 'lps'),
	(562955, 129, '2014-03-01 00:45:36.000000', 'consum', 0.0227, 'lps'),
	(562956, 129, '2014-03-01 00:45:37.000000', 'consum', 0.0221, 'lps'),
	(562957, 129, '2014-03-01 00:45:38.000000', 'consum', 0.0216, 'lps'),
	(562958, 129, '2014-03-01 00:45:39.000000', 'consum', 0.0234, 'lps'),
	(562959, 129, '2014-03-01 00:45:40.000000', 'consum', 0.0226, 'lps'),
	(562960, 129, '2014-03-01 00:45:41.000000', 'consum', 0.0217, 'lps'),
	(562961, 129, '2014-03-01 00:45:42.000000', 'consum', 0.0227, 'lps'),
	(562962, 129, '2014-03-01 00:45:43.000000', 'consum', 0.0219, 'lps'),
	(562963, 129, '2014-03-01 00:45:44.000000', 'consum', 0.0231, 'lps'),
	(562964, 129, '2014-03-01 00:45:45.000000', 'consum', 0.0231, 'lps'),
	(562965, 129, '2014-03-01 00:45:46.000000', 'consum', 0.0224, 'lps'),
	(562966, 129, '2014-03-01 00:45:47.000000', 'consum', 0.0218, 'lps'),
	(562967, 129, '2014-03-01 00:45:48.000000', 'consum', 0.0235, 'lps'),
	(562968, 129, '2014-03-01 00:45:49.000000', 'consum', 0.0226, 'lps'),
	(562969, 129, '2014-03-01 00:45:50.000000', 'consum', 0.0216, 'lps'),
	(562970, 129, '2014-03-01 00:45:51.000000', 'consum', 0.0222, 'lps'),
	(562971, 129, '2014-03-01 00:45:52.000000', 'consum', 0.0222, 'lps'),
	(562972, 129, '2014-03-01 00:45:53.000000', 'consum', 0.0235, 'lps'),
	(562973, 129, '2014-03-01 00:45:54.000000', 'consum', 0.0213, 'lps'),
	(562974, 129, '2014-03-01 00:45:55.000000', 'consum', 0.0238, 'lps'),
	(562975, 129, '2014-03-01 00:45:56.000000', 'consum', 0.0224, 'lps'),
	(562976, 129, '2014-03-01 00:45:57.000000', 'consum', 0.0224, 'lps'),
	(562977, 129, '2014-03-01 00:45:58.000000', 'consum', 0.0211, 'lps'),
	(562978, 129, '2014-03-01 00:45:59.000000', 'consum', 0.0232, 'lps'),
	(562979, 129, '2014-03-01 00:46:00.000000', 'consum', 0.0232, 'lps'),
	(562980, 129, '2014-03-01 00:46:01.000000', 'consum', 0.0225, 'lps'),
	(562981, 129, '2014-03-01 00:46:02.000000', 'consum', 0.0218, 'lps'),
	(562982, 129, '2014-03-01 00:46:03.000000', 'consum', 0.0233, 'lps'),
	(562983, 129, '2014-03-01 00:46:04.000000', 'consum', 0.0218, 'lps'),
	(562984, 129, '2014-03-01 00:46:05.000000', 'consum', 0.0236, 'lps'),
	(562985, 129, '2014-03-01 00:46:06.000000', 'consum', 0.0231, 'lps'),
	(562986, 129, '2014-03-01 00:46:07.000000', 'consum', 0.0210, 'lps'),
	(562987, 129, '2014-03-01 00:46:08.000000', 'consum', 0.0234, 'lps'),
	(562988, 129, '2014-03-01 00:46:09.000000', 'consum', 0.0212, 'lps'),
	(562989, 129, '2014-03-01 00:46:10.000000', 'consum', 0.0238, 'lps'),
	(562990, 129, '2014-03-01 00:46:11.000000', 'consum', 0.0230, 'lps'),
	(562991, 129, '2014-03-01 00:46:12.000000', 'consum', 0.0224, 'lps'),
	(562992, 129, '2014-03-01 00:46:13.000000', 'consum', 0.0222, 'lps'),
	(562993, 129, '2014-03-01 00:46:14.000000', 'consum', 0.0227, 'lps'),
	(562994, 129, '2014-03-01 00:46:15.000000', 'consum', 0.0232, 'lps'),
	(562995, 129, '2014-03-01 00:46:16.000000', 'consum', 0.0210, 'lps'),
	(562996, 129, '2014-03-01 00:46:17.000000', 'consum', 0.0233, 'lps'),
	(562997, 129, '2014-03-01 00:46:18.000000', 'consum', 0.0238, 'lps'),
	(562998, 129, '2014-03-01 00:46:19.000000', 'consum', 0.0223, 'lps'),
	(562999, 129, '2014-03-01 00:46:20.000000', 'consum', 0.0222, 'lps'),
	(563000, 129, '2014-03-01 00:46:21.000000', 'consum', 0.0229, 'lps'),
	(563001, 129, '2014-03-01 00:46:22.000000', 'consum', 0.0214, 'lps'),
	(563002, 129, '2014-03-01 00:46:23.000000', 'consum', 0.0230, 'lps'),
	(563003, 129, '2014-03-01 00:46:24.000000', 'consum', 0.0211, 'lps'),
	(563004, 129, '2014-03-01 00:46:25.000000', 'consum', 0.0212, 'lps'),
	(563005, 129, '2014-03-01 00:46:26.000000', 'consum', 0.0219, 'lps'),
	(563006, 129, '2014-03-01 00:46:27.000000', 'consum', 0.0223, 'lps'),
	(563007, 129, '2014-03-01 00:46:28.000000', 'consum', 0.0216, 'lps'),
	(563008, 129, '2014-03-01 00:46:29.000000', 'consum', 0.0231, 'lps'),
	(563009, 129, '2014-03-01 00:46:30.000000', 'consum', 0.0212, 'lps'),
	(563010, 129, '2014-03-01 00:46:31.000000', 'consum', 0.0217, 'lps'),
	(563011, 129, '2014-03-01 00:46:32.000000', 'consum', 0.0236, 'lps'),
	(563012, 129, '2014-03-01 00:46:33.000000', 'consum', 0.0234, 'lps'),
	(563013, 129, '2014-03-01 00:46:34.000000', 'consum', 0.0222, 'lps'),
	(563014, 129, '2014-03-01 00:46:35.000000', 'consum', 0.0227, 'lps'),
	(563015, 129, '2014-03-01 00:46:36.000000', 'consum', 0.0232, 'lps'),
	(563016, 129, '2014-03-01 00:46:37.000000', 'consum', 0.0211, 'lps'),
	(563017, 129, '2014-03-01 00:46:38.000000', 'consum', 0.0237, 'lps'),
	(563018, 129, '2014-03-01 00:46:39.000000', 'consum', 0.0227, 'lps'),
	(563019, 129, '2014-03-01 00:46:40.000000', 'consum', 0.0214, 'lps'),
	(563020, 129, '2014-03-01 00:46:41.000000', 'consum', 0.0238, 'lps'),
	(563021, 129, '2014-03-01 00:46:42.000000', 'consum', 0.0221, 'lps'),
	(563022, 129, '2014-03-01 00:46:43.000000', 'consum', 0.0212, 'lps'),
	(563023, 129, '2014-03-01 00:46:44.000000', 'consum', 0.0215, 'lps'),
	(563024, 129, '2014-03-01 00:46:45.000000', 'consum', 0.0229, 'lps'),
	(563025, 129, '2014-03-01 00:46:46.000000', 'consum', 0.0235, 'lps'),
	(563026, 129, '2014-03-01 00:46:47.000000', 'consum', 0.0219, 'lps'),
	(563027, 129, '2014-03-01 00:46:48.000000', 'consum', 0.0237, 'lps'),
	(563028, 129, '2014-03-01 00:46:49.000000', 'consum', 0.0232, 'lps'),
	(563029, 129, '2014-03-01 00:46:50.000000', 'consum', 0.0211, 'lps'),
	(563030, 129, '2014-03-01 00:46:51.000000', 'consum', 0.0236, 'lps'),
	(563031, 129, '2014-03-01 00:46:52.000000', 'consum', 0.0222, 'lps'),
	(563032, 129, '2014-03-01 00:46:53.000000', 'consum', 0.0221, 'lps'),
	(563033, 129, '2014-03-01 00:46:54.000000', 'consum', 0.0230, 'lps'),
	(563034, 129, '2014-03-01 00:46:55.000000', 'consum', 0.0219, 'lps'),
	(563035, 129, '2014-03-01 00:46:56.000000', 'consum', 0.0226, 'lps'),
	(563036, 129, '2014-03-01 00:46:57.000000', 'consum', 0.0233, 'lps'),
	(563037, 129, '2014-03-01 00:46:58.000000', 'consum', 0.0222, 'lps'),
	(563038, 129, '2014-03-01 00:46:59.000000', 'consum', 0.0228, 'lps'),
	(563039, 129, '2014-03-01 00:47:00.000000', 'consum', 0.0236, 'lps'),
	(563040, 129, '2014-03-01 00:47:01.000000', 'consum', 0.0231, 'lps'),
	(563041, 129, '2014-03-01 00:47:02.000000', 'consum', 0.0234, 'lps'),
	(563042, 129, '2014-03-01 00:47:03.000000', 'consum', 0.0211, 'lps'),
	(563043, 129, '2014-03-01 00:47:04.000000', 'consum', 0.0230, 'lps'),
	(563044, 129, '2014-03-01 00:47:05.000000', 'consum', 0.0221, 'lps'),
	(563045, 129, '2014-03-01 00:47:06.000000', 'consum', 0.0236, 'lps'),
	(563046, 129, '2014-03-01 00:47:07.000000', 'consum', 0.0217, 'lps'),
	(563047, 129, '2014-03-01 00:47:08.000000', 'consum', 0.0228, 'lps'),
	(563048, 129, '2014-03-01 00:47:09.000000', 'consum', 0.0221, 'lps'),
	(563049, 129, '2014-03-01 00:47:10.000000', 'consum', 0.0213, 'lps'),
	(563050, 129, '2014-03-01 00:47:11.000000', 'consum', 0.0220, 'lps'),
	(563051, 129, '2014-03-01 00:47:12.000000', 'consum', 0.0224, 'lps'),
	(563052, 129, '2014-03-01 00:47:13.000000', 'consum', 0.0220, 'lps'),
	(563053, 129, '2014-03-01 00:47:14.000000', 'consum', 0.0217, 'lps'),
	(563054, 129, '2014-03-01 00:47:15.000000', 'consum', 0.0217, 'lps'),
	(563055, 129, '2014-03-01 00:47:16.000000', 'consum', 0.0224, 'lps'),
	(563056, 129, '2014-03-01 00:47:17.000000', 'consum', 0.0232, 'lps'),
	(563057, 129, '2014-03-01 00:47:18.000000', 'consum', 0.0218, 'lps'),
	(563058, 129, '2014-03-01 00:47:19.000000', 'consum', 0.0217, 'lps'),
	(563059, 129, '2014-03-01 00:47:20.000000', 'consum', 0.0218, 'lps'),
	(563060, 129, '2014-03-01 00:47:21.000000', 'consum', 0.0231, 'lps'),
	(563061, 129, '2014-03-01 00:47:22.000000', 'consum', 0.0231, 'lps'),
	(563062, 129, '2014-03-01 00:47:23.000000', 'consum', 0.0227, 'lps'),
	(563063, 129, '2014-03-01 00:47:24.000000', 'consum', 0.0230, 'lps'),
	(563064, 129, '2014-03-01 00:47:25.000000', 'consum', 0.0231, 'lps'),
	(563065, 129, '2014-03-01 00:47:26.000000', 'consum', 0.0225, 'lps'),
	(563066, 129, '2014-03-01 00:47:27.000000', 'consum', 0.0225, 'lps'),
	(563067, 129, '2014-03-01 00:47:28.000000', 'consum', 0.0238, 'lps'),
	(563068, 129, '2014-03-01 00:47:29.000000', 'consum', 0.0218, 'lps'),
	(563069, 129, '2014-03-01 00:47:30.000000', 'consum', 0.0225, 'lps'),
	(563070, 129, '2014-03-01 00:47:31.000000', 'consum', 0.0235, 'lps'),
	(563071, 129, '2014-03-01 00:47:32.000000', 'consum', 0.0231, 'lps'),
	(563072, 129, '2014-03-01 00:47:33.000000', 'consum', 0.0210, 'lps'),
	(563073, 129, '2014-03-01 00:47:34.000000', 'consum', 0.0237, 'lps'),
	(563074, 129, '2014-03-01 00:47:35.000000', 'consum', 0.0228, 'lps'),
	(563075, 129, '2014-03-01 00:47:36.000000', 'consum', 0.0220, 'lps'),
	(563076, 129, '2014-03-01 00:47:37.000000', 'consum', 0.0236, 'lps'),
	(563077, 129, '2014-03-01 00:47:38.000000', 'consum', 0.0224, 'lps'),
	(563078, 129, '2014-03-01 00:47:39.000000', 'consum', 0.0230, 'lps'),
	(563079, 129, '2014-03-01 00:47:40.000000', 'consum', 0.0212, 'lps'),
	(563080, 129, '2014-03-01 00:47:41.000000', 'consum', 0.0217, 'lps'),
	(563081, 129, '2014-03-01 00:47:42.000000', 'consum', 0.0210, 'lps'),
	(563082, 129, '2014-03-01 00:47:43.000000', 'consum', 0.0219, 'lps'),
	(563083, 129, '2014-03-01 00:47:44.000000', 'consum', 0.0228, 'lps'),
	(563084, 129, '2014-03-01 00:47:45.000000', 'consum', 0.0214, 'lps'),
	(563085, 129, '2014-03-01 00:47:46.000000', 'consum', 0.0236, 'lps'),
	(563086, 129, '2014-03-01 00:47:47.000000', 'consum', 0.0213, 'lps'),
	(563087, 129, '2014-03-01 00:47:48.000000', 'consum', 0.0234, 'lps'),
	(563088, 129, '2014-03-01 00:47:49.000000', 'consum', 0.0234, 'lps'),
	(563089, 129, '2014-03-01 00:47:50.000000', 'consum', 0.0228, 'lps'),
	(563090, 129, '2014-03-01 00:47:51.000000', 'consum', 0.0232, 'lps'),
	(563091, 129, '2014-03-01 00:47:52.000000', 'consum', 0.0234, 'lps'),
	(563092, 129, '2014-03-01 00:47:53.000000', 'consum', 0.0237, 'lps'),
	(563093, 129, '2014-03-01 00:47:54.000000', 'consum', 0.0215, 'lps'),
	(563094, 129, '2014-03-01 00:47:55.000000', 'consum', 0.0212, 'lps'),
	(563095, 129, '2014-03-01 00:47:56.000000', 'consum', 0.0237, 'lps'),
	(563096, 129, '2014-03-01 00:47:57.000000', 'consum', 0.0222, 'lps'),
	(563097, 129, '2014-03-01 00:47:58.000000', 'consum', 0.0219, 'lps'),
	(563098, 129, '2014-03-01 00:47:59.000000', 'consum', 0.0221, 'lps'),
	(563099, 129, '2014-03-01 00:48:00.000000', 'consum', 0.0236, 'lps'),
	(563100, 129, '2014-03-01 00:48:01.000000', 'consum', 0.0223, 'lps'),
	(563101, 129, '2014-03-01 00:48:02.000000', 'consum', 0.0224, 'lps'),
	(563102, 129, '2014-03-01 00:48:03.000000', 'consum', 0.0212, 'lps'),
	(563103, 129, '2014-03-01 00:48:04.000000', 'consum', 0.0237, 'lps'),
	(563104, 129, '2014-03-01 00:48:05.000000', 'consum', 0.0226, 'lps'),
	(563105, 129, '2014-03-01 00:48:06.000000', 'consum', 0.0236, 'lps'),
	(563106, 129, '2014-03-01 00:48:07.000000', 'consum', 0.0234, 'lps'),
	(563107, 129, '2014-03-01 00:48:08.000000', 'consum', 0.0223, 'lps'),
	(563108, 129, '2014-03-01 00:48:09.000000', 'consum', 0.0234, 'lps'),
	(563109, 129, '2014-03-01 00:48:10.000000', 'consum', 0.0235, 'lps'),
	(563110, 129, '2014-03-01 00:48:11.000000', 'consum', 0.0234, 'lps'),
	(563111, 129, '2014-03-01 00:48:12.000000', 'consum', 0.0226, 'lps'),
	(563112, 129, '2014-03-01 00:48:13.000000', 'consum', 0.0220, 'lps'),
	(563113, 129, '2014-03-01 00:48:14.000000', 'consum', 0.0213, 'lps'),
	(563114, 129, '2014-03-01 00:48:15.000000', 'consum', 0.0224, 'lps'),
	(563115, 129, '2014-03-01 00:48:16.000000', 'consum', 0.0215, 'lps'),
	(563116, 129, '2014-03-01 00:48:17.000000', 'consum', 0.0219, 'lps'),
	(563117, 129, '2014-03-01 00:48:18.000000', 'consum', 0.0215, 'lps'),
	(563118, 129, '2014-03-01 00:48:19.000000', 'consum', 0.0236, 'lps'),
	(563119, 129, '2014-03-01 00:48:20.000000', 'consum', 0.0211, 'lps'),
	(563120, 129, '2014-03-01 00:48:21.000000', 'consum', 0.0222, 'lps'),
	(563121, 129, '2014-03-01 00:48:22.000000', 'consum', 0.0211, 'lps'),
	(563122, 129, '2014-03-01 00:48:23.000000', 'consum', 0.0237, 'lps'),
	(563123, 129, '2014-03-01 00:48:24.000000', 'consum', 0.0226, 'lps'),
	(563124, 129, '2014-03-01 00:48:25.000000', 'consum', 0.0210, 'lps'),
	(563125, 129, '2014-03-01 00:48:26.000000', 'consum', 0.0221, 'lps'),
	(563126, 129, '2014-03-01 00:48:27.000000', 'consum', 0.0235, 'lps'),
	(563127, 129, '2014-03-01 00:48:28.000000', 'consum', 0.0217, 'lps'),
	(563128, 129, '2014-03-01 00:48:29.000000', 'consum', 0.0228, 'lps'),
	(563129, 129, '2014-03-01 00:48:30.000000', 'consum', 0.0222, 'lps'),
	(563130, 129, '2014-03-01 00:48:31.000000', 'consum', 0.0216, 'lps'),
	(563131, 129, '2014-03-01 00:48:32.000000', 'consum', 0.0234, 'lps'),
	(563132, 129, '2014-03-01 00:48:33.000000', 'consum', 0.0223, 'lps'),
	(563133, 129, '2014-03-01 00:48:34.000000', 'consum', 0.0235, 'lps'),
	(563134, 129, '2014-03-01 00:48:35.000000', 'consum', 0.0236, 'lps'),
	(563135, 129, '2014-03-01 00:48:36.000000', 'consum', 0.0210, 'lps'),
	(563136, 129, '2014-03-01 00:48:37.000000', 'consum', 0.0219, 'lps'),
	(563137, 129, '2014-03-01 00:48:38.000000', 'consum', 0.0224, 'lps'),
	(563138, 129, '2014-03-01 00:48:39.000000', 'consum', 0.0227, 'lps'),
	(563139, 129, '2014-03-01 00:48:40.000000', 'consum', 0.0222, 'lps'),
	(563140, 129, '2014-03-01 00:48:41.000000', 'consum', 0.0222, 'lps'),
	(563141, 129, '2014-03-01 00:48:42.000000', 'consum', 0.0235, 'lps'),
	(563142, 129, '2014-03-01 00:48:43.000000', 'consum', 0.0213, 'lps'),
	(563143, 129, '2014-03-01 00:48:44.000000', 'consum', 0.0235, 'lps'),
	(563144, 129, '2014-03-01 00:48:45.000000', 'consum', 0.0211, 'lps'),
	(563145, 129, '2014-03-01 00:48:46.000000', 'consum', 0.0227, 'lps'),
	(563146, 129, '2014-03-01 00:48:47.000000', 'consum', 0.0236, 'lps'),
	(563147, 129, '2014-03-01 00:48:48.000000', 'consum', 0.0230, 'lps'),
	(563148, 129, '2014-03-01 00:48:49.000000', 'consum', 0.0234, 'lps'),
	(563149, 129, '2014-03-01 00:48:50.000000', 'consum', 0.0211, 'lps'),
	(563150, 129, '2014-03-01 00:48:51.000000', 'consum', 0.0233, 'lps'),
	(563151, 129, '2014-03-01 00:48:52.000000', 'consum', 0.0234, 'lps'),
	(563152, 129, '2014-03-01 00:48:53.000000', 'consum', 0.0234, 'lps'),
	(563153, 129, '2014-03-01 00:48:54.000000', 'consum', 0.0230, 'lps'),
	(563154, 129, '2014-03-01 00:48:55.000000', 'consum', 0.0236, 'lps'),
	(563155, 129, '2014-03-01 00:48:56.000000', 'consum', 0.0224, 'lps'),
	(563156, 129, '2014-03-01 00:48:57.000000', 'consum', 0.0233, 'lps'),
	(563157, 129, '2014-03-01 00:48:58.000000', 'consum', 0.0223, 'lps'),
	(563158, 129, '2014-03-01 00:48:59.000000', 'consum', 0.0235, 'lps'),
	(563159, 129, '2014-03-01 00:49:00.000000', 'consum', 0.0210, 'lps'),
	(563160, 129, '2014-03-01 00:49:01.000000', 'consum', 0.0222, 'lps'),
	(563161, 129, '2014-03-01 00:49:02.000000', 'consum', 0.0211, 'lps'),
	(563162, 129, '2014-03-01 00:49:03.000000', 'consum', 0.0211, 'lps'),
	(563163, 129, '2014-03-01 00:49:04.000000', 'consum', 0.0212, 'lps'),
	(563164, 129, '2014-03-01 00:49:05.000000', 'consum', 0.0217, 'lps'),
	(563165, 129, '2014-03-01 00:49:06.000000', 'consum', 0.0211, 'lps'),
	(563166, 129, '2014-03-01 00:49:07.000000', 'consum', 0.0223, 'lps'),
	(563167, 129, '2014-03-01 00:49:08.000000', 'consum', 0.0215, 'lps'),
	(563168, 129, '2014-03-01 00:49:09.000000', 'consum', 0.0226, 'lps'),
	(563169, 129, '2014-03-01 00:49:10.000000', 'consum', 0.0217, 'lps'),
	(563170, 129, '2014-03-01 00:49:11.000000', 'consum', 0.0227, 'lps'),
	(563171, 129, '2014-03-01 00:49:12.000000', 'consum', 0.0217, 'lps'),
	(563172, 129, '2014-03-01 00:49:13.000000', 'consum', 0.0223, 'lps'),
	(563173, 129, '2014-03-01 00:49:14.000000', 'consum', 0.0226, 'lps'),
	(563174, 129, '2014-03-01 00:49:15.000000', 'consum', 0.0223, 'lps'),
	(563175, 129, '2014-03-01 00:49:16.000000', 'consum', 0.0227, 'lps'),
	(563176, 129, '2014-03-01 00:49:17.000000', 'consum', 0.0227, 'lps'),
	(563177, 129, '2014-03-01 00:49:18.000000', 'consum', 0.0218, 'lps'),
	(563178, 129, '2014-03-01 00:49:19.000000', 'consum', 0.0225, 'lps'),
	(563179, 129, '2014-03-01 00:49:20.000000', 'consum', 0.0233, 'lps'),
	(563180, 129, '2014-03-01 00:49:21.000000', 'consum', 0.0224, 'lps'),
	(563181, 129, '2014-03-01 00:49:22.000000', 'consum', 0.0213, 'lps'),
	(563182, 129, '2014-03-01 00:49:23.000000', 'consum', 0.0211, 'lps'),
	(563183, 129, '2014-03-01 00:49:24.000000', 'consum', 0.0234, 'lps'),
	(563184, 129, '2014-03-01 00:49:25.000000', 'consum', 0.0212, 'lps'),
	(563185, 129, '2014-03-01 00:49:26.000000', 'consum', 0.0236, 'lps'),
	(563186, 129, '2014-03-01 00:49:27.000000', 'consum', 0.0221, 'lps'),
	(563187, 129, '2014-03-01 00:49:28.000000', 'consum', 0.0213, 'lps'),
	(563188, 129, '2014-03-01 00:49:29.000000', 'consum', 0.0222, 'lps'),
	(563189, 129, '2014-03-01 00:49:30.000000', 'consum', 0.0232, 'lps'),
	(563190, 129, '2014-03-01 00:49:31.000000', 'consum', 0.0229, 'lps'),
	(563191, 129, '2014-03-01 00:49:32.000000', 'consum', 0.0210, 'lps'),
	(563192, 129, '2014-03-01 00:49:33.000000', 'consum', 0.0238, 'lps'),
	(563193, 129, '2014-03-01 00:49:34.000000', 'consum', 0.0237, 'lps'),
	(563194, 129, '2014-03-01 00:49:35.000000', 'consum', 0.0233, 'lps'),
	(563195, 129, '2014-03-01 00:49:36.000000', 'consum', 0.0216, 'lps'),
	(563196, 129, '2014-03-01 00:49:37.000000', 'consum', 0.0227, 'lps'),
	(563197, 129, '2014-03-01 00:49:38.000000', 'consum', 0.0220, 'lps'),
	(563198, 129, '2014-03-01 00:49:39.000000', 'consum', 0.0237, 'lps'),
	(563199, 129, '2014-03-01 00:49:40.000000', 'consum', 0.0231, 'lps'),
	(563200, 129, '2014-03-01 00:49:41.000000', 'consum', 0.0235, 'lps'),
	(563201, 129, '2014-03-01 00:49:42.000000', 'consum', 0.0214, 'lps'),
	(563202, 129, '2014-03-01 00:49:43.000000', 'consum', 0.0214, 'lps'),
	(563203, 129, '2014-03-01 00:49:44.000000', 'consum', 0.0216, 'lps'),
	(563204, 129, '2014-03-01 00:49:45.000000', 'consum', 0.0230, 'lps'),
	(563205, 129, '2014-03-01 00:49:46.000000', 'consum', 0.0233, 'lps'),
	(563206, 129, '2014-03-01 00:49:47.000000', 'consum', 0.0210, 'lps'),
	(563207, 129, '2014-03-01 00:49:48.000000', 'consum', 0.0227, 'lps'),
	(563208, 129, '2014-03-01 00:49:49.000000', 'consum', 0.0211, 'lps'),
	(563209, 129, '2014-03-01 00:49:50.000000', 'consum', 0.0219, 'lps'),
	(563210, 129, '2014-03-01 00:49:51.000000', 'consum', 0.0226, 'lps'),
	(563211, 129, '2014-03-01 00:49:52.000000', 'consum', 0.0234, 'lps'),
	(563212, 129, '2014-03-01 00:49:53.000000', 'consum', 0.0222, 'lps'),
	(563213, 129, '2014-03-01 00:49:54.000000', 'consum', 0.0230, 'lps'),
	(563214, 129, '2014-03-01 00:49:55.000000', 'consum', 0.0217, 'lps'),
	(563215, 129, '2014-03-01 00:49:56.000000', 'consum', 0.0213, 'lps'),
	(563216, 129, '2014-03-01 00:49:57.000000', 'consum', 0.0234, 'lps'),
	(563217, 129, '2014-03-01 00:49:58.000000', 'consum', 0.0235, 'lps'),
	(563218, 129, '2014-03-01 00:49:59.000000', 'consum', 0.0236, 'lps'),
	(563219, 129, '2014-03-01 00:50:00.000000', 'consum', 0.0233, 'lps'),
	(563220, 129, '2014-03-01 00:50:01.000000', 'consum', 0.0222, 'lps'),
	(563221, 129, '2014-03-01 00:50:02.000000', 'consum', 0.0227, 'lps'),
	(563222, 129, '2014-03-01 00:50:03.000000', 'consum', 0.0233, 'lps'),
	(563223, 129, '2014-03-01 00:50:04.000000', 'consum', 0.0217, 'lps'),
	(563224, 129, '2014-03-01 00:50:05.000000', 'consum', 0.0233, 'lps'),
	(563225, 129, '2014-03-01 00:50:06.000000', 'consum', 0.0218, 'lps'),
	(563226, 129, '2014-03-01 00:50:07.000000', 'consum', 0.0238, 'lps'),
	(563227, 129, '2014-03-01 00:50:08.000000', 'consum', 0.0211, 'lps'),
	(563228, 129, '2014-03-01 00:50:09.000000', 'consum', 0.0218, 'lps'),
	(563229, 129, '2014-03-01 00:50:10.000000', 'consum', 0.0219, 'lps'),
	(563230, 129, '2014-03-01 00:50:11.000000', 'consum', 0.0232, 'lps'),
	(563231, 129, '2014-03-01 00:50:12.000000', 'consum', 0.0233, 'lps'),
	(563232, 129, '2014-03-01 00:50:13.000000', 'consum', 0.0233, 'lps'),
	(563233, 129, '2014-03-01 00:50:14.000000', 'consum', 0.0227, 'lps'),
	(563234, 129, '2014-03-01 00:50:15.000000', 'consum', 0.0226, 'lps'),
	(563235, 129, '2014-03-01 00:50:16.000000', 'consum', 0.0213, 'lps'),
	(563236, 129, '2014-03-01 00:50:17.000000', 'consum', 0.0233, 'lps'),
	(563237, 129, '2014-03-01 00:50:18.000000', 'consum', 0.0229, 'lps'),
	(563238, 129, '2014-03-01 00:50:19.000000', 'consum', 0.0238, 'lps'),
	(563239, 129, '2014-03-01 00:50:20.000000', 'consum', 0.0234, 'lps'),
	(563240, 129, '2014-03-01 00:50:21.000000', 'consum', 0.0219, 'lps'),
	(563241, 129, '2014-03-01 00:50:22.000000', 'consum', 0.0212, 'lps'),
	(563242, 129, '2014-03-01 00:50:23.000000', 'consum', 0.0223, 'lps'),
	(563243, 129, '2014-03-01 00:50:24.000000', 'consum', 0.0210, 'lps'),
	(563244, 129, '2014-03-01 00:50:25.000000', 'consum', 0.0229, 'lps'),
	(563245, 129, '2014-03-01 00:50:26.000000', 'consum', 0.0218, 'lps'),
	(563246, 129, '2014-03-01 00:50:27.000000', 'consum', 0.0224, 'lps'),
	(563247, 129, '2014-03-01 00:50:28.000000', 'consum', 0.0228, 'lps'),
	(563248, 129, '2014-03-01 00:50:29.000000', 'consum', 0.0227, 'lps'),
	(563249, 129, '2014-03-01 00:50:30.000000', 'consum', 0.0215, 'lps'),
	(563250, 129, '2014-03-01 00:50:31.000000', 'consum', 0.0213, 'lps'),
	(563251, 129, '2014-03-01 00:50:32.000000', 'consum', 0.0238, 'lps'),
	(563252, 129, '2014-03-01 00:50:33.000000', 'consum', 0.0225, 'lps'),
	(563253, 129, '2014-03-01 00:50:34.000000', 'consum', 0.0233, 'lps'),
	(563254, 129, '2014-03-01 00:50:35.000000', 'consum', 0.0223, 'lps'),
	(563255, 129, '2014-03-01 00:50:36.000000', 'consum', 0.0234, 'lps'),
	(563256, 129, '2014-03-01 00:50:37.000000', 'consum', 0.0234, 'lps'),
	(563257, 129, '2014-03-01 00:50:38.000000', 'consum', 0.0230, 'lps'),
	(563258, 129, '2014-03-01 00:50:39.000000', 'consum', 0.0210, 'lps'),
	(563259, 129, '2014-03-01 00:50:40.000000', 'consum', 0.0210, 'lps'),
	(563260, 129, '2014-03-01 00:50:41.000000', 'consum', 0.0237, 'lps'),
	(563261, 129, '2014-03-01 00:50:42.000000', 'consum', 0.0232, 'lps'),
	(563262, 129, '2014-03-01 00:50:43.000000', 'consum', 0.0236, 'lps'),
	(563263, 129, '2014-03-01 00:50:44.000000', 'consum', 0.0219, 'lps'),
	(563264, 129, '2014-03-01 00:50:45.000000', 'consum', 0.0234, 'lps'),
	(563265, 129, '2014-03-01 00:50:46.000000', 'consum', 0.0216, 'lps'),
	(563266, 129, '2014-03-01 00:50:47.000000', 'consum', 0.0228, 'lps'),
	(563267, 129, '2014-03-01 00:50:48.000000', 'consum', 0.0226, 'lps'),
	(563268, 129, '2014-03-01 00:50:49.000000', 'consum', 0.0235, 'lps'),
	(563269, 129, '2014-03-01 00:50:50.000000', 'consum', 0.0231, 'lps'),
	(563270, 129, '2014-03-01 00:50:51.000000', 'consum', 0.0211, 'lps'),
	(563271, 129, '2014-03-01 00:50:52.000000', 'consum', 0.0212, 'lps'),
	(563272, 129, '2014-03-01 00:50:53.000000', 'consum', 0.0216, 'lps'),
	(563273, 129, '2014-03-01 00:50:54.000000', 'consum', 0.0235, 'lps'),
	(563274, 129, '2014-03-01 00:50:55.000000', 'consum', 0.0230, 'lps'),
	(563275, 129, '2014-03-01 00:50:56.000000', 'consum', 0.0235, 'lps'),
	(563276, 129, '2014-03-01 00:50:57.000000', 'consum', 0.0218, 'lps'),
	(563277, 129, '2014-03-01 00:50:58.000000', 'consum', 0.0231, 'lps'),
	(563278, 129, '2014-03-01 00:50:59.000000', 'consum', 0.0237, 'lps'),
	(563279, 129, '2014-03-01 00:51:00.000000', 'consum', 0.0224, 'lps'),
	(563280, 129, '2014-03-01 00:51:01.000000', 'consum', 0.0230, 'lps'),
	(563281, 129, '2014-03-01 00:51:02.000000', 'consum', 0.0237, 'lps'),
	(563282, 129, '2014-03-01 00:51:03.000000', 'consum', 0.0230, 'lps'),
	(563283, 129, '2014-03-01 00:51:04.000000', 'consum', 0.0228, 'lps'),
	(563284, 129, '2014-03-01 00:51:05.000000', 'consum', 0.0212, 'lps'),
	(563285, 129, '2014-03-01 00:51:06.000000', 'consum', 0.0226, 'lps'),
	(563286, 129, '2014-03-01 00:51:07.000000', 'consum', 0.0224, 'lps'),
	(563287, 129, '2014-03-01 00:51:08.000000', 'consum', 0.0233, 'lps'),
	(563288, 129, '2014-03-01 00:51:09.000000', 'consum', 0.0227, 'lps'),
	(563289, 129, '2014-03-01 00:51:10.000000', 'consum', 0.0224, 'lps'),
	(563290, 129, '2014-03-01 00:51:11.000000', 'consum', 0.0230, 'lps'),
	(563291, 129, '2014-03-01 00:51:12.000000', 'consum', 0.0213, 'lps'),
	(563292, 129, '2014-03-01 00:51:13.000000', 'consum', 0.0222, 'lps'),
	(563293, 129, '2014-03-01 00:51:14.000000', 'consum', 0.0233, 'lps'),
	(563294, 129, '2014-03-01 00:51:15.000000', 'consum', 0.0233, 'lps'),
	(563295, 129, '2014-03-01 00:51:16.000000', 'consum', 0.0227, 'lps'),
	(563296, 129, '2014-03-01 00:51:17.000000', 'consum', 0.0227, 'lps'),
	(563297, 129, '2014-03-01 00:51:18.000000', 'consum', 0.0213, 'lps'),
	(563298, 129, '2014-03-01 00:51:19.000000', 'consum', 0.0235, 'lps'),
	(563299, 129, '2014-03-01 00:51:20.000000', 'consum', 0.0238, 'lps'),
	(563300, 129, '2014-03-01 00:51:21.000000', 'consum', 0.0218, 'lps'),
	(563301, 129, '2014-03-01 00:51:22.000000', 'consum', 0.0222, 'lps'),
	(563302, 129, '2014-03-01 00:51:23.000000', 'consum', 0.0221, 'lps'),
	(563303, 129, '2014-03-01 00:51:24.000000', 'consum', 0.0229, 'lps'),
	(563304, 129, '2014-03-01 00:51:25.000000', 'consum', 0.0214, 'lps'),
	(563305, 129, '2014-03-01 00:51:26.000000', 'consum', 0.0231, 'lps'),
	(563306, 129, '2014-03-01 00:51:27.000000', 'consum', 0.0216, 'lps'),
	(563307, 129, '2014-03-01 00:51:28.000000', 'consum', 0.0236, 'lps'),
	(563308, 129, '2014-03-01 00:51:29.000000', 'consum', 0.0237, 'lps'),
	(563309, 129, '2014-03-01 00:51:30.000000', 'consum', 0.0237, 'lps'),
	(563310, 129, '2014-03-01 00:51:31.000000', 'consum', 0.0236, 'lps'),
	(563311, 129, '2014-03-01 00:51:32.000000', 'consum', 0.0232, 'lps'),
	(563312, 129, '2014-03-01 00:51:33.000000', 'consum', 0.0213, 'lps'),
	(563313, 129, '2014-03-01 00:51:34.000000', 'consum', 0.0217, 'lps'),
	(563314, 129, '2014-03-01 00:51:35.000000', 'consum', 0.0236, 'lps'),
	(563315, 129, '2014-03-01 00:51:36.000000', 'consum', 0.0234, 'lps'),
	(563316, 129, '2014-03-01 00:51:37.000000', 'consum', 0.0225, 'lps'),
	(563317, 129, '2014-03-01 00:51:38.000000', 'consum', 0.0210, 'lps'),
	(563318, 129, '2014-03-01 00:51:39.000000', 'consum', 0.0226, 'lps'),
	(563319, 129, '2014-03-01 00:51:40.000000', 'consum', 0.0231, 'lps'),
	(563320, 129, '2014-03-01 00:51:41.000000', 'consum', 0.0238, 'lps'),
	(563321, 129, '2014-03-01 00:51:42.000000', 'consum', 0.0231, 'lps'),
	(563322, 129, '2014-03-01 00:51:43.000000', 'consum', 0.0232, 'lps'),
	(563323, 129, '2014-03-01 00:51:44.000000', 'consum', 0.0229, 'lps'),
	(563324, 129, '2014-03-01 00:51:45.000000', 'consum', 0.0211, 'lps'),
	(563325, 129, '2014-03-01 00:51:46.000000', 'consum', 0.0218, 'lps'),
	(563326, 129, '2014-03-01 00:51:47.000000', 'consum', 0.0215, 'lps'),
	(563327, 129, '2014-03-01 00:51:48.000000', 'consum', 0.0212, 'lps'),
	(563328, 129, '2014-03-01 00:51:49.000000', 'consum', 0.0233, 'lps'),
	(563329, 129, '2014-03-01 00:51:50.000000', 'consum', 0.0234, 'lps'),
	(563330, 129, '2014-03-01 00:51:51.000000', 'consum', 0.0232, 'lps'),
	(563331, 129, '2014-03-01 00:51:52.000000', 'consum', 0.0220, 'lps'),
	(563332, 129, '2014-03-01 00:51:53.000000', 'consum', 0.0222, 'lps'),
	(563333, 129, '2014-03-01 00:51:54.000000', 'consum', 0.0213, 'lps'),
	(563334, 129, '2014-03-01 00:51:55.000000', 'consum', 0.0219, 'lps'),
	(563335, 129, '2014-03-01 00:51:56.000000', 'consum', 0.0218, 'lps'),
	(563336, 129, '2014-03-01 00:51:57.000000', 'consum', 0.0224, 'lps'),
	(563337, 129, '2014-03-01 00:51:58.000000', 'consum', 0.0227, 'lps'),
	(563338, 129, '2014-03-01 00:51:59.000000', 'consum', 0.0225, 'lps'),
	(563339, 129, '2014-03-01 00:52:00.000000', 'consum', 0.0233, 'lps'),
	(563340, 129, '2014-03-01 00:52:01.000000', 'consum', 0.0222, 'lps'),
	(563341, 129, '2014-03-01 00:52:02.000000', 'consum', 0.0231, 'lps'),
	(563342, 129, '2014-03-01 00:52:03.000000', 'consum', 0.0221, 'lps'),
	(563343, 129, '2014-03-01 00:52:04.000000', 'consum', 0.0232, 'lps'),
	(563344, 129, '2014-03-01 00:52:05.000000', 'consum', 0.0228, 'lps'),
	(563345, 129, '2014-03-01 00:52:06.000000', 'consum', 0.0235, 'lps'),
	(563346, 129, '2014-03-01 00:52:07.000000', 'consum', 0.0222, 'lps'),
	(563347, 129, '2014-03-01 00:52:08.000000', 'consum', 0.0225, 'lps'),
	(563348, 129, '2014-03-01 00:52:09.000000', 'consum', 0.0220, 'lps'),
	(563349, 129, '2014-03-01 00:52:10.000000', 'consum', 0.0218, 'lps'),
	(563350, 129, '2014-03-01 00:52:11.000000', 'consum', 0.0219, 'lps'),
	(563351, 129, '2014-03-01 00:52:12.000000', 'consum', 0.0233, 'lps'),
	(563352, 129, '2014-03-01 00:52:13.000000', 'consum', 0.0211, 'lps'),
	(563353, 129, '2014-03-01 00:52:14.000000', 'consum', 0.0233, 'lps'),
	(563354, 129, '2014-03-01 00:52:15.000000', 'consum', 0.0234, 'lps'),
	(563355, 129, '2014-03-01 00:52:16.000000', 'consum', 0.0232, 'lps'),
	(563356, 129, '2014-03-01 00:52:17.000000', 'consum', 0.0219, 'lps'),
	(563357, 129, '2014-03-01 00:52:18.000000', 'consum', 0.0221, 'lps'),
	(563358, 129, '2014-03-01 00:52:19.000000', 'consum', 0.0237, 'lps'),
	(563359, 129, '2014-03-01 00:52:20.000000', 'consum', 0.0225, 'lps'),
	(563360, 129, '2014-03-01 00:52:21.000000', 'consum', 0.0235, 'lps'),
	(563361, 129, '2014-03-01 00:52:22.000000', 'consum', 0.0233, 'lps'),
	(563362, 129, '2014-03-01 00:52:23.000000', 'consum', 0.0222, 'lps'),
	(563363, 129, '2014-03-01 00:52:24.000000', 'consum', 0.0228, 'lps'),
	(563364, 129, '2014-03-01 00:52:25.000000', 'consum', 0.0210, 'lps'),
	(563365, 129, '2014-03-01 00:52:26.000000', 'consum', 0.0211, 'lps'),
	(563366, 129, '2014-03-01 00:52:27.000000', 'consum', 0.0216, 'lps'),
	(563367, 129, '2014-03-01 00:52:28.000000', 'consum', 0.0210, 'lps'),
	(563368, 129, '2014-03-01 00:52:29.000000', 'consum', 0.0219, 'lps'),
	(563369, 129, '2014-03-01 00:52:30.000000', 'consum', 0.0227, 'lps'),
	(563370, 129, '2014-03-01 00:52:31.000000', 'consum', 0.0210, 'lps'),
	(563371, 129, '2014-03-01 00:52:32.000000', 'consum', 0.0216, 'lps'),
	(563372, 129, '2014-03-01 00:52:33.000000', 'consum', 0.0214, 'lps'),
	(563373, 129, '2014-03-01 00:52:34.000000', 'consum', 0.0211, 'lps'),
	(563374, 129, '2014-03-01 00:52:35.000000', 'consum', 0.0231, 'lps'),
	(563375, 129, '2014-03-01 00:52:36.000000', 'consum', 0.0229, 'lps'),
	(563376, 129, '2014-03-01 00:52:37.000000', 'consum', 0.0212, 'lps'),
	(563377, 129, '2014-03-01 00:52:38.000000', 'consum', 0.0220, 'lps'),
	(563378, 129, '2014-03-01 00:52:39.000000', 'consum', 0.0228, 'lps'),
	(563379, 129, '2014-03-01 00:52:40.000000', 'consum', 0.0210, 'lps'),
	(563380, 129, '2014-03-01 00:52:41.000000', 'consum', 0.0216, 'lps'),
	(563381, 129, '2014-03-01 00:52:42.000000', 'consum', 0.0213, 'lps'),
	(563382, 129, '2014-03-01 00:52:43.000000', 'consum', 0.0233, 'lps'),
	(563383, 129, '2014-03-01 00:52:44.000000', 'consum', 0.0232, 'lps'),
	(563384, 129, '2014-03-01 00:52:45.000000', 'consum', 0.0223, 'lps'),
	(563385, 129, '2014-03-01 00:52:46.000000', 'consum', 0.0237, 'lps'),
	(563386, 129, '2014-03-01 00:52:47.000000', 'consum', 0.0221, 'lps'),
	(563387, 129, '2014-03-01 00:52:48.000000', 'consum', 0.0214, 'lps'),
	(563388, 129, '2014-03-01 00:52:49.000000', 'consum', 0.0226, 'lps'),
	(563389, 129, '2014-03-01 00:52:50.000000', 'consum', 0.0221, 'lps'),
	(563390, 129, '2014-03-01 00:52:51.000000', 'consum', 0.0216, 'lps'),
	(563391, 129, '2014-03-01 00:52:52.000000', 'consum', 0.0236, 'lps'),
	(563392, 129, '2014-03-01 00:52:53.000000', 'consum', 0.0237, 'lps'),
	(563393, 129, '2014-03-01 00:52:54.000000', 'consum', 0.0238, 'lps'),
	(563394, 129, '2014-03-01 00:52:55.000000', 'consum', 0.0211, 'lps'),
	(563395, 129, '2014-03-01 00:52:56.000000', 'consum', 0.0218, 'lps'),
	(563396, 129, '2014-03-01 00:52:57.000000', 'consum', 0.0217, 'lps'),
	(563397, 129, '2014-03-01 00:52:58.000000', 'consum', 0.0223, 'lps'),
	(563398, 129, '2014-03-01 00:52:59.000000', 'consum', 0.0226, 'lps'),
	(563399, 129, '2014-03-01 00:53:00.000000', 'consum', 0.0222, 'lps'),
	(563400, 129, '2014-03-01 00:53:01.000000', 'consum', 0.0224, 'lps'),
	(563401, 129, '2014-03-01 00:53:02.000000', 'consum', 0.0216, 'lps'),
	(563402, 129, '2014-03-01 00:53:03.000000', 'consum', 0.0226, 'lps'),
	(563403, 129, '2014-03-01 00:53:04.000000', 'consum', 0.0216, 'lps'),
	(563404, 129, '2014-03-01 00:53:05.000000', 'consum', 0.0221, 'lps'),
	(563405, 129, '2014-03-01 00:53:06.000000', 'consum', 0.0219, 'lps'),
	(563406, 129, '2014-03-01 00:53:07.000000', 'consum', 0.0221, 'lps'),
	(563407, 129, '2014-03-01 00:53:08.000000', 'consum', 0.0211, 'lps'),
	(563408, 129, '2014-03-01 00:53:09.000000', 'consum', 0.0210, 'lps'),
	(563409, 129, '2014-03-01 00:53:10.000000', 'consum', 0.0238, 'lps'),
	(563410, 129, '2014-03-01 00:53:11.000000', 'consum', 0.0233, 'lps'),
	(563411, 129, '2014-03-01 00:53:12.000000', 'consum', 0.0211, 'lps'),
	(563412, 129, '2014-03-01 00:53:13.000000', 'consum', 0.0237, 'lps'),
	(563413, 129, '2014-03-01 00:53:14.000000', 'consum', 0.0223, 'lps'),
	(563414, 129, '2014-03-01 00:53:15.000000', 'consum', 0.0225, 'lps'),
	(563415, 129, '2014-03-01 00:53:16.000000', 'consum', 0.0219, 'lps'),
	(563416, 129, '2014-03-01 00:53:17.000000', 'consum', 0.0210, 'lps'),
	(563417, 129, '2014-03-01 00:53:18.000000', 'consum', 0.0212, 'lps'),
	(563418, 129, '2014-03-01 00:53:19.000000', 'consum', 0.0220, 'lps'),
	(563419, 129, '2014-03-01 00:53:20.000000', 'consum', 0.0227, 'lps'),
	(563420, 129, '2014-03-01 00:53:21.000000', 'consum', 0.0237, 'lps'),
	(563421, 129, '2014-03-01 00:53:22.000000', 'consum', 0.0237, 'lps'),
	(563422, 129, '2014-03-01 00:53:23.000000', 'consum', 0.0235, 'lps'),
	(563423, 129, '2014-03-01 00:53:24.000000', 'consum', 0.0226, 'lps'),
	(563424, 129, '2014-03-01 00:53:25.000000', 'consum', 0.0214, 'lps'),
	(563425, 129, '2014-03-01 00:53:26.000000', 'consum', 0.0212, 'lps'),
	(563426, 129, '2014-03-01 00:53:27.000000', 'consum', 0.0236, 'lps'),
	(563427, 129, '2014-03-01 00:53:28.000000', 'consum', 0.0221, 'lps'),
	(563428, 129, '2014-03-01 00:53:29.000000', 'consum', 0.0214, 'lps'),
	(563429, 129, '2014-03-01 00:53:30.000000', 'consum', 0.0227, 'lps'),
	(563430, 129, '2014-03-01 00:53:31.000000', 'consum', 0.0227, 'lps'),
	(563431, 129, '2014-03-01 00:53:32.000000', 'consum', 0.0216, 'lps'),
	(563432, 129, '2014-03-01 00:53:33.000000', 'consum', 0.0217, 'lps'),
	(563433, 129, '2014-03-01 00:53:34.000000', 'consum', 0.0229, 'lps'),
	(563434, 129, '2014-03-01 00:53:35.000000', 'consum', 0.0226, 'lps'),
	(563435, 129, '2014-03-01 00:53:36.000000', 'consum', 0.0234, 'lps'),
	(563436, 129, '2014-03-01 00:53:37.000000', 'consum', 0.0225, 'lps'),
	(563437, 129, '2014-03-01 00:53:38.000000', 'consum', 0.0213, 'lps'),
	(563438, 129, '2014-03-01 00:53:39.000000', 'consum', 0.0210, 'lps'),
	(563439, 129, '2014-03-01 00:53:40.000000', 'consum', 0.0228, 'lps'),
	(563440, 129, '2014-03-01 00:53:41.000000', 'consum', 0.0216, 'lps'),
	(563441, 129, '2014-03-01 00:53:42.000000', 'consum', 0.0215, 'lps'),
	(563442, 129, '2014-03-01 00:53:43.000000', 'consum', 0.0215, 'lps'),
	(563443, 129, '2014-03-01 00:53:44.000000', 'consum', 0.0224, 'lps'),
	(563444, 129, '2014-03-01 00:53:45.000000', 'consum', 0.0236, 'lps'),
	(563445, 129, '2014-03-01 00:53:46.000000', 'consum', 0.0211, 'lps'),
	(563446, 129, '2014-03-01 00:53:47.000000', 'consum', 0.0225, 'lps'),
	(563447, 129, '2014-03-01 00:53:48.000000', 'consum', 0.0224, 'lps'),
	(563448, 129, '2014-03-01 00:53:49.000000', 'consum', 0.0236, 'lps'),
	(563449, 129, '2014-03-01 00:53:50.000000', 'consum', 0.0213, 'lps'),
	(563450, 129, '2014-03-01 00:53:51.000000', 'consum', 0.0234, 'lps'),
	(563451, 129, '2014-03-01 00:53:52.000000', 'consum', 0.0234, 'lps'),
	(563452, 129, '2014-03-01 00:53:53.000000', 'consum', 0.0228, 'lps'),
	(563453, 129, '2014-03-01 00:53:54.000000', 'consum', 0.0230, 'lps'),
	(563454, 129, '2014-03-01 00:53:55.000000', 'consum', 0.0227, 'lps'),
	(563455, 129, '2014-03-01 00:53:56.000000', 'consum', 0.0237, 'lps'),
	(563456, 129, '2014-03-01 00:53:57.000000', 'consum', 0.0236, 'lps'),
	(563457, 129, '2014-03-01 00:53:58.000000', 'consum', 0.0231, 'lps'),
	(563458, 129, '2014-03-01 00:53:59.000000', 'consum', 0.0236, 'lps'),
	(563459, 129, '2014-03-01 00:54:00.000000', 'consum', 0.0222, 'lps'),
	(563460, 129, '2014-03-01 00:54:01.000000', 'consum', 0.0220, 'lps'),
	(563461, 129, '2014-03-01 00:54:02.000000', 'consum', 0.0226, 'lps'),
	(563462, 129, '2014-03-01 00:54:03.000000', 'consum', 0.0229, 'lps'),
	(563463, 129, '2014-03-01 00:54:04.000000', 'consum', 0.0231, 'lps'),
	(563464, 129, '2014-03-01 00:54:05.000000', 'consum', 0.0227, 'lps'),
	(563465, 129, '2014-03-01 00:54:06.000000', 'consum', 0.0233, 'lps'),
	(563466, 129, '2014-03-01 00:54:07.000000', 'consum', 0.0218, 'lps'),
	(563467, 129, '2014-03-01 00:54:08.000000', 'consum', 0.0237, 'lps'),
	(563468, 129, '2014-03-01 00:54:09.000000', 'consum', 0.0234, 'lps'),
	(563469, 129, '2014-03-01 00:54:10.000000', 'consum', 0.0223, 'lps'),
	(563470, 129, '2014-03-01 00:54:11.000000', 'consum', 0.0233, 'lps'),
	(563471, 129, '2014-03-01 00:54:12.000000', 'consum', 0.0226, 'lps'),
	(563472, 129, '2014-03-01 00:54:13.000000', 'consum', 0.0223, 'lps'),
	(563473, 129, '2014-03-01 00:54:14.000000', 'consum', 0.0226, 'lps'),
	(563474, 129, '2014-03-01 00:54:15.000000', 'consum', 0.0223, 'lps'),
	(563475, 129, '2014-03-01 00:54:16.000000', 'consum', 0.0226, 'lps'),
	(563476, 129, '2014-03-01 00:54:17.000000', 'consum', 0.0222, 'lps'),
	(563477, 129, '2014-03-01 00:54:18.000000', 'consum', 0.0225, 'lps'),
	(563478, 129, '2014-03-01 00:54:19.000000', 'consum', 0.0220, 'lps'),
	(563479, 129, '2014-03-01 00:54:20.000000', 'consum', 0.0213, 'lps'),
	(563480, 129, '2014-03-01 00:54:21.000000', 'consum', 0.0228, 'lps'),
	(563481, 129, '2014-03-01 00:54:22.000000', 'consum', 0.0233, 'lps'),
	(563482, 129, '2014-03-01 00:54:23.000000', 'consum', 0.0211, 'lps'),
	(563483, 129, '2014-03-01 00:54:24.000000', 'consum', 0.0236, 'lps'),
	(563484, 129, '2014-03-01 00:54:25.000000', 'consum', 0.0221, 'lps'),
	(563485, 129, '2014-03-01 00:54:26.000000', 'consum', 0.0216, 'lps'),
	(563486, 129, '2014-03-01 00:54:27.000000', 'consum', 0.0237, 'lps'),
	(563487, 129, '2014-03-01 00:54:28.000000', 'consum', 0.0210, 'lps'),
	(563488, 129, '2014-03-01 00:54:29.000000', 'consum', 0.0219, 'lps'),
	(563489, 129, '2014-03-01 00:54:30.000000', 'consum', 0.0226, 'lps'),
	(563490, 129, '2014-03-01 00:54:31.000000', 'consum', 0.0234, 'lps'),
	(563491, 129, '2014-03-01 00:54:32.000000', 'consum', 0.0224, 'lps'),
	(563492, 129, '2014-03-01 00:54:33.000000', 'consum', 0.0210, 'lps'),
	(563493, 129, '2014-03-01 00:54:34.000000', 'consum', 0.0225, 'lps'),
	(563494, 129, '2014-03-01 00:54:35.000000', 'consum', 0.0228, 'lps'),
	(563495, 129, '2014-03-01 00:54:36.000000', 'consum', 0.0226, 'lps'),
	(563496, 129, '2014-03-01 00:54:37.000000', 'consum', 0.0238, 'lps'),
	(563497, 129, '2014-03-01 00:54:38.000000', 'consum', 0.0213, 'lps'),
	(563498, 129, '2014-03-01 00:54:39.000000', 'consum', 0.0229, 'lps'),
	(563499, 129, '2014-03-01 00:54:40.000000', 'consum', 0.0238, 'lps'),
	(563500, 129, '2014-03-01 00:54:41.000000', 'consum', 0.0238, 'lps'),
	(563501, 129, '2014-03-01 00:54:42.000000', 'consum', 0.0234, 'lps'),
	(563502, 129, '2014-03-01 00:54:43.000000', 'consum', 0.0219, 'lps'),
	(563503, 129, '2014-03-01 00:54:44.000000', 'consum', 0.0215, 'lps'),
	(563504, 129, '2014-03-01 00:54:45.000000', 'consum', 0.0234, 'lps'),
	(563505, 129, '2014-03-01 00:54:46.000000', 'consum', 0.0230, 'lps'),
	(563506, 129, '2014-03-01 00:54:47.000000', 'consum', 0.0238, 'lps'),
	(563507, 129, '2014-03-01 00:54:48.000000', 'consum', 0.0234, 'lps'),
	(563508, 129, '2014-03-01 00:54:49.000000', 'consum', 0.0217, 'lps'),
	(563509, 129, '2014-03-01 00:54:50.000000', 'consum', 0.0233, 'lps'),
	(563510, 129, '2014-03-01 00:54:51.000000', 'consum', 0.0215, 'lps'),
	(563511, 129, '2014-03-01 00:54:52.000000', 'consum', 0.0224, 'lps'),
	(563512, 129, '2014-03-01 00:54:53.000000', 'consum', 0.0235, 'lps'),
	(563513, 129, '2014-03-01 00:54:54.000000', 'consum', 0.0210, 'lps'),
	(563514, 129, '2014-03-01 00:54:55.000000', 'consum', 0.0222, 'lps'),
	(563515, 129, '2014-03-01 00:54:56.000000', 'consum', 0.0210, 'lps'),
	(563516, 129, '2014-03-01 00:54:57.000000', 'consum', 0.0235, 'lps'),
	(563517, 129, '2014-03-01 00:54:58.000000', 'consum', 0.0221, 'lps'),
	(563518, 129, '2014-03-01 00:54:59.000000', 'consum', 0.0216, 'lps'),
	(563519, 129, '2014-03-01 00:55:00.000000', 'consum', 0.0238, 'lps'),
	(563520, 129, '2014-03-01 00:55:01.000000', 'consum', 0.0216, 'lps'),
	(563521, 129, '2014-03-01 00:55:02.000000', 'consum', 0.0215, 'lps'),
	(563522, 129, '2014-03-01 00:55:03.000000', 'consum', 0.0217, 'lps'),
	(563523, 129, '2014-03-01 00:55:04.000000', 'consum', 0.0232, 'lps'),
	(563524, 129, '2014-03-01 00:55:05.000000', 'consum', 0.0211, 'lps'),
	(563525, 129, '2014-03-01 00:55:06.000000', 'consum', 0.0210, 'lps'),
	(563526, 129, '2014-03-01 00:55:07.000000', 'consum', 0.0234, 'lps'),
	(563527, 129, '2014-03-01 00:55:08.000000', 'consum', 0.0217, 'lps'),
	(563528, 129, '2014-03-01 00:55:09.000000', 'consum', 0.0231, 'lps'),
	(563529, 129, '2014-03-01 00:55:10.000000', 'consum', 0.0237, 'lps'),
	(563530, 129, '2014-03-01 00:55:11.000000', 'consum', 0.0224, 'lps'),
	(563531, 129, '2014-03-01 00:55:12.000000', 'consum', 0.0230, 'lps'),
	(563532, 129, '2014-03-01 00:55:13.000000', 'consum', 0.0238, 'lps'),
	(563533, 129, '2014-03-01 00:55:14.000000', 'consum', 0.0235, 'lps'),
	(563534, 129, '2014-03-01 00:55:15.000000', 'consum', 0.0219, 'lps'),
	(563535, 129, '2014-03-01 00:55:16.000000', 'consum', 0.0210, 'lps'),
	(563536, 129, '2014-03-01 00:55:17.000000', 'consum', 0.0214, 'lps'),
	(563537, 129, '2014-03-01 00:55:18.000000', 'consum', 0.0230, 'lps'),
	(563538, 129, '2014-03-01 00:55:19.000000', 'consum', 0.0213, 'lps'),
	(563539, 129, '2014-03-01 00:55:20.000000', 'consum', 0.0224, 'lps'),
	(563540, 129, '2014-03-01 00:55:21.000000', 'consum', 0.0214, 'lps'),
	(563541, 129, '2014-03-01 00:55:22.000000', 'consum', 0.0215, 'lps'),
	(563542, 129, '2014-03-01 00:55:23.000000', 'consum', 0.0226, 'lps'),
	(563543, 129, '2014-03-01 00:55:24.000000', 'consum', 0.0214, 'lps'),
	(563544, 129, '2014-03-01 00:55:25.000000', 'consum', 0.0215, 'lps'),
	(563545, 129, '2014-03-01 00:55:26.000000', 'consum', 0.0222, 'lps'),
	(563546, 129, '2014-03-01 00:55:27.000000', 'consum', 0.0227, 'lps'),
	(563547, 129, '2014-03-01 00:55:28.000000', 'consum', 0.0229, 'lps'),
	(563548, 129, '2014-03-01 00:55:29.000000', 'consum', 0.0225, 'lps'),
	(563549, 129, '2014-03-01 00:55:30.000000', 'consum', 0.0229, 'lps'),
	(563550, 129, '2014-03-01 00:55:31.000000', 'consum', 0.0231, 'lps'),
	(563551, 129, '2014-03-01 00:55:32.000000', 'consum', 0.0230, 'lps'),
	(563552, 129, '2014-03-01 00:55:33.000000', 'consum', 0.0218, 'lps'),
	(563553, 129, '2014-03-01 00:55:34.000000', 'consum', 0.0219, 'lps'),
	(563554, 129, '2014-03-01 00:55:35.000000', 'consum', 0.0230, 'lps'),
	(563555, 129, '2014-03-01 00:55:36.000000', 'consum', 0.0228, 'lps'),
	(563556, 129, '2014-03-01 00:55:37.000000', 'consum', 0.0212, 'lps'),
	(563557, 129, '2014-03-01 00:55:38.000000', 'consum', 0.0224, 'lps'),
	(563558, 129, '2014-03-01 00:55:39.000000', 'consum', 0.0215, 'lps'),
	(563559, 129, '2014-03-01 00:55:40.000000', 'consum', 0.0222, 'lps'),
	(563560, 129, '2014-03-01 00:55:41.000000', 'consum', 0.0227, 'lps'),
	(563561, 129, '2014-03-01 00:55:42.000000', 'consum', 0.0233, 'lps'),
	(563562, 129, '2014-03-01 00:55:43.000000', 'consum', 0.0213, 'lps'),
	(563563, 129, '2014-03-01 00:55:44.000000', 'consum', 0.0217, 'lps'),
	(563564, 129, '2014-03-01 00:55:45.000000', 'consum', 0.0236, 'lps'),
	(563565, 129, '2014-03-01 00:55:46.000000', 'consum', 0.0233, 'lps'),
	(563566, 129, '2014-03-01 00:55:47.000000', 'consum', 0.0218, 'lps'),
	(563567, 129, '2014-03-01 00:55:48.000000', 'consum', 0.0238, 'lps'),
	(563568, 129, '2014-03-01 00:55:49.000000', 'consum', 0.0213, 'lps'),
	(563569, 129, '2014-03-01 00:55:50.000000', 'consum', 0.0229, 'lps'),
	(563570, 129, '2014-03-01 00:55:51.000000', 'consum', 0.0238, 'lps'),
	(563571, 129, '2014-03-01 00:55:52.000000', 'consum', 0.0237, 'lps'),
	(563572, 129, '2014-03-01 00:55:53.000000', 'consum', 0.0229, 'lps'),
	(563573, 129, '2014-03-01 00:55:54.000000', 'consum', 0.0227, 'lps'),
	(563574, 129, '2014-03-01 00:55:55.000000', 'consum', 0.0237, 'lps'),
	(563575, 129, '2014-03-01 00:55:56.000000', 'consum', 0.0237, 'lps'),
	(563576, 129, '2014-03-01 00:55:57.000000', 'consum', 0.0234, 'lps'),
	(563577, 129, '2014-03-01 00:55:58.000000', 'consum', 0.0222, 'lps'),
	(563578, 129, '2014-03-01 00:55:59.000000', 'consum', 0.0228, 'lps'),
	(563579, 129, '2014-03-01 00:56:00.000000', 'consum', 0.0234, 'lps'),
	(563580, 129, '2014-03-01 00:56:01.000000', 'consum', 0.0219, 'lps'),
	(563581, 129, '2014-03-01 00:56:02.000000', 'consum', 0.0212, 'lps'),
	(563582, 129, '2014-03-01 00:56:03.000000', 'consum', 0.0225, 'lps'),
	(563583, 129, '2014-03-01 00:56:04.000000', 'consum', 0.0220, 'lps'),
	(563584, 129, '2014-03-01 00:56:05.000000', 'consum', 0.0215, 'lps'),
	(563585, 129, '2014-03-01 00:56:06.000000', 'consum', 0.0234, 'lps'),
	(563586, 129, '2014-03-01 00:56:07.000000', 'consum', 0.0231, 'lps'),
	(563587, 129, '2014-03-01 00:56:08.000000', 'consum', 0.0213, 'lps'),
	(563588, 129, '2014-03-01 00:56:09.000000', 'consum', 0.0219, 'lps'),
	(563589, 129, '2014-03-01 00:56:10.000000', 'consum', 0.0220, 'lps'),
	(563590, 129, '2014-03-01 00:56:11.000000', 'consum', 0.0233, 'lps'),
	(563591, 129, '2014-03-01 00:56:12.000000', 'consum', 0.0235, 'lps'),
	(563592, 129, '2014-03-01 00:56:13.000000', 'consum', 0.0212, 'lps'),
	(563593, 129, '2014-03-01 00:56:14.000000', 'consum', 0.0230, 'lps'),
	(563594, 129, '2014-03-01 00:56:15.000000', 'consum', 0.0219, 'lps'),
	(563595, 129, '2014-03-01 00:56:16.000000', 'consum', 0.0222, 'lps'),
	(563596, 129, '2014-03-01 00:56:17.000000', 'consum', 0.0218, 'lps'),
	(563597, 129, '2014-03-01 00:56:18.000000', 'consum', 0.0212, 'lps'),
	(563598, 129, '2014-03-01 00:56:19.000000', 'consum', 0.0225, 'lps'),
	(563599, 129, '2014-03-01 00:56:20.000000', 'consum', 0.0221, 'lps'),
	(563600, 129, '2014-03-01 00:56:21.000000', 'consum', 0.0222, 'lps'),
	(563601, 129, '2014-03-01 00:56:22.000000', 'consum', 0.0236, 'lps'),
	(563602, 129, '2014-03-01 00:56:23.000000', 'consum', 0.0217, 'lps'),
	(563603, 129, '2014-03-01 00:56:24.000000', 'consum', 0.0227, 'lps'),
	(563604, 129, '2014-03-01 00:56:25.000000', 'consum', 0.0218, 'lps'),
	(563605, 129, '2014-03-01 00:56:26.000000', 'consum', 0.0226, 'lps'),
	(563606, 129, '2014-03-01 00:56:27.000000', 'consum', 0.0211, 'lps'),
	(563607, 129, '2014-03-01 00:56:28.000000', 'consum', 0.0224, 'lps'),
	(563608, 129, '2014-03-01 00:56:29.000000', 'consum', 0.0218, 'lps'),
	(563609, 129, '2014-03-01 00:56:30.000000', 'consum', 0.0210, 'lps'),
	(563610, 129, '2014-03-01 00:56:31.000000', 'consum', 0.0215, 'lps'),
	(563611, 129, '2014-03-01 00:56:32.000000', 'consum', 0.0237, 'lps'),
	(563612, 129, '2014-03-01 00:56:33.000000', 'consum', 0.0216, 'lps'),
	(563613, 129, '2014-03-01 00:56:34.000000', 'consum', 0.0214, 'lps'),
	(563614, 129, '2014-03-01 00:56:35.000000', 'consum', 0.0215, 'lps'),
	(563615, 129, '2014-03-01 00:56:36.000000', 'consum', 0.0221, 'lps'),
	(563616, 129, '2014-03-01 00:56:37.000000', 'consum', 0.0221, 'lps'),
	(563617, 129, '2014-03-01 00:56:38.000000', 'consum', 0.0235, 'lps'),
	(563618, 129, '2014-03-01 00:56:39.000000', 'consum', 0.0217, 'lps'),
	(563619, 129, '2014-03-01 00:56:40.000000', 'consum', 0.0225, 'lps'),
	(563620, 129, '2014-03-01 00:56:41.000000', 'consum', 0.0236, 'lps'),
	(563621, 129, '2014-03-01 00:56:42.000000', 'consum', 0.0210, 'lps'),
	(563622, 129, '2014-03-01 00:56:43.000000', 'consum', 0.0218, 'lps'),
	(563623, 129, '2014-03-01 00:56:44.000000', 'consum', 0.0224, 'lps'),
	(563624, 129, '2014-03-01 00:56:45.000000', 'consum', 0.0225, 'lps'),
	(563625, 129, '2014-03-01 00:56:46.000000', 'consum', 0.0214, 'lps'),
	(563626, 129, '2014-03-01 00:56:47.000000', 'consum', 0.0215, 'lps'),
	(563627, 129, '2014-03-01 00:56:48.000000', 'consum', 0.0222, 'lps'),
	(563628, 129, '2014-03-01 00:56:49.000000', 'consum', 0.0230, 'lps'),
	(563629, 129, '2014-03-01 00:56:50.000000', 'consum', 0.0214, 'lps'),
	(563630, 129, '2014-03-01 00:56:51.000000', 'consum', 0.0230, 'lps'),
	(563631, 129, '2014-03-01 00:56:52.000000', 'consum', 0.0210, 'lps'),
	(563632, 129, '2014-03-01 00:56:53.000000', 'consum', 0.0210, 'lps'),
	(563633, 129, '2014-03-01 00:56:54.000000', 'consum', 0.0211, 'lps'),
	(563634, 129, '2014-03-01 00:56:55.000000', 'consum', 0.0216, 'lps'),
	(563635, 129, '2014-03-01 00:56:56.000000', 'consum', 0.0236, 'lps'),
	(563636, 129, '2014-03-01 00:56:57.000000', 'consum', 0.0237, 'lps'),
	(563637, 129, '2014-03-01 00:56:58.000000', 'consum', 0.0238, 'lps'),
	(563638, 129, '2014-03-01 00:56:59.000000', 'consum', 0.0213, 'lps'),
	(563639, 129, '2014-03-01 00:57:00.000000', 'consum', 0.0229, 'lps'),
	(563640, 129, '2014-03-01 00:57:01.000000', 'consum', 0.0210, 'lps'),
	(563641, 129, '2014-03-01 00:57:02.000000', 'consum', 0.0238, 'lps'),
	(563642, 129, '2014-03-01 00:57:03.000000', 'consum', 0.0235, 'lps'),
	(563643, 129, '2014-03-01 00:57:04.000000', 'consum', 0.0221, 'lps'),
	(563644, 129, '2014-03-01 00:57:05.000000', 'consum', 0.0221, 'lps'),
	(563645, 129, '2014-03-01 00:57:06.000000', 'consum', 0.0230, 'lps'),
	(563646, 129, '2014-03-01 00:57:07.000000', 'consum', 0.0222, 'lps'),
	(563647, 129, '2014-03-01 00:57:08.000000', 'consum', 0.0210, 'lps'),
	(563648, 129, '2014-03-01 00:57:09.000000', 'consum', 0.0234, 'lps'),
	(563649, 129, '2014-03-01 00:57:10.000000', 'consum', 0.0212, 'lps'),
	(563650, 129, '2014-03-01 00:57:11.000000', 'consum', 0.0237, 'lps'),
	(563651, 129, '2014-03-01 00:57:12.000000', 'consum', 0.0222, 'lps'),
	(563652, 129, '2014-03-01 00:57:13.000000', 'consum', 0.0218, 'lps'),
	(563653, 129, '2014-03-01 00:57:14.000000', 'consum', 0.0215, 'lps'),
	(563654, 129, '2014-03-01 00:57:15.000000', 'consum', 0.0211, 'lps'),
	(563655, 129, '2014-03-01 00:57:16.000000', 'consum', 0.0232, 'lps'),
	(563656, 129, '2014-03-01 00:57:17.000000', 'consum', 0.0227, 'lps'),
	(563657, 129, '2014-03-01 00:57:18.000000', 'consum', 0.0233, 'lps'),
	(563658, 129, '2014-03-01 00:57:19.000000', 'consum', 0.0214, 'lps'),
	(563659, 129, '2014-03-01 00:57:20.000000', 'consum', 0.0219, 'lps'),
	(563660, 129, '2014-03-01 00:57:21.000000', 'consum', 0.0217, 'lps'),
	(563661, 129, '2014-03-01 00:57:22.000000', 'consum', 0.0216, 'lps'),
	(563662, 129, '2014-03-01 00:57:23.000000', 'consum', 0.0221, 'lps'),
	(563663, 129, '2014-03-01 00:57:24.000000', 'consum', 0.0219, 'lps'),
	(563664, 129, '2014-03-01 00:57:25.000000', 'consum', 0.0224, 'lps'),
	(563665, 129, '2014-03-01 00:57:26.000000', 'consum', 0.0221, 'lps'),
	(563666, 129, '2014-03-01 00:57:27.000000', 'consum', 0.0226, 'lps'),
	(563667, 129, '2014-03-01 00:57:28.000000', 'consum', 0.0228, 'lps'),
	(563668, 129, '2014-03-01 00:57:29.000000', 'consum', 0.0225, 'lps'),
	(563669, 129, '2014-03-01 00:57:30.000000', 'consum', 0.0232, 'lps'),
	(563670, 129, '2014-03-01 00:57:31.000000', 'consum', 0.0217, 'lps'),
	(563671, 129, '2014-03-01 00:57:32.000000', 'consum', 0.0238, 'lps'),
	(563672, 129, '2014-03-01 00:57:33.000000', 'consum', 0.0211, 'lps'),
	(563673, 129, '2014-03-01 00:57:34.000000', 'consum', 0.0220, 'lps'),
	(563674, 129, '2014-03-01 00:57:35.000000', 'consum', 0.0226, 'lps'),
	(563675, 129, '2014-03-01 00:57:36.000000', 'consum', 0.0234, 'lps'),
	(563676, 129, '2014-03-01 00:57:37.000000', 'consum', 0.0224, 'lps'),
	(563677, 129, '2014-03-01 00:57:38.000000', 'consum', 0.0237, 'lps'),
	(563678, 129, '2014-03-01 00:57:39.000000', 'consum', 0.0216, 'lps'),
	(563679, 129, '2014-03-01 00:57:40.000000', 'consum', 0.0219, 'lps'),
	(563680, 129, '2014-03-01 00:57:41.000000', 'consum', 0.0237, 'lps'),
	(563681, 129, '2014-03-01 00:57:42.000000', 'consum', 0.0230, 'lps'),
	(563682, 129, '2014-03-01 00:57:43.000000', 'consum', 0.0231, 'lps'),
	(563683, 129, '2014-03-01 00:57:44.000000', 'consum', 0.0227, 'lps'),
	(563684, 129, '2014-03-01 00:57:45.000000', 'consum', 0.0232, 'lps'),
	(563685, 129, '2014-03-01 00:57:46.000000', 'consum', 0.0213, 'lps'),
	(563686, 129, '2014-03-01 00:57:47.000000', 'consum', 0.0218, 'lps'),
	(563687, 129, '2014-03-01 00:57:48.000000', 'consum', 0.0211, 'lps'),
	(563688, 129, '2014-03-01 00:57:49.000000', 'consum', 0.0220, 'lps'),
	(563689, 129, '2014-03-01 00:57:50.000000', 'consum', 0.0228, 'lps'),
	(563690, 129, '2014-03-01 00:57:51.000000', 'consum', 0.0212, 'lps'),
	(563691, 129, '2014-03-01 00:57:52.000000', 'consum', 0.0223, 'lps'),
	(563692, 129, '2014-03-01 00:57:53.000000', 'consum', 0.0214, 'lps'),
	(563693, 129, '2014-03-01 00:57:54.000000', 'consum', 0.0220, 'lps'),
	(563694, 129, '2014-03-01 00:57:55.000000', 'consum', 0.0221, 'lps'),
	(563695, 129, '2014-03-01 00:57:56.000000', 'consum', 0.0235, 'lps'),
	(563696, 129, '2014-03-01 00:57:57.000000', 'consum', 0.0217, 'lps'),
	(563697, 129, '2014-03-01 00:57:58.000000', 'consum', 0.0227, 'lps'),
	(563698, 129, '2014-03-01 00:57:59.000000', 'consum', 0.0218, 'lps'),
	(563699, 129, '2014-03-01 00:58:00.000000', 'consum', 0.0227, 'lps'),
	(563700, 129, '2014-03-01 00:58:01.000000', 'consum', 0.0212, 'lps'),
	(563701, 129, '2014-03-01 00:58:02.000000', 'consum', 0.0231, 'lps'),
	(563702, 129, '2014-03-01 00:58:03.000000', 'consum', 0.0220, 'lps'),
	(563703, 129, '2014-03-01 00:58:04.000000', 'consum', 0.0226, 'lps'),
	(563704, 129, '2014-03-01 00:58:05.000000', 'consum', 0.0231, 'lps'),
	(563705, 129, '2014-03-01 00:58:06.000000', 'consum', 0.0212, 'lps'),
	(563706, 129, '2014-03-01 00:58:07.000000', 'consum', 0.0216, 'lps'),
	(563707, 129, '2014-03-01 00:58:08.000000', 'consum', 0.0233, 'lps'),
	(563708, 129, '2014-03-01 00:58:09.000000', 'consum', 0.0220, 'lps'),
	(563709, 129, '2014-03-01 00:58:10.000000', 'consum', 0.0219, 'lps'),
	(563710, 129, '2014-03-01 00:58:11.000000', 'consum', 0.0228, 'lps'),
	(563711, 129, '2014-03-01 00:58:12.000000', 'consum', 0.0216, 'lps'),
	(563712, 129, '2014-03-01 00:58:13.000000', 'consum', 0.0213, 'lps'),
	(563713, 129, '2014-03-01 00:58:14.000000', 'consum', 0.0238, 'lps'),
	(563714, 129, '2014-03-01 00:58:15.000000', 'consum', 0.0224, 'lps'),
	(563715, 129, '2014-03-01 00:58:16.000000', 'consum', 0.0225, 'lps'),
	(563716, 129, '2014-03-01 00:58:17.000000', 'consum', 0.0218, 'lps'),
	(563717, 129, '2014-03-01 00:58:18.000000', 'consum', 0.0231, 'lps'),
	(563718, 129, '2014-03-01 00:58:19.000000', 'consum', 0.0234, 'lps'),
	(563719, 129, '2014-03-01 00:58:20.000000', 'consum', 0.0212, 'lps'),
	(563720, 129, '2014-03-01 00:58:21.000000', 'consum', 0.0234, 'lps'),
	(563721, 129, '2014-03-01 00:58:22.000000', 'consum', 0.0210, 'lps'),
	(563722, 129, '2014-03-01 00:58:23.000000', 'consum', 0.0224, 'lps'),
	(563723, 129, '2014-03-01 00:58:24.000000', 'consum', 0.0222, 'lps'),
	(563724, 129, '2014-03-01 00:58:25.000000', 'consum', 0.0230, 'lps'),
	(563725, 129, '2014-03-01 00:58:26.000000', 'consum', 0.0215, 'lps'),
	(563726, 129, '2014-03-01 00:58:27.000000', 'consum', 0.0235, 'lps'),
	(563727, 129, '2014-03-01 00:58:28.000000', 'consum', 0.0233, 'lps'),
	(563728, 129, '2014-03-01 00:58:29.000000', 'consum', 0.0223, 'lps'),
	(563729, 129, '2014-03-01 00:58:30.000000', 'consum', 0.0236, 'lps'),
	(563730, 129, '2014-03-01 00:58:31.000000', 'consum', 0.0212, 'lps'),
	(563731, 129, '2014-03-01 00:58:32.000000', 'consum', 0.0232, 'lps'),
	(563732, 129, '2014-03-01 00:58:33.000000', 'consum', 0.0225, 'lps'),
	(563733, 129, '2014-03-01 00:58:34.000000', 'consum', 0.0222, 'lps'),
	(563734, 129, '2014-03-01 00:58:35.000000', 'consum', 0.0222, 'lps'),
	(563735, 129, '2014-03-01 00:58:36.000000', 'consum', 0.0238, 'lps'),
	(563736, 129, '2014-03-01 00:58:37.000000', 'consum', 0.0228, 'lps'),
	(563737, 129, '2014-03-01 00:58:38.000000', 'consum', 0.0213, 'lps'),
	(563738, 129, '2014-03-01 00:58:39.000000', 'consum', 0.0233, 'lps'),
	(563739, 129, '2014-03-01 00:58:40.000000', 'consum', 0.0227, 'lps'),
	(563740, 129, '2014-03-01 00:58:41.000000', 'consum', 0.0227, 'lps'),
	(563741, 129, '2014-03-01 00:58:42.000000', 'consum', 0.0214, 'lps'),
	(563742, 129, '2014-03-01 00:58:43.000000', 'consum', 0.0237, 'lps'),
	(563743, 129, '2014-03-01 00:58:44.000000', 'consum', 0.0220, 'lps'),
	(563744, 129, '2014-03-01 00:58:45.000000', 'consum', 0.0237, 'lps'),
	(563745, 129, '2014-03-01 00:58:46.000000', 'consum', 0.0228, 'lps'),
	(563746, 129, '2014-03-01 00:58:47.000000', 'consum', 0.0220, 'lps'),
	(563747, 129, '2014-03-01 00:58:48.000000', 'consum', 0.0236, 'lps'),
	(563748, 129, '2014-03-01 00:58:49.000000', 'consum', 0.0223, 'lps'),
	(563749, 129, '2014-03-01 00:58:50.000000', 'consum', 0.0226, 'lps'),
	(563750, 129, '2014-03-01 00:58:51.000000', 'consum', 0.0223, 'lps'),
	(563751, 129, '2014-03-01 00:58:52.000000', 'consum', 0.0227, 'lps'),
	(563752, 129, '2014-03-01 00:58:53.000000', 'consum', 0.0229, 'lps'),
	(563753, 129, '2014-03-01 00:58:54.000000', 'consum', 0.0223, 'lps'),
	(563754, 129, '2014-03-01 00:58:55.000000', 'consum', 0.0221, 'lps'),
	(563755, 129, '2014-03-01 00:58:56.000000', 'consum', 0.0228, 'lps'),
	(563756, 129, '2014-03-01 00:58:57.000000', 'consum', 0.0235, 'lps'),
	(563757, 129, '2014-03-01 00:58:58.000000', 'consum', 0.0223, 'lps'),
	(563758, 129, '2014-03-01 00:58:59.000000', 'consum', 0.0232, 'lps'),
	(563759, 129, '2014-03-01 00:59:00.000000', 'consum', 0.0222, 'lps'),
	(563760, 129, '2014-03-01 00:59:01.000000', 'consum', 0.0235, 'lps'),
	(563761, 129, '2014-03-01 00:59:02.000000', 'consum', 0.0212, 'lps'),
	(563762, 129, '2014-03-01 00:59:03.000000', 'consum', 0.0233, 'lps'),
	(563763, 129, '2014-03-01 00:59:04.000000', 'consum', 0.0230, 'lps'),
	(563764, 129, '2014-03-01 00:59:05.000000', 'consum', 0.0215, 'lps'),
	(563765, 129, '2014-03-01 00:59:06.000000', 'consum', 0.0232, 'lps'),
	(563766, 129, '2014-03-01 00:59:07.000000', 'consum', 0.0219, 'lps'),
	(563767, 129, '2014-03-01 00:59:08.000000', 'consum', 0.0218, 'lps'),
	(563768, 129, '2014-03-01 00:59:09.000000', 'consum', 0.0223, 'lps'),
	(563769, 129, '2014-03-01 00:59:10.000000', 'consum', 0.0221, 'lps'),
	(563770, 129, '2014-03-01 00:59:11.000000', 'consum', 0.0230, 'lps'),
	(563771, 129, '2014-03-01 00:59:12.000000', 'consum', 0.0216, 'lps'),
	(563772, 129, '2014-03-01 00:59:13.000000', 'consum', 0.0212, 'lps'),
	(563773, 129, '2014-03-01 00:59:14.000000', 'consum', 0.0231, 'lps'),
	(563774, 129, '2014-03-01 00:59:15.000000', 'consum', 0.0222, 'lps'),
	(563775, 129, '2014-03-01 00:59:16.000000', 'consum', 0.0238, 'lps'),
	(563776, 129, '2014-03-01 00:59:17.000000', 'consum', 0.0227, 'lps'),
	(563777, 129, '2014-03-01 00:59:18.000000', 'consum', 0.0213, 'lps'),
	(563778, 129, '2014-03-01 00:59:19.000000', 'consum', 0.0231, 'lps'),
	(563779, 129, '2014-03-01 00:59:20.000000', 'consum', 0.0219, 'lps'),
	(563780, 129, '2014-03-01 00:59:21.000000', 'consum', 0.0222, 'lps'),
	(563781, 129, '2014-03-01 00:59:22.000000', 'consum', 0.0214, 'lps'),
	(563782, 129, '2014-03-01 00:59:23.000000', 'consum', 0.0223, 'lps'),
	(563783, 129, '2014-03-01 00:59:24.000000', 'consum', 0.0234, 'lps'),
	(563784, 129, '2014-03-01 00:59:25.000000', 'consum', 0.0232, 'lps'),
	(563785, 129, '2014-03-01 00:59:26.000000', 'consum', 0.0222, 'lps'),
	(563786, 129, '2014-03-01 00:59:27.000000', 'consum', 0.0233, 'lps'),
	(563787, 129, '2014-03-01 00:59:28.000000', 'consum', 0.0230, 'lps'),
	(563788, 129, '2014-03-01 00:59:29.000000', 'consum', 0.0215, 'lps'),
	(563789, 129, '2014-03-01 00:59:30.000000', 'consum', 0.0232, 'lps'),
	(563790, 129, '2014-03-01 00:59:31.000000', 'consum', 0.0221, 'lps'),
	(563791, 129, '2014-03-01 00:59:32.000000', 'consum', 0.0225, 'lps'),
	(563792, 129, '2014-03-01 00:59:33.000000', 'consum', 0.0226, 'lps'),
	(563793, 129, '2014-03-01 00:59:34.000000', 'consum', 0.0217, 'lps'),
	(563794, 129, '2014-03-01 00:59:35.000000', 'consum', 0.0227, 'lps'),
	(563795, 129, '2014-03-01 00:59:36.000000', 'consum', 0.0215, 'lps'),
	(563796, 129, '2014-03-01 00:59:37.000000', 'consum', 0.0215, 'lps'),
	(563797, 129, '2014-03-01 00:59:38.000000', 'consum', 0.0219, 'lps'),
	(563798, 129, '2014-03-01 00:59:39.000000', 'consum', 0.0213, 'lps'),
	(563799, 129, '2014-03-01 00:59:40.000000', 'consum', 0.0227, 'lps'),
	(563800, 129, '2014-03-01 00:59:41.000000', 'consum', 0.0228, 'lps'),
	(563801, 129, '2014-03-01 00:59:42.000000', 'consum', 0.0220, 'lps'),
	(563802, 129, '2014-03-01 00:59:43.000000', 'consum', 0.0235, 'lps'),
	(563803, 129, '2014-03-01 00:59:44.000000', 'consum', 0.0220, 'lps'),
	(563804, 129, '2014-03-01 00:59:45.000000', 'consum', 0.0215, 'lps'),
	(563805, 129, '2014-03-01 00:59:46.000000', 'consum', 0.0232, 'lps'),
	(563806, 129, '2014-03-01 00:59:47.000000', 'consum', 0.0218, 'lps'),
	(563807, 129, '2014-03-01 00:59:48.000000', 'consum', 0.0215, 'lps'),
	(563808, 129, '2014-03-01 00:59:49.000000', 'consum', 0.0212, 'lps'),
	(563809, 129, '2014-03-01 00:59:50.000000', 'consum', 0.0236, 'lps'),
	(563810, 129, '2014-03-01 00:59:51.000000', 'consum', 0.0216, 'lps'),
	(563811, 129, '2014-03-01 00:59:52.000000', 'consum', 0.0223, 'lps'),
	(563812, 129, '2014-03-01 00:59:53.000000', 'consum', 0.0228, 'lps'),
	(563813, 129, '2014-03-01 00:59:54.000000', 'consum', 0.0233, 'lps'),
	(563814, 129, '2014-03-01 00:59:55.000000', 'consum', 0.0212, 'lps'),
	(563815, 129, '2014-03-01 00:59:56.000000', 'consum', 0.0238, 'lps'),
	(563816, 129, '2014-03-01 00:59:57.000000', 'consum', 0.0231, 'lps'),
	(563817, 129, '2014-03-01 00:59:58.000000', 'consum', 0.0230, 'lps'),
	(563818, 129, '2014-03-01 00:59:59.000000', 'consum', 0.0221, 'lps'),
	(563819, 129, '2014-03-01 01:00:00.000000', 'consum', 0.0231, 'lps'),
	(563820, 129, '2014-03-01 01:00:01.000000', 'consum', 0.0226, 'lps'),
	(563821, 129, '2014-03-01 01:00:02.000000', 'consum', 0.0226, 'lps'),
	(563822, 129, '2014-03-01 01:00:03.000000', 'consum', 0.0214, 'lps'),
	(563823, 129, '2014-03-01 01:00:04.000000', 'consum', 0.0210, 'lps'),
	(563824, 129, '2014-03-01 01:00:05.000000', 'consum', 0.0229, 'lps'),
	(563825, 129, '2014-03-01 01:00:06.000000', 'consum', 0.0216, 'lps'),
	(563826, 129, '2014-03-01 01:00:07.000000', 'consum', 0.0215, 'lps'),
	(563827, 129, '2014-03-01 01:00:08.000000', 'consum', 0.0217, 'lps'),
	(563828, 129, '2014-03-01 01:00:09.000000', 'consum', 0.0231, 'lps'),
	(563829, 129, '2014-03-01 01:00:10.000000', 'consum', 0.0238, 'lps'),
	(563830, 129, '2014-03-01 01:00:11.000000', 'consum', 0.0228, 'lps'),
	(563831, 129, '2014-03-01 01:00:12.000000', 'consum', 0.0218, 'lps'),
	(563832, 129, '2014-03-01 01:00:13.000000', 'consum', 0.0224, 'lps'),
	(563833, 129, '2014-03-01 01:00:14.000000', 'consum', 0.0226, 'lps'),
	(563834, 129, '2014-03-01 01:00:15.000000', 'consum', 0.0222, 'lps'),
	(563835, 129, '2014-03-01 01:00:16.000000', 'consum', 0.0221, 'lps'),
	(563836, 129, '2014-03-01 01:00:17.000000', 'consum', 0.0230, 'lps'),
	(563837, 129, '2014-03-01 01:00:18.000000', 'consum', 0.0221, 'lps'),
	(563838, 129, '2014-03-01 01:00:19.000000', 'consum', 0.0231, 'lps'),
	(563839, 129, '2014-03-01 01:00:20.000000', 'consum', 0.0228, 'lps'),
	(563840, 129, '2014-03-01 01:00:21.000000', 'consum', 0.0237, 'lps'),
	(563841, 129, '2014-03-01 01:00:22.000000', 'consum', 0.0232, 'lps'),
	(563842, 129, '2014-03-01 01:00:23.000000', 'consum', 0.0211, 'lps'),
	(563843, 129, '2014-03-01 01:00:24.000000', 'consum', 0.0237, 'lps'),
	(563844, 129, '2014-03-01 01:00:25.000000', 'consum', 0.0225, 'lps'),
	(563845, 129, '2014-03-01 01:00:26.000000', 'consum', 0.0236, 'lps'),
	(563846, 129, '2014-03-01 01:00:27.000000', 'consum', 0.0235, 'lps'),
	(563847, 129, '2014-03-01 01:00:28.000000', 'consum', 0.0229, 'lps'),
	(563848, 129, '2014-03-01 01:00:29.000000', 'consum', 0.0230, 'lps'),
	(563849, 129, '2014-03-01 01:00:30.000000', 'consum', 0.0227, 'lps'),
	(563850, 129, '2014-03-01 01:00:31.000000', 'consum', 0.0234, 'lps'),
	(563851, 129, '2014-03-01 01:00:32.000000', 'consum', 0.0220, 'lps'),
	(563852, 129, '2014-03-01 01:00:33.000000', 'consum', 0.0219, 'lps'),
	(563853, 129, '2014-03-01 01:00:34.000000', 'consum', 0.0226, 'lps'),
	(563854, 129, '2014-03-01 01:00:35.000000', 'consum', 0.0236, 'lps'),
	(563855, 129, '2014-03-01 01:00:36.000000', 'consum', 0.0233, 'lps'),
	(563856, 129, '2014-03-01 01:00:37.000000', 'consum', 0.0217, 'lps'),
	(563857, 129, '2014-03-01 01:00:38.000000', 'consum', 0.0236, 'lps'),
	(563858, 129, '2014-03-01 01:00:39.000000', 'consum', 0.0232, 'lps'),
	(563859, 129, '2014-03-01 01:00:40.000000', 'consum', 0.0214, 'lps'),
	(563860, 129, '2014-03-01 01:00:41.000000', 'consum', 0.0224, 'lps'),
	(563861, 129, '2014-03-01 01:00:42.000000', 'consum', 0.0210, 'lps'),
	(563862, 129, '2014-03-01 01:00:43.000000', 'consum', 0.0225, 'lps'),
	(563863, 129, '2014-03-01 01:00:44.000000', 'consum', 0.0229, 'lps'),
	(563864, 129, '2014-03-01 01:00:45.000000', 'consum', 0.0229, 'lps'),
	(563865, 129, '2014-03-01 01:00:46.000000', 'consum', 0.0223, 'lps'),
	(563866, 129, '2014-03-01 01:00:47.000000', 'consum', 0.0217, 'lps'),
	(563867, 129, '2014-03-01 01:00:48.000000', 'consum', 0.0235, 'lps'),
	(563868, 129, '2014-03-01 01:00:49.000000', 'consum', 0.0227, 'lps'),
	(563869, 129, '2014-03-01 01:00:50.000000', 'consum', 0.0220, 'lps'),
	(563870, 129, '2014-03-01 01:00:51.000000', 'consum', 0.0237, 'lps'),
	(563871, 129, '2014-03-01 01:00:52.000000', 'consum', 0.0231, 'lps'),
	(563872, 129, '2014-03-01 01:00:53.000000', 'consum', 0.0235, 'lps'),
	(563873, 129, '2014-03-01 01:00:54.000000', 'consum', 0.0215, 'lps'),
	(563874, 129, '2014-03-01 01:00:55.000000', 'consum', 0.0216, 'lps'),
	(563875, 129, '2014-03-01 01:00:56.000000', 'consum', 0.0229, 'lps'),
	(563876, 129, '2014-03-01 01:00:57.000000', 'consum', 0.0226, 'lps'),
	(563877, 129, '2014-03-01 01:00:58.000000', 'consum', 0.0236, 'lps'),
	(563878, 129, '2014-03-01 01:00:59.000000', 'consum', 0.0233, 'lps'),
	(563879, 129, '2014-03-01 01:01:00.000000', 'consum', 0.0219, 'lps'),
	(563880, 129, '2014-03-01 01:01:01.000000', 'consum', 0.0215, 'lps'),
	(563881, 129, '2014-03-01 01:01:02.000000', 'consum', 0.0238, 'lps'),
	(563882, 129, '2014-03-01 01:01:03.000000', 'consum', 0.0218, 'lps'),
	(563883, 129, '2014-03-01 01:01:04.000000', 'consum', 0.0226, 'lps'),
	(563884, 129, '2014-03-01 01:01:05.000000', 'consum', 0.0237, 'lps'),
	(563885, 129, '2014-03-01 01:01:06.000000', 'consum', 0.0212, 'lps'),
	(563886, 129, '2014-03-01 01:01:07.000000', 'consum', 0.0227, 'lps'),
	(563887, 129, '2014-03-01 01:01:08.000000', 'consum', 0.0231, 'lps'),
	(563888, 129, '2014-03-01 01:01:09.000000', 'consum', 0.0235, 'lps'),
	(563889, 129, '2014-03-01 01:01:10.000000', 'consum', 0.0214, 'lps'),
	(563890, 129, '2014-03-01 01:01:11.000000', 'consum', 0.0215, 'lps'),
	(563891, 129, '2014-03-01 01:01:12.000000', 'consum', 0.0221, 'lps'),
	(563892, 129, '2014-03-01 01:01:13.000000', 'consum', 0.0224, 'lps'),
	(563893, 129, '2014-03-01 01:01:14.000000', 'consum', 0.0220, 'lps'),
	(563894, 129, '2014-03-01 01:01:15.000000', 'consum', 0.0215, 'lps'),
	(563895, 129, '2014-03-01 01:01:16.000000', 'consum', 0.0237, 'lps'),
	(563896, 129, '2014-03-01 01:01:17.000000', 'consum', 0.0214, 'lps'),
	(563897, 129, '2014-03-01 01:01:18.000000', 'consum', 0.0238, 'lps'),
	(563898, 129, '2014-03-01 01:01:19.000000', 'consum', 0.0220, 'lps'),
	(563899, 129, '2014-03-01 01:01:20.000000', 'consum', 0.0236, 'lps'),
	(563900, 129, '2014-03-01 01:01:21.000000', 'consum', 0.0223, 'lps'),
	(563901, 129, '2014-03-01 01:01:22.000000', 'consum', 0.0227, 'lps'),
	(563902, 129, '2014-03-01 01:01:23.000000', 'consum', 0.0227, 'lps'),
	(563903, 129, '2014-03-01 01:01:24.000000', 'consum', 0.0215, 'lps'),
	(563904, 129, '2014-03-01 01:01:25.000000', 'consum', 0.0212, 'lps'),
	(563905, 129, '2014-03-01 01:01:26.000000', 'consum', 0.0237, 'lps'),
	(563906, 129, '2014-03-01 01:01:27.000000', 'consum', 0.0223, 'lps'),
	(563907, 129, '2014-03-01 01:01:28.000000', 'consum', 0.0225, 'lps'),
	(563908, 129, '2014-03-01 01:01:29.000000', 'consum', 0.0216, 'lps'),
	(563909, 129, '2014-03-01 01:01:30.000000', 'consum', 0.0224, 'lps'),
	(563910, 129, '2014-03-01 01:01:31.000000', 'consum', 0.0235, 'lps'),
	(563911, 129, '2014-03-01 01:01:32.000000', 'consum', 0.0234, 'lps'),
	(563912, 129, '2014-03-01 01:01:33.000000', 'consum', 0.0229, 'lps'),
	(563913, 129, '2014-03-01 01:01:34.000000', 'consum', 0.0231, 'lps'),
	(563914, 129, '2014-03-01 01:01:35.000000', 'consum', 0.0229, 'lps'),
	(563915, 129, '2014-03-01 01:01:36.000000', 'consum', 0.0216, 'lps'),
	(563916, 129, '2014-03-01 01:01:37.000000', 'consum', 0.0213, 'lps'),
	(563917, 129, '2014-03-01 01:01:38.000000', 'consum', 0.0235, 'lps'),
	(563918, 129, '2014-03-01 01:01:39.000000', 'consum', 0.0210, 'lps'),
	(563919, 129, '2014-03-01 01:01:40.000000', 'consum', 0.0224, 'lps'),
	(563920, 129, '2014-03-01 01:01:41.000000', 'consum', 0.0221, 'lps'),
	(563921, 129, '2014-03-01 01:01:42.000000', 'consum', 0.0225, 'lps'),
	(563922, 129, '2014-03-01 01:01:43.000000', 'consum', 0.0222, 'lps'),
	(563923, 129, '2014-03-01 01:01:44.000000', 'consum', 0.0227, 'lps'),
	(563924, 129, '2014-03-01 01:01:45.000000', 'consum', 0.0231, 'lps'),
	(563925, 129, '2014-03-01 01:01:46.000000', 'consum', 0.0236, 'lps'),
	(563926, 129, '2014-03-01 01:01:47.000000', 'consum', 0.0218, 'lps'),
	(563927, 129, '2014-03-01 01:01:48.000000', 'consum', 0.0233, 'lps'),
	(563928, 129, '2014-03-01 01:01:49.000000', 'consum', 0.0213, 'lps'),
	(563929, 129, '2014-03-01 01:01:50.000000', 'consum', 0.0214, 'lps'),
	(563930, 129, '2014-03-01 01:01:51.000000', 'consum', 0.0224, 'lps'),
	(563931, 129, '2014-03-01 01:01:52.000000', 'consum', 0.0237, 'lps'),
	(563932, 129, '2014-03-01 01:01:53.000000', 'consum', 0.0219, 'lps'),
	(563933, 129, '2014-03-01 01:01:54.000000', 'consum', 0.0232, 'lps'),
	(563934, 129, '2014-03-01 01:01:55.000000', 'consum', 0.0237, 'lps'),
	(563935, 129, '2014-03-01 01:01:56.000000', 'consum', 0.0219, 'lps'),
	(563936, 129, '2014-03-01 01:01:57.000000', 'consum', 0.0233, 'lps'),
	(563937, 129, '2014-03-01 01:01:58.000000', 'consum', 0.0214, 'lps'),
	(563938, 129, '2014-03-01 01:01:59.000000', 'consum', 0.0217, 'lps'),
	(563939, 129, '2014-03-01 01:02:00.000000', 'consum', 0.0232, 'lps'),
	(563940, 129, '2014-03-01 01:02:01.000000', 'consum', 0.0215, 'lps'),
	(563941, 129, '2014-03-01 01:02:02.000000', 'consum', 0.0225, 'lps'),
	(563942, 129, '2014-03-01 01:02:03.000000', 'consum', 0.0215, 'lps'),
	(563943, 129, '2014-03-01 01:02:04.000000', 'consum', 0.0217, 'lps'),
	(563944, 129, '2014-03-01 01:02:05.000000', 'consum', 0.0230, 'lps'),
	(563945, 129, '2014-03-01 01:02:06.000000', 'consum', 0.0234, 'lps'),
	(563946, 129, '2014-03-01 01:02:07.000000', 'consum', 0.0210, 'lps'),
	(563947, 129, '2014-03-01 01:02:08.000000', 'consum', 0.0225, 'lps'),
	(563948, 129, '2014-03-01 01:02:09.000000', 'consum', 0.0230, 'lps'),
	(563949, 129, '2014-03-01 01:02:10.000000', 'consum', 0.0236, 'lps'),
	(563950, 129, '2014-03-01 01:02:11.000000', 'consum', 0.0224, 'lps'),
	(563951, 129, '2014-03-01 01:02:12.000000', 'consum', 0.0229, 'lps'),
	(563952, 129, '2014-03-01 01:02:13.000000', 'consum', 0.0237, 'lps'),
	(563953, 129, '2014-03-01 01:02:14.000000', 'consum', 0.0228, 'lps'),
	(563954, 129, '2014-03-01 01:02:15.000000', 'consum', 0.0220, 'lps'),
	(563955, 129, '2014-03-01 01:02:16.000000', 'consum', 0.0235, 'lps'),
	(563956, 129, '2014-03-01 01:02:17.000000', 'consum', 0.0220, 'lps'),
	(563957, 129, '2014-03-01 01:02:18.000000', 'consum', 0.0215, 'lps'),
	(563958, 129, '2014-03-01 01:02:19.000000', 'consum', 0.0234, 'lps'),
	(563959, 129, '2014-03-01 01:02:20.000000', 'consum', 0.0230, 'lps'),
	(563960, 129, '2014-03-01 01:02:21.000000', 'consum', 0.0237, 'lps'),
	(563961, 129, '2014-03-01 01:02:22.000000', 'consum', 0.0226, 'lps'),
	(563962, 129, '2014-03-01 01:02:23.000000', 'consum', 0.0238, 'lps'),
	(563963, 129, '2014-03-01 01:02:24.000000', 'consum', 0.0217, 'lps'),
	(563964, 129, '2014-03-01 01:02:25.000000', 'consum', 0.0220, 'lps'),
	(563965, 129, '2014-03-01 01:02:26.000000', 'consum', 0.0237, 'lps'),
	(563966, 129, '2014-03-01 01:02:27.000000', 'consum', 0.0229, 'lps'),
	(563967, 129, '2014-03-01 01:02:28.000000', 'consum', 0.0226, 'lps'),
	(563968, 129, '2014-03-01 01:02:29.000000', 'consum', 0.0235, 'lps'),
	(563969, 129, '2014-03-01 01:02:30.000000', 'consum', 0.0228, 'lps'),
	(563970, 129, '2014-03-01 01:02:31.000000', 'consum', 0.0224, 'lps'),
	(563971, 129, '2014-03-01 01:02:32.000000', 'consum', 0.0227, 'lps'),
	(563972, 129, '2014-03-01 01:02:33.000000', 'consum', 0.0226, 'lps'),
	(563973, 129, '2014-03-01 01:02:34.000000', 'consum', 0.0238, 'lps'),
	(563974, 129, '2014-03-01 01:02:35.000000', 'consum', 0.0214, 'lps'),
	(563975, 129, '2014-03-01 01:02:36.000000', 'consum', 0.0237, 'lps'),
	(563976, 129, '2014-03-01 01:02:37.000000', 'consum', 0.0214, 'lps'),
	(563977, 129, '2014-03-01 01:02:38.000000', 'consum', 0.0210, 'lps'),
	(563978, 129, '2014-03-01 01:02:39.000000', 'consum', 0.0228, 'lps'),
	(563979, 129, '2014-03-01 01:02:40.000000', 'consum', 0.0214, 'lps'),
	(563980, 129, '2014-03-01 01:02:41.000000', 'consum', 0.0233, 'lps'),
	(563981, 129, '2014-03-01 01:02:42.000000', 'consum', 0.0229, 'lps'),
	(563982, 129, '2014-03-01 01:02:43.000000', 'consum', 0.0234, 'lps'),
	(563983, 129, '2014-03-01 01:02:44.000000', 'consum', 0.0216, 'lps'),
	(563984, 129, '2014-03-01 01:02:45.000000', 'consum', 0.0227, 'lps'),
	(563985, 129, '2014-03-01 01:02:46.000000', 'consum', 0.0219, 'lps'),
	(563986, 129, '2014-03-01 01:02:47.000000', 'consum', 0.0235, 'lps'),
	(563987, 129, '2014-03-01 01:02:48.000000', 'consum', 0.0221, 'lps'),
	(563988, 129, '2014-03-01 01:02:49.000000', 'consum', 0.0218, 'lps'),
	(563989, 129, '2014-03-01 01:02:50.000000', 'consum', 0.0219, 'lps'),
	(563990, 129, '2014-03-01 01:02:51.000000', 'consum', 0.0229, 'lps'),
	(563991, 129, '2014-03-01 01:02:52.000000', 'consum', 0.0223, 'lps'),
	(563992, 129, '2014-03-01 01:02:53.000000', 'consum', 0.0219, 'lps'),
	(563993, 129, '2014-03-01 01:02:54.000000', 'consum', 0.0217, 'lps'),
	(563994, 129, '2014-03-01 01:02:55.000000', 'consum', 0.0218, 'lps'),
	(563995, 129, '2014-03-01 01:02:56.000000', 'consum', 0.0230, 'lps'),
	(563996, 129, '2014-03-01 01:02:57.000000', 'consum', 0.0227, 'lps'),
	(563997, 129, '2014-03-01 01:02:58.000000', 'consum', 0.0236, 'lps'),
	(563998, 129, '2014-03-01 01:02:59.000000', 'consum', 0.0231, 'lps'),
	(563999, 129, '2014-03-01 01:03:00.000000', 'consum', 0.0237, 'lps'),
	(564000, 129, '2014-03-01 01:03:01.000000', 'consum', 0.0223, 'lps'),
	(564001, 129, '2014-03-01 01:03:02.000000', 'consum', 0.0226, 'lps'),
	(564002, 129, '2014-03-01 01:03:03.000000', 'consum', 0.0221, 'lps'),
	(564003, 129, '2014-03-01 01:03:04.000000', 'consum', 0.0217, 'lps'),
	(564004, 129, '2014-03-01 01:03:05.000000', 'consum', 0.0214, 'lps'),
	(564005, 129, '2014-03-01 01:03:06.000000', 'consum', 0.0238, 'lps'),
	(564006, 129, '2014-03-01 01:03:07.000000', 'consum', 0.0221, 'lps'),
	(564007, 129, '2014-03-01 01:03:08.000000', 'consum', 0.0212, 'lps'),
	(564008, 129, '2014-03-01 01:03:09.000000', 'consum', 0.0216, 'lps'),
	(564009, 129, '2014-03-01 01:03:10.000000', 'consum', 0.0234, 'lps'),
	(564010, 129, '2014-03-01 01:03:11.000000', 'consum', 0.0225, 'lps'),
	(564011, 129, '2014-03-01 01:03:12.000000', 'consum', 0.0215, 'lps'),
	(564012, 129, '2014-03-01 01:03:13.000000', 'consum', 0.0218, 'lps'),
	(564013, 129, '2014-03-01 01:03:14.000000', 'consum', 0.0235, 'lps'),
	(564014, 129, '2014-03-01 01:03:15.000000', 'consum', 0.0224, 'lps'),
	(564015, 129, '2014-03-01 01:03:16.000000', 'consum', 0.0235, 'lps'),
	(564016, 129, '2014-03-01 01:03:17.000000', 'consum', 0.0238, 'lps'),
	(564017, 129, '2014-03-01 01:03:18.000000', 'consum', 0.0215, 'lps'),
	(564018, 129, '2014-03-01 01:03:19.000000', 'consum', 0.0210, 'lps'),
	(564019, 129, '2014-03-01 01:03:20.000000', 'consum', 0.0225, 'lps'),
	(564020, 129, '2014-03-01 01:03:21.000000', 'consum', 0.0229, 'lps'),
	(564021, 129, '2014-03-01 01:03:22.000000', 'consum', 0.0229, 'lps'),
	(564022, 129, '2014-03-01 01:03:23.000000', 'consum', 0.0219, 'lps'),
	(564023, 129, '2014-03-01 01:03:24.000000', 'consum', 0.0227, 'lps'),
	(564024, 129, '2014-03-01 01:03:25.000000', 'consum', 0.0210, 'lps'),
	(564025, 129, '2014-03-01 01:03:26.000000', 'consum', 0.0220, 'lps'),
	(564026, 129, '2014-03-01 01:03:27.000000', 'consum', 0.0229, 'lps'),
	(564027, 129, '2014-03-01 01:03:28.000000', 'consum', 0.0219, 'lps'),
	(564028, 129, '2014-03-01 01:03:29.000000', 'consum', 0.0228, 'lps'),
	(564029, 129, '2014-03-01 01:03:30.000000', 'consum', 0.0215, 'lps'),
	(564030, 129, '2014-03-01 01:03:31.000000', 'consum', 0.0212, 'lps'),
	(564031, 129, '2014-03-01 01:03:32.000000', 'consum', 0.0235, 'lps'),
	(564032, 129, '2014-03-01 01:03:33.000000', 'consum', 0.0213, 'lps'),
	(564033, 129, '2014-03-01 01:03:34.000000', 'consum', 0.0235, 'lps'),
	(564034, 129, '2014-03-01 01:03:35.000000', 'consum', 0.0212, 'lps'),
	(564035, 129, '2014-03-01 01:03:36.000000', 'consum', 0.0233, 'lps'),
	(564036, 129, '2014-03-01 01:03:37.000000', 'consum', 0.0234, 'lps'),
	(564037, 129, '2014-03-01 01:03:38.000000', 'consum', 0.0231, 'lps'),
	(564038, 129, '2014-03-01 01:03:39.000000', 'consum', 0.0214, 'lps'),
	(564039, 129, '2014-03-01 01:03:40.000000', 'consum', 0.0226, 'lps'),
	(564040, 129, '2014-03-01 01:03:41.000000', 'consum', 0.0219, 'lps'),
	(564041, 129, '2014-03-01 01:03:42.000000', 'consum', 0.0210, 'lps'),
	(564042, 129, '2014-03-01 01:03:43.000000', 'consum', 0.0210, 'lps'),
	(564043, 129, '2014-03-01 01:03:44.000000', 'consum', 0.0213, 'lps'),
	(564044, 129, '2014-03-01 01:03:45.000000', 'consum', 0.0222, 'lps'),
	(564045, 129, '2014-03-01 01:03:46.000000', 'consum', 0.0236, 'lps'),
	(564046, 129, '2014-03-01 01:03:47.000000', 'consum', 0.0218, 'lps'),
	(564047, 129, '2014-03-01 01:03:48.000000', 'consum', 0.0228, 'lps'),
	(564048, 129, '2014-03-01 01:03:49.000000', 'consum', 0.0220, 'lps'),
	(564049, 129, '2014-03-01 01:03:50.000000', 'consum', 0.0237, 'lps'),
	(564050, 129, '2014-03-01 01:03:51.000000', 'consum', 0.0226, 'lps'),
	(564051, 129, '2014-03-01 01:03:52.000000', 'consum', 0.0238, 'lps'),
	(564052, 129, '2014-03-01 01:03:53.000000', 'consum', 0.0218, 'lps'),
	(564053, 129, '2014-03-01 01:03:54.000000', 'consum', 0.0222, 'lps'),
	(564054, 129, '2014-03-01 01:03:55.000000', 'consum', 0.0218, 'lps'),
	(564055, 129, '2014-03-01 01:03:56.000000', 'consum', 0.0215, 'lps'),
	(564056, 129, '2014-03-01 01:03:57.000000', 'consum', 0.0213, 'lps'),
	(564057, 129, '2014-03-01 01:03:58.000000', 'consum', 0.0211, 'lps'),
	(564058, 129, '2014-03-01 01:03:59.000000', 'consum', 0.0235, 'lps'),
	(564059, 129, '2014-03-01 01:04:00.000000', 'consum', 0.0217, 'lps'),
	(564060, 129, '2014-03-01 01:04:01.000000', 'consum', 0.0227, 'lps'),
	(564061, 129, '2014-03-01 01:04:02.000000', 'consum', 0.0217, 'lps'),
	(564062, 129, '2014-03-01 01:04:03.000000', 'consum', 0.0224, 'lps'),
	(564063, 129, '2014-03-01 01:04:04.000000', 'consum', 0.0230, 'lps'),
	(564064, 129, '2014-03-01 01:04:05.000000', 'consum', 0.0212, 'lps'),
	(564065, 129, '2014-03-01 01:04:06.000000', 'consum', 0.0218, 'lps'),
	(564066, 129, '2014-03-01 01:04:07.000000', 'consum', 0.0214, 'lps'),
	(564067, 129, '2014-03-01 01:04:08.000000', 'consum', 0.0237, 'lps'),
	(564068, 129, '2014-03-01 01:04:09.000000', 'consum', 0.0218, 'lps'),
	(564069, 129, '2014-03-01 01:04:10.000000', 'consum', 0.0226, 'lps'),
	(564070, 129, '2014-03-01 01:04:11.000000', 'consum', 0.0210, 'lps'),
	(564071, 129, '2014-03-01 01:04:12.000000', 'consum', 0.0219, 'lps'),
	(564072, 129, '2014-03-01 01:04:13.000000', 'consum', 0.0229, 'lps'),
	(564073, 129, '2014-03-01 01:04:14.000000', 'consum', 0.0218, 'lps'),
	(564074, 129, '2014-03-01 01:04:15.000000', 'consum', 0.0224, 'lps'),
	(564075, 129, '2014-03-01 01:04:16.000000', 'consum', 0.0225, 'lps'),
	(564076, 129, '2014-03-01 01:04:17.000000', 'consum', 0.0218, 'lps'),
	(564077, 129, '2014-03-01 01:04:18.000000', 'consum', 0.0233, 'lps'),
	(564078, 129, '2014-03-01 01:04:19.000000', 'consum', 0.0213, 'lps'),
	(564079, 129, '2014-03-01 01:04:20.000000', 'consum', 0.0215, 'lps'),
	(564080, 129, '2014-03-01 01:04:21.000000', 'consum', 0.0228, 'lps'),
	(564081, 129, '2014-03-01 01:04:22.000000', 'consum', 0.0227, 'lps'),
	(564082, 129, '2014-03-01 01:04:23.000000', 'consum', 0.0214, 'lps'),
	(564083, 129, '2014-03-01 01:04:24.000000', 'consum', 0.0238, 'lps'),
	(564084, 129, '2014-03-01 01:04:25.000000', 'consum', 0.0221, 'lps'),
	(564085, 129, '2014-03-01 01:04:26.000000', 'consum', 0.0238, 'lps'),
	(564086, 129, '2014-03-01 01:04:27.000000', 'consum', 0.0233, 'lps'),
	(564087, 129, '2014-03-01 01:04:28.000000', 'consum', 0.0213, 'lps'),
	(564088, 129, '2014-03-01 01:04:29.000000', 'consum', 0.0215, 'lps'),
	(564089, 129, '2014-03-01 01:04:30.000000', 'consum', 0.0226, 'lps'),
	(564090, 129, '2014-03-01 01:04:31.000000', 'consum', 0.0217, 'lps'),
	(564091, 129, '2014-03-01 01:04:32.000000', 'consum', 0.0225, 'lps'),
	(564092, 129, '2014-03-01 01:04:33.000000', 'consum', 0.0235, 'lps'),
	(564093, 129, '2014-03-01 01:04:34.000000', 'consum', 0.0232, 'lps'),
	(564094, 129, '2014-03-01 01:04:35.000000', 'consum', 0.0217, 'lps'),
	(564095, 129, '2014-03-01 01:04:36.000000', 'consum', 0.0238, 'lps'),
	(564096, 129, '2014-03-01 01:04:37.000000', 'consum', 0.0215, 'lps'),
	(564097, 129, '2014-03-01 01:04:38.000000', 'consum', 0.0237, 'lps'),
	(564098, 129, '2014-03-01 01:04:39.000000', 'consum', 0.0213, 'lps'),
	(564099, 129, '2014-03-01 01:04:40.000000', 'consum', 0.0234, 'lps'),
	(564100, 129, '2014-03-01 01:04:41.000000', 'consum', 0.0233, 'lps'),
	(564101, 129, '2014-03-01 01:04:42.000000', 'consum', 0.0226, 'lps'),
	(564102, 129, '2014-03-01 01:04:43.000000', 'consum', 0.0219, 'lps'),
	(564103, 129, '2014-03-01 01:04:44.000000', 'consum', 0.0238, 'lps'),
	(564104, 129, '2014-03-01 01:04:45.000000', 'consum', 0.0238, 'lps'),
	(564105, 129, '2014-03-01 01:04:46.000000', 'consum', 0.0236, 'lps'),
	(564106, 129, '2014-03-01 01:04:47.000000', 'consum', 0.0227, 'lps'),
	(564107, 129, '2014-03-01 01:04:48.000000', 'consum', 0.0219, 'lps'),
	(564108, 129, '2014-03-01 01:04:49.000000', 'consum', 0.0231, 'lps'),
	(564109, 129, '2014-03-01 01:04:50.000000', 'consum', 0.0231, 'lps'),
	(564110, 129, '2014-03-01 01:04:51.000000', 'consum', 0.0222, 'lps'),
	(564111, 129, '2014-03-01 01:04:52.000000', 'consum', 0.0210, 'lps'),
	(564112, 129, '2014-03-01 01:04:53.000000', 'consum', 0.0232, 'lps'),
	(564113, 129, '2014-03-01 01:04:54.000000', 'consum', 0.0232, 'lps'),
	(564114, 129, '2014-03-01 01:04:55.000000', 'consum', 0.0227, 'lps'),
	(564115, 129, '2014-03-01 01:04:56.000000', 'consum', 0.0231, 'lps'),
	(564116, 129, '2014-03-01 01:04:57.000000', 'consum', 0.0235, 'lps'),
	(564117, 129, '2014-03-01 01:04:58.000000', 'consum', 0.0214, 'lps'),
	(564118, 129, '2014-03-01 01:04:59.000000', 'consum', 0.0213, 'lps'),
	(564119, 129, '2014-03-01 01:05:00.000000', 'consum', 0.0214, 'lps'),
	(564120, 129, '2014-03-01 01:05:01.000000', 'consum', 0.0220, 'lps'),
	(564121, 129, '2014-03-01 01:05:02.000000', 'consum', 0.0223, 'lps'),
	(564122, 129, '2014-03-01 01:05:03.000000', 'consum', 0.0213, 'lps'),
	(564123, 129, '2014-03-01 01:05:04.000000', 'consum', 0.0217, 'lps'),
	(564124, 129, '2014-03-01 01:05:05.000000', 'consum', 0.0234, 'lps'),
	(564125, 129, '2014-03-01 01:05:06.000000', 'consum', 0.0226, 'lps'),
	(564126, 129, '2014-03-01 01:05:07.000000', 'consum', 0.0217, 'lps'),
	(564127, 129, '2014-03-01 01:05:08.000000', 'consum', 0.0225, 'lps'),
	(564128, 129, '2014-03-01 01:05:09.000000', 'consum', 0.0235, 'lps'),
	(564129, 129, '2014-03-01 01:05:10.000000', 'consum', 0.0232, 'lps'),
	(564130, 129, '2014-03-01 01:05:11.000000', 'consum', 0.0219, 'lps'),
	(564131, 129, '2014-03-01 01:05:12.000000', 'consum', 0.0217, 'lps'),
	(564132, 129, '2014-03-01 01:05:13.000000', 'consum', 0.0219, 'lps'),
	(564133, 129, '2014-03-01 01:05:14.000000', 'consum', 0.0237, 'lps'),
	(564134, 129, '2014-03-01 01:05:15.000000', 'consum', 0.0228, 'lps'),
	(564135, 129, '2014-03-01 01:05:16.000000', 'consum', 0.0220, 'lps'),
	(564136, 129, '2014-03-01 01:05:17.000000', 'consum', 0.0236, 'lps'),
	(564137, 129, '2014-03-01 01:05:18.000000', 'consum', 0.0223, 'lps'),
	(564138, 129, '2014-03-01 01:05:19.000000', 'consum', 0.0227, 'lps'),
	(564139, 129, '2014-03-01 01:05:20.000000', 'consum', 0.0229, 'lps'),
	(564140, 129, '2014-03-01 01:05:21.000000', 'consum', 0.0226, 'lps'),
	(564141, 129, '2014-03-01 01:05:22.000000', 'consum', 0.0231, 'lps'),
	(564142, 129, '2014-03-01 01:05:23.000000', 'consum', 0.0237, 'lps'),
	(564143, 129, '2014-03-01 01:05:24.000000', 'consum', 0.0228, 'lps'),
	(564144, 129, '2014-03-01 01:05:25.000000', 'consum', 0.0219, 'lps'),
	(564145, 129, '2014-03-01 01:05:26.000000', 'consum', 0.0230, 'lps'),
	(564146, 129, '2014-03-01 01:05:27.000000', 'consum', 0.0226, 'lps'),
	(564147, 129, '2014-03-01 01:05:28.000000', 'consum', 0.0232, 'lps'),
	(564148, 129, '2014-03-01 01:05:29.000000', 'consum', 0.0211, 'lps'),
	(564149, 129, '2014-03-01 01:05:30.000000', 'consum', 0.0238, 'lps'),
	(564150, 129, '2014-03-01 01:05:31.000000', 'consum', 0.0234, 'lps'),
	(564151, 129, '2014-03-01 01:05:32.000000', 'consum', 0.0214, 'lps'),
	(564152, 129, '2014-03-01 01:05:33.000000', 'consum', 0.0219, 'lps'),
	(564153, 129, '2014-03-01 01:05:34.000000', 'consum', 0.0214, 'lps'),
	(564154, 129, '2014-03-01 01:05:35.000000', 'consum', 0.0232, 'lps'),
	(564155, 129, '2014-03-01 01:05:36.000000', 'consum', 0.0220, 'lps'),
	(564156, 129, '2014-03-01 01:05:37.000000', 'consum', 0.0226, 'lps'),
	(564157, 129, '2014-03-01 01:05:38.000000', 'consum', 0.0230, 'lps'),
	(564158, 129, '2014-03-01 01:05:39.000000', 'consum', 0.0232, 'lps'),
	(564159, 129, '2014-03-01 01:05:40.000000', 'consum', 0.0234, 'lps'),
	(564160, 129, '2014-03-01 01:05:41.000000', 'consum', 0.0237, 'lps'),
	(564161, 129, '2014-03-01 01:05:42.000000', 'consum', 0.0212, 'lps'),
	(564162, 129, '2014-03-01 01:05:43.000000', 'consum', 0.0229, 'lps'),
	(564163, 129, '2014-03-01 01:05:44.000000', 'consum', 0.0211, 'lps'),
	(564164, 129, '2014-03-01 01:05:45.000000', 'consum', 0.0218, 'lps'),
	(564165, 129, '2014-03-01 01:05:46.000000', 'consum', 0.0216, 'lps'),
	(564166, 129, '2014-03-01 01:05:47.000000', 'consum', 0.0217, 'lps'),
	(564167, 129, '2014-03-01 01:05:48.000000', 'consum', 0.0227, 'lps'),
	(564168, 129, '2014-03-01 01:05:49.000000', 'consum', 0.0218, 'lps'),
	(564169, 129, '2014-03-01 01:05:50.000000', 'consum', 0.0228, 'lps'),
	(564170, 129, '2014-03-01 01:05:51.000000', 'consum', 0.0217, 'lps'),
	(564171, 129, '2014-03-01 01:05:52.000000', 'consum', 0.0220, 'lps'),
	(564172, 129, '2014-03-01 01:05:53.000000', 'consum', 0.0212, 'lps'),
	(564173, 129, '2014-03-01 01:05:54.000000', 'consum', 0.0221, 'lps'),
	(564174, 129, '2014-03-01 01:05:55.000000', 'consum', 0.0228, 'lps'),
	(564175, 129, '2014-03-01 01:05:56.000000', 'consum', 0.0211, 'lps'),
	(564176, 129, '2014-03-01 01:05:57.000000', 'consum', 0.0221, 'lps'),
	(564177, 129, '2014-03-01 01:05:58.000000', 'consum', 0.0231, 'lps'),
	(564178, 129, '2014-03-01 01:05:59.000000', 'consum', 0.0223, 'lps'),
	(564179, 129, '2014-03-01 01:06:00.000000', 'consum', 0.0216, 'lps'),
	(564180, 129, '2014-03-01 01:06:01.000000', 'consum', 0.0228, 'lps'),
	(564181, 129, '2014-03-01 01:06:02.000000', 'consum', 0.0227, 'lps'),
	(564182, 129, '2014-03-01 01:06:03.000000', 'consum', 0.0213, 'lps'),
	(564183, 129, '2014-03-01 01:06:04.000000', 'consum', 0.0231, 'lps'),
	(564184, 129, '2014-03-01 01:06:05.000000', 'consum', 0.0221, 'lps'),
	(564185, 129, '2014-03-01 01:06:06.000000', 'consum', 0.0232, 'lps'),
	(564186, 129, '2014-03-01 01:06:07.000000', 'consum', 0.0228, 'lps'),
	(564187, 129, '2014-03-01 01:06:08.000000', 'consum', 0.0234, 'lps'),
	(564188, 129, '2014-03-01 01:06:09.000000', 'consum', 0.0218, 'lps'),
	(564189, 129, '2014-03-01 01:06:10.000000', 'consum', 0.0210, 'lps'),
	(564190, 129, '2014-03-01 01:06:11.000000', 'consum', 0.0216, 'lps'),
	(564191, 129, '2014-03-01 01:06:12.000000', 'consum', 0.0238, 'lps'),
	(564192, 129, '2014-03-01 01:06:13.000000', 'consum', 0.0216, 'lps'),
	(564193, 129, '2014-03-01 01:06:14.000000', 'consum', 0.0216, 'lps'),
	(564194, 129, '2014-03-01 01:06:15.000000', 'consum', 0.0222, 'lps'),
	(564195, 129, '2014-03-01 01:06:16.000000', 'consum', 0.0224, 'lps'),
	(564196, 129, '2014-03-01 01:06:17.000000', 'consum', 0.0215, 'lps'),
	(564197, 129, '2014-03-01 01:06:18.000000', 'consum', 0.0222, 'lps'),
	(564198, 129, '2014-03-01 01:06:19.000000', 'consum', 0.0227, 'lps'),
	(564199, 129, '2014-03-01 01:06:20.000000', 'consum', 0.0231, 'lps'),
	(564200, 129, '2014-03-01 01:06:21.000000', 'consum', 0.0236, 'lps'),
	(564201, 129, '2014-03-01 01:06:22.000000', 'consum', 0.0220, 'lps'),
	(564202, 129, '2014-03-01 01:06:23.000000', 'consum', 0.0210, 'lps'),
	(564203, 129, '2014-03-01 01:06:24.000000', 'consum', 0.0237, 'lps'),
	(564204, 129, '2014-03-01 01:06:25.000000', 'consum', 0.0232, 'lps'),
	(564205, 129, '2014-03-01 01:06:26.000000', 'consum', 0.0211, 'lps'),
	(564206, 129, '2014-03-01 01:06:27.000000', 'consum', 0.0236, 'lps'),
	(564207, 129, '2014-03-01 01:06:28.000000', 'consum', 0.0221, 'lps'),
	(564208, 129, '2014-03-01 01:06:29.000000', 'consum', 0.0218, 'lps'),
	(564209, 129, '2014-03-01 01:06:30.000000', 'consum', 0.0216, 'lps'),
	(564210, 129, '2014-03-01 01:06:31.000000', 'consum', 0.0216, 'lps'),
	(564211, 129, '2014-03-01 01:06:32.000000', 'consum', 0.0223, 'lps'),
	(564212, 129, '2014-03-01 01:06:33.000000', 'consum', 0.0229, 'lps'),
	(564213, 129, '2014-03-01 01:06:34.000000', 'consum', 0.0236, 'lps'),
	(564214, 129, '2014-03-01 01:06:35.000000', 'consum', 0.0228, 'lps'),
	(564215, 129, '2014-03-01 01:06:36.000000', 'consum', 0.0223, 'lps'),
	(564216, 129, '2014-03-01 01:06:37.000000', 'consum', 0.0221, 'lps'),
	(564217, 129, '2014-03-01 01:06:38.000000', 'consum', 0.0226, 'lps'),
	(564218, 129, '2014-03-01 01:06:39.000000', 'consum', 0.0229, 'lps'),
	(564219, 129, '2014-03-01 01:06:40.000000', 'consum', 0.0227, 'lps'),
	(564220, 129, '2014-03-01 01:06:41.000000', 'consum', 0.0212, 'lps'),
	(564221, 129, '2014-03-01 01:06:42.000000', 'consum', 0.0228, 'lps'),
	(564222, 129, '2014-03-01 01:06:43.000000', 'consum', 0.0236, 'lps'),
	(564223, 129, '2014-03-01 01:06:44.000000', 'consum', 0.0230, 'lps'),
	(564224, 129, '2014-03-01 01:06:45.000000', 'consum', 0.0231, 'lps'),
	(564225, 129, '2014-03-01 01:06:46.000000', 'consum', 0.0226, 'lps'),
	(564226, 129, '2014-03-01 01:06:47.000000', 'consum', 0.0229, 'lps'),
	(564227, 129, '2014-03-01 01:06:48.000000', 'consum', 0.0228, 'lps'),
	(564228, 129, '2014-03-01 01:06:49.000000', 'consum', 0.0216, 'lps'),
	(564229, 129, '2014-03-01 01:06:50.000000', 'consum', 0.0213, 'lps'),
	(564230, 129, '2014-03-01 01:06:51.000000', 'consum', 0.0238, 'lps'),
	(564231, 129, '2014-03-01 01:06:52.000000', 'consum', 0.0223, 'lps'),
	(564232, 129, '2014-03-01 01:06:53.000000', 'consum', 0.0223, 'lps'),
	(564233, 129, '2014-03-01 01:06:54.000000', 'consum', 0.0237, 'lps'),
	(564234, 129, '2014-03-01 01:06:55.000000', 'consum', 0.0219, 'lps'),
	(564235, 129, '2014-03-01 01:06:56.000000', 'consum', 0.0230, 'lps'),
	(564236, 129, '2014-03-01 01:06:57.000000', 'consum', 0.0228, 'lps'),
	(564237, 129, '2014-03-01 01:06:58.000000', 'consum', 0.0213, 'lps'),
	(564238, 129, '2014-03-01 01:06:59.000000', 'consum', 0.0227, 'lps'),
	(564239, 129, '2014-03-01 01:07:00.000000', 'consum', 0.0229, 'lps'),
	(564240, 129, '2014-03-01 01:07:01.000000', 'consum', 0.0225, 'lps'),
	(564241, 129, '2014-03-01 01:07:02.000000', 'consum', 0.0228, 'lps'),
	(564242, 129, '2014-03-01 01:07:03.000000', 'consum', 0.0226, 'lps'),
	(564243, 129, '2014-03-01 01:07:04.000000', 'consum', 0.0235, 'lps'),
	(564244, 129, '2014-03-01 01:07:05.000000', 'consum', 0.0233, 'lps'),
	(564245, 129, '2014-03-01 01:07:06.000000', 'consum', 0.0219, 'lps'),
	(564246, 129, '2014-03-01 01:07:07.000000', 'consum', 0.0215, 'lps'),
	(564247, 129, '2014-03-01 01:07:08.000000', 'consum', 0.0211, 'lps'),
	(564248, 129, '2014-03-01 01:07:09.000000', 'consum', 0.0230, 'lps'),
	(564249, 129, '2014-03-01 01:07:10.000000', 'consum', 0.0219, 'lps'),
	(564250, 129, '2014-03-01 01:07:11.000000', 'consum', 0.0225, 'lps'),
	(564251, 129, '2014-03-01 01:07:12.000000', 'consum', 0.0228, 'lps'),
	(564252, 129, '2014-03-01 01:07:13.000000', 'consum', 0.0228, 'lps'),
	(564253, 129, '2014-03-01 01:07:14.000000', 'consum', 0.0219, 'lps'),
	(564254, 129, '2014-03-01 01:07:15.000000', 'consum', 0.0230, 'lps'),
	(564255, 129, '2014-03-01 01:07:16.000000', 'consum', 0.0224, 'lps'),
	(564256, 130, '2014-03-01 00:00:00.000000', 'consum', 0.0215, 'lps'),
	(564257, 130, '2014-03-01 00:00:01.000000', 'consum', 0.0215, 'lps'),
	(564258, 130, '2014-03-01 00:00:02.000000', 'consum', 0.0222, 'lps'),
	(564259, 130, '2014-03-01 00:00:03.000000', 'consum', 0.0214, 'lps'),
	(564260, 130, '2014-03-01 00:00:04.000000', 'consum', 0.0216, 'lps'),
	(564261, 130, '2014-03-01 00:00:05.000000', 'consum', 0.0210, 'lps'),
	(564262, 130, '2014-03-01 00:00:06.000000', 'consum', 0.0228, 'lps'),
	(564263, 130, '2014-03-01 00:00:07.000000', 'consum', 0.0226, 'lps'),
	(564264, 130, '2014-03-01 00:00:08.000000', 'consum', 0.0218, 'lps'),
	(564265, 130, '2014-03-01 00:00:09.000000', 'consum', 0.0221, 'lps'),
	(564266, 130, '2014-03-01 00:00:10.000000', 'consum', 0.0223, 'lps'),
	(564267, 130, '2014-03-01 00:00:11.000000', 'consum', 0.0225, 'lps'),
	(564268, 130, '2014-03-01 00:00:12.000000', 'consum', 0.0224, 'lps'),
	(564269, 130, '2014-03-01 00:00:13.000000', 'consum', 0.0219, 'lps'),
	(564270, 130, '2014-03-01 00:00:14.000000', 'consum', 0.0212, 'lps'),
	(564271, 130, '2014-03-01 00:00:15.000000', 'consum', 0.0212, 'lps'),
	(564272, 130, '2014-03-01 00:00:16.000000', 'consum', 0.0216, 'lps'),
	(564273, 130, '2014-03-01 00:00:17.000000', 'consum', 0.0214, 'lps'),
	(564274, 130, '2014-03-01 00:00:18.000000', 'consum', 0.0211, 'lps'),
	(564275, 130, '2014-03-01 00:00:19.000000', 'consum', 0.0226, 'lps'),
	(564276, 130, '2014-03-01 00:00:20.000000', 'consum', 0.0228, 'lps'),
	(564277, 130, '2014-03-01 00:00:21.000000', 'consum', 0.0214, 'lps'),
	(564278, 130, '2014-03-01 00:00:22.000000', 'consum', 0.0214, 'lps'),
	(564279, 130, '2014-03-01 00:00:23.000000', 'consum', 0.0218, 'lps'),
	(564280, 130, '2014-03-01 00:00:24.000000', 'consum', 0.0222, 'lps'),
	(564281, 130, '2014-03-01 00:00:25.000000', 'consum', 0.0226, 'lps'),
	(564282, 130, '2014-03-01 00:00:26.000000', 'consum', 0.0216, 'lps'),
	(564283, 130, '2014-03-01 00:00:27.000000', 'consum', 0.0211, 'lps'),
	(564284, 130, '2014-03-01 00:00:28.000000', 'consum', 0.0218, 'lps'),
	(564285, 130, '2014-03-01 00:00:29.000000', 'consum', 0.0227, 'lps'),
	(564286, 130, '2014-03-01 00:00:30.000000', 'consum', 0.0214, 'lps'),
	(564287, 130, '2014-03-01 00:00:31.000000', 'consum', 0.0219, 'lps'),
	(564288, 130, '2014-03-01 00:00:32.000000', 'consum', 0.0226, 'lps'),
	(564289, 130, '2014-03-01 00:00:33.000000', 'consum', 0.0224, 'lps'),
	(564290, 130, '2014-03-01 00:00:34.000000', 'consum', 0.0212, 'lps'),
	(564291, 130, '2014-03-01 00:00:35.000000', 'consum', 0.0218, 'lps'),
	(564292, 130, '2014-03-01 00:00:36.000000', 'consum', 0.0225, 'lps'),
	(564293, 130, '2014-03-01 00:00:37.000000', 'consum', 0.0222, 'lps'),
	(564294, 130, '2014-03-01 00:00:38.000000', 'consum', 0.0227, 'lps'),
	(564295, 130, '2014-03-01 00:00:39.000000', 'consum', 0.0223, 'lps'),
	(564296, 130, '2014-03-01 00:00:40.000000', 'consum', 0.0224, 'lps'),
	(564297, 130, '2014-03-01 00:00:41.000000', 'consum', 0.0221, 'lps'),
	(564298, 130, '2014-03-01 00:00:42.000000', 'consum', 0.0224, 'lps'),
	(564299, 130, '2014-03-01 00:00:43.000000', 'consum', 0.0211, 'lps'),
	(564300, 130, '2014-03-01 00:00:44.000000', 'consum', 0.0212, 'lps'),
	(564301, 130, '2014-03-01 00:00:45.000000', 'consum', 0.0217, 'lps'),
	(564302, 130, '2014-03-01 00:00:46.000000', 'consum', 0.0220, 'lps'),
	(564303, 130, '2014-03-01 00:00:47.000000', 'consum', 0.0221, 'lps'),
	(564304, 130, '2014-03-01 00:00:48.000000', 'consum', 0.0217, 'lps'),
	(564305, 130, '2014-03-01 00:00:49.000000', 'consum', 0.0211, 'lps'),
	(564306, 130, '2014-03-01 00:00:50.000000', 'consum', 0.0213, 'lps'),
	(564307, 130, '2014-03-01 00:00:51.000000', 'consum', 0.0224, 'lps'),
	(564308, 130, '2014-03-01 00:00:52.000000', 'consum', 0.0214, 'lps'),
	(564309, 130, '2014-03-01 00:00:53.000000', 'consum', 0.0225, 'lps'),
	(564310, 130, '2014-03-01 00:00:54.000000', 'consum', 0.0216, 'lps'),
	(564311, 130, '2014-03-01 00:00:55.000000', 'consum', 0.0215, 'lps'),
	(564312, 130, '2014-03-01 00:00:56.000000', 'consum', 0.0220, 'lps'),
	(564313, 130, '2014-03-01 00:00:57.000000', 'consum', 0.0225, 'lps'),
	(564314, 130, '2014-03-01 00:00:58.000000', 'consum', 0.0216, 'lps'),
	(564315, 130, '2014-03-01 00:00:59.000000', 'consum', 0.0216, 'lps'),
	(564316, 130, '2014-03-01 00:01:00.000000', 'consum', 0.0222, 'lps'),
	(564317, 130, '2014-03-01 00:01:01.000000', 'consum', 0.0216, 'lps'),
	(564318, 130, '2014-03-01 00:01:02.000000', 'consum', 0.0223, 'lps'),
	(564319, 130, '2014-03-01 00:01:03.000000', 'consum', 0.0217, 'lps'),
	(564320, 130, '2014-03-01 00:01:04.000000', 'consum', 0.0210, 'lps'),
	(564321, 130, '2014-03-01 00:01:05.000000', 'consum', 0.0226, 'lps'),
	(564322, 130, '2014-03-01 00:01:06.000000', 'consum', 0.0214, 'lps'),
	(564323, 130, '2014-03-01 00:01:07.000000', 'consum', 0.0219, 'lps'),
	(564324, 130, '2014-03-01 00:01:08.000000', 'consum', 0.0227, 'lps'),
	(564325, 130, '2014-03-01 00:01:09.000000', 'consum', 0.0210, 'lps'),
	(564326, 130, '2014-03-01 00:01:10.000000', 'consum', 0.0216, 'lps'),
	(564327, 130, '2014-03-01 00:01:11.000000', 'consum', 0.0223, 'lps'),
	(564328, 130, '2014-03-01 00:01:12.000000', 'consum', 0.0219, 'lps'),
	(564329, 130, '2014-03-01 00:01:13.000000', 'consum', 0.0218, 'lps'),
	(564330, 130, '2014-03-01 00:01:14.000000', 'consum', 0.0224, 'lps'),
	(564331, 130, '2014-03-01 00:01:15.000000', 'consum', 0.0219, 'lps'),
	(564332, 130, '2014-03-01 00:01:16.000000', 'consum', 0.0213, 'lps'),
	(564333, 130, '2014-03-01 00:01:17.000000', 'consum', 0.0217, 'lps'),
	(564334, 130, '2014-03-01 00:01:18.000000', 'consum', 0.0219, 'lps'),
	(564335, 130, '2014-03-01 00:01:19.000000', 'consum', 0.0213, 'lps'),
	(564336, 130, '2014-03-01 00:01:20.000000', 'consum', 0.0219, 'lps'),
	(564337, 130, '2014-03-01 00:01:21.000000', 'consum', 0.0225, 'lps'),
	(564338, 130, '2014-03-01 00:01:22.000000', 'consum', 0.0223, 'lps'),
	(564339, 130, '2014-03-01 00:01:23.000000', 'consum', 0.0212, 'lps'),
	(564340, 130, '2014-03-01 00:01:24.000000', 'consum', 0.0220, 'lps'),
	(564341, 130, '2014-03-01 00:01:25.000000', 'consum', 0.0214, 'lps'),
	(564342, 130, '2014-03-01 00:01:26.000000', 'consum', 0.0220, 'lps'),
	(564343, 130, '2014-03-01 00:01:27.000000', 'consum', 0.0213, 'lps'),
	(564344, 130, '2014-03-01 00:01:28.000000', 'consum', 0.0211, 'lps'),
	(564345, 130, '2014-03-01 00:01:29.000000', 'consum', 0.0227, 'lps'),
	(564346, 130, '2014-03-01 00:01:30.000000', 'consum', 0.0216, 'lps'),
	(564347, 130, '2014-03-01 00:01:31.000000', 'consum', 0.0226, 'lps'),
	(564348, 130, '2014-03-01 00:01:32.000000', 'consum', 0.0219, 'lps'),
	(564349, 130, '2014-03-01 00:01:33.000000', 'consum', 0.0223, 'lps'),
	(564350, 130, '2014-03-01 00:01:34.000000', 'consum', 0.0214, 'lps'),
	(564351, 130, '2014-03-01 00:01:35.000000', 'consum', 0.0228, 'lps'),
	(564352, 130, '2014-03-01 00:01:36.000000', 'consum', 0.0210, 'lps'),
	(564353, 130, '2014-03-01 00:01:37.000000', 'consum', 0.0217, 'lps'),
	(564354, 130, '2014-03-01 00:01:38.000000', 'consum', 0.0224, 'lps'),
	(564355, 130, '2014-03-01 00:01:39.000000', 'consum', 0.0224, 'lps'),
	(564356, 130, '2014-03-01 00:01:40.000000', 'consum', 0.0218, 'lps'),
	(564357, 130, '2014-03-01 00:01:41.000000', 'consum', 0.0227, 'lps'),
	(564358, 130, '2014-03-01 00:01:42.000000', 'consum', 0.0213, 'lps'),
	(564359, 130, '2014-03-01 00:01:43.000000', 'consum', 0.0215, 'lps'),
	(564360, 130, '2014-03-01 00:01:44.000000', 'consum', 0.0226, 'lps'),
	(564361, 130, '2014-03-01 00:01:45.000000', 'consum', 0.0218, 'lps'),
	(564362, 130, '2014-03-01 00:01:46.000000', 'consum', 0.0223, 'lps'),
	(564363, 130, '2014-03-01 00:01:47.000000', 'consum', 0.0215, 'lps'),
	(564364, 130, '2014-03-01 00:01:48.000000', 'consum', 0.0213, 'lps'),
	(564365, 130, '2014-03-01 00:01:49.000000', 'consum', 0.0210, 'lps'),
	(564366, 130, '2014-03-01 00:01:50.000000', 'consum', 0.0222, 'lps'),
	(564367, 130, '2014-03-01 00:01:51.000000', 'consum', 0.0211, 'lps'),
	(564368, 130, '2014-03-01 00:01:52.000000', 'consum', 0.0220, 'lps'),
	(564369, 130, '2014-03-01 00:01:53.000000', 'consum', 0.0217, 'lps'),
	(564370, 130, '2014-03-01 00:01:54.000000', 'consum', 0.0216, 'lps'),
	(564371, 130, '2014-03-01 00:01:55.000000', 'consum', 0.0222, 'lps'),
	(564372, 130, '2014-03-01 00:01:56.000000', 'consum', 0.0213, 'lps'),
	(564373, 130, '2014-03-01 00:01:57.000000', 'consum', 0.0228, 'lps'),
	(564374, 130, '2014-03-01 00:01:58.000000', 'consum', 0.0214, 'lps'),
	(564375, 130, '2014-03-01 00:01:59.000000', 'consum', 0.0217, 'lps'),
	(564376, 130, '2014-03-01 00:02:00.000000', 'consum', 0.0214, 'lps'),
	(564377, 130, '2014-03-01 00:02:01.000000', 'consum', 0.0227, 'lps'),
	(564378, 130, '2014-03-01 00:02:02.000000', 'consum', 0.0227, 'lps'),
	(564379, 130, '2014-03-01 00:02:03.000000', 'consum', 0.0226, 'lps'),
	(564380, 130, '2014-03-01 00:02:04.000000', 'consum', 0.0220, 'lps'),
	(564381, 130, '2014-03-01 00:02:05.000000', 'consum', 0.0212, 'lps'),
	(564382, 130, '2014-03-01 00:02:06.000000', 'consum', 0.0211, 'lps'),
	(564383, 130, '2014-03-01 00:02:07.000000', 'consum', 0.0210, 'lps'),
	(564384, 130, '2014-03-01 00:02:08.000000', 'consum', 0.0226, 'lps'),
	(564385, 130, '2014-03-01 00:02:09.000000', 'consum', 0.0214, 'lps'),
	(564386, 130, '2014-03-01 00:02:10.000000', 'consum', 0.0222, 'lps'),
	(564387, 130, '2014-03-01 00:02:11.000000', 'consum', 0.0218, 'lps'),
	(564388, 130, '2014-03-01 00:02:12.000000', 'consum', 0.0215, 'lps'),
	(564389, 130, '2014-03-01 00:02:13.000000', 'consum', 0.0213, 'lps'),
	(564390, 130, '2014-03-01 00:02:14.000000', 'consum', 0.0212, 'lps'),
	(564391, 130, '2014-03-01 00:02:15.000000', 'consum', 0.0227, 'lps'),
	(564392, 130, '2014-03-01 00:02:16.000000', 'consum', 0.0215, 'lps'),
	(564393, 130, '2014-03-01 00:02:17.000000', 'consum', 0.0221, 'lps'),
	(564394, 130, '2014-03-01 00:02:18.000000', 'consum', 0.0214, 'lps'),
	(564395, 130, '2014-03-01 00:02:19.000000', 'consum', 0.0215, 'lps'),
	(564396, 130, '2014-03-01 00:02:20.000000', 'consum', 0.0225, 'lps'),
	(564397, 130, '2014-03-01 00:02:21.000000', 'consum', 0.0213, 'lps'),
	(564398, 130, '2014-03-01 00:02:22.000000', 'consum', 0.0218, 'lps'),
	(564399, 130, '2014-03-01 00:02:23.000000', 'consum', 0.0224, 'lps'),
	(564400, 130, '2014-03-01 00:02:24.000000', 'consum', 0.0218, 'lps'),
	(564401, 130, '2014-03-01 00:02:25.000000', 'consum', 0.0226, 'lps'),
	(564402, 130, '2014-03-01 00:02:26.000000', 'consum', 0.0211, 'lps'),
	(564403, 130, '2014-03-01 00:02:27.000000', 'consum', 0.0226, 'lps'),
	(564404, 130, '2014-03-01 00:02:28.000000', 'consum', 0.0210, 'lps'),
	(564405, 130, '2014-03-01 00:02:29.000000', 'consum', 0.0218, 'lps'),
	(564406, 130, '2014-03-01 00:02:30.000000', 'consum', 0.0215, 'lps'),
	(564407, 130, '2014-03-01 00:02:31.000000', 'consum', 0.0211, 'lps'),
	(564408, 130, '2014-03-01 00:02:32.000000', 'consum', 0.0218, 'lps'),
	(564409, 130, '2014-03-01 00:02:33.000000', 'consum', 0.0227, 'lps'),
	(564410, 130, '2014-03-01 00:02:34.000000', 'consum', 0.0218, 'lps'),
	(564411, 130, '2014-03-01 00:02:35.000000', 'consum', 0.0216, 'lps'),
	(564412, 130, '2014-03-01 00:02:36.000000', 'consum', 0.0219, 'lps'),
	(564413, 130, '2014-03-01 00:02:37.000000', 'consum', 0.0217, 'lps'),
	(564414, 130, '2014-03-01 00:02:38.000000', 'consum', 0.0218, 'lps'),
	(564415, 130, '2014-03-01 00:02:39.000000', 'consum', 0.0228, 'lps'),
	(564416, 130, '2014-03-01 00:02:40.000000', 'consum', 0.0223, 'lps'),
	(564417, 130, '2014-03-01 00:02:41.000000', 'consum', 0.0219, 'lps'),
	(564418, 130, '2014-03-01 00:02:42.000000', 'consum', 0.0218, 'lps'),
	(564419, 130, '2014-03-01 00:02:43.000000', 'consum', 0.0223, 'lps'),
	(564420, 130, '2014-03-01 00:02:44.000000', 'consum', 0.0213, 'lps'),
	(564421, 130, '2014-03-01 00:02:45.000000', 'consum', 0.0227, 'lps'),
	(564422, 130, '2014-03-01 00:02:46.000000', 'consum', 0.0227, 'lps'),
	(564423, 130, '2014-03-01 00:02:47.000000', 'consum', 0.0225, 'lps'),
	(564424, 130, '2014-03-01 00:02:48.000000', 'consum', 0.0216, 'lps'),
	(564425, 130, '2014-03-01 00:02:49.000000', 'consum', 0.0213, 'lps'),
	(564426, 130, '2014-03-01 00:02:50.000000', 'consum', 0.0210, 'lps'),
	(564427, 130, '2014-03-01 00:02:51.000000', 'consum', 0.0220, 'lps'),
	(564428, 130, '2014-03-01 00:02:52.000000', 'consum', 0.0223, 'lps'),
	(564429, 130, '2014-03-01 00:02:53.000000', 'consum', 0.0224, 'lps'),
	(564430, 130, '2014-03-01 00:02:54.000000', 'consum', 0.0223, 'lps'),
	(564431, 130, '2014-03-01 00:02:55.000000', 'consum', 0.0216, 'lps'),
	(564432, 130, '2014-03-01 00:02:56.000000', 'consum', 0.0220, 'lps'),
	(564433, 130, '2014-03-01 00:02:57.000000', 'consum', 0.0225, 'lps'),
	(564434, 130, '2014-03-01 00:02:58.000000', 'consum', 0.0218, 'lps'),
	(564435, 130, '2014-03-01 00:02:59.000000', 'consum', 0.0222, 'lps'),
	(564436, 130, '2014-03-01 00:03:00.000000', 'consum', 0.0227, 'lps'),
	(564437, 130, '2014-03-01 00:03:01.000000', 'consum', 0.0222, 'lps'),
	(564438, 130, '2014-03-01 00:03:02.000000', 'consum', 0.0220, 'lps'),
	(564439, 130, '2014-03-01 00:03:03.000000', 'consum', 0.0227, 'lps'),
	(564440, 130, '2014-03-01 00:03:04.000000', 'consum', 0.0224, 'lps'),
	(564441, 130, '2014-03-01 00:03:05.000000', 'consum', 0.0210, 'lps'),
	(564442, 130, '2014-03-01 00:03:06.000000', 'consum', 0.0228, 'lps'),
	(564443, 130, '2014-03-01 00:03:07.000000', 'consum', 0.0224, 'lps'),
	(564444, 130, '2014-03-01 00:03:08.000000', 'consum', 0.0225, 'lps'),
	(564445, 130, '2014-03-01 00:03:09.000000', 'consum', 0.0225, 'lps'),
	(564446, 130, '2014-03-01 00:03:10.000000', 'consum', 0.0221, 'lps'),
	(564447, 130, '2014-03-01 00:03:11.000000', 'consum', 0.0221, 'lps'),
	(564448, 130, '2014-03-01 00:03:12.000000', 'consum', 0.0213, 'lps'),
	(564449, 130, '2014-03-01 00:03:13.000000', 'consum', 0.0211, 'lps'),
	(564450, 130, '2014-03-01 00:03:14.000000', 'consum', 0.0226, 'lps'),
	(564451, 130, '2014-03-01 00:03:15.000000', 'consum', 0.0211, 'lps'),
	(564452, 130, '2014-03-01 00:03:16.000000', 'consum', 0.0224, 'lps'),
	(564453, 130, '2014-03-01 00:03:17.000000', 'consum', 0.0222, 'lps'),
	(564454, 130, '2014-03-01 00:03:18.000000', 'consum', 0.0228, 'lps'),
	(564455, 130, '2014-03-01 00:03:19.000000', 'consum', 0.0228, 'lps'),
	(564456, 130, '2014-03-01 00:03:20.000000', 'consum', 0.0225, 'lps'),
	(564457, 130, '2014-03-01 00:03:21.000000', 'consum', 0.0212, 'lps'),
	(564458, 130, '2014-03-01 00:03:22.000000', 'consum', 0.0215, 'lps'),
	(564459, 130, '2014-03-01 00:03:23.000000', 'consum', 0.0212, 'lps'),
	(564460, 130, '2014-03-01 00:03:24.000000', 'consum', 0.0223, 'lps'),
	(564461, 130, '2014-03-01 00:03:25.000000', 'consum', 0.0213, 'lps'),
	(564462, 130, '2014-03-01 00:03:26.000000', 'consum', 0.0223, 'lps'),
	(564463, 130, '2014-03-01 00:03:27.000000', 'consum', 0.0228, 'lps'),
	(564464, 130, '2014-03-01 00:03:28.000000', 'consum', 0.0224, 'lps'),
	(564465, 130, '2014-03-01 00:03:29.000000', 'consum', 0.0225, 'lps'),
	(564466, 130, '2014-03-01 00:03:30.000000', 'consum', 0.0227, 'lps'),
	(564467, 130, '2014-03-01 00:03:31.000000', 'consum', 0.0210, 'lps'),
	(564468, 130, '2014-03-01 00:03:32.000000', 'consum', 0.0219, 'lps'),
	(564469, 130, '2014-03-01 00:03:33.000000', 'consum', 0.0218, 'lps'),
	(564470, 130, '2014-03-01 00:03:34.000000', 'consum', 0.0223, 'lps'),
	(564471, 130, '2014-03-01 00:03:35.000000', 'consum', 0.0214, 'lps'),
	(564472, 130, '2014-03-01 00:03:36.000000', 'consum', 0.0211, 'lps'),
	(564473, 130, '2014-03-01 00:03:37.000000', 'consum', 0.0221, 'lps'),
	(564474, 130, '2014-03-01 00:03:38.000000', 'consum', 0.0224, 'lps'),
	(564475, 130, '2014-03-01 00:03:39.000000', 'consum', 0.0212, 'lps'),
	(564476, 130, '2014-03-01 00:03:40.000000', 'consum', 0.0214, 'lps'),
	(564477, 130, '2014-03-01 00:03:41.000000', 'consum', 0.0224, 'lps'),
	(564478, 130, '2014-03-01 00:03:42.000000', 'consum', 0.0214, 'lps'),
	(564479, 130, '2014-03-01 00:03:43.000000', 'consum', 0.0225, 'lps'),
	(564480, 130, '2014-03-01 00:03:44.000000', 'consum', 0.0219, 'lps'),
	(564481, 130, '2014-03-01 00:03:45.000000', 'consum', 0.0228, 'lps'),
	(564482, 130, '2014-03-01 00:03:46.000000', 'consum', 0.0215, 'lps'),
	(564483, 130, '2014-03-01 00:03:47.000000', 'consum', 0.0220, 'lps'),
	(564484, 130, '2014-03-01 00:03:48.000000', 'consum', 0.0227, 'lps'),
	(564485, 130, '2014-03-01 00:03:49.000000', 'consum', 0.0228, 'lps'),
	(564486, 130, '2014-03-01 00:03:50.000000', 'consum', 0.0212, 'lps'),
	(564487, 130, '2014-03-01 00:03:51.000000', 'consum', 0.0224, 'lps'),
	(564488, 130, '2014-03-01 00:03:52.000000', 'consum', 0.0216, 'lps'),
	(564489, 130, '2014-03-01 00:03:53.000000', 'consum', 0.0219, 'lps'),
	(564490, 130, '2014-03-01 00:03:54.000000', 'consum', 0.0216, 'lps'),
	(564491, 130, '2014-03-01 00:03:55.000000', 'consum', 0.0215, 'lps'),
	(564492, 130, '2014-03-01 00:03:56.000000', 'consum', 0.0219, 'lps'),
	(564493, 130, '2014-03-01 00:03:57.000000', 'consum', 0.0222, 'lps'),
	(564494, 130, '2014-03-01 00:03:58.000000', 'consum', 0.0225, 'lps'),
	(564495, 130, '2014-03-01 00:03:59.000000', 'consum', 0.0210, 'lps'),
	(564496, 130, '2014-03-01 00:04:00.000000', 'consum', 0.0222, 'lps'),
	(564497, 130, '2014-03-01 00:04:01.000000', 'consum', 0.0214, 'lps'),
	(564498, 130, '2014-03-01 00:04:02.000000', 'consum', 0.0215, 'lps'),
	(564499, 130, '2014-03-01 00:04:03.000000', 'consum', 0.0222, 'lps'),
	(564500, 130, '2014-03-01 00:04:04.000000', 'consum', 0.0217, 'lps'),
	(564501, 130, '2014-03-01 00:04:05.000000', 'consum', 0.0228, 'lps'),
	(564502, 130, '2014-03-01 00:04:06.000000', 'consum', 0.0221, 'lps'),
	(564503, 130, '2014-03-01 00:04:07.000000', 'consum', 0.0214, 'lps'),
	(564504, 130, '2014-03-01 00:04:08.000000', 'consum', 0.0215, 'lps'),
	(564505, 130, '2014-03-01 00:04:09.000000', 'consum', 0.0224, 'lps'),
	(564506, 130, '2014-03-01 00:04:10.000000', 'consum', 0.0210, 'lps'),
	(564507, 130, '2014-03-01 00:04:11.000000', 'consum', 0.0223, 'lps'),
	(564508, 130, '2014-03-01 00:04:12.000000', 'consum', 0.0222, 'lps'),
	(564509, 130, '2014-03-01 00:04:13.000000', 'consum', 0.0228, 'lps'),
	(564510, 130, '2014-03-01 00:04:14.000000', 'consum', 0.0227, 'lps'),
	(564511, 130, '2014-03-01 00:04:15.000000', 'consum', 0.0222, 'lps'),
	(564512, 130, '2014-03-01 00:04:16.000000', 'consum', 0.0219, 'lps'),
	(564513, 130, '2014-03-01 00:04:17.000000', 'consum', 0.0220, 'lps'),
	(564514, 130, '2014-03-01 00:04:18.000000', 'consum', 0.0213, 'lps'),
	(564515, 130, '2014-03-01 00:04:19.000000', 'consum', 0.0217, 'lps'),
	(564516, 130, '2014-03-01 00:04:20.000000', 'consum', 0.0217, 'lps'),
	(564517, 130, '2014-03-01 00:04:21.000000', 'consum', 0.0222, 'lps'),
	(564518, 130, '2014-03-01 00:04:22.000000', 'consum', 0.0214, 'lps'),
	(564519, 130, '2014-03-01 00:04:23.000000', 'consum', 0.0211, 'lps'),
	(564520, 130, '2014-03-01 00:04:24.000000', 'consum', 0.0223, 'lps'),
	(564521, 130, '2014-03-01 00:04:25.000000', 'consum', 0.0216, 'lps'),
	(564522, 130, '2014-03-01 00:04:26.000000', 'consum', 0.0222, 'lps'),
	(564523, 130, '2014-03-01 00:04:27.000000', 'consum', 0.0216, 'lps'),
	(564524, 130, '2014-03-01 00:04:28.000000', 'consum', 0.0220, 'lps'),
	(564525, 130, '2014-03-01 00:04:29.000000', 'consum', 0.0225, 'lps'),
	(564526, 130, '2014-03-01 00:04:30.000000', 'consum', 0.0219, 'lps'),
	(564527, 130, '2014-03-01 00:04:31.000000', 'consum', 0.0226, 'lps'),
	(564528, 130, '2014-03-01 00:04:32.000000', 'consum', 0.0228, 'lps'),
	(564529, 130, '2014-03-01 00:04:33.000000', 'consum', 0.0215, 'lps'),
	(564530, 130, '2014-03-01 00:04:34.000000', 'consum', 0.0219, 'lps'),
	(564531, 130, '2014-03-01 00:04:35.000000', 'consum', 0.0220, 'lps'),
	(564532, 130, '2014-03-01 00:04:36.000000', 'consum', 0.0217, 'lps'),
	(564533, 130, '2014-03-01 00:04:37.000000', 'consum', 0.0214, 'lps'),
	(564534, 130, '2014-03-01 00:04:38.000000', 'consum', 0.0210, 'lps'),
	(564535, 130, '2014-03-01 00:04:39.000000', 'consum', 0.0217, 'lps'),
	(564536, 130, '2014-03-01 00:04:40.000000', 'consum', 0.0227, 'lps'),
	(564537, 130, '2014-03-01 00:04:41.000000', 'consum', 0.0218, 'lps'),
	(564538, 130, '2014-03-01 00:04:42.000000', 'consum', 0.0219, 'lps'),
	(564539, 130, '2014-03-01 00:04:43.000000', 'consum', 0.0214, 'lps'),
	(564540, 130, '2014-03-01 00:04:44.000000', 'consum', 0.0219, 'lps'),
	(564541, 130, '2014-03-01 00:04:45.000000', 'consum', 0.0225, 'lps'),
	(564542, 130, '2014-03-01 00:04:46.000000', 'consum', 0.0223, 'lps'),
	(564543, 130, '2014-03-01 00:04:47.000000', 'consum', 0.0227, 'lps'),
	(564544, 130, '2014-03-01 00:04:48.000000', 'consum', 0.0222, 'lps'),
	(564545, 130, '2014-03-01 00:04:49.000000', 'consum', 0.0218, 'lps'),
	(564546, 130, '2014-03-01 00:04:50.000000', 'consum', 0.0215, 'lps'),
	(564547, 130, '2014-03-01 00:04:51.000000', 'consum', 0.0210, 'lps'),
	(564548, 130, '2014-03-01 00:04:52.000000', 'consum', 0.0213, 'lps'),
	(564549, 130, '2014-03-01 00:04:53.000000', 'consum', 0.0228, 'lps'),
	(564550, 130, '2014-03-01 00:04:54.000000', 'consum', 0.0217, 'lps'),
	(564551, 130, '2014-03-01 00:04:55.000000', 'consum', 0.0227, 'lps'),
	(564552, 130, '2014-03-01 00:04:56.000000', 'consum', 0.0220, 'lps'),
	(564553, 130, '2014-03-01 00:04:57.000000', 'consum', 0.0227, 'lps'),
	(564554, 130, '2014-03-01 00:04:58.000000', 'consum', 0.0228, 'lps'),
	(564555, 130, '2014-03-01 00:04:59.000000', 'consum', 0.0210, 'lps'),
	(564556, 130, '2014-03-01 00:05:00.000000', 'consum', 0.0214, 'lps'),
	(564557, 130, '2014-03-01 00:05:01.000000', 'consum', 0.0212, 'lps'),
	(564558, 130, '2014-03-01 00:05:02.000000', 'consum', 0.0228, 'lps'),
	(564559, 130, '2014-03-01 00:05:03.000000', 'consum', 0.0216, 'lps'),
	(564560, 130, '2014-03-01 00:05:04.000000', 'consum', 0.0228, 'lps'),
	(564561, 130, '2014-03-01 00:05:05.000000', 'consum', 0.0222, 'lps'),
	(564562, 130, '2014-03-01 00:05:06.000000', 'consum', 0.0220, 'lps'),
	(564563, 130, '2014-03-01 00:05:07.000000', 'consum', 0.0221, 'lps'),
	(564564, 130, '2014-03-01 00:05:08.000000', 'consum', 0.0219, 'lps'),
	(564565, 130, '2014-03-01 00:05:09.000000', 'consum', 0.0221, 'lps'),
	(564566, 130, '2014-03-01 00:05:10.000000', 'consum', 0.0222, 'lps'),
	(564567, 130, '2014-03-01 00:05:11.000000', 'consum', 0.0217, 'lps'),
	(564568, 130, '2014-03-01 00:05:12.000000', 'consum', 0.0228, 'lps'),
	(564569, 130, '2014-03-01 00:05:13.000000', 'consum', 0.0224, 'lps'),
	(564570, 130, '2014-03-01 00:05:14.000000', 'consum', 0.0228, 'lps'),
	(564571, 130, '2014-03-01 00:05:15.000000', 'consum', 0.0217, 'lps'),
	(564572, 130, '2014-03-01 00:05:16.000000', 'consum', 0.0212, 'lps'),
	(564573, 130, '2014-03-01 00:05:17.000000', 'consum', 0.0218, 'lps'),
	(564574, 130, '2014-03-01 00:05:18.000000', 'consum', 0.0226, 'lps'),
	(564575, 130, '2014-03-01 00:05:19.000000', 'consum', 0.0210, 'lps'),
	(564576, 130, '2014-03-01 00:05:20.000000', 'consum', 0.0218, 'lps'),
	(564577, 130, '2014-03-01 00:05:21.000000', 'consum', 0.0215, 'lps'),
	(564578, 130, '2014-03-01 00:05:22.000000', 'consum', 0.0227, 'lps'),
	(564579, 130, '2014-03-01 00:05:23.000000', 'consum', 0.0226, 'lps'),
	(564580, 130, '2014-03-01 00:05:24.000000', 'consum', 0.0220, 'lps'),
	(564581, 130, '2014-03-01 00:05:25.000000', 'consum', 0.0210, 'lps'),
	(564582, 130, '2014-03-01 00:05:26.000000', 'consum', 0.0221, 'lps'),
	(564583, 130, '2014-03-01 00:05:27.000000', 'consum', 0.0210, 'lps'),
	(564584, 130, '2014-03-01 00:05:28.000000', 'consum', 0.0213, 'lps'),
	(564585, 130, '2014-03-01 00:05:29.000000', 'consum', 0.0226, 'lps'),
	(564586, 130, '2014-03-01 00:05:30.000000', 'consum', 0.0226, 'lps'),
	(564587, 130, '2014-03-01 00:05:31.000000', 'consum', 0.0221, 'lps'),
	(564588, 130, '2014-03-01 00:05:32.000000', 'consum', 0.0217, 'lps'),
	(564589, 130, '2014-03-01 00:05:33.000000', 'consum', 0.0214, 'lps'),
	(564590, 130, '2014-03-01 00:05:34.000000', 'consum', 0.0227, 'lps'),
	(564591, 130, '2014-03-01 00:05:35.000000', 'consum', 0.0225, 'lps'),
	(564592, 130, '2014-03-01 00:05:36.000000', 'consum', 0.0219, 'lps'),
	(564593, 130, '2014-03-01 00:05:37.000000', 'consum', 0.0226, 'lps'),
	(564594, 130, '2014-03-01 00:05:38.000000', 'consum', 0.0228, 'lps'),
	(564595, 130, '2014-03-01 00:05:39.000000', 'consum', 0.0213, 'lps'),
	(564596, 130, '2014-03-01 00:05:40.000000', 'consum', 0.0212, 'lps'),
	(564597, 130, '2014-03-01 00:05:41.000000', 'consum', 0.0228, 'lps'),
	(564598, 130, '2014-03-01 00:05:42.000000', 'consum', 0.0218, 'lps'),
	(564599, 130, '2014-03-01 00:05:43.000000', 'consum', 0.0215, 'lps'),
	(564600, 130, '2014-03-01 00:05:44.000000', 'consum', 0.0213, 'lps'),
	(564601, 130, '2014-03-01 00:05:45.000000', 'consum', 0.0228, 'lps'),
	(564602, 130, '2014-03-01 00:05:46.000000', 'consum', 0.0214, 'lps'),
	(564603, 130, '2014-03-01 00:05:47.000000', 'consum', 0.0218, 'lps'),
	(564604, 130, '2014-03-01 00:05:48.000000', 'consum', 0.0218, 'lps'),
	(564605, 130, '2014-03-01 00:05:49.000000', 'consum', 0.0227, 'lps'),
	(564606, 130, '2014-03-01 00:05:50.000000', 'consum', 0.0214, 'lps'),
	(564607, 130, '2014-03-01 00:05:51.000000', 'consum', 0.0218, 'lps'),
	(564608, 130, '2014-03-01 00:05:52.000000', 'consum', 0.0220, 'lps'),
	(564609, 130, '2014-03-01 00:05:53.000000', 'consum', 0.0217, 'lps'),
	(564610, 130, '2014-03-01 00:05:54.000000', 'consum', 0.0216, 'lps'),
	(564611, 130, '2014-03-01 00:05:55.000000', 'consum', 0.0218, 'lps'),
	(564612, 130, '2014-03-01 00:05:56.000000', 'consum', 0.0216, 'lps'),
	(564613, 130, '2014-03-01 00:05:57.000000', 'consum', 0.0213, 'lps'),
	(564614, 130, '2014-03-01 00:05:58.000000', 'consum', 0.0211, 'lps'),
	(564615, 130, '2014-03-01 00:05:59.000000', 'consum', 0.0224, 'lps'),
	(564616, 130, '2014-03-01 00:06:00.000000', 'consum', 0.0222, 'lps'),
	(564617, 130, '2014-03-01 00:06:01.000000', 'consum', 0.0228, 'lps'),
	(564618, 130, '2014-03-01 00:06:02.000000', 'consum', 0.0225, 'lps'),
	(564619, 130, '2014-03-01 00:06:03.000000', 'consum', 0.0215, 'lps'),
	(564620, 130, '2014-03-01 00:06:04.000000', 'consum', 0.0227, 'lps'),
	(564621, 130, '2014-03-01 00:06:05.000000', 'consum', 0.0223, 'lps'),
	(564622, 130, '2014-03-01 00:06:06.000000', 'consum', 0.0223, 'lps'),
	(564623, 130, '2014-03-01 00:06:07.000000', 'consum', 0.0220, 'lps'),
	(564624, 130, '2014-03-01 00:06:08.000000', 'consum', 0.0220, 'lps'),
	(564625, 130, '2014-03-01 00:06:09.000000', 'consum', 0.0214, 'lps'),
	(564626, 130, '2014-03-01 00:06:10.000000', 'consum', 0.0217, 'lps'),
	(564627, 130, '2014-03-01 00:06:11.000000', 'consum', 0.0214, 'lps'),
	(564628, 130, '2014-03-01 00:06:12.000000', 'consum', 0.0212, 'lps'),
	(564629, 130, '2014-03-01 00:06:13.000000', 'consum', 0.0228, 'lps'),
	(564630, 130, '2014-03-01 00:06:14.000000', 'consum', 0.0219, 'lps'),
	(564631, 130, '2014-03-01 00:06:15.000000', 'consum', 0.0219, 'lps'),
	(564632, 130, '2014-03-01 00:06:16.000000', 'consum', 0.0211, 'lps'),
	(564633, 130, '2014-03-01 00:06:17.000000', 'consum', 0.0225, 'lps'),
	(564634, 130, '2014-03-01 00:06:18.000000', 'consum', 0.0227, 'lps'),
	(564635, 130, '2014-03-01 00:06:19.000000', 'consum', 0.0212, 'lps'),
	(564636, 130, '2014-03-01 00:06:20.000000', 'consum', 0.0225, 'lps'),
	(564637, 130, '2014-03-01 00:06:21.000000', 'consum', 0.0222, 'lps'),
	(564638, 130, '2014-03-01 00:06:22.000000', 'consum', 0.0226, 'lps'),
	(564639, 130, '2014-03-01 00:06:23.000000', 'consum', 0.0217, 'lps'),
	(564640, 130, '2014-03-01 00:06:24.000000', 'consum', 0.0218, 'lps'),
	(564641, 130, '2014-03-01 00:06:25.000000', 'consum', 0.0227, 'lps'),
	(564642, 130, '2014-03-01 00:06:26.000000', 'consum', 0.0215, 'lps'),
	(564643, 130, '2014-03-01 00:06:27.000000', 'consum', 0.0221, 'lps'),
	(564644, 130, '2014-03-01 00:06:28.000000', 'consum', 0.0215, 'lps'),
	(564645, 130, '2014-03-01 00:06:29.000000', 'consum', 0.0221, 'lps'),
	(564646, 130, '2014-03-01 00:06:30.000000', 'consum', 0.0212, 'lps'),
	(564647, 130, '2014-03-01 00:06:31.000000', 'consum', 0.0225, 'lps'),
	(564648, 130, '2014-03-01 00:06:32.000000', 'consum', 0.0223, 'lps'),
	(564649, 130, '2014-03-01 00:06:33.000000', 'consum', 0.0213, 'lps'),
	(564650, 130, '2014-03-01 00:06:34.000000', 'consum', 0.0223, 'lps'),
	(564651, 130, '2014-03-01 00:06:35.000000', 'consum', 0.0227, 'lps'),
	(564652, 130, '2014-03-01 00:06:36.000000', 'consum', 0.0220, 'lps'),
	(564653, 130, '2014-03-01 00:06:37.000000', 'consum', 0.0228, 'lps'),
	(564654, 130, '2014-03-01 00:06:38.000000', 'consum', 0.0214, 'lps'),
	(564655, 130, '2014-03-01 00:06:39.000000', 'consum', 0.0216, 'lps'),
	(564656, 130, '2014-03-01 00:06:40.000000', 'consum', 0.0227, 'lps'),
	(564657, 130, '2014-03-01 00:06:41.000000', 'consum', 0.0219, 'lps'),
	(564658, 130, '2014-03-01 00:06:42.000000', 'consum', 0.0226, 'lps'),
	(564659, 130, '2014-03-01 00:06:43.000000', 'consum', 0.0225, 'lps'),
	(564660, 130, '2014-03-01 00:06:44.000000', 'consum', 0.0217, 'lps'),
	(564661, 130, '2014-03-01 00:06:45.000000', 'consum', 0.0219, 'lps'),
	(564662, 130, '2014-03-01 00:06:46.000000', 'consum', 0.0217, 'lps'),
	(564663, 130, '2014-03-01 00:06:47.000000', 'consum', 0.0218, 'lps'),
	(564664, 130, '2014-03-01 00:06:48.000000', 'consum', 0.0212, 'lps'),
	(564665, 130, '2014-03-01 00:06:49.000000', 'consum', 0.0213, 'lps'),
	(564666, 130, '2014-03-01 00:06:50.000000', 'consum', 0.0219, 'lps'),
	(564667, 130, '2014-03-01 00:06:51.000000', 'consum', 0.0211, 'lps'),
	(564668, 130, '2014-03-01 00:06:52.000000', 'consum', 0.0226, 'lps'),
	(564669, 130, '2014-03-01 00:06:53.000000', 'consum', 0.0213, 'lps'),
	(564670, 130, '2014-03-01 00:06:54.000000', 'consum', 0.0214, 'lps'),
	(564671, 130, '2014-03-01 00:06:55.000000', 'consum', 0.0221, 'lps'),
	(564672, 130, '2014-03-01 00:06:56.000000', 'consum', 0.0216, 'lps'),
	(564673, 130, '2014-03-01 00:06:57.000000', 'consum', 0.0225, 'lps'),
	(564674, 130, '2014-03-01 00:06:58.000000', 'consum', 0.0213, 'lps'),
	(564675, 130, '2014-03-01 00:06:59.000000', 'consum', 0.0215, 'lps'),
	(564676, 130, '2014-03-01 00:07:00.000000', 'consum', 0.0211, 'lps'),
	(564677, 130, '2014-03-01 00:07:01.000000', 'consum', 0.0217, 'lps'),
	(564678, 130, '2014-03-01 00:07:02.000000', 'consum', 0.0223, 'lps'),
	(564679, 130, '2014-03-01 00:07:03.000000', 'consum', 0.0216, 'lps'),
	(564680, 130, '2014-03-01 00:07:04.000000', 'consum', 0.0220, 'lps'),
	(564681, 130, '2014-03-01 00:07:05.000000', 'consum', 0.0226, 'lps'),
	(564682, 130, '2014-03-01 00:07:06.000000', 'consum', 0.0222, 'lps'),
	(564683, 130, '2014-03-01 00:07:07.000000', 'consum', 0.0222, 'lps'),
	(564684, 130, '2014-03-01 00:07:08.000000', 'consum', 0.0215, 'lps'),
	(564685, 130, '2014-03-01 00:07:09.000000', 'consum', 0.0218, 'lps'),
	(564686, 130, '2014-03-01 00:07:10.000000', 'consum', 0.0218, 'lps'),
	(564687, 130, '2014-03-01 00:07:11.000000', 'consum', 0.0226, 'lps'),
	(564688, 130, '2014-03-01 00:07:12.000000', 'consum', 0.0227, 'lps'),
	(564689, 130, '2014-03-01 00:07:13.000000', 'consum', 0.0228, 'lps'),
	(564690, 130, '2014-03-01 00:07:14.000000', 'consum', 0.0212, 'lps'),
	(564691, 130, '2014-03-01 00:07:15.000000', 'consum', 0.0223, 'lps'),
	(564692, 130, '2014-03-01 00:07:16.000000', 'consum', 0.0213, 'lps'),
	(564693, 130, '2014-03-01 00:07:17.000000', 'consum', 0.0223, 'lps'),
	(564694, 130, '2014-03-01 00:07:18.000000', 'consum', 0.0211, 'lps'),
	(564695, 130, '2014-03-01 00:07:19.000000', 'consum', 0.0215, 'lps'),
	(564696, 130, '2014-03-01 00:07:20.000000', 'consum', 0.0213, 'lps'),
	(564697, 130, '2014-03-01 00:07:21.000000', 'consum', 0.0228, 'lps'),
	(564698, 130, '2014-03-01 00:07:22.000000', 'consum', 0.0216, 'lps'),
	(564699, 130, '2014-03-01 00:07:23.000000', 'consum', 0.0223, 'lps'),
	(564700, 130, '2014-03-01 00:07:24.000000', 'consum', 0.0222, 'lps'),
	(564701, 130, '2014-03-01 00:07:25.000000', 'consum', 0.0213, 'lps'),
	(564702, 130, '2014-03-01 00:07:26.000000', 'consum', 0.0226, 'lps'),
	(564703, 130, '2014-03-01 00:07:27.000000', 'consum', 0.0227, 'lps'),
	(564704, 130, '2014-03-01 00:07:28.000000', 'consum', 0.0227, 'lps'),
	(564705, 130, '2014-03-01 00:07:29.000000', 'consum', 0.0224, 'lps'),
	(564706, 130, '2014-03-01 00:07:30.000000', 'consum', 0.0212, 'lps'),
	(564707, 130, '2014-03-01 00:07:31.000000', 'consum', 0.0214, 'lps'),
	(564708, 130, '2014-03-01 00:07:32.000000', 'consum', 0.0228, 'lps'),
	(564709, 130, '2014-03-01 00:07:33.000000', 'consum', 0.0210, 'lps'),
	(564710, 130, '2014-03-01 00:07:34.000000', 'consum', 0.0214, 'lps'),
	(564711, 130, '2014-03-01 00:07:35.000000', 'consum', 0.0214, 'lps'),
	(564712, 130, '2014-03-01 00:07:36.000000', 'consum', 0.0216, 'lps'),
	(564713, 130, '2014-03-01 00:07:37.000000', 'consum', 0.0210, 'lps'),
	(564714, 130, '2014-03-01 00:07:38.000000', 'consum', 0.0213, 'lps'),
	(564715, 130, '2014-03-01 00:07:39.000000', 'consum', 0.0225, 'lps'),
	(564716, 130, '2014-03-01 00:07:40.000000', 'consum', 0.0218, 'lps'),
	(564717, 130, '2014-03-01 00:07:41.000000', 'consum', 0.0226, 'lps'),
	(564718, 130, '2014-03-01 00:07:42.000000', 'consum', 0.0210, 'lps'),
	(564719, 130, '2014-03-01 00:07:43.000000', 'consum', 0.0219, 'lps'),
	(564720, 130, '2014-03-01 00:07:44.000000', 'consum', 0.0218, 'lps'),
	(564721, 130, '2014-03-01 00:07:45.000000', 'consum', 0.0224, 'lps'),
	(564722, 130, '2014-03-01 00:07:46.000000', 'consum', 0.0219, 'lps'),
	(564723, 130, '2014-03-01 00:07:47.000000', 'consum', 0.0214, 'lps'),
	(564724, 130, '2014-03-01 00:07:48.000000', 'consum', 0.0222, 'lps'),
	(564725, 130, '2014-03-01 00:07:49.000000', 'consum', 0.0219, 'lps'),
	(564726, 130, '2014-03-01 00:07:50.000000', 'consum', 0.0221, 'lps'),
	(564727, 130, '2014-03-01 00:07:51.000000', 'consum', 0.0218, 'lps'),
	(564728, 130, '2014-03-01 00:07:52.000000', 'consum', 0.0218, 'lps'),
	(564729, 130, '2014-03-01 00:07:53.000000', 'consum', 0.0225, 'lps'),
	(564730, 130, '2014-03-01 00:07:54.000000', 'consum', 0.0225, 'lps'),
	(564731, 130, '2014-03-01 00:07:55.000000', 'consum', 0.0221, 'lps'),
	(564732, 130, '2014-03-01 00:07:56.000000', 'consum', 0.0220, 'lps'),
	(564733, 130, '2014-03-01 00:07:57.000000', 'consum', 0.0210, 'lps'),
	(564734, 130, '2014-03-01 00:07:58.000000', 'consum', 0.0220, 'lps'),
	(564735, 130, '2014-03-01 00:07:59.000000', 'consum', 0.0220, 'lps'),
	(564736, 130, '2014-03-01 00:08:00.000000', 'consum', 0.0214, 'lps'),
	(564737, 130, '2014-03-01 00:08:01.000000', 'consum', 0.0216, 'lps'),
	(564738, 130, '2014-03-01 00:08:02.000000', 'consum', 0.0213, 'lps'),
	(564739, 130, '2014-03-01 00:08:03.000000', 'consum', 0.0225, 'lps'),
	(564740, 130, '2014-03-01 00:08:04.000000', 'consum', 0.0218, 'lps'),
	(564741, 130, '2014-03-01 00:08:05.000000', 'consum', 0.0224, 'lps'),
	(564742, 130, '2014-03-01 00:08:06.000000', 'consum', 0.0220, 'lps'),
	(564743, 130, '2014-03-01 00:08:07.000000', 'consum', 0.0218, 'lps'),
	(564744, 130, '2014-03-01 00:08:08.000000', 'consum', 0.0222, 'lps'),
	(564745, 130, '2014-03-01 00:08:09.000000', 'consum', 0.0226, 'lps'),
	(564746, 130, '2014-03-01 00:08:10.000000', 'consum', 0.0215, 'lps'),
	(564747, 130, '2014-03-01 00:08:11.000000', 'consum', 0.0226, 'lps'),
	(564748, 130, '2014-03-01 00:08:12.000000', 'consum', 0.0221, 'lps'),
	(564749, 130, '2014-03-01 00:08:13.000000', 'consum', 0.0217, 'lps'),
	(564750, 130, '2014-03-01 00:08:14.000000', 'consum', 0.0210, 'lps'),
	(564751, 130, '2014-03-01 00:08:15.000000', 'consum', 0.0212, 'lps'),
	(564752, 130, '2014-03-01 00:08:16.000000', 'consum', 0.0219, 'lps'),
	(564753, 130, '2014-03-01 00:08:17.000000', 'consum', 0.0210, 'lps'),
	(564754, 130, '2014-03-01 00:08:18.000000', 'consum', 0.0224, 'lps'),
	(564755, 130, '2014-03-01 00:08:19.000000', 'consum', 0.0221, 'lps'),
	(564756, 130, '2014-03-01 00:08:20.000000', 'consum', 0.0223, 'lps'),
	(564757, 130, '2014-03-01 00:08:21.000000', 'consum', 0.0226, 'lps'),
	(564758, 130, '2014-03-01 00:08:22.000000', 'consum', 0.0213, 'lps'),
	(564759, 130, '2014-03-01 00:08:23.000000', 'consum', 0.0215, 'lps'),
	(564760, 130, '2014-03-01 00:08:24.000000', 'consum', 0.0226, 'lps'),
	(564761, 130, '2014-03-01 00:08:25.000000', 'consum', 0.0220, 'lps'),
	(564762, 130, '2014-03-01 00:08:26.000000', 'consum', 0.0210, 'lps'),
	(564763, 130, '2014-03-01 00:08:27.000000', 'consum', 0.0220, 'lps'),
	(564764, 130, '2014-03-01 00:08:28.000000', 'consum', 0.0223, 'lps'),
	(564765, 130, '2014-03-01 00:08:29.000000', 'consum', 0.0225, 'lps'),
	(564766, 130, '2014-03-01 00:08:30.000000', 'consum', 0.0211, 'lps'),
	(564767, 130, '2014-03-01 00:08:31.000000', 'consum', 0.0226, 'lps'),
	(564768, 130, '2014-03-01 00:08:32.000000', 'consum', 0.0213, 'lps'),
	(564769, 130, '2014-03-01 00:08:33.000000', 'consum', 0.0217, 'lps'),
	(564770, 130, '2014-03-01 00:08:34.000000', 'consum', 0.0214, 'lps'),
	(564771, 130, '2014-03-01 00:08:35.000000', 'consum', 0.0212, 'lps'),
	(564772, 130, '2014-03-01 00:08:36.000000', 'consum', 0.0226, 'lps'),
	(564773, 130, '2014-03-01 00:08:37.000000', 'consum', 0.0227, 'lps'),
	(564774, 130, '2014-03-01 00:08:38.000000', 'consum', 0.0227, 'lps'),
	(564775, 130, '2014-03-01 00:08:39.000000', 'consum', 0.0227, 'lps'),
	(564776, 130, '2014-03-01 00:08:40.000000', 'consum', 0.0226, 'lps'),
	(564777, 130, '2014-03-01 00:08:41.000000', 'consum', 0.0219, 'lps'),
	(564778, 130, '2014-03-01 00:08:42.000000', 'consum', 0.0227, 'lps'),
	(564779, 130, '2014-03-01 00:08:43.000000', 'consum', 0.0211, 'lps'),
	(564780, 130, '2014-03-01 00:08:44.000000', 'consum', 0.0224, 'lps'),
	(564781, 130, '2014-03-01 00:08:45.000000', 'consum', 0.0220, 'lps'),
	(564782, 130, '2014-03-01 00:08:46.000000', 'consum', 0.0216, 'lps'),
	(564783, 130, '2014-03-01 00:08:47.000000', 'consum', 0.0211, 'lps'),
	(564784, 130, '2014-03-01 00:08:48.000000', 'consum', 0.0217, 'lps'),
	(564785, 130, '2014-03-01 00:08:49.000000', 'consum', 0.0224, 'lps'),
	(564786, 130, '2014-03-01 00:08:50.000000', 'consum', 0.0223, 'lps'),
	(564787, 130, '2014-03-01 00:08:51.000000', 'consum', 0.0214, 'lps'),
	(564788, 130, '2014-03-01 00:08:52.000000', 'consum', 0.0212, 'lps'),
	(564789, 130, '2014-03-01 00:08:53.000000', 'consum', 0.0226, 'lps'),
	(564790, 130, '2014-03-01 00:08:54.000000', 'consum', 0.0228, 'lps'),
	(564791, 130, '2014-03-01 00:08:55.000000', 'consum', 0.0216, 'lps'),
	(564792, 130, '2014-03-01 00:08:56.000000', 'consum', 0.0222, 'lps'),
	(564793, 130, '2014-03-01 00:08:57.000000', 'consum', 0.0217, 'lps'),
	(564794, 130, '2014-03-01 00:08:58.000000', 'consum', 0.0210, 'lps'),
	(564795, 130, '2014-03-01 00:08:59.000000', 'consum', 0.0227, 'lps'),
	(564796, 130, '2014-03-01 00:09:00.000000', 'consum', 0.0220, 'lps'),
	(564797, 130, '2014-03-01 00:09:01.000000', 'consum', 0.0227, 'lps'),
	(564798, 130, '2014-03-01 00:09:02.000000', 'consum', 0.0211, 'lps'),
	(564799, 130, '2014-03-01 00:09:03.000000', 'consum', 0.0220, 'lps'),
	(564800, 130, '2014-03-01 00:09:04.000000', 'consum', 0.0219, 'lps'),
	(564801, 130, '2014-03-01 00:09:05.000000', 'consum', 0.0224, 'lps'),
	(564802, 130, '2014-03-01 00:09:06.000000', 'consum', 0.0218, 'lps'),
	(564803, 130, '2014-03-01 00:09:07.000000', 'consum', 0.0225, 'lps'),
	(564804, 130, '2014-03-01 00:09:08.000000', 'consum', 0.0226, 'lps'),
	(564805, 130, '2014-03-01 00:09:09.000000', 'consum', 0.0225, 'lps'),
	(564806, 130, '2014-03-01 00:09:10.000000', 'consum', 0.0218, 'lps'),
	(564807, 130, '2014-03-01 00:09:11.000000', 'consum', 0.0224, 'lps'),
	(564808, 130, '2014-03-01 00:09:12.000000', 'consum', 0.0220, 'lps'),
	(564809, 130, '2014-03-01 00:09:13.000000', 'consum', 0.0217, 'lps'),
	(564810, 130, '2014-03-01 00:09:14.000000', 'consum', 0.0216, 'lps'),
	(564811, 130, '2014-03-01 00:09:15.000000', 'consum', 0.0221, 'lps'),
	(564812, 130, '2014-03-01 00:09:16.000000', 'consum', 0.0228, 'lps'),
	(564813, 130, '2014-03-01 00:09:17.000000', 'consum', 0.0228, 'lps'),
	(564814, 130, '2014-03-01 00:09:18.000000', 'consum', 0.0211, 'lps'),
	(564815, 130, '2014-03-01 00:09:19.000000', 'consum', 0.0217, 'lps'),
	(564816, 130, '2014-03-01 00:09:20.000000', 'consum', 0.0225, 'lps'),
	(564817, 130, '2014-03-01 00:09:21.000000', 'consum', 0.0225, 'lps'),
	(564818, 130, '2014-03-01 00:09:22.000000', 'consum', 0.0220, 'lps'),
	(564819, 130, '2014-03-01 00:09:23.000000', 'consum', 0.0216, 'lps'),
	(564820, 130, '2014-03-01 00:09:24.000000', 'consum', 0.0212, 'lps'),
	(564821, 130, '2014-03-01 00:09:25.000000', 'consum', 0.0221, 'lps'),
	(564822, 130, '2014-03-01 00:09:26.000000', 'consum', 0.0222, 'lps'),
	(564823, 130, '2014-03-01 00:09:27.000000', 'consum', 0.0217, 'lps'),
	(564824, 130, '2014-03-01 00:09:28.000000', 'consum', 0.0227, 'lps'),
	(564825, 130, '2014-03-01 00:09:29.000000', 'consum', 0.0221, 'lps'),
	(564826, 130, '2014-03-01 00:09:30.000000', 'consum', 0.0213, 'lps'),
	(564827, 130, '2014-03-01 00:09:31.000000', 'consum', 0.0212, 'lps'),
	(564828, 130, '2014-03-01 00:09:32.000000', 'consum', 0.0211, 'lps'),
	(564829, 130, '2014-03-01 00:09:33.000000', 'consum', 0.0211, 'lps'),
	(564830, 130, '2014-03-01 00:09:34.000000', 'consum', 0.0210, 'lps'),
	(564831, 130, '2014-03-01 00:09:35.000000', 'consum', 0.0227, 'lps'),
	(564832, 130, '2014-03-01 00:09:36.000000', 'consum', 0.0220, 'lps'),
	(564833, 130, '2014-03-01 00:09:37.000000', 'consum', 0.0228, 'lps'),
	(564834, 130, '2014-03-01 00:09:38.000000', 'consum', 0.0212, 'lps'),
	(564835, 130, '2014-03-01 00:09:39.000000', 'consum', 0.0227, 'lps'),
	(564836, 130, '2014-03-01 00:09:40.000000', 'consum', 0.0211, 'lps'),
	(564837, 130, '2014-03-01 00:09:41.000000', 'consum', 0.0221, 'lps'),
	(564838, 130, '2014-03-01 00:09:42.000000', 'consum', 0.0226, 'lps'),
	(564839, 130, '2014-03-01 00:09:43.000000', 'consum', 0.0218, 'lps'),
	(564840, 130, '2014-03-01 00:09:44.000000', 'consum', 0.0222, 'lps'),
	(564841, 130, '2014-03-01 00:09:45.000000', 'consum', 0.0226, 'lps'),
	(564842, 130, '2014-03-01 00:09:46.000000', 'consum', 0.0217, 'lps'),
	(564843, 130, '2014-03-01 00:09:47.000000', 'consum', 0.0216, 'lps'),
	(564844, 130, '2014-03-01 00:09:48.000000', 'consum', 0.0218, 'lps'),
	(564845, 130, '2014-03-01 00:09:49.000000', 'consum', 0.0217, 'lps'),
	(564846, 130, '2014-03-01 00:09:50.000000', 'consum', 0.0221, 'lps'),
	(564847, 130, '2014-03-01 00:09:51.000000', 'consum', 0.0223, 'lps'),
	(564848, 130, '2014-03-01 00:09:52.000000', 'consum', 0.0227, 'lps'),
	(564849, 130, '2014-03-01 00:09:53.000000', 'consum', 0.0216, 'lps'),
	(564850, 130, '2014-03-01 00:09:54.000000', 'consum', 0.0228, 'lps'),
	(564851, 130, '2014-03-01 00:09:55.000000', 'consum', 0.0226, 'lps'),
	(564852, 130, '2014-03-01 00:09:56.000000', 'consum', 0.0219, 'lps'),
	(564853, 130, '2014-03-01 00:09:57.000000', 'consum', 0.0224, 'lps'),
	(564854, 130, '2014-03-01 00:09:58.000000', 'consum', 0.0217, 'lps'),
	(564855, 130, '2014-03-01 00:09:59.000000', 'consum', 0.0222, 'lps'),
	(564856, 130, '2014-03-01 00:10:00.000000', 'consum', 0.0210, 'lps'),
	(564857, 130, '2014-03-01 00:10:01.000000', 'consum', 0.0215, 'lps'),
	(564858, 130, '2014-03-01 00:10:02.000000', 'consum', 0.0214, 'lps'),
	(564859, 130, '2014-03-01 00:10:03.000000', 'consum', 0.0218, 'lps'),
	(564860, 130, '2014-03-01 00:10:04.000000', 'consum', 0.0217, 'lps'),
	(564861, 130, '2014-03-01 00:10:05.000000', 'consum', 0.0224, 'lps'),
	(564862, 130, '2014-03-01 00:10:06.000000', 'consum', 0.0222, 'lps'),
	(564863, 130, '2014-03-01 00:10:07.000000', 'consum', 0.0227, 'lps'),
	(564864, 130, '2014-03-01 00:10:08.000000', 'consum', 0.0222, 'lps'),
	(564865, 130, '2014-03-01 00:10:09.000000', 'consum', 0.0218, 'lps'),
	(564866, 130, '2014-03-01 00:10:10.000000', 'consum', 0.0214, 'lps'),
	(564867, 130, '2014-03-01 00:10:11.000000', 'consum', 0.0225, 'lps'),
	(564868, 130, '2014-03-01 00:10:12.000000', 'consum', 0.0216, 'lps'),
	(564869, 130, '2014-03-01 00:10:13.000000', 'consum', 0.0215, 'lps'),
	(564870, 130, '2014-03-01 00:10:14.000000', 'consum', 0.0216, 'lps'),
	(564871, 130, '2014-03-01 00:10:15.000000', 'consum', 0.0226, 'lps'),
	(564872, 130, '2014-03-01 00:10:16.000000', 'consum', 0.0216, 'lps'),
	(564873, 130, '2014-03-01 00:10:17.000000', 'consum', 0.0210, 'lps'),
	(564874, 130, '2014-03-01 00:10:18.000000', 'consum', 0.0211, 'lps'),
	(564875, 130, '2014-03-01 00:10:19.000000', 'consum', 0.0216, 'lps'),
	(564876, 130, '2014-03-01 00:10:20.000000', 'consum', 0.0219, 'lps'),
	(564877, 130, '2014-03-01 00:10:21.000000', 'consum', 0.0216, 'lps'),
	(564878, 130, '2014-03-01 00:10:22.000000', 'consum', 0.0217, 'lps'),
	(564879, 130, '2014-03-01 00:10:23.000000', 'consum', 0.0228, 'lps'),
	(564880, 130, '2014-03-01 00:10:24.000000', 'consum', 0.0220, 'lps'),
	(564881, 130, '2014-03-01 00:10:25.000000', 'consum', 0.0226, 'lps'),
	(564882, 130, '2014-03-01 00:10:26.000000', 'consum', 0.0223, 'lps'),
	(564883, 130, '2014-03-01 00:10:27.000000', 'consum', 0.0226, 'lps'),
	(564884, 130, '2014-03-01 00:10:28.000000', 'consum', 0.0216, 'lps'),
	(564885, 130, '2014-03-01 00:10:29.000000', 'consum', 0.0211, 'lps'),
	(564886, 130, '2014-03-01 00:10:30.000000', 'consum', 0.0214, 'lps'),
	(564887, 130, '2014-03-01 00:10:31.000000', 'consum', 0.0212, 'lps'),
	(564888, 130, '2014-03-01 00:10:32.000000', 'consum', 0.0225, 'lps'),
	(564889, 130, '2014-03-01 00:10:33.000000', 'consum', 0.0222, 'lps'),
	(564890, 130, '2014-03-01 00:10:34.000000', 'consum', 0.0227, 'lps'),
	(564891, 130, '2014-03-01 00:10:35.000000', 'consum', 0.0223, 'lps'),
	(564892, 130, '2014-03-01 00:10:36.000000', 'consum', 0.0223, 'lps'),
	(564893, 130, '2014-03-01 00:10:37.000000', 'consum', 0.0216, 'lps'),
	(564894, 130, '2014-03-01 00:10:38.000000', 'consum', 0.0223, 'lps'),
	(564895, 130, '2014-03-01 00:10:39.000000', 'consum', 0.0218, 'lps'),
	(564896, 130, '2014-03-01 00:10:40.000000', 'consum', 0.0214, 'lps'),
	(564897, 130, '2014-03-01 00:10:41.000000', 'consum', 0.0223, 'lps'),
	(564898, 130, '2014-03-01 00:10:42.000000', 'consum', 0.0228, 'lps'),
	(564899, 130, '2014-03-01 00:10:43.000000', 'consum', 0.0222, 'lps'),
	(564900, 130, '2014-03-01 00:10:44.000000', 'consum', 0.0215, 'lps'),
	(564901, 130, '2014-03-01 00:10:45.000000', 'consum', 0.0219, 'lps'),
	(564902, 130, '2014-03-01 00:10:46.000000', 'consum', 0.0222, 'lps'),
	(564903, 130, '2014-03-01 00:10:47.000000', 'consum', 0.0224, 'lps'),
	(564904, 130, '2014-03-01 00:10:48.000000', 'consum', 0.0224, 'lps'),
	(564905, 130, '2014-03-01 00:10:49.000000', 'consum', 0.0222, 'lps'),
	(564906, 130, '2014-03-01 00:10:50.000000', 'consum', 0.0210, 'lps'),
	(564907, 130, '2014-03-01 00:10:51.000000', 'consum', 0.0212, 'lps'),
	(564908, 130, '2014-03-01 00:10:52.000000', 'consum', 0.0220, 'lps'),
	(564909, 130, '2014-03-01 00:10:53.000000', 'consum', 0.0216, 'lps'),
	(564910, 130, '2014-03-01 00:10:54.000000', 'consum', 0.0210, 'lps'),
	(564911, 130, '2014-03-01 00:10:55.000000', 'consum', 0.0214, 'lps'),
	(564912, 130, '2014-03-01 00:10:56.000000', 'consum', 0.0210, 'lps'),
	(564913, 130, '2014-03-01 00:10:57.000000', 'consum', 0.0217, 'lps'),
	(564914, 130, '2014-03-01 00:10:58.000000', 'consum', 0.0226, 'lps'),
	(564915, 130, '2014-03-01 00:10:59.000000', 'consum', 0.0211, 'lps'),
	(564916, 130, '2014-03-01 00:11:00.000000', 'consum', 0.0228, 'lps'),
	(564917, 130, '2014-03-01 00:11:01.000000', 'consum', 0.0218, 'lps'),
	(564918, 130, '2014-03-01 00:11:02.000000', 'consum', 0.0218, 'lps'),
	(564919, 130, '2014-03-01 00:11:03.000000', 'consum', 0.0225, 'lps'),
	(564920, 130, '2014-03-01 00:11:04.000000', 'consum', 0.0226, 'lps'),
	(564921, 130, '2014-03-01 00:11:05.000000', 'consum', 0.0224, 'lps'),
	(564922, 130, '2014-03-01 00:11:06.000000', 'consum', 0.0216, 'lps'),
	(564923, 130, '2014-03-01 00:11:07.000000', 'consum', 0.0216, 'lps'),
	(564924, 130, '2014-03-01 00:11:08.000000', 'consum', 0.0221, 'lps'),
	(564925, 130, '2014-03-01 00:11:09.000000', 'consum', 0.0210, 'lps'),
	(564926, 130, '2014-03-01 00:11:10.000000', 'consum', 0.0214, 'lps'),
	(564927, 130, '2014-03-01 00:11:11.000000', 'consum', 0.0212, 'lps'),
	(564928, 130, '2014-03-01 00:11:12.000000', 'consum', 0.0210, 'lps'),
	(564929, 130, '2014-03-01 00:11:13.000000', 'consum', 0.0223, 'lps'),
	(564930, 130, '2014-03-01 00:11:14.000000', 'consum', 0.0219, 'lps'),
	(564931, 130, '2014-03-01 00:11:15.000000', 'consum', 0.0215, 'lps'),
	(564932, 130, '2014-03-01 00:11:16.000000', 'consum', 0.0228, 'lps'),
	(564933, 130, '2014-03-01 00:11:17.000000', 'consum', 0.0210, 'lps'),
	(564934, 130, '2014-03-01 00:11:18.000000', 'consum', 0.0213, 'lps'),
	(564935, 130, '2014-03-01 00:11:19.000000', 'consum', 0.0227, 'lps'),
	(564936, 130, '2014-03-01 00:11:20.000000', 'consum', 0.0211, 'lps'),
	(564937, 130, '2014-03-01 00:11:21.000000', 'consum', 0.0221, 'lps'),
	(564938, 130, '2014-03-01 00:11:22.000000', 'consum', 0.0224, 'lps'),
	(564939, 130, '2014-03-01 00:11:23.000000', 'consum', 0.0211, 'lps'),
	(564940, 130, '2014-03-01 00:11:24.000000', 'consum', 0.0228, 'lps'),
	(564941, 130, '2014-03-01 00:11:25.000000', 'consum', 0.0221, 'lps'),
	(564942, 130, '2014-03-01 00:11:26.000000', 'consum', 0.0212, 'lps'),
	(564943, 130, '2014-03-01 00:11:27.000000', 'consum', 0.0227, 'lps'),
	(564944, 130, '2014-03-01 00:11:28.000000', 'consum', 0.0212, 'lps'),
	(564945, 130, '2014-03-01 00:11:29.000000', 'consum', 0.0226, 'lps'),
	(564946, 130, '2014-03-01 00:11:30.000000', 'consum', 0.0210, 'lps'),
	(564947, 130, '2014-03-01 00:11:31.000000', 'consum', 0.0221, 'lps'),
	(564948, 130, '2014-03-01 00:11:32.000000', 'consum', 0.0226, 'lps'),
	(564949, 130, '2014-03-01 00:11:33.000000', 'consum', 0.0218, 'lps'),
	(564950, 130, '2014-03-01 00:11:34.000000', 'consum', 0.0224, 'lps'),
	(564951, 130, '2014-03-01 00:11:35.000000', 'consum', 0.0218, 'lps'),
	(564952, 130, '2014-03-01 00:11:36.000000', 'consum', 0.0228, 'lps'),
	(564953, 130, '2014-03-01 00:11:37.000000', 'consum', 0.0219, 'lps'),
	(564954, 130, '2014-03-01 00:11:38.000000', 'consum', 0.0219, 'lps'),
	(564955, 130, '2014-03-01 00:11:39.000000', 'consum', 0.0211, 'lps'),
	(564956, 130, '2014-03-01 00:11:40.000000', 'consum', 0.0225, 'lps'),
	(564957, 130, '2014-03-01 00:11:41.000000', 'consum', 0.0227, 'lps'),
	(564958, 130, '2014-03-01 00:11:42.000000', 'consum', 0.0212, 'lps'),
	(564959, 130, '2014-03-01 00:11:43.000000', 'consum', 0.0227, 'lps'),
	(564960, 130, '2014-03-01 00:11:44.000000', 'consum', 0.0213, 'lps'),
	(564961, 130, '2014-03-01 00:11:45.000000', 'consum', 0.0213, 'lps'),
	(564962, 130, '2014-03-01 00:11:46.000000', 'consum', 0.0218, 'lps'),
	(564963, 130, '2014-03-01 00:11:47.000000', 'consum', 0.0222, 'lps'),
	(564964, 130, '2014-03-01 00:11:48.000000', 'consum', 0.0210, 'lps'),
	(564965, 130, '2014-03-01 00:11:49.000000', 'consum', 0.0210, 'lps'),
	(564966, 130, '2014-03-01 00:11:50.000000', 'consum', 0.0228, 'lps'),
	(564967, 130, '2014-03-01 00:11:51.000000', 'consum', 0.0227, 'lps'),
	(564968, 130, '2014-03-01 00:11:52.000000', 'consum', 0.0222, 'lps'),
	(564969, 130, '2014-03-01 00:11:53.000000', 'consum', 0.0220, 'lps'),
	(564970, 130, '2014-03-01 00:11:54.000000', 'consum', 0.0222, 'lps'),
	(564971, 130, '2014-03-01 00:11:55.000000', 'consum', 0.0224, 'lps'),
	(564972, 130, '2014-03-01 00:11:56.000000', 'consum', 0.0225, 'lps'),
	(564973, 130, '2014-03-01 00:11:57.000000', 'consum', 0.0223, 'lps'),
	(564974, 130, '2014-03-01 00:11:58.000000', 'consum', 0.0211, 'lps'),
	(564975, 130, '2014-03-01 00:11:59.000000', 'consum', 0.0215, 'lps'),
	(564976, 130, '2014-03-01 00:12:00.000000', 'consum', 0.0215, 'lps'),
	(564977, 130, '2014-03-01 00:12:01.000000', 'consum', 0.0220, 'lps'),
	(564978, 130, '2014-03-01 00:12:02.000000', 'consum', 0.0227, 'lps'),
	(564979, 130, '2014-03-01 00:12:03.000000', 'consum', 0.0227, 'lps'),
	(564980, 130, '2014-03-01 00:12:04.000000', 'consum', 0.0228, 'lps'),
	(564981, 130, '2014-03-01 00:12:05.000000', 'consum', 0.0227, 'lps'),
	(564982, 130, '2014-03-01 00:12:06.000000', 'consum', 0.0225, 'lps'),
	(564983, 130, '2014-03-01 00:12:07.000000', 'consum', 0.0213, 'lps'),
	(564984, 130, '2014-03-01 00:12:08.000000', 'consum', 0.0221, 'lps'),
	(564985, 130, '2014-03-01 00:12:09.000000', 'consum', 0.0219, 'lps'),
	(564986, 130, '2014-03-01 00:12:10.000000', 'consum', 0.0219, 'lps'),
	(564987, 130, '2014-03-01 00:12:11.000000', 'consum', 0.0213, 'lps'),
	(564988, 130, '2014-03-01 00:12:12.000000', 'consum', 0.0217, 'lps'),
	(564989, 130, '2014-03-01 00:12:13.000000', 'consum', 0.0218, 'lps'),
	(564990, 130, '2014-03-01 00:12:14.000000', 'consum', 0.0210, 'lps'),
	(564991, 130, '2014-03-01 00:12:15.000000', 'consum', 0.0226, 'lps'),
	(564992, 130, '2014-03-01 00:12:16.000000', 'consum', 0.0212, 'lps'),
	(564993, 130, '2014-03-01 00:12:17.000000', 'consum', 0.0213, 'lps'),
	(564994, 130, '2014-03-01 00:12:18.000000', 'consum', 0.0217, 'lps'),
	(564995, 130, '2014-03-01 00:12:19.000000', 'consum', 0.0220, 'lps'),
	(564996, 130, '2014-03-01 00:12:20.000000', 'consum', 0.0218, 'lps'),
	(564997, 130, '2014-03-01 00:12:21.000000', 'consum', 0.0222, 'lps'),
	(564998, 130, '2014-03-01 00:12:22.000000', 'consum', 0.0228, 'lps'),
	(564999, 130, '2014-03-01 00:12:23.000000', 'consum', 0.0225, 'lps'),
	(565000, 130, '2014-03-01 00:12:24.000000', 'consum', 0.0214, 'lps'),
	(565001, 130, '2014-03-01 00:12:25.000000', 'consum', 0.0223, 'lps'),
	(565002, 130, '2014-03-01 00:12:26.000000', 'consum', 0.0225, 'lps'),
	(565003, 130, '2014-03-01 00:12:27.000000', 'consum', 0.0228, 'lps'),
	(565004, 130, '2014-03-01 00:12:28.000000', 'consum', 0.0217, 'lps'),
	(565005, 130, '2014-03-01 00:12:29.000000', 'consum', 0.0228, 'lps'),
	(565006, 130, '2014-03-01 00:12:30.000000', 'consum', 0.0225, 'lps'),
	(565007, 130, '2014-03-01 00:12:31.000000', 'consum', 0.0210, 'lps'),
	(565008, 130, '2014-03-01 00:12:32.000000', 'consum', 0.0223, 'lps'),
	(565009, 130, '2014-03-01 00:12:33.000000', 'consum', 0.0218, 'lps'),
	(565010, 130, '2014-03-01 00:12:34.000000', 'consum', 0.0211, 'lps'),
	(565011, 130, '2014-03-01 00:12:35.000000', 'consum', 0.0210, 'lps'),
	(565012, 130, '2014-03-01 00:12:36.000000', 'consum', 0.0210, 'lps'),
	(565013, 130, '2014-03-01 00:12:37.000000', 'consum', 0.0211, 'lps'),
	(565014, 130, '2014-03-01 00:12:38.000000', 'consum', 0.0217, 'lps'),
	(565015, 130, '2014-03-01 00:12:39.000000', 'consum', 0.0220, 'lps'),
	(565016, 130, '2014-03-01 00:12:40.000000', 'consum', 0.0220, 'lps'),
	(565017, 130, '2014-03-01 00:12:41.000000', 'consum', 0.0212, 'lps'),
	(565018, 130, '2014-03-01 00:12:42.000000', 'consum', 0.0227, 'lps'),
	(565019, 130, '2014-03-01 00:12:43.000000', 'consum', 0.0214, 'lps'),
	(565020, 130, '2014-03-01 00:12:44.000000', 'consum', 0.0220, 'lps'),
	(565021, 130, '2014-03-01 00:12:45.000000', 'consum', 0.0227, 'lps'),
	(565022, 130, '2014-03-01 00:12:46.000000', 'consum', 0.0211, 'lps'),
	(565023, 130, '2014-03-01 00:12:47.000000', 'consum', 0.0220, 'lps'),
	(565024, 130, '2014-03-01 00:12:48.000000', 'consum', 0.0220, 'lps'),
	(565025, 130, '2014-03-01 00:12:49.000000', 'consum', 0.0212, 'lps'),
	(565026, 130, '2014-03-01 00:12:50.000000', 'consum', 0.0210, 'lps'),
	(565027, 130, '2014-03-01 00:12:51.000000', 'consum', 0.0222, 'lps'),
	(565028, 130, '2014-03-01 00:12:52.000000', 'consum', 0.0213, 'lps'),
	(565029, 130, '2014-03-01 00:12:53.000000', 'consum', 0.0210, 'lps'),
	(565030, 130, '2014-03-01 00:12:54.000000', 'consum', 0.0220, 'lps'),
	(565031, 130, '2014-03-01 00:12:55.000000', 'consum', 0.0221, 'lps'),
	(565032, 130, '2014-03-01 00:12:56.000000', 'consum', 0.0215, 'lps'),
	(565033, 130, '2014-03-01 00:12:57.000000', 'consum', 0.0225, 'lps'),
	(565034, 130, '2014-03-01 00:12:58.000000', 'consum', 0.0213, 'lps'),
	(565035, 130, '2014-03-01 00:12:59.000000', 'consum', 0.0218, 'lps'),
	(565036, 130, '2014-03-01 00:13:00.000000', 'consum', 0.0223, 'lps'),
	(565037, 130, '2014-03-01 00:13:01.000000', 'consum', 0.0214, 'lps'),
	(565038, 130, '2014-03-01 00:13:02.000000', 'consum', 0.0227, 'lps'),
	(565039, 130, '2014-03-01 00:13:03.000000', 'consum', 0.0228, 'lps'),
	(565040, 130, '2014-03-01 00:13:04.000000', 'consum', 0.0212, 'lps'),
	(565041, 130, '2014-03-01 00:13:05.000000', 'consum', 0.0223, 'lps'),
	(565042, 130, '2014-03-01 00:13:06.000000', 'consum', 0.0213, 'lps'),
	(565043, 130, '2014-03-01 00:13:07.000000', 'consum', 0.0226, 'lps'),
	(565044, 130, '2014-03-01 00:13:08.000000', 'consum', 0.0223, 'lps'),
	(565045, 130, '2014-03-01 00:13:09.000000', 'consum', 0.0227, 'lps'),
	(565046, 130, '2014-03-01 00:13:10.000000', 'consum', 0.0221, 'lps'),
	(565047, 130, '2014-03-01 00:13:11.000000', 'consum', 0.0213, 'lps'),
	(565048, 130, '2014-03-01 00:13:12.000000', 'consum', 0.0213, 'lps'),
	(565049, 130, '2014-03-01 00:13:13.000000', 'consum', 0.0217, 'lps'),
	(565050, 130, '2014-03-01 00:13:14.000000', 'consum', 0.0218, 'lps'),
	(565051, 130, '2014-03-01 00:13:15.000000', 'consum', 0.0228, 'lps'),
	(565052, 130, '2014-03-01 00:13:16.000000', 'consum', 0.0219, 'lps'),
	(565053, 130, '2014-03-01 00:13:17.000000', 'consum', 0.0220, 'lps'),
	(565054, 130, '2014-03-01 00:13:18.000000', 'consum', 0.0216, 'lps'),
	(565055, 130, '2014-03-01 00:13:19.000000', 'consum', 0.0228, 'lps'),
	(565056, 130, '2014-03-01 00:13:20.000000', 'consum', 0.0225, 'lps'),
	(565057, 130, '2014-03-01 00:13:21.000000', 'consum', 0.0215, 'lps'),
	(565058, 130, '2014-03-01 00:13:22.000000', 'consum', 0.0210, 'lps'),
	(565059, 130, '2014-03-01 00:13:23.000000', 'consum', 0.0212, 'lps'),
	(565060, 130, '2014-03-01 00:13:24.000000', 'consum', 0.0223, 'lps'),
	(565061, 130, '2014-03-01 00:13:25.000000', 'consum', 0.0211, 'lps'),
	(565062, 130, '2014-03-01 00:13:26.000000', 'consum', 0.0217, 'lps'),
	(565063, 130, '2014-03-01 00:13:27.000000', 'consum', 0.0221, 'lps'),
	(565064, 130, '2014-03-01 00:13:28.000000', 'consum', 0.0228, 'lps'),
	(565065, 130, '2014-03-01 00:13:29.000000', 'consum', 0.0228, 'lps'),
	(565066, 130, '2014-03-01 00:13:30.000000', 'consum', 0.0228, 'lps'),
	(565067, 130, '2014-03-01 00:13:31.000000', 'consum', 0.0210, 'lps'),
	(565068, 130, '2014-03-01 00:13:32.000000', 'consum', 0.0212, 'lps'),
	(565069, 130, '2014-03-01 00:13:33.000000', 'consum', 0.0219, 'lps'),
	(565070, 130, '2014-03-01 00:13:34.000000', 'consum', 0.0214, 'lps'),
	(565071, 130, '2014-03-01 00:13:35.000000', 'consum', 0.0224, 'lps'),
	(565072, 130, '2014-03-01 00:13:36.000000', 'consum', 0.0227, 'lps'),
	(565073, 130, '2014-03-01 00:13:37.000000', 'consum', 0.0218, 'lps'),
	(565074, 130, '2014-03-01 00:13:38.000000', 'consum', 0.0216, 'lps'),
	(565075, 130, '2014-03-01 00:13:39.000000', 'consum', 0.0218, 'lps'),
	(565076, 130, '2014-03-01 00:13:40.000000', 'consum', 0.0211, 'lps'),
	(565077, 130, '2014-03-01 00:13:41.000000', 'consum', 0.0213, 'lps'),
	(565078, 130, '2014-03-01 00:13:42.000000', 'consum', 0.0221, 'lps'),
	(565079, 130, '2014-03-01 00:13:43.000000', 'consum', 0.0219, 'lps'),
	(565080, 130, '2014-03-01 00:13:44.000000', 'consum', 0.0221, 'lps'),
	(565081, 130, '2014-03-01 00:13:45.000000', 'consum', 0.0221, 'lps'),
	(565082, 130, '2014-03-01 00:13:46.000000', 'consum', 0.0214, 'lps'),
	(565083, 130, '2014-03-01 00:13:47.000000', 'consum', 0.0214, 'lps'),
	(565084, 130, '2014-03-01 00:13:48.000000', 'consum', 0.0221, 'lps'),
	(565085, 130, '2014-03-01 00:13:49.000000', 'consum', 0.0215, 'lps'),
	(565086, 130, '2014-03-01 00:13:50.000000', 'consum', 0.0223, 'lps'),
	(565087, 130, '2014-03-01 00:13:51.000000', 'consum', 0.0223, 'lps'),
	(565088, 130, '2014-03-01 00:13:52.000000', 'consum', 0.0215, 'lps'),
	(565089, 130, '2014-03-01 00:13:53.000000', 'consum', 0.0217, 'lps'),
	(565090, 130, '2014-03-01 00:13:54.000000', 'consum', 0.0213, 'lps'),
	(565091, 130, '2014-03-01 00:13:55.000000', 'consum', 0.0220, 'lps'),
	(565092, 130, '2014-03-01 00:13:56.000000', 'consum', 0.0217, 'lps'),
	(565093, 130, '2014-03-01 00:13:57.000000', 'consum', 0.0213, 'lps'),
	(565094, 130, '2014-03-01 00:13:58.000000', 'consum', 0.0223, 'lps'),
	(565095, 130, '2014-03-01 00:13:59.000000', 'consum', 0.0211, 'lps'),
	(565096, 130, '2014-03-01 00:14:00.000000', 'consum', 0.0215, 'lps'),
	(565097, 130, '2014-03-01 00:14:01.000000', 'consum', 0.0211, 'lps'),
	(565098, 130, '2014-03-01 00:14:02.000000', 'consum', 0.0221, 'lps'),
	(565099, 130, '2014-03-01 00:14:03.000000', 'consum', 0.0223, 'lps'),
	(565100, 130, '2014-03-01 00:14:04.000000', 'consum', 0.0224, 'lps'),
	(565101, 130, '2014-03-01 00:14:05.000000', 'consum', 0.0223, 'lps'),
	(565102, 130, '2014-03-01 00:14:06.000000', 'consum', 0.0213, 'lps'),
	(565103, 130, '2014-03-01 00:14:07.000000', 'consum', 0.0224, 'lps'),
	(565104, 130, '2014-03-01 00:14:08.000000', 'consum', 0.0217, 'lps'),
	(565105, 130, '2014-03-01 00:14:09.000000', 'consum', 0.0222, 'lps'),
	(565106, 130, '2014-03-01 00:14:10.000000', 'consum', 0.0213, 'lps'),
	(565107, 130, '2014-03-01 00:14:11.000000', 'consum', 0.0225, 'lps'),
	(565108, 130, '2014-03-01 00:14:12.000000', 'consum', 0.0220, 'lps'),
	(565109, 130, '2014-03-01 00:14:13.000000', 'consum', 0.0215, 'lps'),
	(565110, 130, '2014-03-01 00:14:14.000000', 'consum', 0.0226, 'lps'),
	(565111, 130, '2014-03-01 00:14:15.000000', 'consum', 0.0220, 'lps'),
	(565112, 130, '2014-03-01 00:14:16.000000', 'consum', 0.0210, 'lps'),
	(565113, 130, '2014-03-01 00:14:17.000000', 'consum', 0.0219, 'lps'),
	(565114, 130, '2014-03-01 00:14:18.000000', 'consum', 0.0219, 'lps'),
	(565115, 130, '2014-03-01 00:14:19.000000', 'consum', 0.0225, 'lps'),
	(565116, 130, '2014-03-01 00:14:20.000000', 'consum', 0.0224, 'lps'),
	(565117, 130, '2014-03-01 00:14:21.000000', 'consum', 0.0216, 'lps'),
	(565118, 130, '2014-03-01 00:14:22.000000', 'consum', 0.0216, 'lps'),
	(565119, 130, '2014-03-01 00:14:23.000000', 'consum', 0.0222, 'lps'),
	(565120, 130, '2014-03-01 00:14:24.000000', 'consum', 0.0217, 'lps'),
	(565121, 130, '2014-03-01 00:14:25.000000', 'consum', 0.0227, 'lps'),
	(565122, 130, '2014-03-01 00:14:26.000000', 'consum', 0.0220, 'lps'),
	(565123, 130, '2014-03-01 00:14:27.000000', 'consum', 0.0226, 'lps'),
	(565124, 130, '2014-03-01 00:14:28.000000', 'consum', 0.0225, 'lps'),
	(565125, 130, '2014-03-01 00:14:29.000000', 'consum', 0.0216, 'lps'),
	(565126, 130, '2014-03-01 00:14:30.000000', 'consum', 0.0214, 'lps'),
	(565127, 130, '2014-03-01 00:14:31.000000', 'consum', 0.0214, 'lps'),
	(565128, 130, '2014-03-01 00:14:32.000000', 'consum', 0.0217, 'lps'),
	(565129, 130, '2014-03-01 00:14:33.000000', 'consum', 0.0215, 'lps'),
	(565130, 130, '2014-03-01 00:14:34.000000', 'consum', 0.0216, 'lps'),
	(565131, 130, '2014-03-01 00:14:35.000000', 'consum', 0.0225, 'lps'),
	(565132, 130, '2014-03-01 00:14:36.000000', 'consum', 0.0227, 'lps'),
	(565133, 130, '2014-03-01 00:14:37.000000', 'consum', 0.0215, 'lps'),
	(565134, 130, '2014-03-01 00:14:38.000000', 'consum', 0.0221, 'lps'),
	(565135, 130, '2014-03-01 00:14:39.000000', 'consum', 0.0212, 'lps'),
	(565136, 130, '2014-03-01 00:14:40.000000', 'consum', 0.0227, 'lps'),
	(565137, 130, '2014-03-01 00:14:41.000000', 'consum', 0.0214, 'lps'),
	(565138, 130, '2014-03-01 00:14:42.000000', 'consum', 0.0219, 'lps'),
	(565139, 130, '2014-03-01 00:14:43.000000', 'consum', 0.0221, 'lps'),
	(565140, 130, '2014-03-01 00:14:44.000000', 'consum', 0.0221, 'lps'),
	(565141, 130, '2014-03-01 00:14:45.000000', 'consum', 0.0214, 'lps'),
	(565142, 130, '2014-03-01 00:14:46.000000', 'consum', 0.0217, 'lps'),
	(565143, 130, '2014-03-01 00:14:47.000000', 'consum', 0.0213, 'lps'),
	(565144, 130, '2014-03-01 00:14:48.000000', 'consum', 0.0223, 'lps'),
	(565145, 130, '2014-03-01 00:14:49.000000', 'consum', 0.0228, 'lps'),
	(565146, 130, '2014-03-01 00:14:50.000000', 'consum', 0.0223, 'lps'),
	(565147, 130, '2014-03-01 00:14:51.000000', 'consum', 0.0222, 'lps'),
	(565148, 130, '2014-03-01 00:14:52.000000', 'consum', 0.0213, 'lps'),
	(565149, 130, '2014-03-01 00:14:53.000000', 'consum', 0.0225, 'lps'),
	(565150, 130, '2014-03-01 00:14:54.000000', 'consum', 0.0223, 'lps'),
	(565151, 130, '2014-03-01 00:14:55.000000', 'consum', 0.0227, 'lps'),
	(565152, 130, '2014-03-01 00:14:56.000000', 'consum', 0.0222, 'lps'),
	(565153, 130, '2014-03-01 00:14:57.000000', 'consum', 0.0218, 'lps'),
	(565154, 130, '2014-03-01 00:14:58.000000', 'consum', 0.0213, 'lps'),
	(565155, 130, '2014-03-01 00:14:59.000000', 'consum', 0.0221, 'lps'),
	(565156, 130, '2014-03-01 00:15:00.000000', 'consum', 0.0218, 'lps'),
	(565157, 130, '2014-03-01 00:15:01.000000', 'consum', 0.0219, 'lps'),
	(565158, 130, '2014-03-01 00:15:02.000000', 'consum', 0.0211, 'lps'),
	(565159, 130, '2014-03-01 00:15:03.000000', 'consum', 0.0225, 'lps'),
	(565160, 130, '2014-03-01 00:15:04.000000', 'consum', 0.0210, 'lps'),
	(565161, 130, '2014-03-01 00:15:05.000000', 'consum', 0.0221, 'lps'),
	(565162, 130, '2014-03-01 00:15:06.000000', 'consum', 0.0210, 'lps'),
	(565163, 130, '2014-03-01 00:15:07.000000', 'consum', 0.0215, 'lps'),
	(565164, 130, '2014-03-01 00:15:08.000000', 'consum', 0.0217, 'lps'),
	(565165, 130, '2014-03-01 00:15:09.000000', 'consum', 0.0211, 'lps'),
	(565166, 130, '2014-03-01 00:15:10.000000', 'consum', 0.0212, 'lps'),
	(565167, 130, '2014-03-01 00:15:11.000000', 'consum', 0.0220, 'lps'),
	(565168, 130, '2014-03-01 00:15:12.000000', 'consum', 0.0217, 'lps'),
	(565169, 130, '2014-03-01 00:15:13.000000', 'consum', 0.0213, 'lps'),
	(565170, 130, '2014-03-01 00:15:14.000000', 'consum', 0.0226, 'lps'),
	(565171, 130, '2014-03-01 00:15:15.000000', 'consum', 0.0226, 'lps'),
	(565172, 130, '2014-03-01 00:15:16.000000', 'consum', 0.0220, 'lps'),
	(565173, 130, '2014-03-01 00:15:17.000000', 'consum', 0.0214, 'lps'),
	(565174, 130, '2014-03-01 00:15:18.000000', 'consum', 0.0217, 'lps'),
	(565175, 130, '2014-03-01 00:15:19.000000', 'consum', 0.0218, 'lps'),
	(565176, 130, '2014-03-01 00:15:20.000000', 'consum', 0.0210, 'lps'),
	(565177, 130, '2014-03-01 00:15:21.000000', 'consum', 0.0222, 'lps'),
	(565178, 130, '2014-03-01 00:15:22.000000', 'consum', 0.0214, 'lps'),
	(565179, 130, '2014-03-01 00:15:23.000000', 'consum', 0.0214, 'lps'),
	(565180, 130, '2014-03-01 00:15:24.000000', 'consum', 0.0217, 'lps'),
	(565181, 130, '2014-03-01 00:15:25.000000', 'consum', 0.0214, 'lps'),
	(565182, 130, '2014-03-01 00:15:26.000000', 'consum', 0.0211, 'lps'),
	(565183, 130, '2014-03-01 00:15:27.000000', 'consum', 0.0224, 'lps'),
	(565184, 130, '2014-03-01 00:15:28.000000', 'consum', 0.0220, 'lps'),
	(565185, 130, '2014-03-01 00:15:29.000000', 'consum', 0.0220, 'lps'),
	(565186, 130, '2014-03-01 00:15:30.000000', 'consum', 0.0211, 'lps'),
	(565187, 130, '2014-03-01 00:15:31.000000', 'consum', 0.0221, 'lps'),
	(565188, 130, '2014-03-01 00:15:32.000000', 'consum', 0.0228, 'lps'),
	(565189, 130, '2014-03-01 00:15:33.000000', 'consum', 0.0228, 'lps'),
	(565190, 130, '2014-03-01 00:15:34.000000', 'consum', 0.0225, 'lps'),
	(565191, 130, '2014-03-01 00:15:35.000000', 'consum', 0.0216, 'lps'),
	(565192, 130, '2014-03-01 00:15:36.000000', 'consum', 0.0213, 'lps'),
	(565193, 130, '2014-03-01 00:15:37.000000', 'consum', 0.0228, 'lps'),
	(565194, 130, '2014-03-01 00:15:38.000000', 'consum', 0.0217, 'lps'),
	(565195, 130, '2014-03-01 00:15:39.000000', 'consum', 0.0226, 'lps'),
	(565196, 130, '2014-03-01 00:15:40.000000', 'consum', 0.0216, 'lps'),
	(565197, 130, '2014-03-01 00:15:41.000000', 'consum', 0.0228, 'lps'),
	(565198, 130, '2014-03-01 00:15:42.000000', 'consum', 0.0226, 'lps'),
	(565199, 130, '2014-03-01 00:15:43.000000', 'consum', 0.0218, 'lps'),
	(565200, 130, '2014-03-01 00:15:44.000000', 'consum', 0.0222, 'lps'),
	(565201, 130, '2014-03-01 00:15:45.000000', 'consum', 0.0225, 'lps'),
	(565202, 130, '2014-03-01 00:15:46.000000', 'consum', 0.0213, 'lps'),
	(565203, 130, '2014-03-01 00:15:47.000000', 'consum', 0.0218, 'lps'),
	(565204, 130, '2014-03-01 00:15:48.000000', 'consum', 0.0224, 'lps'),
	(565205, 130, '2014-03-01 00:15:49.000000', 'consum', 0.0218, 'lps'),
	(565206, 130, '2014-03-01 00:15:50.000000', 'consum', 0.0210, 'lps'),
	(565207, 130, '2014-03-01 00:15:51.000000', 'consum', 0.0221, 'lps'),
	(565208, 130, '2014-03-01 00:15:52.000000', 'consum', 0.0212, 'lps'),
	(565209, 130, '2014-03-01 00:15:53.000000', 'consum', 0.0222, 'lps'),
	(565210, 130, '2014-03-01 00:15:54.000000', 'consum', 0.0210, 'lps'),
	(565211, 130, '2014-03-01 00:15:55.000000', 'consum', 0.0212, 'lps'),
	(565212, 130, '2014-03-01 00:15:56.000000', 'consum', 0.0220, 'lps'),
	(565213, 130, '2014-03-01 00:15:57.000000', 'consum', 0.0216, 'lps'),
	(565214, 130, '2014-03-01 00:15:58.000000', 'consum', 0.0210, 'lps'),
	(565215, 130, '2014-03-01 00:15:59.000000', 'consum', 0.0211, 'lps'),
	(565216, 130, '2014-03-01 00:16:00.000000', 'consum', 0.0216, 'lps'),
	(565217, 130, '2014-03-01 00:16:01.000000', 'consum', 0.0219, 'lps'),
	(565218, 130, '2014-03-01 00:16:02.000000', 'consum', 0.0219, 'lps'),
	(565219, 130, '2014-03-01 00:16:03.000000', 'consum', 0.0226, 'lps'),
	(565220, 130, '2014-03-01 00:16:04.000000', 'consum', 0.0228, 'lps'),
	(565221, 130, '2014-03-01 00:16:05.000000', 'consum', 0.0215, 'lps'),
	(565222, 130, '2014-03-01 00:16:06.000000', 'consum', 0.0219, 'lps'),
	(565223, 130, '2014-03-01 00:16:07.000000', 'consum', 0.0222, 'lps'),
	(565224, 130, '2014-03-01 00:16:08.000000', 'consum', 0.0226, 'lps'),
	(565225, 130, '2014-03-01 00:16:09.000000', 'consum', 0.0215, 'lps'),
	(565226, 130, '2014-03-01 00:16:10.000000', 'consum', 0.0225, 'lps'),
	(565227, 130, '2014-03-01 00:16:11.000000', 'consum', 0.0215, 'lps'),
	(565228, 130, '2014-03-01 00:16:12.000000', 'consum', 0.0210, 'lps'),
	(565229, 130, '2014-03-01 00:16:13.000000', 'consum', 0.0215, 'lps'),
	(565230, 130, '2014-03-01 00:16:14.000000', 'consum', 0.0215, 'lps'),
	(565231, 130, '2014-03-01 00:16:15.000000', 'consum', 0.0221, 'lps'),
	(565232, 130, '2014-03-01 00:16:16.000000', 'consum', 0.0211, 'lps'),
	(565233, 130, '2014-03-01 00:16:17.000000', 'consum', 0.0221, 'lps'),
	(565234, 130, '2014-03-01 00:16:18.000000', 'consum', 0.0224, 'lps'),
	(565235, 130, '2014-03-01 00:16:19.000000', 'consum', 0.0227, 'lps'),
	(565236, 130, '2014-03-01 00:16:20.000000', 'consum', 0.0218, 'lps'),
	(565237, 130, '2014-03-01 00:16:21.000000', 'consum', 0.0217, 'lps'),
	(565238, 130, '2014-03-01 00:16:22.000000', 'consum', 0.0224, 'lps'),
	(565239, 130, '2014-03-01 00:16:23.000000', 'consum', 0.0219, 'lps'),
	(565240, 130, '2014-03-01 00:16:24.000000', 'consum', 0.0214, 'lps'),
	(565241, 130, '2014-03-01 00:16:25.000000', 'consum', 0.0224, 'lps'),
	(565242, 130, '2014-03-01 00:16:26.000000', 'consum', 0.0213, 'lps'),
	(565243, 130, '2014-03-01 00:16:27.000000', 'consum', 0.0218, 'lps'),
	(565244, 130, '2014-03-01 00:16:28.000000', 'consum', 0.0223, 'lps'),
	(565245, 130, '2014-03-01 00:16:29.000000', 'consum', 0.0215, 'lps'),
	(565246, 130, '2014-03-01 00:16:30.000000', 'consum', 0.0216, 'lps'),
	(565247, 130, '2014-03-01 00:16:31.000000', 'consum', 0.0227, 'lps'),
	(565248, 130, '2014-03-01 00:16:32.000000', 'consum', 0.0218, 'lps'),
	(565249, 130, '2014-03-01 00:16:33.000000', 'consum', 0.0218, 'lps'),
	(565250, 130, '2014-03-01 00:16:34.000000', 'consum', 0.0227, 'lps'),
	(565251, 130, '2014-03-01 00:16:35.000000', 'consum', 0.0217, 'lps'),
	(565252, 130, '2014-03-01 00:16:36.000000', 'consum', 0.0211, 'lps'),
	(565253, 130, '2014-03-01 00:16:37.000000', 'consum', 0.0214, 'lps'),
	(565254, 130, '2014-03-01 00:16:38.000000', 'consum', 0.0228, 'lps'),
	(565255, 130, '2014-03-01 00:16:39.000000', 'consum', 0.0213, 'lps'),
	(565256, 130, '2014-03-01 00:16:40.000000', 'consum', 0.0210, 'lps'),
	(565257, 130, '2014-03-01 00:16:41.000000', 'consum', 0.0220, 'lps'),
	(565258, 130, '2014-03-01 00:16:42.000000', 'consum', 0.0220, 'lps'),
	(565259, 130, '2014-03-01 00:16:43.000000', 'consum', 0.0215, 'lps'),
	(565260, 130, '2014-03-01 00:16:44.000000', 'consum', 0.0221, 'lps'),
	(565261, 130, '2014-03-01 00:16:45.000000', 'consum', 0.0216, 'lps'),
	(565262, 130, '2014-03-01 00:16:46.000000', 'consum', 0.0224, 'lps'),
	(565263, 130, '2014-03-01 00:16:47.000000', 'consum', 0.0226, 'lps'),
	(565264, 130, '2014-03-01 00:16:48.000000', 'consum', 0.0227, 'lps'),
	(565265, 130, '2014-03-01 00:16:49.000000', 'consum', 0.0212, 'lps'),
	(565266, 130, '2014-03-01 00:16:50.000000', 'consum', 0.0227, 'lps'),
	(565267, 130, '2014-03-01 00:16:51.000000', 'consum', 0.0215, 'lps'),
	(565268, 130, '2014-03-01 00:16:52.000000', 'consum', 0.0220, 'lps'),
	(565269, 130, '2014-03-01 00:16:53.000000', 'consum', 0.0226, 'lps'),
	(565270, 130, '2014-03-01 00:16:54.000000', 'consum', 0.0222, 'lps'),
	(565271, 130, '2014-03-01 00:16:55.000000', 'consum', 0.0223, 'lps'),
	(565272, 130, '2014-03-01 00:16:56.000000', 'consum', 0.0223, 'lps'),
	(565273, 130, '2014-03-01 00:16:57.000000', 'consum', 0.0214, 'lps'),
	(565274, 130, '2014-03-01 00:16:58.000000', 'consum', 0.0213, 'lps'),
	(565275, 130, '2014-03-01 00:16:59.000000', 'consum', 0.0215, 'lps'),
	(565276, 130, '2014-03-01 00:17:00.000000', 'consum', 0.0223, 'lps'),
	(565277, 130, '2014-03-01 00:17:01.000000', 'consum', 0.0225, 'lps'),
	(565278, 130, '2014-03-01 00:17:02.000000', 'consum', 0.0227, 'lps'),
	(565279, 130, '2014-03-01 00:17:03.000000', 'consum', 0.0212, 'lps'),
	(565280, 130, '2014-03-01 00:17:04.000000', 'consum', 0.0226, 'lps'),
	(565281, 130, '2014-03-01 00:17:05.000000', 'consum', 0.0227, 'lps'),
	(565282, 130, '2014-03-01 00:17:06.000000', 'consum', 0.0210, 'lps'),
	(565283, 130, '2014-03-01 00:17:07.000000', 'consum', 0.0217, 'lps'),
	(565284, 130, '2014-03-01 00:17:08.000000', 'consum', 0.0228, 'lps'),
	(565285, 130, '2014-03-01 00:17:09.000000', 'consum', 0.0219, 'lps'),
	(565286, 130, '2014-03-01 00:17:10.000000', 'consum', 0.0223, 'lps'),
	(565287, 130, '2014-03-01 00:17:11.000000', 'consum', 0.0212, 'lps'),
	(565288, 130, '2014-03-01 00:17:12.000000', 'consum', 0.0216, 'lps'),
	(565289, 130, '2014-03-01 00:17:13.000000', 'consum', 0.0216, 'lps'),
	(565290, 130, '2014-03-01 00:17:14.000000', 'consum', 0.0225, 'lps'),
	(565291, 130, '2014-03-01 00:17:15.000000', 'consum', 0.0210, 'lps'),
	(565292, 130, '2014-03-01 00:17:16.000000', 'consum', 0.0223, 'lps'),
	(565293, 130, '2014-03-01 00:17:17.000000', 'consum', 0.0218, 'lps'),
	(565294, 130, '2014-03-01 00:17:18.000000', 'consum', 0.0212, 'lps'),
	(565295, 130, '2014-03-01 00:17:19.000000', 'consum', 0.0215, 'lps'),
	(565296, 130, '2014-03-01 00:17:20.000000', 'consum', 0.0210, 'lps'),
	(565297, 130, '2014-03-01 00:17:21.000000', 'consum', 0.0213, 'lps'),
	(565298, 130, '2014-03-01 00:17:22.000000', 'consum', 0.0226, 'lps'),
	(565299, 130, '2014-03-01 00:17:23.000000', 'consum', 0.0225, 'lps'),
	(565300, 130, '2014-03-01 00:17:24.000000', 'consum', 0.0220, 'lps'),
	(565301, 130, '2014-03-01 00:17:25.000000', 'consum', 0.0215, 'lps'),
	(565302, 130, '2014-03-01 00:17:26.000000', 'consum', 0.0224, 'lps'),
	(565303, 130, '2014-03-01 00:17:27.000000', 'consum', 0.0227, 'lps'),
	(565304, 130, '2014-03-01 00:17:28.000000', 'consum', 0.0214, 'lps'),
	(565305, 130, '2014-03-01 00:17:29.000000', 'consum', 0.0220, 'lps'),
	(565306, 130, '2014-03-01 00:17:30.000000', 'consum', 0.0210, 'lps'),
	(565307, 130, '2014-03-01 00:17:31.000000', 'consum', 0.0220, 'lps'),
	(565308, 130, '2014-03-01 00:17:32.000000', 'consum', 0.0221, 'lps'),
	(565309, 130, '2014-03-01 00:17:33.000000', 'consum', 0.0217, 'lps'),
	(565310, 130, '2014-03-01 00:17:34.000000', 'consum', 0.0211, 'lps'),
	(565311, 130, '2014-03-01 00:17:35.000000', 'consum', 0.0214, 'lps'),
	(565312, 130, '2014-03-01 00:17:36.000000', 'consum', 0.0226, 'lps'),
	(565313, 130, '2014-03-01 00:17:37.000000', 'consum', 0.0222, 'lps'),
	(565314, 130, '2014-03-01 00:17:38.000000', 'consum', 0.0222, 'lps'),
	(565315, 130, '2014-03-01 00:17:39.000000', 'consum', 0.0217, 'lps'),
	(565316, 130, '2014-03-01 00:17:40.000000', 'consum', 0.0228, 'lps'),
	(565317, 130, '2014-03-01 00:17:41.000000', 'consum', 0.0221, 'lps'),
	(565318, 130, '2014-03-01 00:17:42.000000', 'consum', 0.0214, 'lps'),
	(565319, 130, '2014-03-01 00:17:43.000000', 'consum', 0.0216, 'lps'),
	(565320, 130, '2014-03-01 00:17:44.000000', 'consum', 0.0228, 'lps'),
	(565321, 130, '2014-03-01 00:17:45.000000', 'consum', 0.0225, 'lps'),
	(565322, 130, '2014-03-01 00:17:46.000000', 'consum', 0.0214, 'lps'),
	(565323, 130, '2014-03-01 00:17:47.000000', 'consum', 0.0224, 'lps'),
	(565324, 130, '2014-03-01 00:17:48.000000', 'consum', 0.0228, 'lps'),
	(565325, 130, '2014-03-01 00:17:49.000000', 'consum', 0.0223, 'lps'),
	(565326, 130, '2014-03-01 00:17:50.000000', 'consum', 0.0222, 'lps'),
	(565327, 130, '2014-03-01 00:17:51.000000', 'consum', 0.0212, 'lps'),
	(565328, 130, '2014-03-01 00:17:52.000000', 'consum', 0.0222, 'lps'),
	(565329, 130, '2014-03-01 00:17:53.000000', 'consum', 0.0225, 'lps'),
	(565330, 130, '2014-03-01 00:17:54.000000', 'consum', 0.0214, 'lps'),
	(565331, 130, '2014-03-01 00:17:55.000000', 'consum', 0.0222, 'lps'),
	(565332, 130, '2014-03-01 00:17:56.000000', 'consum', 0.0221, 'lps'),
	(565333, 130, '2014-03-01 00:17:57.000000', 'consum', 0.0210, 'lps'),
	(565334, 130, '2014-03-01 00:17:58.000000', 'consum', 0.0215, 'lps'),
	(565335, 130, '2014-03-01 00:17:59.000000', 'consum', 0.0215, 'lps'),
	(565336, 130, '2014-03-01 00:18:00.000000', 'consum', 0.0222, 'lps'),
	(565337, 130, '2014-03-01 00:18:01.000000', 'consum', 0.0216, 'lps'),
	(565338, 130, '2014-03-01 00:18:02.000000', 'consum', 0.0223, 'lps'),
	(565339, 130, '2014-03-01 00:18:03.000000', 'consum', 0.0221, 'lps'),
	(565340, 130, '2014-03-01 00:18:04.000000', 'consum', 0.0226, 'lps'),
	(565341, 130, '2014-03-01 00:18:05.000000', 'consum', 0.0222, 'lps'),
	(565342, 130, '2014-03-01 00:18:06.000000', 'consum', 0.0219, 'lps'),
	(565343, 130, '2014-03-01 00:18:07.000000', 'consum', 0.0221, 'lps'),
	(565344, 130, '2014-03-01 00:18:08.000000', 'consum', 0.0217, 'lps'),
	(565345, 130, '2014-03-01 00:18:09.000000', 'consum', 0.0216, 'lps'),
	(565346, 130, '2014-03-01 00:18:10.000000', 'consum', 0.0219, 'lps'),
	(565347, 130, '2014-03-01 00:18:11.000000', 'consum', 0.0219, 'lps'),
	(565348, 130, '2014-03-01 00:18:12.000000', 'consum', 0.0210, 'lps'),
	(565349, 130, '2014-03-01 00:18:13.000000', 'consum', 0.0222, 'lps'),
	(565350, 130, '2014-03-01 00:18:14.000000', 'consum', 0.0212, 'lps'),
	(565351, 130, '2014-03-01 00:18:15.000000', 'consum', 0.0225, 'lps'),
	(565352, 130, '2014-03-01 00:18:16.000000', 'consum', 0.0220, 'lps'),
	(565353, 130, '2014-03-01 00:18:17.000000', 'consum', 0.0217, 'lps'),
	(565354, 130, '2014-03-01 00:18:18.000000', 'consum', 0.0216, 'lps'),
	(565355, 130, '2014-03-01 00:18:19.000000', 'consum', 0.0217, 'lps'),
	(565356, 130, '2014-03-01 00:18:20.000000', 'consum', 0.0210, 'lps'),
	(565357, 130, '2014-03-01 00:18:21.000000', 'consum', 0.0210, 'lps'),
	(565358, 130, '2014-03-01 00:18:22.000000', 'consum', 0.0228, 'lps'),
	(565359, 130, '2014-03-01 00:18:23.000000', 'consum', 0.0223, 'lps'),
	(565360, 130, '2014-03-01 00:18:24.000000', 'consum', 0.0222, 'lps'),
	(565361, 130, '2014-03-01 00:18:25.000000', 'consum', 0.0212, 'lps'),
	(565362, 130, '2014-03-01 00:18:26.000000', 'consum', 0.0223, 'lps'),
	(565363, 130, '2014-03-01 00:18:27.000000', 'consum', 0.0214, 'lps'),
	(565364, 130, '2014-03-01 00:18:28.000000', 'consum', 0.0210, 'lps'),
	(565365, 130, '2014-03-01 00:18:29.000000', 'consum', 0.0218, 'lps'),
	(565366, 130, '2014-03-01 00:18:30.000000', 'consum', 0.0212, 'lps'),
	(565367, 130, '2014-03-01 00:18:31.000000', 'consum', 0.0215, 'lps'),
	(565368, 130, '2014-03-01 00:18:32.000000', 'consum', 0.0210, 'lps'),
	(565369, 130, '2014-03-01 00:18:33.000000', 'consum', 0.0216, 'lps'),
	(565370, 130, '2014-03-01 00:18:34.000000', 'consum', 0.0220, 'lps'),
	(565371, 130, '2014-03-01 00:18:35.000000', 'consum', 0.0226, 'lps'),
	(565372, 130, '2014-03-01 00:18:36.000000', 'consum', 0.0220, 'lps'),
	(565373, 130, '2014-03-01 00:18:37.000000', 'consum', 0.0212, 'lps'),
	(565374, 130, '2014-03-01 00:18:38.000000', 'consum', 0.0210, 'lps'),
	(565375, 130, '2014-03-01 00:18:39.000000', 'consum', 0.0224, 'lps'),
	(565376, 130, '2014-03-01 00:18:40.000000', 'consum', 0.0225, 'lps'),
	(565377, 130, '2014-03-01 00:18:41.000000', 'consum', 0.0223, 'lps'),
	(565378, 130, '2014-03-01 00:18:42.000000', 'consum', 0.0211, 'lps'),
	(565379, 130, '2014-03-01 00:18:43.000000', 'consum', 0.0214, 'lps'),
	(565380, 130, '2014-03-01 00:18:44.000000', 'consum', 0.0210, 'lps'),
	(565381, 130, '2014-03-01 00:18:45.000000', 'consum', 0.0218, 'lps'),
	(565382, 130, '2014-03-01 00:18:46.000000', 'consum', 0.0210, 'lps'),
	(565383, 130, '2014-03-01 00:18:47.000000', 'consum', 0.0226, 'lps'),
	(565384, 130, '2014-03-01 00:18:48.000000', 'consum', 0.0215, 'lps'),
	(565385, 130, '2014-03-01 00:18:49.000000', 'consum', 0.0224, 'lps'),
	(565386, 130, '2014-03-01 00:18:50.000000', 'consum', 0.0228, 'lps'),
	(565387, 130, '2014-03-01 00:18:51.000000', 'consum', 0.0222, 'lps'),
	(565388, 130, '2014-03-01 00:18:52.000000', 'consum', 0.0215, 'lps'),
	(565389, 130, '2014-03-01 00:18:53.000000', 'consum', 0.0221, 'lps'),
	(565390, 130, '2014-03-01 00:18:54.000000', 'consum', 0.0210, 'lps'),
	(565391, 130, '2014-03-01 00:18:55.000000', 'consum', 0.0218, 'lps'),
	(565392, 130, '2014-03-01 00:18:56.000000', 'consum', 0.0211, 'lps'),
	(565393, 130, '2014-03-01 00:18:57.000000', 'consum', 0.0211, 'lps'),
	(565394, 130, '2014-03-01 00:18:58.000000', 'consum', 0.0212, 'lps'),
	(565395, 130, '2014-03-01 00:18:59.000000', 'consum', 0.0219, 'lps'),
	(565396, 130, '2014-03-01 00:19:00.000000', 'consum', 0.0228, 'lps'),
	(565397, 130, '2014-03-01 00:19:01.000000', 'consum', 0.0219, 'lps'),
	(565398, 130, '2014-03-01 00:19:02.000000', 'consum', 0.0218, 'lps'),
	(565399, 130, '2014-03-01 00:19:03.000000', 'consum', 0.0225, 'lps'),
	(565400, 130, '2014-03-01 00:19:04.000000', 'consum', 0.0222, 'lps'),
	(565401, 130, '2014-03-01 00:19:05.000000', 'consum', 0.0226, 'lps'),
	(565402, 130, '2014-03-01 00:19:06.000000', 'consum', 0.0215, 'lps'),
	(565403, 130, '2014-03-01 00:19:07.000000', 'consum', 0.0227, 'lps'),
	(565404, 130, '2014-03-01 00:19:08.000000', 'consum', 0.0223, 'lps'),
	(565405, 130, '2014-03-01 00:19:09.000000', 'consum', 0.0226, 'lps'),
	(565406, 130, '2014-03-01 00:19:10.000000', 'consum', 0.0214, 'lps'),
	(565407, 130, '2014-03-01 00:19:11.000000', 'consum', 0.0219, 'lps'),
	(565408, 130, '2014-03-01 00:19:12.000000', 'consum', 0.0223, 'lps'),
	(565409, 130, '2014-03-01 00:19:13.000000', 'consum', 0.0213, 'lps'),
	(565410, 130, '2014-03-01 00:19:14.000000', 'consum', 0.0223, 'lps'),
	(565411, 130, '2014-03-01 00:19:15.000000', 'consum', 0.0210, 'lps'),
	(565412, 130, '2014-03-01 00:19:16.000000', 'consum', 0.0227, 'lps'),
	(565413, 130, '2014-03-01 00:19:17.000000', 'consum', 0.0221, 'lps'),
	(565414, 130, '2014-03-01 00:19:18.000000', 'consum', 0.0216, 'lps'),
	(565415, 130, '2014-03-01 00:19:19.000000', 'consum', 0.0226, 'lps'),
	(565416, 130, '2014-03-01 00:19:20.000000', 'consum', 0.0215, 'lps'),
	(565417, 130, '2014-03-01 00:19:21.000000', 'consum', 0.0228, 'lps'),
	(565418, 130, '2014-03-01 00:19:22.000000', 'consum', 0.0225, 'lps'),
	(565419, 130, '2014-03-01 00:19:23.000000', 'consum', 0.0214, 'lps'),
	(565420, 130, '2014-03-01 00:19:24.000000', 'consum', 0.0222, 'lps'),
	(565421, 130, '2014-03-01 00:19:25.000000', 'consum', 0.0223, 'lps'),
	(565422, 130, '2014-03-01 00:19:26.000000', 'consum', 0.0220, 'lps'),
	(565423, 130, '2014-03-01 00:19:27.000000', 'consum', 0.0221, 'lps'),
	(565424, 130, '2014-03-01 00:19:28.000000', 'consum', 0.0218, 'lps'),
	(565425, 130, '2014-03-01 00:19:29.000000', 'consum', 0.0215, 'lps'),
	(565426, 130, '2014-03-01 00:19:30.000000', 'consum', 0.0211, 'lps'),
	(565427, 130, '2014-03-01 00:19:31.000000', 'consum', 0.0220, 'lps'),
	(565428, 130, '2014-03-01 00:19:32.000000', 'consum', 0.0218, 'lps'),
	(565429, 130, '2014-03-01 00:19:33.000000', 'consum', 0.0221, 'lps'),
	(565430, 130, '2014-03-01 00:19:34.000000', 'consum', 0.0223, 'lps'),
	(565431, 130, '2014-03-01 00:19:35.000000', 'consum', 0.0223, 'lps'),
	(565432, 130, '2014-03-01 00:19:36.000000', 'consum', 0.0218, 'lps'),
	(565433, 130, '2014-03-01 00:19:37.000000', 'consum', 0.0210, 'lps'),
	(565434, 130, '2014-03-01 00:19:38.000000', 'consum', 0.0226, 'lps'),
	(565435, 130, '2014-03-01 00:19:39.000000', 'consum', 0.0215, 'lps'),
	(565436, 130, '2014-03-01 00:19:40.000000', 'consum', 0.0224, 'lps'),
	(565437, 130, '2014-03-01 00:19:41.000000', 'consum', 0.0228, 'lps'),
	(565438, 130, '2014-03-01 00:19:42.000000', 'consum', 0.0221, 'lps'),
	(565439, 130, '2014-03-01 00:19:43.000000', 'consum', 0.0228, 'lps'),
	(565440, 130, '2014-03-01 00:19:44.000000', 'consum', 0.0214, 'lps'),
	(565441, 130, '2014-03-01 00:19:45.000000', 'consum', 0.0213, 'lps'),
	(565442, 130, '2014-03-01 00:19:46.000000', 'consum', 0.0212, 'lps'),
	(565443, 130, '2014-03-01 00:19:47.000000', 'consum', 0.0211, 'lps'),
	(565444, 130, '2014-03-01 00:19:48.000000', 'consum', 0.0211, 'lps'),
	(565445, 130, '2014-03-01 00:19:49.000000', 'consum', 0.0210, 'lps'),
	(565446, 130, '2014-03-01 00:19:50.000000', 'consum', 0.0210, 'lps'),
	(565447, 130, '2014-03-01 00:19:51.000000', 'consum', 0.0212, 'lps'),
	(565448, 130, '2014-03-01 00:19:52.000000', 'consum', 0.0217, 'lps'),
	(565449, 130, '2014-03-01 00:19:53.000000', 'consum', 0.0222, 'lps'),
	(565450, 130, '2014-03-01 00:19:54.000000', 'consum', 0.0211, 'lps'),
	(565451, 130, '2014-03-01 00:19:55.000000', 'consum', 0.0217, 'lps'),
	(565452, 130, '2014-03-01 00:19:56.000000', 'consum', 0.0223, 'lps'),
	(565453, 130, '2014-03-01 00:19:57.000000', 'consum', 0.0216, 'lps'),
	(565454, 130, '2014-03-01 00:19:58.000000', 'consum', 0.0222, 'lps'),
	(565455, 130, '2014-03-01 00:19:59.000000', 'consum', 0.0214, 'lps'),
	(565456, 130, '2014-03-01 00:20:00.000000', 'consum', 0.0213, 'lps'),
	(565457, 130, '2014-03-01 00:20:01.000000', 'consum', 0.0213, 'lps'),
	(565458, 130, '2014-03-01 00:20:02.000000', 'consum', 0.0217, 'lps'),
	(565459, 130, '2014-03-01 00:20:03.000000', 'consum', 0.0217, 'lps'),
	(565460, 130, '2014-03-01 00:20:04.000000', 'consum', 0.0223, 'lps'),
	(565461, 130, '2014-03-01 00:20:05.000000', 'consum', 0.0220, 'lps'),
	(565462, 130, '2014-03-01 00:20:06.000000', 'consum', 0.0218, 'lps'),
	(565463, 130, '2014-03-01 00:20:07.000000', 'consum', 0.0221, 'lps'),
	(565464, 130, '2014-03-01 00:20:08.000000', 'consum', 0.0225, 'lps'),
	(565465, 130, '2014-03-01 00:20:09.000000', 'consum', 0.0212, 'lps'),
	(565466, 130, '2014-03-01 00:20:10.000000', 'consum', 0.0216, 'lps'),
	(565467, 130, '2014-03-01 00:20:11.000000', 'consum', 0.0214, 'lps'),
	(565468, 130, '2014-03-01 00:20:12.000000', 'consum', 0.0212, 'lps'),
	(565469, 130, '2014-03-01 00:20:13.000000', 'consum', 0.0228, 'lps'),
	(565470, 130, '2014-03-01 00:20:14.000000', 'consum', 0.0220, 'lps'),
	(565471, 130, '2014-03-01 00:20:15.000000', 'consum', 0.0225, 'lps'),
	(565472, 130, '2014-03-01 00:20:16.000000', 'consum', 0.0219, 'lps'),
	(565473, 130, '2014-03-01 00:20:17.000000', 'consum', 0.0227, 'lps'),
	(565474, 130, '2014-03-01 00:20:18.000000', 'consum', 0.0213, 'lps'),
	(565475, 130, '2014-03-01 00:20:19.000000', 'consum', 0.0214, 'lps'),
	(565476, 130, '2014-03-01 00:20:20.000000', 'consum', 0.0220, 'lps'),
	(565477, 130, '2014-03-01 00:20:21.000000', 'consum', 0.0228, 'lps'),
	(565478, 130, '2014-03-01 00:20:22.000000', 'consum', 0.0217, 'lps'),
	(565479, 130, '2014-03-01 00:20:23.000000', 'consum', 0.0226, 'lps'),
	(565480, 130, '2014-03-01 00:20:24.000000', 'consum', 0.0213, 'lps'),
	(565481, 130, '2014-03-01 00:20:25.000000', 'consum', 0.0215, 'lps'),
	(565482, 130, '2014-03-01 00:20:26.000000', 'consum', 0.0210, 'lps'),
	(565483, 130, '2014-03-01 00:20:27.000000', 'consum', 0.0212, 'lps'),
	(565484, 130, '2014-03-01 00:20:28.000000', 'consum', 0.0220, 'lps'),
	(565485, 130, '2014-03-01 00:20:29.000000', 'consum', 0.0216, 'lps'),
	(565486, 130, '2014-03-01 00:20:30.000000', 'consum', 0.0212, 'lps'),
	(565487, 130, '2014-03-01 00:20:31.000000', 'consum', 0.0222, 'lps'),
	(565488, 130, '2014-03-01 00:20:32.000000', 'consum', 0.0227, 'lps'),
	(565489, 130, '2014-03-01 00:20:33.000000', 'consum', 0.0222, 'lps'),
	(565490, 130, '2014-03-01 00:20:34.000000', 'consum', 0.0219, 'lps'),
	(565491, 130, '2014-03-01 00:20:35.000000', 'consum', 0.0220, 'lps'),
	(565492, 130, '2014-03-01 00:20:36.000000', 'consum', 0.0215, 'lps'),
	(565493, 130, '2014-03-01 00:20:37.000000', 'consum', 0.0224, 'lps'),
	(565494, 130, '2014-03-01 00:20:38.000000', 'consum', 0.0226, 'lps'),
	(565495, 130, '2014-03-01 00:20:39.000000', 'consum', 0.0213, 'lps'),
	(565496, 130, '2014-03-01 00:20:40.000000', 'consum', 0.0214, 'lps'),
	(565497, 130, '2014-03-01 00:20:41.000000', 'consum', 0.0222, 'lps'),
	(565498, 130, '2014-03-01 00:20:42.000000', 'consum', 0.0222, 'lps'),
	(565499, 130, '2014-03-01 00:20:43.000000', 'consum', 0.0214, 'lps'),
	(565500, 130, '2014-03-01 00:20:44.000000', 'consum', 0.0215, 'lps'),
	(565501, 130, '2014-03-01 00:20:45.000000', 'consum', 0.0223, 'lps'),
	(565502, 130, '2014-03-01 00:20:46.000000', 'consum', 0.0223, 'lps'),
	(565503, 130, '2014-03-01 00:20:47.000000', 'consum', 0.0217, 'lps'),
	(565504, 130, '2014-03-01 00:20:48.000000', 'consum', 0.0226, 'lps'),
	(565505, 130, '2014-03-01 00:20:49.000000', 'consum', 0.0211, 'lps'),
	(565506, 130, '2014-03-01 00:20:50.000000', 'consum', 0.0223, 'lps'),
	(565507, 130, '2014-03-01 00:20:51.000000', 'consum', 0.0219, 'lps'),
	(565508, 130, '2014-03-01 00:20:52.000000', 'consum', 0.0215, 'lps'),
	(565509, 130, '2014-03-01 00:20:53.000000', 'consum', 0.0227, 'lps'),
	(565510, 130, '2014-03-01 00:20:54.000000', 'consum', 0.0223, 'lps'),
	(565511, 130, '2014-03-01 00:20:55.000000', 'consum', 0.0225, 'lps'),
	(565512, 130, '2014-03-01 00:20:56.000000', 'consum', 0.0227, 'lps'),
	(565513, 130, '2014-03-01 00:20:57.000000', 'consum', 0.0213, 'lps'),
	(565514, 130, '2014-03-01 00:20:58.000000', 'consum', 0.0212, 'lps'),
	(565515, 130, '2014-03-01 00:20:59.000000', 'consum', 0.0213, 'lps'),
	(565516, 130, '2014-03-01 00:21:00.000000', 'consum', 0.0221, 'lps'),
	(565517, 130, '2014-03-01 00:21:01.000000', 'consum', 0.0216, 'lps'),
	(565518, 130, '2014-03-01 00:21:02.000000', 'consum', 0.0227, 'lps'),
	(565519, 130, '2014-03-01 00:21:03.000000', 'consum', 0.0222, 'lps'),
	(565520, 130, '2014-03-01 00:21:04.000000', 'consum', 0.0217, 'lps'),
	(565521, 130, '2014-03-01 00:21:05.000000', 'consum', 0.0212, 'lps'),
	(565522, 130, '2014-03-01 00:21:06.000000', 'consum', 0.0219, 'lps'),
	(565523, 130, '2014-03-01 00:21:07.000000', 'consum', 0.0210, 'lps'),
	(565524, 130, '2014-03-01 00:21:08.000000', 'consum', 0.0221, 'lps'),
	(565525, 130, '2014-03-01 00:21:09.000000', 'consum', 0.0210, 'lps'),
	(565526, 130, '2014-03-01 00:21:10.000000', 'consum', 0.0215, 'lps'),
	(565527, 130, '2014-03-01 00:21:11.000000', 'consum', 0.0215, 'lps'),
	(565528, 130, '2014-03-01 00:21:12.000000', 'consum', 0.0220, 'lps'),
	(565529, 130, '2014-03-01 00:21:13.000000', 'consum', 0.0228, 'lps'),
	(565530, 130, '2014-03-01 00:21:14.000000', 'consum', 0.0212, 'lps'),
	(565531, 130, '2014-03-01 00:21:15.000000', 'consum', 0.0223, 'lps'),
	(565532, 130, '2014-03-01 00:21:16.000000', 'consum', 0.0213, 'lps'),
	(565533, 130, '2014-03-01 00:21:17.000000', 'consum', 0.0224, 'lps'),
	(565534, 130, '2014-03-01 00:21:18.000000', 'consum', 0.0214, 'lps'),
	(565535, 130, '2014-03-01 00:21:19.000000', 'consum', 0.0227, 'lps'),
	(565536, 130, '2014-03-01 00:21:20.000000', 'consum', 0.0228, 'lps'),
	(565537, 130, '2014-03-01 00:21:21.000000', 'consum', 0.0211, 'lps'),
	(565538, 130, '2014-03-01 00:21:22.000000', 'consum', 0.0217, 'lps'),
	(565539, 130, '2014-03-01 00:21:23.000000', 'consum', 0.0225, 'lps'),
	(565540, 130, '2014-03-01 00:21:24.000000', 'consum', 0.0224, 'lps'),
	(565541, 130, '2014-03-01 00:21:25.000000', 'consum', 0.0218, 'lps'),
	(565542, 130, '2014-03-01 00:21:26.000000', 'consum', 0.0227, 'lps'),
	(565543, 130, '2014-03-01 00:21:27.000000', 'consum', 0.0216, 'lps'),
	(565544, 130, '2014-03-01 00:21:28.000000', 'consum', 0.0225, 'lps'),
	(565545, 130, '2014-03-01 00:21:29.000000', 'consum', 0.0211, 'lps'),
	(565546, 130, '2014-03-01 00:21:30.000000', 'consum', 0.0228, 'lps'),
	(565547, 130, '2014-03-01 00:21:31.000000', 'consum', 0.0222, 'lps'),
	(565548, 130, '2014-03-01 00:21:32.000000', 'consum', 0.0218, 'lps'),
	(565549, 130, '2014-03-01 00:21:33.000000', 'consum', 0.0213, 'lps'),
	(565550, 130, '2014-03-01 00:21:34.000000', 'consum', 0.0223, 'lps'),
	(565551, 130, '2014-03-01 00:21:35.000000', 'consum', 0.0225, 'lps'),
	(565552, 130, '2014-03-01 00:21:36.000000', 'consum', 0.0210, 'lps'),
	(565553, 130, '2014-03-01 00:21:37.000000', 'consum', 0.0221, 'lps'),
	(565554, 130, '2014-03-01 00:21:38.000000', 'consum', 0.0211, 'lps'),
	(565555, 130, '2014-03-01 00:21:39.000000', 'consum', 0.0219, 'lps'),
	(565556, 130, '2014-03-01 00:21:40.000000', 'consum', 0.0216, 'lps'),
	(565557, 130, '2014-03-01 00:21:41.000000', 'consum', 0.0211, 'lps'),
	(565558, 130, '2014-03-01 00:21:42.000000', 'consum', 0.0218, 'lps'),
	(565559, 130, '2014-03-01 00:21:43.000000', 'consum', 0.0211, 'lps'),
	(565560, 130, '2014-03-01 00:21:44.000000', 'consum', 0.0227, 'lps'),
	(565561, 130, '2014-03-01 00:21:45.000000', 'consum', 0.0217, 'lps'),
	(565562, 130, '2014-03-01 00:21:46.000000', 'consum', 0.0216, 'lps'),
	(565563, 130, '2014-03-01 00:21:47.000000', 'consum', 0.0216, 'lps'),
	(565564, 130, '2014-03-01 00:21:48.000000', 'consum', 0.0223, 'lps'),
	(565565, 130, '2014-03-01 00:21:49.000000', 'consum', 0.0222, 'lps'),
	(565566, 130, '2014-03-01 00:21:50.000000', 'consum', 0.0210, 'lps'),
	(565567, 130, '2014-03-01 00:21:51.000000', 'consum', 0.0215, 'lps'),
	(565568, 130, '2014-03-01 00:21:52.000000', 'consum', 0.0214, 'lps'),
	(565569, 130, '2014-03-01 00:21:53.000000', 'consum', 0.0215, 'lps'),
	(565570, 130, '2014-03-01 00:21:54.000000', 'consum', 0.0223, 'lps'),
	(565571, 130, '2014-03-01 00:21:55.000000', 'consum', 0.0222, 'lps'),
	(565572, 130, '2014-03-01 00:21:56.000000', 'consum', 0.0215, 'lps'),
	(565573, 130, '2014-03-01 00:21:57.000000', 'consum', 0.0216, 'lps'),
	(565574, 130, '2014-03-01 00:21:58.000000', 'consum', 0.0225, 'lps'),
	(565575, 130, '2014-03-01 00:21:59.000000', 'consum', 0.0211, 'lps'),
	(565576, 130, '2014-03-01 00:22:00.000000', 'consum', 0.0226, 'lps'),
	(565577, 130, '2014-03-01 00:22:01.000000', 'consum', 0.0213, 'lps'),
	(565578, 130, '2014-03-01 00:22:02.000000', 'consum', 0.0217, 'lps'),
	(565579, 130, '2014-03-01 00:22:03.000000', 'consum', 0.0216, 'lps'),
	(565580, 130, '2014-03-01 00:22:04.000000', 'consum', 0.0220, 'lps'),
	(565581, 130, '2014-03-01 00:22:05.000000', 'consum', 0.0223, 'lps'),
	(565582, 130, '2014-03-01 00:22:06.000000', 'consum', 0.0225, 'lps'),
	(565583, 130, '2014-03-01 00:22:07.000000', 'consum', 0.0228, 'lps'),
	(565584, 130, '2014-03-01 00:22:08.000000', 'consum', 0.0216, 'lps'),
	(565585, 130, '2014-03-01 00:22:09.000000', 'consum', 0.0226, 'lps'),
	(565586, 130, '2014-03-01 00:22:10.000000', 'consum', 0.0214, 'lps'),
	(565587, 130, '2014-03-01 00:22:11.000000', 'consum', 0.0220, 'lps'),
	(565588, 130, '2014-03-01 00:22:12.000000', 'consum', 0.0212, 'lps'),
	(565589, 130, '2014-03-01 00:22:13.000000', 'consum', 0.0211, 'lps'),
	(565590, 130, '2014-03-01 00:22:14.000000', 'consum', 0.0226, 'lps'),
	(565591, 130, '2014-03-01 00:22:15.000000', 'consum', 0.0213, 'lps'),
	(565592, 130, '2014-03-01 00:22:16.000000', 'consum', 0.0215, 'lps'),
	(565593, 130, '2014-03-01 00:22:17.000000', 'consum', 0.0228, 'lps'),
	(565594, 130, '2014-03-01 00:22:18.000000', 'consum', 0.0228, 'lps'),
	(565595, 130, '2014-03-01 00:22:19.000000', 'consum', 0.0226, 'lps'),
	(565596, 130, '2014-03-01 00:22:20.000000', 'consum', 0.0219, 'lps'),
	(565597, 130, '2014-03-01 00:22:21.000000', 'consum', 0.0225, 'lps'),
	(565598, 130, '2014-03-01 00:22:22.000000', 'consum', 0.0222, 'lps'),
	(565599, 130, '2014-03-01 00:22:23.000000', 'consum', 0.0223, 'lps'),
	(565600, 130, '2014-03-01 00:22:24.000000', 'consum', 0.0223, 'lps'),
	(565601, 130, '2014-03-01 00:22:25.000000', 'consum', 0.0217, 'lps'),
	(565602, 130, '2014-03-01 00:22:26.000000', 'consum', 0.0225, 'lps'),
	(565603, 130, '2014-03-01 00:22:27.000000', 'consum', 0.0225, 'lps'),
	(565604, 130, '2014-03-01 00:22:28.000000', 'consum', 0.0222, 'lps'),
	(565605, 130, '2014-03-01 00:22:29.000000', 'consum', 0.0228, 'lps'),
	(565606, 130, '2014-03-01 00:22:30.000000', 'consum', 0.0225, 'lps'),
	(565607, 130, '2014-03-01 00:22:31.000000', 'consum', 0.0213, 'lps'),
	(565608, 130, '2014-03-01 00:22:32.000000', 'consum', 0.0219, 'lps'),
	(565609, 130, '2014-03-01 00:22:33.000000', 'consum', 0.0227, 'lps'),
	(565610, 130, '2014-03-01 00:22:34.000000', 'consum', 0.0212, 'lps'),
	(565611, 130, '2014-03-01 00:22:35.000000', 'consum', 0.0225, 'lps'),
	(565612, 130, '2014-03-01 00:22:36.000000', 'consum', 0.0225, 'lps'),
	(565613, 130, '2014-03-01 00:22:37.000000', 'consum', 0.0219, 'lps'),
	(565614, 130, '2014-03-01 00:22:38.000000', 'consum', 0.0210, 'lps'),
	(565615, 130, '2014-03-01 00:22:39.000000', 'consum', 0.0221, 'lps'),
	(565616, 130, '2014-03-01 00:22:40.000000', 'consum', 0.0210, 'lps'),
	(565617, 130, '2014-03-01 00:22:41.000000', 'consum', 0.0214, 'lps'),
	(565618, 130, '2014-03-01 00:22:42.000000', 'consum', 0.0211, 'lps'),
	(565619, 130, '2014-03-01 00:22:43.000000', 'consum', 0.0222, 'lps'),
	(565620, 130, '2014-03-01 00:22:44.000000', 'consum', 0.0213, 'lps'),
	(565621, 130, '2014-03-01 00:22:45.000000', 'consum', 0.0227, 'lps'),
	(565622, 130, '2014-03-01 00:22:46.000000', 'consum', 0.0211, 'lps'),
	(565623, 130, '2014-03-01 00:22:47.000000', 'consum', 0.0223, 'lps'),
	(565624, 130, '2014-03-01 00:22:48.000000', 'consum', 0.0214, 'lps'),
	(565625, 130, '2014-03-01 00:22:49.000000', 'consum', 0.0211, 'lps'),
	(565626, 130, '2014-03-01 00:22:50.000000', 'consum', 0.0223, 'lps'),
	(565627, 130, '2014-03-01 00:22:51.000000', 'consum', 0.0215, 'lps'),
	(565628, 130, '2014-03-01 00:22:52.000000', 'consum', 0.0218, 'lps'),
	(565629, 130, '2014-03-01 00:22:53.000000', 'consum', 0.0213, 'lps'),
	(565630, 130, '2014-03-01 00:22:54.000000', 'consum', 0.0221, 'lps'),
	(565631, 130, '2014-03-01 00:22:55.000000', 'consum', 0.0217, 'lps'),
	(565632, 130, '2014-03-01 00:22:56.000000', 'consum', 0.0214, 'lps'),
	(565633, 130, '2014-03-01 00:22:57.000000', 'consum', 0.0211, 'lps'),
	(565634, 130, '2014-03-01 00:22:58.000000', 'consum', 0.0219, 'lps'),
	(565635, 130, '2014-03-01 00:22:59.000000', 'consum', 0.0218, 'lps'),
	(565636, 130, '2014-03-01 00:23:00.000000', 'consum', 0.0220, 'lps'),
	(565637, 130, '2014-03-01 00:23:01.000000', 'consum', 0.0220, 'lps'),
	(565638, 130, '2014-03-01 00:23:02.000000', 'consum', 0.0228, 'lps'),
	(565639, 130, '2014-03-01 00:23:03.000000', 'consum', 0.0214, 'lps'),
	(565640, 130, '2014-03-01 00:23:04.000000', 'consum', 0.0213, 'lps'),
	(565641, 130, '2014-03-01 00:23:05.000000', 'consum', 0.0215, 'lps'),
	(565642, 130, '2014-03-01 00:23:06.000000', 'consum', 0.0228, 'lps'),
	(565643, 130, '2014-03-01 00:23:07.000000', 'consum', 0.0210, 'lps'),
	(565644, 130, '2014-03-01 00:23:08.000000', 'consum', 0.0213, 'lps'),
	(565645, 130, '2014-03-01 00:23:09.000000', 'consum', 0.0225, 'lps'),
	(565646, 130, '2014-03-01 00:23:10.000000', 'consum', 0.0218, 'lps'),
	(565647, 130, '2014-03-01 00:23:11.000000', 'consum', 0.0227, 'lps'),
	(565648, 130, '2014-03-01 00:23:12.000000', 'consum', 0.0211, 'lps'),
	(565649, 130, '2014-03-01 00:23:13.000000', 'consum', 0.0225, 'lps'),
	(565650, 130, '2014-03-01 00:23:14.000000', 'consum', 0.0226, 'lps'),
	(565651, 130, '2014-03-01 00:23:15.000000', 'consum', 0.0225, 'lps'),
	(565652, 130, '2014-03-01 00:23:16.000000', 'consum', 0.0218, 'lps'),
	(565653, 130, '2014-03-01 00:23:17.000000', 'consum', 0.0225, 'lps'),
	(565654, 130, '2014-03-01 00:23:18.000000', 'consum', 0.0222, 'lps'),
	(565655, 130, '2014-03-01 00:23:19.000000', 'consum', 0.0225, 'lps'),
	(565656, 130, '2014-03-01 00:23:20.000000', 'consum', 0.0212, 'lps'),
	(565657, 130, '2014-03-01 00:23:21.000000', 'consum', 0.0213, 'lps'),
	(565658, 130, '2014-03-01 00:23:22.000000', 'consum', 0.0221, 'lps'),
	(565659, 130, '2014-03-01 00:23:23.000000', 'consum', 0.0217, 'lps'),
	(565660, 130, '2014-03-01 00:23:24.000000', 'consum', 0.0214, 'lps'),
	(565661, 130, '2014-03-01 00:23:25.000000', 'consum', 0.0210, 'lps'),
	(565662, 130, '2014-03-01 00:23:26.000000', 'consum', 0.0215, 'lps'),
	(565663, 130, '2014-03-01 00:23:27.000000', 'consum', 0.0217, 'lps'),
	(565664, 130, '2014-03-01 00:23:28.000000', 'consum', 0.0213, 'lps'),
	(565665, 130, '2014-03-01 00:23:29.000000', 'consum', 0.0225, 'lps'),
	(565666, 130, '2014-03-01 00:23:30.000000', 'consum', 0.0218, 'lps'),
	(565667, 130, '2014-03-01 00:23:31.000000', 'consum', 0.0222, 'lps'),
	(565668, 130, '2014-03-01 00:23:32.000000', 'consum', 0.0212, 'lps'),
	(565669, 130, '2014-03-01 00:23:33.000000', 'consum', 0.0222, 'lps'),
	(565670, 130, '2014-03-01 00:23:34.000000', 'consum', 0.0228, 'lps'),
	(565671, 130, '2014-03-01 00:23:35.000000', 'consum', 0.0223, 'lps'),
	(565672, 130, '2014-03-01 00:23:36.000000', 'consum', 0.0224, 'lps'),
	(565673, 130, '2014-03-01 00:23:37.000000', 'consum', 0.0222, 'lps'),
	(565674, 130, '2014-03-01 00:23:38.000000', 'consum', 0.0210, 'lps'),
	(565675, 130, '2014-03-01 00:23:39.000000', 'consum', 0.0211, 'lps'),
	(565676, 130, '2014-03-01 00:23:40.000000', 'consum', 0.0218, 'lps'),
	(565677, 130, '2014-03-01 00:23:41.000000', 'consum', 0.0226, 'lps'),
	(565678, 130, '2014-03-01 00:23:42.000000', 'consum', 0.0228, 'lps'),
	(565679, 130, '2014-03-01 00:23:43.000000', 'consum', 0.0216, 'lps'),
	(565680, 130, '2014-03-01 00:23:44.000000', 'consum', 0.0224, 'lps'),
	(565681, 130, '2014-03-01 00:23:45.000000', 'consum', 0.0226, 'lps'),
	(565682, 130, '2014-03-01 00:23:46.000000', 'consum', 0.0228, 'lps'),
	(565683, 130, '2014-03-01 00:23:47.000000', 'consum', 0.0217, 'lps'),
	(565684, 130, '2014-03-01 00:23:48.000000', 'consum', 0.0227, 'lps'),
	(565685, 130, '2014-03-01 00:23:49.000000', 'consum', 0.0218, 'lps'),
	(565686, 130, '2014-03-01 00:23:50.000000', 'consum', 0.0219, 'lps'),
	(565687, 130, '2014-03-01 00:23:51.000000', 'consum', 0.0214, 'lps'),
	(565688, 130, '2014-03-01 00:23:52.000000', 'consum', 0.0220, 'lps'),
	(565689, 130, '2014-03-01 00:23:53.000000', 'consum', 0.0212, 'lps'),
	(565690, 130, '2014-03-01 00:23:54.000000', 'consum', 0.0228, 'lps'),
	(565691, 130, '2014-03-01 00:23:55.000000', 'consum', 0.0220, 'lps'),
	(565692, 130, '2014-03-01 00:23:56.000000', 'consum', 0.0222, 'lps'),
	(565693, 130, '2014-03-01 00:23:57.000000', 'consum', 0.0225, 'lps'),
	(565694, 130, '2014-03-01 00:23:58.000000', 'consum', 0.0228, 'lps'),
	(565695, 130, '2014-03-01 00:23:59.000000', 'consum', 0.0219, 'lps'),
	(565696, 130, '2014-03-01 00:24:00.000000', 'consum', 0.0221, 'lps'),
	(565697, 130, '2014-03-01 00:24:01.000000', 'consum', 0.0221, 'lps'),
	(565698, 130, '2014-03-01 00:24:02.000000', 'consum', 0.0211, 'lps'),
	(565699, 130, '2014-03-01 00:24:03.000000', 'consum', 0.0222, 'lps'),
	(565700, 130, '2014-03-01 00:24:04.000000', 'consum', 0.0210, 'lps'),
	(565701, 130, '2014-03-01 00:24:05.000000', 'consum', 0.0213, 'lps'),
	(565702, 130, '2014-03-01 00:24:06.000000', 'consum', 0.0223, 'lps'),
	(565703, 130, '2014-03-01 00:24:07.000000', 'consum', 0.0213, 'lps'),
	(565704, 130, '2014-03-01 00:24:08.000000', 'consum', 0.0222, 'lps'),
	(565705, 130, '2014-03-01 00:24:09.000000', 'consum', 0.0223, 'lps'),
	(565706, 130, '2014-03-01 00:24:10.000000', 'consum', 0.0221, 'lps'),
	(565707, 130, '2014-03-01 00:24:11.000000', 'consum', 0.0227, 'lps'),
	(565708, 130, '2014-03-01 00:24:12.000000', 'consum', 0.0225, 'lps'),
	(565709, 130, '2014-03-01 00:24:13.000000', 'consum', 0.0215, 'lps'),
	(565710, 130, '2014-03-01 00:24:14.000000', 'consum', 0.0211, 'lps'),
	(565711, 130, '2014-03-01 00:24:15.000000', 'consum', 0.0217, 'lps'),
	(565712, 130, '2014-03-01 00:24:16.000000', 'consum', 0.0225, 'lps'),
	(565713, 130, '2014-03-01 00:24:17.000000', 'consum', 0.0226, 'lps'),
	(565714, 130, '2014-03-01 00:24:18.000000', 'consum', 0.0224, 'lps'),
	(565715, 130, '2014-03-01 00:24:19.000000', 'consum', 0.0217, 'lps'),
	(565716, 130, '2014-03-01 00:24:20.000000', 'consum', 0.0223, 'lps'),
	(565717, 130, '2014-03-01 00:24:21.000000', 'consum', 0.0217, 'lps'),
	(565718, 130, '2014-03-01 00:24:22.000000', 'consum', 0.0222, 'lps'),
	(565719, 130, '2014-03-01 00:24:23.000000', 'consum', 0.0215, 'lps'),
	(565720, 130, '2014-03-01 00:24:24.000000', 'consum', 0.0216, 'lps'),
	(565721, 130, '2014-03-01 00:24:25.000000', 'consum', 0.0226, 'lps'),
	(565722, 130, '2014-03-01 00:24:26.000000', 'consum', 0.0216, 'lps'),
	(565723, 130, '2014-03-01 00:24:27.000000', 'consum', 0.0212, 'lps'),
	(565724, 130, '2014-03-01 00:24:28.000000', 'consum', 0.0221, 'lps'),
	(565725, 130, '2014-03-01 00:24:29.000000', 'consum', 0.0220, 'lps'),
	(565726, 130, '2014-03-01 00:24:30.000000', 'consum', 0.0227, 'lps'),
	(565727, 130, '2014-03-01 00:24:31.000000', 'consum', 0.0210, 'lps'),
	(565728, 130, '2014-03-01 00:24:32.000000', 'consum', 0.0217, 'lps'),
	(565729, 130, '2014-03-01 00:24:33.000000', 'consum', 0.0227, 'lps'),
	(565730, 130, '2014-03-01 00:24:34.000000', 'consum', 0.0219, 'lps'),
	(565731, 130, '2014-03-01 00:24:35.000000', 'consum', 0.0220, 'lps'),
	(565732, 130, '2014-03-01 00:24:36.000000', 'consum', 0.0216, 'lps'),
	(565733, 130, '2014-03-01 00:24:37.000000', 'consum', 0.0228, 'lps'),
	(565734, 130, '2014-03-01 00:24:38.000000', 'consum', 0.0225, 'lps'),
	(565735, 130, '2014-03-01 00:24:39.000000', 'consum', 0.0212, 'lps'),
	(565736, 130, '2014-03-01 00:24:40.000000', 'consum', 0.0217, 'lps'),
	(565737, 130, '2014-03-01 00:24:41.000000', 'consum', 0.0217, 'lps'),
	(565738, 130, '2014-03-01 00:24:42.000000', 'consum', 0.0227, 'lps'),
	(565739, 130, '2014-03-01 00:24:43.000000', 'consum', 0.0216, 'lps'),
	(565740, 130, '2014-03-01 00:24:44.000000', 'consum', 0.0228, 'lps'),
	(565741, 130, '2014-03-01 00:24:45.000000', 'consum', 0.0224, 'lps'),
	(565742, 130, '2014-03-01 00:24:46.000000', 'consum', 0.0227, 'lps'),
	(565743, 130, '2014-03-01 00:24:47.000000', 'consum', 0.0217, 'lps'),
	(565744, 130, '2014-03-01 00:24:48.000000', 'consum', 0.0213, 'lps'),
	(565745, 130, '2014-03-01 00:24:49.000000', 'consum', 0.0223, 'lps'),
	(565746, 130, '2014-03-01 00:24:50.000000', 'consum', 0.0211, 'lps'),
	(565747, 130, '2014-03-01 00:24:51.000000', 'consum', 0.0213, 'lps'),
	(565748, 130, '2014-03-01 00:24:52.000000', 'consum', 0.0223, 'lps'),
	(565749, 130, '2014-03-01 00:24:53.000000', 'consum', 0.0210, 'lps'),
	(565750, 130, '2014-03-01 00:24:54.000000', 'consum', 0.0210, 'lps'),
	(565751, 130, '2014-03-01 00:24:55.000000', 'consum', 0.0227, 'lps'),
	(565752, 130, '2014-03-01 00:24:56.000000', 'consum', 0.0220, 'lps'),
	(565753, 130, '2014-03-01 00:24:57.000000', 'consum', 0.0228, 'lps'),
	(565754, 130, '2014-03-01 00:24:58.000000', 'consum', 0.0216, 'lps'),
	(565755, 130, '2014-03-01 00:24:59.000000', 'consum', 0.0223, 'lps'),
	(565756, 130, '2014-03-01 00:25:00.000000', 'consum', 0.0218, 'lps'),
	(565757, 130, '2014-03-01 00:25:01.000000', 'consum', 0.0215, 'lps'),
	(565758, 130, '2014-03-01 00:25:02.000000', 'consum', 0.0227, 'lps'),
	(565759, 130, '2014-03-01 00:25:03.000000', 'consum', 0.0224, 'lps'),
	(565760, 130, '2014-03-01 00:25:04.000000', 'consum', 0.0211, 'lps'),
	(565761, 130, '2014-03-01 00:25:05.000000', 'consum', 0.0213, 'lps'),
	(565762, 130, '2014-03-01 00:25:06.000000', 'consum', 0.0222, 'lps'),
	(565763, 130, '2014-03-01 00:25:07.000000', 'consum', 0.0221, 'lps'),
	(565764, 130, '2014-03-01 00:25:08.000000', 'consum', 0.0213, 'lps'),
	(565765, 130, '2014-03-01 00:25:09.000000', 'consum', 0.0210, 'lps'),
	(565766, 130, '2014-03-01 00:25:10.000000', 'consum', 0.0221, 'lps'),
	(565767, 130, '2014-03-01 00:25:11.000000', 'consum', 0.0228, 'lps'),
	(565768, 130, '2014-03-01 00:25:12.000000', 'consum', 0.0212, 'lps'),
	(565769, 130, '2014-03-01 00:25:13.000000', 'consum', 0.0221, 'lps'),
	(565770, 130, '2014-03-01 00:25:14.000000', 'consum', 0.0221, 'lps'),
	(565771, 130, '2014-03-01 00:25:15.000000', 'consum', 0.0214, 'lps'),
	(565772, 130, '2014-03-01 00:25:16.000000', 'consum', 0.0215, 'lps'),
	(565773, 130, '2014-03-01 00:25:17.000000', 'consum', 0.0225, 'lps'),
	(565774, 130, '2014-03-01 00:25:18.000000', 'consum', 0.0215, 'lps'),
	(565775, 130, '2014-03-01 00:25:19.000000', 'consum', 0.0227, 'lps'),
	(565776, 130, '2014-03-01 00:25:20.000000', 'consum', 0.0225, 'lps'),
	(565777, 130, '2014-03-01 00:25:21.000000', 'consum', 0.0215, 'lps'),
	(565778, 130, '2014-03-01 00:25:22.000000', 'consum', 0.0210, 'lps'),
	(565779, 130, '2014-03-01 00:25:23.000000', 'consum', 0.0214, 'lps'),
	(565780, 130, '2014-03-01 00:25:24.000000', 'consum', 0.0212, 'lps'),
	(565781, 130, '2014-03-01 00:25:25.000000', 'consum', 0.0228, 'lps'),
	(565782, 130, '2014-03-01 00:25:26.000000', 'consum', 0.0220, 'lps'),
	(565783, 130, '2014-03-01 00:25:27.000000', 'consum', 0.0223, 'lps'),
	(565784, 130, '2014-03-01 00:25:28.000000', 'consum', 0.0210, 'lps'),
	(565785, 130, '2014-03-01 00:25:29.000000', 'consum', 0.0225, 'lps'),
	(565786, 130, '2014-03-01 00:25:30.000000', 'consum', 0.0213, 'lps'),
	(565787, 130, '2014-03-01 00:25:31.000000', 'consum', 0.0218, 'lps'),
	(565788, 130, '2014-03-01 00:25:32.000000', 'consum', 0.0220, 'lps'),
	(565789, 130, '2014-03-01 00:25:33.000000', 'consum', 0.0218, 'lps'),
	(565790, 130, '2014-03-01 00:25:34.000000', 'consum', 0.0222, 'lps'),
	(565791, 130, '2014-03-01 00:25:35.000000', 'consum', 0.0226, 'lps'),
	(565792, 130, '2014-03-01 00:25:36.000000', 'consum', 0.0216, 'lps'),
	(565793, 130, '2014-03-01 00:25:37.000000', 'consum', 0.0214, 'lps'),
	(565794, 130, '2014-03-01 00:25:38.000000', 'consum', 0.0212, 'lps'),
	(565795, 130, '2014-03-01 00:25:39.000000', 'consum', 0.0226, 'lps'),
	(565796, 130, '2014-03-01 00:25:40.000000', 'consum', 0.0228, 'lps'),
	(565797, 130, '2014-03-01 00:25:41.000000', 'consum', 0.0217, 'lps'),
	(565798, 130, '2014-03-01 00:25:42.000000', 'consum', 0.0227, 'lps'),
	(565799, 130, '2014-03-01 00:25:43.000000', 'consum', 0.0216, 'lps'),
	(565800, 130, '2014-03-01 00:25:44.000000', 'consum', 0.0210, 'lps'),
	(565801, 130, '2014-03-01 00:25:45.000000', 'consum', 0.0210, 'lps'),
	(565802, 130, '2014-03-01 00:25:46.000000', 'consum', 0.0213, 'lps'),
	(565803, 130, '2014-03-01 00:25:47.000000', 'consum', 0.0224, 'lps'),
	(565804, 130, '2014-03-01 00:25:48.000000', 'consum', 0.0217, 'lps'),
	(565805, 130, '2014-03-01 00:25:49.000000', 'consum', 0.0220, 'lps'),
	(565806, 130, '2014-03-01 00:25:50.000000', 'consum', 0.0222, 'lps'),
	(565807, 130, '2014-03-01 00:25:51.000000', 'consum', 0.0220, 'lps'),
	(565808, 130, '2014-03-01 00:25:52.000000', 'consum', 0.0226, 'lps'),
	(565809, 130, '2014-03-01 00:25:53.000000', 'consum', 0.0224, 'lps'),
	(565810, 130, '2014-03-01 00:25:54.000000', 'consum', 0.0210, 'lps'),
	(565811, 130, '2014-03-01 00:25:55.000000', 'consum', 0.0227, 'lps'),
	(565812, 130, '2014-03-01 00:25:56.000000', 'consum', 0.0221, 'lps'),
	(565813, 130, '2014-03-01 00:25:57.000000', 'consum', 0.0211, 'lps'),
	(565814, 130, '2014-03-01 00:25:58.000000', 'consum', 0.0224, 'lps'),
	(565815, 130, '2014-03-01 00:25:59.000000', 'consum', 0.0219, 'lps'),
	(565816, 130, '2014-03-01 00:26:00.000000', 'consum', 0.0213, 'lps'),
	(565817, 130, '2014-03-01 00:26:01.000000', 'consum', 0.0220, 'lps'),
	(565818, 130, '2014-03-01 00:26:02.000000', 'consum', 0.0213, 'lps'),
	(565819, 130, '2014-03-01 00:26:03.000000', 'consum', 0.0212, 'lps'),
	(565820, 130, '2014-03-01 00:26:04.000000', 'consum', 0.0212, 'lps'),
	(565821, 130, '2014-03-01 00:26:05.000000', 'consum', 0.0213, 'lps'),
	(565822, 130, '2014-03-01 00:26:06.000000', 'consum', 0.0222, 'lps'),
	(565823, 130, '2014-03-01 00:26:07.000000', 'consum', 0.0223, 'lps'),
	(565824, 130, '2014-03-01 00:26:08.000000', 'consum', 0.0219, 'lps'),
	(565825, 130, '2014-03-01 00:26:09.000000', 'consum', 0.0218, 'lps'),
	(565826, 130, '2014-03-01 00:26:10.000000', 'consum', 0.0222, 'lps'),
	(565827, 130, '2014-03-01 00:26:11.000000', 'consum', 0.0210, 'lps'),
	(565828, 130, '2014-03-01 00:26:12.000000', 'consum', 0.0213, 'lps'),
	(565829, 130, '2014-03-01 00:26:13.000000', 'consum', 0.0226, 'lps'),
	(565830, 130, '2014-03-01 00:26:14.000000', 'consum', 0.0222, 'lps'),
	(565831, 130, '2014-03-01 00:26:15.000000', 'consum', 0.0225, 'lps'),
	(565832, 130, '2014-03-01 00:26:16.000000', 'consum', 0.0211, 'lps'),
	(565833, 130, '2014-03-01 00:26:17.000000', 'consum', 0.0226, 'lps'),
	(565834, 130, '2014-03-01 00:26:18.000000', 'consum', 0.0212, 'lps'),
	(565835, 130, '2014-03-01 00:26:19.000000', 'consum', 0.0212, 'lps'),
	(565836, 130, '2014-03-01 00:26:20.000000', 'consum', 0.0215, 'lps'),
	(565837, 130, '2014-03-01 00:26:21.000000', 'consum', 0.0227, 'lps'),
	(565838, 130, '2014-03-01 00:26:22.000000', 'consum', 0.0223, 'lps'),
	(565839, 130, '2014-03-01 00:26:23.000000', 'consum', 0.0226, 'lps'),
	(565840, 130, '2014-03-01 00:26:24.000000', 'consum', 0.0212, 'lps'),
	(565841, 130, '2014-03-01 00:26:25.000000', 'consum', 0.0210, 'lps'),
	(565842, 130, '2014-03-01 00:26:26.000000', 'consum', 0.0224, 'lps'),
	(565843, 130, '2014-03-01 00:26:27.000000', 'consum', 0.0226, 'lps'),
	(565844, 130, '2014-03-01 00:26:28.000000', 'consum', 0.0226, 'lps'),
	(565845, 130, '2014-03-01 00:26:29.000000', 'consum', 0.0225, 'lps'),
	(565846, 130, '2014-03-01 00:26:30.000000', 'consum', 0.0219, 'lps'),
	(565847, 130, '2014-03-01 00:26:31.000000', 'consum', 0.0211, 'lps'),
	(565848, 130, '2014-03-01 00:26:32.000000', 'consum', 0.0226, 'lps'),
	(565849, 130, '2014-03-01 00:26:33.000000', 'consum', 0.0212, 'lps'),
	(565850, 130, '2014-03-01 00:26:34.000000', 'consum', 0.0212, 'lps'),
	(565851, 130, '2014-03-01 00:26:35.000000', 'consum', 0.0212, 'lps'),
	(565852, 130, '2014-03-01 00:26:36.000000', 'consum', 0.0217, 'lps'),
	(565853, 130, '2014-03-01 00:26:37.000000', 'consum', 0.0217, 'lps'),
	(565854, 130, '2014-03-01 00:26:38.000000', 'consum', 0.0227, 'lps'),
	(565855, 130, '2014-03-01 00:26:39.000000', 'consum', 0.0217, 'lps'),
	(565856, 130, '2014-03-01 00:26:40.000000', 'consum', 0.0213, 'lps'),
	(565857, 130, '2014-03-01 00:26:41.000000', 'consum', 0.0224, 'lps'),
	(565858, 130, '2014-03-01 00:26:42.000000', 'consum', 0.0216, 'lps'),
	(565859, 130, '2014-03-01 00:26:43.000000', 'consum', 0.0216, 'lps'),
	(565860, 130, '2014-03-01 00:26:44.000000', 'consum', 0.0221, 'lps'),
	(565861, 130, '2014-03-01 00:26:45.000000', 'consum', 0.0211, 'lps'),
	(565862, 130, '2014-03-01 00:26:46.000000', 'consum', 0.0220, 'lps'),
	(565863, 130, '2014-03-01 00:26:47.000000', 'consum', 0.0222, 'lps'),
	(565864, 130, '2014-03-01 00:26:48.000000', 'consum', 0.0218, 'lps'),
	(565865, 130, '2014-03-01 00:26:49.000000', 'consum', 0.0215, 'lps'),
	(565866, 130, '2014-03-01 00:26:50.000000', 'consum', 0.0212, 'lps'),
	(565867, 130, '2014-03-01 00:26:51.000000', 'consum', 0.0224, 'lps'),
	(565868, 130, '2014-03-01 00:26:52.000000', 'consum', 0.0219, 'lps'),
	(565869, 130, '2014-03-01 00:26:53.000000', 'consum', 0.0213, 'lps'),
	(565870, 130, '2014-03-01 00:26:54.000000', 'consum', 0.0215, 'lps'),
	(565871, 130, '2014-03-01 00:26:55.000000', 'consum', 0.0211, 'lps'),
	(565872, 130, '2014-03-01 00:26:56.000000', 'consum', 0.0218, 'lps'),
	(565873, 130, '2014-03-01 00:26:57.000000', 'consum', 0.0210, 'lps'),
	(565874, 130, '2014-03-01 00:26:58.000000', 'consum', 0.0224, 'lps'),
	(565875, 130, '2014-03-01 00:26:59.000000', 'consum', 0.0226, 'lps'),
	(565876, 130, '2014-03-01 00:27:00.000000', 'consum', 0.0227, 'lps'),
	(565877, 130, '2014-03-01 00:27:01.000000', 'consum', 0.0227, 'lps'),
	(565878, 130, '2014-03-01 00:27:02.000000', 'consum', 0.0228, 'lps'),
	(565879, 130, '2014-03-01 00:27:03.000000', 'consum', 0.0228, 'lps'),
	(565880, 130, '2014-03-01 00:27:04.000000', 'consum', 0.0210, 'lps'),
	(565881, 130, '2014-03-01 00:27:05.000000', 'consum', 0.0212, 'lps'),
	(565882, 130, '2014-03-01 00:27:06.000000', 'consum', 0.0220, 'lps'),
	(565883, 130, '2014-03-01 00:27:07.000000', 'consum', 0.0218, 'lps'),
	(565884, 130, '2014-03-01 00:27:08.000000', 'consum', 0.0219, 'lps'),
	(565885, 130, '2014-03-01 00:27:09.000000', 'consum', 0.0213, 'lps'),
	(565886, 130, '2014-03-01 00:27:10.000000', 'consum', 0.0216, 'lps'),
	(565887, 130, '2014-03-01 00:27:11.000000', 'consum', 0.0213, 'lps'),
	(565888, 130, '2014-03-01 00:27:12.000000', 'consum', 0.0227, 'lps'),
	(565889, 130, '2014-03-01 00:27:13.000000', 'consum', 0.0213, 'lps'),
	(565890, 130, '2014-03-01 00:27:14.000000', 'consum', 0.0228, 'lps'),
	(565891, 130, '2014-03-01 00:27:15.000000', 'consum', 0.0216, 'lps'),
	(565892, 130, '2014-03-01 00:27:16.000000', 'consum', 0.0226, 'lps'),
	(565893, 130, '2014-03-01 00:27:17.000000', 'consum', 0.0214, 'lps'),
	(565894, 130, '2014-03-01 00:27:18.000000', 'consum', 0.0220, 'lps'),
	(565895, 130, '2014-03-01 00:27:19.000000', 'consum', 0.0211, 'lps'),
	(565896, 130, '2014-03-01 00:27:20.000000', 'consum', 0.0225, 'lps'),
	(565897, 130, '2014-03-01 00:27:21.000000', 'consum', 0.0226, 'lps'),
	(565898, 130, '2014-03-01 00:27:22.000000', 'consum', 0.0227, 'lps'),
	(565899, 130, '2014-03-01 00:27:23.000000', 'consum', 0.0228, 'lps'),
	(565900, 130, '2014-03-01 00:27:24.000000', 'consum', 0.0211, 'lps'),
	(565901, 130, '2014-03-01 00:27:25.000000', 'consum', 0.0217, 'lps'),
	(565902, 130, '2014-03-01 00:27:26.000000', 'consum', 0.0223, 'lps'),
	(565903, 130, '2014-03-01 00:27:27.000000', 'consum', 0.0217, 'lps'),
	(565904, 130, '2014-03-01 00:27:28.000000', 'consum', 0.0225, 'lps'),
	(565905, 130, '2014-03-01 00:27:29.000000', 'consum', 0.0228, 'lps'),
	(565906, 130, '2014-03-01 00:27:30.000000', 'consum', 0.0216, 'lps'),
	(565907, 130, '2014-03-01 00:27:31.000000', 'consum', 0.0225, 'lps'),
	(565908, 130, '2014-03-01 00:27:32.000000', 'consum', 0.0212, 'lps'),
	(565909, 130, '2014-03-01 00:27:33.000000', 'consum', 0.0213, 'lps'),
	(565910, 130, '2014-03-01 00:27:34.000000', 'consum', 0.0219, 'lps'),
	(565911, 130, '2014-03-01 00:27:35.000000', 'consum', 0.0210, 'lps'),
	(565912, 130, '2014-03-01 00:27:36.000000', 'consum', 0.0219, 'lps'),
	(565913, 130, '2014-03-01 00:27:37.000000', 'consum', 0.0217, 'lps'),
	(565914, 130, '2014-03-01 00:27:38.000000', 'consum', 0.0220, 'lps'),
	(565915, 130, '2014-03-01 00:27:39.000000', 'consum', 0.0219, 'lps'),
	(565916, 130, '2014-03-01 00:27:40.000000', 'consum', 0.0225, 'lps'),
	(565917, 130, '2014-03-01 00:27:41.000000', 'consum', 0.0220, 'lps'),
	(565918, 130, '2014-03-01 00:27:42.000000', 'consum', 0.0216, 'lps'),
	(565919, 130, '2014-03-01 00:27:43.000000', 'consum', 0.0210, 'lps'),
	(565920, 130, '2014-03-01 00:27:44.000000', 'consum', 0.0211, 'lps'),
	(565921, 130, '2014-03-01 00:27:45.000000', 'consum', 0.0215, 'lps'),
	(565922, 130, '2014-03-01 00:27:46.000000', 'consum', 0.0213, 'lps'),
	(565923, 130, '2014-03-01 00:27:47.000000', 'consum', 0.0212, 'lps'),
	(565924, 130, '2014-03-01 00:27:48.000000', 'consum', 0.0212, 'lps'),
	(565925, 130, '2014-03-01 00:27:49.000000', 'consum', 0.0212, 'lps'),
	(565926, 130, '2014-03-01 00:27:50.000000', 'consum', 0.0215, 'lps'),
	(565927, 130, '2014-03-01 00:27:51.000000', 'consum', 0.0212, 'lps'),
	(565928, 130, '2014-03-01 00:27:52.000000', 'consum', 0.0222, 'lps'),
	(565929, 130, '2014-03-01 00:27:53.000000', 'consum', 0.0211, 'lps'),
	(565930, 130, '2014-03-01 00:27:54.000000', 'consum', 0.0215, 'lps'),
	(565931, 130, '2014-03-01 00:27:55.000000', 'consum', 0.0214, 'lps'),
	(565932, 130, '2014-03-01 00:27:56.000000', 'consum', 0.0215, 'lps'),
	(565933, 130, '2014-03-01 00:27:57.000000', 'consum', 0.0224, 'lps'),
	(565934, 130, '2014-03-01 00:27:58.000000', 'consum', 0.0227, 'lps'),
	(565935, 130, '2014-03-01 00:27:59.000000', 'consum', 0.0217, 'lps'),
	(565936, 130, '2014-03-01 00:28:00.000000', 'consum', 0.0211, 'lps'),
	(565937, 130, '2014-03-01 00:28:01.000000', 'consum', 0.0216, 'lps'),
	(565938, 130, '2014-03-01 00:28:02.000000', 'consum', 0.0217, 'lps'),
	(565939, 130, '2014-03-01 00:28:03.000000', 'consum', 0.0211, 'lps'),
	(565940, 130, '2014-03-01 00:28:04.000000', 'consum', 0.0210, 'lps'),
	(565941, 130, '2014-03-01 00:28:05.000000', 'consum', 0.0210, 'lps'),
	(565942, 130, '2014-03-01 00:28:06.000000', 'consum', 0.0210, 'lps'),
	(565943, 130, '2014-03-01 00:28:07.000000', 'consum', 0.0212, 'lps'),
	(565944, 130, '2014-03-01 00:28:08.000000', 'consum', 0.0221, 'lps'),
	(565945, 130, '2014-03-01 00:28:09.000000', 'consum', 0.0221, 'lps'),
	(565946, 130, '2014-03-01 00:28:10.000000', 'consum', 0.0214, 'lps'),
	(565947, 130, '2014-03-01 00:28:11.000000', 'consum', 0.0216, 'lps'),
	(565948, 130, '2014-03-01 00:28:12.000000', 'consum', 0.0226, 'lps'),
	(565949, 130, '2014-03-01 00:28:13.000000', 'consum', 0.0219, 'lps'),
	(565950, 130, '2014-03-01 00:28:14.000000', 'consum', 0.0226, 'lps'),
	(565951, 130, '2014-03-01 00:28:15.000000', 'consum', 0.0224, 'lps'),
	(565952, 130, '2014-03-01 00:28:16.000000', 'consum', 0.0213, 'lps'),
	(565953, 130, '2014-03-01 00:28:17.000000', 'consum', 0.0223, 'lps'),
	(565954, 130, '2014-03-01 00:28:18.000000', 'consum', 0.0210, 'lps'),
	(565955, 130, '2014-03-01 00:28:19.000000', 'consum', 0.0227, 'lps'),
	(565956, 130, '2014-03-01 00:28:20.000000', 'consum', 0.0221, 'lps'),
	(565957, 130, '2014-03-01 00:28:21.000000', 'consum', 0.0215, 'lps'),
	(565958, 130, '2014-03-01 00:28:22.000000', 'consum', 0.0222, 'lps'),
	(565959, 130, '2014-03-01 00:28:23.000000', 'consum', 0.0218, 'lps'),
	(565960, 130, '2014-03-01 00:28:24.000000', 'consum', 0.0214, 'lps'),
	(565961, 130, '2014-03-01 00:28:25.000000', 'consum', 0.0226, 'lps'),
	(565962, 130, '2014-03-01 00:28:26.000000', 'consum', 0.0221, 'lps'),
	(565963, 130, '2014-03-01 00:28:27.000000', 'consum', 0.0218, 'lps'),
	(565964, 130, '2014-03-01 00:28:28.000000', 'consum', 0.0215, 'lps'),
	(565965, 130, '2014-03-01 00:28:29.000000', 'consum', 0.0213, 'lps'),
	(565966, 130, '2014-03-01 00:28:30.000000', 'consum', 0.0211, 'lps'),
	(565967, 130, '2014-03-01 00:28:31.000000', 'consum', 0.0225, 'lps'),
	(565968, 130, '2014-03-01 00:28:32.000000', 'consum', 0.0227, 'lps'),
	(565969, 130, '2014-03-01 00:28:33.000000', 'consum', 0.0211, 'lps'),
	(565970, 130, '2014-03-01 00:28:34.000000', 'consum', 0.0220, 'lps'),
	(565971, 130, '2014-03-01 00:28:35.000000', 'consum', 0.0221, 'lps'),
	(565972, 130, '2014-03-01 00:28:36.000000', 'consum', 0.0218, 'lps'),
	(565973, 130, '2014-03-01 00:28:37.000000', 'consum', 0.0215, 'lps'),
	(565974, 130, '2014-03-01 00:28:38.000000', 'consum', 0.0213, 'lps'),
	(565975, 130, '2014-03-01 00:28:39.000000', 'consum', 0.0211, 'lps'),
	(565976, 130, '2014-03-01 00:28:40.000000', 'consum', 0.0224, 'lps'),
	(565977, 130, '2014-03-01 00:28:41.000000', 'consum', 0.0220, 'lps'),
	(565978, 130, '2014-03-01 00:28:42.000000', 'consum', 0.0220, 'lps'),
	(565979, 130, '2014-03-01 00:28:43.000000', 'consum', 0.0212, 'lps'),
	(565980, 130, '2014-03-01 00:28:44.000000', 'consum', 0.0228, 'lps'),
	(565981, 130, '2014-03-01 00:28:45.000000', 'consum', 0.0217, 'lps'),
	(565982, 130, '2014-03-01 00:28:46.000000', 'consum', 0.0212, 'lps'),
	(565983, 130, '2014-03-01 00:28:47.000000', 'consum', 0.0216, 'lps'),
	(565984, 130, '2014-03-01 00:28:48.000000', 'consum', 0.0217, 'lps'),
	(565985, 130, '2014-03-01 00:28:49.000000', 'consum', 0.0228, 'lps'),
	(565986, 130, '2014-03-01 00:28:50.000000', 'consum', 0.0223, 'lps'),
	(565987, 130, '2014-03-01 00:28:51.000000', 'consum', 0.0220, 'lps'),
	(565988, 130, '2014-03-01 00:28:52.000000', 'consum', 0.0223, 'lps'),
	(565989, 130, '2014-03-01 00:28:53.000000', 'consum', 0.0225, 'lps'),
	(565990, 130, '2014-03-01 00:28:54.000000', 'consum', 0.0211, 'lps'),
	(565991, 130, '2014-03-01 00:28:55.000000', 'consum', 0.0226, 'lps'),
	(565992, 130, '2014-03-01 00:28:56.000000', 'consum', 0.0210, 'lps'),
	(565993, 130, '2014-03-01 00:28:57.000000', 'consum', 0.0220, 'lps'),
	(565994, 130, '2014-03-01 00:28:58.000000', 'consum', 0.0224, 'lps'),
	(565995, 130, '2014-03-01 00:28:59.000000', 'consum', 0.0210, 'lps'),
	(565996, 130, '2014-03-01 00:29:00.000000', 'consum', 0.0226, 'lps'),
	(565997, 130, '2014-03-01 00:29:01.000000', 'consum', 0.0215, 'lps'),
	(565998, 130, '2014-03-01 00:29:02.000000', 'consum', 0.0226, 'lps'),
	(565999, 130, '2014-03-01 00:29:03.000000', 'consum', 0.0218, 'lps'),
	(566000, 130, '2014-03-01 00:29:04.000000', 'consum', 0.0223, 'lps'),
	(566001, 130, '2014-03-01 00:29:05.000000', 'consum', 0.0214, 'lps'),
	(566002, 130, '2014-03-01 00:29:06.000000', 'consum', 0.0228, 'lps'),
	(566003, 130, '2014-03-01 00:29:07.000000', 'consum', 0.0212, 'lps'),
	(566004, 130, '2014-03-01 00:29:08.000000', 'consum', 0.0225, 'lps'),
	(566005, 130, '2014-03-01 00:29:09.000000', 'consum', 0.0223, 'lps'),
	(566006, 130, '2014-03-01 00:29:10.000000', 'consum', 0.0211, 'lps'),
	(566007, 130, '2014-03-01 00:29:11.000000', 'consum', 0.0214, 'lps'),
	(566008, 130, '2014-03-01 00:29:12.000000', 'consum', 0.0227, 'lps'),
	(566009, 130, '2014-03-01 00:29:13.000000', 'consum', 0.0227, 'lps'),
	(566010, 130, '2014-03-01 00:29:14.000000', 'consum', 0.0226, 'lps'),
	(566011, 130, '2014-03-01 00:29:15.000000', 'consum', 0.0221, 'lps'),
	(566012, 130, '2014-03-01 00:29:16.000000', 'consum', 0.0216, 'lps'),
	(566013, 130, '2014-03-01 00:29:17.000000', 'consum', 0.0210, 'lps'),
	(566014, 130, '2014-03-01 00:29:18.000000', 'consum', 0.0211, 'lps'),
	(566015, 130, '2014-03-01 00:29:19.000000', 'consum', 0.0215, 'lps'),
	(566016, 130, '2014-03-01 00:29:20.000000', 'consum', 0.0214, 'lps'),
	(566017, 130, '2014-03-01 00:29:21.000000', 'consum', 0.0215, 'lps'),
	(566018, 130, '2014-03-01 00:29:22.000000', 'consum', 0.0225, 'lps'),
	(566019, 130, '2014-03-01 00:29:23.000000', 'consum', 0.0213, 'lps'),
	(566020, 130, '2014-03-01 00:29:24.000000', 'consum', 0.0216, 'lps'),
	(566021, 130, '2014-03-01 00:29:25.000000', 'consum', 0.0216, 'lps'),
	(566022, 130, '2014-03-01 00:29:26.000000', 'consum', 0.0219, 'lps'),
	(566023, 130, '2014-03-01 00:29:27.000000', 'consum', 0.0221, 'lps'),
	(566024, 130, '2014-03-01 00:29:28.000000', 'consum', 0.0219, 'lps'),
	(566025, 130, '2014-03-01 00:29:29.000000', 'consum', 0.0220, 'lps'),
	(566026, 130, '2014-03-01 00:29:30.000000', 'consum', 0.0217, 'lps'),
	(566027, 130, '2014-03-01 00:29:31.000000', 'consum', 0.0216, 'lps'),
	(566028, 130, '2014-03-01 00:29:32.000000', 'consum', 0.0220, 'lps'),
	(566029, 130, '2014-03-01 00:29:33.000000', 'consum', 0.0225, 'lps'),
	(566030, 130, '2014-03-01 00:29:34.000000', 'consum', 0.0214, 'lps'),
	(566031, 130, '2014-03-01 00:29:35.000000', 'consum', 0.0226, 'lps'),
	(566032, 130, '2014-03-01 00:29:36.000000', 'consum', 0.0222, 'lps'),
	(566033, 130, '2014-03-01 00:29:37.000000', 'consum', 0.0223, 'lps'),
	(566034, 130, '2014-03-01 00:29:38.000000', 'consum', 0.0217, 'lps'),
	(566035, 130, '2014-03-01 00:29:39.000000', 'consum', 0.0210, 'lps'),
	(566036, 130, '2014-03-01 00:29:40.000000', 'consum', 0.0227, 'lps'),
	(566037, 130, '2014-03-01 00:29:41.000000', 'consum', 0.0220, 'lps'),
	(566038, 130, '2014-03-01 00:29:42.000000', 'consum', 0.0227, 'lps'),
	(566039, 130, '2014-03-01 00:29:43.000000', 'consum', 0.0228, 'lps'),
	(566040, 130, '2014-03-01 00:29:44.000000', 'consum', 0.0211, 'lps'),
	(566041, 130, '2014-03-01 00:29:45.000000', 'consum', 0.0220, 'lps'),
	(566042, 130, '2014-03-01 00:29:46.000000', 'consum', 0.0217, 'lps'),
	(566043, 130, '2014-03-01 00:29:47.000000', 'consum', 0.0215, 'lps'),
	(566044, 130, '2014-03-01 00:29:48.000000', 'consum', 0.0217, 'lps'),
	(566045, 130, '2014-03-01 00:29:49.000000', 'consum', 0.0212, 'lps'),
	(566046, 130, '2014-03-01 00:29:50.000000', 'consum', 0.0217, 'lps'),
	(566047, 130, '2014-03-01 00:29:51.000000', 'consum', 0.0222, 'lps'),
	(566048, 130, '2014-03-01 00:29:52.000000', 'consum', 0.0210, 'lps'),
	(566049, 130, '2014-03-01 00:29:53.000000', 'consum', 0.0213, 'lps'),
	(566050, 130, '2014-03-01 00:29:54.000000', 'consum', 0.0227, 'lps'),
	(566051, 130, '2014-03-01 00:29:55.000000', 'consum', 0.0228, 'lps'),
	(566052, 130, '2014-03-01 00:29:56.000000', 'consum', 0.0212, 'lps'),
	(566053, 130, '2014-03-01 00:29:57.000000', 'consum', 0.0223, 'lps'),
	(566054, 130, '2014-03-01 00:29:58.000000', 'consum', 0.0211, 'lps'),
	(566055, 130, '2014-03-01 00:29:59.000000', 'consum', 0.0216, 'lps'),
	(566056, 130, '2014-03-01 00:30:00.000000', 'consum', 0.0219, 'lps'),
	(566057, 130, '2014-03-01 00:30:01.000000', 'consum', 0.0217, 'lps'),
	(566058, 130, '2014-03-01 00:30:02.000000', 'consum', 0.0219, 'lps'),
	(566059, 130, '2014-03-01 00:30:03.000000', 'consum', 0.0216, 'lps'),
	(566060, 130, '2014-03-01 00:30:04.000000', 'consum', 0.0215, 'lps'),
	(566061, 130, '2014-03-01 00:30:05.000000', 'consum', 0.0217, 'lps'),
	(566062, 130, '2014-03-01 00:30:06.000000', 'consum', 0.0211, 'lps'),
	(566063, 130, '2014-03-01 00:30:07.000000', 'consum', 0.0213, 'lps'),
	(566064, 130, '2014-03-01 00:30:08.000000', 'consum', 0.0221, 'lps'),
	(566065, 130, '2014-03-01 00:30:09.000000', 'consum', 0.0221, 'lps'),
	(566066, 130, '2014-03-01 00:30:10.000000', 'consum', 0.0213, 'lps'),
	(566067, 130, '2014-03-01 00:30:11.000000', 'consum', 0.0212, 'lps'),
	(566068, 130, '2014-03-01 00:30:12.000000', 'consum', 0.0212, 'lps'),
	(566069, 130, '2014-03-01 00:30:13.000000', 'consum', 0.0215, 'lps'),
	(566070, 130, '2014-03-01 00:30:14.000000', 'consum', 0.0227, 'lps'),
	(566071, 130, '2014-03-01 00:30:15.000000', 'consum', 0.0225, 'lps'),
	(566072, 130, '2014-03-01 00:30:16.000000', 'consum', 0.0214, 'lps'),
	(566073, 130, '2014-03-01 00:30:17.000000', 'consum', 0.0224, 'lps'),
	(566074, 130, '2014-03-01 00:30:18.000000', 'consum', 0.0211, 'lps'),
	(566075, 130, '2014-03-01 00:30:19.000000', 'consum', 0.0211, 'lps'),
	(566076, 130, '2014-03-01 00:30:20.000000', 'consum', 0.0215, 'lps'),
	(566077, 130, '2014-03-01 00:30:21.000000', 'consum', 0.0213, 'lps'),
	(566078, 130, '2014-03-01 00:30:22.000000', 'consum', 0.0227, 'lps'),
	(566079, 130, '2014-03-01 00:30:23.000000', 'consum', 0.0212, 'lps'),
	(566080, 130, '2014-03-01 00:30:24.000000', 'consum', 0.0228, 'lps'),
	(566081, 130, '2014-03-01 00:30:25.000000', 'consum', 0.0219, 'lps'),
	(566082, 130, '2014-03-01 00:30:26.000000', 'consum', 0.0220, 'lps'),
	(566083, 130, '2014-03-01 00:30:27.000000', 'consum', 0.0213, 'lps'),
	(566084, 130, '2014-03-01 00:30:28.000000', 'consum', 0.0215, 'lps'),
	(566085, 130, '2014-03-01 00:30:29.000000', 'consum', 0.0228, 'lps'),
	(566086, 130, '2014-03-01 00:30:30.000000', 'consum', 0.0228, 'lps'),
	(566087, 130, '2014-03-01 00:30:31.000000', 'consum', 0.0210, 'lps'),
	(566088, 130, '2014-03-01 00:30:32.000000', 'consum', 0.0210, 'lps'),
	(566089, 130, '2014-03-01 00:30:33.000000', 'consum', 0.0214, 'lps'),
	(566090, 130, '2014-03-01 00:30:34.000000', 'consum', 0.0210, 'lps'),
	(566091, 130, '2014-03-01 00:30:35.000000', 'consum', 0.0218, 'lps'),
	(566092, 130, '2014-03-01 00:30:36.000000', 'consum', 0.0211, 'lps'),
	(566093, 130, '2014-03-01 00:30:37.000000', 'consum', 0.0211, 'lps'),
	(566094, 130, '2014-03-01 00:30:38.000000', 'consum', 0.0211, 'lps'),
	(566095, 130, '2014-03-01 00:30:39.000000', 'consum', 0.0213, 'lps'),
	(566096, 130, '2014-03-01 00:30:40.000000', 'consum', 0.0222, 'lps'),
	(566097, 130, '2014-03-01 00:30:41.000000', 'consum', 0.0226, 'lps'),
	(566098, 130, '2014-03-01 00:30:42.000000', 'consum', 0.0216, 'lps'),
	(566099, 130, '2014-03-01 00:30:43.000000', 'consum', 0.0213, 'lps'),
	(566100, 130, '2014-03-01 00:30:44.000000', 'consum', 0.0226, 'lps'),
	(566101, 130, '2014-03-01 00:30:45.000000', 'consum', 0.0222, 'lps'),
	(566102, 130, '2014-03-01 00:30:46.000000', 'consum', 0.0224, 'lps'),
	(566103, 130, '2014-03-01 00:30:47.000000', 'consum', 0.0224, 'lps'),
	(566104, 130, '2014-03-01 00:30:48.000000', 'consum', 0.0219, 'lps'),
	(566105, 130, '2014-03-01 00:30:49.000000', 'consum', 0.0214, 'lps'),
	(566106, 130, '2014-03-01 00:30:50.000000', 'consum', 0.0224, 'lps'),
	(566107, 130, '2014-03-01 00:30:51.000000', 'consum', 0.0213, 'lps'),
	(566108, 130, '2014-03-01 00:30:52.000000', 'consum', 0.0219, 'lps'),
	(566109, 130, '2014-03-01 00:30:53.000000', 'consum', 0.0210, 'lps'),
	(566110, 130, '2014-03-01 00:30:54.000000', 'consum', 0.0219, 'lps'),
	(566111, 130, '2014-03-01 00:30:55.000000', 'consum', 0.0219, 'lps'),
	(566112, 130, '2014-03-01 00:30:56.000000', 'consum', 0.0227, 'lps'),
	(566113, 130, '2014-03-01 00:30:57.000000', 'consum', 0.0213, 'lps'),
	(566114, 130, '2014-03-01 00:30:58.000000', 'consum', 0.0211, 'lps'),
	(566115, 130, '2014-03-01 00:30:59.000000', 'consum', 0.0226, 'lps'),
	(566116, 130, '2014-03-01 00:31:00.000000', 'consum', 0.0211, 'lps'),
	(566117, 130, '2014-03-01 00:31:01.000000', 'consum', 0.0224, 'lps'),
	(566118, 130, '2014-03-01 00:31:02.000000', 'consum', 0.0223, 'lps'),
	(566119, 130, '2014-03-01 00:31:03.000000', 'consum', 0.0212, 'lps'),
	(566120, 130, '2014-03-01 00:31:04.000000', 'consum', 0.0220, 'lps'),
	(566121, 130, '2014-03-01 00:31:05.000000', 'consum', 0.0215, 'lps'),
	(566122, 130, '2014-03-01 00:31:06.000000', 'consum', 0.0228, 'lps'),
	(566123, 130, '2014-03-01 00:31:07.000000', 'consum', 0.0226, 'lps'),
	(566124, 130, '2014-03-01 00:31:08.000000', 'consum', 0.0218, 'lps'),
	(566125, 130, '2014-03-01 00:31:09.000000', 'consum', 0.0220, 'lps'),
	(566126, 130, '2014-03-01 00:31:10.000000', 'consum', 0.0218, 'lps'),
	(566127, 130, '2014-03-01 00:31:11.000000', 'consum', 0.0221, 'lps'),
	(566128, 130, '2014-03-01 00:31:12.000000', 'consum', 0.0223, 'lps'),
	(566129, 130, '2014-03-01 00:31:13.000000', 'consum', 0.0225, 'lps'),
	(566130, 130, '2014-03-01 00:31:14.000000', 'consum', 0.0225, 'lps'),
	(566131, 130, '2014-03-01 00:31:15.000000', 'consum', 0.0223, 'lps'),
	(566132, 130, '2014-03-01 00:31:16.000000', 'consum', 0.0211, 'lps'),
	(566133, 130, '2014-03-01 00:31:17.000000', 'consum', 0.0215, 'lps'),
	(566134, 130, '2014-03-01 00:31:18.000000', 'consum', 0.0214, 'lps'),
	(566135, 130, '2014-03-01 00:31:19.000000', 'consum', 0.0215, 'lps'),
	(566136, 130, '2014-03-01 00:31:20.000000', 'consum', 0.0224, 'lps'),
	(566137, 130, '2014-03-01 00:31:21.000000', 'consum', 0.0228, 'lps'),
	(566138, 130, '2014-03-01 00:31:22.000000', 'consum', 0.0220, 'lps'),
	(566139, 130, '2014-03-01 00:31:23.000000', 'consum', 0.0224, 'lps'),
	(566140, 130, '2014-03-01 00:31:24.000000', 'consum', 0.0214, 'lps'),
	(566141, 130, '2014-03-01 00:31:25.000000', 'consum', 0.0225, 'lps'),
	(566142, 130, '2014-03-01 00:31:26.000000', 'consum', 0.0217, 'lps'),
	(566143, 130, '2014-03-01 00:31:27.000000', 'consum', 0.0221, 'lps'),
	(566144, 130, '2014-03-01 00:31:28.000000', 'consum', 0.0226, 'lps'),
	(566145, 130, '2014-03-01 00:31:29.000000', 'consum', 0.0216, 'lps'),
	(566146, 130, '2014-03-01 00:31:30.000000', 'consum', 0.0215, 'lps'),
	(566147, 130, '2014-03-01 00:31:31.000000', 'consum', 0.0217, 'lps'),
	(566148, 130, '2014-03-01 00:31:32.000000', 'consum', 0.0213, 'lps'),
	(566149, 130, '2014-03-01 00:31:33.000000', 'consum', 0.0221, 'lps'),
	(566150, 130, '2014-03-01 00:31:34.000000', 'consum', 0.0220, 'lps'),
	(566151, 130, '2014-03-01 00:31:35.000000', 'consum', 0.0210, 'lps'),
	(566152, 130, '2014-03-01 00:31:36.000000', 'consum', 0.0217, 'lps'),
	(566153, 130, '2014-03-01 00:31:37.000000', 'consum', 0.0227, 'lps'),
	(566154, 130, '2014-03-01 00:31:38.000000', 'consum', 0.0219, 'lps'),
	(566155, 130, '2014-03-01 00:31:39.000000', 'consum', 0.0221, 'lps'),
	(566156, 130, '2014-03-01 00:31:40.000000', 'consum', 0.0219, 'lps'),
	(566157, 130, '2014-03-01 00:31:41.000000', 'consum', 0.0223, 'lps'),
	(566158, 130, '2014-03-01 00:31:42.000000', 'consum', 0.0213, 'lps'),
	(566159, 130, '2014-03-01 00:31:43.000000', 'consum', 0.0221, 'lps'),
	(566160, 130, '2014-03-01 00:31:44.000000', 'consum', 0.0222, 'lps'),
	(566161, 130, '2014-03-01 00:31:45.000000', 'consum', 0.0217, 'lps'),
	(566162, 130, '2014-03-01 00:31:46.000000', 'consum', 0.0228, 'lps'),
	(566163, 130, '2014-03-01 00:31:47.000000', 'consum', 0.0224, 'lps'),
	(566164, 130, '2014-03-01 00:31:48.000000', 'consum', 0.0225, 'lps'),
	(566165, 130, '2014-03-01 00:31:49.000000', 'consum', 0.0223, 'lps'),
	(566166, 130, '2014-03-01 00:31:50.000000', 'consum', 0.0213, 'lps'),
	(566167, 130, '2014-03-01 00:31:51.000000', 'consum', 0.0224, 'lps'),
	(566168, 130, '2014-03-01 00:31:52.000000', 'consum', 0.0213, 'lps'),
	(566169, 130, '2014-03-01 00:31:53.000000', 'consum', 0.0223, 'lps'),
	(566170, 130, '2014-03-01 00:31:54.000000', 'consum', 0.0228, 'lps'),
	(566171, 130, '2014-03-01 00:31:55.000000', 'consum', 0.0224, 'lps'),
	(566172, 130, '2014-03-01 00:31:56.000000', 'consum', 0.0228, 'lps'),
	(566173, 130, '2014-03-01 00:31:57.000000', 'consum', 0.0221, 'lps'),
	(566174, 130, '2014-03-01 00:31:58.000000', 'consum', 0.0211, 'lps'),
	(566175, 130, '2014-03-01 00:31:59.000000', 'consum', 0.0220, 'lps'),
	(566176, 130, '2014-03-01 00:32:00.000000', 'consum', 0.0219, 'lps'),
	(566177, 130, '2014-03-01 00:32:01.000000', 'consum', 0.0225, 'lps'),
	(566178, 130, '2014-03-01 00:32:02.000000', 'consum', 0.0220, 'lps'),
	(566179, 130, '2014-03-01 00:32:03.000000', 'consum', 0.0215, 'lps'),
	(566180, 130, '2014-03-01 00:32:04.000000', 'consum', 0.0226, 'lps'),
	(566181, 130, '2014-03-01 00:32:05.000000', 'consum', 0.0219, 'lps'),
	(566182, 130, '2014-03-01 00:32:06.000000', 'consum', 0.0225, 'lps'),
	(566183, 130, '2014-03-01 00:32:07.000000', 'consum', 0.0222, 'lps'),
	(566184, 130, '2014-03-01 00:32:08.000000', 'consum', 0.0223, 'lps'),
	(566185, 130, '2014-03-01 00:32:09.000000', 'consum', 0.0222, 'lps'),
	(566186, 130, '2014-03-01 00:32:10.000000', 'consum', 0.0211, 'lps'),
	(566187, 130, '2014-03-01 00:32:11.000000', 'consum', 0.0220, 'lps'),
	(566188, 130, '2014-03-01 00:32:12.000000', 'consum', 0.0219, 'lps'),
	(566189, 130, '2014-03-01 00:32:13.000000', 'consum', 0.0224, 'lps'),
	(566190, 130, '2014-03-01 00:32:14.000000', 'consum', 0.0218, 'lps'),
	(566191, 130, '2014-03-01 00:32:15.000000', 'consum', 0.0224, 'lps'),
	(566192, 130, '2014-03-01 00:32:16.000000', 'consum', 0.0221, 'lps'),
	(566193, 130, '2014-03-01 00:32:17.000000', 'consum', 0.0224, 'lps'),
	(566194, 130, '2014-03-01 00:32:18.000000', 'consum', 0.0227, 'lps'),
	(566195, 130, '2014-03-01 00:32:19.000000', 'consum', 0.0216, 'lps'),
	(566196, 130, '2014-03-01 00:32:20.000000', 'consum', 0.0226, 'lps'),
	(566197, 130, '2014-03-01 00:32:21.000000', 'consum', 0.0218, 'lps'),
	(566198, 130, '2014-03-01 00:32:22.000000', 'consum', 0.0222, 'lps'),
	(566199, 130, '2014-03-01 00:32:23.000000', 'consum', 0.0226, 'lps'),
	(566200, 130, '2014-03-01 00:32:24.000000', 'consum', 0.0216, 'lps'),
	(566201, 130, '2014-03-01 00:32:25.000000', 'consum', 0.0213, 'lps'),
	(566202, 130, '2014-03-01 00:32:26.000000', 'consum', 0.0224, 'lps'),
	(566203, 130, '2014-03-01 00:32:27.000000', 'consum', 0.0215, 'lps'),
	(566204, 130, '2014-03-01 00:32:28.000000', 'consum', 0.0212, 'lps'),
	(566205, 130, '2014-03-01 00:32:29.000000', 'consum', 0.0224, 'lps'),
	(566206, 130, '2014-03-01 00:32:30.000000', 'consum', 0.0218, 'lps'),
	(566207, 130, '2014-03-01 00:32:31.000000', 'consum', 0.0226, 'lps'),
	(566208, 130, '2014-03-01 00:32:32.000000', 'consum', 0.0210, 'lps'),
	(566209, 130, '2014-03-01 00:32:33.000000', 'consum', 0.0220, 'lps'),
	(566210, 130, '2014-03-01 00:32:34.000000', 'consum', 0.0221, 'lps'),
	(566211, 130, '2014-03-01 00:32:35.000000', 'consum', 0.0218, 'lps'),
	(566212, 130, '2014-03-01 00:32:36.000000', 'consum', 0.0215, 'lps'),
	(566213, 130, '2014-03-01 00:32:37.000000', 'consum', 0.0214, 'lps'),
	(566214, 130, '2014-03-01 00:32:38.000000', 'consum', 0.0215, 'lps'),
	(566215, 130, '2014-03-01 00:32:39.000000', 'consum', 0.0225, 'lps'),
	(566216, 130, '2014-03-01 00:32:40.000000', 'consum', 0.0212, 'lps'),
	(566217, 130, '2014-03-01 00:32:41.000000', 'consum', 0.0215, 'lps'),
	(566218, 130, '2014-03-01 00:32:42.000000', 'consum', 0.0210, 'lps'),
	(566219, 130, '2014-03-01 00:32:43.000000', 'consum', 0.0216, 'lps'),
	(566220, 130, '2014-03-01 00:32:44.000000', 'consum', 0.0218, 'lps'),
	(566221, 130, '2014-03-01 00:32:45.000000', 'consum', 0.0216, 'lps'),
	(566222, 130, '2014-03-01 00:32:46.000000', 'consum', 0.0216, 'lps'),
	(566223, 130, '2014-03-01 00:32:47.000000', 'consum', 0.0223, 'lps'),
	(566224, 130, '2014-03-01 00:32:48.000000', 'consum', 0.0219, 'lps'),
	(566225, 130, '2014-03-01 00:32:49.000000', 'consum', 0.0217, 'lps'),
	(566226, 130, '2014-03-01 00:32:50.000000', 'consum', 0.0216, 'lps'),
	(566227, 130, '2014-03-01 00:32:51.000000', 'consum', 0.0223, 'lps'),
	(566228, 130, '2014-03-01 00:32:52.000000', 'consum', 0.0217, 'lps'),
	(566229, 130, '2014-03-01 00:32:53.000000', 'consum', 0.0224, 'lps'),
	(566230, 130, '2014-03-01 00:32:54.000000', 'consum', 0.0224, 'lps'),
	(566231, 130, '2014-03-01 00:32:55.000000', 'consum', 0.0220, 'lps'),
	(566232, 130, '2014-03-01 00:32:56.000000', 'consum', 0.0219, 'lps'),
	(566233, 130, '2014-03-01 00:32:57.000000', 'consum', 0.0226, 'lps'),
	(566234, 130, '2014-03-01 00:32:58.000000', 'consum', 0.0225, 'lps'),
	(566235, 130, '2014-03-01 00:32:59.000000', 'consum', 0.0217, 'lps'),
	(566236, 130, '2014-03-01 00:33:00.000000', 'consum', 0.0221, 'lps'),
	(566237, 130, '2014-03-01 00:33:01.000000', 'consum', 0.0225, 'lps'),
	(566238, 130, '2014-03-01 00:33:02.000000', 'consum', 0.0216, 'lps'),
	(566239, 130, '2014-03-01 00:33:03.000000', 'consum', 0.0215, 'lps'),
	(566240, 130, '2014-03-01 00:33:04.000000', 'consum', 0.0217, 'lps'),
	(566241, 130, '2014-03-01 00:33:05.000000', 'consum', 0.0228, 'lps'),
	(566242, 130, '2014-03-01 00:33:06.000000', 'consum', 0.0224, 'lps'),
	(566243, 130, '2014-03-01 00:33:07.000000', 'consum', 0.0227, 'lps'),
	(566244, 130, '2014-03-01 00:33:08.000000', 'consum', 0.0216, 'lps'),
	(566245, 130, '2014-03-01 00:33:09.000000', 'consum', 0.0226, 'lps'),
	(566246, 130, '2014-03-01 00:33:10.000000', 'consum', 0.0217, 'lps'),
	(566247, 130, '2014-03-01 00:33:11.000000', 'consum', 0.0216, 'lps'),
	(566248, 130, '2014-03-01 00:33:12.000000', 'consum', 0.0222, 'lps'),
	(566249, 130, '2014-03-01 00:33:13.000000', 'consum', 0.0211, 'lps'),
	(566250, 130, '2014-03-01 00:33:14.000000', 'consum', 0.0218, 'lps'),
	(566251, 130, '2014-03-01 00:33:15.000000', 'consum', 0.0210, 'lps'),
	(566252, 130, '2014-03-01 00:33:16.000000', 'consum', 0.0226, 'lps'),
	(566253, 130, '2014-03-01 00:33:17.000000', 'consum', 0.0213, 'lps'),
	(566254, 130, '2014-03-01 00:33:18.000000', 'consum', 0.0215, 'lps'),
	(566255, 130, '2014-03-01 00:33:19.000000', 'consum', 0.0227, 'lps'),
	(566256, 130, '2014-03-01 00:33:20.000000', 'consum', 0.0223, 'lps'),
	(566257, 130, '2014-03-01 00:33:21.000000', 'consum', 0.0226, 'lps'),
	(566258, 130, '2014-03-01 00:33:22.000000', 'consum', 0.0212, 'lps'),
	(566259, 130, '2014-03-01 00:33:23.000000', 'consum', 0.0213, 'lps'),
	(566260, 130, '2014-03-01 00:33:24.000000', 'consum', 0.0219, 'lps'),
	(566261, 130, '2014-03-01 00:33:25.000000', 'consum', 0.0225, 'lps'),
	(566262, 130, '2014-03-01 00:33:26.000000', 'consum', 0.0222, 'lps'),
	(566263, 130, '2014-03-01 00:33:27.000000', 'consum', 0.0226, 'lps'),
	(566264, 130, '2014-03-01 00:33:28.000000', 'consum', 0.0218, 'lps'),
	(566265, 130, '2014-03-01 00:33:29.000000', 'consum', 0.0219, 'lps'),
	(566266, 130, '2014-03-01 00:33:30.000000', 'consum', 0.0213, 'lps'),
	(566267, 130, '2014-03-01 00:33:31.000000', 'consum', 0.0216, 'lps'),
	(566268, 130, '2014-03-01 00:33:32.000000', 'consum', 0.0215, 'lps'),
	(566269, 130, '2014-03-01 00:33:33.000000', 'consum', 0.0219, 'lps'),
	(566270, 130, '2014-03-01 00:33:34.000000', 'consum', 0.0218, 'lps'),
	(566271, 130, '2014-03-01 00:33:35.000000', 'consum', 0.0224, 'lps'),
	(566272, 130, '2014-03-01 00:33:36.000000', 'consum', 0.0220, 'lps'),
	(566273, 130, '2014-03-01 00:33:37.000000', 'consum', 0.0218, 'lps'),
	(566274, 130, '2014-03-01 00:33:38.000000', 'consum', 0.0220, 'lps'),
	(566275, 130, '2014-03-01 00:33:39.000000', 'consum', 0.0218, 'lps'),
	(566276, 130, '2014-03-01 00:33:40.000000', 'consum', 0.0222, 'lps'),
	(566277, 130, '2014-03-01 00:33:41.000000', 'consum', 0.0227, 'lps'),
	(566278, 130, '2014-03-01 00:33:42.000000', 'consum', 0.0221, 'lps'),
	(566279, 130, '2014-03-01 00:33:43.000000', 'consum', 0.0213, 'lps'),
	(566280, 130, '2014-03-01 00:33:44.000000', 'consum', 0.0211, 'lps'),
	(566281, 130, '2014-03-01 00:33:45.000000', 'consum', 0.0226, 'lps'),
	(566282, 130, '2014-03-01 00:33:46.000000', 'consum', 0.0211, 'lps'),
	(566283, 130, '2014-03-01 00:33:47.000000', 'consum', 0.0227, 'lps'),
	(566284, 130, '2014-03-01 00:33:48.000000', 'consum', 0.0216, 'lps'),
	(566285, 130, '2014-03-01 00:33:49.000000', 'consum', 0.0228, 'lps'),
	(566286, 130, '2014-03-01 00:33:50.000000', 'consum', 0.0223, 'lps'),
	(566287, 130, '2014-03-01 00:33:51.000000', 'consum', 0.0222, 'lps'),
	(566288, 130, '2014-03-01 00:33:52.000000', 'consum', 0.0215, 'lps'),
	(566289, 130, '2014-03-01 00:33:53.000000', 'consum', 0.0215, 'lps'),
	(566290, 130, '2014-03-01 00:33:54.000000', 'consum', 0.0223, 'lps'),
	(566291, 130, '2014-03-01 00:33:55.000000', 'consum', 0.0223, 'lps'),
	(566292, 130, '2014-03-01 00:33:56.000000', 'consum', 0.0216, 'lps'),
	(566293, 130, '2014-03-01 00:33:57.000000', 'consum', 0.0222, 'lps'),
	(566294, 130, '2014-03-01 00:33:58.000000', 'consum', 0.0212, 'lps'),
	(566295, 130, '2014-03-01 00:33:59.000000', 'consum', 0.0224, 'lps'),
	(566296, 130, '2014-03-01 00:34:00.000000', 'consum', 0.0216, 'lps'),
	(566297, 130, '2014-03-01 00:34:01.000000', 'consum', 0.0217, 'lps'),
	(566298, 130, '2014-03-01 00:34:02.000000', 'consum', 0.0228, 'lps'),
	(566299, 130, '2014-03-01 00:34:03.000000', 'consum', 0.0223, 'lps'),
	(566300, 130, '2014-03-01 00:34:04.000000', 'consum', 0.0221, 'lps'),
	(566301, 130, '2014-03-01 00:34:05.000000', 'consum', 0.0228, 'lps'),
	(566302, 130, '2014-03-01 00:34:06.000000', 'consum', 0.0210, 'lps'),
	(566303, 130, '2014-03-01 00:34:07.000000', 'consum', 0.0213, 'lps'),
	(566304, 130, '2014-03-01 00:34:08.000000', 'consum', 0.0227, 'lps'),
	(566305, 130, '2014-03-01 00:34:09.000000', 'consum', 0.0210, 'lps'),
	(566306, 130, '2014-03-01 00:34:10.000000', 'consum', 0.0214, 'lps'),
	(566307, 130, '2014-03-01 00:34:11.000000', 'consum', 0.0214, 'lps'),
	(566308, 130, '2014-03-01 00:34:12.000000', 'consum', 0.0217, 'lps'),
	(566309, 130, '2014-03-01 00:34:13.000000', 'consum', 0.0213, 'lps'),
	(566310, 130, '2014-03-01 00:34:14.000000', 'consum', 0.0226, 'lps'),
	(566311, 130, '2014-03-01 00:34:15.000000', 'consum', 0.0223, 'lps'),
	(566312, 130, '2014-03-01 00:34:16.000000', 'consum', 0.0211, 'lps'),
	(566313, 130, '2014-03-01 00:34:17.000000', 'consum', 0.0213, 'lps'),
	(566314, 130, '2014-03-01 00:34:18.000000', 'consum', 0.0223, 'lps'),
	(566315, 130, '2014-03-01 00:34:19.000000', 'consum', 0.0210, 'lps'),
	(566316, 130, '2014-03-01 00:34:20.000000', 'consum', 0.0227, 'lps'),
	(566317, 130, '2014-03-01 00:34:21.000000', 'consum', 0.0219, 'lps'),
	(566318, 130, '2014-03-01 00:34:22.000000', 'consum', 0.0225, 'lps'),
	(566319, 130, '2014-03-01 00:34:23.000000', 'consum', 0.0220, 'lps'),
	(566320, 130, '2014-03-01 00:34:24.000000', 'consum', 0.0215, 'lps'),
	(566321, 130, '2014-03-01 00:34:25.000000', 'consum', 0.0226, 'lps'),
	(566322, 130, '2014-03-01 00:34:26.000000', 'consum', 0.0220, 'lps'),
	(566323, 130, '2014-03-01 00:34:27.000000', 'consum', 0.0210, 'lps'),
	(566324, 130, '2014-03-01 00:34:28.000000', 'consum', 0.0218, 'lps'),
	(566325, 130, '2014-03-01 00:34:29.000000', 'consum', 0.0211, 'lps'),
	(566326, 130, '2014-03-01 00:34:30.000000', 'consum', 0.0213, 'lps'),
	(566327, 130, '2014-03-01 00:34:31.000000', 'consum', 0.0224, 'lps'),
	(566328, 130, '2014-03-01 00:34:32.000000', 'consum', 0.0213, 'lps'),
	(566329, 130, '2014-03-01 00:34:33.000000', 'consum', 0.0220, 'lps'),
	(566330, 130, '2014-03-01 00:34:34.000000', 'consum', 0.0215, 'lps'),
	(566331, 130, '2014-03-01 00:34:35.000000', 'consum', 0.0225, 'lps'),
	(566332, 130, '2014-03-01 00:34:36.000000', 'consum', 0.0215, 'lps'),
	(566333, 130, '2014-03-01 00:34:37.000000', 'consum', 0.0227, 'lps'),
	(566334, 130, '2014-03-01 00:34:38.000000', 'consum', 0.0222, 'lps'),
	(566335, 130, '2014-03-01 00:34:39.000000', 'consum', 0.0219, 'lps'),
	(566336, 130, '2014-03-01 00:34:40.000000', 'consum', 0.0222, 'lps'),
	(566337, 130, '2014-03-01 00:34:41.000000', 'consum', 0.0222, 'lps'),
	(566338, 130, '2014-03-01 00:34:42.000000', 'consum', 0.0216, 'lps'),
	(566339, 130, '2014-03-01 00:34:43.000000', 'consum', 0.0224, 'lps'),
	(566340, 130, '2014-03-01 00:34:44.000000', 'consum', 0.0226, 'lps'),
	(566341, 130, '2014-03-01 00:34:45.000000', 'consum', 0.0210, 'lps'),
	(566342, 130, '2014-03-01 00:34:46.000000', 'consum', 0.0218, 'lps'),
	(566343, 130, '2014-03-01 00:34:47.000000', 'consum', 0.0213, 'lps'),
	(566344, 130, '2014-03-01 00:34:48.000000', 'consum', 0.0221, 'lps'),
	(566345, 130, '2014-03-01 00:34:49.000000', 'consum', 0.0218, 'lps'),
	(566346, 130, '2014-03-01 00:34:50.000000', 'consum', 0.0218, 'lps'),
	(566347, 130, '2014-03-01 00:34:51.000000', 'consum', 0.0226, 'lps'),
	(566348, 130, '2014-03-01 00:34:52.000000', 'consum', 0.0228, 'lps'),
	(566349, 130, '2014-03-01 00:34:53.000000', 'consum', 0.0214, 'lps'),
	(566350, 130, '2014-03-01 00:34:54.000000', 'consum', 0.0215, 'lps'),
	(566351, 130, '2014-03-01 00:34:55.000000', 'consum', 0.0223, 'lps'),
	(566352, 130, '2014-03-01 00:34:56.000000', 'consum', 0.0223, 'lps'),
	(566353, 130, '2014-03-01 00:34:57.000000', 'consum', 0.0217, 'lps'),
	(566354, 130, '2014-03-01 00:34:58.000000', 'consum', 0.0227, 'lps'),
	(566355, 130, '2014-03-01 00:34:59.000000', 'consum', 0.0215, 'lps'),
	(566356, 130, '2014-03-01 00:35:00.000000', 'consum', 0.0223, 'lps'),
	(566357, 130, '2014-03-01 00:35:01.000000', 'consum', 0.0223, 'lps'),
	(566358, 130, '2014-03-01 00:35:02.000000', 'consum', 0.0217, 'lps'),
	(566359, 130, '2014-03-01 00:35:03.000000', 'consum', 0.0227, 'lps'),
	(566360, 130, '2014-03-01 00:35:04.000000', 'consum', 0.0215, 'lps'),
	(566361, 130, '2014-03-01 00:35:05.000000', 'consum', 0.0223, 'lps'),
	(566362, 130, '2014-03-01 00:35:06.000000', 'consum', 0.0222, 'lps'),
	(566363, 130, '2014-03-01 00:35:07.000000', 'consum', 0.0214, 'lps'),
	(566364, 130, '2014-03-01 00:35:08.000000', 'consum', 0.0215, 'lps'),
	(566365, 130, '2014-03-01 00:35:09.000000', 'consum', 0.0222, 'lps'),
	(566366, 130, '2014-03-01 00:35:10.000000', 'consum', 0.0218, 'lps'),
	(566367, 130, '2014-03-01 00:35:11.000000', 'consum', 0.0213, 'lps'),
	(566368, 130, '2014-03-01 00:35:12.000000', 'consum', 0.0219, 'lps'),
	(566369, 130, '2014-03-01 00:35:13.000000', 'consum', 0.0212, 'lps'),
	(566370, 130, '2014-03-01 00:35:14.000000', 'consum', 0.0212, 'lps'),
	(566371, 130, '2014-03-01 00:35:15.000000', 'consum', 0.0213, 'lps'),
	(566372, 130, '2014-03-01 00:35:16.000000', 'consum', 0.0221, 'lps'),
	(566373, 130, '2014-03-01 00:35:17.000000', 'consum', 0.0217, 'lps'),
	(566374, 130, '2014-03-01 00:35:18.000000', 'consum', 0.0214, 'lps'),
	(566375, 130, '2014-03-01 00:35:19.000000', 'consum', 0.0210, 'lps'),
	(566376, 130, '2014-03-01 00:35:20.000000', 'consum', 0.0219, 'lps'),
	(566377, 130, '2014-03-01 00:35:21.000000', 'consum', 0.0215, 'lps'),
	(566378, 130, '2014-03-01 00:35:22.000000', 'consum', 0.0227, 'lps'),
	(566379, 130, '2014-03-01 00:35:23.000000', 'consum', 0.0226, 'lps'),
	(566380, 130, '2014-03-01 00:35:24.000000', 'consum', 0.0221, 'lps'),
	(566381, 130, '2014-03-01 00:35:25.000000', 'consum', 0.0216, 'lps'),
	(566382, 130, '2014-03-01 00:35:26.000000', 'consum', 0.0225, 'lps'),
	(566383, 130, '2014-03-01 00:35:27.000000', 'consum', 0.0212, 'lps'),
	(566384, 130, '2014-03-01 00:35:28.000000', 'consum', 0.0214, 'lps'),
	(566385, 130, '2014-03-01 00:35:29.000000', 'consum', 0.0223, 'lps'),
	(566386, 130, '2014-03-01 00:35:30.000000', 'consum', 0.0227, 'lps'),
	(566387, 130, '2014-03-01 00:35:31.000000', 'consum', 0.0218, 'lps'),
	(566388, 130, '2014-03-01 00:35:32.000000', 'consum', 0.0218, 'lps'),
	(566389, 130, '2014-03-01 00:35:33.000000', 'consum', 0.0227, 'lps'),
	(566390, 130, '2014-03-01 00:35:34.000000', 'consum', 0.0213, 'lps'),
	(566391, 130, '2014-03-01 00:35:35.000000', 'consum', 0.0211, 'lps'),
	(566392, 130, '2014-03-01 00:35:36.000000', 'consum', 0.0210, 'lps'),
	(566393, 130, '2014-03-01 00:35:37.000000', 'consum', 0.0225, 'lps'),
	(566394, 130, '2014-03-01 00:35:38.000000', 'consum', 0.0212, 'lps'),
	(566395, 130, '2014-03-01 00:35:39.000000', 'consum', 0.0211, 'lps'),
	(566396, 130, '2014-03-01 00:35:40.000000', 'consum', 0.0228, 'lps'),
	(566397, 130, '2014-03-01 00:35:41.000000', 'consum', 0.0222, 'lps'),
	(566398, 130, '2014-03-01 00:35:42.000000', 'consum', 0.0217, 'lps'),
	(566399, 130, '2014-03-01 00:35:43.000000', 'consum', 0.0211, 'lps'),
	(566400, 130, '2014-03-01 00:35:44.000000', 'consum', 0.0213, 'lps'),
	(566401, 130, '2014-03-01 00:35:45.000000', 'consum', 0.0220, 'lps'),
	(566402, 130, '2014-03-01 00:35:46.000000', 'consum', 0.0216, 'lps'),
	(566403, 130, '2014-03-01 00:35:47.000000', 'consum', 0.0211, 'lps'),
	(566404, 130, '2014-03-01 00:35:48.000000', 'consum', 0.0215, 'lps'),
	(566405, 130, '2014-03-01 00:35:49.000000', 'consum', 0.0216, 'lps'),
	(566406, 130, '2014-03-01 00:35:50.000000', 'consum', 0.0224, 'lps'),
	(566407, 130, '2014-03-01 00:35:51.000000', 'consum', 0.0223, 'lps'),
	(566408, 130, '2014-03-01 00:35:52.000000', 'consum', 0.0214, 'lps'),
	(566409, 130, '2014-03-01 00:35:53.000000', 'consum', 0.0212, 'lps'),
	(566410, 130, '2014-03-01 00:35:54.000000', 'consum', 0.0227, 'lps'),
	(566411, 130, '2014-03-01 00:35:55.000000', 'consum', 0.0212, 'lps'),
	(566412, 130, '2014-03-01 00:35:56.000000', 'consum', 0.0211, 'lps'),
	(566413, 130, '2014-03-01 00:35:57.000000', 'consum', 0.0225, 'lps'),
	(566414, 130, '2014-03-01 00:35:58.000000', 'consum', 0.0226, 'lps'),
	(566415, 130, '2014-03-01 00:35:59.000000', 'consum', 0.0226, 'lps'),
	(566416, 130, '2014-03-01 00:36:00.000000', 'consum', 0.0225, 'lps'),
	(566417, 130, '2014-03-01 00:36:01.000000', 'consum', 0.0216, 'lps'),
	(566418, 130, '2014-03-01 00:36:02.000000', 'consum', 0.0215, 'lps'),
	(566419, 130, '2014-03-01 00:36:03.000000', 'consum', 0.0219, 'lps'),
	(566420, 130, '2014-03-01 00:36:04.000000', 'consum', 0.0221, 'lps'),
	(566421, 130, '2014-03-01 00:36:05.000000', 'consum', 0.0221, 'lps'),
	(566422, 130, '2014-03-01 00:36:06.000000', 'consum', 0.0214, 'lps'),
	(566423, 130, '2014-03-01 00:36:07.000000', 'consum', 0.0214, 'lps'),
	(566424, 130, '2014-03-01 00:36:08.000000', 'consum', 0.0220, 'lps'),
	(566425, 130, '2014-03-01 00:36:09.000000', 'consum', 0.0228, 'lps'),
	(566426, 130, '2014-03-01 00:36:10.000000', 'consum', 0.0213, 'lps'),
	(566427, 130, '2014-03-01 00:36:11.000000', 'consum', 0.0210, 'lps'),
	(566428, 130, '2014-03-01 00:36:12.000000', 'consum', 0.0219, 'lps'),
	(566429, 130, '2014-03-01 00:36:13.000000', 'consum', 0.0218, 'lps'),
	(566430, 130, '2014-03-01 00:36:14.000000', 'consum', 0.0226, 'lps'),
	(566431, 130, '2014-03-01 00:36:15.000000', 'consum', 0.0228, 'lps'),
	(566432, 130, '2014-03-01 00:36:16.000000', 'consum', 0.0212, 'lps'),
	(566433, 130, '2014-03-01 00:36:17.000000', 'consum', 0.0225, 'lps'),
	(566434, 130, '2014-03-01 00:36:18.000000', 'consum', 0.0220, 'lps'),
	(566435, 130, '2014-03-01 00:36:19.000000', 'consum', 0.0218, 'lps'),
	(566436, 130, '2014-03-01 00:36:20.000000', 'consum', 0.0221, 'lps'),
	(566437, 130, '2014-03-01 00:36:21.000000', 'consum', 0.0221, 'lps'),
	(566438, 130, '2014-03-01 00:36:22.000000', 'consum', 0.0214, 'lps'),
	(566439, 130, '2014-03-01 00:36:23.000000', 'consum', 0.0218, 'lps'),
	(566440, 130, '2014-03-01 00:36:24.000000', 'consum', 0.0220, 'lps'),
	(566441, 130, '2014-03-01 00:36:25.000000', 'consum', 0.0218, 'lps'),
	(566442, 130, '2014-03-01 00:36:26.000000', 'consum', 0.0219, 'lps'),
	(566443, 130, '2014-03-01 00:36:27.000000', 'consum', 0.0213, 'lps'),
	(566444, 130, '2014-03-01 00:36:28.000000', 'consum', 0.0219, 'lps'),
	(566445, 130, '2014-03-01 00:36:29.000000', 'consum', 0.0228, 'lps'),
	(566446, 130, '2014-03-01 00:36:30.000000', 'consum', 0.0216, 'lps'),
	(566447, 130, '2014-03-01 00:36:31.000000', 'consum', 0.0223, 'lps'),
	(566448, 130, '2014-03-01 00:36:32.000000', 'consum', 0.0221, 'lps'),
	(566449, 130, '2014-03-01 00:36:33.000000', 'consum', 0.0226, 'lps'),
	(566450, 130, '2014-03-01 00:36:34.000000', 'consum', 0.0221, 'lps'),
	(566451, 130, '2014-03-01 00:36:35.000000', 'consum', 0.0217, 'lps'),
	(566452, 130, '2014-03-01 00:36:36.000000', 'consum', 0.0211, 'lps'),
	(566453, 130, '2014-03-01 00:36:37.000000', 'consum', 0.0214, 'lps'),
	(566454, 130, '2014-03-01 00:36:38.000000', 'consum', 0.0226, 'lps'),
	(566455, 130, '2014-03-01 00:36:39.000000', 'consum', 0.0221, 'lps'),
	(566456, 130, '2014-03-01 00:36:40.000000', 'consum', 0.0217, 'lps'),
	(566457, 130, '2014-03-01 00:36:41.000000', 'consum', 0.0215, 'lps'),
	(566458, 130, '2014-03-01 00:36:42.000000', 'consum', 0.0216, 'lps'),
	(566459, 130, '2014-03-01 00:36:43.000000', 'consum', 0.0222, 'lps'),
	(566460, 130, '2014-03-01 00:36:44.000000', 'consum', 0.0217, 'lps'),
	(566461, 130, '2014-03-01 00:36:45.000000', 'consum', 0.0210, 'lps'),
	(566462, 130, '2014-03-01 00:36:46.000000', 'consum', 0.0224, 'lps'),
	(566463, 130, '2014-03-01 00:36:47.000000', 'consum', 0.0227, 'lps'),
	(566464, 130, '2014-03-01 00:36:48.000000', 'consum', 0.0215, 'lps'),
	(566465, 130, '2014-03-01 00:36:49.000000', 'consum', 0.0221, 'lps'),
	(566466, 130, '2014-03-01 00:36:50.000000', 'consum', 0.0212, 'lps'),
	(566467, 130, '2014-03-01 00:36:51.000000', 'consum', 0.0225, 'lps'),
	(566468, 130, '2014-03-01 00:36:52.000000', 'consum', 0.0222, 'lps'),
	(566469, 130, '2014-03-01 00:36:53.000000', 'consum', 0.0224, 'lps'),
	(566470, 130, '2014-03-01 00:36:54.000000', 'consum', 0.0210, 'lps'),
	(566471, 130, '2014-03-01 00:36:55.000000', 'consum', 0.0224, 'lps'),
	(566472, 130, '2014-03-01 00:36:56.000000', 'consum', 0.0225, 'lps'),
	(566473, 130, '2014-03-01 00:36:57.000000', 'consum', 0.0225, 'lps'),
	(566474, 130, '2014-03-01 00:36:58.000000', 'consum', 0.0221, 'lps'),
	(566475, 130, '2014-03-01 00:36:59.000000', 'consum', 0.0221, 'lps'),
	(566476, 130, '2014-03-01 00:37:00.000000', 'consum', 0.0213, 'lps'),
	(566477, 130, '2014-03-01 00:37:01.000000', 'consum', 0.0211, 'lps'),
	(566478, 130, '2014-03-01 00:37:02.000000', 'consum', 0.0227, 'lps'),
	(566479, 130, '2014-03-01 00:37:03.000000', 'consum', 0.0216, 'lps'),
	(566480, 130, '2014-03-01 00:37:04.000000', 'consum', 0.0210, 'lps'),
	(566481, 130, '2014-03-01 00:37:05.000000', 'consum', 0.0211, 'lps'),
	(566482, 130, '2014-03-01 00:37:06.000000', 'consum', 0.0217, 'lps'),
	(566483, 130, '2014-03-01 00:37:07.000000', 'consum', 0.0222, 'lps'),
	(566484, 130, '2014-03-01 00:37:08.000000', 'consum', 0.0212, 'lps'),
	(566485, 130, '2014-03-01 00:37:09.000000', 'consum', 0.0220, 'lps'),
	(566486, 130, '2014-03-01 00:37:10.000000', 'consum', 0.0220, 'lps'),
	(566487, 130, '2014-03-01 00:37:11.000000', 'consum', 0.0210, 'lps'),
	(566488, 130, '2014-03-01 00:37:12.000000', 'consum', 0.0218, 'lps'),
	(566489, 130, '2014-03-01 00:37:13.000000', 'consum', 0.0213, 'lps'),
	(566490, 130, '2014-03-01 00:37:14.000000', 'consum', 0.0222, 'lps'),
	(566491, 130, '2014-03-01 00:37:15.000000', 'consum', 0.0222, 'lps'),
	(566492, 130, '2014-03-01 00:37:16.000000', 'consum', 0.0215, 'lps'),
	(566493, 130, '2014-03-01 00:37:17.000000', 'consum', 0.0220, 'lps'),
	(566494, 130, '2014-03-01 00:37:18.000000', 'consum', 0.0227, 'lps'),
	(566495, 130, '2014-03-01 00:37:19.000000', 'consum', 0.0228, 'lps'),
	(566496, 130, '2014-03-01 00:37:20.000000', 'consum', 0.0211, 'lps'),
	(566497, 130, '2014-03-01 00:37:21.000000', 'consum', 0.0220, 'lps'),
	(566498, 130, '2014-03-01 00:37:22.000000', 'consum', 0.0219, 'lps'),
	(566499, 130, '2014-03-01 00:37:23.000000', 'consum', 0.0224, 'lps'),
	(566500, 130, '2014-03-01 00:37:24.000000', 'consum', 0.0216, 'lps'),
	(566501, 130, '2014-03-01 00:37:25.000000', 'consum', 0.0218, 'lps'),
	(566502, 130, '2014-03-01 00:37:26.000000', 'consum', 0.0215, 'lps'),
	(566503, 130, '2014-03-01 00:37:27.000000', 'consum', 0.0210, 'lps'),
	(566504, 130, '2014-03-01 00:37:28.000000', 'consum', 0.0213, 'lps'),
	(566505, 130, '2014-03-01 00:37:29.000000', 'consum', 0.0228, 'lps'),
	(566506, 130, '2014-03-01 00:37:30.000000', 'consum', 0.0216, 'lps'),
	(566507, 130, '2014-03-01 00:37:31.000000', 'consum', 0.0223, 'lps'),
	(566508, 130, '2014-03-01 00:37:32.000000', 'consum', 0.0219, 'lps'),
	(566509, 130, '2014-03-01 00:37:33.000000', 'consum', 0.0219, 'lps'),
	(566510, 130, '2014-03-01 00:37:34.000000', 'consum', 0.0228, 'lps'),
	(566511, 130, '2014-03-01 00:37:35.000000', 'consum', 0.0214, 'lps'),
	(566512, 130, '2014-03-01 00:37:36.000000', 'consum', 0.0217, 'lps'),
	(566513, 130, '2014-03-01 00:37:37.000000', 'consum', 0.0215, 'lps'),
	(566514, 130, '2014-03-01 00:37:38.000000', 'consum', 0.0213, 'lps'),
	(566515, 130, '2014-03-01 00:37:39.000000', 'consum', 0.0211, 'lps'),
	(566516, 130, '2014-03-01 00:37:40.000000', 'consum', 0.0226, 'lps'),
	(566517, 130, '2014-03-01 00:37:41.000000', 'consum', 0.0213, 'lps'),
	(566518, 130, '2014-03-01 00:37:42.000000', 'consum', 0.0213, 'lps'),
	(566519, 130, '2014-03-01 00:37:43.000000', 'consum', 0.0215, 'lps'),
	(566520, 130, '2014-03-01 00:37:44.000000', 'consum', 0.0211, 'lps'),
	(566521, 130, '2014-03-01 00:37:45.000000', 'consum', 0.0218, 'lps'),
	(566522, 130, '2014-03-01 00:37:46.000000', 'consum', 0.0211, 'lps'),
	(566523, 130, '2014-03-01 00:37:47.000000', 'consum', 0.0211, 'lps'),
	(566524, 130, '2014-03-01 00:37:48.000000', 'consum', 0.0211, 'lps'),
	(566525, 130, '2014-03-01 00:37:49.000000', 'consum', 0.0214, 'lps'),
	(566526, 130, '2014-03-01 00:37:50.000000', 'consum', 0.0225, 'lps'),
	(566527, 130, '2014-03-01 00:37:51.000000', 'consum', 0.0219, 'lps'),
	(566528, 130, '2014-03-01 00:37:52.000000', 'consum', 0.0227, 'lps'),
	(566529, 130, '2014-03-01 00:37:53.000000', 'consum', 0.0211, 'lps'),
	(566530, 130, '2014-03-01 00:37:54.000000', 'consum', 0.0222, 'lps'),
	(566531, 130, '2014-03-01 00:37:55.000000', 'consum', 0.0212, 'lps'),
	(566532, 130, '2014-03-01 00:37:56.000000', 'consum', 0.0223, 'lps'),
	(566533, 130, '2014-03-01 00:37:57.000000', 'consum', 0.0212, 'lps'),
	(566534, 130, '2014-03-01 00:37:58.000000', 'consum', 0.0221, 'lps'),
	(566535, 130, '2014-03-01 00:37:59.000000', 'consum', 0.0219, 'lps'),
	(566536, 130, '2014-03-01 00:38:00.000000', 'consum', 0.0224, 'lps'),
	(566537, 130, '2014-03-01 00:38:01.000000', 'consum', 0.0214, 'lps'),
	(566538, 130, '2014-03-01 00:38:02.000000', 'consum', 0.0226, 'lps'),
	(566539, 130, '2014-03-01 00:38:03.000000', 'consum', 0.0220, 'lps'),
	(566540, 130, '2014-03-01 00:38:04.000000', 'consum', 0.0216, 'lps'),
	(566541, 130, '2014-03-01 00:38:05.000000', 'consum', 0.0228, 'lps'),
	(566542, 130, '2014-03-01 00:38:06.000000', 'consum', 0.0226, 'lps'),
	(566543, 130, '2014-03-01 00:38:07.000000', 'consum', 0.0215, 'lps'),
	(566544, 130, '2014-03-01 00:38:08.000000', 'consum', 0.0228, 'lps'),
	(566545, 130, '2014-03-01 00:38:09.000000', 'consum', 0.0228, 'lps'),
	(566546, 130, '2014-03-01 00:38:10.000000', 'consum', 0.0225, 'lps'),
	(566547, 130, '2014-03-01 00:38:11.000000', 'consum', 0.0216, 'lps'),
	(566548, 130, '2014-03-01 00:38:12.000000', 'consum', 0.0214, 'lps'),
	(566549, 130, '2014-03-01 00:38:13.000000', 'consum', 0.0210, 'lps'),
	(566550, 130, '2014-03-01 00:38:14.000000', 'consum', 0.0220, 'lps'),
	(566551, 130, '2014-03-01 00:38:15.000000', 'consum', 0.0220, 'lps'),
	(566552, 130, '2014-03-01 00:38:16.000000', 'consum', 0.0215, 'lps'),
	(566553, 130, '2014-03-01 00:38:17.000000', 'consum', 0.0221, 'lps'),
	(566554, 130, '2014-03-01 00:38:18.000000', 'consum', 0.0213, 'lps'),
	(566555, 130, '2014-03-01 00:38:19.000000', 'consum', 0.0212, 'lps'),
	(566556, 130, '2014-03-01 00:38:20.000000', 'consum', 0.0212, 'lps'),
	(566557, 130, '2014-03-01 00:38:21.000000', 'consum', 0.0213, 'lps'),
	(566558, 130, '2014-03-01 00:38:22.000000', 'consum', 0.0221, 'lps'),
	(566559, 130, '2014-03-01 00:38:23.000000', 'consum', 0.0216, 'lps'),
	(566560, 130, '2014-03-01 00:38:24.000000', 'consum', 0.0210, 'lps'),
	(566561, 130, '2014-03-01 00:38:25.000000', 'consum', 0.0211, 'lps'),
	(566562, 130, '2014-03-01 00:38:26.000000', 'consum', 0.0216, 'lps'),
	(566563, 130, '2014-03-01 00:38:27.000000', 'consum', 0.0216, 'lps'),
	(566564, 130, '2014-03-01 00:38:28.000000', 'consum', 0.0226, 'lps'),
	(566565, 130, '2014-03-01 00:38:29.000000', 'consum', 0.0213, 'lps'),
	(566566, 130, '2014-03-01 00:38:30.000000', 'consum', 0.0215, 'lps'),
	(566567, 130, '2014-03-01 00:38:31.000000', 'consum', 0.0226, 'lps'),
	(566568, 130, '2014-03-01 00:38:32.000000', 'consum', 0.0217, 'lps'),
	(566569, 130, '2014-03-01 00:38:33.000000', 'consum', 0.0220, 'lps'),
	(566570, 130, '2014-03-01 00:38:34.000000', 'consum', 0.0218, 'lps'),
	(566571, 130, '2014-03-01 00:38:35.000000', 'consum', 0.0223, 'lps'),
	(566572, 130, '2014-03-01 00:38:36.000000', 'consum', 0.0212, 'lps'),
	(566573, 130, '2014-03-01 00:38:37.000000', 'consum', 0.0220, 'lps'),
	(566574, 130, '2014-03-01 00:38:38.000000', 'consum', 0.0217, 'lps'),
	(566575, 130, '2014-03-01 00:38:39.000000', 'consum', 0.0214, 'lps'),
	(566576, 130, '2014-03-01 00:38:40.000000', 'consum', 0.0211, 'lps'),
	(566577, 130, '2014-03-01 00:38:41.000000', 'consum', 0.0223, 'lps'),
	(566578, 130, '2014-03-01 00:38:42.000000', 'consum', 0.0216, 'lps'),
	(566579, 130, '2014-03-01 00:38:43.000000', 'consum', 0.0219, 'lps'),
	(566580, 130, '2014-03-01 00:38:44.000000', 'consum', 0.0218, 'lps'),
	(566581, 130, '2014-03-01 00:38:45.000000', 'consum', 0.0226, 'lps'),
	(566582, 130, '2014-03-01 00:38:46.000000', 'consum', 0.0226, 'lps'),
	(566583, 130, '2014-03-01 00:38:47.000000', 'consum', 0.0225, 'lps'),
	(566584, 130, '2014-03-01 00:38:48.000000', 'consum', 0.0219, 'lps'),
	(566585, 130, '2014-03-01 00:38:49.000000', 'consum', 0.0212, 'lps'),
	(566586, 130, '2014-03-01 00:38:50.000000', 'consum', 0.0210, 'lps'),
	(566587, 130, '2014-03-01 00:38:51.000000', 'consum', 0.0223, 'lps'),
	(566588, 130, '2014-03-01 00:38:52.000000', 'consum', 0.0219, 'lps'),
	(566589, 130, '2014-03-01 00:38:53.000000', 'consum', 0.0216, 'lps'),
	(566590, 130, '2014-03-01 00:38:54.000000', 'consum', 0.0216, 'lps'),
	(566591, 130, '2014-03-01 00:38:55.000000', 'consum', 0.0221, 'lps'),
	(566592, 130, '2014-03-01 00:38:56.000000', 'consum', 0.0211, 'lps'),
	(566593, 130, '2014-03-01 00:38:57.000000', 'consum', 0.0220, 'lps'),
	(566594, 130, '2014-03-01 00:38:58.000000', 'consum', 0.0219, 'lps'),
	(566595, 130, '2014-03-01 00:38:59.000000', 'consum', 0.0225, 'lps'),
	(566596, 130, '2014-03-01 00:39:00.000000', 'consum', 0.0221, 'lps'),
	(566597, 130, '2014-03-01 00:39:01.000000', 'consum', 0.0219, 'lps'),
	(566598, 130, '2014-03-01 00:39:02.000000', 'consum', 0.0225, 'lps'),
	(566599, 130, '2014-03-01 00:39:03.000000', 'consum', 0.0218, 'lps'),
	(566600, 130, '2014-03-01 00:39:04.000000', 'consum', 0.0224, 'lps'),
	(566601, 130, '2014-03-01 00:39:05.000000', 'consum', 0.0221, 'lps'),
	(566602, 130, '2014-03-01 00:39:06.000000', 'consum', 0.0223, 'lps'),
	(566603, 130, '2014-03-01 00:39:07.000000', 'consum', 0.0221, 'lps'),
	(566604, 130, '2014-03-01 00:39:08.000000', 'consum', 0.0210, 'lps'),
	(566605, 130, '2014-03-01 00:39:09.000000', 'consum', 0.0216, 'lps'),
	(566606, 130, '2014-03-01 00:39:10.000000', 'consum', 0.0222, 'lps'),
	(566607, 130, '2014-03-01 00:39:11.000000', 'consum', 0.0215, 'lps'),
	(566608, 130, '2014-03-01 00:39:12.000000', 'consum', 0.0218, 'lps'),
	(566609, 130, '2014-03-01 00:39:13.000000', 'consum', 0.0215, 'lps'),
	(566610, 130, '2014-03-01 00:39:14.000000', 'consum', 0.0213, 'lps'),
	(566611, 130, '2014-03-01 00:39:15.000000', 'consum', 0.0212, 'lps'),
	(566612, 130, '2014-03-01 00:39:16.000000', 'consum', 0.0227, 'lps'),
	(566613, 130, '2014-03-01 00:39:17.000000', 'consum', 0.0217, 'lps'),
	(566614, 130, '2014-03-01 00:39:18.000000', 'consum', 0.0211, 'lps'),
	(566615, 130, '2014-03-01 00:39:19.000000', 'consum', 0.0213, 'lps'),
	(566616, 130, '2014-03-01 00:39:20.000000', 'consum', 0.0221, 'lps'),
	(566617, 130, '2014-03-01 00:39:21.000000', 'consum', 0.0222, 'lps'),
	(566618, 130, '2014-03-01 00:39:22.000000', 'consum', 0.0218, 'lps'),
	(566619, 130, '2014-03-01 00:39:23.000000', 'consum', 0.0216, 'lps'),
	(566620, 130, '2014-03-01 00:39:24.000000', 'consum', 0.0214, 'lps'),
	(566621, 130, '2014-03-01 00:39:25.000000', 'consum', 0.0212, 'lps'),
	(566622, 130, '2014-03-01 00:39:26.000000', 'consum', 0.0228, 'lps'),
	(566623, 130, '2014-03-01 00:39:27.000000', 'consum', 0.0219, 'lps'),
	(566624, 130, '2014-03-01 00:39:28.000000', 'consum', 0.0221, 'lps'),
	(566625, 130, '2014-03-01 00:39:29.000000', 'consum', 0.0219, 'lps'),
	(566626, 130, '2014-03-01 00:39:30.000000', 'consum', 0.0222, 'lps'),
	(566627, 130, '2014-03-01 00:39:31.000000', 'consum', 0.0223, 'lps'),
	(566628, 130, '2014-03-01 00:39:32.000000', 'consum', 0.0221, 'lps'),
	(566629, 130, '2014-03-01 00:39:33.000000', 'consum', 0.0226, 'lps'),
	(566630, 130, '2014-03-01 00:39:34.000000', 'consum', 0.0220, 'lps'),
	(566631, 130, '2014-03-01 00:39:35.000000', 'consum', 0.0212, 'lps'),
	(566632, 130, '2014-03-01 00:39:36.000000', 'consum', 0.0228, 'lps'),
	(566633, 130, '2014-03-01 00:39:37.000000', 'consum', 0.0219, 'lps'),
	(566634, 130, '2014-03-01 00:39:38.000000', 'consum', 0.0222, 'lps'),
	(566635, 130, '2014-03-01 00:39:39.000000', 'consum', 0.0223, 'lps'),
	(566636, 130, '2014-03-01 00:39:40.000000', 'consum', 0.0221, 'lps'),
	(566637, 130, '2014-03-01 00:39:41.000000', 'consum', 0.0228, 'lps'),
	(566638, 130, '2014-03-01 00:39:42.000000', 'consum', 0.0211, 'lps'),
	(566639, 130, '2014-03-01 00:39:43.000000', 'consum', 0.0218, 'lps'),
	(566640, 130, '2014-03-01 00:39:44.000000', 'consum', 0.0227, 'lps'),
	(566641, 130, '2014-03-01 00:39:45.000000', 'consum', 0.0217, 'lps'),
	(566642, 130, '2014-03-01 00:39:46.000000', 'consum', 0.0212, 'lps'),
	(566643, 130, '2014-03-01 00:39:47.000000', 'consum', 0.0217, 'lps'),
	(566644, 130, '2014-03-01 00:39:48.000000', 'consum', 0.0222, 'lps'),
	(566645, 130, '2014-03-01 00:39:49.000000', 'consum', 0.0212, 'lps'),
	(566646, 130, '2014-03-01 00:39:50.000000', 'consum', 0.0221, 'lps'),
	(566647, 130, '2014-03-01 00:39:51.000000', 'consum', 0.0221, 'lps'),
	(566648, 130, '2014-03-01 00:39:52.000000', 'consum', 0.0216, 'lps'),
	(566649, 130, '2014-03-01 00:39:53.000000', 'consum', 0.0226, 'lps'),
	(566650, 130, '2014-03-01 00:39:54.000000', 'consum', 0.0215, 'lps'),
	(566651, 130, '2014-03-01 00:39:55.000000', 'consum', 0.0227, 'lps'),
	(566652, 130, '2014-03-01 00:39:56.000000', 'consum', 0.0223, 'lps'),
	(566653, 130, '2014-03-01 00:39:57.000000', 'consum', 0.0225, 'lps'),
	(566654, 130, '2014-03-01 00:39:58.000000', 'consum', 0.0226, 'lps'),
	(566655, 130, '2014-03-01 00:39:59.000000', 'consum', 0.0226, 'lps'),
	(566656, 130, '2014-03-01 00:40:00.000000', 'consum', 0.0226, 'lps'),
	(566657, 130, '2014-03-01 00:40:01.000000', 'consum', 0.0222, 'lps'),
	(566658, 130, '2014-03-01 00:40:02.000000', 'consum', 0.0225, 'lps'),
	(566659, 130, '2014-03-01 00:40:03.000000', 'consum', 0.0228, 'lps'),
	(566660, 130, '2014-03-01 00:40:04.000000', 'consum', 0.0217, 'lps'),
	(566661, 130, '2014-03-01 00:40:05.000000', 'consum', 0.0211, 'lps'),
	(566662, 130, '2014-03-01 00:40:06.000000', 'consum', 0.0213, 'lps'),
	(566663, 130, '2014-03-01 00:40:07.000000', 'consum', 0.0223, 'lps'),
	(566664, 130, '2014-03-01 00:40:08.000000', 'consum', 0.0211, 'lps'),
	(566665, 130, '2014-03-01 00:40:09.000000', 'consum', 0.0214, 'lps'),
	(566666, 130, '2014-03-01 00:40:10.000000', 'consum', 0.0210, 'lps'),
	(566667, 130, '2014-03-01 00:40:11.000000', 'consum', 0.0215, 'lps'),
	(566668, 130, '2014-03-01 00:40:12.000000', 'consum', 0.0217, 'lps'),
	(566669, 130, '2014-03-01 00:40:13.000000', 'consum', 0.0213, 'lps'),
	(566670, 130, '2014-03-01 00:40:14.000000', 'consum', 0.0221, 'lps'),
	(566671, 130, '2014-03-01 00:40:15.000000', 'consum', 0.0219, 'lps'),
	(566672, 130, '2014-03-01 00:40:16.000000', 'consum', 0.0224, 'lps'),
	(566673, 130, '2014-03-01 00:40:17.000000', 'consum', 0.0215, 'lps'),
	(566674, 130, '2014-03-01 00:40:18.000000', 'consum', 0.0212, 'lps'),
	(566675, 130, '2014-03-01 00:40:19.000000', 'consum', 0.0226, 'lps'),
	(566676, 130, '2014-03-01 00:40:20.000000', 'consum', 0.0226, 'lps'),
	(566677, 130, '2014-03-01 00:40:21.000000', 'consum', 0.0222, 'lps'),
	(566678, 130, '2014-03-01 00:40:22.000000', 'consum', 0.0224, 'lps'),
	(566679, 130, '2014-03-01 00:40:23.000000', 'consum', 0.0227, 'lps'),
	(566680, 130, '2014-03-01 00:40:24.000000', 'consum', 0.0215, 'lps'),
	(566681, 130, '2014-03-01 00:40:25.000000', 'consum', 0.0224, 'lps'),
	(566682, 130, '2014-03-01 00:40:26.000000', 'consum', 0.0226, 'lps'),
	(566683, 130, '2014-03-01 00:40:27.000000', 'consum', 0.0212, 'lps'),
	(566684, 130, '2014-03-01 00:40:28.000000', 'consum', 0.0210, 'lps'),
	(566685, 130, '2014-03-01 00:40:29.000000', 'consum', 0.0222, 'lps'),
	(566686, 130, '2014-03-01 00:40:30.000000', 'consum', 0.0214, 'lps'),
	(566687, 130, '2014-03-01 00:40:31.000000', 'consum', 0.0215, 'lps'),
	(566688, 130, '2014-03-01 00:40:32.000000', 'consum', 0.0223, 'lps'),
	(566689, 130, '2014-03-01 00:40:33.000000', 'consum', 0.0222, 'lps'),
	(566690, 130, '2014-03-01 00:40:34.000000', 'consum', 0.0213, 'lps'),
	(566691, 130, '2014-03-01 00:40:35.000000', 'consum', 0.0228, 'lps'),
	(566692, 130, '2014-03-01 00:40:36.000000', 'consum', 0.0215, 'lps'),
	(566693, 130, '2014-03-01 00:40:37.000000', 'consum', 0.0221, 'lps'),
	(566694, 130, '2014-03-01 00:40:38.000000', 'consum', 0.0212, 'lps'),
	(566695, 130, '2014-03-01 00:40:39.000000', 'consum', 0.0226, 'lps'),
	(566696, 130, '2014-03-01 00:40:40.000000', 'consum', 0.0227, 'lps'),
	(566697, 130, '2014-03-01 00:40:41.000000', 'consum', 0.0211, 'lps'),
	(566698, 130, '2014-03-01 00:40:42.000000', 'consum', 0.0218, 'lps'),
	(566699, 130, '2014-03-01 00:40:43.000000', 'consum', 0.0213, 'lps'),
	(566700, 130, '2014-03-01 00:40:44.000000', 'consum', 0.0218, 'lps'),
	(566701, 130, '2014-03-01 00:40:45.000000', 'consum', 0.0222, 'lps'),
	(566702, 130, '2014-03-01 00:40:46.000000', 'consum', 0.0227, 'lps'),
	(566703, 130, '2014-03-01 00:40:47.000000', 'consum', 0.0222, 'lps'),
	(566704, 130, '2014-03-01 00:40:48.000000', 'consum', 0.0220, 'lps'),
	(566705, 130, '2014-03-01 00:40:49.000000', 'consum', 0.0224, 'lps'),
	(566706, 130, '2014-03-01 00:40:50.000000', 'consum', 0.0214, 'lps'),
	(566707, 130, '2014-03-01 00:40:51.000000', 'consum', 0.0224, 'lps'),
	(566708, 130, '2014-03-01 00:40:52.000000', 'consum', 0.0211, 'lps'),
	(566709, 130, '2014-03-01 00:40:53.000000', 'consum', 0.0212, 'lps'),
	(566710, 130, '2014-03-01 00:40:54.000000', 'consum', 0.0219, 'lps'),
	(566711, 130, '2014-03-01 00:40:55.000000', 'consum', 0.0210, 'lps'),
	(566712, 130, '2014-03-01 00:40:56.000000', 'consum', 0.0224, 'lps'),
	(566713, 130, '2014-03-01 00:40:57.000000', 'consum', 0.0220, 'lps'),
	(566714, 130, '2014-03-01 00:40:58.000000', 'consum', 0.0221, 'lps'),
	(566715, 130, '2014-03-01 00:40:59.000000', 'consum', 0.0216, 'lps'),
	(566716, 130, '2014-03-01 00:41:00.000000', 'consum', 0.0227, 'lps'),
	(566717, 130, '2014-03-01 00:41:01.000000', 'consum', 0.0222, 'lps'),
	(566718, 130, '2014-03-01 00:41:02.000000', 'consum', 0.0218, 'lps'),
	(566719, 130, '2014-03-01 00:41:03.000000', 'consum', 0.0214, 'lps'),
	(566720, 130, '2014-03-01 00:41:04.000000', 'consum', 0.0226, 'lps'),
	(566721, 130, '2014-03-01 00:41:05.000000', 'consum', 0.0224, 'lps'),
	(566722, 130, '2014-03-01 00:41:06.000000', 'consum', 0.0210, 'lps'),
	(566723, 130, '2014-03-01 00:41:07.000000', 'consum', 0.0226, 'lps'),
	(566724, 130, '2014-03-01 00:41:08.000000', 'consum', 0.0217, 'lps'),
	(566725, 130, '2014-03-01 00:41:09.000000', 'consum', 0.0213, 'lps'),
	(566726, 130, '2014-03-01 00:41:10.000000', 'consum', 0.0225, 'lps'),
	(566727, 130, '2014-03-01 00:41:11.000000', 'consum', 0.0221, 'lps'),
	(566728, 130, '2014-03-01 00:41:12.000000', 'consum', 0.0220, 'lps'),
	(566729, 130, '2014-03-01 00:41:13.000000', 'consum', 0.0227, 'lps'),
	(566730, 130, '2014-03-01 00:41:14.000000', 'consum', 0.0226, 'lps'),
	(566731, 130, '2014-03-01 00:41:15.000000', 'consum', 0.0220, 'lps'),
	(566732, 130, '2014-03-01 00:41:16.000000', 'consum', 0.0214, 'lps'),
	(566733, 130, '2014-03-01 00:41:17.000000', 'consum', 0.0219, 'lps'),
	(566734, 130, '2014-03-01 00:41:18.000000', 'consum', 0.0224, 'lps'),
	(566735, 130, '2014-03-01 00:41:19.000000', 'consum', 0.0215, 'lps'),
	(566736, 130, '2014-03-01 00:41:20.000000', 'consum', 0.0212, 'lps'),
	(566737, 130, '2014-03-01 00:41:21.000000', 'consum', 0.0224, 'lps'),
	(566738, 130, '2014-03-01 00:41:22.000000', 'consum', 0.0220, 'lps'),
	(566739, 130, '2014-03-01 00:41:23.000000', 'consum', 0.0217, 'lps'),
	(566740, 130, '2014-03-01 00:41:24.000000', 'consum', 0.0217, 'lps'),
	(566741, 130, '2014-03-01 00:41:25.000000', 'consum', 0.0225, 'lps'),
	(566742, 130, '2014-03-01 00:41:26.000000', 'consum', 0.0224, 'lps'),
	(566743, 130, '2014-03-01 00:41:27.000000', 'consum', 0.0220, 'lps'),
	(566744, 130, '2014-03-01 00:41:28.000000', 'consum', 0.0215, 'lps'),
	(566745, 130, '2014-03-01 00:41:29.000000', 'consum', 0.0226, 'lps'),
	(566746, 130, '2014-03-01 00:41:30.000000', 'consum', 0.0218, 'lps'),
	(566747, 130, '2014-03-01 00:41:31.000000', 'consum', 0.0222, 'lps'),
	(566748, 130, '2014-03-01 00:41:32.000000', 'consum', 0.0226, 'lps'),
	(566749, 130, '2014-03-01 00:41:33.000000', 'consum', 0.0219, 'lps'),
	(566750, 130, '2014-03-01 00:41:34.000000', 'consum', 0.0225, 'lps'),
	(566751, 130, '2014-03-01 00:41:35.000000', 'consum', 0.0220, 'lps'),
	(566752, 130, '2014-03-01 00:41:36.000000', 'consum', 0.0218, 'lps'),
	(566753, 130, '2014-03-01 00:41:37.000000', 'consum', 0.0219, 'lps'),
	(566754, 130, '2014-03-01 00:41:38.000000', 'consum', 0.0213, 'lps'),
	(566755, 130, '2014-03-01 00:41:39.000000', 'consum', 0.0217, 'lps'),
	(566756, 130, '2014-03-01 00:41:40.000000', 'consum', 0.0219, 'lps'),
	(566757, 130, '2014-03-01 00:41:41.000000', 'consum', 0.0215, 'lps'),
	(566758, 130, '2014-03-01 00:41:42.000000', 'consum', 0.0210, 'lps'),
	(566759, 130, '2014-03-01 00:41:43.000000', 'consum', 0.0213, 'lps'),
	(566760, 130, '2014-03-01 00:41:44.000000', 'consum', 0.0224, 'lps'),
	(566761, 130, '2014-03-01 00:41:45.000000', 'consum', 0.0215, 'lps'),
	(566762, 130, '2014-03-01 00:41:46.000000', 'consum', 0.0211, 'lps'),
	(566763, 130, '2014-03-01 00:41:47.000000', 'consum', 0.0222, 'lps'),
	(566764, 130, '2014-03-01 00:41:48.000000', 'consum', 0.0227, 'lps'),
	(566765, 130, '2014-03-01 00:41:49.000000', 'consum', 0.0221, 'lps'),
	(566766, 130, '2014-03-01 00:41:50.000000', 'consum', 0.0215, 'lps'),
	(566767, 130, '2014-03-01 00:41:51.000000', 'consum', 0.0222, 'lps'),
	(566768, 130, '2014-03-01 00:41:52.000000', 'consum', 0.0217, 'lps'),
	(566769, 130, '2014-03-01 00:41:53.000000', 'consum', 0.0210, 'lps'),
	(566770, 130, '2014-03-01 00:41:54.000000', 'consum', 0.0227, 'lps'),
	(566771, 130, '2014-03-01 00:41:55.000000', 'consum', 0.0220, 'lps'),
	(566772, 130, '2014-03-01 00:41:56.000000', 'consum', 0.0211, 'lps'),
	(566773, 130, '2014-03-01 00:41:57.000000', 'consum', 0.0221, 'lps'),
	(566774, 130, '2014-03-01 00:41:58.000000', 'consum', 0.0227, 'lps'),
	(566775, 130, '2014-03-01 00:41:59.000000', 'consum', 0.0222, 'lps'),
	(566776, 130, '2014-03-01 00:42:00.000000', 'consum', 0.0220, 'lps'),
	(566777, 130, '2014-03-01 00:42:01.000000', 'consum', 0.0226, 'lps'),
	(566778, 130, '2014-03-01 00:42:02.000000', 'consum', 0.0220, 'lps'),
	(566779, 130, '2014-03-01 00:42:03.000000', 'consum', 0.0213, 'lps'),
	(566780, 130, '2014-03-01 00:42:04.000000', 'consum', 0.0215, 'lps'),
	(566781, 130, '2014-03-01 00:42:05.000000', 'consum', 0.0226, 'lps'),
	(566782, 130, '2014-03-01 00:42:06.000000', 'consum', 0.0217, 'lps'),
	(566783, 130, '2014-03-01 00:42:07.000000', 'consum', 0.0217, 'lps'),
	(566784, 130, '2014-03-01 00:42:08.000000', 'consum', 0.0227, 'lps'),
	(566785, 130, '2014-03-01 00:42:09.000000', 'consum', 0.0215, 'lps'),
	(566786, 130, '2014-03-01 00:42:10.000000', 'consum', 0.0222, 'lps'),
	(566787, 130, '2014-03-01 00:42:11.000000', 'consum', 0.0220, 'lps'),
	(566788, 130, '2014-03-01 00:42:12.000000', 'consum', 0.0225, 'lps'),
	(566789, 130, '2014-03-01 00:42:13.000000', 'consum', 0.0217, 'lps'),
	(566790, 130, '2014-03-01 00:42:14.000000', 'consum', 0.0218, 'lps'),
	(566791, 130, '2014-03-01 00:42:15.000000', 'consum', 0.0210, 'lps'),
	(566792, 130, '2014-03-01 00:42:16.000000', 'consum', 0.0227, 'lps'),
	(566793, 130, '2014-03-01 00:42:17.000000', 'consum', 0.0217, 'lps'),
	(566794, 130, '2014-03-01 00:42:18.000000', 'consum', 0.0216, 'lps'),
	(566795, 130, '2014-03-01 00:42:19.000000', 'consum', 0.0218, 'lps'),
	(566796, 130, '2014-03-01 00:42:20.000000', 'consum', 0.0212, 'lps'),
	(566797, 130, '2014-03-01 00:42:21.000000', 'consum', 0.0217, 'lps'),
	(566798, 130, '2014-03-01 00:42:22.000000', 'consum', 0.0219, 'lps'),
	(566799, 130, '2014-03-01 00:42:23.000000', 'consum', 0.0218, 'lps'),
	(566800, 130, '2014-03-01 00:42:24.000000', 'consum', 0.0224, 'lps'),
	(566801, 130, '2014-03-01 00:42:25.000000', 'consum', 0.0218, 'lps'),
	(566802, 130, '2014-03-01 00:42:26.000000', 'consum', 0.0227, 'lps'),
	(566803, 130, '2014-03-01 00:42:27.000000', 'consum', 0.0215, 'lps'),
	(566804, 130, '2014-03-01 00:42:28.000000', 'consum', 0.0224, 'lps'),
	(566805, 130, '2014-03-01 00:42:29.000000', 'consum', 0.0227, 'lps'),
	(566806, 130, '2014-03-01 00:42:30.000000', 'consum', 0.0214, 'lps'),
	(566807, 130, '2014-03-01 00:42:31.000000', 'consum', 0.0220, 'lps'),
	(566808, 130, '2014-03-01 00:42:32.000000', 'consum', 0.0226, 'lps'),
	(566809, 130, '2014-03-01 00:42:33.000000', 'consum', 0.0225, 'lps'),
	(566810, 130, '2014-03-01 00:42:34.000000', 'consum', 0.0219, 'lps'),
	(566811, 130, '2014-03-01 00:42:35.000000', 'consum', 0.0227, 'lps'),
	(566812, 130, '2014-03-01 00:42:36.000000', 'consum', 0.0212, 'lps'),
	(566813, 130, '2014-03-01 00:42:37.000000', 'consum', 0.0228, 'lps'),
	(566814, 130, '2014-03-01 00:42:38.000000', 'consum', 0.0217, 'lps'),
	(566815, 130, '2014-03-01 00:42:39.000000', 'consum', 0.0211, 'lps'),
	(566816, 130, '2014-03-01 00:42:40.000000', 'consum', 0.0215, 'lps'),
	(566817, 130, '2014-03-01 00:42:41.000000', 'consum', 0.0212, 'lps'),
	(566818, 130, '2014-03-01 00:42:42.000000', 'consum', 0.0227, 'lps'),
	(566819, 130, '2014-03-01 00:42:43.000000', 'consum', 0.0211, 'lps'),
	(566820, 130, '2014-03-01 00:42:44.000000', 'consum', 0.0221, 'lps'),
	(566821, 130, '2014-03-01 00:42:45.000000', 'consum', 0.0225, 'lps'),
	(566822, 130, '2014-03-01 00:42:46.000000', 'consum', 0.0215, 'lps'),
	(566823, 130, '2014-03-01 00:42:47.000000', 'consum', 0.0210, 'lps'),
	(566824, 130, '2014-03-01 00:42:48.000000', 'consum', 0.0213, 'lps'),
	(566825, 130, '2014-03-01 00:42:49.000000', 'consum', 0.0225, 'lps'),
	(566826, 130, '2014-03-01 00:42:50.000000', 'consum', 0.0220, 'lps'),
	(566827, 130, '2014-03-01 00:42:51.000000', 'consum', 0.0217, 'lps'),
	(566828, 130, '2014-03-01 00:42:52.000000', 'consum', 0.0215, 'lps'),
	(566829, 130, '2014-03-01 00:42:53.000000', 'consum', 0.0216, 'lps'),
	(566830, 130, '2014-03-01 00:42:54.000000', 'consum', 0.0226, 'lps'),
	(566831, 130, '2014-03-01 00:42:55.000000', 'consum', 0.0213, 'lps'),
	(566832, 130, '2014-03-01 00:42:56.000000', 'consum', 0.0215, 'lps'),
	(566833, 130, '2014-03-01 00:42:57.000000', 'consum', 0.0211, 'lps'),
	(566834, 130, '2014-03-01 00:42:58.000000', 'consum', 0.0216, 'lps'),
	(566835, 130, '2014-03-01 00:42:59.000000', 'consum', 0.0220, 'lps'),
	(566836, 130, '2014-03-01 00:43:00.000000', 'consum', 0.0224, 'lps'),
	(566837, 130, '2014-03-01 00:43:01.000000', 'consum', 0.0211, 'lps'),
	(566838, 130, '2014-03-01 00:43:02.000000', 'consum', 0.0213, 'lps'),
	(566839, 130, '2014-03-01 00:43:03.000000', 'consum', 0.0221, 'lps'),
	(566840, 130, '2014-03-01 00:43:04.000000', 'consum', 0.0221, 'lps'),
	(566841, 130, '2014-03-01 00:43:05.000000', 'consum', 0.0212, 'lps'),
	(566842, 130, '2014-03-01 00:43:06.000000', 'consum', 0.0227, 'lps'),
	(566843, 130, '2014-03-01 00:43:07.000000', 'consum', 0.0212, 'lps'),
	(566844, 130, '2014-03-01 00:43:08.000000', 'consum', 0.0228, 'lps'),
	(566845, 130, '2014-03-01 00:43:09.000000', 'consum', 0.0218, 'lps'),
	(566846, 130, '2014-03-01 00:43:10.000000', 'consum', 0.0215, 'lps'),
	(566847, 130, '2014-03-01 00:43:11.000000', 'consum', 0.0210, 'lps'),
	(566848, 130, '2014-03-01 00:43:12.000000', 'consum', 0.0215, 'lps'),
	(566849, 130, '2014-03-01 00:43:13.000000', 'consum', 0.0216, 'lps'),
	(566850, 130, '2014-03-01 00:43:14.000000', 'consum', 0.0227, 'lps'),
	(566851, 130, '2014-03-01 00:43:15.000000', 'consum', 0.0218, 'lps'),
	(566852, 130, '2014-03-01 00:43:16.000000', 'consum', 0.0220, 'lps'),
	(566853, 130, '2014-03-01 00:43:17.000000', 'consum', 0.0216, 'lps'),
	(566854, 130, '2014-03-01 00:43:18.000000', 'consum', 0.0211, 'lps'),
	(566855, 130, '2014-03-01 00:43:19.000000', 'consum', 0.0218, 'lps'),
	(566856, 130, '2014-03-01 00:43:20.000000', 'consum', 0.0210, 'lps'),
	(566857, 130, '2014-03-01 00:43:21.000000', 'consum', 0.0223, 'lps'),
	(566858, 130, '2014-03-01 00:43:22.000000', 'consum', 0.0220, 'lps'),
	(566859, 130, '2014-03-01 00:43:23.000000', 'consum', 0.0222, 'lps'),
	(566860, 130, '2014-03-01 00:43:24.000000', 'consum', 0.0222, 'lps'),
	(566861, 130, '2014-03-01 00:43:25.000000', 'consum', 0.0213, 'lps'),
	(566862, 130, '2014-03-01 00:43:26.000000', 'consum', 0.0228, 'lps'),
	(566863, 130, '2014-03-01 00:43:27.000000', 'consum', 0.0215, 'lps'),
	(566864, 130, '2014-03-01 00:43:28.000000', 'consum', 0.0219, 'lps'),
	(566865, 130, '2014-03-01 00:43:29.000000', 'consum', 0.0223, 'lps'),
	(566866, 130, '2014-03-01 00:43:30.000000', 'consum', 0.0212, 'lps'),
	(566867, 130, '2014-03-01 00:43:31.000000', 'consum', 0.0218, 'lps'),
	(566868, 130, '2014-03-01 00:43:32.000000', 'consum', 0.0227, 'lps'),
	(566869, 130, '2014-03-01 00:43:33.000000', 'consum', 0.0216, 'lps'),
	(566870, 130, '2014-03-01 00:43:34.000000', 'consum', 0.0224, 'lps'),
	(566871, 130, '2014-03-01 00:43:35.000000', 'consum', 0.0227, 'lps'),
	(566872, 130, '2014-03-01 00:43:36.000000', 'consum', 0.0213, 'lps'),
	(566873, 130, '2014-03-01 00:43:37.000000', 'consum', 0.0214, 'lps'),
	(566874, 130, '2014-03-01 00:43:38.000000', 'consum', 0.0223, 'lps'),
	(566875, 130, '2014-03-01 00:43:39.000000', 'consum', 0.0225, 'lps'),
	(566876, 130, '2014-03-01 00:43:40.000000', 'consum', 0.0227, 'lps'),
	(566877, 130, '2014-03-01 00:43:41.000000', 'consum', 0.0211, 'lps'),
	(566878, 130, '2014-03-01 00:43:42.000000', 'consum', 0.0222, 'lps'),
	(566879, 130, '2014-03-01 00:43:43.000000', 'consum', 0.0212, 'lps'),
	(566880, 130, '2014-03-01 00:43:44.000000', 'consum', 0.0222, 'lps'),
	(566881, 130, '2014-03-01 00:43:45.000000', 'consum', 0.0226, 'lps'),
	(566882, 130, '2014-03-01 00:43:46.000000', 'consum', 0.0218, 'lps'),
	(566883, 130, '2014-03-01 00:43:47.000000', 'consum', 0.0220, 'lps'),
	(566884, 130, '2014-03-01 00:43:48.000000', 'consum', 0.0217, 'lps'),
	(566885, 130, '2014-03-01 00:43:49.000000', 'consum', 0.0214, 'lps'),
	(566886, 130, '2014-03-01 00:43:50.000000', 'consum', 0.0212, 'lps'),
	(566887, 130, '2014-03-01 00:43:51.000000', 'consum', 0.0227, 'lps'),
	(566888, 130, '2014-03-01 00:43:52.000000', 'consum', 0.0212, 'lps'),
	(566889, 130, '2014-03-01 00:43:53.000000', 'consum', 0.0228, 'lps'),
	(566890, 130, '2014-03-01 00:43:54.000000', 'consum', 0.0218, 'lps'),
	(566891, 130, '2014-03-01 00:43:55.000000', 'consum', 0.0216, 'lps'),
	(566892, 130, '2014-03-01 00:43:56.000000', 'consum', 0.0217, 'lps'),
	(566893, 130, '2014-03-01 00:43:57.000000', 'consum', 0.0228, 'lps'),
	(566894, 130, '2014-03-01 00:43:58.000000', 'consum', 0.0222, 'lps'),
	(566895, 130, '2014-03-01 00:43:59.000000', 'consum', 0.0218, 'lps'),
	(566896, 130, '2014-03-01 00:44:00.000000', 'consum', 0.0214, 'lps'),
	(566897, 130, '2014-03-01 00:44:01.000000', 'consum', 0.0227, 'lps'),
	(566898, 130, '2014-03-01 00:44:02.000000', 'consum', 0.0223, 'lps'),
	(566899, 130, '2014-03-01 00:44:03.000000', 'consum', 0.0226, 'lps'),
	(566900, 130, '2014-03-01 00:44:04.000000', 'consum', 0.0214, 'lps'),
	(566901, 130, '2014-03-01 00:44:05.000000', 'consum', 0.0221, 'lps'),
	(566902, 130, '2014-03-01 00:44:06.000000', 'consum', 0.0216, 'lps'),
	(566903, 130, '2014-03-01 00:44:07.000000', 'consum', 0.0224, 'lps'),
	(566904, 130, '2014-03-01 00:44:08.000000', 'consum', 0.0225, 'lps'),
	(566905, 130, '2014-03-01 00:44:09.000000', 'consum', 0.0225, 'lps'),
	(566906, 130, '2014-03-01 00:44:10.000000', 'consum', 0.0220, 'lps'),
	(566907, 130, '2014-03-01 00:44:11.000000', 'consum', 0.0216, 'lps'),
	(566908, 130, '2014-03-01 00:44:12.000000', 'consum', 0.0212, 'lps'),
	(566909, 130, '2014-03-01 00:44:13.000000', 'consum', 0.0220, 'lps'),
	(566910, 130, '2014-03-01 00:44:14.000000', 'consum', 0.0219, 'lps'),
	(566911, 130, '2014-03-01 00:44:15.000000', 'consum', 0.0222, 'lps'),
	(566912, 130, '2014-03-01 00:44:16.000000', 'consum', 0.0228, 'lps'),
	(566913, 130, '2014-03-01 00:44:17.000000', 'consum', 0.0225, 'lps'),
	(566914, 130, '2014-03-01 00:44:18.000000', 'consum', 0.0215, 'lps'),
	(566915, 130, '2014-03-01 00:44:19.000000', 'consum', 0.0225, 'lps'),
	(566916, 130, '2014-03-01 00:44:20.000000', 'consum', 0.0214, 'lps'),
	(566917, 130, '2014-03-01 00:44:21.000000', 'consum', 0.0225, 'lps'),
	(566918, 130, '2014-03-01 00:44:22.000000', 'consum', 0.0214, 'lps'),
	(566919, 130, '2014-03-01 00:44:23.000000', 'consum', 0.0225, 'lps'),
	(566920, 130, '2014-03-01 00:44:24.000000', 'consum', 0.0218, 'lps'),
	(566921, 130, '2014-03-01 00:44:25.000000', 'consum', 0.0225, 'lps'),
	(566922, 130, '2014-03-01 00:44:26.000000', 'consum', 0.0220, 'lps'),
	(566923, 130, '2014-03-01 00:44:27.000000', 'consum', 0.0219, 'lps'),
	(566924, 130, '2014-03-01 00:44:28.000000', 'consum', 0.0223, 'lps'),
	(566925, 130, '2014-03-01 00:44:29.000000', 'consum', 0.0228, 'lps'),
	(566926, 130, '2014-03-01 00:44:30.000000', 'consum', 0.0227, 'lps'),
	(566927, 130, '2014-03-01 00:44:31.000000', 'consum', 0.0221, 'lps'),
	(566928, 130, '2014-03-01 00:44:32.000000', 'consum', 0.0213, 'lps'),
	(566929, 130, '2014-03-01 00:44:33.000000', 'consum', 0.0214, 'lps'),
	(566930, 130, '2014-03-01 00:44:34.000000', 'consum', 0.0220, 'lps'),
	(566931, 130, '2014-03-01 00:44:35.000000', 'consum', 0.0211, 'lps'),
	(566932, 130, '2014-03-01 00:44:36.000000', 'consum', 0.0222, 'lps'),
	(566933, 130, '2014-03-01 00:44:37.000000', 'consum', 0.0212, 'lps'),
	(566934, 130, '2014-03-01 00:44:38.000000', 'consum', 0.0221, 'lps'),
	(566935, 130, '2014-03-01 00:44:39.000000', 'consum', 0.0222, 'lps'),
	(566936, 130, '2014-03-01 00:44:40.000000', 'consum', 0.0220, 'lps'),
	(566937, 130, '2014-03-01 00:44:41.000000', 'consum', 0.0222, 'lps'),
	(566938, 130, '2014-03-01 00:44:42.000000', 'consum', 0.0222, 'lps'),
	(566939, 130, '2014-03-01 00:44:43.000000', 'consum', 0.0214, 'lps'),
	(566940, 130, '2014-03-01 00:44:44.000000', 'consum', 0.0215, 'lps'),
	(566941, 130, '2014-03-01 00:44:45.000000', 'consum', 0.0222, 'lps'),
	(566942, 130, '2014-03-01 00:44:46.000000', 'consum', 0.0217, 'lps'),
	(566943, 130, '2014-03-01 00:44:47.000000', 'consum', 0.0212, 'lps'),
	(566944, 130, '2014-03-01 00:44:48.000000', 'consum', 0.0218, 'lps'),
	(566945, 130, '2014-03-01 00:44:49.000000', 'consum', 0.0225, 'lps'),
	(566946, 130, '2014-03-01 00:44:50.000000', 'consum', 0.0226, 'lps'),
	(566947, 130, '2014-03-01 00:44:51.000000', 'consum', 0.0223, 'lps'),
	(566948, 130, '2014-03-01 00:44:52.000000', 'consum', 0.0210, 'lps'),
	(566949, 130, '2014-03-01 00:44:53.000000', 'consum', 0.0228, 'lps'),
	(566950, 130, '2014-03-01 00:44:54.000000', 'consum', 0.0223, 'lps'),
	(566951, 130, '2014-03-01 00:44:55.000000', 'consum', 0.0224, 'lps'),
	(566952, 130, '2014-03-01 00:44:56.000000', 'consum', 0.0223, 'lps'),
	(566953, 130, '2014-03-01 00:44:57.000000', 'consum', 0.0216, 'lps'),
	(566954, 130, '2014-03-01 00:44:58.000000', 'consum', 0.0217, 'lps'),
	(566955, 130, '2014-03-01 00:44:59.000000', 'consum', 0.0227, 'lps'),
	(566956, 130, '2014-03-01 00:45:00.000000', 'consum', 0.0219, 'lps'),
	(566957, 130, '2014-03-01 00:45:01.000000', 'consum', 0.0225, 'lps'),
	(566958, 130, '2014-03-01 00:45:02.000000', 'consum', 0.0220, 'lps'),
	(566959, 130, '2014-03-01 00:45:03.000000', 'consum', 0.0215, 'lps'),
	(566960, 130, '2014-03-01 00:45:04.000000', 'consum', 0.0224, 'lps'),
	(566961, 130, '2014-03-01 00:45:05.000000', 'consum', 0.0210, 'lps'),
	(566962, 130, '2014-03-01 00:45:06.000000', 'consum', 0.0226, 'lps'),
	(566963, 130, '2014-03-01 00:45:07.000000', 'consum', 0.0212, 'lps'),
	(566964, 130, '2014-03-01 00:45:08.000000', 'consum', 0.0212, 'lps'),
	(566965, 130, '2014-03-01 00:45:09.000000', 'consum', 0.0216, 'lps'),
	(566966, 130, '2014-03-01 00:45:10.000000', 'consum', 0.0215, 'lps'),
	(566967, 130, '2014-03-01 00:45:11.000000', 'consum', 0.0218, 'lps'),
	(566968, 130, '2014-03-01 00:45:12.000000', 'consum', 0.0217, 'lps'),
	(566969, 130, '2014-03-01 00:45:13.000000', 'consum', 0.0219, 'lps'),
	(566970, 130, '2014-03-01 00:45:14.000000', 'consum', 0.0217, 'lps'),
	(566971, 130, '2014-03-01 00:45:15.000000', 'consum', 0.0217, 'lps'),
	(566972, 130, '2014-03-01 00:45:16.000000', 'consum', 0.0224, 'lps'),
	(566973, 130, '2014-03-01 00:45:17.000000', 'consum', 0.0221, 'lps'),
	(566974, 130, '2014-03-01 00:45:18.000000', 'consum', 0.0224, 'lps'),
	(566975, 130, '2014-03-01 00:45:19.000000', 'consum', 0.0227, 'lps'),
	(566976, 130, '2014-03-01 00:45:20.000000', 'consum', 0.0218, 'lps'),
	(566977, 130, '2014-03-01 00:45:21.000000', 'consum', 0.0219, 'lps'),
	(566978, 130, '2014-03-01 00:45:22.000000', 'consum', 0.0211, 'lps'),
	(566979, 130, '2014-03-01 00:45:23.000000', 'consum', 0.0226, 'lps'),
	(566980, 130, '2014-03-01 00:45:24.000000', 'consum', 0.0210, 'lps'),
	(566981, 130, '2014-03-01 00:45:25.000000', 'consum', 0.0222, 'lps'),
	(566982, 130, '2014-03-01 00:45:26.000000', 'consum', 0.0215, 'lps'),
	(566983, 130, '2014-03-01 00:45:27.000000', 'consum', 0.0216, 'lps'),
	(566984, 130, '2014-03-01 00:45:28.000000', 'consum', 0.0227, 'lps'),
	(566985, 130, '2014-03-01 00:45:29.000000', 'consum', 0.0218, 'lps'),
	(566986, 130, '2014-03-01 00:45:30.000000', 'consum', 0.0220, 'lps'),
	(566987, 130, '2014-03-01 00:45:31.000000', 'consum', 0.0217, 'lps'),
	(566988, 130, '2014-03-01 00:45:32.000000', 'consum', 0.0215, 'lps'),
	(566989, 130, '2014-03-01 00:45:33.000000', 'consum', 0.0217, 'lps'),
	(566990, 130, '2014-03-01 00:45:34.000000', 'consum', 0.0227, 'lps'),
	(566991, 130, '2014-03-01 00:45:35.000000', 'consum', 0.0220, 'lps'),
	(566992, 130, '2014-03-01 00:45:36.000000', 'consum', 0.0226, 'lps'),
	(566993, 130, '2014-03-01 00:45:37.000000', 'consum', 0.0225, 'lps'),
	(566994, 130, '2014-03-01 00:45:38.000000', 'consum', 0.0219, 'lps'),
	(566995, 130, '2014-03-01 00:45:39.000000', 'consum', 0.0227, 'lps'),
	(566996, 130, '2014-03-01 00:45:40.000000', 'consum', 0.0213, 'lps'),
	(566997, 130, '2014-03-01 00:45:41.000000', 'consum', 0.0211, 'lps'),
	(566998, 130, '2014-03-01 00:45:42.000000', 'consum', 0.0227, 'lps'),
	(566999, 130, '2014-03-01 00:45:43.000000', 'consum', 0.0215, 'lps'),
	(567000, 130, '2014-03-01 00:45:44.000000', 'consum', 0.0224, 'lps'),
	(567001, 130, '2014-03-01 00:45:45.000000', 'consum', 0.0228, 'lps'),
	(567002, 130, '2014-03-01 00:45:46.000000', 'consum', 0.0219, 'lps'),
	(567003, 130, '2014-03-01 00:45:47.000000', 'consum', 0.0223, 'lps'),
	(567004, 130, '2014-03-01 00:45:48.000000', 'consum', 0.0226, 'lps'),
	(567005, 130, '2014-03-01 00:45:49.000000', 'consum', 0.0216, 'lps'),
	(567006, 130, '2014-03-01 00:45:50.000000', 'consum', 0.0211, 'lps'),
	(567007, 130, '2014-03-01 00:45:51.000000', 'consum', 0.0217, 'lps'),
	(567008, 130, '2014-03-01 00:45:52.000000', 'consum', 0.0223, 'lps'),
	(567009, 130, '2014-03-01 00:45:53.000000', 'consum', 0.0218, 'lps'),
	(567010, 130, '2014-03-01 00:45:54.000000', 'consum', 0.0212, 'lps'),
	(567011, 130, '2014-03-01 00:45:55.000000', 'consum', 0.0213, 'lps'),
	(567012, 130, '2014-03-01 00:45:56.000000', 'consum', 0.0221, 'lps'),
	(567013, 130, '2014-03-01 00:45:57.000000', 'consum', 0.0219, 'lps'),
	(567014, 130, '2014-03-01 00:45:58.000000', 'consum', 0.0222, 'lps'),
	(567015, 130, '2014-03-01 00:45:59.000000', 'consum', 0.0224, 'lps'),
	(567016, 130, '2014-03-01 00:46:00.000000', 'consum', 0.0224, 'lps'),
	(567017, 130, '2014-03-01 00:46:01.000000', 'consum', 0.0221, 'lps'),
	(567018, 130, '2014-03-01 00:46:02.000000', 'consum', 0.0224, 'lps'),
	(567019, 130, '2014-03-01 00:46:03.000000', 'consum', 0.0210, 'lps'),
	(567020, 130, '2014-03-01 00:46:04.000000', 'consum', 0.0224, 'lps'),
	(567021, 130, '2014-03-01 00:46:05.000000', 'consum', 0.0226, 'lps'),
	(567022, 130, '2014-03-01 00:46:06.000000', 'consum', 0.0227, 'lps'),
	(567023, 130, '2014-03-01 00:46:07.000000', 'consum', 0.0211, 'lps'),
	(567024, 130, '2014-03-01 00:46:08.000000', 'consum', 0.0220, 'lps'),
	(567025, 130, '2014-03-01 00:46:09.000000', 'consum', 0.0221, 'lps'),
	(567026, 130, '2014-03-01 00:46:10.000000', 'consum', 0.0217, 'lps'),
	(567027, 130, '2014-03-01 00:46:11.000000', 'consum', 0.0212, 'lps'),
	(567028, 130, '2014-03-01 00:46:12.000000', 'consum', 0.0218, 'lps'),
	(567029, 130, '2014-03-01 00:46:13.000000', 'consum', 0.0226, 'lps'),
	(567030, 130, '2014-03-01 00:46:14.000000', 'consum', 0.0210, 'lps'),
	(567031, 130, '2014-03-01 00:46:15.000000', 'consum', 0.0221, 'lps'),
	(567032, 130, '2014-03-01 00:46:16.000000', 'consum', 0.0226, 'lps'),
	(567033, 130, '2014-03-01 00:46:17.000000', 'consum', 0.0219, 'lps'),
	(567034, 130, '2014-03-01 00:46:18.000000', 'consum', 0.0225, 'lps'),
	(567035, 130, '2014-03-01 00:46:19.000000', 'consum', 0.0221, 'lps'),
	(567036, 130, '2014-03-01 00:46:20.000000', 'consum', 0.0221, 'lps'),
	(567037, 130, '2014-03-01 00:46:21.000000', 'consum', 0.0212, 'lps'),
	(567038, 130, '2014-03-01 00:46:22.000000', 'consum', 0.0226, 'lps'),
	(567039, 130, '2014-03-01 00:46:23.000000', 'consum', 0.0226, 'lps'),
	(567040, 130, '2014-03-01 00:46:24.000000', 'consum', 0.0224, 'lps'),
	(567041, 130, '2014-03-01 00:46:25.000000', 'consum', 0.0215, 'lps'),
	(567042, 130, '2014-03-01 00:46:26.000000', 'consum', 0.0210, 'lps'),
	(567043, 130, '2014-03-01 00:46:27.000000', 'consum', 0.0215, 'lps'),
	(567044, 130, '2014-03-01 00:46:28.000000', 'consum', 0.0217, 'lps'),
	(567045, 130, '2014-03-01 00:46:29.000000', 'consum', 0.0211, 'lps'),
	(567046, 130, '2014-03-01 00:46:30.000000', 'consum', 0.0215, 'lps'),
	(567047, 130, '2014-03-01 00:46:31.000000', 'consum', 0.0215, 'lps'),
	(567048, 130, '2014-03-01 00:46:32.000000', 'consum', 0.0218, 'lps'),
	(567049, 130, '2014-03-01 00:46:33.000000', 'consum', 0.0216, 'lps'),
	(567050, 130, '2014-03-01 00:46:34.000000', 'consum', 0.0219, 'lps'),
	(567051, 130, '2014-03-01 00:46:35.000000', 'consum', 0.0219, 'lps'),
	(567052, 130, '2014-03-01 00:46:36.000000', 'consum', 0.0226, 'lps'),
	(567053, 130, '2014-03-01 00:46:37.000000', 'consum', 0.0227, 'lps'),
	(567054, 130, '2014-03-01 00:46:38.000000', 'consum', 0.0227, 'lps'),
	(567055, 130, '2014-03-01 00:46:39.000000', 'consum', 0.0227, 'lps'),
	(567056, 130, '2014-03-01 00:46:40.000000', 'consum', 0.0224, 'lps'),
	(567057, 130, '2014-03-01 00:46:41.000000', 'consum', 0.0213, 'lps'),
	(567058, 130, '2014-03-01 00:46:42.000000', 'consum', 0.0221, 'lps'),
	(567059, 130, '2014-03-01 00:46:43.000000', 'consum', 0.0216, 'lps'),
	(567060, 130, '2014-03-01 00:46:44.000000', 'consum', 0.0211, 'lps'),
	(567061, 130, '2014-03-01 00:46:45.000000', 'consum', 0.0214, 'lps'),
	(567062, 130, '2014-03-01 00:46:46.000000', 'consum', 0.0228, 'lps'),
	(567063, 130, '2014-03-01 00:46:47.000000', 'consum', 0.0214, 'lps'),
	(567064, 130, '2014-03-01 00:46:48.000000', 'consum', 0.0213, 'lps'),
	(567065, 130, '2014-03-01 00:46:49.000000', 'consum', 0.0215, 'lps'),
	(567066, 130, '2014-03-01 00:46:50.000000', 'consum', 0.0227, 'lps'),
	(567067, 130, '2014-03-01 00:46:51.000000', 'consum', 0.0223, 'lps'),
	(567068, 130, '2014-03-01 00:46:52.000000', 'consum', 0.0224, 'lps'),
	(567069, 130, '2014-03-01 00:46:53.000000', 'consum', 0.0222, 'lps'),
	(567070, 130, '2014-03-01 00:46:54.000000', 'consum', 0.0212, 'lps'),
	(567071, 130, '2014-03-01 00:46:55.000000', 'consum', 0.0221, 'lps'),
	(567072, 130, '2014-03-01 00:46:56.000000', 'consum', 0.0223, 'lps'),
	(567073, 130, '2014-03-01 00:46:57.000000', 'consum', 0.0220, 'lps'),
	(567074, 130, '2014-03-01 00:46:58.000000', 'consum', 0.0225, 'lps'),
	(567075, 130, '2014-03-01 00:46:59.000000', 'consum', 0.0218, 'lps'),
	(567076, 130, '2014-03-01 00:47:00.000000', 'consum', 0.0221, 'lps'),
	(567077, 130, '2014-03-01 00:47:01.000000', 'consum', 0.0225, 'lps'),
	(567078, 130, '2014-03-01 00:47:02.000000', 'consum', 0.0213, 'lps'),
	(567079, 130, '2014-03-01 00:47:03.000000', 'consum', 0.0220, 'lps'),
	(567080, 130, '2014-03-01 00:47:04.000000', 'consum', 0.0212, 'lps'),
	(567081, 130, '2014-03-01 00:47:05.000000', 'consum', 0.0211, 'lps'),
	(567082, 130, '2014-03-01 00:47:06.000000', 'consum', 0.0227, 'lps'),
	(567083, 130, '2014-03-01 00:47:07.000000', 'consum', 0.0216, 'lps'),
	(567084, 130, '2014-03-01 00:47:08.000000', 'consum', 0.0210, 'lps'),
	(567085, 130, '2014-03-01 00:47:09.000000', 'consum', 0.0212, 'lps'),
	(567086, 130, '2014-03-01 00:47:10.000000', 'consum', 0.0222, 'lps'),
	(567087, 130, '2014-03-01 00:47:11.000000', 'consum', 0.0224, 'lps'),
	(567088, 130, '2014-03-01 00:47:12.000000', 'consum', 0.0225, 'lps'),
	(567089, 130, '2014-03-01 00:47:13.000000', 'consum', 0.0224, 'lps'),
	(567090, 130, '2014-03-01 00:47:14.000000', 'consum', 0.0218, 'lps'),
	(567091, 130, '2014-03-01 00:47:15.000000', 'consum', 0.0227, 'lps'),
	(567092, 130, '2014-03-01 00:47:16.000000', 'consum', 0.0214, 'lps'),
	(567093, 130, '2014-03-01 00:47:17.000000', 'consum', 0.0219, 'lps'),
	(567094, 130, '2014-03-01 00:47:18.000000', 'consum', 0.0225, 'lps'),
	(567095, 130, '2014-03-01 00:47:19.000000', 'consum', 0.0219, 'lps'),
	(567096, 130, '2014-03-01 00:47:20.000000', 'consum', 0.0228, 'lps'),
	(567097, 130, '2014-03-01 00:47:21.000000', 'consum', 0.0217, 'lps'),
	(567098, 130, '2014-03-01 00:47:22.000000', 'consum', 0.0211, 'lps'),
	(567099, 130, '2014-03-01 00:47:23.000000', 'consum', 0.0215, 'lps'),
	(567100, 130, '2014-03-01 00:47:24.000000', 'consum', 0.0212, 'lps'),
	(567101, 130, '2014-03-01 00:47:25.000000', 'consum', 0.0223, 'lps'),
	(567102, 130, '2014-03-01 00:47:26.000000', 'consum', 0.0214, 'lps'),
	(567103, 130, '2014-03-01 00:47:27.000000', 'consum', 0.0211, 'lps'),
	(567104, 130, '2014-03-01 00:47:28.000000', 'consum', 0.0222, 'lps'),
	(567105, 130, '2014-03-01 00:47:29.000000', 'consum', 0.0211, 'lps'),
	(567106, 130, '2014-03-01 00:47:30.000000', 'consum', 0.0217, 'lps'),
	(567107, 130, '2014-03-01 00:47:31.000000', 'consum', 0.0224, 'lps'),
	(567108, 130, '2014-03-01 00:47:32.000000', 'consum', 0.0222, 'lps'),
	(567109, 130, '2014-03-01 00:47:33.000000', 'consum', 0.0228, 'lps'),
	(567110, 130, '2014-03-01 00:47:34.000000', 'consum', 0.0226, 'lps'),
	(567111, 130, '2014-03-01 00:47:35.000000', 'consum', 0.0220, 'lps'),
	(567112, 130, '2014-03-01 00:47:36.000000', 'consum', 0.0211, 'lps'),
	(567113, 130, '2014-03-01 00:47:37.000000', 'consum', 0.0222, 'lps'),
	(567114, 130, '2014-03-01 00:47:38.000000', 'consum', 0.0210, 'lps'),
	(567115, 130, '2014-03-01 00:47:39.000000', 'consum', 0.0213, 'lps'),
	(567116, 130, '2014-03-01 00:47:40.000000', 'consum', 0.0225, 'lps'),
	(567117, 130, '2014-03-01 00:47:41.000000', 'consum', 0.0219, 'lps'),
	(567118, 130, '2014-03-01 00:47:42.000000', 'consum', 0.0213, 'lps'),
	(567119, 130, '2014-03-01 00:47:43.000000', 'consum', 0.0216, 'lps'),
	(567120, 130, '2014-03-01 00:47:44.000000', 'consum', 0.0211, 'lps'),
	(567121, 130, '2014-03-01 00:47:45.000000', 'consum', 0.0217, 'lps'),
	(567122, 130, '2014-03-01 00:47:46.000000', 'consum', 0.0225, 'lps'),
	(567123, 130, '2014-03-01 00:47:47.000000', 'consum', 0.0227, 'lps'),
	(567124, 130, '2014-03-01 00:47:48.000000', 'consum', 0.0210, 'lps'),
	(567125, 130, '2014-03-01 00:47:49.000000', 'consum', 0.0216, 'lps'),
	(567126, 130, '2014-03-01 00:47:50.000000', 'consum', 0.0222, 'lps'),
	(567127, 130, '2014-03-01 00:47:51.000000', 'consum', 0.0216, 'lps'),
	(567128, 130, '2014-03-01 00:47:52.000000', 'consum', 0.0224, 'lps'),
	(567129, 130, '2014-03-01 00:47:53.000000', 'consum', 0.0224, 'lps'),
	(567130, 130, '2014-03-01 00:47:54.000000', 'consum', 0.0218, 'lps'),
	(567131, 130, '2014-03-01 00:47:55.000000', 'consum', 0.0211, 'lps'),
	(567132, 130, '2014-03-01 00:47:56.000000', 'consum', 0.0227, 'lps'),
	(567133, 130, '2014-03-01 00:47:57.000000', 'consum', 0.0216, 'lps'),
	(567134, 130, '2014-03-01 00:47:58.000000', 'consum', 0.0227, 'lps'),
	(567135, 130, '2014-03-01 00:47:59.000000', 'consum', 0.0220, 'lps'),
	(567136, 130, '2014-03-01 00:48:00.000000', 'consum', 0.0211, 'lps'),
	(567137, 130, '2014-03-01 00:48:01.000000', 'consum', 0.0223, 'lps'),
	(567138, 130, '2014-03-01 00:48:02.000000', 'consum', 0.0215, 'lps'),
	(567139, 130, '2014-03-01 00:48:03.000000', 'consum', 0.0216, 'lps'),
	(567140, 130, '2014-03-01 00:48:04.000000', 'consum', 0.0227, 'lps'),
	(567141, 130, '2014-03-01 00:48:05.000000', 'consum', 0.0218, 'lps'),
	(567142, 130, '2014-03-01 00:48:06.000000', 'consum', 0.0219, 'lps'),
	(567143, 130, '2014-03-01 00:48:07.000000', 'consum', 0.0213, 'lps'),
	(567144, 130, '2014-03-01 00:48:08.000000', 'consum', 0.0218, 'lps'),
	(567145, 130, '2014-03-01 00:48:09.000000', 'consum', 0.0220, 'lps'),
	(567146, 130, '2014-03-01 00:48:10.000000', 'consum', 0.0221, 'lps'),
	(567147, 130, '2014-03-01 00:48:11.000000', 'consum', 0.0214, 'lps'),
	(567148, 130, '2014-03-01 00:48:12.000000', 'consum', 0.0218, 'lps'),
	(567149, 130, '2014-03-01 00:48:13.000000', 'consum', 0.0221, 'lps'),
	(567150, 130, '2014-03-01 00:48:14.000000', 'consum', 0.0219, 'lps'),
	(567151, 130, '2014-03-01 00:48:15.000000', 'consum', 0.0224, 'lps'),
	(567152, 130, '2014-03-01 00:48:16.000000', 'consum', 0.0217, 'lps'),
	(567153, 130, '2014-03-01 00:48:17.000000', 'consum', 0.0220, 'lps'),
	(567154, 130, '2014-03-01 00:48:18.000000', 'consum', 0.0222, 'lps'),
	(567155, 130, '2014-03-01 00:48:19.000000', 'consum', 0.0220, 'lps'),
	(567156, 130, '2014-03-01 00:48:20.000000', 'consum', 0.0226, 'lps'),
	(567157, 130, '2014-03-01 00:48:21.000000', 'consum', 0.0223, 'lps'),
	(567158, 130, '2014-03-01 00:48:22.000000', 'consum', 0.0225, 'lps'),
	(567159, 130, '2014-03-01 00:48:23.000000', 'consum', 0.0211, 'lps'),
	(567160, 130, '2014-03-01 00:48:24.000000', 'consum', 0.0225, 'lps'),
	(567161, 130, '2014-03-01 00:48:25.000000', 'consum', 0.0226, 'lps'),
	(567162, 130, '2014-03-01 00:48:26.000000', 'consum', 0.0228, 'lps'),
	(567163, 130, '2014-03-01 00:48:27.000000', 'consum', 0.0215, 'lps'),
	(567164, 130, '2014-03-01 00:48:28.000000', 'consum', 0.0217, 'lps'),
	(567165, 130, '2014-03-01 00:48:29.000000', 'consum', 0.0214, 'lps'),
	(567166, 130, '2014-03-01 00:48:30.000000', 'consum', 0.0228, 'lps'),
	(567167, 130, '2014-03-01 00:48:31.000000', 'consum', 0.0211, 'lps'),
	(567168, 130, '2014-03-01 00:48:32.000000', 'consum', 0.0220, 'lps'),
	(567169, 130, '2014-03-01 00:48:33.000000', 'consum', 0.0220, 'lps'),
	(567170, 130, '2014-03-01 00:48:34.000000', 'consum', 0.0213, 'lps'),
	(567171, 130, '2014-03-01 00:48:35.000000', 'consum', 0.0211, 'lps'),
	(567172, 130, '2014-03-01 00:48:36.000000', 'consum', 0.0226, 'lps'),
	(567173, 130, '2014-03-01 00:48:37.000000', 'consum', 0.0214, 'lps'),
	(567174, 130, '2014-03-01 00:48:38.000000', 'consum', 0.0219, 'lps'),
	(567175, 130, '2014-03-01 00:48:39.000000', 'consum', 0.0225, 'lps'),
	(567176, 130, '2014-03-01 00:48:40.000000', 'consum', 0.0219, 'lps'),
	(567177, 130, '2014-03-01 00:48:41.000000', 'consum', 0.0213, 'lps'),
	(567178, 130, '2014-03-01 00:48:42.000000', 'consum', 0.0217, 'lps'),
	(567179, 130, '2014-03-01 00:48:43.000000', 'consum', 0.0215, 'lps'),
	(567180, 130, '2014-03-01 00:48:44.000000', 'consum', 0.0216, 'lps'),
	(567181, 130, '2014-03-01 00:48:45.000000', 'consum', 0.0227, 'lps'),
	(567182, 130, '2014-03-01 00:48:46.000000', 'consum', 0.0220, 'lps'),
	(567183, 130, '2014-03-01 00:48:47.000000', 'consum', 0.0228, 'lps'),
	(567184, 130, '2014-03-01 00:48:48.000000', 'consum', 0.0213, 'lps'),
	(567185, 130, '2014-03-01 00:48:49.000000', 'consum', 0.0228, 'lps'),
	(567186, 130, '2014-03-01 00:48:50.000000', 'consum', 0.0217, 'lps'),
	(567187, 130, '2014-03-01 00:48:51.000000', 'consum', 0.0227, 'lps'),
	(567188, 130, '2014-03-01 00:48:52.000000', 'consum', 0.0219, 'lps'),
	(567189, 130, '2014-03-01 00:48:53.000000', 'consum', 0.0224, 'lps'),
	(567190, 130, '2014-03-01 00:48:54.000000', 'consum', 0.0213, 'lps'),
	(567191, 130, '2014-03-01 00:48:55.000000', 'consum', 0.0225, 'lps'),
	(567192, 130, '2014-03-01 00:48:56.000000', 'consum', 0.0217, 'lps'),
	(567193, 130, '2014-03-01 00:48:57.000000', 'consum', 0.0220, 'lps'),
	(567194, 130, '2014-03-01 00:48:58.000000', 'consum', 0.0220, 'lps'),
	(567195, 130, '2014-03-01 00:48:59.000000', 'consum', 0.0213, 'lps'),
	(567196, 130, '2014-03-01 00:49:00.000000', 'consum', 0.0213, 'lps'),
	(567197, 130, '2014-03-01 00:49:01.000000', 'consum', 0.0216, 'lps'),
	(567198, 130, '2014-03-01 00:49:02.000000', 'consum', 0.0214, 'lps'),
	(567199, 130, '2014-03-01 00:49:03.000000', 'consum', 0.0211, 'lps'),
	(567200, 130, '2014-03-01 00:49:04.000000', 'consum', 0.0223, 'lps'),
	(567201, 130, '2014-03-01 00:49:05.000000', 'consum', 0.0215, 'lps'),
	(567202, 130, '2014-03-01 00:49:06.000000', 'consum', 0.0214, 'lps'),
	(567203, 130, '2014-03-01 00:49:07.000000', 'consum', 0.0219, 'lps'),
	(567204, 130, '2014-03-01 00:49:08.000000', 'consum', 0.0223, 'lps'),
	(567205, 130, '2014-03-01 00:49:09.000000', 'consum', 0.0210, 'lps'),
	(567206, 130, '2014-03-01 00:49:10.000000', 'consum', 0.0210, 'lps'),
	(567207, 130, '2014-03-01 00:49:11.000000', 'consum', 0.0212, 'lps'),
	(567208, 130, '2014-03-01 00:49:12.000000', 'consum', 0.0219, 'lps'),
	(567209, 130, '2014-03-01 00:49:13.000000', 'consum', 0.0212, 'lps'),
	(567210, 130, '2014-03-01 00:49:14.000000', 'consum', 0.0212, 'lps'),
	(567211, 130, '2014-03-01 00:49:15.000000', 'consum', 0.0217, 'lps'),
	(567212, 130, '2014-03-01 00:49:16.000000', 'consum', 0.0217, 'lps'),
	(567213, 130, '2014-03-01 00:49:17.000000', 'consum', 0.0227, 'lps'),
	(567214, 130, '2014-03-01 00:49:18.000000', 'consum', 0.0218, 'lps'),
	(567215, 130, '2014-03-01 00:49:19.000000', 'consum', 0.0220, 'lps'),
	(567216, 130, '2014-03-01 00:49:20.000000', 'consum', 0.0214, 'lps'),
	(567217, 130, '2014-03-01 00:49:21.000000', 'consum', 0.0219, 'lps'),
	(567218, 130, '2014-03-01 00:49:22.000000', 'consum', 0.0227, 'lps'),
	(567219, 130, '2014-03-01 00:49:23.000000', 'consum', 0.0212, 'lps'),
	(567220, 130, '2014-03-01 00:49:24.000000', 'consum', 0.0227, 'lps'),
	(567221, 130, '2014-03-01 00:49:25.000000', 'consum', 0.0214, 'lps'),
	(567222, 130, '2014-03-01 00:49:26.000000', 'consum', 0.0217, 'lps'),
	(567223, 130, '2014-03-01 00:49:27.000000', 'consum', 0.0213, 'lps'),
	(567224, 130, '2014-03-01 00:49:28.000000', 'consum', 0.0223, 'lps'),
	(567225, 130, '2014-03-01 00:49:29.000000', 'consum', 0.0212, 'lps'),
	(567226, 130, '2014-03-01 00:49:30.000000', 'consum', 0.0219, 'lps'),
	(567227, 130, '2014-03-01 00:49:31.000000', 'consum', 0.0211, 'lps'),
	(567228, 130, '2014-03-01 00:49:32.000000', 'consum', 0.0225, 'lps'),
	(567229, 130, '2014-03-01 00:49:33.000000', 'consum', 0.0210, 'lps'),
	(567230, 130, '2014-03-01 00:49:34.000000', 'consum', 0.0219, 'lps'),
	(567231, 130, '2014-03-01 00:49:35.000000', 'consum', 0.0219, 'lps'),
	(567232, 130, '2014-03-01 00:49:36.000000', 'consum', 0.0227, 'lps'),
	(567233, 130, '2014-03-01 00:49:37.000000', 'consum', 0.0211, 'lps'),
	(567234, 130, '2014-03-01 00:49:38.000000', 'consum', 0.0223, 'lps'),
	(567235, 130, '2014-03-01 00:49:39.000000', 'consum', 0.0215, 'lps'),
	(567236, 130, '2014-03-01 00:49:40.000000', 'consum', 0.0216, 'lps'),
	(567237, 130, '2014-03-01 00:49:41.000000', 'consum', 0.0227, 'lps'),
	(567238, 130, '2014-03-01 00:49:42.000000', 'consum', 0.0219, 'lps'),
	(567239, 130, '2014-03-01 00:49:43.000000', 'consum', 0.0224, 'lps'),
	(567240, 130, '2014-03-01 00:49:44.000000', 'consum', 0.0217, 'lps'),
	(567241, 130, '2014-03-01 00:49:45.000000', 'consum', 0.0220, 'lps'),
	(567242, 130, '2014-03-01 00:49:46.000000', 'consum', 0.0224, 'lps'),
	(567243, 130, '2014-03-01 00:49:47.000000', 'consum', 0.0228, 'lps'),
	(567244, 130, '2014-03-01 00:49:48.000000', 'consum', 0.0220, 'lps'),
	(567245, 130, '2014-03-01 00:49:49.000000', 'consum', 0.0227, 'lps'),
	(567246, 130, '2014-03-01 00:49:50.000000', 'consum', 0.0210, 'lps'),
	(567247, 130, '2014-03-01 00:49:51.000000', 'consum', 0.0214, 'lps'),
	(567248, 130, '2014-03-01 00:49:52.000000', 'consum', 0.0211, 'lps'),
	(567249, 130, '2014-03-01 00:49:53.000000', 'consum', 0.0223, 'lps'),
	(567250, 130, '2014-03-01 00:49:54.000000', 'consum', 0.0216, 'lps'),
	(567251, 130, '2014-03-01 00:49:55.000000', 'consum', 0.0221, 'lps'),
	(567252, 130, '2014-03-01 00:49:56.000000', 'consum', 0.0211, 'lps'),
	(567253, 130, '2014-03-01 00:49:57.000000', 'consum', 0.0220, 'lps'),
	(567254, 130, '2014-03-01 00:49:58.000000', 'consum', 0.0218, 'lps'),
	(567255, 130, '2014-03-01 00:49:59.000000', 'consum', 0.0221, 'lps'),
	(567256, 130, '2014-03-01 00:50:00.000000', 'consum', 0.0221, 'lps'),
	(567257, 130, '2014-03-01 00:50:01.000000', 'consum', 0.0214, 'lps'),
	(567258, 130, '2014-03-01 00:50:02.000000', 'consum', 0.0219, 'lps'),
	(567259, 130, '2014-03-01 00:50:03.000000', 'consum', 0.0222, 'lps'),
	(567260, 130, '2014-03-01 00:50:04.000000', 'consum', 0.0224, 'lps'),
	(567261, 130, '2014-03-01 00:50:05.000000', 'consum', 0.0228, 'lps'),
	(567262, 130, '2014-03-01 00:50:06.000000', 'consum', 0.0219, 'lps'),
	(567263, 130, '2014-03-01 00:50:07.000000', 'consum', 0.0219, 'lps'),
	(567264, 130, '2014-03-01 00:50:08.000000', 'consum', 0.0210, 'lps'),
	(567265, 130, '2014-03-01 00:50:09.000000', 'consum', 0.0223, 'lps'),
	(567266, 130, '2014-03-01 00:50:10.000000', 'consum', 0.0219, 'lps'),
	(567267, 130, '2014-03-01 00:50:11.000000', 'consum', 0.0215, 'lps'),
	(567268, 130, '2014-03-01 00:50:12.000000', 'consum', 0.0210, 'lps'),
	(567269, 130, '2014-03-01 00:50:13.000000', 'consum', 0.0214, 'lps'),
	(567270, 130, '2014-03-01 00:50:14.000000', 'consum', 0.0228, 'lps'),
	(567271, 130, '2014-03-01 00:50:15.000000', 'consum', 0.0216, 'lps'),
	(567272, 130, '2014-03-01 00:50:16.000000', 'consum', 0.0222, 'lps'),
	(567273, 130, '2014-03-01 00:50:17.000000', 'consum', 0.0214, 'lps'),
	(567274, 130, '2014-03-01 00:50:18.000000', 'consum', 0.0215, 'lps'),
	(567275, 130, '2014-03-01 00:50:19.000000', 'consum', 0.0225, 'lps'),
	(567276, 130, '2014-03-01 00:50:20.000000', 'consum', 0.0211, 'lps'),
	(567277, 130, '2014-03-01 00:50:21.000000', 'consum', 0.0211, 'lps'),
	(567278, 130, '2014-03-01 00:50:22.000000', 'consum', 0.0212, 'lps'),
	(567279, 130, '2014-03-01 00:50:23.000000', 'consum', 0.0215, 'lps'),
	(567280, 130, '2014-03-01 00:50:24.000000', 'consum', 0.0213, 'lps'),
	(567281, 130, '2014-03-01 00:50:25.000000', 'consum', 0.0210, 'lps'),
	(567282, 130, '2014-03-01 00:50:26.000000', 'consum', 0.0222, 'lps'),
	(567283, 130, '2014-03-01 00:50:27.000000', 'consum', 0.0211, 'lps'),
	(567284, 130, '2014-03-01 00:50:28.000000', 'consum', 0.0216, 'lps'),
	(567285, 130, '2014-03-01 00:50:29.000000', 'consum', 0.0222, 'lps'),
	(567286, 130, '2014-03-01 00:50:30.000000', 'consum', 0.0215, 'lps'),
	(567287, 130, '2014-03-01 00:50:31.000000', 'consum', 0.0216, 'lps'),
	(567288, 130, '2014-03-01 00:50:32.000000', 'consum', 0.0225, 'lps'),
	(567289, 130, '2014-03-01 00:50:33.000000', 'consum', 0.0211, 'lps'),
	(567290, 130, '2014-03-01 00:50:34.000000', 'consum', 0.0227, 'lps'),
	(567291, 130, '2014-03-01 00:50:35.000000', 'consum', 0.0218, 'lps'),
	(567292, 130, '2014-03-01 00:50:36.000000', 'consum', 0.0219, 'lps'),
	(567293, 130, '2014-03-01 00:50:37.000000', 'consum', 0.0212, 'lps'),
	(567294, 130, '2014-03-01 00:50:38.000000', 'consum', 0.0212, 'lps'),
	(567295, 130, '2014-03-01 00:50:39.000000', 'consum', 0.0214, 'lps'),
	(567296, 130, '2014-03-01 00:50:40.000000', 'consum', 0.0225, 'lps'),
	(567297, 130, '2014-03-01 00:50:41.000000', 'consum', 0.0216, 'lps'),
	(567298, 130, '2014-03-01 00:50:42.000000', 'consum', 0.0214, 'lps'),
	(567299, 130, '2014-03-01 00:50:43.000000', 'consum', 0.0213, 'lps'),
	(567300, 130, '2014-03-01 00:50:44.000000', 'consum', 0.0215, 'lps'),
	(567301, 130, '2014-03-01 00:50:45.000000', 'consum', 0.0224, 'lps'),
	(567302, 130, '2014-03-01 00:50:46.000000', 'consum', 0.0210, 'lps'),
	(567303, 130, '2014-03-01 00:50:47.000000', 'consum', 0.0225, 'lps'),
	(567304, 130, '2014-03-01 00:50:48.000000', 'consum', 0.0211, 'lps'),
	(567305, 130, '2014-03-01 00:50:49.000000', 'consum', 0.0226, 'lps'),
	(567306, 130, '2014-03-01 00:50:50.000000', 'consum', 0.0212, 'lps'),
	(567307, 130, '2014-03-01 00:50:51.000000', 'consum', 0.0211, 'lps'),
	(567308, 130, '2014-03-01 00:50:52.000000', 'consum', 0.0228, 'lps'),
	(567309, 130, '2014-03-01 00:50:53.000000', 'consum', 0.0223, 'lps'),
	(567310, 130, '2014-03-01 00:50:54.000000', 'consum', 0.0220, 'lps'),
	(567311, 130, '2014-03-01 00:50:55.000000', 'consum', 0.0223, 'lps'),
	(567312, 130, '2014-03-01 00:50:56.000000', 'consum', 0.0225, 'lps'),
	(567313, 130, '2014-03-01 00:50:57.000000', 'consum', 0.0226, 'lps'),
	(567314, 130, '2014-03-01 00:50:58.000000', 'consum', 0.0211, 'lps'),
	(567315, 130, '2014-03-01 00:50:59.000000', 'consum', 0.0222, 'lps'),
	(567316, 130, '2014-03-01 00:51:00.000000', 'consum', 0.0211, 'lps'),
	(567317, 130, '2014-03-01 00:51:01.000000', 'consum', 0.0220, 'lps'),
	(567318, 130, '2014-03-01 00:51:02.000000', 'consum', 0.0217, 'lps'),
	(567319, 130, '2014-03-01 00:51:03.000000', 'consum', 0.0215, 'lps'),
	(567320, 130, '2014-03-01 00:51:04.000000', 'consum', 0.0217, 'lps'),
	(567321, 130, '2014-03-01 00:51:05.000000', 'consum', 0.0212, 'lps'),
	(567322, 130, '2014-03-01 00:51:06.000000', 'consum', 0.0215, 'lps'),
	(567323, 130, '2014-03-01 00:51:07.000000', 'consum', 0.0214, 'lps'),
	(567324, 130, '2014-03-01 00:51:08.000000', 'consum', 0.0215, 'lps'),
	(567325, 130, '2014-03-01 00:51:09.000000', 'consum', 0.0224, 'lps'),
	(567326, 130, '2014-03-01 00:51:10.000000', 'consum', 0.0227, 'lps'),
	(567327, 130, '2014-03-01 00:51:11.000000', 'consum', 0.0216, 'lps'),
	(567328, 130, '2014-03-01 00:51:12.000000', 'consum', 0.0210, 'lps'),
	(567329, 130, '2014-03-01 00:51:13.000000', 'consum', 0.0227, 'lps'),
	(567330, 130, '2014-03-01 00:51:14.000000', 'consum', 0.0223, 'lps'),
	(567331, 130, '2014-03-01 00:51:15.000000', 'consum', 0.0223, 'lps'),
	(567332, 130, '2014-03-01 00:51:16.000000', 'consum', 0.0217, 'lps'),
	(567333, 130, '2014-03-01 00:51:17.000000', 'consum', 0.0225, 'lps'),
	(567334, 130, '2014-03-01 00:51:18.000000', 'consum', 0.0227, 'lps'),
	(567335, 130, '2014-03-01 00:51:19.000000', 'consum', 0.0212, 'lps'),
	(567336, 130, '2014-03-01 00:51:20.000000', 'consum', 0.0225, 'lps'),
	(567337, 130, '2014-03-01 00:51:21.000000', 'consum', 0.0223, 'lps'),
	(567338, 130, '2014-03-01 00:51:22.000000', 'consum', 0.0212, 'lps'),
	(567339, 130, '2014-03-01 00:51:23.000000', 'consum', 0.0220, 'lps'),
	(567340, 130, '2014-03-01 00:51:24.000000', 'consum', 0.0218, 'lps'),
	(567341, 130, '2014-03-01 00:51:25.000000', 'consum', 0.0218, 'lps'),
	(567342, 130, '2014-03-01 00:51:26.000000', 'consum', 0.0226, 'lps'),
	(567343, 130, '2014-03-01 00:51:27.000000', 'consum', 0.0212, 'lps'),
	(567344, 130, '2014-03-01 00:51:28.000000', 'consum', 0.0211, 'lps'),
	(567345, 130, '2014-03-01 00:51:29.000000', 'consum', 0.0228, 'lps'),
	(567346, 130, '2014-03-01 00:51:30.000000', 'consum', 0.0220, 'lps'),
	(567347, 130, '2014-03-01 00:51:31.000000', 'consum', 0.0226, 'lps'),
	(567348, 130, '2014-03-01 00:51:32.000000', 'consum', 0.0224, 'lps'),
	(567349, 130, '2014-03-01 00:51:33.000000', 'consum', 0.0212, 'lps'),
	(567350, 130, '2014-03-01 00:51:34.000000', 'consum', 0.0218, 'lps'),
	(567351, 130, '2014-03-01 00:51:35.000000', 'consum', 0.0223, 'lps'),
	(567352, 130, '2014-03-01 00:51:36.000000', 'consum', 0.0213, 'lps'),
	(567353, 130, '2014-03-01 00:51:37.000000', 'consum', 0.0226, 'lps'),
	(567354, 130, '2014-03-01 00:51:38.000000', 'consum', 0.0225, 'lps'),
	(567355, 130, '2014-03-01 00:51:39.000000', 'consum', 0.0217, 'lps'),
	(567356, 130, '2014-03-01 00:51:40.000000', 'consum', 0.0219, 'lps'),
	(567357, 130, '2014-03-01 00:51:41.000000', 'consum', 0.0216, 'lps'),
	(567358, 130, '2014-03-01 00:51:42.000000', 'consum', 0.0215, 'lps'),
	(567359, 130, '2014-03-01 00:51:43.000000', 'consum', 0.0215, 'lps'),
	(567360, 130, '2014-03-01 00:51:44.000000', 'consum', 0.0224, 'lps'),
	(567361, 130, '2014-03-01 00:51:45.000000', 'consum', 0.0225, 'lps'),
	(567362, 130, '2014-03-01 00:51:46.000000', 'consum', 0.0224, 'lps'),
	(567363, 130, '2014-03-01 00:51:47.000000', 'consum', 0.0216, 'lps'),
	(567364, 130, '2014-03-01 00:51:48.000000', 'consum', 0.0219, 'lps'),
	(567365, 130, '2014-03-01 00:51:49.000000', 'consum', 0.0216, 'lps'),
	(567366, 130, '2014-03-01 00:51:50.000000', 'consum', 0.0215, 'lps'),
	(567367, 130, '2014-03-01 00:51:51.000000', 'consum', 0.0217, 'lps'),
	(567368, 130, '2014-03-01 00:51:52.000000', 'consum', 0.0214, 'lps'),
	(567369, 130, '2014-03-01 00:51:53.000000', 'consum', 0.0225, 'lps'),
	(567370, 130, '2014-03-01 00:51:54.000000', 'consum', 0.0219, 'lps'),
	(567371, 130, '2014-03-01 00:51:55.000000', 'consum', 0.0210, 'lps'),
	(567372, 130, '2014-03-01 00:51:56.000000', 'consum', 0.0222, 'lps'),
	(567373, 130, '2014-03-01 00:51:57.000000', 'consum', 0.0213, 'lps'),
	(567374, 130, '2014-03-01 00:51:58.000000', 'consum', 0.0226, 'lps'),
	(567375, 130, '2014-03-01 00:51:59.000000', 'consum', 0.0227, 'lps'),
	(567376, 130, '2014-03-01 00:52:00.000000', 'consum', 0.0226, 'lps'),
	(567377, 130, '2014-03-01 00:52:01.000000', 'consum', 0.0221, 'lps'),
	(567378, 130, '2014-03-01 00:52:02.000000', 'consum', 0.0219, 'lps'),
	(567379, 130, '2014-03-01 00:52:03.000000', 'consum', 0.0223, 'lps'),
	(567380, 130, '2014-03-01 00:52:04.000000', 'consum', 0.0227, 'lps'),
	(567381, 130, '2014-03-01 00:52:05.000000', 'consum', 0.0221, 'lps'),
	(567382, 130, '2014-03-01 00:52:06.000000', 'consum', 0.0213, 'lps'),
	(567383, 130, '2014-03-01 00:52:07.000000', 'consum', 0.0212, 'lps'),
	(567384, 130, '2014-03-01 00:52:08.000000', 'consum', 0.0212, 'lps'),
	(567385, 130, '2014-03-01 00:52:09.000000', 'consum', 0.0214, 'lps'),
	(567386, 130, '2014-03-01 00:52:10.000000', 'consum', 0.0225, 'lps'),
	(567387, 130, '2014-03-01 00:52:11.000000', 'consum', 0.0215, 'lps'),
	(567388, 130, '2014-03-01 00:52:12.000000', 'consum', 0.0212, 'lps'),
	(567389, 130, '2014-03-01 00:52:13.000000', 'consum', 0.0224, 'lps'),
	(567390, 130, '2014-03-01 00:52:14.000000', 'consum', 0.0218, 'lps'),
	(567391, 130, '2014-03-01 00:52:15.000000', 'consum', 0.0210, 'lps'),
	(567392, 130, '2014-03-01 00:52:16.000000', 'consum', 0.0221, 'lps'),
	(567393, 130, '2014-03-01 00:52:17.000000', 'consum', 0.0211, 'lps'),
	(567394, 130, '2014-03-01 00:52:18.000000', 'consum', 0.0220, 'lps'),
	(567395, 130, '2014-03-01 00:52:19.000000', 'consum', 0.0221, 'lps'),
	(567396, 130, '2014-03-01 00:52:20.000000', 'consum', 0.0215, 'lps'),
	(567397, 130, '2014-03-01 00:52:21.000000', 'consum', 0.0222, 'lps'),
	(567398, 130, '2014-03-01 00:52:22.000000', 'consum', 0.0216, 'lps'),
	(567399, 130, '2014-03-01 00:52:23.000000', 'consum', 0.0226, 'lps'),
	(567400, 130, '2014-03-01 00:52:24.000000', 'consum', 0.0213, 'lps'),
	(567401, 130, '2014-03-01 00:52:25.000000', 'consum', 0.0216, 'lps'),
	(567402, 130, '2014-03-01 00:52:26.000000', 'consum', 0.0213, 'lps'),
	(567403, 130, '2014-03-01 00:52:27.000000', 'consum', 0.0227, 'lps'),
	(567404, 130, '2014-03-01 00:52:28.000000', 'consum', 0.0211, 'lps'),
	(567405, 130, '2014-03-01 00:52:29.000000', 'consum', 0.0221, 'lps'),
	(567406, 130, '2014-03-01 00:52:30.000000', 'consum', 0.0226, 'lps'),
	(567407, 130, '2014-03-01 00:52:31.000000', 'consum', 0.0217, 'lps'),
	(567408, 130, '2014-03-01 00:52:32.000000', 'consum', 0.0219, 'lps'),
	(567409, 130, '2014-03-01 00:52:33.000000', 'consum', 0.0216, 'lps'),
	(567410, 130, '2014-03-01 00:52:34.000000', 'consum', 0.0212, 'lps'),
	(567411, 130, '2014-03-01 00:52:35.000000', 'consum', 0.0221, 'lps'),
	(567412, 130, '2014-03-01 00:52:36.000000', 'consum', 0.0224, 'lps'),
	(567413, 130, '2014-03-01 00:52:37.000000', 'consum', 0.0226, 'lps'),
	(567414, 130, '2014-03-01 00:52:38.000000', 'consum', 0.0212, 'lps'),
	(567415, 130, '2014-03-01 00:52:39.000000', 'consum', 0.0228, 'lps'),
	(567416, 130, '2014-03-01 00:52:40.000000', 'consum', 0.0221, 'lps'),
	(567417, 130, '2014-03-01 00:52:41.000000', 'consum', 0.0227, 'lps'),
	(567418, 130, '2014-03-01 00:52:42.000000', 'consum', 0.0227, 'lps'),
	(567419, 130, '2014-03-01 00:52:43.000000', 'consum', 0.0226, 'lps'),
	(567420, 130, '2014-03-01 00:52:44.000000', 'consum', 0.0220, 'lps'),
	(567421, 130, '2014-03-01 00:52:45.000000', 'consum', 0.0214, 'lps'),
	(567422, 130, '2014-03-01 00:52:46.000000', 'consum', 0.0217, 'lps'),
	(567423, 130, '2014-03-01 00:52:47.000000', 'consum', 0.0217, 'lps'),
	(567424, 130, '2014-03-01 00:52:48.000000', 'consum', 0.0222, 'lps'),
	(567425, 130, '2014-03-01 00:52:49.000000', 'consum', 0.0212, 'lps'),
	(567426, 130, '2014-03-01 00:52:50.000000', 'consum', 0.0225, 'lps'),
	(567427, 130, '2014-03-01 00:52:51.000000', 'consum', 0.0220, 'lps'),
	(567428, 130, '2014-03-01 00:52:52.000000', 'consum', 0.0216, 'lps'),
	(567429, 130, '2014-03-01 00:52:53.000000', 'consum', 0.0211, 'lps'),
	(567430, 130, '2014-03-01 00:52:54.000000', 'consum', 0.0215, 'lps'),
	(567431, 130, '2014-03-01 00:52:55.000000', 'consum', 0.0214, 'lps'),
	(567432, 130, '2014-03-01 00:52:56.000000', 'consum', 0.0216, 'lps'),
	(567433, 130, '2014-03-01 00:52:57.000000', 'consum', 0.0226, 'lps'),
	(567434, 130, '2014-03-01 00:52:58.000000', 'consum', 0.0218, 'lps'),
	(567435, 130, '2014-03-01 00:52:59.000000', 'consum', 0.0223, 'lps'),
	(567436, 130, '2014-03-01 00:53:00.000000', 'consum', 0.0210, 'lps'),
	(567437, 130, '2014-03-01 00:53:01.000000', 'consum', 0.0213, 'lps'),
	(567438, 130, '2014-03-01 00:53:02.000000', 'consum', 0.0222, 'lps'),
	(567439, 130, '2014-03-01 00:53:03.000000', 'consum', 0.0227, 'lps'),
	(567440, 130, '2014-03-01 00:53:04.000000', 'consum', 0.0220, 'lps'),
	(567441, 130, '2014-03-01 00:53:05.000000', 'consum', 0.0227, 'lps'),
	(567442, 130, '2014-03-01 00:53:06.000000', 'consum', 0.0212, 'lps'),
	(567443, 130, '2014-03-01 00:53:07.000000', 'consum', 0.0223, 'lps'),
	(567444, 130, '2014-03-01 00:53:08.000000', 'consum', 0.0214, 'lps'),
	(567445, 130, '2014-03-01 00:53:09.000000', 'consum', 0.0211, 'lps'),
	(567446, 130, '2014-03-01 00:53:10.000000', 'consum', 0.0222, 'lps'),
	(567447, 130, '2014-03-01 00:53:11.000000', 'consum', 0.0228, 'lps'),
	(567448, 130, '2014-03-01 00:53:12.000000', 'consum', 0.0228, 'lps'),
	(567449, 130, '2014-03-01 00:53:13.000000', 'consum', 0.0225, 'lps'),
	(567450, 130, '2014-03-01 00:53:14.000000', 'consum', 0.0215, 'lps'),
	(567451, 130, '2014-03-01 00:53:15.000000', 'consum', 0.0227, 'lps'),
	(567452, 130, '2014-03-01 00:53:16.000000', 'consum', 0.0223, 'lps'),
	(567453, 130, '2014-03-01 00:53:17.000000', 'consum', 0.0224, 'lps'),
	(567454, 130, '2014-03-01 00:53:18.000000', 'consum', 0.0224, 'lps'),
	(567455, 130, '2014-03-01 00:53:19.000000', 'consum', 0.0217, 'lps'),
	(567456, 130, '2014-03-01 00:53:20.000000', 'consum', 0.0224, 'lps'),
	(567457, 130, '2014-03-01 00:53:21.000000', 'consum', 0.0223, 'lps'),
	(567458, 130, '2014-03-01 00:53:22.000000', 'consum', 0.0212, 'lps'),
	(567459, 130, '2014-03-01 00:53:23.000000', 'consum', 0.0219, 'lps'),
	(567460, 130, '2014-03-01 00:53:24.000000', 'consum', 0.0213, 'lps'),
	(567461, 130, '2014-03-01 00:53:25.000000', 'consum', 0.0217, 'lps'),
	(567462, 130, '2014-03-01 00:53:26.000000', 'consum', 0.0216, 'lps'),
	(567463, 130, '2014-03-01 00:53:27.000000', 'consum', 0.0221, 'lps'),
	(567464, 130, '2014-03-01 00:53:28.000000', 'consum', 0.0210, 'lps'),
	(567465, 130, '2014-03-01 00:53:29.000000', 'consum', 0.0215, 'lps'),
	(567466, 130, '2014-03-01 00:53:30.000000', 'consum', 0.0217, 'lps'),
	(567467, 130, '2014-03-01 00:53:31.000000', 'consum', 0.0213, 'lps'),
	(567468, 130, '2014-03-01 00:53:32.000000', 'consum', 0.0222, 'lps'),
	(567469, 130, '2014-03-01 00:53:33.000000', 'consum', 0.0225, 'lps'),
	(567470, 130, '2014-03-01 00:53:34.000000', 'consum', 0.0228, 'lps'),
	(567471, 130, '2014-03-01 00:53:35.000000', 'consum', 0.0218, 'lps'),
	(567472, 130, '2014-03-01 00:53:36.000000', 'consum', 0.0215, 'lps'),
	(567473, 130, '2014-03-01 00:53:37.000000', 'consum', 0.0213, 'lps'),
	(567474, 130, '2014-03-01 00:53:38.000000', 'consum', 0.0211, 'lps'),
	(567475, 130, '2014-03-01 00:53:39.000000', 'consum', 0.0226, 'lps'),
	(567476, 130, '2014-03-01 00:53:40.000000', 'consum', 0.0212, 'lps'),
	(567477, 130, '2014-03-01 00:53:41.000000', 'consum', 0.0228, 'lps'),
	(567478, 130, '2014-03-01 00:53:42.000000', 'consum', 0.0221, 'lps'),
	(567479, 130, '2014-03-01 00:53:43.000000', 'consum', 0.0210, 'lps'),
	(567480, 130, '2014-03-01 00:53:44.000000', 'consum', 0.0215, 'lps'),
	(567481, 130, '2014-03-01 00:53:45.000000', 'consum', 0.0217, 'lps'),
	(567482, 130, '2014-03-01 00:53:46.000000', 'consum', 0.0213, 'lps'),
	(567483, 130, '2014-03-01 00:53:47.000000', 'consum', 0.0221, 'lps'),
	(567484, 130, '2014-03-01 00:53:48.000000', 'consum', 0.0220, 'lps'),
	(567485, 130, '2014-03-01 00:53:49.000000', 'consum', 0.0226, 'lps'),
	(567486, 130, '2014-03-01 00:53:50.000000', 'consum', 0.0223, 'lps'),
	(567487, 130, '2014-03-01 00:53:51.000000', 'consum', 0.0227, 'lps'),
	(567488, 130, '2014-03-01 00:53:52.000000', 'consum', 0.0221, 'lps'),
	(567489, 130, '2014-03-01 00:53:53.000000', 'consum', 0.0211, 'lps'),
	(567490, 130, '2014-03-01 00:53:54.000000', 'consum', 0.0222, 'lps'),
	(567491, 130, '2014-03-01 00:53:55.000000', 'consum', 0.0211, 'lps'),
	(567492, 130, '2014-03-01 00:53:56.000000', 'consum', 0.0215, 'lps'),
	(567493, 130, '2014-03-01 00:53:57.000000', 'consum', 0.0216, 'lps'),
	(567494, 130, '2014-03-01 00:53:58.000000', 'consum', 0.0223, 'lps'),
	(567495, 130, '2014-03-01 00:53:59.000000', 'consum', 0.0220, 'lps'),
	(567496, 130, '2014-03-01 00:54:00.000000', 'consum', 0.0224, 'lps'),
	(567497, 130, '2014-03-01 00:54:01.000000', 'consum', 0.0212, 'lps'),
	(567498, 130, '2014-03-01 00:54:02.000000', 'consum', 0.0215, 'lps'),
	(567499, 130, '2014-03-01 00:54:03.000000', 'consum', 0.0210, 'lps'),
	(567500, 130, '2014-03-01 00:54:04.000000', 'consum', 0.0217, 'lps'),
	(567501, 130, '2014-03-01 00:54:05.000000', 'consum', 0.0225, 'lps'),
	(567502, 130, '2014-03-01 00:54:06.000000', 'consum', 0.0227, 'lps'),
	(567503, 130, '2014-03-01 00:54:07.000000', 'consum', 0.0212, 'lps'),
	(567504, 130, '2014-03-01 00:54:08.000000', 'consum', 0.0225, 'lps'),
	(567505, 130, '2014-03-01 00:54:09.000000', 'consum', 0.0226, 'lps'),
	(567506, 130, '2014-03-01 00:54:10.000000', 'consum', 0.0223, 'lps'),
	(567507, 130, '2014-03-01 00:54:11.000000', 'consum', 0.0212, 'lps'),
	(567508, 130, '2014-03-01 00:54:12.000000', 'consum', 0.0217, 'lps'),
	(567509, 130, '2014-03-01 00:54:13.000000', 'consum', 0.0223, 'lps'),
	(567510, 130, '2014-03-01 00:54:14.000000', 'consum', 0.0215, 'lps'),
	(567511, 130, '2014-03-01 00:54:15.000000', 'consum', 0.0216, 'lps'),
	(567512, 130, '2014-03-01 00:54:16.000000', 'consum', 0.0227, 'lps'),
	(567513, 130, '2014-03-01 00:54:17.000000', 'consum', 0.0219, 'lps'),
	(567514, 130, '2014-03-01 00:54:18.000000', 'consum', 0.0225, 'lps'),
	(567515, 130, '2014-03-01 00:54:19.000000', 'consum', 0.0219, 'lps'),
	(567516, 130, '2014-03-01 00:54:20.000000', 'consum', 0.0228, 'lps'),
	(567517, 130, '2014-03-01 00:54:21.000000', 'consum', 0.0220, 'lps'),
	(567518, 130, '2014-03-01 00:54:22.000000', 'consum', 0.0222, 'lps'),
	(567519, 130, '2014-03-01 00:54:23.000000', 'consum', 0.0224, 'lps'),
	(567520, 130, '2014-03-01 00:54:24.000000', 'consum', 0.0224, 'lps'),
	(567521, 130, '2014-03-01 00:54:25.000000', 'consum', 0.0219, 'lps'),
	(567522, 130, '2014-03-01 00:54:26.000000', 'consum', 0.0213, 'lps'),
	(567523, 130, '2014-03-01 00:54:27.000000', 'consum', 0.0216, 'lps'),
	(567524, 130, '2014-03-01 00:54:28.000000', 'consum', 0.0215, 'lps'),
	(567525, 130, '2014-03-01 00:54:29.000000', 'consum', 0.0218, 'lps'),
	(567526, 130, '2014-03-01 00:54:30.000000', 'consum', 0.0216, 'lps'),
	(567527, 130, '2014-03-01 00:54:31.000000', 'consum', 0.0215, 'lps'),
	(567528, 130, '2014-03-01 00:54:32.000000', 'consum', 0.0220, 'lps'),
	(567529, 130, '2014-03-01 00:54:33.000000', 'consum', 0.0226, 'lps'),
	(567530, 130, '2014-03-01 00:54:34.000000', 'consum', 0.0224, 'lps'),
	(567531, 130, '2014-03-01 00:54:35.000000', 'consum', 0.0213, 'lps'),
	(567532, 130, '2014-03-01 00:54:36.000000', 'consum', 0.0220, 'lps'),
	(567533, 130, '2014-03-01 00:54:37.000000', 'consum', 0.0213, 'lps'),
	(567534, 130, '2014-03-01 00:54:38.000000', 'consum', 0.0216, 'lps'),
	(567535, 130, '2014-03-01 00:54:39.000000', 'consum', 0.0213, 'lps'),
	(567536, 130, '2014-03-01 00:54:40.000000', 'consum', 0.0224, 'lps'),
	(567537, 130, '2014-03-01 00:54:41.000000', 'consum', 0.0216, 'lps'),
	(567538, 130, '2014-03-01 00:54:42.000000', 'consum', 0.0217, 'lps'),
	(567539, 130, '2014-03-01 00:54:43.000000', 'consum', 0.0211, 'lps'),
	(567540, 130, '2014-03-01 00:54:44.000000', 'consum', 0.0211, 'lps'),
	(567541, 130, '2014-03-01 00:54:45.000000', 'consum', 0.0214, 'lps'),
	(567542, 130, '2014-03-01 00:54:46.000000', 'consum', 0.0225, 'lps'),
	(567543, 130, '2014-03-01 00:54:47.000000', 'consum', 0.0217, 'lps'),
	(567544, 130, '2014-03-01 00:54:48.000000', 'consum', 0.0222, 'lps'),
	(567545, 130, '2014-03-01 00:54:49.000000', 'consum', 0.0211, 'lps'),
	(567546, 130, '2014-03-01 00:54:50.000000', 'consum', 0.0216, 'lps'),
	(567547, 130, '2014-03-01 00:54:51.000000', 'consum', 0.0220, 'lps'),
	(567548, 130, '2014-03-01 00:54:52.000000', 'consum', 0.0223, 'lps'),
	(567549, 130, '2014-03-01 00:54:53.000000', 'consum', 0.0228, 'lps'),
	(567550, 130, '2014-03-01 00:54:54.000000', 'consum', 0.0224, 'lps'),
	(567551, 130, '2014-03-01 00:54:55.000000', 'consum', 0.0226, 'lps'),
	(567552, 130, '2014-03-01 00:54:56.000000', 'consum', 0.0228, 'lps'),
	(567553, 130, '2014-03-01 00:54:57.000000', 'consum', 0.0217, 'lps'),
	(567554, 130, '2014-03-01 00:54:58.000000', 'consum', 0.0228, 'lps'),
	(567555, 130, '2014-03-01 00:54:59.000000', 'consum', 0.0222, 'lps'),
	(567556, 130, '2014-03-01 00:55:00.000000', 'consum', 0.0216, 'lps'),
	(567557, 130, '2014-03-01 00:55:01.000000', 'consum', 0.0223, 'lps'),
	(567558, 130, '2014-03-01 00:55:02.000000', 'consum', 0.0220, 'lps'),
	(567559, 130, '2014-03-01 00:55:03.000000', 'consum', 0.0220, 'lps'),
	(567560, 130, '2014-03-01 00:55:04.000000', 'consum', 0.0213, 'lps'),
	(567561, 130, '2014-03-01 00:55:05.000000', 'consum', 0.0215, 'lps'),
	(567562, 130, '2014-03-01 00:55:06.000000', 'consum', 0.0227, 'lps'),
	(567563, 130, '2014-03-01 00:55:07.000000', 'consum', 0.0223, 'lps'),
	(567564, 130, '2014-03-01 00:55:08.000000', 'consum', 0.0223, 'lps'),
	(567565, 130, '2014-03-01 00:55:09.000000', 'consum', 0.0219, 'lps'),
	(567566, 130, '2014-03-01 00:55:10.000000', 'consum', 0.0217, 'lps'),
	(567567, 130, '2014-03-01 00:55:11.000000', 'consum', 0.0220, 'lps'),
	(567568, 130, '2014-03-01 00:55:12.000000', 'consum', 0.0218, 'lps'),
	(567569, 130, '2014-03-01 00:55:13.000000', 'consum', 0.0223, 'lps'),
	(567570, 130, '2014-03-01 00:55:14.000000', 'consum', 0.0211, 'lps'),
	(567571, 130, '2014-03-01 00:55:15.000000', 'consum', 0.0217, 'lps'),
	(567572, 130, '2014-03-01 00:55:16.000000', 'consum', 0.0224, 'lps'),
	(567573, 130, '2014-03-01 00:55:17.000000', 'consum', 0.0219, 'lps'),
	(567574, 130, '2014-03-01 00:55:18.000000', 'consum', 0.0214, 'lps'),
	(567575, 130, '2014-03-01 00:55:19.000000', 'consum', 0.0223, 'lps'),
	(567576, 130, '2014-03-01 00:55:20.000000', 'consum', 0.0227, 'lps'),
	(567577, 130, '2014-03-01 00:55:21.000000', 'consum', 0.0218, 'lps'),
	(567578, 130, '2014-03-01 00:55:22.000000', 'consum', 0.0217, 'lps'),
	(567579, 130, '2014-03-01 00:55:23.000000', 'consum', 0.0222, 'lps'),
	(567580, 130, '2014-03-01 00:55:24.000000', 'consum', 0.0211, 'lps'),
	(567581, 130, '2014-03-01 00:55:25.000000', 'consum', 0.0216, 'lps'),
	(567582, 130, '2014-03-01 00:55:26.000000', 'consum', 0.0221, 'lps'),
	(567583, 130, '2014-03-01 00:55:27.000000', 'consum', 0.0210, 'lps'),
	(567584, 130, '2014-03-01 00:55:28.000000', 'consum', 0.0215, 'lps'),
	(567585, 130, '2014-03-01 00:55:29.000000', 'consum', 0.0215, 'lps'),
	(567586, 130, '2014-03-01 00:55:30.000000', 'consum', 0.0222, 'lps'),
	(567587, 130, '2014-03-01 00:55:31.000000', 'consum', 0.0215, 'lps'),
	(567588, 130, '2014-03-01 00:55:32.000000', 'consum', 0.0222, 'lps'),
	(567589, 130, '2014-03-01 00:55:33.000000', 'consum', 0.0215, 'lps'),
	(567590, 130, '2014-03-01 00:55:34.000000', 'consum', 0.0218, 'lps'),
	(567591, 130, '2014-03-01 00:55:35.000000', 'consum', 0.0217, 'lps'),
	(567592, 130, '2014-03-01 00:55:36.000000', 'consum', 0.0221, 'lps'),
	(567593, 130, '2014-03-01 00:55:37.000000', 'consum', 0.0225, 'lps'),
	(567594, 130, '2014-03-01 00:55:38.000000', 'consum', 0.0215, 'lps'),
	(567595, 130, '2014-03-01 00:55:39.000000', 'consum', 0.0211, 'lps'),
	(567596, 130, '2014-03-01 00:55:40.000000', 'consum', 0.0220, 'lps'),
	(567597, 130, '2014-03-01 00:55:41.000000', 'consum', 0.0217, 'lps'),
	(567598, 130, '2014-03-01 00:55:42.000000', 'consum', 0.0215, 'lps'),
	(567599, 130, '2014-03-01 00:55:43.000000', 'consum', 0.0215, 'lps'),
	(567600, 130, '2014-03-01 00:55:44.000000', 'consum', 0.0221, 'lps'),
	(567601, 130, '2014-03-01 00:55:45.000000', 'consum', 0.0214, 'lps'),
	(567602, 130, '2014-03-01 00:55:46.000000', 'consum', 0.0215, 'lps'),
	(567603, 130, '2014-03-01 00:55:47.000000', 'consum', 0.0223, 'lps'),
	(567604, 130, '2014-03-01 00:55:48.000000', 'consum', 0.0224, 'lps'),
	(567605, 130, '2014-03-01 00:55:49.000000', 'consum', 0.0223, 'lps'),
	(567606, 130, '2014-03-01 00:55:50.000000', 'consum', 0.0214, 'lps'),
	(567607, 130, '2014-03-01 00:55:51.000000', 'consum', 0.0227, 'lps'),
	(567608, 130, '2014-03-01 00:55:52.000000', 'consum', 0.0210, 'lps'),
	(567609, 130, '2014-03-01 00:55:53.000000', 'consum', 0.0216, 'lps'),
	(567610, 130, '2014-03-01 00:55:54.000000', 'consum', 0.0220, 'lps'),
	(567611, 130, '2014-03-01 00:55:55.000000', 'consum', 0.0226, 'lps'),
	(567612, 130, '2014-03-01 00:55:56.000000', 'consum', 0.0222, 'lps'),
	(567613, 130, '2014-03-01 00:55:57.000000', 'consum', 0.0221, 'lps'),
	(567614, 130, '2014-03-01 00:55:58.000000', 'consum', 0.0210, 'lps'),
	(567615, 130, '2014-03-01 00:55:59.000000', 'consum', 0.0218, 'lps'),
	(567616, 130, '2014-03-01 00:56:00.000000', 'consum', 0.0211, 'lps'),
	(567617, 130, '2014-03-01 00:56:01.000000', 'consum', 0.0228, 'lps'),
	(567618, 130, '2014-03-01 00:56:02.000000', 'consum', 0.0225, 'lps'),
	(567619, 130, '2014-03-01 00:56:03.000000', 'consum', 0.0228, 'lps'),
	(567620, 130, '2014-03-01 00:56:04.000000', 'consum', 0.0218, 'lps'),
	(567621, 130, '2014-03-01 00:56:05.000000', 'consum', 0.0216, 'lps'),
	(567622, 130, '2014-03-01 00:56:06.000000', 'consum', 0.0216, 'lps'),
	(567623, 130, '2014-03-01 00:56:07.000000', 'consum', 0.0222, 'lps'),
	(567624, 130, '2014-03-01 00:56:08.000000', 'consum', 0.0213, 'lps'),
	(567625, 130, '2014-03-01 00:56:09.000000', 'consum', 0.0212, 'lps'),
	(567626, 130, '2014-03-01 00:56:10.000000', 'consum', 0.0211, 'lps'),
	(567627, 130, '2014-03-01 00:56:11.000000', 'consum', 0.0226, 'lps'),
	(567628, 130, '2014-03-01 00:56:12.000000', 'consum', 0.0213, 'lps'),
	(567629, 130, '2014-03-01 00:56:13.000000', 'consum', 0.0216, 'lps'),
	(567630, 130, '2014-03-01 00:56:14.000000', 'consum', 0.0212, 'lps'),
	(567631, 130, '2014-03-01 00:56:15.000000', 'consum', 0.0222, 'lps'),
	(567632, 130, '2014-03-01 00:56:16.000000', 'consum', 0.0225, 'lps'),
	(567633, 130, '2014-03-01 00:56:17.000000', 'consum', 0.0213, 'lps'),
	(567634, 130, '2014-03-01 00:56:18.000000', 'consum', 0.0217, 'lps'),
	(567635, 130, '2014-03-01 00:56:19.000000', 'consum', 0.0217, 'lps'),
	(567636, 130, '2014-03-01 00:56:20.000000', 'consum', 0.0224, 'lps'),
	(567637, 130, '2014-03-01 00:56:21.000000', 'consum', 0.0222, 'lps'),
	(567638, 130, '2014-03-01 00:56:22.000000', 'consum', 0.0228, 'lps'),
	(567639, 130, '2014-03-01 00:56:23.000000', 'consum', 0.0226, 'lps'),
	(567640, 130, '2014-03-01 00:56:24.000000', 'consum', 0.0220, 'lps'),
	(567641, 130, '2014-03-01 00:56:25.000000', 'consum', 0.0213, 'lps'),
	(567642, 130, '2014-03-01 00:56:26.000000', 'consum', 0.0211, 'lps'),
	(567643, 130, '2014-03-01 00:56:27.000000', 'consum', 0.0210, 'lps'),
	(567644, 130, '2014-03-01 00:56:28.000000', 'consum', 0.0225, 'lps'),
	(567645, 130, '2014-03-01 00:56:29.000000', 'consum', 0.0211, 'lps'),
	(567646, 130, '2014-03-01 00:56:30.000000', 'consum', 0.0228, 'lps'),
	(567647, 130, '2014-03-01 00:56:31.000000', 'consum', 0.0222, 'lps'),
	(567648, 130, '2014-03-01 00:56:32.000000', 'consum', 0.0215, 'lps'),
	(567649, 130, '2014-03-01 00:56:33.000000', 'consum', 0.0219, 'lps'),
	(567650, 130, '2014-03-01 00:56:34.000000', 'consum', 0.0221, 'lps'),
	(567651, 130, '2014-03-01 00:56:35.000000', 'consum', 0.0220, 'lps'),
	(567652, 130, '2014-03-01 00:56:36.000000', 'consum', 0.0227, 'lps'),
	(567653, 130, '2014-03-01 00:56:37.000000', 'consum', 0.0210, 'lps'),
	(567654, 130, '2014-03-01 00:56:38.000000', 'consum', 0.0215, 'lps'),
	(567655, 130, '2014-03-01 00:56:39.000000', 'consum', 0.0218, 'lps'),
	(567656, 130, '2014-03-01 00:56:40.000000', 'consum', 0.0215, 'lps'),
	(567657, 130, '2014-03-01 00:56:41.000000', 'consum', 0.0213, 'lps'),
	(567658, 130, '2014-03-01 00:56:42.000000', 'consum', 0.0227, 'lps'),
	(567659, 130, '2014-03-01 00:56:43.000000', 'consum', 0.0213, 'lps'),
	(567660, 130, '2014-03-01 00:56:44.000000', 'consum', 0.0212, 'lps'),
	(567661, 130, '2014-03-01 00:56:45.000000', 'consum', 0.0211, 'lps'),
	(567662, 130, '2014-03-01 00:56:46.000000', 'consum', 0.0228, 'lps'),
	(567663, 130, '2014-03-01 00:56:47.000000', 'consum', 0.0224, 'lps'),
	(567664, 130, '2014-03-01 00:56:48.000000', 'consum', 0.0224, 'lps'),
	(567665, 130, '2014-03-01 00:56:49.000000', 'consum', 0.0219, 'lps'),
	(567666, 130, '2014-03-01 00:56:50.000000', 'consum', 0.0214, 'lps'),
	(567667, 130, '2014-03-01 00:56:51.000000', 'consum', 0.0222, 'lps'),
	(567668, 130, '2014-03-01 00:56:52.000000', 'consum', 0.0221, 'lps'),
	(567669, 130, '2014-03-01 00:56:53.000000', 'consum', 0.0210, 'lps'),
	(567670, 130, '2014-03-01 00:56:54.000000', 'consum', 0.0214, 'lps'),
	(567671, 130, '2014-03-01 00:56:55.000000', 'consum', 0.0213, 'lps'),
	(567672, 130, '2014-03-01 00:56:56.000000', 'consum', 0.0213, 'lps'),
	(567673, 130, '2014-03-01 00:56:57.000000', 'consum', 0.0217, 'lps'),
	(567674, 130, '2014-03-01 00:56:58.000000', 'consum', 0.0219, 'lps'),
	(567675, 130, '2014-03-01 00:56:59.000000', 'consum', 0.0215, 'lps'),
	(567676, 130, '2014-03-01 00:57:00.000000', 'consum', 0.0210, 'lps'),
	(567677, 130, '2014-03-01 00:57:01.000000', 'consum', 0.0212, 'lps'),
	(567678, 130, '2014-03-01 00:57:02.000000', 'consum', 0.0223, 'lps'),
	(567679, 130, '2014-03-01 00:57:03.000000', 'consum', 0.0211, 'lps'),
	(567680, 130, '2014-03-01 00:57:04.000000', 'consum', 0.0214, 'lps'),
	(567681, 130, '2014-03-01 00:57:05.000000', 'consum', 0.0227, 'lps'),
	(567682, 130, '2014-03-01 00:57:06.000000', 'consum', 0.0228, 'lps'),
	(567683, 130, '2014-03-01 00:57:07.000000', 'consum', 0.0228, 'lps'),
	(567684, 130, '2014-03-01 00:57:08.000000', 'consum', 0.0211, 'lps'),
	(567685, 130, '2014-03-01 00:57:09.000000', 'consum', 0.0220, 'lps'),
	(567686, 130, '2014-03-01 00:57:10.000000', 'consum', 0.0216, 'lps'),
	(567687, 130, '2014-03-01 00:57:11.000000', 'consum', 0.0213, 'lps'),
	(567688, 130, '2014-03-01 00:57:12.000000', 'consum', 0.0225, 'lps'),
	(567689, 130, '2014-03-01 00:57:13.000000', 'consum', 0.0218, 'lps'),
	(567690, 130, '2014-03-01 00:57:14.000000', 'consum', 0.0227, 'lps'),
	(567691, 130, '2014-03-01 00:57:15.000000', 'consum', 0.0212, 'lps'),
	(567692, 130, '2014-03-01 00:57:16.000000', 'consum', 0.0210, 'lps'),
	(567693, 130, '2014-03-01 00:57:17.000000', 'consum', 0.0223, 'lps'),
	(567694, 130, '2014-03-01 00:57:18.000000', 'consum', 0.0217, 'lps'),
	(567695, 130, '2014-03-01 00:57:19.000000', 'consum', 0.0225, 'lps'),
	(567696, 130, '2014-03-01 00:57:20.000000', 'consum', 0.0211, 'lps'),
	(567697, 130, '2014-03-01 00:57:21.000000', 'consum', 0.0224, 'lps'),
	(567698, 130, '2014-03-01 00:57:22.000000', 'consum', 0.0221, 'lps'),
	(567699, 130, '2014-03-01 00:57:23.000000', 'consum', 0.0222, 'lps'),
	(567700, 130, '2014-03-01 00:57:24.000000', 'consum', 0.0221, 'lps'),
	(567701, 130, '2014-03-01 00:57:25.000000', 'consum', 0.0227, 'lps'),
	(567702, 130, '2014-03-01 00:57:26.000000', 'consum', 0.0224, 'lps'),
	(567703, 130, '2014-03-01 00:57:27.000000', 'consum', 0.0213, 'lps'),
	(567704, 130, '2014-03-01 00:57:28.000000', 'consum', 0.0222, 'lps'),
	(567705, 130, '2014-03-01 00:57:29.000000', 'consum', 0.0223, 'lps'),
	(567706, 130, '2014-03-01 00:57:30.000000', 'consum', 0.0220, 'lps'),
	(567707, 130, '2014-03-01 00:57:31.000000', 'consum', 0.0222, 'lps'),
	(567708, 130, '2014-03-01 00:57:32.000000', 'consum', 0.0221, 'lps'),
	(567709, 130, '2014-03-01 00:57:33.000000', 'consum', 0.0212, 'lps'),
	(567710, 130, '2014-03-01 00:57:34.000000', 'consum', 0.0223, 'lps'),
	(567711, 130, '2014-03-01 00:57:35.000000', 'consum', 0.0213, 'lps'),
	(567712, 130, '2014-03-01 00:57:36.000000', 'consum', 0.0226, 'lps'),
	(567713, 130, '2014-03-01 00:57:37.000000', 'consum', 0.0224, 'lps'),
	(567714, 130, '2014-03-01 00:57:38.000000', 'consum', 0.0215, 'lps'),
	(567715, 130, '2014-03-01 00:57:39.000000', 'consum', 0.0228, 'lps'),
	(567716, 130, '2014-03-01 00:57:40.000000', 'consum', 0.0213, 'lps'),
	(567717, 130, '2014-03-01 00:57:41.000000', 'consum', 0.0226, 'lps'),
	(567718, 130, '2014-03-01 00:57:42.000000', 'consum', 0.0224, 'lps'),
	(567719, 130, '2014-03-01 00:57:43.000000', 'consum', 0.0217, 'lps'),
	(567720, 130, '2014-03-01 00:57:44.000000', 'consum', 0.0219, 'lps'),
	(567721, 130, '2014-03-01 00:57:45.000000', 'consum', 0.0216, 'lps'),
	(567722, 130, '2014-03-01 00:57:46.000000', 'consum', 0.0214, 'lps'),
	(567723, 130, '2014-03-01 00:57:47.000000', 'consum', 0.0212, 'lps'),
	(567724, 130, '2014-03-01 00:57:48.000000', 'consum', 0.0228, 'lps'),
	(567725, 130, '2014-03-01 00:57:49.000000', 'consum', 0.0217, 'lps'),
	(567726, 130, '2014-03-01 00:57:50.000000', 'consum', 0.0213, 'lps'),
	(567727, 130, '2014-03-01 00:57:51.000000', 'consum', 0.0221, 'lps'),
	(567728, 130, '2014-03-01 00:57:52.000000', 'consum', 0.0218, 'lps'),
	(567729, 130, '2014-03-01 00:57:53.000000', 'consum', 0.0220, 'lps'),
	(567730, 130, '2014-03-01 00:57:54.000000', 'consum', 0.0215, 'lps'),
	(567731, 130, '2014-03-01 00:57:55.000000', 'consum', 0.0225, 'lps'),
	(567732, 130, '2014-03-01 00:57:56.000000', 'consum', 0.0212, 'lps'),
	(567733, 130, '2014-03-01 00:57:57.000000', 'consum', 0.0216, 'lps'),
	(567734, 130, '2014-03-01 00:57:58.000000', 'consum', 0.0213, 'lps'),
	(567735, 130, '2014-03-01 00:57:59.000000', 'consum', 0.0210, 'lps'),
	(567736, 130, '2014-03-01 00:58:00.000000', 'consum', 0.0222, 'lps'),
	(567737, 130, '2014-03-01 00:58:01.000000', 'consum', 0.0211, 'lps'),
	(567738, 130, '2014-03-01 00:58:02.000000', 'consum', 0.0216, 'lps'),
	(567739, 130, '2014-03-01 00:58:03.000000', 'consum', 0.0220, 'lps'),
	(567740, 130, '2014-03-01 00:58:04.000000', 'consum', 0.0222, 'lps'),
	(567741, 130, '2014-03-01 00:58:05.000000', 'consum', 0.0221, 'lps'),
	(567742, 130, '2014-03-01 00:58:06.000000', 'consum', 0.0211, 'lps'),
	(567743, 130, '2014-03-01 00:58:07.000000', 'consum', 0.0219, 'lps'),
	(567744, 130, '2014-03-01 00:58:08.000000', 'consum', 0.0216, 'lps'),
	(567745, 130, '2014-03-01 00:58:09.000000', 'consum', 0.0215, 'lps'),
	(567746, 130, '2014-03-01 00:58:10.000000', 'consum', 0.0218, 'lps'),
	(567747, 130, '2014-03-01 00:58:11.000000', 'consum', 0.0214, 'lps'),
	(567748, 130, '2014-03-01 00:58:12.000000', 'consum', 0.0227, 'lps'),
	(567749, 130, '2014-03-01 00:58:13.000000', 'consum', 0.0226, 'lps'),
	(567750, 130, '2014-03-01 00:58:14.000000', 'consum', 0.0221, 'lps'),
	(567751, 130, '2014-03-01 00:58:15.000000', 'consum', 0.0219, 'lps'),
	(567752, 130, '2014-03-01 00:58:16.000000', 'consum', 0.0221, 'lps'),
	(567753, 130, '2014-03-01 00:58:17.000000', 'consum', 0.0218, 'lps'),
	(567754, 130, '2014-03-01 00:58:18.000000', 'consum', 0.0220, 'lps'),
	(567755, 130, '2014-03-01 00:58:19.000000', 'consum', 0.0218, 'lps'),
	(567756, 130, '2014-03-01 00:58:20.000000', 'consum', 0.0220, 'lps'),
	(567757, 130, '2014-03-01 00:58:21.000000', 'consum', 0.0216, 'lps'),
	(567758, 130, '2014-03-01 00:58:22.000000', 'consum', 0.0212, 'lps'),
	(567759, 130, '2014-03-01 00:58:23.000000', 'consum', 0.0219, 'lps'),
	(567760, 130, '2014-03-01 00:58:24.000000', 'consum', 0.0213, 'lps'),
	(567761, 130, '2014-03-01 00:58:25.000000', 'consum', 0.0219, 'lps'),
	(567762, 130, '2014-03-01 00:58:26.000000', 'consum', 0.0225, 'lps'),
	(567763, 130, '2014-03-01 00:58:27.000000', 'consum', 0.0223, 'lps'),
	(567764, 130, '2014-03-01 00:58:28.000000', 'consum', 0.0210, 'lps'),
	(567765, 130, '2014-03-01 00:58:29.000000', 'consum', 0.0212, 'lps'),
	(567766, 130, '2014-03-01 00:58:30.000000', 'consum', 0.0219, 'lps'),
	(567767, 130, '2014-03-01 00:58:31.000000', 'consum', 0.0228, 'lps'),
	(567768, 130, '2014-03-01 00:58:32.000000', 'consum', 0.0220, 'lps'),
	(567769, 130, '2014-03-01 00:58:33.000000', 'consum', 0.0224, 'lps'),
	(567770, 130, '2014-03-01 00:58:34.000000', 'consum', 0.0212, 'lps'),
	(567771, 130, '2014-03-01 00:58:35.000000', 'consum', 0.0219, 'lps'),
	(567772, 130, '2014-03-01 00:58:36.000000', 'consum', 0.0210, 'lps'),
	(567773, 130, '2014-03-01 00:58:37.000000', 'consum', 0.0222, 'lps'),
	(567774, 130, '2014-03-01 00:58:38.000000', 'consum', 0.0215, 'lps'),
	(567775, 130, '2014-03-01 00:58:39.000000', 'consum', 0.0217, 'lps'),
	(567776, 130, '2014-03-01 00:58:40.000000', 'consum', 0.0211, 'lps'),
	(567777, 130, '2014-03-01 00:58:41.000000', 'consum', 0.0214, 'lps'),
	(567778, 130, '2014-03-01 00:58:42.000000', 'consum', 0.0228, 'lps'),
	(567779, 130, '2014-03-01 00:58:43.000000', 'consum', 0.0213, 'lps'),
	(567780, 130, '2014-03-01 00:58:44.000000', 'consum', 0.0227, 'lps'),
	(567781, 130, '2014-03-01 00:58:45.000000', 'consum', 0.0211, 'lps'),
	(567782, 130, '2014-03-01 00:58:46.000000', 'consum', 0.0224, 'lps'),
	(567783, 130, '2014-03-01 00:58:47.000000', 'consum', 0.0218, 'lps'),
	(567784, 130, '2014-03-01 00:58:48.000000', 'consum', 0.0227, 'lps'),
	(567785, 130, '2014-03-01 00:58:49.000000', 'consum', 0.0214, 'lps'),
	(567786, 130, '2014-03-01 00:58:50.000000', 'consum', 0.0217, 'lps'),
	(567787, 130, '2014-03-01 00:58:51.000000', 'consum', 0.0217, 'lps'),
	(567788, 130, '2014-03-01 00:58:52.000000', 'consum', 0.0225, 'lps'),
	(567789, 130, '2014-03-01 00:58:53.000000', 'consum', 0.0227, 'lps'),
	(567790, 130, '2014-03-01 00:58:54.000000', 'consum', 0.0228, 'lps'),
	(567791, 130, '2014-03-01 00:58:55.000000', 'consum', 0.0214, 'lps'),
	(567792, 130, '2014-03-01 00:58:56.000000', 'consum', 0.0215, 'lps'),
	(567793, 130, '2014-03-01 00:58:57.000000', 'consum', 0.0223, 'lps'),
	(567794, 130, '2014-03-01 00:58:58.000000', 'consum', 0.0222, 'lps'),
	(567795, 130, '2014-03-01 00:58:59.000000', 'consum', 0.0213, 'lps'),
	(567796, 130, '2014-03-01 00:59:00.000000', 'consum', 0.0227, 'lps'),
	(567797, 130, '2014-03-01 00:59:01.000000', 'consum', 0.0228, 'lps'),
	(567798, 130, '2014-03-01 00:59:02.000000', 'consum', 0.0212, 'lps'),
	(567799, 130, '2014-03-01 00:59:03.000000', 'consum', 0.0223, 'lps'),
	(567800, 130, '2014-03-01 00:59:04.000000', 'consum', 0.0214, 'lps'),
	(567801, 130, '2014-03-01 00:59:05.000000', 'consum', 0.0210, 'lps'),
	(567802, 130, '2014-03-01 00:59:06.000000', 'consum', 0.0216, 'lps'),
	(567803, 130, '2014-03-01 00:59:07.000000', 'consum', 0.0222, 'lps'),
	(567804, 130, '2014-03-01 00:59:08.000000', 'consum', 0.0216, 'lps'),
	(567805, 130, '2014-03-01 00:59:09.000000', 'consum', 0.0224, 'lps'),
	(567806, 130, '2014-03-01 00:59:10.000000', 'consum', 0.0223, 'lps'),
	(567807, 130, '2014-03-01 00:59:11.000000', 'consum', 0.0213, 'lps'),
	(567808, 130, '2014-03-01 00:59:12.000000', 'consum', 0.0228, 'lps'),
	(567809, 130, '2014-03-01 00:59:13.000000', 'consum', 0.0213, 'lps'),
	(567810, 130, '2014-03-01 00:59:14.000000', 'consum', 0.0211, 'lps'),
	(567811, 130, '2014-03-01 00:59:15.000000', 'consum', 0.0225, 'lps'),
	(567812, 130, '2014-03-01 00:59:16.000000', 'consum', 0.0228, 'lps'),
	(567813, 130, '2014-03-01 00:59:17.000000', 'consum', 0.0214, 'lps'),
	(567814, 130, '2014-03-01 00:59:18.000000', 'consum', 0.0215, 'lps'),
	(567815, 130, '2014-03-01 00:59:19.000000', 'consum', 0.0224, 'lps'),
	(567816, 130, '2014-03-01 00:59:20.000000', 'consum', 0.0226, 'lps'),
	(567817, 130, '2014-03-01 00:59:21.000000', 'consum', 0.0214, 'lps'),
	(567818, 130, '2014-03-01 00:59:22.000000', 'consum', 0.0217, 'lps'),
	(567819, 130, '2014-03-01 00:59:23.000000', 'consum', 0.0215, 'lps'),
	(567820, 130, '2014-03-01 00:59:24.000000', 'consum', 0.0216, 'lps'),
	(567821, 130, '2014-03-01 00:59:25.000000', 'consum', 0.0227, 'lps'),
	(567822, 130, '2014-03-01 00:59:26.000000', 'consum', 0.0217, 'lps'),
	(567823, 130, '2014-03-01 00:59:27.000000', 'consum', 0.0214, 'lps'),
	(567824, 130, '2014-03-01 00:59:28.000000', 'consum', 0.0212, 'lps'),
	(567825, 130, '2014-03-01 00:59:29.000000', 'consum', 0.0224, 'lps'),
	(567826, 130, '2014-03-01 00:59:30.000000', 'consum', 0.0220, 'lps'),
	(567827, 130, '2014-03-01 00:59:31.000000', 'consum', 0.0218, 'lps'),
	(567828, 130, '2014-03-01 00:59:32.000000', 'consum', 0.0220, 'lps'),
	(567829, 130, '2014-03-01 00:59:33.000000', 'consum', 0.0216, 'lps'),
	(567830, 130, '2014-03-01 00:59:34.000000', 'consum', 0.0213, 'lps'),
	(567831, 130, '2014-03-01 00:59:35.000000', 'consum', 0.0225, 'lps'),
	(567832, 130, '2014-03-01 00:59:36.000000', 'consum', 0.0219, 'lps'),
	(567833, 130, '2014-03-01 00:59:37.000000', 'consum', 0.0213, 'lps'),
	(567834, 130, '2014-03-01 00:59:38.000000', 'consum', 0.0216, 'lps'),
	(567835, 130, '2014-03-01 00:59:39.000000', 'consum', 0.0215, 'lps'),
	(567836, 130, '2014-03-01 00:59:40.000000', 'consum', 0.0215, 'lps'),
	(567837, 130, '2014-03-01 00:59:41.000000', 'consum', 0.0219, 'lps'),
	(567838, 130, '2014-03-01 00:59:42.000000', 'consum', 0.0224, 'lps'),
	(567839, 130, '2014-03-01 00:59:43.000000', 'consum', 0.0216, 'lps'),
	(567840, 130, '2014-03-01 00:59:44.000000', 'consum', 0.0215, 'lps'),
	(567841, 130, '2014-03-01 00:59:45.000000', 'consum', 0.0217, 'lps'),
	(567842, 130, '2014-03-01 00:59:46.000000', 'consum', 0.0212, 'lps'),
	(567843, 130, '2014-03-01 00:59:47.000000', 'consum', 0.0221, 'lps'),
	(567844, 130, '2014-03-01 00:59:48.000000', 'consum', 0.0218, 'lps'),
	(567845, 130, '2014-03-01 00:59:49.000000', 'consum', 0.0220, 'lps'),
	(567846, 130, '2014-03-01 00:59:50.000000', 'consum', 0.0217, 'lps'),
	(567847, 130, '2014-03-01 00:59:51.000000', 'consum', 0.0214, 'lps'),
	(567848, 130, '2014-03-01 00:59:52.000000', 'consum', 0.0212, 'lps'),
	(567849, 130, '2014-03-01 00:59:53.000000', 'consum', 0.0226, 'lps'),
	(567850, 130, '2014-03-01 00:59:54.000000', 'consum', 0.0226, 'lps'),
	(567851, 130, '2014-03-01 00:59:55.000000', 'consum', 0.0224, 'lps'),
	(567852, 130, '2014-03-01 00:59:56.000000', 'consum', 0.0215, 'lps'),
	(567853, 130, '2014-03-01 00:59:57.000000', 'consum', 0.0212, 'lps'),
	(567854, 130, '2014-03-01 00:59:58.000000', 'consum', 0.0224, 'lps'),
	(567855, 130, '2014-03-01 00:59:59.000000', 'consum', 0.0220, 'lps'),
	(567856, 130, '2014-03-01 01:00:00.000000', 'consum', 0.0216, 'lps'),
	(567857, 130, '2014-03-01 01:00:01.000000', 'consum', 0.0228, 'lps'),
	(567858, 130, '2014-03-01 01:00:02.000000', 'consum', 0.0210, 'lps'),
	(567859, 130, '2014-03-01 01:00:03.000000', 'consum', 0.0210, 'lps'),
	(567860, 130, '2014-03-01 01:00:04.000000', 'consum', 0.0214, 'lps'),
	(567861, 130, '2014-03-01 01:00:05.000000', 'consum', 0.0227, 'lps'),
	(567862, 130, '2014-03-01 01:00:06.000000', 'consum', 0.0210, 'lps'),
	(567863, 130, '2014-03-01 01:00:07.000000', 'consum', 0.0216, 'lps'),
	(567864, 130, '2014-03-01 01:00:08.000000', 'consum', 0.0220, 'lps'),
	(567865, 130, '2014-03-01 01:00:09.000000', 'consum', 0.0223, 'lps'),
	(567866, 130, '2014-03-01 01:00:10.000000', 'consum', 0.0228, 'lps'),
	(567867, 130, '2014-03-01 01:00:11.000000', 'consum', 0.0223, 'lps'),
	(567868, 130, '2014-03-01 01:00:12.000000', 'consum', 0.0224, 'lps'),
	(567869, 130, '2014-03-01 01:00:13.000000', 'consum', 0.0219, 'lps'),
	(567870, 130, '2014-03-01 01:00:14.000000', 'consum', 0.0216, 'lps'),
	(567871, 130, '2014-03-01 01:00:15.000000', 'consum', 0.0215, 'lps'),
	(567872, 130, '2014-03-01 01:00:16.000000', 'consum', 0.0214, 'lps'),
	(567873, 130, '2014-03-01 01:00:17.000000', 'consum', 0.0216, 'lps'),
	(567874, 130, '2014-03-01 01:00:18.000000', 'consum', 0.0212, 'lps'),
	(567875, 130, '2014-03-01 01:00:19.000000', 'consum', 0.0220, 'lps'),
	(567876, 130, '2014-03-01 01:00:20.000000', 'consum', 0.0218, 'lps'),
	(567877, 130, '2014-03-01 01:00:21.000000', 'consum', 0.0218, 'lps'),
	(567878, 130, '2014-03-01 01:00:22.000000', 'consum', 0.0225, 'lps'),
	(567879, 130, '2014-03-01 01:00:23.000000', 'consum', 0.0227, 'lps'),
	(567880, 130, '2014-03-01 01:00:24.000000', 'consum', 0.0212, 'lps'),
	(567881, 130, '2014-03-01 01:00:25.000000', 'consum', 0.0226, 'lps'),
	(567882, 130, '2014-03-01 01:00:26.000000', 'consum', 0.0210, 'lps'),
	(567883, 130, '2014-03-01 01:00:27.000000', 'consum', 0.0218, 'lps'),
	(567884, 130, '2014-03-01 01:00:28.000000', 'consum', 0.0213, 'lps'),
	(567885, 130, '2014-03-01 01:00:29.000000', 'consum', 0.0219, 'lps'),
	(567886, 130, '2014-03-01 01:00:30.000000', 'consum', 0.0211, 'lps'),
	(567887, 130, '2014-03-01 01:00:31.000000', 'consum', 0.0224, 'lps'),
	(567888, 130, '2014-03-01 01:00:32.000000', 'consum', 0.0220, 'lps'),
	(567889, 130, '2014-03-01 01:00:33.000000', 'consum', 0.0221, 'lps'),
	(567890, 130, '2014-03-01 01:00:34.000000', 'consum', 0.0217, 'lps'),
	(567891, 130, '2014-03-01 01:00:35.000000', 'consum', 0.0214, 'lps'),
	(567892, 130, '2014-03-01 01:00:36.000000', 'consum', 0.0225, 'lps'),
	(567893, 130, '2014-03-01 01:00:37.000000', 'consum', 0.0217, 'lps'),
	(567894, 130, '2014-03-01 01:00:38.000000', 'consum', 0.0222, 'lps'),
	(567895, 130, '2014-03-01 01:00:39.000000', 'consum', 0.0227, 'lps'),
	(567896, 130, '2014-03-01 01:00:40.000000', 'consum', 0.0225, 'lps'),
	(567897, 130, '2014-03-01 01:00:41.000000', 'consum', 0.0213, 'lps'),
	(567898, 130, '2014-03-01 01:00:42.000000', 'consum', 0.0221, 'lps'),
	(567899, 130, '2014-03-01 01:00:43.000000', 'consum', 0.0217, 'lps'),
	(567900, 130, '2014-03-01 01:00:44.000000', 'consum', 0.0213, 'lps'),
	(567901, 130, '2014-03-01 01:00:45.000000', 'consum', 0.0224, 'lps'),
	(567902, 130, '2014-03-01 01:00:46.000000', 'consum', 0.0213, 'lps'),
	(567903, 130, '2014-03-01 01:00:47.000000', 'consum', 0.0221, 'lps'),
	(567904, 130, '2014-03-01 01:00:48.000000', 'consum', 0.0217, 'lps'),
	(567905, 130, '2014-03-01 01:00:49.000000', 'consum', 0.0216, 'lps'),
	(567906, 130, '2014-03-01 01:00:50.000000', 'consum', 0.0219, 'lps'),
	(567907, 130, '2014-03-01 01:00:51.000000', 'consum', 0.0218, 'lps'),
	(567908, 130, '2014-03-01 01:00:52.000000', 'consum', 0.0222, 'lps'),
	(567909, 130, '2014-03-01 01:00:53.000000', 'consum', 0.0228, 'lps'),
	(567910, 130, '2014-03-01 01:00:54.000000', 'consum', 0.0210, 'lps'),
	(567911, 130, '2014-03-01 01:00:55.000000', 'consum', 0.0210, 'lps'),
	(567912, 130, '2014-03-01 01:00:56.000000', 'consum', 0.0212, 'lps'),
	(567913, 130, '2014-03-01 01:00:57.000000', 'consum', 0.0221, 'lps'),
	(567914, 130, '2014-03-01 01:00:58.000000', 'consum', 0.0223, 'lps'),
	(567915, 130, '2014-03-01 01:00:59.000000', 'consum', 0.0221, 'lps'),
	(567916, 130, '2014-03-01 01:01:00.000000', 'consum', 0.0210, 'lps'),
	(567917, 130, '2014-03-01 01:01:01.000000', 'consum', 0.0216, 'lps'),
	(567918, 130, '2014-03-01 01:01:02.000000', 'consum', 0.0220, 'lps'),
	(567919, 130, '2014-03-01 01:01:03.000000', 'consum', 0.0224, 'lps'),
	(567920, 130, '2014-03-01 01:01:04.000000', 'consum', 0.0212, 'lps'),
	(567921, 130, '2014-03-01 01:01:05.000000', 'consum', 0.0218, 'lps'),
	(567922, 130, '2014-03-01 01:01:06.000000', 'consum', 0.0225, 'lps'),
	(567923, 130, '2014-03-01 01:01:07.000000', 'consum', 0.0223, 'lps'),
	(567924, 130, '2014-03-01 01:01:08.000000', 'consum', 0.0213, 'lps'),
	(567925, 130, '2014-03-01 01:01:09.000000', 'consum', 0.0225, 'lps'),
	(567926, 130, '2014-03-01 01:01:10.000000', 'consum', 0.0219, 'lps'),
	(567927, 130, '2014-03-01 01:01:11.000000', 'consum', 0.0227, 'lps'),
	(567928, 130, '2014-03-01 01:01:12.000000', 'consum', 0.0214, 'lps'),
	(567929, 130, '2014-03-01 01:01:13.000000', 'consum', 0.0218, 'lps'),
	(567930, 130, '2014-03-01 01:01:14.000000', 'consum', 0.0217, 'lps'),
	(567931, 130, '2014-03-01 01:01:15.000000', 'consum', 0.0223, 'lps'),
	(567932, 130, '2014-03-01 01:01:16.000000', 'consum', 0.0215, 'lps'),
	(567933, 130, '2014-03-01 01:01:17.000000', 'consum', 0.0217, 'lps'),
	(567934, 130, '2014-03-01 01:01:18.000000', 'consum', 0.0210, 'lps'),
	(567935, 130, '2014-03-01 01:01:19.000000', 'consum', 0.0227, 'lps'),
	(567936, 130, '2014-03-01 01:01:20.000000', 'consum', 0.0219, 'lps'),
	(567937, 130, '2014-03-01 01:01:21.000000', 'consum', 0.0224, 'lps'),
	(567938, 130, '2014-03-01 01:01:22.000000', 'consum', 0.0214, 'lps'),
	(567939, 130, '2014-03-01 01:01:23.000000', 'consum', 0.0211, 'lps'),
	(567940, 130, '2014-03-01 01:01:24.000000', 'consum', 0.0220, 'lps'),
	(567941, 130, '2014-03-01 01:01:25.000000', 'consum', 0.0219, 'lps'),
	(567942, 130, '2014-03-01 01:01:26.000000', 'consum', 0.0225, 'lps'),
	(567943, 130, '2014-03-01 01:01:27.000000', 'consum', 0.0223, 'lps'),
	(567944, 130, '2014-03-01 01:01:28.000000', 'consum', 0.0213, 'lps'),
	(567945, 130, '2014-03-01 01:01:29.000000', 'consum', 0.0221, 'lps'),
	(567946, 130, '2014-03-01 01:01:30.000000', 'consum', 0.0218, 'lps'),
	(567947, 130, '2014-03-01 01:01:31.000000', 'consum', 0.0218, 'lps'),
	(567948, 130, '2014-03-01 01:01:32.000000', 'consum', 0.0226, 'lps'),
	(567949, 130, '2014-03-01 01:01:33.000000', 'consum', 0.0212, 'lps'),
	(567950, 130, '2014-03-01 01:01:34.000000', 'consum', 0.0228, 'lps'),
	(567951, 130, '2014-03-01 01:01:35.000000', 'consum', 0.0219, 'lps'),
	(567952, 130, '2014-03-01 01:01:36.000000', 'consum', 0.0221, 'lps'),
	(567953, 130, '2014-03-01 01:01:37.000000', 'consum', 0.0221, 'lps'),
	(567954, 130, '2014-03-01 01:01:38.000000', 'consum', 0.0211, 'lps'),
	(567955, 130, '2014-03-01 01:01:39.000000', 'consum', 0.0220, 'lps'),
	(567956, 130, '2014-03-01 01:01:40.000000', 'consum', 0.0221, 'lps'),
	(567957, 130, '2014-03-01 01:01:41.000000', 'consum', 0.0217, 'lps'),
	(567958, 130, '2014-03-01 01:01:42.000000', 'consum', 0.0212, 'lps'),
	(567959, 130, '2014-03-01 01:01:43.000000', 'consum', 0.0219, 'lps'),
	(567960, 130, '2014-03-01 01:01:44.000000', 'consum', 0.0228, 'lps'),
	(567961, 130, '2014-03-01 01:01:45.000000', 'consum', 0.0220, 'lps'),
	(567962, 130, '2014-03-01 01:01:46.000000', 'consum', 0.0223, 'lps'),
	(567963, 130, '2014-03-01 01:01:47.000000', 'consum', 0.0226, 'lps'),
	(567964, 130, '2014-03-01 01:01:48.000000', 'consum', 0.0217, 'lps'),
	(567965, 130, '2014-03-01 01:01:49.000000', 'consum', 0.0213, 'lps'),
	(567966, 130, '2014-03-01 01:01:50.000000', 'consum', 0.0223, 'lps'),
	(567967, 130, '2014-03-01 01:01:51.000000', 'consum', 0.0210, 'lps'),
	(567968, 130, '2014-03-01 01:01:52.000000', 'consum', 0.0210, 'lps'),
	(567969, 130, '2014-03-01 01:01:53.000000', 'consum', 0.0211, 'lps'),
	(567970, 130, '2014-03-01 01:01:54.000000', 'consum', 0.0213, 'lps'),
	(567971, 130, '2014-03-01 01:01:55.000000', 'consum', 0.0225, 'lps'),
	(567972, 130, '2014-03-01 01:01:56.000000', 'consum', 0.0218, 'lps'),
	(567973, 130, '2014-03-01 01:01:57.000000', 'consum', 0.0225, 'lps'),
	(567974, 130, '2014-03-01 01:01:58.000000', 'consum', 0.0223, 'lps'),
	(567975, 130, '2014-03-01 01:01:59.000000', 'consum', 0.0213, 'lps'),
	(567976, 130, '2014-03-01 01:02:00.000000', 'consum', 0.0225, 'lps'),
	(567977, 130, '2014-03-01 01:02:01.000000', 'consum', 0.0220, 'lps'),
	(567978, 130, '2014-03-01 01:02:02.000000', 'consum', 0.0213, 'lps'),
	(567979, 130, '2014-03-01 01:02:03.000000', 'consum', 0.0216, 'lps'),
	(567980, 130, '2014-03-01 01:02:04.000000', 'consum', 0.0211, 'lps'),
	(567981, 130, '2014-03-01 01:02:05.000000', 'consum', 0.0216, 'lps'),
	(567982, 130, '2014-03-01 01:02:06.000000', 'consum', 0.0218, 'lps'),
	(567983, 130, '2014-03-01 01:02:07.000000', 'consum', 0.0214, 'lps'),
	(567984, 130, '2014-03-01 01:02:08.000000', 'consum', 0.0228, 'lps'),
	(567985, 130, '2014-03-01 01:02:09.000000', 'consum', 0.0210, 'lps'),
	(567986, 130, '2014-03-01 01:02:10.000000', 'consum', 0.0213, 'lps'),
	(567987, 130, '2014-03-01 01:02:11.000000', 'consum', 0.0226, 'lps'),
	(567988, 130, '2014-03-01 01:02:12.000000', 'consum', 0.0225, 'lps'),
	(567989, 130, '2014-03-01 01:02:13.000000', 'consum', 0.0218, 'lps'),
	(567990, 130, '2014-03-01 01:02:14.000000', 'consum', 0.0223, 'lps'),
	(567991, 130, '2014-03-01 01:02:15.000000', 'consum', 0.0214, 'lps'),
	(567992, 130, '2014-03-01 01:02:16.000000', 'consum', 0.0228, 'lps'),
	(567993, 130, '2014-03-01 01:02:17.000000', 'consum', 0.0214, 'lps'),
	(567994, 130, '2014-03-01 01:02:18.000000', 'consum', 0.0216, 'lps'),
	(567995, 130, '2014-03-01 01:02:19.000000', 'consum', 0.0227, 'lps'),
	(567996, 130, '2014-03-01 01:02:20.000000', 'consum', 0.0220, 'lps'),
	(567997, 130, '2014-03-01 01:02:21.000000', 'consum', 0.0227, 'lps'),
	(567998, 130, '2014-03-01 01:02:22.000000', 'consum', 0.0211, 'lps'),
	(567999, 130, '2014-03-01 01:02:23.000000', 'consum', 0.0219, 'lps'),
	(568000, 130, '2014-03-01 01:02:24.000000', 'consum', 0.0217, 'lps'),
	(568001, 130, '2014-03-01 01:02:25.000000', 'consum', 0.0217, 'lps'),
	(568002, 130, '2014-03-01 01:02:26.000000', 'consum', 0.0223, 'lps'),
	(568003, 130, '2014-03-01 01:02:27.000000', 'consum', 0.0217, 'lps'),
	(568004, 130, '2014-03-01 01:02:28.000000', 'consum', 0.0228, 'lps'),
	(568005, 130, '2014-03-01 01:02:29.000000', 'consum', 0.0220, 'lps'),
	(568006, 130, '2014-03-01 01:02:30.000000', 'consum', 0.0225, 'lps'),
	(568007, 130, '2014-03-01 01:02:31.000000', 'consum', 0.0218, 'lps'),
	(568008, 130, '2014-03-01 01:02:32.000000', 'consum', 0.0224, 'lps'),
	(568009, 130, '2014-03-01 01:02:33.000000', 'consum', 0.0221, 'lps'),
	(568010, 130, '2014-03-01 01:02:34.000000', 'consum', 0.0221, 'lps'),
	(568011, 130, '2014-03-01 01:02:35.000000', 'consum', 0.0214, 'lps'),
	(568012, 130, '2014-03-01 01:02:36.000000', 'consum', 0.0217, 'lps'),
	(568013, 130, '2014-03-01 01:02:37.000000', 'consum', 0.0214, 'lps'),
	(568014, 130, '2014-03-01 01:02:38.000000', 'consum', 0.0212, 'lps'),
	(568015, 130, '2014-03-01 01:02:39.000000', 'consum', 0.0224, 'lps'),
	(568016, 130, '2014-03-01 01:02:40.000000', 'consum', 0.0219, 'lps'),
	(568017, 130, '2014-03-01 01:02:41.000000', 'consum', 0.0214, 'lps'),
	(568018, 130, '2014-03-01 01:02:42.000000', 'consum', 0.0224, 'lps'),
	(568019, 130, '2014-03-01 01:02:43.000000', 'consum', 0.0228, 'lps'),
	(568020, 130, '2014-03-01 01:02:44.000000', 'consum', 0.0221, 'lps'),
	(568021, 130, '2014-03-01 01:02:45.000000', 'consum', 0.0213, 'lps'),
	(568022, 130, '2014-03-01 01:02:46.000000', 'consum', 0.0210, 'lps'),
	(568023, 130, '2014-03-01 01:02:47.000000', 'consum', 0.0220, 'lps'),
	(568024, 130, '2014-03-01 01:02:48.000000', 'consum', 0.0225, 'lps'),
	(568025, 130, '2014-03-01 01:02:49.000000', 'consum', 0.0215, 'lps'),
	(568026, 130, '2014-03-01 01:02:50.000000', 'consum', 0.0211, 'lps'),
	(568027, 130, '2014-03-01 01:02:51.000000', 'consum', 0.0217, 'lps'),
	(568028, 130, '2014-03-01 01:02:52.000000', 'consum', 0.0225, 'lps'),
	(568029, 130, '2014-03-01 01:02:53.000000', 'consum', 0.0226, 'lps'),
	(568030, 130, '2014-03-01 01:02:54.000000', 'consum', 0.0227, 'lps'),
	(568031, 130, '2014-03-01 01:02:55.000000', 'consum', 0.0228, 'lps'),
	(568032, 130, '2014-03-01 01:02:56.000000', 'consum', 0.0211, 'lps'),
	(568033, 130, '2014-03-01 01:02:57.000000', 'consum', 0.0219, 'lps'),
	(568034, 130, '2014-03-01 01:02:58.000000', 'consum', 0.0216, 'lps'),
	(568035, 130, '2014-03-01 01:02:59.000000', 'consum', 0.0214, 'lps'),
	(568036, 130, '2014-03-01 01:03:00.000000', 'consum', 0.0228, 'lps'),
	(568037, 130, '2014-03-01 01:03:01.000000', 'consum', 0.0216, 'lps'),
	(568038, 130, '2014-03-01 01:03:02.000000', 'consum', 0.0223, 'lps'),
	(568039, 130, '2014-03-01 01:03:03.000000', 'consum', 0.0221, 'lps'),
	(568040, 130, '2014-03-01 01:03:04.000000', 'consum', 0.0226, 'lps'),
	(568041, 130, '2014-03-01 01:03:05.000000', 'consum', 0.0217, 'lps'),
	(568042, 130, '2014-03-01 01:03:06.000000', 'consum', 0.0220, 'lps'),
	(568043, 130, '2014-03-01 01:03:07.000000', 'consum', 0.0220, 'lps'),
	(568044, 130, '2014-03-01 01:03:08.000000', 'consum', 0.0210, 'lps'),
	(568045, 130, '2014-03-01 01:03:09.000000', 'consum', 0.0221, 'lps'),
	(568046, 130, '2014-03-01 01:03:10.000000', 'consum', 0.0226, 'lps'),
	(568047, 130, '2014-03-01 01:03:11.000000', 'consum', 0.0222, 'lps'),
	(568048, 130, '2014-03-01 01:03:12.000000', 'consum', 0.0220, 'lps'),
	(568049, 130, '2014-03-01 01:03:13.000000', 'consum', 0.0223, 'lps'),
	(568050, 130, '2014-03-01 01:03:14.000000', 'consum', 0.0228, 'lps'),
	(568051, 130, '2014-03-01 01:03:15.000000', 'consum', 0.0224, 'lps'),
	(568052, 130, '2014-03-01 01:03:16.000000', 'consum', 0.0228, 'lps'),
	(568053, 130, '2014-03-01 01:03:17.000000', 'consum', 0.0218, 'lps'),
	(568054, 130, '2014-03-01 01:03:18.000000', 'consum', 0.0217, 'lps'),
	(568055, 130, '2014-03-01 01:03:19.000000', 'consum', 0.0221, 'lps'),
	(568056, 130, '2014-03-01 01:03:20.000000', 'consum', 0.0225, 'lps'),
	(568057, 130, '2014-03-01 01:03:21.000000', 'consum', 0.0215, 'lps'),
	(568058, 130, '2014-03-01 01:03:22.000000', 'consum', 0.0228, 'lps'),
	(568059, 130, '2014-03-01 01:03:23.000000', 'consum', 0.0212, 'lps'),
	(568060, 130, '2014-03-01 01:03:24.000000', 'consum', 0.0220, 'lps'),
	(568061, 130, '2014-03-01 01:03:25.000000', 'consum', 0.0219, 'lps'),
	(568062, 130, '2014-03-01 01:03:26.000000', 'consum', 0.0225, 'lps'),
	(568063, 130, '2014-03-01 01:03:27.000000', 'consum', 0.0221, 'lps'),
	(568064, 130, '2014-03-01 01:03:28.000000', 'consum', 0.0220, 'lps'),
	(568065, 130, '2014-03-01 01:03:29.000000', 'consum', 0.0210, 'lps'),
	(568066, 130, '2014-03-01 01:03:30.000000', 'consum', 0.0219, 'lps'),
	(568067, 130, '2014-03-01 01:03:31.000000', 'consum', 0.0217, 'lps'),
	(568068, 130, '2014-03-01 01:03:32.000000', 'consum', 0.0217, 'lps'),
	(568069, 130, '2014-03-01 01:03:33.000000', 'consum', 0.0226, 'lps'),
	(568070, 130, '2014-03-01 01:03:34.000000', 'consum', 0.0214, 'lps'),
	(568071, 130, '2014-03-01 01:03:35.000000', 'consum', 0.0219, 'lps'),
	(568072, 130, '2014-03-01 01:03:36.000000', 'consum', 0.0224, 'lps'),
	(568073, 130, '2014-03-01 01:03:37.000000', 'consum', 0.0218, 'lps'),
	(568074, 130, '2014-03-01 01:03:38.000000', 'consum', 0.0225, 'lps'),
	(568075, 130, '2014-03-01 01:03:39.000000', 'consum', 0.0226, 'lps'),
	(568076, 130, '2014-03-01 01:03:40.000000', 'consum', 0.0224, 'lps'),
	(568077, 130, '2014-03-01 01:03:41.000000', 'consum', 0.0215, 'lps'),
	(568078, 130, '2014-03-01 01:03:42.000000', 'consum', 0.0210, 'lps'),
	(568079, 130, '2014-03-01 01:03:43.000000', 'consum', 0.0217, 'lps'),
	(568080, 130, '2014-03-01 01:03:44.000000', 'consum', 0.0227, 'lps'),
	(568081, 130, '2014-03-01 01:03:45.000000', 'consum', 0.0215, 'lps'),
	(568082, 130, '2014-03-01 01:03:46.000000', 'consum', 0.0222, 'lps'),
	(568083, 130, '2014-03-01 01:03:47.000000', 'consum', 0.0219, 'lps'),
	(568084, 130, '2014-03-01 01:03:48.000000', 'consum', 0.0220, 'lps'),
	(568085, 130, '2014-03-01 01:03:49.000000', 'consum', 0.0214, 'lps'),
	(568086, 130, '2014-03-01 01:03:50.000000', 'consum', 0.0222, 'lps'),
	(568087, 130, '2014-03-01 01:03:51.000000', 'consum', 0.0217, 'lps'),
	(568088, 130, '2014-03-01 01:03:52.000000', 'consum', 0.0210, 'lps'),
	(568089, 130, '2014-03-01 01:03:53.000000', 'consum', 0.0211, 'lps'),
	(568090, 130, '2014-03-01 01:03:54.000000', 'consum', 0.0215, 'lps'),
	(568091, 130, '2014-03-01 01:03:55.000000', 'consum', 0.0211, 'lps'),
	(568092, 130, '2014-03-01 01:03:56.000000', 'consum', 0.0221, 'lps'),
	(568093, 130, '2014-03-01 01:03:57.000000', 'consum', 0.0224, 'lps'),
	(568094, 130, '2014-03-01 01:03:58.000000', 'consum', 0.0227, 'lps'),
	(568095, 130, '2014-03-01 01:03:59.000000', 'consum', 0.0218, 'lps'),
	(568096, 130, '2014-03-01 01:04:00.000000', 'consum', 0.0217, 'lps'),
	(568097, 130, '2014-03-01 01:04:01.000000', 'consum', 0.0221, 'lps'),
	(568098, 130, '2014-03-01 01:04:02.000000', 'consum', 0.0228, 'lps'),
	(568099, 130, '2014-03-01 01:04:03.000000', 'consum', 0.0228, 'lps'),
	(568100, 130, '2014-03-01 01:04:04.000000', 'consum', 0.0227, 'lps'),
	(568101, 130, '2014-03-01 01:04:05.000000', 'consum', 0.0223, 'lps'),
	(568102, 130, '2014-03-01 01:04:06.000000', 'consum', 0.0225, 'lps'),
	(568103, 130, '2014-03-01 01:04:07.000000', 'consum', 0.0226, 'lps'),
	(568104, 130, '2014-03-01 01:04:08.000000', 'consum', 0.0225, 'lps'),
	(568105, 130, '2014-03-01 01:04:09.000000', 'consum', 0.0222, 'lps'),
	(568106, 130, '2014-03-01 01:04:10.000000', 'consum', 0.0224, 'lps'),
	(568107, 130, '2014-03-01 01:04:11.000000', 'consum', 0.0226, 'lps'),
	(568108, 130, '2014-03-01 01:04:12.000000', 'consum', 0.0211, 'lps'),
	(568109, 130, '2014-03-01 01:04:13.000000', 'consum', 0.0226, 'lps'),
	(568110, 130, '2014-03-01 01:04:14.000000', 'consum', 0.0228, 'lps'),
	(568111, 130, '2014-03-01 01:04:15.000000', 'consum', 0.0217, 'lps'),
	(568112, 130, '2014-03-01 01:04:16.000000', 'consum', 0.0227, 'lps'),
	(568113, 130, '2014-03-01 01:04:17.000000', 'consum', 0.0219, 'lps'),
	(568114, 130, '2014-03-01 01:04:18.000000', 'consum', 0.0224, 'lps'),
	(568115, 130, '2014-03-01 01:04:19.000000', 'consum', 0.0215, 'lps'),
	(568116, 130, '2014-03-01 01:04:20.000000', 'consum', 0.0210, 'lps'),
	(568117, 130, '2014-03-01 01:04:21.000000', 'consum', 0.0218, 'lps'),
	(568118, 130, '2014-03-01 01:04:22.000000', 'consum', 0.0212, 'lps'),
	(568119, 130, '2014-03-01 01:04:23.000000', 'consum', 0.0215, 'lps'),
	(568120, 130, '2014-03-01 01:04:24.000000', 'consum', 0.0211, 'lps'),
	(568121, 130, '2014-03-01 01:04:25.000000', 'consum', 0.0218, 'lps'),
	(568122, 130, '2014-03-01 01:04:26.000000', 'consum', 0.0210, 'lps'),
	(568123, 130, '2014-03-01 01:04:27.000000', 'consum', 0.0223, 'lps'),
	(568124, 130, '2014-03-01 01:04:28.000000', 'consum', 0.0220, 'lps'),
	(568125, 130, '2014-03-01 01:04:29.000000', 'consum', 0.0220, 'lps'),
	(568126, 130, '2014-03-01 01:04:30.000000', 'consum', 0.0213, 'lps'),
	(568127, 130, '2014-03-01 01:04:31.000000', 'consum', 0.0215, 'lps'),
	(568128, 130, '2014-03-01 01:04:32.000000', 'consum', 0.0224, 'lps'),
	(568129, 130, '2014-03-01 01:04:33.000000', 'consum', 0.0228, 'lps'),
	(568130, 130, '2014-03-01 01:04:34.000000', 'consum', 0.0221, 'lps'),
	(568131, 130, '2014-03-01 01:04:35.000000', 'consum', 0.0210, 'lps'),
	(568132, 130, '2014-03-01 01:04:36.000000', 'consum', 0.0216, 'lps'),
	(568133, 130, '2014-03-01 01:04:37.000000', 'consum', 0.0224, 'lps'),
	(568134, 130, '2014-03-01 01:04:38.000000', 'consum', 0.0221, 'lps'),
	(568135, 130, '2014-03-01 01:04:39.000000', 'consum', 0.0225, 'lps'),
	(568136, 130, '2014-03-01 01:04:40.000000', 'consum', 0.0214, 'lps'),
	(568137, 130, '2014-03-01 01:04:41.000000', 'consum', 0.0222, 'lps'),
	(568138, 130, '2014-03-01 01:04:42.000000', 'consum', 0.0221, 'lps'),
	(568139, 130, '2014-03-01 01:04:43.000000', 'consum', 0.0228, 'lps'),
	(568140, 130, '2014-03-01 01:04:44.000000', 'consum', 0.0214, 'lps'),
	(568141, 130, '2014-03-01 01:04:45.000000', 'consum', 0.0211, 'lps'),
	(568142, 130, '2014-03-01 01:04:46.000000', 'consum', 0.0225, 'lps'),
	(568143, 130, '2014-03-01 01:04:47.000000', 'consum', 0.0224, 'lps'),
	(568144, 130, '2014-03-01 01:04:48.000000', 'consum', 0.0219, 'lps'),
	(568145, 130, '2014-03-01 01:04:49.000000', 'consum', 0.0210, 'lps'),
	(568146, 130, '2014-03-01 01:04:50.000000', 'consum', 0.0225, 'lps'),
	(568147, 130, '2014-03-01 01:04:51.000000', 'consum', 0.0227, 'lps'),
	(568148, 130, '2014-03-01 01:04:52.000000', 'consum', 0.0213, 'lps'),
	(568149, 130, '2014-03-01 01:04:53.000000', 'consum', 0.0212, 'lps'),
	(568150, 130, '2014-03-01 01:04:54.000000', 'consum', 0.0213, 'lps'),
	(568151, 130, '2014-03-01 01:04:55.000000', 'consum', 0.0218, 'lps'),
	(568152, 130, '2014-03-01 01:04:56.000000', 'consum', 0.0223, 'lps'),
	(568153, 130, '2014-03-01 01:04:57.000000', 'consum', 0.0215, 'lps'),
	(568154, 130, '2014-03-01 01:04:58.000000', 'consum', 0.0214, 'lps'),
	(568155, 130, '2014-03-01 01:04:59.000000', 'consum', 0.0214, 'lps'),
	(568156, 130, '2014-03-01 01:05:00.000000', 'consum', 0.0220, 'lps'),
	(568157, 130, '2014-03-01 01:05:01.000000', 'consum', 0.0212, 'lps'),
	(568158, 130, '2014-03-01 01:05:02.000000', 'consum', 0.0225, 'lps'),
	(568159, 130, '2014-03-01 01:05:03.000000', 'consum', 0.0226, 'lps'),
	(568160, 130, '2014-03-01 01:05:04.000000', 'consum', 0.0225, 'lps'),
	(568161, 130, '2014-03-01 01:05:05.000000', 'consum', 0.0220, 'lps'),
	(568162, 130, '2014-03-01 01:05:06.000000', 'consum', 0.0216, 'lps'),
	(568163, 130, '2014-03-01 01:05:07.000000', 'consum', 0.0211, 'lps'),
	(568164, 130, '2014-03-01 01:05:08.000000', 'consum', 0.0215, 'lps'),
	(568165, 130, '2014-03-01 01:05:09.000000', 'consum', 0.0213, 'lps'),
	(568166, 130, '2014-03-01 01:05:10.000000', 'consum', 0.0212, 'lps'),
	(568167, 130, '2014-03-01 01:05:11.000000', 'consum', 0.0212, 'lps'),
	(568168, 130, '2014-03-01 01:05:12.000000', 'consum', 0.0213, 'lps'),
	(568169, 130, '2014-03-01 01:05:13.000000', 'consum', 0.0220, 'lps'),
	(568170, 130, '2014-03-01 01:05:14.000000', 'consum', 0.0215, 'lps'),
	(568171, 130, '2014-03-01 01:05:15.000000', 'consum', 0.0223, 'lps'),
	(568172, 130, '2014-03-01 01:05:16.000000', 'consum', 0.0222, 'lps'),
	(568173, 130, '2014-03-01 01:05:17.000000', 'consum', 0.0214, 'lps'),
	(568174, 130, '2014-03-01 01:05:18.000000', 'consum', 0.0214, 'lps'),
	(568175, 130, '2014-03-01 01:05:19.000000', 'consum', 0.0216, 'lps'),
	(568176, 130, '2014-03-01 01:05:20.000000', 'consum', 0.0212, 'lps'),
	(568177, 130, '2014-03-01 01:05:21.000000', 'consum', 0.0220, 'lps'),
	(568178, 130, '2014-03-01 01:05:22.000000', 'consum', 0.0216, 'lps'),
	(568179, 130, '2014-03-01 01:05:23.000000', 'consum', 0.0212, 'lps'),
	(568180, 130, '2014-03-01 01:05:24.000000', 'consum', 0.0221, 'lps'),
	(568181, 130, '2014-03-01 01:05:25.000000', 'consum', 0.0223, 'lps'),
	(568182, 130, '2014-03-01 01:05:26.000000', 'consum', 0.0222, 'lps'),
	(568183, 130, '2014-03-01 01:05:27.000000', 'consum', 0.0213, 'lps'),
	(568184, 130, '2014-03-01 01:05:28.000000', 'consum', 0.0210, 'lps'),
	(568185, 130, '2014-03-01 01:05:29.000000', 'consum', 0.0219, 'lps'),
	(568186, 130, '2014-03-01 01:05:30.000000', 'consum', 0.0218, 'lps'),
	(568187, 130, '2014-03-01 01:05:31.000000', 'consum', 0.0221, 'lps'),
	(568188, 130, '2014-03-01 01:05:32.000000', 'consum', 0.0225, 'lps'),
	(568189, 130, '2014-03-01 01:05:33.000000', 'consum', 0.0215, 'lps'),
	(568190, 130, '2014-03-01 01:05:34.000000', 'consum', 0.0228, 'lps'),
	(568191, 130, '2014-03-01 01:05:35.000000', 'consum', 0.0211, 'lps'),
	(568192, 130, '2014-03-01 01:05:36.000000', 'consum', 0.0216, 'lps'),
	(568193, 130, '2014-03-01 01:05:37.000000', 'consum', 0.0220, 'lps'),
	(568194, 130, '2014-03-01 01:05:38.000000', 'consum', 0.0223, 'lps'),
	(568195, 130, '2014-03-01 01:05:39.000000', 'consum', 0.0228, 'lps'),
	(568196, 130, '2014-03-01 01:05:40.000000', 'consum', 0.0223, 'lps'),
	(568197, 130, '2014-03-01 01:05:41.000000', 'consum', 0.0221, 'lps'),
	(568198, 130, '2014-03-01 01:05:42.000000', 'consum', 0.0225, 'lps'),
	(568199, 130, '2014-03-01 01:05:43.000000', 'consum', 0.0217, 'lps'),
	(568200, 130, '2014-03-01 01:05:44.000000', 'consum', 0.0219, 'lps'),
	(568201, 130, '2014-03-01 01:05:45.000000', 'consum', 0.0216, 'lps'),
	(568202, 130, '2014-03-01 01:05:46.000000', 'consum', 0.0211, 'lps'),
	(568203, 130, '2014-03-01 01:05:47.000000', 'consum', 0.0217, 'lps'),
	(568204, 130, '2014-03-01 01:05:48.000000', 'consum', 0.0224, 'lps'),
	(568205, 130, '2014-03-01 01:05:49.000000', 'consum', 0.0222, 'lps'),
	(568206, 130, '2014-03-01 01:05:50.000000', 'consum', 0.0211, 'lps'),
	(568207, 130, '2014-03-01 01:05:51.000000', 'consum', 0.0217, 'lps'),
	(568208, 130, '2014-03-01 01:05:52.000000', 'consum', 0.0221, 'lps'),
	(568209, 130, '2014-03-01 01:05:53.000000', 'consum', 0.0228, 'lps'),
	(568210, 130, '2014-03-01 01:05:54.000000', 'consum', 0.0228, 'lps'),
	(568211, 130, '2014-03-01 01:05:55.000000', 'consum', 0.0228, 'lps'),
	(568212, 130, '2014-03-01 01:05:56.000000', 'consum', 0.0227, 'lps'),
	(568213, 130, '2014-03-01 01:05:57.000000', 'consum', 0.0221, 'lps'),
	(568214, 130, '2014-03-01 01:05:58.000000', 'consum', 0.0217, 'lps'),
	(568215, 130, '2014-03-01 01:05:59.000000', 'consum', 0.0210, 'lps'),
	(568216, 130, '2014-03-01 01:06:00.000000', 'consum', 0.0211, 'lps'),
	(568217, 130, '2014-03-01 01:06:01.000000', 'consum', 0.0216, 'lps'),
	(568218, 130, '2014-03-01 01:06:02.000000', 'consum', 0.0219, 'lps'),
	(568219, 130, '2014-03-01 01:06:03.000000', 'consum', 0.0217, 'lps'),
	(568220, 130, '2014-03-01 01:06:04.000000', 'consum', 0.0218, 'lps'),
	(568221, 130, '2014-03-01 01:06:05.000000', 'consum', 0.0211, 'lps'),
	(568222, 130, '2014-03-01 01:06:06.000000', 'consum', 0.0228, 'lps'),
	(568223, 130, '2014-03-01 01:06:07.000000', 'consum', 0.0222, 'lps'),
	(568224, 130, '2014-03-01 01:06:08.000000', 'consum', 0.0218, 'lps'),
	(568225, 130, '2014-03-01 01:06:09.000000', 'consum', 0.0215, 'lps'),
	(568226, 130, '2014-03-01 01:06:10.000000', 'consum', 0.0210, 'lps'),
	(568227, 130, '2014-03-01 01:06:11.000000', 'consum', 0.0216, 'lps'),
	(568228, 130, '2014-03-01 01:06:12.000000', 'consum', 0.0221, 'lps'),
	(568229, 130, '2014-03-01 01:06:13.000000', 'consum', 0.0227, 'lps'),
	(568230, 130, '2014-03-01 01:06:14.000000', 'consum', 0.0224, 'lps'),
	(568231, 130, '2014-03-01 01:06:15.000000', 'consum', 0.0210, 'lps'),
	(568232, 130, '2014-03-01 01:06:16.000000', 'consum', 0.0228, 'lps'),
	(568233, 130, '2014-03-01 01:06:17.000000', 'consum', 0.0222, 'lps'),
	(568234, 130, '2014-03-01 01:06:18.000000', 'consum', 0.0217, 'lps'),
	(568235, 130, '2014-03-01 01:06:19.000000', 'consum', 0.0227, 'lps'),
	(568236, 130, '2014-03-01 01:06:20.000000', 'consum', 0.0220, 'lps'),
	(568237, 130, '2014-03-01 01:06:21.000000', 'consum', 0.0226, 'lps'),
	(568238, 130, '2014-03-01 01:06:22.000000', 'consum', 0.0225, 'lps'),
	(568239, 130, '2014-03-01 01:06:23.000000', 'consum', 0.0216, 'lps'),
	(568240, 130, '2014-03-01 01:06:24.000000', 'consum', 0.0215, 'lps'),
	(568241, 130, '2014-03-01 01:06:25.000000', 'consum', 0.0219, 'lps'),
	(568242, 130, '2014-03-01 01:06:26.000000', 'consum', 0.0221, 'lps'),
	(568243, 130, '2014-03-01 01:06:27.000000', 'consum', 0.0220, 'lps'),
	(568244, 130, '2014-03-01 01:06:28.000000', 'consum', 0.0225, 'lps'),
	(568245, 130, '2014-03-01 01:06:29.000000', 'consum', 0.0220, 'lps'),
	(568246, 130, '2014-03-01 01:06:30.000000', 'consum', 0.0214, 'lps'),
	(568247, 130, '2014-03-01 01:06:31.000000', 'consum', 0.0219, 'lps'),
	(568248, 130, '2014-03-01 01:06:32.000000', 'consum', 0.0224, 'lps'),
	(568249, 130, '2014-03-01 01:06:33.000000', 'consum', 0.0218, 'lps'),
	(568250, 130, '2014-03-01 01:06:34.000000', 'consum', 0.0228, 'lps'),
	(568251, 130, '2014-03-01 01:06:35.000000', 'consum', 0.0219, 'lps'),
	(568252, 130, '2014-03-01 01:06:36.000000', 'consum', 0.0222, 'lps'),
	(568253, 130, '2014-03-01 01:06:37.000000', 'consum', 0.0224, 'lps'),
	(568254, 130, '2014-03-01 01:06:38.000000', 'consum', 0.0225, 'lps'),
	(568255, 130, '2014-03-01 01:06:39.000000', 'consum', 0.0223, 'lps'),
	(568256, 130, '2014-03-01 01:06:40.000000', 'consum', 0.0212, 'lps'),
	(568257, 130, '2014-03-01 01:06:41.000000', 'consum', 0.0220, 'lps'),
	(568258, 130, '2014-03-01 01:06:42.000000', 'consum', 0.0215, 'lps'),
	(568259, 130, '2014-03-01 01:06:43.000000', 'consum', 0.0227, 'lps'),
	(568260, 130, '2014-03-01 01:06:44.000000', 'consum', 0.0222, 'lps'),
	(568261, 130, '2014-03-01 01:06:45.000000', 'consum', 0.0220, 'lps'),
	(568262, 130, '2014-03-01 01:06:46.000000', 'consum', 0.0226, 'lps'),
	(568263, 130, '2014-03-01 01:06:47.000000', 'consum', 0.0221, 'lps'),
	(568264, 130, '2014-03-01 01:06:48.000000', 'consum', 0.0218, 'lps'),
	(568265, 130, '2014-03-01 01:06:49.000000', 'consum', 0.0219, 'lps'),
	(568266, 130, '2014-03-01 01:06:50.000000', 'consum', 0.0213, 'lps'),
	(568267, 130, '2014-03-01 01:06:51.000000', 'consum', 0.0215, 'lps'),
	(568268, 130, '2014-03-01 01:06:52.000000', 'consum', 0.0228, 'lps'),
	(568269, 130, '2014-03-01 01:06:53.000000', 'consum', 0.0211, 'lps'),
	(568270, 130, '2014-03-01 01:06:54.000000', 'consum', 0.0218, 'lps'),
	(568271, 130, '2014-03-01 01:06:55.000000', 'consum', 0.0227, 'lps'),
	(568272, 130, '2014-03-01 01:06:56.000000', 'consum', 0.0217, 'lps'),
	(568273, 130, '2014-03-01 01:06:57.000000', 'consum', 0.0212, 'lps'),
	(568274, 130, '2014-03-01 01:06:58.000000', 'consum', 0.0221, 'lps'),
	(568275, 130, '2014-03-01 01:06:59.000000', 'consum', 0.0218, 'lps'),
	(568276, 130, '2014-03-01 01:07:00.000000', 'consum', 0.0219, 'lps'),
	(568277, 130, '2014-03-01 01:07:01.000000', 'consum', 0.0211, 'lps'),
	(568278, 130, '2014-03-01 01:07:02.000000', 'consum', 0.0227, 'lps'),
	(568279, 130, '2014-03-01 01:07:03.000000', 'consum', 0.0218, 'lps'),
	(568280, 130, '2014-03-01 01:07:04.000000', 'consum', 0.0217, 'lps'),
	(568281, 130, '2014-03-01 01:07:05.000000', 'consum', 0.0223, 'lps'),
	(568282, 130, '2014-03-01 01:07:06.000000', 'consum', 0.0214, 'lps'),
	(568283, 130, '2014-03-01 01:07:07.000000', 'consum', 0.0214, 'lps'),
	(568284, 130, '2014-03-01 01:07:08.000000', 'consum', 0.0215, 'lps'),
	(568285, 130, '2014-03-01 01:07:09.000000', 'consum', 0.0225, 'lps'),
	(568286, 130, '2014-03-01 01:07:10.000000', 'consum', 0.0213, 'lps'),
	(568287, 130, '2014-03-01 01:07:11.000000', 'consum', 0.0219, 'lps'),
	(568288, 130, '2014-03-01 01:07:12.000000', 'consum', 0.0228, 'lps'),
	(568289, 130, '2014-03-01 01:07:13.000000', 'consum', 0.0218, 'lps'),
	(568290, 130, '2014-03-01 01:07:14.000000', 'consum', 0.0213, 'lps'),
	(568291, 130, '2014-03-01 01:07:15.000000', 'consum', 0.0221, 'lps'),
	(568292, 130, '2014-03-01 01:07:16.000000', 'consum', 0.0218, 'lps'),
	(568293, 130, '2014-03-01 01:07:17.000000', 'consum', 0.0216, 'lps'),
	(568294, 130, '2014-03-01 01:07:18.000000', 'consum', 0.0220, 'lps'),
	(568295, 130, '2014-03-01 01:07:19.000000', 'consum', 0.0221, 'lps'),
	(568296, 130, '2014-03-01 01:07:20.000000', 'consum', 0.0218, 'lps'),
	(568297, 130, '2014-03-01 01:07:21.000000', 'consum', 0.0217, 'lps'),
	(568298, 130, '2014-03-01 01:07:22.000000', 'consum', 0.0221, 'lps'),
	(568299, 130, '2014-03-01 01:07:23.000000', 'consum', 0.0226, 'lps'),
	(568300, 130, '2014-03-01 01:07:24.000000', 'consum', 0.0220, 'lps'),
	(568301, 130, '2014-03-01 01:07:25.000000', 'consum', 0.0211, 'lps'),
	(568302, 130, '2014-03-01 01:07:26.000000', 'consum', 0.0222, 'lps'),
	(568303, 130, '2014-03-01 01:07:27.000000', 'consum', 0.0214, 'lps'),
	(568304, 130, '2014-03-01 01:07:28.000000', 'consum', 0.0211, 'lps'),
	(568305, 130, '2014-03-01 01:07:29.000000', 'consum', 0.0221, 'lps'),
	(568306, 130, '2014-03-01 01:07:30.000000', 'consum', 0.0227, 'lps'),
	(568307, 130, '2014-03-01 01:07:31.000000', 'consum', 0.0223, 'lps'),
	(568308, 130, '2014-03-01 01:07:32.000000', 'consum', 0.0224, 'lps'),
	(568309, 130, '2014-03-01 01:07:33.000000', 'consum', 0.0225, 'lps'),
	(568310, 130, '2014-03-01 01:07:34.000000', 'consum', 0.0224, 'lps'),
	(568311, 130, '2014-03-01 01:07:35.000000', 'consum', 0.0215, 'lps'),
	(568312, 130, '2014-03-01 01:07:36.000000', 'consum', 0.0212, 'lps'),
	(568313, 130, '2014-03-01 01:07:37.000000', 'consum', 0.0227, 'lps'),
	(568314, 130, '2014-03-01 01:07:38.000000', 'consum', 0.0210, 'lps'),
	(568315, 130, '2014-03-01 01:07:39.000000', 'consum', 0.0219, 'lps'),
	(568316, 130, '2014-03-01 01:07:40.000000', 'consum', 0.0218, 'lps'),
	(568317, 130, '2014-03-01 01:07:41.000000', 'consum', 0.0222, 'lps'),
	(568318, 130, '2014-03-01 01:07:42.000000', 'consum', 0.0211, 'lps'),
	(568319, 130, '2014-03-01 01:07:43.000000', 'consum', 0.0216, 'lps'),
	(568320, 130, '2014-03-01 01:07:44.000000', 'consum', 0.0220, 'lps'),
	(568321, 130, '2014-03-01 01:07:45.000000', 'consum', 0.0224, 'lps'),
	(568322, 130, '2014-03-01 01:07:46.000000', 'consum', 0.0213, 'lps'),
	(568323, 130, '2014-03-01 01:07:47.000000', 'consum', 0.0220, 'lps'),
	(568324, 130, '2014-03-01 01:07:48.000000', 'consum', 0.0212, 'lps'),
	(568325, 130, '2014-03-01 01:07:49.000000', 'consum', 0.0210, 'lps'),
	(568326, 130, '2014-03-01 01:07:50.000000', 'consum', 0.0223, 'lps'),
	(568327, 130, '2014-03-01 01:07:51.000000', 'consum', 0.0217, 'lps'),
	(568328, 130, '2014-03-01 01:07:52.000000', 'consum', 0.0228, 'lps'),
	(568329, 130, '2014-03-01 01:07:53.000000', 'consum', 0.0221, 'lps'),
	(568330, 130, '2014-03-01 01:07:54.000000', 'consum', 0.0212, 'lps'),
	(568331, 130, '2014-03-01 01:07:55.000000', 'consum', 0.0225, 'lps'),
	(568332, 130, '2014-03-01 01:07:56.000000', 'consum', 0.0223, 'lps'),
	(568333, 130, '2014-03-01 01:07:57.000000', 'consum', 0.0210, 'lps'),
	(568334, 130, '2014-03-01 01:07:58.000000', 'consum', 0.0212, 'lps'),
	(568335, 130, '2014-03-01 01:07:59.000000', 'consum', 0.0221, 'lps'),
	(568336, 130, '2014-03-01 01:08:00.000000', 'consum', 0.0219, 'lps'),
	(568337, 130, '2014-03-01 01:08:01.000000', 'consum', 0.0222, 'lps'),
	(568338, 130, '2014-03-01 01:08:02.000000', 'consum', 0.0225, 'lps'),
	(568339, 130, '2014-03-01 01:08:03.000000', 'consum', 0.0213, 'lps'),
	(568340, 130, '2014-03-01 01:08:04.000000', 'consum', 0.0216, 'lps'),
	(568341, 130, '2014-03-01 01:08:05.000000', 'consum', 0.0215, 'lps'),
	(568342, 130, '2014-03-01 01:08:06.000000', 'consum', 0.0215, 'lps'),
	(568343, 130, '2014-03-01 01:08:07.000000', 'consum', 0.0222, 'lps'),
	(568344, 130, '2014-03-01 01:08:08.000000', 'consum', 0.0216, 'lps'),
	(568345, 130, '2014-03-01 01:08:09.000000', 'consum', 0.0225, 'lps'),
	(568346, 130, '2014-03-01 01:08:10.000000', 'consum', 0.0210, 'lps'),
	(568347, 130, '2014-03-01 01:08:11.000000', 'consum', 0.0225, 'lps'),
	(568348, 130, '2014-03-01 01:08:12.000000', 'consum', 0.0225, 'lps'),
	(568349, 130, '2014-03-01 01:08:13.000000', 'consum', 0.0223, 'lps'),
	(568350, 130, '2014-03-01 01:08:14.000000', 'consum', 0.0211, 'lps'),
	(568351, 130, '2014-03-01 01:08:15.000000', 'consum', 0.0214, 'lps'),
	(568352, 130, '2014-03-01 01:08:16.000000', 'consum', 0.0211, 'lps'),
	(568353, 130, '2014-03-01 01:08:17.000000', 'consum', 0.0221, 'lps'),
	(568354, 130, '2014-03-01 01:08:18.000000', 'consum', 0.0223, 'lps'),
	(568355, 130, '2014-03-01 01:08:19.000000', 'consum', 0.0223, 'lps'),
	(568356, 130, '2014-03-01 01:08:20.000000', 'consum', 0.0218, 'lps'),
	(568357, 130, '2014-03-01 01:08:21.000000', 'consum', 0.0211, 'lps'),
	(568358, 130, '2014-03-01 01:08:22.000000', 'consum', 0.0213, 'lps'),
	(568359, 130, '2014-03-01 01:08:23.000000', 'consum', 0.0220, 'lps'),
	(568360, 130, '2014-03-01 01:08:24.000000', 'consum', 0.0216, 'lps'),
	(568361, 130, '2014-03-01 01:08:25.000000', 'consum', 0.0210, 'lps'),
	(568362, 130, '2014-03-01 01:08:26.000000', 'consum', 0.0210, 'lps'),
	(568363, 130, '2014-03-01 01:08:27.000000', 'consum', 0.0212, 'lps'),
	(568364, 130, '2014-03-01 01:08:28.000000', 'consum', 0.0222, 'lps'),
	(568365, 130, '2014-03-01 01:08:29.000000', 'consum', 0.0225, 'lps'),
	(568366, 130, '2014-03-01 01:08:30.000000', 'consum', 0.0213, 'lps'),
	(568367, 130, '2014-03-01 01:08:31.000000', 'consum', 0.0219, 'lps'),
	(568368, 130, '2014-03-01 01:08:32.000000', 'consum', 0.0225, 'lps'),
	(568369, 130, '2014-03-01 01:08:33.000000', 'consum', 0.0220, 'lps'),
	(568370, 130, '2014-03-01 01:08:34.000000', 'consum', 0.0218, 'lps'),
	(568371, 130, '2014-03-01 01:08:35.000000', 'consum', 0.0220, 'lps'),
	(568372, 130, '2014-03-01 01:08:36.000000', 'consum', 0.0218, 'lps'),
	(568373, 130, '2014-03-01 01:08:37.000000', 'consum', 0.0221, 'lps'),
	(568374, 130, '2014-03-01 01:08:38.000000', 'consum', 0.0223, 'lps'),
	(568375, 130, '2014-03-01 01:08:39.000000', 'consum', 0.0223, 'lps'),
	(568376, 130, '2014-03-01 01:08:40.000000', 'consum', 0.0219, 'lps'),
	(568377, 130, '2014-03-01 01:08:41.000000', 'consum', 0.0215, 'lps'),
	(568378, 130, '2014-03-01 01:08:42.000000', 'consum', 0.0210, 'lps'),
	(568379, 130, '2014-03-01 01:08:43.000000', 'consum', 0.0213, 'lps'),
	(568380, 130, '2014-03-01 01:08:44.000000', 'consum', 0.0227, 'lps'),
	(568381, 130, '2014-03-01 01:08:45.000000', 'consum', 0.0211, 'lps'),
	(568382, 130, '2014-03-01 01:08:46.000000', 'consum', 0.0220, 'lps'),
	(568383, 130, '2014-03-01 01:08:47.000000', 'consum', 0.0221, 'lps'),
	(568384, 130, '2014-03-01 01:08:48.000000', 'consum', 0.0218, 'lps'),
	(568385, 130, '2014-03-01 01:08:49.000000', 'consum', 0.0214, 'lps'),
	(568386, 130, '2014-03-01 01:08:50.000000', 'consum', 0.0210, 'lps'),
	(568387, 130, '2014-03-01 01:08:51.000000', 'consum', 0.0215, 'lps'),
	(568388, 130, '2014-03-01 01:08:52.000000', 'consum', 0.0219, 'lps'),
	(568389, 130, '2014-03-01 01:08:53.000000', 'consum', 0.0220, 'lps'),
	(568390, 130, '2014-03-01 01:08:54.000000', 'consum', 0.0213, 'lps'),
	(568391, 130, '2014-03-01 01:08:55.000000', 'consum', 0.0217, 'lps'),
	(568392, 130, '2014-03-01 01:08:56.000000', 'consum', 0.0215, 'lps'),
	(568393, 130, '2014-03-01 01:08:57.000000', 'consum', 0.0215, 'lps'),
	(568394, 130, '2014-03-01 01:08:58.000000', 'consum', 0.0223, 'lps'),
	(568395, 130, '2014-03-01 01:08:59.000000', 'consum', 0.0219, 'lps'),
	(568396, 130, '2014-03-01 01:09:00.000000', 'consum', 0.0219, 'lps'),
	(568397, 130, '2014-03-01 01:09:01.000000', 'consum', 0.0226, 'lps'),
	(568398, 130, '2014-03-01 01:09:02.000000', 'consum', 0.0227, 'lps'),
	(568399, 130, '2014-03-01 01:09:03.000000', 'consum', 0.0228, 'lps'),
	(568400, 130, '2014-03-01 01:09:04.000000', 'consum', 0.0210, 'lps'),
	(568401, 130, '2014-03-01 01:09:05.000000', 'consum', 0.0215, 'lps'),
	(568402, 130, '2014-03-01 01:09:06.000000', 'consum', 0.0214, 'lps'),
	(568403, 130, '2014-03-01 01:09:07.000000', 'consum', 0.0219, 'lps'),
	(568404, 130, '2014-03-01 01:09:08.000000', 'consum', 0.0221, 'lps'),
	(568405, 130, '2014-03-01 01:09:09.000000', 'consum', 0.0222, 'lps'),
	(568406, 130, '2014-03-01 01:09:10.000000', 'consum', 0.0217, 'lps'),
	(568407, 130, '2014-03-01 01:09:11.000000', 'consum', 0.0212, 'lps'),
	(568408, 130, '2014-03-01 01:09:12.000000', 'consum', 0.0217, 'lps'),
	(568409, 130, '2014-03-01 01:09:13.000000', 'consum', 0.0220, 'lps'),
	(568410, 130, '2014-03-01 01:09:14.000000', 'consum', 0.0219, 'lps'),
	(568411, 130, '2014-03-01 01:09:15.000000', 'consum', 0.0210, 'lps'),
	(568412, 130, '2014-03-01 01:09:16.000000', 'consum', 0.0219, 'lps'),
	(568413, 130, '2014-03-01 01:09:17.000000', 'consum', 0.0217, 'lps'),
	(568414, 130, '2014-03-01 01:09:18.000000', 'consum', 0.0221, 'lps'),
	(568415, 130, '2014-03-01 01:09:19.000000', 'consum', 0.0223, 'lps'),
	(568416, 130, '2014-03-01 01:09:20.000000', 'consum', 0.0222, 'lps'),
	(568417, 130, '2014-03-01 01:09:21.000000', 'consum', 0.0216, 'lps'),
	(568418, 130, '2014-03-01 01:09:22.000000', 'consum', 0.0223, 'lps'),
	(568419, 130, '2014-03-01 01:09:23.000000', 'consum', 0.0221, 'lps'),
	(568420, 130, '2014-03-01 01:09:24.000000', 'consum', 0.0225, 'lps'),
	(568421, 130, '2014-03-01 01:09:25.000000', 'consum', 0.0213, 'lps'),
	(568422, 130, '2014-03-01 01:09:26.000000', 'consum', 0.0221, 'lps'),
	(568423, 130, '2014-03-01 01:09:27.000000', 'consum', 0.0218, 'lps'),
	(568424, 130, '2014-03-01 01:09:28.000000', 'consum', 0.0219, 'lps'),
	(568425, 130, '2014-03-01 01:09:29.000000', 'consum', 0.0211, 'lps'),
	(568426, 130, '2014-03-01 01:09:30.000000', 'consum', 0.0228, 'lps'),
	(568427, 130, '2014-03-01 01:09:31.000000', 'consum', 0.0222, 'lps'),
	(568428, 130, '2014-03-01 01:09:32.000000', 'consum', 0.0217, 'lps'),
	(568429, 130, '2014-03-01 01:09:33.000000', 'consum', 0.0228, 'lps'),
	(568430, 130, '2014-03-01 01:09:34.000000', 'consum', 0.0221, 'lps'),
	(568431, 130, '2014-03-01 01:09:35.000000', 'consum', 0.0213, 'lps'),
	(568432, 130, '2014-03-01 01:09:36.000000', 'consum', 0.0211, 'lps'),
	(568433, 130, '2014-03-01 01:09:37.000000', 'consum', 0.0227, 'lps'),
	(568434, 130, '2014-03-01 01:09:38.000000', 'consum', 0.0216, 'lps'),
	(568435, 130, '2014-03-01 01:09:39.000000', 'consum', 0.0227, 'lps'),
	(568436, 130, '2014-03-01 01:09:40.000000', 'consum', 0.0222, 'lps'),
	(568437, 130, '2014-03-01 01:09:41.000000', 'consum', 0.0220, 'lps'),
	(568438, 130, '2014-03-01 01:09:42.000000', 'consum', 0.0222, 'lps'),
	(568439, 130, '2014-03-01 01:09:43.000000', 'consum', 0.0221, 'lps'),
	(568440, 130, '2014-03-01 01:09:44.000000', 'consum', 0.0212, 'lps'),
	(568441, 130, '2014-03-01 01:09:45.000000', 'consum', 0.0227, 'lps'),
	(568442, 130, '2014-03-01 01:09:46.000000', 'consum', 0.0210, 'lps'),
	(568443, 130, '2014-03-01 01:09:47.000000', 'consum', 0.0219, 'lps'),
	(568444, 130, '2014-03-01 01:09:48.000000', 'consum', 0.0216, 'lps'),
	(568445, 130, '2014-03-01 01:09:49.000000', 'consum', 0.0215, 'lps'),
	(568446, 130, '2014-03-01 01:09:50.000000', 'consum', 0.0215, 'lps'),
	(568447, 130, '2014-03-01 01:09:51.000000', 'consum', 0.0223, 'lps'),
	(568448, 130, '2014-03-01 01:09:52.000000', 'consum', 0.0222, 'lps'),
	(568449, 130, '2014-03-01 01:09:53.000000', 'consum', 0.0211, 'lps'),
	(568450, 130, '2014-03-01 01:09:54.000000', 'consum', 0.0218, 'lps'),
	(568451, 130, '2014-03-01 01:09:55.000000', 'consum', 0.0210, 'lps'),
	(568452, 130, '2014-03-01 01:09:56.000000', 'consum', 0.0223, 'lps'),
	(568453, 130, '2014-03-01 01:09:57.000000', 'consum', 0.0219, 'lps'),
	(568454, 130, '2014-03-01 01:09:58.000000', 'consum', 0.0217, 'lps'),
	(568455, 130, '2014-03-01 01:09:59.000000', 'consum', 0.0220, 'lps'),
	(568456, 130, '2014-03-01 01:10:00.000000', 'consum', 0.0221, 'lps'),
	(568457, 130, '2014-03-01 01:10:01.000000', 'consum', 0.0213, 'lps'),
	(568458, 130, '2014-03-01 01:10:02.000000', 'consum', 0.0215, 'lps'),
	(568459, 130, '2014-03-01 01:10:03.000000', 'consum', 0.0226, 'lps'),
	(568460, 130, '2014-03-01 01:10:04.000000', 'consum', 0.0219, 'lps'),
	(568461, 130, '2014-03-01 01:10:05.000000', 'consum', 0.0224, 'lps'),
	(568462, 130, '2014-03-01 01:10:06.000000', 'consum', 0.0219, 'lps'),
	(568463, 130, '2014-03-01 01:10:07.000000', 'consum', 0.0210, 'lps'),
	(568464, 130, '2014-03-01 01:10:08.000000', 'consum', 0.0222, 'lps'),
	(568465, 130, '2014-03-01 01:10:09.000000', 'consum', 0.0213, 'lps'),
	(568466, 130, '2014-03-01 01:10:10.000000', 'consum', 0.0211, 'lps'),
	(568467, 130, '2014-03-01 01:10:11.000000', 'consum', 0.0225, 'lps'),
	(568468, 130, '2014-03-01 01:10:12.000000', 'consum', 0.0225, 'lps'),
	(568469, 130, '2014-03-01 01:10:13.000000', 'consum', 0.0220, 'lps'),
	(568470, 130, '2014-03-01 01:10:14.000000', 'consum', 0.0215, 'lps'),
	(568471, 130, '2014-03-01 01:10:15.000000', 'consum', 0.0227, 'lps'),
	(568472, 130, '2014-03-01 01:10:16.000000', 'consum', 0.0224, 'lps'),
	(568473, 130, '2014-03-01 01:10:17.000000', 'consum', 0.0211, 'lps'),
	(568474, 130, '2014-03-01 01:10:18.000000', 'consum', 0.0210, 'lps'),
	(568475, 130, '2014-03-01 01:10:19.000000', 'consum', 0.0228, 'lps'),
	(568476, 130, '2014-03-01 01:10:20.000000', 'consum', 0.0223, 'lps'),
	(568477, 130, '2014-03-01 01:10:21.000000', 'consum', 0.0223, 'lps'),
	(568478, 130, '2014-03-01 01:10:22.000000', 'consum', 0.0218, 'lps'),
	(568479, 130, '2014-03-01 01:10:23.000000', 'consum', 0.0228, 'lps'),
	(568480, 130, '2014-03-01 01:10:24.000000', 'consum', 0.0219, 'lps'),
	(568481, 130, '2014-03-01 01:10:25.000000', 'consum', 0.0223, 'lps'),
	(568482, 130, '2014-03-01 01:10:26.000000', 'consum', 0.0228, 'lps'),
	(568483, 130, '2014-03-01 01:10:27.000000', 'consum', 0.0224, 'lps'),
	(568484, 130, '2014-03-01 01:10:28.000000', 'consum', 0.0227, 'lps'),
	(568485, 130, '2014-03-01 01:10:29.000000', 'consum', 0.0216, 'lps'),
	(568486, 130, '2014-03-01 01:10:30.000000', 'consum', 0.0226, 'lps'),
	(568487, 130, '2014-03-01 01:10:31.000000', 'consum', 0.0218, 'lps'),
	(568488, 130, '2014-03-01 01:10:32.000000', 'consum', 0.0220, 'lps'),
	(568489, 130, '2014-03-01 01:10:33.000000', 'consum', 0.0216, 'lps'),
	(568490, 130, '2014-03-01 01:10:34.000000', 'consum', 0.0211, 'lps'),
	(568491, 130, '2014-03-01 01:10:35.000000', 'consum', 0.0219, 'lps'),
	(568492, 130, '2014-03-01 01:10:36.000000', 'consum', 0.0212, 'lps'),
	(568493, 130, '2014-03-01 01:10:37.000000', 'consum', 0.0211, 'lps'),
	(568494, 130, '2014-03-01 01:10:38.000000', 'consum', 0.0213, 'lps'),
	(568495, 130, '2014-03-01 01:10:39.000000', 'consum', 0.0221, 'lps'),
	(568496, 130, '2014-03-01 01:10:40.000000', 'consum', 0.0218, 'lps'),
	(568497, 130, '2014-03-01 01:10:41.000000', 'consum', 0.0218, 'lps'),
	(568498, 130, '2014-03-01 01:10:42.000000', 'consum', 0.0225, 'lps'),
	(568499, 130, '2014-03-01 01:10:43.000000', 'consum', 0.0225, 'lps'),
	(568500, 130, '2014-03-01 01:10:44.000000', 'consum', 0.0221, 'lps'),
	(568501, 130, '2014-03-01 01:10:45.000000', 'consum', 0.0223, 'lps'),
	(568502, 130, '2014-03-01 01:10:46.000000', 'consum', 0.0220, 'lps'),
	(568503, 130, '2014-03-01 01:10:47.000000', 'consum', 0.0223, 'lps'),
	(568504, 130, '2014-03-01 01:10:48.000000', 'consum', 0.0225, 'lps'),
	(568505, 130, '2014-03-01 01:10:49.000000', 'consum', 0.0210, 'lps'),
	(568506, 130, '2014-03-01 01:10:50.000000', 'consum', 0.0222, 'lps'),
	(568507, 130, '2014-03-01 01:10:51.000000', 'consum', 0.0215, 'lps'),
	(568508, 130, '2014-03-01 01:10:52.000000', 'consum', 0.0219, 'lps'),
	(568509, 130, '2014-03-01 01:10:53.000000', 'consum', 0.0220, 'lps'),
	(568510, 130, '2014-03-01 01:10:54.000000', 'consum', 0.0215, 'lps'),
	(568511, 130, '2014-03-01 01:10:55.000000', 'consum', 0.0225, 'lps'),
	(568512, 130, '2014-03-01 01:10:56.000000', 'consum', 0.0211, 'lps'),
	(568513, 130, '2014-03-01 01:10:57.000000', 'consum', 0.0212, 'lps'),
	(568514, 130, '2014-03-01 01:10:58.000000', 'consum', 0.0216, 'lps'),
	(568515, 130, '2014-03-01 01:10:59.000000', 'consum', 0.0215, 'lps'),
	(568516, 130, '2014-03-01 01:11:00.000000', 'consum', 0.0216, 'lps'),
	(568517, 130, '2014-03-01 01:11:01.000000', 'consum', 0.0227, 'lps'),
	(568518, 130, '2014-03-01 01:11:02.000000', 'consum', 0.0221, 'lps'),
	(568519, 130, '2014-03-01 01:11:03.000000', 'consum', 0.0215, 'lps'),
	(568520, 130, '2014-03-01 01:11:04.000000', 'consum', 0.0221, 'lps'),
	(568521, 130, '2014-03-01 01:11:05.000000', 'consum', 0.0211, 'lps'),
	(568522, 130, '2014-03-01 01:11:06.000000', 'consum', 0.0221, 'lps'),
	(568523, 130, '2014-03-01 01:11:07.000000', 'consum', 0.0223, 'lps'),
	(568524, 130, '2014-03-01 01:11:08.000000', 'consum', 0.0225, 'lps'),
	(568525, 130, '2014-03-01 01:11:09.000000', 'consum', 0.0228, 'lps'),
	(568526, 130, '2014-03-01 01:11:10.000000', 'consum', 0.0217, 'lps'),
	(568527, 130, '2014-03-01 01:11:11.000000', 'consum', 0.0211, 'lps'),
	(568528, 130, '2014-03-01 01:11:12.000000', 'consum', 0.0213, 'lps'),
	(568529, 130, '2014-03-01 01:11:13.000000', 'consum', 0.0223, 'lps'),
	(568530, 130, '2014-03-01 01:11:14.000000', 'consum', 0.0211, 'lps'),
	(568531, 130, '2014-03-01 01:11:15.000000', 'consum', 0.0213, 'lps'),
	(568532, 130, '2014-03-01 01:11:16.000000', 'consum', 0.0222, 'lps'),
	(568533, 130, '2014-03-01 01:11:17.000000', 'consum', 0.0224, 'lps'),
	(568534, 130, '2014-03-01 01:11:18.000000', 'consum', 0.0226, 'lps'),
	(568535, 130, '2014-03-01 01:11:19.000000', 'consum', 0.0210, 'lps'),
	(568536, 130, '2014-03-01 01:11:20.000000', 'consum', 0.0219, 'lps'),
	(568537, 130, '2014-03-01 01:11:21.000000', 'consum', 0.0219, 'lps'),
	(568538, 130, '2014-03-01 01:11:22.000000', 'consum', 0.0228, 'lps'),
	(568539, 130, '2014-03-01 01:11:23.000000', 'consum', 0.0214, 'lps'),
	(568540, 130, '2014-03-01 01:11:24.000000', 'consum', 0.0218, 'lps'),
	(568541, 130, '2014-03-01 01:11:25.000000', 'consum', 0.0219, 'lps'),
	(568542, 130, '2014-03-01 01:11:26.000000', 'consum', 0.0211, 'lps'),
	(568543, 130, '2014-03-01 01:11:27.000000', 'consum', 0.0228, 'lps'),
	(568544, 130, '2014-03-01 01:11:28.000000', 'consum', 0.0219, 'lps'),
	(568545, 130, '2014-03-01 01:11:29.000000', 'consum', 0.0222, 'lps'),
	(568546, 130, '2014-03-01 01:11:30.000000', 'consum', 0.0226, 'lps'),
	(568547, 130, '2014-03-01 01:11:31.000000', 'consum', 0.0217, 'lps'),
	(568548, 130, '2014-03-01 01:11:32.000000', 'consum', 0.0214, 'lps'),
	(568549, 130, '2014-03-01 01:11:33.000000', 'consum', 0.0228, 'lps'),
	(568550, 130, '2014-03-01 01:11:34.000000', 'consum', 0.0214, 'lps'),
	(568551, 130, '2014-03-01 01:11:35.000000', 'consum', 0.0213, 'lps'),
	(568552, 130, '2014-03-01 01:11:36.000000', 'consum', 0.0215, 'lps'),
	(568553, 130, '2014-03-01 01:11:37.000000', 'consum', 0.0225, 'lps'),
	(568554, 130, '2014-03-01 01:11:38.000000', 'consum', 0.0212, 'lps'),
	(568555, 130, '2014-03-01 01:11:39.000000', 'consum', 0.0216, 'lps'),
	(568556, 130, '2014-03-01 01:11:40.000000', 'consum', 0.0216, 'lps'),
	(568557, 130, '2014-03-01 01:11:41.000000', 'consum', 0.0220, 'lps'),
	(568558, 130, '2014-03-01 01:11:42.000000', 'consum', 0.0226, 'lps'),
	(568559, 130, '2014-03-01 01:11:43.000000', 'consum', 0.0223, 'lps'),
	(568560, 130, '2014-03-01 01:11:44.000000', 'consum', 0.0228, 'lps'),
	(568561, 130, '2014-03-01 01:11:45.000000', 'consum', 0.0222, 'lps'),
	(568562, 130, '2014-03-01 01:11:46.000000', 'consum', 0.0219, 'lps'),
	(568563, 130, '2014-03-01 01:11:47.000000', 'consum', 0.0218, 'lps'),
	(568564, 130, '2014-03-01 01:11:48.000000', 'consum', 0.0222, 'lps'),
	(568565, 130, '2014-03-01 01:11:49.000000', 'consum', 0.0211, 'lps'),
	(568566, 130, '2014-03-01 01:11:50.000000', 'consum', 0.0217, 'lps'),
	(568567, 130, '2014-03-01 01:11:51.000000', 'consum', 0.0222, 'lps'),
	(568568, 130, '2014-03-01 01:11:52.000000', 'consum', 0.0211, 'lps'),
	(568569, 130, '2014-03-01 01:11:53.000000', 'consum', 0.0217, 'lps'),
	(568570, 130, '2014-03-01 01:11:54.000000', 'consum', 0.0225, 'lps'),
	(568571, 130, '2014-03-01 01:11:55.000000', 'consum', 0.0228, 'lps'),
	(568572, 130, '2014-03-01 01:11:56.000000', 'consum', 0.0215, 'lps'),
	(568573, 130, '2014-03-01 01:11:57.000000', 'consum', 0.0218, 'lps'),
	(568574, 130, '2014-03-01 01:11:58.000000', 'consum', 0.0219, 'lps'),
	(568575, 130, '2014-03-01 01:11:59.000000', 'consum', 0.0214, 'lps'),
	(568576, 130, '2014-03-01 01:12:00.000000', 'consum', 0.0220, 'lps'),
	(568577, 130, '2014-03-01 01:12:01.000000', 'consum', 0.0213, 'lps'),
	(568578, 130, '2014-03-01 01:12:02.000000', 'consum', 0.0211, 'lps'),
	(568579, 130, '2014-03-01 01:12:03.000000', 'consum', 0.0210, 'lps'),
	(568580, 130, '2014-03-01 01:12:04.000000', 'consum', 0.0224, 'lps'),
	(568581, 130, '2014-03-01 01:12:05.000000', 'consum', 0.0223, 'lps'),
	(568582, 130, '2014-03-01 01:12:06.000000', 'consum', 0.0216, 'lps'),
	(568583, 130, '2014-03-01 01:12:07.000000', 'consum', 0.0221, 'lps'),
	(568584, 130, '2014-03-01 01:12:08.000000', 'consum', 0.0227, 'lps'),
	(568585, 130, '2014-03-01 01:12:09.000000', 'consum', 0.0224, 'lps'),
	(568586, 130, '2014-03-01 01:12:10.000000', 'consum', 0.0213, 'lps'),
	(568587, 130, '2014-03-01 01:12:11.000000', 'consum', 0.0219, 'lps'),
	(568588, 130, '2014-03-01 01:12:12.000000', 'consum', 0.0211, 'lps'),
	(568589, 130, '2014-03-01 01:12:13.000000', 'consum', 0.0225, 'lps'),
	(568590, 130, '2014-03-01 01:12:14.000000', 'consum', 0.0226, 'lps'),
	(568591, 130, '2014-03-01 01:12:15.000000', 'consum', 0.0226, 'lps'),
	(568592, 130, '2014-03-01 01:12:16.000000', 'consum', 0.0225, 'lps'),
	(568593, 130, '2014-03-01 01:12:17.000000', 'consum', 0.0219, 'lps'),
	(568594, 130, '2014-03-01 01:12:18.000000', 'consum', 0.0211, 'lps'),
	(568595, 130, '2014-03-01 01:12:19.000000', 'consum', 0.0227, 'lps'),
	(568596, 130, '2014-03-01 01:12:20.000000', 'consum', 0.0217, 'lps'),
	(568597, 130, '2014-03-01 01:12:21.000000', 'consum', 0.0214, 'lps'),
	(568598, 130, '2014-03-01 01:12:22.000000', 'consum', 0.0225, 'lps'),
	(568599, 130, '2014-03-01 01:12:23.000000', 'consum', 0.0220, 'lps'),
	(568600, 130, '2014-03-01 01:12:24.000000', 'consum', 0.0213, 'lps'),
	(568601, 130, '2014-03-01 01:12:25.000000', 'consum', 0.0217, 'lps'),
	(568602, 130, '2014-03-01 01:12:26.000000', 'consum', 0.0216, 'lps'),
	(568603, 130, '2014-03-01 01:12:27.000000', 'consum', 0.0219, 'lps'),
	(568604, 130, '2014-03-01 01:12:28.000000', 'consum', 0.0221, 'lps'),
	(568605, 130, '2014-03-01 01:12:29.000000', 'consum', 0.0218, 'lps'),
	(568606, 130, '2014-03-01 01:12:30.000000', 'consum', 0.0219, 'lps'),
	(568607, 130, '2014-03-01 01:12:31.000000', 'consum', 0.0210, 'lps'),
	(568608, 130, '2014-03-01 01:12:32.000000', 'consum', 0.0223, 'lps'),
	(568609, 130, '2014-03-01 01:12:33.000000', 'consum', 0.0219, 'lps'),
	(568610, 130, '2014-03-01 01:12:34.000000', 'consum', 0.0214, 'lps'),
	(568611, 130, '2014-03-01 01:12:35.000000', 'consum', 0.0226, 'lps'),
	(568612, 130, '2014-03-01 01:12:36.000000', 'consum', 0.0220, 'lps'),
	(568613, 130, '2014-03-01 01:12:37.000000', 'consum', 0.0212, 'lps'),
	(568614, 130, '2014-03-01 01:12:38.000000', 'consum', 0.0228, 'lps'),
	(568615, 130, '2014-03-01 01:12:39.000000', 'consum', 0.0218, 'lps'),
	(568616, 130, '2014-03-01 01:12:40.000000', 'consum', 0.0218, 'lps'),
	(568617, 130, '2014-03-01 01:12:41.000000', 'consum', 0.0225, 'lps'),
	(568618, 130, '2014-03-01 01:12:42.000000', 'consum', 0.0226, 'lps'),
	(568619, 130, '2014-03-01 01:12:43.000000', 'consum', 0.0223, 'lps'),
	(568620, 130, '2014-03-01 01:12:44.000000', 'consum', 0.0210, 'lps'),
	(568621, 130, '2014-03-01 01:12:45.000000', 'consum', 0.0227, 'lps'),
	(568622, 130, '2014-03-01 01:12:46.000000', 'consum', 0.0219, 'lps'),
	(568623, 130, '2014-03-01 01:12:47.000000', 'consum', 0.0226, 'lps'),
	(568624, 130, '2014-03-01 01:12:48.000000', 'consum', 0.0225, 'lps'),
	(568625, 130, '2014-03-01 01:12:49.000000', 'consum', 0.0217, 'lps'),
	(568626, 130, '2014-03-01 01:12:50.000000', 'consum', 0.0219, 'lps'),
	(568627, 130, '2014-03-01 01:12:51.000000', 'consum', 0.0215, 'lps'),
	(568628, 130, '2014-03-01 01:12:52.000000', 'consum', 0.0228, 'lps'),
	(568629, 130, '2014-03-01 01:12:53.000000', 'consum', 0.0228, 'lps'),
	(568630, 130, '2014-03-01 01:12:54.000000', 'consum', 0.0227, 'lps'),
	(568631, 130, '2014-03-01 01:12:55.000000', 'consum', 0.0222, 'lps'),
	(568632, 130, '2014-03-01 01:12:56.000000', 'consum', 0.0222, 'lps'),
	(568633, 130, '2014-03-01 01:12:57.000000', 'consum', 0.0216, 'lps'),
	(568634, 130, '2014-03-01 01:12:58.000000', 'consum', 0.0220, 'lps'),
	(568635, 130, '2014-03-01 01:12:59.000000', 'consum', 0.0227, 'lps'),
	(568636, 130, '2014-03-01 01:13:00.000000', 'consum', 0.0224, 'lps'),
	(568637, 130, '2014-03-01 01:13:01.000000', 'consum', 0.0213, 'lps'),
	(568638, 130, '2014-03-01 01:13:02.000000', 'consum', 0.0220, 'lps'),
	(568639, 130, '2014-03-01 01:13:03.000000', 'consum', 0.0215, 'lps'),
	(568640, 130, '2014-03-01 01:13:04.000000', 'consum', 0.0222, 'lps'),
	(568641, 130, '2014-03-01 01:13:05.000000', 'consum', 0.0218, 'lps'),
	(568642, 130, '2014-03-01 01:13:06.000000', 'consum', 0.0217, 'lps'),
	(568643, 130, '2014-03-01 01:13:07.000000', 'consum', 0.0219, 'lps'),
	(568644, 130, '2014-03-01 01:13:08.000000', 'consum', 0.0218, 'lps'),
	(568645, 130, '2014-03-01 01:13:09.000000', 'consum', 0.0221, 'lps'),
	(568646, 130, '2014-03-01 01:13:10.000000', 'consum', 0.0223, 'lps'),
	(568647, 130, '2014-03-01 01:13:11.000000', 'consum', 0.0223, 'lps'),
	(568648, 130, '2014-03-01 01:13:12.000000', 'consum', 0.0218, 'lps'),
	(568649, 130, '2014-03-01 01:13:13.000000', 'consum', 0.0214, 'lps'),
	(568650, 130, '2014-03-01 01:13:14.000000', 'consum', 0.0222, 'lps'),
	(568651, 130, '2014-03-01 01:13:15.000000', 'consum', 0.0221, 'lps'),
	(568652, 130, '2014-03-01 01:13:16.000000', 'consum', 0.0228, 'lps'),
	(568653, 130, '2014-03-01 01:13:17.000000', 'consum', 0.0212, 'lps'),
	(568654, 130, '2014-03-01 01:13:18.000000', 'consum', 0.0223, 'lps'),
	(568655, 130, '2014-03-01 01:13:19.000000', 'consum', 0.0215, 'lps'),
	(568656, 130, '2014-03-01 01:13:20.000000', 'consum', 0.0212, 'lps'),
	(568657, 130, '2014-03-01 01:13:21.000000', 'consum', 0.0226, 'lps'),
	(568658, 130, '2014-03-01 01:13:22.000000', 'consum', 0.0210, 'lps'),
	(568659, 130, '2014-03-01 01:13:23.000000', 'consum', 0.0217, 'lps'),
	(568660, 130, '2014-03-01 01:13:24.000000', 'consum', 0.0228, 'lps'),
	(568661, 130, '2014-03-01 01:13:25.000000', 'consum', 0.0223, 'lps'),
	(568662, 130, '2014-03-01 01:13:26.000000', 'consum', 0.0219, 'lps'),
	(568663, 130, '2014-03-01 01:13:27.000000', 'consum', 0.0219, 'lps'),
	(568664, 130, '2014-03-01 01:13:28.000000', 'consum', 0.0228, 'lps'),
	(568665, 130, '2014-03-01 01:13:29.000000', 'consum', 0.0216, 'lps'),
	(568666, 130, '2014-03-01 01:13:30.000000', 'consum', 0.0226, 'lps'),
	(568667, 130, '2014-03-01 01:13:31.000000', 'consum', 0.0215, 'lps'),
	(568668, 130, '2014-03-01 01:13:32.000000', 'consum', 0.0227, 'lps'),
	(568669, 130, '2014-03-01 01:13:33.000000', 'consum', 0.0222, 'lps'),
	(568670, 130, '2014-03-01 01:13:34.000000', 'consum', 0.0220, 'lps'),
	(568671, 130, '2014-03-01 01:13:35.000000', 'consum', 0.0225, 'lps'),
	(568672, 130, '2014-03-01 01:13:36.000000', 'consum', 0.0217, 'lps'),
	(568673, 130, '2014-03-01 01:13:37.000000', 'consum', 0.0218, 'lps'),
	(568674, 130, '2014-03-01 01:13:38.000000', 'consum', 0.0212, 'lps'),
	(568675, 130, '2014-03-01 01:13:39.000000', 'consum', 0.0215, 'lps'),
	(568676, 130, '2014-03-01 01:13:40.000000', 'consum', 0.0212, 'lps'),
	(568677, 130, '2014-03-01 01:13:41.000000', 'consum', 0.0224, 'lps'),
	(568678, 130, '2014-03-01 01:13:42.000000', 'consum', 0.0215, 'lps'),
	(568679, 130, '2014-03-01 01:13:43.000000', 'consum', 0.0215, 'lps'),
	(568680, 130, '2014-03-01 01:13:44.000000', 'consum', 0.0221, 'lps'),
	(568681, 130, '2014-03-01 01:13:45.000000', 'consum', 0.0213, 'lps'),
	(568682, 130, '2014-03-01 01:13:46.000000', 'consum', 0.0210, 'lps'),
	(568683, 130, '2014-03-01 01:13:47.000000', 'consum', 0.0221, 'lps'),
	(568684, 130, '2014-03-01 01:13:48.000000', 'consum', 0.0228, 'lps'),
	(568685, 130, '2014-03-01 01:13:49.000000', 'consum', 0.0211, 'lps'),
	(568686, 130, '2014-03-01 01:13:50.000000', 'consum', 0.0217, 'lps'),
	(568687, 130, '2014-03-01 01:13:51.000000', 'consum', 0.0225, 'lps'),
	(568688, 130, '2014-03-01 01:13:52.000000', 'consum', 0.0224, 'lps'),
	(568689, 130, '2014-03-01 01:13:53.000000', 'consum', 0.0217, 'lps'),
	(568690, 130, '2014-03-01 01:13:54.000000', 'consum', 0.0223, 'lps'),
	(568691, 130, '2014-03-01 01:13:55.000000', 'consum', 0.0218, 'lps'),
	(568692, 130, '2014-03-01 01:13:56.000000', 'consum', 0.0228, 'lps'),
	(568693, 130, '2014-03-01 01:13:57.000000', 'consum', 0.0219, 'lps'),
	(568694, 130, '2014-03-01 01:13:58.000000', 'consum', 0.0221, 'lps'),
	(568695, 130, '2014-03-01 01:13:59.000000', 'consum', 0.0219, 'lps'),
	(568696, 130, '2014-03-01 01:14:00.000000', 'consum', 0.0224, 'lps'),
	(568697, 130, '2014-03-01 01:14:01.000000', 'consum', 0.0213, 'lps'),
	(568698, 130, '2014-03-01 01:14:02.000000', 'consum', 0.0222, 'lps'),
	(568699, 130, '2014-03-01 01:14:03.000000', 'consum', 0.0224, 'lps'),
	(568700, 130, '2014-03-01 01:14:04.000000', 'consum', 0.0224, 'lps'),
	(568701, 130, '2014-03-01 01:14:05.000000', 'consum', 0.0219, 'lps'),
	(568702, 130, '2014-03-01 01:14:06.000000', 'consum', 0.0216, 'lps'),
	(568703, 130, '2014-03-01 01:14:07.000000', 'consum', 0.0212, 'lps'),
	(568704, 130, '2014-03-01 01:14:08.000000', 'consum', 0.0221, 'lps'),
	(568705, 130, '2014-03-01 01:14:09.000000', 'consum', 0.0221, 'lps'),
	(568706, 130, '2014-03-01 01:14:10.000000', 'consum', 0.0215, 'lps'),
	(568707, 130, '2014-03-01 01:14:11.000000', 'consum', 0.0222, 'lps'),
	(568708, 130, '2014-03-01 01:14:12.000000', 'consum', 0.0215, 'lps'),
	(568709, 130, '2014-03-01 01:14:13.000000', 'consum', 0.0220, 'lps'),
	(568710, 130, '2014-03-01 01:14:14.000000', 'consum', 0.0225, 'lps'),
	(568711, 130, '2014-03-01 01:14:15.000000', 'consum', 0.0217, 'lps'),
	(568712, 130, '2014-03-01 01:14:16.000000', 'consum', 0.0223, 'lps'),
	(568713, 130, '2014-03-01 01:14:17.000000', 'consum', 0.0213, 'lps'),
	(568714, 130, '2014-03-01 01:14:18.000000', 'consum', 0.0226, 'lps'),
	(568715, 130, '2014-03-01 01:14:19.000000', 'consum', 0.0226, 'lps'),
	(568716, 130, '2014-03-01 01:14:20.000000', 'consum', 0.0224, 'lps'),
	(568717, 130, '2014-03-01 01:14:21.000000', 'consum', 0.0213, 'lps'),
	(568718, 130, '2014-03-01 01:14:22.000000', 'consum', 0.0222, 'lps'),
	(568719, 130, '2014-03-01 01:14:23.000000', 'consum', 0.0224, 'lps'),
	(568720, 130, '2014-03-01 01:14:24.000000', 'consum', 0.0226, 'lps'),
	(568721, 130, '2014-03-01 01:14:25.000000', 'consum', 0.0228, 'lps'),
	(568722, 130, '2014-03-01 01:14:26.000000', 'consum', 0.0213, 'lps'),
	(568723, 130, '2014-03-01 01:14:27.000000', 'consum', 0.0211, 'lps'),
	(568724, 130, '2014-03-01 01:14:28.000000', 'consum', 0.0225, 'lps'),
	(568725, 130, '2014-03-01 01:14:29.000000', 'consum', 0.0226, 'lps'),
	(568726, 130, '2014-03-01 01:14:30.000000', 'consum', 0.0225, 'lps'),
	(568727, 130, '2014-03-01 01:14:31.000000', 'consum', 0.0220, 'lps'),
	(568728, 130, '2014-03-01 01:14:32.000000', 'consum', 0.0214, 'lps'),
	(568729, 130, '2014-03-01 01:14:33.000000', 'consum', 0.0221, 'lps'),
	(568730, 130, '2014-03-01 01:14:34.000000', 'consum', 0.0213, 'lps'),
	(568731, 130, '2014-03-01 01:14:35.000000', 'consum', 0.0214, 'lps'),
	(568732, 130, '2014-03-01 01:14:36.000000', 'consum', 0.0221, 'lps'),
	(568733, 130, '2014-03-01 01:14:37.000000', 'consum', 0.0214, 'lps'),
	(568734, 130, '2014-03-01 01:14:38.000000', 'consum', 0.0216, 'lps'),
	(568735, 130, '2014-03-01 01:14:39.000000', 'consum', 0.0228, 'lps'),
	(568736, 130, '2014-03-01 01:14:40.000000', 'consum', 0.0225, 'lps'),
	(568737, 130, '2014-03-01 01:14:41.000000', 'consum', 0.0213, 'lps'),
	(568738, 130, '2014-03-01 01:14:42.000000', 'consum', 0.0221, 'lps'),
	(568739, 130, '2014-03-01 01:14:43.000000', 'consum', 0.0216, 'lps'),
	(568740, 130, '2014-03-01 01:14:44.000000', 'consum', 0.0228, 'lps'),
	(568741, 130, '2014-03-01 01:14:45.000000', 'consum', 0.0225, 'lps'),
	(568742, 130, '2014-03-01 01:14:46.000000', 'consum', 0.0211, 'lps'),
	(568743, 130, '2014-03-01 01:14:47.000000', 'consum', 0.0210, 'lps'),
	(568744, 130, '2014-03-01 01:14:48.000000', 'consum', 0.0225, 'lps'),
	(568745, 130, '2014-03-01 01:14:49.000000', 'consum', 0.0210, 'lps'),
	(568746, 130, '2014-03-01 01:14:50.000000', 'consum', 0.0221, 'lps'),
	(568747, 130, '2014-03-01 01:14:51.000000', 'consum', 0.0227, 'lps'),
	(568748, 130, '2014-03-01 01:14:52.000000', 'consum', 0.0227, 'lps'),
	(568749, 130, '2014-03-01 01:14:53.000000', 'consum', 0.0224, 'lps'),
	(568750, 130, '2014-03-01 01:14:54.000000', 'consum', 0.0213, 'lps'),
	(568751, 130, '2014-03-01 01:14:55.000000', 'consum', 0.0219, 'lps'),
	(568752, 130, '2014-03-01 01:14:56.000000', 'consum', 0.0228, 'lps'),
	(568753, 130, '2014-03-01 01:14:57.000000', 'consum', 0.0218, 'lps'),
	(568754, 130, '2014-03-01 01:14:58.000000', 'consum', 0.0215, 'lps'),
	(568755, 130, '2014-03-01 01:14:59.000000', 'consum', 0.0210, 'lps'),
	(568756, 130, '2014-03-01 01:15:00.000000', 'consum', 0.0214, 'lps'),
	(568757, 130, '2014-03-01 01:15:01.000000', 'consum', 0.0211, 'lps'),
	(568758, 130, '2014-03-01 01:15:02.000000', 'consum', 0.0223, 'lps'),
	(568759, 130, '2014-03-01 01:15:03.000000', 'consum', 0.0215, 'lps'),
	(568760, 130, '2014-03-01 01:15:04.000000', 'consum', 0.0215, 'lps'),
	(568761, 130, '2014-03-01 01:15:05.000000', 'consum', 0.0222, 'lps'),
	(568762, 130, '2014-03-01 01:15:06.000000', 'consum', 0.0216, 'lps'),
	(568763, 130, '2014-03-01 01:15:07.000000', 'consum', 0.0223, 'lps'),
	(568764, 130, '2014-03-01 01:15:08.000000', 'consum', 0.0221, 'lps'),
	(568765, 130, '2014-03-01 01:15:09.000000', 'consum', 0.0228, 'lps'),
	(568766, 130, '2014-03-01 01:15:10.000000', 'consum', 0.0227, 'lps'),
	(568767, 130, '2014-03-01 01:15:11.000000', 'consum', 0.0225, 'lps'),
	(568768, 130, '2014-03-01 01:15:12.000000', 'consum', 0.0213, 'lps'),
	(568769, 130, '2014-03-01 01:15:13.000000', 'consum', 0.0217, 'lps'),
	(568770, 130, '2014-03-01 01:15:14.000000', 'consum', 0.0221, 'lps'),
	(568771, 130, '2014-03-01 01:15:15.000000', 'consum', 0.0225, 'lps'),
	(568772, 130, '2014-03-01 01:15:16.000000', 'consum', 0.0214, 'lps'),
	(568773, 130, '2014-03-01 01:15:17.000000', 'consum', 0.0225, 'lps'),
	(568774, 130, '2014-03-01 01:15:18.000000', 'consum', 0.0214, 'lps'),
	(568775, 130, '2014-03-01 01:15:19.000000', 'consum', 0.0224, 'lps'),
	(568776, 130, '2014-03-01 01:15:20.000000', 'consum', 0.0211, 'lps'),
	(568777, 130, '2014-03-01 01:15:21.000000', 'consum', 0.0211, 'lps'),
	(568778, 130, '2014-03-01 01:15:22.000000', 'consum', 0.0214, 'lps'),
	(568779, 130, '2014-03-01 01:15:23.000000', 'consum', 0.0227, 'lps'),
	(568780, 130, '2014-03-01 01:15:24.000000', 'consum', 0.0226, 'lps'),
	(568781, 130, '2014-03-01 01:15:25.000000', 'consum', 0.0222, 'lps'),
	(568782, 130, '2014-03-01 01:15:26.000000', 'consum', 0.0220, 'lps'),
	(568783, 130, '2014-03-01 01:15:27.000000', 'consum', 0.0227, 'lps'),
	(568784, 130, '2014-03-01 01:15:28.000000', 'consum', 0.0225, 'lps'),
	(568785, 130, '2014-03-01 01:15:29.000000', 'consum', 0.0218, 'lps'),
	(568786, 130, '2014-03-01 01:15:30.000000', 'consum', 0.0225, 'lps'),
	(568787, 130, '2014-03-01 01:15:31.000000', 'consum', 0.0220, 'lps'),
	(568788, 130, '2014-03-01 01:15:32.000000', 'consum', 0.0219, 'lps'),
	(568789, 130, '2014-03-01 01:15:33.000000', 'consum', 0.0225, 'lps'),
	(568790, 130, '2014-03-01 01:15:34.000000', 'consum', 0.0221, 'lps'),
	(568791, 130, '2014-03-01 01:15:35.000000', 'consum', 0.0220, 'lps'),
	(568792, 130, '2014-03-01 01:15:36.000000', 'consum', 0.0225, 'lps'),
	(568793, 130, '2014-03-01 01:15:37.000000', 'consum', 0.0221, 'lps'),
	(568794, 130, '2014-03-01 01:15:38.000000', 'consum', 0.0217, 'lps'),
	(568795, 130, '2014-03-01 01:15:39.000000', 'consum', 0.0214, 'lps'),
	(568796, 130, '2014-03-01 01:15:40.000000', 'consum', 0.0211, 'lps'),
	(568797, 130, '2014-03-01 01:15:41.000000', 'consum', 0.0221, 'lps'),
	(568798, 130, '2014-03-01 01:15:42.000000', 'consum', 0.0223, 'lps'),
	(568799, 130, '2014-03-01 01:15:43.000000', 'consum', 0.0225, 'lps'),
	(568800, 130, '2014-03-01 01:15:44.000000', 'consum', 0.0227, 'lps'),
	(568801, 130, '2014-03-01 01:15:45.000000', 'consum', 0.0213, 'lps'),
	(568802, 130, '2014-03-01 01:15:46.000000', 'consum', 0.0212, 'lps'),
	(568803, 130, '2014-03-01 01:15:47.000000', 'consum', 0.0213, 'lps'),
	(568804, 130, '2014-03-01 01:15:48.000000', 'consum', 0.0218, 'lps'),
	(568805, 130, '2014-03-01 01:15:49.000000', 'consum', 0.0223, 'lps'),
	(568806, 130, '2014-03-01 01:15:50.000000', 'consum', 0.0215, 'lps'),
	(568807, 130, '2014-03-01 01:15:51.000000', 'consum', 0.0216, 'lps'),
	(568808, 130, '2014-03-01 01:15:52.000000', 'consum', 0.0224, 'lps'),
	(568809, 130, '2014-03-01 01:15:53.000000', 'consum', 0.0225, 'lps'),
	(568810, 130, '2014-03-01 01:15:54.000000', 'consum', 0.0225, 'lps'),
	(568811, 130, '2014-03-01 01:15:55.000000', 'consum', 0.0223, 'lps'),
	(568812, 130, '2014-03-01 01:15:56.000000', 'consum', 0.0211, 'lps'),
	(568813, 130, '2014-03-01 01:15:57.000000', 'consum', 0.0214, 'lps'),
	(568814, 130, '2014-03-01 01:15:58.000000', 'consum', 0.0226, 'lps'),
	(568815, 130, '2014-03-01 01:15:59.000000', 'consum', 0.0222, 'lps'),
	(568816, 130, '2014-03-01 01:16:00.000000', 'consum', 0.0224, 'lps'),
	(568817, 130, '2014-03-01 01:16:01.000000', 'consum', 0.0223, 'lps'),
	(568818, 130, '2014-03-01 01:16:02.000000', 'consum', 0.0215, 'lps'),
	(568819, 130, '2014-03-01 01:16:03.000000', 'consum', 0.0214, 'lps'),
	(568820, 130, '2014-03-01 01:16:04.000000', 'consum', 0.0219, 'lps'),
	(568821, 130, '2014-03-01 01:16:05.000000', 'consum', 0.0222, 'lps'),
	(568822, 130, '2014-03-01 01:16:06.000000', 'consum', 0.0224, 'lps'),
	(568823, 130, '2014-03-01 01:16:07.000000', 'consum', 0.0226, 'lps'),
	(568824, 130, '2014-03-01 01:16:08.000000', 'consum', 0.0228, 'lps'),
	(568825, 130, '2014-03-01 01:16:09.000000', 'consum', 0.0218, 'lps'),
	(568826, 130, '2014-03-01 01:16:10.000000', 'consum', 0.0212, 'lps'),
	(568827, 130, '2014-03-01 01:16:11.000000', 'consum', 0.0218, 'lps'),
	(568828, 130, '2014-03-01 01:16:12.000000', 'consum', 0.0223, 'lps'),
	(568829, 130, '2014-03-01 01:16:13.000000', 'consum', 0.0213, 'lps'),
	(568830, 130, '2014-03-01 01:16:14.000000', 'consum', 0.0227, 'lps'),
	(568831, 130, '2014-03-01 01:16:15.000000', 'consum', 0.0228, 'lps'),
	(568832, 130, '2014-03-01 01:16:16.000000', 'consum', 0.0213, 'lps'),
	(568833, 130, '2014-03-01 01:16:17.000000', 'consum', 0.0228, 'lps'),
	(568834, 130, '2014-03-01 01:16:18.000000', 'consum', 0.0215, 'lps'),
	(568835, 130, '2014-03-01 01:16:19.000000', 'consum', 0.0220, 'lps'),
	(568836, 130, '2014-03-01 01:16:20.000000', 'consum', 0.0227, 'lps'),
	(568837, 130, '2014-03-01 01:16:21.000000', 'consum', 0.0225, 'lps'),
	(568838, 130, '2014-03-01 01:16:22.000000', 'consum', 0.0219, 'lps'),
	(568839, 130, '2014-03-01 01:16:23.000000', 'consum', 0.0226, 'lps'),
	(568840, 130, '2014-03-01 01:16:24.000000', 'consum', 0.0227, 'lps'),
	(568841, 130, '2014-03-01 01:16:25.000000', 'consum', 0.0211, 'lps'),
	(568842, 130, '2014-03-01 01:16:26.000000', 'consum', 0.0220, 'lps'),
	(568843, 130, '2014-03-01 01:16:27.000000', 'consum', 0.0221, 'lps'),
	(568844, 130, '2014-03-01 01:16:28.000000', 'consum', 0.0217, 'lps'),
	(568845, 130, '2014-03-01 01:16:29.000000', 'consum', 0.0213, 'lps'),
	(568846, 130, '2014-03-01 01:16:30.000000', 'consum', 0.0223, 'lps'),
	(568847, 130, '2014-03-01 01:16:31.000000', 'consum', 0.0228, 'lps'),
	(568848, 130, '2014-03-01 01:16:32.000000', 'consum', 0.0223, 'lps'),
	(568849, 130, '2014-03-01 01:16:33.000000', 'consum', 0.0224, 'lps'),
	(568850, 130, '2014-03-01 01:16:34.000000', 'consum', 0.0220, 'lps'),
	(568851, 130, '2014-03-01 01:16:35.000000', 'consum', 0.0219, 'lps'),
	(568852, 130, '2014-03-01 01:16:36.000000', 'consum', 0.0224, 'lps'),
	(568853, 130, '2014-03-01 01:16:37.000000', 'consum', 0.0216, 'lps'),
	(568854, 130, '2014-03-01 01:16:38.000000', 'consum', 0.0219, 'lps'),
	(568855, 130, '2014-03-01 01:16:39.000000', 'consum', 0.0216, 'lps'),
	(568856, 130, '2014-03-01 01:16:40.000000', 'consum', 0.0217, 'lps'),
	(568857, 130, '2014-03-01 01:16:41.000000', 'consum', 0.0224, 'lps'),
	(568858, 130, '2014-03-01 01:16:42.000000', 'consum', 0.0224, 'lps'),
	(568859, 130, '2014-03-01 01:16:43.000000', 'consum', 0.0219, 'lps'),
	(568860, 130, '2014-03-01 01:16:44.000000', 'consum', 0.0213, 'lps'),
	(568861, 130, '2014-03-01 01:16:45.000000', 'consum', 0.0219, 'lps'),
	(568862, 130, '2014-03-01 01:16:46.000000', 'consum', 0.0225, 'lps'),
	(568863, 130, '2014-03-01 01:16:47.000000', 'consum', 0.0224, 'lps'),
	(568864, 130, '2014-03-01 01:16:48.000000', 'consum', 0.0213, 'lps'),
	(568865, 130, '2014-03-01 01:16:49.000000', 'consum', 0.0223, 'lps'),
	(568866, 130, '2014-03-01 01:16:50.000000', 'consum', 0.0226, 'lps'),
	(568867, 130, '2014-03-01 01:16:51.000000', 'consum', 0.0216, 'lps'),
	(568868, 130, '2014-03-01 01:16:52.000000', 'consum', 0.0213, 'lps'),
	(568869, 130, '2014-03-01 01:16:53.000000', 'consum', 0.0225, 'lps'),
	(568870, 130, '2014-03-01 01:16:54.000000', 'consum', 0.0218, 'lps'),
	(568871, 130, '2014-03-01 01:16:55.000000', 'consum', 0.0226, 'lps'),
	(568872, 130, '2014-03-01 01:16:56.000000', 'consum', 0.0227, 'lps'),
	(568873, 130, '2014-03-01 01:16:57.000000', 'consum', 0.0212, 'lps'),
	(568874, 130, '2014-03-01 01:16:58.000000', 'consum', 0.0227, 'lps'),
	(568875, 130, '2014-03-01 01:16:59.000000', 'consum', 0.0214, 'lps'),
	(568876, 130, '2014-03-01 01:17:00.000000', 'consum', 0.0215, 'lps'),
	(568877, 130, '2014-03-01 01:17:01.000000', 'consum', 0.0226, 'lps'),
	(568878, 130, '2014-03-01 01:17:02.000000', 'consum', 0.0216, 'lps'),
	(568879, 130, '2014-03-01 01:17:03.000000', 'consum', 0.0214, 'lps'),
	(568880, 130, '2014-03-01 01:17:04.000000', 'consum', 0.0211, 'lps'),
	(568881, 130, '2014-03-01 01:17:05.000000', 'consum', 0.0223, 'lps'),
	(568882, 130, '2014-03-01 01:17:06.000000', 'consum', 0.0214, 'lps'),
	(568883, 130, '2014-03-01 01:17:07.000000', 'consum', 0.0210, 'lps'),
	(568884, 130, '2014-03-01 01:17:08.000000', 'consum', 0.0219, 'lps'),
	(568885, 130, '2014-03-01 01:17:09.000000', 'consum', 0.0218, 'lps'),
	(568886, 130, '2014-03-01 01:17:10.000000', 'consum', 0.0225, 'lps'),
	(568887, 130, '2014-03-01 01:17:11.000000', 'consum', 0.0220, 'lps'),
	(568888, 130, '2014-03-01 01:17:12.000000', 'consum', 0.0219, 'lps'),
	(568889, 130, '2014-03-01 01:17:13.000000', 'consum', 0.0223, 'lps'),
	(568890, 130, '2014-03-01 01:17:14.000000', 'consum', 0.0210, 'lps'),
	(568891, 130, '2014-03-01 01:17:15.000000', 'consum', 0.0212, 'lps'),
	(568892, 130, '2014-03-01 01:17:16.000000', 'consum', 0.0220, 'lps'),
	(568893, 130, '2014-03-01 01:17:17.000000', 'consum', 0.0218, 'lps'),
	(568894, 130, '2014-03-01 01:17:18.000000', 'consum', 0.0217, 'lps'),
	(568895, 130, '2014-03-01 01:17:19.000000', 'consum', 0.0225, 'lps'),
	(568896, 130, '2014-03-01 01:17:20.000000', 'consum', 0.0224, 'lps'),
	(568897, 130, '2014-03-01 01:17:21.000000', 'consum', 0.0217, 'lps'),
	(568898, 130, '2014-03-01 01:17:22.000000', 'consum', 0.0222, 'lps'),
	(568899, 130, '2014-03-01 01:17:23.000000', 'consum', 0.0212, 'lps'),
	(568900, 130, '2014-03-01 01:17:24.000000', 'consum', 0.0224, 'lps'),
	(568901, 130, '2014-03-01 01:17:25.000000', 'consum', 0.0217, 'lps'),
	(568902, 130, '2014-03-01 01:17:26.000000', 'consum', 0.0221, 'lps'),
	(568903, 130, '2014-03-01 01:17:27.000000', 'consum', 0.0226, 'lps'),
	(568904, 130, '2014-03-01 01:17:28.000000', 'consum', 0.0219, 'lps'),
	(568905, 130, '2014-03-01 01:17:29.000000', 'consum', 0.0228, 'lps'),
	(568906, 130, '2014-03-01 01:17:30.000000', 'consum', 0.0215, 'lps'),
	(568907, 130, '2014-03-01 01:17:31.000000', 'consum', 0.0221, 'lps'),
	(568908, 130, '2014-03-01 01:17:32.000000', 'consum', 0.0212, 'lps'),
	(568909, 130, '2014-03-01 01:17:33.000000', 'consum', 0.0224, 'lps'),
	(568910, 130, '2014-03-01 01:17:34.000000', 'consum', 0.0218, 'lps'),
	(568911, 130, '2014-03-01 01:17:35.000000', 'consum', 0.0226, 'lps'),
	(568912, 130, '2014-03-01 01:17:36.000000', 'consum', 0.0213, 'lps'),
	(568913, 130, '2014-03-01 01:17:37.000000', 'consum', 0.0212, 'lps'),
	(568914, 130, '2014-03-01 01:17:38.000000', 'consum', 0.0214, 'lps'),
	(568915, 130, '2014-03-01 01:17:39.000000', 'consum', 0.0225, 'lps'),
	(568916, 130, '2014-03-01 01:17:40.000000', 'consum', 0.0217, 'lps'),
	(568917, 130, '2014-03-01 01:17:41.000000', 'consum', 0.0218, 'lps'),
	(568918, 130, '2014-03-01 01:17:42.000000', 'consum', 0.0228, 'lps'),
	(568919, 130, '2014-03-01 01:17:43.000000', 'consum', 0.0222, 'lps'),
	(568920, 130, '2014-03-01 01:17:44.000000', 'consum', 0.0217, 'lps'),
	(568921, 130, '2014-03-01 01:17:45.000000', 'consum', 0.0226, 'lps'),
	(568922, 130, '2014-03-01 01:17:46.000000', 'consum', 0.0213, 'lps'),
	(568923, 130, '2014-03-01 01:17:47.000000', 'consum', 0.0214, 'lps'),
	(568924, 130, '2014-03-01 01:17:48.000000', 'consum', 0.0222, 'lps'),
	(568925, 130, '2014-03-01 01:17:49.000000', 'consum', 0.0220, 'lps'),
	(568926, 130, '2014-03-01 01:17:50.000000', 'consum', 0.0227, 'lps'),
	(568927, 130, '2014-03-01 01:17:51.000000', 'consum', 0.0224, 'lps'),
	(568928, 130, '2014-03-01 01:17:52.000000', 'consum', 0.0214, 'lps'),
	(568929, 130, '2014-03-01 01:17:53.000000', 'consum', 0.0223, 'lps'),
	(568930, 130, '2014-03-01 01:17:54.000000', 'consum', 0.0228, 'lps'),
	(568931, 130, '2014-03-01 01:17:55.000000', 'consum', 0.0222, 'lps'),
	(568932, 130, '2014-03-01 01:17:56.000000', 'consum', 0.0216, 'lps'),
	(568933, 130, '2014-03-01 01:17:57.000000', 'consum', 0.0224, 'lps'),
	(568934, 130, '2014-03-01 01:17:58.000000', 'consum', 0.0226, 'lps'),
	(568935, 130, '2014-03-01 01:17:59.000000', 'consum', 0.0211, 'lps'),
	(568936, 130, '2014-03-01 01:18:00.000000', 'consum', 0.0221, 'lps'),
	(568937, 130, '2014-03-01 01:18:01.000000', 'consum', 0.0228, 'lps'),
	(568938, 130, '2014-03-01 01:18:02.000000', 'consum', 0.0228, 'lps'),
	(568939, 130, '2014-03-01 01:18:03.000000', 'consum', 0.0228, 'lps'),
	(568940, 130, '2014-03-01 01:18:04.000000', 'consum', 0.0228, 'lps'),
	(568941, 130, '2014-03-01 01:18:05.000000', 'consum', 0.0226, 'lps'),
	(568942, 130, '2014-03-01 01:18:06.000000', 'consum', 0.0219, 'lps'),
	(568943, 130, '2014-03-01 01:18:07.000000', 'consum', 0.0226, 'lps'),
	(568944, 130, '2014-03-01 01:18:08.000000', 'consum', 0.0226, 'lps'),
	(568945, 130, '2014-03-01 01:18:09.000000', 'consum', 0.0224, 'lps'),
	(568946, 130, '2014-03-01 01:18:10.000000', 'consum', 0.0214, 'lps'),
	(568947, 130, '2014-03-01 01:18:11.000000', 'consum', 0.0225, 'lps'),
	(568948, 130, '2014-03-01 01:18:12.000000', 'consum', 0.0217, 'lps'),
	(568949, 130, '2014-03-01 01:18:13.000000', 'consum', 0.0218, 'lps'),
	(568950, 130, '2014-03-01 01:18:14.000000', 'consum', 0.0211, 'lps'),
	(568951, 130, '2014-03-01 01:18:15.000000', 'consum', 0.0211, 'lps'),
	(568952, 130, '2014-03-01 01:18:16.000000', 'consum', 0.0213, 'lps'),
	(568953, 130, '2014-03-01 01:18:17.000000', 'consum', 0.0222, 'lps'),
	(568954, 130, '2014-03-01 01:18:18.000000', 'consum', 0.0224, 'lps'),
	(568955, 130, '2014-03-01 01:18:19.000000', 'consum', 0.0226, 'lps'),
	(568956, 130, '2014-03-01 01:18:20.000000', 'consum', 0.0227, 'lps'),
	(568957, 130, '2014-03-01 01:18:21.000000', 'consum', 0.0210, 'lps'),
	(568958, 130, '2014-03-01 01:18:22.000000', 'consum', 0.0219, 'lps'),
	(568959, 130, '2014-03-01 01:18:23.000000', 'consum', 0.0214, 'lps'),
	(568960, 130, '2014-03-01 01:18:24.000000', 'consum', 0.0226, 'lps'),
	(568961, 130, '2014-03-01 01:18:25.000000', 'consum', 0.0219, 'lps'),
	(568962, 130, '2014-03-01 01:18:26.000000', 'consum', 0.0226, 'lps'),
	(568963, 130, '2014-03-01 01:18:27.000000', 'consum', 0.0226, 'lps'),
	(568964, 130, '2014-03-01 01:18:28.000000', 'consum', 0.0225, 'lps'),
	(568965, 130, '2014-03-01 01:18:29.000000', 'consum', 0.0218, 'lps'),
	(568966, 130, '2014-03-01 01:18:30.000000', 'consum', 0.0226, 'lps'),
	(568967, 130, '2014-03-01 01:18:31.000000', 'consum', 0.0225, 'lps'),
	(568968, 130, '2014-03-01 01:18:32.000000', 'consum', 0.0222, 'lps'),
	(568969, 130, '2014-03-01 01:18:33.000000', 'consum', 0.0224, 'lps'),
	(568970, 130, '2014-03-01 01:18:34.000000', 'consum', 0.0227, 'lps'),
	(568971, 130, '2014-03-01 01:18:35.000000', 'consum', 0.0216, 'lps'),
	(568972, 130, '2014-03-01 01:18:36.000000', 'consum', 0.0225, 'lps'),
	(568973, 130, '2014-03-01 01:18:37.000000', 'consum', 0.0228, 'lps'),
	(568974, 130, '2014-03-01 01:18:38.000000', 'consum', 0.0221, 'lps'),
	(568975, 130, '2014-03-01 01:18:39.000000', 'consum', 0.0212, 'lps'),
	(568976, 130, '2014-03-01 01:18:40.000000', 'consum', 0.0224, 'lps'),
	(568977, 130, '2014-03-01 01:18:41.000000', 'consum', 0.0217, 'lps'),
	(568978, 130, '2014-03-01 01:18:42.000000', 'consum', 0.0225, 'lps'),
	(568979, 130, '2014-03-01 01:18:43.000000', 'consum', 0.0224, 'lps'),
	(568980, 130, '2014-03-01 01:18:44.000000', 'consum', 0.0217, 'lps'),
	(568981, 130, '2014-03-01 01:18:45.000000', 'consum', 0.0223, 'lps'),
	(568982, 130, '2014-03-01 01:18:46.000000', 'consum', 0.0215, 'lps'),
	(568983, 130, '2014-03-01 01:18:47.000000', 'consum', 0.0215, 'lps'),
	(568984, 130, '2014-03-01 01:18:48.000000', 'consum', 0.0221, 'lps'),
	(568985, 130, '2014-03-01 01:18:49.000000', 'consum', 0.0212, 'lps'),
	(568986, 130, '2014-03-01 01:18:50.000000', 'consum', 0.0227, 'lps'),
	(568987, 130, '2014-03-01 01:18:51.000000', 'consum', 0.0213, 'lps'),
	(568988, 130, '2014-03-01 01:18:52.000000', 'consum', 0.0211, 'lps'),
	(568989, 130, '2014-03-01 01:18:53.000000', 'consum', 0.0226, 'lps'),
	(568990, 130, '2014-03-01 01:18:54.000000', 'consum', 0.0213, 'lps'),
	(568991, 130, '2014-03-01 01:18:55.000000', 'consum', 0.0215, 'lps'),
	(568992, 130, '2014-03-01 01:18:56.000000', 'consum', 0.0226, 'lps'),
	(568993, 130, '2014-03-01 01:18:57.000000', 'consum', 0.0217, 'lps'),
	(568994, 130, '2014-03-01 01:18:58.000000', 'consum', 0.0219, 'lps'),
	(568995, 130, '2014-03-01 01:18:59.000000', 'consum', 0.0214, 'lps'),
	(568996, 130, '2014-03-01 01:19:00.000000', 'consum', 0.0222, 'lps'),
	(568997, 130, '2014-03-01 01:19:01.000000', 'consum', 0.0222, 'lps'),
	(568998, 130, '2014-03-01 01:19:02.000000', 'consum', 0.0216, 'lps'),
	(568999, 130, '2014-03-01 01:19:03.000000', 'consum', 0.0221, 'lps'),
	(569000, 130, '2014-03-01 01:19:04.000000', 'consum', 0.0210, 'lps'),
	(569001, 130, '2014-03-01 01:19:05.000000', 'consum', 0.0217, 'lps'),
	(569002, 130, '2014-03-01 01:19:06.000000', 'consum', 0.0224, 'lps'),
	(569003, 130, '2014-03-01 01:19:07.000000', 'consum', 0.0221, 'lps'),
	(569004, 130, '2014-03-01 01:19:08.000000', 'consum', 0.0226, 'lps'),
	(569005, 130, '2014-03-01 01:19:09.000000', 'consum', 0.0220, 'lps'),
	(569006, 130, '2014-03-01 01:19:10.000000', 'consum', 0.0211, 'lps'),
	(569007, 130, '2014-03-01 01:19:11.000000', 'consum', 0.0222, 'lps'),
	(569008, 130, '2014-03-01 01:19:12.000000', 'consum', 0.0213, 'lps'),
	(569009, 130, '2014-03-01 01:19:13.000000', 'consum', 0.0228, 'lps'),
	(569010, 130, '2014-03-01 01:19:14.000000', 'consum', 0.0213, 'lps'),
	(569011, 130, '2014-03-01 01:19:15.000000', 'consum', 0.0211, 'lps'),
	(569012, 130, '2014-03-01 01:19:16.000000', 'consum', 0.0225, 'lps'),
	(569013, 130, '2014-03-01 01:19:17.000000', 'consum', 0.0227, 'lps'),
	(569014, 130, '2014-03-01 01:19:18.000000', 'consum', 0.0211, 'lps'),
	(569015, 130, '2014-03-01 01:19:19.000000', 'consum', 0.0222, 'lps'),
	(569016, 130, '2014-03-01 01:19:20.000000', 'consum', 0.0227, 'lps'),
	(569017, 130, '2014-03-01 01:19:21.000000', 'consum', 0.0225, 'lps'),
	(569018, 130, '2014-03-01 01:19:22.000000', 'consum', 0.0215, 'lps'),
	(569019, 130, '2014-03-01 01:19:23.000000', 'consum', 0.0227, 'lps'),
	(569020, 130, '2014-03-01 01:19:24.000000', 'consum', 0.0223, 'lps'),
	(569021, 130, '2014-03-01 01:19:25.000000', 'consum', 0.0227, 'lps'),
	(569022, 130, '2014-03-01 01:19:26.000000', 'consum', 0.0218, 'lps'),
	(569023, 130, '2014-03-01 01:19:27.000000', 'consum', 0.0218, 'lps'),
	(569024, 130, '2014-03-01 01:19:28.000000', 'consum', 0.0226, 'lps'),
	(569025, 130, '2014-03-01 01:19:29.000000', 'consum', 0.0228, 'lps'),
	(569026, 130, '2014-03-01 01:19:30.000000', 'consum', 0.0214, 'lps'),
	(569027, 130, '2014-03-01 01:19:31.000000', 'consum', 0.0213, 'lps'),
	(569028, 130, '2014-03-01 01:19:32.000000', 'consum', 0.0217, 'lps'),
	(569029, 130, '2014-03-01 01:19:33.000000', 'consum', 0.0215, 'lps'),
	(569030, 130, '2014-03-01 01:19:34.000000', 'consum', 0.0217, 'lps'),
	(569031, 130, '2014-03-01 01:19:35.000000', 'consum', 0.0228, 'lps'),
	(569032, 130, '2014-03-01 01:19:36.000000', 'consum', 0.0223, 'lps'),
	(569033, 130, '2014-03-01 01:19:37.000000', 'consum', 0.0221, 'lps'),
	(569034, 130, '2014-03-01 01:19:38.000000', 'consum', 0.0225, 'lps'),
	(569035, 130, '2014-03-01 01:19:39.000000', 'consum', 0.0216, 'lps'),
	(569036, 130, '2014-03-01 01:19:40.000000', 'consum', 0.0215, 'lps'),
	(569037, 130, '2014-03-01 01:19:41.000000', 'consum', 0.0217, 'lps'),
	(569038, 130, '2014-03-01 01:19:42.000000', 'consum', 0.0211, 'lps'),
	(569039, 130, '2014-03-01 01:19:43.000000', 'consum', 0.0212, 'lps'),
	(569040, 130, '2014-03-01 01:19:44.000000', 'consum', 0.0220, 'lps'),
	(569041, 130, '2014-03-01 01:19:45.000000', 'consum', 0.0215, 'lps'),
	(569042, 130, '2014-03-01 01:19:46.000000', 'consum', 0.0223, 'lps'),
	(569043, 130, '2014-03-01 01:19:47.000000', 'consum', 0.0223, 'lps'),
	(569044, 130, '2014-03-01 01:19:48.000000', 'consum', 0.0220, 'lps'),
	(569045, 130, '2014-03-01 01:19:49.000000', 'consum', 0.0219, 'lps'),
	(569046, 130, '2014-03-01 01:19:50.000000', 'consum', 0.0227, 'lps'),
	(569047, 130, '2014-03-01 01:19:51.000000', 'consum', 0.0210, 'lps'),
	(569048, 130, '2014-03-01 01:19:52.000000', 'consum', 0.0218, 'lps'),
	(569049, 130, '2014-03-01 01:19:53.000000', 'consum', 0.0214, 'lps'),
	(569050, 130, '2014-03-01 01:19:54.000000', 'consum', 0.0223, 'lps'),
	(569051, 130, '2014-03-01 01:19:55.000000', 'consum', 0.0225, 'lps'),
	(569052, 130, '2014-03-01 01:19:56.000000', 'consum', 0.0227, 'lps'),
	(569053, 130, '2014-03-01 01:19:57.000000', 'consum', 0.0212, 'lps'),
	(569054, 130, '2014-03-01 01:19:58.000000', 'consum', 0.0227, 'lps'),
	(569055, 130, '2014-03-01 01:19:59.000000', 'consum', 0.0213, 'lps'),
	(569056, 130, '2014-03-01 01:20:00.000000', 'consum', 0.0212, 'lps'),
	(569057, 130, '2014-03-01 01:20:01.000000', 'consum', 0.0212, 'lps'),
	(569058, 130, '2014-03-01 01:20:02.000000', 'consum', 0.0215, 'lps'),
	(569059, 130, '2014-03-01 01:20:03.000000', 'consum', 0.0228, 'lps'),
	(569060, 130, '2014-03-01 01:20:04.000000', 'consum', 0.0211, 'lps'),
	(569061, 130, '2014-03-01 01:20:05.000000', 'consum', 0.0220, 'lps'),
	(569062, 130, '2014-03-01 01:20:06.000000', 'consum', 0.0219, 'lps'),
	(569063, 130, '2014-03-01 01:20:07.000000', 'consum', 0.0224, 'lps'),
	(569064, 130, '2014-03-01 01:20:08.000000', 'consum', 0.0216, 'lps'),
	(569065, 130, '2014-03-01 01:20:09.000000', 'consum', 0.0218, 'lps'),
	(569066, 130, '2014-03-01 01:20:10.000000', 'consum', 0.0214, 'lps'),
	(569067, 130, '2014-03-01 01:20:11.000000', 'consum', 0.0225, 'lps'),
	(569068, 130, '2014-03-01 01:20:12.000000', 'consum', 0.0215, 'lps'),
	(569069, 130, '2014-03-01 01:20:13.000000', 'consum', 0.0210, 'lps'),
	(569070, 130, '2014-03-01 01:20:14.000000', 'consum', 0.0216, 'lps'),
	(569071, 130, '2014-03-01 01:20:15.000000', 'consum', 0.0222, 'lps'),
	(569072, 130, '2014-03-01 01:20:16.000000', 'consum', 0.0214, 'lps'),
	(569073, 130, '2014-03-01 01:20:17.000000', 'consum', 0.0214, 'lps'),
	(569074, 130, '2014-03-01 01:20:18.000000', 'consum', 0.0219, 'lps'),
	(569075, 130, '2014-03-01 01:20:19.000000', 'consum', 0.0225, 'lps'),
	(569076, 130, '2014-03-01 01:20:20.000000', 'consum', 0.0218, 'lps'),
	(569077, 130, '2014-03-01 01:20:21.000000', 'consum', 0.0225, 'lps'),
	(569078, 130, '2014-03-01 01:20:22.000000', 'consum', 0.0222, 'lps'),
	(569079, 130, '2014-03-01 01:20:23.000000', 'consum', 0.0210, 'lps'),
	(569080, 130, '2014-03-01 01:20:24.000000', 'consum', 0.0210, 'lps'),
	(569081, 130, '2014-03-01 01:20:25.000000', 'consum', 0.0210, 'lps'),
	(569082, 130, '2014-03-01 01:20:26.000000', 'consum', 0.0210, 'lps'),
	(569083, 130, '2014-03-01 01:20:27.000000', 'consum', 0.0212, 'lps'),
	(569084, 130, '2014-03-01 01:20:28.000000', 'consum', 0.0221, 'lps'),
	(569085, 130, '2014-03-01 01:20:29.000000', 'consum', 0.0222, 'lps'),
	(569086, 130, '2014-03-01 01:20:30.000000', 'consum', 0.0216, 'lps'),
	(569087, 130, '2014-03-01 01:20:31.000000', 'consum', 0.0226, 'lps'),
	(569088, 130, '2014-03-01 01:20:32.000000', 'consum', 0.0213, 'lps'),
	(569089, 130, '2014-03-01 01:20:33.000000', 'consum', 0.0216, 'lps'),
	(569090, 130, '2014-03-01 01:20:34.000000', 'consum', 0.0215, 'lps'),
	(569091, 130, '2014-03-01 01:20:35.000000', 'consum', 0.0214, 'lps'),
	(569092, 130, '2014-03-01 01:20:36.000000', 'consum', 0.0218, 'lps'),
	(569093, 130, '2014-03-01 01:20:37.000000', 'consum', 0.0218, 'lps'),
	(569094, 130, '2014-03-01 01:20:38.000000', 'consum', 0.0226, 'lps'),
	(569095, 130, '2014-03-01 01:20:39.000000', 'consum', 0.0228, 'lps'),
	(569096, 130, '2014-03-01 01:20:40.000000', 'consum', 0.0216, 'lps'),
	(569097, 130, '2014-03-01 01:20:41.000000', 'consum', 0.0223, 'lps'),
	(569098, 130, '2014-03-01 01:20:42.000000', 'consum', 0.0219, 'lps'),
	(569099, 130, '2014-03-01 01:20:43.000000', 'consum', 0.0215, 'lps'),
	(569100, 130, '2014-03-01 01:20:44.000000', 'consum', 0.0212, 'lps'),
	(569101, 130, '2014-03-01 01:20:45.000000', 'consum', 0.0224, 'lps'),
	(569102, 130, '2014-03-01 01:20:46.000000', 'consum', 0.0217, 'lps'),
	(569103, 130, '2014-03-01 01:20:47.000000', 'consum', 0.0222, 'lps'),
	(569104, 130, '2014-03-01 01:20:48.000000', 'consum', 0.0211, 'lps'),
	(569105, 130, '2014-03-01 01:20:49.000000', 'consum', 0.0219, 'lps'),
	(569106, 130, '2014-03-01 01:20:50.000000', 'consum', 0.0214, 'lps'),
	(569107, 130, '2014-03-01 01:20:51.000000', 'consum', 0.0221, 'lps'),
	(569108, 130, '2014-03-01 01:20:52.000000', 'consum', 0.0217, 'lps'),
	(569109, 130, '2014-03-01 01:20:53.000000', 'consum', 0.0213, 'lps'),
	(569110, 130, '2014-03-01 01:20:54.000000', 'consum', 0.0223, 'lps'),
	(569111, 130, '2014-03-01 01:20:55.000000', 'consum', 0.0226, 'lps'),
	(569112, 130, '2014-03-01 01:20:56.000000', 'consum', 0.0217, 'lps'),
	(569113, 130, '2014-03-01 01:20:57.000000', 'consum', 0.0215, 'lps'),
	(569114, 130, '2014-03-01 01:20:58.000000', 'consum', 0.0213, 'lps'),
	(569115, 130, '2014-03-01 01:20:59.000000', 'consum', 0.0212, 'lps'),
	(569116, 130, '2014-03-01 01:21:00.000000', 'consum', 0.0210, 'lps'),
	(569117, 130, '2014-03-01 01:21:01.000000', 'consum', 0.0226, 'lps'),
	(569118, 130, '2014-03-01 01:21:02.000000', 'consum', 0.0212, 'lps'),
	(569119, 130, '2014-03-01 01:21:03.000000', 'consum', 0.0214, 'lps'),
	(569120, 130, '2014-03-01 01:21:04.000000', 'consum', 0.0221, 'lps'),
	(569121, 130, '2014-03-01 01:21:05.000000', 'consum', 0.0216, 'lps'),
	(569122, 130, '2014-03-01 01:21:06.000000', 'consum', 0.0227, 'lps'),
	(569123, 130, '2014-03-01 01:21:07.000000', 'consum', 0.0222, 'lps'),
	(569124, 130, '2014-03-01 01:21:08.000000', 'consum', 0.0220, 'lps'),
	(569125, 130, '2014-03-01 01:21:09.000000', 'consum', 0.0223, 'lps'),
	(569126, 130, '2014-03-01 01:21:10.000000', 'consum', 0.0227, 'lps'),
	(569127, 130, '2014-03-01 01:21:11.000000', 'consum', 0.0218, 'lps'),
	(569128, 130, '2014-03-01 01:21:12.000000', 'consum', 0.0217, 'lps'),
	(569129, 130, '2014-03-01 01:21:13.000000', 'consum', 0.0222, 'lps'),
	(569130, 130, '2014-03-01 01:21:14.000000', 'consum', 0.0212, 'lps'),
	(569131, 130, '2014-03-01 01:21:15.000000', 'consum', 0.0222, 'lps'),
	(569132, 130, '2014-03-01 01:21:16.000000', 'consum', 0.0226, 'lps'),
	(569133, 130, '2014-03-01 01:21:17.000000', 'consum', 0.0217, 'lps'),
	(569134, 130, '2014-03-01 01:21:18.000000', 'consum', 0.0215, 'lps'),
	(569135, 130, '2014-03-01 01:21:19.000000', 'consum', 0.0217, 'lps'),
	(569136, 130, '2014-03-01 01:21:20.000000', 'consum', 0.0228, 'lps'),
	(569137, 130, '2014-03-01 01:21:21.000000', 'consum', 0.0223, 'lps'),
	(569138, 130, '2014-03-01 01:21:22.000000', 'consum', 0.0221, 'lps'),
	(569139, 130, '2014-03-01 01:21:23.000000', 'consum', 0.0226, 'lps'),
	(569140, 130, '2014-03-01 01:21:24.000000', 'consum', 0.0221, 'lps'),
	(569141, 130, '2014-03-01 01:21:25.000000', 'consum', 0.0219, 'lps'),
	(569142, 130, '2014-03-01 01:21:26.000000', 'consum', 0.0220, 'lps'),
	(569143, 130, '2014-03-01 01:21:27.000000', 'consum', 0.0216, 'lps'),
	(569144, 130, '2014-03-01 01:21:28.000000', 'consum', 0.0211, 'lps'),
	(569145, 130, '2014-03-01 01:21:29.000000', 'consum', 0.0216, 'lps'),
	(569146, 130, '2014-03-01 01:21:30.000000', 'consum', 0.0219, 'lps'),
	(569147, 130, '2014-03-01 01:21:31.000000', 'consum', 0.0216, 'lps'),
	(569148, 130, '2014-03-01 01:21:32.000000', 'consum', 0.0215, 'lps'),
	(569149, 130, '2014-03-01 01:21:33.000000', 'consum', 0.0219, 'lps'),
	(569150, 130, '2014-03-01 01:21:34.000000', 'consum', 0.0222, 'lps'),
	(569151, 130, '2014-03-01 01:21:35.000000', 'consum', 0.0225, 'lps'),
	(569152, 130, '2014-03-01 01:21:36.000000', 'consum', 0.0228, 'lps'),
	(569153, 130, '2014-03-01 01:21:37.000000', 'consum', 0.0220, 'lps'),
	(569154, 130, '2014-03-01 01:21:38.000000', 'consum', 0.0224, 'lps'),
	(569155, 130, '2014-03-01 01:21:39.000000', 'consum', 0.0215, 'lps'),
	(569156, 130, '2014-03-01 01:21:40.000000', 'consum', 0.0211, 'lps'),
	(569157, 130, '2014-03-01 01:21:41.000000', 'consum', 0.0218, 'lps'),
	(569158, 130, '2014-03-01 01:21:42.000000', 'consum', 0.0210, 'lps'),
	(569159, 130, '2014-03-01 01:21:43.000000', 'consum', 0.0224, 'lps'),
	(569160, 130, '2014-03-01 01:21:44.000000', 'consum', 0.0222, 'lps'),
	(569161, 130, '2014-03-01 01:21:45.000000', 'consum', 0.0212, 'lps'),
	(569162, 130, '2014-03-01 01:21:46.000000', 'consum', 0.0223, 'lps'),
	(569163, 130, '2014-03-01 01:21:47.000000', 'consum', 0.0210, 'lps'),
	(569164, 130, '2014-03-01 01:21:48.000000', 'consum', 0.0211, 'lps'),
	(569165, 130, '2014-03-01 01:21:49.000000', 'consum', 0.0216, 'lps'),
	(569166, 130, '2014-03-01 01:21:50.000000', 'consum', 0.0218, 'lps'),
	(569167, 130, '2014-03-01 01:21:51.000000', 'consum', 0.0211, 'lps'),
	(569168, 130, '2014-03-01 01:21:52.000000', 'consum', 0.0214, 'lps'),
	(569169, 130, '2014-03-01 01:21:53.000000', 'consum', 0.0226, 'lps'),
	(569170, 130, '2014-03-01 01:21:54.000000', 'consum', 0.0221, 'lps'),
	(569171, 130, '2014-03-01 01:21:55.000000', 'consum', 0.0217, 'lps'),
	(569172, 130, '2014-03-01 01:21:56.000000', 'consum', 0.0213, 'lps'),
	(569173, 130, '2014-03-01 01:21:57.000000', 'consum', 0.0222, 'lps'),
	(569174, 130, '2014-03-01 01:21:58.000000', 'consum', 0.0226, 'lps'),
	(569175, 130, '2014-03-01 01:21:59.000000', 'consum', 0.0217, 'lps'),
	(569176, 130, '2014-03-01 01:22:00.000000', 'consum', 0.0217, 'lps'),
	(569177, 130, '2014-03-01 01:22:01.000000', 'consum', 0.0222, 'lps'),
	(569178, 130, '2014-03-01 01:22:02.000000', 'consum', 0.0211, 'lps'),
	(569179, 130, '2014-03-01 01:22:03.000000', 'consum', 0.0218, 'lps'),
	(569180, 130, '2014-03-01 01:22:04.000000', 'consum', 0.0228, 'lps'),
	(569181, 130, '2014-03-01 01:22:05.000000', 'consum', 0.0220, 'lps'),
	(569182, 130, '2014-03-01 01:22:06.000000', 'consum', 0.0227, 'lps'),
	(569183, 130, '2014-03-01 01:22:07.000000', 'consum', 0.0228, 'lps'),
	(569184, 130, '2014-03-01 01:22:08.000000', 'consum', 0.0210, 'lps'),
	(569185, 130, '2014-03-01 01:22:09.000000', 'consum', 0.0214, 'lps'),
	(569186, 130, '2014-03-01 01:22:10.000000', 'consum', 0.0211, 'lps'),
	(569187, 130, '2014-03-01 01:22:11.000000', 'consum', 0.0221, 'lps'),
	(569188, 130, '2014-03-01 01:22:12.000000', 'consum', 0.0224, 'lps'),
	(569189, 130, '2014-03-01 01:22:13.000000', 'consum', 0.0213, 'lps'),
	(569190, 130, '2014-03-01 01:22:14.000000', 'consum', 0.0219, 'lps'),
	(569191, 130, '2014-03-01 01:22:15.000000', 'consum', 0.0210, 'lps'),
	(569192, 130, '2014-03-01 01:22:16.000000', 'consum', 0.0221, 'lps'),
	(569193, 130, '2014-03-01 01:22:17.000000', 'consum', 0.0227, 'lps'),
	(569194, 130, '2014-03-01 01:22:18.000000', 'consum', 0.0227, 'lps'),
	(569195, 130, '2014-03-01 01:22:19.000000', 'consum', 0.0223, 'lps'),
	(569196, 130, '2014-03-01 01:22:20.000000', 'consum', 0.0226, 'lps'),
	(569197, 130, '2014-03-01 01:22:21.000000', 'consum', 0.0211, 'lps'),
	(569198, 130, '2014-03-01 01:22:22.000000', 'consum', 0.0226, 'lps'),
	(569199, 130, '2014-03-01 01:22:23.000000', 'consum', 0.0212, 'lps'),
	(569200, 130, '2014-03-01 01:22:24.000000', 'consum', 0.0228, 'lps'),
	(569201, 130, '2014-03-01 01:22:25.000000', 'consum', 0.0221, 'lps'),
	(569202, 130, '2014-03-01 01:22:26.000000', 'consum', 0.0212, 'lps'),
	(569203, 130, '2014-03-01 01:22:27.000000', 'consum', 0.0223, 'lps'),
	(569204, 130, '2014-03-01 01:22:28.000000', 'consum', 0.0214, 'lps'),
	(569205, 130, '2014-03-01 01:22:29.000000', 'consum', 0.0211, 'lps'),
	(569206, 130, '2014-03-01 01:22:30.000000', 'consum', 0.0223, 'lps'),
	(569207, 130, '2014-03-01 01:22:31.000000', 'consum', 0.0213, 'lps'),
	(569208, 130, '2014-03-01 01:22:32.000000', 'consum', 0.0227, 'lps'),
	(569209, 130, '2014-03-01 01:22:33.000000', 'consum', 0.0228, 'lps'),
	(569210, 130, '2014-03-01 01:22:34.000000', 'consum', 0.0214, 'lps'),
	(569211, 130, '2014-03-01 01:22:35.000000', 'consum', 0.0211, 'lps'),
	(569212, 130, '2014-03-01 01:22:36.000000', 'consum', 0.0224, 'lps'),
	(569213, 130, '2014-03-01 01:22:37.000000', 'consum', 0.0221, 'lps'),
	(569214, 130, '2014-03-01 01:22:38.000000', 'consum', 0.0223, 'lps'),
	(569215, 130, '2014-03-01 01:22:39.000000', 'consum', 0.0224, 'lps'),
	(569216, 130, '2014-03-01 01:22:40.000000', 'consum', 0.0222, 'lps'),
	(569217, 130, '2014-03-01 01:22:41.000000', 'consum', 0.0211, 'lps'),
	(569218, 130, '2014-03-01 01:22:42.000000', 'consum', 0.0216, 'lps'),
	(569219, 130, '2014-03-01 01:22:43.000000', 'consum', 0.0218, 'lps'),
	(569220, 130, '2014-03-01 01:22:44.000000', 'consum', 0.0216, 'lps'),
	(569221, 130, '2014-03-01 01:22:45.000000', 'consum', 0.0215, 'lps'),
	(569222, 130, '2014-03-01 01:22:46.000000', 'consum', 0.0217, 'lps'),
	(569223, 130, '2014-03-01 01:22:47.000000', 'consum', 0.0214, 'lps'),
	(569224, 130, '2014-03-01 01:22:48.000000', 'consum', 0.0226, 'lps'),
	(569225, 130, '2014-03-01 01:22:49.000000', 'consum', 0.0222, 'lps'),
	(569226, 130, '2014-03-01 01:22:50.000000', 'consum', 0.0222, 'lps'),
	(569227, 130, '2014-03-01 01:22:51.000000', 'consum', 0.0216, 'lps'),
	(569228, 130, '2014-03-01 01:22:52.000000', 'consum', 0.0225, 'lps'),
	(569229, 130, '2014-03-01 01:22:53.000000', 'consum', 0.0210, 'lps'),
	(569230, 130, '2014-03-01 01:22:54.000000', 'consum', 0.0224, 'lps'),
	(569231, 130, '2014-03-01 01:22:55.000000', 'consum', 0.0222, 'lps'),
	(569232, 130, '2014-03-01 01:22:56.000000', 'consum', 0.0212, 'lps'),
	(569233, 130, '2014-03-01 01:22:57.000000', 'consum', 0.0220, 'lps'),
	(569234, 130, '2014-03-01 01:22:58.000000', 'consum', 0.0215, 'lps'),
	(569235, 130, '2014-03-01 01:22:59.000000', 'consum', 0.0226, 'lps'),
	(569236, 130, '2014-03-01 01:23:00.000000', 'consum', 0.0219, 'lps'),
	(569237, 130, '2014-03-01 01:23:01.000000', 'consum', 0.0225, 'lps'),
	(569238, 130, '2014-03-01 01:23:02.000000', 'consum', 0.0219, 'lps'),
	(569239, 130, '2014-03-01 01:23:03.000000', 'consum', 0.0213, 'lps'),
	(569240, 130, '2014-03-01 01:23:04.000000', 'consum', 0.0219, 'lps'),
	(569241, 130, '2014-03-01 01:23:05.000000', 'consum', 0.0224, 'lps'),
	(569242, 130, '2014-03-01 01:23:06.000000', 'consum', 0.0218, 'lps'),
	(569243, 130, '2014-03-01 01:23:07.000000', 'consum', 0.0228, 'lps'),
	(569244, 130, '2014-03-01 01:23:08.000000', 'consum', 0.0220, 'lps'),
	(569245, 130, '2014-03-01 01:23:09.000000', 'consum', 0.0226, 'lps'),
	(569246, 130, '2014-03-01 01:23:10.000000', 'consum', 0.0221, 'lps'),
	(569247, 130, '2014-03-01 01:23:11.000000', 'consum', 0.0217, 'lps'),
	(569248, 130, '2014-03-01 01:23:12.000000', 'consum', 0.0213, 'lps'),
	(569249, 130, '2014-03-01 01:23:13.000000', 'consum', 0.0224, 'lps'),
	(569250, 130, '2014-03-01 01:23:14.000000', 'consum', 0.0214, 'lps'),
	(569251, 130, '2014-03-01 01:23:15.000000', 'consum', 0.0226, 'lps'),
	(569252, 130, '2014-03-01 01:23:16.000000', 'consum', 0.0220, 'lps'),
	(569253, 130, '2014-03-01 01:23:17.000000', 'consum', 0.0216, 'lps'),
	(569254, 130, '2014-03-01 01:23:18.000000', 'consum', 0.0226, 'lps'),
	(569255, 130, '2014-03-01 01:23:19.000000', 'consum', 0.0217, 'lps'),
	(569256, 130, '2014-03-01 01:23:20.000000', 'consum', 0.0217, 'lps'),
	(569257, 130, '2014-03-01 01:23:21.000000', 'consum', 0.0225, 'lps'),
	(569258, 130, '2014-03-01 01:23:22.000000', 'consum', 0.0227, 'lps'),
	(569259, 130, '2014-03-01 01:23:23.000000', 'consum', 0.0213, 'lps'),
	(569260, 130, '2014-03-01 01:23:24.000000', 'consum', 0.0213, 'lps'),
	(569261, 130, '2014-03-01 01:23:25.000000', 'consum', 0.0215, 'lps'),
	(569262, 130, '2014-03-01 01:23:26.000000', 'consum', 0.0226, 'lps'),
	(569263, 130, '2014-03-01 01:23:27.000000', 'consum', 0.0220, 'lps'),
	(569264, 130, '2014-03-01 01:23:28.000000', 'consum', 0.0211, 'lps'),
	(569265, 130, '2014-03-01 01:23:29.000000', 'consum', 0.0224, 'lps'),
	(569266, 130, '2014-03-01 01:23:30.000000', 'consum', 0.0222, 'lps'),
	(569267, 130, '2014-03-01 01:23:31.000000', 'consum', 0.0210, 'lps'),
	(569268, 130, '2014-03-01 01:23:32.000000', 'consum', 0.0210, 'lps'),
	(569269, 130, '2014-03-01 01:23:33.000000', 'consum', 0.0214, 'lps'),
	(569270, 130, '2014-03-01 01:23:34.000000', 'consum', 0.0227, 'lps'),
	(569271, 130, '2014-03-01 01:23:35.000000', 'consum', 0.0210, 'lps'),
	(569272, 130, '2014-03-01 01:23:36.000000', 'consum', 0.0216, 'lps'),
	(569273, 130, '2014-03-01 01:23:37.000000', 'consum', 0.0222, 'lps'),
	(569274, 130, '2014-03-01 01:23:38.000000', 'consum', 0.0212, 'lps'),
	(569275, 130, '2014-03-01 01:23:39.000000', 'consum', 0.0223, 'lps'),
	(569276, 130, '2014-03-01 01:23:40.000000', 'consum', 0.0214, 'lps'),
	(569277, 130, '2014-03-01 01:23:41.000000', 'consum', 0.0228, 'lps'),
	(569278, 130, '2014-03-01 01:23:42.000000', 'consum', 0.0214, 'lps'),
	(569279, 130, '2014-03-01 01:23:43.000000', 'consum', 0.0215, 'lps'),
	(569280, 130, '2014-03-01 01:23:44.000000', 'consum', 0.0222, 'lps'),
	(569281, 130, '2014-03-01 01:23:45.000000', 'consum', 0.0219, 'lps'),
	(569282, 130, '2014-03-01 01:23:46.000000', 'consum', 0.0217, 'lps'),
	(569283, 130, '2014-03-01 01:23:47.000000', 'consum', 0.0219, 'lps'),
	(569284, 130, '2014-03-01 01:23:48.000000', 'consum', 0.0217, 'lps'),
	(569285, 130, '2014-03-01 01:23:49.000000', 'consum', 0.0219, 'lps'),
	(569286, 130, '2014-03-01 01:23:50.000000', 'consum', 0.0215, 'lps'),
	(569287, 130, '2014-03-01 01:23:51.000000', 'consum', 0.0227, 'lps'),
	(569288, 130, '2014-03-01 01:23:52.000000', 'consum', 0.0223, 'lps'),
	(569289, 130, '2014-03-01 01:23:53.000000', 'consum', 0.0224, 'lps'),
	(569290, 130, '2014-03-01 01:23:54.000000', 'consum', 0.0224, 'lps'),
	(569291, 130, '2014-03-01 01:23:55.000000', 'consum', 0.0219, 'lps'),
	(569292, 130, '2014-03-01 01:23:56.000000', 'consum', 0.0215, 'lps'),
	(569293, 130, '2014-03-01 01:23:57.000000', 'consum', 0.0226, 'lps'),
	(569294, 130, '2014-03-01 01:23:58.000000', 'consum', 0.0219, 'lps'),
	(569295, 130, '2014-03-01 01:23:59.000000', 'consum', 0.0228, 'lps'),
	(569296, 130, '2014-03-01 01:24:00.000000', 'consum', 0.0214, 'lps'),
	(569297, 130, '2014-03-01 01:24:01.000000', 'consum', 0.0213, 'lps'),
	(569298, 130, '2014-03-01 01:24:02.000000', 'consum', 0.0217, 'lps'),
	(569299, 130, '2014-03-01 01:24:03.000000', 'consum', 0.0217, 'lps'),
	(569300, 130, '2014-03-01 01:24:04.000000', 'consum', 0.0222, 'lps'),
	(569301, 130, '2014-03-01 01:24:05.000000', 'consum', 0.0213, 'lps'),
	(569302, 130, '2014-03-01 01:24:06.000000', 'consum', 0.0227, 'lps'),
	(569303, 130, '2014-03-01 01:24:07.000000', 'consum', 0.0213, 'lps'),
	(569304, 130, '2014-03-01 01:24:08.000000', 'consum', 0.0210, 'lps'),
	(569305, 130, '2014-03-01 01:24:09.000000', 'consum', 0.0222, 'lps'),
	(569306, 130, '2014-03-01 01:24:10.000000', 'consum', 0.0213, 'lps'),
	(569307, 130, '2014-03-01 01:24:11.000000', 'consum', 0.0210, 'lps'),
	(569308, 130, '2014-03-01 01:24:12.000000', 'consum', 0.0219, 'lps'),
	(569309, 130, '2014-03-01 01:24:13.000000', 'consum', 0.0216, 'lps'),
	(569310, 130, '2014-03-01 01:24:14.000000', 'consum', 0.0215, 'lps'),
	(569311, 130, '2014-03-01 01:24:15.000000', 'consum', 0.0218, 'lps'),
	(569312, 130, '2014-03-01 01:24:16.000000', 'consum', 0.0217, 'lps'),
	(569313, 130, '2014-03-01 01:24:17.000000', 'consum', 0.0219, 'lps'),
	(569314, 130, '2014-03-01 01:24:18.000000', 'consum', 0.0216, 'lps'),
	(569315, 130, '2014-03-01 01:24:19.000000', 'consum', 0.0214, 'lps'),
	(569316, 130, '2014-03-01 01:24:20.000000', 'consum', 0.0213, 'lps'),
	(569317, 130, '2014-03-01 01:24:21.000000', 'consum', 0.0213, 'lps'),
	(569318, 130, '2014-03-01 01:24:22.000000', 'consum', 0.0216, 'lps'),
	(569319, 130, '2014-03-01 01:24:23.000000', 'consum', 0.0212, 'lps'),
	(569320, 130, '2014-03-01 01:24:24.000000', 'consum', 0.0222, 'lps'),
	(569321, 130, '2014-03-01 01:24:25.000000', 'consum', 0.0210, 'lps'),
	(569322, 130, '2014-03-01 01:24:26.000000', 'consum', 0.0228, 'lps'),
	(569323, 130, '2014-03-01 01:24:27.000000', 'consum', 0.0227, 'lps'),
	(569324, 130, '2014-03-01 01:24:28.000000', 'consum', 0.0220, 'lps'),
	(569325, 130, '2014-03-01 01:24:29.000000', 'consum', 0.0228, 'lps'),
	(569326, 130, '2014-03-01 01:24:30.000000', 'consum', 0.0213, 'lps'),
	(569327, 130, '2014-03-01 01:24:31.000000', 'consum', 0.0228, 'lps'),
	(569328, 130, '2014-03-01 01:24:32.000000', 'consum', 0.0218, 'lps'),
	(569329, 130, '2014-03-01 01:24:33.000000', 'consum', 0.0215, 'lps'),
	(569330, 130, '2014-03-01 01:24:34.000000', 'consum', 0.0212, 'lps'),
	(569331, 130, '2014-03-01 01:24:35.000000', 'consum', 0.0223, 'lps'),
	(569332, 130, '2014-03-01 01:24:36.000000', 'consum', 0.0214, 'lps'),
	(569333, 130, '2014-03-01 01:24:37.000000', 'consum', 0.0227, 'lps'),
	(569334, 130, '2014-03-01 01:24:38.000000', 'consum', 0.0211, 'lps'),
	(569335, 130, '2014-03-01 01:24:39.000000', 'consum', 0.0218, 'lps'),
	(569336, 130, '2014-03-01 01:24:40.000000', 'consum', 0.0213, 'lps'),
	(569337, 130, '2014-03-01 01:24:41.000000', 'consum', 0.0219, 'lps'),
	(569338, 130, '2014-03-01 01:24:42.000000', 'consum', 0.0228, 'lps'),
	(569339, 130, '2014-03-01 01:24:43.000000', 'consum', 0.0214, 'lps'),
	(569340, 130, '2014-03-01 01:24:44.000000', 'consum', 0.0218, 'lps'),
	(569341, 130, '2014-03-01 01:24:45.000000', 'consum', 0.0218, 'lps'),
	(569342, 130, '2014-03-01 01:24:46.000000', 'consum', 0.0228, 'lps'),
	(569343, 130, '2014-03-01 01:24:47.000000', 'consum', 0.0221, 'lps'),
	(569344, 130, '2014-03-01 01:24:48.000000', 'consum', 0.0227, 'lps'),
	(569345, 130, '2014-03-01 01:24:49.000000', 'consum', 0.0226, 'lps'),
	(569346, 130, '2014-03-01 01:24:50.000000', 'consum', 0.0221, 'lps'),
	(569347, 130, '2014-03-01 01:24:51.000000', 'consum', 0.0216, 'lps'),
	(569348, 130, '2014-03-01 01:24:52.000000', 'consum', 0.0228, 'lps'),
	(569349, 130, '2014-03-01 01:24:53.000000', 'consum', 0.0223, 'lps'),
	(569350, 130, '2014-03-01 01:24:54.000000', 'consum', 0.0224, 'lps'),
	(569351, 130, '2014-03-01 01:24:55.000000', 'consum', 0.0223, 'lps'),
	(569352, 130, '2014-03-01 01:24:56.000000', 'consum', 0.0213, 'lps'),
	(569353, 130, '2014-03-01 01:24:57.000000', 'consum', 0.0223, 'lps'),
	(569354, 130, '2014-03-01 01:24:58.000000', 'consum', 0.0210, 'lps'),
	(569355, 130, '2014-03-01 01:24:59.000000', 'consum', 0.0211, 'lps'),
	(569356, 130, '2014-03-01 01:25:00.000000', 'consum', 0.0216, 'lps'),
	(569357, 130, '2014-03-01 01:25:01.000000', 'consum', 0.0219, 'lps'),
	(569358, 130, '2014-03-01 01:25:02.000000', 'consum', 0.0216, 'lps'),
	(569359, 130, '2014-03-01 01:25:03.000000', 'consum', 0.0213, 'lps'),
	(569360, 130, '2014-03-01 01:25:04.000000', 'consum', 0.0210, 'lps'),
	(569361, 130, '2014-03-01 01:25:05.000000', 'consum', 0.0218, 'lps'),
	(569362, 130, '2014-03-01 01:25:06.000000', 'consum', 0.0212, 'lps'),
	(569363, 130, '2014-03-01 01:25:07.000000', 'consum', 0.0216, 'lps'),
	(569364, 130, '2014-03-01 01:25:08.000000', 'consum', 0.0215, 'lps'),
	(569365, 130, '2014-03-01 01:25:09.000000', 'consum', 0.0219, 'lps'),
	(569366, 130, '2014-03-01 01:25:10.000000', 'consum', 0.0219, 'lps'),
	(569367, 130, '2014-03-01 01:25:11.000000', 'consum', 0.0210, 'lps'),
	(569368, 130, '2014-03-01 01:25:12.000000', 'consum', 0.0224, 'lps'),
	(569369, 130, '2014-03-01 01:25:13.000000', 'consum', 0.0221, 'lps'),
	(569370, 130, '2014-03-01 01:25:14.000000', 'consum', 0.0225, 'lps'),
	(569371, 130, '2014-03-01 01:25:15.000000', 'consum', 0.0212, 'lps'),
	(569372, 130, '2014-03-01 01:25:16.000000', 'consum', 0.0215, 'lps'),
	(569373, 130, '2014-03-01 01:25:17.000000', 'consum', 0.0211, 'lps'),
	(569374, 130, '2014-03-01 01:25:18.000000', 'consum', 0.0218, 'lps'),
	(569375, 130, '2014-03-01 01:25:19.000000', 'consum', 0.0212, 'lps'),
	(569376, 130, '2014-03-01 01:25:20.000000', 'consum', 0.0215, 'lps'),
	(569377, 130, '2014-03-01 01:25:21.000000', 'consum', 0.0210, 'lps'),
	(569378, 130, '2014-03-01 01:25:22.000000', 'consum', 0.0216, 'lps'),
	(569379, 130, '2014-03-01 01:25:23.000000', 'consum', 0.0222, 'lps'),
	(569380, 130, '2014-03-01 01:25:24.000000', 'consum', 0.0212, 'lps'),
	(569381, 130, '2014-03-01 01:25:25.000000', 'consum', 0.0223, 'lps'),
	(569382, 130, '2014-03-01 01:25:26.000000', 'consum', 0.0214, 'lps'),
	(569383, 130, '2014-03-01 01:25:27.000000', 'consum', 0.0210, 'lps'),
	(569384, 130, '2014-03-01 01:25:28.000000', 'consum', 0.0219, 'lps'),
	(569385, 130, '2014-03-01 01:25:29.000000', 'consum', 0.0216, 'lps'),
	(569386, 130, '2014-03-01 01:25:30.000000', 'consum', 0.0213, 'lps'),
	(569387, 130, '2014-03-01 01:25:31.000000', 'consum', 0.0210, 'lps'),
	(569388, 130, '2014-03-01 01:25:32.000000', 'consum', 0.0218, 'lps'),
	(569389, 130, '2014-03-01 01:25:33.000000', 'consum', 0.0213, 'lps'),
	(569390, 130, '2014-03-01 01:25:34.000000', 'consum', 0.0219, 'lps'),
	(569391, 130, '2014-03-01 01:25:35.000000', 'consum', 0.0211, 'lps'),
	(569392, 130, '2014-03-01 01:25:36.000000', 'consum', 0.0226, 'lps'),
	(569393, 130, '2014-03-01 01:25:37.000000', 'consum', 0.0212, 'lps'),
	(569394, 130, '2014-03-01 01:25:38.000000', 'consum', 0.0210, 'lps'),
	(569395, 130, '2014-03-01 01:25:39.000000', 'consum', 0.0222, 'lps'),
	(569396, 130, '2014-03-01 01:25:40.000000', 'consum', 0.0213, 'lps'),
	(569397, 130, '2014-03-01 01:25:41.000000', 'consum', 0.0210, 'lps'),
	(569398, 130, '2014-03-01 01:25:42.000000', 'consum', 0.0220, 'lps'),
	(569399, 130, '2014-03-01 01:25:43.000000', 'consum', 0.0221, 'lps'),
	(569400, 130, '2014-03-01 01:25:44.000000', 'consum', 0.0217, 'lps'),
	(569401, 130, '2014-03-01 01:25:45.000000', 'consum', 0.0212, 'lps'),
	(569402, 130, '2014-03-01 01:25:46.000000', 'consum', 0.0220, 'lps'),
	(569403, 130, '2014-03-01 01:25:47.000000', 'consum', 0.0217, 'lps'),
	(569404, 130, '2014-03-01 01:25:48.000000', 'consum', 0.0216, 'lps'),
	(569405, 130, '2014-03-01 01:25:49.000000', 'consum', 0.0219, 'lps'),
	(569406, 130, '2014-03-01 01:25:50.000000', 'consum', 0.0218, 'lps'),
	(569407, 130, '2014-03-01 01:25:51.000000', 'consum', 0.0223, 'lps'),
	(569408, 130, '2014-03-01 01:25:52.000000', 'consum', 0.0213, 'lps'),
	(569409, 130, '2014-03-01 01:25:53.000000', 'consum', 0.0224, 'lps'),
	(569410, 130, '2014-03-01 01:25:54.000000', 'consum', 0.0216, 'lps'),
	(569411, 130, '2014-03-01 01:25:55.000000', 'consum', 0.0216, 'lps'),
	(569412, 130, '2014-03-01 01:25:56.000000', 'consum', 0.0225, 'lps'),
	(569413, 130, '2014-03-01 01:25:57.000000', 'consum', 0.0227, 'lps'),
	(569414, 130, '2014-03-01 01:25:58.000000', 'consum', 0.0214, 'lps'),
	(569415, 130, '2014-03-01 01:25:59.000000', 'consum', 0.0215, 'lps'),
	(569416, 130, '2014-03-01 01:26:00.000000', 'consum', 0.0225, 'lps'),
	(569417, 130, '2014-03-01 01:26:01.000000', 'consum', 0.0214, 'lps'),
	(569418, 130, '2014-03-01 01:26:02.000000', 'consum', 0.0223, 'lps'),
	(569419, 130, '2014-03-01 01:26:03.000000', 'consum', 0.0227, 'lps'),
	(569420, 130, '2014-03-01 01:26:04.000000', 'consum', 0.0217, 'lps'),
	(569421, 130, '2014-03-01 01:26:05.000000', 'consum', 0.0214, 'lps'),
	(569422, 130, '2014-03-01 01:26:06.000000', 'consum', 0.0227, 'lps'),
	(569423, 130, '2014-03-01 01:26:07.000000', 'consum', 0.0210, 'lps'),
	(569424, 130, '2014-03-01 01:26:08.000000', 'consum', 0.0216, 'lps'),
	(569425, 130, '2014-03-01 01:26:09.000000', 'consum', 0.0219, 'lps'),
	(569426, 130, '2014-03-01 01:26:10.000000', 'consum', 0.0221, 'lps'),
	(569427, 130, '2014-03-01 01:26:11.000000', 'consum', 0.0217, 'lps'),
	(569428, 130, '2014-03-01 01:26:12.000000', 'consum', 0.0213, 'lps'),
	(569429, 130, '2014-03-01 01:26:13.000000', 'consum', 0.0223, 'lps'),
	(569430, 130, '2014-03-01 01:26:14.000000', 'consum', 0.0211, 'lps'),
	(569431, 130, '2014-03-01 01:26:15.000000', 'consum', 0.0213, 'lps'),
	(569432, 130, '2014-03-01 01:26:16.000000', 'consum', 0.0223, 'lps'),
	(569433, 130, '2014-03-01 01:26:17.000000', 'consum', 0.0210, 'lps'),
	(569434, 130, '2014-03-01 01:26:18.000000', 'consum', 0.0228, 'lps'),
	(569435, 130, '2014-03-01 01:26:19.000000', 'consum', 0.0223, 'lps'),
	(569436, 130, '2014-03-01 01:26:20.000000', 'consum', 0.0221, 'lps'),
	(569437, 130, '2014-03-01 01:26:21.000000', 'consum', 0.0226, 'lps'),
	(569438, 130, '2014-03-01 01:26:22.000000', 'consum', 0.0220, 'lps'),
	(569439, 130, '2014-03-01 01:26:23.000000', 'consum', 0.0211, 'lps'),
	(569440, 130, '2014-03-01 01:26:24.000000', 'consum', 0.0227, 'lps'),
	(569441, 130, '2014-03-01 01:26:25.000000', 'consum', 0.0215, 'lps'),
	(569442, 130, '2014-03-01 01:26:26.000000', 'consum', 0.0222, 'lps'),
	(569443, 130, '2014-03-01 01:26:27.000000', 'consum', 0.0219, 'lps'),
	(569444, 130, '2014-03-01 01:26:28.000000', 'consum', 0.0218, 'lps'),
	(569445, 130, '2014-03-01 01:26:29.000000', 'consum', 0.0224, 'lps'),
	(569446, 130, '2014-03-01 01:26:30.000000', 'consum', 0.0218, 'lps'),
	(569447, 130, '2014-03-01 01:26:31.000000', 'consum', 0.0227, 'lps'),
	(569448, 130, '2014-03-01 01:26:32.000000', 'consum', 0.0216, 'lps'),
	(569449, 130, '2014-03-01 01:26:33.000000', 'consum', 0.0226, 'lps'),
	(569450, 130, '2014-03-01 01:26:34.000000', 'consum', 0.0218, 'lps'),
	(569451, 130, '2014-03-01 01:26:35.000000', 'consum', 0.0220, 'lps'),
	(569452, 130, '2014-03-01 01:26:36.000000', 'consum', 0.0217, 'lps'),
	(569453, 131, '2014-03-01 00:00:00.000000', 'consum', 0.0215, 'lps'),
	(569454, 131, '2014-03-01 00:00:01.000000', 'consum', 0.0223, 'lps'),
	(569455, 131, '2014-03-01 00:00:02.000000', 'consum', 0.0225, 'lps'),
	(569456, 131, '2014-03-01 00:00:03.000000', 'consum', 0.0226, 'lps'),
	(569457, 131, '2014-03-01 00:00:04.000000', 'consum', 0.0212, 'lps'),
	(569458, 131, '2014-03-01 00:00:05.000000', 'consum', 0.0227, 'lps'),
	(569459, 131, '2014-03-01 00:00:06.000000', 'consum', 0.0217, 'lps'),
	(569460, 131, '2014-03-01 00:00:07.000000', 'consum', 0.0214, 'lps'),
	(569461, 131, '2014-03-01 00:00:08.000000', 'consum', 0.0210, 'lps'),
	(569462, 131, '2014-03-01 00:00:09.000000', 'consum', 0.0215, 'lps'),
	(569463, 131, '2014-03-01 00:00:10.000000', 'consum', 0.0219, 'lps'),
	(569464, 131, '2014-03-01 00:00:11.000000', 'consum', 0.0221, 'lps'),
	(569465, 131, '2014-03-01 00:00:12.000000', 'consum', 0.0220, 'lps'),
	(569466, 131, '2014-03-01 00:00:13.000000', 'consum', 0.0211, 'lps'),
	(569467, 131, '2014-03-01 00:00:14.000000', 'consum', 0.0220, 'lps'),
	(569468, 131, '2014-03-01 00:00:15.000000', 'consum', 0.0222, 'lps'),
	(569469, 131, '2014-03-01 00:00:16.000000', 'consum', 0.0223, 'lps'),
	(569470, 131, '2014-03-01 00:00:17.000000', 'consum', 0.0223, 'lps'),
	(569471, 131, '2014-03-01 00:00:18.000000', 'consum', 0.0215, 'lps'),
	(569472, 131, '2014-03-01 00:00:19.000000', 'consum', 0.0217, 'lps'),
	(569473, 131, '2014-03-01 00:00:20.000000', 'consum', 0.0211, 'lps'),
	(569474, 131, '2014-03-01 00:00:21.000000', 'consum', 0.0213, 'lps'),
	(569475, 131, '2014-03-01 00:00:22.000000', 'consum', 0.0224, 'lps'),
	(569476, 131, '2014-03-01 00:00:23.000000', 'consum', 0.0218, 'lps'),
	(569477, 131, '2014-03-01 00:00:24.000000', 'consum', 0.0225, 'lps'),
	(569478, 131, '2014-03-01 00:00:25.000000', 'consum', 0.0226, 'lps'),
	(569479, 131, '2014-03-01 00:00:26.000000', 'consum', 0.0210, 'lps'),
	(569480, 131, '2014-03-01 00:00:27.000000', 'consum', 0.0215, 'lps'),
	(569481, 131, '2014-03-01 00:00:28.000000', 'consum', 0.0218, 'lps'),
	(569482, 131, '2014-03-01 00:00:29.000000', 'consum', 0.0216, 'lps'),
	(569483, 131, '2014-03-01 00:00:30.000000', 'consum', 0.0217, 'lps'),
	(569484, 131, '2014-03-01 00:00:31.000000', 'consum', 0.0226, 'lps'),
	(569485, 131, '2014-03-01 00:00:32.000000', 'consum', 0.0219, 'lps'),
	(569486, 131, '2014-03-01 00:00:33.000000', 'consum', 0.0224, 'lps'),
	(569487, 131, '2014-03-01 00:00:34.000000', 'consum', 0.0218, 'lps'),
	(569488, 131, '2014-03-01 00:00:35.000000', 'consum', 0.0226, 'lps'),
	(569489, 131, '2014-03-01 00:00:36.000000', 'consum', 0.0211, 'lps'),
	(569490, 131, '2014-03-01 00:00:37.000000', 'consum', 0.0222, 'lps'),
	(569491, 131, '2014-03-01 00:00:38.000000', 'consum', 0.0214, 'lps'),
	(569492, 131, '2014-03-01 00:00:39.000000', 'consum', 0.0213, 'lps'),
	(569493, 131, '2014-03-01 00:00:40.000000', 'consum', 0.0212, 'lps'),
	(569494, 131, '2014-03-01 00:00:41.000000', 'consum', 0.0212, 'lps'),
	(569495, 131, '2014-03-01 00:00:42.000000', 'consum', 0.0213, 'lps'),
	(569496, 131, '2014-03-01 00:00:43.000000', 'consum', 0.0220, 'lps'),
	(569497, 131, '2014-03-01 00:00:44.000000', 'consum', 0.0214, 'lps'),
	(569498, 131, '2014-03-01 00:00:45.000000', 'consum', 0.0219, 'lps'),
	(569499, 131, '2014-03-01 00:00:46.000000', 'consum', 0.0227, 'lps'),
	(569500, 131, '2014-03-01 00:00:47.000000', 'consum', 0.0213, 'lps'),
	(569501, 131, '2014-03-01 00:00:48.000000', 'consum', 0.0227, 'lps'),
	(569502, 131, '2014-03-01 00:00:49.000000', 'consum', 0.0218, 'lps'),
	(569503, 131, '2014-03-01 00:00:50.000000', 'consum', 0.0214, 'lps'),
	(569504, 131, '2014-03-01 00:00:51.000000', 'consum', 0.0226, 'lps'),
	(569505, 131, '2014-03-01 00:00:52.000000', 'consum', 0.0223, 'lps'),
	(569506, 131, '2014-03-01 00:00:53.000000', 'consum', 0.0212, 'lps'),
	(569507, 131, '2014-03-01 00:00:54.000000', 'consum', 0.0218, 'lps'),
	(569508, 131, '2014-03-01 00:00:55.000000', 'consum', 0.0224, 'lps'),
	(569509, 131, '2014-03-01 00:00:56.000000', 'consum', 0.0222, 'lps'),
	(569510, 131, '2014-03-01 00:00:57.000000', 'consum', 0.0210, 'lps'),
	(569511, 131, '2014-03-01 00:00:58.000000', 'consum', 0.0211, 'lps'),
	(569512, 131, '2014-03-01 00:00:59.000000', 'consum', 0.0216, 'lps'),
	(569513, 131, '2014-03-01 00:01:00.000000', 'consum', 0.0220, 'lps'),
	(569514, 131, '2014-03-01 00:01:01.000000', 'consum', 0.0225, 'lps'),
	(569515, 131, '2014-03-01 00:01:02.000000', 'consum', 0.0220, 'lps'),
	(569516, 131, '2014-03-01 00:01:03.000000', 'consum', 0.0215, 'lps'),
	(569517, 131, '2014-03-01 00:01:04.000000', 'consum', 0.0224, 'lps'),
	(569518, 131, '2014-03-01 00:01:05.000000', 'consum', 0.0210, 'lps'),
	(569519, 131, '2014-03-01 00:01:06.000000', 'consum', 0.0222, 'lps'),
	(569520, 131, '2014-03-01 00:01:07.000000', 'consum', 0.0217, 'lps'),
	(569521, 131, '2014-03-01 00:01:08.000000', 'consum', 0.0212, 'lps'),
	(569522, 131, '2014-03-01 00:01:09.000000', 'consum', 0.0214, 'lps'),
	(569523, 131, '2014-03-01 00:01:10.000000', 'consum', 0.0210, 'lps'),
	(569524, 131, '2014-03-01 00:01:11.000000', 'consum', 0.0215, 'lps'),
	(569525, 131, '2014-03-01 00:01:12.000000', 'consum', 0.0216, 'lps'),
	(569526, 131, '2014-03-01 00:01:13.000000', 'consum', 0.0210, 'lps'),
	(569527, 131, '2014-03-01 00:01:14.000000', 'consum', 0.0226, 'lps'),
	(569528, 131, '2014-03-01 00:01:15.000000', 'consum', 0.0218, 'lps'),
	(569529, 131, '2014-03-01 00:01:16.000000', 'consum', 0.0220, 'lps'),
	(569530, 131, '2014-03-01 00:01:17.000000', 'consum', 0.0220, 'lps'),
	(569531, 131, '2014-03-01 00:01:18.000000', 'consum', 0.0213, 'lps'),
	(569532, 131, '2014-03-01 00:01:19.000000', 'consum', 0.0212, 'lps'),
	(569533, 131, '2014-03-01 00:01:20.000000', 'consum', 0.0211, 'lps'),
	(569534, 131, '2014-03-01 00:01:21.000000', 'consum', 0.0211, 'lps'),
	(569535, 131, '2014-03-01 00:01:22.000000', 'consum', 0.0212, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(569536, 131, '2014-03-01 00:01:23.000000', 'consum', 0.0216, 'lps'),
	(569537, 131, '2014-03-01 00:01:24.000000', 'consum', 0.0219, 'lps'),
	(569538, 131, '2014-03-01 00:01:25.000000', 'consum', 0.0220, 'lps'),
	(569539, 131, '2014-03-01 00:01:26.000000', 'consum', 0.0216, 'lps'),
	(569540, 131, '2014-03-01 00:01:27.000000', 'consum', 0.0227, 'lps'),
	(569541, 131, '2014-03-01 00:01:28.000000', 'consum', 0.0223, 'lps'),
	(569542, 131, '2014-03-01 00:01:29.000000', 'consum', 0.0226, 'lps'),
	(569543, 131, '2014-03-01 00:01:30.000000', 'consum', 0.0215, 'lps'),
	(569544, 131, '2014-03-01 00:01:31.000000', 'consum', 0.0222, 'lps'),
	(569545, 131, '2014-03-01 00:01:32.000000', 'consum', 0.0219, 'lps'),
	(569546, 131, '2014-03-01 00:01:33.000000', 'consum', 0.0221, 'lps'),
	(569547, 131, '2014-03-01 00:01:34.000000', 'consum', 0.0222, 'lps'),
	(569548, 131, '2014-03-01 00:01:35.000000', 'consum', 0.0218, 'lps'),
	(569549, 131, '2014-03-01 00:01:36.000000', 'consum', 0.0214, 'lps'),
	(569550, 131, '2014-03-01 00:01:37.000000', 'consum', 0.0226, 'lps'),
	(569551, 131, '2014-03-01 00:01:38.000000', 'consum', 0.0223, 'lps'),
	(569552, 131, '2014-03-01 00:01:39.000000', 'consum', 0.0210, 'lps'),
	(569553, 131, '2014-03-01 00:01:40.000000', 'consum', 0.0227, 'lps'),
	(569554, 131, '2014-03-01 00:01:41.000000', 'consum', 0.0222, 'lps'),
	(569555, 131, '2014-03-01 00:01:42.000000', 'consum', 0.0221, 'lps'),
	(569556, 131, '2014-03-01 00:01:43.000000', 'consum', 0.0227, 'lps'),
	(569557, 131, '2014-03-01 00:01:44.000000', 'consum', 0.0226, 'lps'),
	(569558, 131, '2014-03-01 00:01:45.000000', 'consum', 0.0224, 'lps'),
	(569559, 131, '2014-03-01 00:01:46.000000', 'consum', 0.0215, 'lps'),
	(569560, 131, '2014-03-01 00:01:47.000000', 'consum', 0.0210, 'lps'),
	(569561, 131, '2014-03-01 00:01:48.000000', 'consum', 0.0216, 'lps'),
	(569562, 131, '2014-03-01 00:01:49.000000', 'consum', 0.0219, 'lps'),
	(569563, 131, '2014-03-01 00:01:50.000000', 'consum', 0.0221, 'lps'),
	(569564, 131, '2014-03-01 00:01:51.000000', 'consum', 0.0222, 'lps'),
	(569565, 131, '2014-03-01 00:01:52.000000', 'consum', 0.0220, 'lps'),
	(569566, 131, '2014-03-01 00:01:53.000000', 'consum', 0.0223, 'lps'),
	(569567, 131, '2014-03-01 00:01:54.000000', 'consum', 0.0210, 'lps'),
	(569568, 131, '2014-03-01 00:01:55.000000', 'consum', 0.0224, 'lps'),
	(569569, 131, '2014-03-01 00:01:56.000000', 'consum', 0.0210, 'lps'),
	(569570, 131, '2014-03-01 00:01:57.000000', 'consum', 0.0221, 'lps'),
	(569571, 131, '2014-03-01 00:01:58.000000', 'consum', 0.0212, 'lps'),
	(569572, 131, '2014-03-01 00:01:59.000000', 'consum', 0.0225, 'lps'),
	(569573, 131, '2014-03-01 00:02:00.000000', 'consum', 0.0225, 'lps'),
	(569574, 131, '2014-03-01 00:02:01.000000', 'consum', 0.0221, 'lps'),
	(569575, 131, '2014-03-01 00:02:02.000000', 'consum', 0.0221, 'lps'),
	(569576, 131, '2014-03-01 00:02:03.000000', 'consum', 0.0215, 'lps'),
	(569577, 131, '2014-03-01 00:02:04.000000', 'consum', 0.0219, 'lps'),
	(569578, 131, '2014-03-01 00:02:05.000000', 'consum', 0.0222, 'lps'),
	(569579, 131, '2014-03-01 00:02:06.000000', 'consum', 0.0210, 'lps'),
	(569580, 131, '2014-03-01 00:02:07.000000', 'consum', 0.0226, 'lps'),
	(569581, 131, '2014-03-01 00:02:08.000000', 'consum', 0.0218, 'lps'),
	(569582, 131, '2014-03-01 00:02:09.000000', 'consum', 0.0222, 'lps'),
	(569583, 131, '2014-03-01 00:02:10.000000', 'consum', 0.0210, 'lps'),
	(569584, 131, '2014-03-01 00:02:11.000000', 'consum', 0.0210, 'lps'),
	(569585, 131, '2014-03-01 00:02:12.000000', 'consum', 0.0227, 'lps'),
	(569586, 131, '2014-03-01 00:02:13.000000', 'consum', 0.0226, 'lps'),
	(569587, 131, '2014-03-01 00:02:14.000000', 'consum', 0.0222, 'lps'),
	(569588, 131, '2014-03-01 00:02:15.000000', 'consum', 0.0220, 'lps'),
	(569589, 131, '2014-03-01 00:02:16.000000', 'consum', 0.0226, 'lps'),
	(569590, 131, '2014-03-01 00:02:17.000000', 'consum', 0.0225, 'lps'),
	(569591, 131, '2014-03-01 00:02:18.000000', 'consum', 0.0217, 'lps'),
	(569592, 131, '2014-03-01 00:02:19.000000', 'consum', 0.0222, 'lps'),
	(569593, 131, '2014-03-01 00:02:20.000000', 'consum', 0.0211, 'lps'),
	(569594, 131, '2014-03-01 00:02:21.000000', 'consum', 0.0218, 'lps'),
	(569595, 131, '2014-03-01 00:02:22.000000', 'consum', 0.0210, 'lps'),
	(569596, 131, '2014-03-01 00:02:23.000000', 'consum', 0.0224, 'lps'),
	(569597, 131, '2014-03-01 00:02:24.000000', 'consum', 0.0224, 'lps'),
	(569598, 131, '2014-03-01 00:02:25.000000', 'consum', 0.0220, 'lps'),
	(569599, 131, '2014-03-01 00:02:26.000000', 'consum', 0.0220, 'lps'),
	(569600, 131, '2014-03-01 00:02:27.000000', 'consum', 0.0212, 'lps'),
	(569601, 131, '2014-03-01 00:02:28.000000', 'consum', 0.0226, 'lps'),
	(569602, 131, '2014-03-01 00:02:29.000000', 'consum', 0.0211, 'lps'),
	(569603, 131, '2014-03-01 00:02:30.000000', 'consum', 0.0225, 'lps'),
	(569604, 131, '2014-03-01 00:02:31.000000', 'consum', 0.0226, 'lps'),
	(569605, 131, '2014-03-01 00:02:32.000000', 'consum', 0.0210, 'lps'),
	(569606, 131, '2014-03-01 00:02:33.000000', 'consum', 0.0216, 'lps'),
	(569607, 131, '2014-03-01 00:02:34.000000', 'consum', 0.0223, 'lps'),
	(569608, 131, '2014-03-01 00:02:35.000000', 'consum', 0.0220, 'lps'),
	(569609, 131, '2014-03-01 00:02:36.000000', 'consum', 0.0221, 'lps'),
	(569610, 131, '2014-03-01 00:02:37.000000', 'consum', 0.0219, 'lps'),
	(569611, 131, '2014-03-01 00:02:38.000000', 'consum', 0.0222, 'lps'),
	(569612, 131, '2014-03-01 00:02:39.000000', 'consum', 0.0227, 'lps'),
	(569613, 131, '2014-03-01 00:02:40.000000', 'consum', 0.0223, 'lps'),
	(569614, 131, '2014-03-01 00:02:41.000000', 'consum', 0.0223, 'lps'),
	(569615, 131, '2014-03-01 00:02:42.000000', 'consum', 0.0221, 'lps'),
	(569616, 131, '2014-03-01 00:02:43.000000', 'consum', 0.0226, 'lps'),
	(569617, 131, '2014-03-01 00:02:44.000000', 'consum', 0.0221, 'lps'),
	(569618, 131, '2014-03-01 00:02:45.000000', 'consum', 0.0216, 'lps'),
	(569619, 131, '2014-03-01 00:02:46.000000', 'consum', 0.0226, 'lps'),
	(569620, 131, '2014-03-01 00:02:47.000000', 'consum', 0.0219, 'lps'),
	(569621, 131, '2014-03-01 00:02:48.000000', 'consum', 0.0224, 'lps'),
	(569622, 131, '2014-03-01 00:02:49.000000', 'consum', 0.0220, 'lps'),
	(569623, 131, '2014-03-01 00:02:50.000000', 'consum', 0.0216, 'lps'),
	(569624, 131, '2014-03-01 00:02:51.000000', 'consum', 0.0212, 'lps'),
	(569625, 131, '2014-03-01 00:02:52.000000', 'consum', 0.0219, 'lps'),
	(569626, 131, '2014-03-01 00:02:53.000000', 'consum', 0.0213, 'lps'),
	(569627, 131, '2014-03-01 00:02:54.000000', 'consum', 0.0216, 'lps'),
	(569628, 131, '2014-03-01 00:02:55.000000', 'consum', 0.0216, 'lps'),
	(569629, 131, '2014-03-01 00:02:56.000000', 'consum', 0.0220, 'lps'),
	(569630, 131, '2014-03-01 00:02:57.000000', 'consum', 0.0227, 'lps'),
	(569631, 131, '2014-03-01 00:02:58.000000', 'consum', 0.0227, 'lps'),
	(569632, 131, '2014-03-01 00:02:59.000000', 'consum', 0.0211, 'lps'),
	(569633, 131, '2014-03-01 00:03:00.000000', 'consum', 0.0218, 'lps'),
	(569634, 131, '2014-03-01 00:03:01.000000', 'consum', 0.0227, 'lps'),
	(569635, 131, '2014-03-01 00:03:02.000000', 'consum', 0.0220, 'lps'),
	(569636, 131, '2014-03-01 00:03:03.000000', 'consum', 0.0225, 'lps'),
	(569637, 131, '2014-03-01 00:03:04.000000', 'consum', 0.0220, 'lps'),
	(569638, 131, '2014-03-01 00:03:05.000000', 'consum', 0.0214, 'lps'),
	(569639, 131, '2014-03-01 00:03:06.000000', 'consum', 0.0222, 'lps'),
	(569640, 131, '2014-03-01 00:03:07.000000', 'consum', 0.0220, 'lps'),
	(569641, 131, '2014-03-01 00:03:08.000000', 'consum', 0.0225, 'lps'),
	(569642, 131, '2014-03-01 00:03:09.000000', 'consum', 0.0218, 'lps'),
	(569643, 131, '2014-03-01 00:03:10.000000', 'consum', 0.0224, 'lps'),
	(569644, 131, '2014-03-01 00:03:11.000000', 'consum', 0.0222, 'lps'),
	(569645, 131, '2014-03-01 00:03:12.000000', 'consum', 0.0210, 'lps'),
	(569646, 131, '2014-03-01 00:03:13.000000', 'consum', 0.0227, 'lps'),
	(569647, 131, '2014-03-01 00:03:14.000000', 'consum', 0.0223, 'lps'),
	(569648, 131, '2014-03-01 00:03:15.000000', 'consum', 0.0227, 'lps'),
	(569649, 131, '2014-03-01 00:03:16.000000', 'consum', 0.0219, 'lps'),
	(569650, 131, '2014-03-01 00:03:17.000000', 'consum', 0.0222, 'lps'),
	(569651, 131, '2014-03-01 00:03:18.000000', 'consum', 0.0224, 'lps'),
	(569652, 131, '2014-03-01 00:03:19.000000', 'consum', 0.0211, 'lps'),
	(569653, 131, '2014-03-01 00:03:20.000000', 'consum', 0.0210, 'lps'),
	(569654, 131, '2014-03-01 00:03:21.000000', 'consum', 0.0223, 'lps'),
	(569655, 131, '2014-03-01 00:03:22.000000', 'consum', 0.0221, 'lps'),
	(569656, 131, '2014-03-01 00:03:23.000000', 'consum', 0.0210, 'lps'),
	(569657, 131, '2014-03-01 00:03:24.000000', 'consum', 0.0214, 'lps'),
	(569658, 131, '2014-03-01 00:03:25.000000', 'consum', 0.0211, 'lps'),
	(569659, 131, '2014-03-01 00:03:26.000000', 'consum', 0.0221, 'lps'),
	(569660, 131, '2014-03-01 00:03:27.000000', 'consum', 0.0226, 'lps'),
	(569661, 131, '2014-03-01 00:03:28.000000', 'consum', 0.0220, 'lps'),
	(569662, 131, '2014-03-01 00:03:29.000000', 'consum', 0.0215, 'lps'),
	(569663, 131, '2014-03-01 00:03:30.000000', 'consum', 0.0225, 'lps'),
	(569664, 131, '2014-03-01 00:03:31.000000', 'consum', 0.0215, 'lps'),
	(569665, 131, '2014-03-01 00:03:32.000000', 'consum', 0.0227, 'lps'),
	(569666, 131, '2014-03-01 00:03:33.000000', 'consum', 0.0226, 'lps'),
	(569667, 131, '2014-03-01 00:03:34.000000', 'consum', 0.0222, 'lps'),
	(569668, 131, '2014-03-01 00:03:35.000000', 'consum', 0.0223, 'lps'),
	(569669, 131, '2014-03-01 00:03:36.000000', 'consum', 0.0219, 'lps'),
	(569670, 131, '2014-03-01 00:03:37.000000', 'consum', 0.0219, 'lps'),
	(569671, 131, '2014-03-01 00:03:38.000000', 'consum', 0.0226, 'lps'),
	(569672, 131, '2014-03-01 00:03:39.000000', 'consum', 0.0212, 'lps'),
	(569673, 131, '2014-03-01 00:03:40.000000', 'consum', 0.0226, 'lps'),
	(569674, 131, '2014-03-01 00:03:41.000000', 'consum', 0.0213, 'lps'),
	(569675, 131, '2014-03-01 00:03:42.000000', 'consum', 0.0213, 'lps'),
	(569676, 131, '2014-03-01 00:03:43.000000', 'consum', 0.0215, 'lps'),
	(569677, 131, '2014-03-01 00:03:44.000000', 'consum', 0.0210, 'lps'),
	(569678, 131, '2014-03-01 00:03:45.000000', 'consum', 0.0214, 'lps'),
	(569679, 131, '2014-03-01 00:03:46.000000', 'consum', 0.0213, 'lps'),
	(569680, 131, '2014-03-01 00:03:47.000000', 'consum', 0.0211, 'lps'),
	(569681, 131, '2014-03-01 00:03:48.000000', 'consum', 0.0225, 'lps'),
	(569682, 131, '2014-03-01 00:03:49.000000', 'consum', 0.0212, 'lps'),
	(569683, 131, '2014-03-01 00:03:50.000000', 'consum', 0.0211, 'lps'),
	(569684, 131, '2014-03-01 00:03:51.000000', 'consum', 0.0211, 'lps'),
	(569685, 131, '2014-03-01 00:03:52.000000', 'consum', 0.0213, 'lps'),
	(569686, 131, '2014-03-01 00:03:53.000000', 'consum', 0.0220, 'lps'),
	(569687, 131, '2014-03-01 00:03:54.000000', 'consum', 0.0216, 'lps'),
	(569688, 131, '2014-03-01 00:03:55.000000', 'consum', 0.0211, 'lps'),
	(569689, 131, '2014-03-01 00:03:56.000000', 'consum', 0.0213, 'lps'),
	(569690, 131, '2014-03-01 00:03:57.000000', 'consum', 0.0226, 'lps'),
	(569691, 131, '2014-03-01 00:03:58.000000', 'consum', 0.0226, 'lps'),
	(569692, 131, '2014-03-01 00:03:59.000000', 'consum', 0.0223, 'lps'),
	(569693, 131, '2014-03-01 00:04:00.000000', 'consum', 0.0210, 'lps'),
	(569694, 131, '2014-03-01 00:04:01.000000', 'consum', 0.0226, 'lps'),
	(569695, 131, '2014-03-01 00:04:02.000000', 'consum', 0.0220, 'lps'),
	(569696, 131, '2014-03-01 00:04:03.000000', 'consum', 0.0211, 'lps'),
	(569697, 131, '2014-03-01 00:04:04.000000', 'consum', 0.0221, 'lps'),
	(569698, 131, '2014-03-01 00:04:05.000000', 'consum', 0.0227, 'lps'),
	(569699, 131, '2014-03-01 00:04:06.000000', 'consum', 0.0225, 'lps'),
	(569700, 131, '2014-03-01 00:04:07.000000', 'consum', 0.0217, 'lps'),
	(569701, 131, '2014-03-01 00:04:08.000000', 'consum', 0.0219, 'lps'),
	(569702, 131, '2014-03-01 00:04:09.000000', 'consum', 0.0216, 'lps'),
	(569703, 131, '2014-03-01 00:04:10.000000', 'consum', 0.0214, 'lps'),
	(569704, 131, '2014-03-01 00:04:11.000000', 'consum', 0.0212, 'lps'),
	(569705, 131, '2014-03-01 00:04:12.000000', 'consum', 0.0226, 'lps'),
	(569706, 131, '2014-03-01 00:04:13.000000', 'consum', 0.0211, 'lps'),
	(569707, 131, '2014-03-01 00:04:14.000000', 'consum', 0.0225, 'lps'),
	(569708, 131, '2014-03-01 00:04:15.000000', 'consum', 0.0227, 'lps'),
	(569709, 131, '2014-03-01 00:04:16.000000', 'consum', 0.0214, 'lps'),
	(569710, 131, '2014-03-01 00:04:17.000000', 'consum', 0.0216, 'lps'),
	(569711, 131, '2014-03-01 00:04:18.000000', 'consum', 0.0211, 'lps'),
	(569712, 131, '2014-03-01 00:04:19.000000', 'consum', 0.0216, 'lps'),
	(569713, 131, '2014-03-01 00:04:20.000000', 'consum', 0.0219, 'lps'),
	(569714, 131, '2014-03-01 00:04:21.000000', 'consum', 0.0219, 'lps'),
	(569715, 131, '2014-03-01 00:04:22.000000', 'consum', 0.0210, 'lps'),
	(569716, 131, '2014-03-01 00:04:23.000000', 'consum', 0.0221, 'lps'),
	(569717, 131, '2014-03-01 00:04:24.000000', 'consum', 0.0211, 'lps'),
	(569718, 131, '2014-03-01 00:04:25.000000', 'consum', 0.0219, 'lps'),
	(569719, 131, '2014-03-01 00:04:26.000000', 'consum', 0.0217, 'lps'),
	(569720, 131, '2014-03-01 00:04:27.000000', 'consum', 0.0217, 'lps'),
	(569721, 131, '2014-03-01 00:04:28.000000', 'consum', 0.0227, 'lps'),
	(569722, 131, '2014-03-01 00:04:29.000000', 'consum', 0.0220, 'lps'),
	(569723, 131, '2014-03-01 00:04:30.000000', 'consum', 0.0225, 'lps'),
	(569724, 131, '2014-03-01 00:04:31.000000', 'consum', 0.0223, 'lps'),
	(569725, 131, '2014-03-01 00:04:32.000000', 'consum', 0.0227, 'lps'),
	(569726, 131, '2014-03-01 00:04:33.000000', 'consum', 0.0223, 'lps'),
	(569727, 131, '2014-03-01 00:04:34.000000', 'consum', 0.0225, 'lps'),
	(569728, 131, '2014-03-01 00:04:35.000000', 'consum', 0.0227, 'lps'),
	(569729, 131, '2014-03-01 00:04:36.000000', 'consum', 0.0214, 'lps'),
	(569730, 131, '2014-03-01 00:04:37.000000', 'consum', 0.0215, 'lps'),
	(569731, 131, '2014-03-01 00:04:38.000000', 'consum', 0.0226, 'lps'),
	(569732, 131, '2014-03-01 00:04:39.000000', 'consum', 0.0219, 'lps'),
	(569733, 131, '2014-03-01 00:04:40.000000', 'consum', 0.0210, 'lps'),
	(569734, 131, '2014-03-01 00:04:41.000000', 'consum', 0.0217, 'lps'),
	(569735, 131, '2014-03-01 00:04:42.000000', 'consum', 0.0211, 'lps'),
	(569736, 131, '2014-03-01 00:04:43.000000', 'consum', 0.0214, 'lps'),
	(569737, 131, '2014-03-01 00:04:44.000000', 'consum', 0.0225, 'lps'),
	(569738, 131, '2014-03-01 00:04:45.000000', 'consum', 0.0222, 'lps'),
	(569739, 131, '2014-03-01 00:04:46.000000', 'consum', 0.0225, 'lps'),
	(569740, 131, '2014-03-01 00:04:47.000000', 'consum', 0.0214, 'lps'),
	(569741, 131, '2014-03-01 00:04:48.000000', 'consum', 0.0223, 'lps'),
	(569742, 131, '2014-03-01 00:04:49.000000', 'consum', 0.0225, 'lps'),
	(569743, 131, '2014-03-01 00:04:50.000000', 'consum', 0.0211, 'lps'),
	(569744, 131, '2014-03-01 00:04:51.000000', 'consum', 0.0223, 'lps'),
	(569745, 131, '2014-03-01 00:04:52.000000', 'consum', 0.0218, 'lps'),
	(569746, 131, '2014-03-01 00:04:53.000000', 'consum', 0.0211, 'lps'),
	(569747, 131, '2014-03-01 00:04:54.000000', 'consum', 0.0227, 'lps'),
	(569748, 131, '2014-03-01 00:04:55.000000', 'consum', 0.0221, 'lps'),
	(569749, 131, '2014-03-01 00:04:56.000000', 'consum', 0.0216, 'lps'),
	(569750, 131, '2014-03-01 00:04:57.000000', 'consum', 0.0227, 'lps'),
	(569751, 131, '2014-03-01 00:04:58.000000', 'consum', 0.0221, 'lps'),
	(569752, 131, '2014-03-01 00:04:59.000000', 'consum', 0.0215, 'lps'),
	(569753, 131, '2014-03-01 00:05:00.000000', 'consum', 0.0221, 'lps'),
	(569754, 131, '2014-03-01 00:05:01.000000', 'consum', 0.0215, 'lps'),
	(569755, 131, '2014-03-01 00:05:02.000000', 'consum', 0.0220, 'lps'),
	(569756, 131, '2014-03-01 00:05:03.000000', 'consum', 0.0211, 'lps'),
	(569757, 131, '2014-03-01 00:05:04.000000', 'consum', 0.0220, 'lps'),
	(569758, 131, '2014-03-01 00:05:05.000000', 'consum', 0.0221, 'lps'),
	(569759, 131, '2014-03-01 00:05:06.000000', 'consum', 0.0219, 'lps'),
	(569760, 131, '2014-03-01 00:05:07.000000', 'consum', 0.0222, 'lps'),
	(569761, 131, '2014-03-01 00:05:08.000000', 'consum', 0.0224, 'lps'),
	(569762, 131, '2014-03-01 00:05:09.000000', 'consum', 0.0211, 'lps'),
	(569763, 131, '2014-03-01 00:05:10.000000', 'consum', 0.0210, 'lps'),
	(569764, 131, '2014-03-01 00:05:11.000000', 'consum', 0.0224, 'lps'),
	(569765, 131, '2014-03-01 00:05:12.000000', 'consum', 0.0210, 'lps'),
	(569766, 131, '2014-03-01 00:05:13.000000', 'consum', 0.0221, 'lps'),
	(569767, 131, '2014-03-01 00:05:14.000000', 'consum', 0.0211, 'lps'),
	(569768, 131, '2014-03-01 00:05:15.000000', 'consum', 0.0218, 'lps'),
	(569769, 131, '2014-03-01 00:05:16.000000', 'consum', 0.0214, 'lps'),
	(569770, 131, '2014-03-01 00:05:17.000000', 'consum', 0.0223, 'lps'),
	(569771, 131, '2014-03-01 00:05:18.000000', 'consum', 0.0211, 'lps'),
	(569772, 131, '2014-03-01 00:05:19.000000', 'consum', 0.0212, 'lps'),
	(569773, 131, '2014-03-01 00:05:20.000000', 'consum', 0.0217, 'lps'),
	(569774, 131, '2014-03-01 00:05:21.000000', 'consum', 0.0223, 'lps'),
	(569775, 131, '2014-03-01 00:05:22.000000', 'consum', 0.0219, 'lps'),
	(569776, 131, '2014-03-01 00:05:23.000000', 'consum', 0.0215, 'lps'),
	(569777, 131, '2014-03-01 00:05:24.000000', 'consum', 0.0210, 'lps'),
	(569778, 131, '2014-03-01 00:05:25.000000', 'consum', 0.0211, 'lps'),
	(569779, 131, '2014-03-01 00:05:26.000000', 'consum', 0.0218, 'lps'),
	(569780, 131, '2014-03-01 00:05:27.000000', 'consum', 0.0227, 'lps'),
	(569781, 131, '2014-03-01 00:05:28.000000', 'consum', 0.0220, 'lps'),
	(569782, 131, '2014-03-01 00:05:29.000000', 'consum', 0.0226, 'lps'),
	(569783, 131, '2014-03-01 00:05:30.000000', 'consum', 0.0224, 'lps'),
	(569784, 131, '2014-03-01 00:05:31.000000', 'consum', 0.0215, 'lps'),
	(569785, 131, '2014-03-01 00:05:32.000000', 'consum', 0.0213, 'lps'),
	(569786, 131, '2014-03-01 00:05:33.000000', 'consum', 0.0227, 'lps'),
	(569787, 131, '2014-03-01 00:05:34.000000', 'consum', 0.0215, 'lps'),
	(569788, 131, '2014-03-01 00:05:35.000000', 'consum', 0.0219, 'lps'),
	(569789, 131, '2014-03-01 00:05:36.000000', 'consum', 0.0223, 'lps'),
	(569790, 131, '2014-03-01 00:05:37.000000', 'consum', 0.0214, 'lps'),
	(569791, 131, '2014-03-01 00:05:38.000000', 'consum', 0.0227, 'lps'),
	(569792, 131, '2014-03-01 00:05:39.000000', 'consum', 0.0211, 'lps'),
	(569793, 131, '2014-03-01 00:05:40.000000', 'consum', 0.0218, 'lps'),
	(569794, 131, '2014-03-01 00:05:41.000000', 'consum', 0.0212, 'lps'),
	(569795, 131, '2014-03-01 00:05:42.000000', 'consum', 0.0216, 'lps'),
	(569796, 131, '2014-03-01 00:05:43.000000', 'consum', 0.0215, 'lps'),
	(569797, 131, '2014-03-01 00:05:44.000000', 'consum', 0.0219, 'lps'),
	(569798, 131, '2014-03-01 00:05:45.000000', 'consum', 0.0221, 'lps'),
	(569799, 131, '2014-03-01 00:05:46.000000', 'consum', 0.0220, 'lps'),
	(569800, 131, '2014-03-01 00:05:47.000000', 'consum', 0.0211, 'lps'),
	(569801, 131, '2014-03-01 00:05:48.000000', 'consum', 0.0223, 'lps'),
	(569802, 131, '2014-03-01 00:05:49.000000', 'consum', 0.0217, 'lps'),
	(569803, 131, '2014-03-01 00:05:50.000000', 'consum', 0.0225, 'lps'),
	(569804, 131, '2014-03-01 00:05:51.000000', 'consum', 0.0227, 'lps'),
	(569805, 131, '2014-03-01 00:05:52.000000', 'consum', 0.0215, 'lps'),
	(569806, 131, '2014-03-01 00:05:53.000000', 'consum', 0.0219, 'lps'),
	(569807, 131, '2014-03-01 00:05:54.000000', 'consum', 0.0224, 'lps'),
	(569808, 131, '2014-03-01 00:05:55.000000', 'consum', 0.0219, 'lps'),
	(569809, 131, '2014-03-01 00:05:56.000000', 'consum', 0.0211, 'lps'),
	(569810, 131, '2014-03-01 00:05:57.000000', 'consum', 0.0225, 'lps'),
	(569811, 131, '2014-03-01 00:05:58.000000', 'consum', 0.0227, 'lps'),
	(569812, 131, '2014-03-01 00:05:59.000000', 'consum', 0.0215, 'lps'),
	(569813, 131, '2014-03-01 00:06:00.000000', 'consum', 0.0221, 'lps'),
	(569814, 131, '2014-03-01 00:06:01.000000', 'consum', 0.0216, 'lps'),
	(569815, 131, '2014-03-01 00:06:02.000000', 'consum', 0.0226, 'lps'),
	(569816, 131, '2014-03-01 00:06:03.000000', 'consum', 0.0216, 'lps'),
	(569817, 131, '2014-03-01 00:06:04.000000', 'consum', 0.0213, 'lps'),
	(569818, 131, '2014-03-01 00:06:05.000000', 'consum', 0.0224, 'lps'),
	(569819, 131, '2014-03-01 00:06:06.000000', 'consum', 0.0217, 'lps'),
	(569820, 131, '2014-03-01 00:06:07.000000', 'consum', 0.0222, 'lps'),
	(569821, 131, '2014-03-01 00:06:08.000000', 'consum', 0.0214, 'lps'),
	(569822, 131, '2014-03-01 00:06:09.000000', 'consum', 0.0211, 'lps'),
	(569823, 131, '2014-03-01 00:06:10.000000', 'consum', 0.0224, 'lps'),
	(569824, 131, '2014-03-01 00:06:11.000000', 'consum', 0.0222, 'lps'),
	(569825, 131, '2014-03-01 00:06:12.000000', 'consum', 0.0213, 'lps'),
	(569826, 131, '2014-03-01 00:06:13.000000', 'consum', 0.0223, 'lps'),
	(569827, 131, '2014-03-01 00:06:14.000000', 'consum', 0.0214, 'lps'),
	(569828, 131, '2014-03-01 00:06:15.000000', 'consum', 0.0210, 'lps'),
	(569829, 131, '2014-03-01 00:06:16.000000', 'consum', 0.0214, 'lps'),
	(569830, 131, '2014-03-01 00:06:17.000000', 'consum', 0.0214, 'lps'),
	(569831, 131, '2014-03-01 00:06:18.000000', 'consum', 0.0218, 'lps'),
	(569832, 131, '2014-03-01 00:06:19.000000', 'consum', 0.0221, 'lps'),
	(569833, 131, '2014-03-01 00:06:20.000000', 'consum', 0.0225, 'lps'),
	(569834, 131, '2014-03-01 00:06:21.000000', 'consum', 0.0214, 'lps'),
	(569835, 131, '2014-03-01 00:06:22.000000', 'consum', 0.0223, 'lps'),
	(569836, 131, '2014-03-01 00:06:23.000000', 'consum', 0.0211, 'lps'),
	(569837, 131, '2014-03-01 00:06:24.000000', 'consum', 0.0210, 'lps'),
	(569838, 131, '2014-03-01 00:06:25.000000', 'consum', 0.0210, 'lps'),
	(569839, 131, '2014-03-01 00:06:26.000000', 'consum', 0.0227, 'lps'),
	(569840, 131, '2014-03-01 00:06:27.000000', 'consum', 0.0225, 'lps'),
	(569841, 131, '2014-03-01 00:06:28.000000', 'consum', 0.0215, 'lps'),
	(569842, 131, '2014-03-01 00:06:29.000000', 'consum', 0.0227, 'lps'),
	(569843, 131, '2014-03-01 00:06:30.000000', 'consum', 0.0227, 'lps'),
	(569844, 131, '2014-03-01 00:06:31.000000', 'consum', 0.0227, 'lps'),
	(569845, 131, '2014-03-01 00:06:32.000000', 'consum', 0.0225, 'lps'),
	(569846, 131, '2014-03-01 00:06:33.000000', 'consum', 0.0217, 'lps'),
	(569847, 131, '2014-03-01 00:06:34.000000', 'consum', 0.0218, 'lps'),
	(569848, 131, '2014-03-01 00:06:35.000000', 'consum', 0.0210, 'lps'),
	(569849, 131, '2014-03-01 00:06:36.000000', 'consum', 0.0226, 'lps'),
	(569850, 131, '2014-03-01 00:06:37.000000', 'consum', 0.0215, 'lps'),
	(569851, 131, '2014-03-01 00:06:38.000000', 'consum', 0.0227, 'lps'),
	(569852, 131, '2014-03-01 00:06:39.000000', 'consum', 0.0225, 'lps'),
	(569853, 131, '2014-03-01 00:06:40.000000', 'consum', 0.0215, 'lps'),
	(569854, 131, '2014-03-01 00:06:41.000000', 'consum', 0.0227, 'lps'),
	(569855, 131, '2014-03-01 00:06:42.000000', 'consum', 0.0227, 'lps'),
	(569856, 131, '2014-03-01 00:06:43.000000', 'consum', 0.0210, 'lps'),
	(569857, 131, '2014-03-01 00:06:44.000000', 'consum', 0.0212, 'lps'),
	(569858, 131, '2014-03-01 00:06:45.000000', 'consum', 0.0221, 'lps'),
	(569859, 131, '2014-03-01 00:06:46.000000', 'consum', 0.0225, 'lps'),
	(569860, 131, '2014-03-01 00:06:47.000000', 'consum', 0.0214, 'lps'),
	(569861, 131, '2014-03-01 00:06:48.000000', 'consum', 0.0222, 'lps'),
	(569862, 131, '2014-03-01 00:06:49.000000', 'consum', 0.0222, 'lps'),
	(569863, 131, '2014-03-01 00:06:50.000000', 'consum', 0.0216, 'lps'),
	(569864, 131, '2014-03-01 00:06:51.000000', 'consum', 0.0223, 'lps'),
	(569865, 131, '2014-03-01 00:06:52.000000', 'consum', 0.0220, 'lps'),
	(569866, 131, '2014-03-01 00:06:53.000000', 'consum', 0.0221, 'lps'),
	(569867, 131, '2014-03-01 00:06:54.000000', 'consum', 0.0217, 'lps'),
	(569868, 131, '2014-03-01 00:06:55.000000', 'consum', 0.0214, 'lps'),
	(569869, 131, '2014-03-01 00:06:56.000000', 'consum', 0.0227, 'lps'),
	(569870, 131, '2014-03-01 00:06:57.000000', 'consum', 0.0211, 'lps'),
	(569871, 131, '2014-03-01 00:06:58.000000', 'consum', 0.0219, 'lps'),
	(569872, 131, '2014-03-01 00:06:59.000000', 'consum', 0.0215, 'lps'),
	(569873, 131, '2014-03-01 00:07:00.000000', 'consum', 0.0210, 'lps'),
	(569874, 131, '2014-03-01 00:07:01.000000', 'consum', 0.0213, 'lps'),
	(569875, 131, '2014-03-01 00:07:02.000000', 'consum', 0.0226, 'lps'),
	(569876, 131, '2014-03-01 00:07:03.000000', 'consum', 0.0227, 'lps'),
	(569877, 131, '2014-03-01 00:07:04.000000', 'consum', 0.0210, 'lps'),
	(569878, 131, '2014-03-01 00:07:05.000000', 'consum', 0.0215, 'lps'),
	(569879, 131, '2014-03-01 00:07:06.000000', 'consum', 0.0216, 'lps'),
	(569880, 131, '2014-03-01 00:07:07.000000', 'consum', 0.0227, 'lps'),
	(569881, 131, '2014-03-01 00:07:08.000000', 'consum', 0.0223, 'lps'),
	(569882, 131, '2014-03-01 00:07:09.000000', 'consum', 0.0226, 'lps'),
	(569883, 131, '2014-03-01 00:07:10.000000', 'consum', 0.0215, 'lps'),
	(569884, 131, '2014-03-01 00:07:11.000000', 'consum', 0.0225, 'lps'),
	(569885, 131, '2014-03-01 00:07:12.000000', 'consum', 0.0216, 'lps'),
	(569886, 131, '2014-03-01 00:07:13.000000', 'consum', 0.0213, 'lps'),
	(569887, 131, '2014-03-01 00:07:14.000000', 'consum', 0.0227, 'lps'),
	(569888, 131, '2014-03-01 00:07:15.000000', 'consum', 0.0212, 'lps'),
	(569889, 131, '2014-03-01 00:07:16.000000', 'consum', 0.0225, 'lps'),
	(569890, 131, '2014-03-01 00:07:17.000000', 'consum', 0.0226, 'lps'),
	(569891, 131, '2014-03-01 00:07:18.000000', 'consum', 0.0227, 'lps'),
	(569892, 131, '2014-03-01 00:07:19.000000', 'consum', 0.0212, 'lps'),
	(569893, 131, '2014-03-01 00:07:20.000000', 'consum', 0.0224, 'lps'),
	(569894, 131, '2014-03-01 00:07:21.000000', 'consum', 0.0221, 'lps'),
	(569895, 131, '2014-03-01 00:07:22.000000', 'consum', 0.0221, 'lps'),
	(569896, 131, '2014-03-01 00:07:23.000000', 'consum', 0.0215, 'lps'),
	(569897, 131, '2014-03-01 00:07:24.000000', 'consum', 0.0222, 'lps'),
	(569898, 131, '2014-03-01 00:07:25.000000', 'consum', 0.0219, 'lps'),
	(569899, 131, '2014-03-01 00:07:26.000000', 'consum', 0.0221, 'lps'),
	(569900, 131, '2014-03-01 00:07:27.000000', 'consum', 0.0218, 'lps'),
	(569901, 131, '2014-03-01 00:07:28.000000', 'consum', 0.0220, 'lps'),
	(569902, 131, '2014-03-01 00:07:29.000000', 'consum', 0.0216, 'lps'),
	(569903, 131, '2014-03-01 00:07:30.000000', 'consum', 0.0211, 'lps'),
	(569904, 131, '2014-03-01 00:07:31.000000', 'consum', 0.0218, 'lps'),
	(569905, 131, '2014-03-01 00:07:32.000000', 'consum', 0.0210, 'lps'),
	(569906, 131, '2014-03-01 00:07:33.000000', 'consum', 0.0221, 'lps'),
	(569907, 131, '2014-03-01 00:07:34.000000', 'consum', 0.0213, 'lps'),
	(569908, 131, '2014-03-01 00:07:35.000000', 'consum', 0.0210, 'lps'),
	(569909, 131, '2014-03-01 00:07:36.000000', 'consum', 0.0221, 'lps'),
	(569910, 131, '2014-03-01 00:07:37.000000', 'consum', 0.0211, 'lps'),
	(569911, 131, '2014-03-01 00:07:38.000000', 'consum', 0.0216, 'lps'),
	(569912, 131, '2014-03-01 00:07:39.000000', 'consum', 0.0222, 'lps'),
	(569913, 131, '2014-03-01 00:07:40.000000', 'consum', 0.0218, 'lps'),
	(569914, 131, '2014-03-01 00:07:41.000000', 'consum', 0.0212, 'lps'),
	(569915, 131, '2014-03-01 00:07:42.000000', 'consum', 0.0216, 'lps'),
	(569916, 131, '2014-03-01 00:07:43.000000', 'consum', 0.0217, 'lps'),
	(569917, 131, '2014-03-01 00:07:44.000000', 'consum', 0.0227, 'lps'),
	(569918, 131, '2014-03-01 00:07:45.000000', 'consum', 0.0221, 'lps'),
	(569919, 131, '2014-03-01 00:07:46.000000', 'consum', 0.0212, 'lps'),
	(569920, 131, '2014-03-01 00:07:47.000000', 'consum', 0.0225, 'lps'),
	(569921, 131, '2014-03-01 00:07:48.000000', 'consum', 0.0225, 'lps'),
	(569922, 131, '2014-03-01 00:07:49.000000', 'consum', 0.0223, 'lps'),
	(569923, 131, '2014-03-01 00:07:50.000000', 'consum', 0.0213, 'lps'),
	(569924, 131, '2014-03-01 00:07:51.000000', 'consum', 0.0224, 'lps'),
	(569925, 131, '2014-03-01 00:07:52.000000', 'consum', 0.0215, 'lps'),
	(569926, 131, '2014-03-01 00:07:53.000000', 'consum', 0.0213, 'lps'),
	(569927, 131, '2014-03-01 00:07:54.000000', 'consum', 0.0211, 'lps'),
	(569928, 131, '2014-03-01 00:07:55.000000', 'consum', 0.0224, 'lps'),
	(569929, 131, '2014-03-01 00:07:56.000000', 'consum', 0.0222, 'lps'),
	(569930, 131, '2014-03-01 00:07:57.000000', 'consum', 0.0213, 'lps'),
	(569931, 131, '2014-03-01 00:07:58.000000', 'consum', 0.0224, 'lps'),
	(569932, 131, '2014-03-01 00:07:59.000000', 'consum', 0.0218, 'lps'),
	(569933, 131, '2014-03-01 00:08:00.000000', 'consum', 0.0224, 'lps'),
	(569934, 131, '2014-03-01 00:08:01.000000', 'consum', 0.0223, 'lps'),
	(569935, 131, '2014-03-01 00:08:02.000000', 'consum', 0.0215, 'lps'),
	(569936, 131, '2014-03-01 00:08:03.000000', 'consum', 0.0215, 'lps'),
	(569937, 131, '2014-03-01 00:08:04.000000', 'consum', 0.0221, 'lps'),
	(569938, 131, '2014-03-01 00:08:05.000000', 'consum', 0.0212, 'lps'),
	(569939, 131, '2014-03-01 00:08:06.000000', 'consum', 0.0225, 'lps'),
	(569940, 131, '2014-03-01 00:08:07.000000', 'consum', 0.0225, 'lps'),
	(569941, 131, '2014-03-01 00:08:08.000000', 'consum', 0.0224, 'lps'),
	(569942, 131, '2014-03-01 00:08:09.000000', 'consum', 0.0215, 'lps'),
	(569943, 131, '2014-03-01 00:08:10.000000', 'consum', 0.0211, 'lps'),
	(569944, 131, '2014-03-01 00:08:11.000000', 'consum', 0.0219, 'lps'),
	(569945, 131, '2014-03-01 00:08:12.000000', 'consum', 0.0216, 'lps'),
	(569946, 131, '2014-03-01 00:08:13.000000', 'consum', 0.0215, 'lps'),
	(569947, 131, '2014-03-01 00:08:14.000000', 'consum', 0.0216, 'lps'),
	(569948, 131, '2014-03-01 00:08:15.000000', 'consum', 0.0225, 'lps'),
	(569949, 131, '2014-03-01 00:08:16.000000', 'consum', 0.0215, 'lps'),
	(569950, 131, '2014-03-01 00:08:17.000000', 'consum', 0.0225, 'lps'),
	(569951, 131, '2014-03-01 00:08:18.000000', 'consum', 0.0217, 'lps'),
	(569952, 131, '2014-03-01 00:08:19.000000', 'consum', 0.0217, 'lps'),
	(569953, 131, '2014-03-01 00:08:20.000000', 'consum', 0.0224, 'lps'),
	(569954, 131, '2014-03-01 00:08:21.000000', 'consum', 0.0225, 'lps'),
	(569955, 131, '2014-03-01 00:08:22.000000', 'consum', 0.0227, 'lps'),
	(569956, 131, '2014-03-01 00:08:23.000000', 'consum', 0.0212, 'lps'),
	(569957, 131, '2014-03-01 00:08:24.000000', 'consum', 0.0223, 'lps'),
	(569958, 131, '2014-03-01 00:08:25.000000', 'consum', 0.0217, 'lps'),
	(569959, 131, '2014-03-01 00:08:26.000000', 'consum', 0.0222, 'lps'),
	(569960, 131, '2014-03-01 00:08:27.000000', 'consum', 0.0216, 'lps'),
	(569961, 131, '2014-03-01 00:08:28.000000', 'consum', 0.0220, 'lps'),
	(569962, 131, '2014-03-01 00:08:29.000000', 'consum', 0.0225, 'lps'),
	(569963, 131, '2014-03-01 00:08:30.000000', 'consum', 0.0219, 'lps'),
	(569964, 131, '2014-03-01 00:08:31.000000', 'consum', 0.0227, 'lps'),
	(569965, 131, '2014-03-01 00:08:32.000000', 'consum', 0.0217, 'lps'),
	(569966, 131, '2014-03-01 00:08:33.000000', 'consum', 0.0210, 'lps'),
	(569967, 131, '2014-03-01 00:08:34.000000', 'consum', 0.0227, 'lps'),
	(569968, 131, '2014-03-01 00:08:35.000000', 'consum', 0.0223, 'lps'),
	(569969, 131, '2014-03-01 00:08:36.000000', 'consum', 0.0225, 'lps'),
	(569970, 131, '2014-03-01 00:08:37.000000', 'consum', 0.0210, 'lps'),
	(569971, 131, '2014-03-01 00:08:38.000000', 'consum', 0.0220, 'lps'),
	(569972, 131, '2014-03-01 00:08:39.000000', 'consum', 0.0226, 'lps'),
	(569973, 131, '2014-03-01 00:08:40.000000', 'consum', 0.0222, 'lps'),
	(569974, 131, '2014-03-01 00:08:41.000000', 'consum', 0.0225, 'lps'),
	(569975, 131, '2014-03-01 00:08:42.000000', 'consum', 0.0211, 'lps'),
	(569976, 131, '2014-03-01 00:08:43.000000', 'consum', 0.0225, 'lps'),
	(569977, 131, '2014-03-01 00:08:44.000000', 'consum', 0.0210, 'lps'),
	(569978, 131, '2014-03-01 00:08:45.000000', 'consum', 0.0222, 'lps'),
	(569979, 131, '2014-03-01 00:08:46.000000', 'consum', 0.0215, 'lps'),
	(569980, 131, '2014-03-01 00:08:47.000000', 'consum', 0.0217, 'lps'),
	(569981, 131, '2014-03-01 00:08:48.000000', 'consum', 0.0211, 'lps'),
	(569982, 131, '2014-03-01 00:08:49.000000', 'consum', 0.0213, 'lps'),
	(569983, 131, '2014-03-01 00:08:50.000000', 'consum', 0.0223, 'lps'),
	(569984, 131, '2014-03-01 00:08:51.000000', 'consum', 0.0211, 'lps'),
	(569985, 131, '2014-03-01 00:08:52.000000', 'consum', 0.0213, 'lps'),
	(569986, 131, '2014-03-01 00:08:53.000000', 'consum', 0.0224, 'lps'),
	(569987, 131, '2014-03-01 00:08:54.000000', 'consum', 0.0216, 'lps'),
	(569988, 131, '2014-03-01 00:08:55.000000', 'consum', 0.0218, 'lps'),
	(569989, 131, '2014-03-01 00:08:56.000000', 'consum', 0.0215, 'lps'),
	(569990, 131, '2014-03-01 00:08:57.000000', 'consum', 0.0211, 'lps'),
	(569991, 131, '2014-03-01 00:08:58.000000', 'consum', 0.0218, 'lps'),
	(569992, 131, '2014-03-01 00:08:59.000000', 'consum', 0.0211, 'lps'),
	(569993, 131, '2014-03-01 00:09:00.000000', 'consum', 0.0211, 'lps'),
	(569994, 131, '2014-03-01 00:09:01.000000', 'consum', 0.0210, 'lps'),
	(569995, 131, '2014-03-01 00:09:02.000000', 'consum', 0.0226, 'lps'),
	(569996, 131, '2014-03-01 00:09:03.000000', 'consum', 0.0218, 'lps'),
	(569997, 131, '2014-03-01 00:09:04.000000', 'consum', 0.0223, 'lps'),
	(569998, 131, '2014-03-01 00:09:05.000000', 'consum', 0.0213, 'lps'),
	(569999, 131, '2014-03-01 00:09:06.000000', 'consum', 0.0225, 'lps'),
	(570000, 131, '2014-03-01 00:09:07.000000', 'consum', 0.0222, 'lps'),
	(570001, 131, '2014-03-01 00:09:08.000000', 'consum', 0.0224, 'lps'),
	(570002, 131, '2014-03-01 00:09:09.000000', 'consum', 0.0226, 'lps'),
	(570003, 131, '2014-03-01 00:09:10.000000', 'consum', 0.0214, 'lps'),
	(570004, 131, '2014-03-01 00:09:11.000000', 'consum', 0.0217, 'lps'),
	(570005, 131, '2014-03-01 00:09:12.000000', 'consum', 0.0218, 'lps'),
	(570006, 131, '2014-03-01 00:09:13.000000', 'consum', 0.0227, 'lps'),
	(570007, 131, '2014-03-01 00:09:14.000000', 'consum', 0.0218, 'lps'),
	(570008, 131, '2014-03-01 00:09:15.000000', 'consum', 0.0218, 'lps'),
	(570009, 131, '2014-03-01 00:09:16.000000', 'consum', 0.0227, 'lps'),
	(570010, 131, '2014-03-01 00:09:17.000000', 'consum', 0.0215, 'lps'),
	(570011, 131, '2014-03-01 00:09:18.000000', 'consum', 0.0224, 'lps'),
	(570012, 131, '2014-03-01 00:09:19.000000', 'consum', 0.0226, 'lps'),
	(570013, 131, '2014-03-01 00:09:20.000000', 'consum', 0.0215, 'lps'),
	(570014, 131, '2014-03-01 00:09:21.000000', 'consum', 0.0222, 'lps'),
	(570015, 131, '2014-03-01 00:09:22.000000', 'consum', 0.0221, 'lps'),
	(570016, 131, '2014-03-01 00:09:23.000000', 'consum', 0.0227, 'lps'),
	(570017, 131, '2014-03-01 00:09:24.000000', 'consum', 0.0227, 'lps'),
	(570018, 131, '2014-03-01 00:09:25.000000', 'consum', 0.0210, 'lps'),
	(570019, 131, '2014-03-01 00:09:26.000000', 'consum', 0.0213, 'lps'),
	(570020, 131, '2014-03-01 00:09:27.000000', 'consum', 0.0226, 'lps'),
	(570021, 131, '2014-03-01 00:09:28.000000', 'consum', 0.0210, 'lps'),
	(570022, 131, '2014-03-01 00:09:29.000000', 'consum', 0.0217, 'lps'),
	(570023, 131, '2014-03-01 00:09:30.000000', 'consum', 0.0225, 'lps'),
	(570024, 131, '2014-03-01 00:09:31.000000', 'consum', 0.0212, 'lps'),
	(570025, 131, '2014-03-01 00:09:32.000000', 'consum', 0.0211, 'lps'),
	(570026, 131, '2014-03-01 00:09:33.000000', 'consum', 0.0211, 'lps'),
	(570027, 131, '2014-03-01 00:09:34.000000', 'consum', 0.0211, 'lps'),
	(570028, 131, '2014-03-01 00:09:35.000000', 'consum', 0.0212, 'lps'),
	(570029, 131, '2014-03-01 00:09:36.000000', 'consum', 0.0217, 'lps'),
	(570030, 131, '2014-03-01 00:09:37.000000', 'consum', 0.0222, 'lps'),
	(570031, 131, '2014-03-01 00:09:38.000000', 'consum', 0.0212, 'lps'),
	(570032, 131, '2014-03-01 00:09:39.000000', 'consum', 0.0220, 'lps'),
	(570033, 131, '2014-03-01 00:09:40.000000', 'consum', 0.0221, 'lps'),
	(570034, 131, '2014-03-01 00:09:41.000000', 'consum', 0.0215, 'lps'),
	(570035, 131, '2014-03-01 00:09:42.000000', 'consum', 0.0223, 'lps'),
	(570036, 131, '2014-03-01 00:09:43.000000', 'consum', 0.0223, 'lps'),
	(570037, 131, '2014-03-01 00:09:44.000000', 'consum', 0.0217, 'lps'),
	(570038, 131, '2014-03-01 00:09:45.000000', 'consum', 0.0226, 'lps'),
	(570039, 131, '2014-03-01 00:09:46.000000', 'consum', 0.0215, 'lps'),
	(570040, 131, '2014-03-01 00:09:47.000000', 'consum', 0.0226, 'lps'),
	(570041, 131, '2014-03-01 00:09:48.000000', 'consum', 0.0219, 'lps'),
	(570042, 131, '2014-03-01 00:09:49.000000', 'consum', 0.0226, 'lps'),
	(570043, 131, '2014-03-01 00:09:50.000000', 'consum', 0.0227, 'lps'),
	(570044, 131, '2014-03-01 00:09:51.000000', 'consum', 0.0210, 'lps'),
	(570045, 131, '2014-03-01 00:09:52.000000', 'consum', 0.0216, 'lps'),
	(570046, 131, '2014-03-01 00:09:53.000000', 'consum', 0.0222, 'lps'),
	(570047, 131, '2014-03-01 00:09:54.000000', 'consum', 0.0217, 'lps'),
	(570048, 131, '2014-03-01 00:09:55.000000', 'consum', 0.0210, 'lps'),
	(570049, 131, '2014-03-01 00:09:56.000000', 'consum', 0.0227, 'lps'),
	(570050, 131, '2014-03-01 00:09:57.000000', 'consum', 0.0221, 'lps'),
	(570051, 131, '2014-03-01 00:09:58.000000', 'consum', 0.0213, 'lps'),
	(570052, 131, '2014-03-01 00:09:59.000000', 'consum', 0.0214, 'lps'),
	(570053, 131, '2014-03-01 00:10:00.000000', 'consum', 0.0218, 'lps'),
	(570054, 131, '2014-03-01 00:10:01.000000', 'consum', 0.0222, 'lps'),
	(570055, 131, '2014-03-01 00:10:02.000000', 'consum', 0.0212, 'lps'),
	(570056, 131, '2014-03-01 00:10:03.000000', 'consum', 0.0218, 'lps'),
	(570057, 131, '2014-03-01 00:10:04.000000', 'consum', 0.0212, 'lps'),
	(570058, 131, '2014-03-01 00:10:05.000000', 'consum', 0.0211, 'lps'),
	(570059, 131, '2014-03-01 00:10:06.000000', 'consum', 0.0212, 'lps'),
	(570060, 131, '2014-03-01 00:10:07.000000', 'consum', 0.0216, 'lps'),
	(570061, 131, '2014-03-01 00:10:08.000000', 'consum', 0.0215, 'lps'),
	(570062, 131, '2014-03-01 00:10:09.000000', 'consum', 0.0221, 'lps'),
	(570063, 131, '2014-03-01 00:10:10.000000', 'consum', 0.0211, 'lps'),
	(570064, 131, '2014-03-01 00:10:11.000000', 'consum', 0.0221, 'lps'),
	(570065, 131, '2014-03-01 00:10:12.000000', 'consum', 0.0224, 'lps'),
	(570066, 131, '2014-03-01 00:10:13.000000', 'consum', 0.0213, 'lps'),
	(570067, 131, '2014-03-01 00:10:14.000000', 'consum', 0.0218, 'lps'),
	(570068, 131, '2014-03-01 00:10:15.000000', 'consum', 0.0224, 'lps'),
	(570069, 131, '2014-03-01 00:10:16.000000', 'consum', 0.0220, 'lps'),
	(570070, 131, '2014-03-01 00:10:17.000000', 'consum', 0.0217, 'lps'),
	(570071, 131, '2014-03-01 00:10:18.000000', 'consum', 0.0218, 'lps'),
	(570072, 131, '2014-03-01 00:10:19.000000', 'consum', 0.0213, 'lps'),
	(570073, 131, '2014-03-01 00:10:20.000000', 'consum', 0.0216, 'lps'),
	(570074, 131, '2014-03-01 00:10:21.000000', 'consum', 0.0216, 'lps'),
	(570075, 131, '2014-03-01 00:10:22.000000', 'consum', 0.0224, 'lps'),
	(570076, 131, '2014-03-01 00:10:23.000000', 'consum', 0.0223, 'lps'),
	(570077, 131, '2014-03-01 00:10:24.000000', 'consum', 0.0216, 'lps'),
	(570078, 131, '2014-03-01 00:10:25.000000', 'consum', 0.0220, 'lps'),
	(570079, 131, '2014-03-01 00:10:26.000000', 'consum', 0.0226, 'lps'),
	(570080, 131, '2014-03-01 00:10:27.000000', 'consum', 0.0222, 'lps'),
	(570081, 131, '2014-03-01 00:10:28.000000', 'consum', 0.0223, 'lps'),
	(570082, 131, '2014-03-01 00:10:29.000000', 'consum', 0.0222, 'lps'),
	(570083, 131, '2014-03-01 00:10:30.000000', 'consum', 0.0215, 'lps'),
	(570084, 131, '2014-03-01 00:10:31.000000', 'consum', 0.0218, 'lps'),
	(570085, 131, '2014-03-01 00:10:32.000000', 'consum', 0.0214, 'lps'),
	(570086, 131, '2014-03-01 00:10:33.000000', 'consum', 0.0227, 'lps'),
	(570087, 131, '2014-03-01 00:10:34.000000', 'consum', 0.0213, 'lps'),
	(570088, 131, '2014-03-01 00:10:35.000000', 'consum', 0.0225, 'lps'),
	(570089, 131, '2014-03-01 00:10:36.000000', 'consum', 0.0223, 'lps'),
	(570090, 131, '2014-03-01 00:10:37.000000', 'consum', 0.0215, 'lps'),
	(570091, 131, '2014-03-01 00:10:38.000000', 'consum', 0.0214, 'lps'),
	(570092, 131, '2014-03-01 00:10:39.000000', 'consum', 0.0217, 'lps'),
	(570093, 131, '2014-03-01 00:10:40.000000', 'consum', 0.0214, 'lps'),
	(570094, 131, '2014-03-01 00:10:41.000000', 'consum', 0.0227, 'lps'),
	(570095, 131, '2014-03-01 00:10:42.000000', 'consum', 0.0212, 'lps'),
	(570096, 131, '2014-03-01 00:10:43.000000', 'consum', 0.0223, 'lps'),
	(570097, 131, '2014-03-01 00:10:44.000000', 'consum', 0.0214, 'lps'),
	(570098, 131, '2014-03-01 00:10:45.000000', 'consum', 0.0211, 'lps'),
	(570099, 131, '2014-03-01 00:10:46.000000', 'consum', 0.0223, 'lps'),
	(570100, 131, '2014-03-01 00:10:47.000000', 'consum', 0.0218, 'lps'),
	(570101, 131, '2014-03-01 00:10:48.000000', 'consum', 0.0210, 'lps'),
	(570102, 131, '2014-03-01 00:10:49.000000', 'consum', 0.0224, 'lps'),
	(570103, 131, '2014-03-01 00:10:50.000000', 'consum', 0.0226, 'lps'),
	(570104, 131, '2014-03-01 00:10:51.000000', 'consum', 0.0210, 'lps'),
	(570105, 131, '2014-03-01 00:10:52.000000', 'consum', 0.0220, 'lps'),
	(570106, 131, '2014-03-01 00:10:53.000000', 'consum', 0.0222, 'lps'),
	(570107, 131, '2014-03-01 00:10:54.000000', 'consum', 0.0225, 'lps'),
	(570108, 131, '2014-03-01 00:10:55.000000', 'consum', 0.0210, 'lps'),
	(570109, 131, '2014-03-01 00:10:56.000000', 'consum', 0.0223, 'lps'),
	(570110, 131, '2014-03-01 00:10:57.000000', 'consum', 0.0220, 'lps'),
	(570111, 131, '2014-03-01 00:10:58.000000', 'consum', 0.0220, 'lps'),
	(570112, 131, '2014-03-01 00:10:59.000000', 'consum', 0.0213, 'lps'),
	(570113, 131, '2014-03-01 00:11:00.000000', 'consum', 0.0213, 'lps'),
	(570114, 131, '2014-03-01 00:11:01.000000', 'consum', 0.0217, 'lps'),
	(570115, 131, '2014-03-01 00:11:02.000000', 'consum', 0.0221, 'lps'),
	(570116, 131, '2014-03-01 00:11:03.000000', 'consum', 0.0223, 'lps'),
	(570117, 131, '2014-03-01 00:11:04.000000', 'consum', 0.0226, 'lps'),
	(570118, 131, '2014-03-01 00:11:05.000000', 'consum', 0.0216, 'lps'),
	(570119, 131, '2014-03-01 00:11:06.000000', 'consum', 0.0211, 'lps'),
	(570120, 131, '2014-03-01 00:11:07.000000', 'consum', 0.0216, 'lps'),
	(570121, 131, '2014-03-01 00:11:08.000000', 'consum', 0.0217, 'lps'),
	(570122, 131, '2014-03-01 00:11:09.000000', 'consum', 0.0210, 'lps'),
	(570123, 131, '2014-03-01 00:11:10.000000', 'consum', 0.0225, 'lps'),
	(570124, 131, '2014-03-01 00:11:11.000000', 'consum', 0.0216, 'lps'),
	(570125, 131, '2014-03-01 00:11:12.000000', 'consum', 0.0211, 'lps'),
	(570126, 131, '2014-03-01 00:11:13.000000', 'consum', 0.0215, 'lps'),
	(570127, 131, '2014-03-01 00:11:14.000000', 'consum', 0.0217, 'lps'),
	(570128, 131, '2014-03-01 00:11:15.000000', 'consum', 0.0214, 'lps'),
	(570129, 131, '2014-03-01 00:11:16.000000', 'consum', 0.0224, 'lps'),
	(570130, 131, '2014-03-01 00:11:17.000000', 'consum', 0.0214, 'lps'),
	(570131, 131, '2014-03-01 00:11:18.000000', 'consum', 0.0227, 'lps'),
	(570132, 131, '2014-03-01 00:11:19.000000', 'consum', 0.0213, 'lps'),
	(570133, 131, '2014-03-01 00:11:20.000000', 'consum', 0.0226, 'lps'),
	(570134, 131, '2014-03-01 00:11:21.000000', 'consum', 0.0226, 'lps'),
	(570135, 131, '2014-03-01 00:11:22.000000', 'consum', 0.0226, 'lps'),
	(570136, 131, '2014-03-01 00:11:23.000000', 'consum', 0.0227, 'lps'),
	(570137, 131, '2014-03-01 00:11:24.000000', 'consum', 0.0226, 'lps'),
	(570138, 131, '2014-03-01 00:11:25.000000', 'consum', 0.0222, 'lps'),
	(570139, 131, '2014-03-01 00:11:26.000000', 'consum', 0.0223, 'lps'),
	(570140, 131, '2014-03-01 00:11:27.000000', 'consum', 0.0223, 'lps'),
	(570141, 131, '2014-03-01 00:11:28.000000', 'consum', 0.0216, 'lps'),
	(570142, 131, '2014-03-01 00:11:29.000000', 'consum', 0.0220, 'lps'),
	(570143, 131, '2014-03-01 00:11:30.000000', 'consum', 0.0224, 'lps'),
	(570144, 131, '2014-03-01 00:11:31.000000', 'consum', 0.0216, 'lps'),
	(570145, 131, '2014-03-01 00:11:32.000000', 'consum', 0.0214, 'lps'),
	(570146, 131, '2014-03-01 00:11:33.000000', 'consum', 0.0216, 'lps'),
	(570147, 131, '2014-03-01 00:11:34.000000', 'consum', 0.0226, 'lps'),
	(570148, 131, '2014-03-01 00:11:35.000000', 'consum', 0.0219, 'lps'),
	(570149, 131, '2014-03-01 00:11:36.000000', 'consum', 0.0225, 'lps'),
	(570150, 131, '2014-03-01 00:11:37.000000', 'consum', 0.0223, 'lps'),
	(570151, 131, '2014-03-01 00:11:38.000000', 'consum', 0.0210, 'lps'),
	(570152, 131, '2014-03-01 00:11:39.000000', 'consum', 0.0211, 'lps'),
	(570153, 131, '2014-03-01 00:11:40.000000', 'consum', 0.0216, 'lps'),
	(570154, 131, '2014-03-01 00:11:41.000000', 'consum', 0.0217, 'lps'),
	(570155, 131, '2014-03-01 00:11:42.000000', 'consum', 0.0227, 'lps'),
	(570156, 131, '2014-03-01 00:11:43.000000', 'consum', 0.0222, 'lps'),
	(570157, 131, '2014-03-01 00:11:44.000000', 'consum', 0.0219, 'lps'),
	(570158, 131, '2014-03-01 00:11:45.000000', 'consum', 0.0219, 'lps'),
	(570159, 131, '2014-03-01 00:11:46.000000', 'consum', 0.0227, 'lps'),
	(570160, 131, '2014-03-01 00:11:47.000000', 'consum', 0.0216, 'lps'),
	(570161, 131, '2014-03-01 00:11:48.000000', 'consum', 0.0227, 'lps'),
	(570162, 131, '2014-03-01 00:11:49.000000', 'consum', 0.0224, 'lps'),
	(570163, 131, '2014-03-01 00:11:50.000000', 'consum', 0.0211, 'lps'),
	(570164, 131, '2014-03-01 00:11:51.000000', 'consum', 0.0225, 'lps'),
	(570165, 131, '2014-03-01 00:11:52.000000', 'consum', 0.0214, 'lps'),
	(570166, 131, '2014-03-01 00:11:53.000000', 'consum', 0.0219, 'lps'),
	(570167, 131, '2014-03-01 00:11:54.000000', 'consum', 0.0226, 'lps'),
	(570168, 131, '2014-03-01 00:11:55.000000', 'consum', 0.0226, 'lps'),
	(570169, 131, '2014-03-01 00:11:56.000000', 'consum', 0.0224, 'lps'),
	(570170, 131, '2014-03-01 00:11:57.000000', 'consum', 0.0216, 'lps'),
	(570171, 131, '2014-03-01 00:11:58.000000', 'consum', 0.0218, 'lps'),
	(570172, 131, '2014-03-01 00:11:59.000000', 'consum', 0.0213, 'lps'),
	(570173, 131, '2014-03-01 00:12:00.000000', 'consum', 0.0220, 'lps'),
	(570174, 131, '2014-03-01 00:12:01.000000', 'consum', 0.0215, 'lps'),
	(570175, 131, '2014-03-01 00:12:02.000000', 'consum', 0.0222, 'lps'),
	(570176, 131, '2014-03-01 00:12:03.000000', 'consum', 0.0223, 'lps'),
	(570177, 131, '2014-03-01 00:12:04.000000', 'consum', 0.0219, 'lps'),
	(570178, 131, '2014-03-01 00:12:05.000000', 'consum', 0.0216, 'lps'),
	(570179, 131, '2014-03-01 00:12:06.000000', 'consum', 0.0215, 'lps'),
	(570180, 131, '2014-03-01 00:12:07.000000', 'consum', 0.0217, 'lps'),
	(570181, 131, '2014-03-01 00:12:08.000000', 'consum', 0.0212, 'lps'),
	(570182, 131, '2014-03-01 00:12:09.000000', 'consum', 0.0220, 'lps'),
	(570183, 131, '2014-03-01 00:12:10.000000', 'consum', 0.0216, 'lps'),
	(570184, 131, '2014-03-01 00:12:11.000000', 'consum', 0.0213, 'lps'),
	(570185, 131, '2014-03-01 00:12:12.000000', 'consum', 0.0223, 'lps'),
	(570186, 131, '2014-03-01 00:12:13.000000', 'consum', 0.0212, 'lps'),
	(570187, 131, '2014-03-01 00:12:14.000000', 'consum', 0.0219, 'lps'),
	(570188, 131, '2014-03-01 00:12:15.000000', 'consum', 0.0212, 'lps'),
	(570189, 131, '2014-03-01 00:12:16.000000', 'consum', 0.0214, 'lps'),
	(570190, 131, '2014-03-01 00:12:17.000000', 'consum', 0.0224, 'lps'),
	(570191, 131, '2014-03-01 00:12:18.000000', 'consum', 0.0213, 'lps'),
	(570192, 131, '2014-03-01 00:12:19.000000', 'consum', 0.0221, 'lps'),
	(570193, 131, '2014-03-01 00:12:20.000000', 'consum', 0.0222, 'lps'),
	(570194, 131, '2014-03-01 00:12:21.000000', 'consum', 0.0217, 'lps'),
	(570195, 131, '2014-03-01 00:12:22.000000', 'consum', 0.0211, 'lps'),
	(570196, 131, '2014-03-01 00:12:23.000000', 'consum', 0.0210, 'lps'),
	(570197, 131, '2014-03-01 00:12:24.000000', 'consum', 0.0227, 'lps'),
	(570198, 131, '2014-03-01 00:12:25.000000', 'consum', 0.0225, 'lps'),
	(570199, 131, '2014-03-01 00:12:26.000000', 'consum', 0.0214, 'lps'),
	(570200, 131, '2014-03-01 00:12:27.000000', 'consum', 0.0223, 'lps'),
	(570201, 131, '2014-03-01 00:12:28.000000', 'consum', 0.0227, 'lps'),
	(570202, 131, '2014-03-01 00:12:29.000000', 'consum', 0.0221, 'lps'),
	(570203, 131, '2014-03-01 00:12:30.000000', 'consum', 0.0216, 'lps'),
	(570204, 131, '2014-03-01 00:12:31.000000', 'consum', 0.0225, 'lps'),
	(570205, 131, '2014-03-01 00:12:32.000000', 'consum', 0.0213, 'lps'),
	(570206, 131, '2014-03-01 00:12:33.000000', 'consum', 0.0216, 'lps'),
	(570207, 131, '2014-03-01 00:12:34.000000', 'consum', 0.0214, 'lps'),
	(570208, 131, '2014-03-01 00:12:35.000000', 'consum', 0.0210, 'lps'),
	(570209, 131, '2014-03-01 00:12:36.000000', 'consum', 0.0220, 'lps'),
	(570210, 131, '2014-03-01 00:12:37.000000', 'consum', 0.0223, 'lps'),
	(570211, 131, '2014-03-01 00:12:38.000000', 'consum', 0.0211, 'lps'),
	(570212, 131, '2014-03-01 00:12:39.000000', 'consum', 0.0211, 'lps'),
	(570213, 131, '2014-03-01 00:12:40.000000', 'consum', 0.0215, 'lps'),
	(570214, 131, '2014-03-01 00:12:41.000000', 'consum', 0.0213, 'lps'),
	(570215, 131, '2014-03-01 00:12:42.000000', 'consum', 0.0226, 'lps'),
	(570216, 131, '2014-03-01 00:12:43.000000', 'consum', 0.0213, 'lps'),
	(570217, 131, '2014-03-01 00:12:44.000000', 'consum', 0.0212, 'lps'),
	(570218, 131, '2014-03-01 00:12:45.000000', 'consum', 0.0214, 'lps'),
	(570219, 131, '2014-03-01 00:12:46.000000', 'consum', 0.0222, 'lps'),
	(570220, 131, '2014-03-01 00:12:47.000000', 'consum', 0.0222, 'lps'),
	(570221, 131, '2014-03-01 00:12:48.000000', 'consum', 0.0219, 'lps'),
	(570222, 131, '2014-03-01 00:12:49.000000', 'consum', 0.0219, 'lps'),
	(570223, 131, '2014-03-01 00:12:50.000000', 'consum', 0.0226, 'lps'),
	(570224, 131, '2014-03-01 00:12:51.000000', 'consum', 0.0211, 'lps'),
	(570225, 131, '2014-03-01 00:12:52.000000', 'consum', 0.0221, 'lps'),
	(570226, 131, '2014-03-01 00:12:53.000000', 'consum', 0.0226, 'lps'),
	(570227, 131, '2014-03-01 00:12:54.000000', 'consum', 0.0220, 'lps'),
	(570228, 131, '2014-03-01 00:12:55.000000', 'consum', 0.0215, 'lps'),
	(570229, 131, '2014-03-01 00:12:56.000000', 'consum', 0.0224, 'lps'),
	(570230, 131, '2014-03-01 00:12:57.000000', 'consum', 0.0212, 'lps'),
	(570231, 131, '2014-03-01 00:12:58.000000', 'consum', 0.0214, 'lps'),
	(570232, 131, '2014-03-01 00:12:59.000000', 'consum', 0.0224, 'lps'),
	(570233, 131, '2014-03-01 00:13:00.000000', 'consum', 0.0215, 'lps'),
	(570234, 131, '2014-03-01 00:13:01.000000', 'consum', 0.0210, 'lps'),
	(570235, 131, '2014-03-01 00:13:02.000000', 'consum', 0.0215, 'lps'),
	(570236, 131, '2014-03-01 00:13:03.000000', 'consum', 0.0216, 'lps'),
	(570237, 131, '2014-03-01 00:13:04.000000', 'consum', 0.0224, 'lps'),
	(570238, 131, '2014-03-01 00:13:05.000000', 'consum', 0.0212, 'lps'),
	(570239, 131, '2014-03-01 00:13:06.000000', 'consum', 0.0212, 'lps'),
	(570240, 131, '2014-03-01 00:13:07.000000', 'consum', 0.0213, 'lps'),
	(570241, 131, '2014-03-01 00:13:08.000000', 'consum', 0.0222, 'lps'),
	(570242, 131, '2014-03-01 00:13:09.000000', 'consum', 0.0225, 'lps'),
	(570243, 131, '2014-03-01 00:13:10.000000', 'consum', 0.0214, 'lps'),
	(570244, 131, '2014-03-01 00:13:11.000000', 'consum', 0.0221, 'lps'),
	(570245, 131, '2014-03-01 00:13:12.000000', 'consum', 0.0219, 'lps'),
	(570246, 131, '2014-03-01 00:13:13.000000', 'consum', 0.0220, 'lps'),
	(570247, 131, '2014-03-01 00:13:14.000000', 'consum', 0.0217, 'lps'),
	(570248, 131, '2014-03-01 00:13:15.000000', 'consum', 0.0217, 'lps'),
	(570249, 131, '2014-03-01 00:13:16.000000', 'consum', 0.0222, 'lps'),
	(570250, 131, '2014-03-01 00:13:17.000000', 'consum', 0.0215, 'lps'),
	(570251, 131, '2014-03-01 00:13:18.000000', 'consum', 0.0218, 'lps'),
	(570252, 131, '2014-03-01 00:13:19.000000', 'consum', 0.0215, 'lps'),
	(570253, 131, '2014-03-01 00:13:20.000000', 'consum', 0.0213, 'lps'),
	(570254, 131, '2014-03-01 00:13:21.000000', 'consum', 0.0227, 'lps'),
	(570255, 131, '2014-03-01 00:13:22.000000', 'consum', 0.0214, 'lps'),
	(570256, 131, '2014-03-01 00:13:23.000000', 'consum', 0.0218, 'lps'),
	(570257, 131, '2014-03-01 00:13:24.000000', 'consum', 0.0219, 'lps'),
	(570258, 131, '2014-03-01 00:13:25.000000', 'consum', 0.0214, 'lps'),
	(570259, 131, '2014-03-01 00:13:26.000000', 'consum', 0.0220, 'lps'),
	(570260, 131, '2014-03-01 00:13:27.000000', 'consum', 0.0214, 'lps'),
	(570261, 131, '2014-03-01 00:13:28.000000', 'consum', 0.0217, 'lps'),
	(570262, 131, '2014-03-01 00:13:29.000000', 'consum', 0.0217, 'lps'),
	(570263, 131, '2014-03-01 00:13:30.000000', 'consum', 0.0224, 'lps'),
	(570264, 131, '2014-03-01 00:13:31.000000', 'consum', 0.0223, 'lps'),
	(570265, 131, '2014-03-01 00:13:32.000000', 'consum', 0.0215, 'lps'),
	(570266, 131, '2014-03-01 00:13:33.000000', 'consum', 0.0217, 'lps'),
	(570267, 131, '2014-03-01 00:13:34.000000', 'consum', 0.0212, 'lps'),
	(570268, 131, '2014-03-01 00:13:35.000000', 'consum', 0.0217, 'lps'),
	(570269, 131, '2014-03-01 00:13:36.000000', 'consum', 0.0222, 'lps'),
	(570270, 131, '2014-03-01 00:13:37.000000', 'consum', 0.0214, 'lps'),
	(570271, 131, '2014-03-01 00:13:38.000000', 'consum', 0.0211, 'lps'),
	(570272, 131, '2014-03-01 00:13:39.000000', 'consum', 0.0220, 'lps'),
	(570273, 131, '2014-03-01 00:13:40.000000', 'consum', 0.0225, 'lps'),
	(570274, 131, '2014-03-01 00:13:41.000000', 'consum', 0.0217, 'lps'),
	(570275, 131, '2014-03-01 00:13:42.000000', 'consum', 0.0221, 'lps'),
	(570276, 131, '2014-03-01 00:13:43.000000', 'consum', 0.0225, 'lps'),
	(570277, 131, '2014-03-01 00:13:44.000000', 'consum', 0.0216, 'lps'),
	(570278, 131, '2014-03-01 00:13:45.000000', 'consum', 0.0215, 'lps'),
	(570279, 131, '2014-03-01 00:13:46.000000', 'consum', 0.0218, 'lps'),
	(570280, 131, '2014-03-01 00:13:47.000000', 'consum', 0.0216, 'lps'),
	(570281, 131, '2014-03-01 00:13:48.000000', 'consum', 0.0215, 'lps'),
	(570282, 131, '2014-03-01 00:13:49.000000', 'consum', 0.0221, 'lps'),
	(570283, 131, '2014-03-01 00:13:50.000000', 'consum', 0.0212, 'lps'),
	(570284, 131, '2014-03-01 00:13:51.000000', 'consum', 0.0226, 'lps'),
	(570285, 131, '2014-03-01 00:13:52.000000', 'consum', 0.0211, 'lps'),
	(570286, 131, '2014-03-01 00:13:53.000000', 'consum', 0.0222, 'lps'),
	(570287, 131, '2014-03-01 00:13:54.000000', 'consum', 0.0213, 'lps'),
	(570288, 131, '2014-03-01 00:13:55.000000', 'consum', 0.0225, 'lps'),
	(570289, 131, '2014-03-01 00:13:56.000000', 'consum', 0.0223, 'lps'),
	(570290, 131, '2014-03-01 00:13:57.000000', 'consum', 0.0214, 'lps'),
	(570291, 131, '2014-03-01 00:13:58.000000', 'consum', 0.0225, 'lps'),
	(570292, 131, '2014-03-01 00:13:59.000000', 'consum', 0.0219, 'lps'),
	(570293, 131, '2014-03-01 00:14:00.000000', 'consum', 0.0212, 'lps'),
	(570294, 131, '2014-03-01 00:14:01.000000', 'consum', 0.0227, 'lps'),
	(570295, 131, '2014-03-01 00:14:02.000000', 'consum', 0.0221, 'lps'),
	(570296, 131, '2014-03-01 00:14:03.000000', 'consum', 0.0212, 'lps'),
	(570297, 131, '2014-03-01 00:14:04.000000', 'consum', 0.0224, 'lps'),
	(570298, 131, '2014-03-01 00:14:05.000000', 'consum', 0.0220, 'lps'),
	(570299, 131, '2014-03-01 00:14:06.000000', 'consum', 0.0220, 'lps'),
	(570300, 131, '2014-03-01 00:14:07.000000', 'consum', 0.0213, 'lps'),
	(570301, 131, '2014-03-01 00:14:08.000000', 'consum', 0.0214, 'lps'),
	(570302, 131, '2014-03-01 00:14:09.000000', 'consum', 0.0219, 'lps'),
	(570303, 131, '2014-03-01 00:14:10.000000', 'consum', 0.0226, 'lps'),
	(570304, 131, '2014-03-01 00:14:11.000000', 'consum', 0.0226, 'lps'),
	(570305, 131, '2014-03-01 00:14:12.000000', 'consum', 0.0227, 'lps'),
	(570306, 131, '2014-03-01 00:14:13.000000', 'consum', 0.0227, 'lps'),
	(570307, 131, '2014-03-01 00:14:14.000000', 'consum', 0.0211, 'lps'),
	(570308, 131, '2014-03-01 00:14:15.000000', 'consum', 0.0217, 'lps'),
	(570309, 131, '2014-03-01 00:14:16.000000', 'consum', 0.0226, 'lps'),
	(570310, 131, '2014-03-01 00:14:17.000000', 'consum', 0.0215, 'lps'),
	(570311, 131, '2014-03-01 00:14:18.000000', 'consum', 0.0222, 'lps'),
	(570312, 131, '2014-03-01 00:14:19.000000', 'consum', 0.0222, 'lps'),
	(570313, 131, '2014-03-01 00:14:20.000000', 'consum', 0.0214, 'lps'),
	(570314, 131, '2014-03-01 00:14:21.000000', 'consum', 0.0215, 'lps'),
	(570315, 131, '2014-03-01 00:14:22.000000', 'consum', 0.0224, 'lps'),
	(570316, 131, '2014-03-01 00:14:23.000000', 'consum', 0.0210, 'lps'),
	(570317, 131, '2014-03-01 00:14:24.000000', 'consum', 0.0222, 'lps'),
	(570318, 131, '2014-03-01 00:14:25.000000', 'consum', 0.0217, 'lps'),
	(570319, 131, '2014-03-01 00:14:26.000000', 'consum', 0.0211, 'lps'),
	(570320, 131, '2014-03-01 00:14:27.000000', 'consum', 0.0211, 'lps'),
	(570321, 131, '2014-03-01 00:14:28.000000', 'consum', 0.0213, 'lps'),
	(570322, 131, '2014-03-01 00:14:29.000000', 'consum', 0.0223, 'lps'),
	(570323, 131, '2014-03-01 00:14:30.000000', 'consum', 0.0210, 'lps'),
	(570324, 131, '2014-03-01 00:14:31.000000', 'consum', 0.0211, 'lps'),
	(570325, 131, '2014-03-01 00:14:32.000000', 'consum', 0.0212, 'lps'),
	(570326, 131, '2014-03-01 00:14:33.000000', 'consum', 0.0220, 'lps'),
	(570327, 131, '2014-03-01 00:14:34.000000', 'consum', 0.0219, 'lps'),
	(570328, 131, '2014-03-01 00:14:35.000000', 'consum', 0.0224, 'lps'),
	(570329, 131, '2014-03-01 00:14:36.000000', 'consum', 0.0219, 'lps'),
	(570330, 131, '2014-03-01 00:14:37.000000', 'consum', 0.0212, 'lps'),
	(570331, 131, '2014-03-01 00:14:38.000000', 'consum', 0.0212, 'lps'),
	(570332, 131, '2014-03-01 00:14:39.000000', 'consum', 0.0216, 'lps'),
	(570333, 131, '2014-03-01 00:14:40.000000', 'consum', 0.0216, 'lps'),
	(570334, 131, '2014-03-01 00:14:41.000000', 'consum', 0.0223, 'lps'),
	(570335, 131, '2014-03-01 00:14:42.000000', 'consum', 0.0220, 'lps'),
	(570336, 131, '2014-03-01 00:14:43.000000', 'consum', 0.0221, 'lps'),
	(570337, 131, '2014-03-01 00:14:44.000000', 'consum', 0.0219, 'lps'),
	(570338, 131, '2014-03-01 00:14:45.000000', 'consum', 0.0220, 'lps'),
	(570339, 131, '2014-03-01 00:14:46.000000', 'consum', 0.0218, 'lps'),
	(570340, 131, '2014-03-01 00:14:47.000000', 'consum', 0.0219, 'lps'),
	(570341, 131, '2014-03-01 00:14:48.000000', 'consum', 0.0215, 'lps'),
	(570342, 131, '2014-03-01 00:14:49.000000', 'consum', 0.0224, 'lps'),
	(570343, 131, '2014-03-01 00:14:50.000000', 'consum', 0.0213, 'lps'),
	(570344, 131, '2014-03-01 00:14:51.000000', 'consum', 0.0221, 'lps'),
	(570345, 131, '2014-03-01 00:14:52.000000', 'consum', 0.0218, 'lps'),
	(570346, 131, '2014-03-01 00:14:53.000000', 'consum', 0.0218, 'lps'),
	(570347, 131, '2014-03-01 00:14:54.000000', 'consum', 0.0227, 'lps'),
	(570348, 131, '2014-03-01 00:14:55.000000', 'consum', 0.0216, 'lps'),
	(570349, 131, '2014-03-01 00:14:56.000000', 'consum', 0.0225, 'lps'),
	(570350, 131, '2014-03-01 00:14:57.000000', 'consum', 0.0213, 'lps'),
	(570351, 131, '2014-03-01 00:14:58.000000', 'consum', 0.0218, 'lps'),
	(570352, 131, '2014-03-01 00:14:59.000000', 'consum', 0.0225, 'lps'),
	(570353, 131, '2014-03-01 00:15:00.000000', 'consum', 0.0224, 'lps'),
	(570354, 131, '2014-03-01 00:15:01.000000', 'consum', 0.0216, 'lps'),
	(570355, 131, '2014-03-01 00:15:02.000000', 'consum', 0.0219, 'lps'),
	(570356, 131, '2014-03-01 00:15:03.000000', 'consum', 0.0219, 'lps'),
	(570357, 131, '2014-03-01 00:15:04.000000', 'consum', 0.0212, 'lps'),
	(570358, 131, '2014-03-01 00:15:05.000000', 'consum', 0.0226, 'lps'),
	(570359, 131, '2014-03-01 00:15:06.000000', 'consum', 0.0215, 'lps'),
	(570360, 131, '2014-03-01 00:15:07.000000', 'consum', 0.0222, 'lps'),
	(570361, 131, '2014-03-01 00:15:08.000000', 'consum', 0.0220, 'lps'),
	(570362, 131, '2014-03-01 00:15:09.000000', 'consum', 0.0226, 'lps'),
	(570363, 131, '2014-03-01 00:15:10.000000', 'consum', 0.0223, 'lps'),
	(570364, 131, '2014-03-01 00:15:11.000000', 'consum', 0.0210, 'lps'),
	(570365, 131, '2014-03-01 00:15:12.000000', 'consum', 0.0226, 'lps'),
	(570366, 131, '2014-03-01 00:15:13.000000', 'consum', 0.0220, 'lps'),
	(570367, 131, '2014-03-01 00:15:14.000000', 'consum', 0.0210, 'lps'),
	(570368, 131, '2014-03-01 00:15:15.000000', 'consum', 0.0218, 'lps'),
	(570369, 131, '2014-03-01 00:15:16.000000', 'consum', 0.0214, 'lps'),
	(570370, 131, '2014-03-01 00:15:17.000000', 'consum', 0.0223, 'lps'),
	(570371, 131, '2014-03-01 00:15:18.000000', 'consum', 0.0227, 'lps'),
	(570372, 131, '2014-03-01 00:15:19.000000', 'consum', 0.0221, 'lps'),
	(570373, 131, '2014-03-01 00:15:20.000000', 'consum', 0.0216, 'lps'),
	(570374, 131, '2014-03-01 00:15:21.000000', 'consum', 0.0223, 'lps'),
	(570375, 131, '2014-03-01 00:15:22.000000', 'consum', 0.0223, 'lps'),
	(570376, 131, '2014-03-01 00:15:23.000000', 'consum', 0.0219, 'lps'),
	(570377, 131, '2014-03-01 00:15:24.000000', 'consum', 0.0218, 'lps'),
	(570378, 131, '2014-03-01 00:15:25.000000', 'consum', 0.0220, 'lps'),
	(570379, 131, '2014-03-01 00:15:26.000000', 'consum', 0.0221, 'lps'),
	(570380, 131, '2014-03-01 00:15:27.000000', 'consum', 0.0216, 'lps'),
	(570381, 131, '2014-03-01 00:15:28.000000', 'consum', 0.0210, 'lps'),
	(570382, 131, '2014-03-01 00:15:29.000000', 'consum', 0.0210, 'lps'),
	(570383, 131, '2014-03-01 00:15:30.000000', 'consum', 0.0227, 'lps'),
	(570384, 131, '2014-03-01 00:15:31.000000', 'consum', 0.0225, 'lps'),
	(570385, 131, '2014-03-01 00:15:32.000000', 'consum', 0.0217, 'lps'),
	(570386, 131, '2014-03-01 00:15:33.000000', 'consum', 0.0217, 'lps'),
	(570387, 131, '2014-03-01 00:15:34.000000', 'consum', 0.0226, 'lps'),
	(570388, 131, '2014-03-01 00:15:35.000000', 'consum', 0.0214, 'lps'),
	(570389, 131, '2014-03-01 00:15:36.000000', 'consum', 0.0217, 'lps'),
	(570390, 131, '2014-03-01 00:15:37.000000', 'consum', 0.0219, 'lps'),
	(570391, 131, '2014-03-01 00:15:38.000000', 'consum', 0.0214, 'lps'),
	(570392, 131, '2014-03-01 00:15:39.000000', 'consum', 0.0220, 'lps'),
	(570393, 131, '2014-03-01 00:15:40.000000', 'consum', 0.0215, 'lps'),
	(570394, 131, '2014-03-01 00:15:41.000000', 'consum', 0.0221, 'lps'),
	(570395, 131, '2014-03-01 00:15:42.000000', 'consum', 0.0218, 'lps'),
	(570396, 131, '2014-03-01 00:15:43.000000', 'consum', 0.0214, 'lps'),
	(570397, 131, '2014-03-01 00:15:44.000000', 'consum', 0.0226, 'lps'),
	(570398, 131, '2014-03-01 00:15:45.000000', 'consum', 0.0223, 'lps'),
	(570399, 131, '2014-03-01 00:15:46.000000', 'consum', 0.0212, 'lps'),
	(570400, 131, '2014-03-01 00:15:47.000000', 'consum', 0.0217, 'lps'),
	(570401, 131, '2014-03-01 00:15:48.000000', 'consum', 0.0220, 'lps'),
	(570402, 131, '2014-03-01 00:15:49.000000', 'consum', 0.0224, 'lps'),
	(570403, 131, '2014-03-01 00:15:50.000000', 'consum', 0.0214, 'lps'),
	(570404, 131, '2014-03-01 00:15:51.000000', 'consum', 0.0225, 'lps'),
	(570405, 131, '2014-03-01 00:15:52.000000', 'consum', 0.0219, 'lps'),
	(570406, 131, '2014-03-01 00:15:53.000000', 'consum', 0.0212, 'lps'),
	(570407, 131, '2014-03-01 00:15:54.000000', 'consum', 0.0211, 'lps'),
	(570408, 131, '2014-03-01 00:15:55.000000', 'consum', 0.0225, 'lps'),
	(570409, 131, '2014-03-01 00:15:56.000000', 'consum', 0.0212, 'lps'),
	(570410, 131, '2014-03-01 00:15:57.000000', 'consum', 0.0213, 'lps'),
	(570411, 131, '2014-03-01 00:15:58.000000', 'consum', 0.0220, 'lps'),
	(570412, 131, '2014-03-01 00:15:59.000000', 'consum', 0.0215, 'lps'),
	(570413, 131, '2014-03-01 00:16:00.000000', 'consum', 0.0223, 'lps'),
	(570414, 131, '2014-03-01 00:16:01.000000', 'consum', 0.0224, 'lps'),
	(570415, 131, '2014-03-01 00:16:02.000000', 'consum', 0.0225, 'lps'),
	(570416, 131, '2014-03-01 00:16:03.000000', 'consum', 0.0224, 'lps'),
	(570417, 131, '2014-03-01 00:16:04.000000', 'consum', 0.0217, 'lps'),
	(570418, 131, '2014-03-01 00:16:05.000000', 'consum', 0.0222, 'lps'),
	(570419, 131, '2014-03-01 00:16:06.000000', 'consum', 0.0214, 'lps'),
	(570420, 131, '2014-03-01 00:16:07.000000', 'consum', 0.0214, 'lps'),
	(570421, 131, '2014-03-01 00:16:08.000000', 'consum', 0.0218, 'lps'),
	(570422, 131, '2014-03-01 00:16:09.000000', 'consum', 0.0220, 'lps'),
	(570423, 131, '2014-03-01 00:16:10.000000', 'consum', 0.0217, 'lps'),
	(570424, 131, '2014-03-01 00:16:11.000000', 'consum', 0.0216, 'lps'),
	(570425, 131, '2014-03-01 00:16:12.000000', 'consum', 0.0220, 'lps'),
	(570426, 131, '2014-03-01 00:16:13.000000', 'consum', 0.0222, 'lps'),
	(570427, 131, '2014-03-01 00:16:14.000000', 'consum', 0.0225, 'lps'),
	(570428, 131, '2014-03-01 00:16:15.000000', 'consum', 0.0215, 'lps'),
	(570429, 131, '2014-03-01 00:16:16.000000', 'consum', 0.0224, 'lps'),
	(570430, 131, '2014-03-01 00:16:17.000000', 'consum', 0.0212, 'lps'),
	(570431, 131, '2014-03-01 00:16:18.000000', 'consum', 0.0215, 'lps'),
	(570432, 131, '2014-03-01 00:16:19.000000', 'consum', 0.0210, 'lps'),
	(570433, 131, '2014-03-01 00:16:20.000000', 'consum', 0.0216, 'lps'),
	(570434, 131, '2014-03-01 00:16:21.000000', 'consum', 0.0222, 'lps'),
	(570435, 131, '2014-03-01 00:16:22.000000', 'consum', 0.0214, 'lps'),
	(570436, 131, '2014-03-01 00:16:23.000000', 'consum', 0.0214, 'lps'),
	(570437, 131, '2014-03-01 00:16:24.000000', 'consum', 0.0219, 'lps'),
	(570438, 131, '2014-03-01 00:16:25.000000', 'consum', 0.0226, 'lps'),
	(570439, 131, '2014-03-01 00:16:26.000000', 'consum', 0.0210, 'lps'),
	(570440, 131, '2014-03-01 00:16:27.000000', 'consum', 0.0217, 'lps'),
	(570441, 131, '2014-03-01 00:16:28.000000', 'consum', 0.0210, 'lps'),
	(570442, 131, '2014-03-01 00:16:29.000000', 'consum', 0.0225, 'lps'),
	(570443, 131, '2014-03-01 00:16:30.000000', 'consum', 0.0212, 'lps'),
	(570444, 131, '2014-03-01 00:16:31.000000', 'consum', 0.0214, 'lps'),
	(570445, 131, '2014-03-01 00:16:32.000000', 'consum', 0.0222, 'lps'),
	(570446, 131, '2014-03-01 00:16:33.000000', 'consum', 0.0223, 'lps'),
	(570447, 131, '2014-03-01 00:16:34.000000', 'consum', 0.0223, 'lps'),
	(570448, 131, '2014-03-01 00:16:35.000000', 'consum', 0.0217, 'lps'),
	(570449, 131, '2014-03-01 00:16:36.000000', 'consum', 0.0224, 'lps'),
	(570450, 131, '2014-03-01 00:16:37.000000', 'consum', 0.0223, 'lps'),
	(570451, 131, '2014-03-01 00:16:38.000000', 'consum', 0.0216, 'lps'),
	(570452, 131, '2014-03-01 00:16:39.000000', 'consum', 0.0221, 'lps'),
	(570453, 131, '2014-03-01 00:16:40.000000', 'consum', 0.0212, 'lps'),
	(570454, 131, '2014-03-01 00:16:41.000000', 'consum', 0.0224, 'lps'),
	(570455, 131, '2014-03-01 00:16:42.000000', 'consum', 0.0222, 'lps'),
	(570456, 131, '2014-03-01 00:16:43.000000', 'consum', 0.0225, 'lps'),
	(570457, 131, '2014-03-01 00:16:44.000000', 'consum', 0.0215, 'lps'),
	(570458, 131, '2014-03-01 00:16:45.000000', 'consum', 0.0225, 'lps'),
	(570459, 131, '2014-03-01 00:16:46.000000', 'consum', 0.0218, 'lps'),
	(570460, 131, '2014-03-01 00:16:47.000000', 'consum', 0.0224, 'lps'),
	(570461, 131, '2014-03-01 00:16:48.000000', 'consum', 0.0220, 'lps'),
	(570462, 131, '2014-03-01 00:16:49.000000', 'consum', 0.0219, 'lps'),
	(570463, 131, '2014-03-01 00:16:50.000000', 'consum', 0.0227, 'lps'),
	(570464, 131, '2014-03-01 00:16:51.000000', 'consum', 0.0213, 'lps'),
	(570465, 131, '2014-03-01 00:16:52.000000', 'consum', 0.0211, 'lps'),
	(570466, 131, '2014-03-01 00:16:53.000000', 'consum', 0.0222, 'lps'),
	(570467, 131, '2014-03-01 00:16:54.000000', 'consum', 0.0216, 'lps'),
	(570468, 131, '2014-03-01 00:16:55.000000', 'consum', 0.0223, 'lps'),
	(570469, 131, '2014-03-01 00:16:56.000000', 'consum', 0.0220, 'lps'),
	(570470, 131, '2014-03-01 00:16:57.000000', 'consum', 0.0223, 'lps'),
	(570471, 131, '2014-03-01 00:16:58.000000', 'consum', 0.0227, 'lps'),
	(570472, 131, '2014-03-01 00:16:59.000000', 'consum', 0.0221, 'lps'),
	(570473, 131, '2014-03-01 00:17:00.000000', 'consum', 0.0214, 'lps'),
	(570474, 131, '2014-03-01 00:17:01.000000', 'consum', 0.0216, 'lps'),
	(570475, 131, '2014-03-01 00:17:02.000000', 'consum', 0.0212, 'lps'),
	(570476, 131, '2014-03-01 00:17:03.000000', 'consum', 0.0217, 'lps'),
	(570477, 131, '2014-03-01 00:17:04.000000', 'consum', 0.0224, 'lps'),
	(570478, 131, '2014-03-01 00:17:05.000000', 'consum', 0.0221, 'lps'),
	(570479, 131, '2014-03-01 00:17:06.000000', 'consum', 0.0226, 'lps'),
	(570480, 131, '2014-03-01 00:17:07.000000', 'consum', 0.0221, 'lps'),
	(570481, 131, '2014-03-01 00:17:08.000000', 'consum', 0.0217, 'lps'),
	(570482, 131, '2014-03-01 00:17:09.000000', 'consum', 0.0211, 'lps'),
	(570483, 131, '2014-03-01 00:17:10.000000', 'consum', 0.0213, 'lps'),
	(570484, 131, '2014-03-01 00:17:11.000000', 'consum', 0.0224, 'lps'),
	(570485, 131, '2014-03-01 00:17:12.000000', 'consum', 0.0217, 'lps'),
	(570486, 131, '2014-03-01 00:17:13.000000', 'consum', 0.0219, 'lps'),
	(570487, 131, '2014-03-01 00:17:14.000000', 'consum', 0.0219, 'lps'),
	(570488, 131, '2014-03-01 00:17:15.000000', 'consum', 0.0210, 'lps'),
	(570489, 131, '2014-03-01 00:17:16.000000', 'consum', 0.0221, 'lps'),
	(570490, 131, '2014-03-01 00:17:17.000000', 'consum', 0.0210, 'lps'),
	(570491, 131, '2014-03-01 00:17:18.000000', 'consum', 0.0212, 'lps'),
	(570492, 131, '2014-03-01 00:17:19.000000', 'consum', 0.0223, 'lps'),
	(570493, 131, '2014-03-01 00:17:20.000000', 'consum', 0.0213, 'lps'),
	(570494, 131, '2014-03-01 00:17:21.000000', 'consum', 0.0225, 'lps'),
	(570495, 131, '2014-03-01 00:17:22.000000', 'consum', 0.0223, 'lps'),
	(570496, 131, '2014-03-01 00:17:23.000000', 'consum', 0.0210, 'lps'),
	(570497, 131, '2014-03-01 00:17:24.000000', 'consum', 0.0225, 'lps'),
	(570498, 131, '2014-03-01 00:17:25.000000', 'consum', 0.0216, 'lps'),
	(570499, 131, '2014-03-01 00:17:26.000000', 'consum', 0.0211, 'lps'),
	(570500, 131, '2014-03-01 00:17:27.000000', 'consum', 0.0215, 'lps'),
	(570501, 131, '2014-03-01 00:17:28.000000', 'consum', 0.0214, 'lps'),
	(570502, 131, '2014-03-01 00:17:29.000000', 'consum', 0.0216, 'lps'),
	(570503, 131, '2014-03-01 00:17:30.000000', 'consum', 0.0213, 'lps'),
	(570504, 131, '2014-03-01 00:17:31.000000', 'consum', 0.0222, 'lps'),
	(570505, 131, '2014-03-01 00:17:32.000000', 'consum', 0.0227, 'lps'),
	(570506, 131, '2014-03-01 00:17:33.000000', 'consum', 0.0222, 'lps'),
	(570507, 131, '2014-03-01 00:17:34.000000', 'consum', 0.0219, 'lps'),
	(570508, 131, '2014-03-01 00:17:35.000000', 'consum', 0.0220, 'lps'),
	(570509, 131, '2014-03-01 00:17:36.000000', 'consum', 0.0214, 'lps'),
	(570510, 131, '2014-03-01 00:17:37.000000', 'consum', 0.0220, 'lps'),
	(570511, 131, '2014-03-01 00:17:38.000000', 'consum', 0.0210, 'lps'),
	(570512, 131, '2014-03-01 00:17:39.000000', 'consum', 0.0220, 'lps'),
	(570513, 131, '2014-03-01 00:17:40.000000', 'consum', 0.0222, 'lps'),
	(570514, 131, '2014-03-01 00:17:41.000000', 'consum', 0.0223, 'lps'),
	(570515, 131, '2014-03-01 00:17:42.000000', 'consum', 0.0223, 'lps'),
	(570516, 131, '2014-03-01 00:17:43.000000', 'consum', 0.0219, 'lps'),
	(570517, 131, '2014-03-01 00:17:44.000000', 'consum', 0.0215, 'lps'),
	(570518, 131, '2014-03-01 00:17:45.000000', 'consum', 0.0227, 'lps'),
	(570519, 131, '2014-03-01 00:17:46.000000', 'consum', 0.0210, 'lps'),
	(570520, 131, '2014-03-01 00:17:47.000000', 'consum', 0.0213, 'lps'),
	(570521, 131, '2014-03-01 00:17:48.000000', 'consum', 0.0227, 'lps'),
	(570522, 131, '2014-03-01 00:17:49.000000', 'consum', 0.0213, 'lps'),
	(570523, 131, '2014-03-01 00:17:50.000000', 'consum', 0.0227, 'lps'),
	(570524, 131, '2014-03-01 00:17:51.000000', 'consum', 0.0215, 'lps'),
	(570525, 131, '2014-03-01 00:17:52.000000', 'consum', 0.0223, 'lps'),
	(570526, 131, '2014-03-01 00:17:53.000000', 'consum', 0.0223, 'lps'),
	(570527, 131, '2014-03-01 00:17:54.000000', 'consum', 0.0220, 'lps'),
	(570528, 131, '2014-03-01 00:17:55.000000', 'consum', 0.0220, 'lps'),
	(570529, 131, '2014-03-01 00:17:56.000000', 'consum', 0.0215, 'lps'),
	(570530, 131, '2014-03-01 00:17:57.000000', 'consum', 0.0220, 'lps'),
	(570531, 131, '2014-03-01 00:17:58.000000', 'consum', 0.0212, 'lps'),
	(570532, 131, '2014-03-01 00:17:59.000000', 'consum', 0.0227, 'lps'),
	(570533, 131, '2014-03-01 00:18:00.000000', 'consum', 0.0218, 'lps'),
	(570534, 131, '2014-03-01 00:18:01.000000', 'consum', 0.0217, 'lps'),
	(570535, 131, '2014-03-01 00:18:02.000000', 'consum', 0.0220, 'lps'),
	(570536, 131, '2014-03-01 00:18:03.000000', 'consum', 0.0221, 'lps'),
	(570537, 131, '2014-03-01 00:18:04.000000', 'consum', 0.0218, 'lps'),
	(570538, 131, '2014-03-01 00:18:05.000000', 'consum', 0.0218, 'lps'),
	(570539, 131, '2014-03-01 00:18:06.000000', 'consum', 0.0210, 'lps'),
	(570540, 131, '2014-03-01 00:18:07.000000', 'consum', 0.0221, 'lps'),
	(570541, 131, '2014-03-01 00:18:08.000000', 'consum', 0.0213, 'lps'),
	(570542, 131, '2014-03-01 00:18:09.000000', 'consum', 0.0210, 'lps'),
	(570543, 131, '2014-03-01 00:18:10.000000', 'consum', 0.0221, 'lps'),
	(570544, 131, '2014-03-01 00:18:11.000000', 'consum', 0.0211, 'lps'),
	(570545, 131, '2014-03-01 00:18:12.000000', 'consum', 0.0216, 'lps'),
	(570546, 131, '2014-03-01 00:18:13.000000', 'consum', 0.0222, 'lps'),
	(570547, 131, '2014-03-01 00:18:14.000000', 'consum', 0.0217, 'lps'),
	(570548, 131, '2014-03-01 00:18:15.000000', 'consum', 0.0227, 'lps'),
	(570549, 131, '2014-03-01 00:18:16.000000', 'consum', 0.0218, 'lps'),
	(570550, 131, '2014-03-01 00:18:17.000000', 'consum', 0.0221, 'lps'),
	(570551, 131, '2014-03-01 00:18:18.000000', 'consum', 0.0222, 'lps'),
	(570552, 131, '2014-03-01 00:18:19.000000', 'consum', 0.0218, 'lps'),
	(570553, 131, '2014-03-01 00:18:20.000000', 'consum', 0.0216, 'lps'),
	(570554, 131, '2014-03-01 00:18:21.000000', 'consum', 0.0217, 'lps'),
	(570555, 131, '2014-03-01 00:18:22.000000', 'consum', 0.0226, 'lps'),
	(570556, 131, '2014-03-01 00:18:23.000000', 'consum', 0.0216, 'lps'),
	(570557, 131, '2014-03-01 00:18:24.000000', 'consum', 0.0212, 'lps'),
	(570558, 131, '2014-03-01 00:18:25.000000', 'consum', 0.0218, 'lps'),
	(570559, 131, '2014-03-01 00:18:26.000000', 'consum', 0.0226, 'lps'),
	(570560, 131, '2014-03-01 00:18:27.000000', 'consum', 0.0215, 'lps'),
	(570561, 131, '2014-03-01 00:18:28.000000', 'consum', 0.0223, 'lps'),
	(570562, 131, '2014-03-01 00:18:29.000000', 'consum', 0.0226, 'lps'),
	(570563, 131, '2014-03-01 00:18:30.000000', 'consum', 0.0214, 'lps'),
	(570564, 131, '2014-03-01 00:18:31.000000', 'consum', 0.0217, 'lps'),
	(570565, 131, '2014-03-01 00:18:32.000000', 'consum', 0.0215, 'lps'),
	(570566, 131, '2014-03-01 00:18:33.000000', 'consum', 0.0217, 'lps'),
	(570567, 131, '2014-03-01 00:18:34.000000', 'consum', 0.0213, 'lps'),
	(570568, 131, '2014-03-01 00:18:35.000000', 'consum', 0.0220, 'lps'),
	(570569, 131, '2014-03-01 00:18:36.000000', 'consum', 0.0218, 'lps'),
	(570570, 131, '2014-03-01 00:18:37.000000', 'consum', 0.0220, 'lps'),
	(570571, 131, '2014-03-01 00:18:38.000000', 'consum', 0.0219, 'lps'),
	(570572, 131, '2014-03-01 00:18:39.000000', 'consum', 0.0224, 'lps'),
	(570573, 131, '2014-03-01 00:18:40.000000', 'consum', 0.0217, 'lps'),
	(570574, 131, '2014-03-01 00:18:41.000000', 'consum', 0.0223, 'lps'),
	(570575, 131, '2014-03-01 00:18:42.000000', 'consum', 0.0218, 'lps'),
	(570576, 131, '2014-03-01 00:18:43.000000', 'consum', 0.0213, 'lps'),
	(570577, 131, '2014-03-01 00:18:44.000000', 'consum', 0.0218, 'lps'),
	(570578, 131, '2014-03-01 00:18:45.000000', 'consum', 0.0225, 'lps'),
	(570579, 131, '2014-03-01 00:18:46.000000', 'consum', 0.0226, 'lps'),
	(570580, 131, '2014-03-01 00:18:47.000000', 'consum', 0.0227, 'lps'),
	(570581, 131, '2014-03-01 00:18:48.000000', 'consum', 0.0211, 'lps'),
	(570582, 131, '2014-03-01 00:18:49.000000', 'consum', 0.0220, 'lps'),
	(570583, 131, '2014-03-01 00:18:50.000000', 'consum', 0.0221, 'lps'),
	(570584, 131, '2014-03-01 00:18:51.000000', 'consum', 0.0216, 'lps'),
	(570585, 131, '2014-03-01 00:18:52.000000', 'consum', 0.0225, 'lps'),
	(570586, 131, '2014-03-01 00:18:53.000000', 'consum', 0.0215, 'lps'),
	(570587, 131, '2014-03-01 00:18:54.000000', 'consum', 0.0226, 'lps'),
	(570588, 131, '2014-03-01 00:18:55.000000', 'consum', 0.0224, 'lps'),
	(570589, 131, '2014-03-01 00:18:56.000000', 'consum', 0.0211, 'lps'),
	(570590, 131, '2014-03-01 00:18:57.000000', 'consum', 0.0212, 'lps'),
	(570591, 131, '2014-03-01 00:18:58.000000', 'consum', 0.0218, 'lps'),
	(570592, 131, '2014-03-01 00:18:59.000000', 'consum', 0.0227, 'lps'),
	(570593, 131, '2014-03-01 00:19:00.000000', 'consum', 0.0219, 'lps'),
	(570594, 131, '2014-03-01 00:19:01.000000', 'consum', 0.0219, 'lps'),
	(570595, 131, '2014-03-01 00:19:02.000000', 'consum', 0.0211, 'lps'),
	(570596, 131, '2014-03-01 00:19:03.000000', 'consum', 0.0224, 'lps'),
	(570597, 131, '2014-03-01 00:19:04.000000', 'consum', 0.0224, 'lps'),
	(570598, 131, '2014-03-01 00:19:05.000000', 'consum', 0.0219, 'lps'),
	(570599, 131, '2014-03-01 00:19:06.000000', 'consum', 0.0214, 'lps'),
	(570600, 131, '2014-03-01 00:19:07.000000', 'consum', 0.0223, 'lps'),
	(570601, 131, '2014-03-01 00:19:08.000000', 'consum', 0.0210, 'lps'),
	(570602, 131, '2014-03-01 00:19:09.000000', 'consum', 0.0226, 'lps'),
	(570603, 131, '2014-03-01 00:19:10.000000', 'consum', 0.0216, 'lps'),
	(570604, 131, '2014-03-01 00:19:11.000000', 'consum', 0.0212, 'lps'),
	(570605, 131, '2014-03-01 00:19:12.000000', 'consum', 0.0220, 'lps'),
	(570606, 131, '2014-03-01 00:19:13.000000', 'consum', 0.0218, 'lps'),
	(570607, 131, '2014-03-01 00:19:14.000000', 'consum', 0.0223, 'lps'),
	(570608, 131, '2014-03-01 00:19:15.000000', 'consum', 0.0212, 'lps'),
	(570609, 131, '2014-03-01 00:19:16.000000', 'consum', 0.0221, 'lps'),
	(570610, 131, '2014-03-01 00:19:17.000000', 'consum', 0.0222, 'lps'),
	(570611, 131, '2014-03-01 00:19:18.000000', 'consum', 0.0218, 'lps'),
	(570612, 131, '2014-03-01 00:19:19.000000', 'consum', 0.0217, 'lps'),
	(570613, 131, '2014-03-01 00:19:20.000000', 'consum', 0.0219, 'lps'),
	(570614, 131, '2014-03-01 00:19:21.000000', 'consum', 0.0217, 'lps'),
	(570615, 131, '2014-03-01 00:19:22.000000', 'consum', 0.0220, 'lps'),
	(570616, 131, '2014-03-01 00:19:23.000000', 'consum', 0.0219, 'lps'),
	(570617, 131, '2014-03-01 00:19:24.000000', 'consum', 0.0210, 'lps'),
	(570618, 131, '2014-03-01 00:19:25.000000', 'consum', 0.0218, 'lps'),
	(570619, 131, '2014-03-01 00:19:26.000000', 'consum', 0.0215, 'lps'),
	(570620, 131, '2014-03-01 00:19:27.000000', 'consum', 0.0210, 'lps'),
	(570621, 131, '2014-03-01 00:19:28.000000', 'consum', 0.0213, 'lps'),
	(570622, 131, '2014-03-01 00:19:29.000000', 'consum', 0.0210, 'lps'),
	(570623, 131, '2014-03-01 00:19:30.000000', 'consum', 0.0218, 'lps'),
	(570624, 131, '2014-03-01 00:19:31.000000', 'consum', 0.0216, 'lps'),
	(570625, 131, '2014-03-01 00:19:32.000000', 'consum', 0.0217, 'lps'),
	(570626, 131, '2014-03-01 00:19:33.000000', 'consum', 0.0226, 'lps'),
	(570627, 131, '2014-03-01 00:19:34.000000', 'consum', 0.0216, 'lps'),
	(570628, 131, '2014-03-01 00:19:35.000000', 'consum', 0.0210, 'lps'),
	(570629, 131, '2014-03-01 00:19:36.000000', 'consum', 0.0227, 'lps'),
	(570630, 131, '2014-03-01 00:19:37.000000', 'consum', 0.0225, 'lps'),
	(570631, 131, '2014-03-01 00:19:38.000000', 'consum', 0.0216, 'lps'),
	(570632, 131, '2014-03-01 00:19:39.000000', 'consum', 0.0214, 'lps'),
	(570633, 131, '2014-03-01 00:19:40.000000', 'consum', 0.0213, 'lps'),
	(570634, 131, '2014-03-01 00:19:41.000000', 'consum', 0.0215, 'lps'),
	(570635, 131, '2014-03-01 00:19:42.000000', 'consum', 0.0224, 'lps'),
	(570636, 131, '2014-03-01 00:19:43.000000', 'consum', 0.0212, 'lps'),
	(570637, 131, '2014-03-01 00:19:44.000000', 'consum', 0.0215, 'lps'),
	(570638, 131, '2014-03-01 00:19:45.000000', 'consum', 0.0227, 'lps'),
	(570639, 131, '2014-03-01 00:19:46.000000', 'consum', 0.0211, 'lps'),
	(570640, 131, '2014-03-01 00:19:47.000000', 'consum', 0.0218, 'lps'),
	(570641, 131, '2014-03-01 00:19:48.000000', 'consum', 0.0212, 'lps'),
	(570642, 131, '2014-03-01 00:19:49.000000', 'consum', 0.0214, 'lps'),
	(570643, 131, '2014-03-01 00:19:50.000000', 'consum', 0.0225, 'lps'),
	(570644, 131, '2014-03-01 00:19:51.000000', 'consum', 0.0217, 'lps'),
	(570645, 131, '2014-03-01 00:19:52.000000', 'consum', 0.0221, 'lps'),
	(570646, 131, '2014-03-01 00:19:53.000000', 'consum', 0.0225, 'lps'),
	(570647, 131, '2014-03-01 00:19:54.000000', 'consum', 0.0216, 'lps'),
	(570648, 131, '2014-03-01 00:19:55.000000', 'consum', 0.0215, 'lps'),
	(570649, 131, '2014-03-01 00:19:56.000000', 'consum', 0.0216, 'lps'),
	(570650, 131, '2014-03-01 00:19:57.000000', 'consum', 0.0210, 'lps'),
	(570651, 131, '2014-03-01 00:19:58.000000', 'consum', 0.0226, 'lps'),
	(570652, 131, '2014-03-01 00:19:59.000000', 'consum', 0.0217, 'lps'),
	(570653, 131, '2014-03-01 00:20:00.000000', 'consum', 0.0218, 'lps'),
	(570654, 131, '2014-03-01 00:20:01.000000', 'consum', 0.0212, 'lps'),
	(570655, 131, '2014-03-01 00:20:02.000000', 'consum', 0.0213, 'lps'),
	(570656, 131, '2014-03-01 00:20:03.000000', 'consum', 0.0218, 'lps'),
	(570657, 131, '2014-03-01 00:20:04.000000', 'consum', 0.0225, 'lps'),
	(570658, 131, '2014-03-01 00:20:05.000000', 'consum', 0.0227, 'lps'),
	(570659, 131, '2014-03-01 00:20:06.000000', 'consum', 0.0213, 'lps'),
	(570660, 131, '2014-03-01 00:20:07.000000', 'consum', 0.0213, 'lps'),
	(570661, 131, '2014-03-01 00:20:08.000000', 'consum', 0.0213, 'lps'),
	(570662, 131, '2014-03-01 00:20:09.000000', 'consum', 0.0220, 'lps'),
	(570663, 131, '2014-03-01 00:20:10.000000', 'consum', 0.0214, 'lps'),
	(570664, 131, '2014-03-01 00:20:11.000000', 'consum', 0.0217, 'lps'),
	(570665, 131, '2014-03-01 00:20:12.000000', 'consum', 0.0215, 'lps'),
	(570666, 131, '2014-03-01 00:20:13.000000', 'consum', 0.0214, 'lps'),
	(570667, 131, '2014-03-01 00:20:14.000000', 'consum', 0.0215, 'lps'),
	(570668, 131, '2014-03-01 00:20:15.000000', 'consum', 0.0226, 'lps'),
	(570669, 131, '2014-03-01 00:20:16.000000', 'consum', 0.0221, 'lps'),
	(570670, 131, '2014-03-01 00:20:17.000000', 'consum', 0.0218, 'lps'),
	(570671, 131, '2014-03-01 00:20:18.000000', 'consum', 0.0215, 'lps'),
	(570672, 131, '2014-03-01 00:20:19.000000', 'consum', 0.0213, 'lps'),
	(570673, 131, '2014-03-01 00:20:20.000000', 'consum', 0.0227, 'lps'),
	(570674, 131, '2014-03-01 00:20:21.000000', 'consum', 0.0214, 'lps'),
	(570675, 131, '2014-03-01 00:20:22.000000', 'consum', 0.0217, 'lps'),
	(570676, 131, '2014-03-01 00:20:23.000000', 'consum', 0.0217, 'lps'),
	(570677, 131, '2014-03-01 00:20:24.000000', 'consum', 0.0222, 'lps'),
	(570678, 131, '2014-03-01 00:20:25.000000', 'consum', 0.0214, 'lps'),
	(570679, 131, '2014-03-01 00:20:26.000000', 'consum', 0.0211, 'lps'),
	(570680, 131, '2014-03-01 00:20:27.000000', 'consum', 0.0221, 'lps'),
	(570681, 131, '2014-03-01 00:20:28.000000', 'consum', 0.0210, 'lps'),
	(570682, 131, '2014-03-01 00:20:29.000000', 'consum', 0.0212, 'lps'),
	(570683, 131, '2014-03-01 00:20:30.000000', 'consum', 0.0222, 'lps'),
	(570684, 131, '2014-03-01 00:20:31.000000', 'consum', 0.0212, 'lps'),
	(570685, 131, '2014-03-01 00:20:32.000000', 'consum', 0.0217, 'lps'),
	(570686, 131, '2014-03-01 00:20:33.000000', 'consum', 0.0223, 'lps'),
	(570687, 131, '2014-03-01 00:20:34.000000', 'consum', 0.0220, 'lps'),
	(570688, 131, '2014-03-01 00:20:35.000000', 'consum', 0.0222, 'lps'),
	(570689, 131, '2014-03-01 00:20:36.000000', 'consum', 0.0220, 'lps'),
	(570690, 131, '2014-03-01 00:20:37.000000', 'consum', 0.0224, 'lps'),
	(570691, 131, '2014-03-01 00:20:38.000000', 'consum', 0.0213, 'lps'),
	(570692, 131, '2014-03-01 00:20:39.000000', 'consum', 0.0223, 'lps'),
	(570693, 131, '2014-03-01 00:20:40.000000', 'consum', 0.0212, 'lps'),
	(570694, 131, '2014-03-01 00:20:41.000000', 'consum', 0.0218, 'lps'),
	(570695, 131, '2014-03-01 00:20:42.000000', 'consum', 0.0226, 'lps'),
	(570696, 131, '2014-03-01 00:20:43.000000', 'consum', 0.0211, 'lps'),
	(570697, 131, '2014-03-01 00:20:44.000000', 'consum', 0.0223, 'lps'),
	(570698, 131, '2014-03-01 00:20:45.000000', 'consum', 0.0217, 'lps'),
	(570699, 131, '2014-03-01 00:20:46.000000', 'consum', 0.0227, 'lps'),
	(570700, 131, '2014-03-01 00:20:47.000000', 'consum', 0.0217, 'lps'),
	(570701, 131, '2014-03-01 00:20:48.000000', 'consum', 0.0216, 'lps'),
	(570702, 131, '2014-03-01 00:20:49.000000', 'consum', 0.0218, 'lps'),
	(570703, 131, '2014-03-01 00:20:50.000000', 'consum', 0.0214, 'lps'),
	(570704, 131, '2014-03-01 00:20:51.000000', 'consum', 0.0225, 'lps'),
	(570705, 131, '2014-03-01 00:20:52.000000', 'consum', 0.0218, 'lps'),
	(570706, 131, '2014-03-01 00:20:53.000000', 'consum', 0.0226, 'lps'),
	(570707, 131, '2014-03-01 00:20:54.000000', 'consum', 0.0227, 'lps'),
	(570708, 131, '2014-03-01 00:20:55.000000', 'consum', 0.0215, 'lps'),
	(570709, 131, '2014-03-01 00:20:56.000000', 'consum', 0.0218, 'lps'),
	(570710, 131, '2014-03-01 00:20:57.000000', 'consum', 0.0220, 'lps'),
	(570711, 131, '2014-03-01 00:20:58.000000', 'consum', 0.0219, 'lps'),
	(570712, 131, '2014-03-01 00:20:59.000000', 'consum', 0.0223, 'lps'),
	(570713, 131, '2014-03-01 00:21:00.000000', 'consum', 0.0213, 'lps'),
	(570714, 131, '2014-03-01 00:21:01.000000', 'consum', 0.0221, 'lps'),
	(570715, 131, '2014-03-01 00:21:02.000000', 'consum', 0.0221, 'lps'),
	(570716, 131, '2014-03-01 00:21:03.000000', 'consum', 0.0214, 'lps'),
	(570717, 131, '2014-03-01 00:21:04.000000', 'consum', 0.0217, 'lps'),
	(570718, 131, '2014-03-01 00:21:05.000000', 'consum', 0.0217, 'lps'),
	(570719, 131, '2014-03-01 00:21:06.000000', 'consum', 0.0223, 'lps'),
	(570720, 131, '2014-03-01 00:21:07.000000', 'consum', 0.0218, 'lps'),
	(570721, 131, '2014-03-01 00:21:08.000000', 'consum', 0.0213, 'lps'),
	(570722, 131, '2014-03-01 00:21:09.000000', 'consum', 0.0220, 'lps'),
	(570723, 131, '2014-03-01 00:21:10.000000', 'consum', 0.0215, 'lps'),
	(570724, 131, '2014-03-01 00:21:11.000000', 'consum', 0.0225, 'lps'),
	(570725, 131, '2014-03-01 00:21:12.000000', 'consum', 0.0214, 'lps'),
	(570726, 131, '2014-03-01 00:21:13.000000', 'consum', 0.0222, 'lps'),
	(570727, 131, '2014-03-01 00:21:14.000000', 'consum', 0.0221, 'lps'),
	(570728, 131, '2014-03-01 00:21:15.000000', 'consum', 0.0212, 'lps'),
	(570729, 131, '2014-03-01 00:21:16.000000', 'consum', 0.0225, 'lps'),
	(570730, 131, '2014-03-01 00:21:17.000000', 'consum', 0.0225, 'lps'),
	(570731, 131, '2014-03-01 00:21:18.000000', 'consum', 0.0223, 'lps'),
	(570732, 131, '2014-03-01 00:21:19.000000', 'consum', 0.0210, 'lps'),
	(570733, 131, '2014-03-01 00:21:20.000000', 'consum', 0.0227, 'lps'),
	(570734, 131, '2014-03-01 00:21:21.000000', 'consum', 0.0222, 'lps'),
	(570735, 131, '2014-03-01 00:21:22.000000', 'consum', 0.0221, 'lps'),
	(570736, 131, '2014-03-01 00:21:23.000000', 'consum', 0.0213, 'lps'),
	(570737, 131, '2014-03-01 00:21:24.000000', 'consum', 0.0227, 'lps'),
	(570738, 131, '2014-03-01 00:21:25.000000', 'consum', 0.0213, 'lps'),
	(570739, 131, '2014-03-01 00:21:26.000000', 'consum', 0.0211, 'lps'),
	(570740, 131, '2014-03-01 00:21:27.000000', 'consum', 0.0227, 'lps'),
	(570741, 131, '2014-03-01 00:21:28.000000', 'consum', 0.0219, 'lps'),
	(570742, 131, '2014-03-01 00:21:29.000000', 'consum', 0.0223, 'lps'),
	(570743, 131, '2014-03-01 00:21:30.000000', 'consum', 0.0213, 'lps'),
	(570744, 131, '2014-03-01 00:21:31.000000', 'consum', 0.0220, 'lps'),
	(570745, 131, '2014-03-01 00:21:32.000000', 'consum', 0.0217, 'lps'),
	(570746, 131, '2014-03-01 00:21:33.000000', 'consum', 0.0216, 'lps'),
	(570747, 131, '2014-03-01 00:21:34.000000', 'consum', 0.0221, 'lps'),
	(570748, 131, '2014-03-01 00:21:35.000000', 'consum', 0.0211, 'lps'),
	(570749, 131, '2014-03-01 00:21:36.000000', 'consum', 0.0216, 'lps'),
	(570750, 131, '2014-03-01 00:21:37.000000', 'consum', 0.0221, 'lps'),
	(570751, 131, '2014-03-01 00:21:38.000000', 'consum', 0.0211, 'lps'),
	(570752, 131, '2014-03-01 00:21:39.000000', 'consum', 0.0218, 'lps'),
	(570753, 131, '2014-03-01 00:21:40.000000', 'consum', 0.0213, 'lps'),
	(570754, 131, '2014-03-01 00:21:41.000000', 'consum', 0.0217, 'lps'),
	(570755, 131, '2014-03-01 00:21:42.000000', 'consum', 0.0219, 'lps'),
	(570756, 131, '2014-03-01 00:21:43.000000', 'consum', 0.0218, 'lps'),
	(570757, 131, '2014-03-01 00:21:44.000000', 'consum', 0.0221, 'lps'),
	(570758, 131, '2014-03-01 00:21:45.000000', 'consum', 0.0224, 'lps'),
	(570759, 131, '2014-03-01 00:21:46.000000', 'consum', 0.0214, 'lps'),
	(570760, 131, '2014-03-01 00:21:47.000000', 'consum', 0.0223, 'lps'),
	(570761, 131, '2014-03-01 00:21:48.000000', 'consum', 0.0210, 'lps'),
	(570762, 131, '2014-03-01 00:21:49.000000', 'consum', 0.0227, 'lps'),
	(570763, 131, '2014-03-01 00:21:50.000000', 'consum', 0.0222, 'lps'),
	(570764, 131, '2014-03-01 00:21:51.000000', 'consum', 0.0220, 'lps'),
	(570765, 131, '2014-03-01 00:21:52.000000', 'consum', 0.0223, 'lps'),
	(570766, 131, '2014-03-01 00:21:53.000000', 'consum', 0.0210, 'lps'),
	(570767, 131, '2014-03-01 00:21:54.000000', 'consum', 0.0227, 'lps'),
	(570768, 131, '2014-03-01 00:21:55.000000', 'consum', 0.0222, 'lps'),
	(570769, 131, '2014-03-01 00:21:56.000000', 'consum', 0.0221, 'lps'),
	(570770, 131, '2014-03-01 00:21:57.000000', 'consum', 0.0227, 'lps'),
	(570771, 131, '2014-03-01 00:21:58.000000', 'consum', 0.0211, 'lps'),
	(570772, 131, '2014-03-01 00:21:59.000000', 'consum', 0.0217, 'lps'),
	(570773, 131, '2014-03-01 00:22:00.000000', 'consum', 0.0224, 'lps'),
	(570774, 131, '2014-03-01 00:22:01.000000', 'consum', 0.0226, 'lps'),
	(570775, 131, '2014-03-01 00:22:02.000000', 'consum', 0.0227, 'lps'),
	(570776, 131, '2014-03-01 00:22:03.000000', 'consum', 0.0214, 'lps'),
	(570777, 131, '2014-03-01 00:22:04.000000', 'consum', 0.0213, 'lps'),
	(570778, 131, '2014-03-01 00:22:05.000000', 'consum', 0.0216, 'lps'),
	(570779, 131, '2014-03-01 00:22:06.000000', 'consum', 0.0211, 'lps'),
	(570780, 131, '2014-03-01 00:22:07.000000', 'consum', 0.0217, 'lps'),
	(570781, 131, '2014-03-01 00:22:08.000000', 'consum', 0.0225, 'lps'),
	(570782, 131, '2014-03-01 00:22:09.000000', 'consum', 0.0227, 'lps'),
	(570783, 131, '2014-03-01 00:22:10.000000', 'consum', 0.0215, 'lps'),
	(570784, 131, '2014-03-01 00:22:11.000000', 'consum', 0.0222, 'lps'),
	(570785, 131, '2014-03-01 00:22:12.000000', 'consum', 0.0216, 'lps'),
	(570786, 131, '2014-03-01 00:22:13.000000', 'consum', 0.0226, 'lps'),
	(570787, 131, '2014-03-01 00:22:14.000000', 'consum', 0.0217, 'lps'),
	(570788, 131, '2014-03-01 00:22:15.000000', 'consum', 0.0216, 'lps'),
	(570789, 131, '2014-03-01 00:22:16.000000', 'consum', 0.0221, 'lps'),
	(570790, 131, '2014-03-01 00:22:17.000000', 'consum', 0.0212, 'lps'),
	(570791, 131, '2014-03-01 00:22:18.000000', 'consum', 0.0221, 'lps'),
	(570792, 131, '2014-03-01 00:22:19.000000', 'consum', 0.0225, 'lps'),
	(570793, 131, '2014-03-01 00:22:20.000000', 'consum', 0.0218, 'lps'),
	(570794, 131, '2014-03-01 00:22:21.000000', 'consum', 0.0222, 'lps'),
	(570795, 131, '2014-03-01 00:22:22.000000', 'consum', 0.0210, 'lps'),
	(570796, 131, '2014-03-01 00:22:23.000000', 'consum', 0.0212, 'lps'),
	(570797, 131, '2014-03-01 00:22:24.000000', 'consum', 0.0221, 'lps'),
	(570798, 131, '2014-03-01 00:22:25.000000', 'consum', 0.0223, 'lps'),
	(570799, 131, '2014-03-01 00:22:26.000000', 'consum', 0.0225, 'lps'),
	(570800, 131, '2014-03-01 00:22:27.000000', 'consum', 0.0212, 'lps'),
	(570801, 131, '2014-03-01 00:22:28.000000', 'consum', 0.0227, 'lps'),
	(570802, 131, '2014-03-01 00:22:29.000000', 'consum', 0.0219, 'lps'),
	(570803, 131, '2014-03-01 00:22:30.000000', 'consum', 0.0223, 'lps'),
	(570804, 131, '2014-03-01 00:22:31.000000', 'consum', 0.0212, 'lps'),
	(570805, 131, '2014-03-01 00:22:32.000000', 'consum', 0.0217, 'lps'),
	(570806, 131, '2014-03-01 00:22:33.000000', 'consum', 0.0220, 'lps'),
	(570807, 131, '2014-03-01 00:22:34.000000', 'consum', 0.0221, 'lps'),
	(570808, 131, '2014-03-01 00:22:35.000000', 'consum', 0.0219, 'lps'),
	(570809, 131, '2014-03-01 00:22:36.000000', 'consum', 0.0221, 'lps'),
	(570810, 131, '2014-03-01 00:22:37.000000', 'consum', 0.0222, 'lps'),
	(570811, 131, '2014-03-01 00:22:38.000000', 'consum', 0.0219, 'lps'),
	(570812, 131, '2014-03-01 00:22:39.000000', 'consum', 0.0218, 'lps'),
	(570813, 131, '2014-03-01 00:22:40.000000', 'consum', 0.0223, 'lps'),
	(570814, 131, '2014-03-01 00:22:41.000000', 'consum', 0.0216, 'lps'),
	(570815, 131, '2014-03-01 00:22:42.000000', 'consum', 0.0222, 'lps'),
	(570816, 131, '2014-03-01 00:22:43.000000', 'consum', 0.0214, 'lps'),
	(570817, 131, '2014-03-01 00:22:44.000000', 'consum', 0.0215, 'lps'),
	(570818, 131, '2014-03-01 00:22:45.000000', 'consum', 0.0222, 'lps'),
	(570819, 131, '2014-03-01 00:22:46.000000', 'consum', 0.0218, 'lps'),
	(570820, 131, '2014-03-01 00:22:47.000000', 'consum', 0.0215, 'lps'),
	(570821, 131, '2014-03-01 00:22:48.000000', 'consum', 0.0213, 'lps'),
	(570822, 131, '2014-03-01 00:22:49.000000', 'consum', 0.0227, 'lps'),
	(570823, 131, '2014-03-01 00:22:50.000000', 'consum', 0.0214, 'lps'),
	(570824, 131, '2014-03-01 00:22:51.000000', 'consum', 0.0216, 'lps'),
	(570825, 131, '2014-03-01 00:22:52.000000', 'consum', 0.0211, 'lps'),
	(570826, 131, '2014-03-01 00:22:53.000000', 'consum', 0.0216, 'lps'),
	(570827, 131, '2014-03-01 00:22:54.000000', 'consum', 0.0219, 'lps'),
	(570828, 131, '2014-03-01 00:22:55.000000', 'consum', 0.0221, 'lps'),
	(570829, 131, '2014-03-01 00:22:56.000000', 'consum', 0.0220, 'lps'),
	(570830, 131, '2014-03-01 00:22:57.000000', 'consum', 0.0211, 'lps'),
	(570831, 131, '2014-03-01 00:22:58.000000', 'consum', 0.0219, 'lps'),
	(570832, 131, '2014-03-01 00:22:59.000000', 'consum', 0.0218, 'lps'),
	(570833, 131, '2014-03-01 00:23:00.000000', 'consum', 0.0223, 'lps'),
	(570834, 131, '2014-03-01 00:23:01.000000', 'consum', 0.0217, 'lps'),
	(570835, 131, '2014-03-01 00:23:02.000000', 'consum', 0.0223, 'lps'),
	(570836, 131, '2014-03-01 00:23:03.000000', 'consum', 0.0218, 'lps'),
	(570837, 131, '2014-03-01 00:23:04.000000', 'consum', 0.0213, 'lps'),
	(570838, 131, '2014-03-01 00:23:05.000000', 'consum', 0.0221, 'lps'),
	(570839, 131, '2014-03-01 00:23:06.000000', 'consum', 0.0217, 'lps'),
	(570840, 131, '2014-03-01 00:23:07.000000', 'consum', 0.0214, 'lps'),
	(570841, 131, '2014-03-01 00:23:08.000000', 'consum', 0.0210, 'lps'),
	(570842, 131, '2014-03-01 00:23:09.000000', 'consum', 0.0216, 'lps'),
	(570843, 131, '2014-03-01 00:23:10.000000', 'consum', 0.0224, 'lps'),
	(570844, 131, '2014-03-01 00:23:11.000000', 'consum', 0.0226, 'lps'),
	(570845, 131, '2014-03-01 00:23:12.000000', 'consum', 0.0214, 'lps'),
	(570846, 131, '2014-03-01 00:23:13.000000', 'consum', 0.0217, 'lps'),
	(570847, 131, '2014-03-01 00:23:14.000000', 'consum', 0.0218, 'lps'),
	(570848, 131, '2014-03-01 00:23:15.000000', 'consum', 0.0227, 'lps'),
	(570849, 131, '2014-03-01 00:23:16.000000', 'consum', 0.0216, 'lps'),
	(570850, 131, '2014-03-01 00:23:17.000000', 'consum', 0.0210, 'lps'),
	(570851, 131, '2014-03-01 00:23:18.000000', 'consum', 0.0210, 'lps'),
	(570852, 131, '2014-03-01 00:23:19.000000', 'consum', 0.0227, 'lps'),
	(570853, 131, '2014-03-01 00:23:20.000000', 'consum', 0.0224, 'lps'),
	(570854, 131, '2014-03-01 00:23:21.000000', 'consum', 0.0210, 'lps'),
	(570855, 131, '2014-03-01 00:23:22.000000', 'consum', 0.0223, 'lps'),
	(570856, 131, '2014-03-01 00:23:23.000000', 'consum', 0.0221, 'lps'),
	(570857, 131, '2014-03-01 00:23:24.000000', 'consum', 0.0226, 'lps'),
	(570858, 131, '2014-03-01 00:23:25.000000', 'consum', 0.0222, 'lps'),
	(570859, 131, '2014-03-01 00:23:26.000000', 'consum', 0.0222, 'lps'),
	(570860, 131, '2014-03-01 00:23:27.000000', 'consum', 0.0217, 'lps'),
	(570861, 131, '2014-03-01 00:23:28.000000', 'consum', 0.0226, 'lps'),
	(570862, 131, '2014-03-01 00:23:29.000000', 'consum', 0.0216, 'lps'),
	(570863, 131, '2014-03-01 00:23:30.000000', 'consum', 0.0210, 'lps'),
	(570864, 131, '2014-03-01 00:23:31.000000', 'consum', 0.0211, 'lps'),
	(570865, 131, '2014-03-01 00:23:32.000000', 'consum', 0.0216, 'lps'),
	(570866, 131, '2014-03-01 00:23:33.000000', 'consum', 0.0220, 'lps'),
	(570867, 131, '2014-03-01 00:23:34.000000', 'consum', 0.0223, 'lps'),
	(570868, 131, '2014-03-01 00:23:35.000000', 'consum', 0.0210, 'lps'),
	(570869, 131, '2014-03-01 00:23:36.000000', 'consum', 0.0226, 'lps'),
	(570870, 131, '2014-03-01 00:23:37.000000', 'consum', 0.0217, 'lps'),
	(570871, 131, '2014-03-01 00:23:38.000000', 'consum', 0.0218, 'lps'),
	(570872, 131, '2014-03-01 00:23:39.000000', 'consum', 0.0227, 'lps'),
	(570873, 131, '2014-03-01 00:23:40.000000', 'consum', 0.0218, 'lps'),
	(570874, 131, '2014-03-01 00:23:41.000000', 'consum', 0.0220, 'lps'),
	(570875, 131, '2014-03-01 00:23:42.000000', 'consum', 0.0215, 'lps'),
	(570876, 131, '2014-03-01 00:23:43.000000', 'consum', 0.0225, 'lps'),
	(570877, 131, '2014-03-01 00:23:44.000000', 'consum', 0.0217, 'lps'),
	(570878, 131, '2014-03-01 00:23:45.000000', 'consum', 0.0216, 'lps'),
	(570879, 131, '2014-03-01 00:23:46.000000', 'consum', 0.0223, 'lps'),
	(570880, 131, '2014-03-01 00:23:47.000000', 'consum', 0.0218, 'lps'),
	(570881, 131, '2014-03-01 00:23:48.000000', 'consum', 0.0214, 'lps'),
	(570882, 131, '2014-03-01 00:23:49.000000', 'consum', 0.0223, 'lps'),
	(570883, 131, '2014-03-01 00:23:50.000000', 'consum', 0.0211, 'lps'),
	(570884, 131, '2014-03-01 00:23:51.000000', 'consum', 0.0213, 'lps'),
	(570885, 131, '2014-03-01 00:23:52.000000', 'consum', 0.0220, 'lps'),
	(570886, 131, '2014-03-01 00:23:53.000000', 'consum', 0.0218, 'lps'),
	(570887, 131, '2014-03-01 00:23:54.000000', 'consum', 0.0219, 'lps'),
	(570888, 131, '2014-03-01 00:23:55.000000', 'consum', 0.0215, 'lps'),
	(570889, 131, '2014-03-01 00:23:56.000000', 'consum', 0.0227, 'lps'),
	(570890, 131, '2014-03-01 00:23:57.000000', 'consum', 0.0225, 'lps'),
	(570891, 131, '2014-03-01 00:23:58.000000', 'consum', 0.0216, 'lps'),
	(570892, 131, '2014-03-01 00:23:59.000000', 'consum', 0.0212, 'lps'),
	(570893, 131, '2014-03-01 00:24:00.000000', 'consum', 0.0224, 'lps'),
	(570894, 131, '2014-03-01 00:24:01.000000', 'consum', 0.0219, 'lps'),
	(570895, 131, '2014-03-01 00:24:02.000000', 'consum', 0.0212, 'lps'),
	(570896, 131, '2014-03-01 00:24:03.000000', 'consum', 0.0212, 'lps'),
	(570897, 131, '2014-03-01 00:24:04.000000', 'consum', 0.0215, 'lps'),
	(570898, 131, '2014-03-01 00:24:05.000000', 'consum', 0.0210, 'lps'),
	(570899, 131, '2014-03-01 00:24:06.000000', 'consum', 0.0213, 'lps'),
	(570900, 131, '2014-03-01 00:24:07.000000', 'consum', 0.0225, 'lps'),
	(570901, 131, '2014-03-01 00:24:08.000000', 'consum', 0.0223, 'lps'),
	(570902, 131, '2014-03-01 00:24:09.000000', 'consum', 0.0211, 'lps'),
	(570903, 131, '2014-03-01 00:24:10.000000', 'consum', 0.0215, 'lps'),
	(570904, 131, '2014-03-01 00:24:11.000000', 'consum', 0.0215, 'lps'),
	(570905, 131, '2014-03-01 00:24:12.000000', 'consum', 0.0219, 'lps'),
	(570906, 131, '2014-03-01 00:24:13.000000', 'consum', 0.0224, 'lps'),
	(570907, 131, '2014-03-01 00:24:14.000000', 'consum', 0.0217, 'lps'),
	(570908, 131, '2014-03-01 00:24:15.000000', 'consum', 0.0219, 'lps'),
	(570909, 131, '2014-03-01 00:24:16.000000', 'consum', 0.0220, 'lps'),
	(570910, 131, '2014-03-01 00:24:17.000000', 'consum', 0.0215, 'lps'),
	(570911, 131, '2014-03-01 00:24:18.000000', 'consum', 0.0221, 'lps'),
	(570912, 131, '2014-03-01 00:24:19.000000', 'consum', 0.0217, 'lps'),
	(570913, 131, '2014-03-01 00:24:20.000000', 'consum', 0.0214, 'lps'),
	(570914, 131, '2014-03-01 00:24:21.000000', 'consum', 0.0224, 'lps'),
	(570915, 131, '2014-03-01 00:24:22.000000', 'consum', 0.0218, 'lps'),
	(570916, 131, '2014-03-01 00:24:23.000000', 'consum', 0.0224, 'lps'),
	(570917, 131, '2014-03-01 00:24:24.000000', 'consum', 0.0223, 'lps'),
	(570918, 131, '2014-03-01 00:24:25.000000', 'consum', 0.0214, 'lps'),
	(570919, 131, '2014-03-01 00:24:26.000000', 'consum', 0.0227, 'lps'),
	(570920, 131, '2014-03-01 00:24:27.000000', 'consum', 0.0211, 'lps'),
	(570921, 131, '2014-03-01 00:24:28.000000', 'consum', 0.0221, 'lps'),
	(570922, 131, '2014-03-01 00:24:29.000000', 'consum', 0.0223, 'lps'),
	(570923, 131, '2014-03-01 00:24:30.000000', 'consum', 0.0210, 'lps'),
	(570924, 131, '2014-03-01 00:24:31.000000', 'consum', 0.0223, 'lps'),
	(570925, 131, '2014-03-01 00:24:32.000000', 'consum', 0.0224, 'lps'),
	(570926, 131, '2014-03-01 00:24:33.000000', 'consum', 0.0221, 'lps'),
	(570927, 131, '2014-03-01 00:24:34.000000', 'consum', 0.0226, 'lps'),
	(570928, 131, '2014-03-01 00:24:35.000000', 'consum', 0.0220, 'lps'),
	(570929, 131, '2014-03-01 00:24:36.000000', 'consum', 0.0211, 'lps'),
	(570930, 131, '2014-03-01 00:24:37.000000', 'consum', 0.0225, 'lps'),
	(570931, 131, '2014-03-01 00:24:38.000000', 'consum', 0.0226, 'lps'),
	(570932, 131, '2014-03-01 00:24:39.000000', 'consum', 0.0211, 'lps'),
	(570933, 131, '2014-03-01 00:24:40.000000', 'consum', 0.0222, 'lps'),
	(570934, 131, '2014-03-01 00:24:41.000000', 'consum', 0.0214, 'lps'),
	(570935, 131, '2014-03-01 00:24:42.000000', 'consum', 0.0211, 'lps'),
	(570936, 131, '2014-03-01 00:24:43.000000', 'consum', 0.0221, 'lps'),
	(570937, 131, '2014-03-01 00:24:44.000000', 'consum', 0.0210, 'lps'),
	(570938, 131, '2014-03-01 00:24:45.000000', 'consum', 0.0214, 'lps'),
	(570939, 131, '2014-03-01 00:24:46.000000', 'consum', 0.0214, 'lps'),
	(570940, 131, '2014-03-01 00:24:47.000000', 'consum', 0.0216, 'lps'),
	(570941, 131, '2014-03-01 00:24:48.000000', 'consum', 0.0213, 'lps'),
	(570942, 131, '2014-03-01 00:24:49.000000', 'consum', 0.0224, 'lps'),
	(570943, 131, '2014-03-01 00:24:50.000000', 'consum', 0.0218, 'lps'),
	(570944, 131, '2014-03-01 00:24:51.000000', 'consum', 0.0226, 'lps'),
	(570945, 131, '2014-03-01 00:24:52.000000', 'consum', 0.0213, 'lps'),
	(570946, 131, '2014-03-01 00:24:53.000000', 'consum', 0.0213, 'lps'),
	(570947, 131, '2014-03-01 00:24:54.000000', 'consum', 0.0218, 'lps'),
	(570948, 131, '2014-03-01 00:24:55.000000', 'consum', 0.0221, 'lps'),
	(570949, 131, '2014-03-01 00:24:56.000000', 'consum', 0.0226, 'lps'),
	(570950, 131, '2014-03-01 00:24:57.000000', 'consum', 0.0219, 'lps'),
	(570951, 131, '2014-03-01 00:24:58.000000', 'consum', 0.0225, 'lps'),
	(570952, 131, '2014-03-01 00:24:59.000000', 'consum', 0.0226, 'lps'),
	(570953, 131, '2014-03-01 00:25:00.000000', 'consum', 0.0224, 'lps'),
	(570954, 131, '2014-03-01 00:25:01.000000', 'consum', 0.0215, 'lps'),
	(570955, 131, '2014-03-01 00:25:02.000000', 'consum', 0.0212, 'lps'),
	(570956, 131, '2014-03-01 00:25:03.000000', 'consum', 0.0225, 'lps'),
	(570957, 131, '2014-03-01 00:25:04.000000', 'consum', 0.0223, 'lps'),
	(570958, 131, '2014-03-01 00:25:05.000000', 'consum', 0.0213, 'lps'),
	(570959, 131, '2014-03-01 00:25:06.000000', 'consum', 0.0222, 'lps'),
	(570960, 131, '2014-03-01 00:25:07.000000', 'consum', 0.0226, 'lps'),
	(570961, 131, '2014-03-01 00:25:08.000000', 'consum', 0.0216, 'lps'),
	(570962, 131, '2014-03-01 00:25:09.000000', 'consum', 0.0214, 'lps'),
	(570963, 131, '2014-03-01 00:25:10.000000', 'consum', 0.0212, 'lps'),
	(570964, 131, '2014-03-01 00:25:11.000000', 'consum', 0.0226, 'lps'),
	(570965, 131, '2014-03-01 00:25:12.000000', 'consum', 0.0213, 'lps'),
	(570966, 131, '2014-03-01 00:25:13.000000', 'consum', 0.0215, 'lps'),
	(570967, 131, '2014-03-01 00:25:14.000000', 'consum', 0.0224, 'lps'),
	(570968, 131, '2014-03-01 00:25:15.000000', 'consum', 0.0211, 'lps'),
	(570969, 131, '2014-03-01 00:25:16.000000', 'consum', 0.0227, 'lps'),
	(570970, 131, '2014-03-01 00:25:17.000000', 'consum', 0.0222, 'lps'),
	(570971, 131, '2014-03-01 00:25:18.000000', 'consum', 0.0221, 'lps'),
	(570972, 131, '2014-03-01 00:25:19.000000', 'consum', 0.0210, 'lps'),
	(570973, 131, '2014-03-01 00:25:20.000000', 'consum', 0.0214, 'lps'),
	(570974, 131, '2014-03-01 00:25:21.000000', 'consum', 0.0211, 'lps'),
	(570975, 131, '2014-03-01 00:25:22.000000', 'consum', 0.0223, 'lps'),
	(570976, 131, '2014-03-01 00:25:23.000000', 'consum', 0.0217, 'lps'),
	(570977, 131, '2014-03-01 00:25:24.000000', 'consum', 0.0224, 'lps'),
	(570978, 131, '2014-03-01 00:25:25.000000', 'consum', 0.0226, 'lps'),
	(570979, 131, '2014-03-01 00:25:26.000000', 'consum', 0.0213, 'lps'),
	(570980, 131, '2014-03-01 00:25:27.000000', 'consum', 0.0214, 'lps'),
	(570981, 131, '2014-03-01 00:25:28.000000', 'consum', 0.0219, 'lps'),
	(570982, 131, '2014-03-01 00:25:29.000000', 'consum', 0.0210, 'lps'),
	(570983, 131, '2014-03-01 00:25:30.000000', 'consum', 0.0220, 'lps'),
	(570984, 131, '2014-03-01 00:25:31.000000', 'consum', 0.0224, 'lps'),
	(570985, 131, '2014-03-01 00:25:32.000000', 'consum', 0.0215, 'lps'),
	(570986, 131, '2014-03-01 00:25:33.000000', 'consum', 0.0211, 'lps'),
	(570987, 131, '2014-03-01 00:25:34.000000', 'consum', 0.0217, 'lps'),
	(570988, 131, '2014-03-01 00:25:35.000000', 'consum', 0.0225, 'lps'),
	(570989, 131, '2014-03-01 00:25:36.000000', 'consum', 0.0210, 'lps'),
	(570990, 131, '2014-03-01 00:25:37.000000', 'consum', 0.0220, 'lps'),
	(570991, 131, '2014-03-01 00:25:38.000000', 'consum', 0.0226, 'lps'),
	(570992, 131, '2014-03-01 00:25:39.000000', 'consum', 0.0226, 'lps'),
	(570993, 131, '2014-03-01 00:25:40.000000', 'consum', 0.0221, 'lps'),
	(570994, 131, '2014-03-01 00:25:41.000000', 'consum', 0.0218, 'lps'),
	(570995, 131, '2014-03-01 00:25:42.000000', 'consum', 0.0218, 'lps'),
	(570996, 131, '2014-03-01 00:25:43.000000', 'consum', 0.0210, 'lps'),
	(570997, 131, '2014-03-01 00:25:44.000000', 'consum', 0.0222, 'lps'),
	(570998, 131, '2014-03-01 00:25:45.000000', 'consum', 0.0217, 'lps'),
	(570999, 131, '2014-03-01 00:25:46.000000', 'consum', 0.0225, 'lps'),
	(571000, 131, '2014-03-01 00:25:47.000000', 'consum', 0.0211, 'lps'),
	(571001, 131, '2014-03-01 00:25:48.000000', 'consum', 0.0224, 'lps'),
	(571002, 131, '2014-03-01 00:25:49.000000', 'consum', 0.0226, 'lps'),
	(571003, 131, '2014-03-01 00:25:50.000000', 'consum', 0.0210, 'lps'),
	(571004, 131, '2014-03-01 00:25:51.000000', 'consum', 0.0217, 'lps'),
	(571005, 131, '2014-03-01 00:25:52.000000', 'consum', 0.0226, 'lps'),
	(571006, 131, '2014-03-01 00:25:53.000000', 'consum', 0.0216, 'lps'),
	(571007, 131, '2014-03-01 00:25:54.000000', 'consum', 0.0212, 'lps'),
	(571008, 131, '2014-03-01 00:25:55.000000', 'consum', 0.0221, 'lps'),
	(571009, 131, '2014-03-01 00:25:56.000000', 'consum', 0.0223, 'lps'),
	(571010, 131, '2014-03-01 00:25:57.000000', 'consum', 0.0226, 'lps'),
	(571011, 131, '2014-03-01 00:25:58.000000', 'consum', 0.0213, 'lps'),
	(571012, 131, '2014-03-01 00:25:59.000000', 'consum', 0.0216, 'lps'),
	(571013, 131, '2014-03-01 00:26:00.000000', 'consum', 0.0213, 'lps'),
	(571014, 131, '2014-03-01 00:26:01.000000', 'consum', 0.0223, 'lps'),
	(571015, 131, '2014-03-01 00:26:02.000000', 'consum', 0.0216, 'lps'),
	(571016, 131, '2014-03-01 00:26:03.000000', 'consum', 0.0216, 'lps'),
	(571017, 131, '2014-03-01 00:26:04.000000', 'consum', 0.0224, 'lps'),
	(571018, 131, '2014-03-01 00:26:05.000000', 'consum', 0.0210, 'lps'),
	(571019, 131, '2014-03-01 00:26:06.000000', 'consum', 0.0222, 'lps'),
	(571020, 131, '2014-03-01 00:26:07.000000', 'consum', 0.0215, 'lps'),
	(571021, 131, '2014-03-01 00:26:08.000000', 'consum', 0.0216, 'lps'),
	(571022, 131, '2014-03-01 00:26:09.000000', 'consum', 0.0210, 'lps'),
	(571023, 131, '2014-03-01 00:26:10.000000', 'consum', 0.0211, 'lps'),
	(571024, 131, '2014-03-01 00:26:11.000000', 'consum', 0.0213, 'lps'),
	(571025, 131, '2014-03-01 00:26:12.000000', 'consum', 0.0223, 'lps'),
	(571026, 131, '2014-03-01 00:26:13.000000', 'consum', 0.0214, 'lps'),
	(571027, 131, '2014-03-01 00:26:14.000000', 'consum', 0.0227, 'lps'),
	(571028, 131, '2014-03-01 00:26:15.000000', 'consum', 0.0213, 'lps'),
	(571029, 131, '2014-03-01 00:26:16.000000', 'consum', 0.0225, 'lps'),
	(571030, 131, '2014-03-01 00:26:17.000000', 'consum', 0.0225, 'lps'),
	(571031, 131, '2014-03-01 00:26:18.000000', 'consum', 0.0224, 'lps'),
	(571032, 131, '2014-03-01 00:26:19.000000', 'consum', 0.0215, 'lps'),
	(571033, 131, '2014-03-01 00:26:20.000000', 'consum', 0.0213, 'lps'),
	(571034, 131, '2014-03-01 00:26:21.000000', 'consum', 0.0211, 'lps'),
	(571035, 131, '2014-03-01 00:26:22.000000', 'consum', 0.0226, 'lps'),
	(571036, 131, '2014-03-01 00:26:23.000000', 'consum', 0.0212, 'lps'),
	(571037, 131, '2014-03-01 00:26:24.000000', 'consum', 0.0227, 'lps'),
	(571038, 131, '2014-03-01 00:26:25.000000', 'consum', 0.0218, 'lps'),
	(571039, 131, '2014-03-01 00:26:26.000000', 'consum', 0.0218, 'lps'),
	(571040, 131, '2014-03-01 00:26:27.000000', 'consum', 0.0225, 'lps'),
	(571041, 131, '2014-03-01 00:26:28.000000', 'consum', 0.0225, 'lps'),
	(571042, 131, '2014-03-01 00:26:29.000000', 'consum', 0.0223, 'lps'),
	(571043, 131, '2014-03-01 00:26:30.000000', 'consum', 0.0215, 'lps'),
	(571044, 131, '2014-03-01 00:26:31.000000', 'consum', 0.0212, 'lps'),
	(571045, 131, '2014-03-01 00:26:32.000000', 'consum', 0.0226, 'lps'),
	(571046, 131, '2014-03-01 00:26:33.000000', 'consum', 0.0227, 'lps'),
	(571047, 131, '2014-03-01 00:26:34.000000', 'consum', 0.0215, 'lps'),
	(571048, 131, '2014-03-01 00:26:35.000000', 'consum', 0.0218, 'lps'),
	(571049, 131, '2014-03-01 00:26:36.000000', 'consum', 0.0220, 'lps'),
	(571050, 131, '2014-03-01 00:26:37.000000', 'consum', 0.0219, 'lps'),
	(571051, 131, '2014-03-01 00:26:38.000000', 'consum', 0.0224, 'lps'),
	(571052, 131, '2014-03-01 00:26:39.000000', 'consum', 0.0217, 'lps'),
	(571053, 131, '2014-03-01 00:26:40.000000', 'consum', 0.0223, 'lps'),
	(571054, 131, '2014-03-01 00:26:41.000000', 'consum', 0.0216, 'lps'),
	(571055, 131, '2014-03-01 00:26:42.000000', 'consum', 0.0220, 'lps'),
	(571056, 131, '2014-03-01 00:26:43.000000', 'consum', 0.0224, 'lps'),
	(571057, 131, '2014-03-01 00:26:44.000000', 'consum', 0.0214, 'lps'),
	(571058, 131, '2014-03-01 00:26:45.000000', 'consum', 0.0227, 'lps'),
	(571059, 131, '2014-03-01 00:26:46.000000', 'consum', 0.0227, 'lps'),
	(571060, 131, '2014-03-01 00:26:47.000000', 'consum', 0.0227, 'lps'),
	(571061, 131, '2014-03-01 00:26:48.000000', 'consum', 0.0226, 'lps'),
	(571062, 131, '2014-03-01 00:26:49.000000', 'consum', 0.0221, 'lps'),
	(571063, 131, '2014-03-01 00:26:50.000000', 'consum', 0.0219, 'lps'),
	(571064, 131, '2014-03-01 00:26:51.000000', 'consum', 0.0222, 'lps'),
	(571065, 131, '2014-03-01 00:26:52.000000', 'consum', 0.0225, 'lps'),
	(571066, 131, '2014-03-01 00:26:53.000000', 'consum', 0.0213, 'lps'),
	(571067, 131, '2014-03-01 00:26:54.000000', 'consum', 0.0218, 'lps'),
	(571068, 131, '2014-03-01 00:26:55.000000', 'consum', 0.0223, 'lps'),
	(571069, 131, '2014-03-01 00:26:56.000000', 'consum', 0.0215, 'lps'),
	(571070, 131, '2014-03-01 00:26:57.000000', 'consum', 0.0213, 'lps'),
	(571071, 131, '2014-03-01 00:26:58.000000', 'consum', 0.0214, 'lps'),
	(571072, 131, '2014-03-01 00:26:59.000000', 'consum', 0.0218, 'lps'),
	(571073, 131, '2014-03-01 00:27:00.000000', 'consum', 0.0222, 'lps'),
	(571074, 131, '2014-03-01 00:27:01.000000', 'consum', 0.0226, 'lps'),
	(571075, 131, '2014-03-01 00:27:02.000000', 'consum', 0.0222, 'lps'),
	(571076, 131, '2014-03-01 00:27:03.000000', 'consum', 0.0222, 'lps'),
	(571077, 131, '2014-03-01 00:27:04.000000', 'consum', 0.0216, 'lps'),
	(571078, 131, '2014-03-01 00:27:05.000000', 'consum', 0.0222, 'lps'),
	(571079, 131, '2014-03-01 00:27:06.000000', 'consum', 0.0216, 'lps'),
	(571080, 131, '2014-03-01 00:27:07.000000', 'consum', 0.0224, 'lps'),
	(571081, 131, '2014-03-01 00:27:08.000000', 'consum', 0.0227, 'lps'),
	(571082, 131, '2014-03-01 00:27:09.000000', 'consum', 0.0216, 'lps'),
	(571083, 131, '2014-03-01 00:27:10.000000', 'consum', 0.0226, 'lps'),
	(571084, 131, '2014-03-01 00:27:11.000000', 'consum', 0.0217, 'lps'),
	(571085, 131, '2014-03-01 00:27:12.000000', 'consum', 0.0215, 'lps'),
	(571086, 131, '2014-03-01 00:27:13.000000', 'consum', 0.0217, 'lps'),
	(571087, 131, '2014-03-01 00:27:14.000000', 'consum', 0.0210, 'lps'),
	(571088, 131, '2014-03-01 00:27:15.000000', 'consum', 0.0210, 'lps'),
	(571089, 131, '2014-03-01 00:27:16.000000', 'consum', 0.0227, 'lps'),
	(571090, 131, '2014-03-01 00:27:17.000000', 'consum', 0.0224, 'lps'),
	(571091, 131, '2014-03-01 00:27:18.000000', 'consum', 0.0212, 'lps'),
	(571092, 131, '2014-03-01 00:27:19.000000', 'consum', 0.0215, 'lps'),
	(571093, 131, '2014-03-01 00:27:20.000000', 'consum', 0.0211, 'lps'),
	(571094, 131, '2014-03-01 00:27:21.000000', 'consum', 0.0216, 'lps'),
	(571095, 131, '2014-03-01 00:27:22.000000', 'consum', 0.0223, 'lps'),
	(571096, 131, '2014-03-01 00:27:23.000000', 'consum', 0.0220, 'lps'),
	(571097, 131, '2014-03-01 00:27:24.000000', 'consum', 0.0220, 'lps'),
	(571098, 131, '2014-03-01 00:27:25.000000', 'consum', 0.0213, 'lps'),
	(571099, 131, '2014-03-01 00:27:26.000000', 'consum', 0.0212, 'lps'),
	(571100, 131, '2014-03-01 00:27:27.000000', 'consum', 0.0213, 'lps'),
	(571101, 131, '2014-03-01 00:27:28.000000', 'consum', 0.0222, 'lps'),
	(571102, 131, '2014-03-01 00:27:29.000000', 'consum', 0.0222, 'lps'),
	(571103, 131, '2014-03-01 00:27:30.000000', 'consum', 0.0217, 'lps'),
	(571104, 131, '2014-03-01 00:27:31.000000', 'consum', 0.0226, 'lps'),
	(571105, 131, '2014-03-01 00:27:32.000000', 'consum', 0.0218, 'lps'),
	(571106, 131, '2014-03-01 00:27:33.000000', 'consum', 0.0219, 'lps'),
	(571107, 131, '2014-03-01 00:27:34.000000', 'consum', 0.0213, 'lps'),
	(571108, 131, '2014-03-01 00:27:35.000000', 'consum', 0.0219, 'lps'),
	(571109, 131, '2014-03-01 00:27:36.000000', 'consum', 0.0227, 'lps'),
	(571110, 131, '2014-03-01 00:27:37.000000', 'consum', 0.0215, 'lps'),
	(571111, 131, '2014-03-01 00:27:38.000000', 'consum', 0.0222, 'lps'),
	(571112, 131, '2014-03-01 00:27:39.000000', 'consum', 0.0217, 'lps'),
	(571113, 131, '2014-03-01 00:27:40.000000', 'consum', 0.0210, 'lps'),
	(571114, 131, '2014-03-01 00:27:41.000000', 'consum', 0.0225, 'lps'),
	(571115, 131, '2014-03-01 00:27:42.000000', 'consum', 0.0215, 'lps'),
	(571116, 131, '2014-03-01 00:27:43.000000', 'consum', 0.0226, 'lps'),
	(571117, 131, '2014-03-01 00:27:44.000000', 'consum', 0.0223, 'lps'),
	(571118, 131, '2014-03-01 00:27:45.000000', 'consum', 0.0210, 'lps'),
	(571119, 131, '2014-03-01 00:27:46.000000', 'consum', 0.0224, 'lps'),
	(571120, 131, '2014-03-01 00:27:47.000000', 'consum', 0.0226, 'lps'),
	(571121, 131, '2014-03-01 00:27:48.000000', 'consum', 0.0212, 'lps'),
	(571122, 131, '2014-03-01 00:27:49.000000', 'consum', 0.0211, 'lps'),
	(571123, 131, '2014-03-01 00:27:50.000000', 'consum', 0.0226, 'lps'),
	(571124, 131, '2014-03-01 00:27:51.000000', 'consum', 0.0214, 'lps'),
	(571125, 131, '2014-03-01 00:27:52.000000', 'consum', 0.0220, 'lps'),
	(571126, 131, '2014-03-01 00:27:53.000000', 'consum', 0.0210, 'lps'),
	(571127, 131, '2014-03-01 00:27:54.000000', 'consum', 0.0219, 'lps'),
	(571128, 131, '2014-03-01 00:27:55.000000', 'consum', 0.0219, 'lps'),
	(571129, 131, '2014-03-01 00:27:56.000000', 'consum', 0.0211, 'lps'),
	(571130, 131, '2014-03-01 00:27:57.000000', 'consum', 0.0225, 'lps'),
	(571131, 131, '2014-03-01 00:27:58.000000', 'consum', 0.0211, 'lps'),
	(571132, 131, '2014-03-01 00:27:59.000000', 'consum', 0.0224, 'lps'),
	(571133, 131, '2014-03-01 00:28:00.000000', 'consum', 0.0222, 'lps'),
	(571134, 131, '2014-03-01 00:28:01.000000', 'consum', 0.0211, 'lps'),
	(571135, 131, '2014-03-01 00:28:02.000000', 'consum', 0.0214, 'lps'),
	(571136, 131, '2014-03-01 00:28:03.000000', 'consum', 0.0211, 'lps'),
	(571137, 131, '2014-03-01 00:28:04.000000', 'consum', 0.0222, 'lps'),
	(571138, 131, '2014-03-01 00:28:05.000000', 'consum', 0.0212, 'lps'),
	(571139, 131, '2014-03-01 00:28:06.000000', 'consum', 0.0219, 'lps'),
	(571140, 131, '2014-03-01 00:28:07.000000', 'consum', 0.0215, 'lps'),
	(571141, 131, '2014-03-01 00:28:08.000000', 'consum', 0.0210, 'lps'),
	(571142, 131, '2014-03-01 00:28:09.000000', 'consum', 0.0214, 'lps'),
	(571143, 131, '2014-03-01 00:28:10.000000', 'consum', 0.0213, 'lps'),
	(571144, 131, '2014-03-01 00:28:11.000000', 'consum', 0.0211, 'lps'),
	(571145, 131, '2014-03-01 00:28:12.000000', 'consum', 0.0224, 'lps'),
	(571146, 131, '2014-03-01 00:28:13.000000', 'consum', 0.0226, 'lps'),
	(571147, 131, '2014-03-01 00:28:14.000000', 'consum', 0.0210, 'lps'),
	(571148, 131, '2014-03-01 00:28:15.000000', 'consum', 0.0217, 'lps'),
	(571149, 131, '2014-03-01 00:28:16.000000', 'consum', 0.0211, 'lps'),
	(571150, 131, '2014-03-01 00:28:17.000000', 'consum', 0.0212, 'lps'),
	(571151, 131, '2014-03-01 00:28:18.000000', 'consum', 0.0217, 'lps'),
	(571152, 131, '2014-03-01 00:28:19.000000', 'consum', 0.0224, 'lps'),
	(571153, 131, '2014-03-01 00:28:20.000000', 'consum', 0.0220, 'lps'),
	(571154, 131, '2014-03-01 00:28:21.000000', 'consum', 0.0220, 'lps'),
	(571155, 131, '2014-03-01 00:28:22.000000', 'consum', 0.0211, 'lps'),
	(571156, 131, '2014-03-01 00:28:23.000000', 'consum', 0.0222, 'lps'),
	(571157, 131, '2014-03-01 00:28:24.000000', 'consum', 0.0215, 'lps'),
	(571158, 131, '2014-03-01 00:28:25.000000', 'consum', 0.0217, 'lps'),
	(571159, 131, '2014-03-01 00:28:26.000000', 'consum', 0.0214, 'lps'),
	(571160, 131, '2014-03-01 00:28:27.000000', 'consum', 0.0227, 'lps'),
	(571161, 131, '2014-03-01 00:28:28.000000', 'consum', 0.0210, 'lps'),
	(571162, 131, '2014-03-01 00:28:29.000000', 'consum', 0.0216, 'lps'),
	(571163, 131, '2014-03-01 00:28:30.000000', 'consum', 0.0221, 'lps'),
	(571164, 131, '2014-03-01 00:28:31.000000', 'consum', 0.0210, 'lps'),
	(571165, 131, '2014-03-01 00:28:32.000000', 'consum', 0.0213, 'lps'),
	(571166, 131, '2014-03-01 00:28:33.000000', 'consum', 0.0225, 'lps'),
	(571167, 131, '2014-03-01 00:28:34.000000', 'consum', 0.0226, 'lps'),
	(571168, 131, '2014-03-01 00:28:35.000000', 'consum', 0.0224, 'lps'),
	(571169, 131, '2014-03-01 00:28:36.000000', 'consum', 0.0216, 'lps'),
	(571170, 131, '2014-03-01 00:28:37.000000', 'consum', 0.0218, 'lps'),
	(571171, 131, '2014-03-01 00:28:38.000000', 'consum', 0.0212, 'lps'),
	(571172, 131, '2014-03-01 00:28:39.000000', 'consum', 0.0216, 'lps'),
	(571173, 131, '2014-03-01 00:28:40.000000', 'consum', 0.0216, 'lps'),
	(571174, 131, '2014-03-01 00:28:41.000000', 'consum', 0.0222, 'lps'),
	(571175, 131, '2014-03-01 00:28:42.000000', 'consum', 0.0218, 'lps'),
	(571176, 131, '2014-03-01 00:28:43.000000', 'consum', 0.0212, 'lps'),
	(571177, 131, '2014-03-01 00:28:44.000000', 'consum', 0.0218, 'lps'),
	(571178, 131, '2014-03-01 00:28:45.000000', 'consum', 0.0224, 'lps'),
	(571179, 131, '2014-03-01 00:28:46.000000', 'consum', 0.0220, 'lps'),
	(571180, 131, '2014-03-01 00:28:47.000000', 'consum', 0.0221, 'lps'),
	(571181, 131, '2014-03-01 00:28:48.000000', 'consum', 0.0215, 'lps'),
	(571182, 131, '2014-03-01 00:28:49.000000', 'consum', 0.0221, 'lps'),
	(571183, 131, '2014-03-01 00:28:50.000000', 'consum', 0.0214, 'lps'),
	(571184, 131, '2014-03-01 00:28:51.000000', 'consum', 0.0218, 'lps'),
	(571185, 131, '2014-03-01 00:28:52.000000', 'consum', 0.0217, 'lps'),
	(571186, 131, '2014-03-01 00:28:53.000000', 'consum', 0.0223, 'lps'),
	(571187, 131, '2014-03-01 00:28:54.000000', 'consum', 0.0219, 'lps'),
	(571188, 131, '2014-03-01 00:28:55.000000', 'consum', 0.0215, 'lps'),
	(571189, 131, '2014-03-01 00:28:56.000000', 'consum', 0.0226, 'lps'),
	(571190, 131, '2014-03-01 00:28:57.000000', 'consum', 0.0223, 'lps'),
	(571191, 131, '2014-03-01 00:28:58.000000', 'consum', 0.0226, 'lps'),
	(571192, 131, '2014-03-01 00:28:59.000000', 'consum', 0.0214, 'lps'),
	(571193, 131, '2014-03-01 00:29:00.000000', 'consum', 0.0221, 'lps'),
	(571194, 131, '2014-03-01 00:29:01.000000', 'consum', 0.0217, 'lps'),
	(571195, 131, '2014-03-01 00:29:02.000000', 'consum', 0.0212, 'lps'),
	(571196, 131, '2014-03-01 00:29:03.000000', 'consum', 0.0219, 'lps'),
	(571197, 131, '2014-03-01 00:29:04.000000', 'consum', 0.0212, 'lps'),
	(571198, 131, '2014-03-01 00:29:05.000000', 'consum', 0.0210, 'lps'),
	(571199, 131, '2014-03-01 00:29:06.000000', 'consum', 0.0226, 'lps'),
	(571200, 131, '2014-03-01 00:29:07.000000', 'consum', 0.0216, 'lps'),
	(571201, 131, '2014-03-01 00:29:08.000000', 'consum', 0.0213, 'lps'),
	(571202, 131, '2014-03-01 00:29:09.000000', 'consum', 0.0222, 'lps'),
	(571203, 131, '2014-03-01 00:29:10.000000', 'consum', 0.0211, 'lps'),
	(571204, 131, '2014-03-01 00:29:11.000000', 'consum', 0.0212, 'lps'),
	(571205, 131, '2014-03-01 00:29:12.000000', 'consum', 0.0220, 'lps'),
	(571206, 131, '2014-03-01 00:29:13.000000', 'consum', 0.0219, 'lps'),
	(571207, 131, '2014-03-01 00:29:14.000000', 'consum', 0.0225, 'lps'),
	(571208, 131, '2014-03-01 00:29:15.000000', 'consum', 0.0222, 'lps'),
	(571209, 131, '2014-03-01 00:29:16.000000', 'consum', 0.0227, 'lps'),
	(571210, 131, '2014-03-01 00:29:17.000000', 'consum', 0.0223, 'lps'),
	(571211, 131, '2014-03-01 00:29:18.000000', 'consum', 0.0224, 'lps'),
	(571212, 131, '2014-03-01 00:29:19.000000', 'consum', 0.0223, 'lps'),
	(571213, 131, '2014-03-01 00:29:20.000000', 'consum', 0.0216, 'lps'),
	(571214, 131, '2014-03-01 00:29:21.000000', 'consum', 0.0221, 'lps'),
	(571215, 131, '2014-03-01 00:29:22.000000', 'consum', 0.0211, 'lps'),
	(571216, 131, '2014-03-01 00:29:23.000000', 'consum', 0.0220, 'lps'),
	(571217, 131, '2014-03-01 00:29:24.000000', 'consum', 0.0220, 'lps'),
	(571218, 131, '2014-03-01 00:29:25.000000', 'consum', 0.0211, 'lps'),
	(571219, 131, '2014-03-01 00:29:26.000000', 'consum', 0.0221, 'lps'),
	(571220, 131, '2014-03-01 00:29:27.000000', 'consum', 0.0211, 'lps'),
	(571221, 131, '2014-03-01 00:29:28.000000', 'consum', 0.0215, 'lps'),
	(571222, 131, '2014-03-01 00:29:29.000000', 'consum', 0.0218, 'lps'),
	(571223, 131, '2014-03-01 00:29:30.000000', 'consum', 0.0218, 'lps'),
	(571224, 131, '2014-03-01 00:29:31.000000', 'consum', 0.0226, 'lps'),
	(571225, 131, '2014-03-01 00:29:32.000000', 'consum', 0.0210, 'lps'),
	(571226, 131, '2014-03-01 00:29:33.000000', 'consum', 0.0219, 'lps'),
	(571227, 131, '2014-03-01 00:29:34.000000', 'consum', 0.0220, 'lps'),
	(571228, 131, '2014-03-01 00:29:35.000000', 'consum', 0.0215, 'lps'),
	(571229, 131, '2014-03-01 00:29:36.000000', 'consum', 0.0224, 'lps'),
	(571230, 131, '2014-03-01 00:29:37.000000', 'consum', 0.0227, 'lps'),
	(571231, 131, '2014-03-01 00:29:38.000000', 'consum', 0.0221, 'lps'),
	(571232, 131, '2014-03-01 00:29:39.000000', 'consum', 0.0213, 'lps'),
	(571233, 131, '2014-03-01 00:29:40.000000', 'consum', 0.0210, 'lps'),
	(571234, 131, '2014-03-01 00:29:41.000000', 'consum', 0.0218, 'lps'),
	(571235, 131, '2014-03-01 00:29:42.000000', 'consum', 0.0218, 'lps'),
	(571236, 131, '2014-03-01 00:29:43.000000', 'consum', 0.0223, 'lps'),
	(571237, 131, '2014-03-01 00:29:44.000000', 'consum', 0.0217, 'lps'),
	(571238, 131, '2014-03-01 00:29:45.000000', 'consum', 0.0224, 'lps'),
	(571239, 131, '2014-03-01 00:29:46.000000', 'consum', 0.0224, 'lps'),
	(571240, 131, '2014-03-01 00:29:47.000000', 'consum', 0.0221, 'lps'),
	(571241, 131, '2014-03-01 00:29:48.000000', 'consum', 0.0223, 'lps'),
	(571242, 131, '2014-03-01 00:29:49.000000', 'consum', 0.0223, 'lps'),
	(571243, 131, '2014-03-01 00:29:50.000000', 'consum', 0.0220, 'lps'),
	(571244, 131, '2014-03-01 00:29:51.000000', 'consum', 0.0220, 'lps'),
	(571245, 131, '2014-03-01 00:29:52.000000', 'consum', 0.0212, 'lps'),
	(571246, 131, '2014-03-01 00:29:53.000000', 'consum', 0.0227, 'lps'),
	(571247, 131, '2014-03-01 00:29:54.000000', 'consum', 0.0218, 'lps'),
	(571248, 131, '2014-03-01 00:29:55.000000', 'consum', 0.0216, 'lps'),
	(571249, 131, '2014-03-01 00:29:56.000000', 'consum', 0.0220, 'lps'),
	(571250, 131, '2014-03-01 00:29:57.000000', 'consum', 0.0221, 'lps'),
	(571251, 131, '2014-03-01 00:29:58.000000', 'consum', 0.0218, 'lps'),
	(571252, 131, '2014-03-01 00:29:59.000000', 'consum', 0.0219, 'lps'),
	(571253, 131, '2014-03-01 00:30:00.000000', 'consum', 0.0215, 'lps'),
	(571254, 131, '2014-03-01 00:30:01.000000', 'consum', 0.0223, 'lps'),
	(571255, 131, '2014-03-01 00:30:02.000000', 'consum', 0.0226, 'lps'),
	(571256, 131, '2014-03-01 00:30:03.000000', 'consum', 0.0216, 'lps'),
	(571257, 131, '2014-03-01 00:30:04.000000', 'consum', 0.0211, 'lps'),
	(571258, 131, '2014-03-01 00:30:05.000000', 'consum', 0.0217, 'lps'),
	(571259, 131, '2014-03-01 00:30:06.000000', 'consum', 0.0221, 'lps'),
	(571260, 131, '2014-03-01 00:30:07.000000', 'consum', 0.0210, 'lps'),
	(571261, 131, '2014-03-01 00:30:08.000000', 'consum', 0.0213, 'lps'),
	(571262, 131, '2014-03-01 00:30:09.000000', 'consum', 0.0225, 'lps'),
	(571263, 131, '2014-03-01 00:30:10.000000', 'consum', 0.0222, 'lps'),
	(571264, 131, '2014-03-01 00:30:11.000000', 'consum', 0.0226, 'lps'),
	(571265, 131, '2014-03-01 00:30:12.000000', 'consum', 0.0219, 'lps'),
	(571266, 131, '2014-03-01 00:30:13.000000', 'consum', 0.0224, 'lps'),
	(571267, 131, '2014-03-01 00:30:14.000000', 'consum', 0.0219, 'lps'),
	(571268, 131, '2014-03-01 00:30:15.000000', 'consum', 0.0211, 'lps'),
	(571269, 131, '2014-03-01 00:30:16.000000', 'consum', 0.0226, 'lps'),
	(571270, 131, '2014-03-01 00:30:17.000000', 'consum', 0.0214, 'lps'),
	(571271, 131, '2014-03-01 00:30:18.000000', 'consum', 0.0219, 'lps'),
	(571272, 131, '2014-03-01 00:30:19.000000', 'consum', 0.0224, 'lps'),
	(571273, 131, '2014-03-01 00:30:20.000000', 'consum', 0.0219, 'lps'),
	(571274, 131, '2014-03-01 00:30:21.000000', 'consum', 0.0211, 'lps'),
	(571275, 131, '2014-03-01 00:30:22.000000', 'consum', 0.0227, 'lps'),
	(571276, 131, '2014-03-01 00:30:23.000000', 'consum', 0.0220, 'lps'),
	(571277, 131, '2014-03-01 00:30:24.000000', 'consum', 0.0210, 'lps'),
	(571278, 131, '2014-03-01 00:30:25.000000', 'consum', 0.0216, 'lps'),
	(571279, 131, '2014-03-01 00:30:26.000000', 'consum', 0.0223, 'lps'),
	(571280, 131, '2014-03-01 00:30:27.000000', 'consum', 0.0223, 'lps'),
	(571281, 131, '2014-03-01 00:30:28.000000', 'consum', 0.0217, 'lps'),
	(571282, 131, '2014-03-01 00:30:29.000000', 'consum', 0.0225, 'lps'),
	(571283, 131, '2014-03-01 00:30:30.000000', 'consum', 0.0211, 'lps'),
	(571284, 131, '2014-03-01 00:30:31.000000', 'consum', 0.0223, 'lps'),
	(571285, 131, '2014-03-01 00:30:32.000000', 'consum', 0.0220, 'lps'),
	(571286, 131, '2014-03-01 00:30:33.000000', 'consum', 0.0223, 'lps'),
	(571287, 131, '2014-03-01 00:30:34.000000', 'consum', 0.0226, 'lps'),
	(571288, 131, '2014-03-01 00:30:35.000000', 'consum', 0.0217, 'lps'),
	(571289, 131, '2014-03-01 00:30:36.000000', 'consum', 0.0213, 'lps'),
	(571290, 131, '2014-03-01 00:30:37.000000', 'consum', 0.0225, 'lps'),
	(571291, 131, '2014-03-01 00:30:38.000000', 'consum', 0.0221, 'lps'),
	(571292, 131, '2014-03-01 00:30:39.000000', 'consum', 0.0220, 'lps'),
	(571293, 131, '2014-03-01 00:30:40.000000', 'consum', 0.0211, 'lps'),
	(571294, 131, '2014-03-01 00:30:41.000000', 'consum', 0.0221, 'lps'),
	(571295, 131, '2014-03-01 00:30:42.000000', 'consum', 0.0224, 'lps'),
	(571296, 131, '2014-03-01 00:30:43.000000', 'consum', 0.0215, 'lps'),
	(571297, 131, '2014-03-01 00:30:44.000000', 'consum', 0.0210, 'lps'),
	(571298, 131, '2014-03-01 00:30:45.000000', 'consum', 0.0212, 'lps'),
	(571299, 131, '2014-03-01 00:30:46.000000', 'consum', 0.0221, 'lps'),
	(571300, 131, '2014-03-01 00:30:47.000000', 'consum', 0.0226, 'lps'),
	(571301, 131, '2014-03-01 00:30:48.000000', 'consum', 0.0219, 'lps'),
	(571302, 131, '2014-03-01 00:30:49.000000', 'consum', 0.0225, 'lps'),
	(571303, 131, '2014-03-01 00:30:50.000000', 'consum', 0.0225, 'lps'),
	(571304, 131, '2014-03-01 00:30:51.000000', 'consum', 0.0220, 'lps'),
	(571305, 131, '2014-03-01 00:30:52.000000', 'consum', 0.0218, 'lps'),
	(571306, 131, '2014-03-01 00:30:53.000000', 'consum', 0.0219, 'lps'),
	(571307, 131, '2014-03-01 00:30:54.000000', 'consum', 0.0215, 'lps'),
	(571308, 131, '2014-03-01 00:30:55.000000', 'consum', 0.0225, 'lps'),
	(571309, 131, '2014-03-01 00:30:56.000000', 'consum', 0.0219, 'lps'),
	(571310, 131, '2014-03-01 00:30:57.000000', 'consum', 0.0227, 'lps'),
	(571311, 131, '2014-03-01 00:30:58.000000', 'consum', 0.0216, 'lps'),
	(571312, 131, '2014-03-01 00:30:59.000000', 'consum', 0.0223, 'lps'),
	(571313, 131, '2014-03-01 00:31:00.000000', 'consum', 0.0223, 'lps'),
	(571314, 131, '2014-03-01 00:31:01.000000', 'consum', 0.0218, 'lps'),
	(571315, 131, '2014-03-01 00:31:02.000000', 'consum', 0.0213, 'lps'),
	(571316, 131, '2014-03-01 00:31:03.000000', 'consum', 0.0219, 'lps'),
	(571317, 131, '2014-03-01 00:31:04.000000', 'consum', 0.0210, 'lps'),
	(571318, 131, '2014-03-01 00:31:05.000000', 'consum', 0.0220, 'lps'),
	(571319, 131, '2014-03-01 00:31:06.000000', 'consum', 0.0224, 'lps'),
	(571320, 131, '2014-03-01 00:31:07.000000', 'consum', 0.0215, 'lps'),
	(571321, 131, '2014-03-01 00:31:08.000000', 'consum', 0.0213, 'lps'),
	(571322, 131, '2014-03-01 00:31:09.000000', 'consum', 0.0226, 'lps'),
	(571323, 131, '2014-03-01 00:31:10.000000', 'consum', 0.0227, 'lps'),
	(571324, 131, '2014-03-01 00:31:11.000000', 'consum', 0.0212, 'lps'),
	(571325, 131, '2014-03-01 00:31:12.000000', 'consum', 0.0224, 'lps'),
	(571326, 131, '2014-03-01 00:31:13.000000', 'consum', 0.0220, 'lps'),
	(571327, 131, '2014-03-01 00:31:14.000000', 'consum', 0.0218, 'lps'),
	(571328, 131, '2014-03-01 00:31:15.000000', 'consum', 0.0222, 'lps'),
	(571329, 131, '2014-03-01 00:31:16.000000', 'consum', 0.0227, 'lps'),
	(571330, 131, '2014-03-01 00:31:17.000000', 'consum', 0.0223, 'lps'),
	(571331, 131, '2014-03-01 00:31:18.000000', 'consum', 0.0223, 'lps'),
	(571332, 131, '2014-03-01 00:31:19.000000', 'consum', 0.0222, 'lps'),
	(571333, 131, '2014-03-01 00:31:20.000000', 'consum', 0.0210, 'lps'),
	(571334, 131, '2014-03-01 00:31:21.000000', 'consum', 0.0213, 'lps'),
	(571335, 131, '2014-03-01 00:31:22.000000', 'consum', 0.0224, 'lps'),
	(571336, 131, '2014-03-01 00:31:23.000000', 'consum', 0.0217, 'lps'),
	(571337, 131, '2014-03-01 00:31:24.000000', 'consum', 0.0224, 'lps'),
	(571338, 131, '2014-03-01 00:31:25.000000', 'consum', 0.0220, 'lps'),
	(571339, 131, '2014-03-01 00:31:26.000000', 'consum', 0.0221, 'lps'),
	(571340, 131, '2014-03-01 00:31:27.000000', 'consum', 0.0216, 'lps'),
	(571341, 131, '2014-03-01 00:31:28.000000', 'consum', 0.0226, 'lps'),
	(571342, 131, '2014-03-01 00:31:29.000000', 'consum', 0.0217, 'lps'),
	(571343, 131, '2014-03-01 00:31:30.000000', 'consum', 0.0216, 'lps'),
	(571344, 131, '2014-03-01 00:31:31.000000', 'consum', 0.0218, 'lps'),
	(571345, 131, '2014-03-01 00:31:32.000000', 'consum', 0.0218, 'lps'),
	(571346, 131, '2014-03-01 00:31:33.000000', 'consum', 0.0225, 'lps'),
	(571347, 131, '2014-03-01 00:31:34.000000', 'consum', 0.0225, 'lps'),
	(571348, 131, '2014-03-01 00:31:35.000000', 'consum', 0.0223, 'lps'),
	(571349, 131, '2014-03-01 00:31:36.000000', 'consum', 0.0213, 'lps'),
	(571350, 131, '2014-03-01 00:31:37.000000', 'consum', 0.0224, 'lps'),
	(571351, 131, '2014-03-01 00:31:38.000000', 'consum', 0.0215, 'lps'),
	(571352, 131, '2014-03-01 00:31:39.000000', 'consum', 0.0211, 'lps'),
	(571353, 131, '2014-03-01 00:31:40.000000', 'consum', 0.0218, 'lps'),
	(571354, 131, '2014-03-01 00:31:41.000000', 'consum', 0.0211, 'lps'),
	(571355, 131, '2014-03-01 00:31:42.000000', 'consum', 0.0211, 'lps'),
	(571356, 131, '2014-03-01 00:31:43.000000', 'consum', 0.0213, 'lps'),
	(571357, 131, '2014-03-01 00:31:44.000000', 'consum', 0.0223, 'lps'),
	(571358, 131, '2014-03-01 00:31:45.000000', 'consum', 0.0213, 'lps'),
	(571359, 131, '2014-03-01 00:31:46.000000', 'consum', 0.0220, 'lps'),
	(571360, 131, '2014-03-01 00:31:47.000000', 'consum', 0.0218, 'lps'),
	(571361, 131, '2014-03-01 00:31:48.000000', 'consum', 0.0220, 'lps'),
	(571362, 131, '2014-03-01 00:31:49.000000', 'consum', 0.0219, 'lps'),
	(571363, 131, '2014-03-01 00:31:50.000000', 'consum', 0.0226, 'lps'),
	(571364, 131, '2014-03-01 00:31:51.000000', 'consum', 0.0210, 'lps'),
	(571365, 131, '2014-03-01 00:31:52.000000', 'consum', 0.0215, 'lps'),
	(571366, 131, '2014-03-01 00:31:53.000000', 'consum', 0.0216, 'lps'),
	(571367, 131, '2014-03-01 00:31:54.000000', 'consum', 0.0210, 'lps'),
	(571368, 131, '2014-03-01 00:31:55.000000', 'consum', 0.0226, 'lps'),
	(571369, 131, '2014-03-01 00:31:56.000000', 'consum', 0.0219, 'lps'),
	(571370, 131, '2014-03-01 00:31:57.000000', 'consum', 0.0227, 'lps'),
	(571371, 131, '2014-03-01 00:31:58.000000', 'consum', 0.0215, 'lps'),
	(571372, 131, '2014-03-01 00:31:59.000000', 'consum', 0.0218, 'lps'),
	(571373, 131, '2014-03-01 00:32:00.000000', 'consum', 0.0220, 'lps'),
	(571374, 131, '2014-03-01 00:32:01.000000', 'consum', 0.0215, 'lps'),
	(571375, 131, '2014-03-01 00:32:02.000000', 'consum', 0.0227, 'lps'),
	(571376, 131, '2014-03-01 00:32:03.000000', 'consum', 0.0226, 'lps'),
	(571377, 131, '2014-03-01 00:32:04.000000', 'consum', 0.0220, 'lps'),
	(571378, 131, '2014-03-01 00:32:05.000000', 'consum', 0.0215, 'lps'),
	(571379, 131, '2014-03-01 00:32:06.000000', 'consum', 0.0221, 'lps'),
	(571380, 131, '2014-03-01 00:32:07.000000', 'consum', 0.0217, 'lps'),
	(571381, 131, '2014-03-01 00:32:08.000000', 'consum', 0.0213, 'lps'),
	(571382, 131, '2014-03-01 00:32:09.000000', 'consum', 0.0222, 'lps'),
	(571383, 131, '2014-03-01 00:32:10.000000', 'consum', 0.0225, 'lps'),
	(571384, 131, '2014-03-01 00:32:11.000000', 'consum', 0.0215, 'lps'),
	(571385, 131, '2014-03-01 00:32:12.000000', 'consum', 0.0226, 'lps'),
	(571386, 131, '2014-03-01 00:32:13.000000', 'consum', 0.0221, 'lps'),
	(571387, 131, '2014-03-01 00:32:14.000000', 'consum', 0.0217, 'lps'),
	(571388, 131, '2014-03-01 00:32:15.000000', 'consum', 0.0212, 'lps'),
	(571389, 131, '2014-03-01 00:32:16.000000', 'consum', 0.0216, 'lps'),
	(571390, 131, '2014-03-01 00:32:17.000000', 'consum', 0.0219, 'lps'),
	(571391, 131, '2014-03-01 00:32:18.000000', 'consum', 0.0220, 'lps'),
	(571392, 131, '2014-03-01 00:32:19.000000', 'consum', 0.0214, 'lps'),
	(571393, 131, '2014-03-01 00:32:20.000000', 'consum', 0.0218, 'lps'),
	(571394, 131, '2014-03-01 00:32:21.000000', 'consum', 0.0222, 'lps'),
	(571395, 131, '2014-03-01 00:32:22.000000', 'consum', 0.0227, 'lps'),
	(571396, 131, '2014-03-01 00:32:23.000000', 'consum', 0.0223, 'lps'),
	(571397, 131, '2014-03-01 00:32:24.000000', 'consum', 0.0223, 'lps'),
	(571398, 131, '2014-03-01 00:32:25.000000', 'consum', 0.0222, 'lps'),
	(571399, 131, '2014-03-01 00:32:26.000000', 'consum', 0.0212, 'lps'),
	(571400, 131, '2014-03-01 00:32:27.000000', 'consum', 0.0222, 'lps'),
	(571401, 131, '2014-03-01 00:32:28.000000', 'consum', 0.0212, 'lps'),
	(571402, 131, '2014-03-01 00:32:29.000000', 'consum', 0.0217, 'lps'),
	(571403, 131, '2014-03-01 00:32:30.000000', 'consum', 0.0222, 'lps'),
	(571404, 131, '2014-03-01 00:32:31.000000', 'consum', 0.0214, 'lps'),
	(571405, 131, '2014-03-01 00:32:32.000000', 'consum', 0.0213, 'lps'),
	(571406, 131, '2014-03-01 00:32:33.000000', 'consum', 0.0212, 'lps'),
	(571407, 131, '2014-03-01 00:32:34.000000', 'consum', 0.0214, 'lps'),
	(571408, 131, '2014-03-01 00:32:35.000000', 'consum', 0.0225, 'lps'),
	(571409, 131, '2014-03-01 00:32:36.000000', 'consum', 0.0216, 'lps'),
	(571410, 131, '2014-03-01 00:32:37.000000', 'consum', 0.0217, 'lps'),
	(571411, 131, '2014-03-01 00:32:38.000000', 'consum', 0.0225, 'lps'),
	(571412, 131, '2014-03-01 00:32:39.000000', 'consum', 0.0213, 'lps'),
	(571413, 131, '2014-03-01 00:32:40.000000', 'consum', 0.0217, 'lps'),
	(571414, 131, '2014-03-01 00:32:41.000000', 'consum', 0.0218, 'lps'),
	(571415, 131, '2014-03-01 00:32:42.000000', 'consum', 0.0212, 'lps'),
	(571416, 131, '2014-03-01 00:32:43.000000', 'consum', 0.0214, 'lps'),
	(571417, 131, '2014-03-01 00:32:44.000000', 'consum', 0.0223, 'lps'),
	(571418, 131, '2014-03-01 00:32:45.000000', 'consum', 0.0227, 'lps'),
	(571419, 131, '2014-03-01 00:32:46.000000', 'consum', 0.0220, 'lps'),
	(571420, 131, '2014-03-01 00:32:47.000000', 'consum', 0.0227, 'lps'),
	(571421, 131, '2014-03-01 00:32:48.000000', 'consum', 0.0212, 'lps'),
	(571422, 131, '2014-03-01 00:32:49.000000', 'consum', 0.0222, 'lps'),
	(571423, 131, '2014-03-01 00:32:50.000000', 'consum', 0.0213, 'lps'),
	(571424, 131, '2014-03-01 00:32:51.000000', 'consum', 0.0227, 'lps'),
	(571425, 131, '2014-03-01 00:32:52.000000', 'consum', 0.0212, 'lps'),
	(571426, 131, '2014-03-01 00:32:53.000000', 'consum', 0.0224, 'lps'),
	(571427, 131, '2014-03-01 00:32:54.000000', 'consum', 0.0221, 'lps'),
	(571428, 131, '2014-03-01 00:32:55.000000', 'consum', 0.0222, 'lps'),
	(571429, 131, '2014-03-01 00:32:56.000000', 'consum', 0.0222, 'lps'),
	(571430, 131, '2014-03-01 00:32:57.000000', 'consum', 0.0215, 'lps'),
	(571431, 131, '2014-03-01 00:32:58.000000', 'consum', 0.0219, 'lps'),
	(571432, 131, '2014-03-01 00:32:59.000000', 'consum', 0.0221, 'lps'),
	(571433, 131, '2014-03-01 00:33:00.000000', 'consum', 0.0221, 'lps'),
	(571434, 131, '2014-03-01 00:33:01.000000', 'consum', 0.0213, 'lps'),
	(571435, 131, '2014-03-01 00:33:02.000000', 'consum', 0.0212, 'lps'),
	(571436, 131, '2014-03-01 00:33:03.000000', 'consum', 0.0211, 'lps'),
	(571437, 131, '2014-03-01 00:33:04.000000', 'consum', 0.0211, 'lps'),
	(571438, 131, '2014-03-01 00:33:05.000000', 'consum', 0.0210, 'lps'),
	(571439, 131, '2014-03-01 00:33:06.000000', 'consum', 0.0225, 'lps'),
	(571440, 131, '2014-03-01 00:33:07.000000', 'consum', 0.0215, 'lps'),
	(571441, 131, '2014-03-01 00:33:08.000000', 'consum', 0.0225, 'lps'),
	(571442, 131, '2014-03-01 00:33:09.000000', 'consum', 0.0215, 'lps'),
	(571443, 131, '2014-03-01 00:33:10.000000', 'consum', 0.0211, 'lps'),
	(571444, 131, '2014-03-01 00:33:11.000000', 'consum', 0.0218, 'lps'),
	(571445, 131, '2014-03-01 00:33:12.000000', 'consum', 0.0213, 'lps'),
	(571446, 131, '2014-03-01 00:33:13.000000', 'consum', 0.0220, 'lps'),
	(571447, 131, '2014-03-01 00:33:14.000000', 'consum', 0.0213, 'lps'),
	(571448, 131, '2014-03-01 00:33:15.000000', 'consum', 0.0216, 'lps'),
	(571449, 131, '2014-03-01 00:33:16.000000', 'consum', 0.0211, 'lps'),
	(571450, 131, '2014-03-01 00:33:17.000000', 'consum', 0.0215, 'lps'),
	(571451, 131, '2014-03-01 00:33:18.000000', 'consum', 0.0217, 'lps'),
	(571452, 131, '2014-03-01 00:33:19.000000', 'consum', 0.0211, 'lps'),
	(571453, 131, '2014-03-01 00:33:20.000000', 'consum', 0.0211, 'lps'),
	(571454, 131, '2014-03-01 00:33:21.000000', 'consum', 0.0216, 'lps'),
	(571455, 131, '2014-03-01 00:33:22.000000', 'consum', 0.0217, 'lps'),
	(571456, 131, '2014-03-01 00:33:23.000000', 'consum', 0.0212, 'lps'),
	(571457, 131, '2014-03-01 00:33:24.000000', 'consum', 0.0217, 'lps'),
	(571458, 131, '2014-03-01 00:33:25.000000', 'consum', 0.0221, 'lps'),
	(571459, 131, '2014-03-01 00:33:26.000000', 'consum', 0.0227, 'lps'),
	(571460, 131, '2014-03-01 00:33:27.000000', 'consum', 0.0225, 'lps'),
	(571461, 131, '2014-03-01 00:33:28.000000', 'consum', 0.0219, 'lps'),
	(571462, 131, '2014-03-01 00:33:29.000000', 'consum', 0.0210, 'lps'),
	(571463, 131, '2014-03-01 00:33:30.000000', 'consum', 0.0218, 'lps'),
	(571464, 131, '2014-03-01 00:33:31.000000', 'consum', 0.0217, 'lps'),
	(571465, 131, '2014-03-01 00:33:32.000000', 'consum', 0.0219, 'lps'),
	(571466, 131, '2014-03-01 00:33:33.000000', 'consum', 0.0217, 'lps'),
	(571467, 131, '2014-03-01 00:33:34.000000', 'consum', 0.0219, 'lps'),
	(571468, 131, '2014-03-01 00:33:35.000000', 'consum', 0.0218, 'lps'),
	(571469, 131, '2014-03-01 00:33:36.000000', 'consum', 0.0221, 'lps'),
	(571470, 131, '2014-03-01 00:33:37.000000', 'consum', 0.0224, 'lps'),
	(571471, 131, '2014-03-01 00:33:38.000000', 'consum', 0.0213, 'lps'),
	(571472, 131, '2014-03-01 00:33:39.000000', 'consum', 0.0221, 'lps'),
	(571473, 131, '2014-03-01 00:33:40.000000', 'consum', 0.0217, 'lps'),
	(571474, 131, '2014-03-01 00:33:41.000000', 'consum', 0.0216, 'lps'),
	(571475, 131, '2014-03-01 00:33:42.000000', 'consum', 0.0216, 'lps'),
	(571476, 131, '2014-03-01 00:33:43.000000', 'consum', 0.0225, 'lps'),
	(571477, 131, '2014-03-01 00:33:44.000000', 'consum', 0.0211, 'lps'),
	(571478, 131, '2014-03-01 00:33:45.000000', 'consum', 0.0225, 'lps'),
	(571479, 131, '2014-03-01 00:33:46.000000', 'consum', 0.0211, 'lps'),
	(571480, 131, '2014-03-01 00:33:47.000000', 'consum', 0.0225, 'lps'),
	(571481, 131, '2014-03-01 00:33:48.000000', 'consum', 0.0212, 'lps'),
	(571482, 131, '2014-03-01 00:33:49.000000', 'consum', 0.0227, 'lps'),
	(571483, 131, '2014-03-01 00:33:50.000000', 'consum', 0.0217, 'lps'),
	(571484, 131, '2014-03-01 00:33:51.000000', 'consum', 0.0213, 'lps'),
	(571485, 131, '2014-03-01 00:33:52.000000', 'consum', 0.0225, 'lps'),
	(571486, 131, '2014-03-01 00:33:53.000000', 'consum', 0.0219, 'lps'),
	(571487, 131, '2014-03-01 00:33:54.000000', 'consum', 0.0212, 'lps'),
	(571488, 131, '2014-03-01 00:33:55.000000', 'consum', 0.0212, 'lps'),
	(571489, 131, '2014-03-01 00:33:56.000000', 'consum', 0.0216, 'lps'),
	(571490, 131, '2014-03-01 00:33:57.000000', 'consum', 0.0216, 'lps'),
	(571491, 131, '2014-03-01 00:33:58.000000', 'consum', 0.0221, 'lps'),
	(571492, 131, '2014-03-01 00:33:59.000000', 'consum', 0.0212, 'lps'),
	(571493, 131, '2014-03-01 00:34:00.000000', 'consum', 0.0226, 'lps'),
	(571494, 131, '2014-03-01 00:34:01.000000', 'consum', 0.0210, 'lps'),
	(571495, 131, '2014-03-01 00:34:02.000000', 'consum', 0.0216, 'lps'),
	(571496, 131, '2014-03-01 00:34:03.000000', 'consum', 0.0222, 'lps'),
	(571497, 131, '2014-03-01 00:34:04.000000', 'consum', 0.0216, 'lps'),
	(571498, 131, '2014-03-01 00:34:05.000000', 'consum', 0.0225, 'lps'),
	(571499, 131, '2014-03-01 00:34:06.000000', 'consum', 0.0210, 'lps'),
	(571500, 131, '2014-03-01 00:34:07.000000', 'consum', 0.0223, 'lps'),
	(571501, 131, '2014-03-01 00:34:08.000000', 'consum', 0.0219, 'lps'),
	(571502, 131, '2014-03-01 00:34:09.000000', 'consum', 0.0219, 'lps'),
	(571503, 131, '2014-03-01 00:34:10.000000', 'consum', 0.0211, 'lps'),
	(571504, 131, '2014-03-01 00:34:11.000000', 'consum', 0.0223, 'lps'),
	(571505, 131, '2014-03-01 00:34:12.000000', 'consum', 0.0221, 'lps'),
	(571506, 131, '2014-03-01 00:34:13.000000', 'consum', 0.0224, 'lps'),
	(571507, 131, '2014-03-01 00:34:14.000000', 'consum', 0.0213, 'lps'),
	(571508, 131, '2014-03-01 00:34:15.000000', 'consum', 0.0220, 'lps'),
	(571509, 131, '2014-03-01 00:34:16.000000', 'consum', 0.0215, 'lps'),
	(571510, 131, '2014-03-01 00:34:17.000000', 'consum', 0.0224, 'lps'),
	(571511, 131, '2014-03-01 00:34:18.000000', 'consum', 0.0211, 'lps'),
	(571512, 131, '2014-03-01 00:34:19.000000', 'consum', 0.0210, 'lps'),
	(571513, 131, '2014-03-01 00:34:20.000000', 'consum', 0.0224, 'lps'),
	(571514, 131, '2014-03-01 00:34:21.000000', 'consum', 0.0226, 'lps'),
	(571515, 131, '2014-03-01 00:34:22.000000', 'consum', 0.0215, 'lps'),
	(571516, 131, '2014-03-01 00:34:23.000000', 'consum', 0.0221, 'lps'),
	(571517, 131, '2014-03-01 00:34:24.000000', 'consum', 0.0213, 'lps'),
	(571518, 131, '2014-03-01 00:34:25.000000', 'consum', 0.0214, 'lps'),
	(571519, 131, '2014-03-01 00:34:26.000000', 'consum', 0.0219, 'lps'),
	(571520, 131, '2014-03-01 00:34:27.000000', 'consum', 0.0225, 'lps'),
	(571521, 131, '2014-03-01 00:34:28.000000', 'consum', 0.0223, 'lps'),
	(571522, 131, '2014-03-01 00:34:29.000000', 'consum', 0.0211, 'lps'),
	(571523, 131, '2014-03-01 00:34:30.000000', 'consum', 0.0214, 'lps'),
	(571524, 131, '2014-03-01 00:34:31.000000', 'consum', 0.0226, 'lps'),
	(571525, 131, '2014-03-01 00:34:32.000000', 'consum', 0.0225, 'lps'),
	(571526, 131, '2014-03-01 00:34:33.000000', 'consum', 0.0220, 'lps'),
	(571527, 131, '2014-03-01 00:34:34.000000', 'consum', 0.0216, 'lps'),
	(571528, 131, '2014-03-01 00:34:35.000000', 'consum', 0.0211, 'lps'),
	(571529, 131, '2014-03-01 00:34:36.000000', 'consum', 0.0214, 'lps'),
	(571530, 131, '2014-03-01 00:34:37.000000', 'consum', 0.0212, 'lps'),
	(571531, 131, '2014-03-01 00:34:38.000000', 'consum', 0.0226, 'lps'),
	(571532, 131, '2014-03-01 00:34:39.000000', 'consum', 0.0211, 'lps'),
	(571533, 131, '2014-03-01 00:34:40.000000', 'consum', 0.0221, 'lps'),
	(571534, 131, '2014-03-01 00:34:41.000000', 'consum', 0.0226, 'lps'),
	(571535, 131, '2014-03-01 00:34:42.000000', 'consum', 0.0221, 'lps'),
	(571536, 131, '2014-03-01 00:34:43.000000', 'consum', 0.0218, 'lps'),
	(571537, 131, '2014-03-01 00:34:44.000000', 'consum', 0.0219, 'lps'),
	(571538, 131, '2014-03-01 00:34:45.000000', 'consum', 0.0211, 'lps'),
	(571539, 131, '2014-03-01 00:34:46.000000', 'consum', 0.0224, 'lps'),
	(571540, 131, '2014-03-01 00:34:47.000000', 'consum', 0.0224, 'lps'),
	(571541, 131, '2014-03-01 00:34:48.000000', 'consum', 0.0220, 'lps'),
	(571542, 131, '2014-03-01 00:34:49.000000', 'consum', 0.0218, 'lps'),
	(571543, 131, '2014-03-01 00:34:50.000000', 'consum', 0.0221, 'lps'),
	(571544, 131, '2014-03-01 00:34:51.000000', 'consum', 0.0224, 'lps'),
	(571545, 131, '2014-03-01 00:34:52.000000', 'consum', 0.0210, 'lps'),
	(571546, 131, '2014-03-01 00:34:53.000000', 'consum', 0.0224, 'lps'),
	(571547, 131, '2014-03-01 00:34:54.000000', 'consum', 0.0224, 'lps'),
	(571548, 131, '2014-03-01 00:34:55.000000', 'consum', 0.0223, 'lps'),
	(571549, 131, '2014-03-01 00:34:56.000000', 'consum', 0.0216, 'lps'),
	(571550, 131, '2014-03-01 00:34:57.000000', 'consum', 0.0218, 'lps'),
	(571551, 131, '2014-03-01 00:34:58.000000', 'consum', 0.0215, 'lps'),
	(571552, 131, '2014-03-01 00:34:59.000000', 'consum', 0.0211, 'lps'),
	(571553, 131, '2014-03-01 00:35:00.000000', 'consum', 0.0220, 'lps'),
	(571554, 131, '2014-03-01 00:35:01.000000', 'consum', 0.0219, 'lps'),
	(571555, 131, '2014-03-01 00:35:02.000000', 'consum', 0.0225, 'lps'),
	(571556, 131, '2014-03-01 00:35:03.000000', 'consum', 0.0223, 'lps'),
	(571557, 131, '2014-03-01 00:35:04.000000', 'consum', 0.0212, 'lps'),
	(571558, 131, '2014-03-01 00:35:05.000000', 'consum', 0.0220, 'lps'),
	(571559, 131, '2014-03-01 00:35:06.000000', 'consum', 0.0217, 'lps'),
	(571560, 131, '2014-03-01 00:35:07.000000', 'consum', 0.0215, 'lps'),
	(571561, 131, '2014-03-01 00:35:08.000000', 'consum', 0.0214, 'lps'),
	(571562, 131, '2014-03-01 00:35:09.000000', 'consum', 0.0216, 'lps'),
	(571563, 131, '2014-03-01 00:35:10.000000', 'consum', 0.0211, 'lps'),
	(571564, 131, '2014-03-01 00:35:11.000000', 'consum', 0.0213, 'lps'),
	(571565, 131, '2014-03-01 00:35:12.000000', 'consum', 0.0225, 'lps'),
	(571566, 131, '2014-03-01 00:35:13.000000', 'consum', 0.0220, 'lps'),
	(571567, 131, '2014-03-01 00:35:14.000000', 'consum', 0.0217, 'lps'),
	(571568, 131, '2014-03-01 00:35:15.000000', 'consum', 0.0217, 'lps'),
	(571569, 131, '2014-03-01 00:35:16.000000', 'consum', 0.0224, 'lps'),
	(571570, 131, '2014-03-01 00:35:17.000000', 'consum', 0.0223, 'lps'),
	(571571, 131, '2014-03-01 00:35:18.000000', 'consum', 0.0216, 'lps'),
	(571572, 131, '2014-03-01 00:35:19.000000', 'consum', 0.0219, 'lps'),
	(571573, 131, '2014-03-01 00:35:20.000000', 'consum', 0.0220, 'lps'),
	(571574, 131, '2014-03-01 00:35:21.000000', 'consum', 0.0217, 'lps'),
	(571575, 131, '2014-03-01 00:35:22.000000', 'consum', 0.0213, 'lps'),
	(571576, 131, '2014-03-01 00:35:23.000000', 'consum', 0.0222, 'lps'),
	(571577, 131, '2014-03-01 00:35:24.000000', 'consum', 0.0226, 'lps'),
	(571578, 131, '2014-03-01 00:35:25.000000', 'consum', 0.0218, 'lps'),
	(571579, 131, '2014-03-01 00:35:26.000000', 'consum', 0.0222, 'lps'),
	(571580, 131, '2014-03-01 00:35:27.000000', 'consum', 0.0210, 'lps'),
	(571581, 131, '2014-03-01 00:35:28.000000', 'consum', 0.0226, 'lps'),
	(571582, 131, '2014-03-01 00:35:29.000000', 'consum', 0.0222, 'lps'),
	(571583, 131, '2014-03-01 00:35:30.000000', 'consum', 0.0220, 'lps'),
	(571584, 131, '2014-03-01 00:35:31.000000', 'consum', 0.0227, 'lps'),
	(571585, 131, '2014-03-01 00:35:32.000000', 'consum', 0.0212, 'lps'),
	(571586, 131, '2014-03-01 00:35:33.000000', 'consum', 0.0222, 'lps'),
	(571587, 131, '2014-03-01 00:35:34.000000', 'consum', 0.0212, 'lps'),
	(571588, 131, '2014-03-01 00:35:35.000000', 'consum', 0.0218, 'lps'),
	(571589, 131, '2014-03-01 00:35:36.000000', 'consum', 0.0210, 'lps'),
	(571590, 131, '2014-03-01 00:35:37.000000', 'consum', 0.0223, 'lps'),
	(571591, 131, '2014-03-01 00:35:38.000000', 'consum', 0.0220, 'lps'),
	(571592, 131, '2014-03-01 00:35:39.000000', 'consum', 0.0220, 'lps'),
	(571593, 131, '2014-03-01 00:35:40.000000', 'consum', 0.0214, 'lps'),
	(571594, 131, '2014-03-01 00:35:41.000000', 'consum', 0.0221, 'lps'),
	(571595, 131, '2014-03-01 00:35:42.000000', 'consum', 0.0214, 'lps'),
	(571596, 131, '2014-03-01 00:35:43.000000', 'consum', 0.0217, 'lps'),
	(571597, 131, '2014-03-01 00:35:44.000000', 'consum', 0.0215, 'lps'),
	(571598, 131, '2014-03-01 00:35:45.000000', 'consum', 0.0214, 'lps'),
	(571599, 131, '2014-03-01 00:35:46.000000', 'consum', 0.0216, 'lps'),
	(571600, 131, '2014-03-01 00:35:47.000000', 'consum', 0.0210, 'lps'),
	(571601, 131, '2014-03-01 00:35:48.000000', 'consum', 0.0211, 'lps'),
	(571602, 131, '2014-03-01 00:35:49.000000', 'consum', 0.0216, 'lps'),
	(571603, 131, '2014-03-01 00:35:50.000000', 'consum', 0.0221, 'lps'),
	(571604, 131, '2014-03-01 00:35:51.000000', 'consum', 0.0211, 'lps'),
	(571605, 131, '2014-03-01 00:35:52.000000', 'consum', 0.0218, 'lps'),
	(571606, 131, '2014-03-01 00:35:53.000000', 'consum', 0.0213, 'lps'),
	(571607, 131, '2014-03-01 00:35:54.000000', 'consum', 0.0220, 'lps'),
	(571608, 131, '2014-03-01 00:35:55.000000', 'consum', 0.0212, 'lps'),
	(571609, 131, '2014-03-01 00:35:56.000000', 'consum', 0.0211, 'lps'),
	(571610, 131, '2014-03-01 00:35:57.000000', 'consum', 0.0210, 'lps'),
	(571611, 131, '2014-03-01 00:35:58.000000', 'consum', 0.0226, 'lps'),
	(571612, 131, '2014-03-01 00:35:59.000000', 'consum', 0.0217, 'lps'),
	(571613, 131, '2014-03-01 00:36:00.000000', 'consum', 0.0218, 'lps'),
	(571614, 131, '2014-03-01 00:36:01.000000', 'consum', 0.0210, 'lps'),
	(571615, 131, '2014-03-01 00:36:02.000000', 'consum', 0.0222, 'lps'),
	(571616, 131, '2014-03-01 00:36:03.000000', 'consum', 0.0217, 'lps'),
	(571617, 131, '2014-03-01 00:36:04.000000', 'consum', 0.0210, 'lps'),
	(571618, 131, '2014-03-01 00:36:05.000000', 'consum', 0.0223, 'lps'),
	(571619, 131, '2014-03-01 00:36:06.000000', 'consum', 0.0223, 'lps'),
	(571620, 131, '2014-03-01 00:36:07.000000', 'consum', 0.0218, 'lps'),
	(571621, 131, '2014-03-01 00:36:08.000000', 'consum', 0.0210, 'lps'),
	(571622, 131, '2014-03-01 00:36:09.000000', 'consum', 0.0225, 'lps'),
	(571623, 131, '2014-03-01 00:36:10.000000', 'consum', 0.0211, 'lps'),
	(571624, 131, '2014-03-01 00:36:11.000000', 'consum', 0.0227, 'lps'),
	(571625, 131, '2014-03-01 00:36:12.000000', 'consum', 0.0222, 'lps'),
	(571626, 131, '2014-03-01 00:36:13.000000', 'consum', 0.0216, 'lps'),
	(571627, 131, '2014-03-01 00:36:14.000000', 'consum', 0.0223, 'lps'),
	(571628, 131, '2014-03-01 00:36:15.000000', 'consum', 0.0224, 'lps'),
	(571629, 131, '2014-03-01 00:36:16.000000', 'consum', 0.0221, 'lps'),
	(571630, 131, '2014-03-01 00:36:17.000000', 'consum', 0.0226, 'lps'),
	(571631, 131, '2014-03-01 00:36:18.000000', 'consum', 0.0219, 'lps'),
	(571632, 131, '2014-03-01 00:36:19.000000', 'consum', 0.0224, 'lps'),
	(571633, 131, '2014-03-01 00:36:20.000000', 'consum', 0.0221, 'lps'),
	(571634, 131, '2014-03-01 00:36:21.000000', 'consum', 0.0222, 'lps'),
	(571635, 131, '2014-03-01 00:36:22.000000', 'consum', 0.0220, 'lps'),
	(571636, 131, '2014-03-01 00:36:23.000000', 'consum', 0.0226, 'lps'),
	(571637, 131, '2014-03-01 00:36:24.000000', 'consum', 0.0225, 'lps'),
	(571638, 131, '2014-03-01 00:36:25.000000', 'consum', 0.0217, 'lps'),
	(571639, 131, '2014-03-01 00:36:26.000000', 'consum', 0.0221, 'lps'),
	(571640, 131, '2014-03-01 00:36:27.000000', 'consum', 0.0225, 'lps'),
	(571641, 131, '2014-03-01 00:36:28.000000', 'consum', 0.0217, 'lps'),
	(571642, 131, '2014-03-01 00:36:29.000000', 'consum', 0.0216, 'lps'),
	(571643, 131, '2014-03-01 00:36:30.000000', 'consum', 0.0222, 'lps'),
	(571644, 131, '2014-03-01 00:36:31.000000', 'consum', 0.0217, 'lps'),
	(571645, 131, '2014-03-01 00:36:32.000000', 'consum', 0.0210, 'lps'),
	(571646, 131, '2014-03-01 00:36:33.000000', 'consum', 0.0223, 'lps'),
	(571647, 131, '2014-03-01 00:36:34.000000', 'consum', 0.0223, 'lps'),
	(571648, 131, '2014-03-01 00:36:35.000000', 'consum', 0.0218, 'lps'),
	(571649, 131, '2014-03-01 00:36:36.000000', 'consum', 0.0211, 'lps'),
	(571650, 131, '2014-03-01 00:36:37.000000', 'consum', 0.0210, 'lps'),
	(571651, 131, '2014-03-01 00:36:38.000000', 'consum', 0.0224, 'lps'),
	(571652, 131, '2014-03-01 00:36:39.000000', 'consum', 0.0210, 'lps'),
	(571653, 131, '2014-03-01 00:36:40.000000', 'consum', 0.0223, 'lps'),
	(571654, 131, '2014-03-01 00:36:41.000000', 'consum', 0.0222, 'lps'),
	(571655, 131, '2014-03-01 00:36:42.000000', 'consum', 0.0215, 'lps'),
	(571656, 131, '2014-03-01 00:36:43.000000', 'consum', 0.0215, 'lps'),
	(571657, 131, '2014-03-01 00:36:44.000000', 'consum', 0.0220, 'lps'),
	(571658, 131, '2014-03-01 00:36:45.000000', 'consum', 0.0226, 'lps'),
	(571659, 131, '2014-03-01 00:36:46.000000', 'consum', 0.0210, 'lps'),
	(571660, 131, '2014-03-01 00:36:47.000000', 'consum', 0.0215, 'lps'),
	(571661, 131, '2014-03-01 00:36:48.000000', 'consum', 0.0216, 'lps'),
	(571662, 131, '2014-03-01 00:36:49.000000', 'consum', 0.0226, 'lps'),
	(571663, 131, '2014-03-01 00:36:50.000000', 'consum', 0.0221, 'lps'),
	(571664, 131, '2014-03-01 00:36:51.000000', 'consum', 0.0216, 'lps'),
	(571665, 131, '2014-03-01 00:36:52.000000', 'consum', 0.0226, 'lps'),
	(571666, 131, '2014-03-01 00:36:53.000000', 'consum', 0.0220, 'lps'),
	(571667, 131, '2014-03-01 00:36:54.000000', 'consum', 0.0210, 'lps'),
	(571668, 131, '2014-03-01 00:36:55.000000', 'consum', 0.0215, 'lps'),
	(571669, 131, '2014-03-01 00:36:56.000000', 'consum', 0.0221, 'lps'),
	(571670, 131, '2014-03-01 00:36:57.000000', 'consum', 0.0213, 'lps'),
	(571671, 131, '2014-03-01 00:36:58.000000', 'consum', 0.0210, 'lps'),
	(571672, 131, '2014-03-01 00:36:59.000000', 'consum', 0.0220, 'lps'),
	(571673, 131, '2014-03-01 00:37:00.000000', 'consum', 0.0223, 'lps'),
	(571674, 131, '2014-03-01 00:37:01.000000', 'consum', 0.0210, 'lps'),
	(571675, 131, '2014-03-01 00:37:02.000000', 'consum', 0.0226, 'lps'),
	(571676, 131, '2014-03-01 00:37:03.000000', 'consum', 0.0220, 'lps'),
	(571677, 131, '2014-03-01 00:37:04.000000', 'consum', 0.0211, 'lps'),
	(571678, 131, '2014-03-01 00:37:05.000000', 'consum', 0.0223, 'lps'),
	(571679, 131, '2014-03-01 00:37:06.000000', 'consum', 0.0217, 'lps'),
	(571680, 131, '2014-03-01 00:37:07.000000', 'consum', 0.0226, 'lps'),
	(571681, 131, '2014-03-01 00:37:08.000000', 'consum', 0.0215, 'lps'),
	(571682, 131, '2014-03-01 00:37:09.000000', 'consum', 0.0222, 'lps'),
	(571683, 131, '2014-03-01 00:37:10.000000', 'consum', 0.0219, 'lps'),
	(571684, 131, '2014-03-01 00:37:11.000000', 'consum', 0.0219, 'lps'),
	(571685, 131, '2014-03-01 00:37:12.000000', 'consum', 0.0211, 'lps'),
	(571686, 131, '2014-03-01 00:37:13.000000', 'consum', 0.0224, 'lps'),
	(571687, 131, '2014-03-01 00:37:14.000000', 'consum', 0.0223, 'lps'),
	(571688, 131, '2014-03-01 00:37:15.000000', 'consum', 0.0216, 'lps'),
	(571689, 131, '2014-03-01 00:37:16.000000', 'consum', 0.0221, 'lps'),
	(571690, 131, '2014-03-01 00:37:17.000000', 'consum', 0.0213, 'lps'),
	(571691, 131, '2014-03-01 00:37:18.000000', 'consum', 0.0225, 'lps'),
	(571692, 131, '2014-03-01 00:37:19.000000', 'consum', 0.0226, 'lps'),
	(571693, 131, '2014-03-01 00:37:20.000000', 'consum', 0.0225, 'lps'),
	(571694, 131, '2014-03-01 00:37:21.000000', 'consum', 0.0221, 'lps'),
	(571695, 131, '2014-03-01 00:37:22.000000', 'consum', 0.0220, 'lps'),
	(571696, 131, '2014-03-01 00:37:23.000000', 'consum', 0.0225, 'lps'),
	(571697, 131, '2014-03-01 00:37:24.000000', 'consum', 0.0223, 'lps'),
	(571698, 131, '2014-03-01 00:37:25.000000', 'consum', 0.0210, 'lps'),
	(571699, 131, '2014-03-01 00:37:26.000000', 'consum', 0.0210, 'lps'),
	(571700, 131, '2014-03-01 00:37:27.000000', 'consum', 0.0210, 'lps'),
	(571701, 131, '2014-03-01 00:37:28.000000', 'consum', 0.0212, 'lps'),
	(571702, 131, '2014-03-01 00:37:29.000000', 'consum', 0.0218, 'lps'),
	(571703, 131, '2014-03-01 00:37:30.000000', 'consum', 0.0211, 'lps'),
	(571704, 131, '2014-03-01 00:37:31.000000', 'consum', 0.0210, 'lps'),
	(571705, 131, '2014-03-01 00:37:32.000000', 'consum', 0.0225, 'lps'),
	(571706, 131, '2014-03-01 00:37:33.000000', 'consum', 0.0213, 'lps'),
	(571707, 131, '2014-03-01 00:37:34.000000', 'consum', 0.0215, 'lps'),
	(571708, 131, '2014-03-01 00:37:35.000000', 'consum', 0.0226, 'lps'),
	(571709, 131, '2014-03-01 00:37:36.000000', 'consum', 0.0221, 'lps'),
	(571710, 131, '2014-03-01 00:37:37.000000', 'consum', 0.0219, 'lps'),
	(571711, 131, '2014-03-01 00:37:38.000000', 'consum', 0.0221, 'lps'),
	(571712, 131, '2014-03-01 00:37:39.000000', 'consum', 0.0221, 'lps'),
	(571713, 131, '2014-03-01 00:37:40.000000', 'consum', 0.0214, 'lps'),
	(571714, 131, '2014-03-01 00:37:41.000000', 'consum', 0.0215, 'lps'),
	(571715, 131, '2014-03-01 00:37:42.000000', 'consum', 0.0225, 'lps'),
	(571716, 131, '2014-03-01 00:37:43.000000', 'consum', 0.0215, 'lps'),
	(571717, 131, '2014-03-01 00:37:44.000000', 'consum', 0.0211, 'lps'),
	(571718, 131, '2014-03-01 00:37:45.000000', 'consum', 0.0216, 'lps'),
	(571719, 131, '2014-03-01 00:37:46.000000', 'consum', 0.0220, 'lps'),
	(571720, 131, '2014-03-01 00:37:47.000000', 'consum', 0.0227, 'lps'),
	(571721, 131, '2014-03-01 00:37:48.000000', 'consum', 0.0227, 'lps'),
	(571722, 131, '2014-03-01 00:37:49.000000', 'consum', 0.0227, 'lps'),
	(571723, 131, '2014-03-01 00:37:50.000000', 'consum', 0.0227, 'lps'),
	(571724, 131, '2014-03-01 00:37:51.000000', 'consum', 0.0226, 'lps'),
	(571725, 131, '2014-03-01 00:37:52.000000', 'consum', 0.0223, 'lps'),
	(571726, 131, '2014-03-01 00:37:53.000000', 'consum', 0.0226, 'lps'),
	(571727, 131, '2014-03-01 00:37:54.000000', 'consum', 0.0214, 'lps'),
	(571728, 131, '2014-03-01 00:37:55.000000', 'consum', 0.0222, 'lps'),
	(571729, 131, '2014-03-01 00:37:56.000000', 'consum', 0.0220, 'lps'),
	(571730, 131, '2014-03-01 00:37:57.000000', 'consum', 0.0223, 'lps'),
	(571731, 131, '2014-03-01 00:37:58.000000', 'consum', 0.0212, 'lps'),
	(571732, 131, '2014-03-01 00:37:59.000000', 'consum', 0.0219, 'lps'),
	(571733, 131, '2014-03-01 00:38:00.000000', 'consum', 0.0211, 'lps'),
	(571734, 131, '2014-03-01 00:38:01.000000', 'consum', 0.0225, 'lps'),
	(571735, 131, '2014-03-01 00:38:02.000000', 'consum', 0.0212, 'lps'),
	(571736, 131, '2014-03-01 00:38:03.000000', 'consum', 0.0226, 'lps'),
	(571737, 131, '2014-03-01 00:38:04.000000', 'consum', 0.0216, 'lps'),
	(571738, 131, '2014-03-01 00:38:05.000000', 'consum', 0.0211, 'lps'),
	(571739, 131, '2014-03-01 00:38:06.000000', 'consum', 0.0214, 'lps'),
	(571740, 131, '2014-03-01 00:38:07.000000', 'consum', 0.0227, 'lps'),
	(571741, 131, '2014-03-01 00:38:08.000000', 'consum', 0.0211, 'lps'),
	(571742, 131, '2014-03-01 00:38:09.000000', 'consum', 0.0218, 'lps'),
	(571743, 131, '2014-03-01 00:38:10.000000', 'consum', 0.0211, 'lps'),
	(571744, 131, '2014-03-01 00:38:11.000000', 'consum', 0.0227, 'lps'),
	(571745, 131, '2014-03-01 00:38:12.000000', 'consum', 0.0223, 'lps'),
	(571746, 131, '2014-03-01 00:38:13.000000', 'consum', 0.0225, 'lps'),
	(571747, 131, '2014-03-01 00:38:14.000000', 'consum', 0.0227, 'lps'),
	(571748, 131, '2014-03-01 00:38:15.000000', 'consum', 0.0217, 'lps'),
	(571749, 131, '2014-03-01 00:38:16.000000', 'consum', 0.0227, 'lps'),
	(571750, 131, '2014-03-01 00:38:17.000000', 'consum', 0.0223, 'lps'),
	(571751, 131, '2014-03-01 00:38:18.000000', 'consum', 0.0226, 'lps'),
	(571752, 131, '2014-03-01 00:38:19.000000', 'consum', 0.0212, 'lps'),
	(571753, 131, '2014-03-01 00:38:20.000000', 'consum', 0.0212, 'lps'),
	(571754, 131, '2014-03-01 00:38:21.000000', 'consum', 0.0211, 'lps'),
	(571755, 131, '2014-03-01 00:38:22.000000', 'consum', 0.0212, 'lps'),
	(571756, 131, '2014-03-01 00:38:23.000000', 'consum', 0.0216, 'lps'),
	(571757, 131, '2014-03-01 00:38:24.000000', 'consum', 0.0218, 'lps'),
	(571758, 131, '2014-03-01 00:38:25.000000', 'consum', 0.0213, 'lps'),
	(571759, 131, '2014-03-01 00:38:26.000000', 'consum', 0.0221, 'lps'),
	(571760, 131, '2014-03-01 00:38:27.000000', 'consum', 0.0218, 'lps'),
	(571761, 131, '2014-03-01 00:38:28.000000', 'consum', 0.0218, 'lps'),
	(571762, 131, '2014-03-01 00:38:29.000000', 'consum', 0.0226, 'lps'),
	(571763, 131, '2014-03-01 00:38:30.000000', 'consum', 0.0213, 'lps'),
	(571764, 131, '2014-03-01 00:38:31.000000', 'consum', 0.0213, 'lps'),
	(571765, 131, '2014-03-01 00:38:32.000000', 'consum', 0.0217, 'lps'),
	(571766, 131, '2014-03-01 00:38:33.000000', 'consum', 0.0218, 'lps'),
	(571767, 131, '2014-03-01 00:38:34.000000', 'consum', 0.0211, 'lps'),
	(571768, 131, '2014-03-01 00:38:35.000000', 'consum', 0.0227, 'lps'),
	(571769, 131, '2014-03-01 00:38:36.000000', 'consum', 0.0223, 'lps'),
	(571770, 131, '2014-03-01 00:38:37.000000', 'consum', 0.0222, 'lps'),
	(571771, 131, '2014-03-01 00:38:38.000000', 'consum', 0.0213, 'lps'),
	(571772, 131, '2014-03-01 00:38:39.000000', 'consum', 0.0227, 'lps'),
	(571773, 131, '2014-03-01 00:38:40.000000', 'consum', 0.0215, 'lps'),
	(571774, 131, '2014-03-01 00:38:41.000000', 'consum', 0.0219, 'lps'),
	(571775, 131, '2014-03-01 00:38:42.000000', 'consum', 0.0223, 'lps'),
	(571776, 131, '2014-03-01 00:38:43.000000', 'consum', 0.0212, 'lps'),
	(571777, 131, '2014-03-01 00:38:44.000000', 'consum', 0.0219, 'lps'),
	(571778, 131, '2014-03-01 00:38:45.000000', 'consum', 0.0214, 'lps'),
	(571779, 131, '2014-03-01 00:38:46.000000', 'consum', 0.0219, 'lps'),
	(571780, 131, '2014-03-01 00:38:47.000000', 'consum', 0.0226, 'lps'),
	(571781, 131, '2014-03-01 00:38:48.000000', 'consum', 0.0210, 'lps'),
	(571782, 131, '2014-03-01 00:38:49.000000', 'consum', 0.0216, 'lps'),
	(571783, 131, '2014-03-01 00:38:50.000000', 'consum', 0.0225, 'lps'),
	(571784, 131, '2014-03-01 00:38:51.000000', 'consum', 0.0210, 'lps'),
	(571785, 131, '2014-03-01 00:38:52.000000', 'consum', 0.0223, 'lps'),
	(571786, 131, '2014-03-01 00:38:53.000000', 'consum', 0.0219, 'lps'),
	(571787, 131, '2014-03-01 00:38:54.000000', 'consum', 0.0218, 'lps'),
	(571788, 131, '2014-03-01 00:38:55.000000', 'consum', 0.0225, 'lps'),
	(571789, 131, '2014-03-01 00:38:56.000000', 'consum', 0.0222, 'lps'),
	(571790, 131, '2014-03-01 00:38:57.000000', 'consum', 0.0227, 'lps'),
	(571791, 131, '2014-03-01 00:38:58.000000', 'consum', 0.0224, 'lps'),
	(571792, 131, '2014-03-01 00:38:59.000000', 'consum', 0.0227, 'lps'),
	(571793, 131, '2014-03-01 00:39:00.000000', 'consum', 0.0220, 'lps'),
	(571794, 131, '2014-03-01 00:39:01.000000', 'consum', 0.0227, 'lps'),
	(571795, 131, '2014-03-01 00:39:02.000000', 'consum', 0.0211, 'lps'),
	(571796, 131, '2014-03-01 00:39:03.000000', 'consum', 0.0218, 'lps'),
	(571797, 131, '2014-03-01 00:39:04.000000', 'consum', 0.0210, 'lps'),
	(571798, 131, '2014-03-01 00:39:05.000000', 'consum', 0.0224, 'lps'),
	(571799, 131, '2014-03-01 00:39:06.000000', 'consum', 0.0227, 'lps'),
	(571800, 131, '2014-03-01 00:39:07.000000', 'consum', 0.0218, 'lps'),
	(571801, 131, '2014-03-01 00:39:08.000000', 'consum', 0.0218, 'lps'),
	(571802, 131, '2014-03-01 00:39:09.000000', 'consum', 0.0227, 'lps'),
	(571803, 131, '2014-03-01 00:39:10.000000', 'consum', 0.0218, 'lps'),
	(571804, 131, '2014-03-01 00:39:11.000000', 'consum', 0.0215, 'lps'),
	(571805, 131, '2014-03-01 00:39:12.000000', 'consum', 0.0213, 'lps'),
	(571806, 131, '2014-03-01 00:39:13.000000', 'consum', 0.0210, 'lps'),
	(571807, 131, '2014-03-01 00:39:14.000000', 'consum', 0.0219, 'lps'),
	(571808, 131, '2014-03-01 00:39:15.000000', 'consum', 0.0220, 'lps'),
	(571809, 131, '2014-03-01 00:39:16.000000', 'consum', 0.0216, 'lps'),
	(571810, 131, '2014-03-01 00:39:17.000000', 'consum', 0.0211, 'lps'),
	(571811, 131, '2014-03-01 00:39:18.000000', 'consum', 0.0216, 'lps'),
	(571812, 131, '2014-03-01 00:39:19.000000', 'consum', 0.0220, 'lps'),
	(571813, 131, '2014-03-01 00:39:20.000000', 'consum', 0.0222, 'lps'),
	(571814, 131, '2014-03-01 00:39:21.000000', 'consum', 0.0224, 'lps'),
	(571815, 131, '2014-03-01 00:39:22.000000', 'consum', 0.0210, 'lps'),
	(571816, 131, '2014-03-01 00:39:23.000000', 'consum', 0.0221, 'lps'),
	(571817, 131, '2014-03-01 00:39:24.000000', 'consum', 0.0214, 'lps'),
	(571818, 131, '2014-03-01 00:39:25.000000', 'consum', 0.0213, 'lps'),
	(571819, 131, '2014-03-01 00:39:26.000000', 'consum', 0.0212, 'lps'),
	(571820, 131, '2014-03-01 00:39:27.000000', 'consum', 0.0213, 'lps'),
	(571821, 131, '2014-03-01 00:39:28.000000', 'consum', 0.0220, 'lps'),
	(571822, 131, '2014-03-01 00:39:29.000000', 'consum', 0.0216, 'lps'),
	(571823, 131, '2014-03-01 00:39:30.000000', 'consum', 0.0211, 'lps'),
	(571824, 131, '2014-03-01 00:39:31.000000', 'consum', 0.0217, 'lps'),
	(571825, 131, '2014-03-01 00:39:32.000000', 'consum', 0.0222, 'lps'),
	(571826, 131, '2014-03-01 00:39:33.000000', 'consum', 0.0212, 'lps'),
	(571827, 131, '2014-03-01 00:39:34.000000', 'consum', 0.0224, 'lps'),
	(571828, 131, '2014-03-01 00:39:35.000000', 'consum', 0.0218, 'lps'),
	(571829, 131, '2014-03-01 00:39:36.000000', 'consum', 0.0210, 'lps'),
	(571830, 131, '2014-03-01 00:39:37.000000', 'consum', 0.0220, 'lps'),
	(571831, 131, '2014-03-01 00:39:38.000000', 'consum', 0.0225, 'lps'),
	(571832, 131, '2014-03-01 00:39:39.000000', 'consum', 0.0222, 'lps'),
	(571833, 131, '2014-03-01 00:39:40.000000', 'consum', 0.0223, 'lps'),
	(571834, 131, '2014-03-01 00:39:41.000000', 'consum', 0.0224, 'lps'),
	(571835, 131, '2014-03-01 00:39:42.000000', 'consum', 0.0221, 'lps'),
	(571836, 131, '2014-03-01 00:39:43.000000', 'consum', 0.0224, 'lps'),
	(571837, 131, '2014-03-01 00:39:44.000000', 'consum', 0.0212, 'lps'),
	(571838, 131, '2014-03-01 00:39:45.000000', 'consum', 0.0213, 'lps'),
	(571839, 131, '2014-03-01 00:39:46.000000', 'consum', 0.0220, 'lps'),
	(571840, 131, '2014-03-01 00:39:47.000000', 'consum', 0.0217, 'lps'),
	(571841, 131, '2014-03-01 00:39:48.000000', 'consum', 0.0216, 'lps'),
	(571842, 131, '2014-03-01 00:39:49.000000', 'consum', 0.0220, 'lps'),
	(571843, 131, '2014-03-01 00:39:50.000000', 'consum', 0.0222, 'lps'),
	(571844, 131, '2014-03-01 00:39:51.000000', 'consum', 0.0223, 'lps'),
	(571845, 131, '2014-03-01 00:39:52.000000', 'consum', 0.0222, 'lps'),
	(571846, 131, '2014-03-01 00:39:53.000000', 'consum', 0.0215, 'lps'),
	(571847, 131, '2014-03-01 00:39:54.000000', 'consum', 0.0216, 'lps'),
	(571848, 131, '2014-03-01 00:39:55.000000', 'consum', 0.0224, 'lps'),
	(571849, 131, '2014-03-01 00:39:56.000000', 'consum', 0.0210, 'lps'),
	(571850, 131, '2014-03-01 00:39:57.000000', 'consum', 0.0222, 'lps'),
	(571851, 131, '2014-03-01 00:39:58.000000', 'consum', 0.0215, 'lps'),
	(571852, 131, '2014-03-01 00:39:59.000000', 'consum', 0.0220, 'lps'),
	(571853, 131, '2014-03-01 00:40:00.000000', 'consum', 0.0210, 'lps'),
	(571854, 131, '2014-03-01 00:40:01.000000', 'consum', 0.0216, 'lps'),
	(571855, 131, '2014-03-01 00:40:02.000000', 'consum', 0.0222, 'lps'),
	(571856, 131, '2014-03-01 00:40:03.000000', 'consum', 0.0217, 'lps'),
	(571857, 131, '2014-03-01 00:40:04.000000', 'consum', 0.0225, 'lps'),
	(571858, 131, '2014-03-01 00:40:05.000000', 'consum', 0.0214, 'lps'),
	(571859, 131, '2014-03-01 00:40:06.000000', 'consum', 0.0218, 'lps'),
	(571860, 131, '2014-03-01 00:40:07.000000', 'consum', 0.0223, 'lps'),
	(571861, 131, '2014-03-01 00:40:08.000000', 'consum', 0.0214, 'lps'),
	(571862, 131, '2014-03-01 00:40:09.000000', 'consum', 0.0211, 'lps'),
	(571863, 131, '2014-03-01 00:40:10.000000', 'consum', 0.0221, 'lps'),
	(571864, 131, '2014-03-01 00:40:11.000000', 'consum', 0.0226, 'lps'),
	(571865, 131, '2014-03-01 00:40:12.000000', 'consum', 0.0222, 'lps'),
	(571866, 131, '2014-03-01 00:40:13.000000', 'consum', 0.0223, 'lps'),
	(571867, 131, '2014-03-01 00:40:14.000000', 'consum', 0.0219, 'lps'),
	(571868, 131, '2014-03-01 00:40:15.000000', 'consum', 0.0218, 'lps'),
	(571869, 131, '2014-03-01 00:40:16.000000', 'consum', 0.0222, 'lps'),
	(571870, 131, '2014-03-01 00:40:17.000000', 'consum', 0.0213, 'lps'),
	(571871, 131, '2014-03-01 00:40:18.000000', 'consum', 0.0222, 'lps'),
	(571872, 131, '2014-03-01 00:40:19.000000', 'consum', 0.0211, 'lps'),
	(571873, 131, '2014-03-01 00:40:20.000000', 'consum', 0.0214, 'lps'),
	(571874, 131, '2014-03-01 00:40:21.000000', 'consum', 0.0226, 'lps'),
	(571875, 131, '2014-03-01 00:40:22.000000', 'consum', 0.0225, 'lps'),
	(571876, 131, '2014-03-01 00:40:23.000000', 'consum', 0.0219, 'lps'),
	(571877, 131, '2014-03-01 00:40:24.000000', 'consum', 0.0212, 'lps'),
	(571878, 131, '2014-03-01 00:40:25.000000', 'consum', 0.0212, 'lps'),
	(571879, 131, '2014-03-01 00:40:26.000000', 'consum', 0.0214, 'lps'),
	(571880, 131, '2014-03-01 00:40:27.000000', 'consum', 0.0223, 'lps'),
	(571881, 131, '2014-03-01 00:40:28.000000', 'consum', 0.0211, 'lps'),
	(571882, 131, '2014-03-01 00:40:29.000000', 'consum', 0.0213, 'lps'),
	(571883, 131, '2014-03-01 00:40:30.000000', 'consum', 0.0222, 'lps'),
	(571884, 131, '2014-03-01 00:40:31.000000', 'consum', 0.0224, 'lps'),
	(571885, 131, '2014-03-01 00:40:32.000000', 'consum', 0.0227, 'lps'),
	(571886, 131, '2014-03-01 00:40:33.000000', 'consum', 0.0220, 'lps'),
	(571887, 131, '2014-03-01 00:40:34.000000', 'consum', 0.0224, 'lps'),
	(571888, 131, '2014-03-01 00:40:35.000000', 'consum', 0.0216, 'lps'),
	(571889, 131, '2014-03-01 00:40:36.000000', 'consum', 0.0215, 'lps'),
	(571890, 131, '2014-03-01 00:40:37.000000', 'consum', 0.0220, 'lps'),
	(571891, 131, '2014-03-01 00:40:38.000000', 'consum', 0.0210, 'lps'),
	(571892, 131, '2014-03-01 00:40:39.000000', 'consum', 0.0216, 'lps'),
	(571893, 131, '2014-03-01 00:40:40.000000', 'consum', 0.0221, 'lps'),
	(571894, 131, '2014-03-01 00:40:41.000000', 'consum', 0.0212, 'lps'),
	(571895, 131, '2014-03-01 00:40:42.000000', 'consum', 0.0225, 'lps'),
	(571896, 131, '2014-03-01 00:40:43.000000', 'consum', 0.0225, 'lps'),
	(571897, 131, '2014-03-01 00:40:44.000000', 'consum', 0.0221, 'lps'),
	(571898, 131, '2014-03-01 00:40:45.000000', 'consum', 0.0219, 'lps'),
	(571899, 131, '2014-03-01 00:40:46.000000', 'consum', 0.0226, 'lps'),
	(571900, 131, '2014-03-01 00:40:47.000000', 'consum', 0.0226, 'lps'),
	(571901, 131, '2014-03-01 00:40:48.000000', 'consum', 0.0224, 'lps'),
	(571902, 131, '2014-03-01 00:40:49.000000', 'consum', 0.0215, 'lps'),
	(571903, 131, '2014-03-01 00:40:50.000000', 'consum', 0.0212, 'lps'),
	(571904, 131, '2014-03-01 00:40:51.000000', 'consum', 0.0224, 'lps'),
	(571905, 131, '2014-03-01 00:40:52.000000', 'consum', 0.0222, 'lps'),
	(571906, 131, '2014-03-01 00:40:53.000000', 'consum', 0.0225, 'lps'),
	(571907, 131, '2014-03-01 00:40:54.000000', 'consum', 0.0215, 'lps'),
	(571908, 131, '2014-03-01 00:40:55.000000', 'consum', 0.0224, 'lps'),
	(571909, 131, '2014-03-01 00:40:56.000000', 'consum', 0.0215, 'lps'),
	(571910, 131, '2014-03-01 00:40:57.000000', 'consum', 0.0227, 'lps'),
	(571911, 131, '2014-03-01 00:40:58.000000', 'consum', 0.0210, 'lps'),
	(571912, 131, '2014-03-01 00:40:59.000000', 'consum', 0.0211, 'lps'),
	(571913, 131, '2014-03-01 00:41:00.000000', 'consum', 0.0219, 'lps'),
	(571914, 131, '2014-03-01 00:41:01.000000', 'consum', 0.0215, 'lps'),
	(571915, 131, '2014-03-01 00:41:02.000000', 'consum', 0.0227, 'lps'),
	(571916, 131, '2014-03-01 00:41:03.000000', 'consum', 0.0226, 'lps'),
	(571917, 131, '2014-03-01 00:41:04.000000', 'consum', 0.0223, 'lps'),
	(571918, 131, '2014-03-01 00:41:05.000000', 'consum', 0.0225, 'lps'),
	(571919, 131, '2014-03-01 00:41:06.000000', 'consum', 0.0210, 'lps'),
	(571920, 131, '2014-03-01 00:41:07.000000', 'consum', 0.0222, 'lps'),
	(571921, 131, '2014-03-01 00:41:08.000000', 'consum', 0.0216, 'lps'),
	(571922, 131, '2014-03-01 00:41:09.000000', 'consum', 0.0222, 'lps'),
	(571923, 131, '2014-03-01 00:41:10.000000', 'consum', 0.0215, 'lps'),
	(571924, 131, '2014-03-01 00:41:11.000000', 'consum', 0.0221, 'lps'),
	(571925, 131, '2014-03-01 00:41:12.000000', 'consum', 0.0211, 'lps'),
	(571926, 131, '2014-03-01 00:41:13.000000', 'consum', 0.0219, 'lps'),
	(571927, 131, '2014-03-01 00:41:14.000000', 'consum', 0.0216, 'lps'),
	(571928, 131, '2014-03-01 00:41:15.000000', 'consum', 0.0215, 'lps'),
	(571929, 131, '2014-03-01 00:41:16.000000', 'consum', 0.0216, 'lps'),
	(571930, 131, '2014-03-01 00:41:17.000000', 'consum', 0.0226, 'lps'),
	(571931, 131, '2014-03-01 00:41:18.000000', 'consum', 0.0219, 'lps'),
	(571932, 131, '2014-03-01 00:41:19.000000', 'consum', 0.0225, 'lps'),
	(571933, 131, '2014-03-01 00:41:20.000000', 'consum', 0.0222, 'lps'),
	(571934, 131, '2014-03-01 00:41:21.000000', 'consum', 0.0227, 'lps'),
	(571935, 131, '2014-03-01 00:41:22.000000', 'consum', 0.0221, 'lps'),
	(571936, 131, '2014-03-01 00:41:23.000000', 'consum', 0.0218, 'lps'),
	(571937, 131, '2014-03-01 00:41:24.000000', 'consum', 0.0215, 'lps'),
	(571938, 131, '2014-03-01 00:41:25.000000', 'consum', 0.0214, 'lps'),
	(571939, 131, '2014-03-01 00:41:26.000000', 'consum', 0.0212, 'lps'),
	(571940, 131, '2014-03-01 00:41:27.000000', 'consum', 0.0212, 'lps'),
	(571941, 131, '2014-03-01 00:41:28.000000', 'consum', 0.0211, 'lps'),
	(571942, 131, '2014-03-01 00:41:29.000000', 'consum', 0.0211, 'lps'),
	(571943, 131, '2014-03-01 00:41:30.000000', 'consum', 0.0214, 'lps'),
	(571944, 131, '2014-03-01 00:41:31.000000', 'consum', 0.0227, 'lps'),
	(571945, 131, '2014-03-01 00:41:32.000000', 'consum', 0.0212, 'lps'),
	(571946, 131, '2014-03-01 00:41:33.000000', 'consum', 0.0222, 'lps'),
	(571947, 131, '2014-03-01 00:41:34.000000', 'consum', 0.0210, 'lps'),
	(571948, 131, '2014-03-01 00:41:35.000000', 'consum', 0.0212, 'lps'),
	(571949, 131, '2014-03-01 00:41:36.000000', 'consum', 0.0221, 'lps'),
	(571950, 131, '2014-03-01 00:41:37.000000', 'consum', 0.0223, 'lps'),
	(571951, 131, '2014-03-01 00:41:38.000000', 'consum', 0.0226, 'lps'),
	(571952, 131, '2014-03-01 00:41:39.000000', 'consum', 0.0216, 'lps'),
	(571953, 131, '2014-03-01 00:41:40.000000', 'consum', 0.0226, 'lps'),
	(571954, 131, '2014-03-01 00:41:41.000000', 'consum', 0.0221, 'lps'),
	(571955, 131, '2014-03-01 00:41:42.000000', 'consum', 0.0218, 'lps'),
	(571956, 131, '2014-03-01 00:41:43.000000', 'consum', 0.0218, 'lps'),
	(571957, 131, '2014-03-01 00:41:44.000000', 'consum', 0.0227, 'lps'),
	(571958, 131, '2014-03-01 00:41:45.000000', 'consum', 0.0216, 'lps'),
	(571959, 131, '2014-03-01 00:41:46.000000', 'consum', 0.0227, 'lps'),
	(571960, 131, '2014-03-01 00:41:47.000000', 'consum', 0.0224, 'lps'),
	(571961, 131, '2014-03-01 00:41:48.000000', 'consum', 0.0210, 'lps'),
	(571962, 131, '2014-03-01 00:41:49.000000', 'consum', 0.0221, 'lps'),
	(571963, 131, '2014-03-01 00:41:50.000000', 'consum', 0.0214, 'lps'),
	(571964, 131, '2014-03-01 00:41:51.000000', 'consum', 0.0213, 'lps'),
	(571965, 131, '2014-03-01 00:41:52.000000', 'consum', 0.0216, 'lps'),
	(571966, 131, '2014-03-01 00:41:53.000000', 'consum', 0.0212, 'lps'),
	(571967, 131, '2014-03-01 00:41:54.000000', 'consum', 0.0220, 'lps'),
	(571968, 131, '2014-03-01 00:41:55.000000', 'consum', 0.0217, 'lps'),
	(571969, 131, '2014-03-01 00:41:56.000000', 'consum', 0.0218, 'lps'),
	(571970, 131, '2014-03-01 00:41:57.000000', 'consum', 0.0212, 'lps'),
	(571971, 131, '2014-03-01 00:41:58.000000', 'consum', 0.0212, 'lps'),
	(571972, 131, '2014-03-01 00:41:59.000000', 'consum', 0.0217, 'lps'),
	(571973, 131, '2014-03-01 00:42:00.000000', 'consum', 0.0221, 'lps'),
	(571974, 131, '2014-03-01 00:42:01.000000', 'consum', 0.0224, 'lps'),
	(571975, 131, '2014-03-01 00:42:02.000000', 'consum', 0.0213, 'lps'),
	(571976, 131, '2014-03-01 00:42:03.000000', 'consum', 0.0221, 'lps'),
	(571977, 131, '2014-03-01 00:42:04.000000', 'consum', 0.0221, 'lps'),
	(571978, 131, '2014-03-01 00:42:05.000000', 'consum', 0.0214, 'lps'),
	(571979, 131, '2014-03-01 00:42:06.000000', 'consum', 0.0214, 'lps'),
	(571980, 131, '2014-03-01 00:42:07.000000', 'consum', 0.0220, 'lps'),
	(571981, 131, '2014-03-01 00:42:08.000000', 'consum', 0.0213, 'lps'),
	(571982, 131, '2014-03-01 00:42:09.000000', 'consum', 0.0211, 'lps'),
	(571983, 131, '2014-03-01 00:42:10.000000', 'consum', 0.0226, 'lps'),
	(571984, 131, '2014-03-01 00:42:11.000000', 'consum', 0.0217, 'lps'),
	(571985, 131, '2014-03-01 00:42:12.000000', 'consum', 0.0215, 'lps'),
	(571986, 131, '2014-03-01 00:42:13.000000', 'consum', 0.0213, 'lps'),
	(571987, 131, '2014-03-01 00:42:14.000000', 'consum', 0.0212, 'lps'),
	(571988, 131, '2014-03-01 00:42:15.000000', 'consum', 0.0212, 'lps'),
	(571989, 131, '2014-03-01 00:42:16.000000', 'consum', 0.0214, 'lps'),
	(571990, 131, '2014-03-01 00:42:17.000000', 'consum', 0.0225, 'lps'),
	(571991, 131, '2014-03-01 00:42:18.000000', 'consum', 0.0219, 'lps'),
	(571992, 131, '2014-03-01 00:42:19.000000', 'consum', 0.0227, 'lps'),
	(571993, 131, '2014-03-01 00:42:20.000000', 'consum', 0.0214, 'lps'),
	(571994, 131, '2014-03-01 00:42:21.000000', 'consum', 0.0216, 'lps'),
	(571995, 131, '2014-03-01 00:42:22.000000', 'consum', 0.0212, 'lps'),
	(571996, 131, '2014-03-01 00:42:23.000000', 'consum', 0.0221, 'lps'),
	(571997, 131, '2014-03-01 00:42:24.000000', 'consum', 0.0225, 'lps'),
	(571998, 131, '2014-03-01 00:42:25.000000', 'consum', 0.0214, 'lps'),
	(571999, 131, '2014-03-01 00:42:26.000000', 'consum', 0.0220, 'lps'),
	(572000, 131, '2014-03-01 00:42:27.000000', 'consum', 0.0214, 'lps'),
	(572001, 131, '2014-03-01 00:42:28.000000', 'consum', 0.0220, 'lps'),
	(572002, 131, '2014-03-01 00:42:29.000000', 'consum', 0.0211, 'lps'),
	(572003, 131, '2014-03-01 00:42:30.000000', 'consum', 0.0222, 'lps'),
	(572004, 131, '2014-03-01 00:42:31.000000', 'consum', 0.0212, 'lps'),
	(572005, 131, '2014-03-01 00:42:32.000000', 'consum', 0.0223, 'lps'),
	(572006, 131, '2014-03-01 00:42:33.000000', 'consum', 0.0213, 'lps'),
	(572007, 131, '2014-03-01 00:42:34.000000', 'consum', 0.0225, 'lps'),
	(572008, 131, '2014-03-01 00:42:35.000000', 'consum', 0.0221, 'lps'),
	(572009, 131, '2014-03-01 00:42:36.000000', 'consum', 0.0219, 'lps'),
	(572010, 131, '2014-03-01 00:42:37.000000', 'consum', 0.0222, 'lps'),
	(572011, 131, '2014-03-01 00:42:38.000000', 'consum', 0.0210, 'lps'),
	(572012, 131, '2014-03-01 00:42:39.000000', 'consum', 0.0211, 'lps'),
	(572013, 131, '2014-03-01 00:42:40.000000', 'consum', 0.0216, 'lps'),
	(572014, 131, '2014-03-01 00:42:41.000000', 'consum', 0.0219, 'lps'),
	(572015, 131, '2014-03-01 00:42:42.000000', 'consum', 0.0220, 'lps'),
	(572016, 131, '2014-03-01 00:42:43.000000', 'consum', 0.0214, 'lps'),
	(572017, 131, '2014-03-01 00:42:44.000000', 'consum', 0.0219, 'lps'),
	(572018, 131, '2014-03-01 00:42:45.000000', 'consum', 0.0224, 'lps'),
	(572019, 131, '2014-03-01 00:42:46.000000', 'consum', 0.0217, 'lps'),
	(572020, 131, '2014-03-01 00:42:47.000000', 'consum', 0.0223, 'lps'),
	(572021, 131, '2014-03-01 00:42:48.000000', 'consum', 0.0220, 'lps'),
	(572022, 131, '2014-03-01 00:42:49.000000', 'consum', 0.0221, 'lps'),
	(572023, 131, '2014-03-01 00:42:50.000000', 'consum', 0.0216, 'lps'),
	(572024, 131, '2014-03-01 00:42:51.000000', 'consum', 0.0225, 'lps'),
	(572025, 131, '2014-03-01 00:42:52.000000', 'consum', 0.0216, 'lps'),
	(572026, 131, '2014-03-01 00:42:53.000000', 'consum', 0.0214, 'lps'),
	(572027, 131, '2014-03-01 00:42:54.000000', 'consum', 0.0212, 'lps'),
	(572028, 131, '2014-03-01 00:42:55.000000', 'consum', 0.0227, 'lps'),
	(572029, 131, '2014-03-01 00:42:56.000000', 'consum', 0.0217, 'lps'),
	(572030, 131, '2014-03-01 00:42:57.000000', 'consum', 0.0214, 'lps'),
	(572031, 131, '2014-03-01 00:42:58.000000', 'consum', 0.0226, 'lps'),
	(572032, 131, '2014-03-01 00:42:59.000000', 'consum', 0.0225, 'lps'),
	(572033, 131, '2014-03-01 00:43:00.000000', 'consum', 0.0221, 'lps'),
	(572034, 131, '2014-03-01 00:43:01.000000', 'consum', 0.0221, 'lps'),
	(572035, 131, '2014-03-01 00:43:02.000000', 'consum', 0.0214, 'lps'),
	(572036, 131, '2014-03-01 00:43:03.000000', 'consum', 0.0215, 'lps'),
	(572037, 131, '2014-03-01 00:43:04.000000', 'consum', 0.0223, 'lps'),
	(572038, 131, '2014-03-01 00:43:05.000000', 'consum', 0.0225, 'lps'),
	(572039, 131, '2014-03-01 00:43:06.000000', 'consum', 0.0226, 'lps'),
	(572040, 131, '2014-03-01 00:43:07.000000', 'consum', 0.0213, 'lps'),
	(572041, 131, '2014-03-01 00:43:08.000000', 'consum', 0.0210, 'lps'),
	(572042, 131, '2014-03-01 00:43:09.000000', 'consum', 0.0223, 'lps'),
	(572043, 131, '2014-03-01 00:43:10.000000', 'consum', 0.0221, 'lps'),
	(572044, 131, '2014-03-01 00:43:11.000000', 'consum', 0.0225, 'lps'),
	(572045, 131, '2014-03-01 00:43:12.000000', 'consum', 0.0218, 'lps'),
	(572046, 131, '2014-03-01 00:43:13.000000', 'consum', 0.0222, 'lps'),
	(572047, 131, '2014-03-01 00:43:14.000000', 'consum', 0.0212, 'lps'),
	(572048, 131, '2014-03-01 00:43:15.000000', 'consum', 0.0221, 'lps'),
	(572049, 131, '2014-03-01 00:43:16.000000', 'consum', 0.0221, 'lps'),
	(572050, 131, '2014-03-01 00:43:17.000000', 'consum', 0.0216, 'lps'),
	(572051, 131, '2014-03-01 00:43:18.000000', 'consum', 0.0225, 'lps'),
	(572052, 131, '2014-03-01 00:43:19.000000', 'consum', 0.0212, 'lps'),
	(572053, 131, '2014-03-01 00:43:20.000000', 'consum', 0.0212, 'lps'),
	(572054, 131, '2014-03-01 00:43:21.000000', 'consum', 0.0214, 'lps'),
	(572055, 131, '2014-03-01 00:43:22.000000', 'consum', 0.0223, 'lps'),
	(572056, 131, '2014-03-01 00:43:23.000000', 'consum', 0.0211, 'lps'),
	(572057, 131, '2014-03-01 00:43:24.000000', 'consum', 0.0214, 'lps'),
	(572058, 131, '2014-03-01 00:43:25.000000', 'consum', 0.0227, 'lps'),
	(572059, 131, '2014-03-01 00:43:26.000000', 'consum', 0.0210, 'lps'),
	(572060, 131, '2014-03-01 00:43:27.000000', 'consum', 0.0216, 'lps'),
	(572061, 131, '2014-03-01 00:43:28.000000', 'consum', 0.0222, 'lps'),
	(572062, 131, '2014-03-01 00:43:29.000000', 'consum', 0.0215, 'lps'),
	(572063, 131, '2014-03-01 00:43:30.000000', 'consum', 0.0216, 'lps'),
	(572064, 131, '2014-03-01 00:43:31.000000', 'consum', 0.0210, 'lps'),
	(572065, 131, '2014-03-01 00:43:32.000000', 'consum', 0.0226, 'lps'),
	(572066, 131, '2014-03-01 00:43:33.000000', 'consum', 0.0219, 'lps'),
	(572067, 131, '2014-03-01 00:43:34.000000', 'consum', 0.0210, 'lps'),
	(572068, 131, '2014-03-01 00:43:35.000000', 'consum', 0.0216, 'lps'),
	(572069, 131, '2014-03-01 00:43:36.000000', 'consum', 0.0226, 'lps'),
	(572070, 131, '2014-03-01 00:43:37.000000', 'consum', 0.0217, 'lps'),
	(572071, 131, '2014-03-01 00:43:38.000000', 'consum', 0.0214, 'lps'),
	(572072, 131, '2014-03-01 00:43:39.000000', 'consum', 0.0213, 'lps'),
	(572073, 131, '2014-03-01 00:43:40.000000', 'consum', 0.0210, 'lps'),
	(572074, 131, '2014-03-01 00:43:41.000000', 'consum', 0.0222, 'lps'),
	(572075, 131, '2014-03-01 00:43:42.000000', 'consum', 0.0217, 'lps'),
	(572076, 131, '2014-03-01 00:43:43.000000', 'consum', 0.0211, 'lps'),
	(572077, 131, '2014-03-01 00:43:44.000000', 'consum', 0.0227, 'lps'),
	(572078, 131, '2014-03-01 00:43:45.000000', 'consum', 0.0221, 'lps'),
	(572079, 131, '2014-03-01 00:43:46.000000', 'consum', 0.0213, 'lps'),
	(572080, 131, '2014-03-01 00:43:47.000000', 'consum', 0.0212, 'lps'),
	(572081, 131, '2014-03-01 00:43:48.000000', 'consum', 0.0212, 'lps'),
	(572082, 131, '2014-03-01 00:43:49.000000', 'consum', 0.0214, 'lps'),
	(572083, 131, '2014-03-01 00:43:50.000000', 'consum', 0.0225, 'lps'),
	(572084, 131, '2014-03-01 00:43:51.000000', 'consum', 0.0220, 'lps'),
	(572085, 131, '2014-03-01 00:43:52.000000', 'consum', 0.0214, 'lps'),
	(572086, 131, '2014-03-01 00:43:53.000000', 'consum', 0.0220, 'lps'),
	(572087, 131, '2014-03-01 00:43:54.000000', 'consum', 0.0214, 'lps'),
	(572088, 131, '2014-03-01 00:43:55.000000', 'consum', 0.0216, 'lps'),
	(572089, 131, '2014-03-01 00:43:56.000000', 'consum', 0.0213, 'lps'),
	(572090, 131, '2014-03-01 00:43:57.000000', 'consum', 0.0224, 'lps'),
	(572091, 131, '2014-03-01 00:43:58.000000', 'consum', 0.0217, 'lps'),
	(572092, 131, '2014-03-01 00:43:59.000000', 'consum', 0.0222, 'lps'),
	(572093, 131, '2014-03-01 00:44:00.000000', 'consum', 0.0213, 'lps'),
	(572094, 131, '2014-03-01 00:44:01.000000', 'consum', 0.0227, 'lps'),
	(572095, 131, '2014-03-01 00:44:02.000000', 'consum', 0.0215, 'lps'),
	(572096, 131, '2014-03-01 00:44:03.000000', 'consum', 0.0221, 'lps'),
	(572097, 131, '2014-03-01 00:44:04.000000', 'consum', 0.0215, 'lps'),
	(572098, 131, '2014-03-01 00:44:05.000000', 'consum', 0.0220, 'lps'),
	(572099, 131, '2014-03-01 00:44:06.000000', 'consum', 0.0227, 'lps'),
	(572100, 131, '2014-03-01 00:44:07.000000', 'consum', 0.0213, 'lps'),
	(572101, 131, '2014-03-01 00:44:08.000000', 'consum', 0.0211, 'lps'),
	(572102, 131, '2014-03-01 00:44:09.000000', 'consum', 0.0223, 'lps'),
	(572103, 131, '2014-03-01 00:44:10.000000', 'consum', 0.0220, 'lps'),
	(572104, 131, '2014-03-01 00:44:11.000000', 'consum', 0.0219, 'lps'),
	(572105, 131, '2014-03-01 00:44:12.000000', 'consum', 0.0210, 'lps'),
	(572106, 131, '2014-03-01 00:44:13.000000', 'consum', 0.0218, 'lps'),
	(572107, 131, '2014-03-01 00:44:14.000000', 'consum', 0.0215, 'lps'),
	(572108, 131, '2014-03-01 00:44:15.000000', 'consum', 0.0227, 'lps'),
	(572109, 131, '2014-03-01 00:44:16.000000', 'consum', 0.0212, 'lps'),
	(572110, 131, '2014-03-01 00:44:17.000000', 'consum', 0.0222, 'lps'),
	(572111, 131, '2014-03-01 00:44:18.000000', 'consum', 0.0227, 'lps'),
	(572112, 131, '2014-03-01 00:44:19.000000', 'consum', 0.0226, 'lps'),
	(572113, 131, '2014-03-01 00:44:20.000000', 'consum', 0.0220, 'lps'),
	(572114, 131, '2014-03-01 00:44:21.000000', 'consum', 0.0211, 'lps'),
	(572115, 131, '2014-03-01 00:44:22.000000', 'consum', 0.0222, 'lps'),
	(572116, 131, '2014-03-01 00:44:23.000000', 'consum', 0.0215, 'lps'),
	(572117, 131, '2014-03-01 00:44:24.000000', 'consum', 0.0217, 'lps'),
	(572118, 131, '2014-03-01 00:44:25.000000', 'consum', 0.0213, 'lps'),
	(572119, 131, '2014-03-01 00:44:26.000000', 'consum', 0.0223, 'lps'),
	(572120, 131, '2014-03-01 00:44:27.000000', 'consum', 0.0210, 'lps'),
	(572121, 131, '2014-03-01 00:44:28.000000', 'consum', 0.0227, 'lps'),
	(572122, 131, '2014-03-01 00:44:29.000000', 'consum', 0.0224, 'lps'),
	(572123, 131, '2014-03-01 00:44:30.000000', 'consum', 0.0210, 'lps'),
	(572124, 131, '2014-03-01 00:44:31.000000', 'consum', 0.0223, 'lps'),
	(572125, 131, '2014-03-01 00:44:32.000000', 'consum', 0.0220, 'lps'),
	(572126, 131, '2014-03-01 00:44:33.000000', 'consum', 0.0221, 'lps'),
	(572127, 131, '2014-03-01 00:44:34.000000', 'consum', 0.0219, 'lps'),
	(572128, 131, '2014-03-01 00:44:35.000000', 'consum', 0.0222, 'lps'),
	(572129, 131, '2014-03-01 00:44:36.000000', 'consum', 0.0210, 'lps'),
	(572130, 131, '2014-03-01 00:44:37.000000', 'consum', 0.0225, 'lps'),
	(572131, 131, '2014-03-01 00:44:38.000000', 'consum', 0.0215, 'lps'),
	(572132, 131, '2014-03-01 00:44:39.000000', 'consum', 0.0225, 'lps'),
	(572133, 131, '2014-03-01 00:44:40.000000', 'consum', 0.0217, 'lps'),
	(572134, 131, '2014-03-01 00:44:41.000000', 'consum', 0.0220, 'lps'),
	(572135, 131, '2014-03-01 00:44:42.000000', 'consum', 0.0221, 'lps'),
	(572136, 131, '2014-03-01 00:44:43.000000', 'consum', 0.0217, 'lps'),
	(572137, 131, '2014-03-01 00:44:44.000000', 'consum', 0.0215, 'lps'),
	(572138, 131, '2014-03-01 00:44:45.000000', 'consum', 0.0212, 'lps'),
	(572139, 131, '2014-03-01 00:44:46.000000', 'consum', 0.0224, 'lps'),
	(572140, 131, '2014-03-01 00:44:47.000000', 'consum', 0.0222, 'lps'),
	(572141, 131, '2014-03-01 00:44:48.000000', 'consum', 0.0211, 'lps'),
	(572142, 131, '2014-03-01 00:44:49.000000', 'consum', 0.0213, 'lps'),
	(572143, 131, '2014-03-01 00:44:50.000000', 'consum', 0.0225, 'lps'),
	(572144, 131, '2014-03-01 00:44:51.000000', 'consum', 0.0220, 'lps'),
	(572145, 131, '2014-03-01 00:44:52.000000', 'consum', 0.0214, 'lps'),
	(572146, 131, '2014-03-01 00:44:53.000000', 'consum', 0.0222, 'lps'),
	(572147, 131, '2014-03-01 00:44:54.000000', 'consum', 0.0222, 'lps'),
	(572148, 131, '2014-03-01 00:44:55.000000', 'consum', 0.0215, 'lps'),
	(572149, 131, '2014-03-01 00:44:56.000000', 'consum', 0.0218, 'lps'),
	(572150, 131, '2014-03-01 00:44:57.000000', 'consum', 0.0216, 'lps'),
	(572151, 131, '2014-03-01 00:44:58.000000', 'consum', 0.0220, 'lps'),
	(572152, 131, '2014-03-01 00:44:59.000000', 'consum', 0.0221, 'lps'),
	(572153, 131, '2014-03-01 00:45:00.000000', 'consum', 0.0221, 'lps'),
	(572154, 131, '2014-03-01 00:45:01.000000', 'consum', 0.0212, 'lps'),
	(572155, 131, '2014-03-01 00:45:02.000000', 'consum', 0.0226, 'lps'),
	(572156, 131, '2014-03-01 00:45:03.000000', 'consum', 0.0210, 'lps'),
	(572157, 131, '2014-03-01 00:45:04.000000', 'consum', 0.0216, 'lps'),
	(572158, 131, '2014-03-01 00:45:05.000000', 'consum', 0.0224, 'lps'),
	(572159, 131, '2014-03-01 00:45:06.000000', 'consum', 0.0226, 'lps'),
	(572160, 131, '2014-03-01 00:45:07.000000', 'consum', 0.0213, 'lps'),
	(572161, 131, '2014-03-01 00:45:08.000000', 'consum', 0.0215, 'lps'),
	(572162, 131, '2014-03-01 00:45:09.000000', 'consum', 0.0223, 'lps'),
	(572163, 131, '2014-03-01 00:45:10.000000', 'consum', 0.0227, 'lps'),
	(572164, 131, '2014-03-01 00:45:11.000000', 'consum', 0.0219, 'lps'),
	(572165, 131, '2014-03-01 00:45:12.000000', 'consum', 0.0223, 'lps'),
	(572166, 131, '2014-03-01 00:45:13.000000', 'consum', 0.0211, 'lps'),
	(572167, 131, '2014-03-01 00:45:14.000000', 'consum', 0.0213, 'lps'),
	(572168, 131, '2014-03-01 00:45:15.000000', 'consum', 0.0224, 'lps'),
	(572169, 131, '2014-03-01 00:45:16.000000', 'consum', 0.0217, 'lps'),
	(572170, 131, '2014-03-01 00:45:17.000000', 'consum', 0.0220, 'lps'),
	(572171, 131, '2014-03-01 00:45:18.000000', 'consum', 0.0223, 'lps'),
	(572172, 131, '2014-03-01 00:45:19.000000', 'consum', 0.0227, 'lps'),
	(572173, 131, '2014-03-01 00:45:20.000000', 'consum', 0.0221, 'lps'),
	(572174, 131, '2014-03-01 00:45:21.000000', 'consum', 0.0212, 'lps'),
	(572175, 131, '2014-03-01 00:45:22.000000', 'consum', 0.0225, 'lps'),
	(572176, 131, '2014-03-01 00:45:23.000000', 'consum', 0.0227, 'lps'),
	(572177, 131, '2014-03-01 00:45:24.000000', 'consum', 0.0214, 'lps'),
	(572178, 131, '2014-03-01 00:45:25.000000', 'consum', 0.0216, 'lps'),
	(572179, 131, '2014-03-01 00:45:26.000000', 'consum', 0.0210, 'lps'),
	(572180, 131, '2014-03-01 00:45:27.000000', 'consum', 0.0227, 'lps'),
	(572181, 131, '2014-03-01 00:45:28.000000', 'consum', 0.0225, 'lps'),
	(572182, 131, '2014-03-01 00:45:29.000000', 'consum', 0.0216, 'lps'),
	(572183, 131, '2014-03-01 00:45:30.000000', 'consum', 0.0212, 'lps'),
	(572184, 131, '2014-03-01 00:45:31.000000', 'consum', 0.0223, 'lps'),
	(572185, 131, '2014-03-01 00:45:32.000000', 'consum', 0.0216, 'lps'),
	(572186, 131, '2014-03-01 00:45:33.000000', 'consum', 0.0219, 'lps'),
	(572187, 131, '2014-03-01 00:45:34.000000', 'consum', 0.0218, 'lps'),
	(572188, 131, '2014-03-01 00:45:35.000000', 'consum', 0.0225, 'lps'),
	(572189, 131, '2014-03-01 00:45:36.000000', 'consum', 0.0226, 'lps'),
	(572190, 131, '2014-03-01 00:45:37.000000', 'consum', 0.0211, 'lps'),
	(572191, 131, '2014-03-01 00:45:38.000000', 'consum', 0.0219, 'lps'),
	(572192, 131, '2014-03-01 00:45:39.000000', 'consum', 0.0216, 'lps'),
	(572193, 131, '2014-03-01 00:45:40.000000', 'consum', 0.0216, 'lps'),
	(572194, 131, '2014-03-01 00:45:41.000000', 'consum', 0.0223, 'lps'),
	(572195, 131, '2014-03-01 00:45:42.000000', 'consum', 0.0220, 'lps'),
	(572196, 131, '2014-03-01 00:45:43.000000', 'consum', 0.0222, 'lps'),
	(572197, 131, '2014-03-01 00:45:44.000000', 'consum', 0.0222, 'lps'),
	(572198, 131, '2014-03-01 00:45:45.000000', 'consum', 0.0216, 'lps'),
	(572199, 131, '2014-03-01 00:45:46.000000', 'consum', 0.0221, 'lps'),
	(572200, 131, '2014-03-01 00:45:47.000000', 'consum', 0.0214, 'lps'),
	(572201, 131, '2014-03-01 00:45:48.000000', 'consum', 0.0213, 'lps'),
	(572202, 131, '2014-03-01 00:45:49.000000', 'consum', 0.0213, 'lps'),
	(572203, 131, '2014-03-01 00:45:50.000000', 'consum', 0.0220, 'lps'),
	(572204, 131, '2014-03-01 00:45:51.000000', 'consum', 0.0212, 'lps'),
	(572205, 131, '2014-03-01 00:45:52.000000', 'consum', 0.0210, 'lps'),
	(572206, 131, '2014-03-01 00:45:53.000000', 'consum', 0.0221, 'lps'),
	(572207, 131, '2014-03-01 00:45:54.000000', 'consum', 0.0212, 'lps'),
	(572208, 131, '2014-03-01 00:45:55.000000', 'consum', 0.0225, 'lps'),
	(572209, 131, '2014-03-01 00:45:56.000000', 'consum', 0.0226, 'lps'),
	(572210, 131, '2014-03-01 00:45:57.000000', 'consum', 0.0210, 'lps'),
	(572211, 131, '2014-03-01 00:45:58.000000', 'consum', 0.0214, 'lps'),
	(572212, 131, '2014-03-01 00:45:59.000000', 'consum', 0.0213, 'lps'),
	(572213, 131, '2014-03-01 00:46:00.000000', 'consum', 0.0214, 'lps'),
	(572214, 131, '2014-03-01 00:46:01.000000', 'consum', 0.0223, 'lps'),
	(572215, 131, '2014-03-01 00:46:02.000000', 'consum', 0.0210, 'lps'),
	(572216, 131, '2014-03-01 00:46:03.000000', 'consum', 0.0223, 'lps'),
	(572217, 131, '2014-03-01 00:46:04.000000', 'consum', 0.0222, 'lps'),
	(572218, 131, '2014-03-01 00:46:05.000000', 'consum', 0.0215, 'lps'),
	(572219, 131, '2014-03-01 00:46:06.000000', 'consum', 0.0218, 'lps'),
	(572220, 131, '2014-03-01 00:46:07.000000', 'consum', 0.0219, 'lps'),
	(572221, 131, '2014-03-01 00:46:08.000000', 'consum', 0.0210, 'lps'),
	(572222, 131, '2014-03-01 00:46:09.000000', 'consum', 0.0223, 'lps'),
	(572223, 131, '2014-03-01 00:46:10.000000', 'consum', 0.0218, 'lps'),
	(572224, 131, '2014-03-01 00:46:11.000000', 'consum', 0.0213, 'lps'),
	(572225, 131, '2014-03-01 00:46:12.000000', 'consum', 0.0218, 'lps'),
	(572226, 131, '2014-03-01 00:46:13.000000', 'consum', 0.0223, 'lps'),
	(572227, 131, '2014-03-01 00:46:14.000000', 'consum', 0.0218, 'lps'),
	(572228, 131, '2014-03-01 00:46:15.000000', 'consum', 0.0210, 'lps'),
	(572229, 131, '2014-03-01 00:46:16.000000', 'consum', 0.0222, 'lps'),
	(572230, 131, '2014-03-01 00:46:17.000000', 'consum', 0.0215, 'lps'),
	(572231, 131, '2014-03-01 00:46:18.000000', 'consum', 0.0220, 'lps'),
	(572232, 131, '2014-03-01 00:46:19.000000', 'consum', 0.0210, 'lps'),
	(572233, 131, '2014-03-01 00:46:20.000000', 'consum', 0.0214, 'lps'),
	(572234, 131, '2014-03-01 00:46:21.000000', 'consum', 0.0215, 'lps'),
	(572235, 131, '2014-03-01 00:46:22.000000', 'consum', 0.0223, 'lps'),
	(572236, 131, '2014-03-01 00:46:23.000000', 'consum', 0.0224, 'lps'),
	(572237, 131, '2014-03-01 00:46:24.000000', 'consum', 0.0223, 'lps'),
	(572238, 131, '2014-03-01 00:46:25.000000', 'consum', 0.0216, 'lps'),
	(572239, 131, '2014-03-01 00:46:26.000000', 'consum', 0.0220, 'lps'),
	(572240, 131, '2014-03-01 00:46:27.000000', 'consum', 0.0225, 'lps'),
	(572241, 131, '2014-03-01 00:46:28.000000', 'consum', 0.0219, 'lps'),
	(572242, 131, '2014-03-01 00:46:29.000000', 'consum', 0.0211, 'lps'),
	(572243, 131, '2014-03-01 00:46:30.000000', 'consum', 0.0226, 'lps'),
	(572244, 131, '2014-03-01 00:46:31.000000', 'consum', 0.0212, 'lps'),
	(572245, 131, '2014-03-01 00:46:32.000000', 'consum', 0.0212, 'lps'),
	(572246, 131, '2014-03-01 00:46:33.000000', 'consum', 0.0214, 'lps'),
	(572247, 131, '2014-03-01 00:46:34.000000', 'consum', 0.0222, 'lps'),
	(572248, 131, '2014-03-01 00:46:35.000000', 'consum', 0.0224, 'lps'),
	(572249, 131, '2014-03-01 00:46:36.000000', 'consum', 0.0226, 'lps'),
	(572250, 131, '2014-03-01 00:46:37.000000', 'consum', 0.0213, 'lps'),
	(572251, 131, '2014-03-01 00:46:38.000000', 'consum', 0.0213, 'lps'),
	(572252, 131, '2014-03-01 00:46:39.000000', 'consum', 0.0216, 'lps'),
	(572253, 131, '2014-03-01 00:46:40.000000', 'consum', 0.0215, 'lps'),
	(572254, 131, '2014-03-01 00:46:41.000000', 'consum', 0.0217, 'lps'),
	(572255, 131, '2014-03-01 00:46:42.000000', 'consum', 0.0214, 'lps'),
	(572256, 131, '2014-03-01 00:46:43.000000', 'consum', 0.0210, 'lps'),
	(572257, 131, '2014-03-01 00:46:44.000000', 'consum', 0.0214, 'lps'),
	(572258, 131, '2014-03-01 00:46:45.000000', 'consum', 0.0215, 'lps'),
	(572259, 131, '2014-03-01 00:46:46.000000', 'consum', 0.0221, 'lps'),
	(572260, 131, '2014-03-01 00:46:47.000000', 'consum', 0.0215, 'lps'),
	(572261, 131, '2014-03-01 00:46:48.000000', 'consum', 0.0220, 'lps'),
	(572262, 131, '2014-03-01 00:46:49.000000', 'consum', 0.0211, 'lps'),
	(572263, 131, '2014-03-01 00:46:50.000000', 'consum', 0.0221, 'lps'),
	(572264, 131, '2014-03-01 00:46:51.000000', 'consum', 0.0210, 'lps'),
	(572265, 131, '2014-03-01 00:46:52.000000', 'consum', 0.0213, 'lps'),
	(572266, 131, '2014-03-01 00:46:53.000000', 'consum', 0.0225, 'lps'),
	(572267, 131, '2014-03-01 00:46:54.000000', 'consum', 0.0221, 'lps'),
	(572268, 131, '2014-03-01 00:46:55.000000', 'consum', 0.0222, 'lps'),
	(572269, 131, '2014-03-01 00:46:56.000000', 'consum', 0.0219, 'lps'),
	(572270, 131, '2014-03-01 00:46:57.000000', 'consum', 0.0219, 'lps'),
	(572271, 131, '2014-03-01 00:46:58.000000', 'consum', 0.0211, 'lps'),
	(572272, 131, '2014-03-01 00:46:59.000000', 'consum', 0.0226, 'lps'),
	(572273, 131, '2014-03-01 00:47:00.000000', 'consum', 0.0215, 'lps'),
	(572274, 131, '2014-03-01 00:47:01.000000', 'consum', 0.0225, 'lps'),
	(572275, 131, '2014-03-01 00:47:02.000000', 'consum', 0.0214, 'lps'),
	(572276, 131, '2014-03-01 00:47:03.000000', 'consum', 0.0220, 'lps'),
	(572277, 131, '2014-03-01 00:47:04.000000', 'consum', 0.0215, 'lps'),
	(572278, 131, '2014-03-01 00:47:05.000000', 'consum', 0.0222, 'lps'),
	(572279, 131, '2014-03-01 00:47:06.000000', 'consum', 0.0222, 'lps'),
	(572280, 131, '2014-03-01 00:47:07.000000', 'consum', 0.0215, 'lps'),
	(572281, 131, '2014-03-01 00:47:08.000000', 'consum', 0.0219, 'lps'),
	(572282, 131, '2014-03-01 00:47:09.000000', 'consum', 0.0224, 'lps'),
	(572283, 131, '2014-03-01 00:47:10.000000', 'consum', 0.0214, 'lps'),
	(572284, 131, '2014-03-01 00:47:11.000000', 'consum', 0.0226, 'lps'),
	(572285, 131, '2014-03-01 00:47:12.000000', 'consum', 0.0224, 'lps'),
	(572286, 131, '2014-03-01 00:47:13.000000', 'consum', 0.0216, 'lps'),
	(572287, 131, '2014-03-01 00:47:14.000000', 'consum', 0.0215, 'lps'),
	(572288, 131, '2014-03-01 00:47:15.000000', 'consum', 0.0220, 'lps'),
	(572289, 131, '2014-03-01 00:47:16.000000', 'consum', 0.0225, 'lps'),
	(572290, 131, '2014-03-01 00:47:17.000000', 'consum', 0.0219, 'lps'),
	(572291, 131, '2014-03-01 00:47:18.000000', 'consum', 0.0213, 'lps'),
	(572292, 131, '2014-03-01 00:47:19.000000', 'consum', 0.0215, 'lps'),
	(572293, 131, '2014-03-01 00:47:20.000000', 'consum', 0.0225, 'lps'),
	(572294, 131, '2014-03-01 00:47:21.000000', 'consum', 0.0218, 'lps'),
	(572295, 131, '2014-03-01 00:47:22.000000', 'consum', 0.0225, 'lps'),
	(572296, 131, '2014-03-01 00:47:23.000000', 'consum', 0.0223, 'lps'),
	(572297, 131, '2014-03-01 00:47:24.000000', 'consum', 0.0215, 'lps'),
	(572298, 131, '2014-03-01 00:47:25.000000', 'consum', 0.0216, 'lps'),
	(572299, 131, '2014-03-01 00:47:26.000000', 'consum', 0.0222, 'lps'),
	(572300, 131, '2014-03-01 00:47:27.000000', 'consum', 0.0216, 'lps'),
	(572301, 131, '2014-03-01 00:47:28.000000', 'consum', 0.0223, 'lps'),
	(572302, 131, '2014-03-01 00:47:29.000000', 'consum', 0.0222, 'lps'),
	(572303, 131, '2014-03-01 00:47:30.000000', 'consum', 0.0212, 'lps'),
	(572304, 131, '2014-03-01 00:47:31.000000', 'consum', 0.0220, 'lps'),
	(572305, 131, '2014-03-01 00:47:32.000000', 'consum', 0.0219, 'lps'),
	(572306, 131, '2014-03-01 00:47:33.000000', 'consum', 0.0226, 'lps'),
	(572307, 131, '2014-03-01 00:47:34.000000', 'consum', 0.0210, 'lps'),
	(572308, 131, '2014-03-01 00:47:35.000000', 'consum', 0.0216, 'lps'),
	(572309, 131, '2014-03-01 00:47:36.000000', 'consum', 0.0222, 'lps'),
	(572310, 131, '2014-03-01 00:47:37.000000', 'consum', 0.0216, 'lps'),
	(572311, 131, '2014-03-01 00:47:38.000000', 'consum', 0.0222, 'lps'),
	(572312, 131, '2014-03-01 00:47:39.000000', 'consum', 0.0218, 'lps'),
	(572313, 131, '2014-03-01 00:47:40.000000', 'consum', 0.0215, 'lps'),
	(572314, 131, '2014-03-01 00:47:41.000000', 'consum', 0.0211, 'lps'),
	(572315, 131, '2014-03-01 00:47:42.000000', 'consum', 0.0220, 'lps'),
	(572316, 131, '2014-03-01 00:47:43.000000', 'consum', 0.0220, 'lps'),
	(572317, 131, '2014-03-01 00:47:44.000000', 'consum', 0.0215, 'lps'),
	(572318, 131, '2014-03-01 00:47:45.000000', 'consum', 0.0221, 'lps'),
	(572319, 131, '2014-03-01 00:47:46.000000', 'consum', 0.0213, 'lps'),
	(572320, 131, '2014-03-01 00:47:47.000000', 'consum', 0.0214, 'lps'),
	(572321, 131, '2014-03-01 00:47:48.000000', 'consum', 0.0218, 'lps'),
	(572322, 131, '2014-03-01 00:47:49.000000', 'consum', 0.0222, 'lps'),
	(572323, 131, '2014-03-01 00:47:50.000000', 'consum', 0.0210, 'lps'),
	(572324, 131, '2014-03-01 00:47:51.000000', 'consum', 0.0227, 'lps'),
	(572325, 131, '2014-03-01 00:47:52.000000', 'consum', 0.0225, 'lps'),
	(572326, 131, '2014-03-01 00:47:53.000000', 'consum', 0.0218, 'lps'),
	(572327, 131, '2014-03-01 00:47:54.000000', 'consum', 0.0224, 'lps'),
	(572328, 131, '2014-03-01 00:47:55.000000', 'consum', 0.0219, 'lps'),
	(572329, 131, '2014-03-01 00:47:56.000000', 'consum', 0.0214, 'lps'),
	(572330, 131, '2014-03-01 00:47:57.000000', 'consum', 0.0222, 'lps'),
	(572331, 131, '2014-03-01 00:47:58.000000', 'consum', 0.0221, 'lps'),
	(572332, 131, '2014-03-01 00:47:59.000000', 'consum', 0.0212, 'lps'),
	(572333, 131, '2014-03-01 00:48:00.000000', 'consum', 0.0223, 'lps'),
	(572334, 131, '2014-03-01 00:48:01.000000', 'consum', 0.0215, 'lps'),
	(572335, 131, '2014-03-01 00:48:02.000000', 'consum', 0.0215, 'lps'),
	(572336, 131, '2014-03-01 00:48:03.000000', 'consum', 0.0220, 'lps'),
	(572337, 131, '2014-03-01 00:48:04.000000', 'consum', 0.0227, 'lps'),
	(572338, 131, '2014-03-01 00:48:05.000000', 'consum', 0.0213, 'lps'),
	(572339, 131, '2014-03-01 00:48:06.000000', 'consum', 0.0226, 'lps'),
	(572340, 131, '2014-03-01 00:48:07.000000', 'consum', 0.0212, 'lps'),
	(572341, 131, '2014-03-01 00:48:08.000000', 'consum', 0.0227, 'lps'),
	(572342, 131, '2014-03-01 00:48:09.000000', 'consum', 0.0218, 'lps'),
	(572343, 131, '2014-03-01 00:48:10.000000', 'consum', 0.0218, 'lps'),
	(572344, 131, '2014-03-01 00:48:11.000000', 'consum', 0.0226, 'lps'),
	(572345, 131, '2014-03-01 00:48:12.000000', 'consum', 0.0213, 'lps'),
	(572346, 131, '2014-03-01 00:48:13.000000', 'consum', 0.0211, 'lps'),
	(572347, 131, '2014-03-01 00:48:14.000000', 'consum', 0.0210, 'lps'),
	(572348, 131, '2014-03-01 00:48:15.000000', 'consum', 0.0222, 'lps'),
	(572349, 131, '2014-03-01 00:48:16.000000', 'consum', 0.0218, 'lps'),
	(572350, 131, '2014-03-01 00:48:17.000000', 'consum', 0.0216, 'lps'),
	(572351, 131, '2014-03-01 00:48:18.000000', 'consum', 0.0214, 'lps'),
	(572352, 131, '2014-03-01 00:48:19.000000', 'consum', 0.0215, 'lps'),
	(572353, 131, '2014-03-01 00:48:20.000000', 'consum', 0.0224, 'lps'),
	(572354, 131, '2014-03-01 00:48:21.000000', 'consum', 0.0211, 'lps'),
	(572355, 131, '2014-03-01 00:48:22.000000', 'consum', 0.0226, 'lps'),
	(572356, 131, '2014-03-01 00:48:23.000000', 'consum', 0.0216, 'lps'),
	(572357, 131, '2014-03-01 00:48:24.000000', 'consum', 0.0210, 'lps'),
	(572358, 131, '2014-03-01 00:48:25.000000', 'consum', 0.0213, 'lps'),
	(572359, 131, '2014-03-01 00:48:26.000000', 'consum', 0.0224, 'lps'),
	(572360, 131, '2014-03-01 00:48:27.000000', 'consum', 0.0218, 'lps'),
	(572361, 131, '2014-03-01 00:48:28.000000', 'consum', 0.0227, 'lps'),
	(572362, 131, '2014-03-01 00:48:29.000000', 'consum', 0.0219, 'lps'),
	(572363, 131, '2014-03-01 00:48:30.000000', 'consum', 0.0221, 'lps'),
	(572364, 131, '2014-03-01 00:48:31.000000', 'consum', 0.0219, 'lps'),
	(572365, 131, '2014-03-01 00:48:32.000000', 'consum', 0.0224, 'lps'),
	(572366, 131, '2014-03-01 00:48:33.000000', 'consum', 0.0219, 'lps'),
	(572367, 131, '2014-03-01 00:48:34.000000', 'consum', 0.0213, 'lps'),
	(572368, 131, '2014-03-01 00:48:35.000000', 'consum', 0.0217, 'lps'),
	(572369, 131, '2014-03-01 00:48:36.000000', 'consum', 0.0220, 'lps'),
	(572370, 131, '2014-03-01 00:48:37.000000', 'consum', 0.0220, 'lps'),
	(572371, 131, '2014-03-01 00:48:38.000000', 'consum', 0.0211, 'lps'),
	(572372, 131, '2014-03-01 00:48:39.000000', 'consum', 0.0222, 'lps'),
	(572373, 131, '2014-03-01 00:48:40.000000', 'consum', 0.0216, 'lps'),
	(572374, 131, '2014-03-01 00:48:41.000000', 'consum', 0.0220, 'lps'),
	(572375, 131, '2014-03-01 00:48:42.000000', 'consum', 0.0223, 'lps'),
	(572376, 131, '2014-03-01 00:48:43.000000', 'consum', 0.0213, 'lps'),
	(572377, 131, '2014-03-01 00:48:44.000000', 'consum', 0.0221, 'lps'),
	(572378, 131, '2014-03-01 00:48:45.000000', 'consum', 0.0219, 'lps'),
	(572379, 131, '2014-03-01 00:48:46.000000', 'consum', 0.0222, 'lps'),
	(572380, 131, '2014-03-01 00:48:47.000000', 'consum', 0.0225, 'lps'),
	(572381, 131, '2014-03-01 00:48:48.000000', 'consum', 0.0216, 'lps'),
	(572382, 131, '2014-03-01 00:48:49.000000', 'consum', 0.0212, 'lps'),
	(572383, 131, '2014-03-01 00:48:50.000000', 'consum', 0.0219, 'lps'),
	(572384, 131, '2014-03-01 00:48:51.000000', 'consum', 0.0216, 'lps'),
	(572385, 131, '2014-03-01 00:48:52.000000', 'consum', 0.0211, 'lps'),
	(572386, 131, '2014-03-01 00:48:53.000000', 'consum', 0.0217, 'lps'),
	(572387, 131, '2014-03-01 00:48:54.000000', 'consum', 0.0224, 'lps'),
	(572388, 131, '2014-03-01 00:48:55.000000', 'consum', 0.0224, 'lps'),
	(572389, 131, '2014-03-01 00:48:56.000000', 'consum', 0.0221, 'lps'),
	(572390, 131, '2014-03-01 00:48:57.000000', 'consum', 0.0225, 'lps'),
	(572391, 131, '2014-03-01 00:48:58.000000', 'consum', 0.0215, 'lps'),
	(572392, 131, '2014-03-01 00:48:59.000000', 'consum', 0.0225, 'lps'),
	(572393, 131, '2014-03-01 00:49:00.000000', 'consum', 0.0217, 'lps'),
	(572394, 131, '2014-03-01 00:49:01.000000', 'consum', 0.0219, 'lps'),
	(572395, 131, '2014-03-01 00:49:02.000000', 'consum', 0.0217, 'lps'),
	(572396, 131, '2014-03-01 00:49:03.000000', 'consum', 0.0219, 'lps'),
	(572397, 131, '2014-03-01 00:49:04.000000', 'consum', 0.0217, 'lps'),
	(572398, 131, '2014-03-01 00:49:05.000000', 'consum', 0.0218, 'lps'),
	(572399, 131, '2014-03-01 00:49:06.000000', 'consum', 0.0212, 'lps'),
	(572400, 131, '2014-03-01 00:49:07.000000', 'consum', 0.0214, 'lps'),
	(572401, 131, '2014-03-01 00:49:08.000000', 'consum', 0.0225, 'lps'),
	(572402, 131, '2014-03-01 00:49:09.000000', 'consum', 0.0220, 'lps'),
	(572403, 131, '2014-03-01 00:49:10.000000', 'consum', 0.0215, 'lps'),
	(572404, 131, '2014-03-01 00:49:11.000000', 'consum', 0.0225, 'lps'),
	(572405, 131, '2014-03-01 00:49:12.000000', 'consum', 0.0214, 'lps'),
	(572406, 131, '2014-03-01 00:49:13.000000', 'consum', 0.0224, 'lps'),
	(572407, 131, '2014-03-01 00:49:14.000000', 'consum', 0.0213, 'lps'),
	(572408, 131, '2014-03-01 00:49:15.000000', 'consum', 0.0222, 'lps'),
	(572409, 131, '2014-03-01 00:49:16.000000', 'consum', 0.0222, 'lps'),
	(572410, 131, '2014-03-01 00:49:17.000000', 'consum', 0.0218, 'lps'),
	(572411, 131, '2014-03-01 00:49:18.000000', 'consum', 0.0214, 'lps'),
	(572412, 131, '2014-03-01 00:49:19.000000', 'consum', 0.0227, 'lps'),
	(572413, 131, '2014-03-01 00:49:20.000000', 'consum', 0.0226, 'lps'),
	(572414, 131, '2014-03-01 00:49:21.000000', 'consum', 0.0222, 'lps'),
	(572415, 131, '2014-03-01 00:49:22.000000', 'consum', 0.0224, 'lps'),
	(572416, 131, '2014-03-01 00:49:23.000000', 'consum', 0.0227, 'lps'),
	(572417, 131, '2014-03-01 00:49:24.000000', 'consum', 0.0218, 'lps'),
	(572418, 131, '2014-03-01 00:49:25.000000', 'consum', 0.0217, 'lps'),
	(572419, 131, '2014-03-01 00:49:26.000000', 'consum', 0.0222, 'lps'),
	(572420, 131, '2014-03-01 00:49:27.000000', 'consum', 0.0215, 'lps'),
	(572421, 131, '2014-03-01 00:49:28.000000', 'consum', 0.0216, 'lps'),
	(572422, 131, '2014-03-01 00:49:29.000000', 'consum', 0.0225, 'lps'),
	(572423, 131, '2014-03-01 00:49:30.000000', 'consum', 0.0214, 'lps'),
	(572424, 131, '2014-03-01 00:49:31.000000', 'consum', 0.0223, 'lps'),
	(572425, 131, '2014-03-01 00:49:32.000000', 'consum', 0.0210, 'lps'),
	(572426, 131, '2014-03-01 00:49:33.000000', 'consum', 0.0224, 'lps'),
	(572427, 131, '2014-03-01 00:49:34.000000', 'consum', 0.0225, 'lps'),
	(572428, 131, '2014-03-01 00:49:35.000000', 'consum', 0.0226, 'lps'),
	(572429, 131, '2014-03-01 00:49:36.000000', 'consum', 0.0227, 'lps'),
	(572430, 131, '2014-03-01 00:49:37.000000', 'consum', 0.0211, 'lps'),
	(572431, 131, '2014-03-01 00:49:38.000000', 'consum', 0.0220, 'lps'),
	(572432, 131, '2014-03-01 00:49:39.000000', 'consum', 0.0220, 'lps'),
	(572433, 131, '2014-03-01 00:49:40.000000', 'consum', 0.0212, 'lps'),
	(572434, 131, '2014-03-01 00:49:41.000000', 'consum', 0.0227, 'lps'),
	(572435, 131, '2014-03-01 00:49:42.000000', 'consum', 0.0218, 'lps'),
	(572436, 131, '2014-03-01 00:49:43.000000', 'consum', 0.0218, 'lps'),
	(572437, 131, '2014-03-01 00:49:44.000000', 'consum', 0.0226, 'lps'),
	(572438, 131, '2014-03-01 00:49:45.000000', 'consum', 0.0214, 'lps'),
	(572439, 131, '2014-03-01 00:49:46.000000', 'consum', 0.0216, 'lps'),
	(572440, 131, '2014-03-01 00:49:47.000000', 'consum', 0.0212, 'lps'),
	(572441, 131, '2014-03-01 00:49:48.000000', 'consum', 0.0218, 'lps'),
	(572442, 131, '2014-03-01 00:49:49.000000', 'consum', 0.0211, 'lps'),
	(572443, 131, '2014-03-01 00:49:50.000000', 'consum', 0.0210, 'lps'),
	(572444, 131, '2014-03-01 00:49:51.000000', 'consum', 0.0227, 'lps'),
	(572445, 131, '2014-03-01 00:49:52.000000', 'consum', 0.0221, 'lps'),
	(572446, 131, '2014-03-01 00:49:53.000000', 'consum', 0.0214, 'lps'),
	(572447, 131, '2014-03-01 00:49:54.000000', 'consum', 0.0214, 'lps'),
	(572448, 131, '2014-03-01 00:49:55.000000', 'consum', 0.0221, 'lps'),
	(572449, 131, '2014-03-01 00:49:56.000000', 'consum', 0.0217, 'lps'),
	(572450, 131, '2014-03-01 00:49:57.000000', 'consum', 0.0212, 'lps'),
	(572451, 131, '2014-03-01 00:49:58.000000', 'consum', 0.0220, 'lps'),
	(572452, 131, '2014-03-01 00:49:59.000000', 'consum', 0.0215, 'lps'),
	(572453, 131, '2014-03-01 00:50:00.000000', 'consum', 0.0224, 'lps'),
	(572454, 131, '2014-03-01 00:50:01.000000', 'consum', 0.0213, 'lps'),
	(572455, 131, '2014-03-01 00:50:02.000000', 'consum', 0.0217, 'lps'),
	(572456, 131, '2014-03-01 00:50:03.000000', 'consum', 0.0220, 'lps'),
	(572457, 131, '2014-03-01 00:50:04.000000', 'consum', 0.0223, 'lps'),
	(572458, 131, '2014-03-01 00:50:05.000000', 'consum', 0.0227, 'lps'),
	(572459, 131, '2014-03-01 00:50:06.000000', 'consum', 0.0218, 'lps'),
	(572460, 131, '2014-03-01 00:50:07.000000', 'consum', 0.0220, 'lps'),
	(572461, 131, '2014-03-01 00:50:08.000000', 'consum', 0.0218, 'lps'),
	(572462, 131, '2014-03-01 00:50:09.000000', 'consum', 0.0220, 'lps'),
	(572463, 131, '2014-03-01 00:50:10.000000', 'consum', 0.0218, 'lps'),
	(572464, 131, '2014-03-01 00:50:11.000000', 'consum', 0.0223, 'lps'),
	(572465, 131, '2014-03-01 00:50:12.000000', 'consum', 0.0214, 'lps'),
	(572466, 131, '2014-03-01 00:50:13.000000', 'consum', 0.0210, 'lps'),
	(572467, 131, '2014-03-01 00:50:14.000000', 'consum', 0.0215, 'lps'),
	(572468, 131, '2014-03-01 00:50:15.000000', 'consum', 0.0219, 'lps'),
	(572469, 131, '2014-03-01 00:50:16.000000', 'consum', 0.0221, 'lps'),
	(572470, 131, '2014-03-01 00:50:17.000000', 'consum', 0.0220, 'lps'),
	(572471, 131, '2014-03-01 00:50:18.000000', 'consum', 0.0211, 'lps'),
	(572472, 131, '2014-03-01 00:50:19.000000', 'consum', 0.0222, 'lps'),
	(572473, 131, '2014-03-01 00:50:20.000000', 'consum', 0.0215, 'lps'),
	(572474, 131, '2014-03-01 00:50:21.000000', 'consum', 0.0216, 'lps'),
	(572475, 131, '2014-03-01 00:50:22.000000', 'consum', 0.0225, 'lps'),
	(572476, 131, '2014-03-01 00:50:23.000000', 'consum', 0.0212, 'lps'),
	(572477, 131, '2014-03-01 00:50:24.000000', 'consum', 0.0215, 'lps'),
	(572478, 131, '2014-03-01 00:50:25.000000', 'consum', 0.0227, 'lps'),
	(572479, 131, '2014-03-01 00:50:26.000000', 'consum', 0.0227, 'lps'),
	(572480, 131, '2014-03-01 00:50:27.000000', 'consum', 0.0226, 'lps'),
	(572481, 131, '2014-03-01 00:50:28.000000', 'consum', 0.0221, 'lps'),
	(572482, 131, '2014-03-01 00:50:29.000000', 'consum', 0.0216, 'lps'),
	(572483, 131, '2014-03-01 00:50:30.000000', 'consum', 0.0211, 'lps'),
	(572484, 131, '2014-03-01 00:50:31.000000', 'consum', 0.0214, 'lps'),
	(572485, 131, '2014-03-01 00:50:32.000000', 'consum', 0.0226, 'lps'),
	(572486, 131, '2014-03-01 00:50:33.000000', 'consum', 0.0227, 'lps'),
	(572487, 131, '2014-03-01 00:50:34.000000', 'consum', 0.0211, 'lps'),
	(572488, 131, '2014-03-01 00:50:35.000000', 'consum', 0.0220, 'lps'),
	(572489, 131, '2014-03-01 00:50:36.000000', 'consum', 0.0220, 'lps'),
	(572490, 131, '2014-03-01 00:50:37.000000', 'consum', 0.0211, 'lps'),
	(572491, 131, '2014-03-01 00:50:38.000000', 'consum', 0.0224, 'lps'),
	(572492, 131, '2014-03-01 00:50:39.000000', 'consum', 0.0222, 'lps'),
	(572493, 131, '2014-03-01 00:50:40.000000', 'consum', 0.0212, 'lps'),
	(572494, 131, '2014-03-01 00:50:41.000000', 'consum', 0.0222, 'lps'),
	(572495, 131, '2014-03-01 00:50:42.000000', 'consum', 0.0225, 'lps'),
	(572496, 131, '2014-03-01 00:50:43.000000', 'consum', 0.0215, 'lps'),
	(572497, 131, '2014-03-01 00:50:44.000000', 'consum', 0.0225, 'lps'),
	(572498, 131, '2014-03-01 00:50:45.000000', 'consum', 0.0217, 'lps'),
	(572499, 131, '2014-03-01 00:50:46.000000', 'consum', 0.0221, 'lps'),
	(572500, 131, '2014-03-01 00:50:47.000000', 'consum', 0.0224, 'lps'),
	(572501, 131, '2014-03-01 00:50:48.000000', 'consum', 0.0210, 'lps'),
	(572502, 131, '2014-03-01 00:50:49.000000', 'consum', 0.0226, 'lps'),
	(572503, 131, '2014-03-01 00:50:50.000000', 'consum', 0.0217, 'lps'),
	(572504, 131, '2014-03-01 00:50:51.000000', 'consum', 0.0216, 'lps'),
	(572505, 131, '2014-03-01 00:50:52.000000', 'consum', 0.0219, 'lps'),
	(572506, 131, '2014-03-01 00:50:53.000000', 'consum', 0.0221, 'lps'),
	(572507, 131, '2014-03-01 00:50:54.000000', 'consum', 0.0220, 'lps'),
	(572508, 131, '2014-03-01 00:50:55.000000', 'consum', 0.0211, 'lps'),
	(572509, 131, '2014-03-01 00:50:56.000000', 'consum', 0.0219, 'lps'),
	(572510, 131, '2014-03-01 00:50:57.000000', 'consum', 0.0216, 'lps'),
	(572511, 131, '2014-03-01 00:50:58.000000', 'consum', 0.0213, 'lps'),
	(572512, 131, '2014-03-01 00:50:59.000000', 'consum', 0.0210, 'lps'),
	(572513, 131, '2014-03-01 00:51:00.000000', 'consum', 0.0217, 'lps'),
	(572514, 131, '2014-03-01 00:51:01.000000', 'consum', 0.0212, 'lps'),
	(572515, 131, '2014-03-01 00:51:02.000000', 'consum', 0.0216, 'lps'),
	(572516, 131, '2014-03-01 00:51:03.000000', 'consum', 0.0218, 'lps'),
	(572517, 131, '2014-03-01 00:51:04.000000', 'consum', 0.0212, 'lps'),
	(572518, 131, '2014-03-01 00:51:05.000000', 'consum', 0.0215, 'lps'),
	(572519, 131, '2014-03-01 00:51:06.000000', 'consum', 0.0210, 'lps'),
	(572520, 131, '2014-03-01 00:51:07.000000', 'consum', 0.0216, 'lps'),
	(572521, 131, '2014-03-01 00:51:08.000000', 'consum', 0.0223, 'lps'),
	(572522, 131, '2014-03-01 00:51:09.000000', 'consum', 0.0222, 'lps'),
	(572523, 131, '2014-03-01 00:51:10.000000', 'consum', 0.0214, 'lps'),
	(572524, 131, '2014-03-01 00:51:11.000000', 'consum', 0.0212, 'lps'),
	(572525, 131, '2014-03-01 00:51:12.000000', 'consum', 0.0225, 'lps'),
	(572526, 131, '2014-03-01 00:51:13.000000', 'consum', 0.0227, 'lps'),
	(572527, 131, '2014-03-01 00:51:14.000000', 'consum', 0.0212, 'lps'),
	(572528, 131, '2014-03-01 00:51:15.000000', 'consum', 0.0225, 'lps'),
	(572529, 131, '2014-03-01 00:51:16.000000', 'consum', 0.0227, 'lps'),
	(572530, 131, '2014-03-01 00:51:17.000000', 'consum', 0.0214, 'lps'),
	(572531, 131, '2014-03-01 00:51:18.000000', 'consum', 0.0215, 'lps'),
	(572532, 131, '2014-03-01 00:51:19.000000', 'consum', 0.0222, 'lps'),
	(572533, 131, '2014-03-01 00:51:20.000000', 'consum', 0.0221, 'lps'),
	(572534, 131, '2014-03-01 00:51:21.000000', 'consum', 0.0213, 'lps'),
	(572535, 131, '2014-03-01 00:51:22.000000', 'consum', 0.0226, 'lps'),
	(572536, 131, '2014-03-01 00:51:23.000000', 'consum', 0.0212, 'lps'),
	(572537, 131, '2014-03-01 00:51:24.000000', 'consum', 0.0224, 'lps'),
	(572538, 131, '2014-03-01 00:51:25.000000', 'consum', 0.0223, 'lps'),
	(572539, 131, '2014-03-01 00:51:26.000000', 'consum', 0.0213, 'lps'),
	(572540, 131, '2014-03-01 00:51:27.000000', 'consum', 0.0226, 'lps'),
	(572541, 131, '2014-03-01 00:51:28.000000', 'consum', 0.0224, 'lps'),
	(572542, 131, '2014-03-01 00:51:29.000000', 'consum', 0.0215, 'lps'),
	(572543, 131, '2014-03-01 00:51:30.000000', 'consum', 0.0210, 'lps'),
	(572544, 131, '2014-03-01 00:51:31.000000', 'consum', 0.0215, 'lps'),
	(572545, 131, '2014-03-01 00:51:32.000000', 'consum', 0.0218, 'lps'),
	(572546, 131, '2014-03-01 00:51:33.000000', 'consum', 0.0216, 'lps'),
	(572547, 131, '2014-03-01 00:51:34.000000', 'consum', 0.0218, 'lps'),
	(572548, 131, '2014-03-01 00:51:35.000000', 'consum', 0.0214, 'lps'),
	(572549, 131, '2014-03-01 00:51:36.000000', 'consum', 0.0226, 'lps'),
	(572550, 131, '2014-03-01 00:51:37.000000', 'consum', 0.0222, 'lps'),
	(572551, 131, '2014-03-01 00:51:38.000000', 'consum', 0.0225, 'lps'),
	(572552, 131, '2014-03-01 00:51:39.000000', 'consum', 0.0214, 'lps'),
	(572553, 131, '2014-03-01 00:51:40.000000', 'consum', 0.0221, 'lps'),
	(572554, 131, '2014-03-01 00:51:41.000000', 'consum', 0.0216, 'lps'),
	(572555, 131, '2014-03-01 00:51:42.000000', 'consum', 0.0225, 'lps'),
	(572556, 131, '2014-03-01 00:51:43.000000', 'consum', 0.0216, 'lps'),
	(572557, 131, '2014-03-01 00:51:44.000000', 'consum', 0.0210, 'lps'),
	(572558, 131, '2014-03-01 00:51:45.000000', 'consum', 0.0214, 'lps'),
	(572559, 131, '2014-03-01 00:51:46.000000', 'consum', 0.0211, 'lps'),
	(572560, 131, '2014-03-01 00:51:47.000000', 'consum', 0.0224, 'lps'),
	(572561, 131, '2014-03-01 00:51:48.000000', 'consum', 0.0221, 'lps'),
	(572562, 131, '2014-03-01 00:51:49.000000', 'consum', 0.0223, 'lps'),
	(572563, 131, '2014-03-01 00:51:50.000000', 'consum', 0.0226, 'lps'),
	(572564, 131, '2014-03-01 00:51:51.000000', 'consum', 0.0213, 'lps'),
	(572565, 131, '2014-03-01 00:51:52.000000', 'consum', 0.0216, 'lps'),
	(572566, 131, '2014-03-01 00:51:53.000000', 'consum', 0.0215, 'lps'),
	(572567, 131, '2014-03-01 00:51:54.000000', 'consum', 0.0214, 'lps'),
	(572568, 131, '2014-03-01 00:51:55.000000', 'consum', 0.0216, 'lps'),
	(572569, 131, '2014-03-01 00:51:56.000000', 'consum', 0.0211, 'lps'),
	(572570, 131, '2014-03-01 00:51:57.000000', 'consum', 0.0215, 'lps'),
	(572571, 131, '2014-03-01 00:51:58.000000', 'consum', 0.0214, 'lps'),
	(572572, 131, '2014-03-01 00:51:59.000000', 'consum', 0.0218, 'lps'),
	(572573, 131, '2014-03-01 00:52:00.000000', 'consum', 0.0218, 'lps'),
	(572574, 131, '2014-03-01 00:52:01.000000', 'consum', 0.0227, 'lps'),
	(572575, 131, '2014-03-01 00:52:02.000000', 'consum', 0.0219, 'lps'),
	(572576, 131, '2014-03-01 00:52:03.000000', 'consum', 0.0220, 'lps'),
	(572577, 131, '2014-03-01 00:52:04.000000', 'consum', 0.0215, 'lps'),
	(572578, 131, '2014-03-01 00:52:05.000000', 'consum', 0.0225, 'lps'),
	(572579, 131, '2014-03-01 00:52:06.000000', 'consum', 0.0214, 'lps'),
	(572580, 131, '2014-03-01 00:52:07.000000', 'consum', 0.0225, 'lps'),
	(572581, 131, '2014-03-01 00:52:08.000000', 'consum', 0.0216, 'lps'),
	(572582, 131, '2014-03-01 00:52:09.000000', 'consum', 0.0216, 'lps'),
	(572583, 131, '2014-03-01 00:52:10.000000', 'consum', 0.0221, 'lps'),
	(572584, 131, '2014-03-01 00:52:11.000000', 'consum', 0.0214, 'lps'),
	(572585, 131, '2014-03-01 00:52:12.000000', 'consum', 0.0213, 'lps'),
	(572586, 131, '2014-03-01 00:52:13.000000', 'consum', 0.0215, 'lps'),
	(572587, 131, '2014-03-01 00:52:14.000000', 'consum', 0.0226, 'lps'),
	(572588, 131, '2014-03-01 00:52:15.000000', 'consum', 0.0220, 'lps'),
	(572589, 131, '2014-03-01 00:52:16.000000', 'consum', 0.0213, 'lps'),
	(572590, 131, '2014-03-01 00:52:17.000000', 'consum', 0.0215, 'lps'),
	(572591, 131, '2014-03-01 00:52:18.000000', 'consum', 0.0226, 'lps'),
	(572592, 131, '2014-03-01 00:52:19.000000', 'consum', 0.0222, 'lps'),
	(572593, 131, '2014-03-01 00:52:20.000000', 'consum', 0.0220, 'lps'),
	(572594, 131, '2014-03-01 00:52:21.000000', 'consum', 0.0227, 'lps'),
	(572595, 131, '2014-03-01 00:52:22.000000', 'consum', 0.0210, 'lps'),
	(572596, 131, '2014-03-01 00:52:23.000000', 'consum', 0.0216, 'lps'),
	(572597, 131, '2014-03-01 00:52:24.000000', 'consum', 0.0220, 'lps'),
	(572598, 131, '2014-03-01 00:52:25.000000', 'consum', 0.0224, 'lps'),
	(572599, 131, '2014-03-01 00:52:26.000000', 'consum', 0.0216, 'lps'),
	(572600, 131, '2014-03-01 00:52:27.000000', 'consum', 0.0215, 'lps'),
	(572601, 131, '2014-03-01 00:52:28.000000', 'consum', 0.0219, 'lps'),
	(572602, 131, '2014-03-01 00:52:29.000000', 'consum', 0.0220, 'lps'),
	(572603, 131, '2014-03-01 00:52:30.000000', 'consum', 0.0219, 'lps'),
	(572604, 131, '2014-03-01 00:52:31.000000', 'consum', 0.0223, 'lps'),
	(572605, 131, '2014-03-01 00:52:32.000000', 'consum', 0.0211, 'lps'),
	(572606, 131, '2014-03-01 00:52:33.000000', 'consum', 0.0216, 'lps'),
	(572607, 131, '2014-03-01 00:52:34.000000', 'consum', 0.0217, 'lps'),
	(572608, 131, '2014-03-01 00:52:35.000000', 'consum', 0.0227, 'lps'),
	(572609, 131, '2014-03-01 00:52:36.000000', 'consum', 0.0220, 'lps'),
	(572610, 131, '2014-03-01 00:52:37.000000', 'consum', 0.0227, 'lps'),
	(572611, 131, '2014-03-01 00:52:38.000000', 'consum', 0.0211, 'lps'),
	(572612, 131, '2014-03-01 00:52:39.000000', 'consum', 0.0217, 'lps'),
	(572613, 131, '2014-03-01 00:52:40.000000', 'consum', 0.0210, 'lps'),
	(572614, 131, '2014-03-01 00:52:41.000000', 'consum', 0.0225, 'lps'),
	(572615, 131, '2014-03-01 00:52:42.000000', 'consum', 0.0211, 'lps'),
	(572616, 131, '2014-03-01 00:52:43.000000', 'consum', 0.0210, 'lps'),
	(572617, 131, '2014-03-01 00:52:44.000000', 'consum', 0.0224, 'lps'),
	(572618, 131, '2014-03-01 00:52:45.000000', 'consum', 0.0226, 'lps'),
	(572619, 131, '2014-03-01 00:52:46.000000', 'consum', 0.0213, 'lps'),
	(572620, 131, '2014-03-01 00:52:47.000000', 'consum', 0.0213, 'lps'),
	(572621, 131, '2014-03-01 00:52:48.000000', 'consum', 0.0218, 'lps'),
	(572622, 131, '2014-03-01 00:52:49.000000', 'consum', 0.0221, 'lps'),
	(572623, 131, '2014-03-01 00:52:50.000000', 'consum', 0.0226, 'lps'),
	(572624, 131, '2014-03-01 00:52:51.000000', 'consum', 0.0219, 'lps'),
	(572625, 131, '2014-03-01 00:52:52.000000', 'consum', 0.0210, 'lps'),
	(572626, 131, '2014-03-01 00:52:53.000000', 'consum', 0.0220, 'lps'),
	(572627, 131, '2014-03-01 00:52:54.000000', 'consum', 0.0223, 'lps'),
	(572628, 131, '2014-03-01 00:52:55.000000', 'consum', 0.0210, 'lps'),
	(572629, 131, '2014-03-01 00:52:56.000000', 'consum', 0.0224, 'lps'),
	(572630, 131, '2014-03-01 00:52:57.000000', 'consum', 0.0211, 'lps'),
	(572631, 131, '2014-03-01 00:52:58.000000', 'consum', 0.0227, 'lps'),
	(572632, 131, '2014-03-01 00:52:59.000000', 'consum', 0.0221, 'lps'),
	(572633, 131, '2014-03-01 00:53:00.000000', 'consum', 0.0212, 'lps'),
	(572634, 131, '2014-03-01 00:53:01.000000', 'consum', 0.0224, 'lps'),
	(572635, 131, '2014-03-01 00:53:02.000000', 'consum', 0.0223, 'lps'),
	(572636, 131, '2014-03-01 00:53:03.000000', 'consum', 0.0212, 'lps'),
	(572637, 131, '2014-03-01 00:53:04.000000', 'consum', 0.0220, 'lps'),
	(572638, 131, '2014-03-01 00:53:05.000000', 'consum', 0.0217, 'lps'),
	(572639, 131, '2014-03-01 00:53:06.000000', 'consum', 0.0217, 'lps'),
	(572640, 131, '2014-03-01 00:53:07.000000', 'consum', 0.0222, 'lps'),
	(572641, 131, '2014-03-01 00:53:08.000000', 'consum', 0.0215, 'lps'),
	(572642, 131, '2014-03-01 00:53:09.000000', 'consum', 0.0218, 'lps'),
	(572643, 131, '2014-03-01 00:53:10.000000', 'consum', 0.0215, 'lps'),
	(572644, 131, '2014-03-01 00:53:11.000000', 'consum', 0.0214, 'lps'),
	(572645, 131, '2014-03-01 00:53:12.000000', 'consum', 0.0215, 'lps'),
	(572646, 131, '2014-03-01 00:53:13.000000', 'consum', 0.0223, 'lps'),
	(572647, 131, '2014-03-01 00:53:14.000000', 'consum', 0.0224, 'lps'),
	(572648, 131, '2014-03-01 00:53:15.000000', 'consum', 0.0222, 'lps'),
	(572649, 131, '2014-03-01 00:53:16.000000', 'consum', 0.0212, 'lps'),
	(572650, 131, '2014-03-01 00:53:17.000000', 'consum', 0.0222, 'lps'),
	(572651, 131, '2014-03-01 00:53:18.000000', 'consum', 0.0211, 'lps'),
	(572652, 131, '2014-03-01 00:53:19.000000', 'consum', 0.0214, 'lps'),
	(572653, 131, '2014-03-01 00:53:20.000000', 'consum', 0.0212, 'lps'),
	(572654, 131, '2014-03-01 00:53:21.000000', 'consum', 0.0224, 'lps'),
	(572655, 131, '2014-03-01 00:53:22.000000', 'consum', 0.0220, 'lps'),
	(572656, 131, '2014-03-01 00:53:23.000000', 'consum', 0.0220, 'lps'),
	(572657, 131, '2014-03-01 00:53:24.000000', 'consum', 0.0211, 'lps'),
	(572658, 131, '2014-03-01 00:53:25.000000', 'consum', 0.0220, 'lps'),
	(572659, 131, '2014-03-01 00:53:26.000000', 'consum', 0.0224, 'lps'),
	(572660, 131, '2014-03-01 00:53:27.000000', 'consum', 0.0212, 'lps'),
	(572661, 131, '2014-03-01 00:53:28.000000', 'consum', 0.0217, 'lps'),
	(572662, 131, '2014-03-01 00:53:29.000000', 'consum', 0.0220, 'lps'),
	(572663, 131, '2014-03-01 00:53:30.000000', 'consum', 0.0221, 'lps'),
	(572664, 131, '2014-03-01 00:53:31.000000', 'consum', 0.0217, 'lps'),
	(572665, 131, '2014-03-01 00:53:32.000000', 'consum', 0.0215, 'lps'),
	(572666, 131, '2014-03-01 00:53:33.000000', 'consum', 0.0215, 'lps'),
	(572667, 131, '2014-03-01 00:53:34.000000', 'consum', 0.0221, 'lps'),
	(572668, 131, '2014-03-01 00:53:35.000000', 'consum', 0.0212, 'lps'),
	(572669, 131, '2014-03-01 00:53:36.000000', 'consum', 0.0224, 'lps'),
	(572670, 131, '2014-03-01 00:53:37.000000', 'consum', 0.0219, 'lps'),
	(572671, 131, '2014-03-01 00:53:38.000000', 'consum', 0.0215, 'lps'),
	(572672, 131, '2014-03-01 00:53:39.000000', 'consum', 0.0226, 'lps'),
	(572673, 131, '2014-03-01 00:53:40.000000', 'consum', 0.0224, 'lps'),
	(572674, 131, '2014-03-01 00:53:41.000000', 'consum', 0.0212, 'lps'),
	(572675, 131, '2014-03-01 00:53:42.000000', 'consum', 0.0215, 'lps'),
	(572676, 131, '2014-03-01 00:53:43.000000', 'consum', 0.0211, 'lps'),
	(572677, 131, '2014-03-01 00:53:44.000000', 'consum', 0.0220, 'lps'),
	(572678, 131, '2014-03-01 00:53:45.000000', 'consum', 0.0220, 'lps'),
	(572679, 131, '2014-03-01 00:53:46.000000', 'consum', 0.0215, 'lps'),
	(572680, 131, '2014-03-01 00:53:47.000000', 'consum', 0.0221, 'lps'),
	(572681, 131, '2014-03-01 00:53:48.000000', 'consum', 0.0217, 'lps'),
	(572682, 131, '2014-03-01 00:53:49.000000', 'consum', 0.0212, 'lps'),
	(572683, 131, '2014-03-01 00:53:50.000000', 'consum', 0.0216, 'lps'),
	(572684, 131, '2014-03-01 00:53:51.000000', 'consum', 0.0216, 'lps'),
	(572685, 131, '2014-03-01 00:53:52.000000', 'consum', 0.0225, 'lps'),
	(572686, 131, '2014-03-01 00:53:53.000000', 'consum', 0.0213, 'lps'),
	(572687, 131, '2014-03-01 00:53:54.000000', 'consum', 0.0218, 'lps'),
	(572688, 131, '2014-03-01 00:53:55.000000', 'consum', 0.0223, 'lps'),
	(572689, 131, '2014-03-01 00:53:56.000000', 'consum', 0.0214, 'lps'),
	(572690, 131, '2014-03-01 00:53:57.000000', 'consum', 0.0210, 'lps'),
	(572691, 131, '2014-03-01 00:53:58.000000', 'consum', 0.0217, 'lps'),
	(572692, 131, '2014-03-01 00:53:59.000000', 'consum', 0.0210, 'lps'),
	(572693, 131, '2014-03-01 00:54:00.000000', 'consum', 0.0227, 'lps'),
	(572694, 131, '2014-03-01 00:54:01.000000', 'consum', 0.0221, 'lps'),
	(572695, 131, '2014-03-01 00:54:02.000000', 'consum', 0.0216, 'lps'),
	(572696, 131, '2014-03-01 00:54:03.000000', 'consum', 0.0226, 'lps'),
	(572697, 131, '2014-03-01 00:54:04.000000', 'consum', 0.0216, 'lps'),
	(572698, 131, '2014-03-01 00:54:05.000000', 'consum', 0.0211, 'lps'),
	(572699, 131, '2014-03-01 00:54:06.000000', 'consum', 0.0217, 'lps'),
	(572700, 131, '2014-03-01 00:54:07.000000', 'consum', 0.0224, 'lps'),
	(572701, 131, '2014-03-01 00:54:08.000000', 'consum', 0.0223, 'lps'),
	(572702, 131, '2014-03-01 00:54:09.000000', 'consum', 0.0217, 'lps'),
	(572703, 131, '2014-03-01 00:54:10.000000', 'consum', 0.0225, 'lps'),
	(572704, 131, '2014-03-01 00:54:11.000000', 'consum', 0.0211, 'lps'),
	(572705, 131, '2014-03-01 00:54:12.000000', 'consum', 0.0222, 'lps'),
	(572706, 131, '2014-03-01 00:54:13.000000', 'consum', 0.0216, 'lps'),
	(572707, 131, '2014-03-01 00:54:14.000000', 'consum', 0.0224, 'lps'),
	(572708, 131, '2014-03-01 00:54:15.000000', 'consum', 0.0223, 'lps'),
	(572709, 131, '2014-03-01 00:54:16.000000', 'consum', 0.0217, 'lps'),
	(572710, 131, '2014-03-01 00:54:17.000000', 'consum', 0.0224, 'lps'),
	(572711, 131, '2014-03-01 00:54:18.000000', 'consum', 0.0225, 'lps'),
	(572712, 131, '2014-03-01 00:54:19.000000', 'consum', 0.0224, 'lps'),
	(572713, 131, '2014-03-01 00:54:20.000000', 'consum', 0.0217, 'lps'),
	(572714, 131, '2014-03-01 00:54:21.000000', 'consum', 0.0221, 'lps'),
	(572715, 131, '2014-03-01 00:54:22.000000', 'consum', 0.0227, 'lps'),
	(572716, 131, '2014-03-01 00:54:23.000000', 'consum', 0.0210, 'lps'),
	(572717, 131, '2014-03-01 00:54:24.000000', 'consum', 0.0211, 'lps'),
	(572718, 131, '2014-03-01 00:54:25.000000', 'consum', 0.0215, 'lps'),
	(572719, 131, '2014-03-01 00:54:26.000000', 'consum', 0.0215, 'lps'),
	(572720, 131, '2014-03-01 00:54:27.000000', 'consum', 0.0219, 'lps'),
	(572721, 131, '2014-03-01 00:54:28.000000', 'consum', 0.0223, 'lps'),
	(572722, 131, '2014-03-01 00:54:29.000000', 'consum', 0.0215, 'lps'),
	(572723, 131, '2014-03-01 00:54:30.000000', 'consum', 0.0212, 'lps'),
	(572724, 131, '2014-03-01 00:54:31.000000', 'consum', 0.0225, 'lps'),
	(572725, 131, '2014-03-01 00:54:32.000000', 'consum', 0.0223, 'lps'),
	(572726, 131, '2014-03-01 00:54:33.000000', 'consum', 0.0214, 'lps'),
	(572727, 131, '2014-03-01 00:54:34.000000', 'consum', 0.0227, 'lps'),
	(572728, 131, '2014-03-01 00:54:35.000000', 'consum', 0.0213, 'lps'),
	(572729, 131, '2014-03-01 00:54:36.000000', 'consum', 0.0226, 'lps'),
	(572730, 131, '2014-03-01 00:54:37.000000', 'consum', 0.0211, 'lps'),
	(572731, 131, '2014-03-01 00:54:38.000000', 'consum', 0.0223, 'lps'),
	(572732, 131, '2014-03-01 00:54:39.000000', 'consum', 0.0218, 'lps'),
	(572733, 131, '2014-03-01 00:54:40.000000', 'consum', 0.0210, 'lps'),
	(572734, 131, '2014-03-01 00:54:41.000000', 'consum', 0.0225, 'lps'),
	(572735, 131, '2014-03-01 00:54:42.000000', 'consum', 0.0211, 'lps'),
	(572736, 131, '2014-03-01 00:54:43.000000', 'consum', 0.0226, 'lps'),
	(572737, 131, '2014-03-01 00:54:44.000000', 'consum', 0.0213, 'lps'),
	(572738, 131, '2014-03-01 00:54:45.000000', 'consum', 0.0215, 'lps'),
	(572739, 131, '2014-03-01 00:54:46.000000', 'consum', 0.0227, 'lps'),
	(572740, 131, '2014-03-01 00:54:47.000000', 'consum', 0.0224, 'lps'),
	(572741, 131, '2014-03-01 00:54:48.000000', 'consum', 0.0214, 'lps'),
	(572742, 131, '2014-03-01 00:54:49.000000', 'consum', 0.0223, 'lps'),
	(572743, 131, '2014-03-01 00:54:50.000000', 'consum', 0.0227, 'lps'),
	(572744, 131, '2014-03-01 00:54:51.000000', 'consum', 0.0221, 'lps'),
	(572745, 131, '2014-03-01 00:54:52.000000', 'consum', 0.0215, 'lps'),
	(572746, 131, '2014-03-01 00:54:53.000000', 'consum', 0.0218, 'lps'),
	(572747, 131, '2014-03-01 00:54:54.000000', 'consum', 0.0221, 'lps'),
	(572748, 131, '2014-03-01 00:54:55.000000', 'consum', 0.0222, 'lps'),
	(572749, 131, '2014-03-01 00:54:56.000000', 'consum', 0.0220, 'lps'),
	(572750, 131, '2014-03-01 00:54:57.000000', 'consum', 0.0223, 'lps'),
	(572751, 131, '2014-03-01 00:54:58.000000', 'consum', 0.0212, 'lps'),
	(572752, 131, '2014-03-01 00:54:59.000000', 'consum', 0.0216, 'lps'),
	(572753, 131, '2014-03-01 00:55:00.000000', 'consum', 0.0218, 'lps'),
	(572754, 131, '2014-03-01 00:55:01.000000', 'consum', 0.0215, 'lps'),
	(572755, 131, '2014-03-01 00:55:02.000000', 'consum', 0.0227, 'lps'),
	(572756, 131, '2014-03-01 00:55:03.000000', 'consum', 0.0226, 'lps'),
	(572757, 131, '2014-03-01 00:55:04.000000', 'consum', 0.0221, 'lps'),
	(572758, 131, '2014-03-01 00:55:05.000000', 'consum', 0.0219, 'lps'),
	(572759, 131, '2014-03-01 00:55:06.000000', 'consum', 0.0221, 'lps'),
	(572760, 131, '2014-03-01 00:55:07.000000', 'consum', 0.0222, 'lps'),
	(572761, 131, '2014-03-01 00:55:08.000000', 'consum', 0.0218, 'lps'),
	(572762, 131, '2014-03-01 00:55:09.000000', 'consum', 0.0216, 'lps'),
	(572763, 131, '2014-03-01 00:55:10.000000', 'consum', 0.0214, 'lps'),
	(572764, 131, '2014-03-01 00:55:11.000000', 'consum', 0.0215, 'lps'),
	(572765, 131, '2014-03-01 00:55:12.000000', 'consum', 0.0221, 'lps'),
	(572766, 131, '2014-03-01 00:55:13.000000', 'consum', 0.0215, 'lps'),
	(572767, 131, '2014-03-01 00:55:14.000000', 'consum', 0.0223, 'lps'),
	(572768, 131, '2014-03-01 00:55:15.000000', 'consum', 0.0223, 'lps'),
	(572769, 131, '2014-03-01 00:55:16.000000', 'consum', 0.0218, 'lps'),
	(572770, 131, '2014-03-01 00:55:17.000000', 'consum', 0.0211, 'lps'),
	(572771, 131, '2014-03-01 00:55:18.000000', 'consum', 0.0211, 'lps'),
	(572772, 131, '2014-03-01 00:55:19.000000', 'consum', 0.0210, 'lps'),
	(572773, 131, '2014-03-01 00:55:20.000000', 'consum', 0.0210, 'lps'),
	(572774, 131, '2014-03-01 00:55:21.000000', 'consum', 0.0210, 'lps'),
	(572775, 131, '2014-03-01 00:55:22.000000', 'consum', 0.0227, 'lps'),
	(572776, 131, '2014-03-01 00:55:23.000000', 'consum', 0.0225, 'lps'),
	(572777, 131, '2014-03-01 00:55:24.000000', 'consum', 0.0217, 'lps'),
	(572778, 131, '2014-03-01 00:55:25.000000', 'consum', 0.0218, 'lps'),
	(572779, 131, '2014-03-01 00:55:26.000000', 'consum', 0.0213, 'lps'),
	(572780, 131, '2014-03-01 00:55:27.000000', 'consum', 0.0220, 'lps'),
	(572781, 131, '2014-03-01 00:55:28.000000', 'consum', 0.0215, 'lps'),
	(572782, 131, '2014-03-01 00:55:29.000000', 'consum', 0.0225, 'lps'),
	(572783, 131, '2014-03-01 00:55:30.000000', 'consum', 0.0215, 'lps'),
	(572784, 131, '2014-03-01 00:55:31.000000', 'consum', 0.0227, 'lps'),
	(572785, 131, '2014-03-01 00:55:32.000000', 'consum', 0.0226, 'lps'),
	(572786, 131, '2014-03-01 00:55:33.000000', 'consum', 0.0221, 'lps'),
	(572787, 131, '2014-03-01 00:55:34.000000', 'consum', 0.0217, 'lps'),
	(572788, 131, '2014-03-01 00:55:35.000000', 'consum', 0.0214, 'lps'),
	(572789, 131, '2014-03-01 00:55:36.000000', 'consum', 0.0210, 'lps'),
	(572790, 131, '2014-03-01 00:55:37.000000', 'consum', 0.0216, 'lps'),
	(572791, 131, '2014-03-01 00:55:38.000000', 'consum', 0.0221, 'lps'),
	(572792, 131, '2014-03-01 00:55:39.000000', 'consum', 0.0215, 'lps'),
	(572793, 131, '2014-03-01 00:55:40.000000', 'consum', 0.0217, 'lps'),
	(572794, 131, '2014-03-01 00:55:41.000000', 'consum', 0.0212, 'lps'),
	(572795, 131, '2014-03-01 00:55:42.000000', 'consum', 0.0219, 'lps'),
	(572796, 131, '2014-03-01 00:55:43.000000', 'consum', 0.0211, 'lps'),
	(572797, 131, '2014-03-01 00:55:44.000000', 'consum', 0.0227, 'lps'),
	(572798, 131, '2014-03-01 00:55:45.000000', 'consum', 0.0218, 'lps'),
	(572799, 131, '2014-03-01 00:55:46.000000', 'consum', 0.0221, 'lps'),
	(572800, 131, '2014-03-01 00:55:47.000000', 'consum', 0.0220, 'lps'),
	(572801, 131, '2014-03-01 00:55:48.000000', 'consum', 0.0211, 'lps'),
	(572802, 131, '2014-03-01 00:55:49.000000', 'consum', 0.0220, 'lps'),
	(572803, 131, '2014-03-01 00:55:50.000000', 'consum', 0.0224, 'lps'),
	(572804, 131, '2014-03-01 00:55:51.000000', 'consum', 0.0215, 'lps'),
	(572805, 131, '2014-03-01 00:55:52.000000', 'consum', 0.0212, 'lps'),
	(572806, 131, '2014-03-01 00:55:53.000000', 'consum', 0.0223, 'lps'),
	(572807, 131, '2014-03-01 00:55:54.000000', 'consum', 0.0217, 'lps'),
	(572808, 131, '2014-03-01 00:55:55.000000', 'consum', 0.0224, 'lps'),
	(572809, 131, '2014-03-01 00:55:56.000000', 'consum', 0.0223, 'lps'),
	(572810, 131, '2014-03-01 00:55:57.000000', 'consum', 0.0217, 'lps'),
	(572811, 131, '2014-03-01 00:55:58.000000', 'consum', 0.0223, 'lps'),
	(572812, 131, '2014-03-01 00:55:59.000000', 'consum', 0.0218, 'lps'),
	(572813, 131, '2014-03-01 00:56:00.000000', 'consum', 0.0212, 'lps'),
	(572814, 131, '2014-03-01 00:56:01.000000', 'consum', 0.0213, 'lps'),
	(572815, 131, '2014-03-01 00:56:02.000000', 'consum', 0.0222, 'lps'),
	(572816, 131, '2014-03-01 00:56:03.000000', 'consum', 0.0224, 'lps'),
	(572817, 131, '2014-03-01 00:56:04.000000', 'consum', 0.0226, 'lps'),
	(572818, 131, '2014-03-01 00:56:05.000000', 'consum', 0.0211, 'lps'),
	(572819, 131, '2014-03-01 00:56:06.000000', 'consum', 0.0225, 'lps'),
	(572820, 131, '2014-03-01 00:56:07.000000', 'consum', 0.0227, 'lps'),
	(572821, 131, '2014-03-01 00:56:08.000000', 'consum', 0.0213, 'lps'),
	(572822, 131, '2014-03-01 00:56:09.000000', 'consum', 0.0211, 'lps'),
	(572823, 131, '2014-03-01 00:56:10.000000', 'consum', 0.0226, 'lps'),
	(572824, 131, '2014-03-01 00:56:11.000000', 'consum', 0.0215, 'lps'),
	(572825, 131, '2014-03-01 00:56:12.000000', 'consum', 0.0225, 'lps'),
	(572826, 131, '2014-03-01 00:56:13.000000', 'consum', 0.0216, 'lps'),
	(572827, 131, '2014-03-01 00:56:14.000000', 'consum', 0.0212, 'lps'),
	(572828, 131, '2014-03-01 00:56:15.000000', 'consum', 0.0222, 'lps'),
	(572829, 131, '2014-03-01 00:56:16.000000', 'consum', 0.0227, 'lps'),
	(572830, 131, '2014-03-01 00:56:17.000000', 'consum', 0.0223, 'lps'),
	(572831, 131, '2014-03-01 00:56:18.000000', 'consum', 0.0224, 'lps'),
	(572832, 131, '2014-03-01 00:56:19.000000', 'consum', 0.0226, 'lps'),
	(572833, 131, '2014-03-01 00:56:20.000000', 'consum', 0.0210, 'lps'),
	(572834, 131, '2014-03-01 00:56:21.000000', 'consum', 0.0217, 'lps'),
	(572835, 131, '2014-03-01 00:56:22.000000', 'consum', 0.0210, 'lps'),
	(572836, 131, '2014-03-01 00:56:23.000000', 'consum', 0.0225, 'lps'),
	(572837, 131, '2014-03-01 00:56:24.000000', 'consum', 0.0212, 'lps'),
	(572838, 131, '2014-03-01 00:56:25.000000', 'consum', 0.0213, 'lps'),
	(572839, 131, '2014-03-01 00:56:26.000000', 'consum', 0.0219, 'lps'),
	(572840, 131, '2014-03-01 00:56:27.000000', 'consum', 0.0212, 'lps'),
	(572841, 131, '2014-03-01 00:56:28.000000', 'consum', 0.0212, 'lps'),
	(572842, 131, '2014-03-01 00:56:29.000000', 'consum', 0.0212, 'lps'),
	(572843, 131, '2014-03-01 00:56:30.000000', 'consum', 0.0216, 'lps'),
	(572844, 131, '2014-03-01 00:56:31.000000', 'consum', 0.0214, 'lps'),
	(572845, 131, '2014-03-01 00:56:32.000000', 'consum', 0.0215, 'lps'),
	(572846, 131, '2014-03-01 00:56:33.000000', 'consum', 0.0223, 'lps'),
	(572847, 131, '2014-03-01 00:56:34.000000', 'consum', 0.0224, 'lps'),
	(572848, 131, '2014-03-01 00:56:35.000000', 'consum', 0.0223, 'lps'),
	(572849, 131, '2014-03-01 00:56:36.000000', 'consum', 0.0215, 'lps'),
	(572850, 131, '2014-03-01 00:56:37.000000', 'consum', 0.0216, 'lps'),
	(572851, 131, '2014-03-01 00:56:38.000000', 'consum', 0.0227, 'lps'),
	(572852, 131, '2014-03-01 00:56:39.000000', 'consum', 0.0222, 'lps'),
	(572853, 131, '2014-03-01 00:56:40.000000', 'consum', 0.0220, 'lps'),
	(572854, 131, '2014-03-01 00:56:41.000000', 'consum', 0.0223, 'lps'),
	(572855, 131, '2014-03-01 00:56:42.000000', 'consum', 0.0212, 'lps'),
	(572856, 131, '2014-03-01 00:56:43.000000', 'consum', 0.0216, 'lps'),
	(572857, 131, '2014-03-01 00:56:44.000000', 'consum', 0.0215, 'lps'),
	(572858, 131, '2014-03-01 00:56:45.000000', 'consum', 0.0219, 'lps'),
	(572859, 131, '2014-03-01 00:56:46.000000', 'consum', 0.0221, 'lps'),
	(572860, 131, '2014-03-01 00:56:47.000000', 'consum', 0.0222, 'lps'),
	(572861, 131, '2014-03-01 00:56:48.000000', 'consum', 0.0220, 'lps'),
	(572862, 131, '2014-03-01 00:56:49.000000', 'consum', 0.0226, 'lps'),
	(572863, 131, '2014-03-01 00:56:50.000000', 'consum', 0.0223, 'lps'),
	(572864, 131, '2014-03-01 00:56:51.000000', 'consum', 0.0227, 'lps'),
	(572865, 131, '2014-03-01 00:56:52.000000', 'consum', 0.0221, 'lps'),
	(572866, 131, '2014-03-01 00:56:53.000000', 'consum', 0.0214, 'lps'),
	(572867, 131, '2014-03-01 00:56:54.000000', 'consum', 0.0214, 'lps'),
	(572868, 131, '2014-03-01 00:56:55.000000', 'consum', 0.0221, 'lps'),
	(572869, 131, '2014-03-01 00:56:56.000000', 'consum', 0.0214, 'lps'),
	(572870, 131, '2014-03-01 00:56:57.000000', 'consum', 0.0219, 'lps'),
	(572871, 131, '2014-03-01 00:56:58.000000', 'consum', 0.0226, 'lps'),
	(572872, 131, '2014-03-01 00:56:59.000000', 'consum', 0.0210, 'lps'),
	(572873, 131, '2014-03-01 00:57:00.000000', 'consum', 0.0215, 'lps'),
	(572874, 131, '2014-03-01 00:57:01.000000', 'consum', 0.0217, 'lps'),
	(572875, 131, '2014-03-01 00:57:02.000000', 'consum', 0.0213, 'lps'),
	(572876, 131, '2014-03-01 00:57:03.000000', 'consum', 0.0225, 'lps'),
	(572877, 131, '2014-03-01 00:57:04.000000', 'consum', 0.0219, 'lps'),
	(572878, 131, '2014-03-01 00:57:05.000000', 'consum', 0.0212, 'lps'),
	(572879, 131, '2014-03-01 00:57:06.000000', 'consum', 0.0213, 'lps'),
	(572880, 131, '2014-03-01 00:57:07.000000', 'consum', 0.0220, 'lps'),
	(572881, 131, '2014-03-01 00:57:08.000000', 'consum', 0.0215, 'lps'),
	(572882, 131, '2014-03-01 00:57:09.000000', 'consum', 0.0221, 'lps'),
	(572883, 131, '2014-03-01 00:57:10.000000', 'consum', 0.0218, 'lps'),
	(572884, 131, '2014-03-01 00:57:11.000000', 'consum', 0.0214, 'lps'),
	(572885, 131, '2014-03-01 00:57:12.000000', 'consum', 0.0210, 'lps'),
	(572886, 131, '2014-03-01 00:57:13.000000', 'consum', 0.0214, 'lps'),
	(572887, 131, '2014-03-01 00:57:14.000000', 'consum', 0.0213, 'lps'),
	(572888, 131, '2014-03-01 00:57:15.000000', 'consum', 0.0212, 'lps'),
	(572889, 131, '2014-03-01 00:57:16.000000', 'consum', 0.0211, 'lps'),
	(572890, 131, '2014-03-01 00:57:17.000000', 'consum', 0.0210, 'lps'),
	(572891, 131, '2014-03-01 00:57:18.000000', 'consum', 0.0227, 'lps'),
	(572892, 131, '2014-03-01 00:57:19.000000', 'consum', 0.0225, 'lps'),
	(572893, 131, '2014-03-01 00:57:20.000000', 'consum', 0.0214, 'lps'),
	(572894, 131, '2014-03-01 00:57:21.000000', 'consum', 0.0223, 'lps'),
	(572895, 131, '2014-03-01 00:57:22.000000', 'consum', 0.0227, 'lps'),
	(572896, 131, '2014-03-01 00:57:23.000000', 'consum', 0.0222, 'lps'),
	(572897, 131, '2014-03-01 00:57:24.000000', 'consum', 0.0217, 'lps'),
	(572898, 131, '2014-03-01 00:57:25.000000', 'consum', 0.0211, 'lps'),
	(572899, 131, '2014-03-01 00:57:26.000000', 'consum', 0.0213, 'lps'),
	(572900, 131, '2014-03-01 00:57:27.000000', 'consum', 0.0223, 'lps'),
	(572901, 131, '2014-03-01 00:57:28.000000', 'consum', 0.0211, 'lps'),
	(572902, 131, '2014-03-01 00:57:29.000000', 'consum', 0.0212, 'lps'),
	(572903, 131, '2014-03-01 00:57:30.000000', 'consum', 0.0220, 'lps'),
	(572904, 131, '2014-03-01 00:57:31.000000', 'consum', 0.0217, 'lps'),
	(572905, 131, '2014-03-01 00:57:32.000000', 'consum', 0.0217, 'lps'),
	(572906, 131, '2014-03-01 00:57:33.000000', 'consum', 0.0225, 'lps'),
	(572907, 131, '2014-03-01 00:57:34.000000', 'consum', 0.0210, 'lps'),
	(572908, 131, '2014-03-01 00:57:35.000000', 'consum', 0.0221, 'lps'),
	(572909, 131, '2014-03-01 00:57:36.000000', 'consum', 0.0227, 'lps'),
	(572910, 131, '2014-03-01 00:57:37.000000', 'consum', 0.0226, 'lps'),
	(572911, 131, '2014-03-01 00:57:38.000000', 'consum', 0.0223, 'lps'),
	(572912, 131, '2014-03-01 00:57:39.000000', 'consum', 0.0211, 'lps'),
	(572913, 131, '2014-03-01 00:57:40.000000', 'consum', 0.0210, 'lps'),
	(572914, 131, '2014-03-01 00:57:41.000000', 'consum', 0.0226, 'lps'),
	(572915, 131, '2014-03-01 00:57:42.000000', 'consum', 0.0218, 'lps'),
	(572916, 131, '2014-03-01 00:57:43.000000', 'consum', 0.0220, 'lps'),
	(572917, 131, '2014-03-01 00:57:44.000000', 'consum', 0.0221, 'lps'),
	(572918, 131, '2014-03-01 00:57:45.000000', 'consum', 0.0216, 'lps'),
	(572919, 131, '2014-03-01 00:57:46.000000', 'consum', 0.0227, 'lps'),
	(572920, 131, '2014-03-01 00:57:47.000000', 'consum', 0.0225, 'lps'),
	(572921, 131, '2014-03-01 00:57:48.000000', 'consum', 0.0213, 'lps'),
	(572922, 131, '2014-03-01 00:57:49.000000', 'consum', 0.0220, 'lps'),
	(572923, 131, '2014-03-01 00:57:50.000000', 'consum', 0.0212, 'lps'),
	(572924, 131, '2014-03-01 00:57:51.000000', 'consum', 0.0211, 'lps'),
	(572925, 131, '2014-03-01 00:57:52.000000', 'consum', 0.0225, 'lps'),
	(572926, 131, '2014-03-01 00:57:53.000000', 'consum', 0.0212, 'lps'),
	(572927, 131, '2014-03-01 00:57:54.000000', 'consum', 0.0227, 'lps'),
	(572928, 131, '2014-03-01 00:57:55.000000', 'consum', 0.0221, 'lps'),
	(572929, 131, '2014-03-01 00:57:56.000000', 'consum', 0.0213, 'lps'),
	(572930, 131, '2014-03-01 00:57:57.000000', 'consum', 0.0210, 'lps'),
	(572931, 131, '2014-03-01 00:57:58.000000', 'consum', 0.0219, 'lps'),
	(572932, 131, '2014-03-01 00:57:59.000000', 'consum', 0.0222, 'lps'),
	(572933, 131, '2014-03-01 00:58:00.000000', 'consum', 0.0223, 'lps'),
	(572934, 131, '2014-03-01 00:58:01.000000', 'consum', 0.0221, 'lps'),
	(572935, 131, '2014-03-01 00:58:02.000000', 'consum', 0.0210, 'lps'),
	(572936, 131, '2014-03-01 00:58:03.000000', 'consum', 0.0211, 'lps'),
	(572937, 131, '2014-03-01 00:58:04.000000', 'consum', 0.0217, 'lps'),
	(572938, 131, '2014-03-01 00:58:05.000000', 'consum', 0.0226, 'lps'),
	(572939, 131, '2014-03-01 00:58:06.000000', 'consum', 0.0216, 'lps'),
	(572940, 131, '2014-03-01 00:58:07.000000', 'consum', 0.0211, 'lps'),
	(572941, 131, '2014-03-01 00:58:08.000000', 'consum', 0.0215, 'lps'),
	(572942, 131, '2014-03-01 00:58:09.000000', 'consum', 0.0213, 'lps'),
	(572943, 131, '2014-03-01 00:58:10.000000', 'consum', 0.0211, 'lps'),
	(572944, 131, '2014-03-01 00:58:11.000000', 'consum', 0.0224, 'lps'),
	(572945, 131, '2014-03-01 00:58:12.000000', 'consum', 0.0223, 'lps'),
	(572946, 131, '2014-03-01 00:58:13.000000', 'consum', 0.0216, 'lps'),
	(572947, 131, '2014-03-01 00:58:14.000000', 'consum', 0.0219, 'lps'),
	(572948, 131, '2014-03-01 00:58:15.000000', 'consum', 0.0218, 'lps'),
	(572949, 131, '2014-03-01 00:58:16.000000', 'consum', 0.0225, 'lps'),
	(572950, 131, '2014-03-01 00:58:17.000000', 'consum', 0.0227, 'lps'),
	(572951, 131, '2014-03-01 00:58:18.000000', 'consum', 0.0212, 'lps'),
	(572952, 131, '2014-03-01 00:58:19.000000', 'consum', 0.0225, 'lps'),
	(572953, 131, '2014-03-01 00:58:20.000000', 'consum', 0.0224, 'lps'),
	(572954, 131, '2014-03-01 00:58:21.000000', 'consum', 0.0219, 'lps'),
	(572955, 131, '2014-03-01 00:58:22.000000', 'consum', 0.0214, 'lps'),
	(572956, 131, '2014-03-01 00:58:23.000000', 'consum', 0.0219, 'lps'),
	(572957, 131, '2014-03-01 00:58:24.000000', 'consum', 0.0226, 'lps'),
	(572958, 131, '2014-03-01 00:58:25.000000', 'consum', 0.0227, 'lps'),
	(572959, 131, '2014-03-01 00:58:26.000000', 'consum', 0.0210, 'lps'),
	(572960, 131, '2014-03-01 00:58:27.000000', 'consum', 0.0216, 'lps'),
	(572961, 131, '2014-03-01 00:58:28.000000', 'consum', 0.0222, 'lps'),
	(572962, 131, '2014-03-01 00:58:29.000000', 'consum', 0.0216, 'lps'),
	(572963, 131, '2014-03-01 00:58:30.000000', 'consum', 0.0222, 'lps'),
	(572964, 131, '2014-03-01 00:58:31.000000', 'consum', 0.0218, 'lps'),
	(572965, 131, '2014-03-01 00:58:32.000000', 'consum', 0.0212, 'lps'),
	(572966, 131, '2014-03-01 00:58:33.000000', 'consum', 0.0217, 'lps'),
	(572967, 131, '2014-03-01 00:58:34.000000', 'consum', 0.0220, 'lps'),
	(572968, 131, '2014-03-01 00:58:35.000000', 'consum', 0.0220, 'lps'),
	(572969, 131, '2014-03-01 00:58:36.000000', 'consum', 0.0216, 'lps'),
	(572970, 131, '2014-03-01 00:58:37.000000', 'consum', 0.0226, 'lps'),
	(572971, 131, '2014-03-01 00:58:38.000000', 'consum', 0.0218, 'lps'),
	(572972, 131, '2014-03-01 00:58:39.000000', 'consum', 0.0220, 'lps'),
	(572973, 131, '2014-03-01 00:58:40.000000', 'consum', 0.0221, 'lps'),
	(572974, 131, '2014-03-01 00:58:41.000000', 'consum', 0.0215, 'lps'),
	(572975, 131, '2014-03-01 00:58:42.000000', 'consum', 0.0223, 'lps'),
	(572976, 131, '2014-03-01 00:58:43.000000', 'consum', 0.0224, 'lps'),
	(572977, 131, '2014-03-01 00:58:44.000000', 'consum', 0.0224, 'lps'),
	(572978, 131, '2014-03-01 00:58:45.000000', 'consum', 0.0219, 'lps'),
	(572979, 131, '2014-03-01 00:58:46.000000', 'consum', 0.0216, 'lps'),
	(572980, 131, '2014-03-01 00:58:47.000000', 'consum', 0.0212, 'lps'),
	(572981, 131, '2014-03-01 00:58:48.000000', 'consum', 0.0220, 'lps'),
	(572982, 131, '2014-03-01 00:58:49.000000', 'consum', 0.0219, 'lps'),
	(572983, 131, '2014-03-01 00:58:50.000000', 'consum', 0.0224, 'lps'),
	(572984, 131, '2014-03-01 00:58:51.000000', 'consum', 0.0219, 'lps'),
	(572985, 131, '2014-03-01 00:58:52.000000', 'consum', 0.0212, 'lps'),
	(572986, 131, '2014-03-01 00:58:53.000000', 'consum', 0.0214, 'lps'),
	(572987, 131, '2014-03-01 00:58:54.000000', 'consum', 0.0222, 'lps'),
	(572988, 131, '2014-03-01 00:58:55.000000', 'consum', 0.0223, 'lps'),
	(572989, 131, '2014-03-01 00:58:56.000000', 'consum', 0.0222, 'lps'),
	(572990, 131, '2014-03-01 00:58:57.000000', 'consum', 0.0214, 'lps'),
	(572991, 131, '2014-03-01 00:58:58.000000', 'consum', 0.0211, 'lps'),
	(572992, 131, '2014-03-01 00:58:59.000000', 'consum', 0.0222, 'lps'),
	(572993, 131, '2014-03-01 00:59:00.000000', 'consum', 0.0213, 'lps'),
	(572994, 131, '2014-03-01 00:59:01.000000', 'consum', 0.0224, 'lps'),
	(572995, 131, '2014-03-01 00:59:02.000000', 'consum', 0.0221, 'lps'),
	(572996, 131, '2014-03-01 00:59:03.000000', 'consum', 0.0221, 'lps'),
	(572997, 131, '2014-03-01 00:59:04.000000', 'consum', 0.0213, 'lps'),
	(572998, 131, '2014-03-01 00:59:05.000000', 'consum', 0.0213, 'lps'),
	(572999, 131, '2014-03-01 00:59:06.000000', 'consum', 0.0214, 'lps'),
	(573000, 131, '2014-03-01 00:59:07.000000', 'consum', 0.0222, 'lps'),
	(573001, 131, '2014-03-01 00:59:08.000000', 'consum', 0.0224, 'lps'),
	(573002, 131, '2014-03-01 00:59:09.000000', 'consum', 0.0224, 'lps'),
	(573003, 131, '2014-03-01 00:59:10.000000', 'consum', 0.0222, 'lps'),
	(573004, 131, '2014-03-01 00:59:11.000000', 'consum', 0.0211, 'lps'),
	(573005, 131, '2014-03-01 00:59:12.000000', 'consum', 0.0213, 'lps'),
	(573006, 131, '2014-03-01 00:59:13.000000', 'consum', 0.0224, 'lps'),
	(573007, 131, '2014-03-01 00:59:14.000000', 'consum', 0.0219, 'lps'),
	(573008, 131, '2014-03-01 00:59:15.000000', 'consum', 0.0212, 'lps'),
	(573009, 131, '2014-03-01 00:59:16.000000', 'consum', 0.0210, 'lps'),
	(573010, 131, '2014-03-01 00:59:17.000000', 'consum', 0.0223, 'lps'),
	(573011, 131, '2014-03-01 00:59:18.000000', 'consum', 0.0223, 'lps'),
	(573012, 131, '2014-03-01 00:59:19.000000', 'consum', 0.0219, 'lps'),
	(573013, 131, '2014-03-01 00:59:20.000000', 'consum', 0.0215, 'lps'),
	(573014, 131, '2014-03-01 00:59:21.000000', 'consum', 0.0211, 'lps'),
	(573015, 131, '2014-03-01 00:59:22.000000', 'consum', 0.0215, 'lps'),
	(573016, 131, '2014-03-01 00:59:23.000000', 'consum', 0.0217, 'lps'),
	(573017, 131, '2014-03-01 00:59:24.000000', 'consum', 0.0210, 'lps'),
	(573018, 131, '2014-03-01 00:59:25.000000', 'consum', 0.0227, 'lps'),
	(573019, 131, '2014-03-01 00:59:26.000000', 'consum', 0.0223, 'lps'),
	(573020, 131, '2014-03-01 00:59:27.000000', 'consum', 0.0227, 'lps'),
	(573021, 131, '2014-03-01 00:59:28.000000', 'consum', 0.0218, 'lps'),
	(573022, 131, '2014-03-01 00:59:29.000000', 'consum', 0.0219, 'lps'),
	(573023, 131, '2014-03-01 00:59:30.000000', 'consum', 0.0213, 'lps'),
	(573024, 131, '2014-03-01 00:59:31.000000', 'consum', 0.0216, 'lps'),
	(573025, 131, '2014-03-01 00:59:32.000000', 'consum', 0.0213, 'lps'),
	(573026, 131, '2014-03-01 00:59:33.000000', 'consum', 0.0225, 'lps'),
	(573027, 131, '2014-03-01 00:59:34.000000', 'consum', 0.0223, 'lps'),
	(573028, 131, '2014-03-01 00:59:35.000000', 'consum', 0.0212, 'lps'),
	(573029, 131, '2014-03-01 00:59:36.000000', 'consum', 0.0216, 'lps'),
	(573030, 131, '2014-03-01 00:59:37.000000', 'consum', 0.0217, 'lps'),
	(573031, 131, '2014-03-01 00:59:38.000000', 'consum', 0.0212, 'lps'),
	(573032, 131, '2014-03-01 00:59:39.000000', 'consum', 0.0215, 'lps'),
	(573033, 131, '2014-03-01 00:59:40.000000', 'consum', 0.0212, 'lps'),
	(573034, 131, '2014-03-01 00:59:41.000000', 'consum', 0.0223, 'lps'),
	(573035, 131, '2014-03-01 00:59:42.000000', 'consum', 0.0215, 'lps'),
	(573036, 131, '2014-03-01 00:59:43.000000', 'consum', 0.0215, 'lps'),
	(573037, 131, '2014-03-01 00:59:44.000000', 'consum', 0.0219, 'lps'),
	(573038, 131, '2014-03-01 00:59:45.000000', 'consum', 0.0224, 'lps'),
	(573039, 131, '2014-03-01 00:59:46.000000', 'consum', 0.0216, 'lps'),
	(573040, 131, '2014-03-01 00:59:47.000000', 'consum', 0.0216, 'lps'),
	(573041, 131, '2014-03-01 00:59:48.000000', 'consum', 0.0223, 'lps'),
	(573042, 131, '2014-03-01 00:59:49.000000', 'consum', 0.0223, 'lps'),
	(573043, 131, '2014-03-01 00:59:50.000000', 'consum', 0.0216, 'lps'),
	(573044, 131, '2014-03-01 00:59:51.000000', 'consum', 0.0221, 'lps'),
	(573045, 131, '2014-03-01 00:59:52.000000', 'consum', 0.0210, 'lps'),
	(573046, 131, '2014-03-01 00:59:53.000000', 'consum', 0.0216, 'lps'),
	(573047, 131, '2014-03-01 00:59:54.000000', 'consum', 0.0220, 'lps'),
	(573048, 131, '2014-03-01 00:59:55.000000', 'consum', 0.0224, 'lps'),
	(573049, 131, '2014-03-01 00:59:56.000000', 'consum', 0.0215, 'lps'),
	(573050, 131, '2014-03-01 00:59:57.000000', 'consum', 0.0211, 'lps'),
	(573051, 131, '2014-03-01 00:59:58.000000', 'consum', 0.0217, 'lps'),
	(573052, 131, '2014-03-01 00:59:59.000000', 'consum', 0.0226, 'lps'),
	(573053, 131, '2014-03-01 01:00:00.000000', 'consum', 0.0216, 'lps'),
	(573054, 131, '2014-03-01 01:00:01.000000', 'consum', 0.0210, 'lps'),
	(573055, 131, '2014-03-01 01:00:02.000000', 'consum', 0.0227, 'lps'),
	(573056, 131, '2014-03-01 01:00:03.000000', 'consum', 0.0225, 'lps'),
	(573057, 131, '2014-03-01 01:00:04.000000', 'consum', 0.0214, 'lps'),
	(573058, 131, '2014-03-01 01:00:05.000000', 'consum', 0.0225, 'lps'),
	(573059, 131, '2014-03-01 01:00:06.000000', 'consum', 0.0218, 'lps'),
	(573060, 131, '2014-03-01 01:00:07.000000', 'consum', 0.0225, 'lps'),
	(573061, 131, '2014-03-01 01:00:08.000000', 'consum', 0.0225, 'lps'),
	(573062, 131, '2014-03-01 01:00:09.000000', 'consum', 0.0222, 'lps'),
	(573063, 131, '2014-03-01 01:00:10.000000', 'consum', 0.0227, 'lps'),
	(573064, 131, '2014-03-01 01:00:11.000000', 'consum', 0.0222, 'lps'),
	(573065, 131, '2014-03-01 01:00:12.000000', 'consum', 0.0219, 'lps'),
	(573066, 131, '2014-03-01 01:00:13.000000', 'consum', 0.0219, 'lps'),
	(573067, 131, '2014-03-01 01:00:14.000000', 'consum', 0.0213, 'lps'),
	(573068, 131, '2014-03-01 01:00:15.000000', 'consum', 0.0217, 'lps'),
	(573069, 131, '2014-03-01 01:00:16.000000', 'consum', 0.0215, 'lps'),
	(573070, 131, '2014-03-01 01:00:17.000000', 'consum', 0.0217, 'lps'),
	(573071, 131, '2014-03-01 01:00:18.000000', 'consum', 0.0213, 'lps'),
	(573072, 131, '2014-03-01 01:00:19.000000', 'consum', 0.0222, 'lps'),
	(573073, 131, '2014-03-01 01:00:20.000000', 'consum', 0.0225, 'lps'),
	(573074, 131, '2014-03-01 01:00:21.000000', 'consum', 0.0212, 'lps'),
	(573075, 131, '2014-03-01 01:00:22.000000', 'consum', 0.0211, 'lps'),
	(573076, 131, '2014-03-01 01:00:23.000000', 'consum', 0.0210, 'lps'),
	(573077, 131, '2014-03-01 01:00:24.000000', 'consum', 0.0227, 'lps'),
	(573078, 131, '2014-03-01 01:00:25.000000', 'consum', 0.0222, 'lps'),
	(573079, 131, '2014-03-01 01:00:26.000000', 'consum', 0.0219, 'lps'),
	(573080, 131, '2014-03-01 01:00:27.000000', 'consum', 0.0220, 'lps'),
	(573081, 131, '2014-03-01 01:00:28.000000', 'consum', 0.0214, 'lps'),
	(573082, 131, '2014-03-01 01:00:29.000000', 'consum', 0.0219, 'lps'),
	(573083, 131, '2014-03-01 01:00:30.000000', 'consum', 0.0224, 'lps'),
	(573084, 131, '2014-03-01 01:00:31.000000', 'consum', 0.0220, 'lps'),
	(573085, 131, '2014-03-01 01:00:32.000000', 'consum', 0.0220, 'lps'),
	(573086, 131, '2014-03-01 01:00:33.000000', 'consum', 0.0210, 'lps'),
	(573087, 131, '2014-03-01 01:00:34.000000', 'consum', 0.0216, 'lps'),
	(573088, 131, '2014-03-01 01:00:35.000000', 'consum', 0.0222, 'lps'),
	(573089, 131, '2014-03-01 01:00:36.000000', 'consum', 0.0216, 'lps'),
	(573090, 131, '2014-03-01 01:00:37.000000', 'consum', 0.0223, 'lps'),
	(573091, 131, '2014-03-01 01:00:38.000000', 'consum', 0.0223, 'lps'),
	(573092, 131, '2014-03-01 01:00:39.000000', 'consum', 0.0219, 'lps'),
	(573093, 131, '2014-03-01 01:00:40.000000', 'consum', 0.0217, 'lps'),
	(573094, 131, '2014-03-01 01:00:41.000000', 'consum', 0.0219, 'lps'),
	(573095, 131, '2014-03-01 01:00:42.000000', 'consum', 0.0215, 'lps'),
	(573096, 131, '2014-03-01 01:00:43.000000', 'consum', 0.0226, 'lps'),
	(573097, 131, '2014-03-01 01:00:44.000000', 'consum', 0.0221, 'lps'),
	(573098, 131, '2014-03-01 01:00:45.000000', 'consum', 0.0217, 'lps'),
	(573099, 131, '2014-03-01 01:00:46.000000', 'consum', 0.0212, 'lps'),
	(573100, 131, '2014-03-01 01:00:47.000000', 'consum', 0.0218, 'lps'),
	(573101, 131, '2014-03-01 01:00:48.000000', 'consum', 0.0210, 'lps'),
	(573102, 131, '2014-03-01 01:00:49.000000', 'consum', 0.0222, 'lps'),
	(573103, 131, '2014-03-01 01:00:50.000000', 'consum', 0.0215, 'lps'),
	(573104, 131, '2014-03-01 01:00:51.000000', 'consum', 0.0216, 'lps'),
	(573105, 131, '2014-03-01 01:00:52.000000', 'consum', 0.0211, 'lps'),
	(573106, 131, '2014-03-01 01:00:53.000000', 'consum', 0.0216, 'lps'),
	(573107, 131, '2014-03-01 01:00:54.000000', 'consum', 0.0216, 'lps'),
	(573108, 131, '2014-03-01 01:00:55.000000', 'consum', 0.0225, 'lps'),
	(573109, 131, '2014-03-01 01:00:56.000000', 'consum', 0.0213, 'lps'),
	(573110, 131, '2014-03-01 01:00:57.000000', 'consum', 0.0217, 'lps'),
	(573111, 131, '2014-03-01 01:00:58.000000', 'consum', 0.0217, 'lps'),
	(573112, 131, '2014-03-01 01:00:59.000000', 'consum', 0.0226, 'lps'),
	(573113, 131, '2014-03-01 01:01:00.000000', 'consum', 0.0217, 'lps'),
	(573114, 131, '2014-03-01 01:01:01.000000', 'consum', 0.0214, 'lps'),
	(573115, 131, '2014-03-01 01:01:02.000000', 'consum', 0.0227, 'lps'),
	(573116, 131, '2014-03-01 01:01:03.000000', 'consum', 0.0212, 'lps'),
	(573117, 131, '2014-03-01 01:01:04.000000', 'consum', 0.0224, 'lps'),
	(573118, 131, '2014-03-01 01:01:05.000000', 'consum', 0.0222, 'lps'),
	(573119, 131, '2014-03-01 01:01:06.000000', 'consum', 0.0226, 'lps'),
	(573120, 131, '2014-03-01 01:01:07.000000', 'consum', 0.0218, 'lps'),
	(573121, 131, '2014-03-01 01:01:08.000000', 'consum', 0.0220, 'lps'),
	(573122, 131, '2014-03-01 01:01:09.000000', 'consum', 0.0219, 'lps'),
	(573123, 131, '2014-03-01 01:01:10.000000', 'consum', 0.0225, 'lps'),
	(573124, 131, '2014-03-01 01:01:11.000000', 'consum', 0.0223, 'lps'),
	(573125, 131, '2014-03-01 01:01:12.000000', 'consum', 0.0212, 'lps'),
	(573126, 131, '2014-03-01 01:01:13.000000', 'consum', 0.0218, 'lps'),
	(573127, 131, '2014-03-01 01:01:14.000000', 'consum', 0.0210, 'lps'),
	(573128, 131, '2014-03-01 01:01:15.000000', 'consum', 0.0224, 'lps'),
	(573129, 131, '2014-03-01 01:01:16.000000', 'consum', 0.0223, 'lps'),
	(573130, 131, '2014-03-01 01:01:17.000000', 'consum', 0.0215, 'lps'),
	(573131, 131, '2014-03-01 01:01:18.000000', 'consum', 0.0215, 'lps'),
	(573132, 131, '2014-03-01 01:01:19.000000', 'consum', 0.0221, 'lps'),
	(573133, 131, '2014-03-01 01:01:20.000000', 'consum', 0.0213, 'lps'),
	(573134, 131, '2014-03-01 01:01:21.000000', 'consum', 0.0211, 'lps'),
	(573135, 131, '2014-03-01 01:01:22.000000', 'consum', 0.0226, 'lps'),
	(573136, 131, '2014-03-01 01:01:23.000000', 'consum', 0.0214, 'lps'),
	(573137, 131, '2014-03-01 01:01:24.000000', 'consum', 0.0221, 'lps'),
	(573138, 131, '2014-03-01 01:01:25.000000', 'consum', 0.0215, 'lps'),
	(573139, 131, '2014-03-01 01:01:26.000000', 'consum', 0.0221, 'lps'),
	(573140, 131, '2014-03-01 01:01:27.000000', 'consum', 0.0213, 'lps'),
	(573141, 131, '2014-03-01 01:01:28.000000', 'consum', 0.0210, 'lps'),
	(573142, 131, '2014-03-01 01:01:29.000000', 'consum', 0.0221, 'lps'),
	(573143, 131, '2014-03-01 01:01:30.000000', 'consum', 0.0212, 'lps'),
	(573144, 131, '2014-03-01 01:01:31.000000', 'consum', 0.0225, 'lps'),
	(573145, 131, '2014-03-01 01:01:32.000000', 'consum', 0.0222, 'lps'),
	(573146, 131, '2014-03-01 01:01:33.000000', 'consum', 0.0227, 'lps'),
	(573147, 131, '2014-03-01 01:01:34.000000', 'consum', 0.0225, 'lps'),
	(573148, 131, '2014-03-01 01:01:35.000000', 'consum', 0.0215, 'lps'),
	(573149, 131, '2014-03-01 01:01:36.000000', 'consum', 0.0211, 'lps'),
	(573150, 131, '2014-03-01 01:01:37.000000', 'consum', 0.0216, 'lps'),
	(573151, 131, '2014-03-01 01:01:38.000000', 'consum', 0.0219, 'lps'),
	(573152, 131, '2014-03-01 01:01:39.000000', 'consum', 0.0219, 'lps'),
	(573153, 131, '2014-03-01 01:01:40.000000', 'consum', 0.0211, 'lps'),
	(573154, 131, '2014-03-01 01:01:41.000000', 'consum', 0.0223, 'lps'),
	(573155, 131, '2014-03-01 01:01:42.000000', 'consum', 0.0220, 'lps'),
	(573156, 131, '2014-03-01 01:01:43.000000', 'consum', 0.0221, 'lps'),
	(573157, 131, '2014-03-01 01:01:44.000000', 'consum', 0.0217, 'lps'),
	(573158, 131, '2014-03-01 01:01:45.000000', 'consum', 0.0212, 'lps'),
	(573159, 131, '2014-03-01 01:01:46.000000', 'consum', 0.0220, 'lps'),
	(573160, 131, '2014-03-01 01:01:47.000000', 'consum', 0.0217, 'lps'),
	(573161, 131, '2014-03-01 01:01:48.000000', 'consum', 0.0218, 'lps'),
	(573162, 131, '2014-03-01 01:01:49.000000', 'consum', 0.0227, 'lps'),
	(573163, 131, '2014-03-01 01:01:50.000000', 'consum', 0.0218, 'lps'),
	(573164, 131, '2014-03-01 01:01:51.000000', 'consum', 0.0218, 'lps'),
	(573165, 131, '2014-03-01 01:01:52.000000', 'consum', 0.0227, 'lps'),
	(573166, 131, '2014-03-01 01:01:53.000000', 'consum', 0.0216, 'lps'),
	(573167, 131, '2014-03-01 01:01:54.000000', 'consum', 0.0226, 'lps'),
	(573168, 131, '2014-03-01 01:01:55.000000', 'consum', 0.0219, 'lps'),
	(573169, 131, '2014-03-01 01:01:56.000000', 'consum', 0.0227, 'lps'),
	(573170, 131, '2014-03-01 01:01:57.000000', 'consum', 0.0215, 'lps'),
	(573171, 131, '2014-03-01 01:01:58.000000', 'consum', 0.0218, 'lps'),
	(573172, 131, '2014-03-01 01:01:59.000000', 'consum', 0.0220, 'lps'),
	(573173, 131, '2014-03-01 01:02:00.000000', 'consum', 0.0219, 'lps'),
	(573174, 131, '2014-03-01 01:02:01.000000', 'consum', 0.0226, 'lps'),
	(573175, 131, '2014-03-01 01:02:02.000000', 'consum', 0.0210, 'lps'),
	(573176, 131, '2014-03-01 01:02:03.000000', 'consum', 0.0215, 'lps'),
	(573177, 131, '2014-03-01 01:02:04.000000', 'consum', 0.0220, 'lps'),
	(573178, 131, '2014-03-01 01:02:05.000000', 'consum', 0.0224, 'lps'),
	(573179, 131, '2014-03-01 01:02:06.000000', 'consum', 0.0216, 'lps'),
	(573180, 131, '2014-03-01 01:02:07.000000', 'consum', 0.0215, 'lps'),
	(573181, 131, '2014-03-01 01:02:08.000000', 'consum', 0.0220, 'lps'),
	(573182, 131, '2014-03-01 01:02:09.000000', 'consum', 0.0227, 'lps'),
	(573183, 131, '2014-03-01 01:02:10.000000', 'consum', 0.0213, 'lps'),
	(573184, 131, '2014-03-01 01:02:11.000000', 'consum', 0.0226, 'lps'),
	(573185, 131, '2014-03-01 01:02:12.000000', 'consum', 0.0212, 'lps'),
	(573186, 131, '2014-03-01 01:02:13.000000', 'consum', 0.0224, 'lps'),
	(573187, 131, '2014-03-01 01:02:14.000000', 'consum', 0.0220, 'lps'),
	(573188, 131, '2014-03-01 01:02:15.000000', 'consum', 0.0219, 'lps'),
	(573189, 131, '2014-03-01 01:02:16.000000', 'consum', 0.0226, 'lps'),
	(573190, 131, '2014-03-01 01:02:17.000000', 'consum', 0.0227, 'lps'),
	(573191, 131, '2014-03-01 01:02:18.000000', 'consum', 0.0212, 'lps'),
	(573192, 131, '2014-03-01 01:02:19.000000', 'consum', 0.0225, 'lps'),
	(573193, 131, '2014-03-01 01:02:20.000000', 'consum', 0.0223, 'lps'),
	(573194, 131, '2014-03-01 01:02:21.000000', 'consum', 0.0212, 'lps'),
	(573195, 131, '2014-03-01 01:02:22.000000', 'consum', 0.0217, 'lps'),
	(573196, 131, '2014-03-01 01:02:23.000000', 'consum', 0.0223, 'lps'),
	(573197, 131, '2014-03-01 01:02:24.000000', 'consum', 0.0217, 'lps'),
	(573198, 131, '2014-03-01 01:02:25.000000', 'consum', 0.0224, 'lps'),
	(573199, 131, '2014-03-01 01:02:26.000000', 'consum', 0.0225, 'lps'),
	(573200, 131, '2014-03-01 01:02:27.000000', 'consum', 0.0224, 'lps'),
	(573201, 131, '2014-03-01 01:02:28.000000', 'consum', 0.0217, 'lps'),
	(573202, 131, '2014-03-01 01:02:29.000000', 'consum', 0.0224, 'lps'),
	(573203, 131, '2014-03-01 01:02:30.000000', 'consum', 0.0222, 'lps'),
	(573204, 131, '2014-03-01 01:02:31.000000', 'consum', 0.0210, 'lps'),
	(573205, 131, '2014-03-01 01:02:32.000000', 'consum', 0.0210, 'lps'),
	(573206, 131, '2014-03-01 01:02:33.000000', 'consum', 0.0213, 'lps'),
	(573207, 131, '2014-03-01 01:02:34.000000', 'consum', 0.0223, 'lps'),
	(573208, 131, '2014-03-01 01:02:35.000000', 'consum', 0.0215, 'lps'),
	(573209, 131, '2014-03-01 01:02:36.000000', 'consum', 0.0212, 'lps'),
	(573210, 131, '2014-03-01 01:02:37.000000', 'consum', 0.0226, 'lps'),
	(573211, 131, '2014-03-01 01:02:38.000000', 'consum', 0.0210, 'lps'),
	(573212, 131, '2014-03-01 01:02:39.000000', 'consum', 0.0216, 'lps'),
	(573213, 131, '2014-03-01 01:02:40.000000', 'consum', 0.0222, 'lps'),
	(573214, 131, '2014-03-01 01:02:41.000000', 'consum', 0.0216, 'lps'),
	(573215, 131, '2014-03-01 01:02:42.000000', 'consum', 0.0225, 'lps'),
	(573216, 131, '2014-03-01 01:02:43.000000', 'consum', 0.0211, 'lps'),
	(573217, 131, '2014-03-01 01:02:44.000000', 'consum', 0.0224, 'lps'),
	(573218, 131, '2014-03-01 01:02:45.000000', 'consum', 0.0225, 'lps'),
	(573219, 131, '2014-03-01 01:02:46.000000', 'consum', 0.0223, 'lps'),
	(573220, 131, '2014-03-01 01:02:47.000000', 'consum', 0.0216, 'lps'),
	(573221, 131, '2014-03-01 01:02:48.000000', 'consum', 0.0217, 'lps'),
	(573222, 131, '2014-03-01 01:02:49.000000', 'consum', 0.0210, 'lps'),
	(573223, 131, '2014-03-01 01:02:50.000000', 'consum', 0.0225, 'lps'),
	(573224, 131, '2014-03-01 01:02:51.000000', 'consum', 0.0215, 'lps'),
	(573225, 131, '2014-03-01 01:02:52.000000', 'consum', 0.0224, 'lps'),
	(573226, 131, '2014-03-01 01:02:53.000000', 'consum', 0.0213, 'lps'),
	(573227, 131, '2014-03-01 01:02:54.000000', 'consum', 0.0220, 'lps'),
	(573228, 131, '2014-03-01 01:02:55.000000', 'consum', 0.0214, 'lps'),
	(573229, 131, '2014-03-01 01:02:56.000000', 'consum', 0.0219, 'lps'),
	(573230, 131, '2014-03-01 01:02:57.000000', 'consum', 0.0227, 'lps'),
	(573231, 131, '2014-03-01 01:02:58.000000', 'consum', 0.0215, 'lps'),
	(573232, 131, '2014-03-01 01:02:59.000000', 'consum', 0.0221, 'lps'),
	(573233, 131, '2014-03-01 01:03:00.000000', 'consum', 0.0213, 'lps'),
	(573234, 131, '2014-03-01 01:03:01.000000', 'consum', 0.0227, 'lps'),
	(573235, 131, '2014-03-01 01:03:02.000000', 'consum', 0.0217, 'lps'),
	(573236, 131, '2014-03-01 01:03:03.000000', 'consum', 0.0211, 'lps'),
	(573237, 131, '2014-03-01 01:03:04.000000', 'consum', 0.0212, 'lps'),
	(573238, 131, '2014-03-01 01:03:05.000000', 'consum', 0.0219, 'lps'),
	(573239, 131, '2014-03-01 01:03:06.000000', 'consum', 0.0214, 'lps'),
	(573240, 131, '2014-03-01 01:03:07.000000', 'consum', 0.0219, 'lps'),
	(573241, 131, '2014-03-01 01:03:08.000000', 'consum', 0.0211, 'lps'),
	(573242, 131, '2014-03-01 01:03:09.000000', 'consum', 0.0222, 'lps'),
	(573243, 131, '2014-03-01 01:03:10.000000', 'consum', 0.0215, 'lps'),
	(573244, 131, '2014-03-01 01:03:11.000000', 'consum', 0.0217, 'lps'),
	(573245, 131, '2014-03-01 01:03:12.000000', 'consum', 0.0213, 'lps'),
	(573246, 131, '2014-03-01 01:03:13.000000', 'consum', 0.0222, 'lps'),
	(573247, 131, '2014-03-01 01:03:14.000000', 'consum', 0.0226, 'lps'),
	(573248, 131, '2014-03-01 01:03:15.000000', 'consum', 0.0219, 'lps'),
	(573249, 131, '2014-03-01 01:03:16.000000', 'consum', 0.0224, 'lps'),
	(573250, 131, '2014-03-01 01:03:17.000000', 'consum', 0.0219, 'lps'),
	(573251, 131, '2014-03-01 01:03:18.000000', 'consum', 0.0213, 'lps'),
	(573252, 131, '2014-03-01 01:03:19.000000', 'consum', 0.0218, 'lps'),
	(573253, 131, '2014-03-01 01:03:20.000000', 'consum', 0.0221, 'lps'),
	(573254, 131, '2014-03-01 01:03:21.000000', 'consum', 0.0222, 'lps'),
	(573255, 131, '2014-03-01 01:03:22.000000', 'consum', 0.0223, 'lps'),
	(573256, 131, '2014-03-01 01:03:23.000000', 'consum', 0.0219, 'lps'),
	(573257, 131, '2014-03-01 01:03:24.000000', 'consum', 0.0217, 'lps'),
	(573258, 131, '2014-03-01 01:03:25.000000', 'consum', 0.0219, 'lps'),
	(573259, 131, '2014-03-01 01:03:26.000000', 'consum', 0.0218, 'lps'),
	(573260, 131, '2014-03-01 01:03:27.000000', 'consum', 0.0223, 'lps'),
	(573261, 131, '2014-03-01 01:03:28.000000', 'consum', 0.0216, 'lps'),
	(573262, 131, '2014-03-01 01:03:29.000000', 'consum', 0.0218, 'lps'),
	(573263, 131, '2014-03-01 01:03:30.000000', 'consum', 0.0213, 'lps'),
	(573264, 131, '2014-03-01 01:03:31.000000', 'consum', 0.0221, 'lps'),
	(573265, 131, '2014-03-01 01:03:32.000000', 'consum', 0.0221, 'lps'),
	(573266, 131, '2014-03-01 01:03:33.000000', 'consum', 0.0216, 'lps'),
	(573267, 131, '2014-03-01 01:03:34.000000', 'consum', 0.0224, 'lps'),
	(573268, 131, '2014-03-01 01:03:35.000000', 'consum', 0.0227, 'lps'),
	(573269, 131, '2014-03-01 01:03:36.000000', 'consum', 0.0216, 'lps'),
	(573270, 131, '2014-03-01 01:03:37.000000', 'consum', 0.0225, 'lps'),
	(573271, 131, '2014-03-01 01:03:38.000000', 'consum', 0.0214, 'lps'),
	(573272, 131, '2014-03-01 01:03:39.000000', 'consum', 0.0220, 'lps'),
	(573273, 131, '2014-03-01 01:03:40.000000', 'consum', 0.0215, 'lps'),
	(573274, 131, '2014-03-01 01:03:41.000000', 'consum', 0.0222, 'lps'),
	(573275, 131, '2014-03-01 01:03:42.000000', 'consum', 0.0221, 'lps'),
	(573276, 131, '2014-03-01 01:03:43.000000', 'consum', 0.0210, 'lps'),
	(573277, 131, '2014-03-01 01:03:44.000000', 'consum', 0.0214, 'lps'),
	(573278, 131, '2014-03-01 01:03:45.000000', 'consum', 0.0212, 'lps'),
	(573279, 131, '2014-03-01 01:03:46.000000', 'consum', 0.0210, 'lps'),
	(573280, 131, '2014-03-01 01:03:47.000000', 'consum', 0.0220, 'lps'),
	(573281, 131, '2014-03-01 01:03:48.000000', 'consum', 0.0224, 'lps'),
	(573282, 131, '2014-03-01 01:03:49.000000', 'consum', 0.0216, 'lps'),
	(573283, 131, '2014-03-01 01:03:50.000000', 'consum', 0.0218, 'lps'),
	(573284, 131, '2014-03-01 01:03:51.000000', 'consum', 0.0215, 'lps'),
	(573285, 131, '2014-03-01 01:03:52.000000', 'consum', 0.0211, 'lps'),
	(573286, 131, '2014-03-01 01:03:53.000000', 'consum', 0.0217, 'lps'),
	(573287, 131, '2014-03-01 01:03:54.000000', 'consum', 0.0224, 'lps'),
	(573288, 131, '2014-03-01 01:03:55.000000', 'consum', 0.0224, 'lps'),
	(573289, 131, '2014-03-01 01:03:56.000000', 'consum', 0.0219, 'lps'),
	(573290, 131, '2014-03-01 01:03:57.000000', 'consum', 0.0215, 'lps'),
	(573291, 131, '2014-03-01 01:03:58.000000', 'consum', 0.0227, 'lps'),
	(573292, 131, '2014-03-01 01:03:59.000000', 'consum', 0.0227, 'lps'),
	(573293, 131, '2014-03-01 01:04:00.000000', 'consum', 0.0225, 'lps'),
	(573294, 131, '2014-03-01 01:04:01.000000', 'consum', 0.0218, 'lps'),
	(573295, 131, '2014-03-01 01:04:02.000000', 'consum', 0.0221, 'lps'),
	(573296, 131, '2014-03-01 01:04:03.000000', 'consum', 0.0225, 'lps'),
	(573297, 131, '2014-03-01 01:04:04.000000', 'consum', 0.0217, 'lps'),
	(573298, 131, '2014-03-01 01:04:05.000000', 'consum', 0.0219, 'lps'),
	(573299, 131, '2014-03-01 01:04:06.000000', 'consum', 0.0215, 'lps'),
	(573300, 131, '2014-03-01 01:04:07.000000', 'consum', 0.0226, 'lps'),
	(573301, 131, '2014-03-01 01:04:08.000000', 'consum', 0.0223, 'lps'),
	(573302, 131, '2014-03-01 01:04:09.000000', 'consum', 0.0226, 'lps'),
	(573303, 131, '2014-03-01 01:04:10.000000', 'consum', 0.0215, 'lps'),
	(573304, 131, '2014-03-01 01:04:11.000000', 'consum', 0.0226, 'lps'),
	(573305, 131, '2014-03-01 01:04:12.000000', 'consum', 0.0221, 'lps'),
	(573306, 131, '2014-03-01 01:04:13.000000', 'consum', 0.0216, 'lps'),
	(573307, 131, '2014-03-01 01:04:14.000000', 'consum', 0.0226, 'lps'),
	(573308, 131, '2014-03-01 01:04:15.000000', 'consum', 0.0220, 'lps'),
	(573309, 131, '2014-03-01 01:04:16.000000', 'consum', 0.0210, 'lps'),
	(573310, 131, '2014-03-01 01:04:17.000000', 'consum', 0.0218, 'lps'),
	(573311, 131, '2014-03-01 01:04:18.000000', 'consum', 0.0215, 'lps'),
	(573312, 131, '2014-03-01 01:04:19.000000', 'consum', 0.0211, 'lps'),
	(573313, 131, '2014-03-01 01:04:20.000000', 'consum', 0.0217, 'lps'),
	(573314, 131, '2014-03-01 01:04:21.000000', 'consum', 0.0225, 'lps'),
	(573315, 131, '2014-03-01 01:04:22.000000', 'consum', 0.0211, 'lps'),
	(573316, 131, '2014-03-01 01:04:23.000000', 'consum', 0.0225, 'lps'),
	(573317, 131, '2014-03-01 01:04:24.000000', 'consum', 0.0211, 'lps'),
	(573318, 131, '2014-03-01 01:04:25.000000', 'consum', 0.0222, 'lps'),
	(573319, 131, '2014-03-01 01:04:26.000000', 'consum', 0.0214, 'lps'),
	(573320, 131, '2014-03-01 01:04:27.000000', 'consum', 0.0212, 'lps'),
	(573321, 131, '2014-03-01 01:04:28.000000', 'consum', 0.0211, 'lps'),
	(573322, 131, '2014-03-01 01:04:29.000000', 'consum', 0.0225, 'lps'),
	(573323, 131, '2014-03-01 01:04:30.000000', 'consum', 0.0210, 'lps'),
	(573324, 131, '2014-03-01 01:04:31.000000', 'consum', 0.0221, 'lps'),
	(573325, 131, '2014-03-01 01:04:32.000000', 'consum', 0.0227, 'lps'),
	(573326, 131, '2014-03-01 01:04:33.000000', 'consum', 0.0211, 'lps'),
	(573327, 131, '2014-03-01 01:04:34.000000', 'consum', 0.0218, 'lps'),
	(573328, 131, '2014-03-01 01:04:35.000000', 'consum', 0.0210, 'lps'),
	(573329, 131, '2014-03-01 01:04:36.000000', 'consum', 0.0222, 'lps'),
	(573330, 131, '2014-03-01 01:04:37.000000', 'consum', 0.0215, 'lps'),
	(573331, 131, '2014-03-01 01:04:38.000000', 'consum', 0.0221, 'lps'),
	(573332, 131, '2014-03-01 01:04:39.000000', 'consum', 0.0214, 'lps'),
	(573333, 131, '2014-03-01 01:04:40.000000', 'consum', 0.0214, 'lps'),
	(573334, 131, '2014-03-01 01:04:41.000000', 'consum', 0.0218, 'lps'),
	(573335, 131, '2014-03-01 01:04:42.000000', 'consum', 0.0221, 'lps'),
	(573336, 131, '2014-03-01 01:04:43.000000', 'consum', 0.0225, 'lps'),
	(573337, 131, '2014-03-01 01:04:44.000000', 'consum', 0.0217, 'lps'),
	(573338, 131, '2014-03-01 01:04:45.000000', 'consum', 0.0216, 'lps'),
	(573339, 131, '2014-03-01 01:04:46.000000', 'consum', 0.0222, 'lps'),
	(573340, 131, '2014-03-01 01:04:47.000000', 'consum', 0.0217, 'lps'),
	(573341, 131, '2014-03-01 01:04:48.000000', 'consum', 0.0227, 'lps'),
	(573342, 131, '2014-03-01 01:04:49.000000', 'consum', 0.0221, 'lps'),
	(573343, 131, '2014-03-01 01:04:50.000000', 'consum', 0.0216, 'lps'),
	(573344, 131, '2014-03-01 01:04:51.000000', 'consum', 0.0224, 'lps'),
	(573345, 131, '2014-03-01 01:04:52.000000', 'consum', 0.0225, 'lps'),
	(573346, 131, '2014-03-01 01:04:53.000000', 'consum', 0.0227, 'lps'),
	(573347, 131, '2014-03-01 01:04:54.000000', 'consum', 0.0213, 'lps'),
	(573348, 131, '2014-03-01 01:04:55.000000', 'consum', 0.0213, 'lps'),
	(573349, 131, '2014-03-01 01:04:56.000000', 'consum', 0.0215, 'lps'),
	(573350, 131, '2014-03-01 01:04:57.000000', 'consum', 0.0225, 'lps'),
	(573351, 131, '2014-03-01 01:04:58.000000', 'consum', 0.0216, 'lps'),
	(573352, 131, '2014-03-01 01:04:59.000000', 'consum', 0.0216, 'lps'),
	(573353, 131, '2014-03-01 01:05:00.000000', 'consum', 0.0221, 'lps'),
	(573354, 131, '2014-03-01 01:05:01.000000', 'consum', 0.0212, 'lps'),
	(573355, 131, '2014-03-01 01:05:02.000000', 'consum', 0.0225, 'lps'),
	(573356, 131, '2014-03-01 01:05:03.000000', 'consum', 0.0226, 'lps'),
	(573357, 131, '2014-03-01 01:05:04.000000', 'consum', 0.0210, 'lps'),
	(573358, 131, '2014-03-01 01:05:05.000000', 'consum', 0.0214, 'lps'),
	(573359, 131, '2014-03-01 01:05:06.000000', 'consum', 0.0215, 'lps'),
	(573360, 131, '2014-03-01 01:05:07.000000', 'consum', 0.0222, 'lps'),
	(573361, 131, '2014-03-01 01:05:08.000000', 'consum', 0.0220, 'lps'),
	(573362, 131, '2014-03-01 01:05:09.000000', 'consum', 0.0226, 'lps'),
	(573363, 131, '2014-03-01 01:05:10.000000', 'consum', 0.0223, 'lps'),
	(573364, 131, '2014-03-01 01:05:11.000000', 'consum', 0.0211, 'lps'),
	(573365, 131, '2014-03-01 01:05:12.000000', 'consum', 0.0214, 'lps'),
	(573366, 131, '2014-03-01 01:05:13.000000', 'consum', 0.0224, 'lps'),
	(573367, 131, '2014-03-01 01:05:14.000000', 'consum', 0.0217, 'lps'),
	(573368, 131, '2014-03-01 01:05:15.000000', 'consum', 0.0219, 'lps'),
	(573369, 131, '2014-03-01 01:05:16.000000', 'consum', 0.0219, 'lps'),
	(573370, 131, '2014-03-01 01:05:17.000000', 'consum', 0.0212, 'lps'),
	(573371, 131, '2014-03-01 01:05:18.000000', 'consum', 0.0226, 'lps'),
	(573372, 131, '2014-03-01 01:05:19.000000', 'consum', 0.0215, 'lps'),
	(573373, 131, '2014-03-01 01:05:20.000000', 'consum', 0.0223, 'lps'),
	(573374, 131, '2014-03-01 01:05:21.000000', 'consum', 0.0223, 'lps'),
	(573375, 131, '2014-03-01 01:05:22.000000', 'consum', 0.0221, 'lps'),
	(573376, 131, '2014-03-01 01:05:23.000000', 'consum', 0.0226, 'lps'),
	(573377, 131, '2014-03-01 01:05:24.000000', 'consum', 0.0221, 'lps'),
	(573378, 131, '2014-03-01 01:05:25.000000', 'consum', 0.0219, 'lps'),
	(573379, 131, '2014-03-01 01:05:26.000000', 'consum', 0.0220, 'lps'),
	(573380, 131, '2014-03-01 01:05:27.000000', 'consum', 0.0215, 'lps'),
	(573381, 131, '2014-03-01 01:05:28.000000', 'consum', 0.0224, 'lps'),
	(573382, 131, '2014-03-01 01:05:29.000000', 'consum', 0.0213, 'lps'),
	(573383, 131, '2014-03-01 01:05:30.000000', 'consum', 0.0218, 'lps'),
	(573384, 131, '2014-03-01 01:05:31.000000', 'consum', 0.0226, 'lps'),
	(573385, 131, '2014-03-01 01:05:32.000000', 'consum', 0.0211, 'lps'),
	(573386, 131, '2014-03-01 01:05:33.000000', 'consum', 0.0223, 'lps'),
	(573387, 131, '2014-03-01 01:05:34.000000', 'consum', 0.0217, 'lps'),
	(573388, 131, '2014-03-01 01:05:35.000000', 'consum', 0.0223, 'lps'),
	(573389, 131, '2014-03-01 01:05:36.000000', 'consum', 0.0220, 'lps'),
	(573390, 131, '2014-03-01 01:05:37.000000', 'consum', 0.0222, 'lps'),
	(573391, 131, '2014-03-01 01:05:38.000000', 'consum', 0.0220, 'lps'),
	(573392, 131, '2014-03-01 01:05:39.000000', 'consum', 0.0210, 'lps'),
	(573393, 131, '2014-03-01 01:05:40.000000', 'consum', 0.0214, 'lps'),
	(573394, 131, '2014-03-01 01:05:41.000000', 'consum', 0.0213, 'lps'),
	(573395, 131, '2014-03-01 01:05:42.000000', 'consum', 0.0215, 'lps'),
	(573396, 131, '2014-03-01 01:05:43.000000', 'consum', 0.0227, 'lps'),
	(573397, 131, '2014-03-01 01:05:44.000000', 'consum', 0.0225, 'lps'),
	(573398, 131, '2014-03-01 01:05:45.000000', 'consum', 0.0216, 'lps'),
	(573399, 131, '2014-03-01 01:05:46.000000', 'consum', 0.0214, 'lps'),
	(573400, 131, '2014-03-01 01:05:47.000000', 'consum', 0.0212, 'lps'),
	(573401, 131, '2014-03-01 01:05:48.000000', 'consum', 0.0226, 'lps'),
	(573402, 131, '2014-03-01 01:05:49.000000', 'consum', 0.0215, 'lps'),
	(573403, 131, '2014-03-01 01:05:50.000000', 'consum', 0.0221, 'lps'),
	(573404, 131, '2014-03-01 01:05:51.000000', 'consum', 0.0216, 'lps'),
	(573405, 131, '2014-03-01 01:05:52.000000', 'consum', 0.0223, 'lps'),
	(573406, 131, '2014-03-01 01:05:53.000000', 'consum', 0.0224, 'lps'),
	(573407, 131, '2014-03-01 01:05:54.000000', 'consum', 0.0223, 'lps'),
	(573408, 131, '2014-03-01 01:05:55.000000', 'consum', 0.0217, 'lps'),
	(573409, 131, '2014-03-01 01:05:56.000000', 'consum', 0.0222, 'lps'),
	(573410, 131, '2014-03-01 01:05:57.000000', 'consum', 0.0215, 'lps'),
	(573411, 131, '2014-03-01 01:05:58.000000', 'consum', 0.0217, 'lps'),
	(573412, 131, '2014-03-01 01:05:59.000000', 'consum', 0.0215, 'lps'),
	(573413, 131, '2014-03-01 01:06:00.000000', 'consum', 0.0211, 'lps'),
	(573414, 131, '2014-03-01 01:06:01.000000', 'consum', 0.0220, 'lps'),
	(573415, 131, '2014-03-01 01:06:02.000000', 'consum', 0.0220, 'lps'),
	(573416, 131, '2014-03-01 01:06:03.000000', 'consum', 0.0212, 'lps'),
	(573417, 131, '2014-03-01 01:06:04.000000', 'consum', 0.0211, 'lps'),
	(573418, 131, '2014-03-01 01:06:05.000000', 'consum', 0.0225, 'lps'),
	(573419, 131, '2014-03-01 01:06:06.000000', 'consum', 0.0213, 'lps'),
	(573420, 131, '2014-03-01 01:06:07.000000', 'consum', 0.0217, 'lps'),
	(573421, 131, '2014-03-01 01:06:08.000000', 'consum', 0.0215, 'lps'),
	(573422, 131, '2014-03-01 01:06:09.000000', 'consum', 0.0218, 'lps'),
	(573423, 131, '2014-03-01 01:06:10.000000', 'consum', 0.0217, 'lps'),
	(573424, 131, '2014-03-01 01:06:11.000000', 'consum', 0.0222, 'lps'),
	(573425, 131, '2014-03-01 01:06:12.000000', 'consum', 0.0212, 'lps'),
	(573426, 131, '2014-03-01 01:06:13.000000', 'consum', 0.0223, 'lps'),
	(573427, 131, '2014-03-01 01:06:14.000000', 'consum', 0.0213, 'lps'),
	(573428, 131, '2014-03-01 01:06:15.000000', 'consum', 0.0224, 'lps'),
	(573429, 131, '2014-03-01 01:06:16.000000', 'consum', 0.0217, 'lps'),
	(573430, 131, '2014-03-01 01:06:17.000000', 'consum', 0.0222, 'lps'),
	(573431, 131, '2014-03-01 01:06:18.000000', 'consum', 0.0214, 'lps'),
	(573432, 131, '2014-03-01 01:06:19.000000', 'consum', 0.0211, 'lps'),
	(573433, 131, '2014-03-01 01:06:20.000000', 'consum', 0.0221, 'lps'),
	(573434, 131, '2014-03-01 01:06:21.000000', 'consum', 0.0227, 'lps'),
	(573435, 131, '2014-03-01 01:06:22.000000', 'consum', 0.0225, 'lps'),
	(573436, 131, '2014-03-01 01:06:23.000000', 'consum', 0.0220, 'lps'),
	(573437, 131, '2014-03-01 01:06:24.000000', 'consum', 0.0213, 'lps'),
	(573438, 131, '2014-03-01 01:06:25.000000', 'consum', 0.0213, 'lps'),
	(573439, 131, '2014-03-01 01:06:26.000000', 'consum', 0.0218, 'lps'),
	(573440, 131, '2014-03-01 01:06:27.000000', 'consum', 0.0222, 'lps'),
	(573441, 131, '2014-03-01 01:06:28.000000', 'consum', 0.0213, 'lps'),
	(573442, 131, '2014-03-01 01:06:29.000000', 'consum', 0.0225, 'lps'),
	(573443, 131, '2014-03-01 01:06:30.000000', 'consum', 0.0221, 'lps'),
	(573444, 131, '2014-03-01 01:06:31.000000', 'consum', 0.0223, 'lps'),
	(573445, 131, '2014-03-01 01:06:32.000000', 'consum', 0.0222, 'lps'),
	(573446, 131, '2014-03-01 01:06:33.000000', 'consum', 0.0214, 'lps'),
	(573447, 131, '2014-03-01 01:06:34.000000', 'consum', 0.0213, 'lps'),
	(573448, 131, '2014-03-01 01:06:35.000000', 'consum', 0.0214, 'lps'),
	(573449, 131, '2014-03-01 01:06:36.000000', 'consum', 0.0219, 'lps'),
	(573450, 131, '2014-03-01 01:06:37.000000', 'consum', 0.0227, 'lps'),
	(573451, 131, '2014-03-01 01:06:38.000000', 'consum', 0.0216, 'lps'),
	(573452, 131, '2014-03-01 01:06:39.000000', 'consum', 0.0223, 'lps'),
	(573453, 131, '2014-03-01 01:06:40.000000', 'consum', 0.0223, 'lps'),
	(573454, 131, '2014-03-01 01:06:41.000000', 'consum', 0.0219, 'lps'),
	(573455, 131, '2014-03-01 01:06:42.000000', 'consum', 0.0217, 'lps'),
	(573456, 131, '2014-03-01 01:06:43.000000', 'consum', 0.0218, 'lps'),
	(573457, 131, '2014-03-01 01:06:44.000000', 'consum', 0.0212, 'lps'),
	(573458, 131, '2014-03-01 01:06:45.000000', 'consum', 0.0216, 'lps'),
	(573459, 131, '2014-03-01 01:06:46.000000', 'consum', 0.0214, 'lps'),
	(573460, 131, '2014-03-01 01:06:47.000000', 'consum', 0.0212, 'lps'),
	(573461, 131, '2014-03-01 01:06:48.000000', 'consum', 0.0227, 'lps'),
	(573462, 131, '2014-03-01 01:06:49.000000', 'consum', 0.0220, 'lps'),
	(573463, 131, '2014-03-01 01:06:50.000000', 'consum', 0.0224, 'lps'),
	(573464, 131, '2014-03-01 01:06:51.000000', 'consum', 0.0215, 'lps'),
	(573465, 131, '2014-03-01 01:06:52.000000', 'consum', 0.0213, 'lps'),
	(573466, 131, '2014-03-01 01:06:53.000000', 'consum', 0.0226, 'lps'),
	(573467, 131, '2014-03-01 01:06:54.000000', 'consum', 0.0212, 'lps'),
	(573468, 131, '2014-03-01 01:06:55.000000', 'consum', 0.0224, 'lps'),
	(573469, 131, '2014-03-01 01:06:56.000000', 'consum', 0.0221, 'lps'),
	(573470, 131, '2014-03-01 01:06:57.000000', 'consum', 0.0225, 'lps'),
	(573471, 131, '2014-03-01 01:06:58.000000', 'consum', 0.0218, 'lps'),
	(573472, 131, '2014-03-01 01:06:59.000000', 'consum', 0.0221, 'lps'),
	(573473, 131, '2014-03-01 01:07:00.000000', 'consum', 0.0224, 'lps'),
	(573474, 131, '2014-03-01 01:07:01.000000', 'consum', 0.0212, 'lps'),
	(573475, 131, '2014-03-01 01:07:02.000000', 'consum', 0.0214, 'lps'),
	(573476, 131, '2014-03-01 01:07:03.000000', 'consum', 0.0223, 'lps'),
	(573477, 131, '2014-03-01 01:07:04.000000', 'consum', 0.0227, 'lps'),
	(573478, 131, '2014-03-01 01:07:05.000000', 'consum', 0.0222, 'lps'),
	(573479, 131, '2014-03-01 01:07:06.000000', 'consum', 0.0219, 'lps'),
	(573480, 131, '2014-03-01 01:07:07.000000', 'consum', 0.0220, 'lps'),
	(573481, 131, '2014-03-01 01:07:08.000000', 'consum', 0.0215, 'lps'),
	(573482, 131, '2014-03-01 01:07:09.000000', 'consum', 0.0224, 'lps'),
	(573483, 131, '2014-03-01 01:07:10.000000', 'consum', 0.0212, 'lps'),
	(573484, 131, '2014-03-01 01:07:11.000000', 'consum', 0.0215, 'lps'),
	(573485, 131, '2014-03-01 01:07:12.000000', 'consum', 0.0210, 'lps'),
	(573486, 131, '2014-03-01 01:07:13.000000', 'consum', 0.0214, 'lps'),
	(573487, 131, '2014-03-01 01:07:14.000000', 'consum', 0.0212, 'lps'),
	(573488, 131, '2014-03-01 01:07:15.000000', 'consum', 0.0211, 'lps'),
	(573489, 131, '2014-03-01 01:07:16.000000', 'consum', 0.0226, 'lps'),
	(573490, 131, '2014-03-01 01:07:17.000000', 'consum', 0.0215, 'lps'),
	(573491, 131, '2014-03-01 01:07:18.000000', 'consum', 0.0226, 'lps'),
	(573492, 131, '2014-03-01 01:07:19.000000', 'consum', 0.0219, 'lps'),
	(573493, 131, '2014-03-01 01:07:20.000000', 'consum', 0.0227, 'lps'),
	(573494, 131, '2014-03-01 01:07:21.000000', 'consum', 0.0216, 'lps'),
	(573495, 131, '2014-03-01 01:07:22.000000', 'consum', 0.0224, 'lps'),
	(573496, 131, '2014-03-01 01:07:23.000000', 'consum', 0.0226, 'lps'),
	(573497, 131, '2014-03-01 01:07:24.000000', 'consum', 0.0212, 'lps'),
	(573498, 131, '2014-03-01 01:07:25.000000', 'consum', 0.0210, 'lps'),
	(573499, 131, '2014-03-01 01:07:26.000000', 'consum', 0.0222, 'lps'),
	(573500, 131, '2014-03-01 01:07:27.000000', 'consum', 0.0216, 'lps'),
	(573501, 131, '2014-03-01 01:07:28.000000', 'consum', 0.0224, 'lps'),
	(573502, 131, '2014-03-01 01:07:29.000000', 'consum', 0.0210, 'lps'),
	(573503, 131, '2014-03-01 01:07:30.000000', 'consum', 0.0219, 'lps'),
	(573504, 131, '2014-03-01 01:07:31.000000', 'consum', 0.0221, 'lps'),
	(573505, 131, '2014-03-01 01:07:32.000000', 'consum', 0.0222, 'lps'),
	(573506, 131, '2014-03-01 01:07:33.000000', 'consum', 0.0219, 'lps'),
	(573507, 131, '2014-03-01 01:07:34.000000', 'consum', 0.0219, 'lps'),
	(573508, 131, '2014-03-01 01:07:35.000000', 'consum', 0.0211, 'lps'),
	(573509, 131, '2014-03-01 01:07:36.000000', 'consum', 0.0224, 'lps'),
	(573510, 131, '2014-03-01 01:07:37.000000', 'consum', 0.0223, 'lps'),
	(573511, 131, '2014-03-01 01:07:38.000000', 'consum', 0.0216, 'lps'),
	(573512, 131, '2014-03-01 01:07:39.000000', 'consum', 0.0219, 'lps'),
	(573513, 131, '2014-03-01 01:07:40.000000', 'consum', 0.0218, 'lps'),
	(573514, 131, '2014-03-01 01:07:41.000000', 'consum', 0.0224, 'lps'),
	(573515, 131, '2014-03-01 01:07:42.000000', 'consum', 0.0223, 'lps'),
	(573516, 131, '2014-03-01 01:07:43.000000', 'consum', 0.0215, 'lps'),
	(573517, 131, '2014-03-01 01:07:44.000000', 'consum', 0.0213, 'lps'),
	(573518, 131, '2014-03-01 01:07:45.000000', 'consum', 0.0213, 'lps'),
	(573519, 131, '2014-03-01 01:07:46.000000', 'consum', 0.0215, 'lps'),
	(573520, 131, '2014-03-01 01:07:47.000000', 'consum', 0.0226, 'lps'),
	(573521, 131, '2014-03-01 01:07:48.000000', 'consum', 0.0224, 'lps'),
	(573522, 131, '2014-03-01 01:07:49.000000', 'consum', 0.0212, 'lps'),
	(573523, 131, '2014-03-01 01:07:50.000000', 'consum', 0.0214, 'lps'),
	(573524, 131, '2014-03-01 01:07:51.000000', 'consum', 0.0225, 'lps'),
	(573525, 131, '2014-03-01 01:07:52.000000', 'consum', 0.0221, 'lps'),
	(573526, 131, '2014-03-01 01:07:53.000000', 'consum', 0.0221, 'lps'),
	(573527, 131, '2014-03-01 01:07:54.000000', 'consum', 0.0215, 'lps'),
	(573528, 131, '2014-03-01 01:07:55.000000', 'consum', 0.0218, 'lps'),
	(573529, 131, '2014-03-01 01:07:56.000000', 'consum', 0.0219, 'lps'),
	(573530, 131, '2014-03-01 01:07:57.000000', 'consum', 0.0214, 'lps'),
	(573531, 131, '2014-03-01 01:07:58.000000', 'consum', 0.0221, 'lps'),
	(573532, 131, '2014-03-01 01:07:59.000000', 'consum', 0.0219, 'lps'),
	(573533, 131, '2014-03-01 01:08:00.000000', 'consum', 0.0221, 'lps'),
	(573534, 131, '2014-03-01 01:08:01.000000', 'consum', 0.0222, 'lps'),
	(573535, 131, '2014-03-01 01:08:02.000000', 'consum', 0.0219, 'lps'),
	(573536, 131, '2014-03-01 01:08:03.000000', 'consum', 0.0219, 'lps'),
	(573537, 131, '2014-03-01 01:08:04.000000', 'consum', 0.0210, 'lps'),
	(573538, 131, '2014-03-01 01:08:05.000000', 'consum', 0.0218, 'lps'),
	(573539, 131, '2014-03-01 01:08:06.000000', 'consum', 0.0215, 'lps'),
	(573540, 131, '2014-03-01 01:08:07.000000', 'consum', 0.0214, 'lps'),
	(573541, 131, '2014-03-01 01:08:08.000000', 'consum', 0.0215, 'lps'),
	(573542, 131, '2014-03-01 01:08:09.000000', 'consum', 0.0223, 'lps'),
	(573543, 131, '2014-03-01 01:08:10.000000', 'consum', 0.0223, 'lps'),
	(573544, 131, '2014-03-01 01:08:11.000000', 'consum', 0.0220, 'lps'),
	(573545, 131, '2014-03-01 01:08:12.000000', 'consum', 0.0220, 'lps'),
	(573546, 131, '2014-03-01 01:08:13.000000', 'consum', 0.0214, 'lps'),
	(573547, 131, '2014-03-01 01:08:14.000000', 'consum', 0.0219, 'lps'),
	(573548, 131, '2014-03-01 01:08:15.000000', 'consum', 0.0227, 'lps'),
	(573549, 131, '2014-03-01 01:08:16.000000', 'consum', 0.0211, 'lps'),
	(573550, 131, '2014-03-01 01:08:17.000000', 'consum', 0.0220, 'lps'),
	(573551, 131, '2014-03-01 01:08:18.000000', 'consum', 0.0220, 'lps'),
	(573552, 131, '2014-03-01 01:08:19.000000', 'consum', 0.0215, 'lps'),
	(573553, 131, '2014-03-01 01:08:20.000000', 'consum', 0.0222, 'lps'),
	(573554, 131, '2014-03-01 01:08:21.000000', 'consum', 0.0219, 'lps'),
	(573555, 131, '2014-03-01 01:08:22.000000', 'consum', 0.0219, 'lps'),
	(573556, 131, '2014-03-01 01:08:23.000000', 'consum', 0.0213, 'lps'),
	(573557, 131, '2014-03-01 01:08:24.000000', 'consum', 0.0216, 'lps'),
	(573558, 131, '2014-03-01 01:08:25.000000', 'consum', 0.0215, 'lps'),
	(573559, 131, '2014-03-01 01:08:26.000000', 'consum', 0.0215, 'lps'),
	(573560, 131, '2014-03-01 01:08:27.000000', 'consum', 0.0223, 'lps'),
	(573561, 131, '2014-03-01 01:08:28.000000', 'consum', 0.0221, 'lps'),
	(573562, 131, '2014-03-01 01:08:29.000000', 'consum', 0.0212, 'lps'),
	(573563, 131, '2014-03-01 01:08:30.000000', 'consum', 0.0222, 'lps'),
	(573564, 131, '2014-03-01 01:08:31.000000', 'consum', 0.0210, 'lps'),
	(573565, 131, '2014-03-01 01:08:32.000000', 'consum', 0.0212, 'lps'),
	(573566, 131, '2014-03-01 01:08:33.000000', 'consum', 0.0218, 'lps'),
	(573567, 131, '2014-03-01 01:08:34.000000', 'consum', 0.0212, 'lps'),
	(573568, 131, '2014-03-01 01:08:35.000000', 'consum', 0.0211, 'lps'),
	(573569, 131, '2014-03-01 01:08:36.000000', 'consum', 0.0210, 'lps'),
	(573570, 131, '2014-03-01 01:08:37.000000', 'consum', 0.0226, 'lps'),
	(573571, 131, '2014-03-01 01:08:38.000000', 'consum', 0.0219, 'lps'),
	(573572, 131, '2014-03-01 01:08:39.000000', 'consum', 0.0226, 'lps'),
	(573573, 131, '2014-03-01 01:08:40.000000', 'consum', 0.0227, 'lps'),
	(573574, 131, '2014-03-01 01:08:41.000000', 'consum', 0.0212, 'lps'),
	(573575, 131, '2014-03-01 01:08:42.000000', 'consum', 0.0222, 'lps'),
	(573576, 131, '2014-03-01 01:08:43.000000', 'consum', 0.0212, 'lps'),
	(573577, 131, '2014-03-01 01:08:44.000000', 'consum', 0.0221, 'lps'),
	(573578, 131, '2014-03-01 01:08:45.000000', 'consum', 0.0223, 'lps'),
	(573579, 131, '2014-03-01 01:08:46.000000', 'consum', 0.0224, 'lps'),
	(573580, 131, '2014-03-01 01:08:47.000000', 'consum', 0.0225, 'lps'),
	(573581, 131, '2014-03-01 01:08:48.000000', 'consum', 0.0225, 'lps'),
	(573582, 131, '2014-03-01 01:08:49.000000', 'consum', 0.0221, 'lps'),
	(573583, 131, '2014-03-01 01:08:50.000000', 'consum', 0.0220, 'lps'),
	(573584, 131, '2014-03-01 01:08:51.000000', 'consum', 0.0211, 'lps'),
	(573585, 131, '2014-03-01 01:08:52.000000', 'consum', 0.0221, 'lps'),
	(573586, 131, '2014-03-01 01:08:53.000000', 'consum', 0.0225, 'lps'),
	(573587, 131, '2014-03-01 01:08:54.000000', 'consum', 0.0219, 'lps'),
	(573588, 131, '2014-03-01 01:08:55.000000', 'consum', 0.0227, 'lps'),
	(573589, 131, '2014-03-01 01:08:56.000000', 'consum', 0.0216, 'lps'),
	(573590, 131, '2014-03-01 01:08:57.000000', 'consum', 0.0223, 'lps'),
	(573591, 131, '2014-03-01 01:08:58.000000', 'consum', 0.0222, 'lps'),
	(573592, 131, '2014-03-01 01:08:59.000000', 'consum', 0.0213, 'lps'),
	(573593, 131, '2014-03-01 01:09:00.000000', 'consum', 0.0210, 'lps'),
	(573594, 131, '2014-03-01 01:09:01.000000', 'consum', 0.0216, 'lps'),
	(573595, 131, '2014-03-01 01:09:02.000000', 'consum', 0.0226, 'lps'),
	(573596, 131, '2014-03-01 01:09:03.000000', 'consum', 0.0216, 'lps'),
	(573597, 131, '2014-03-01 01:09:04.000000', 'consum', 0.0213, 'lps'),
	(573598, 131, '2014-03-01 01:09:05.000000', 'consum', 0.0223, 'lps'),
	(573599, 131, '2014-03-01 01:09:06.000000', 'consum', 0.0215, 'lps'),
	(573600, 131, '2014-03-01 01:09:07.000000', 'consum', 0.0213, 'lps'),
	(573601, 131, '2014-03-01 01:09:08.000000', 'consum', 0.0211, 'lps'),
	(573602, 131, '2014-03-01 01:09:09.000000', 'consum', 0.0224, 'lps'),
	(573603, 131, '2014-03-01 01:09:10.000000', 'consum', 0.0224, 'lps'),
	(573604, 131, '2014-03-01 01:09:11.000000', 'consum', 0.0220, 'lps'),
	(573605, 131, '2014-03-01 01:09:12.000000', 'consum', 0.0217, 'lps'),
	(573606, 131, '2014-03-01 01:09:13.000000', 'consum', 0.0216, 'lps'),
	(573607, 131, '2014-03-01 01:09:14.000000', 'consum', 0.0219, 'lps'),
	(573608, 131, '2014-03-01 01:09:15.000000', 'consum', 0.0219, 'lps'),
	(573609, 131, '2014-03-01 01:09:16.000000', 'consum', 0.0213, 'lps'),
	(573610, 131, '2014-03-01 01:09:17.000000', 'consum', 0.0214, 'lps'),
	(573611, 131, '2014-03-01 01:09:18.000000', 'consum', 0.0221, 'lps'),
	(573612, 131, '2014-03-01 01:09:19.000000', 'consum', 0.0221, 'lps'),
	(573613, 131, '2014-03-01 01:09:20.000000', 'consum', 0.0211, 'lps'),
	(573614, 131, '2014-03-01 01:09:21.000000', 'consum', 0.0218, 'lps'),
	(573615, 131, '2014-03-01 01:09:22.000000', 'consum', 0.0213, 'lps'),
	(573616, 131, '2014-03-01 01:09:23.000000', 'consum', 0.0220, 'lps'),
	(573617, 131, '2014-03-01 01:09:24.000000', 'consum', 0.0214, 'lps'),
	(573618, 131, '2014-03-01 01:09:25.000000', 'consum', 0.0220, 'lps'),
	(573619, 131, '2014-03-01 01:09:26.000000', 'consum', 0.0210, 'lps'),
	(573620, 131, '2014-03-01 01:09:27.000000', 'consum', 0.0219, 'lps'),
	(573621, 131, '2014-03-01 01:09:28.000000', 'consum', 0.0217, 'lps'),
	(573622, 131, '2014-03-01 01:09:29.000000', 'consum', 0.0221, 'lps'),
	(573623, 131, '2014-03-01 01:09:30.000000', 'consum', 0.0210, 'lps'),
	(573624, 131, '2014-03-01 01:09:31.000000', 'consum', 0.0210, 'lps'),
	(573625, 131, '2014-03-01 01:09:32.000000', 'consum', 0.0214, 'lps'),
	(573626, 131, '2014-03-01 01:09:33.000000', 'consum', 0.0227, 'lps'),
	(573627, 131, '2014-03-01 01:09:34.000000', 'consum', 0.0214, 'lps'),
	(573628, 131, '2014-03-01 01:09:35.000000', 'consum', 0.0215, 'lps'),
	(573629, 131, '2014-03-01 01:09:36.000000', 'consum', 0.0222, 'lps'),
	(573630, 131, '2014-03-01 01:09:37.000000', 'consum', 0.0218, 'lps'),
	(573631, 131, '2014-03-01 01:09:38.000000', 'consum', 0.0218, 'lps'),
	(573632, 131, '2014-03-01 01:09:39.000000', 'consum', 0.0223, 'lps'),
	(573633, 131, '2014-03-01 01:09:40.000000', 'consum', 0.0219, 'lps'),
	(573634, 131, '2014-03-01 01:09:41.000000', 'consum', 0.0214, 'lps'),
	(573635, 131, '2014-03-01 01:09:42.000000', 'consum', 0.0221, 'lps'),
	(573636, 131, '2014-03-01 01:09:43.000000', 'consum', 0.0217, 'lps'),
	(573637, 131, '2014-03-01 01:09:44.000000', 'consum', 0.0215, 'lps'),
	(573638, 131, '2014-03-01 01:09:45.000000', 'consum', 0.0214, 'lps'),
	(573639, 131, '2014-03-01 01:09:46.000000', 'consum', 0.0213, 'lps'),
	(573640, 131, '2014-03-01 01:09:47.000000', 'consum', 0.0217, 'lps'),
	(573641, 131, '2014-03-01 01:09:48.000000', 'consum', 0.0215, 'lps'),
	(573642, 131, '2014-03-01 01:09:49.000000', 'consum', 0.0216, 'lps'),
	(573643, 131, '2014-03-01 01:09:50.000000', 'consum', 0.0225, 'lps'),
	(573644, 131, '2014-03-01 01:09:51.000000', 'consum', 0.0212, 'lps'),
	(573645, 131, '2014-03-01 01:09:52.000000', 'consum', 0.0212, 'lps'),
	(573646, 131, '2014-03-01 01:09:53.000000', 'consum', 0.0216, 'lps'),
	(573647, 131, '2014-03-01 01:09:54.000000', 'consum', 0.0215, 'lps'),
	(573648, 131, '2014-03-01 01:09:55.000000', 'consum', 0.0219, 'lps'),
	(573649, 131, '2014-03-01 01:09:56.000000', 'consum', 0.0222, 'lps'),
	(573650, 131, '2014-03-01 01:09:57.000000', 'consum', 0.0225, 'lps'),
	(573651, 131, '2014-03-01 01:09:58.000000', 'consum', 0.0213, 'lps'),
	(573652, 131, '2014-03-01 01:09:59.000000', 'consum', 0.0218, 'lps'),
	(573653, 131, '2014-03-01 01:10:00.000000', 'consum', 0.0222, 'lps'),
	(573654, 131, '2014-03-01 01:10:01.000000', 'consum', 0.0213, 'lps'),
	(573655, 131, '2014-03-01 01:10:02.000000', 'consum', 0.0224, 'lps'),
	(573656, 131, '2014-03-01 01:10:03.000000', 'consum', 0.0218, 'lps'),
	(573657, 131, '2014-03-01 01:10:04.000000', 'consum', 0.0210, 'lps'),
	(573658, 131, '2014-03-01 01:10:05.000000', 'consum', 0.0221, 'lps'),
	(573659, 131, '2014-03-01 01:10:06.000000', 'consum', 0.0212, 'lps'),
	(573660, 131, '2014-03-01 01:10:07.000000', 'consum', 0.0222, 'lps'),
	(573661, 131, '2014-03-01 01:10:08.000000', 'consum', 0.0212, 'lps'),
	(573662, 131, '2014-03-01 01:10:09.000000', 'consum', 0.0219, 'lps'),
	(573663, 131, '2014-03-01 01:10:10.000000', 'consum', 0.0215, 'lps'),
	(573664, 131, '2014-03-01 01:10:11.000000', 'consum', 0.0210, 'lps'),
	(573665, 131, '2014-03-01 01:10:12.000000', 'consum', 0.0210, 'lps'),
	(573666, 131, '2014-03-01 01:10:13.000000', 'consum', 0.0212, 'lps'),
	(573667, 131, '2014-03-01 01:10:14.000000', 'consum', 0.0221, 'lps'),
	(573668, 131, '2014-03-01 01:10:15.000000', 'consum', 0.0225, 'lps'),
	(573669, 131, '2014-03-01 01:10:16.000000', 'consum', 0.0216, 'lps'),
	(573670, 131, '2014-03-01 01:10:17.000000', 'consum', 0.0211, 'lps'),
	(573671, 131, '2014-03-01 01:10:18.000000', 'consum', 0.0219, 'lps'),
	(573672, 131, '2014-03-01 01:10:19.000000', 'consum', 0.0214, 'lps'),
	(573673, 131, '2014-03-01 01:10:20.000000', 'consum', 0.0221, 'lps'),
	(573674, 131, '2014-03-01 01:10:21.000000', 'consum', 0.0218, 'lps'),
	(573675, 131, '2014-03-01 01:10:22.000000', 'consum', 0.0218, 'lps'),
	(573676, 131, '2014-03-01 01:10:23.000000', 'consum', 0.0226, 'lps'),
	(573677, 131, '2014-03-01 01:10:24.000000', 'consum', 0.0211, 'lps'),
	(573678, 131, '2014-03-01 01:10:25.000000', 'consum', 0.0223, 'lps'),
	(573679, 131, '2014-03-01 01:10:26.000000', 'consum', 0.0220, 'lps'),
	(573680, 131, '2014-03-01 01:10:27.000000', 'consum', 0.0220, 'lps'),
	(573681, 131, '2014-03-01 01:10:28.000000', 'consum', 0.0213, 'lps'),
	(573682, 131, '2014-03-01 01:10:29.000000', 'consum', 0.0213, 'lps'),
	(573683, 131, '2014-03-01 01:10:30.000000', 'consum', 0.0216, 'lps'),
	(573684, 131, '2014-03-01 01:10:31.000000', 'consum', 0.0213, 'lps'),
	(573685, 131, '2014-03-01 01:10:32.000000', 'consum', 0.0226, 'lps'),
	(573686, 131, '2014-03-01 01:10:33.000000', 'consum', 0.0210, 'lps'),
	(573687, 131, '2014-03-01 01:10:34.000000', 'consum', 0.0215, 'lps'),
	(573688, 131, '2014-03-01 01:10:35.000000', 'consum', 0.0219, 'lps'),
	(573689, 131, '2014-03-01 01:10:36.000000', 'consum', 0.0221, 'lps'),
	(573690, 131, '2014-03-01 01:10:37.000000', 'consum', 0.0223, 'lps'),
	(573691, 131, '2014-03-01 01:10:38.000000', 'consum', 0.0224, 'lps'),
	(573692, 131, '2014-03-01 01:10:39.000000', 'consum', 0.0221, 'lps'),
	(573693, 131, '2014-03-01 01:10:40.000000', 'consum', 0.0226, 'lps'),
	(573694, 131, '2014-03-01 01:10:41.000000', 'consum', 0.0221, 'lps'),
	(573695, 131, '2014-03-01 01:10:42.000000', 'consum', 0.0216, 'lps'),
	(573696, 131, '2014-03-01 01:10:43.000000', 'consum', 0.0210, 'lps'),
	(573697, 131, '2014-03-01 01:10:44.000000', 'consum', 0.0227, 'lps'),
	(573698, 131, '2014-03-01 01:10:45.000000', 'consum', 0.0225, 'lps'),
	(573699, 131, '2014-03-01 01:10:46.000000', 'consum', 0.0216, 'lps'),
	(573700, 131, '2014-03-01 01:10:47.000000', 'consum', 0.0212, 'lps'),
	(573701, 131, '2014-03-01 01:10:48.000000', 'consum', 0.0220, 'lps'),
	(573702, 131, '2014-03-01 01:10:49.000000', 'consum', 0.0218, 'lps'),
	(573703, 131, '2014-03-01 01:10:50.000000', 'consum', 0.0223, 'lps'),
	(573704, 131, '2014-03-01 01:10:51.000000', 'consum', 0.0213, 'lps'),
	(573705, 131, '2014-03-01 01:10:52.000000', 'consum', 0.0222, 'lps'),
	(573706, 131, '2014-03-01 01:10:53.000000', 'consum', 0.0227, 'lps'),
	(573707, 131, '2014-03-01 01:10:54.000000', 'consum', 0.0223, 'lps'),
	(573708, 131, '2014-03-01 01:10:55.000000', 'consum', 0.0225, 'lps'),
	(573709, 131, '2014-03-01 01:10:56.000000', 'consum', 0.0227, 'lps'),
	(573710, 131, '2014-03-01 01:10:57.000000', 'consum', 0.0213, 'lps'),
	(573711, 131, '2014-03-01 01:10:58.000000', 'consum', 0.0214, 'lps'),
	(573712, 131, '2014-03-01 01:10:59.000000', 'consum', 0.0220, 'lps'),
	(573713, 131, '2014-03-01 01:11:00.000000', 'consum', 0.0211, 'lps'),
	(573714, 131, '2014-03-01 01:11:01.000000', 'consum', 0.0222, 'lps'),
	(573715, 131, '2014-03-01 01:11:02.000000', 'consum', 0.0213, 'lps'),
	(573716, 131, '2014-03-01 01:11:03.000000', 'consum', 0.0227, 'lps'),
	(573717, 131, '2014-03-01 01:11:04.000000', 'consum', 0.0215, 'lps'),
	(573718, 131, '2014-03-01 01:11:05.000000', 'consum', 0.0219, 'lps'),
	(573719, 131, '2014-03-01 01:11:06.000000', 'consum', 0.0224, 'lps'),
	(573720, 131, '2014-03-01 01:11:07.000000', 'consum', 0.0215, 'lps'),
	(573721, 131, '2014-03-01 01:11:08.000000', 'consum', 0.0211, 'lps'),
	(573722, 131, '2014-03-01 01:11:09.000000', 'consum', 0.0221, 'lps'),
	(573723, 131, '2014-03-01 01:11:10.000000', 'consum', 0.0210, 'lps'),
	(573724, 131, '2014-03-01 01:11:11.000000', 'consum', 0.0210, 'lps'),
	(573725, 131, '2014-03-01 01:11:12.000000', 'consum', 0.0212, 'lps'),
	(573726, 131, '2014-03-01 01:11:13.000000', 'consum', 0.0220, 'lps'),
	(573727, 131, '2014-03-01 01:11:14.000000', 'consum', 0.0220, 'lps'),
	(573728, 131, '2014-03-01 01:11:15.000000', 'consum', 0.0210, 'lps'),
	(573729, 131, '2014-03-01 01:11:16.000000', 'consum', 0.0216, 'lps'),
	(573730, 131, '2014-03-01 01:11:17.000000', 'consum', 0.0225, 'lps'),
	(573731, 131, '2014-03-01 01:11:18.000000', 'consum', 0.0214, 'lps'),
	(573732, 131, '2014-03-01 01:11:19.000000', 'consum', 0.0218, 'lps'),
	(573733, 131, '2014-03-01 01:11:20.000000', 'consum', 0.0224, 'lps'),
	(573734, 131, '2014-03-01 01:11:21.000000', 'consum', 0.0221, 'lps'),
	(573735, 131, '2014-03-01 01:11:22.000000', 'consum', 0.0220, 'lps'),
	(573736, 131, '2014-03-01 01:11:23.000000', 'consum', 0.0212, 'lps'),
	(573737, 131, '2014-03-01 01:11:24.000000', 'consum', 0.0226, 'lps'),
	(573738, 131, '2014-03-01 01:11:25.000000', 'consum', 0.0213, 'lps'),
	(573739, 131, '2014-03-01 01:11:26.000000', 'consum', 0.0212, 'lps'),
	(573740, 131, '2014-03-01 01:11:27.000000', 'consum', 0.0210, 'lps'),
	(573741, 131, '2014-03-01 01:11:28.000000', 'consum', 0.0225, 'lps'),
	(573742, 131, '2014-03-01 01:11:29.000000', 'consum', 0.0215, 'lps'),
	(573743, 131, '2014-03-01 01:11:30.000000', 'consum', 0.0224, 'lps'),
	(573744, 131, '2014-03-01 01:11:31.000000', 'consum', 0.0211, 'lps'),
	(573745, 131, '2014-03-01 01:11:32.000000', 'consum', 0.0226, 'lps'),
	(573746, 131, '2014-03-01 01:11:33.000000', 'consum', 0.0218, 'lps'),
	(573747, 131, '2014-03-01 01:11:34.000000', 'consum', 0.0222, 'lps'),
	(573748, 131, '2014-03-01 01:11:35.000000', 'consum', 0.0226, 'lps'),
	(573749, 131, '2014-03-01 01:11:36.000000', 'consum', 0.0221, 'lps'),
	(573750, 131, '2014-03-01 01:11:37.000000', 'consum', 0.0214, 'lps'),
	(573751, 131, '2014-03-01 01:11:38.000000', 'consum', 0.0219, 'lps'),
	(573752, 131, '2014-03-01 01:11:39.000000', 'consum', 0.0224, 'lps'),
	(573753, 131, '2014-03-01 01:11:40.000000', 'consum', 0.0216, 'lps'),
	(573754, 131, '2014-03-01 01:11:41.000000', 'consum', 0.0217, 'lps'),
	(573755, 131, '2014-03-01 01:11:42.000000', 'consum', 0.0210, 'lps'),
	(573756, 131, '2014-03-01 01:11:43.000000', 'consum', 0.0224, 'lps'),
	(573757, 131, '2014-03-01 01:11:44.000000', 'consum', 0.0212, 'lps'),
	(573758, 131, '2014-03-01 01:11:45.000000', 'consum', 0.0211, 'lps'),
	(573759, 131, '2014-03-01 01:11:46.000000', 'consum', 0.0211, 'lps'),
	(573760, 131, '2014-03-01 01:11:47.000000', 'consum', 0.0214, 'lps'),
	(573761, 131, '2014-03-01 01:11:48.000000', 'consum', 0.0225, 'lps'),
	(573762, 131, '2014-03-01 01:11:49.000000', 'consum', 0.0222, 'lps'),
	(573763, 131, '2014-03-01 01:11:50.000000', 'consum', 0.0225, 'lps'),
	(573764, 131, '2014-03-01 01:11:51.000000', 'consum', 0.0215, 'lps'),
	(573765, 131, '2014-03-01 01:11:52.000000', 'consum', 0.0225, 'lps'),
	(573766, 131, '2014-03-01 01:11:53.000000', 'consum', 0.0215, 'lps'),
	(573767, 131, '2014-03-01 01:11:54.000000', 'consum', 0.0227, 'lps'),
	(573768, 131, '2014-03-01 01:11:55.000000', 'consum', 0.0211, 'lps'),
	(573769, 131, '2014-03-01 01:11:56.000000', 'consum', 0.0217, 'lps'),
	(573770, 131, '2014-03-01 01:11:57.000000', 'consum', 0.0225, 'lps'),
	(573771, 131, '2014-03-01 01:11:58.000000', 'consum', 0.0211, 'lps'),
	(573772, 131, '2014-03-01 01:11:59.000000', 'consum', 0.0223, 'lps'),
	(573773, 131, '2014-03-01 01:12:00.000000', 'consum', 0.0218, 'lps'),
	(573774, 131, '2014-03-01 01:12:01.000000', 'consum', 0.0213, 'lps'),
	(573775, 131, '2014-03-01 01:12:02.000000', 'consum', 0.0217, 'lps'),
	(573776, 131, '2014-03-01 01:12:03.000000', 'consum', 0.0220, 'lps'),
	(573777, 131, '2014-03-01 01:12:04.000000', 'consum', 0.0221, 'lps'),
	(573778, 131, '2014-03-01 01:12:05.000000', 'consum', 0.0220, 'lps'),
	(573779, 131, '2014-03-01 01:12:06.000000', 'consum', 0.0225, 'lps'),
	(573780, 131, '2014-03-01 01:12:07.000000', 'consum', 0.0222, 'lps'),
	(573781, 131, '2014-03-01 01:12:08.000000', 'consum', 0.0222, 'lps'),
	(573782, 131, '2014-03-01 01:12:09.000000', 'consum', 0.0220, 'lps'),
	(573783, 131, '2014-03-01 01:12:10.000000', 'consum', 0.0223, 'lps'),
	(573784, 131, '2014-03-01 01:12:11.000000', 'consum', 0.0211, 'lps'),
	(573785, 131, '2014-03-01 01:12:12.000000', 'consum', 0.0212, 'lps'),
	(573786, 131, '2014-03-01 01:12:13.000000', 'consum', 0.0219, 'lps'),
	(573787, 131, '2014-03-01 01:12:14.000000', 'consum', 0.0213, 'lps'),
	(573788, 131, '2014-03-01 01:12:15.000000', 'consum', 0.0215, 'lps'),
	(573789, 131, '2014-03-01 01:12:16.000000', 'consum', 0.0227, 'lps'),
	(573790, 131, '2014-03-01 01:12:17.000000', 'consum', 0.0210, 'lps'),
	(573791, 131, '2014-03-01 01:12:18.000000', 'consum', 0.0211, 'lps'),
	(573792, 131, '2014-03-01 01:12:19.000000', 'consum', 0.0216, 'lps'),
	(573793, 131, '2014-03-01 01:12:20.000000', 'consum', 0.0220, 'lps'),
	(573794, 131, '2014-03-01 01:12:21.000000', 'consum', 0.0224, 'lps'),
	(573795, 131, '2014-03-01 01:12:22.000000', 'consum', 0.0216, 'lps'),
	(573796, 131, '2014-03-01 01:12:23.000000', 'consum', 0.0215, 'lps'),
	(573797, 131, '2014-03-01 01:12:24.000000', 'consum', 0.0217, 'lps'),
	(573798, 131, '2014-03-01 01:12:25.000000', 'consum', 0.0214, 'lps'),
	(573799, 131, '2014-03-01 01:12:26.000000', 'consum', 0.0227, 'lps'),
	(573800, 131, '2014-03-01 01:12:27.000000', 'consum', 0.0212, 'lps'),
	(573801, 131, '2014-03-01 01:12:28.000000', 'consum', 0.0225, 'lps'),
	(573802, 131, '2014-03-01 01:12:29.000000', 'consum', 0.0225, 'lps'),
	(573803, 131, '2014-03-01 01:12:30.000000', 'consum', 0.0220, 'lps'),
	(573804, 131, '2014-03-01 01:12:31.000000', 'consum', 0.0216, 'lps'),
	(573805, 131, '2014-03-01 01:12:32.000000', 'consum', 0.0212, 'lps'),
	(573806, 131, '2014-03-01 01:12:33.000000', 'consum', 0.0218, 'lps'),
	(573807, 131, '2014-03-01 01:12:34.000000', 'consum', 0.0210, 'lps'),
	(573808, 131, '2014-03-01 01:12:35.000000', 'consum', 0.0222, 'lps'),
	(573809, 131, '2014-03-01 01:12:36.000000', 'consum', 0.0219, 'lps'),
	(573810, 131, '2014-03-01 01:12:37.000000', 'consum', 0.0217, 'lps'),
	(573811, 131, '2014-03-01 01:12:38.000000', 'consum', 0.0217, 'lps'),
	(573812, 131, '2014-03-01 01:12:39.000000', 'consum', 0.0227, 'lps'),
	(573813, 131, '2014-03-01 01:12:40.000000', 'consum', 0.0218, 'lps'),
	(573814, 131, '2014-03-01 01:12:41.000000', 'consum', 0.0219, 'lps'),
	(573815, 131, '2014-03-01 01:12:42.000000', 'consum', 0.0211, 'lps'),
	(573816, 131, '2014-03-01 01:12:43.000000', 'consum', 0.0210, 'lps'),
	(573817, 131, '2014-03-01 01:12:44.000000', 'consum', 0.0222, 'lps'),
	(573818, 131, '2014-03-01 01:12:45.000000', 'consum', 0.0218, 'lps'),
	(573819, 131, '2014-03-01 01:12:46.000000', 'consum', 0.0217, 'lps'),
	(573820, 131, '2014-03-01 01:12:47.000000', 'consum', 0.0218, 'lps'),
	(573821, 131, '2014-03-01 01:12:48.000000', 'consum', 0.0211, 'lps'),
	(573822, 131, '2014-03-01 01:12:49.000000', 'consum', 0.0211, 'lps'),
	(573823, 131, '2014-03-01 01:12:50.000000', 'consum', 0.0214, 'lps'),
	(573824, 131, '2014-03-01 01:12:51.000000', 'consum', 0.0225, 'lps'),
	(573825, 131, '2014-03-01 01:12:52.000000', 'consum', 0.0220, 'lps'),
	(573826, 131, '2014-03-01 01:12:53.000000', 'consum', 0.0215, 'lps'),
	(573827, 131, '2014-03-01 01:12:54.000000', 'consum', 0.0226, 'lps'),
	(573828, 131, '2014-03-01 01:12:55.000000', 'consum', 0.0221, 'lps'),
	(573829, 131, '2014-03-01 01:12:56.000000', 'consum', 0.0216, 'lps'),
	(573830, 131, '2014-03-01 01:12:57.000000', 'consum', 0.0227, 'lps'),
	(573831, 131, '2014-03-01 01:12:58.000000', 'consum', 0.0221, 'lps'),
	(573832, 131, '2014-03-01 01:12:59.000000', 'consum', 0.0217, 'lps'),
	(573833, 131, '2014-03-01 01:13:00.000000', 'consum', 0.0212, 'lps'),
	(573834, 131, '2014-03-01 01:13:01.000000', 'consum', 0.0216, 'lps'),
	(573835, 131, '2014-03-01 01:13:02.000000', 'consum', 0.0219, 'lps'),
	(573836, 131, '2014-03-01 01:13:03.000000', 'consum', 0.0218, 'lps'),
	(573837, 131, '2014-03-01 01:13:04.000000', 'consum', 0.0223, 'lps'),
	(573838, 131, '2014-03-01 01:13:05.000000', 'consum', 0.0215, 'lps'),
	(573839, 131, '2014-03-01 01:13:06.000000', 'consum', 0.0215, 'lps'),
	(573840, 131, '2014-03-01 01:13:07.000000', 'consum', 0.0219, 'lps'),
	(573841, 131, '2014-03-01 01:13:08.000000', 'consum', 0.0225, 'lps'),
	(573842, 131, '2014-03-01 01:13:09.000000', 'consum', 0.0220, 'lps'),
	(573843, 131, '2014-03-01 01:13:10.000000', 'consum', 0.0218, 'lps'),
	(573844, 131, '2014-03-01 01:13:11.000000', 'consum', 0.0220, 'lps'),
	(573845, 131, '2014-03-01 01:13:12.000000', 'consum', 0.0220, 'lps'),
	(573846, 131, '2014-03-01 01:13:13.000000', 'consum', 0.0211, 'lps'),
	(573847, 131, '2014-03-01 01:13:14.000000', 'consum', 0.0221, 'lps'),
	(573848, 131, '2014-03-01 01:13:15.000000', 'consum', 0.0211, 'lps'),
	(573849, 131, '2014-03-01 01:13:16.000000', 'consum', 0.0215, 'lps'),
	(573850, 131, '2014-03-01 01:13:17.000000', 'consum', 0.0217, 'lps'),
	(573851, 131, '2014-03-01 01:13:18.000000', 'consum', 0.0211, 'lps'),
	(573852, 131, '2014-03-01 01:13:19.000000', 'consum', 0.0214, 'lps'),
	(573853, 131, '2014-03-01 01:13:20.000000', 'consum', 0.0210, 'lps'),
	(573854, 131, '2014-03-01 01:13:21.000000', 'consum', 0.0215, 'lps'),
	(573855, 131, '2014-03-01 01:13:22.000000', 'consum', 0.0216, 'lps'),
	(573856, 131, '2014-03-01 01:13:23.000000', 'consum', 0.0210, 'lps'),
	(573857, 131, '2014-03-01 01:13:24.000000', 'consum', 0.0210, 'lps'),
	(573858, 131, '2014-03-01 01:13:25.000000', 'consum', 0.0211, 'lps'),
	(573859, 131, '2014-03-01 01:13:26.000000', 'consum', 0.0215, 'lps'),
	(573860, 131, '2014-03-01 01:13:27.000000', 'consum', 0.0213, 'lps'),
	(573861, 131, '2014-03-01 01:13:28.000000', 'consum', 0.0210, 'lps'),
	(573862, 131, '2014-03-01 01:13:29.000000', 'consum', 0.0223, 'lps'),
	(573863, 131, '2014-03-01 01:13:30.000000', 'consum', 0.0218, 'lps'),
	(573864, 131, '2014-03-01 01:13:31.000000', 'consum', 0.0213, 'lps'),
	(573865, 131, '2014-03-01 01:13:32.000000', 'consum', 0.0220, 'lps'),
	(573866, 131, '2014-03-01 01:13:33.000000', 'consum', 0.0215, 'lps'),
	(573867, 131, '2014-03-01 01:13:34.000000', 'consum', 0.0225, 'lps'),
	(573868, 131, '2014-03-01 01:13:35.000000', 'consum', 0.0216, 'lps'),
	(573869, 131, '2014-03-01 01:13:36.000000', 'consum', 0.0215, 'lps'),
	(573870, 131, '2014-03-01 01:13:37.000000', 'consum', 0.0214, 'lps'),
	(573871, 131, '2014-03-01 01:13:38.000000', 'consum', 0.0218, 'lps'),
	(573872, 131, '2014-03-01 01:13:39.000000', 'consum', 0.0218, 'lps'),
	(573873, 131, '2014-03-01 01:13:40.000000', 'consum', 0.0210, 'lps'),
	(573874, 131, '2014-03-01 01:13:41.000000', 'consum', 0.0223, 'lps'),
	(573875, 131, '2014-03-01 01:13:42.000000', 'consum', 0.0220, 'lps'),
	(573876, 131, '2014-03-01 01:13:43.000000', 'consum', 0.0224, 'lps'),
	(573877, 131, '2014-03-01 01:13:44.000000', 'consum', 0.0215, 'lps'),
	(573878, 131, '2014-03-01 01:13:45.000000', 'consum', 0.0226, 'lps'),
	(573879, 131, '2014-03-01 01:13:46.000000', 'consum', 0.0225, 'lps'),
	(573880, 131, '2014-03-01 01:13:47.000000', 'consum', 0.0216, 'lps'),
	(573881, 131, '2014-03-01 01:13:48.000000', 'consum', 0.0215, 'lps'),
	(573882, 131, '2014-03-01 01:13:49.000000', 'consum', 0.0219, 'lps'),
	(573883, 131, '2014-03-01 01:13:50.000000', 'consum', 0.0223, 'lps'),
	(573884, 131, '2014-03-01 01:13:51.000000', 'consum', 0.0212, 'lps'),
	(573885, 131, '2014-03-01 01:13:52.000000', 'consum', 0.0218, 'lps'),
	(573886, 131, '2014-03-01 01:13:53.000000', 'consum', 0.0226, 'lps'),
	(573887, 131, '2014-03-01 01:13:54.000000', 'consum', 0.0210, 'lps'),
	(573888, 131, '2014-03-01 01:13:55.000000', 'consum', 0.0220, 'lps'),
	(573889, 131, '2014-03-01 01:13:56.000000', 'consum', 0.0224, 'lps'),
	(573890, 131, '2014-03-01 01:13:57.000000', 'consum', 0.0213, 'lps'),
	(573891, 131, '2014-03-01 01:13:58.000000', 'consum', 0.0220, 'lps'),
	(573892, 131, '2014-03-01 01:13:59.000000', 'consum', 0.0217, 'lps'),
	(573893, 131, '2014-03-01 01:14:00.000000', 'consum', 0.0215, 'lps'),
	(573894, 131, '2014-03-01 01:14:01.000000', 'consum', 0.0213, 'lps'),
	(573895, 131, '2014-03-01 01:14:02.000000', 'consum', 0.0227, 'lps'),
	(573896, 131, '2014-03-01 01:14:03.000000', 'consum', 0.0217, 'lps'),
	(573897, 131, '2014-03-01 01:14:04.000000', 'consum', 0.0212, 'lps'),
	(573898, 131, '2014-03-01 01:14:05.000000', 'consum', 0.0218, 'lps'),
	(573899, 131, '2014-03-01 01:14:06.000000', 'consum', 0.0227, 'lps'),
	(573900, 131, '2014-03-01 01:14:07.000000', 'consum', 0.0219, 'lps'),
	(573901, 131, '2014-03-01 01:14:08.000000', 'consum', 0.0220, 'lps'),
	(573902, 131, '2014-03-01 01:14:09.000000', 'consum', 0.0218, 'lps'),
	(573903, 131, '2014-03-01 01:14:10.000000', 'consum', 0.0220, 'lps'),
	(573904, 131, '2014-03-01 01:14:11.000000', 'consum', 0.0218, 'lps'),
	(573905, 131, '2014-03-01 01:14:12.000000', 'consum', 0.0222, 'lps'),
	(573906, 131, '2014-03-01 01:14:13.000000', 'consum', 0.0226, 'lps'),
	(573907, 131, '2014-03-01 01:14:14.000000', 'consum', 0.0218, 'lps'),
	(573908, 131, '2014-03-01 01:14:15.000000', 'consum', 0.0221, 'lps'),
	(573909, 131, '2014-03-01 01:14:16.000000', 'consum', 0.0222, 'lps'),
	(573910, 131, '2014-03-01 01:14:17.000000', 'consum', 0.0222, 'lps'),
	(573911, 131, '2014-03-01 01:14:18.000000', 'consum', 0.0218, 'lps'),
	(573912, 131, '2014-03-01 01:14:19.000000', 'consum', 0.0212, 'lps'),
	(573913, 131, '2014-03-01 01:14:20.000000', 'consum', 0.0214, 'lps'),
	(573914, 131, '2014-03-01 01:14:21.000000', 'consum', 0.0224, 'lps'),
	(573915, 131, '2014-03-01 01:14:22.000000', 'consum', 0.0214, 'lps'),
	(573916, 131, '2014-03-01 01:14:23.000000', 'consum', 0.0226, 'lps'),
	(573917, 131, '2014-03-01 01:14:24.000000', 'consum', 0.0223, 'lps'),
	(573918, 131, '2014-03-01 01:14:25.000000', 'consum', 0.0227, 'lps'),
	(573919, 131, '2014-03-01 01:14:26.000000', 'consum', 0.0222, 'lps'),
	(573920, 131, '2014-03-01 01:14:27.000000', 'consum', 0.0217, 'lps'),
	(573921, 131, '2014-03-01 01:14:28.000000', 'consum', 0.0213, 'lps'),
	(573922, 131, '2014-03-01 01:14:29.000000', 'consum', 0.0220, 'lps'),
	(573923, 131, '2014-03-01 01:14:30.000000', 'consum', 0.0214, 'lps'),
	(573924, 131, '2014-03-01 01:14:31.000000', 'consum', 0.0222, 'lps'),
	(573925, 131, '2014-03-01 01:14:32.000000', 'consum', 0.0219, 'lps'),
	(573926, 131, '2014-03-01 01:14:33.000000', 'consum', 0.0223, 'lps'),
	(573927, 131, '2014-03-01 01:14:34.000000', 'consum', 0.0211, 'lps'),
	(573928, 131, '2014-03-01 01:14:35.000000', 'consum', 0.0213, 'lps'),
	(573929, 131, '2014-03-01 01:14:36.000000', 'consum', 0.0222, 'lps'),
	(573930, 131, '2014-03-01 01:14:37.000000', 'consum', 0.0226, 'lps'),
	(573931, 131, '2014-03-01 01:14:38.000000', 'consum', 0.0217, 'lps'),
	(573932, 131, '2014-03-01 01:14:39.000000', 'consum', 0.0217, 'lps'),
	(573933, 131, '2014-03-01 01:14:40.000000', 'consum', 0.0224, 'lps'),
	(573934, 131, '2014-03-01 01:14:41.000000', 'consum', 0.0225, 'lps'),
	(573935, 131, '2014-03-01 01:14:42.000000', 'consum', 0.0225, 'lps'),
	(573936, 131, '2014-03-01 01:14:43.000000', 'consum', 0.0221, 'lps'),
	(573937, 131, '2014-03-01 01:14:44.000000', 'consum', 0.0220, 'lps'),
	(573938, 131, '2014-03-01 01:14:45.000000', 'consum', 0.0211, 'lps'),
	(573939, 131, '2014-03-01 01:14:46.000000', 'consum', 0.0220, 'lps'),
	(573940, 131, '2014-03-01 01:14:47.000000', 'consum', 0.0223, 'lps'),
	(573941, 131, '2014-03-01 01:14:48.000000', 'consum', 0.0210, 'lps'),
	(573942, 131, '2014-03-01 01:14:49.000000', 'consum', 0.0223, 'lps'),
	(573943, 131, '2014-03-01 01:14:50.000000', 'consum', 0.0224, 'lps'),
	(573944, 131, '2014-03-01 01:14:51.000000', 'consum', 0.0222, 'lps'),
	(573945, 131, '2014-03-01 01:14:52.000000', 'consum', 0.0213, 'lps'),
	(573946, 131, '2014-03-01 01:14:53.000000', 'consum', 0.0223, 'lps'),
	(573947, 131, '2014-03-01 01:14:54.000000', 'consum', 0.0212, 'lps'),
	(573948, 131, '2014-03-01 01:14:55.000000', 'consum', 0.0220, 'lps'),
	(573949, 131, '2014-03-01 01:14:56.000000', 'consum', 0.0219, 'lps'),
	(573950, 131, '2014-03-01 01:14:57.000000', 'consum', 0.0224, 'lps'),
	(573951, 131, '2014-03-01 01:14:58.000000', 'consum', 0.0219, 'lps'),
	(573952, 131, '2014-03-01 01:14:59.000000', 'consum', 0.0212, 'lps'),
	(573953, 131, '2014-03-01 01:15:00.000000', 'consum', 0.0212, 'lps'),
	(573954, 131, '2014-03-01 01:15:01.000000', 'consum', 0.0216, 'lps'),
	(573955, 131, '2014-03-01 01:15:02.000000', 'consum', 0.0214, 'lps'),
	(573956, 131, '2014-03-01 01:15:03.000000', 'consum', 0.0212, 'lps'),
	(573957, 131, '2014-03-01 01:15:04.000000', 'consum', 0.0227, 'lps'),
	(573958, 131, '2014-03-01 01:15:05.000000', 'consum', 0.0217, 'lps'),
	(573959, 131, '2014-03-01 01:15:06.000000', 'consum', 0.0212, 'lps'),
	(573960, 131, '2014-03-01 01:15:07.000000', 'consum', 0.0220, 'lps'),
	(573961, 131, '2014-03-01 01:15:08.000000', 'consum', 0.0216, 'lps'),
	(573962, 131, '2014-03-01 01:15:09.000000', 'consum', 0.0210, 'lps'),
	(573963, 131, '2014-03-01 01:15:10.000000', 'consum', 0.0212, 'lps'),
	(573964, 131, '2014-03-01 01:15:11.000000', 'consum', 0.0219, 'lps'),
	(573965, 131, '2014-03-01 01:15:12.000000', 'consum', 0.0213, 'lps'),
	(573966, 131, '2014-03-01 01:15:13.000000', 'consum', 0.0216, 'lps'),
	(573967, 131, '2014-03-01 01:15:14.000000', 'consum', 0.0216, 'lps'),
	(573968, 131, '2014-03-01 01:15:15.000000', 'consum', 0.0220, 'lps'),
	(573969, 131, '2014-03-01 01:15:16.000000', 'consum', 0.0226, 'lps'),
	(573970, 131, '2014-03-01 01:15:17.000000', 'consum', 0.0225, 'lps'),
	(573971, 131, '2014-03-01 01:15:18.000000', 'consum', 0.0219, 'lps'),
	(573972, 131, '2014-03-01 01:15:19.000000', 'consum', 0.0212, 'lps'),
	(573973, 131, '2014-03-01 01:15:20.000000', 'consum', 0.0227, 'lps'),
	(573974, 131, '2014-03-01 01:15:21.000000', 'consum', 0.0219, 'lps'),
	(573975, 131, '2014-03-01 01:15:22.000000', 'consum', 0.0221, 'lps'),
	(573976, 131, '2014-03-01 01:15:23.000000', 'consum', 0.0223, 'lps'),
	(573977, 131, '2014-03-01 01:15:24.000000', 'consum', 0.0221, 'lps'),
	(573978, 131, '2014-03-01 01:15:25.000000', 'consum', 0.0211, 'lps'),
	(573979, 131, '2014-03-01 01:15:26.000000', 'consum', 0.0219, 'lps'),
	(573980, 131, '2014-03-01 01:15:27.000000', 'consum', 0.0216, 'lps'),
	(573981, 131, '2014-03-01 01:15:28.000000', 'consum', 0.0212, 'lps'),
	(573982, 131, '2014-03-01 01:15:29.000000', 'consum', 0.0219, 'lps'),
	(573983, 131, '2014-03-01 01:15:30.000000', 'consum', 0.0217, 'lps'),
	(573984, 131, '2014-03-01 01:15:31.000000', 'consum', 0.0216, 'lps'),
	(573985, 131, '2014-03-01 01:15:32.000000', 'consum', 0.0220, 'lps'),
	(573986, 131, '2014-03-01 01:15:33.000000', 'consum', 0.0224, 'lps'),
	(573987, 131, '2014-03-01 01:15:34.000000', 'consum', 0.0217, 'lps'),
	(573988, 131, '2014-03-01 01:15:35.000000', 'consum', 0.0220, 'lps'),
	(573989, 131, '2014-03-01 01:15:36.000000', 'consum', 0.0223, 'lps'),
	(573990, 131, '2014-03-01 01:15:37.000000', 'consum', 0.0210, 'lps'),
	(573991, 131, '2014-03-01 01:15:38.000000', 'consum', 0.0226, 'lps'),
	(573992, 131, '2014-03-01 01:15:39.000000', 'consum', 0.0219, 'lps'),
	(573993, 131, '2014-03-01 01:15:40.000000', 'consum', 0.0225, 'lps'),
	(573994, 131, '2014-03-01 01:15:41.000000', 'consum', 0.0220, 'lps'),
	(573995, 131, '2014-03-01 01:15:42.000000', 'consum', 0.0219, 'lps'),
	(573996, 131, '2014-03-01 01:15:43.000000', 'consum', 0.0224, 'lps'),
	(573997, 131, '2014-03-01 01:15:44.000000', 'consum', 0.0219, 'lps'),
	(573998, 131, '2014-03-01 01:15:45.000000', 'consum', 0.0214, 'lps'),
	(573999, 131, '2014-03-01 01:15:46.000000', 'consum', 0.0219, 'lps'),
	(574000, 131, '2014-03-01 01:15:47.000000', 'consum', 0.0225, 'lps'),
	(574001, 131, '2014-03-01 01:15:48.000000', 'consum', 0.0223, 'lps'),
	(574002, 131, '2014-03-01 01:15:49.000000', 'consum', 0.0214, 'lps'),
	(574003, 131, '2014-03-01 01:15:50.000000', 'consum', 0.0226, 'lps'),
	(574004, 131, '2014-03-01 01:15:51.000000', 'consum', 0.0225, 'lps'),
	(574005, 131, '2014-03-01 01:15:52.000000', 'consum', 0.0219, 'lps'),
	(574006, 131, '2014-03-01 01:15:53.000000', 'consum', 0.0212, 'lps'),
	(574007, 131, '2014-03-01 01:15:54.000000', 'consum', 0.0227, 'lps'),
	(574008, 131, '2014-03-01 01:15:55.000000', 'consum', 0.0219, 'lps'),
	(574009, 131, '2014-03-01 01:15:56.000000', 'consum', 0.0223, 'lps'),
	(574010, 131, '2014-03-01 01:15:57.000000', 'consum', 0.0211, 'lps'),
	(574011, 131, '2014-03-01 01:15:58.000000', 'consum', 0.0211, 'lps'),
	(574012, 131, '2014-03-01 01:15:59.000000', 'consum', 0.0215, 'lps'),
	(574013, 131, '2014-03-01 01:16:00.000000', 'consum', 0.0216, 'lps'),
	(574014, 131, '2014-03-01 01:16:01.000000', 'consum', 0.0223, 'lps'),
	(574015, 131, '2014-03-01 01:16:02.000000', 'consum', 0.0223, 'lps'),
	(574016, 131, '2014-03-01 01:16:03.000000', 'consum', 0.0220, 'lps'),
	(574017, 131, '2014-03-01 01:16:04.000000', 'consum', 0.0220, 'lps'),
	(574018, 131, '2014-03-01 01:16:05.000000', 'consum', 0.0211, 'lps'),
	(574019, 131, '2014-03-01 01:16:06.000000', 'consum', 0.0224, 'lps'),
	(574020, 131, '2014-03-01 01:16:07.000000', 'consum', 0.0221, 'lps'),
	(574021, 131, '2014-03-01 01:16:08.000000', 'consum', 0.0223, 'lps'),
	(574022, 131, '2014-03-01 01:16:09.000000', 'consum', 0.0227, 'lps'),
	(574023, 131, '2014-03-01 01:16:10.000000', 'consum', 0.0219, 'lps'),
	(574024, 131, '2014-03-01 01:16:11.000000', 'consum', 0.0222, 'lps'),
	(574025, 131, '2014-03-01 01:16:12.000000', 'consum', 0.0224, 'lps'),
	(574026, 131, '2014-03-01 01:16:13.000000', 'consum', 0.0210, 'lps'),
	(574027, 131, '2014-03-01 01:16:14.000000', 'consum', 0.0222, 'lps'),
	(574028, 131, '2014-03-01 01:16:15.000000', 'consum', 0.0217, 'lps'),
	(574029, 131, '2014-03-01 01:16:16.000000', 'consum', 0.0211, 'lps'),
	(574030, 131, '2014-03-01 01:16:17.000000', 'consum', 0.0210, 'lps'),
	(574031, 131, '2014-03-01 01:16:18.000000', 'consum', 0.0227, 'lps'),
	(574032, 131, '2014-03-01 01:16:19.000000', 'consum', 0.0225, 'lps'),
	(574033, 131, '2014-03-01 01:16:20.000000', 'consum', 0.0215, 'lps'),
	(574034, 131, '2014-03-01 01:16:21.000000', 'consum', 0.0210, 'lps'),
	(574035, 131, '2014-03-01 01:16:22.000000', 'consum', 0.0211, 'lps'),
	(574036, 131, '2014-03-01 01:16:23.000000', 'consum', 0.0215, 'lps'),
	(574037, 131, '2014-03-01 01:16:24.000000', 'consum', 0.0214, 'lps'),
	(574038, 131, '2014-03-01 01:16:25.000000', 'consum', 0.0218, 'lps'),
	(574039, 131, '2014-03-01 01:16:26.000000', 'consum', 0.0218, 'lps'),
	(574040, 131, '2014-03-01 01:16:27.000000', 'consum', 0.0211, 'lps'),
	(574041, 131, '2014-03-01 01:16:28.000000', 'consum', 0.0225, 'lps'),
	(574042, 131, '2014-03-01 01:16:29.000000', 'consum', 0.0210, 'lps'),
	(574043, 131, '2014-03-01 01:16:30.000000', 'consum', 0.0219, 'lps'),
	(574044, 131, '2014-03-01 01:16:31.000000', 'consum', 0.0221, 'lps'),
	(574045, 131, '2014-03-01 01:16:32.000000', 'consum', 0.0220, 'lps'),
	(574046, 131, '2014-03-01 01:16:33.000000', 'consum', 0.0210, 'lps'),
	(574047, 131, '2014-03-01 01:16:34.000000', 'consum', 0.0218, 'lps'),
	(574048, 131, '2014-03-01 01:16:35.000000', 'consum', 0.0212, 'lps'),
	(574049, 131, '2014-03-01 01:16:36.000000', 'consum', 0.0215, 'lps'),
	(574050, 131, '2014-03-01 01:16:37.000000', 'consum', 0.0211, 'lps'),
	(574051, 131, '2014-03-01 01:16:38.000000', 'consum', 0.0220, 'lps'),
	(574052, 131, '2014-03-01 01:16:39.000000', 'consum', 0.0219, 'lps'),
	(574053, 131, '2014-03-01 01:16:40.000000', 'consum', 0.0210, 'lps'),
	(574054, 131, '2014-03-01 01:16:41.000000', 'consum', 0.0220, 'lps'),
	(574055, 131, '2014-03-01 01:16:42.000000', 'consum', 0.0223, 'lps'),
	(574056, 131, '2014-03-01 01:16:43.000000', 'consum', 0.0226, 'lps'),
	(574057, 131, '2014-03-01 01:16:44.000000', 'consum', 0.0217, 'lps'),
	(574058, 131, '2014-03-01 01:16:45.000000', 'consum', 0.0214, 'lps'),
	(574059, 131, '2014-03-01 01:16:46.000000', 'consum', 0.0211, 'lps'),
	(574060, 131, '2014-03-01 01:16:47.000000', 'consum', 0.0220, 'lps'),
	(574061, 131, '2014-03-01 01:16:48.000000', 'consum', 0.0222, 'lps'),
	(574062, 131, '2014-03-01 01:16:49.000000', 'consum', 0.0225, 'lps'),
	(574063, 131, '2014-03-01 01:16:50.000000', 'consum', 0.0210, 'lps'),
	(574064, 131, '2014-03-01 01:16:51.000000', 'consum', 0.0222, 'lps'),
	(574065, 131, '2014-03-01 01:16:52.000000', 'consum', 0.0214, 'lps'),
	(574066, 131, '2014-03-01 01:16:53.000000', 'consum', 0.0212, 'lps'),
	(574067, 131, '2014-03-01 01:16:54.000000', 'consum', 0.0211, 'lps'),
	(574068, 131, '2014-03-01 01:16:55.000000', 'consum', 0.0211, 'lps'),
	(574069, 131, '2014-03-01 01:16:56.000000', 'consum', 0.0210, 'lps'),
	(574070, 131, '2014-03-01 01:16:57.000000', 'consum', 0.0224, 'lps'),
	(574071, 131, '2014-03-01 01:16:58.000000', 'consum', 0.0210, 'lps'),
	(574072, 131, '2014-03-01 01:16:59.000000', 'consum', 0.0224, 'lps'),
	(574073, 131, '2014-03-01 01:17:00.000000', 'consum', 0.0227, 'lps'),
	(574074, 131, '2014-03-01 01:17:01.000000', 'consum', 0.0215, 'lps'),
	(574075, 131, '2014-03-01 01:17:02.000000', 'consum', 0.0223, 'lps'),
	(574076, 131, '2014-03-01 01:17:03.000000', 'consum', 0.0222, 'lps'),
	(574077, 131, '2014-03-01 01:17:04.000000', 'consum', 0.0214, 'lps'),
	(574078, 131, '2014-03-01 01:17:05.000000', 'consum', 0.0215, 'lps'),
	(574079, 131, '2014-03-01 01:17:06.000000', 'consum', 0.0220, 'lps'),
	(574080, 131, '2014-03-01 01:17:07.000000', 'consum', 0.0212, 'lps'),
	(574081, 131, '2014-03-01 01:17:08.000000', 'consum', 0.0226, 'lps'),
	(574082, 131, '2014-03-01 01:17:09.000000', 'consum', 0.0213, 'lps'),
	(574083, 131, '2014-03-01 01:17:10.000000', 'consum', 0.0212, 'lps'),
	(574084, 131, '2014-03-01 01:17:11.000000', 'consum', 0.0214, 'lps'),
	(574085, 131, '2014-03-01 01:17:12.000000', 'consum', 0.0222, 'lps'),
	(574086, 131, '2014-03-01 01:17:13.000000', 'consum', 0.0223, 'lps'),
	(574087, 131, '2014-03-01 01:17:14.000000', 'consum', 0.0220, 'lps'),
	(574088, 131, '2014-03-01 01:17:15.000000', 'consum', 0.0221, 'lps'),
	(574089, 131, '2014-03-01 01:17:16.000000', 'consum', 0.0221, 'lps'),
	(574090, 131, '2014-03-01 01:17:17.000000', 'consum', 0.0212, 'lps'),
	(574091, 131, '2014-03-01 01:17:18.000000', 'consum', 0.0225, 'lps'),
	(574092, 131, '2014-03-01 01:17:19.000000', 'consum', 0.0225, 'lps'),
	(574093, 131, '2014-03-01 01:17:20.000000', 'consum', 0.0224, 'lps'),
	(574094, 131, '2014-03-01 01:17:21.000000', 'consum', 0.0218, 'lps'),
	(574095, 131, '2014-03-01 01:17:22.000000', 'consum', 0.0224, 'lps'),
	(574096, 131, '2014-03-01 01:17:23.000000', 'consum', 0.0223, 'lps'),
	(574097, 131, '2014-03-01 01:17:24.000000', 'consum', 0.0215, 'lps'),
	(574098, 131, '2014-03-01 01:17:25.000000', 'consum', 0.0214, 'lps'),
	(574099, 131, '2014-03-01 01:17:26.000000', 'consum', 0.0214, 'lps'),
	(574100, 131, '2014-03-01 01:17:27.000000', 'consum', 0.0218, 'lps'),
	(574101, 131, '2014-03-01 01:17:28.000000', 'consum', 0.0222, 'lps'),
	(574102, 131, '2014-03-01 01:17:29.000000', 'consum', 0.0211, 'lps'),
	(574103, 131, '2014-03-01 01:17:30.000000', 'consum', 0.0213, 'lps'),
	(574104, 131, '2014-03-01 01:17:31.000000', 'consum', 0.0224, 'lps'),
	(574105, 131, '2014-03-01 01:17:32.000000', 'consum', 0.0216, 'lps'),
	(574106, 131, '2014-03-01 01:17:33.000000', 'consum', 0.0219, 'lps'),
	(574107, 131, '2014-03-01 01:17:34.000000', 'consum', 0.0218, 'lps'),
	(574108, 131, '2014-03-01 01:17:35.000000', 'consum', 0.0224, 'lps'),
	(574109, 131, '2014-03-01 01:17:36.000000', 'consum', 0.0220, 'lps'),
	(574110, 131, '2014-03-01 01:17:37.000000', 'consum', 0.0218, 'lps'),
	(574111, 131, '2014-03-01 01:17:38.000000', 'consum', 0.0221, 'lps'),
	(574112, 131, '2014-03-01 01:17:39.000000', 'consum', 0.0225, 'lps'),
	(574113, 131, '2014-03-01 01:17:40.000000', 'consum', 0.0216, 'lps'),
	(574114, 131, '2014-03-01 01:17:41.000000', 'consum', 0.0214, 'lps'),
	(574115, 131, '2014-03-01 01:17:42.000000', 'consum', 0.0212, 'lps'),
	(574116, 131, '2014-03-01 01:17:43.000000', 'consum', 0.0224, 'lps'),
	(574117, 131, '2014-03-01 01:17:44.000000', 'consum', 0.0224, 'lps'),
	(574118, 131, '2014-03-01 01:17:45.000000', 'consum', 0.0219, 'lps'),
	(574119, 131, '2014-03-01 01:17:46.000000', 'consum', 0.0214, 'lps'),
	(574120, 131, '2014-03-01 01:17:47.000000', 'consum', 0.0222, 'lps'),
	(574121, 131, '2014-03-01 01:17:48.000000', 'consum', 0.0222, 'lps'),
	(574122, 131, '2014-03-01 01:17:49.000000', 'consum', 0.0218, 'lps'),
	(574123, 131, '2014-03-01 01:17:50.000000', 'consum', 0.0215, 'lps'),
	(574124, 131, '2014-03-01 01:17:51.000000', 'consum', 0.0212, 'lps'),
	(574125, 131, '2014-03-01 01:17:52.000000', 'consum', 0.0221, 'lps'),
	(574126, 131, '2014-03-01 01:17:53.000000', 'consum', 0.0226, 'lps'),
	(574127, 131, '2014-03-01 01:17:54.000000', 'consum', 0.0220, 'lps'),
	(574128, 131, '2014-03-01 01:17:55.000000', 'consum', 0.0213, 'lps'),
	(574129, 131, '2014-03-01 01:17:56.000000', 'consum', 0.0214, 'lps'),
	(574130, 131, '2014-03-01 01:17:57.000000', 'consum', 0.0221, 'lps'),
	(574131, 131, '2014-03-01 01:17:58.000000', 'consum', 0.0219, 'lps'),
	(574132, 131, '2014-03-01 01:17:59.000000', 'consum', 0.0221, 'lps'),
	(574133, 131, '2014-03-01 01:18:00.000000', 'consum', 0.0223, 'lps'),
	(574134, 131, '2014-03-01 01:18:01.000000', 'consum', 0.0223, 'lps'),
	(574135, 131, '2014-03-01 01:18:02.000000', 'consum', 0.0217, 'lps'),
	(574136, 131, '2014-03-01 01:18:03.000000', 'consum', 0.0226, 'lps'),
	(574137, 131, '2014-03-01 01:18:04.000000', 'consum', 0.0216, 'lps'),
	(574138, 131, '2014-03-01 01:18:05.000000', 'consum', 0.0210, 'lps'),
	(574139, 131, '2014-03-01 01:18:06.000000', 'consum', 0.0211, 'lps'),
	(574140, 131, '2014-03-01 01:18:07.000000', 'consum', 0.0215, 'lps'),
	(574141, 131, '2014-03-01 01:18:08.000000', 'consum', 0.0217, 'lps'),
	(574142, 131, '2014-03-01 01:18:09.000000', 'consum', 0.0227, 'lps'),
	(574143, 131, '2014-03-01 01:18:10.000000', 'consum', 0.0221, 'lps'),
	(574144, 131, '2014-03-01 01:18:11.000000', 'consum', 0.0216, 'lps'),
	(574145, 131, '2014-03-01 01:18:12.000000', 'consum', 0.0223, 'lps'),
	(574146, 131, '2014-03-01 01:18:13.000000', 'consum', 0.0222, 'lps'),
	(574147, 131, '2014-03-01 01:18:14.000000', 'consum', 0.0212, 'lps'),
	(574148, 131, '2014-03-01 01:18:15.000000', 'consum', 0.0223, 'lps'),
	(574149, 131, '2014-03-01 01:18:16.000000', 'consum', 0.0216, 'lps'),
	(574150, 131, '2014-03-01 01:18:17.000000', 'consum', 0.0216, 'lps'),
	(574151, 131, '2014-03-01 01:18:18.000000', 'consum', 0.0226, 'lps'),
	(574152, 131, '2014-03-01 01:18:19.000000', 'consum', 0.0219, 'lps'),
	(574153, 131, '2014-03-01 01:18:20.000000', 'consum', 0.0225, 'lps'),
	(574154, 131, '2014-03-01 01:18:21.000000', 'consum', 0.0221, 'lps'),
	(574155, 131, '2014-03-01 01:18:22.000000', 'consum', 0.0220, 'lps'),
	(574156, 131, '2014-03-01 01:18:23.000000', 'consum', 0.0211, 'lps'),
	(574157, 131, '2014-03-01 01:18:24.000000', 'consum', 0.0221, 'lps'),
	(574158, 131, '2014-03-01 01:18:25.000000', 'consum', 0.0226, 'lps'),
	(574159, 131, '2014-03-01 01:18:26.000000', 'consum', 0.0223, 'lps'),
	(574160, 131, '2014-03-01 01:18:27.000000', 'consum', 0.0210, 'lps'),
	(574161, 131, '2014-03-01 01:18:28.000000', 'consum', 0.0223, 'lps'),
	(574162, 131, '2014-03-01 01:18:29.000000', 'consum', 0.0222, 'lps'),
	(574163, 131, '2014-03-01 01:18:30.000000', 'consum', 0.0213, 'lps'),
	(574164, 131, '2014-03-01 01:18:31.000000', 'consum', 0.0225, 'lps'),
	(574165, 131, '2014-03-01 01:18:32.000000', 'consum', 0.0224, 'lps'),
	(574166, 131, '2014-03-01 01:18:33.000000', 'consum', 0.0215, 'lps'),
	(574167, 131, '2014-03-01 01:18:34.000000', 'consum', 0.0213, 'lps'),
	(574168, 131, '2014-03-01 01:18:35.000000', 'consum', 0.0212, 'lps'),
	(574169, 131, '2014-03-01 01:18:36.000000', 'consum', 0.0211, 'lps'),
	(574170, 131, '2014-03-01 01:18:37.000000', 'consum', 0.0211, 'lps'),
	(574171, 131, '2014-03-01 01:18:38.000000', 'consum', 0.0212, 'lps'),
	(574172, 131, '2014-03-01 01:18:39.000000', 'consum', 0.0216, 'lps'),
	(574173, 131, '2014-03-01 01:18:40.000000', 'consum', 0.0218, 'lps'),
	(574174, 131, '2014-03-01 01:18:41.000000', 'consum', 0.0212, 'lps'),
	(574175, 131, '2014-03-01 01:18:42.000000', 'consum', 0.0216, 'lps'),
	(574176, 131, '2014-03-01 01:18:43.000000', 'consum', 0.0215, 'lps'),
	(574177, 131, '2014-03-01 01:18:44.000000', 'consum', 0.0219, 'lps'),
	(574178, 131, '2014-03-01 01:18:45.000000', 'consum', 0.0223, 'lps'),
	(574179, 131, '2014-03-01 01:18:46.000000', 'consum', 0.0210, 'lps'),
	(574180, 131, '2014-03-01 01:18:47.000000', 'consum', 0.0211, 'lps'),
	(574181, 131, '2014-03-01 01:18:48.000000', 'consum', 0.0214, 'lps'),
	(574182, 131, '2014-03-01 01:18:49.000000', 'consum', 0.0227, 'lps'),
	(574183, 131, '2014-03-01 01:18:50.000000', 'consum', 0.0210, 'lps'),
	(574184, 131, '2014-03-01 01:18:51.000000', 'consum', 0.0215, 'lps'),
	(574185, 131, '2014-03-01 01:18:52.000000', 'consum', 0.0219, 'lps'),
	(574186, 131, '2014-03-01 01:18:53.000000', 'consum', 0.0222, 'lps'),
	(574187, 131, '2014-03-01 01:18:54.000000', 'consum', 0.0225, 'lps'),
	(574188, 131, '2014-03-01 01:18:55.000000', 'consum', 0.0214, 'lps'),
	(574189, 131, '2014-03-01 01:18:56.000000', 'consum', 0.0219, 'lps'),
	(574190, 131, '2014-03-01 01:18:57.000000', 'consum', 0.0210, 'lps'),
	(574191, 131, '2014-03-01 01:18:58.000000', 'consum', 0.0217, 'lps'),
	(574192, 131, '2014-03-01 01:18:59.000000', 'consum', 0.0213, 'lps'),
	(574193, 131, '2014-03-01 01:19:00.000000', 'consum', 0.0219, 'lps'),
	(574194, 131, '2014-03-01 01:19:01.000000', 'consum', 0.0213, 'lps'),
	(574195, 131, '2014-03-01 01:19:02.000000', 'consum', 0.0214, 'lps'),
	(574196, 131, '2014-03-01 01:19:03.000000', 'consum', 0.0225, 'lps'),
	(574197, 131, '2014-03-01 01:19:04.000000', 'consum', 0.0216, 'lps'),
	(574198, 131, '2014-03-01 01:19:05.000000', 'consum', 0.0216, 'lps'),
	(574199, 131, '2014-03-01 01:19:06.000000', 'consum', 0.0222, 'lps'),
	(574200, 131, '2014-03-01 01:19:07.000000', 'consum', 0.0217, 'lps'),
	(574201, 131, '2014-03-01 01:19:08.000000', 'consum', 0.0226, 'lps'),
	(574202, 131, '2014-03-01 01:19:09.000000', 'consum', 0.0218, 'lps'),
	(574203, 131, '2014-03-01 01:19:10.000000', 'consum', 0.0219, 'lps'),
	(574204, 131, '2014-03-01 01:19:11.000000', 'consum', 0.0213, 'lps'),
	(574205, 131, '2014-03-01 01:19:12.000000', 'consum', 0.0217, 'lps'),
	(574206, 131, '2014-03-01 01:19:13.000000', 'consum', 0.0217, 'lps'),
	(574207, 131, '2014-03-01 01:19:14.000000', 'consum', 0.0227, 'lps'),
	(574208, 131, '2014-03-01 01:19:15.000000', 'consum', 0.0218, 'lps'),
	(574209, 131, '2014-03-01 01:19:16.000000', 'consum', 0.0220, 'lps'),
	(574210, 131, '2014-03-01 01:19:17.000000', 'consum', 0.0216, 'lps'),
	(574211, 131, '2014-03-01 01:19:18.000000', 'consum', 0.0213, 'lps'),
	(574212, 131, '2014-03-01 01:19:19.000000', 'consum', 0.0225, 'lps'),
	(574213, 131, '2014-03-01 01:19:20.000000', 'consum', 0.0223, 'lps'),
	(574214, 131, '2014-03-01 01:19:21.000000', 'consum', 0.0212, 'lps'),
	(574215, 131, '2014-03-01 01:19:22.000000', 'consum', 0.0216, 'lps'),
	(574216, 131, '2014-03-01 01:19:23.000000', 'consum', 0.0219, 'lps'),
	(574217, 131, '2014-03-01 01:19:24.000000', 'consum', 0.0219, 'lps'),
	(574218, 131, '2014-03-01 01:19:25.000000', 'consum', 0.0227, 'lps'),
	(574219, 131, '2014-03-01 01:19:26.000000', 'consum', 0.0216, 'lps'),
	(574220, 131, '2014-03-01 01:19:27.000000', 'consum', 0.0225, 'lps'),
	(574221, 131, '2014-03-01 01:19:28.000000', 'consum', 0.0212, 'lps'),
	(574222, 131, '2014-03-01 01:19:29.000000', 'consum', 0.0211, 'lps'),
	(574223, 131, '2014-03-01 01:19:30.000000', 'consum', 0.0212, 'lps'),
	(574224, 131, '2014-03-01 01:19:31.000000', 'consum', 0.0218, 'lps'),
	(574225, 131, '2014-03-01 01:19:32.000000', 'consum', 0.0227, 'lps'),
	(574226, 131, '2014-03-01 01:19:33.000000', 'consum', 0.0215, 'lps'),
	(574227, 131, '2014-03-01 01:19:34.000000', 'consum', 0.0223, 'lps'),
	(574228, 131, '2014-03-01 01:19:35.000000', 'consum', 0.0223, 'lps'),
	(574229, 131, '2014-03-01 01:19:36.000000', 'consum', 0.0220, 'lps'),
	(574230, 131, '2014-03-01 01:19:37.000000', 'consum', 0.0219, 'lps'),
	(574231, 131, '2014-03-01 01:19:38.000000', 'consum', 0.0226, 'lps'),
	(574232, 131, '2014-03-01 01:19:39.000000', 'consum', 0.0226, 'lps'),
	(574233, 131, '2014-03-01 01:19:40.000000', 'consum', 0.0210, 'lps'),
	(574234, 131, '2014-03-01 01:19:41.000000', 'consum', 0.0215, 'lps'),
	(574235, 131, '2014-03-01 01:19:42.000000', 'consum', 0.0216, 'lps'),
	(574236, 131, '2014-03-01 01:19:43.000000', 'consum', 0.0210, 'lps'),
	(574237, 131, '2014-03-01 01:19:44.000000', 'consum', 0.0210, 'lps'),
	(574238, 131, '2014-03-01 01:19:45.000000', 'consum', 0.0227, 'lps'),
	(574239, 131, '2014-03-01 01:19:46.000000', 'consum', 0.0223, 'lps'),
	(574240, 131, '2014-03-01 01:19:47.000000', 'consum', 0.0227, 'lps'),
	(574241, 131, '2014-03-01 01:19:48.000000', 'consum', 0.0220, 'lps'),
	(574242, 131, '2014-03-01 01:19:49.000000', 'consum', 0.0225, 'lps'),
	(574243, 131, '2014-03-01 01:19:50.000000', 'consum', 0.0223, 'lps'),
	(574244, 131, '2014-03-01 01:19:51.000000', 'consum', 0.0210, 'lps'),
	(574245, 131, '2014-03-01 01:19:52.000000', 'consum', 0.0225, 'lps'),
	(574246, 131, '2014-03-01 01:19:53.000000', 'consum', 0.0216, 'lps'),
	(574247, 131, '2014-03-01 01:19:54.000000', 'consum', 0.0212, 'lps'),
	(574248, 131, '2014-03-01 01:19:55.000000', 'consum', 0.0222, 'lps'),
	(574249, 131, '2014-03-01 01:19:56.000000', 'consum', 0.0226, 'lps'),
	(574250, 131, '2014-03-01 01:19:57.000000', 'consum', 0.0218, 'lps'),
	(574251, 131, '2014-03-01 01:19:58.000000', 'consum', 0.0220, 'lps'),
	(574252, 131, '2014-03-01 01:19:59.000000', 'consum', 0.0221, 'lps'),
	(574253, 131, '2014-03-01 01:20:00.000000', 'consum', 0.0217, 'lps'),
	(574254, 131, '2014-03-01 01:20:01.000000', 'consum', 0.0212, 'lps'),
	(574255, 131, '2014-03-01 01:20:02.000000', 'consum', 0.0218, 'lps'),
	(574256, 131, '2014-03-01 01:20:03.000000', 'consum', 0.0227, 'lps'),
	(574257, 131, '2014-03-01 01:20:04.000000', 'consum', 0.0218, 'lps'),
	(574258, 131, '2014-03-01 01:20:05.000000', 'consum', 0.0219, 'lps'),
	(574259, 131, '2014-03-01 01:20:06.000000', 'consum', 0.0211, 'lps'),
	(574260, 131, '2014-03-01 01:20:07.000000', 'consum', 0.0226, 'lps'),
	(574261, 131, '2014-03-01 01:20:08.000000', 'consum', 0.0216, 'lps'),
	(574262, 131, '2014-03-01 01:20:09.000000', 'consum', 0.0212, 'lps'),
	(574263, 131, '2014-03-01 01:20:10.000000', 'consum', 0.0218, 'lps'),
	(574264, 131, '2014-03-01 01:20:11.000000', 'consum', 0.0227, 'lps'),
	(574265, 131, '2014-03-01 01:20:12.000000', 'consum', 0.0216, 'lps'),
	(574266, 131, '2014-03-01 01:20:13.000000', 'consum', 0.0211, 'lps'),
	(574267, 131, '2014-03-01 01:20:14.000000', 'consum', 0.0213, 'lps'),
	(574268, 131, '2014-03-01 01:20:15.000000', 'consum', 0.0222, 'lps'),
	(574269, 131, '2014-03-01 01:20:16.000000', 'consum', 0.0226, 'lps'),
	(574270, 131, '2014-03-01 01:20:17.000000', 'consum', 0.0218, 'lps'),
	(574271, 131, '2014-03-01 01:20:18.000000', 'consum', 0.0222, 'lps'),
	(574272, 131, '2014-03-01 01:20:19.000000', 'consum', 0.0211, 'lps'),
	(574273, 131, '2014-03-01 01:20:20.000000', 'consum', 0.0213, 'lps'),
	(574274, 131, '2014-03-01 01:20:21.000000', 'consum', 0.0223, 'lps'),
	(574275, 131, '2014-03-01 01:20:22.000000', 'consum', 0.0215, 'lps'),
	(574276, 131, '2014-03-01 01:20:23.000000', 'consum', 0.0214, 'lps'),
	(574277, 131, '2014-03-01 01:20:24.000000', 'consum', 0.0213, 'lps'),
	(574278, 131, '2014-03-01 01:20:25.000000', 'consum', 0.0214, 'lps'),
	(574279, 131, '2014-03-01 01:20:26.000000', 'consum', 0.0221, 'lps'),
	(574280, 131, '2014-03-01 01:20:27.000000', 'consum', 0.0219, 'lps'),
	(574281, 131, '2014-03-01 01:20:28.000000', 'consum', 0.0223, 'lps'),
	(574282, 131, '2014-03-01 01:20:29.000000', 'consum', 0.0212, 'lps'),
	(574283, 131, '2014-03-01 01:20:30.000000', 'consum', 0.0219, 'lps'),
	(574284, 131, '2014-03-01 01:20:31.000000', 'consum', 0.0211, 'lps'),
	(574285, 131, '2014-03-01 01:20:32.000000', 'consum', 0.0224, 'lps'),
	(574286, 131, '2014-03-01 01:20:33.000000', 'consum', 0.0223, 'lps'),
	(574287, 131, '2014-03-01 01:20:34.000000', 'consum', 0.0215, 'lps'),
	(574288, 131, '2014-03-01 01:20:35.000000', 'consum', 0.0217, 'lps'),
	(574289, 131, '2014-03-01 01:20:36.000000', 'consum', 0.0211, 'lps'),
	(574290, 131, '2014-03-01 01:20:37.000000', 'consum', 0.0212, 'lps'),
	(574291, 131, '2014-03-01 01:20:38.000000', 'consum', 0.0218, 'lps'),
	(574292, 131, '2014-03-01 01:20:39.000000', 'consum', 0.0210, 'lps'),
	(574293, 131, '2014-03-01 01:20:40.000000', 'consum', 0.0221, 'lps'),
	(574294, 131, '2014-03-01 01:20:41.000000', 'consum', 0.0210, 'lps'),
	(574295, 131, '2014-03-01 01:20:42.000000', 'consum', 0.0214, 'lps'),
	(574296, 131, '2014-03-01 01:20:43.000000', 'consum', 0.0213, 'lps'),
	(574297, 131, '2014-03-01 01:20:44.000000', 'consum', 0.0212, 'lps'),
	(574298, 131, '2014-03-01 01:20:45.000000', 'consum', 0.0212, 'lps'),
	(574299, 131, '2014-03-01 01:20:46.000000', 'consum', 0.0213, 'lps'),
	(574300, 131, '2014-03-01 01:20:47.000000', 'consum', 0.0220, 'lps'),
	(574301, 131, '2014-03-01 01:20:48.000000', 'consum', 0.0217, 'lps'),
	(574302, 131, '2014-03-01 01:20:49.000000', 'consum', 0.0216, 'lps'),
	(574303, 131, '2014-03-01 01:20:50.000000', 'consum', 0.0217, 'lps'),
	(574304, 131, '2014-03-01 01:20:51.000000', 'consum', 0.0210, 'lps'),
	(574305, 131, '2014-03-01 01:20:52.000000', 'consum', 0.0225, 'lps'),
	(574306, 131, '2014-03-01 01:20:53.000000', 'consum', 0.0213, 'lps'),
	(574307, 131, '2014-03-01 01:20:54.000000', 'consum', 0.0216, 'lps'),
	(574308, 131, '2014-03-01 01:20:55.000000', 'consum', 0.0214, 'lps'),
	(574309, 131, '2014-03-01 01:20:56.000000', 'consum', 0.0215, 'lps'),
	(574310, 131, '2014-03-01 01:20:57.000000', 'consum', 0.0221, 'lps'),
	(574311, 131, '2014-03-01 01:20:58.000000', 'consum', 0.0216, 'lps'),
	(574312, 131, '2014-03-01 01:20:59.000000', 'consum', 0.0227, 'lps'),
	(574313, 131, '2014-03-01 01:21:00.000000', 'consum', 0.0221, 'lps'),
	(574314, 131, '2014-03-01 01:21:01.000000', 'consum', 0.0215, 'lps'),
	(574315, 131, '2014-03-01 01:21:02.000000', 'consum', 0.0220, 'lps'),
	(574316, 131, '2014-03-01 01:21:03.000000', 'consum', 0.0226, 'lps'),
	(574317, 131, '2014-03-01 01:21:04.000000', 'consum', 0.0227, 'lps'),
	(574318, 131, '2014-03-01 01:21:05.000000', 'consum', 0.0227, 'lps'),
	(574319, 131, '2014-03-01 01:21:06.000000', 'consum', 0.0210, 'lps'),
	(574320, 131, '2014-03-01 01:21:07.000000', 'consum', 0.0213, 'lps'),
	(574321, 131, '2014-03-01 01:21:08.000000', 'consum', 0.0227, 'lps'),
	(574322, 131, '2014-03-01 01:21:09.000000', 'consum', 0.0213, 'lps'),
	(574323, 131, '2014-03-01 01:21:10.000000', 'consum', 0.0227, 'lps'),
	(574324, 131, '2014-03-01 01:21:11.000000', 'consum', 0.0215, 'lps'),
	(574325, 131, '2014-03-01 01:21:12.000000', 'consum', 0.0221, 'lps'),
	(574326, 131, '2014-03-01 01:21:13.000000', 'consum', 0.0214, 'lps'),
	(574327, 131, '2014-03-01 01:21:14.000000', 'consum', 0.0216, 'lps'),
	(574328, 131, '2014-03-01 01:21:15.000000', 'consum', 0.0226, 'lps'),
	(574329, 131, '2014-03-01 01:21:16.000000', 'consum', 0.0222, 'lps'),
	(574330, 131, '2014-03-01 01:21:17.000000', 'consum', 0.0220, 'lps'),
	(574331, 131, '2014-03-01 01:21:18.000000', 'consum', 0.0225, 'lps'),
	(574332, 131, '2014-03-01 01:21:19.000000', 'consum', 0.0219, 'lps'),
	(574333, 131, '2014-03-01 01:21:20.000000', 'consum', 0.0211, 'lps'),
	(574334, 131, '2014-03-01 01:21:21.000000', 'consum', 0.0224, 'lps'),
	(574335, 131, '2014-03-01 01:21:22.000000', 'consum', 0.0226, 'lps'),
	(574336, 131, '2014-03-01 01:21:23.000000', 'consum', 0.0210, 'lps'),
	(574337, 131, '2014-03-01 01:21:24.000000', 'consum', 0.0219, 'lps'),
	(574338, 131, '2014-03-01 01:21:25.000000', 'consum', 0.0220, 'lps'),
	(574339, 131, '2014-03-01 01:21:26.000000', 'consum', 0.0213, 'lps'),
	(574340, 131, '2014-03-01 01:21:27.000000', 'consum', 0.0214, 'lps'),
	(574341, 131, '2014-03-01 01:21:28.000000', 'consum', 0.0221, 'lps'),
	(574342, 131, '2014-03-01 01:21:29.000000', 'consum', 0.0217, 'lps'),
	(574343, 131, '2014-03-01 01:21:30.000000', 'consum', 0.0213, 'lps'),
	(574344, 131, '2014-03-01 01:21:31.000000', 'consum', 0.0224, 'lps'),
	(574345, 131, '2014-03-01 01:21:32.000000', 'consum', 0.0216, 'lps'),
	(574346, 131, '2014-03-01 01:21:33.000000', 'consum', 0.0219, 'lps'),
	(574347, 131, '2014-03-01 01:21:34.000000', 'consum', 0.0216, 'lps'),
	(574348, 131, '2014-03-01 01:21:35.000000', 'consum', 0.0216, 'lps'),
	(574349, 131, '2014-03-01 01:21:36.000000', 'consum', 0.0224, 'lps'),
	(574350, 131, '2014-03-01 01:21:37.000000', 'consum', 0.0223, 'lps'),
	(574351, 131, '2014-03-01 01:21:38.000000', 'consum', 0.0218, 'lps'),
	(574352, 131, '2014-03-01 01:21:39.000000', 'consum', 0.0210, 'lps'),
	(574353, 131, '2014-03-01 01:21:40.000000', 'consum', 0.0221, 'lps'),
	(574354, 131, '2014-03-01 01:21:41.000000', 'consum', 0.0215, 'lps'),
	(574355, 131, '2014-03-01 01:21:42.000000', 'consum', 0.0218, 'lps'),
	(574356, 131, '2014-03-01 01:21:43.000000', 'consum', 0.0219, 'lps'),
	(574357, 131, '2014-03-01 01:21:44.000000', 'consum', 0.0213, 'lps'),
	(574358, 131, '2014-03-01 01:21:45.000000', 'consum', 0.0217, 'lps'),
	(574359, 131, '2014-03-01 01:21:46.000000', 'consum', 0.0219, 'lps'),
	(574360, 131, '2014-03-01 01:21:47.000000', 'consum', 0.0214, 'lps'),
	(574361, 131, '2014-03-01 01:21:48.000000', 'consum', 0.0222, 'lps'),
	(574362, 131, '2014-03-01 01:21:49.000000', 'consum', 0.0222, 'lps'),
	(574363, 131, '2014-03-01 01:21:50.000000', 'consum', 0.0219, 'lps'),
	(574364, 131, '2014-03-01 01:21:51.000000', 'consum', 0.0217, 'lps'),
	(574365, 131, '2014-03-01 01:21:52.000000', 'consum', 0.0221, 'lps'),
	(574366, 131, '2014-03-01 01:21:53.000000', 'consum', 0.0224, 'lps'),
	(574367, 131, '2014-03-01 01:21:54.000000', 'consum', 0.0212, 'lps'),
	(574368, 131, '2014-03-01 01:21:55.000000', 'consum', 0.0216, 'lps'),
	(574369, 131, '2014-03-01 01:21:56.000000', 'consum', 0.0217, 'lps'),
	(574370, 131, '2014-03-01 01:21:57.000000', 'consum', 0.0226, 'lps'),
	(574371, 131, '2014-03-01 01:21:58.000000', 'consum', 0.0218, 'lps'),
	(574372, 131, '2014-03-01 01:21:59.000000', 'consum', 0.0217, 'lps'),
	(574373, 131, '2014-03-01 01:22:00.000000', 'consum', 0.0223, 'lps'),
	(574374, 131, '2014-03-01 01:22:01.000000', 'consum', 0.0218, 'lps'),
	(574375, 131, '2014-03-01 01:22:02.000000', 'consum', 0.0211, 'lps'),
	(574376, 131, '2014-03-01 01:22:03.000000', 'consum', 0.0211, 'lps'),
	(574377, 131, '2014-03-01 01:22:04.000000', 'consum', 0.0211, 'lps'),
	(574378, 131, '2014-03-01 01:22:05.000000', 'consum', 0.0212, 'lps'),
	(574379, 131, '2014-03-01 01:22:06.000000', 'consum', 0.0219, 'lps'),
	(574380, 131, '2014-03-01 01:22:07.000000', 'consum', 0.0213, 'lps'),
	(574381, 131, '2014-03-01 01:22:08.000000', 'consum', 0.0217, 'lps'),
	(574382, 131, '2014-03-01 01:22:09.000000', 'consum', 0.0219, 'lps'),
	(574383, 131, '2014-03-01 01:22:10.000000', 'consum', 0.0214, 'lps'),
	(574384, 131, '2014-03-01 01:22:11.000000', 'consum', 0.0224, 'lps'),
	(574385, 131, '2014-03-01 01:22:12.000000', 'consum', 0.0215, 'lps'),
	(574386, 131, '2014-03-01 01:22:13.000000', 'consum', 0.0227, 'lps'),
	(574387, 131, '2014-03-01 01:22:14.000000', 'consum', 0.0212, 'lps'),
	(574388, 131, '2014-03-01 01:22:15.000000', 'consum', 0.0221, 'lps'),
	(574389, 131, '2014-03-01 01:22:16.000000', 'consum', 0.0223, 'lps'),
	(574390, 131, '2014-03-01 01:22:17.000000', 'consum', 0.0224, 'lps'),
	(574391, 131, '2014-03-01 01:22:18.000000', 'consum', 0.0223, 'lps'),
	(574392, 131, '2014-03-01 01:22:19.000000', 'consum', 0.0215, 'lps'),
	(574393, 131, '2014-03-01 01:22:20.000000', 'consum', 0.0217, 'lps'),
	(574394, 131, '2014-03-01 01:22:21.000000', 'consum', 0.0210, 'lps'),
	(574395, 131, '2014-03-01 01:22:22.000000', 'consum', 0.0210, 'lps'),
	(574396, 131, '2014-03-01 01:22:23.000000', 'consum', 0.0211, 'lps'),
	(574397, 131, '2014-03-01 01:22:24.000000', 'consum', 0.0215, 'lps'),
	(574398, 131, '2014-03-01 01:22:25.000000', 'consum', 0.0215, 'lps'),
	(574399, 131, '2014-03-01 01:22:26.000000', 'consum', 0.0218, 'lps'),
	(574400, 131, '2014-03-01 01:22:27.000000', 'consum', 0.0219, 'lps'),
	(574401, 131, '2014-03-01 01:22:28.000000', 'consum', 0.0212, 'lps'),
	(574402, 131, '2014-03-01 01:22:29.000000', 'consum', 0.0214, 'lps'),
	(574403, 131, '2014-03-01 01:22:30.000000', 'consum', 0.0222, 'lps'),
	(574404, 131, '2014-03-01 01:22:31.000000', 'consum', 0.0223, 'lps'),
	(574405, 131, '2014-03-01 01:22:32.000000', 'consum', 0.0220, 'lps'),
	(574406, 131, '2014-03-01 01:22:33.000000', 'consum', 0.0223, 'lps'),
	(574407, 131, '2014-03-01 01:22:34.000000', 'consum', 0.0225, 'lps'),
	(574408, 131, '2014-03-01 01:22:35.000000', 'consum', 0.0214, 'lps'),
	(574409, 131, '2014-03-01 01:22:36.000000', 'consum', 0.0218, 'lps'),
	(574410, 131, '2014-03-01 01:22:37.000000', 'consum', 0.0222, 'lps'),
	(574411, 131, '2014-03-01 01:22:38.000000', 'consum', 0.0212, 'lps'),
	(574412, 131, '2014-03-01 01:22:39.000000', 'consum', 0.0221, 'lps'),
	(574413, 131, '2014-03-01 01:22:40.000000', 'consum', 0.0220, 'lps'),
	(574414, 131, '2014-03-01 01:22:41.000000', 'consum', 0.0213, 'lps'),
	(574415, 131, '2014-03-01 01:22:42.000000', 'consum', 0.0210, 'lps'),
	(574416, 131, '2014-03-01 01:22:43.000000', 'consum', 0.0222, 'lps'),
	(574417, 131, '2014-03-01 01:22:44.000000', 'consum', 0.0214, 'lps'),
	(574418, 131, '2014-03-01 01:22:45.000000', 'consum', 0.0215, 'lps'),
	(574419, 131, '2014-03-01 01:22:46.000000', 'consum', 0.0223, 'lps'),
	(574420, 131, '2014-03-01 01:22:47.000000', 'consum', 0.0226, 'lps'),
	(574421, 131, '2014-03-01 01:22:48.000000', 'consum', 0.0214, 'lps'),
	(574422, 131, '2014-03-01 01:22:49.000000', 'consum', 0.0218, 'lps'),
	(574423, 131, '2014-03-01 01:22:50.000000', 'consum', 0.0220, 'lps'),
	(574424, 131, '2014-03-01 01:22:51.000000', 'consum', 0.0218, 'lps'),
	(574425, 131, '2014-03-01 01:22:52.000000', 'consum', 0.0220, 'lps'),
	(574426, 131, '2014-03-01 01:22:53.000000', 'consum', 0.0218, 'lps'),
	(574427, 131, '2014-03-01 01:22:54.000000', 'consum', 0.0220, 'lps'),
	(574428, 131, '2014-03-01 01:22:55.000000', 'consum', 0.0219, 'lps'),
	(574429, 131, '2014-03-01 01:22:56.000000', 'consum', 0.0225, 'lps'),
	(574430, 131, '2014-03-01 01:22:57.000000', 'consum', 0.0223, 'lps'),
	(574431, 131, '2014-03-01 01:22:58.000000', 'consum', 0.0214, 'lps'),
	(574432, 131, '2014-03-01 01:22:59.000000', 'consum', 0.0210, 'lps'),
	(574433, 131, '2014-03-01 01:23:00.000000', 'consum', 0.0217, 'lps'),
	(574434, 131, '2014-03-01 01:23:01.000000', 'consum', 0.0210, 'lps'),
	(574435, 131, '2014-03-01 01:23:02.000000', 'consum', 0.0223, 'lps'),
	(574436, 131, '2014-03-01 01:23:03.000000', 'consum', 0.0223, 'lps'),
	(574437, 131, '2014-03-01 01:23:04.000000', 'consum', 0.0220, 'lps'),
	(574438, 131, '2014-03-01 01:23:05.000000', 'consum', 0.0221, 'lps'),
	(574439, 131, '2014-03-01 01:23:06.000000', 'consum', 0.0219, 'lps'),
	(574440, 131, '2014-03-01 01:23:07.000000', 'consum', 0.0219, 'lps'),
	(574441, 131, '2014-03-01 01:23:08.000000', 'consum', 0.0214, 'lps'),
	(574442, 131, '2014-03-01 01:23:09.000000', 'consum', 0.0219, 'lps'),
	(574443, 131, '2014-03-01 01:23:10.000000', 'consum', 0.0226, 'lps'),
	(574444, 131, '2014-03-01 01:23:11.000000', 'consum', 0.0227, 'lps'),
	(574445, 131, '2014-03-01 01:23:12.000000', 'consum', 0.0210, 'lps'),
	(574446, 131, '2014-03-01 01:23:13.000000', 'consum', 0.0216, 'lps'),
	(574447, 131, '2014-03-01 01:23:14.000000', 'consum', 0.0223, 'lps'),
	(574448, 131, '2014-03-01 01:23:15.000000', 'consum', 0.0219, 'lps'),
	(574449, 131, '2014-03-01 01:23:16.000000', 'consum', 0.0218, 'lps'),
	(574450, 131, '2014-03-01 01:23:17.000000', 'consum', 0.0221, 'lps'),
	(574451, 131, '2014-03-01 01:23:18.000000', 'consum', 0.0226, 'lps'),
	(574452, 131, '2014-03-01 01:23:19.000000', 'consum', 0.0219, 'lps'),
	(574453, 131, '2014-03-01 01:23:20.000000', 'consum', 0.0226, 'lps'),
	(574454, 131, '2014-03-01 01:23:21.000000', 'consum', 0.0210, 'lps'),
	(574455, 131, '2014-03-01 01:23:22.000000', 'consum', 0.0218, 'lps'),
	(574456, 131, '2014-03-01 01:23:23.000000', 'consum', 0.0212, 'lps'),
	(574457, 131, '2014-03-01 01:23:24.000000', 'consum', 0.0215, 'lps'),
	(574458, 131, '2014-03-01 01:23:25.000000', 'consum', 0.0213, 'lps'),
	(574459, 131, '2014-03-01 01:23:26.000000', 'consum', 0.0210, 'lps'),
	(574460, 131, '2014-03-01 01:23:27.000000', 'consum', 0.0221, 'lps'),
	(574461, 131, '2014-03-01 01:23:28.000000', 'consum', 0.0211, 'lps'),
	(574462, 131, '2014-03-01 01:23:29.000000', 'consum', 0.0217, 'lps'),
	(574463, 131, '2014-03-01 01:23:30.000000', 'consum', 0.0226, 'lps'),
	(574464, 131, '2014-03-01 01:23:31.000000', 'consum', 0.0214, 'lps'),
	(574465, 131, '2014-03-01 01:23:32.000000', 'consum', 0.0220, 'lps'),
	(574466, 131, '2014-03-01 01:23:33.000000', 'consum', 0.0212, 'lps'),
	(574467, 131, '2014-03-01 01:23:34.000000', 'consum', 0.0224, 'lps'),
	(574468, 131, '2014-03-01 01:23:35.000000', 'consum', 0.0223, 'lps'),
	(574469, 131, '2014-03-01 01:23:36.000000', 'consum', 0.0217, 'lps'),
	(574470, 131, '2014-03-01 01:23:37.000000', 'consum', 0.0223, 'lps'),
	(574471, 131, '2014-03-01 01:23:38.000000', 'consum', 0.0220, 'lps'),
	(574472, 131, '2014-03-01 01:23:39.000000', 'consum', 0.0220, 'lps'),
	(574473, 131, '2014-03-01 01:23:40.000000', 'consum', 0.0212, 'lps'),
	(574474, 131, '2014-03-01 01:23:41.000000', 'consum', 0.0227, 'lps'),
	(574475, 131, '2014-03-01 01:23:42.000000', 'consum', 0.0216, 'lps'),
	(574476, 131, '2014-03-01 01:23:43.000000', 'consum', 0.0227, 'lps'),
	(574477, 131, '2014-03-01 01:23:44.000000', 'consum', 0.0225, 'lps'),
	(574478, 131, '2014-03-01 01:23:45.000000', 'consum', 0.0214, 'lps'),
	(574479, 131, '2014-03-01 01:23:46.000000', 'consum', 0.0223, 'lps'),
	(574480, 131, '2014-03-01 01:23:47.000000', 'consum', 0.0226, 'lps'),
	(574481, 131, '2014-03-01 01:23:48.000000', 'consum', 0.0215, 'lps'),
	(574482, 131, '2014-03-01 01:23:49.000000', 'consum', 0.0223, 'lps'),
	(574483, 131, '2014-03-01 01:23:50.000000', 'consum', 0.0225, 'lps'),
	(574484, 131, '2014-03-01 01:23:51.000000', 'consum', 0.0212, 'lps'),
	(574485, 131, '2014-03-01 01:23:52.000000', 'consum', 0.0210, 'lps'),
	(574486, 131, '2014-03-01 01:23:53.000000', 'consum', 0.0223, 'lps'),
	(574487, 131, '2014-03-01 01:23:54.000000', 'consum', 0.0221, 'lps'),
	(574488, 131, '2014-03-01 01:23:55.000000', 'consum', 0.0225, 'lps'),
	(574489, 131, '2014-03-01 01:23:56.000000', 'consum', 0.0218, 'lps'),
	(574490, 131, '2014-03-01 01:23:57.000000', 'consum', 0.0224, 'lps'),
	(574491, 131, '2014-03-01 01:23:58.000000', 'consum', 0.0219, 'lps'),
	(574492, 131, '2014-03-01 01:23:59.000000', 'consum', 0.0215, 'lps'),
	(574493, 131, '2014-03-01 01:24:00.000000', 'consum', 0.0227, 'lps'),
	(574494, 131, '2014-03-01 01:24:01.000000', 'consum', 0.0227, 'lps'),
	(574495, 131, '2014-03-01 01:24:02.000000', 'consum', 0.0210, 'lps'),
	(574496, 131, '2014-03-01 01:24:03.000000', 'consum', 0.0210, 'lps'),
	(574497, 131, '2014-03-01 01:24:04.000000', 'consum', 0.0211, 'lps'),
	(574498, 131, '2014-03-01 01:24:05.000000', 'consum', 0.0215, 'lps'),
	(574499, 131, '2014-03-01 01:24:06.000000', 'consum', 0.0217, 'lps'),
	(574500, 131, '2014-03-01 01:24:07.000000', 'consum', 0.0211, 'lps'),
	(574501, 131, '2014-03-01 01:24:08.000000', 'consum', 0.0212, 'lps'),
	(574502, 131, '2014-03-01 01:24:09.000000', 'consum', 0.0219, 'lps'),
	(574503, 131, '2014-03-01 01:24:10.000000', 'consum', 0.0211, 'lps'),
	(574504, 131, '2014-03-01 01:24:11.000000', 'consum', 0.0225, 'lps'),
	(574505, 131, '2014-03-01 01:24:12.000000', 'consum', 0.0210, 'lps'),
	(574506, 131, '2014-03-01 01:24:13.000000', 'consum', 0.0219, 'lps'),
	(574507, 131, '2014-03-01 01:24:14.000000', 'consum', 0.0221, 'lps'),
	(574508, 131, '2014-03-01 01:24:15.000000', 'consum', 0.0219, 'lps'),
	(574509, 131, '2014-03-01 01:24:16.000000', 'consum', 0.0223, 'lps'),
	(574510, 131, '2014-03-01 01:24:17.000000', 'consum', 0.0213, 'lps'),
	(574511, 131, '2014-03-01 01:24:18.000000', 'consum', 0.0224, 'lps'),
	(574512, 131, '2014-03-01 01:24:19.000000', 'consum', 0.0217, 'lps'),
	(574513, 131, '2014-03-01 01:24:20.000000', 'consum', 0.0222, 'lps'),
	(574514, 131, '2014-03-01 01:24:21.000000', 'consum', 0.0211, 'lps'),
	(574515, 131, '2014-03-01 01:24:22.000000', 'consum', 0.0218, 'lps'),
	(574516, 131, '2014-03-01 01:24:23.000000', 'consum', 0.0210, 'lps'),
	(574517, 131, '2014-03-01 01:24:24.000000', 'consum', 0.0223, 'lps'),
	(574518, 131, '2014-03-01 01:24:25.000000', 'consum', 0.0223, 'lps'),
	(574519, 131, '2014-03-01 01:24:26.000000', 'consum', 0.0219, 'lps'),
	(574520, 131, '2014-03-01 01:24:27.000000', 'consum', 0.0215, 'lps'),
	(574521, 131, '2014-03-01 01:24:28.000000', 'consum', 0.0210, 'lps'),
	(574522, 131, '2014-03-01 01:24:29.000000', 'consum', 0.0211, 'lps'),
	(574523, 131, '2014-03-01 01:24:30.000000', 'consum', 0.0216, 'lps'),
	(574524, 131, '2014-03-01 01:24:31.000000', 'consum', 0.0220, 'lps'),
	(574525, 131, '2014-03-01 01:24:32.000000', 'consum', 0.0224, 'lps'),
	(574526, 131, '2014-03-01 01:24:33.000000', 'consum', 0.0214, 'lps'),
	(574527, 131, '2014-03-01 01:24:34.000000', 'consum', 0.0226, 'lps'),
	(574528, 131, '2014-03-01 01:24:35.000000', 'consum', 0.0225, 'lps'),
	(574529, 131, '2014-03-01 01:24:36.000000', 'consum', 0.0218, 'lps'),
	(574530, 131, '2014-03-01 01:24:37.000000', 'consum', 0.0225, 'lps'),
	(574531, 131, '2014-03-01 01:24:38.000000', 'consum', 0.0225, 'lps'),
	(574532, 131, '2014-03-01 01:24:39.000000', 'consum', 0.0224, 'lps'),
	(574533, 131, '2014-03-01 01:24:40.000000', 'consum', 0.0217, 'lps'),
	(574534, 131, '2014-03-01 01:24:41.000000', 'consum', 0.0220, 'lps'),
	(574535, 131, '2014-03-01 01:24:42.000000', 'consum', 0.0223, 'lps'),
	(574536, 131, '2014-03-01 01:24:43.000000', 'consum', 0.0225, 'lps'),
	(574537, 131, '2014-03-01 01:24:44.000000', 'consum', 0.0213, 'lps'),
	(574538, 131, '2014-03-01 01:24:45.000000', 'consum', 0.0214, 'lps'),
	(574539, 131, '2014-03-01 01:24:46.000000', 'consum', 0.0223, 'lps'),
	(574540, 131, '2014-03-01 01:24:47.000000', 'consum', 0.0210, 'lps'),
	(574541, 131, '2014-03-01 01:24:48.000000', 'consum', 0.0227, 'lps'),
	(574542, 131, '2014-03-01 01:24:49.000000', 'consum', 0.0223, 'lps'),
	(574543, 131, '2014-03-01 01:24:50.000000', 'consum', 0.0222, 'lps'),
	(574544, 131, '2014-03-01 01:24:51.000000', 'consum', 0.0214, 'lps'),
	(574545, 131, '2014-03-01 01:24:52.000000', 'consum', 0.0212, 'lps'),
	(574546, 131, '2014-03-01 01:24:53.000000', 'consum', 0.0226, 'lps'),
	(574547, 131, '2014-03-01 01:24:54.000000', 'consum', 0.0212, 'lps'),
	(574548, 131, '2014-03-01 01:24:55.000000', 'consum', 0.0210, 'lps'),
	(574549, 131, '2014-03-01 01:24:56.000000', 'consum', 0.0224, 'lps'),
	(574550, 131, '2014-03-01 01:24:57.000000', 'consum', 0.0224, 'lps'),
	(574551, 131, '2014-03-01 01:24:58.000000', 'consum', 0.0222, 'lps'),
	(574552, 131, '2014-03-01 01:24:59.000000', 'consum', 0.0210, 'lps'),
	(574553, 131, '2014-03-01 01:25:00.000000', 'consum', 0.0227, 'lps'),
	(574554, 131, '2014-03-01 01:25:01.000000', 'consum', 0.0225, 'lps'),
	(574555, 131, '2014-03-01 01:25:02.000000', 'consum', 0.0215, 'lps'),
	(574556, 131, '2014-03-01 01:25:03.000000', 'consum', 0.0227, 'lps'),
	(574557, 131, '2014-03-01 01:25:04.000000', 'consum', 0.0225, 'lps'),
	(574558, 131, '2014-03-01 01:25:05.000000', 'consum', 0.0216, 'lps'),
	(574559, 131, '2014-03-01 01:25:06.000000', 'consum', 0.0216, 'lps'),
	(574560, 131, '2014-03-01 01:25:07.000000', 'consum', 0.0223, 'lps'),
	(574561, 131, '2014-03-01 01:25:08.000000', 'consum', 0.0219, 'lps'),
	(574562, 131, '2014-03-01 01:25:09.000000', 'consum', 0.0219, 'lps'),
	(574563, 131, '2014-03-01 01:25:10.000000', 'consum', 0.0225, 'lps'),
	(574564, 131, '2014-03-01 01:25:11.000000', 'consum', 0.0226, 'lps'),
	(574565, 131, '2014-03-01 01:25:12.000000', 'consum', 0.0226, 'lps'),
	(574566, 131, '2014-03-01 01:25:13.000000', 'consum', 0.0227, 'lps'),
	(574567, 131, '2014-03-01 01:25:14.000000', 'consum', 0.0226, 'lps'),
	(574568, 131, '2014-03-01 01:25:15.000000', 'consum', 0.0223, 'lps'),
	(574569, 131, '2014-03-01 01:25:16.000000', 'consum', 0.0227, 'lps'),
	(574570, 131, '2014-03-01 01:25:17.000000', 'consum', 0.0220, 'lps'),
	(574571, 131, '2014-03-01 01:25:18.000000', 'consum', 0.0227, 'lps'),
	(574572, 131, '2014-03-01 01:25:19.000000', 'consum', 0.0212, 'lps'),
	(574573, 131, '2014-03-01 01:25:20.000000', 'consum', 0.0226, 'lps'),
	(574574, 131, '2014-03-01 01:25:21.000000', 'consum', 0.0227, 'lps'),
	(574575, 131, '2014-03-01 01:25:22.000000', 'consum', 0.0212, 'lps'),
	(574576, 131, '2014-03-01 01:25:23.000000', 'consum', 0.0222, 'lps'),
	(574577, 131, '2014-03-01 01:25:24.000000', 'consum', 0.0213, 'lps'),
	(574578, 131, '2014-03-01 01:25:25.000000', 'consum', 0.0223, 'lps'),
	(574579, 131, '2014-03-01 01:25:26.000000', 'consum', 0.0214, 'lps'),
	(574580, 131, '2014-03-01 01:25:27.000000', 'consum', 0.0227, 'lps'),
	(574581, 131, '2014-03-01 01:25:28.000000', 'consum', 0.0210, 'lps'),
	(574582, 131, '2014-03-01 01:25:29.000000', 'consum', 0.0216, 'lps'),
	(574583, 131, '2014-03-01 01:25:30.000000', 'consum', 0.0223, 'lps'),
	(574584, 131, '2014-03-01 01:25:31.000000', 'consum', 0.0220, 'lps'),
	(574585, 131, '2014-03-01 01:25:32.000000', 'consum', 0.0224, 'lps'),
	(574586, 131, '2014-03-01 01:25:33.000000', 'consum', 0.0211, 'lps'),
	(574587, 131, '2014-03-01 01:25:34.000000', 'consum', 0.0211, 'lps'),
	(574588, 131, '2014-03-01 01:25:35.000000', 'consum', 0.0213, 'lps'),
	(574589, 131, '2014-03-01 01:25:36.000000', 'consum', 0.0221, 'lps'),
	(574590, 131, '2014-03-01 01:25:37.000000', 'consum', 0.0221, 'lps'),
	(574591, 131, '2014-03-01 01:25:38.000000', 'consum', 0.0215, 'lps'),
	(574592, 131, '2014-03-01 01:25:39.000000', 'consum', 0.0219, 'lps'),
	(574593, 131, '2014-03-01 01:25:40.000000', 'consum', 0.0221, 'lps'),
	(574594, 131, '2014-03-01 01:25:41.000000', 'consum', 0.0224, 'lps'),
	(574595, 131, '2014-03-01 01:25:42.000000', 'consum', 0.0226, 'lps'),
	(574596, 131, '2014-03-01 01:25:43.000000', 'consum', 0.0215, 'lps'),
	(574597, 131, '2014-03-01 01:25:44.000000', 'consum', 0.0225, 'lps'),
	(574598, 131, '2014-03-01 01:25:45.000000', 'consum', 0.0214, 'lps'),
	(574599, 131, '2014-03-01 01:25:46.000000', 'consum', 0.0224, 'lps'),
	(574600, 131, '2014-03-01 01:25:47.000000', 'consum', 0.0215, 'lps'),
	(574601, 131, '2014-03-01 01:25:48.000000', 'consum', 0.0227, 'lps'),
	(574602, 131, '2014-03-01 01:25:49.000000', 'consum', 0.0227, 'lps'),
	(574603, 131, '2014-03-01 01:25:50.000000', 'consum', 0.0226, 'lps'),
	(574604, 131, '2014-03-01 01:25:51.000000', 'consum', 0.0223, 'lps'),
	(574605, 131, '2014-03-01 01:25:52.000000', 'consum', 0.0226, 'lps'),
	(574606, 131, '2014-03-01 01:25:53.000000', 'consum', 0.0217, 'lps'),
	(574607, 131, '2014-03-01 01:25:54.000000', 'consum', 0.0216, 'lps'),
	(574608, 131, '2014-03-01 01:25:55.000000', 'consum', 0.0218, 'lps'),
	(574609, 131, '2014-03-01 01:25:56.000000', 'consum', 0.0215, 'lps'),
	(574610, 131, '2014-03-01 01:25:57.000000', 'consum', 0.0211, 'lps'),
	(574611, 131, '2014-03-01 01:25:58.000000', 'consum', 0.0220, 'lps'),
	(574612, 131, '2014-03-01 01:25:59.000000', 'consum', 0.0220, 'lps'),
	(574613, 131, '2014-03-01 01:26:00.000000', 'consum', 0.0213, 'lps'),
	(574614, 131, '2014-03-01 01:26:01.000000', 'consum', 0.0212, 'lps'),
	(574615, 131, '2014-03-01 01:26:02.000000', 'consum', 0.0211, 'lps'),
	(574616, 131, '2014-03-01 01:26:03.000000', 'consum', 0.0212, 'lps'),
	(574617, 131, '2014-03-01 01:26:04.000000', 'consum', 0.0215, 'lps'),
	(574618, 131, '2014-03-01 01:26:05.000000', 'consum', 0.0213, 'lps'),
	(574619, 131, '2014-03-01 01:26:06.000000', 'consum', 0.0210, 'lps'),
	(574620, 131, '2014-03-01 01:26:07.000000', 'consum', 0.0221, 'lps'),
	(574621, 131, '2014-03-01 01:26:08.000000', 'consum', 0.0227, 'lps'),
	(574622, 131, '2014-03-01 01:26:09.000000', 'consum', 0.0227, 'lps'),
	(574623, 131, '2014-03-01 01:26:10.000000', 'consum', 0.0225, 'lps'),
	(574624, 131, '2014-03-01 01:26:11.000000', 'consum', 0.0219, 'lps'),
	(574625, 131, '2014-03-01 01:26:12.000000', 'consum', 0.0227, 'lps'),
	(574626, 131, '2014-03-01 01:26:13.000000', 'consum', 0.0217, 'lps'),
	(574627, 131, '2014-03-01 01:26:14.000000', 'consum', 0.0211, 'lps'),
	(574628, 131, '2014-03-01 01:26:15.000000', 'consum', 0.0214, 'lps'),
	(574629, 131, '2014-03-01 01:26:16.000000', 'consum', 0.0225, 'lps'),
	(574630, 131, '2014-03-01 01:26:17.000000', 'consum', 0.0219, 'lps'),
	(574631, 131, '2014-03-01 01:26:18.000000', 'consum', 0.0210, 'lps'),
	(574632, 131, '2014-03-01 01:26:19.000000', 'consum', 0.0219, 'lps'),
	(574633, 131, '2014-03-01 01:26:20.000000', 'consum', 0.0221, 'lps'),
	(574634, 131, '2014-03-01 01:26:21.000000', 'consum', 0.0222, 'lps'),
	(574635, 131, '2014-03-01 01:26:22.000000', 'consum', 0.0217, 'lps'),
	(574636, 131, '2014-03-01 01:26:23.000000', 'consum', 0.0211, 'lps'),
	(574637, 131, '2014-03-01 01:26:24.000000', 'consum', 0.0211, 'lps'),
	(574638, 131, '2014-03-01 01:26:25.000000', 'consum', 0.0212, 'lps'),
	(574639, 131, '2014-03-01 01:26:26.000000', 'consum', 0.0218, 'lps'),
	(574640, 131, '2014-03-01 01:26:27.000000', 'consum', 0.0225, 'lps'),
	(574641, 131, '2014-03-01 01:26:28.000000', 'consum', 0.0226, 'lps'),
	(574642, 131, '2014-03-01 01:26:29.000000', 'consum', 0.0212, 'lps'),
	(574643, 131, '2014-03-01 01:26:30.000000', 'consum', 0.0223, 'lps'),
	(574644, 131, '2014-03-01 01:26:31.000000', 'consum', 0.0218, 'lps'),
	(574645, 131, '2014-03-01 01:26:32.000000', 'consum', 0.0213, 'lps'),
	(574646, 131, '2014-03-01 01:26:33.000000', 'consum', 0.0216, 'lps'),
	(574647, 131, '2014-03-01 01:26:34.000000', 'consum', 0.0215, 'lps'),
	(574648, 131, '2014-03-01 01:26:35.000000', 'consum', 0.0217, 'lps'),
	(574649, 131, '2014-03-01 01:26:36.000000', 'consum', 0.0211, 'lps'),
	(574650, 131, '2014-03-01 01:26:37.000000', 'consum', 0.0215, 'lps'),
	(574651, 131, '2014-03-01 01:26:38.000000', 'consum', 0.0212, 'lps'),
	(574652, 131, '2014-03-01 01:26:39.000000', 'consum', 0.0225, 'lps'),
	(574653, 131, '2014-03-01 01:26:40.000000', 'consum', 0.0226, 'lps'),
	(574654, 131, '2014-03-01 01:26:41.000000', 'consum', 0.0226, 'lps'),
	(574655, 131, '2014-03-01 01:26:42.000000', 'consum', 0.0223, 'lps'),
	(574656, 131, '2014-03-01 01:26:43.000000', 'consum', 0.0212, 'lps'),
	(574657, 131, '2014-03-01 01:26:44.000000', 'consum', 0.0219, 'lps'),
	(574658, 131, '2014-03-01 01:26:45.000000', 'consum', 0.0211, 'lps'),
	(574659, 131, '2014-03-01 01:26:46.000000', 'consum', 0.0224, 'lps'),
	(574660, 131, '2014-03-01 01:26:47.000000', 'consum', 0.0223, 'lps'),
	(574661, 131, '2014-03-01 01:26:48.000000', 'consum', 0.0217, 'lps'),
	(574662, 131, '2014-03-01 01:26:49.000000', 'consum', 0.0223, 'lps'),
	(574663, 131, '2014-03-01 01:26:50.000000', 'consum', 0.0220, 'lps'),
	(574664, 131, '2014-03-01 01:26:51.000000', 'consum', 0.0220, 'lps'),
	(574665, 131, '2014-03-01 01:26:52.000000', 'consum', 0.0214, 'lps'),
	(574666, 131, '2014-03-01 01:26:53.000000', 'consum', 0.0219, 'lps'),
	(574667, 131, '2014-03-01 01:26:54.000000', 'consum', 0.0223, 'lps'),
	(574668, 131, '2014-03-01 01:26:55.000000', 'consum', 0.0215, 'lps'),
	(574669, 131, '2014-03-01 01:26:56.000000', 'consum', 0.0214, 'lps'),
	(574670, 131, '2014-03-01 01:26:57.000000', 'consum', 0.0216, 'lps'),
	(574671, 131, '2014-03-01 01:26:58.000000', 'consum', 0.0211, 'lps'),
	(574672, 131, '2014-03-01 01:26:59.000000', 'consum', 0.0217, 'lps'),
	(574673, 131, '2014-03-01 01:27:00.000000', 'consum', 0.0221, 'lps'),
	(574674, 131, '2014-03-01 01:27:01.000000', 'consum', 0.0210, 'lps'),
	(574675, 131, '2014-03-01 01:27:02.000000', 'consum', 0.0215, 'lps'),
	(574676, 131, '2014-03-01 01:27:03.000000', 'consum', 0.0216, 'lps'),
	(574677, 131, '2014-03-01 01:27:04.000000', 'consum', 0.0226, 'lps'),
	(574678, 131, '2014-03-01 01:27:05.000000', 'consum', 0.0217, 'lps'),
	(574679, 131, '2014-03-01 01:27:06.000000', 'consum', 0.0216, 'lps'),
	(574680, 131, '2014-03-01 01:27:07.000000', 'consum', 0.0221, 'lps'),
	(574681, 131, '2014-03-01 01:27:08.000000', 'consum', 0.0210, 'lps'),
	(574682, 131, '2014-03-01 01:27:09.000000', 'consum', 0.0215, 'lps'),
	(574683, 131, '2014-03-01 01:27:10.000000', 'consum', 0.0216, 'lps'),
	(574684, 131, '2014-03-01 01:27:11.000000', 'consum', 0.0210, 'lps'),
	(574685, 131, '2014-03-01 01:27:12.000000', 'consum', 0.0225, 'lps'),
	(574686, 131, '2014-03-01 01:27:13.000000', 'consum', 0.0216, 'lps'),
	(574687, 131, '2014-03-01 01:27:14.000000', 'consum', 0.0213, 'lps'),
	(574688, 131, '2014-03-01 01:27:15.000000', 'consum', 0.0227, 'lps'),
	(574689, 131, '2014-03-01 01:27:16.000000', 'consum', 0.0213, 'lps'),
	(574690, 131, '2014-03-01 01:27:17.000000', 'consum', 0.0210, 'lps'),
	(574691, 131, '2014-03-01 01:27:18.000000', 'consum', 0.0219, 'lps'),
	(574692, 131, '2014-03-01 01:27:19.000000', 'consum', 0.0222, 'lps'),
	(574693, 131, '2014-03-01 01:27:20.000000', 'consum', 0.0222, 'lps'),
	(574694, 131, '2014-03-01 01:27:21.000000', 'consum', 0.0219, 'lps'),
	(574695, 131, '2014-03-01 01:27:22.000000', 'consum', 0.0219, 'lps'),
	(574696, 131, '2014-03-01 01:27:23.000000', 'consum', 0.0211, 'lps'),
	(574697, 131, '2014-03-01 01:27:24.000000', 'consum', 0.0223, 'lps'),
	(574698, 131, '2014-03-01 01:27:25.000000', 'consum', 0.0219, 'lps'),
	(574699, 131, '2014-03-01 01:27:26.000000', 'consum', 0.0215, 'lps'),
	(574700, 131, '2014-03-01 01:27:27.000000', 'consum', 0.0212, 'lps'),
	(574701, 131, '2014-03-01 01:27:28.000000', 'consum', 0.0220, 'lps'),
	(574702, 131, '2014-03-01 01:27:29.000000', 'consum', 0.0219, 'lps'),
	(574703, 131, '2014-03-01 01:27:30.000000', 'consum', 0.0227, 'lps'),
	(574704, 131, '2014-03-01 01:27:31.000000', 'consum', 0.0212, 'lps'),
	(574705, 131, '2014-03-01 01:27:32.000000', 'consum', 0.0224, 'lps'),
	(574706, 131, '2014-03-01 01:27:33.000000', 'consum', 0.0221, 'lps'),
	(574707, 131, '2014-03-01 01:27:34.000000', 'consum', 0.0223, 'lps'),
	(574708, 131, '2014-03-01 01:27:35.000000', 'consum', 0.0225, 'lps'),
	(574709, 131, '2014-03-01 01:27:36.000000', 'consum', 0.0227, 'lps'),
	(574710, 131, '2014-03-01 01:27:37.000000', 'consum', 0.0213, 'lps'),
	(574711, 131, '2014-03-01 01:27:38.000000', 'consum', 0.0214, 'lps'),
	(574712, 131, '2014-03-01 01:27:39.000000', 'consum', 0.0219, 'lps'),
	(574713, 131, '2014-03-01 01:27:40.000000', 'consum', 0.0210, 'lps'),
	(574714, 131, '2014-03-01 01:27:41.000000', 'consum', 0.0220, 'lps'),
	(574715, 131, '2014-03-01 01:27:42.000000', 'consum', 0.0224, 'lps'),
	(574716, 131, '2014-03-01 01:27:43.000000', 'consum', 0.0213, 'lps'),
	(574717, 131, '2014-03-01 01:27:44.000000', 'consum', 0.0220, 'lps'),
	(574718, 131, '2014-03-01 01:27:45.000000', 'consum', 0.0217, 'lps'),
	(574719, 131, '2014-03-01 01:27:46.000000', 'consum', 0.0215, 'lps'),
	(574720, 131, '2014-03-01 01:27:47.000000', 'consum', 0.0214, 'lps'),
	(574721, 131, '2014-03-01 01:27:48.000000', 'consum', 0.0214, 'lps'),
	(574722, 131, '2014-03-01 01:27:49.000000', 'consum', 0.0221, 'lps'),
	(574723, 131, '2014-03-01 01:27:50.000000', 'consum', 0.0216, 'lps'),
	(574724, 131, '2014-03-01 01:27:51.000000', 'consum', 0.0210, 'lps'),
	(574725, 131, '2014-03-01 01:27:52.000000', 'consum', 0.0226, 'lps'),
	(574726, 131, '2014-03-01 01:27:53.000000', 'consum', 0.0220, 'lps'),
	(574727, 131, '2014-03-01 01:27:54.000000', 'consum', 0.0211, 'lps'),
	(574728, 131, '2014-03-01 01:27:55.000000', 'consum', 0.0222, 'lps'),
	(574729, 131, '2014-03-01 01:27:56.000000', 'consum', 0.0214, 'lps'),
	(574730, 131, '2014-03-01 01:27:57.000000', 'consum', 0.0210, 'lps'),
	(574731, 131, '2014-03-01 01:27:58.000000', 'consum', 0.0219, 'lps'),
	(574732, 131, '2014-03-01 01:27:59.000000', 'consum', 0.0219, 'lps'),
	(574733, 131, '2014-03-01 01:28:00.000000', 'consum', 0.0226, 'lps'),
	(574734, 131, '2014-03-01 01:28:01.000000', 'consum', 0.0213, 'lps'),
	(574735, 131, '2014-03-01 01:28:02.000000', 'consum', 0.0212, 'lps'),
	(574736, 131, '2014-03-01 01:28:03.000000', 'consum', 0.0211, 'lps'),
	(574737, 131, '2014-03-01 01:28:04.000000', 'consum', 0.0210, 'lps'),
	(574738, 131, '2014-03-01 01:28:05.000000', 'consum', 0.0210, 'lps'),
	(574739, 131, '2014-03-01 01:28:06.000000', 'consum', 0.0225, 'lps'),
	(574740, 131, '2014-03-01 01:28:07.000000', 'consum', 0.0214, 'lps'),
	(574741, 131, '2014-03-01 01:28:08.000000', 'consum', 0.0224, 'lps'),
	(574742, 131, '2014-03-01 01:28:09.000000', 'consum', 0.0213, 'lps'),
	(574743, 131, '2014-03-01 01:28:10.000000', 'consum', 0.0217, 'lps'),
	(574744, 131, '2014-03-01 01:28:11.000000', 'consum', 0.0222, 'lps'),
	(574745, 131, '2014-03-01 01:28:12.000000', 'consum', 0.0214, 'lps'),
	(574746, 131, '2014-03-01 01:28:13.000000', 'consum', 0.0211, 'lps'),
	(574747, 131, '2014-03-01 01:28:14.000000', 'consum', 0.0222, 'lps'),
	(574748, 131, '2014-03-01 01:28:15.000000', 'consum', 0.0214, 'lps'),
	(574749, 131, '2014-03-01 01:28:16.000000', 'consum', 0.0211, 'lps'),
	(574750, 131, '2014-03-01 01:28:17.000000', 'consum', 0.0222, 'lps'),
	(574751, 131, '2014-03-01 01:28:18.000000', 'consum', 0.0214, 'lps'),
	(574752, 131, '2014-03-01 01:28:19.000000', 'consum', 0.0214, 'lps'),
	(574753, 131, '2014-03-01 01:28:20.000000', 'consum', 0.0217, 'lps'),
	(574754, 131, '2014-03-01 01:28:21.000000', 'consum', 0.0215, 'lps'),
	(574755, 131, '2014-03-01 01:28:22.000000', 'consum', 0.0215, 'lps'),
	(574756, 131, '2014-03-01 01:28:23.000000', 'consum', 0.0220, 'lps'),
	(574757, 131, '2014-03-01 01:28:24.000000', 'consum', 0.0226, 'lps'),
	(574758, 131, '2014-03-01 01:28:25.000000', 'consum', 0.0225, 'lps'),
	(574759, 131, '2014-03-01 01:28:26.000000', 'consum', 0.0218, 'lps'),
	(574760, 131, '2014-03-01 01:28:27.000000', 'consum', 0.0226, 'lps'),
	(574761, 131, '2014-03-01 01:28:28.000000', 'consum', 0.0213, 'lps'),
	(574762, 131, '2014-03-01 01:28:29.000000', 'consum', 0.0213, 'lps'),
	(574763, 131, '2014-03-01 01:28:30.000000', 'consum', 0.0217, 'lps'),
	(574764, 131, '2014-03-01 01:28:31.000000', 'consum', 0.0218, 'lps'),
	(574765, 131, '2014-03-01 01:28:32.000000', 'consum', 0.0211, 'lps'),
	(574766, 131, '2014-03-01 01:28:33.000000', 'consum', 0.0211, 'lps'),
	(574767, 131, '2014-03-01 01:28:34.000000', 'consum', 0.0213, 'lps'),
	(574768, 131, '2014-03-01 01:28:35.000000', 'consum', 0.0223, 'lps'),
	(574769, 131, '2014-03-01 01:28:36.000000', 'consum', 0.0211, 'lps'),
	(574770, 131, '2014-03-01 01:28:37.000000', 'consum', 0.0211, 'lps'),
	(574771, 131, '2014-03-01 01:28:38.000000', 'consum', 0.0214, 'lps'),
	(574772, 131, '2014-03-01 01:28:39.000000', 'consum', 0.0227, 'lps'),
	(574773, 131, '2014-03-01 01:28:40.000000', 'consum', 0.0211, 'lps'),
	(574774, 131, '2014-03-01 01:28:41.000000', 'consum', 0.0219, 'lps'),
	(574775, 131, '2014-03-01 01:28:42.000000', 'consum', 0.0217, 'lps'),
	(574776, 131, '2014-03-01 01:28:43.000000', 'consum', 0.0219, 'lps'),
	(574777, 131, '2014-03-01 01:28:44.000000', 'consum', 0.0214, 'lps'),
	(574778, 131, '2014-03-01 01:28:45.000000', 'consum', 0.0223, 'lps'),
	(574779, 131, '2014-03-01 01:28:46.000000', 'consum', 0.0211, 'lps'),
	(574780, 131, '2014-03-01 01:28:47.000000', 'consum', 0.0213, 'lps'),
	(574781, 131, '2014-03-01 01:28:48.000000', 'consum', 0.0221, 'lps'),
	(574782, 131, '2014-03-01 01:28:49.000000', 'consum', 0.0222, 'lps'),
	(574783, 131, '2014-03-01 01:28:50.000000', 'consum', 0.0217, 'lps'),
	(574784, 131, '2014-03-01 01:28:51.000000', 'consum', 0.0212, 'lps'),
	(574785, 131, '2014-03-01 01:28:52.000000', 'consum', 0.0218, 'lps'),
	(574786, 131, '2014-03-01 01:28:53.000000', 'consum', 0.0227, 'lps'),
	(574787, 131, '2014-03-01 01:28:54.000000', 'consum', 0.0216, 'lps'),
	(574788, 131, '2014-03-01 01:28:55.000000', 'consum', 0.0224, 'lps'),
	(574789, 131, '2014-03-01 01:28:56.000000', 'consum', 0.0210, 'lps'),
	(574790, 131, '2014-03-01 01:28:57.000000', 'consum', 0.0220, 'lps'),
	(574791, 131, '2014-03-01 01:28:58.000000', 'consum', 0.0227, 'lps'),
	(574792, 131, '2014-03-01 01:28:59.000000', 'consum', 0.0213, 'lps'),
	(574793, 131, '2014-03-01 01:29:00.000000', 'consum', 0.0226, 'lps'),
	(574794, 131, '2014-03-01 01:29:01.000000', 'consum', 0.0212, 'lps'),
	(574795, 131, '2014-03-01 01:29:02.000000', 'consum', 0.0224, 'lps'),
	(574796, 131, '2014-03-01 01:29:03.000000', 'consum', 0.0223, 'lps'),
	(574797, 131, '2014-03-01 01:29:04.000000', 'consum', 0.0214, 'lps'),
	(574798, 131, '2014-03-01 01:29:05.000000', 'consum', 0.0227, 'lps'),
	(574799, 131, '2014-03-01 01:29:06.000000', 'consum', 0.0210, 'lps'),
	(574800, 131, '2014-03-01 01:29:07.000000', 'consum', 0.0216, 'lps'),
	(574801, 131, '2014-03-01 01:29:08.000000', 'consum', 0.0220, 'lps'),
	(574802, 131, '2014-03-01 01:29:09.000000', 'consum', 0.0226, 'lps'),
	(574803, 131, '2014-03-01 01:29:10.000000', 'consum', 0.0222, 'lps'),
	(574804, 131, '2014-03-01 01:29:11.000000', 'consum', 0.0226, 'lps'),
	(574805, 131, '2014-03-01 01:29:12.000000', 'consum', 0.0216, 'lps'),
	(574806, 131, '2014-03-01 01:29:13.000000', 'consum', 0.0227, 'lps'),
	(574807, 131, '2014-03-01 01:29:14.000000', 'consum', 0.0227, 'lps'),
	(574808, 131, '2014-03-01 01:29:15.000000', 'consum', 0.0224, 'lps'),
	(574809, 131, '2014-03-01 01:29:16.000000', 'consum', 0.0212, 'lps'),
	(574810, 131, '2014-03-01 01:29:17.000000', 'consum', 0.0216, 'lps'),
	(574811, 131, '2014-03-01 01:29:18.000000', 'consum', 0.0215, 'lps'),
	(574812, 131, '2014-03-01 01:29:19.000000', 'consum', 0.0220, 'lps'),
	(574813, 131, '2014-03-01 01:29:20.000000', 'consum', 0.0226, 'lps'),
	(574814, 131, '2014-03-01 01:29:21.000000', 'consum', 0.0225, 'lps'),
	(574815, 131, '2014-03-01 01:29:22.000000', 'consum', 0.0219, 'lps'),
	(574816, 131, '2014-03-01 01:29:23.000000', 'consum', 0.0211, 'lps'),
	(574817, 131, '2014-03-01 01:29:24.000000', 'consum', 0.0222, 'lps'),
	(574818, 131, '2014-03-01 01:29:25.000000', 'consum', 0.0217, 'lps'),
	(574819, 131, '2014-03-01 01:29:26.000000', 'consum', 0.0227, 'lps'),
	(574820, 131, '2014-03-01 01:29:27.000000', 'consum', 0.0219, 'lps'),
	(574821, 131, '2014-03-01 01:29:28.000000', 'consum', 0.0223, 'lps'),
	(574822, 131, '2014-03-01 01:29:29.000000', 'consum', 0.0215, 'lps'),
	(574823, 131, '2014-03-01 01:29:30.000000', 'consum', 0.0211, 'lps'),
	(574824, 131, '2014-03-01 01:29:31.000000', 'consum', 0.0222, 'lps'),
	(574825, 131, '2014-03-01 01:29:32.000000', 'consum', 0.0211, 'lps'),
	(574826, 131, '2014-03-01 01:29:33.000000', 'consum', 0.0214, 'lps'),
	(574827, 131, '2014-03-01 01:29:34.000000', 'consum', 0.0213, 'lps'),
	(574828, 131, '2014-03-01 01:29:35.000000', 'consum', 0.0210, 'lps'),
	(574829, 131, '2014-03-01 01:29:36.000000', 'consum', 0.0223, 'lps'),
	(574830, 131, '2014-03-01 01:29:37.000000', 'consum', 0.0220, 'lps'),
	(574831, 131, '2014-03-01 01:29:38.000000', 'consum', 0.0220, 'lps'),
	(574832, 131, '2014-03-01 01:29:39.000000', 'consum', 0.0214, 'lps'),
	(574833, 131, '2014-03-01 01:29:40.000000', 'consum', 0.0220, 'lps'),
	(574834, 131, '2014-03-01 01:29:41.000000', 'consum', 0.0212, 'lps'),
	(574835, 131, '2014-03-01 01:29:42.000000', 'consum', 0.0210, 'lps'),
	(574836, 131, '2014-03-01 01:29:43.000000', 'consum', 0.0221, 'lps'),
	(574837, 131, '2014-03-01 01:29:44.000000', 'consum', 0.0210, 'lps'),
	(574838, 131, '2014-03-01 01:29:45.000000', 'consum', 0.0216, 'lps'),
	(574839, 131, '2014-03-01 01:29:46.000000', 'consum', 0.0220, 'lps'),
	(574840, 131, '2014-03-01 01:29:47.000000', 'consum', 0.0225, 'lps'),
	(574841, 131, '2014-03-01 01:29:48.000000', 'consum', 0.0220, 'lps'),
	(574842, 131, '2014-03-01 01:29:49.000000', 'consum', 0.0216, 'lps'),
	(574843, 131, '2014-03-01 01:29:50.000000', 'consum', 0.0210, 'lps'),
	(574844, 131, '2014-03-01 01:29:51.000000', 'consum', 0.0211, 'lps'),
	(574845, 131, '2014-03-01 01:29:52.000000', 'consum', 0.0216, 'lps'),
	(574846, 131, '2014-03-01 01:29:53.000000', 'consum', 0.0220, 'lps'),
	(574847, 131, '2014-03-01 01:29:54.000000', 'consum', 0.0223, 'lps'),
	(574848, 131, '2014-03-01 01:29:55.000000', 'consum', 0.0227, 'lps'),
	(574849, 131, '2014-03-01 01:29:56.000000', 'consum', 0.0223, 'lps'),
	(574850, 131, '2014-03-01 01:29:57.000000', 'consum', 0.0222, 'lps'),
	(574851, 131, '2014-03-01 01:29:58.000000', 'consum', 0.0216, 'lps'),
	(574852, 131, '2014-03-01 01:29:59.000000', 'consum', 0.0220, 'lps'),
	(574853, 131, '2014-03-01 01:30:00.000000', 'consum', 0.0227, 'lps'),
	(574854, 131, '2014-03-01 01:30:01.000000', 'consum', 0.0211, 'lps'),
	(574855, 131, '2014-03-01 01:30:02.000000', 'consum', 0.0218, 'lps'),
	(574856, 131, '2014-03-01 01:30:03.000000', 'consum', 0.0210, 'lps'),
	(574857, 131, '2014-03-01 01:30:04.000000', 'consum', 0.0225, 'lps'),
	(574858, 131, '2014-03-01 01:30:05.000000', 'consum', 0.0211, 'lps'),
	(574859, 131, '2014-03-01 01:30:06.000000', 'consum', 0.0226, 'lps'),
	(574860, 131, '2014-03-01 01:30:07.000000', 'consum', 0.0216, 'lps'),
	(574861, 131, '2014-03-01 01:30:08.000000', 'consum', 0.0227, 'lps'),
	(574862, 131, '2014-03-01 01:30:09.000000', 'consum', 0.0223, 'lps'),
	(574863, 131, '2014-03-01 01:30:10.000000', 'consum', 0.0225, 'lps'),
	(574864, 131, '2014-03-01 01:30:11.000000', 'consum', 0.0213, 'lps'),
	(574865, 131, '2014-03-01 01:30:12.000000', 'consum', 0.0214, 'lps'),
	(574866, 131, '2014-03-01 01:30:13.000000', 'consum', 0.0220, 'lps'),
	(574867, 131, '2014-03-01 01:30:14.000000', 'consum', 0.0215, 'lps'),
	(574868, 131, '2014-03-01 01:30:15.000000', 'consum', 0.0222, 'lps'),
	(574869, 131, '2014-03-01 01:30:16.000000', 'consum', 0.0220, 'lps'),
	(574870, 131, '2014-03-01 01:30:17.000000', 'consum', 0.0225, 'lps'),
	(574871, 131, '2014-03-01 01:30:18.000000', 'consum', 0.0220, 'lps'),
	(574872, 131, '2014-03-01 01:30:19.000000', 'consum', 0.0216, 'lps'),
	(574873, 131, '2014-03-01 01:30:20.000000', 'consum', 0.0210, 'lps'),
	(574874, 131, '2014-03-01 01:30:21.000000', 'consum', 0.0212, 'lps'),
	(574875, 131, '2014-03-01 01:30:22.000000', 'consum', 0.0219, 'lps'),
	(574876, 131, '2014-03-01 01:30:23.000000', 'consum', 0.0213, 'lps'),
	(574877, 131, '2014-03-01 01:30:24.000000', 'consum', 0.0219, 'lps'),
	(574878, 131, '2014-03-01 01:30:25.000000', 'consum', 0.0227, 'lps'),
	(574879, 131, '2014-03-01 01:30:26.000000', 'consum', 0.0216, 'lps'),
	(574880, 131, '2014-03-01 01:30:27.000000', 'consum', 0.0223, 'lps'),
	(574881, 131, '2014-03-01 01:30:28.000000', 'consum', 0.0223, 'lps'),
	(574882, 131, '2014-03-01 01:30:29.000000', 'consum', 0.0220, 'lps'),
	(574883, 131, '2014-03-01 01:30:30.000000', 'consum', 0.0220, 'lps'),
	(574884, 131, '2014-03-01 01:30:31.000000', 'consum', 0.0213, 'lps'),
	(574885, 131, '2014-03-01 01:30:32.000000', 'consum', 0.0215, 'lps'),
	(574886, 131, '2014-03-01 01:30:33.000000', 'consum', 0.0224, 'lps'),
	(574887, 131, '2014-03-01 01:30:34.000000', 'consum', 0.0213, 'lps'),
	(574888, 131, '2014-03-01 01:30:35.000000', 'consum', 0.0218, 'lps'),
	(574889, 131, '2014-03-01 01:30:36.000000', 'consum', 0.0225, 'lps'),
	(574890, 131, '2014-03-01 01:30:37.000000', 'consum', 0.0224, 'lps'),
	(574891, 131, '2014-03-01 01:30:38.000000', 'consum', 0.0218, 'lps'),
	(574892, 131, '2014-03-01 01:30:39.000000', 'consum', 0.0225, 'lps'),
	(574893, 131, '2014-03-01 01:30:40.000000', 'consum', 0.0226, 'lps'),
	(574894, 131, '2014-03-01 01:30:41.000000', 'consum', 0.0212, 'lps'),
	(574895, 131, '2014-03-01 01:30:42.000000', 'consum', 0.0225, 'lps'),
	(574896, 131, '2014-03-01 01:30:43.000000', 'consum', 0.0226, 'lps'),
	(574897, 131, '2014-03-01 01:30:44.000000', 'consum', 0.0226, 'lps'),
	(574898, 131, '2014-03-01 01:30:45.000000', 'consum', 0.0226, 'lps'),
	(574899, 131, '2014-03-01 01:30:46.000000', 'consum', 0.0225, 'lps'),
	(574900, 131, '2014-03-01 01:30:47.000000', 'consum', 0.0217, 'lps'),
	(574901, 131, '2014-03-01 01:30:48.000000', 'consum', 0.0222, 'lps'),
	(574902, 131, '2014-03-01 01:30:49.000000', 'consum', 0.0211, 'lps'),
	(574903, 131, '2014-03-01 01:30:50.000000', 'consum', 0.0218, 'lps'),
	(574904, 131, '2014-03-01 01:30:51.000000', 'consum', 0.0211, 'lps'),
	(574905, 131, '2014-03-01 01:30:52.000000', 'consum', 0.0227, 'lps'),
	(574906, 131, '2014-03-01 01:30:53.000000', 'consum', 0.0219, 'lps'),
	(574907, 131, '2014-03-01 01:30:54.000000', 'consum', 0.0224, 'lps'),
	(574908, 131, '2014-03-01 01:30:55.000000', 'consum', 0.0219, 'lps'),
	(574909, 131, '2014-03-01 01:30:56.000000', 'consum', 0.0213, 'lps'),
	(574910, 131, '2014-03-01 01:30:57.000000', 'consum', 0.0217, 'lps'),
	(574911, 131, '2014-03-01 01:30:58.000000', 'consum', 0.0219, 'lps'),
	(574912, 131, '2014-03-01 01:30:59.000000', 'consum', 0.0216, 'lps'),
	(574913, 131, '2014-03-01 01:31:00.000000', 'consum', 0.0212, 'lps'),
	(574914, 131, '2014-03-01 01:31:01.000000', 'consum', 0.0220, 'lps'),
	(574915, 131, '2014-03-01 01:31:02.000000', 'consum', 0.0221, 'lps'),
	(574916, 131, '2014-03-01 01:31:03.000000', 'consum', 0.0216, 'lps'),
	(574917, 131, '2014-03-01 01:31:04.000000', 'consum', 0.0227, 'lps'),
	(574918, 131, '2014-03-01 01:31:05.000000', 'consum', 0.0221, 'lps'),
	(574919, 131, '2014-03-01 01:31:06.000000', 'consum', 0.0216, 'lps'),
	(574920, 131, '2014-03-01 01:31:07.000000', 'consum', 0.0225, 'lps'),
	(574921, 131, '2014-03-01 01:31:08.000000', 'consum', 0.0215, 'lps'),
	(574922, 131, '2014-03-01 01:31:09.000000', 'consum', 0.0225, 'lps'),
	(574923, 131, '2014-03-01 01:31:10.000000', 'consum', 0.0215, 'lps'),
	(574924, 131, '2014-03-01 01:31:11.000000', 'consum', 0.0210, 'lps'),
	(574925, 131, '2014-03-01 01:31:12.000000', 'consum', 0.0213, 'lps'),
	(574926, 131, '2014-03-01 01:31:13.000000', 'consum', 0.0224, 'lps'),
	(574927, 131, '2014-03-01 01:31:14.000000', 'consum', 0.0218, 'lps'),
	(574928, 131, '2014-03-01 01:31:15.000000', 'consum', 0.0225, 'lps'),
	(574929, 131, '2014-03-01 01:31:16.000000', 'consum', 0.0211, 'lps'),
	(574930, 131, '2014-03-01 01:31:17.000000', 'consum', 0.0223, 'lps'),
	(574931, 131, '2014-03-01 01:31:18.000000', 'consum', 0.0218, 'lps'),
	(574932, 131, '2014-03-01 01:31:19.000000', 'consum', 0.0210, 'lps'),
	(574933, 131, '2014-03-01 01:31:20.000000', 'consum', 0.0225, 'lps'),
	(574934, 131, '2014-03-01 01:31:21.000000', 'consum', 0.0214, 'lps'),
	(574935, 131, '2014-03-01 01:31:22.000000', 'consum', 0.0222, 'lps'),
	(574936, 131, '2014-03-01 01:31:23.000000', 'consum', 0.0222, 'lps'),
	(574937, 131, '2014-03-01 01:31:24.000000', 'consum', 0.0217, 'lps'),
	(574938, 131, '2014-03-01 01:31:25.000000', 'consum', 0.0210, 'lps'),
	(574939, 131, '2014-03-01 01:31:26.000000', 'consum', 0.0227, 'lps'),
	(574940, 131, '2014-03-01 01:31:27.000000', 'consum', 0.0221, 'lps'),
	(574941, 131, '2014-03-01 01:31:28.000000', 'consum', 0.0215, 'lps'),
	(574942, 131, '2014-03-01 01:31:29.000000', 'consum', 0.0221, 'lps'),
	(574943, 131, '2014-03-01 01:31:30.000000', 'consum', 0.0215, 'lps'),
	(574944, 131, '2014-03-01 01:31:31.000000', 'consum', 0.0221, 'lps'),
	(574945, 131, '2014-03-01 01:31:32.000000', 'consum', 0.0213, 'lps'),
	(574946, 131, '2014-03-01 01:31:33.000000', 'consum', 0.0211, 'lps'),
	(574947, 131, '2014-03-01 01:31:34.000000', 'consum', 0.0225, 'lps'),
	(574948, 131, '2014-03-01 01:31:35.000000', 'consum', 0.0227, 'lps'),
	(574949, 131, '2014-03-01 01:31:36.000000', 'consum', 0.0214, 'lps'),
	(574950, 131, '2014-03-01 01:31:37.000000', 'consum', 0.0217, 'lps'),
	(574951, 131, '2014-03-01 01:31:38.000000', 'consum', 0.0215, 'lps'),
	(574952, 131, '2014-03-01 01:31:39.000000', 'consum', 0.0216, 'lps'),
	(574953, 131, '2014-03-01 01:31:40.000000', 'consum', 0.0226, 'lps'),
	(574954, 131, '2014-03-01 01:31:41.000000', 'consum', 0.0219, 'lps'),
	(574955, 131, '2014-03-01 01:31:42.000000', 'consum', 0.0225, 'lps'),
	(574956, 131, '2014-03-01 01:31:43.000000', 'consum', 0.0221, 'lps'),
	(574957, 131, '2014-03-01 01:31:44.000000', 'consum', 0.0223, 'lps'),
	(574958, 131, '2014-03-01 01:31:45.000000', 'consum', 0.0222, 'lps'),
	(574959, 131, '2014-03-01 01:31:46.000000', 'consum', 0.0213, 'lps'),
	(574960, 131, '2014-03-01 01:31:47.000000', 'consum', 0.0226, 'lps'),
	(574961, 131, '2014-03-01 01:31:48.000000', 'consum', 0.0211, 'lps'),
	(574962, 131, '2014-03-01 01:31:49.000000', 'consum', 0.0222, 'lps'),
	(574963, 131, '2014-03-01 01:31:50.000000', 'consum', 0.0214, 'lps'),
	(574964, 131, '2014-03-01 01:31:51.000000', 'consum', 0.0212, 'lps'),
	(574965, 131, '2014-03-01 01:31:52.000000', 'consum', 0.0225, 'lps'),
	(574966, 131, '2014-03-01 01:31:53.000000', 'consum', 0.0225, 'lps'),
	(574967, 131, '2014-03-01 01:31:54.000000', 'consum', 0.0222, 'lps'),
	(574968, 131, '2014-03-01 01:31:55.000000', 'consum', 0.0226, 'lps'),
	(574969, 131, '2014-03-01 01:31:56.000000', 'consum', 0.0217, 'lps'),
	(574970, 131, '2014-03-01 01:31:57.000000', 'consum', 0.0217, 'lps'),
	(574971, 131, '2014-03-01 01:31:58.000000', 'consum', 0.0224, 'lps'),
	(574972, 131, '2014-03-01 01:31:59.000000', 'consum', 0.0223, 'lps'),
	(574973, 131, '2014-03-01 01:32:00.000000', 'consum', 0.0215, 'lps'),
	(574974, 131, '2014-03-01 01:32:01.000000', 'consum', 0.0217, 'lps'),
	(574975, 131, '2014-03-01 01:32:02.000000', 'consum', 0.0227, 'lps'),
	(574976, 131, '2014-03-01 01:32:03.000000', 'consum', 0.0223, 'lps'),
	(574977, 131, '2014-03-01 01:32:04.000000', 'consum', 0.0222, 'lps'),
	(574978, 131, '2014-03-01 01:32:05.000000', 'consum', 0.0214, 'lps'),
	(574979, 131, '2014-03-01 01:32:06.000000', 'consum', 0.0215, 'lps'),
	(574980, 131, '2014-03-01 01:32:07.000000', 'consum', 0.0223, 'lps'),
	(574981, 131, '2014-03-01 01:32:08.000000', 'consum', 0.0224, 'lps'),
	(574982, 131, '2014-03-01 01:32:09.000000', 'consum', 0.0223, 'lps'),
	(574983, 131, '2014-03-01 01:32:10.000000', 'consum', 0.0215, 'lps'),
	(574984, 131, '2014-03-01 01:32:11.000000', 'consum', 0.0216, 'lps'),
	(574985, 131, '2014-03-01 01:32:12.000000', 'consum', 0.0225, 'lps'),
	(574986, 131, '2014-03-01 01:32:13.000000', 'consum', 0.0212, 'lps'),
	(574987, 131, '2014-03-01 01:32:14.000000', 'consum', 0.0214, 'lps'),
	(574988, 131, '2014-03-01 01:32:15.000000', 'consum', 0.0224, 'lps'),
	(574989, 131, '2014-03-01 01:32:16.000000', 'consum', 0.0213, 'lps'),
	(574990, 131, '2014-03-01 01:32:17.000000', 'consum', 0.0218, 'lps'),
	(574991, 131, '2014-03-01 01:32:18.000000', 'consum', 0.0226, 'lps'),
	(574992, 131, '2014-03-01 01:32:19.000000', 'consum', 0.0210, 'lps'),
	(574993, 131, '2014-03-01 01:32:20.000000', 'consum', 0.0219, 'lps'),
	(574994, 131, '2014-03-01 01:32:21.000000', 'consum', 0.0217, 'lps'),
	(574995, 131, '2014-03-01 01:32:22.000000', 'consum', 0.0218, 'lps'),
	(574996, 131, '2014-03-01 01:32:23.000000', 'consum', 0.0214, 'lps'),
	(574997, 131, '2014-03-01 01:32:24.000000', 'consum', 0.0223, 'lps'),
	(574998, 131, '2014-03-01 01:32:25.000000', 'consum', 0.0226, 'lps'),
	(574999, 131, '2014-03-01 01:32:26.000000', 'consum', 0.0217, 'lps'),
	(575000, 131, '2014-03-01 01:32:27.000000', 'consum', 0.0214, 'lps'),
	(575001, 131, '2014-03-01 01:32:28.000000', 'consum', 0.0212, 'lps'),
	(575002, 131, '2014-03-01 01:32:29.000000', 'consum', 0.0223, 'lps'),
	(575003, 131, '2014-03-01 01:32:30.000000', 'consum', 0.0219, 'lps'),
	(575004, 131, '2014-03-01 01:32:31.000000', 'consum', 0.0217, 'lps'),
	(575005, 131, '2014-03-01 01:32:32.000000', 'consum', 0.0215, 'lps'),
	(575006, 131, '2014-03-01 01:32:33.000000', 'consum', 0.0217, 'lps'),
	(575007, 131, '2014-03-01 01:32:34.000000', 'consum', 0.0211, 'lps'),
	(575008, 131, '2014-03-01 01:32:35.000000', 'consum', 0.0215, 'lps'),
	(575009, 131, '2014-03-01 01:32:36.000000', 'consum', 0.0211, 'lps'),
	(575010, 131, '2014-03-01 01:32:37.000000', 'consum', 0.0220, 'lps'),
	(575011, 131, '2014-03-01 01:32:38.000000', 'consum', 0.0223, 'lps'),
	(575012, 131, '2014-03-01 01:32:39.000000', 'consum', 0.0210, 'lps'),
	(575013, 131, '2014-03-01 01:32:40.000000', 'consum', 0.0223, 'lps'),
	(575014, 131, '2014-03-01 01:32:41.000000', 'consum', 0.0224, 'lps'),
	(575015, 131, '2014-03-01 01:32:42.000000', 'consum', 0.0221, 'lps'),
	(575016, 131, '2014-03-01 01:32:43.000000', 'consum', 0.0225, 'lps'),
	(575017, 131, '2014-03-01 01:32:44.000000', 'consum', 0.0217, 'lps'),
	(575018, 131, '2014-03-01 01:32:45.000000', 'consum', 0.0219, 'lps'),
	(575019, 131, '2014-03-01 01:32:46.000000', 'consum', 0.0216, 'lps'),
	(575020, 131, '2014-03-01 01:32:47.000000', 'consum', 0.0213, 'lps'),
	(575021, 131, '2014-03-01 01:32:48.000000', 'consum', 0.0227, 'lps'),
	(575022, 131, '2014-03-01 01:32:49.000000', 'consum', 0.0212, 'lps'),
	(575023, 131, '2014-03-01 01:32:50.000000', 'consum', 0.0226, 'lps'),
	(575024, 131, '2014-03-01 01:32:51.000000', 'consum', 0.0213, 'lps'),
	(575025, 131, '2014-03-01 01:32:52.000000', 'consum', 0.0212, 'lps'),
	(575026, 131, '2014-03-01 01:32:53.000000', 'consum', 0.0211, 'lps'),
	(575027, 131, '2014-03-01 01:32:54.000000', 'consum', 0.0226, 'lps'),
	(575028, 131, '2014-03-01 01:32:55.000000', 'consum', 0.0217, 'lps'),
	(575029, 131, '2014-03-01 01:32:56.000000', 'consum', 0.0216, 'lps'),
	(575030, 131, '2014-03-01 01:32:57.000000', 'consum', 0.0221, 'lps'),
	(575031, 131, '2014-03-01 01:32:58.000000', 'consum', 0.0211, 'lps'),
	(575032, 131, '2014-03-01 01:32:59.000000', 'consum', 0.0216, 'lps'),
	(575033, 131, '2014-03-01 01:33:00.000000', 'consum', 0.0222, 'lps'),
	(575034, 131, '2014-03-01 01:33:01.000000', 'consum', 0.0218, 'lps'),
	(575035, 131, '2014-03-01 01:33:02.000000', 'consum', 0.0212, 'lps'),
	(575036, 131, '2014-03-01 01:33:03.000000', 'consum', 0.0216, 'lps'),
	(575037, 131, '2014-03-01 01:33:04.000000', 'consum', 0.0216, 'lps'),
	(575038, 131, '2014-03-01 01:33:05.000000', 'consum', 0.0223, 'lps'),
	(575039, 131, '2014-03-01 01:33:06.000000', 'consum', 0.0220, 'lps'),
	(575040, 131, '2014-03-01 01:33:07.000000', 'consum', 0.0221, 'lps'),
	(575041, 131, '2014-03-01 01:33:08.000000', 'consum', 0.0217, 'lps'),
	(575042, 131, '2014-03-01 01:33:09.000000', 'consum', 0.0213, 'lps'),
	(575043, 131, '2014-03-01 01:33:10.000000', 'consum', 0.0222, 'lps'),
	(575044, 131, '2014-03-01 01:33:11.000000', 'consum', 0.0210, 'lps'),
	(575045, 131, '2014-03-01 01:33:12.000000', 'consum', 0.0227, 'lps'),
	(575046, 131, '2014-03-01 01:33:13.000000', 'consum', 0.0224, 'lps'),
	(575047, 131, '2014-03-01 01:33:14.000000', 'consum', 0.0212, 'lps'),
	(575048, 131, '2014-03-01 01:33:15.000000', 'consum', 0.0216, 'lps'),
	(575049, 131, '2014-03-01 01:33:16.000000', 'consum', 0.0214, 'lps'),
	(575050, 131, '2014-03-01 01:33:17.000000', 'consum', 0.0215, 'lps'),
	(575051, 131, '2014-03-01 01:33:18.000000', 'consum', 0.0220, 'lps'),
	(575052, 131, '2014-03-01 01:33:19.000000', 'consum', 0.0212, 'lps'),
	(575053, 131, '2014-03-01 01:33:20.000000', 'consum', 0.0227, 'lps'),
	(575054, 131, '2014-03-01 01:33:21.000000', 'consum', 0.0215, 'lps'),
	(575055, 131, '2014-03-01 01:33:22.000000', 'consum', 0.0220, 'lps'),
	(575056, 131, '2014-03-01 01:33:23.000000', 'consum', 0.0210, 'lps'),
	(575057, 131, '2014-03-01 01:33:24.000000', 'consum', 0.0217, 'lps'),
	(575058, 131, '2014-03-01 01:33:25.000000', 'consum', 0.0212, 'lps'),
	(575059, 131, '2014-03-01 01:33:26.000000', 'consum', 0.0214, 'lps'),
	(575060, 131, '2014-03-01 01:33:27.000000', 'consum', 0.0226, 'lps'),
	(575061, 131, '2014-03-01 01:33:28.000000', 'consum', 0.0226, 'lps'),
	(575062, 131, '2014-03-01 01:33:29.000000', 'consum', 0.0222, 'lps'),
	(575063, 131, '2014-03-01 01:33:30.000000', 'consum', 0.0223, 'lps'),
	(575064, 131, '2014-03-01 01:33:31.000000', 'consum', 0.0222, 'lps'),
	(575065, 131, '2014-03-01 01:33:32.000000', 'consum', 0.0213, 'lps'),
	(575066, 131, '2014-03-01 01:33:33.000000', 'consum', 0.0227, 'lps'),
	(575067, 131, '2014-03-01 01:33:34.000000', 'consum', 0.0213, 'lps'),
	(575068, 131, '2014-03-01 01:33:35.000000', 'consum', 0.0211, 'lps'),
	(575069, 131, '2014-03-01 01:33:36.000000', 'consum', 0.0223, 'lps'),
	(575070, 131, '2014-03-01 01:33:37.000000', 'consum', 0.0220, 'lps'),
	(575071, 131, '2014-03-01 01:33:38.000000', 'consum', 0.0221, 'lps'),
	(575072, 131, '2014-03-01 01:33:39.000000', 'consum', 0.0219, 'lps'),
	(575073, 131, '2014-03-01 01:33:40.000000', 'consum', 0.0223, 'lps'),
	(575074, 131, '2014-03-01 01:33:41.000000', 'consum', 0.0211, 'lps'),
	(575075, 131, '2014-03-01 01:33:42.000000', 'consum', 0.0213, 'lps'),
	(575076, 131, '2014-03-01 01:33:43.000000', 'consum', 0.0221, 'lps'),
	(575077, 131, '2014-03-01 01:33:44.000000', 'consum', 0.0222, 'lps'),
	(575078, 131, '2014-03-01 01:33:45.000000', 'consum', 0.0218, 'lps'),
	(575079, 131, '2014-03-01 01:33:46.000000', 'consum', 0.0216, 'lps'),
	(575080, 131, '2014-03-01 01:33:47.000000', 'consum', 0.0215, 'lps'),
	(575081, 131, '2014-03-01 01:33:48.000000', 'consum', 0.0219, 'lps'),
	(575082, 131, '2014-03-01 01:33:49.000000', 'consum', 0.0223, 'lps'),
	(575083, 131, '2014-03-01 01:33:50.000000', 'consum', 0.0212, 'lps'),
	(575084, 131, '2014-03-01 01:33:51.000000', 'consum', 0.0218, 'lps'),
	(575085, 131, '2014-03-01 01:33:52.000000', 'consum', 0.0226, 'lps'),
	(575086, 131, '2014-03-01 01:33:53.000000', 'consum', 0.0211, 'lps'),
	(575087, 131, '2014-03-01 01:33:54.000000', 'consum', 0.0223, 'lps'),
	(575088, 131, '2014-03-01 01:33:55.000000', 'consum', 0.0217, 'lps'),
	(575089, 131, '2014-03-01 01:33:56.000000', 'consum', 0.0227, 'lps'),
	(575090, 131, '2014-03-01 01:33:57.000000', 'consum', 0.0220, 'lps'),
	(575091, 131, '2014-03-01 01:33:58.000000', 'consum', 0.0210, 'lps'),
	(575092, 131, '2014-03-01 01:33:59.000000', 'consum', 0.0216, 'lps'),
	(575093, 131, '2014-03-01 01:34:00.000000', 'consum', 0.0224, 'lps'),
	(575094, 131, '2014-03-01 01:34:01.000000', 'consum', 0.0227, 'lps'),
	(575095, 131, '2014-03-01 01:34:02.000000', 'consum', 0.0217, 'lps'),
	(575096, 131, '2014-03-01 01:34:03.000000', 'consum', 0.0211, 'lps'),
	(575097, 131, '2014-03-01 01:34:04.000000', 'consum', 0.0211, 'lps'),
	(575098, 131, '2014-03-01 01:34:05.000000', 'consum', 0.0215, 'lps'),
	(575099, 131, '2014-03-01 01:34:06.000000', 'consum', 0.0216, 'lps'),
	(575100, 131, '2014-03-01 01:34:07.000000', 'consum', 0.0224, 'lps'),
	(575101, 131, '2014-03-01 01:34:08.000000', 'consum', 0.0226, 'lps'),
	(575102, 131, '2014-03-01 01:34:09.000000', 'consum', 0.0212, 'lps'),
	(575103, 131, '2014-03-01 01:34:10.000000', 'consum', 0.0210, 'lps'),
	(575104, 131, '2014-03-01 01:34:11.000000', 'consum', 0.0222, 'lps'),
	(575105, 131, '2014-03-01 01:34:12.000000', 'consum', 0.0217, 'lps'),
	(575106, 131, '2014-03-01 01:34:13.000000', 'consum', 0.0225, 'lps'),
	(575107, 131, '2014-03-01 01:34:14.000000', 'consum', 0.0212, 'lps'),
	(575108, 131, '2014-03-01 01:34:15.000000', 'consum', 0.0210, 'lps'),
	(575109, 131, '2014-03-01 01:34:16.000000', 'consum', 0.0225, 'lps'),
	(575110, 131, '2014-03-01 01:34:17.000000', 'consum', 0.0213, 'lps'),
	(575111, 131, '2014-03-01 01:34:18.000000', 'consum', 0.0214, 'lps'),
	(575112, 131, '2014-03-01 01:34:19.000000', 'consum', 0.0223, 'lps'),
	(575113, 131, '2014-03-01 01:34:20.000000', 'consum', 0.0211, 'lps'),
	(575114, 131, '2014-03-01 01:34:21.000000', 'consum', 0.0213, 'lps'),
	(575115, 131, '2014-03-01 01:34:22.000000', 'consum', 0.0223, 'lps'),
	(575116, 131, '2014-03-01 01:34:23.000000', 'consum', 0.0210, 'lps'),
	(575117, 131, '2014-03-01 01:34:24.000000', 'consum', 0.0211, 'lps'),
	(575118, 131, '2014-03-01 01:34:25.000000', 'consum', 0.0212, 'lps'),
	(575119, 131, '2014-03-01 01:34:26.000000', 'consum', 0.0218, 'lps'),
	(575120, 131, '2014-03-01 01:34:27.000000', 'consum', 0.0211, 'lps'),
	(575121, 131, '2014-03-01 01:34:28.000000', 'consum', 0.0227, 'lps'),
	(575122, 131, '2014-03-01 01:34:29.000000', 'consum', 0.0218, 'lps'),
	(575123, 131, '2014-03-01 01:34:30.000000', 'consum', 0.0218, 'lps'),
	(575124, 131, '2014-03-01 01:34:31.000000', 'consum', 0.0227, 'lps'),
	(575125, 131, '2014-03-01 01:34:32.000000', 'consum', 0.0216, 'lps'),
	(575126, 131, '2014-03-01 01:34:33.000000', 'consum', 0.0210, 'lps'),
	(575127, 131, '2014-03-01 01:34:34.000000', 'consum', 0.0227, 'lps'),
	(575128, 131, '2014-03-01 01:34:35.000000', 'consum', 0.0222, 'lps'),
	(575129, 131, '2014-03-01 01:34:36.000000', 'consum', 0.0222, 'lps'),
	(575130, 131, '2014-03-01 01:34:37.000000', 'consum', 0.0218, 'lps'),
	(575131, 131, '2014-03-01 01:34:38.000000', 'consum', 0.0212, 'lps'),
	(575132, 131, '2014-03-01 01:34:39.000000', 'consum', 0.0214, 'lps'),
	(575133, 131, '2014-03-01 01:34:40.000000', 'consum', 0.0225, 'lps'),
	(575134, 131, '2014-03-01 01:34:41.000000', 'consum', 0.0219, 'lps'),
	(575135, 131, '2014-03-01 01:34:42.000000', 'consum', 0.0213, 'lps'),
	(575136, 131, '2014-03-01 01:34:43.000000', 'consum', 0.0216, 'lps'),
	(575137, 131, '2014-03-01 01:34:44.000000', 'consum', 0.0211, 'lps'),
	(575138, 131, '2014-03-01 01:34:45.000000', 'consum', 0.0218, 'lps'),
	(575139, 131, '2014-03-01 01:34:46.000000', 'consum', 0.0212, 'lps'),
	(575140, 131, '2014-03-01 01:34:47.000000', 'consum', 0.0212, 'lps'),
	(575141, 131, '2014-03-01 01:34:48.000000', 'consum', 0.0216, 'lps'),
	(575142, 131, '2014-03-01 01:34:49.000000', 'consum', 0.0215, 'lps'),
	(575143, 131, '2014-03-01 01:34:50.000000', 'consum', 0.0216, 'lps'),
	(575144, 131, '2014-03-01 01:34:51.000000', 'consum', 0.0211, 'lps'),
	(575145, 131, '2014-03-01 01:34:52.000000', 'consum', 0.0215, 'lps'),
	(575146, 131, '2014-03-01 01:34:53.000000', 'consum', 0.0213, 'lps'),
	(575147, 131, '2014-03-01 01:34:54.000000', 'consum', 0.0227, 'lps'),
	(575148, 131, '2014-03-01 01:34:55.000000', 'consum', 0.0216, 'lps'),
	(575149, 131, '2014-03-01 01:34:56.000000', 'consum', 0.0226, 'lps'),
	(575150, 131, '2014-03-01 01:34:57.000000', 'consum', 0.0220, 'lps'),
	(575151, 131, '2014-03-01 01:34:58.000000', 'consum', 0.0211, 'lps'),
	(575152, 131, '2014-03-01 01:34:59.000000', 'consum', 0.0220, 'lps'),
	(575153, 131, '2014-03-01 01:35:00.000000', 'consum', 0.0222, 'lps'),
	(575154, 131, '2014-03-01 01:35:01.000000', 'consum', 0.0222, 'lps'),
	(575155, 131, '2014-03-01 01:35:02.000000', 'consum', 0.0217, 'lps'),
	(575156, 131, '2014-03-01 01:35:03.000000', 'consum', 0.0210, 'lps'),
	(575157, 131, '2014-03-01 01:35:04.000000', 'consum', 0.0224, 'lps'),
	(575158, 131, '2014-03-01 01:35:05.000000', 'consum', 0.0210, 'lps'),
	(575159, 131, '2014-03-01 01:35:06.000000', 'consum', 0.0222, 'lps'),
	(575160, 131, '2014-03-01 01:35:07.000000', 'consum', 0.0218, 'lps'),
	(575161, 131, '2014-03-01 01:35:08.000000', 'consum', 0.0215, 'lps'),
	(575162, 131, '2014-03-01 01:35:09.000000', 'consum', 0.0210, 'lps'),
	(575163, 131, '2014-03-01 01:35:10.000000', 'consum', 0.0213, 'lps'),
	(575164, 131, '2014-03-01 01:35:11.000000', 'consum', 0.0225, 'lps'),
	(575165, 131, '2014-03-01 01:35:12.000000', 'consum', 0.0225, 'lps'),
	(575166, 131, '2014-03-01 01:35:13.000000', 'consum', 0.0221, 'lps'),
	(575167, 131, '2014-03-01 01:35:14.000000', 'consum', 0.0220, 'lps'),
	(575168, 131, '2014-03-01 01:35:15.000000', 'consum', 0.0210, 'lps'),
	(575169, 131, '2014-03-01 01:35:16.000000', 'consum', 0.0215, 'lps'),
	(575170, 131, '2014-03-01 01:35:17.000000', 'consum', 0.0218, 'lps'),
	(575171, 131, '2014-03-01 01:35:18.000000', 'consum', 0.0217, 'lps'),
	(575172, 131, '2014-03-01 01:35:19.000000', 'consum', 0.0221, 'lps'),
	(575173, 131, '2014-03-01 01:35:20.000000', 'consum', 0.0210, 'lps'),
	(575174, 131, '2014-03-01 01:35:21.000000', 'consum', 0.0214, 'lps'),
	(575175, 131, '2014-03-01 01:35:22.000000', 'consum', 0.0210, 'lps'),
	(575176, 131, '2014-03-01 01:35:23.000000', 'consum', 0.0217, 'lps'),
	(575177, 131, '2014-03-01 01:35:24.000000', 'consum', 0.0226, 'lps'),
	(575178, 131, '2014-03-01 01:35:25.000000', 'consum', 0.0217, 'lps'),
	(575179, 131, '2014-03-01 01:35:26.000000', 'consum', 0.0217, 'lps'),
	(575180, 131, '2014-03-01 01:35:27.000000', 'consum', 0.0224, 'lps'),
	(575181, 131, '2014-03-01 01:35:28.000000', 'consum', 0.0222, 'lps'),
	(575182, 131, '2014-03-01 01:35:29.000000', 'consum', 0.0212, 'lps'),
	(575183, 131, '2014-03-01 01:35:30.000000', 'consum', 0.0218, 'lps'),
	(575184, 131, '2014-03-01 01:35:31.000000', 'consum', 0.0212, 'lps'),
	(575185, 131, '2014-03-01 01:35:32.000000', 'consum', 0.0212, 'lps'),
	(575186, 131, '2014-03-01 01:35:33.000000', 'consum', 0.0214, 'lps'),
	(575187, 131, '2014-03-01 01:35:34.000000', 'consum', 0.0227, 'lps'),
	(575188, 131, '2014-03-01 01:35:35.000000', 'consum', 0.0227, 'lps'),
	(575189, 131, '2014-03-01 01:35:36.000000', 'consum', 0.0211, 'lps'),
	(575190, 131, '2014-03-01 01:35:37.000000', 'consum', 0.0218, 'lps'),
	(575191, 131, '2014-03-01 01:35:38.000000', 'consum', 0.0210, 'lps'),
	(575192, 131, '2014-03-01 01:35:39.000000', 'consum', 0.0223, 'lps'),
	(575193, 131, '2014-03-01 01:35:40.000000', 'consum', 0.0220, 'lps'),
	(575194, 131, '2014-03-01 01:35:41.000000', 'consum', 0.0221, 'lps'),
	(575195, 131, '2014-03-01 01:35:42.000000', 'consum', 0.0218, 'lps'),
	(575196, 131, '2014-03-01 01:35:43.000000', 'consum', 0.0219, 'lps'),
	(575197, 131, '2014-03-01 01:35:44.000000', 'consum', 0.0215, 'lps'),
	(575198, 131, '2014-03-01 01:35:45.000000', 'consum', 0.0224, 'lps'),
	(575199, 131, '2014-03-01 01:35:46.000000', 'consum', 0.0211, 'lps'),
	(575200, 131, '2014-03-01 01:35:47.000000', 'consum', 0.0227, 'lps'),
	(575201, 131, '2014-03-01 01:35:48.000000', 'consum', 0.0223, 'lps'),
	(575202, 131, '2014-03-01 01:35:49.000000', 'consum', 0.0223, 'lps'),
	(575203, 131, '2014-03-01 01:35:50.000000', 'consum', 0.0220, 'lps'),
	(575204, 131, '2014-03-01 01:35:51.000000', 'consum', 0.0220, 'lps'),
	(575205, 131, '2014-03-01 01:35:52.000000', 'consum', 0.0214, 'lps'),
	(575206, 131, '2014-03-01 01:35:53.000000', 'consum', 0.0218, 'lps'),
	(575207, 131, '2014-03-01 01:35:54.000000', 'consum', 0.0222, 'lps'),
	(575208, 131, '2014-03-01 01:35:55.000000', 'consum', 0.0210, 'lps'),
	(575209, 131, '2014-03-01 01:35:56.000000', 'consum', 0.0227, 'lps'),
	(575210, 131, '2014-03-01 01:35:57.000000', 'consum', 0.0223, 'lps'),
	(575211, 131, '2014-03-01 01:35:58.000000', 'consum', 0.0227, 'lps'),
	(575212, 131, '2014-03-01 01:35:59.000000', 'consum', 0.0218, 'lps'),
	(575213, 131, '2014-03-01 01:36:00.000000', 'consum', 0.0221, 'lps'),
	(575214, 131, '2014-03-01 01:36:01.000000', 'consum', 0.0220, 'lps'),
	(575215, 131, '2014-03-01 01:36:02.000000', 'consum', 0.0210, 'lps'),
	(575216, 127, '2014-03-15 00:00:00.000000', 'consum', 0.0224, 'lps'),
	(575217, 127, '2014-03-15 00:00:01.000000', 'consum', 0.0211, 'lps'),
	(575218, 127, '2014-03-15 00:00:02.000000', 'consum', 0.0210, 'lps'),
	(575219, 127, '2014-03-15 00:00:03.000000', 'consum', 0.0225, 'lps'),
	(575220, 127, '2014-03-15 00:00:04.000000', 'consum', 0.0214, 'lps'),
	(575221, 127, '2014-03-15 00:00:05.000000', 'consum', 0.0223, 'lps'),
	(575222, 127, '2014-03-15 00:00:06.000000', 'consum', 0.0225, 'lps'),
	(575223, 127, '2014-03-15 00:00:07.000000', 'consum', 0.0212, 'lps'),
	(575224, 127, '2014-03-15 00:00:08.000000', 'consum', 0.0213, 'lps'),
	(575225, 127, '2014-03-15 00:00:09.000000', 'consum', 0.0216, 'lps'),
	(575226, 127, '2014-03-15 00:00:10.000000', 'consum', 0.0217, 'lps'),
	(575227, 127, '2014-03-15 00:00:11.000000', 'consum', 0.0224, 'lps'),
	(575228, 127, '2014-03-15 00:00:12.000000', 'consum', 0.0226, 'lps'),
	(575229, 127, '2014-03-15 00:00:13.000000', 'consum', 0.0211, 'lps'),
	(575230, 127, '2014-03-15 00:00:14.000000', 'consum', 0.0220, 'lps'),
	(575231, 127, '2014-03-15 00:00:15.000000', 'consum', 0.0224, 'lps'),
	(575232, 127, '2014-03-15 00:00:16.000000', 'consum', 0.0215, 'lps'),
	(575233, 127, '2014-03-15 00:00:17.000000', 'consum', 0.0211, 'lps'),
	(575234, 127, '2014-03-15 00:00:18.000000', 'consum', 0.0217, 'lps'),
	(575235, 127, '2014-03-15 00:00:19.000000', 'consum', 0.0224, 'lps'),
	(575236, 127, '2014-03-15 00:00:20.000000', 'consum', 0.0224, 'lps'),
	(575237, 127, '2014-03-15 00:00:21.000000', 'consum', 0.0221, 'lps'),
	(575238, 127, '2014-03-15 00:00:22.000000', 'consum', 0.0223, 'lps'),
	(575239, 127, '2014-03-15 00:00:23.000000', 'consum', 0.0223, 'lps'),
	(575240, 127, '2014-03-15 00:00:24.000000', 'consum', 0.0219, 'lps'),
	(575241, 127, '2014-03-15 00:00:25.000000', 'consum', 0.0219, 'lps'),
	(575242, 127, '2014-03-15 00:00:26.000000', 'consum', 0.0225, 'lps'),
	(575243, 127, '2014-03-15 00:00:27.000000', 'consum', 0.0226, 'lps'),
	(575244, 127, '2014-03-15 00:00:28.000000', 'consum', 0.0226, 'lps'),
	(575245, 127, '2014-03-15 00:00:29.000000', 'consum', 0.0225, 'lps'),
	(575246, 127, '2014-03-15 00:00:30.000000', 'consum', 0.0220, 'lps'),
	(575247, 127, '2014-03-15 00:00:31.000000', 'consum', 0.0216, 'lps'),
	(575248, 127, '2014-03-15 00:00:32.000000', 'consum', 0.0211, 'lps'),
	(575249, 127, '2014-03-15 00:00:33.000000', 'consum', 0.0215, 'lps'),
	(575250, 127, '2014-03-15 00:00:34.000000', 'consum', 0.0213, 'lps'),
	(575251, 127, '2014-03-15 00:00:35.000000', 'consum', 0.0211, 'lps'),
	(575252, 127, '2014-03-15 00:00:36.000000', 'consum', 0.0223, 'lps'),
	(575253, 127, '2014-03-15 00:00:37.000000', 'consum', 0.0220, 'lps'),
	(575254, 127, '2014-03-15 00:00:38.000000', 'consum', 0.0221, 'lps'),
	(575255, 127, '2014-03-15 00:00:39.000000', 'consum', 0.0219, 'lps'),
	(575256, 127, '2014-03-15 00:00:40.000000', 'consum', 0.0221, 'lps'),
	(575257, 127, '2014-03-15 00:00:41.000000', 'consum', 0.0219, 'lps'),
	(575258, 127, '2014-03-15 00:00:42.000000', 'consum', 0.0224, 'lps'),
	(575259, 127, '2014-03-15 00:00:43.000000', 'consum', 0.0217, 'lps'),
	(575260, 127, '2014-03-15 00:00:44.000000', 'consum', 0.0224, 'lps'),
	(575261, 127, '2014-03-15 00:00:45.000000', 'consum', 0.0221, 'lps'),
	(575262, 127, '2014-03-15 00:00:46.000000', 'consum', 0.0225, 'lps'),
	(575263, 127, '2014-03-15 00:00:47.000000', 'consum', 0.0215, 'lps'),
	(575264, 127, '2014-03-15 00:00:48.000000', 'consum', 0.0210, 'lps'),
	(575265, 127, '2014-03-15 00:00:49.000000', 'consum', 0.0211, 'lps'),
	(575266, 127, '2014-03-15 00:00:50.000000', 'consum', 0.0217, 'lps'),
	(575267, 127, '2014-03-15 00:00:51.000000', 'consum', 0.0223, 'lps'),
	(575268, 127, '2014-03-15 00:00:52.000000', 'consum', 0.0218, 'lps'),
	(575269, 127, '2014-03-15 00:00:53.000000', 'consum', 0.0213, 'lps'),
	(575270, 127, '2014-03-15 00:00:54.000000', 'consum', 0.0219, 'lps'),
	(575271, 127, '2014-03-15 00:00:55.000000', 'consum', 0.0212, 'lps'),
	(575272, 127, '2014-03-15 00:00:56.000000', 'consum', 0.0211, 'lps'),
	(575273, 127, '2014-03-15 00:00:57.000000', 'consum', 0.0211, 'lps'),
	(575274, 127, '2014-03-15 00:00:58.000000', 'consum', 0.0211, 'lps'),
	(575275, 127, '2014-03-15 00:00:59.000000', 'consum', 0.0215, 'lps'),
	(575276, 127, '2014-03-15 00:01:00.000000', 'consum', 0.0212, 'lps'),
	(575277, 127, '2014-03-15 00:01:01.000000', 'consum', 0.0223, 'lps'),
	(575278, 127, '2014-03-15 00:01:02.000000', 'consum', 0.0217, 'lps'),
	(575279, 127, '2014-03-15 00:01:03.000000', 'consum', 0.0223, 'lps'),
	(575280, 127, '2014-03-15 00:01:04.000000', 'consum', 0.0219, 'lps'),
	(575281, 127, '2014-03-15 00:01:05.000000', 'consum', 0.0216, 'lps'),
	(575282, 127, '2014-03-15 00:01:06.000000', 'consum', 0.0216, 'lps'),
	(575283, 127, '2014-03-15 00:01:07.000000', 'consum', 0.0219, 'lps'),
	(575284, 127, '2014-03-15 00:01:08.000000', 'consum', 0.0222, 'lps'),
	(575285, 127, '2014-03-15 00:01:09.000000', 'consum', 0.0224, 'lps'),
	(575286, 127, '2014-03-15 00:01:10.000000', 'consum', 0.0226, 'lps'),
	(575287, 127, '2014-03-15 00:01:11.000000', 'consum', 0.0212, 'lps'),
	(575288, 127, '2014-03-15 00:01:12.000000', 'consum', 0.0227, 'lps'),
	(575289, 127, '2014-03-15 00:01:13.000000', 'consum', 0.0217, 'lps'),
	(575290, 127, '2014-03-15 00:01:14.000000', 'consum', 0.0214, 'lps'),
	(575291, 127, '2014-03-15 00:01:15.000000', 'consum', 0.0225, 'lps'),
	(575292, 127, '2014-03-15 00:01:16.000000', 'consum', 0.0222, 'lps'),
	(575293, 127, '2014-03-15 00:01:17.000000', 'consum', 0.0225, 'lps'),
	(575294, 127, '2014-03-15 00:01:18.000000', 'consum', 0.0214, 'lps'),
	(575295, 127, '2014-03-15 00:01:19.000000', 'consum', 0.0219, 'lps'),
	(575296, 127, '2014-03-15 00:01:20.000000', 'consum', 0.0227, 'lps'),
	(575297, 127, '2014-03-15 00:01:21.000000', 'consum', 0.0215, 'lps'),
	(575298, 127, '2014-03-15 00:01:22.000000', 'consum', 0.0219, 'lps'),
	(575299, 127, '2014-03-15 00:01:23.000000', 'consum', 0.0222, 'lps'),
	(575300, 127, '2014-03-15 00:01:24.000000', 'consum', 0.0210, 'lps'),
	(575301, 127, '2014-03-15 00:01:25.000000', 'consum', 0.0210, 'lps'),
	(575302, 127, '2014-03-15 00:01:26.000000', 'consum', 0.0211, 'lps'),
	(575303, 127, '2014-03-15 00:01:27.000000', 'consum', 0.0213, 'lps'),
	(575304, 127, '2014-03-15 00:01:28.000000', 'consum', 0.0225, 'lps'),
	(575305, 127, '2014-03-15 00:01:29.000000', 'consum', 0.0223, 'lps'),
	(575306, 127, '2014-03-15 00:01:30.000000', 'consum', 0.0211, 'lps'),
	(575307, 127, '2014-03-15 00:01:31.000000', 'consum', 0.0213, 'lps'),
	(575308, 127, '2014-03-15 00:01:32.000000', 'consum', 0.0224, 'lps'),
	(575309, 127, '2014-03-15 00:01:33.000000', 'consum', 0.0217, 'lps'),
	(575310, 127, '2014-03-15 00:01:34.000000', 'consum', 0.0220, 'lps'),
	(575311, 127, '2014-03-15 00:01:35.000000', 'consum', 0.0221, 'lps'),
	(575312, 127, '2014-03-15 00:01:36.000000', 'consum', 0.0219, 'lps'),
	(575313, 127, '2014-03-15 00:01:37.000000', 'consum', 0.0220, 'lps'),
	(575314, 127, '2014-03-15 00:01:38.000000', 'consum', 0.0218, 'lps'),
	(575315, 127, '2014-03-15 00:01:39.000000', 'consum', 0.0221, 'lps'),
	(575316, 127, '2014-03-15 00:01:40.000000', 'consum', 0.0221, 'lps'),
	(575317, 127, '2014-03-15 00:01:41.000000', 'consum', 0.0215, 'lps'),
	(575318, 127, '2014-03-15 00:01:42.000000', 'consum', 0.0221, 'lps'),
	(575319, 127, '2014-03-15 00:01:43.000000', 'consum', 0.0215, 'lps'),
	(575320, 127, '2014-03-15 00:01:44.000000', 'consum', 0.0221, 'lps'),
	(575321, 127, '2014-03-15 00:01:45.000000', 'consum', 0.0212, 'lps'),
	(575322, 127, '2014-03-15 00:01:46.000000', 'consum', 0.0224, 'lps'),
	(575323, 127, '2014-03-15 00:01:47.000000', 'consum', 0.0222, 'lps'),
	(575324, 127, '2014-03-15 00:01:48.000000', 'consum', 0.0227, 'lps'),
	(575325, 127, '2014-03-15 00:01:49.000000', 'consum', 0.0225, 'lps'),
	(575326, 127, '2014-03-15 00:01:50.000000', 'consum', 0.0215, 'lps'),
	(575327, 127, '2014-03-15 00:01:51.000000', 'consum', 0.0225, 'lps'),
	(575328, 127, '2014-03-15 00:01:52.000000', 'consum', 0.0220, 'lps'),
	(575329, 127, '2014-03-15 00:01:53.000000', 'consum', 0.0213, 'lps'),
	(575330, 127, '2014-03-15 00:01:54.000000', 'consum', 0.0215, 'lps'),
	(575331, 127, '2014-03-15 00:01:55.000000', 'consum', 0.0224, 'lps'),
	(575332, 127, '2014-03-15 00:01:56.000000', 'consum', 0.0212, 'lps'),
	(575333, 127, '2014-03-15 00:01:57.000000', 'consum', 0.0217, 'lps'),
	(575334, 127, '2014-03-15 00:01:58.000000', 'consum', 0.0219, 'lps'),
	(575335, 127, '2014-03-15 00:01:59.000000', 'consum', 0.0219, 'lps'),
	(575336, 127, '2014-03-15 00:02:00.000000', 'consum', 0.0225, 'lps'),
	(575337, 127, '2014-03-15 00:02:01.000000', 'consum', 0.0225, 'lps'),
	(575338, 127, '2014-03-15 00:02:02.000000', 'consum', 0.0223, 'lps'),
	(575339, 127, '2014-03-15 00:02:03.000000', 'consum', 0.0212, 'lps'),
	(575340, 127, '2014-03-15 00:02:04.000000', 'consum', 0.0218, 'lps'),
	(575341, 127, '2014-03-15 00:02:05.000000', 'consum', 0.0226, 'lps'),
	(575342, 127, '2014-03-15 00:02:06.000000', 'consum', 0.0212, 'lps'),
	(575343, 127, '2014-03-15 00:02:07.000000', 'consum', 0.0226, 'lps'),
	(575344, 127, '2014-03-15 00:02:08.000000', 'consum', 0.0214, 'lps'),
	(575345, 127, '2014-03-15 00:02:09.000000', 'consum', 0.0219, 'lps'),
	(575346, 127, '2014-03-15 00:02:10.000000', 'consum', 0.0225, 'lps'),
	(575347, 127, '2014-03-15 00:02:11.000000', 'consum', 0.0222, 'lps'),
	(575348, 127, '2014-03-15 00:02:12.000000', 'consum', 0.0224, 'lps'),
	(575349, 127, '2014-03-15 00:02:13.000000', 'consum', 0.0227, 'lps'),
	(575350, 127, '2014-03-15 00:02:14.000000', 'consum', 0.0219, 'lps'),
	(575351, 127, '2014-03-15 00:02:15.000000', 'consum', 0.0224, 'lps'),
	(575352, 127, '2014-03-15 00:02:16.000000', 'consum', 0.0214, 'lps'),
	(575353, 127, '2014-03-15 00:02:17.000000', 'consum', 0.0227, 'lps'),
	(575354, 127, '2014-03-15 00:02:18.000000', 'consum', 0.0212, 'lps'),
	(575355, 127, '2014-03-15 00:02:19.000000', 'consum', 0.0223, 'lps'),
	(575356, 127, '2014-03-15 00:02:20.000000', 'consum', 0.0214, 'lps'),
	(575357, 127, '2014-03-15 00:02:21.000000', 'consum', 0.0211, 'lps'),
	(575358, 127, '2014-03-15 00:02:22.000000', 'consum', 0.0223, 'lps'),
	(575359, 127, '2014-03-15 00:02:23.000000', 'consum', 0.0216, 'lps'),
	(575360, 127, '2014-03-15 00:02:24.000000', 'consum', 0.0220, 'lps'),
	(575361, 127, '2014-03-15 00:02:25.000000', 'consum', 0.0223, 'lps'),
	(575362, 127, '2014-03-15 00:02:26.000000', 'consum', 0.0211, 'lps'),
	(575363, 127, '2014-03-15 00:02:27.000000', 'consum', 0.0211, 'lps'),
	(575364, 127, '2014-03-15 00:02:28.000000', 'consum', 0.0214, 'lps'),
	(575365, 127, '2014-03-15 00:02:29.000000', 'consum', 0.0225, 'lps'),
	(575366, 127, '2014-03-15 00:02:30.000000', 'consum', 0.0221, 'lps'),
	(575367, 127, '2014-03-15 00:02:31.000000', 'consum', 0.0222, 'lps'),
	(575368, 127, '2014-03-15 00:02:32.000000', 'consum', 0.0218, 'lps'),
	(575369, 127, '2014-03-15 00:02:33.000000', 'consum', 0.0214, 'lps'),
	(575370, 127, '2014-03-15 00:02:34.000000', 'consum', 0.0223, 'lps'),
	(575371, 127, '2014-03-15 00:02:35.000000', 'consum', 0.0213, 'lps'),
	(575372, 127, '2014-03-15 00:02:36.000000', 'consum', 0.0220, 'lps'),
	(575373, 127, '2014-03-15 00:02:37.000000', 'consum', 0.0215, 'lps'),
	(575374, 127, '2014-03-15 00:02:38.000000', 'consum', 0.0225, 'lps'),
	(575375, 127, '2014-03-15 00:02:39.000000', 'consum', 0.0217, 'lps'),
	(575376, 127, '2014-03-15 00:02:40.000000', 'consum', 0.0217, 'lps'),
	(575377, 127, '2014-03-15 00:02:41.000000', 'consum', 0.0227, 'lps'),
	(575378, 127, '2014-03-15 00:02:42.000000', 'consum', 0.0219, 'lps'),
	(575379, 127, '2014-03-15 00:02:43.000000', 'consum', 0.0224, 'lps'),
	(575380, 127, '2014-03-15 00:02:44.000000', 'consum', 0.0217, 'lps'),
	(575381, 127, '2014-03-15 00:02:45.000000', 'consum', 0.0220, 'lps'),
	(575382, 127, '2014-03-15 00:02:46.000000', 'consum', 0.0222, 'lps'),
	(575383, 127, '2014-03-15 00:02:47.000000', 'consum', 0.0222, 'lps'),
	(575384, 127, '2014-03-15 00:02:48.000000', 'consum', 0.0217, 'lps'),
	(575385, 127, '2014-03-15 00:02:49.000000', 'consum', 0.0227, 'lps'),
	(575386, 127, '2014-03-15 00:02:50.000000', 'consum', 0.0221, 'lps'),
	(575387, 127, '2014-03-15 00:02:51.000000', 'consum', 0.0212, 'lps'),
	(575388, 127, '2014-03-15 00:02:52.000000', 'consum', 0.0227, 'lps'),
	(575389, 127, '2014-03-15 00:02:53.000000', 'consum', 0.0214, 'lps'),
	(575390, 127, '2014-03-15 00:02:54.000000', 'consum', 0.0219, 'lps'),
	(575391, 127, '2014-03-15 00:02:55.000000', 'consum', 0.0225, 'lps'),
	(575392, 127, '2014-03-15 00:02:56.000000', 'consum', 0.0220, 'lps'),
	(575393, 127, '2014-03-15 00:02:57.000000', 'consum', 0.0216, 'lps'),
	(575394, 127, '2014-03-15 00:02:58.000000', 'consum', 0.0213, 'lps'),
	(575395, 127, '2014-03-15 00:02:59.000000', 'consum', 0.0223, 'lps'),
	(575396, 127, '2014-03-15 00:03:00.000000', 'consum', 0.0213, 'lps'),
	(575397, 127, '2014-03-15 00:03:01.000000', 'consum', 0.0221, 'lps'),
	(575398, 127, '2014-03-15 00:03:02.000000', 'consum', 0.0223, 'lps'),
	(575399, 127, '2014-03-15 00:03:03.000000', 'consum', 0.0223, 'lps'),
	(575400, 127, '2014-03-15 00:03:04.000000', 'consum', 0.0219, 'lps'),
	(575401, 127, '2014-03-15 00:03:05.000000', 'consum', 0.0218, 'lps'),
	(575402, 127, '2014-03-15 00:03:06.000000', 'consum', 0.0222, 'lps'),
	(575403, 127, '2014-03-15 00:03:07.000000', 'consum', 0.0227, 'lps'),
	(575404, 127, '2014-03-15 00:03:08.000000', 'consum', 0.0225, 'lps'),
	(575405, 127, '2014-03-15 00:03:09.000000', 'consum', 0.0214, 'lps'),
	(575406, 127, '2014-03-15 00:03:10.000000', 'consum', 0.0224, 'lps'),
	(575407, 127, '2014-03-15 00:03:11.000000', 'consum', 0.0216, 'lps'),
	(575408, 127, '2014-03-15 00:03:12.000000', 'consum', 0.0214, 'lps'),
	(575409, 127, '2014-03-15 00:03:13.000000', 'consum', 0.0213, 'lps'),
	(575410, 127, '2014-03-15 00:03:14.000000', 'consum', 0.0216, 'lps'),
	(575411, 127, '2014-03-15 00:03:15.000000', 'consum', 0.0211, 'lps'),
	(575412, 127, '2014-03-15 00:03:16.000000', 'consum', 0.0216, 'lps'),
	(575413, 127, '2014-03-15 00:03:17.000000', 'consum', 0.0218, 'lps'),
	(575414, 127, '2014-03-15 00:03:18.000000', 'consum', 0.0216, 'lps'),
	(575415, 127, '2014-03-15 00:03:19.000000', 'consum', 0.0215, 'lps'),
	(575416, 127, '2014-03-15 00:03:20.000000', 'consum', 0.0217, 'lps'),
	(575417, 127, '2014-03-15 00:03:21.000000', 'consum', 0.0213, 'lps'),
	(575418, 127, '2014-03-15 00:03:22.000000', 'consum', 0.0225, 'lps'),
	(575419, 127, '2014-03-15 00:03:23.000000', 'consum', 0.0219, 'lps'),
	(575420, 127, '2014-03-15 00:03:24.000000', 'consum', 0.0211, 'lps'),
	(575421, 127, '2014-03-15 00:03:25.000000', 'consum', 0.0227, 'lps'),
	(575422, 127, '2014-03-15 00:03:26.000000', 'consum', 0.0218, 'lps'),
	(575423, 127, '2014-03-15 00:03:27.000000', 'consum', 0.0220, 'lps'),
	(575424, 127, '2014-03-15 00:03:28.000000', 'consum', 0.0216, 'lps'),
	(575425, 127, '2014-03-15 00:03:29.000000', 'consum', 0.0211, 'lps'),
	(575426, 127, '2014-03-15 00:03:30.000000', 'consum', 0.0214, 'lps'),
	(575427, 127, '2014-03-15 00:03:31.000000', 'consum', 0.0212, 'lps'),
	(575428, 127, '2014-03-15 00:03:32.000000', 'consum', 0.0224, 'lps'),
	(575429, 127, '2014-03-15 00:03:33.000000', 'consum', 0.0224, 'lps'),
	(575430, 127, '2014-03-15 00:03:34.000000', 'consum', 0.0217, 'lps'),
	(575431, 127, '2014-03-15 00:03:35.000000', 'consum', 0.0222, 'lps'),
	(575432, 127, '2014-03-15 00:03:36.000000', 'consum', 0.0214, 'lps'),
	(575433, 127, '2014-03-15 00:03:37.000000', 'consum', 0.0214, 'lps'),
	(575434, 127, '2014-03-15 00:03:38.000000', 'consum', 0.0218, 'lps'),
	(575435, 127, '2014-03-15 00:03:39.000000', 'consum', 0.0221, 'lps'),
	(575436, 127, '2014-03-15 00:03:40.000000', 'consum', 0.0224, 'lps'),
	(575437, 127, '2014-03-15 00:03:41.000000', 'consum', 0.0212, 'lps'),
	(575438, 127, '2014-03-15 00:03:42.000000', 'consum', 0.0213, 'lps'),
	(575439, 127, '2014-03-15 00:03:43.000000', 'consum', 0.0219, 'lps'),
	(575440, 127, '2014-03-15 00:03:44.000000', 'consum', 0.0213, 'lps'),
	(575441, 127, '2014-03-15 00:03:45.000000', 'consum', 0.0216, 'lps'),
	(575442, 127, '2014-03-15 00:03:46.000000', 'consum', 0.0214, 'lps'),
	(575443, 127, '2014-03-15 00:03:47.000000', 'consum', 0.0212, 'lps'),
	(575444, 127, '2014-03-15 00:03:48.000000', 'consum', 0.0225, 'lps'),
	(575445, 127, '2014-03-15 00:03:49.000000', 'consum', 0.0226, 'lps'),
	(575446, 127, '2014-03-15 00:03:50.000000', 'consum', 0.0226, 'lps'),
	(575447, 127, '2014-03-15 00:03:51.000000', 'consum', 0.0227, 'lps'),
	(575448, 127, '2014-03-15 00:03:52.000000', 'consum', 0.0212, 'lps'),
	(575449, 127, '2014-03-15 00:03:53.000000', 'consum', 0.0222, 'lps'),
	(575450, 127, '2014-03-15 00:03:54.000000', 'consum', 0.0213, 'lps'),
	(575451, 127, '2014-03-15 00:03:55.000000', 'consum', 0.0222, 'lps'),
	(575452, 127, '2014-03-15 00:03:56.000000', 'consum', 0.0210, 'lps'),
	(575453, 127, '2014-03-15 00:03:57.000000', 'consum', 0.0211, 'lps'),
	(575454, 127, '2014-03-15 00:03:58.000000', 'consum', 0.0217, 'lps'),
	(575455, 127, '2014-03-15 00:03:59.000000', 'consum', 0.0221, 'lps'),
	(575456, 127, '2014-03-15 00:04:00.000000', 'consum', 0.0227, 'lps'),
	(575457, 127, '2014-03-15 00:04:01.000000', 'consum', 0.0225, 'lps'),
	(575458, 127, '2014-03-15 00:04:02.000000', 'consum', 0.0220, 'lps'),
	(575459, 127, '2014-03-15 00:04:03.000000', 'consum', 0.0212, 'lps'),
	(575460, 127, '2014-03-15 00:04:04.000000', 'consum', 0.0211, 'lps'),
	(575461, 127, '2014-03-15 00:04:05.000000', 'consum', 0.0211, 'lps'),
	(575462, 127, '2014-03-15 00:04:06.000000', 'consum', 0.0210, 'lps'),
	(575463, 127, '2014-03-15 00:04:07.000000', 'consum', 0.0226, 'lps'),
	(575464, 127, '2014-03-15 00:04:08.000000', 'consum', 0.0217, 'lps'),
	(575465, 127, '2014-03-15 00:04:09.000000', 'consum', 0.0215, 'lps'),
	(575466, 127, '2014-03-15 00:04:10.000000', 'consum', 0.0214, 'lps'),
	(575467, 127, '2014-03-15 00:04:11.000000', 'consum', 0.0215, 'lps'),
	(575468, 127, '2014-03-15 00:04:12.000000', 'consum', 0.0225, 'lps'),
	(575469, 127, '2014-03-15 00:04:13.000000', 'consum', 0.0218, 'lps'),
	(575470, 127, '2014-03-15 00:04:14.000000', 'consum', 0.0222, 'lps'),
	(575471, 127, '2014-03-15 00:04:15.000000', 'consum', 0.0227, 'lps'),
	(575472, 127, '2014-03-15 00:04:16.000000', 'consum', 0.0225, 'lps'),
	(575473, 127, '2014-03-15 00:04:17.000000', 'consum', 0.0215, 'lps'),
	(575474, 127, '2014-03-15 00:04:18.000000', 'consum', 0.0225, 'lps'),
	(575475, 127, '2014-03-15 00:04:19.000000', 'consum', 0.0220, 'lps'),
	(575476, 127, '2014-03-15 00:04:20.000000', 'consum', 0.0212, 'lps'),
	(575477, 127, '2014-03-15 00:04:21.000000', 'consum', 0.0211, 'lps'),
	(575478, 127, '2014-03-15 00:04:22.000000', 'consum', 0.0226, 'lps'),
	(575479, 127, '2014-03-15 00:04:23.000000', 'consum', 0.0218, 'lps'),
	(575480, 127, '2014-03-15 00:04:24.000000', 'consum', 0.0219, 'lps'),
	(575481, 127, '2014-03-15 00:04:25.000000', 'consum', 0.0213, 'lps'),
	(575482, 127, '2014-03-15 00:04:26.000000', 'consum', 0.0219, 'lps'),
	(575483, 127, '2014-03-15 00:04:27.000000', 'consum', 0.0226, 'lps'),
	(575484, 127, '2014-03-15 00:04:28.000000', 'consum', 0.0227, 'lps'),
	(575485, 127, '2014-03-15 00:04:29.000000', 'consum', 0.0213, 'lps'),
	(575486, 127, '2014-03-15 00:04:30.000000', 'consum', 0.0210, 'lps'),
	(575487, 127, '2014-03-15 00:04:31.000000', 'consum', 0.0220, 'lps'),
	(575488, 127, '2014-03-15 00:04:32.000000', 'consum', 0.0223, 'lps'),
	(575489, 127, '2014-03-15 00:04:33.000000', 'consum', 0.0212, 'lps'),
	(575490, 127, '2014-03-15 00:04:34.000000', 'consum', 0.0217, 'lps'),
	(575491, 127, '2014-03-15 00:04:35.000000', 'consum', 0.0219, 'lps'),
	(575492, 127, '2014-03-15 00:04:36.000000', 'consum', 0.0218, 'lps'),
	(575493, 127, '2014-03-15 00:04:37.000000', 'consum', 0.0224, 'lps'),
	(575494, 127, '2014-03-15 00:04:38.000000', 'consum', 0.0222, 'lps'),
	(575495, 127, '2014-03-15 00:04:39.000000', 'consum', 0.0227, 'lps'),
	(575496, 127, '2014-03-15 00:04:40.000000', 'consum', 0.0222, 'lps'),
	(575497, 127, '2014-03-15 00:04:41.000000', 'consum', 0.0219, 'lps'),
	(575498, 127, '2014-03-15 00:04:42.000000', 'consum', 0.0221, 'lps'),
	(575499, 127, '2014-03-15 00:04:43.000000', 'consum', 0.0222, 'lps'),
	(575500, 127, '2014-03-15 00:04:44.000000', 'consum', 0.0219, 'lps'),
	(575501, 127, '2014-03-15 00:04:45.000000', 'consum', 0.0217, 'lps'),
	(575502, 127, '2014-03-15 00:04:46.000000', 'consum', 0.0221, 'lps'),
	(575503, 127, '2014-03-15 00:04:47.000000', 'consum', 0.0227, 'lps'),
	(575504, 127, '2014-03-15 00:04:48.000000', 'consum', 0.0227, 'lps'),
	(575505, 127, '2014-03-15 00:04:49.000000', 'consum', 0.0224, 'lps'),
	(575506, 127, '2014-03-15 00:04:50.000000', 'consum', 0.0212, 'lps'),
	(575507, 127, '2014-03-15 00:04:51.000000', 'consum', 0.0215, 'lps'),
	(575508, 127, '2014-03-15 00:04:52.000000', 'consum', 0.0211, 'lps'),
	(575509, 127, '2014-03-15 00:04:53.000000', 'consum', 0.0219, 'lps'),
	(575510, 127, '2014-03-15 00:04:54.000000', 'consum', 0.0214, 'lps'),
	(575511, 127, '2014-03-15 00:04:55.000000', 'consum', 0.0225, 'lps'),
	(575512, 127, '2014-03-15 00:04:56.000000', 'consum', 0.0216, 'lps'),
	(575513, 127, '2014-03-15 00:04:57.000000', 'consum', 0.0217, 'lps'),
	(575514, 127, '2014-03-15 00:04:58.000000', 'consum', 0.0225, 'lps'),
	(575515, 127, '2014-03-15 00:04:59.000000', 'consum', 0.0227, 'lps'),
	(575516, 127, '2014-03-15 00:05:00.000000', 'consum', 0.0217, 'lps'),
	(575517, 127, '2014-03-15 00:05:01.000000', 'consum', 0.0213, 'lps'),
	(575518, 127, '2014-03-15 00:05:02.000000', 'consum', 0.0222, 'lps'),
	(575519, 127, '2014-03-15 00:05:03.000000', 'consum', 0.0226, 'lps'),
	(575520, 127, '2014-03-15 00:05:04.000000', 'consum', 0.0219, 'lps'),
	(575521, 127, '2014-03-15 00:05:05.000000', 'consum', 0.0224, 'lps'),
	(575522, 127, '2014-03-15 00:05:06.000000', 'consum', 0.0218, 'lps'),
	(575523, 127, '2014-03-15 00:05:07.000000', 'consum', 0.0226, 'lps'),
	(575524, 127, '2014-03-15 00:05:08.000000', 'consum', 0.0212, 'lps'),
	(575525, 127, '2014-03-15 00:05:09.000000', 'consum', 0.0210, 'lps'),
	(575526, 127, '2014-03-15 00:05:10.000000', 'consum', 0.0223, 'lps'),
	(575527, 127, '2014-03-15 00:05:11.000000', 'consum', 0.0219, 'lps'),
	(575528, 127, '2014-03-15 00:05:12.000000', 'consum', 0.0220, 'lps'),
	(575529, 127, '2014-03-15 00:05:13.000000', 'consum', 0.0212, 'lps'),
	(575530, 127, '2014-03-15 00:05:14.000000', 'consum', 0.0227, 'lps'),
	(575531, 127, '2014-03-15 00:05:15.000000', 'consum', 0.0217, 'lps'),
	(575532, 127, '2014-03-15 00:05:16.000000', 'consum', 0.0215, 'lps'),
	(575533, 127, '2014-03-15 00:05:17.000000', 'consum', 0.0212, 'lps'),
	(575534, 127, '2014-03-15 00:05:18.000000', 'consum', 0.0224, 'lps'),
	(575535, 127, '2014-03-15 00:05:19.000000', 'consum', 0.0220, 'lps'),
	(575536, 127, '2014-03-15 00:05:20.000000', 'consum', 0.0221, 'lps'),
	(575537, 127, '2014-03-15 00:05:21.000000', 'consum', 0.0215, 'lps'),
	(575538, 127, '2014-03-15 00:05:22.000000', 'consum', 0.0223, 'lps'),
	(575539, 127, '2014-03-15 00:05:23.000000', 'consum', 0.0224, 'lps'),
	(575540, 127, '2014-03-15 00:05:24.000000', 'consum', 0.0224, 'lps'),
	(575541, 127, '2014-03-15 00:05:25.000000', 'consum', 0.0220, 'lps'),
	(575542, 127, '2014-03-15 00:05:26.000000', 'consum', 0.0219, 'lps'),
	(575543, 127, '2014-03-15 00:05:27.000000', 'consum', 0.0224, 'lps'),
	(575544, 127, '2014-03-15 00:05:28.000000', 'consum', 0.0216, 'lps'),
	(575545, 127, '2014-03-15 00:05:29.000000', 'consum', 0.0219, 'lps'),
	(575546, 127, '2014-03-15 00:05:30.000000', 'consum', 0.0219, 'lps'),
	(575547, 127, '2014-03-15 00:05:31.000000', 'consum', 0.0212, 'lps'),
	(575548, 127, '2014-03-15 00:05:32.000000', 'consum', 0.0212, 'lps'),
	(575549, 127, '2014-03-15 00:05:33.000000', 'consum', 0.0215, 'lps'),
	(575550, 127, '2014-03-15 00:05:34.000000', 'consum', 0.0227, 'lps'),
	(575551, 127, '2014-03-15 00:05:35.000000', 'consum', 0.0210, 'lps'),
	(575552, 127, '2014-03-15 00:05:36.000000', 'consum', 0.0215, 'lps'),
	(575553, 127, '2014-03-15 00:05:37.000000', 'consum', 0.0217, 'lps'),
	(575554, 127, '2014-03-15 00:05:38.000000', 'consum', 0.0213, 'lps'),
	(575555, 127, '2014-03-15 00:05:39.000000', 'consum', 0.0220, 'lps'),
	(575556, 127, '2014-03-15 00:05:40.000000', 'consum', 0.0218, 'lps'),
	(575557, 127, '2014-03-15 00:05:41.000000', 'consum', 0.0218, 'lps'),
	(575558, 127, '2014-03-15 00:05:42.000000', 'consum', 0.0227, 'lps'),
	(575559, 127, '2014-03-15 00:05:43.000000', 'consum', 0.0218, 'lps'),
	(575560, 127, '2014-03-15 00:05:44.000000', 'consum', 0.0219, 'lps'),
	(575561, 127, '2014-03-15 00:05:45.000000', 'consum', 0.0213, 'lps'),
	(575562, 127, '2014-03-15 00:05:46.000000', 'consum', 0.0215, 'lps'),
	(575563, 127, '2014-03-15 00:05:47.000000', 'consum', 0.0225, 'lps'),
	(575564, 127, '2014-03-15 00:05:48.000000', 'consum', 0.0220, 'lps'),
	(575565, 127, '2014-03-15 00:05:49.000000', 'consum', 0.0214, 'lps'),
	(575566, 127, '2014-03-15 00:05:50.000000', 'consum', 0.0219, 'lps'),
	(575567, 127, '2014-03-15 00:05:51.000000', 'consum', 0.0226, 'lps'),
	(575568, 127, '2014-03-15 00:05:52.000000', 'consum', 0.0225, 'lps'),
	(575569, 127, '2014-03-15 00:05:53.000000', 'consum', 0.0221, 'lps'),
	(575570, 127, '2014-03-15 00:05:54.000000', 'consum', 0.0220, 'lps'),
	(575571, 127, '2014-03-15 00:05:55.000000', 'consum', 0.0226, 'lps'),
	(575572, 127, '2014-03-15 00:05:56.000000', 'consum', 0.0225, 'lps'),
	(575573, 127, '2014-03-15 00:05:57.000000', 'consum', 0.0222, 'lps'),
	(575574, 127, '2014-03-15 00:05:58.000000', 'consum', 0.0224, 'lps'),
	(575575, 127, '2014-03-15 00:05:59.000000', 'consum', 0.0226, 'lps'),
	(575576, 127, '2014-03-15 00:06:00.000000', 'consum', 0.0215, 'lps'),
	(575577, 127, '2014-03-15 00:06:01.000000', 'consum', 0.0222, 'lps'),
	(575578, 127, '2014-03-15 00:06:02.000000', 'consum', 0.0218, 'lps'),
	(575579, 127, '2014-03-15 00:06:03.000000', 'consum', 0.0216, 'lps'),
	(575580, 127, '2014-03-15 00:06:04.000000', 'consum', 0.0215, 'lps'),
	(575581, 127, '2014-03-15 00:06:05.000000', 'consum', 0.0218, 'lps'),
	(575582, 127, '2014-03-15 00:06:06.000000', 'consum', 0.0216, 'lps'),
	(575583, 127, '2014-03-15 00:06:07.000000', 'consum', 0.0216, 'lps'),
	(575584, 127, '2014-03-15 00:06:08.000000', 'consum', 0.0226, 'lps'),
	(575585, 127, '2014-03-15 00:06:09.000000', 'consum', 0.0215, 'lps'),
	(575586, 127, '2014-03-15 00:06:10.000000', 'consum', 0.0226, 'lps'),
	(575587, 127, '2014-03-15 00:06:11.000000', 'consum', 0.0219, 'lps'),
	(575588, 127, '2014-03-15 00:06:12.000000', 'consum', 0.0210, 'lps'),
	(575589, 127, '2014-03-15 00:06:13.000000', 'consum', 0.0219, 'lps'),
	(575590, 127, '2014-03-15 00:06:14.000000', 'consum', 0.0218, 'lps'),
	(575591, 127, '2014-03-15 00:06:15.000000', 'consum', 0.0223, 'lps'),
	(575592, 127, '2014-03-15 00:06:16.000000', 'consum', 0.0217, 'lps'),
	(575593, 127, '2014-03-15 00:06:17.000000', 'consum', 0.0224, 'lps'),
	(575594, 127, '2014-03-15 00:06:18.000000', 'consum', 0.0223, 'lps'),
	(575595, 127, '2014-03-15 00:06:19.000000', 'consum', 0.0216, 'lps'),
	(575596, 127, '2014-03-15 00:06:20.000000', 'consum', 0.0221, 'lps'),
	(575597, 127, '2014-03-15 00:06:21.000000', 'consum', 0.0212, 'lps'),
	(575598, 127, '2014-03-15 00:06:22.000000', 'consum', 0.0222, 'lps'),
	(575599, 127, '2014-03-15 00:06:23.000000', 'consum', 0.0227, 'lps'),
	(575600, 127, '2014-03-15 00:06:24.000000', 'consum', 0.0224, 'lps'),
	(575601, 127, '2014-03-15 00:06:25.000000', 'consum', 0.0211, 'lps'),
	(575602, 127, '2014-03-15 00:06:26.000000', 'consum', 0.0211, 'lps'),
	(575603, 127, '2014-03-15 00:06:27.000000', 'consum', 0.0210, 'lps'),
	(575604, 127, '2014-03-15 00:06:28.000000', 'consum', 0.0226, 'lps'),
	(575605, 127, '2014-03-15 00:06:29.000000', 'consum', 0.0220, 'lps'),
	(575606, 127, '2014-03-15 00:06:30.000000', 'consum', 0.0214, 'lps'),
	(575607, 127, '2014-03-15 00:06:31.000000', 'consum', 0.0217, 'lps'),
	(575608, 127, '2014-03-15 00:06:32.000000', 'consum', 0.0214, 'lps'),
	(575609, 127, '2014-03-15 00:06:33.000000', 'consum', 0.0212, 'lps'),
	(575610, 127, '2014-03-15 00:06:34.000000', 'consum', 0.0225, 'lps'),
	(575611, 127, '2014-03-15 00:06:35.000000', 'consum', 0.0224, 'lps'),
	(575612, 127, '2014-03-15 00:06:36.000000', 'consum', 0.0218, 'lps'),
	(575613, 127, '2014-03-15 00:06:37.000000', 'consum', 0.0211, 'lps'),
	(575614, 127, '2014-03-15 00:06:38.000000', 'consum', 0.0225, 'lps'),
	(575615, 127, '2014-03-15 00:06:39.000000', 'consum', 0.0212, 'lps'),
	(575616, 127, '2014-03-15 00:06:40.000000', 'consum', 0.0213, 'lps'),
	(575617, 127, '2014-03-15 00:06:41.000000', 'consum', 0.0217, 'lps'),
	(575618, 127, '2014-03-15 00:06:42.000000', 'consum', 0.0219, 'lps'),
	(575619, 127, '2014-03-15 00:06:43.000000', 'consum', 0.0216, 'lps'),
	(575620, 127, '2014-03-15 00:06:44.000000', 'consum', 0.0212, 'lps'),
	(575621, 127, '2014-03-15 00:06:45.000000', 'consum', 0.0221, 'lps'),
	(575622, 127, '2014-03-15 00:06:46.000000', 'consum', 0.0226, 'lps'),
	(575623, 127, '2014-03-15 00:06:47.000000', 'consum', 0.0221, 'lps'),
	(575624, 127, '2014-03-15 00:06:48.000000', 'consum', 0.0216, 'lps'),
	(575625, 127, '2014-03-15 00:06:49.000000', 'consum', 0.0226, 'lps'),
	(575626, 127, '2014-03-15 00:06:50.000000', 'consum', 0.0219, 'lps'),
	(575627, 127, '2014-03-15 00:06:51.000000', 'consum', 0.0224, 'lps'),
	(575628, 127, '2014-03-15 00:06:52.000000', 'consum', 0.0218, 'lps'),
	(575629, 127, '2014-03-15 00:06:53.000000', 'consum', 0.0210, 'lps'),
	(575630, 127, '2014-03-15 00:06:54.000000', 'consum', 0.0223, 'lps'),
	(575631, 127, '2014-03-15 00:06:55.000000', 'consum', 0.0222, 'lps'),
	(575632, 127, '2014-03-15 00:06:56.000000', 'consum', 0.0213, 'lps'),
	(575633, 127, '2014-03-15 00:06:57.000000', 'consum', 0.0223, 'lps'),
	(575634, 127, '2014-03-15 00:06:58.000000', 'consum', 0.0216, 'lps'),
	(575635, 127, '2014-03-15 00:06:59.000000', 'consum', 0.0217, 'lps'),
	(575636, 127, '2014-03-15 00:07:00.000000', 'consum', 0.0210, 'lps'),
	(575637, 127, '2014-03-15 00:07:01.000000', 'consum', 0.0227, 'lps'),
	(575638, 127, '2014-03-15 00:07:02.000000', 'consum', 0.0222, 'lps'),
	(575639, 127, '2014-03-15 00:07:03.000000', 'consum', 0.0221, 'lps'),
	(575640, 127, '2014-03-15 00:07:04.000000', 'consum', 0.0212, 'lps'),
	(575641, 127, '2014-03-15 00:07:05.000000', 'consum', 0.0225, 'lps'),
	(575642, 127, '2014-03-15 00:07:06.000000', 'consum', 0.0222, 'lps'),
	(575643, 127, '2014-03-15 00:07:07.000000', 'consum', 0.0227, 'lps'),
	(575644, 127, '2014-03-15 00:07:08.000000', 'consum', 0.0223, 'lps'),
	(575645, 127, '2014-03-15 00:07:09.000000', 'consum', 0.0225, 'lps'),
	(575646, 127, '2014-03-15 00:07:10.000000', 'consum', 0.0210, 'lps'),
	(575647, 127, '2014-03-15 00:07:11.000000', 'consum', 0.0221, 'lps'),
	(575648, 127, '2014-03-15 00:07:12.000000', 'consum', 0.0212, 'lps'),
	(575649, 127, '2014-03-15 00:07:13.000000', 'consum', 0.0222, 'lps'),
	(575650, 127, '2014-03-15 00:07:14.000000', 'consum', 0.0211, 'lps'),
	(575651, 127, '2014-03-15 00:07:15.000000', 'consum', 0.0213, 'lps'),
	(575652, 127, '2014-03-15 00:07:16.000000', 'consum', 0.0226, 'lps'),
	(575653, 127, '2014-03-15 00:07:17.000000', 'consum', 0.0225, 'lps'),
	(575654, 127, '2014-03-15 00:07:18.000000', 'consum', 0.0218, 'lps'),
	(575655, 127, '2014-03-15 00:07:19.000000', 'consum', 0.0227, 'lps'),
	(575656, 127, '2014-03-15 00:07:20.000000', 'consum', 0.0215, 'lps'),
	(575657, 127, '2014-03-15 00:07:21.000000', 'consum', 0.0221, 'lps'),
	(575658, 127, '2014-03-15 00:07:22.000000', 'consum', 0.0216, 'lps'),
	(575659, 127, '2014-03-15 00:07:23.000000', 'consum', 0.0225, 'lps'),
	(575660, 127, '2014-03-15 00:07:24.000000', 'consum', 0.0212, 'lps'),
	(575661, 127, '2014-03-15 00:07:25.000000', 'consum', 0.0210, 'lps'),
	(575662, 127, '2014-03-15 00:07:26.000000', 'consum', 0.0226, 'lps'),
	(575663, 127, '2014-03-15 00:07:27.000000', 'consum', 0.0217, 'lps'),
	(575664, 127, '2014-03-15 00:07:28.000000', 'consum', 0.0214, 'lps'),
	(575665, 127, '2014-03-15 00:07:29.000000', 'consum', 0.0227, 'lps'),
	(575666, 127, '2014-03-15 00:07:30.000000', 'consum', 0.0213, 'lps'),
	(575667, 127, '2014-03-15 00:07:31.000000', 'consum', 0.0212, 'lps'),
	(575668, 127, '2014-03-15 00:07:32.000000', 'consum', 0.0210, 'lps'),
	(575669, 127, '2014-03-15 00:07:33.000000', 'consum', 0.0225, 'lps'),
	(575670, 127, '2014-03-15 00:07:34.000000', 'consum', 0.0210, 'lps'),
	(575671, 127, '2014-03-15 00:07:35.000000', 'consum', 0.0221, 'lps'),
	(575672, 127, '2014-03-15 00:07:36.000000', 'consum', 0.0210, 'lps'),
	(575673, 127, '2014-03-15 00:07:37.000000', 'consum', 0.0216, 'lps'),
	(575674, 127, '2014-03-15 00:07:38.000000', 'consum', 0.0223, 'lps'),
	(575675, 127, '2014-03-15 00:07:39.000000', 'consum', 0.0220, 'lps'),
	(575676, 127, '2014-03-15 00:07:40.000000', 'consum', 0.0223, 'lps'),
	(575677, 127, '2014-03-15 00:07:41.000000', 'consum', 0.0225, 'lps'),
	(575678, 127, '2014-03-15 00:07:42.000000', 'consum', 0.0213, 'lps'),
	(575679, 127, '2014-03-15 00:07:43.000000', 'consum', 0.0216, 'lps'),
	(575680, 127, '2014-03-15 00:07:44.000000', 'consum', 0.0213, 'lps'),
	(575681, 127, '2014-03-15 00:07:45.000000', 'consum', 0.0226, 'lps'),
	(575682, 127, '2014-03-15 00:07:46.000000', 'consum', 0.0227, 'lps'),
	(575683, 127, '2014-03-15 00:07:47.000000', 'consum', 0.0210, 'lps'),
	(575684, 127, '2014-03-15 00:07:48.000000', 'consum', 0.0215, 'lps'),
	(575685, 127, '2014-03-15 00:07:49.000000', 'consum', 0.0216, 'lps'),
	(575686, 127, '2014-03-15 00:07:50.000000', 'consum', 0.0226, 'lps'),
	(575687, 127, '2014-03-15 00:07:51.000000', 'consum', 0.0217, 'lps'),
	(575688, 127, '2014-03-15 00:07:52.000000', 'consum', 0.0217, 'lps'),
	(575689, 127, '2014-03-15 00:07:53.000000', 'consum', 0.0223, 'lps'),
	(575690, 127, '2014-03-15 00:07:54.000000', 'consum', 0.0218, 'lps'),
	(575691, 127, '2014-03-15 00:07:55.000000', 'consum', 0.0214, 'lps'),
	(575692, 127, '2014-03-15 00:07:56.000000', 'consum', 0.0221, 'lps'),
	(575693, 127, '2014-03-15 00:07:57.000000', 'consum', 0.0221, 'lps'),
	(575694, 127, '2014-03-15 00:07:58.000000', 'consum', 0.0212, 'lps'),
	(575695, 127, '2014-03-15 00:07:59.000000', 'consum', 0.0224, 'lps'),
	(575696, 127, '2014-03-15 00:08:00.000000', 'consum', 0.0219, 'lps'),
	(575697, 127, '2014-03-15 00:08:01.000000', 'consum', 0.0215, 'lps'),
	(575698, 127, '2014-03-15 00:08:02.000000', 'consum', 0.0225, 'lps'),
	(575699, 127, '2014-03-15 00:08:03.000000', 'consum', 0.0215, 'lps'),
	(575700, 127, '2014-03-15 00:08:04.000000', 'consum', 0.0212, 'lps'),
	(575701, 127, '2014-03-15 00:08:05.000000', 'consum', 0.0221, 'lps'),
	(575702, 127, '2014-03-15 00:08:06.000000', 'consum', 0.0222, 'lps'),
	(575703, 127, '2014-03-15 00:08:07.000000', 'consum', 0.0223, 'lps'),
	(575704, 127, '2014-03-15 00:08:08.000000', 'consum', 0.0219, 'lps'),
	(575705, 127, '2014-03-15 00:08:09.000000', 'consum', 0.0219, 'lps'),
	(575706, 127, '2014-03-15 00:08:10.000000', 'consum', 0.0211, 'lps'),
	(575707, 127, '2014-03-15 00:08:11.000000', 'consum', 0.0224, 'lps'),
	(575708, 127, '2014-03-15 00:08:12.000000', 'consum', 0.0222, 'lps'),
	(575709, 127, '2014-03-15 00:08:13.000000', 'consum', 0.0227, 'lps'),
	(575710, 127, '2014-03-15 00:08:14.000000', 'consum', 0.0226, 'lps'),
	(575711, 127, '2014-03-15 00:08:15.000000', 'consum', 0.0220, 'lps'),
	(575712, 127, '2014-03-15 00:08:16.000000', 'consum', 0.0212, 'lps'),
	(575713, 127, '2014-03-15 00:08:17.000000', 'consum', 0.0225, 'lps'),
	(575714, 127, '2014-03-15 00:08:18.000000', 'consum', 0.0210, 'lps'),
	(575715, 127, '2014-03-15 00:08:19.000000', 'consum', 0.0218, 'lps'),
	(575716, 127, '2014-03-15 00:08:20.000000', 'consum', 0.0217, 'lps'),
	(575717, 127, '2014-03-15 00:08:21.000000', 'consum', 0.0221, 'lps'),
	(575718, 127, '2014-03-15 00:08:22.000000', 'consum', 0.0224, 'lps'),
	(575719, 127, '2014-03-15 00:08:23.000000', 'consum', 0.0215, 'lps'),
	(575720, 127, '2014-03-15 00:08:24.000000', 'consum', 0.0226, 'lps'),
	(575721, 127, '2014-03-15 00:08:25.000000', 'consum', 0.0224, 'lps'),
	(575722, 127, '2014-03-15 00:08:26.000000', 'consum', 0.0213, 'lps'),
	(575723, 127, '2014-03-15 00:08:27.000000', 'consum', 0.0221, 'lps'),
	(575724, 127, '2014-03-15 00:08:28.000000', 'consum', 0.0219, 'lps'),
	(575725, 127, '2014-03-15 00:08:29.000000', 'consum', 0.0225, 'lps'),
	(575726, 127, '2014-03-15 00:08:30.000000', 'consum', 0.0219, 'lps'),
	(575727, 127, '2014-03-15 00:08:31.000000', 'consum', 0.0212, 'lps'),
	(575728, 127, '2014-03-15 00:08:32.000000', 'consum', 0.0213, 'lps'),
	(575729, 127, '2014-03-15 00:08:33.000000', 'consum', 0.0220, 'lps'),
	(575730, 127, '2014-03-15 00:08:34.000000', 'consum', 0.0216, 'lps'),
	(575731, 127, '2014-03-15 00:08:35.000000', 'consum', 0.0211, 'lps'),
	(575732, 127, '2014-03-15 00:08:36.000000', 'consum', 0.0212, 'lps'),
	(575733, 127, '2014-03-15 00:08:37.000000', 'consum', 0.0221, 'lps'),
	(575734, 127, '2014-03-15 00:08:38.000000', 'consum', 0.0220, 'lps'),
	(575735, 127, '2014-03-15 00:08:39.000000', 'consum', 0.0212, 'lps'),
	(575736, 127, '2014-03-15 00:08:40.000000', 'consum', 0.0227, 'lps'),
	(575737, 127, '2014-03-15 00:08:41.000000', 'consum', 0.0216, 'lps'),
	(575738, 127, '2014-03-15 00:08:42.000000', 'consum', 0.0224, 'lps'),
	(575739, 127, '2014-03-15 00:08:43.000000', 'consum', 0.0227, 'lps'),
	(575740, 127, '2014-03-15 00:08:44.000000', 'consum', 0.0220, 'lps'),
	(575741, 127, '2014-03-15 00:08:45.000000', 'consum', 0.0225, 'lps'),
	(575742, 127, '2014-03-15 00:08:46.000000', 'consum', 0.0219, 'lps'),
	(575743, 127, '2014-03-15 00:08:47.000000', 'consum', 0.0211, 'lps'),
	(575744, 127, '2014-03-15 00:08:48.000000', 'consum', 0.0226, 'lps'),
	(575745, 127, '2014-03-15 00:08:49.000000', 'consum', 0.0216, 'lps'),
	(575746, 127, '2014-03-15 00:08:50.000000', 'consum', 0.0226, 'lps'),
	(575747, 127, '2014-03-15 00:08:51.000000', 'consum', 0.0221, 'lps'),
	(575748, 127, '2014-03-15 00:08:52.000000', 'consum', 0.0217, 'lps'),
	(575749, 127, '2014-03-15 00:08:53.000000', 'consum', 0.0211, 'lps'),
	(575750, 127, '2014-03-15 00:08:54.000000', 'consum', 0.0212, 'lps'),
	(575751, 127, '2014-03-15 00:08:55.000000', 'consum', 0.0217, 'lps'),
	(575752, 127, '2014-03-15 00:08:56.000000', 'consum', 0.0224, 'lps'),
	(575753, 127, '2014-03-15 00:08:57.000000', 'consum', 0.0221, 'lps'),
	(575754, 127, '2014-03-15 00:08:58.000000', 'consum', 0.0224, 'lps'),
	(575755, 127, '2014-03-15 00:08:59.000000', 'consum', 0.0211, 'lps'),
	(575756, 127, '2014-03-15 00:09:00.000000', 'consum', 0.0210, 'lps'),
	(575757, 127, '2014-03-15 00:09:01.000000', 'consum', 0.0227, 'lps'),
	(575758, 127, '2014-03-15 00:09:02.000000', 'consum', 0.0222, 'lps'),
	(575759, 127, '2014-03-15 00:09:03.000000', 'consum', 0.0219, 'lps'),
	(575760, 127, '2014-03-15 00:09:04.000000', 'consum', 0.0222, 'lps'),
	(575761, 127, '2014-03-15 00:09:05.000000', 'consum', 0.0222, 'lps'),
	(575762, 127, '2014-03-15 00:09:06.000000', 'consum', 0.0220, 'lps'),
	(575763, 127, '2014-03-15 00:09:07.000000', 'consum', 0.0221, 'lps'),
	(575764, 127, '2014-03-15 00:09:08.000000', 'consum', 0.0219, 'lps'),
	(575765, 127, '2014-03-15 00:09:09.000000', 'consum', 0.0223, 'lps'),
	(575766, 127, '2014-03-15 00:09:10.000000', 'consum', 0.0212, 'lps'),
	(575767, 127, '2014-03-15 00:09:11.000000', 'consum', 0.0216, 'lps'),
	(575768, 127, '2014-03-15 00:09:12.000000', 'consum', 0.0218, 'lps'),
	(575769, 127, '2014-03-15 00:09:13.000000', 'consum', 0.0215, 'lps'),
	(575770, 127, '2014-03-15 00:09:14.000000', 'consum', 0.0211, 'lps'),
	(575771, 127, '2014-03-15 00:09:15.000000', 'consum', 0.0217, 'lps'),
	(575772, 127, '2014-03-15 00:09:16.000000', 'consum', 0.0225, 'lps'),
	(575773, 127, '2014-03-15 00:09:17.000000', 'consum', 0.0212, 'lps'),
	(575774, 127, '2014-03-15 00:09:18.000000', 'consum', 0.0211, 'lps'),
	(575775, 127, '2014-03-15 00:09:19.000000', 'consum', 0.0226, 'lps'),
	(575776, 127, '2014-03-15 00:09:20.000000', 'consum', 0.0218, 'lps'),
	(575777, 127, '2014-03-15 00:09:21.000000', 'consum', 0.0221, 'lps'),
	(575778, 127, '2014-03-15 00:09:22.000000', 'consum', 0.0224, 'lps'),
	(575779, 127, '2014-03-15 00:09:23.000000', 'consum', 0.0211, 'lps'),
	(575780, 127, '2014-03-15 00:09:24.000000', 'consum', 0.0227, 'lps'),
	(575781, 127, '2014-03-15 00:09:25.000000', 'consum', 0.0219, 'lps'),
	(575782, 127, '2014-03-15 00:09:26.000000', 'consum', 0.0224, 'lps'),
	(575783, 127, '2014-03-15 00:09:27.000000', 'consum', 0.0219, 'lps'),
	(575784, 127, '2014-03-15 00:09:28.000000', 'consum', 0.0214, 'lps'),
	(575785, 127, '2014-03-15 00:09:29.000000', 'consum', 0.0218, 'lps'),
	(575786, 127, '2014-03-15 00:09:30.000000', 'consum', 0.0224, 'lps'),
	(575787, 127, '2014-03-15 00:09:31.000000', 'consum', 0.0218, 'lps'),
	(575788, 127, '2014-03-15 00:09:32.000000', 'consum', 0.0227, 'lps'),
	(575789, 127, '2014-03-15 00:09:33.000000', 'consum', 0.0219, 'lps'),
	(575790, 127, '2014-03-15 00:09:34.000000', 'consum', 0.0221, 'lps'),
	(575791, 127, '2014-03-15 00:09:35.000000', 'consum', 0.0220, 'lps'),
	(575792, 127, '2014-03-15 00:09:36.000000', 'consum', 0.0212, 'lps'),
	(575793, 127, '2014-03-15 00:09:37.000000', 'consum', 0.0226, 'lps'),
	(575794, 127, '2014-03-15 00:09:38.000000', 'consum', 0.0213, 'lps'),
	(575795, 127, '2014-03-15 00:09:39.000000', 'consum', 0.0212, 'lps'),
	(575796, 127, '2014-03-15 00:09:40.000000', 'consum', 0.0213, 'lps'),
	(575797, 127, '2014-03-15 00:09:41.000000', 'consum', 0.0217, 'lps'),
	(575798, 127, '2014-03-15 00:09:42.000000', 'consum', 0.0221, 'lps'),
	(575799, 127, '2014-03-15 00:09:43.000000', 'consum', 0.0227, 'lps'),
	(575800, 127, '2014-03-15 00:09:44.000000', 'consum', 0.0224, 'lps'),
	(575801, 127, '2014-03-15 00:09:45.000000', 'consum', 0.0212, 'lps'),
	(575802, 127, '2014-03-15 00:09:46.000000', 'consum', 0.0215, 'lps'),
	(575803, 127, '2014-03-15 00:09:47.000000', 'consum', 0.0212, 'lps'),
	(575804, 127, '2014-03-15 00:09:48.000000', 'consum', 0.0224, 'lps'),
	(575805, 127, '2014-03-15 00:09:49.000000', 'consum', 0.0219, 'lps'),
	(575806, 127, '2014-03-15 00:09:50.000000', 'consum', 0.0216, 'lps'),
	(575807, 127, '2014-03-15 00:09:51.000000', 'consum', 0.0212, 'lps'),
	(575808, 127, '2014-03-15 00:09:52.000000', 'consum', 0.0221, 'lps'),
	(575809, 127, '2014-03-15 00:09:53.000000', 'consum', 0.0224, 'lps'),
	(575810, 127, '2014-03-15 00:09:54.000000', 'consum', 0.0211, 'lps'),
	(575811, 127, '2014-03-15 00:09:55.000000', 'consum', 0.0226, 'lps'),
	(575812, 127, '2014-03-15 00:09:56.000000', 'consum', 0.0218, 'lps'),
	(575813, 127, '2014-03-15 00:09:57.000000', 'consum', 0.0220, 'lps'),
	(575814, 127, '2014-03-15 00:09:58.000000', 'consum', 0.0217, 'lps'),
	(575815, 127, '2014-03-15 00:09:59.000000', 'consum', 0.0217, 'lps'),
	(575816, 127, '2014-03-15 00:10:00.000000', 'consum', 0.0223, 'lps'),
	(575817, 127, '2014-03-15 00:10:01.000000', 'consum', 0.0220, 'lps'),
	(575818, 127, '2014-03-15 00:10:02.000000', 'consum', 0.0223, 'lps'),
	(575819, 127, '2014-03-15 00:10:03.000000', 'consum', 0.0226, 'lps'),
	(575820, 127, '2014-03-15 00:10:04.000000', 'consum', 0.0217, 'lps'),
	(575821, 127, '2014-03-15 00:10:05.000000', 'consum', 0.0215, 'lps'),
	(575822, 127, '2014-03-15 00:10:06.000000', 'consum', 0.0216, 'lps'),
	(575823, 127, '2014-03-15 00:10:07.000000', 'consum', 0.0224, 'lps'),
	(575824, 127, '2014-03-15 00:10:08.000000', 'consum', 0.0210, 'lps'),
	(575825, 127, '2014-03-15 00:10:09.000000', 'consum', 0.0220, 'lps'),
	(575826, 127, '2014-03-15 00:10:10.000000', 'consum', 0.0227, 'lps'),
	(575827, 127, '2014-03-15 00:10:11.000000', 'consum', 0.0212, 'lps'),
	(575828, 127, '2014-03-15 00:10:12.000000', 'consum', 0.0222, 'lps'),
	(575829, 127, '2014-03-15 00:10:13.000000', 'consum', 0.0210, 'lps'),
	(575830, 127, '2014-03-15 00:10:14.000000', 'consum', 0.0210, 'lps'),
	(575831, 127, '2014-03-15 00:10:15.000000', 'consum', 0.0210, 'lps'),
	(575832, 127, '2014-03-15 00:10:16.000000', 'consum', 0.0210, 'lps'),
	(575833, 127, '2014-03-15 00:10:17.000000', 'consum', 0.0211, 'lps'),
	(575834, 127, '2014-03-15 00:10:18.000000', 'consum', 0.0214, 'lps'),
	(575835, 127, '2014-03-15 00:10:19.000000', 'consum', 0.0210, 'lps'),
	(575836, 127, '2014-03-15 00:10:20.000000', 'consum', 0.0215, 'lps'),
	(575837, 127, '2014-03-15 00:10:21.000000', 'consum', 0.0221, 'lps'),
	(575838, 127, '2014-03-15 00:10:22.000000', 'consum', 0.0213, 'lps'),
	(575839, 127, '2014-03-15 00:10:23.000000', 'consum', 0.0210, 'lps'),
	(575840, 127, '2014-03-15 00:10:24.000000', 'consum', 0.0221, 'lps'),
	(575841, 127, '2014-03-15 00:10:25.000000', 'consum', 0.0227, 'lps'),
	(575842, 127, '2014-03-15 00:10:26.000000', 'consum', 0.0227, 'lps'),
	(575843, 127, '2014-03-15 00:10:27.000000', 'consum', 0.0227, 'lps'),
	(575844, 127, '2014-03-15 00:10:28.000000', 'consum', 0.0225, 'lps'),
	(575845, 127, '2014-03-15 00:10:29.000000', 'consum', 0.0216, 'lps'),
	(575846, 127, '2014-03-15 00:10:30.000000', 'consum', 0.0213, 'lps'),
	(575847, 127, '2014-03-15 00:10:31.000000', 'consum', 0.0226, 'lps'),
	(575848, 127, '2014-03-15 00:10:32.000000', 'consum', 0.0210, 'lps'),
	(575849, 127, '2014-03-15 00:10:33.000000', 'consum', 0.0215, 'lps'),
	(575850, 127, '2014-03-15 00:10:34.000000', 'consum', 0.0219, 'lps'),
	(575851, 127, '2014-03-15 00:10:35.000000', 'consum', 0.0224, 'lps'),
	(575852, 127, '2014-03-15 00:10:36.000000', 'consum', 0.0216, 'lps'),
	(575853, 127, '2014-03-15 00:10:37.000000', 'consum', 0.0217, 'lps'),
	(575854, 127, '2014-03-15 00:10:38.000000', 'consum', 0.0211, 'lps'),
	(575855, 127, '2014-03-15 00:10:39.000000', 'consum', 0.0212, 'lps'),
	(575856, 127, '2014-03-15 00:10:40.000000', 'consum', 0.0215, 'lps'),
	(575857, 127, '2014-03-15 00:10:41.000000', 'consum', 0.0214, 'lps'),
	(575858, 127, '2014-03-15 00:10:42.000000', 'consum', 0.0213, 'lps'),
	(575859, 127, '2014-03-15 00:10:43.000000', 'consum', 0.0214, 'lps'),
	(575860, 127, '2014-03-15 00:10:44.000000', 'consum', 0.0224, 'lps'),
	(575861, 127, '2014-03-15 00:10:45.000000', 'consum', 0.0214, 'lps'),
	(575862, 127, '2014-03-15 00:10:46.000000', 'consum', 0.0223, 'lps'),
	(575863, 127, '2014-03-15 00:10:47.000000', 'consum', 0.0226, 'lps'),
	(575864, 127, '2014-03-15 00:10:48.000000', 'consum', 0.0218, 'lps'),
	(575865, 127, '2014-03-15 00:10:49.000000', 'consum', 0.0218, 'lps'),
	(575866, 127, '2014-03-15 00:10:50.000000', 'consum', 0.0212, 'lps'),
	(575867, 127, '2014-03-15 00:10:51.000000', 'consum', 0.0211, 'lps'),
	(575868, 127, '2014-03-15 00:10:52.000000', 'consum', 0.0213, 'lps'),
	(575869, 127, '2014-03-15 00:10:53.000000', 'consum', 0.0221, 'lps'),
	(575870, 127, '2014-03-15 00:10:54.000000', 'consum', 0.0220, 'lps'),
	(575871, 127, '2014-03-15 00:10:55.000000', 'consum', 0.0210, 'lps'),
	(575872, 127, '2014-03-15 00:10:56.000000', 'consum', 0.0218, 'lps'),
	(575873, 127, '2014-03-15 00:10:57.000000', 'consum', 0.0215, 'lps'),
	(575874, 127, '2014-03-15 00:10:58.000000', 'consum', 0.0227, 'lps'),
	(575875, 127, '2014-03-15 00:10:59.000000', 'consum', 0.0226, 'lps'),
	(575876, 127, '2014-03-15 00:11:00.000000', 'consum', 0.0223, 'lps'),
	(575877, 127, '2014-03-15 00:11:01.000000', 'consum', 0.0210, 'lps'),
	(575878, 127, '2014-03-15 00:11:02.000000', 'consum', 0.0224, 'lps'),
	(575879, 127, '2014-03-15 00:11:03.000000', 'consum', 0.0226, 'lps'),
	(575880, 127, '2014-03-15 00:11:04.000000', 'consum', 0.0212, 'lps'),
	(575881, 127, '2014-03-15 00:11:05.000000', 'consum', 0.0211, 'lps'),
	(575882, 127, '2014-03-15 00:11:06.000000', 'consum', 0.0227, 'lps'),
	(575883, 127, '2014-03-15 00:11:07.000000', 'consum', 0.0220, 'lps'),
	(575884, 127, '2014-03-15 00:11:08.000000', 'consum', 0.0210, 'lps'),
	(575885, 127, '2014-03-15 00:11:09.000000', 'consum', 0.0218, 'lps'),
	(575886, 127, '2014-03-15 00:11:10.000000', 'consum', 0.0213, 'lps'),
	(575887, 127, '2014-03-15 00:11:11.000000', 'consum', 0.0221, 'lps'),
	(575888, 127, '2014-03-15 00:11:12.000000', 'consum', 0.0221, 'lps'),
	(575889, 127, '2014-03-15 00:11:13.000000', 'consum', 0.0214, 'lps'),
	(575890, 127, '2014-03-15 00:11:14.000000', 'consum', 0.0213, 'lps'),
	(575891, 127, '2014-03-15 00:11:15.000000', 'consum', 0.0216, 'lps'),
	(575892, 127, '2014-03-15 00:11:16.000000', 'consum', 0.0212, 'lps'),
	(575893, 127, '2014-03-15 00:11:17.000000', 'consum', 0.0222, 'lps'),
	(575894, 127, '2014-03-15 00:11:18.000000', 'consum', 0.0227, 'lps'),
	(575895, 127, '2014-03-15 00:11:19.000000', 'consum', 0.0222, 'lps'),
	(575896, 127, '2014-03-15 00:11:20.000000', 'consum', 0.0223, 'lps'),
	(575897, 127, '2014-03-15 00:11:21.000000', 'consum', 0.0219, 'lps'),
	(575898, 127, '2014-03-15 00:11:22.000000', 'consum', 0.0216, 'lps'),
	(575899, 127, '2014-03-15 00:11:23.000000', 'consum', 0.0215, 'lps'),
	(575900, 127, '2014-03-15 00:11:24.000000', 'consum', 0.0217, 'lps'),
	(575901, 127, '2014-03-15 00:11:25.000000', 'consum', 0.0213, 'lps'),
	(575902, 127, '2014-03-15 00:11:26.000000', 'consum', 0.0222, 'lps'),
	(575903, 127, '2014-03-15 00:11:27.000000', 'consum', 0.0225, 'lps'),
	(575904, 127, '2014-03-15 00:11:28.000000', 'consum', 0.0214, 'lps'),
	(575905, 127, '2014-03-15 00:11:29.000000', 'consum', 0.0219, 'lps'),
	(575906, 127, '2014-03-15 00:11:30.000000', 'consum', 0.0211, 'lps'),
	(575907, 127, '2014-03-15 00:11:31.000000', 'consum', 0.0225, 'lps'),
	(575908, 127, '2014-03-15 00:11:32.000000', 'consum', 0.0225, 'lps'),
	(575909, 127, '2014-03-15 00:11:33.000000', 'consum', 0.0225, 'lps'),
	(575910, 127, '2014-03-15 00:11:34.000000', 'consum', 0.0221, 'lps'),
	(575911, 127, '2014-03-15 00:11:35.000000', 'consum', 0.0221, 'lps'),
	(575912, 127, '2014-03-15 00:11:36.000000', 'consum', 0.0216, 'lps'),
	(575913, 127, '2014-03-15 00:11:37.000000', 'consum', 0.0222, 'lps'),
	(575914, 127, '2014-03-15 00:11:38.000000', 'consum', 0.0220, 'lps'),
	(575915, 127, '2014-03-15 00:11:39.000000', 'consum', 0.0222, 'lps'),
	(575916, 127, '2014-03-15 00:11:40.000000', 'consum', 0.0225, 'lps'),
	(575917, 127, '2014-03-15 00:11:41.000000', 'consum', 0.0213, 'lps'),
	(575918, 127, '2014-03-15 00:11:42.000000', 'consum', 0.0217, 'lps'),
	(575919, 127, '2014-03-15 00:11:43.000000', 'consum', 0.0220, 'lps'),
	(575920, 127, '2014-03-15 00:11:44.000000', 'consum', 0.0220, 'lps'),
	(575921, 127, '2014-03-15 00:11:45.000000', 'consum', 0.0211, 'lps'),
	(575922, 127, '2014-03-15 00:11:46.000000', 'consum', 0.0222, 'lps'),
	(575923, 127, '2014-03-15 00:11:47.000000', 'consum', 0.0213, 'lps'),
	(575924, 127, '2014-03-15 00:11:48.000000', 'consum', 0.0227, 'lps'),
	(575925, 127, '2014-03-15 00:11:49.000000', 'consum', 0.0212, 'lps'),
	(575926, 127, '2014-03-15 00:11:50.000000', 'consum', 0.0226, 'lps'),
	(575927, 127, '2014-03-15 00:11:51.000000', 'consum', 0.0213, 'lps'),
	(575928, 127, '2014-03-15 00:11:52.000000', 'consum', 0.0213, 'lps'),
	(575929, 127, '2014-03-15 00:11:53.000000', 'consum', 0.0217, 'lps'),
	(575930, 127, '2014-03-15 00:11:54.000000', 'consum', 0.0216, 'lps'),
	(575931, 127, '2014-03-15 00:11:55.000000', 'consum', 0.0222, 'lps'),
	(575932, 127, '2014-03-15 00:11:56.000000', 'consum', 0.0216, 'lps'),
	(575933, 127, '2014-03-15 00:11:57.000000', 'consum', 0.0221, 'lps'),
	(575934, 127, '2014-03-15 00:11:58.000000', 'consum', 0.0214, 'lps'),
	(575935, 127, '2014-03-15 00:11:59.000000', 'consum', 0.0213, 'lps'),
	(575936, 127, '2014-03-15 00:12:00.000000', 'consum', 0.0216, 'lps'),
	(575937, 127, '2014-03-15 00:12:01.000000', 'consum', 0.0214, 'lps'),
	(575938, 127, '2014-03-15 00:12:02.000000', 'consum', 0.0212, 'lps'),
	(575939, 127, '2014-03-15 00:12:03.000000', 'consum', 0.0227, 'lps'),
	(575940, 127, '2014-03-15 00:12:04.000000', 'consum', 0.0215, 'lps'),
	(575941, 127, '2014-03-15 00:12:05.000000', 'consum', 0.0224, 'lps'),
	(575942, 127, '2014-03-15 00:12:06.000000', 'consum', 0.0227, 'lps'),
	(575943, 127, '2014-03-15 00:12:07.000000', 'consum', 0.0218, 'lps'),
	(575944, 127, '2014-03-15 00:12:08.000000', 'consum', 0.0218, 'lps'),
	(575945, 127, '2014-03-15 00:12:09.000000', 'consum', 0.0225, 'lps'),
	(575946, 127, '2014-03-15 00:12:10.000000', 'consum', 0.0210, 'lps'),
	(575947, 127, '2014-03-15 00:12:11.000000', 'consum', 0.0219, 'lps'),
	(575948, 127, '2014-03-15 00:12:12.000000', 'consum', 0.0221, 'lps'),
	(575949, 127, '2014-03-15 00:12:13.000000', 'consum', 0.0217, 'lps'),
	(575950, 127, '2014-03-15 00:12:14.000000', 'consum', 0.0216, 'lps'),
	(575951, 127, '2014-03-15 00:12:15.000000', 'consum', 0.0216, 'lps'),
	(575952, 127, '2014-03-15 00:12:16.000000', 'consum', 0.0225, 'lps'),
	(575953, 127, '2014-03-15 00:12:17.000000', 'consum', 0.0214, 'lps'),
	(575954, 127, '2014-03-15 00:12:18.000000', 'consum', 0.0221, 'lps'),
	(575955, 127, '2014-03-15 00:12:19.000000', 'consum', 0.0218, 'lps'),
	(575956, 127, '2014-03-15 00:12:20.000000', 'consum', 0.0218, 'lps'),
	(575957, 127, '2014-03-15 00:12:21.000000', 'consum', 0.0227, 'lps'),
	(575958, 127, '2014-03-15 00:12:22.000000', 'consum', 0.0216, 'lps'),
	(575959, 127, '2014-03-15 00:12:23.000000', 'consum', 0.0226, 'lps'),
	(575960, 127, '2014-03-15 00:12:24.000000', 'consum', 0.0219, 'lps'),
	(575961, 127, '2014-03-15 00:12:25.000000', 'consum', 0.0223, 'lps'),
	(575962, 127, '2014-03-15 00:12:26.000000', 'consum', 0.0215, 'lps'),
	(575963, 127, '2014-03-15 00:12:27.000000', 'consum', 0.0212, 'lps'),
	(575964, 127, '2014-03-15 00:12:28.000000', 'consum', 0.0226, 'lps'),
	(575965, 127, '2014-03-15 00:12:29.000000', 'consum', 0.0212, 'lps'),
	(575966, 127, '2014-03-15 00:12:30.000000', 'consum', 0.0227, 'lps'),
	(575967, 127, '2014-03-15 00:12:31.000000', 'consum', 0.0217, 'lps'),
	(575968, 127, '2014-03-15 00:12:32.000000', 'consum', 0.0211, 'lps'),
	(575969, 127, '2014-03-15 00:12:33.000000', 'consum', 0.0214, 'lps'),
	(575970, 127, '2014-03-15 00:12:34.000000', 'consum', 0.0226, 'lps'),
	(575971, 127, '2014-03-15 00:12:35.000000', 'consum', 0.0224, 'lps'),
	(575972, 127, '2014-03-15 00:12:36.000000', 'consum', 0.0215, 'lps'),
	(575973, 127, '2014-03-15 00:12:37.000000', 'consum', 0.0210, 'lps'),
	(575974, 127, '2014-03-15 00:12:38.000000', 'consum', 0.0215, 'lps'),
	(575975, 127, '2014-03-15 00:12:39.000000', 'consum', 0.0216, 'lps'),
	(575976, 127, '2014-03-15 00:12:40.000000', 'consum', 0.0225, 'lps'),
	(575977, 127, '2014-03-15 00:12:41.000000', 'consum', 0.0215, 'lps'),
	(575978, 127, '2014-03-15 00:12:42.000000', 'consum', 0.0227, 'lps'),
	(575979, 127, '2014-03-15 00:12:43.000000', 'consum', 0.0210, 'lps'),
	(575980, 127, '2014-03-15 00:12:44.000000', 'consum', 0.0212, 'lps'),
	(575981, 127, '2014-03-15 00:12:45.000000', 'consum', 0.0221, 'lps'),
	(575982, 127, '2014-03-15 00:12:46.000000', 'consum', 0.0224, 'lps'),
	(575983, 127, '2014-03-15 00:12:47.000000', 'consum', 0.0210, 'lps'),
	(575984, 127, '2014-03-15 00:12:48.000000', 'consum', 0.0223, 'lps'),
	(575985, 127, '2014-03-15 00:12:49.000000', 'consum', 0.0221, 'lps'),
	(575986, 127, '2014-03-15 00:12:50.000000', 'consum', 0.0226, 'lps'),
	(575987, 127, '2014-03-15 00:12:51.000000', 'consum', 0.0222, 'lps'),
	(575988, 127, '2014-03-15 00:12:52.000000', 'consum', 0.0221, 'lps'),
	(575989, 127, '2014-03-15 00:12:53.000000', 'consum', 0.0211, 'lps'),
	(575990, 127, '2014-03-15 00:12:54.000000', 'consum', 0.0220, 'lps'),
	(575991, 127, '2014-03-15 00:12:55.000000', 'consum', 0.0223, 'lps'),
	(575992, 127, '2014-03-15 00:12:56.000000', 'consum', 0.0226, 'lps'),
	(575993, 127, '2014-03-15 00:12:57.000000', 'consum', 0.0214, 'lps'),
	(575994, 127, '2014-03-15 00:12:58.000000', 'consum', 0.0221, 'lps'),
	(575995, 127, '2014-03-15 00:12:59.000000', 'consum', 0.0215, 'lps'),
	(575996, 127, '2014-03-15 00:13:00.000000', 'consum', 0.0223, 'lps'),
	(575997, 127, '2014-03-15 00:13:01.000000', 'consum', 0.0225, 'lps'),
	(575998, 127, '2014-03-15 00:13:02.000000', 'consum', 0.0225, 'lps'),
	(575999, 127, '2014-03-15 00:13:03.000000', 'consum', 0.0226, 'lps'),
	(576000, 127, '2014-03-15 00:13:04.000000', 'consum', 0.0225, 'lps'),
	(576001, 127, '2014-03-15 00:13:05.000000', 'consum', 0.0222, 'lps'),
	(576002, 127, '2014-03-15 00:13:06.000000', 'consum', 0.0223, 'lps'),
	(576003, 127, '2014-03-15 00:13:07.000000', 'consum', 0.0224, 'lps'),
	(576004, 127, '2014-03-15 00:13:08.000000', 'consum', 0.0223, 'lps'),
	(576005, 127, '2014-03-15 00:13:09.000000', 'consum', 0.0217, 'lps'),
	(576006, 127, '2014-03-15 00:13:10.000000', 'consum', 0.0221, 'lps'),
	(576007, 127, '2014-03-15 00:13:11.000000', 'consum', 0.0211, 'lps'),
	(576008, 127, '2014-03-15 00:13:12.000000', 'consum', 0.0219, 'lps'),
	(576009, 127, '2014-03-15 00:13:13.000000', 'consum', 0.0217, 'lps'),
	(576010, 127, '2014-03-15 00:13:14.000000', 'consum', 0.0216, 'lps'),
	(576011, 127, '2014-03-15 00:13:15.000000', 'consum', 0.0221, 'lps'),
	(576012, 127, '2014-03-15 00:13:16.000000', 'consum', 0.0213, 'lps'),
	(576013, 127, '2014-03-15 00:13:17.000000', 'consum', 0.0210, 'lps'),
	(576014, 127, '2014-03-15 00:13:18.000000', 'consum', 0.0220, 'lps'),
	(576015, 127, '2014-03-15 00:13:19.000000', 'consum', 0.0223, 'lps'),
	(576016, 127, '2014-03-15 00:13:20.000000', 'consum', 0.0210, 'lps'),
	(576017, 127, '2014-03-15 00:13:21.000000', 'consum', 0.0226, 'lps'),
	(576018, 127, '2014-03-15 00:13:22.000000', 'consum', 0.0217, 'lps'),
	(576019, 127, '2014-03-15 00:13:23.000000', 'consum', 0.0214, 'lps'),
	(576020, 127, '2014-03-15 00:13:24.000000', 'consum', 0.0212, 'lps'),
	(576021, 127, '2014-03-15 00:13:25.000000', 'consum', 0.0226, 'lps'),
	(576022, 127, '2014-03-15 00:13:26.000000', 'consum', 0.0212, 'lps'),
	(576023, 127, '2014-03-15 00:13:27.000000', 'consum', 0.0226, 'lps'),
	(576024, 127, '2014-03-15 00:13:28.000000', 'consum', 0.0212, 'lps'),
	(576025, 127, '2014-03-15 00:13:29.000000', 'consum', 0.0210, 'lps'),
	(576026, 127, '2014-03-15 00:13:30.000000', 'consum', 0.0224, 'lps'),
	(576027, 127, '2014-03-15 00:13:31.000000', 'consum', 0.0225, 'lps'),
	(576028, 127, '2014-03-15 00:13:32.000000', 'consum', 0.0225, 'lps'),
	(576029, 127, '2014-03-15 00:13:33.000000', 'consum', 0.0225, 'lps'),
	(576030, 127, '2014-03-15 00:13:34.000000', 'consum', 0.0220, 'lps'),
	(576031, 127, '2014-03-15 00:13:35.000000', 'consum', 0.0217, 'lps'),
	(576032, 127, '2014-03-15 00:13:36.000000', 'consum', 0.0214, 'lps'),
	(576033, 127, '2014-03-15 00:13:37.000000', 'consum', 0.0227, 'lps'),
	(576034, 127, '2014-03-15 00:13:38.000000', 'consum', 0.0212, 'lps'),
	(576035, 127, '2014-03-15 00:13:39.000000', 'consum', 0.0225, 'lps'),
	(576036, 127, '2014-03-15 00:13:40.000000', 'consum', 0.0224, 'lps'),
	(576037, 127, '2014-03-15 00:13:41.000000', 'consum', 0.0219, 'lps'),
	(576038, 127, '2014-03-15 00:13:42.000000', 'consum', 0.0214, 'lps'),
	(576039, 127, '2014-03-15 00:13:43.000000', 'consum', 0.0223, 'lps'),
	(576040, 127, '2014-03-15 00:13:44.000000', 'consum', 0.0224, 'lps'),
	(576041, 127, '2014-03-15 00:13:45.000000', 'consum', 0.0224, 'lps'),
	(576042, 127, '2014-03-15 00:13:46.000000', 'consum', 0.0222, 'lps'),
	(576043, 127, '2014-03-15 00:13:47.000000', 'consum', 0.0210, 'lps'),
	(576044, 127, '2014-03-15 00:13:48.000000', 'consum', 0.0210, 'lps'),
	(576045, 127, '2014-03-15 00:13:49.000000', 'consum', 0.0213, 'lps'),
	(576046, 127, '2014-03-15 00:13:50.000000', 'consum', 0.0222, 'lps'),
	(576047, 127, '2014-03-15 00:13:51.000000', 'consum', 0.0210, 'lps'),
	(576048, 127, '2014-03-15 00:13:52.000000', 'consum', 0.0210, 'lps'),
	(576049, 127, '2014-03-15 00:13:53.000000', 'consum', 0.0227, 'lps'),
	(576050, 127, '2014-03-15 00:13:54.000000', 'consum', 0.0222, 'lps'),
	(576051, 127, '2014-03-15 00:13:55.000000', 'consum', 0.0223, 'lps'),
	(576052, 127, '2014-03-15 00:13:56.000000', 'consum', 0.0220, 'lps'),
	(576053, 127, '2014-03-15 00:13:57.000000', 'consum', 0.0222, 'lps'),
	(576054, 127, '2014-03-15 00:13:58.000000', 'consum', 0.0220, 'lps'),
	(576055, 127, '2014-03-15 00:13:59.000000', 'consum', 0.0210, 'lps'),
	(576056, 127, '2014-03-15 00:14:00.000000', 'consum', 0.0213, 'lps'),
	(576057, 127, '2014-03-15 00:14:01.000000', 'consum', 0.0210, 'lps'),
	(576058, 127, '2014-03-15 00:14:02.000000', 'consum', 0.0218, 'lps'),
	(576059, 127, '2014-03-15 00:14:03.000000', 'consum', 0.0214, 'lps'),
	(576060, 127, '2014-03-15 00:14:04.000000', 'consum', 0.0227, 'lps'),
	(576061, 127, '2014-03-15 00:14:05.000000', 'consum', 0.0227, 'lps'),
	(576062, 127, '2014-03-15 00:14:06.000000', 'consum', 0.0227, 'lps'),
	(576063, 127, '2014-03-15 00:14:07.000000', 'consum', 0.0227, 'lps'),
	(576064, 127, '2014-03-15 00:14:08.000000', 'consum', 0.0210, 'lps'),
	(576065, 127, '2014-03-15 00:14:09.000000', 'consum', 0.0212, 'lps'),
	(576066, 127, '2014-03-15 00:14:10.000000', 'consum', 0.0222, 'lps'),
	(576067, 127, '2014-03-15 00:14:11.000000', 'consum', 0.0210, 'lps'),
	(576068, 127, '2014-03-15 00:14:12.000000', 'consum', 0.0210, 'lps'),
	(576069, 127, '2014-03-15 00:14:13.000000', 'consum', 0.0210, 'lps'),
	(576070, 127, '2014-03-15 00:14:14.000000', 'consum', 0.0210, 'lps'),
	(576071, 127, '2014-03-15 00:14:15.000000', 'consum', 0.0212, 'lps'),
	(576072, 127, '2014-03-15 00:14:16.000000', 'consum', 0.0222, 'lps'),
	(576073, 127, '2014-03-15 00:14:17.000000', 'consum', 0.0226, 'lps'),
	(576074, 127, '2014-03-15 00:14:18.000000', 'consum', 0.0220, 'lps'),
	(576075, 127, '2014-03-15 00:14:19.000000', 'consum', 0.0211, 'lps'),
	(576076, 127, '2014-03-15 00:14:20.000000', 'consum', 0.0223, 'lps'),
	(576077, 127, '2014-03-15 00:14:21.000000', 'consum', 0.0219, 'lps'),
	(576078, 127, '2014-03-15 00:14:22.000000', 'consum', 0.0216, 'lps'),
	(576079, 127, '2014-03-15 00:14:23.000000', 'consum', 0.0215, 'lps'),
	(576080, 127, '2014-03-15 00:14:24.000000', 'consum', 0.0218, 'lps'),
	(576081, 127, '2014-03-15 00:14:25.000000', 'consum', 0.0216, 'lps'),
	(576082, 127, '2014-03-15 00:14:26.000000', 'consum', 0.0216, 'lps'),
	(576083, 127, '2014-03-15 00:14:27.000000', 'consum', 0.0223, 'lps'),
	(576084, 127, '2014-03-15 00:14:28.000000', 'consum', 0.0223, 'lps'),
	(576085, 127, '2014-03-15 00:14:29.000000', 'consum', 0.0219, 'lps'),
	(576086, 127, '2014-03-15 00:14:30.000000', 'consum', 0.0216, 'lps'),
	(576087, 127, '2014-03-15 00:14:31.000000', 'consum', 0.0213, 'lps'),
	(576088, 127, '2014-03-15 00:14:32.000000', 'consum', 0.0226, 'lps'),
	(576089, 127, '2014-03-15 00:14:33.000000', 'consum', 0.0226, 'lps'),
	(576090, 127, '2014-03-15 00:14:34.000000', 'consum', 0.0225, 'lps'),
	(576091, 127, '2014-03-15 00:14:35.000000', 'consum', 0.0218, 'lps'),
	(576092, 127, '2014-03-15 00:14:36.000000', 'consum', 0.0225, 'lps'),
	(576093, 127, '2014-03-15 00:14:37.000000', 'consum', 0.0224, 'lps'),
	(576094, 127, '2014-03-15 00:14:38.000000', 'consum', 0.0217, 'lps'),
	(576095, 127, '2014-03-15 00:14:39.000000', 'consum', 0.0223, 'lps'),
	(576096, 127, '2014-03-15 00:14:40.000000', 'consum', 0.0220, 'lps'),
	(576097, 127, '2014-03-15 00:14:41.000000', 'consum', 0.0221, 'lps'),
	(576098, 127, '2014-03-15 00:14:42.000000', 'consum', 0.0217, 'lps'),
	(576099, 127, '2014-03-15 00:14:43.000000', 'consum', 0.0214, 'lps'),
	(576100, 127, '2014-03-15 00:14:44.000000', 'consum', 0.0210, 'lps'),
	(576101, 127, '2014-03-15 00:14:45.000000', 'consum', 0.0216, 'lps'),
	(576102, 127, '2014-03-15 00:14:46.000000', 'consum', 0.0220, 'lps'),
	(576103, 127, '2014-03-15 00:14:47.000000', 'consum', 0.0210, 'lps'),
	(576104, 127, '2014-03-15 00:14:48.000000', 'consum', 0.0214, 'lps'),
	(576105, 127, '2014-03-15 00:14:49.000000', 'consum', 0.0215, 'lps'),
	(576106, 127, '2014-03-15 00:14:50.000000', 'consum', 0.0222, 'lps'),
	(576107, 127, '2014-03-15 00:14:51.000000', 'consum', 0.0220, 'lps'),
	(576108, 127, '2014-03-15 00:14:52.000000', 'consum', 0.0225, 'lps'),
	(576109, 127, '2014-03-15 00:14:53.000000', 'consum', 0.0218, 'lps'),
	(576110, 127, '2014-03-15 00:14:54.000000', 'consum', 0.0226, 'lps'),
	(576111, 127, '2014-03-15 00:14:55.000000', 'consum', 0.0212, 'lps'),
	(576112, 127, '2014-03-15 00:14:56.000000', 'consum', 0.0225, 'lps'),
	(576113, 127, '2014-03-15 00:14:57.000000', 'consum', 0.0225, 'lps'),
	(576114, 127, '2014-03-15 00:14:58.000000', 'consum', 0.0224, 'lps'),
	(576115, 127, '2014-03-15 00:14:59.000000', 'consum', 0.0216, 'lps'),
	(576116, 127, '2014-03-15 00:15:00.000000', 'consum', 0.0215, 'lps'),
	(576117, 127, '2014-03-15 00:15:01.000000', 'consum', 0.0220, 'lps'),
	(576118, 127, '2014-03-15 00:15:02.000000', 'consum', 0.0225, 'lps'),
	(576119, 127, '2014-03-15 00:15:03.000000', 'consum', 0.0223, 'lps'),
	(576120, 127, '2014-03-15 00:15:04.000000', 'consum', 0.0210, 'lps'),
	(576121, 127, '2014-03-15 00:15:05.000000', 'consum', 0.0210, 'lps'),
	(576122, 127, '2014-03-15 00:15:06.000000', 'consum', 0.0225, 'lps'),
	(576123, 127, '2014-03-15 00:15:07.000000', 'consum', 0.0216, 'lps'),
	(576124, 127, '2014-03-15 00:15:08.000000', 'consum', 0.0215, 'lps'),
	(576125, 127, '2014-03-15 00:15:09.000000', 'consum', 0.0215, 'lps'),
	(576126, 127, '2014-03-15 00:15:10.000000', 'consum', 0.0222, 'lps'),
	(576127, 127, '2014-03-15 00:15:11.000000', 'consum', 0.0219, 'lps'),
	(576128, 127, '2014-03-15 00:15:12.000000', 'consum', 0.0219, 'lps'),
	(576129, 127, '2014-03-15 00:15:13.000000', 'consum', 0.0210, 'lps'),
	(576130, 127, '2014-03-15 00:15:14.000000', 'consum', 0.0221, 'lps'),
	(576131, 127, '2014-03-15 00:15:15.000000', 'consum', 0.0211, 'lps'),
	(576132, 127, '2014-03-15 00:15:16.000000', 'consum', 0.0218, 'lps'),
	(576133, 127, '2014-03-15 00:15:17.000000', 'consum', 0.0212, 'lps'),
	(576134, 127, '2014-03-15 00:15:18.000000', 'consum', 0.0216, 'lps'),
	(576135, 127, '2014-03-15 00:15:19.000000', 'consum', 0.0217, 'lps'),
	(576136, 127, '2014-03-15 00:15:20.000000', 'consum', 0.0226, 'lps'),
	(576137, 127, '2014-03-15 00:15:21.000000', 'consum', 0.0214, 'lps'),
	(576138, 127, '2014-03-15 00:15:22.000000', 'consum', 0.0219, 'lps'),
	(576139, 127, '2014-03-15 00:15:23.000000', 'consum', 0.0225, 'lps'),
	(576140, 127, '2014-03-15 00:15:24.000000', 'consum', 0.0222, 'lps'),
	(576141, 127, '2014-03-15 00:15:25.000000', 'consum', 0.0210, 'lps'),
	(576142, 127, '2014-03-15 00:15:26.000000', 'consum', 0.0227, 'lps'),
	(576143, 127, '2014-03-15 00:15:27.000000', 'consum', 0.0222, 'lps'),
	(576144, 127, '2014-03-15 00:15:28.000000', 'consum', 0.0219, 'lps'),
	(576145, 127, '2014-03-15 00:15:29.000000', 'consum', 0.0222, 'lps'),
	(576146, 127, '2014-03-15 00:15:30.000000', 'consum', 0.0226, 'lps'),
	(576147, 127, '2014-03-15 00:15:31.000000', 'consum', 0.0216, 'lps'),
	(576148, 127, '2014-03-15 00:15:32.000000', 'consum', 0.0213, 'lps'),
	(576149, 127, '2014-03-15 00:15:33.000000', 'consum', 0.0223, 'lps'),
	(576150, 127, '2014-03-15 00:15:34.000000', 'consum', 0.0215, 'lps'),
	(576151, 127, '2014-03-15 00:15:35.000000', 'consum', 0.0214, 'lps'),
	(576152, 127, '2014-03-15 00:15:36.000000', 'consum', 0.0213, 'lps'),
	(576153, 127, '2014-03-15 00:15:37.000000', 'consum', 0.0216, 'lps'),
	(576154, 127, '2014-03-15 00:15:38.000000', 'consum', 0.0211, 'lps'),
	(576155, 127, '2014-03-15 00:15:39.000000', 'consum', 0.0217, 'lps'),
	(576156, 127, '2014-03-15 00:15:40.000000', 'consum', 0.0222, 'lps'),
	(576157, 127, '2014-03-15 00:15:41.000000', 'consum', 0.0217, 'lps'),
	(576158, 127, '2014-03-15 00:15:42.000000', 'consum', 0.0224, 'lps'),
	(576159, 127, '2014-03-15 00:15:43.000000', 'consum', 0.0226, 'lps'),
	(576160, 127, '2014-03-15 00:15:44.000000', 'consum', 0.0212, 'lps'),
	(576161, 127, '2014-03-15 00:15:45.000000', 'consum', 0.0227, 'lps'),
	(576162, 127, '2014-03-15 00:15:46.000000', 'consum', 0.0218, 'lps'),
	(576163, 127, '2014-03-15 00:15:47.000000', 'consum', 0.0218, 'lps'),
	(576164, 127, '2014-03-15 00:15:48.000000', 'consum', 0.0225, 'lps'),
	(576165, 127, '2014-03-15 00:15:49.000000', 'consum', 0.0227, 'lps'),
	(576166, 127, '2014-03-15 00:15:50.000000', 'consum', 0.0214, 'lps'),
	(576167, 127, '2014-03-15 00:15:51.000000', 'consum', 0.0216, 'lps'),
	(576168, 127, '2014-03-15 00:15:52.000000', 'consum', 0.0211, 'lps'),
	(576169, 127, '2014-03-15 00:15:53.000000', 'consum', 0.0215, 'lps'),
	(576170, 127, '2014-03-15 00:15:54.000000', 'consum', 0.0216, 'lps'),
	(576171, 127, '2014-03-15 00:15:55.000000', 'consum', 0.0223, 'lps'),
	(576172, 127, '2014-03-15 00:15:56.000000', 'consum', 0.0224, 'lps'),
	(576173, 127, '2014-03-15 00:15:57.000000', 'consum', 0.0222, 'lps'),
	(576174, 127, '2014-03-15 00:15:58.000000', 'consum', 0.0212, 'lps'),
	(576175, 127, '2014-03-15 00:15:59.000000', 'consum', 0.0219, 'lps'),
	(576176, 127, '2014-03-15 00:16:00.000000', 'consum', 0.0214, 'lps'),
	(576177, 127, '2014-03-15 00:16:01.000000', 'consum', 0.0223, 'lps'),
	(576178, 127, '2014-03-15 00:16:02.000000', 'consum', 0.0210, 'lps'),
	(576179, 127, '2014-03-15 00:16:03.000000', 'consum', 0.0225, 'lps'),
	(576180, 127, '2014-03-15 00:16:04.000000', 'consum', 0.0212, 'lps'),
	(576181, 127, '2014-03-15 00:16:05.000000', 'consum', 0.0211, 'lps'),
	(576182, 127, '2014-03-15 00:16:06.000000', 'consum', 0.0210, 'lps'),
	(576183, 127, '2014-03-15 00:16:07.000000', 'consum', 0.0227, 'lps'),
	(576184, 127, '2014-03-15 00:16:08.000000', 'consum', 0.0224, 'lps'),
	(576185, 127, '2014-03-15 00:16:09.000000', 'consum', 0.0227, 'lps'),
	(576186, 127, '2014-03-15 00:16:10.000000', 'consum', 0.0218, 'lps'),
	(576187, 127, '2014-03-15 00:16:11.000000', 'consum', 0.0218, 'lps'),
	(576188, 127, '2014-03-15 00:16:12.000000', 'consum', 0.0226, 'lps'),
	(576189, 127, '2014-03-15 00:16:13.000000', 'consum', 0.0212, 'lps'),
	(576190, 127, '2014-03-15 00:16:14.000000', 'consum', 0.0211, 'lps'),
	(576191, 127, '2014-03-15 00:16:15.000000', 'consum', 0.0224, 'lps'),
	(576192, 127, '2014-03-15 00:16:16.000000', 'consum', 0.0225, 'lps'),
	(576193, 127, '2014-03-15 00:16:17.000000', 'consum', 0.0227, 'lps'),
	(576194, 127, '2014-03-15 00:16:18.000000', 'consum', 0.0211, 'lps'),
	(576195, 127, '2014-03-15 00:16:19.000000', 'consum', 0.0222, 'lps'),
	(576196, 127, '2014-03-15 00:16:20.000000', 'consum', 0.0212, 'lps'),
	(576197, 127, '2014-03-15 00:16:21.000000', 'consum', 0.0222, 'lps'),
	(576198, 127, '2014-03-15 00:16:22.000000', 'consum', 0.0211, 'lps'),
	(576199, 127, '2014-03-15 00:16:23.000000', 'consum', 0.0213, 'lps'),
	(576200, 127, '2014-03-15 00:16:24.000000', 'consum', 0.0224, 'lps'),
	(576201, 127, '2014-03-15 00:16:25.000000', 'consum', 0.0217, 'lps'),
	(576202, 127, '2014-03-15 00:16:26.000000', 'consum', 0.0220, 'lps'),
	(576203, 127, '2014-03-15 00:16:27.000000', 'consum', 0.0223, 'lps'),
	(576204, 127, '2014-03-15 00:16:28.000000', 'consum', 0.0225, 'lps'),
	(576205, 127, '2014-03-15 00:16:29.000000', 'consum', 0.0213, 'lps'),
	(576206, 127, '2014-03-15 00:16:30.000000', 'consum', 0.0216, 'lps'),
	(576207, 127, '2014-03-15 00:16:31.000000', 'consum', 0.0214, 'lps'),
	(576208, 127, '2014-03-15 00:16:32.000000', 'consum', 0.0210, 'lps'),
	(576209, 127, '2014-03-15 00:16:33.000000', 'consum', 0.0220, 'lps'),
	(576210, 127, '2014-03-15 00:16:34.000000', 'consum', 0.0223, 'lps'),
	(576211, 127, '2014-03-15 00:16:35.000000', 'consum', 0.0210, 'lps'),
	(576212, 127, '2014-03-15 00:16:36.000000', 'consum', 0.0226, 'lps'),
	(576213, 127, '2014-03-15 00:16:37.000000', 'consum', 0.0218, 'lps'),
	(576214, 127, '2014-03-15 00:16:38.000000', 'consum', 0.0221, 'lps'),
	(576215, 127, '2014-03-15 00:16:39.000000', 'consum', 0.0225, 'lps'),
	(576216, 127, '2014-03-15 00:16:40.000000', 'consum', 0.0215, 'lps'),
	(576217, 127, '2014-03-15 00:16:41.000000', 'consum', 0.0227, 'lps'),
	(576218, 127, '2014-03-15 00:16:42.000000', 'consum', 0.0226, 'lps'),
	(576219, 127, '2014-03-15 00:16:43.000000', 'consum', 0.0221, 'lps'),
	(576220, 127, '2014-03-15 00:16:44.000000', 'consum', 0.0217, 'lps'),
	(576221, 127, '2014-03-15 00:16:45.000000', 'consum', 0.0213, 'lps'),
	(576222, 127, '2014-03-15 00:16:46.000000', 'consum', 0.0222, 'lps'),
	(576223, 127, '2014-03-15 00:16:47.000000', 'consum', 0.0224, 'lps'),
	(576224, 127, '2014-03-15 00:16:48.000000', 'consum', 0.0211, 'lps'),
	(576225, 127, '2014-03-15 00:16:49.000000', 'consum', 0.0226, 'lps'),
	(576226, 127, '2014-03-15 00:16:50.000000', 'consum', 0.0216, 'lps'),
	(576227, 127, '2014-03-15 00:16:51.000000', 'consum', 0.0213, 'lps'),
	(576228, 127, '2014-03-15 00:16:52.000000', 'consum', 0.0222, 'lps'),
	(576229, 127, '2014-03-15 00:16:53.000000', 'consum', 0.0226, 'lps'),
	(576230, 127, '2014-03-15 00:16:54.000000', 'consum', 0.0217, 'lps'),
	(576231, 127, '2014-03-15 00:16:55.000000', 'consum', 0.0219, 'lps'),
	(576232, 127, '2014-03-15 00:16:56.000000', 'consum', 0.0214, 'lps'),
	(576233, 127, '2014-03-15 00:16:57.000000', 'consum', 0.0223, 'lps'),
	(576234, 127, '2014-03-15 00:16:58.000000', 'consum', 0.0211, 'lps'),
	(576235, 127, '2014-03-15 00:16:59.000000', 'consum', 0.0210, 'lps'),
	(576236, 127, '2014-03-15 00:17:00.000000', 'consum', 0.0225, 'lps'),
	(576237, 127, '2014-03-15 00:17:01.000000', 'consum', 0.0217, 'lps'),
	(576238, 127, '2014-03-15 00:17:02.000000', 'consum', 0.0215, 'lps'),
	(576239, 127, '2014-03-15 00:17:03.000000', 'consum', 0.0214, 'lps'),
	(576240, 127, '2014-03-15 00:17:04.000000', 'consum', 0.0215, 'lps'),
	(576241, 127, '2014-03-15 00:17:05.000000', 'consum', 0.0226, 'lps'),
	(576242, 127, '2014-03-15 00:17:06.000000', 'consum', 0.0223, 'lps'),
	(576243, 127, '2014-03-15 00:17:07.000000', 'consum', 0.0224, 'lps'),
	(576244, 127, '2014-03-15 00:17:08.000000', 'consum', 0.0226, 'lps'),
	(576245, 127, '2014-03-15 00:17:09.000000', 'consum', 0.0212, 'lps'),
	(576246, 127, '2014-03-15 00:17:10.000000', 'consum', 0.0227, 'lps'),
	(576247, 127, '2014-03-15 00:17:11.000000', 'consum', 0.0216, 'lps'),
	(576248, 127, '2014-03-15 00:17:12.000000', 'consum', 0.0210, 'lps'),
	(576249, 127, '2014-03-15 00:17:13.000000', 'consum', 0.0227, 'lps'),
	(576250, 127, '2014-03-15 00:17:14.000000', 'consum', 0.0224, 'lps'),
	(576251, 127, '2014-03-15 00:17:15.000000', 'consum', 0.0213, 'lps'),
	(576252, 127, '2014-03-15 00:17:16.000000', 'consum', 0.0217, 'lps'),
	(576253, 127, '2014-03-15 00:17:17.000000', 'consum', 0.0218, 'lps'),
	(576254, 127, '2014-03-15 00:17:18.000000', 'consum', 0.0212, 'lps'),
	(576255, 127, '2014-03-15 00:17:19.000000', 'consum', 0.0217, 'lps'),
	(576256, 127, '2014-03-15 00:17:20.000000', 'consum', 0.0218, 'lps'),
	(576257, 127, '2014-03-15 00:17:21.000000', 'consum', 0.0213, 'lps'),
	(576258, 127, '2014-03-15 00:17:22.000000', 'consum', 0.0219, 'lps'),
	(576259, 127, '2014-03-15 00:17:23.000000', 'consum', 0.0210, 'lps'),
	(576260, 127, '2014-03-15 00:17:24.000000', 'consum', 0.0220, 'lps'),
	(576261, 127, '2014-03-15 00:17:25.000000', 'consum', 0.0225, 'lps'),
	(576262, 127, '2014-03-15 00:17:26.000000', 'consum', 0.0218, 'lps'),
	(576263, 127, '2014-03-15 00:17:27.000000', 'consum', 0.0226, 'lps'),
	(576264, 127, '2014-03-15 00:17:28.000000', 'consum', 0.0213, 'lps'),
	(576265, 127, '2014-03-15 00:17:29.000000', 'consum', 0.0214, 'lps'),
	(576266, 127, '2014-03-15 00:17:30.000000', 'consum', 0.0219, 'lps'),
	(576267, 127, '2014-03-15 00:17:31.000000', 'consum', 0.0210, 'lps'),
	(576268, 127, '2014-03-15 00:17:32.000000', 'consum', 0.0216, 'lps'),
	(576269, 127, '2014-03-15 00:17:33.000000', 'consum', 0.0226, 'lps'),
	(576270, 127, '2014-03-15 00:17:34.000000', 'consum', 0.0215, 'lps'),
	(576271, 127, '2014-03-15 00:17:35.000000', 'consum', 0.0226, 'lps'),
	(576272, 127, '2014-03-15 00:17:36.000000', 'consum', 0.0220, 'lps'),
	(576273, 127, '2014-03-15 00:17:37.000000', 'consum', 0.0212, 'lps'),
	(576274, 127, '2014-03-15 00:17:38.000000', 'consum', 0.0211, 'lps'),
	(576275, 127, '2014-03-15 00:17:39.000000', 'consum', 0.0227, 'lps'),
	(576276, 127, '2014-03-15 00:17:40.000000', 'consum', 0.0221, 'lps'),
	(576277, 127, '2014-03-15 00:17:41.000000', 'consum', 0.0214, 'lps'),
	(576278, 127, '2014-03-15 00:17:42.000000', 'consum', 0.0217, 'lps'),
	(576279, 127, '2014-03-15 00:17:43.000000', 'consum', 0.0213, 'lps'),
	(576280, 127, '2014-03-15 00:17:44.000000', 'consum', 0.0222, 'lps'),
	(576281, 127, '2014-03-15 00:17:45.000000', 'consum', 0.0226, 'lps'),
	(576282, 127, '2014-03-15 00:17:46.000000', 'consum', 0.0220, 'lps'),
	(576283, 127, '2014-03-15 00:17:47.000000', 'consum', 0.0213, 'lps'),
	(576284, 127, '2014-03-15 00:17:48.000000', 'consum', 0.0214, 'lps'),
	(576285, 127, '2014-03-15 00:17:49.000000', 'consum', 0.0221, 'lps'),
	(576286, 127, '2014-03-15 00:17:50.000000', 'consum', 0.0219, 'lps'),
	(576287, 127, '2014-03-15 00:17:51.000000', 'consum', 0.0221, 'lps'),
	(576288, 127, '2014-03-15 00:17:52.000000', 'consum', 0.0220, 'lps'),
	(576289, 127, '2014-03-15 00:17:53.000000', 'consum', 0.0210, 'lps'),
	(576290, 127, '2014-03-15 00:17:54.000000', 'consum', 0.0217, 'lps'),
	(576291, 127, '2014-03-15 00:17:55.000000', 'consum', 0.0227, 'lps'),
	(576292, 127, '2014-03-15 00:17:56.000000', 'consum', 0.0222, 'lps'),
	(576293, 127, '2014-03-15 00:17:57.000000', 'consum', 0.0219, 'lps'),
	(576294, 127, '2014-03-15 00:17:58.000000', 'consum', 0.0219, 'lps'),
	(576295, 127, '2014-03-15 00:17:59.000000', 'consum', 0.0210, 'lps'),
	(576296, 127, '2014-03-15 00:18:00.000000', 'consum', 0.0222, 'lps'),
	(576297, 127, '2014-03-15 00:18:01.000000', 'consum', 0.0214, 'lps'),
	(576298, 127, '2014-03-15 00:18:02.000000', 'consum', 0.0211, 'lps'),
	(576299, 127, '2014-03-15 00:18:03.000000', 'consum', 0.0225, 'lps'),
	(576300, 127, '2014-03-15 00:18:04.000000', 'consum', 0.0227, 'lps'),
	(576301, 127, '2014-03-15 00:18:05.000000', 'consum', 0.0216, 'lps'),
	(576302, 127, '2014-03-15 00:18:06.000000', 'consum', 0.0225, 'lps'),
	(576303, 127, '2014-03-15 00:18:07.000000', 'consum', 0.0213, 'lps'),
	(576304, 127, '2014-03-15 00:18:08.000000', 'consum', 0.0216, 'lps'),
	(576305, 127, '2014-03-15 00:18:09.000000', 'consum', 0.0213, 'lps'),
	(576306, 127, '2014-03-15 00:18:10.000000', 'consum', 0.0210, 'lps'),
	(576307, 127, '2014-03-15 00:18:11.000000', 'consum', 0.0216, 'lps'),
	(576308, 127, '2014-03-15 00:18:12.000000', 'consum', 0.0224, 'lps'),
	(576309, 127, '2014-03-15 00:18:13.000000', 'consum', 0.0210, 'lps'),
	(576310, 127, '2014-03-15 00:18:14.000000', 'consum', 0.0223, 'lps'),
	(576311, 127, '2014-03-15 00:18:15.000000', 'consum', 0.0222, 'lps'),
	(576312, 127, '2014-03-15 00:18:16.000000', 'consum', 0.0212, 'lps'),
	(576313, 127, '2014-03-15 00:18:17.000000', 'consum', 0.0221, 'lps'),
	(576314, 127, '2014-03-15 00:18:18.000000', 'consum', 0.0225, 'lps'),
	(576315, 127, '2014-03-15 00:18:19.000000', 'consum', 0.0217, 'lps'),
	(576316, 127, '2014-03-15 00:18:20.000000', 'consum', 0.0219, 'lps'),
	(576317, 127, '2014-03-15 00:18:21.000000', 'consum', 0.0214, 'lps'),
	(576318, 127, '2014-03-15 00:18:22.000000', 'consum', 0.0224, 'lps'),
	(576319, 127, '2014-03-15 00:18:23.000000', 'consum', 0.0212, 'lps'),
	(576320, 127, '2014-03-15 00:18:24.000000', 'consum', 0.0216, 'lps'),
	(576321, 127, '2014-03-15 00:18:25.000000', 'consum', 0.0215, 'lps'),
	(576322, 127, '2014-03-15 00:18:26.000000', 'consum', 0.0217, 'lps'),
	(576323, 127, '2014-03-15 00:18:27.000000', 'consum', 0.0214, 'lps'),
	(576324, 127, '2014-03-15 00:18:28.000000', 'consum', 0.0226, 'lps'),
	(576325, 127, '2014-03-15 00:18:29.000000', 'consum', 0.0226, 'lps'),
	(576326, 127, '2014-03-15 00:18:30.000000', 'consum', 0.0224, 'lps'),
	(576327, 127, '2014-03-15 00:18:31.000000', 'consum', 0.0213, 'lps'),
	(576328, 127, '2014-03-15 00:18:32.000000', 'consum', 0.0221, 'lps'),
	(576329, 127, '2014-03-15 00:18:33.000000', 'consum', 0.0221, 'lps'),
	(576330, 127, '2014-03-15 00:18:34.000000', 'consum', 0.0212, 'lps'),
	(576331, 127, '2014-03-15 00:18:35.000000', 'consum', 0.0227, 'lps'),
	(576332, 127, '2014-03-15 00:18:36.000000', 'consum', 0.0214, 'lps'),
	(576333, 127, '2014-03-15 00:18:37.000000', 'consum', 0.0217, 'lps'),
	(576334, 127, '2014-03-15 00:18:38.000000', 'consum', 0.0216, 'lps'),
	(576335, 127, '2014-03-15 00:18:39.000000', 'consum', 0.0221, 'lps'),
	(576336, 127, '2014-03-15 00:18:40.000000', 'consum', 0.0210, 'lps'),
	(576337, 127, '2014-03-15 00:18:41.000000', 'consum', 0.0214, 'lps'),
	(576338, 127, '2014-03-15 00:18:42.000000', 'consum', 0.0210, 'lps'),
	(576339, 127, '2014-03-15 00:18:43.000000', 'consum', 0.0220, 'lps'),
	(576340, 127, '2014-03-15 00:18:44.000000', 'consum', 0.0222, 'lps'),
	(576341, 127, '2014-03-15 00:18:45.000000', 'consum', 0.0224, 'lps'),
	(576342, 127, '2014-03-15 00:18:46.000000', 'consum', 0.0227, 'lps'),
	(576343, 127, '2014-03-15 00:18:47.000000', 'consum', 0.0219, 'lps'),
	(576344, 127, '2014-03-15 00:18:48.000000', 'consum', 0.0219, 'lps'),
	(576345, 127, '2014-03-15 00:18:49.000000', 'consum', 0.0214, 'lps'),
	(576346, 127, '2014-03-15 00:18:50.000000', 'consum', 0.0219, 'lps'),
	(576347, 127, '2014-03-15 00:18:51.000000', 'consum', 0.0210, 'lps'),
	(576348, 127, '2014-03-15 00:18:52.000000', 'consum', 0.0219, 'lps'),
	(576349, 127, '2014-03-15 00:18:53.000000', 'consum', 0.0218, 'lps'),
	(576350, 127, '2014-03-15 00:18:54.000000', 'consum', 0.0222, 'lps'),
	(576351, 127, '2014-03-15 00:18:55.000000', 'consum', 0.0213, 'lps'),
	(576352, 127, '2014-03-15 00:18:56.000000', 'consum', 0.0224, 'lps'),
	(576353, 127, '2014-03-15 00:18:57.000000', 'consum', 0.0220, 'lps'),
	(576354, 127, '2014-03-15 00:18:58.000000', 'consum', 0.0215, 'lps'),
	(576355, 127, '2014-03-15 00:18:59.000000', 'consum', 0.0226, 'lps'),
	(576356, 127, '2014-03-15 00:19:00.000000', 'consum', 0.0221, 'lps'),
	(576357, 127, '2014-03-15 00:19:01.000000', 'consum', 0.0216, 'lps'),
	(576358, 127, '2014-03-15 00:19:02.000000', 'consum', 0.0227, 'lps'),
	(576359, 127, '2014-03-15 00:19:03.000000', 'consum', 0.0225, 'lps'),
	(576360, 127, '2014-03-15 00:19:04.000000', 'consum', 0.0215, 'lps'),
	(576361, 127, '2014-03-15 00:19:05.000000', 'consum', 0.0211, 'lps'),
	(576362, 127, '2014-03-15 00:19:06.000000', 'consum', 0.0215, 'lps'),
	(576363, 127, '2014-03-15 00:19:07.000000', 'consum', 0.0216, 'lps'),
	(576364, 127, '2014-03-15 00:19:08.000000', 'consum', 0.0225, 'lps'),
	(576365, 127, '2014-03-15 00:19:09.000000', 'consum', 0.0215, 'lps'),
	(576366, 127, '2014-03-15 00:19:10.000000', 'consum', 0.0224, 'lps'),
	(576367, 127, '2014-03-15 00:19:11.000000', 'consum', 0.0211, 'lps'),
	(576368, 127, '2014-03-15 00:19:12.000000', 'consum', 0.0210, 'lps'),
	(576369, 127, '2014-03-15 00:19:13.000000', 'consum', 0.0226, 'lps'),
	(576370, 127, '2014-03-15 00:19:14.000000', 'consum', 0.0219, 'lps'),
	(576371, 127, '2014-03-15 00:19:15.000000', 'consum', 0.0227, 'lps'),
	(576372, 127, '2014-03-15 00:19:16.000000', 'consum', 0.0213, 'lps'),
	(576373, 127, '2014-03-15 00:19:17.000000', 'consum', 0.0212, 'lps'),
	(576374, 127, '2014-03-15 00:19:18.000000', 'consum', 0.0211, 'lps'),
	(576375, 127, '2014-03-15 00:19:19.000000', 'consum', 0.0227, 'lps'),
	(576376, 127, '2014-03-15 00:19:20.000000', 'consum', 0.0221, 'lps'),
	(576377, 127, '2014-03-15 00:19:21.000000', 'consum', 0.0214, 'lps'),
	(576378, 127, '2014-03-15 00:19:22.000000', 'consum', 0.0218, 'lps'),
	(576379, 127, '2014-03-15 00:19:23.000000', 'consum', 0.0217, 'lps'),
	(576380, 127, '2014-03-15 00:19:24.000000', 'consum', 0.0224, 'lps'),
	(576381, 127, '2014-03-15 00:19:25.000000', 'consum', 0.0224, 'lps'),
	(576382, 127, '2014-03-15 00:19:26.000000', 'consum', 0.0220, 'lps'),
	(576383, 127, '2014-03-15 00:19:27.000000', 'consum', 0.0218, 'lps'),
	(576384, 127, '2014-03-15 00:19:28.000000', 'consum', 0.0222, 'lps'),
	(576385, 127, '2014-03-15 00:19:29.000000', 'consum', 0.0211, 'lps'),
	(576386, 127, '2014-03-15 00:19:30.000000', 'consum', 0.0214, 'lps'),
	(576387, 127, '2014-03-15 00:19:31.000000', 'consum', 0.0210, 'lps'),
	(576388, 127, '2014-03-15 00:19:32.000000', 'consum', 0.0218, 'lps'),
	(576389, 127, '2014-03-15 00:19:33.000000', 'consum', 0.0214, 'lps'),
	(576390, 127, '2014-03-15 00:19:34.000000', 'consum', 0.0223, 'lps'),
	(576391, 127, '2014-03-15 00:19:35.000000', 'consum', 0.0211, 'lps'),
	(576392, 127, '2014-03-15 00:19:36.000000', 'consum', 0.0210, 'lps'),
	(576393, 127, '2014-03-15 00:19:37.000000', 'consum', 0.0211, 'lps'),
	(576394, 127, '2014-03-15 00:19:38.000000', 'consum', 0.0214, 'lps'),
	(576395, 127, '2014-03-15 00:19:39.000000', 'consum', 0.0226, 'lps'),
	(576396, 127, '2014-03-15 00:19:40.000000', 'consum', 0.0225, 'lps'),
	(576397, 127, '2014-03-15 00:19:41.000000', 'consum', 0.0219, 'lps'),
	(576398, 127, '2014-03-15 00:19:42.000000', 'consum', 0.0211, 'lps'),
	(576399, 127, '2014-03-15 00:19:43.000000', 'consum', 0.0226, 'lps'),
	(576400, 127, '2014-03-15 00:19:44.000000', 'consum', 0.0212, 'lps'),
	(576401, 127, '2014-03-15 00:19:45.000000', 'consum', 0.0212, 'lps'),
	(576402, 127, '2014-03-15 00:19:46.000000', 'consum', 0.0214, 'lps'),
	(576403, 127, '2014-03-15 00:19:47.000000', 'consum', 0.0226, 'lps'),
	(576404, 127, '2014-03-15 00:19:48.000000', 'consum', 0.0222, 'lps'),
	(576405, 127, '2014-03-15 00:19:49.000000', 'consum', 0.0225, 'lps'),
	(576406, 127, '2014-03-15 00:19:50.000000', 'consum', 0.0213, 'lps'),
	(576407, 127, '2014-03-15 00:19:51.000000', 'consum', 0.0217, 'lps'),
	(576408, 127, '2014-03-15 00:19:52.000000', 'consum', 0.0219, 'lps'),
	(576409, 127, '2014-03-15 00:19:53.000000', 'consum', 0.0214, 'lps'),
	(576410, 127, '2014-03-15 00:19:54.000000', 'consum', 0.0222, 'lps'),
	(576411, 127, '2014-03-15 00:19:55.000000', 'consum', 0.0223, 'lps'),
	(576412, 127, '2014-03-15 00:19:56.000000', 'consum', 0.0220, 'lps'),
	(576413, 127, '2014-03-15 00:19:57.000000', 'consum', 0.0224, 'lps'),
	(576414, 127, '2014-03-15 00:19:58.000000', 'consum', 0.0213, 'lps'),
	(576415, 127, '2014-03-15 00:19:59.000000', 'consum', 0.0221, 'lps'),
	(576416, 127, '2014-03-15 00:20:00.000000', 'consum', 0.0220, 'lps'),
	(576417, 127, '2014-03-15 00:20:01.000000', 'consum', 0.0227, 'lps'),
	(576418, 127, '2014-03-15 00:20:02.000000', 'consum', 0.0214, 'lps'),
	(576419, 127, '2014-03-15 00:20:03.000000', 'consum', 0.0213, 'lps'),
	(576420, 127, '2014-03-15 00:20:04.000000', 'consum', 0.0213, 'lps'),
	(576421, 127, '2014-03-15 00:20:05.000000', 'consum', 0.0217, 'lps'),
	(576422, 127, '2014-03-15 00:20:06.000000', 'consum', 0.0218, 'lps'),
	(576423, 127, '2014-03-15 00:20:07.000000', 'consum', 0.0212, 'lps'),
	(576424, 127, '2014-03-15 00:20:08.000000', 'consum', 0.0212, 'lps'),
	(576425, 127, '2014-03-15 00:20:09.000000', 'consum', 0.0218, 'lps'),
	(576426, 127, '2014-03-15 00:20:10.000000', 'consum', 0.0225, 'lps'),
	(576427, 127, '2014-03-15 00:20:11.000000', 'consum', 0.0224, 'lps'),
	(576428, 127, '2014-03-15 00:20:12.000000', 'consum', 0.0219, 'lps'),
	(576429, 127, '2014-03-15 00:20:13.000000', 'consum', 0.0214, 'lps'),
	(576430, 127, '2014-03-15 00:20:14.000000', 'consum', 0.0219, 'lps'),
	(576431, 127, '2014-03-15 00:20:15.000000', 'consum', 0.0226, 'lps'),
	(576432, 127, '2014-03-15 00:20:16.000000', 'consum', 0.0211, 'lps'),
	(576433, 127, '2014-03-15 00:20:17.000000', 'consum', 0.0222, 'lps'),
	(576434, 127, '2014-03-15 00:20:18.000000', 'consum', 0.0211, 'lps'),
	(576435, 127, '2014-03-15 00:20:19.000000', 'consum', 0.0218, 'lps'),
	(576436, 127, '2014-03-15 00:20:20.000000', 'consum', 0.0227, 'lps'),
	(576437, 127, '2014-03-15 00:20:21.000000', 'consum', 0.0220, 'lps'),
	(576438, 127, '2014-03-15 00:20:22.000000', 'consum', 0.0226, 'lps'),
	(576439, 127, '2014-03-15 00:20:23.000000', 'consum', 0.0224, 'lps'),
	(576440, 127, '2014-03-15 00:20:24.000000', 'consum', 0.0214, 'lps'),
	(576441, 127, '2014-03-15 00:20:25.000000', 'consum', 0.0227, 'lps'),
	(576442, 127, '2014-03-15 00:20:26.000000', 'consum', 0.0211, 'lps'),
	(576443, 127, '2014-03-15 00:20:27.000000', 'consum', 0.0220, 'lps'),
	(576444, 127, '2014-03-15 00:20:28.000000', 'consum', 0.0219, 'lps'),
	(576445, 127, '2014-03-15 00:20:29.000000', 'consum', 0.0227, 'lps'),
	(576446, 127, '2014-03-15 00:20:30.000000', 'consum', 0.0213, 'lps'),
	(576447, 127, '2014-03-15 00:20:31.000000', 'consum', 0.0213, 'lps'),
	(576448, 127, '2014-03-15 00:20:32.000000', 'consum', 0.0217, 'lps'),
	(576449, 127, '2014-03-15 00:20:33.000000', 'consum', 0.0215, 'lps'),
	(576450, 127, '2014-03-15 00:20:34.000000', 'consum', 0.0217, 'lps'),
	(576451, 127, '2014-03-15 00:20:35.000000', 'consum', 0.0214, 'lps'),
	(576452, 127, '2014-03-15 00:20:36.000000', 'consum', 0.0225, 'lps'),
	(576453, 127, '2014-03-15 00:20:37.000000', 'consum', 0.0218, 'lps'),
	(576454, 127, '2014-03-15 00:20:38.000000', 'consum', 0.0226, 'lps'),
	(576455, 127, '2014-03-15 00:20:39.000000', 'consum', 0.0210, 'lps'),
	(576456, 127, '2014-03-15 00:20:40.000000', 'consum', 0.0219, 'lps'),
	(576457, 127, '2014-03-15 00:20:41.000000', 'consum', 0.0217, 'lps'),
	(576458, 127, '2014-03-15 00:20:42.000000', 'consum', 0.0218, 'lps'),
	(576459, 127, '2014-03-15 00:20:43.000000', 'consum', 0.0214, 'lps'),
	(576460, 127, '2014-03-15 00:20:44.000000', 'consum', 0.0222, 'lps'),
	(576461, 127, '2014-03-15 00:20:45.000000', 'consum', 0.0225, 'lps'),
	(576462, 127, '2014-03-15 00:20:46.000000', 'consum', 0.0212, 'lps'),
	(576463, 127, '2014-03-15 00:20:47.000000', 'consum', 0.0213, 'lps'),
	(576464, 127, '2014-03-15 00:20:48.000000', 'consum', 0.0218, 'lps'),
	(576465, 127, '2014-03-15 00:20:49.000000', 'consum', 0.0225, 'lps'),
	(576466, 127, '2014-03-15 00:20:50.000000', 'consum', 0.0225, 'lps'),
	(576467, 127, '2014-03-15 00:20:51.000000', 'consum', 0.0223, 'lps'),
	(576468, 127, '2014-03-15 00:20:52.000000', 'consum', 0.0211, 'lps'),
	(576469, 127, '2014-03-15 00:20:53.000000', 'consum', 0.0211, 'lps'),
	(576470, 127, '2014-03-15 00:20:54.000000', 'consum', 0.0214, 'lps'),
	(576471, 127, '2014-03-15 00:20:55.000000', 'consum', 0.0211, 'lps'),
	(576472, 127, '2014-03-15 00:20:56.000000', 'consum', 0.0223, 'lps'),
	(576473, 127, '2014-03-15 00:20:57.000000', 'consum', 0.0215, 'lps'),
	(576474, 127, '2014-03-15 00:20:58.000000', 'consum', 0.0216, 'lps'),
	(576475, 127, '2014-03-15 00:20:59.000000', 'consum', 0.0226, 'lps'),
	(576476, 127, '2014-03-15 00:21:00.000000', 'consum', 0.0218, 'lps'),
	(576477, 127, '2014-03-15 00:21:01.000000', 'consum', 0.0220, 'lps'),
	(576478, 127, '2014-03-15 00:21:02.000000', 'consum', 0.0218, 'lps'),
	(576479, 127, '2014-03-15 00:21:03.000000', 'consum', 0.0222, 'lps'),
	(576480, 127, '2014-03-15 00:21:04.000000', 'consum', 0.0227, 'lps'),
	(576481, 127, '2014-03-15 00:21:05.000000', 'consum', 0.0224, 'lps'),
	(576482, 127, '2014-03-15 00:21:06.000000', 'consum', 0.0210, 'lps'),
	(576483, 127, '2014-03-15 00:21:07.000000', 'consum', 0.0223, 'lps'),
	(576484, 127, '2014-03-15 00:21:08.000000', 'consum', 0.0222, 'lps'),
	(576485, 127, '2014-03-15 00:21:09.000000', 'consum', 0.0214, 'lps'),
	(576486, 127, '2014-03-15 00:21:10.000000', 'consum', 0.0212, 'lps'),
	(576487, 127, '2014-03-15 00:21:11.000000', 'consum', 0.0210, 'lps'),
	(576488, 127, '2014-03-15 00:21:12.000000', 'consum', 0.0220, 'lps'),
	(576489, 127, '2014-03-15 00:21:13.000000', 'consum', 0.0223, 'lps'),
	(576490, 127, '2014-03-15 00:21:14.000000', 'consum', 0.0213, 'lps'),
	(576491, 127, '2014-03-15 00:21:15.000000', 'consum', 0.0223, 'lps'),
	(576492, 127, '2014-03-15 00:21:16.000000', 'consum', 0.0210, 'lps'),
	(576493, 127, '2014-03-15 00:21:17.000000', 'consum', 0.0225, 'lps'),
	(576494, 127, '2014-03-15 00:21:18.000000', 'consum', 0.0216, 'lps'),
	(576495, 127, '2014-03-15 00:21:19.000000', 'consum', 0.0213, 'lps'),
	(576496, 127, '2014-03-15 00:21:20.000000', 'consum', 0.0225, 'lps'),
	(576497, 127, '2014-03-15 00:21:21.000000', 'consum', 0.0224, 'lps'),
	(576498, 127, '2014-03-15 00:21:22.000000', 'consum', 0.0218, 'lps'),
	(576499, 127, '2014-03-15 00:21:23.000000', 'consum', 0.0226, 'lps'),
	(576500, 127, '2014-03-15 00:21:24.000000', 'consum', 0.0214, 'lps'),
	(576501, 127, '2014-03-15 00:21:25.000000', 'consum', 0.0218, 'lps'),
	(576502, 127, '2014-03-15 00:21:26.000000', 'consum', 0.0218, 'lps'),
	(576503, 127, '2014-03-15 00:21:27.000000', 'consum', 0.0210, 'lps'),
	(576504, 127, '2014-03-15 00:21:28.000000', 'consum', 0.0223, 'lps'),
	(576505, 127, '2014-03-15 00:21:29.000000', 'consum', 0.0222, 'lps'),
	(576506, 127, '2014-03-15 00:21:30.000000', 'consum', 0.0213, 'lps'),
	(576507, 127, '2014-03-15 00:21:31.000000', 'consum', 0.0227, 'lps'),
	(576508, 127, '2014-03-15 00:21:32.000000', 'consum', 0.0211, 'lps'),
	(576509, 127, '2014-03-15 00:21:33.000000', 'consum', 0.0222, 'lps'),
	(576510, 127, '2014-03-15 00:21:34.000000', 'consum', 0.0211, 'lps'),
	(576511, 127, '2014-03-15 00:21:35.000000', 'consum', 0.0216, 'lps'),
	(576512, 127, '2014-03-15 00:21:36.000000', 'consum', 0.0219, 'lps'),
	(576513, 127, '2014-03-15 00:21:37.000000', 'consum', 0.0219, 'lps'),
	(576514, 127, '2014-03-15 00:21:38.000000', 'consum', 0.0213, 'lps'),
	(576515, 127, '2014-03-15 00:21:39.000000', 'consum', 0.0215, 'lps'),
	(576516, 127, '2014-03-15 00:21:40.000000', 'consum', 0.0210, 'lps'),
	(576517, 127, '2014-03-15 00:21:41.000000', 'consum', 0.0211, 'lps'),
	(576518, 127, '2014-03-15 00:21:42.000000', 'consum', 0.0218, 'lps'),
	(576519, 127, '2014-03-15 00:21:43.000000', 'consum', 0.0210, 'lps'),
	(576520, 127, '2014-03-15 00:21:44.000000', 'consum', 0.0224, 'lps'),
	(576521, 127, '2014-03-15 00:21:45.000000', 'consum', 0.0224, 'lps'),
	(576522, 127, '2014-03-15 00:21:46.000000', 'consum', 0.0221, 'lps'),
	(576523, 127, '2014-03-15 00:21:47.000000', 'consum', 0.0226, 'lps'),
	(576524, 127, '2014-03-15 00:21:48.000000', 'consum', 0.0219, 'lps'),
	(576525, 127, '2014-03-15 00:21:49.000000', 'consum', 0.0225, 'lps'),
	(576526, 127, '2014-03-15 00:21:50.000000', 'consum', 0.0224, 'lps'),
	(576527, 127, '2014-03-15 00:21:51.000000', 'consum', 0.0218, 'lps'),
	(576528, 127, '2014-03-15 00:21:52.000000', 'consum', 0.0226, 'lps'),
	(576529, 127, '2014-03-15 00:21:53.000000', 'consum', 0.0212, 'lps'),
	(576530, 127, '2014-03-15 00:21:54.000000', 'consum', 0.0210, 'lps'),
	(576531, 127, '2014-03-15 00:21:55.000000', 'consum', 0.0221, 'lps'),
	(576532, 127, '2014-03-15 00:21:56.000000', 'consum', 0.0212, 'lps'),
	(576533, 127, '2014-03-15 00:21:57.000000', 'consum', 0.0222, 'lps'),
	(576534, 127, '2014-03-15 00:21:58.000000', 'consum', 0.0213, 'lps'),
	(576535, 127, '2014-03-15 00:21:59.000000', 'consum', 0.0225, 'lps'),
	(576536, 127, '2014-03-15 00:22:00.000000', 'consum', 0.0223, 'lps'),
	(576537, 127, '2014-03-15 00:22:01.000000', 'consum', 0.0214, 'lps'),
	(576538, 127, '2014-03-15 00:22:02.000000', 'consum', 0.0225, 'lps'),
	(576539, 127, '2014-03-15 00:22:03.000000', 'consum', 0.0220, 'lps'),
	(576540, 127, '2014-03-15 00:22:04.000000', 'consum', 0.0215, 'lps'),
	(576541, 127, '2014-03-15 00:22:05.000000', 'consum', 0.0224, 'lps'),
	(576542, 127, '2014-03-15 00:22:06.000000', 'consum', 0.0212, 'lps'),
	(576543, 127, '2014-03-15 00:22:07.000000', 'consum', 0.0213, 'lps'),
	(576544, 127, '2014-03-15 00:22:08.000000', 'consum', 0.0219, 'lps'),
	(576545, 127, '2014-03-15 00:22:09.000000', 'consum', 0.0210, 'lps'),
	(576546, 127, '2014-03-15 00:22:10.000000', 'consum', 0.0220, 'lps'),
	(576547, 127, '2014-03-15 00:22:11.000000', 'consum', 0.0226, 'lps'),
	(576548, 127, '2014-03-15 00:22:12.000000', 'consum', 0.0222, 'lps'),
	(576549, 127, '2014-03-15 00:22:13.000000', 'consum', 0.0223, 'lps'),
	(576550, 127, '2014-03-15 00:22:14.000000', 'consum', 0.0221, 'lps'),
	(576551, 127, '2014-03-15 00:22:15.000000', 'consum', 0.0225, 'lps'),
	(576552, 127, '2014-03-15 00:22:16.000000', 'consum', 0.0218, 'lps'),
	(576553, 127, '2014-03-15 00:22:17.000000', 'consum', 0.0225, 'lps'),
	(576554, 127, '2014-03-15 00:22:18.000000', 'consum', 0.0225, 'lps'),
	(576555, 127, '2014-03-15 00:22:19.000000', 'consum', 0.0223, 'lps'),
	(576556, 127, '2014-03-15 00:22:20.000000', 'consum', 0.0214, 'lps'),
	(576557, 127, '2014-03-15 00:22:21.000000', 'consum', 0.0226, 'lps'),
	(576558, 127, '2014-03-15 00:22:22.000000', 'consum', 0.0224, 'lps'),
	(576559, 127, '2014-03-15 00:22:23.000000', 'consum', 0.0214, 'lps'),
	(576560, 127, '2014-03-15 00:22:24.000000', 'consum', 0.0224, 'lps'),
	(576561, 127, '2014-03-15 00:22:25.000000', 'consum', 0.0217, 'lps'),
	(576562, 127, '2014-03-15 00:22:26.000000', 'consum', 0.0220, 'lps'),
	(576563, 127, '2014-03-15 00:22:27.000000', 'consum', 0.0223, 'lps'),
	(576564, 127, '2014-03-15 00:22:28.000000', 'consum', 0.0210, 'lps'),
	(576565, 127, '2014-03-15 00:22:29.000000', 'consum', 0.0224, 'lps'),
	(576566, 127, '2014-03-15 00:22:30.000000', 'consum', 0.0225, 'lps'),
	(576567, 127, '2014-03-15 00:22:31.000000', 'consum', 0.0211, 'lps'),
	(576568, 127, '2014-03-15 00:22:32.000000', 'consum', 0.0221, 'lps'),
	(576569, 127, '2014-03-15 00:22:33.000000', 'consum', 0.0212, 'lps'),
	(576570, 127, '2014-03-15 00:22:34.000000', 'consum', 0.0222, 'lps'),
	(576571, 127, '2014-03-15 00:22:35.000000', 'consum', 0.0210, 'lps'),
	(576572, 127, '2014-03-15 00:22:36.000000', 'consum', 0.0213, 'lps'),
	(576573, 127, '2014-03-15 00:22:37.000000', 'consum', 0.0222, 'lps'),
	(576574, 127, '2014-03-15 00:22:38.000000', 'consum', 0.0211, 'lps'),
	(576575, 127, '2014-03-15 00:22:39.000000', 'consum', 0.0213, 'lps'),
	(576576, 127, '2014-03-15 00:22:40.000000', 'consum', 0.0221, 'lps'),
	(576577, 127, '2014-03-15 00:22:41.000000', 'consum', 0.0223, 'lps'),
	(576578, 127, '2014-03-15 00:22:42.000000', 'consum', 0.0223, 'lps'),
	(576579, 127, '2014-03-15 00:22:43.000000', 'consum', 0.0219, 'lps'),
	(576580, 127, '2014-03-15 00:22:44.000000', 'consum', 0.0214, 'lps'),
	(576581, 127, '2014-03-15 00:22:45.000000', 'consum', 0.0225, 'lps'),
	(576582, 127, '2014-03-15 00:22:46.000000', 'consum', 0.0219, 'lps'),
	(576583, 127, '2014-03-15 00:22:47.000000', 'consum', 0.0210, 'lps'),
	(576584, 127, '2014-03-15 00:22:48.000000', 'consum', 0.0218, 'lps'),
	(576585, 127, '2014-03-15 00:22:49.000000', 'consum', 0.0216, 'lps'),
	(576586, 127, '2014-03-15 00:22:50.000000', 'consum', 0.0215, 'lps'),
	(576587, 127, '2014-03-15 00:22:51.000000', 'consum', 0.0218, 'lps'),
	(576588, 127, '2014-03-15 00:22:52.000000', 'consum', 0.0219, 'lps'),
	(576589, 127, '2014-03-15 00:22:53.000000', 'consum', 0.0214, 'lps'),
	(576590, 127, '2014-03-15 00:22:54.000000', 'consum', 0.0222, 'lps'),
	(576591, 127, '2014-03-15 00:22:55.000000', 'consum', 0.0223, 'lps'),
	(576592, 127, '2014-03-15 00:22:56.000000', 'consum', 0.0220, 'lps'),
	(576593, 127, '2014-03-15 00:22:57.000000', 'consum', 0.0220, 'lps'),
	(576594, 127, '2014-03-15 00:22:58.000000', 'consum', 0.0215, 'lps'),
	(576595, 127, '2014-03-15 00:22:59.000000', 'consum', 0.0221, 'lps'),
	(576596, 127, '2014-03-15 00:23:00.000000', 'consum', 0.0215, 'lps'),
	(576597, 127, '2014-03-15 00:23:01.000000', 'consum', 0.0223, 'lps'),
	(576598, 127, '2014-03-15 00:23:02.000000', 'consum', 0.0222, 'lps'),
	(576599, 127, '2014-03-15 00:23:03.000000', 'consum', 0.0214, 'lps'),
	(576600, 127, '2014-03-15 00:23:04.000000', 'consum', 0.0213, 'lps'),
	(576601, 127, '2014-03-15 00:23:05.000000', 'consum', 0.0213, 'lps'),
	(576602, 127, '2014-03-15 00:23:06.000000', 'consum', 0.0219, 'lps'),
	(576603, 127, '2014-03-15 00:23:07.000000', 'consum', 0.0225, 'lps'),
	(576604, 127, '2014-03-15 00:23:08.000000', 'consum', 0.0223, 'lps'),
	(576605, 127, '2014-03-15 00:23:09.000000', 'consum', 0.0212, 'lps'),
	(576606, 127, '2014-03-15 00:23:10.000000', 'consum', 0.0219, 'lps'),
	(576607, 127, '2014-03-15 00:23:11.000000', 'consum', 0.0214, 'lps'),
	(576608, 127, '2014-03-15 00:23:12.000000', 'consum', 0.0221, 'lps'),
	(576609, 127, '2014-03-15 00:23:13.000000', 'consum', 0.0219, 'lps'),
	(576610, 127, '2014-03-15 00:23:14.000000', 'consum', 0.0220, 'lps'),
	(576611, 127, '2014-03-15 00:23:15.000000', 'consum', 0.0217, 'lps'),
	(576612, 127, '2014-03-15 00:23:16.000000', 'consum', 0.0213, 'lps'),
	(576613, 127, '2014-03-15 00:23:17.000000', 'consum', 0.0224, 'lps'),
	(576614, 127, '2014-03-15 00:23:18.000000', 'consum', 0.0217, 'lps'),
	(576615, 127, '2014-03-15 00:23:19.000000', 'consum', 0.0223, 'lps'),
	(576616, 127, '2014-03-15 00:23:20.000000', 'consum', 0.0217, 'lps'),
	(576617, 127, '2014-03-15 00:23:21.000000', 'consum', 0.0226, 'lps'),
	(576618, 127, '2014-03-15 00:23:22.000000', 'consum', 0.0216, 'lps'),
	(576619, 127, '2014-03-15 00:23:23.000000', 'consum', 0.0210, 'lps'),
	(576620, 127, '2014-03-15 00:23:24.000000', 'consum', 0.0210, 'lps'),
	(576621, 127, '2014-03-15 00:23:25.000000', 'consum', 0.0227, 'lps'),
	(576622, 127, '2014-03-15 00:23:26.000000', 'consum', 0.0225, 'lps'),
	(576623, 127, '2014-03-15 00:23:27.000000', 'consum', 0.0217, 'lps'),
	(576624, 127, '2014-03-15 00:23:28.000000', 'consum', 0.0219, 'lps'),
	(576625, 127, '2014-03-15 00:23:29.000000', 'consum', 0.0217, 'lps'),
	(576626, 127, '2014-03-15 00:23:30.000000', 'consum', 0.0216, 'lps'),
	(576627, 127, '2014-03-15 00:23:31.000000', 'consum', 0.0221, 'lps'),
	(576628, 127, '2014-03-15 00:23:32.000000', 'consum', 0.0210, 'lps'),
	(576629, 127, '2014-03-15 00:23:33.000000', 'consum', 0.0214, 'lps'),
	(576630, 127, '2014-03-15 00:23:34.000000', 'consum', 0.0214, 'lps'),
	(576631, 127, '2014-03-15 00:23:35.000000', 'consum', 0.0217, 'lps'),
	(576632, 127, '2014-03-15 00:23:36.000000', 'consum', 0.0218, 'lps'),
	(576633, 127, '2014-03-15 00:23:37.000000', 'consum', 0.0226, 'lps'),
	(576634, 127, '2014-03-15 00:23:38.000000', 'consum', 0.0216, 'lps'),
	(576635, 127, '2014-03-15 00:23:39.000000', 'consum', 0.0226, 'lps'),
	(576636, 127, '2014-03-15 00:23:40.000000', 'consum', 0.0219, 'lps'),
	(576637, 127, '2014-03-15 00:23:41.000000', 'consum', 0.0227, 'lps'),
	(576638, 127, '2014-03-15 00:23:42.000000', 'consum', 0.0212, 'lps'),
	(576639, 127, '2014-03-15 00:23:43.000000', 'consum', 0.0225, 'lps'),
	(576640, 127, '2014-03-15 00:23:44.000000', 'consum', 0.0227, 'lps'),
	(576641, 127, '2014-03-15 00:23:45.000000', 'consum', 0.0212, 'lps'),
	(576642, 127, '2014-03-15 00:23:46.000000', 'consum', 0.0226, 'lps'),
	(576643, 127, '2014-03-15 00:23:47.000000', 'consum', 0.0211, 'lps'),
	(576644, 127, '2014-03-15 00:23:48.000000', 'consum', 0.0221, 'lps'),
	(576645, 127, '2014-03-15 00:23:49.000000', 'consum', 0.0227, 'lps'),
	(576646, 127, '2014-03-15 00:23:50.000000', 'consum', 0.0225, 'lps'),
	(576647, 127, '2014-03-15 00:23:51.000000', 'consum', 0.0217, 'lps'),
	(576648, 127, '2014-03-15 00:23:52.000000', 'consum', 0.0218, 'lps'),
	(576649, 127, '2014-03-15 00:23:53.000000', 'consum', 0.0213, 'lps'),
	(576650, 127, '2014-03-15 00:23:54.000000', 'consum', 0.0220, 'lps'),
	(576651, 127, '2014-03-15 00:23:55.000000', 'consum', 0.0214, 'lps'),
	(576652, 127, '2014-03-15 00:23:56.000000', 'consum', 0.0218, 'lps'),
	(576653, 127, '2014-03-15 00:23:57.000000', 'consum', 0.0220, 'lps'),
	(576654, 127, '2014-03-15 00:23:58.000000', 'consum', 0.0218, 'lps'),
	(576655, 127, '2014-03-15 00:23:59.000000', 'consum', 0.0221, 'lps'),
	(576656, 127, '2014-03-15 00:24:00.000000', 'consum', 0.0223, 'lps'),
	(576657, 127, '2014-03-15 00:24:01.000000', 'consum', 0.0224, 'lps'),
	(576658, 127, '2014-03-15 00:24:02.000000', 'consum', 0.0224, 'lps'),
	(576659, 127, '2014-03-15 00:24:03.000000', 'consum', 0.0220, 'lps'),
	(576660, 127, '2014-03-15 00:24:04.000000', 'consum', 0.0219, 'lps'),
	(576661, 127, '2014-03-15 00:24:05.000000', 'consum', 0.0227, 'lps'),
	(576662, 127, '2014-03-15 00:24:06.000000', 'consum', 0.0214, 'lps'),
	(576663, 127, '2014-03-15 00:24:07.000000', 'consum', 0.0214, 'lps'),
	(576664, 127, '2014-03-15 00:24:08.000000', 'consum', 0.0220, 'lps'),
	(576665, 127, '2014-03-15 00:24:09.000000', 'consum', 0.0213, 'lps'),
	(576666, 127, '2014-03-15 00:24:10.000000', 'consum', 0.0212, 'lps'),
	(576667, 127, '2014-03-15 00:24:11.000000', 'consum', 0.0213, 'lps'),
	(576668, 127, '2014-03-15 00:24:12.000000', 'consum', 0.0220, 'lps'),
	(576669, 127, '2014-03-15 00:24:13.000000', 'consum', 0.0217, 'lps'),
	(576670, 127, '2014-03-15 00:24:14.000000', 'consum', 0.0213, 'lps'),
	(576671, 127, '2014-03-15 00:24:15.000000', 'consum', 0.0221, 'lps'),
	(576672, 127, '2014-03-15 00:24:16.000000', 'consum', 0.0222, 'lps'),
	(576673, 127, '2014-03-15 00:24:17.000000', 'consum', 0.0221, 'lps'),
	(576674, 127, '2014-03-15 00:24:18.000000', 'consum', 0.0227, 'lps'),
	(576675, 127, '2014-03-15 00:24:19.000000', 'consum', 0.0211, 'lps'),
	(576676, 127, '2014-03-15 00:24:20.000000', 'consum', 0.0219, 'lps'),
	(576677, 127, '2014-03-15 00:24:21.000000', 'consum', 0.0216, 'lps'),
	(576678, 127, '2014-03-15 00:24:22.000000', 'consum', 0.0212, 'lps'),
	(576679, 127, '2014-03-15 00:24:23.000000', 'consum', 0.0220, 'lps'),
	(576680, 127, '2014-03-15 00:24:24.000000', 'consum', 0.0220, 'lps'),
	(576681, 127, '2014-03-15 00:24:25.000000', 'consum', 0.0212, 'lps'),
	(576682, 127, '2014-03-15 00:24:26.000000', 'consum', 0.0210, 'lps'),
	(576683, 127, '2014-03-15 00:24:27.000000', 'consum', 0.0224, 'lps'),
	(576684, 127, '2014-03-15 00:24:28.000000', 'consum', 0.0223, 'lps'),
	(576685, 127, '2014-03-15 00:24:29.000000', 'consum', 0.0217, 'lps'),
	(576686, 127, '2014-03-15 00:24:30.000000', 'consum', 0.0226, 'lps'),
	(576687, 127, '2014-03-15 00:24:31.000000', 'consum', 0.0214, 'lps'),
	(576688, 127, '2014-03-15 00:24:32.000000', 'consum', 0.0218, 'lps'),
	(576689, 127, '2014-03-15 00:24:33.000000', 'consum', 0.0219, 'lps'),
	(576690, 127, '2014-03-15 00:24:34.000000', 'consum', 0.0217, 'lps'),
	(576691, 127, '2014-03-15 00:24:35.000000', 'consum', 0.0217, 'lps'),
	(576692, 127, '2014-03-15 00:24:36.000000', 'consum', 0.0224, 'lps'),
	(576693, 127, '2014-03-15 00:24:37.000000', 'consum', 0.0224, 'lps'),
	(576694, 127, '2014-03-15 00:24:38.000000', 'consum', 0.0222, 'lps'),
	(576695, 127, '2014-03-15 00:24:39.000000', 'consum', 0.0225, 'lps'),
	(576696, 127, '2014-03-15 00:24:40.000000', 'consum', 0.0217, 'lps'),
	(576697, 127, '2014-03-15 00:24:41.000000', 'consum', 0.0216, 'lps'),
	(576698, 127, '2014-03-15 00:24:42.000000', 'consum', 0.0221, 'lps'),
	(576699, 127, '2014-03-15 00:24:43.000000', 'consum', 0.0211, 'lps'),
	(576700, 127, '2014-03-15 00:24:44.000000', 'consum', 0.0220, 'lps'),
	(576701, 127, '2014-03-15 00:24:45.000000', 'consum', 0.0222, 'lps'),
	(576702, 127, '2014-03-15 00:24:46.000000', 'consum', 0.0222, 'lps'),
	(576703, 127, '2014-03-15 00:24:47.000000', 'consum', 0.0218, 'lps'),
	(576704, 127, '2014-03-15 00:24:48.000000', 'consum', 0.0214, 'lps'),
	(576705, 127, '2014-03-15 00:24:49.000000', 'consum', 0.0223, 'lps'),
	(576706, 127, '2014-03-15 00:24:50.000000', 'consum', 0.0212, 'lps'),
	(576707, 127, '2014-03-15 00:24:51.000000', 'consum', 0.0215, 'lps'),
	(576708, 127, '2014-03-15 00:24:52.000000', 'consum', 0.0213, 'lps'),
	(576709, 127, '2014-03-15 00:24:53.000000', 'consum', 0.0227, 'lps'),
	(576710, 127, '2014-03-15 00:24:54.000000', 'consum', 0.0217, 'lps'),
	(576711, 127, '2014-03-15 00:24:55.000000', 'consum', 0.0211, 'lps'),
	(576712, 127, '2014-03-15 00:24:56.000000', 'consum', 0.0214, 'lps'),
	(576713, 127, '2014-03-15 00:24:57.000000', 'consum', 0.0225, 'lps'),
	(576714, 127, '2014-03-15 00:24:58.000000', 'consum', 0.0222, 'lps'),
	(576715, 127, '2014-03-15 00:24:59.000000', 'consum', 0.0224, 'lps'),
	(576716, 127, '2014-03-15 00:25:00.000000', 'consum', 0.0227, 'lps'),
	(576717, 127, '2014-03-15 00:25:01.000000', 'consum', 0.0216, 'lps'),
	(576718, 127, '2014-03-15 00:25:02.000000', 'consum', 0.0227, 'lps'),
	(576719, 127, '2014-03-15 00:25:03.000000', 'consum', 0.0223, 'lps'),
	(576720, 127, '2014-03-15 00:25:04.000000', 'consum', 0.0227, 'lps'),
	(576721, 127, '2014-03-15 00:25:05.000000', 'consum', 0.0217, 'lps'),
	(576722, 127, '2014-03-15 00:25:06.000000', 'consum', 0.0214, 'lps'),
	(576723, 127, '2014-03-15 00:25:07.000000', 'consum', 0.0211, 'lps'),
	(576724, 127, '2014-03-15 00:25:08.000000', 'consum', 0.0222, 'lps'),
	(576725, 127, '2014-03-15 00:25:09.000000', 'consum', 0.0211, 'lps'),
	(576726, 127, '2014-03-15 00:25:10.000000', 'consum', 0.0216, 'lps'),
	(576727, 127, '2014-03-15 00:25:11.000000', 'consum', 0.0220, 'lps'),
	(576728, 127, '2014-03-15 00:25:12.000000', 'consum', 0.0224, 'lps'),
	(576729, 127, '2014-03-15 00:25:13.000000', 'consum', 0.0214, 'lps'),
	(576730, 127, '2014-03-15 00:25:14.000000', 'consum', 0.0225, 'lps'),
	(576731, 127, '2014-03-15 00:25:15.000000', 'consum', 0.0221, 'lps'),
	(576732, 127, '2014-03-15 00:25:16.000000', 'consum', 0.0220, 'lps'),
	(576733, 127, '2014-03-15 00:25:17.000000', 'consum', 0.0211, 'lps'),
	(576734, 127, '2014-03-15 00:25:18.000000', 'consum', 0.0221, 'lps'),
	(576735, 127, '2014-03-15 00:25:19.000000', 'consum', 0.0224, 'lps'),
	(576736, 127, '2014-03-15 00:25:20.000000', 'consum', 0.0212, 'lps'),
	(576737, 127, '2014-03-15 00:25:21.000000', 'consum', 0.0217, 'lps'),
	(576738, 127, '2014-03-15 00:25:22.000000', 'consum', 0.0220, 'lps'),
	(576739, 127, '2014-03-15 00:25:23.000000', 'consum', 0.0222, 'lps'),
	(576740, 127, '2014-03-15 00:25:24.000000', 'consum', 0.0223, 'lps'),
	(576741, 127, '2014-03-15 00:25:25.000000', 'consum', 0.0222, 'lps'),
	(576742, 127, '2014-03-15 00:25:26.000000', 'consum', 0.0213, 'lps'),
	(576743, 127, '2014-03-15 00:25:27.000000', 'consum', 0.0227, 'lps'),
	(576744, 127, '2014-03-15 00:25:28.000000', 'consum', 0.0211, 'lps'),
	(576745, 127, '2014-03-15 00:25:29.000000', 'consum', 0.0222, 'lps'),
	(576746, 127, '2014-03-15 00:25:30.000000', 'consum', 0.0212, 'lps'),
	(576747, 127, '2014-03-15 00:25:31.000000', 'consum', 0.0221, 'lps'),
	(576748, 127, '2014-03-15 00:25:32.000000', 'consum', 0.0223, 'lps'),
	(576749, 127, '2014-03-15 00:25:33.000000', 'consum', 0.0223, 'lps'),
	(576750, 127, '2014-03-15 00:25:34.000000', 'consum', 0.0219, 'lps'),
	(576751, 127, '2014-03-15 00:25:35.000000', 'consum', 0.0216, 'lps'),
	(576752, 127, '2014-03-15 00:25:36.000000', 'consum', 0.0216, 'lps'),
	(576753, 127, '2014-03-15 00:25:37.000000', 'consum', 0.0221, 'lps'),
	(576754, 127, '2014-03-15 00:25:38.000000', 'consum', 0.0213, 'lps'),
	(576755, 127, '2014-03-15 00:25:39.000000', 'consum', 0.0211, 'lps'),
	(576756, 127, '2014-03-15 00:25:40.000000', 'consum', 0.0224, 'lps'),
	(576757, 127, '2014-03-15 00:25:41.000000', 'consum', 0.0223, 'lps'),
	(576758, 127, '2014-03-15 00:25:42.000000', 'consum', 0.0218, 'lps'),
	(576759, 127, '2014-03-15 00:25:43.000000', 'consum', 0.0226, 'lps'),
	(576760, 127, '2014-03-15 00:25:44.000000', 'consum', 0.0213, 'lps'),
	(576761, 127, '2014-03-15 00:25:45.000000', 'consum', 0.0214, 'lps'),
	(576762, 127, '2014-03-15 00:25:46.000000', 'consum', 0.0222, 'lps'),
	(576763, 127, '2014-03-15 00:25:47.000000', 'consum', 0.0223, 'lps'),
	(576764, 127, '2014-03-15 00:25:48.000000', 'consum', 0.0223, 'lps'),
	(576765, 127, '2014-03-15 00:25:49.000000', 'consum', 0.0217, 'lps'),
	(576766, 127, '2014-03-15 00:25:50.000000', 'consum', 0.0222, 'lps'),
	(576767, 127, '2014-03-15 00:25:51.000000', 'consum', 0.0217, 'lps'),
	(576768, 127, '2014-03-15 00:25:52.000000', 'consum', 0.0210, 'lps'),
	(576769, 127, '2014-03-15 00:25:53.000000', 'consum', 0.0223, 'lps'),
	(576770, 127, '2014-03-15 00:25:54.000000', 'consum', 0.0224, 'lps'),
	(576771, 127, '2014-03-15 00:25:55.000000', 'consum', 0.0223, 'lps'),
	(576772, 127, '2014-03-15 00:25:56.000000', 'consum', 0.0214, 'lps'),
	(576773, 127, '2014-03-15 00:25:57.000000', 'consum', 0.0212, 'lps'),
	(576774, 127, '2014-03-15 00:25:58.000000', 'consum', 0.0225, 'lps'),
	(576775, 127, '2014-03-15 00:25:59.000000', 'consum', 0.0224, 'lps'),
	(576776, 127, '2014-03-15 00:26:00.000000', 'consum', 0.0218, 'lps'),
	(576777, 127, '2014-03-15 00:26:01.000000', 'consum', 0.0211, 'lps'),
	(576778, 127, '2014-03-15 00:26:02.000000', 'consum', 0.0226, 'lps'),
	(576779, 127, '2014-03-15 00:26:03.000000', 'consum', 0.0216, 'lps'),
	(576780, 127, '2014-03-15 00:26:04.000000', 'consum', 0.0210, 'lps'),
	(576781, 127, '2014-03-15 00:26:05.000000', 'consum', 0.0210, 'lps'),
	(576782, 127, '2014-03-15 00:26:06.000000', 'consum', 0.0227, 'lps'),
	(576783, 127, '2014-03-15 00:26:07.000000', 'consum', 0.0226, 'lps'),
	(576784, 127, '2014-03-15 00:26:08.000000', 'consum', 0.0220, 'lps'),
	(576785, 127, '2014-03-15 00:26:09.000000', 'consum', 0.0212, 'lps'),
	(576786, 127, '2014-03-15 00:26:10.000000', 'consum', 0.0225, 'lps'),
	(576787, 127, '2014-03-15 00:26:11.000000', 'consum', 0.0211, 'lps'),
	(576788, 127, '2014-03-15 00:26:12.000000', 'consum', 0.0224, 'lps'),
	(576789, 127, '2014-03-15 00:26:13.000000', 'consum', 0.0222, 'lps'),
	(576790, 127, '2014-03-15 00:26:14.000000', 'consum', 0.0227, 'lps'),
	(576791, 127, '2014-03-15 00:26:15.000000', 'consum', 0.0226, 'lps'),
	(576792, 127, '2014-03-15 00:26:16.000000', 'consum', 0.0221, 'lps'),
	(576793, 127, '2014-03-15 00:26:17.000000', 'consum', 0.0219, 'lps'),
	(576794, 127, '2014-03-15 00:26:18.000000', 'consum', 0.0221, 'lps'),
	(576795, 127, '2014-03-15 00:26:19.000000', 'consum', 0.0220, 'lps'),
	(576796, 127, '2014-03-15 00:26:20.000000', 'consum', 0.0211, 'lps'),
	(576797, 127, '2014-03-15 00:26:21.000000', 'consum', 0.0219, 'lps'),
	(576798, 127, '2014-03-15 00:26:22.000000', 'consum', 0.0219, 'lps'),
	(576799, 127, '2014-03-15 00:26:23.000000', 'consum', 0.0210, 'lps'),
	(576800, 127, '2014-03-15 00:26:24.000000', 'consum', 0.0219, 'lps'),
	(576801, 127, '2014-03-15 00:26:25.000000', 'consum', 0.0222, 'lps'),
	(576802, 127, '2014-03-15 00:26:26.000000', 'consum', 0.0223, 'lps'),
	(576803, 127, '2014-03-15 00:26:27.000000', 'consum', 0.0222, 'lps'),
	(576804, 127, '2014-03-15 00:26:28.000000', 'consum', 0.0214, 'lps'),
	(576805, 127, '2014-03-15 00:26:29.000000', 'consum', 0.0211, 'lps'),
	(576806, 127, '2014-03-15 00:26:30.000000', 'consum', 0.0220, 'lps'),
	(576807, 127, '2014-03-15 00:26:31.000000', 'consum', 0.0225, 'lps'),
	(576808, 127, '2014-03-15 00:26:32.000000', 'consum', 0.0217, 'lps'),
	(576809, 127, '2014-03-15 00:26:33.000000', 'consum', 0.0220, 'lps'),
	(576810, 127, '2014-03-15 00:26:34.000000', 'consum', 0.0220, 'lps'),
	(576811, 127, '2014-03-15 00:26:35.000000', 'consum', 0.0213, 'lps'),
	(576812, 127, '2014-03-15 00:26:36.000000', 'consum', 0.0215, 'lps'),
	(576813, 127, '2014-03-15 00:26:37.000000', 'consum', 0.0227, 'lps'),
	(576814, 127, '2014-03-15 00:26:38.000000', 'consum', 0.0224, 'lps'),
	(576815, 127, '2014-03-15 00:26:39.000000', 'consum', 0.0215, 'lps'),
	(576816, 127, '2014-03-15 00:26:40.000000', 'consum', 0.0226, 'lps'),
	(576817, 127, '2014-03-15 00:26:41.000000', 'consum', 0.0223, 'lps'),
	(576818, 127, '2014-03-15 00:26:42.000000', 'consum', 0.0210, 'lps'),
	(576819, 127, '2014-03-15 00:26:43.000000', 'consum', 0.0226, 'lps'),
	(576820, 127, '2014-03-15 00:26:44.000000', 'consum', 0.0216, 'lps'),
	(576821, 127, '2014-03-15 00:26:45.000000', 'consum', 0.0213, 'lps'),
	(576822, 127, '2014-03-15 00:26:46.000000', 'consum', 0.0223, 'lps'),
	(576823, 127, '2014-03-15 00:26:47.000000', 'consum', 0.0213, 'lps'),
	(576824, 127, '2014-03-15 00:26:48.000000', 'consum', 0.0221, 'lps'),
	(576825, 127, '2014-03-15 00:26:49.000000', 'consum', 0.0224, 'lps'),
	(576826, 127, '2014-03-15 00:26:50.000000', 'consum', 0.0226, 'lps'),
	(576827, 127, '2014-03-15 00:26:51.000000', 'consum', 0.0216, 'lps'),
	(576828, 127, '2014-03-15 00:26:52.000000', 'consum', 0.0227, 'lps'),
	(576829, 127, '2014-03-15 00:26:53.000000', 'consum', 0.0224, 'lps'),
	(576830, 127, '2014-03-15 00:26:54.000000', 'consum', 0.0213, 'lps'),
	(576831, 127, '2014-03-15 00:26:55.000000', 'consum', 0.0218, 'lps'),
	(576832, 127, '2014-03-15 00:26:56.000000', 'consum', 0.0223, 'lps'),
	(576833, 127, '2014-03-15 00:26:57.000000', 'consum', 0.0217, 'lps'),
	(576834, 127, '2014-03-15 00:26:58.000000', 'consum', 0.0225, 'lps'),
	(576835, 127, '2014-03-15 00:26:59.000000', 'consum', 0.0227, 'lps'),
	(576836, 127, '2014-03-15 00:27:00.000000', 'consum', 0.0215, 'lps'),
	(576837, 127, '2014-03-15 00:27:01.000000', 'consum', 0.0222, 'lps'),
	(576838, 127, '2014-03-15 00:27:02.000000', 'consum', 0.0221, 'lps'),
	(576839, 127, '2014-03-15 00:27:03.000000', 'consum', 0.0226, 'lps'),
	(576840, 127, '2014-03-15 00:27:04.000000', 'consum', 0.0221, 'lps'),
	(576841, 127, '2014-03-15 00:27:05.000000', 'consum', 0.0221, 'lps'),
	(576842, 127, '2014-03-15 00:27:06.000000', 'consum', 0.0211, 'lps'),
	(576843, 127, '2014-03-15 00:27:07.000000', 'consum', 0.0220, 'lps'),
	(576844, 127, '2014-03-15 00:27:08.000000', 'consum', 0.0219, 'lps'),
	(576845, 127, '2014-03-15 00:27:09.000000', 'consum', 0.0211, 'lps'),
	(576846, 127, '2014-03-15 00:27:10.000000', 'consum', 0.0223, 'lps'),
	(576847, 127, '2014-03-15 00:27:11.000000', 'consum', 0.0219, 'lps'),
	(576848, 127, '2014-03-15 00:27:12.000000', 'consum', 0.0216, 'lps'),
	(576849, 127, '2014-03-15 00:27:13.000000', 'consum', 0.0212, 'lps'),
	(576850, 127, '2014-03-15 00:27:14.000000', 'consum', 0.0221, 'lps'),
	(576851, 127, '2014-03-15 00:27:15.000000', 'consum', 0.0224, 'lps'),
	(576852, 127, '2014-03-15 00:27:16.000000', 'consum', 0.0210, 'lps'),
	(576853, 127, '2014-03-15 00:27:17.000000', 'consum', 0.0224, 'lps'),
	(576854, 127, '2014-03-15 00:27:18.000000', 'consum', 0.0225, 'lps'),
	(576855, 127, '2014-03-15 00:27:19.000000', 'consum', 0.0224, 'lps'),
	(576856, 127, '2014-03-15 00:27:20.000000', 'consum', 0.0221, 'lps'),
	(576857, 127, '2014-03-15 00:27:21.000000', 'consum', 0.0220, 'lps'),
	(576858, 127, '2014-03-15 00:27:22.000000', 'consum', 0.0212, 'lps'),
	(576859, 127, '2014-03-15 00:27:23.000000', 'consum', 0.0225, 'lps'),
	(576860, 127, '2014-03-15 00:27:24.000000', 'consum', 0.0226, 'lps'),
	(576861, 127, '2014-03-15 00:27:25.000000', 'consum', 0.0210, 'lps'),
	(576862, 127, '2014-03-15 00:27:26.000000', 'consum', 0.0216, 'lps'),
	(576863, 127, '2014-03-15 00:27:27.000000', 'consum', 0.0224, 'lps'),
	(576864, 127, '2014-03-15 00:27:28.000000', 'consum', 0.0224, 'lps'),
	(576865, 127, '2014-03-15 00:27:29.000000', 'consum', 0.0222, 'lps'),
	(576866, 127, '2014-03-15 00:27:30.000000', 'consum', 0.0211, 'lps'),
	(576867, 127, '2014-03-15 00:27:31.000000', 'consum', 0.0217, 'lps'),
	(576868, 127, '2014-03-15 00:27:32.000000', 'consum', 0.0223, 'lps'),
	(576869, 127, '2014-03-15 00:27:33.000000', 'consum', 0.0220, 'lps'),
	(576870, 127, '2014-03-15 00:27:34.000000', 'consum', 0.0222, 'lps'),
	(576871, 127, '2014-03-15 00:27:35.000000', 'consum', 0.0222, 'lps'),
	(576872, 127, '2014-03-15 00:27:36.000000', 'consum', 0.0216, 'lps'),
	(576873, 127, '2014-03-15 00:27:37.000000', 'consum', 0.0224, 'lps'),
	(576874, 127, '2014-03-15 00:27:38.000000', 'consum', 0.0226, 'lps'),
	(576875, 127, '2014-03-15 00:27:39.000000', 'consum', 0.0213, 'lps'),
	(576876, 127, '2014-03-15 00:27:40.000000', 'consum', 0.0211, 'lps'),
	(576877, 127, '2014-03-15 00:27:41.000000', 'consum', 0.0227, 'lps'),
	(576878, 127, '2014-03-15 00:27:42.000000', 'consum', 0.0220, 'lps'),
	(576879, 127, '2014-03-15 00:27:43.000000', 'consum', 0.0227, 'lps'),
	(576880, 127, '2014-03-15 00:27:44.000000', 'consum', 0.0213, 'lps'),
	(576881, 127, '2014-03-15 00:27:45.000000', 'consum', 0.0210, 'lps'),
	(576882, 127, '2014-03-15 00:27:46.000000', 'consum', 0.0218, 'lps'),
	(576883, 127, '2014-03-15 00:27:47.000000', 'consum', 0.0214, 'lps'),
	(576884, 127, '2014-03-15 00:27:48.000000', 'consum', 0.0223, 'lps'),
	(576885, 127, '2014-03-15 00:27:49.000000', 'consum', 0.0213, 'lps'),
	(576886, 127, '2014-03-15 00:27:50.000000', 'consum', 0.0222, 'lps'),
	(576887, 127, '2014-03-15 00:27:51.000000', 'consum', 0.0225, 'lps'),
	(576888, 127, '2014-03-15 00:27:52.000000', 'consum', 0.0212, 'lps'),
	(576889, 127, '2014-03-15 00:27:53.000000', 'consum', 0.0213, 'lps'),
	(576890, 127, '2014-03-15 00:27:54.000000', 'consum', 0.0221, 'lps'),
	(576891, 127, '2014-03-15 00:27:55.000000', 'consum', 0.0218, 'lps'),
	(576892, 127, '2014-03-15 00:27:56.000000', 'consum', 0.0220, 'lps'),
	(576893, 127, '2014-03-15 00:27:57.000000', 'consum', 0.0217, 'lps'),
	(576894, 127, '2014-03-15 00:27:58.000000', 'consum', 0.0216, 'lps'),
	(576895, 127, '2014-03-15 00:27:59.000000', 'consum', 0.0218, 'lps'),
	(576896, 127, '2014-03-15 00:28:00.000000', 'consum', 0.0215, 'lps'),
	(576897, 127, '2014-03-15 00:28:01.000000', 'consum', 0.0212, 'lps'),
	(576898, 127, '2014-03-15 00:28:02.000000', 'consum', 0.0223, 'lps'),
	(576899, 127, '2014-03-15 00:28:03.000000', 'consum', 0.0214, 'lps'),
	(576900, 127, '2014-03-15 00:28:04.000000', 'consum', 0.0210, 'lps'),
	(576901, 127, '2014-03-15 00:28:05.000000', 'consum', 0.0218, 'lps'),
	(576902, 127, '2014-03-15 00:28:06.000000', 'consum', 0.0212, 'lps'),
	(576903, 127, '2014-03-15 00:28:07.000000', 'consum', 0.0216, 'lps'),
	(576904, 127, '2014-03-15 00:28:08.000000', 'consum', 0.0217, 'lps'),
	(576905, 127, '2014-03-15 00:28:09.000000', 'consum', 0.0227, 'lps'),
	(576906, 127, '2014-03-15 00:28:10.000000', 'consum', 0.0222, 'lps'),
	(576907, 127, '2014-03-15 00:28:11.000000', 'consum', 0.0217, 'lps'),
	(576908, 127, '2014-03-15 00:28:12.000000', 'consum', 0.0227, 'lps'),
	(576909, 127, '2014-03-15 00:28:13.000000', 'consum', 0.0224, 'lps'),
	(576910, 127, '2014-03-15 00:28:14.000000', 'consum', 0.0226, 'lps'),
	(576911, 127, '2014-03-15 00:28:15.000000', 'consum', 0.0215, 'lps'),
	(576912, 127, '2014-03-15 00:28:16.000000', 'consum', 0.0221, 'lps'),
	(576913, 127, '2014-03-15 00:28:17.000000', 'consum', 0.0217, 'lps'),
	(576914, 127, '2014-03-15 00:28:18.000000', 'consum', 0.0210, 'lps'),
	(576915, 127, '2014-03-15 00:28:19.000000', 'consum', 0.0225, 'lps'),
	(576916, 127, '2014-03-15 00:28:20.000000', 'consum', 0.0216, 'lps'),
	(576917, 127, '2014-03-15 00:28:21.000000', 'consum', 0.0213, 'lps'),
	(576918, 127, '2014-03-15 00:28:22.000000', 'consum', 0.0225, 'lps'),
	(576919, 127, '2014-03-15 00:28:23.000000', 'consum', 0.0223, 'lps'),
	(576920, 127, '2014-03-15 00:28:24.000000', 'consum', 0.0214, 'lps'),
	(576921, 127, '2014-03-15 00:28:25.000000', 'consum', 0.0225, 'lps'),
	(576922, 127, '2014-03-15 00:28:26.000000', 'consum', 0.0222, 'lps'),
	(576923, 127, '2014-03-15 00:28:27.000000', 'consum', 0.0223, 'lps'),
	(576924, 127, '2014-03-15 00:28:28.000000', 'consum', 0.0223, 'lps'),
	(576925, 127, '2014-03-15 00:28:29.000000', 'consum', 0.0216, 'lps'),
	(576926, 127, '2014-03-15 00:28:30.000000', 'consum', 0.0221, 'lps'),
	(576927, 127, '2014-03-15 00:28:31.000000', 'consum', 0.0214, 'lps'),
	(576928, 127, '2014-03-15 00:28:32.000000', 'consum', 0.0212, 'lps'),
	(576929, 127, '2014-03-15 00:28:33.000000', 'consum', 0.0210, 'lps'),
	(576930, 127, '2014-03-15 00:28:34.000000', 'consum', 0.0221, 'lps'),
	(576931, 127, '2014-03-15 00:28:35.000000', 'consum', 0.0211, 'lps'),
	(576932, 127, '2014-03-15 00:28:36.000000', 'consum', 0.0220, 'lps'),
	(576933, 127, '2014-03-15 00:28:37.000000', 'consum', 0.0220, 'lps'),
	(576934, 127, '2014-03-15 00:28:38.000000', 'consum', 0.0212, 'lps'),
	(576935, 127, '2014-03-15 00:28:39.000000', 'consum', 0.0226, 'lps'),
	(576936, 127, '2014-03-15 00:28:40.000000', 'consum', 0.0216, 'lps'),
	(576937, 127, '2014-03-15 00:28:41.000000', 'consum', 0.0225, 'lps'),
	(576938, 127, '2014-03-15 00:28:42.000000', 'consum', 0.0215, 'lps'),
	(576939, 127, '2014-03-15 00:28:43.000000', 'consum', 0.0226, 'lps'),
	(576940, 127, '2014-03-15 00:28:44.000000', 'consum', 0.0220, 'lps'),
	(576941, 127, '2014-03-15 00:28:45.000000', 'consum', 0.0216, 'lps'),
	(576942, 127, '2014-03-15 00:28:46.000000', 'consum', 0.0226, 'lps'),
	(576943, 127, '2014-03-15 00:28:47.000000', 'consum', 0.0218, 'lps'),
	(576944, 127, '2014-03-15 00:28:48.000000', 'consum', 0.0222, 'lps'),
	(576945, 127, '2014-03-15 00:28:49.000000', 'consum', 0.0212, 'lps'),
	(576946, 127, '2014-03-15 00:28:50.000000', 'consum', 0.0218, 'lps'),
	(576947, 127, '2014-03-15 00:28:51.000000', 'consum', 0.0227, 'lps'),
	(576948, 127, '2014-03-15 00:28:52.000000', 'consum', 0.0216, 'lps'),
	(576949, 127, '2014-03-15 00:28:53.000000', 'consum', 0.0210, 'lps'),
	(576950, 127, '2014-03-15 00:28:54.000000', 'consum', 0.0211, 'lps'),
	(576951, 127, '2014-03-15 00:28:55.000000', 'consum', 0.0217, 'lps'),
	(576952, 127, '2014-03-15 00:28:56.000000', 'consum', 0.0221, 'lps'),
	(576953, 127, '2014-03-15 00:28:57.000000', 'consum', 0.0226, 'lps'),
	(576954, 127, '2014-03-15 00:28:58.000000', 'consum', 0.0224, 'lps'),
	(576955, 127, '2014-03-15 00:28:59.000000', 'consum', 0.0214, 'lps'),
	(576956, 127, '2014-03-15 00:29:00.000000', 'consum', 0.0223, 'lps'),
	(576957, 127, '2014-03-15 00:29:01.000000', 'consum', 0.0227, 'lps'),
	(576958, 127, '2014-03-15 00:29:02.000000', 'consum', 0.0223, 'lps'),
	(576959, 127, '2014-03-15 00:29:03.000000', 'consum', 0.0224, 'lps'),
	(576960, 127, '2014-03-15 00:29:04.000000', 'consum', 0.0223, 'lps'),
	(576961, 127, '2014-03-15 00:29:05.000000', 'consum', 0.0216, 'lps'),
	(576962, 127, '2014-03-15 00:29:06.000000', 'consum', 0.0220, 'lps'),
	(576963, 127, '2014-03-15 00:29:07.000000', 'consum', 0.0222, 'lps'),
	(576964, 127, '2014-03-15 00:29:08.000000', 'consum', 0.0223, 'lps'),
	(576965, 127, '2014-03-15 00:29:09.000000', 'consum', 0.0224, 'lps'),
	(576966, 127, '2014-03-15 00:29:10.000000', 'consum', 0.0222, 'lps'),
	(576967, 127, '2014-03-15 00:29:11.000000', 'consum', 0.0227, 'lps'),
	(576968, 127, '2014-03-15 00:29:12.000000', 'consum', 0.0225, 'lps'),
	(576969, 127, '2014-03-15 00:29:13.000000', 'consum', 0.0215, 'lps'),
	(576970, 127, '2014-03-15 00:29:14.000000', 'consum', 0.0227, 'lps'),
	(576971, 127, '2014-03-15 00:29:15.000000', 'consum', 0.0210, 'lps'),
	(576972, 127, '2014-03-15 00:29:16.000000', 'consum', 0.0212, 'lps'),
	(576973, 127, '2014-03-15 00:29:17.000000', 'consum', 0.0223, 'lps'),
	(576974, 127, '2014-03-15 00:29:18.000000', 'consum', 0.0214, 'lps'),
	(576975, 127, '2014-03-15 00:29:19.000000', 'consum', 0.0227, 'lps'),
	(576976, 127, '2014-03-15 00:29:20.000000', 'consum', 0.0212, 'lps'),
	(576977, 127, '2014-03-15 00:29:21.000000', 'consum', 0.0224, 'lps'),
	(576978, 127, '2014-03-15 00:29:22.000000', 'consum', 0.0221, 'lps'),
	(576979, 127, '2014-03-15 00:29:23.000000', 'consum', 0.0222, 'lps'),
	(576980, 127, '2014-03-15 00:29:24.000000', 'consum', 0.0218, 'lps'),
	(576981, 127, '2014-03-15 00:29:25.000000', 'consum', 0.0217, 'lps'),
	(576982, 127, '2014-03-15 00:29:26.000000', 'consum', 0.0222, 'lps'),
	(576983, 127, '2014-03-15 00:29:27.000000', 'consum', 0.0211, 'lps'),
	(576984, 127, '2014-03-15 00:29:28.000000', 'consum', 0.0216, 'lps'),
	(576985, 127, '2014-03-15 00:29:29.000000', 'consum', 0.0220, 'lps'),
	(576986, 127, '2014-03-15 00:29:30.000000', 'consum', 0.0224, 'lps'),
	(576987, 127, '2014-03-15 00:29:31.000000', 'consum', 0.0213, 'lps'),
	(576988, 127, '2014-03-15 00:29:32.000000', 'consum', 0.0223, 'lps'),
	(576989, 127, '2014-03-15 00:29:33.000000', 'consum', 0.0211, 'lps'),
	(576990, 127, '2014-03-15 00:29:34.000000', 'consum', 0.0211, 'lps'),
	(576991, 127, '2014-03-15 00:29:35.000000', 'consum', 0.0212, 'lps'),
	(576992, 127, '2014-03-15 00:29:36.000000', 'consum', 0.0219, 'lps'),
	(576993, 127, '2014-03-15 00:29:37.000000', 'consum', 0.0212, 'lps'),
	(576994, 127, '2014-03-15 00:29:38.000000', 'consum', 0.0214, 'lps'),
	(576995, 127, '2014-03-15 00:29:39.000000', 'consum', 0.0221, 'lps'),
	(576996, 127, '2014-03-15 00:29:40.000000', 'consum', 0.0221, 'lps'),
	(576997, 127, '2014-03-15 00:29:41.000000', 'consum', 0.0212, 'lps'),
	(576998, 127, '2014-03-15 00:29:42.000000', 'consum', 0.0226, 'lps'),
	(576999, 127, '2014-03-15 00:29:43.000000', 'consum', 0.0211, 'lps'),
	(577000, 127, '2014-03-15 00:29:44.000000', 'consum', 0.0221, 'lps'),
	(577001, 127, '2014-03-15 00:29:45.000000', 'consum', 0.0211, 'lps'),
	(577002, 127, '2014-03-15 00:29:46.000000', 'consum', 0.0216, 'lps'),
	(577003, 127, '2014-03-15 00:29:47.000000', 'consum', 0.0222, 'lps'),
	(577004, 127, '2014-03-15 00:29:48.000000', 'consum', 0.0214, 'lps'),
	(577005, 127, '2014-03-15 00:29:49.000000', 'consum', 0.0211, 'lps'),
	(577006, 127, '2014-03-15 00:29:50.000000', 'consum', 0.0225, 'lps'),
	(577007, 127, '2014-03-15 00:29:51.000000', 'consum', 0.0210, 'lps'),
	(577008, 127, '2014-03-15 00:29:52.000000', 'consum', 0.0220, 'lps'),
	(577009, 127, '2014-03-15 00:29:53.000000', 'consum', 0.0224, 'lps'),
	(577010, 127, '2014-03-15 00:29:54.000000', 'consum', 0.0215, 'lps'),
	(577011, 127, '2014-03-15 00:29:55.000000', 'consum', 0.0211, 'lps'),
	(577012, 127, '2014-03-15 00:29:56.000000', 'consum', 0.0220, 'lps'),
	(577013, 127, '2014-03-15 00:29:57.000000', 'consum', 0.0220, 'lps'),
	(577014, 127, '2014-03-15 00:29:58.000000', 'consum', 0.0211, 'lps'),
	(577015, 127, '2014-03-15 00:29:59.000000', 'consum', 0.0223, 'lps'),
	(577016, 127, '2014-03-15 00:30:00.000000', 'consum', 0.0218, 'lps'),
	(577017, 127, '2014-03-15 00:30:01.000000', 'consum', 0.0211, 'lps'),
	(577018, 127, '2014-03-15 00:30:02.000000', 'consum', 0.0210, 'lps'),
	(577019, 127, '2014-03-15 00:30:03.000000', 'consum', 0.0224, 'lps'),
	(577020, 127, '2014-03-15 00:30:04.000000', 'consum', 0.0211, 'lps'),
	(577021, 127, '2014-03-15 00:30:05.000000', 'consum', 0.0210, 'lps'),
	(577022, 127, '2014-03-15 00:30:06.000000', 'consum', 0.0225, 'lps'),
	(577023, 127, '2014-03-15 00:30:07.000000', 'consum', 0.0211, 'lps'),
	(577024, 127, '2014-03-15 00:30:08.000000', 'consum', 0.0210, 'lps'),
	(577025, 127, '2014-03-15 00:30:09.000000', 'consum', 0.0224, 'lps'),
	(577026, 127, '2014-03-15 00:30:10.000000', 'consum', 0.0227, 'lps'),
	(577027, 127, '2014-03-15 00:30:11.000000', 'consum', 0.0218, 'lps'),
	(577028, 127, '2014-03-15 00:30:12.000000', 'consum', 0.0219, 'lps'),
	(577029, 127, '2014-03-15 00:30:13.000000', 'consum', 0.0211, 'lps'),
	(577030, 127, '2014-03-15 00:30:14.000000', 'consum', 0.0223, 'lps'),
	(577031, 127, '2014-03-15 00:30:15.000000', 'consum', 0.0221, 'lps'),
	(577032, 127, '2014-03-15 00:30:16.000000', 'consum', 0.0225, 'lps'),
	(577033, 127, '2014-03-15 00:30:17.000000', 'consum', 0.0215, 'lps'),
	(577034, 127, '2014-03-15 00:30:18.000000', 'consum', 0.0210, 'lps'),
	(577035, 127, '2014-03-15 00:30:19.000000', 'consum', 0.0215, 'lps'),
	(577036, 127, '2014-03-15 00:30:20.000000', 'consum', 0.0218, 'lps'),
	(577037, 127, '2014-03-15 00:30:21.000000', 'consum', 0.0215, 'lps'),
	(577038, 127, '2014-03-15 00:30:22.000000', 'consum', 0.0212, 'lps'),
	(577039, 127, '2014-03-15 00:30:23.000000', 'consum', 0.0223, 'lps'),
	(577040, 127, '2014-03-15 00:30:24.000000', 'consum', 0.0216, 'lps'),
	(577041, 127, '2014-03-15 00:30:25.000000', 'consum', 0.0220, 'lps'),
	(577042, 127, '2014-03-15 00:30:26.000000', 'consum', 0.0225, 'lps'),
	(577043, 127, '2014-03-15 00:30:27.000000', 'consum', 0.0221, 'lps'),
	(577044, 127, '2014-03-15 00:30:28.000000', 'consum', 0.0218, 'lps'),
	(577045, 127, '2014-03-15 00:30:29.000000', 'consum', 0.0220, 'lps'),
	(577046, 127, '2014-03-15 00:30:30.000000', 'consum', 0.0217, 'lps'),
	(577047, 127, '2014-03-15 00:30:31.000000', 'consum', 0.0216, 'lps'),
	(577048, 127, '2014-03-15 00:30:32.000000', 'consum', 0.0221, 'lps'),
	(577049, 127, '2014-03-15 00:30:33.000000', 'consum', 0.0212, 'lps'),
	(577050, 127, '2014-03-15 00:30:34.000000', 'consum', 0.0222, 'lps'),
	(577051, 127, '2014-03-15 00:30:35.000000', 'consum', 0.0210, 'lps'),
	(577052, 127, '2014-03-15 00:30:36.000000', 'consum', 0.0213, 'lps'),
	(577053, 127, '2014-03-15 00:30:37.000000', 'consum', 0.0224, 'lps'),
	(577054, 127, '2014-03-15 00:30:38.000000', 'consum', 0.0217, 'lps'),
	(577055, 127, '2014-03-15 00:30:39.000000', 'consum', 0.0220, 'lps'),
	(577056, 127, '2014-03-15 00:30:40.000000', 'consum', 0.0224, 'lps'),
	(577057, 127, '2014-03-15 00:30:41.000000', 'consum', 0.0212, 'lps'),
	(577058, 127, '2014-03-15 00:30:42.000000', 'consum', 0.0216, 'lps'),
	(577059, 127, '2014-03-15 00:30:43.000000', 'consum', 0.0217, 'lps'),
	(577060, 127, '2014-03-15 00:30:44.000000', 'consum', 0.0226, 'lps'),
	(577061, 127, '2014-03-15 00:30:45.000000', 'consum', 0.0215, 'lps'),
	(577062, 127, '2014-03-15 00:30:46.000000', 'consum', 0.0223, 'lps'),
	(577063, 127, '2014-03-15 00:30:47.000000', 'consum', 0.0227, 'lps'),
	(577064, 127, '2014-03-15 00:30:48.000000', 'consum', 0.0219, 'lps'),
	(577065, 127, '2014-03-15 00:30:49.000000', 'consum', 0.0222, 'lps'),
	(577066, 127, '2014-03-15 00:30:50.000000', 'consum', 0.0210, 'lps'),
	(577067, 127, '2014-03-15 00:30:51.000000', 'consum', 0.0226, 'lps'),
	(577068, 127, '2014-03-15 00:30:52.000000', 'consum', 0.0218, 'lps'),
	(577069, 127, '2014-03-15 00:30:53.000000', 'consum', 0.0220, 'lps'),
	(577070, 127, '2014-03-15 00:30:54.000000', 'consum', 0.0221, 'lps'),
	(577071, 127, '2014-03-15 00:30:55.000000', 'consum', 0.0216, 'lps'),
	(577072, 127, '2014-03-15 00:30:56.000000', 'consum', 0.0227, 'lps'),
	(577073, 127, '2014-03-15 00:30:57.000000', 'consum', 0.0222, 'lps'),
	(577074, 127, '2014-03-15 00:30:58.000000', 'consum', 0.0220, 'lps'),
	(577075, 127, '2014-03-15 00:30:59.000000', 'consum', 0.0226, 'lps'),
	(577076, 127, '2014-03-15 00:31:00.000000', 'consum', 0.0225, 'lps'),
	(577077, 127, '2014-03-15 00:31:01.000000', 'consum', 0.0217, 'lps'),
	(577078, 127, '2014-03-15 00:31:02.000000', 'consum', 0.0220, 'lps'),
	(577079, 127, '2014-03-15 00:31:03.000000', 'consum', 0.0223, 'lps'),
	(577080, 127, '2014-03-15 00:31:04.000000', 'consum', 0.0225, 'lps'),
	(577081, 127, '2014-03-15 00:31:05.000000', 'consum', 0.0211, 'lps'),
	(577082, 127, '2014-03-15 00:31:06.000000', 'consum', 0.0226, 'lps'),
	(577083, 127, '2014-03-15 00:31:07.000000', 'consum', 0.0214, 'lps'),
	(577084, 127, '2014-03-15 00:31:08.000000', 'consum', 0.0218, 'lps'),
	(577085, 127, '2014-03-15 00:31:09.000000', 'consum', 0.0222, 'lps'),
	(577086, 127, '2014-03-15 00:31:10.000000', 'consum', 0.0211, 'lps'),
	(577087, 127, '2014-03-15 00:31:11.000000', 'consum', 0.0214, 'lps'),
	(577088, 127, '2014-03-15 00:31:12.000000', 'consum', 0.0227, 'lps'),
	(577089, 127, '2014-03-15 00:31:13.000000', 'consum', 0.0211, 'lps'),
	(577090, 127, '2014-03-15 00:31:14.000000', 'consum', 0.0218, 'lps'),
	(577091, 127, '2014-03-15 00:31:15.000000', 'consum', 0.0212, 'lps'),
	(577092, 127, '2014-03-15 00:31:16.000000', 'consum', 0.0216, 'lps'),
	(577093, 127, '2014-03-15 00:31:17.000000', 'consum', 0.0214, 'lps'),
	(577094, 127, '2014-03-15 00:31:18.000000', 'consum', 0.0212, 'lps'),
	(577095, 127, '2014-03-15 00:31:19.000000', 'consum', 0.0211, 'lps'),
	(577096, 127, '2014-03-15 00:31:20.000000', 'consum', 0.0227, 'lps'),
	(577097, 127, '2014-03-15 00:31:21.000000', 'consum', 0.0219, 'lps'),
	(577098, 127, '2014-03-15 00:31:22.000000', 'consum', 0.0224, 'lps'),
	(577099, 127, '2014-03-15 00:31:23.000000', 'consum', 0.0218, 'lps'),
	(577100, 127, '2014-03-15 00:31:24.000000', 'consum', 0.0227, 'lps'),
	(577101, 127, '2014-03-15 00:31:25.000000', 'consum', 0.0215, 'lps'),
	(577102, 127, '2014-03-15 00:31:26.000000', 'consum', 0.0221, 'lps'),
	(577103, 127, '2014-03-15 00:31:27.000000', 'consum', 0.0217, 'lps'),
	(577104, 127, '2014-03-15 00:31:28.000000', 'consum', 0.0210, 'lps'),
	(577105, 127, '2014-03-15 00:31:29.000000', 'consum', 0.0210, 'lps'),
	(577106, 127, '2014-03-15 00:31:30.000000', 'consum', 0.0227, 'lps'),
	(577107, 127, '2014-03-15 00:31:31.000000', 'consum', 0.0226, 'lps'),
	(577108, 127, '2014-03-15 00:31:32.000000', 'consum', 0.0219, 'lps'),
	(577109, 127, '2014-03-15 00:31:33.000000', 'consum', 0.0227, 'lps'),
	(577110, 127, '2014-03-15 00:31:34.000000', 'consum', 0.0212, 'lps'),
	(577111, 127, '2014-03-15 00:31:35.000000', 'consum', 0.0225, 'lps'),
	(577112, 127, '2014-03-15 00:31:36.000000', 'consum', 0.0224, 'lps'),
	(577113, 127, '2014-03-15 00:31:37.000000', 'consum', 0.0220, 'lps'),
	(577114, 127, '2014-03-15 00:31:38.000000', 'consum', 0.0215, 'lps'),
	(577115, 127, '2014-03-15 00:31:39.000000', 'consum', 0.0227, 'lps'),
	(577116, 127, '2014-03-15 00:31:40.000000', 'consum', 0.0224, 'lps'),
	(577117, 127, '2014-03-15 00:31:41.000000', 'consum', 0.0211, 'lps'),
	(577118, 127, '2014-03-15 00:31:42.000000', 'consum', 0.0213, 'lps'),
	(577119, 127, '2014-03-15 00:31:43.000000', 'consum', 0.0219, 'lps'),
	(577120, 127, '2014-03-15 00:31:44.000000', 'consum', 0.0212, 'lps'),
	(577121, 127, '2014-03-15 00:31:45.000000', 'consum', 0.0210, 'lps'),
	(577122, 127, '2014-03-15 00:31:46.000000', 'consum', 0.0223, 'lps'),
	(577123, 127, '2014-03-15 00:31:47.000000', 'consum', 0.0220, 'lps'),
	(577124, 127, '2014-03-15 00:31:48.000000', 'consum', 0.0224, 'lps'),
	(577125, 127, '2014-03-15 00:31:49.000000', 'consum', 0.0214, 'lps'),
	(577126, 127, '2014-03-15 00:31:50.000000', 'consum', 0.0224, 'lps'),
	(577127, 127, '2014-03-15 00:31:51.000000', 'consum', 0.0217, 'lps'),
	(577128, 127, '2014-03-15 00:31:52.000000', 'consum', 0.0219, 'lps'),
	(577129, 127, '2014-03-15 00:31:53.000000', 'consum', 0.0217, 'lps'),
	(577130, 127, '2014-03-15 00:31:54.000000', 'consum', 0.0218, 'lps'),
	(577131, 127, '2014-03-15 00:31:55.000000', 'consum', 0.0210, 'lps'),
	(577132, 127, '2014-03-15 00:31:56.000000', 'consum', 0.0225, 'lps'),
	(577133, 127, '2014-03-15 00:31:57.000000', 'consum', 0.0213, 'lps'),
	(577134, 127, '2014-03-15 00:31:58.000000', 'consum', 0.0216, 'lps'),
	(577135, 127, '2014-03-15 00:31:59.000000', 'consum', 0.0213, 'lps'),
	(577136, 127, '2014-03-15 00:32:00.000000', 'consum', 0.0226, 'lps'),
	(577137, 127, '2014-03-15 00:32:01.000000', 'consum', 0.0227, 'lps'),
	(577138, 127, '2014-03-15 00:32:02.000000', 'consum', 0.0214, 'lps'),
	(577139, 127, '2014-03-15 00:32:03.000000', 'consum', 0.0212, 'lps'),
	(577140, 127, '2014-03-15 00:32:04.000000', 'consum', 0.0210, 'lps'),
	(577141, 127, '2014-03-15 00:32:05.000000', 'consum', 0.0224, 'lps'),
	(577142, 127, '2014-03-15 00:32:06.000000', 'consum', 0.0226, 'lps'),
	(577143, 127, '2014-03-15 00:32:07.000000', 'consum', 0.0211, 'lps'),
	(577144, 127, '2014-03-15 00:32:08.000000', 'consum', 0.0220, 'lps'),
	(577145, 127, '2014-03-15 00:32:09.000000', 'consum', 0.0224, 'lps'),
	(577146, 127, '2014-03-15 00:32:10.000000', 'consum', 0.0213, 'lps'),
	(577147, 127, '2014-03-15 00:32:11.000000', 'consum', 0.0222, 'lps'),
	(577148, 127, '2014-03-15 00:32:12.000000', 'consum', 0.0224, 'lps'),
	(577149, 127, '2014-03-15 00:32:13.000000', 'consum', 0.0225, 'lps'),
	(577150, 127, '2014-03-15 00:32:14.000000', 'consum', 0.0225, 'lps'),
	(577151, 127, '2014-03-15 00:32:15.000000', 'consum', 0.0225, 'lps'),
	(577152, 127, '2014-03-15 00:32:16.000000', 'consum', 0.0222, 'lps'),
	(577153, 127, '2014-03-15 00:32:17.000000', 'consum', 0.0223, 'lps'),
	(577154, 127, '2014-03-15 00:32:18.000000', 'consum', 0.0224, 'lps'),
	(577155, 127, '2014-03-15 00:32:19.000000', 'consum', 0.0221, 'lps'),
	(577156, 127, '2014-03-15 00:32:20.000000', 'consum', 0.0226, 'lps'),
	(577157, 127, '2014-03-15 00:32:21.000000', 'consum', 0.0220, 'lps'),
	(577158, 127, '2014-03-15 00:32:22.000000', 'consum', 0.0214, 'lps'),
	(577159, 127, '2014-03-15 00:32:23.000000', 'consum', 0.0219, 'lps'),
	(577160, 127, '2014-03-15 00:32:24.000000', 'consum', 0.0226, 'lps'),
	(577161, 127, '2014-03-15 00:32:25.000000', 'consum', 0.0211, 'lps'),
	(577162, 127, '2014-03-15 00:32:26.000000', 'consum', 0.0218, 'lps'),
	(577163, 127, '2014-03-15 00:32:27.000000', 'consum', 0.0214, 'lps'),
	(577164, 127, '2014-03-15 00:32:28.000000', 'consum', 0.0223, 'lps'),
	(577165, 127, '2014-03-15 00:32:29.000000', 'consum', 0.0210, 'lps'),
	(577166, 127, '2014-03-15 00:32:30.000000', 'consum', 0.0225, 'lps'),
	(577167, 127, '2014-03-15 00:32:31.000000', 'consum', 0.0214, 'lps'),
	(577168, 127, '2014-03-15 00:32:32.000000', 'consum', 0.0221, 'lps'),
	(577169, 127, '2014-03-15 00:32:33.000000', 'consum', 0.0218, 'lps'),
	(577170, 127, '2014-03-15 00:32:34.000000', 'consum', 0.0219, 'lps'),
	(577171, 127, '2014-03-15 00:32:35.000000', 'consum', 0.0211, 'lps'),
	(577172, 127, '2014-03-15 00:32:36.000000', 'consum', 0.0223, 'lps'),
	(577173, 127, '2014-03-15 00:32:37.000000', 'consum', 0.0222, 'lps'),
	(577174, 127, '2014-03-15 00:32:38.000000', 'consum', 0.0213, 'lps'),
	(577175, 127, '2014-03-15 00:32:39.000000', 'consum', 0.0226, 'lps'),
	(577176, 127, '2014-03-15 00:32:40.000000', 'consum', 0.0226, 'lps'),
	(577177, 127, '2014-03-15 00:32:41.000000', 'consum', 0.0226, 'lps'),
	(577178, 127, '2014-03-15 00:32:42.000000', 'consum', 0.0223, 'lps'),
	(577179, 127, '2014-03-15 00:32:43.000000', 'consum', 0.0210, 'lps'),
	(577180, 127, '2014-03-15 00:32:44.000000', 'consum', 0.0227, 'lps'),
	(577181, 127, '2014-03-15 00:32:45.000000', 'consum', 0.0222, 'lps'),
	(577182, 127, '2014-03-15 00:32:46.000000', 'consum', 0.0218, 'lps'),
	(577183, 127, '2014-03-15 00:32:47.000000', 'consum', 0.0218, 'lps'),
	(577184, 127, '2014-03-15 00:32:48.000000', 'consum', 0.0224, 'lps'),
	(577185, 127, '2014-03-15 00:32:49.000000', 'consum', 0.0221, 'lps'),
	(577186, 127, '2014-03-15 00:32:50.000000', 'consum', 0.0223, 'lps'),
	(577187, 127, '2014-03-15 00:32:51.000000', 'consum', 0.0223, 'lps'),
	(577188, 127, '2014-03-15 00:32:52.000000', 'consum', 0.0220, 'lps'),
	(577189, 127, '2014-03-15 00:32:53.000000', 'consum', 0.0220, 'lps'),
	(577190, 127, '2014-03-15 00:32:54.000000', 'consum', 0.0214, 'lps'),
	(577191, 127, '2014-03-15 00:32:55.000000', 'consum', 0.0217, 'lps'),
	(577192, 127, '2014-03-15 00:32:56.000000', 'consum', 0.0216, 'lps'),
	(577193, 127, '2014-03-15 00:32:57.000000', 'consum', 0.0221, 'lps'),
	(577194, 127, '2014-03-15 00:32:58.000000', 'consum', 0.0211, 'lps'),
	(577195, 127, '2014-03-15 00:32:59.000000', 'consum', 0.0217, 'lps'),
	(577196, 127, '2014-03-15 00:33:00.000000', 'consum', 0.0224, 'lps'),
	(577197, 127, '2014-03-15 00:33:01.000000', 'consum', 0.0223, 'lps'),
	(577198, 127, '2014-03-15 00:33:02.000000', 'consum', 0.0218, 'lps'),
	(577199, 127, '2014-03-15 00:33:03.000000', 'consum', 0.0212, 'lps'),
	(577200, 127, '2014-03-15 00:33:04.000000', 'consum', 0.0212, 'lps'),
	(577201, 127, '2014-03-15 00:33:05.000000', 'consum', 0.0214, 'lps'),
	(577202, 127, '2014-03-15 00:33:06.000000', 'consum', 0.0225, 'lps'),
	(577203, 127, '2014-03-15 00:33:07.000000', 'consum', 0.0221, 'lps'),
	(577204, 127, '2014-03-15 00:33:08.000000', 'consum', 0.0220, 'lps'),
	(577205, 127, '2014-03-15 00:33:09.000000', 'consum', 0.0210, 'lps'),
	(577206, 127, '2014-03-15 00:33:10.000000', 'consum', 0.0217, 'lps'),
	(577207, 127, '2014-03-15 00:33:11.000000', 'consum', 0.0211, 'lps'),
	(577208, 127, '2014-03-15 00:33:12.000000', 'consum', 0.0227, 'lps'),
	(577209, 127, '2014-03-15 00:33:13.000000', 'consum', 0.0223, 'lps'),
	(577210, 127, '2014-03-15 00:33:14.000000', 'consum', 0.0225, 'lps'),
	(577211, 127, '2014-03-15 00:33:15.000000', 'consum', 0.0226, 'lps'),
	(577212, 127, '2014-03-15 00:33:16.000000', 'consum', 0.0211, 'lps'),
	(577213, 127, '2014-03-15 00:33:17.000000', 'consum', 0.0219, 'lps'),
	(577214, 127, '2014-03-15 00:33:18.000000', 'consum', 0.0220, 'lps'),
	(577215, 127, '2014-03-15 00:33:19.000000', 'consum', 0.0212, 'lps'),
	(577216, 127, '2014-03-15 00:33:20.000000', 'consum', 0.0211, 'lps'),
	(577217, 127, '2014-03-15 00:33:21.000000', 'consum', 0.0210, 'lps'),
	(577218, 127, '2014-03-15 00:33:22.000000', 'consum', 0.0225, 'lps'),
	(577219, 127, '2014-03-15 00:33:23.000000', 'consum', 0.0212, 'lps'),
	(577220, 127, '2014-03-15 00:33:24.000000', 'consum', 0.0214, 'lps'),
	(577221, 127, '2014-03-15 00:33:25.000000', 'consum', 0.0225, 'lps'),
	(577222, 127, '2014-03-15 00:33:26.000000', 'consum', 0.0216, 'lps'),
	(577223, 127, '2014-03-15 00:33:27.000000', 'consum', 0.0217, 'lps'),
	(577224, 127, '2014-03-15 00:33:28.000000', 'consum', 0.0227, 'lps'),
	(577225, 127, '2014-03-15 00:33:29.000000', 'consum', 0.0220, 'lps'),
	(577226, 127, '2014-03-15 00:33:30.000000', 'consum', 0.0226, 'lps'),
	(577227, 127, '2014-03-15 00:33:31.000000', 'consum', 0.0226, 'lps'),
	(577228, 127, '2014-03-15 00:33:32.000000', 'consum', 0.0224, 'lps'),
	(577229, 127, '2014-03-15 00:33:33.000000', 'consum', 0.0215, 'lps'),
	(577230, 127, '2014-03-15 00:33:34.000000', 'consum', 0.0210, 'lps'),
	(577231, 127, '2014-03-15 00:33:35.000000', 'consum', 0.0215, 'lps'),
	(577232, 127, '2014-03-15 00:33:36.000000', 'consum', 0.0218, 'lps'),
	(577233, 127, '2014-03-15 00:33:37.000000', 'consum', 0.0217, 'lps'),
	(577234, 127, '2014-03-15 00:33:38.000000', 'consum', 0.0222, 'lps'),
	(577235, 127, '2014-03-15 00:33:39.000000', 'consum', 0.0214, 'lps'),
	(577236, 127, '2014-03-15 00:33:40.000000', 'consum', 0.0213, 'lps'),
	(577237, 127, '2014-03-15 00:33:41.000000', 'consum', 0.0212, 'lps'),
	(577238, 127, '2014-03-15 00:33:42.000000', 'consum', 0.0212, 'lps'),
	(577239, 127, '2014-03-15 00:33:43.000000', 'consum', 0.0216, 'lps'),
	(577240, 127, '2014-03-15 00:33:44.000000', 'consum', 0.0217, 'lps'),
	(577241, 127, '2014-03-15 00:33:45.000000', 'consum', 0.0227, 'lps'),
	(577242, 127, '2014-03-15 00:33:46.000000', 'consum', 0.0222, 'lps'),
	(577243, 127, '2014-03-15 00:33:47.000000', 'consum', 0.0219, 'lps'),
	(577244, 127, '2014-03-15 00:33:48.000000', 'consum', 0.0220, 'lps'),
	(577245, 127, '2014-03-15 00:33:49.000000', 'consum', 0.0213, 'lps'),
	(577246, 127, '2014-03-15 00:33:50.000000', 'consum', 0.0216, 'lps'),
	(577247, 127, '2014-03-15 00:33:51.000000', 'consum', 0.0213, 'lps'),
	(577248, 127, '2014-03-15 00:33:52.000000', 'consum', 0.0227, 'lps'),
	(577249, 127, '2014-03-15 00:33:53.000000', 'consum', 0.0211, 'lps'),
	(577250, 127, '2014-03-15 00:33:54.000000', 'consum', 0.0221, 'lps'),
	(577251, 127, '2014-03-15 00:33:55.000000', 'consum', 0.0225, 'lps'),
	(577252, 127, '2014-03-15 00:33:56.000000', 'consum', 0.0215, 'lps'),
	(577253, 127, '2014-03-15 00:33:57.000000', 'consum', 0.0210, 'lps'),
	(577254, 127, '2014-03-15 00:33:58.000000', 'consum', 0.0212, 'lps'),
	(577255, 127, '2014-03-15 00:33:59.000000', 'consum', 0.0224, 'lps'),
	(577256, 127, '2014-03-15 00:34:00.000000', 'consum', 0.0217, 'lps'),
	(577257, 127, '2014-03-15 00:34:01.000000', 'consum', 0.0224, 'lps'),
	(577258, 127, '2014-03-15 00:34:02.000000', 'consum', 0.0223, 'lps'),
	(577259, 127, '2014-03-15 00:34:03.000000', 'consum', 0.0216, 'lps'),
	(577260, 127, '2014-03-15 00:34:04.000000', 'consum', 0.0221, 'lps'),
	(577261, 127, '2014-03-15 00:34:05.000000', 'consum', 0.0227, 'lps'),
	(577262, 127, '2014-03-15 00:34:06.000000', 'consum', 0.0210, 'lps'),
	(577263, 127, '2014-03-15 00:34:07.000000', 'consum', 0.0213, 'lps'),
	(577264, 127, '2014-03-15 00:34:08.000000', 'consum', 0.0224, 'lps'),
	(577265, 127, '2014-03-15 00:34:09.000000', 'consum', 0.0217, 'lps'),
	(577266, 127, '2014-03-15 00:34:10.000000', 'consum', 0.0221, 'lps'),
	(577267, 127, '2014-03-15 00:34:11.000000', 'consum', 0.0211, 'lps'),
	(577268, 127, '2014-03-15 00:34:12.000000', 'consum', 0.0219, 'lps'),
	(577269, 127, '2014-03-15 00:34:13.000000', 'consum', 0.0214, 'lps'),
	(577270, 127, '2014-03-15 00:34:14.000000', 'consum', 0.0221, 'lps'),
	(577271, 127, '2014-03-15 00:34:15.000000', 'consum', 0.0218, 'lps'),
	(577272, 127, '2014-03-15 00:34:16.000000', 'consum', 0.0218, 'lps'),
	(577273, 127, '2014-03-15 00:34:17.000000', 'consum', 0.0226, 'lps'),
	(577274, 127, '2014-03-15 00:34:18.000000', 'consum', 0.0212, 'lps'),
	(577275, 127, '2014-03-15 00:34:19.000000', 'consum', 0.0227, 'lps'),
	(577276, 127, '2014-03-15 00:34:20.000000', 'consum', 0.0218, 'lps'),
	(577277, 127, '2014-03-15 00:34:21.000000', 'consum', 0.0217, 'lps'),
	(577278, 127, '2014-03-15 00:34:22.000000', 'consum', 0.0220, 'lps'),
	(577279, 127, '2014-03-15 00:34:23.000000', 'consum', 0.0225, 'lps'),
	(577280, 127, '2014-03-15 00:34:24.000000', 'consum', 0.0216, 'lps'),
	(577281, 127, '2014-03-15 00:34:25.000000', 'consum', 0.0214, 'lps'),
	(577282, 127, '2014-03-15 00:34:26.000000', 'consum', 0.0212, 'lps'),
	(577283, 127, '2014-03-15 00:34:27.000000', 'consum', 0.0210, 'lps'),
	(577284, 127, '2014-03-15 00:34:28.000000', 'consum', 0.0224, 'lps'),
	(577285, 127, '2014-03-15 00:34:29.000000', 'consum', 0.0225, 'lps'),
	(577286, 127, '2014-03-15 00:34:30.000000', 'consum', 0.0227, 'lps'),
	(577287, 127, '2014-03-15 00:34:31.000000', 'consum', 0.0213, 'lps'),
	(577288, 127, '2014-03-15 00:34:32.000000', 'consum', 0.0227, 'lps'),
	(577289, 127, '2014-03-15 00:34:33.000000', 'consum', 0.0215, 'lps'),
	(577290, 127, '2014-03-15 00:34:34.000000', 'consum', 0.0221, 'lps'),
	(577291, 127, '2014-03-15 00:34:35.000000', 'consum', 0.0212, 'lps'),
	(577292, 127, '2014-03-15 00:34:36.000000', 'consum', 0.0227, 'lps'),
	(577293, 127, '2014-03-15 00:34:37.000000', 'consum', 0.0216, 'lps'),
	(577294, 127, '2014-03-15 00:34:38.000000', 'consum', 0.0227, 'lps'),
	(577295, 127, '2014-03-15 00:34:39.000000', 'consum', 0.0223, 'lps'),
	(577296, 127, '2014-03-15 00:34:40.000000', 'consum', 0.0226, 'lps'),
	(577297, 127, '2014-03-15 00:34:41.000000', 'consum', 0.0215, 'lps'),
	(577298, 127, '2014-03-15 00:34:42.000000', 'consum', 0.0221, 'lps'),
	(577299, 127, '2014-03-15 00:34:43.000000', 'consum', 0.0215, 'lps'),
	(577300, 127, '2014-03-15 00:34:44.000000', 'consum', 0.0223, 'lps'),
	(577301, 127, '2014-03-15 00:34:45.000000', 'consum', 0.0224, 'lps'),
	(577302, 127, '2014-03-15 00:34:46.000000', 'consum', 0.0222, 'lps'),
	(577303, 127, '2014-03-15 00:34:47.000000', 'consum', 0.0213, 'lps'),
	(577304, 127, '2014-03-15 00:34:48.000000', 'consum', 0.0224, 'lps'),
	(577305, 127, '2014-03-15 00:34:49.000000', 'consum', 0.0216, 'lps'),
	(577306, 127, '2014-03-15 00:34:50.000000', 'consum', 0.0218, 'lps'),
	(577307, 127, '2014-03-15 00:34:51.000000', 'consum', 0.0216, 'lps'),
	(577308, 127, '2014-03-15 00:34:52.000000', 'consum', 0.0214, 'lps'),
	(577309, 127, '2014-03-15 00:34:53.000000', 'consum', 0.0215, 'lps'),
	(577310, 127, '2014-03-15 00:34:54.000000', 'consum', 0.0220, 'lps'),
	(577311, 127, '2014-03-15 00:34:55.000000', 'consum', 0.0213, 'lps'),
	(577312, 127, '2014-03-15 00:34:56.000000', 'consum', 0.0213, 'lps'),
	(577313, 127, '2014-03-15 00:34:57.000000', 'consum', 0.0216, 'lps'),
	(577314, 127, '2014-03-15 00:34:58.000000', 'consum', 0.0214, 'lps'),
	(577315, 127, '2014-03-15 00:34:59.000000', 'consum', 0.0214, 'lps'),
	(577316, 127, '2014-03-15 00:35:00.000000', 'consum', 0.0216, 'lps'),
	(577317, 127, '2014-03-15 00:35:01.000000', 'consum', 0.0211, 'lps'),
	(577318, 127, '2014-03-15 00:35:02.000000', 'consum', 0.0216, 'lps'),
	(577319, 127, '2014-03-15 00:35:03.000000', 'consum', 0.0219, 'lps'),
	(577320, 127, '2014-03-15 00:35:04.000000', 'consum', 0.0219, 'lps'),
	(577321, 127, '2014-03-15 00:35:05.000000', 'consum', 0.0210, 'lps'),
	(577322, 127, '2014-03-15 00:35:06.000000', 'consum', 0.0219, 'lps'),
	(577323, 127, '2014-03-15 00:35:07.000000', 'consum', 0.0222, 'lps'),
	(577324, 127, '2014-03-15 00:35:08.000000', 'consum', 0.0223, 'lps'),
	(577325, 127, '2014-03-15 00:35:09.000000', 'consum', 0.0224, 'lps'),
	(577326, 127, '2014-03-15 00:35:10.000000', 'consum', 0.0222, 'lps'),
	(577327, 127, '2014-03-15 00:35:11.000000', 'consum', 0.0227, 'lps'),
	(577328, 127, '2014-03-15 00:35:12.000000', 'consum', 0.0224, 'lps'),
	(577329, 127, '2014-03-15 00:35:13.000000', 'consum', 0.0212, 'lps'),
	(577330, 127, '2014-03-15 00:35:14.000000', 'consum', 0.0213, 'lps'),
	(577331, 127, '2014-03-15 00:35:15.000000', 'consum', 0.0219, 'lps'),
	(577332, 127, '2014-03-15 00:35:16.000000', 'consum', 0.0213, 'lps'),
	(577333, 127, '2014-03-15 00:35:17.000000', 'consum', 0.0214, 'lps'),
	(577334, 127, '2014-03-15 00:35:18.000000', 'consum', 0.0223, 'lps'),
	(577335, 127, '2014-03-15 00:35:19.000000', 'consum', 0.0226, 'lps'),
	(577336, 127, '2014-03-15 00:35:20.000000', 'consum', 0.0217, 'lps'),
	(577337, 127, '2014-03-15 00:35:21.000000', 'consum', 0.0214, 'lps'),
	(577338, 127, '2014-03-15 00:35:22.000000', 'consum', 0.0227, 'lps'),
	(577339, 127, '2014-03-15 00:35:23.000000', 'consum', 0.0214, 'lps'),
	(577340, 127, '2014-03-15 00:35:24.000000', 'consum', 0.0215, 'lps'),
	(577341, 127, '2014-03-15 00:35:25.000000', 'consum', 0.0223, 'lps'),
	(577342, 127, '2014-03-15 00:35:26.000000', 'consum', 0.0226, 'lps'),
	(577343, 127, '2014-03-15 00:35:27.000000', 'consum', 0.0214, 'lps'),
	(577344, 127, '2014-03-15 00:35:28.000000', 'consum', 0.0219, 'lps'),
	(577345, 127, '2014-03-15 00:35:29.000000', 'consum', 0.0224, 'lps'),
	(577346, 127, '2014-03-15 00:35:30.000000', 'consum', 0.0218, 'lps'),
	(577347, 127, '2014-03-15 00:35:31.000000', 'consum', 0.0210, 'lps'),
	(577348, 127, '2014-03-15 00:35:32.000000', 'consum', 0.0221, 'lps'),
	(577349, 127, '2014-03-15 00:35:33.000000', 'consum', 0.0213, 'lps'),
	(577350, 127, '2014-03-15 00:35:34.000000', 'consum', 0.0226, 'lps'),
	(577351, 127, '2014-03-15 00:35:35.000000', 'consum', 0.0211, 'lps'),
	(577352, 127, '2014-03-15 00:35:36.000000', 'consum', 0.0223, 'lps'),
	(577353, 127, '2014-03-15 00:35:37.000000', 'consum', 0.0216, 'lps'),
	(577354, 127, '2014-03-15 00:35:38.000000', 'consum', 0.0222, 'lps'),
	(577355, 127, '2014-03-15 00:35:39.000000', 'consum', 0.0215, 'lps'),
	(577356, 127, '2014-03-15 00:35:40.000000', 'consum', 0.0217, 'lps'),
	(577357, 127, '2014-03-15 00:35:41.000000', 'consum', 0.0215, 'lps'),
	(577358, 127, '2014-03-15 00:35:42.000000', 'consum', 0.0214, 'lps'),
	(577359, 127, '2014-03-15 00:35:43.000000', 'consum', 0.0214, 'lps'),
	(577360, 127, '2014-03-15 00:35:44.000000', 'consum', 0.0218, 'lps'),
	(577361, 127, '2014-03-15 00:35:45.000000', 'consum', 0.0223, 'lps'),
	(577362, 127, '2014-03-15 00:35:46.000000', 'consum', 0.0213, 'lps'),
	(577363, 127, '2014-03-15 00:35:47.000000', 'consum', 0.0224, 'lps'),
	(577364, 127, '2014-03-15 00:35:48.000000', 'consum', 0.0218, 'lps'),
	(577365, 127, '2014-03-15 00:35:49.000000', 'consum', 0.0225, 'lps'),
	(577366, 127, '2014-03-15 00:35:50.000000', 'consum', 0.0227, 'lps'),
	(577367, 127, '2014-03-15 00:35:51.000000', 'consum', 0.0213, 'lps'),
	(577368, 127, '2014-03-15 00:35:52.000000', 'consum', 0.0210, 'lps'),
	(577369, 127, '2014-03-15 00:35:53.000000', 'consum', 0.0221, 'lps'),
	(577370, 127, '2014-03-15 00:35:54.000000', 'consum', 0.0212, 'lps'),
	(577371, 127, '2014-03-15 00:35:55.000000', 'consum', 0.0221, 'lps'),
	(577372, 127, '2014-03-15 00:35:56.000000', 'consum', 0.0224, 'lps'),
	(577373, 127, '2014-03-15 00:35:57.000000', 'consum', 0.0212, 'lps'),
	(577374, 127, '2014-03-15 00:35:58.000000', 'consum', 0.0212, 'lps'),
	(577375, 127, '2014-03-15 00:35:59.000000', 'consum', 0.0218, 'lps'),
	(577376, 127, '2014-03-15 00:36:00.000000', 'consum', 0.0227, 'lps'),
	(577377, 127, '2014-03-15 00:36:01.000000', 'consum', 0.0215, 'lps'),
	(577378, 127, '2014-03-15 00:36:02.000000', 'consum', 0.0221, 'lps'),
	(577379, 127, '2014-03-15 00:36:03.000000', 'consum', 0.0214, 'lps'),
	(577380, 127, '2014-03-15 00:36:04.000000', 'consum', 0.0218, 'lps'),
	(577381, 127, '2014-03-15 00:36:05.000000', 'consum', 0.0218, 'lps'),
	(577382, 127, '2014-03-15 00:36:06.000000', 'consum', 0.0227, 'lps'),
	(577383, 127, '2014-03-15 00:36:07.000000', 'consum', 0.0219, 'lps'),
	(577384, 127, '2014-03-15 00:36:08.000000', 'consum', 0.0220, 'lps'),
	(577385, 127, '2014-03-15 00:36:09.000000', 'consum', 0.0216, 'lps'),
	(577386, 127, '2014-03-15 00:36:10.000000', 'consum', 0.0210, 'lps'),
	(577387, 127, '2014-03-15 00:36:11.000000', 'consum', 0.0210, 'lps'),
	(577388, 127, '2014-03-15 00:36:12.000000', 'consum', 0.0211, 'lps'),
	(577389, 127, '2014-03-15 00:36:13.000000', 'consum', 0.0218, 'lps'),
	(577390, 127, '2014-03-15 00:36:14.000000', 'consum', 0.0226, 'lps'),
	(577391, 127, '2014-03-15 00:36:15.000000', 'consum', 0.0214, 'lps'),
	(577392, 127, '2014-03-15 00:36:16.000000', 'consum', 0.0218, 'lps'),
	(577393, 127, '2014-03-15 00:36:17.000000', 'consum', 0.0220, 'lps'),
	(577394, 127, '2014-03-15 00:36:18.000000', 'consum', 0.0220, 'lps'),
	(577395, 127, '2014-03-15 00:36:19.000000', 'consum', 0.0211, 'lps'),
	(577396, 127, '2014-03-15 00:36:20.000000', 'consum', 0.0222, 'lps'),
	(577397, 127, '2014-03-15 00:36:21.000000', 'consum', 0.0214, 'lps'),
	(577398, 127, '2014-03-15 00:36:22.000000', 'consum', 0.0212, 'lps'),
	(577399, 127, '2014-03-15 00:36:23.000000', 'consum', 0.0226, 'lps'),
	(577400, 127, '2014-03-15 00:36:24.000000', 'consum', 0.0214, 'lps'),
	(577401, 127, '2014-03-15 00:36:25.000000', 'consum', 0.0217, 'lps'),
	(577402, 127, '2014-03-15 00:36:26.000000', 'consum', 0.0214, 'lps'),
	(577403, 127, '2014-03-15 00:36:27.000000', 'consum', 0.0213, 'lps'),
	(577404, 127, '2014-03-15 00:36:28.000000', 'consum', 0.0211, 'lps'),
	(577405, 127, '2014-03-15 00:36:29.000000', 'consum', 0.0225, 'lps'),
	(577406, 127, '2014-03-15 00:36:30.000000', 'consum', 0.0211, 'lps'),
	(577407, 127, '2014-03-15 00:36:31.000000', 'consum', 0.0225, 'lps'),
	(577408, 127, '2014-03-15 00:36:32.000000', 'consum', 0.0211, 'lps'),
	(577409, 127, '2014-03-15 00:36:33.000000', 'consum', 0.0222, 'lps'),
	(577410, 127, '2014-03-15 00:36:34.000000', 'consum', 0.0214, 'lps'),
	(577411, 127, '2014-03-15 00:36:35.000000', 'consum', 0.0215, 'lps'),
	(577412, 127, '2014-03-15 00:36:36.000000', 'consum', 0.0222, 'lps'),
	(577413, 127, '2014-03-15 00:36:37.000000', 'consum', 0.0221, 'lps'),
	(577414, 127, '2014-03-15 00:36:38.000000', 'consum', 0.0227, 'lps'),
	(577415, 127, '2014-03-15 00:36:39.000000', 'consum', 0.0226, 'lps'),
	(577416, 127, '2014-03-15 00:36:40.000000', 'consum', 0.0224, 'lps'),
	(577417, 127, '2014-03-15 00:36:41.000000', 'consum', 0.0215, 'lps'),
	(577418, 127, '2014-03-15 00:36:42.000000', 'consum', 0.0210, 'lps'),
	(577419, 127, '2014-03-15 00:36:43.000000', 'consum', 0.0213, 'lps'),
	(577420, 127, '2014-03-15 00:36:44.000000', 'consum', 0.0224, 'lps'),
	(577421, 127, '2014-03-15 00:36:45.000000', 'consum', 0.0220, 'lps'),
	(577422, 127, '2014-03-15 00:36:46.000000', 'consum', 0.0219, 'lps'),
	(577423, 127, '2014-03-15 00:36:47.000000', 'consum', 0.0226, 'lps'),
	(577424, 127, '2014-03-15 00:36:48.000000', 'consum', 0.0224, 'lps'),
	(577425, 127, '2014-03-15 00:36:49.000000', 'consum', 0.0218, 'lps'),
	(577426, 127, '2014-03-15 00:36:50.000000', 'consum', 0.0226, 'lps'),
	(577427, 127, '2014-03-15 00:36:51.000000', 'consum', 0.0214, 'lps'),
	(577428, 127, '2014-03-15 00:36:52.000000', 'consum', 0.0215, 'lps'),
	(577429, 127, '2014-03-15 00:36:53.000000', 'consum', 0.0226, 'lps'),
	(577430, 127, '2014-03-15 00:36:54.000000', 'consum', 0.0221, 'lps'),
	(577431, 127, '2014-03-15 00:36:55.000000', 'consum', 0.0219, 'lps'),
	(577432, 127, '2014-03-15 00:36:56.000000', 'consum', 0.0220, 'lps'),
	(577433, 127, '2014-03-15 00:36:57.000000', 'consum', 0.0216, 'lps'),
	(577434, 127, '2014-03-15 00:36:58.000000', 'consum', 0.0213, 'lps'),
	(577435, 127, '2014-03-15 00:36:59.000000', 'consum', 0.0223, 'lps'),
	(577436, 127, '2014-03-15 00:37:00.000000', 'consum', 0.0212, 'lps'),
	(577437, 127, '2014-03-15 00:37:01.000000', 'consum', 0.0217, 'lps'),
	(577438, 127, '2014-03-15 00:37:02.000000', 'consum', 0.0221, 'lps'),
	(577439, 127, '2014-03-15 00:37:03.000000', 'consum', 0.0210, 'lps'),
	(577440, 127, '2014-03-15 00:37:04.000000', 'consum', 0.0213, 'lps'),
	(577441, 127, '2014-03-15 00:37:05.000000', 'consum', 0.0226, 'lps'),
	(577442, 127, '2014-03-15 00:37:06.000000', 'consum', 0.0227, 'lps'),
	(577443, 127, '2014-03-15 00:37:07.000000', 'consum', 0.0212, 'lps'),
	(577444, 127, '2014-03-15 00:37:08.000000', 'consum', 0.0224, 'lps'),
	(577445, 127, '2014-03-15 00:37:09.000000', 'consum', 0.0220, 'lps'),
	(577446, 127, '2014-03-15 00:37:10.000000', 'consum', 0.0221, 'lps'),
	(577447, 127, '2014-03-15 00:37:11.000000', 'consum', 0.0214, 'lps'),
	(577448, 127, '2014-03-15 00:37:12.000000', 'consum', 0.0217, 'lps'),
	(577449, 127, '2014-03-15 00:37:13.000000', 'consum', 0.0217, 'lps'),
	(577450, 127, '2014-03-15 00:37:14.000000', 'consum', 0.0225, 'lps'),
	(577451, 127, '2014-03-15 00:37:15.000000', 'consum', 0.0227, 'lps'),
	(577452, 127, '2014-03-15 00:37:16.000000', 'consum', 0.0216, 'lps'),
	(577453, 127, '2014-03-15 00:37:17.000000', 'consum', 0.0223, 'lps'),
	(577454, 127, '2014-03-15 00:37:18.000000', 'consum', 0.0223, 'lps'),
	(577455, 127, '2014-03-15 00:37:19.000000', 'consum', 0.0217, 'lps'),
	(577456, 127, '2014-03-15 00:37:20.000000', 'consum', 0.0223, 'lps'),
	(577457, 127, '2014-03-15 00:37:21.000000', 'consum', 0.0221, 'lps'),
	(577458, 127, '2014-03-15 00:37:22.000000', 'consum', 0.0227, 'lps'),
	(577459, 127, '2014-03-15 00:37:23.000000', 'consum', 0.0226, 'lps'),
	(577460, 127, '2014-03-15 00:37:24.000000', 'consum', 0.0223, 'lps'),
	(577461, 127, '2014-03-15 00:37:25.000000', 'consum', 0.0226, 'lps'),
	(577462, 127, '2014-03-15 00:37:26.000000', 'consum', 0.0217, 'lps'),
	(577463, 127, '2014-03-15 00:37:27.000000', 'consum', 0.0214, 'lps'),
	(577464, 127, '2014-03-15 00:37:28.000000', 'consum', 0.0226, 'lps'),
	(577465, 127, '2014-03-15 00:37:29.000000', 'consum', 0.0226, 'lps'),
	(577466, 127, '2014-03-15 00:37:30.000000', 'consum', 0.0224, 'lps'),
	(577467, 127, '2014-03-15 00:37:31.000000', 'consum', 0.0216, 'lps'),
	(577468, 127, '2014-03-15 00:37:32.000000', 'consum', 0.0216, 'lps'),
	(577469, 127, '2014-03-15 00:37:33.000000', 'consum', 0.0224, 'lps'),
	(577470, 127, '2014-03-15 00:37:34.000000', 'consum', 0.0225, 'lps'),
	(577471, 127, '2014-03-15 00:37:35.000000', 'consum', 0.0226, 'lps'),
	(577472, 127, '2014-03-15 00:37:36.000000', 'consum', 0.0211, 'lps'),
	(577473, 127, '2014-03-15 00:37:37.000000', 'consum', 0.0222, 'lps'),
	(577474, 127, '2014-03-15 00:37:38.000000', 'consum', 0.0213, 'lps'),
	(577475, 127, '2014-03-15 00:37:39.000000', 'consum', 0.0224, 'lps'),
	(577476, 127, '2014-03-15 00:37:40.000000', 'consum', 0.0220, 'lps'),
	(577477, 127, '2014-03-15 00:37:41.000000', 'consum', 0.0219, 'lps'),
	(577478, 127, '2014-03-15 00:37:42.000000', 'consum', 0.0223, 'lps'),
	(577479, 127, '2014-03-15 00:37:43.000000', 'consum', 0.0212, 'lps'),
	(577480, 127, '2014-03-15 00:37:44.000000', 'consum', 0.0218, 'lps'),
	(577481, 127, '2014-03-15 00:37:45.000000', 'consum', 0.0226, 'lps'),
	(577482, 127, '2014-03-15 00:37:46.000000', 'consum', 0.0214, 'lps'),
	(577483, 127, '2014-03-15 00:37:47.000000', 'consum', 0.0220, 'lps'),
	(577484, 127, '2014-03-15 00:37:48.000000', 'consum', 0.0210, 'lps'),
	(577485, 127, '2014-03-15 00:37:49.000000', 'consum', 0.0216, 'lps'),
	(577486, 127, '2014-03-15 00:37:50.000000', 'consum', 0.0222, 'lps'),
	(577487, 127, '2014-03-15 00:37:51.000000', 'consum', 0.0216, 'lps'),
	(577488, 127, '2014-03-15 00:37:52.000000', 'consum', 0.0226, 'lps'),
	(577489, 127, '2014-03-15 00:37:53.000000', 'consum', 0.0215, 'lps'),
	(577490, 127, '2014-03-15 00:37:54.000000', 'consum', 0.0224, 'lps'),
	(577491, 127, '2014-03-15 00:37:55.000000', 'consum', 0.0210, 'lps'),
	(577492, 127, '2014-03-15 00:37:56.000000', 'consum', 0.0223, 'lps'),
	(577493, 127, '2014-03-15 00:37:57.000000', 'consum', 0.0223, 'lps'),
	(577494, 127, '2014-03-15 00:37:58.000000', 'consum', 0.0220, 'lps'),
	(577495, 127, '2014-03-15 00:37:59.000000', 'consum', 0.0219, 'lps'),
	(577496, 127, '2014-03-15 00:38:00.000000', 'consum', 0.0225, 'lps'),
	(577497, 127, '2014-03-15 00:38:01.000000', 'consum', 0.0225, 'lps'),
	(577498, 127, '2014-03-15 00:38:02.000000', 'consum', 0.0222, 'lps'),
	(577499, 127, '2014-03-15 00:38:03.000000', 'consum', 0.0225, 'lps'),
	(577500, 127, '2014-03-15 00:38:04.000000', 'consum', 0.0214, 'lps'),
	(577501, 127, '2014-03-15 00:38:05.000000', 'consum', 0.0223, 'lps'),
	(577502, 127, '2014-03-15 00:38:06.000000', 'consum', 0.0226, 'lps'),
	(577503, 127, '2014-03-15 00:38:07.000000', 'consum', 0.0215, 'lps'),
	(577504, 127, '2014-03-15 00:38:08.000000', 'consum', 0.0224, 'lps'),
	(577505, 127, '2014-03-15 00:38:09.000000', 'consum', 0.0210, 'lps'),
	(577506, 127, '2014-03-15 00:38:10.000000', 'consum', 0.0225, 'lps'),
	(577507, 127, '2014-03-15 00:38:11.000000', 'consum', 0.0213, 'lps'),
	(577508, 127, '2014-03-15 00:38:12.000000', 'consum', 0.0215, 'lps'),
	(577509, 127, '2014-03-15 00:38:13.000000', 'consum', 0.0227, 'lps'),
	(577510, 127, '2014-03-15 00:38:14.000000', 'consum', 0.0227, 'lps'),
	(577511, 127, '2014-03-15 00:38:15.000000', 'consum', 0.0226, 'lps'),
	(577512, 127, '2014-03-15 00:38:16.000000', 'consum', 0.0222, 'lps'),
	(577513, 127, '2014-03-15 00:38:17.000000', 'consum', 0.0223, 'lps'),
	(577514, 127, '2014-03-15 00:38:18.000000', 'consum', 0.0222, 'lps'),
	(577515, 127, '2014-03-15 00:38:19.000000', 'consum', 0.0215, 'lps'),
	(577516, 127, '2014-03-15 00:38:20.000000', 'consum', 0.0214, 'lps'),
	(577517, 127, '2014-03-15 00:38:21.000000', 'consum', 0.0219, 'lps'),
	(577518, 127, '2014-03-15 00:38:22.000000', 'consum', 0.0223, 'lps'),
	(577519, 127, '2014-03-15 00:38:23.000000', 'consum', 0.0214, 'lps'),
	(577520, 127, '2014-03-15 00:38:24.000000', 'consum', 0.0226, 'lps'),
	(577521, 127, '2014-03-15 00:38:25.000000', 'consum', 0.0225, 'lps'),
	(577522, 127, '2014-03-15 00:38:26.000000', 'consum', 0.0220, 'lps'),
	(577523, 127, '2014-03-15 00:38:27.000000', 'consum', 0.0215, 'lps'),
	(577524, 127, '2014-03-15 00:38:28.000000', 'consum', 0.0224, 'lps'),
	(577525, 127, '2014-03-15 00:38:29.000000', 'consum', 0.0211, 'lps'),
	(577526, 127, '2014-03-15 00:38:30.000000', 'consum', 0.0211, 'lps'),
	(577527, 127, '2014-03-15 00:38:31.000000', 'consum', 0.0210, 'lps'),
	(577528, 127, '2014-03-15 00:38:32.000000', 'consum', 0.0227, 'lps'),
	(577529, 127, '2014-03-15 00:38:33.000000', 'consum', 0.0223, 'lps'),
	(577530, 127, '2014-03-15 00:38:34.000000', 'consum', 0.0226, 'lps'),
	(577531, 127, '2014-03-15 00:38:35.000000', 'consum', 0.0214, 'lps'),
	(577532, 127, '2014-03-15 00:38:36.000000', 'consum', 0.0219, 'lps'),
	(577533, 127, '2014-03-15 00:38:37.000000', 'consum', 0.0224, 'lps'),
	(577534, 127, '2014-03-15 00:38:38.000000', 'consum', 0.0216, 'lps'),
	(577535, 127, '2014-03-15 00:38:39.000000', 'consum', 0.0220, 'lps'),
	(577536, 127, '2014-03-15 00:38:40.000000', 'consum', 0.0223, 'lps'),
	(577537, 127, '2014-03-15 00:38:41.000000', 'consum', 0.0211, 'lps'),
	(577538, 127, '2014-03-15 00:38:42.000000', 'consum', 0.0210, 'lps'),
	(577539, 127, '2014-03-15 00:38:43.000000', 'consum', 0.0225, 'lps'),
	(577540, 127, '2014-03-15 00:38:44.000000', 'consum', 0.0213, 'lps'),
	(577541, 127, '2014-03-15 00:38:45.000000', 'consum', 0.0217, 'lps'),
	(577542, 127, '2014-03-15 00:38:46.000000', 'consum', 0.0217, 'lps'),
	(577543, 127, '2014-03-15 00:38:47.000000', 'consum', 0.0210, 'lps'),
	(577544, 127, '2014-03-15 00:38:48.000000', 'consum', 0.0223, 'lps'),
	(577545, 127, '2014-03-15 00:38:49.000000', 'consum', 0.0223, 'lps'),
	(577546, 127, '2014-03-15 00:38:50.000000', 'consum', 0.0218, 'lps'),
	(577547, 127, '2014-03-15 00:38:51.000000', 'consum', 0.0212, 'lps'),
	(577548, 127, '2014-03-15 00:38:52.000000', 'consum', 0.0215, 'lps'),
	(577549, 127, '2014-03-15 00:38:53.000000', 'consum', 0.0212, 'lps'),
	(577550, 127, '2014-03-15 00:38:54.000000', 'consum', 0.0221, 'lps'),
	(577551, 127, '2014-03-15 00:38:55.000000', 'consum', 0.0224, 'lps'),
	(577552, 127, '2014-03-15 00:38:56.000000', 'consum', 0.0210, 'lps'),
	(577553, 127, '2014-03-15 00:38:57.000000', 'consum', 0.0224, 'lps'),
	(577554, 127, '2014-03-15 00:38:58.000000', 'consum', 0.0210, 'lps'),
	(577555, 127, '2014-03-15 00:38:59.000000', 'consum', 0.0221, 'lps'),
	(577556, 127, '2014-03-15 00:39:00.000000', 'consum', 0.0213, 'lps'),
	(577557, 127, '2014-03-15 00:39:01.000000', 'consum', 0.0226, 'lps'),
	(577558, 127, '2014-03-15 00:39:02.000000', 'consum', 0.0211, 'lps'),
	(577559, 127, '2014-03-15 00:39:03.000000', 'consum', 0.0220, 'lps'),
	(577560, 127, '2014-03-15 00:39:04.000000', 'consum', 0.0222, 'lps'),
	(577561, 127, '2014-03-15 00:39:05.000000', 'consum', 0.0223, 'lps'),
	(577562, 127, '2014-03-15 00:39:06.000000', 'consum', 0.0223, 'lps'),
	(577563, 127, '2014-03-15 00:39:07.000000', 'consum', 0.0217, 'lps'),
	(577564, 127, '2014-03-15 00:39:08.000000', 'consum', 0.0223, 'lps'),
	(577565, 127, '2014-03-15 00:39:09.000000', 'consum', 0.0219, 'lps'),
	(577566, 127, '2014-03-15 00:39:10.000000', 'consum', 0.0215, 'lps'),
	(577567, 127, '2014-03-15 00:39:11.000000', 'consum', 0.0211, 'lps'),
	(577568, 127, '2014-03-15 00:39:12.000000', 'consum', 0.0219, 'lps'),
	(577569, 127, '2014-03-15 00:39:13.000000', 'consum', 0.0215, 'lps'),
	(577570, 127, '2014-03-15 00:39:14.000000', 'consum', 0.0211, 'lps'),
	(577571, 127, '2014-03-15 00:39:15.000000', 'consum', 0.0217, 'lps'),
	(577572, 127, '2014-03-15 00:39:16.000000', 'consum', 0.0225, 'lps'),
	(577573, 127, '2014-03-15 00:39:17.000000', 'consum', 0.0227, 'lps'),
	(577574, 127, '2014-03-15 00:39:18.000000', 'consum', 0.0217, 'lps'),
	(577575, 127, '2014-03-15 00:39:19.000000', 'consum', 0.0213, 'lps'),
	(577576, 127, '2014-03-15 00:39:20.000000', 'consum', 0.0222, 'lps'),
	(577577, 127, '2014-03-15 00:39:21.000000', 'consum', 0.0225, 'lps'),
	(577578, 127, '2014-03-15 00:39:22.000000', 'consum', 0.0212, 'lps'),
	(577579, 127, '2014-03-15 00:39:23.000000', 'consum', 0.0212, 'lps'),
	(577580, 127, '2014-03-15 00:39:24.000000', 'consum', 0.0214, 'lps'),
	(577581, 127, '2014-03-15 00:39:25.000000', 'consum', 0.0226, 'lps'),
	(577582, 127, '2014-03-15 00:39:26.000000', 'consum', 0.0225, 'lps'),
	(577583, 127, '2014-03-15 00:39:27.000000', 'consum', 0.0218, 'lps'),
	(577584, 127, '2014-03-15 00:39:28.000000', 'consum', 0.0224, 'lps'),
	(577585, 127, '2014-03-15 00:39:29.000000', 'consum', 0.0219, 'lps'),
	(577586, 127, '2014-03-15 00:39:30.000000', 'consum', 0.0214, 'lps'),
	(577587, 127, '2014-03-15 00:39:31.000000', 'consum', 0.0222, 'lps'),
	(577588, 127, '2014-03-15 00:39:32.000000', 'consum', 0.0223, 'lps'),
	(577589, 127, '2014-03-15 00:39:33.000000', 'consum', 0.0220, 'lps'),
	(577590, 127, '2014-03-15 00:39:34.000000', 'consum', 0.0224, 'lps'),
	(577591, 127, '2014-03-15 00:39:35.000000', 'consum', 0.0214, 'lps'),
	(577592, 127, '2014-03-15 00:39:36.000000', 'consum', 0.0225, 'lps'),
	(577593, 127, '2014-03-15 00:39:37.000000', 'consum', 0.0220, 'lps'),
	(577594, 127, '2014-03-15 00:39:38.000000', 'consum', 0.0214, 'lps'),
	(577595, 127, '2014-03-15 00:39:39.000000', 'consum', 0.0218, 'lps'),
	(577596, 127, '2014-03-15 00:39:40.000000', 'consum', 0.0220, 'lps'),
	(577597, 127, '2014-03-15 00:39:41.000000', 'consum', 0.0221, 'lps'),
	(577598, 127, '2014-03-15 00:39:42.000000', 'consum', 0.0215, 'lps'),
	(577599, 127, '2014-03-15 00:39:43.000000', 'consum', 0.0224, 'lps'),
	(577600, 127, '2014-03-15 00:39:44.000000', 'consum', 0.0226, 'lps'),
	(577601, 127, '2014-03-15 00:39:45.000000', 'consum', 0.0213, 'lps'),
	(577602, 127, '2014-03-15 00:39:46.000000', 'consum', 0.0214, 'lps'),
	(577603, 127, '2014-03-15 00:39:47.000000', 'consum', 0.0223, 'lps'),
	(577604, 127, '2014-03-15 00:39:48.000000', 'consum', 0.0225, 'lps'),
	(577605, 127, '2014-03-15 00:39:49.000000', 'consum', 0.0227, 'lps'),
	(577606, 127, '2014-03-15 00:39:50.000000', 'consum', 0.0218, 'lps'),
	(577607, 127, '2014-03-15 00:39:51.000000', 'consum', 0.0217, 'lps'),
	(577608, 127, '2014-03-15 00:39:52.000000', 'consum', 0.0220, 'lps'),
	(577609, 127, '2014-03-15 00:39:53.000000', 'consum', 0.0221, 'lps'),
	(577610, 127, '2014-03-15 00:39:54.000000', 'consum', 0.0216, 'lps'),
	(577611, 127, '2014-03-15 00:39:55.000000', 'consum', 0.0210, 'lps'),
	(577612, 127, '2014-03-15 00:39:56.000000', 'consum', 0.0210, 'lps'),
	(577613, 127, '2014-03-15 00:39:57.000000', 'consum', 0.0212, 'lps'),
	(577614, 127, '2014-03-15 00:39:58.000000', 'consum', 0.0219, 'lps'),
	(577615, 127, '2014-03-15 00:39:59.000000', 'consum', 0.0213, 'lps'),
	(577616, 127, '2014-03-15 00:40:00.000000', 'consum', 0.0215, 'lps'),
	(577617, 127, '2014-03-15 00:40:01.000000', 'consum', 0.0210, 'lps'),
	(577618, 127, '2014-03-15 00:40:02.000000', 'consum', 0.0213, 'lps'),
	(577619, 127, '2014-03-15 00:40:03.000000', 'consum', 0.0224, 'lps'),
	(577620, 127, '2014-03-15 00:40:04.000000', 'consum', 0.0220, 'lps'),
	(577621, 127, '2014-03-15 00:40:05.000000', 'consum', 0.0216, 'lps'),
	(577622, 127, '2014-03-15 00:40:06.000000', 'consum', 0.0214, 'lps'),
	(577623, 127, '2014-03-15 00:40:07.000000', 'consum', 0.0227, 'lps'),
	(577624, 127, '2014-03-15 00:40:08.000000', 'consum', 0.0213, 'lps'),
	(577625, 127, '2014-03-15 00:40:09.000000', 'consum', 0.0227, 'lps'),
	(577626, 127, '2014-03-15 00:40:10.000000', 'consum', 0.0215, 'lps'),
	(577627, 127, '2014-03-15 00:40:11.000000', 'consum', 0.0219, 'lps'),
	(577628, 127, '2014-03-15 00:40:12.000000', 'consum', 0.0223, 'lps'),
	(577629, 127, '2014-03-15 00:40:13.000000', 'consum', 0.0214, 'lps'),
	(577630, 127, '2014-03-15 00:40:14.000000', 'consum', 0.0227, 'lps'),
	(577631, 127, '2014-03-15 00:40:15.000000', 'consum', 0.0213, 'lps'),
	(577632, 127, '2014-03-15 00:40:16.000000', 'consum', 0.0211, 'lps'),
	(577633, 127, '2014-03-15 00:40:17.000000', 'consum', 0.0223, 'lps'),
	(577634, 127, '2014-03-15 00:40:18.000000', 'consum', 0.0220, 'lps'),
	(577635, 127, '2014-03-15 00:40:19.000000', 'consum', 0.0222, 'lps'),
	(577636, 127, '2014-03-15 00:40:20.000000', 'consum', 0.0220, 'lps'),
	(577637, 127, '2014-03-15 00:40:21.000000', 'consum', 0.0224, 'lps'),
	(577638, 127, '2014-03-15 00:40:22.000000', 'consum', 0.0217, 'lps'),
	(577639, 127, '2014-03-15 00:40:23.000000', 'consum', 0.0221, 'lps'),
	(577640, 127, '2014-03-15 00:40:24.000000', 'consum', 0.0210, 'lps'),
	(577641, 127, '2014-03-15 00:40:25.000000', 'consum', 0.0210, 'lps'),
	(577642, 127, '2014-03-15 00:40:26.000000', 'consum', 0.0213, 'lps'),
	(577643, 127, '2014-03-15 00:40:27.000000', 'consum', 0.0224, 'lps'),
	(577644, 127, '2014-03-15 00:40:28.000000', 'consum', 0.0218, 'lps'),
	(577645, 127, '2014-03-15 00:40:29.000000', 'consum', 0.0210, 'lps'),
	(577646, 127, '2014-03-15 00:40:30.000000', 'consum', 0.0222, 'lps'),
	(577647, 127, '2014-03-15 00:40:31.000000', 'consum', 0.0218, 'lps'),
	(577648, 127, '2014-03-15 00:40:32.000000', 'consum', 0.0211, 'lps'),
	(577649, 127, '2014-03-15 00:40:33.000000', 'consum', 0.0212, 'lps'),
	(577650, 127, '2014-03-15 00:40:34.000000', 'consum', 0.0219, 'lps'),
	(577651, 127, '2014-03-15 00:40:35.000000', 'consum', 0.0211, 'lps'),
	(577652, 127, '2014-03-15 00:40:36.000000', 'consum', 0.0226, 'lps'),
	(577653, 127, '2014-03-15 00:40:37.000000', 'consum', 0.0216, 'lps'),
	(577654, 127, '2014-03-15 00:40:38.000000', 'consum', 0.0210, 'lps'),
	(577655, 127, '2014-03-15 00:40:39.000000', 'consum', 0.0211, 'lps'),
	(577656, 127, '2014-03-15 00:40:40.000000', 'consum', 0.0214, 'lps'),
	(577657, 127, '2014-03-15 00:40:41.000000', 'consum', 0.0227, 'lps'),
	(577658, 127, '2014-03-15 00:40:42.000000', 'consum', 0.0214, 'lps'),
	(577659, 127, '2014-03-15 00:40:43.000000', 'consum', 0.0213, 'lps'),
	(577660, 127, '2014-03-15 00:40:44.000000', 'consum', 0.0213, 'lps'),
	(577661, 127, '2014-03-15 00:40:45.000000', 'consum', 0.0219, 'lps'),
	(577662, 127, '2014-03-15 00:40:46.000000', 'consum', 0.0210, 'lps'),
	(577663, 127, '2014-03-15 00:40:47.000000', 'consum', 0.0220, 'lps'),
	(577664, 127, '2014-03-15 00:40:48.000000', 'consum', 0.0224, 'lps'),
	(577665, 127, '2014-03-15 00:40:49.000000', 'consum', 0.0215, 'lps'),
	(577666, 127, '2014-03-15 00:40:50.000000', 'consum', 0.0213, 'lps'),
	(577667, 127, '2014-03-15 00:40:51.000000', 'consum', 0.0226, 'lps'),
	(577668, 127, '2014-03-15 00:40:52.000000', 'consum', 0.0210, 'lps'),
	(577669, 127, '2014-03-15 00:40:53.000000', 'consum', 0.0217, 'lps'),
	(577670, 127, '2014-03-15 00:40:54.000000', 'consum', 0.0226, 'lps'),
	(577671, 127, '2014-03-15 00:40:55.000000', 'consum', 0.0216, 'lps'),
	(577672, 127, '2014-03-15 00:40:56.000000', 'consum', 0.0227, 'lps'),
	(577673, 127, '2014-03-15 00:40:57.000000', 'consum', 0.0225, 'lps'),
	(577674, 127, '2014-03-15 00:40:58.000000', 'consum', 0.0218, 'lps'),
	(577675, 127, '2014-03-15 00:40:59.000000', 'consum', 0.0220, 'lps'),
	(577676, 127, '2014-03-15 00:41:00.000000', 'consum', 0.0222, 'lps'),
	(577677, 127, '2014-03-15 00:41:01.000000', 'consum', 0.0222, 'lps'),
	(577678, 127, '2014-03-15 00:41:02.000000', 'consum', 0.0214, 'lps'),
	(577679, 127, '2014-03-15 00:41:03.000000', 'consum', 0.0213, 'lps'),
	(577680, 127, '2014-03-15 00:41:04.000000', 'consum', 0.0214, 'lps'),
	(577681, 127, '2014-03-15 00:41:05.000000', 'consum', 0.0221, 'lps'),
	(577682, 127, '2014-03-15 00:41:06.000000', 'consum', 0.0220, 'lps'),
	(577683, 127, '2014-03-15 00:41:07.000000', 'consum', 0.0225, 'lps'),
	(577684, 127, '2014-03-15 00:41:08.000000', 'consum', 0.0220, 'lps'),
	(577685, 127, '2014-03-15 00:41:09.000000', 'consum', 0.0217, 'lps'),
	(577686, 127, '2014-03-15 00:41:10.000000', 'consum', 0.0216, 'lps'),
	(577687, 127, '2014-03-15 00:41:11.000000', 'consum', 0.0220, 'lps'),
	(577688, 127, '2014-03-15 00:41:12.000000', 'consum', 0.0225, 'lps'),
	(577689, 127, '2014-03-15 00:41:13.000000', 'consum', 0.0218, 'lps'),
	(577690, 127, '2014-03-15 00:41:14.000000', 'consum', 0.0224, 'lps'),
	(577691, 127, '2014-03-15 00:41:15.000000', 'consum', 0.0221, 'lps'),
	(577692, 127, '2014-03-15 00:41:16.000000', 'consum', 0.0221, 'lps'),
	(577693, 127, '2014-03-15 00:41:17.000000', 'consum', 0.0217, 'lps'),
	(577694, 127, '2014-03-15 00:41:18.000000', 'consum', 0.0210, 'lps'),
	(577695, 127, '2014-03-15 00:41:19.000000', 'consum', 0.0225, 'lps'),
	(577696, 127, '2014-03-15 00:41:20.000000', 'consum', 0.0215, 'lps'),
	(577697, 127, '2014-03-15 00:41:21.000000', 'consum', 0.0226, 'lps'),
	(577698, 127, '2014-03-15 00:41:22.000000', 'consum', 0.0223, 'lps'),
	(577699, 127, '2014-03-15 00:41:23.000000', 'consum', 0.0211, 'lps'),
	(577700, 127, '2014-03-15 00:41:24.000000', 'consum', 0.0210, 'lps'),
	(577701, 127, '2014-03-15 00:41:25.000000', 'consum', 0.0225, 'lps'),
	(577702, 127, '2014-03-15 00:41:26.000000', 'consum', 0.0213, 'lps'),
	(577703, 127, '2014-03-15 00:41:27.000000', 'consum', 0.0219, 'lps'),
	(577704, 127, '2014-03-15 00:41:28.000000', 'consum', 0.0210, 'lps'),
	(577705, 127, '2014-03-15 00:41:29.000000', 'consum', 0.0218, 'lps'),
	(577706, 127, '2014-03-15 00:41:30.000000', 'consum', 0.0214, 'lps'),
	(577707, 127, '2014-03-15 00:41:31.000000', 'consum', 0.0225, 'lps'),
	(577708, 127, '2014-03-15 00:41:32.000000', 'consum', 0.0220, 'lps'),
	(577709, 127, '2014-03-15 00:41:33.000000', 'consum', 0.0213, 'lps'),
	(577710, 127, '2014-03-15 00:41:34.000000', 'consum', 0.0217, 'lps'),
	(577711, 127, '2014-03-15 00:41:35.000000', 'consum', 0.0217, 'lps'),
	(577712, 127, '2014-03-15 00:41:36.000000', 'consum', 0.0224, 'lps'),
	(577713, 127, '2014-03-15 00:41:37.000000', 'consum', 0.0225, 'lps'),
	(577714, 127, '2014-03-15 00:41:38.000000', 'consum', 0.0227, 'lps'),
	(577715, 127, '2014-03-15 00:41:39.000000', 'consum', 0.0212, 'lps'),
	(577716, 127, '2014-03-15 00:41:40.000000', 'consum', 0.0226, 'lps'),
	(577717, 127, '2014-03-15 00:41:41.000000', 'consum', 0.0211, 'lps'),
	(577718, 127, '2014-03-15 00:41:42.000000', 'consum', 0.0224, 'lps'),
	(577719, 127, '2014-03-15 00:41:43.000000', 'consum', 0.0220, 'lps'),
	(577720, 127, '2014-03-15 00:41:44.000000', 'consum', 0.0221, 'lps'),
	(577721, 127, '2014-03-15 00:41:45.000000', 'consum', 0.0218, 'lps'),
	(577722, 127, '2014-03-15 00:41:46.000000', 'consum', 0.0218, 'lps'),
	(577723, 127, '2014-03-15 00:41:47.000000', 'consum', 0.0226, 'lps'),
	(577724, 127, '2014-03-15 00:41:48.000000', 'consum', 0.0213, 'lps'),
	(577725, 127, '2014-03-15 00:41:49.000000', 'consum', 0.0212, 'lps'),
	(577726, 127, '2014-03-15 00:41:50.000000', 'consum', 0.0214, 'lps'),
	(577727, 127, '2014-03-15 00:41:51.000000', 'consum', 0.0224, 'lps'),
	(577728, 127, '2014-03-15 00:41:52.000000', 'consum', 0.0213, 'lps'),
	(577729, 127, '2014-03-15 00:41:53.000000', 'consum', 0.0219, 'lps'),
	(577730, 127, '2014-03-15 00:41:54.000000', 'consum', 0.0213, 'lps'),
	(577731, 127, '2014-03-15 00:41:55.000000', 'consum', 0.0214, 'lps'),
	(577732, 127, '2014-03-15 00:41:56.000000', 'consum', 0.0222, 'lps'),
	(577733, 127, '2014-03-15 00:41:57.000000', 'consum', 0.0222, 'lps'),
	(577734, 127, '2014-03-15 00:41:58.000000', 'consum', 0.0218, 'lps'),
	(577735, 127, '2014-03-15 00:41:59.000000', 'consum', 0.0212, 'lps'),
	(577736, 127, '2014-03-15 00:42:00.000000', 'consum', 0.0218, 'lps'),
	(577737, 127, '2014-03-15 00:42:01.000000', 'consum', 0.0223, 'lps'),
	(577738, 127, '2014-03-15 00:42:02.000000', 'consum', 0.0217, 'lps'),
	(577739, 127, '2014-03-15 00:42:03.000000', 'consum', 0.0226, 'lps'),
	(577740, 127, '2014-03-15 00:42:04.000000', 'consum', 0.0215, 'lps'),
	(577741, 127, '2014-03-15 00:42:05.000000', 'consum', 0.0225, 'lps'),
	(577742, 127, '2014-03-15 00:42:06.000000', 'consum', 0.0215, 'lps'),
	(577743, 127, '2014-03-15 00:42:07.000000', 'consum', 0.0226, 'lps'),
	(577744, 127, '2014-03-15 00:42:08.000000', 'consum', 0.0223, 'lps'),
	(577745, 127, '2014-03-15 00:42:09.000000', 'consum', 0.0226, 'lps'),
	(577746, 127, '2014-03-15 00:42:10.000000', 'consum', 0.0214, 'lps'),
	(577747, 127, '2014-03-15 00:42:11.000000', 'consum', 0.0220, 'lps'),
	(577748, 127, '2014-03-15 00:42:12.000000', 'consum', 0.0211, 'lps'),
	(577749, 127, '2014-03-15 00:42:13.000000', 'consum', 0.0222, 'lps'),
	(577750, 127, '2014-03-15 00:42:14.000000', 'consum', 0.0213, 'lps'),
	(577751, 127, '2014-03-15 00:42:15.000000', 'consum', 0.0225, 'lps'),
	(577752, 127, '2014-03-15 00:42:16.000000', 'consum', 0.0223, 'lps'),
	(577753, 127, '2014-03-15 00:42:17.000000', 'consum', 0.0215, 'lps'),
	(577754, 127, '2014-03-15 00:42:18.000000', 'consum', 0.0211, 'lps'),
	(577755, 127, '2014-03-15 00:42:19.000000', 'consum', 0.0221, 'lps'),
	(577756, 127, '2014-03-15 00:42:20.000000', 'consum', 0.0225, 'lps'),
	(577757, 127, '2014-03-15 00:42:21.000000', 'consum', 0.0216, 'lps'),
	(577758, 127, '2014-03-15 00:42:22.000000', 'consum', 0.0216, 'lps'),
	(577759, 127, '2014-03-15 00:42:23.000000', 'consum', 0.0221, 'lps'),
	(577760, 127, '2014-03-15 00:42:24.000000', 'consum', 0.0210, 'lps'),
	(577761, 127, '2014-03-15 00:42:25.000000', 'consum', 0.0213, 'lps'),
	(577762, 127, '2014-03-15 00:42:26.000000', 'consum', 0.0226, 'lps'),
	(577763, 127, '2014-03-15 00:42:27.000000', 'consum', 0.0211, 'lps'),
	(577764, 127, '2014-03-15 00:42:28.000000', 'consum', 0.0219, 'lps'),
	(577765, 127, '2014-03-15 00:42:29.000000', 'consum', 0.0217, 'lps'),
	(577766, 127, '2014-03-15 00:42:30.000000', 'consum', 0.0220, 'lps'),
	(577767, 127, '2014-03-15 00:42:31.000000', 'consum', 0.0220, 'lps'),
	(577768, 127, '2014-03-15 00:42:32.000000', 'consum', 0.0212, 'lps'),
	(577769, 127, '2014-03-15 00:42:33.000000', 'consum', 0.0210, 'lps'),
	(577770, 127, '2014-03-15 00:42:34.000000', 'consum', 0.0221, 'lps'),
	(577771, 127, '2014-03-15 00:42:35.000000', 'consum', 0.0214, 'lps'),
	(577772, 127, '2014-03-15 00:42:36.000000', 'consum', 0.0214, 'lps'),
	(577773, 127, '2014-03-15 00:42:37.000000', 'consum', 0.0218, 'lps'),
	(577774, 127, '2014-03-15 00:42:38.000000', 'consum', 0.0221, 'lps'),
	(577775, 127, '2014-03-15 00:42:39.000000', 'consum', 0.0222, 'lps'),
	(577776, 127, '2014-03-15 00:42:40.000000', 'consum', 0.0219, 'lps'),
	(577777, 127, '2014-03-15 00:42:41.000000', 'consum', 0.0220, 'lps'),
	(577778, 127, '2014-03-15 00:42:42.000000', 'consum', 0.0217, 'lps'),
	(577779, 127, '2014-03-15 00:42:43.000000', 'consum', 0.0216, 'lps'),
	(577780, 127, '2014-03-15 00:42:44.000000', 'consum', 0.0218, 'lps'),
	(577781, 127, '2014-03-15 00:42:45.000000', 'consum', 0.0214, 'lps'),
	(577782, 127, '2014-03-15 00:42:46.000000', 'consum', 0.0226, 'lps'),
	(577783, 127, '2014-03-15 00:42:47.000000', 'consum', 0.0224, 'lps'),
	(577784, 127, '2014-03-15 00:42:48.000000', 'consum', 0.0215, 'lps'),
	(577785, 127, '2014-03-15 00:42:49.000000', 'consum', 0.0210, 'lps'),
	(577786, 127, '2014-03-15 00:42:50.000000', 'consum', 0.0215, 'lps'),
	(577787, 127, '2014-03-15 00:42:51.000000', 'consum', 0.0219, 'lps'),
	(577788, 127, '2014-03-15 00:42:52.000000', 'consum', 0.0221, 'lps'),
	(577789, 127, '2014-03-15 00:42:53.000000', 'consum', 0.0220, 'lps'),
	(577790, 127, '2014-03-15 00:42:54.000000', 'consum', 0.0212, 'lps'),
	(577791, 127, '2014-03-15 00:42:55.000000', 'consum', 0.0224, 'lps'),
	(577792, 127, '2014-03-15 00:42:56.000000', 'consum', 0.0222, 'lps'),
	(577793, 127, '2014-03-15 00:42:57.000000', 'consum', 0.0227, 'lps'),
	(577794, 127, '2014-03-15 00:42:58.000000', 'consum', 0.0225, 'lps'),
	(577795, 127, '2014-03-15 00:42:59.000000', 'consum', 0.0218, 'lps'),
	(577796, 127, '2014-03-15 00:43:00.000000', 'consum', 0.0221, 'lps'),
	(577797, 127, '2014-03-15 00:43:01.000000', 'consum', 0.0225, 'lps'),
	(577798, 127, '2014-03-15 00:43:02.000000', 'consum', 0.0215, 'lps'),
	(577799, 127, '2014-03-15 00:43:03.000000', 'consum', 0.0227, 'lps'),
	(577800, 127, '2014-03-15 00:43:04.000000', 'consum', 0.0225, 'lps'),
	(577801, 127, '2014-03-15 00:43:05.000000', 'consum', 0.0217, 'lps'),
	(577802, 127, '2014-03-15 00:43:06.000000', 'consum', 0.0220, 'lps'),
	(577803, 127, '2014-03-15 00:43:07.000000', 'consum', 0.0219, 'lps'),
	(577804, 127, '2014-03-15 00:43:08.000000', 'consum', 0.0210, 'lps'),
	(577805, 127, '2014-03-15 00:43:09.000000', 'consum', 0.0220, 'lps'),
	(577806, 127, '2014-03-15 00:43:10.000000', 'consum', 0.0222, 'lps'),
	(577807, 127, '2014-03-15 00:43:11.000000', 'consum', 0.0222, 'lps'),
	(577808, 127, '2014-03-15 00:43:12.000000', 'consum', 0.0219, 'lps'),
	(577809, 127, '2014-03-15 00:43:13.000000', 'consum', 0.0220, 'lps'),
	(577810, 127, '2014-03-15 00:43:14.000000', 'consum', 0.0213, 'lps'),
	(577811, 127, '2014-03-15 00:43:15.000000', 'consum', 0.0215, 'lps'),
	(577812, 127, '2014-03-15 00:43:16.000000', 'consum', 0.0227, 'lps'),
	(577813, 127, '2014-03-15 00:43:17.000000', 'consum', 0.0227, 'lps'),
	(577814, 127, '2014-03-15 00:43:18.000000', 'consum', 0.0210, 'lps'),
	(577815, 127, '2014-03-15 00:43:19.000000', 'consum', 0.0210, 'lps'),
	(577816, 127, '2014-03-15 00:43:20.000000', 'consum', 0.0212, 'lps'),
	(577817, 127, '2014-03-15 00:43:21.000000', 'consum', 0.0222, 'lps'),
	(577818, 127, '2014-03-15 00:43:22.000000', 'consum', 0.0227, 'lps'),
	(577819, 127, '2014-03-15 00:43:23.000000', 'consum', 0.0226, 'lps'),
	(577820, 127, '2014-03-15 00:43:24.000000', 'consum', 0.0219, 'lps'),
	(577821, 127, '2014-03-15 00:43:25.000000', 'consum', 0.0227, 'lps'),
	(577822, 127, '2014-03-15 00:43:26.000000', 'consum', 0.0214, 'lps'),
	(577823, 127, '2014-03-15 00:43:27.000000', 'consum', 0.0214, 'lps'),
	(577824, 127, '2014-03-15 00:43:28.000000', 'consum', 0.0221, 'lps'),
	(577825, 127, '2014-03-15 00:43:29.000000', 'consum', 0.0215, 'lps'),
	(577826, 127, '2014-03-15 00:43:30.000000', 'consum', 0.0220, 'lps'),
	(577827, 127, '2014-03-15 00:43:31.000000', 'consum', 0.0227, 'lps'),
	(577828, 127, '2014-03-15 00:43:32.000000', 'consum', 0.0212, 'lps'),
	(577829, 127, '2014-03-15 00:43:33.000000', 'consum', 0.0225, 'lps'),
	(577830, 127, '2014-03-15 00:43:34.000000', 'consum', 0.0227, 'lps'),
	(577831, 127, '2014-03-15 00:43:35.000000', 'consum', 0.0211, 'lps'),
	(577832, 127, '2014-03-15 00:43:36.000000', 'consum', 0.0221, 'lps'),
	(577833, 127, '2014-03-15 00:43:37.000000', 'consum', 0.0226, 'lps'),
	(577834, 127, '2014-03-15 00:43:38.000000', 'consum', 0.0221, 'lps'),
	(577835, 127, '2014-03-15 00:43:39.000000', 'consum', 0.0219, 'lps'),
	(577836, 127, '2014-03-15 00:43:40.000000', 'consum', 0.0220, 'lps'),
	(577837, 127, '2014-03-15 00:43:41.000000', 'consum', 0.0217, 'lps'),
	(577838, 127, '2014-03-15 00:43:42.000000', 'consum', 0.0215, 'lps'),
	(577839, 127, '2014-03-15 00:43:43.000000', 'consum', 0.0216, 'lps'),
	(577840, 127, '2014-03-15 00:43:44.000000', 'consum', 0.0226, 'lps'),
	(577841, 127, '2014-03-15 00:43:45.000000', 'consum', 0.0216, 'lps'),
	(577842, 127, '2014-03-15 00:43:46.000000', 'consum', 0.0210, 'lps'),
	(577843, 127, '2014-03-15 00:43:47.000000', 'consum', 0.0212, 'lps'),
	(577844, 127, '2014-03-15 00:43:48.000000', 'consum', 0.0220, 'lps'),
	(577845, 127, '2014-03-15 00:43:49.000000', 'consum', 0.0220, 'lps'),
	(577846, 127, '2014-03-15 00:43:50.000000', 'consum', 0.0210, 'lps'),
	(577847, 127, '2014-03-15 00:43:51.000000', 'consum', 0.0217, 'lps'),
	(577848, 127, '2014-03-15 00:43:52.000000', 'consum', 0.0227, 'lps'),
	(577849, 127, '2014-03-15 00:43:53.000000', 'consum', 0.0221, 'lps'),
	(577850, 127, '2014-03-15 00:43:54.000000', 'consum', 0.0216, 'lps'),
	(577851, 127, '2014-03-15 00:43:55.000000', 'consum', 0.0223, 'lps'),
	(577852, 127, '2014-03-15 00:43:56.000000', 'consum', 0.0223, 'lps'),
	(577853, 127, '2014-03-15 00:43:57.000000', 'consum', 0.0220, 'lps'),
	(577854, 127, '2014-03-15 00:43:58.000000', 'consum', 0.0219, 'lps'),
	(577855, 127, '2014-03-15 00:43:59.000000', 'consum', 0.0224, 'lps'),
	(577856, 127, '2014-03-15 00:44:00.000000', 'consum', 0.0220, 'lps'),
	(577857, 127, '2014-03-15 00:44:01.000000', 'consum', 0.0220, 'lps'),
	(577858, 127, '2014-03-15 00:44:02.000000', 'consum', 0.0227, 'lps'),
	(577859, 127, '2014-03-15 00:44:03.000000', 'consum', 0.0213, 'lps'),
	(577860, 127, '2014-03-15 00:44:04.000000', 'consum', 0.0212, 'lps'),
	(577861, 127, '2014-03-15 00:44:05.000000', 'consum', 0.0211, 'lps'),
	(577862, 127, '2014-03-15 00:44:06.000000', 'consum', 0.0225, 'lps'),
	(577863, 127, '2014-03-15 00:44:07.000000', 'consum', 0.0213, 'lps'),
	(577864, 127, '2014-03-15 00:44:08.000000', 'consum', 0.0216, 'lps'),
	(577865, 127, '2014-03-15 00:44:09.000000', 'consum', 0.0214, 'lps'),
	(577866, 127, '2014-03-15 00:44:10.000000', 'consum', 0.0214, 'lps'),
	(577867, 127, '2014-03-15 00:44:11.000000', 'consum', 0.0215, 'lps'),
	(577868, 127, '2014-03-15 00:44:12.000000', 'consum', 0.0227, 'lps'),
	(577869, 127, '2014-03-15 00:44:13.000000', 'consum', 0.0224, 'lps'),
	(577870, 127, '2014-03-15 00:44:14.000000', 'consum', 0.0213, 'lps'),
	(577871, 127, '2014-03-15 00:44:15.000000', 'consum', 0.0217, 'lps'),
	(577872, 127, '2014-03-15 00:44:16.000000', 'consum', 0.0220, 'lps'),
	(577873, 127, '2014-03-15 00:44:17.000000', 'consum', 0.0221, 'lps'),
	(577874, 127, '2014-03-15 00:44:18.000000', 'consum', 0.0218, 'lps'),
	(577875, 127, '2014-03-15 00:44:19.000000', 'consum', 0.0219, 'lps'),
	(577876, 127, '2014-03-15 00:44:20.000000', 'consum', 0.0213, 'lps'),
	(577877, 127, '2014-03-15 00:44:21.000000', 'consum', 0.0218, 'lps'),
	(577878, 127, '2014-03-15 00:44:22.000000', 'consum', 0.0222, 'lps'),
	(577879, 127, '2014-03-15 00:44:23.000000', 'consum', 0.0212, 'lps'),
	(577880, 127, '2014-03-15 00:44:24.000000', 'consum', 0.0221, 'lps'),
	(577881, 127, '2014-03-15 00:44:25.000000', 'consum', 0.0221, 'lps'),
	(577882, 127, '2014-03-15 00:44:26.000000', 'consum', 0.0217, 'lps'),
	(577883, 127, '2014-03-15 00:44:27.000000', 'consum', 0.0213, 'lps'),
	(577884, 127, '2014-03-15 00:44:28.000000', 'consum', 0.0223, 'lps'),
	(577885, 127, '2014-03-15 00:44:29.000000', 'consum', 0.0211, 'lps'),
	(577886, 127, '2014-03-15 00:44:30.000000', 'consum', 0.0214, 'lps'),
	(577887, 127, '2014-03-15 00:44:31.000000', 'consum', 0.0225, 'lps'),
	(577888, 127, '2014-03-15 00:44:32.000000', 'consum', 0.0220, 'lps'),
	(577889, 127, '2014-03-15 00:44:33.000000', 'consum', 0.0218, 'lps'),
	(577890, 127, '2014-03-15 00:44:34.000000', 'consum', 0.0218, 'lps'),
	(577891, 127, '2014-03-15 00:44:35.000000', 'consum', 0.0225, 'lps'),
	(577892, 127, '2014-03-15 00:44:36.000000', 'consum', 0.0210, 'lps'),
	(577893, 127, '2014-03-15 00:44:37.000000', 'consum', 0.0218, 'lps'),
	(577894, 127, '2014-03-15 00:44:38.000000', 'consum', 0.0214, 'lps'),
	(577895, 127, '2014-03-15 00:44:39.000000', 'consum', 0.0227, 'lps'),
	(577896, 127, '2014-03-15 00:44:40.000000', 'consum', 0.0227, 'lps'),
	(577897, 127, '2014-03-15 00:44:41.000000', 'consum', 0.0210, 'lps'),
	(577898, 127, '2014-03-15 00:44:42.000000', 'consum', 0.0212, 'lps'),
	(577899, 127, '2014-03-15 00:44:43.000000', 'consum', 0.0223, 'lps'),
	(577900, 127, '2014-03-15 00:44:44.000000', 'consum', 0.0213, 'lps'),
	(577901, 127, '2014-03-15 00:44:45.000000', 'consum', 0.0223, 'lps'),
	(577902, 127, '2014-03-15 00:44:46.000000', 'consum', 0.0214, 'lps'),
	(577903, 127, '2014-03-15 00:44:47.000000', 'consum', 0.0227, 'lps'),
	(577904, 127, '2014-03-15 00:44:48.000000', 'consum', 0.0210, 'lps'),
	(577905, 127, '2014-03-15 00:44:49.000000', 'consum', 0.0215, 'lps'),
	(577906, 127, '2014-03-15 00:44:50.000000', 'consum', 0.0217, 'lps'),
	(577907, 127, '2014-03-15 00:44:51.000000', 'consum', 0.0212, 'lps'),
	(577908, 127, '2014-03-15 00:44:52.000000', 'consum', 0.0217, 'lps'),
	(577909, 127, '2014-03-15 00:44:53.000000', 'consum', 0.0222, 'lps'),
	(577910, 127, '2014-03-15 00:44:54.000000', 'consum', 0.0213, 'lps'),
	(577911, 127, '2014-03-15 00:44:55.000000', 'consum', 0.0210, 'lps'),
	(577912, 127, '2014-03-15 00:44:56.000000', 'consum', 0.0216, 'lps'),
	(577913, 127, '2014-03-15 00:44:57.000000', 'consum', 0.0224, 'lps'),
	(577914, 127, '2014-03-15 00:44:58.000000', 'consum', 0.0225, 'lps'),
	(577915, 127, '2014-03-15 00:44:59.000000', 'consum', 0.0225, 'lps'),
	(577916, 127, '2014-03-15 00:45:00.000000', 'consum', 0.0221, 'lps'),
	(577917, 127, '2014-03-15 00:45:01.000000', 'consum', 0.0224, 'lps'),
	(577918, 127, '2014-03-15 00:45:02.000000', 'consum', 0.0211, 'lps'),
	(577919, 127, '2014-03-15 00:45:03.000000', 'consum', 0.0225, 'lps'),
	(577920, 127, '2014-03-15 00:45:04.000000', 'consum', 0.0213, 'lps'),
	(577921, 127, '2014-03-15 00:45:05.000000', 'consum', 0.0215, 'lps'),
	(577922, 127, '2014-03-15 00:45:06.000000', 'consum', 0.0210, 'lps'),
	(577923, 127, '2014-03-15 00:45:07.000000', 'consum', 0.0212, 'lps'),
	(577924, 127, '2014-03-15 00:45:08.000000', 'consum', 0.0222, 'lps'),
	(577925, 127, '2014-03-15 00:45:09.000000', 'consum', 0.0210, 'lps'),
	(577926, 127, '2014-03-15 00:45:10.000000', 'consum', 0.0211, 'lps'),
	(577927, 127, '2014-03-15 00:45:11.000000', 'consum', 0.0213, 'lps'),
	(577928, 127, '2014-03-15 00:45:12.000000', 'consum', 0.0225, 'lps'),
	(577929, 127, '2014-03-15 00:45:13.000000', 'consum', 0.0220, 'lps'),
	(577930, 127, '2014-03-15 00:45:14.000000', 'consum', 0.0219, 'lps'),
	(577931, 127, '2014-03-15 00:45:15.000000', 'consum', 0.0223, 'lps'),
	(577932, 127, '2014-03-15 00:45:16.000000', 'consum', 0.0215, 'lps'),
	(577933, 127, '2014-03-15 00:45:17.000000', 'consum', 0.0213, 'lps'),
	(577934, 127, '2014-03-15 00:45:18.000000', 'consum', 0.0210, 'lps'),
	(577935, 127, '2014-03-15 00:45:19.000000', 'consum', 0.0220, 'lps'),
	(577936, 127, '2014-03-15 00:45:20.000000', 'consum', 0.0222, 'lps'),
	(577937, 127, '2014-03-15 00:45:21.000000', 'consum', 0.0226, 'lps'),
	(577938, 127, '2014-03-15 00:45:22.000000', 'consum', 0.0217, 'lps'),
	(577939, 127, '2014-03-15 00:45:23.000000', 'consum', 0.0217, 'lps'),
	(577940, 127, '2014-03-15 00:45:24.000000', 'consum', 0.0223, 'lps'),
	(577941, 127, '2014-03-15 00:45:25.000000', 'consum', 0.0219, 'lps'),
	(577942, 127, '2014-03-15 00:45:26.000000', 'consum', 0.0217, 'lps'),
	(577943, 127, '2014-03-15 00:45:27.000000', 'consum', 0.0219, 'lps'),
	(577944, 127, '2014-03-15 00:45:28.000000', 'consum', 0.0218, 'lps'),
	(577945, 127, '2014-03-15 00:45:29.000000', 'consum', 0.0220, 'lps'),
	(577946, 127, '2014-03-15 00:45:30.000000', 'consum', 0.0222, 'lps'),
	(577947, 127, '2014-03-15 00:45:31.000000', 'consum', 0.0221, 'lps'),
	(577948, 127, '2014-03-15 00:45:32.000000', 'consum', 0.0227, 'lps'),
	(577949, 127, '2014-03-15 00:45:33.000000', 'consum', 0.0212, 'lps'),
	(577950, 127, '2014-03-15 00:45:34.000000', 'consum', 0.0222, 'lps'),
	(577951, 127, '2014-03-15 00:45:35.000000', 'consum', 0.0212, 'lps'),
	(577952, 127, '2014-03-15 00:45:36.000000', 'consum', 0.0221, 'lps'),
	(577953, 127, '2014-03-15 00:45:37.000000', 'consum', 0.0222, 'lps'),
	(577954, 127, '2014-03-15 00:45:38.000000', 'consum', 0.0218, 'lps'),
	(577955, 127, '2014-03-15 00:45:39.000000', 'consum', 0.0217, 'lps'),
	(577956, 127, '2014-03-15 00:45:40.000000', 'consum', 0.0219, 'lps'),
	(577957, 127, '2014-03-15 00:45:41.000000', 'consum', 0.0220, 'lps'),
	(577958, 127, '2014-03-15 00:45:42.000000', 'consum', 0.0212, 'lps'),
	(577959, 127, '2014-03-15 00:45:43.000000', 'consum', 0.0227, 'lps'),
	(577960, 127, '2014-03-15 00:45:44.000000', 'consum', 0.0217, 'lps'),
	(577961, 127, '2014-03-15 00:45:45.000000', 'consum', 0.0215, 'lps'),
	(577962, 127, '2014-03-15 00:45:46.000000', 'consum', 0.0213, 'lps'),
	(577963, 127, '2014-03-15 00:45:47.000000', 'consum', 0.0212, 'lps'),
	(577964, 127, '2014-03-15 00:45:48.000000', 'consum', 0.0211, 'lps'),
	(577965, 127, '2014-03-15 00:45:49.000000', 'consum', 0.0227, 'lps'),
	(577966, 127, '2014-03-15 00:45:50.000000', 'consum', 0.0221, 'lps'),
	(577967, 127, '2014-03-15 00:45:51.000000', 'consum', 0.0216, 'lps'),
	(577968, 127, '2014-03-15 00:45:52.000000', 'consum', 0.0226, 'lps'),
	(577969, 127, '2014-03-15 00:45:53.000000', 'consum', 0.0216, 'lps'),
	(577970, 127, '2014-03-15 00:45:54.000000', 'consum', 0.0210, 'lps'),
	(577971, 127, '2014-03-15 00:45:55.000000', 'consum', 0.0213, 'lps'),
	(577972, 127, '2014-03-15 00:45:56.000000', 'consum', 0.0225, 'lps'),
	(577973, 127, '2014-03-15 00:45:57.000000', 'consum', 0.0223, 'lps'),
	(577974, 127, '2014-03-15 00:45:58.000000', 'consum', 0.0213, 'lps'),
	(577975, 127, '2014-03-15 00:45:59.000000', 'consum', 0.0224, 'lps'),
	(577976, 127, '2014-03-15 00:46:00.000000', 'consum', 0.0215, 'lps'),
	(577977, 127, '2014-03-15 00:46:01.000000', 'consum', 0.0211, 'lps'),
	(577978, 127, '2014-03-15 00:46:02.000000', 'consum', 0.0219, 'lps'),
	(577979, 127, '2014-03-15 00:46:03.000000', 'consum', 0.0216, 'lps'),
	(577980, 127, '2014-03-15 00:46:04.000000', 'consum', 0.0213, 'lps'),
	(577981, 127, '2014-03-15 00:46:05.000000', 'consum', 0.0227, 'lps'),
	(577982, 127, '2014-03-15 00:46:06.000000', 'consum', 0.0216, 'lps'),
	(577983, 127, '2014-03-15 00:46:07.000000', 'consum', 0.0222, 'lps'),
	(577984, 127, '2014-03-15 00:46:08.000000', 'consum', 0.0218, 'lps'),
	(577985, 127, '2014-03-15 00:46:09.000000', 'consum', 0.0215, 'lps'),
	(577986, 127, '2014-03-15 00:46:10.000000', 'consum', 0.0213, 'lps'),
	(577987, 127, '2014-03-15 00:46:11.000000', 'consum', 0.0226, 'lps'),
	(577988, 127, '2014-03-15 00:46:12.000000', 'consum', 0.0226, 'lps'),
	(577989, 127, '2014-03-15 00:46:13.000000', 'consum', 0.0210, 'lps'),
	(577990, 127, '2014-03-15 00:46:14.000000', 'consum', 0.0215, 'lps'),
	(577991, 127, '2014-03-15 00:46:15.000000', 'consum', 0.0217, 'lps'),
	(577992, 127, '2014-03-15 00:46:16.000000', 'consum', 0.0213, 'lps'),
	(577993, 127, '2014-03-15 00:46:17.000000', 'consum', 0.0220, 'lps'),
	(577994, 127, '2014-03-15 00:46:18.000000', 'consum', 0.0219, 'lps'),
	(577995, 127, '2014-03-15 00:46:19.000000', 'consum', 0.0225, 'lps'),
	(577996, 127, '2014-03-15 00:46:20.000000', 'consum', 0.0222, 'lps'),
	(577997, 127, '2014-03-15 00:46:21.000000', 'consum', 0.0227, 'lps'),
	(577998, 127, '2014-03-15 00:46:22.000000', 'consum', 0.0222, 'lps'),
	(577999, 127, '2014-03-15 00:46:23.000000', 'consum', 0.0221, 'lps'),
	(578000, 127, '2014-03-15 00:46:24.000000', 'consum', 0.0212, 'lps'),
	(578001, 127, '2014-03-15 00:46:25.000000', 'consum', 0.0221, 'lps'),
	(578002, 127, '2014-03-15 00:46:26.000000', 'consum', 0.0224, 'lps'),
	(578003, 127, '2014-03-15 00:46:27.000000', 'consum', 0.0213, 'lps'),
	(578004, 127, '2014-03-15 00:46:28.000000', 'consum', 0.0219, 'lps'),
	(578005, 127, '2014-03-15 00:46:29.000000', 'consum', 0.0227, 'lps'),
	(578006, 127, '2014-03-15 00:46:30.000000', 'consum', 0.0216, 'lps'),
	(578007, 127, '2014-03-15 00:46:31.000000', 'consum', 0.0227, 'lps'),
	(578008, 127, '2014-03-15 00:46:32.000000', 'consum', 0.0222, 'lps'),
	(578009, 127, '2014-03-15 00:46:33.000000', 'consum', 0.0219, 'lps'),
	(578010, 127, '2014-03-15 00:46:34.000000', 'consum', 0.0221, 'lps'),
	(578011, 127, '2014-03-15 00:46:35.000000', 'consum', 0.0219, 'lps'),
	(578012, 127, '2014-03-15 00:46:36.000000', 'consum', 0.0221, 'lps'),
	(578013, 127, '2014-03-15 00:46:37.000000', 'consum', 0.0222, 'lps'),
	(578014, 127, '2014-03-15 00:46:38.000000', 'consum', 0.0219, 'lps'),
	(578015, 127, '2014-03-15 00:46:39.000000', 'consum', 0.0221, 'lps'),
	(578016, 127, '2014-03-15 00:46:40.000000', 'consum', 0.0218, 'lps'),
	(578017, 127, '2014-03-15 00:46:41.000000', 'consum', 0.0219, 'lps'),
	(578018, 127, '2014-03-15 00:46:42.000000', 'consum', 0.0214, 'lps'),
	(578019, 127, '2014-03-15 00:46:43.000000', 'consum', 0.0219, 'lps'),
	(578020, 127, '2014-03-15 00:46:44.000000', 'consum', 0.0226, 'lps'),
	(578021, 127, '2014-03-15 00:46:45.000000', 'consum', 0.0212, 'lps'),
	(578022, 127, '2014-03-15 00:46:46.000000', 'consum', 0.0226, 'lps'),
	(578023, 127, '2014-03-15 00:46:47.000000', 'consum', 0.0213, 'lps'),
	(578024, 127, '2014-03-15 00:46:48.000000', 'consum', 0.0214, 'lps'),
	(578025, 127, '2014-03-15 00:46:49.000000', 'consum', 0.0221, 'lps'),
	(578026, 127, '2014-03-15 00:46:50.000000', 'consum', 0.0216, 'lps'),
	(578027, 127, '2014-03-15 00:46:51.000000', 'consum', 0.0227, 'lps'),
	(578028, 127, '2014-03-15 00:46:52.000000', 'consum', 0.0225, 'lps'),
	(578029, 127, '2014-03-15 00:46:53.000000', 'consum', 0.0216, 'lps'),
	(578030, 127, '2014-03-15 00:46:54.000000', 'consum', 0.0212, 'lps'),
	(578031, 127, '2014-03-15 00:46:55.000000', 'consum', 0.0222, 'lps'),
	(578032, 127, '2014-03-15 00:46:56.000000', 'consum', 0.0210, 'lps'),
	(578033, 127, '2014-03-15 00:46:57.000000', 'consum', 0.0226, 'lps'),
	(578034, 127, '2014-03-15 00:46:58.000000', 'consum', 0.0222, 'lps'),
	(578035, 127, '2014-03-15 00:46:59.000000', 'consum', 0.0222, 'lps'),
	(578036, 127, '2014-03-15 00:47:00.000000', 'consum', 0.0216, 'lps'),
	(578037, 127, '2014-03-15 00:47:01.000000', 'consum', 0.0224, 'lps'),
	(578038, 127, '2014-03-15 00:47:02.000000', 'consum', 0.0226, 'lps'),
	(578039, 127, '2014-03-15 00:47:03.000000', 'consum', 0.0213, 'lps'),
	(578040, 127, '2014-03-15 00:47:04.000000', 'consum', 0.0212, 'lps'),
	(578041, 127, '2014-03-15 00:47:05.000000', 'consum', 0.0214, 'lps'),
	(578042, 127, '2014-03-15 00:47:06.000000', 'consum', 0.0222, 'lps'),
	(578043, 127, '2014-03-15 00:47:07.000000', 'consum', 0.0223, 'lps'),
	(578044, 127, '2014-03-15 00:47:08.000000', 'consum', 0.0222, 'lps'),
	(578045, 127, '2014-03-15 00:47:09.000000', 'consum', 0.0212, 'lps'),
	(578046, 127, '2014-03-15 00:47:10.000000', 'consum', 0.0220, 'lps'),
	(578047, 127, '2014-03-15 00:47:11.000000', 'consum', 0.0220, 'lps'),
	(578048, 127, '2014-03-15 00:47:12.000000', 'consum', 0.0214, 'lps'),
	(578049, 127, '2014-03-15 00:47:13.000000', 'consum', 0.0216, 'lps'),
	(578050, 127, '2014-03-15 00:47:14.000000', 'consum', 0.0210, 'lps'),
	(578051, 127, '2014-03-15 00:47:15.000000', 'consum', 0.0212, 'lps'),
	(578052, 127, '2014-03-15 00:47:16.000000', 'consum', 0.0221, 'lps'),
	(578053, 127, '2014-03-15 00:47:17.000000', 'consum', 0.0224, 'lps'),
	(578054, 127, '2014-03-15 00:47:18.000000', 'consum', 0.0210, 'lps'),
	(578055, 127, '2014-03-15 00:47:19.000000', 'consum', 0.0222, 'lps'),
	(578056, 127, '2014-03-15 00:47:20.000000', 'consum', 0.0215, 'lps'),
	(578057, 127, '2014-03-15 00:47:21.000000', 'consum', 0.0221, 'lps'),
	(578058, 127, '2014-03-15 00:47:22.000000', 'consum', 0.0213, 'lps'),
	(578059, 127, '2014-03-15 00:47:23.000000', 'consum', 0.0227, 'lps'),
	(578060, 127, '2014-03-15 00:47:24.000000', 'consum', 0.0214, 'lps'),
	(578061, 127, '2014-03-15 00:47:25.000000', 'consum', 0.0216, 'lps'),
	(578062, 127, '2014-03-15 00:47:26.000000', 'consum', 0.0213, 'lps'),
	(578063, 127, '2014-03-15 00:47:27.000000', 'consum', 0.0223, 'lps'),
	(578064, 127, '2014-03-15 00:47:28.000000', 'consum', 0.0213, 'lps'),
	(578065, 127, '2014-03-15 00:47:29.000000', 'consum', 0.0223, 'lps'),
	(578066, 127, '2014-03-15 00:47:30.000000', 'consum', 0.0212, 'lps'),
	(578067, 127, '2014-03-15 00:47:31.000000', 'consum', 0.0218, 'lps'),
	(578068, 127, '2014-03-15 00:47:32.000000', 'consum', 0.0226, 'lps'),
	(578069, 127, '2014-03-15 00:47:33.000000', 'consum', 0.0215, 'lps'),
	(578070, 127, '2014-03-15 00:47:34.000000', 'consum', 0.0220, 'lps'),
	(578071, 127, '2014-03-15 00:47:35.000000', 'consum', 0.0211, 'lps'),
	(578072, 127, '2014-03-15 00:47:36.000000', 'consum', 0.0221, 'lps'),
	(578073, 127, '2014-03-15 00:47:37.000000', 'consum', 0.0225, 'lps'),
	(578074, 127, '2014-03-15 00:47:38.000000', 'consum', 0.0219, 'lps'),
	(578075, 127, '2014-03-15 00:47:39.000000', 'consum', 0.0227, 'lps'),
	(578076, 127, '2014-03-15 00:47:40.000000', 'consum', 0.0214, 'lps'),
	(578077, 127, '2014-03-15 00:47:41.000000', 'consum', 0.0217, 'lps'),
	(578078, 127, '2014-03-15 00:47:42.000000', 'consum', 0.0217, 'lps'),
	(578079, 127, '2014-03-15 00:47:43.000000', 'consum', 0.0223, 'lps'),
	(578080, 127, '2014-03-15 00:47:44.000000', 'consum', 0.0217, 'lps'),
	(578081, 127, '2014-03-15 00:47:45.000000', 'consum', 0.0226, 'lps'),
	(578082, 127, '2014-03-15 00:47:46.000000', 'consum', 0.0214, 'lps'),
	(578083, 127, '2014-03-15 00:47:47.000000', 'consum', 0.0220, 'lps'),
	(578084, 127, '2014-03-15 00:47:48.000000', 'consum', 0.0210, 'lps'),
	(578085, 127, '2014-03-15 00:47:49.000000', 'consum', 0.0218, 'lps'),
	(578086, 127, '2014-03-15 00:47:50.000000', 'consum', 0.0216, 'lps'),
	(578087, 127, '2014-03-15 00:47:51.000000', 'consum', 0.0216, 'lps'),
	(578088, 127, '2014-03-15 00:47:52.000000', 'consum', 0.0224, 'lps'),
	(578089, 127, '2014-03-15 00:47:53.000000', 'consum', 0.0224, 'lps'),
	(578090, 127, '2014-03-15 00:47:54.000000', 'consum', 0.0222, 'lps'),
	(578091, 127, '2014-03-15 00:47:55.000000', 'consum', 0.0211, 'lps'),
	(578092, 127, '2014-03-15 00:47:56.000000', 'consum', 0.0215, 'lps'),
	(578093, 127, '2014-03-15 00:47:57.000000', 'consum', 0.0216, 'lps'),
	(578094, 127, '2014-03-15 00:47:58.000000', 'consum', 0.0226, 'lps'),
	(578095, 127, '2014-03-15 00:47:59.000000', 'consum', 0.0219, 'lps'),
	(578096, 127, '2014-03-15 00:48:00.000000', 'consum', 0.0223, 'lps'),
	(578097, 127, '2014-03-15 00:48:01.000000', 'consum', 0.0212, 'lps'),
	(578098, 127, '2014-03-15 00:48:02.000000', 'consum', 0.0216, 'lps'),
	(578099, 127, '2014-03-15 00:48:03.000000', 'consum', 0.0220, 'lps'),
	(578100, 127, '2014-03-15 00:48:04.000000', 'consum', 0.0225, 'lps'),
	(578101, 127, '2014-03-15 00:48:05.000000', 'consum', 0.0218, 'lps'),
	(578102, 127, '2014-03-15 00:48:06.000000', 'consum', 0.0222, 'lps'),
	(578103, 127, '2014-03-15 00:48:07.000000', 'consum', 0.0212, 'lps'),
	(578104, 127, '2014-03-15 00:48:08.000000', 'consum', 0.0219, 'lps'),
	(578105, 127, '2014-03-15 00:48:09.000000', 'consum', 0.0213, 'lps'),
	(578106, 127, '2014-03-15 00:48:10.000000', 'consum', 0.0218, 'lps'),
	(578107, 127, '2014-03-15 00:48:11.000000', 'consum', 0.0222, 'lps'),
	(578108, 127, '2014-03-15 00:48:12.000000', 'consum', 0.0212, 'lps'),
	(578109, 127, '2014-03-15 00:48:13.000000', 'consum', 0.0220, 'lps'),
	(578110, 127, '2014-03-15 00:48:14.000000', 'consum', 0.0220, 'lps'),
	(578111, 127, '2014-03-15 00:48:15.000000', 'consum', 0.0212, 'lps'),
	(578112, 127, '2014-03-15 00:48:16.000000', 'consum', 0.0225, 'lps'),
	(578113, 127, '2014-03-15 00:48:17.000000', 'consum', 0.0227, 'lps'),
	(578114, 127, '2014-03-15 00:48:18.000000', 'consum', 0.0216, 'lps'),
	(578115, 127, '2014-03-15 00:48:19.000000', 'consum', 0.0224, 'lps'),
	(578116, 127, '2014-03-15 00:48:20.000000', 'consum', 0.0210, 'lps'),
	(578117, 127, '2014-03-15 00:48:21.000000', 'consum', 0.0222, 'lps'),
	(578118, 127, '2014-03-15 00:48:22.000000', 'consum', 0.0217, 'lps'),
	(578119, 127, '2014-03-15 00:48:23.000000', 'consum', 0.0227, 'lps'),
	(578120, 127, '2014-03-15 00:48:24.000000', 'consum', 0.0219, 'lps'),
	(578121, 127, '2014-03-15 00:48:25.000000', 'consum', 0.0221, 'lps'),
	(578122, 127, '2014-03-15 00:48:26.000000', 'consum', 0.0224, 'lps'),
	(578123, 127, '2014-03-15 00:48:27.000000', 'consum', 0.0210, 'lps'),
	(578124, 127, '2014-03-15 00:48:28.000000', 'consum', 0.0222, 'lps'),
	(578125, 127, '2014-03-15 00:48:29.000000', 'consum', 0.0218, 'lps'),
	(578126, 127, '2014-03-15 00:48:30.000000', 'consum', 0.0213, 'lps'),
	(578127, 127, '2014-03-15 00:48:31.000000', 'consum', 0.0220, 'lps'),
	(578128, 127, '2014-03-15 00:48:32.000000', 'consum', 0.0218, 'lps'),
	(578129, 127, '2014-03-15 00:48:33.000000', 'consum', 0.0217, 'lps'),
	(578130, 127, '2014-03-15 00:48:34.000000', 'consum', 0.0225, 'lps'),
	(578131, 127, '2014-03-15 00:48:35.000000', 'consum', 0.0225, 'lps'),
	(578132, 127, '2014-03-15 00:48:36.000000', 'consum', 0.0224, 'lps'),
	(578133, 127, '2014-03-15 00:48:37.000000', 'consum', 0.0219, 'lps'),
	(578134, 127, '2014-03-15 00:48:38.000000', 'consum', 0.0213, 'lps'),
	(578135, 127, '2014-03-15 00:48:39.000000', 'consum', 0.0218, 'lps'),
	(578136, 127, '2014-03-15 00:48:40.000000', 'consum', 0.0222, 'lps'),
	(578137, 127, '2014-03-15 00:48:41.000000', 'consum', 0.0227, 'lps'),
	(578138, 127, '2014-03-15 00:48:42.000000', 'consum', 0.0224, 'lps'),
	(578139, 127, '2014-03-15 00:48:43.000000', 'consum', 0.0212, 'lps'),
	(578140, 127, '2014-03-15 00:48:44.000000', 'consum', 0.0216, 'lps'),
	(578141, 127, '2014-03-15 00:48:45.000000', 'consum', 0.0215, 'lps'),
	(578142, 127, '2014-03-15 00:48:46.000000', 'consum', 0.0219, 'lps'),
	(578143, 127, '2014-03-15 00:48:47.000000', 'consum', 0.0223, 'lps'),
	(578144, 127, '2014-03-15 00:48:48.000000', 'consum', 0.0213, 'lps'),
	(578145, 127, '2014-03-15 00:48:49.000000', 'consum', 0.0222, 'lps'),
	(578146, 127, '2014-03-15 00:48:50.000000', 'consum', 0.0224, 'lps'),
	(578147, 127, '2014-03-15 00:48:51.000000', 'consum', 0.0211, 'lps'),
	(578148, 127, '2014-03-15 00:48:52.000000', 'consum', 0.0224, 'lps'),
	(578149, 127, '2014-03-15 00:48:53.000000', 'consum', 0.0226, 'lps'),
	(578150, 127, '2014-03-15 00:48:54.000000', 'consum', 0.0212, 'lps'),
	(578151, 127, '2014-03-15 00:48:55.000000', 'consum', 0.0225, 'lps'),
	(578152, 127, '2014-03-15 00:48:56.000000', 'consum', 0.0226, 'lps'),
	(578153, 127, '2014-03-15 00:48:57.000000', 'consum', 0.0227, 'lps'),
	(578154, 127, '2014-03-15 00:48:58.000000', 'consum', 0.0210, 'lps'),
	(578155, 127, '2014-03-15 00:48:59.000000', 'consum', 0.0215, 'lps'),
	(578156, 127, '2014-03-15 00:49:00.000000', 'consum', 0.0219, 'lps'),
	(578157, 127, '2014-03-15 00:49:01.000000', 'consum', 0.0222, 'lps'),
	(578158, 127, '2014-03-15 00:49:02.000000', 'consum', 0.0225, 'lps'),
	(578159, 127, '2014-03-15 00:49:03.000000', 'consum', 0.0214, 'lps'),
	(578160, 127, '2014-03-15 00:49:04.000000', 'consum', 0.0222, 'lps'),
	(578161, 127, '2014-03-15 00:49:05.000000', 'consum', 0.0221, 'lps'),
	(578162, 127, '2014-03-15 00:49:06.000000', 'consum', 0.0211, 'lps'),
	(578163, 127, '2014-03-15 00:49:07.000000', 'consum', 0.0218, 'lps'),
	(578164, 127, '2014-03-15 00:49:08.000000', 'consum', 0.0210, 'lps'),
	(578165, 127, '2014-03-15 00:49:09.000000', 'consum', 0.0226, 'lps'),
	(578166, 127, '2014-03-15 00:49:10.000000', 'consum', 0.0217, 'lps'),
	(578167, 127, '2014-03-15 00:49:11.000000', 'consum', 0.0214, 'lps'),
	(578168, 127, '2014-03-15 00:49:12.000000', 'consum', 0.0212, 'lps'),
	(578169, 127, '2014-03-15 00:49:13.000000', 'consum', 0.0227, 'lps'),
	(578170, 127, '2014-03-15 00:49:14.000000', 'consum', 0.0217, 'lps'),
	(578171, 127, '2014-03-15 00:49:15.000000', 'consum', 0.0213, 'lps'),
	(578172, 127, '2014-03-15 00:49:16.000000', 'consum', 0.0223, 'lps'),
	(578173, 127, '2014-03-15 00:49:17.000000', 'consum', 0.0212, 'lps'),
	(578174, 127, '2014-03-15 00:49:18.000000', 'consum', 0.0218, 'lps'),
	(578175, 127, '2014-03-15 00:49:19.000000', 'consum', 0.0227, 'lps'),
	(578176, 127, '2014-03-15 00:49:20.000000', 'consum', 0.0217, 'lps'),
	(578177, 127, '2014-03-15 00:49:21.000000', 'consum', 0.0212, 'lps'),
	(578178, 127, '2014-03-15 00:49:22.000000', 'consum', 0.0216, 'lps'),
	(578179, 127, '2014-03-15 00:49:23.000000', 'consum', 0.0220, 'lps'),
	(578180, 127, '2014-03-15 00:49:24.000000', 'consum', 0.0222, 'lps'),
	(578181, 127, '2014-03-15 00:49:25.000000', 'consum', 0.0222, 'lps'),
	(578182, 127, '2014-03-15 00:49:26.000000', 'consum', 0.0217, 'lps'),
	(578183, 127, '2014-03-15 00:49:27.000000', 'consum', 0.0226, 'lps'),
	(578184, 127, '2014-03-15 00:49:28.000000', 'consum', 0.0217, 'lps'),
	(578185, 127, '2014-03-15 00:49:29.000000', 'consum', 0.0216, 'lps'),
	(578186, 127, '2014-03-15 00:49:30.000000', 'consum', 0.0221, 'lps'),
	(578187, 127, '2014-03-15 00:49:31.000000', 'consum', 0.0210, 'lps'),
	(578188, 127, '2014-03-15 00:49:32.000000', 'consum', 0.0213, 'lps'),
	(578189, 127, '2014-03-15 00:49:33.000000', 'consum', 0.0225, 'lps'),
	(578190, 127, '2014-03-15 00:49:34.000000', 'consum', 0.0225, 'lps'),
	(578191, 127, '2014-03-15 00:49:35.000000', 'consum', 0.0219, 'lps'),
	(578192, 127, '2014-03-15 00:49:36.000000', 'consum', 0.0213, 'lps'),
	(578193, 127, '2014-03-15 00:49:37.000000', 'consum', 0.0216, 'lps'),
	(578194, 127, '2014-03-15 00:49:38.000000', 'consum', 0.0214, 'lps'),
	(578195, 127, '2014-03-15 00:49:39.000000', 'consum', 0.0210, 'lps'),
	(578196, 127, '2014-03-15 00:49:40.000000', 'consum', 0.0218, 'lps'),
	(578197, 127, '2014-03-15 00:49:41.000000', 'consum', 0.0213, 'lps'),
	(578198, 127, '2014-03-15 00:49:42.000000', 'consum', 0.0221, 'lps'),
	(578199, 127, '2014-03-15 00:49:43.000000', 'consum', 0.0221, 'lps'),
	(578200, 127, '2014-03-15 00:49:44.000000', 'consum', 0.0212, 'lps'),
	(578201, 127, '2014-03-15 00:49:45.000000', 'consum', 0.0226, 'lps'),
	(578202, 127, '2014-03-15 00:49:46.000000', 'consum', 0.0211, 'lps'),
	(578203, 127, '2014-03-15 00:49:47.000000', 'consum', 0.0222, 'lps'),
	(578204, 127, '2014-03-15 00:49:48.000000', 'consum', 0.0212, 'lps'),
	(578205, 127, '2014-03-15 00:49:49.000000', 'consum', 0.0220, 'lps'),
	(578206, 127, '2014-03-15 00:49:50.000000', 'consum', 0.0218, 'lps'),
	(578207, 127, '2014-03-15 00:49:51.000000', 'consum', 0.0220, 'lps'),
	(578208, 127, '2014-03-15 00:49:52.000000', 'consum', 0.0220, 'lps'),
	(578209, 127, '2014-03-15 00:49:53.000000', 'consum', 0.0214, 'lps'),
	(578210, 127, '2014-03-15 00:49:54.000000', 'consum', 0.0216, 'lps'),
	(578211, 127, '2014-03-15 00:49:55.000000', 'consum', 0.0213, 'lps'),
	(578212, 127, '2014-03-15 00:49:56.000000', 'consum', 0.0225, 'lps'),
	(578213, 127, '2014-03-15 00:49:57.000000', 'consum', 0.0221, 'lps'),
	(578214, 127, '2014-03-15 00:49:58.000000', 'consum', 0.0223, 'lps'),
	(578215, 127, '2014-03-15 00:49:59.000000', 'consum', 0.0222, 'lps'),
	(578216, 127, '2014-03-15 00:50:00.000000', 'consum', 0.0213, 'lps'),
	(578217, 127, '2014-03-15 00:50:01.000000', 'consum', 0.0227, 'lps'),
	(578218, 127, '2014-03-15 00:50:02.000000', 'consum', 0.0216, 'lps'),
	(578219, 127, '2014-03-15 00:50:03.000000', 'consum', 0.0223, 'lps'),
	(578220, 127, '2014-03-15 00:50:04.000000', 'consum', 0.0222, 'lps'),
	(578221, 127, '2014-03-15 00:50:05.000000', 'consum', 0.0214, 'lps'),
	(578222, 127, '2014-03-15 00:50:06.000000', 'consum', 0.0212, 'lps'),
	(578223, 127, '2014-03-15 00:50:07.000000', 'consum', 0.0210, 'lps'),
	(578224, 127, '2014-03-15 00:50:08.000000', 'consum', 0.0222, 'lps'),
	(578225, 127, '2014-03-15 00:50:09.000000', 'consum', 0.0216, 'lps'),
	(578226, 127, '2014-03-15 00:50:10.000000', 'consum', 0.0224, 'lps'),
	(578227, 127, '2014-03-15 00:50:11.000000', 'consum', 0.0227, 'lps'),
	(578228, 127, '2014-03-15 00:50:12.000000', 'consum', 0.0215, 'lps'),
	(578229, 127, '2014-03-15 00:50:13.000000', 'consum', 0.0223, 'lps'),
	(578230, 127, '2014-03-15 00:50:14.000000', 'consum', 0.0222, 'lps'),
	(578231, 127, '2014-03-15 00:50:15.000000', 'consum', 0.0215, 'lps'),
	(578232, 127, '2014-03-15 00:50:16.000000', 'consum', 0.0219, 'lps'),
	(578233, 127, '2014-03-15 00:50:17.000000', 'consum', 0.0223, 'lps'),
	(578234, 127, '2014-03-15 00:50:18.000000', 'consum', 0.0227, 'lps'),
	(578235, 127, '2014-03-15 00:50:19.000000', 'consum', 0.0224, 'lps'),
	(578236, 127, '2014-03-15 00:50:20.000000', 'consum', 0.0210, 'lps'),
	(578237, 127, '2014-03-15 00:50:21.000000', 'consum', 0.0224, 'lps'),
	(578238, 127, '2014-03-15 00:50:22.000000', 'consum', 0.0225, 'lps'),
	(578239, 127, '2014-03-15 00:50:23.000000', 'consum', 0.0227, 'lps'),
	(578240, 127, '2014-03-15 00:50:24.000000', 'consum', 0.0212, 'lps'),
	(578241, 127, '2014-03-15 00:50:25.000000', 'consum', 0.0225, 'lps'),
	(578242, 127, '2014-03-15 00:50:26.000000', 'consum', 0.0225, 'lps'),
	(578243, 127, '2014-03-15 00:50:27.000000', 'consum', 0.0224, 'lps'),
	(578244, 127, '2014-03-15 00:50:28.000000', 'consum', 0.0216, 'lps'),
	(578245, 127, '2014-03-15 00:50:29.000000', 'consum', 0.0218, 'lps'),
	(578246, 127, '2014-03-15 00:50:30.000000', 'consum', 0.0213, 'lps'),
	(578247, 127, '2014-03-15 00:50:31.000000', 'consum', 0.0221, 'lps'),
	(578248, 127, '2014-03-15 00:50:32.000000', 'consum', 0.0219, 'lps'),
	(578249, 127, '2014-03-15 00:50:33.000000', 'consum', 0.0224, 'lps'),
	(578250, 127, '2014-03-15 00:50:34.000000', 'consum', 0.0215, 'lps'),
	(578251, 127, '2014-03-15 00:50:35.000000', 'consum', 0.0213, 'lps'),
	(578252, 127, '2014-03-15 00:50:36.000000', 'consum', 0.0212, 'lps'),
	(578253, 127, '2014-03-15 00:50:37.000000', 'consum', 0.0211, 'lps'),
	(578254, 127, '2014-03-15 00:50:38.000000', 'consum', 0.0211, 'lps'),
	(578255, 127, '2014-03-15 00:50:39.000000', 'consum', 0.0211, 'lps'),
	(578256, 127, '2014-03-15 00:50:40.000000', 'consum', 0.0213, 'lps'),
	(578257, 127, '2014-03-15 00:50:41.000000', 'consum', 0.0220, 'lps'),
	(578258, 127, '2014-03-15 00:50:42.000000', 'consum', 0.0218, 'lps'),
	(578259, 127, '2014-03-15 00:50:43.000000', 'consum', 0.0220, 'lps'),
	(578260, 127, '2014-03-15 00:50:44.000000', 'consum', 0.0217, 'lps'),
	(578261, 127, '2014-03-15 00:50:45.000000', 'consum', 0.0217, 'lps'),
	(578262, 127, '2014-03-15 00:50:46.000000', 'consum', 0.0225, 'lps'),
	(578263, 127, '2014-03-15 00:50:47.000000', 'consum', 0.0212, 'lps'),
	(578264, 127, '2014-03-15 00:50:48.000000', 'consum', 0.0227, 'lps'),
	(578265, 127, '2014-03-15 00:50:49.000000', 'consum', 0.0220, 'lps'),
	(578266, 127, '2014-03-15 00:50:50.000000', 'consum', 0.0226, 'lps'),
	(578267, 127, '2014-03-15 00:50:51.000000', 'consum', 0.0225, 'lps'),
	(578268, 127, '2014-03-15 00:50:52.000000', 'consum', 0.0221, 'lps'),
	(578269, 127, '2014-03-15 00:50:53.000000', 'consum', 0.0220, 'lps'),
	(578270, 127, '2014-03-15 00:50:54.000000', 'consum', 0.0227, 'lps'),
	(578271, 127, '2014-03-15 00:50:55.000000', 'consum', 0.0212, 'lps'),
	(578272, 127, '2014-03-15 00:50:56.000000', 'consum', 0.0224, 'lps'),
	(578273, 127, '2014-03-15 00:50:57.000000', 'consum', 0.0218, 'lps'),
	(578274, 128, '2014-03-15 00:00:00.000000', 'consum', 0.0212, 'lps'),
	(578275, 128, '2014-03-15 00:00:01.000000', 'consum', 0.0215, 'lps'),
	(578276, 128, '2014-03-15 00:00:02.000000', 'consum', 0.0218, 'lps'),
	(578277, 128, '2014-03-15 00:00:03.000000', 'consum', 0.0214, 'lps'),
	(578278, 128, '2014-03-15 00:00:04.000000', 'consum', 0.0219, 'lps'),
	(578279, 128, '2014-03-15 00:00:05.000000', 'consum', 0.0220, 'lps'),
	(578280, 128, '2014-03-15 00:00:06.000000', 'consum', 0.0213, 'lps'),
	(578281, 128, '2014-03-15 00:00:07.000000', 'consum', 0.0217, 'lps'),
	(578282, 128, '2014-03-15 00:00:08.000000', 'consum', 0.0215, 'lps'),
	(578283, 128, '2014-03-15 00:00:09.000000', 'consum', 0.0215, 'lps'),
	(578284, 128, '2014-03-15 00:00:10.000000', 'consum', 0.0211, 'lps'),
	(578285, 128, '2014-03-15 00:00:11.000000', 'consum', 0.0220, 'lps'),
	(578286, 128, '2014-03-15 00:00:12.000000', 'consum', 0.0214, 'lps'),
	(578287, 128, '2014-03-15 00:00:13.000000', 'consum', 0.0211, 'lps'),
	(578288, 128, '2014-03-15 00:00:14.000000', 'consum', 0.0217, 'lps'),
	(578289, 128, '2014-03-15 00:00:15.000000', 'consum', 0.0218, 'lps'),
	(578290, 128, '2014-03-15 00:00:16.000000', 'consum', 0.0219, 'lps'),
	(578291, 128, '2014-03-15 00:00:17.000000', 'consum', 0.0220, 'lps'),
	(578292, 128, '2014-03-15 00:00:18.000000', 'consum', 0.0212, 'lps'),
	(578293, 128, '2014-03-15 00:00:19.000000', 'consum', 0.0215, 'lps'),
	(578294, 128, '2014-03-15 00:00:20.000000', 'consum', 0.0215, 'lps'),
	(578295, 128, '2014-03-15 00:00:21.000000', 'consum', 0.0211, 'lps'),
	(578296, 128, '2014-03-15 00:00:22.000000', 'consum', 0.0211, 'lps'),
	(578297, 128, '2014-03-15 00:00:23.000000', 'consum', 0.0213, 'lps'),
	(578298, 128, '2014-03-15 00:00:24.000000', 'consum', 0.0210, 'lps'),
	(578299, 128, '2014-03-15 00:00:25.000000', 'consum', 0.0214, 'lps'),
	(578300, 128, '2014-03-15 00:00:26.000000', 'consum', 0.0220, 'lps'),
	(578301, 128, '2014-03-15 00:00:27.000000', 'consum', 0.0215, 'lps'),
	(578302, 128, '2014-03-15 00:00:28.000000', 'consum', 0.0214, 'lps'),
	(578303, 128, '2014-03-15 00:00:29.000000', 'consum', 0.0219, 'lps'),
	(578304, 128, '2014-03-15 00:00:30.000000', 'consum', 0.0210, 'lps'),
	(578305, 128, '2014-03-15 00:00:31.000000', 'consum', 0.0217, 'lps'),
	(578306, 128, '2014-03-15 00:00:32.000000', 'consum', 0.0211, 'lps'),
	(578307, 128, '2014-03-15 00:00:33.000000', 'consum', 0.0218, 'lps'),
	(578308, 128, '2014-03-15 00:00:34.000000', 'consum', 0.0215, 'lps'),
	(578309, 128, '2014-03-15 00:00:35.000000', 'consum', 0.0211, 'lps'),
	(578310, 128, '2014-03-15 00:00:36.000000', 'consum', 0.0212, 'lps'),
	(578311, 128, '2014-03-15 00:00:37.000000', 'consum', 0.0219, 'lps'),
	(578312, 128, '2014-03-15 00:00:38.000000', 'consum', 0.0215, 'lps'),
	(578313, 128, '2014-03-15 00:00:39.000000', 'consum', 0.0219, 'lps'),
	(578314, 128, '2014-03-15 00:00:40.000000', 'consum', 0.0218, 'lps'),
	(578315, 128, '2014-03-15 00:00:41.000000', 'consum', 0.0215, 'lps'),
	(578316, 128, '2014-03-15 00:00:42.000000', 'consum', 0.0211, 'lps'),
	(578317, 128, '2014-03-15 00:00:43.000000', 'consum', 0.0210, 'lps'),
	(578318, 128, '2014-03-15 00:00:44.000000', 'consum', 0.0219, 'lps'),
	(578319, 128, '2014-03-15 00:00:45.000000', 'consum', 0.0213, 'lps'),
	(578320, 128, '2014-03-15 00:00:46.000000', 'consum', 0.0220, 'lps'),
	(578321, 128, '2014-03-15 00:00:47.000000', 'consum', 0.0216, 'lps'),
	(578322, 128, '2014-03-15 00:00:48.000000', 'consum', 0.0212, 'lps'),
	(578323, 128, '2014-03-15 00:00:49.000000', 'consum', 0.0216, 'lps'),
	(578324, 128, '2014-03-15 00:00:50.000000', 'consum', 0.0220, 'lps'),
	(578325, 128, '2014-03-15 00:00:51.000000', 'consum', 0.0210, 'lps'),
	(578326, 128, '2014-03-15 00:00:52.000000', 'consum', 0.0214, 'lps'),
	(578327, 128, '2014-03-15 00:00:53.000000', 'consum', 0.0217, 'lps'),
	(578328, 128, '2014-03-15 00:00:54.000000', 'consum', 0.0215, 'lps'),
	(578329, 128, '2014-03-15 00:00:55.000000', 'consum', 0.0215, 'lps'),
	(578330, 128, '2014-03-15 00:00:56.000000', 'consum', 0.0219, 'lps'),
	(578331, 128, '2014-03-15 00:00:57.000000', 'consum', 0.0219, 'lps'),
	(578332, 128, '2014-03-15 00:00:58.000000', 'consum', 0.0216, 'lps'),
	(578333, 128, '2014-03-15 00:00:59.000000', 'consum', 0.0212, 'lps'),
	(578334, 128, '2014-03-15 00:01:00.000000', 'consum', 0.0217, 'lps'),
	(578335, 128, '2014-03-15 00:01:01.000000', 'consum', 0.0217, 'lps'),
	(578336, 128, '2014-03-15 00:01:02.000000', 'consum', 0.0212, 'lps'),
	(578337, 128, '2014-03-15 00:01:03.000000', 'consum', 0.0211, 'lps'),
	(578338, 128, '2014-03-15 00:01:04.000000', 'consum', 0.0220, 'lps'),
	(578339, 128, '2014-03-15 00:01:05.000000', 'consum', 0.0216, 'lps'),
	(578340, 128, '2014-03-15 00:01:06.000000', 'consum', 0.0219, 'lps'),
	(578341, 128, '2014-03-15 00:01:07.000000', 'consum', 0.0218, 'lps'),
	(578342, 128, '2014-03-15 00:01:08.000000', 'consum', 0.0211, 'lps'),
	(578343, 128, '2014-03-15 00:01:09.000000', 'consum', 0.0213, 'lps'),
	(578344, 128, '2014-03-15 00:01:10.000000', 'consum', 0.0214, 'lps'),
	(578345, 128, '2014-03-15 00:01:11.000000', 'consum', 0.0220, 'lps'),
	(578346, 128, '2014-03-15 00:01:12.000000', 'consum', 0.0214, 'lps'),
	(578347, 128, '2014-03-15 00:01:13.000000', 'consum', 0.0212, 'lps'),
	(578348, 128, '2014-03-15 00:01:14.000000', 'consum', 0.0220, 'lps'),
	(578349, 128, '2014-03-15 00:01:15.000000', 'consum', 0.0220, 'lps'),
	(578350, 128, '2014-03-15 00:01:16.000000', 'consum', 0.0211, 'lps'),
	(578351, 128, '2014-03-15 00:01:17.000000', 'consum', 0.0217, 'lps'),
	(578352, 128, '2014-03-15 00:01:18.000000', 'consum', 0.0210, 'lps'),
	(578353, 128, '2014-03-15 00:01:19.000000', 'consum', 0.0210, 'lps'),
	(578354, 128, '2014-03-15 00:01:20.000000', 'consum', 0.0211, 'lps'),
	(578355, 128, '2014-03-15 00:01:21.000000', 'consum', 0.0218, 'lps'),
	(578356, 128, '2014-03-15 00:01:22.000000', 'consum', 0.0211, 'lps'),
	(578357, 128, '2014-03-15 00:01:23.000000', 'consum', 0.0214, 'lps'),
	(578358, 128, '2014-03-15 00:01:24.000000', 'consum', 0.0218, 'lps'),
	(578359, 128, '2014-03-15 00:01:25.000000', 'consum', 0.0216, 'lps'),
	(578360, 128, '2014-03-15 00:01:26.000000', 'consum', 0.0215, 'lps'),
	(578361, 128, '2014-03-15 00:01:27.000000', 'consum', 0.0218, 'lps'),
	(578362, 128, '2014-03-15 00:01:28.000000', 'consum', 0.0213, 'lps'),
	(578363, 128, '2014-03-15 00:01:29.000000', 'consum', 0.0214, 'lps'),
	(578364, 128, '2014-03-15 00:01:30.000000', 'consum', 0.0212, 'lps'),
	(578365, 128, '2014-03-15 00:01:31.000000', 'consum', 0.0217, 'lps'),
	(578366, 128, '2014-03-15 00:01:32.000000', 'consum', 0.0218, 'lps'),
	(578367, 128, '2014-03-15 00:01:33.000000', 'consum', 0.0219, 'lps'),
	(578368, 128, '2014-03-15 00:01:34.000000', 'consum', 0.0220, 'lps'),
	(578369, 128, '2014-03-15 00:01:35.000000', 'consum', 0.0210, 'lps'),
	(578370, 128, '2014-03-15 00:01:36.000000', 'consum', 0.0216, 'lps'),
	(578371, 128, '2014-03-15 00:01:37.000000', 'consum', 0.0219, 'lps'),
	(578372, 128, '2014-03-15 00:01:38.000000', 'consum', 0.0213, 'lps'),
	(578373, 128, '2014-03-15 00:01:39.000000', 'consum', 0.0220, 'lps'),
	(578374, 128, '2014-03-15 00:01:40.000000', 'consum', 0.0210, 'lps'),
	(578375, 128, '2014-03-15 00:01:41.000000', 'consum', 0.0214, 'lps'),
	(578376, 128, '2014-03-15 00:01:42.000000', 'consum', 0.0218, 'lps'),
	(578377, 128, '2014-03-15 00:01:43.000000', 'consum', 0.0218, 'lps'),
	(578378, 128, '2014-03-15 00:01:44.000000', 'consum', 0.0213, 'lps'),
	(578379, 128, '2014-03-15 00:01:45.000000', 'consum', 0.0216, 'lps'),
	(578380, 128, '2014-03-15 00:01:46.000000', 'consum', 0.0218, 'lps'),
	(578381, 128, '2014-03-15 00:01:47.000000', 'consum', 0.0220, 'lps'),
	(578382, 128, '2014-03-15 00:01:48.000000', 'consum', 0.0218, 'lps'),
	(578383, 128, '2014-03-15 00:01:49.000000', 'consum', 0.0219, 'lps'),
	(578384, 128, '2014-03-15 00:01:50.000000', 'consum', 0.0220, 'lps'),
	(578385, 128, '2014-03-15 00:01:51.000000', 'consum', 0.0212, 'lps'),
	(578386, 128, '2014-03-15 00:01:52.000000', 'consum', 0.0213, 'lps'),
	(578387, 128, '2014-03-15 00:01:53.000000', 'consum', 0.0218, 'lps'),
	(578388, 128, '2014-03-15 00:01:54.000000', 'consum', 0.0210, 'lps'),
	(578389, 128, '2014-03-15 00:01:55.000000', 'consum', 0.0217, 'lps'),
	(578390, 128, '2014-03-15 00:01:56.000000', 'consum', 0.0216, 'lps'),
	(578391, 128, '2014-03-15 00:01:57.000000', 'consum', 0.0218, 'lps'),
	(578392, 128, '2014-03-15 00:01:58.000000', 'consum', 0.0220, 'lps'),
	(578393, 128, '2014-03-15 00:01:59.000000', 'consum', 0.0215, 'lps'),
	(578394, 128, '2014-03-15 00:02:00.000000', 'consum', 0.0216, 'lps'),
	(578395, 128, '2014-03-15 00:02:01.000000', 'consum', 0.0217, 'lps'),
	(578396, 128, '2014-03-15 00:02:02.000000', 'consum', 0.0216, 'lps'),
	(578397, 128, '2014-03-15 00:02:03.000000', 'consum', 0.0217, 'lps'),
	(578398, 128, '2014-03-15 00:02:04.000000', 'consum', 0.0219, 'lps'),
	(578399, 128, '2014-03-15 00:02:05.000000', 'consum', 0.0210, 'lps'),
	(578400, 128, '2014-03-15 00:02:06.000000', 'consum', 0.0217, 'lps'),
	(578401, 128, '2014-03-15 00:02:07.000000', 'consum', 0.0214, 'lps'),
	(578402, 128, '2014-03-15 00:02:08.000000', 'consum', 0.0219, 'lps'),
	(578403, 128, '2014-03-15 00:02:09.000000', 'consum', 0.0212, 'lps'),
	(578404, 128, '2014-03-15 00:02:10.000000', 'consum', 0.0213, 'lps'),
	(578405, 128, '2014-03-15 00:02:11.000000', 'consum', 0.0210, 'lps'),
	(578406, 128, '2014-03-15 00:02:12.000000', 'consum', 0.0213, 'lps'),
	(578407, 128, '2014-03-15 00:02:13.000000', 'consum', 0.0213, 'lps'),
	(578408, 128, '2014-03-15 00:02:14.000000', 'consum', 0.0216, 'lps'),
	(578409, 128, '2014-03-15 00:02:15.000000', 'consum', 0.0212, 'lps'),
	(578410, 128, '2014-03-15 00:02:16.000000', 'consum', 0.0212, 'lps'),
	(578411, 128, '2014-03-15 00:02:17.000000', 'consum', 0.0216, 'lps'),
	(578412, 128, '2014-03-15 00:02:18.000000', 'consum', 0.0210, 'lps'),
	(578413, 128, '2014-03-15 00:02:19.000000', 'consum', 0.0214, 'lps'),
	(578414, 128, '2014-03-15 00:02:20.000000', 'consum', 0.0219, 'lps'),
	(578415, 128, '2014-03-15 00:02:21.000000', 'consum', 0.0210, 'lps'),
	(578416, 128, '2014-03-15 00:02:22.000000', 'consum', 0.0219, 'lps'),
	(578417, 128, '2014-03-15 00:02:23.000000', 'consum', 0.0212, 'lps'),
	(578418, 128, '2014-03-15 00:02:24.000000', 'consum', 0.0216, 'lps'),
	(578419, 128, '2014-03-15 00:02:25.000000', 'consum', 0.0211, 'lps'),
	(578420, 128, '2014-03-15 00:02:26.000000', 'consum', 0.0220, 'lps'),
	(578421, 128, '2014-03-15 00:02:27.000000', 'consum', 0.0215, 'lps'),
	(578422, 128, '2014-03-15 00:02:28.000000', 'consum', 0.0217, 'lps'),
	(578423, 128, '2014-03-15 00:02:29.000000', 'consum', 0.0219, 'lps'),
	(578424, 128, '2014-03-15 00:02:30.000000', 'consum', 0.0211, 'lps'),
	(578425, 128, '2014-03-15 00:02:31.000000', 'consum', 0.0220, 'lps'),
	(578426, 128, '2014-03-15 00:02:32.000000', 'consum', 0.0216, 'lps'),
	(578427, 128, '2014-03-15 00:02:33.000000', 'consum', 0.0210, 'lps'),
	(578428, 128, '2014-03-15 00:02:34.000000', 'consum', 0.0216, 'lps'),
	(578429, 128, '2014-03-15 00:02:35.000000', 'consum', 0.0216, 'lps'),
	(578430, 128, '2014-03-15 00:02:36.000000', 'consum', 0.0213, 'lps'),
	(578431, 128, '2014-03-15 00:02:37.000000', 'consum', 0.0218, 'lps'),
	(578432, 128, '2014-03-15 00:02:38.000000', 'consum', 0.0210, 'lps'),
	(578433, 128, '2014-03-15 00:02:39.000000', 'consum', 0.0220, 'lps'),
	(578434, 128, '2014-03-15 00:02:40.000000', 'consum', 0.0217, 'lps'),
	(578435, 128, '2014-03-15 00:02:41.000000', 'consum', 0.0213, 'lps'),
	(578436, 128, '2014-03-15 00:02:42.000000', 'consum', 0.0215, 'lps'),
	(578437, 128, '2014-03-15 00:02:43.000000', 'consum', 0.0215, 'lps'),
	(578438, 128, '2014-03-15 00:02:44.000000', 'consum', 0.0210, 'lps'),
	(578439, 128, '2014-03-15 00:02:45.000000', 'consum', 0.0218, 'lps'),
	(578440, 128, '2014-03-15 00:02:46.000000', 'consum', 0.0219, 'lps'),
	(578441, 128, '2014-03-15 00:02:47.000000', 'consum', 0.0210, 'lps'),
	(578442, 128, '2014-03-15 00:02:48.000000', 'consum', 0.0217, 'lps'),
	(578443, 128, '2014-03-15 00:02:49.000000', 'consum', 0.0211, 'lps'),
	(578444, 128, '2014-03-15 00:02:50.000000', 'consum', 0.0215, 'lps'),
	(578445, 128, '2014-03-15 00:02:51.000000', 'consum', 0.0213, 'lps'),
	(578446, 128, '2014-03-15 00:02:52.000000', 'consum', 0.0219, 'lps'),
	(578447, 128, '2014-03-15 00:02:53.000000', 'consum', 0.0214, 'lps'),
	(578448, 128, '2014-03-15 00:02:54.000000', 'consum', 0.0215, 'lps'),
	(578449, 128, '2014-03-15 00:02:55.000000', 'consum', 0.0213, 'lps'),
	(578450, 128, '2014-03-15 00:02:56.000000', 'consum', 0.0220, 'lps'),
	(578451, 128, '2014-03-15 00:02:57.000000', 'consum', 0.0218, 'lps'),
	(578452, 128, '2014-03-15 00:02:58.000000', 'consum', 0.0220, 'lps'),
	(578453, 128, '2014-03-15 00:02:59.000000', 'consum', 0.0215, 'lps'),
	(578454, 128, '2014-03-15 00:03:00.000000', 'consum', 0.0219, 'lps'),
	(578455, 128, '2014-03-15 00:03:01.000000', 'consum', 0.0215, 'lps'),
	(578456, 128, '2014-03-15 00:03:02.000000', 'consum', 0.0212, 'lps'),
	(578457, 128, '2014-03-15 00:03:03.000000', 'consum', 0.0215, 'lps'),
	(578458, 128, '2014-03-15 00:03:04.000000', 'consum', 0.0218, 'lps'),
	(578459, 128, '2014-03-15 00:03:05.000000', 'consum', 0.0215, 'lps'),
	(578460, 128, '2014-03-15 00:03:06.000000', 'consum', 0.0211, 'lps'),
	(578461, 128, '2014-03-15 00:03:07.000000', 'consum', 0.0212, 'lps'),
	(578462, 128, '2014-03-15 00:03:08.000000', 'consum', 0.0216, 'lps'),
	(578463, 128, '2014-03-15 00:03:09.000000', 'consum', 0.0213, 'lps'),
	(578464, 128, '2014-03-15 00:03:10.000000', 'consum', 0.0219, 'lps'),
	(578465, 128, '2014-03-15 00:03:11.000000', 'consum', 0.0212, 'lps'),
	(578466, 128, '2014-03-15 00:03:12.000000', 'consum', 0.0216, 'lps'),
	(578467, 128, '2014-03-15 00:03:13.000000', 'consum', 0.0211, 'lps'),
	(578468, 128, '2014-03-15 00:03:14.000000', 'consum', 0.0211, 'lps'),
	(578469, 128, '2014-03-15 00:03:15.000000', 'consum', 0.0211, 'lps'),
	(578470, 128, '2014-03-15 00:03:16.000000', 'consum', 0.0212, 'lps'),
	(578471, 128, '2014-03-15 00:03:17.000000', 'consum', 0.0218, 'lps'),
	(578472, 128, '2014-03-15 00:03:18.000000', 'consum', 0.0211, 'lps'),
	(578473, 128, '2014-03-15 00:03:19.000000', 'consum', 0.0215, 'lps'),
	(578474, 128, '2014-03-15 00:03:20.000000', 'consum', 0.0219, 'lps'),
	(578475, 128, '2014-03-15 00:03:21.000000', 'consum', 0.0210, 'lps'),
	(578476, 128, '2014-03-15 00:03:22.000000', 'consum', 0.0216, 'lps'),
	(578477, 128, '2014-03-15 00:03:23.000000', 'consum', 0.0218, 'lps'),
	(578478, 128, '2014-03-15 00:03:24.000000', 'consum', 0.0213, 'lps'),
	(578479, 128, '2014-03-15 00:03:25.000000', 'consum', 0.0210, 'lps'),
	(578480, 128, '2014-03-15 00:03:26.000000', 'consum', 0.0212, 'lps'),
	(578481, 128, '2014-03-15 00:03:27.000000', 'consum', 0.0211, 'lps'),
	(578482, 128, '2014-03-15 00:03:28.000000', 'consum', 0.0219, 'lps'),
	(578483, 128, '2014-03-15 00:03:29.000000', 'consum', 0.0219, 'lps'),
	(578484, 128, '2014-03-15 00:03:30.000000', 'consum', 0.0217, 'lps'),
	(578485, 128, '2014-03-15 00:03:31.000000', 'consum', 0.0210, 'lps'),
	(578486, 128, '2014-03-15 00:03:32.000000', 'consum', 0.0212, 'lps'),
	(578487, 128, '2014-03-15 00:03:33.000000', 'consum', 0.0220, 'lps'),
	(578488, 128, '2014-03-15 00:03:34.000000', 'consum', 0.0212, 'lps'),
	(578489, 128, '2014-03-15 00:03:35.000000', 'consum', 0.0210, 'lps'),
	(578490, 128, '2014-03-15 00:03:36.000000', 'consum', 0.0215, 'lps'),
	(578491, 128, '2014-03-15 00:03:37.000000', 'consum', 0.0216, 'lps'),
	(578492, 128, '2014-03-15 00:03:38.000000', 'consum', 0.0213, 'lps'),
	(578493, 128, '2014-03-15 00:03:39.000000', 'consum', 0.0217, 'lps'),
	(578494, 128, '2014-03-15 00:03:40.000000', 'consum', 0.0218, 'lps'),
	(578495, 128, '2014-03-15 00:03:41.000000', 'consum', 0.0216, 'lps'),
	(578496, 128, '2014-03-15 00:03:42.000000', 'consum', 0.0218, 'lps'),
	(578497, 128, '2014-03-15 00:03:43.000000', 'consum', 0.0220, 'lps'),
	(578498, 128, '2014-03-15 00:03:44.000000', 'consum', 0.0213, 'lps'),
	(578499, 128, '2014-03-15 00:03:45.000000', 'consum', 0.0219, 'lps'),
	(578500, 128, '2014-03-15 00:03:46.000000', 'consum', 0.0216, 'lps'),
	(578501, 128, '2014-03-15 00:03:47.000000', 'consum', 0.0210, 'lps'),
	(578502, 128, '2014-03-15 00:03:48.000000', 'consum', 0.0214, 'lps'),
	(578503, 128, '2014-03-15 00:03:49.000000', 'consum', 0.0210, 'lps'),
	(578504, 128, '2014-03-15 00:03:50.000000', 'consum', 0.0211, 'lps'),
	(578505, 128, '2014-03-15 00:03:51.000000', 'consum', 0.0213, 'lps'),
	(578506, 128, '2014-03-15 00:03:52.000000', 'consum', 0.0211, 'lps'),
	(578507, 128, '2014-03-15 00:03:53.000000', 'consum', 0.0216, 'lps'),
	(578508, 128, '2014-03-15 00:03:54.000000', 'consum', 0.0219, 'lps'),
	(578509, 128, '2014-03-15 00:03:55.000000', 'consum', 0.0216, 'lps'),
	(578510, 128, '2014-03-15 00:03:56.000000', 'consum', 0.0211, 'lps'),
	(578511, 128, '2014-03-15 00:03:57.000000', 'consum', 0.0211, 'lps'),
	(578512, 128, '2014-03-15 00:03:58.000000', 'consum', 0.0210, 'lps'),
	(578513, 128, '2014-03-15 00:03:59.000000', 'consum', 0.0210, 'lps'),
	(578514, 128, '2014-03-15 00:04:00.000000', 'consum', 0.0210, 'lps'),
	(578515, 128, '2014-03-15 00:04:01.000000', 'consum', 0.0220, 'lps'),
	(578516, 128, '2014-03-15 00:04:02.000000', 'consum', 0.0217, 'lps'),
	(578517, 128, '2014-03-15 00:04:03.000000', 'consum', 0.0214, 'lps'),
	(578518, 128, '2014-03-15 00:04:04.000000', 'consum', 0.0211, 'lps'),
	(578519, 128, '2014-03-15 00:04:05.000000', 'consum', 0.0215, 'lps'),
	(578520, 128, '2014-03-15 00:04:06.000000', 'consum', 0.0211, 'lps'),
	(578521, 128, '2014-03-15 00:04:07.000000', 'consum', 0.0213, 'lps'),
	(578522, 128, '2014-03-15 00:04:08.000000', 'consum', 0.0220, 'lps'),
	(578523, 128, '2014-03-15 00:04:09.000000', 'consum', 0.0217, 'lps'),
	(578524, 128, '2014-03-15 00:04:10.000000', 'consum', 0.0219, 'lps'),
	(578525, 128, '2014-03-15 00:04:11.000000', 'consum', 0.0220, 'lps'),
	(578526, 128, '2014-03-15 00:04:12.000000', 'consum', 0.0214, 'lps'),
	(578527, 128, '2014-03-15 00:04:13.000000', 'consum', 0.0210, 'lps'),
	(578528, 128, '2014-03-15 00:04:14.000000', 'consum', 0.0211, 'lps'),
	(578529, 128, '2014-03-15 00:04:15.000000', 'consum', 0.0215, 'lps'),
	(578530, 128, '2014-03-15 00:04:16.000000', 'consum', 0.0211, 'lps'),
	(578531, 128, '2014-03-15 00:04:17.000000', 'consum', 0.0210, 'lps'),
	(578532, 128, '2014-03-15 00:04:18.000000', 'consum', 0.0210, 'lps'),
	(578533, 128, '2014-03-15 00:04:19.000000', 'consum', 0.0219, 'lps'),
	(578534, 128, '2014-03-15 00:04:20.000000', 'consum', 0.0213, 'lps'),
	(578535, 128, '2014-03-15 00:04:21.000000', 'consum', 0.0220, 'lps'),
	(578536, 128, '2014-03-15 00:04:22.000000', 'consum', 0.0218, 'lps'),
	(578537, 128, '2014-03-15 00:04:23.000000', 'consum', 0.0210, 'lps'),
	(578538, 128, '2014-03-15 00:04:24.000000', 'consum', 0.0219, 'lps'),
	(578539, 128, '2014-03-15 00:04:25.000000', 'consum', 0.0211, 'lps'),
	(578540, 128, '2014-03-15 00:04:26.000000', 'consum', 0.0210, 'lps'),
	(578541, 128, '2014-03-15 00:04:27.000000', 'consum', 0.0220, 'lps'),
	(578542, 128, '2014-03-15 00:04:28.000000', 'consum', 0.0218, 'lps'),
	(578543, 128, '2014-03-15 00:04:29.000000', 'consum', 0.0218, 'lps'),
	(578544, 128, '2014-03-15 00:04:30.000000', 'consum', 0.0216, 'lps'),
	(578545, 128, '2014-03-15 00:04:31.000000', 'consum', 0.0216, 'lps'),
	(578546, 128, '2014-03-15 00:04:32.000000', 'consum', 0.0213, 'lps'),
	(578547, 128, '2014-03-15 00:04:33.000000', 'consum', 0.0216, 'lps'),
	(578548, 128, '2014-03-15 00:04:34.000000', 'consum', 0.0220, 'lps'),
	(578549, 128, '2014-03-15 00:04:35.000000', 'consum', 0.0212, 'lps'),
	(578550, 128, '2014-03-15 00:04:36.000000', 'consum', 0.0213, 'lps'),
	(578551, 128, '2014-03-15 00:04:37.000000', 'consum', 0.0218, 'lps'),
	(578552, 128, '2014-03-15 00:04:38.000000', 'consum', 0.0218, 'lps'),
	(578553, 128, '2014-03-15 00:04:39.000000', 'consum', 0.0218, 'lps'),
	(578554, 128, '2014-03-15 00:04:40.000000', 'consum', 0.0213, 'lps'),
	(578555, 128, '2014-03-15 00:04:41.000000', 'consum', 0.0214, 'lps'),
	(578556, 128, '2014-03-15 00:04:42.000000', 'consum', 0.0212, 'lps'),
	(578557, 128, '2014-03-15 00:04:43.000000', 'consum', 0.0217, 'lps'),
	(578558, 128, '2014-03-15 00:04:44.000000', 'consum', 0.0217, 'lps'),
	(578559, 128, '2014-03-15 00:04:45.000000', 'consum', 0.0213, 'lps'),
	(578560, 128, '2014-03-15 00:04:46.000000', 'consum', 0.0216, 'lps'),
	(578561, 128, '2014-03-15 00:04:47.000000', 'consum', 0.0212, 'lps'),
	(578562, 128, '2014-03-15 00:04:48.000000', 'consum', 0.0211, 'lps'),
	(578563, 128, '2014-03-15 00:04:49.000000', 'consum', 0.0219, 'lps'),
	(578564, 128, '2014-03-15 00:04:50.000000', 'consum', 0.0211, 'lps'),
	(578565, 128, '2014-03-15 00:04:51.000000', 'consum', 0.0212, 'lps'),
	(578566, 128, '2014-03-15 00:04:52.000000', 'consum', 0.0215, 'lps'),
	(578567, 128, '2014-03-15 00:04:53.000000', 'consum', 0.0220, 'lps'),
	(578568, 128, '2014-03-15 00:04:54.000000', 'consum', 0.0210, 'lps'),
	(578569, 128, '2014-03-15 00:04:55.000000', 'consum', 0.0215, 'lps'),
	(578570, 128, '2014-03-15 00:04:56.000000', 'consum', 0.0215, 'lps'),
	(578571, 128, '2014-03-15 00:04:57.000000', 'consum', 0.0220, 'lps'),
	(578572, 128, '2014-03-15 00:04:58.000000', 'consum', 0.0211, 'lps'),
	(578573, 128, '2014-03-15 00:04:59.000000', 'consum', 0.0219, 'lps'),
	(578574, 128, '2014-03-15 00:05:00.000000', 'consum', 0.0211, 'lps'),
	(578575, 128, '2014-03-15 00:05:01.000000', 'consum', 0.0218, 'lps'),
	(578576, 128, '2014-03-15 00:05:02.000000', 'consum', 0.0215, 'lps'),
	(578577, 128, '2014-03-15 00:05:03.000000', 'consum', 0.0212, 'lps'),
	(578578, 128, '2014-03-15 00:05:04.000000', 'consum', 0.0217, 'lps'),
	(578579, 128, '2014-03-15 00:05:05.000000', 'consum', 0.0216, 'lps'),
	(578580, 128, '2014-03-15 00:05:06.000000', 'consum', 0.0220, 'lps'),
	(578581, 128, '2014-03-15 00:05:07.000000', 'consum', 0.0220, 'lps'),
	(578582, 128, '2014-03-15 00:05:08.000000', 'consum', 0.0211, 'lps'),
	(578583, 128, '2014-03-15 00:05:09.000000', 'consum', 0.0217, 'lps'),
	(578584, 128, '2014-03-15 00:05:10.000000', 'consum', 0.0210, 'lps'),
	(578585, 128, '2014-03-15 00:05:11.000000', 'consum', 0.0213, 'lps'),
	(578586, 128, '2014-03-15 00:05:12.000000', 'consum', 0.0214, 'lps'),
	(578587, 128, '2014-03-15 00:05:13.000000', 'consum', 0.0220, 'lps'),
	(578588, 128, '2014-03-15 00:05:14.000000', 'consum', 0.0215, 'lps'),
	(578589, 128, '2014-03-15 00:05:15.000000', 'consum', 0.0219, 'lps'),
	(578590, 128, '2014-03-15 00:05:16.000000', 'consum', 0.0216, 'lps'),
	(578591, 128, '2014-03-15 00:05:17.000000', 'consum', 0.0215, 'lps'),
	(578592, 128, '2014-03-15 00:05:18.000000', 'consum', 0.0216, 'lps'),
	(578593, 128, '2014-03-15 00:05:19.000000', 'consum', 0.0216, 'lps'),
	(578594, 128, '2014-03-15 00:05:20.000000', 'consum', 0.0213, 'lps'),
	(578595, 128, '2014-03-15 00:05:21.000000', 'consum', 0.0216, 'lps'),
	(578596, 128, '2014-03-15 00:05:22.000000', 'consum', 0.0210, 'lps'),
	(578597, 128, '2014-03-15 00:05:23.000000', 'consum', 0.0214, 'lps'),
	(578598, 128, '2014-03-15 00:05:24.000000', 'consum', 0.0220, 'lps'),
	(578599, 128, '2014-03-15 00:05:25.000000', 'consum', 0.0214, 'lps'),
	(578600, 128, '2014-03-15 00:05:26.000000', 'consum', 0.0212, 'lps'),
	(578601, 128, '2014-03-15 00:05:27.000000', 'consum', 0.0219, 'lps'),
	(578602, 128, '2014-03-15 00:05:28.000000', 'consum', 0.0217, 'lps'),
	(578603, 128, '2014-03-15 00:05:29.000000', 'consum', 0.0219, 'lps'),
	(578604, 128, '2014-03-15 00:05:30.000000', 'consum', 0.0214, 'lps'),
	(578605, 128, '2014-03-15 00:05:31.000000', 'consum', 0.0214, 'lps'),
	(578606, 128, '2014-03-15 00:05:32.000000', 'consum', 0.0220, 'lps'),
	(578607, 128, '2014-03-15 00:05:33.000000', 'consum', 0.0214, 'lps'),
	(578608, 128, '2014-03-15 00:05:34.000000', 'consum', 0.0214, 'lps'),
	(578609, 128, '2014-03-15 00:05:35.000000', 'consum', 0.0215, 'lps'),
	(578610, 128, '2014-03-15 00:05:36.000000', 'consum', 0.0213, 'lps'),
	(578611, 128, '2014-03-15 00:05:37.000000', 'consum', 0.0220, 'lps'),
	(578612, 128, '2014-03-15 00:05:38.000000', 'consum', 0.0211, 'lps'),
	(578613, 128, '2014-03-15 00:05:39.000000', 'consum', 0.0216, 'lps'),
	(578614, 128, '2014-03-15 00:05:40.000000', 'consum', 0.0214, 'lps'),
	(578615, 128, '2014-03-15 00:05:41.000000', 'consum', 0.0215, 'lps'),
	(578616, 128, '2014-03-15 00:05:42.000000', 'consum', 0.0214, 'lps'),
	(578617, 128, '2014-03-15 00:05:43.000000', 'consum', 0.0212, 'lps'),
	(578618, 128, '2014-03-15 00:05:44.000000', 'consum', 0.0211, 'lps'),
	(578619, 128, '2014-03-15 00:05:45.000000', 'consum', 0.0218, 'lps'),
	(578620, 128, '2014-03-15 00:05:46.000000', 'consum', 0.0214, 'lps'),
	(578621, 128, '2014-03-15 00:05:47.000000', 'consum', 0.0218, 'lps'),
	(578622, 128, '2014-03-15 00:05:48.000000', 'consum', 0.0218, 'lps'),
	(578623, 128, '2014-03-15 00:05:49.000000', 'consum', 0.0216, 'lps'),
	(578624, 128, '2014-03-15 00:05:50.000000', 'consum', 0.0216, 'lps'),
	(578625, 128, '2014-03-15 00:05:51.000000', 'consum', 0.0213, 'lps'),
	(578626, 128, '2014-03-15 00:05:52.000000', 'consum', 0.0216, 'lps'),
	(578627, 128, '2014-03-15 00:05:53.000000', 'consum', 0.0211, 'lps'),
	(578628, 128, '2014-03-15 00:05:54.000000', 'consum', 0.0220, 'lps'),
	(578629, 128, '2014-03-15 00:05:55.000000', 'consum', 0.0214, 'lps'),
	(578630, 128, '2014-03-15 00:05:56.000000', 'consum', 0.0211, 'lps'),
	(578631, 128, '2014-03-15 00:05:57.000000', 'consum', 0.0214, 'lps'),
	(578632, 128, '2014-03-15 00:05:58.000000', 'consum', 0.0216, 'lps'),
	(578633, 128, '2014-03-15 00:05:59.000000', 'consum', 0.0218, 'lps'),
	(578634, 128, '2014-03-15 00:06:00.000000', 'consum', 0.0220, 'lps'),
	(578635, 128, '2014-03-15 00:06:01.000000', 'consum', 0.0214, 'lps'),
	(578636, 128, '2014-03-15 00:06:02.000000', 'consum', 0.0212, 'lps'),
	(578637, 128, '2014-03-15 00:06:03.000000', 'consum', 0.0220, 'lps'),
	(578638, 128, '2014-03-15 00:06:04.000000', 'consum', 0.0220, 'lps'),
	(578639, 128, '2014-03-15 00:06:05.000000', 'consum', 0.0220, 'lps'),
	(578640, 128, '2014-03-15 00:06:06.000000', 'consum', 0.0218, 'lps'),
	(578641, 128, '2014-03-15 00:06:07.000000', 'consum', 0.0211, 'lps'),
	(578642, 128, '2014-03-15 00:06:08.000000', 'consum', 0.0212, 'lps'),
	(578643, 128, '2014-03-15 00:06:09.000000', 'consum', 0.0220, 'lps'),
	(578644, 128, '2014-03-15 00:06:10.000000', 'consum', 0.0219, 'lps'),
	(578645, 128, '2014-03-15 00:06:11.000000', 'consum', 0.0215, 'lps'),
	(578646, 128, '2014-03-15 00:06:12.000000', 'consum', 0.0219, 'lps'),
	(578647, 128, '2014-03-15 00:06:13.000000', 'consum', 0.0220, 'lps'),
	(578648, 128, '2014-03-15 00:06:14.000000', 'consum', 0.0210, 'lps'),
	(578649, 128, '2014-03-15 00:06:15.000000', 'consum', 0.0214, 'lps'),
	(578650, 128, '2014-03-15 00:06:16.000000', 'consum', 0.0218, 'lps'),
	(578651, 128, '2014-03-15 00:06:17.000000', 'consum', 0.0217, 'lps'),
	(578652, 128, '2014-03-15 00:06:18.000000', 'consum', 0.0211, 'lps'),
	(578653, 128, '2014-03-15 00:06:19.000000', 'consum', 0.0216, 'lps'),
	(578654, 128, '2014-03-15 00:06:20.000000', 'consum', 0.0214, 'lps'),
	(578655, 128, '2014-03-15 00:06:21.000000', 'consum', 0.0215, 'lps'),
	(578656, 128, '2014-03-15 00:06:22.000000', 'consum', 0.0212, 'lps'),
	(578657, 128, '2014-03-15 00:06:23.000000', 'consum', 0.0217, 'lps'),
	(578658, 128, '2014-03-15 00:06:24.000000', 'consum', 0.0216, 'lps'),
	(578659, 128, '2014-03-15 00:06:25.000000', 'consum', 0.0219, 'lps'),
	(578660, 128, '2014-03-15 00:06:26.000000', 'consum', 0.0215, 'lps'),
	(578661, 128, '2014-03-15 00:06:27.000000', 'consum', 0.0219, 'lps'),
	(578662, 128, '2014-03-15 00:06:28.000000', 'consum', 0.0219, 'lps'),
	(578663, 128, '2014-03-15 00:06:29.000000', 'consum', 0.0219, 'lps'),
	(578664, 128, '2014-03-15 00:06:30.000000', 'consum', 0.0215, 'lps'),
	(578665, 128, '2014-03-15 00:06:31.000000', 'consum', 0.0220, 'lps'),
	(578666, 128, '2014-03-15 00:06:32.000000', 'consum', 0.0211, 'lps'),
	(578667, 128, '2014-03-15 00:06:33.000000', 'consum', 0.0220, 'lps'),
	(578668, 128, '2014-03-15 00:06:34.000000', 'consum', 0.0215, 'lps'),
	(578669, 128, '2014-03-15 00:06:35.000000', 'consum', 0.0216, 'lps'),
	(578670, 128, '2014-03-15 00:06:36.000000', 'consum', 0.0214, 'lps'),
	(578671, 128, '2014-03-15 00:06:37.000000', 'consum', 0.0212, 'lps'),
	(578672, 128, '2014-03-15 00:06:38.000000', 'consum', 0.0219, 'lps'),
	(578673, 128, '2014-03-15 00:06:39.000000', 'consum', 0.0217, 'lps'),
	(578674, 128, '2014-03-15 00:06:40.000000', 'consum', 0.0217, 'lps'),
	(578675, 128, '2014-03-15 00:06:41.000000', 'consum', 0.0213, 'lps'),
	(578676, 128, '2014-03-15 00:06:42.000000', 'consum', 0.0219, 'lps'),
	(578677, 128, '2014-03-15 00:06:43.000000', 'consum', 0.0210, 'lps'),
	(578678, 128, '2014-03-15 00:06:44.000000', 'consum', 0.0217, 'lps'),
	(578679, 128, '2014-03-15 00:06:45.000000', 'consum', 0.0215, 'lps'),
	(578680, 128, '2014-03-15 00:06:46.000000', 'consum', 0.0214, 'lps'),
	(578681, 128, '2014-03-15 00:06:47.000000', 'consum', 0.0213, 'lps'),
	(578682, 128, '2014-03-15 00:06:48.000000', 'consum', 0.0215, 'lps'),
	(578683, 128, '2014-03-15 00:06:49.000000', 'consum', 0.0215, 'lps'),
	(578684, 128, '2014-03-15 00:06:50.000000', 'consum', 0.0220, 'lps'),
	(578685, 128, '2014-03-15 00:06:51.000000', 'consum', 0.0215, 'lps'),
	(578686, 128, '2014-03-15 00:06:52.000000', 'consum', 0.0215, 'lps'),
	(578687, 128, '2014-03-15 00:06:53.000000', 'consum', 0.0212, 'lps'),
	(578688, 128, '2014-03-15 00:06:54.000000', 'consum', 0.0213, 'lps'),
	(578689, 128, '2014-03-15 00:06:55.000000', 'consum', 0.0210, 'lps'),
	(578690, 128, '2014-03-15 00:06:56.000000', 'consum', 0.0210, 'lps'),
	(578691, 128, '2014-03-15 00:06:57.000000', 'consum', 0.0214, 'lps'),
	(578692, 128, '2014-03-15 00:06:58.000000', 'consum', 0.0219, 'lps'),
	(578693, 128, '2014-03-15 00:06:59.000000', 'consum', 0.0211, 'lps'),
	(578694, 128, '2014-03-15 00:07:00.000000', 'consum', 0.0212, 'lps'),
	(578695, 128, '2014-03-15 00:07:01.000000', 'consum', 0.0214, 'lps'),
	(578696, 128, '2014-03-15 00:07:02.000000', 'consum', 0.0217, 'lps'),
	(578697, 128, '2014-03-15 00:07:03.000000', 'consum', 0.0210, 'lps'),
	(578698, 128, '2014-03-15 00:07:04.000000', 'consum', 0.0211, 'lps'),
	(578699, 128, '2014-03-15 00:07:05.000000', 'consum', 0.0216, 'lps'),
	(578700, 128, '2014-03-15 00:07:06.000000', 'consum', 0.0215, 'lps'),
	(578701, 128, '2014-03-15 00:07:07.000000', 'consum', 0.0220, 'lps'),
	(578702, 128, '2014-03-15 00:07:08.000000', 'consum', 0.0210, 'lps'),
	(578703, 128, '2014-03-15 00:07:09.000000', 'consum', 0.0216, 'lps'),
	(578704, 128, '2014-03-15 00:07:10.000000', 'consum', 0.0217, 'lps'),
	(578705, 128, '2014-03-15 00:07:11.000000', 'consum', 0.0218, 'lps'),
	(578706, 128, '2014-03-15 00:07:12.000000', 'consum', 0.0218, 'lps'),
	(578707, 128, '2014-03-15 00:07:13.000000', 'consum', 0.0216, 'lps'),
	(578708, 128, '2014-03-15 00:07:14.000000', 'consum', 0.0217, 'lps'),
	(578709, 128, '2014-03-15 00:07:15.000000', 'consum', 0.0214, 'lps'),
	(578710, 128, '2014-03-15 00:07:16.000000', 'consum', 0.0212, 'lps'),
	(578711, 128, '2014-03-15 00:07:17.000000', 'consum', 0.0220, 'lps'),
	(578712, 128, '2014-03-15 00:07:18.000000', 'consum', 0.0211, 'lps'),
	(578713, 128, '2014-03-15 00:07:19.000000', 'consum', 0.0216, 'lps'),
	(578714, 128, '2014-03-15 00:07:20.000000', 'consum', 0.0217, 'lps'),
	(578715, 128, '2014-03-15 00:07:21.000000', 'consum', 0.0218, 'lps'),
	(578716, 128, '2014-03-15 00:07:22.000000', 'consum', 0.0218, 'lps'),
	(578717, 128, '2014-03-15 00:07:23.000000', 'consum', 0.0216, 'lps'),
	(578718, 128, '2014-03-15 00:07:24.000000', 'consum', 0.0216, 'lps'),
	(578719, 128, '2014-03-15 00:07:25.000000', 'consum', 0.0210, 'lps'),
	(578720, 128, '2014-03-15 00:07:26.000000', 'consum', 0.0217, 'lps'),
	(578721, 128, '2014-03-15 00:07:27.000000', 'consum', 0.0211, 'lps'),
	(578722, 128, '2014-03-15 00:07:28.000000', 'consum', 0.0218, 'lps'),
	(578723, 128, '2014-03-15 00:07:29.000000', 'consum', 0.0213, 'lps'),
	(578724, 128, '2014-03-15 00:07:30.000000', 'consum', 0.0212, 'lps'),
	(578725, 128, '2014-03-15 00:07:31.000000', 'consum', 0.0213, 'lps'),
	(578726, 128, '2014-03-15 00:07:32.000000', 'consum', 0.0220, 'lps'),
	(578727, 128, '2014-03-15 00:07:33.000000', 'consum', 0.0218, 'lps'),
	(578728, 128, '2014-03-15 00:07:34.000000', 'consum', 0.0211, 'lps'),
	(578729, 128, '2014-03-15 00:07:35.000000', 'consum', 0.0213, 'lps'),
	(578730, 128, '2014-03-15 00:07:36.000000', 'consum', 0.0212, 'lps'),
	(578731, 128, '2014-03-15 00:07:37.000000', 'consum', 0.0210, 'lps'),
	(578732, 128, '2014-03-15 00:07:38.000000', 'consum', 0.0216, 'lps'),
	(578733, 128, '2014-03-15 00:07:39.000000', 'consum', 0.0220, 'lps'),
	(578734, 128, '2014-03-15 00:07:40.000000', 'consum', 0.0220, 'lps'),
	(578735, 128, '2014-03-15 00:07:41.000000', 'consum', 0.0210, 'lps'),
	(578736, 128, '2014-03-15 00:07:42.000000', 'consum', 0.0210, 'lps'),
	(578737, 128, '2014-03-15 00:07:43.000000', 'consum', 0.0214, 'lps'),
	(578738, 128, '2014-03-15 00:07:44.000000', 'consum', 0.0216, 'lps'),
	(578739, 128, '2014-03-15 00:07:45.000000', 'consum', 0.0210, 'lps'),
	(578740, 128, '2014-03-15 00:07:46.000000', 'consum', 0.0213, 'lps'),
	(578741, 128, '2014-03-15 00:07:47.000000', 'consum', 0.0212, 'lps'),
	(578742, 128, '2014-03-15 00:07:48.000000', 'consum', 0.0215, 'lps'),
	(578743, 128, '2014-03-15 00:07:49.000000', 'consum', 0.0219, 'lps'),
	(578744, 128, '2014-03-15 00:07:50.000000', 'consum', 0.0217, 'lps'),
	(578745, 128, '2014-03-15 00:07:51.000000', 'consum', 0.0219, 'lps'),
	(578746, 128, '2014-03-15 00:07:52.000000', 'consum', 0.0211, 'lps'),
	(578747, 128, '2014-03-15 00:07:53.000000', 'consum', 0.0212, 'lps'),
	(578748, 128, '2014-03-15 00:07:54.000000', 'consum', 0.0218, 'lps'),
	(578749, 128, '2014-03-15 00:07:55.000000', 'consum', 0.0211, 'lps'),
	(578750, 128, '2014-03-15 00:07:56.000000', 'consum', 0.0215, 'lps'),
	(578751, 128, '2014-03-15 00:07:57.000000', 'consum', 0.0220, 'lps'),
	(578752, 128, '2014-03-15 00:07:58.000000', 'consum', 0.0214, 'lps'),
	(578753, 128, '2014-03-15 00:07:59.000000', 'consum', 0.0211, 'lps'),
	(578754, 128, '2014-03-15 00:08:00.000000', 'consum', 0.0213, 'lps'),
	(578755, 128, '2014-03-15 00:08:01.000000', 'consum', 0.0212, 'lps'),
	(578756, 128, '2014-03-15 00:08:02.000000', 'consum', 0.0211, 'lps'),
	(578757, 128, '2014-03-15 00:08:03.000000', 'consum', 0.0219, 'lps'),
	(578758, 128, '2014-03-15 00:08:04.000000', 'consum', 0.0212, 'lps'),
	(578759, 128, '2014-03-15 00:08:05.000000', 'consum', 0.0214, 'lps'),
	(578760, 128, '2014-03-15 00:08:06.000000', 'consum', 0.0213, 'lps'),
	(578761, 128, '2014-03-15 00:08:07.000000', 'consum', 0.0213, 'lps'),
	(578762, 128, '2014-03-15 00:08:08.000000', 'consum', 0.0216, 'lps'),
	(578763, 128, '2014-03-15 00:08:09.000000', 'consum', 0.0210, 'lps'),
	(578764, 128, '2014-03-15 00:08:10.000000', 'consum', 0.0215, 'lps'),
	(578765, 128, '2014-03-15 00:08:11.000000', 'consum', 0.0214, 'lps'),
	(578766, 128, '2014-03-15 00:08:12.000000', 'consum', 0.0214, 'lps'),
	(578767, 128, '2014-03-15 00:08:13.000000', 'consum', 0.0218, 'lps'),
	(578768, 128, '2014-03-15 00:08:14.000000', 'consum', 0.0218, 'lps'),
	(578769, 128, '2014-03-15 00:08:15.000000', 'consum', 0.0217, 'lps'),
	(578770, 128, '2014-03-15 00:08:16.000000', 'consum', 0.0220, 'lps'),
	(578771, 128, '2014-03-15 00:08:17.000000', 'consum', 0.0217, 'lps'),
	(578772, 128, '2014-03-15 00:08:18.000000', 'consum', 0.0217, 'lps'),
	(578773, 128, '2014-03-15 00:08:19.000000', 'consum', 0.0212, 'lps'),
	(578774, 128, '2014-03-15 00:08:20.000000', 'consum', 0.0220, 'lps'),
	(578775, 128, '2014-03-15 00:08:21.000000', 'consum', 0.0214, 'lps'),
	(578776, 128, '2014-03-15 00:08:22.000000', 'consum', 0.0210, 'lps'),
	(578777, 128, '2014-03-15 00:08:23.000000', 'consum', 0.0219, 'lps'),
	(578778, 128, '2014-03-15 00:08:24.000000', 'consum', 0.0212, 'lps'),
	(578779, 128, '2014-03-15 00:08:25.000000', 'consum', 0.0216, 'lps'),
	(578780, 128, '2014-03-15 00:08:26.000000', 'consum', 0.0213, 'lps'),
	(578781, 128, '2014-03-15 00:08:27.000000', 'consum', 0.0220, 'lps'),
	(578782, 128, '2014-03-15 00:08:28.000000', 'consum', 0.0218, 'lps'),
	(578783, 128, '2014-03-15 00:08:29.000000', 'consum', 0.0218, 'lps'),
	(578784, 128, '2014-03-15 00:08:30.000000', 'consum', 0.0218, 'lps'),
	(578785, 128, '2014-03-15 00:08:31.000000', 'consum', 0.0215, 'lps'),
	(578786, 128, '2014-03-15 00:08:32.000000', 'consum', 0.0211, 'lps'),
	(578787, 128, '2014-03-15 00:08:33.000000', 'consum', 0.0213, 'lps'),
	(578788, 128, '2014-03-15 00:08:34.000000', 'consum', 0.0213, 'lps'),
	(578789, 128, '2014-03-15 00:08:35.000000', 'consum', 0.0213, 'lps'),
	(578790, 128, '2014-03-15 00:08:36.000000', 'consum', 0.0217, 'lps'),
	(578791, 128, '2014-03-15 00:08:37.000000', 'consum', 0.0213, 'lps'),
	(578792, 128, '2014-03-15 00:08:38.000000', 'consum', 0.0217, 'lps'),
	(578793, 128, '2014-03-15 00:08:39.000000', 'consum', 0.0214, 'lps'),
	(578794, 128, '2014-03-15 00:08:40.000000', 'consum', 0.0211, 'lps'),
	(578795, 128, '2014-03-15 00:08:41.000000', 'consum', 0.0214, 'lps'),
	(578796, 128, '2014-03-15 00:08:42.000000', 'consum', 0.0214, 'lps'),
	(578797, 128, '2014-03-15 00:08:43.000000', 'consum', 0.0211, 'lps'),
	(578798, 128, '2014-03-15 00:08:44.000000', 'consum', 0.0214, 'lps'),
	(578799, 128, '2014-03-15 00:08:45.000000', 'consum', 0.0215, 'lps'),
	(578800, 128, '2014-03-15 00:08:46.000000', 'consum', 0.0212, 'lps'),
	(578801, 128, '2014-03-15 00:08:47.000000', 'consum', 0.0217, 'lps'),
	(578802, 128, '2014-03-15 00:08:48.000000', 'consum', 0.0219, 'lps'),
	(578803, 128, '2014-03-15 00:08:49.000000', 'consum', 0.0211, 'lps'),
	(578804, 128, '2014-03-15 00:08:50.000000', 'consum', 0.0213, 'lps'),
	(578805, 128, '2014-03-15 00:08:51.000000', 'consum', 0.0220, 'lps'),
	(578806, 128, '2014-03-15 00:08:52.000000', 'consum', 0.0220, 'lps'),
	(578807, 128, '2014-03-15 00:08:53.000000', 'consum', 0.0219, 'lps'),
	(578808, 128, '2014-03-15 00:08:54.000000', 'consum', 0.0214, 'lps'),
	(578809, 128, '2014-03-15 00:08:55.000000', 'consum', 0.0216, 'lps'),
	(578810, 128, '2014-03-15 00:08:56.000000', 'consum', 0.0216, 'lps'),
	(578811, 128, '2014-03-15 00:08:57.000000', 'consum', 0.0212, 'lps'),
	(578812, 128, '2014-03-15 00:08:58.000000', 'consum', 0.0214, 'lps'),
	(578813, 128, '2014-03-15 00:08:59.000000', 'consum', 0.0214, 'lps'),
	(578814, 128, '2014-03-15 00:09:00.000000', 'consum', 0.0218, 'lps'),
	(578815, 128, '2014-03-15 00:09:01.000000', 'consum', 0.0215, 'lps'),
	(578816, 128, '2014-03-15 00:09:02.000000', 'consum', 0.0212, 'lps'),
	(578817, 128, '2014-03-15 00:09:03.000000', 'consum', 0.0215, 'lps'),
	(578818, 128, '2014-03-15 00:09:04.000000', 'consum', 0.0210, 'lps'),
	(578819, 128, '2014-03-15 00:09:05.000000', 'consum', 0.0218, 'lps'),
	(578820, 128, '2014-03-15 00:09:06.000000', 'consum', 0.0218, 'lps'),
	(578821, 128, '2014-03-15 00:09:07.000000', 'consum', 0.0213, 'lps'),
	(578822, 128, '2014-03-15 00:09:08.000000', 'consum', 0.0213, 'lps'),
	(578823, 128, '2014-03-15 00:09:09.000000', 'consum', 0.0217, 'lps'),
	(578824, 128, '2014-03-15 00:09:10.000000', 'consum', 0.0214, 'lps'),
	(578825, 128, '2014-03-15 00:09:11.000000', 'consum', 0.0219, 'lps'),
	(578826, 128, '2014-03-15 00:09:12.000000', 'consum', 0.0211, 'lps'),
	(578827, 128, '2014-03-15 00:09:13.000000', 'consum', 0.0210, 'lps'),
	(578828, 128, '2014-03-15 00:09:14.000000', 'consum', 0.0210, 'lps'),
	(578829, 128, '2014-03-15 00:09:15.000000', 'consum', 0.0220, 'lps'),
	(578830, 128, '2014-03-15 00:09:16.000000', 'consum', 0.0216, 'lps'),
	(578831, 128, '2014-03-15 00:09:17.000000', 'consum', 0.0212, 'lps'),
	(578832, 128, '2014-03-15 00:09:18.000000', 'consum', 0.0213, 'lps'),
	(578833, 128, '2014-03-15 00:09:19.000000', 'consum', 0.0210, 'lps'),
	(578834, 128, '2014-03-15 00:09:20.000000', 'consum', 0.0211, 'lps'),
	(578835, 128, '2014-03-15 00:09:21.000000', 'consum', 0.0217, 'lps'),
	(578836, 128, '2014-03-15 00:09:22.000000', 'consum', 0.0218, 'lps'),
	(578837, 128, '2014-03-15 00:09:23.000000', 'consum', 0.0210, 'lps'),
	(578838, 128, '2014-03-15 00:09:24.000000', 'consum', 0.0218, 'lps'),
	(578839, 128, '2014-03-15 00:09:25.000000', 'consum', 0.0219, 'lps'),
	(578840, 128, '2014-03-15 00:09:26.000000', 'consum', 0.0218, 'lps'),
	(578841, 128, '2014-03-15 00:09:27.000000', 'consum', 0.0214, 'lps'),
	(578842, 128, '2014-03-15 00:09:28.000000', 'consum', 0.0216, 'lps'),
	(578843, 128, '2014-03-15 00:09:29.000000', 'consum', 0.0217, 'lps'),
	(578844, 128, '2014-03-15 00:09:30.000000', 'consum', 0.0218, 'lps'),
	(578845, 128, '2014-03-15 00:09:31.000000', 'consum', 0.0219, 'lps'),
	(578846, 128, '2014-03-15 00:09:32.000000', 'consum', 0.0210, 'lps'),
	(578847, 128, '2014-03-15 00:09:33.000000', 'consum', 0.0214, 'lps'),
	(578848, 128, '2014-03-15 00:09:34.000000', 'consum', 0.0220, 'lps'),
	(578849, 128, '2014-03-15 00:09:35.000000', 'consum', 0.0214, 'lps'),
	(578850, 128, '2014-03-15 00:09:36.000000', 'consum', 0.0213, 'lps'),
	(578851, 128, '2014-03-15 00:09:37.000000', 'consum', 0.0215, 'lps'),
	(578852, 128, '2014-03-15 00:09:38.000000', 'consum', 0.0214, 'lps'),
	(578853, 128, '2014-03-15 00:09:39.000000', 'consum', 0.0218, 'lps'),
	(578854, 128, '2014-03-15 00:09:40.000000', 'consum', 0.0214, 'lps'),
	(578855, 128, '2014-03-15 00:09:41.000000', 'consum', 0.0219, 'lps'),
	(578856, 128, '2014-03-15 00:09:42.000000', 'consum', 0.0210, 'lps'),
	(578857, 128, '2014-03-15 00:09:43.000000', 'consum', 0.0216, 'lps'),
	(578858, 128, '2014-03-15 00:09:44.000000', 'consum', 0.0217, 'lps'),
	(578859, 128, '2014-03-15 00:09:45.000000', 'consum', 0.0218, 'lps'),
	(578860, 128, '2014-03-15 00:09:46.000000', 'consum', 0.0219, 'lps'),
	(578861, 128, '2014-03-15 00:09:47.000000', 'consum', 0.0218, 'lps'),
	(578862, 128, '2014-03-15 00:09:48.000000', 'consum', 0.0215, 'lps'),
	(578863, 128, '2014-03-15 00:09:49.000000', 'consum', 0.0220, 'lps'),
	(578864, 128, '2014-03-15 00:09:50.000000', 'consum', 0.0214, 'lps'),
	(578865, 128, '2014-03-15 00:09:51.000000', 'consum', 0.0211, 'lps'),
	(578866, 128, '2014-03-15 00:09:52.000000', 'consum', 0.0215, 'lps'),
	(578867, 128, '2014-03-15 00:09:53.000000', 'consum', 0.0220, 'lps'),
	(578868, 128, '2014-03-15 00:09:54.000000', 'consum', 0.0213, 'lps'),
	(578869, 128, '2014-03-15 00:09:55.000000', 'consum', 0.0216, 'lps'),
	(578870, 128, '2014-03-15 00:09:56.000000', 'consum', 0.0210, 'lps'),
	(578871, 128, '2014-03-15 00:09:57.000000', 'consum', 0.0213, 'lps'),
	(578872, 128, '2014-03-15 00:09:58.000000', 'consum', 0.0215, 'lps'),
	(578873, 128, '2014-03-15 00:09:59.000000', 'consum', 0.0218, 'lps'),
	(578874, 128, '2014-03-15 00:10:00.000000', 'consum', 0.0212, 'lps'),
	(578875, 128, '2014-03-15 00:10:01.000000', 'consum', 0.0210, 'lps'),
	(578876, 128, '2014-03-15 00:10:02.000000', 'consum', 0.0212, 'lps'),
	(578877, 128, '2014-03-15 00:10:03.000000', 'consum', 0.0210, 'lps'),
	(578878, 128, '2014-03-15 00:10:04.000000', 'consum', 0.0216, 'lps'),
	(578879, 128, '2014-03-15 00:10:05.000000', 'consum', 0.0220, 'lps'),
	(578880, 128, '2014-03-15 00:10:06.000000', 'consum', 0.0219, 'lps'),
	(578881, 128, '2014-03-15 00:10:07.000000', 'consum', 0.0213, 'lps'),
	(578882, 128, '2014-03-15 00:10:08.000000', 'consum', 0.0212, 'lps'),
	(578883, 128, '2014-03-15 00:10:09.000000', 'consum', 0.0212, 'lps'),
	(578884, 128, '2014-03-15 00:10:10.000000', 'consum', 0.0212, 'lps'),
	(578885, 128, '2014-03-15 00:10:11.000000', 'consum', 0.0218, 'lps'),
	(578886, 128, '2014-03-15 00:10:12.000000', 'consum', 0.0219, 'lps'),
	(578887, 128, '2014-03-15 00:10:13.000000', 'consum', 0.0210, 'lps'),
	(578888, 128, '2014-03-15 00:10:14.000000', 'consum', 0.0217, 'lps'),
	(578889, 128, '2014-03-15 00:10:15.000000', 'consum', 0.0213, 'lps'),
	(578890, 128, '2014-03-15 00:10:16.000000', 'consum', 0.0214, 'lps'),
	(578891, 128, '2014-03-15 00:10:17.000000', 'consum', 0.0211, 'lps'),
	(578892, 128, '2014-03-15 00:10:18.000000', 'consum', 0.0213, 'lps'),
	(578893, 128, '2014-03-15 00:10:19.000000', 'consum', 0.0212, 'lps'),
	(578894, 128, '2014-03-15 00:10:20.000000', 'consum', 0.0211, 'lps'),
	(578895, 128, '2014-03-15 00:10:21.000000', 'consum', 0.0219, 'lps'),
	(578896, 128, '2014-03-15 00:10:22.000000', 'consum', 0.0211, 'lps'),
	(578897, 128, '2014-03-15 00:10:23.000000', 'consum', 0.0220, 'lps'),
	(578898, 128, '2014-03-15 00:10:24.000000', 'consum', 0.0215, 'lps'),
	(578899, 128, '2014-03-15 00:10:25.000000', 'consum', 0.0215, 'lps'),
	(578900, 128, '2014-03-15 00:10:26.000000', 'consum', 0.0211, 'lps'),
	(578901, 128, '2014-03-15 00:10:27.000000', 'consum', 0.0212, 'lps'),
	(578902, 128, '2014-03-15 00:10:28.000000', 'consum', 0.0218, 'lps'),
	(578903, 128, '2014-03-15 00:10:29.000000', 'consum', 0.0210, 'lps'),
	(578904, 128, '2014-03-15 00:10:30.000000', 'consum', 0.0218, 'lps'),
	(578905, 128, '2014-03-15 00:10:31.000000', 'consum', 0.0220, 'lps'),
	(578906, 128, '2014-03-15 00:10:32.000000', 'consum', 0.0214, 'lps'),
	(578907, 128, '2014-03-15 00:10:33.000000', 'consum', 0.0212, 'lps'),
	(578908, 128, '2014-03-15 00:10:34.000000', 'consum', 0.0217, 'lps'),
	(578909, 128, '2014-03-15 00:10:35.000000', 'consum', 0.0218, 'lps'),
	(578910, 128, '2014-03-15 00:10:36.000000', 'consum', 0.0210, 'lps'),
	(578911, 128, '2014-03-15 00:10:37.000000', 'consum', 0.0218, 'lps'),
	(578912, 128, '2014-03-15 00:10:38.000000', 'consum', 0.0216, 'lps'),
	(578913, 128, '2014-03-15 00:10:39.000000', 'consum', 0.0218, 'lps'),
	(578914, 128, '2014-03-15 00:10:40.000000', 'consum', 0.0211, 'lps'),
	(578915, 128, '2014-03-15 00:10:41.000000', 'consum', 0.0212, 'lps'),
	(578916, 128, '2014-03-15 00:10:42.000000', 'consum', 0.0220, 'lps'),
	(578917, 128, '2014-03-15 00:10:43.000000', 'consum', 0.0210, 'lps'),
	(578918, 128, '2014-03-15 00:10:44.000000', 'consum', 0.0215, 'lps'),
	(578919, 128, '2014-03-15 00:10:45.000000', 'consum', 0.0210, 'lps'),
	(578920, 128, '2014-03-15 00:10:46.000000', 'consum', 0.0210, 'lps'),
	(578921, 128, '2014-03-15 00:10:47.000000', 'consum', 0.0219, 'lps'),
	(578922, 128, '2014-03-15 00:10:48.000000', 'consum', 0.0211, 'lps'),
	(578923, 128, '2014-03-15 00:10:49.000000', 'consum', 0.0213, 'lps'),
	(578924, 128, '2014-03-15 00:10:50.000000', 'consum', 0.0210, 'lps'),
	(578925, 128, '2014-03-15 00:10:51.000000', 'consum', 0.0211, 'lps'),
	(578926, 128, '2014-03-15 00:10:52.000000', 'consum', 0.0217, 'lps'),
	(578927, 128, '2014-03-15 00:10:53.000000', 'consum', 0.0219, 'lps'),
	(578928, 128, '2014-03-15 00:10:54.000000', 'consum', 0.0214, 'lps'),
	(578929, 128, '2014-03-15 00:10:55.000000', 'consum', 0.0212, 'lps'),
	(578930, 128, '2014-03-15 00:10:56.000000', 'consum', 0.0210, 'lps'),
	(578931, 128, '2014-03-15 00:10:57.000000', 'consum', 0.0217, 'lps'),
	(578932, 128, '2014-03-15 00:10:58.000000', 'consum', 0.0211, 'lps'),
	(578933, 128, '2014-03-15 00:10:59.000000', 'consum', 0.0217, 'lps'),
	(578934, 128, '2014-03-15 00:11:00.000000', 'consum', 0.0219, 'lps'),
	(578935, 128, '2014-03-15 00:11:01.000000', 'consum', 0.0215, 'lps'),
	(578936, 128, '2014-03-15 00:11:02.000000', 'consum', 0.0219, 'lps'),
	(578937, 128, '2014-03-15 00:11:03.000000', 'consum', 0.0218, 'lps'),
	(578938, 128, '2014-03-15 00:11:04.000000', 'consum', 0.0213, 'lps'),
	(578939, 128, '2014-03-15 00:11:05.000000', 'consum', 0.0212, 'lps'),
	(578940, 128, '2014-03-15 00:11:06.000000', 'consum', 0.0210, 'lps'),
	(578941, 128, '2014-03-15 00:11:07.000000', 'consum', 0.0218, 'lps'),
	(578942, 128, '2014-03-15 00:11:08.000000', 'consum', 0.0218, 'lps'),
	(578943, 128, '2014-03-15 00:11:09.000000', 'consum', 0.0215, 'lps'),
	(578944, 128, '2014-03-15 00:11:10.000000', 'consum', 0.0213, 'lps'),
	(578945, 128, '2014-03-15 00:11:11.000000', 'consum', 0.0220, 'lps'),
	(578946, 128, '2014-03-15 00:11:12.000000', 'consum', 0.0210, 'lps'),
	(578947, 128, '2014-03-15 00:11:13.000000', 'consum', 0.0210, 'lps'),
	(578948, 128, '2014-03-15 00:11:14.000000', 'consum', 0.0214, 'lps'),
	(578949, 128, '2014-03-15 00:11:15.000000', 'consum', 0.0216, 'lps'),
	(578950, 128, '2014-03-15 00:11:16.000000', 'consum', 0.0220, 'lps'),
	(578951, 128, '2014-03-15 00:11:17.000000', 'consum', 0.0220, 'lps'),
	(578952, 128, '2014-03-15 00:11:18.000000', 'consum', 0.0219, 'lps'),
	(578953, 128, '2014-03-15 00:11:19.000000', 'consum', 0.0215, 'lps'),
	(578954, 128, '2014-03-15 00:11:20.000000', 'consum', 0.0219, 'lps'),
	(578955, 128, '2014-03-15 00:11:21.000000', 'consum', 0.0217, 'lps'),
	(578956, 128, '2014-03-15 00:11:22.000000', 'consum', 0.0220, 'lps'),
	(578957, 128, '2014-03-15 00:11:23.000000', 'consum', 0.0219, 'lps'),
	(578958, 128, '2014-03-15 00:11:24.000000', 'consum', 0.0212, 'lps'),
	(578959, 128, '2014-03-15 00:11:25.000000', 'consum', 0.0217, 'lps'),
	(578960, 128, '2014-03-15 00:11:26.000000', 'consum', 0.0218, 'lps'),
	(578961, 128, '2014-03-15 00:11:27.000000', 'consum', 0.0217, 'lps'),
	(578962, 128, '2014-03-15 00:11:28.000000', 'consum', 0.0210, 'lps'),
	(578963, 128, '2014-03-15 00:11:29.000000', 'consum', 0.0211, 'lps'),
	(578964, 128, '2014-03-15 00:11:30.000000', 'consum', 0.0217, 'lps'),
	(578965, 128, '2014-03-15 00:11:31.000000', 'consum', 0.0219, 'lps'),
	(578966, 128, '2014-03-15 00:11:32.000000', 'consum', 0.0215, 'lps'),
	(578967, 128, '2014-03-15 00:11:33.000000', 'consum', 0.0218, 'lps'),
	(578968, 128, '2014-03-15 00:11:34.000000', 'consum', 0.0213, 'lps'),
	(578969, 128, '2014-03-15 00:11:35.000000', 'consum', 0.0211, 'lps'),
	(578970, 128, '2014-03-15 00:11:36.000000', 'consum', 0.0210, 'lps'),
	(578971, 128, '2014-03-15 00:11:37.000000', 'consum', 0.0217, 'lps'),
	(578972, 128, '2014-03-15 00:11:38.000000', 'consum', 0.0211, 'lps'),
	(578973, 128, '2014-03-15 00:11:39.000000', 'consum', 0.0217, 'lps'),
	(578974, 128, '2014-03-15 00:11:40.000000', 'consum', 0.0220, 'lps'),
	(578975, 128, '2014-03-15 00:11:41.000000', 'consum', 0.0220, 'lps'),
	(578976, 128, '2014-03-15 00:11:42.000000', 'consum', 0.0219, 'lps'),
	(578977, 128, '2014-03-15 00:11:43.000000', 'consum', 0.0214, 'lps'),
	(578978, 128, '2014-03-15 00:11:44.000000', 'consum', 0.0216, 'lps'),
	(578979, 128, '2014-03-15 00:11:45.000000', 'consum', 0.0214, 'lps'),
	(578980, 128, '2014-03-15 00:11:46.000000', 'consum', 0.0215, 'lps'),
	(578981, 128, '2014-03-15 00:11:47.000000', 'consum', 0.0214, 'lps'),
	(578982, 128, '2014-03-15 00:11:48.000000', 'consum', 0.0214, 'lps'),
	(578983, 128, '2014-03-15 00:11:49.000000', 'consum', 0.0217, 'lps'),
	(578984, 128, '2014-03-15 00:11:50.000000', 'consum', 0.0213, 'lps'),
	(578985, 128, '2014-03-15 00:11:51.000000', 'consum', 0.0216, 'lps'),
	(578986, 128, '2014-03-15 00:11:52.000000', 'consum', 0.0211, 'lps'),
	(578987, 128, '2014-03-15 00:11:53.000000', 'consum', 0.0217, 'lps'),
	(578988, 128, '2014-03-15 00:11:54.000000', 'consum', 0.0212, 'lps'),
	(578989, 128, '2014-03-15 00:11:55.000000', 'consum', 0.0220, 'lps'),
	(578990, 128, '2014-03-15 00:11:56.000000', 'consum', 0.0211, 'lps'),
	(578991, 128, '2014-03-15 00:11:57.000000', 'consum', 0.0217, 'lps'),
	(578992, 128, '2014-03-15 00:11:58.000000', 'consum', 0.0210, 'lps'),
	(578993, 128, '2014-03-15 00:11:59.000000', 'consum', 0.0210, 'lps'),
	(578994, 128, '2014-03-15 00:12:00.000000', 'consum', 0.0212, 'lps'),
	(578995, 128, '2014-03-15 00:12:01.000000', 'consum', 0.0211, 'lps'),
	(578996, 128, '2014-03-15 00:12:02.000000', 'consum', 0.0219, 'lps'),
	(578997, 128, '2014-03-15 00:12:03.000000', 'consum', 0.0218, 'lps'),
	(578998, 128, '2014-03-15 00:12:04.000000', 'consum', 0.0215, 'lps'),
	(578999, 128, '2014-03-15 00:12:05.000000', 'consum', 0.0211, 'lps'),
	(579000, 128, '2014-03-15 00:12:06.000000', 'consum', 0.0211, 'lps'),
	(579001, 128, '2014-03-15 00:12:07.000000', 'consum', 0.0213, 'lps'),
	(579002, 128, '2014-03-15 00:12:08.000000', 'consum', 0.0213, 'lps'),
	(579003, 128, '2014-03-15 00:12:09.000000', 'consum', 0.0213, 'lps'),
	(579004, 128, '2014-03-15 00:12:10.000000', 'consum', 0.0219, 'lps'),
	(579005, 128, '2014-03-15 00:12:11.000000', 'consum', 0.0213, 'lps'),
	(579006, 128, '2014-03-15 00:12:12.000000', 'consum', 0.0211, 'lps'),
	(579007, 128, '2014-03-15 00:12:13.000000', 'consum', 0.0218, 'lps'),
	(579008, 128, '2014-03-15 00:12:14.000000', 'consum', 0.0212, 'lps'),
	(579009, 128, '2014-03-15 00:12:15.000000', 'consum', 0.0210, 'lps'),
	(579010, 128, '2014-03-15 00:12:16.000000', 'consum', 0.0215, 'lps'),
	(579011, 128, '2014-03-15 00:12:17.000000', 'consum', 0.0212, 'lps'),
	(579012, 128, '2014-03-15 00:12:18.000000', 'consum', 0.0219, 'lps'),
	(579013, 128, '2014-03-15 00:12:19.000000', 'consum', 0.0215, 'lps'),
	(579014, 128, '2014-03-15 00:12:20.000000', 'consum', 0.0211, 'lps'),
	(579015, 128, '2014-03-15 00:12:21.000000', 'consum', 0.0219, 'lps'),
	(579016, 128, '2014-03-15 00:12:22.000000', 'consum', 0.0211, 'lps'),
	(579017, 128, '2014-03-15 00:12:23.000000', 'consum', 0.0210, 'lps'),
	(579018, 128, '2014-03-15 00:12:24.000000', 'consum', 0.0219, 'lps'),
	(579019, 128, '2014-03-15 00:12:25.000000', 'consum', 0.0211, 'lps'),
	(579020, 128, '2014-03-15 00:12:26.000000', 'consum', 0.0220, 'lps'),
	(579021, 128, '2014-03-15 00:12:27.000000', 'consum', 0.0216, 'lps'),
	(579022, 128, '2014-03-15 00:12:28.000000', 'consum', 0.0211, 'lps'),
	(579023, 128, '2014-03-15 00:12:29.000000', 'consum', 0.0218, 'lps'),
	(579024, 128, '2014-03-15 00:12:30.000000', 'consum', 0.0216, 'lps'),
	(579025, 128, '2014-03-15 00:12:31.000000', 'consum', 0.0216, 'lps'),
	(579026, 128, '2014-03-15 00:12:32.000000', 'consum', 0.0213, 'lps'),
	(579027, 128, '2014-03-15 00:12:33.000000', 'consum', 0.0218, 'lps'),
	(579028, 128, '2014-03-15 00:12:34.000000', 'consum', 0.0218, 'lps'),
	(579029, 128, '2014-03-15 00:12:35.000000', 'consum', 0.0218, 'lps'),
	(579030, 128, '2014-03-15 00:12:36.000000', 'consum', 0.0216, 'lps'),
	(579031, 128, '2014-03-15 00:12:37.000000', 'consum', 0.0214, 'lps'),
	(579032, 128, '2014-03-15 00:12:38.000000', 'consum', 0.0211, 'lps'),
	(579033, 128, '2014-03-15 00:12:39.000000', 'consum', 0.0218, 'lps'),
	(579034, 128, '2014-03-15 00:12:40.000000', 'consum', 0.0211, 'lps'),
	(579035, 128, '2014-03-15 00:12:41.000000', 'consum', 0.0216, 'lps'),
	(579036, 128, '2014-03-15 00:12:42.000000', 'consum', 0.0214, 'lps'),
	(579037, 128, '2014-03-15 00:12:43.000000', 'consum', 0.0215, 'lps'),
	(579038, 128, '2014-03-15 00:12:44.000000', 'consum', 0.0210, 'lps'),
	(579039, 128, '2014-03-15 00:12:45.000000', 'consum', 0.0217, 'lps'),
	(579040, 128, '2014-03-15 00:12:46.000000', 'consum', 0.0214, 'lps'),
	(579041, 128, '2014-03-15 00:12:47.000000', 'consum', 0.0210, 'lps'),
	(579042, 128, '2014-03-15 00:12:48.000000', 'consum', 0.0211, 'lps'),
	(579043, 128, '2014-03-15 00:12:49.000000', 'consum', 0.0212, 'lps'),
	(579044, 128, '2014-03-15 00:12:50.000000', 'consum', 0.0220, 'lps'),
	(579045, 128, '2014-03-15 00:12:51.000000', 'consum', 0.0210, 'lps'),
	(579046, 128, '2014-03-15 00:12:52.000000', 'consum', 0.0211, 'lps'),
	(579047, 128, '2014-03-15 00:12:53.000000', 'consum', 0.0219, 'lps'),
	(579048, 128, '2014-03-15 00:12:54.000000', 'consum', 0.0218, 'lps'),
	(579049, 128, '2014-03-15 00:12:55.000000', 'consum', 0.0214, 'lps'),
	(579050, 128, '2014-03-15 00:12:56.000000', 'consum', 0.0217, 'lps'),
	(579051, 128, '2014-03-15 00:12:57.000000', 'consum', 0.0213, 'lps'),
	(579052, 128, '2014-03-15 00:12:58.000000', 'consum', 0.0212, 'lps'),
	(579053, 128, '2014-03-15 00:12:59.000000', 'consum', 0.0214, 'lps'),
	(579054, 128, '2014-03-15 00:13:00.000000', 'consum', 0.0211, 'lps'),
	(579055, 128, '2014-03-15 00:13:01.000000', 'consum', 0.0217, 'lps'),
	(579056, 128, '2014-03-15 00:13:02.000000', 'consum', 0.0211, 'lps'),
	(579057, 128, '2014-03-15 00:13:03.000000', 'consum', 0.0213, 'lps'),
	(579058, 128, '2014-03-15 00:13:04.000000', 'consum', 0.0215, 'lps'),
	(579059, 128, '2014-03-15 00:13:05.000000', 'consum', 0.0213, 'lps'),
	(579060, 128, '2014-03-15 00:13:06.000000', 'consum', 0.0211, 'lps'),
	(579061, 128, '2014-03-15 00:13:07.000000', 'consum', 0.0217, 'lps'),
	(579062, 128, '2014-03-15 00:13:08.000000', 'consum', 0.0219, 'lps'),
	(579063, 128, '2014-03-15 00:13:09.000000', 'consum', 0.0214, 'lps'),
	(579064, 128, '2014-03-15 00:13:10.000000', 'consum', 0.0213, 'lps'),
	(579065, 128, '2014-03-15 00:13:11.000000', 'consum', 0.0215, 'lps'),
	(579066, 128, '2014-03-15 00:13:12.000000', 'consum', 0.0216, 'lps'),
	(579067, 128, '2014-03-15 00:13:13.000000', 'consum', 0.0213, 'lps'),
	(579068, 128, '2014-03-15 00:13:14.000000', 'consum', 0.0219, 'lps'),
	(579069, 128, '2014-03-15 00:13:15.000000', 'consum', 0.0213, 'lps'),
	(579070, 128, '2014-03-15 00:13:16.000000', 'consum', 0.0219, 'lps'),
	(579071, 128, '2014-03-15 00:13:17.000000', 'consum', 0.0215, 'lps'),
	(579072, 128, '2014-03-15 00:13:18.000000', 'consum', 0.0210, 'lps'),
	(579073, 128, '2014-03-15 00:13:19.000000', 'consum', 0.0217, 'lps'),
	(579074, 128, '2014-03-15 00:13:20.000000', 'consum', 0.0214, 'lps'),
	(579075, 128, '2014-03-15 00:13:21.000000', 'consum', 0.0217, 'lps'),
	(579076, 128, '2014-03-15 00:13:22.000000', 'consum', 0.0213, 'lps'),
	(579077, 128, '2014-03-15 00:13:23.000000', 'consum', 0.0216, 'lps'),
	(579078, 128, '2014-03-15 00:13:24.000000', 'consum', 0.0218, 'lps'),
	(579079, 128, '2014-03-15 00:13:25.000000', 'consum', 0.0213, 'lps'),
	(579080, 128, '2014-03-15 00:13:26.000000', 'consum', 0.0213, 'lps'),
	(579081, 128, '2014-03-15 00:13:27.000000', 'consum', 0.0215, 'lps'),
	(579082, 128, '2014-03-15 00:13:28.000000', 'consum', 0.0215, 'lps'),
	(579083, 128, '2014-03-15 00:13:29.000000', 'consum', 0.0220, 'lps'),
	(579084, 128, '2014-03-15 00:13:30.000000', 'consum', 0.0213, 'lps'),
	(579085, 128, '2014-03-15 00:13:31.000000', 'consum', 0.0217, 'lps'),
	(579086, 128, '2014-03-15 00:13:32.000000', 'consum', 0.0214, 'lps'),
	(579087, 128, '2014-03-15 00:13:33.000000', 'consum', 0.0220, 'lps'),
	(579088, 128, '2014-03-15 00:13:34.000000', 'consum', 0.0218, 'lps'),
	(579089, 128, '2014-03-15 00:13:35.000000', 'consum', 0.0220, 'lps'),
	(579090, 128, '2014-03-15 00:13:36.000000', 'consum', 0.0215, 'lps'),
	(579091, 128, '2014-03-15 00:13:37.000000', 'consum', 0.0215, 'lps'),
	(579092, 128, '2014-03-15 00:13:38.000000', 'consum', 0.0210, 'lps'),
	(579093, 128, '2014-03-15 00:13:39.000000', 'consum', 0.0216, 'lps'),
	(579094, 128, '2014-03-15 00:13:40.000000', 'consum', 0.0210, 'lps'),
	(579095, 128, '2014-03-15 00:13:41.000000', 'consum', 0.0215, 'lps'),
	(579096, 128, '2014-03-15 00:13:42.000000', 'consum', 0.0211, 'lps'),
	(579097, 128, '2014-03-15 00:13:43.000000', 'consum', 0.0211, 'lps'),
	(579098, 128, '2014-03-15 00:13:44.000000', 'consum', 0.0213, 'lps'),
	(579099, 128, '2014-03-15 00:13:45.000000', 'consum', 0.0212, 'lps'),
	(579100, 128, '2014-03-15 00:13:46.000000', 'consum', 0.0213, 'lps'),
	(579101, 128, '2014-03-15 00:13:47.000000', 'consum', 0.0220, 'lps'),
	(579102, 128, '2014-03-15 00:13:48.000000', 'consum', 0.0216, 'lps'),
	(579103, 128, '2014-03-15 00:13:49.000000', 'consum', 0.0210, 'lps'),
	(579104, 128, '2014-03-15 00:13:50.000000', 'consum', 0.0215, 'lps'),
	(579105, 128, '2014-03-15 00:13:51.000000', 'consum', 0.0215, 'lps'),
	(579106, 128, '2014-03-15 00:13:52.000000', 'consum', 0.0219, 'lps'),
	(579107, 128, '2014-03-15 00:13:53.000000', 'consum', 0.0217, 'lps'),
	(579108, 128, '2014-03-15 00:13:54.000000', 'consum', 0.0220, 'lps'),
	(579109, 128, '2014-03-15 00:13:55.000000', 'consum', 0.0218, 'lps'),
	(579110, 128, '2014-03-15 00:13:56.000000', 'consum', 0.0211, 'lps'),
	(579111, 128, '2014-03-15 00:13:57.000000', 'consum', 0.0211, 'lps'),
	(579112, 128, '2014-03-15 00:13:58.000000', 'consum', 0.0215, 'lps'),
	(579113, 128, '2014-03-15 00:13:59.000000', 'consum', 0.0211, 'lps'),
	(579114, 128, '2014-03-15 00:14:00.000000', 'consum', 0.0211, 'lps'),
	(579115, 128, '2014-03-15 00:14:01.000000', 'consum', 0.0211, 'lps'),
	(579116, 128, '2014-03-15 00:14:02.000000', 'consum', 0.0211, 'lps'),
	(579117, 128, '2014-03-15 00:14:03.000000', 'consum', 0.0215, 'lps'),
	(579118, 128, '2014-03-15 00:14:04.000000', 'consum', 0.0211, 'lps'),
	(579119, 128, '2014-03-15 00:14:05.000000', 'consum', 0.0211, 'lps'),
	(579120, 128, '2014-03-15 00:14:06.000000', 'consum', 0.0211, 'lps'),
	(579121, 128, '2014-03-15 00:14:07.000000', 'consum', 0.0215, 'lps'),
	(579122, 128, '2014-03-15 00:14:08.000000', 'consum', 0.0210, 'lps'),
	(579123, 128, '2014-03-15 00:14:09.000000', 'consum', 0.0217, 'lps'),
	(579124, 128, '2014-03-15 00:14:10.000000', 'consum', 0.0214, 'lps'),
	(579125, 128, '2014-03-15 00:14:11.000000', 'consum', 0.0220, 'lps'),
	(579126, 128, '2014-03-15 00:14:12.000000', 'consum', 0.0215, 'lps'),
	(579127, 128, '2014-03-15 00:14:13.000000', 'consum', 0.0219, 'lps'),
	(579128, 128, '2014-03-15 00:14:14.000000', 'consum', 0.0216, 'lps'),
	(579129, 128, '2014-03-15 00:14:15.000000', 'consum', 0.0213, 'lps'),
	(579130, 128, '2014-03-15 00:14:16.000000', 'consum', 0.0219, 'lps'),
	(579131, 128, '2014-03-15 00:14:17.000000', 'consum', 0.0213, 'lps'),
	(579132, 128, '2014-03-15 00:14:18.000000', 'consum', 0.0219, 'lps'),
	(579133, 128, '2014-03-15 00:14:19.000000', 'consum', 0.0214, 'lps'),
	(579134, 128, '2014-03-15 00:14:20.000000', 'consum', 0.0216, 'lps'),
	(579135, 128, '2014-03-15 00:14:21.000000', 'consum', 0.0216, 'lps'),
	(579136, 128, '2014-03-15 00:14:22.000000', 'consum', 0.0211, 'lps'),
	(579137, 128, '2014-03-15 00:14:23.000000', 'consum', 0.0220, 'lps'),
	(579138, 128, '2014-03-15 00:14:24.000000', 'consum', 0.0212, 'lps'),
	(579139, 128, '2014-03-15 00:14:25.000000', 'consum', 0.0212, 'lps'),
	(579140, 128, '2014-03-15 00:14:26.000000', 'consum', 0.0218, 'lps'),
	(579141, 128, '2014-03-15 00:14:27.000000', 'consum', 0.0219, 'lps'),
	(579142, 128, '2014-03-15 00:14:28.000000', 'consum', 0.0213, 'lps'),
	(579143, 128, '2014-03-15 00:14:29.000000', 'consum', 0.0218, 'lps'),
	(579144, 128, '2014-03-15 00:14:30.000000', 'consum', 0.0210, 'lps'),
	(579145, 128, '2014-03-15 00:14:31.000000', 'consum', 0.0220, 'lps'),
	(579146, 128, '2014-03-15 00:14:32.000000', 'consum', 0.0214, 'lps'),
	(579147, 128, '2014-03-15 00:14:33.000000', 'consum', 0.0212, 'lps'),
	(579148, 128, '2014-03-15 00:14:34.000000', 'consum', 0.0211, 'lps'),
	(579149, 128, '2014-03-15 00:14:35.000000', 'consum', 0.0219, 'lps'),
	(579150, 128, '2014-03-15 00:14:36.000000', 'consum', 0.0218, 'lps'),
	(579151, 128, '2014-03-15 00:14:37.000000', 'consum', 0.0213, 'lps'),
	(579152, 128, '2014-03-15 00:14:38.000000', 'consum', 0.0213, 'lps'),
	(579153, 128, '2014-03-15 00:14:39.000000', 'consum', 0.0216, 'lps'),
	(579154, 128, '2014-03-15 00:14:40.000000', 'consum', 0.0220, 'lps'),
	(579155, 128, '2014-03-15 00:14:41.000000', 'consum', 0.0211, 'lps'),
	(579156, 128, '2014-03-15 00:14:42.000000', 'consum', 0.0220, 'lps'),
	(579157, 128, '2014-03-15 00:14:43.000000', 'consum', 0.0211, 'lps'),
	(579158, 128, '2014-03-15 00:14:44.000000', 'consum', 0.0218, 'lps'),
	(579159, 128, '2014-03-15 00:14:45.000000', 'consum', 0.0217, 'lps'),
	(579160, 128, '2014-03-15 00:14:46.000000', 'consum', 0.0210, 'lps'),
	(579161, 128, '2014-03-15 00:14:47.000000', 'consum', 0.0210, 'lps'),
	(579162, 128, '2014-03-15 00:14:48.000000', 'consum', 0.0211, 'lps'),
	(579163, 128, '2014-03-15 00:14:49.000000', 'consum', 0.0216, 'lps'),
	(579164, 128, '2014-03-15 00:14:50.000000', 'consum', 0.0216, 'lps'),
	(579165, 128, '2014-03-15 00:14:51.000000', 'consum', 0.0211, 'lps'),
	(579166, 128, '2014-03-15 00:14:52.000000', 'consum', 0.0210, 'lps'),
	(579167, 128, '2014-03-15 00:14:53.000000', 'consum', 0.0216, 'lps'),
	(579168, 128, '2014-03-15 00:14:54.000000', 'consum', 0.0219, 'lps'),
	(579169, 128, '2014-03-15 00:14:55.000000', 'consum', 0.0218, 'lps'),
	(579170, 128, '2014-03-15 00:14:56.000000', 'consum', 0.0220, 'lps'),
	(579171, 128, '2014-03-15 00:14:57.000000', 'consum', 0.0216, 'lps'),
	(579172, 128, '2014-03-15 00:14:58.000000', 'consum', 0.0220, 'lps'),
	(579173, 128, '2014-03-15 00:14:59.000000', 'consum', 0.0220, 'lps'),
	(579174, 128, '2014-03-15 00:15:00.000000', 'consum', 0.0219, 'lps'),
	(579175, 128, '2014-03-15 00:15:01.000000', 'consum', 0.0214, 'lps'),
	(579176, 128, '2014-03-15 00:15:02.000000', 'consum', 0.0215, 'lps'),
	(579177, 128, '2014-03-15 00:15:03.000000', 'consum', 0.0211, 'lps'),
	(579178, 128, '2014-03-15 00:15:04.000000', 'consum', 0.0213, 'lps'),
	(579179, 128, '2014-03-15 00:15:05.000000', 'consum', 0.0212, 'lps'),
	(579180, 128, '2014-03-15 00:15:06.000000', 'consum', 0.0211, 'lps'),
	(579181, 128, '2014-03-15 00:15:07.000000', 'consum', 0.0220, 'lps'),
	(579182, 128, '2014-03-15 00:15:08.000000', 'consum', 0.0212, 'lps'),
	(579183, 128, '2014-03-15 00:15:09.000000', 'consum', 0.0213, 'lps'),
	(579184, 128, '2014-03-15 00:15:10.000000', 'consum', 0.0211, 'lps'),
	(579185, 128, '2014-03-15 00:15:11.000000', 'consum', 0.0215, 'lps'),
	(579186, 128, '2014-03-15 00:15:12.000000', 'consum', 0.0211, 'lps'),
	(579187, 128, '2014-03-15 00:15:13.000000', 'consum', 0.0213, 'lps'),
	(579188, 128, '2014-03-15 00:15:14.000000', 'consum', 0.0212, 'lps'),
	(579189, 128, '2014-03-15 00:15:15.000000', 'consum', 0.0220, 'lps'),
	(579190, 128, '2014-03-15 00:15:16.000000', 'consum', 0.0213, 'lps'),
	(579191, 128, '2014-03-15 00:15:17.000000', 'consum', 0.0219, 'lps'),
	(579192, 128, '2014-03-15 00:15:18.000000', 'consum', 0.0210, 'lps'),
	(579193, 128, '2014-03-15 00:15:19.000000', 'consum', 0.0217, 'lps'),
	(579194, 128, '2014-03-15 00:15:20.000000', 'consum', 0.0211, 'lps'),
	(579195, 128, '2014-03-15 00:15:21.000000', 'consum', 0.0218, 'lps'),
	(579196, 128, '2014-03-15 00:15:22.000000', 'consum', 0.0215, 'lps'),
	(579197, 128, '2014-03-15 00:15:23.000000', 'consum', 0.0210, 'lps'),
	(579198, 128, '2014-03-15 00:15:24.000000', 'consum', 0.0216, 'lps'),
	(579199, 128, '2014-03-15 00:15:25.000000', 'consum', 0.0210, 'lps'),
	(579200, 128, '2014-03-15 00:15:26.000000', 'consum', 0.0213, 'lps'),
	(579201, 128, '2014-03-15 00:15:27.000000', 'consum', 0.0217, 'lps'),
	(579202, 128, '2014-03-15 00:15:28.000000', 'consum', 0.0213, 'lps'),
	(579203, 128, '2014-03-15 00:15:29.000000', 'consum', 0.0217, 'lps'),
	(579204, 128, '2014-03-15 00:15:30.000000', 'consum', 0.0215, 'lps'),
	(579205, 128, '2014-03-15 00:15:31.000000', 'consum', 0.0212, 'lps'),
	(579206, 128, '2014-03-15 00:15:32.000000', 'consum', 0.0216, 'lps'),
	(579207, 128, '2014-03-15 00:15:33.000000', 'consum', 0.0213, 'lps'),
	(579208, 128, '2014-03-15 00:15:34.000000', 'consum', 0.0218, 'lps'),
	(579209, 128, '2014-03-15 00:15:35.000000', 'consum', 0.0210, 'lps'),
	(579210, 128, '2014-03-15 00:15:36.000000', 'consum', 0.0220, 'lps'),
	(579211, 128, '2014-03-15 00:15:37.000000', 'consum', 0.0214, 'lps'),
	(579212, 128, '2014-03-15 00:15:38.000000', 'consum', 0.0213, 'lps'),
	(579213, 128, '2014-03-15 00:15:39.000000', 'consum', 0.0214, 'lps'),
	(579214, 128, '2014-03-15 00:15:40.000000', 'consum', 0.0211, 'lps'),
	(579215, 128, '2014-03-15 00:15:41.000000', 'consum', 0.0214, 'lps'),
	(579216, 128, '2014-03-15 00:15:42.000000', 'consum', 0.0216, 'lps'),
	(579217, 128, '2014-03-15 00:15:43.000000', 'consum', 0.0219, 'lps'),
	(579218, 128, '2014-03-15 00:15:44.000000', 'consum', 0.0216, 'lps'),
	(579219, 128, '2014-03-15 00:15:45.000000', 'consum', 0.0212, 'lps'),
	(579220, 128, '2014-03-15 00:15:46.000000', 'consum', 0.0213, 'lps'),
	(579221, 128, '2014-03-15 00:15:47.000000', 'consum', 0.0220, 'lps'),
	(579222, 128, '2014-03-15 00:15:48.000000', 'consum', 0.0218, 'lps'),
	(579223, 128, '2014-03-15 00:15:49.000000', 'consum', 0.0220, 'lps'),
	(579224, 128, '2014-03-15 00:15:50.000000', 'consum', 0.0217, 'lps'),
	(579225, 128, '2014-03-15 00:15:51.000000', 'consum', 0.0213, 'lps'),
	(579226, 128, '2014-03-15 00:15:52.000000', 'consum', 0.0216, 'lps'),
	(579227, 128, '2014-03-15 00:15:53.000000', 'consum', 0.0210, 'lps'),
	(579228, 128, '2014-03-15 00:15:54.000000', 'consum', 0.0216, 'lps'),
	(579229, 128, '2014-03-15 00:15:55.000000', 'consum', 0.0218, 'lps'),
	(579230, 128, '2014-03-15 00:15:56.000000', 'consum', 0.0212, 'lps'),
	(579231, 128, '2014-03-15 00:15:57.000000', 'consum', 0.0217, 'lps'),
	(579232, 128, '2014-03-15 00:15:58.000000', 'consum', 0.0219, 'lps'),
	(579233, 128, '2014-03-15 00:15:59.000000', 'consum', 0.0211, 'lps'),
	(579234, 128, '2014-03-15 00:16:00.000000', 'consum', 0.0211, 'lps'),
	(579235, 128, '2014-03-15 00:16:01.000000', 'consum', 0.0212, 'lps'),
	(579236, 128, '2014-03-15 00:16:02.000000', 'consum', 0.0217, 'lps'),
	(579237, 128, '2014-03-15 00:16:03.000000', 'consum', 0.0218, 'lps'),
	(579238, 128, '2014-03-15 00:16:04.000000', 'consum', 0.0210, 'lps'),
	(579239, 128, '2014-03-15 00:16:05.000000', 'consum', 0.0216, 'lps'),
	(579240, 128, '2014-03-15 00:16:06.000000', 'consum', 0.0218, 'lps'),
	(579241, 128, '2014-03-15 00:16:07.000000', 'consum', 0.0214, 'lps'),
	(579242, 128, '2014-03-15 00:16:08.000000', 'consum', 0.0214, 'lps'),
	(579243, 128, '2014-03-15 00:16:09.000000', 'consum', 0.0219, 'lps'),
	(579244, 128, '2014-03-15 00:16:10.000000', 'consum', 0.0213, 'lps'),
	(579245, 128, '2014-03-15 00:16:11.000000', 'consum', 0.0219, 'lps'),
	(579246, 128, '2014-03-15 00:16:12.000000', 'consum', 0.0214, 'lps'),
	(579247, 128, '2014-03-15 00:16:13.000000', 'consum', 0.0213, 'lps'),
	(579248, 128, '2014-03-15 00:16:14.000000', 'consum', 0.0216, 'lps'),
	(579249, 128, '2014-03-15 00:16:15.000000', 'consum', 0.0210, 'lps'),
	(579250, 128, '2014-03-15 00:16:16.000000', 'consum', 0.0212, 'lps'),
	(579251, 128, '2014-03-15 00:16:17.000000', 'consum', 0.0210, 'lps'),
	(579252, 128, '2014-03-15 00:16:18.000000', 'consum', 0.0216, 'lps'),
	(579253, 128, '2014-03-15 00:16:19.000000', 'consum', 0.0218, 'lps'),
	(579254, 128, '2014-03-15 00:16:20.000000', 'consum', 0.0212, 'lps'),
	(579255, 128, '2014-03-15 00:16:21.000000', 'consum', 0.0219, 'lps'),
	(579256, 128, '2014-03-15 00:16:22.000000', 'consum', 0.0214, 'lps'),
	(579257, 128, '2014-03-15 00:16:23.000000', 'consum', 0.0214, 'lps'),
	(579258, 128, '2014-03-15 00:16:24.000000', 'consum', 0.0219, 'lps'),
	(579259, 128, '2014-03-15 00:16:25.000000', 'consum', 0.0220, 'lps'),
	(579260, 128, '2014-03-15 00:16:26.000000', 'consum', 0.0213, 'lps'),
	(579261, 128, '2014-03-15 00:16:27.000000', 'consum', 0.0219, 'lps'),
	(579262, 128, '2014-03-15 00:16:28.000000', 'consum', 0.0214, 'lps'),
	(579263, 128, '2014-03-15 00:16:29.000000', 'consum', 0.0215, 'lps'),
	(579264, 128, '2014-03-15 00:16:30.000000', 'consum', 0.0212, 'lps'),
	(579265, 128, '2014-03-15 00:16:31.000000', 'consum', 0.0214, 'lps'),
	(579266, 128, '2014-03-15 00:16:32.000000', 'consum', 0.0216, 'lps'),
	(579267, 128, '2014-03-15 00:16:33.000000', 'consum', 0.0217, 'lps'),
	(579268, 128, '2014-03-15 00:16:34.000000', 'consum', 0.0215, 'lps'),
	(579269, 128, '2014-03-15 00:16:35.000000', 'consum', 0.0214, 'lps'),
	(579270, 128, '2014-03-15 00:16:36.000000', 'consum', 0.0218, 'lps'),
	(579271, 128, '2014-03-15 00:16:37.000000', 'consum', 0.0217, 'lps'),
	(579272, 128, '2014-03-15 00:16:38.000000', 'consum', 0.0211, 'lps'),
	(579273, 128, '2014-03-15 00:16:39.000000', 'consum', 0.0217, 'lps'),
	(579274, 128, '2014-03-15 00:16:40.000000', 'consum', 0.0218, 'lps'),
	(579275, 128, '2014-03-15 00:16:41.000000', 'consum', 0.0220, 'lps'),
	(579276, 128, '2014-03-15 00:16:42.000000', 'consum', 0.0214, 'lps'),
	(579277, 128, '2014-03-15 00:16:43.000000', 'consum', 0.0211, 'lps'),
	(579278, 128, '2014-03-15 00:16:44.000000', 'consum', 0.0214, 'lps'),
	(579279, 128, '2014-03-15 00:16:45.000000', 'consum', 0.0215, 'lps'),
	(579280, 128, '2014-03-15 00:16:46.000000', 'consum', 0.0214, 'lps'),
	(579281, 128, '2014-03-15 00:16:47.000000', 'consum', 0.0215, 'lps'),
	(579282, 128, '2014-03-15 00:16:48.000000', 'consum', 0.0215, 'lps'),
	(579283, 128, '2014-03-15 00:16:49.000000', 'consum', 0.0218, 'lps'),
	(579284, 128, '2014-03-15 00:16:50.000000', 'consum', 0.0212, 'lps'),
	(579285, 128, '2014-03-15 00:16:51.000000', 'consum', 0.0211, 'lps'),
	(579286, 128, '2014-03-15 00:16:52.000000', 'consum', 0.0218, 'lps'),
	(579287, 128, '2014-03-15 00:16:53.000000', 'consum', 0.0217, 'lps'),
	(579288, 128, '2014-03-15 00:16:54.000000', 'consum', 0.0210, 'lps'),
	(579289, 128, '2014-03-15 00:16:55.000000', 'consum', 0.0210, 'lps'),
	(579290, 128, '2014-03-15 00:16:56.000000', 'consum', 0.0220, 'lps'),
	(579291, 128, '2014-03-15 00:16:57.000000', 'consum', 0.0220, 'lps'),
	(579292, 128, '2014-03-15 00:16:58.000000', 'consum', 0.0216, 'lps'),
	(579293, 128, '2014-03-15 00:16:59.000000', 'consum', 0.0212, 'lps'),
	(579294, 128, '2014-03-15 00:17:00.000000', 'consum', 0.0214, 'lps'),
	(579295, 128, '2014-03-15 00:17:01.000000', 'consum', 0.0212, 'lps'),
	(579296, 128, '2014-03-15 00:17:02.000000', 'consum', 0.0210, 'lps'),
	(579297, 128, '2014-03-15 00:17:03.000000', 'consum', 0.0214, 'lps'),
	(579298, 128, '2014-03-15 00:17:04.000000', 'consum', 0.0219, 'lps'),
	(579299, 128, '2014-03-15 00:17:05.000000', 'consum', 0.0210, 'lps'),
	(579300, 128, '2014-03-15 00:17:06.000000', 'consum', 0.0218, 'lps'),
	(579301, 128, '2014-03-15 00:17:07.000000', 'consum', 0.0218, 'lps'),
	(579302, 128, '2014-03-15 00:17:08.000000', 'consum', 0.0216, 'lps'),
	(579303, 128, '2014-03-15 00:17:09.000000', 'consum', 0.0215, 'lps'),
	(579304, 128, '2014-03-15 00:17:10.000000', 'consum', 0.0217, 'lps'),
	(579305, 128, '2014-03-15 00:17:11.000000', 'consum', 0.0218, 'lps'),
	(579306, 128, '2014-03-15 00:17:12.000000', 'consum', 0.0210, 'lps'),
	(579307, 128, '2014-03-15 00:17:13.000000', 'consum', 0.0220, 'lps'),
	(579308, 128, '2014-03-15 00:17:14.000000', 'consum', 0.0215, 'lps'),
	(579309, 128, '2014-03-15 00:17:15.000000', 'consum', 0.0216, 'lps'),
	(579310, 128, '2014-03-15 00:17:16.000000', 'consum', 0.0214, 'lps'),
	(579311, 128, '2014-03-15 00:17:17.000000', 'consum', 0.0214, 'lps'),
	(579312, 128, '2014-03-15 00:17:18.000000', 'consum', 0.0219, 'lps'),
	(579313, 128, '2014-03-15 00:17:19.000000', 'consum', 0.0220, 'lps'),
	(579314, 128, '2014-03-15 00:17:20.000000', 'consum', 0.0213, 'lps'),
	(579315, 128, '2014-03-15 00:17:21.000000', 'consum', 0.0218, 'lps'),
	(579316, 128, '2014-03-15 00:17:22.000000', 'consum', 0.0218, 'lps'),
	(579317, 128, '2014-03-15 00:17:23.000000', 'consum', 0.0215, 'lps'),
	(579318, 128, '2014-03-15 00:17:24.000000', 'consum', 0.0213, 'lps'),
	(579319, 128, '2014-03-15 00:17:25.000000', 'consum', 0.0211, 'lps'),
	(579320, 128, '2014-03-15 00:17:26.000000', 'consum', 0.0215, 'lps'),
	(579321, 128, '2014-03-15 00:17:27.000000', 'consum', 0.0212, 'lps'),
	(579322, 128, '2014-03-15 00:17:28.000000', 'consum', 0.0215, 'lps'),
	(579323, 128, '2014-03-15 00:17:29.000000', 'consum', 0.0219, 'lps'),
	(579324, 128, '2014-03-15 00:17:30.000000', 'consum', 0.0217, 'lps'),
	(579325, 128, '2014-03-15 00:17:31.000000', 'consum', 0.0220, 'lps'),
	(579326, 128, '2014-03-15 00:17:32.000000', 'consum', 0.0219, 'lps'),
	(579327, 128, '2014-03-15 00:17:33.000000', 'consum', 0.0215, 'lps'),
	(579328, 128, '2014-03-15 00:17:34.000000', 'consum', 0.0219, 'lps'),
	(579329, 128, '2014-03-15 00:17:35.000000', 'consum', 0.0220, 'lps'),
	(579330, 128, '2014-03-15 00:17:36.000000', 'consum', 0.0220, 'lps'),
	(579331, 128, '2014-03-15 00:17:37.000000', 'consum', 0.0210, 'lps'),
	(579332, 128, '2014-03-15 00:17:38.000000', 'consum', 0.0213, 'lps'),
	(579333, 128, '2014-03-15 00:17:39.000000', 'consum', 0.0215, 'lps'),
	(579334, 128, '2014-03-15 00:17:40.000000', 'consum', 0.0214, 'lps'),
	(579335, 128, '2014-03-15 00:17:41.000000', 'consum', 0.0216, 'lps'),
	(579336, 128, '2014-03-15 00:17:42.000000', 'consum', 0.0219, 'lps'),
	(579337, 128, '2014-03-15 00:17:43.000000', 'consum', 0.0214, 'lps'),
	(579338, 128, '2014-03-15 00:17:44.000000', 'consum', 0.0217, 'lps'),
	(579339, 128, '2014-03-15 00:17:45.000000', 'consum', 0.0210, 'lps'),
	(579340, 128, '2014-03-15 00:17:46.000000', 'consum', 0.0210, 'lps'),
	(579341, 128, '2014-03-15 00:17:47.000000', 'consum', 0.0213, 'lps'),
	(579342, 128, '2014-03-15 00:17:48.000000', 'consum', 0.0212, 'lps'),
	(579343, 128, '2014-03-15 00:17:49.000000', 'consum', 0.0214, 'lps'),
	(579344, 128, '2014-03-15 00:17:50.000000', 'consum', 0.0214, 'lps'),
	(579345, 128, '2014-03-15 00:17:51.000000', 'consum', 0.0219, 'lps'),
	(579346, 128, '2014-03-15 00:17:52.000000', 'consum', 0.0210, 'lps'),
	(579347, 128, '2014-03-15 00:17:53.000000', 'consum', 0.0216, 'lps'),
	(579348, 128, '2014-03-15 00:17:54.000000', 'consum', 0.0218, 'lps'),
	(579349, 128, '2014-03-15 00:17:55.000000', 'consum', 0.0211, 'lps'),
	(579350, 128, '2014-03-15 00:17:56.000000', 'consum', 0.0213, 'lps'),
	(579351, 128, '2014-03-15 00:17:57.000000', 'consum', 0.0212, 'lps'),
	(579352, 128, '2014-03-15 00:17:58.000000', 'consum', 0.0213, 'lps'),
	(579353, 128, '2014-03-15 00:17:59.000000', 'consum', 0.0217, 'lps'),
	(579354, 128, '2014-03-15 00:18:00.000000', 'consum', 0.0216, 'lps'),
	(579355, 128, '2014-03-15 00:18:01.000000', 'consum', 0.0219, 'lps'),
	(579356, 128, '2014-03-15 00:18:02.000000', 'consum', 0.0213, 'lps'),
	(579357, 128, '2014-03-15 00:18:03.000000', 'consum', 0.0213, 'lps'),
	(579358, 128, '2014-03-15 00:18:04.000000', 'consum', 0.0217, 'lps'),
	(579359, 128, '2014-03-15 00:18:05.000000', 'consum', 0.0213, 'lps'),
	(579360, 128, '2014-03-15 00:18:06.000000', 'consum', 0.0215, 'lps'),
	(579361, 128, '2014-03-15 00:18:07.000000', 'consum', 0.0215, 'lps'),
	(579362, 128, '2014-03-15 00:18:08.000000', 'consum', 0.0211, 'lps'),
	(579363, 128, '2014-03-15 00:18:09.000000', 'consum', 0.0210, 'lps'),
	(579364, 128, '2014-03-15 00:18:10.000000', 'consum', 0.0218, 'lps'),
	(579365, 128, '2014-03-15 00:18:11.000000', 'consum', 0.0216, 'lps'),
	(579366, 128, '2014-03-15 00:18:12.000000', 'consum', 0.0219, 'lps'),
	(579367, 128, '2014-03-15 00:18:13.000000', 'consum', 0.0216, 'lps'),
	(579368, 128, '2014-03-15 00:18:14.000000', 'consum', 0.0213, 'lps'),
	(579369, 128, '2014-03-15 00:18:15.000000', 'consum', 0.0217, 'lps'),
	(579370, 128, '2014-03-15 00:18:16.000000', 'consum', 0.0215, 'lps'),
	(579371, 128, '2014-03-15 00:18:17.000000', 'consum', 0.0213, 'lps'),
	(579372, 128, '2014-03-15 00:18:18.000000', 'consum', 0.0213, 'lps'),
	(579373, 128, '2014-03-15 00:18:19.000000', 'consum', 0.0217, 'lps'),
	(579374, 128, '2014-03-15 00:18:20.000000', 'consum', 0.0215, 'lps'),
	(579375, 128, '2014-03-15 00:18:21.000000', 'consum', 0.0214, 'lps'),
	(579376, 128, '2014-03-15 00:18:22.000000', 'consum', 0.0213, 'lps'),
	(579377, 128, '2014-03-15 00:18:23.000000', 'consum', 0.0217, 'lps'),
	(579378, 128, '2014-03-15 00:18:24.000000', 'consum', 0.0212, 'lps'),
	(579379, 128, '2014-03-15 00:18:25.000000', 'consum', 0.0211, 'lps'),
	(579380, 128, '2014-03-15 00:18:26.000000', 'consum', 0.0220, 'lps'),
	(579381, 128, '2014-03-15 00:18:27.000000', 'consum', 0.0215, 'lps'),
	(579382, 128, '2014-03-15 00:18:28.000000', 'consum', 0.0216, 'lps'),
	(579383, 128, '2014-03-15 00:18:29.000000', 'consum', 0.0213, 'lps'),
	(579384, 128, '2014-03-15 00:18:30.000000', 'consum', 0.0218, 'lps'),
	(579385, 128, '2014-03-15 00:18:31.000000', 'consum', 0.0210, 'lps'),
	(579386, 128, '2014-03-15 00:18:32.000000', 'consum', 0.0220, 'lps'),
	(579387, 128, '2014-03-15 00:18:33.000000', 'consum', 0.0214, 'lps'),
	(579388, 128, '2014-03-15 00:18:34.000000', 'consum', 0.0214, 'lps'),
	(579389, 128, '2014-03-15 00:18:35.000000', 'consum', 0.0219, 'lps'),
	(579390, 128, '2014-03-15 00:18:36.000000', 'consum', 0.0219, 'lps'),
	(579391, 128, '2014-03-15 00:18:37.000000', 'consum', 0.0218, 'lps'),
	(579392, 128, '2014-03-15 00:18:38.000000', 'consum', 0.0211, 'lps'),
	(579393, 128, '2014-03-15 00:18:39.000000', 'consum', 0.0216, 'lps'),
	(579394, 128, '2014-03-15 00:18:40.000000', 'consum', 0.0217, 'lps'),
	(579395, 128, '2014-03-15 00:18:41.000000', 'consum', 0.0213, 'lps'),
	(579396, 128, '2014-03-15 00:18:42.000000', 'consum', 0.0216, 'lps'),
	(579397, 128, '2014-03-15 00:18:43.000000', 'consum', 0.0212, 'lps'),
	(579398, 128, '2014-03-15 00:18:44.000000', 'consum', 0.0211, 'lps'),
	(579399, 128, '2014-03-15 00:18:45.000000', 'consum', 0.0210, 'lps'),
	(579400, 128, '2014-03-15 00:18:46.000000', 'consum', 0.0219, 'lps'),
	(579401, 128, '2014-03-15 00:18:47.000000', 'consum', 0.0212, 'lps'),
	(579402, 128, '2014-03-15 00:18:48.000000', 'consum', 0.0215, 'lps'),
	(579403, 128, '2014-03-15 00:18:49.000000', 'consum', 0.0220, 'lps'),
	(579404, 128, '2014-03-15 00:18:50.000000', 'consum', 0.0213, 'lps'),
	(579405, 128, '2014-03-15 00:18:51.000000', 'consum', 0.0217, 'lps'),
	(579406, 128, '2014-03-15 00:18:52.000000', 'consum', 0.0213, 'lps'),
	(579407, 128, '2014-03-15 00:18:53.000000', 'consum', 0.0216, 'lps'),
	(579408, 128, '2014-03-15 00:18:54.000000', 'consum', 0.0219, 'lps'),
	(579409, 128, '2014-03-15 00:18:55.000000', 'consum', 0.0216, 'lps'),
	(579410, 128, '2014-03-15 00:18:56.000000', 'consum', 0.0213, 'lps'),
	(579411, 128, '2014-03-15 00:18:57.000000', 'consum', 0.0218, 'lps'),
	(579412, 128, '2014-03-15 00:18:58.000000', 'consum', 0.0219, 'lps'),
	(579413, 128, '2014-03-15 00:18:59.000000', 'consum', 0.0220, 'lps'),
	(579414, 128, '2014-03-15 00:19:00.000000', 'consum', 0.0213, 'lps'),
	(579415, 128, '2014-03-15 00:19:01.000000', 'consum', 0.0217, 'lps'),
	(579416, 128, '2014-03-15 00:19:02.000000', 'consum', 0.0217, 'lps'),
	(579417, 128, '2014-03-15 00:19:03.000000', 'consum', 0.0210, 'lps'),
	(579418, 128, '2014-03-15 00:19:04.000000', 'consum', 0.0214, 'lps'),
	(579419, 128, '2014-03-15 00:19:05.000000', 'consum', 0.0218, 'lps'),
	(579420, 128, '2014-03-15 00:19:06.000000', 'consum', 0.0218, 'lps'),
	(579421, 128, '2014-03-15 00:19:07.000000', 'consum', 0.0215, 'lps'),
	(579422, 128, '2014-03-15 00:19:08.000000', 'consum', 0.0213, 'lps'),
	(579423, 128, '2014-03-15 00:19:09.000000', 'consum', 0.0219, 'lps'),
	(579424, 128, '2014-03-15 00:19:10.000000', 'consum', 0.0216, 'lps'),
	(579425, 128, '2014-03-15 00:19:11.000000', 'consum', 0.0211, 'lps'),
	(579426, 128, '2014-03-15 00:19:12.000000', 'consum', 0.0219, 'lps'),
	(579427, 128, '2014-03-15 00:19:13.000000', 'consum', 0.0210, 'lps'),
	(579428, 128, '2014-03-15 00:19:14.000000', 'consum', 0.0215, 'lps'),
	(579429, 128, '2014-03-15 00:19:15.000000', 'consum', 0.0212, 'lps'),
	(579430, 128, '2014-03-15 00:19:16.000000', 'consum', 0.0219, 'lps'),
	(579431, 128, '2014-03-15 00:19:17.000000', 'consum', 0.0216, 'lps'),
	(579432, 128, '2014-03-15 00:19:18.000000', 'consum', 0.0213, 'lps'),
	(579433, 128, '2014-03-15 00:19:19.000000', 'consum', 0.0219, 'lps'),
	(579434, 128, '2014-03-15 00:19:20.000000', 'consum', 0.0215, 'lps'),
	(579435, 128, '2014-03-15 00:19:21.000000', 'consum', 0.0216, 'lps'),
	(579436, 128, '2014-03-15 00:19:22.000000', 'consum', 0.0217, 'lps'),
	(579437, 128, '2014-03-15 00:19:23.000000', 'consum', 0.0218, 'lps'),
	(579438, 128, '2014-03-15 00:19:24.000000', 'consum', 0.0216, 'lps'),
	(579439, 128, '2014-03-15 00:19:25.000000', 'consum', 0.0217, 'lps'),
	(579440, 128, '2014-03-15 00:19:26.000000', 'consum', 0.0218, 'lps'),
	(579441, 128, '2014-03-15 00:19:27.000000', 'consum', 0.0219, 'lps'),
	(579442, 128, '2014-03-15 00:19:28.000000', 'consum', 0.0218, 'lps'),
	(579443, 128, '2014-03-15 00:19:29.000000', 'consum', 0.0212, 'lps'),
	(579444, 128, '2014-03-15 00:19:30.000000', 'consum', 0.0210, 'lps'),
	(579445, 128, '2014-03-15 00:19:31.000000', 'consum', 0.0213, 'lps'),
	(579446, 128, '2014-03-15 00:19:32.000000', 'consum', 0.0215, 'lps'),
	(579447, 128, '2014-03-15 00:19:33.000000', 'consum', 0.0215, 'lps'),
	(579448, 128, '2014-03-15 00:19:34.000000', 'consum', 0.0220, 'lps'),
	(579449, 128, '2014-03-15 00:19:35.000000', 'consum', 0.0212, 'lps'),
	(579450, 128, '2014-03-15 00:19:36.000000', 'consum', 0.0212, 'lps'),
	(579451, 128, '2014-03-15 00:19:37.000000', 'consum', 0.0216, 'lps'),
	(579452, 128, '2014-03-15 00:19:38.000000', 'consum', 0.0213, 'lps'),
	(579453, 128, '2014-03-15 00:19:39.000000', 'consum', 0.0220, 'lps'),
	(579454, 128, '2014-03-15 00:19:40.000000', 'consum', 0.0215, 'lps'),
	(579455, 128, '2014-03-15 00:19:41.000000', 'consum', 0.0218, 'lps'),
	(579456, 128, '2014-03-15 00:19:42.000000', 'consum', 0.0213, 'lps'),
	(579457, 128, '2014-03-15 00:19:43.000000', 'consum', 0.0211, 'lps'),
	(579458, 128, '2014-03-15 00:19:44.000000', 'consum', 0.0218, 'lps'),
	(579459, 128, '2014-03-15 00:19:45.000000', 'consum', 0.0216, 'lps'),
	(579460, 128, '2014-03-15 00:19:46.000000', 'consum', 0.0218, 'lps'),
	(579461, 128, '2014-03-15 00:19:47.000000', 'consum', 0.0219, 'lps'),
	(579462, 128, '2014-03-15 00:19:48.000000', 'consum', 0.0211, 'lps'),
	(579463, 128, '2014-03-15 00:19:49.000000', 'consum', 0.0211, 'lps'),
	(579464, 128, '2014-03-15 00:19:50.000000', 'consum', 0.0212, 'lps'),
	(579465, 128, '2014-03-15 00:19:51.000000', 'consum', 0.0217, 'lps'),
	(579466, 128, '2014-03-15 00:19:52.000000', 'consum', 0.0220, 'lps'),
	(579467, 128, '2014-03-15 00:19:53.000000', 'consum', 0.0214, 'lps'),
	(579468, 128, '2014-03-15 00:19:54.000000', 'consum', 0.0213, 'lps'),
	(579469, 128, '2014-03-15 00:19:55.000000', 'consum', 0.0212, 'lps'),
	(579470, 128, '2014-03-15 00:19:56.000000', 'consum', 0.0211, 'lps'),
	(579471, 128, '2014-03-15 00:19:57.000000', 'consum', 0.0212, 'lps'),
	(579472, 128, '2014-03-15 00:19:58.000000', 'consum', 0.0215, 'lps'),
	(579473, 128, '2014-03-15 00:19:59.000000', 'consum', 0.0220, 'lps'),
	(579474, 128, '2014-03-15 00:20:00.000000', 'consum', 0.0211, 'lps'),
	(579475, 128, '2014-03-15 00:20:01.000000', 'consum', 0.0218, 'lps'),
	(579476, 128, '2014-03-15 00:20:02.000000', 'consum', 0.0217, 'lps'),
	(579477, 128, '2014-03-15 00:20:03.000000', 'consum', 0.0219, 'lps'),
	(579478, 128, '2014-03-15 00:20:04.000000', 'consum', 0.0213, 'lps'),
	(579479, 128, '2014-03-15 00:20:05.000000', 'consum', 0.0220, 'lps'),
	(579480, 128, '2014-03-15 00:20:06.000000', 'consum', 0.0218, 'lps'),
	(579481, 128, '2014-03-15 00:20:07.000000', 'consum', 0.0212, 'lps'),
	(579482, 128, '2014-03-15 00:20:08.000000', 'consum', 0.0215, 'lps'),
	(579483, 128, '2014-03-15 00:20:09.000000', 'consum', 0.0211, 'lps'),
	(579484, 128, '2014-03-15 00:20:10.000000', 'consum', 0.0210, 'lps'),
	(579485, 128, '2014-03-15 00:20:11.000000', 'consum', 0.0218, 'lps'),
	(579486, 128, '2014-03-15 00:20:12.000000', 'consum', 0.0216, 'lps'),
	(579487, 128, '2014-03-15 00:20:13.000000', 'consum', 0.0217, 'lps'),
	(579488, 128, '2014-03-15 00:20:14.000000', 'consum', 0.0217, 'lps'),
	(579489, 128, '2014-03-15 00:20:15.000000', 'consum', 0.0213, 'lps'),
	(579490, 128, '2014-03-15 00:20:16.000000', 'consum', 0.0216, 'lps'),
	(579491, 128, '2014-03-15 00:20:17.000000', 'consum', 0.0211, 'lps'),
	(579492, 128, '2014-03-15 00:20:18.000000', 'consum', 0.0219, 'lps'),
	(579493, 128, '2014-03-15 00:20:19.000000', 'consum', 0.0218, 'lps'),
	(579494, 128, '2014-03-15 00:20:20.000000', 'consum', 0.0214, 'lps'),
	(579495, 128, '2014-03-15 00:20:21.000000', 'consum', 0.0216, 'lps'),
	(579496, 128, '2014-03-15 00:20:22.000000', 'consum', 0.0220, 'lps'),
	(579497, 128, '2014-03-15 00:20:23.000000', 'consum', 0.0219, 'lps'),
	(579498, 128, '2014-03-15 00:20:24.000000', 'consum', 0.0213, 'lps'),
	(579499, 128, '2014-03-15 00:20:25.000000', 'consum', 0.0212, 'lps'),
	(579500, 128, '2014-03-15 00:20:26.000000', 'consum', 0.0211, 'lps'),
	(579501, 128, '2014-03-15 00:20:27.000000', 'consum', 0.0218, 'lps'),
	(579502, 128, '2014-03-15 00:20:28.000000', 'consum', 0.0218, 'lps'),
	(579503, 128, '2014-03-15 00:20:29.000000', 'consum', 0.0214, 'lps'),
	(579504, 128, '2014-03-15 00:20:30.000000', 'consum', 0.0219, 'lps'),
	(579505, 128, '2014-03-15 00:20:31.000000', 'consum', 0.0210, 'lps'),
	(579506, 128, '2014-03-15 00:20:32.000000', 'consum', 0.0216, 'lps'),
	(579507, 128, '2014-03-15 00:20:33.000000', 'consum', 0.0217, 'lps'),
	(579508, 128, '2014-03-15 00:20:34.000000', 'consum', 0.0216, 'lps'),
	(579509, 128, '2014-03-15 00:20:35.000000', 'consum', 0.0220, 'lps'),
	(579510, 128, '2014-03-15 00:20:36.000000', 'consum', 0.0212, 'lps'),
	(579511, 128, '2014-03-15 00:20:37.000000', 'consum', 0.0211, 'lps'),
	(579512, 128, '2014-03-15 00:20:38.000000', 'consum', 0.0219, 'lps'),
	(579513, 128, '2014-03-15 00:20:39.000000', 'consum', 0.0211, 'lps'),
	(579514, 128, '2014-03-15 00:20:40.000000', 'consum', 0.0212, 'lps'),
	(579515, 128, '2014-03-15 00:20:41.000000', 'consum', 0.0214, 'lps'),
	(579516, 128, '2014-03-15 00:20:42.000000', 'consum', 0.0215, 'lps'),
	(579517, 128, '2014-03-15 00:20:43.000000', 'consum', 0.0210, 'lps'),
	(579518, 128, '2014-03-15 00:20:44.000000', 'consum', 0.0220, 'lps'),
	(579519, 128, '2014-03-15 00:20:45.000000', 'consum', 0.0218, 'lps'),
	(579520, 128, '2014-03-15 00:20:46.000000', 'consum', 0.0219, 'lps'),
	(579521, 128, '2014-03-15 00:20:47.000000', 'consum', 0.0219, 'lps'),
	(579522, 128, '2014-03-15 00:20:48.000000', 'consum', 0.0218, 'lps'),
	(579523, 128, '2014-03-15 00:20:49.000000', 'consum', 0.0214, 'lps'),
	(579524, 128, '2014-03-15 00:20:50.000000', 'consum', 0.0217, 'lps'),
	(579525, 128, '2014-03-15 00:20:51.000000', 'consum', 0.0210, 'lps'),
	(579526, 128, '2014-03-15 00:20:52.000000', 'consum', 0.0212, 'lps'),
	(579527, 128, '2014-03-15 00:20:53.000000', 'consum', 0.0220, 'lps'),
	(579528, 128, '2014-03-15 00:20:54.000000', 'consum', 0.0210, 'lps'),
	(579529, 128, '2014-03-15 00:20:55.000000', 'consum', 0.0213, 'lps'),
	(579530, 128, '2014-03-15 00:20:56.000000', 'consum', 0.0213, 'lps'),
	(579531, 128, '2014-03-15 00:20:57.000000', 'consum', 0.0220, 'lps'),
	(579532, 128, '2014-03-15 00:20:58.000000', 'consum', 0.0217, 'lps'),
	(579533, 128, '2014-03-15 00:20:59.000000', 'consum', 0.0214, 'lps'),
	(579534, 128, '2014-03-15 00:21:00.000000', 'consum', 0.0212, 'lps'),
	(579535, 128, '2014-03-15 00:21:01.000000', 'consum', 0.0219, 'lps'),
	(579536, 128, '2014-03-15 00:21:02.000000', 'consum', 0.0216, 'lps'),
	(579537, 128, '2014-03-15 00:21:03.000000', 'consum', 0.0213, 'lps'),
	(579538, 128, '2014-03-15 00:21:04.000000', 'consum', 0.0217, 'lps'),
	(579539, 128, '2014-03-15 00:21:05.000000', 'consum', 0.0218, 'lps'),
	(579540, 128, '2014-03-15 00:21:06.000000', 'consum', 0.0215, 'lps'),
	(579541, 128, '2014-03-15 00:21:07.000000', 'consum', 0.0214, 'lps'),
	(579542, 128, '2014-03-15 00:21:08.000000', 'consum', 0.0214, 'lps'),
	(579543, 128, '2014-03-15 00:21:09.000000', 'consum', 0.0217, 'lps'),
	(579544, 128, '2014-03-15 00:21:10.000000', 'consum', 0.0213, 'lps'),
	(579545, 128, '2014-03-15 00:21:11.000000', 'consum', 0.0216, 'lps'),
	(579546, 128, '2014-03-15 00:21:12.000000', 'consum', 0.0211, 'lps'),
	(579547, 128, '2014-03-15 00:21:13.000000', 'consum', 0.0218, 'lps'),
	(579548, 128, '2014-03-15 00:21:14.000000', 'consum', 0.0216, 'lps'),
	(579549, 128, '2014-03-15 00:21:15.000000', 'consum', 0.0217, 'lps'),
	(579550, 128, '2014-03-15 00:21:16.000000', 'consum', 0.0214, 'lps'),
	(579551, 128, '2014-03-15 00:21:17.000000', 'consum', 0.0211, 'lps'),
	(579552, 128, '2014-03-15 00:21:18.000000', 'consum', 0.0215, 'lps'),
	(579553, 128, '2014-03-15 00:21:19.000000', 'consum', 0.0211, 'lps'),
	(579554, 128, '2014-03-15 00:21:20.000000', 'consum', 0.0212, 'lps'),
	(579555, 128, '2014-03-15 00:21:21.000000', 'consum', 0.0216, 'lps'),
	(579556, 128, '2014-03-15 00:21:22.000000', 'consum', 0.0213, 'lps'),
	(579557, 128, '2014-03-15 00:21:23.000000', 'consum', 0.0219, 'lps'),
	(579558, 128, '2014-03-15 00:21:24.000000', 'consum', 0.0212, 'lps'),
	(579559, 128, '2014-03-15 00:21:25.000000', 'consum', 0.0215, 'lps'),
	(579560, 128, '2014-03-15 00:21:26.000000', 'consum', 0.0220, 'lps'),
	(579561, 128, '2014-03-15 00:21:27.000000', 'consum', 0.0212, 'lps'),
	(579562, 128, '2014-03-15 00:21:28.000000', 'consum', 0.0214, 'lps'),
	(579563, 128, '2014-03-15 00:21:29.000000', 'consum', 0.0215, 'lps'),
	(579564, 128, '2014-03-15 00:21:30.000000', 'consum', 0.0220, 'lps'),
	(579565, 128, '2014-03-15 00:21:31.000000', 'consum', 0.0214, 'lps'),
	(579566, 128, '2014-03-15 00:21:32.000000', 'consum', 0.0212, 'lps'),
	(579567, 128, '2014-03-15 00:21:33.000000', 'consum', 0.0219, 'lps'),
	(579568, 128, '2014-03-15 00:21:34.000000', 'consum', 0.0215, 'lps'),
	(579569, 128, '2014-03-15 00:21:35.000000', 'consum', 0.0219, 'lps'),
	(579570, 128, '2014-03-15 00:21:36.000000', 'consum', 0.0210, 'lps'),
	(579571, 128, '2014-03-15 00:21:37.000000', 'consum', 0.0216, 'lps'),
	(579572, 128, '2014-03-15 00:21:38.000000', 'consum', 0.0219, 'lps'),
	(579573, 128, '2014-03-15 00:21:39.000000', 'consum', 0.0216, 'lps'),
	(579574, 128, '2014-03-15 00:21:40.000000', 'consum', 0.0213, 'lps'),
	(579575, 128, '2014-03-15 00:21:41.000000', 'consum', 0.0218, 'lps'),
	(579576, 128, '2014-03-15 00:21:42.000000', 'consum', 0.0219, 'lps'),
	(579577, 128, '2014-03-15 00:21:43.000000', 'consum', 0.0212, 'lps'),
	(579578, 128, '2014-03-15 00:21:44.000000', 'consum', 0.0214, 'lps'),
	(579579, 128, '2014-03-15 00:21:45.000000', 'consum', 0.0214, 'lps'),
	(579580, 128, '2014-03-15 00:21:46.000000', 'consum', 0.0217, 'lps'),
	(579581, 128, '2014-03-15 00:21:47.000000', 'consum', 0.0212, 'lps'),
	(579582, 128, '2014-03-15 00:21:48.000000', 'consum', 0.0211, 'lps'),
	(579583, 128, '2014-03-15 00:21:49.000000', 'consum', 0.0219, 'lps'),
	(579584, 128, '2014-03-15 00:21:50.000000', 'consum', 0.0220, 'lps'),
	(579585, 128, '2014-03-15 00:21:51.000000', 'consum', 0.0212, 'lps'),
	(579586, 128, '2014-03-15 00:21:52.000000', 'consum', 0.0213, 'lps'),
	(579587, 128, '2014-03-15 00:21:53.000000', 'consum', 0.0218, 'lps'),
	(579588, 128, '2014-03-15 00:21:54.000000', 'consum', 0.0218, 'lps'),
	(579589, 128, '2014-03-15 00:21:55.000000', 'consum', 0.0217, 'lps'),
	(579590, 128, '2014-03-15 00:21:56.000000', 'consum', 0.0212, 'lps'),
	(579591, 128, '2014-03-15 00:21:57.000000', 'consum', 0.0211, 'lps'),
	(579592, 128, '2014-03-15 00:21:58.000000', 'consum', 0.0218, 'lps'),
	(579593, 128, '2014-03-15 00:21:59.000000', 'consum', 0.0216, 'lps'),
	(579594, 128, '2014-03-15 00:22:00.000000', 'consum', 0.0216, 'lps'),
	(579595, 128, '2014-03-15 00:22:01.000000', 'consum', 0.0213, 'lps'),
	(579596, 128, '2014-03-15 00:22:02.000000', 'consum', 0.0220, 'lps'),
	(579597, 128, '2014-03-15 00:22:03.000000', 'consum', 0.0215, 'lps'),
	(579598, 128, '2014-03-15 00:22:04.000000', 'consum', 0.0218, 'lps'),
	(579599, 128, '2014-03-15 00:22:05.000000', 'consum', 0.0213, 'lps'),
	(579600, 128, '2014-03-15 00:22:06.000000', 'consum', 0.0212, 'lps'),
	(579601, 128, '2014-03-15 00:22:07.000000', 'consum', 0.0211, 'lps'),
	(579602, 128, '2014-03-15 00:22:08.000000', 'consum', 0.0219, 'lps'),
	(579603, 128, '2014-03-15 00:22:09.000000', 'consum', 0.0211, 'lps'),
	(579604, 128, '2014-03-15 00:22:10.000000', 'consum', 0.0210, 'lps'),
	(579605, 128, '2014-03-15 00:22:11.000000', 'consum', 0.0219, 'lps'),
	(579606, 128, '2014-03-15 00:22:12.000000', 'consum', 0.0220, 'lps'),
	(579607, 128, '2014-03-15 00:22:13.000000', 'consum', 0.0214, 'lps'),
	(579608, 128, '2014-03-15 00:22:14.000000', 'consum', 0.0212, 'lps'),
	(579609, 128, '2014-03-15 00:22:15.000000', 'consum', 0.0220, 'lps'),
	(579610, 128, '2014-03-15 00:22:16.000000', 'consum', 0.0211, 'lps'),
	(579611, 128, '2014-03-15 00:22:17.000000', 'consum', 0.0217, 'lps'),
	(579612, 128, '2014-03-15 00:22:18.000000', 'consum', 0.0210, 'lps'),
	(579613, 128, '2014-03-15 00:22:19.000000', 'consum', 0.0211, 'lps'),
	(579614, 128, '2014-03-15 00:22:20.000000', 'consum', 0.0215, 'lps'),
	(579615, 128, '2014-03-15 00:22:21.000000', 'consum', 0.0211, 'lps'),
	(579616, 128, '2014-03-15 00:22:22.000000', 'consum', 0.0213, 'lps'),
	(579617, 128, '2014-03-15 00:22:23.000000', 'consum', 0.0212, 'lps'),
	(579618, 128, '2014-03-15 00:22:24.000000', 'consum', 0.0220, 'lps'),
	(579619, 128, '2014-03-15 00:22:25.000000', 'consum', 0.0210, 'lps'),
	(579620, 128, '2014-03-15 00:22:26.000000', 'consum', 0.0215, 'lps'),
	(579621, 128, '2014-03-15 00:22:27.000000', 'consum', 0.0212, 'lps'),
	(579622, 128, '2014-03-15 00:22:28.000000', 'consum', 0.0215, 'lps'),
	(579623, 128, '2014-03-15 00:22:29.000000', 'consum', 0.0210, 'lps'),
	(579624, 128, '2014-03-15 00:22:30.000000', 'consum', 0.0218, 'lps'),
	(579625, 128, '2014-03-15 00:22:31.000000', 'consum', 0.0216, 'lps'),
	(579626, 128, '2014-03-15 00:22:32.000000', 'consum', 0.0217, 'lps'),
	(579627, 128, '2014-03-15 00:22:33.000000', 'consum', 0.0216, 'lps'),
	(579628, 128, '2014-03-15 00:22:34.000000', 'consum', 0.0210, 'lps'),
	(579629, 128, '2014-03-15 00:22:35.000000', 'consum', 0.0215, 'lps'),
	(579630, 128, '2014-03-15 00:22:36.000000', 'consum', 0.0214, 'lps'),
	(579631, 128, '2014-03-15 00:22:37.000000', 'consum', 0.0214, 'lps'),
	(579632, 128, '2014-03-15 00:22:38.000000', 'consum', 0.0218, 'lps'),
	(579633, 128, '2014-03-15 00:22:39.000000', 'consum', 0.0219, 'lps'),
	(579634, 128, '2014-03-15 00:22:40.000000', 'consum', 0.0218, 'lps'),
	(579635, 128, '2014-03-15 00:22:41.000000', 'consum', 0.0213, 'lps'),
	(579636, 128, '2014-03-15 00:22:42.000000', 'consum', 0.0214, 'lps'),
	(579637, 128, '2014-03-15 00:22:43.000000', 'consum', 0.0220, 'lps'),
	(579638, 128, '2014-03-15 00:22:44.000000', 'consum', 0.0215, 'lps'),
	(579639, 128, '2014-03-15 00:22:45.000000', 'consum', 0.0217, 'lps'),
	(579640, 128, '2014-03-15 00:22:46.000000', 'consum', 0.0210, 'lps'),
	(579641, 128, '2014-03-15 00:22:47.000000', 'consum', 0.0210, 'lps'),
	(579642, 128, '2014-03-15 00:22:48.000000', 'consum', 0.0220, 'lps'),
	(579643, 128, '2014-03-15 00:22:49.000000', 'consum', 0.0219, 'lps'),
	(579644, 128, '2014-03-15 00:22:50.000000', 'consum', 0.0215, 'lps'),
	(579645, 128, '2014-03-15 00:22:51.000000', 'consum', 0.0217, 'lps'),
	(579646, 128, '2014-03-15 00:22:52.000000', 'consum', 0.0220, 'lps'),
	(579647, 128, '2014-03-15 00:22:53.000000', 'consum', 0.0219, 'lps'),
	(579648, 128, '2014-03-15 00:22:54.000000', 'consum', 0.0214, 'lps'),
	(579649, 128, '2014-03-15 00:22:55.000000', 'consum', 0.0216, 'lps'),
	(579650, 128, '2014-03-15 00:22:56.000000', 'consum', 0.0216, 'lps'),
	(579651, 128, '2014-03-15 00:22:57.000000', 'consum', 0.0212, 'lps'),
	(579652, 128, '2014-03-15 00:22:58.000000', 'consum', 0.0214, 'lps'),
	(579653, 128, '2014-03-15 00:22:59.000000', 'consum', 0.0212, 'lps'),
	(579654, 128, '2014-03-15 00:23:00.000000', 'consum', 0.0219, 'lps'),
	(579655, 128, '2014-03-15 00:23:01.000000', 'consum', 0.0216, 'lps'),
	(579656, 128, '2014-03-15 00:23:02.000000', 'consum', 0.0214, 'lps'),
	(579657, 128, '2014-03-15 00:23:03.000000', 'consum', 0.0212, 'lps'),
	(579658, 128, '2014-03-15 00:23:04.000000', 'consum', 0.0218, 'lps'),
	(579659, 128, '2014-03-15 00:23:05.000000', 'consum', 0.0213, 'lps'),
	(579660, 128, '2014-03-15 00:23:06.000000', 'consum', 0.0212, 'lps'),
	(579661, 128, '2014-03-15 00:23:07.000000', 'consum', 0.0211, 'lps'),
	(579662, 128, '2014-03-15 00:23:08.000000', 'consum', 0.0212, 'lps'),
	(579663, 128, '2014-03-15 00:23:09.000000', 'consum', 0.0217, 'lps'),
	(579664, 128, '2014-03-15 00:23:10.000000', 'consum', 0.0215, 'lps'),
	(579665, 128, '2014-03-15 00:23:11.000000', 'consum', 0.0217, 'lps'),
	(579666, 128, '2014-03-15 00:23:12.000000', 'consum', 0.0217, 'lps'),
	(579667, 128, '2014-03-15 00:23:13.000000', 'consum', 0.0214, 'lps'),
	(579668, 128, '2014-03-15 00:23:14.000000', 'consum', 0.0210, 'lps'),
	(579669, 128, '2014-03-15 00:23:15.000000', 'consum', 0.0220, 'lps'),
	(579670, 128, '2014-03-15 00:23:16.000000', 'consum', 0.0216, 'lps'),
	(579671, 128, '2014-03-15 00:23:17.000000', 'consum', 0.0212, 'lps'),
	(579672, 128, '2014-03-15 00:23:18.000000', 'consum', 0.0212, 'lps'),
	(579673, 128, '2014-03-15 00:23:19.000000', 'consum', 0.0215, 'lps'),
	(579674, 128, '2014-03-15 00:23:20.000000', 'consum', 0.0220, 'lps'),
	(579675, 128, '2014-03-15 00:23:21.000000', 'consum', 0.0213, 'lps'),
	(579676, 128, '2014-03-15 00:23:22.000000', 'consum', 0.0215, 'lps'),
	(579677, 128, '2014-03-15 00:23:23.000000', 'consum', 0.0215, 'lps'),
	(579678, 128, '2014-03-15 00:23:24.000000', 'consum', 0.0210, 'lps'),
	(579679, 128, '2014-03-15 00:23:25.000000', 'consum', 0.0217, 'lps'),
	(579680, 128, '2014-03-15 00:23:26.000000', 'consum', 0.0215, 'lps'),
	(579681, 128, '2014-03-15 00:23:27.000000', 'consum', 0.0211, 'lps'),
	(579682, 128, '2014-03-15 00:23:28.000000', 'consum', 0.0213, 'lps'),
	(579683, 128, '2014-03-15 00:23:29.000000', 'consum', 0.0213, 'lps'),
	(579684, 128, '2014-03-15 00:23:30.000000', 'consum', 0.0215, 'lps'),
	(579685, 128, '2014-03-15 00:23:31.000000', 'consum', 0.0216, 'lps'),
	(579686, 128, '2014-03-15 00:23:32.000000', 'consum', 0.0214, 'lps'),
	(579687, 128, '2014-03-15 00:23:33.000000', 'consum', 0.0213, 'lps'),
	(579688, 128, '2014-03-15 00:23:34.000000', 'consum', 0.0215, 'lps'),
	(579689, 128, '2014-03-15 00:23:35.000000', 'consum', 0.0214, 'lps'),
	(579690, 128, '2014-03-15 00:23:36.000000', 'consum', 0.0216, 'lps'),
	(579691, 128, '2014-03-15 00:23:37.000000', 'consum', 0.0216, 'lps'),
	(579692, 128, '2014-03-15 00:23:38.000000', 'consum', 0.0213, 'lps'),
	(579693, 128, '2014-03-15 00:23:39.000000', 'consum', 0.0219, 'lps'),
	(579694, 128, '2014-03-15 00:23:40.000000', 'consum', 0.0215, 'lps'),
	(579695, 128, '2014-03-15 00:23:41.000000', 'consum', 0.0216, 'lps'),
	(579696, 128, '2014-03-15 00:23:42.000000', 'consum', 0.0218, 'lps'),
	(579697, 128, '2014-03-15 00:23:43.000000', 'consum', 0.0219, 'lps'),
	(579698, 128, '2014-03-15 00:23:44.000000', 'consum', 0.0220, 'lps'),
	(579699, 128, '2014-03-15 00:23:45.000000', 'consum', 0.0212, 'lps'),
	(579700, 128, '2014-03-15 00:23:46.000000', 'consum', 0.0211, 'lps'),
	(579701, 128, '2014-03-15 00:23:47.000000', 'consum', 0.0211, 'lps'),
	(579702, 128, '2014-03-15 00:23:48.000000', 'consum', 0.0214, 'lps'),
	(579703, 128, '2014-03-15 00:23:49.000000', 'consum', 0.0213, 'lps'),
	(579704, 128, '2014-03-15 00:23:50.000000', 'consum', 0.0217, 'lps'),
	(579705, 128, '2014-03-15 00:23:51.000000', 'consum', 0.0212, 'lps'),
	(579706, 128, '2014-03-15 00:23:52.000000', 'consum', 0.0210, 'lps'),
	(579707, 128, '2014-03-15 00:23:53.000000', 'consum', 0.0215, 'lps'),
	(579708, 128, '2014-03-15 00:23:54.000000', 'consum', 0.0215, 'lps'),
	(579709, 128, '2014-03-15 00:23:55.000000', 'consum', 0.0218, 'lps'),
	(579710, 128, '2014-03-15 00:23:56.000000', 'consum', 0.0216, 'lps'),
	(579711, 128, '2014-03-15 00:23:57.000000', 'consum', 0.0218, 'lps'),
	(579712, 128, '2014-03-15 00:23:58.000000', 'consum', 0.0219, 'lps'),
	(579713, 128, '2014-03-15 00:23:59.000000', 'consum', 0.0211, 'lps'),
	(579714, 128, '2014-03-15 00:24:00.000000', 'consum', 0.0211, 'lps'),
	(579715, 128, '2014-03-15 00:24:01.000000', 'consum', 0.0212, 'lps'),
	(579716, 128, '2014-03-15 00:24:02.000000', 'consum', 0.0217, 'lps'),
	(579717, 128, '2014-03-15 00:24:03.000000', 'consum', 0.0218, 'lps'),
	(579718, 128, '2014-03-15 00:24:04.000000', 'consum', 0.0220, 'lps'),
	(579719, 128, '2014-03-15 00:24:05.000000', 'consum', 0.0211, 'lps'),
	(579720, 128, '2014-03-15 00:24:06.000000', 'consum', 0.0210, 'lps'),
	(579721, 128, '2014-03-15 00:24:07.000000', 'consum', 0.0219, 'lps'),
	(579722, 128, '2014-03-15 00:24:08.000000', 'consum', 0.0212, 'lps'),
	(579723, 128, '2014-03-15 00:24:09.000000', 'consum', 0.0215, 'lps'),
	(579724, 128, '2014-03-15 00:24:10.000000', 'consum', 0.0218, 'lps'),
	(579725, 128, '2014-03-15 00:24:11.000000', 'consum', 0.0215, 'lps'),
	(579726, 128, '2014-03-15 00:24:12.000000', 'consum', 0.0211, 'lps'),
	(579727, 128, '2014-03-15 00:24:13.000000', 'consum', 0.0213, 'lps'),
	(579728, 128, '2014-03-15 00:24:14.000000', 'consum', 0.0211, 'lps'),
	(579729, 128, '2014-03-15 00:24:15.000000', 'consum', 0.0215, 'lps'),
	(579730, 128, '2014-03-15 00:24:16.000000', 'consum', 0.0212, 'lps'),
	(579731, 128, '2014-03-15 00:24:17.000000', 'consum', 0.0217, 'lps'),
	(579732, 128, '2014-03-15 00:24:18.000000', 'consum', 0.0218, 'lps'),
	(579733, 128, '2014-03-15 00:24:19.000000', 'consum', 0.0217, 'lps'),
	(579734, 128, '2014-03-15 00:24:20.000000', 'consum', 0.0212, 'lps'),
	(579735, 128, '2014-03-15 00:24:21.000000', 'consum', 0.0210, 'lps'),
	(579736, 128, '2014-03-15 00:24:22.000000', 'consum', 0.0216, 'lps'),
	(579737, 128, '2014-03-15 00:24:23.000000', 'consum', 0.0218, 'lps'),
	(579738, 128, '2014-03-15 00:24:24.000000', 'consum', 0.0220, 'lps'),
	(579739, 128, '2014-03-15 00:24:25.000000', 'consum', 0.0215, 'lps'),
	(579740, 128, '2014-03-15 00:24:26.000000', 'consum', 0.0217, 'lps'),
	(579741, 128, '2014-03-15 00:24:27.000000', 'consum', 0.0219, 'lps'),
	(579742, 128, '2014-03-15 00:24:28.000000', 'consum', 0.0213, 'lps'),
	(579743, 128, '2014-03-15 00:24:29.000000', 'consum', 0.0210, 'lps'),
	(579744, 128, '2014-03-15 00:24:30.000000', 'consum', 0.0213, 'lps'),
	(579745, 128, '2014-03-15 00:24:31.000000', 'consum', 0.0213, 'lps'),
	(579746, 128, '2014-03-15 00:24:32.000000', 'consum', 0.0219, 'lps'),
	(579747, 128, '2014-03-15 00:24:33.000000', 'consum', 0.0212, 'lps'),
	(579748, 128, '2014-03-15 00:24:34.000000', 'consum', 0.0215, 'lps'),
	(579749, 128, '2014-03-15 00:24:35.000000', 'consum', 0.0220, 'lps'),
	(579750, 128, '2014-03-15 00:24:36.000000', 'consum', 0.0211, 'lps'),
	(579751, 128, '2014-03-15 00:24:37.000000', 'consum', 0.0217, 'lps'),
	(579752, 128, '2014-03-15 00:24:38.000000', 'consum', 0.0211, 'lps'),
	(579753, 128, '2014-03-15 00:24:39.000000', 'consum', 0.0218, 'lps'),
	(579754, 128, '2014-03-15 00:24:40.000000', 'consum', 0.0212, 'lps'),
	(579755, 128, '2014-03-15 00:24:41.000000', 'consum', 0.0220, 'lps'),
	(579756, 128, '2014-03-15 00:24:42.000000', 'consum', 0.0211, 'lps'),
	(579757, 128, '2014-03-15 00:24:43.000000', 'consum', 0.0217, 'lps'),
	(579758, 128, '2014-03-15 00:24:44.000000', 'consum', 0.0220, 'lps'),
	(579759, 128, '2014-03-15 00:24:45.000000', 'consum', 0.0217, 'lps'),
	(579760, 128, '2014-03-15 00:24:46.000000', 'consum', 0.0215, 'lps'),
	(579761, 128, '2014-03-15 00:24:47.000000', 'consum', 0.0214, 'lps'),
	(579762, 128, '2014-03-15 00:24:48.000000', 'consum', 0.0217, 'lps'),
	(579763, 128, '2014-03-15 00:24:49.000000', 'consum', 0.0210, 'lps'),
	(579764, 128, '2014-03-15 00:24:50.000000', 'consum', 0.0211, 'lps'),
	(579765, 128, '2014-03-15 00:24:51.000000', 'consum', 0.0215, 'lps'),
	(579766, 128, '2014-03-15 00:24:52.000000', 'consum', 0.0210, 'lps'),
	(579767, 128, '2014-03-15 00:24:53.000000', 'consum', 0.0219, 'lps'),
	(579768, 128, '2014-03-15 00:24:54.000000', 'consum', 0.0211, 'lps'),
	(579769, 128, '2014-03-15 00:24:55.000000', 'consum', 0.0212, 'lps'),
	(579770, 128, '2014-03-15 00:24:56.000000', 'consum', 0.0216, 'lps'),
	(579771, 128, '2014-03-15 00:24:57.000000', 'consum', 0.0213, 'lps'),
	(579772, 128, '2014-03-15 00:24:58.000000', 'consum', 0.0218, 'lps'),
	(579773, 128, '2014-03-15 00:24:59.000000', 'consum', 0.0220, 'lps'),
	(579774, 128, '2014-03-15 00:25:00.000000', 'consum', 0.0213, 'lps'),
	(579775, 128, '2014-03-15 00:25:01.000000', 'consum', 0.0217, 'lps'),
	(579776, 128, '2014-03-15 00:25:02.000000', 'consum', 0.0215, 'lps'),
	(579777, 128, '2014-03-15 00:25:03.000000', 'consum', 0.0215, 'lps'),
	(579778, 128, '2014-03-15 00:25:04.000000', 'consum', 0.0211, 'lps'),
	(579779, 128, '2014-03-15 00:25:05.000000', 'consum', 0.0220, 'lps'),
	(579780, 128, '2014-03-15 00:25:06.000000', 'consum', 0.0215, 'lps'),
	(579781, 128, '2014-03-15 00:25:07.000000', 'consum', 0.0214, 'lps'),
	(579782, 128, '2014-03-15 00:25:08.000000', 'consum', 0.0219, 'lps'),
	(579783, 128, '2014-03-15 00:25:09.000000', 'consum', 0.0220, 'lps'),
	(579784, 128, '2014-03-15 00:25:10.000000', 'consum', 0.0213, 'lps'),
	(579785, 128, '2014-03-15 00:25:11.000000', 'consum', 0.0218, 'lps'),
	(579786, 128, '2014-03-15 00:25:12.000000', 'consum', 0.0218, 'lps'),
	(579787, 128, '2014-03-15 00:25:13.000000', 'consum', 0.0215, 'lps'),
	(579788, 128, '2014-03-15 00:25:14.000000', 'consum', 0.0211, 'lps'),
	(579789, 128, '2014-03-15 00:25:15.000000', 'consum', 0.0214, 'lps'),
	(579790, 128, '2014-03-15 00:25:16.000000', 'consum', 0.0213, 'lps'),
	(579791, 128, '2014-03-15 00:25:17.000000', 'consum', 0.0216, 'lps'),
	(579792, 128, '2014-03-15 00:25:18.000000', 'consum', 0.0210, 'lps'),
	(579793, 128, '2014-03-15 00:25:19.000000', 'consum', 0.0215, 'lps'),
	(579794, 128, '2014-03-15 00:25:20.000000', 'consum', 0.0211, 'lps'),
	(579795, 128, '2014-03-15 00:25:21.000000', 'consum', 0.0213, 'lps'),
	(579796, 128, '2014-03-15 00:25:22.000000', 'consum', 0.0210, 'lps'),
	(579797, 128, '2014-03-15 00:25:23.000000', 'consum', 0.0215, 'lps'),
	(579798, 128, '2014-03-15 00:25:24.000000', 'consum', 0.0210, 'lps'),
	(579799, 128, '2014-03-15 00:25:25.000000', 'consum', 0.0220, 'lps'),
	(579800, 128, '2014-03-15 00:25:26.000000', 'consum', 0.0216, 'lps'),
	(579801, 128, '2014-03-15 00:25:27.000000', 'consum', 0.0211, 'lps'),
	(579802, 128, '2014-03-15 00:25:28.000000', 'consum', 0.0220, 'lps'),
	(579803, 128, '2014-03-15 00:25:29.000000', 'consum', 0.0215, 'lps'),
	(579804, 128, '2014-03-15 00:25:30.000000', 'consum', 0.0214, 'lps'),
	(579805, 128, '2014-03-15 00:25:31.000000', 'consum', 0.0217, 'lps'),
	(579806, 128, '2014-03-15 00:25:32.000000', 'consum', 0.0220, 'lps'),
	(579807, 128, '2014-03-15 00:25:33.000000', 'consum', 0.0219, 'lps'),
	(579808, 128, '2014-03-15 00:25:34.000000', 'consum', 0.0216, 'lps'),
	(579809, 128, '2014-03-15 00:25:35.000000', 'consum', 0.0212, 'lps'),
	(579810, 128, '2014-03-15 00:25:36.000000', 'consum', 0.0215, 'lps'),
	(579811, 128, '2014-03-15 00:25:37.000000', 'consum', 0.0219, 'lps'),
	(579812, 128, '2014-03-15 00:25:38.000000', 'consum', 0.0216, 'lps'),
	(579813, 128, '2014-03-15 00:25:39.000000', 'consum', 0.0215, 'lps'),
	(579814, 128, '2014-03-15 00:25:40.000000', 'consum', 0.0215, 'lps'),
	(579815, 128, '2014-03-15 00:25:41.000000', 'consum', 0.0212, 'lps'),
	(579816, 128, '2014-03-15 00:25:42.000000', 'consum', 0.0218, 'lps'),
	(579817, 128, '2014-03-15 00:25:43.000000', 'consum', 0.0210, 'lps'),
	(579818, 128, '2014-03-15 00:25:44.000000', 'consum', 0.0219, 'lps'),
	(579819, 128, '2014-03-15 00:25:45.000000', 'consum', 0.0210, 'lps'),
	(579820, 128, '2014-03-15 00:25:46.000000', 'consum', 0.0220, 'lps'),
	(579821, 128, '2014-03-15 00:25:47.000000', 'consum', 0.0214, 'lps'),
	(579822, 128, '2014-03-15 00:25:48.000000', 'consum', 0.0212, 'lps'),
	(579823, 128, '2014-03-15 00:25:49.000000', 'consum', 0.0218, 'lps'),
	(579824, 128, '2014-03-15 00:25:50.000000', 'consum', 0.0212, 'lps'),
	(579825, 128, '2014-03-15 00:25:51.000000', 'consum', 0.0220, 'lps'),
	(579826, 128, '2014-03-15 00:25:52.000000', 'consum', 0.0220, 'lps'),
	(579827, 128, '2014-03-15 00:25:53.000000', 'consum', 0.0210, 'lps'),
	(579828, 128, '2014-03-15 00:25:54.000000', 'consum', 0.0214, 'lps'),
	(579829, 128, '2014-03-15 00:25:55.000000', 'consum', 0.0219, 'lps'),
	(579830, 128, '2014-03-15 00:25:56.000000', 'consum', 0.0212, 'lps'),
	(579831, 128, '2014-03-15 00:25:57.000000', 'consum', 0.0213, 'lps'),
	(579832, 128, '2014-03-15 00:25:58.000000', 'consum', 0.0211, 'lps'),
	(579833, 128, '2014-03-15 00:25:59.000000', 'consum', 0.0216, 'lps'),
	(579834, 128, '2014-03-15 00:26:00.000000', 'consum', 0.0214, 'lps'),
	(579835, 128, '2014-03-15 00:26:01.000000', 'consum', 0.0214, 'lps'),
	(579836, 128, '2014-03-15 00:26:02.000000', 'consum', 0.0217, 'lps'),
	(579837, 128, '2014-03-15 00:26:03.000000', 'consum', 0.0212, 'lps'),
	(579838, 128, '2014-03-15 00:26:04.000000', 'consum', 0.0213, 'lps'),
	(579839, 128, '2014-03-15 00:26:05.000000', 'consum', 0.0217, 'lps'),
	(579840, 128, '2014-03-15 00:26:06.000000', 'consum', 0.0214, 'lps'),
	(579841, 128, '2014-03-15 00:26:07.000000', 'consum', 0.0220, 'lps'),
	(579842, 128, '2014-03-15 00:26:08.000000', 'consum', 0.0215, 'lps'),
	(579843, 128, '2014-03-15 00:26:09.000000', 'consum', 0.0216, 'lps'),
	(579844, 128, '2014-03-15 00:26:10.000000', 'consum', 0.0218, 'lps'),
	(579845, 128, '2014-03-15 00:26:11.000000', 'consum', 0.0218, 'lps'),
	(579846, 128, '2014-03-15 00:26:12.000000', 'consum', 0.0218, 'lps'),
	(579847, 128, '2014-03-15 00:26:13.000000', 'consum', 0.0214, 'lps'),
	(579848, 128, '2014-03-15 00:26:14.000000', 'consum', 0.0219, 'lps'),
	(579849, 128, '2014-03-15 00:26:15.000000', 'consum', 0.0219, 'lps'),
	(579850, 128, '2014-03-15 00:26:16.000000', 'consum', 0.0210, 'lps'),
	(579851, 128, '2014-03-15 00:26:17.000000', 'consum', 0.0213, 'lps'),
	(579852, 128, '2014-03-15 00:26:18.000000', 'consum', 0.0216, 'lps'),
	(579853, 128, '2014-03-15 00:26:19.000000', 'consum', 0.0219, 'lps'),
	(579854, 128, '2014-03-15 00:26:20.000000', 'consum', 0.0217, 'lps'),
	(579855, 128, '2014-03-15 00:26:21.000000', 'consum', 0.0217, 'lps'),
	(579856, 128, '2014-03-15 00:26:22.000000', 'consum', 0.0212, 'lps'),
	(579857, 128, '2014-03-15 00:26:23.000000', 'consum', 0.0214, 'lps'),
	(579858, 128, '2014-03-15 00:26:24.000000', 'consum', 0.0211, 'lps'),
	(579859, 128, '2014-03-15 00:26:25.000000', 'consum', 0.0217, 'lps'),
	(579860, 128, '2014-03-15 00:26:26.000000', 'consum', 0.0220, 'lps'),
	(579861, 128, '2014-03-15 00:26:27.000000', 'consum', 0.0218, 'lps'),
	(579862, 128, '2014-03-15 00:26:28.000000', 'consum', 0.0220, 'lps'),
	(579863, 128, '2014-03-15 00:26:29.000000', 'consum', 0.0216, 'lps'),
	(579864, 128, '2014-03-15 00:26:30.000000', 'consum', 0.0220, 'lps'),
	(579865, 128, '2014-03-15 00:26:31.000000', 'consum', 0.0210, 'lps'),
	(579866, 128, '2014-03-15 00:26:32.000000', 'consum', 0.0215, 'lps'),
	(579867, 128, '2014-03-15 00:26:33.000000', 'consum', 0.0214, 'lps'),
	(579868, 128, '2014-03-15 00:26:34.000000', 'consum', 0.0214, 'lps'),
	(579869, 128, '2014-03-15 00:26:35.000000', 'consum', 0.0220, 'lps'),
	(579870, 128, '2014-03-15 00:26:36.000000', 'consum', 0.0214, 'lps'),
	(579871, 128, '2014-03-15 00:26:37.000000', 'consum', 0.0212, 'lps'),
	(579872, 128, '2014-03-15 00:26:38.000000', 'consum', 0.0219, 'lps'),
	(579873, 128, '2014-03-15 00:26:39.000000', 'consum', 0.0218, 'lps'),
	(579874, 128, '2014-03-15 00:26:40.000000', 'consum', 0.0211, 'lps'),
	(579875, 128, '2014-03-15 00:26:41.000000', 'consum', 0.0212, 'lps'),
	(579876, 128, '2014-03-15 00:26:42.000000', 'consum', 0.0219, 'lps'),
	(579877, 128, '2014-03-15 00:26:43.000000', 'consum', 0.0215, 'lps'),
	(579878, 128, '2014-03-15 00:26:44.000000', 'consum', 0.0211, 'lps'),
	(579879, 128, '2014-03-15 00:26:45.000000', 'consum', 0.0210, 'lps'),
	(579880, 128, '2014-03-15 00:26:46.000000', 'consum', 0.0217, 'lps'),
	(579881, 128, '2014-03-15 00:26:47.000000', 'consum', 0.0214, 'lps'),
	(579882, 128, '2014-03-15 00:26:48.000000', 'consum', 0.0219, 'lps'),
	(579883, 128, '2014-03-15 00:26:49.000000', 'consum', 0.0211, 'lps'),
	(579884, 128, '2014-03-15 00:26:50.000000', 'consum', 0.0212, 'lps'),
	(579885, 128, '2014-03-15 00:26:51.000000', 'consum', 0.0218, 'lps'),
	(579886, 128, '2014-03-15 00:26:52.000000', 'consum', 0.0212, 'lps'),
	(579887, 128, '2014-03-15 00:26:53.000000', 'consum', 0.0219, 'lps'),
	(579888, 128, '2014-03-15 00:26:54.000000', 'consum', 0.0217, 'lps'),
	(579889, 128, '2014-03-15 00:26:55.000000', 'consum', 0.0219, 'lps'),
	(579890, 128, '2014-03-15 00:26:56.000000', 'consum', 0.0220, 'lps'),
	(579891, 128, '2014-03-15 00:26:57.000000', 'consum', 0.0214, 'lps'),
	(579892, 128, '2014-03-15 00:26:58.000000', 'consum', 0.0213, 'lps'),
	(579893, 128, '2014-03-15 00:26:59.000000', 'consum', 0.0211, 'lps'),
	(579894, 128, '2014-03-15 00:27:00.000000', 'consum', 0.0217, 'lps'),
	(579895, 128, '2014-03-15 00:27:01.000000', 'consum', 0.0210, 'lps'),
	(579896, 128, '2014-03-15 00:27:02.000000', 'consum', 0.0210, 'lps'),
	(579897, 128, '2014-03-15 00:27:03.000000', 'consum', 0.0214, 'lps'),
	(579898, 128, '2014-03-15 00:27:04.000000', 'consum', 0.0217, 'lps'),
	(579899, 128, '2014-03-15 00:27:05.000000', 'consum', 0.0213, 'lps'),
	(579900, 128, '2014-03-15 00:27:06.000000', 'consum', 0.0213, 'lps'),
	(579901, 128, '2014-03-15 00:27:07.000000', 'consum', 0.0218, 'lps'),
	(579902, 128, '2014-03-15 00:27:08.000000', 'consum', 0.0210, 'lps'),
	(579903, 128, '2014-03-15 00:27:09.000000', 'consum', 0.0220, 'lps'),
	(579904, 128, '2014-03-15 00:27:10.000000', 'consum', 0.0214, 'lps'),
	(579905, 128, '2014-03-15 00:27:11.000000', 'consum', 0.0211, 'lps'),
	(579906, 128, '2014-03-15 00:27:12.000000', 'consum', 0.0216, 'lps'),
	(579907, 128, '2014-03-15 00:27:13.000000', 'consum', 0.0214, 'lps'),
	(579908, 128, '2014-03-15 00:27:14.000000', 'consum', 0.0215, 'lps'),
	(579909, 128, '2014-03-15 00:27:15.000000', 'consum', 0.0210, 'lps'),
	(579910, 128, '2014-03-15 00:27:16.000000', 'consum', 0.0218, 'lps'),
	(579911, 128, '2014-03-15 00:27:17.000000', 'consum', 0.0218, 'lps'),
	(579912, 128, '2014-03-15 00:27:18.000000', 'consum', 0.0214, 'lps'),
	(579913, 128, '2014-03-15 00:27:19.000000', 'consum', 0.0217, 'lps'),
	(579914, 128, '2014-03-15 00:27:20.000000', 'consum', 0.0213, 'lps'),
	(579915, 128, '2014-03-15 00:27:21.000000', 'consum', 0.0216, 'lps'),
	(579916, 128, '2014-03-15 00:27:22.000000', 'consum', 0.0218, 'lps'),
	(579917, 128, '2014-03-15 00:27:23.000000', 'consum', 0.0214, 'lps'),
	(579918, 128, '2014-03-15 00:27:24.000000', 'consum', 0.0215, 'lps'),
	(579919, 128, '2014-03-15 00:27:25.000000', 'consum', 0.0213, 'lps'),
	(579920, 128, '2014-03-15 00:27:26.000000', 'consum', 0.0212, 'lps'),
	(579921, 128, '2014-03-15 00:27:27.000000', 'consum', 0.0210, 'lps'),
	(579922, 128, '2014-03-15 00:27:28.000000', 'consum', 0.0217, 'lps'),
	(579923, 128, '2014-03-15 00:27:29.000000', 'consum', 0.0213, 'lps'),
	(579924, 128, '2014-03-15 00:27:30.000000', 'consum', 0.0213, 'lps'),
	(579925, 128, '2014-03-15 00:27:31.000000', 'consum', 0.0216, 'lps'),
	(579926, 128, '2014-03-15 00:27:32.000000', 'consum', 0.0210, 'lps'),
	(579927, 128, '2014-03-15 00:27:33.000000', 'consum', 0.0216, 'lps'),
	(579928, 128, '2014-03-15 00:27:34.000000', 'consum', 0.0218, 'lps'),
	(579929, 128, '2014-03-15 00:27:35.000000', 'consum', 0.0220, 'lps'),
	(579930, 128, '2014-03-15 00:27:36.000000', 'consum', 0.0216, 'lps'),
	(579931, 128, '2014-03-15 00:27:37.000000', 'consum', 0.0220, 'lps'),
	(579932, 128, '2014-03-15 00:27:38.000000', 'consum', 0.0210, 'lps'),
	(579933, 128, '2014-03-15 00:27:39.000000', 'consum', 0.0215, 'lps'),
	(579934, 128, '2014-03-15 00:27:40.000000', 'consum', 0.0211, 'lps'),
	(579935, 128, '2014-03-15 00:27:41.000000', 'consum', 0.0212, 'lps'),
	(579936, 128, '2014-03-15 00:27:42.000000', 'consum', 0.0219, 'lps'),
	(579937, 128, '2014-03-15 00:27:43.000000', 'consum', 0.0215, 'lps'),
	(579938, 128, '2014-03-15 00:27:44.000000', 'consum', 0.0210, 'lps'),
	(579939, 128, '2014-03-15 00:27:45.000000', 'consum', 0.0218, 'lps'),
	(579940, 128, '2014-03-15 00:27:46.000000', 'consum', 0.0218, 'lps'),
	(579941, 128, '2014-03-15 00:27:47.000000', 'consum', 0.0216, 'lps'),
	(579942, 128, '2014-03-15 00:27:48.000000', 'consum', 0.0214, 'lps'),
	(579943, 128, '2014-03-15 00:27:49.000000', 'consum', 0.0213, 'lps'),
	(579944, 128, '2014-03-15 00:27:50.000000', 'consum', 0.0213, 'lps'),
	(579945, 128, '2014-03-15 00:27:51.000000', 'consum', 0.0217, 'lps'),
	(579946, 128, '2014-03-15 00:27:52.000000', 'consum', 0.0217, 'lps'),
	(579947, 128, '2014-03-15 00:27:53.000000', 'consum', 0.0210, 'lps'),
	(579948, 128, '2014-03-15 00:27:54.000000', 'consum', 0.0211, 'lps'),
	(579949, 128, '2014-03-15 00:27:55.000000', 'consum', 0.0219, 'lps'),
	(579950, 128, '2014-03-15 00:27:56.000000', 'consum', 0.0217, 'lps'),
	(579951, 128, '2014-03-15 00:27:57.000000', 'consum', 0.0218, 'lps'),
	(579952, 128, '2014-03-15 00:27:58.000000', 'consum', 0.0210, 'lps'),
	(579953, 128, '2014-03-15 00:27:59.000000', 'consum', 0.0217, 'lps'),
	(579954, 128, '2014-03-15 00:28:00.000000', 'consum', 0.0215, 'lps'),
	(579955, 128, '2014-03-15 00:28:01.000000', 'consum', 0.0215, 'lps'),
	(579956, 128, '2014-03-15 00:28:02.000000', 'consum', 0.0218, 'lps'),
	(579957, 128, '2014-03-15 00:28:03.000000', 'consum', 0.0212, 'lps'),
	(579958, 128, '2014-03-15 00:28:04.000000', 'consum', 0.0211, 'lps'),
	(579959, 128, '2014-03-15 00:28:05.000000', 'consum', 0.0219, 'lps'),
	(579960, 128, '2014-03-15 00:28:06.000000', 'consum', 0.0219, 'lps'),
	(579961, 128, '2014-03-15 00:28:07.000000', 'consum', 0.0219, 'lps'),
	(579962, 128, '2014-03-15 00:28:08.000000', 'consum', 0.0216, 'lps'),
	(579963, 128, '2014-03-15 00:28:09.000000', 'consum', 0.0212, 'lps'),
	(579964, 128, '2014-03-15 00:28:10.000000', 'consum', 0.0215, 'lps'),
	(579965, 128, '2014-03-15 00:28:11.000000', 'consum', 0.0220, 'lps'),
	(579966, 128, '2014-03-15 00:28:12.000000', 'consum', 0.0212, 'lps'),
	(579967, 128, '2014-03-15 00:28:13.000000', 'consum', 0.0212, 'lps'),
	(579968, 128, '2014-03-15 00:28:14.000000', 'consum', 0.0214, 'lps'),
	(579969, 128, '2014-03-15 00:28:15.000000', 'consum', 0.0214, 'lps'),
	(579970, 128, '2014-03-15 00:28:16.000000', 'consum', 0.0217, 'lps'),
	(579971, 128, '2014-03-15 00:28:17.000000', 'consum', 0.0213, 'lps'),
	(579972, 128, '2014-03-15 00:28:18.000000', 'consum', 0.0214, 'lps'),
	(579973, 128, '2014-03-15 00:28:19.000000', 'consum', 0.0210, 'lps'),
	(579974, 128, '2014-03-15 00:28:20.000000', 'consum', 0.0212, 'lps'),
	(579975, 128, '2014-03-15 00:28:21.000000', 'consum', 0.0219, 'lps'),
	(579976, 128, '2014-03-15 00:28:22.000000', 'consum', 0.0217, 'lps'),
	(579977, 128, '2014-03-15 00:28:23.000000', 'consum', 0.0218, 'lps'),
	(579978, 128, '2014-03-15 00:28:24.000000', 'consum', 0.0220, 'lps'),
	(579979, 128, '2014-03-15 00:28:25.000000', 'consum', 0.0214, 'lps'),
	(579980, 128, '2014-03-15 00:28:26.000000', 'consum', 0.0213, 'lps'),
	(579981, 128, '2014-03-15 00:28:27.000000', 'consum', 0.0211, 'lps'),
	(579982, 128, '2014-03-15 00:28:28.000000', 'consum', 0.0218, 'lps'),
	(579983, 128, '2014-03-15 00:28:29.000000', 'consum', 0.0213, 'lps'),
	(579984, 128, '2014-03-15 00:28:30.000000', 'consum', 0.0215, 'lps'),
	(579985, 128, '2014-03-15 00:28:31.000000', 'consum', 0.0216, 'lps'),
	(579986, 128, '2014-03-15 00:28:32.000000', 'consum', 0.0214, 'lps'),
	(579987, 128, '2014-03-15 00:28:33.000000', 'consum', 0.0211, 'lps'),
	(579988, 128, '2014-03-15 00:28:34.000000', 'consum', 0.0217, 'lps'),
	(579989, 128, '2014-03-15 00:28:35.000000', 'consum', 0.0210, 'lps'),
	(579990, 128, '2014-03-15 00:28:36.000000', 'consum', 0.0220, 'lps'),
	(579991, 128, '2014-03-15 00:28:37.000000', 'consum', 0.0219, 'lps'),
	(579992, 128, '2014-03-15 00:28:38.000000', 'consum', 0.0214, 'lps'),
	(579993, 128, '2014-03-15 00:28:39.000000', 'consum', 0.0214, 'lps'),
	(579994, 128, '2014-03-15 00:28:40.000000', 'consum', 0.0220, 'lps'),
	(579995, 128, '2014-03-15 00:28:41.000000', 'consum', 0.0217, 'lps'),
	(579996, 128, '2014-03-15 00:28:42.000000', 'consum', 0.0212, 'lps'),
	(579997, 128, '2014-03-15 00:28:43.000000', 'consum', 0.0213, 'lps'),
	(579998, 128, '2014-03-15 00:28:44.000000', 'consum', 0.0217, 'lps'),
	(579999, 128, '2014-03-15 00:28:45.000000', 'consum', 0.0215, 'lps'),
	(580000, 128, '2014-03-15 00:28:46.000000', 'consum', 0.0216, 'lps'),
	(580001, 128, '2014-03-15 00:28:47.000000', 'consum', 0.0215, 'lps'),
	(580002, 128, '2014-03-15 00:28:48.000000', 'consum', 0.0219, 'lps'),
	(580003, 128, '2014-03-15 00:28:49.000000', 'consum', 0.0216, 'lps'),
	(580004, 128, '2014-03-15 00:28:50.000000', 'consum', 0.0213, 'lps'),
	(580005, 128, '2014-03-15 00:28:51.000000', 'consum', 0.0219, 'lps'),
	(580006, 128, '2014-03-15 00:28:52.000000', 'consum', 0.0213, 'lps'),
	(580007, 128, '2014-03-15 00:28:53.000000', 'consum', 0.0220, 'lps'),
	(580008, 128, '2014-03-15 00:28:54.000000', 'consum', 0.0220, 'lps'),
	(580009, 128, '2014-03-15 00:28:55.000000', 'consum', 0.0220, 'lps'),
	(580010, 128, '2014-03-15 00:28:56.000000', 'consum', 0.0219, 'lps'),
	(580011, 128, '2014-03-15 00:28:57.000000', 'consum', 0.0216, 'lps'),
	(580012, 128, '2014-03-15 00:28:58.000000', 'consum', 0.0214, 'lps'),
	(580013, 128, '2014-03-15 00:28:59.000000', 'consum', 0.0212, 'lps'),
	(580014, 128, '2014-03-15 00:29:00.000000', 'consum', 0.0210, 'lps'),
	(580015, 128, '2014-03-15 00:29:01.000000', 'consum', 0.0214, 'lps'),
	(580016, 128, '2014-03-15 00:29:02.000000', 'consum', 0.0218, 'lps'),
	(580017, 128, '2014-03-15 00:29:03.000000', 'consum', 0.0216, 'lps'),
	(580018, 128, '2014-03-15 00:29:04.000000', 'consum', 0.0220, 'lps'),
	(580019, 128, '2014-03-15 00:29:05.000000', 'consum', 0.0217, 'lps'),
	(580020, 128, '2014-03-15 00:29:06.000000', 'consum', 0.0218, 'lps'),
	(580021, 128, '2014-03-15 00:29:07.000000', 'consum', 0.0218, 'lps'),
	(580022, 128, '2014-03-15 00:29:08.000000', 'consum', 0.0215, 'lps'),
	(580023, 128, '2014-03-15 00:29:09.000000', 'consum', 0.0211, 'lps'),
	(580024, 128, '2014-03-15 00:29:10.000000', 'consum', 0.0212, 'lps'),
	(580025, 128, '2014-03-15 00:29:11.000000', 'consum', 0.0217, 'lps'),
	(580026, 128, '2014-03-15 00:29:12.000000', 'consum', 0.0219, 'lps'),
	(580027, 128, '2014-03-15 00:29:13.000000', 'consum', 0.0211, 'lps'),
	(580028, 128, '2014-03-15 00:29:14.000000', 'consum', 0.0211, 'lps'),
	(580029, 128, '2014-03-15 00:29:15.000000', 'consum', 0.0213, 'lps'),
	(580030, 128, '2014-03-15 00:29:16.000000', 'consum', 0.0220, 'lps'),
	(580031, 128, '2014-03-15 00:29:17.000000', 'consum', 0.0220, 'lps'),
	(580032, 128, '2014-03-15 00:29:18.000000', 'consum', 0.0219, 'lps'),
	(580033, 128, '2014-03-15 00:29:19.000000', 'consum', 0.0217, 'lps'),
	(580034, 128, '2014-03-15 00:29:20.000000', 'consum', 0.0215, 'lps'),
	(580035, 128, '2014-03-15 00:29:21.000000', 'consum', 0.0217, 'lps'),
	(580036, 128, '2014-03-15 00:29:22.000000', 'consum', 0.0218, 'lps'),
	(580037, 128, '2014-03-15 00:29:23.000000', 'consum', 0.0219, 'lps'),
	(580038, 128, '2014-03-15 00:29:24.000000', 'consum', 0.0220, 'lps'),
	(580039, 128, '2014-03-15 00:29:25.000000', 'consum', 0.0211, 'lps'),
	(580040, 128, '2014-03-15 00:29:26.000000', 'consum', 0.0217, 'lps'),
	(580041, 128, '2014-03-15 00:29:27.000000', 'consum', 0.0212, 'lps'),
	(580042, 128, '2014-03-15 00:29:28.000000', 'consum', 0.0210, 'lps'),
	(580043, 128, '2014-03-15 00:29:29.000000', 'consum', 0.0215, 'lps'),
	(580044, 128, '2014-03-15 00:29:30.000000', 'consum', 0.0214, 'lps'),
	(580045, 128, '2014-03-15 00:29:31.000000', 'consum', 0.0215, 'lps'),
	(580046, 128, '2014-03-15 00:29:32.000000', 'consum', 0.0214, 'lps'),
	(580047, 128, '2014-03-15 00:29:33.000000', 'consum', 0.0216, 'lps'),
	(580048, 128, '2014-03-15 00:29:34.000000', 'consum', 0.0215, 'lps'),
	(580049, 128, '2014-03-15 00:29:35.000000', 'consum', 0.0218, 'lps'),
	(580050, 128, '2014-03-15 00:29:36.000000', 'consum', 0.0214, 'lps'),
	(580051, 128, '2014-03-15 00:29:37.000000', 'consum', 0.0217, 'lps'),
	(580052, 128, '2014-03-15 00:29:38.000000', 'consum', 0.0211, 'lps'),
	(580053, 128, '2014-03-15 00:29:39.000000', 'consum', 0.0217, 'lps'),
	(580054, 128, '2014-03-15 00:29:40.000000', 'consum', 0.0219, 'lps'),
	(580055, 128, '2014-03-15 00:29:41.000000', 'consum', 0.0213, 'lps'),
	(580056, 128, '2014-03-15 00:29:42.000000', 'consum', 0.0211, 'lps'),
	(580057, 128, '2014-03-15 00:29:43.000000', 'consum', 0.0216, 'lps'),
	(580058, 128, '2014-03-15 00:29:44.000000', 'consum', 0.0215, 'lps'),
	(580059, 128, '2014-03-15 00:29:45.000000', 'consum', 0.0219, 'lps'),
	(580060, 128, '2014-03-15 00:29:46.000000', 'consum', 0.0217, 'lps'),
	(580061, 128, '2014-03-15 00:29:47.000000', 'consum', 0.0218, 'lps'),
	(580062, 128, '2014-03-15 00:29:48.000000', 'consum', 0.0220, 'lps'),
	(580063, 128, '2014-03-15 00:29:49.000000', 'consum', 0.0216, 'lps'),
	(580064, 128, '2014-03-15 00:29:50.000000', 'consum', 0.0219, 'lps'),
	(580065, 128, '2014-03-15 00:29:51.000000', 'consum', 0.0218, 'lps'),
	(580066, 128, '2014-03-15 00:29:52.000000', 'consum', 0.0213, 'lps'),
	(580067, 128, '2014-03-15 00:29:53.000000', 'consum', 0.0220, 'lps'),
	(580068, 128, '2014-03-15 00:29:54.000000', 'consum', 0.0211, 'lps'),
	(580069, 128, '2014-03-15 00:29:55.000000', 'consum', 0.0217, 'lps'),
	(580070, 128, '2014-03-15 00:29:56.000000', 'consum', 0.0220, 'lps'),
	(580071, 128, '2014-03-15 00:29:57.000000', 'consum', 0.0217, 'lps'),
	(580072, 128, '2014-03-15 00:29:58.000000', 'consum', 0.0217, 'lps'),
	(580073, 128, '2014-03-15 00:29:59.000000', 'consum', 0.0214, 'lps'),
	(580074, 128, '2014-03-15 00:30:00.000000', 'consum', 0.0218, 'lps'),
	(580075, 128, '2014-03-15 00:30:01.000000', 'consum', 0.0219, 'lps'),
	(580076, 128, '2014-03-15 00:30:02.000000', 'consum', 0.0218, 'lps'),
	(580077, 128, '2014-03-15 00:30:03.000000', 'consum', 0.0214, 'lps'),
	(580078, 128, '2014-03-15 00:30:04.000000', 'consum', 0.0215, 'lps'),
	(580079, 128, '2014-03-15 00:30:05.000000', 'consum', 0.0215, 'lps'),
	(580080, 128, '2014-03-15 00:30:06.000000', 'consum', 0.0210, 'lps'),
	(580081, 128, '2014-03-15 00:30:07.000000', 'consum', 0.0215, 'lps'),
	(580082, 128, '2014-03-15 00:30:08.000000', 'consum', 0.0216, 'lps'),
	(580083, 128, '2014-03-15 00:30:09.000000', 'consum', 0.0213, 'lps'),
	(580084, 128, '2014-03-15 00:30:10.000000', 'consum', 0.0219, 'lps'),
	(580085, 128, '2014-03-15 00:30:11.000000', 'consum', 0.0214, 'lps'),
	(580086, 128, '2014-03-15 00:30:12.000000', 'consum', 0.0216, 'lps'),
	(580087, 128, '2014-03-15 00:30:13.000000', 'consum', 0.0215, 'lps'),
	(580088, 128, '2014-03-15 00:30:14.000000', 'consum', 0.0217, 'lps'),
	(580089, 128, '2014-03-15 00:30:15.000000', 'consum', 0.0210, 'lps'),
	(580090, 128, '2014-03-15 00:30:16.000000', 'consum', 0.0210, 'lps'),
	(580091, 128, '2014-03-15 00:30:17.000000', 'consum', 0.0213, 'lps'),
	(580092, 128, '2014-03-15 00:30:18.000000', 'consum', 0.0213, 'lps'),
	(580093, 128, '2014-03-15 00:30:19.000000', 'consum', 0.0215, 'lps'),
	(580094, 128, '2014-03-15 00:30:20.000000', 'consum', 0.0217, 'lps'),
	(580095, 128, '2014-03-15 00:30:21.000000', 'consum', 0.0219, 'lps'),
	(580096, 128, '2014-03-15 00:30:22.000000', 'consum', 0.0212, 'lps'),
	(580097, 128, '2014-03-15 00:30:23.000000', 'consum', 0.0216, 'lps'),
	(580098, 128, '2014-03-15 00:30:24.000000', 'consum', 0.0214, 'lps'),
	(580099, 128, '2014-03-15 00:30:25.000000', 'consum', 0.0212, 'lps'),
	(580100, 128, '2014-03-15 00:30:26.000000', 'consum', 0.0219, 'lps'),
	(580101, 128, '2014-03-15 00:30:27.000000', 'consum', 0.0217, 'lps'),
	(580102, 128, '2014-03-15 00:30:28.000000', 'consum', 0.0217, 'lps'),
	(580103, 128, '2014-03-15 00:30:29.000000', 'consum', 0.0214, 'lps'),
	(580104, 128, '2014-03-15 00:30:30.000000', 'consum', 0.0211, 'lps'),
	(580105, 128, '2014-03-15 00:30:31.000000', 'consum', 0.0215, 'lps'),
	(580106, 128, '2014-03-15 00:30:32.000000', 'consum', 0.0210, 'lps'),
	(580107, 128, '2014-03-15 00:30:33.000000', 'consum', 0.0217, 'lps'),
	(580108, 128, '2014-03-15 00:30:34.000000', 'consum', 0.0212, 'lps'),
	(580109, 128, '2014-03-15 00:30:35.000000', 'consum', 0.0211, 'lps'),
	(580110, 128, '2014-03-15 00:30:36.000000', 'consum', 0.0220, 'lps'),
	(580111, 128, '2014-03-15 00:30:37.000000', 'consum', 0.0212, 'lps'),
	(580112, 128, '2014-03-15 00:30:38.000000', 'consum', 0.0216, 'lps'),
	(580113, 128, '2014-03-15 00:30:39.000000', 'consum', 0.0210, 'lps'),
	(580114, 128, '2014-03-15 00:30:40.000000', 'consum', 0.0214, 'lps'),
	(580115, 128, '2014-03-15 00:30:41.000000', 'consum', 0.0211, 'lps'),
	(580116, 128, '2014-03-15 00:30:42.000000', 'consum', 0.0212, 'lps'),
	(580117, 128, '2014-03-15 00:30:43.000000', 'consum', 0.0220, 'lps'),
	(580118, 128, '2014-03-15 00:30:44.000000', 'consum', 0.0219, 'lps'),
	(580119, 128, '2014-03-15 00:30:45.000000', 'consum', 0.0214, 'lps'),
	(580120, 128, '2014-03-15 00:30:46.000000', 'consum', 0.0217, 'lps'),
	(580121, 128, '2014-03-15 00:30:47.000000', 'consum', 0.0212, 'lps'),
	(580122, 128, '2014-03-15 00:30:48.000000', 'consum', 0.0220, 'lps'),
	(580123, 128, '2014-03-15 00:30:49.000000', 'consum', 0.0210, 'lps'),
	(580124, 128, '2014-03-15 00:30:50.000000', 'consum', 0.0214, 'lps'),
	(580125, 128, '2014-03-15 00:30:51.000000', 'consum', 0.0218, 'lps'),
	(580126, 128, '2014-03-15 00:30:52.000000', 'consum', 0.0219, 'lps'),
	(580127, 128, '2014-03-15 00:30:53.000000', 'consum', 0.0220, 'lps'),
	(580128, 128, '2014-03-15 00:30:54.000000', 'consum', 0.0211, 'lps'),
	(580129, 128, '2014-03-15 00:30:55.000000', 'consum', 0.0217, 'lps'),
	(580130, 128, '2014-03-15 00:30:56.000000', 'consum', 0.0211, 'lps'),
	(580131, 128, '2014-03-15 00:30:57.000000', 'consum', 0.0218, 'lps'),
	(580132, 128, '2014-03-15 00:30:58.000000', 'consum', 0.0211, 'lps'),
	(580133, 128, '2014-03-15 00:30:59.000000', 'consum', 0.0216, 'lps'),
	(580134, 128, '2014-03-15 00:31:00.000000', 'consum', 0.0214, 'lps'),
	(580135, 128, '2014-03-15 00:31:01.000000', 'consum', 0.0211, 'lps'),
	(580136, 128, '2014-03-15 00:31:02.000000', 'consum', 0.0218, 'lps'),
	(580137, 128, '2014-03-15 00:31:03.000000', 'consum', 0.0212, 'lps'),
	(580138, 128, '2014-03-15 00:31:04.000000', 'consum', 0.0217, 'lps'),
	(580139, 128, '2014-03-15 00:31:05.000000', 'consum', 0.0220, 'lps'),
	(580140, 128, '2014-03-15 00:31:06.000000', 'consum', 0.0215, 'lps'),
	(580141, 128, '2014-03-15 00:31:07.000000', 'consum', 0.0218, 'lps'),
	(580142, 128, '2014-03-15 00:31:08.000000', 'consum', 0.0213, 'lps'),
	(580143, 128, '2014-03-15 00:31:09.000000', 'consum', 0.0214, 'lps'),
	(580144, 128, '2014-03-15 00:31:10.000000', 'consum', 0.0212, 'lps'),
	(580145, 128, '2014-03-15 00:31:11.000000', 'consum', 0.0217, 'lps'),
	(580146, 128, '2014-03-15 00:31:12.000000', 'consum', 0.0217, 'lps'),
	(580147, 128, '2014-03-15 00:31:13.000000', 'consum', 0.0213, 'lps'),
	(580148, 128, '2014-03-15 00:31:14.000000', 'consum', 0.0216, 'lps'),
	(580149, 128, '2014-03-15 00:31:15.000000', 'consum', 0.0211, 'lps'),
	(580150, 128, '2014-03-15 00:31:16.000000', 'consum', 0.0219, 'lps'),
	(580151, 128, '2014-03-15 00:31:17.000000', 'consum', 0.0210, 'lps'),
	(580152, 128, '2014-03-15 00:31:18.000000', 'consum', 0.0215, 'lps'),
	(580153, 128, '2014-03-15 00:31:19.000000', 'consum', 0.0214, 'lps'),
	(580154, 128, '2014-03-15 00:31:20.000000', 'consum', 0.0214, 'lps'),
	(580155, 128, '2014-03-15 00:31:21.000000', 'consum', 0.0210, 'lps'),
	(580156, 128, '2014-03-15 00:31:22.000000', 'consum', 0.0220, 'lps'),
	(580157, 128, '2014-03-15 00:31:23.000000', 'consum', 0.0216, 'lps'),
	(580158, 128, '2014-03-15 00:31:24.000000', 'consum', 0.0212, 'lps'),
	(580159, 128, '2014-03-15 00:31:25.000000', 'consum', 0.0214, 'lps'),
	(580160, 128, '2014-03-15 00:31:26.000000', 'consum', 0.0213, 'lps'),
	(580161, 128, '2014-03-15 00:31:27.000000', 'consum', 0.0212, 'lps'),
	(580162, 128, '2014-03-15 00:31:28.000000', 'consum', 0.0214, 'lps'),
	(580163, 128, '2014-03-15 00:31:29.000000', 'consum', 0.0212, 'lps'),
	(580164, 128, '2014-03-15 00:31:30.000000', 'consum', 0.0218, 'lps'),
	(580165, 128, '2014-03-15 00:31:31.000000', 'consum', 0.0213, 'lps'),
	(580166, 128, '2014-03-15 00:31:32.000000', 'consum', 0.0212, 'lps'),
	(580167, 128, '2014-03-15 00:31:33.000000', 'consum', 0.0213, 'lps'),
	(580168, 128, '2014-03-15 00:31:34.000000', 'consum', 0.0219, 'lps'),
	(580169, 128, '2014-03-15 00:31:35.000000', 'consum', 0.0213, 'lps'),
	(580170, 128, '2014-03-15 00:31:36.000000', 'consum', 0.0212, 'lps'),
	(580171, 128, '2014-03-15 00:31:37.000000', 'consum', 0.0219, 'lps'),
	(580172, 128, '2014-03-15 00:31:38.000000', 'consum', 0.0219, 'lps'),
	(580173, 128, '2014-03-15 00:31:39.000000', 'consum', 0.0219, 'lps'),
	(580174, 128, '2014-03-15 00:31:40.000000', 'consum', 0.0215, 'lps'),
	(580175, 128, '2014-03-15 00:31:41.000000', 'consum', 0.0220, 'lps'),
	(580176, 128, '2014-03-15 00:31:42.000000', 'consum', 0.0212, 'lps'),
	(580177, 128, '2014-03-15 00:31:43.000000', 'consum', 0.0213, 'lps'),
	(580178, 128, '2014-03-15 00:31:44.000000', 'consum', 0.0219, 'lps'),
	(580179, 128, '2014-03-15 00:31:45.000000', 'consum', 0.0212, 'lps'),
	(580180, 128, '2014-03-15 00:31:46.000000', 'consum', 0.0217, 'lps'),
	(580181, 128, '2014-03-15 00:31:47.000000', 'consum', 0.0216, 'lps'),
	(580182, 128, '2014-03-15 00:31:48.000000', 'consum', 0.0210, 'lps'),
	(580183, 128, '2014-03-15 00:31:49.000000', 'consum', 0.0214, 'lps'),
	(580184, 128, '2014-03-15 00:31:50.000000', 'consum', 0.0210, 'lps'),
	(580185, 128, '2014-03-15 00:31:51.000000', 'consum', 0.0211, 'lps'),
	(580186, 128, '2014-03-15 00:31:52.000000', 'consum', 0.0212, 'lps'),
	(580187, 128, '2014-03-15 00:31:53.000000', 'consum', 0.0219, 'lps'),
	(580188, 128, '2014-03-15 00:31:54.000000', 'consum', 0.0217, 'lps'),
	(580189, 128, '2014-03-15 00:31:55.000000', 'consum', 0.0218, 'lps'),
	(580190, 128, '2014-03-15 00:31:56.000000', 'consum', 0.0220, 'lps'),
	(580191, 128, '2014-03-15 00:31:57.000000', 'consum', 0.0212, 'lps'),
	(580192, 128, '2014-03-15 00:31:58.000000', 'consum', 0.0214, 'lps'),
	(580193, 128, '2014-03-15 00:31:59.000000', 'consum', 0.0213, 'lps'),
	(580194, 128, '2014-03-15 00:32:00.000000', 'consum', 0.0213, 'lps'),
	(580195, 128, '2014-03-15 00:32:01.000000', 'consum', 0.0216, 'lps'),
	(580196, 128, '2014-03-15 00:32:02.000000', 'consum', 0.0212, 'lps'),
	(580197, 128, '2014-03-15 00:32:03.000000', 'consum', 0.0213, 'lps'),
	(580198, 128, '2014-03-15 00:32:04.000000', 'consum', 0.0220, 'lps'),
	(580199, 128, '2014-03-15 00:32:05.000000', 'consum', 0.0218, 'lps'),
	(580200, 128, '2014-03-15 00:32:06.000000', 'consum', 0.0219, 'lps'),
	(580201, 128, '2014-03-15 00:32:07.000000', 'consum', 0.0211, 'lps'),
	(580202, 128, '2014-03-15 00:32:08.000000', 'consum', 0.0210, 'lps'),
	(580203, 128, '2014-03-15 00:32:09.000000', 'consum', 0.0220, 'lps'),
	(580204, 128, '2014-03-15 00:32:10.000000', 'consum', 0.0214, 'lps'),
	(580205, 128, '2014-03-15 00:32:11.000000', 'consum', 0.0214, 'lps'),
	(580206, 128, '2014-03-15 00:32:12.000000', 'consum', 0.0219, 'lps'),
	(580207, 128, '2014-03-15 00:32:13.000000', 'consum', 0.0218, 'lps'),
	(580208, 128, '2014-03-15 00:32:14.000000', 'consum', 0.0216, 'lps'),
	(580209, 128, '2014-03-15 00:32:15.000000', 'consum', 0.0215, 'lps'),
	(580210, 128, '2014-03-15 00:32:16.000000', 'consum', 0.0217, 'lps'),
	(580211, 128, '2014-03-15 00:32:17.000000', 'consum', 0.0218, 'lps'),
	(580212, 128, '2014-03-15 00:32:18.000000', 'consum', 0.0220, 'lps'),
	(580213, 128, '2014-03-15 00:32:19.000000', 'consum', 0.0216, 'lps'),
	(580214, 128, '2014-03-15 00:32:20.000000', 'consum', 0.0220, 'lps'),
	(580215, 128, '2014-03-15 00:32:21.000000', 'consum', 0.0210, 'lps'),
	(580216, 128, '2014-03-15 00:32:22.000000', 'consum', 0.0214, 'lps'),
	(580217, 128, '2014-03-15 00:32:23.000000', 'consum', 0.0219, 'lps'),
	(580218, 128, '2014-03-15 00:32:24.000000', 'consum', 0.0220, 'lps'),
	(580219, 128, '2014-03-15 00:32:25.000000', 'consum', 0.0210, 'lps'),
	(580220, 128, '2014-03-15 00:32:26.000000', 'consum', 0.0217, 'lps'),
	(580221, 128, '2014-03-15 00:32:27.000000', 'consum', 0.0213, 'lps'),
	(580222, 128, '2014-03-15 00:32:28.000000', 'consum', 0.0212, 'lps'),
	(580223, 128, '2014-03-15 00:32:29.000000', 'consum', 0.0214, 'lps'),
	(580224, 128, '2014-03-15 00:32:30.000000', 'consum', 0.0213, 'lps'),
	(580225, 128, '2014-03-15 00:32:31.000000', 'consum', 0.0213, 'lps'),
	(580226, 128, '2014-03-15 00:32:32.000000', 'consum', 0.0216, 'lps'),
	(580227, 128, '2014-03-15 00:32:33.000000', 'consum', 0.0220, 'lps'),
	(580228, 128, '2014-03-15 00:32:34.000000', 'consum', 0.0212, 'lps'),
	(580229, 128, '2014-03-15 00:32:35.000000', 'consum', 0.0211, 'lps'),
	(580230, 128, '2014-03-15 00:32:36.000000', 'consum', 0.0220, 'lps'),
	(580231, 128, '2014-03-15 00:32:37.000000', 'consum', 0.0214, 'lps'),
	(580232, 128, '2014-03-15 00:32:38.000000', 'consum', 0.0212, 'lps'),
	(580233, 128, '2014-03-15 00:32:39.000000', 'consum', 0.0220, 'lps'),
	(580234, 128, '2014-03-15 00:32:40.000000', 'consum', 0.0211, 'lps'),
	(580235, 128, '2014-03-15 00:32:41.000000', 'consum', 0.0216, 'lps'),
	(580236, 128, '2014-03-15 00:32:42.000000', 'consum', 0.0216, 'lps'),
	(580237, 128, '2014-03-15 00:32:43.000000', 'consum', 0.0211, 'lps'),
	(580238, 128, '2014-03-15 00:32:44.000000', 'consum', 0.0211, 'lps'),
	(580239, 128, '2014-03-15 00:32:45.000000', 'consum', 0.0211, 'lps'),
	(580240, 128, '2014-03-15 00:32:46.000000', 'consum', 0.0211, 'lps'),
	(580241, 128, '2014-03-15 00:32:47.000000', 'consum', 0.0214, 'lps'),
	(580242, 128, '2014-03-15 00:32:48.000000', 'consum', 0.0218, 'lps'),
	(580243, 128, '2014-03-15 00:32:49.000000', 'consum', 0.0217, 'lps'),
	(580244, 128, '2014-03-15 00:32:50.000000', 'consum', 0.0220, 'lps'),
	(580245, 128, '2014-03-15 00:32:51.000000', 'consum', 0.0217, 'lps'),
	(580246, 128, '2014-03-15 00:32:52.000000', 'consum', 0.0215, 'lps'),
	(580247, 128, '2014-03-15 00:32:53.000000', 'consum', 0.0217, 'lps'),
	(580248, 128, '2014-03-15 00:32:54.000000', 'consum', 0.0217, 'lps'),
	(580249, 128, '2014-03-15 00:32:55.000000', 'consum', 0.0213, 'lps'),
	(580250, 128, '2014-03-15 00:32:56.000000', 'consum', 0.0215, 'lps'),
	(580251, 128, '2014-03-15 00:32:57.000000', 'consum', 0.0217, 'lps'),
	(580252, 128, '2014-03-15 00:32:58.000000', 'consum', 0.0218, 'lps'),
	(580253, 128, '2014-03-15 00:32:59.000000', 'consum', 0.0220, 'lps'),
	(580254, 128, '2014-03-15 00:33:00.000000', 'consum', 0.0216, 'lps'),
	(580255, 128, '2014-03-15 00:33:01.000000', 'consum', 0.0220, 'lps'),
	(580256, 128, '2014-03-15 00:33:02.000000', 'consum', 0.0211, 'lps'),
	(580257, 128, '2014-03-15 00:33:03.000000', 'consum', 0.0216, 'lps'),
	(580258, 128, '2014-03-15 00:33:04.000000', 'consum', 0.0216, 'lps'),
	(580259, 128, '2014-03-15 00:33:05.000000', 'consum', 0.0210, 'lps'),
	(580260, 128, '2014-03-15 00:33:06.000000', 'consum', 0.0217, 'lps'),
	(580261, 128, '2014-03-15 00:33:07.000000', 'consum', 0.0210, 'lps'),
	(580262, 128, '2014-03-15 00:33:08.000000', 'consum', 0.0214, 'lps'),
	(580263, 128, '2014-03-15 00:33:09.000000', 'consum', 0.0218, 'lps'),
	(580264, 128, '2014-03-15 00:33:10.000000', 'consum', 0.0217, 'lps'),
	(580265, 128, '2014-03-15 00:33:11.000000', 'consum', 0.0212, 'lps'),
	(580266, 128, '2014-03-15 00:33:12.000000', 'consum', 0.0219, 'lps'),
	(580267, 128, '2014-03-15 00:33:13.000000', 'consum', 0.0216, 'lps'),
	(580268, 128, '2014-03-15 00:33:14.000000', 'consum', 0.0216, 'lps'),
	(580269, 128, '2014-03-15 00:33:15.000000', 'consum', 0.0210, 'lps'),
	(580270, 128, '2014-03-15 00:33:16.000000', 'consum', 0.0215, 'lps'),
	(580271, 128, '2014-03-15 00:33:17.000000', 'consum', 0.0212, 'lps'),
	(580272, 128, '2014-03-15 00:33:18.000000', 'consum', 0.0215, 'lps'),
	(580273, 128, '2014-03-15 00:33:19.000000', 'consum', 0.0211, 'lps'),
	(580274, 128, '2014-03-15 00:33:20.000000', 'consum', 0.0212, 'lps'),
	(580275, 128, '2014-03-15 00:33:21.000000', 'consum', 0.0214, 'lps'),
	(580276, 128, '2014-03-15 00:33:22.000000', 'consum', 0.0217, 'lps'),
	(580277, 128, '2014-03-15 00:33:23.000000', 'consum', 0.0219, 'lps'),
	(580278, 128, '2014-03-15 00:33:24.000000', 'consum', 0.0216, 'lps'),
	(580279, 128, '2014-03-15 00:33:25.000000', 'consum', 0.0212, 'lps'),
	(580280, 128, '2014-03-15 00:33:26.000000', 'consum', 0.0216, 'lps'),
	(580281, 128, '2014-03-15 00:33:27.000000', 'consum', 0.0210, 'lps'),
	(580282, 128, '2014-03-15 00:33:28.000000', 'consum', 0.0213, 'lps'),
	(580283, 128, '2014-03-15 00:33:29.000000', 'consum', 0.0216, 'lps'),
	(580284, 128, '2014-03-15 00:33:30.000000', 'consum', 0.0220, 'lps'),
	(580285, 128, '2014-03-15 00:33:31.000000', 'consum', 0.0219, 'lps'),
	(580286, 128, '2014-03-15 00:33:32.000000', 'consum', 0.0215, 'lps'),
	(580287, 128, '2014-03-15 00:33:33.000000', 'consum', 0.0219, 'lps'),
	(580288, 128, '2014-03-15 00:33:34.000000', 'consum', 0.0218, 'lps'),
	(580289, 128, '2014-03-15 00:33:35.000000', 'consum', 0.0215, 'lps'),
	(580290, 128, '2014-03-15 00:33:36.000000', 'consum', 0.0212, 'lps'),
	(580291, 128, '2014-03-15 00:33:37.000000', 'consum', 0.0217, 'lps'),
	(580292, 128, '2014-03-15 00:33:38.000000', 'consum', 0.0216, 'lps'),
	(580293, 128, '2014-03-15 00:33:39.000000', 'consum', 0.0220, 'lps'),
	(580294, 128, '2014-03-15 00:33:40.000000', 'consum', 0.0211, 'lps'),
	(580295, 128, '2014-03-15 00:33:41.000000', 'consum', 0.0217, 'lps'),
	(580296, 128, '2014-03-15 00:33:42.000000', 'consum', 0.0219, 'lps'),
	(580297, 128, '2014-03-15 00:33:43.000000', 'consum', 0.0214, 'lps'),
	(580298, 128, '2014-03-15 00:33:44.000000', 'consum', 0.0213, 'lps'),
	(580299, 128, '2014-03-15 00:33:45.000000', 'consum', 0.0216, 'lps'),
	(580300, 128, '2014-03-15 00:33:46.000000', 'consum', 0.0210, 'lps'),
	(580301, 128, '2014-03-15 00:33:47.000000', 'consum', 0.0215, 'lps'),
	(580302, 128, '2014-03-15 00:33:48.000000', 'consum', 0.0211, 'lps'),
	(580303, 128, '2014-03-15 00:33:49.000000', 'consum', 0.0214, 'lps'),
	(580304, 128, '2014-03-15 00:33:50.000000', 'consum', 0.0215, 'lps'),
	(580305, 128, '2014-03-15 00:33:51.000000', 'consum', 0.0212, 'lps'),
	(580306, 128, '2014-03-15 00:33:52.000000', 'consum', 0.0218, 'lps'),
	(580307, 128, '2014-03-15 00:33:53.000000', 'consum', 0.0211, 'lps'),
	(580308, 128, '2014-03-15 00:33:54.000000', 'consum', 0.0212, 'lps'),
	(580309, 128, '2014-03-15 00:33:55.000000', 'consum', 0.0220, 'lps'),
	(580310, 128, '2014-03-15 00:33:56.000000', 'consum', 0.0210, 'lps'),
	(580311, 128, '2014-03-15 00:33:57.000000', 'consum', 0.0211, 'lps'),
	(580312, 128, '2014-03-15 00:33:58.000000', 'consum', 0.0217, 'lps'),
	(580313, 128, '2014-03-15 00:33:59.000000', 'consum', 0.0220, 'lps'),
	(580314, 128, '2014-03-15 00:34:00.000000', 'consum', 0.0217, 'lps'),
	(580315, 128, '2014-03-15 00:34:01.000000', 'consum', 0.0216, 'lps'),
	(580316, 128, '2014-03-15 00:34:02.000000', 'consum', 0.0219, 'lps'),
	(580317, 128, '2014-03-15 00:34:03.000000', 'consum', 0.0217, 'lps'),
	(580318, 128, '2014-03-15 00:34:04.000000', 'consum', 0.0216, 'lps'),
	(580319, 128, '2014-03-15 00:34:05.000000', 'consum', 0.0212, 'lps'),
	(580320, 128, '2014-03-15 00:34:06.000000', 'consum', 0.0211, 'lps'),
	(580321, 128, '2014-03-15 00:34:07.000000', 'consum', 0.0211, 'lps'),
	(580322, 128, '2014-03-15 00:34:08.000000', 'consum', 0.0212, 'lps'),
	(580323, 128, '2014-03-15 00:34:09.000000', 'consum', 0.0216, 'lps'),
	(580324, 128, '2014-03-15 00:34:10.000000', 'consum', 0.0213, 'lps'),
	(580325, 128, '2014-03-15 00:34:11.000000', 'consum', 0.0219, 'lps'),
	(580326, 128, '2014-03-15 00:34:12.000000', 'consum', 0.0214, 'lps'),
	(580327, 128, '2014-03-15 00:34:13.000000', 'consum', 0.0215, 'lps'),
	(580328, 128, '2014-03-15 00:34:14.000000', 'consum', 0.0212, 'lps'),
	(580329, 128, '2014-03-15 00:34:15.000000', 'consum', 0.0218, 'lps'),
	(580330, 128, '2014-03-15 00:34:16.000000', 'consum', 0.0220, 'lps'),
	(580331, 128, '2014-03-15 00:34:17.000000', 'consum', 0.0215, 'lps'),
	(580332, 128, '2014-03-15 00:34:18.000000', 'consum', 0.0216, 'lps'),
	(580333, 128, '2014-03-15 00:34:19.000000', 'consum', 0.0216, 'lps'),
	(580334, 128, '2014-03-15 00:34:20.000000', 'consum', 0.0211, 'lps'),
	(580335, 128, '2014-03-15 00:34:21.000000', 'consum', 0.0217, 'lps'),
	(580336, 128, '2014-03-15 00:34:22.000000', 'consum', 0.0213, 'lps'),
	(580337, 128, '2014-03-15 00:34:23.000000', 'consum', 0.0215, 'lps'),
	(580338, 128, '2014-03-15 00:34:24.000000', 'consum', 0.0215, 'lps'),
	(580339, 128, '2014-03-15 00:34:25.000000', 'consum', 0.0220, 'lps'),
	(580340, 128, '2014-03-15 00:34:26.000000', 'consum', 0.0214, 'lps'),
	(580341, 128, '2014-03-15 00:34:27.000000', 'consum', 0.0213, 'lps'),
	(580342, 128, '2014-03-15 00:34:28.000000', 'consum', 0.0210, 'lps'),
	(580343, 128, '2014-03-15 00:34:29.000000', 'consum', 0.0213, 'lps'),
	(580344, 128, '2014-03-15 00:34:30.000000', 'consum', 0.0217, 'lps'),
	(580345, 128, '2014-03-15 00:34:31.000000', 'consum', 0.0214, 'lps'),
	(580346, 128, '2014-03-15 00:34:32.000000', 'consum', 0.0220, 'lps'),
	(580347, 128, '2014-03-15 00:34:33.000000', 'consum', 0.0215, 'lps'),
	(580348, 128, '2014-03-15 00:34:34.000000', 'consum', 0.0215, 'lps'),
	(580349, 128, '2014-03-15 00:34:35.000000', 'consum', 0.0210, 'lps'),
	(580350, 128, '2014-03-15 00:34:36.000000', 'consum', 0.0220, 'lps'),
	(580351, 128, '2014-03-15 00:34:37.000000', 'consum', 0.0215, 'lps'),
	(580352, 128, '2014-03-15 00:34:38.000000', 'consum', 0.0215, 'lps'),
	(580353, 128, '2014-03-15 00:34:39.000000', 'consum', 0.0211, 'lps'),
	(580354, 128, '2014-03-15 00:34:40.000000', 'consum', 0.0211, 'lps'),
	(580355, 128, '2014-03-15 00:34:41.000000', 'consum', 0.0213, 'lps'),
	(580356, 128, '2014-03-15 00:34:42.000000', 'consum', 0.0211, 'lps'),
	(580357, 128, '2014-03-15 00:34:43.000000', 'consum', 0.0218, 'lps'),
	(580358, 128, '2014-03-15 00:34:44.000000', 'consum', 0.0215, 'lps'),
	(580359, 128, '2014-03-15 00:34:45.000000', 'consum', 0.0213, 'lps'),
	(580360, 128, '2014-03-15 00:34:46.000000', 'consum', 0.0219, 'lps'),
	(580361, 128, '2014-03-15 00:34:47.000000', 'consum', 0.0216, 'lps'),
	(580362, 128, '2014-03-15 00:34:48.000000', 'consum', 0.0211, 'lps'),
	(580363, 128, '2014-03-15 00:34:49.000000', 'consum', 0.0211, 'lps'),
	(580364, 128, '2014-03-15 00:34:50.000000', 'consum', 0.0210, 'lps'),
	(580365, 128, '2014-03-15 00:34:51.000000', 'consum', 0.0220, 'lps'),
	(580366, 128, '2014-03-15 00:34:52.000000', 'consum', 0.0217, 'lps'),
	(580367, 128, '2014-03-15 00:34:53.000000', 'consum', 0.0214, 'lps'),
	(580368, 128, '2014-03-15 00:34:54.000000', 'consum', 0.0220, 'lps'),
	(580369, 128, '2014-03-15 00:34:55.000000', 'consum', 0.0217, 'lps'),
	(580370, 128, '2014-03-15 00:34:56.000000', 'consum', 0.0214, 'lps'),
	(580371, 128, '2014-03-15 00:34:57.000000', 'consum', 0.0210, 'lps'),
	(580372, 128, '2014-03-15 00:34:58.000000', 'consum', 0.0210, 'lps'),
	(580373, 128, '2014-03-15 00:34:59.000000', 'consum', 0.0210, 'lps'),
	(580374, 128, '2014-03-15 00:35:00.000000', 'consum', 0.0213, 'lps'),
	(580375, 128, '2014-03-15 00:35:01.000000', 'consum', 0.0211, 'lps'),
	(580376, 128, '2014-03-15 00:35:02.000000', 'consum', 0.0220, 'lps'),
	(580377, 128, '2014-03-15 00:35:03.000000', 'consum', 0.0213, 'lps'),
	(580378, 128, '2014-03-15 00:35:04.000000', 'consum', 0.0216, 'lps'),
	(580379, 128, '2014-03-15 00:35:05.000000', 'consum', 0.0220, 'lps'),
	(580380, 128, '2014-03-15 00:35:06.000000', 'consum', 0.0210, 'lps'),
	(580381, 128, '2014-03-15 00:35:07.000000', 'consum', 0.0214, 'lps'),
	(580382, 128, '2014-03-15 00:35:08.000000', 'consum', 0.0210, 'lps'),
	(580383, 128, '2014-03-15 00:35:09.000000', 'consum', 0.0218, 'lps'),
	(580384, 128, '2014-03-15 00:35:10.000000', 'consum', 0.0219, 'lps'),
	(580385, 128, '2014-03-15 00:35:11.000000', 'consum', 0.0210, 'lps'),
	(580386, 128, '2014-03-15 00:35:12.000000', 'consum', 0.0217, 'lps'),
	(580387, 128, '2014-03-15 00:35:13.000000', 'consum', 0.0211, 'lps'),
	(580388, 128, '2014-03-15 00:35:14.000000', 'consum', 0.0216, 'lps'),
	(580389, 128, '2014-03-15 00:35:15.000000', 'consum', 0.0215, 'lps'),
	(580390, 128, '2014-03-15 00:35:16.000000', 'consum', 0.0217, 'lps'),
	(580391, 128, '2014-03-15 00:35:17.000000', 'consum', 0.0220, 'lps'),
	(580392, 128, '2014-03-15 00:35:18.000000', 'consum', 0.0217, 'lps'),
	(580393, 128, '2014-03-15 00:35:19.000000', 'consum', 0.0215, 'lps'),
	(580394, 128, '2014-03-15 00:35:20.000000', 'consum', 0.0215, 'lps'),
	(580395, 128, '2014-03-15 00:35:21.000000', 'consum', 0.0220, 'lps'),
	(580396, 128, '2014-03-15 00:35:22.000000', 'consum', 0.0212, 'lps'),
	(580397, 128, '2014-03-15 00:35:23.000000', 'consum', 0.0215, 'lps'),
	(580398, 128, '2014-03-15 00:35:24.000000', 'consum', 0.0216, 'lps'),
	(580399, 128, '2014-03-15 00:35:25.000000', 'consum', 0.0217, 'lps'),
	(580400, 128, '2014-03-15 00:35:26.000000', 'consum', 0.0217, 'lps'),
	(580401, 128, '2014-03-15 00:35:27.000000', 'consum', 0.0213, 'lps'),
	(580402, 128, '2014-03-15 00:35:28.000000', 'consum', 0.0214, 'lps'),
	(580403, 128, '2014-03-15 00:35:29.000000', 'consum', 0.0212, 'lps'),
	(580404, 128, '2014-03-15 00:35:30.000000', 'consum', 0.0219, 'lps'),
	(580405, 128, '2014-03-15 00:35:31.000000', 'consum', 0.0215, 'lps'),
	(580406, 128, '2014-03-15 00:35:32.000000', 'consum', 0.0210, 'lps'),
	(580407, 128, '2014-03-15 00:35:33.000000', 'consum', 0.0217, 'lps'),
	(580408, 128, '2014-03-15 00:35:34.000000', 'consum', 0.0215, 'lps'),
	(580409, 128, '2014-03-15 00:35:35.000000', 'consum', 0.0211, 'lps'),
	(580410, 128, '2014-03-15 00:35:36.000000', 'consum', 0.0213, 'lps'),
	(580411, 128, '2014-03-15 00:35:37.000000', 'consum', 0.0212, 'lps'),
	(580412, 128, '2014-03-15 00:35:38.000000', 'consum', 0.0213, 'lps'),
	(580413, 128, '2014-03-15 00:35:39.000000', 'consum', 0.0218, 'lps'),
	(580414, 128, '2014-03-15 00:35:40.000000', 'consum', 0.0218, 'lps'),
	(580415, 128, '2014-03-15 00:35:41.000000', 'consum', 0.0218, 'lps'),
	(580416, 128, '2014-03-15 00:35:42.000000', 'consum', 0.0214, 'lps'),
	(580417, 128, '2014-03-15 00:35:43.000000', 'consum', 0.0216, 'lps'),
	(580418, 128, '2014-03-15 00:35:44.000000', 'consum', 0.0220, 'lps'),
	(580419, 128, '2014-03-15 00:35:45.000000', 'consum', 0.0211, 'lps'),
	(580420, 128, '2014-03-15 00:35:46.000000', 'consum', 0.0216, 'lps'),
	(580421, 128, '2014-03-15 00:35:47.000000', 'consum', 0.0216, 'lps'),
	(580422, 128, '2014-03-15 00:35:48.000000', 'consum', 0.0212, 'lps'),
	(580423, 128, '2014-03-15 00:35:49.000000', 'consum', 0.0212, 'lps'),
	(580424, 128, '2014-03-15 00:35:50.000000', 'consum', 0.0213, 'lps'),
	(580425, 128, '2014-03-15 00:35:51.000000', 'consum', 0.0211, 'lps'),
	(580426, 128, '2014-03-15 00:35:52.000000', 'consum', 0.0217, 'lps'),
	(580427, 128, '2014-03-15 00:35:53.000000', 'consum', 0.0219, 'lps'),
	(580428, 128, '2014-03-15 00:35:54.000000', 'consum', 0.0215, 'lps'),
	(580429, 128, '2014-03-15 00:35:55.000000', 'consum', 0.0217, 'lps'),
	(580430, 128, '2014-03-15 00:35:56.000000', 'consum', 0.0220, 'lps'),
	(580431, 128, '2014-03-15 00:35:57.000000', 'consum', 0.0219, 'lps'),
	(580432, 128, '2014-03-15 00:35:58.000000', 'consum', 0.0214, 'lps'),
	(580433, 128, '2014-03-15 00:35:59.000000', 'consum', 0.0216, 'lps'),
	(580434, 128, '2014-03-15 00:36:00.000000', 'consum', 0.0217, 'lps'),
	(580435, 128, '2014-03-15 00:36:01.000000', 'consum', 0.0217, 'lps'),
	(580436, 128, '2014-03-15 00:36:02.000000', 'consum', 0.0215, 'lps'),
	(580437, 128, '2014-03-15 00:36:03.000000', 'consum', 0.0212, 'lps'),
	(580438, 128, '2014-03-15 00:36:04.000000', 'consum', 0.0215, 'lps'),
	(580439, 128, '2014-03-15 00:36:05.000000', 'consum', 0.0210, 'lps'),
	(580440, 128, '2014-03-15 00:36:06.000000', 'consum', 0.0218, 'lps'),
	(580441, 128, '2014-03-15 00:36:07.000000', 'consum', 0.0218, 'lps'),
	(580442, 128, '2014-03-15 00:36:08.000000', 'consum', 0.0213, 'lps'),
	(580443, 128, '2014-03-15 00:36:09.000000', 'consum', 0.0214, 'lps'),
	(580444, 128, '2014-03-15 00:36:10.000000', 'consum', 0.0210, 'lps'),
	(580445, 128, '2014-03-15 00:36:11.000000', 'consum', 0.0211, 'lps'),
	(580446, 128, '2014-03-15 00:36:12.000000', 'consum', 0.0216, 'lps'),
	(580447, 128, '2014-03-15 00:36:13.000000', 'consum', 0.0215, 'lps'),
	(580448, 128, '2014-03-15 00:36:14.000000', 'consum', 0.0217, 'lps'),
	(580449, 128, '2014-03-15 00:36:15.000000', 'consum', 0.0210, 'lps'),
	(580450, 128, '2014-03-15 00:36:16.000000', 'consum', 0.0212, 'lps'),
	(580451, 128, '2014-03-15 00:36:17.000000', 'consum', 0.0210, 'lps'),
	(580452, 128, '2014-03-15 00:36:18.000000', 'consum', 0.0216, 'lps'),
	(580453, 128, '2014-03-15 00:36:19.000000', 'consum', 0.0220, 'lps'),
	(580454, 128, '2014-03-15 00:36:20.000000', 'consum', 0.0217, 'lps'),
	(580455, 128, '2014-03-15 00:36:21.000000', 'consum', 0.0215, 'lps'),
	(580456, 128, '2014-03-15 00:36:22.000000', 'consum', 0.0218, 'lps'),
	(580457, 128, '2014-03-15 00:36:23.000000', 'consum', 0.0210, 'lps'),
	(580458, 128, '2014-03-15 00:36:24.000000', 'consum', 0.0210, 'lps'),
	(580459, 128, '2014-03-15 00:36:25.000000', 'consum', 0.0211, 'lps'),
	(580460, 128, '2014-03-15 00:36:26.000000', 'consum', 0.0213, 'lps'),
	(580461, 128, '2014-03-15 00:36:27.000000', 'consum', 0.0215, 'lps'),
	(580462, 128, '2014-03-15 00:36:28.000000', 'consum', 0.0214, 'lps'),
	(580463, 128, '2014-03-15 00:36:29.000000', 'consum', 0.0217, 'lps'),
	(580464, 128, '2014-03-15 00:36:30.000000', 'consum', 0.0210, 'lps'),
	(580465, 128, '2014-03-15 00:36:31.000000', 'consum', 0.0212, 'lps'),
	(580466, 128, '2014-03-15 00:36:32.000000', 'consum', 0.0210, 'lps'),
	(580467, 128, '2014-03-15 00:36:33.000000', 'consum', 0.0213, 'lps'),
	(580468, 128, '2014-03-15 00:36:34.000000', 'consum', 0.0217, 'lps'),
	(580469, 128, '2014-03-15 00:36:35.000000', 'consum', 0.0213, 'lps'),
	(580470, 128, '2014-03-15 00:36:36.000000', 'consum', 0.0216, 'lps'),
	(580471, 128, '2014-03-15 00:36:37.000000', 'consum', 0.0212, 'lps'),
	(580472, 128, '2014-03-15 00:36:38.000000', 'consum', 0.0210, 'lps'),
	(580473, 128, '2014-03-15 00:36:39.000000', 'consum', 0.0216, 'lps'),
	(580474, 128, '2014-03-15 00:36:40.000000', 'consum', 0.0220, 'lps'),
	(580475, 128, '2014-03-15 00:36:41.000000', 'consum', 0.0218, 'lps'),
	(580476, 128, '2014-03-15 00:36:42.000000', 'consum', 0.0212, 'lps'),
	(580477, 128, '2014-03-15 00:36:43.000000', 'consum', 0.0219, 'lps'),
	(580478, 128, '2014-03-15 00:36:44.000000', 'consum', 0.0215, 'lps'),
	(580479, 128, '2014-03-15 00:36:45.000000', 'consum', 0.0219, 'lps'),
	(580480, 128, '2014-03-15 00:36:46.000000', 'consum', 0.0218, 'lps'),
	(580481, 128, '2014-03-15 00:36:47.000000', 'consum', 0.0212, 'lps'),
	(580482, 128, '2014-03-15 00:36:48.000000', 'consum', 0.0220, 'lps'),
	(580483, 128, '2014-03-15 00:36:49.000000', 'consum', 0.0220, 'lps'),
	(580484, 128, '2014-03-15 00:36:50.000000', 'consum', 0.0211, 'lps'),
	(580485, 128, '2014-03-15 00:36:51.000000', 'consum', 0.0218, 'lps'),
	(580486, 128, '2014-03-15 00:36:52.000000', 'consum', 0.0212, 'lps'),
	(580487, 128, '2014-03-15 00:36:53.000000', 'consum', 0.0220, 'lps'),
	(580488, 128, '2014-03-15 00:36:54.000000', 'consum', 0.0212, 'lps'),
	(580489, 128, '2014-03-15 00:36:55.000000', 'consum', 0.0211, 'lps'),
	(580490, 128, '2014-03-15 00:36:56.000000', 'consum', 0.0210, 'lps'),
	(580491, 128, '2014-03-15 00:36:57.000000', 'consum', 0.0217, 'lps'),
	(580492, 128, '2014-03-15 00:36:58.000000', 'consum', 0.0213, 'lps'),
	(580493, 128, '2014-03-15 00:36:59.000000', 'consum', 0.0216, 'lps'),
	(580494, 128, '2014-03-15 00:37:00.000000', 'consum', 0.0210, 'lps'),
	(580495, 128, '2014-03-15 00:37:01.000000', 'consum', 0.0213, 'lps'),
	(580496, 128, '2014-03-15 00:37:02.000000', 'consum', 0.0215, 'lps'),
	(580497, 128, '2014-03-15 00:37:03.000000', 'consum', 0.0218, 'lps'),
	(580498, 128, '2014-03-15 00:37:04.000000', 'consum', 0.0210, 'lps'),
	(580499, 128, '2014-03-15 00:37:05.000000', 'consum', 0.0210, 'lps'),
	(580500, 128, '2014-03-15 00:37:06.000000', 'consum', 0.0211, 'lps'),
	(580501, 128, '2014-03-15 00:37:07.000000', 'consum', 0.0216, 'lps'),
	(580502, 128, '2014-03-15 00:37:08.000000', 'consum', 0.0215, 'lps'),
	(580503, 128, '2014-03-15 00:37:09.000000', 'consum', 0.0217, 'lps'),
	(580504, 128, '2014-03-15 00:37:10.000000', 'consum', 0.0210, 'lps'),
	(580505, 128, '2014-03-15 00:37:11.000000', 'consum', 0.0212, 'lps'),
	(580506, 128, '2014-03-15 00:37:12.000000', 'consum', 0.0211, 'lps'),
	(580507, 128, '2014-03-15 00:37:13.000000', 'consum', 0.0217, 'lps'),
	(580508, 128, '2014-03-15 00:37:14.000000', 'consum', 0.0220, 'lps'),
	(580509, 128, '2014-03-15 00:37:15.000000', 'consum', 0.0220, 'lps'),
	(580510, 128, '2014-03-15 00:37:16.000000', 'consum', 0.0219, 'lps'),
	(580511, 128, '2014-03-15 00:37:17.000000', 'consum', 0.0215, 'lps'),
	(580512, 128, '2014-03-15 00:37:18.000000', 'consum', 0.0220, 'lps'),
	(580513, 128, '2014-03-15 00:37:19.000000', 'consum', 0.0212, 'lps'),
	(580514, 128, '2014-03-15 00:37:20.000000', 'consum', 0.0212, 'lps'),
	(580515, 128, '2014-03-15 00:37:21.000000', 'consum', 0.0216, 'lps'),
	(580516, 128, '2014-03-15 00:37:22.000000', 'consum', 0.0213, 'lps'),
	(580517, 128, '2014-03-15 00:37:23.000000', 'consum', 0.0218, 'lps'),
	(580518, 128, '2014-03-15 00:37:24.000000', 'consum', 0.0218, 'lps'),
	(580519, 128, '2014-03-15 00:37:25.000000', 'consum', 0.0216, 'lps'),
	(580520, 128, '2014-03-15 00:37:26.000000', 'consum', 0.0215, 'lps'),
	(580521, 128, '2014-03-15 00:37:27.000000', 'consum', 0.0219, 'lps'),
	(580522, 128, '2014-03-15 00:37:28.000000', 'consum', 0.0218, 'lps'),
	(580523, 128, '2014-03-15 00:37:29.000000', 'consum', 0.0211, 'lps'),
	(580524, 128, '2014-03-15 00:37:30.000000', 'consum', 0.0216, 'lps'),
	(580525, 128, '2014-03-15 00:37:31.000000', 'consum', 0.0215, 'lps'),
	(580526, 128, '2014-03-15 00:37:32.000000', 'consum', 0.0216, 'lps'),
	(580527, 128, '2014-03-15 00:37:33.000000', 'consum', 0.0213, 'lps'),
	(580528, 128, '2014-03-15 00:37:34.000000', 'consum', 0.0210, 'lps'),
	(580529, 128, '2014-03-15 00:37:35.000000', 'consum', 0.0212, 'lps'),
	(580530, 128, '2014-03-15 00:37:36.000000', 'consum', 0.0210, 'lps'),
	(580531, 128, '2014-03-15 00:37:37.000000', 'consum', 0.0216, 'lps'),
	(580532, 128, '2014-03-15 00:37:38.000000', 'consum', 0.0216, 'lps'),
	(580533, 128, '2014-03-15 00:37:39.000000', 'consum', 0.0214, 'lps'),
	(580534, 128, '2014-03-15 00:37:40.000000', 'consum', 0.0212, 'lps'),
	(580535, 128, '2014-03-15 00:37:41.000000', 'consum', 0.0210, 'lps'),
	(580536, 128, '2014-03-15 00:37:42.000000', 'consum', 0.0213, 'lps'),
	(580537, 128, '2014-03-15 00:37:43.000000', 'consum', 0.0216, 'lps'),
	(580538, 128, '2014-03-15 00:37:44.000000', 'consum', 0.0220, 'lps'),
	(580539, 128, '2014-03-15 00:37:45.000000', 'consum', 0.0211, 'lps'),
	(580540, 128, '2014-03-15 00:37:46.000000', 'consum', 0.0218, 'lps'),
	(580541, 128, '2014-03-15 00:37:47.000000', 'consum', 0.0213, 'lps'),
	(580542, 128, '2014-03-15 00:37:48.000000', 'consum', 0.0211, 'lps'),
	(580543, 128, '2014-03-15 00:37:49.000000', 'consum', 0.0220, 'lps'),
	(580544, 128, '2014-03-15 00:37:50.000000', 'consum', 0.0212, 'lps'),
	(580545, 128, '2014-03-15 00:37:51.000000', 'consum', 0.0215, 'lps'),
	(580546, 128, '2014-03-15 00:37:52.000000', 'consum', 0.0216, 'lps'),
	(580547, 128, '2014-03-15 00:37:53.000000', 'consum', 0.0216, 'lps'),
	(580548, 128, '2014-03-15 00:37:54.000000', 'consum', 0.0220, 'lps'),
	(580549, 128, '2014-03-15 00:37:55.000000', 'consum', 0.0213, 'lps'),
	(580550, 128, '2014-03-15 00:37:56.000000', 'consum', 0.0215, 'lps'),
	(580551, 128, '2014-03-15 00:37:57.000000', 'consum', 0.0218, 'lps'),
	(580552, 128, '2014-03-15 00:37:58.000000', 'consum', 0.0211, 'lps'),
	(580553, 128, '2014-03-15 00:37:59.000000', 'consum', 0.0214, 'lps'),
	(580554, 128, '2014-03-15 00:38:00.000000', 'consum', 0.0217, 'lps'),
	(580555, 128, '2014-03-15 00:38:01.000000', 'consum', 0.0213, 'lps'),
	(580556, 128, '2014-03-15 00:38:02.000000', 'consum', 0.0213, 'lps'),
	(580557, 128, '2014-03-15 00:38:03.000000', 'consum', 0.0216, 'lps'),
	(580558, 128, '2014-03-15 00:38:04.000000', 'consum', 0.0213, 'lps'),
	(580559, 128, '2014-03-15 00:38:05.000000', 'consum', 0.0215, 'lps'),
	(580560, 128, '2014-03-15 00:38:06.000000', 'consum', 0.0216, 'lps'),
	(580561, 128, '2014-03-15 00:38:07.000000', 'consum', 0.0213, 'lps'),
	(580562, 128, '2014-03-15 00:38:08.000000', 'consum', 0.0211, 'lps'),
	(580563, 128, '2014-03-15 00:38:09.000000', 'consum', 0.0216, 'lps'),
	(580564, 128, '2014-03-15 00:38:10.000000', 'consum', 0.0216, 'lps'),
	(580565, 128, '2014-03-15 00:38:11.000000', 'consum', 0.0211, 'lps'),
	(580566, 128, '2014-03-15 00:38:12.000000', 'consum', 0.0210, 'lps'),
	(580567, 128, '2014-03-15 00:38:13.000000', 'consum', 0.0219, 'lps'),
	(580568, 128, '2014-03-15 00:38:14.000000', 'consum', 0.0220, 'lps'),
	(580569, 128, '2014-03-15 00:38:15.000000', 'consum', 0.0213, 'lps'),
	(580570, 128, '2014-03-15 00:38:16.000000', 'consum', 0.0219, 'lps'),
	(580571, 128, '2014-03-15 00:38:17.000000', 'consum', 0.0212, 'lps'),
	(580572, 128, '2014-03-15 00:38:18.000000', 'consum', 0.0217, 'lps'),
	(580573, 128, '2014-03-15 00:38:19.000000', 'consum', 0.0215, 'lps'),
	(580574, 128, '2014-03-15 00:38:20.000000', 'consum', 0.0214, 'lps'),
	(580575, 128, '2014-03-15 00:38:21.000000', 'consum', 0.0219, 'lps'),
	(580576, 128, '2014-03-15 00:38:22.000000', 'consum', 0.0218, 'lps'),
	(580577, 128, '2014-03-15 00:38:23.000000', 'consum', 0.0213, 'lps'),
	(580578, 128, '2014-03-15 00:38:24.000000', 'consum', 0.0213, 'lps'),
	(580579, 128, '2014-03-15 00:38:25.000000', 'consum', 0.0218, 'lps'),
	(580580, 128, '2014-03-15 00:38:26.000000', 'consum', 0.0219, 'lps'),
	(580581, 128, '2014-03-15 00:38:27.000000', 'consum', 0.0210, 'lps'),
	(580582, 128, '2014-03-15 00:38:28.000000', 'consum', 0.0216, 'lps'),
	(580583, 128, '2014-03-15 00:38:29.000000', 'consum', 0.0218, 'lps'),
	(580584, 128, '2014-03-15 00:38:30.000000', 'consum', 0.0211, 'lps'),
	(580585, 128, '2014-03-15 00:38:31.000000', 'consum', 0.0212, 'lps'),
	(580586, 128, '2014-03-15 00:38:32.000000', 'consum', 0.0217, 'lps'),
	(580587, 128, '2014-03-15 00:38:33.000000', 'consum', 0.0218, 'lps'),
	(580588, 128, '2014-03-15 00:38:34.000000', 'consum', 0.0218, 'lps'),
	(580589, 128, '2014-03-15 00:38:35.000000', 'consum', 0.0218, 'lps'),
	(580590, 128, '2014-03-15 00:38:36.000000', 'consum', 0.0215, 'lps'),
	(580591, 128, '2014-03-15 00:38:37.000000', 'consum', 0.0212, 'lps'),
	(580592, 128, '2014-03-15 00:38:38.000000', 'consum', 0.0215, 'lps'),
	(580593, 128, '2014-03-15 00:38:39.000000', 'consum', 0.0217, 'lps'),
	(580594, 128, '2014-03-15 00:38:40.000000', 'consum', 0.0211, 'lps'),
	(580595, 128, '2014-03-15 00:38:41.000000', 'consum', 0.0216, 'lps'),
	(580596, 128, '2014-03-15 00:38:42.000000', 'consum', 0.0214, 'lps'),
	(580597, 128, '2014-03-15 00:38:43.000000', 'consum', 0.0214, 'lps'),
	(580598, 128, '2014-03-15 00:38:44.000000', 'consum', 0.0218, 'lps'),
	(580599, 128, '2014-03-15 00:38:45.000000', 'consum', 0.0218, 'lps'),
	(580600, 128, '2014-03-15 00:38:46.000000', 'consum', 0.0216, 'lps'),
	(580601, 128, '2014-03-15 00:38:47.000000', 'consum', 0.0215, 'lps'),
	(580602, 128, '2014-03-15 00:38:48.000000', 'consum', 0.0218, 'lps'),
	(580603, 128, '2014-03-15 00:38:49.000000', 'consum', 0.0212, 'lps'),
	(580604, 128, '2014-03-15 00:38:50.000000', 'consum', 0.0217, 'lps'),
	(580605, 128, '2014-03-15 00:38:51.000000', 'consum', 0.0210, 'lps'),
	(580606, 128, '2014-03-15 00:38:52.000000', 'consum', 0.0212, 'lps'),
	(580607, 128, '2014-03-15 00:38:53.000000', 'consum', 0.0218, 'lps'),
	(580608, 128, '2014-03-15 00:38:54.000000', 'consum', 0.0214, 'lps'),
	(580609, 128, '2014-03-15 00:38:55.000000', 'consum', 0.0216, 'lps'),
	(580610, 128, '2014-03-15 00:38:56.000000', 'consum', 0.0218, 'lps'),
	(580611, 128, '2014-03-15 00:38:57.000000', 'consum', 0.0211, 'lps'),
	(580612, 128, '2014-03-15 00:38:58.000000', 'consum', 0.0215, 'lps'),
	(580613, 128, '2014-03-15 00:38:59.000000', 'consum', 0.0220, 'lps'),
	(580614, 128, '2014-03-15 00:39:00.000000', 'consum', 0.0214, 'lps'),
	(580615, 128, '2014-03-15 00:39:01.000000', 'consum', 0.0219, 'lps'),
	(580616, 128, '2014-03-15 00:39:02.000000', 'consum', 0.0214, 'lps'),
	(580617, 128, '2014-03-15 00:39:03.000000', 'consum', 0.0214, 'lps'),
	(580618, 128, '2014-03-15 00:39:04.000000', 'consum', 0.0220, 'lps'),
	(580619, 128, '2014-03-15 00:39:05.000000', 'consum', 0.0213, 'lps'),
	(580620, 128, '2014-03-15 00:39:06.000000', 'consum', 0.0217, 'lps'),
	(580621, 128, '2014-03-15 00:39:07.000000', 'consum', 0.0217, 'lps'),
	(580622, 128, '2014-03-15 00:39:08.000000', 'consum', 0.0210, 'lps'),
	(580623, 128, '2014-03-15 00:39:09.000000', 'consum', 0.0215, 'lps'),
	(580624, 128, '2014-03-15 00:39:10.000000', 'consum', 0.0212, 'lps'),
	(580625, 128, '2014-03-15 00:39:11.000000', 'consum', 0.0217, 'lps'),
	(580626, 128, '2014-03-15 00:39:12.000000', 'consum', 0.0218, 'lps'),
	(580627, 128, '2014-03-15 00:39:13.000000', 'consum', 0.0218, 'lps'),
	(580628, 128, '2014-03-15 00:39:14.000000', 'consum', 0.0216, 'lps'),
	(580629, 128, '2014-03-15 00:39:15.000000', 'consum', 0.0217, 'lps'),
	(580630, 128, '2014-03-15 00:39:16.000000', 'consum', 0.0217, 'lps'),
	(580631, 128, '2014-03-15 00:39:17.000000', 'consum', 0.0215, 'lps'),
	(580632, 128, '2014-03-15 00:39:18.000000', 'consum', 0.0212, 'lps'),
	(580633, 128, '2014-03-15 00:39:19.000000', 'consum', 0.0218, 'lps'),
	(580634, 128, '2014-03-15 00:39:20.000000', 'consum', 0.0212, 'lps'),
	(580635, 128, '2014-03-15 00:39:21.000000', 'consum', 0.0219, 'lps'),
	(580636, 128, '2014-03-15 00:39:22.000000', 'consum', 0.0218, 'lps'),
	(580637, 128, '2014-03-15 00:39:23.000000', 'consum', 0.0220, 'lps'),
	(580638, 128, '2014-03-15 00:39:24.000000', 'consum', 0.0216, 'lps'),
	(580639, 128, '2014-03-15 00:39:25.000000', 'consum', 0.0220, 'lps'),
	(580640, 128, '2014-03-15 00:39:26.000000', 'consum', 0.0210, 'lps'),
	(580641, 128, '2014-03-15 00:39:27.000000', 'consum', 0.0215, 'lps'),
	(580642, 128, '2014-03-15 00:39:28.000000', 'consum', 0.0215, 'lps'),
	(580643, 128, '2014-03-15 00:39:29.000000', 'consum', 0.0217, 'lps'),
	(580644, 128, '2014-03-15 00:39:30.000000', 'consum', 0.0211, 'lps'),
	(580645, 128, '2014-03-15 00:39:31.000000', 'consum', 0.0216, 'lps'),
	(580646, 128, '2014-03-15 00:39:32.000000', 'consum', 0.0217, 'lps'),
	(580647, 128, '2014-03-15 00:39:33.000000', 'consum', 0.0217, 'lps'),
	(580648, 128, '2014-03-15 00:39:34.000000', 'consum', 0.0210, 'lps'),
	(580649, 128, '2014-03-15 00:39:35.000000', 'consum', 0.0215, 'lps'),
	(580650, 128, '2014-03-15 00:39:36.000000', 'consum', 0.0213, 'lps'),
	(580651, 128, '2014-03-15 00:39:37.000000', 'consum', 0.0211, 'lps'),
	(580652, 128, '2014-03-15 00:39:38.000000', 'consum', 0.0216, 'lps'),
	(580653, 128, '2014-03-15 00:39:39.000000', 'consum', 0.0217, 'lps'),
	(580654, 128, '2014-03-15 00:39:40.000000', 'consum', 0.0217, 'lps'),
	(580655, 128, '2014-03-15 00:39:41.000000', 'consum', 0.0211, 'lps'),
	(580656, 128, '2014-03-15 00:39:42.000000', 'consum', 0.0216, 'lps'),
	(580657, 128, '2014-03-15 00:39:43.000000', 'consum', 0.0219, 'lps'),
	(580658, 128, '2014-03-15 00:39:44.000000', 'consum', 0.0212, 'lps'),
	(580659, 128, '2014-03-15 00:39:45.000000', 'consum', 0.0217, 'lps'),
	(580660, 128, '2014-03-15 00:39:46.000000', 'consum', 0.0218, 'lps'),
	(580661, 128, '2014-03-15 00:39:47.000000', 'consum', 0.0216, 'lps'),
	(580662, 128, '2014-03-15 00:39:48.000000', 'consum', 0.0219, 'lps'),
	(580663, 128, '2014-03-15 00:39:49.000000', 'consum', 0.0217, 'lps'),
	(580664, 128, '2014-03-15 00:39:50.000000', 'consum', 0.0216, 'lps'),
	(580665, 128, '2014-03-15 00:39:51.000000', 'consum', 0.0210, 'lps'),
	(580666, 128, '2014-03-15 00:39:52.000000', 'consum', 0.0213, 'lps'),
	(580667, 128, '2014-03-15 00:39:53.000000', 'consum', 0.0215, 'lps'),
	(580668, 128, '2014-03-15 00:39:54.000000', 'consum', 0.0215, 'lps'),
	(580669, 128, '2014-03-15 00:39:55.000000', 'consum', 0.0220, 'lps'),
	(580670, 128, '2014-03-15 00:39:56.000000', 'consum', 0.0215, 'lps'),
	(580671, 128, '2014-03-15 00:39:57.000000', 'consum', 0.0213, 'lps'),
	(580672, 128, '2014-03-15 00:39:58.000000', 'consum', 0.0213, 'lps'),
	(580673, 128, '2014-03-15 00:39:59.000000', 'consum', 0.0214, 'lps'),
	(580674, 128, '2014-03-15 00:40:00.000000', 'consum', 0.0212, 'lps'),
	(580675, 128, '2014-03-15 00:40:01.000000', 'consum', 0.0218, 'lps'),
	(580676, 128, '2014-03-15 00:40:02.000000', 'consum', 0.0214, 'lps'),
	(580677, 128, '2014-03-15 00:40:03.000000', 'consum', 0.0215, 'lps'),
	(580678, 128, '2014-03-15 00:40:04.000000', 'consum', 0.0213, 'lps'),
	(580679, 128, '2014-03-15 00:40:05.000000', 'consum', 0.0220, 'lps'),
	(580680, 128, '2014-03-15 00:40:06.000000', 'consum', 0.0220, 'lps'),
	(580681, 128, '2014-03-15 00:40:07.000000', 'consum', 0.0220, 'lps'),
	(580682, 128, '2014-03-15 00:40:08.000000', 'consum', 0.0220, 'lps'),
	(580683, 128, '2014-03-15 00:40:09.000000', 'consum', 0.0219, 'lps'),
	(580684, 128, '2014-03-15 00:40:10.000000', 'consum', 0.0214, 'lps'),
	(580685, 128, '2014-03-15 00:40:11.000000', 'consum', 0.0216, 'lps'),
	(580686, 128, '2014-03-15 00:40:12.000000', 'consum', 0.0215, 'lps'),
	(580687, 128, '2014-03-15 00:40:13.000000', 'consum', 0.0219, 'lps'),
	(580688, 128, '2014-03-15 00:40:14.000000', 'consum', 0.0218, 'lps'),
	(580689, 128, '2014-03-15 00:40:15.000000', 'consum', 0.0213, 'lps'),
	(580690, 128, '2014-03-15 00:40:16.000000', 'consum', 0.0213, 'lps'),
	(580691, 128, '2014-03-15 00:40:17.000000', 'consum', 0.0217, 'lps'),
	(580692, 128, '2014-03-15 00:40:18.000000', 'consum', 0.0213, 'lps'),
	(580693, 128, '2014-03-15 00:40:19.000000', 'consum', 0.0217, 'lps'),
	(580694, 128, '2014-03-15 00:40:20.000000', 'consum', 0.0214, 'lps'),
	(580695, 128, '2014-03-15 00:40:21.000000', 'consum', 0.0210, 'lps'),
	(580696, 128, '2014-03-15 00:40:22.000000', 'consum', 0.0211, 'lps'),
	(580697, 128, '2014-03-15 00:40:23.000000', 'consum', 0.0214, 'lps'),
	(580698, 128, '2014-03-15 00:40:24.000000', 'consum', 0.0215, 'lps'),
	(580699, 128, '2014-03-15 00:40:25.000000', 'consum', 0.0214, 'lps'),
	(580700, 128, '2014-03-15 00:40:26.000000', 'consum', 0.0214, 'lps'),
	(580701, 128, '2014-03-15 00:40:27.000000', 'consum', 0.0210, 'lps'),
	(580702, 128, '2014-03-15 00:40:28.000000', 'consum', 0.0218, 'lps'),
	(580703, 128, '2014-03-15 00:40:29.000000', 'consum', 0.0219, 'lps'),
	(580704, 128, '2014-03-15 00:40:30.000000', 'consum', 0.0219, 'lps'),
	(580705, 128, '2014-03-15 00:40:31.000000', 'consum', 0.0219, 'lps'),
	(580706, 128, '2014-03-15 00:40:32.000000', 'consum', 0.0218, 'lps'),
	(580707, 128, '2014-03-15 00:40:33.000000', 'consum', 0.0211, 'lps'),
	(580708, 128, '2014-03-15 00:40:34.000000', 'consum', 0.0215, 'lps'),
	(580709, 128, '2014-03-15 00:40:35.000000', 'consum', 0.0211, 'lps'),
	(580710, 128, '2014-03-15 00:40:36.000000', 'consum', 0.0212, 'lps'),
	(580711, 128, '2014-03-15 00:40:37.000000', 'consum', 0.0216, 'lps'),
	(580712, 128, '2014-03-15 00:40:38.000000', 'consum', 0.0214, 'lps'),
	(580713, 128, '2014-03-15 00:40:39.000000', 'consum', 0.0212, 'lps'),
	(580714, 128, '2014-03-15 00:40:40.000000', 'consum', 0.0219, 'lps'),
	(580715, 128, '2014-03-15 00:40:41.000000', 'consum', 0.0217, 'lps'),
	(580716, 128, '2014-03-15 00:40:42.000000', 'consum', 0.0220, 'lps'),
	(580717, 128, '2014-03-15 00:40:43.000000', 'consum', 0.0218, 'lps'),
	(580718, 128, '2014-03-15 00:40:44.000000', 'consum', 0.0218, 'lps'),
	(580719, 128, '2014-03-15 00:40:45.000000', 'consum', 0.0215, 'lps'),
	(580720, 128, '2014-03-15 00:40:46.000000', 'consum', 0.0212, 'lps'),
	(580721, 128, '2014-03-15 00:40:47.000000', 'consum', 0.0216, 'lps'),
	(580722, 128, '2014-03-15 00:40:48.000000', 'consum', 0.0214, 'lps'),
	(580723, 128, '2014-03-15 00:40:49.000000', 'consum', 0.0213, 'lps'),
	(580724, 128, '2014-03-15 00:40:50.000000', 'consum', 0.0212, 'lps'),
	(580725, 128, '2014-03-15 00:40:51.000000', 'consum', 0.0211, 'lps'),
	(580726, 128, '2014-03-15 00:40:52.000000', 'consum', 0.0220, 'lps'),
	(580727, 128, '2014-03-15 00:40:53.000000', 'consum', 0.0213, 'lps'),
	(580728, 128, '2014-03-15 00:40:54.000000', 'consum', 0.0220, 'lps'),
	(580729, 128, '2014-03-15 00:40:55.000000', 'consum', 0.0219, 'lps'),
	(580730, 128, '2014-03-15 00:40:56.000000', 'consum', 0.0215, 'lps'),
	(580731, 128, '2014-03-15 00:40:57.000000', 'consum', 0.0220, 'lps'),
	(580732, 128, '2014-03-15 00:40:58.000000', 'consum', 0.0210, 'lps'),
	(580733, 128, '2014-03-15 00:40:59.000000', 'consum', 0.0214, 'lps'),
	(580734, 128, '2014-03-15 00:41:00.000000', 'consum', 0.0218, 'lps'),
	(580735, 128, '2014-03-15 00:41:01.000000', 'consum', 0.0220, 'lps'),
	(580736, 128, '2014-03-15 00:41:02.000000', 'consum', 0.0211, 'lps'),
	(580737, 128, '2014-03-15 00:41:03.000000', 'consum', 0.0211, 'lps'),
	(580738, 128, '2014-03-15 00:41:04.000000', 'consum', 0.0220, 'lps'),
	(580739, 128, '2014-03-15 00:41:05.000000', 'consum', 0.0215, 'lps'),
	(580740, 128, '2014-03-15 00:41:06.000000', 'consum', 0.0216, 'lps'),
	(580741, 128, '2014-03-15 00:41:07.000000', 'consum', 0.0213, 'lps'),
	(580742, 128, '2014-03-15 00:41:08.000000', 'consum', 0.0210, 'lps'),
	(580743, 128, '2014-03-15 00:41:09.000000', 'consum', 0.0213, 'lps'),
	(580744, 128, '2014-03-15 00:41:10.000000', 'consum', 0.0215, 'lps'),
	(580745, 128, '2014-03-15 00:41:11.000000', 'consum', 0.0213, 'lps'),
	(580746, 128, '2014-03-15 00:41:12.000000', 'consum', 0.0213, 'lps'),
	(580747, 128, '2014-03-15 00:41:13.000000', 'consum', 0.0213, 'lps'),
	(580748, 128, '2014-03-15 00:41:14.000000', 'consum', 0.0220, 'lps'),
	(580749, 128, '2014-03-15 00:41:15.000000', 'consum', 0.0218, 'lps'),
	(580750, 128, '2014-03-15 00:41:16.000000', 'consum', 0.0219, 'lps'),
	(580751, 128, '2014-03-15 00:41:17.000000', 'consum', 0.0212, 'lps'),
	(580752, 128, '2014-03-15 00:41:18.000000', 'consum', 0.0213, 'lps'),
	(580753, 128, '2014-03-15 00:41:19.000000', 'consum', 0.0218, 'lps'),
	(580754, 128, '2014-03-15 00:41:20.000000', 'consum', 0.0211, 'lps'),
	(580755, 128, '2014-03-15 00:41:21.000000', 'consum', 0.0215, 'lps'),
	(580756, 128, '2014-03-15 00:41:22.000000', 'consum', 0.0220, 'lps'),
	(580757, 128, '2014-03-15 00:41:23.000000', 'consum', 0.0212, 'lps'),
	(580758, 128, '2014-03-15 00:41:24.000000', 'consum', 0.0213, 'lps'),
	(580759, 128, '2014-03-15 00:41:25.000000', 'consum', 0.0210, 'lps'),
	(580760, 128, '2014-03-15 00:41:26.000000', 'consum', 0.0210, 'lps'),
	(580761, 128, '2014-03-15 00:41:27.000000', 'consum', 0.0211, 'lps'),
	(580762, 128, '2014-03-15 00:41:28.000000', 'consum', 0.0217, 'lps'),
	(580763, 128, '2014-03-15 00:41:29.000000', 'consum', 0.0218, 'lps'),
	(580764, 128, '2014-03-15 00:41:30.000000', 'consum', 0.0210, 'lps'),
	(580765, 128, '2014-03-15 00:41:31.000000', 'consum', 0.0218, 'lps'),
	(580766, 128, '2014-03-15 00:41:32.000000', 'consum', 0.0219, 'lps'),
	(580767, 128, '2014-03-15 00:41:33.000000', 'consum', 0.0220, 'lps'),
	(580768, 128, '2014-03-15 00:41:34.000000', 'consum', 0.0213, 'lps'),
	(580769, 128, '2014-03-15 00:41:35.000000', 'consum', 0.0215, 'lps'),
	(580770, 128, '2014-03-15 00:41:36.000000', 'consum', 0.0215, 'lps'),
	(580771, 128, '2014-03-15 00:41:37.000000', 'consum', 0.0213, 'lps'),
	(580772, 128, '2014-03-15 00:41:38.000000', 'consum', 0.0218, 'lps'),
	(580773, 128, '2014-03-15 00:41:39.000000', 'consum', 0.0210, 'lps'),
	(580774, 128, '2014-03-15 00:41:40.000000', 'consum', 0.0219, 'lps'),
	(580775, 128, '2014-03-15 00:41:41.000000', 'consum', 0.0210, 'lps'),
	(580776, 128, '2014-03-15 00:41:42.000000', 'consum', 0.0216, 'lps'),
	(580777, 128, '2014-03-15 00:41:43.000000', 'consum', 0.0220, 'lps'),
	(580778, 128, '2014-03-15 00:41:44.000000', 'consum', 0.0219, 'lps'),
	(580779, 128, '2014-03-15 00:41:45.000000', 'consum', 0.0215, 'lps'),
	(580780, 128, '2014-03-15 00:41:46.000000', 'consum', 0.0218, 'lps'),
	(580781, 128, '2014-03-15 00:41:47.000000', 'consum', 0.0215, 'lps'),
	(580782, 128, '2014-03-15 00:41:48.000000', 'consum', 0.0213, 'lps'),
	(580783, 128, '2014-03-15 00:41:49.000000', 'consum', 0.0220, 'lps'),
	(580784, 128, '2014-03-15 00:41:50.000000', 'consum', 0.0217, 'lps'),
	(580785, 128, '2014-03-15 00:41:51.000000', 'consum', 0.0215, 'lps'),
	(580786, 128, '2014-03-15 00:41:52.000000', 'consum', 0.0215, 'lps'),
	(580787, 128, '2014-03-15 00:41:53.000000', 'consum', 0.0211, 'lps'),
	(580788, 128, '2014-03-15 00:41:54.000000', 'consum', 0.0212, 'lps'),
	(580789, 128, '2014-03-15 00:41:55.000000', 'consum', 0.0216, 'lps'),
	(580790, 128, '2014-03-15 00:41:56.000000', 'consum', 0.0213, 'lps'),
	(580791, 128, '2014-03-15 00:41:57.000000', 'consum', 0.0219, 'lps'),
	(580792, 128, '2014-03-15 00:41:58.000000', 'consum', 0.0214, 'lps'),
	(580793, 128, '2014-03-15 00:41:59.000000', 'consum', 0.0214, 'lps'),
	(580794, 128, '2014-03-15 00:42:00.000000', 'consum', 0.0217, 'lps'),
	(580795, 128, '2014-03-15 00:42:01.000000', 'consum', 0.0214, 'lps'),
	(580796, 128, '2014-03-15 00:42:02.000000', 'consum', 0.0218, 'lps'),
	(580797, 128, '2014-03-15 00:42:03.000000', 'consum', 0.0218, 'lps'),
	(580798, 128, '2014-03-15 00:42:04.000000', 'consum', 0.0216, 'lps'),
	(580799, 128, '2014-03-15 00:42:05.000000', 'consum', 0.0217, 'lps'),
	(580800, 128, '2014-03-15 00:42:06.000000', 'consum', 0.0218, 'lps'),
	(580801, 128, '2014-03-15 00:42:07.000000', 'consum', 0.0215, 'lps'),
	(580802, 128, '2014-03-15 00:42:08.000000', 'consum', 0.0213, 'lps'),
	(580803, 128, '2014-03-15 00:42:09.000000', 'consum', 0.0211, 'lps'),
	(580804, 128, '2014-03-15 00:42:10.000000', 'consum', 0.0219, 'lps'),
	(580805, 128, '2014-03-15 00:42:11.000000', 'consum', 0.0219, 'lps'),
	(580806, 128, '2014-03-15 00:42:12.000000', 'consum', 0.0217, 'lps'),
	(580807, 128, '2014-03-15 00:42:13.000000', 'consum', 0.0220, 'lps'),
	(580808, 128, '2014-03-15 00:42:14.000000', 'consum', 0.0215, 'lps'),
	(580809, 128, '2014-03-15 00:42:15.000000', 'consum', 0.0218, 'lps'),
	(580810, 128, '2014-03-15 00:42:16.000000', 'consum', 0.0214, 'lps'),
	(580811, 128, '2014-03-15 00:42:17.000000', 'consum', 0.0218, 'lps'),
	(580812, 128, '2014-03-15 00:42:18.000000', 'consum', 0.0214, 'lps'),
	(580813, 128, '2014-03-15 00:42:19.000000', 'consum', 0.0217, 'lps'),
	(580814, 128, '2014-03-15 00:42:20.000000', 'consum', 0.0215, 'lps'),
	(580815, 128, '2014-03-15 00:42:21.000000', 'consum', 0.0211, 'lps'),
	(580816, 128, '2014-03-15 00:42:22.000000', 'consum', 0.0213, 'lps'),
	(580817, 128, '2014-03-15 00:42:23.000000', 'consum', 0.0211, 'lps'),
	(580818, 128, '2014-03-15 00:42:24.000000', 'consum', 0.0219, 'lps'),
	(580819, 128, '2014-03-15 00:42:25.000000', 'consum', 0.0217, 'lps'),
	(580820, 128, '2014-03-15 00:42:26.000000', 'consum', 0.0219, 'lps'),
	(580821, 128, '2014-03-15 00:42:27.000000', 'consum', 0.0213, 'lps'),
	(580822, 128, '2014-03-15 00:42:28.000000', 'consum', 0.0220, 'lps'),
	(580823, 128, '2014-03-15 00:42:29.000000', 'consum', 0.0218, 'lps'),
	(580824, 128, '2014-03-15 00:42:30.000000', 'consum', 0.0219, 'lps'),
	(580825, 128, '2014-03-15 00:42:31.000000', 'consum', 0.0213, 'lps'),
	(580826, 128, '2014-03-15 00:42:32.000000', 'consum', 0.0218, 'lps'),
	(580827, 128, '2014-03-15 00:42:33.000000', 'consum', 0.0219, 'lps'),
	(580828, 128, '2014-03-15 00:42:34.000000', 'consum', 0.0211, 'lps'),
	(580829, 128, '2014-03-15 00:42:35.000000', 'consum', 0.0211, 'lps'),
	(580830, 128, '2014-03-15 00:42:36.000000', 'consum', 0.0214, 'lps'),
	(580831, 128, '2014-03-15 00:42:37.000000', 'consum', 0.0214, 'lps'),
	(580832, 128, '2014-03-15 00:42:38.000000', 'consum', 0.0219, 'lps'),
	(580833, 128, '2014-03-15 00:42:39.000000', 'consum', 0.0213, 'lps'),
	(580834, 128, '2014-03-15 00:42:40.000000', 'consum', 0.0218, 'lps'),
	(580835, 128, '2014-03-15 00:42:41.000000', 'consum', 0.0219, 'lps'),
	(580836, 128, '2014-03-15 00:42:42.000000', 'consum', 0.0219, 'lps'),
	(580837, 128, '2014-03-15 00:42:43.000000', 'consum', 0.0210, 'lps'),
	(580838, 128, '2014-03-15 00:42:44.000000', 'consum', 0.0214, 'lps'),
	(580839, 128, '2014-03-15 00:42:45.000000', 'consum', 0.0210, 'lps'),
	(580840, 128, '2014-03-15 00:42:46.000000', 'consum', 0.0211, 'lps'),
	(580841, 128, '2014-03-15 00:42:47.000000', 'consum', 0.0215, 'lps'),
	(580842, 128, '2014-03-15 00:42:48.000000', 'consum', 0.0219, 'lps'),
	(580843, 128, '2014-03-15 00:42:49.000000', 'consum', 0.0220, 'lps'),
	(580844, 128, '2014-03-15 00:42:50.000000', 'consum', 0.0211, 'lps'),
	(580845, 128, '2014-03-15 00:42:51.000000', 'consum', 0.0220, 'lps'),
	(580846, 128, '2014-03-15 00:42:52.000000', 'consum', 0.0214, 'lps'),
	(580847, 128, '2014-03-15 00:42:53.000000', 'consum', 0.0220, 'lps'),
	(580848, 128, '2014-03-15 00:42:54.000000', 'consum', 0.0217, 'lps'),
	(580849, 128, '2014-03-15 00:42:55.000000', 'consum', 0.0217, 'lps'),
	(580850, 128, '2014-03-15 00:42:56.000000', 'consum', 0.0211, 'lps'),
	(580851, 128, '2014-03-15 00:42:57.000000', 'consum', 0.0217, 'lps'),
	(580852, 128, '2014-03-15 00:42:58.000000', 'consum', 0.0211, 'lps'),
	(580853, 128, '2014-03-15 00:42:59.000000', 'consum', 0.0214, 'lps'),
	(580854, 128, '2014-03-15 00:43:00.000000', 'consum', 0.0218, 'lps'),
	(580855, 128, '2014-03-15 00:43:01.000000', 'consum', 0.0216, 'lps'),
	(580856, 128, '2014-03-15 00:43:02.000000', 'consum', 0.0218, 'lps'),
	(580857, 128, '2014-03-15 00:43:03.000000', 'consum', 0.0210, 'lps'),
	(580858, 128, '2014-03-15 00:43:04.000000', 'consum', 0.0218, 'lps'),
	(580859, 128, '2014-03-15 00:43:05.000000', 'consum', 0.0217, 'lps'),
	(580860, 128, '2014-03-15 00:43:06.000000', 'consum', 0.0213, 'lps'),
	(580861, 128, '2014-03-15 00:43:07.000000', 'consum', 0.0216, 'lps'),
	(580862, 128, '2014-03-15 00:43:08.000000', 'consum', 0.0210, 'lps'),
	(580863, 128, '2014-03-15 00:43:09.000000', 'consum', 0.0211, 'lps'),
	(580864, 128, '2014-03-15 00:43:10.000000', 'consum', 0.0219, 'lps'),
	(580865, 128, '2014-03-15 00:43:11.000000', 'consum', 0.0219, 'lps'),
	(580866, 128, '2014-03-15 00:43:12.000000', 'consum', 0.0218, 'lps'),
	(580867, 128, '2014-03-15 00:43:13.000000', 'consum', 0.0213, 'lps'),
	(580868, 128, '2014-03-15 00:43:14.000000', 'consum', 0.0214, 'lps'),
	(580869, 128, '2014-03-15 00:43:15.000000', 'consum', 0.0218, 'lps'),
	(580870, 128, '2014-03-15 00:43:16.000000', 'consum', 0.0218, 'lps'),
	(580871, 128, '2014-03-15 00:43:17.000000', 'consum', 0.0217, 'lps'),
	(580872, 128, '2014-03-15 00:43:18.000000', 'consum', 0.0219, 'lps'),
	(580873, 128, '2014-03-15 00:43:19.000000', 'consum', 0.0214, 'lps'),
	(580874, 128, '2014-03-15 00:43:20.000000', 'consum', 0.0216, 'lps'),
	(580875, 128, '2014-03-15 00:43:21.000000', 'consum', 0.0216, 'lps'),
	(580876, 128, '2014-03-15 00:43:22.000000', 'consum', 0.0210, 'lps'),
	(580877, 128, '2014-03-15 00:43:23.000000', 'consum', 0.0216, 'lps'),
	(580878, 128, '2014-03-15 00:43:24.000000', 'consum', 0.0219, 'lps'),
	(580879, 128, '2014-03-15 00:43:25.000000', 'consum', 0.0214, 'lps'),
	(580880, 128, '2014-03-15 00:43:26.000000', 'consum', 0.0215, 'lps'),
	(580881, 128, '2014-03-15 00:43:27.000000', 'consum', 0.0213, 'lps'),
	(580882, 128, '2014-03-15 00:43:28.000000', 'consum', 0.0220, 'lps'),
	(580883, 128, '2014-03-15 00:43:29.000000', 'consum', 0.0220, 'lps'),
	(580884, 128, '2014-03-15 00:43:30.000000', 'consum', 0.0210, 'lps'),
	(580885, 128, '2014-03-15 00:43:31.000000', 'consum', 0.0211, 'lps'),
	(580886, 128, '2014-03-15 00:43:32.000000', 'consum', 0.0218, 'lps'),
	(580887, 128, '2014-03-15 00:43:33.000000', 'consum', 0.0213, 'lps'),
	(580888, 128, '2014-03-15 00:43:34.000000', 'consum', 0.0214, 'lps'),
	(580889, 128, '2014-03-15 00:43:35.000000', 'consum', 0.0211, 'lps'),
	(580890, 128, '2014-03-15 00:43:36.000000', 'consum', 0.0214, 'lps'),
	(580891, 128, '2014-03-15 00:43:37.000000', 'consum', 0.0218, 'lps'),
	(580892, 128, '2014-03-15 00:43:38.000000', 'consum', 0.0216, 'lps'),
	(580893, 128, '2014-03-15 00:43:39.000000', 'consum', 0.0215, 'lps'),
	(580894, 128, '2014-03-15 00:43:40.000000', 'consum', 0.0217, 'lps'),
	(580895, 128, '2014-03-15 00:43:41.000000', 'consum', 0.0219, 'lps'),
	(580896, 128, '2014-03-15 00:43:42.000000', 'consum', 0.0212, 'lps'),
	(580897, 128, '2014-03-15 00:43:43.000000', 'consum', 0.0218, 'lps'),
	(580898, 128, '2014-03-15 00:43:44.000000', 'consum', 0.0212, 'lps'),
	(580899, 128, '2014-03-15 00:43:45.000000', 'consum', 0.0216, 'lps'),
	(580900, 128, '2014-03-15 00:43:46.000000', 'consum', 0.0214, 'lps'),
	(580901, 128, '2014-03-15 00:43:47.000000', 'consum', 0.0213, 'lps'),
	(580902, 128, '2014-03-15 00:43:48.000000', 'consum', 0.0215, 'lps'),
	(580903, 128, '2014-03-15 00:43:49.000000', 'consum', 0.0213, 'lps'),
	(580904, 128, '2014-03-15 00:43:50.000000', 'consum', 0.0213, 'lps'),
	(580905, 128, '2014-03-15 00:43:51.000000', 'consum', 0.0214, 'lps'),
	(580906, 128, '2014-03-15 00:43:52.000000', 'consum', 0.0213, 'lps'),
	(580907, 128, '2014-03-15 00:43:53.000000', 'consum', 0.0212, 'lps'),
	(580908, 128, '2014-03-15 00:43:54.000000', 'consum', 0.0211, 'lps'),
	(580909, 128, '2014-03-15 00:43:55.000000', 'consum', 0.0219, 'lps'),
	(580910, 128, '2014-03-15 00:43:56.000000', 'consum', 0.0211, 'lps'),
	(580911, 128, '2014-03-15 00:43:57.000000', 'consum', 0.0219, 'lps'),
	(580912, 128, '2014-03-15 00:43:58.000000', 'consum', 0.0219, 'lps'),
	(580913, 128, '2014-03-15 00:43:59.000000', 'consum', 0.0220, 'lps'),
	(580914, 128, '2014-03-15 00:44:00.000000', 'consum', 0.0213, 'lps'),
	(580915, 128, '2014-03-15 00:44:01.000000', 'consum', 0.0214, 'lps'),
	(580916, 128, '2014-03-15 00:44:02.000000', 'consum', 0.0211, 'lps'),
	(580917, 128, '2014-03-15 00:44:03.000000', 'consum', 0.0213, 'lps'),
	(580918, 128, '2014-03-15 00:44:04.000000', 'consum', 0.0215, 'lps'),
	(580919, 128, '2014-03-15 00:44:05.000000', 'consum', 0.0212, 'lps'),
	(580920, 128, '2014-03-15 00:44:06.000000', 'consum', 0.0218, 'lps'),
	(580921, 128, '2014-03-15 00:44:07.000000', 'consum', 0.0212, 'lps'),
	(580922, 128, '2014-03-15 00:44:08.000000', 'consum', 0.0219, 'lps'),
	(580923, 128, '2014-03-15 00:44:09.000000', 'consum', 0.0218, 'lps'),
	(580924, 128, '2014-03-15 00:44:10.000000', 'consum', 0.0211, 'lps'),
	(580925, 128, '2014-03-15 00:44:11.000000', 'consum', 0.0213, 'lps'),
	(580926, 128, '2014-03-15 00:44:12.000000', 'consum', 0.0210, 'lps'),
	(580927, 128, '2014-03-15 00:44:13.000000', 'consum', 0.0215, 'lps'),
	(580928, 128, '2014-03-15 00:44:14.000000', 'consum', 0.0214, 'lps'),
	(580929, 128, '2014-03-15 00:44:15.000000', 'consum', 0.0215, 'lps'),
	(580930, 128, '2014-03-15 00:44:16.000000', 'consum', 0.0214, 'lps'),
	(580931, 128, '2014-03-15 00:44:17.000000', 'consum', 0.0212, 'lps'),
	(580932, 128, '2014-03-15 00:44:18.000000', 'consum', 0.0211, 'lps'),
	(580933, 128, '2014-03-15 00:44:19.000000', 'consum', 0.0211, 'lps'),
	(580934, 128, '2014-03-15 00:44:20.000000', 'consum', 0.0210, 'lps'),
	(580935, 128, '2014-03-15 00:44:21.000000', 'consum', 0.0217, 'lps'),
	(580936, 128, '2014-03-15 00:44:22.000000', 'consum', 0.0215, 'lps'),
	(580937, 128, '2014-03-15 00:44:23.000000', 'consum', 0.0215, 'lps'),
	(580938, 128, '2014-03-15 00:44:24.000000', 'consum', 0.0220, 'lps'),
	(580939, 128, '2014-03-15 00:44:25.000000', 'consum', 0.0212, 'lps'),
	(580940, 128, '2014-03-15 00:44:26.000000', 'consum', 0.0214, 'lps'),
	(580941, 128, '2014-03-15 00:44:27.000000', 'consum', 0.0213, 'lps'),
	(580942, 128, '2014-03-15 00:44:28.000000', 'consum', 0.0214, 'lps'),
	(580943, 128, '2014-03-15 00:44:29.000000', 'consum', 0.0219, 'lps'),
	(580944, 128, '2014-03-15 00:44:30.000000', 'consum', 0.0214, 'lps'),
	(580945, 128, '2014-03-15 00:44:31.000000', 'consum', 0.0212, 'lps'),
	(580946, 128, '2014-03-15 00:44:32.000000', 'consum', 0.0220, 'lps'),
	(580947, 128, '2014-03-15 00:44:33.000000', 'consum', 0.0210, 'lps'),
	(580948, 128, '2014-03-15 00:44:34.000000', 'consum', 0.0216, 'lps'),
	(580949, 128, '2014-03-15 00:44:35.000000', 'consum', 0.0216, 'lps'),
	(580950, 128, '2014-03-15 00:44:36.000000', 'consum', 0.0213, 'lps'),
	(580951, 128, '2014-03-15 00:44:37.000000', 'consum', 0.0219, 'lps'),
	(580952, 128, '2014-03-15 00:44:38.000000', 'consum', 0.0212, 'lps'),
	(580953, 128, '2014-03-15 00:44:39.000000', 'consum', 0.0216, 'lps'),
	(580954, 128, '2014-03-15 00:44:40.000000', 'consum', 0.0214, 'lps'),
	(580955, 128, '2014-03-15 00:44:41.000000', 'consum', 0.0211, 'lps'),
	(580956, 128, '2014-03-15 00:44:42.000000', 'consum', 0.0217, 'lps'),
	(580957, 128, '2014-03-15 00:44:43.000000', 'consum', 0.0219, 'lps'),
	(580958, 128, '2014-03-15 00:44:44.000000', 'consum', 0.0212, 'lps'),
	(580959, 128, '2014-03-15 00:44:45.000000', 'consum', 0.0216, 'lps'),
	(580960, 128, '2014-03-15 00:44:46.000000', 'consum', 0.0213, 'lps'),
	(580961, 128, '2014-03-15 00:44:47.000000', 'consum', 0.0216, 'lps'),
	(580962, 128, '2014-03-15 00:44:48.000000', 'consum', 0.0211, 'lps'),
	(580963, 128, '2014-03-15 00:44:49.000000', 'consum', 0.0210, 'lps'),
	(580964, 128, '2014-03-15 00:44:50.000000', 'consum', 0.0216, 'lps'),
	(580965, 128, '2014-03-15 00:44:51.000000', 'consum', 0.0218, 'lps'),
	(580966, 128, '2014-03-15 00:44:52.000000', 'consum', 0.0213, 'lps'),
	(580967, 128, '2014-03-15 00:44:53.000000', 'consum', 0.0210, 'lps'),
	(580968, 128, '2014-03-15 00:44:54.000000', 'consum', 0.0215, 'lps'),
	(580969, 128, '2014-03-15 00:44:55.000000', 'consum', 0.0213, 'lps'),
	(580970, 128, '2014-03-15 00:44:56.000000', 'consum', 0.0211, 'lps'),
	(580971, 128, '2014-03-15 00:44:57.000000', 'consum', 0.0217, 'lps'),
	(580972, 128, '2014-03-15 00:44:58.000000', 'consum', 0.0210, 'lps'),
	(580973, 128, '2014-03-15 00:44:59.000000', 'consum', 0.0213, 'lps'),
	(580974, 128, '2014-03-15 00:45:00.000000', 'consum', 0.0213, 'lps'),
	(580975, 128, '2014-03-15 00:45:01.000000', 'consum', 0.0215, 'lps'),
	(580976, 128, '2014-03-15 00:45:02.000000', 'consum', 0.0215, 'lps'),
	(580977, 128, '2014-03-15 00:45:03.000000', 'consum', 0.0220, 'lps'),
	(580978, 128, '2014-03-15 00:45:04.000000', 'consum', 0.0213, 'lps'),
	(580979, 128, '2014-03-15 00:45:05.000000', 'consum', 0.0218, 'lps'),
	(580980, 128, '2014-03-15 00:45:06.000000', 'consum', 0.0210, 'lps'),
	(580981, 128, '2014-03-15 00:45:07.000000', 'consum', 0.0218, 'lps'),
	(580982, 128, '2014-03-15 00:45:08.000000', 'consum', 0.0217, 'lps'),
	(580983, 128, '2014-03-15 00:45:09.000000', 'consum', 0.0213, 'lps'),
	(580984, 128, '2014-03-15 00:45:10.000000', 'consum', 0.0213, 'lps'),
	(580985, 128, '2014-03-15 00:45:11.000000', 'consum', 0.0219, 'lps'),
	(580986, 128, '2014-03-15 00:45:12.000000', 'consum', 0.0211, 'lps'),
	(580987, 128, '2014-03-15 00:45:13.000000', 'consum', 0.0211, 'lps'),
	(580988, 128, '2014-03-15 00:45:14.000000', 'consum', 0.0213, 'lps'),
	(580989, 128, '2014-03-15 00:45:15.000000', 'consum', 0.0210, 'lps'),
	(580990, 128, '2014-03-15 00:45:16.000000', 'consum', 0.0212, 'lps'),
	(580991, 128, '2014-03-15 00:45:17.000000', 'consum', 0.0210, 'lps'),
	(580992, 128, '2014-03-15 00:45:18.000000', 'consum', 0.0218, 'lps'),
	(580993, 128, '2014-03-15 00:45:19.000000', 'consum', 0.0214, 'lps'),
	(580994, 128, '2014-03-15 00:45:20.000000', 'consum', 0.0210, 'lps'),
	(580995, 128, '2014-03-15 00:45:21.000000', 'consum', 0.0217, 'lps'),
	(580996, 128, '2014-03-15 00:45:22.000000', 'consum', 0.0215, 'lps'),
	(580997, 128, '2014-03-15 00:45:23.000000', 'consum', 0.0212, 'lps'),
	(580998, 128, '2014-03-15 00:45:24.000000', 'consum', 0.0218, 'lps'),
	(580999, 128, '2014-03-15 00:45:25.000000', 'consum', 0.0210, 'lps'),
	(581000, 128, '2014-03-15 00:45:26.000000', 'consum', 0.0219, 'lps'),
	(581001, 128, '2014-03-15 00:45:27.000000', 'consum', 0.0210, 'lps'),
	(581002, 128, '2014-03-15 00:45:28.000000', 'consum', 0.0220, 'lps'),
	(581003, 128, '2014-03-15 00:45:29.000000', 'consum', 0.0216, 'lps'),
	(581004, 128, '2014-03-15 00:45:30.000000', 'consum', 0.0211, 'lps'),
	(581005, 128, '2014-03-15 00:45:31.000000', 'consum', 0.0220, 'lps'),
	(581006, 128, '2014-03-15 00:45:32.000000', 'consum', 0.0213, 'lps'),
	(581007, 128, '2014-03-15 00:45:33.000000', 'consum', 0.0218, 'lps'),
	(581008, 128, '2014-03-15 00:45:34.000000', 'consum', 0.0220, 'lps'),
	(581009, 128, '2014-03-15 00:45:35.000000', 'consum', 0.0213, 'lps'),
	(581010, 128, '2014-03-15 00:45:36.000000', 'consum', 0.0218, 'lps'),
	(581011, 128, '2014-03-15 00:45:37.000000', 'consum', 0.0218, 'lps'),
	(581012, 128, '2014-03-15 00:45:38.000000', 'consum', 0.0217, 'lps'),
	(581013, 128, '2014-03-15 00:45:39.000000', 'consum', 0.0212, 'lps'),
	(581014, 128, '2014-03-15 00:45:40.000000', 'consum', 0.0219, 'lps'),
	(581015, 128, '2014-03-15 00:45:41.000000', 'consum', 0.0217, 'lps'),
	(581016, 128, '2014-03-15 00:45:42.000000', 'consum', 0.0220, 'lps'),
	(581017, 128, '2014-03-15 00:45:43.000000', 'consum', 0.0215, 'lps'),
	(581018, 128, '2014-03-15 00:45:44.000000', 'consum', 0.0217, 'lps'),
	(581019, 128, '2014-03-15 00:45:45.000000', 'consum', 0.0220, 'lps'),
	(581020, 128, '2014-03-15 00:45:46.000000', 'consum', 0.0216, 'lps'),
	(581021, 128, '2014-03-15 00:45:47.000000', 'consum', 0.0212, 'lps'),
	(581022, 128, '2014-03-15 00:45:48.000000', 'consum', 0.0212, 'lps'),
	(581023, 128, '2014-03-15 00:45:49.000000', 'consum', 0.0214, 'lps'),
	(581024, 128, '2014-03-15 00:45:50.000000', 'consum', 0.0216, 'lps'),
	(581025, 128, '2014-03-15 00:45:51.000000', 'consum', 0.0216, 'lps'),
	(581026, 128, '2014-03-15 00:45:52.000000', 'consum', 0.0212, 'lps'),
	(581027, 128, '2014-03-15 00:45:53.000000', 'consum', 0.0213, 'lps'),
	(581028, 128, '2014-03-15 00:45:54.000000', 'consum', 0.0218, 'lps'),
	(581029, 128, '2014-03-15 00:45:55.000000', 'consum', 0.0210, 'lps'),
	(581030, 128, '2014-03-15 00:45:56.000000', 'consum', 0.0219, 'lps'),
	(581031, 128, '2014-03-15 00:45:57.000000', 'consum', 0.0210, 'lps'),
	(581032, 128, '2014-03-15 00:45:58.000000', 'consum', 0.0219, 'lps'),
	(581033, 128, '2014-03-15 00:45:59.000000', 'consum', 0.0212, 'lps'),
	(581034, 128, '2014-03-15 00:46:00.000000', 'consum', 0.0215, 'lps'),
	(581035, 128, '2014-03-15 00:46:01.000000', 'consum', 0.0216, 'lps'),
	(581036, 128, '2014-03-15 00:46:02.000000', 'consum', 0.0216, 'lps'),
	(581037, 128, '2014-03-15 00:46:03.000000', 'consum', 0.0213, 'lps'),
	(581038, 128, '2014-03-15 00:46:04.000000', 'consum', 0.0217, 'lps'),
	(581039, 128, '2014-03-15 00:46:05.000000', 'consum', 0.0213, 'lps'),
	(581040, 128, '2014-03-15 00:46:06.000000', 'consum', 0.0217, 'lps'),
	(581041, 128, '2014-03-15 00:46:07.000000', 'consum', 0.0216, 'lps'),
	(581042, 128, '2014-03-15 00:46:08.000000', 'consum', 0.0220, 'lps'),
	(581043, 128, '2014-03-15 00:46:09.000000', 'consum', 0.0220, 'lps'),
	(581044, 128, '2014-03-15 00:46:10.000000', 'consum', 0.0219, 'lps'),
	(581045, 128, '2014-03-15 00:46:11.000000', 'consum', 0.0215, 'lps'),
	(581046, 128, '2014-03-15 00:46:12.000000', 'consum', 0.0218, 'lps'),
	(581047, 128, '2014-03-15 00:46:13.000000', 'consum', 0.0214, 'lps'),
	(581048, 128, '2014-03-15 00:46:14.000000', 'consum', 0.0216, 'lps'),
	(581049, 128, '2014-03-15 00:46:15.000000', 'consum', 0.0210, 'lps'),
	(581050, 128, '2014-03-15 00:46:16.000000', 'consum', 0.0211, 'lps'),
	(581051, 128, '2014-03-15 00:46:17.000000', 'consum', 0.0217, 'lps'),
	(581052, 128, '2014-03-15 00:46:18.000000', 'consum', 0.0210, 'lps'),
	(581053, 128, '2014-03-15 00:46:19.000000', 'consum', 0.0211, 'lps'),
	(581054, 128, '2014-03-15 00:46:20.000000', 'consum', 0.0217, 'lps'),
	(581055, 128, '2014-03-15 00:46:21.000000', 'consum', 0.0218, 'lps'),
	(581056, 128, '2014-03-15 00:46:22.000000', 'consum', 0.0220, 'lps'),
	(581057, 128, '2014-03-15 00:46:23.000000', 'consum', 0.0215, 'lps'),
	(581058, 128, '2014-03-15 00:46:24.000000', 'consum', 0.0216, 'lps'),
	(581059, 128, '2014-03-15 00:46:25.000000', 'consum', 0.0214, 'lps'),
	(581060, 128, '2014-03-15 00:46:26.000000', 'consum', 0.0214, 'lps'),
	(581061, 128, '2014-03-15 00:46:27.000000', 'consum', 0.0216, 'lps'),
	(581062, 128, '2014-03-15 00:46:28.000000', 'consum', 0.0219, 'lps'),
	(581063, 128, '2014-03-15 00:46:29.000000', 'consum', 0.0217, 'lps'),
	(581064, 128, '2014-03-15 00:46:30.000000', 'consum', 0.0218, 'lps'),
	(581065, 128, '2014-03-15 00:46:31.000000', 'consum', 0.0220, 'lps'),
	(581066, 128, '2014-03-15 00:46:32.000000', 'consum', 0.0213, 'lps'),
	(581067, 128, '2014-03-15 00:46:33.000000', 'consum', 0.0219, 'lps'),
	(581068, 128, '2014-03-15 00:46:34.000000', 'consum', 0.0212, 'lps'),
	(581069, 128, '2014-03-15 00:46:35.000000', 'consum', 0.0217, 'lps'),
	(581070, 128, '2014-03-15 00:46:36.000000', 'consum', 0.0215, 'lps'),
	(581071, 128, '2014-03-15 00:46:37.000000', 'consum', 0.0217, 'lps'),
	(581072, 128, '2014-03-15 00:46:38.000000', 'consum', 0.0220, 'lps'),
	(581073, 128, '2014-03-15 00:46:39.000000', 'consum', 0.0216, 'lps'),
	(581074, 128, '2014-03-15 00:46:40.000000', 'consum', 0.0210, 'lps'),
	(581075, 128, '2014-03-15 00:46:41.000000', 'consum', 0.0215, 'lps'),
	(581076, 128, '2014-03-15 00:46:42.000000', 'consum', 0.0215, 'lps'),
	(581077, 128, '2014-03-15 00:46:43.000000', 'consum', 0.0219, 'lps'),
	(581078, 128, '2014-03-15 00:46:44.000000', 'consum', 0.0217, 'lps'),
	(581079, 128, '2014-03-15 00:46:45.000000', 'consum', 0.0220, 'lps'),
	(581080, 128, '2014-03-15 00:46:46.000000', 'consum', 0.0219, 'lps'),
	(581081, 128, '2014-03-15 00:46:47.000000', 'consum', 0.0215, 'lps'),
	(581082, 128, '2014-03-15 00:46:48.000000', 'consum', 0.0219, 'lps'),
	(581083, 128, '2014-03-15 00:46:49.000000', 'consum', 0.0218, 'lps'),
	(581084, 128, '2014-03-15 00:46:50.000000', 'consum', 0.0214, 'lps'),
	(581085, 128, '2014-03-15 00:46:51.000000', 'consum', 0.0216, 'lps'),
	(581086, 128, '2014-03-15 00:46:52.000000', 'consum', 0.0216, 'lps'),
	(581087, 128, '2014-03-15 00:46:53.000000', 'consum', 0.0213, 'lps'),
	(581088, 128, '2014-03-15 00:46:54.000000', 'consum', 0.0220, 'lps'),
	(581089, 128, '2014-03-15 00:46:55.000000', 'consum', 0.0215, 'lps'),
	(581090, 128, '2014-03-15 00:46:56.000000', 'consum', 0.0220, 'lps'),
	(581091, 128, '2014-03-15 00:46:57.000000', 'consum', 0.0220, 'lps'),
	(581092, 128, '2014-03-15 00:46:58.000000', 'consum', 0.0212, 'lps'),
	(581093, 128, '2014-03-15 00:46:59.000000', 'consum', 0.0210, 'lps'),
	(581094, 128, '2014-03-15 00:47:00.000000', 'consum', 0.0215, 'lps'),
	(581095, 128, '2014-03-15 00:47:01.000000', 'consum', 0.0213, 'lps'),
	(581096, 128, '2014-03-15 00:47:02.000000', 'consum', 0.0210, 'lps'),
	(581097, 128, '2014-03-15 00:47:03.000000', 'consum', 0.0215, 'lps'),
	(581098, 128, '2014-03-15 00:47:04.000000', 'consum', 0.0213, 'lps'),
	(581099, 128, '2014-03-15 00:47:05.000000', 'consum', 0.0220, 'lps'),
	(581100, 128, '2014-03-15 00:47:06.000000', 'consum', 0.0217, 'lps'),
	(581101, 128, '2014-03-15 00:47:07.000000', 'consum', 0.0219, 'lps'),
	(581102, 128, '2014-03-15 00:47:08.000000', 'consum', 0.0210, 'lps'),
	(581103, 128, '2014-03-15 00:47:09.000000', 'consum', 0.0218, 'lps'),
	(581104, 128, '2014-03-15 00:47:10.000000', 'consum', 0.0219, 'lps'),
	(581105, 128, '2014-03-15 00:47:11.000000', 'consum', 0.0217, 'lps'),
	(581106, 128, '2014-03-15 00:47:12.000000', 'consum', 0.0211, 'lps'),
	(581107, 128, '2014-03-15 00:47:13.000000', 'consum', 0.0214, 'lps'),
	(581108, 128, '2014-03-15 00:47:14.000000', 'consum', 0.0219, 'lps'),
	(581109, 128, '2014-03-15 00:47:15.000000', 'consum', 0.0210, 'lps'),
	(581110, 128, '2014-03-15 00:47:16.000000', 'consum', 0.0216, 'lps'),
	(581111, 128, '2014-03-15 00:47:17.000000', 'consum', 0.0220, 'lps'),
	(581112, 128, '2014-03-15 00:47:18.000000', 'consum', 0.0218, 'lps'),
	(581113, 128, '2014-03-15 00:47:19.000000', 'consum', 0.0220, 'lps'),
	(581114, 128, '2014-03-15 00:47:20.000000', 'consum', 0.0217, 'lps'),
	(581115, 128, '2014-03-15 00:47:21.000000', 'consum', 0.0213, 'lps'),
	(581116, 128, '2014-03-15 00:47:22.000000', 'consum', 0.0218, 'lps'),
	(581117, 128, '2014-03-15 00:47:23.000000', 'consum', 0.0217, 'lps'),
	(581118, 128, '2014-03-15 00:47:24.000000', 'consum', 0.0213, 'lps'),
	(581119, 128, '2014-03-15 00:47:25.000000', 'consum', 0.0213, 'lps'),
	(581120, 128, '2014-03-15 00:47:26.000000', 'consum', 0.0219, 'lps'),
	(581121, 128, '2014-03-15 00:47:27.000000', 'consum', 0.0212, 'lps'),
	(581122, 128, '2014-03-15 00:47:28.000000', 'consum', 0.0217, 'lps'),
	(581123, 128, '2014-03-15 00:47:29.000000', 'consum', 0.0219, 'lps'),
	(581124, 128, '2014-03-15 00:47:30.000000', 'consum', 0.0220, 'lps'),
	(581125, 128, '2014-03-15 00:47:31.000000', 'consum', 0.0213, 'lps'),
	(581126, 128, '2014-03-15 00:47:32.000000', 'consum', 0.0218, 'lps'),
	(581127, 128, '2014-03-15 00:47:33.000000', 'consum', 0.0220, 'lps'),
	(581128, 128, '2014-03-15 00:47:34.000000', 'consum', 0.0215, 'lps'),
	(581129, 128, '2014-03-15 00:47:35.000000', 'consum', 0.0214, 'lps'),
	(581130, 128, '2014-03-15 00:47:36.000000', 'consum', 0.0219, 'lps'),
	(581131, 128, '2014-03-15 00:47:37.000000', 'consum', 0.0218, 'lps'),
	(581132, 128, '2014-03-15 00:47:38.000000', 'consum', 0.0214, 'lps'),
	(581133, 128, '2014-03-15 00:47:39.000000', 'consum', 0.0216, 'lps'),
	(581134, 128, '2014-03-15 00:47:40.000000', 'consum', 0.0219, 'lps'),
	(581135, 128, '2014-03-15 00:47:41.000000', 'consum', 0.0214, 'lps'),
	(581136, 128, '2014-03-15 00:47:42.000000', 'consum', 0.0216, 'lps'),
	(581137, 128, '2014-03-15 00:47:43.000000', 'consum', 0.0218, 'lps'),
	(581138, 128, '2014-03-15 00:47:44.000000', 'consum', 0.0220, 'lps'),
	(581139, 128, '2014-03-15 00:47:45.000000', 'consum', 0.0214, 'lps'),
	(581140, 128, '2014-03-15 00:47:46.000000', 'consum', 0.0211, 'lps'),
	(581141, 128, '2014-03-15 00:47:47.000000', 'consum', 0.0216, 'lps'),
	(581142, 128, '2014-03-15 00:47:48.000000', 'consum', 0.0215, 'lps'),
	(581143, 128, '2014-03-15 00:47:49.000000', 'consum', 0.0217, 'lps'),
	(581144, 128, '2014-03-15 00:47:50.000000', 'consum', 0.0218, 'lps'),
	(581145, 128, '2014-03-15 00:47:51.000000', 'consum', 0.0220, 'lps'),
	(581146, 128, '2014-03-15 00:47:52.000000', 'consum', 0.0213, 'lps'),
	(581147, 128, '2014-03-15 00:47:53.000000', 'consum', 0.0216, 'lps'),
	(581148, 128, '2014-03-15 00:47:54.000000', 'consum', 0.0213, 'lps'),
	(581149, 128, '2014-03-15 00:47:55.000000', 'consum', 0.0217, 'lps'),
	(581150, 128, '2014-03-15 00:47:56.000000', 'consum', 0.0216, 'lps'),
	(581151, 128, '2014-03-15 00:47:57.000000', 'consum', 0.0210, 'lps'),
	(581152, 128, '2014-03-15 00:47:58.000000', 'consum', 0.0211, 'lps'),
	(581153, 128, '2014-03-15 00:47:59.000000', 'consum', 0.0218, 'lps'),
	(581154, 128, '2014-03-15 00:48:00.000000', 'consum', 0.0215, 'lps'),
	(581155, 128, '2014-03-15 00:48:01.000000', 'consum', 0.0213, 'lps'),
	(581156, 128, '2014-03-15 00:48:02.000000', 'consum', 0.0218, 'lps'),
	(581157, 128, '2014-03-15 00:48:03.000000', 'consum', 0.0210, 'lps'),
	(581158, 128, '2014-03-15 00:48:04.000000', 'consum', 0.0218, 'lps'),
	(581159, 128, '2014-03-15 00:48:05.000000', 'consum', 0.0217, 'lps'),
	(581160, 128, '2014-03-15 00:48:06.000000', 'consum', 0.0213, 'lps'),
	(581161, 128, '2014-03-15 00:48:07.000000', 'consum', 0.0213, 'lps'),
	(581162, 128, '2014-03-15 00:48:08.000000', 'consum', 0.0217, 'lps'),
	(581163, 128, '2014-03-15 00:48:09.000000', 'consum', 0.0217, 'lps'),
	(581164, 128, '2014-03-15 00:48:10.000000', 'consum', 0.0212, 'lps'),
	(581165, 128, '2014-03-15 00:48:11.000000', 'consum', 0.0220, 'lps'),
	(581166, 128, '2014-03-15 00:48:12.000000', 'consum', 0.0213, 'lps'),
	(581167, 128, '2014-03-15 00:48:13.000000', 'consum', 0.0215, 'lps'),
	(581168, 128, '2014-03-15 00:48:14.000000', 'consum', 0.0216, 'lps'),
	(581169, 128, '2014-03-15 00:48:15.000000', 'consum', 0.0213, 'lps'),
	(581170, 128, '2014-03-15 00:48:16.000000', 'consum', 0.0211, 'lps'),
	(581171, 128, '2014-03-15 00:48:17.000000', 'consum', 0.0215, 'lps'),
	(581172, 128, '2014-03-15 00:48:18.000000', 'consum', 0.0220, 'lps'),
	(581173, 128, '2014-03-15 00:48:19.000000', 'consum', 0.0216, 'lps'),
	(581174, 128, '2014-03-15 00:48:20.000000', 'consum', 0.0218, 'lps'),
	(581175, 128, '2014-03-15 00:48:21.000000', 'consum', 0.0212, 'lps'),
	(581176, 128, '2014-03-15 00:48:22.000000', 'consum', 0.0219, 'lps'),
	(581177, 128, '2014-03-15 00:48:23.000000', 'consum', 0.0218, 'lps'),
	(581178, 128, '2014-03-15 00:48:24.000000', 'consum', 0.0212, 'lps'),
	(581179, 128, '2014-03-15 00:48:25.000000', 'consum', 0.0220, 'lps'),
	(581180, 128, '2014-03-15 00:48:26.000000', 'consum', 0.0218, 'lps'),
	(581181, 128, '2014-03-15 00:48:27.000000', 'consum', 0.0211, 'lps'),
	(581182, 128, '2014-03-15 00:48:28.000000', 'consum', 0.0213, 'lps'),
	(581183, 128, '2014-03-15 00:48:29.000000', 'consum', 0.0213, 'lps'),
	(581184, 128, '2014-03-15 00:48:30.000000', 'consum', 0.0215, 'lps'),
	(581185, 128, '2014-03-15 00:48:31.000000', 'consum', 0.0215, 'lps'),
	(581186, 128, '2014-03-15 00:48:32.000000', 'consum', 0.0219, 'lps'),
	(581187, 128, '2014-03-15 00:48:33.000000', 'consum', 0.0210, 'lps'),
	(581188, 128, '2014-03-15 00:48:34.000000', 'consum', 0.0217, 'lps'),
	(581189, 128, '2014-03-15 00:48:35.000000', 'consum', 0.0210, 'lps'),
	(581190, 128, '2014-03-15 00:48:36.000000', 'consum', 0.0214, 'lps'),
	(581191, 128, '2014-03-15 00:48:37.000000', 'consum', 0.0217, 'lps'),
	(581192, 128, '2014-03-15 00:48:38.000000', 'consum', 0.0213, 'lps'),
	(581193, 128, '2014-03-15 00:48:39.000000', 'consum', 0.0216, 'lps'),
	(581194, 128, '2014-03-15 00:48:40.000000', 'consum', 0.0220, 'lps'),
	(581195, 128, '2014-03-15 00:48:41.000000', 'consum', 0.0220, 'lps'),
	(581196, 128, '2014-03-15 00:48:42.000000', 'consum', 0.0218, 'lps'),
	(581197, 128, '2014-03-15 00:48:43.000000', 'consum', 0.0212, 'lps'),
	(581198, 128, '2014-03-15 00:48:44.000000', 'consum', 0.0217, 'lps'),
	(581199, 128, '2014-03-15 00:48:45.000000', 'consum', 0.0218, 'lps'),
	(581200, 128, '2014-03-15 00:48:46.000000', 'consum', 0.0219, 'lps'),
	(581201, 128, '2014-03-15 00:48:47.000000', 'consum', 0.0219, 'lps'),
	(581202, 128, '2014-03-15 00:48:48.000000', 'consum', 0.0217, 'lps'),
	(581203, 128, '2014-03-15 00:48:49.000000', 'consum', 0.0210, 'lps'),
	(581204, 128, '2014-03-15 00:48:50.000000', 'consum', 0.0210, 'lps'),
	(581205, 128, '2014-03-15 00:48:51.000000', 'consum', 0.0210, 'lps'),
	(581206, 128, '2014-03-15 00:48:52.000000', 'consum', 0.0212, 'lps'),
	(581207, 128, '2014-03-15 00:48:53.000000', 'consum', 0.0219, 'lps'),
	(581208, 128, '2014-03-15 00:48:54.000000', 'consum', 0.0217, 'lps'),
	(581209, 128, '2014-03-15 00:48:55.000000', 'consum', 0.0219, 'lps'),
	(581210, 128, '2014-03-15 00:48:56.000000', 'consum', 0.0211, 'lps'),
	(581211, 128, '2014-03-15 00:48:57.000000', 'consum', 0.0220, 'lps'),
	(581212, 128, '2014-03-15 00:48:58.000000', 'consum', 0.0217, 'lps'),
	(581213, 128, '2014-03-15 00:48:59.000000', 'consum', 0.0213, 'lps'),
	(581214, 128, '2014-03-15 00:49:00.000000', 'consum', 0.0217, 'lps'),
	(581215, 128, '2014-03-15 00:49:01.000000', 'consum', 0.0214, 'lps'),
	(581216, 128, '2014-03-15 00:49:02.000000', 'consum', 0.0220, 'lps'),
	(581217, 128, '2014-03-15 00:49:03.000000', 'consum', 0.0215, 'lps'),
	(581218, 128, '2014-03-15 00:49:04.000000', 'consum', 0.0219, 'lps'),
	(581219, 128, '2014-03-15 00:49:05.000000', 'consum', 0.0217, 'lps'),
	(581220, 128, '2014-03-15 00:49:06.000000', 'consum', 0.0219, 'lps'),
	(581221, 128, '2014-03-15 00:49:07.000000', 'consum', 0.0211, 'lps'),
	(581222, 128, '2014-03-15 00:49:08.000000', 'consum', 0.0212, 'lps'),
	(581223, 128, '2014-03-15 00:49:09.000000', 'consum', 0.0219, 'lps'),
	(581224, 128, '2014-03-15 00:49:10.000000', 'consum', 0.0215, 'lps'),
	(581225, 128, '2014-03-15 00:49:11.000000', 'consum', 0.0218, 'lps'),
	(581226, 128, '2014-03-15 00:49:12.000000', 'consum', 0.0213, 'lps'),
	(581227, 128, '2014-03-15 00:49:13.000000', 'consum', 0.0215, 'lps'),
	(581228, 128, '2014-03-15 00:49:14.000000', 'consum', 0.0213, 'lps'),
	(581229, 128, '2014-03-15 00:49:15.000000', 'consum', 0.0213, 'lps'),
	(581230, 128, '2014-03-15 00:49:16.000000', 'consum', 0.0217, 'lps'),
	(581231, 128, '2014-03-15 00:49:17.000000', 'consum', 0.0214, 'lps'),
	(581232, 128, '2014-03-15 00:49:18.000000', 'consum', 0.0218, 'lps'),
	(581233, 128, '2014-03-15 00:49:19.000000', 'consum', 0.0220, 'lps'),
	(581234, 128, '2014-03-15 00:49:20.000000', 'consum', 0.0213, 'lps'),
	(581235, 128, '2014-03-15 00:49:21.000000', 'consum', 0.0218, 'lps'),
	(581236, 128, '2014-03-15 00:49:22.000000', 'consum', 0.0217, 'lps'),
	(581237, 128, '2014-03-15 00:49:23.000000', 'consum', 0.0213, 'lps'),
	(581238, 128, '2014-03-15 00:49:24.000000', 'consum', 0.0214, 'lps'),
	(581239, 128, '2014-03-15 00:49:25.000000', 'consum', 0.0212, 'lps'),
	(581240, 128, '2014-03-15 00:49:26.000000', 'consum', 0.0219, 'lps'),
	(581241, 128, '2014-03-15 00:49:27.000000', 'consum', 0.0216, 'lps'),
	(581242, 128, '2014-03-15 00:49:28.000000', 'consum', 0.0213, 'lps'),
	(581243, 128, '2014-03-15 00:49:29.000000', 'consum', 0.0220, 'lps'),
	(581244, 128, '2014-03-15 00:49:30.000000', 'consum', 0.0218, 'lps'),
	(581245, 128, '2014-03-15 00:49:31.000000', 'consum', 0.0211, 'lps'),
	(581246, 128, '2014-03-15 00:49:32.000000', 'consum', 0.0210, 'lps'),
	(581247, 128, '2014-03-15 00:49:33.000000', 'consum', 0.0211, 'lps'),
	(581248, 128, '2014-03-15 00:49:34.000000', 'consum', 0.0213, 'lps'),
	(581249, 128, '2014-03-15 00:49:35.000000', 'consum', 0.0214, 'lps'),
	(581250, 128, '2014-03-15 00:49:36.000000', 'consum', 0.0219, 'lps'),
	(581251, 128, '2014-03-15 00:49:37.000000', 'consum', 0.0210, 'lps'),
	(581252, 128, '2014-03-15 00:49:38.000000', 'consum', 0.0217, 'lps'),
	(581253, 128, '2014-03-15 00:49:39.000000', 'consum', 0.0214, 'lps'),
	(581254, 128, '2014-03-15 00:49:40.000000', 'consum', 0.0211, 'lps'),
	(581255, 128, '2014-03-15 00:49:41.000000', 'consum', 0.0212, 'lps'),
	(581256, 128, '2014-03-15 00:49:42.000000', 'consum', 0.0219, 'lps'),
	(581257, 128, '2014-03-15 00:49:43.000000', 'consum', 0.0214, 'lps'),
	(581258, 128, '2014-03-15 00:49:44.000000', 'consum', 0.0218, 'lps'),
	(581259, 128, '2014-03-15 00:49:45.000000', 'consum', 0.0213, 'lps'),
	(581260, 128, '2014-03-15 00:49:46.000000', 'consum', 0.0215, 'lps'),
	(581261, 128, '2014-03-15 00:49:47.000000', 'consum', 0.0216, 'lps'),
	(581262, 128, '2014-03-15 00:49:48.000000', 'consum', 0.0212, 'lps'),
	(581263, 128, '2014-03-15 00:49:49.000000', 'consum', 0.0215, 'lps'),
	(581264, 128, '2014-03-15 00:49:50.000000', 'consum', 0.0219, 'lps'),
	(581265, 128, '2014-03-15 00:49:51.000000', 'consum', 0.0219, 'lps'),
	(581266, 128, '2014-03-15 00:49:52.000000', 'consum', 0.0218, 'lps'),
	(581267, 128, '2014-03-15 00:49:53.000000', 'consum', 0.0211, 'lps'),
	(581268, 128, '2014-03-15 00:49:54.000000', 'consum', 0.0216, 'lps'),
	(581269, 128, '2014-03-15 00:49:55.000000', 'consum', 0.0214, 'lps'),
	(581270, 128, '2014-03-15 00:49:56.000000', 'consum', 0.0211, 'lps'),
	(581271, 128, '2014-03-15 00:49:57.000000', 'consum', 0.0216, 'lps'),
	(581272, 128, '2014-03-15 00:49:58.000000', 'consum', 0.0216, 'lps'),
	(581273, 128, '2014-03-15 00:49:59.000000', 'consum', 0.0212, 'lps'),
	(581274, 128, '2014-03-15 00:50:00.000000', 'consum', 0.0214, 'lps'),
	(581275, 128, '2014-03-15 00:50:01.000000', 'consum', 0.0213, 'lps'),
	(581276, 128, '2014-03-15 00:50:02.000000', 'consum', 0.0214, 'lps'),
	(581277, 128, '2014-03-15 00:50:03.000000', 'consum', 0.0211, 'lps'),
	(581278, 128, '2014-03-15 00:50:04.000000', 'consum', 0.0212, 'lps'),
	(581279, 128, '2014-03-15 00:50:05.000000', 'consum', 0.0219, 'lps'),
	(581280, 128, '2014-03-15 00:50:06.000000', 'consum', 0.0216, 'lps'),
	(581281, 128, '2014-03-15 00:50:07.000000', 'consum', 0.0214, 'lps'),
	(581282, 128, '2014-03-15 00:50:08.000000', 'consum', 0.0211, 'lps'),
	(581283, 128, '2014-03-15 00:50:09.000000', 'consum', 0.0215, 'lps'),
	(581284, 128, '2014-03-15 00:50:10.000000', 'consum', 0.0220, 'lps'),
	(581285, 128, '2014-03-15 00:50:11.000000', 'consum', 0.0213, 'lps'),
	(581286, 128, '2014-03-15 00:50:12.000000', 'consum', 0.0220, 'lps'),
	(581287, 128, '2014-03-15 00:50:13.000000', 'consum', 0.0217, 'lps'),
	(581288, 128, '2014-03-15 00:50:14.000000', 'consum', 0.0214, 'lps'),
	(581289, 128, '2014-03-15 00:50:15.000000', 'consum', 0.0211, 'lps'),
	(581290, 128, '2014-03-15 00:50:16.000000', 'consum', 0.0214, 'lps'),
	(581291, 128, '2014-03-15 00:50:17.000000', 'consum', 0.0216, 'lps'),
	(581292, 128, '2014-03-15 00:50:18.000000', 'consum', 0.0219, 'lps'),
	(581293, 128, '2014-03-15 00:50:19.000000', 'consum', 0.0217, 'lps'),
	(581294, 128, '2014-03-15 00:50:20.000000', 'consum', 0.0216, 'lps'),
	(581295, 128, '2014-03-15 00:50:21.000000', 'consum', 0.0219, 'lps'),
	(581296, 128, '2014-03-15 00:50:22.000000', 'consum', 0.0218, 'lps'),
	(581297, 128, '2014-03-15 00:50:23.000000', 'consum', 0.0211, 'lps'),
	(581298, 128, '2014-03-15 00:50:24.000000', 'consum', 0.0213, 'lps'),
	(581299, 128, '2014-03-15 00:50:25.000000', 'consum', 0.0210, 'lps'),
	(581300, 128, '2014-03-15 00:50:26.000000', 'consum', 0.0215, 'lps'),
	(581301, 128, '2014-03-15 00:50:27.000000', 'consum', 0.0213, 'lps'),
	(581302, 128, '2014-03-15 00:50:28.000000', 'consum', 0.0210, 'lps'),
	(581303, 128, '2014-03-15 00:50:29.000000', 'consum', 0.0212, 'lps'),
	(581304, 128, '2014-03-15 00:50:30.000000', 'consum', 0.0210, 'lps'),
	(581305, 128, '2014-03-15 00:50:31.000000', 'consum', 0.0214, 'lps'),
	(581306, 128, '2014-03-15 00:50:32.000000', 'consum', 0.0219, 'lps'),
	(581307, 128, '2014-03-15 00:50:33.000000', 'consum', 0.0213, 'lps'),
	(581308, 128, '2014-03-15 00:50:34.000000', 'consum', 0.0219, 'lps'),
	(581309, 128, '2014-03-15 00:50:35.000000', 'consum', 0.0212, 'lps'),
	(581310, 128, '2014-03-15 00:50:36.000000', 'consum', 0.0216, 'lps'),
	(581311, 128, '2014-03-15 00:50:37.000000', 'consum', 0.0213, 'lps'),
	(581312, 128, '2014-03-15 00:50:38.000000', 'consum', 0.0220, 'lps'),
	(581313, 128, '2014-03-15 00:50:39.000000', 'consum', 0.0215, 'lps'),
	(581314, 128, '2014-03-15 00:50:40.000000', 'consum', 0.0220, 'lps'),
	(581315, 128, '2014-03-15 00:50:41.000000', 'consum', 0.0213, 'lps'),
	(581316, 128, '2014-03-15 00:50:42.000000', 'consum', 0.0216, 'lps'),
	(581317, 128, '2014-03-15 00:50:43.000000', 'consum', 0.0220, 'lps'),
	(581318, 128, '2014-03-15 00:50:44.000000', 'consum', 0.0220, 'lps'),
	(581319, 128, '2014-03-15 00:50:45.000000', 'consum', 0.0220, 'lps'),
	(581320, 128, '2014-03-15 00:50:46.000000', 'consum', 0.0218, 'lps'),
	(581321, 128, '2014-03-15 00:50:47.000000', 'consum', 0.0220, 'lps'),
	(581322, 128, '2014-03-15 00:50:48.000000', 'consum', 0.0215, 'lps'),
	(581323, 128, '2014-03-15 00:50:49.000000', 'consum', 0.0218, 'lps'),
	(581324, 128, '2014-03-15 00:50:50.000000', 'consum', 0.0214, 'lps'),
	(581325, 128, '2014-03-15 00:50:51.000000', 'consum', 0.0215, 'lps'),
	(581326, 128, '2014-03-15 00:50:52.000000', 'consum', 0.0215, 'lps'),
	(581327, 128, '2014-03-15 00:50:53.000000', 'consum', 0.0210, 'lps'),
	(581328, 128, '2014-03-15 00:50:54.000000', 'consum', 0.0214, 'lps'),
	(581329, 128, '2014-03-15 00:50:55.000000', 'consum', 0.0212, 'lps'),
	(581330, 128, '2014-03-15 00:50:56.000000', 'consum', 0.0219, 'lps'),
	(581331, 128, '2014-03-15 00:50:57.000000', 'consum', 0.0216, 'lps'),
	(581332, 128, '2014-03-15 00:50:58.000000', 'consum', 0.0215, 'lps'),
	(581333, 128, '2014-03-15 00:50:59.000000', 'consum', 0.0217, 'lps'),
	(581334, 128, '2014-03-15 00:51:00.000000', 'consum', 0.0210, 'lps'),
	(581335, 128, '2014-03-15 00:51:01.000000', 'consum', 0.0219, 'lps'),
	(581336, 128, '2014-03-15 00:51:02.000000', 'consum', 0.0214, 'lps'),
	(581337, 128, '2014-03-15 00:51:03.000000', 'consum', 0.0213, 'lps'),
	(581338, 128, '2014-03-15 00:51:04.000000', 'consum', 0.0212, 'lps'),
	(581339, 128, '2014-03-15 00:51:05.000000', 'consum', 0.0215, 'lps'),
	(581340, 128, '2014-03-15 00:51:06.000000', 'consum', 0.0215, 'lps'),
	(581341, 128, '2014-03-15 00:51:07.000000', 'consum', 0.0212, 'lps'),
	(581342, 128, '2014-03-15 00:51:08.000000', 'consum', 0.0218, 'lps'),
	(581343, 128, '2014-03-15 00:51:09.000000', 'consum', 0.0220, 'lps'),
	(581344, 128, '2014-03-15 00:51:10.000000', 'consum', 0.0217, 'lps'),
	(581345, 128, '2014-03-15 00:51:11.000000', 'consum', 0.0213, 'lps'),
	(581346, 128, '2014-03-15 00:51:12.000000', 'consum', 0.0218, 'lps'),
	(581347, 128, '2014-03-15 00:51:13.000000', 'consum', 0.0219, 'lps'),
	(581348, 128, '2014-03-15 00:51:14.000000', 'consum', 0.0210, 'lps'),
	(581349, 128, '2014-03-15 00:51:15.000000', 'consum', 0.0216, 'lps'),
	(581350, 128, '2014-03-15 00:51:16.000000', 'consum', 0.0217, 'lps'),
	(581351, 128, '2014-03-15 00:51:17.000000', 'consum', 0.0220, 'lps'),
	(581352, 128, '2014-03-15 00:51:18.000000', 'consum', 0.0214, 'lps'),
	(581353, 128, '2014-03-15 00:51:19.000000', 'consum', 0.0211, 'lps'),
	(581354, 128, '2014-03-15 00:51:20.000000', 'consum', 0.0216, 'lps'),
	(581355, 128, '2014-03-15 00:51:21.000000', 'consum', 0.0213, 'lps'),
	(581356, 128, '2014-03-15 00:51:22.000000', 'consum', 0.0210, 'lps'),
	(581357, 128, '2014-03-15 00:51:23.000000', 'consum', 0.0213, 'lps'),
	(581358, 128, '2014-03-15 00:51:24.000000', 'consum', 0.0212, 'lps'),
	(581359, 128, '2014-03-15 00:51:25.000000', 'consum', 0.0212, 'lps'),
	(581360, 128, '2014-03-15 00:51:26.000000', 'consum', 0.0216, 'lps'),
	(581361, 128, '2014-03-15 00:51:27.000000', 'consum', 0.0211, 'lps'),
	(581362, 128, '2014-03-15 00:51:28.000000', 'consum', 0.0219, 'lps'),
	(581363, 128, '2014-03-15 00:51:29.000000', 'consum', 0.0218, 'lps'),
	(581364, 128, '2014-03-15 00:51:30.000000', 'consum', 0.0215, 'lps'),
	(581365, 128, '2014-03-15 00:51:31.000000', 'consum', 0.0210, 'lps'),
	(581366, 128, '2014-03-15 00:51:32.000000', 'consum', 0.0218, 'lps'),
	(581367, 128, '2014-03-15 00:51:33.000000', 'consum', 0.0219, 'lps'),
	(581368, 128, '2014-03-15 00:51:34.000000', 'consum', 0.0218, 'lps'),
	(581369, 128, '2014-03-15 00:51:35.000000', 'consum', 0.0215, 'lps'),
	(581370, 128, '2014-03-15 00:51:36.000000', 'consum', 0.0212, 'lps'),
	(581371, 128, '2014-03-15 00:51:37.000000', 'consum', 0.0217, 'lps'),
	(581372, 128, '2014-03-15 00:51:38.000000', 'consum', 0.0218, 'lps'),
	(581373, 128, '2014-03-15 00:51:39.000000', 'consum', 0.0216, 'lps'),
	(581374, 128, '2014-03-15 00:51:40.000000', 'consum', 0.0216, 'lps'),
	(581375, 128, '2014-03-15 00:51:41.000000', 'consum', 0.0214, 'lps'),
	(581376, 128, '2014-03-15 00:51:42.000000', 'consum', 0.0211, 'lps'),
	(581377, 128, '2014-03-15 00:51:43.000000', 'consum', 0.0213, 'lps'),
	(581378, 128, '2014-03-15 00:51:44.000000', 'consum', 0.0214, 'lps'),
	(581379, 128, '2014-03-15 00:51:45.000000', 'consum', 0.0210, 'lps'),
	(581380, 128, '2014-03-15 00:51:46.000000', 'consum', 0.0210, 'lps'),
	(581381, 128, '2014-03-15 00:51:47.000000', 'consum', 0.0210, 'lps'),
	(581382, 128, '2014-03-15 00:51:48.000000', 'consum', 0.0220, 'lps'),
	(581383, 128, '2014-03-15 00:51:49.000000', 'consum', 0.0217, 'lps'),
	(581384, 128, '2014-03-15 00:51:50.000000', 'consum', 0.0217, 'lps'),
	(581385, 128, '2014-03-15 00:51:51.000000', 'consum', 0.0212, 'lps'),
	(581386, 128, '2014-03-15 00:51:52.000000', 'consum', 0.0211, 'lps'),
	(581387, 128, '2014-03-15 00:51:53.000000', 'consum', 0.0211, 'lps'),
	(581388, 128, '2014-03-15 00:51:54.000000', 'consum', 0.0210, 'lps'),
	(581389, 128, '2014-03-15 00:51:55.000000', 'consum', 0.0210, 'lps'),
	(581390, 128, '2014-03-15 00:51:56.000000', 'consum', 0.0220, 'lps'),
	(581391, 128, '2014-03-15 00:51:57.000000', 'consum', 0.0217, 'lps'),
	(581392, 128, '2014-03-15 00:51:58.000000', 'consum', 0.0216, 'lps'),
	(581393, 128, '2014-03-15 00:51:59.000000', 'consum', 0.0219, 'lps'),
	(581394, 128, '2014-03-15 00:52:00.000000', 'consum', 0.0216, 'lps'),
	(581395, 128, '2014-03-15 00:52:01.000000', 'consum', 0.0214, 'lps'),
	(581396, 128, '2014-03-15 00:52:02.000000', 'consum', 0.0212, 'lps'),
	(581397, 128, '2014-03-15 00:52:03.000000', 'consum', 0.0219, 'lps'),
	(581398, 128, '2014-03-15 00:52:04.000000', 'consum', 0.0215, 'lps'),
	(581399, 128, '2014-03-15 00:52:05.000000', 'consum', 0.0211, 'lps'),
	(581400, 128, '2014-03-15 00:52:06.000000', 'consum', 0.0210, 'lps'),
	(581401, 128, '2014-03-15 00:52:07.000000', 'consum', 0.0210, 'lps'),
	(581402, 128, '2014-03-15 00:52:08.000000', 'consum', 0.0219, 'lps'),
	(581403, 128, '2014-03-15 00:52:09.000000', 'consum', 0.0214, 'lps'),
	(581404, 128, '2014-03-15 00:52:10.000000', 'consum', 0.0213, 'lps'),
	(581405, 128, '2014-03-15 00:52:11.000000', 'consum', 0.0214, 'lps'),
	(581406, 128, '2014-03-15 00:52:12.000000', 'consum', 0.0212, 'lps'),
	(581407, 128, '2014-03-15 00:52:13.000000', 'consum', 0.0218, 'lps'),
	(581408, 128, '2014-03-15 00:52:14.000000', 'consum', 0.0210, 'lps'),
	(581409, 128, '2014-03-15 00:52:15.000000', 'consum', 0.0210, 'lps'),
	(581410, 128, '2014-03-15 00:52:16.000000', 'consum', 0.0212, 'lps'),
	(581411, 128, '2014-03-15 00:52:17.000000', 'consum', 0.0210, 'lps'),
	(581412, 128, '2014-03-15 00:52:18.000000', 'consum', 0.0213, 'lps'),
	(581413, 128, '2014-03-15 00:52:19.000000', 'consum', 0.0217, 'lps'),
	(581414, 128, '2014-03-15 00:52:20.000000', 'consum', 0.0215, 'lps'),
	(581415, 128, '2014-03-15 00:52:21.000000', 'consum', 0.0215, 'lps'),
	(581416, 128, '2014-03-15 00:52:22.000000', 'consum', 0.0219, 'lps'),
	(581417, 128, '2014-03-15 00:52:23.000000', 'consum', 0.0220, 'lps'),
	(581418, 128, '2014-03-15 00:52:24.000000', 'consum', 0.0211, 'lps'),
	(581419, 128, '2014-03-15 00:52:25.000000', 'consum', 0.0220, 'lps'),
	(581420, 128, '2014-03-15 00:52:26.000000', 'consum', 0.0211, 'lps'),
	(581421, 128, '2014-03-15 00:52:27.000000', 'consum', 0.0220, 'lps'),
	(581422, 128, '2014-03-15 00:52:28.000000', 'consum', 0.0212, 'lps'),
	(581423, 128, '2014-03-15 00:52:29.000000', 'consum', 0.0215, 'lps'),
	(581424, 128, '2014-03-15 00:52:30.000000', 'consum', 0.0219, 'lps'),
	(581425, 128, '2014-03-15 00:52:31.000000', 'consum', 0.0217, 'lps'),
	(581426, 128, '2014-03-15 00:52:32.000000', 'consum', 0.0218, 'lps'),
	(581427, 128, '2014-03-15 00:52:33.000000', 'consum', 0.0210, 'lps'),
	(581428, 128, '2014-03-15 00:52:34.000000', 'consum', 0.0216, 'lps'),
	(581429, 128, '2014-03-15 00:52:35.000000', 'consum', 0.0220, 'lps'),
	(581430, 128, '2014-03-15 00:52:36.000000', 'consum', 0.0212, 'lps'),
	(581431, 128, '2014-03-15 00:52:37.000000', 'consum', 0.0220, 'lps'),
	(581432, 128, '2014-03-15 00:52:38.000000', 'consum', 0.0212, 'lps'),
	(581433, 128, '2014-03-15 00:52:39.000000', 'consum', 0.0213, 'lps'),
	(581434, 128, '2014-03-15 00:52:40.000000', 'consum', 0.0217, 'lps'),
	(581435, 128, '2014-03-15 00:52:41.000000', 'consum', 0.0218, 'lps'),
	(581436, 128, '2014-03-15 00:52:42.000000', 'consum', 0.0217, 'lps'),
	(581437, 128, '2014-03-15 00:52:43.000000', 'consum', 0.0220, 'lps'),
	(581438, 128, '2014-03-15 00:52:44.000000', 'consum', 0.0218, 'lps'),
	(581439, 128, '2014-03-15 00:52:45.000000', 'consum', 0.0219, 'lps'),
	(581440, 128, '2014-03-15 00:52:46.000000', 'consum', 0.0211, 'lps'),
	(581441, 128, '2014-03-15 00:52:47.000000', 'consum', 0.0220, 'lps'),
	(581442, 128, '2014-03-15 00:52:48.000000', 'consum', 0.0215, 'lps'),
	(581443, 128, '2014-03-15 00:52:49.000000', 'consum', 0.0215, 'lps'),
	(581444, 128, '2014-03-15 00:52:50.000000', 'consum', 0.0220, 'lps'),
	(581445, 128, '2014-03-15 00:52:51.000000', 'consum', 0.0212, 'lps'),
	(581446, 128, '2014-03-15 00:52:52.000000', 'consum', 0.0214, 'lps'),
	(581447, 128, '2014-03-15 00:52:53.000000', 'consum', 0.0213, 'lps'),
	(581448, 128, '2014-03-15 00:52:54.000000', 'consum', 0.0215, 'lps'),
	(581449, 128, '2014-03-15 00:52:55.000000', 'consum', 0.0216, 'lps'),
	(581450, 128, '2014-03-15 00:52:56.000000', 'consum', 0.0215, 'lps'),
	(581451, 128, '2014-03-15 00:52:57.000000', 'consum', 0.0218, 'lps'),
	(581452, 128, '2014-03-15 00:52:58.000000', 'consum', 0.0213, 'lps'),
	(581453, 128, '2014-03-15 00:52:59.000000', 'consum', 0.0214, 'lps'),
	(581454, 128, '2014-03-15 00:53:00.000000', 'consum', 0.0219, 'lps'),
	(581455, 128, '2014-03-15 00:53:01.000000', 'consum', 0.0211, 'lps'),
	(581456, 128, '2014-03-15 00:53:02.000000', 'consum', 0.0211, 'lps'),
	(581457, 128, '2014-03-15 00:53:03.000000', 'consum', 0.0214, 'lps'),
	(581458, 128, '2014-03-15 00:53:04.000000', 'consum', 0.0214, 'lps'),
	(581459, 128, '2014-03-15 00:53:05.000000', 'consum', 0.0217, 'lps'),
	(581460, 128, '2014-03-15 00:53:06.000000', 'consum', 0.0215, 'lps'),
	(581461, 128, '2014-03-15 00:53:07.000000', 'consum', 0.0214, 'lps'),
	(581462, 128, '2014-03-15 00:53:08.000000', 'consum', 0.0217, 'lps'),
	(581463, 128, '2014-03-15 00:53:09.000000', 'consum', 0.0211, 'lps'),
	(581464, 128, '2014-03-15 00:53:10.000000', 'consum', 0.0214, 'lps'),
	(581465, 128, '2014-03-15 00:53:11.000000', 'consum', 0.0218, 'lps'),
	(581466, 128, '2014-03-15 00:53:12.000000', 'consum', 0.0216, 'lps'),
	(581467, 128, '2014-03-15 00:53:13.000000', 'consum', 0.0216, 'lps'),
	(581468, 128, '2014-03-15 00:53:14.000000', 'consum', 0.0212, 'lps'),
	(581469, 128, '2014-03-15 00:53:15.000000', 'consum', 0.0215, 'lps'),
	(581470, 128, '2014-03-15 00:53:16.000000', 'consum', 0.0219, 'lps'),
	(581471, 128, '2014-03-15 00:53:17.000000', 'consum', 0.0219, 'lps'),
	(581472, 128, '2014-03-15 00:53:18.000000', 'consum', 0.0217, 'lps'),
	(581473, 128, '2014-03-15 00:53:19.000000', 'consum', 0.0216, 'lps'),
	(581474, 128, '2014-03-15 00:53:20.000000', 'consum', 0.0212, 'lps'),
	(581475, 128, '2014-03-15 00:53:21.000000', 'consum', 0.0210, 'lps'),
	(581476, 128, '2014-03-15 00:53:22.000000', 'consum', 0.0218, 'lps'),
	(581477, 128, '2014-03-15 00:53:23.000000', 'consum', 0.0217, 'lps'),
	(581478, 128, '2014-03-15 00:53:24.000000', 'consum', 0.0210, 'lps'),
	(581479, 128, '2014-03-15 00:53:25.000000', 'consum', 0.0214, 'lps'),
	(581480, 128, '2014-03-15 00:53:26.000000', 'consum', 0.0216, 'lps'),
	(581481, 128, '2014-03-15 00:53:27.000000', 'consum', 0.0220, 'lps'),
	(581482, 128, '2014-03-15 00:53:28.000000', 'consum', 0.0220, 'lps'),
	(581483, 128, '2014-03-15 00:53:29.000000', 'consum', 0.0210, 'lps'),
	(581484, 128, '2014-03-15 00:53:30.000000', 'consum', 0.0212, 'lps'),
	(581485, 128, '2014-03-15 00:53:31.000000', 'consum', 0.0211, 'lps'),
	(581486, 128, '2014-03-15 00:53:32.000000', 'consum', 0.0220, 'lps'),
	(581487, 128, '2014-03-15 00:53:33.000000', 'consum', 0.0214, 'lps'),
	(581488, 128, '2014-03-15 00:53:34.000000', 'consum', 0.0211, 'lps'),
	(581489, 128, '2014-03-15 00:53:35.000000', 'consum', 0.0213, 'lps'),
	(581490, 128, '2014-03-15 00:53:36.000000', 'consum', 0.0214, 'lps'),
	(581491, 128, '2014-03-15 00:53:37.000000', 'consum', 0.0219, 'lps'),
	(581492, 128, '2014-03-15 00:53:38.000000', 'consum', 0.0212, 'lps'),
	(581493, 128, '2014-03-15 00:53:39.000000', 'consum', 0.0216, 'lps'),
	(581494, 128, '2014-03-15 00:53:40.000000', 'consum', 0.0213, 'lps'),
	(581495, 128, '2014-03-15 00:53:41.000000', 'consum', 0.0217, 'lps'),
	(581496, 128, '2014-03-15 00:53:42.000000', 'consum', 0.0217, 'lps'),
	(581497, 128, '2014-03-15 00:53:43.000000', 'consum', 0.0211, 'lps'),
	(581498, 128, '2014-03-15 00:53:44.000000', 'consum', 0.0218, 'lps'),
	(581499, 128, '2014-03-15 00:53:45.000000', 'consum', 0.0212, 'lps'),
	(581500, 128, '2014-03-15 00:53:46.000000', 'consum', 0.0220, 'lps'),
	(581501, 128, '2014-03-15 00:53:47.000000', 'consum', 0.0210, 'lps'),
	(581502, 128, '2014-03-15 00:53:48.000000', 'consum', 0.0212, 'lps'),
	(581503, 128, '2014-03-15 00:53:49.000000', 'consum', 0.0211, 'lps'),
	(581504, 128, '2014-03-15 00:53:50.000000', 'consum', 0.0210, 'lps'),
	(581505, 128, '2014-03-15 00:53:51.000000', 'consum', 0.0217, 'lps'),
	(581506, 128, '2014-03-15 00:53:52.000000', 'consum', 0.0213, 'lps'),
	(581507, 128, '2014-03-15 00:53:53.000000', 'consum', 0.0216, 'lps'),
	(581508, 128, '2014-03-15 00:53:54.000000', 'consum', 0.0219, 'lps'),
	(581509, 128, '2014-03-15 00:53:55.000000', 'consum', 0.0215, 'lps'),
	(581510, 128, '2014-03-15 00:53:56.000000', 'consum', 0.0220, 'lps'),
	(581511, 128, '2014-03-15 00:53:57.000000', 'consum', 0.0211, 'lps'),
	(581512, 128, '2014-03-15 00:53:58.000000', 'consum', 0.0211, 'lps'),
	(581513, 128, '2014-03-15 00:53:59.000000', 'consum', 0.0211, 'lps'),
	(581514, 128, '2014-03-15 00:54:00.000000', 'consum', 0.0211, 'lps'),
	(581515, 128, '2014-03-15 00:54:01.000000', 'consum', 0.0212, 'lps'),
	(581516, 128, '2014-03-15 00:54:02.000000', 'consum', 0.0220, 'lps'),
	(581517, 128, '2014-03-15 00:54:03.000000', 'consum', 0.0210, 'lps'),
	(581518, 128, '2014-03-15 00:54:04.000000', 'consum', 0.0215, 'lps'),
	(581519, 128, '2014-03-15 00:54:05.000000', 'consum', 0.0211, 'lps'),
	(581520, 128, '2014-03-15 00:54:06.000000', 'consum', 0.0213, 'lps'),
	(581521, 128, '2014-03-15 00:54:07.000000', 'consum', 0.0220, 'lps'),
	(581522, 128, '2014-03-15 00:54:08.000000', 'consum', 0.0210, 'lps'),
	(581523, 128, '2014-03-15 00:54:09.000000', 'consum', 0.0214, 'lps'),
	(581524, 128, '2014-03-15 00:54:10.000000', 'consum', 0.0218, 'lps'),
	(581525, 128, '2014-03-15 00:54:11.000000', 'consum', 0.0216, 'lps'),
	(581526, 128, '2014-03-15 00:54:12.000000', 'consum', 0.0216, 'lps'),
	(581527, 128, '2014-03-15 00:54:13.000000', 'consum', 0.0211, 'lps'),
	(581528, 128, '2014-03-15 00:54:14.000000', 'consum', 0.0220, 'lps'),
	(581529, 128, '2014-03-15 00:54:15.000000', 'consum', 0.0214, 'lps'),
	(581530, 128, '2014-03-15 00:54:16.000000', 'consum', 0.0210, 'lps'),
	(581531, 128, '2014-03-15 00:54:17.000000', 'consum', 0.0220, 'lps'),
	(581532, 128, '2014-03-15 00:54:18.000000', 'consum', 0.0216, 'lps'),
	(581533, 128, '2014-03-15 00:54:19.000000', 'consum', 0.0211, 'lps'),
	(581534, 128, '2014-03-15 00:54:20.000000', 'consum', 0.0219, 'lps'),
	(581535, 128, '2014-03-15 00:54:21.000000', 'consum', 0.0220, 'lps'),
	(581536, 128, '2014-03-15 00:54:22.000000', 'consum', 0.0211, 'lps'),
	(581537, 128, '2014-03-15 00:54:23.000000', 'consum', 0.0219, 'lps'),
	(581538, 128, '2014-03-15 00:54:24.000000', 'consum', 0.0210, 'lps'),
	(581539, 128, '2014-03-15 00:54:25.000000', 'consum', 0.0217, 'lps'),
	(581540, 128, '2014-03-15 00:54:26.000000', 'consum', 0.0212, 'lps'),
	(581541, 128, '2014-03-15 00:54:27.000000', 'consum', 0.0219, 'lps'),
	(581542, 128, '2014-03-15 00:54:28.000000', 'consum', 0.0218, 'lps'),
	(581543, 128, '2014-03-15 00:54:29.000000', 'consum', 0.0214, 'lps'),
	(581544, 128, '2014-03-15 00:54:30.000000', 'consum', 0.0215, 'lps'),
	(581545, 128, '2014-03-15 00:54:31.000000', 'consum', 0.0214, 'lps'),
	(581546, 128, '2014-03-15 00:54:32.000000', 'consum', 0.0216, 'lps'),
	(581547, 128, '2014-03-15 00:54:33.000000', 'consum', 0.0217, 'lps'),
	(581548, 128, '2014-03-15 00:54:34.000000', 'consum', 0.0218, 'lps'),
	(581549, 128, '2014-03-15 00:54:35.000000', 'consum', 0.0216, 'lps'),
	(581550, 128, '2014-03-15 00:54:36.000000', 'consum', 0.0217, 'lps'),
	(581551, 128, '2014-03-15 00:54:37.000000', 'consum', 0.0215, 'lps'),
	(581552, 128, '2014-03-15 00:54:38.000000', 'consum', 0.0218, 'lps'),
	(581553, 128, '2014-03-15 00:54:39.000000', 'consum', 0.0210, 'lps'),
	(581554, 128, '2014-03-15 00:54:40.000000', 'consum', 0.0220, 'lps'),
	(581555, 128, '2014-03-15 00:54:41.000000', 'consum', 0.0218, 'lps'),
	(581556, 128, '2014-03-15 00:54:42.000000', 'consum', 0.0210, 'lps'),
	(581557, 128, '2014-03-15 00:54:43.000000', 'consum', 0.0220, 'lps'),
	(581558, 128, '2014-03-15 00:54:44.000000', 'consum', 0.0217, 'lps'),
	(581559, 128, '2014-03-15 00:54:45.000000', 'consum', 0.0214, 'lps'),
	(581560, 128, '2014-03-15 00:54:46.000000', 'consum', 0.0219, 'lps'),
	(581561, 128, '2014-03-15 00:54:47.000000', 'consum', 0.0212, 'lps'),
	(581562, 128, '2014-03-15 00:54:48.000000', 'consum', 0.0217, 'lps'),
	(581563, 128, '2014-03-15 00:54:49.000000', 'consum', 0.0216, 'lps'),
	(581564, 128, '2014-03-15 00:54:50.000000', 'consum', 0.0220, 'lps'),
	(581565, 128, '2014-03-15 00:54:51.000000', 'consum', 0.0211, 'lps'),
	(581566, 128, '2014-03-15 00:54:52.000000', 'consum', 0.0219, 'lps'),
	(581567, 128, '2014-03-15 00:54:53.000000', 'consum', 0.0217, 'lps'),
	(581568, 128, '2014-03-15 00:54:54.000000', 'consum', 0.0220, 'lps'),
	(581569, 128, '2014-03-15 00:54:55.000000', 'consum', 0.0218, 'lps'),
	(581570, 128, '2014-03-15 00:54:56.000000', 'consum', 0.0210, 'lps'),
	(581571, 128, '2014-03-15 00:54:57.000000', 'consum', 0.0220, 'lps'),
	(581572, 128, '2014-03-15 00:54:58.000000', 'consum', 0.0215, 'lps'),
	(581573, 128, '2014-03-15 00:54:59.000000', 'consum', 0.0215, 'lps'),
	(581574, 128, '2014-03-15 00:55:00.000000', 'consum', 0.0211, 'lps'),
	(581575, 128, '2014-03-15 00:55:01.000000', 'consum', 0.0213, 'lps'),
	(581576, 128, '2014-03-15 00:55:02.000000', 'consum', 0.0211, 'lps'),
	(581577, 128, '2014-03-15 00:55:03.000000', 'consum', 0.0215, 'lps'),
	(581578, 128, '2014-03-15 00:55:04.000000', 'consum', 0.0213, 'lps'),
	(581579, 128, '2014-03-15 00:55:05.000000', 'consum', 0.0220, 'lps'),
	(581580, 128, '2014-03-15 00:55:06.000000', 'consum', 0.0210, 'lps'),
	(581581, 128, '2014-03-15 00:55:07.000000', 'consum', 0.0212, 'lps'),
	(581582, 128, '2014-03-15 00:55:08.000000', 'consum', 0.0211, 'lps'),
	(581583, 128, '2014-03-15 00:55:09.000000', 'consum', 0.0220, 'lps'),
	(581584, 128, '2014-03-15 00:55:10.000000', 'consum', 0.0212, 'lps'),
	(581585, 128, '2014-03-15 00:55:11.000000', 'consum', 0.0215, 'lps'),
	(581586, 128, '2014-03-15 00:55:12.000000', 'consum', 0.0218, 'lps'),
	(581587, 128, '2014-03-15 00:55:13.000000', 'consum', 0.0212, 'lps'),
	(581588, 128, '2014-03-15 00:55:14.000000', 'consum', 0.0210, 'lps'),
	(581589, 128, '2014-03-15 00:55:15.000000', 'consum', 0.0215, 'lps'),
	(581590, 128, '2014-03-15 00:55:16.000000', 'consum', 0.0214, 'lps'),
	(581591, 128, '2014-03-15 00:55:17.000000', 'consum', 0.0215, 'lps'),
	(581592, 128, '2014-03-15 00:55:18.000000', 'consum', 0.0213, 'lps'),
	(581593, 128, '2014-03-15 00:55:19.000000', 'consum', 0.0211, 'lps'),
	(581594, 128, '2014-03-15 00:55:20.000000', 'consum', 0.0217, 'lps'),
	(581595, 128, '2014-03-15 00:55:21.000000', 'consum', 0.0218, 'lps'),
	(581596, 128, '2014-03-15 00:55:22.000000', 'consum', 0.0211, 'lps'),
	(581597, 128, '2014-03-15 00:55:23.000000', 'consum', 0.0211, 'lps'),
	(581598, 128, '2014-03-15 00:55:24.000000', 'consum', 0.0212, 'lps'),
	(581599, 128, '2014-03-15 00:55:25.000000', 'consum', 0.0217, 'lps'),
	(581600, 128, '2014-03-15 00:55:26.000000', 'consum', 0.0220, 'lps'),
	(581601, 128, '2014-03-15 00:55:27.000000', 'consum', 0.0216, 'lps'),
	(581602, 128, '2014-03-15 00:55:28.000000', 'consum', 0.0212, 'lps'),
	(581603, 128, '2014-03-15 00:55:29.000000', 'consum', 0.0211, 'lps'),
	(581604, 128, '2014-03-15 00:55:30.000000', 'consum', 0.0210, 'lps'),
	(581605, 128, '2014-03-15 00:55:31.000000', 'consum', 0.0220, 'lps'),
	(581606, 128, '2014-03-15 00:55:32.000000', 'consum', 0.0215, 'lps'),
	(581607, 128, '2014-03-15 00:55:33.000000', 'consum', 0.0217, 'lps'),
	(581608, 128, '2014-03-15 00:55:34.000000', 'consum', 0.0220, 'lps'),
	(581609, 128, '2014-03-15 00:55:35.000000', 'consum', 0.0216, 'lps'),
	(581610, 128, '2014-03-15 00:55:36.000000', 'consum', 0.0212, 'lps'),
	(581611, 128, '2014-03-15 00:55:37.000000', 'consum', 0.0212, 'lps'),
	(581612, 128, '2014-03-15 00:55:38.000000', 'consum', 0.0216, 'lps'),
	(581613, 128, '2014-03-15 00:55:39.000000', 'consum', 0.0212, 'lps'),
	(581614, 128, '2014-03-15 00:55:40.000000', 'consum', 0.0213, 'lps'),
	(581615, 128, '2014-03-15 00:55:41.000000', 'consum', 0.0210, 'lps'),
	(581616, 128, '2014-03-15 00:55:42.000000', 'consum', 0.0212, 'lps'),
	(581617, 128, '2014-03-15 00:55:43.000000', 'consum', 0.0220, 'lps'),
	(581618, 128, '2014-03-15 00:55:44.000000', 'consum', 0.0210, 'lps'),
	(581619, 128, '2014-03-15 00:55:45.000000', 'consum', 0.0216, 'lps'),
	(581620, 128, '2014-03-15 00:55:46.000000', 'consum', 0.0217, 'lps'),
	(581621, 128, '2014-03-15 00:55:47.000000', 'consum', 0.0215, 'lps'),
	(581622, 128, '2014-03-15 00:55:48.000000', 'consum', 0.0214, 'lps'),
	(581623, 128, '2014-03-15 00:55:49.000000', 'consum', 0.0217, 'lps'),
	(581624, 128, '2014-03-15 00:55:50.000000', 'consum', 0.0211, 'lps'),
	(581625, 128, '2014-03-15 00:55:51.000000', 'consum', 0.0216, 'lps'),
	(581626, 128, '2014-03-15 00:55:52.000000', 'consum', 0.0217, 'lps'),
	(581627, 128, '2014-03-15 00:55:53.000000', 'consum', 0.0216, 'lps'),
	(581628, 128, '2014-03-15 00:55:54.000000', 'consum', 0.0210, 'lps'),
	(581629, 128, '2014-03-15 00:55:55.000000', 'consum', 0.0213, 'lps'),
	(581630, 128, '2014-03-15 00:55:56.000000', 'consum', 0.0214, 'lps'),
	(581631, 128, '2014-03-15 00:55:57.000000', 'consum', 0.0213, 'lps'),
	(581632, 128, '2014-03-15 00:55:58.000000', 'consum', 0.0210, 'lps'),
	(581633, 128, '2014-03-15 00:55:59.000000', 'consum', 0.0216, 'lps'),
	(581634, 128, '2014-03-15 00:56:00.000000', 'consum', 0.0215, 'lps'),
	(581635, 128, '2014-03-15 00:56:01.000000', 'consum', 0.0220, 'lps'),
	(581636, 128, '2014-03-15 00:56:02.000000', 'consum', 0.0214, 'lps'),
	(581637, 128, '2014-03-15 00:56:03.000000', 'consum', 0.0219, 'lps'),
	(581638, 128, '2014-03-15 00:56:04.000000', 'consum', 0.0213, 'lps'),
	(581639, 128, '2014-03-15 00:56:05.000000', 'consum', 0.0219, 'lps'),
	(581640, 128, '2014-03-15 00:56:06.000000', 'consum', 0.0214, 'lps'),
	(581641, 128, '2014-03-15 00:56:07.000000', 'consum', 0.0216, 'lps'),
	(581642, 128, '2014-03-15 00:56:08.000000', 'consum', 0.0218, 'lps'),
	(581643, 128, '2014-03-15 00:56:09.000000', 'consum', 0.0218, 'lps'),
	(581644, 128, '2014-03-15 00:56:10.000000', 'consum', 0.0219, 'lps'),
	(581645, 128, '2014-03-15 00:56:11.000000', 'consum', 0.0218, 'lps'),
	(581646, 128, '2014-03-15 00:56:12.000000', 'consum', 0.0213, 'lps'),
	(581647, 128, '2014-03-15 00:56:13.000000', 'consum', 0.0212, 'lps'),
	(581648, 128, '2014-03-15 00:56:14.000000', 'consum', 0.0212, 'lps'),
	(581649, 128, '2014-03-15 00:56:15.000000', 'consum', 0.0215, 'lps'),
	(581650, 128, '2014-03-15 00:56:16.000000', 'consum', 0.0216, 'lps'),
	(581651, 128, '2014-03-15 00:56:17.000000', 'consum', 0.0217, 'lps'),
	(581652, 128, '2014-03-15 00:56:18.000000', 'consum', 0.0217, 'lps'),
	(581653, 128, '2014-03-15 00:56:19.000000', 'consum', 0.0211, 'lps'),
	(581654, 128, '2014-03-15 00:56:20.000000', 'consum', 0.0216, 'lps'),
	(581655, 128, '2014-03-15 00:56:21.000000', 'consum', 0.0216, 'lps'),
	(581656, 128, '2014-03-15 00:56:22.000000', 'consum', 0.0214, 'lps'),
	(581657, 128, '2014-03-15 00:56:23.000000', 'consum', 0.0210, 'lps'),
	(581658, 128, '2014-03-15 00:56:24.000000', 'consum', 0.0219, 'lps'),
	(581659, 128, '2014-03-15 00:56:25.000000', 'consum', 0.0215, 'lps'),
	(581660, 128, '2014-03-15 00:56:26.000000', 'consum', 0.0218, 'lps'),
	(581661, 128, '2014-03-15 00:56:27.000000', 'consum', 0.0215, 'lps'),
	(581662, 128, '2014-03-15 00:56:28.000000', 'consum', 0.0212, 'lps'),
	(581663, 128, '2014-03-15 00:56:29.000000', 'consum', 0.0215, 'lps'),
	(581664, 128, '2014-03-15 00:56:30.000000', 'consum', 0.0217, 'lps'),
	(581665, 128, '2014-03-15 00:56:31.000000', 'consum', 0.0210, 'lps'),
	(581666, 128, '2014-03-15 00:56:32.000000', 'consum', 0.0213, 'lps'),
	(581667, 128, '2014-03-15 00:56:33.000000', 'consum', 0.0212, 'lps'),
	(581668, 128, '2014-03-15 00:56:34.000000', 'consum', 0.0213, 'lps'),
	(581669, 128, '2014-03-15 00:56:35.000000', 'consum', 0.0210, 'lps'),
	(581670, 128, '2014-03-15 00:56:36.000000', 'consum', 0.0211, 'lps'),
	(581671, 128, '2014-03-15 00:56:37.000000', 'consum', 0.0215, 'lps'),
	(581672, 128, '2014-03-15 00:56:38.000000', 'consum', 0.0211, 'lps'),
	(581673, 128, '2014-03-15 00:56:39.000000', 'consum', 0.0211, 'lps'),
	(581674, 128, '2014-03-15 00:56:40.000000', 'consum', 0.0211, 'lps'),
	(581675, 128, '2014-03-15 00:56:41.000000', 'consum', 0.0212, 'lps'),
	(581676, 128, '2014-03-15 00:56:42.000000', 'consum', 0.0210, 'lps'),
	(581677, 128, '2014-03-15 00:56:43.000000', 'consum', 0.0212, 'lps'),
	(581678, 128, '2014-03-15 00:56:44.000000', 'consum', 0.0210, 'lps'),
	(581679, 128, '2014-03-15 00:56:45.000000', 'consum', 0.0216, 'lps'),
	(581680, 128, '2014-03-15 00:56:46.000000', 'consum', 0.0217, 'lps'),
	(581681, 128, '2014-03-15 00:56:47.000000', 'consum', 0.0216, 'lps'),
	(581682, 128, '2014-03-15 00:56:48.000000', 'consum', 0.0220, 'lps'),
	(581683, 128, '2014-03-15 00:56:49.000000', 'consum', 0.0212, 'lps'),
	(581684, 128, '2014-03-15 00:56:50.000000', 'consum', 0.0210, 'lps'),
	(581685, 128, '2014-03-15 00:56:51.000000', 'consum', 0.0214, 'lps'),
	(581686, 128, '2014-03-15 00:56:52.000000', 'consum', 0.0212, 'lps'),
	(581687, 128, '2014-03-15 00:56:53.000000', 'consum', 0.0217, 'lps'),
	(581688, 128, '2014-03-15 00:56:54.000000', 'consum', 0.0217, 'lps'),
	(581689, 128, '2014-03-15 00:56:55.000000', 'consum', 0.0215, 'lps'),
	(581690, 128, '2014-03-15 00:56:56.000000', 'consum', 0.0213, 'lps'),
	(581691, 128, '2014-03-15 00:56:57.000000', 'consum', 0.0212, 'lps'),
	(581692, 128, '2014-03-15 00:56:58.000000', 'consum', 0.0212, 'lps'),
	(581693, 128, '2014-03-15 00:56:59.000000', 'consum', 0.0214, 'lps'),
	(581694, 128, '2014-03-15 00:57:00.000000', 'consum', 0.0213, 'lps'),
	(581695, 128, '2014-03-15 00:57:01.000000', 'consum', 0.0215, 'lps'),
	(581696, 128, '2014-03-15 00:57:02.000000', 'consum', 0.0216, 'lps'),
	(581697, 128, '2014-03-15 00:57:03.000000', 'consum', 0.0214, 'lps'),
	(581698, 128, '2014-03-15 00:57:04.000000', 'consum', 0.0212, 'lps'),
	(581699, 128, '2014-03-15 00:57:05.000000', 'consum', 0.0219, 'lps'),
	(581700, 128, '2014-03-15 00:57:06.000000', 'consum', 0.0218, 'lps'),
	(581701, 128, '2014-03-15 00:57:07.000000', 'consum', 0.0211, 'lps'),
	(581702, 128, '2014-03-15 00:57:08.000000', 'consum', 0.0215, 'lps'),
	(581703, 128, '2014-03-15 00:57:09.000000', 'consum', 0.0210, 'lps'),
	(581704, 128, '2014-03-15 00:57:10.000000', 'consum', 0.0219, 'lps'),
	(581705, 128, '2014-03-15 00:57:11.000000', 'consum', 0.0210, 'lps'),
	(581706, 128, '2014-03-15 00:57:12.000000', 'consum', 0.0215, 'lps'),
	(581707, 128, '2014-03-15 00:57:13.000000', 'consum', 0.0213, 'lps'),
	(581708, 128, '2014-03-15 00:57:14.000000', 'consum', 0.0213, 'lps'),
	(581709, 128, '2014-03-15 00:57:15.000000', 'consum', 0.0217, 'lps'),
	(581710, 128, '2014-03-15 00:57:16.000000', 'consum', 0.0212, 'lps'),
	(581711, 128, '2014-03-15 00:57:17.000000', 'consum', 0.0210, 'lps'),
	(581712, 128, '2014-03-15 00:57:18.000000', 'consum', 0.0215, 'lps'),
	(581713, 128, '2014-03-15 00:57:19.000000', 'consum', 0.0216, 'lps'),
	(581714, 128, '2014-03-15 00:57:20.000000', 'consum', 0.0212, 'lps'),
	(581715, 128, '2014-03-15 00:57:21.000000', 'consum', 0.0216, 'lps'),
	(581716, 128, '2014-03-15 00:57:22.000000', 'consum', 0.0213, 'lps'),
	(581717, 128, '2014-03-15 00:57:23.000000', 'consum', 0.0217, 'lps'),
	(581718, 128, '2014-03-15 00:57:24.000000', 'consum', 0.0216, 'lps'),
	(581719, 128, '2014-03-15 00:57:25.000000', 'consum', 0.0218, 'lps'),
	(581720, 128, '2014-03-15 00:57:26.000000', 'consum', 0.0211, 'lps'),
	(581721, 128, '2014-03-15 00:57:27.000000', 'consum', 0.0212, 'lps'),
	(581722, 128, '2014-03-15 00:57:28.000000', 'consum', 0.0220, 'lps'),
	(581723, 128, '2014-03-15 00:57:29.000000', 'consum', 0.0220, 'lps'),
	(581724, 128, '2014-03-15 00:57:30.000000', 'consum', 0.0218, 'lps'),
	(581725, 128, '2014-03-15 00:57:31.000000', 'consum', 0.0220, 'lps'),
	(581726, 128, '2014-03-15 00:57:32.000000', 'consum', 0.0218, 'lps'),
	(581727, 128, '2014-03-15 00:57:33.000000', 'consum', 0.0218, 'lps'),
	(581728, 128, '2014-03-15 00:57:34.000000', 'consum', 0.0215, 'lps'),
	(581729, 128, '2014-03-15 00:57:35.000000', 'consum', 0.0214, 'lps'),
	(581730, 128, '2014-03-15 00:57:36.000000', 'consum', 0.0212, 'lps'),
	(581731, 128, '2014-03-15 00:57:37.000000', 'consum', 0.0211, 'lps'),
	(581732, 128, '2014-03-15 00:57:38.000000', 'consum', 0.0220, 'lps'),
	(581733, 128, '2014-03-15 00:57:39.000000', 'consum', 0.0213, 'lps'),
	(581734, 128, '2014-03-15 00:57:40.000000', 'consum', 0.0216, 'lps'),
	(581735, 128, '2014-03-15 00:57:41.000000', 'consum', 0.0210, 'lps'),
	(581736, 128, '2014-03-15 00:57:42.000000', 'consum', 0.0214, 'lps'),
	(581737, 128, '2014-03-15 00:57:43.000000', 'consum', 0.0220, 'lps'),
	(581738, 128, '2014-03-15 00:57:44.000000', 'consum', 0.0217, 'lps'),
	(581739, 128, '2014-03-15 00:57:45.000000', 'consum', 0.0213, 'lps'),
	(581740, 128, '2014-03-15 00:57:46.000000', 'consum', 0.0215, 'lps'),
	(581741, 128, '2014-03-15 00:57:47.000000', 'consum', 0.0215, 'lps'),
	(581742, 128, '2014-03-15 00:57:48.000000', 'consum', 0.0220, 'lps'),
	(581743, 128, '2014-03-15 00:57:49.000000', 'consum', 0.0214, 'lps'),
	(581744, 128, '2014-03-15 00:57:50.000000', 'consum', 0.0210, 'lps'),
	(581745, 128, '2014-03-15 00:57:51.000000', 'consum', 0.0211, 'lps'),
	(581746, 128, '2014-03-15 00:57:52.000000', 'consum', 0.0216, 'lps'),
	(581747, 128, '2014-03-15 00:57:53.000000', 'consum', 0.0216, 'lps'),
	(581748, 128, '2014-03-15 00:57:54.000000', 'consum', 0.0211, 'lps'),
	(581749, 128, '2014-03-15 00:57:55.000000', 'consum', 0.0210, 'lps'),
	(581750, 128, '2014-03-15 00:57:56.000000', 'consum', 0.0216, 'lps'),
	(581751, 128, '2014-03-15 00:57:57.000000', 'consum', 0.0210, 'lps'),
	(581752, 128, '2014-03-15 00:57:58.000000', 'consum', 0.0215, 'lps'),
	(581753, 128, '2014-03-15 00:57:59.000000', 'consum', 0.0210, 'lps'),
	(581754, 128, '2014-03-15 00:58:00.000000', 'consum', 0.0210, 'lps'),
	(581755, 128, '2014-03-15 00:58:01.000000', 'consum', 0.0219, 'lps'),
	(581756, 128, '2014-03-15 00:58:02.000000', 'consum', 0.0214, 'lps'),
	(581757, 128, '2014-03-15 00:58:03.000000', 'consum', 0.0211, 'lps'),
	(581758, 128, '2014-03-15 00:58:04.000000', 'consum', 0.0217, 'lps'),
	(581759, 128, '2014-03-15 00:58:05.000000', 'consum', 0.0210, 'lps'),
	(581760, 128, '2014-03-15 00:58:06.000000', 'consum', 0.0212, 'lps'),
	(581761, 128, '2014-03-15 00:58:07.000000', 'consum', 0.0218, 'lps'),
	(581762, 128, '2014-03-15 00:58:08.000000', 'consum', 0.0213, 'lps'),
	(581763, 128, '2014-03-15 00:58:09.000000', 'consum', 0.0210, 'lps'),
	(581764, 128, '2014-03-15 00:58:10.000000', 'consum', 0.0215, 'lps'),
	(581765, 128, '2014-03-15 00:58:11.000000', 'consum', 0.0213, 'lps'),
	(581766, 128, '2014-03-15 00:58:12.000000', 'consum', 0.0220, 'lps'),
	(581767, 128, '2014-03-15 00:58:13.000000', 'consum', 0.0217, 'lps'),
	(581768, 128, '2014-03-15 00:58:14.000000', 'consum', 0.0219, 'lps'),
	(581769, 128, '2014-03-15 00:58:15.000000', 'consum', 0.0211, 'lps'),
	(581770, 128, '2014-03-15 00:58:16.000000', 'consum', 0.0211, 'lps'),
	(581771, 128, '2014-03-15 00:58:17.000000', 'consum', 0.0212, 'lps'),
	(581772, 128, '2014-03-15 00:58:18.000000', 'consum', 0.0217, 'lps'),
	(581773, 128, '2014-03-15 00:58:19.000000', 'consum', 0.0220, 'lps'),
	(581774, 128, '2014-03-15 00:58:20.000000', 'consum', 0.0214, 'lps'),
	(581775, 128, '2014-03-15 00:58:21.000000', 'consum', 0.0214, 'lps'),
	(581776, 128, '2014-03-15 00:58:22.000000', 'consum', 0.0216, 'lps'),
	(581777, 128, '2014-03-15 00:58:23.000000', 'consum', 0.0218, 'lps'),
	(581778, 128, '2014-03-15 00:58:24.000000', 'consum', 0.0212, 'lps'),
	(581779, 128, '2014-03-15 00:58:25.000000', 'consum', 0.0217, 'lps'),
	(581780, 128, '2014-03-15 00:58:26.000000', 'consum', 0.0217, 'lps'),
	(581781, 128, '2014-03-15 00:58:27.000000', 'consum', 0.0212, 'lps'),
	(581782, 128, '2014-03-15 00:58:28.000000', 'consum', 0.0214, 'lps'),
	(581783, 128, '2014-03-15 00:58:29.000000', 'consum', 0.0212, 'lps'),
	(581784, 128, '2014-03-15 00:58:30.000000', 'consum', 0.0219, 'lps'),
	(581785, 128, '2014-03-15 00:58:31.000000', 'consum', 0.0218, 'lps'),
	(581786, 128, '2014-03-15 00:58:32.000000', 'consum', 0.0213, 'lps'),
	(581787, 128, '2014-03-15 00:58:33.000000', 'consum', 0.0212, 'lps'),
	(581788, 128, '2014-03-15 00:58:34.000000', 'consum', 0.0212, 'lps'),
	(581789, 128, '2014-03-15 00:58:35.000000', 'consum', 0.0215, 'lps'),
	(581790, 128, '2014-03-15 00:58:36.000000', 'consum', 0.0219, 'lps'),
	(581791, 128, '2014-03-15 00:58:37.000000', 'consum', 0.0216, 'lps'),
	(581792, 128, '2014-03-15 00:58:38.000000', 'consum', 0.0215, 'lps'),
	(581793, 128, '2014-03-15 00:58:39.000000', 'consum', 0.0217, 'lps'),
	(581794, 128, '2014-03-15 00:58:40.000000', 'consum', 0.0218, 'lps'),
	(581795, 128, '2014-03-15 00:58:41.000000', 'consum', 0.0220, 'lps'),
	(581796, 128, '2014-03-15 00:58:42.000000', 'consum', 0.0215, 'lps'),
	(581797, 128, '2014-03-15 00:58:43.000000', 'consum', 0.0214, 'lps'),
	(581798, 128, '2014-03-15 00:58:44.000000', 'consum', 0.0217, 'lps'),
	(581799, 128, '2014-03-15 00:58:45.000000', 'consum', 0.0211, 'lps'),
	(581800, 128, '2014-03-15 00:58:46.000000', 'consum', 0.0215, 'lps'),
	(581801, 128, '2014-03-15 00:58:47.000000', 'consum', 0.0213, 'lps'),
	(581802, 128, '2014-03-15 00:58:48.000000', 'consum', 0.0211, 'lps'),
	(581803, 128, '2014-03-15 00:58:49.000000', 'consum', 0.0216, 'lps'),
	(581804, 128, '2014-03-15 00:58:50.000000', 'consum', 0.0216, 'lps'),
	(581805, 128, '2014-03-15 00:58:51.000000', 'consum', 0.0210, 'lps'),
	(581806, 128, '2014-03-15 00:58:52.000000', 'consum', 0.0213, 'lps'),
	(581807, 128, '2014-03-15 00:58:53.000000', 'consum', 0.0218, 'lps'),
	(581808, 128, '2014-03-15 00:58:54.000000', 'consum', 0.0220, 'lps'),
	(581809, 128, '2014-03-15 00:58:55.000000', 'consum', 0.0213, 'lps'),
	(581810, 128, '2014-03-15 00:58:56.000000', 'consum', 0.0216, 'lps'),
	(581811, 128, '2014-03-15 00:58:57.000000', 'consum', 0.0220, 'lps'),
	(581812, 128, '2014-03-15 00:58:58.000000', 'consum', 0.0212, 'lps'),
	(581813, 128, '2014-03-15 00:58:59.000000', 'consum', 0.0210, 'lps'),
	(581814, 128, '2014-03-15 00:59:00.000000', 'consum', 0.0216, 'lps'),
	(581815, 128, '2014-03-15 00:59:01.000000', 'consum', 0.0220, 'lps'),
	(581816, 128, '2014-03-15 00:59:02.000000', 'consum', 0.0220, 'lps'),
	(581817, 128, '2014-03-15 00:59:03.000000', 'consum', 0.0210, 'lps'),
	(581818, 128, '2014-03-15 00:59:04.000000', 'consum', 0.0211, 'lps'),
	(581819, 128, '2014-03-15 00:59:05.000000', 'consum', 0.0217, 'lps'),
	(581820, 128, '2014-03-15 00:59:06.000000', 'consum', 0.0211, 'lps'),
	(581821, 128, '2014-03-15 00:59:07.000000', 'consum', 0.0216, 'lps'),
	(581822, 128, '2014-03-15 00:59:08.000000', 'consum', 0.0214, 'lps'),
	(581823, 128, '2014-03-15 00:59:09.000000', 'consum', 0.0211, 'lps'),
	(581824, 128, '2014-03-15 00:59:10.000000', 'consum', 0.0216, 'lps'),
	(581825, 128, '2014-03-15 00:59:11.000000', 'consum', 0.0216, 'lps'),
	(581826, 128, '2014-03-15 00:59:12.000000', 'consum', 0.0220, 'lps'),
	(581827, 128, '2014-03-15 00:59:13.000000', 'consum', 0.0212, 'lps'),
	(581828, 128, '2014-03-15 00:59:14.000000', 'consum', 0.0214, 'lps'),
	(581829, 128, '2014-03-15 00:59:15.000000', 'consum', 0.0212, 'lps'),
	(581830, 128, '2014-03-15 00:59:16.000000', 'consum', 0.0218, 'lps'),
	(581831, 128, '2014-03-15 00:59:17.000000', 'consum', 0.0211, 'lps'),
	(581832, 128, '2014-03-15 00:59:18.000000', 'consum', 0.0214, 'lps'),
	(581833, 128, '2014-03-15 00:59:19.000000', 'consum', 0.0217, 'lps'),
	(581834, 128, '2014-03-15 00:59:20.000000', 'consum', 0.0220, 'lps'),
	(581835, 128, '2014-03-15 00:59:21.000000', 'consum', 0.0210, 'lps'),
	(581836, 128, '2014-03-15 00:59:22.000000', 'consum', 0.0213, 'lps'),
	(581837, 128, '2014-03-15 00:59:23.000000', 'consum', 0.0214, 'lps'),
	(581838, 128, '2014-03-15 00:59:24.000000', 'consum', 0.0212, 'lps'),
	(581839, 128, '2014-03-15 00:59:25.000000', 'consum', 0.0217, 'lps'),
	(581840, 128, '2014-03-15 00:59:26.000000', 'consum', 0.0219, 'lps'),
	(581841, 128, '2014-03-15 00:59:27.000000', 'consum', 0.0214, 'lps'),
	(581842, 128, '2014-03-15 00:59:28.000000', 'consum', 0.0213, 'lps'),
	(581843, 128, '2014-03-15 00:59:29.000000', 'consum', 0.0216, 'lps'),
	(581844, 128, '2014-03-15 00:59:30.000000', 'consum', 0.0218, 'lps'),
	(581845, 128, '2014-03-15 00:59:31.000000', 'consum', 0.0210, 'lps'),
	(581846, 128, '2014-03-15 00:59:32.000000', 'consum', 0.0210, 'lps'),
	(581847, 128, '2014-03-15 00:59:33.000000', 'consum', 0.0210, 'lps'),
	(581848, 128, '2014-03-15 00:59:34.000000', 'consum', 0.0220, 'lps'),
	(581849, 128, '2014-03-15 00:59:35.000000', 'consum', 0.0216, 'lps'),
	(581850, 128, '2014-03-15 00:59:36.000000', 'consum', 0.0211, 'lps'),
	(581851, 128, '2014-03-15 00:59:37.000000', 'consum', 0.0220, 'lps'),
	(581852, 128, '2014-03-15 00:59:38.000000', 'consum', 0.0212, 'lps'),
	(581853, 128, '2014-03-15 00:59:39.000000', 'consum', 0.0212, 'lps'),
	(581854, 128, '2014-03-15 00:59:40.000000', 'consum', 0.0214, 'lps'),
	(581855, 128, '2014-03-15 00:59:41.000000', 'consum', 0.0214, 'lps'),
	(581856, 128, '2014-03-15 00:59:42.000000', 'consum', 0.0220, 'lps'),
	(581857, 128, '2014-03-15 00:59:43.000000', 'consum', 0.0216, 'lps'),
	(581858, 128, '2014-03-15 00:59:44.000000', 'consum', 0.0219, 'lps'),
	(581859, 128, '2014-03-15 00:59:45.000000', 'consum', 0.0217, 'lps'),
	(581860, 128, '2014-03-15 00:59:46.000000', 'consum', 0.0220, 'lps'),
	(581861, 128, '2014-03-15 00:59:47.000000', 'consum', 0.0216, 'lps'),
	(581862, 128, '2014-03-15 00:59:48.000000', 'consum', 0.0210, 'lps'),
	(581863, 128, '2014-03-15 00:59:49.000000', 'consum', 0.0214, 'lps'),
	(581864, 128, '2014-03-15 00:59:50.000000', 'consum', 0.0218, 'lps'),
	(581865, 128, '2014-03-15 00:59:51.000000', 'consum', 0.0219, 'lps'),
	(581866, 128, '2014-03-15 00:59:52.000000', 'consum', 0.0220, 'lps'),
	(581867, 128, '2014-03-15 00:59:53.000000', 'consum', 0.0212, 'lps'),
	(581868, 128, '2014-03-15 00:59:54.000000', 'consum', 0.0214, 'lps'),
	(581869, 128, '2014-03-15 00:59:55.000000', 'consum', 0.0211, 'lps'),
	(581870, 128, '2014-03-15 00:59:56.000000', 'consum', 0.0214, 'lps'),
	(581871, 128, '2014-03-15 00:59:57.000000', 'consum', 0.0218, 'lps'),
	(581872, 128, '2014-03-15 00:59:58.000000', 'consum', 0.0216, 'lps'),
	(581873, 128, '2014-03-15 00:59:59.000000', 'consum', 0.0215, 'lps'),
	(581874, 128, '2014-03-15 01:00:00.000000', 'consum', 0.0220, 'lps'),
	(581875, 128, '2014-03-15 01:00:01.000000', 'consum', 0.0212, 'lps'),
	(581876, 128, '2014-03-15 01:00:02.000000', 'consum', 0.0212, 'lps'),
	(581877, 128, '2014-03-15 01:00:03.000000', 'consum', 0.0212, 'lps'),
	(581878, 128, '2014-03-15 01:00:04.000000', 'consum', 0.0218, 'lps'),
	(581879, 128, '2014-03-15 01:00:05.000000', 'consum', 0.0212, 'lps'),
	(581880, 128, '2014-03-15 01:00:06.000000', 'consum', 0.0216, 'lps'),
	(581881, 128, '2014-03-15 01:00:07.000000', 'consum', 0.0215, 'lps'),
	(581882, 128, '2014-03-15 01:00:08.000000', 'consum', 0.0214, 'lps'),
	(581883, 128, '2014-03-15 01:00:09.000000', 'consum', 0.0218, 'lps'),
	(581884, 128, '2014-03-15 01:00:10.000000', 'consum', 0.0218, 'lps'),
	(581885, 128, '2014-03-15 01:00:11.000000', 'consum', 0.0214, 'lps'),
	(581886, 128, '2014-03-15 01:00:12.000000', 'consum', 0.0217, 'lps'),
	(581887, 128, '2014-03-15 01:00:13.000000', 'consum', 0.0213, 'lps'),
	(581888, 128, '2014-03-15 01:00:14.000000', 'consum', 0.0216, 'lps'),
	(581889, 128, '2014-03-15 01:00:15.000000', 'consum', 0.0220, 'lps'),
	(581890, 128, '2014-03-15 01:00:16.000000', 'consum', 0.0218, 'lps'),
	(581891, 128, '2014-03-15 01:00:17.000000', 'consum', 0.0213, 'lps'),
	(581892, 128, '2014-03-15 01:00:18.000000', 'consum', 0.0210, 'lps'),
	(581893, 128, '2014-03-15 01:00:19.000000', 'consum', 0.0212, 'lps'),
	(581894, 128, '2014-03-15 01:00:20.000000', 'consum', 0.0219, 'lps'),
	(581895, 128, '2014-03-15 01:00:21.000000', 'consum', 0.0220, 'lps'),
	(581896, 128, '2014-03-15 01:00:22.000000', 'consum', 0.0210, 'lps'),
	(581897, 128, '2014-03-15 01:00:23.000000', 'consum', 0.0215, 'lps'),
	(581898, 128, '2014-03-15 01:00:24.000000', 'consum', 0.0212, 'lps'),
	(581899, 128, '2014-03-15 01:00:25.000000', 'consum', 0.0217, 'lps'),
	(581900, 128, '2014-03-15 01:00:26.000000', 'consum', 0.0216, 'lps'),
	(581901, 128, '2014-03-15 01:00:27.000000', 'consum', 0.0220, 'lps'),
	(581902, 128, '2014-03-15 01:00:28.000000', 'consum', 0.0210, 'lps'),
	(581903, 128, '2014-03-15 01:00:29.000000', 'consum', 0.0213, 'lps'),
	(581904, 128, '2014-03-15 01:00:30.000000', 'consum', 0.0214, 'lps'),
	(581905, 128, '2014-03-15 01:00:31.000000', 'consum', 0.0220, 'lps'),
	(581906, 128, '2014-03-15 01:00:32.000000', 'consum', 0.0218, 'lps'),
	(581907, 128, '2014-03-15 01:00:33.000000', 'consum', 0.0211, 'lps'),
	(581908, 128, '2014-03-15 01:00:34.000000', 'consum', 0.0210, 'lps'),
	(581909, 128, '2014-03-15 01:00:35.000000', 'consum', 0.0220, 'lps'),
	(581910, 128, '2014-03-15 01:00:36.000000', 'consum', 0.0216, 'lps'),
	(581911, 128, '2014-03-15 01:00:37.000000', 'consum', 0.0220, 'lps'),
	(581912, 128, '2014-03-15 01:00:38.000000', 'consum', 0.0212, 'lps'),
	(581913, 128, '2014-03-15 01:00:39.000000', 'consum', 0.0212, 'lps'),
	(581914, 128, '2014-03-15 01:00:40.000000', 'consum', 0.0213, 'lps'),
	(581915, 128, '2014-03-15 01:00:41.000000', 'consum', 0.0211, 'lps'),
	(581916, 128, '2014-03-15 01:00:42.000000', 'consum', 0.0218, 'lps'),
	(581917, 128, '2014-03-15 01:00:43.000000', 'consum', 0.0214, 'lps'),
	(581918, 128, '2014-03-15 01:00:44.000000', 'consum', 0.0216, 'lps'),
	(581919, 128, '2014-03-15 01:00:45.000000', 'consum', 0.0218, 'lps'),
	(581920, 128, '2014-03-15 01:00:46.000000', 'consum', 0.0211, 'lps'),
	(581921, 128, '2014-03-15 01:00:47.000000', 'consum', 0.0213, 'lps'),
	(581922, 128, '2014-03-15 01:00:48.000000', 'consum', 0.0210, 'lps'),
	(581923, 128, '2014-03-15 01:00:49.000000', 'consum', 0.0213, 'lps'),
	(581924, 128, '2014-03-15 01:00:50.000000', 'consum', 0.0216, 'lps'),
	(581925, 128, '2014-03-15 01:00:51.000000', 'consum', 0.0219, 'lps'),
	(581926, 128, '2014-03-15 01:00:52.000000', 'consum', 0.0216, 'lps'),
	(581927, 128, '2014-03-15 01:00:53.000000', 'consum', 0.0212, 'lps'),
	(581928, 128, '2014-03-15 01:00:54.000000', 'consum', 0.0213, 'lps'),
	(581929, 128, '2014-03-15 01:00:55.000000', 'consum', 0.0211, 'lps'),
	(581930, 128, '2014-03-15 01:00:56.000000', 'consum', 0.0216, 'lps'),
	(581931, 128, '2014-03-15 01:00:57.000000', 'consum', 0.0216, 'lps'),
	(581932, 128, '2014-03-15 01:00:58.000000', 'consum', 0.0211, 'lps'),
	(581933, 128, '2014-03-15 01:00:59.000000', 'consum', 0.0220, 'lps'),
	(581934, 128, '2014-03-15 01:01:00.000000', 'consum', 0.0211, 'lps'),
	(581935, 128, '2014-03-15 01:01:01.000000', 'consum', 0.0210, 'lps'),
	(581936, 128, '2014-03-15 01:01:02.000000', 'consum', 0.0220, 'lps'),
	(581937, 128, '2014-03-15 01:01:03.000000', 'consum', 0.0213, 'lps'),
	(581938, 128, '2014-03-15 01:01:04.000000', 'consum', 0.0220, 'lps'),
	(581939, 128, '2014-03-15 01:01:05.000000', 'consum', 0.0216, 'lps'),
	(581940, 128, '2014-03-15 01:01:06.000000', 'consum', 0.0212, 'lps'),
	(581941, 128, '2014-03-15 01:01:07.000000', 'consum', 0.0213, 'lps'),
	(581942, 128, '2014-03-15 01:01:08.000000', 'consum', 0.0219, 'lps'),
	(581943, 128, '2014-03-15 01:01:09.000000', 'consum', 0.0212, 'lps'),
	(581944, 128, '2014-03-15 01:01:10.000000', 'consum', 0.0217, 'lps'),
	(581945, 128, '2014-03-15 01:01:11.000000', 'consum', 0.0218, 'lps'),
	(581946, 128, '2014-03-15 01:01:12.000000', 'consum', 0.0216, 'lps'),
	(581947, 128, '2014-03-15 01:01:13.000000', 'consum', 0.0220, 'lps'),
	(581948, 128, '2014-03-15 01:01:14.000000', 'consum', 0.0218, 'lps'),
	(581949, 128, '2014-03-15 01:01:15.000000', 'consum', 0.0210, 'lps'),
	(581950, 128, '2014-03-15 01:01:16.000000', 'consum', 0.0211, 'lps'),
	(581951, 128, '2014-03-15 01:01:17.000000', 'consum', 0.0213, 'lps'),
	(581952, 128, '2014-03-15 01:01:18.000000', 'consum', 0.0210, 'lps'),
	(581953, 128, '2014-03-15 01:01:19.000000', 'consum', 0.0215, 'lps'),
	(581954, 128, '2014-03-15 01:01:20.000000', 'consum', 0.0212, 'lps'),
	(581955, 128, '2014-03-15 01:01:21.000000', 'consum', 0.0215, 'lps'),
	(581956, 128, '2014-03-15 01:01:22.000000', 'consum', 0.0210, 'lps'),
	(581957, 128, '2014-03-15 01:01:23.000000', 'consum', 0.0215, 'lps'),
	(581958, 128, '2014-03-15 01:01:24.000000', 'consum', 0.0215, 'lps'),
	(581959, 128, '2014-03-15 01:01:25.000000', 'consum', 0.0219, 'lps'),
	(581960, 128, '2014-03-15 01:01:26.000000', 'consum', 0.0210, 'lps'),
	(581961, 128, '2014-03-15 01:01:27.000000', 'consum', 0.0215, 'lps'),
	(581962, 128, '2014-03-15 01:01:28.000000', 'consum', 0.0212, 'lps'),
	(581963, 128, '2014-03-15 01:01:29.000000', 'consum', 0.0220, 'lps'),
	(581964, 128, '2014-03-15 01:01:30.000000', 'consum', 0.0218, 'lps'),
	(581965, 128, '2014-03-15 01:01:31.000000', 'consum', 0.0212, 'lps'),
	(581966, 128, '2014-03-15 01:01:32.000000', 'consum', 0.0216, 'lps'),
	(581967, 128, '2014-03-15 01:01:33.000000', 'consum', 0.0215, 'lps'),
	(581968, 128, '2014-03-15 01:01:34.000000', 'consum', 0.0216, 'lps'),
	(581969, 128, '2014-03-15 01:01:35.000000', 'consum', 0.0214, 'lps'),
	(581970, 128, '2014-03-15 01:01:36.000000', 'consum', 0.0212, 'lps'),
	(581971, 128, '2014-03-15 01:01:37.000000', 'consum', 0.0220, 'lps'),
	(581972, 128, '2014-03-15 01:01:38.000000', 'consum', 0.0220, 'lps'),
	(581973, 128, '2014-03-15 01:01:39.000000', 'consum', 0.0210, 'lps'),
	(581974, 128, '2014-03-15 01:01:40.000000', 'consum', 0.0213, 'lps'),
	(581975, 128, '2014-03-15 01:01:41.000000', 'consum', 0.0215, 'lps'),
	(581976, 128, '2014-03-15 01:01:42.000000', 'consum', 0.0216, 'lps'),
	(581977, 128, '2014-03-15 01:01:43.000000', 'consum', 0.0214, 'lps'),
	(581978, 128, '2014-03-15 01:01:44.000000', 'consum', 0.0211, 'lps'),
	(581979, 128, '2014-03-15 01:01:45.000000', 'consum', 0.0215, 'lps'),
	(581980, 128, '2014-03-15 01:01:46.000000', 'consum', 0.0210, 'lps'),
	(581981, 128, '2014-03-15 01:01:47.000000', 'consum', 0.0219, 'lps'),
	(581982, 128, '2014-03-15 01:01:48.000000', 'consum', 0.0211, 'lps'),
	(581983, 128, '2014-03-15 01:01:49.000000', 'consum', 0.0211, 'lps'),
	(581984, 128, '2014-03-15 01:01:50.000000', 'consum', 0.0212, 'lps'),
	(581985, 128, '2014-03-15 01:01:51.000000', 'consum', 0.0218, 'lps'),
	(581986, 128, '2014-03-15 01:01:52.000000', 'consum', 0.0212, 'lps'),
	(581987, 128, '2014-03-15 01:01:53.000000', 'consum', 0.0216, 'lps'),
	(581988, 128, '2014-03-15 01:01:54.000000', 'consum', 0.0215, 'lps'),
	(581989, 128, '2014-03-15 01:01:55.000000', 'consum', 0.0216, 'lps'),
	(581990, 128, '2014-03-15 01:01:56.000000', 'consum', 0.0217, 'lps'),
	(581991, 128, '2014-03-15 01:01:57.000000', 'consum', 0.0213, 'lps'),
	(581992, 128, '2014-03-15 01:01:58.000000', 'consum', 0.0217, 'lps'),
	(581993, 128, '2014-03-15 01:01:59.000000', 'consum', 0.0215, 'lps'),
	(581994, 128, '2014-03-15 01:02:00.000000', 'consum', 0.0213, 'lps'),
	(581995, 128, '2014-03-15 01:02:01.000000', 'consum', 0.0212, 'lps'),
	(581996, 128, '2014-03-15 01:02:02.000000', 'consum', 0.0212, 'lps'),
	(581997, 128, '2014-03-15 01:02:03.000000', 'consum', 0.0214, 'lps'),
	(581998, 128, '2014-03-15 01:02:04.000000', 'consum', 0.0214, 'lps'),
	(581999, 128, '2014-03-15 01:02:05.000000', 'consum', 0.0218, 'lps'),
	(582000, 128, '2014-03-15 01:02:06.000000', 'consum', 0.0216, 'lps'),
	(582001, 128, '2014-03-15 01:02:07.000000', 'consum', 0.0215, 'lps'),
	(582002, 128, '2014-03-15 01:02:08.000000', 'consum', 0.0220, 'lps'),
	(582003, 128, '2014-03-15 01:02:09.000000', 'consum', 0.0210, 'lps'),
	(582004, 128, '2014-03-15 01:02:10.000000', 'consum', 0.0213, 'lps'),
	(582005, 128, '2014-03-15 01:02:11.000000', 'consum', 0.0217, 'lps'),
	(582006, 128, '2014-03-15 01:02:12.000000', 'consum', 0.0213, 'lps'),
	(582007, 128, '2014-03-15 01:02:13.000000', 'consum', 0.0217, 'lps'),
	(582008, 128, '2014-03-15 01:02:14.000000', 'consum', 0.0215, 'lps'),
	(582009, 128, '2014-03-15 01:02:15.000000', 'consum', 0.0212, 'lps'),
	(582010, 128, '2014-03-15 01:02:16.000000', 'consum', 0.0217, 'lps'),
	(582011, 128, '2014-03-15 01:02:17.000000', 'consum', 0.0216, 'lps'),
	(582012, 128, '2014-03-15 01:02:18.000000', 'consum', 0.0210, 'lps'),
	(582013, 128, '2014-03-15 01:02:19.000000', 'consum', 0.0216, 'lps'),
	(582014, 128, '2014-03-15 01:02:20.000000', 'consum', 0.0217, 'lps'),
	(582015, 128, '2014-03-15 01:02:21.000000', 'consum', 0.0215, 'lps'),
	(582016, 128, '2014-03-15 01:02:22.000000', 'consum', 0.0215, 'lps'),
	(582017, 128, '2014-03-15 01:02:23.000000', 'consum', 0.0210, 'lps'),
	(582018, 128, '2014-03-15 01:02:24.000000', 'consum', 0.0217, 'lps'),
	(582019, 128, '2014-03-15 01:02:25.000000', 'consum', 0.0214, 'lps'),
	(582020, 128, '2014-03-15 01:02:26.000000', 'consum', 0.0218, 'lps'),
	(582021, 128, '2014-03-15 01:02:27.000000', 'consum', 0.0219, 'lps'),
	(582022, 128, '2014-03-15 01:02:28.000000', 'consum', 0.0218, 'lps'),
	(582023, 128, '2014-03-15 01:02:29.000000', 'consum', 0.0214, 'lps'),
	(582024, 128, '2014-03-15 01:02:30.000000', 'consum', 0.0217, 'lps'),
	(582025, 128, '2014-03-15 01:02:31.000000', 'consum', 0.0212, 'lps'),
	(582026, 128, '2014-03-15 01:02:32.000000', 'consum', 0.0210, 'lps'),
	(582027, 128, '2014-03-15 01:02:33.000000', 'consum', 0.0217, 'lps'),
	(582028, 128, '2014-03-15 01:02:34.000000', 'consum', 0.0210, 'lps'),
	(582029, 128, '2014-03-15 01:02:35.000000', 'consum', 0.0212, 'lps'),
	(582030, 128, '2014-03-15 01:02:36.000000', 'consum', 0.0220, 'lps'),
	(582031, 128, '2014-03-15 01:02:37.000000', 'consum', 0.0213, 'lps'),
	(582032, 128, '2014-03-15 01:02:38.000000', 'consum', 0.0217, 'lps'),
	(582033, 128, '2014-03-15 01:02:39.000000', 'consum', 0.0216, 'lps'),
	(582034, 128, '2014-03-15 01:02:40.000000', 'consum', 0.0217, 'lps'),
	(582035, 128, '2014-03-15 01:02:41.000000', 'consum', 0.0219, 'lps'),
	(582036, 128, '2014-03-15 01:02:42.000000', 'consum', 0.0211, 'lps'),
	(582037, 128, '2014-03-15 01:02:43.000000', 'consum', 0.0212, 'lps'),
	(582038, 128, '2014-03-15 01:02:44.000000', 'consum', 0.0216, 'lps'),
	(582039, 128, '2014-03-15 01:02:45.000000', 'consum', 0.0212, 'lps'),
	(582040, 128, '2014-03-15 01:02:46.000000', 'consum', 0.0216, 'lps'),
	(582041, 128, '2014-03-15 01:02:47.000000', 'consum', 0.0212, 'lps'),
	(582042, 128, '2014-03-15 01:02:48.000000', 'consum', 0.0214, 'lps'),
	(582043, 128, '2014-03-15 01:02:49.000000', 'consum', 0.0212, 'lps'),
	(582044, 128, '2014-03-15 01:02:50.000000', 'consum', 0.0220, 'lps'),
	(582045, 128, '2014-03-15 01:02:51.000000', 'consum', 0.0212, 'lps'),
	(582046, 128, '2014-03-15 01:02:52.000000', 'consum', 0.0210, 'lps'),
	(582047, 128, '2014-03-15 01:02:53.000000', 'consum', 0.0217, 'lps'),
	(582048, 128, '2014-03-15 01:02:54.000000', 'consum', 0.0212, 'lps'),
	(582049, 128, '2014-03-15 01:02:55.000000', 'consum', 0.0210, 'lps'),
	(582050, 128, '2014-03-15 01:02:56.000000', 'consum', 0.0217, 'lps'),
	(582051, 128, '2014-03-15 01:02:57.000000', 'consum', 0.0214, 'lps'),
	(582052, 128, '2014-03-15 01:02:58.000000', 'consum', 0.0217, 'lps'),
	(582053, 128, '2014-03-15 01:02:59.000000', 'consum', 0.0214, 'lps'),
	(582054, 128, '2014-03-15 01:03:00.000000', 'consum', 0.0219, 'lps'),
	(582055, 128, '2014-03-15 01:03:01.000000', 'consum', 0.0210, 'lps'),
	(582056, 128, '2014-03-15 01:03:02.000000', 'consum', 0.0215, 'lps'),
	(582057, 128, '2014-03-15 01:03:03.000000', 'consum', 0.0216, 'lps'),
	(582058, 128, '2014-03-15 01:03:04.000000', 'consum', 0.0212, 'lps'),
	(582059, 128, '2014-03-15 01:03:05.000000', 'consum', 0.0215, 'lps'),
	(582060, 128, '2014-03-15 01:03:06.000000', 'consum', 0.0219, 'lps'),
	(582061, 128, '2014-03-15 01:03:07.000000', 'consum', 0.0218, 'lps'),
	(582062, 128, '2014-03-15 01:03:08.000000', 'consum', 0.0214, 'lps'),
	(582063, 128, '2014-03-15 01:03:09.000000', 'consum', 0.0215, 'lps'),
	(582064, 128, '2014-03-15 01:03:10.000000', 'consum', 0.0212, 'lps'),
	(582065, 128, '2014-03-15 01:03:11.000000', 'consum', 0.0217, 'lps'),
	(582066, 128, '2014-03-15 01:03:12.000000', 'consum', 0.0217, 'lps'),
	(582067, 128, '2014-03-15 01:03:13.000000', 'consum', 0.0215, 'lps'),
	(582068, 128, '2014-03-15 01:03:14.000000', 'consum', 0.0214, 'lps'),
	(582069, 128, '2014-03-15 01:03:15.000000', 'consum', 0.0215, 'lps'),
	(582070, 128, '2014-03-15 01:03:16.000000', 'consum', 0.0212, 'lps'),
	(582071, 128, '2014-03-15 01:03:17.000000', 'consum', 0.0216, 'lps'),
	(582072, 128, '2014-03-15 01:03:18.000000', 'consum', 0.0212, 'lps'),
	(582073, 128, '2014-03-15 01:03:19.000000', 'consum', 0.0216, 'lps'),
	(582074, 128, '2014-03-15 01:03:20.000000', 'consum', 0.0210, 'lps'),
	(582075, 128, '2014-03-15 01:03:21.000000', 'consum', 0.0215, 'lps'),
	(582076, 128, '2014-03-15 01:03:22.000000', 'consum', 0.0213, 'lps'),
	(582077, 128, '2014-03-15 01:03:23.000000', 'consum', 0.0220, 'lps'),
	(582078, 128, '2014-03-15 01:03:24.000000', 'consum', 0.0220, 'lps'),
	(582079, 128, '2014-03-15 01:03:25.000000', 'consum', 0.0220, 'lps'),
	(582080, 128, '2014-03-15 01:03:26.000000', 'consum', 0.0219, 'lps'),
	(582081, 128, '2014-03-15 01:03:27.000000', 'consum', 0.0216, 'lps'),
	(582082, 128, '2014-03-15 01:03:28.000000', 'consum', 0.0211, 'lps'),
	(582083, 128, '2014-03-15 01:03:29.000000', 'consum', 0.0212, 'lps'),
	(582084, 128, '2014-03-15 01:03:30.000000', 'consum', 0.0214, 'lps'),
	(582085, 128, '2014-03-15 01:03:31.000000', 'consum', 0.0217, 'lps'),
	(582086, 128, '2014-03-15 01:03:32.000000', 'consum', 0.0220, 'lps'),
	(582087, 128, '2014-03-15 01:03:33.000000', 'consum', 0.0216, 'lps'),
	(582088, 128, '2014-03-15 01:03:34.000000', 'consum', 0.0214, 'lps'),
	(582089, 128, '2014-03-15 01:03:35.000000', 'consum', 0.0220, 'lps'),
	(582090, 128, '2014-03-15 01:03:36.000000', 'consum', 0.0218, 'lps'),
	(582091, 128, '2014-03-15 01:03:37.000000', 'consum', 0.0218, 'lps'),
	(582092, 128, '2014-03-15 01:03:38.000000', 'consum', 0.0217, 'lps'),
	(582093, 128, '2014-03-15 01:03:39.000000', 'consum', 0.0212, 'lps'),
	(582094, 128, '2014-03-15 01:03:40.000000', 'consum', 0.0211, 'lps'),
	(582095, 128, '2014-03-15 01:03:41.000000', 'consum', 0.0218, 'lps'),
	(582096, 128, '2014-03-15 01:03:42.000000', 'consum', 0.0217, 'lps'),
	(582097, 128, '2014-03-15 01:03:43.000000', 'consum', 0.0220, 'lps'),
	(582098, 128, '2014-03-15 01:03:44.000000', 'consum', 0.0217, 'lps'),
	(582099, 128, '2014-03-15 01:03:45.000000', 'consum', 0.0217, 'lps'),
	(582100, 128, '2014-03-15 01:03:46.000000', 'consum', 0.0214, 'lps'),
	(582101, 128, '2014-03-15 01:03:47.000000', 'consum', 0.0218, 'lps'),
	(582102, 128, '2014-03-15 01:03:48.000000', 'consum', 0.0216, 'lps'),
	(582103, 128, '2014-03-15 01:03:49.000000', 'consum', 0.0217, 'lps'),
	(582104, 128, '2014-03-15 01:03:50.000000', 'consum', 0.0216, 'lps'),
	(582105, 128, '2014-03-15 01:03:51.000000', 'consum', 0.0220, 'lps'),
	(582106, 128, '2014-03-15 01:03:52.000000', 'consum', 0.0211, 'lps'),
	(582107, 128, '2014-03-15 01:03:53.000000', 'consum', 0.0217, 'lps'),
	(582108, 128, '2014-03-15 01:03:54.000000', 'consum', 0.0210, 'lps'),
	(582109, 128, '2014-03-15 01:03:55.000000', 'consum', 0.0211, 'lps'),
	(582110, 128, '2014-03-15 01:03:56.000000', 'consum', 0.0216, 'lps'),
	(582111, 128, '2014-03-15 01:03:57.000000', 'consum', 0.0214, 'lps'),
	(582112, 128, '2014-03-15 01:03:58.000000', 'consum', 0.0212, 'lps'),
	(582113, 128, '2014-03-15 01:03:59.000000', 'consum', 0.0220, 'lps'),
	(582114, 128, '2014-03-15 01:04:00.000000', 'consum', 0.0220, 'lps'),
	(582115, 128, '2014-03-15 01:04:01.000000', 'consum', 0.0210, 'lps'),
	(582116, 128, '2014-03-15 01:04:02.000000', 'consum', 0.0214, 'lps'),
	(582117, 128, '2014-03-15 01:04:03.000000', 'consum', 0.0220, 'lps'),
	(582118, 128, '2014-03-15 01:04:04.000000', 'consum', 0.0214, 'lps'),
	(582119, 128, '2014-03-15 01:04:05.000000', 'consum', 0.0211, 'lps'),
	(582120, 128, '2014-03-15 01:04:06.000000', 'consum', 0.0215, 'lps'),
	(582121, 128, '2014-03-15 01:04:07.000000', 'consum', 0.0220, 'lps'),
	(582122, 128, '2014-03-15 01:04:08.000000', 'consum', 0.0212, 'lps'),
	(582123, 128, '2014-03-15 01:04:09.000000', 'consum', 0.0214, 'lps'),
	(582124, 128, '2014-03-15 01:04:10.000000', 'consum', 0.0214, 'lps'),
	(582125, 128, '2014-03-15 01:04:11.000000', 'consum', 0.0219, 'lps'),
	(582126, 128, '2014-03-15 01:04:12.000000', 'consum', 0.0219, 'lps'),
	(582127, 128, '2014-03-15 01:04:13.000000', 'consum', 0.0219, 'lps'),
	(582128, 128, '2014-03-15 01:04:14.000000', 'consum', 0.0216, 'lps'),
	(582129, 128, '2014-03-15 01:04:15.000000', 'consum', 0.0213, 'lps'),
	(582130, 128, '2014-03-15 01:04:16.000000', 'consum', 0.0220, 'lps'),
	(582131, 128, '2014-03-15 01:04:17.000000', 'consum', 0.0219, 'lps'),
	(582132, 128, '2014-03-15 01:04:18.000000', 'consum', 0.0216, 'lps'),
	(582133, 128, '2014-03-15 01:04:19.000000', 'consum', 0.0211, 'lps'),
	(582134, 128, '2014-03-15 01:04:20.000000', 'consum', 0.0219, 'lps'),
	(582135, 128, '2014-03-15 01:04:21.000000', 'consum', 0.0220, 'lps'),
	(582136, 128, '2014-03-15 01:04:22.000000', 'consum', 0.0213, 'lps'),
	(582137, 128, '2014-03-15 01:04:23.000000', 'consum', 0.0218, 'lps'),
	(582138, 128, '2014-03-15 01:04:24.000000', 'consum', 0.0218, 'lps'),
	(582139, 128, '2014-03-15 01:04:25.000000', 'consum', 0.0215, 'lps'),
	(582140, 128, '2014-03-15 01:04:26.000000', 'consum', 0.0213, 'lps'),
	(582141, 128, '2014-03-15 01:04:27.000000', 'consum', 0.0210, 'lps'),
	(582142, 128, '2014-03-15 01:04:28.000000', 'consum', 0.0214, 'lps'),
	(582143, 128, '2014-03-15 01:04:29.000000', 'consum', 0.0218, 'lps'),
	(582144, 128, '2014-03-15 01:04:30.000000', 'consum', 0.0218, 'lps'),
	(582145, 128, '2014-03-15 01:04:31.000000', 'consum', 0.0215, 'lps'),
	(582146, 128, '2014-03-15 01:04:32.000000', 'consum', 0.0212, 'lps'),
	(582147, 128, '2014-03-15 01:04:33.000000', 'consum', 0.0215, 'lps'),
	(582148, 128, '2014-03-15 01:04:34.000000', 'consum', 0.0219, 'lps'),
	(582149, 128, '2014-03-15 01:04:35.000000', 'consum', 0.0217, 'lps'),
	(582150, 128, '2014-03-15 01:04:36.000000', 'consum', 0.0210, 'lps'),
	(582151, 128, '2014-03-15 01:04:37.000000', 'consum', 0.0212, 'lps'),
	(582152, 128, '2014-03-15 01:04:38.000000', 'consum', 0.0218, 'lps'),
	(582153, 128, '2014-03-15 01:04:39.000000', 'consum', 0.0212, 'lps'),
	(582154, 128, '2014-03-15 01:04:40.000000', 'consum', 0.0217, 'lps'),
	(582155, 128, '2014-03-15 01:04:41.000000', 'consum', 0.0210, 'lps'),
	(582156, 128, '2014-03-15 01:04:42.000000', 'consum', 0.0210, 'lps'),
	(582157, 128, '2014-03-15 01:04:43.000000', 'consum', 0.0220, 'lps'),
	(582158, 128, '2014-03-15 01:04:44.000000', 'consum', 0.0220, 'lps'),
	(582159, 128, '2014-03-15 01:04:45.000000', 'consum', 0.0216, 'lps'),
	(582160, 128, '2014-03-15 01:04:46.000000', 'consum', 0.0212, 'lps'),
	(582161, 128, '2014-03-15 01:04:47.000000', 'consum', 0.0214, 'lps'),
	(582162, 128, '2014-03-15 01:04:48.000000', 'consum', 0.0214, 'lps'),
	(582163, 128, '2014-03-15 01:04:49.000000', 'consum', 0.0216, 'lps'),
	(582164, 128, '2014-03-15 01:04:50.000000', 'consum', 0.0218, 'lps'),
	(582165, 128, '2014-03-15 01:04:51.000000', 'consum', 0.0211, 'lps'),
	(582166, 128, '2014-03-15 01:04:52.000000', 'consum', 0.0213, 'lps'),
	(582167, 128, '2014-03-15 01:04:53.000000', 'consum', 0.0214, 'lps'),
	(582168, 128, '2014-03-15 01:04:54.000000', 'consum', 0.0218, 'lps'),
	(582169, 128, '2014-03-15 01:04:55.000000', 'consum', 0.0220, 'lps'),
	(582170, 128, '2014-03-15 01:04:56.000000', 'consum', 0.0211, 'lps'),
	(582171, 128, '2014-03-15 01:04:57.000000', 'consum', 0.0210, 'lps'),
	(582172, 128, '2014-03-15 01:04:58.000000', 'consum', 0.0219, 'lps'),
	(582173, 128, '2014-03-15 01:04:59.000000', 'consum', 0.0211, 'lps'),
	(582174, 128, '2014-03-15 01:05:00.000000', 'consum', 0.0211, 'lps'),
	(582175, 128, '2014-03-15 01:05:01.000000', 'consum', 0.0212, 'lps'),
	(582176, 128, '2014-03-15 01:05:02.000000', 'consum', 0.0219, 'lps'),
	(582177, 128, '2014-03-15 01:05:03.000000', 'consum', 0.0218, 'lps'),
	(582178, 128, '2014-03-15 01:05:04.000000', 'consum', 0.0220, 'lps'),
	(582179, 128, '2014-03-15 01:05:05.000000', 'consum', 0.0215, 'lps'),
	(582180, 128, '2014-03-15 01:05:06.000000', 'consum', 0.0218, 'lps'),
	(582181, 128, '2014-03-15 01:05:07.000000', 'consum', 0.0213, 'lps'),
	(582182, 128, '2014-03-15 01:05:08.000000', 'consum', 0.0213, 'lps'),
	(582183, 128, '2014-03-15 01:05:09.000000', 'consum', 0.0216, 'lps'),
	(582184, 128, '2014-03-15 01:05:10.000000', 'consum', 0.0219, 'lps'),
	(582185, 128, '2014-03-15 01:05:11.000000', 'consum', 0.0217, 'lps'),
	(582186, 128, '2014-03-15 01:05:12.000000', 'consum', 0.0218, 'lps'),
	(582187, 128, '2014-03-15 01:05:13.000000', 'consum', 0.0217, 'lps'),
	(582188, 128, '2014-03-15 01:05:14.000000', 'consum', 0.0211, 'lps'),
	(582189, 128, '2014-03-15 01:05:15.000000', 'consum', 0.0219, 'lps'),
	(582190, 128, '2014-03-15 01:05:16.000000', 'consum', 0.0216, 'lps'),
	(582191, 128, '2014-03-15 01:05:17.000000', 'consum', 0.0216, 'lps'),
	(582192, 128, '2014-03-15 01:05:18.000000', 'consum', 0.0211, 'lps'),
	(582193, 128, '2014-03-15 01:05:19.000000', 'consum', 0.0219, 'lps'),
	(582194, 128, '2014-03-15 01:05:20.000000', 'consum', 0.0219, 'lps'),
	(582195, 128, '2014-03-15 01:05:21.000000', 'consum', 0.0217, 'lps'),
	(582196, 128, '2014-03-15 01:05:22.000000', 'consum', 0.0217, 'lps'),
	(582197, 128, '2014-03-15 01:05:23.000000', 'consum', 0.0216, 'lps'),
	(582198, 128, '2014-03-15 01:05:24.000000', 'consum', 0.0210, 'lps'),
	(582199, 128, '2014-03-15 01:05:25.000000', 'consum', 0.0213, 'lps'),
	(582200, 128, '2014-03-15 01:05:26.000000', 'consum', 0.0213, 'lps'),
	(582201, 128, '2014-03-15 01:05:27.000000', 'consum', 0.0217, 'lps'),
	(582202, 128, '2014-03-15 01:05:28.000000', 'consum', 0.0217, 'lps'),
	(582203, 128, '2014-03-15 01:05:29.000000', 'consum', 0.0211, 'lps'),
	(582204, 128, '2014-03-15 01:05:30.000000', 'consum', 0.0217, 'lps'),
	(582205, 128, '2014-03-15 01:05:31.000000', 'consum', 0.0220, 'lps'),
	(582206, 128, '2014-03-15 01:05:32.000000', 'consum', 0.0217, 'lps'),
	(582207, 128, '2014-03-15 01:05:33.000000', 'consum', 0.0218, 'lps'),
	(582208, 128, '2014-03-15 01:05:34.000000', 'consum', 0.0215, 'lps'),
	(582209, 128, '2014-03-15 01:05:35.000000', 'consum', 0.0215, 'lps'),
	(582210, 128, '2014-03-15 01:05:36.000000', 'consum', 0.0219, 'lps'),
	(582211, 128, '2014-03-15 01:05:37.000000', 'consum', 0.0218, 'lps'),
	(582212, 128, '2014-03-15 01:05:38.000000', 'consum', 0.0215, 'lps'),
	(582213, 128, '2014-03-15 01:05:39.000000', 'consum', 0.0220, 'lps'),
	(582214, 128, '2014-03-15 01:05:40.000000', 'consum', 0.0213, 'lps'),
	(582215, 128, '2014-03-15 01:05:41.000000', 'consum', 0.0217, 'lps'),
	(582216, 128, '2014-03-15 01:05:42.000000', 'consum', 0.0215, 'lps'),
	(582217, 128, '2014-03-15 01:05:43.000000', 'consum', 0.0214, 'lps'),
	(582218, 128, '2014-03-15 01:05:44.000000', 'consum', 0.0216, 'lps'),
	(582219, 128, '2014-03-15 01:05:45.000000', 'consum', 0.0218, 'lps'),
	(582220, 128, '2014-03-15 01:05:46.000000', 'consum', 0.0212, 'lps'),
	(582221, 128, '2014-03-15 01:05:47.000000', 'consum', 0.0216, 'lps'),
	(582222, 128, '2014-03-15 01:05:48.000000', 'consum', 0.0212, 'lps'),
	(582223, 128, '2014-03-15 01:05:49.000000', 'consum', 0.0213, 'lps'),
	(582224, 128, '2014-03-15 01:05:50.000000', 'consum', 0.0219, 'lps'),
	(582225, 128, '2014-03-15 01:05:51.000000', 'consum', 0.0214, 'lps'),
	(582226, 128, '2014-03-15 01:05:52.000000', 'consum', 0.0217, 'lps'),
	(582227, 128, '2014-03-15 01:05:53.000000', 'consum', 0.0210, 'lps'),
	(582228, 128, '2014-03-15 01:05:54.000000', 'consum', 0.0210, 'lps'),
	(582229, 128, '2014-03-15 01:05:55.000000', 'consum', 0.0210, 'lps'),
	(582230, 128, '2014-03-15 01:05:56.000000', 'consum', 0.0211, 'lps'),
	(582231, 128, '2014-03-15 01:05:57.000000', 'consum', 0.0216, 'lps'),
	(582232, 128, '2014-03-15 01:05:58.000000', 'consum', 0.0216, 'lps'),
	(582233, 128, '2014-03-15 01:05:59.000000', 'consum', 0.0211, 'lps'),
	(582234, 128, '2014-03-15 01:06:00.000000', 'consum', 0.0211, 'lps'),
	(582235, 128, '2014-03-15 01:06:01.000000', 'consum', 0.0220, 'lps'),
	(582236, 128, '2014-03-15 01:06:02.000000', 'consum', 0.0214, 'lps'),
	(582237, 128, '2014-03-15 01:06:03.000000', 'consum', 0.0210, 'lps'),
	(582238, 128, '2014-03-15 01:06:04.000000', 'consum', 0.0213, 'lps'),
	(582239, 128, '2014-03-15 01:06:05.000000', 'consum', 0.0213, 'lps'),
	(582240, 128, '2014-03-15 01:06:06.000000', 'consum', 0.0215, 'lps'),
	(582241, 128, '2014-03-15 01:06:07.000000', 'consum', 0.0217, 'lps'),
	(582242, 128, '2014-03-15 01:06:08.000000', 'consum', 0.0218, 'lps'),
	(582243, 128, '2014-03-15 01:06:09.000000', 'consum', 0.0219, 'lps'),
	(582244, 128, '2014-03-15 01:06:10.000000', 'consum', 0.0219, 'lps'),
	(582245, 128, '2014-03-15 01:06:11.000000', 'consum', 0.0218, 'lps'),
	(582246, 128, '2014-03-15 01:06:12.000000', 'consum', 0.0212, 'lps'),
	(582247, 128, '2014-03-15 01:06:13.000000', 'consum', 0.0218, 'lps'),
	(582248, 128, '2014-03-15 01:06:14.000000', 'consum', 0.0214, 'lps'),
	(582249, 128, '2014-03-15 01:06:15.000000', 'consum', 0.0217, 'lps'),
	(582250, 128, '2014-03-15 01:06:16.000000', 'consum', 0.0220, 'lps'),
	(582251, 128, '2014-03-15 01:06:17.000000', 'consum', 0.0220, 'lps'),
	(582252, 128, '2014-03-15 01:06:18.000000', 'consum', 0.0220, 'lps'),
	(582253, 128, '2014-03-15 01:06:19.000000', 'consum', 0.0210, 'lps'),
	(582254, 128, '2014-03-15 01:06:20.000000', 'consum', 0.0211, 'lps'),
	(582255, 128, '2014-03-15 01:06:21.000000', 'consum', 0.0215, 'lps'),
	(582256, 128, '2014-03-15 01:06:22.000000', 'consum', 0.0212, 'lps'),
	(582257, 128, '2014-03-15 01:06:23.000000', 'consum', 0.0218, 'lps'),
	(582258, 128, '2014-03-15 01:06:24.000000', 'consum', 0.0220, 'lps'),
	(582259, 128, '2014-03-15 01:06:25.000000', 'consum', 0.0215, 'lps'),
	(582260, 128, '2014-03-15 01:06:26.000000', 'consum', 0.0218, 'lps'),
	(582261, 128, '2014-03-15 01:06:27.000000', 'consum', 0.0212, 'lps'),
	(582262, 128, '2014-03-15 01:06:28.000000', 'consum', 0.0218, 'lps'),
	(582263, 128, '2014-03-15 01:06:29.000000', 'consum', 0.0210, 'lps'),
	(582264, 128, '2014-03-15 01:06:30.000000', 'consum', 0.0212, 'lps'),
	(582265, 128, '2014-03-15 01:06:31.000000', 'consum', 0.0219, 'lps'),
	(582266, 128, '2014-03-15 01:06:32.000000', 'consum', 0.0215, 'lps'),
	(582267, 128, '2014-03-15 01:06:33.000000', 'consum', 0.0211, 'lps'),
	(582268, 128, '2014-03-15 01:06:34.000000', 'consum', 0.0212, 'lps'),
	(582269, 128, '2014-03-15 01:06:35.000000', 'consum', 0.0215, 'lps'),
	(582270, 128, '2014-03-15 01:06:36.000000', 'consum', 0.0210, 'lps'),
	(582271, 128, '2014-03-15 01:06:37.000000', 'consum', 0.0217, 'lps'),
	(582272, 128, '2014-03-15 01:06:38.000000', 'consum', 0.0211, 'lps'),
	(582273, 128, '2014-03-15 01:06:39.000000', 'consum', 0.0219, 'lps'),
	(582274, 128, '2014-03-15 01:06:40.000000', 'consum', 0.0219, 'lps'),
	(582275, 128, '2014-03-15 01:06:41.000000', 'consum', 0.0218, 'lps'),
	(582276, 128, '2014-03-15 01:06:42.000000', 'consum', 0.0210, 'lps'),
	(582277, 128, '2014-03-15 01:06:43.000000', 'consum', 0.0220, 'lps'),
	(582278, 128, '2014-03-15 01:06:44.000000', 'consum', 0.0218, 'lps'),
	(582279, 128, '2014-03-15 01:06:45.000000', 'consum', 0.0211, 'lps'),
	(582280, 128, '2014-03-15 01:06:46.000000', 'consum', 0.0212, 'lps'),
	(582281, 128, '2014-03-15 01:06:47.000000', 'consum', 0.0217, 'lps'),
	(582282, 128, '2014-03-15 01:06:48.000000', 'consum', 0.0217, 'lps'),
	(582283, 128, '2014-03-15 01:06:49.000000', 'consum', 0.0216, 'lps'),
	(582284, 128, '2014-03-15 01:06:50.000000', 'consum', 0.0216, 'lps'),
	(582285, 128, '2014-03-15 01:06:51.000000', 'consum', 0.0214, 'lps'),
	(582286, 128, '2014-03-15 01:06:52.000000', 'consum', 0.0210, 'lps'),
	(582287, 128, '2014-03-15 01:06:53.000000', 'consum', 0.0220, 'lps'),
	(582288, 128, '2014-03-15 01:06:54.000000', 'consum', 0.0220, 'lps'),
	(582289, 128, '2014-03-15 01:06:55.000000', 'consum', 0.0217, 'lps'),
	(582290, 128, '2014-03-15 01:06:56.000000', 'consum', 0.0218, 'lps'),
	(582291, 128, '2014-03-15 01:06:57.000000', 'consum', 0.0216, 'lps'),
	(582292, 128, '2014-03-15 01:06:58.000000', 'consum', 0.0218, 'lps'),
	(582293, 128, '2014-03-15 01:06:59.000000', 'consum', 0.0211, 'lps'),
	(582294, 128, '2014-03-15 01:07:00.000000', 'consum', 0.0212, 'lps'),
	(582295, 128, '2014-03-15 01:07:01.000000', 'consum', 0.0219, 'lps'),
	(582296, 128, '2014-03-15 01:07:02.000000', 'consum', 0.0214, 'lps'),
	(582297, 128, '2014-03-15 01:07:03.000000', 'consum', 0.0215, 'lps'),
	(582298, 128, '2014-03-15 01:07:04.000000', 'consum', 0.0215, 'lps'),
	(582299, 128, '2014-03-15 01:07:05.000000', 'consum', 0.0217, 'lps'),
	(582300, 128, '2014-03-15 01:07:06.000000', 'consum', 0.0210, 'lps'),
	(582301, 128, '2014-03-15 01:07:07.000000', 'consum', 0.0214, 'lps'),
	(582302, 128, '2014-03-15 01:07:08.000000', 'consum', 0.0216, 'lps'),
	(582303, 128, '2014-03-15 01:07:09.000000', 'consum', 0.0219, 'lps'),
	(582304, 128, '2014-03-15 01:07:10.000000', 'consum', 0.0216, 'lps'),
	(582305, 128, '2014-03-15 01:07:11.000000', 'consum', 0.0212, 'lps'),
	(582306, 128, '2014-03-15 01:07:12.000000', 'consum', 0.0213, 'lps'),
	(582307, 128, '2014-03-15 01:07:13.000000', 'consum', 0.0210, 'lps'),
	(582308, 128, '2014-03-15 01:07:14.000000', 'consum', 0.0214, 'lps'),
	(582309, 128, '2014-03-15 01:07:15.000000', 'consum', 0.0217, 'lps'),
	(582310, 128, '2014-03-15 01:07:16.000000', 'consum', 0.0211, 'lps'),
	(582311, 128, '2014-03-15 01:07:17.000000', 'consum', 0.0219, 'lps'),
	(582312, 128, '2014-03-15 01:07:18.000000', 'consum', 0.0218, 'lps'),
	(582313, 128, '2014-03-15 01:07:19.000000', 'consum', 0.0212, 'lps'),
	(582314, 128, '2014-03-15 01:07:20.000000', 'consum', 0.0220, 'lps'),
	(582315, 128, '2014-03-15 01:07:21.000000', 'consum', 0.0219, 'lps'),
	(582316, 128, '2014-03-15 01:07:22.000000', 'consum', 0.0216, 'lps'),
	(582317, 128, '2014-03-15 01:07:23.000000', 'consum', 0.0213, 'lps'),
	(582318, 128, '2014-03-15 01:07:24.000000', 'consum', 0.0219, 'lps'),
	(582319, 128, '2014-03-15 01:07:25.000000', 'consum', 0.0212, 'lps'),
	(582320, 128, '2014-03-15 01:07:26.000000', 'consum', 0.0217, 'lps'),
	(582321, 128, '2014-03-15 01:07:27.000000', 'consum', 0.0217, 'lps'),
	(582322, 128, '2014-03-15 01:07:28.000000', 'consum', 0.0212, 'lps'),
	(582323, 128, '2014-03-15 01:07:29.000000', 'consum', 0.0211, 'lps'),
	(582324, 128, '2014-03-15 01:07:30.000000', 'consum', 0.0219, 'lps'),
	(582325, 128, '2014-03-15 01:07:31.000000', 'consum', 0.0212, 'lps'),
	(582326, 128, '2014-03-15 01:07:32.000000', 'consum', 0.0214, 'lps'),
	(582327, 128, '2014-03-15 01:07:33.000000', 'consum', 0.0212, 'lps'),
	(582328, 128, '2014-03-15 01:07:34.000000', 'consum', 0.0210, 'lps'),
	(582329, 128, '2014-03-15 01:07:35.000000', 'consum', 0.0215, 'lps'),
	(582330, 128, '2014-03-15 01:07:36.000000', 'consum', 0.0214, 'lps'),
	(582331, 128, '2014-03-15 01:07:37.000000', 'consum', 0.0216, 'lps'),
	(582332, 128, '2014-03-15 01:07:38.000000', 'consum', 0.0218, 'lps'),
	(582333, 128, '2014-03-15 01:07:39.000000', 'consum', 0.0220, 'lps'),
	(582334, 128, '2014-03-15 01:07:40.000000', 'consum', 0.0215, 'lps'),
	(582335, 128, '2014-03-15 01:07:41.000000', 'consum', 0.0215, 'lps'),
	(582336, 128, '2014-03-15 01:07:42.000000', 'consum', 0.0211, 'lps'),
	(582337, 128, '2014-03-15 01:07:43.000000', 'consum', 0.0212, 'lps'),
	(582338, 128, '2014-03-15 01:07:44.000000', 'consum', 0.0216, 'lps'),
	(582339, 128, '2014-03-15 01:07:45.000000', 'consum', 0.0212, 'lps'),
	(582340, 128, '2014-03-15 01:07:46.000000', 'consum', 0.0216, 'lps'),
	(582341, 128, '2014-03-15 01:07:47.000000', 'consum', 0.0212, 'lps'),
	(582342, 128, '2014-03-15 01:07:48.000000', 'consum', 0.0211, 'lps'),
	(582343, 128, '2014-03-15 01:07:49.000000', 'consum', 0.0211, 'lps'),
	(582344, 128, '2014-03-15 01:07:50.000000', 'consum', 0.0211, 'lps'),
	(582345, 128, '2014-03-15 01:07:51.000000', 'consum', 0.0212, 'lps'),
	(582346, 128, '2014-03-15 01:07:52.000000', 'consum', 0.0219, 'lps'),
	(582347, 128, '2014-03-15 01:07:53.000000', 'consum', 0.0218, 'lps'),
	(582348, 128, '2014-03-15 01:07:54.000000', 'consum', 0.0212, 'lps'),
	(582349, 128, '2014-03-15 01:07:55.000000', 'consum', 0.0218, 'lps'),
	(582350, 128, '2014-03-15 01:07:56.000000', 'consum', 0.0210, 'lps'),
	(582351, 128, '2014-03-15 01:07:57.000000', 'consum', 0.0212, 'lps'),
	(582352, 128, '2014-03-15 01:07:58.000000', 'consum', 0.0217, 'lps'),
	(582353, 128, '2014-03-15 01:07:59.000000', 'consum', 0.0219, 'lps'),
	(582354, 128, '2014-03-15 01:08:00.000000', 'consum', 0.0212, 'lps'),
	(582355, 128, '2014-03-15 01:08:01.000000', 'consum', 0.0217, 'lps'),
	(582356, 128, '2014-03-15 01:08:02.000000', 'consum', 0.0214, 'lps'),
	(582357, 128, '2014-03-15 01:08:03.000000', 'consum', 0.0213, 'lps'),
	(582358, 128, '2014-03-15 01:08:04.000000', 'consum', 0.0214, 'lps'),
	(582359, 128, '2014-03-15 01:08:05.000000', 'consum', 0.0219, 'lps'),
	(582360, 128, '2014-03-15 01:08:06.000000', 'consum', 0.0213, 'lps'),
	(582361, 128, '2014-03-15 01:08:07.000000', 'consum', 0.0219, 'lps'),
	(582362, 128, '2014-03-15 01:08:08.000000', 'consum', 0.0213, 'lps'),
	(582363, 128, '2014-03-15 01:08:09.000000', 'consum', 0.0219, 'lps'),
	(582364, 128, '2014-03-15 01:08:10.000000', 'consum', 0.0216, 'lps'),
	(582365, 128, '2014-03-15 01:08:11.000000', 'consum', 0.0211, 'lps'),
	(582366, 128, '2014-03-15 01:08:12.000000', 'consum', 0.0210, 'lps'),
	(582367, 128, '2014-03-15 01:08:13.000000', 'consum', 0.0217, 'lps'),
	(582368, 128, '2014-03-15 01:08:14.000000', 'consum', 0.0212, 'lps'),
	(582369, 128, '2014-03-15 01:08:15.000000', 'consum', 0.0211, 'lps'),
	(582370, 128, '2014-03-15 01:08:16.000000', 'consum', 0.0219, 'lps'),
	(582371, 128, '2014-03-15 01:08:17.000000', 'consum', 0.0219, 'lps'),
	(582372, 128, '2014-03-15 01:08:18.000000', 'consum', 0.0210, 'lps'),
	(582373, 128, '2014-03-15 01:08:19.000000', 'consum', 0.0214, 'lps'),
	(582374, 128, '2014-03-15 01:08:20.000000', 'consum', 0.0210, 'lps'),
	(582375, 128, '2014-03-15 01:08:21.000000', 'consum', 0.0219, 'lps'),
	(582376, 128, '2014-03-15 01:08:22.000000', 'consum', 0.0210, 'lps'),
	(582377, 128, '2014-03-15 01:08:23.000000', 'consum', 0.0219, 'lps'),
	(582378, 128, '2014-03-15 01:08:24.000000', 'consum', 0.0211, 'lps'),
	(582379, 128, '2014-03-15 01:08:25.000000', 'consum', 0.0212, 'lps'),
	(582380, 128, '2014-03-15 01:08:26.000000', 'consum', 0.0215, 'lps'),
	(582381, 128, '2014-03-15 01:08:27.000000', 'consum', 0.0218, 'lps'),
	(582382, 128, '2014-03-15 01:08:28.000000', 'consum', 0.0212, 'lps'),
	(582383, 128, '2014-03-15 01:08:29.000000', 'consum', 0.0211, 'lps'),
	(582384, 128, '2014-03-15 01:08:30.000000', 'consum', 0.0219, 'lps'),
	(582385, 128, '2014-03-15 01:08:31.000000', 'consum', 0.0220, 'lps'),
	(582386, 128, '2014-03-15 01:08:32.000000', 'consum', 0.0210, 'lps'),
	(582387, 128, '2014-03-15 01:08:33.000000', 'consum', 0.0214, 'lps'),
	(582388, 128, '2014-03-15 01:08:34.000000', 'consum', 0.0219, 'lps'),
	(582389, 128, '2014-03-15 01:08:35.000000', 'consum', 0.0212, 'lps'),
	(582390, 128, '2014-03-15 01:08:36.000000', 'consum', 0.0215, 'lps'),
	(582391, 128, '2014-03-15 01:08:37.000000', 'consum', 0.0220, 'lps'),
	(582392, 128, '2014-03-15 01:08:38.000000', 'consum', 0.0211, 'lps'),
	(582393, 128, '2014-03-15 01:08:39.000000', 'consum', 0.0210, 'lps'),
	(582394, 128, '2014-03-15 01:08:40.000000', 'consum', 0.0215, 'lps'),
	(582395, 128, '2014-03-15 01:08:41.000000', 'consum', 0.0216, 'lps'),
	(582396, 128, '2014-03-15 01:08:42.000000', 'consum', 0.0215, 'lps'),
	(582397, 128, '2014-03-15 01:08:43.000000', 'consum', 0.0217, 'lps'),
	(582398, 128, '2014-03-15 01:08:44.000000', 'consum', 0.0217, 'lps'),
	(582399, 128, '2014-03-15 01:08:45.000000', 'consum', 0.0216, 'lps'),
	(582400, 128, '2014-03-15 01:08:46.000000', 'consum', 0.0218, 'lps'),
	(582401, 128, '2014-03-15 01:08:47.000000', 'consum', 0.0220, 'lps'),
	(582402, 128, '2014-03-15 01:08:48.000000', 'consum', 0.0218, 'lps'),
	(582403, 128, '2014-03-15 01:08:49.000000', 'consum', 0.0219, 'lps'),
	(582404, 128, '2014-03-15 01:08:50.000000', 'consum', 0.0211, 'lps'),
	(582405, 128, '2014-03-15 01:08:51.000000', 'consum', 0.0220, 'lps'),
	(582406, 128, '2014-03-15 01:08:52.000000', 'consum', 0.0213, 'lps'),
	(582407, 128, '2014-03-15 01:08:53.000000', 'consum', 0.0217, 'lps'),
	(582408, 128, '2014-03-15 01:08:54.000000', 'consum', 0.0216, 'lps'),
	(582409, 128, '2014-03-15 01:08:55.000000', 'consum', 0.0218, 'lps'),
	(582410, 128, '2014-03-15 01:08:56.000000', 'consum', 0.0212, 'lps'),
	(582411, 128, '2014-03-15 01:08:57.000000', 'consum', 0.0219, 'lps'),
	(582412, 128, '2014-03-15 01:08:58.000000', 'consum', 0.0217, 'lps'),
	(582413, 128, '2014-03-15 01:08:59.000000', 'consum', 0.0219, 'lps'),
	(582414, 128, '2014-03-15 01:09:00.000000', 'consum', 0.0213, 'lps'),
	(582415, 128, '2014-03-15 01:09:01.000000', 'consum', 0.0220, 'lps'),
	(582416, 128, '2014-03-15 01:09:02.000000', 'consum', 0.0219, 'lps'),
	(582417, 128, '2014-03-15 01:09:03.000000', 'consum', 0.0212, 'lps'),
	(582418, 128, '2014-03-15 01:09:04.000000', 'consum', 0.0217, 'lps'),
	(582419, 128, '2014-03-15 01:09:05.000000', 'consum', 0.0217, 'lps'),
	(582420, 128, '2014-03-15 01:09:06.000000', 'consum', 0.0213, 'lps'),
	(582421, 128, '2014-03-15 01:09:07.000000', 'consum', 0.0215, 'lps'),
	(582422, 128, '2014-03-15 01:09:08.000000', 'consum', 0.0215, 'lps'),
	(582423, 128, '2014-03-15 01:09:09.000000', 'consum', 0.0210, 'lps'),
	(582424, 128, '2014-03-15 01:09:10.000000', 'consum', 0.0216, 'lps'),
	(582425, 128, '2014-03-15 01:09:11.000000', 'consum', 0.0220, 'lps'),
	(582426, 128, '2014-03-15 01:09:12.000000', 'consum', 0.0211, 'lps'),
	(582427, 128, '2014-03-15 01:09:13.000000', 'consum', 0.0216, 'lps'),
	(582428, 128, '2014-03-15 01:09:14.000000', 'consum', 0.0218, 'lps'),
	(582429, 128, '2014-03-15 01:09:15.000000', 'consum', 0.0211, 'lps'),
	(582430, 128, '2014-03-15 01:09:16.000000', 'consum', 0.0213, 'lps'),
	(582431, 128, '2014-03-15 01:09:17.000000', 'consum', 0.0212, 'lps'),
	(582432, 128, '2014-03-15 01:09:18.000000', 'consum', 0.0213, 'lps'),
	(582433, 128, '2014-03-15 01:09:19.000000', 'consum', 0.0216, 'lps'),
	(582434, 128, '2014-03-15 01:09:20.000000', 'consum', 0.0210, 'lps'),
	(582435, 128, '2014-03-15 01:09:21.000000', 'consum', 0.0217, 'lps'),
	(582436, 128, '2014-03-15 01:09:22.000000', 'consum', 0.0210, 'lps'),
	(582437, 128, '2014-03-15 01:09:23.000000', 'consum', 0.0211, 'lps'),
	(582438, 128, '2014-03-15 01:09:24.000000', 'consum', 0.0215, 'lps'),
	(582439, 128, '2014-03-15 01:09:25.000000', 'consum', 0.0211, 'lps'),
	(582440, 128, '2014-03-15 01:09:26.000000', 'consum', 0.0213, 'lps'),
	(582441, 128, '2014-03-15 01:09:27.000000', 'consum', 0.0211, 'lps'),
	(582442, 128, '2014-03-15 01:09:28.000000', 'consum', 0.0217, 'lps'),
	(582443, 128, '2014-03-15 01:09:29.000000', 'consum', 0.0210, 'lps'),
	(582444, 128, '2014-03-15 01:09:30.000000', 'consum', 0.0213, 'lps'),
	(582445, 128, '2014-03-15 01:09:31.000000', 'consum', 0.0212, 'lps'),
	(582446, 128, '2014-03-15 01:09:32.000000', 'consum', 0.0213, 'lps'),
	(582447, 128, '2014-03-15 01:09:33.000000', 'consum', 0.0219, 'lps'),
	(582448, 128, '2014-03-15 01:09:34.000000', 'consum', 0.0215, 'lps'),
	(582449, 128, '2014-03-15 01:09:35.000000', 'consum', 0.0218, 'lps'),
	(582450, 128, '2014-03-15 01:09:36.000000', 'consum', 0.0214, 'lps'),
	(582451, 128, '2014-03-15 01:09:37.000000', 'consum', 0.0216, 'lps'),
	(582452, 128, '2014-03-15 01:09:38.000000', 'consum', 0.0218, 'lps'),
	(582453, 128, '2014-03-15 01:09:39.000000', 'consum', 0.0210, 'lps'),
	(582454, 128, '2014-03-15 01:09:40.000000', 'consum', 0.0211, 'lps'),
	(582455, 128, '2014-03-15 01:09:41.000000', 'consum', 0.0214, 'lps'),
	(582456, 128, '2014-03-15 01:09:42.000000', 'consum', 0.0218, 'lps'),
	(582457, 128, '2014-03-15 01:09:43.000000', 'consum', 0.0217, 'lps'),
	(582458, 128, '2014-03-15 01:09:44.000000', 'consum', 0.0219, 'lps'),
	(582459, 128, '2014-03-15 01:09:45.000000', 'consum', 0.0215, 'lps'),
	(582460, 128, '2014-03-15 01:09:46.000000', 'consum', 0.0220, 'lps'),
	(582461, 128, '2014-03-15 01:09:47.000000', 'consum', 0.0212, 'lps'),
	(582462, 128, '2014-03-15 01:09:48.000000', 'consum', 0.0211, 'lps'),
	(582463, 128, '2014-03-15 01:09:49.000000', 'consum', 0.0212, 'lps'),
	(582464, 128, '2014-03-15 01:09:50.000000', 'consum', 0.0217, 'lps'),
	(582465, 128, '2014-03-15 01:09:51.000000', 'consum', 0.0217, 'lps'),
	(582466, 128, '2014-03-15 01:09:52.000000', 'consum', 0.0212, 'lps'),
	(582467, 128, '2014-03-15 01:09:53.000000', 'consum', 0.0210, 'lps'),
	(582468, 128, '2014-03-15 01:09:54.000000', 'consum', 0.0218, 'lps'),
	(582469, 128, '2014-03-15 01:09:55.000000', 'consum', 0.0218, 'lps'),
	(582470, 128, '2014-03-15 01:09:56.000000', 'consum', 0.0215, 'lps'),
	(582471, 128, '2014-03-15 01:09:57.000000', 'consum', 0.0210, 'lps'),
	(582472, 128, '2014-03-15 01:09:58.000000', 'consum', 0.0217, 'lps'),
	(582473, 128, '2014-03-15 01:09:59.000000', 'consum', 0.0212, 'lps'),
	(582474, 128, '2014-03-15 01:10:00.000000', 'consum', 0.0212, 'lps'),
	(582475, 128, '2014-03-15 01:10:01.000000', 'consum', 0.0216, 'lps'),
	(582476, 128, '2014-03-15 01:10:02.000000', 'consum', 0.0210, 'lps'),
	(582477, 128, '2014-03-15 01:10:03.000000', 'consum', 0.0215, 'lps'),
	(582478, 128, '2014-03-15 01:10:04.000000', 'consum', 0.0212, 'lps'),
	(582479, 128, '2014-03-15 01:10:05.000000', 'consum', 0.0218, 'lps'),
	(582480, 128, '2014-03-15 01:10:06.000000', 'consum', 0.0220, 'lps'),
	(582481, 128, '2014-03-15 01:10:07.000000', 'consum', 0.0218, 'lps'),
	(582482, 128, '2014-03-15 01:10:08.000000', 'consum', 0.0218, 'lps'),
	(582483, 128, '2014-03-15 01:10:09.000000', 'consum', 0.0218, 'lps'),
	(582484, 128, '2014-03-15 01:10:10.000000', 'consum', 0.0216, 'lps'),
	(582485, 128, '2014-03-15 01:10:11.000000', 'consum', 0.0216, 'lps'),
	(582486, 128, '2014-03-15 01:10:12.000000', 'consum', 0.0220, 'lps'),
	(582487, 128, '2014-03-15 01:10:13.000000', 'consum', 0.0213, 'lps'),
	(582488, 128, '2014-03-15 01:10:14.000000', 'consum', 0.0215, 'lps'),
	(582489, 128, '2014-03-15 01:10:15.000000', 'consum', 0.0215, 'lps'),
	(582490, 128, '2014-03-15 01:10:16.000000', 'consum', 0.0219, 'lps'),
	(582491, 128, '2014-03-15 01:10:17.000000', 'consum', 0.0211, 'lps'),
	(582492, 128, '2014-03-15 01:10:18.000000', 'consum', 0.0210, 'lps'),
	(582493, 128, '2014-03-15 01:10:19.000000', 'consum', 0.0216, 'lps'),
	(582494, 128, '2014-03-15 01:10:20.000000', 'consum', 0.0219, 'lps'),
	(582495, 128, '2014-03-15 01:10:21.000000', 'consum', 0.0216, 'lps'),
	(582496, 128, '2014-03-15 01:10:22.000000', 'consum', 0.0215, 'lps'),
	(582497, 128, '2014-03-15 01:10:23.000000', 'consum', 0.0214, 'lps'),
	(582498, 128, '2014-03-15 01:10:24.000000', 'consum', 0.0219, 'lps'),
	(582499, 128, '2014-03-15 01:10:25.000000', 'consum', 0.0220, 'lps'),
	(582500, 128, '2014-03-15 01:10:26.000000', 'consum', 0.0212, 'lps'),
	(582501, 128, '2014-03-15 01:10:27.000000', 'consum', 0.0214, 'lps'),
	(582502, 128, '2014-03-15 01:10:28.000000', 'consum', 0.0214, 'lps'),
	(582503, 128, '2014-03-15 01:10:29.000000', 'consum', 0.0216, 'lps'),
	(582504, 128, '2014-03-15 01:10:30.000000', 'consum', 0.0217, 'lps'),
	(582505, 128, '2014-03-15 01:10:31.000000', 'consum', 0.0219, 'lps'),
	(582506, 128, '2014-03-15 01:10:32.000000', 'consum', 0.0210, 'lps'),
	(582507, 128, '2014-03-15 01:10:33.000000', 'consum', 0.0217, 'lps'),
	(582508, 128, '2014-03-15 01:10:34.000000', 'consum', 0.0215, 'lps'),
	(582509, 128, '2014-03-15 01:10:35.000000', 'consum', 0.0213, 'lps'),
	(582510, 128, '2014-03-15 01:10:36.000000', 'consum', 0.0210, 'lps'),
	(582511, 128, '2014-03-15 01:10:37.000000', 'consum', 0.0212, 'lps'),
	(582512, 128, '2014-03-15 01:10:38.000000', 'consum', 0.0211, 'lps'),
	(582513, 128, '2014-03-15 01:10:39.000000', 'consum', 0.0219, 'lps'),
	(582514, 128, '2014-03-15 01:10:40.000000', 'consum', 0.0210, 'lps'),
	(582515, 128, '2014-03-15 01:10:41.000000', 'consum', 0.0216, 'lps'),
	(582516, 128, '2014-03-15 01:10:42.000000', 'consum', 0.0220, 'lps'),
	(582517, 128, '2014-03-15 01:10:43.000000', 'consum', 0.0218, 'lps'),
	(582518, 128, '2014-03-15 01:10:44.000000', 'consum', 0.0212, 'lps'),
	(582519, 128, '2014-03-15 01:10:45.000000', 'consum', 0.0217, 'lps'),
	(582520, 128, '2014-03-15 01:10:46.000000', 'consum', 0.0217, 'lps'),
	(582521, 128, '2014-03-15 01:10:47.000000', 'consum', 0.0212, 'lps'),
	(582522, 128, '2014-03-15 01:10:48.000000', 'consum', 0.0212, 'lps'),
	(582523, 128, '2014-03-15 01:10:49.000000', 'consum', 0.0214, 'lps'),
	(582524, 128, '2014-03-15 01:10:50.000000', 'consum', 0.0215, 'lps'),
	(582525, 128, '2014-03-15 01:10:51.000000', 'consum', 0.0213, 'lps'),
	(582526, 128, '2014-03-15 01:10:52.000000', 'consum', 0.0211, 'lps'),
	(582527, 128, '2014-03-15 01:10:53.000000', 'consum', 0.0215, 'lps'),
	(582528, 128, '2014-03-15 01:10:54.000000', 'consum', 0.0212, 'lps'),
	(582529, 128, '2014-03-15 01:10:55.000000', 'consum', 0.0217, 'lps'),
	(582530, 128, '2014-03-15 01:10:56.000000', 'consum', 0.0218, 'lps'),
	(582531, 128, '2014-03-15 01:10:57.000000', 'consum', 0.0219, 'lps'),
	(582532, 128, '2014-03-15 01:10:58.000000', 'consum', 0.0210, 'lps'),
	(582533, 128, '2014-03-15 01:10:59.000000', 'consum', 0.0214, 'lps'),
	(582534, 128, '2014-03-15 01:11:00.000000', 'consum', 0.0219, 'lps'),
	(582535, 128, '2014-03-15 01:11:01.000000', 'consum', 0.0211, 'lps'),
	(582536, 128, '2014-03-15 01:11:02.000000', 'consum', 0.0211, 'lps'),
	(582537, 128, '2014-03-15 01:11:03.000000', 'consum', 0.0214, 'lps'),
	(582538, 128, '2014-03-15 01:11:04.000000', 'consum', 0.0216, 'lps'),
	(582539, 128, '2014-03-15 01:11:05.000000', 'consum', 0.0217, 'lps'),
	(582540, 128, '2014-03-15 01:11:06.000000', 'consum', 0.0216, 'lps'),
	(582541, 128, '2014-03-15 01:11:07.000000', 'consum', 0.0219, 'lps'),
	(582542, 128, '2014-03-15 01:11:08.000000', 'consum', 0.0217, 'lps'),
	(582543, 128, '2014-03-15 01:11:09.000000', 'consum', 0.0219, 'lps'),
	(582544, 128, '2014-03-15 01:11:10.000000', 'consum', 0.0210, 'lps'),
	(582545, 128, '2014-03-15 01:11:11.000000', 'consum', 0.0216, 'lps'),
	(582546, 128, '2014-03-15 01:11:12.000000', 'consum', 0.0210, 'lps'),
	(582547, 128, '2014-03-15 01:11:13.000000', 'consum', 0.0212, 'lps'),
	(582548, 128, '2014-03-15 01:11:14.000000', 'consum', 0.0211, 'lps'),
	(582549, 128, '2014-03-15 01:11:15.000000', 'consum', 0.0210, 'lps'),
	(582550, 128, '2014-03-15 01:11:16.000000', 'consum', 0.0218, 'lps'),
	(582551, 128, '2014-03-15 01:11:17.000000', 'consum', 0.0216, 'lps'),
	(582552, 128, '2014-03-15 01:11:18.000000', 'consum', 0.0216, 'lps'),
	(582553, 128, '2014-03-15 01:11:19.000000', 'consum', 0.0214, 'lps'),
	(582554, 128, '2014-03-15 01:11:20.000000', 'consum', 0.0211, 'lps'),
	(582555, 128, '2014-03-15 01:11:21.000000', 'consum', 0.0215, 'lps'),
	(582556, 128, '2014-03-15 01:11:22.000000', 'consum', 0.0210, 'lps'),
	(582557, 128, '2014-03-15 01:11:23.000000', 'consum', 0.0217, 'lps'),
	(582558, 128, '2014-03-15 01:11:24.000000', 'consum', 0.0212, 'lps'),
	(582559, 128, '2014-03-15 01:11:25.000000', 'consum', 0.0210, 'lps'),
	(582560, 128, '2014-03-15 01:11:26.000000', 'consum', 0.0216, 'lps'),
	(582561, 128, '2014-03-15 01:11:27.000000', 'consum', 0.0218, 'lps'),
	(582562, 128, '2014-03-15 01:11:28.000000', 'consum', 0.0212, 'lps'),
	(582563, 128, '2014-03-15 01:11:29.000000', 'consum', 0.0220, 'lps'),
	(582564, 128, '2014-03-15 01:11:30.000000', 'consum', 0.0219, 'lps'),
	(582565, 128, '2014-03-15 01:11:31.000000', 'consum', 0.0215, 'lps'),
	(582566, 128, '2014-03-15 01:11:32.000000', 'consum', 0.0218, 'lps'),
	(582567, 128, '2014-03-15 01:11:33.000000', 'consum', 0.0216, 'lps'),
	(582568, 128, '2014-03-15 01:11:34.000000', 'consum', 0.0214, 'lps'),
	(582569, 128, '2014-03-15 01:11:35.000000', 'consum', 0.0213, 'lps'),
	(582570, 128, '2014-03-15 01:11:36.000000', 'consum', 0.0212, 'lps'),
	(582571, 128, '2014-03-15 01:11:37.000000', 'consum', 0.0215, 'lps'),
	(582572, 128, '2014-03-15 01:11:38.000000', 'consum', 0.0216, 'lps'),
	(582573, 128, '2014-03-15 01:11:39.000000', 'consum', 0.0214, 'lps'),
	(582574, 128, '2014-03-15 01:11:40.000000', 'consum', 0.0214, 'lps'),
	(582575, 128, '2014-03-15 01:11:41.000000', 'consum', 0.0217, 'lps'),
	(582576, 128, '2014-03-15 01:11:42.000000', 'consum', 0.0214, 'lps'),
	(582577, 128, '2014-03-15 01:11:43.000000', 'consum', 0.0219, 'lps'),
	(582578, 128, '2014-03-15 01:11:44.000000', 'consum', 0.0210, 'lps'),
	(582579, 128, '2014-03-15 01:11:45.000000', 'consum', 0.0218, 'lps'),
	(582580, 128, '2014-03-15 01:11:46.000000', 'consum', 0.0217, 'lps'),
	(582581, 128, '2014-03-15 01:11:47.000000', 'consum', 0.0211, 'lps'),
	(582582, 128, '2014-03-15 01:11:48.000000', 'consum', 0.0215, 'lps'),
	(582583, 128, '2014-03-15 01:11:49.000000', 'consum', 0.0211, 'lps'),
	(582584, 128, '2014-03-15 01:11:50.000000', 'consum', 0.0213, 'lps'),
	(582585, 128, '2014-03-15 01:11:51.000000', 'consum', 0.0212, 'lps'),
	(582586, 128, '2014-03-15 01:11:52.000000', 'consum', 0.0211, 'lps'),
	(582587, 128, '2014-03-15 01:11:53.000000', 'consum', 0.0210, 'lps'),
	(582588, 128, '2014-03-15 01:11:54.000000', 'consum', 0.0218, 'lps'),
	(582589, 128, '2014-03-15 01:11:55.000000', 'consum', 0.0219, 'lps'),
	(582590, 128, '2014-03-15 01:11:56.000000', 'consum', 0.0210, 'lps'),
	(582591, 128, '2014-03-15 01:11:57.000000', 'consum', 0.0215, 'lps'),
	(582592, 128, '2014-03-15 01:11:58.000000', 'consum', 0.0215, 'lps'),
	(582593, 128, '2014-03-15 01:11:59.000000', 'consum', 0.0210, 'lps'),
	(582594, 128, '2014-03-15 01:12:00.000000', 'consum', 0.0215, 'lps'),
	(582595, 128, '2014-03-15 01:12:01.000000', 'consum', 0.0215, 'lps'),
	(582596, 128, '2014-03-15 01:12:02.000000', 'consum', 0.0218, 'lps'),
	(582597, 128, '2014-03-15 01:12:03.000000', 'consum', 0.0216, 'lps'),
	(582598, 128, '2014-03-15 01:12:04.000000', 'consum', 0.0215, 'lps'),
	(582599, 128, '2014-03-15 01:12:05.000000', 'consum', 0.0219, 'lps'),
	(582600, 128, '2014-03-15 01:12:06.000000', 'consum', 0.0219, 'lps'),
	(582601, 128, '2014-03-15 01:12:07.000000', 'consum', 0.0216, 'lps'),
	(582602, 128, '2014-03-15 01:12:08.000000', 'consum', 0.0214, 'lps'),
	(582603, 128, '2014-03-15 01:12:09.000000', 'consum', 0.0211, 'lps'),
	(582604, 128, '2014-03-15 01:12:10.000000', 'consum', 0.0217, 'lps'),
	(582605, 128, '2014-03-15 01:12:11.000000', 'consum', 0.0218, 'lps'),
	(582606, 128, '2014-03-15 01:12:12.000000', 'consum', 0.0219, 'lps'),
	(582607, 128, '2014-03-15 01:12:13.000000', 'consum', 0.0220, 'lps'),
	(582608, 128, '2014-03-15 01:12:14.000000', 'consum', 0.0210, 'lps'),
	(582609, 128, '2014-03-15 01:12:15.000000', 'consum', 0.0216, 'lps'),
	(582610, 128, '2014-03-15 01:12:16.000000', 'consum', 0.0216, 'lps'),
	(582611, 128, '2014-03-15 01:12:17.000000', 'consum', 0.0211, 'lps'),
	(582612, 128, '2014-03-15 01:12:18.000000', 'consum', 0.0211, 'lps'),
	(582613, 128, '2014-03-15 01:12:19.000000', 'consum', 0.0210, 'lps'),
	(582614, 128, '2014-03-15 01:12:20.000000', 'consum', 0.0211, 'lps'),
	(582615, 128, '2014-03-15 01:12:21.000000', 'consum', 0.0212, 'lps'),
	(582616, 128, '2014-03-15 01:12:22.000000', 'consum', 0.0218, 'lps'),
	(582617, 128, '2014-03-15 01:12:23.000000', 'consum', 0.0213, 'lps'),
	(582618, 128, '2014-03-15 01:12:24.000000', 'consum', 0.0213, 'lps'),
	(582619, 128, '2014-03-15 01:12:25.000000', 'consum', 0.0214, 'lps'),
	(582620, 128, '2014-03-15 01:12:26.000000', 'consum', 0.0213, 'lps'),
	(582621, 128, '2014-03-15 01:12:27.000000', 'consum', 0.0211, 'lps'),
	(582622, 128, '2014-03-15 01:12:28.000000', 'consum', 0.0220, 'lps'),
	(582623, 128, '2014-03-15 01:12:29.000000', 'consum', 0.0214, 'lps'),
	(582624, 128, '2014-03-15 01:12:30.000000', 'consum', 0.0210, 'lps'),
	(582625, 128, '2014-03-15 01:12:31.000000', 'consum', 0.0212, 'lps'),
	(582626, 128, '2014-03-15 01:12:32.000000', 'consum', 0.0219, 'lps'),
	(582627, 128, '2014-03-15 01:12:33.000000', 'consum', 0.0214, 'lps'),
	(582628, 128, '2014-03-15 01:12:34.000000', 'consum', 0.0218, 'lps'),
	(582629, 128, '2014-03-15 01:12:35.000000', 'consum', 0.0215, 'lps'),
	(582630, 128, '2014-03-15 01:12:36.000000', 'consum', 0.0211, 'lps'),
	(582631, 128, '2014-03-15 01:12:37.000000', 'consum', 0.0211, 'lps'),
	(582632, 128, '2014-03-15 01:12:38.000000', 'consum', 0.0212, 'lps'),
	(582633, 128, '2014-03-15 01:12:39.000000', 'consum', 0.0219, 'lps'),
	(582634, 128, '2014-03-15 01:12:40.000000', 'consum', 0.0217, 'lps'),
	(582635, 128, '2014-03-15 01:12:41.000000', 'consum', 0.0217, 'lps'),
	(582636, 128, '2014-03-15 01:12:42.000000', 'consum', 0.0215, 'lps'),
	(582637, 128, '2014-03-15 01:12:43.000000', 'consum', 0.0212, 'lps'),
	(582638, 128, '2014-03-15 01:12:44.000000', 'consum', 0.0219, 'lps'),
	(582639, 128, '2014-03-15 01:12:45.000000', 'consum', 0.0215, 'lps'),
	(582640, 128, '2014-03-15 01:12:46.000000', 'consum', 0.0211, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(582641, 128, '2014-03-15 01:12:47.000000', 'consum', 0.0210, 'lps'),
	(582642, 128, '2014-03-15 01:12:48.000000', 'consum', 0.0219, 'lps'),
	(582643, 128, '2014-03-15 01:12:49.000000', 'consum', 0.0213, 'lps'),
	(582644, 128, '2014-03-15 01:12:50.000000', 'consum', 0.0218, 'lps'),
	(582645, 128, '2014-03-15 01:12:51.000000', 'consum', 0.0220, 'lps'),
	(582646, 128, '2014-03-15 01:12:52.000000', 'consum', 0.0214, 'lps'),
	(582647, 128, '2014-03-15 01:12:53.000000', 'consum', 0.0214, 'lps'),
	(582648, 128, '2014-03-15 01:12:54.000000', 'consum', 0.0215, 'lps'),
	(582649, 128, '2014-03-15 01:12:55.000000', 'consum', 0.0216, 'lps'),
	(582650, 128, '2014-03-15 01:12:56.000000', 'consum', 0.0212, 'lps'),
	(582651, 128, '2014-03-15 01:12:57.000000', 'consum', 0.0215, 'lps'),
	(582652, 128, '2014-03-15 01:12:58.000000', 'consum', 0.0217, 'lps'),
	(582653, 128, '2014-03-15 01:12:59.000000', 'consum', 0.0220, 'lps'),
	(582654, 128, '2014-03-15 01:13:00.000000', 'consum', 0.0216, 'lps'),
	(582655, 128, '2014-03-15 01:13:01.000000', 'consum', 0.0212, 'lps'),
	(582656, 128, '2014-03-15 01:13:02.000000', 'consum', 0.0215, 'lps'),
	(582657, 128, '2014-03-15 01:13:03.000000', 'consum', 0.0217, 'lps'),
	(582658, 128, '2014-03-15 01:13:04.000000', 'consum', 0.0210, 'lps'),
	(582659, 128, '2014-03-15 01:13:05.000000', 'consum', 0.0212, 'lps'),
	(582660, 128, '2014-03-15 01:13:06.000000', 'consum', 0.0210, 'lps'),
	(582661, 128, '2014-03-15 01:13:07.000000', 'consum', 0.0215, 'lps'),
	(582662, 128, '2014-03-15 01:13:08.000000', 'consum', 0.0214, 'lps'),
	(582663, 128, '2014-03-15 01:13:09.000000', 'consum', 0.0213, 'lps'),
	(582664, 128, '2014-03-15 01:13:10.000000', 'consum', 0.0217, 'lps'),
	(582665, 128, '2014-03-15 01:13:11.000000', 'consum', 0.0211, 'lps'),
	(582666, 128, '2014-03-15 01:13:12.000000', 'consum', 0.0219, 'lps'),
	(582667, 128, '2014-03-15 01:13:13.000000', 'consum', 0.0218, 'lps'),
	(582668, 128, '2014-03-15 01:13:14.000000', 'consum', 0.0213, 'lps'),
	(582669, 128, '2014-03-15 01:13:15.000000', 'consum', 0.0213, 'lps'),
	(582670, 128, '2014-03-15 01:13:16.000000', 'consum', 0.0218, 'lps'),
	(582671, 128, '2014-03-15 01:13:17.000000', 'consum', 0.0217, 'lps'),
	(582672, 128, '2014-03-15 01:13:18.000000', 'consum', 0.0211, 'lps'),
	(582673, 128, '2014-03-15 01:13:19.000000', 'consum', 0.0217, 'lps'),
	(582674, 128, '2014-03-15 01:13:20.000000', 'consum', 0.0211, 'lps'),
	(582675, 128, '2014-03-15 01:13:21.000000', 'consum', 0.0213, 'lps'),
	(582676, 128, '2014-03-15 01:13:22.000000', 'consum', 0.0215, 'lps'),
	(582677, 128, '2014-03-15 01:13:23.000000', 'consum', 0.0212, 'lps'),
	(582678, 128, '2014-03-15 01:13:24.000000', 'consum', 0.0220, 'lps'),
	(582679, 128, '2014-03-15 01:13:25.000000', 'consum', 0.0210, 'lps'),
	(582680, 128, '2014-03-15 01:13:26.000000', 'consum', 0.0212, 'lps'),
	(582681, 128, '2014-03-15 01:13:27.000000', 'consum', 0.0211, 'lps'),
	(582682, 128, '2014-03-15 01:13:28.000000', 'consum', 0.0210, 'lps'),
	(582683, 128, '2014-03-15 01:13:29.000000', 'consum', 0.0217, 'lps'),
	(582684, 128, '2014-03-15 01:13:30.000000', 'consum', 0.0215, 'lps'),
	(582685, 128, '2014-03-15 01:13:31.000000', 'consum', 0.0212, 'lps'),
	(582686, 128, '2014-03-15 01:13:32.000000', 'consum', 0.0219, 'lps'),
	(582687, 128, '2014-03-15 01:13:33.000000', 'consum', 0.0214, 'lps'),
	(582688, 128, '2014-03-15 01:13:34.000000', 'consum', 0.0217, 'lps'),
	(582689, 128, '2014-03-15 01:13:35.000000', 'consum', 0.0220, 'lps'),
	(582690, 128, '2014-03-15 01:13:36.000000', 'consum', 0.0220, 'lps'),
	(582691, 128, '2014-03-15 01:13:37.000000', 'consum', 0.0219, 'lps'),
	(582692, 128, '2014-03-15 01:13:38.000000', 'consum', 0.0214, 'lps'),
	(582693, 128, '2014-03-15 01:13:39.000000', 'consum', 0.0215, 'lps'),
	(582694, 128, '2014-03-15 01:13:40.000000', 'consum', 0.0211, 'lps'),
	(582695, 128, '2014-03-15 01:13:41.000000', 'consum', 0.0211, 'lps'),
	(582696, 128, '2014-03-15 01:13:42.000000', 'consum', 0.0215, 'lps'),
	(582697, 128, '2014-03-15 01:13:43.000000', 'consum', 0.0220, 'lps'),
	(582698, 128, '2014-03-15 01:13:44.000000', 'consum', 0.0211, 'lps'),
	(582699, 128, '2014-03-15 01:13:45.000000', 'consum', 0.0220, 'lps'),
	(582700, 128, '2014-03-15 01:13:46.000000', 'consum', 0.0212, 'lps'),
	(582701, 128, '2014-03-15 01:13:47.000000', 'consum', 0.0213, 'lps'),
	(582702, 128, '2014-03-15 01:13:48.000000', 'consum', 0.0218, 'lps'),
	(582703, 128, '2014-03-15 01:13:49.000000', 'consum', 0.0210, 'lps'),
	(582704, 128, '2014-03-15 01:13:50.000000', 'consum', 0.0219, 'lps'),
	(582705, 128, '2014-03-15 01:13:51.000000', 'consum', 0.0211, 'lps'),
	(582706, 128, '2014-03-15 01:13:52.000000', 'consum', 0.0210, 'lps'),
	(582707, 128, '2014-03-15 01:13:53.000000', 'consum', 0.0218, 'lps'),
	(582708, 128, '2014-03-15 01:13:54.000000', 'consum', 0.0217, 'lps'),
	(582709, 128, '2014-03-15 01:13:55.000000', 'consum', 0.0213, 'lps'),
	(582710, 128, '2014-03-15 01:13:56.000000', 'consum', 0.0215, 'lps'),
	(582711, 128, '2014-03-15 01:13:57.000000', 'consum', 0.0214, 'lps'),
	(582712, 128, '2014-03-15 01:13:58.000000', 'consum', 0.0214, 'lps'),
	(582713, 128, '2014-03-15 01:13:59.000000', 'consum', 0.0211, 'lps'),
	(582714, 128, '2014-03-15 01:14:00.000000', 'consum', 0.0213, 'lps'),
	(582715, 128, '2014-03-15 01:14:01.000000', 'consum', 0.0211, 'lps'),
	(582716, 128, '2014-03-15 01:14:02.000000', 'consum', 0.0220, 'lps'),
	(582717, 128, '2014-03-15 01:14:03.000000', 'consum', 0.0212, 'lps'),
	(582718, 128, '2014-03-15 01:14:04.000000', 'consum', 0.0212, 'lps'),
	(582719, 128, '2014-03-15 01:14:05.000000', 'consum', 0.0215, 'lps'),
	(582720, 128, '2014-03-15 01:14:06.000000', 'consum', 0.0219, 'lps'),
	(582721, 128, '2014-03-15 01:14:07.000000', 'consum', 0.0217, 'lps'),
	(582722, 128, '2014-03-15 01:14:08.000000', 'consum', 0.0218, 'lps'),
	(582723, 128, '2014-03-15 01:14:09.000000', 'consum', 0.0219, 'lps'),
	(582724, 128, '2014-03-15 01:14:10.000000', 'consum', 0.0210, 'lps'),
	(582725, 128, '2014-03-15 01:14:11.000000', 'consum', 0.0216, 'lps'),
	(582726, 128, '2014-03-15 01:14:12.000000', 'consum', 0.0218, 'lps'),
	(582727, 128, '2014-03-15 01:14:13.000000', 'consum', 0.0210, 'lps'),
	(582728, 128, '2014-03-15 01:14:14.000000', 'consum', 0.0220, 'lps'),
	(582729, 128, '2014-03-15 01:14:15.000000', 'consum', 0.0215, 'lps'),
	(582730, 128, '2014-03-15 01:14:16.000000', 'consum', 0.0216, 'lps'),
	(582731, 128, '2014-03-15 01:14:17.000000', 'consum', 0.0215, 'lps'),
	(582732, 128, '2014-03-15 01:14:18.000000', 'consum', 0.0218, 'lps'),
	(582733, 128, '2014-03-15 01:14:19.000000', 'consum', 0.0213, 'lps'),
	(582734, 128, '2014-03-15 01:14:20.000000', 'consum', 0.0213, 'lps'),
	(582735, 128, '2014-03-15 01:14:21.000000', 'consum', 0.0218, 'lps'),
	(582736, 128, '2014-03-15 01:14:22.000000', 'consum', 0.0220, 'lps'),
	(582737, 128, '2014-03-15 01:14:23.000000', 'consum', 0.0214, 'lps'),
	(582738, 128, '2014-03-15 01:14:24.000000', 'consum', 0.0213, 'lps'),
	(582739, 128, '2014-03-15 01:14:25.000000', 'consum', 0.0213, 'lps'),
	(582740, 128, '2014-03-15 01:14:26.000000', 'consum', 0.0215, 'lps'),
	(582741, 128, '2014-03-15 01:14:27.000000', 'consum', 0.0218, 'lps'),
	(582742, 128, '2014-03-15 01:14:28.000000', 'consum', 0.0213, 'lps'),
	(582743, 128, '2014-03-15 01:14:29.000000', 'consum', 0.0212, 'lps'),
	(582744, 128, '2014-03-15 01:14:30.000000', 'consum', 0.0210, 'lps'),
	(582745, 128, '2014-03-15 01:14:31.000000', 'consum', 0.0217, 'lps'),
	(582746, 128, '2014-03-15 01:14:32.000000', 'consum', 0.0212, 'lps'),
	(582747, 128, '2014-03-15 01:14:33.000000', 'consum', 0.0213, 'lps'),
	(582748, 128, '2014-03-15 01:14:34.000000', 'consum', 0.0216, 'lps'),
	(582749, 128, '2014-03-15 01:14:35.000000', 'consum', 0.0210, 'lps'),
	(582750, 128, '2014-03-15 01:14:36.000000', 'consum', 0.0216, 'lps'),
	(582751, 128, '2014-03-15 01:14:37.000000', 'consum', 0.0217, 'lps'),
	(582752, 128, '2014-03-15 01:14:38.000000', 'consum', 0.0215, 'lps'),
	(582753, 128, '2014-03-15 01:14:39.000000', 'consum', 0.0217, 'lps'),
	(582754, 128, '2014-03-15 01:14:40.000000', 'consum', 0.0220, 'lps'),
	(582755, 128, '2014-03-15 01:14:41.000000', 'consum', 0.0218, 'lps'),
	(582756, 128, '2014-03-15 01:14:42.000000', 'consum', 0.0211, 'lps'),
	(582757, 128, '2014-03-15 01:14:43.000000', 'consum', 0.0210, 'lps'),
	(582758, 128, '2014-03-15 01:14:44.000000', 'consum', 0.0220, 'lps'),
	(582759, 128, '2014-03-15 01:14:45.000000', 'consum', 0.0214, 'lps'),
	(582760, 128, '2014-03-15 01:14:46.000000', 'consum', 0.0214, 'lps'),
	(582761, 128, '2014-03-15 01:14:47.000000', 'consum', 0.0220, 'lps'),
	(582762, 128, '2014-03-15 01:14:48.000000', 'consum', 0.0214, 'lps'),
	(582763, 128, '2014-03-15 01:14:49.000000', 'consum', 0.0211, 'lps'),
	(582764, 128, '2014-03-15 01:14:50.000000', 'consum', 0.0216, 'lps'),
	(582765, 128, '2014-03-15 01:14:51.000000', 'consum', 0.0213, 'lps'),
	(582766, 128, '2014-03-15 01:14:52.000000', 'consum', 0.0219, 'lps'),
	(582767, 128, '2014-03-15 01:14:53.000000', 'consum', 0.0215, 'lps'),
	(582768, 128, '2014-03-15 01:14:54.000000', 'consum', 0.0220, 'lps'),
	(582769, 128, '2014-03-15 01:14:55.000000', 'consum', 0.0210, 'lps'),
	(582770, 128, '2014-03-15 01:14:56.000000', 'consum', 0.0214, 'lps'),
	(582771, 128, '2014-03-15 01:14:57.000000', 'consum', 0.0211, 'lps'),
	(582772, 128, '2014-03-15 01:14:58.000000', 'consum', 0.0213, 'lps'),
	(582773, 128, '2014-03-15 01:14:59.000000', 'consum', 0.0212, 'lps'),
	(582774, 128, '2014-03-15 01:15:00.000000', 'consum', 0.0211, 'lps'),
	(582775, 128, '2014-03-15 01:15:01.000000', 'consum', 0.0210, 'lps'),
	(582776, 128, '2014-03-15 01:15:02.000000', 'consum', 0.0219, 'lps'),
	(582777, 128, '2014-03-15 01:15:03.000000', 'consum', 0.0210, 'lps'),
	(582778, 128, '2014-03-15 01:15:04.000000', 'consum', 0.0217, 'lps'),
	(582779, 128, '2014-03-15 01:15:05.000000', 'consum', 0.0213, 'lps'),
	(582780, 128, '2014-03-15 01:15:06.000000', 'consum', 0.0213, 'lps'),
	(582781, 128, '2014-03-15 01:15:07.000000', 'consum', 0.0220, 'lps'),
	(582782, 128, '2014-03-15 01:15:08.000000', 'consum', 0.0216, 'lps'),
	(582783, 128, '2014-03-15 01:15:09.000000', 'consum', 0.0210, 'lps'),
	(582784, 128, '2014-03-15 01:15:10.000000', 'consum', 0.0215, 'lps'),
	(582785, 128, '2014-03-15 01:15:11.000000', 'consum', 0.0214, 'lps'),
	(582786, 128, '2014-03-15 01:15:12.000000', 'consum', 0.0216, 'lps'),
	(582787, 128, '2014-03-15 01:15:13.000000', 'consum', 0.0218, 'lps'),
	(582788, 128, '2014-03-15 01:15:14.000000', 'consum', 0.0211, 'lps'),
	(582789, 128, '2014-03-15 01:15:15.000000', 'consum', 0.0212, 'lps'),
	(582790, 128, '2014-03-15 01:15:16.000000', 'consum', 0.0218, 'lps'),
	(582791, 128, '2014-03-15 01:15:17.000000', 'consum', 0.0212, 'lps'),
	(582792, 128, '2014-03-15 01:15:18.000000', 'consum', 0.0220, 'lps'),
	(582793, 128, '2014-03-15 01:15:19.000000', 'consum', 0.0219, 'lps'),
	(582794, 128, '2014-03-15 01:15:20.000000', 'consum', 0.0216, 'lps'),
	(582795, 128, '2014-03-15 01:15:21.000000', 'consum', 0.0211, 'lps'),
	(582796, 128, '2014-03-15 01:15:22.000000', 'consum', 0.0210, 'lps'),
	(582797, 128, '2014-03-15 01:15:23.000000', 'consum', 0.0219, 'lps'),
	(582798, 128, '2014-03-15 01:15:24.000000', 'consum', 0.0213, 'lps'),
	(582799, 128, '2014-03-15 01:15:25.000000', 'consum', 0.0217, 'lps'),
	(582800, 128, '2014-03-15 01:15:26.000000', 'consum', 0.0217, 'lps'),
	(582801, 128, '2014-03-15 01:15:27.000000', 'consum', 0.0212, 'lps'),
	(582802, 128, '2014-03-15 01:15:28.000000', 'consum', 0.0210, 'lps'),
	(582803, 128, '2014-03-15 01:15:29.000000', 'consum', 0.0218, 'lps'),
	(582804, 128, '2014-03-15 01:15:30.000000', 'consum', 0.0217, 'lps'),
	(582805, 128, '2014-03-15 01:15:31.000000', 'consum', 0.0211, 'lps'),
	(582806, 128, '2014-03-15 01:15:32.000000', 'consum', 0.0218, 'lps'),
	(582807, 128, '2014-03-15 01:15:33.000000', 'consum', 0.0212, 'lps'),
	(582808, 128, '2014-03-15 01:15:34.000000', 'consum', 0.0220, 'lps'),
	(582809, 128, '2014-03-15 01:15:35.000000', 'consum', 0.0211, 'lps'),
	(582810, 128, '2014-03-15 01:15:36.000000', 'consum', 0.0218, 'lps'),
	(582811, 128, '2014-03-15 01:15:37.000000', 'consum', 0.0212, 'lps'),
	(582812, 128, '2014-03-15 01:15:38.000000', 'consum', 0.0211, 'lps'),
	(582813, 128, '2014-03-15 01:15:39.000000', 'consum', 0.0219, 'lps'),
	(582814, 128, '2014-03-15 01:15:40.000000', 'consum', 0.0218, 'lps'),
	(582815, 128, '2014-03-15 01:15:41.000000', 'consum', 0.0214, 'lps'),
	(582816, 128, '2014-03-15 01:15:42.000000', 'consum', 0.0218, 'lps'),
	(582817, 128, '2014-03-15 01:15:43.000000', 'consum', 0.0216, 'lps'),
	(582818, 128, '2014-03-15 01:15:44.000000', 'consum', 0.0216, 'lps'),
	(582819, 128, '2014-03-15 01:15:45.000000', 'consum', 0.0214, 'lps'),
	(582820, 128, '2014-03-15 01:15:46.000000', 'consum', 0.0210, 'lps'),
	(582821, 128, '2014-03-15 01:15:47.000000', 'consum', 0.0212, 'lps'),
	(582822, 128, '2014-03-15 01:15:48.000000', 'consum', 0.0220, 'lps'),
	(582823, 128, '2014-03-15 01:15:49.000000', 'consum', 0.0211, 'lps'),
	(582824, 128, '2014-03-15 01:15:50.000000', 'consum', 0.0220, 'lps'),
	(582825, 128, '2014-03-15 01:15:51.000000', 'consum', 0.0211, 'lps'),
	(582826, 128, '2014-03-15 01:15:52.000000', 'consum', 0.0219, 'lps'),
	(582827, 128, '2014-03-15 01:15:53.000000', 'consum', 0.0219, 'lps'),
	(582828, 128, '2014-03-15 01:15:54.000000', 'consum', 0.0218, 'lps'),
	(582829, 128, '2014-03-15 01:15:55.000000', 'consum', 0.0213, 'lps'),
	(582830, 128, '2014-03-15 01:15:56.000000', 'consum', 0.0212, 'lps'),
	(582831, 128, '2014-03-15 01:15:57.000000', 'consum', 0.0213, 'lps'),
	(582832, 128, '2014-03-15 01:15:58.000000', 'consum', 0.0219, 'lps'),
	(582833, 128, '2014-03-15 01:15:59.000000', 'consum', 0.0215, 'lps'),
	(582834, 128, '2014-03-15 01:16:00.000000', 'consum', 0.0219, 'lps'),
	(582835, 128, '2014-03-15 01:16:01.000000', 'consum', 0.0218, 'lps'),
	(582836, 128, '2014-03-15 01:16:02.000000', 'consum', 0.0211, 'lps'),
	(582837, 128, '2014-03-15 01:16:03.000000', 'consum', 0.0214, 'lps'),
	(582838, 128, '2014-03-15 01:16:04.000000', 'consum', 0.0217, 'lps'),
	(582839, 128, '2014-03-15 01:16:05.000000', 'consum', 0.0212, 'lps'),
	(582840, 128, '2014-03-15 01:16:06.000000', 'consum', 0.0211, 'lps'),
	(582841, 128, '2014-03-15 01:16:07.000000', 'consum', 0.0219, 'lps'),
	(582842, 128, '2014-03-15 01:16:08.000000', 'consum', 0.0220, 'lps'),
	(582843, 128, '2014-03-15 01:16:09.000000', 'consum', 0.0212, 'lps'),
	(582844, 128, '2014-03-15 01:16:10.000000', 'consum', 0.0214, 'lps'),
	(582845, 128, '2014-03-15 01:16:11.000000', 'consum', 0.0213, 'lps'),
	(582846, 128, '2014-03-15 01:16:12.000000', 'consum', 0.0211, 'lps'),
	(582847, 128, '2014-03-15 01:16:13.000000', 'consum', 0.0220, 'lps'),
	(582848, 128, '2014-03-15 01:16:14.000000', 'consum', 0.0214, 'lps'),
	(582849, 128, '2014-03-15 01:16:15.000000', 'consum', 0.0220, 'lps'),
	(582850, 128, '2014-03-15 01:16:16.000000', 'consum', 0.0218, 'lps'),
	(582851, 128, '2014-03-15 01:16:17.000000', 'consum', 0.0220, 'lps'),
	(582852, 128, '2014-03-15 01:16:18.000000', 'consum', 0.0212, 'lps'),
	(582853, 128, '2014-03-15 01:16:19.000000', 'consum', 0.0215, 'lps'),
	(582854, 128, '2014-03-15 01:16:20.000000', 'consum', 0.0218, 'lps'),
	(582855, 128, '2014-03-15 01:16:21.000000', 'consum', 0.0215, 'lps'),
	(582856, 128, '2014-03-15 01:16:22.000000', 'consum', 0.0210, 'lps'),
	(582857, 128, '2014-03-15 01:16:23.000000', 'consum', 0.0216, 'lps'),
	(582858, 128, '2014-03-15 01:16:24.000000', 'consum', 0.0219, 'lps'),
	(582859, 128, '2014-03-15 01:16:25.000000', 'consum', 0.0216, 'lps'),
	(582860, 128, '2014-03-15 01:16:26.000000', 'consum', 0.0214, 'lps'),
	(582861, 128, '2014-03-15 01:16:27.000000', 'consum', 0.0214, 'lps'),
	(582862, 128, '2014-03-15 01:16:28.000000', 'consum', 0.0218, 'lps'),
	(582863, 128, '2014-03-15 01:16:29.000000', 'consum', 0.0217, 'lps'),
	(582864, 128, '2014-03-15 01:16:30.000000', 'consum', 0.0211, 'lps'),
	(582865, 128, '2014-03-15 01:16:31.000000', 'consum', 0.0217, 'lps'),
	(582866, 128, '2014-03-15 01:16:32.000000', 'consum', 0.0218, 'lps'),
	(582867, 128, '2014-03-15 01:16:33.000000', 'consum', 0.0210, 'lps'),
	(582868, 128, '2014-03-15 01:16:34.000000', 'consum', 0.0220, 'lps'),
	(582869, 128, '2014-03-15 01:16:35.000000', 'consum', 0.0216, 'lps'),
	(582870, 128, '2014-03-15 01:16:36.000000', 'consum', 0.0219, 'lps'),
	(582871, 128, '2014-03-15 01:16:37.000000', 'consum', 0.0218, 'lps'),
	(582872, 128, '2014-03-15 01:16:38.000000', 'consum', 0.0211, 'lps'),
	(582873, 128, '2014-03-15 01:16:39.000000', 'consum', 0.0216, 'lps'),
	(582874, 128, '2014-03-15 01:16:40.000000', 'consum', 0.0214, 'lps'),
	(582875, 128, '2014-03-15 01:16:41.000000', 'consum', 0.0213, 'lps'),
	(582876, 128, '2014-03-15 01:16:42.000000', 'consum', 0.0211, 'lps'),
	(582877, 128, '2014-03-15 01:16:43.000000', 'consum', 0.0210, 'lps'),
	(582878, 128, '2014-03-15 01:16:44.000000', 'consum', 0.0216, 'lps'),
	(582879, 128, '2014-03-15 01:16:45.000000', 'consum', 0.0220, 'lps'),
	(582880, 128, '2014-03-15 01:16:46.000000', 'consum', 0.0219, 'lps'),
	(582881, 128, '2014-03-15 01:16:47.000000', 'consum', 0.0214, 'lps'),
	(582882, 128, '2014-03-15 01:16:48.000000', 'consum', 0.0217, 'lps'),
	(582883, 128, '2014-03-15 01:16:49.000000', 'consum', 0.0220, 'lps'),
	(582884, 128, '2014-03-15 01:16:50.000000', 'consum', 0.0219, 'lps'),
	(582885, 128, '2014-03-15 01:16:51.000000', 'consum', 0.0216, 'lps'),
	(582886, 128, '2014-03-15 01:16:52.000000', 'consum', 0.0210, 'lps'),
	(582887, 128, '2014-03-15 01:16:53.000000', 'consum', 0.0218, 'lps'),
	(582888, 128, '2014-03-15 01:16:54.000000', 'consum', 0.0216, 'lps'),
	(582889, 128, '2014-03-15 01:16:55.000000', 'consum', 0.0216, 'lps'),
	(582890, 128, '2014-03-15 01:16:56.000000', 'consum', 0.0210, 'lps'),
	(582891, 128, '2014-03-15 01:16:57.000000', 'consum', 0.0215, 'lps'),
	(582892, 128, '2014-03-15 01:16:58.000000', 'consum', 0.0214, 'lps'),
	(582893, 128, '2014-03-15 01:16:59.000000', 'consum', 0.0216, 'lps'),
	(582894, 128, '2014-03-15 01:17:00.000000', 'consum', 0.0217, 'lps'),
	(582895, 128, '2014-03-15 01:17:01.000000', 'consum', 0.0215, 'lps'),
	(582896, 128, '2014-03-15 01:17:02.000000', 'consum', 0.0215, 'lps'),
	(582897, 128, '2014-03-15 01:17:03.000000', 'consum', 0.0220, 'lps'),
	(582898, 128, '2014-03-15 01:17:04.000000', 'consum', 0.0214, 'lps'),
	(582899, 128, '2014-03-15 01:17:05.000000', 'consum', 0.0220, 'lps'),
	(582900, 128, '2014-03-15 01:17:06.000000', 'consum', 0.0216, 'lps'),
	(582901, 128, '2014-03-15 01:17:07.000000', 'consum', 0.0212, 'lps'),
	(582902, 128, '2014-03-15 01:17:08.000000', 'consum', 0.0215, 'lps'),
	(582903, 128, '2014-03-15 01:17:09.000000', 'consum', 0.0217, 'lps'),
	(582904, 128, '2014-03-15 01:17:10.000000', 'consum', 0.0219, 'lps'),
	(582905, 128, '2014-03-15 01:17:11.000000', 'consum', 0.0214, 'lps'),
	(582906, 128, '2014-03-15 01:17:12.000000', 'consum', 0.0213, 'lps'),
	(582907, 128, '2014-03-15 01:17:13.000000', 'consum', 0.0212, 'lps'),
	(582908, 128, '2014-03-15 01:17:14.000000', 'consum', 0.0215, 'lps'),
	(582909, 128, '2014-03-15 01:17:15.000000', 'consum', 0.0217, 'lps'),
	(582910, 128, '2014-03-15 01:17:16.000000', 'consum', 0.0220, 'lps'),
	(582911, 128, '2014-03-15 01:17:17.000000', 'consum', 0.0216, 'lps'),
	(582912, 128, '2014-03-15 01:17:18.000000', 'consum', 0.0210, 'lps'),
	(582913, 128, '2014-03-15 01:17:19.000000', 'consum', 0.0217, 'lps'),
	(582914, 128, '2014-03-15 01:17:20.000000', 'consum', 0.0212, 'lps'),
	(582915, 128, '2014-03-15 01:17:21.000000', 'consum', 0.0211, 'lps'),
	(582916, 128, '2014-03-15 01:17:22.000000', 'consum', 0.0210, 'lps'),
	(582917, 128, '2014-03-15 01:17:23.000000', 'consum', 0.0217, 'lps'),
	(582918, 128, '2014-03-15 01:17:24.000000', 'consum', 0.0214, 'lps'),
	(582919, 128, '2014-03-15 01:17:25.000000', 'consum', 0.0211, 'lps'),
	(582920, 128, '2014-03-15 01:17:26.000000', 'consum', 0.0212, 'lps'),
	(582921, 128, '2014-03-15 01:17:27.000000', 'consum', 0.0218, 'lps'),
	(582922, 128, '2014-03-15 01:17:28.000000', 'consum', 0.0210, 'lps'),
	(582923, 128, '2014-03-15 01:17:29.000000', 'consum', 0.0210, 'lps'),
	(582924, 128, '2014-03-15 01:17:30.000000', 'consum', 0.0211, 'lps'),
	(582925, 128, '2014-03-15 01:17:31.000000', 'consum', 0.0217, 'lps'),
	(582926, 128, '2014-03-15 01:17:32.000000', 'consum', 0.0218, 'lps'),
	(582927, 128, '2014-03-15 01:17:33.000000', 'consum', 0.0219, 'lps'),
	(582928, 128, '2014-03-15 01:17:34.000000', 'consum', 0.0210, 'lps'),
	(582929, 128, '2014-03-15 01:17:35.000000', 'consum', 0.0217, 'lps'),
	(582930, 128, '2014-03-15 01:17:36.000000', 'consum', 0.0212, 'lps'),
	(582931, 128, '2014-03-15 01:17:37.000000', 'consum', 0.0212, 'lps'),
	(582932, 128, '2014-03-15 01:17:38.000000', 'consum', 0.0214, 'lps'),
	(582933, 128, '2014-03-15 01:17:39.000000', 'consum', 0.0212, 'lps'),
	(582934, 128, '2014-03-15 01:17:40.000000', 'consum', 0.0220, 'lps'),
	(582935, 128, '2014-03-15 01:17:41.000000', 'consum', 0.0220, 'lps'),
	(582936, 128, '2014-03-15 01:17:42.000000', 'consum', 0.0211, 'lps'),
	(582937, 128, '2014-03-15 01:17:43.000000', 'consum', 0.0217, 'lps'),
	(582938, 128, '2014-03-15 01:17:44.000000', 'consum', 0.0211, 'lps'),
	(582939, 128, '2014-03-15 01:17:45.000000', 'consum', 0.0216, 'lps'),
	(582940, 128, '2014-03-15 01:17:46.000000', 'consum', 0.0215, 'lps'),
	(582941, 128, '2014-03-15 01:17:47.000000', 'consum', 0.0216, 'lps'),
	(582942, 128, '2014-03-15 01:17:48.000000', 'consum', 0.0216, 'lps'),
	(582943, 128, '2014-03-15 01:17:49.000000', 'consum', 0.0211, 'lps'),
	(582944, 128, '2014-03-15 01:17:50.000000', 'consum', 0.0210, 'lps'),
	(582945, 128, '2014-03-15 01:17:51.000000', 'consum', 0.0216, 'lps'),
	(582946, 128, '2014-03-15 01:17:52.000000', 'consum', 0.0219, 'lps'),
	(582947, 128, '2014-03-15 01:17:53.000000', 'consum', 0.0218, 'lps'),
	(582948, 128, '2014-03-15 01:17:54.000000', 'consum', 0.0211, 'lps'),
	(582949, 128, '2014-03-15 01:17:55.000000', 'consum', 0.0213, 'lps'),
	(582950, 128, '2014-03-15 01:17:56.000000', 'consum', 0.0210, 'lps'),
	(582951, 128, '2014-03-15 01:17:57.000000', 'consum', 0.0213, 'lps'),
	(582952, 128, '2014-03-15 01:17:58.000000', 'consum', 0.0217, 'lps'),
	(582953, 128, '2014-03-15 01:17:59.000000', 'consum', 0.0211, 'lps'),
	(582954, 128, '2014-03-15 01:18:00.000000', 'consum', 0.0220, 'lps'),
	(582955, 128, '2014-03-15 01:18:01.000000', 'consum', 0.0213, 'lps'),
	(582956, 128, '2014-03-15 01:18:02.000000', 'consum', 0.0216, 'lps'),
	(582957, 128, '2014-03-15 01:18:03.000000', 'consum', 0.0219, 'lps'),
	(582958, 128, '2014-03-15 01:18:04.000000', 'consum', 0.0218, 'lps'),
	(582959, 128, '2014-03-15 01:18:05.000000', 'consum', 0.0214, 'lps'),
	(582960, 128, '2014-03-15 01:18:06.000000', 'consum', 0.0214, 'lps'),
	(582961, 128, '2014-03-15 01:18:07.000000', 'consum', 0.0210, 'lps'),
	(582962, 128, '2014-03-15 01:18:08.000000', 'consum', 0.0220, 'lps'),
	(582963, 128, '2014-03-15 01:18:09.000000', 'consum', 0.0216, 'lps'),
	(582964, 128, '2014-03-15 01:18:10.000000', 'consum', 0.0211, 'lps'),
	(582965, 128, '2014-03-15 01:18:11.000000', 'consum', 0.0220, 'lps'),
	(582966, 128, '2014-03-15 01:18:12.000000', 'consum', 0.0214, 'lps'),
	(582967, 128, '2014-03-15 01:18:13.000000', 'consum', 0.0211, 'lps'),
	(582968, 128, '2014-03-15 01:18:14.000000', 'consum', 0.0216, 'lps'),
	(582969, 128, '2014-03-15 01:18:15.000000', 'consum', 0.0215, 'lps'),
	(582970, 128, '2014-03-15 01:18:16.000000', 'consum', 0.0215, 'lps'),
	(582971, 128, '2014-03-15 01:18:17.000000', 'consum', 0.0211, 'lps'),
	(582972, 128, '2014-03-15 01:18:18.000000', 'consum', 0.0213, 'lps'),
	(582973, 128, '2014-03-15 01:18:19.000000', 'consum', 0.0212, 'lps'),
	(582974, 128, '2014-03-15 01:18:20.000000', 'consum', 0.0212, 'lps'),
	(582975, 128, '2014-03-15 01:18:21.000000', 'consum', 0.0212, 'lps'),
	(582976, 128, '2014-03-15 01:18:22.000000', 'consum', 0.0213, 'lps'),
	(582977, 128, '2014-03-15 01:18:23.000000', 'consum', 0.0212, 'lps'),
	(582978, 128, '2014-03-15 01:18:24.000000', 'consum', 0.0220, 'lps'),
	(582979, 128, '2014-03-15 01:18:25.000000', 'consum', 0.0213, 'lps'),
	(582980, 128, '2014-03-15 01:18:26.000000', 'consum', 0.0218, 'lps'),
	(582981, 128, '2014-03-15 01:18:27.000000', 'consum', 0.0219, 'lps'),
	(582982, 128, '2014-03-15 01:18:28.000000', 'consum', 0.0220, 'lps'),
	(582983, 128, '2014-03-15 01:18:29.000000', 'consum', 0.0212, 'lps'),
	(582984, 128, '2014-03-15 01:18:30.000000', 'consum', 0.0212, 'lps'),
	(582985, 128, '2014-03-15 01:18:31.000000', 'consum', 0.0216, 'lps'),
	(582986, 128, '2014-03-15 01:18:32.000000', 'consum', 0.0213, 'lps'),
	(582987, 128, '2014-03-15 01:18:33.000000', 'consum', 0.0218, 'lps'),
	(582988, 128, '2014-03-15 01:18:34.000000', 'consum', 0.0219, 'lps'),
	(582989, 128, '2014-03-15 01:18:35.000000', 'consum', 0.0220, 'lps'),
	(582990, 128, '2014-03-15 01:18:36.000000', 'consum', 0.0212, 'lps'),
	(582991, 128, '2014-03-15 01:18:37.000000', 'consum', 0.0214, 'lps'),
	(582992, 128, '2014-03-15 01:18:38.000000', 'consum', 0.0213, 'lps'),
	(582993, 128, '2014-03-15 01:18:39.000000', 'consum', 0.0213, 'lps'),
	(582994, 128, '2014-03-15 01:18:40.000000', 'consum', 0.0215, 'lps'),
	(582995, 128, '2014-03-15 01:18:41.000000', 'consum', 0.0217, 'lps'),
	(582996, 128, '2014-03-15 01:18:42.000000', 'consum', 0.0220, 'lps'),
	(582997, 128, '2014-03-15 01:18:43.000000', 'consum', 0.0217, 'lps'),
	(582998, 128, '2014-03-15 01:18:44.000000', 'consum', 0.0214, 'lps'),
	(582999, 128, '2014-03-15 01:18:45.000000', 'consum', 0.0211, 'lps'),
	(583000, 128, '2014-03-15 01:18:46.000000', 'consum', 0.0213, 'lps'),
	(583001, 128, '2014-03-15 01:18:47.000000', 'consum', 0.0212, 'lps'),
	(583002, 128, '2014-03-15 01:18:48.000000', 'consum', 0.0210, 'lps'),
	(583003, 128, '2014-03-15 01:18:49.000000', 'consum', 0.0216, 'lps'),
	(583004, 128, '2014-03-15 01:18:50.000000', 'consum', 0.0217, 'lps'),
	(583005, 128, '2014-03-15 01:18:51.000000', 'consum', 0.0219, 'lps'),
	(583006, 128, '2014-03-15 01:18:52.000000', 'consum', 0.0213, 'lps'),
	(583007, 128, '2014-03-15 01:18:53.000000', 'consum', 0.0220, 'lps'),
	(583008, 128, '2014-03-15 01:18:54.000000', 'consum', 0.0217, 'lps'),
	(583009, 128, '2014-03-15 01:18:55.000000', 'consum', 0.0215, 'lps'),
	(583010, 128, '2014-03-15 01:18:56.000000', 'consum', 0.0214, 'lps'),
	(583011, 128, '2014-03-15 01:18:57.000000', 'consum', 0.0217, 'lps'),
	(583012, 128, '2014-03-15 01:18:58.000000', 'consum', 0.0213, 'lps'),
	(583013, 128, '2014-03-15 01:18:59.000000', 'consum', 0.0213, 'lps'),
	(583014, 128, '2014-03-15 01:19:00.000000', 'consum', 0.0219, 'lps'),
	(583015, 128, '2014-03-15 01:19:01.000000', 'consum', 0.0211, 'lps'),
	(583016, 128, '2014-03-15 01:19:02.000000', 'consum', 0.0212, 'lps'),
	(583017, 128, '2014-03-15 01:19:03.000000', 'consum', 0.0216, 'lps'),
	(583018, 128, '2014-03-15 01:19:04.000000', 'consum', 0.0214, 'lps'),
	(583019, 128, '2014-03-15 01:19:05.000000', 'consum', 0.0211, 'lps'),
	(583020, 128, '2014-03-15 01:19:06.000000', 'consum', 0.0213, 'lps'),
	(583021, 128, '2014-03-15 01:19:07.000000', 'consum', 0.0214, 'lps'),
	(583022, 128, '2014-03-15 01:19:08.000000', 'consum', 0.0210, 'lps'),
	(583023, 128, '2014-03-15 01:19:09.000000', 'consum', 0.0220, 'lps'),
	(583024, 128, '2014-03-15 01:19:10.000000', 'consum', 0.0218, 'lps'),
	(583025, 128, '2014-03-15 01:19:11.000000', 'consum', 0.0218, 'lps'),
	(583026, 128, '2014-03-15 01:19:12.000000', 'consum', 0.0215, 'lps'),
	(583027, 128, '2014-03-15 01:19:13.000000', 'consum', 0.0213, 'lps'),
	(583028, 128, '2014-03-15 01:19:14.000000', 'consum', 0.0210, 'lps'),
	(583029, 128, '2014-03-15 01:19:15.000000', 'consum', 0.0213, 'lps'),
	(583030, 128, '2014-03-15 01:19:16.000000', 'consum', 0.0214, 'lps'),
	(583031, 128, '2014-03-15 01:19:17.000000', 'consum', 0.0212, 'lps'),
	(583032, 128, '2014-03-15 01:19:18.000000', 'consum', 0.0220, 'lps'),
	(583033, 128, '2014-03-15 01:19:19.000000', 'consum', 0.0219, 'lps'),
	(583034, 128, '2014-03-15 01:19:20.000000', 'consum', 0.0215, 'lps'),
	(583035, 128, '2014-03-15 01:19:21.000000', 'consum', 0.0219, 'lps'),
	(583036, 128, '2014-03-15 01:19:22.000000', 'consum', 0.0210, 'lps'),
	(583037, 128, '2014-03-15 01:19:23.000000', 'consum', 0.0215, 'lps'),
	(583038, 128, '2014-03-15 01:19:24.000000', 'consum', 0.0213, 'lps'),
	(583039, 128, '2014-03-15 01:19:25.000000', 'consum', 0.0220, 'lps'),
	(583040, 128, '2014-03-15 01:19:26.000000', 'consum', 0.0220, 'lps'),
	(583041, 128, '2014-03-15 01:19:27.000000', 'consum', 0.0218, 'lps'),
	(583042, 128, '2014-03-15 01:19:28.000000', 'consum', 0.0210, 'lps'),
	(583043, 128, '2014-03-15 01:19:29.000000', 'consum', 0.0220, 'lps'),
	(583044, 128, '2014-03-15 01:19:30.000000', 'consum', 0.0216, 'lps'),
	(583045, 128, '2014-03-15 01:19:31.000000', 'consum', 0.0210, 'lps'),
	(583046, 128, '2014-03-15 01:19:32.000000', 'consum', 0.0215, 'lps'),
	(583047, 128, '2014-03-15 01:19:33.000000', 'consum', 0.0215, 'lps'),
	(583048, 128, '2014-03-15 01:19:34.000000', 'consum', 0.0217, 'lps'),
	(583049, 128, '2014-03-15 01:19:35.000000', 'consum', 0.0212, 'lps'),
	(583050, 128, '2014-03-15 01:19:36.000000', 'consum', 0.0210, 'lps'),
	(583051, 128, '2014-03-15 01:19:37.000000', 'consum', 0.0213, 'lps'),
	(583052, 128, '2014-03-15 01:19:38.000000', 'consum', 0.0218, 'lps'),
	(583053, 128, '2014-03-15 01:19:39.000000', 'consum', 0.0217, 'lps'),
	(583054, 128, '2014-03-15 01:19:40.000000', 'consum', 0.0211, 'lps'),
	(583055, 128, '2014-03-15 01:19:41.000000', 'consum', 0.0215, 'lps'),
	(583056, 128, '2014-03-15 01:19:42.000000', 'consum', 0.0210, 'lps'),
	(583057, 128, '2014-03-15 01:19:43.000000', 'consum', 0.0220, 'lps'),
	(583058, 128, '2014-03-15 01:19:44.000000', 'consum', 0.0217, 'lps'),
	(583059, 128, '2014-03-15 01:19:45.000000', 'consum', 0.0217, 'lps'),
	(583060, 128, '2014-03-15 01:19:46.000000', 'consum', 0.0210, 'lps'),
	(583061, 128, '2014-03-15 01:19:47.000000', 'consum', 0.0213, 'lps'),
	(583062, 128, '2014-03-15 01:19:48.000000', 'consum', 0.0215, 'lps'),
	(583063, 128, '2014-03-15 01:19:49.000000', 'consum', 0.0216, 'lps'),
	(583064, 128, '2014-03-15 01:19:50.000000', 'consum', 0.0214, 'lps'),
	(583065, 128, '2014-03-15 01:19:51.000000', 'consum', 0.0211, 'lps'),
	(583066, 128, '2014-03-15 01:19:52.000000', 'consum', 0.0213, 'lps'),
	(583067, 128, '2014-03-15 01:19:53.000000', 'consum', 0.0215, 'lps'),
	(583068, 128, '2014-03-15 01:19:54.000000', 'consum', 0.0213, 'lps'),
	(583069, 128, '2014-03-15 01:19:55.000000', 'consum', 0.0211, 'lps'),
	(583070, 128, '2014-03-15 01:19:56.000000', 'consum', 0.0217, 'lps'),
	(583071, 128, '2014-03-15 01:19:57.000000', 'consum', 0.0211, 'lps'),
	(583072, 128, '2014-03-15 01:19:58.000000', 'consum', 0.0215, 'lps'),
	(583073, 128, '2014-03-15 01:19:59.000000', 'consum', 0.0210, 'lps'),
	(583074, 128, '2014-03-15 01:20:00.000000', 'consum', 0.0217, 'lps'),
	(583075, 128, '2014-03-15 01:20:01.000000', 'consum', 0.0212, 'lps'),
	(583076, 128, '2014-03-15 01:20:02.000000', 'consum', 0.0211, 'lps'),
	(583077, 128, '2014-03-15 01:20:03.000000', 'consum', 0.0219, 'lps'),
	(583078, 128, '2014-03-15 01:20:04.000000', 'consum', 0.0220, 'lps'),
	(583079, 128, '2014-03-15 01:20:05.000000', 'consum', 0.0212, 'lps'),
	(583080, 128, '2014-03-15 01:20:06.000000', 'consum', 0.0211, 'lps'),
	(583081, 128, '2014-03-15 01:20:07.000000', 'consum', 0.0212, 'lps'),
	(583082, 128, '2014-03-15 01:20:08.000000', 'consum', 0.0216, 'lps'),
	(583083, 128, '2014-03-15 01:20:09.000000', 'consum', 0.0214, 'lps'),
	(583084, 128, '2014-03-15 01:20:10.000000', 'consum', 0.0212, 'lps'),
	(583085, 128, '2014-03-15 01:20:11.000000', 'consum', 0.0218, 'lps'),
	(583086, 128, '2014-03-15 01:20:12.000000', 'consum', 0.0214, 'lps'),
	(583087, 128, '2014-03-15 01:20:13.000000', 'consum', 0.0216, 'lps'),
	(583088, 128, '2014-03-15 01:20:14.000000', 'consum', 0.0219, 'lps'),
	(583089, 128, '2014-03-15 01:20:15.000000', 'consum', 0.0213, 'lps'),
	(583090, 128, '2014-03-15 01:20:16.000000', 'consum', 0.0220, 'lps'),
	(583091, 128, '2014-03-15 01:20:17.000000', 'consum', 0.0220, 'lps'),
	(583092, 128, '2014-03-15 01:20:18.000000', 'consum', 0.0210, 'lps'),
	(583093, 128, '2014-03-15 01:20:19.000000', 'consum', 0.0213, 'lps'),
	(583094, 128, '2014-03-15 01:20:20.000000', 'consum', 0.0215, 'lps'),
	(583095, 128, '2014-03-15 01:20:21.000000', 'consum', 0.0216, 'lps'),
	(583096, 128, '2014-03-15 01:20:22.000000', 'consum', 0.0214, 'lps'),
	(583097, 128, '2014-03-15 01:20:23.000000', 'consum', 0.0212, 'lps'),
	(583098, 128, '2014-03-15 01:20:24.000000', 'consum', 0.0219, 'lps'),
	(583099, 128, '2014-03-15 01:20:25.000000', 'consum', 0.0218, 'lps'),
	(583100, 128, '2014-03-15 01:20:26.000000', 'consum', 0.0213, 'lps'),
	(583101, 128, '2014-03-15 01:20:27.000000', 'consum', 0.0214, 'lps'),
	(583102, 128, '2014-03-15 01:20:28.000000', 'consum', 0.0219, 'lps'),
	(583103, 128, '2014-03-15 01:20:29.000000', 'consum', 0.0210, 'lps'),
	(583104, 128, '2014-03-15 01:20:30.000000', 'consum', 0.0217, 'lps'),
	(583105, 128, '2014-03-15 01:20:31.000000', 'consum', 0.0213, 'lps'),
	(583106, 128, '2014-03-15 01:20:32.000000', 'consum', 0.0217, 'lps'),
	(583107, 128, '2014-03-15 01:20:33.000000', 'consum', 0.0214, 'lps'),
	(583108, 128, '2014-03-15 01:20:34.000000', 'consum', 0.0218, 'lps'),
	(583109, 128, '2014-03-15 01:20:35.000000', 'consum', 0.0220, 'lps'),
	(583110, 128, '2014-03-15 01:20:36.000000', 'consum', 0.0211, 'lps'),
	(583111, 128, '2014-03-15 01:20:37.000000', 'consum', 0.0220, 'lps'),
	(583112, 128, '2014-03-15 01:20:38.000000', 'consum', 0.0213, 'lps'),
	(583113, 128, '2014-03-15 01:20:39.000000', 'consum', 0.0220, 'lps'),
	(583114, 128, '2014-03-15 01:20:40.000000', 'consum', 0.0215, 'lps'),
	(583115, 128, '2014-03-15 01:20:41.000000', 'consum', 0.0220, 'lps'),
	(583116, 128, '2014-03-15 01:20:42.000000', 'consum', 0.0210, 'lps'),
	(583117, 128, '2014-03-15 01:20:43.000000', 'consum', 0.0214, 'lps'),
	(583118, 128, '2014-03-15 01:20:44.000000', 'consum', 0.0210, 'lps'),
	(583119, 128, '2014-03-15 01:20:45.000000', 'consum', 0.0217, 'lps'),
	(583120, 128, '2014-03-15 01:20:46.000000', 'consum', 0.0216, 'lps'),
	(583121, 128, '2014-03-15 01:20:47.000000', 'consum', 0.0220, 'lps'),
	(583122, 128, '2014-03-15 01:20:48.000000', 'consum', 0.0217, 'lps'),
	(583123, 128, '2014-03-15 01:20:49.000000', 'consum', 0.0218, 'lps'),
	(583124, 128, '2014-03-15 01:20:50.000000', 'consum', 0.0218, 'lps'),
	(583125, 128, '2014-03-15 01:20:51.000000', 'consum', 0.0216, 'lps'),
	(583126, 128, '2014-03-15 01:20:52.000000', 'consum', 0.0215, 'lps'),
	(583127, 128, '2014-03-15 01:20:53.000000', 'consum', 0.0219, 'lps'),
	(583128, 128, '2014-03-15 01:20:54.000000', 'consum', 0.0218, 'lps'),
	(583129, 128, '2014-03-15 01:20:55.000000', 'consum', 0.0213, 'lps'),
	(583130, 128, '2014-03-15 01:20:56.000000', 'consum', 0.0210, 'lps'),
	(583131, 128, '2014-03-15 01:20:57.000000', 'consum', 0.0216, 'lps'),
	(583132, 128, '2014-03-15 01:20:58.000000', 'consum', 0.0215, 'lps'),
	(583133, 128, '2014-03-15 01:20:59.000000', 'consum', 0.0219, 'lps'),
	(583134, 128, '2014-03-15 01:21:00.000000', 'consum', 0.0218, 'lps'),
	(583135, 128, '2014-03-15 01:21:01.000000', 'consum', 0.0214, 'lps'),
	(583136, 128, '2014-03-15 01:21:02.000000', 'consum', 0.0216, 'lps'),
	(583137, 128, '2014-03-15 01:21:03.000000', 'consum', 0.0217, 'lps'),
	(583138, 128, '2014-03-15 01:21:04.000000', 'consum', 0.0216, 'lps'),
	(583139, 128, '2014-03-15 01:21:05.000000', 'consum', 0.0210, 'lps'),
	(583140, 128, '2014-03-15 01:21:06.000000', 'consum', 0.0213, 'lps'),
	(583141, 128, '2014-03-15 01:21:07.000000', 'consum', 0.0214, 'lps'),
	(583142, 128, '2014-03-15 01:21:08.000000', 'consum', 0.0211, 'lps'),
	(583143, 128, '2014-03-15 01:21:09.000000', 'consum', 0.0214, 'lps'),
	(583144, 128, '2014-03-15 01:21:10.000000', 'consum', 0.0218, 'lps'),
	(583145, 128, '2014-03-15 01:21:11.000000', 'consum', 0.0216, 'lps'),
	(583146, 128, '2014-03-15 01:21:12.000000', 'consum', 0.0215, 'lps'),
	(583147, 128, '2014-03-15 01:21:13.000000', 'consum', 0.0216, 'lps'),
	(583148, 128, '2014-03-15 01:21:14.000000', 'consum', 0.0218, 'lps'),
	(583149, 128, '2014-03-15 01:21:15.000000', 'consum', 0.0219, 'lps'),
	(583150, 128, '2014-03-15 01:21:16.000000', 'consum', 0.0220, 'lps'),
	(583151, 128, '2014-03-15 01:21:17.000000', 'consum', 0.0213, 'lps'),
	(583152, 128, '2014-03-15 01:21:18.000000', 'consum', 0.0217, 'lps'),
	(583153, 128, '2014-03-15 01:21:19.000000', 'consum', 0.0213, 'lps'),
	(583154, 128, '2014-03-15 01:21:20.000000', 'consum', 0.0216, 'lps'),
	(583155, 128, '2014-03-15 01:21:21.000000', 'consum', 0.0211, 'lps'),
	(583156, 128, '2014-03-15 01:21:22.000000', 'consum', 0.0217, 'lps'),
	(583157, 128, '2014-03-15 01:21:23.000000', 'consum', 0.0212, 'lps'),
	(583158, 128, '2014-03-15 01:21:24.000000', 'consum', 0.0220, 'lps'),
	(583159, 128, '2014-03-15 01:21:25.000000', 'consum', 0.0213, 'lps'),
	(583160, 128, '2014-03-15 01:21:26.000000', 'consum', 0.0215, 'lps'),
	(583161, 128, '2014-03-15 01:21:27.000000', 'consum', 0.0214, 'lps'),
	(583162, 128, '2014-03-15 01:21:28.000000', 'consum', 0.0218, 'lps'),
	(583163, 128, '2014-03-15 01:21:29.000000', 'consum', 0.0215, 'lps'),
	(583164, 128, '2014-03-15 01:21:30.000000', 'consum', 0.0212, 'lps'),
	(583165, 128, '2014-03-15 01:21:31.000000', 'consum', 0.0216, 'lps'),
	(583166, 128, '2014-03-15 01:21:32.000000', 'consum', 0.0215, 'lps'),
	(583167, 128, '2014-03-15 01:21:33.000000', 'consum', 0.0214, 'lps'),
	(583168, 128, '2014-03-15 01:21:34.000000', 'consum', 0.0218, 'lps'),
	(583169, 128, '2014-03-15 01:21:35.000000', 'consum', 0.0217, 'lps'),
	(583170, 128, '2014-03-15 01:21:36.000000', 'consum', 0.0211, 'lps'),
	(583171, 128, '2014-03-15 01:21:37.000000', 'consum', 0.0215, 'lps'),
	(583172, 128, '2014-03-15 01:21:38.000000', 'consum', 0.0212, 'lps'),
	(583173, 128, '2014-03-15 01:21:39.000000', 'consum', 0.0214, 'lps'),
	(583174, 128, '2014-03-15 01:21:40.000000', 'consum', 0.0214, 'lps'),
	(583175, 128, '2014-03-15 01:21:41.000000', 'consum', 0.0210, 'lps'),
	(583176, 128, '2014-03-15 01:21:42.000000', 'consum', 0.0217, 'lps'),
	(583177, 128, '2014-03-15 01:21:43.000000', 'consum', 0.0215, 'lps'),
	(583178, 128, '2014-03-15 01:21:44.000000', 'consum', 0.0215, 'lps'),
	(583179, 128, '2014-03-15 01:21:45.000000', 'consum', 0.0219, 'lps'),
	(583180, 128, '2014-03-15 01:21:46.000000', 'consum', 0.0219, 'lps'),
	(583181, 128, '2014-03-15 01:21:47.000000', 'consum', 0.0218, 'lps'),
	(583182, 128, '2014-03-15 01:21:48.000000', 'consum', 0.0213, 'lps'),
	(583183, 128, '2014-03-15 01:21:49.000000', 'consum', 0.0214, 'lps'),
	(583184, 128, '2014-03-15 01:21:50.000000', 'consum', 0.0219, 'lps'),
	(583185, 128, '2014-03-15 01:21:51.000000', 'consum', 0.0220, 'lps'),
	(583186, 128, '2014-03-15 01:21:52.000000', 'consum', 0.0214, 'lps'),
	(583187, 128, '2014-03-15 01:21:53.000000', 'consum', 0.0210, 'lps'),
	(583188, 128, '2014-03-15 01:21:54.000000', 'consum', 0.0211, 'lps'),
	(583189, 128, '2014-03-15 01:21:55.000000', 'consum', 0.0213, 'lps'),
	(583190, 128, '2014-03-15 01:21:56.000000', 'consum', 0.0214, 'lps'),
	(583191, 128, '2014-03-15 01:21:57.000000', 'consum', 0.0211, 'lps'),
	(583192, 128, '2014-03-15 01:21:58.000000', 'consum', 0.0214, 'lps'),
	(583193, 128, '2014-03-15 01:21:59.000000', 'consum', 0.0215, 'lps'),
	(583194, 128, '2014-03-15 01:22:00.000000', 'consum', 0.0215, 'lps'),
	(583195, 128, '2014-03-15 01:22:01.000000', 'consum', 0.0217, 'lps'),
	(583196, 128, '2014-03-15 01:22:02.000000', 'consum', 0.0212, 'lps'),
	(583197, 128, '2014-03-15 01:22:03.000000', 'consum', 0.0218, 'lps'),
	(583198, 128, '2014-03-15 01:22:04.000000', 'consum', 0.0215, 'lps'),
	(583199, 128, '2014-03-15 01:22:05.000000', 'consum', 0.0211, 'lps'),
	(583200, 128, '2014-03-15 01:22:06.000000', 'consum', 0.0210, 'lps'),
	(583201, 128, '2014-03-15 01:22:07.000000', 'consum', 0.0218, 'lps'),
	(583202, 128, '2014-03-15 01:22:08.000000', 'consum', 0.0219, 'lps'),
	(583203, 128, '2014-03-15 01:22:09.000000', 'consum', 0.0219, 'lps'),
	(583204, 128, '2014-03-15 01:22:10.000000', 'consum', 0.0220, 'lps'),
	(583205, 128, '2014-03-15 01:22:11.000000', 'consum', 0.0211, 'lps'),
	(583206, 128, '2014-03-15 01:22:12.000000', 'consum', 0.0219, 'lps'),
	(583207, 128, '2014-03-15 01:22:13.000000', 'consum', 0.0220, 'lps'),
	(583208, 128, '2014-03-15 01:22:14.000000', 'consum', 0.0220, 'lps'),
	(583209, 128, '2014-03-15 01:22:15.000000', 'consum', 0.0211, 'lps'),
	(583210, 128, '2014-03-15 01:22:16.000000', 'consum', 0.0216, 'lps'),
	(583211, 128, '2014-03-15 01:22:17.000000', 'consum', 0.0215, 'lps'),
	(583212, 128, '2014-03-15 01:22:18.000000', 'consum', 0.0218, 'lps'),
	(583213, 128, '2014-03-15 01:22:19.000000', 'consum', 0.0214, 'lps'),
	(583214, 128, '2014-03-15 01:22:20.000000', 'consum', 0.0218, 'lps'),
	(583215, 128, '2014-03-15 01:22:21.000000', 'consum', 0.0217, 'lps'),
	(583216, 128, '2014-03-15 01:22:22.000000', 'consum', 0.0211, 'lps'),
	(583217, 128, '2014-03-15 01:22:23.000000', 'consum', 0.0214, 'lps'),
	(583218, 128, '2014-03-15 01:22:24.000000', 'consum', 0.0218, 'lps'),
	(583219, 128, '2014-03-15 01:22:25.000000', 'consum', 0.0216, 'lps'),
	(583220, 128, '2014-03-15 01:22:26.000000', 'consum', 0.0217, 'lps'),
	(583221, 128, '2014-03-15 01:22:27.000000', 'consum', 0.0214, 'lps'),
	(583222, 128, '2014-03-15 01:22:28.000000', 'consum', 0.0213, 'lps'),
	(583223, 128, '2014-03-15 01:22:29.000000', 'consum', 0.0211, 'lps'),
	(583224, 128, '2014-03-15 01:22:30.000000', 'consum', 0.0218, 'lps'),
	(583225, 128, '2014-03-15 01:22:31.000000', 'consum', 0.0214, 'lps'),
	(583226, 128, '2014-03-15 01:22:32.000000', 'consum', 0.0219, 'lps'),
	(583227, 128, '2014-03-15 01:22:33.000000', 'consum', 0.0210, 'lps'),
	(583228, 128, '2014-03-15 01:22:34.000000', 'consum', 0.0214, 'lps'),
	(583229, 128, '2014-03-15 01:22:35.000000', 'consum', 0.0212, 'lps'),
	(583230, 128, '2014-03-15 01:22:36.000000', 'consum', 0.0217, 'lps'),
	(583231, 128, '2014-03-15 01:22:37.000000', 'consum', 0.0217, 'lps'),
	(583232, 128, '2014-03-15 01:22:38.000000', 'consum', 0.0216, 'lps'),
	(583233, 128, '2014-03-15 01:22:39.000000', 'consum', 0.0219, 'lps'),
	(583234, 128, '2014-03-15 01:22:40.000000', 'consum', 0.0214, 'lps'),
	(583235, 128, '2014-03-15 01:22:41.000000', 'consum', 0.0216, 'lps'),
	(583236, 128, '2014-03-15 01:22:42.000000', 'consum', 0.0216, 'lps'),
	(583237, 128, '2014-03-15 01:22:43.000000', 'consum', 0.0212, 'lps'),
	(583238, 128, '2014-03-15 01:22:44.000000', 'consum', 0.0215, 'lps'),
	(583239, 128, '2014-03-15 01:22:45.000000', 'consum', 0.0218, 'lps'),
	(583240, 128, '2014-03-15 01:22:46.000000', 'consum', 0.0214, 'lps'),
	(583241, 128, '2014-03-15 01:22:47.000000', 'consum', 0.0216, 'lps'),
	(583242, 128, '2014-03-15 01:22:48.000000', 'consum', 0.0220, 'lps'),
	(583243, 128, '2014-03-15 01:22:49.000000', 'consum', 0.0218, 'lps'),
	(583244, 128, '2014-03-15 01:22:50.000000', 'consum', 0.0219, 'lps'),
	(583245, 128, '2014-03-15 01:22:51.000000', 'consum', 0.0213, 'lps'),
	(583246, 128, '2014-03-15 01:22:52.000000', 'consum', 0.0217, 'lps'),
	(583247, 128, '2014-03-15 01:22:53.000000', 'consum', 0.0217, 'lps'),
	(583248, 128, '2014-03-15 01:22:54.000000', 'consum', 0.0212, 'lps'),
	(583249, 128, '2014-03-15 01:22:55.000000', 'consum', 0.0220, 'lps'),
	(583250, 128, '2014-03-15 01:22:56.000000', 'consum', 0.0213, 'lps'),
	(583251, 128, '2014-03-15 01:22:57.000000', 'consum', 0.0217, 'lps'),
	(583252, 128, '2014-03-15 01:22:58.000000', 'consum', 0.0216, 'lps'),
	(583253, 128, '2014-03-15 01:22:59.000000', 'consum', 0.0220, 'lps'),
	(583254, 128, '2014-03-15 01:23:00.000000', 'consum', 0.0219, 'lps'),
	(583255, 128, '2014-03-15 01:23:01.000000', 'consum', 0.0215, 'lps'),
	(583256, 128, '2014-03-15 01:23:02.000000', 'consum', 0.0210, 'lps'),
	(583257, 128, '2014-03-15 01:23:03.000000', 'consum', 0.0218, 'lps'),
	(583258, 128, '2014-03-15 01:23:04.000000', 'consum', 0.0216, 'lps'),
	(583259, 128, '2014-03-15 01:23:05.000000', 'consum', 0.0217, 'lps'),
	(583260, 128, '2014-03-15 01:23:06.000000', 'consum', 0.0218, 'lps'),
	(583261, 128, '2014-03-15 01:23:07.000000', 'consum', 0.0217, 'lps'),
	(583262, 128, '2014-03-15 01:23:08.000000', 'consum', 0.0212, 'lps'),
	(583263, 128, '2014-03-15 01:23:09.000000', 'consum', 0.0211, 'lps'),
	(583264, 128, '2014-03-15 01:23:10.000000', 'consum', 0.0218, 'lps'),
	(583265, 128, '2014-03-15 01:23:11.000000', 'consum', 0.0216, 'lps'),
	(583266, 128, '2014-03-15 01:23:12.000000', 'consum', 0.0218, 'lps'),
	(583267, 128, '2014-03-15 01:23:13.000000', 'consum', 0.0210, 'lps'),
	(583268, 128, '2014-03-15 01:23:14.000000', 'consum', 0.0219, 'lps'),
	(583269, 128, '2014-03-15 01:23:15.000000', 'consum', 0.0210, 'lps'),
	(583270, 128, '2014-03-15 01:23:16.000000', 'consum', 0.0218, 'lps'),
	(583271, 128, '2014-03-15 01:23:17.000000', 'consum', 0.0218, 'lps'),
	(583272, 128, '2014-03-15 01:23:18.000000', 'consum', 0.0216, 'lps'),
	(583273, 128, '2014-03-15 01:23:19.000000', 'consum', 0.0215, 'lps'),
	(583274, 128, '2014-03-15 01:23:20.000000', 'consum', 0.0218, 'lps'),
	(583275, 128, '2014-03-15 01:23:21.000000', 'consum', 0.0213, 'lps'),
	(583276, 128, '2014-03-15 01:23:22.000000', 'consum', 0.0211, 'lps'),
	(583277, 128, '2014-03-15 01:23:23.000000', 'consum', 0.0210, 'lps'),
	(583278, 128, '2014-03-15 01:23:24.000000', 'consum', 0.0215, 'lps'),
	(583279, 128, '2014-03-15 01:23:25.000000', 'consum', 0.0214, 'lps'),
	(583280, 128, '2014-03-15 01:23:26.000000', 'consum', 0.0218, 'lps'),
	(583281, 128, '2014-03-15 01:23:27.000000', 'consum', 0.0216, 'lps'),
	(583282, 128, '2014-03-15 01:23:28.000000', 'consum', 0.0215, 'lps'),
	(583283, 128, '2014-03-15 01:23:29.000000', 'consum', 0.0217, 'lps'),
	(583284, 128, '2014-03-15 01:23:30.000000', 'consum', 0.0219, 'lps'),
	(583285, 128, '2014-03-15 01:23:31.000000', 'consum', 0.0212, 'lps'),
	(583286, 128, '2014-03-15 01:23:32.000000', 'consum', 0.0217, 'lps'),
	(583287, 128, '2014-03-15 01:23:33.000000', 'consum', 0.0217, 'lps'),
	(583288, 128, '2014-03-15 01:23:34.000000', 'consum', 0.0213, 'lps'),
	(583289, 128, '2014-03-15 01:23:35.000000', 'consum', 0.0216, 'lps'),
	(583290, 128, '2014-03-15 01:23:36.000000', 'consum', 0.0211, 'lps'),
	(583291, 128, '2014-03-15 01:23:37.000000', 'consum', 0.0218, 'lps'),
	(583292, 128, '2014-03-15 01:23:38.000000', 'consum', 0.0214, 'lps'),
	(583293, 128, '2014-03-15 01:23:39.000000', 'consum', 0.0218, 'lps'),
	(583294, 128, '2014-03-15 01:23:40.000000', 'consum', 0.0216, 'lps'),
	(583295, 128, '2014-03-15 01:23:41.000000', 'consum', 0.0218, 'lps'),
	(583296, 128, '2014-03-15 01:23:42.000000', 'consum', 0.0219, 'lps'),
	(583297, 128, '2014-03-15 01:23:43.000000', 'consum', 0.0210, 'lps'),
	(583298, 128, '2014-03-15 01:23:44.000000', 'consum', 0.0215, 'lps'),
	(583299, 128, '2014-03-15 01:23:45.000000', 'consum', 0.0216, 'lps'),
	(583300, 128, '2014-03-15 01:23:46.000000', 'consum', 0.0215, 'lps'),
	(583301, 128, '2014-03-15 01:23:47.000000', 'consum', 0.0217, 'lps'),
	(583302, 128, '2014-03-15 01:23:48.000000', 'consum', 0.0220, 'lps'),
	(583303, 128, '2014-03-15 01:23:49.000000', 'consum', 0.0219, 'lps'),
	(583304, 128, '2014-03-15 01:23:50.000000', 'consum', 0.0212, 'lps'),
	(583305, 128, '2014-03-15 01:23:51.000000', 'consum', 0.0216, 'lps'),
	(583306, 128, '2014-03-15 01:23:52.000000', 'consum', 0.0211, 'lps'),
	(583307, 128, '2014-03-15 01:23:53.000000', 'consum', 0.0220, 'lps'),
	(583308, 128, '2014-03-15 01:23:54.000000', 'consum', 0.0215, 'lps'),
	(583309, 128, '2014-03-15 01:23:55.000000', 'consum', 0.0217, 'lps'),
	(583310, 128, '2014-03-15 01:23:56.000000', 'consum', 0.0220, 'lps'),
	(583311, 128, '2014-03-15 01:23:57.000000', 'consum', 0.0217, 'lps'),
	(583312, 128, '2014-03-15 01:23:58.000000', 'consum', 0.0214, 'lps'),
	(583313, 128, '2014-03-15 01:23:59.000000', 'consum', 0.0211, 'lps'),
	(583314, 128, '2014-03-15 01:24:00.000000', 'consum', 0.0215, 'lps'),
	(583315, 128, '2014-03-15 01:24:01.000000', 'consum', 0.0210, 'lps'),
	(583316, 128, '2014-03-15 01:24:02.000000', 'consum', 0.0218, 'lps'),
	(583317, 128, '2014-03-15 01:24:03.000000', 'consum', 0.0218, 'lps'),
	(583318, 128, '2014-03-15 01:24:04.000000', 'consum', 0.0214, 'lps'),
	(583319, 128, '2014-03-15 01:24:05.000000', 'consum', 0.0217, 'lps'),
	(583320, 128, '2014-03-15 01:24:06.000000', 'consum', 0.0210, 'lps'),
	(583321, 128, '2014-03-15 01:24:07.000000', 'consum', 0.0214, 'lps'),
	(583322, 128, '2014-03-15 01:24:08.000000', 'consum', 0.0218, 'lps'),
	(583323, 128, '2014-03-15 01:24:09.000000', 'consum', 0.0219, 'lps'),
	(583324, 128, '2014-03-15 01:24:10.000000', 'consum', 0.0220, 'lps'),
	(583325, 128, '2014-03-15 01:24:11.000000', 'consum', 0.0220, 'lps'),
	(583326, 128, '2014-03-15 01:24:12.000000', 'consum', 0.0220, 'lps'),
	(583327, 128, '2014-03-15 01:24:13.000000', 'consum', 0.0210, 'lps'),
	(583328, 128, '2014-03-15 01:24:14.000000', 'consum', 0.0214, 'lps'),
	(583329, 128, '2014-03-15 01:24:15.000000', 'consum', 0.0219, 'lps'),
	(583330, 128, '2014-03-15 01:24:16.000000', 'consum', 0.0219, 'lps'),
	(583331, 128, '2014-03-15 01:24:17.000000', 'consum', 0.0220, 'lps'),
	(583332, 128, '2014-03-15 01:24:18.000000', 'consum', 0.0210, 'lps'),
	(583333, 128, '2014-03-15 01:24:19.000000', 'consum', 0.0213, 'lps'),
	(583334, 128, '2014-03-15 01:24:20.000000', 'consum', 0.0217, 'lps'),
	(583335, 128, '2014-03-15 01:24:21.000000', 'consum', 0.0214, 'lps'),
	(583336, 128, '2014-03-15 01:24:22.000000', 'consum', 0.0220, 'lps'),
	(583337, 128, '2014-03-15 01:24:23.000000', 'consum', 0.0216, 'lps'),
	(583338, 128, '2014-03-15 01:24:24.000000', 'consum', 0.0210, 'lps'),
	(583339, 128, '2014-03-15 01:24:25.000000', 'consum', 0.0213, 'lps'),
	(583340, 128, '2014-03-15 01:24:26.000000', 'consum', 0.0216, 'lps'),
	(583341, 128, '2014-03-15 01:24:27.000000', 'consum', 0.0210, 'lps'),
	(583342, 128, '2014-03-15 01:24:28.000000', 'consum', 0.0215, 'lps'),
	(583343, 128, '2014-03-15 01:24:29.000000', 'consum', 0.0211, 'lps'),
	(583344, 128, '2014-03-15 01:24:30.000000', 'consum', 0.0211, 'lps'),
	(583345, 128, '2014-03-15 01:24:31.000000', 'consum', 0.0216, 'lps'),
	(583346, 128, '2014-03-15 01:24:32.000000', 'consum', 0.0212, 'lps'),
	(583347, 128, '2014-03-15 01:24:33.000000', 'consum', 0.0214, 'lps'),
	(583348, 128, '2014-03-15 01:24:34.000000', 'consum', 0.0213, 'lps'),
	(583349, 128, '2014-03-15 01:24:35.000000', 'consum', 0.0215, 'lps'),
	(583350, 128, '2014-03-15 01:24:36.000000', 'consum', 0.0216, 'lps'),
	(583351, 128, '2014-03-15 01:24:37.000000', 'consum', 0.0213, 'lps'),
	(583352, 128, '2014-03-15 01:24:38.000000', 'consum', 0.0220, 'lps'),
	(583353, 128, '2014-03-15 01:24:39.000000', 'consum', 0.0218, 'lps'),
	(583354, 128, '2014-03-15 01:24:40.000000', 'consum', 0.0220, 'lps'),
	(583355, 128, '2014-03-15 01:24:41.000000', 'consum', 0.0213, 'lps'),
	(583356, 128, '2014-03-15 01:24:42.000000', 'consum', 0.0220, 'lps'),
	(583357, 128, '2014-03-15 01:24:43.000000', 'consum', 0.0217, 'lps'),
	(583358, 128, '2014-03-15 01:24:44.000000', 'consum', 0.0217, 'lps'),
	(583359, 128, '2014-03-15 01:24:45.000000', 'consum', 0.0214, 'lps'),
	(583360, 128, '2014-03-15 01:24:46.000000', 'consum', 0.0219, 'lps'),
	(583361, 128, '2014-03-15 01:24:47.000000', 'consum', 0.0211, 'lps'),
	(583362, 128, '2014-03-15 01:24:48.000000', 'consum', 0.0211, 'lps'),
	(583363, 128, '2014-03-15 01:24:49.000000', 'consum', 0.0210, 'lps'),
	(583364, 128, '2014-03-15 01:24:50.000000', 'consum', 0.0220, 'lps'),
	(583365, 128, '2014-03-15 01:24:51.000000', 'consum', 0.0216, 'lps'),
	(583366, 128, '2014-03-15 01:24:52.000000', 'consum', 0.0211, 'lps'),
	(583367, 128, '2014-03-15 01:24:53.000000', 'consum', 0.0218, 'lps'),
	(583368, 128, '2014-03-15 01:24:54.000000', 'consum', 0.0215, 'lps'),
	(583369, 128, '2014-03-15 01:24:55.000000', 'consum', 0.0210, 'lps'),
	(583370, 128, '2014-03-15 01:24:56.000000', 'consum', 0.0219, 'lps'),
	(583371, 128, '2014-03-15 01:24:57.000000', 'consum', 0.0220, 'lps'),
	(583372, 128, '2014-03-15 01:24:58.000000', 'consum', 0.0215, 'lps'),
	(583373, 128, '2014-03-15 01:24:59.000000', 'consum', 0.0214, 'lps'),
	(583374, 128, '2014-03-15 01:25:00.000000', 'consum', 0.0217, 'lps'),
	(583375, 128, '2014-03-15 01:25:01.000000', 'consum', 0.0210, 'lps'),
	(583376, 128, '2014-03-15 01:25:02.000000', 'consum', 0.0212, 'lps'),
	(583377, 128, '2014-03-15 01:25:03.000000', 'consum', 0.0212, 'lps'),
	(583378, 128, '2014-03-15 01:25:04.000000', 'consum', 0.0211, 'lps'),
	(583379, 128, '2014-03-15 01:25:05.000000', 'consum', 0.0210, 'lps'),
	(583380, 128, '2014-03-15 01:25:06.000000', 'consum', 0.0220, 'lps'),
	(583381, 128, '2014-03-15 01:25:07.000000', 'consum', 0.0216, 'lps'),
	(583382, 128, '2014-03-15 01:25:08.000000', 'consum', 0.0211, 'lps'),
	(583383, 128, '2014-03-15 01:25:09.000000', 'consum', 0.0217, 'lps'),
	(583384, 128, '2014-03-15 01:25:10.000000', 'consum', 0.0213, 'lps'),
	(583385, 128, '2014-03-15 01:25:11.000000', 'consum', 0.0213, 'lps'),
	(583386, 128, '2014-03-15 01:25:12.000000', 'consum', 0.0216, 'lps'),
	(583387, 128, '2014-03-15 01:25:13.000000', 'consum', 0.0211, 'lps'),
	(583388, 128, '2014-03-15 01:25:14.000000', 'consum', 0.0220, 'lps'),
	(583389, 128, '2014-03-15 01:25:15.000000', 'consum', 0.0213, 'lps'),
	(583390, 128, '2014-03-15 01:25:16.000000', 'consum', 0.0216, 'lps'),
	(583391, 128, '2014-03-15 01:25:17.000000', 'consum', 0.0210, 'lps'),
	(583392, 128, '2014-03-15 01:25:18.000000', 'consum', 0.0214, 'lps'),
	(583393, 128, '2014-03-15 01:25:19.000000', 'consum', 0.0219, 'lps'),
	(583394, 128, '2014-03-15 01:25:20.000000', 'consum', 0.0212, 'lps'),
	(583395, 128, '2014-03-15 01:25:21.000000', 'consum', 0.0213, 'lps'),
	(583396, 128, '2014-03-15 01:25:22.000000', 'consum', 0.0210, 'lps'),
	(583397, 128, '2014-03-15 01:25:23.000000', 'consum', 0.0211, 'lps'),
	(583398, 128, '2014-03-15 01:25:24.000000', 'consum', 0.0216, 'lps'),
	(583399, 128, '2014-03-15 01:25:25.000000', 'consum', 0.0217, 'lps'),
	(583400, 128, '2014-03-15 01:25:26.000000', 'consum', 0.0216, 'lps'),
	(583401, 128, '2014-03-15 01:25:27.000000', 'consum', 0.0220, 'lps'),
	(583402, 128, '2014-03-15 01:25:28.000000', 'consum', 0.0211, 'lps'),
	(583403, 128, '2014-03-15 01:25:29.000000', 'consum', 0.0217, 'lps'),
	(583404, 128, '2014-03-15 01:25:30.000000', 'consum', 0.0220, 'lps'),
	(583405, 128, '2014-03-15 01:25:31.000000', 'consum', 0.0216, 'lps'),
	(583406, 128, '2014-03-15 01:25:32.000000', 'consum', 0.0211, 'lps'),
	(583407, 128, '2014-03-15 01:25:33.000000', 'consum', 0.0211, 'lps'),
	(583408, 128, '2014-03-15 01:25:34.000000', 'consum', 0.0210, 'lps'),
	(583409, 128, '2014-03-15 01:25:35.000000', 'consum', 0.0210, 'lps'),
	(583410, 128, '2014-03-15 01:25:36.000000', 'consum', 0.0211, 'lps'),
	(583411, 128, '2014-03-15 01:25:37.000000', 'consum', 0.0214, 'lps'),
	(583412, 128, '2014-03-15 01:25:38.000000', 'consum', 0.0215, 'lps'),
	(583413, 128, '2014-03-15 01:25:39.000000', 'consum', 0.0212, 'lps'),
	(583414, 128, '2014-03-15 01:25:40.000000', 'consum', 0.0218, 'lps'),
	(583415, 128, '2014-03-15 01:25:41.000000', 'consum', 0.0213, 'lps'),
	(583416, 128, '2014-03-15 01:25:42.000000', 'consum', 0.0210, 'lps'),
	(583417, 128, '2014-03-15 01:25:43.000000', 'consum', 0.0213, 'lps'),
	(583418, 128, '2014-03-15 01:25:44.000000', 'consum', 0.0215, 'lps'),
	(583419, 128, '2014-03-15 01:25:45.000000', 'consum', 0.0215, 'lps'),
	(583420, 128, '2014-03-15 01:25:46.000000', 'consum', 0.0211, 'lps'),
	(583421, 128, '2014-03-15 01:25:47.000000', 'consum', 0.0213, 'lps'),
	(583422, 128, '2014-03-15 01:25:48.000000', 'consum', 0.0219, 'lps'),
	(583423, 128, '2014-03-15 01:25:49.000000', 'consum', 0.0215, 'lps'),
	(583424, 128, '2014-03-15 01:25:50.000000', 'consum', 0.0210, 'lps'),
	(583425, 128, '2014-03-15 01:25:51.000000', 'consum', 0.0216, 'lps'),
	(583426, 128, '2014-03-15 01:25:52.000000', 'consum', 0.0218, 'lps'),
	(583427, 128, '2014-03-15 01:25:53.000000', 'consum', 0.0210, 'lps'),
	(583428, 128, '2014-03-15 01:25:54.000000', 'consum', 0.0218, 'lps'),
	(583429, 128, '2014-03-15 01:25:55.000000', 'consum', 0.0220, 'lps'),
	(583430, 128, '2014-03-15 01:25:56.000000', 'consum', 0.0214, 'lps'),
	(583431, 128, '2014-03-15 01:25:57.000000', 'consum', 0.0211, 'lps'),
	(583432, 128, '2014-03-15 01:25:58.000000', 'consum', 0.0215, 'lps'),
	(583433, 128, '2014-03-15 01:25:59.000000', 'consum', 0.0210, 'lps'),
	(583434, 128, '2014-03-15 01:26:00.000000', 'consum', 0.0218, 'lps'),
	(583435, 128, '2014-03-15 01:26:01.000000', 'consum', 0.0217, 'lps'),
	(583436, 128, '2014-03-15 01:26:02.000000', 'consum', 0.0220, 'lps'),
	(583437, 128, '2014-03-15 01:26:03.000000', 'consum', 0.0218, 'lps'),
	(583438, 128, '2014-03-15 01:26:04.000000', 'consum', 0.0219, 'lps'),
	(583439, 128, '2014-03-15 01:26:05.000000', 'consum', 0.0213, 'lps'),
	(583440, 128, '2014-03-15 01:26:06.000000', 'consum', 0.0219, 'lps'),
	(583441, 128, '2014-03-15 01:26:07.000000', 'consum', 0.0214, 'lps'),
	(583442, 128, '2014-03-15 01:26:08.000000', 'consum', 0.0214, 'lps'),
	(583443, 128, '2014-03-15 01:26:09.000000', 'consum', 0.0220, 'lps'),
	(583444, 128, '2014-03-15 01:26:10.000000', 'consum', 0.0214, 'lps'),
	(583445, 128, '2014-03-15 01:26:11.000000', 'consum', 0.0214, 'lps'),
	(583446, 128, '2014-03-15 01:26:12.000000', 'consum', 0.0215, 'lps'),
	(583447, 128, '2014-03-15 01:26:13.000000', 'consum', 0.0213, 'lps'),
	(583448, 128, '2014-03-15 01:26:14.000000', 'consum', 0.0213, 'lps'),
	(583449, 128, '2014-03-15 01:26:15.000000', 'consum', 0.0214, 'lps'),
	(583450, 128, '2014-03-15 01:26:16.000000', 'consum', 0.0213, 'lps'),
	(583451, 128, '2014-03-15 01:26:17.000000', 'consum', 0.0213, 'lps'),
	(583452, 128, '2014-03-15 01:26:18.000000', 'consum', 0.0217, 'lps'),
	(583453, 128, '2014-03-15 01:26:19.000000', 'consum', 0.0213, 'lps'),
	(583454, 128, '2014-03-15 01:26:20.000000', 'consum', 0.0217, 'lps'),
	(583455, 128, '2014-03-15 01:26:21.000000', 'consum', 0.0212, 'lps'),
	(583456, 128, '2014-03-15 01:26:22.000000', 'consum', 0.0212, 'lps'),
	(583457, 128, '2014-03-15 01:26:23.000000', 'consum', 0.0216, 'lps'),
	(583458, 128, '2014-03-15 01:26:24.000000', 'consum', 0.0211, 'lps'),
	(583459, 128, '2014-03-15 01:26:25.000000', 'consum', 0.0218, 'lps'),
	(583460, 128, '2014-03-15 01:26:26.000000', 'consum', 0.0214, 'lps'),
	(583461, 128, '2014-03-15 01:26:27.000000', 'consum', 0.0219, 'lps'),
	(583462, 128, '2014-03-15 01:26:28.000000', 'consum', 0.0210, 'lps'),
	(583463, 128, '2014-03-15 01:26:29.000000', 'consum', 0.0216, 'lps'),
	(583464, 128, '2014-03-15 01:26:30.000000', 'consum', 0.0219, 'lps'),
	(583465, 128, '2014-03-15 01:26:31.000000', 'consum', 0.0215, 'lps'),
	(583466, 128, '2014-03-15 01:26:32.000000', 'consum', 0.0211, 'lps'),
	(583467, 128, '2014-03-15 01:26:33.000000', 'consum', 0.0220, 'lps'),
	(583468, 128, '2014-03-15 01:26:34.000000', 'consum', 0.0213, 'lps'),
	(583469, 128, '2014-03-15 01:26:35.000000', 'consum', 0.0217, 'lps'),
	(583470, 128, '2014-03-15 01:26:36.000000', 'consum', 0.0216, 'lps'),
	(583471, 128, '2014-03-15 01:26:37.000000', 'consum', 0.0219, 'lps'),
	(583472, 128, '2014-03-15 01:26:38.000000', 'consum', 0.0215, 'lps'),
	(583473, 128, '2014-03-15 01:26:39.000000', 'consum', 0.0210, 'lps'),
	(583474, 128, '2014-03-15 01:26:40.000000', 'consum', 0.0218, 'lps'),
	(583475, 128, '2014-03-15 01:26:41.000000', 'consum', 0.0215, 'lps'),
	(583476, 128, '2014-03-15 01:26:42.000000', 'consum', 0.0214, 'lps'),
	(583477, 128, '2014-03-15 01:26:43.000000', 'consum', 0.0215, 'lps'),
	(583478, 128, '2014-03-15 01:26:44.000000', 'consum', 0.0211, 'lps'),
	(583479, 128, '2014-03-15 01:26:45.000000', 'consum', 0.0212, 'lps'),
	(583480, 128, '2014-03-15 01:26:46.000000', 'consum', 0.0219, 'lps'),
	(583481, 128, '2014-03-15 01:26:47.000000', 'consum', 0.0215, 'lps'),
	(583482, 128, '2014-03-15 01:26:48.000000', 'consum', 0.0220, 'lps'),
	(583483, 128, '2014-03-15 01:26:49.000000', 'consum', 0.0211, 'lps'),
	(583484, 128, '2014-03-15 01:26:50.000000', 'consum', 0.0219, 'lps'),
	(583485, 128, '2014-03-15 01:26:51.000000', 'consum', 0.0211, 'lps'),
	(583486, 128, '2014-03-15 01:26:52.000000', 'consum', 0.0218, 'lps'),
	(583487, 128, '2014-03-15 01:26:53.000000', 'consum', 0.0218, 'lps'),
	(583488, 128, '2014-03-15 01:26:54.000000', 'consum', 0.0213, 'lps'),
	(583489, 128, '2014-03-15 01:26:55.000000', 'consum', 0.0213, 'lps'),
	(583490, 128, '2014-03-15 01:26:56.000000', 'consum', 0.0219, 'lps'),
	(583491, 128, '2014-03-15 01:26:57.000000', 'consum', 0.0211, 'lps'),
	(583492, 128, '2014-03-15 01:26:58.000000', 'consum', 0.0210, 'lps'),
	(583493, 128, '2014-03-15 01:26:59.000000', 'consum', 0.0219, 'lps'),
	(583494, 128, '2014-03-15 01:27:00.000000', 'consum', 0.0213, 'lps'),
	(583495, 128, '2014-03-15 01:27:01.000000', 'consum', 0.0211, 'lps'),
	(583496, 128, '2014-03-15 01:27:02.000000', 'consum', 0.0214, 'lps'),
	(583497, 128, '2014-03-15 01:27:03.000000', 'consum', 0.0217, 'lps'),
	(583498, 128, '2014-03-15 01:27:04.000000', 'consum', 0.0213, 'lps'),
	(583499, 128, '2014-03-15 01:27:05.000000', 'consum', 0.0215, 'lps'),
	(583500, 128, '2014-03-15 01:27:06.000000', 'consum', 0.0215, 'lps'),
	(583501, 128, '2014-03-15 01:27:07.000000', 'consum', 0.0220, 'lps'),
	(583502, 128, '2014-03-15 01:27:08.000000', 'consum', 0.0213, 'lps'),
	(583503, 128, '2014-03-15 01:27:09.000000', 'consum', 0.0219, 'lps'),
	(583504, 128, '2014-03-15 01:27:10.000000', 'consum', 0.0212, 'lps'),
	(583505, 128, '2014-03-15 01:27:11.000000', 'consum', 0.0217, 'lps'),
	(583506, 128, '2014-03-15 01:27:12.000000', 'consum', 0.0216, 'lps'),
	(583507, 128, '2014-03-15 01:27:13.000000', 'consum', 0.0219, 'lps'),
	(583508, 128, '2014-03-15 01:27:14.000000', 'consum', 0.0215, 'lps'),
	(583509, 128, '2014-03-15 01:27:15.000000', 'consum', 0.0220, 'lps'),
	(583510, 128, '2014-03-15 01:27:16.000000', 'consum', 0.0211, 'lps'),
	(583511, 128, '2014-03-15 01:27:17.000000', 'consum', 0.0219, 'lps'),
	(583512, 128, '2014-03-15 01:27:18.000000', 'consum', 0.0211, 'lps'),
	(583513, 128, '2014-03-15 01:27:19.000000', 'consum', 0.0220, 'lps'),
	(583514, 128, '2014-03-15 01:27:20.000000', 'consum', 0.0214, 'lps'),
	(583515, 128, '2014-03-15 01:27:21.000000', 'consum', 0.0211, 'lps'),
	(583516, 128, '2014-03-15 01:27:22.000000', 'consum', 0.0214, 'lps'),
	(583517, 128, '2014-03-15 01:27:23.000000', 'consum', 0.0216, 'lps'),
	(583518, 128, '2014-03-15 01:27:24.000000', 'consum', 0.0217, 'lps'),
	(583519, 128, '2014-03-15 01:27:25.000000', 'consum', 0.0215, 'lps'),
	(583520, 128, '2014-03-15 01:27:26.000000', 'consum', 0.0217, 'lps'),
	(583521, 128, '2014-03-15 01:27:27.000000', 'consum', 0.0218, 'lps'),
	(583522, 128, '2014-03-15 01:27:28.000000', 'consum', 0.0210, 'lps'),
	(583523, 128, '2014-03-15 01:27:29.000000', 'consum', 0.0219, 'lps'),
	(583524, 128, '2014-03-15 01:27:30.000000', 'consum', 0.0212, 'lps'),
	(583525, 128, '2014-03-15 01:27:31.000000', 'consum', 0.0213, 'lps'),
	(583526, 128, '2014-03-15 01:27:32.000000', 'consum', 0.0211, 'lps'),
	(583527, 128, '2014-03-15 01:27:33.000000', 'consum', 0.0215, 'lps'),
	(583528, 128, '2014-03-15 01:27:34.000000', 'consum', 0.0210, 'lps'),
	(583529, 128, '2014-03-15 01:27:35.000000', 'consum', 0.0218, 'lps'),
	(583530, 128, '2014-03-15 01:27:36.000000', 'consum', 0.0218, 'lps'),
	(583531, 128, '2014-03-15 01:27:37.000000', 'consum', 0.0217, 'lps'),
	(583532, 128, '2014-03-15 01:27:38.000000', 'consum', 0.0220, 'lps'),
	(583533, 128, '2014-03-15 01:27:39.000000', 'consum', 0.0218, 'lps'),
	(583534, 128, '2014-03-15 01:27:40.000000', 'consum', 0.0210, 'lps'),
	(583535, 128, '2014-03-15 01:27:41.000000', 'consum', 0.0220, 'lps'),
	(583536, 128, '2014-03-15 01:27:42.000000', 'consum', 0.0217, 'lps'),
	(583537, 128, '2014-03-15 01:27:43.000000', 'consum', 0.0213, 'lps'),
	(583538, 128, '2014-03-15 01:27:44.000000', 'consum', 0.0218, 'lps'),
	(583539, 128, '2014-03-15 01:27:45.000000', 'consum', 0.0217, 'lps'),
	(583540, 128, '2014-03-15 01:27:46.000000', 'consum', 0.0210, 'lps'),
	(583541, 128, '2014-03-15 01:27:47.000000', 'consum', 0.0214, 'lps'),
	(583542, 128, '2014-03-15 01:27:48.000000', 'consum', 0.0217, 'lps'),
	(583543, 128, '2014-03-15 01:27:49.000000', 'consum', 0.0214, 'lps'),
	(583544, 128, '2014-03-15 01:27:50.000000', 'consum', 0.0218, 'lps'),
	(583545, 128, '2014-03-15 01:27:51.000000', 'consum', 0.0219, 'lps'),
	(583546, 128, '2014-03-15 01:27:52.000000', 'consum', 0.0220, 'lps'),
	(583547, 128, '2014-03-15 01:27:53.000000', 'consum', 0.0212, 'lps'),
	(583548, 128, '2014-03-15 01:27:54.000000', 'consum', 0.0213, 'lps'),
	(583549, 128, '2014-03-15 01:27:55.000000', 'consum', 0.0220, 'lps'),
	(583550, 128, '2014-03-15 01:27:56.000000', 'consum', 0.0219, 'lps'),
	(583551, 128, '2014-03-15 01:27:57.000000', 'consum', 0.0212, 'lps'),
	(583552, 128, '2014-03-15 01:27:58.000000', 'consum', 0.0216, 'lps'),
	(583553, 128, '2014-03-15 01:27:59.000000', 'consum', 0.0214, 'lps'),
	(583554, 128, '2014-03-15 01:28:00.000000', 'consum', 0.0211, 'lps'),
	(583555, 128, '2014-03-15 01:28:01.000000', 'consum', 0.0217, 'lps'),
	(583556, 128, '2014-03-15 01:28:02.000000', 'consum', 0.0220, 'lps'),
	(583557, 128, '2014-03-15 01:28:03.000000', 'consum', 0.0215, 'lps'),
	(583558, 128, '2014-03-15 01:28:04.000000', 'consum', 0.0219, 'lps'),
	(583559, 128, '2014-03-15 01:28:05.000000', 'consum', 0.0218, 'lps'),
	(583560, 128, '2014-03-15 01:28:06.000000', 'consum', 0.0213, 'lps'),
	(583561, 128, '2014-03-15 01:28:07.000000', 'consum', 0.0212, 'lps'),
	(583562, 128, '2014-03-15 01:28:08.000000', 'consum', 0.0213, 'lps'),
	(583563, 128, '2014-03-15 01:28:09.000000', 'consum', 0.0220, 'lps'),
	(583564, 128, '2014-03-15 01:28:10.000000', 'consum', 0.0217, 'lps'),
	(583565, 128, '2014-03-15 01:28:11.000000', 'consum', 0.0214, 'lps'),
	(583566, 128, '2014-03-15 01:28:12.000000', 'consum', 0.0210, 'lps'),
	(583567, 128, '2014-03-15 01:28:13.000000', 'consum', 0.0211, 'lps'),
	(583568, 128, '2014-03-15 01:28:14.000000', 'consum', 0.0214, 'lps'),
	(583569, 128, '2014-03-15 01:28:15.000000', 'consum', 0.0215, 'lps'),
	(583570, 128, '2014-03-15 01:28:16.000000', 'consum', 0.0215, 'lps'),
	(583571, 128, '2014-03-15 01:28:17.000000', 'consum', 0.0211, 'lps'),
	(583572, 128, '2014-03-15 01:28:18.000000', 'consum', 0.0220, 'lps'),
	(583573, 128, '2014-03-15 01:28:19.000000', 'consum', 0.0216, 'lps'),
	(583574, 128, '2014-03-15 01:28:20.000000', 'consum', 0.0219, 'lps'),
	(583575, 128, '2014-03-15 01:28:21.000000', 'consum', 0.0218, 'lps'),
	(583576, 128, '2014-03-15 01:28:22.000000', 'consum', 0.0212, 'lps'),
	(583577, 128, '2014-03-15 01:28:23.000000', 'consum', 0.0217, 'lps'),
	(583578, 128, '2014-03-15 01:28:24.000000', 'consum', 0.0220, 'lps'),
	(583579, 128, '2014-03-15 01:28:25.000000', 'consum', 0.0217, 'lps'),
	(583580, 128, '2014-03-15 01:28:26.000000', 'consum', 0.0215, 'lps'),
	(583581, 128, '2014-03-15 01:28:27.000000', 'consum', 0.0213, 'lps'),
	(583582, 128, '2014-03-15 01:28:28.000000', 'consum', 0.0213, 'lps'),
	(583583, 128, '2014-03-15 01:28:29.000000', 'consum', 0.0216, 'lps'),
	(583584, 128, '2014-03-15 01:28:30.000000', 'consum', 0.0218, 'lps'),
	(583585, 128, '2014-03-15 01:28:31.000000', 'consum', 0.0213, 'lps'),
	(583586, 128, '2014-03-15 01:28:32.000000', 'consum', 0.0213, 'lps'),
	(583587, 128, '2014-03-15 01:28:33.000000', 'consum', 0.0217, 'lps'),
	(583588, 128, '2014-03-15 01:28:34.000000', 'consum', 0.0213, 'lps'),
	(583589, 128, '2014-03-15 01:28:35.000000', 'consum', 0.0214, 'lps'),
	(583590, 128, '2014-03-15 01:28:36.000000', 'consum', 0.0212, 'lps'),
	(583591, 128, '2014-03-15 01:28:37.000000', 'consum', 0.0220, 'lps'),
	(583592, 128, '2014-03-15 01:28:38.000000', 'consum', 0.0212, 'lps'),
	(583593, 128, '2014-03-15 01:28:39.000000', 'consum', 0.0211, 'lps'),
	(583594, 128, '2014-03-15 01:28:40.000000', 'consum', 0.0219, 'lps'),
	(583595, 128, '2014-03-15 01:28:41.000000', 'consum', 0.0220, 'lps'),
	(583596, 128, '2014-03-15 01:28:42.000000', 'consum', 0.0212, 'lps'),
	(583597, 128, '2014-03-15 01:28:43.000000', 'consum', 0.0214, 'lps'),
	(583598, 128, '2014-03-15 01:28:44.000000', 'consum', 0.0214, 'lps'),
	(583599, 128, '2014-03-15 01:28:45.000000', 'consum', 0.0216, 'lps'),
	(583600, 128, '2014-03-15 01:28:46.000000', 'consum', 0.0219, 'lps'),
	(583601, 128, '2014-03-15 01:28:47.000000', 'consum', 0.0214, 'lps'),
	(583602, 128, '2014-03-15 01:28:48.000000', 'consum', 0.0213, 'lps'),
	(583603, 128, '2014-03-15 01:28:49.000000', 'consum', 0.0216, 'lps'),
	(583604, 128, '2014-03-15 01:28:50.000000', 'consum', 0.0219, 'lps'),
	(583605, 128, '2014-03-15 01:28:51.000000', 'consum', 0.0216, 'lps'),
	(583606, 128, '2014-03-15 01:28:52.000000', 'consum', 0.0213, 'lps'),
	(583607, 128, '2014-03-15 01:28:53.000000', 'consum', 0.0217, 'lps'),
	(583608, 128, '2014-03-15 01:28:54.000000', 'consum', 0.0216, 'lps'),
	(583609, 128, '2014-03-15 01:28:55.000000', 'consum', 0.0210, 'lps'),
	(583610, 128, '2014-03-15 01:28:56.000000', 'consum', 0.0214, 'lps'),
	(583611, 128, '2014-03-15 01:28:57.000000', 'consum', 0.0210, 'lps'),
	(583612, 128, '2014-03-15 01:28:58.000000', 'consum', 0.0218, 'lps'),
	(583613, 128, '2014-03-15 01:28:59.000000', 'consum', 0.0217, 'lps'),
	(583614, 128, '2014-03-15 01:29:00.000000', 'consum', 0.0211, 'lps'),
	(583615, 128, '2014-03-15 01:29:01.000000', 'consum', 0.0217, 'lps'),
	(583616, 128, '2014-03-15 01:29:02.000000', 'consum', 0.0211, 'lps'),
	(583617, 128, '2014-03-15 01:29:03.000000', 'consum', 0.0216, 'lps'),
	(583618, 128, '2014-03-15 01:29:04.000000', 'consum', 0.0213, 'lps'),
	(583619, 128, '2014-03-15 01:29:05.000000', 'consum', 0.0210, 'lps'),
	(583620, 128, '2014-03-15 01:29:06.000000', 'consum', 0.0214, 'lps'),
	(583621, 128, '2014-03-15 01:29:07.000000', 'consum', 0.0217, 'lps'),
	(583622, 128, '2014-03-15 01:29:08.000000', 'consum', 0.0212, 'lps'),
	(583623, 128, '2014-03-15 01:29:09.000000', 'consum', 0.0212, 'lps'),
	(583624, 128, '2014-03-15 01:29:10.000000', 'consum', 0.0212, 'lps'),
	(583625, 128, '2014-03-15 01:29:11.000000', 'consum', 0.0215, 'lps'),
	(583626, 128, '2014-03-15 01:29:12.000000', 'consum', 0.0220, 'lps'),
	(583627, 128, '2014-03-15 01:29:13.000000', 'consum', 0.0213, 'lps'),
	(583628, 128, '2014-03-15 01:29:14.000000', 'consum', 0.0218, 'lps'),
	(583629, 128, '2014-03-15 01:29:15.000000', 'consum', 0.0219, 'lps'),
	(583630, 128, '2014-03-15 01:29:16.000000', 'consum', 0.0220, 'lps'),
	(583631, 128, '2014-03-15 01:29:17.000000', 'consum', 0.0210, 'lps'),
	(583632, 128, '2014-03-15 01:29:18.000000', 'consum', 0.0214, 'lps'),
	(583633, 128, '2014-03-15 01:29:19.000000', 'consum', 0.0220, 'lps'),
	(583634, 128, '2014-03-15 01:29:20.000000', 'consum', 0.0216, 'lps'),
	(583635, 128, '2014-03-15 01:29:21.000000', 'consum', 0.0212, 'lps'),
	(583636, 128, '2014-03-15 01:29:22.000000', 'consum', 0.0211, 'lps'),
	(583637, 128, '2014-03-15 01:29:23.000000', 'consum', 0.0212, 'lps'),
	(583638, 128, '2014-03-15 01:29:24.000000', 'consum', 0.0218, 'lps'),
	(583639, 128, '2014-03-15 01:29:25.000000', 'consum', 0.0211, 'lps'),
	(583640, 128, '2014-03-15 01:29:26.000000', 'consum', 0.0214, 'lps'),
	(583641, 128, '2014-03-15 01:29:27.000000', 'consum', 0.0217, 'lps'),
	(583642, 128, '2014-03-15 01:29:28.000000', 'consum', 0.0212, 'lps'),
	(583643, 128, '2014-03-15 01:29:29.000000', 'consum', 0.0219, 'lps'),
	(583644, 128, '2014-03-15 01:29:30.000000', 'consum', 0.0216, 'lps'),
	(583645, 128, '2014-03-15 01:29:31.000000', 'consum', 0.0214, 'lps'),
	(583646, 128, '2014-03-15 01:29:32.000000', 'consum', 0.0213, 'lps'),
	(583647, 128, '2014-03-15 01:29:33.000000', 'consum', 0.0212, 'lps'),
	(583648, 128, '2014-03-15 01:29:34.000000', 'consum', 0.0213, 'lps'),
	(583649, 128, '2014-03-15 01:29:35.000000', 'consum', 0.0219, 'lps'),
	(583650, 128, '2014-03-15 01:29:36.000000', 'consum', 0.0213, 'lps'),
	(583651, 128, '2014-03-15 01:29:37.000000', 'consum', 0.0212, 'lps'),
	(583652, 128, '2014-03-15 01:29:38.000000', 'consum', 0.0210, 'lps'),
	(583653, 128, '2014-03-15 01:29:39.000000', 'consum', 0.0215, 'lps'),
	(583654, 128, '2014-03-15 01:29:40.000000', 'consum', 0.0212, 'lps'),
	(583655, 128, '2014-03-15 01:29:41.000000', 'consum', 0.0220, 'lps'),
	(583656, 128, '2014-03-15 01:29:42.000000', 'consum', 0.0219, 'lps'),
	(583657, 128, '2014-03-15 01:29:43.000000', 'consum', 0.0214, 'lps'),
	(583658, 128, '2014-03-15 01:29:44.000000', 'consum', 0.0214, 'lps'),
	(583659, 128, '2014-03-15 01:29:45.000000', 'consum', 0.0210, 'lps'),
	(583660, 128, '2014-03-15 01:29:46.000000', 'consum', 0.0219, 'lps'),
	(583661, 128, '2014-03-15 01:29:47.000000', 'consum', 0.0211, 'lps'),
	(583662, 128, '2014-03-15 01:29:48.000000', 'consum', 0.0212, 'lps'),
	(583663, 128, '2014-03-15 01:29:49.000000', 'consum', 0.0216, 'lps'),
	(583664, 128, '2014-03-15 01:29:50.000000', 'consum', 0.0212, 'lps'),
	(583665, 128, '2014-03-15 01:29:51.000000', 'consum', 0.0214, 'lps'),
	(583666, 128, '2014-03-15 01:29:52.000000', 'consum', 0.0213, 'lps'),
	(583667, 128, '2014-03-15 01:29:53.000000', 'consum', 0.0216, 'lps'),
	(583668, 128, '2014-03-15 01:29:54.000000', 'consum', 0.0219, 'lps'),
	(583669, 128, '2014-03-15 01:29:55.000000', 'consum', 0.0215, 'lps'),
	(583670, 128, '2014-03-15 01:29:56.000000', 'consum', 0.0219, 'lps'),
	(583671, 128, '2014-03-15 01:29:57.000000', 'consum', 0.0218, 'lps'),
	(583672, 128, '2014-03-15 01:29:58.000000', 'consum', 0.0213, 'lps'),
	(583673, 128, '2014-03-15 01:29:59.000000', 'consum', 0.0213, 'lps'),
	(583674, 128, '2014-03-15 01:30:00.000000', 'consum', 0.0216, 'lps'),
	(583675, 128, '2014-03-15 01:30:01.000000', 'consum', 0.0211, 'lps'),
	(583676, 128, '2014-03-15 01:30:02.000000', 'consum', 0.0218, 'lps'),
	(583677, 128, '2014-03-15 01:30:03.000000', 'consum', 0.0215, 'lps'),
	(583678, 128, '2014-03-15 01:30:04.000000', 'consum', 0.0213, 'lps'),
	(583679, 128, '2014-03-15 01:30:05.000000', 'consum', 0.0211, 'lps'),
	(583680, 128, '2014-03-15 01:30:06.000000', 'consum', 0.0218, 'lps'),
	(583681, 128, '2014-03-15 01:30:07.000000', 'consum', 0.0214, 'lps'),
	(583682, 128, '2014-03-15 01:30:08.000000', 'consum', 0.0217, 'lps'),
	(583683, 128, '2014-03-15 01:30:09.000000', 'consum', 0.0211, 'lps'),
	(583684, 128, '2014-03-15 01:30:10.000000', 'consum', 0.0219, 'lps'),
	(583685, 128, '2014-03-15 01:30:11.000000', 'consum', 0.0217, 'lps'),
	(583686, 128, '2014-03-15 01:30:12.000000', 'consum', 0.0210, 'lps'),
	(583687, 128, '2014-03-15 01:30:13.000000', 'consum', 0.0212, 'lps'),
	(583688, 128, '2014-03-15 01:30:14.000000', 'consum', 0.0218, 'lps'),
	(583689, 128, '2014-03-15 01:30:15.000000', 'consum', 0.0214, 'lps'),
	(583690, 128, '2014-03-15 01:30:16.000000', 'consum', 0.0216, 'lps'),
	(583691, 128, '2014-03-15 01:30:17.000000', 'consum', 0.0216, 'lps'),
	(583692, 128, '2014-03-15 01:30:18.000000', 'consum', 0.0212, 'lps'),
	(583693, 128, '2014-03-15 01:30:19.000000', 'consum', 0.0215, 'lps'),
	(583694, 128, '2014-03-15 01:30:20.000000', 'consum', 0.0218, 'lps'),
	(583695, 128, '2014-03-15 01:30:21.000000', 'consum', 0.0214, 'lps'),
	(583696, 128, '2014-03-15 01:30:22.000000', 'consum', 0.0218, 'lps'),
	(583697, 128, '2014-03-15 01:30:23.000000', 'consum', 0.0217, 'lps'),
	(583698, 128, '2014-03-15 01:30:24.000000', 'consum', 0.0211, 'lps'),
	(583699, 128, '2014-03-15 01:30:25.000000', 'consum', 0.0215, 'lps'),
	(583700, 128, '2014-03-15 01:30:26.000000', 'consum', 0.0213, 'lps'),
	(583701, 128, '2014-03-15 01:30:27.000000', 'consum', 0.0218, 'lps'),
	(583702, 128, '2014-03-15 01:30:28.000000', 'consum', 0.0210, 'lps'),
	(583703, 128, '2014-03-15 01:30:29.000000', 'consum', 0.0220, 'lps'),
	(583704, 128, '2014-03-15 01:30:30.000000', 'consum', 0.0216, 'lps'),
	(583705, 128, '2014-03-15 01:30:31.000000', 'consum', 0.0212, 'lps'),
	(583706, 128, '2014-03-15 01:30:32.000000', 'consum', 0.0213, 'lps'),
	(583707, 128, '2014-03-15 01:30:33.000000', 'consum', 0.0219, 'lps'),
	(583708, 128, '2014-03-15 01:30:34.000000', 'consum', 0.0214, 'lps'),
	(583709, 128, '2014-03-15 01:30:35.000000', 'consum', 0.0215, 'lps'),
	(583710, 128, '2014-03-15 01:30:36.000000', 'consum', 0.0210, 'lps'),
	(583711, 128, '2014-03-15 01:30:37.000000', 'consum', 0.0210, 'lps'),
	(583712, 128, '2014-03-15 01:30:38.000000', 'consum', 0.0219, 'lps'),
	(583713, 128, '2014-03-15 01:30:39.000000', 'consum', 0.0211, 'lps'),
	(583714, 128, '2014-03-15 01:30:40.000000', 'consum', 0.0212, 'lps'),
	(583715, 128, '2014-03-15 01:30:41.000000', 'consum', 0.0219, 'lps'),
	(583716, 128, '2014-03-15 01:30:42.000000', 'consum', 0.0213, 'lps'),
	(583717, 128, '2014-03-15 01:30:43.000000', 'consum', 0.0212, 'lps'),
	(583718, 128, '2014-03-15 01:30:44.000000', 'consum', 0.0211, 'lps'),
	(583719, 128, '2014-03-15 01:30:45.000000', 'consum', 0.0210, 'lps'),
	(583720, 128, '2014-03-15 01:30:46.000000', 'consum', 0.0218, 'lps'),
	(583721, 128, '2014-03-15 01:30:47.000000', 'consum', 0.0219, 'lps'),
	(583722, 128, '2014-03-15 01:30:48.000000', 'consum', 0.0218, 'lps'),
	(583723, 128, '2014-03-15 01:30:49.000000', 'consum', 0.0214, 'lps'),
	(583724, 128, '2014-03-15 01:30:50.000000', 'consum', 0.0219, 'lps'),
	(583725, 128, '2014-03-15 01:30:51.000000', 'consum', 0.0210, 'lps'),
	(583726, 128, '2014-03-15 01:30:52.000000', 'consum', 0.0218, 'lps'),
	(583727, 128, '2014-03-15 01:30:53.000000', 'consum', 0.0216, 'lps'),
	(583728, 128, '2014-03-15 01:30:54.000000', 'consum', 0.0216, 'lps'),
	(583729, 128, '2014-03-15 01:30:55.000000', 'consum', 0.0210, 'lps'),
	(583730, 128, '2014-03-15 01:30:56.000000', 'consum', 0.0218, 'lps'),
	(583731, 128, '2014-03-15 01:30:57.000000', 'consum', 0.0216, 'lps'),
	(583732, 128, '2014-03-15 01:30:58.000000', 'consum', 0.0215, 'lps'),
	(583733, 128, '2014-03-15 01:30:59.000000', 'consum', 0.0220, 'lps'),
	(583734, 128, '2014-03-15 01:31:00.000000', 'consum', 0.0212, 'lps'),
	(583735, 128, '2014-03-15 01:31:01.000000', 'consum', 0.0212, 'lps'),
	(583736, 128, '2014-03-15 01:31:02.000000', 'consum', 0.0213, 'lps'),
	(583737, 128, '2014-03-15 01:31:03.000000', 'consum', 0.0220, 'lps'),
	(583738, 128, '2014-03-15 01:31:04.000000', 'consum', 0.0210, 'lps'),
	(583739, 128, '2014-03-15 01:31:05.000000', 'consum', 0.0211, 'lps'),
	(583740, 128, '2014-03-15 01:31:06.000000', 'consum', 0.0216, 'lps'),
	(583741, 128, '2014-03-15 01:31:07.000000', 'consum', 0.0215, 'lps'),
	(583742, 128, '2014-03-15 01:31:08.000000', 'consum', 0.0219, 'lps'),
	(583743, 128, '2014-03-15 01:31:09.000000', 'consum', 0.0218, 'lps'),
	(583744, 128, '2014-03-15 01:31:10.000000', 'consum', 0.0214, 'lps'),
	(583745, 128, '2014-03-15 01:31:11.000000', 'consum', 0.0215, 'lps'),
	(583746, 128, '2014-03-15 01:31:12.000000', 'consum', 0.0213, 'lps'),
	(583747, 128, '2014-03-15 01:31:13.000000', 'consum', 0.0210, 'lps'),
	(583748, 128, '2014-03-15 01:31:14.000000', 'consum', 0.0212, 'lps'),
	(583749, 128, '2014-03-15 01:31:15.000000', 'consum', 0.0220, 'lps'),
	(583750, 128, '2014-03-15 01:31:16.000000', 'consum', 0.0211, 'lps'),
	(583751, 128, '2014-03-15 01:31:17.000000', 'consum', 0.0218, 'lps'),
	(583752, 128, '2014-03-15 01:31:18.000000', 'consum', 0.0216, 'lps'),
	(583753, 128, '2014-03-15 01:31:19.000000', 'consum', 0.0214, 'lps'),
	(583754, 128, '2014-03-15 01:31:20.000000', 'consum', 0.0213, 'lps'),
	(583755, 128, '2014-03-15 01:31:21.000000', 'consum', 0.0214, 'lps'),
	(583756, 128, '2014-03-15 01:31:22.000000', 'consum', 0.0210, 'lps'),
	(583757, 128, '2014-03-15 01:31:23.000000', 'consum', 0.0212, 'lps'),
	(583758, 128, '2014-03-15 01:31:24.000000', 'consum', 0.0219, 'lps'),
	(583759, 128, '2014-03-15 01:31:25.000000', 'consum', 0.0217, 'lps'),
	(583760, 128, '2014-03-15 01:31:26.000000', 'consum', 0.0216, 'lps'),
	(583761, 128, '2014-03-15 01:31:27.000000', 'consum', 0.0210, 'lps'),
	(583762, 128, '2014-03-15 01:31:28.000000', 'consum', 0.0216, 'lps'),
	(583763, 128, '2014-03-15 01:31:29.000000', 'consum', 0.0219, 'lps'),
	(583764, 128, '2014-03-15 01:31:30.000000', 'consum', 0.0214, 'lps'),
	(583765, 128, '2014-03-15 01:31:31.000000', 'consum', 0.0216, 'lps'),
	(583766, 128, '2014-03-15 01:31:32.000000', 'consum', 0.0215, 'lps'),
	(583767, 128, '2014-03-15 01:31:33.000000', 'consum', 0.0220, 'lps'),
	(583768, 128, '2014-03-15 01:31:34.000000', 'consum', 0.0212, 'lps'),
	(583769, 128, '2014-03-15 01:31:35.000000', 'consum', 0.0213, 'lps'),
	(583770, 128, '2014-03-15 01:31:36.000000', 'consum', 0.0220, 'lps'),
	(583771, 128, '2014-03-15 01:31:37.000000', 'consum', 0.0216, 'lps'),
	(583772, 128, '2014-03-15 01:31:38.000000', 'consum', 0.0212, 'lps'),
	(583773, 128, '2014-03-15 01:31:39.000000', 'consum', 0.0213, 'lps'),
	(583774, 128, '2014-03-15 01:31:40.000000', 'consum', 0.0210, 'lps'),
	(583775, 128, '2014-03-15 01:31:41.000000', 'consum', 0.0210, 'lps'),
	(583776, 128, '2014-03-15 01:31:42.000000', 'consum', 0.0211, 'lps'),
	(583777, 128, '2014-03-15 01:31:43.000000', 'consum', 0.0218, 'lps'),
	(583778, 128, '2014-03-15 01:31:44.000000', 'consum', 0.0213, 'lps'),
	(583779, 128, '2014-03-15 01:31:45.000000', 'consum', 0.0213, 'lps'),
	(583780, 128, '2014-03-15 01:31:46.000000', 'consum', 0.0217, 'lps'),
	(583781, 128, '2014-03-15 01:31:47.000000', 'consum', 0.0215, 'lps'),
	(583782, 128, '2014-03-15 01:31:48.000000', 'consum', 0.0212, 'lps'),
	(583783, 128, '2014-03-15 01:31:49.000000', 'consum', 0.0216, 'lps'),
	(583784, 128, '2014-03-15 01:31:50.000000', 'consum', 0.0215, 'lps'),
	(583785, 128, '2014-03-15 01:31:51.000000', 'consum', 0.0215, 'lps'),
	(583786, 128, '2014-03-15 01:31:52.000000', 'consum', 0.0210, 'lps'),
	(583787, 128, '2014-03-15 01:31:53.000000', 'consum', 0.0217, 'lps'),
	(583788, 128, '2014-03-15 01:31:54.000000', 'consum', 0.0214, 'lps'),
	(583789, 128, '2014-03-15 01:31:55.000000', 'consum', 0.0220, 'lps'),
	(583790, 128, '2014-03-15 01:31:56.000000', 'consum', 0.0214, 'lps'),
	(583791, 128, '2014-03-15 01:31:57.000000', 'consum', 0.0212, 'lps'),
	(583792, 128, '2014-03-15 01:31:58.000000', 'consum', 0.0211, 'lps'),
	(583793, 128, '2014-03-15 01:31:59.000000', 'consum', 0.0218, 'lps'),
	(583794, 128, '2014-03-15 01:32:00.000000', 'consum', 0.0214, 'lps'),
	(583795, 128, '2014-03-15 01:32:01.000000', 'consum', 0.0219, 'lps'),
	(583796, 128, '2014-03-15 01:32:02.000000', 'consum', 0.0212, 'lps'),
	(583797, 128, '2014-03-15 01:32:03.000000', 'consum', 0.0213, 'lps'),
	(583798, 128, '2014-03-15 01:32:04.000000', 'consum', 0.0219, 'lps'),
	(583799, 128, '2014-03-15 01:32:05.000000', 'consum', 0.0214, 'lps'),
	(583800, 128, '2014-03-15 01:32:06.000000', 'consum', 0.0214, 'lps'),
	(583801, 128, '2014-03-15 01:32:07.000000', 'consum', 0.0210, 'lps'),
	(583802, 128, '2014-03-15 01:32:08.000000', 'consum', 0.0220, 'lps'),
	(583803, 128, '2014-03-15 01:32:09.000000', 'consum', 0.0215, 'lps'),
	(583804, 128, '2014-03-15 01:32:10.000000', 'consum', 0.0217, 'lps'),
	(583805, 128, '2014-03-15 01:32:11.000000', 'consum', 0.0218, 'lps'),
	(583806, 128, '2014-03-15 01:32:12.000000', 'consum', 0.0219, 'lps'),
	(583807, 128, '2014-03-15 01:32:13.000000', 'consum', 0.0210, 'lps'),
	(583808, 128, '2014-03-15 01:32:14.000000', 'consum', 0.0217, 'lps'),
	(583809, 128, '2014-03-15 01:32:15.000000', 'consum', 0.0211, 'lps'),
	(583810, 128, '2014-03-15 01:32:16.000000', 'consum', 0.0218, 'lps'),
	(583811, 128, '2014-03-15 01:32:17.000000', 'consum', 0.0212, 'lps'),
	(583812, 128, '2014-03-15 01:32:18.000000', 'consum', 0.0210, 'lps'),
	(583813, 128, '2014-03-15 01:32:19.000000', 'consum', 0.0214, 'lps'),
	(583814, 128, '2014-03-15 01:32:20.000000', 'consum', 0.0218, 'lps'),
	(583815, 128, '2014-03-15 01:32:21.000000', 'consum', 0.0220, 'lps'),
	(583816, 128, '2014-03-15 01:32:22.000000', 'consum', 0.0212, 'lps'),
	(583817, 128, '2014-03-15 01:32:23.000000', 'consum', 0.0213, 'lps'),
	(583818, 128, '2014-03-15 01:32:24.000000', 'consum', 0.0219, 'lps'),
	(583819, 128, '2014-03-15 01:32:25.000000', 'consum', 0.0215, 'lps'),
	(583820, 128, '2014-03-15 01:32:26.000000', 'consum', 0.0210, 'lps'),
	(583821, 128, '2014-03-15 01:32:27.000000', 'consum', 0.0215, 'lps'),
	(583822, 128, '2014-03-15 01:32:28.000000', 'consum', 0.0213, 'lps'),
	(583823, 128, '2014-03-15 01:32:29.000000', 'consum', 0.0213, 'lps'),
	(583824, 128, '2014-03-15 01:32:30.000000', 'consum', 0.0216, 'lps'),
	(583825, 128, '2014-03-15 01:32:31.000000', 'consum', 0.0219, 'lps'),
	(583826, 128, '2014-03-15 01:32:32.000000', 'consum', 0.0215, 'lps'),
	(583827, 128, '2014-03-15 01:32:33.000000', 'consum', 0.0220, 'lps'),
	(583828, 128, '2014-03-15 01:32:34.000000', 'consum', 0.0213, 'lps'),
	(583829, 128, '2014-03-15 01:32:35.000000', 'consum', 0.0218, 'lps'),
	(583830, 128, '2014-03-15 01:32:36.000000', 'consum', 0.0220, 'lps'),
	(583831, 128, '2014-03-15 01:32:37.000000', 'consum', 0.0213, 'lps'),
	(583832, 128, '2014-03-15 01:32:38.000000', 'consum', 0.0217, 'lps'),
	(583833, 128, '2014-03-15 01:32:39.000000', 'consum', 0.0216, 'lps'),
	(583834, 128, '2014-03-15 01:32:40.000000', 'consum', 0.0217, 'lps'),
	(583835, 128, '2014-03-15 01:32:41.000000', 'consum', 0.0219, 'lps'),
	(583836, 128, '2014-03-15 01:32:42.000000', 'consum', 0.0213, 'lps'),
	(583837, 128, '2014-03-15 01:32:43.000000', 'consum', 0.0220, 'lps'),
	(583838, 128, '2014-03-15 01:32:44.000000', 'consum', 0.0217, 'lps'),
	(583839, 128, '2014-03-15 01:32:45.000000', 'consum', 0.0217, 'lps'),
	(583840, 128, '2014-03-15 01:32:46.000000', 'consum', 0.0215, 'lps'),
	(583841, 128, '2014-03-15 01:32:47.000000', 'consum', 0.0212, 'lps'),
	(583842, 128, '2014-03-15 01:32:48.000000', 'consum', 0.0217, 'lps'),
	(583843, 128, '2014-03-15 01:32:49.000000', 'consum', 0.0218, 'lps'),
	(583844, 128, '2014-03-15 01:32:50.000000', 'consum', 0.0218, 'lps'),
	(583845, 128, '2014-03-15 01:32:51.000000', 'consum', 0.0215, 'lps'),
	(583846, 128, '2014-03-15 01:32:52.000000', 'consum', 0.0213, 'lps'),
	(583847, 128, '2014-03-15 01:32:53.000000', 'consum', 0.0211, 'lps'),
	(583848, 128, '2014-03-15 01:32:54.000000', 'consum', 0.0217, 'lps'),
	(583849, 128, '2014-03-15 01:32:55.000000', 'consum', 0.0211, 'lps'),
	(583850, 128, '2014-03-15 01:32:56.000000', 'consum', 0.0215, 'lps'),
	(583851, 128, '2014-03-15 01:32:57.000000', 'consum', 0.0210, 'lps'),
	(583852, 128, '2014-03-15 01:32:58.000000', 'consum', 0.0220, 'lps'),
	(583853, 128, '2014-03-15 01:32:59.000000', 'consum', 0.0214, 'lps'),
	(583854, 128, '2014-03-15 01:33:00.000000', 'consum', 0.0212, 'lps'),
	(583855, 128, '2014-03-15 01:33:01.000000', 'consum', 0.0218, 'lps'),
	(583856, 128, '2014-03-15 01:33:02.000000', 'consum', 0.0214, 'lps'),
	(583857, 128, '2014-03-15 01:33:03.000000', 'consum', 0.0215, 'lps'),
	(583858, 128, '2014-03-15 01:33:04.000000', 'consum', 0.0214, 'lps'),
	(583859, 128, '2014-03-15 01:33:05.000000', 'consum', 0.0217, 'lps'),
	(583860, 128, '2014-03-15 01:33:06.000000', 'consum', 0.0210, 'lps'),
	(583861, 128, '2014-03-15 01:33:07.000000', 'consum', 0.0213, 'lps'),
	(583862, 128, '2014-03-15 01:33:08.000000', 'consum', 0.0216, 'lps'),
	(583863, 128, '2014-03-15 01:33:09.000000', 'consum', 0.0218, 'lps'),
	(583864, 128, '2014-03-15 01:33:10.000000', 'consum', 0.0220, 'lps'),
	(583865, 128, '2014-03-15 01:33:11.000000', 'consum', 0.0217, 'lps'),
	(583866, 128, '2014-03-15 01:33:12.000000', 'consum', 0.0216, 'lps'),
	(583867, 128, '2014-03-15 01:33:13.000000', 'consum', 0.0217, 'lps'),
	(583868, 128, '2014-03-15 01:33:14.000000', 'consum', 0.0218, 'lps'),
	(583869, 128, '2014-03-15 01:33:15.000000', 'consum', 0.0220, 'lps'),
	(583870, 128, '2014-03-15 01:33:16.000000', 'consum', 0.0212, 'lps'),
	(583871, 128, '2014-03-15 01:33:17.000000', 'consum', 0.0213, 'lps'),
	(583872, 128, '2014-03-15 01:33:18.000000', 'consum', 0.0220, 'lps'),
	(583873, 128, '2014-03-15 01:33:19.000000', 'consum', 0.0220, 'lps'),
	(583874, 128, '2014-03-15 01:33:20.000000', 'consum', 0.0220, 'lps'),
	(583875, 128, '2014-03-15 01:33:21.000000', 'consum', 0.0219, 'lps'),
	(583876, 128, '2014-03-15 01:33:22.000000', 'consum', 0.0214, 'lps'),
	(583877, 128, '2014-03-15 01:33:23.000000', 'consum', 0.0213, 'lps'),
	(583878, 128, '2014-03-15 01:33:24.000000', 'consum', 0.0216, 'lps'),
	(583879, 128, '2014-03-15 01:33:25.000000', 'consum', 0.0219, 'lps'),
	(583880, 128, '2014-03-15 01:33:26.000000', 'consum', 0.0217, 'lps'),
	(583881, 128, '2014-03-15 01:33:27.000000', 'consum', 0.0219, 'lps'),
	(583882, 128, '2014-03-15 01:33:28.000000', 'consum', 0.0212, 'lps'),
	(583883, 128, '2014-03-15 01:33:29.000000', 'consum', 0.0217, 'lps'),
	(583884, 128, '2014-03-15 01:33:30.000000', 'consum', 0.0214, 'lps'),
	(583885, 128, '2014-03-15 01:33:31.000000', 'consum', 0.0213, 'lps'),
	(583886, 128, '2014-03-15 01:33:32.000000', 'consum', 0.0211, 'lps'),
	(583887, 128, '2014-03-15 01:33:33.000000', 'consum', 0.0218, 'lps'),
	(583888, 128, '2014-03-15 01:33:34.000000', 'consum', 0.0213, 'lps'),
	(583889, 128, '2014-03-15 01:33:35.000000', 'consum', 0.0213, 'lps'),
	(583890, 128, '2014-03-15 01:33:36.000000', 'consum', 0.0217, 'lps'),
	(583891, 128, '2014-03-15 01:33:37.000000', 'consum', 0.0214, 'lps'),
	(583892, 128, '2014-03-15 01:33:38.000000', 'consum', 0.0211, 'lps'),
	(583893, 128, '2014-03-15 01:33:39.000000', 'consum', 0.0213, 'lps'),
	(583894, 128, '2014-03-15 01:33:40.000000', 'consum', 0.0210, 'lps'),
	(583895, 128, '2014-03-15 01:33:41.000000', 'consum', 0.0215, 'lps'),
	(583896, 128, '2014-03-15 01:33:42.000000', 'consum', 0.0214, 'lps'),
	(583897, 128, '2014-03-15 01:33:43.000000', 'consum', 0.0214, 'lps'),
	(583898, 128, '2014-03-15 01:33:44.000000', 'consum', 0.0219, 'lps'),
	(583899, 128, '2014-03-15 01:33:45.000000', 'consum', 0.0212, 'lps'),
	(583900, 128, '2014-03-15 01:33:46.000000', 'consum', 0.0215, 'lps'),
	(583901, 128, '2014-03-15 01:33:47.000000', 'consum', 0.0217, 'lps'),
	(583902, 128, '2014-03-15 01:33:48.000000', 'consum', 0.0211, 'lps'),
	(583903, 128, '2014-03-15 01:33:49.000000', 'consum', 0.0216, 'lps'),
	(583904, 128, '2014-03-15 01:33:50.000000', 'consum', 0.0216, 'lps'),
	(583905, 128, '2014-03-15 01:33:51.000000', 'consum', 0.0210, 'lps'),
	(583906, 128, '2014-03-15 01:33:52.000000', 'consum', 0.0213, 'lps'),
	(583907, 128, '2014-03-15 01:33:53.000000', 'consum', 0.0217, 'lps'),
	(583908, 128, '2014-03-15 01:33:54.000000', 'consum', 0.0212, 'lps'),
	(583909, 128, '2014-03-15 01:33:55.000000', 'consum', 0.0211, 'lps'),
	(583910, 128, '2014-03-15 01:33:56.000000', 'consum', 0.0220, 'lps'),
	(583911, 128, '2014-03-15 01:33:57.000000', 'consum', 0.0216, 'lps'),
	(583912, 128, '2014-03-15 01:33:58.000000', 'consum', 0.0211, 'lps'),
	(583913, 128, '2014-03-15 01:33:59.000000', 'consum', 0.0217, 'lps'),
	(583914, 128, '2014-03-15 01:34:00.000000', 'consum', 0.0211, 'lps'),
	(583915, 128, '2014-03-15 01:34:01.000000', 'consum', 0.0218, 'lps'),
	(583916, 128, '2014-03-15 01:34:02.000000', 'consum', 0.0213, 'lps'),
	(583917, 128, '2014-03-15 01:34:03.000000', 'consum', 0.0212, 'lps'),
	(583918, 128, '2014-03-15 01:34:04.000000', 'consum', 0.0212, 'lps'),
	(583919, 128, '2014-03-15 01:34:05.000000', 'consum', 0.0215, 'lps'),
	(583920, 128, '2014-03-15 01:34:06.000000', 'consum', 0.0217, 'lps'),
	(583921, 128, '2014-03-15 01:34:07.000000', 'consum', 0.0220, 'lps'),
	(583922, 128, '2014-03-15 01:34:08.000000', 'consum', 0.0218, 'lps'),
	(583923, 128, '2014-03-15 01:34:09.000000', 'consum', 0.0220, 'lps'),
	(583924, 128, '2014-03-15 01:34:10.000000', 'consum', 0.0214, 'lps'),
	(583925, 128, '2014-03-15 01:34:11.000000', 'consum', 0.0212, 'lps'),
	(583926, 128, '2014-03-15 01:34:12.000000', 'consum', 0.0210, 'lps'),
	(583927, 128, '2014-03-15 01:34:13.000000', 'consum', 0.0216, 'lps'),
	(583928, 128, '2014-03-15 01:34:14.000000', 'consum', 0.0216, 'lps'),
	(583929, 128, '2014-03-15 01:34:15.000000', 'consum', 0.0213, 'lps'),
	(583930, 128, '2014-03-15 01:34:16.000000', 'consum', 0.0217, 'lps'),
	(583931, 128, '2014-03-15 01:34:17.000000', 'consum', 0.0216, 'lps'),
	(583932, 128, '2014-03-15 01:34:18.000000', 'consum', 0.0217, 'lps'),
	(583933, 128, '2014-03-15 01:34:19.000000', 'consum', 0.0219, 'lps'),
	(583934, 129, '2014-03-15 00:00:00.000000', 'consum', 0.0213, 'lps'),
	(583935, 129, '2014-03-15 00:00:01.000000', 'consum', 0.0214, 'lps'),
	(583936, 129, '2014-03-15 00:00:02.000000', 'consum', 0.0210, 'lps'),
	(583937, 129, '2014-03-15 00:00:03.000000', 'consum', 0.0212, 'lps'),
	(583938, 129, '2014-03-15 00:00:04.000000', 'consum', 0.0219, 'lps'),
	(583939, 129, '2014-03-15 00:00:05.000000', 'consum', 0.0210, 'lps'),
	(583940, 129, '2014-03-15 00:00:06.000000', 'consum', 0.0223, 'lps'),
	(583941, 129, '2014-03-15 00:00:07.000000', 'consum', 0.0220, 'lps'),
	(583942, 129, '2014-03-15 00:00:08.000000', 'consum', 0.0221, 'lps'),
	(583943, 129, '2014-03-15 00:00:09.000000', 'consum', 0.0221, 'lps'),
	(583944, 129, '2014-03-15 00:00:10.000000', 'consum', 0.0220, 'lps'),
	(583945, 129, '2014-03-15 00:00:11.000000', 'consum', 0.0215, 'lps'),
	(583946, 129, '2014-03-15 00:00:12.000000', 'consum', 0.0218, 'lps'),
	(583947, 129, '2014-03-15 00:00:13.000000', 'consum', 0.0220, 'lps'),
	(583948, 129, '2014-03-15 00:00:14.000000', 'consum', 0.0223, 'lps'),
	(583949, 129, '2014-03-15 00:00:15.000000', 'consum', 0.0218, 'lps'),
	(583950, 129, '2014-03-15 00:00:16.000000', 'consum', 0.0211, 'lps'),
	(583951, 129, '2014-03-15 00:00:17.000000', 'consum', 0.0222, 'lps'),
	(583952, 129, '2014-03-15 00:00:18.000000', 'consum', 0.0223, 'lps'),
	(583953, 129, '2014-03-15 00:00:19.000000', 'consum', 0.0214, 'lps'),
	(583954, 129, '2014-03-15 00:00:20.000000', 'consum', 0.0220, 'lps'),
	(583955, 129, '2014-03-15 00:00:21.000000', 'consum', 0.0218, 'lps'),
	(583956, 129, '2014-03-15 00:00:22.000000', 'consum', 0.0220, 'lps'),
	(583957, 129, '2014-03-15 00:00:23.000000', 'consum', 0.0222, 'lps'),
	(583958, 129, '2014-03-15 00:00:24.000000', 'consum', 0.0211, 'lps'),
	(583959, 129, '2014-03-15 00:00:25.000000', 'consum', 0.0211, 'lps'),
	(583960, 129, '2014-03-15 00:00:26.000000', 'consum', 0.0211, 'lps'),
	(583961, 129, '2014-03-15 00:00:27.000000', 'consum', 0.0213, 'lps'),
	(583962, 129, '2014-03-15 00:00:28.000000', 'consum', 0.0223, 'lps'),
	(583963, 129, '2014-03-15 00:00:29.000000', 'consum', 0.0222, 'lps'),
	(583964, 129, '2014-03-15 00:00:30.000000', 'consum', 0.0219, 'lps'),
	(583965, 129, '2014-03-15 00:00:31.000000', 'consum', 0.0218, 'lps'),
	(583966, 129, '2014-03-15 00:00:32.000000', 'consum', 0.0211, 'lps'),
	(583967, 129, '2014-03-15 00:00:33.000000', 'consum', 0.0221, 'lps'),
	(583968, 129, '2014-03-15 00:00:34.000000', 'consum', 0.0218, 'lps'),
	(583969, 129, '2014-03-15 00:00:35.000000', 'consum', 0.0220, 'lps'),
	(583970, 129, '2014-03-15 00:00:36.000000', 'consum', 0.0222, 'lps'),
	(583971, 129, '2014-03-15 00:00:37.000000', 'consum', 0.0213, 'lps'),
	(583972, 129, '2014-03-15 00:00:38.000000', 'consum', 0.0218, 'lps'),
	(583973, 129, '2014-03-15 00:00:39.000000', 'consum', 0.0213, 'lps'),
	(583974, 129, '2014-03-15 00:00:40.000000', 'consum', 0.0214, 'lps'),
	(583975, 129, '2014-03-15 00:00:41.000000', 'consum', 0.0221, 'lps'),
	(583976, 129, '2014-03-15 00:00:42.000000', 'consum', 0.0213, 'lps'),
	(583977, 129, '2014-03-15 00:00:43.000000', 'consum', 0.0218, 'lps'),
	(583978, 129, '2014-03-15 00:00:44.000000', 'consum', 0.0215, 'lps'),
	(583979, 129, '2014-03-15 00:00:45.000000', 'consum', 0.0212, 'lps'),
	(583980, 129, '2014-03-15 00:00:46.000000', 'consum', 0.0220, 'lps'),
	(583981, 129, '2014-03-15 00:00:47.000000', 'consum', 0.0213, 'lps'),
	(583982, 129, '2014-03-15 00:00:48.000000', 'consum', 0.0223, 'lps'),
	(583983, 129, '2014-03-15 00:00:49.000000', 'consum', 0.0223, 'lps'),
	(583984, 129, '2014-03-15 00:00:50.000000', 'consum', 0.0223, 'lps'),
	(583985, 129, '2014-03-15 00:00:51.000000', 'consum', 0.0211, 'lps'),
	(583986, 129, '2014-03-15 00:00:52.000000', 'consum', 0.0216, 'lps'),
	(583987, 129, '2014-03-15 00:00:53.000000', 'consum', 0.0210, 'lps'),
	(583988, 129, '2014-03-15 00:00:54.000000', 'consum', 0.0220, 'lps'),
	(583989, 129, '2014-03-15 00:00:55.000000', 'consum', 0.0218, 'lps'),
	(583990, 129, '2014-03-15 00:00:56.000000', 'consum', 0.0220, 'lps'),
	(583991, 129, '2014-03-15 00:00:57.000000', 'consum', 0.0222, 'lps'),
	(583992, 129, '2014-03-15 00:00:58.000000', 'consum', 0.0214, 'lps'),
	(583993, 129, '2014-03-15 00:00:59.000000', 'consum', 0.0221, 'lps'),
	(583994, 129, '2014-03-15 00:01:00.000000', 'consum', 0.0211, 'lps'),
	(583995, 129, '2014-03-15 00:01:01.000000', 'consum', 0.0213, 'lps'),
	(583996, 129, '2014-03-15 00:01:02.000000', 'consum', 0.0220, 'lps'),
	(583997, 129, '2014-03-15 00:01:03.000000', 'consum', 0.0223, 'lps'),
	(583998, 129, '2014-03-15 00:01:04.000000', 'consum', 0.0217, 'lps'),
	(583999, 129, '2014-03-15 00:01:05.000000', 'consum', 0.0221, 'lps'),
	(584000, 129, '2014-03-15 00:01:06.000000', 'consum', 0.0218, 'lps'),
	(584001, 129, '2014-03-15 00:01:07.000000', 'consum', 0.0217, 'lps'),
	(584002, 129, '2014-03-15 00:01:08.000000', 'consum', 0.0222, 'lps'),
	(584003, 129, '2014-03-15 00:01:09.000000', 'consum', 0.0223, 'lps'),
	(584004, 129, '2014-03-15 00:01:10.000000', 'consum', 0.0222, 'lps'),
	(584005, 129, '2014-03-15 00:01:11.000000', 'consum', 0.0219, 'lps'),
	(584006, 129, '2014-03-15 00:01:12.000000', 'consum', 0.0221, 'lps'),
	(584007, 129, '2014-03-15 00:01:13.000000', 'consum', 0.0211, 'lps'),
	(584008, 129, '2014-03-15 00:01:14.000000', 'consum', 0.0223, 'lps'),
	(584009, 129, '2014-03-15 00:01:15.000000', 'consum', 0.0215, 'lps'),
	(584010, 129, '2014-03-15 00:01:16.000000', 'consum', 0.0212, 'lps'),
	(584011, 129, '2014-03-15 00:01:17.000000', 'consum', 0.0220, 'lps'),
	(584012, 129, '2014-03-15 00:01:18.000000', 'consum', 0.0212, 'lps'),
	(584013, 129, '2014-03-15 00:01:19.000000', 'consum', 0.0220, 'lps'),
	(584014, 129, '2014-03-15 00:01:20.000000', 'consum', 0.0213, 'lps'),
	(584015, 129, '2014-03-15 00:01:21.000000', 'consum', 0.0210, 'lps'),
	(584016, 129, '2014-03-15 00:01:22.000000', 'consum', 0.0216, 'lps'),
	(584017, 129, '2014-03-15 00:01:23.000000', 'consum', 0.0212, 'lps'),
	(584018, 129, '2014-03-15 00:01:24.000000', 'consum', 0.0215, 'lps'),
	(584019, 129, '2014-03-15 00:01:25.000000', 'consum', 0.0217, 'lps'),
	(584020, 129, '2014-03-15 00:01:26.000000', 'consum', 0.0214, 'lps'),
	(584021, 129, '2014-03-15 00:01:27.000000', 'consum', 0.0213, 'lps'),
	(584022, 129, '2014-03-15 00:01:28.000000', 'consum', 0.0212, 'lps'),
	(584023, 129, '2014-03-15 00:01:29.000000', 'consum', 0.0211, 'lps'),
	(584024, 129, '2014-03-15 00:01:30.000000', 'consum', 0.0223, 'lps'),
	(584025, 129, '2014-03-15 00:01:31.000000', 'consum', 0.0217, 'lps'),
	(584026, 129, '2014-03-15 00:01:32.000000', 'consum', 0.0220, 'lps'),
	(584027, 129, '2014-03-15 00:01:33.000000', 'consum', 0.0210, 'lps'),
	(584028, 129, '2014-03-15 00:01:34.000000', 'consum', 0.0211, 'lps'),
	(584029, 129, '2014-03-15 00:01:35.000000', 'consum', 0.0214, 'lps'),
	(584030, 129, '2014-03-15 00:01:36.000000', 'consum', 0.0214, 'lps'),
	(584031, 129, '2014-03-15 00:01:37.000000', 'consum', 0.0219, 'lps'),
	(584032, 129, '2014-03-15 00:01:38.000000', 'consum', 0.0215, 'lps'),
	(584033, 129, '2014-03-15 00:01:39.000000', 'consum', 0.0223, 'lps'),
	(584034, 129, '2014-03-15 00:01:40.000000', 'consum', 0.0220, 'lps'),
	(584035, 129, '2014-03-15 00:01:41.000000', 'consum', 0.0222, 'lps'),
	(584036, 129, '2014-03-15 00:01:42.000000', 'consum', 0.0210, 'lps'),
	(584037, 129, '2014-03-15 00:01:43.000000', 'consum', 0.0216, 'lps'),
	(584038, 129, '2014-03-15 00:01:44.000000', 'consum', 0.0213, 'lps'),
	(584039, 129, '2014-03-15 00:01:45.000000', 'consum', 0.0221, 'lps'),
	(584040, 129, '2014-03-15 00:01:46.000000', 'consum', 0.0213, 'lps'),
	(584041, 129, '2014-03-15 00:01:47.000000', 'consum', 0.0223, 'lps'),
	(584042, 129, '2014-03-15 00:01:48.000000', 'consum', 0.0210, 'lps'),
	(584043, 129, '2014-03-15 00:01:49.000000', 'consum', 0.0212, 'lps'),
	(584044, 129, '2014-03-15 00:01:50.000000', 'consum', 0.0223, 'lps'),
	(584045, 129, '2014-03-15 00:01:51.000000', 'consum', 0.0213, 'lps'),
	(584046, 129, '2014-03-15 00:01:52.000000', 'consum', 0.0215, 'lps'),
	(584047, 129, '2014-03-15 00:01:53.000000', 'consum', 0.0213, 'lps'),
	(584048, 129, '2014-03-15 00:01:54.000000', 'consum', 0.0223, 'lps'),
	(584049, 129, '2014-03-15 00:01:55.000000', 'consum', 0.0210, 'lps'),
	(584050, 129, '2014-03-15 00:01:56.000000', 'consum', 0.0214, 'lps'),
	(584051, 129, '2014-03-15 00:01:57.000000', 'consum', 0.0216, 'lps'),
	(584052, 129, '2014-03-15 00:01:58.000000', 'consum', 0.0217, 'lps'),
	(584053, 129, '2014-03-15 00:01:59.000000', 'consum', 0.0212, 'lps'),
	(584054, 129, '2014-03-15 00:02:00.000000', 'consum', 0.0212, 'lps'),
	(584055, 129, '2014-03-15 00:02:01.000000', 'consum', 0.0215, 'lps'),
	(584056, 129, '2014-03-15 00:02:02.000000', 'consum', 0.0217, 'lps'),
	(584057, 129, '2014-03-15 00:02:03.000000', 'consum', 0.0216, 'lps'),
	(584058, 129, '2014-03-15 00:02:04.000000', 'consum', 0.0221, 'lps'),
	(584059, 129, '2014-03-15 00:02:05.000000', 'consum', 0.0218, 'lps'),
	(584060, 129, '2014-03-15 00:02:06.000000', 'consum', 0.0217, 'lps'),
	(584061, 129, '2014-03-15 00:02:07.000000', 'consum', 0.0223, 'lps'),
	(584062, 129, '2014-03-15 00:02:08.000000', 'consum', 0.0211, 'lps'),
	(584063, 129, '2014-03-15 00:02:09.000000', 'consum', 0.0217, 'lps'),
	(584064, 129, '2014-03-15 00:02:10.000000', 'consum', 0.0217, 'lps'),
	(584065, 129, '2014-03-15 00:02:11.000000', 'consum', 0.0222, 'lps'),
	(584066, 129, '2014-03-15 00:02:12.000000', 'consum', 0.0210, 'lps'),
	(584067, 129, '2014-03-15 00:02:13.000000', 'consum', 0.0218, 'lps'),
	(584068, 129, '2014-03-15 00:02:14.000000', 'consum', 0.0220, 'lps'),
	(584069, 129, '2014-03-15 00:02:15.000000', 'consum', 0.0222, 'lps'),
	(584070, 129, '2014-03-15 00:02:16.000000', 'consum', 0.0211, 'lps'),
	(584071, 129, '2014-03-15 00:02:17.000000', 'consum', 0.0210, 'lps'),
	(584072, 129, '2014-03-15 00:02:18.000000', 'consum', 0.0219, 'lps'),
	(584073, 129, '2014-03-15 00:02:19.000000', 'consum', 0.0214, 'lps'),
	(584074, 129, '2014-03-15 00:02:20.000000', 'consum', 0.0219, 'lps'),
	(584075, 129, '2014-03-15 00:02:21.000000', 'consum', 0.0216, 'lps'),
	(584076, 129, '2014-03-15 00:02:22.000000', 'consum', 0.0214, 'lps'),
	(584077, 129, '2014-03-15 00:02:23.000000', 'consum', 0.0211, 'lps'),
	(584078, 129, '2014-03-15 00:02:24.000000', 'consum', 0.0219, 'lps'),
	(584079, 129, '2014-03-15 00:02:25.000000', 'consum', 0.0222, 'lps'),
	(584080, 129, '2014-03-15 00:02:26.000000', 'consum', 0.0217, 'lps'),
	(584081, 129, '2014-03-15 00:02:27.000000', 'consum', 0.0210, 'lps'),
	(584082, 129, '2014-03-15 00:02:28.000000', 'consum', 0.0216, 'lps'),
	(584083, 129, '2014-03-15 00:02:29.000000', 'consum', 0.0214, 'lps'),
	(584084, 129, '2014-03-15 00:02:30.000000', 'consum', 0.0210, 'lps'),
	(584085, 129, '2014-03-15 00:02:31.000000', 'consum', 0.0214, 'lps'),
	(584086, 129, '2014-03-15 00:02:32.000000', 'consum', 0.0218, 'lps'),
	(584087, 129, '2014-03-15 00:02:33.000000', 'consum', 0.0210, 'lps'),
	(584088, 129, '2014-03-15 00:02:34.000000', 'consum', 0.0215, 'lps'),
	(584089, 129, '2014-03-15 00:02:35.000000', 'consum', 0.0222, 'lps'),
	(584090, 129, '2014-03-15 00:02:36.000000', 'consum', 0.0213, 'lps'),
	(584091, 129, '2014-03-15 00:02:37.000000', 'consum', 0.0216, 'lps'),
	(584092, 129, '2014-03-15 00:02:38.000000', 'consum', 0.0217, 'lps'),
	(584093, 129, '2014-03-15 00:02:39.000000', 'consum', 0.0213, 'lps'),
	(584094, 129, '2014-03-15 00:02:40.000000', 'consum', 0.0219, 'lps'),
	(584095, 129, '2014-03-15 00:02:41.000000', 'consum', 0.0219, 'lps'),
	(584096, 129, '2014-03-15 00:02:42.000000', 'consum', 0.0215, 'lps'),
	(584097, 129, '2014-03-15 00:02:43.000000', 'consum', 0.0223, 'lps'),
	(584098, 129, '2014-03-15 00:02:44.000000', 'consum', 0.0217, 'lps'),
	(584099, 129, '2014-03-15 00:02:45.000000', 'consum', 0.0221, 'lps'),
	(584100, 129, '2014-03-15 00:02:46.000000', 'consum', 0.0215, 'lps'),
	(584101, 129, '2014-03-15 00:02:47.000000', 'consum', 0.0217, 'lps'),
	(584102, 129, '2014-03-15 00:02:48.000000', 'consum', 0.0218, 'lps'),
	(584103, 129, '2014-03-15 00:02:49.000000', 'consum', 0.0214, 'lps'),
	(584104, 129, '2014-03-15 00:02:50.000000', 'consum', 0.0220, 'lps'),
	(584105, 129, '2014-03-15 00:02:51.000000', 'consum', 0.0222, 'lps'),
	(584106, 129, '2014-03-15 00:02:52.000000', 'consum', 0.0211, 'lps'),
	(584107, 129, '2014-03-15 00:02:53.000000', 'consum', 0.0221, 'lps'),
	(584108, 129, '2014-03-15 00:02:54.000000', 'consum', 0.0220, 'lps'),
	(584109, 129, '2014-03-15 00:02:55.000000', 'consum', 0.0213, 'lps'),
	(584110, 129, '2014-03-15 00:02:56.000000', 'consum', 0.0223, 'lps'),
	(584111, 129, '2014-03-15 00:02:57.000000', 'consum', 0.0212, 'lps'),
	(584112, 129, '2014-03-15 00:02:58.000000', 'consum', 0.0223, 'lps'),
	(584113, 129, '2014-03-15 00:02:59.000000', 'consum', 0.0214, 'lps'),
	(584114, 129, '2014-03-15 00:03:00.000000', 'consum', 0.0217, 'lps'),
	(584115, 129, '2014-03-15 00:03:01.000000', 'consum', 0.0222, 'lps'),
	(584116, 129, '2014-03-15 00:03:02.000000', 'consum', 0.0220, 'lps'),
	(584117, 129, '2014-03-15 00:03:03.000000', 'consum', 0.0211, 'lps'),
	(584118, 129, '2014-03-15 00:03:04.000000', 'consum', 0.0214, 'lps'),
	(584119, 129, '2014-03-15 00:03:05.000000', 'consum', 0.0213, 'lps'),
	(584120, 129, '2014-03-15 00:03:06.000000', 'consum', 0.0215, 'lps'),
	(584121, 129, '2014-03-15 00:03:07.000000', 'consum', 0.0213, 'lps'),
	(584122, 129, '2014-03-15 00:03:08.000000', 'consum', 0.0223, 'lps'),
	(584123, 129, '2014-03-15 00:03:09.000000', 'consum', 0.0213, 'lps'),
	(584124, 129, '2014-03-15 00:03:10.000000', 'consum', 0.0212, 'lps'),
	(584125, 129, '2014-03-15 00:03:11.000000', 'consum', 0.0212, 'lps'),
	(584126, 129, '2014-03-15 00:03:12.000000', 'consum', 0.0216, 'lps'),
	(584127, 129, '2014-03-15 00:03:13.000000', 'consum', 0.0219, 'lps'),
	(584128, 129, '2014-03-15 00:03:14.000000', 'consum', 0.0211, 'lps'),
	(584129, 129, '2014-03-15 00:03:15.000000', 'consum', 0.0214, 'lps'),
	(584130, 129, '2014-03-15 00:03:16.000000', 'consum', 0.0217, 'lps'),
	(584131, 129, '2014-03-15 00:03:17.000000', 'consum', 0.0216, 'lps'),
	(584132, 129, '2014-03-15 00:03:18.000000', 'consum', 0.0223, 'lps'),
	(584133, 129, '2014-03-15 00:03:19.000000', 'consum', 0.0213, 'lps'),
	(584134, 129, '2014-03-15 00:03:20.000000', 'consum', 0.0216, 'lps'),
	(584135, 129, '2014-03-15 00:03:21.000000', 'consum', 0.0218, 'lps'),
	(584136, 129, '2014-03-15 00:03:22.000000', 'consum', 0.0219, 'lps'),
	(584137, 129, '2014-03-15 00:03:23.000000', 'consum', 0.0217, 'lps'),
	(584138, 129, '2014-03-15 00:03:24.000000', 'consum', 0.0220, 'lps'),
	(584139, 129, '2014-03-15 00:03:25.000000', 'consum', 0.0211, 'lps'),
	(584140, 129, '2014-03-15 00:03:26.000000', 'consum', 0.0214, 'lps'),
	(584141, 129, '2014-03-15 00:03:27.000000', 'consum', 0.0215, 'lps'),
	(584142, 129, '2014-03-15 00:03:28.000000', 'consum', 0.0221, 'lps'),
	(584143, 129, '2014-03-15 00:03:29.000000', 'consum', 0.0222, 'lps'),
	(584144, 129, '2014-03-15 00:03:30.000000', 'consum', 0.0223, 'lps'),
	(584145, 129, '2014-03-15 00:03:31.000000', 'consum', 0.0214, 'lps'),
	(584146, 129, '2014-03-15 00:03:32.000000', 'consum', 0.0218, 'lps'),
	(584147, 129, '2014-03-15 00:03:33.000000', 'consum', 0.0211, 'lps'),
	(584148, 129, '2014-03-15 00:03:34.000000', 'consum', 0.0220, 'lps'),
	(584149, 129, '2014-03-15 00:03:35.000000', 'consum', 0.0215, 'lps'),
	(584150, 129, '2014-03-15 00:03:36.000000', 'consum', 0.0220, 'lps'),
	(584151, 129, '2014-03-15 00:03:37.000000', 'consum', 0.0217, 'lps'),
	(584152, 129, '2014-03-15 00:03:38.000000', 'consum', 0.0216, 'lps'),
	(584153, 129, '2014-03-15 00:03:39.000000', 'consum', 0.0221, 'lps'),
	(584154, 129, '2014-03-15 00:03:40.000000', 'consum', 0.0217, 'lps'),
	(584155, 129, '2014-03-15 00:03:41.000000', 'consum', 0.0214, 'lps'),
	(584156, 129, '2014-03-15 00:03:42.000000', 'consum', 0.0223, 'lps'),
	(584157, 129, '2014-03-15 00:03:43.000000', 'consum', 0.0210, 'lps'),
	(584158, 129, '2014-03-15 00:03:44.000000', 'consum', 0.0210, 'lps'),
	(584159, 129, '2014-03-15 00:03:45.000000', 'consum', 0.0211, 'lps'),
	(584160, 129, '2014-03-15 00:03:46.000000', 'consum', 0.0218, 'lps'),
	(584161, 129, '2014-03-15 00:03:47.000000', 'consum', 0.0218, 'lps'),
	(584162, 129, '2014-03-15 00:03:48.000000', 'consum', 0.0213, 'lps'),
	(584163, 129, '2014-03-15 00:03:49.000000', 'consum', 0.0217, 'lps'),
	(584164, 129, '2014-03-15 00:03:50.000000', 'consum', 0.0222, 'lps'),
	(584165, 129, '2014-03-15 00:03:51.000000', 'consum', 0.0222, 'lps'),
	(584166, 129, '2014-03-15 00:03:52.000000', 'consum', 0.0219, 'lps'),
	(584167, 129, '2014-03-15 00:03:53.000000', 'consum', 0.0218, 'lps'),
	(584168, 129, '2014-03-15 00:03:54.000000', 'consum', 0.0211, 'lps'),
	(584169, 129, '2014-03-15 00:03:55.000000', 'consum', 0.0221, 'lps'),
	(584170, 129, '2014-03-15 00:03:56.000000', 'consum', 0.0219, 'lps'),
	(584171, 129, '2014-03-15 00:03:57.000000', 'consum', 0.0222, 'lps'),
	(584172, 129, '2014-03-15 00:03:58.000000', 'consum', 0.0218, 'lps'),
	(584173, 129, '2014-03-15 00:03:59.000000', 'consum', 0.0214, 'lps'),
	(584174, 129, '2014-03-15 00:04:00.000000', 'consum', 0.0220, 'lps'),
	(584175, 129, '2014-03-15 00:04:01.000000', 'consum', 0.0220, 'lps'),
	(584176, 129, '2014-03-15 00:04:02.000000', 'consum', 0.0217, 'lps'),
	(584177, 129, '2014-03-15 00:04:03.000000', 'consum', 0.0213, 'lps'),
	(584178, 129, '2014-03-15 00:04:04.000000', 'consum', 0.0222, 'lps'),
	(584179, 129, '2014-03-15 00:04:05.000000', 'consum', 0.0219, 'lps'),
	(584180, 129, '2014-03-15 00:04:06.000000', 'consum', 0.0219, 'lps'),
	(584181, 129, '2014-03-15 00:04:07.000000', 'consum', 0.0216, 'lps'),
	(584182, 129, '2014-03-15 00:04:08.000000', 'consum', 0.0214, 'lps'),
	(584183, 129, '2014-03-15 00:04:09.000000', 'consum', 0.0223, 'lps'),
	(584184, 129, '2014-03-15 00:04:10.000000', 'consum', 0.0211, 'lps'),
	(584185, 129, '2014-03-15 00:04:11.000000', 'consum', 0.0216, 'lps'),
	(584186, 129, '2014-03-15 00:04:12.000000', 'consum', 0.0211, 'lps'),
	(584187, 129, '2014-03-15 00:04:13.000000', 'consum', 0.0223, 'lps'),
	(584188, 129, '2014-03-15 00:04:14.000000', 'consum', 0.0219, 'lps'),
	(584189, 129, '2014-03-15 00:04:15.000000', 'consum', 0.0214, 'lps'),
	(584190, 129, '2014-03-15 00:04:16.000000', 'consum', 0.0218, 'lps'),
	(584191, 129, '2014-03-15 00:04:17.000000', 'consum', 0.0212, 'lps'),
	(584192, 129, '2014-03-15 00:04:18.000000', 'consum', 0.0222, 'lps'),
	(584193, 129, '2014-03-15 00:04:19.000000', 'consum', 0.0210, 'lps'),
	(584194, 129, '2014-03-15 00:04:20.000000', 'consum', 0.0217, 'lps'),
	(584195, 129, '2014-03-15 00:04:21.000000', 'consum', 0.0216, 'lps'),
	(584196, 129, '2014-03-15 00:04:22.000000', 'consum', 0.0219, 'lps'),
	(584197, 129, '2014-03-15 00:04:23.000000', 'consum', 0.0223, 'lps'),
	(584198, 129, '2014-03-15 00:04:24.000000', 'consum', 0.0222, 'lps'),
	(584199, 129, '2014-03-15 00:04:25.000000', 'consum', 0.0216, 'lps'),
	(584200, 129, '2014-03-15 00:04:26.000000', 'consum', 0.0218, 'lps'),
	(584201, 129, '2014-03-15 00:04:27.000000', 'consum', 0.0218, 'lps'),
	(584202, 129, '2014-03-15 00:04:28.000000', 'consum', 0.0214, 'lps'),
	(584203, 129, '2014-03-15 00:04:29.000000', 'consum', 0.0218, 'lps'),
	(584204, 129, '2014-03-15 00:04:30.000000', 'consum', 0.0214, 'lps'),
	(584205, 129, '2014-03-15 00:04:31.000000', 'consum', 0.0219, 'lps'),
	(584206, 129, '2014-03-15 00:04:32.000000', 'consum', 0.0217, 'lps'),
	(584207, 129, '2014-03-15 00:04:33.000000', 'consum', 0.0216, 'lps'),
	(584208, 129, '2014-03-15 00:04:34.000000', 'consum', 0.0221, 'lps'),
	(584209, 129, '2014-03-15 00:04:35.000000', 'consum', 0.0218, 'lps'),
	(584210, 129, '2014-03-15 00:04:36.000000', 'consum', 0.0219, 'lps'),
	(584211, 129, '2014-03-15 00:04:37.000000', 'consum', 0.0217, 'lps'),
	(584212, 129, '2014-03-15 00:04:38.000000', 'consum', 0.0220, 'lps'),
	(584213, 129, '2014-03-15 00:04:39.000000', 'consum', 0.0211, 'lps'),
	(584214, 129, '2014-03-15 00:04:40.000000', 'consum', 0.0212, 'lps'),
	(584215, 129, '2014-03-15 00:04:41.000000', 'consum', 0.0218, 'lps'),
	(584216, 129, '2014-03-15 00:04:42.000000', 'consum', 0.0217, 'lps'),
	(584217, 129, '2014-03-15 00:04:43.000000', 'consum', 0.0219, 'lps'),
	(584218, 129, '2014-03-15 00:04:44.000000', 'consum', 0.0210, 'lps'),
	(584219, 129, '2014-03-15 00:04:45.000000', 'consum', 0.0210, 'lps'),
	(584220, 129, '2014-03-15 00:04:46.000000', 'consum', 0.0212, 'lps'),
	(584221, 129, '2014-03-15 00:04:47.000000', 'consum', 0.0220, 'lps'),
	(584222, 129, '2014-03-15 00:04:48.000000', 'consum', 0.0212, 'lps'),
	(584223, 129, '2014-03-15 00:04:49.000000', 'consum', 0.0219, 'lps'),
	(584224, 129, '2014-03-15 00:04:50.000000', 'consum', 0.0221, 'lps'),
	(584225, 129, '2014-03-15 00:04:51.000000', 'consum', 0.0210, 'lps'),
	(584226, 129, '2014-03-15 00:04:52.000000', 'consum', 0.0221, 'lps'),
	(584227, 129, '2014-03-15 00:04:53.000000', 'consum', 0.0222, 'lps'),
	(584228, 129, '2014-03-15 00:04:54.000000', 'consum', 0.0222, 'lps'),
	(584229, 129, '2014-03-15 00:04:55.000000', 'consum', 0.0223, 'lps'),
	(584230, 129, '2014-03-15 00:04:56.000000', 'consum', 0.0210, 'lps'),
	(584231, 129, '2014-03-15 00:04:57.000000', 'consum', 0.0216, 'lps'),
	(584232, 129, '2014-03-15 00:04:58.000000', 'consum', 0.0223, 'lps'),
	(584233, 129, '2014-03-15 00:04:59.000000', 'consum', 0.0219, 'lps'),
	(584234, 129, '2014-03-15 00:05:00.000000', 'consum', 0.0214, 'lps'),
	(584235, 129, '2014-03-15 00:05:01.000000', 'consum', 0.0219, 'lps'),
	(584236, 129, '2014-03-15 00:05:02.000000', 'consum', 0.0216, 'lps'),
	(584237, 129, '2014-03-15 00:05:03.000000', 'consum', 0.0211, 'lps'),
	(584238, 129, '2014-03-15 00:05:04.000000', 'consum', 0.0215, 'lps'),
	(584239, 129, '2014-03-15 00:05:05.000000', 'consum', 0.0216, 'lps'),
	(584240, 129, '2014-03-15 00:05:06.000000', 'consum', 0.0210, 'lps'),
	(584241, 129, '2014-03-15 00:05:07.000000', 'consum', 0.0210, 'lps'),
	(584242, 129, '2014-03-15 00:05:08.000000', 'consum', 0.0223, 'lps'),
	(584243, 129, '2014-03-15 00:05:09.000000', 'consum', 0.0219, 'lps'),
	(584244, 129, '2014-03-15 00:05:10.000000', 'consum', 0.0218, 'lps'),
	(584245, 129, '2014-03-15 00:05:11.000000', 'consum', 0.0211, 'lps'),
	(584246, 129, '2014-03-15 00:05:12.000000', 'consum', 0.0217, 'lps'),
	(584247, 129, '2014-03-15 00:05:13.000000', 'consum', 0.0213, 'lps'),
	(584248, 129, '2014-03-15 00:05:14.000000', 'consum', 0.0221, 'lps'),
	(584249, 129, '2014-03-15 00:05:15.000000', 'consum', 0.0215, 'lps'),
	(584250, 129, '2014-03-15 00:05:16.000000', 'consum', 0.0215, 'lps'),
	(584251, 129, '2014-03-15 00:05:17.000000', 'consum', 0.0222, 'lps'),
	(584252, 129, '2014-03-15 00:05:18.000000', 'consum', 0.0212, 'lps'),
	(584253, 129, '2014-03-15 00:05:19.000000', 'consum', 0.0211, 'lps'),
	(584254, 129, '2014-03-15 00:05:20.000000', 'consum', 0.0212, 'lps'),
	(584255, 129, '2014-03-15 00:05:21.000000', 'consum', 0.0218, 'lps'),
	(584256, 129, '2014-03-15 00:05:22.000000', 'consum', 0.0214, 'lps'),
	(584257, 129, '2014-03-15 00:05:23.000000', 'consum', 0.0223, 'lps'),
	(584258, 129, '2014-03-15 00:05:24.000000', 'consum', 0.0222, 'lps'),
	(584259, 129, '2014-03-15 00:05:25.000000', 'consum', 0.0215, 'lps'),
	(584260, 129, '2014-03-15 00:05:26.000000', 'consum', 0.0217, 'lps'),
	(584261, 129, '2014-03-15 00:05:27.000000', 'consum', 0.0213, 'lps'),
	(584262, 129, '2014-03-15 00:05:28.000000', 'consum', 0.0221, 'lps'),
	(584263, 129, '2014-03-15 00:05:29.000000', 'consum', 0.0212, 'lps'),
	(584264, 129, '2014-03-15 00:05:30.000000', 'consum', 0.0216, 'lps'),
	(584265, 129, '2014-03-15 00:05:31.000000', 'consum', 0.0222, 'lps'),
	(584266, 129, '2014-03-15 00:05:32.000000', 'consum', 0.0222, 'lps'),
	(584267, 129, '2014-03-15 00:05:33.000000', 'consum', 0.0222, 'lps'),
	(584268, 129, '2014-03-15 00:05:34.000000', 'consum', 0.0220, 'lps'),
	(584269, 129, '2014-03-15 00:05:35.000000', 'consum', 0.0211, 'lps'),
	(584270, 129, '2014-03-15 00:05:36.000000', 'consum', 0.0212, 'lps'),
	(584271, 129, '2014-03-15 00:05:37.000000', 'consum', 0.0220, 'lps'),
	(584272, 129, '2014-03-15 00:05:38.000000', 'consum', 0.0212, 'lps'),
	(584273, 129, '2014-03-15 00:05:39.000000', 'consum', 0.0216, 'lps'),
	(584274, 129, '2014-03-15 00:05:40.000000', 'consum', 0.0222, 'lps'),
	(584275, 129, '2014-03-15 00:05:41.000000', 'consum', 0.0211, 'lps'),
	(584276, 129, '2014-03-15 00:05:42.000000', 'consum', 0.0220, 'lps'),
	(584277, 129, '2014-03-15 00:05:43.000000', 'consum', 0.0214, 'lps'),
	(584278, 129, '2014-03-15 00:05:44.000000', 'consum', 0.0217, 'lps'),
	(584279, 129, '2014-03-15 00:05:45.000000', 'consum', 0.0221, 'lps'),
	(584280, 129, '2014-03-15 00:05:46.000000', 'consum', 0.0215, 'lps'),
	(584281, 129, '2014-03-15 00:05:47.000000', 'consum', 0.0217, 'lps'),
	(584282, 129, '2014-03-15 00:05:48.000000', 'consum', 0.0215, 'lps'),
	(584283, 129, '2014-03-15 00:05:49.000000', 'consum', 0.0213, 'lps'),
	(584284, 129, '2014-03-15 00:05:50.000000', 'consum', 0.0214, 'lps'),
	(584285, 129, '2014-03-15 00:05:51.000000', 'consum', 0.0221, 'lps'),
	(584286, 129, '2014-03-15 00:05:52.000000', 'consum', 0.0210, 'lps'),
	(584287, 129, '2014-03-15 00:05:53.000000', 'consum', 0.0218, 'lps'),
	(584288, 129, '2014-03-15 00:05:54.000000', 'consum', 0.0211, 'lps'),
	(584289, 129, '2014-03-15 00:05:55.000000', 'consum', 0.0218, 'lps'),
	(584290, 129, '2014-03-15 00:05:56.000000', 'consum', 0.0219, 'lps'),
	(584291, 129, '2014-03-15 00:05:57.000000', 'consum', 0.0219, 'lps'),
	(584292, 129, '2014-03-15 00:05:58.000000', 'consum', 0.0214, 'lps'),
	(584293, 129, '2014-03-15 00:05:59.000000', 'consum', 0.0217, 'lps'),
	(584294, 129, '2014-03-15 00:06:00.000000', 'consum', 0.0218, 'lps'),
	(584295, 129, '2014-03-15 00:06:01.000000', 'consum', 0.0217, 'lps'),
	(584296, 129, '2014-03-15 00:06:02.000000', 'consum', 0.0220, 'lps'),
	(584297, 129, '2014-03-15 00:06:03.000000', 'consum', 0.0212, 'lps'),
	(584298, 129, '2014-03-15 00:06:04.000000', 'consum', 0.0219, 'lps'),
	(584299, 129, '2014-03-15 00:06:05.000000', 'consum', 0.0220, 'lps'),
	(584300, 129, '2014-03-15 00:06:06.000000', 'consum', 0.0220, 'lps'),
	(584301, 129, '2014-03-15 00:06:07.000000', 'consum', 0.0219, 'lps'),
	(584302, 129, '2014-03-15 00:06:08.000000', 'consum', 0.0223, 'lps'),
	(584303, 129, '2014-03-15 00:06:09.000000', 'consum', 0.0222, 'lps'),
	(584304, 129, '2014-03-15 00:06:10.000000', 'consum', 0.0218, 'lps'),
	(584305, 129, '2014-03-15 00:06:11.000000', 'consum', 0.0215, 'lps'),
	(584306, 129, '2014-03-15 00:06:12.000000', 'consum', 0.0210, 'lps'),
	(584307, 129, '2014-03-15 00:06:13.000000', 'consum', 0.0211, 'lps'),
	(584308, 129, '2014-03-15 00:06:14.000000', 'consum', 0.0215, 'lps'),
	(584309, 129, '2014-03-15 00:06:15.000000', 'consum', 0.0218, 'lps'),
	(584310, 129, '2014-03-15 00:06:16.000000', 'consum', 0.0220, 'lps'),
	(584311, 129, '2014-03-15 00:06:17.000000', 'consum', 0.0210, 'lps'),
	(584312, 129, '2014-03-15 00:06:18.000000', 'consum', 0.0223, 'lps'),
	(584313, 129, '2014-03-15 00:06:19.000000', 'consum', 0.0217, 'lps'),
	(584314, 129, '2014-03-15 00:06:20.000000', 'consum', 0.0222, 'lps'),
	(584315, 129, '2014-03-15 00:06:21.000000', 'consum', 0.0221, 'lps'),
	(584316, 129, '2014-03-15 00:06:22.000000', 'consum', 0.0217, 'lps'),
	(584317, 129, '2014-03-15 00:06:23.000000', 'consum', 0.0210, 'lps'),
	(584318, 129, '2014-03-15 00:06:24.000000', 'consum', 0.0220, 'lps'),
	(584319, 129, '2014-03-15 00:06:25.000000', 'consum', 0.0218, 'lps'),
	(584320, 129, '2014-03-15 00:06:26.000000', 'consum', 0.0220, 'lps'),
	(584321, 129, '2014-03-15 00:06:27.000000', 'consum', 0.0222, 'lps'),
	(584322, 129, '2014-03-15 00:06:28.000000', 'consum', 0.0215, 'lps'),
	(584323, 129, '2014-03-15 00:06:29.000000', 'consum', 0.0212, 'lps'),
	(584324, 129, '2014-03-15 00:06:30.000000', 'consum', 0.0220, 'lps'),
	(584325, 129, '2014-03-15 00:06:31.000000', 'consum', 0.0213, 'lps'),
	(584326, 129, '2014-03-15 00:06:32.000000', 'consum', 0.0221, 'lps'),
	(584327, 129, '2014-03-15 00:06:33.000000', 'consum', 0.0217, 'lps'),
	(584328, 129, '2014-03-15 00:06:34.000000', 'consum', 0.0210, 'lps'),
	(584329, 129, '2014-03-15 00:06:35.000000', 'consum', 0.0217, 'lps'),
	(584330, 129, '2014-03-15 00:06:36.000000', 'consum', 0.0220, 'lps'),
	(584331, 129, '2014-03-15 00:06:37.000000', 'consum', 0.0212, 'lps'),
	(584332, 129, '2014-03-15 00:06:38.000000', 'consum', 0.0216, 'lps'),
	(584333, 129, '2014-03-15 00:06:39.000000', 'consum', 0.0219, 'lps'),
	(584334, 129, '2014-03-15 00:06:40.000000', 'consum', 0.0213, 'lps'),
	(584335, 129, '2014-03-15 00:06:41.000000', 'consum', 0.0212, 'lps'),
	(584336, 129, '2014-03-15 00:06:42.000000', 'consum', 0.0223, 'lps'),
	(584337, 129, '2014-03-15 00:06:43.000000', 'consum', 0.0215, 'lps'),
	(584338, 129, '2014-03-15 00:06:44.000000', 'consum', 0.0212, 'lps'),
	(584339, 129, '2014-03-15 00:06:45.000000', 'consum', 0.0217, 'lps'),
	(584340, 129, '2014-03-15 00:06:46.000000', 'consum', 0.0211, 'lps'),
	(584341, 129, '2014-03-15 00:06:47.000000', 'consum', 0.0223, 'lps'),
	(584342, 129, '2014-03-15 00:06:48.000000', 'consum', 0.0217, 'lps'),
	(584343, 129, '2014-03-15 00:06:49.000000', 'consum', 0.0219, 'lps'),
	(584344, 129, '2014-03-15 00:06:50.000000', 'consum', 0.0221, 'lps'),
	(584345, 129, '2014-03-15 00:06:51.000000', 'consum', 0.0223, 'lps'),
	(584346, 129, '2014-03-15 00:06:52.000000', 'consum', 0.0215, 'lps'),
	(584347, 129, '2014-03-15 00:06:53.000000', 'consum', 0.0212, 'lps'),
	(584348, 129, '2014-03-15 00:06:54.000000', 'consum', 0.0220, 'lps'),
	(584349, 129, '2014-03-15 00:06:55.000000', 'consum', 0.0214, 'lps'),
	(584350, 129, '2014-03-15 00:06:56.000000', 'consum', 0.0211, 'lps'),
	(584351, 129, '2014-03-15 00:06:57.000000', 'consum', 0.0219, 'lps'),
	(584352, 129, '2014-03-15 00:06:58.000000', 'consum', 0.0210, 'lps'),
	(584353, 129, '2014-03-15 00:06:59.000000', 'consum', 0.0211, 'lps'),
	(584354, 129, '2014-03-15 00:07:00.000000', 'consum', 0.0215, 'lps'),
	(584355, 129, '2014-03-15 00:07:01.000000', 'consum', 0.0218, 'lps'),
	(584356, 129, '2014-03-15 00:07:02.000000', 'consum', 0.0222, 'lps'),
	(584357, 129, '2014-03-15 00:07:03.000000', 'consum', 0.0219, 'lps'),
	(584358, 129, '2014-03-15 00:07:04.000000', 'consum', 0.0220, 'lps'),
	(584359, 129, '2014-03-15 00:07:05.000000', 'consum', 0.0217, 'lps'),
	(584360, 129, '2014-03-15 00:07:06.000000', 'consum', 0.0217, 'lps'),
	(584361, 129, '2014-03-15 00:07:07.000000', 'consum', 0.0223, 'lps'),
	(584362, 129, '2014-03-15 00:07:08.000000', 'consum', 0.0212, 'lps'),
	(584363, 129, '2014-03-15 00:07:09.000000', 'consum', 0.0212, 'lps'),
	(584364, 129, '2014-03-15 00:07:10.000000', 'consum', 0.0214, 'lps'),
	(584365, 129, '2014-03-15 00:07:11.000000', 'consum', 0.0223, 'lps'),
	(584366, 129, '2014-03-15 00:07:12.000000', 'consum', 0.0223, 'lps'),
	(584367, 129, '2014-03-15 00:07:13.000000', 'consum', 0.0223, 'lps'),
	(584368, 129, '2014-03-15 00:07:14.000000', 'consum', 0.0221, 'lps'),
	(584369, 129, '2014-03-15 00:07:15.000000', 'consum', 0.0215, 'lps'),
	(584370, 129, '2014-03-15 00:07:16.000000', 'consum', 0.0214, 'lps'),
	(584371, 129, '2014-03-15 00:07:17.000000', 'consum', 0.0214, 'lps'),
	(584372, 129, '2014-03-15 00:07:18.000000', 'consum', 0.0221, 'lps'),
	(584373, 129, '2014-03-15 00:07:19.000000', 'consum', 0.0211, 'lps'),
	(584374, 129, '2014-03-15 00:07:20.000000', 'consum', 0.0211, 'lps'),
	(584375, 129, '2014-03-15 00:07:21.000000', 'consum', 0.0210, 'lps'),
	(584376, 129, '2014-03-15 00:07:22.000000', 'consum', 0.0223, 'lps'),
	(584377, 129, '2014-03-15 00:07:23.000000', 'consum', 0.0219, 'lps'),
	(584378, 129, '2014-03-15 00:07:24.000000', 'consum', 0.0215, 'lps'),
	(584379, 129, '2014-03-15 00:07:25.000000', 'consum', 0.0211, 'lps'),
	(584380, 129, '2014-03-15 00:07:26.000000', 'consum', 0.0214, 'lps'),
	(584381, 129, '2014-03-15 00:07:27.000000', 'consum', 0.0212, 'lps'),
	(584382, 129, '2014-03-15 00:07:28.000000', 'consum', 0.0210, 'lps'),
	(584383, 129, '2014-03-15 00:07:29.000000', 'consum', 0.0219, 'lps'),
	(584384, 129, '2014-03-15 00:07:30.000000', 'consum', 0.0215, 'lps'),
	(584385, 129, '2014-03-15 00:07:31.000000', 'consum', 0.0220, 'lps'),
	(584386, 129, '2014-03-15 00:07:32.000000', 'consum', 0.0218, 'lps'),
	(584387, 129, '2014-03-15 00:07:33.000000', 'consum', 0.0221, 'lps'),
	(584388, 129, '2014-03-15 00:07:34.000000', 'consum', 0.0215, 'lps'),
	(584389, 129, '2014-03-15 00:07:35.000000', 'consum', 0.0215, 'lps'),
	(584390, 129, '2014-03-15 00:07:36.000000', 'consum', 0.0220, 'lps'),
	(584391, 129, '2014-03-15 00:07:37.000000', 'consum', 0.0219, 'lps'),
	(584392, 129, '2014-03-15 00:07:38.000000', 'consum', 0.0210, 'lps'),
	(584393, 129, '2014-03-15 00:07:39.000000', 'consum', 0.0210, 'lps'),
	(584394, 129, '2014-03-15 00:07:40.000000', 'consum', 0.0213, 'lps'),
	(584395, 129, '2014-03-15 00:07:41.000000', 'consum', 0.0210, 'lps'),
	(584396, 129, '2014-03-15 00:07:42.000000', 'consum', 0.0215, 'lps'),
	(584397, 129, '2014-03-15 00:07:43.000000', 'consum', 0.0222, 'lps'),
	(584398, 129, '2014-03-15 00:07:44.000000', 'consum', 0.0215, 'lps'),
	(584399, 129, '2014-03-15 00:07:45.000000', 'consum', 0.0215, 'lps'),
	(584400, 129, '2014-03-15 00:07:46.000000', 'consum', 0.0217, 'lps'),
	(584401, 129, '2014-03-15 00:07:47.000000', 'consum', 0.0218, 'lps'),
	(584402, 129, '2014-03-15 00:07:48.000000', 'consum', 0.0217, 'lps'),
	(584403, 129, '2014-03-15 00:07:49.000000', 'consum', 0.0220, 'lps'),
	(584404, 129, '2014-03-15 00:07:50.000000', 'consum', 0.0212, 'lps'),
	(584405, 129, '2014-03-15 00:07:51.000000', 'consum', 0.0220, 'lps'),
	(584406, 129, '2014-03-15 00:07:52.000000', 'consum', 0.0223, 'lps'),
	(584407, 129, '2014-03-15 00:07:53.000000', 'consum', 0.0220, 'lps'),
	(584408, 129, '2014-03-15 00:07:54.000000', 'consum', 0.0222, 'lps'),
	(584409, 129, '2014-03-15 00:07:55.000000', 'consum', 0.0211, 'lps'),
	(584410, 129, '2014-03-15 00:07:56.000000', 'consum', 0.0221, 'lps'),
	(584411, 129, '2014-03-15 00:07:57.000000', 'consum', 0.0223, 'lps'),
	(584412, 129, '2014-03-15 00:07:58.000000', 'consum', 0.0211, 'lps'),
	(584413, 129, '2014-03-15 00:07:59.000000', 'consum', 0.0222, 'lps'),
	(584414, 129, '2014-03-15 00:08:00.000000', 'consum', 0.0222, 'lps'),
	(584415, 129, '2014-03-15 00:08:01.000000', 'consum', 0.0223, 'lps'),
	(584416, 129, '2014-03-15 00:08:02.000000', 'consum', 0.0213, 'lps'),
	(584417, 129, '2014-03-15 00:08:03.000000', 'consum', 0.0212, 'lps'),
	(584418, 129, '2014-03-15 00:08:04.000000', 'consum', 0.0213, 'lps'),
	(584419, 129, '2014-03-15 00:08:05.000000', 'consum', 0.0217, 'lps'),
	(584420, 129, '2014-03-15 00:08:06.000000', 'consum', 0.0210, 'lps'),
	(584421, 129, '2014-03-15 00:08:07.000000', 'consum', 0.0219, 'lps'),
	(584422, 129, '2014-03-15 00:08:08.000000', 'consum', 0.0212, 'lps'),
	(584423, 129, '2014-03-15 00:08:09.000000', 'consum', 0.0220, 'lps'),
	(584424, 129, '2014-03-15 00:08:10.000000', 'consum', 0.0213, 'lps'),
	(584425, 129, '2014-03-15 00:08:11.000000', 'consum', 0.0212, 'lps'),
	(584426, 129, '2014-03-15 00:08:12.000000', 'consum', 0.0211, 'lps'),
	(584427, 129, '2014-03-15 00:08:13.000000', 'consum', 0.0221, 'lps'),
	(584428, 129, '2014-03-15 00:08:14.000000', 'consum', 0.0223, 'lps'),
	(584429, 129, '2014-03-15 00:08:15.000000', 'consum', 0.0212, 'lps'),
	(584430, 129, '2014-03-15 00:08:16.000000', 'consum', 0.0213, 'lps'),
	(584431, 129, '2014-03-15 00:08:17.000000', 'consum', 0.0217, 'lps'),
	(584432, 129, '2014-03-15 00:08:18.000000', 'consum', 0.0223, 'lps'),
	(584433, 129, '2014-03-15 00:08:19.000000', 'consum', 0.0211, 'lps'),
	(584434, 129, '2014-03-15 00:08:20.000000', 'consum', 0.0220, 'lps'),
	(584435, 129, '2014-03-15 00:08:21.000000', 'consum', 0.0215, 'lps'),
	(584436, 129, '2014-03-15 00:08:22.000000', 'consum', 0.0219, 'lps'),
	(584437, 129, '2014-03-15 00:08:23.000000', 'consum', 0.0215, 'lps'),
	(584438, 129, '2014-03-15 00:08:24.000000', 'consum', 0.0219, 'lps'),
	(584439, 129, '2014-03-15 00:08:25.000000', 'consum', 0.0216, 'lps'),
	(584440, 129, '2014-03-15 00:08:26.000000', 'consum', 0.0211, 'lps'),
	(584441, 129, '2014-03-15 00:08:27.000000', 'consum', 0.0211, 'lps'),
	(584442, 129, '2014-03-15 00:08:28.000000', 'consum', 0.0214, 'lps'),
	(584443, 129, '2014-03-15 00:08:29.000000', 'consum', 0.0215, 'lps'),
	(584444, 129, '2014-03-15 00:08:30.000000', 'consum', 0.0222, 'lps'),
	(584445, 129, '2014-03-15 00:08:31.000000', 'consum', 0.0214, 'lps'),
	(584446, 129, '2014-03-15 00:08:32.000000', 'consum', 0.0221, 'lps'),
	(584447, 129, '2014-03-15 00:08:33.000000', 'consum', 0.0211, 'lps'),
	(584448, 129, '2014-03-15 00:08:34.000000', 'consum', 0.0213, 'lps'),
	(584449, 129, '2014-03-15 00:08:35.000000', 'consum', 0.0221, 'lps'),
	(584450, 129, '2014-03-15 00:08:36.000000', 'consum', 0.0215, 'lps'),
	(584451, 129, '2014-03-15 00:08:37.000000', 'consum', 0.0217, 'lps'),
	(584452, 129, '2014-03-15 00:08:38.000000', 'consum', 0.0216, 'lps'),
	(584453, 129, '2014-03-15 00:08:39.000000', 'consum', 0.0218, 'lps'),
	(584454, 129, '2014-03-15 00:08:40.000000', 'consum', 0.0218, 'lps'),
	(584455, 129, '2014-03-15 00:08:41.000000', 'consum', 0.0214, 'lps'),
	(584456, 129, '2014-03-15 00:08:42.000000', 'consum', 0.0221, 'lps'),
	(584457, 129, '2014-03-15 00:08:43.000000', 'consum', 0.0210, 'lps'),
	(584458, 129, '2014-03-15 00:08:44.000000', 'consum', 0.0220, 'lps'),
	(584459, 129, '2014-03-15 00:08:45.000000', 'consum', 0.0219, 'lps'),
	(584460, 129, '2014-03-15 00:08:46.000000', 'consum', 0.0211, 'lps'),
	(584461, 129, '2014-03-15 00:08:47.000000', 'consum', 0.0216, 'lps'),
	(584462, 129, '2014-03-15 00:08:48.000000', 'consum', 0.0210, 'lps'),
	(584463, 129, '2014-03-15 00:08:49.000000', 'consum', 0.0220, 'lps'),
	(584464, 129, '2014-03-15 00:08:50.000000', 'consum', 0.0218, 'lps'),
	(584465, 129, '2014-03-15 00:08:51.000000', 'consum', 0.0219, 'lps'),
	(584466, 129, '2014-03-15 00:08:52.000000', 'consum', 0.0220, 'lps'),
	(584467, 129, '2014-03-15 00:08:53.000000', 'consum', 0.0218, 'lps'),
	(584468, 129, '2014-03-15 00:08:54.000000', 'consum', 0.0220, 'lps'),
	(584469, 129, '2014-03-15 00:08:55.000000', 'consum', 0.0210, 'lps'),
	(584470, 129, '2014-03-15 00:08:56.000000', 'consum', 0.0221, 'lps'),
	(584471, 129, '2014-03-15 00:08:57.000000', 'consum', 0.0210, 'lps'),
	(584472, 129, '2014-03-15 00:08:58.000000', 'consum', 0.0220, 'lps'),
	(584473, 129, '2014-03-15 00:08:59.000000', 'consum', 0.0220, 'lps'),
	(584474, 129, '2014-03-15 00:09:00.000000', 'consum', 0.0215, 'lps'),
	(584475, 129, '2014-03-15 00:09:01.000000', 'consum', 0.0219, 'lps'),
	(584476, 129, '2014-03-15 00:09:02.000000', 'consum', 0.0211, 'lps'),
	(584477, 129, '2014-03-15 00:09:03.000000', 'consum', 0.0217, 'lps'),
	(584478, 129, '2014-03-15 00:09:04.000000', 'consum', 0.0216, 'lps'),
	(584479, 129, '2014-03-15 00:09:05.000000', 'consum', 0.0221, 'lps'),
	(584480, 129, '2014-03-15 00:09:06.000000', 'consum', 0.0218, 'lps'),
	(584481, 129, '2014-03-15 00:09:07.000000', 'consum', 0.0216, 'lps'),
	(584482, 129, '2014-03-15 00:09:08.000000', 'consum', 0.0219, 'lps'),
	(584483, 129, '2014-03-15 00:09:09.000000', 'consum', 0.0222, 'lps'),
	(584484, 129, '2014-03-15 00:09:10.000000', 'consum', 0.0215, 'lps'),
	(584485, 129, '2014-03-15 00:09:11.000000', 'consum', 0.0213, 'lps'),
	(584486, 129, '2014-03-15 00:09:12.000000', 'consum', 0.0223, 'lps'),
	(584487, 129, '2014-03-15 00:09:13.000000', 'consum', 0.0213, 'lps'),
	(584488, 129, '2014-03-15 00:09:14.000000', 'consum', 0.0215, 'lps'),
	(584489, 129, '2014-03-15 00:09:15.000000', 'consum', 0.0211, 'lps'),
	(584490, 129, '2014-03-15 00:09:16.000000', 'consum', 0.0216, 'lps'),
	(584491, 129, '2014-03-15 00:09:17.000000', 'consum', 0.0222, 'lps'),
	(584492, 129, '2014-03-15 00:09:18.000000', 'consum', 0.0210, 'lps'),
	(584493, 129, '2014-03-15 00:09:19.000000', 'consum', 0.0216, 'lps'),
	(584494, 129, '2014-03-15 00:09:20.000000', 'consum', 0.0213, 'lps'),
	(584495, 129, '2014-03-15 00:09:21.000000', 'consum', 0.0221, 'lps'),
	(584496, 129, '2014-03-15 00:09:22.000000', 'consum', 0.0214, 'lps'),
	(584497, 129, '2014-03-15 00:09:23.000000', 'consum', 0.0211, 'lps'),
	(584498, 129, '2014-03-15 00:09:24.000000', 'consum', 0.0219, 'lps'),
	(584499, 129, '2014-03-15 00:09:25.000000', 'consum', 0.0211, 'lps'),
	(584500, 129, '2014-03-15 00:09:26.000000', 'consum', 0.0214, 'lps'),
	(584501, 129, '2014-03-15 00:09:27.000000', 'consum', 0.0217, 'lps'),
	(584502, 129, '2014-03-15 00:09:28.000000', 'consum', 0.0217, 'lps'),
	(584503, 129, '2014-03-15 00:09:29.000000', 'consum', 0.0213, 'lps'),
	(584504, 129, '2014-03-15 00:09:30.000000', 'consum', 0.0216, 'lps'),
	(584505, 129, '2014-03-15 00:09:31.000000', 'consum', 0.0216, 'lps'),
	(584506, 129, '2014-03-15 00:09:32.000000', 'consum', 0.0212, 'lps'),
	(584507, 129, '2014-03-15 00:09:33.000000', 'consum', 0.0215, 'lps'),
	(584508, 129, '2014-03-15 00:09:34.000000', 'consum', 0.0215, 'lps'),
	(584509, 129, '2014-03-15 00:09:35.000000', 'consum', 0.0221, 'lps'),
	(584510, 129, '2014-03-15 00:09:36.000000', 'consum', 0.0223, 'lps'),
	(584511, 129, '2014-03-15 00:09:37.000000', 'consum', 0.0215, 'lps'),
	(584512, 129, '2014-03-15 00:09:38.000000', 'consum', 0.0223, 'lps'),
	(584513, 129, '2014-03-15 00:09:39.000000', 'consum', 0.0219, 'lps'),
	(584514, 129, '2014-03-15 00:09:40.000000', 'consum', 0.0218, 'lps'),
	(584515, 129, '2014-03-15 00:09:41.000000', 'consum', 0.0223, 'lps'),
	(584516, 129, '2014-03-15 00:09:42.000000', 'consum', 0.0211, 'lps'),
	(584517, 129, '2014-03-15 00:09:43.000000', 'consum', 0.0218, 'lps'),
	(584518, 129, '2014-03-15 00:09:44.000000', 'consum', 0.0221, 'lps'),
	(584519, 129, '2014-03-15 00:09:45.000000', 'consum', 0.0210, 'lps'),
	(584520, 129, '2014-03-15 00:09:46.000000', 'consum', 0.0223, 'lps'),
	(584521, 129, '2014-03-15 00:09:47.000000', 'consum', 0.0216, 'lps'),
	(584522, 129, '2014-03-15 00:09:48.000000', 'consum', 0.0218, 'lps'),
	(584523, 129, '2014-03-15 00:09:49.000000', 'consum', 0.0216, 'lps'),
	(584524, 129, '2014-03-15 00:09:50.000000', 'consum', 0.0219, 'lps'),
	(584525, 129, '2014-03-15 00:09:51.000000', 'consum', 0.0223, 'lps'),
	(584526, 129, '2014-03-15 00:09:52.000000', 'consum', 0.0222, 'lps'),
	(584527, 129, '2014-03-15 00:09:53.000000', 'consum', 0.0218, 'lps'),
	(584528, 129, '2014-03-15 00:09:54.000000', 'consum', 0.0212, 'lps'),
	(584529, 129, '2014-03-15 00:09:55.000000', 'consum', 0.0210, 'lps'),
	(584530, 129, '2014-03-15 00:09:56.000000', 'consum', 0.0221, 'lps'),
	(584531, 129, '2014-03-15 00:09:57.000000', 'consum', 0.0223, 'lps'),
	(584532, 129, '2014-03-15 00:09:58.000000', 'consum', 0.0215, 'lps'),
	(584533, 129, '2014-03-15 00:09:59.000000', 'consum', 0.0211, 'lps'),
	(584534, 129, '2014-03-15 00:10:00.000000', 'consum', 0.0213, 'lps'),
	(584535, 129, '2014-03-15 00:10:01.000000', 'consum', 0.0222, 'lps'),
	(584536, 129, '2014-03-15 00:10:02.000000', 'consum', 0.0220, 'lps'),
	(584537, 129, '2014-03-15 00:10:03.000000', 'consum', 0.0210, 'lps'),
	(584538, 129, '2014-03-15 00:10:04.000000', 'consum', 0.0223, 'lps'),
	(584539, 129, '2014-03-15 00:10:05.000000', 'consum', 0.0220, 'lps'),
	(584540, 129, '2014-03-15 00:10:06.000000', 'consum', 0.0221, 'lps'),
	(584541, 129, '2014-03-15 00:10:07.000000', 'consum', 0.0221, 'lps'),
	(584542, 129, '2014-03-15 00:10:08.000000', 'consum', 0.0220, 'lps'),
	(584543, 129, '2014-03-15 00:10:09.000000', 'consum', 0.0211, 'lps'),
	(584544, 129, '2014-03-15 00:10:10.000000', 'consum', 0.0214, 'lps'),
	(584545, 129, '2014-03-15 00:10:11.000000', 'consum', 0.0215, 'lps'),
	(584546, 129, '2014-03-15 00:10:12.000000', 'consum', 0.0210, 'lps'),
	(584547, 129, '2014-03-15 00:10:13.000000', 'consum', 0.0210, 'lps'),
	(584548, 129, '2014-03-15 00:10:14.000000', 'consum', 0.0223, 'lps'),
	(584549, 129, '2014-03-15 00:10:15.000000', 'consum', 0.0221, 'lps'),
	(584550, 129, '2014-03-15 00:10:16.000000', 'consum', 0.0214, 'lps'),
	(584551, 129, '2014-03-15 00:10:17.000000', 'consum', 0.0222, 'lps'),
	(584552, 129, '2014-03-15 00:10:18.000000', 'consum', 0.0219, 'lps'),
	(584553, 129, '2014-03-15 00:10:19.000000', 'consum', 0.0221, 'lps'),
	(584554, 129, '2014-03-15 00:10:20.000000', 'consum', 0.0222, 'lps'),
	(584555, 129, '2014-03-15 00:10:21.000000', 'consum', 0.0210, 'lps'),
	(584556, 129, '2014-03-15 00:10:22.000000', 'consum', 0.0215, 'lps'),
	(584557, 129, '2014-03-15 00:10:23.000000', 'consum', 0.0210, 'lps'),
	(584558, 129, '2014-03-15 00:10:24.000000', 'consum', 0.0221, 'lps'),
	(584559, 129, '2014-03-15 00:10:25.000000', 'consum', 0.0212, 'lps'),
	(584560, 129, '2014-03-15 00:10:26.000000', 'consum', 0.0216, 'lps'),
	(584561, 129, '2014-03-15 00:10:27.000000', 'consum', 0.0221, 'lps'),
	(584562, 129, '2014-03-15 00:10:28.000000', 'consum', 0.0217, 'lps'),
	(584563, 129, '2014-03-15 00:10:29.000000', 'consum', 0.0214, 'lps'),
	(584564, 129, '2014-03-15 00:10:30.000000', 'consum', 0.0222, 'lps'),
	(584565, 129, '2014-03-15 00:10:31.000000', 'consum', 0.0217, 'lps'),
	(584566, 129, '2014-03-15 00:10:32.000000', 'consum', 0.0222, 'lps'),
	(584567, 129, '2014-03-15 00:10:33.000000', 'consum', 0.0222, 'lps'),
	(584568, 129, '2014-03-15 00:10:34.000000', 'consum', 0.0223, 'lps'),
	(584569, 129, '2014-03-15 00:10:35.000000', 'consum', 0.0210, 'lps'),
	(584570, 129, '2014-03-15 00:10:36.000000', 'consum', 0.0214, 'lps'),
	(584571, 129, '2014-03-15 00:10:37.000000', 'consum', 0.0215, 'lps'),
	(584572, 129, '2014-03-15 00:10:38.000000', 'consum', 0.0210, 'lps'),
	(584573, 129, '2014-03-15 00:10:39.000000', 'consum', 0.0223, 'lps'),
	(584574, 129, '2014-03-15 00:10:40.000000', 'consum', 0.0222, 'lps'),
	(584575, 129, '2014-03-15 00:10:41.000000', 'consum', 0.0215, 'lps'),
	(584576, 129, '2014-03-15 00:10:42.000000', 'consum', 0.0214, 'lps'),
	(584577, 129, '2014-03-15 00:10:43.000000', 'consum', 0.0216, 'lps'),
	(584578, 129, '2014-03-15 00:10:44.000000', 'consum', 0.0213, 'lps'),
	(584579, 129, '2014-03-15 00:10:45.000000', 'consum', 0.0220, 'lps'),
	(584580, 129, '2014-03-15 00:10:46.000000', 'consum', 0.0213, 'lps'),
	(584581, 129, '2014-03-15 00:10:47.000000', 'consum', 0.0220, 'lps'),
	(584582, 129, '2014-03-15 00:10:48.000000', 'consum', 0.0212, 'lps'),
	(584583, 129, '2014-03-15 00:10:49.000000', 'consum', 0.0219, 'lps'),
	(584584, 129, '2014-03-15 00:10:50.000000', 'consum', 0.0221, 'lps'),
	(584585, 129, '2014-03-15 00:10:51.000000', 'consum', 0.0212, 'lps'),
	(584586, 129, '2014-03-15 00:10:52.000000', 'consum', 0.0215, 'lps'),
	(584587, 129, '2014-03-15 00:10:53.000000', 'consum', 0.0217, 'lps'),
	(584588, 129, '2014-03-15 00:10:54.000000', 'consum', 0.0215, 'lps'),
	(584589, 129, '2014-03-15 00:10:55.000000', 'consum', 0.0213, 'lps'),
	(584590, 129, '2014-03-15 00:10:56.000000', 'consum', 0.0210, 'lps'),
	(584591, 129, '2014-03-15 00:10:57.000000', 'consum', 0.0215, 'lps'),
	(584592, 129, '2014-03-15 00:10:58.000000', 'consum', 0.0222, 'lps'),
	(584593, 129, '2014-03-15 00:10:59.000000', 'consum', 0.0212, 'lps'),
	(584594, 129, '2014-03-15 00:11:00.000000', 'consum', 0.0214, 'lps'),
	(584595, 129, '2014-03-15 00:11:01.000000', 'consum', 0.0212, 'lps'),
	(584596, 129, '2014-03-15 00:11:02.000000', 'consum', 0.0222, 'lps'),
	(584597, 129, '2014-03-15 00:11:03.000000', 'consum', 0.0221, 'lps'),
	(584598, 129, '2014-03-15 00:11:04.000000', 'consum', 0.0215, 'lps'),
	(584599, 129, '2014-03-15 00:11:05.000000', 'consum', 0.0218, 'lps'),
	(584600, 129, '2014-03-15 00:11:06.000000', 'consum', 0.0223, 'lps'),
	(584601, 129, '2014-03-15 00:11:07.000000', 'consum', 0.0221, 'lps'),
	(584602, 129, '2014-03-15 00:11:08.000000', 'consum', 0.0212, 'lps'),
	(584603, 129, '2014-03-15 00:11:09.000000', 'consum', 0.0215, 'lps'),
	(584604, 129, '2014-03-15 00:11:10.000000', 'consum', 0.0216, 'lps'),
	(584605, 129, '2014-03-15 00:11:11.000000', 'consum', 0.0212, 'lps'),
	(584606, 129, '2014-03-15 00:11:12.000000', 'consum', 0.0214, 'lps'),
	(584607, 129, '2014-03-15 00:11:13.000000', 'consum', 0.0214, 'lps'),
	(584608, 129, '2014-03-15 00:11:14.000000', 'consum', 0.0215, 'lps'),
	(584609, 129, '2014-03-15 00:11:15.000000', 'consum', 0.0211, 'lps'),
	(584610, 129, '2014-03-15 00:11:16.000000', 'consum', 0.0216, 'lps'),
	(584611, 129, '2014-03-15 00:11:17.000000', 'consum', 0.0210, 'lps'),
	(584612, 129, '2014-03-15 00:11:18.000000', 'consum', 0.0218, 'lps'),
	(584613, 129, '2014-03-15 00:11:19.000000', 'consum', 0.0211, 'lps'),
	(584614, 129, '2014-03-15 00:11:20.000000', 'consum', 0.0218, 'lps'),
	(584615, 129, '2014-03-15 00:11:21.000000', 'consum', 0.0220, 'lps'),
	(584616, 129, '2014-03-15 00:11:22.000000', 'consum', 0.0223, 'lps'),
	(584617, 129, '2014-03-15 00:11:23.000000', 'consum', 0.0216, 'lps'),
	(584618, 129, '2014-03-15 00:11:24.000000', 'consum', 0.0215, 'lps'),
	(584619, 129, '2014-03-15 00:11:25.000000', 'consum', 0.0218, 'lps'),
	(584620, 129, '2014-03-15 00:11:26.000000', 'consum', 0.0222, 'lps'),
	(584621, 129, '2014-03-15 00:11:27.000000', 'consum', 0.0218, 'lps'),
	(584622, 129, '2014-03-15 00:11:28.000000', 'consum', 0.0213, 'lps'),
	(584623, 129, '2014-03-15 00:11:29.000000', 'consum', 0.0218, 'lps'),
	(584624, 129, '2014-03-15 00:11:30.000000', 'consum', 0.0214, 'lps'),
	(584625, 129, '2014-03-15 00:11:31.000000', 'consum', 0.0221, 'lps'),
	(584626, 129, '2014-03-15 00:11:32.000000', 'consum', 0.0223, 'lps'),
	(584627, 129, '2014-03-15 00:11:33.000000', 'consum', 0.0215, 'lps'),
	(584628, 129, '2014-03-15 00:11:34.000000', 'consum', 0.0210, 'lps'),
	(584629, 129, '2014-03-15 00:11:35.000000', 'consum', 0.0211, 'lps'),
	(584630, 129, '2014-03-15 00:11:36.000000', 'consum', 0.0215, 'lps'),
	(584631, 129, '2014-03-15 00:11:37.000000', 'consum', 0.0216, 'lps'),
	(584632, 129, '2014-03-15 00:11:38.000000', 'consum', 0.0214, 'lps'),
	(584633, 129, '2014-03-15 00:11:39.000000', 'consum', 0.0213, 'lps'),
	(584634, 129, '2014-03-15 00:11:40.000000', 'consum', 0.0215, 'lps'),
	(584635, 129, '2014-03-15 00:11:41.000000', 'consum', 0.0210, 'lps'),
	(584636, 129, '2014-03-15 00:11:42.000000', 'consum', 0.0212, 'lps'),
	(584637, 129, '2014-03-15 00:11:43.000000', 'consum', 0.0218, 'lps'),
	(584638, 129, '2014-03-15 00:11:44.000000', 'consum', 0.0218, 'lps'),
	(584639, 129, '2014-03-15 00:11:45.000000', 'consum', 0.0210, 'lps'),
	(584640, 129, '2014-03-15 00:11:46.000000', 'consum', 0.0216, 'lps'),
	(584641, 129, '2014-03-15 00:11:47.000000', 'consum', 0.0212, 'lps'),
	(584642, 129, '2014-03-15 00:11:48.000000', 'consum', 0.0219, 'lps'),
	(584643, 129, '2014-03-15 00:11:49.000000', 'consum', 0.0218, 'lps'),
	(584644, 129, '2014-03-15 00:11:50.000000', 'consum', 0.0211, 'lps'),
	(584645, 129, '2014-03-15 00:11:51.000000', 'consum', 0.0221, 'lps'),
	(584646, 129, '2014-03-15 00:11:52.000000', 'consum', 0.0218, 'lps'),
	(584647, 129, '2014-03-15 00:11:53.000000', 'consum', 0.0219, 'lps'),
	(584648, 129, '2014-03-15 00:11:54.000000', 'consum', 0.0216, 'lps'),
	(584649, 129, '2014-03-15 00:11:55.000000', 'consum', 0.0216, 'lps'),
	(584650, 129, '2014-03-15 00:11:56.000000', 'consum', 0.0220, 'lps'),
	(584651, 129, '2014-03-15 00:11:57.000000', 'consum', 0.0214, 'lps'),
	(584652, 129, '2014-03-15 00:11:58.000000', 'consum', 0.0217, 'lps'),
	(584653, 129, '2014-03-15 00:11:59.000000', 'consum', 0.0218, 'lps'),
	(584654, 129, '2014-03-15 00:12:00.000000', 'consum', 0.0214, 'lps'),
	(584655, 129, '2014-03-15 00:12:01.000000', 'consum', 0.0210, 'lps'),
	(584656, 129, '2014-03-15 00:12:02.000000', 'consum', 0.0210, 'lps'),
	(584657, 129, '2014-03-15 00:12:03.000000', 'consum', 0.0210, 'lps'),
	(584658, 129, '2014-03-15 00:12:04.000000', 'consum', 0.0211, 'lps'),
	(584659, 129, '2014-03-15 00:12:05.000000', 'consum', 0.0215, 'lps'),
	(584660, 129, '2014-03-15 00:12:06.000000', 'consum', 0.0219, 'lps'),
	(584661, 129, '2014-03-15 00:12:07.000000', 'consum', 0.0213, 'lps'),
	(584662, 129, '2014-03-15 00:12:08.000000', 'consum', 0.0212, 'lps'),
	(584663, 129, '2014-03-15 00:12:09.000000', 'consum', 0.0212, 'lps'),
	(584664, 129, '2014-03-15 00:12:10.000000', 'consum', 0.0213, 'lps'),
	(584665, 129, '2014-03-15 00:12:11.000000', 'consum', 0.0219, 'lps'),
	(584666, 129, '2014-03-15 00:12:12.000000', 'consum', 0.0220, 'lps'),
	(584667, 129, '2014-03-15 00:12:13.000000', 'consum', 0.0220, 'lps'),
	(584668, 129, '2014-03-15 00:12:14.000000', 'consum', 0.0214, 'lps'),
	(584669, 129, '2014-03-15 00:12:15.000000', 'consum', 0.0215, 'lps'),
	(584670, 129, '2014-03-15 00:12:16.000000', 'consum', 0.0211, 'lps'),
	(584671, 129, '2014-03-15 00:12:17.000000', 'consum', 0.0214, 'lps'),
	(584672, 129, '2014-03-15 00:12:18.000000', 'consum', 0.0211, 'lps'),
	(584673, 129, '2014-03-15 00:12:19.000000', 'consum', 0.0221, 'lps'),
	(584674, 129, '2014-03-15 00:12:20.000000', 'consum', 0.0219, 'lps'),
	(584675, 129, '2014-03-15 00:12:21.000000', 'consum', 0.0221, 'lps'),
	(584676, 129, '2014-03-15 00:12:22.000000', 'consum', 0.0214, 'lps'),
	(584677, 129, '2014-03-15 00:12:23.000000', 'consum', 0.0222, 'lps'),
	(584678, 129, '2014-03-15 00:12:24.000000', 'consum', 0.0217, 'lps'),
	(584679, 129, '2014-03-15 00:12:25.000000', 'consum', 0.0211, 'lps'),
	(584680, 129, '2014-03-15 00:12:26.000000', 'consum', 0.0223, 'lps'),
	(584681, 129, '2014-03-15 00:12:27.000000', 'consum', 0.0216, 'lps'),
	(584682, 129, '2014-03-15 00:12:28.000000', 'consum', 0.0214, 'lps'),
	(584683, 129, '2014-03-15 00:12:29.000000', 'consum', 0.0215, 'lps'),
	(584684, 129, '2014-03-15 00:12:30.000000', 'consum', 0.0221, 'lps'),
	(584685, 129, '2014-03-15 00:12:31.000000', 'consum', 0.0222, 'lps'),
	(584686, 129, '2014-03-15 00:12:32.000000', 'consum', 0.0211, 'lps'),
	(584687, 129, '2014-03-15 00:12:33.000000', 'consum', 0.0219, 'lps'),
	(584688, 129, '2014-03-15 00:12:34.000000', 'consum', 0.0213, 'lps'),
	(584689, 129, '2014-03-15 00:12:35.000000', 'consum', 0.0213, 'lps'),
	(584690, 129, '2014-03-15 00:12:36.000000', 'consum', 0.0215, 'lps'),
	(584691, 129, '2014-03-15 00:12:37.000000', 'consum', 0.0215, 'lps'),
	(584692, 129, '2014-03-15 00:12:38.000000', 'consum', 0.0218, 'lps'),
	(584693, 129, '2014-03-15 00:12:39.000000', 'consum', 0.0221, 'lps'),
	(584694, 129, '2014-03-15 00:12:40.000000', 'consum', 0.0215, 'lps'),
	(584695, 129, '2014-03-15 00:12:41.000000', 'consum', 0.0217, 'lps'),
	(584696, 129, '2014-03-15 00:12:42.000000', 'consum', 0.0217, 'lps'),
	(584697, 129, '2014-03-15 00:12:43.000000', 'consum', 0.0211, 'lps'),
	(584698, 129, '2014-03-15 00:12:44.000000', 'consum', 0.0220, 'lps'),
	(584699, 129, '2014-03-15 00:12:45.000000', 'consum', 0.0216, 'lps'),
	(584700, 129, '2014-03-15 00:12:46.000000', 'consum', 0.0212, 'lps'),
	(584701, 129, '2014-03-15 00:12:47.000000', 'consum', 0.0216, 'lps'),
	(584702, 129, '2014-03-15 00:12:48.000000', 'consum', 0.0219, 'lps'),
	(584703, 129, '2014-03-15 00:12:49.000000', 'consum', 0.0211, 'lps'),
	(584704, 129, '2014-03-15 00:12:50.000000', 'consum', 0.0217, 'lps'),
	(584705, 129, '2014-03-15 00:12:51.000000', 'consum', 0.0213, 'lps'),
	(584706, 129, '2014-03-15 00:12:52.000000', 'consum', 0.0218, 'lps'),
	(584707, 129, '2014-03-15 00:12:53.000000', 'consum', 0.0216, 'lps'),
	(584708, 129, '2014-03-15 00:12:54.000000', 'consum', 0.0214, 'lps'),
	(584709, 129, '2014-03-15 00:12:55.000000', 'consum', 0.0214, 'lps'),
	(584710, 129, '2014-03-15 00:12:56.000000', 'consum', 0.0218, 'lps'),
	(584711, 129, '2014-03-15 00:12:57.000000', 'consum', 0.0212, 'lps'),
	(584712, 129, '2014-03-15 00:12:58.000000', 'consum', 0.0210, 'lps'),
	(584713, 129, '2014-03-15 00:12:59.000000', 'consum', 0.0218, 'lps'),
	(584714, 129, '2014-03-15 00:13:00.000000', 'consum', 0.0221, 'lps'),
	(584715, 129, '2014-03-15 00:13:01.000000', 'consum', 0.0215, 'lps'),
	(584716, 129, '2014-03-15 00:13:02.000000', 'consum', 0.0215, 'lps'),
	(584717, 129, '2014-03-15 00:13:03.000000', 'consum', 0.0222, 'lps'),
	(584718, 129, '2014-03-15 00:13:04.000000', 'consum', 0.0215, 'lps'),
	(584719, 129, '2014-03-15 00:13:05.000000', 'consum', 0.0212, 'lps'),
	(584720, 129, '2014-03-15 00:13:06.000000', 'consum', 0.0218, 'lps'),
	(584721, 129, '2014-03-15 00:13:07.000000', 'consum', 0.0216, 'lps'),
	(584722, 129, '2014-03-15 00:13:08.000000', 'consum', 0.0218, 'lps'),
	(584723, 129, '2014-03-15 00:13:09.000000', 'consum', 0.0219, 'lps'),
	(584724, 129, '2014-03-15 00:13:10.000000', 'consum', 0.0217, 'lps'),
	(584725, 129, '2014-03-15 00:13:11.000000', 'consum', 0.0217, 'lps'),
	(584726, 129, '2014-03-15 00:13:12.000000', 'consum', 0.0213, 'lps'),
	(584727, 129, '2014-03-15 00:13:13.000000', 'consum', 0.0216, 'lps'),
	(584728, 129, '2014-03-15 00:13:14.000000', 'consum', 0.0218, 'lps'),
	(584729, 129, '2014-03-15 00:13:15.000000', 'consum', 0.0220, 'lps'),
	(584730, 129, '2014-03-15 00:13:16.000000', 'consum', 0.0220, 'lps'),
	(584731, 129, '2014-03-15 00:13:17.000000', 'consum', 0.0218, 'lps'),
	(584732, 129, '2014-03-15 00:13:18.000000', 'consum', 0.0221, 'lps'),
	(584733, 129, '2014-03-15 00:13:19.000000', 'consum', 0.0212, 'lps'),
	(584734, 129, '2014-03-15 00:13:20.000000', 'consum', 0.0215, 'lps'),
	(584735, 129, '2014-03-15 00:13:21.000000', 'consum', 0.0216, 'lps'),
	(584736, 129, '2014-03-15 00:13:22.000000', 'consum', 0.0212, 'lps'),
	(584737, 129, '2014-03-15 00:13:23.000000', 'consum', 0.0215, 'lps'),
	(584738, 129, '2014-03-15 00:13:24.000000', 'consum', 0.0216, 'lps'),
	(584739, 129, '2014-03-15 00:13:25.000000', 'consum', 0.0213, 'lps'),
	(584740, 129, '2014-03-15 00:13:26.000000', 'consum', 0.0220, 'lps'),
	(584741, 129, '2014-03-15 00:13:27.000000', 'consum', 0.0212, 'lps'),
	(584742, 129, '2014-03-15 00:13:28.000000', 'consum', 0.0217, 'lps'),
	(584743, 129, '2014-03-15 00:13:29.000000', 'consum', 0.0210, 'lps'),
	(584744, 129, '2014-03-15 00:13:30.000000', 'consum', 0.0217, 'lps'),
	(584745, 129, '2014-03-15 00:13:31.000000', 'consum', 0.0219, 'lps'),
	(584746, 129, '2014-03-15 00:13:32.000000', 'consum', 0.0219, 'lps'),
	(584747, 129, '2014-03-15 00:13:33.000000', 'consum', 0.0215, 'lps'),
	(584748, 129, '2014-03-15 00:13:34.000000', 'consum', 0.0223, 'lps'),
	(584749, 129, '2014-03-15 00:13:35.000000', 'consum', 0.0218, 'lps'),
	(584750, 129, '2014-03-15 00:13:36.000000', 'consum', 0.0212, 'lps'),
	(584751, 129, '2014-03-15 00:13:37.000000', 'consum', 0.0210, 'lps'),
	(584752, 129, '2014-03-15 00:13:38.000000', 'consum', 0.0219, 'lps'),
	(584753, 129, '2014-03-15 00:13:39.000000', 'consum', 0.0212, 'lps'),
	(584754, 129, '2014-03-15 00:13:40.000000', 'consum', 0.0221, 'lps'),
	(584755, 129, '2014-03-15 00:13:41.000000', 'consum', 0.0217, 'lps'),
	(584756, 129, '2014-03-15 00:13:42.000000', 'consum', 0.0212, 'lps'),
	(584757, 129, '2014-03-15 00:13:43.000000', 'consum', 0.0213, 'lps'),
	(584758, 129, '2014-03-15 00:13:44.000000', 'consum', 0.0222, 'lps'),
	(584759, 129, '2014-03-15 00:13:45.000000', 'consum', 0.0220, 'lps'),
	(584760, 129, '2014-03-15 00:13:46.000000', 'consum', 0.0210, 'lps'),
	(584761, 129, '2014-03-15 00:13:47.000000', 'consum', 0.0223, 'lps'),
	(584762, 129, '2014-03-15 00:13:48.000000', 'consum', 0.0217, 'lps'),
	(584763, 129, '2014-03-15 00:13:49.000000', 'consum', 0.0210, 'lps'),
	(584764, 129, '2014-03-15 00:13:50.000000', 'consum', 0.0214, 'lps'),
	(584765, 129, '2014-03-15 00:13:51.000000', 'consum', 0.0218, 'lps'),
	(584766, 129, '2014-03-15 00:13:52.000000', 'consum', 0.0223, 'lps'),
	(584767, 129, '2014-03-15 00:13:53.000000', 'consum', 0.0222, 'lps'),
	(584768, 129, '2014-03-15 00:13:54.000000', 'consum', 0.0221, 'lps'),
	(584769, 129, '2014-03-15 00:13:55.000000', 'consum', 0.0213, 'lps'),
	(584770, 129, '2014-03-15 00:13:56.000000', 'consum', 0.0221, 'lps'),
	(584771, 129, '2014-03-15 00:13:57.000000', 'consum', 0.0215, 'lps'),
	(584772, 129, '2014-03-15 00:13:58.000000', 'consum', 0.0216, 'lps'),
	(584773, 129, '2014-03-15 00:13:59.000000', 'consum', 0.0210, 'lps'),
	(584774, 129, '2014-03-15 00:14:00.000000', 'consum', 0.0221, 'lps'),
	(584775, 129, '2014-03-15 00:14:01.000000', 'consum', 0.0210, 'lps'),
	(584776, 129, '2014-03-15 00:14:02.000000', 'consum', 0.0218, 'lps'),
	(584777, 129, '2014-03-15 00:14:03.000000', 'consum', 0.0223, 'lps'),
	(584778, 129, '2014-03-15 00:14:04.000000', 'consum', 0.0210, 'lps'),
	(584779, 129, '2014-03-15 00:14:05.000000', 'consum', 0.0211, 'lps'),
	(584780, 129, '2014-03-15 00:14:06.000000', 'consum', 0.0219, 'lps'),
	(584781, 129, '2014-03-15 00:14:07.000000', 'consum', 0.0221, 'lps'),
	(584782, 129, '2014-03-15 00:14:08.000000', 'consum', 0.0214, 'lps'),
	(584783, 129, '2014-03-15 00:14:09.000000', 'consum', 0.0223, 'lps'),
	(584784, 129, '2014-03-15 00:14:10.000000', 'consum', 0.0223, 'lps'),
	(584785, 129, '2014-03-15 00:14:11.000000', 'consum', 0.0222, 'lps'),
	(584786, 129, '2014-03-15 00:14:12.000000', 'consum', 0.0217, 'lps'),
	(584787, 129, '2014-03-15 00:14:13.000000', 'consum', 0.0222, 'lps'),
	(584788, 129, '2014-03-15 00:14:14.000000', 'consum', 0.0223, 'lps'),
	(584789, 129, '2014-03-15 00:14:15.000000', 'consum', 0.0213, 'lps'),
	(584790, 129, '2014-03-15 00:14:16.000000', 'consum', 0.0215, 'lps'),
	(584791, 129, '2014-03-15 00:14:17.000000', 'consum', 0.0213, 'lps'),
	(584792, 129, '2014-03-15 00:14:18.000000', 'consum', 0.0211, 'lps'),
	(584793, 129, '2014-03-15 00:14:19.000000', 'consum', 0.0218, 'lps'),
	(584794, 129, '2014-03-15 00:14:20.000000', 'consum', 0.0221, 'lps'),
	(584795, 129, '2014-03-15 00:14:21.000000', 'consum', 0.0213, 'lps'),
	(584796, 129, '2014-03-15 00:14:22.000000', 'consum', 0.0221, 'lps'),
	(584797, 129, '2014-03-15 00:14:23.000000', 'consum', 0.0214, 'lps'),
	(584798, 129, '2014-03-15 00:14:24.000000', 'consum', 0.0212, 'lps'),
	(584799, 129, '2014-03-15 00:14:25.000000', 'consum', 0.0223, 'lps'),
	(584800, 129, '2014-03-15 00:14:26.000000', 'consum', 0.0211, 'lps'),
	(584801, 129, '2014-03-15 00:14:27.000000', 'consum', 0.0219, 'lps'),
	(584802, 129, '2014-03-15 00:14:28.000000', 'consum', 0.0213, 'lps'),
	(584803, 129, '2014-03-15 00:14:29.000000', 'consum', 0.0211, 'lps'),
	(584804, 129, '2014-03-15 00:14:30.000000', 'consum', 0.0220, 'lps'),
	(584805, 129, '2014-03-15 00:14:31.000000', 'consum', 0.0217, 'lps'),
	(584806, 129, '2014-03-15 00:14:32.000000', 'consum', 0.0214, 'lps'),
	(584807, 129, '2014-03-15 00:14:33.000000', 'consum', 0.0222, 'lps'),
	(584808, 129, '2014-03-15 00:14:34.000000', 'consum', 0.0218, 'lps'),
	(584809, 129, '2014-03-15 00:14:35.000000', 'consum', 0.0216, 'lps'),
	(584810, 129, '2014-03-15 00:14:36.000000', 'consum', 0.0217, 'lps'),
	(584811, 129, '2014-03-15 00:14:37.000000', 'consum', 0.0211, 'lps'),
	(584812, 129, '2014-03-15 00:14:38.000000', 'consum', 0.0222, 'lps'),
	(584813, 129, '2014-03-15 00:14:39.000000', 'consum', 0.0214, 'lps'),
	(584814, 129, '2014-03-15 00:14:40.000000', 'consum', 0.0222, 'lps'),
	(584815, 129, '2014-03-15 00:14:41.000000', 'consum', 0.0214, 'lps'),
	(584816, 129, '2014-03-15 00:14:42.000000', 'consum', 0.0211, 'lps'),
	(584817, 129, '2014-03-15 00:14:43.000000', 'consum', 0.0216, 'lps'),
	(584818, 129, '2014-03-15 00:14:44.000000', 'consum', 0.0210, 'lps'),
	(584819, 129, '2014-03-15 00:14:45.000000', 'consum', 0.0222, 'lps'),
	(584820, 129, '2014-03-15 00:14:46.000000', 'consum', 0.0215, 'lps'),
	(584821, 129, '2014-03-15 00:14:47.000000', 'consum', 0.0211, 'lps'),
	(584822, 129, '2014-03-15 00:14:48.000000', 'consum', 0.0216, 'lps'),
	(584823, 129, '2014-03-15 00:14:49.000000', 'consum', 0.0211, 'lps'),
	(584824, 129, '2014-03-15 00:14:50.000000', 'consum', 0.0210, 'lps'),
	(584825, 129, '2014-03-15 00:14:51.000000', 'consum', 0.0223, 'lps'),
	(584826, 129, '2014-03-15 00:14:52.000000', 'consum', 0.0217, 'lps'),
	(584827, 129, '2014-03-15 00:14:53.000000', 'consum', 0.0222, 'lps'),
	(584828, 129, '2014-03-15 00:14:54.000000', 'consum', 0.0220, 'lps'),
	(584829, 129, '2014-03-15 00:14:55.000000', 'consum', 0.0210, 'lps'),
	(584830, 129, '2014-03-15 00:14:56.000000', 'consum', 0.0223, 'lps'),
	(584831, 129, '2014-03-15 00:14:57.000000', 'consum', 0.0219, 'lps'),
	(584832, 129, '2014-03-15 00:14:58.000000', 'consum', 0.0218, 'lps'),
	(584833, 129, '2014-03-15 00:14:59.000000', 'consum', 0.0221, 'lps'),
	(584834, 129, '2014-03-15 00:15:00.000000', 'consum', 0.0217, 'lps'),
	(584835, 129, '2014-03-15 00:15:01.000000', 'consum', 0.0210, 'lps'),
	(584836, 129, '2014-03-15 00:15:02.000000', 'consum', 0.0217, 'lps'),
	(584837, 129, '2014-03-15 00:15:03.000000', 'consum', 0.0218, 'lps'),
	(584838, 129, '2014-03-15 00:15:04.000000', 'consum', 0.0217, 'lps'),
	(584839, 129, '2014-03-15 00:15:05.000000', 'consum', 0.0219, 'lps'),
	(584840, 129, '2014-03-15 00:15:06.000000', 'consum', 0.0223, 'lps'),
	(584841, 129, '2014-03-15 00:15:07.000000', 'consum', 0.0218, 'lps'),
	(584842, 129, '2014-03-15 00:15:08.000000', 'consum', 0.0214, 'lps'),
	(584843, 129, '2014-03-15 00:15:09.000000', 'consum', 0.0218, 'lps'),
	(584844, 129, '2014-03-15 00:15:10.000000', 'consum', 0.0212, 'lps'),
	(584845, 129, '2014-03-15 00:15:11.000000', 'consum', 0.0211, 'lps'),
	(584846, 129, '2014-03-15 00:15:12.000000', 'consum', 0.0211, 'lps'),
	(584847, 129, '2014-03-15 00:15:13.000000', 'consum', 0.0210, 'lps'),
	(584848, 129, '2014-03-15 00:15:14.000000', 'consum', 0.0221, 'lps'),
	(584849, 129, '2014-03-15 00:15:15.000000', 'consum', 0.0211, 'lps'),
	(584850, 129, '2014-03-15 00:15:16.000000', 'consum', 0.0223, 'lps'),
	(584851, 129, '2014-03-15 00:15:17.000000', 'consum', 0.0218, 'lps'),
	(584852, 129, '2014-03-15 00:15:18.000000', 'consum', 0.0212, 'lps'),
	(584853, 129, '2014-03-15 00:15:19.000000', 'consum', 0.0211, 'lps'),
	(584854, 129, '2014-03-15 00:15:20.000000', 'consum', 0.0221, 'lps'),
	(584855, 129, '2014-03-15 00:15:21.000000', 'consum', 0.0220, 'lps'),
	(584856, 129, '2014-03-15 00:15:22.000000', 'consum', 0.0213, 'lps'),
	(584857, 129, '2014-03-15 00:15:23.000000', 'consum', 0.0212, 'lps'),
	(584858, 129, '2014-03-15 00:15:24.000000', 'consum', 0.0211, 'lps'),
	(584859, 129, '2014-03-15 00:15:25.000000', 'consum', 0.0223, 'lps'),
	(584860, 129, '2014-03-15 00:15:26.000000', 'consum', 0.0218, 'lps'),
	(584861, 129, '2014-03-15 00:15:27.000000', 'consum', 0.0210, 'lps'),
	(584862, 129, '2014-03-15 00:15:28.000000', 'consum', 0.0213, 'lps'),
	(584863, 129, '2014-03-15 00:15:29.000000', 'consum', 0.0212, 'lps'),
	(584864, 129, '2014-03-15 00:15:30.000000', 'consum', 0.0211, 'lps'),
	(584865, 129, '2014-03-15 00:15:31.000000', 'consum', 0.0211, 'lps'),
	(584866, 129, '2014-03-15 00:15:32.000000', 'consum', 0.0213, 'lps'),
	(584867, 129, '2014-03-15 00:15:33.000000', 'consum', 0.0220, 'lps'),
	(584868, 129, '2014-03-15 00:15:34.000000', 'consum', 0.0213, 'lps'),
	(584869, 129, '2014-03-15 00:15:35.000000', 'consum', 0.0221, 'lps'),
	(584870, 129, '2014-03-15 00:15:36.000000', 'consum', 0.0217, 'lps'),
	(584871, 129, '2014-03-15 00:15:37.000000', 'consum', 0.0210, 'lps'),
	(584872, 129, '2014-03-15 00:15:38.000000', 'consum', 0.0219, 'lps'),
	(584873, 129, '2014-03-15 00:15:39.000000', 'consum', 0.0213, 'lps'),
	(584874, 129, '2014-03-15 00:15:40.000000', 'consum', 0.0212, 'lps'),
	(584875, 129, '2014-03-15 00:15:41.000000', 'consum', 0.0214, 'lps'),
	(584876, 129, '2014-03-15 00:15:42.000000', 'consum', 0.0223, 'lps'),
	(584877, 129, '2014-03-15 00:15:43.000000', 'consum', 0.0221, 'lps'),
	(584878, 129, '2014-03-15 00:15:44.000000', 'consum', 0.0213, 'lps'),
	(584879, 129, '2014-03-15 00:15:45.000000', 'consum', 0.0219, 'lps'),
	(584880, 129, '2014-03-15 00:15:46.000000', 'consum', 0.0219, 'lps'),
	(584881, 129, '2014-03-15 00:15:47.000000', 'consum', 0.0216, 'lps'),
	(584882, 129, '2014-03-15 00:15:48.000000', 'consum', 0.0213, 'lps'),
	(584883, 129, '2014-03-15 00:15:49.000000', 'consum', 0.0223, 'lps'),
	(584884, 129, '2014-03-15 00:15:50.000000', 'consum', 0.0210, 'lps'),
	(584885, 129, '2014-03-15 00:15:51.000000', 'consum', 0.0213, 'lps'),
	(584886, 129, '2014-03-15 00:15:52.000000', 'consum', 0.0213, 'lps'),
	(584887, 129, '2014-03-15 00:15:53.000000', 'consum', 0.0217, 'lps'),
	(584888, 129, '2014-03-15 00:15:54.000000', 'consum', 0.0222, 'lps'),
	(584889, 129, '2014-03-15 00:15:55.000000', 'consum', 0.0220, 'lps'),
	(584890, 129, '2014-03-15 00:15:56.000000', 'consum', 0.0210, 'lps'),
	(584891, 129, '2014-03-15 00:15:57.000000', 'consum', 0.0222, 'lps'),
	(584892, 129, '2014-03-15 00:15:58.000000', 'consum', 0.0218, 'lps'),
	(584893, 129, '2014-03-15 00:15:59.000000', 'consum', 0.0211, 'lps'),
	(584894, 129, '2014-03-15 00:16:00.000000', 'consum', 0.0221, 'lps'),
	(584895, 129, '2014-03-15 00:16:01.000000', 'consum', 0.0219, 'lps'),
	(584896, 129, '2014-03-15 00:16:02.000000', 'consum', 0.0223, 'lps'),
	(584897, 129, '2014-03-15 00:16:03.000000', 'consum', 0.0221, 'lps'),
	(584898, 129, '2014-03-15 00:16:04.000000', 'consum', 0.0214, 'lps'),
	(584899, 129, '2014-03-15 00:16:05.000000', 'consum', 0.0212, 'lps'),
	(584900, 129, '2014-03-15 00:16:06.000000', 'consum', 0.0222, 'lps'),
	(584901, 129, '2014-03-15 00:16:07.000000', 'consum', 0.0221, 'lps'),
	(584902, 129, '2014-03-15 00:16:08.000000', 'consum', 0.0215, 'lps'),
	(584903, 129, '2014-03-15 00:16:09.000000', 'consum', 0.0218, 'lps'),
	(584904, 129, '2014-03-15 00:16:10.000000', 'consum', 0.0221, 'lps'),
	(584905, 129, '2014-03-15 00:16:11.000000', 'consum', 0.0214, 'lps'),
	(584906, 129, '2014-03-15 00:16:12.000000', 'consum', 0.0223, 'lps'),
	(584907, 129, '2014-03-15 00:16:13.000000', 'consum', 0.0210, 'lps'),
	(584908, 129, '2014-03-15 00:16:14.000000', 'consum', 0.0212, 'lps'),
	(584909, 129, '2014-03-15 00:16:15.000000', 'consum', 0.0222, 'lps'),
	(584910, 129, '2014-03-15 00:16:16.000000', 'consum', 0.0223, 'lps'),
	(584911, 129, '2014-03-15 00:16:17.000000', 'consum', 0.0223, 'lps'),
	(584912, 129, '2014-03-15 00:16:18.000000', 'consum', 0.0210, 'lps'),
	(584913, 129, '2014-03-15 00:16:19.000000', 'consum', 0.0213, 'lps'),
	(584914, 129, '2014-03-15 00:16:20.000000', 'consum', 0.0210, 'lps'),
	(584915, 129, '2014-03-15 00:16:21.000000', 'consum', 0.0218, 'lps'),
	(584916, 129, '2014-03-15 00:16:22.000000', 'consum', 0.0222, 'lps'),
	(584917, 129, '2014-03-15 00:16:23.000000', 'consum', 0.0220, 'lps'),
	(584918, 129, '2014-03-15 00:16:24.000000', 'consum', 0.0222, 'lps'),
	(584919, 129, '2014-03-15 00:16:25.000000', 'consum', 0.0213, 'lps'),
	(584920, 129, '2014-03-15 00:16:26.000000', 'consum', 0.0216, 'lps'),
	(584921, 129, '2014-03-15 00:16:27.000000', 'consum', 0.0220, 'lps'),
	(584922, 129, '2014-03-15 00:16:28.000000', 'consum', 0.0215, 'lps'),
	(584923, 129, '2014-03-15 00:16:29.000000', 'consum', 0.0217, 'lps'),
	(584924, 129, '2014-03-15 00:16:30.000000', 'consum', 0.0220, 'lps'),
	(584925, 129, '2014-03-15 00:16:31.000000', 'consum', 0.0222, 'lps'),
	(584926, 129, '2014-03-15 00:16:32.000000', 'consum', 0.0214, 'lps'),
	(584927, 129, '2014-03-15 00:16:33.000000', 'consum', 0.0210, 'lps'),
	(584928, 129, '2014-03-15 00:16:34.000000', 'consum', 0.0213, 'lps'),
	(584929, 129, '2014-03-15 00:16:35.000000', 'consum', 0.0210, 'lps'),
	(584930, 129, '2014-03-15 00:16:36.000000', 'consum', 0.0216, 'lps'),
	(584931, 129, '2014-03-15 00:16:37.000000', 'consum', 0.0211, 'lps'),
	(584932, 129, '2014-03-15 00:16:38.000000', 'consum', 0.0211, 'lps'),
	(584933, 129, '2014-03-15 00:16:39.000000', 'consum', 0.0213, 'lps'),
	(584934, 129, '2014-03-15 00:16:40.000000', 'consum', 0.0211, 'lps'),
	(584935, 129, '2014-03-15 00:16:41.000000', 'consum', 0.0217, 'lps'),
	(584936, 129, '2014-03-15 00:16:42.000000', 'consum', 0.0216, 'lps'),
	(584937, 129, '2014-03-15 00:16:43.000000', 'consum', 0.0219, 'lps'),
	(584938, 129, '2014-03-15 00:16:44.000000', 'consum', 0.0210, 'lps'),
	(584939, 129, '2014-03-15 00:16:45.000000', 'consum', 0.0212, 'lps'),
	(584940, 129, '2014-03-15 00:16:46.000000', 'consum', 0.0219, 'lps'),
	(584941, 129, '2014-03-15 00:16:47.000000', 'consum', 0.0210, 'lps'),
	(584942, 129, '2014-03-15 00:16:48.000000', 'consum', 0.0211, 'lps'),
	(584943, 129, '2014-03-15 00:16:49.000000', 'consum', 0.0214, 'lps'),
	(584944, 129, '2014-03-15 00:16:50.000000', 'consum', 0.0216, 'lps'),
	(584945, 129, '2014-03-15 00:16:51.000000', 'consum', 0.0214, 'lps'),
	(584946, 129, '2014-03-15 00:16:52.000000', 'consum', 0.0214, 'lps'),
	(584947, 129, '2014-03-15 00:16:53.000000', 'consum', 0.0216, 'lps'),
	(584948, 129, '2014-03-15 00:16:54.000000', 'consum', 0.0216, 'lps'),
	(584949, 129, '2014-03-15 00:16:55.000000', 'consum', 0.0222, 'lps'),
	(584950, 129, '2014-03-15 00:16:56.000000', 'consum', 0.0213, 'lps'),
	(584951, 129, '2014-03-15 00:16:57.000000', 'consum', 0.0214, 'lps'),
	(584952, 129, '2014-03-15 00:16:58.000000', 'consum', 0.0222, 'lps'),
	(584953, 129, '2014-03-15 00:16:59.000000', 'consum', 0.0219, 'lps'),
	(584954, 129, '2014-03-15 00:17:00.000000', 'consum', 0.0217, 'lps'),
	(584955, 129, '2014-03-15 00:17:01.000000', 'consum', 0.0221, 'lps'),
	(584956, 129, '2014-03-15 00:17:02.000000', 'consum', 0.0217, 'lps'),
	(584957, 129, '2014-03-15 00:17:03.000000', 'consum', 0.0210, 'lps'),
	(584958, 129, '2014-03-15 00:17:04.000000', 'consum', 0.0218, 'lps'),
	(584959, 129, '2014-03-15 00:17:05.000000', 'consum', 0.0211, 'lps'),
	(584960, 129, '2014-03-15 00:17:06.000000', 'consum', 0.0217, 'lps'),
	(584961, 129, '2014-03-15 00:17:07.000000', 'consum', 0.0215, 'lps'),
	(584962, 129, '2014-03-15 00:17:08.000000', 'consum', 0.0214, 'lps'),
	(584963, 129, '2014-03-15 00:17:09.000000', 'consum', 0.0217, 'lps'),
	(584964, 129, '2014-03-15 00:17:10.000000', 'consum', 0.0217, 'lps'),
	(584965, 129, '2014-03-15 00:17:11.000000', 'consum', 0.0214, 'lps'),
	(584966, 129, '2014-03-15 00:17:12.000000', 'consum', 0.0221, 'lps'),
	(584967, 129, '2014-03-15 00:17:13.000000', 'consum', 0.0213, 'lps'),
	(584968, 129, '2014-03-15 00:17:14.000000', 'consum', 0.0221, 'lps'),
	(584969, 129, '2014-03-15 00:17:15.000000', 'consum', 0.0213, 'lps'),
	(584970, 129, '2014-03-15 00:17:16.000000', 'consum', 0.0223, 'lps'),
	(584971, 129, '2014-03-15 00:17:17.000000', 'consum', 0.0222, 'lps'),
	(584972, 129, '2014-03-15 00:17:18.000000', 'consum', 0.0220, 'lps'),
	(584973, 129, '2014-03-15 00:17:19.000000', 'consum', 0.0210, 'lps'),
	(584974, 129, '2014-03-15 00:17:20.000000', 'consum', 0.0222, 'lps'),
	(584975, 129, '2014-03-15 00:17:21.000000', 'consum', 0.0213, 'lps'),
	(584976, 129, '2014-03-15 00:17:22.000000', 'consum', 0.0218, 'lps'),
	(584977, 129, '2014-03-15 00:17:23.000000', 'consum', 0.0214, 'lps'),
	(584978, 129, '2014-03-15 00:17:24.000000', 'consum', 0.0221, 'lps'),
	(584979, 129, '2014-03-15 00:17:25.000000', 'consum', 0.0223, 'lps'),
	(584980, 129, '2014-03-15 00:17:26.000000', 'consum', 0.0217, 'lps'),
	(584981, 129, '2014-03-15 00:17:27.000000', 'consum', 0.0219, 'lps'),
	(584982, 129, '2014-03-15 00:17:28.000000', 'consum', 0.0222, 'lps'),
	(584983, 129, '2014-03-15 00:17:29.000000', 'consum', 0.0215, 'lps'),
	(584984, 129, '2014-03-15 00:17:30.000000', 'consum', 0.0212, 'lps'),
	(584985, 129, '2014-03-15 00:17:31.000000', 'consum', 0.0219, 'lps'),
	(584986, 129, '2014-03-15 00:17:32.000000', 'consum', 0.0223, 'lps'),
	(584987, 129, '2014-03-15 00:17:33.000000', 'consum', 0.0222, 'lps'),
	(584988, 129, '2014-03-15 00:17:34.000000', 'consum', 0.0217, 'lps'),
	(584989, 129, '2014-03-15 00:17:35.000000', 'consum', 0.0222, 'lps'),
	(584990, 129, '2014-03-15 00:17:36.000000', 'consum', 0.0220, 'lps'),
	(584991, 129, '2014-03-15 00:17:37.000000', 'consum', 0.0214, 'lps'),
	(584992, 129, '2014-03-15 00:17:38.000000', 'consum', 0.0213, 'lps'),
	(584993, 129, '2014-03-15 00:17:39.000000', 'consum', 0.0214, 'lps'),
	(584994, 129, '2014-03-15 00:17:40.000000', 'consum', 0.0220, 'lps'),
	(584995, 129, '2014-03-15 00:17:41.000000', 'consum', 0.0221, 'lps'),
	(584996, 129, '2014-03-15 00:17:42.000000', 'consum', 0.0222, 'lps'),
	(584997, 129, '2014-03-15 00:17:43.000000', 'consum', 0.0223, 'lps'),
	(584998, 129, '2014-03-15 00:17:44.000000', 'consum', 0.0213, 'lps'),
	(584999, 129, '2014-03-15 00:17:45.000000', 'consum', 0.0215, 'lps'),
	(585000, 129, '2014-03-15 00:17:46.000000', 'consum', 0.0211, 'lps'),
	(585001, 129, '2014-03-15 00:17:47.000000', 'consum', 0.0217, 'lps'),
	(585002, 129, '2014-03-15 00:17:48.000000', 'consum', 0.0212, 'lps'),
	(585003, 129, '2014-03-15 00:17:49.000000', 'consum', 0.0216, 'lps'),
	(585004, 129, '2014-03-15 00:17:50.000000', 'consum', 0.0219, 'lps'),
	(585005, 129, '2014-03-15 00:17:51.000000', 'consum', 0.0210, 'lps'),
	(585006, 129, '2014-03-15 00:17:52.000000', 'consum', 0.0210, 'lps'),
	(585007, 129, '2014-03-15 00:17:53.000000', 'consum', 0.0212, 'lps'),
	(585008, 129, '2014-03-15 00:17:54.000000', 'consum', 0.0221, 'lps'),
	(585009, 129, '2014-03-15 00:17:55.000000', 'consum', 0.0215, 'lps'),
	(585010, 129, '2014-03-15 00:17:56.000000', 'consum', 0.0218, 'lps'),
	(585011, 129, '2014-03-15 00:17:57.000000', 'consum', 0.0219, 'lps'),
	(585012, 129, '2014-03-15 00:17:58.000000', 'consum', 0.0221, 'lps'),
	(585013, 129, '2014-03-15 00:17:59.000000', 'consum', 0.0222, 'lps'),
	(585014, 129, '2014-03-15 00:18:00.000000', 'consum', 0.0222, 'lps'),
	(585015, 129, '2014-03-15 00:18:01.000000', 'consum', 0.0210, 'lps'),
	(585016, 129, '2014-03-15 00:18:02.000000', 'consum', 0.0216, 'lps'),
	(585017, 129, '2014-03-15 00:18:03.000000', 'consum', 0.0211, 'lps'),
	(585018, 129, '2014-03-15 00:18:04.000000', 'consum', 0.0213, 'lps'),
	(585019, 129, '2014-03-15 00:18:05.000000', 'consum', 0.0222, 'lps'),
	(585020, 129, '2014-03-15 00:18:06.000000', 'consum', 0.0221, 'lps'),
	(585021, 129, '2014-03-15 00:18:07.000000', 'consum', 0.0215, 'lps'),
	(585022, 129, '2014-03-15 00:18:08.000000', 'consum', 0.0216, 'lps'),
	(585023, 129, '2014-03-15 00:18:09.000000', 'consum', 0.0213, 'lps'),
	(585024, 129, '2014-03-15 00:18:10.000000', 'consum', 0.0219, 'lps'),
	(585025, 129, '2014-03-15 00:18:11.000000', 'consum', 0.0220, 'lps'),
	(585026, 129, '2014-03-15 00:18:12.000000', 'consum', 0.0221, 'lps'),
	(585027, 129, '2014-03-15 00:18:13.000000', 'consum', 0.0221, 'lps'),
	(585028, 129, '2014-03-15 00:18:14.000000', 'consum', 0.0216, 'lps'),
	(585029, 129, '2014-03-15 00:18:15.000000', 'consum', 0.0222, 'lps'),
	(585030, 129, '2014-03-15 00:18:16.000000', 'consum', 0.0213, 'lps'),
	(585031, 129, '2014-03-15 00:18:17.000000', 'consum', 0.0216, 'lps'),
	(585032, 129, '2014-03-15 00:18:18.000000', 'consum', 0.0220, 'lps'),
	(585033, 129, '2014-03-15 00:18:19.000000', 'consum', 0.0211, 'lps'),
	(585034, 129, '2014-03-15 00:18:20.000000', 'consum', 0.0217, 'lps'),
	(585035, 129, '2014-03-15 00:18:21.000000', 'consum', 0.0211, 'lps'),
	(585036, 129, '2014-03-15 00:18:22.000000', 'consum', 0.0212, 'lps'),
	(585037, 129, '2014-03-15 00:18:23.000000', 'consum', 0.0215, 'lps'),
	(585038, 129, '2014-03-15 00:18:24.000000', 'consum', 0.0215, 'lps'),
	(585039, 129, '2014-03-15 00:18:25.000000', 'consum', 0.0223, 'lps'),
	(585040, 129, '2014-03-15 00:18:26.000000', 'consum', 0.0216, 'lps'),
	(585041, 129, '2014-03-15 00:18:27.000000', 'consum', 0.0214, 'lps'),
	(585042, 129, '2014-03-15 00:18:28.000000', 'consum', 0.0216, 'lps'),
	(585043, 129, '2014-03-15 00:18:29.000000', 'consum', 0.0213, 'lps'),
	(585044, 129, '2014-03-15 00:18:30.000000', 'consum', 0.0221, 'lps'),
	(585045, 129, '2014-03-15 00:18:31.000000', 'consum', 0.0215, 'lps'),
	(585046, 129, '2014-03-15 00:18:32.000000', 'consum', 0.0215, 'lps'),
	(585047, 129, '2014-03-15 00:18:33.000000', 'consum', 0.0223, 'lps'),
	(585048, 129, '2014-03-15 00:18:34.000000', 'consum', 0.0216, 'lps'),
	(585049, 129, '2014-03-15 00:18:35.000000', 'consum', 0.0217, 'lps'),
	(585050, 129, '2014-03-15 00:18:36.000000', 'consum', 0.0212, 'lps'),
	(585051, 129, '2014-03-15 00:18:37.000000', 'consum', 0.0215, 'lps'),
	(585052, 129, '2014-03-15 00:18:38.000000', 'consum', 0.0216, 'lps'),
	(585053, 129, '2014-03-15 00:18:39.000000', 'consum', 0.0211, 'lps'),
	(585054, 129, '2014-03-15 00:18:40.000000', 'consum', 0.0210, 'lps'),
	(585055, 129, '2014-03-15 00:18:41.000000', 'consum', 0.0223, 'lps'),
	(585056, 129, '2014-03-15 00:18:42.000000', 'consum', 0.0217, 'lps'),
	(585057, 129, '2014-03-15 00:18:43.000000', 'consum', 0.0223, 'lps'),
	(585058, 129, '2014-03-15 00:18:44.000000', 'consum', 0.0211, 'lps'),
	(585059, 129, '2014-03-15 00:18:45.000000', 'consum', 0.0217, 'lps'),
	(585060, 129, '2014-03-15 00:18:46.000000', 'consum', 0.0216, 'lps'),
	(585061, 129, '2014-03-15 00:18:47.000000', 'consum', 0.0219, 'lps'),
	(585062, 129, '2014-03-15 00:18:48.000000', 'consum', 0.0211, 'lps'),
	(585063, 129, '2014-03-15 00:18:49.000000', 'consum', 0.0218, 'lps'),
	(585064, 129, '2014-03-15 00:18:50.000000', 'consum', 0.0216, 'lps'),
	(585065, 129, '2014-03-15 00:18:51.000000', 'consum', 0.0219, 'lps'),
	(585066, 129, '2014-03-15 00:18:52.000000', 'consum', 0.0222, 'lps'),
	(585067, 129, '2014-03-15 00:18:53.000000', 'consum', 0.0217, 'lps'),
	(585068, 129, '2014-03-15 00:18:54.000000', 'consum', 0.0223, 'lps'),
	(585069, 129, '2014-03-15 00:18:55.000000', 'consum', 0.0214, 'lps'),
	(585070, 129, '2014-03-15 00:18:56.000000', 'consum', 0.0220, 'lps'),
	(585071, 129, '2014-03-15 00:18:57.000000', 'consum', 0.0221, 'lps'),
	(585072, 129, '2014-03-15 00:18:58.000000', 'consum', 0.0222, 'lps'),
	(585073, 129, '2014-03-15 00:18:59.000000', 'consum', 0.0222, 'lps'),
	(585074, 129, '2014-03-15 00:19:00.000000', 'consum', 0.0219, 'lps'),
	(585075, 129, '2014-03-15 00:19:01.000000', 'consum', 0.0222, 'lps'),
	(585076, 129, '2014-03-15 00:19:02.000000', 'consum', 0.0214, 'lps'),
	(585077, 129, '2014-03-15 00:19:03.000000', 'consum', 0.0210, 'lps'),
	(585078, 129, '2014-03-15 00:19:04.000000', 'consum', 0.0213, 'lps'),
	(585079, 129, '2014-03-15 00:19:05.000000', 'consum', 0.0212, 'lps'),
	(585080, 129, '2014-03-15 00:19:06.000000', 'consum', 0.0212, 'lps'),
	(585081, 129, '2014-03-15 00:19:07.000000', 'consum', 0.0214, 'lps'),
	(585082, 129, '2014-03-15 00:19:08.000000', 'consum', 0.0210, 'lps'),
	(585083, 129, '2014-03-15 00:19:09.000000', 'consum', 0.0211, 'lps'),
	(585084, 129, '2014-03-15 00:19:10.000000', 'consum', 0.0217, 'lps'),
	(585085, 129, '2014-03-15 00:19:11.000000', 'consum', 0.0215, 'lps'),
	(585086, 129, '2014-03-15 00:19:12.000000', 'consum', 0.0215, 'lps'),
	(585087, 129, '2014-03-15 00:19:13.000000', 'consum', 0.0219, 'lps'),
	(585088, 129, '2014-03-15 00:19:14.000000', 'consum', 0.0212, 'lps'),
	(585089, 129, '2014-03-15 00:19:15.000000', 'consum', 0.0210, 'lps'),
	(585090, 129, '2014-03-15 00:19:16.000000', 'consum', 0.0217, 'lps'),
	(585091, 129, '2014-03-15 00:19:17.000000', 'consum', 0.0219, 'lps'),
	(585092, 129, '2014-03-15 00:19:18.000000', 'consum', 0.0220, 'lps'),
	(585093, 129, '2014-03-15 00:19:19.000000', 'consum', 0.0220, 'lps'),
	(585094, 129, '2014-03-15 00:19:20.000000', 'consum', 0.0218, 'lps'),
	(585095, 129, '2014-03-15 00:19:21.000000', 'consum', 0.0218, 'lps'),
	(585096, 129, '2014-03-15 00:19:22.000000', 'consum', 0.0213, 'lps'),
	(585097, 129, '2014-03-15 00:19:23.000000', 'consum', 0.0215, 'lps'),
	(585098, 129, '2014-03-15 00:19:24.000000', 'consum', 0.0211, 'lps'),
	(585099, 129, '2014-03-15 00:19:25.000000', 'consum', 0.0217, 'lps'),
	(585100, 129, '2014-03-15 00:19:26.000000', 'consum', 0.0213, 'lps'),
	(585101, 129, '2014-03-15 00:19:27.000000', 'consum', 0.0220, 'lps'),
	(585102, 129, '2014-03-15 00:19:28.000000', 'consum', 0.0221, 'lps'),
	(585103, 129, '2014-03-15 00:19:29.000000', 'consum', 0.0210, 'lps'),
	(585104, 129, '2014-03-15 00:19:30.000000', 'consum', 0.0218, 'lps'),
	(585105, 129, '2014-03-15 00:19:31.000000', 'consum', 0.0210, 'lps'),
	(585106, 129, '2014-03-15 00:19:32.000000', 'consum', 0.0212, 'lps'),
	(585107, 129, '2014-03-15 00:19:33.000000', 'consum', 0.0210, 'lps'),
	(585108, 129, '2014-03-15 00:19:34.000000', 'consum', 0.0215, 'lps'),
	(585109, 129, '2014-03-15 00:19:35.000000', 'consum', 0.0210, 'lps'),
	(585110, 129, '2014-03-15 00:19:36.000000', 'consum', 0.0210, 'lps'),
	(585111, 129, '2014-03-15 00:19:37.000000', 'consum', 0.0211, 'lps'),
	(585112, 129, '2014-03-15 00:19:38.000000', 'consum', 0.0213, 'lps'),
	(585113, 129, '2014-03-15 00:19:39.000000', 'consum', 0.0222, 'lps'),
	(585114, 129, '2014-03-15 00:19:40.000000', 'consum', 0.0220, 'lps'),
	(585115, 129, '2014-03-15 00:19:41.000000', 'consum', 0.0210, 'lps'),
	(585116, 129, '2014-03-15 00:19:42.000000', 'consum', 0.0221, 'lps'),
	(585117, 129, '2014-03-15 00:19:43.000000', 'consum', 0.0211, 'lps'),
	(585118, 129, '2014-03-15 00:19:44.000000', 'consum', 0.0211, 'lps'),
	(585119, 129, '2014-03-15 00:19:45.000000', 'consum', 0.0214, 'lps'),
	(585120, 129, '2014-03-15 00:19:46.000000', 'consum', 0.0213, 'lps'),
	(585121, 129, '2014-03-15 00:19:47.000000', 'consum', 0.0214, 'lps'),
	(585122, 129, '2014-03-15 00:19:48.000000', 'consum', 0.0219, 'lps'),
	(585123, 129, '2014-03-15 00:19:49.000000', 'consum', 0.0217, 'lps'),
	(585124, 129, '2014-03-15 00:19:50.000000', 'consum', 0.0218, 'lps'),
	(585125, 129, '2014-03-15 00:19:51.000000', 'consum', 0.0217, 'lps'),
	(585126, 129, '2014-03-15 00:19:52.000000', 'consum', 0.0220, 'lps'),
	(585127, 129, '2014-03-15 00:19:53.000000', 'consum', 0.0211, 'lps'),
	(585128, 129, '2014-03-15 00:19:54.000000', 'consum', 0.0216, 'lps'),
	(585129, 129, '2014-03-15 00:19:55.000000', 'consum', 0.0221, 'lps'),
	(585130, 129, '2014-03-15 00:19:56.000000', 'consum', 0.0219, 'lps'),
	(585131, 129, '2014-03-15 00:19:57.000000', 'consum', 0.0223, 'lps'),
	(585132, 129, '2014-03-15 00:19:58.000000', 'consum', 0.0223, 'lps'),
	(585133, 129, '2014-03-15 00:19:59.000000', 'consum', 0.0220, 'lps'),
	(585134, 129, '2014-03-15 00:20:00.000000', 'consum', 0.0210, 'lps'),
	(585135, 129, '2014-03-15 00:20:01.000000', 'consum', 0.0220, 'lps'),
	(585136, 129, '2014-03-15 00:20:02.000000', 'consum', 0.0220, 'lps'),
	(585137, 129, '2014-03-15 00:20:03.000000', 'consum', 0.0217, 'lps'),
	(585138, 129, '2014-03-15 00:20:04.000000', 'consum', 0.0216, 'lps'),
	(585139, 129, '2014-03-15 00:20:05.000000', 'consum', 0.0220, 'lps'),
	(585140, 129, '2014-03-15 00:20:06.000000', 'consum', 0.0216, 'lps'),
	(585141, 129, '2014-03-15 00:20:07.000000', 'consum', 0.0222, 'lps'),
	(585142, 129, '2014-03-15 00:20:08.000000', 'consum', 0.0210, 'lps'),
	(585143, 129, '2014-03-15 00:20:09.000000', 'consum', 0.0216, 'lps'),
	(585144, 129, '2014-03-15 00:20:10.000000', 'consum', 0.0211, 'lps'),
	(585145, 129, '2014-03-15 00:20:11.000000', 'consum', 0.0215, 'lps'),
	(585146, 129, '2014-03-15 00:20:12.000000', 'consum', 0.0216, 'lps'),
	(585147, 129, '2014-03-15 00:20:13.000000', 'consum', 0.0210, 'lps'),
	(585148, 129, '2014-03-15 00:20:14.000000', 'consum', 0.0210, 'lps'),
	(585149, 129, '2014-03-15 00:20:15.000000', 'consum', 0.0223, 'lps'),
	(585150, 129, '2014-03-15 00:20:16.000000', 'consum', 0.0218, 'lps'),
	(585151, 129, '2014-03-15 00:20:17.000000', 'consum', 0.0215, 'lps'),
	(585152, 129, '2014-03-15 00:20:18.000000', 'consum', 0.0222, 'lps'),
	(585153, 129, '2014-03-15 00:20:19.000000', 'consum', 0.0215, 'lps'),
	(585154, 129, '2014-03-15 00:20:20.000000', 'consum', 0.0213, 'lps'),
	(585155, 129, '2014-03-15 00:20:21.000000', 'consum', 0.0213, 'lps'),
	(585156, 129, '2014-03-15 00:20:22.000000', 'consum', 0.0214, 'lps'),
	(585157, 129, '2014-03-15 00:20:23.000000', 'consum', 0.0210, 'lps'),
	(585158, 129, '2014-03-15 00:20:24.000000', 'consum', 0.0211, 'lps'),
	(585159, 129, '2014-03-15 00:20:25.000000', 'consum', 0.0217, 'lps'),
	(585160, 129, '2014-03-15 00:20:26.000000', 'consum', 0.0215, 'lps'),
	(585161, 129, '2014-03-15 00:20:27.000000', 'consum', 0.0213, 'lps'),
	(585162, 129, '2014-03-15 00:20:28.000000', 'consum', 0.0211, 'lps'),
	(585163, 129, '2014-03-15 00:20:29.000000', 'consum', 0.0220, 'lps'),
	(585164, 129, '2014-03-15 00:20:30.000000', 'consum', 0.0215, 'lps'),
	(585165, 129, '2014-03-15 00:20:31.000000', 'consum', 0.0222, 'lps'),
	(585166, 129, '2014-03-15 00:20:32.000000', 'consum', 0.0211, 'lps'),
	(585167, 129, '2014-03-15 00:20:33.000000', 'consum', 0.0222, 'lps'),
	(585168, 129, '2014-03-15 00:20:34.000000', 'consum', 0.0211, 'lps'),
	(585169, 129, '2014-03-15 00:20:35.000000', 'consum', 0.0221, 'lps'),
	(585170, 129, '2014-03-15 00:20:36.000000', 'consum', 0.0221, 'lps'),
	(585171, 129, '2014-03-15 00:20:37.000000', 'consum', 0.0217, 'lps'),
	(585172, 129, '2014-03-15 00:20:38.000000', 'consum', 0.0212, 'lps'),
	(585173, 129, '2014-03-15 00:20:39.000000', 'consum', 0.0214, 'lps'),
	(585174, 129, '2014-03-15 00:20:40.000000', 'consum', 0.0223, 'lps'),
	(585175, 129, '2014-03-15 00:20:41.000000', 'consum', 0.0223, 'lps'),
	(585176, 129, '2014-03-15 00:20:42.000000', 'consum', 0.0222, 'lps'),
	(585177, 129, '2014-03-15 00:20:43.000000', 'consum', 0.0219, 'lps'),
	(585178, 129, '2014-03-15 00:20:44.000000', 'consum', 0.0220, 'lps'),
	(585179, 129, '2014-03-15 00:20:45.000000', 'consum', 0.0219, 'lps'),
	(585180, 129, '2014-03-15 00:20:46.000000', 'consum', 0.0211, 'lps'),
	(585181, 129, '2014-03-15 00:20:47.000000', 'consum', 0.0215, 'lps'),
	(585182, 129, '2014-03-15 00:20:48.000000', 'consum', 0.0220, 'lps'),
	(585183, 129, '2014-03-15 00:20:49.000000', 'consum', 0.0218, 'lps'),
	(585184, 129, '2014-03-15 00:20:50.000000', 'consum', 0.0218, 'lps'),
	(585185, 129, '2014-03-15 00:20:51.000000', 'consum', 0.0213, 'lps'),
	(585186, 129, '2014-03-15 00:20:52.000000', 'consum', 0.0218, 'lps'),
	(585187, 129, '2014-03-15 00:20:53.000000', 'consum', 0.0210, 'lps'),
	(585188, 129, '2014-03-15 00:20:54.000000', 'consum', 0.0217, 'lps'),
	(585189, 129, '2014-03-15 00:20:55.000000', 'consum', 0.0218, 'lps'),
	(585190, 129, '2014-03-15 00:20:56.000000', 'consum', 0.0214, 'lps'),
	(585191, 129, '2014-03-15 00:20:57.000000', 'consum', 0.0221, 'lps'),
	(585192, 129, '2014-03-15 00:20:58.000000', 'consum', 0.0211, 'lps'),
	(585193, 129, '2014-03-15 00:20:59.000000', 'consum', 0.0223, 'lps'),
	(585194, 129, '2014-03-15 00:21:00.000000', 'consum', 0.0217, 'lps'),
	(585195, 129, '2014-03-15 00:21:01.000000', 'consum', 0.0222, 'lps'),
	(585196, 129, '2014-03-15 00:21:02.000000', 'consum', 0.0220, 'lps'),
	(585197, 129, '2014-03-15 00:21:03.000000', 'consum', 0.0211, 'lps'),
	(585198, 129, '2014-03-15 00:21:04.000000', 'consum', 0.0212, 'lps'),
	(585199, 129, '2014-03-15 00:21:05.000000', 'consum', 0.0220, 'lps'),
	(585200, 129, '2014-03-15 00:21:06.000000', 'consum', 0.0210, 'lps'),
	(585201, 129, '2014-03-15 00:21:07.000000', 'consum', 0.0210, 'lps'),
	(585202, 129, '2014-03-15 00:21:08.000000', 'consum', 0.0210, 'lps'),
	(585203, 129, '2014-03-15 00:21:09.000000', 'consum', 0.0211, 'lps'),
	(585204, 129, '2014-03-15 00:21:10.000000', 'consum', 0.0215, 'lps'),
	(585205, 129, '2014-03-15 00:21:11.000000', 'consum', 0.0217, 'lps'),
	(585206, 129, '2014-03-15 00:21:12.000000', 'consum', 0.0218, 'lps'),
	(585207, 129, '2014-03-15 00:21:13.000000', 'consum', 0.0213, 'lps'),
	(585208, 129, '2014-03-15 00:21:14.000000', 'consum', 0.0218, 'lps'),
	(585209, 129, '2014-03-15 00:21:15.000000', 'consum', 0.0211, 'lps'),
	(585210, 129, '2014-03-15 00:21:16.000000', 'consum', 0.0222, 'lps'),
	(585211, 129, '2014-03-15 00:21:17.000000', 'consum', 0.0211, 'lps'),
	(585212, 129, '2014-03-15 00:21:18.000000', 'consum', 0.0222, 'lps'),
	(585213, 129, '2014-03-15 00:21:19.000000', 'consum', 0.0210, 'lps'),
	(585214, 129, '2014-03-15 00:21:20.000000', 'consum', 0.0219, 'lps'),
	(585215, 129, '2014-03-15 00:21:21.000000', 'consum', 0.0210, 'lps'),
	(585216, 129, '2014-03-15 00:21:22.000000', 'consum', 0.0214, 'lps'),
	(585217, 129, '2014-03-15 00:21:23.000000', 'consum', 0.0217, 'lps'),
	(585218, 129, '2014-03-15 00:21:24.000000', 'consum', 0.0217, 'lps'),
	(585219, 129, '2014-03-15 00:21:25.000000', 'consum', 0.0213, 'lps'),
	(585220, 129, '2014-03-15 00:21:26.000000', 'consum', 0.0216, 'lps'),
	(585221, 129, '2014-03-15 00:21:27.000000', 'consum', 0.0219, 'lps'),
	(585222, 129, '2014-03-15 00:21:28.000000', 'consum', 0.0210, 'lps'),
	(585223, 129, '2014-03-15 00:21:29.000000', 'consum', 0.0213, 'lps'),
	(585224, 129, '2014-03-15 00:21:30.000000', 'consum', 0.0223, 'lps'),
	(585225, 129, '2014-03-15 00:21:31.000000', 'consum', 0.0211, 'lps'),
	(585226, 129, '2014-03-15 00:21:32.000000', 'consum', 0.0219, 'lps'),
	(585227, 129, '2014-03-15 00:21:33.000000', 'consum', 0.0212, 'lps'),
	(585228, 129, '2014-03-15 00:21:34.000000', 'consum', 0.0221, 'lps'),
	(585229, 129, '2014-03-15 00:21:35.000000', 'consum', 0.0215, 'lps'),
	(585230, 129, '2014-03-15 00:21:36.000000', 'consum', 0.0218, 'lps'),
	(585231, 129, '2014-03-15 00:21:37.000000', 'consum', 0.0221, 'lps'),
	(585232, 129, '2014-03-15 00:21:38.000000', 'consum', 0.0213, 'lps'),
	(585233, 129, '2014-03-15 00:21:39.000000', 'consum', 0.0220, 'lps'),
	(585234, 129, '2014-03-15 00:21:40.000000', 'consum', 0.0212, 'lps'),
	(585235, 129, '2014-03-15 00:21:41.000000', 'consum', 0.0216, 'lps'),
	(585236, 129, '2014-03-15 00:21:42.000000', 'consum', 0.0223, 'lps'),
	(585237, 129, '2014-03-15 00:21:43.000000', 'consum', 0.0215, 'lps'),
	(585238, 129, '2014-03-15 00:21:44.000000', 'consum', 0.0212, 'lps'),
	(585239, 129, '2014-03-15 00:21:45.000000', 'consum', 0.0219, 'lps'),
	(585240, 129, '2014-03-15 00:21:46.000000', 'consum', 0.0219, 'lps'),
	(585241, 129, '2014-03-15 00:21:47.000000', 'consum', 0.0217, 'lps'),
	(585242, 129, '2014-03-15 00:21:48.000000', 'consum', 0.0219, 'lps'),
	(585243, 129, '2014-03-15 00:21:49.000000', 'consum', 0.0221, 'lps'),
	(585244, 129, '2014-03-15 00:21:50.000000', 'consum', 0.0222, 'lps'),
	(585245, 129, '2014-03-15 00:21:51.000000', 'consum', 0.0222, 'lps'),
	(585246, 129, '2014-03-15 00:21:52.000000', 'consum', 0.0210, 'lps'),
	(585247, 129, '2014-03-15 00:21:53.000000', 'consum', 0.0216, 'lps'),
	(585248, 129, '2014-03-15 00:21:54.000000', 'consum', 0.0213, 'lps'),
	(585249, 129, '2014-03-15 00:21:55.000000', 'consum', 0.0222, 'lps'),
	(585250, 129, '2014-03-15 00:21:56.000000', 'consum', 0.0218, 'lps'),
	(585251, 129, '2014-03-15 00:21:57.000000', 'consum', 0.0213, 'lps'),
	(585252, 129, '2014-03-15 00:21:58.000000', 'consum', 0.0218, 'lps'),
	(585253, 129, '2014-03-15 00:21:59.000000', 'consum', 0.0211, 'lps'),
	(585254, 129, '2014-03-15 00:22:00.000000', 'consum', 0.0222, 'lps'),
	(585255, 129, '2014-03-15 00:22:01.000000', 'consum', 0.0223, 'lps'),
	(585256, 129, '2014-03-15 00:22:02.000000', 'consum', 0.0213, 'lps'),
	(585257, 129, '2014-03-15 00:22:03.000000', 'consum', 0.0214, 'lps'),
	(585258, 129, '2014-03-15 00:22:04.000000', 'consum', 0.0220, 'lps'),
	(585259, 129, '2014-03-15 00:22:05.000000', 'consum', 0.0222, 'lps'),
	(585260, 129, '2014-03-15 00:22:06.000000', 'consum', 0.0214, 'lps'),
	(585261, 129, '2014-03-15 00:22:07.000000', 'consum', 0.0219, 'lps'),
	(585262, 129, '2014-03-15 00:22:08.000000', 'consum', 0.0219, 'lps'),
	(585263, 129, '2014-03-15 00:22:09.000000', 'consum', 0.0211, 'lps'),
	(585264, 129, '2014-03-15 00:22:10.000000', 'consum', 0.0219, 'lps'),
	(585265, 129, '2014-03-15 00:22:11.000000', 'consum', 0.0210, 'lps'),
	(585266, 129, '2014-03-15 00:22:12.000000', 'consum', 0.0213, 'lps'),
	(585267, 129, '2014-03-15 00:22:13.000000', 'consum', 0.0210, 'lps'),
	(585268, 129, '2014-03-15 00:22:14.000000', 'consum', 0.0215, 'lps'),
	(585269, 129, '2014-03-15 00:22:15.000000', 'consum', 0.0223, 'lps'),
	(585270, 129, '2014-03-15 00:22:16.000000', 'consum', 0.0216, 'lps'),
	(585271, 129, '2014-03-15 00:22:17.000000', 'consum', 0.0216, 'lps'),
	(585272, 129, '2014-03-15 00:22:18.000000', 'consum', 0.0211, 'lps'),
	(585273, 129, '2014-03-15 00:22:19.000000', 'consum', 0.0210, 'lps'),
	(585274, 129, '2014-03-15 00:22:20.000000', 'consum', 0.0223, 'lps'),
	(585275, 129, '2014-03-15 00:22:21.000000', 'consum', 0.0217, 'lps'),
	(585276, 129, '2014-03-15 00:22:22.000000', 'consum', 0.0220, 'lps'),
	(585277, 129, '2014-03-15 00:22:23.000000', 'consum', 0.0213, 'lps'),
	(585278, 129, '2014-03-15 00:22:24.000000', 'consum', 0.0211, 'lps'),
	(585279, 129, '2014-03-15 00:22:25.000000', 'consum', 0.0218, 'lps'),
	(585280, 129, '2014-03-15 00:22:26.000000', 'consum', 0.0222, 'lps'),
	(585281, 129, '2014-03-15 00:22:27.000000', 'consum', 0.0215, 'lps'),
	(585282, 129, '2014-03-15 00:22:28.000000', 'consum', 0.0217, 'lps'),
	(585283, 129, '2014-03-15 00:22:29.000000', 'consum', 0.0214, 'lps'),
	(585284, 129, '2014-03-15 00:22:30.000000', 'consum', 0.0222, 'lps'),
	(585285, 129, '2014-03-15 00:22:31.000000', 'consum', 0.0219, 'lps'),
	(585286, 129, '2014-03-15 00:22:32.000000', 'consum', 0.0219, 'lps'),
	(585287, 129, '2014-03-15 00:22:33.000000', 'consum', 0.0214, 'lps'),
	(585288, 129, '2014-03-15 00:22:34.000000', 'consum', 0.0216, 'lps'),
	(585289, 129, '2014-03-15 00:22:35.000000', 'consum', 0.0215, 'lps'),
	(585290, 129, '2014-03-15 00:22:36.000000', 'consum', 0.0219, 'lps'),
	(585291, 129, '2014-03-15 00:22:37.000000', 'consum', 0.0213, 'lps'),
	(585292, 129, '2014-03-15 00:22:38.000000', 'consum', 0.0211, 'lps'),
	(585293, 129, '2014-03-15 00:22:39.000000', 'consum', 0.0220, 'lps'),
	(585294, 129, '2014-03-15 00:22:40.000000', 'consum', 0.0216, 'lps'),
	(585295, 129, '2014-03-15 00:22:41.000000', 'consum', 0.0223, 'lps'),
	(585296, 129, '2014-03-15 00:22:42.000000', 'consum', 0.0218, 'lps'),
	(585297, 129, '2014-03-15 00:22:43.000000', 'consum', 0.0212, 'lps'),
	(585298, 129, '2014-03-15 00:22:44.000000', 'consum', 0.0222, 'lps'),
	(585299, 129, '2014-03-15 00:22:45.000000', 'consum', 0.0223, 'lps'),
	(585300, 129, '2014-03-15 00:22:46.000000', 'consum', 0.0210, 'lps'),
	(585301, 129, '2014-03-15 00:22:47.000000', 'consum', 0.0216, 'lps'),
	(585302, 129, '2014-03-15 00:22:48.000000', 'consum', 0.0210, 'lps'),
	(585303, 129, '2014-03-15 00:22:49.000000', 'consum', 0.0221, 'lps'),
	(585304, 129, '2014-03-15 00:22:50.000000', 'consum', 0.0212, 'lps'),
	(585305, 129, '2014-03-15 00:22:51.000000', 'consum', 0.0213, 'lps'),
	(585306, 129, '2014-03-15 00:22:52.000000', 'consum', 0.0222, 'lps'),
	(585307, 129, '2014-03-15 00:22:53.000000', 'consum', 0.0216, 'lps'),
	(585308, 129, '2014-03-15 00:22:54.000000', 'consum', 0.0221, 'lps'),
	(585309, 129, '2014-03-15 00:22:55.000000', 'consum', 0.0221, 'lps'),
	(585310, 129, '2014-03-15 00:22:56.000000', 'consum', 0.0216, 'lps'),
	(585311, 129, '2014-03-15 00:22:57.000000', 'consum', 0.0223, 'lps'),
	(585312, 129, '2014-03-15 00:22:58.000000', 'consum', 0.0215, 'lps'),
	(585313, 129, '2014-03-15 00:22:59.000000', 'consum', 0.0211, 'lps'),
	(585314, 129, '2014-03-15 00:23:00.000000', 'consum', 0.0215, 'lps'),
	(585315, 129, '2014-03-15 00:23:01.000000', 'consum', 0.0216, 'lps'),
	(585316, 129, '2014-03-15 00:23:02.000000', 'consum', 0.0213, 'lps'),
	(585317, 129, '2014-03-15 00:23:03.000000', 'consum', 0.0220, 'lps'),
	(585318, 129, '2014-03-15 00:23:04.000000', 'consum', 0.0211, 'lps'),
	(585319, 129, '2014-03-15 00:23:05.000000', 'consum', 0.0214, 'lps'),
	(585320, 129, '2014-03-15 00:23:06.000000', 'consum', 0.0211, 'lps'),
	(585321, 129, '2014-03-15 00:23:07.000000', 'consum', 0.0218, 'lps'),
	(585322, 129, '2014-03-15 00:23:08.000000', 'consum', 0.0219, 'lps'),
	(585323, 129, '2014-03-15 00:23:09.000000', 'consum', 0.0218, 'lps'),
	(585324, 129, '2014-03-15 00:23:10.000000', 'consum', 0.0222, 'lps'),
	(585325, 129, '2014-03-15 00:23:11.000000', 'consum', 0.0218, 'lps'),
	(585326, 129, '2014-03-15 00:23:12.000000', 'consum', 0.0218, 'lps'),
	(585327, 129, '2014-03-15 00:23:13.000000', 'consum', 0.0223, 'lps'),
	(585328, 129, '2014-03-15 00:23:14.000000', 'consum', 0.0210, 'lps'),
	(585329, 129, '2014-03-15 00:23:15.000000', 'consum', 0.0214, 'lps'),
	(585330, 129, '2014-03-15 00:23:16.000000', 'consum', 0.0217, 'lps'),
	(585331, 129, '2014-03-15 00:23:17.000000', 'consum', 0.0219, 'lps'),
	(585332, 129, '2014-03-15 00:23:18.000000', 'consum', 0.0220, 'lps'),
	(585333, 129, '2014-03-15 00:23:19.000000', 'consum', 0.0220, 'lps'),
	(585334, 129, '2014-03-15 00:23:20.000000', 'consum', 0.0217, 'lps'),
	(585335, 129, '2014-03-15 00:23:21.000000', 'consum', 0.0215, 'lps'),
	(585336, 129, '2014-03-15 00:23:22.000000', 'consum', 0.0215, 'lps'),
	(585337, 129, '2014-03-15 00:23:23.000000', 'consum', 0.0219, 'lps'),
	(585338, 129, '2014-03-15 00:23:24.000000', 'consum', 0.0211, 'lps'),
	(585339, 129, '2014-03-15 00:23:25.000000', 'consum', 0.0220, 'lps'),
	(585340, 129, '2014-03-15 00:23:26.000000', 'consum', 0.0215, 'lps'),
	(585341, 129, '2014-03-15 00:23:27.000000', 'consum', 0.0218, 'lps'),
	(585342, 129, '2014-03-15 00:23:28.000000', 'consum', 0.0223, 'lps'),
	(585343, 129, '2014-03-15 00:23:29.000000', 'consum', 0.0211, 'lps'),
	(585344, 129, '2014-03-15 00:23:30.000000', 'consum', 0.0216, 'lps'),
	(585345, 129, '2014-03-15 00:23:31.000000', 'consum', 0.0212, 'lps'),
	(585346, 129, '2014-03-15 00:23:32.000000', 'consum', 0.0216, 'lps'),
	(585347, 129, '2014-03-15 00:23:33.000000', 'consum', 0.0222, 'lps'),
	(585348, 129, '2014-03-15 00:23:34.000000', 'consum', 0.0222, 'lps'),
	(585349, 129, '2014-03-15 00:23:35.000000', 'consum', 0.0221, 'lps'),
	(585350, 129, '2014-03-15 00:23:36.000000', 'consum', 0.0215, 'lps'),
	(585351, 129, '2014-03-15 00:23:37.000000', 'consum', 0.0217, 'lps'),
	(585352, 129, '2014-03-15 00:23:38.000000', 'consum', 0.0218, 'lps'),
	(585353, 129, '2014-03-15 00:23:39.000000', 'consum', 0.0215, 'lps'),
	(585354, 129, '2014-03-15 00:23:40.000000', 'consum', 0.0210, 'lps'),
	(585355, 129, '2014-03-15 00:23:41.000000', 'consum', 0.0212, 'lps'),
	(585356, 129, '2014-03-15 00:23:42.000000', 'consum', 0.0218, 'lps'),
	(585357, 129, '2014-03-15 00:23:43.000000', 'consum', 0.0217, 'lps'),
	(585358, 129, '2014-03-15 00:23:44.000000', 'consum', 0.0220, 'lps'),
	(585359, 129, '2014-03-15 00:23:45.000000', 'consum', 0.0211, 'lps'),
	(585360, 129, '2014-03-15 00:23:46.000000', 'consum', 0.0216, 'lps'),
	(585361, 129, '2014-03-15 00:23:47.000000', 'consum', 0.0223, 'lps'),
	(585362, 129, '2014-03-15 00:23:48.000000', 'consum', 0.0216, 'lps'),
	(585363, 129, '2014-03-15 00:23:49.000000', 'consum', 0.0217, 'lps'),
	(585364, 129, '2014-03-15 00:23:50.000000', 'consum', 0.0211, 'lps'),
	(585365, 129, '2014-03-15 00:23:51.000000', 'consum', 0.0211, 'lps'),
	(585366, 129, '2014-03-15 00:23:52.000000', 'consum', 0.0223, 'lps'),
	(585367, 129, '2014-03-15 00:23:53.000000', 'consum', 0.0220, 'lps'),
	(585368, 129, '2014-03-15 00:23:54.000000', 'consum', 0.0218, 'lps'),
	(585369, 129, '2014-03-15 00:23:55.000000', 'consum', 0.0223, 'lps'),
	(585370, 129, '2014-03-15 00:23:56.000000', 'consum', 0.0210, 'lps'),
	(585371, 129, '2014-03-15 00:23:57.000000', 'consum', 0.0213, 'lps'),
	(585372, 129, '2014-03-15 00:23:58.000000', 'consum', 0.0210, 'lps'),
	(585373, 129, '2014-03-15 00:23:59.000000', 'consum', 0.0218, 'lps'),
	(585374, 129, '2014-03-15 00:24:00.000000', 'consum', 0.0222, 'lps'),
	(585375, 129, '2014-03-15 00:24:01.000000', 'consum', 0.0217, 'lps'),
	(585376, 129, '2014-03-15 00:24:02.000000', 'consum', 0.0223, 'lps'),
	(585377, 129, '2014-03-15 00:24:03.000000', 'consum', 0.0214, 'lps'),
	(585378, 129, '2014-03-15 00:24:04.000000', 'consum', 0.0221, 'lps'),
	(585379, 129, '2014-03-15 00:24:05.000000', 'consum', 0.0211, 'lps'),
	(585380, 129, '2014-03-15 00:24:06.000000', 'consum', 0.0222, 'lps'),
	(585381, 129, '2014-03-15 00:24:07.000000', 'consum', 0.0212, 'lps'),
	(585382, 129, '2014-03-15 00:24:08.000000', 'consum', 0.0215, 'lps'),
	(585383, 129, '2014-03-15 00:24:09.000000', 'consum', 0.0213, 'lps'),
	(585384, 129, '2014-03-15 00:24:10.000000', 'consum', 0.0212, 'lps'),
	(585385, 129, '2014-03-15 00:24:11.000000', 'consum', 0.0210, 'lps'),
	(585386, 129, '2014-03-15 00:24:12.000000', 'consum', 0.0218, 'lps'),
	(585387, 129, '2014-03-15 00:24:13.000000', 'consum', 0.0222, 'lps'),
	(585388, 129, '2014-03-15 00:24:14.000000', 'consum', 0.0221, 'lps'),
	(585389, 129, '2014-03-15 00:24:15.000000', 'consum', 0.0214, 'lps'),
	(585390, 129, '2014-03-15 00:24:16.000000', 'consum', 0.0211, 'lps'),
	(585391, 129, '2014-03-15 00:24:17.000000', 'consum', 0.0219, 'lps'),
	(585392, 129, '2014-03-15 00:24:18.000000', 'consum', 0.0210, 'lps'),
	(585393, 129, '2014-03-15 00:24:19.000000', 'consum', 0.0210, 'lps'),
	(585394, 129, '2014-03-15 00:24:20.000000', 'consum', 0.0213, 'lps'),
	(585395, 129, '2014-03-15 00:24:21.000000', 'consum', 0.0223, 'lps'),
	(585396, 129, '2014-03-15 00:24:22.000000', 'consum', 0.0213, 'lps'),
	(585397, 129, '2014-03-15 00:24:23.000000', 'consum', 0.0212, 'lps'),
	(585398, 129, '2014-03-15 00:24:24.000000', 'consum', 0.0214, 'lps'),
	(585399, 129, '2014-03-15 00:24:25.000000', 'consum', 0.0222, 'lps'),
	(585400, 129, '2014-03-15 00:24:26.000000', 'consum', 0.0219, 'lps'),
	(585401, 129, '2014-03-15 00:24:27.000000', 'consum', 0.0217, 'lps'),
	(585402, 129, '2014-03-15 00:24:28.000000', 'consum', 0.0220, 'lps'),
	(585403, 129, '2014-03-15 00:24:29.000000', 'consum', 0.0210, 'lps'),
	(585404, 129, '2014-03-15 00:24:30.000000', 'consum', 0.0211, 'lps'),
	(585405, 129, '2014-03-15 00:24:31.000000', 'consum', 0.0213, 'lps'),
	(585406, 129, '2014-03-15 00:24:32.000000', 'consum', 0.0210, 'lps'),
	(585407, 129, '2014-03-15 00:24:33.000000', 'consum', 0.0215, 'lps'),
	(585408, 129, '2014-03-15 00:24:34.000000', 'consum', 0.0223, 'lps'),
	(585409, 129, '2014-03-15 00:24:35.000000', 'consum', 0.0216, 'lps'),
	(585410, 129, '2014-03-15 00:24:36.000000', 'consum', 0.0218, 'lps'),
	(585411, 129, '2014-03-15 00:24:37.000000', 'consum', 0.0217, 'lps'),
	(585412, 129, '2014-03-15 00:24:38.000000', 'consum', 0.0221, 'lps'),
	(585413, 129, '2014-03-15 00:24:39.000000', 'consum', 0.0216, 'lps'),
	(585414, 129, '2014-03-15 00:24:40.000000', 'consum', 0.0223, 'lps'),
	(585415, 129, '2014-03-15 00:24:41.000000', 'consum', 0.0213, 'lps'),
	(585416, 129, '2014-03-15 00:24:42.000000', 'consum', 0.0218, 'lps'),
	(585417, 129, '2014-03-15 00:24:43.000000', 'consum', 0.0212, 'lps'),
	(585418, 129, '2014-03-15 00:24:44.000000', 'consum', 0.0211, 'lps'),
	(585419, 129, '2014-03-15 00:24:45.000000', 'consum', 0.0222, 'lps'),
	(585420, 129, '2014-03-15 00:24:46.000000', 'consum', 0.0214, 'lps'),
	(585421, 129, '2014-03-15 00:24:47.000000', 'consum', 0.0222, 'lps'),
	(585422, 129, '2014-03-15 00:24:48.000000', 'consum', 0.0217, 'lps'),
	(585423, 129, '2014-03-15 00:24:49.000000', 'consum', 0.0223, 'lps'),
	(585424, 129, '2014-03-15 00:24:50.000000', 'consum', 0.0211, 'lps'),
	(585425, 129, '2014-03-15 00:24:51.000000', 'consum', 0.0218, 'lps'),
	(585426, 129, '2014-03-15 00:24:52.000000', 'consum', 0.0220, 'lps'),
	(585427, 129, '2014-03-15 00:24:53.000000', 'consum', 0.0210, 'lps'),
	(585428, 129, '2014-03-15 00:24:54.000000', 'consum', 0.0220, 'lps'),
	(585429, 129, '2014-03-15 00:24:55.000000', 'consum', 0.0219, 'lps'),
	(585430, 129, '2014-03-15 00:24:56.000000', 'consum', 0.0213, 'lps'),
	(585431, 129, '2014-03-15 00:24:57.000000', 'consum', 0.0212, 'lps'),
	(585432, 129, '2014-03-15 00:24:58.000000', 'consum', 0.0211, 'lps'),
	(585433, 129, '2014-03-15 00:24:59.000000', 'consum', 0.0212, 'lps'),
	(585434, 129, '2014-03-15 00:25:00.000000', 'consum', 0.0215, 'lps'),
	(585435, 129, '2014-03-15 00:25:01.000000', 'consum', 0.0218, 'lps'),
	(585436, 129, '2014-03-15 00:25:02.000000', 'consum', 0.0221, 'lps'),
	(585437, 129, '2014-03-15 00:25:03.000000', 'consum', 0.0213, 'lps'),
	(585438, 129, '2014-03-15 00:25:04.000000', 'consum', 0.0221, 'lps'),
	(585439, 129, '2014-03-15 00:25:05.000000', 'consum', 0.0213, 'lps'),
	(585440, 129, '2014-03-15 00:25:06.000000', 'consum', 0.0220, 'lps'),
	(585441, 129, '2014-03-15 00:25:07.000000', 'consum', 0.0211, 'lps'),
	(585442, 129, '2014-03-15 00:25:08.000000', 'consum', 0.0215, 'lps'),
	(585443, 129, '2014-03-15 00:25:09.000000', 'consum', 0.0216, 'lps'),
	(585444, 129, '2014-03-15 00:25:10.000000', 'consum', 0.0214, 'lps'),
	(585445, 129, '2014-03-15 00:25:11.000000', 'consum', 0.0210, 'lps'),
	(585446, 129, '2014-03-15 00:25:12.000000', 'consum', 0.0214, 'lps'),
	(585447, 129, '2014-03-15 00:25:13.000000', 'consum', 0.0217, 'lps'),
	(585448, 129, '2014-03-15 00:25:14.000000', 'consum', 0.0221, 'lps'),
	(585449, 129, '2014-03-15 00:25:15.000000', 'consum', 0.0213, 'lps'),
	(585450, 129, '2014-03-15 00:25:16.000000', 'consum', 0.0210, 'lps'),
	(585451, 129, '2014-03-15 00:25:17.000000', 'consum', 0.0212, 'lps'),
	(585452, 129, '2014-03-15 00:25:18.000000', 'consum', 0.0222, 'lps'),
	(585453, 129, '2014-03-15 00:25:19.000000', 'consum', 0.0223, 'lps'),
	(585454, 129, '2014-03-15 00:25:20.000000', 'consum', 0.0212, 'lps'),
	(585455, 129, '2014-03-15 00:25:21.000000', 'consum', 0.0221, 'lps'),
	(585456, 129, '2014-03-15 00:25:22.000000', 'consum', 0.0219, 'lps'),
	(585457, 129, '2014-03-15 00:25:23.000000', 'consum', 0.0221, 'lps'),
	(585458, 129, '2014-03-15 00:25:24.000000', 'consum', 0.0210, 'lps'),
	(585459, 129, '2014-03-15 00:25:25.000000', 'consum', 0.0222, 'lps'),
	(585460, 129, '2014-03-15 00:25:26.000000', 'consum', 0.0213, 'lps'),
	(585461, 129, '2014-03-15 00:25:27.000000', 'consum', 0.0218, 'lps'),
	(585462, 129, '2014-03-15 00:25:28.000000', 'consum', 0.0212, 'lps'),
	(585463, 129, '2014-03-15 00:25:29.000000', 'consum', 0.0211, 'lps'),
	(585464, 129, '2014-03-15 00:25:30.000000', 'consum', 0.0210, 'lps'),
	(585465, 129, '2014-03-15 00:25:31.000000', 'consum', 0.0222, 'lps'),
	(585466, 129, '2014-03-15 00:25:32.000000', 'consum', 0.0216, 'lps'),
	(585467, 129, '2014-03-15 00:25:33.000000', 'consum', 0.0217, 'lps'),
	(585468, 129, '2014-03-15 00:25:34.000000', 'consum', 0.0215, 'lps'),
	(585469, 129, '2014-03-15 00:25:35.000000', 'consum', 0.0214, 'lps'),
	(585470, 129, '2014-03-15 00:25:36.000000', 'consum', 0.0216, 'lps'),
	(585471, 129, '2014-03-15 00:25:37.000000', 'consum', 0.0214, 'lps'),
	(585472, 129, '2014-03-15 00:25:38.000000', 'consum', 0.0212, 'lps'),
	(585473, 129, '2014-03-15 00:25:39.000000', 'consum', 0.0222, 'lps'),
	(585474, 129, '2014-03-15 00:25:40.000000', 'consum', 0.0211, 'lps'),
	(585475, 129, '2014-03-15 00:25:41.000000', 'consum', 0.0220, 'lps'),
	(585476, 129, '2014-03-15 00:25:42.000000', 'consum', 0.0215, 'lps'),
	(585477, 129, '2014-03-15 00:25:43.000000', 'consum', 0.0218, 'lps'),
	(585478, 129, '2014-03-15 00:25:44.000000', 'consum', 0.0222, 'lps'),
	(585479, 129, '2014-03-15 00:25:45.000000', 'consum', 0.0219, 'lps'),
	(585480, 129, '2014-03-15 00:25:46.000000', 'consum', 0.0219, 'lps'),
	(585481, 129, '2014-03-15 00:25:47.000000', 'consum', 0.0215, 'lps'),
	(585482, 129, '2014-03-15 00:25:48.000000', 'consum', 0.0223, 'lps'),
	(585483, 129, '2014-03-15 00:25:49.000000', 'consum', 0.0220, 'lps'),
	(585484, 129, '2014-03-15 00:25:50.000000', 'consum', 0.0218, 'lps'),
	(585485, 129, '2014-03-15 00:25:51.000000', 'consum', 0.0223, 'lps'),
	(585486, 129, '2014-03-15 00:25:52.000000', 'consum', 0.0223, 'lps'),
	(585487, 129, '2014-03-15 00:25:53.000000', 'consum', 0.0221, 'lps'),
	(585488, 129, '2014-03-15 00:25:54.000000', 'consum', 0.0212, 'lps'),
	(585489, 129, '2014-03-15 00:25:55.000000', 'consum', 0.0217, 'lps'),
	(585490, 129, '2014-03-15 00:25:56.000000', 'consum', 0.0210, 'lps'),
	(585491, 129, '2014-03-15 00:25:57.000000', 'consum', 0.0220, 'lps'),
	(585492, 129, '2014-03-15 00:25:58.000000', 'consum', 0.0216, 'lps'),
	(585493, 129, '2014-03-15 00:25:59.000000', 'consum', 0.0211, 'lps'),
	(585494, 129, '2014-03-15 00:26:00.000000', 'consum', 0.0212, 'lps'),
	(585495, 129, '2014-03-15 00:26:01.000000', 'consum', 0.0216, 'lps'),
	(585496, 129, '2014-03-15 00:26:02.000000', 'consum', 0.0210, 'lps'),
	(585497, 129, '2014-03-15 00:26:03.000000', 'consum', 0.0217, 'lps'),
	(585498, 129, '2014-03-15 00:26:04.000000', 'consum', 0.0218, 'lps'),
	(585499, 129, '2014-03-15 00:26:05.000000', 'consum', 0.0214, 'lps'),
	(585500, 129, '2014-03-15 00:26:06.000000', 'consum', 0.0210, 'lps'),
	(585501, 129, '2014-03-15 00:26:07.000000', 'consum', 0.0223, 'lps'),
	(585502, 129, '2014-03-15 00:26:08.000000', 'consum', 0.0223, 'lps'),
	(585503, 129, '2014-03-15 00:26:09.000000', 'consum', 0.0220, 'lps'),
	(585504, 129, '2014-03-15 00:26:10.000000', 'consum', 0.0221, 'lps'),
	(585505, 129, '2014-03-15 00:26:11.000000', 'consum', 0.0223, 'lps'),
	(585506, 129, '2014-03-15 00:26:12.000000', 'consum', 0.0213, 'lps'),
	(585507, 129, '2014-03-15 00:26:13.000000', 'consum', 0.0215, 'lps'),
	(585508, 129, '2014-03-15 00:26:14.000000', 'consum', 0.0212, 'lps'),
	(585509, 129, '2014-03-15 00:26:15.000000', 'consum', 0.0221, 'lps'),
	(585510, 129, '2014-03-15 00:26:16.000000', 'consum', 0.0217, 'lps'),
	(585511, 129, '2014-03-15 00:26:17.000000', 'consum', 0.0213, 'lps'),
	(585512, 129, '2014-03-15 00:26:18.000000', 'consum', 0.0218, 'lps'),
	(585513, 129, '2014-03-15 00:26:19.000000', 'consum', 0.0212, 'lps'),
	(585514, 129, '2014-03-15 00:26:20.000000', 'consum', 0.0213, 'lps'),
	(585515, 129, '2014-03-15 00:26:21.000000', 'consum', 0.0217, 'lps'),
	(585516, 129, '2014-03-15 00:26:22.000000', 'consum', 0.0210, 'lps'),
	(585517, 129, '2014-03-15 00:26:23.000000', 'consum', 0.0218, 'lps'),
	(585518, 129, '2014-03-15 00:26:24.000000', 'consum', 0.0222, 'lps'),
	(585519, 129, '2014-03-15 00:26:25.000000', 'consum', 0.0220, 'lps'),
	(585520, 129, '2014-03-15 00:26:26.000000', 'consum', 0.0210, 'lps'),
	(585521, 129, '2014-03-15 00:26:27.000000', 'consum', 0.0210, 'lps'),
	(585522, 129, '2014-03-15 00:26:28.000000', 'consum', 0.0210, 'lps'),
	(585523, 129, '2014-03-15 00:26:29.000000', 'consum', 0.0210, 'lps'),
	(585524, 129, '2014-03-15 00:26:30.000000', 'consum', 0.0223, 'lps'),
	(585525, 129, '2014-03-15 00:26:31.000000', 'consum', 0.0219, 'lps'),
	(585526, 129, '2014-03-15 00:26:32.000000', 'consum', 0.0217, 'lps'),
	(585527, 129, '2014-03-15 00:26:33.000000', 'consum', 0.0217, 'lps'),
	(585528, 129, '2014-03-15 00:26:34.000000', 'consum', 0.0212, 'lps'),
	(585529, 129, '2014-03-15 00:26:35.000000', 'consum', 0.0212, 'lps'),
	(585530, 129, '2014-03-15 00:26:36.000000', 'consum', 0.0216, 'lps'),
	(585531, 129, '2014-03-15 00:26:37.000000', 'consum', 0.0222, 'lps'),
	(585532, 129, '2014-03-15 00:26:38.000000', 'consum', 0.0222, 'lps'),
	(585533, 129, '2014-03-15 00:26:39.000000', 'consum', 0.0223, 'lps'),
	(585534, 129, '2014-03-15 00:26:40.000000', 'consum', 0.0210, 'lps'),
	(585535, 129, '2014-03-15 00:26:41.000000', 'consum', 0.0214, 'lps'),
	(585536, 129, '2014-03-15 00:26:42.000000', 'consum', 0.0217, 'lps'),
	(585537, 129, '2014-03-15 00:26:43.000000', 'consum', 0.0219, 'lps'),
	(585538, 129, '2014-03-15 00:26:44.000000', 'consum', 0.0220, 'lps'),
	(585539, 129, '2014-03-15 00:26:45.000000', 'consum', 0.0221, 'lps'),
	(585540, 129, '2014-03-15 00:26:46.000000', 'consum', 0.0220, 'lps'),
	(585541, 129, '2014-03-15 00:26:47.000000', 'consum', 0.0214, 'lps'),
	(585542, 129, '2014-03-15 00:26:48.000000', 'consum', 0.0216, 'lps'),
	(585543, 129, '2014-03-15 00:26:49.000000', 'consum', 0.0212, 'lps'),
	(585544, 129, '2014-03-15 00:26:50.000000', 'consum', 0.0218, 'lps'),
	(585545, 129, '2014-03-15 00:26:51.000000', 'consum', 0.0215, 'lps'),
	(585546, 129, '2014-03-15 00:26:52.000000', 'consum', 0.0214, 'lps'),
	(585547, 129, '2014-03-15 00:26:53.000000', 'consum', 0.0213, 'lps'),
	(585548, 129, '2014-03-15 00:26:54.000000', 'consum', 0.0215, 'lps'),
	(585549, 129, '2014-03-15 00:26:55.000000', 'consum', 0.0211, 'lps'),
	(585550, 129, '2014-03-15 00:26:56.000000', 'consum', 0.0214, 'lps'),
	(585551, 129, '2014-03-15 00:26:57.000000', 'consum', 0.0215, 'lps'),
	(585552, 129, '2014-03-15 00:26:58.000000', 'consum', 0.0223, 'lps'),
	(585553, 129, '2014-03-15 00:26:59.000000', 'consum', 0.0217, 'lps'),
	(585554, 129, '2014-03-15 00:27:00.000000', 'consum', 0.0210, 'lps'),
	(585555, 129, '2014-03-15 00:27:01.000000', 'consum', 0.0214, 'lps'),
	(585556, 129, '2014-03-15 00:27:02.000000', 'consum', 0.0219, 'lps'),
	(585557, 129, '2014-03-15 00:27:03.000000', 'consum', 0.0213, 'lps'),
	(585558, 129, '2014-03-15 00:27:04.000000', 'consum', 0.0212, 'lps'),
	(585559, 129, '2014-03-15 00:27:05.000000', 'consum', 0.0213, 'lps'),
	(585560, 129, '2014-03-15 00:27:06.000000', 'consum', 0.0221, 'lps'),
	(585561, 129, '2014-03-15 00:27:07.000000', 'consum', 0.0211, 'lps'),
	(585562, 129, '2014-03-15 00:27:08.000000', 'consum', 0.0214, 'lps'),
	(585563, 129, '2014-03-15 00:27:09.000000', 'consum', 0.0212, 'lps'),
	(585564, 129, '2014-03-15 00:27:10.000000', 'consum', 0.0223, 'lps'),
	(585565, 129, '2014-03-15 00:27:11.000000', 'consum', 0.0212, 'lps'),
	(585566, 129, '2014-03-15 00:27:12.000000', 'consum', 0.0223, 'lps'),
	(585567, 129, '2014-03-15 00:27:13.000000', 'consum', 0.0216, 'lps'),
	(585568, 129, '2014-03-15 00:27:14.000000', 'consum', 0.0213, 'lps'),
	(585569, 129, '2014-03-15 00:27:15.000000', 'consum', 0.0223, 'lps'),
	(585570, 129, '2014-03-15 00:27:16.000000', 'consum', 0.0211, 'lps'),
	(585571, 129, '2014-03-15 00:27:17.000000', 'consum', 0.0216, 'lps'),
	(585572, 129, '2014-03-15 00:27:18.000000', 'consum', 0.0212, 'lps'),
	(585573, 129, '2014-03-15 00:27:19.000000', 'consum', 0.0216, 'lps'),
	(585574, 129, '2014-03-15 00:27:20.000000', 'consum', 0.0219, 'lps'),
	(585575, 129, '2014-03-15 00:27:21.000000', 'consum', 0.0212, 'lps'),
	(585576, 129, '2014-03-15 00:27:22.000000', 'consum', 0.0219, 'lps'),
	(585577, 129, '2014-03-15 00:27:23.000000', 'consum', 0.0223, 'lps'),
	(585578, 129, '2014-03-15 00:27:24.000000', 'consum', 0.0220, 'lps'),
	(585579, 129, '2014-03-15 00:27:25.000000', 'consum', 0.0220, 'lps'),
	(585580, 129, '2014-03-15 00:27:26.000000', 'consum', 0.0217, 'lps'),
	(585581, 129, '2014-03-15 00:27:27.000000', 'consum', 0.0214, 'lps'),
	(585582, 129, '2014-03-15 00:27:28.000000', 'consum', 0.0210, 'lps'),
	(585583, 129, '2014-03-15 00:27:29.000000', 'consum', 0.0213, 'lps'),
	(585584, 129, '2014-03-15 00:27:30.000000', 'consum', 0.0211, 'lps'),
	(585585, 129, '2014-03-15 00:27:31.000000', 'consum', 0.0220, 'lps'),
	(585586, 129, '2014-03-15 00:27:32.000000', 'consum', 0.0217, 'lps'),
	(585587, 129, '2014-03-15 00:27:33.000000', 'consum', 0.0214, 'lps'),
	(585588, 129, '2014-03-15 00:27:34.000000', 'consum', 0.0210, 'lps'),
	(585589, 129, '2014-03-15 00:27:35.000000', 'consum', 0.0213, 'lps'),
	(585590, 129, '2014-03-15 00:27:36.000000', 'consum', 0.0212, 'lps'),
	(585591, 129, '2014-03-15 00:27:37.000000', 'consum', 0.0212, 'lps'),
	(585592, 129, '2014-03-15 00:27:38.000000', 'consum', 0.0215, 'lps'),
	(585593, 129, '2014-03-15 00:27:39.000000', 'consum', 0.0215, 'lps'),
	(585594, 129, '2014-03-15 00:27:40.000000', 'consum', 0.0221, 'lps'),
	(585595, 129, '2014-03-15 00:27:41.000000', 'consum', 0.0221, 'lps'),
	(585596, 129, '2014-03-15 00:27:42.000000', 'consum', 0.0217, 'lps'),
	(585597, 129, '2014-03-15 00:27:43.000000', 'consum', 0.0216, 'lps'),
	(585598, 129, '2014-03-15 00:27:44.000000', 'consum', 0.0218, 'lps'),
	(585599, 129, '2014-03-15 00:27:45.000000', 'consum', 0.0218, 'lps'),
	(585600, 129, '2014-03-15 00:27:46.000000', 'consum', 0.0214, 'lps'),
	(585601, 129, '2014-03-15 00:27:47.000000', 'consum', 0.0219, 'lps'),
	(585602, 129, '2014-03-15 00:27:48.000000', 'consum', 0.0216, 'lps'),
	(585603, 129, '2014-03-15 00:27:49.000000', 'consum', 0.0212, 'lps'),
	(585604, 129, '2014-03-15 00:27:50.000000', 'consum', 0.0216, 'lps'),
	(585605, 129, '2014-03-15 00:27:51.000000', 'consum', 0.0221, 'lps'),
	(585606, 129, '2014-03-15 00:27:52.000000', 'consum', 0.0222, 'lps'),
	(585607, 129, '2014-03-15 00:27:53.000000', 'consum', 0.0222, 'lps'),
	(585608, 129, '2014-03-15 00:27:54.000000', 'consum', 0.0221, 'lps'),
	(585609, 129, '2014-03-15 00:27:55.000000', 'consum', 0.0213, 'lps'),
	(585610, 129, '2014-03-15 00:27:56.000000', 'consum', 0.0223, 'lps'),
	(585611, 129, '2014-03-15 00:27:57.000000', 'consum', 0.0212, 'lps'),
	(585612, 129, '2014-03-15 00:27:58.000000', 'consum', 0.0220, 'lps'),
	(585613, 129, '2014-03-15 00:27:59.000000', 'consum', 0.0214, 'lps'),
	(585614, 129, '2014-03-15 00:28:00.000000', 'consum', 0.0216, 'lps'),
	(585615, 129, '2014-03-15 00:28:01.000000', 'consum', 0.0214, 'lps'),
	(585616, 129, '2014-03-15 00:28:02.000000', 'consum', 0.0214, 'lps'),
	(585617, 129, '2014-03-15 00:28:03.000000', 'consum', 0.0218, 'lps'),
	(585618, 129, '2014-03-15 00:28:04.000000', 'consum', 0.0223, 'lps'),
	(585619, 129, '2014-03-15 00:28:05.000000', 'consum', 0.0211, 'lps'),
	(585620, 129, '2014-03-15 00:28:06.000000', 'consum', 0.0218, 'lps'),
	(585621, 129, '2014-03-15 00:28:07.000000', 'consum', 0.0221, 'lps'),
	(585622, 129, '2014-03-15 00:28:08.000000', 'consum', 0.0212, 'lps'),
	(585623, 129, '2014-03-15 00:28:09.000000', 'consum', 0.0214, 'lps'),
	(585624, 129, '2014-03-15 00:28:10.000000', 'consum', 0.0212, 'lps'),
	(585625, 129, '2014-03-15 00:28:11.000000', 'consum', 0.0223, 'lps'),
	(585626, 129, '2014-03-15 00:28:12.000000', 'consum', 0.0213, 'lps'),
	(585627, 129, '2014-03-15 00:28:13.000000', 'consum', 0.0216, 'lps'),
	(585628, 129, '2014-03-15 00:28:14.000000', 'consum', 0.0218, 'lps'),
	(585629, 129, '2014-03-15 00:28:15.000000', 'consum', 0.0215, 'lps'),
	(585630, 129, '2014-03-15 00:28:16.000000', 'consum', 0.0215, 'lps'),
	(585631, 129, '2014-03-15 00:28:17.000000', 'consum', 0.0218, 'lps'),
	(585632, 129, '2014-03-15 00:28:18.000000', 'consum', 0.0221, 'lps'),
	(585633, 129, '2014-03-15 00:28:19.000000', 'consum', 0.0214, 'lps'),
	(585634, 129, '2014-03-15 00:28:20.000000', 'consum', 0.0213, 'lps'),
	(585635, 129, '2014-03-15 00:28:21.000000', 'consum', 0.0212, 'lps'),
	(585636, 129, '2014-03-15 00:28:22.000000', 'consum', 0.0213, 'lps'),
	(585637, 129, '2014-03-15 00:28:23.000000', 'consum', 0.0217, 'lps'),
	(585638, 129, '2014-03-15 00:28:24.000000', 'consum', 0.0223, 'lps'),
	(585639, 129, '2014-03-15 00:28:25.000000', 'consum', 0.0215, 'lps'),
	(585640, 129, '2014-03-15 00:28:26.000000', 'consum', 0.0223, 'lps'),
	(585641, 129, '2014-03-15 00:28:27.000000', 'consum', 0.0220, 'lps'),
	(585642, 129, '2014-03-15 00:28:28.000000', 'consum', 0.0220, 'lps'),
	(585643, 129, '2014-03-15 00:28:29.000000', 'consum', 0.0215, 'lps'),
	(585644, 129, '2014-03-15 00:28:30.000000', 'consum', 0.0222, 'lps'),
	(585645, 129, '2014-03-15 00:28:31.000000', 'consum', 0.0213, 'lps'),
	(585646, 129, '2014-03-15 00:28:32.000000', 'consum', 0.0218, 'lps'),
	(585647, 129, '2014-03-15 00:28:33.000000', 'consum', 0.0212, 'lps'),
	(585648, 129, '2014-03-15 00:28:34.000000', 'consum', 0.0212, 'lps'),
	(585649, 129, '2014-03-15 00:28:35.000000', 'consum', 0.0214, 'lps'),
	(585650, 129, '2014-03-15 00:28:36.000000', 'consum', 0.0212, 'lps'),
	(585651, 129, '2014-03-15 00:28:37.000000', 'consum', 0.0220, 'lps'),
	(585652, 129, '2014-03-15 00:28:38.000000', 'consum', 0.0215, 'lps'),
	(585653, 129, '2014-03-15 00:28:39.000000', 'consum', 0.0217, 'lps'),
	(585654, 129, '2014-03-15 00:28:40.000000', 'consum', 0.0217, 'lps'),
	(585655, 129, '2014-03-15 00:28:41.000000', 'consum', 0.0211, 'lps'),
	(585656, 129, '2014-03-15 00:28:42.000000', 'consum', 0.0210, 'lps'),
	(585657, 129, '2014-03-15 00:28:43.000000', 'consum', 0.0221, 'lps'),
	(585658, 129, '2014-03-15 00:28:44.000000', 'consum', 0.0223, 'lps'),
	(585659, 129, '2014-03-15 00:28:45.000000', 'consum', 0.0214, 'lps'),
	(585660, 129, '2014-03-15 00:28:46.000000', 'consum', 0.0219, 'lps'),
	(585661, 129, '2014-03-15 00:28:47.000000', 'consum', 0.0214, 'lps'),
	(585662, 129, '2014-03-15 00:28:48.000000', 'consum', 0.0220, 'lps'),
	(585663, 129, '2014-03-15 00:28:49.000000', 'consum', 0.0218, 'lps'),
	(585664, 129, '2014-03-15 00:28:50.000000', 'consum', 0.0222, 'lps'),
	(585665, 129, '2014-03-15 00:28:51.000000', 'consum', 0.0216, 'lps'),
	(585666, 129, '2014-03-15 00:28:52.000000', 'consum', 0.0222, 'lps'),
	(585667, 129, '2014-03-15 00:28:53.000000', 'consum', 0.0210, 'lps'),
	(585668, 129, '2014-03-15 00:28:54.000000', 'consum', 0.0216, 'lps'),
	(585669, 129, '2014-03-15 00:28:55.000000', 'consum', 0.0210, 'lps'),
	(585670, 129, '2014-03-15 00:28:56.000000', 'consum', 0.0210, 'lps'),
	(585671, 129, '2014-03-15 00:28:57.000000', 'consum', 0.0211, 'lps'),
	(585672, 129, '2014-03-15 00:28:58.000000', 'consum', 0.0213, 'lps'),
	(585673, 129, '2014-03-15 00:28:59.000000', 'consum', 0.0222, 'lps'),
	(585674, 129, '2014-03-15 00:29:00.000000', 'consum', 0.0221, 'lps'),
	(585675, 129, '2014-03-15 00:29:01.000000', 'consum', 0.0214, 'lps'),
	(585676, 129, '2014-03-15 00:29:02.000000', 'consum', 0.0213, 'lps'),
	(585677, 129, '2014-03-15 00:29:03.000000', 'consum', 0.0211, 'lps'),
	(585678, 129, '2014-03-15 00:29:04.000000', 'consum', 0.0223, 'lps'),
	(585679, 129, '2014-03-15 00:29:05.000000', 'consum', 0.0215, 'lps'),
	(585680, 129, '2014-03-15 00:29:06.000000', 'consum', 0.0223, 'lps'),
	(585681, 129, '2014-03-15 00:29:07.000000', 'consum', 0.0219, 'lps'),
	(585682, 129, '2014-03-15 00:29:08.000000', 'consum', 0.0219, 'lps'),
	(585683, 129, '2014-03-15 00:29:09.000000', 'consum', 0.0213, 'lps'),
	(585684, 129, '2014-03-15 00:29:10.000000', 'consum', 0.0213, 'lps'),
	(585685, 129, '2014-03-15 00:29:11.000000', 'consum', 0.0216, 'lps'),
	(585686, 129, '2014-03-15 00:29:12.000000', 'consum', 0.0216, 'lps'),
	(585687, 129, '2014-03-15 00:29:13.000000', 'consum', 0.0212, 'lps'),
	(585688, 129, '2014-03-15 00:29:14.000000', 'consum', 0.0214, 'lps'),
	(585689, 129, '2014-03-15 00:29:15.000000', 'consum', 0.0211, 'lps'),
	(585690, 129, '2014-03-15 00:29:16.000000', 'consum', 0.0219, 'lps'),
	(585691, 129, '2014-03-15 00:29:17.000000', 'consum', 0.0211, 'lps'),
	(585692, 129, '2014-03-15 00:29:18.000000', 'consum', 0.0217, 'lps'),
	(585693, 129, '2014-03-15 00:29:19.000000', 'consum', 0.0213, 'lps'),
	(585694, 129, '2014-03-15 00:29:20.000000', 'consum', 0.0217, 'lps'),
	(585695, 129, '2014-03-15 00:29:21.000000', 'consum', 0.0210, 'lps'),
	(585696, 129, '2014-03-15 00:29:22.000000', 'consum', 0.0218, 'lps'),
	(585697, 129, '2014-03-15 00:29:23.000000', 'consum', 0.0220, 'lps'),
	(585698, 129, '2014-03-15 00:29:24.000000', 'consum', 0.0211, 'lps'),
	(585699, 129, '2014-03-15 00:29:25.000000', 'consum', 0.0211, 'lps'),
	(585700, 129, '2014-03-15 00:29:26.000000', 'consum', 0.0212, 'lps'),
	(585701, 129, '2014-03-15 00:29:27.000000', 'consum', 0.0219, 'lps'),
	(585702, 129, '2014-03-15 00:29:28.000000', 'consum', 0.0223, 'lps'),
	(585703, 129, '2014-03-15 00:29:29.000000', 'consum', 0.0220, 'lps'),
	(585704, 129, '2014-03-15 00:29:30.000000', 'consum', 0.0222, 'lps'),
	(585705, 129, '2014-03-15 00:29:31.000000', 'consum', 0.0212, 'lps'),
	(585706, 129, '2014-03-15 00:29:32.000000', 'consum', 0.0210, 'lps'),
	(585707, 129, '2014-03-15 00:29:33.000000', 'consum', 0.0222, 'lps'),
	(585708, 129, '2014-03-15 00:29:34.000000', 'consum', 0.0211, 'lps'),
	(585709, 129, '2014-03-15 00:29:35.000000', 'consum', 0.0211, 'lps'),
	(585710, 129, '2014-03-15 00:29:36.000000', 'consum', 0.0210, 'lps'),
	(585711, 129, '2014-03-15 00:29:37.000000', 'consum', 0.0222, 'lps'),
	(585712, 129, '2014-03-15 00:29:38.000000', 'consum', 0.0214, 'lps'),
	(585713, 129, '2014-03-15 00:29:39.000000', 'consum', 0.0211, 'lps'),
	(585714, 129, '2014-03-15 00:29:40.000000', 'consum', 0.0216, 'lps'),
	(585715, 129, '2014-03-15 00:29:41.000000', 'consum', 0.0223, 'lps'),
	(585716, 129, '2014-03-15 00:29:42.000000', 'consum', 0.0215, 'lps'),
	(585717, 129, '2014-03-15 00:29:43.000000', 'consum', 0.0210, 'lps'),
	(585718, 129, '2014-03-15 00:29:44.000000', 'consum', 0.0223, 'lps'),
	(585719, 129, '2014-03-15 00:29:45.000000', 'consum', 0.0220, 'lps'),
	(585720, 129, '2014-03-15 00:29:46.000000', 'consum', 0.0221, 'lps'),
	(585721, 129, '2014-03-15 00:29:47.000000', 'consum', 0.0210, 'lps'),
	(585722, 129, '2014-03-15 00:29:48.000000', 'consum', 0.0216, 'lps'),
	(585723, 129, '2014-03-15 00:29:49.000000', 'consum', 0.0215, 'lps'),
	(585724, 129, '2014-03-15 00:29:50.000000', 'consum', 0.0215, 'lps'),
	(585725, 129, '2014-03-15 00:29:51.000000', 'consum', 0.0223, 'lps'),
	(585726, 129, '2014-03-15 00:29:52.000000', 'consum', 0.0219, 'lps'),
	(585727, 129, '2014-03-15 00:29:53.000000', 'consum', 0.0215, 'lps'),
	(585728, 129, '2014-03-15 00:29:54.000000', 'consum', 0.0221, 'lps'),
	(585729, 129, '2014-03-15 00:29:55.000000', 'consum', 0.0211, 'lps'),
	(585730, 129, '2014-03-15 00:29:56.000000', 'consum', 0.0212, 'lps'),
	(585731, 129, '2014-03-15 00:29:57.000000', 'consum', 0.0215, 'lps'),
	(585732, 129, '2014-03-15 00:29:58.000000', 'consum', 0.0215, 'lps'),
	(585733, 129, '2014-03-15 00:29:59.000000', 'consum', 0.0222, 'lps'),
	(585734, 129, '2014-03-15 00:30:00.000000', 'consum', 0.0213, 'lps'),
	(585735, 129, '2014-03-15 00:30:01.000000', 'consum', 0.0217, 'lps'),
	(585736, 129, '2014-03-15 00:30:02.000000', 'consum', 0.0223, 'lps'),
	(585737, 129, '2014-03-15 00:30:03.000000', 'consum', 0.0212, 'lps'),
	(585738, 129, '2014-03-15 00:30:04.000000', 'consum', 0.0210, 'lps'),
	(585739, 129, '2014-03-15 00:30:05.000000', 'consum', 0.0219, 'lps'),
	(585740, 129, '2014-03-15 00:30:06.000000', 'consum', 0.0213, 'lps'),
	(585741, 129, '2014-03-15 00:30:07.000000', 'consum', 0.0213, 'lps'),
	(585742, 129, '2014-03-15 00:30:08.000000', 'consum', 0.0216, 'lps'),
	(585743, 129, '2014-03-15 00:30:09.000000', 'consum', 0.0218, 'lps'),
	(585744, 129, '2014-03-15 00:30:10.000000', 'consum', 0.0219, 'lps'),
	(585745, 129, '2014-03-15 00:30:11.000000', 'consum', 0.0217, 'lps'),
	(585746, 129, '2014-03-15 00:30:12.000000', 'consum', 0.0220, 'lps'),
	(585747, 129, '2014-03-15 00:30:13.000000', 'consum', 0.0210, 'lps'),
	(585748, 129, '2014-03-15 00:30:14.000000', 'consum', 0.0211, 'lps'),
	(585749, 129, '2014-03-15 00:30:15.000000', 'consum', 0.0213, 'lps'),
	(585750, 129, '2014-03-15 00:30:16.000000', 'consum', 0.0221, 'lps'),
	(585751, 129, '2014-03-15 00:30:17.000000', 'consum', 0.0217, 'lps'),
	(585752, 129, '2014-03-15 00:30:18.000000', 'consum', 0.0212, 'lps'),
	(585753, 129, '2014-03-15 00:30:19.000000', 'consum', 0.0212, 'lps'),
	(585754, 129, '2014-03-15 00:30:20.000000', 'consum', 0.0215, 'lps'),
	(585755, 129, '2014-03-15 00:30:21.000000', 'consum', 0.0215, 'lps'),
	(585756, 129, '2014-03-15 00:30:22.000000', 'consum', 0.0220, 'lps'),
	(585757, 129, '2014-03-15 00:30:23.000000', 'consum', 0.0218, 'lps'),
	(585758, 129, '2014-03-15 00:30:24.000000', 'consum', 0.0219, 'lps'),
	(585759, 129, '2014-03-15 00:30:25.000000', 'consum', 0.0220, 'lps'),
	(585760, 129, '2014-03-15 00:30:26.000000', 'consum', 0.0220, 'lps'),
	(585761, 129, '2014-03-15 00:30:27.000000', 'consum', 0.0214, 'lps'),
	(585762, 129, '2014-03-15 00:30:28.000000', 'consum', 0.0214, 'lps'),
	(585763, 129, '2014-03-15 00:30:29.000000', 'consum', 0.0219, 'lps'),
	(585764, 129, '2014-03-15 00:30:30.000000', 'consum', 0.0217, 'lps'),
	(585765, 129, '2014-03-15 00:30:31.000000', 'consum', 0.0219, 'lps'),
	(585766, 129, '2014-03-15 00:30:32.000000', 'consum', 0.0221, 'lps'),
	(585767, 129, '2014-03-15 00:30:33.000000', 'consum', 0.0223, 'lps'),
	(585768, 129, '2014-03-15 00:30:34.000000', 'consum', 0.0215, 'lps'),
	(585769, 129, '2014-03-15 00:30:35.000000', 'consum', 0.0212, 'lps'),
	(585770, 129, '2014-03-15 00:30:36.000000', 'consum', 0.0218, 'lps'),
	(585771, 129, '2014-03-15 00:30:37.000000', 'consum', 0.0215, 'lps'),
	(585772, 129, '2014-03-15 00:30:38.000000', 'consum', 0.0214, 'lps'),
	(585773, 129, '2014-03-15 00:30:39.000000', 'consum', 0.0214, 'lps'),
	(585774, 129, '2014-03-15 00:30:40.000000', 'consum', 0.0217, 'lps'),
	(585775, 129, '2014-03-15 00:30:41.000000', 'consum', 0.0222, 'lps'),
	(585776, 129, '2014-03-15 00:30:42.000000', 'consum', 0.0221, 'lps'),
	(585777, 129, '2014-03-15 00:30:43.000000', 'consum', 0.0217, 'lps'),
	(585778, 129, '2014-03-15 00:30:44.000000', 'consum', 0.0210, 'lps'),
	(585779, 129, '2014-03-15 00:30:45.000000', 'consum', 0.0217, 'lps'),
	(585780, 129, '2014-03-15 00:30:46.000000', 'consum', 0.0216, 'lps'),
	(585781, 129, '2014-03-15 00:30:47.000000', 'consum', 0.0223, 'lps'),
	(585782, 129, '2014-03-15 00:30:48.000000', 'consum', 0.0215, 'lps'),
	(585783, 129, '2014-03-15 00:30:49.000000', 'consum', 0.0211, 'lps'),
	(585784, 129, '2014-03-15 00:30:50.000000', 'consum', 0.0212, 'lps'),
	(585785, 129, '2014-03-15 00:30:51.000000', 'consum', 0.0221, 'lps'),
	(585786, 129, '2014-03-15 00:30:52.000000', 'consum', 0.0214, 'lps'),
	(585787, 129, '2014-03-15 00:30:53.000000', 'consum', 0.0213, 'lps'),
	(585788, 129, '2014-03-15 00:30:54.000000', 'consum', 0.0212, 'lps'),
	(585789, 129, '2014-03-15 00:30:55.000000', 'consum', 0.0212, 'lps'),
	(585790, 129, '2014-03-15 00:30:56.000000', 'consum', 0.0215, 'lps'),
	(585791, 129, '2014-03-15 00:30:57.000000', 'consum', 0.0215, 'lps'),
	(585792, 129, '2014-03-15 00:30:58.000000', 'consum', 0.0219, 'lps'),
	(585793, 129, '2014-03-15 00:30:59.000000', 'consum', 0.0213, 'lps'),
	(585794, 129, '2014-03-15 00:31:00.000000', 'consum', 0.0212, 'lps'),
	(585795, 129, '2014-03-15 00:31:01.000000', 'consum', 0.0212, 'lps'),
	(585796, 129, '2014-03-15 00:31:02.000000', 'consum', 0.0213, 'lps'),
	(585797, 129, '2014-03-15 00:31:03.000000', 'consum', 0.0220, 'lps'),
	(585798, 129, '2014-03-15 00:31:04.000000', 'consum', 0.0210, 'lps'),
	(585799, 129, '2014-03-15 00:31:05.000000', 'consum', 0.0223, 'lps'),
	(585800, 129, '2014-03-15 00:31:06.000000', 'consum', 0.0220, 'lps'),
	(585801, 129, '2014-03-15 00:31:07.000000', 'consum', 0.0220, 'lps'),
	(585802, 129, '2014-03-15 00:31:08.000000', 'consum', 0.0215, 'lps'),
	(585803, 129, '2014-03-15 00:31:09.000000', 'consum', 0.0221, 'lps'),
	(585804, 129, '2014-03-15 00:31:10.000000', 'consum', 0.0222, 'lps'),
	(585805, 129, '2014-03-15 00:31:11.000000', 'consum', 0.0211, 'lps'),
	(585806, 129, '2014-03-15 00:31:12.000000', 'consum', 0.0220, 'lps'),
	(585807, 129, '2014-03-15 00:31:13.000000', 'consum', 0.0215, 'lps'),
	(585808, 129, '2014-03-15 00:31:14.000000', 'consum', 0.0222, 'lps'),
	(585809, 129, '2014-03-15 00:31:15.000000', 'consum', 0.0213, 'lps'),
	(585810, 129, '2014-03-15 00:31:16.000000', 'consum', 0.0217, 'lps'),
	(585811, 129, '2014-03-15 00:31:17.000000', 'consum', 0.0223, 'lps'),
	(585812, 129, '2014-03-15 00:31:18.000000', 'consum', 0.0212, 'lps'),
	(585813, 129, '2014-03-15 00:31:19.000000', 'consum', 0.0222, 'lps'),
	(585814, 129, '2014-03-15 00:31:20.000000', 'consum', 0.0222, 'lps'),
	(585815, 129, '2014-03-15 00:31:21.000000', 'consum', 0.0222, 'lps'),
	(585816, 129, '2014-03-15 00:31:22.000000', 'consum', 0.0220, 'lps'),
	(585817, 129, '2014-03-15 00:31:23.000000', 'consum', 0.0210, 'lps'),
	(585818, 129, '2014-03-15 00:31:24.000000', 'consum', 0.0221, 'lps'),
	(585819, 129, '2014-03-15 00:31:25.000000', 'consum', 0.0211, 'lps'),
	(585820, 129, '2014-03-15 00:31:26.000000', 'consum', 0.0213, 'lps'),
	(585821, 129, '2014-03-15 00:31:27.000000', 'consum', 0.0219, 'lps'),
	(585822, 129, '2014-03-15 00:31:28.000000', 'consum', 0.0218, 'lps'),
	(585823, 129, '2014-03-15 00:31:29.000000', 'consum', 0.0213, 'lps'),
	(585824, 129, '2014-03-15 00:31:30.000000', 'consum', 0.0212, 'lps'),
	(585825, 129, '2014-03-15 00:31:31.000000', 'consum', 0.0212, 'lps'),
	(585826, 129, '2014-03-15 00:31:32.000000', 'consum', 0.0217, 'lps'),
	(585827, 129, '2014-03-15 00:31:33.000000', 'consum', 0.0223, 'lps'),
	(585828, 129, '2014-03-15 00:31:34.000000', 'consum', 0.0215, 'lps'),
	(585829, 129, '2014-03-15 00:31:35.000000', 'consum', 0.0221, 'lps'),
	(585830, 129, '2014-03-15 00:31:36.000000', 'consum', 0.0212, 'lps'),
	(585831, 129, '2014-03-15 00:31:37.000000', 'consum', 0.0213, 'lps'),
	(585832, 129, '2014-03-15 00:31:38.000000', 'consum', 0.0222, 'lps'),
	(585833, 129, '2014-03-15 00:31:39.000000', 'consum', 0.0218, 'lps'),
	(585834, 129, '2014-03-15 00:31:40.000000', 'consum', 0.0214, 'lps'),
	(585835, 129, '2014-03-15 00:31:41.000000', 'consum', 0.0221, 'lps'),
	(585836, 129, '2014-03-15 00:31:42.000000', 'consum', 0.0211, 'lps'),
	(585837, 129, '2014-03-15 00:31:43.000000', 'consum', 0.0211, 'lps'),
	(585838, 129, '2014-03-15 00:31:44.000000', 'consum', 0.0212, 'lps'),
	(585839, 129, '2014-03-15 00:31:45.000000', 'consum', 0.0219, 'lps'),
	(585840, 129, '2014-03-15 00:31:46.000000', 'consum', 0.0219, 'lps'),
	(585841, 129, '2014-03-15 00:31:47.000000', 'consum', 0.0216, 'lps'),
	(585842, 129, '2014-03-15 00:31:48.000000', 'consum', 0.0212, 'lps'),
	(585843, 129, '2014-03-15 00:31:49.000000', 'consum', 0.0218, 'lps'),
	(585844, 129, '2014-03-15 00:31:50.000000', 'consum', 0.0216, 'lps'),
	(585845, 129, '2014-03-15 00:31:51.000000', 'consum', 0.0216, 'lps'),
	(585846, 129, '2014-03-15 00:31:52.000000', 'consum', 0.0211, 'lps'),
	(585847, 129, '2014-03-15 00:31:53.000000', 'consum', 0.0223, 'lps'),
	(585848, 129, '2014-03-15 00:31:54.000000', 'consum', 0.0219, 'lps'),
	(585849, 129, '2014-03-15 00:31:55.000000', 'consum', 0.0215, 'lps'),
	(585850, 129, '2014-03-15 00:31:56.000000', 'consum', 0.0223, 'lps'),
	(585851, 129, '2014-03-15 00:31:57.000000', 'consum', 0.0217, 'lps'),
	(585852, 129, '2014-03-15 00:31:58.000000', 'consum', 0.0221, 'lps'),
	(585853, 129, '2014-03-15 00:31:59.000000', 'consum', 0.0216, 'lps'),
	(585854, 129, '2014-03-15 00:32:00.000000', 'consum', 0.0223, 'lps'),
	(585855, 129, '2014-03-15 00:32:01.000000', 'consum', 0.0214, 'lps'),
	(585856, 129, '2014-03-15 00:32:02.000000', 'consum', 0.0221, 'lps'),
	(585857, 129, '2014-03-15 00:32:03.000000', 'consum', 0.0210, 'lps'),
	(585858, 129, '2014-03-15 00:32:04.000000', 'consum', 0.0220, 'lps'),
	(585859, 129, '2014-03-15 00:32:05.000000', 'consum', 0.0219, 'lps'),
	(585860, 129, '2014-03-15 00:32:06.000000', 'consum', 0.0213, 'lps'),
	(585861, 129, '2014-03-15 00:32:07.000000', 'consum', 0.0212, 'lps'),
	(585862, 129, '2014-03-15 00:32:08.000000', 'consum', 0.0211, 'lps'),
	(585863, 129, '2014-03-15 00:32:09.000000', 'consum', 0.0222, 'lps'),
	(585864, 129, '2014-03-15 00:32:10.000000', 'consum', 0.0212, 'lps'),
	(585865, 129, '2014-03-15 00:32:11.000000', 'consum', 0.0212, 'lps'),
	(585866, 129, '2014-03-15 00:32:12.000000', 'consum', 0.0215, 'lps'),
	(585867, 129, '2014-03-15 00:32:13.000000', 'consum', 0.0218, 'lps'),
	(585868, 129, '2014-03-15 00:32:14.000000', 'consum', 0.0218, 'lps'),
	(585869, 129, '2014-03-15 00:32:15.000000', 'consum', 0.0215, 'lps'),
	(585870, 129, '2014-03-15 00:32:16.000000', 'consum', 0.0211, 'lps'),
	(585871, 129, '2014-03-15 00:32:17.000000', 'consum', 0.0214, 'lps'),
	(585872, 129, '2014-03-15 00:32:18.000000', 'consum', 0.0213, 'lps'),
	(585873, 129, '2014-03-15 00:32:19.000000', 'consum', 0.0213, 'lps'),
	(585874, 129, '2014-03-15 00:32:20.000000', 'consum', 0.0217, 'lps'),
	(585875, 129, '2014-03-15 00:32:21.000000', 'consum', 0.0222, 'lps'),
	(585876, 129, '2014-03-15 00:32:22.000000', 'consum', 0.0220, 'lps'),
	(585877, 129, '2014-03-15 00:32:23.000000', 'consum', 0.0211, 'lps'),
	(585878, 129, '2014-03-15 00:32:24.000000', 'consum', 0.0214, 'lps'),
	(585879, 129, '2014-03-15 00:32:25.000000', 'consum', 0.0215, 'lps'),
	(585880, 129, '2014-03-15 00:32:26.000000', 'consum', 0.0223, 'lps'),
	(585881, 129, '2014-03-15 00:32:27.000000', 'consum', 0.0218, 'lps'),
	(585882, 129, '2014-03-15 00:32:28.000000', 'consum', 0.0210, 'lps'),
	(585883, 129, '2014-03-15 00:32:29.000000', 'consum', 0.0215, 'lps'),
	(585884, 129, '2014-03-15 00:32:30.000000', 'consum', 0.0221, 'lps'),
	(585885, 129, '2014-03-15 00:32:31.000000', 'consum', 0.0222, 'lps'),
	(585886, 129, '2014-03-15 00:32:32.000000', 'consum', 0.0212, 'lps'),
	(585887, 129, '2014-03-15 00:32:33.000000', 'consum', 0.0211, 'lps'),
	(585888, 129, '2014-03-15 00:32:34.000000', 'consum', 0.0222, 'lps'),
	(585889, 129, '2014-03-15 00:32:35.000000', 'consum', 0.0214, 'lps'),
	(585890, 129, '2014-03-15 00:32:36.000000', 'consum', 0.0221, 'lps'),
	(585891, 129, '2014-03-15 00:32:37.000000', 'consum', 0.0211, 'lps'),
	(585892, 129, '2014-03-15 00:32:38.000000', 'consum', 0.0212, 'lps'),
	(585893, 129, '2014-03-15 00:32:39.000000', 'consum', 0.0218, 'lps'),
	(585894, 129, '2014-03-15 00:32:40.000000', 'consum', 0.0214, 'lps'),
	(585895, 129, '2014-03-15 00:32:41.000000', 'consum', 0.0223, 'lps'),
	(585896, 129, '2014-03-15 00:32:42.000000', 'consum', 0.0220, 'lps'),
	(585897, 129, '2014-03-15 00:32:43.000000', 'consum', 0.0221, 'lps'),
	(585898, 129, '2014-03-15 00:32:44.000000', 'consum', 0.0220, 'lps'),
	(585899, 129, '2014-03-15 00:32:45.000000', 'consum', 0.0217, 'lps'),
	(585900, 129, '2014-03-15 00:32:46.000000', 'consum', 0.0214, 'lps'),
	(585901, 129, '2014-03-15 00:32:47.000000', 'consum', 0.0210, 'lps'),
	(585902, 129, '2014-03-15 00:32:48.000000', 'consum', 0.0210, 'lps'),
	(585903, 129, '2014-03-15 00:32:49.000000', 'consum', 0.0213, 'lps'),
	(585904, 129, '2014-03-15 00:32:50.000000', 'consum', 0.0212, 'lps'),
	(585905, 129, '2014-03-15 00:32:51.000000', 'consum', 0.0210, 'lps'),
	(585906, 129, '2014-03-15 00:32:52.000000', 'consum', 0.0219, 'lps'),
	(585907, 129, '2014-03-15 00:32:53.000000', 'consum', 0.0212, 'lps'),
	(585908, 129, '2014-03-15 00:32:54.000000', 'consum', 0.0222, 'lps'),
	(585909, 129, '2014-03-15 00:32:55.000000', 'consum', 0.0210, 'lps'),
	(585910, 129, '2014-03-15 00:32:56.000000', 'consum', 0.0217, 'lps'),
	(585911, 129, '2014-03-15 00:32:57.000000', 'consum', 0.0216, 'lps'),
	(585912, 129, '2014-03-15 00:32:58.000000', 'consum', 0.0220, 'lps'),
	(585913, 129, '2014-03-15 00:32:59.000000', 'consum', 0.0217, 'lps'),
	(585914, 129, '2014-03-15 00:33:00.000000', 'consum', 0.0212, 'lps'),
	(585915, 129, '2014-03-15 00:33:01.000000', 'consum', 0.0213, 'lps'),
	(585916, 129, '2014-03-15 00:33:02.000000', 'consum', 0.0222, 'lps'),
	(585917, 129, '2014-03-15 00:33:03.000000', 'consum', 0.0218, 'lps'),
	(585918, 129, '2014-03-15 00:33:04.000000', 'consum', 0.0216, 'lps'),
	(585919, 129, '2014-03-15 00:33:05.000000', 'consum', 0.0214, 'lps'),
	(585920, 129, '2014-03-15 00:33:06.000000', 'consum', 0.0214, 'lps'),
	(585921, 129, '2014-03-15 00:33:07.000000', 'consum', 0.0219, 'lps'),
	(585922, 129, '2014-03-15 00:33:08.000000', 'consum', 0.0215, 'lps'),
	(585923, 129, '2014-03-15 00:33:09.000000', 'consum', 0.0222, 'lps'),
	(585924, 129, '2014-03-15 00:33:10.000000', 'consum', 0.0213, 'lps'),
	(585925, 129, '2014-03-15 00:33:11.000000', 'consum', 0.0220, 'lps'),
	(585926, 129, '2014-03-15 00:33:12.000000', 'consum', 0.0220, 'lps'),
	(585927, 129, '2014-03-15 00:33:13.000000', 'consum', 0.0218, 'lps'),
	(585928, 129, '2014-03-15 00:33:14.000000', 'consum', 0.0222, 'lps'),
	(585929, 129, '2014-03-15 00:33:15.000000', 'consum', 0.0216, 'lps'),
	(585930, 129, '2014-03-15 00:33:16.000000', 'consum', 0.0218, 'lps'),
	(585931, 129, '2014-03-15 00:33:17.000000', 'consum', 0.0220, 'lps'),
	(585932, 129, '2014-03-15 00:33:18.000000', 'consum', 0.0223, 'lps'),
	(585933, 129, '2014-03-15 00:33:19.000000', 'consum', 0.0218, 'lps'),
	(585934, 129, '2014-03-15 00:33:20.000000', 'consum', 0.0223, 'lps'),
	(585935, 129, '2014-03-15 00:33:21.000000', 'consum', 0.0223, 'lps'),
	(585936, 129, '2014-03-15 00:33:22.000000', 'consum', 0.0210, 'lps'),
	(585937, 129, '2014-03-15 00:33:23.000000', 'consum', 0.0215, 'lps'),
	(585938, 129, '2014-03-15 00:33:24.000000', 'consum', 0.0220, 'lps'),
	(585939, 129, '2014-03-15 00:33:25.000000', 'consum', 0.0218, 'lps'),
	(585940, 129, '2014-03-15 00:33:26.000000', 'consum', 0.0219, 'lps'),
	(585941, 129, '2014-03-15 00:33:27.000000', 'consum', 0.0217, 'lps'),
	(585942, 129, '2014-03-15 00:33:28.000000', 'consum', 0.0218, 'lps'),
	(585943, 129, '2014-03-15 00:33:29.000000', 'consum', 0.0218, 'lps'),
	(585944, 129, '2014-03-15 00:33:30.000000', 'consum', 0.0211, 'lps'),
	(585945, 129, '2014-03-15 00:33:31.000000', 'consum', 0.0218, 'lps'),
	(585946, 129, '2014-03-15 00:33:32.000000', 'consum', 0.0221, 'lps'),
	(585947, 129, '2014-03-15 00:33:33.000000', 'consum', 0.0214, 'lps'),
	(585948, 129, '2014-03-15 00:33:34.000000', 'consum', 0.0223, 'lps'),
	(585949, 129, '2014-03-15 00:33:35.000000', 'consum', 0.0210, 'lps'),
	(585950, 129, '2014-03-15 00:33:36.000000', 'consum', 0.0215, 'lps'),
	(585951, 129, '2014-03-15 00:33:37.000000', 'consum', 0.0219, 'lps'),
	(585952, 129, '2014-03-15 00:33:38.000000', 'consum', 0.0215, 'lps'),
	(585953, 129, '2014-03-15 00:33:39.000000', 'consum', 0.0220, 'lps'),
	(585954, 129, '2014-03-15 00:33:40.000000', 'consum', 0.0217, 'lps'),
	(585955, 129, '2014-03-15 00:33:41.000000', 'consum', 0.0217, 'lps'),
	(585956, 129, '2014-03-15 00:33:42.000000', 'consum', 0.0211, 'lps'),
	(585957, 129, '2014-03-15 00:33:43.000000', 'consum', 0.0220, 'lps'),
	(585958, 129, '2014-03-15 00:33:44.000000', 'consum', 0.0217, 'lps'),
	(585959, 129, '2014-03-15 00:33:45.000000', 'consum', 0.0214, 'lps'),
	(585960, 129, '2014-03-15 00:33:46.000000', 'consum', 0.0211, 'lps'),
	(585961, 129, '2014-03-15 00:33:47.000000', 'consum', 0.0215, 'lps'),
	(585962, 129, '2014-03-15 00:33:48.000000', 'consum', 0.0221, 'lps'),
	(585963, 129, '2014-03-15 00:33:49.000000', 'consum', 0.0221, 'lps'),
	(585964, 129, '2014-03-15 00:33:50.000000', 'consum', 0.0221, 'lps'),
	(585965, 129, '2014-03-15 00:33:51.000000', 'consum', 0.0218, 'lps'),
	(585966, 129, '2014-03-15 00:33:52.000000', 'consum', 0.0216, 'lps'),
	(585967, 129, '2014-03-15 00:33:53.000000', 'consum', 0.0218, 'lps'),
	(585968, 129, '2014-03-15 00:33:54.000000', 'consum', 0.0218, 'lps'),
	(585969, 129, '2014-03-15 00:33:55.000000', 'consum', 0.0211, 'lps'),
	(585970, 129, '2014-03-15 00:33:56.000000', 'consum', 0.0222, 'lps'),
	(585971, 129, '2014-03-15 00:33:57.000000', 'consum', 0.0210, 'lps'),
	(585972, 129, '2014-03-15 00:33:58.000000', 'consum', 0.0217, 'lps'),
	(585973, 129, '2014-03-15 00:33:59.000000', 'consum', 0.0218, 'lps'),
	(585974, 129, '2014-03-15 00:34:00.000000', 'consum', 0.0213, 'lps'),
	(585975, 129, '2014-03-15 00:34:01.000000', 'consum', 0.0219, 'lps'),
	(585976, 129, '2014-03-15 00:34:02.000000', 'consum', 0.0216, 'lps'),
	(585977, 129, '2014-03-15 00:34:03.000000', 'consum', 0.0214, 'lps'),
	(585978, 129, '2014-03-15 00:34:04.000000', 'consum', 0.0214, 'lps'),
	(585979, 129, '2014-03-15 00:34:05.000000', 'consum', 0.0216, 'lps'),
	(585980, 129, '2014-03-15 00:34:06.000000', 'consum', 0.0218, 'lps'),
	(585981, 129, '2014-03-15 00:34:07.000000', 'consum', 0.0215, 'lps'),
	(585982, 129, '2014-03-15 00:34:08.000000', 'consum', 0.0212, 'lps'),
	(585983, 129, '2014-03-15 00:34:09.000000', 'consum', 0.0219, 'lps'),
	(585984, 129, '2014-03-15 00:34:10.000000', 'consum', 0.0222, 'lps'),
	(585985, 129, '2014-03-15 00:34:11.000000', 'consum', 0.0216, 'lps'),
	(585986, 129, '2014-03-15 00:34:12.000000', 'consum', 0.0217, 'lps'),
	(585987, 129, '2014-03-15 00:34:13.000000', 'consum', 0.0214, 'lps'),
	(585988, 129, '2014-03-15 00:34:14.000000', 'consum', 0.0210, 'lps'),
	(585989, 129, '2014-03-15 00:34:15.000000', 'consum', 0.0213, 'lps'),
	(585990, 129, '2014-03-15 00:34:16.000000', 'consum', 0.0211, 'lps'),
	(585991, 129, '2014-03-15 00:34:17.000000', 'consum', 0.0219, 'lps'),
	(585992, 129, '2014-03-15 00:34:18.000000', 'consum', 0.0212, 'lps'),
	(585993, 129, '2014-03-15 00:34:19.000000', 'consum', 0.0223, 'lps'),
	(585994, 129, '2014-03-15 00:34:20.000000', 'consum', 0.0211, 'lps'),
	(585995, 129, '2014-03-15 00:34:21.000000', 'consum', 0.0217, 'lps'),
	(585996, 129, '2014-03-15 00:34:22.000000', 'consum', 0.0218, 'lps'),
	(585997, 129, '2014-03-15 00:34:23.000000', 'consum', 0.0213, 'lps'),
	(585998, 129, '2014-03-15 00:34:24.000000', 'consum', 0.0218, 'lps'),
	(585999, 129, '2014-03-15 00:34:25.000000', 'consum', 0.0213, 'lps'),
	(586000, 129, '2014-03-15 00:34:26.000000', 'consum', 0.0215, 'lps'),
	(586001, 129, '2014-03-15 00:34:27.000000', 'consum', 0.0212, 'lps'),
	(586002, 129, '2014-03-15 00:34:28.000000', 'consum', 0.0222, 'lps'),
	(586003, 129, '2014-03-15 00:34:29.000000', 'consum', 0.0219, 'lps'),
	(586004, 129, '2014-03-15 00:34:30.000000', 'consum', 0.0221, 'lps'),
	(586005, 129, '2014-03-15 00:34:31.000000', 'consum', 0.0212, 'lps'),
	(586006, 129, '2014-03-15 00:34:32.000000', 'consum', 0.0215, 'lps'),
	(586007, 129, '2014-03-15 00:34:33.000000', 'consum', 0.0215, 'lps'),
	(586008, 129, '2014-03-15 00:34:34.000000', 'consum', 0.0222, 'lps'),
	(586009, 129, '2014-03-15 00:34:35.000000', 'consum', 0.0213, 'lps'),
	(586010, 129, '2014-03-15 00:34:36.000000', 'consum', 0.0218, 'lps'),
	(586011, 129, '2014-03-15 00:34:37.000000', 'consum', 0.0212, 'lps'),
	(586012, 129, '2014-03-15 00:34:38.000000', 'consum', 0.0223, 'lps'),
	(586013, 129, '2014-03-15 00:34:39.000000', 'consum', 0.0216, 'lps'),
	(586014, 129, '2014-03-15 00:34:40.000000', 'consum', 0.0217, 'lps'),
	(586015, 129, '2014-03-15 00:34:41.000000', 'consum', 0.0210, 'lps'),
	(586016, 129, '2014-03-15 00:34:42.000000', 'consum', 0.0220, 'lps'),
	(586017, 129, '2014-03-15 00:34:43.000000', 'consum', 0.0218, 'lps'),
	(586018, 129, '2014-03-15 00:34:44.000000', 'consum', 0.0220, 'lps'),
	(586019, 129, '2014-03-15 00:34:45.000000', 'consum', 0.0221, 'lps'),
	(586020, 129, '2014-03-15 00:34:46.000000', 'consum', 0.0223, 'lps'),
	(586021, 129, '2014-03-15 00:34:47.000000', 'consum', 0.0213, 'lps'),
	(586022, 129, '2014-03-15 00:34:48.000000', 'consum', 0.0217, 'lps'),
	(586023, 129, '2014-03-15 00:34:49.000000', 'consum', 0.0221, 'lps'),
	(586024, 129, '2014-03-15 00:34:50.000000', 'consum', 0.0216, 'lps'),
	(586025, 129, '2014-03-15 00:34:51.000000', 'consum', 0.0220, 'lps'),
	(586026, 129, '2014-03-15 00:34:52.000000', 'consum', 0.0218, 'lps'),
	(586027, 129, '2014-03-15 00:34:53.000000', 'consum', 0.0217, 'lps'),
	(586028, 129, '2014-03-15 00:34:54.000000', 'consum', 0.0210, 'lps'),
	(586029, 129, '2014-03-15 00:34:55.000000', 'consum', 0.0219, 'lps'),
	(586030, 129, '2014-03-15 00:34:56.000000', 'consum', 0.0210, 'lps'),
	(586031, 129, '2014-03-15 00:34:57.000000', 'consum', 0.0214, 'lps'),
	(586032, 129, '2014-03-15 00:34:58.000000', 'consum', 0.0215, 'lps'),
	(586033, 129, '2014-03-15 00:34:59.000000', 'consum', 0.0210, 'lps'),
	(586034, 129, '2014-03-15 00:35:00.000000', 'consum', 0.0211, 'lps'),
	(586035, 129, '2014-03-15 00:35:01.000000', 'consum', 0.0216, 'lps'),
	(586036, 129, '2014-03-15 00:35:02.000000', 'consum', 0.0222, 'lps'),
	(586037, 129, '2014-03-15 00:35:03.000000', 'consum', 0.0211, 'lps'),
	(586038, 129, '2014-03-15 00:35:04.000000', 'consum', 0.0223, 'lps'),
	(586039, 129, '2014-03-15 00:35:05.000000', 'consum', 0.0214, 'lps'),
	(586040, 129, '2014-03-15 00:35:06.000000', 'consum', 0.0220, 'lps'),
	(586041, 129, '2014-03-15 00:35:07.000000', 'consum', 0.0220, 'lps'),
	(586042, 129, '2014-03-15 00:35:08.000000', 'consum', 0.0219, 'lps'),
	(586043, 129, '2014-03-15 00:35:09.000000', 'consum', 0.0210, 'lps'),
	(586044, 129, '2014-03-15 00:35:10.000000', 'consum', 0.0213, 'lps'),
	(586045, 129, '2014-03-15 00:35:11.000000', 'consum', 0.0211, 'lps'),
	(586046, 129, '2014-03-15 00:35:12.000000', 'consum', 0.0219, 'lps'),
	(586047, 129, '2014-03-15 00:35:13.000000', 'consum', 0.0210, 'lps'),
	(586048, 129, '2014-03-15 00:35:14.000000', 'consum', 0.0214, 'lps'),
	(586049, 129, '2014-03-15 00:35:15.000000', 'consum', 0.0215, 'lps'),
	(586050, 129, '2014-03-15 00:35:16.000000', 'consum', 0.0211, 'lps'),
	(586051, 129, '2014-03-15 00:35:17.000000', 'consum', 0.0214, 'lps'),
	(586052, 129, '2014-03-15 00:35:18.000000', 'consum', 0.0213, 'lps'),
	(586053, 129, '2014-03-15 00:35:19.000000', 'consum', 0.0214, 'lps'),
	(586054, 129, '2014-03-15 00:35:20.000000', 'consum', 0.0221, 'lps'),
	(586055, 129, '2014-03-15 00:35:21.000000', 'consum', 0.0213, 'lps'),
	(586056, 129, '2014-03-15 00:35:22.000000', 'consum', 0.0218, 'lps'),
	(586057, 129, '2014-03-15 00:35:23.000000', 'consum', 0.0216, 'lps'),
	(586058, 129, '2014-03-15 00:35:24.000000', 'consum', 0.0217, 'lps'),
	(586059, 129, '2014-03-15 00:35:25.000000', 'consum', 0.0214, 'lps'),
	(586060, 129, '2014-03-15 00:35:26.000000', 'consum', 0.0210, 'lps'),
	(586061, 129, '2014-03-15 00:35:27.000000', 'consum', 0.0212, 'lps'),
	(586062, 129, '2014-03-15 00:35:28.000000', 'consum', 0.0221, 'lps'),
	(586063, 129, '2014-03-15 00:35:29.000000', 'consum', 0.0215, 'lps'),
	(586064, 129, '2014-03-15 00:35:30.000000', 'consum', 0.0217, 'lps'),
	(586065, 129, '2014-03-15 00:35:31.000000', 'consum', 0.0218, 'lps'),
	(586066, 129, '2014-03-15 00:35:32.000000', 'consum', 0.0216, 'lps'),
	(586067, 129, '2014-03-15 00:35:33.000000', 'consum', 0.0216, 'lps'),
	(586068, 129, '2014-03-15 00:35:34.000000', 'consum', 0.0221, 'lps'),
	(586069, 129, '2014-03-15 00:35:35.000000', 'consum', 0.0221, 'lps'),
	(586070, 129, '2014-03-15 00:35:36.000000', 'consum', 0.0216, 'lps'),
	(586071, 129, '2014-03-15 00:35:37.000000', 'consum', 0.0223, 'lps'),
	(586072, 129, '2014-03-15 00:35:38.000000', 'consum', 0.0216, 'lps'),
	(586073, 129, '2014-03-15 00:35:39.000000', 'consum', 0.0216, 'lps'),
	(586074, 129, '2014-03-15 00:35:40.000000', 'consum', 0.0220, 'lps'),
	(586075, 129, '2014-03-15 00:35:41.000000', 'consum', 0.0218, 'lps'),
	(586076, 129, '2014-03-15 00:35:42.000000', 'consum', 0.0218, 'lps'),
	(586077, 129, '2014-03-15 00:35:43.000000', 'consum', 0.0214, 'lps'),
	(586078, 129, '2014-03-15 00:35:44.000000', 'consum', 0.0222, 'lps'),
	(586079, 129, '2014-03-15 00:35:45.000000', 'consum', 0.0214, 'lps'),
	(586080, 129, '2014-03-15 00:35:46.000000', 'consum', 0.0223, 'lps'),
	(586081, 129, '2014-03-15 00:35:47.000000', 'consum', 0.0222, 'lps'),
	(586082, 129, '2014-03-15 00:35:48.000000', 'consum', 0.0219, 'lps'),
	(586083, 129, '2014-03-15 00:35:49.000000', 'consum', 0.0218, 'lps'),
	(586084, 129, '2014-03-15 00:35:50.000000', 'consum', 0.0222, 'lps'),
	(586085, 129, '2014-03-15 00:35:51.000000', 'consum', 0.0218, 'lps'),
	(586086, 129, '2014-03-15 00:35:52.000000', 'consum', 0.0217, 'lps'),
	(586087, 129, '2014-03-15 00:35:53.000000', 'consum', 0.0221, 'lps'),
	(586088, 129, '2014-03-15 00:35:54.000000', 'consum', 0.0217, 'lps'),
	(586089, 129, '2014-03-15 00:35:55.000000', 'consum', 0.0213, 'lps'),
	(586090, 129, '2014-03-15 00:35:56.000000', 'consum', 0.0218, 'lps'),
	(586091, 129, '2014-03-15 00:35:57.000000', 'consum', 0.0213, 'lps'),
	(586092, 129, '2014-03-15 00:35:58.000000', 'consum', 0.0216, 'lps'),
	(586093, 129, '2014-03-15 00:35:59.000000', 'consum', 0.0216, 'lps'),
	(586094, 129, '2014-03-15 00:36:00.000000', 'consum', 0.0211, 'lps'),
	(586095, 129, '2014-03-15 00:36:01.000000', 'consum', 0.0210, 'lps'),
	(586096, 129, '2014-03-15 00:36:02.000000', 'consum', 0.0221, 'lps'),
	(586097, 129, '2014-03-15 00:36:03.000000', 'consum', 0.0223, 'lps'),
	(586098, 129, '2014-03-15 00:36:04.000000', 'consum', 0.0215, 'lps'),
	(586099, 129, '2014-03-15 00:36:05.000000', 'consum', 0.0211, 'lps'),
	(586100, 129, '2014-03-15 00:36:06.000000', 'consum', 0.0214, 'lps'),
	(586101, 129, '2014-03-15 00:36:07.000000', 'consum', 0.0215, 'lps'),
	(586102, 129, '2014-03-15 00:36:08.000000', 'consum', 0.0210, 'lps'),
	(586103, 129, '2014-03-15 00:36:09.000000', 'consum', 0.0210, 'lps'),
	(586104, 129, '2014-03-15 00:36:10.000000', 'consum', 0.0212, 'lps'),
	(586105, 129, '2014-03-15 00:36:11.000000', 'consum', 0.0217, 'lps'),
	(586106, 129, '2014-03-15 00:36:12.000000', 'consum', 0.0212, 'lps'),
	(586107, 129, '2014-03-15 00:36:13.000000', 'consum', 0.0214, 'lps'),
	(586108, 129, '2014-03-15 00:36:14.000000', 'consum', 0.0212, 'lps'),
	(586109, 129, '2014-03-15 00:36:15.000000', 'consum', 0.0221, 'lps'),
	(586110, 129, '2014-03-15 00:36:16.000000', 'consum', 0.0216, 'lps'),
	(586111, 129, '2014-03-15 00:36:17.000000', 'consum', 0.0210, 'lps'),
	(586112, 129, '2014-03-15 00:36:18.000000', 'consum', 0.0220, 'lps'),
	(586113, 129, '2014-03-15 00:36:19.000000', 'consum', 0.0217, 'lps'),
	(586114, 129, '2014-03-15 00:36:20.000000', 'consum', 0.0216, 'lps'),
	(586115, 129, '2014-03-15 00:36:21.000000', 'consum', 0.0219, 'lps'),
	(586116, 129, '2014-03-15 00:36:22.000000', 'consum', 0.0211, 'lps'),
	(586117, 129, '2014-03-15 00:36:23.000000', 'consum', 0.0218, 'lps'),
	(586118, 129, '2014-03-15 00:36:24.000000', 'consum', 0.0217, 'lps'),
	(586119, 129, '2014-03-15 00:36:25.000000', 'consum', 0.0222, 'lps'),
	(586120, 129, '2014-03-15 00:36:26.000000', 'consum', 0.0220, 'lps'),
	(586121, 129, '2014-03-15 00:36:27.000000', 'consum', 0.0211, 'lps'),
	(586122, 129, '2014-03-15 00:36:28.000000', 'consum', 0.0214, 'lps'),
	(586123, 129, '2014-03-15 00:36:29.000000', 'consum', 0.0214, 'lps'),
	(586124, 129, '2014-03-15 00:36:30.000000', 'consum', 0.0220, 'lps'),
	(586125, 129, '2014-03-15 00:36:31.000000', 'consum', 0.0217, 'lps'),
	(586126, 129, '2014-03-15 00:36:32.000000', 'consum', 0.0219, 'lps'),
	(586127, 129, '2014-03-15 00:36:33.000000', 'consum', 0.0219, 'lps'),
	(586128, 129, '2014-03-15 00:36:34.000000', 'consum', 0.0214, 'lps'),
	(586129, 129, '2014-03-15 00:36:35.000000', 'consum', 0.0217, 'lps'),
	(586130, 129, '2014-03-15 00:36:36.000000', 'consum', 0.0222, 'lps'),
	(586131, 129, '2014-03-15 00:36:37.000000', 'consum', 0.0218, 'lps'),
	(586132, 129, '2014-03-15 00:36:38.000000', 'consum', 0.0216, 'lps'),
	(586133, 129, '2014-03-15 00:36:39.000000', 'consum', 0.0218, 'lps'),
	(586134, 129, '2014-03-15 00:36:40.000000', 'consum', 0.0218, 'lps'),
	(586135, 129, '2014-03-15 00:36:41.000000', 'consum', 0.0214, 'lps'),
	(586136, 129, '2014-03-15 00:36:42.000000', 'consum', 0.0219, 'lps'),
	(586137, 129, '2014-03-15 00:36:43.000000', 'consum', 0.0214, 'lps'),
	(586138, 129, '2014-03-15 00:36:44.000000', 'consum', 0.0219, 'lps'),
	(586139, 129, '2014-03-15 00:36:45.000000', 'consum', 0.0214, 'lps'),
	(586140, 129, '2014-03-15 00:36:46.000000', 'consum', 0.0218, 'lps'),
	(586141, 129, '2014-03-15 00:36:47.000000', 'consum', 0.0212, 'lps'),
	(586142, 129, '2014-03-15 00:36:48.000000', 'consum', 0.0211, 'lps'),
	(586143, 129, '2014-03-15 00:36:49.000000', 'consum', 0.0220, 'lps'),
	(586144, 129, '2014-03-15 00:36:50.000000', 'consum', 0.0219, 'lps'),
	(586145, 129, '2014-03-15 00:36:51.000000', 'consum', 0.0211, 'lps'),
	(586146, 129, '2014-03-15 00:36:52.000000', 'consum', 0.0214, 'lps'),
	(586147, 129, '2014-03-15 00:36:53.000000', 'consum', 0.0215, 'lps'),
	(586148, 129, '2014-03-15 00:36:54.000000', 'consum', 0.0211, 'lps'),
	(586149, 129, '2014-03-15 00:36:55.000000', 'consum', 0.0215, 'lps'),
	(586150, 129, '2014-03-15 00:36:56.000000', 'consum', 0.0218, 'lps'),
	(586151, 129, '2014-03-15 00:36:57.000000', 'consum', 0.0223, 'lps'),
	(586152, 129, '2014-03-15 00:36:58.000000', 'consum', 0.0223, 'lps'),
	(586153, 129, '2014-03-15 00:36:59.000000', 'consum', 0.0221, 'lps'),
	(586154, 129, '2014-03-15 00:37:00.000000', 'consum', 0.0211, 'lps'),
	(586155, 129, '2014-03-15 00:37:01.000000', 'consum', 0.0214, 'lps'),
	(586156, 129, '2014-03-15 00:37:02.000000', 'consum', 0.0212, 'lps'),
	(586157, 129, '2014-03-15 00:37:03.000000', 'consum', 0.0223, 'lps'),
	(586158, 129, '2014-03-15 00:37:04.000000', 'consum', 0.0212, 'lps'),
	(586159, 129, '2014-03-15 00:37:05.000000', 'consum', 0.0212, 'lps'),
	(586160, 129, '2014-03-15 00:37:06.000000', 'consum', 0.0215, 'lps'),
	(586161, 129, '2014-03-15 00:37:07.000000', 'consum', 0.0216, 'lps'),
	(586162, 129, '2014-03-15 00:37:08.000000', 'consum', 0.0211, 'lps'),
	(586163, 129, '2014-03-15 00:37:09.000000', 'consum', 0.0211, 'lps'),
	(586164, 129, '2014-03-15 00:37:10.000000', 'consum', 0.0212, 'lps'),
	(586165, 129, '2014-03-15 00:37:11.000000', 'consum', 0.0219, 'lps'),
	(586166, 129, '2014-03-15 00:37:12.000000', 'consum', 0.0220, 'lps'),
	(586167, 129, '2014-03-15 00:37:13.000000', 'consum', 0.0222, 'lps'),
	(586168, 129, '2014-03-15 00:37:14.000000', 'consum', 0.0211, 'lps'),
	(586169, 129, '2014-03-15 00:37:15.000000', 'consum', 0.0222, 'lps'),
	(586170, 129, '2014-03-15 00:37:16.000000', 'consum', 0.0213, 'lps'),
	(586171, 129, '2014-03-15 00:37:17.000000', 'consum', 0.0217, 'lps'),
	(586172, 129, '2014-03-15 00:37:18.000000', 'consum', 0.0222, 'lps'),
	(586173, 129, '2014-03-15 00:37:19.000000', 'consum', 0.0223, 'lps'),
	(586174, 129, '2014-03-15 00:37:20.000000', 'consum', 0.0223, 'lps'),
	(586175, 129, '2014-03-15 00:37:21.000000', 'consum', 0.0223, 'lps'),
	(586176, 129, '2014-03-15 00:37:22.000000', 'consum', 0.0223, 'lps'),
	(586177, 129, '2014-03-15 00:37:23.000000', 'consum', 0.0222, 'lps'),
	(586178, 129, '2014-03-15 00:37:24.000000', 'consum', 0.0218, 'lps'),
	(586179, 129, '2014-03-15 00:37:25.000000', 'consum', 0.0216, 'lps'),
	(586180, 129, '2014-03-15 00:37:26.000000', 'consum', 0.0214, 'lps'),
	(586181, 129, '2014-03-15 00:37:27.000000', 'consum', 0.0213, 'lps'),
	(586182, 129, '2014-03-15 00:37:28.000000', 'consum', 0.0214, 'lps'),
	(586183, 129, '2014-03-15 00:37:29.000000', 'consum', 0.0222, 'lps'),
	(586184, 129, '2014-03-15 00:37:30.000000', 'consum', 0.0217, 'lps'),
	(586185, 129, '2014-03-15 00:37:31.000000', 'consum', 0.0223, 'lps'),
	(586186, 129, '2014-03-15 00:37:32.000000', 'consum', 0.0212, 'lps'),
	(586187, 129, '2014-03-15 00:37:33.000000', 'consum', 0.0211, 'lps'),
	(586188, 129, '2014-03-15 00:37:34.000000', 'consum', 0.0221, 'lps'),
	(586189, 129, '2014-03-15 00:37:35.000000', 'consum', 0.0220, 'lps'),
	(586190, 129, '2014-03-15 00:37:36.000000', 'consum', 0.0214, 'lps'),
	(586191, 129, '2014-03-15 00:37:37.000000', 'consum', 0.0217, 'lps'),
	(586192, 129, '2014-03-15 00:37:38.000000', 'consum', 0.0217, 'lps'),
	(586193, 129, '2014-03-15 00:37:39.000000', 'consum', 0.0210, 'lps'),
	(586194, 129, '2014-03-15 00:37:40.000000', 'consum', 0.0216, 'lps'),
	(586195, 129, '2014-03-15 00:37:41.000000', 'consum', 0.0216, 'lps'),
	(586196, 129, '2014-03-15 00:37:42.000000', 'consum', 0.0220, 'lps'),
	(586197, 129, '2014-03-15 00:37:43.000000', 'consum', 0.0217, 'lps'),
	(586198, 129, '2014-03-15 00:37:44.000000', 'consum', 0.0216, 'lps'),
	(586199, 129, '2014-03-15 00:37:45.000000', 'consum', 0.0217, 'lps'),
	(586200, 129, '2014-03-15 00:37:46.000000', 'consum', 0.0216, 'lps'),
	(586201, 129, '2014-03-15 00:37:47.000000', 'consum', 0.0218, 'lps'),
	(586202, 129, '2014-03-15 00:37:48.000000', 'consum', 0.0217, 'lps'),
	(586203, 129, '2014-03-15 00:37:49.000000', 'consum', 0.0221, 'lps'),
	(586204, 129, '2014-03-15 00:37:50.000000', 'consum', 0.0220, 'lps'),
	(586205, 129, '2014-03-15 00:37:51.000000', 'consum', 0.0210, 'lps'),
	(586206, 129, '2014-03-15 00:37:52.000000', 'consum', 0.0223, 'lps'),
	(586207, 129, '2014-03-15 00:37:53.000000', 'consum', 0.0221, 'lps'),
	(586208, 129, '2014-03-15 00:37:54.000000', 'consum', 0.0210, 'lps'),
	(586209, 129, '2014-03-15 00:37:55.000000', 'consum', 0.0220, 'lps'),
	(586210, 129, '2014-03-15 00:37:56.000000', 'consum', 0.0219, 'lps'),
	(586211, 129, '2014-03-15 00:37:57.000000', 'consum', 0.0212, 'lps'),
	(586212, 129, '2014-03-15 00:37:58.000000', 'consum', 0.0222, 'lps'),
	(586213, 129, '2014-03-15 00:37:59.000000', 'consum', 0.0221, 'lps'),
	(586214, 129, '2014-03-15 00:38:00.000000', 'consum', 0.0218, 'lps'),
	(586215, 129, '2014-03-15 00:38:01.000000', 'consum', 0.0216, 'lps'),
	(586216, 129, '2014-03-15 00:38:02.000000', 'consum', 0.0217, 'lps'),
	(586217, 129, '2014-03-15 00:38:03.000000', 'consum', 0.0215, 'lps'),
	(586218, 129, '2014-03-15 00:38:04.000000', 'consum', 0.0211, 'lps'),
	(586219, 129, '2014-03-15 00:38:05.000000', 'consum', 0.0217, 'lps'),
	(586220, 129, '2014-03-15 00:38:06.000000', 'consum', 0.0213, 'lps'),
	(586221, 129, '2014-03-15 00:38:07.000000', 'consum', 0.0219, 'lps'),
	(586222, 129, '2014-03-15 00:38:08.000000', 'consum', 0.0218, 'lps'),
	(586223, 129, '2014-03-15 00:38:09.000000', 'consum', 0.0210, 'lps'),
	(586224, 129, '2014-03-15 00:38:10.000000', 'consum', 0.0213, 'lps'),
	(586225, 129, '2014-03-15 00:38:11.000000', 'consum', 0.0210, 'lps'),
	(586226, 129, '2014-03-15 00:38:12.000000', 'consum', 0.0219, 'lps'),
	(586227, 129, '2014-03-15 00:38:13.000000', 'consum', 0.0213, 'lps'),
	(586228, 129, '2014-03-15 00:38:14.000000', 'consum', 0.0211, 'lps'),
	(586229, 129, '2014-03-15 00:38:15.000000', 'consum', 0.0221, 'lps'),
	(586230, 129, '2014-03-15 00:38:16.000000', 'consum', 0.0219, 'lps'),
	(586231, 129, '2014-03-15 00:38:17.000000', 'consum', 0.0211, 'lps'),
	(586232, 129, '2014-03-15 00:38:18.000000', 'consum', 0.0214, 'lps'),
	(586233, 129, '2014-03-15 00:38:19.000000', 'consum', 0.0215, 'lps'),
	(586234, 129, '2014-03-15 00:38:20.000000', 'consum', 0.0210, 'lps'),
	(586235, 129, '2014-03-15 00:38:21.000000', 'consum', 0.0210, 'lps'),
	(586236, 129, '2014-03-15 00:38:22.000000', 'consum', 0.0223, 'lps'),
	(586237, 129, '2014-03-15 00:38:23.000000', 'consum', 0.0219, 'lps'),
	(586238, 129, '2014-03-15 00:38:24.000000', 'consum', 0.0217, 'lps'),
	(586239, 129, '2014-03-15 00:38:25.000000', 'consum', 0.0221, 'lps'),
	(586240, 129, '2014-03-15 00:38:26.000000', 'consum', 0.0213, 'lps'),
	(586241, 129, '2014-03-15 00:38:27.000000', 'consum', 0.0221, 'lps'),
	(586242, 129, '2014-03-15 00:38:28.000000', 'consum', 0.0217, 'lps'),
	(586243, 129, '2014-03-15 00:38:29.000000', 'consum', 0.0223, 'lps'),
	(586244, 129, '2014-03-15 00:38:30.000000', 'consum', 0.0215, 'lps'),
	(586245, 129, '2014-03-15 00:38:31.000000', 'consum', 0.0210, 'lps'),
	(586246, 129, '2014-03-15 00:38:32.000000', 'consum', 0.0210, 'lps'),
	(586247, 129, '2014-03-15 00:38:33.000000', 'consum', 0.0222, 'lps'),
	(586248, 129, '2014-03-15 00:38:34.000000', 'consum', 0.0216, 'lps'),
	(586249, 129, '2014-03-15 00:38:35.000000', 'consum', 0.0219, 'lps'),
	(586250, 129, '2014-03-15 00:38:36.000000', 'consum', 0.0211, 'lps'),
	(586251, 129, '2014-03-15 00:38:37.000000', 'consum', 0.0214, 'lps'),
	(586252, 129, '2014-03-15 00:38:38.000000', 'consum', 0.0212, 'lps'),
	(586253, 129, '2014-03-15 00:38:39.000000', 'consum', 0.0212, 'lps'),
	(586254, 129, '2014-03-15 00:38:40.000000', 'consum', 0.0211, 'lps'),
	(586255, 129, '2014-03-15 00:38:41.000000', 'consum', 0.0211, 'lps'),
	(586256, 129, '2014-03-15 00:38:42.000000', 'consum', 0.0214, 'lps'),
	(586257, 129, '2014-03-15 00:38:43.000000', 'consum', 0.0211, 'lps'),
	(586258, 129, '2014-03-15 00:38:44.000000', 'consum', 0.0218, 'lps'),
	(586259, 129, '2014-03-15 00:38:45.000000', 'consum', 0.0220, 'lps'),
	(586260, 129, '2014-03-15 00:38:46.000000', 'consum', 0.0222, 'lps'),
	(586261, 129, '2014-03-15 00:38:47.000000', 'consum', 0.0212, 'lps'),
	(586262, 129, '2014-03-15 00:38:48.000000', 'consum', 0.0211, 'lps'),
	(586263, 129, '2014-03-15 00:38:49.000000', 'consum', 0.0211, 'lps'),
	(586264, 129, '2014-03-15 00:38:50.000000', 'consum', 0.0212, 'lps'),
	(586265, 129, '2014-03-15 00:38:51.000000', 'consum', 0.0218, 'lps'),
	(586266, 129, '2014-03-15 00:38:52.000000', 'consum', 0.0215, 'lps'),
	(586267, 129, '2014-03-15 00:38:53.000000', 'consum', 0.0213, 'lps'),
	(586268, 129, '2014-03-15 00:38:54.000000', 'consum', 0.0212, 'lps'),
	(586269, 129, '2014-03-15 00:38:55.000000', 'consum', 0.0223, 'lps'),
	(586270, 129, '2014-03-15 00:38:56.000000', 'consum', 0.0216, 'lps'),
	(586271, 129, '2014-03-15 00:38:57.000000', 'consum', 0.0216, 'lps'),
	(586272, 129, '2014-03-15 00:38:58.000000', 'consum', 0.0221, 'lps'),
	(586273, 129, '2014-03-15 00:38:59.000000', 'consum', 0.0221, 'lps'),
	(586274, 129, '2014-03-15 00:39:00.000000', 'consum', 0.0216, 'lps'),
	(586275, 129, '2014-03-15 00:39:01.000000', 'consum', 0.0222, 'lps'),
	(586276, 129, '2014-03-15 00:39:02.000000', 'consum', 0.0212, 'lps'),
	(586277, 129, '2014-03-15 00:39:03.000000', 'consum', 0.0212, 'lps'),
	(586278, 129, '2014-03-15 00:39:04.000000', 'consum', 0.0216, 'lps'),
	(586279, 129, '2014-03-15 00:39:05.000000', 'consum', 0.0218, 'lps'),
	(586280, 129, '2014-03-15 00:39:06.000000', 'consum', 0.0221, 'lps'),
	(586281, 129, '2014-03-15 00:39:07.000000', 'consum', 0.0213, 'lps'),
	(586282, 129, '2014-03-15 00:39:08.000000', 'consum', 0.0222, 'lps'),
	(586283, 129, '2014-03-15 00:39:09.000000', 'consum', 0.0217, 'lps'),
	(586284, 129, '2014-03-15 00:39:10.000000', 'consum', 0.0212, 'lps'),
	(586285, 129, '2014-03-15 00:39:11.000000', 'consum', 0.0211, 'lps'),
	(586286, 129, '2014-03-15 00:39:12.000000', 'consum', 0.0212, 'lps'),
	(586287, 129, '2014-03-15 00:39:13.000000', 'consum', 0.0215, 'lps'),
	(586288, 129, '2014-03-15 00:39:14.000000', 'consum', 0.0215, 'lps'),
	(586289, 129, '2014-03-15 00:39:15.000000', 'consum', 0.0221, 'lps'),
	(586290, 129, '2014-03-15 00:39:16.000000', 'consum', 0.0210, 'lps'),
	(586291, 129, '2014-03-15 00:39:17.000000', 'consum', 0.0220, 'lps'),
	(586292, 129, '2014-03-15 00:39:18.000000', 'consum', 0.0217, 'lps'),
	(586293, 129, '2014-03-15 00:39:19.000000', 'consum', 0.0215, 'lps'),
	(586294, 129, '2014-03-15 00:39:20.000000', 'consum', 0.0213, 'lps'),
	(586295, 129, '2014-03-15 00:39:21.000000', 'consum', 0.0213, 'lps'),
	(586296, 129, '2014-03-15 00:39:22.000000', 'consum', 0.0216, 'lps'),
	(586297, 129, '2014-03-15 00:39:23.000000', 'consum', 0.0218, 'lps'),
	(586298, 129, '2014-03-15 00:39:24.000000', 'consum', 0.0220, 'lps'),
	(586299, 129, '2014-03-15 00:39:25.000000', 'consum', 0.0220, 'lps'),
	(586300, 129, '2014-03-15 00:39:26.000000', 'consum', 0.0215, 'lps'),
	(586301, 129, '2014-03-15 00:39:27.000000', 'consum', 0.0222, 'lps'),
	(586302, 129, '2014-03-15 00:39:28.000000', 'consum', 0.0215, 'lps'),
	(586303, 129, '2014-03-15 00:39:29.000000', 'consum', 0.0212, 'lps'),
	(586304, 129, '2014-03-15 00:39:30.000000', 'consum', 0.0219, 'lps'),
	(586305, 129, '2014-03-15 00:39:31.000000', 'consum', 0.0223, 'lps'),
	(586306, 129, '2014-03-15 00:39:32.000000', 'consum', 0.0219, 'lps'),
	(586307, 129, '2014-03-15 00:39:33.000000', 'consum', 0.0218, 'lps'),
	(586308, 129, '2014-03-15 00:39:34.000000', 'consum', 0.0221, 'lps'),
	(586309, 129, '2014-03-15 00:39:35.000000', 'consum', 0.0213, 'lps'),
	(586310, 129, '2014-03-15 00:39:36.000000', 'consum', 0.0223, 'lps'),
	(586311, 129, '2014-03-15 00:39:37.000000', 'consum', 0.0223, 'lps'),
	(586312, 129, '2014-03-15 00:39:38.000000', 'consum', 0.0222, 'lps'),
	(586313, 129, '2014-03-15 00:39:39.000000', 'consum', 0.0218, 'lps'),
	(586314, 129, '2014-03-15 00:39:40.000000', 'consum', 0.0216, 'lps'),
	(586315, 129, '2014-03-15 00:39:41.000000', 'consum', 0.0216, 'lps'),
	(586316, 129, '2014-03-15 00:39:42.000000', 'consum', 0.0221, 'lps'),
	(586317, 129, '2014-03-15 00:39:43.000000', 'consum', 0.0221, 'lps'),
	(586318, 129, '2014-03-15 00:39:44.000000', 'consum', 0.0217, 'lps'),
	(586319, 129, '2014-03-15 00:39:45.000000', 'consum', 0.0212, 'lps'),
	(586320, 129, '2014-03-15 00:39:46.000000', 'consum', 0.0216, 'lps'),
	(586321, 129, '2014-03-15 00:39:47.000000', 'consum', 0.0220, 'lps'),
	(586322, 129, '2014-03-15 00:39:48.000000', 'consum', 0.0215, 'lps'),
	(586323, 129, '2014-03-15 00:39:49.000000', 'consum', 0.0218, 'lps'),
	(586324, 129, '2014-03-15 00:39:50.000000', 'consum', 0.0221, 'lps'),
	(586325, 129, '2014-03-15 00:39:51.000000', 'consum', 0.0215, 'lps'),
	(586326, 129, '2014-03-15 00:39:52.000000', 'consum', 0.0216, 'lps'),
	(586327, 129, '2014-03-15 00:39:53.000000', 'consum', 0.0211, 'lps'),
	(586328, 129, '2014-03-15 00:39:54.000000', 'consum', 0.0210, 'lps'),
	(586329, 129, '2014-03-15 00:39:55.000000', 'consum', 0.0222, 'lps'),
	(586330, 129, '2014-03-15 00:39:56.000000', 'consum', 0.0216, 'lps'),
	(586331, 129, '2014-03-15 00:39:57.000000', 'consum', 0.0220, 'lps'),
	(586332, 129, '2014-03-15 00:39:58.000000', 'consum', 0.0213, 'lps'),
	(586333, 129, '2014-03-15 00:39:59.000000', 'consum', 0.0221, 'lps'),
	(586334, 129, '2014-03-15 00:40:00.000000', 'consum', 0.0218, 'lps'),
	(586335, 129, '2014-03-15 00:40:01.000000', 'consum', 0.0217, 'lps'),
	(586336, 129, '2014-03-15 00:40:02.000000', 'consum', 0.0219, 'lps'),
	(586337, 129, '2014-03-15 00:40:03.000000', 'consum', 0.0223, 'lps'),
	(586338, 129, '2014-03-15 00:40:04.000000', 'consum', 0.0221, 'lps'),
	(586339, 129, '2014-03-15 00:40:05.000000', 'consum', 0.0213, 'lps'),
	(586340, 129, '2014-03-15 00:40:06.000000', 'consum', 0.0220, 'lps'),
	(586341, 129, '2014-03-15 00:40:07.000000', 'consum', 0.0221, 'lps'),
	(586342, 129, '2014-03-15 00:40:08.000000', 'consum', 0.0211, 'lps'),
	(586343, 129, '2014-03-15 00:40:09.000000', 'consum', 0.0221, 'lps'),
	(586344, 129, '2014-03-15 00:40:10.000000', 'consum', 0.0210, 'lps'),
	(586345, 129, '2014-03-15 00:40:11.000000', 'consum', 0.0218, 'lps'),
	(586346, 129, '2014-03-15 00:40:12.000000', 'consum', 0.0222, 'lps'),
	(586347, 129, '2014-03-15 00:40:13.000000', 'consum', 0.0219, 'lps'),
	(586348, 129, '2014-03-15 00:40:14.000000', 'consum', 0.0220, 'lps'),
	(586349, 129, '2014-03-15 00:40:15.000000', 'consum', 0.0218, 'lps'),
	(586350, 129, '2014-03-15 00:40:16.000000', 'consum', 0.0221, 'lps'),
	(586351, 129, '2014-03-15 00:40:17.000000', 'consum', 0.0213, 'lps'),
	(586352, 129, '2014-03-15 00:40:18.000000', 'consum', 0.0221, 'lps'),
	(586353, 129, '2014-03-15 00:40:19.000000', 'consum', 0.0215, 'lps'),
	(586354, 129, '2014-03-15 00:40:20.000000', 'consum', 0.0215, 'lps'),
	(586355, 129, '2014-03-15 00:40:21.000000', 'consum', 0.0221, 'lps'),
	(586356, 129, '2014-03-15 00:40:22.000000', 'consum', 0.0221, 'lps'),
	(586357, 129, '2014-03-15 00:40:23.000000', 'consum', 0.0219, 'lps'),
	(586358, 129, '2014-03-15 00:40:24.000000', 'consum', 0.0223, 'lps'),
	(586359, 129, '2014-03-15 00:40:25.000000', 'consum', 0.0220, 'lps'),
	(586360, 129, '2014-03-15 00:40:26.000000', 'consum', 0.0220, 'lps'),
	(586361, 129, '2014-03-15 00:40:27.000000', 'consum', 0.0218, 'lps'),
	(586362, 129, '2014-03-15 00:40:28.000000', 'consum', 0.0219, 'lps'),
	(586363, 129, '2014-03-15 00:40:29.000000', 'consum', 0.0219, 'lps'),
	(586364, 129, '2014-03-15 00:40:30.000000', 'consum', 0.0215, 'lps'),
	(586365, 129, '2014-03-15 00:40:31.000000', 'consum', 0.0220, 'lps'),
	(586366, 129, '2014-03-15 00:40:32.000000', 'consum', 0.0220, 'lps'),
	(586367, 129, '2014-03-15 00:40:33.000000', 'consum', 0.0215, 'lps'),
	(586368, 129, '2014-03-15 00:40:34.000000', 'consum', 0.0221, 'lps'),
	(586369, 129, '2014-03-15 00:40:35.000000', 'consum', 0.0220, 'lps'),
	(586370, 129, '2014-03-15 00:40:36.000000', 'consum', 0.0214, 'lps'),
	(586371, 129, '2014-03-15 00:40:37.000000', 'consum', 0.0216, 'lps'),
	(586372, 129, '2014-03-15 00:40:38.000000', 'consum', 0.0214, 'lps'),
	(586373, 129, '2014-03-15 00:40:39.000000', 'consum', 0.0214, 'lps'),
	(586374, 129, '2014-03-15 00:40:40.000000', 'consum', 0.0216, 'lps'),
	(586375, 129, '2014-03-15 00:40:41.000000', 'consum', 0.0215, 'lps'),
	(586376, 129, '2014-03-15 00:40:42.000000', 'consum', 0.0217, 'lps'),
	(586377, 129, '2014-03-15 00:40:43.000000', 'consum', 0.0216, 'lps'),
	(586378, 129, '2014-03-15 00:40:44.000000', 'consum', 0.0222, 'lps'),
	(586379, 129, '2014-03-15 00:40:45.000000', 'consum', 0.0210, 'lps'),
	(586380, 129, '2014-03-15 00:40:46.000000', 'consum', 0.0214, 'lps'),
	(586381, 129, '2014-03-15 00:40:47.000000', 'consum', 0.0219, 'lps'),
	(586382, 129, '2014-03-15 00:40:48.000000', 'consum', 0.0213, 'lps'),
	(586383, 129, '2014-03-15 00:40:49.000000', 'consum', 0.0214, 'lps'),
	(586384, 129, '2014-03-15 00:40:50.000000', 'consum', 0.0219, 'lps'),
	(586385, 129, '2014-03-15 00:40:51.000000', 'consum', 0.0219, 'lps'),
	(586386, 129, '2014-03-15 00:40:52.000000', 'consum', 0.0213, 'lps'),
	(586387, 129, '2014-03-15 00:40:53.000000', 'consum', 0.0213, 'lps'),
	(586388, 129, '2014-03-15 00:40:54.000000', 'consum', 0.0215, 'lps'),
	(586389, 129, '2014-03-15 00:40:55.000000', 'consum', 0.0212, 'lps'),
	(586390, 129, '2014-03-15 00:40:56.000000', 'consum', 0.0222, 'lps'),
	(586391, 129, '2014-03-15 00:40:57.000000', 'consum', 0.0222, 'lps'),
	(586392, 129, '2014-03-15 00:40:58.000000', 'consum', 0.0219, 'lps'),
	(586393, 129, '2014-03-15 00:40:59.000000', 'consum', 0.0219, 'lps'),
	(586394, 129, '2014-03-15 00:41:00.000000', 'consum', 0.0216, 'lps'),
	(586395, 129, '2014-03-15 00:41:01.000000', 'consum', 0.0215, 'lps'),
	(586396, 129, '2014-03-15 00:41:02.000000', 'consum', 0.0214, 'lps'),
	(586397, 129, '2014-03-15 00:41:03.000000', 'consum', 0.0219, 'lps'),
	(586398, 129, '2014-03-15 00:41:04.000000', 'consum', 0.0214, 'lps'),
	(586399, 129, '2014-03-15 00:41:05.000000', 'consum', 0.0217, 'lps'),
	(586400, 129, '2014-03-15 00:41:06.000000', 'consum', 0.0219, 'lps'),
	(586401, 129, '2014-03-15 00:41:07.000000', 'consum', 0.0223, 'lps'),
	(586402, 129, '2014-03-15 00:41:08.000000', 'consum', 0.0218, 'lps'),
	(586403, 129, '2014-03-15 00:41:09.000000', 'consum', 0.0212, 'lps'),
	(586404, 129, '2014-03-15 00:41:10.000000', 'consum', 0.0212, 'lps'),
	(586405, 129, '2014-03-15 00:41:11.000000', 'consum', 0.0214, 'lps'),
	(586406, 129, '2014-03-15 00:41:12.000000', 'consum', 0.0211, 'lps'),
	(586407, 129, '2014-03-15 00:41:13.000000', 'consum', 0.0215, 'lps'),
	(586408, 129, '2014-03-15 00:41:14.000000', 'consum', 0.0222, 'lps'),
	(586409, 129, '2014-03-15 00:41:15.000000', 'consum', 0.0212, 'lps'),
	(586410, 129, '2014-03-15 00:41:16.000000', 'consum', 0.0212, 'lps'),
	(586411, 129, '2014-03-15 00:41:17.000000', 'consum', 0.0214, 'lps'),
	(586412, 129, '2014-03-15 00:41:18.000000', 'consum', 0.0211, 'lps'),
	(586413, 129, '2014-03-15 00:41:19.000000', 'consum', 0.0217, 'lps'),
	(586414, 129, '2014-03-15 00:41:20.000000', 'consum', 0.0214, 'lps'),
	(586415, 129, '2014-03-15 00:41:21.000000', 'consum', 0.0211, 'lps'),
	(586416, 129, '2014-03-15 00:41:22.000000', 'consum', 0.0216, 'lps'),
	(586417, 129, '2014-03-15 00:41:23.000000', 'consum', 0.0212, 'lps'),
	(586418, 129, '2014-03-15 00:41:24.000000', 'consum', 0.0216, 'lps'),
	(586419, 129, '2014-03-15 00:41:25.000000', 'consum', 0.0220, 'lps'),
	(586420, 129, '2014-03-15 00:41:26.000000', 'consum', 0.0216, 'lps'),
	(586421, 129, '2014-03-15 00:41:27.000000', 'consum', 0.0223, 'lps'),
	(586422, 129, '2014-03-15 00:41:28.000000', 'consum', 0.0214, 'lps'),
	(586423, 129, '2014-03-15 00:41:29.000000', 'consum', 0.0223, 'lps'),
	(586424, 129, '2014-03-15 00:41:30.000000', 'consum', 0.0219, 'lps'),
	(586425, 129, '2014-03-15 00:41:31.000000', 'consum', 0.0219, 'lps'),
	(586426, 129, '2014-03-15 00:41:32.000000', 'consum', 0.0214, 'lps'),
	(586427, 129, '2014-03-15 00:41:33.000000', 'consum', 0.0218, 'lps'),
	(586428, 129, '2014-03-15 00:41:34.000000', 'consum', 0.0211, 'lps'),
	(586429, 129, '2014-03-15 00:41:35.000000', 'consum', 0.0218, 'lps'),
	(586430, 129, '2014-03-15 00:41:36.000000', 'consum', 0.0220, 'lps'),
	(586431, 129, '2014-03-15 00:41:37.000000', 'consum', 0.0221, 'lps'),
	(586432, 129, '2014-03-15 00:41:38.000000', 'consum', 0.0221, 'lps'),
	(586433, 129, '2014-03-15 00:41:39.000000', 'consum', 0.0221, 'lps'),
	(586434, 129, '2014-03-15 00:41:40.000000', 'consum', 0.0217, 'lps'),
	(586435, 129, '2014-03-15 00:41:41.000000', 'consum', 0.0212, 'lps'),
	(586436, 129, '2014-03-15 00:41:42.000000', 'consum', 0.0213, 'lps'),
	(586437, 129, '2014-03-15 00:41:43.000000', 'consum', 0.0219, 'lps'),
	(586438, 129, '2014-03-15 00:41:44.000000', 'consum', 0.0219, 'lps'),
	(586439, 129, '2014-03-15 00:41:45.000000', 'consum', 0.0214, 'lps'),
	(586440, 129, '2014-03-15 00:41:46.000000', 'consum', 0.0217, 'lps'),
	(586441, 129, '2014-03-15 00:41:47.000000', 'consum', 0.0219, 'lps'),
	(586442, 129, '2014-03-15 00:41:48.000000', 'consum', 0.0223, 'lps'),
	(586443, 129, '2014-03-15 00:41:49.000000', 'consum', 0.0217, 'lps'),
	(586444, 129, '2014-03-15 00:41:50.000000', 'consum', 0.0223, 'lps'),
	(586445, 129, '2014-03-15 00:41:51.000000', 'consum', 0.0213, 'lps'),
	(586446, 129, '2014-03-15 00:41:52.000000', 'consum', 0.0212, 'lps'),
	(586447, 129, '2014-03-15 00:41:53.000000', 'consum', 0.0212, 'lps'),
	(586448, 129, '2014-03-15 00:41:54.000000', 'consum', 0.0217, 'lps'),
	(586449, 129, '2014-03-15 00:41:55.000000', 'consum', 0.0222, 'lps'),
	(586450, 129, '2014-03-15 00:41:56.000000', 'consum', 0.0211, 'lps'),
	(586451, 129, '2014-03-15 00:41:57.000000', 'consum', 0.0220, 'lps'),
	(586452, 129, '2014-03-15 00:41:58.000000', 'consum', 0.0216, 'lps'),
	(586453, 129, '2014-03-15 00:41:59.000000', 'consum', 0.0222, 'lps'),
	(586454, 129, '2014-03-15 00:42:00.000000', 'consum', 0.0213, 'lps'),
	(586455, 129, '2014-03-15 00:42:01.000000', 'consum', 0.0217, 'lps'),
	(586456, 129, '2014-03-15 00:42:02.000000', 'consum', 0.0220, 'lps'),
	(586457, 129, '2014-03-15 00:42:03.000000', 'consum', 0.0215, 'lps'),
	(586458, 129, '2014-03-15 00:42:04.000000', 'consum', 0.0219, 'lps'),
	(586459, 129, '2014-03-15 00:42:05.000000', 'consum', 0.0213, 'lps'),
	(586460, 129, '2014-03-15 00:42:06.000000', 'consum', 0.0214, 'lps'),
	(586461, 129, '2014-03-15 00:42:07.000000', 'consum', 0.0219, 'lps'),
	(586462, 129, '2014-03-15 00:42:08.000000', 'consum', 0.0215, 'lps'),
	(586463, 129, '2014-03-15 00:42:09.000000', 'consum', 0.0210, 'lps'),
	(586464, 129, '2014-03-15 00:42:10.000000', 'consum', 0.0210, 'lps'),
	(586465, 129, '2014-03-15 00:42:11.000000', 'consum', 0.0222, 'lps'),
	(586466, 129, '2014-03-15 00:42:12.000000', 'consum', 0.0215, 'lps'),
	(586467, 129, '2014-03-15 00:42:13.000000', 'consum', 0.0214, 'lps'),
	(586468, 129, '2014-03-15 00:42:14.000000', 'consum', 0.0214, 'lps'),
	(586469, 129, '2014-03-15 00:42:15.000000', 'consum', 0.0218, 'lps'),
	(586470, 129, '2014-03-15 00:42:16.000000', 'consum', 0.0214, 'lps'),
	(586471, 129, '2014-03-15 00:42:17.000000', 'consum', 0.0217, 'lps'),
	(586472, 129, '2014-03-15 00:42:18.000000', 'consum', 0.0223, 'lps'),
	(586473, 129, '2014-03-15 00:42:19.000000', 'consum', 0.0210, 'lps'),
	(586474, 129, '2014-03-15 00:42:20.000000', 'consum', 0.0214, 'lps'),
	(586475, 129, '2014-03-15 00:42:21.000000', 'consum', 0.0218, 'lps'),
	(586476, 129, '2014-03-15 00:42:22.000000', 'consum', 0.0211, 'lps'),
	(586477, 129, '2014-03-15 00:42:23.000000', 'consum', 0.0220, 'lps'),
	(586478, 129, '2014-03-15 00:42:24.000000', 'consum', 0.0216, 'lps'),
	(586479, 129, '2014-03-15 00:42:25.000000', 'consum', 0.0211, 'lps'),
	(586480, 129, '2014-03-15 00:42:26.000000', 'consum', 0.0211, 'lps'),
	(586481, 129, '2014-03-15 00:42:27.000000', 'consum', 0.0212, 'lps'),
	(586482, 129, '2014-03-15 00:42:28.000000', 'consum', 0.0217, 'lps'),
	(586483, 129, '2014-03-15 00:42:29.000000', 'consum', 0.0212, 'lps'),
	(586484, 129, '2014-03-15 00:42:30.000000', 'consum', 0.0214, 'lps'),
	(586485, 129, '2014-03-15 00:42:31.000000', 'consum', 0.0212, 'lps'),
	(586486, 129, '2014-03-15 00:42:32.000000', 'consum', 0.0222, 'lps'),
	(586487, 129, '2014-03-15 00:42:33.000000', 'consum', 0.0221, 'lps'),
	(586488, 129, '2014-03-15 00:42:34.000000', 'consum', 0.0214, 'lps'),
	(586489, 129, '2014-03-15 00:42:35.000000', 'consum', 0.0214, 'lps'),
	(586490, 129, '2014-03-15 00:42:36.000000', 'consum', 0.0220, 'lps'),
	(586491, 129, '2014-03-15 00:42:37.000000', 'consum', 0.0217, 'lps'),
	(586492, 129, '2014-03-15 00:42:38.000000', 'consum', 0.0219, 'lps'),
	(586493, 129, '2014-03-15 00:42:39.000000', 'consum', 0.0217, 'lps'),
	(586494, 129, '2014-03-15 00:42:40.000000', 'consum', 0.0221, 'lps'),
	(586495, 129, '2014-03-15 00:42:41.000000', 'consum', 0.0216, 'lps'),
	(586496, 129, '2014-03-15 00:42:42.000000', 'consum', 0.0222, 'lps'),
	(586497, 129, '2014-03-15 00:42:43.000000', 'consum', 0.0212, 'lps'),
	(586498, 129, '2014-03-15 00:42:44.000000', 'consum', 0.0211, 'lps'),
	(586499, 129, '2014-03-15 00:42:45.000000', 'consum', 0.0222, 'lps'),
	(586500, 129, '2014-03-15 00:42:46.000000', 'consum', 0.0214, 'lps'),
	(586501, 129, '2014-03-15 00:42:47.000000', 'consum', 0.0220, 'lps'),
	(586502, 129, '2014-03-15 00:42:48.000000', 'consum', 0.0220, 'lps'),
	(586503, 129, '2014-03-15 00:42:49.000000', 'consum', 0.0218, 'lps'),
	(586504, 129, '2014-03-15 00:42:50.000000', 'consum', 0.0220, 'lps'),
	(586505, 129, '2014-03-15 00:42:51.000000', 'consum', 0.0222, 'lps'),
	(586506, 129, '2014-03-15 00:42:52.000000', 'consum', 0.0212, 'lps'),
	(586507, 129, '2014-03-15 00:42:53.000000', 'consum', 0.0215, 'lps'),
	(586508, 129, '2014-03-15 00:42:54.000000', 'consum', 0.0215, 'lps'),
	(586509, 129, '2014-03-15 00:42:55.000000', 'consum', 0.0220, 'lps'),
	(586510, 129, '2014-03-15 00:42:56.000000', 'consum', 0.0217, 'lps'),
	(586511, 129, '2014-03-15 00:42:57.000000', 'consum', 0.0214, 'lps'),
	(586512, 129, '2014-03-15 00:42:58.000000', 'consum', 0.0212, 'lps'),
	(586513, 129, '2014-03-15 00:42:59.000000', 'consum', 0.0220, 'lps'),
	(586514, 129, '2014-03-15 00:43:00.000000', 'consum', 0.0213, 'lps'),
	(586515, 129, '2014-03-15 00:43:01.000000', 'consum', 0.0210, 'lps'),
	(586516, 129, '2014-03-15 00:43:02.000000', 'consum', 0.0217, 'lps'),
	(586517, 129, '2014-03-15 00:43:03.000000', 'consum', 0.0216, 'lps'),
	(586518, 129, '2014-03-15 00:43:04.000000', 'consum', 0.0221, 'lps'),
	(586519, 129, '2014-03-15 00:43:05.000000', 'consum', 0.0220, 'lps'),
	(586520, 129, '2014-03-15 00:43:06.000000', 'consum', 0.0214, 'lps'),
	(586521, 129, '2014-03-15 00:43:07.000000', 'consum', 0.0215, 'lps'),
	(586522, 129, '2014-03-15 00:43:08.000000', 'consum', 0.0222, 'lps'),
	(586523, 129, '2014-03-15 00:43:09.000000', 'consum', 0.0212, 'lps'),
	(586524, 129, '2014-03-15 00:43:10.000000', 'consum', 0.0214, 'lps'),
	(586525, 129, '2014-03-15 00:43:11.000000', 'consum', 0.0211, 'lps'),
	(586526, 129, '2014-03-15 00:43:12.000000', 'consum', 0.0216, 'lps'),
	(586527, 129, '2014-03-15 00:43:13.000000', 'consum', 0.0211, 'lps'),
	(586528, 129, '2014-03-15 00:43:14.000000', 'consum', 0.0211, 'lps'),
	(586529, 129, '2014-03-15 00:43:15.000000', 'consum', 0.0212, 'lps'),
	(586530, 129, '2014-03-15 00:43:16.000000', 'consum', 0.0219, 'lps'),
	(586531, 129, '2014-03-15 00:43:17.000000', 'consum', 0.0222, 'lps'),
	(586532, 129, '2014-03-15 00:43:18.000000', 'consum', 0.0215, 'lps'),
	(586533, 129, '2014-03-15 00:43:19.000000', 'consum', 0.0214, 'lps'),
	(586534, 129, '2014-03-15 00:43:20.000000', 'consum', 0.0214, 'lps'),
	(586535, 129, '2014-03-15 00:43:21.000000', 'consum', 0.0220, 'lps'),
	(586536, 129, '2014-03-15 00:43:22.000000', 'consum', 0.0220, 'lps'),
	(586537, 129, '2014-03-15 00:43:23.000000', 'consum', 0.0218, 'lps'),
	(586538, 129, '2014-03-15 00:43:24.000000', 'consum', 0.0219, 'lps'),
	(586539, 129, '2014-03-15 00:43:25.000000', 'consum', 0.0218, 'lps'),
	(586540, 129, '2014-03-15 00:43:26.000000', 'consum', 0.0210, 'lps'),
	(586541, 129, '2014-03-15 00:43:27.000000', 'consum', 0.0213, 'lps'),
	(586542, 129, '2014-03-15 00:43:28.000000', 'consum', 0.0214, 'lps'),
	(586543, 129, '2014-03-15 00:43:29.000000', 'consum', 0.0219, 'lps'),
	(586544, 129, '2014-03-15 00:43:30.000000', 'consum', 0.0216, 'lps'),
	(586545, 129, '2014-03-15 00:43:31.000000', 'consum', 0.0215, 'lps'),
	(586546, 129, '2014-03-15 00:43:32.000000', 'consum', 0.0215, 'lps'),
	(586547, 129, '2014-03-15 00:43:33.000000', 'consum', 0.0222, 'lps'),
	(586548, 129, '2014-03-15 00:43:34.000000', 'consum', 0.0212, 'lps'),
	(586549, 129, '2014-03-15 00:43:35.000000', 'consum', 0.0212, 'lps'),
	(586550, 129, '2014-03-15 00:43:36.000000', 'consum', 0.0217, 'lps'),
	(586551, 129, '2014-03-15 00:43:37.000000', 'consum', 0.0223, 'lps'),
	(586552, 129, '2014-03-15 00:43:38.000000', 'consum', 0.0216, 'lps'),
	(586553, 129, '2014-03-15 00:43:39.000000', 'consum', 0.0212, 'lps'),
	(586554, 129, '2014-03-15 00:43:40.000000', 'consum', 0.0218, 'lps'),
	(586555, 129, '2014-03-15 00:43:41.000000', 'consum', 0.0216, 'lps'),
	(586556, 129, '2014-03-15 00:43:42.000000', 'consum', 0.0217, 'lps'),
	(586557, 129, '2014-03-15 00:43:43.000000', 'consum', 0.0213, 'lps'),
	(586558, 129, '2014-03-15 00:43:44.000000', 'consum', 0.0219, 'lps'),
	(586559, 129, '2014-03-15 00:43:45.000000', 'consum', 0.0216, 'lps'),
	(586560, 129, '2014-03-15 00:43:46.000000', 'consum', 0.0216, 'lps'),
	(586561, 129, '2014-03-15 00:43:47.000000', 'consum', 0.0222, 'lps'),
	(586562, 129, '2014-03-15 00:43:48.000000', 'consum', 0.0210, 'lps'),
	(586563, 129, '2014-03-15 00:43:49.000000', 'consum', 0.0216, 'lps'),
	(586564, 129, '2014-03-15 00:43:50.000000', 'consum', 0.0213, 'lps'),
	(586565, 129, '2014-03-15 00:43:51.000000', 'consum', 0.0223, 'lps'),
	(586566, 129, '2014-03-15 00:43:52.000000', 'consum', 0.0223, 'lps'),
	(586567, 129, '2014-03-15 00:43:53.000000', 'consum', 0.0222, 'lps'),
	(586568, 129, '2014-03-15 00:43:54.000000', 'consum', 0.0219, 'lps'),
	(586569, 129, '2014-03-15 00:43:55.000000', 'consum', 0.0219, 'lps'),
	(586570, 129, '2014-03-15 00:43:56.000000', 'consum', 0.0215, 'lps'),
	(586571, 129, '2014-03-15 00:43:57.000000', 'consum', 0.0223, 'lps'),
	(586572, 129, '2014-03-15 00:43:58.000000', 'consum', 0.0216, 'lps'),
	(586573, 129, '2014-03-15 00:43:59.000000', 'consum', 0.0218, 'lps'),
	(586574, 129, '2014-03-15 00:44:00.000000', 'consum', 0.0220, 'lps'),
	(586575, 129, '2014-03-15 00:44:01.000000', 'consum', 0.0219, 'lps'),
	(586576, 129, '2014-03-15 00:44:02.000000', 'consum', 0.0214, 'lps'),
	(586577, 129, '2014-03-15 00:44:03.000000', 'consum', 0.0218, 'lps'),
	(586578, 129, '2014-03-15 00:44:04.000000', 'consum', 0.0222, 'lps'),
	(586579, 129, '2014-03-15 00:44:05.000000', 'consum', 0.0221, 'lps'),
	(586580, 129, '2014-03-15 00:44:06.000000', 'consum', 0.0216, 'lps'),
	(586581, 129, '2014-03-15 00:44:07.000000', 'consum', 0.0222, 'lps'),
	(586582, 129, '2014-03-15 00:44:08.000000', 'consum', 0.0223, 'lps'),
	(586583, 129, '2014-03-15 00:44:09.000000', 'consum', 0.0210, 'lps'),
	(586584, 129, '2014-03-15 00:44:10.000000', 'consum', 0.0215, 'lps'),
	(586585, 129, '2014-03-15 00:44:11.000000', 'consum', 0.0221, 'lps'),
	(586586, 129, '2014-03-15 00:44:12.000000', 'consum', 0.0223, 'lps'),
	(586587, 129, '2014-03-15 00:44:13.000000', 'consum', 0.0215, 'lps'),
	(586588, 129, '2014-03-15 00:44:14.000000', 'consum', 0.0210, 'lps'),
	(586589, 129, '2014-03-15 00:44:15.000000', 'consum', 0.0210, 'lps'),
	(586590, 129, '2014-03-15 00:44:16.000000', 'consum', 0.0211, 'lps'),
	(586591, 129, '2014-03-15 00:44:17.000000', 'consum', 0.0215, 'lps'),
	(586592, 129, '2014-03-15 00:44:18.000000', 'consum', 0.0217, 'lps'),
	(586593, 129, '2014-03-15 00:44:19.000000', 'consum', 0.0219, 'lps'),
	(586594, 129, '2014-03-15 00:44:20.000000', 'consum', 0.0219, 'lps'),
	(586595, 129, '2014-03-15 00:44:21.000000', 'consum', 0.0215, 'lps'),
	(586596, 129, '2014-03-15 00:44:22.000000', 'consum', 0.0221, 'lps'),
	(586597, 129, '2014-03-15 00:44:23.000000', 'consum', 0.0210, 'lps'),
	(586598, 129, '2014-03-15 00:44:24.000000', 'consum', 0.0221, 'lps'),
	(586599, 129, '2014-03-15 00:44:25.000000', 'consum', 0.0221, 'lps'),
	(586600, 129, '2014-03-15 00:44:26.000000', 'consum', 0.0221, 'lps'),
	(586601, 129, '2014-03-15 00:44:27.000000', 'consum', 0.0218, 'lps'),
	(586602, 129, '2014-03-15 00:44:28.000000', 'consum', 0.0215, 'lps'),
	(586603, 129, '2014-03-15 00:44:29.000000', 'consum', 0.0213, 'lps'),
	(586604, 129, '2014-03-15 00:44:30.000000', 'consum', 0.0222, 'lps'),
	(586605, 129, '2014-03-15 00:44:31.000000', 'consum', 0.0223, 'lps'),
	(586606, 129, '2014-03-15 00:44:32.000000', 'consum', 0.0223, 'lps'),
	(586607, 129, '2014-03-15 00:44:33.000000', 'consum', 0.0211, 'lps'),
	(586608, 129, '2014-03-15 00:44:34.000000', 'consum', 0.0219, 'lps'),
	(586609, 129, '2014-03-15 00:44:35.000000', 'consum', 0.0211, 'lps'),
	(586610, 129, '2014-03-15 00:44:36.000000', 'consum', 0.0215, 'lps'),
	(586611, 129, '2014-03-15 00:44:37.000000', 'consum', 0.0217, 'lps'),
	(586612, 129, '2014-03-15 00:44:38.000000', 'consum', 0.0216, 'lps'),
	(586613, 129, '2014-03-15 00:44:39.000000', 'consum', 0.0222, 'lps'),
	(586614, 129, '2014-03-15 00:44:40.000000', 'consum', 0.0223, 'lps'),
	(586615, 129, '2014-03-15 00:44:41.000000', 'consum', 0.0210, 'lps'),
	(586616, 129, '2014-03-15 00:44:42.000000', 'consum', 0.0216, 'lps'),
	(586617, 129, '2014-03-15 00:44:43.000000', 'consum', 0.0211, 'lps'),
	(586618, 129, '2014-03-15 00:44:44.000000', 'consum', 0.0211, 'lps'),
	(586619, 129, '2014-03-15 00:44:45.000000', 'consum', 0.0211, 'lps'),
	(586620, 129, '2014-03-15 00:44:46.000000', 'consum', 0.0215, 'lps'),
	(586621, 129, '2014-03-15 00:44:47.000000', 'consum', 0.0220, 'lps'),
	(586622, 129, '2014-03-15 00:44:48.000000', 'consum', 0.0215, 'lps'),
	(586623, 129, '2014-03-15 00:44:49.000000', 'consum', 0.0222, 'lps'),
	(586624, 129, '2014-03-15 00:44:50.000000', 'consum', 0.0214, 'lps'),
	(586625, 129, '2014-03-15 00:44:51.000000', 'consum', 0.0219, 'lps'),
	(586626, 129, '2014-03-15 00:44:52.000000', 'consum', 0.0218, 'lps'),
	(586627, 129, '2014-03-15 00:44:53.000000', 'consum', 0.0210, 'lps'),
	(586628, 129, '2014-03-15 00:44:54.000000', 'consum', 0.0213, 'lps'),
	(586629, 129, '2014-03-15 00:44:55.000000', 'consum', 0.0214, 'lps'),
	(586630, 129, '2014-03-15 00:44:56.000000', 'consum', 0.0220, 'lps'),
	(586631, 129, '2014-03-15 00:44:57.000000', 'consum', 0.0219, 'lps'),
	(586632, 129, '2014-03-15 00:44:58.000000', 'consum', 0.0212, 'lps'),
	(586633, 129, '2014-03-15 00:44:59.000000', 'consum', 0.0221, 'lps'),
	(586634, 129, '2014-03-15 00:45:00.000000', 'consum', 0.0218, 'lps'),
	(586635, 129, '2014-03-15 00:45:01.000000', 'consum', 0.0218, 'lps'),
	(586636, 129, '2014-03-15 00:45:02.000000', 'consum', 0.0213, 'lps'),
	(586637, 129, '2014-03-15 00:45:03.000000', 'consum', 0.0215, 'lps'),
	(586638, 129, '2014-03-15 00:45:04.000000', 'consum', 0.0214, 'lps'),
	(586639, 129, '2014-03-15 00:45:05.000000', 'consum', 0.0213, 'lps'),
	(586640, 129, '2014-03-15 00:45:06.000000', 'consum', 0.0214, 'lps'),
	(586641, 129, '2014-03-15 00:45:07.000000', 'consum', 0.0220, 'lps'),
	(586642, 129, '2014-03-15 00:45:08.000000', 'consum', 0.0222, 'lps'),
	(586643, 129, '2014-03-15 00:45:09.000000', 'consum', 0.0211, 'lps'),
	(586644, 129, '2014-03-15 00:45:10.000000', 'consum', 0.0222, 'lps'),
	(586645, 129, '2014-03-15 00:45:11.000000', 'consum', 0.0210, 'lps'),
	(586646, 129, '2014-03-15 00:45:12.000000', 'consum', 0.0216, 'lps'),
	(586647, 129, '2014-03-15 00:45:13.000000', 'consum', 0.0216, 'lps'),
	(586648, 129, '2014-03-15 00:45:14.000000', 'consum', 0.0220, 'lps'),
	(586649, 129, '2014-03-15 00:45:15.000000', 'consum', 0.0213, 'lps'),
	(586650, 129, '2014-03-15 00:45:16.000000', 'consum', 0.0212, 'lps'),
	(586651, 129, '2014-03-15 00:45:17.000000', 'consum', 0.0223, 'lps'),
	(586652, 129, '2014-03-15 00:45:18.000000', 'consum', 0.0213, 'lps'),
	(586653, 129, '2014-03-15 00:45:19.000000', 'consum', 0.0217, 'lps'),
	(586654, 129, '2014-03-15 00:45:20.000000', 'consum', 0.0221, 'lps'),
	(586655, 129, '2014-03-15 00:45:21.000000', 'consum', 0.0219, 'lps'),
	(586656, 129, '2014-03-15 00:45:22.000000', 'consum', 0.0221, 'lps'),
	(586657, 129, '2014-03-15 00:45:23.000000', 'consum', 0.0212, 'lps'),
	(586658, 129, '2014-03-15 00:45:24.000000', 'consum', 0.0215, 'lps'),
	(586659, 129, '2014-03-15 00:45:25.000000', 'consum', 0.0215, 'lps'),
	(586660, 129, '2014-03-15 00:45:26.000000', 'consum', 0.0221, 'lps'),
	(586661, 129, '2014-03-15 00:45:27.000000', 'consum', 0.0223, 'lps'),
	(586662, 129, '2014-03-15 00:45:28.000000', 'consum', 0.0212, 'lps'),
	(586663, 129, '2014-03-15 00:45:29.000000', 'consum', 0.0212, 'lps'),
	(586664, 129, '2014-03-15 00:45:30.000000', 'consum', 0.0215, 'lps'),
	(586665, 129, '2014-03-15 00:45:31.000000', 'consum', 0.0214, 'lps'),
	(586666, 129, '2014-03-15 00:45:32.000000', 'consum', 0.0218, 'lps'),
	(586667, 129, '2014-03-15 00:45:33.000000', 'consum', 0.0222, 'lps'),
	(586668, 129, '2014-03-15 00:45:34.000000', 'consum', 0.0221, 'lps'),
	(586669, 129, '2014-03-15 00:45:35.000000', 'consum', 0.0213, 'lps'),
	(586670, 129, '2014-03-15 00:45:36.000000', 'consum', 0.0220, 'lps'),
	(586671, 129, '2014-03-15 00:45:37.000000', 'consum', 0.0222, 'lps'),
	(586672, 129, '2014-03-15 00:45:38.000000', 'consum', 0.0216, 'lps'),
	(586673, 129, '2014-03-15 00:45:39.000000', 'consum', 0.0217, 'lps'),
	(586674, 129, '2014-03-15 00:45:40.000000', 'consum', 0.0215, 'lps'),
	(586675, 129, '2014-03-15 00:45:41.000000', 'consum', 0.0215, 'lps'),
	(586676, 129, '2014-03-15 00:45:42.000000', 'consum', 0.0220, 'lps'),
	(586677, 129, '2014-03-15 00:45:43.000000', 'consum', 0.0217, 'lps'),
	(586678, 129, '2014-03-15 00:45:44.000000', 'consum', 0.0215, 'lps'),
	(586679, 129, '2014-03-15 00:45:45.000000', 'consum', 0.0215, 'lps'),
	(586680, 129, '2014-03-15 00:45:46.000000', 'consum', 0.0223, 'lps'),
	(586681, 129, '2014-03-15 00:45:47.000000', 'consum', 0.0215, 'lps'),
	(586682, 129, '2014-03-15 00:45:48.000000', 'consum', 0.0210, 'lps'),
	(586683, 129, '2014-03-15 00:45:49.000000', 'consum', 0.0212, 'lps'),
	(586684, 129, '2014-03-15 00:45:50.000000', 'consum', 0.0221, 'lps'),
	(586685, 129, '2014-03-15 00:45:51.000000', 'consum', 0.0215, 'lps'),
	(586686, 129, '2014-03-15 00:45:52.000000', 'consum', 0.0219, 'lps'),
	(586687, 129, '2014-03-15 00:45:53.000000', 'consum', 0.0210, 'lps'),
	(586688, 129, '2014-03-15 00:45:54.000000', 'consum', 0.0211, 'lps'),
	(586689, 129, '2014-03-15 00:45:55.000000', 'consum', 0.0218, 'lps'),
	(586690, 129, '2014-03-15 00:45:56.000000', 'consum', 0.0220, 'lps'),
	(586691, 129, '2014-03-15 00:45:57.000000', 'consum', 0.0220, 'lps'),
	(586692, 129, '2014-03-15 00:45:58.000000', 'consum', 0.0216, 'lps'),
	(586693, 129, '2014-03-15 00:45:59.000000', 'consum', 0.0210, 'lps'),
	(586694, 129, '2014-03-15 00:46:00.000000', 'consum', 0.0222, 'lps'),
	(586695, 129, '2014-03-15 00:46:01.000000', 'consum', 0.0215, 'lps'),
	(586696, 129, '2014-03-15 00:46:02.000000', 'consum', 0.0213, 'lps'),
	(586697, 129, '2014-03-15 00:46:03.000000', 'consum', 0.0223, 'lps'),
	(586698, 129, '2014-03-15 00:46:04.000000', 'consum', 0.0211, 'lps'),
	(586699, 129, '2014-03-15 00:46:05.000000', 'consum', 0.0220, 'lps'),
	(586700, 129, '2014-03-15 00:46:06.000000', 'consum', 0.0214, 'lps'),
	(586701, 129, '2014-03-15 00:46:07.000000', 'consum', 0.0213, 'lps'),
	(586702, 129, '2014-03-15 00:46:08.000000', 'consum', 0.0216, 'lps'),
	(586703, 129, '2014-03-15 00:46:09.000000', 'consum', 0.0215, 'lps'),
	(586704, 129, '2014-03-15 00:46:10.000000', 'consum', 0.0221, 'lps'),
	(586705, 129, '2014-03-15 00:46:11.000000', 'consum', 0.0219, 'lps'),
	(586706, 129, '2014-03-15 00:46:12.000000', 'consum', 0.0211, 'lps'),
	(586707, 129, '2014-03-15 00:46:13.000000', 'consum', 0.0216, 'lps'),
	(586708, 129, '2014-03-15 00:46:14.000000', 'consum', 0.0223, 'lps'),
	(586709, 129, '2014-03-15 00:46:15.000000', 'consum', 0.0216, 'lps'),
	(586710, 129, '2014-03-15 00:46:16.000000', 'consum', 0.0215, 'lps'),
	(586711, 129, '2014-03-15 00:46:17.000000', 'consum', 0.0216, 'lps'),
	(586712, 129, '2014-03-15 00:46:18.000000', 'consum', 0.0214, 'lps'),
	(586713, 129, '2014-03-15 00:46:19.000000', 'consum', 0.0213, 'lps'),
	(586714, 129, '2014-03-15 00:46:20.000000', 'consum', 0.0212, 'lps'),
	(586715, 129, '2014-03-15 00:46:21.000000', 'consum', 0.0211, 'lps'),
	(586716, 129, '2014-03-15 00:46:22.000000', 'consum', 0.0210, 'lps'),
	(586717, 129, '2014-03-15 00:46:23.000000', 'consum', 0.0222, 'lps'),
	(586718, 129, '2014-03-15 00:46:24.000000', 'consum', 0.0214, 'lps'),
	(586719, 129, '2014-03-15 00:46:25.000000', 'consum', 0.0222, 'lps'),
	(586720, 129, '2014-03-15 00:46:26.000000', 'consum', 0.0218, 'lps'),
	(586721, 129, '2014-03-15 00:46:27.000000', 'consum', 0.0215, 'lps'),
	(586722, 129, '2014-03-15 00:46:28.000000', 'consum', 0.0212, 'lps'),
	(586723, 129, '2014-03-15 00:46:29.000000', 'consum', 0.0219, 'lps'),
	(586724, 129, '2014-03-15 00:46:30.000000', 'consum', 0.0222, 'lps'),
	(586725, 129, '2014-03-15 00:46:31.000000', 'consum', 0.0213, 'lps'),
	(586726, 129, '2014-03-15 00:46:32.000000', 'consum', 0.0220, 'lps'),
	(586727, 129, '2014-03-15 00:46:33.000000', 'consum', 0.0223, 'lps'),
	(586728, 129, '2014-03-15 00:46:34.000000', 'consum', 0.0218, 'lps'),
	(586729, 129, '2014-03-15 00:46:35.000000', 'consum', 0.0212, 'lps'),
	(586730, 129, '2014-03-15 00:46:36.000000', 'consum', 0.0222, 'lps'),
	(586731, 129, '2014-03-15 00:46:37.000000', 'consum', 0.0210, 'lps'),
	(586732, 129, '2014-03-15 00:46:38.000000', 'consum', 0.0216, 'lps'),
	(586733, 129, '2014-03-15 00:46:39.000000', 'consum', 0.0214, 'lps'),
	(586734, 129, '2014-03-15 00:46:40.000000', 'consum', 0.0211, 'lps'),
	(586735, 129, '2014-03-15 00:46:41.000000', 'consum', 0.0219, 'lps'),
	(586736, 129, '2014-03-15 00:46:42.000000', 'consum', 0.0211, 'lps'),
	(586737, 129, '2014-03-15 00:46:43.000000', 'consum', 0.0214, 'lps'),
	(586738, 129, '2014-03-15 00:46:44.000000', 'consum', 0.0214, 'lps'),
	(586739, 129, '2014-03-15 00:46:45.000000', 'consum', 0.0218, 'lps'),
	(586740, 129, '2014-03-15 00:46:46.000000', 'consum', 0.0212, 'lps'),
	(586741, 129, '2014-03-15 00:46:47.000000', 'consum', 0.0210, 'lps'),
	(586742, 129, '2014-03-15 00:46:48.000000', 'consum', 0.0217, 'lps'),
	(586743, 129, '2014-03-15 00:46:49.000000', 'consum', 0.0218, 'lps'),
	(586744, 129, '2014-03-15 00:46:50.000000', 'consum', 0.0218, 'lps'),
	(586745, 129, '2014-03-15 00:46:51.000000', 'consum', 0.0210, 'lps'),
	(586746, 129, '2014-03-15 00:46:52.000000', 'consum', 0.0217, 'lps'),
	(586747, 129, '2014-03-15 00:46:53.000000', 'consum', 0.0215, 'lps'),
	(586748, 129, '2014-03-15 00:46:54.000000', 'consum', 0.0216, 'lps'),
	(586749, 129, '2014-03-15 00:46:55.000000', 'consum', 0.0211, 'lps'),
	(586750, 129, '2014-03-15 00:46:56.000000', 'consum', 0.0211, 'lps'),
	(586751, 129, '2014-03-15 00:46:57.000000', 'consum', 0.0213, 'lps'),
	(586752, 129, '2014-03-15 00:46:58.000000', 'consum', 0.0223, 'lps'),
	(586753, 129, '2014-03-15 00:46:59.000000', 'consum', 0.0211, 'lps'),
	(586754, 129, '2014-03-15 00:47:00.000000', 'consum', 0.0218, 'lps'),
	(586755, 129, '2014-03-15 00:47:01.000000', 'consum', 0.0218, 'lps'),
	(586756, 129, '2014-03-15 00:47:02.000000', 'consum', 0.0215, 'lps'),
	(586757, 129, '2014-03-15 00:47:03.000000', 'consum', 0.0210, 'lps'),
	(586758, 129, '2014-03-15 00:47:04.000000', 'consum', 0.0210, 'lps'),
	(586759, 129, '2014-03-15 00:47:05.000000', 'consum', 0.0223, 'lps'),
	(586760, 129, '2014-03-15 00:47:06.000000', 'consum', 0.0220, 'lps'),
	(586761, 129, '2014-03-15 00:47:07.000000', 'consum', 0.0220, 'lps'),
	(586762, 129, '2014-03-15 00:47:08.000000', 'consum', 0.0220, 'lps'),
	(586763, 129, '2014-03-15 00:47:09.000000', 'consum', 0.0214, 'lps'),
	(586764, 129, '2014-03-15 00:47:10.000000', 'consum', 0.0217, 'lps'),
	(586765, 129, '2014-03-15 00:47:11.000000', 'consum', 0.0217, 'lps'),
	(586766, 129, '2014-03-15 00:47:12.000000', 'consum', 0.0213, 'lps'),
	(586767, 129, '2014-03-15 00:47:13.000000', 'consum', 0.0218, 'lps'),
	(586768, 129, '2014-03-15 00:47:14.000000', 'consum', 0.0211, 'lps'),
	(586769, 129, '2014-03-15 00:47:15.000000', 'consum', 0.0222, 'lps'),
	(586770, 129, '2014-03-15 00:47:16.000000', 'consum', 0.0210, 'lps'),
	(586771, 129, '2014-03-15 00:47:17.000000', 'consum', 0.0218, 'lps'),
	(586772, 129, '2014-03-15 00:47:18.000000', 'consum', 0.0221, 'lps'),
	(586773, 129, '2014-03-15 00:47:19.000000', 'consum', 0.0214, 'lps'),
	(586774, 129, '2014-03-15 00:47:20.000000', 'consum', 0.0211, 'lps'),
	(586775, 129, '2014-03-15 00:47:21.000000', 'consum', 0.0220, 'lps'),
	(586776, 129, '2014-03-15 00:47:22.000000', 'consum', 0.0213, 'lps'),
	(586777, 129, '2014-03-15 00:47:23.000000', 'consum', 0.0223, 'lps'),
	(586778, 129, '2014-03-15 00:47:24.000000', 'consum', 0.0211, 'lps'),
	(586779, 129, '2014-03-15 00:47:25.000000', 'consum', 0.0218, 'lps'),
	(586780, 129, '2014-03-15 00:47:26.000000', 'consum', 0.0219, 'lps'),
	(586781, 129, '2014-03-15 00:47:27.000000', 'consum', 0.0220, 'lps'),
	(586782, 129, '2014-03-15 00:47:28.000000', 'consum', 0.0217, 'lps'),
	(586783, 129, '2014-03-15 00:47:29.000000', 'consum', 0.0216, 'lps'),
	(586784, 129, '2014-03-15 00:47:30.000000', 'consum', 0.0218, 'lps'),
	(586785, 129, '2014-03-15 00:47:31.000000', 'consum', 0.0219, 'lps'),
	(586786, 129, '2014-03-15 00:47:32.000000', 'consum', 0.0219, 'lps'),
	(586787, 129, '2014-03-15 00:47:33.000000', 'consum', 0.0212, 'lps'),
	(586788, 129, '2014-03-15 00:47:34.000000', 'consum', 0.0210, 'lps'),
	(586789, 129, '2014-03-15 00:47:35.000000', 'consum', 0.0218, 'lps'),
	(586790, 129, '2014-03-15 00:47:36.000000', 'consum', 0.0221, 'lps'),
	(586791, 129, '2014-03-15 00:47:37.000000', 'consum', 0.0215, 'lps'),
	(586792, 129, '2014-03-15 00:47:38.000000', 'consum', 0.0218, 'lps'),
	(586793, 129, '2014-03-15 00:47:39.000000', 'consum', 0.0218, 'lps'),
	(586794, 129, '2014-03-15 00:47:40.000000', 'consum', 0.0214, 'lps'),
	(586795, 129, '2014-03-15 00:47:41.000000', 'consum', 0.0220, 'lps'),
	(586796, 129, '2014-03-15 00:47:42.000000', 'consum', 0.0223, 'lps'),
	(586797, 129, '2014-03-15 00:47:43.000000', 'consum', 0.0214, 'lps'),
	(586798, 129, '2014-03-15 00:47:44.000000', 'consum', 0.0222, 'lps'),
	(586799, 129, '2014-03-15 00:47:45.000000', 'consum', 0.0217, 'lps'),
	(586800, 129, '2014-03-15 00:47:46.000000', 'consum', 0.0210, 'lps'),
	(586801, 129, '2014-03-15 00:47:47.000000', 'consum', 0.0217, 'lps'),
	(586802, 129, '2014-03-15 00:47:48.000000', 'consum', 0.0218, 'lps'),
	(586803, 129, '2014-03-15 00:47:49.000000', 'consum', 0.0214, 'lps'),
	(586804, 129, '2014-03-15 00:47:50.000000', 'consum', 0.0220, 'lps'),
	(586805, 129, '2014-03-15 00:47:51.000000', 'consum', 0.0223, 'lps'),
	(586806, 129, '2014-03-15 00:47:52.000000', 'consum', 0.0216, 'lps'),
	(586807, 129, '2014-03-15 00:47:53.000000', 'consum', 0.0218, 'lps'),
	(586808, 129, '2014-03-15 00:47:54.000000', 'consum', 0.0215, 'lps'),
	(586809, 129, '2014-03-15 00:47:55.000000', 'consum', 0.0214, 'lps'),
	(586810, 129, '2014-03-15 00:47:56.000000', 'consum', 0.0216, 'lps'),
	(586811, 129, '2014-03-15 00:47:57.000000', 'consum', 0.0214, 'lps'),
	(586812, 129, '2014-03-15 00:47:58.000000', 'consum', 0.0213, 'lps'),
	(586813, 129, '2014-03-15 00:47:59.000000', 'consum', 0.0211, 'lps'),
	(586814, 129, '2014-03-15 00:48:00.000000', 'consum', 0.0210, 'lps'),
	(586815, 129, '2014-03-15 00:48:01.000000', 'consum', 0.0219, 'lps'),
	(586816, 129, '2014-03-15 00:48:02.000000', 'consum', 0.0212, 'lps'),
	(586817, 129, '2014-03-15 00:48:03.000000', 'consum', 0.0211, 'lps'),
	(586818, 129, '2014-03-15 00:48:04.000000', 'consum', 0.0221, 'lps'),
	(586819, 129, '2014-03-15 00:48:05.000000', 'consum', 0.0220, 'lps'),
	(586820, 129, '2014-03-15 00:48:06.000000', 'consum', 0.0214, 'lps'),
	(586821, 129, '2014-03-15 00:48:07.000000', 'consum', 0.0214, 'lps'),
	(586822, 129, '2014-03-15 00:48:08.000000', 'consum', 0.0219, 'lps'),
	(586823, 129, '2014-03-15 00:48:09.000000', 'consum', 0.0216, 'lps'),
	(586824, 129, '2014-03-15 00:48:10.000000', 'consum', 0.0212, 'lps'),
	(586825, 129, '2014-03-15 00:48:11.000000', 'consum', 0.0218, 'lps'),
	(586826, 129, '2014-03-15 00:48:12.000000', 'consum', 0.0214, 'lps'),
	(586827, 129, '2014-03-15 00:48:13.000000', 'consum', 0.0210, 'lps'),
	(586828, 129, '2014-03-15 00:48:14.000000', 'consum', 0.0210, 'lps'),
	(586829, 129, '2014-03-15 00:48:15.000000', 'consum', 0.0212, 'lps'),
	(586830, 129, '2014-03-15 00:48:16.000000', 'consum', 0.0219, 'lps'),
	(586831, 129, '2014-03-15 00:48:17.000000', 'consum', 0.0220, 'lps'),
	(586832, 129, '2014-03-15 00:48:18.000000', 'consum', 0.0221, 'lps'),
	(586833, 129, '2014-03-15 00:48:19.000000', 'consum', 0.0222, 'lps'),
	(586834, 129, '2014-03-15 00:48:20.000000', 'consum', 0.0210, 'lps'),
	(586835, 129, '2014-03-15 00:48:21.000000', 'consum', 0.0215, 'lps'),
	(586836, 129, '2014-03-15 00:48:22.000000', 'consum', 0.0210, 'lps'),
	(586837, 129, '2014-03-15 00:48:23.000000', 'consum', 0.0223, 'lps'),
	(586838, 129, '2014-03-15 00:48:24.000000', 'consum', 0.0219, 'lps'),
	(586839, 129, '2014-03-15 00:48:25.000000', 'consum', 0.0217, 'lps'),
	(586840, 129, '2014-03-15 00:48:26.000000', 'consum', 0.0219, 'lps'),
	(586841, 129, '2014-03-15 00:48:27.000000', 'consum', 0.0219, 'lps'),
	(586842, 129, '2014-03-15 00:48:28.000000', 'consum', 0.0215, 'lps'),
	(586843, 129, '2014-03-15 00:48:29.000000', 'consum', 0.0223, 'lps'),
	(586844, 129, '2014-03-15 00:48:30.000000', 'consum', 0.0219, 'lps'),
	(586845, 129, '2014-03-15 00:48:31.000000', 'consum', 0.0216, 'lps'),
	(586846, 129, '2014-03-15 00:48:32.000000', 'consum', 0.0214, 'lps'),
	(586847, 129, '2014-03-15 00:48:33.000000', 'consum', 0.0212, 'lps'),
	(586848, 129, '2014-03-15 00:48:34.000000', 'consum', 0.0222, 'lps'),
	(586849, 129, '2014-03-15 00:48:35.000000', 'consum', 0.0222, 'lps'),
	(586850, 129, '2014-03-15 00:48:36.000000', 'consum', 0.0219, 'lps'),
	(586851, 129, '2014-03-15 00:48:37.000000', 'consum', 0.0222, 'lps'),
	(586852, 129, '2014-03-15 00:48:38.000000', 'consum', 0.0214, 'lps'),
	(586853, 129, '2014-03-15 00:48:39.000000', 'consum', 0.0210, 'lps'),
	(586854, 129, '2014-03-15 00:48:40.000000', 'consum', 0.0212, 'lps'),
	(586855, 129, '2014-03-15 00:48:41.000000', 'consum', 0.0220, 'lps'),
	(586856, 129, '2014-03-15 00:48:42.000000', 'consum', 0.0215, 'lps'),
	(586857, 129, '2014-03-15 00:48:43.000000', 'consum', 0.0218, 'lps'),
	(586858, 129, '2014-03-15 00:48:44.000000', 'consum', 0.0220, 'lps'),
	(586859, 129, '2014-03-15 00:48:45.000000', 'consum', 0.0222, 'lps'),
	(586860, 129, '2014-03-15 00:48:46.000000', 'consum', 0.0213, 'lps'),
	(586861, 129, '2014-03-15 00:48:47.000000', 'consum', 0.0218, 'lps'),
	(586862, 129, '2014-03-15 00:48:48.000000', 'consum', 0.0214, 'lps'),
	(586863, 129, '2014-03-15 00:48:49.000000', 'consum', 0.0219, 'lps'),
	(586864, 129, '2014-03-15 00:48:50.000000', 'consum', 0.0216, 'lps'),
	(586865, 129, '2014-03-15 00:48:51.000000', 'consum', 0.0212, 'lps'),
	(586866, 129, '2014-03-15 00:48:52.000000', 'consum', 0.0216, 'lps'),
	(586867, 129, '2014-03-15 00:48:53.000000', 'consum', 0.0223, 'lps'),
	(586868, 129, '2014-03-15 00:48:54.000000', 'consum', 0.0216, 'lps'),
	(586869, 129, '2014-03-15 00:48:55.000000', 'consum', 0.0213, 'lps'),
	(586870, 129, '2014-03-15 00:48:56.000000', 'consum', 0.0222, 'lps'),
	(586871, 129, '2014-03-15 00:48:57.000000', 'consum', 0.0218, 'lps'),
	(586872, 129, '2014-03-15 00:48:58.000000', 'consum', 0.0215, 'lps'),
	(586873, 129, '2014-03-15 00:48:59.000000', 'consum', 0.0212, 'lps'),
	(586874, 129, '2014-03-15 00:49:00.000000', 'consum', 0.0220, 'lps'),
	(586875, 129, '2014-03-15 00:49:01.000000', 'consum', 0.0214, 'lps'),
	(586876, 129, '2014-03-15 00:49:02.000000', 'consum', 0.0213, 'lps'),
	(586877, 129, '2014-03-15 00:49:03.000000', 'consum', 0.0216, 'lps'),
	(586878, 129, '2014-03-15 00:49:04.000000', 'consum', 0.0214, 'lps'),
	(586879, 129, '2014-03-15 00:49:05.000000', 'consum', 0.0214, 'lps'),
	(586880, 129, '2014-03-15 00:49:06.000000', 'consum', 0.0217, 'lps'),
	(586881, 129, '2014-03-15 00:49:07.000000', 'consum', 0.0218, 'lps'),
	(586882, 129, '2014-03-15 00:49:08.000000', 'consum', 0.0219, 'lps'),
	(586883, 129, '2014-03-15 00:49:09.000000', 'consum', 0.0217, 'lps'),
	(586884, 129, '2014-03-15 00:49:10.000000', 'consum', 0.0216, 'lps'),
	(586885, 129, '2014-03-15 00:49:11.000000', 'consum', 0.0221, 'lps'),
	(586886, 129, '2014-03-15 00:49:12.000000', 'consum', 0.0221, 'lps'),
	(586887, 129, '2014-03-15 00:49:13.000000', 'consum', 0.0218, 'lps'),
	(586888, 129, '2014-03-15 00:49:14.000000', 'consum', 0.0216, 'lps'),
	(586889, 129, '2014-03-15 00:49:15.000000', 'consum', 0.0219, 'lps'),
	(586890, 129, '2014-03-15 00:49:16.000000', 'consum', 0.0210, 'lps'),
	(586891, 129, '2014-03-15 00:49:17.000000', 'consum', 0.0222, 'lps'),
	(586892, 129, '2014-03-15 00:49:18.000000', 'consum', 0.0218, 'lps'),
	(586893, 129, '2014-03-15 00:49:19.000000', 'consum', 0.0214, 'lps'),
	(586894, 129, '2014-03-15 00:49:20.000000', 'consum', 0.0219, 'lps'),
	(586895, 129, '2014-03-15 00:49:21.000000', 'consum', 0.0215, 'lps'),
	(586896, 129, '2014-03-15 00:49:22.000000', 'consum', 0.0223, 'lps'),
	(586897, 129, '2014-03-15 00:49:23.000000', 'consum', 0.0217, 'lps'),
	(586898, 129, '2014-03-15 00:49:24.000000', 'consum', 0.0221, 'lps'),
	(586899, 129, '2014-03-15 00:49:25.000000', 'consum', 0.0218, 'lps'),
	(586900, 129, '2014-03-15 00:49:26.000000', 'consum', 0.0218, 'lps'),
	(586901, 129, '2014-03-15 00:49:27.000000', 'consum', 0.0210, 'lps'),
	(586902, 129, '2014-03-15 00:49:28.000000', 'consum', 0.0214, 'lps'),
	(586903, 129, '2014-03-15 00:49:29.000000', 'consum', 0.0219, 'lps'),
	(586904, 129, '2014-03-15 00:49:30.000000', 'consum', 0.0215, 'lps'),
	(586905, 129, '2014-03-15 00:49:31.000000', 'consum', 0.0222, 'lps'),
	(586906, 129, '2014-03-15 00:49:32.000000', 'consum', 0.0212, 'lps'),
	(586907, 129, '2014-03-15 00:49:33.000000', 'consum', 0.0212, 'lps'),
	(586908, 129, '2014-03-15 00:49:34.000000', 'consum', 0.0217, 'lps'),
	(586909, 129, '2014-03-15 00:49:35.000000', 'consum', 0.0223, 'lps'),
	(586910, 129, '2014-03-15 00:49:36.000000', 'consum', 0.0213, 'lps'),
	(586911, 129, '2014-03-15 00:49:37.000000', 'consum', 0.0213, 'lps'),
	(586912, 129, '2014-03-15 00:49:38.000000', 'consum', 0.0220, 'lps'),
	(586913, 129, '2014-03-15 00:49:39.000000', 'consum', 0.0220, 'lps'),
	(586914, 129, '2014-03-15 00:49:40.000000', 'consum', 0.0218, 'lps'),
	(586915, 129, '2014-03-15 00:49:41.000000', 'consum', 0.0222, 'lps'),
	(586916, 129, '2014-03-15 00:49:42.000000', 'consum', 0.0216, 'lps'),
	(586917, 129, '2014-03-15 00:49:43.000000', 'consum', 0.0220, 'lps'),
	(586918, 129, '2014-03-15 00:49:44.000000', 'consum', 0.0215, 'lps'),
	(586919, 129, '2014-03-15 00:49:45.000000', 'consum', 0.0219, 'lps'),
	(586920, 129, '2014-03-15 00:49:46.000000', 'consum', 0.0214, 'lps'),
	(586921, 129, '2014-03-15 00:49:47.000000', 'consum', 0.0217, 'lps'),
	(586922, 129, '2014-03-15 00:49:48.000000', 'consum', 0.0218, 'lps'),
	(586923, 129, '2014-03-15 00:49:49.000000', 'consum', 0.0216, 'lps'),
	(586924, 129, '2014-03-15 00:49:50.000000', 'consum', 0.0217, 'lps'),
	(586925, 129, '2014-03-15 00:49:51.000000', 'consum', 0.0214, 'lps'),
	(586926, 129, '2014-03-15 00:49:52.000000', 'consum', 0.0210, 'lps'),
	(586927, 129, '2014-03-15 00:49:53.000000', 'consum', 0.0212, 'lps'),
	(586928, 129, '2014-03-15 00:49:54.000000', 'consum', 0.0220, 'lps'),
	(586929, 129, '2014-03-15 00:49:55.000000', 'consum', 0.0213, 'lps'),
	(586930, 129, '2014-03-15 00:49:56.000000', 'consum', 0.0223, 'lps'),
	(586931, 129, '2014-03-15 00:49:57.000000', 'consum', 0.0211, 'lps'),
	(586932, 129, '2014-03-15 00:49:58.000000', 'consum', 0.0218, 'lps'),
	(586933, 129, '2014-03-15 00:49:59.000000', 'consum', 0.0219, 'lps'),
	(586934, 129, '2014-03-15 00:50:00.000000', 'consum', 0.0216, 'lps'),
	(586935, 129, '2014-03-15 00:50:01.000000', 'consum', 0.0217, 'lps'),
	(586936, 129, '2014-03-15 00:50:02.000000', 'consum', 0.0210, 'lps'),
	(586937, 129, '2014-03-15 00:50:03.000000', 'consum', 0.0219, 'lps'),
	(586938, 129, '2014-03-15 00:50:04.000000', 'consum', 0.0212, 'lps'),
	(586939, 129, '2014-03-15 00:50:05.000000', 'consum', 0.0223, 'lps'),
	(586940, 129, '2014-03-15 00:50:06.000000', 'consum', 0.0211, 'lps'),
	(586941, 129, '2014-03-15 00:50:07.000000', 'consum', 0.0221, 'lps'),
	(586942, 129, '2014-03-15 00:50:08.000000', 'consum', 0.0219, 'lps'),
	(586943, 129, '2014-03-15 00:50:09.000000', 'consum', 0.0223, 'lps'),
	(586944, 129, '2014-03-15 00:50:10.000000', 'consum', 0.0219, 'lps'),
	(586945, 129, '2014-03-15 00:50:11.000000', 'consum', 0.0217, 'lps'),
	(586946, 129, '2014-03-15 00:50:12.000000', 'consum', 0.0217, 'lps'),
	(586947, 129, '2014-03-15 00:50:13.000000', 'consum', 0.0212, 'lps'),
	(586948, 129, '2014-03-15 00:50:14.000000', 'consum', 0.0212, 'lps'),
	(586949, 129, '2014-03-15 00:50:15.000000', 'consum', 0.0215, 'lps'),
	(586950, 129, '2014-03-15 00:50:16.000000', 'consum', 0.0215, 'lps'),
	(586951, 129, '2014-03-15 00:50:17.000000', 'consum', 0.0220, 'lps'),
	(586952, 129, '2014-03-15 00:50:18.000000', 'consum', 0.0219, 'lps'),
	(586953, 129, '2014-03-15 00:50:19.000000', 'consum', 0.0211, 'lps'),
	(586954, 129, '2014-03-15 00:50:20.000000', 'consum', 0.0218, 'lps'),
	(586955, 129, '2014-03-15 00:50:21.000000', 'consum', 0.0219, 'lps'),
	(586956, 129, '2014-03-15 00:50:22.000000', 'consum', 0.0217, 'lps'),
	(586957, 129, '2014-03-15 00:50:23.000000', 'consum', 0.0219, 'lps'),
	(586958, 129, '2014-03-15 00:50:24.000000', 'consum', 0.0222, 'lps'),
	(586959, 129, '2014-03-15 00:50:25.000000', 'consum', 0.0212, 'lps'),
	(586960, 129, '2014-03-15 00:50:26.000000', 'consum', 0.0215, 'lps'),
	(586961, 129, '2014-03-15 00:50:27.000000', 'consum', 0.0213, 'lps'),
	(586962, 129, '2014-03-15 00:50:28.000000', 'consum', 0.0214, 'lps'),
	(586963, 129, '2014-03-15 00:50:29.000000', 'consum', 0.0219, 'lps'),
	(586964, 129, '2014-03-15 00:50:30.000000', 'consum', 0.0218, 'lps'),
	(586965, 129, '2014-03-15 00:50:31.000000', 'consum', 0.0221, 'lps'),
	(586966, 129, '2014-03-15 00:50:32.000000', 'consum', 0.0215, 'lps'),
	(586967, 129, '2014-03-15 00:50:33.000000', 'consum', 0.0217, 'lps'),
	(586968, 129, '2014-03-15 00:50:34.000000', 'consum', 0.0215, 'lps'),
	(586969, 129, '2014-03-15 00:50:35.000000', 'consum', 0.0217, 'lps'),
	(586970, 129, '2014-03-15 00:50:36.000000', 'consum', 0.0216, 'lps'),
	(586971, 129, '2014-03-15 00:50:37.000000', 'consum', 0.0217, 'lps'),
	(586972, 129, '2014-03-15 00:50:38.000000', 'consum', 0.0216, 'lps'),
	(586973, 129, '2014-03-15 00:50:39.000000', 'consum', 0.0218, 'lps'),
	(586974, 129, '2014-03-15 00:50:40.000000', 'consum', 0.0221, 'lps'),
	(586975, 129, '2014-03-15 00:50:41.000000', 'consum', 0.0211, 'lps'),
	(586976, 129, '2014-03-15 00:50:42.000000', 'consum', 0.0211, 'lps'),
	(586977, 129, '2014-03-15 00:50:43.000000', 'consum', 0.0211, 'lps'),
	(586978, 129, '2014-03-15 00:50:44.000000', 'consum', 0.0215, 'lps'),
	(586979, 129, '2014-03-15 00:50:45.000000', 'consum', 0.0218, 'lps'),
	(586980, 129, '2014-03-15 00:50:46.000000', 'consum', 0.0221, 'lps'),
	(586981, 129, '2014-03-15 00:50:47.000000', 'consum', 0.0216, 'lps'),
	(586982, 129, '2014-03-15 00:50:48.000000', 'consum', 0.0218, 'lps'),
	(586983, 129, '2014-03-15 00:50:49.000000', 'consum', 0.0219, 'lps'),
	(586984, 129, '2014-03-15 00:50:50.000000', 'consum', 0.0219, 'lps'),
	(586985, 129, '2014-03-15 00:50:51.000000', 'consum', 0.0213, 'lps'),
	(586986, 129, '2014-03-15 00:50:52.000000', 'consum', 0.0213, 'lps'),
	(586987, 129, '2014-03-15 00:50:53.000000', 'consum', 0.0216, 'lps'),
	(586988, 129, '2014-03-15 00:50:54.000000', 'consum', 0.0217, 'lps'),
	(586989, 129, '2014-03-15 00:50:55.000000', 'consum', 0.0213, 'lps'),
	(586990, 129, '2014-03-15 00:50:56.000000', 'consum', 0.0221, 'lps'),
	(586991, 129, '2014-03-15 00:50:57.000000', 'consum', 0.0214, 'lps'),
	(586992, 129, '2014-03-15 00:50:58.000000', 'consum', 0.0213, 'lps'),
	(586993, 129, '2014-03-15 00:50:59.000000', 'consum', 0.0213, 'lps'),
	(586994, 129, '2014-03-15 00:51:00.000000', 'consum', 0.0214, 'lps'),
	(586995, 129, '2014-03-15 00:51:01.000000', 'consum', 0.0210, 'lps'),
	(586996, 129, '2014-03-15 00:51:02.000000', 'consum', 0.0212, 'lps'),
	(586997, 129, '2014-03-15 00:51:03.000000', 'consum', 0.0222, 'lps'),
	(586998, 129, '2014-03-15 00:51:04.000000', 'consum', 0.0220, 'lps'),
	(586999, 129, '2014-03-15 00:51:05.000000', 'consum', 0.0212, 'lps'),
	(587000, 129, '2014-03-15 00:51:06.000000', 'consum', 0.0218, 'lps'),
	(587001, 129, '2014-03-15 00:51:07.000000', 'consum', 0.0216, 'lps'),
	(587002, 129, '2014-03-15 00:51:08.000000', 'consum', 0.0216, 'lps'),
	(587003, 129, '2014-03-15 00:51:09.000000', 'consum', 0.0222, 'lps'),
	(587004, 129, '2014-03-15 00:51:10.000000', 'consum', 0.0210, 'lps'),
	(587005, 129, '2014-03-15 00:51:11.000000', 'consum', 0.0219, 'lps'),
	(587006, 129, '2014-03-15 00:51:12.000000', 'consum', 0.0212, 'lps'),
	(587007, 129, '2014-03-15 00:51:13.000000', 'consum', 0.0222, 'lps'),
	(587008, 129, '2014-03-15 00:51:14.000000', 'consum', 0.0222, 'lps'),
	(587009, 129, '2014-03-15 00:51:15.000000', 'consum', 0.0222, 'lps'),
	(587010, 129, '2014-03-15 00:51:16.000000', 'consum', 0.0221, 'lps'),
	(587011, 129, '2014-03-15 00:51:17.000000', 'consum', 0.0216, 'lps'),
	(587012, 129, '2014-03-15 00:51:18.000000', 'consum', 0.0219, 'lps'),
	(587013, 129, '2014-03-15 00:51:19.000000', 'consum', 0.0212, 'lps'),
	(587014, 129, '2014-03-15 00:51:20.000000', 'consum', 0.0220, 'lps'),
	(587015, 129, '2014-03-15 00:51:21.000000', 'consum', 0.0212, 'lps'),
	(587016, 129, '2014-03-15 00:51:22.000000', 'consum', 0.0218, 'lps'),
	(587017, 129, '2014-03-15 00:51:23.000000', 'consum', 0.0215, 'lps'),
	(587018, 129, '2014-03-15 00:51:24.000000', 'consum', 0.0214, 'lps'),
	(587019, 129, '2014-03-15 00:51:25.000000', 'consum', 0.0214, 'lps'),
	(587020, 129, '2014-03-15 00:51:26.000000', 'consum', 0.0219, 'lps'),
	(587021, 129, '2014-03-15 00:51:27.000000', 'consum', 0.0214, 'lps'),
	(587022, 129, '2014-03-15 00:51:28.000000', 'consum', 0.0220, 'lps'),
	(587023, 129, '2014-03-15 00:51:29.000000', 'consum', 0.0221, 'lps'),
	(587024, 129, '2014-03-15 00:51:30.000000', 'consum', 0.0220, 'lps'),
	(587025, 129, '2014-03-15 00:51:31.000000', 'consum', 0.0216, 'lps'),
	(587026, 129, '2014-03-15 00:51:32.000000', 'consum', 0.0222, 'lps'),
	(587027, 129, '2014-03-15 00:51:33.000000', 'consum', 0.0213, 'lps'),
	(587028, 129, '2014-03-15 00:51:34.000000', 'consum', 0.0214, 'lps'),
	(587029, 129, '2014-03-15 00:51:35.000000', 'consum', 0.0211, 'lps'),
	(587030, 129, '2014-03-15 00:51:36.000000', 'consum', 0.0216, 'lps'),
	(587031, 129, '2014-03-15 00:51:37.000000', 'consum', 0.0211, 'lps'),
	(587032, 129, '2014-03-15 00:51:38.000000', 'consum', 0.0210, 'lps'),
	(587033, 129, '2014-03-15 00:51:39.000000', 'consum', 0.0223, 'lps'),
	(587034, 129, '2014-03-15 00:51:40.000000', 'consum', 0.0220, 'lps'),
	(587035, 129, '2014-03-15 00:51:41.000000', 'consum', 0.0219, 'lps'),
	(587036, 129, '2014-03-15 00:51:42.000000', 'consum', 0.0213, 'lps'),
	(587037, 129, '2014-03-15 00:51:43.000000', 'consum', 0.0211, 'lps'),
	(587038, 129, '2014-03-15 00:51:44.000000', 'consum', 0.0223, 'lps'),
	(587039, 129, '2014-03-15 00:51:45.000000', 'consum', 0.0214, 'lps'),
	(587040, 129, '2014-03-15 00:51:46.000000', 'consum', 0.0222, 'lps'),
	(587041, 129, '2014-03-15 00:51:47.000000', 'consum', 0.0214, 'lps'),
	(587042, 129, '2014-03-15 00:51:48.000000', 'consum', 0.0210, 'lps'),
	(587043, 129, '2014-03-15 00:51:49.000000', 'consum', 0.0213, 'lps'),
	(587044, 129, '2014-03-15 00:51:50.000000', 'consum', 0.0223, 'lps'),
	(587045, 129, '2014-03-15 00:51:51.000000', 'consum', 0.0211, 'lps'),
	(587046, 129, '2014-03-15 00:51:52.000000', 'consum', 0.0220, 'lps'),
	(587047, 129, '2014-03-15 00:51:53.000000', 'consum', 0.0215, 'lps'),
	(587048, 129, '2014-03-15 00:51:54.000000', 'consum', 0.0221, 'lps'),
	(587049, 129, '2014-03-15 00:51:55.000000', 'consum', 0.0219, 'lps'),
	(587050, 129, '2014-03-15 00:51:56.000000', 'consum', 0.0212, 'lps'),
	(587051, 129, '2014-03-15 00:51:57.000000', 'consum', 0.0219, 'lps'),
	(587052, 129, '2014-03-15 00:51:58.000000', 'consum', 0.0222, 'lps'),
	(587053, 129, '2014-03-15 00:51:59.000000', 'consum', 0.0218, 'lps'),
	(587054, 129, '2014-03-15 00:52:00.000000', 'consum', 0.0212, 'lps'),
	(587055, 129, '2014-03-15 00:52:01.000000', 'consum', 0.0211, 'lps'),
	(587056, 129, '2014-03-15 00:52:02.000000', 'consum', 0.0210, 'lps'),
	(587057, 129, '2014-03-15 00:52:03.000000', 'consum', 0.0221, 'lps'),
	(587058, 129, '2014-03-15 00:52:04.000000', 'consum', 0.0210, 'lps'),
	(587059, 129, '2014-03-15 00:52:05.000000', 'consum', 0.0219, 'lps'),
	(587060, 129, '2014-03-15 00:52:06.000000', 'consum', 0.0216, 'lps'),
	(587061, 129, '2014-03-15 00:52:07.000000', 'consum', 0.0211, 'lps'),
	(587062, 129, '2014-03-15 00:52:08.000000', 'consum', 0.0210, 'lps'),
	(587063, 129, '2014-03-15 00:52:09.000000', 'consum', 0.0210, 'lps'),
	(587064, 129, '2014-03-15 00:52:10.000000', 'consum', 0.0210, 'lps'),
	(587065, 129, '2014-03-15 00:52:11.000000', 'consum', 0.0210, 'lps'),
	(587066, 129, '2014-03-15 00:52:12.000000', 'consum', 0.0211, 'lps'),
	(587067, 129, '2014-03-15 00:52:13.000000', 'consum', 0.0214, 'lps'),
	(587068, 129, '2014-03-15 00:52:14.000000', 'consum', 0.0214, 'lps'),
	(587069, 129, '2014-03-15 00:52:15.000000', 'consum', 0.0217, 'lps'),
	(587070, 129, '2014-03-15 00:52:16.000000', 'consum', 0.0220, 'lps'),
	(587071, 129, '2014-03-15 00:52:17.000000', 'consum', 0.0214, 'lps'),
	(587072, 129, '2014-03-15 00:52:18.000000', 'consum', 0.0213, 'lps'),
	(587073, 129, '2014-03-15 00:52:19.000000', 'consum', 0.0213, 'lps'),
	(587074, 129, '2014-03-15 00:52:20.000000', 'consum', 0.0218, 'lps'),
	(587075, 129, '2014-03-15 00:52:21.000000', 'consum', 0.0211, 'lps'),
	(587076, 129, '2014-03-15 00:52:22.000000', 'consum', 0.0221, 'lps'),
	(587077, 129, '2014-03-15 00:52:23.000000', 'consum', 0.0219, 'lps'),
	(587078, 129, '2014-03-15 00:52:24.000000', 'consum', 0.0222, 'lps'),
	(587079, 129, '2014-03-15 00:52:25.000000', 'consum', 0.0216, 'lps'),
	(587080, 129, '2014-03-15 00:52:26.000000', 'consum', 0.0217, 'lps'),
	(587081, 129, '2014-03-15 00:52:27.000000', 'consum', 0.0215, 'lps'),
	(587082, 129, '2014-03-15 00:52:28.000000', 'consum', 0.0216, 'lps'),
	(587083, 129, '2014-03-15 00:52:29.000000', 'consum', 0.0211, 'lps'),
	(587084, 129, '2014-03-15 00:52:30.000000', 'consum', 0.0213, 'lps'),
	(587085, 129, '2014-03-15 00:52:31.000000', 'consum', 0.0222, 'lps'),
	(587086, 129, '2014-03-15 00:52:32.000000', 'consum', 0.0218, 'lps'),
	(587087, 129, '2014-03-15 00:52:33.000000', 'consum', 0.0215, 'lps'),
	(587088, 129, '2014-03-15 00:52:34.000000', 'consum', 0.0213, 'lps'),
	(587089, 129, '2014-03-15 00:52:35.000000', 'consum', 0.0211, 'lps'),
	(587090, 129, '2014-03-15 00:52:36.000000', 'consum', 0.0220, 'lps'),
	(587091, 129, '2014-03-15 00:52:37.000000', 'consum', 0.0214, 'lps'),
	(587092, 129, '2014-03-15 00:52:38.000000', 'consum', 0.0216, 'lps'),
	(587093, 129, '2014-03-15 00:52:39.000000', 'consum', 0.0215, 'lps'),
	(587094, 129, '2014-03-15 00:52:40.000000', 'consum', 0.0215, 'lps'),
	(587095, 129, '2014-03-15 00:52:41.000000', 'consum', 0.0210, 'lps'),
	(587096, 129, '2014-03-15 00:52:42.000000', 'consum', 0.0220, 'lps'),
	(587097, 129, '2014-03-15 00:52:43.000000', 'consum', 0.0221, 'lps'),
	(587098, 129, '2014-03-15 00:52:44.000000', 'consum', 0.0219, 'lps'),
	(587099, 129, '2014-03-15 00:52:45.000000', 'consum', 0.0210, 'lps'),
	(587100, 129, '2014-03-15 00:52:46.000000', 'consum', 0.0210, 'lps'),
	(587101, 129, '2014-03-15 00:52:47.000000', 'consum', 0.0211, 'lps'),
	(587102, 129, '2014-03-15 00:52:48.000000', 'consum', 0.0214, 'lps'),
	(587103, 129, '2014-03-15 00:52:49.000000', 'consum', 0.0215, 'lps'),
	(587104, 129, '2014-03-15 00:52:50.000000', 'consum', 0.0211, 'lps'),
	(587105, 129, '2014-03-15 00:52:51.000000', 'consum', 0.0214, 'lps'),
	(587106, 129, '2014-03-15 00:52:52.000000', 'consum', 0.0214, 'lps'),
	(587107, 129, '2014-03-15 00:52:53.000000', 'consum', 0.0217, 'lps'),
	(587108, 129, '2014-03-15 00:52:54.000000', 'consum', 0.0219, 'lps'),
	(587109, 129, '2014-03-15 00:52:55.000000', 'consum', 0.0220, 'lps'),
	(587110, 129, '2014-03-15 00:52:56.000000', 'consum', 0.0219, 'lps'),
	(587111, 129, '2014-03-15 00:52:57.000000', 'consum', 0.0211, 'lps'),
	(587112, 129, '2014-03-15 00:52:58.000000', 'consum', 0.0219, 'lps'),
	(587113, 129, '2014-03-15 00:52:59.000000', 'consum', 0.0210, 'lps'),
	(587114, 129, '2014-03-15 00:53:00.000000', 'consum', 0.0212, 'lps'),
	(587115, 129, '2014-03-15 00:53:01.000000', 'consum', 0.0220, 'lps'),
	(587116, 129, '2014-03-15 00:53:02.000000', 'consum', 0.0213, 'lps'),
	(587117, 129, '2014-03-15 00:53:03.000000', 'consum', 0.0210, 'lps'),
	(587118, 129, '2014-03-15 00:53:04.000000', 'consum', 0.0214, 'lps'),
	(587119, 129, '2014-03-15 00:53:05.000000', 'consum', 0.0217, 'lps'),
	(587120, 129, '2014-03-15 00:53:06.000000', 'consum', 0.0219, 'lps'),
	(587121, 129, '2014-03-15 00:53:07.000000', 'consum', 0.0222, 'lps'),
	(587122, 129, '2014-03-15 00:53:08.000000', 'consum', 0.0217, 'lps'),
	(587123, 129, '2014-03-15 00:53:09.000000', 'consum', 0.0221, 'lps'),
	(587124, 129, '2014-03-15 00:53:10.000000', 'consum', 0.0219, 'lps'),
	(587125, 129, '2014-03-15 00:53:11.000000', 'consum', 0.0221, 'lps'),
	(587126, 129, '2014-03-15 00:53:12.000000', 'consum', 0.0223, 'lps'),
	(587127, 129, '2014-03-15 00:53:13.000000', 'consum', 0.0215, 'lps'),
	(587128, 129, '2014-03-15 00:53:14.000000', 'consum', 0.0210, 'lps'),
	(587129, 129, '2014-03-15 00:53:15.000000', 'consum', 0.0211, 'lps'),
	(587130, 129, '2014-03-15 00:53:16.000000', 'consum', 0.0217, 'lps'),
	(587131, 129, '2014-03-15 00:53:17.000000', 'consum', 0.0212, 'lps'),
	(587132, 129, '2014-03-15 00:53:18.000000', 'consum', 0.0212, 'lps'),
	(587133, 129, '2014-03-15 00:53:19.000000', 'consum', 0.0218, 'lps'),
	(587134, 129, '2014-03-15 00:53:20.000000', 'consum', 0.0216, 'lps'),
	(587135, 129, '2014-03-15 00:53:21.000000', 'consum', 0.0216, 'lps'),
	(587136, 129, '2014-03-15 00:53:22.000000', 'consum', 0.0221, 'lps'),
	(587137, 129, '2014-03-15 00:53:23.000000', 'consum', 0.0222, 'lps'),
	(587138, 129, '2014-03-15 00:53:24.000000', 'consum', 0.0223, 'lps'),
	(587139, 129, '2014-03-15 00:53:25.000000', 'consum', 0.0210, 'lps'),
	(587140, 129, '2014-03-15 00:53:26.000000', 'consum', 0.0216, 'lps'),
	(587141, 129, '2014-03-15 00:53:27.000000', 'consum', 0.0212, 'lps'),
	(587142, 129, '2014-03-15 00:53:28.000000', 'consum', 0.0215, 'lps'),
	(587143, 129, '2014-03-15 00:53:29.000000', 'consum', 0.0218, 'lps'),
	(587144, 129, '2014-03-15 00:53:30.000000', 'consum', 0.0218, 'lps'),
	(587145, 129, '2014-03-15 00:53:31.000000', 'consum', 0.0215, 'lps'),
	(587146, 129, '2014-03-15 00:53:32.000000', 'consum', 0.0223, 'lps'),
	(587147, 129, '2014-03-15 00:53:33.000000', 'consum', 0.0222, 'lps'),
	(587148, 129, '2014-03-15 00:53:34.000000', 'consum', 0.0215, 'lps'),
	(587149, 129, '2014-03-15 00:53:35.000000', 'consum', 0.0213, 'lps'),
	(587150, 129, '2014-03-15 00:53:36.000000', 'consum', 0.0211, 'lps'),
	(587151, 129, '2014-03-15 00:53:37.000000', 'consum', 0.0219, 'lps'),
	(587152, 129, '2014-03-15 00:53:38.000000', 'consum', 0.0213, 'lps'),
	(587153, 129, '2014-03-15 00:53:39.000000', 'consum', 0.0213, 'lps'),
	(587154, 129, '2014-03-15 00:53:40.000000', 'consum', 0.0215, 'lps'),
	(587155, 129, '2014-03-15 00:53:41.000000', 'consum', 0.0214, 'lps'),
	(587156, 129, '2014-03-15 00:53:42.000000', 'consum', 0.0213, 'lps'),
	(587157, 129, '2014-03-15 00:53:43.000000', 'consum', 0.0215, 'lps'),
	(587158, 129, '2014-03-15 00:53:44.000000', 'consum', 0.0210, 'lps'),
	(587159, 129, '2014-03-15 00:53:45.000000', 'consum', 0.0213, 'lps'),
	(587160, 129, '2014-03-15 00:53:46.000000', 'consum', 0.0211, 'lps'),
	(587161, 129, '2014-03-15 00:53:47.000000', 'consum', 0.0220, 'lps'),
	(587162, 129, '2014-03-15 00:53:48.000000', 'consum', 0.0214, 'lps'),
	(587163, 129, '2014-03-15 00:53:49.000000', 'consum', 0.0215, 'lps'),
	(587164, 129, '2014-03-15 00:53:50.000000', 'consum', 0.0211, 'lps'),
	(587165, 129, '2014-03-15 00:53:51.000000', 'consum', 0.0213, 'lps'),
	(587166, 129, '2014-03-15 00:53:52.000000', 'consum', 0.0222, 'lps'),
	(587167, 129, '2014-03-15 00:53:53.000000', 'consum', 0.0221, 'lps'),
	(587168, 129, '2014-03-15 00:53:54.000000', 'consum', 0.0214, 'lps'),
	(587169, 129, '2014-03-15 00:53:55.000000', 'consum', 0.0212, 'lps'),
	(587170, 129, '2014-03-15 00:53:56.000000', 'consum', 0.0210, 'lps'),
	(587171, 129, '2014-03-15 00:53:57.000000', 'consum', 0.0219, 'lps'),
	(587172, 129, '2014-03-15 00:53:58.000000', 'consum', 0.0213, 'lps'),
	(587173, 129, '2014-03-15 00:53:59.000000', 'consum', 0.0214, 'lps'),
	(587174, 129, '2014-03-15 00:54:00.000000', 'consum', 0.0219, 'lps'),
	(587175, 129, '2014-03-15 00:54:01.000000', 'consum', 0.0217, 'lps'),
	(587176, 129, '2014-03-15 00:54:02.000000', 'consum', 0.0217, 'lps'),
	(587177, 129, '2014-03-15 00:54:03.000000', 'consum', 0.0211, 'lps'),
	(587178, 129, '2014-03-15 00:54:04.000000', 'consum', 0.0223, 'lps'),
	(587179, 129, '2014-03-15 00:54:05.000000', 'consum', 0.0216, 'lps'),
	(587180, 129, '2014-03-15 00:54:06.000000', 'consum', 0.0214, 'lps'),
	(587181, 129, '2014-03-15 00:54:07.000000', 'consum', 0.0214, 'lps'),
	(587182, 129, '2014-03-15 00:54:08.000000', 'consum', 0.0218, 'lps'),
	(587183, 129, '2014-03-15 00:54:09.000000', 'consum', 0.0212, 'lps'),
	(587184, 129, '2014-03-15 00:54:10.000000', 'consum', 0.0211, 'lps'),
	(587185, 129, '2014-03-15 00:54:11.000000', 'consum', 0.0222, 'lps'),
	(587186, 129, '2014-03-15 00:54:12.000000', 'consum', 0.0214, 'lps'),
	(587187, 129, '2014-03-15 00:54:13.000000', 'consum', 0.0220, 'lps'),
	(587188, 129, '2014-03-15 00:54:14.000000', 'consum', 0.0222, 'lps'),
	(587189, 129, '2014-03-15 00:54:15.000000', 'consum', 0.0213, 'lps'),
	(587190, 129, '2014-03-15 00:54:16.000000', 'consum', 0.0216, 'lps'),
	(587191, 129, '2014-03-15 00:54:17.000000', 'consum', 0.0219, 'lps'),
	(587192, 129, '2014-03-15 00:54:18.000000', 'consum', 0.0222, 'lps'),
	(587193, 129, '2014-03-15 00:54:19.000000', 'consum', 0.0214, 'lps'),
	(587194, 129, '2014-03-15 00:54:20.000000', 'consum', 0.0211, 'lps'),
	(587195, 129, '2014-03-15 00:54:21.000000', 'consum', 0.0217, 'lps'),
	(587196, 129, '2014-03-15 00:54:22.000000', 'consum', 0.0214, 'lps'),
	(587197, 129, '2014-03-15 00:54:23.000000', 'consum', 0.0222, 'lps'),
	(587198, 129, '2014-03-15 00:54:24.000000', 'consum', 0.0218, 'lps'),
	(587199, 129, '2014-03-15 00:54:25.000000', 'consum', 0.0214, 'lps'),
	(587200, 129, '2014-03-15 00:54:26.000000', 'consum', 0.0221, 'lps'),
	(587201, 129, '2014-03-15 00:54:27.000000', 'consum', 0.0210, 'lps'),
	(587202, 129, '2014-03-15 00:54:28.000000', 'consum', 0.0219, 'lps'),
	(587203, 129, '2014-03-15 00:54:29.000000', 'consum', 0.0213, 'lps'),
	(587204, 129, '2014-03-15 00:54:30.000000', 'consum', 0.0216, 'lps'),
	(587205, 129, '2014-03-15 00:54:31.000000', 'consum', 0.0214, 'lps'),
	(587206, 129, '2014-03-15 00:54:32.000000', 'consum', 0.0214, 'lps'),
	(587207, 129, '2014-03-15 00:54:33.000000', 'consum', 0.0216, 'lps'),
	(587208, 129, '2014-03-15 00:54:34.000000', 'consum', 0.0218, 'lps'),
	(587209, 129, '2014-03-15 00:54:35.000000', 'consum', 0.0218, 'lps'),
	(587210, 129, '2014-03-15 00:54:36.000000', 'consum', 0.0212, 'lps'),
	(587211, 129, '2014-03-15 00:54:37.000000', 'consum', 0.0222, 'lps'),
	(587212, 129, '2014-03-15 00:54:38.000000', 'consum', 0.0212, 'lps'),
	(587213, 129, '2014-03-15 00:54:39.000000', 'consum', 0.0211, 'lps'),
	(587214, 129, '2014-03-15 00:54:40.000000', 'consum', 0.0211, 'lps'),
	(587215, 129, '2014-03-15 00:54:41.000000', 'consum', 0.0213, 'lps'),
	(587216, 129, '2014-03-15 00:54:42.000000', 'consum', 0.0222, 'lps'),
	(587217, 129, '2014-03-15 00:54:43.000000', 'consum', 0.0221, 'lps'),
	(587218, 129, '2014-03-15 00:54:44.000000', 'consum', 0.0215, 'lps'),
	(587219, 129, '2014-03-15 00:54:45.000000', 'consum', 0.0216, 'lps'),
	(587220, 129, '2014-03-15 00:54:46.000000', 'consum', 0.0210, 'lps'),
	(587221, 129, '2014-03-15 00:54:47.000000', 'consum', 0.0222, 'lps'),
	(587222, 129, '2014-03-15 00:54:48.000000', 'consum', 0.0215, 'lps'),
	(587223, 129, '2014-03-15 00:54:49.000000', 'consum', 0.0215, 'lps'),
	(587224, 129, '2014-03-15 00:54:50.000000', 'consum', 0.0217, 'lps'),
	(587225, 129, '2014-03-15 00:54:51.000000', 'consum', 0.0219, 'lps'),
	(587226, 129, '2014-03-15 00:54:52.000000', 'consum', 0.0220, 'lps'),
	(587227, 129, '2014-03-15 00:54:53.000000', 'consum', 0.0219, 'lps'),
	(587228, 129, '2014-03-15 00:54:54.000000', 'consum', 0.0213, 'lps'),
	(587229, 129, '2014-03-15 00:54:55.000000', 'consum', 0.0212, 'lps'),
	(587230, 129, '2014-03-15 00:54:56.000000', 'consum', 0.0210, 'lps'),
	(587231, 129, '2014-03-15 00:54:57.000000', 'consum', 0.0219, 'lps'),
	(587232, 129, '2014-03-15 00:54:58.000000', 'consum', 0.0215, 'lps'),
	(587233, 129, '2014-03-15 00:54:59.000000', 'consum', 0.0223, 'lps'),
	(587234, 129, '2014-03-15 00:55:00.000000', 'consum', 0.0216, 'lps'),
	(587235, 129, '2014-03-15 00:55:01.000000', 'consum', 0.0216, 'lps'),
	(587236, 129, '2014-03-15 00:55:02.000000', 'consum', 0.0222, 'lps'),
	(587237, 129, '2014-03-15 00:55:03.000000', 'consum', 0.0210, 'lps'),
	(587238, 129, '2014-03-15 00:55:04.000000', 'consum', 0.0216, 'lps'),
	(587239, 129, '2014-03-15 00:55:05.000000', 'consum', 0.0213, 'lps'),
	(587240, 129, '2014-03-15 00:55:06.000000', 'consum', 0.0223, 'lps'),
	(587241, 129, '2014-03-15 00:55:07.000000', 'consum', 0.0210, 'lps'),
	(587242, 129, '2014-03-15 00:55:08.000000', 'consum', 0.0215, 'lps'),
	(587243, 129, '2014-03-15 00:55:09.000000', 'consum', 0.0219, 'lps'),
	(587244, 129, '2014-03-15 00:55:10.000000', 'consum', 0.0212, 'lps'),
	(587245, 129, '2014-03-15 00:55:11.000000', 'consum', 0.0221, 'lps'),
	(587246, 129, '2014-03-15 00:55:12.000000', 'consum', 0.0218, 'lps'),
	(587247, 129, '2014-03-15 00:55:13.000000', 'consum', 0.0219, 'lps'),
	(587248, 129, '2014-03-15 00:55:14.000000', 'consum', 0.0215, 'lps'),
	(587249, 129, '2014-03-15 00:55:15.000000', 'consum', 0.0211, 'lps'),
	(587250, 129, '2014-03-15 00:55:16.000000', 'consum', 0.0212, 'lps'),
	(587251, 129, '2014-03-15 00:55:17.000000', 'consum', 0.0218, 'lps'),
	(587252, 129, '2014-03-15 00:55:18.000000', 'consum', 0.0216, 'lps'),
	(587253, 129, '2014-03-15 00:55:19.000000', 'consum', 0.0219, 'lps'),
	(587254, 129, '2014-03-15 00:55:20.000000', 'consum', 0.0222, 'lps'),
	(587255, 129, '2014-03-15 00:55:21.000000', 'consum', 0.0214, 'lps'),
	(587256, 129, '2014-03-15 00:55:22.000000', 'consum', 0.0222, 'lps'),
	(587257, 129, '2014-03-15 00:55:23.000000', 'consum', 0.0217, 'lps'),
	(587258, 129, '2014-03-15 00:55:24.000000', 'consum', 0.0212, 'lps'),
	(587259, 129, '2014-03-15 00:55:25.000000', 'consum', 0.0211, 'lps'),
	(587260, 129, '2014-03-15 00:55:26.000000', 'consum', 0.0223, 'lps'),
	(587261, 129, '2014-03-15 00:55:27.000000', 'consum', 0.0219, 'lps'),
	(587262, 129, '2014-03-15 00:55:28.000000', 'consum', 0.0214, 'lps'),
	(587263, 129, '2014-03-15 00:55:29.000000', 'consum', 0.0220, 'lps'),
	(587264, 129, '2014-03-15 00:55:30.000000', 'consum', 0.0220, 'lps'),
	(587265, 129, '2014-03-15 00:55:31.000000', 'consum', 0.0214, 'lps'),
	(587266, 129, '2014-03-15 00:55:32.000000', 'consum', 0.0216, 'lps'),
	(587267, 129, '2014-03-15 00:55:33.000000', 'consum', 0.0216, 'lps'),
	(587268, 129, '2014-03-15 00:55:34.000000', 'consum', 0.0222, 'lps'),
	(587269, 129, '2014-03-15 00:55:35.000000', 'consum', 0.0211, 'lps'),
	(587270, 129, '2014-03-15 00:55:36.000000', 'consum', 0.0219, 'lps'),
	(587271, 129, '2014-03-15 00:55:37.000000', 'consum', 0.0213, 'lps'),
	(587272, 129, '2014-03-15 00:55:38.000000', 'consum', 0.0214, 'lps'),
	(587273, 129, '2014-03-15 00:55:39.000000', 'consum', 0.0218, 'lps'),
	(587274, 129, '2014-03-15 00:55:40.000000', 'consum', 0.0212, 'lps'),
	(587275, 129, '2014-03-15 00:55:41.000000', 'consum', 0.0212, 'lps'),
	(587276, 129, '2014-03-15 00:55:42.000000', 'consum', 0.0215, 'lps'),
	(587277, 129, '2014-03-15 00:55:43.000000', 'consum', 0.0213, 'lps'),
	(587278, 129, '2014-03-15 00:55:44.000000', 'consum', 0.0210, 'lps'),
	(587279, 129, '2014-03-15 00:55:45.000000', 'consum', 0.0216, 'lps'),
	(587280, 129, '2014-03-15 00:55:46.000000', 'consum', 0.0212, 'lps'),
	(587281, 129, '2014-03-15 00:55:47.000000', 'consum', 0.0218, 'lps'),
	(587282, 129, '2014-03-15 00:55:48.000000', 'consum', 0.0216, 'lps'),
	(587283, 129, '2014-03-15 00:55:49.000000', 'consum', 0.0216, 'lps'),
	(587284, 129, '2014-03-15 00:55:50.000000', 'consum', 0.0222, 'lps'),
	(587285, 129, '2014-03-15 00:55:51.000000', 'consum', 0.0211, 'lps'),
	(587286, 129, '2014-03-15 00:55:52.000000', 'consum', 0.0223, 'lps'),
	(587287, 129, '2014-03-15 00:55:53.000000', 'consum', 0.0217, 'lps'),
	(587288, 129, '2014-03-15 00:55:54.000000', 'consum', 0.0219, 'lps'),
	(587289, 129, '2014-03-15 00:55:55.000000', 'consum', 0.0223, 'lps'),
	(587290, 129, '2014-03-15 00:55:56.000000', 'consum', 0.0218, 'lps'),
	(587291, 129, '2014-03-15 00:55:57.000000', 'consum', 0.0212, 'lps'),
	(587292, 129, '2014-03-15 00:55:58.000000', 'consum', 0.0223, 'lps'),
	(587293, 129, '2014-03-15 00:55:59.000000', 'consum', 0.0213, 'lps'),
	(587294, 129, '2014-03-15 00:56:00.000000', 'consum', 0.0215, 'lps'),
	(587295, 129, '2014-03-15 00:56:01.000000', 'consum', 0.0214, 'lps'),
	(587296, 129, '2014-03-15 00:56:02.000000', 'consum', 0.0216, 'lps'),
	(587297, 129, '2014-03-15 00:56:03.000000', 'consum', 0.0213, 'lps'),
	(587298, 129, '2014-03-15 00:56:04.000000', 'consum', 0.0220, 'lps'),
	(587299, 129, '2014-03-15 00:56:05.000000', 'consum', 0.0212, 'lps'),
	(587300, 129, '2014-03-15 00:56:06.000000', 'consum', 0.0216, 'lps'),
	(587301, 129, '2014-03-15 00:56:07.000000', 'consum', 0.0220, 'lps'),
	(587302, 129, '2014-03-15 00:56:08.000000', 'consum', 0.0217, 'lps'),
	(587303, 129, '2014-03-15 00:56:09.000000', 'consum', 0.0215, 'lps'),
	(587304, 129, '2014-03-15 00:56:10.000000', 'consum', 0.0214, 'lps'),
	(587305, 129, '2014-03-15 00:56:11.000000', 'consum', 0.0215, 'lps'),
	(587306, 129, '2014-03-15 00:56:12.000000', 'consum', 0.0211, 'lps'),
	(587307, 129, '2014-03-15 00:56:13.000000', 'consum', 0.0213, 'lps'),
	(587308, 129, '2014-03-15 00:56:14.000000', 'consum', 0.0223, 'lps'),
	(587309, 129, '2014-03-15 00:56:15.000000', 'consum', 0.0210, 'lps'),
	(587310, 129, '2014-03-15 00:56:16.000000', 'consum', 0.0215, 'lps'),
	(587311, 129, '2014-03-15 00:56:17.000000', 'consum', 0.0221, 'lps'),
	(587312, 129, '2014-03-15 00:56:18.000000', 'consum', 0.0220, 'lps'),
	(587313, 129, '2014-03-15 00:56:19.000000', 'consum', 0.0216, 'lps'),
	(587314, 129, '2014-03-15 00:56:20.000000', 'consum', 0.0211, 'lps'),
	(587315, 129, '2014-03-15 00:56:21.000000', 'consum', 0.0211, 'lps'),
	(587316, 129, '2014-03-15 00:56:22.000000', 'consum', 0.0213, 'lps'),
	(587317, 129, '2014-03-15 00:56:23.000000', 'consum', 0.0220, 'lps'),
	(587318, 129, '2014-03-15 00:56:24.000000', 'consum', 0.0211, 'lps'),
	(587319, 129, '2014-03-15 00:56:25.000000', 'consum', 0.0214, 'lps'),
	(587320, 129, '2014-03-15 00:56:26.000000', 'consum', 0.0213, 'lps'),
	(587321, 129, '2014-03-15 00:56:27.000000', 'consum', 0.0212, 'lps'),
	(587322, 129, '2014-03-15 00:56:28.000000', 'consum', 0.0211, 'lps'),
	(587323, 129, '2014-03-15 00:56:29.000000', 'consum', 0.0210, 'lps'),
	(587324, 129, '2014-03-15 00:56:30.000000', 'consum', 0.0220, 'lps'),
	(587325, 129, '2014-03-15 00:56:31.000000', 'consum', 0.0219, 'lps'),
	(587326, 129, '2014-03-15 00:56:32.000000', 'consum', 0.0212, 'lps'),
	(587327, 129, '2014-03-15 00:56:33.000000', 'consum', 0.0222, 'lps'),
	(587328, 129, '2014-03-15 00:56:34.000000', 'consum', 0.0220, 'lps'),
	(587329, 129, '2014-03-15 00:56:35.000000', 'consum', 0.0213, 'lps'),
	(587330, 129, '2014-03-15 00:56:36.000000', 'consum', 0.0223, 'lps'),
	(587331, 129, '2014-03-15 00:56:37.000000', 'consum', 0.0211, 'lps'),
	(587332, 129, '2014-03-15 00:56:38.000000', 'consum', 0.0217, 'lps'),
	(587333, 129, '2014-03-15 00:56:39.000000', 'consum', 0.0213, 'lps'),
	(587334, 129, '2014-03-15 00:56:40.000000', 'consum', 0.0222, 'lps'),
	(587335, 129, '2014-03-15 00:56:41.000000', 'consum', 0.0218, 'lps'),
	(587336, 129, '2014-03-15 00:56:42.000000', 'consum', 0.0214, 'lps'),
	(587337, 129, '2014-03-15 00:56:43.000000', 'consum', 0.0220, 'lps'),
	(587338, 129, '2014-03-15 00:56:44.000000', 'consum', 0.0220, 'lps'),
	(587339, 129, '2014-03-15 00:56:45.000000', 'consum', 0.0218, 'lps'),
	(587340, 129, '2014-03-15 00:56:46.000000', 'consum', 0.0218, 'lps'),
	(587341, 129, '2014-03-15 00:56:47.000000', 'consum', 0.0216, 'lps'),
	(587342, 129, '2014-03-15 00:56:48.000000', 'consum', 0.0214, 'lps'),
	(587343, 129, '2014-03-15 00:56:49.000000', 'consum', 0.0213, 'lps'),
	(587344, 129, '2014-03-15 00:56:50.000000', 'consum', 0.0213, 'lps'),
	(587345, 129, '2014-03-15 00:56:51.000000', 'consum', 0.0217, 'lps'),
	(587346, 129, '2014-03-15 00:56:52.000000', 'consum', 0.0222, 'lps'),
	(587347, 129, '2014-03-15 00:56:53.000000', 'consum', 0.0222, 'lps'),
	(587348, 129, '2014-03-15 00:56:54.000000', 'consum', 0.0221, 'lps'),
	(587349, 129, '2014-03-15 00:56:55.000000', 'consum', 0.0216, 'lps'),
	(587350, 129, '2014-03-15 00:56:56.000000', 'consum', 0.0219, 'lps'),
	(587351, 129, '2014-03-15 00:56:57.000000', 'consum', 0.0211, 'lps'),
	(587352, 129, '2014-03-15 00:56:58.000000', 'consum', 0.0216, 'lps'),
	(587353, 129, '2014-03-15 00:56:59.000000', 'consum', 0.0211, 'lps'),
	(587354, 129, '2014-03-15 00:57:00.000000', 'consum', 0.0223, 'lps'),
	(587355, 129, '2014-03-15 00:57:01.000000', 'consum', 0.0216, 'lps'),
	(587356, 129, '2014-03-15 00:57:02.000000', 'consum', 0.0219, 'lps'),
	(587357, 129, '2014-03-15 00:57:03.000000', 'consum', 0.0220, 'lps'),
	(587358, 129, '2014-03-15 00:57:04.000000', 'consum', 0.0222, 'lps'),
	(587359, 129, '2014-03-15 00:57:05.000000', 'consum', 0.0212, 'lps'),
	(587360, 129, '2014-03-15 00:57:06.000000', 'consum', 0.0212, 'lps'),
	(587361, 129, '2014-03-15 00:57:07.000000', 'consum', 0.0213, 'lps'),
	(587362, 129, '2014-03-15 00:57:08.000000', 'consum', 0.0223, 'lps'),
	(587363, 129, '2014-03-15 00:57:09.000000', 'consum', 0.0221, 'lps'),
	(587364, 129, '2014-03-15 00:57:10.000000', 'consum', 0.0214, 'lps'),
	(587365, 129, '2014-03-15 00:57:11.000000', 'consum', 0.0213, 'lps'),
	(587366, 129, '2014-03-15 00:57:12.000000', 'consum', 0.0213, 'lps'),
	(587367, 129, '2014-03-15 00:57:13.000000', 'consum', 0.0217, 'lps'),
	(587368, 129, '2014-03-15 00:57:14.000000', 'consum', 0.0221, 'lps'),
	(587369, 129, '2014-03-15 00:57:15.000000', 'consum', 0.0216, 'lps'),
	(587370, 129, '2014-03-15 00:57:16.000000', 'consum', 0.0210, 'lps'),
	(587371, 129, '2014-03-15 00:57:17.000000', 'consum', 0.0220, 'lps'),
	(587372, 129, '2014-03-15 00:57:18.000000', 'consum', 0.0218, 'lps'),
	(587373, 129, '2014-03-15 00:57:19.000000', 'consum', 0.0220, 'lps'),
	(587374, 129, '2014-03-15 00:57:20.000000', 'consum', 0.0222, 'lps'),
	(587375, 129, '2014-03-15 00:57:21.000000', 'consum', 0.0215, 'lps'),
	(587376, 129, '2014-03-15 00:57:22.000000', 'consum', 0.0211, 'lps'),
	(587377, 129, '2014-03-15 00:57:23.000000', 'consum', 0.0215, 'lps'),
	(587378, 129, '2014-03-15 00:57:24.000000', 'consum', 0.0219, 'lps'),
	(587379, 129, '2014-03-15 00:57:25.000000', 'consum', 0.0211, 'lps'),
	(587380, 129, '2014-03-15 00:57:26.000000', 'consum', 0.0217, 'lps'),
	(587381, 129, '2014-03-15 00:57:27.000000', 'consum', 0.0217, 'lps'),
	(587382, 129, '2014-03-15 00:57:28.000000', 'consum', 0.0221, 'lps'),
	(587383, 129, '2014-03-15 00:57:29.000000', 'consum', 0.0218, 'lps'),
	(587384, 129, '2014-03-15 00:57:30.000000', 'consum', 0.0217, 'lps'),
	(587385, 129, '2014-03-15 00:57:31.000000', 'consum', 0.0223, 'lps'),
	(587386, 129, '2014-03-15 00:57:32.000000', 'consum', 0.0211, 'lps'),
	(587387, 129, '2014-03-15 00:57:33.000000', 'consum', 0.0219, 'lps'),
	(587388, 129, '2014-03-15 00:57:34.000000', 'consum', 0.0211, 'lps'),
	(587389, 129, '2014-03-15 00:57:35.000000', 'consum', 0.0215, 'lps'),
	(587390, 129, '2014-03-15 00:57:36.000000', 'consum', 0.0220, 'lps'),
	(587391, 129, '2014-03-15 00:57:37.000000', 'consum', 0.0215, 'lps'),
	(587392, 129, '2014-03-15 00:57:38.000000', 'consum', 0.0222, 'lps'),
	(587393, 129, '2014-03-15 00:57:39.000000', 'consum', 0.0212, 'lps'),
	(587394, 129, '2014-03-15 00:57:40.000000', 'consum', 0.0214, 'lps'),
	(587395, 129, '2014-03-15 00:57:41.000000', 'consum', 0.0212, 'lps'),
	(587396, 129, '2014-03-15 00:57:42.000000', 'consum', 0.0219, 'lps'),
	(587397, 129, '2014-03-15 00:57:43.000000', 'consum', 0.0210, 'lps'),
	(587398, 129, '2014-03-15 00:57:44.000000', 'consum', 0.0210, 'lps'),
	(587399, 129, '2014-03-15 00:57:45.000000', 'consum', 0.0211, 'lps'),
	(587400, 129, '2014-03-15 00:57:46.000000', 'consum', 0.0214, 'lps'),
	(587401, 129, '2014-03-15 00:57:47.000000', 'consum', 0.0216, 'lps'),
	(587402, 129, '2014-03-15 00:57:48.000000', 'consum', 0.0212, 'lps'),
	(587403, 129, '2014-03-15 00:57:49.000000', 'consum', 0.0217, 'lps'),
	(587404, 129, '2014-03-15 00:57:50.000000', 'consum', 0.0212, 'lps'),
	(587405, 129, '2014-03-15 00:57:51.000000', 'consum', 0.0215, 'lps'),
	(587406, 129, '2014-03-15 00:57:52.000000', 'consum', 0.0212, 'lps'),
	(587407, 129, '2014-03-15 00:57:53.000000', 'consum', 0.0223, 'lps'),
	(587408, 129, '2014-03-15 00:57:54.000000', 'consum', 0.0213, 'lps'),
	(587409, 129, '2014-03-15 00:57:55.000000', 'consum', 0.0213, 'lps'),
	(587410, 129, '2014-03-15 00:57:56.000000', 'consum', 0.0215, 'lps'),
	(587411, 129, '2014-03-15 00:57:57.000000', 'consum', 0.0216, 'lps'),
	(587412, 129, '2014-03-15 00:57:58.000000', 'consum', 0.0211, 'lps'),
	(587413, 129, '2014-03-15 00:57:59.000000', 'consum', 0.0210, 'lps'),
	(587414, 129, '2014-03-15 00:58:00.000000', 'consum', 0.0221, 'lps'),
	(587415, 129, '2014-03-15 00:58:01.000000', 'consum', 0.0211, 'lps'),
	(587416, 129, '2014-03-15 00:58:02.000000', 'consum', 0.0210, 'lps'),
	(587417, 129, '2014-03-15 00:58:03.000000', 'consum', 0.0221, 'lps'),
	(587418, 129, '2014-03-15 00:58:04.000000', 'consum', 0.0210, 'lps'),
	(587419, 129, '2014-03-15 00:58:05.000000', 'consum', 0.0219, 'lps'),
	(587420, 129, '2014-03-15 00:58:06.000000', 'consum', 0.0215, 'lps'),
	(587421, 129, '2014-03-15 00:58:07.000000', 'consum', 0.0222, 'lps'),
	(587422, 129, '2014-03-15 00:58:08.000000', 'consum', 0.0215, 'lps'),
	(587423, 129, '2014-03-15 00:58:09.000000', 'consum', 0.0214, 'lps'),
	(587424, 129, '2014-03-15 00:58:10.000000', 'consum', 0.0213, 'lps'),
	(587425, 129, '2014-03-15 00:58:11.000000', 'consum', 0.0212, 'lps'),
	(587426, 129, '2014-03-15 00:58:12.000000', 'consum', 0.0215, 'lps'),
	(587427, 129, '2014-03-15 00:58:13.000000', 'consum', 0.0214, 'lps'),
	(587428, 129, '2014-03-15 00:58:14.000000', 'consum', 0.0214, 'lps'),
	(587429, 129, '2014-03-15 00:58:15.000000', 'consum', 0.0220, 'lps'),
	(587430, 129, '2014-03-15 00:58:16.000000', 'consum', 0.0221, 'lps'),
	(587431, 129, '2014-03-15 00:58:17.000000', 'consum', 0.0223, 'lps'),
	(587432, 129, '2014-03-15 00:58:18.000000', 'consum', 0.0212, 'lps'),
	(587433, 129, '2014-03-15 00:58:19.000000', 'consum', 0.0210, 'lps'),
	(587434, 129, '2014-03-15 00:58:20.000000', 'consum', 0.0220, 'lps'),
	(587435, 129, '2014-03-15 00:58:21.000000', 'consum', 0.0216, 'lps'),
	(587436, 129, '2014-03-15 00:58:22.000000', 'consum', 0.0214, 'lps'),
	(587437, 129, '2014-03-15 00:58:23.000000', 'consum', 0.0210, 'lps'),
	(587438, 129, '2014-03-15 00:58:24.000000', 'consum', 0.0212, 'lps'),
	(587439, 129, '2014-03-15 00:58:25.000000', 'consum', 0.0219, 'lps'),
	(587440, 129, '2014-03-15 00:58:26.000000', 'consum', 0.0211, 'lps'),
	(587441, 129, '2014-03-15 00:58:27.000000', 'consum', 0.0215, 'lps'),
	(587442, 129, '2014-03-15 00:58:28.000000', 'consum', 0.0220, 'lps'),
	(587443, 129, '2014-03-15 00:58:29.000000', 'consum', 0.0216, 'lps'),
	(587444, 129, '2014-03-15 00:58:30.000000', 'consum', 0.0223, 'lps'),
	(587445, 129, '2014-03-15 00:58:31.000000', 'consum', 0.0216, 'lps'),
	(587446, 129, '2014-03-15 00:58:32.000000', 'consum', 0.0214, 'lps'),
	(587447, 129, '2014-03-15 00:58:33.000000', 'consum', 0.0216, 'lps'),
	(587448, 129, '2014-03-15 00:58:34.000000', 'consum', 0.0212, 'lps'),
	(587449, 129, '2014-03-15 00:58:35.000000', 'consum', 0.0216, 'lps'),
	(587450, 129, '2014-03-15 00:58:36.000000', 'consum', 0.0219, 'lps'),
	(587451, 129, '2014-03-15 00:58:37.000000', 'consum', 0.0212, 'lps'),
	(587452, 129, '2014-03-15 00:58:38.000000', 'consum', 0.0223, 'lps'),
	(587453, 129, '2014-03-15 00:58:39.000000', 'consum', 0.0211, 'lps'),
	(587454, 129, '2014-03-15 00:58:40.000000', 'consum', 0.0221, 'lps'),
	(587455, 129, '2014-03-15 00:58:41.000000', 'consum', 0.0219, 'lps'),
	(587456, 129, '2014-03-15 00:58:42.000000', 'consum', 0.0223, 'lps'),
	(587457, 129, '2014-03-15 00:58:43.000000', 'consum', 0.0219, 'lps'),
	(587458, 129, '2014-03-15 00:58:44.000000', 'consum', 0.0217, 'lps'),
	(587459, 129, '2014-03-15 00:58:45.000000', 'consum', 0.0219, 'lps'),
	(587460, 129, '2014-03-15 00:58:46.000000', 'consum', 0.0221, 'lps'),
	(587461, 129, '2014-03-15 00:58:47.000000', 'consum', 0.0222, 'lps'),
	(587462, 129, '2014-03-15 00:58:48.000000', 'consum', 0.0211, 'lps'),
	(587463, 129, '2014-03-15 00:58:49.000000', 'consum', 0.0223, 'lps'),
	(587464, 129, '2014-03-15 00:58:50.000000', 'consum', 0.0214, 'lps'),
	(587465, 129, '2014-03-15 00:58:51.000000', 'consum', 0.0222, 'lps'),
	(587466, 129, '2014-03-15 00:58:52.000000', 'consum', 0.0213, 'lps'),
	(587467, 129, '2014-03-15 00:58:53.000000', 'consum', 0.0221, 'lps'),
	(587468, 129, '2014-03-15 00:58:54.000000', 'consum', 0.0213, 'lps'),
	(587469, 129, '2014-03-15 00:58:55.000000', 'consum', 0.0220, 'lps'),
	(587470, 129, '2014-03-15 00:58:56.000000', 'consum', 0.0210, 'lps'),
	(587471, 129, '2014-03-15 00:58:57.000000', 'consum', 0.0210, 'lps'),
	(587472, 129, '2014-03-15 00:58:58.000000', 'consum', 0.0222, 'lps'),
	(587473, 129, '2014-03-15 00:58:59.000000', 'consum', 0.0216, 'lps'),
	(587474, 129, '2014-03-15 00:59:00.000000', 'consum', 0.0218, 'lps'),
	(587475, 129, '2014-03-15 00:59:01.000000', 'consum', 0.0218, 'lps'),
	(587476, 129, '2014-03-15 00:59:02.000000', 'consum', 0.0212, 'lps'),
	(587477, 129, '2014-03-15 00:59:03.000000', 'consum', 0.0210, 'lps'),
	(587478, 129, '2014-03-15 00:59:04.000000', 'consum', 0.0219, 'lps'),
	(587479, 129, '2014-03-15 00:59:05.000000', 'consum', 0.0213, 'lps'),
	(587480, 129, '2014-03-15 00:59:06.000000', 'consum', 0.0214, 'lps'),
	(587481, 129, '2014-03-15 00:59:07.000000', 'consum', 0.0219, 'lps'),
	(587482, 129, '2014-03-15 00:59:08.000000', 'consum', 0.0218, 'lps'),
	(587483, 129, '2014-03-15 00:59:09.000000', 'consum', 0.0221, 'lps'),
	(587484, 129, '2014-03-15 00:59:10.000000', 'consum', 0.0216, 'lps'),
	(587485, 129, '2014-03-15 00:59:11.000000', 'consum', 0.0221, 'lps'),
	(587486, 129, '2014-03-15 00:59:12.000000', 'consum', 0.0219, 'lps'),
	(587487, 129, '2014-03-15 00:59:13.000000', 'consum', 0.0222, 'lps'),
	(587488, 129, '2014-03-15 00:59:14.000000', 'consum', 0.0217, 'lps'),
	(587489, 129, '2014-03-15 00:59:15.000000', 'consum', 0.0210, 'lps'),
	(587490, 129, '2014-03-15 00:59:16.000000', 'consum', 0.0216, 'lps'),
	(587491, 129, '2014-03-15 00:59:17.000000', 'consum', 0.0213, 'lps'),
	(587492, 129, '2014-03-15 00:59:18.000000', 'consum', 0.0222, 'lps'),
	(587493, 129, '2014-03-15 00:59:19.000000', 'consum', 0.0218, 'lps'),
	(587494, 129, '2014-03-15 00:59:20.000000', 'consum', 0.0215, 'lps'),
	(587495, 129, '2014-03-15 00:59:21.000000', 'consum', 0.0211, 'lps'),
	(587496, 129, '2014-03-15 00:59:22.000000', 'consum', 0.0217, 'lps'),
	(587497, 129, '2014-03-15 00:59:23.000000', 'consum', 0.0212, 'lps'),
	(587498, 129, '2014-03-15 00:59:24.000000', 'consum', 0.0215, 'lps'),
	(587499, 129, '2014-03-15 00:59:25.000000', 'consum', 0.0215, 'lps'),
	(587500, 129, '2014-03-15 00:59:26.000000', 'consum', 0.0222, 'lps'),
	(587501, 129, '2014-03-15 00:59:27.000000', 'consum', 0.0212, 'lps'),
	(587502, 129, '2014-03-15 00:59:28.000000', 'consum', 0.0211, 'lps'),
	(587503, 129, '2014-03-15 00:59:29.000000', 'consum', 0.0212, 'lps'),
	(587504, 129, '2014-03-15 00:59:30.000000', 'consum', 0.0218, 'lps'),
	(587505, 129, '2014-03-15 00:59:31.000000', 'consum', 0.0215, 'lps'),
	(587506, 129, '2014-03-15 00:59:32.000000', 'consum', 0.0211, 'lps'),
	(587507, 129, '2014-03-15 00:59:33.000000', 'consum', 0.0216, 'lps'),
	(587508, 129, '2014-03-15 00:59:34.000000', 'consum', 0.0223, 'lps'),
	(587509, 129, '2014-03-15 00:59:35.000000', 'consum', 0.0214, 'lps'),
	(587510, 129, '2014-03-15 00:59:36.000000', 'consum', 0.0220, 'lps'),
	(587511, 129, '2014-03-15 00:59:37.000000', 'consum', 0.0219, 'lps'),
	(587512, 129, '2014-03-15 00:59:38.000000', 'consum', 0.0213, 'lps'),
	(587513, 129, '2014-03-15 00:59:39.000000', 'consum', 0.0213, 'lps'),
	(587514, 129, '2014-03-15 00:59:40.000000', 'consum', 0.0217, 'lps'),
	(587515, 129, '2014-03-15 00:59:41.000000', 'consum', 0.0221, 'lps'),
	(587516, 129, '2014-03-15 00:59:42.000000', 'consum', 0.0216, 'lps'),
	(587517, 129, '2014-03-15 00:59:43.000000', 'consum', 0.0220, 'lps'),
	(587518, 129, '2014-03-15 00:59:44.000000', 'consum', 0.0218, 'lps'),
	(587519, 129, '2014-03-15 00:59:45.000000', 'consum', 0.0218, 'lps'),
	(587520, 129, '2014-03-15 00:59:46.000000', 'consum', 0.0212, 'lps'),
	(587521, 129, '2014-03-15 00:59:47.000000', 'consum', 0.0212, 'lps'),
	(587522, 129, '2014-03-15 00:59:48.000000', 'consum', 0.0215, 'lps'),
	(587523, 129, '2014-03-15 00:59:49.000000', 'consum', 0.0213, 'lps'),
	(587524, 129, '2014-03-15 00:59:50.000000', 'consum', 0.0214, 'lps'),
	(587525, 129, '2014-03-15 00:59:51.000000', 'consum', 0.0219, 'lps'),
	(587526, 129, '2014-03-15 00:59:52.000000', 'consum', 0.0217, 'lps'),
	(587527, 129, '2014-03-15 00:59:53.000000', 'consum', 0.0216, 'lps'),
	(587528, 129, '2014-03-15 00:59:54.000000', 'consum', 0.0220, 'lps'),
	(587529, 129, '2014-03-15 00:59:55.000000', 'consum', 0.0216, 'lps'),
	(587530, 129, '2014-03-15 00:59:56.000000', 'consum', 0.0212, 'lps'),
	(587531, 129, '2014-03-15 00:59:57.000000', 'consum', 0.0215, 'lps'),
	(587532, 129, '2014-03-15 00:59:58.000000', 'consum', 0.0215, 'lps'),
	(587533, 129, '2014-03-15 00:59:59.000000', 'consum', 0.0220, 'lps'),
	(587534, 129, '2014-03-15 01:00:00.000000', 'consum', 0.0218, 'lps'),
	(587535, 129, '2014-03-15 01:00:01.000000', 'consum', 0.0219, 'lps'),
	(587536, 129, '2014-03-15 01:00:02.000000', 'consum', 0.0219, 'lps'),
	(587537, 129, '2014-03-15 01:00:03.000000', 'consum', 0.0213, 'lps'),
	(587538, 129, '2014-03-15 01:00:04.000000', 'consum', 0.0215, 'lps'),
	(587539, 129, '2014-03-15 01:00:05.000000', 'consum', 0.0223, 'lps'),
	(587540, 129, '2014-03-15 01:00:06.000000', 'consum', 0.0221, 'lps'),
	(587541, 129, '2014-03-15 01:00:07.000000', 'consum', 0.0212, 'lps'),
	(587542, 129, '2014-03-15 01:00:08.000000', 'consum', 0.0215, 'lps'),
	(587543, 129, '2014-03-15 01:00:09.000000', 'consum', 0.0214, 'lps'),
	(587544, 129, '2014-03-15 01:00:10.000000', 'consum', 0.0218, 'lps'),
	(587545, 129, '2014-03-15 01:00:11.000000', 'consum', 0.0211, 'lps'),
	(587546, 129, '2014-03-15 01:00:12.000000', 'consum', 0.0219, 'lps'),
	(587547, 129, '2014-03-15 01:00:13.000000', 'consum', 0.0211, 'lps'),
	(587548, 129, '2014-03-15 01:00:14.000000', 'consum', 0.0215, 'lps'),
	(587549, 129, '2014-03-15 01:00:15.000000', 'consum', 0.0220, 'lps'),
	(587550, 129, '2014-03-15 01:00:16.000000', 'consum', 0.0216, 'lps'),
	(587551, 129, '2014-03-15 01:00:17.000000', 'consum', 0.0212, 'lps'),
	(587552, 129, '2014-03-15 01:00:18.000000', 'consum', 0.0215, 'lps'),
	(587553, 129, '2014-03-15 01:00:19.000000', 'consum', 0.0218, 'lps'),
	(587554, 129, '2014-03-15 01:00:20.000000', 'consum', 0.0219, 'lps'),
	(587555, 129, '2014-03-15 01:00:21.000000', 'consum', 0.0218, 'lps'),
	(587556, 129, '2014-03-15 01:00:22.000000', 'consum', 0.0223, 'lps'),
	(587557, 129, '2014-03-15 01:00:23.000000', 'consum', 0.0212, 'lps'),
	(587558, 129, '2014-03-15 01:00:24.000000', 'consum', 0.0222, 'lps'),
	(587559, 129, '2014-03-15 01:00:25.000000', 'consum', 0.0220, 'lps'),
	(587560, 129, '2014-03-15 01:00:26.000000', 'consum', 0.0214, 'lps'),
	(587561, 129, '2014-03-15 01:00:27.000000', 'consum', 0.0215, 'lps'),
	(587562, 129, '2014-03-15 01:00:28.000000', 'consum', 0.0221, 'lps'),
	(587563, 129, '2014-03-15 01:00:29.000000', 'consum', 0.0223, 'lps'),
	(587564, 129, '2014-03-15 01:00:30.000000', 'consum', 0.0214, 'lps'),
	(587565, 129, '2014-03-15 01:00:31.000000', 'consum', 0.0222, 'lps'),
	(587566, 129, '2014-03-15 01:00:32.000000', 'consum', 0.0215, 'lps'),
	(587567, 129, '2014-03-15 01:00:33.000000', 'consum', 0.0215, 'lps'),
	(587568, 129, '2014-03-15 01:00:34.000000', 'consum', 0.0218, 'lps'),
	(587569, 129, '2014-03-15 01:00:35.000000', 'consum', 0.0223, 'lps'),
	(587570, 129, '2014-03-15 01:00:36.000000', 'consum', 0.0223, 'lps'),
	(587571, 129, '2014-03-15 01:00:37.000000', 'consum', 0.0222, 'lps'),
	(587572, 129, '2014-03-15 01:00:38.000000', 'consum', 0.0217, 'lps'),
	(587573, 129, '2014-03-15 01:00:39.000000', 'consum', 0.0210, 'lps'),
	(587574, 129, '2014-03-15 01:00:40.000000', 'consum', 0.0217, 'lps'),
	(587575, 129, '2014-03-15 01:00:41.000000', 'consum', 0.0217, 'lps'),
	(587576, 129, '2014-03-15 01:00:42.000000', 'consum', 0.0213, 'lps'),
	(587577, 129, '2014-03-15 01:00:43.000000', 'consum', 0.0215, 'lps'),
	(587578, 129, '2014-03-15 01:00:44.000000', 'consum', 0.0215, 'lps'),
	(587579, 129, '2014-03-15 01:00:45.000000', 'consum', 0.0220, 'lps'),
	(587580, 129, '2014-03-15 01:00:46.000000', 'consum', 0.0217, 'lps'),
	(587581, 129, '2014-03-15 01:00:47.000000', 'consum', 0.0218, 'lps'),
	(587582, 129, '2014-03-15 01:00:48.000000', 'consum', 0.0213, 'lps'),
	(587583, 129, '2014-03-15 01:00:49.000000', 'consum', 0.0215, 'lps'),
	(587584, 129, '2014-03-15 01:00:50.000000', 'consum', 0.0215, 'lps'),
	(587585, 129, '2014-03-15 01:00:51.000000', 'consum', 0.0219, 'lps'),
	(587586, 129, '2014-03-15 01:00:52.000000', 'consum', 0.0212, 'lps'),
	(587587, 129, '2014-03-15 01:00:53.000000', 'consum', 0.0222, 'lps'),
	(587588, 129, '2014-03-15 01:00:54.000000', 'consum', 0.0210, 'lps'),
	(587589, 129, '2014-03-15 01:00:55.000000', 'consum', 0.0216, 'lps'),
	(587590, 129, '2014-03-15 01:00:56.000000', 'consum', 0.0213, 'lps'),
	(587591, 129, '2014-03-15 01:00:57.000000', 'consum', 0.0221, 'lps'),
	(587592, 129, '2014-03-15 01:00:58.000000', 'consum', 0.0213, 'lps'),
	(587593, 129, '2014-03-15 01:00:59.000000', 'consum', 0.0223, 'lps'),
	(587594, 129, '2014-03-15 01:01:00.000000', 'consum', 0.0222, 'lps'),
	(587595, 129, '2014-03-15 01:01:01.000000', 'consum', 0.0218, 'lps'),
	(587596, 129, '2014-03-15 01:01:02.000000', 'consum', 0.0214, 'lps'),
	(587597, 129, '2014-03-15 01:01:03.000000', 'consum', 0.0223, 'lps'),
	(587598, 129, '2014-03-15 01:01:04.000000', 'consum', 0.0220, 'lps'),
	(587599, 129, '2014-03-15 01:01:05.000000', 'consum', 0.0222, 'lps'),
	(587600, 129, '2014-03-15 01:01:06.000000', 'consum', 0.0214, 'lps'),
	(587601, 129, '2014-03-15 01:01:07.000000', 'consum', 0.0221, 'lps'),
	(587602, 129, '2014-03-15 01:01:08.000000', 'consum', 0.0211, 'lps'),
	(587603, 129, '2014-03-15 01:01:09.000000', 'consum', 0.0212, 'lps'),
	(587604, 129, '2014-03-15 01:01:10.000000', 'consum', 0.0215, 'lps'),
	(587605, 129, '2014-03-15 01:01:11.000000', 'consum', 0.0218, 'lps'),
	(587606, 129, '2014-03-15 01:01:12.000000', 'consum', 0.0222, 'lps'),
	(587607, 129, '2014-03-15 01:01:13.000000', 'consum', 0.0217, 'lps'),
	(587608, 129, '2014-03-15 01:01:14.000000', 'consum', 0.0211, 'lps'),
	(587609, 129, '2014-03-15 01:01:15.000000', 'consum', 0.0223, 'lps'),
	(587610, 129, '2014-03-15 01:01:16.000000', 'consum', 0.0217, 'lps'),
	(587611, 129, '2014-03-15 01:01:17.000000', 'consum', 0.0218, 'lps'),
	(587612, 129, '2014-03-15 01:01:18.000000', 'consum', 0.0217, 'lps'),
	(587613, 129, '2014-03-15 01:01:19.000000', 'consum', 0.0219, 'lps'),
	(587614, 129, '2014-03-15 01:01:20.000000', 'consum', 0.0223, 'lps'),
	(587615, 129, '2014-03-15 01:01:21.000000', 'consum', 0.0221, 'lps'),
	(587616, 129, '2014-03-15 01:01:22.000000', 'consum', 0.0211, 'lps'),
	(587617, 129, '2014-03-15 01:01:23.000000', 'consum', 0.0212, 'lps'),
	(587618, 129, '2014-03-15 01:01:24.000000', 'consum', 0.0219, 'lps'),
	(587619, 129, '2014-03-15 01:01:25.000000', 'consum', 0.0219, 'lps'),
	(587620, 129, '2014-03-15 01:01:26.000000', 'consum', 0.0216, 'lps'),
	(587621, 129, '2014-03-15 01:01:27.000000', 'consum', 0.0211, 'lps'),
	(587622, 129, '2014-03-15 01:01:28.000000', 'consum', 0.0213, 'lps'),
	(587623, 129, '2014-03-15 01:01:29.000000', 'consum', 0.0221, 'lps'),
	(587624, 129, '2014-03-15 01:01:30.000000', 'consum', 0.0215, 'lps'),
	(587625, 129, '2014-03-15 01:01:31.000000', 'consum', 0.0216, 'lps'),
	(587626, 129, '2014-03-15 01:01:32.000000', 'consum', 0.0214, 'lps'),
	(587627, 129, '2014-03-15 01:01:33.000000', 'consum', 0.0210, 'lps'),
	(587628, 129, '2014-03-15 01:01:34.000000', 'consum', 0.0212, 'lps'),
	(587629, 129, '2014-03-15 01:01:35.000000', 'consum', 0.0221, 'lps'),
	(587630, 129, '2014-03-15 01:01:36.000000', 'consum', 0.0219, 'lps'),
	(587631, 129, '2014-03-15 01:01:37.000000', 'consum', 0.0222, 'lps'),
	(587632, 129, '2014-03-15 01:01:38.000000', 'consum', 0.0214, 'lps'),
	(587633, 129, '2014-03-15 01:01:39.000000', 'consum', 0.0221, 'lps'),
	(587634, 129, '2014-03-15 01:01:40.000000', 'consum', 0.0214, 'lps'),
	(587635, 129, '2014-03-15 01:01:41.000000', 'consum', 0.0213, 'lps'),
	(587636, 129, '2014-03-15 01:01:42.000000', 'consum', 0.0211, 'lps'),
	(587637, 129, '2014-03-15 01:01:43.000000', 'consum', 0.0223, 'lps'),
	(587638, 129, '2014-03-15 01:01:44.000000', 'consum', 0.0215, 'lps'),
	(587639, 129, '2014-03-15 01:01:45.000000', 'consum', 0.0223, 'lps'),
	(587640, 129, '2014-03-15 01:01:46.000000', 'consum', 0.0220, 'lps'),
	(587641, 129, '2014-03-15 01:01:47.000000', 'consum', 0.0223, 'lps'),
	(587642, 129, '2014-03-15 01:01:48.000000', 'consum', 0.0216, 'lps'),
	(587643, 129, '2014-03-15 01:01:49.000000', 'consum', 0.0217, 'lps'),
	(587644, 129, '2014-03-15 01:01:50.000000', 'consum', 0.0212, 'lps'),
	(587645, 129, '2014-03-15 01:01:51.000000', 'consum', 0.0213, 'lps'),
	(587646, 129, '2014-03-15 01:01:52.000000', 'consum', 0.0220, 'lps'),
	(587647, 129, '2014-03-15 01:01:53.000000', 'consum', 0.0211, 'lps'),
	(587648, 129, '2014-03-15 01:01:54.000000', 'consum', 0.0212, 'lps'),
	(587649, 129, '2014-03-15 01:01:55.000000', 'consum', 0.0220, 'lps'),
	(587650, 129, '2014-03-15 01:01:56.000000', 'consum', 0.0223, 'lps'),
	(587651, 129, '2014-03-15 01:01:57.000000', 'consum', 0.0220, 'lps'),
	(587652, 129, '2014-03-15 01:01:58.000000', 'consum', 0.0219, 'lps'),
	(587653, 129, '2014-03-15 01:01:59.000000', 'consum', 0.0213, 'lps'),
	(587654, 129, '2014-03-15 01:02:00.000000', 'consum', 0.0213, 'lps'),
	(587655, 129, '2014-03-15 01:02:01.000000', 'consum', 0.0215, 'lps'),
	(587656, 129, '2014-03-15 01:02:02.000000', 'consum', 0.0212, 'lps'),
	(587657, 129, '2014-03-15 01:02:03.000000', 'consum', 0.0219, 'lps'),
	(587658, 129, '2014-03-15 01:02:04.000000', 'consum', 0.0222, 'lps'),
	(587659, 129, '2014-03-15 01:02:05.000000', 'consum', 0.0216, 'lps'),
	(587660, 129, '2014-03-15 01:02:06.000000', 'consum', 0.0220, 'lps'),
	(587661, 129, '2014-03-15 01:02:07.000000', 'consum', 0.0214, 'lps'),
	(587662, 129, '2014-03-15 01:02:08.000000', 'consum', 0.0215, 'lps'),
	(587663, 129, '2014-03-15 01:02:09.000000', 'consum', 0.0210, 'lps'),
	(587664, 129, '2014-03-15 01:02:10.000000', 'consum', 0.0210, 'lps'),
	(587665, 129, '2014-03-15 01:02:11.000000', 'consum', 0.0223, 'lps'),
	(587666, 129, '2014-03-15 01:02:12.000000', 'consum', 0.0221, 'lps'),
	(587667, 129, '2014-03-15 01:02:13.000000', 'consum', 0.0214, 'lps'),
	(587668, 129, '2014-03-15 01:02:14.000000', 'consum', 0.0223, 'lps'),
	(587669, 129, '2014-03-15 01:02:15.000000', 'consum', 0.0210, 'lps'),
	(587670, 129, '2014-03-15 01:02:16.000000', 'consum', 0.0212, 'lps'),
	(587671, 129, '2014-03-15 01:02:17.000000', 'consum', 0.0220, 'lps'),
	(587672, 129, '2014-03-15 01:02:18.000000', 'consum', 0.0212, 'lps'),
	(587673, 129, '2014-03-15 01:02:19.000000', 'consum', 0.0217, 'lps'),
	(587674, 129, '2014-03-15 01:02:20.000000', 'consum', 0.0215, 'lps'),
	(587675, 129, '2014-03-15 01:02:21.000000', 'consum', 0.0213, 'lps'),
	(587676, 129, '2014-03-15 01:02:22.000000', 'consum', 0.0223, 'lps'),
	(587677, 129, '2014-03-15 01:02:23.000000', 'consum', 0.0213, 'lps'),
	(587678, 129, '2014-03-15 01:02:24.000000', 'consum', 0.0215, 'lps'),
	(587679, 129, '2014-03-15 01:02:25.000000', 'consum', 0.0210, 'lps'),
	(587680, 129, '2014-03-15 01:02:26.000000', 'consum', 0.0212, 'lps'),
	(587681, 129, '2014-03-15 01:02:27.000000', 'consum', 0.0218, 'lps'),
	(587682, 129, '2014-03-15 01:02:28.000000', 'consum', 0.0217, 'lps'),
	(587683, 129, '2014-03-15 01:02:29.000000', 'consum', 0.0223, 'lps'),
	(587684, 129, '2014-03-15 01:02:30.000000', 'consum', 0.0210, 'lps'),
	(587685, 129, '2014-03-15 01:02:31.000000', 'consum', 0.0213, 'lps'),
	(587686, 129, '2014-03-15 01:02:32.000000', 'consum', 0.0213, 'lps'),
	(587687, 129, '2014-03-15 01:02:33.000000', 'consum', 0.0218, 'lps'),
	(587688, 129, '2014-03-15 01:02:34.000000', 'consum', 0.0212, 'lps'),
	(587689, 129, '2014-03-15 01:02:35.000000', 'consum', 0.0223, 'lps'),
	(587690, 129, '2014-03-15 01:02:36.000000', 'consum', 0.0215, 'lps'),
	(587691, 129, '2014-03-15 01:02:37.000000', 'consum', 0.0223, 'lps'),
	(587692, 129, '2014-03-15 01:02:38.000000', 'consum', 0.0218, 'lps'),
	(587693, 129, '2014-03-15 01:02:39.000000', 'consum', 0.0211, 'lps'),
	(587694, 129, '2014-03-15 01:02:40.000000', 'consum', 0.0221, 'lps'),
	(587695, 129, '2014-03-15 01:02:41.000000', 'consum', 0.0221, 'lps'),
	(587696, 129, '2014-03-15 01:02:42.000000', 'consum', 0.0216, 'lps'),
	(587697, 129, '2014-03-15 01:02:43.000000', 'consum', 0.0210, 'lps'),
	(587698, 129, '2014-03-15 01:02:44.000000', 'consum', 0.0220, 'lps'),
	(587699, 129, '2014-03-15 01:02:45.000000', 'consum', 0.0220, 'lps'),
	(587700, 129, '2014-03-15 01:02:46.000000', 'consum', 0.0214, 'lps'),
	(587701, 129, '2014-03-15 01:02:47.000000', 'consum', 0.0216, 'lps'),
	(587702, 129, '2014-03-15 01:02:48.000000', 'consum', 0.0213, 'lps'),
	(587703, 129, '2014-03-15 01:02:49.000000', 'consum', 0.0223, 'lps'),
	(587704, 129, '2014-03-15 01:02:50.000000', 'consum', 0.0211, 'lps'),
	(587705, 129, '2014-03-15 01:02:51.000000', 'consum', 0.0217, 'lps'),
	(587706, 129, '2014-03-15 01:02:52.000000', 'consum', 0.0216, 'lps'),
	(587707, 129, '2014-03-15 01:02:53.000000', 'consum', 0.0217, 'lps'),
	(587708, 129, '2014-03-15 01:02:54.000000', 'consum', 0.0214, 'lps'),
	(587709, 129, '2014-03-15 01:02:55.000000', 'consum', 0.0212, 'lps'),
	(587710, 129, '2014-03-15 01:02:56.000000', 'consum', 0.0220, 'lps'),
	(587711, 129, '2014-03-15 01:02:57.000000', 'consum', 0.0213, 'lps'),
	(587712, 129, '2014-03-15 01:02:58.000000', 'consum', 0.0211, 'lps'),
	(587713, 129, '2014-03-15 01:02:59.000000', 'consum', 0.0220, 'lps'),
	(587714, 129, '2014-03-15 01:03:00.000000', 'consum', 0.0215, 'lps'),
	(587715, 129, '2014-03-15 01:03:01.000000', 'consum', 0.0218, 'lps'),
	(587716, 129, '2014-03-15 01:03:02.000000', 'consum', 0.0210, 'lps'),
	(587717, 129, '2014-03-15 01:03:03.000000', 'consum', 0.0214, 'lps'),
	(587718, 129, '2014-03-15 01:03:04.000000', 'consum', 0.0218, 'lps'),
	(587719, 129, '2014-03-15 01:03:05.000000', 'consum', 0.0210, 'lps'),
	(587720, 129, '2014-03-15 01:03:06.000000', 'consum', 0.0214, 'lps'),
	(587721, 129, '2014-03-15 01:03:07.000000', 'consum', 0.0216, 'lps'),
	(587722, 129, '2014-03-15 01:03:08.000000', 'consum', 0.0215, 'lps'),
	(587723, 129, '2014-03-15 01:03:09.000000', 'consum', 0.0217, 'lps'),
	(587724, 129, '2014-03-15 01:03:10.000000', 'consum', 0.0217, 'lps'),
	(587725, 129, '2014-03-15 01:03:11.000000', 'consum', 0.0212, 'lps'),
	(587726, 129, '2014-03-15 01:03:12.000000', 'consum', 0.0212, 'lps'),
	(587727, 129, '2014-03-15 01:03:13.000000', 'consum', 0.0213, 'lps'),
	(587728, 129, '2014-03-15 01:03:14.000000', 'consum', 0.0222, 'lps'),
	(587729, 129, '2014-03-15 01:03:15.000000', 'consum', 0.0220, 'lps'),
	(587730, 129, '2014-03-15 01:03:16.000000', 'consum', 0.0222, 'lps'),
	(587731, 129, '2014-03-15 01:03:17.000000', 'consum', 0.0213, 'lps'),
	(587732, 129, '2014-03-15 01:03:18.000000', 'consum', 0.0217, 'lps'),
	(587733, 129, '2014-03-15 01:03:19.000000', 'consum', 0.0223, 'lps'),
	(587734, 129, '2014-03-15 01:03:20.000000', 'consum', 0.0213, 'lps'),
	(587735, 129, '2014-03-15 01:03:21.000000', 'consum', 0.0216, 'lps'),
	(587736, 129, '2014-03-15 01:03:22.000000', 'consum', 0.0215, 'lps'),
	(587737, 129, '2014-03-15 01:03:23.000000', 'consum', 0.0217, 'lps'),
	(587738, 129, '2014-03-15 01:03:24.000000', 'consum', 0.0217, 'lps'),
	(587739, 129, '2014-03-15 01:03:25.000000', 'consum', 0.0213, 'lps'),
	(587740, 129, '2014-03-15 01:03:26.000000', 'consum', 0.0216, 'lps'),
	(587741, 129, '2014-03-15 01:03:27.000000', 'consum', 0.0220, 'lps'),
	(587742, 129, '2014-03-15 01:03:28.000000', 'consum', 0.0212, 'lps'),
	(587743, 129, '2014-03-15 01:03:29.000000', 'consum', 0.0219, 'lps'),
	(587744, 129, '2014-03-15 01:03:30.000000', 'consum', 0.0220, 'lps'),
	(587745, 129, '2014-03-15 01:03:31.000000', 'consum', 0.0220, 'lps'),
	(587746, 129, '2014-03-15 01:03:32.000000', 'consum', 0.0218, 'lps'),
	(587747, 129, '2014-03-15 01:03:33.000000', 'consum', 0.0220, 'lps'),
	(587748, 129, '2014-03-15 01:03:34.000000', 'consum', 0.0222, 'lps'),
	(587749, 129, '2014-03-15 01:03:35.000000', 'consum', 0.0211, 'lps'),
	(587750, 129, '2014-03-15 01:03:36.000000', 'consum', 0.0223, 'lps'),
	(587751, 129, '2014-03-15 01:03:37.000000', 'consum', 0.0218, 'lps'),
	(587752, 129, '2014-03-15 01:03:38.000000', 'consum', 0.0210, 'lps'),
	(587753, 129, '2014-03-15 01:03:39.000000', 'consum', 0.0213, 'lps'),
	(587754, 129, '2014-03-15 01:03:40.000000', 'consum', 0.0214, 'lps'),
	(587755, 129, '2014-03-15 01:03:41.000000', 'consum', 0.0220, 'lps'),
	(587756, 129, '2014-03-15 01:03:42.000000', 'consum', 0.0219, 'lps'),
	(587757, 129, '2014-03-15 01:03:43.000000', 'consum', 0.0214, 'lps'),
	(587758, 129, '2014-03-15 01:03:44.000000', 'consum', 0.0215, 'lps'),
	(587759, 129, '2014-03-15 01:03:45.000000', 'consum', 0.0212, 'lps'),
	(587760, 129, '2014-03-15 01:03:46.000000', 'consum', 0.0217, 'lps'),
	(587761, 129, '2014-03-15 01:03:47.000000', 'consum', 0.0214, 'lps'),
	(587762, 129, '2014-03-15 01:03:48.000000', 'consum', 0.0221, 'lps'),
	(587763, 129, '2014-03-15 01:03:49.000000', 'consum', 0.0213, 'lps'),
	(587764, 129, '2014-03-15 01:03:50.000000', 'consum', 0.0220, 'lps'),
	(587765, 129, '2014-03-15 01:03:51.000000', 'consum', 0.0222, 'lps'),
	(587766, 129, '2014-03-15 01:03:52.000000', 'consum', 0.0214, 'lps'),
	(587767, 129, '2014-03-15 01:03:53.000000', 'consum', 0.0221, 'lps'),
	(587768, 129, '2014-03-15 01:03:54.000000', 'consum', 0.0212, 'lps'),
	(587769, 129, '2014-03-15 01:03:55.000000', 'consum', 0.0215, 'lps'),
	(587770, 129, '2014-03-15 01:03:56.000000', 'consum', 0.0215, 'lps'),
	(587771, 129, '2014-03-15 01:03:57.000000', 'consum', 0.0221, 'lps'),
	(587772, 129, '2014-03-15 01:03:58.000000', 'consum', 0.0222, 'lps'),
	(587773, 129, '2014-03-15 01:03:59.000000', 'consum', 0.0211, 'lps'),
	(587774, 129, '2014-03-15 01:04:00.000000', 'consum', 0.0220, 'lps'),
	(587775, 129, '2014-03-15 01:04:01.000000', 'consum', 0.0217, 'lps'),
	(587776, 129, '2014-03-15 01:04:02.000000', 'consum', 0.0216, 'lps'),
	(587777, 129, '2014-03-15 01:04:03.000000', 'consum', 0.0219, 'lps'),
	(587778, 129, '2014-03-15 01:04:04.000000', 'consum', 0.0211, 'lps'),
	(587779, 129, '2014-03-15 01:04:05.000000', 'consum', 0.0217, 'lps'),
	(587780, 129, '2014-03-15 01:04:06.000000', 'consum', 0.0212, 'lps'),
	(587781, 129, '2014-03-15 01:04:07.000000', 'consum', 0.0215, 'lps'),
	(587782, 129, '2014-03-15 01:04:08.000000', 'consum', 0.0213, 'lps'),
	(587783, 129, '2014-03-15 01:04:09.000000', 'consum', 0.0212, 'lps'),
	(587784, 129, '2014-03-15 01:04:10.000000', 'consum', 0.0210, 'lps'),
	(587785, 129, '2014-03-15 01:04:11.000000', 'consum', 0.0221, 'lps'),
	(587786, 129, '2014-03-15 01:04:12.000000', 'consum', 0.0223, 'lps'),
	(587787, 129, '2014-03-15 01:04:13.000000', 'consum', 0.0214, 'lps'),
	(587788, 129, '2014-03-15 01:04:14.000000', 'consum', 0.0220, 'lps'),
	(587789, 129, '2014-03-15 01:04:15.000000', 'consum', 0.0219, 'lps'),
	(587790, 129, '2014-03-15 01:04:16.000000', 'consum', 0.0211, 'lps'),
	(587791, 129, '2014-03-15 01:04:17.000000', 'consum', 0.0218, 'lps'),
	(587792, 129, '2014-03-15 01:04:18.000000', 'consum', 0.0221, 'lps'),
	(587793, 129, '2014-03-15 01:04:19.000000', 'consum', 0.0211, 'lps'),
	(587794, 129, '2014-03-15 01:04:20.000000', 'consum', 0.0212, 'lps'),
	(587795, 129, '2014-03-15 01:04:21.000000', 'consum', 0.0218, 'lps'),
	(587796, 129, '2014-03-15 01:04:22.000000', 'consum', 0.0216, 'lps'),
	(587797, 129, '2014-03-15 01:04:23.000000', 'consum', 0.0215, 'lps'),
	(587798, 129, '2014-03-15 01:04:24.000000', 'consum', 0.0219, 'lps'),
	(587799, 129, '2014-03-15 01:04:25.000000', 'consum', 0.0212, 'lps'),
	(587800, 129, '2014-03-15 01:04:26.000000', 'consum', 0.0220, 'lps'),
	(587801, 129, '2014-03-15 01:04:27.000000', 'consum', 0.0214, 'lps'),
	(587802, 129, '2014-03-15 01:04:28.000000', 'consum', 0.0214, 'lps'),
	(587803, 129, '2014-03-15 01:04:29.000000', 'consum', 0.0219, 'lps'),
	(587804, 129, '2014-03-15 01:04:30.000000', 'consum', 0.0216, 'lps'),
	(587805, 129, '2014-03-15 01:04:31.000000', 'consum', 0.0212, 'lps'),
	(587806, 129, '2014-03-15 01:04:32.000000', 'consum', 0.0219, 'lps'),
	(587807, 129, '2014-03-15 01:04:33.000000', 'consum', 0.0222, 'lps'),
	(587808, 129, '2014-03-15 01:04:34.000000', 'consum', 0.0212, 'lps'),
	(587809, 129, '2014-03-15 01:04:35.000000', 'consum', 0.0216, 'lps'),
	(587810, 129, '2014-03-15 01:04:36.000000', 'consum', 0.0217, 'lps'),
	(587811, 129, '2014-03-15 01:04:37.000000', 'consum', 0.0217, 'lps'),
	(587812, 129, '2014-03-15 01:04:38.000000', 'consum', 0.0221, 'lps'),
	(587813, 129, '2014-03-15 01:04:39.000000', 'consum', 0.0218, 'lps'),
	(587814, 129, '2014-03-15 01:04:40.000000', 'consum', 0.0218, 'lps'),
	(587815, 129, '2014-03-15 01:04:41.000000', 'consum', 0.0212, 'lps'),
	(587816, 129, '2014-03-15 01:04:42.000000', 'consum', 0.0210, 'lps'),
	(587817, 129, '2014-03-15 01:04:43.000000', 'consum', 0.0220, 'lps'),
	(587818, 129, '2014-03-15 01:04:44.000000', 'consum', 0.0218, 'lps'),
	(587819, 129, '2014-03-15 01:04:45.000000', 'consum', 0.0222, 'lps'),
	(587820, 129, '2014-03-15 01:04:46.000000', 'consum', 0.0219, 'lps'),
	(587821, 129, '2014-03-15 01:04:47.000000', 'consum', 0.0219, 'lps'),
	(587822, 129, '2014-03-15 01:04:48.000000', 'consum', 0.0213, 'lps'),
	(587823, 129, '2014-03-15 01:04:49.000000', 'consum', 0.0213, 'lps'),
	(587824, 129, '2014-03-15 01:04:50.000000', 'consum', 0.0217, 'lps'),
	(587825, 129, '2014-03-15 01:04:51.000000', 'consum', 0.0221, 'lps'),
	(587826, 129, '2014-03-15 01:04:52.000000', 'consum', 0.0219, 'lps'),
	(587827, 129, '2014-03-15 01:04:53.000000', 'consum', 0.0223, 'lps'),
	(587828, 129, '2014-03-15 01:04:54.000000', 'consum', 0.0219, 'lps'),
	(587829, 129, '2014-03-15 01:04:55.000000', 'consum', 0.0216, 'lps'),
	(587830, 129, '2014-03-15 01:04:56.000000', 'consum', 0.0214, 'lps'),
	(587831, 129, '2014-03-15 01:04:57.000000', 'consum', 0.0214, 'lps'),
	(587832, 129, '2014-03-15 01:04:58.000000', 'consum', 0.0216, 'lps'),
	(587833, 129, '2014-03-15 01:04:59.000000', 'consum', 0.0214, 'lps'),
	(587834, 129, '2014-03-15 01:05:00.000000', 'consum', 0.0214, 'lps'),
	(587835, 129, '2014-03-15 01:05:01.000000', 'consum', 0.0217, 'lps'),
	(587836, 129, '2014-03-15 01:05:02.000000', 'consum', 0.0220, 'lps'),
	(587837, 129, '2014-03-15 01:05:03.000000', 'consum', 0.0210, 'lps'),
	(587838, 129, '2014-03-15 01:05:04.000000', 'consum', 0.0223, 'lps'),
	(587839, 129, '2014-03-15 01:05:05.000000', 'consum', 0.0220, 'lps'),
	(587840, 129, '2014-03-15 01:05:06.000000', 'consum', 0.0220, 'lps'),
	(587841, 129, '2014-03-15 01:05:07.000000', 'consum', 0.0217, 'lps'),
	(587842, 129, '2014-03-15 01:05:08.000000', 'consum', 0.0215, 'lps'),
	(587843, 129, '2014-03-15 01:05:09.000000', 'consum', 0.0216, 'lps'),
	(587844, 129, '2014-03-15 01:05:10.000000', 'consum', 0.0212, 'lps'),
	(587845, 129, '2014-03-15 01:05:11.000000', 'consum', 0.0216, 'lps'),
	(587846, 129, '2014-03-15 01:05:12.000000', 'consum', 0.0219, 'lps'),
	(587847, 129, '2014-03-15 01:05:13.000000', 'consum', 0.0213, 'lps'),
	(587848, 129, '2014-03-15 01:05:14.000000', 'consum', 0.0223, 'lps'),
	(587849, 129, '2014-03-15 01:05:15.000000', 'consum', 0.0211, 'lps'),
	(587850, 129, '2014-03-15 01:05:16.000000', 'consum', 0.0218, 'lps'),
	(587851, 129, '2014-03-15 01:05:17.000000', 'consum', 0.0220, 'lps'),
	(587852, 129, '2014-03-15 01:05:18.000000', 'consum', 0.0223, 'lps'),
	(587853, 129, '2014-03-15 01:05:19.000000', 'consum', 0.0217, 'lps'),
	(587854, 129, '2014-03-15 01:05:20.000000', 'consum', 0.0223, 'lps'),
	(587855, 129, '2014-03-15 01:05:21.000000', 'consum', 0.0223, 'lps'),
	(587856, 129, '2014-03-15 01:05:22.000000', 'consum', 0.0210, 'lps'),
	(587857, 129, '2014-03-15 01:05:23.000000', 'consum', 0.0212, 'lps'),
	(587858, 129, '2014-03-15 01:05:24.000000', 'consum', 0.0223, 'lps'),
	(587859, 129, '2014-03-15 01:05:25.000000', 'consum', 0.0212, 'lps'),
	(587860, 129, '2014-03-15 01:05:26.000000', 'consum', 0.0211, 'lps'),
	(587861, 129, '2014-03-15 01:05:27.000000', 'consum', 0.0221, 'lps'),
	(587862, 129, '2014-03-15 01:05:28.000000', 'consum', 0.0222, 'lps'),
	(587863, 129, '2014-03-15 01:05:29.000000', 'consum', 0.0210, 'lps'),
	(587864, 129, '2014-03-15 01:05:30.000000', 'consum', 0.0215, 'lps'),
	(587865, 129, '2014-03-15 01:05:31.000000', 'consum', 0.0210, 'lps'),
	(587866, 129, '2014-03-15 01:05:32.000000', 'consum', 0.0222, 'lps'),
	(587867, 129, '2014-03-15 01:05:33.000000', 'consum', 0.0214, 'lps'),
	(587868, 129, '2014-03-15 01:05:34.000000', 'consum', 0.0222, 'lps'),
	(587869, 129, '2014-03-15 01:05:35.000000', 'consum', 0.0218, 'lps'),
	(587870, 129, '2014-03-15 01:05:36.000000', 'consum', 0.0216, 'lps'),
	(587871, 129, '2014-03-15 01:05:37.000000', 'consum', 0.0215, 'lps'),
	(587872, 129, '2014-03-15 01:05:38.000000', 'consum', 0.0217, 'lps'),
	(587873, 129, '2014-03-15 01:05:39.000000', 'consum', 0.0216, 'lps'),
	(587874, 129, '2014-03-15 01:05:40.000000', 'consum', 0.0222, 'lps'),
	(587875, 129, '2014-03-15 01:05:41.000000', 'consum', 0.0222, 'lps'),
	(587876, 129, '2014-03-15 01:05:42.000000', 'consum', 0.0222, 'lps'),
	(587877, 129, '2014-03-15 01:05:43.000000', 'consum', 0.0222, 'lps'),
	(587878, 129, '2014-03-15 01:05:44.000000', 'consum', 0.0220, 'lps'),
	(587879, 129, '2014-03-15 01:05:45.000000', 'consum', 0.0223, 'lps'),
	(587880, 129, '2014-03-15 01:05:46.000000', 'consum', 0.0217, 'lps'),
	(587881, 129, '2014-03-15 01:05:47.000000', 'consum', 0.0222, 'lps'),
	(587882, 129, '2014-03-15 01:05:48.000000', 'consum', 0.0222, 'lps'),
	(587883, 129, '2014-03-15 01:05:49.000000', 'consum', 0.0219, 'lps'),
	(587884, 129, '2014-03-15 01:05:50.000000', 'consum', 0.0222, 'lps'),
	(587885, 129, '2014-03-15 01:05:51.000000', 'consum', 0.0215, 'lps'),
	(587886, 129, '2014-03-15 01:05:52.000000', 'consum', 0.0213, 'lps'),
	(587887, 129, '2014-03-15 01:05:53.000000', 'consum', 0.0211, 'lps'),
	(587888, 129, '2014-03-15 01:05:54.000000', 'consum', 0.0219, 'lps'),
	(587889, 129, '2014-03-15 01:05:55.000000', 'consum', 0.0210, 'lps'),
	(587890, 129, '2014-03-15 01:05:56.000000', 'consum', 0.0212, 'lps'),
	(587891, 129, '2014-03-15 01:05:57.000000', 'consum', 0.0223, 'lps'),
	(587892, 129, '2014-03-15 01:05:58.000000', 'consum', 0.0210, 'lps'),
	(587893, 129, '2014-03-15 01:05:59.000000', 'consum', 0.0215, 'lps'),
	(587894, 129, '2014-03-15 01:06:00.000000', 'consum', 0.0221, 'lps'),
	(587895, 129, '2014-03-15 01:06:01.000000', 'consum', 0.0221, 'lps'),
	(587896, 129, '2014-03-15 01:06:02.000000', 'consum', 0.0221, 'lps'),
	(587897, 129, '2014-03-15 01:06:03.000000', 'consum', 0.0219, 'lps'),
	(587898, 129, '2014-03-15 01:06:04.000000', 'consum', 0.0223, 'lps'),
	(587899, 129, '2014-03-15 01:06:05.000000', 'consum', 0.0221, 'lps'),
	(587900, 129, '2014-03-15 01:06:06.000000', 'consum', 0.0212, 'lps'),
	(587901, 129, '2014-03-15 01:06:07.000000', 'consum', 0.0213, 'lps'),
	(587902, 129, '2014-03-15 01:06:08.000000', 'consum', 0.0222, 'lps'),
	(587903, 129, '2014-03-15 01:06:09.000000', 'consum', 0.0221, 'lps'),
	(587904, 129, '2014-03-15 01:06:10.000000', 'consum', 0.0212, 'lps'),
	(587905, 129, '2014-03-15 01:06:11.000000', 'consum', 0.0217, 'lps'),
	(587906, 129, '2014-03-15 01:06:12.000000', 'consum', 0.0212, 'lps'),
	(587907, 129, '2014-03-15 01:06:13.000000', 'consum', 0.0213, 'lps'),
	(587908, 129, '2014-03-15 01:06:14.000000', 'consum', 0.0221, 'lps'),
	(587909, 129, '2014-03-15 01:06:15.000000', 'consum', 0.0213, 'lps'),
	(587910, 129, '2014-03-15 01:06:16.000000', 'consum', 0.0221, 'lps'),
	(587911, 129, '2014-03-15 01:06:17.000000', 'consum', 0.0215, 'lps'),
	(587912, 129, '2014-03-15 01:06:18.000000', 'consum', 0.0215, 'lps'),
	(587913, 129, '2014-03-15 01:06:19.000000', 'consum', 0.0221, 'lps'),
	(587914, 129, '2014-03-15 01:06:20.000000', 'consum', 0.0221, 'lps'),
	(587915, 129, '2014-03-15 01:06:21.000000', 'consum', 0.0218, 'lps'),
	(587916, 129, '2014-03-15 01:06:22.000000', 'consum', 0.0218, 'lps'),
	(587917, 129, '2014-03-15 01:06:23.000000', 'consum', 0.0213, 'lps'),
	(587918, 129, '2014-03-15 01:06:24.000000', 'consum', 0.0217, 'lps'),
	(587919, 129, '2014-03-15 01:06:25.000000', 'consum', 0.0221, 'lps'),
	(587920, 129, '2014-03-15 01:06:26.000000', 'consum', 0.0216, 'lps'),
	(587921, 129, '2014-03-15 01:06:27.000000', 'consum', 0.0221, 'lps'),
	(587922, 129, '2014-03-15 01:06:28.000000', 'consum', 0.0220, 'lps'),
	(587923, 129, '2014-03-15 01:06:29.000000', 'consum', 0.0213, 'lps'),
	(587924, 129, '2014-03-15 01:06:30.000000', 'consum', 0.0222, 'lps'),
	(587925, 129, '2014-03-15 01:06:31.000000', 'consum', 0.0222, 'lps'),
	(587926, 129, '2014-03-15 01:06:32.000000', 'consum', 0.0220, 'lps'),
	(587927, 129, '2014-03-15 01:06:33.000000', 'consum', 0.0211, 'lps'),
	(587928, 129, '2014-03-15 01:06:34.000000', 'consum', 0.0213, 'lps'),
	(587929, 129, '2014-03-15 01:06:35.000000', 'consum', 0.0221, 'lps'),
	(587930, 129, '2014-03-15 01:06:36.000000', 'consum', 0.0217, 'lps'),
	(587931, 129, '2014-03-15 01:06:37.000000', 'consum', 0.0211, 'lps'),
	(587932, 129, '2014-03-15 01:06:38.000000', 'consum', 0.0222, 'lps'),
	(587933, 129, '2014-03-15 01:06:39.000000', 'consum', 0.0213, 'lps'),
	(587934, 129, '2014-03-15 01:06:40.000000', 'consum', 0.0216, 'lps'),
	(587935, 129, '2014-03-15 01:06:41.000000', 'consum', 0.0218, 'lps'),
	(587936, 129, '2014-03-15 01:06:42.000000', 'consum', 0.0219, 'lps'),
	(587937, 129, '2014-03-15 01:06:43.000000', 'consum', 0.0217, 'lps'),
	(587938, 129, '2014-03-15 01:06:44.000000', 'consum', 0.0217, 'lps'),
	(587939, 129, '2014-03-15 01:06:45.000000', 'consum', 0.0211, 'lps'),
	(587940, 129, '2014-03-15 01:06:46.000000', 'consum', 0.0223, 'lps'),
	(587941, 129, '2014-03-15 01:06:47.000000', 'consum', 0.0218, 'lps'),
	(587942, 129, '2014-03-15 01:06:48.000000', 'consum', 0.0210, 'lps'),
	(587943, 129, '2014-03-15 01:06:49.000000', 'consum', 0.0215, 'lps'),
	(587944, 129, '2014-03-15 01:06:50.000000', 'consum', 0.0221, 'lps'),
	(587945, 129, '2014-03-15 01:06:51.000000', 'consum', 0.0221, 'lps'),
	(587946, 129, '2014-03-15 01:06:52.000000', 'consum', 0.0220, 'lps'),
	(587947, 129, '2014-03-15 01:06:53.000000', 'consum', 0.0213, 'lps'),
	(587948, 129, '2014-03-15 01:06:54.000000', 'consum', 0.0212, 'lps'),
	(587949, 129, '2014-03-15 01:06:55.000000', 'consum', 0.0222, 'lps'),
	(587950, 129, '2014-03-15 01:06:56.000000', 'consum', 0.0210, 'lps'),
	(587951, 129, '2014-03-15 01:06:57.000000', 'consum', 0.0214, 'lps'),
	(587952, 129, '2014-03-15 01:06:58.000000', 'consum', 0.0219, 'lps'),
	(587953, 129, '2014-03-15 01:06:59.000000', 'consum', 0.0216, 'lps'),
	(587954, 129, '2014-03-15 01:07:00.000000', 'consum', 0.0213, 'lps'),
	(587955, 129, '2014-03-15 01:07:01.000000', 'consum', 0.0222, 'lps'),
	(587956, 129, '2014-03-15 01:07:02.000000', 'consum', 0.0220, 'lps'),
	(587957, 129, '2014-03-15 01:07:03.000000', 'consum', 0.0210, 'lps'),
	(587958, 129, '2014-03-15 01:07:04.000000', 'consum', 0.0223, 'lps'),
	(587959, 129, '2014-03-15 01:07:05.000000', 'consum', 0.0221, 'lps'),
	(587960, 129, '2014-03-15 01:07:06.000000', 'consum', 0.0211, 'lps'),
	(587961, 129, '2014-03-15 01:07:07.000000', 'consum', 0.0212, 'lps'),
	(587962, 129, '2014-03-15 01:07:08.000000', 'consum', 0.0217, 'lps'),
	(587963, 129, '2014-03-15 01:07:09.000000', 'consum', 0.0213, 'lps'),
	(587964, 129, '2014-03-15 01:07:10.000000', 'consum', 0.0215, 'lps'),
	(587965, 129, '2014-03-15 01:07:11.000000', 'consum', 0.0215, 'lps'),
	(587966, 129, '2014-03-15 01:07:12.000000', 'consum', 0.0220, 'lps'),
	(587967, 129, '2014-03-15 01:07:13.000000', 'consum', 0.0218, 'lps'),
	(587968, 129, '2014-03-15 01:07:14.000000', 'consum', 0.0221, 'lps'),
	(587969, 129, '2014-03-15 01:07:15.000000', 'consum', 0.0213, 'lps'),
	(587970, 129, '2014-03-15 01:07:16.000000', 'consum', 0.0220, 'lps'),
	(587971, 129, '2014-03-15 01:07:17.000000', 'consum', 0.0223, 'lps'),
	(587972, 129, '2014-03-15 01:07:18.000000', 'consum', 0.0217, 'lps'),
	(587973, 129, '2014-03-15 01:07:19.000000', 'consum', 0.0219, 'lps'),
	(587974, 129, '2014-03-15 01:07:20.000000', 'consum', 0.0223, 'lps'),
	(587975, 129, '2014-03-15 01:07:21.000000', 'consum', 0.0220, 'lps'),
	(587976, 129, '2014-03-15 01:07:22.000000', 'consum', 0.0219, 'lps'),
	(587977, 129, '2014-03-15 01:07:23.000000', 'consum', 0.0215, 'lps'),
	(587978, 129, '2014-03-15 01:07:24.000000', 'consum', 0.0221, 'lps'),
	(587979, 129, '2014-03-15 01:07:25.000000', 'consum', 0.0211, 'lps'),
	(587980, 129, '2014-03-15 01:07:26.000000', 'consum', 0.0221, 'lps'),
	(587981, 129, '2014-03-15 01:07:27.000000', 'consum', 0.0210, 'lps'),
	(587982, 129, '2014-03-15 01:07:28.000000', 'consum', 0.0217, 'lps'),
	(587983, 129, '2014-03-15 01:07:29.000000', 'consum', 0.0220, 'lps'),
	(587984, 129, '2014-03-15 01:07:30.000000', 'consum', 0.0223, 'lps'),
	(587985, 129, '2014-03-15 01:07:31.000000', 'consum', 0.0217, 'lps'),
	(587986, 129, '2014-03-15 01:07:32.000000', 'consum', 0.0223, 'lps'),
	(587987, 129, '2014-03-15 01:07:33.000000', 'consum', 0.0210, 'lps'),
	(587988, 129, '2014-03-15 01:07:34.000000', 'consum', 0.0215, 'lps'),
	(587989, 129, '2014-03-15 01:07:35.000000', 'consum', 0.0222, 'lps'),
	(587990, 129, '2014-03-15 01:07:36.000000', 'consum', 0.0212, 'lps'),
	(587991, 129, '2014-03-15 01:07:37.000000', 'consum', 0.0215, 'lps'),
	(587992, 129, '2014-03-15 01:07:38.000000', 'consum', 0.0212, 'lps'),
	(587993, 129, '2014-03-15 01:07:39.000000', 'consum', 0.0222, 'lps'),
	(587994, 129, '2014-03-15 01:07:40.000000', 'consum', 0.0210, 'lps'),
	(587995, 129, '2014-03-15 01:07:41.000000', 'consum', 0.0214, 'lps'),
	(587996, 129, '2014-03-15 01:07:42.000000', 'consum', 0.0218, 'lps'),
	(587997, 129, '2014-03-15 01:07:43.000000', 'consum', 0.0211, 'lps'),
	(587998, 129, '2014-03-15 01:07:44.000000', 'consum', 0.0218, 'lps'),
	(587999, 129, '2014-03-15 01:07:45.000000', 'consum', 0.0221, 'lps'),
	(588000, 129, '2014-03-15 01:07:46.000000', 'consum', 0.0212, 'lps'),
	(588001, 129, '2014-03-15 01:07:47.000000', 'consum', 0.0216, 'lps'),
	(588002, 129, '2014-03-15 01:07:48.000000', 'consum', 0.0220, 'lps'),
	(588003, 129, '2014-03-15 01:07:49.000000', 'consum', 0.0216, 'lps'),
	(588004, 129, '2014-03-15 01:07:50.000000', 'consum', 0.0222, 'lps'),
	(588005, 129, '2014-03-15 01:07:51.000000', 'consum', 0.0212, 'lps'),
	(588006, 129, '2014-03-15 01:07:52.000000', 'consum', 0.0211, 'lps'),
	(588007, 129, '2014-03-15 01:07:53.000000', 'consum', 0.0212, 'lps'),
	(588008, 129, '2014-03-15 01:07:54.000000', 'consum', 0.0218, 'lps'),
	(588009, 129, '2014-03-15 01:07:55.000000', 'consum', 0.0214, 'lps'),
	(588010, 129, '2014-03-15 01:07:56.000000', 'consum', 0.0220, 'lps'),
	(588011, 129, '2014-03-15 01:07:57.000000', 'consum', 0.0222, 'lps'),
	(588012, 129, '2014-03-15 01:07:58.000000', 'consum', 0.0212, 'lps'),
	(588013, 129, '2014-03-15 01:07:59.000000', 'consum', 0.0214, 'lps'),
	(588014, 129, '2014-03-15 01:08:00.000000', 'consum', 0.0223, 'lps'),
	(588015, 129, '2014-03-15 01:08:01.000000', 'consum', 0.0222, 'lps'),
	(588016, 129, '2014-03-15 01:08:02.000000', 'consum', 0.0218, 'lps'),
	(588017, 129, '2014-03-15 01:08:03.000000', 'consum', 0.0215, 'lps'),
	(588018, 129, '2014-03-15 01:08:04.000000', 'consum', 0.0210, 'lps'),
	(588019, 129, '2014-03-15 01:08:05.000000', 'consum', 0.0211, 'lps'),
	(588020, 129, '2014-03-15 01:08:06.000000', 'consum', 0.0214, 'lps'),
	(588021, 129, '2014-03-15 01:08:07.000000', 'consum', 0.0216, 'lps'),
	(588022, 129, '2014-03-15 01:08:08.000000', 'consum', 0.0213, 'lps'),
	(588023, 129, '2014-03-15 01:08:09.000000', 'consum', 0.0222, 'lps'),
	(588024, 129, '2014-03-15 01:08:10.000000', 'consum', 0.0220, 'lps'),
	(588025, 129, '2014-03-15 01:08:11.000000', 'consum', 0.0210, 'lps'),
	(588026, 129, '2014-03-15 01:08:12.000000', 'consum', 0.0210, 'lps'),
	(588027, 129, '2014-03-15 01:08:13.000000', 'consum', 0.0223, 'lps'),
	(588028, 129, '2014-03-15 01:08:14.000000', 'consum', 0.0219, 'lps'),
	(588029, 129, '2014-03-15 01:08:15.000000', 'consum', 0.0217, 'lps'),
	(588030, 129, '2014-03-15 01:08:16.000000', 'consum', 0.0220, 'lps'),
	(588031, 129, '2014-03-15 01:08:17.000000', 'consum', 0.0211, 'lps'),
	(588032, 129, '2014-03-15 01:08:18.000000', 'consum', 0.0212, 'lps'),
	(588033, 129, '2014-03-15 01:08:19.000000', 'consum', 0.0217, 'lps'),
	(588034, 129, '2014-03-15 01:08:20.000000', 'consum', 0.0213, 'lps'),
	(588035, 129, '2014-03-15 01:08:21.000000', 'consum', 0.0219, 'lps'),
	(588036, 129, '2014-03-15 01:08:22.000000', 'consum', 0.0218, 'lps'),
	(588037, 129, '2014-03-15 01:08:23.000000', 'consum', 0.0210, 'lps'),
	(588038, 129, '2014-03-15 01:08:24.000000', 'consum', 0.0214, 'lps'),
	(588039, 129, '2014-03-15 01:08:25.000000', 'consum', 0.0216, 'lps'),
	(588040, 129, '2014-03-15 01:08:26.000000', 'consum', 0.0217, 'lps'),
	(588041, 129, '2014-03-15 01:08:27.000000', 'consum', 0.0210, 'lps'),
	(588042, 129, '2014-03-15 01:08:28.000000', 'consum', 0.0219, 'lps'),
	(588043, 129, '2014-03-15 01:08:29.000000', 'consum', 0.0213, 'lps'),
	(588044, 129, '2014-03-15 01:08:30.000000', 'consum', 0.0214, 'lps'),
	(588045, 129, '2014-03-15 01:08:31.000000', 'consum', 0.0221, 'lps'),
	(588046, 129, '2014-03-15 01:08:32.000000', 'consum', 0.0210, 'lps'),
	(588047, 129, '2014-03-15 01:08:33.000000', 'consum', 0.0221, 'lps'),
	(588048, 129, '2014-03-15 01:08:34.000000', 'consum', 0.0221, 'lps'),
	(588049, 129, '2014-03-15 01:08:35.000000', 'consum', 0.0220, 'lps'),
	(588050, 129, '2014-03-15 01:08:36.000000', 'consum', 0.0214, 'lps'),
	(588051, 129, '2014-03-15 01:08:37.000000', 'consum', 0.0212, 'lps'),
	(588052, 129, '2014-03-15 01:08:38.000000', 'consum', 0.0211, 'lps'),
	(588053, 129, '2014-03-15 01:08:39.000000', 'consum', 0.0210, 'lps'),
	(588054, 129, '2014-03-15 01:08:40.000000', 'consum', 0.0221, 'lps'),
	(588055, 129, '2014-03-15 01:08:41.000000', 'consum', 0.0222, 'lps'),
	(588056, 129, '2014-03-15 01:08:42.000000', 'consum', 0.0210, 'lps'),
	(588057, 129, '2014-03-15 01:08:43.000000', 'consum', 0.0215, 'lps'),
	(588058, 129, '2014-03-15 01:08:44.000000', 'consum', 0.0210, 'lps'),
	(588059, 129, '2014-03-15 01:08:45.000000', 'consum', 0.0222, 'lps'),
	(588060, 129, '2014-03-15 01:08:46.000000', 'consum', 0.0215, 'lps'),
	(588061, 129, '2014-03-15 01:08:47.000000', 'consum', 0.0214, 'lps'),
	(588062, 129, '2014-03-15 01:08:48.000000', 'consum', 0.0214, 'lps'),
	(588063, 129, '2014-03-15 01:08:49.000000', 'consum', 0.0218, 'lps'),
	(588064, 129, '2014-03-15 01:08:50.000000', 'consum', 0.0211, 'lps'),
	(588065, 129, '2014-03-15 01:08:51.000000', 'consum', 0.0219, 'lps'),
	(588066, 129, '2014-03-15 01:08:52.000000', 'consum', 0.0223, 'lps'),
	(588067, 129, '2014-03-15 01:08:53.000000', 'consum', 0.0221, 'lps'),
	(588068, 129, '2014-03-15 01:08:54.000000', 'consum', 0.0215, 'lps'),
	(588069, 129, '2014-03-15 01:08:55.000000', 'consum', 0.0216, 'lps'),
	(588070, 129, '2014-03-15 01:08:56.000000', 'consum', 0.0210, 'lps'),
	(588071, 129, '2014-03-15 01:08:57.000000', 'consum', 0.0222, 'lps'),
	(588072, 129, '2014-03-15 01:08:58.000000', 'consum', 0.0215, 'lps'),
	(588073, 129, '2014-03-15 01:08:59.000000', 'consum', 0.0212, 'lps'),
	(588074, 129, '2014-03-15 01:09:00.000000', 'consum', 0.0218, 'lps'),
	(588075, 129, '2014-03-15 01:09:01.000000', 'consum', 0.0220, 'lps'),
	(588076, 129, '2014-03-15 01:09:02.000000', 'consum', 0.0220, 'lps'),
	(588077, 129, '2014-03-15 01:09:03.000000', 'consum', 0.0215, 'lps'),
	(588078, 129, '2014-03-15 01:09:04.000000', 'consum', 0.0221, 'lps'),
	(588079, 129, '2014-03-15 01:09:05.000000', 'consum', 0.0210, 'lps'),
	(588080, 129, '2014-03-15 01:09:06.000000', 'consum', 0.0220, 'lps'),
	(588081, 129, '2014-03-15 01:09:07.000000', 'consum', 0.0216, 'lps'),
	(588082, 129, '2014-03-15 01:09:08.000000', 'consum', 0.0210, 'lps'),
	(588083, 129, '2014-03-15 01:09:09.000000', 'consum', 0.0221, 'lps'),
	(588084, 129, '2014-03-15 01:09:10.000000', 'consum', 0.0211, 'lps'),
	(588085, 129, '2014-03-15 01:09:11.000000', 'consum', 0.0223, 'lps'),
	(588086, 129, '2014-03-15 01:09:12.000000', 'consum', 0.0218, 'lps'),
	(588087, 129, '2014-03-15 01:09:13.000000', 'consum', 0.0212, 'lps'),
	(588088, 129, '2014-03-15 01:09:14.000000', 'consum', 0.0210, 'lps'),
	(588089, 129, '2014-03-15 01:09:15.000000', 'consum', 0.0218, 'lps'),
	(588090, 129, '2014-03-15 01:09:16.000000', 'consum', 0.0221, 'lps'),
	(588091, 129, '2014-03-15 01:09:17.000000', 'consum', 0.0215, 'lps'),
	(588092, 129, '2014-03-15 01:09:18.000000', 'consum', 0.0215, 'lps'),
	(588093, 129, '2014-03-15 01:09:19.000000', 'consum', 0.0222, 'lps'),
	(588094, 129, '2014-03-15 01:09:20.000000', 'consum', 0.0212, 'lps'),
	(588095, 129, '2014-03-15 01:09:21.000000', 'consum', 0.0214, 'lps'),
	(588096, 129, '2014-03-15 01:09:22.000000', 'consum', 0.0223, 'lps'),
	(588097, 129, '2014-03-15 01:09:23.000000', 'consum', 0.0223, 'lps'),
	(588098, 129, '2014-03-15 01:09:24.000000', 'consum', 0.0220, 'lps'),
	(588099, 129, '2014-03-15 01:09:25.000000', 'consum', 0.0210, 'lps'),
	(588100, 129, '2014-03-15 01:09:26.000000', 'consum', 0.0210, 'lps'),
	(588101, 129, '2014-03-15 01:09:27.000000', 'consum', 0.0221, 'lps'),
	(588102, 129, '2014-03-15 01:09:28.000000', 'consum', 0.0212, 'lps'),
	(588103, 129, '2014-03-15 01:09:29.000000', 'consum', 0.0215, 'lps'),
	(588104, 129, '2014-03-15 01:09:30.000000', 'consum', 0.0217, 'lps'),
	(588105, 129, '2014-03-15 01:09:31.000000', 'consum', 0.0217, 'lps'),
	(588106, 129, '2014-03-15 01:09:32.000000', 'consum', 0.0221, 'lps'),
	(588107, 129, '2014-03-15 01:09:33.000000', 'consum', 0.0219, 'lps'),
	(588108, 129, '2014-03-15 01:09:34.000000', 'consum', 0.0222, 'lps'),
	(588109, 129, '2014-03-15 01:09:35.000000', 'consum', 0.0216, 'lps'),
	(588110, 129, '2014-03-15 01:09:36.000000', 'consum', 0.0216, 'lps'),
	(588111, 129, '2014-03-15 01:09:37.000000', 'consum', 0.0211, 'lps'),
	(588112, 129, '2014-03-15 01:09:38.000000', 'consum', 0.0210, 'lps'),
	(588113, 129, '2014-03-15 01:09:39.000000', 'consum', 0.0223, 'lps'),
	(588114, 129, '2014-03-15 01:09:40.000000', 'consum', 0.0221, 'lps'),
	(588115, 129, '2014-03-15 01:09:41.000000', 'consum', 0.0223, 'lps'),
	(588116, 129, '2014-03-15 01:09:42.000000', 'consum', 0.0217, 'lps'),
	(588117, 129, '2014-03-15 01:09:43.000000', 'consum', 0.0220, 'lps'),
	(588118, 129, '2014-03-15 01:09:44.000000', 'consum', 0.0213, 'lps'),
	(588119, 129, '2014-03-15 01:09:45.000000', 'consum', 0.0221, 'lps'),
	(588120, 129, '2014-03-15 01:09:46.000000', 'consum', 0.0214, 'lps'),
	(588121, 129, '2014-03-15 01:09:47.000000', 'consum', 0.0215, 'lps'),
	(588122, 129, '2014-03-15 01:09:48.000000', 'consum', 0.0220, 'lps'),
	(588123, 129, '2014-03-15 01:09:49.000000', 'consum', 0.0218, 'lps'),
	(588124, 129, '2014-03-15 01:09:50.000000', 'consum', 0.0220, 'lps'),
	(588125, 129, '2014-03-15 01:09:51.000000', 'consum', 0.0211, 'lps'),
	(588126, 129, '2014-03-15 01:09:52.000000', 'consum', 0.0214, 'lps'),
	(588127, 129, '2014-03-15 01:09:53.000000', 'consum', 0.0211, 'lps'),
	(588128, 129, '2014-03-15 01:09:54.000000', 'consum', 0.0219, 'lps'),
	(588129, 129, '2014-03-15 01:09:55.000000', 'consum', 0.0222, 'lps'),
	(588130, 129, '2014-03-15 01:09:56.000000', 'consum', 0.0217, 'lps'),
	(588131, 129, '2014-03-15 01:09:57.000000', 'consum', 0.0210, 'lps'),
	(588132, 129, '2014-03-15 01:09:58.000000', 'consum', 0.0216, 'lps'),
	(588133, 129, '2014-03-15 01:09:59.000000', 'consum', 0.0215, 'lps'),
	(588134, 129, '2014-03-15 01:10:00.000000', 'consum', 0.0217, 'lps'),
	(588135, 129, '2014-03-15 01:10:01.000000', 'consum', 0.0214, 'lps'),
	(588136, 129, '2014-03-15 01:10:02.000000', 'consum', 0.0212, 'lps'),
	(588137, 129, '2014-03-15 01:10:03.000000', 'consum', 0.0220, 'lps'),
	(588138, 129, '2014-03-15 01:10:04.000000', 'consum', 0.0214, 'lps'),
	(588139, 129, '2014-03-15 01:10:05.000000', 'consum', 0.0212, 'lps'),
	(588140, 129, '2014-03-15 01:10:06.000000', 'consum', 0.0211, 'lps'),
	(588141, 129, '2014-03-15 01:10:07.000000', 'consum', 0.0223, 'lps'),
	(588142, 129, '2014-03-15 01:10:08.000000', 'consum', 0.0214, 'lps'),
	(588143, 129, '2014-03-15 01:10:09.000000', 'consum', 0.0223, 'lps'),
	(588144, 129, '2014-03-15 01:10:10.000000', 'consum', 0.0220, 'lps'),
	(588145, 129, '2014-03-15 01:10:11.000000', 'consum', 0.0220, 'lps'),
	(588146, 129, '2014-03-15 01:10:12.000000', 'consum', 0.0219, 'lps'),
	(588147, 129, '2014-03-15 01:10:13.000000', 'consum', 0.0213, 'lps'),
	(588148, 129, '2014-03-15 01:10:14.000000', 'consum', 0.0223, 'lps'),
	(588149, 129, '2014-03-15 01:10:15.000000', 'consum', 0.0211, 'lps'),
	(588150, 129, '2014-03-15 01:10:16.000000', 'consum', 0.0217, 'lps'),
	(588151, 129, '2014-03-15 01:10:17.000000', 'consum', 0.0216, 'lps'),
	(588152, 129, '2014-03-15 01:10:18.000000', 'consum', 0.0221, 'lps'),
	(588153, 129, '2014-03-15 01:10:19.000000', 'consum', 0.0219, 'lps'),
	(588154, 129, '2014-03-15 01:10:20.000000', 'consum', 0.0223, 'lps'),
	(588155, 129, '2014-03-15 01:10:21.000000', 'consum', 0.0221, 'lps'),
	(588156, 129, '2014-03-15 01:10:22.000000', 'consum', 0.0211, 'lps'),
	(588157, 129, '2014-03-15 01:10:23.000000', 'consum', 0.0212, 'lps'),
	(588158, 129, '2014-03-15 01:10:24.000000', 'consum', 0.0215, 'lps'),
	(588159, 129, '2014-03-15 01:10:25.000000', 'consum', 0.0216, 'lps'),
	(588160, 129, '2014-03-15 01:10:26.000000', 'consum', 0.0214, 'lps'),
	(588161, 129, '2014-03-15 01:10:27.000000', 'consum', 0.0210, 'lps'),
	(588162, 129, '2014-03-15 01:10:28.000000', 'consum', 0.0215, 'lps'),
	(588163, 129, '2014-03-15 01:10:29.000000', 'consum', 0.0220, 'lps'),
	(588164, 129, '2014-03-15 01:10:30.000000', 'consum', 0.0219, 'lps'),
	(588165, 129, '2014-03-15 01:10:31.000000', 'consum', 0.0213, 'lps'),
	(588166, 129, '2014-03-15 01:10:32.000000', 'consum', 0.0223, 'lps'),
	(588167, 129, '2014-03-15 01:10:33.000000', 'consum', 0.0213, 'lps'),
	(588168, 129, '2014-03-15 01:10:34.000000', 'consum', 0.0215, 'lps'),
	(588169, 129, '2014-03-15 01:10:35.000000', 'consum', 0.0211, 'lps'),
	(588170, 129, '2014-03-15 01:10:36.000000', 'consum', 0.0216, 'lps'),
	(588171, 129, '2014-03-15 01:10:37.000000', 'consum', 0.0221, 'lps'),
	(588172, 129, '2014-03-15 01:10:38.000000', 'consum', 0.0221, 'lps'),
	(588173, 129, '2014-03-15 01:10:39.000000', 'consum', 0.0218, 'lps'),
	(588174, 129, '2014-03-15 01:10:40.000000', 'consum', 0.0220, 'lps'),
	(588175, 129, '2014-03-15 01:10:41.000000', 'consum', 0.0219, 'lps'),
	(588176, 129, '2014-03-15 01:10:42.000000', 'consum', 0.0214, 'lps'),
	(588177, 129, '2014-03-15 01:10:43.000000', 'consum', 0.0217, 'lps'),
	(588178, 129, '2014-03-15 01:10:44.000000', 'consum', 0.0217, 'lps'),
	(588179, 129, '2014-03-15 01:10:45.000000', 'consum', 0.0214, 'lps'),
	(588180, 129, '2014-03-15 01:10:46.000000', 'consum', 0.0222, 'lps'),
	(588181, 129, '2014-03-15 01:10:47.000000', 'consum', 0.0217, 'lps'),
	(588182, 129, '2014-03-15 01:10:48.000000', 'consum', 0.0223, 'lps'),
	(588183, 129, '2014-03-15 01:10:49.000000', 'consum', 0.0212, 'lps'),
	(588184, 129, '2014-03-15 01:10:50.000000', 'consum', 0.0223, 'lps'),
	(588185, 129, '2014-03-15 01:10:51.000000', 'consum', 0.0215, 'lps'),
	(588186, 129, '2014-03-15 01:10:52.000000', 'consum', 0.0210, 'lps'),
	(588187, 129, '2014-03-15 01:10:53.000000', 'consum', 0.0211, 'lps'),
	(588188, 129, '2014-03-15 01:10:54.000000', 'consum', 0.0216, 'lps'),
	(588189, 129, '2014-03-15 01:10:55.000000', 'consum', 0.0223, 'lps'),
	(588190, 129, '2014-03-15 01:10:56.000000', 'consum', 0.0216, 'lps'),
	(588191, 129, '2014-03-15 01:10:57.000000', 'consum', 0.0216, 'lps'),
	(588192, 129, '2014-03-15 01:10:58.000000', 'consum', 0.0221, 'lps'),
	(588193, 129, '2014-03-15 01:10:59.000000', 'consum', 0.0219, 'lps'),
	(588194, 129, '2014-03-15 01:11:00.000000', 'consum', 0.0223, 'lps'),
	(588195, 129, '2014-03-15 01:11:01.000000', 'consum', 0.0220, 'lps'),
	(588196, 129, '2014-03-15 01:11:02.000000', 'consum', 0.0223, 'lps'),
	(588197, 129, '2014-03-15 01:11:03.000000', 'consum', 0.0217, 'lps'),
	(588198, 129, '2014-03-15 01:11:04.000000', 'consum', 0.0222, 'lps'),
	(588199, 129, '2014-03-15 01:11:05.000000', 'consum', 0.0219, 'lps'),
	(588200, 129, '2014-03-15 01:11:06.000000', 'consum', 0.0221, 'lps'),
	(588201, 129, '2014-03-15 01:11:07.000000', 'consum', 0.0212, 'lps'),
	(588202, 129, '2014-03-15 01:11:08.000000', 'consum', 0.0213, 'lps'),
	(588203, 129, '2014-03-15 01:11:09.000000', 'consum', 0.0221, 'lps'),
	(588204, 129, '2014-03-15 01:11:10.000000', 'consum', 0.0213, 'lps'),
	(588205, 129, '2014-03-15 01:11:11.000000', 'consum', 0.0222, 'lps'),
	(588206, 129, '2014-03-15 01:11:12.000000', 'consum', 0.0219, 'lps'),
	(588207, 129, '2014-03-15 01:11:13.000000', 'consum', 0.0218, 'lps'),
	(588208, 129, '2014-03-15 01:11:14.000000', 'consum', 0.0212, 'lps'),
	(588209, 129, '2014-03-15 01:11:15.000000', 'consum', 0.0222, 'lps'),
	(588210, 129, '2014-03-15 01:11:16.000000', 'consum', 0.0211, 'lps'),
	(588211, 129, '2014-03-15 01:11:17.000000', 'consum', 0.0219, 'lps'),
	(588212, 129, '2014-03-15 01:11:18.000000', 'consum', 0.0212, 'lps'),
	(588213, 129, '2014-03-15 01:11:19.000000', 'consum', 0.0223, 'lps'),
	(588214, 129, '2014-03-15 01:11:20.000000', 'consum', 0.0211, 'lps'),
	(588215, 129, '2014-03-15 01:11:21.000000', 'consum', 0.0220, 'lps'),
	(588216, 129, '2014-03-15 01:11:22.000000', 'consum', 0.0215, 'lps'),
	(588217, 129, '2014-03-15 01:11:23.000000', 'consum', 0.0220, 'lps'),
	(588218, 129, '2014-03-15 01:11:24.000000', 'consum', 0.0217, 'lps'),
	(588219, 129, '2014-03-15 01:11:25.000000', 'consum', 0.0216, 'lps'),
	(588220, 129, '2014-03-15 01:11:26.000000', 'consum', 0.0219, 'lps'),
	(588221, 129, '2014-03-15 01:11:27.000000', 'consum', 0.0223, 'lps'),
	(588222, 129, '2014-03-15 01:11:28.000000', 'consum', 0.0223, 'lps'),
	(588223, 129, '2014-03-15 01:11:29.000000', 'consum', 0.0220, 'lps'),
	(588224, 129, '2014-03-15 01:11:30.000000', 'consum', 0.0210, 'lps'),
	(588225, 129, '2014-03-15 01:11:31.000000', 'consum', 0.0221, 'lps'),
	(588226, 129, '2014-03-15 01:11:32.000000', 'consum', 0.0223, 'lps'),
	(588227, 129, '2014-03-15 01:11:33.000000', 'consum', 0.0216, 'lps'),
	(588228, 129, '2014-03-15 01:11:34.000000', 'consum', 0.0215, 'lps'),
	(588229, 129, '2014-03-15 01:11:35.000000', 'consum', 0.0219, 'lps'),
	(588230, 129, '2014-03-15 01:11:36.000000', 'consum', 0.0212, 'lps'),
	(588231, 129, '2014-03-15 01:11:37.000000', 'consum', 0.0219, 'lps'),
	(588232, 129, '2014-03-15 01:11:38.000000', 'consum', 0.0223, 'lps'),
	(588233, 129, '2014-03-15 01:11:39.000000', 'consum', 0.0221, 'lps'),
	(588234, 129, '2014-03-15 01:11:40.000000', 'consum', 0.0211, 'lps'),
	(588235, 129, '2014-03-15 01:11:41.000000', 'consum', 0.0211, 'lps'),
	(588236, 129, '2014-03-15 01:11:42.000000', 'consum', 0.0213, 'lps'),
	(588237, 129, '2014-03-15 01:11:43.000000', 'consum', 0.0223, 'lps'),
	(588238, 129, '2014-03-15 01:11:44.000000', 'consum', 0.0211, 'lps'),
	(588239, 129, '2014-03-15 01:11:45.000000', 'consum', 0.0220, 'lps'),
	(588240, 129, '2014-03-15 01:11:46.000000', 'consum', 0.0213, 'lps'),
	(588241, 129, '2014-03-15 01:11:47.000000', 'consum', 0.0210, 'lps'),
	(588242, 129, '2014-03-15 01:11:48.000000', 'consum', 0.0214, 'lps'),
	(588243, 129, '2014-03-15 01:11:49.000000', 'consum', 0.0218, 'lps'),
	(588244, 129, '2014-03-15 01:11:50.000000', 'consum', 0.0223, 'lps'),
	(588245, 129, '2014-03-15 01:11:51.000000', 'consum', 0.0211, 'lps'),
	(588246, 129, '2014-03-15 01:11:52.000000', 'consum', 0.0217, 'lps'),
	(588247, 129, '2014-03-15 01:11:53.000000', 'consum', 0.0216, 'lps'),
	(588248, 129, '2014-03-15 01:11:54.000000', 'consum', 0.0220, 'lps'),
	(588249, 129, '2014-03-15 01:11:55.000000', 'consum', 0.0216, 'lps'),
	(588250, 129, '2014-03-15 01:11:56.000000', 'consum', 0.0221, 'lps'),
	(588251, 129, '2014-03-15 01:11:57.000000', 'consum', 0.0222, 'lps'),
	(588252, 129, '2014-03-15 01:11:58.000000', 'consum', 0.0211, 'lps'),
	(588253, 129, '2014-03-15 01:11:59.000000', 'consum', 0.0218, 'lps'),
	(588254, 129, '2014-03-15 01:12:00.000000', 'consum', 0.0220, 'lps'),
	(588255, 129, '2014-03-15 01:12:01.000000', 'consum', 0.0211, 'lps'),
	(588256, 129, '2014-03-15 01:12:02.000000', 'consum', 0.0211, 'lps'),
	(588257, 129, '2014-03-15 01:12:03.000000', 'consum', 0.0212, 'lps'),
	(588258, 129, '2014-03-15 01:12:04.000000', 'consum', 0.0217, 'lps'),
	(588259, 129, '2014-03-15 01:12:05.000000', 'consum', 0.0211, 'lps'),
	(588260, 129, '2014-03-15 01:12:06.000000', 'consum', 0.0223, 'lps'),
	(588261, 129, '2014-03-15 01:12:07.000000', 'consum', 0.0218, 'lps'),
	(588262, 129, '2014-03-15 01:12:08.000000', 'consum', 0.0223, 'lps'),
	(588263, 129, '2014-03-15 01:12:09.000000', 'consum', 0.0213, 'lps'),
	(588264, 129, '2014-03-15 01:12:10.000000', 'consum', 0.0212, 'lps'),
	(588265, 129, '2014-03-15 01:12:11.000000', 'consum', 0.0211, 'lps'),
	(588266, 129, '2014-03-15 01:12:12.000000', 'consum', 0.0212, 'lps'),
	(588267, 129, '2014-03-15 01:12:13.000000', 'consum', 0.0216, 'lps'),
	(588268, 129, '2014-03-15 01:12:14.000000', 'consum', 0.0219, 'lps'),
	(588269, 129, '2014-03-15 01:12:15.000000', 'consum', 0.0212, 'lps'),
	(588270, 129, '2014-03-15 01:12:16.000000', 'consum', 0.0220, 'lps'),
	(588271, 129, '2014-03-15 01:12:17.000000', 'consum', 0.0212, 'lps'),
	(588272, 129, '2014-03-15 01:12:18.000000', 'consum', 0.0221, 'lps'),
	(588273, 129, '2014-03-15 01:12:19.000000', 'consum', 0.0214, 'lps'),
	(588274, 129, '2014-03-15 01:12:20.000000', 'consum', 0.0215, 'lps'),
	(588275, 129, '2014-03-15 01:12:21.000000', 'consum', 0.0221, 'lps'),
	(588276, 129, '2014-03-15 01:12:22.000000', 'consum', 0.0223, 'lps'),
	(588277, 129, '2014-03-15 01:12:23.000000', 'consum', 0.0213, 'lps'),
	(588278, 129, '2014-03-15 01:12:24.000000', 'consum', 0.0215, 'lps'),
	(588279, 129, '2014-03-15 01:12:25.000000', 'consum', 0.0211, 'lps'),
	(588280, 129, '2014-03-15 01:12:26.000000', 'consum', 0.0216, 'lps'),
	(588281, 129, '2014-03-15 01:12:27.000000', 'consum', 0.0211, 'lps'),
	(588282, 129, '2014-03-15 01:12:28.000000', 'consum', 0.0212, 'lps'),
	(588283, 129, '2014-03-15 01:12:29.000000', 'consum', 0.0216, 'lps'),
	(588284, 129, '2014-03-15 01:12:30.000000', 'consum', 0.0222, 'lps'),
	(588285, 129, '2014-03-15 01:12:31.000000', 'consum', 0.0223, 'lps'),
	(588286, 129, '2014-03-15 01:12:32.000000', 'consum', 0.0210, 'lps'),
	(588287, 129, '2014-03-15 01:12:33.000000', 'consum', 0.0216, 'lps'),
	(588288, 129, '2014-03-15 01:12:34.000000', 'consum', 0.0214, 'lps'),
	(588289, 129, '2014-03-15 01:12:35.000000', 'consum', 0.0210, 'lps'),
	(588290, 129, '2014-03-15 01:12:36.000000', 'consum', 0.0213, 'lps'),
	(588291, 129, '2014-03-15 01:12:37.000000', 'consum', 0.0210, 'lps'),
	(588292, 129, '2014-03-15 01:12:38.000000', 'consum', 0.0216, 'lps'),
	(588293, 129, '2014-03-15 01:12:39.000000', 'consum', 0.0212, 'lps'),
	(588294, 129, '2014-03-15 01:12:40.000000', 'consum', 0.0218, 'lps'),
	(588295, 129, '2014-03-15 01:12:41.000000', 'consum', 0.0214, 'lps'),
	(588296, 129, '2014-03-15 01:12:42.000000', 'consum', 0.0221, 'lps'),
	(588297, 129, '2014-03-15 01:12:43.000000', 'consum', 0.0214, 'lps'),
	(588298, 129, '2014-03-15 01:12:44.000000', 'consum', 0.0222, 'lps'),
	(588299, 129, '2014-03-15 01:12:45.000000', 'consum', 0.0218, 'lps'),
	(588300, 129, '2014-03-15 01:12:46.000000', 'consum', 0.0215, 'lps'),
	(588301, 129, '2014-03-15 01:12:47.000000', 'consum', 0.0213, 'lps'),
	(588302, 129, '2014-03-15 01:12:48.000000', 'consum', 0.0222, 'lps'),
	(588303, 129, '2014-03-15 01:12:49.000000', 'consum', 0.0222, 'lps'),
	(588304, 129, '2014-03-15 01:12:50.000000', 'consum', 0.0219, 'lps'),
	(588305, 129, '2014-03-15 01:12:51.000000', 'consum', 0.0220, 'lps'),
	(588306, 129, '2014-03-15 01:12:52.000000', 'consum', 0.0219, 'lps'),
	(588307, 129, '2014-03-15 01:12:53.000000', 'consum', 0.0212, 'lps'),
	(588308, 129, '2014-03-15 01:12:54.000000', 'consum', 0.0222, 'lps'),
	(588309, 129, '2014-03-15 01:12:55.000000', 'consum', 0.0222, 'lps'),
	(588310, 129, '2014-03-15 01:12:56.000000', 'consum', 0.0220, 'lps'),
	(588311, 129, '2014-03-15 01:12:57.000000', 'consum', 0.0212, 'lps'),
	(588312, 129, '2014-03-15 01:12:58.000000', 'consum', 0.0217, 'lps'),
	(588313, 129, '2014-03-15 01:12:59.000000', 'consum', 0.0212, 'lps'),
	(588314, 129, '2014-03-15 01:13:00.000000', 'consum', 0.0212, 'lps'),
	(588315, 129, '2014-03-15 01:13:01.000000', 'consum', 0.0215, 'lps'),
	(588316, 129, '2014-03-15 01:13:02.000000', 'consum', 0.0218, 'lps'),
	(588317, 129, '2014-03-15 01:13:03.000000', 'consum', 0.0218, 'lps'),
	(588318, 129, '2014-03-15 01:13:04.000000', 'consum', 0.0215, 'lps'),
	(588319, 129, '2014-03-15 01:13:05.000000', 'consum', 0.0212, 'lps'),
	(588320, 129, '2014-03-15 01:13:06.000000', 'consum', 0.0219, 'lps'),
	(588321, 129, '2014-03-15 01:13:07.000000', 'consum', 0.0221, 'lps'),
	(588322, 129, '2014-03-15 01:13:08.000000', 'consum', 0.0212, 'lps'),
	(588323, 129, '2014-03-15 01:13:09.000000', 'consum', 0.0216, 'lps'),
	(588324, 129, '2014-03-15 01:13:10.000000', 'consum', 0.0218, 'lps'),
	(588325, 129, '2014-03-15 01:13:11.000000', 'consum', 0.0218, 'lps'),
	(588326, 129, '2014-03-15 01:13:12.000000', 'consum', 0.0215, 'lps'),
	(588327, 129, '2014-03-15 01:13:13.000000', 'consum', 0.0223, 'lps'),
	(588328, 129, '2014-03-15 01:13:14.000000', 'consum', 0.0221, 'lps'),
	(588329, 129, '2014-03-15 01:13:15.000000', 'consum', 0.0210, 'lps'),
	(588330, 129, '2014-03-15 01:13:16.000000', 'consum', 0.0218, 'lps'),
	(588331, 129, '2014-03-15 01:13:17.000000', 'consum', 0.0212, 'lps'),
	(588332, 129, '2014-03-15 01:13:18.000000', 'consum', 0.0223, 'lps'),
	(588333, 129, '2014-03-15 01:13:19.000000', 'consum', 0.0216, 'lps'),
	(588334, 129, '2014-03-15 01:13:20.000000', 'consum', 0.0213, 'lps'),
	(588335, 129, '2014-03-15 01:13:21.000000', 'consum', 0.0223, 'lps'),
	(588336, 129, '2014-03-15 01:13:22.000000', 'consum', 0.0210, 'lps'),
	(588337, 129, '2014-03-15 01:13:23.000000', 'consum', 0.0213, 'lps'),
	(588338, 129, '2014-03-15 01:13:24.000000', 'consum', 0.0213, 'lps'),
	(588339, 129, '2014-03-15 01:13:25.000000', 'consum', 0.0217, 'lps'),
	(588340, 129, '2014-03-15 01:13:26.000000', 'consum', 0.0222, 'lps'),
	(588341, 129, '2014-03-15 01:13:27.000000', 'consum', 0.0219, 'lps'),
	(588342, 129, '2014-03-15 01:13:28.000000', 'consum', 0.0222, 'lps'),
	(588343, 129, '2014-03-15 01:13:29.000000', 'consum', 0.0214, 'lps'),
	(588344, 129, '2014-03-15 01:13:30.000000', 'consum', 0.0223, 'lps'),
	(588345, 129, '2014-03-15 01:13:31.000000', 'consum', 0.0223, 'lps'),
	(588346, 129, '2014-03-15 01:13:32.000000', 'consum', 0.0223, 'lps'),
	(588347, 129, '2014-03-15 01:13:33.000000', 'consum', 0.0223, 'lps'),
	(588348, 129, '2014-03-15 01:13:34.000000', 'consum', 0.0221, 'lps'),
	(588349, 129, '2014-03-15 01:13:35.000000', 'consum', 0.0212, 'lps'),
	(588350, 129, '2014-03-15 01:13:36.000000', 'consum', 0.0216, 'lps'),
	(588351, 129, '2014-03-15 01:13:37.000000', 'consum', 0.0221, 'lps'),
	(588352, 129, '2014-03-15 01:13:38.000000', 'consum', 0.0217, 'lps'),
	(588353, 129, '2014-03-15 01:13:39.000000', 'consum', 0.0216, 'lps'),
	(588354, 129, '2014-03-15 01:13:40.000000', 'consum', 0.0217, 'lps'),
	(588355, 129, '2014-03-15 01:13:41.000000', 'consum', 0.0214, 'lps'),
	(588356, 129, '2014-03-15 01:13:42.000000', 'consum', 0.0222, 'lps'),
	(588357, 129, '2014-03-15 01:13:43.000000', 'consum', 0.0219, 'lps'),
	(588358, 129, '2014-03-15 01:13:44.000000', 'consum', 0.0220, 'lps'),
	(588359, 129, '2014-03-15 01:13:45.000000', 'consum', 0.0218, 'lps'),
	(588360, 129, '2014-03-15 01:13:46.000000', 'consum', 0.0219, 'lps'),
	(588361, 129, '2014-03-15 01:13:47.000000', 'consum', 0.0221, 'lps'),
	(588362, 129, '2014-03-15 01:13:48.000000', 'consum', 0.0222, 'lps'),
	(588363, 129, '2014-03-15 01:13:49.000000', 'consum', 0.0223, 'lps'),
	(588364, 129, '2014-03-15 01:13:50.000000', 'consum', 0.0210, 'lps'),
	(588365, 129, '2014-03-15 01:13:51.000000', 'consum', 0.0217, 'lps'),
	(588366, 129, '2014-03-15 01:13:52.000000', 'consum', 0.0217, 'lps'),
	(588367, 129, '2014-03-15 01:13:53.000000', 'consum', 0.0222, 'lps'),
	(588368, 129, '2014-03-15 01:13:54.000000', 'consum', 0.0210, 'lps'),
	(588369, 129, '2014-03-15 01:13:55.000000', 'consum', 0.0215, 'lps'),
	(588370, 129, '2014-03-15 01:13:56.000000', 'consum', 0.0223, 'lps'),
	(588371, 129, '2014-03-15 01:13:57.000000', 'consum', 0.0217, 'lps'),
	(588372, 129, '2014-03-15 01:13:58.000000', 'consum', 0.0222, 'lps'),
	(588373, 129, '2014-03-15 01:13:59.000000', 'consum', 0.0220, 'lps'),
	(588374, 129, '2014-03-15 01:14:00.000000', 'consum', 0.0210, 'lps'),
	(588375, 129, '2014-03-15 01:14:01.000000', 'consum', 0.0210, 'lps'),
	(588376, 129, '2014-03-15 01:14:02.000000', 'consum', 0.0211, 'lps'),
	(588377, 129, '2014-03-15 01:14:03.000000', 'consum', 0.0216, 'lps'),
	(588378, 129, '2014-03-15 01:14:04.000000', 'consum', 0.0210, 'lps'),
	(588379, 129, '2014-03-15 01:14:05.000000', 'consum', 0.0219, 'lps'),
	(588380, 129, '2014-03-15 01:14:06.000000', 'consum', 0.0213, 'lps'),
	(588381, 129, '2014-03-15 01:14:07.000000', 'consum', 0.0212, 'lps'),
	(588382, 129, '2014-03-15 01:14:08.000000', 'consum', 0.0211, 'lps'),
	(588383, 129, '2014-03-15 01:14:09.000000', 'consum', 0.0210, 'lps'),
	(588384, 129, '2014-03-15 01:14:10.000000', 'consum', 0.0223, 'lps'),
	(588385, 129, '2014-03-15 01:14:11.000000', 'consum', 0.0217, 'lps'),
	(588386, 129, '2014-03-15 01:14:12.000000', 'consum', 0.0222, 'lps'),
	(588387, 129, '2014-03-15 01:14:13.000000', 'consum', 0.0223, 'lps'),
	(588388, 129, '2014-03-15 01:14:14.000000', 'consum', 0.0211, 'lps'),
	(588389, 129, '2014-03-15 01:14:15.000000', 'consum', 0.0217, 'lps'),
	(588390, 129, '2014-03-15 01:14:16.000000', 'consum', 0.0215, 'lps'),
	(588391, 129, '2014-03-15 01:14:17.000000', 'consum', 0.0215, 'lps'),
	(588392, 129, '2014-03-15 01:14:18.000000', 'consum', 0.0218, 'lps'),
	(588393, 129, '2014-03-15 01:14:19.000000', 'consum', 0.0210, 'lps'),
	(588394, 129, '2014-03-15 01:14:20.000000', 'consum', 0.0212, 'lps'),
	(588395, 129, '2014-03-15 01:14:21.000000', 'consum', 0.0223, 'lps'),
	(588396, 129, '2014-03-15 01:14:22.000000', 'consum', 0.0212, 'lps'),
	(588397, 129, '2014-03-15 01:14:23.000000', 'consum', 0.0223, 'lps'),
	(588398, 129, '2014-03-15 01:14:24.000000', 'consum', 0.0213, 'lps'),
	(588399, 129, '2014-03-15 01:14:25.000000', 'consum', 0.0214, 'lps'),
	(588400, 129, '2014-03-15 01:14:26.000000', 'consum', 0.0223, 'lps'),
	(588401, 129, '2014-03-15 01:14:27.000000', 'consum', 0.0222, 'lps'),
	(588402, 129, '2014-03-15 01:14:28.000000', 'consum', 0.0219, 'lps'),
	(588403, 129, '2014-03-15 01:14:29.000000', 'consum', 0.0217, 'lps'),
	(588404, 129, '2014-03-15 01:14:30.000000', 'consum', 0.0220, 'lps'),
	(588405, 129, '2014-03-15 01:14:31.000000', 'consum', 0.0210, 'lps'),
	(588406, 129, '2014-03-15 01:14:32.000000', 'consum', 0.0210, 'lps'),
	(588407, 129, '2014-03-15 01:14:33.000000', 'consum', 0.0222, 'lps'),
	(588408, 129, '2014-03-15 01:14:34.000000', 'consum', 0.0216, 'lps'),
	(588409, 129, '2014-03-15 01:14:35.000000', 'consum', 0.0220, 'lps'),
	(588410, 129, '2014-03-15 01:14:36.000000', 'consum', 0.0215, 'lps'),
	(588411, 129, '2014-03-15 01:14:37.000000', 'consum', 0.0216, 'lps'),
	(588412, 129, '2014-03-15 01:14:38.000000', 'consum', 0.0215, 'lps'),
	(588413, 129, '2014-03-15 01:14:39.000000', 'consum', 0.0215, 'lps'),
	(588414, 129, '2014-03-15 01:14:40.000000', 'consum', 0.0222, 'lps'),
	(588415, 129, '2014-03-15 01:14:41.000000', 'consum', 0.0214, 'lps'),
	(588416, 129, '2014-03-15 01:14:42.000000', 'consum', 0.0221, 'lps'),
	(588417, 129, '2014-03-15 01:14:43.000000', 'consum', 0.0210, 'lps'),
	(588418, 129, '2014-03-15 01:14:44.000000', 'consum', 0.0221, 'lps'),
	(588419, 129, '2014-03-15 01:14:45.000000', 'consum', 0.0210, 'lps'),
	(588420, 129, '2014-03-15 01:14:46.000000', 'consum', 0.0219, 'lps'),
	(588421, 129, '2014-03-15 01:14:47.000000', 'consum', 0.0212, 'lps'),
	(588422, 129, '2014-03-15 01:14:48.000000', 'consum', 0.0223, 'lps'),
	(588423, 129, '2014-03-15 01:14:49.000000', 'consum', 0.0214, 'lps'),
	(588424, 129, '2014-03-15 01:14:50.000000', 'consum', 0.0220, 'lps'),
	(588425, 129, '2014-03-15 01:14:51.000000', 'consum', 0.0219, 'lps'),
	(588426, 129, '2014-03-15 01:14:52.000000', 'consum', 0.0213, 'lps'),
	(588427, 129, '2014-03-15 01:14:53.000000', 'consum', 0.0213, 'lps'),
	(588428, 129, '2014-03-15 01:14:54.000000', 'consum', 0.0218, 'lps'),
	(588429, 129, '2014-03-15 01:14:55.000000', 'consum', 0.0211, 'lps'),
	(588430, 129, '2014-03-15 01:14:56.000000', 'consum', 0.0218, 'lps'),
	(588431, 129, '2014-03-15 01:14:57.000000', 'consum', 0.0223, 'lps'),
	(588432, 129, '2014-03-15 01:14:58.000000', 'consum', 0.0220, 'lps'),
	(588433, 129, '2014-03-15 01:14:59.000000', 'consum', 0.0210, 'lps'),
	(588434, 129, '2014-03-15 01:15:00.000000', 'consum', 0.0220, 'lps'),
	(588435, 129, '2014-03-15 01:15:01.000000', 'consum', 0.0220, 'lps'),
	(588436, 129, '2014-03-15 01:15:02.000000', 'consum', 0.0216, 'lps'),
	(588437, 129, '2014-03-15 01:15:03.000000', 'consum', 0.0223, 'lps'),
	(588438, 129, '2014-03-15 01:15:04.000000', 'consum', 0.0217, 'lps'),
	(588439, 129, '2014-03-15 01:15:05.000000', 'consum', 0.0221, 'lps'),
	(588440, 129, '2014-03-15 01:15:06.000000', 'consum', 0.0216, 'lps'),
	(588441, 129, '2014-03-15 01:15:07.000000', 'consum', 0.0223, 'lps'),
	(588442, 129, '2014-03-15 01:15:08.000000', 'consum', 0.0215, 'lps'),
	(588443, 129, '2014-03-15 01:15:09.000000', 'consum', 0.0223, 'lps'),
	(588444, 129, '2014-03-15 01:15:10.000000', 'consum', 0.0221, 'lps'),
	(588445, 129, '2014-03-15 01:15:11.000000', 'consum', 0.0210, 'lps'),
	(588446, 129, '2014-03-15 01:15:12.000000', 'consum', 0.0221, 'lps'),
	(588447, 129, '2014-03-15 01:15:13.000000', 'consum', 0.0211, 'lps'),
	(588448, 129, '2014-03-15 01:15:14.000000', 'consum', 0.0223, 'lps'),
	(588449, 129, '2014-03-15 01:15:15.000000', 'consum', 0.0215, 'lps'),
	(588450, 129, '2014-03-15 01:15:16.000000', 'consum', 0.0211, 'lps'),
	(588451, 129, '2014-03-15 01:15:17.000000', 'consum', 0.0216, 'lps'),
	(588452, 129, '2014-03-15 01:15:18.000000', 'consum', 0.0222, 'lps'),
	(588453, 129, '2014-03-15 01:15:19.000000', 'consum', 0.0210, 'lps'),
	(588454, 129, '2014-03-15 01:15:20.000000', 'consum', 0.0216, 'lps'),
	(588455, 129, '2014-03-15 01:15:21.000000', 'consum', 0.0212, 'lps'),
	(588456, 129, '2014-03-15 01:15:22.000000', 'consum', 0.0219, 'lps'),
	(588457, 129, '2014-03-15 01:15:23.000000', 'consum', 0.0221, 'lps'),
	(588458, 129, '2014-03-15 01:15:24.000000', 'consum', 0.0222, 'lps'),
	(588459, 129, '2014-03-15 01:15:25.000000', 'consum', 0.0211, 'lps'),
	(588460, 129, '2014-03-15 01:15:26.000000', 'consum', 0.0220, 'lps'),
	(588461, 129, '2014-03-15 01:15:27.000000', 'consum', 0.0219, 'lps'),
	(588462, 129, '2014-03-15 01:15:28.000000', 'consum', 0.0222, 'lps'),
	(588463, 129, '2014-03-15 01:15:29.000000', 'consum', 0.0216, 'lps'),
	(588464, 129, '2014-03-15 01:15:30.000000', 'consum', 0.0218, 'lps'),
	(588465, 129, '2014-03-15 01:15:31.000000', 'consum', 0.0221, 'lps'),
	(588466, 129, '2014-03-15 01:15:32.000000', 'consum', 0.0212, 'lps'),
	(588467, 129, '2014-03-15 01:15:33.000000', 'consum', 0.0217, 'lps'),
	(588468, 129, '2014-03-15 01:15:34.000000', 'consum', 0.0211, 'lps'),
	(588469, 129, '2014-03-15 01:15:35.000000', 'consum', 0.0222, 'lps'),
	(588470, 129, '2014-03-15 01:15:36.000000', 'consum', 0.0210, 'lps'),
	(588471, 129, '2014-03-15 01:15:37.000000', 'consum', 0.0217, 'lps'),
	(588472, 129, '2014-03-15 01:15:38.000000', 'consum', 0.0219, 'lps'),
	(588473, 129, '2014-03-15 01:15:39.000000', 'consum', 0.0221, 'lps'),
	(588474, 129, '2014-03-15 01:15:40.000000', 'consum', 0.0223, 'lps'),
	(588475, 129, '2014-03-15 01:15:41.000000', 'consum', 0.0217, 'lps'),
	(588476, 129, '2014-03-15 01:15:42.000000', 'consum', 0.0219, 'lps'),
	(588477, 129, '2014-03-15 01:15:43.000000', 'consum', 0.0222, 'lps'),
	(588478, 129, '2014-03-15 01:15:44.000000', 'consum', 0.0215, 'lps'),
	(588479, 129, '2014-03-15 01:15:45.000000', 'consum', 0.0215, 'lps'),
	(588480, 129, '2014-03-15 01:15:46.000000', 'consum', 0.0220, 'lps'),
	(588481, 129, '2014-03-15 01:15:47.000000', 'consum', 0.0217, 'lps'),
	(588482, 129, '2014-03-15 01:15:48.000000', 'consum', 0.0213, 'lps'),
	(588483, 129, '2014-03-15 01:15:49.000000', 'consum', 0.0222, 'lps'),
	(588484, 129, '2014-03-15 01:15:50.000000', 'consum', 0.0219, 'lps'),
	(588485, 129, '2014-03-15 01:15:51.000000', 'consum', 0.0220, 'lps'),
	(588486, 129, '2014-03-15 01:15:52.000000', 'consum', 0.0219, 'lps'),
	(588487, 129, '2014-03-15 01:15:53.000000', 'consum', 0.0211, 'lps'),
	(588488, 129, '2014-03-15 01:15:54.000000', 'consum', 0.0218, 'lps'),
	(588489, 129, '2014-03-15 01:15:55.000000', 'consum', 0.0217, 'lps'),
	(588490, 129, '2014-03-15 01:15:56.000000', 'consum', 0.0223, 'lps'),
	(588491, 129, '2014-03-15 01:15:57.000000', 'consum', 0.0211, 'lps'),
	(588492, 129, '2014-03-15 01:15:58.000000', 'consum', 0.0219, 'lps'),
	(588493, 129, '2014-03-15 01:15:59.000000', 'consum', 0.0211, 'lps'),
	(588494, 129, '2014-03-15 01:16:00.000000', 'consum', 0.0217, 'lps'),
	(588495, 129, '2014-03-15 01:16:01.000000', 'consum', 0.0215, 'lps'),
	(588496, 129, '2014-03-15 01:16:02.000000', 'consum', 0.0215, 'lps'),
	(588497, 129, '2014-03-15 01:16:03.000000', 'consum', 0.0218, 'lps'),
	(588498, 129, '2014-03-15 01:16:04.000000', 'consum', 0.0223, 'lps'),
	(588499, 129, '2014-03-15 01:16:05.000000', 'consum', 0.0223, 'lps'),
	(588500, 129, '2014-03-15 01:16:06.000000', 'consum', 0.0210, 'lps'),
	(588501, 129, '2014-03-15 01:16:07.000000', 'consum', 0.0211, 'lps'),
	(588502, 129, '2014-03-15 01:16:08.000000', 'consum', 0.0215, 'lps'),
	(588503, 129, '2014-03-15 01:16:09.000000', 'consum', 0.0220, 'lps'),
	(588504, 129, '2014-03-15 01:16:10.000000', 'consum', 0.0215, 'lps'),
	(588505, 129, '2014-03-15 01:16:11.000000', 'consum', 0.0222, 'lps'),
	(588506, 129, '2014-03-15 01:16:12.000000', 'consum', 0.0211, 'lps'),
	(588507, 129, '2014-03-15 01:16:13.000000', 'consum', 0.0210, 'lps'),
	(588508, 129, '2014-03-15 01:16:14.000000', 'consum', 0.0220, 'lps'),
	(588509, 129, '2014-03-15 01:16:15.000000', 'consum', 0.0217, 'lps'),
	(588510, 129, '2014-03-15 01:16:16.000000', 'consum', 0.0218, 'lps'),
	(588511, 129, '2014-03-15 01:16:17.000000', 'consum', 0.0216, 'lps'),
	(588512, 129, '2014-03-15 01:16:18.000000', 'consum', 0.0217, 'lps'),
	(588513, 129, '2014-03-15 01:16:19.000000', 'consum', 0.0213, 'lps'),
	(588514, 129, '2014-03-15 01:16:20.000000', 'consum', 0.0218, 'lps'),
	(588515, 129, '2014-03-15 01:16:21.000000', 'consum', 0.0214, 'lps'),
	(588516, 129, '2014-03-15 01:16:22.000000', 'consum', 0.0218, 'lps'),
	(588517, 129, '2014-03-15 01:16:23.000000', 'consum', 0.0213, 'lps'),
	(588518, 129, '2014-03-15 01:16:24.000000', 'consum', 0.0217, 'lps'),
	(588519, 129, '2014-03-15 01:16:25.000000', 'consum', 0.0219, 'lps'),
	(588520, 129, '2014-03-15 01:16:26.000000', 'consum', 0.0210, 'lps'),
	(588521, 129, '2014-03-15 01:16:27.000000', 'consum', 0.0223, 'lps'),
	(588522, 129, '2014-03-15 01:16:28.000000', 'consum', 0.0220, 'lps'),
	(588523, 129, '2014-03-15 01:16:29.000000', 'consum', 0.0222, 'lps'),
	(588524, 129, '2014-03-15 01:16:30.000000', 'consum', 0.0214, 'lps'),
	(588525, 129, '2014-03-15 01:16:31.000000', 'consum', 0.0220, 'lps'),
	(588526, 129, '2014-03-15 01:16:32.000000', 'consum', 0.0222, 'lps'),
	(588527, 129, '2014-03-15 01:16:33.000000', 'consum', 0.0210, 'lps'),
	(588528, 129, '2014-03-15 01:16:34.000000', 'consum', 0.0219, 'lps'),
	(588529, 129, '2014-03-15 01:16:35.000000', 'consum', 0.0213, 'lps'),
	(588530, 129, '2014-03-15 01:16:36.000000', 'consum', 0.0214, 'lps'),
	(588531, 129, '2014-03-15 01:16:37.000000', 'consum', 0.0220, 'lps'),
	(588532, 129, '2014-03-15 01:16:38.000000', 'consum', 0.0219, 'lps'),
	(588533, 129, '2014-03-15 01:16:39.000000', 'consum', 0.0213, 'lps'),
	(588534, 129, '2014-03-15 01:16:40.000000', 'consum', 0.0213, 'lps'),
	(588535, 129, '2014-03-15 01:16:41.000000', 'consum', 0.0217, 'lps'),
	(588536, 129, '2014-03-15 01:16:42.000000', 'consum', 0.0221, 'lps'),
	(588537, 129, '2014-03-15 01:16:43.000000', 'consum', 0.0219, 'lps'),
	(588538, 129, '2014-03-15 01:16:44.000000', 'consum', 0.0220, 'lps'),
	(588539, 129, '2014-03-15 01:16:45.000000', 'consum', 0.0221, 'lps'),
	(588540, 129, '2014-03-15 01:16:46.000000', 'consum', 0.0222, 'lps'),
	(588541, 129, '2014-03-15 01:16:47.000000', 'consum', 0.0221, 'lps'),
	(588542, 129, '2014-03-15 01:16:48.000000', 'consum', 0.0216, 'lps'),
	(588543, 129, '2014-03-15 01:16:49.000000', 'consum', 0.0223, 'lps'),
	(588544, 129, '2014-03-15 01:16:50.000000', 'consum', 0.0216, 'lps'),
	(588545, 129, '2014-03-15 01:16:51.000000', 'consum', 0.0215, 'lps'),
	(588546, 129, '2014-03-15 01:16:52.000000', 'consum', 0.0219, 'lps'),
	(588547, 129, '2014-03-15 01:16:53.000000', 'consum', 0.0211, 'lps'),
	(588548, 129, '2014-03-15 01:16:54.000000', 'consum', 0.0216, 'lps'),
	(588549, 129, '2014-03-15 01:16:55.000000', 'consum', 0.0210, 'lps'),
	(588550, 129, '2014-03-15 01:16:56.000000', 'consum', 0.0220, 'lps'),
	(588551, 129, '2014-03-15 01:16:57.000000', 'consum', 0.0219, 'lps'),
	(588552, 129, '2014-03-15 01:16:58.000000', 'consum', 0.0212, 'lps'),
	(588553, 129, '2014-03-15 01:16:59.000000', 'consum', 0.0222, 'lps'),
	(588554, 129, '2014-03-15 01:17:00.000000', 'consum', 0.0223, 'lps'),
	(588555, 129, '2014-03-15 01:17:01.000000', 'consum', 0.0211, 'lps'),
	(588556, 129, '2014-03-15 01:17:02.000000', 'consum', 0.0217, 'lps'),
	(588557, 129, '2014-03-15 01:17:03.000000', 'consum', 0.0214, 'lps'),
	(588558, 129, '2014-03-15 01:17:04.000000', 'consum', 0.0211, 'lps'),
	(588559, 129, '2014-03-15 01:17:05.000000', 'consum', 0.0219, 'lps'),
	(588560, 129, '2014-03-15 01:17:06.000000', 'consum', 0.0221, 'lps'),
	(588561, 129, '2014-03-15 01:17:07.000000', 'consum', 0.0213, 'lps'),
	(588562, 129, '2014-03-15 01:17:08.000000', 'consum', 0.0218, 'lps'),
	(588563, 129, '2014-03-15 01:17:09.000000', 'consum', 0.0216, 'lps'),
	(588564, 129, '2014-03-15 01:17:10.000000', 'consum', 0.0218, 'lps'),
	(588565, 129, '2014-03-15 01:17:11.000000', 'consum', 0.0215, 'lps'),
	(588566, 129, '2014-03-15 01:17:12.000000', 'consum', 0.0214, 'lps'),
	(588567, 129, '2014-03-15 01:17:13.000000', 'consum', 0.0213, 'lps'),
	(588568, 129, '2014-03-15 01:17:14.000000', 'consum', 0.0216, 'lps'),
	(588569, 129, '2014-03-15 01:17:15.000000', 'consum', 0.0218, 'lps'),
	(588570, 129, '2014-03-15 01:17:16.000000', 'consum', 0.0218, 'lps'),
	(588571, 129, '2014-03-15 01:17:17.000000', 'consum', 0.0213, 'lps'),
	(588572, 129, '2014-03-15 01:17:18.000000', 'consum', 0.0217, 'lps'),
	(588573, 129, '2014-03-15 01:17:19.000000', 'consum', 0.0221, 'lps'),
	(588574, 129, '2014-03-15 01:17:20.000000', 'consum', 0.0214, 'lps'),
	(588575, 129, '2014-03-15 01:17:21.000000', 'consum', 0.0215, 'lps'),
	(588576, 129, '2014-03-15 01:17:22.000000', 'consum', 0.0222, 'lps'),
	(588577, 129, '2014-03-15 01:17:23.000000', 'consum', 0.0214, 'lps'),
	(588578, 129, '2014-03-15 01:17:24.000000', 'consum', 0.0221, 'lps'),
	(588579, 129, '2014-03-15 01:17:25.000000', 'consum', 0.0212, 'lps'),
	(588580, 129, '2014-03-15 01:17:26.000000', 'consum', 0.0217, 'lps'),
	(588581, 129, '2014-03-15 01:17:27.000000', 'consum', 0.0212, 'lps'),
	(588582, 129, '2014-03-15 01:17:28.000000', 'consum', 0.0214, 'lps'),
	(588583, 129, '2014-03-15 01:17:29.000000', 'consum', 0.0222, 'lps'),
	(588584, 129, '2014-03-15 01:17:30.000000', 'consum', 0.0217, 'lps'),
	(588585, 129, '2014-03-15 01:17:31.000000', 'consum', 0.0211, 'lps'),
	(588586, 129, '2014-03-15 01:17:32.000000', 'consum', 0.0222, 'lps'),
	(588587, 129, '2014-03-15 01:17:33.000000', 'consum', 0.0210, 'lps'),
	(588588, 129, '2014-03-15 01:17:34.000000', 'consum', 0.0216, 'lps'),
	(588589, 129, '2014-03-15 01:17:35.000000', 'consum', 0.0213, 'lps'),
	(588590, 129, '2014-03-15 01:17:36.000000', 'consum', 0.0223, 'lps'),
	(588591, 129, '2014-03-15 01:17:37.000000', 'consum', 0.0212, 'lps'),
	(588592, 129, '2014-03-15 01:17:38.000000', 'consum', 0.0220, 'lps'),
	(588593, 129, '2014-03-15 01:17:39.000000', 'consum', 0.0215, 'lps'),
	(588594, 129, '2014-03-15 01:17:40.000000', 'consum', 0.0217, 'lps'),
	(588595, 129, '2014-03-15 01:17:41.000000', 'consum', 0.0219, 'lps'),
	(588596, 129, '2014-03-15 01:17:42.000000', 'consum', 0.0218, 'lps'),
	(588597, 129, '2014-03-15 01:17:43.000000', 'consum', 0.0211, 'lps'),
	(588598, 129, '2014-03-15 01:17:44.000000', 'consum', 0.0218, 'lps'),
	(588599, 129, '2014-03-15 01:17:45.000000', 'consum', 0.0222, 'lps'),
	(588600, 129, '2014-03-15 01:17:46.000000', 'consum', 0.0216, 'lps'),
	(588601, 129, '2014-03-15 01:17:47.000000', 'consum', 0.0219, 'lps'),
	(588602, 129, '2014-03-15 01:17:48.000000', 'consum', 0.0211, 'lps'),
	(588603, 129, '2014-03-15 01:17:49.000000', 'consum', 0.0216, 'lps'),
	(588604, 129, '2014-03-15 01:17:50.000000', 'consum', 0.0223, 'lps'),
	(588605, 129, '2014-03-15 01:17:51.000000', 'consum', 0.0215, 'lps'),
	(588606, 129, '2014-03-15 01:17:52.000000', 'consum', 0.0223, 'lps'),
	(588607, 129, '2014-03-15 01:17:53.000000', 'consum', 0.0219, 'lps'),
	(588608, 129, '2014-03-15 01:17:54.000000', 'consum', 0.0218, 'lps'),
	(588609, 129, '2014-03-15 01:17:55.000000', 'consum', 0.0222, 'lps'),
	(588610, 129, '2014-03-15 01:17:56.000000', 'consum', 0.0218, 'lps'),
	(588611, 129, '2014-03-15 01:17:57.000000', 'consum', 0.0216, 'lps'),
	(588612, 129, '2014-03-15 01:17:58.000000', 'consum', 0.0215, 'lps'),
	(588613, 129, '2014-03-15 01:17:59.000000', 'consum', 0.0217, 'lps'),
	(588614, 129, '2014-03-15 01:18:00.000000', 'consum', 0.0215, 'lps'),
	(588615, 129, '2014-03-15 01:18:01.000000', 'consum', 0.0218, 'lps'),
	(588616, 129, '2014-03-15 01:18:02.000000', 'consum', 0.0220, 'lps'),
	(588617, 129, '2014-03-15 01:18:03.000000', 'consum', 0.0223, 'lps'),
	(588618, 129, '2014-03-15 01:18:04.000000', 'consum', 0.0215, 'lps'),
	(588619, 129, '2014-03-15 01:18:05.000000', 'consum', 0.0214, 'lps'),
	(588620, 129, '2014-03-15 01:18:06.000000', 'consum', 0.0214, 'lps'),
	(588621, 129, '2014-03-15 01:18:07.000000', 'consum', 0.0218, 'lps'),
	(588622, 129, '2014-03-15 01:18:08.000000', 'consum', 0.0211, 'lps'),
	(588623, 129, '2014-03-15 01:18:09.000000', 'consum', 0.0219, 'lps'),
	(588624, 129, '2014-03-15 01:18:10.000000', 'consum', 0.0212, 'lps'),
	(588625, 129, '2014-03-15 01:18:11.000000', 'consum', 0.0222, 'lps'),
	(588626, 129, '2014-03-15 01:18:12.000000', 'consum', 0.0223, 'lps'),
	(588627, 129, '2014-03-15 01:18:13.000000', 'consum', 0.0222, 'lps'),
	(588628, 129, '2014-03-15 01:18:14.000000', 'consum', 0.0221, 'lps'),
	(588629, 129, '2014-03-15 01:18:15.000000', 'consum', 0.0215, 'lps'),
	(588630, 129, '2014-03-15 01:18:16.000000', 'consum', 0.0216, 'lps'),
	(588631, 129, '2014-03-15 01:18:17.000000', 'consum', 0.0213, 'lps'),
	(588632, 129, '2014-03-15 01:18:18.000000', 'consum', 0.0221, 'lps'),
	(588633, 129, '2014-03-15 01:18:19.000000', 'consum', 0.0215, 'lps'),
	(588634, 129, '2014-03-15 01:18:20.000000', 'consum', 0.0214, 'lps'),
	(588635, 129, '2014-03-15 01:18:21.000000', 'consum', 0.0217, 'lps'),
	(588636, 129, '2014-03-15 01:18:22.000000', 'consum', 0.0219, 'lps'),
	(588637, 129, '2014-03-15 01:18:23.000000', 'consum', 0.0222, 'lps'),
	(588638, 129, '2014-03-15 01:18:24.000000', 'consum', 0.0215, 'lps'),
	(588639, 129, '2014-03-15 01:18:25.000000', 'consum', 0.0214, 'lps'),
	(588640, 129, '2014-03-15 01:18:26.000000', 'consum', 0.0214, 'lps'),
	(588641, 129, '2014-03-15 01:18:27.000000', 'consum', 0.0221, 'lps'),
	(588642, 129, '2014-03-15 01:18:28.000000', 'consum', 0.0210, 'lps'),
	(588643, 129, '2014-03-15 01:18:29.000000', 'consum', 0.0219, 'lps'),
	(588644, 129, '2014-03-15 01:18:30.000000', 'consum', 0.0216, 'lps'),
	(588645, 129, '2014-03-15 01:18:31.000000', 'consum', 0.0211, 'lps'),
	(588646, 129, '2014-03-15 01:18:32.000000', 'consum', 0.0214, 'lps'),
	(588647, 129, '2014-03-15 01:18:33.000000', 'consum', 0.0211, 'lps'),
	(588648, 129, '2014-03-15 01:18:34.000000', 'consum', 0.0217, 'lps'),
	(588649, 129, '2014-03-15 01:18:35.000000', 'consum', 0.0215, 'lps'),
	(588650, 129, '2014-03-15 01:18:36.000000', 'consum', 0.0216, 'lps'),
	(588651, 129, '2014-03-15 01:18:37.000000', 'consum', 0.0210, 'lps'),
	(588652, 129, '2014-03-15 01:18:38.000000', 'consum', 0.0221, 'lps'),
	(588653, 129, '2014-03-15 01:18:39.000000', 'consum', 0.0222, 'lps'),
	(588654, 129, '2014-03-15 01:18:40.000000', 'consum', 0.0210, 'lps'),
	(588655, 129, '2014-03-15 01:18:41.000000', 'consum', 0.0217, 'lps'),
	(588656, 129, '2014-03-15 01:18:42.000000', 'consum', 0.0219, 'lps'),
	(588657, 129, '2014-03-15 01:18:43.000000', 'consum', 0.0221, 'lps'),
	(588658, 129, '2014-03-15 01:18:44.000000', 'consum', 0.0211, 'lps'),
	(588659, 129, '2014-03-15 01:18:45.000000', 'consum', 0.0210, 'lps'),
	(588660, 129, '2014-03-15 01:18:46.000000', 'consum', 0.0219, 'lps'),
	(588661, 129, '2014-03-15 01:18:47.000000', 'consum', 0.0215, 'lps'),
	(588662, 129, '2014-03-15 01:18:48.000000', 'consum', 0.0222, 'lps'),
	(588663, 129, '2014-03-15 01:18:49.000000', 'consum', 0.0214, 'lps'),
	(588664, 129, '2014-03-15 01:18:50.000000', 'consum', 0.0210, 'lps'),
	(588665, 129, '2014-03-15 01:18:51.000000', 'consum', 0.0211, 'lps'),
	(588666, 129, '2014-03-15 01:18:52.000000', 'consum', 0.0217, 'lps'),
	(588667, 129, '2014-03-15 01:18:53.000000', 'consum', 0.0212, 'lps'),
	(588668, 129, '2014-03-15 01:18:54.000000', 'consum', 0.0213, 'lps'),
	(588669, 129, '2014-03-15 01:18:55.000000', 'consum', 0.0219, 'lps'),
	(588670, 129, '2014-03-15 01:18:56.000000', 'consum', 0.0219, 'lps'),
	(588671, 129, '2014-03-15 01:18:57.000000', 'consum', 0.0215, 'lps'),
	(588672, 129, '2014-03-15 01:18:58.000000', 'consum', 0.0223, 'lps'),
	(588673, 129, '2014-03-15 01:18:59.000000', 'consum', 0.0219, 'lps'),
	(588674, 129, '2014-03-15 01:19:00.000000', 'consum', 0.0215, 'lps'),
	(588675, 129, '2014-03-15 01:19:01.000000', 'consum', 0.0223, 'lps'),
	(588676, 129, '2014-03-15 01:19:02.000000', 'consum', 0.0219, 'lps'),
	(588677, 129, '2014-03-15 01:19:03.000000', 'consum', 0.0215, 'lps'),
	(588678, 129, '2014-03-15 01:19:04.000000', 'consum', 0.0210, 'lps'),
	(588679, 129, '2014-03-15 01:19:05.000000', 'consum', 0.0223, 'lps'),
	(588680, 129, '2014-03-15 01:19:06.000000', 'consum', 0.0220, 'lps'),
	(588681, 129, '2014-03-15 01:19:07.000000', 'consum', 0.0221, 'lps'),
	(588682, 129, '2014-03-15 01:19:08.000000', 'consum', 0.0223, 'lps'),
	(588683, 129, '2014-03-15 01:19:09.000000', 'consum', 0.0216, 'lps'),
	(588684, 129, '2014-03-15 01:19:10.000000', 'consum', 0.0212, 'lps'),
	(588685, 129, '2014-03-15 01:19:11.000000', 'consum', 0.0219, 'lps'),
	(588686, 129, '2014-03-15 01:19:12.000000', 'consum', 0.0222, 'lps'),
	(588687, 129, '2014-03-15 01:19:13.000000', 'consum', 0.0213, 'lps'),
	(588688, 129, '2014-03-15 01:19:14.000000', 'consum', 0.0216, 'lps'),
	(588689, 129, '2014-03-15 01:19:15.000000', 'consum', 0.0221, 'lps'),
	(588690, 129, '2014-03-15 01:19:16.000000', 'consum', 0.0220, 'lps'),
	(588691, 129, '2014-03-15 01:19:17.000000', 'consum', 0.0212, 'lps'),
	(588692, 129, '2014-03-15 01:19:18.000000', 'consum', 0.0220, 'lps'),
	(588693, 129, '2014-03-15 01:19:19.000000', 'consum', 0.0213, 'lps'),
	(588694, 129, '2014-03-15 01:19:20.000000', 'consum', 0.0221, 'lps'),
	(588695, 129, '2014-03-15 01:19:21.000000', 'consum', 0.0216, 'lps'),
	(588696, 129, '2014-03-15 01:19:22.000000', 'consum', 0.0221, 'lps'),
	(588697, 129, '2014-03-15 01:19:23.000000', 'consum', 0.0221, 'lps'),
	(588698, 129, '2014-03-15 01:19:24.000000', 'consum', 0.0218, 'lps'),
	(588699, 129, '2014-03-15 01:19:25.000000', 'consum', 0.0216, 'lps'),
	(588700, 129, '2014-03-15 01:19:26.000000', 'consum', 0.0217, 'lps'),
	(588701, 130, '2014-03-15 00:00:00.000000', 'consum', 0.0213, 'lps'),
	(588702, 130, '2014-03-15 00:00:01.000000', 'consum', 0.0220, 'lps'),
	(588703, 130, '2014-03-15 00:00:02.000000', 'consum', 0.0222, 'lps'),
	(588704, 130, '2014-03-15 00:00:03.000000', 'consum', 0.0210, 'lps'),
	(588705, 130, '2014-03-15 00:00:04.000000', 'consum', 0.0222, 'lps'),
	(588706, 130, '2014-03-15 00:00:05.000000', 'consum', 0.0222, 'lps'),
	(588707, 130, '2014-03-15 00:00:06.000000', 'consum', 0.0222, 'lps'),
	(588708, 130, '2014-03-15 00:00:07.000000', 'consum', 0.0219, 'lps'),
	(588709, 130, '2014-03-15 00:00:08.000000', 'consum', 0.0219, 'lps'),
	(588710, 130, '2014-03-15 00:00:09.000000', 'consum', 0.0215, 'lps'),
	(588711, 130, '2014-03-15 00:00:10.000000', 'consum', 0.0222, 'lps'),
	(588712, 130, '2014-03-15 00:00:11.000000', 'consum', 0.0224, 'lps'),
	(588713, 130, '2014-03-15 00:00:12.000000', 'consum', 0.0216, 'lps'),
	(588714, 130, '2014-03-15 00:00:13.000000', 'consum', 0.0213, 'lps'),
	(588715, 130, '2014-03-15 00:00:14.000000', 'consum', 0.0224, 'lps'),
	(588716, 130, '2014-03-15 00:00:15.000000', 'consum', 0.0213, 'lps'),
	(588717, 130, '2014-03-15 00:00:16.000000', 'consum', 0.0211, 'lps'),
	(588718, 130, '2014-03-15 00:00:17.000000', 'consum', 0.0221, 'lps'),
	(588719, 130, '2014-03-15 00:00:18.000000', 'consum', 0.0219, 'lps'),
	(588720, 130, '2014-03-15 00:00:19.000000', 'consum', 0.0221, 'lps'),
	(588721, 130, '2014-03-15 00:00:20.000000', 'consum', 0.0224, 'lps'),
	(588722, 130, '2014-03-15 00:00:21.000000', 'consum', 0.0220, 'lps'),
	(588723, 130, '2014-03-15 00:00:22.000000', 'consum', 0.0216, 'lps'),
	(588724, 130, '2014-03-15 00:00:23.000000', 'consum', 0.0224, 'lps'),
	(588725, 130, '2014-03-15 00:00:24.000000', 'consum', 0.0219, 'lps'),
	(588726, 130, '2014-03-15 00:00:25.000000', 'consum', 0.0215, 'lps'),
	(588727, 130, '2014-03-15 00:00:26.000000', 'consum', 0.0222, 'lps'),
	(588728, 130, '2014-03-15 00:00:27.000000', 'consum', 0.0210, 'lps'),
	(588729, 130, '2014-03-15 00:00:28.000000', 'consum', 0.0220, 'lps'),
	(588730, 130, '2014-03-15 00:00:29.000000', 'consum', 0.0214, 'lps'),
	(588731, 130, '2014-03-15 00:00:30.000000', 'consum', 0.0217, 'lps'),
	(588732, 130, '2014-03-15 00:00:31.000000', 'consum', 0.0217, 'lps'),
	(588733, 130, '2014-03-15 00:00:32.000000', 'consum', 0.0212, 'lps'),
	(588734, 130, '2014-03-15 00:00:33.000000', 'consum', 0.0211, 'lps'),
	(588735, 130, '2014-03-15 00:00:34.000000', 'consum', 0.0212, 'lps'),
	(588736, 130, '2014-03-15 00:00:35.000000', 'consum', 0.0218, 'lps'),
	(588737, 130, '2014-03-15 00:00:36.000000', 'consum', 0.0213, 'lps'),
	(588738, 130, '2014-03-15 00:00:37.000000', 'consum', 0.0215, 'lps'),
	(588739, 130, '2014-03-15 00:00:38.000000', 'consum', 0.0214, 'lps'),
	(588740, 130, '2014-03-15 00:00:39.000000', 'consum', 0.0216, 'lps'),
	(588741, 130, '2014-03-15 00:00:40.000000', 'consum', 0.0213, 'lps'),
	(588742, 130, '2014-03-15 00:00:41.000000', 'consum', 0.0223, 'lps'),
	(588743, 130, '2014-03-15 00:00:42.000000', 'consum', 0.0223, 'lps'),
	(588744, 130, '2014-03-15 00:00:43.000000', 'consum', 0.0220, 'lps'),
	(588745, 130, '2014-03-15 00:00:44.000000', 'consum', 0.0222, 'lps'),
	(588746, 130, '2014-03-15 00:00:45.000000', 'consum', 0.0210, 'lps'),
	(588747, 130, '2014-03-15 00:00:46.000000', 'consum', 0.0219, 'lps'),
	(588748, 130, '2014-03-15 00:00:47.000000', 'consum', 0.0211, 'lps'),
	(588749, 130, '2014-03-15 00:00:48.000000', 'consum', 0.0219, 'lps'),
	(588750, 130, '2014-03-15 00:00:49.000000', 'consum', 0.0222, 'lps'),
	(588751, 130, '2014-03-15 00:00:50.000000', 'consum', 0.0212, 'lps'),
	(588752, 130, '2014-03-15 00:00:51.000000', 'consum', 0.0217, 'lps'),
	(588753, 130, '2014-03-15 00:00:52.000000', 'consum', 0.0222, 'lps'),
	(588754, 130, '2014-03-15 00:00:53.000000', 'consum', 0.0221, 'lps'),
	(588755, 130, '2014-03-15 00:00:54.000000', 'consum', 0.0216, 'lps'),
	(588756, 130, '2014-03-15 00:00:55.000000', 'consum', 0.0223, 'lps'),
	(588757, 130, '2014-03-15 00:00:56.000000', 'consum', 0.0210, 'lps'),
	(588758, 130, '2014-03-15 00:00:57.000000', 'consum', 0.0217, 'lps'),
	(588759, 130, '2014-03-15 00:00:58.000000', 'consum', 0.0216, 'lps'),
	(588760, 130, '2014-03-15 00:00:59.000000', 'consum', 0.0221, 'lps'),
	(588761, 130, '2014-03-15 00:01:00.000000', 'consum', 0.0215, 'lps'),
	(588762, 130, '2014-03-15 00:01:01.000000', 'consum', 0.0218, 'lps'),
	(588763, 130, '2014-03-15 00:01:02.000000', 'consum', 0.0220, 'lps'),
	(588764, 130, '2014-03-15 00:01:03.000000', 'consum', 0.0224, 'lps'),
	(588765, 130, '2014-03-15 00:01:04.000000', 'consum', 0.0220, 'lps'),
	(588766, 130, '2014-03-15 00:01:05.000000', 'consum', 0.0218, 'lps'),
	(588767, 130, '2014-03-15 00:01:06.000000', 'consum', 0.0220, 'lps'),
	(588768, 130, '2014-03-15 00:01:07.000000', 'consum', 0.0222, 'lps'),
	(588769, 130, '2014-03-15 00:01:08.000000', 'consum', 0.0223, 'lps'),
	(588770, 130, '2014-03-15 00:01:09.000000', 'consum', 0.0213, 'lps'),
	(588771, 130, '2014-03-15 00:01:10.000000', 'consum', 0.0214, 'lps'),
	(588772, 130, '2014-03-15 00:01:11.000000', 'consum', 0.0221, 'lps'),
	(588773, 130, '2014-03-15 00:01:12.000000', 'consum', 0.0211, 'lps'),
	(588774, 130, '2014-03-15 00:01:13.000000', 'consum', 0.0211, 'lps'),
	(588775, 130, '2014-03-15 00:01:14.000000', 'consum', 0.0211, 'lps'),
	(588776, 130, '2014-03-15 00:01:15.000000', 'consum', 0.0213, 'lps'),
	(588777, 130, '2014-03-15 00:01:16.000000', 'consum', 0.0222, 'lps'),
	(588778, 130, '2014-03-15 00:01:17.000000', 'consum', 0.0217, 'lps'),
	(588779, 130, '2014-03-15 00:01:18.000000', 'consum', 0.0222, 'lps'),
	(588780, 130, '2014-03-15 00:01:19.000000', 'consum', 0.0223, 'lps'),
	(588781, 130, '2014-03-15 00:01:20.000000', 'consum', 0.0210, 'lps'),
	(588782, 130, '2014-03-15 00:01:21.000000', 'consum', 0.0217, 'lps'),
	(588783, 130, '2014-03-15 00:01:22.000000', 'consum', 0.0215, 'lps'),
	(588784, 130, '2014-03-15 00:01:23.000000', 'consum', 0.0213, 'lps'),
	(588785, 130, '2014-03-15 00:01:24.000000', 'consum', 0.0213, 'lps'),
	(588786, 130, '2014-03-15 00:01:25.000000', 'consum', 0.0215, 'lps'),
	(588787, 130, '2014-03-15 00:01:26.000000', 'consum', 0.0212, 'lps'),
	(588788, 130, '2014-03-15 00:01:27.000000', 'consum', 0.0222, 'lps'),
	(588789, 130, '2014-03-15 00:01:28.000000', 'consum', 0.0217, 'lps'),
	(588790, 130, '2014-03-15 00:01:29.000000', 'consum', 0.0212, 'lps'),
	(588791, 130, '2014-03-15 00:01:30.000000', 'consum', 0.0215, 'lps'),
	(588792, 130, '2014-03-15 00:01:31.000000', 'consum', 0.0213, 'lps'),
	(588793, 130, '2014-03-15 00:01:32.000000', 'consum', 0.0211, 'lps'),
	(588794, 130, '2014-03-15 00:01:33.000000', 'consum', 0.0220, 'lps'),
	(588795, 130, '2014-03-15 00:01:34.000000', 'consum', 0.0213, 'lps'),
	(588796, 130, '2014-03-15 00:01:35.000000', 'consum', 0.0212, 'lps'),
	(588797, 130, '2014-03-15 00:01:36.000000', 'consum', 0.0211, 'lps'),
	(588798, 130, '2014-03-15 00:01:37.000000', 'consum', 0.0210, 'lps'),
	(588799, 130, '2014-03-15 00:01:38.000000', 'consum', 0.0222, 'lps'),
	(588800, 130, '2014-03-15 00:01:39.000000', 'consum', 0.0223, 'lps'),
	(588801, 130, '2014-03-15 00:01:40.000000', 'consum', 0.0213, 'lps'),
	(588802, 130, '2014-03-15 00:01:41.000000', 'consum', 0.0216, 'lps'),
	(588803, 130, '2014-03-15 00:01:42.000000', 'consum', 0.0215, 'lps'),
	(588804, 130, '2014-03-15 00:01:43.000000', 'consum', 0.0217, 'lps'),
	(588805, 130, '2014-03-15 00:01:44.000000', 'consum', 0.0215, 'lps'),
	(588806, 130, '2014-03-15 00:01:45.000000', 'consum', 0.0215, 'lps'),
	(588807, 130, '2014-03-15 00:01:46.000000', 'consum', 0.0219, 'lps'),
	(588808, 130, '2014-03-15 00:01:47.000000', 'consum', 0.0212, 'lps'),
	(588809, 130, '2014-03-15 00:01:48.000000', 'consum', 0.0223, 'lps'),
	(588810, 130, '2014-03-15 00:01:49.000000', 'consum', 0.0223, 'lps'),
	(588811, 130, '2014-03-15 00:01:50.000000', 'consum', 0.0221, 'lps'),
	(588812, 130, '2014-03-15 00:01:51.000000', 'consum', 0.0214, 'lps'),
	(588813, 130, '2014-03-15 00:01:52.000000', 'consum', 0.0210, 'lps'),
	(588814, 130, '2014-03-15 00:01:53.000000', 'consum', 0.0215, 'lps'),
	(588815, 130, '2014-03-15 00:01:54.000000', 'consum', 0.0221, 'lps'),
	(588816, 130, '2014-03-15 00:01:55.000000', 'consum', 0.0218, 'lps'),
	(588817, 130, '2014-03-15 00:01:56.000000', 'consum', 0.0220, 'lps'),
	(588818, 130, '2014-03-15 00:01:57.000000', 'consum', 0.0220, 'lps'),
	(588819, 130, '2014-03-15 00:01:58.000000', 'consum', 0.0217, 'lps'),
	(588820, 130, '2014-03-15 00:01:59.000000', 'consum', 0.0216, 'lps'),
	(588821, 130, '2014-03-15 00:02:00.000000', 'consum', 0.0221, 'lps'),
	(588822, 130, '2014-03-15 00:02:01.000000', 'consum', 0.0214, 'lps'),
	(588823, 130, '2014-03-15 00:02:02.000000', 'consum', 0.0213, 'lps'),
	(588824, 130, '2014-03-15 00:02:03.000000', 'consum', 0.0215, 'lps'),
	(588825, 130, '2014-03-15 00:02:04.000000', 'consum', 0.0224, 'lps'),
	(588826, 130, '2014-03-15 00:02:05.000000', 'consum', 0.0223, 'lps'),
	(588827, 130, '2014-03-15 00:02:06.000000', 'consum', 0.0216, 'lps'),
	(588828, 130, '2014-03-15 00:02:07.000000', 'consum', 0.0219, 'lps'),
	(588829, 130, '2014-03-15 00:02:08.000000', 'consum', 0.0221, 'lps'),
	(588830, 130, '2014-03-15 00:02:09.000000', 'consum', 0.0223, 'lps'),
	(588831, 130, '2014-03-15 00:02:10.000000', 'consum', 0.0215, 'lps'),
	(588832, 130, '2014-03-15 00:02:11.000000', 'consum', 0.0211, 'lps'),
	(588833, 130, '2014-03-15 00:02:12.000000', 'consum', 0.0213, 'lps'),
	(588834, 130, '2014-03-15 00:02:13.000000', 'consum', 0.0210, 'lps'),
	(588835, 130, '2014-03-15 00:02:14.000000', 'consum', 0.0218, 'lps'),
	(588836, 130, '2014-03-15 00:02:15.000000', 'consum', 0.0218, 'lps'),
	(588837, 130, '2014-03-15 00:02:16.000000', 'consum', 0.0212, 'lps'),
	(588838, 130, '2014-03-15 00:02:17.000000', 'consum', 0.0213, 'lps'),
	(588839, 130, '2014-03-15 00:02:18.000000', 'consum', 0.0220, 'lps'),
	(588840, 130, '2014-03-15 00:02:19.000000', 'consum', 0.0219, 'lps'),
	(588841, 130, '2014-03-15 00:02:20.000000', 'consum', 0.0211, 'lps'),
	(588842, 130, '2014-03-15 00:02:21.000000', 'consum', 0.0219, 'lps'),
	(588843, 130, '2014-03-15 00:02:22.000000', 'consum', 0.0223, 'lps'),
	(588844, 130, '2014-03-15 00:02:23.000000', 'consum', 0.0217, 'lps'),
	(588845, 130, '2014-03-15 00:02:24.000000', 'consum', 0.0220, 'lps'),
	(588846, 130, '2014-03-15 00:02:25.000000', 'consum', 0.0212, 'lps'),
	(588847, 130, '2014-03-15 00:02:26.000000', 'consum', 0.0218, 'lps'),
	(588848, 130, '2014-03-15 00:02:27.000000', 'consum', 0.0218, 'lps'),
	(588849, 130, '2014-03-15 00:02:28.000000', 'consum', 0.0223, 'lps'),
	(588850, 130, '2014-03-15 00:02:29.000000', 'consum', 0.0224, 'lps'),
	(588851, 130, '2014-03-15 00:02:30.000000', 'consum', 0.0212, 'lps'),
	(588852, 130, '2014-03-15 00:02:31.000000', 'consum', 0.0222, 'lps'),
	(588853, 130, '2014-03-15 00:02:32.000000', 'consum', 0.0222, 'lps'),
	(588854, 130, '2014-03-15 00:02:33.000000', 'consum', 0.0217, 'lps'),
	(588855, 130, '2014-03-15 00:02:34.000000', 'consum', 0.0210, 'lps'),
	(588856, 130, '2014-03-15 00:02:35.000000', 'consum', 0.0220, 'lps'),
	(588857, 130, '2014-03-15 00:02:36.000000', 'consum', 0.0217, 'lps'),
	(588858, 130, '2014-03-15 00:02:37.000000', 'consum', 0.0216, 'lps'),
	(588859, 130, '2014-03-15 00:02:38.000000', 'consum', 0.0216, 'lps'),
	(588860, 130, '2014-03-15 00:02:39.000000', 'consum', 0.0210, 'lps'),
	(588861, 130, '2014-03-15 00:02:40.000000', 'consum', 0.0223, 'lps'),
	(588862, 130, '2014-03-15 00:02:41.000000', 'consum', 0.0214, 'lps'),
	(588863, 130, '2014-03-15 00:02:42.000000', 'consum', 0.0222, 'lps'),
	(588864, 130, '2014-03-15 00:02:43.000000', 'consum', 0.0212, 'lps'),
	(588865, 130, '2014-03-15 00:02:44.000000', 'consum', 0.0217, 'lps'),
	(588866, 130, '2014-03-15 00:02:45.000000', 'consum', 0.0223, 'lps'),
	(588867, 130, '2014-03-15 00:02:46.000000', 'consum', 0.0210, 'lps'),
	(588868, 130, '2014-03-15 00:02:47.000000', 'consum', 0.0217, 'lps'),
	(588869, 130, '2014-03-15 00:02:48.000000', 'consum', 0.0214, 'lps'),
	(588870, 130, '2014-03-15 00:02:49.000000', 'consum', 0.0211, 'lps'),
	(588871, 130, '2014-03-15 00:02:50.000000', 'consum', 0.0218, 'lps'),
	(588872, 130, '2014-03-15 00:02:51.000000', 'consum', 0.0217, 'lps'),
	(588873, 130, '2014-03-15 00:02:52.000000', 'consum', 0.0223, 'lps'),
	(588874, 130, '2014-03-15 00:02:53.000000', 'consum', 0.0222, 'lps'),
	(588875, 130, '2014-03-15 00:02:54.000000', 'consum', 0.0216, 'lps'),
	(588876, 130, '2014-03-15 00:02:55.000000', 'consum', 0.0222, 'lps'),
	(588877, 130, '2014-03-15 00:02:56.000000', 'consum', 0.0222, 'lps'),
	(588878, 130, '2014-03-15 00:02:57.000000', 'consum', 0.0218, 'lps'),
	(588879, 130, '2014-03-15 00:02:58.000000', 'consum', 0.0216, 'lps'),
	(588880, 130, '2014-03-15 00:02:59.000000', 'consum', 0.0216, 'lps'),
	(588881, 130, '2014-03-15 00:03:00.000000', 'consum', 0.0222, 'lps'),
	(588882, 130, '2014-03-15 00:03:01.000000', 'consum', 0.0224, 'lps'),
	(588883, 130, '2014-03-15 00:03:02.000000', 'consum', 0.0215, 'lps'),
	(588884, 130, '2014-03-15 00:03:03.000000', 'consum', 0.0222, 'lps'),
	(588885, 130, '2014-03-15 00:03:04.000000', 'consum', 0.0213, 'lps'),
	(588886, 130, '2014-03-15 00:03:05.000000', 'consum', 0.0217, 'lps'),
	(588887, 130, '2014-03-15 00:03:06.000000', 'consum', 0.0223, 'lps'),
	(588888, 130, '2014-03-15 00:03:07.000000', 'consum', 0.0224, 'lps'),
	(588889, 130, '2014-03-15 00:03:08.000000', 'consum', 0.0212, 'lps'),
	(588890, 130, '2014-03-15 00:03:09.000000', 'consum', 0.0224, 'lps'),
	(588891, 130, '2014-03-15 00:03:10.000000', 'consum', 0.0214, 'lps'),
	(588892, 130, '2014-03-15 00:03:11.000000', 'consum', 0.0220, 'lps'),
	(588893, 130, '2014-03-15 00:03:12.000000', 'consum', 0.0215, 'lps'),
	(588894, 130, '2014-03-15 00:03:13.000000', 'consum', 0.0224, 'lps'),
	(588895, 130, '2014-03-15 00:03:14.000000', 'consum', 0.0219, 'lps'),
	(588896, 130, '2014-03-15 00:03:15.000000', 'consum', 0.0213, 'lps'),
	(588897, 130, '2014-03-15 00:03:16.000000', 'consum', 0.0212, 'lps'),
	(588898, 130, '2014-03-15 00:03:17.000000', 'consum', 0.0215, 'lps'),
	(588899, 130, '2014-03-15 00:03:18.000000', 'consum', 0.0212, 'lps'),
	(588900, 130, '2014-03-15 00:03:19.000000', 'consum', 0.0221, 'lps'),
	(588901, 130, '2014-03-15 00:03:20.000000', 'consum', 0.0214, 'lps'),
	(588902, 130, '2014-03-15 00:03:21.000000', 'consum', 0.0211, 'lps'),
	(588903, 130, '2014-03-15 00:03:22.000000', 'consum', 0.0219, 'lps'),
	(588904, 130, '2014-03-15 00:03:23.000000', 'consum', 0.0210, 'lps'),
	(588905, 130, '2014-03-15 00:03:24.000000', 'consum', 0.0212, 'lps'),
	(588906, 130, '2014-03-15 00:03:25.000000', 'consum', 0.0222, 'lps'),
	(588907, 130, '2014-03-15 00:03:26.000000', 'consum', 0.0221, 'lps'),
	(588908, 130, '2014-03-15 00:03:27.000000', 'consum', 0.0211, 'lps'),
	(588909, 130, '2014-03-15 00:03:28.000000', 'consum', 0.0214, 'lps'),
	(588910, 130, '2014-03-15 00:03:29.000000', 'consum', 0.0213, 'lps'),
	(588911, 130, '2014-03-15 00:03:30.000000', 'consum', 0.0213, 'lps'),
	(588912, 130, '2014-03-15 00:03:31.000000', 'consum', 0.0217, 'lps'),
	(588913, 130, '2014-03-15 00:03:32.000000', 'consum', 0.0223, 'lps'),
	(588914, 130, '2014-03-15 00:03:33.000000', 'consum', 0.0222, 'lps'),
	(588915, 130, '2014-03-15 00:03:34.000000', 'consum', 0.0217, 'lps'),
	(588916, 130, '2014-03-15 00:03:35.000000', 'consum', 0.0211, 'lps'),
	(588917, 130, '2014-03-15 00:03:36.000000', 'consum', 0.0224, 'lps'),
	(588918, 130, '2014-03-15 00:03:37.000000', 'consum', 0.0218, 'lps'),
	(588919, 130, '2014-03-15 00:03:38.000000', 'consum', 0.0221, 'lps'),
	(588920, 130, '2014-03-15 00:03:39.000000', 'consum', 0.0214, 'lps'),
	(588921, 130, '2014-03-15 00:03:40.000000', 'consum', 0.0213, 'lps'),
	(588922, 130, '2014-03-15 00:03:41.000000', 'consum', 0.0213, 'lps'),
	(588923, 130, '2014-03-15 00:03:42.000000', 'consum', 0.0217, 'lps'),
	(588924, 130, '2014-03-15 00:03:43.000000', 'consum', 0.0221, 'lps'),
	(588925, 130, '2014-03-15 00:03:44.000000', 'consum', 0.0214, 'lps'),
	(588926, 130, '2014-03-15 00:03:45.000000', 'consum', 0.0214, 'lps'),
	(588927, 130, '2014-03-15 00:03:46.000000', 'consum', 0.0217, 'lps'),
	(588928, 130, '2014-03-15 00:03:47.000000', 'consum', 0.0219, 'lps'),
	(588929, 130, '2014-03-15 00:03:48.000000', 'consum', 0.0220, 'lps'),
	(588930, 130, '2014-03-15 00:03:49.000000', 'consum', 0.0216, 'lps'),
	(588931, 130, '2014-03-15 00:03:50.000000', 'consum', 0.0214, 'lps'),
	(588932, 130, '2014-03-15 00:03:51.000000', 'consum', 0.0210, 'lps'),
	(588933, 130, '2014-03-15 00:03:52.000000', 'consum', 0.0213, 'lps'),
	(588934, 130, '2014-03-15 00:03:53.000000', 'consum', 0.0210, 'lps'),
	(588935, 130, '2014-03-15 00:03:54.000000', 'consum', 0.0217, 'lps'),
	(588936, 130, '2014-03-15 00:03:55.000000', 'consum', 0.0217, 'lps'),
	(588937, 130, '2014-03-15 00:03:56.000000', 'consum', 0.0210, 'lps'),
	(588938, 130, '2014-03-15 00:03:57.000000', 'consum', 0.0220, 'lps'),
	(588939, 130, '2014-03-15 00:03:58.000000', 'consum', 0.0214, 'lps'),
	(588940, 130, '2014-03-15 00:03:59.000000', 'consum', 0.0217, 'lps'),
	(588941, 130, '2014-03-15 00:04:00.000000', 'consum', 0.0217, 'lps'),
	(588942, 130, '2014-03-15 00:04:01.000000', 'consum', 0.0211, 'lps'),
	(588943, 130, '2014-03-15 00:04:02.000000', 'consum', 0.0224, 'lps'),
	(588944, 130, '2014-03-15 00:04:03.000000', 'consum', 0.0219, 'lps'),
	(588945, 130, '2014-03-15 00:04:04.000000', 'consum', 0.0211, 'lps'),
	(588946, 130, '2014-03-15 00:04:05.000000', 'consum', 0.0221, 'lps'),
	(588947, 130, '2014-03-15 00:04:06.000000', 'consum', 0.0215, 'lps'),
	(588948, 130, '2014-03-15 00:04:07.000000', 'consum', 0.0220, 'lps'),
	(588949, 130, '2014-03-15 00:04:08.000000', 'consum', 0.0213, 'lps'),
	(588950, 130, '2014-03-15 00:04:09.000000', 'consum', 0.0213, 'lps'),
	(588951, 130, '2014-03-15 00:04:10.000000', 'consum', 0.0217, 'lps'),
	(588952, 130, '2014-03-15 00:04:11.000000', 'consum', 0.0222, 'lps'),
	(588953, 130, '2014-03-15 00:04:12.000000', 'consum', 0.0220, 'lps'),
	(588954, 130, '2014-03-15 00:04:13.000000', 'consum', 0.0223, 'lps'),
	(588955, 130, '2014-03-15 00:04:14.000000', 'consum', 0.0217, 'lps'),
	(588956, 130, '2014-03-15 00:04:15.000000', 'consum', 0.0221, 'lps'),
	(588957, 130, '2014-03-15 00:04:16.000000', 'consum', 0.0215, 'lps'),
	(588958, 130, '2014-03-15 00:04:17.000000', 'consum', 0.0216, 'lps'),
	(588959, 130, '2014-03-15 00:04:18.000000', 'consum', 0.0210, 'lps'),
	(588960, 130, '2014-03-15 00:04:19.000000', 'consum', 0.0222, 'lps'),
	(588961, 130, '2014-03-15 00:04:20.000000', 'consum', 0.0210, 'lps'),
	(588962, 130, '2014-03-15 00:04:21.000000', 'consum', 0.0220, 'lps'),
	(588963, 130, '2014-03-15 00:04:22.000000', 'consum', 0.0215, 'lps'),
	(588964, 130, '2014-03-15 00:04:23.000000', 'consum', 0.0221, 'lps'),
	(588965, 130, '2014-03-15 00:04:24.000000', 'consum', 0.0220, 'lps'),
	(588966, 130, '2014-03-15 00:04:25.000000', 'consum', 0.0213, 'lps'),
	(588967, 130, '2014-03-15 00:04:26.000000', 'consum', 0.0212, 'lps'),
	(588968, 130, '2014-03-15 00:04:27.000000', 'consum', 0.0212, 'lps'),
	(588969, 130, '2014-03-15 00:04:28.000000', 'consum', 0.0212, 'lps'),
	(588970, 130, '2014-03-15 00:04:29.000000', 'consum', 0.0216, 'lps'),
	(588971, 130, '2014-03-15 00:04:30.000000', 'consum', 0.0220, 'lps'),
	(588972, 130, '2014-03-15 00:04:31.000000', 'consum', 0.0213, 'lps'),
	(588973, 130, '2014-03-15 00:04:32.000000', 'consum', 0.0223, 'lps'),
	(588974, 130, '2014-03-15 00:04:33.000000', 'consum', 0.0221, 'lps'),
	(588975, 130, '2014-03-15 00:04:34.000000', 'consum', 0.0213, 'lps'),
	(588976, 130, '2014-03-15 00:04:35.000000', 'consum', 0.0221, 'lps'),
	(588977, 130, '2014-03-15 00:04:36.000000', 'consum', 0.0210, 'lps'),
	(588978, 130, '2014-03-15 00:04:37.000000', 'consum', 0.0210, 'lps'),
	(588979, 130, '2014-03-15 00:04:38.000000', 'consum', 0.0212, 'lps'),
	(588980, 130, '2014-03-15 00:04:39.000000', 'consum', 0.0218, 'lps'),
	(588981, 130, '2014-03-15 00:04:40.000000', 'consum', 0.0214, 'lps'),
	(588982, 130, '2014-03-15 00:04:41.000000', 'consum', 0.0224, 'lps'),
	(588983, 130, '2014-03-15 00:04:42.000000', 'consum', 0.0221, 'lps'),
	(588984, 130, '2014-03-15 00:04:43.000000', 'consum', 0.0211, 'lps'),
	(588985, 130, '2014-03-15 00:04:44.000000', 'consum', 0.0210, 'lps'),
	(588986, 130, '2014-03-15 00:04:45.000000', 'consum', 0.0222, 'lps'),
	(588987, 130, '2014-03-15 00:04:46.000000', 'consum', 0.0212, 'lps'),
	(588988, 130, '2014-03-15 00:04:47.000000', 'consum', 0.0215, 'lps'),
	(588989, 130, '2014-03-15 00:04:48.000000', 'consum', 0.0214, 'lps'),
	(588990, 130, '2014-03-15 00:04:49.000000', 'consum', 0.0216, 'lps'),
	(588991, 130, '2014-03-15 00:04:50.000000', 'consum', 0.0213, 'lps'),
	(588992, 130, '2014-03-15 00:04:51.000000', 'consum', 0.0224, 'lps'),
	(588993, 130, '2014-03-15 00:04:52.000000', 'consum', 0.0211, 'lps'),
	(588994, 130, '2014-03-15 00:04:53.000000', 'consum', 0.0217, 'lps'),
	(588995, 130, '2014-03-15 00:04:54.000000', 'consum', 0.0213, 'lps'),
	(588996, 130, '2014-03-15 00:04:55.000000', 'consum', 0.0221, 'lps'),
	(588997, 130, '2014-03-15 00:04:56.000000', 'consum', 0.0210, 'lps'),
	(588998, 130, '2014-03-15 00:04:57.000000', 'consum', 0.0222, 'lps'),
	(588999, 130, '2014-03-15 00:04:58.000000', 'consum', 0.0213, 'lps'),
	(589000, 130, '2014-03-15 00:04:59.000000', 'consum', 0.0219, 'lps'),
	(589001, 130, '2014-03-15 00:05:00.000000', 'consum', 0.0214, 'lps'),
	(589002, 130, '2014-03-15 00:05:01.000000', 'consum', 0.0220, 'lps'),
	(589003, 130, '2014-03-15 00:05:02.000000', 'consum', 0.0218, 'lps'),
	(589004, 130, '2014-03-15 00:05:03.000000', 'consum', 0.0221, 'lps'),
	(589005, 130, '2014-03-15 00:05:04.000000', 'consum', 0.0211, 'lps'),
	(589006, 130, '2014-03-15 00:05:05.000000', 'consum', 0.0211, 'lps'),
	(589007, 130, '2014-03-15 00:05:06.000000', 'consum', 0.0212, 'lps'),
	(589008, 130, '2014-03-15 00:05:07.000000', 'consum', 0.0220, 'lps'),
	(589009, 130, '2014-03-15 00:05:08.000000', 'consum', 0.0223, 'lps'),
	(589010, 130, '2014-03-15 00:05:09.000000', 'consum', 0.0217, 'lps'),
	(589011, 130, '2014-03-15 00:05:10.000000', 'consum', 0.0223, 'lps'),
	(589012, 130, '2014-03-15 00:05:11.000000', 'consum', 0.0221, 'lps'),
	(589013, 130, '2014-03-15 00:05:12.000000', 'consum', 0.0213, 'lps'),
	(589014, 130, '2014-03-15 00:05:13.000000', 'consum', 0.0222, 'lps'),
	(589015, 130, '2014-03-15 00:05:14.000000', 'consum', 0.0219, 'lps'),
	(589016, 130, '2014-03-15 00:05:15.000000', 'consum', 0.0217, 'lps'),
	(589017, 130, '2014-03-15 00:05:16.000000', 'consum', 0.0219, 'lps'),
	(589018, 130, '2014-03-15 00:05:17.000000', 'consum', 0.0221, 'lps'),
	(589019, 130, '2014-03-15 00:05:18.000000', 'consum', 0.0221, 'lps'),
	(589020, 130, '2014-03-15 00:05:19.000000', 'consum', 0.0218, 'lps'),
	(589021, 130, '2014-03-15 00:05:20.000000', 'consum', 0.0219, 'lps'),
	(589022, 130, '2014-03-15 00:05:21.000000', 'consum', 0.0214, 'lps'),
	(589023, 130, '2014-03-15 00:05:22.000000', 'consum', 0.0220, 'lps'),
	(589024, 130, '2014-03-15 00:05:23.000000', 'consum', 0.0218, 'lps'),
	(589025, 130, '2014-03-15 00:05:24.000000', 'consum', 0.0219, 'lps'),
	(589026, 130, '2014-03-15 00:05:25.000000', 'consum', 0.0219, 'lps'),
	(589027, 130, '2014-03-15 00:05:26.000000', 'consum', 0.0211, 'lps'),
	(589028, 130, '2014-03-15 00:05:27.000000', 'consum', 0.0219, 'lps'),
	(589029, 130, '2014-03-15 00:05:28.000000', 'consum', 0.0210, 'lps'),
	(589030, 130, '2014-03-15 00:05:29.000000', 'consum', 0.0212, 'lps'),
	(589031, 130, '2014-03-15 00:05:30.000000', 'consum', 0.0220, 'lps'),
	(589032, 130, '2014-03-15 00:05:31.000000', 'consum', 0.0211, 'lps'),
	(589033, 130, '2014-03-15 00:05:32.000000', 'consum', 0.0215, 'lps'),
	(589034, 130, '2014-03-15 00:05:33.000000', 'consum', 0.0216, 'lps'),
	(589035, 130, '2014-03-15 00:05:34.000000', 'consum', 0.0213, 'lps'),
	(589036, 130, '2014-03-15 00:05:35.000000', 'consum', 0.0221, 'lps'),
	(589037, 130, '2014-03-15 00:05:36.000000', 'consum', 0.0214, 'lps'),
	(589038, 130, '2014-03-15 00:05:37.000000', 'consum', 0.0210, 'lps'),
	(589039, 130, '2014-03-15 00:05:38.000000', 'consum', 0.0216, 'lps'),
	(589040, 130, '2014-03-15 00:05:39.000000', 'consum', 0.0210, 'lps'),
	(589041, 130, '2014-03-15 00:05:40.000000', 'consum', 0.0221, 'lps'),
	(589042, 130, '2014-03-15 00:05:41.000000', 'consum', 0.0220, 'lps'),
	(589043, 130, '2014-03-15 00:05:42.000000', 'consum', 0.0211, 'lps'),
	(589044, 130, '2014-03-15 00:05:43.000000', 'consum', 0.0218, 'lps'),
	(589045, 130, '2014-03-15 00:05:44.000000', 'consum', 0.0218, 'lps'),
	(589046, 130, '2014-03-15 00:05:45.000000', 'consum', 0.0212, 'lps'),
	(589047, 130, '2014-03-15 00:05:46.000000', 'consum', 0.0210, 'lps'),
	(589048, 130, '2014-03-15 00:05:47.000000', 'consum', 0.0218, 'lps'),
	(589049, 130, '2014-03-15 00:05:48.000000', 'consum', 0.0224, 'lps'),
	(589050, 130, '2014-03-15 00:05:49.000000', 'consum', 0.0223, 'lps'),
	(589051, 130, '2014-03-15 00:05:50.000000', 'consum', 0.0221, 'lps'),
	(589052, 130, '2014-03-15 00:05:51.000000', 'consum', 0.0211, 'lps'),
	(589053, 130, '2014-03-15 00:05:52.000000', 'consum', 0.0212, 'lps'),
	(589054, 130, '2014-03-15 00:05:53.000000', 'consum', 0.0218, 'lps'),
	(589055, 130, '2014-03-15 00:05:54.000000', 'consum', 0.0212, 'lps'),
	(589056, 130, '2014-03-15 00:05:55.000000', 'consum', 0.0215, 'lps'),
	(589057, 130, '2014-03-15 00:05:56.000000', 'consum', 0.0212, 'lps'),
	(589058, 130, '2014-03-15 00:05:57.000000', 'consum', 0.0223, 'lps'),
	(589059, 130, '2014-03-15 00:05:58.000000', 'consum', 0.0224, 'lps'),
	(589060, 130, '2014-03-15 00:05:59.000000', 'consum', 0.0210, 'lps'),
	(589061, 130, '2014-03-15 00:06:00.000000', 'consum', 0.0213, 'lps'),
	(589062, 130, '2014-03-15 00:06:01.000000', 'consum', 0.0212, 'lps'),
	(589063, 130, '2014-03-15 00:06:02.000000', 'consum', 0.0212, 'lps'),
	(589064, 130, '2014-03-15 00:06:03.000000', 'consum', 0.0213, 'lps'),
	(589065, 130, '2014-03-15 00:06:04.000000', 'consum', 0.0219, 'lps'),
	(589066, 130, '2014-03-15 00:06:05.000000', 'consum', 0.0217, 'lps'),
	(589067, 130, '2014-03-15 00:06:06.000000', 'consum', 0.0220, 'lps'),
	(589068, 130, '2014-03-15 00:06:07.000000', 'consum', 0.0224, 'lps'),
	(589069, 130, '2014-03-15 00:06:08.000000', 'consum', 0.0219, 'lps'),
	(589070, 130, '2014-03-15 00:06:09.000000', 'consum', 0.0215, 'lps'),
	(589071, 130, '2014-03-15 00:06:10.000000', 'consum', 0.0221, 'lps'),
	(589072, 130, '2014-03-15 00:06:11.000000', 'consum', 0.0222, 'lps'),
	(589073, 130, '2014-03-15 00:06:12.000000', 'consum', 0.0221, 'lps'),
	(589074, 130, '2014-03-15 00:06:13.000000', 'consum', 0.0215, 'lps'),
	(589075, 130, '2014-03-15 00:06:14.000000', 'consum', 0.0218, 'lps'),
	(589076, 130, '2014-03-15 00:06:15.000000', 'consum', 0.0219, 'lps'),
	(589077, 130, '2014-03-15 00:06:16.000000', 'consum', 0.0220, 'lps'),
	(589078, 130, '2014-03-15 00:06:17.000000', 'consum', 0.0215, 'lps'),
	(589079, 130, '2014-03-15 00:06:18.000000', 'consum', 0.0222, 'lps'),
	(589080, 130, '2014-03-15 00:06:19.000000', 'consum', 0.0210, 'lps'),
	(589081, 130, '2014-03-15 00:06:20.000000', 'consum', 0.0220, 'lps'),
	(589082, 130, '2014-03-15 00:06:21.000000', 'consum', 0.0217, 'lps'),
	(589083, 130, '2014-03-15 00:06:22.000000', 'consum', 0.0216, 'lps'),
	(589084, 130, '2014-03-15 00:06:23.000000', 'consum', 0.0219, 'lps'),
	(589085, 130, '2014-03-15 00:06:24.000000', 'consum', 0.0223, 'lps'),
	(589086, 130, '2014-03-15 00:06:25.000000', 'consum', 0.0219, 'lps'),
	(589087, 130, '2014-03-15 00:06:26.000000', 'consum', 0.0217, 'lps'),
	(589088, 130, '2014-03-15 00:06:27.000000', 'consum', 0.0218, 'lps'),
	(589089, 130, '2014-03-15 00:06:28.000000', 'consum', 0.0214, 'lps'),
	(589090, 130, '2014-03-15 00:06:29.000000', 'consum', 0.0222, 'lps'),
	(589091, 130, '2014-03-15 00:06:30.000000', 'consum', 0.0213, 'lps'),
	(589092, 130, '2014-03-15 00:06:31.000000', 'consum', 0.0222, 'lps'),
	(589093, 130, '2014-03-15 00:06:32.000000', 'consum', 0.0213, 'lps'),
	(589094, 130, '2014-03-15 00:06:33.000000', 'consum', 0.0222, 'lps'),
	(589095, 130, '2014-03-15 00:06:34.000000', 'consum', 0.0215, 'lps'),
	(589096, 130, '2014-03-15 00:06:35.000000', 'consum', 0.0215, 'lps'),
	(589097, 130, '2014-03-15 00:06:36.000000', 'consum', 0.0222, 'lps'),
	(589098, 130, '2014-03-15 00:06:37.000000', 'consum', 0.0222, 'lps'),
	(589099, 130, '2014-03-15 00:06:38.000000', 'consum', 0.0223, 'lps'),
	(589100, 130, '2014-03-15 00:06:39.000000', 'consum', 0.0222, 'lps'),
	(589101, 130, '2014-03-15 00:06:40.000000', 'consum', 0.0218, 'lps'),
	(589102, 130, '2014-03-15 00:06:41.000000', 'consum', 0.0212, 'lps'),
	(589103, 130, '2014-03-15 00:06:42.000000', 'consum', 0.0213, 'lps'),
	(589104, 130, '2014-03-15 00:06:43.000000', 'consum', 0.0218, 'lps'),
	(589105, 130, '2014-03-15 00:06:44.000000', 'consum', 0.0213, 'lps'),
	(589106, 130, '2014-03-15 00:06:45.000000', 'consum', 0.0214, 'lps'),
	(589107, 130, '2014-03-15 00:06:46.000000', 'consum', 0.0210, 'lps'),
	(589108, 130, '2014-03-15 00:06:47.000000', 'consum', 0.0210, 'lps'),
	(589109, 130, '2014-03-15 00:06:48.000000', 'consum', 0.0214, 'lps'),
	(589110, 130, '2014-03-15 00:06:49.000000', 'consum', 0.0214, 'lps'),
	(589111, 130, '2014-03-15 00:06:50.000000', 'consum', 0.0219, 'lps'),
	(589112, 130, '2014-03-15 00:06:51.000000', 'consum', 0.0213, 'lps'),
	(589113, 130, '2014-03-15 00:06:52.000000', 'consum', 0.0212, 'lps'),
	(589114, 130, '2014-03-15 00:06:53.000000', 'consum', 0.0215, 'lps'),
	(589115, 130, '2014-03-15 00:06:54.000000', 'consum', 0.0211, 'lps'),
	(589116, 130, '2014-03-15 00:06:55.000000', 'consum', 0.0217, 'lps'),
	(589117, 130, '2014-03-15 00:06:56.000000', 'consum', 0.0211, 'lps'),
	(589118, 130, '2014-03-15 00:06:57.000000', 'consum', 0.0211, 'lps'),
	(589119, 130, '2014-03-15 00:06:58.000000', 'consum', 0.0213, 'lps'),
	(589120, 130, '2014-03-15 00:06:59.000000', 'consum', 0.0220, 'lps'),
	(589121, 130, '2014-03-15 00:07:00.000000', 'consum', 0.0210, 'lps'),
	(589122, 130, '2014-03-15 00:07:01.000000', 'consum', 0.0223, 'lps'),
	(589123, 130, '2014-03-15 00:07:02.000000', 'consum', 0.0218, 'lps'),
	(589124, 130, '2014-03-15 00:07:03.000000', 'consum', 0.0211, 'lps'),
	(589125, 130, '2014-03-15 00:07:04.000000', 'consum', 0.0222, 'lps'),
	(589126, 130, '2014-03-15 00:07:05.000000', 'consum', 0.0221, 'lps'),
	(589127, 130, '2014-03-15 00:07:06.000000', 'consum', 0.0217, 'lps'),
	(589128, 130, '2014-03-15 00:07:07.000000', 'consum', 0.0224, 'lps'),
	(589129, 130, '2014-03-15 00:07:08.000000', 'consum', 0.0216, 'lps'),
	(589130, 130, '2014-03-15 00:07:09.000000', 'consum', 0.0215, 'lps'),
	(589131, 130, '2014-03-15 00:07:10.000000', 'consum', 0.0217, 'lps'),
	(589132, 130, '2014-03-15 00:07:11.000000', 'consum', 0.0215, 'lps'),
	(589133, 130, '2014-03-15 00:07:12.000000', 'consum', 0.0215, 'lps'),
	(589134, 130, '2014-03-15 00:07:13.000000', 'consum', 0.0220, 'lps'),
	(589135, 130, '2014-03-15 00:07:14.000000', 'consum', 0.0216, 'lps'),
	(589136, 130, '2014-03-15 00:07:15.000000', 'consum', 0.0210, 'lps'),
	(589137, 130, '2014-03-15 00:07:16.000000', 'consum', 0.0223, 'lps'),
	(589138, 130, '2014-03-15 00:07:17.000000', 'consum', 0.0217, 'lps'),
	(589139, 130, '2014-03-15 00:07:18.000000', 'consum', 0.0221, 'lps'),
	(589140, 130, '2014-03-15 00:07:19.000000', 'consum', 0.0216, 'lps'),
	(589141, 130, '2014-03-15 00:07:20.000000', 'consum', 0.0220, 'lps'),
	(589142, 130, '2014-03-15 00:07:21.000000', 'consum', 0.0215, 'lps'),
	(589143, 130, '2014-03-15 00:07:22.000000', 'consum', 0.0220, 'lps'),
	(589144, 130, '2014-03-15 00:07:23.000000', 'consum', 0.0217, 'lps'),
	(589145, 130, '2014-03-15 00:07:24.000000', 'consum', 0.0213, 'lps'),
	(589146, 130, '2014-03-15 00:07:25.000000', 'consum', 0.0221, 'lps'),
	(589147, 130, '2014-03-15 00:07:26.000000', 'consum', 0.0210, 'lps'),
	(589148, 130, '2014-03-15 00:07:27.000000', 'consum', 0.0210, 'lps'),
	(589149, 130, '2014-03-15 00:07:28.000000', 'consum', 0.0210, 'lps'),
	(589150, 130, '2014-03-15 00:07:29.000000', 'consum', 0.0224, 'lps'),
	(589151, 130, '2014-03-15 00:07:30.000000', 'consum', 0.0221, 'lps'),
	(589152, 130, '2014-03-15 00:07:31.000000', 'consum', 0.0210, 'lps'),
	(589153, 130, '2014-03-15 00:07:32.000000', 'consum', 0.0222, 'lps'),
	(589154, 130, '2014-03-15 00:07:33.000000', 'consum', 0.0223, 'lps'),
	(589155, 130, '2014-03-15 00:07:34.000000', 'consum', 0.0212, 'lps'),
	(589156, 130, '2014-03-15 00:07:35.000000', 'consum', 0.0213, 'lps'),
	(589157, 130, '2014-03-15 00:07:36.000000', 'consum', 0.0218, 'lps'),
	(589158, 130, '2014-03-15 00:07:37.000000', 'consum', 0.0210, 'lps'),
	(589159, 130, '2014-03-15 00:07:38.000000', 'consum', 0.0216, 'lps'),
	(589160, 130, '2014-03-15 00:07:39.000000', 'consum', 0.0213, 'lps'),
	(589161, 130, '2014-03-15 00:07:40.000000', 'consum', 0.0219, 'lps'),
	(589162, 130, '2014-03-15 00:07:41.000000', 'consum', 0.0220, 'lps'),
	(589163, 130, '2014-03-15 00:07:42.000000', 'consum', 0.0218, 'lps'),
	(589164, 130, '2014-03-15 00:07:43.000000', 'consum', 0.0220, 'lps'),
	(589165, 130, '2014-03-15 00:07:44.000000', 'consum', 0.0220, 'lps'),
	(589166, 130, '2014-03-15 00:07:45.000000', 'consum', 0.0215, 'lps'),
	(589167, 130, '2014-03-15 00:07:46.000000', 'consum', 0.0221, 'lps'),
	(589168, 130, '2014-03-15 00:07:47.000000', 'consum', 0.0220, 'lps'),
	(589169, 130, '2014-03-15 00:07:48.000000', 'consum', 0.0213, 'lps'),
	(589170, 130, '2014-03-15 00:07:49.000000', 'consum', 0.0210, 'lps'),
	(589171, 130, '2014-03-15 00:07:50.000000', 'consum', 0.0217, 'lps'),
	(589172, 130, '2014-03-15 00:07:51.000000', 'consum', 0.0215, 'lps'),
	(589173, 130, '2014-03-15 00:07:52.000000', 'consum', 0.0213, 'lps'),
	(589174, 130, '2014-03-15 00:07:53.000000', 'consum', 0.0212, 'lps'),
	(589175, 130, '2014-03-15 00:07:54.000000', 'consum', 0.0211, 'lps'),
	(589176, 130, '2014-03-15 00:07:55.000000', 'consum', 0.0224, 'lps'),
	(589177, 130, '2014-03-15 00:07:56.000000', 'consum', 0.0216, 'lps'),
	(589178, 130, '2014-03-15 00:07:57.000000', 'consum', 0.0217, 'lps'),
	(589179, 130, '2014-03-15 00:07:58.000000', 'consum', 0.0210, 'lps'),
	(589180, 130, '2014-03-15 00:07:59.000000', 'consum', 0.0219, 'lps'),
	(589181, 130, '2014-03-15 00:08:00.000000', 'consum', 0.0212, 'lps'),
	(589182, 130, '2014-03-15 00:08:01.000000', 'consum', 0.0223, 'lps'),
	(589183, 130, '2014-03-15 00:08:02.000000', 'consum', 0.0222, 'lps'),
	(589184, 130, '2014-03-15 00:08:03.000000', 'consum', 0.0220, 'lps'),
	(589185, 130, '2014-03-15 00:08:04.000000', 'consum', 0.0210, 'lps'),
	(589186, 130, '2014-03-15 00:08:05.000000', 'consum', 0.0223, 'lps'),
	(589187, 130, '2014-03-15 00:08:06.000000', 'consum', 0.0218, 'lps'),
	(589188, 130, '2014-03-15 00:08:07.000000', 'consum', 0.0211, 'lps'),
	(589189, 130, '2014-03-15 00:08:08.000000', 'consum', 0.0222, 'lps'),
	(589190, 130, '2014-03-15 00:08:09.000000', 'consum', 0.0223, 'lps'),
	(589191, 130, '2014-03-15 00:08:10.000000', 'consum', 0.0222, 'lps'),
	(589192, 130, '2014-03-15 00:08:11.000000', 'consum', 0.0219, 'lps'),
	(589193, 130, '2014-03-15 00:08:12.000000', 'consum', 0.0219, 'lps'),
	(589194, 130, '2014-03-15 00:08:13.000000', 'consum', 0.0213, 'lps'),
	(589195, 130, '2014-03-15 00:08:14.000000', 'consum', 0.0215, 'lps'),
	(589196, 130, '2014-03-15 00:08:15.000000', 'consum', 0.0210, 'lps'),
	(589197, 130, '2014-03-15 00:08:16.000000', 'consum', 0.0212, 'lps'),
	(589198, 130, '2014-03-15 00:08:17.000000', 'consum', 0.0221, 'lps'),
	(589199, 130, '2014-03-15 00:08:18.000000', 'consum', 0.0215, 'lps'),
	(589200, 130, '2014-03-15 00:08:19.000000', 'consum', 0.0215, 'lps'),
	(589201, 130, '2014-03-15 00:08:20.000000', 'consum', 0.0221, 'lps'),
	(589202, 130, '2014-03-15 00:08:21.000000', 'consum', 0.0220, 'lps'),
	(589203, 130, '2014-03-15 00:08:22.000000', 'consum', 0.0213, 'lps'),
	(589204, 130, '2014-03-15 00:08:23.000000', 'consum', 0.0223, 'lps'),
	(589205, 130, '2014-03-15 00:08:24.000000', 'consum', 0.0210, 'lps'),
	(589206, 130, '2014-03-15 00:08:25.000000', 'consum', 0.0216, 'lps'),
	(589207, 130, '2014-03-15 00:08:26.000000', 'consum', 0.0212, 'lps'),
	(589208, 130, '2014-03-15 00:08:27.000000', 'consum', 0.0216, 'lps'),
	(589209, 130, '2014-03-15 00:08:28.000000', 'consum', 0.0221, 'lps'),
	(589210, 130, '2014-03-15 00:08:29.000000', 'consum', 0.0216, 'lps'),
	(589211, 130, '2014-03-15 00:08:30.000000', 'consum', 0.0221, 'lps'),
	(589212, 130, '2014-03-15 00:08:31.000000', 'consum', 0.0218, 'lps'),
	(589213, 130, '2014-03-15 00:08:32.000000', 'consum', 0.0220, 'lps'),
	(589214, 130, '2014-03-15 00:08:33.000000', 'consum', 0.0219, 'lps'),
	(589215, 130, '2014-03-15 00:08:34.000000', 'consum', 0.0210, 'lps'),
	(589216, 130, '2014-03-15 00:08:35.000000', 'consum', 0.0213, 'lps'),
	(589217, 130, '2014-03-15 00:08:36.000000', 'consum', 0.0211, 'lps'),
	(589218, 130, '2014-03-15 00:08:37.000000', 'consum', 0.0224, 'lps'),
	(589219, 130, '2014-03-15 00:08:38.000000', 'consum', 0.0215, 'lps'),
	(589220, 130, '2014-03-15 00:08:39.000000', 'consum', 0.0224, 'lps'),
	(589221, 130, '2014-03-15 00:08:40.000000', 'consum', 0.0222, 'lps'),
	(589222, 130, '2014-03-15 00:08:41.000000', 'consum', 0.0214, 'lps'),
	(589223, 130, '2014-03-15 00:08:42.000000', 'consum', 0.0210, 'lps'),
	(589224, 130, '2014-03-15 00:08:43.000000', 'consum', 0.0210, 'lps'),
	(589225, 130, '2014-03-15 00:08:44.000000', 'consum', 0.0214, 'lps'),
	(589226, 130, '2014-03-15 00:08:45.000000', 'consum', 0.0213, 'lps'),
	(589227, 130, '2014-03-15 00:08:46.000000', 'consum', 0.0213, 'lps'),
	(589228, 130, '2014-03-15 00:08:47.000000', 'consum', 0.0216, 'lps'),
	(589229, 130, '2014-03-15 00:08:48.000000', 'consum', 0.0217, 'lps'),
	(589230, 130, '2014-03-15 00:08:49.000000', 'consum', 0.0213, 'lps'),
	(589231, 130, '2014-03-15 00:08:50.000000', 'consum', 0.0219, 'lps'),
	(589232, 130, '2014-03-15 00:08:51.000000', 'consum', 0.0218, 'lps'),
	(589233, 130, '2014-03-15 00:08:52.000000', 'consum', 0.0224, 'lps'),
	(589234, 130, '2014-03-15 00:08:53.000000', 'consum', 0.0224, 'lps'),
	(589235, 130, '2014-03-15 00:08:54.000000', 'consum', 0.0212, 'lps'),
	(589236, 130, '2014-03-15 00:08:55.000000', 'consum', 0.0220, 'lps'),
	(589237, 130, '2014-03-15 00:08:56.000000', 'consum', 0.0211, 'lps'),
	(589238, 130, '2014-03-15 00:08:57.000000', 'consum', 0.0217, 'lps'),
	(589239, 130, '2014-03-15 00:08:58.000000', 'consum', 0.0210, 'lps'),
	(589240, 130, '2014-03-15 00:08:59.000000', 'consum', 0.0220, 'lps'),
	(589241, 130, '2014-03-15 00:09:00.000000', 'consum', 0.0215, 'lps'),
	(589242, 130, '2014-03-15 00:09:01.000000', 'consum', 0.0221, 'lps'),
	(589243, 130, '2014-03-15 00:09:02.000000', 'consum', 0.0219, 'lps'),
	(589244, 130, '2014-03-15 00:09:03.000000', 'consum', 0.0210, 'lps'),
	(589245, 130, '2014-03-15 00:09:04.000000', 'consum', 0.0211, 'lps'),
	(589246, 130, '2014-03-15 00:09:05.000000', 'consum', 0.0219, 'lps'),
	(589247, 130, '2014-03-15 00:09:06.000000', 'consum', 0.0219, 'lps'),
	(589248, 130, '2014-03-15 00:09:07.000000', 'consum', 0.0214, 'lps'),
	(589249, 130, '2014-03-15 00:09:08.000000', 'consum', 0.0221, 'lps'),
	(589250, 130, '2014-03-15 00:09:09.000000', 'consum', 0.0221, 'lps'),
	(589251, 130, '2014-03-15 00:09:10.000000', 'consum', 0.0217, 'lps'),
	(589252, 130, '2014-03-15 00:09:11.000000', 'consum', 0.0212, 'lps'),
	(589253, 130, '2014-03-15 00:09:12.000000', 'consum', 0.0214, 'lps'),
	(589254, 130, '2014-03-15 00:09:13.000000', 'consum', 0.0212, 'lps'),
	(589255, 130, '2014-03-15 00:09:14.000000', 'consum', 0.0222, 'lps'),
	(589256, 130, '2014-03-15 00:09:15.000000', 'consum', 0.0222, 'lps'),
	(589257, 130, '2014-03-15 00:09:16.000000', 'consum', 0.0216, 'lps'),
	(589258, 130, '2014-03-15 00:09:17.000000', 'consum', 0.0222, 'lps'),
	(589259, 130, '2014-03-15 00:09:18.000000', 'consum', 0.0223, 'lps'),
	(589260, 130, '2014-03-15 00:09:19.000000', 'consum', 0.0210, 'lps'),
	(589261, 130, '2014-03-15 00:09:20.000000', 'consum', 0.0216, 'lps'),
	(589262, 130, '2014-03-15 00:09:21.000000', 'consum', 0.0223, 'lps'),
	(589263, 130, '2014-03-15 00:09:22.000000', 'consum', 0.0216, 'lps'),
	(589264, 130, '2014-03-15 00:09:23.000000', 'consum', 0.0215, 'lps'),
	(589265, 130, '2014-03-15 00:09:24.000000', 'consum', 0.0218, 'lps'),
	(589266, 130, '2014-03-15 00:09:25.000000', 'consum', 0.0219, 'lps'),
	(589267, 130, '2014-03-15 00:09:26.000000', 'consum', 0.0219, 'lps'),
	(589268, 130, '2014-03-15 00:09:27.000000', 'consum', 0.0210, 'lps'),
	(589269, 130, '2014-03-15 00:09:28.000000', 'consum', 0.0216, 'lps'),
	(589270, 130, '2014-03-15 00:09:29.000000', 'consum', 0.0210, 'lps'),
	(589271, 130, '2014-03-15 00:09:30.000000', 'consum', 0.0224, 'lps'),
	(589272, 130, '2014-03-15 00:09:31.000000', 'consum', 0.0219, 'lps'),
	(589273, 130, '2014-03-15 00:09:32.000000', 'consum', 0.0215, 'lps'),
	(589274, 130, '2014-03-15 00:09:33.000000', 'consum', 0.0224, 'lps'),
	(589275, 130, '2014-03-15 00:09:34.000000', 'consum', 0.0219, 'lps'),
	(589276, 130, '2014-03-15 00:09:35.000000', 'consum', 0.0216, 'lps'),
	(589277, 130, '2014-03-15 00:09:36.000000', 'consum', 0.0211, 'lps'),
	(589278, 130, '2014-03-15 00:09:37.000000', 'consum', 0.0211, 'lps'),
	(589279, 130, '2014-03-15 00:09:38.000000', 'consum', 0.0214, 'lps'),
	(589280, 130, '2014-03-15 00:09:39.000000', 'consum', 0.0214, 'lps'),
	(589281, 130, '2014-03-15 00:09:40.000000', 'consum', 0.0218, 'lps'),
	(589282, 130, '2014-03-15 00:09:41.000000', 'consum', 0.0222, 'lps'),
	(589283, 130, '2014-03-15 00:09:42.000000', 'consum', 0.0218, 'lps'),
	(589284, 130, '2014-03-15 00:09:43.000000', 'consum', 0.0212, 'lps'),
	(589285, 130, '2014-03-15 00:09:44.000000', 'consum', 0.0213, 'lps'),
	(589286, 130, '2014-03-15 00:09:45.000000', 'consum', 0.0221, 'lps'),
	(589287, 130, '2014-03-15 00:09:46.000000', 'consum', 0.0224, 'lps'),
	(589288, 130, '2014-03-15 00:09:47.000000', 'consum', 0.0220, 'lps'),
	(589289, 130, '2014-03-15 00:09:48.000000', 'consum', 0.0216, 'lps'),
	(589290, 130, '2014-03-15 00:09:49.000000', 'consum', 0.0210, 'lps'),
	(589291, 130, '2014-03-15 00:09:50.000000', 'consum', 0.0210, 'lps'),
	(589292, 130, '2014-03-15 00:09:51.000000', 'consum', 0.0223, 'lps'),
	(589293, 130, '2014-03-15 00:09:52.000000', 'consum', 0.0216, 'lps'),
	(589294, 130, '2014-03-15 00:09:53.000000', 'consum', 0.0216, 'lps'),
	(589295, 130, '2014-03-15 00:09:54.000000', 'consum', 0.0223, 'lps'),
	(589296, 130, '2014-03-15 00:09:55.000000', 'consum', 0.0214, 'lps'),
	(589297, 130, '2014-03-15 00:09:56.000000', 'consum', 0.0220, 'lps'),
	(589298, 130, '2014-03-15 00:09:57.000000', 'consum', 0.0218, 'lps'),
	(589299, 130, '2014-03-15 00:09:58.000000', 'consum', 0.0221, 'lps'),
	(589300, 130, '2014-03-15 00:09:59.000000', 'consum', 0.0212, 'lps'),
	(589301, 130, '2014-03-15 00:10:00.000000', 'consum', 0.0215, 'lps'),
	(589302, 130, '2014-03-15 00:10:01.000000', 'consum', 0.0217, 'lps'),
	(589303, 130, '2014-03-15 00:10:02.000000', 'consum', 0.0213, 'lps'),
	(589304, 130, '2014-03-15 00:10:03.000000', 'consum', 0.0223, 'lps'),
	(589305, 130, '2014-03-15 00:10:04.000000', 'consum', 0.0218, 'lps'),
	(589306, 130, '2014-03-15 00:10:05.000000', 'consum', 0.0214, 'lps'),
	(589307, 130, '2014-03-15 00:10:06.000000', 'consum', 0.0219, 'lps'),
	(589308, 130, '2014-03-15 00:10:07.000000', 'consum', 0.0216, 'lps'),
	(589309, 130, '2014-03-15 00:10:08.000000', 'consum', 0.0212, 'lps'),
	(589310, 130, '2014-03-15 00:10:09.000000', 'consum', 0.0217, 'lps'),
	(589311, 130, '2014-03-15 00:10:10.000000', 'consum', 0.0210, 'lps'),
	(589312, 130, '2014-03-15 00:10:11.000000', 'consum', 0.0221, 'lps'),
	(589313, 130, '2014-03-15 00:10:12.000000', 'consum', 0.0220, 'lps'),
	(589314, 130, '2014-03-15 00:10:13.000000', 'consum', 0.0213, 'lps'),
	(589315, 130, '2014-03-15 00:10:14.000000', 'consum', 0.0224, 'lps'),
	(589316, 130, '2014-03-15 00:10:15.000000', 'consum', 0.0211, 'lps'),
	(589317, 130, '2014-03-15 00:10:16.000000', 'consum', 0.0221, 'lps'),
	(589318, 130, '2014-03-15 00:10:17.000000', 'consum', 0.0218, 'lps'),
	(589319, 130, '2014-03-15 00:10:18.000000', 'consum', 0.0214, 'lps'),
	(589320, 130, '2014-03-15 00:10:19.000000', 'consum', 0.0224, 'lps'),
	(589321, 130, '2014-03-15 00:10:20.000000', 'consum', 0.0210, 'lps'),
	(589322, 130, '2014-03-15 00:10:21.000000', 'consum', 0.0211, 'lps'),
	(589323, 130, '2014-03-15 00:10:22.000000', 'consum', 0.0215, 'lps'),
	(589324, 130, '2014-03-15 00:10:23.000000', 'consum', 0.0219, 'lps'),
	(589325, 130, '2014-03-15 00:10:24.000000', 'consum', 0.0210, 'lps'),
	(589326, 130, '2014-03-15 00:10:25.000000', 'consum', 0.0215, 'lps'),
	(589327, 130, '2014-03-15 00:10:26.000000', 'consum', 0.0221, 'lps'),
	(589328, 130, '2014-03-15 00:10:27.000000', 'consum', 0.0218, 'lps'),
	(589329, 130, '2014-03-15 00:10:28.000000', 'consum', 0.0217, 'lps'),
	(589330, 130, '2014-03-15 00:10:29.000000', 'consum', 0.0224, 'lps'),
	(589331, 130, '2014-03-15 00:10:30.000000', 'consum', 0.0215, 'lps'),
	(589332, 130, '2014-03-15 00:10:31.000000', 'consum', 0.0223, 'lps'),
	(589333, 130, '2014-03-15 00:10:32.000000', 'consum', 0.0215, 'lps'),
	(589334, 130, '2014-03-15 00:10:33.000000', 'consum', 0.0213, 'lps'),
	(589335, 130, '2014-03-15 00:10:34.000000', 'consum', 0.0223, 'lps'),
	(589336, 130, '2014-03-15 00:10:35.000000', 'consum', 0.0222, 'lps'),
	(589337, 130, '2014-03-15 00:10:36.000000', 'consum', 0.0216, 'lps'),
	(589338, 130, '2014-03-15 00:10:37.000000', 'consum', 0.0220, 'lps'),
	(589339, 130, '2014-03-15 00:10:38.000000', 'consum', 0.0211, 'lps'),
	(589340, 130, '2014-03-15 00:10:39.000000', 'consum', 0.0218, 'lps'),
	(589341, 130, '2014-03-15 00:10:40.000000', 'consum', 0.0216, 'lps'),
	(589342, 130, '2014-03-15 00:10:41.000000', 'consum', 0.0218, 'lps'),
	(589343, 130, '2014-03-15 00:10:42.000000', 'consum', 0.0219, 'lps'),
	(589344, 130, '2014-03-15 00:10:43.000000', 'consum', 0.0214, 'lps'),
	(589345, 130, '2014-03-15 00:10:44.000000', 'consum', 0.0220, 'lps'),
	(589346, 130, '2014-03-15 00:10:45.000000', 'consum', 0.0218, 'lps'),
	(589347, 130, '2014-03-15 00:10:46.000000', 'consum', 0.0222, 'lps'),
	(589348, 130, '2014-03-15 00:10:47.000000', 'consum', 0.0217, 'lps'),
	(589349, 130, '2014-03-15 00:10:48.000000', 'consum', 0.0210, 'lps'),
	(589350, 130, '2014-03-15 00:10:49.000000', 'consum', 0.0216, 'lps'),
	(589351, 130, '2014-03-15 00:10:50.000000', 'consum', 0.0214, 'lps'),
	(589352, 130, '2014-03-15 00:10:51.000000', 'consum', 0.0212, 'lps'),
	(589353, 130, '2014-03-15 00:10:52.000000', 'consum', 0.0210, 'lps'),
	(589354, 130, '2014-03-15 00:10:53.000000', 'consum', 0.0217, 'lps'),
	(589355, 130, '2014-03-15 00:10:54.000000', 'consum', 0.0216, 'lps'),
	(589356, 130, '2014-03-15 00:10:55.000000', 'consum', 0.0219, 'lps'),
	(589357, 130, '2014-03-15 00:10:56.000000', 'consum', 0.0224, 'lps'),
	(589358, 130, '2014-03-15 00:10:57.000000', 'consum', 0.0222, 'lps'),
	(589359, 130, '2014-03-15 00:10:58.000000', 'consum', 0.0216, 'lps'),
	(589360, 130, '2014-03-15 00:10:59.000000', 'consum', 0.0217, 'lps'),
	(589361, 130, '2014-03-15 00:11:00.000000', 'consum', 0.0214, 'lps'),
	(589362, 130, '2014-03-15 00:11:01.000000', 'consum', 0.0223, 'lps'),
	(589363, 130, '2014-03-15 00:11:02.000000', 'consum', 0.0219, 'lps'),
	(589364, 130, '2014-03-15 00:11:03.000000', 'consum', 0.0218, 'lps'),
	(589365, 130, '2014-03-15 00:11:04.000000', 'consum', 0.0223, 'lps'),
	(589366, 130, '2014-03-15 00:11:05.000000', 'consum', 0.0219, 'lps'),
	(589367, 130, '2014-03-15 00:11:06.000000', 'consum', 0.0220, 'lps'),
	(589368, 130, '2014-03-15 00:11:07.000000', 'consum', 0.0216, 'lps'),
	(589369, 130, '2014-03-15 00:11:08.000000', 'consum', 0.0213, 'lps'),
	(589370, 130, '2014-03-15 00:11:09.000000', 'consum', 0.0221, 'lps'),
	(589371, 130, '2014-03-15 00:11:10.000000', 'consum', 0.0213, 'lps'),
	(589372, 130, '2014-03-15 00:11:11.000000', 'consum', 0.0221, 'lps'),
	(589373, 130, '2014-03-15 00:11:12.000000', 'consum', 0.0211, 'lps'),
	(589374, 130, '2014-03-15 00:11:13.000000', 'consum', 0.0215, 'lps'),
	(589375, 130, '2014-03-15 00:11:14.000000', 'consum', 0.0214, 'lps'),
	(589376, 130, '2014-03-15 00:11:15.000000', 'consum', 0.0217, 'lps'),
	(589377, 130, '2014-03-15 00:11:16.000000', 'consum', 0.0220, 'lps'),
	(589378, 130, '2014-03-15 00:11:17.000000', 'consum', 0.0224, 'lps'),
	(589379, 130, '2014-03-15 00:11:18.000000', 'consum', 0.0219, 'lps'),
	(589380, 130, '2014-03-15 00:11:19.000000', 'consum', 0.0213, 'lps'),
	(589381, 130, '2014-03-15 00:11:20.000000', 'consum', 0.0212, 'lps'),
	(589382, 130, '2014-03-15 00:11:21.000000', 'consum', 0.0215, 'lps'),
	(589383, 130, '2014-03-15 00:11:22.000000', 'consum', 0.0213, 'lps'),
	(589384, 130, '2014-03-15 00:11:23.000000', 'consum', 0.0213, 'lps'),
	(589385, 130, '2014-03-15 00:11:24.000000', 'consum', 0.0214, 'lps'),
	(589386, 130, '2014-03-15 00:11:25.000000', 'consum', 0.0221, 'lps'),
	(589387, 130, '2014-03-15 00:11:26.000000', 'consum', 0.0210, 'lps'),
	(589388, 130, '2014-03-15 00:11:27.000000', 'consum', 0.0222, 'lps'),
	(589389, 130, '2014-03-15 00:11:28.000000', 'consum', 0.0211, 'lps'),
	(589390, 130, '2014-03-15 00:11:29.000000', 'consum', 0.0223, 'lps'),
	(589391, 130, '2014-03-15 00:11:30.000000', 'consum', 0.0214, 'lps'),
	(589392, 130, '2014-03-15 00:11:31.000000', 'consum', 0.0222, 'lps'),
	(589393, 130, '2014-03-15 00:11:32.000000', 'consum', 0.0211, 'lps'),
	(589394, 130, '2014-03-15 00:11:33.000000', 'consum', 0.0211, 'lps'),
	(589395, 130, '2014-03-15 00:11:34.000000', 'consum', 0.0211, 'lps'),
	(589396, 130, '2014-03-15 00:11:35.000000', 'consum', 0.0213, 'lps'),
	(589397, 130, '2014-03-15 00:11:36.000000', 'consum', 0.0222, 'lps'),
	(589398, 130, '2014-03-15 00:11:37.000000', 'consum', 0.0218, 'lps'),
	(589399, 130, '2014-03-15 00:11:38.000000', 'consum', 0.0215, 'lps'),
	(589400, 130, '2014-03-15 00:11:39.000000', 'consum', 0.0211, 'lps'),
	(589401, 130, '2014-03-15 00:11:40.000000', 'consum', 0.0216, 'lps'),
	(589402, 130, '2014-03-15 00:11:41.000000', 'consum', 0.0222, 'lps'),
	(589403, 130, '2014-03-15 00:11:42.000000', 'consum', 0.0222, 'lps'),
	(589404, 130, '2014-03-15 00:11:43.000000', 'consum', 0.0221, 'lps'),
	(589405, 130, '2014-03-15 00:11:44.000000', 'consum', 0.0213, 'lps'),
	(589406, 130, '2014-03-15 00:11:45.000000', 'consum', 0.0222, 'lps'),
	(589407, 130, '2014-03-15 00:11:46.000000', 'consum', 0.0218, 'lps'),
	(589408, 130, '2014-03-15 00:11:47.000000', 'consum', 0.0212, 'lps'),
	(589409, 130, '2014-03-15 00:11:48.000000', 'consum', 0.0214, 'lps'),
	(589410, 130, '2014-03-15 00:11:49.000000', 'consum', 0.0210, 'lps'),
	(589411, 130, '2014-03-15 00:11:50.000000', 'consum', 0.0211, 'lps'),
	(589412, 130, '2014-03-15 00:11:51.000000', 'consum', 0.0218, 'lps'),
	(589413, 130, '2014-03-15 00:11:52.000000', 'consum', 0.0218, 'lps'),
	(589414, 130, '2014-03-15 00:11:53.000000', 'consum', 0.0210, 'lps'),
	(589415, 130, '2014-03-15 00:11:54.000000', 'consum', 0.0218, 'lps'),
	(589416, 130, '2014-03-15 00:11:55.000000', 'consum', 0.0218, 'lps'),
	(589417, 130, '2014-03-15 00:11:56.000000', 'consum', 0.0212, 'lps'),
	(589418, 130, '2014-03-15 00:11:57.000000', 'consum', 0.0212, 'lps'),
	(589419, 130, '2014-03-15 00:11:58.000000', 'consum', 0.0217, 'lps'),
	(589420, 130, '2014-03-15 00:11:59.000000', 'consum', 0.0221, 'lps'),
	(589421, 130, '2014-03-15 00:12:00.000000', 'consum', 0.0215, 'lps'),
	(589422, 130, '2014-03-15 00:12:01.000000', 'consum', 0.0220, 'lps'),
	(589423, 130, '2014-03-15 00:12:02.000000', 'consum', 0.0213, 'lps'),
	(589424, 130, '2014-03-15 00:12:03.000000', 'consum', 0.0212, 'lps'),
	(589425, 130, '2014-03-15 00:12:04.000000', 'consum', 0.0210, 'lps'),
	(589426, 130, '2014-03-15 00:12:05.000000', 'consum', 0.0222, 'lps'),
	(589427, 130, '2014-03-15 00:12:06.000000', 'consum', 0.0224, 'lps'),
	(589428, 130, '2014-03-15 00:12:07.000000', 'consum', 0.0213, 'lps'),
	(589429, 130, '2014-03-15 00:12:08.000000', 'consum', 0.0215, 'lps'),
	(589430, 130, '2014-03-15 00:12:09.000000', 'consum', 0.0212, 'lps'),
	(589431, 130, '2014-03-15 00:12:10.000000', 'consum', 0.0218, 'lps'),
	(589432, 130, '2014-03-15 00:12:11.000000', 'consum', 0.0216, 'lps'),
	(589433, 130, '2014-03-15 00:12:12.000000', 'consum', 0.0217, 'lps'),
	(589434, 130, '2014-03-15 00:12:13.000000', 'consum', 0.0213, 'lps'),
	(589435, 130, '2014-03-15 00:12:14.000000', 'consum', 0.0217, 'lps'),
	(589436, 130, '2014-03-15 00:12:15.000000', 'consum', 0.0223, 'lps'),
	(589437, 130, '2014-03-15 00:12:16.000000', 'consum', 0.0224, 'lps'),
	(589438, 130, '2014-03-15 00:12:17.000000', 'consum', 0.0211, 'lps'),
	(589439, 130, '2014-03-15 00:12:18.000000', 'consum', 0.0218, 'lps'),
	(589440, 130, '2014-03-15 00:12:19.000000', 'consum', 0.0218, 'lps'),
	(589441, 130, '2014-03-15 00:12:20.000000', 'consum', 0.0212, 'lps'),
	(589442, 130, '2014-03-15 00:12:21.000000', 'consum', 0.0212, 'lps'),
	(589443, 130, '2014-03-15 00:12:22.000000', 'consum', 0.0213, 'lps'),
	(589444, 130, '2014-03-15 00:12:23.000000', 'consum', 0.0222, 'lps'),
	(589445, 130, '2014-03-15 00:12:24.000000', 'consum', 0.0215, 'lps'),
	(589446, 130, '2014-03-15 00:12:25.000000', 'consum', 0.0214, 'lps'),
	(589447, 130, '2014-03-15 00:12:26.000000', 'consum', 0.0217, 'lps'),
	(589448, 130, '2014-03-15 00:12:27.000000', 'consum', 0.0220, 'lps'),
	(589449, 130, '2014-03-15 00:12:28.000000', 'consum', 0.0222, 'lps'),
	(589450, 130, '2014-03-15 00:12:29.000000', 'consum', 0.0210, 'lps'),
	(589451, 130, '2014-03-15 00:12:30.000000', 'consum', 0.0221, 'lps'),
	(589452, 130, '2014-03-15 00:12:31.000000', 'consum', 0.0222, 'lps'),
	(589453, 130, '2014-03-15 00:12:32.000000', 'consum', 0.0221, 'lps'),
	(589454, 130, '2014-03-15 00:12:33.000000', 'consum', 0.0213, 'lps'),
	(589455, 130, '2014-03-15 00:12:34.000000', 'consum', 0.0223, 'lps'),
	(589456, 130, '2014-03-15 00:12:35.000000', 'consum', 0.0223, 'lps'),
	(589457, 130, '2014-03-15 00:12:36.000000', 'consum', 0.0222, 'lps'),
	(589458, 130, '2014-03-15 00:12:37.000000', 'consum', 0.0214, 'lps'),
	(589459, 130, '2014-03-15 00:12:38.000000', 'consum', 0.0211, 'lps'),
	(589460, 130, '2014-03-15 00:12:39.000000', 'consum', 0.0220, 'lps'),
	(589461, 130, '2014-03-15 00:12:40.000000', 'consum', 0.0211, 'lps'),
	(589462, 130, '2014-03-15 00:12:41.000000', 'consum', 0.0217, 'lps'),
	(589463, 130, '2014-03-15 00:12:42.000000', 'consum', 0.0212, 'lps'),
	(589464, 130, '2014-03-15 00:12:43.000000', 'consum', 0.0212, 'lps'),
	(589465, 130, '2014-03-15 00:12:44.000000', 'consum', 0.0217, 'lps'),
	(589466, 130, '2014-03-15 00:12:45.000000', 'consum', 0.0210, 'lps'),
	(589467, 130, '2014-03-15 00:12:46.000000', 'consum', 0.0218, 'lps'),
	(589468, 130, '2014-03-15 00:12:47.000000', 'consum', 0.0222, 'lps'),
	(589469, 130, '2014-03-15 00:12:48.000000', 'consum', 0.0215, 'lps'),
	(589470, 130, '2014-03-15 00:12:49.000000', 'consum', 0.0216, 'lps'),
	(589471, 130, '2014-03-15 00:12:50.000000', 'consum', 0.0210, 'lps'),
	(589472, 130, '2014-03-15 00:12:51.000000', 'consum', 0.0222, 'lps'),
	(589473, 130, '2014-03-15 00:12:52.000000', 'consum', 0.0212, 'lps'),
	(589474, 130, '2014-03-15 00:12:53.000000', 'consum', 0.0215, 'lps'),
	(589475, 130, '2014-03-15 00:12:54.000000', 'consum', 0.0216, 'lps'),
	(589476, 130, '2014-03-15 00:12:55.000000', 'consum', 0.0222, 'lps'),
	(589477, 130, '2014-03-15 00:12:56.000000', 'consum', 0.0223, 'lps'),
	(589478, 130, '2014-03-15 00:12:57.000000', 'consum', 0.0224, 'lps'),
	(589479, 130, '2014-03-15 00:12:58.000000', 'consum', 0.0213, 'lps'),
	(589480, 130, '2014-03-15 00:12:59.000000', 'consum', 0.0214, 'lps'),
	(589481, 130, '2014-03-15 00:13:00.000000', 'consum', 0.0221, 'lps'),
	(589482, 130, '2014-03-15 00:13:01.000000', 'consum', 0.0223, 'lps'),
	(589483, 130, '2014-03-15 00:13:02.000000', 'consum', 0.0212, 'lps'),
	(589484, 130, '2014-03-15 00:13:03.000000', 'consum', 0.0214, 'lps'),
	(589485, 130, '2014-03-15 00:13:04.000000', 'consum', 0.0222, 'lps'),
	(589486, 130, '2014-03-15 00:13:05.000000', 'consum', 0.0216, 'lps'),
	(589487, 130, '2014-03-15 00:13:06.000000', 'consum', 0.0217, 'lps'),
	(589488, 130, '2014-03-15 00:13:07.000000', 'consum', 0.0214, 'lps'),
	(589489, 130, '2014-03-15 00:13:08.000000', 'consum', 0.0210, 'lps'),
	(589490, 130, '2014-03-15 00:13:09.000000', 'consum', 0.0213, 'lps'),
	(589491, 130, '2014-03-15 00:13:10.000000', 'consum', 0.0211, 'lps'),
	(589492, 130, '2014-03-15 00:13:11.000000', 'consum', 0.0222, 'lps'),
	(589493, 130, '2014-03-15 00:13:12.000000', 'consum', 0.0222, 'lps'),
	(589494, 130, '2014-03-15 00:13:13.000000', 'consum', 0.0218, 'lps'),
	(589495, 130, '2014-03-15 00:13:14.000000', 'consum', 0.0215, 'lps'),
	(589496, 130, '2014-03-15 00:13:15.000000', 'consum', 0.0213, 'lps'),
	(589497, 130, '2014-03-15 00:13:16.000000', 'consum', 0.0224, 'lps'),
	(589498, 130, '2014-03-15 00:13:17.000000', 'consum', 0.0214, 'lps'),
	(589499, 130, '2014-03-15 00:13:18.000000', 'consum', 0.0216, 'lps'),
	(589500, 130, '2014-03-15 00:13:19.000000', 'consum', 0.0216, 'lps'),
	(589501, 130, '2014-03-15 00:13:20.000000', 'consum', 0.0220, 'lps'),
	(589502, 130, '2014-03-15 00:13:21.000000', 'consum', 0.0215, 'lps'),
	(589503, 130, '2014-03-15 00:13:22.000000', 'consum', 0.0222, 'lps'),
	(589504, 130, '2014-03-15 00:13:23.000000', 'consum', 0.0222, 'lps'),
	(589505, 130, '2014-03-15 00:13:24.000000', 'consum', 0.0219, 'lps'),
	(589506, 130, '2014-03-15 00:13:25.000000', 'consum', 0.0222, 'lps'),
	(589507, 130, '2014-03-15 00:13:26.000000', 'consum', 0.0210, 'lps'),
	(589508, 130, '2014-03-15 00:13:27.000000', 'consum', 0.0223, 'lps'),
	(589509, 130, '2014-03-15 00:13:28.000000', 'consum', 0.0216, 'lps'),
	(589510, 130, '2014-03-15 00:13:29.000000', 'consum', 0.0215, 'lps'),
	(589511, 130, '2014-03-15 00:13:30.000000', 'consum', 0.0219, 'lps'),
	(589512, 130, '2014-03-15 00:13:31.000000', 'consum', 0.0210, 'lps'),
	(589513, 130, '2014-03-15 00:13:32.000000', 'consum', 0.0214, 'lps'),
	(589514, 130, '2014-03-15 00:13:33.000000', 'consum', 0.0216, 'lps'),
	(589515, 130, '2014-03-15 00:13:34.000000', 'consum', 0.0213, 'lps'),
	(589516, 130, '2014-03-15 00:13:35.000000', 'consum', 0.0222, 'lps'),
	(589517, 130, '2014-03-15 00:13:36.000000', 'consum', 0.0218, 'lps'),
	(589518, 130, '2014-03-15 00:13:37.000000', 'consum', 0.0212, 'lps'),
	(589519, 130, '2014-03-15 00:13:38.000000', 'consum', 0.0212, 'lps'),
	(589520, 130, '2014-03-15 00:13:39.000000', 'consum', 0.0214, 'lps'),
	(589521, 130, '2014-03-15 00:13:40.000000', 'consum', 0.0211, 'lps'),
	(589522, 130, '2014-03-15 00:13:41.000000', 'consum', 0.0216, 'lps'),
	(589523, 130, '2014-03-15 00:13:42.000000', 'consum', 0.0224, 'lps'),
	(589524, 130, '2014-03-15 00:13:43.000000', 'consum', 0.0219, 'lps'),
	(589525, 130, '2014-03-15 00:13:44.000000', 'consum', 0.0212, 'lps'),
	(589526, 130, '2014-03-15 00:13:45.000000', 'consum', 0.0224, 'lps'),
	(589527, 130, '2014-03-15 00:13:46.000000', 'consum', 0.0215, 'lps'),
	(589528, 130, '2014-03-15 00:13:47.000000', 'consum', 0.0222, 'lps'),
	(589529, 130, '2014-03-15 00:13:48.000000', 'consum', 0.0211, 'lps'),
	(589530, 130, '2014-03-15 00:13:49.000000', 'consum', 0.0223, 'lps'),
	(589531, 130, '2014-03-15 00:13:50.000000', 'consum', 0.0212, 'lps'),
	(589532, 130, '2014-03-15 00:13:51.000000', 'consum', 0.0212, 'lps'),
	(589533, 130, '2014-03-15 00:13:52.000000', 'consum', 0.0215, 'lps'),
	(589534, 130, '2014-03-15 00:13:53.000000', 'consum', 0.0214, 'lps'),
	(589535, 130, '2014-03-15 00:13:54.000000', 'consum', 0.0214, 'lps'),
	(589536, 130, '2014-03-15 00:13:55.000000', 'consum', 0.0219, 'lps'),
	(589537, 130, '2014-03-15 00:13:56.000000', 'consum', 0.0212, 'lps'),
	(589538, 130, '2014-03-15 00:13:57.000000', 'consum', 0.0211, 'lps'),
	(589539, 130, '2014-03-15 00:13:58.000000', 'consum', 0.0224, 'lps'),
	(589540, 130, '2014-03-15 00:13:59.000000', 'consum', 0.0217, 'lps'),
	(589541, 130, '2014-03-15 00:14:00.000000', 'consum', 0.0220, 'lps'),
	(589542, 130, '2014-03-15 00:14:01.000000', 'consum', 0.0223, 'lps'),
	(589543, 130, '2014-03-15 00:14:02.000000', 'consum', 0.0218, 'lps'),
	(589544, 130, '2014-03-15 00:14:03.000000', 'consum', 0.0210, 'lps'),
	(589545, 130, '2014-03-15 00:14:04.000000', 'consum', 0.0217, 'lps'),
	(589546, 130, '2014-03-15 00:14:05.000000', 'consum', 0.0215, 'lps'),
	(589547, 130, '2014-03-15 00:14:06.000000', 'consum', 0.0215, 'lps'),
	(589548, 130, '2014-03-15 00:14:07.000000', 'consum', 0.0221, 'lps'),
	(589549, 130, '2014-03-15 00:14:08.000000', 'consum', 0.0220, 'lps'),
	(589550, 130, '2014-03-15 00:14:09.000000', 'consum', 0.0215, 'lps'),
	(589551, 130, '2014-03-15 00:14:10.000000', 'consum', 0.0217, 'lps'),
	(589552, 130, '2014-03-15 00:14:11.000000', 'consum', 0.0217, 'lps'),
	(589553, 130, '2014-03-15 00:14:12.000000', 'consum', 0.0210, 'lps'),
	(589554, 130, '2014-03-15 00:14:13.000000', 'consum', 0.0219, 'lps'),
	(589555, 130, '2014-03-15 00:14:14.000000', 'consum', 0.0212, 'lps'),
	(589556, 130, '2014-03-15 00:14:15.000000', 'consum', 0.0222, 'lps'),
	(589557, 130, '2014-03-15 00:14:16.000000', 'consum', 0.0221, 'lps'),
	(589558, 130, '2014-03-15 00:14:17.000000', 'consum', 0.0214, 'lps'),
	(589559, 130, '2014-03-15 00:14:18.000000', 'consum', 0.0214, 'lps'),
	(589560, 130, '2014-03-15 00:14:19.000000', 'consum', 0.0215, 'lps'),
	(589561, 130, '2014-03-15 00:14:20.000000', 'consum', 0.0212, 'lps'),
	(589562, 130, '2014-03-15 00:14:21.000000', 'consum', 0.0218, 'lps'),
	(589563, 130, '2014-03-15 00:14:22.000000', 'consum', 0.0215, 'lps'),
	(589564, 130, '2014-03-15 00:14:23.000000', 'consum', 0.0213, 'lps'),
	(589565, 130, '2014-03-15 00:14:24.000000', 'consum', 0.0224, 'lps'),
	(589566, 130, '2014-03-15 00:14:25.000000', 'consum', 0.0212, 'lps'),
	(589567, 130, '2014-03-15 00:14:26.000000', 'consum', 0.0210, 'lps'),
	(589568, 130, '2014-03-15 00:14:27.000000', 'consum', 0.0217, 'lps'),
	(589569, 130, '2014-03-15 00:14:28.000000', 'consum', 0.0215, 'lps'),
	(589570, 130, '2014-03-15 00:14:29.000000', 'consum', 0.0216, 'lps'),
	(589571, 130, '2014-03-15 00:14:30.000000', 'consum', 0.0212, 'lps'),
	(589572, 130, '2014-03-15 00:14:31.000000', 'consum', 0.0215, 'lps'),
	(589573, 130, '2014-03-15 00:14:32.000000', 'consum', 0.0217, 'lps'),
	(589574, 130, '2014-03-15 00:14:33.000000', 'consum', 0.0216, 'lps'),
	(589575, 130, '2014-03-15 00:14:34.000000', 'consum', 0.0218, 'lps'),
	(589576, 130, '2014-03-15 00:14:35.000000', 'consum', 0.0216, 'lps'),
	(589577, 130, '2014-03-15 00:14:36.000000', 'consum', 0.0217, 'lps'),
	(589578, 130, '2014-03-15 00:14:37.000000', 'consum', 0.0214, 'lps'),
	(589579, 130, '2014-03-15 00:14:38.000000', 'consum', 0.0210, 'lps'),
	(589580, 130, '2014-03-15 00:14:39.000000', 'consum', 0.0212, 'lps'),
	(589581, 130, '2014-03-15 00:14:40.000000', 'consum', 0.0222, 'lps'),
	(589582, 130, '2014-03-15 00:14:41.000000', 'consum', 0.0218, 'lps'),
	(589583, 130, '2014-03-15 00:14:42.000000', 'consum', 0.0217, 'lps'),
	(589584, 130, '2014-03-15 00:14:43.000000', 'consum', 0.0219, 'lps'),
	(589585, 130, '2014-03-15 00:14:44.000000', 'consum', 0.0219, 'lps'),
	(589586, 130, '2014-03-15 00:14:45.000000', 'consum', 0.0215, 'lps'),
	(589587, 130, '2014-03-15 00:14:46.000000', 'consum', 0.0210, 'lps'),
	(589588, 130, '2014-03-15 00:14:47.000000', 'consum', 0.0223, 'lps'),
	(589589, 130, '2014-03-15 00:14:48.000000', 'consum', 0.0217, 'lps'),
	(589590, 130, '2014-03-15 00:14:49.000000', 'consum', 0.0221, 'lps'),
	(589591, 130, '2014-03-15 00:14:50.000000', 'consum', 0.0213, 'lps'),
	(589592, 130, '2014-03-15 00:14:51.000000', 'consum', 0.0222, 'lps'),
	(589593, 130, '2014-03-15 00:14:52.000000', 'consum', 0.0219, 'lps'),
	(589594, 130, '2014-03-15 00:14:53.000000', 'consum', 0.0219, 'lps'),
	(589595, 130, '2014-03-15 00:14:54.000000', 'consum', 0.0211, 'lps'),
	(589596, 130, '2014-03-15 00:14:55.000000', 'consum', 0.0222, 'lps'),
	(589597, 130, '2014-03-15 00:14:56.000000', 'consum', 0.0219, 'lps'),
	(589598, 130, '2014-03-15 00:14:57.000000', 'consum', 0.0223, 'lps'),
	(589599, 130, '2014-03-15 00:14:58.000000', 'consum', 0.0215, 'lps'),
	(589600, 130, '2014-03-15 00:14:59.000000', 'consum', 0.0213, 'lps'),
	(589601, 130, '2014-03-15 00:15:00.000000', 'consum', 0.0212, 'lps'),
	(589602, 130, '2014-03-15 00:15:01.000000', 'consum', 0.0224, 'lps'),
	(589603, 130, '2014-03-15 00:15:02.000000', 'consum', 0.0213, 'lps'),
	(589604, 130, '2014-03-15 00:15:03.000000', 'consum', 0.0217, 'lps'),
	(589605, 130, '2014-03-15 00:15:04.000000', 'consum', 0.0221, 'lps'),
	(589606, 130, '2014-03-15 00:15:05.000000', 'consum', 0.0214, 'lps'),
	(589607, 130, '2014-03-15 00:15:06.000000', 'consum', 0.0213, 'lps'),
	(589608, 130, '2014-03-15 00:15:07.000000', 'consum', 0.0212, 'lps'),
	(589609, 130, '2014-03-15 00:15:08.000000', 'consum', 0.0212, 'lps'),
	(589610, 130, '2014-03-15 00:15:09.000000', 'consum', 0.0215, 'lps'),
	(589611, 130, '2014-03-15 00:15:10.000000', 'consum', 0.0214, 'lps'),
	(589612, 130, '2014-03-15 00:15:11.000000', 'consum', 0.0217, 'lps'),
	(589613, 130, '2014-03-15 00:15:12.000000', 'consum', 0.0216, 'lps'),
	(589614, 130, '2014-03-15 00:15:13.000000', 'consum', 0.0221, 'lps'),
	(589615, 130, '2014-03-15 00:15:14.000000', 'consum', 0.0219, 'lps'),
	(589616, 130, '2014-03-15 00:15:15.000000', 'consum', 0.0222, 'lps'),
	(589617, 130, '2014-03-15 00:15:16.000000', 'consum', 0.0214, 'lps'),
	(589618, 130, '2014-03-15 00:15:17.000000', 'consum', 0.0224, 'lps'),
	(589619, 130, '2014-03-15 00:15:18.000000', 'consum', 0.0210, 'lps'),
	(589620, 130, '2014-03-15 00:15:19.000000', 'consum', 0.0214, 'lps'),
	(589621, 130, '2014-03-15 00:15:20.000000', 'consum', 0.0213, 'lps'),
	(589622, 130, '2014-03-15 00:15:21.000000', 'consum', 0.0214, 'lps'),
	(589623, 130, '2014-03-15 00:15:22.000000', 'consum', 0.0221, 'lps'),
	(589624, 130, '2014-03-15 00:15:23.000000', 'consum', 0.0223, 'lps'),
	(589625, 130, '2014-03-15 00:15:24.000000', 'consum', 0.0212, 'lps'),
	(589626, 130, '2014-03-15 00:15:25.000000', 'consum', 0.0211, 'lps'),
	(589627, 130, '2014-03-15 00:15:26.000000', 'consum', 0.0210, 'lps'),
	(589628, 130, '2014-03-15 00:15:27.000000', 'consum', 0.0223, 'lps'),
	(589629, 130, '2014-03-15 00:15:28.000000', 'consum', 0.0216, 'lps'),
	(589630, 130, '2014-03-15 00:15:29.000000', 'consum', 0.0217, 'lps'),
	(589631, 130, '2014-03-15 00:15:30.000000', 'consum', 0.0210, 'lps'),
	(589632, 130, '2014-03-15 00:15:31.000000', 'consum', 0.0220, 'lps'),
	(589633, 130, '2014-03-15 00:15:32.000000', 'consum', 0.0217, 'lps'),
	(589634, 130, '2014-03-15 00:15:33.000000', 'consum', 0.0216, 'lps'),
	(589635, 130, '2014-03-15 00:15:34.000000', 'consum', 0.0217, 'lps'),
	(589636, 130, '2014-03-15 00:15:35.000000', 'consum', 0.0214, 'lps'),
	(589637, 130, '2014-03-15 00:15:36.000000', 'consum', 0.0224, 'lps'),
	(589638, 130, '2014-03-15 00:15:37.000000', 'consum', 0.0222, 'lps'),
	(589639, 130, '2014-03-15 00:15:38.000000', 'consum', 0.0213, 'lps'),
	(589640, 130, '2014-03-15 00:15:39.000000', 'consum', 0.0220, 'lps'),
	(589641, 130, '2014-03-15 00:15:40.000000', 'consum', 0.0223, 'lps'),
	(589642, 130, '2014-03-15 00:15:41.000000', 'consum', 0.0213, 'lps'),
	(589643, 130, '2014-03-15 00:15:42.000000', 'consum', 0.0217, 'lps'),
	(589644, 130, '2014-03-15 00:15:43.000000', 'consum', 0.0222, 'lps'),
	(589645, 130, '2014-03-15 00:15:44.000000', 'consum', 0.0218, 'lps'),
	(589646, 130, '2014-03-15 00:15:45.000000', 'consum', 0.0217, 'lps'),
	(589647, 130, '2014-03-15 00:15:46.000000', 'consum', 0.0221, 'lps'),
	(589648, 130, '2014-03-15 00:15:47.000000', 'consum', 0.0213, 'lps'),
	(589649, 130, '2014-03-15 00:15:48.000000', 'consum', 0.0223, 'lps'),
	(589650, 130, '2014-03-15 00:15:49.000000', 'consum', 0.0221, 'lps'),
	(589651, 130, '2014-03-15 00:15:50.000000', 'consum', 0.0212, 'lps'),
	(589652, 130, '2014-03-15 00:15:51.000000', 'consum', 0.0217, 'lps'),
	(589653, 130, '2014-03-15 00:15:52.000000', 'consum', 0.0212, 'lps'),
	(589654, 130, '2014-03-15 00:15:53.000000', 'consum', 0.0213, 'lps'),
	(589655, 130, '2014-03-15 00:15:54.000000', 'consum', 0.0219, 'lps'),
	(589656, 130, '2014-03-15 00:15:55.000000', 'consum', 0.0216, 'lps'),
	(589657, 130, '2014-03-15 00:15:56.000000', 'consum', 0.0213, 'lps'),
	(589658, 130, '2014-03-15 00:15:57.000000', 'consum', 0.0221, 'lps'),
	(589659, 130, '2014-03-15 00:15:58.000000', 'consum', 0.0215, 'lps'),
	(589660, 130, '2014-03-15 00:15:59.000000', 'consum', 0.0217, 'lps'),
	(589661, 130, '2014-03-15 00:16:00.000000', 'consum', 0.0215, 'lps'),
	(589662, 130, '2014-03-15 00:16:01.000000', 'consum', 0.0215, 'lps'),
	(589663, 130, '2014-03-15 00:16:02.000000', 'consum', 0.0221, 'lps'),
	(589664, 130, '2014-03-15 00:16:03.000000', 'consum', 0.0220, 'lps'),
	(589665, 130, '2014-03-15 00:16:04.000000', 'consum', 0.0210, 'lps'),
	(589666, 130, '2014-03-15 00:16:05.000000', 'consum', 0.0214, 'lps'),
	(589667, 130, '2014-03-15 00:16:06.000000', 'consum', 0.0214, 'lps'),
	(589668, 130, '2014-03-15 00:16:07.000000', 'consum', 0.0217, 'lps'),
	(589669, 130, '2014-03-15 00:16:08.000000', 'consum', 0.0220, 'lps'),
	(589670, 130, '2014-03-15 00:16:09.000000', 'consum', 0.0211, 'lps'),
	(589671, 130, '2014-03-15 00:16:10.000000', 'consum', 0.0215, 'lps'),
	(589672, 130, '2014-03-15 00:16:11.000000', 'consum', 0.0219, 'lps'),
	(589673, 130, '2014-03-15 00:16:12.000000', 'consum', 0.0223, 'lps'),
	(589674, 130, '2014-03-15 00:16:13.000000', 'consum', 0.0219, 'lps'),
	(589675, 130, '2014-03-15 00:16:14.000000', 'consum', 0.0217, 'lps'),
	(589676, 130, '2014-03-15 00:16:15.000000', 'consum', 0.0218, 'lps'),
	(589677, 130, '2014-03-15 00:16:16.000000', 'consum', 0.0214, 'lps'),
	(589678, 130, '2014-03-15 00:16:17.000000', 'consum', 0.0223, 'lps'),
	(589679, 130, '2014-03-15 00:16:18.000000', 'consum', 0.0216, 'lps'),
	(589680, 130, '2014-03-15 00:16:19.000000', 'consum', 0.0217, 'lps'),
	(589681, 130, '2014-03-15 00:16:20.000000', 'consum', 0.0212, 'lps'),
	(589682, 130, '2014-03-15 00:16:21.000000', 'consum', 0.0215, 'lps'),
	(589683, 130, '2014-03-15 00:16:22.000000', 'consum', 0.0216, 'lps'),
	(589684, 130, '2014-03-15 00:16:23.000000', 'consum', 0.0212, 'lps'),
	(589685, 130, '2014-03-15 00:16:24.000000', 'consum', 0.0214, 'lps'),
	(589686, 130, '2014-03-15 00:16:25.000000', 'consum', 0.0210, 'lps'),
	(589687, 130, '2014-03-15 00:16:26.000000', 'consum', 0.0213, 'lps'),
	(589688, 130, '2014-03-15 00:16:27.000000', 'consum', 0.0213, 'lps'),
	(589689, 130, '2014-03-15 00:16:28.000000', 'consum', 0.0216, 'lps'),
	(589690, 130, '2014-03-15 00:16:29.000000', 'consum', 0.0215, 'lps'),
	(589691, 130, '2014-03-15 00:16:30.000000', 'consum', 0.0220, 'lps'),
	(589692, 130, '2014-03-15 00:16:31.000000', 'consum', 0.0214, 'lps'),
	(589693, 130, '2014-03-15 00:16:32.000000', 'consum', 0.0214, 'lps'),
	(589694, 130, '2014-03-15 00:16:33.000000', 'consum', 0.0221, 'lps'),
	(589695, 130, '2014-03-15 00:16:34.000000', 'consum', 0.0224, 'lps'),
	(589696, 130, '2014-03-15 00:16:35.000000', 'consum', 0.0216, 'lps'),
	(589697, 130, '2014-03-15 00:16:36.000000', 'consum', 0.0213, 'lps'),
	(589698, 130, '2014-03-15 00:16:37.000000', 'consum', 0.0222, 'lps'),
	(589699, 130, '2014-03-15 00:16:38.000000', 'consum', 0.0219, 'lps'),
	(589700, 130, '2014-03-15 00:16:39.000000', 'consum', 0.0218, 'lps'),
	(589701, 130, '2014-03-15 00:16:40.000000', 'consum', 0.0224, 'lps'),
	(589702, 130, '2014-03-15 00:16:41.000000', 'consum', 0.0211, 'lps'),
	(589703, 130, '2014-03-15 00:16:42.000000', 'consum', 0.0220, 'lps'),
	(589704, 130, '2014-03-15 00:16:43.000000', 'consum', 0.0212, 'lps'),
	(589705, 130, '2014-03-15 00:16:44.000000', 'consum', 0.0222, 'lps'),
	(589706, 130, '2014-03-15 00:16:45.000000', 'consum', 0.0216, 'lps'),
	(589707, 130, '2014-03-15 00:16:46.000000', 'consum', 0.0222, 'lps'),
	(589708, 130, '2014-03-15 00:16:47.000000', 'consum', 0.0223, 'lps'),
	(589709, 130, '2014-03-15 00:16:48.000000', 'consum', 0.0222, 'lps'),
	(589710, 130, '2014-03-15 00:16:49.000000', 'consum', 0.0220, 'lps'),
	(589711, 130, '2014-03-15 00:16:50.000000', 'consum', 0.0221, 'lps'),
	(589712, 130, '2014-03-15 00:16:51.000000', 'consum', 0.0222, 'lps'),
	(589713, 130, '2014-03-15 00:16:52.000000', 'consum', 0.0222, 'lps'),
	(589714, 130, '2014-03-15 00:16:53.000000', 'consum', 0.0218, 'lps'),
	(589715, 130, '2014-03-15 00:16:54.000000', 'consum', 0.0217, 'lps'),
	(589716, 130, '2014-03-15 00:16:55.000000', 'consum', 0.0219, 'lps'),
	(589717, 130, '2014-03-15 00:16:56.000000', 'consum', 0.0219, 'lps'),
	(589718, 130, '2014-03-15 00:16:57.000000', 'consum', 0.0214, 'lps'),
	(589719, 130, '2014-03-15 00:16:58.000000', 'consum', 0.0218, 'lps'),
	(589720, 130, '2014-03-15 00:16:59.000000', 'consum', 0.0222, 'lps'),
	(589721, 130, '2014-03-15 00:17:00.000000', 'consum', 0.0218, 'lps'),
	(589722, 130, '2014-03-15 00:17:01.000000', 'consum', 0.0217, 'lps'),
	(589723, 130, '2014-03-15 00:17:02.000000', 'consum', 0.0218, 'lps'),
	(589724, 130, '2014-03-15 00:17:03.000000', 'consum', 0.0217, 'lps'),
	(589725, 130, '2014-03-15 00:17:04.000000', 'consum', 0.0219, 'lps'),
	(589726, 130, '2014-03-15 00:17:05.000000', 'consum', 0.0219, 'lps'),
	(589727, 130, '2014-03-15 00:17:06.000000', 'consum', 0.0216, 'lps'),
	(589728, 130, '2014-03-15 00:17:07.000000', 'consum', 0.0213, 'lps'),
	(589729, 130, '2014-03-15 00:17:08.000000', 'consum', 0.0223, 'lps'),
	(589730, 130, '2014-03-15 00:17:09.000000', 'consum', 0.0222, 'lps'),
	(589731, 130, '2014-03-15 00:17:10.000000', 'consum', 0.0215, 'lps'),
	(589732, 130, '2014-03-15 00:17:11.000000', 'consum', 0.0213, 'lps'),
	(589733, 130, '2014-03-15 00:17:12.000000', 'consum', 0.0214, 'lps'),
	(589734, 130, '2014-03-15 00:17:13.000000', 'consum', 0.0220, 'lps'),
	(589735, 130, '2014-03-15 00:17:14.000000', 'consum', 0.0218, 'lps'),
	(589736, 130, '2014-03-15 00:17:15.000000', 'consum', 0.0222, 'lps'),
	(589737, 130, '2014-03-15 00:17:16.000000', 'consum', 0.0214, 'lps'),
	(589738, 130, '2014-03-15 00:17:17.000000', 'consum', 0.0224, 'lps'),
	(589739, 130, '2014-03-15 00:17:18.000000', 'consum', 0.0210, 'lps'),
	(589740, 130, '2014-03-15 00:17:19.000000', 'consum', 0.0212, 'lps'),
	(589741, 130, '2014-03-15 00:17:20.000000', 'consum', 0.0222, 'lps'),
	(589742, 130, '2014-03-15 00:17:21.000000', 'consum', 0.0220, 'lps'),
	(589743, 130, '2014-03-15 00:17:22.000000', 'consum', 0.0211, 'lps'),
	(589744, 130, '2014-03-15 00:17:23.000000', 'consum', 0.0213, 'lps'),
	(589745, 130, '2014-03-15 00:17:24.000000', 'consum', 0.0223, 'lps'),
	(589746, 130, '2014-03-15 00:17:25.000000', 'consum', 0.0224, 'lps'),
	(589747, 130, '2014-03-15 00:17:26.000000', 'consum', 0.0224, 'lps'),
	(589748, 130, '2014-03-15 00:17:27.000000', 'consum', 0.0223, 'lps'),
	(589749, 130, '2014-03-15 00:17:28.000000', 'consum', 0.0218, 'lps'),
	(589750, 130, '2014-03-15 00:17:29.000000', 'consum', 0.0212, 'lps'),
	(589751, 130, '2014-03-15 00:17:30.000000', 'consum', 0.0211, 'lps'),
	(589752, 130, '2014-03-15 00:17:31.000000', 'consum', 0.0224, 'lps'),
	(589753, 130, '2014-03-15 00:17:32.000000', 'consum', 0.0220, 'lps'),
	(589754, 130, '2014-03-15 00:17:33.000000', 'consum', 0.0218, 'lps'),
	(589755, 130, '2014-03-15 00:17:34.000000', 'consum', 0.0218, 'lps'),
	(589756, 130, '2014-03-15 00:17:35.000000', 'consum', 0.0215, 'lps'),
	(589757, 130, '2014-03-15 00:17:36.000000', 'consum', 0.0210, 'lps'),
	(589758, 130, '2014-03-15 00:17:37.000000', 'consum', 0.0210, 'lps'),
	(589759, 130, '2014-03-15 00:17:38.000000', 'consum', 0.0212, 'lps'),
	(589760, 130, '2014-03-15 00:17:39.000000', 'consum', 0.0221, 'lps'),
	(589761, 130, '2014-03-15 00:17:40.000000', 'consum', 0.0212, 'lps'),
	(589762, 130, '2014-03-15 00:17:41.000000', 'consum', 0.0219, 'lps'),
	(589763, 130, '2014-03-15 00:17:42.000000', 'consum', 0.0218, 'lps'),
	(589764, 130, '2014-03-15 00:17:43.000000', 'consum', 0.0211, 'lps'),
	(589765, 130, '2014-03-15 00:17:44.000000', 'consum', 0.0222, 'lps'),
	(589766, 130, '2014-03-15 00:17:45.000000', 'consum', 0.0222, 'lps'),
	(589767, 130, '2014-03-15 00:17:46.000000', 'consum', 0.0219, 'lps'),
	(589768, 130, '2014-03-15 00:17:47.000000', 'consum', 0.0218, 'lps'),
	(589769, 130, '2014-03-15 00:17:48.000000', 'consum', 0.0224, 'lps'),
	(589770, 130, '2014-03-15 00:17:49.000000', 'consum', 0.0213, 'lps'),
	(589771, 130, '2014-03-15 00:17:50.000000', 'consum', 0.0211, 'lps'),
	(589772, 130, '2014-03-15 00:17:51.000000', 'consum', 0.0224, 'lps'),
	(589773, 130, '2014-03-15 00:17:52.000000', 'consum', 0.0215, 'lps'),
	(589774, 130, '2014-03-15 00:17:53.000000', 'consum', 0.0210, 'lps'),
	(589775, 130, '2014-03-15 00:17:54.000000', 'consum', 0.0212, 'lps'),
	(589776, 130, '2014-03-15 00:17:55.000000', 'consum', 0.0218, 'lps'),
	(589777, 130, '2014-03-15 00:17:56.000000', 'consum', 0.0214, 'lps'),
	(589778, 130, '2014-03-15 00:17:57.000000', 'consum', 0.0224, 'lps'),
	(589779, 130, '2014-03-15 00:17:58.000000', 'consum', 0.0222, 'lps'),
	(589780, 130, '2014-03-15 00:17:59.000000', 'consum', 0.0213, 'lps'),
	(589781, 130, '2014-03-15 00:18:00.000000', 'consum', 0.0219, 'lps'),
	(589782, 130, '2014-03-15 00:18:01.000000', 'consum', 0.0217, 'lps'),
	(589783, 130, '2014-03-15 00:18:02.000000', 'consum', 0.0220, 'lps'),
	(589784, 130, '2014-03-15 00:18:03.000000', 'consum', 0.0222, 'lps'),
	(589785, 130, '2014-03-15 00:18:04.000000', 'consum', 0.0212, 'lps'),
	(589786, 130, '2014-03-15 00:18:05.000000', 'consum', 0.0215, 'lps'),
	(589787, 130, '2014-03-15 00:18:06.000000', 'consum', 0.0214, 'lps'),
	(589788, 130, '2014-03-15 00:18:07.000000', 'consum', 0.0213, 'lps'),
	(589789, 130, '2014-03-15 00:18:08.000000', 'consum', 0.0217, 'lps'),
	(589790, 130, '2014-03-15 00:18:09.000000', 'consum', 0.0221, 'lps'),
	(589791, 130, '2014-03-15 00:18:10.000000', 'consum', 0.0215, 'lps'),
	(589792, 130, '2014-03-15 00:18:11.000000', 'consum', 0.0217, 'lps'),
	(589793, 130, '2014-03-15 00:18:12.000000', 'consum', 0.0217, 'lps'),
	(589794, 130, '2014-03-15 00:18:13.000000', 'consum', 0.0224, 'lps'),
	(589795, 130, '2014-03-15 00:18:14.000000', 'consum', 0.0213, 'lps'),
	(589796, 130, '2014-03-15 00:18:15.000000', 'consum', 0.0215, 'lps'),
	(589797, 130, '2014-03-15 00:18:16.000000', 'consum', 0.0211, 'lps'),
	(589798, 130, '2014-03-15 00:18:17.000000', 'consum', 0.0217, 'lps'),
	(589799, 130, '2014-03-15 00:18:18.000000', 'consum', 0.0211, 'lps'),
	(589800, 130, '2014-03-15 00:18:19.000000', 'consum', 0.0211, 'lps'),
	(589801, 130, '2014-03-15 00:18:20.000000', 'consum', 0.0210, 'lps'),
	(589802, 130, '2014-03-15 00:18:21.000000', 'consum', 0.0223, 'lps'),
	(589803, 130, '2014-03-15 00:18:22.000000', 'consum', 0.0215, 'lps'),
	(589804, 130, '2014-03-15 00:18:23.000000', 'consum', 0.0212, 'lps'),
	(589805, 130, '2014-03-15 00:18:24.000000', 'consum', 0.0221, 'lps'),
	(589806, 130, '2014-03-15 00:18:25.000000', 'consum', 0.0216, 'lps'),
	(589807, 130, '2014-03-15 00:18:26.000000', 'consum', 0.0222, 'lps'),
	(589808, 130, '2014-03-15 00:18:27.000000', 'consum', 0.0221, 'lps'),
	(589809, 130, '2014-03-15 00:18:28.000000', 'consum', 0.0215, 'lps'),
	(589810, 130, '2014-03-15 00:18:29.000000', 'consum', 0.0217, 'lps'),
	(589811, 130, '2014-03-15 00:18:30.000000', 'consum', 0.0214, 'lps'),
	(589812, 130, '2014-03-15 00:18:31.000000', 'consum', 0.0212, 'lps'),
	(589813, 130, '2014-03-15 00:18:32.000000', 'consum', 0.0224, 'lps'),
	(589814, 130, '2014-03-15 00:18:33.000000', 'consum', 0.0213, 'lps'),
	(589815, 130, '2014-03-15 00:18:34.000000', 'consum', 0.0215, 'lps'),
	(589816, 130, '2014-03-15 00:18:35.000000', 'consum', 0.0212, 'lps'),
	(589817, 130, '2014-03-15 00:18:36.000000', 'consum', 0.0221, 'lps'),
	(589818, 130, '2014-03-15 00:18:37.000000', 'consum', 0.0213, 'lps'),
	(589819, 130, '2014-03-15 00:18:38.000000', 'consum', 0.0222, 'lps'),
	(589820, 130, '2014-03-15 00:18:39.000000', 'consum', 0.0218, 'lps'),
	(589821, 130, '2014-03-15 00:18:40.000000', 'consum', 0.0212, 'lps'),
	(589822, 130, '2014-03-15 00:18:41.000000', 'consum', 0.0212, 'lps'),
	(589823, 130, '2014-03-15 00:18:42.000000', 'consum', 0.0216, 'lps'),
	(589824, 130, '2014-03-15 00:18:43.000000', 'consum', 0.0220, 'lps'),
	(589825, 130, '2014-03-15 00:18:44.000000', 'consum', 0.0210, 'lps'),
	(589826, 130, '2014-03-15 00:18:45.000000', 'consum', 0.0213, 'lps'),
	(589827, 130, '2014-03-15 00:18:46.000000', 'consum', 0.0210, 'lps'),
	(589828, 130, '2014-03-15 00:18:47.000000', 'consum', 0.0215, 'lps'),
	(589829, 130, '2014-03-15 00:18:48.000000', 'consum', 0.0222, 'lps'),
	(589830, 130, '2014-03-15 00:18:49.000000', 'consum', 0.0211, 'lps'),
	(589831, 130, '2014-03-15 00:18:50.000000', 'consum', 0.0223, 'lps'),
	(589832, 130, '2014-03-15 00:18:51.000000', 'consum', 0.0214, 'lps'),
	(589833, 130, '2014-03-15 00:18:52.000000', 'consum', 0.0222, 'lps'),
	(589834, 130, '2014-03-15 00:18:53.000000', 'consum', 0.0211, 'lps'),
	(589835, 130, '2014-03-15 00:18:54.000000', 'consum', 0.0224, 'lps'),
	(589836, 130, '2014-03-15 00:18:55.000000', 'consum', 0.0221, 'lps'),
	(589837, 130, '2014-03-15 00:18:56.000000', 'consum', 0.0221, 'lps'),
	(589838, 130, '2014-03-15 00:18:57.000000', 'consum', 0.0218, 'lps'),
	(589839, 130, '2014-03-15 00:18:58.000000', 'consum', 0.0217, 'lps'),
	(589840, 130, '2014-03-15 00:18:59.000000', 'consum', 0.0222, 'lps'),
	(589841, 130, '2014-03-15 00:19:00.000000', 'consum', 0.0220, 'lps'),
	(589842, 130, '2014-03-15 00:19:01.000000', 'consum', 0.0224, 'lps'),
	(589843, 130, '2014-03-15 00:19:02.000000', 'consum', 0.0221, 'lps'),
	(589844, 130, '2014-03-15 00:19:03.000000', 'consum', 0.0222, 'lps'),
	(589845, 130, '2014-03-15 00:19:04.000000', 'consum', 0.0222, 'lps'),
	(589846, 130, '2014-03-15 00:19:05.000000', 'consum', 0.0221, 'lps'),
	(589847, 130, '2014-03-15 00:19:06.000000', 'consum', 0.0216, 'lps'),
	(589848, 130, '2014-03-15 00:19:07.000000', 'consum', 0.0220, 'lps'),
	(589849, 130, '2014-03-15 00:19:08.000000', 'consum', 0.0212, 'lps'),
	(589850, 130, '2014-03-15 00:19:09.000000', 'consum', 0.0222, 'lps'),
	(589851, 130, '2014-03-15 00:19:10.000000', 'consum', 0.0221, 'lps'),
	(589852, 130, '2014-03-15 00:19:11.000000', 'consum', 0.0212, 'lps'),
	(589853, 130, '2014-03-15 00:19:12.000000', 'consum', 0.0218, 'lps'),
	(589854, 130, '2014-03-15 00:19:13.000000', 'consum', 0.0216, 'lps'),
	(589855, 130, '2014-03-15 00:19:14.000000', 'consum', 0.0216, 'lps'),
	(589856, 130, '2014-03-15 00:19:15.000000', 'consum', 0.0224, 'lps'),
	(589857, 130, '2014-03-15 00:19:16.000000', 'consum', 0.0216, 'lps'),
	(589858, 130, '2014-03-15 00:19:17.000000', 'consum', 0.0212, 'lps'),
	(589859, 130, '2014-03-15 00:19:18.000000', 'consum', 0.0218, 'lps'),
	(589860, 130, '2014-03-15 00:19:19.000000', 'consum', 0.0215, 'lps'),
	(589861, 130, '2014-03-15 00:19:20.000000', 'consum', 0.0213, 'lps'),
	(589862, 130, '2014-03-15 00:19:21.000000', 'consum', 0.0211, 'lps'),
	(589863, 130, '2014-03-15 00:19:22.000000', 'consum', 0.0221, 'lps'),
	(589864, 130, '2014-03-15 00:19:23.000000', 'consum', 0.0217, 'lps'),
	(589865, 130, '2014-03-15 00:19:24.000000', 'consum', 0.0213, 'lps'),
	(589866, 130, '2014-03-15 00:19:25.000000', 'consum', 0.0220, 'lps'),
	(589867, 130, '2014-03-15 00:19:26.000000', 'consum', 0.0219, 'lps'),
	(589868, 130, '2014-03-15 00:19:27.000000', 'consum', 0.0212, 'lps'),
	(589869, 130, '2014-03-15 00:19:28.000000', 'consum', 0.0224, 'lps'),
	(589870, 130, '2014-03-15 00:19:29.000000', 'consum', 0.0216, 'lps'),
	(589871, 130, '2014-03-15 00:19:30.000000', 'consum', 0.0212, 'lps'),
	(589872, 130, '2014-03-15 00:19:31.000000', 'consum', 0.0219, 'lps'),
	(589873, 130, '2014-03-15 00:19:32.000000', 'consum', 0.0219, 'lps'),
	(589874, 130, '2014-03-15 00:19:33.000000', 'consum', 0.0215, 'lps'),
	(589875, 130, '2014-03-15 00:19:34.000000', 'consum', 0.0220, 'lps'),
	(589876, 130, '2014-03-15 00:19:35.000000', 'consum', 0.0219, 'lps'),
	(589877, 130, '2014-03-15 00:19:36.000000', 'consum', 0.0224, 'lps'),
	(589878, 130, '2014-03-15 00:19:37.000000', 'consum', 0.0222, 'lps'),
	(589879, 130, '2014-03-15 00:19:38.000000', 'consum', 0.0214, 'lps'),
	(589880, 130, '2014-03-15 00:19:39.000000', 'consum', 0.0223, 'lps'),
	(589881, 130, '2014-03-15 00:19:40.000000', 'consum', 0.0220, 'lps'),
	(589882, 130, '2014-03-15 00:19:41.000000', 'consum', 0.0223, 'lps'),
	(589883, 130, '2014-03-15 00:19:42.000000', 'consum', 0.0216, 'lps'),
	(589884, 130, '2014-03-15 00:19:43.000000', 'consum', 0.0217, 'lps'),
	(589885, 130, '2014-03-15 00:19:44.000000', 'consum', 0.0211, 'lps'),
	(589886, 130, '2014-03-15 00:19:45.000000', 'consum', 0.0211, 'lps'),
	(589887, 130, '2014-03-15 00:19:46.000000', 'consum', 0.0210, 'lps'),
	(589888, 130, '2014-03-15 00:19:47.000000', 'consum', 0.0224, 'lps'),
	(589889, 130, '2014-03-15 00:19:48.000000', 'consum', 0.0219, 'lps'),
	(589890, 130, '2014-03-15 00:19:49.000000', 'consum', 0.0215, 'lps'),
	(589891, 130, '2014-03-15 00:19:50.000000', 'consum', 0.0210, 'lps'),
	(589892, 130, '2014-03-15 00:19:51.000000', 'consum', 0.0224, 'lps'),
	(589893, 130, '2014-03-15 00:19:52.000000', 'consum', 0.0222, 'lps'),
	(589894, 130, '2014-03-15 00:19:53.000000', 'consum', 0.0213, 'lps'),
	(589895, 130, '2014-03-15 00:19:54.000000', 'consum', 0.0221, 'lps'),
	(589896, 130, '2014-03-15 00:19:55.000000', 'consum', 0.0210, 'lps'),
	(589897, 130, '2014-03-15 00:19:56.000000', 'consum', 0.0221, 'lps'),
	(589898, 130, '2014-03-15 00:19:57.000000', 'consum', 0.0223, 'lps'),
	(589899, 130, '2014-03-15 00:19:58.000000', 'consum', 0.0212, 'lps'),
	(589900, 130, '2014-03-15 00:19:59.000000', 'consum', 0.0213, 'lps'),
	(589901, 130, '2014-03-15 00:20:00.000000', 'consum', 0.0219, 'lps'),
	(589902, 130, '2014-03-15 00:20:01.000000', 'consum', 0.0217, 'lps'),
	(589903, 130, '2014-03-15 00:20:02.000000', 'consum', 0.0220, 'lps'),
	(589904, 130, '2014-03-15 00:20:03.000000', 'consum', 0.0223, 'lps'),
	(589905, 130, '2014-03-15 00:20:04.000000', 'consum', 0.0214, 'lps'),
	(589906, 130, '2014-03-15 00:20:05.000000', 'consum', 0.0223, 'lps'),
	(589907, 130, '2014-03-15 00:20:06.000000', 'consum', 0.0216, 'lps'),
	(589908, 130, '2014-03-15 00:20:07.000000', 'consum', 0.0220, 'lps'),
	(589909, 130, '2014-03-15 00:20:08.000000', 'consum', 0.0224, 'lps'),
	(589910, 130, '2014-03-15 00:20:09.000000', 'consum', 0.0222, 'lps'),
	(589911, 130, '2014-03-15 00:20:10.000000', 'consum', 0.0213, 'lps'),
	(589912, 130, '2014-03-15 00:20:11.000000', 'consum', 0.0219, 'lps'),
	(589913, 130, '2014-03-15 00:20:12.000000', 'consum', 0.0218, 'lps'),
	(589914, 130, '2014-03-15 00:20:13.000000', 'consum', 0.0221, 'lps'),
	(589915, 130, '2014-03-15 00:20:14.000000', 'consum', 0.0213, 'lps'),
	(589916, 130, '2014-03-15 00:20:15.000000', 'consum', 0.0221, 'lps'),
	(589917, 130, '2014-03-15 00:20:16.000000', 'consum', 0.0214, 'lps'),
	(589918, 130, '2014-03-15 00:20:17.000000', 'consum', 0.0210, 'lps'),
	(589919, 130, '2014-03-15 00:20:18.000000', 'consum', 0.0216, 'lps'),
	(589920, 130, '2014-03-15 00:20:19.000000', 'consum', 0.0211, 'lps'),
	(589921, 130, '2014-03-15 00:20:20.000000', 'consum', 0.0211, 'lps'),
	(589922, 130, '2014-03-15 00:20:21.000000', 'consum', 0.0215, 'lps'),
	(589923, 130, '2014-03-15 00:20:22.000000', 'consum', 0.0215, 'lps'),
	(589924, 130, '2014-03-15 00:20:23.000000', 'consum', 0.0221, 'lps'),
	(589925, 130, '2014-03-15 00:20:24.000000', 'consum', 0.0219, 'lps'),
	(589926, 130, '2014-03-15 00:20:25.000000', 'consum', 0.0223, 'lps'),
	(589927, 130, '2014-03-15 00:20:26.000000', 'consum', 0.0217, 'lps'),
	(589928, 130, '2014-03-15 00:20:27.000000', 'consum', 0.0223, 'lps'),
	(589929, 130, '2014-03-15 00:20:28.000000', 'consum', 0.0224, 'lps'),
	(589930, 130, '2014-03-15 00:20:29.000000', 'consum', 0.0210, 'lps'),
	(589931, 130, '2014-03-15 00:20:30.000000', 'consum', 0.0214, 'lps'),
	(589932, 130, '2014-03-15 00:20:31.000000', 'consum', 0.0216, 'lps'),
	(589933, 130, '2014-03-15 00:20:32.000000', 'consum', 0.0216, 'lps'),
	(589934, 130, '2014-03-15 00:20:33.000000', 'consum', 0.0219, 'lps'),
	(589935, 130, '2014-03-15 00:20:34.000000', 'consum', 0.0222, 'lps'),
	(589936, 130, '2014-03-15 00:20:35.000000', 'consum', 0.0216, 'lps'),
	(589937, 130, '2014-03-15 00:20:36.000000', 'consum', 0.0220, 'lps'),
	(589938, 130, '2014-03-15 00:20:37.000000', 'consum', 0.0210, 'lps'),
	(589939, 130, '2014-03-15 00:20:38.000000', 'consum', 0.0213, 'lps'),
	(589940, 130, '2014-03-15 00:20:39.000000', 'consum', 0.0210, 'lps'),
	(589941, 130, '2014-03-15 00:20:40.000000', 'consum', 0.0217, 'lps'),
	(589942, 130, '2014-03-15 00:20:41.000000', 'consum', 0.0216, 'lps'),
	(589943, 130, '2014-03-15 00:20:42.000000', 'consum', 0.0219, 'lps'),
	(589944, 130, '2014-03-15 00:20:43.000000', 'consum', 0.0224, 'lps'),
	(589945, 130, '2014-03-15 00:20:44.000000', 'consum', 0.0221, 'lps'),
	(589946, 130, '2014-03-15 00:20:45.000000', 'consum', 0.0223, 'lps'),
	(589947, 130, '2014-03-15 00:20:46.000000', 'consum', 0.0213, 'lps'),
	(589948, 130, '2014-03-15 00:20:47.000000', 'consum', 0.0216, 'lps'),
	(589949, 130, '2014-03-15 00:20:48.000000', 'consum', 0.0218, 'lps'),
	(589950, 130, '2014-03-15 00:20:49.000000', 'consum', 0.0216, 'lps'),
	(589951, 130, '2014-03-15 00:20:50.000000', 'consum', 0.0215, 'lps'),
	(589952, 130, '2014-03-15 00:20:51.000000', 'consum', 0.0220, 'lps'),
	(589953, 130, '2014-03-15 00:20:52.000000', 'consum', 0.0216, 'lps'),
	(589954, 130, '2014-03-15 00:20:53.000000', 'consum', 0.0224, 'lps'),
	(589955, 130, '2014-03-15 00:20:54.000000', 'consum', 0.0217, 'lps'),
	(589956, 130, '2014-03-15 00:20:55.000000', 'consum', 0.0221, 'lps'),
	(589957, 130, '2014-03-15 00:20:56.000000', 'consum', 0.0212, 'lps'),
	(589958, 130, '2014-03-15 00:20:57.000000', 'consum', 0.0216, 'lps'),
	(589959, 130, '2014-03-15 00:20:58.000000', 'consum', 0.0223, 'lps'),
	(589960, 130, '2014-03-15 00:20:59.000000', 'consum', 0.0212, 'lps'),
	(589961, 130, '2014-03-15 00:21:00.000000', 'consum', 0.0211, 'lps'),
	(589962, 130, '2014-03-15 00:21:01.000000', 'consum', 0.0224, 'lps'),
	(589963, 130, '2014-03-15 00:21:02.000000', 'consum', 0.0218, 'lps'),
	(589964, 130, '2014-03-15 00:21:03.000000', 'consum', 0.0222, 'lps'),
	(589965, 130, '2014-03-15 00:21:04.000000', 'consum', 0.0218, 'lps'),
	(589966, 130, '2014-03-15 00:21:05.000000', 'consum', 0.0213, 'lps'),
	(589967, 130, '2014-03-15 00:21:06.000000', 'consum', 0.0218, 'lps'),
	(589968, 130, '2014-03-15 00:21:07.000000', 'consum', 0.0224, 'lps'),
	(589969, 130, '2014-03-15 00:21:08.000000', 'consum', 0.0214, 'lps'),
	(589970, 130, '2014-03-15 00:21:09.000000', 'consum', 0.0218, 'lps'),
	(589971, 130, '2014-03-15 00:21:10.000000', 'consum', 0.0210, 'lps'),
	(589972, 130, '2014-03-15 00:21:11.000000', 'consum', 0.0214, 'lps'),
	(589973, 130, '2014-03-15 00:21:12.000000', 'consum', 0.0217, 'lps'),
	(589974, 130, '2014-03-15 00:21:13.000000', 'consum', 0.0218, 'lps'),
	(589975, 130, '2014-03-15 00:21:14.000000', 'consum', 0.0214, 'lps'),
	(589976, 130, '2014-03-15 00:21:15.000000', 'consum', 0.0221, 'lps'),
	(589977, 130, '2014-03-15 00:21:16.000000', 'consum', 0.0223, 'lps'),
	(589978, 130, '2014-03-15 00:21:17.000000', 'consum', 0.0214, 'lps'),
	(589979, 130, '2014-03-15 00:21:18.000000', 'consum', 0.0223, 'lps'),
	(589980, 130, '2014-03-15 00:21:19.000000', 'consum', 0.0217, 'lps'),
	(589981, 130, '2014-03-15 00:21:20.000000', 'consum', 0.0221, 'lps'),
	(589982, 130, '2014-03-15 00:21:21.000000', 'consum', 0.0216, 'lps'),
	(589983, 130, '2014-03-15 00:21:22.000000', 'consum', 0.0221, 'lps'),
	(589984, 130, '2014-03-15 00:21:23.000000', 'consum', 0.0219, 'lps'),
	(589985, 130, '2014-03-15 00:21:24.000000', 'consum', 0.0222, 'lps'),
	(589986, 130, '2014-03-15 00:21:25.000000', 'consum', 0.0213, 'lps'),
	(589987, 130, '2014-03-15 00:21:26.000000', 'consum', 0.0219, 'lps'),
	(589988, 130, '2014-03-15 00:21:27.000000', 'consum', 0.0219, 'lps'),
	(589989, 130, '2014-03-15 00:21:28.000000', 'consum', 0.0212, 'lps'),
	(589990, 130, '2014-03-15 00:21:29.000000', 'consum', 0.0223, 'lps'),
	(589991, 130, '2014-03-15 00:21:30.000000', 'consum', 0.0223, 'lps'),
	(589992, 130, '2014-03-15 00:21:31.000000', 'consum', 0.0223, 'lps'),
	(589993, 130, '2014-03-15 00:21:32.000000', 'consum', 0.0219, 'lps'),
	(589994, 130, '2014-03-15 00:21:33.000000', 'consum', 0.0220, 'lps'),
	(589995, 130, '2014-03-15 00:21:34.000000', 'consum', 0.0218, 'lps'),
	(589996, 130, '2014-03-15 00:21:35.000000', 'consum', 0.0220, 'lps'),
	(589997, 130, '2014-03-15 00:21:36.000000', 'consum', 0.0222, 'lps'),
	(589998, 130, '2014-03-15 00:21:37.000000', 'consum', 0.0223, 'lps'),
	(589999, 130, '2014-03-15 00:21:38.000000', 'consum', 0.0213, 'lps'),
	(590000, 130, '2014-03-15 00:21:39.000000', 'consum', 0.0214, 'lps'),
	(590001, 130, '2014-03-15 00:21:40.000000', 'consum', 0.0224, 'lps'),
	(590002, 130, '2014-03-15 00:21:41.000000', 'consum', 0.0220, 'lps'),
	(590003, 130, '2014-03-15 00:21:42.000000', 'consum', 0.0222, 'lps'),
	(590004, 130, '2014-03-15 00:21:43.000000', 'consum', 0.0224, 'lps'),
	(590005, 130, '2014-03-15 00:21:44.000000', 'consum', 0.0215, 'lps'),
	(590006, 130, '2014-03-15 00:21:45.000000', 'consum', 0.0224, 'lps'),
	(590007, 130, '2014-03-15 00:21:46.000000', 'consum', 0.0221, 'lps'),
	(590008, 130, '2014-03-15 00:21:47.000000', 'consum', 0.0223, 'lps'),
	(590009, 130, '2014-03-15 00:21:48.000000', 'consum', 0.0212, 'lps'),
	(590010, 130, '2014-03-15 00:21:49.000000', 'consum', 0.0214, 'lps'),
	(590011, 130, '2014-03-15 00:21:50.000000', 'consum', 0.0222, 'lps'),
	(590012, 130, '2014-03-15 00:21:51.000000', 'consum', 0.0216, 'lps'),
	(590013, 130, '2014-03-15 00:21:52.000000', 'consum', 0.0218, 'lps'),
	(590014, 130, '2014-03-15 00:21:53.000000', 'consum', 0.0219, 'lps'),
	(590015, 130, '2014-03-15 00:21:54.000000', 'consum', 0.0215, 'lps'),
	(590016, 130, '2014-03-15 00:21:55.000000', 'consum', 0.0223, 'lps'),
	(590017, 130, '2014-03-15 00:21:56.000000', 'consum', 0.0218, 'lps'),
	(590018, 130, '2014-03-15 00:21:57.000000', 'consum', 0.0224, 'lps'),
	(590019, 130, '2014-03-15 00:21:58.000000', 'consum', 0.0212, 'lps'),
	(590020, 130, '2014-03-15 00:21:59.000000', 'consum', 0.0222, 'lps'),
	(590021, 130, '2014-03-15 00:22:00.000000', 'consum', 0.0220, 'lps'),
	(590022, 130, '2014-03-15 00:22:01.000000', 'consum', 0.0212, 'lps'),
	(590023, 130, '2014-03-15 00:22:02.000000', 'consum', 0.0220, 'lps'),
	(590024, 130, '2014-03-15 00:22:03.000000', 'consum', 0.0222, 'lps'),
	(590025, 130, '2014-03-15 00:22:04.000000', 'consum', 0.0213, 'lps'),
	(590026, 130, '2014-03-15 00:22:05.000000', 'consum', 0.0219, 'lps'),
	(590027, 130, '2014-03-15 00:22:06.000000', 'consum', 0.0217, 'lps'),
	(590028, 130, '2014-03-15 00:22:07.000000', 'consum', 0.0218, 'lps'),
	(590029, 130, '2014-03-15 00:22:08.000000', 'consum', 0.0212, 'lps'),
	(590030, 130, '2014-03-15 00:22:09.000000', 'consum', 0.0215, 'lps'),
	(590031, 130, '2014-03-15 00:22:10.000000', 'consum', 0.0213, 'lps'),
	(590032, 130, '2014-03-15 00:22:11.000000', 'consum', 0.0224, 'lps'),
	(590033, 130, '2014-03-15 00:22:12.000000', 'consum', 0.0211, 'lps'),
	(590034, 130, '2014-03-15 00:22:13.000000', 'consum', 0.0221, 'lps'),
	(590035, 130, '2014-03-15 00:22:14.000000', 'consum', 0.0219, 'lps'),
	(590036, 130, '2014-03-15 00:22:15.000000', 'consum', 0.0220, 'lps'),
	(590037, 130, '2014-03-15 00:22:16.000000', 'consum', 0.0217, 'lps'),
	(590038, 130, '2014-03-15 00:22:17.000000', 'consum', 0.0218, 'lps'),
	(590039, 130, '2014-03-15 00:22:18.000000', 'consum', 0.0216, 'lps'),
	(590040, 130, '2014-03-15 00:22:19.000000', 'consum', 0.0214, 'lps'),
	(590041, 130, '2014-03-15 00:22:20.000000', 'consum', 0.0213, 'lps'),
	(590042, 130, '2014-03-15 00:22:21.000000', 'consum', 0.0212, 'lps'),
	(590043, 130, '2014-03-15 00:22:22.000000', 'consum', 0.0215, 'lps'),
	(590044, 130, '2014-03-15 00:22:23.000000', 'consum', 0.0211, 'lps'),
	(590045, 130, '2014-03-15 00:22:24.000000', 'consum', 0.0217, 'lps'),
	(590046, 130, '2014-03-15 00:22:25.000000', 'consum', 0.0211, 'lps'),
	(590047, 130, '2014-03-15 00:22:26.000000', 'consum', 0.0210, 'lps'),
	(590048, 130, '2014-03-15 00:22:27.000000', 'consum', 0.0221, 'lps'),
	(590049, 130, '2014-03-15 00:22:28.000000', 'consum', 0.0221, 'lps'),
	(590050, 130, '2014-03-15 00:22:29.000000', 'consum', 0.0216, 'lps'),
	(590051, 130, '2014-03-15 00:22:30.000000', 'consum', 0.0224, 'lps'),
	(590052, 130, '2014-03-15 00:22:31.000000', 'consum', 0.0218, 'lps'),
	(590053, 130, '2014-03-15 00:22:32.000000', 'consum', 0.0224, 'lps'),
	(590054, 130, '2014-03-15 00:22:33.000000', 'consum', 0.0210, 'lps'),
	(590055, 130, '2014-03-15 00:22:34.000000', 'consum', 0.0212, 'lps'),
	(590056, 130, '2014-03-15 00:22:35.000000', 'consum', 0.0223, 'lps'),
	(590057, 130, '2014-03-15 00:22:36.000000', 'consum', 0.0222, 'lps'),
	(590058, 130, '2014-03-15 00:22:37.000000', 'consum', 0.0217, 'lps'),
	(590059, 130, '2014-03-15 00:22:38.000000', 'consum', 0.0223, 'lps'),
	(590060, 130, '2014-03-15 00:22:39.000000', 'consum', 0.0211, 'lps'),
	(590061, 130, '2014-03-15 00:22:40.000000', 'consum', 0.0221, 'lps'),
	(590062, 130, '2014-03-15 00:22:41.000000', 'consum', 0.0219, 'lps'),
	(590063, 130, '2014-03-15 00:22:42.000000', 'consum', 0.0220, 'lps'),
	(590064, 130, '2014-03-15 00:22:43.000000', 'consum', 0.0220, 'lps'),
	(590065, 130, '2014-03-15 00:22:44.000000', 'consum', 0.0213, 'lps'),
	(590066, 130, '2014-03-15 00:22:45.000000', 'consum', 0.0213, 'lps'),
	(590067, 130, '2014-03-15 00:22:46.000000', 'consum', 0.0217, 'lps'),
	(590068, 130, '2014-03-15 00:22:47.000000', 'consum', 0.0220, 'lps'),
	(590069, 130, '2014-03-15 00:22:48.000000', 'consum', 0.0224, 'lps'),
	(590070, 130, '2014-03-15 00:22:49.000000', 'consum', 0.0221, 'lps'),
	(590071, 130, '2014-03-15 00:22:50.000000', 'consum', 0.0222, 'lps'),
	(590072, 130, '2014-03-15 00:22:51.000000', 'consum', 0.0211, 'lps'),
	(590073, 130, '2014-03-15 00:22:52.000000', 'consum', 0.0222, 'lps'),
	(590074, 130, '2014-03-15 00:22:53.000000', 'consum', 0.0222, 'lps'),
	(590075, 130, '2014-03-15 00:22:54.000000', 'consum', 0.0218, 'lps'),
	(590076, 130, '2014-03-15 00:22:55.000000', 'consum', 0.0218, 'lps'),
	(590077, 130, '2014-03-15 00:22:56.000000', 'consum', 0.0210, 'lps'),
	(590078, 130, '2014-03-15 00:22:57.000000', 'consum', 0.0217, 'lps'),
	(590079, 130, '2014-03-15 00:22:58.000000', 'consum', 0.0216, 'lps'),
	(590080, 130, '2014-03-15 00:22:59.000000', 'consum', 0.0217, 'lps'),
	(590081, 130, '2014-03-15 00:23:00.000000', 'consum', 0.0214, 'lps'),
	(590082, 130, '2014-03-15 00:23:01.000000', 'consum', 0.0223, 'lps'),
	(590083, 130, '2014-03-15 00:23:02.000000', 'consum', 0.0218, 'lps'),
	(590084, 130, '2014-03-15 00:23:03.000000', 'consum', 0.0213, 'lps'),
	(590085, 130, '2014-03-15 00:23:04.000000', 'consum', 0.0216, 'lps'),
	(590086, 130, '2014-03-15 00:23:05.000000', 'consum', 0.0217, 'lps'),
	(590087, 130, '2014-03-15 00:23:06.000000', 'consum', 0.0213, 'lps'),
	(590088, 130, '2014-03-15 00:23:07.000000', 'consum', 0.0221, 'lps'),
	(590089, 130, '2014-03-15 00:23:08.000000', 'consum', 0.0224, 'lps'),
	(590090, 130, '2014-03-15 00:23:09.000000', 'consum', 0.0217, 'lps'),
	(590091, 130, '2014-03-15 00:23:10.000000', 'consum', 0.0220, 'lps'),
	(590092, 130, '2014-03-15 00:23:11.000000', 'consum', 0.0223, 'lps'),
	(590093, 130, '2014-03-15 00:23:12.000000', 'consum', 0.0217, 'lps'),
	(590094, 130, '2014-03-15 00:23:13.000000', 'consum', 0.0220, 'lps'),
	(590095, 130, '2014-03-15 00:23:14.000000', 'consum', 0.0224, 'lps'),
	(590096, 130, '2014-03-15 00:23:15.000000', 'consum', 0.0220, 'lps'),
	(590097, 130, '2014-03-15 00:23:16.000000', 'consum', 0.0220, 'lps'),
	(590098, 130, '2014-03-15 00:23:17.000000', 'consum', 0.0215, 'lps'),
	(590099, 130, '2014-03-15 00:23:18.000000', 'consum', 0.0219, 'lps'),
	(590100, 130, '2014-03-15 00:23:19.000000', 'consum', 0.0212, 'lps'),
	(590101, 130, '2014-03-15 00:23:20.000000', 'consum', 0.0224, 'lps'),
	(590102, 130, '2014-03-15 00:23:21.000000', 'consum', 0.0216, 'lps'),
	(590103, 130, '2014-03-15 00:23:22.000000', 'consum', 0.0211, 'lps'),
	(590104, 130, '2014-03-15 00:23:23.000000', 'consum', 0.0215, 'lps'),
	(590105, 130, '2014-03-15 00:23:24.000000', 'consum', 0.0215, 'lps'),
	(590106, 130, '2014-03-15 00:23:25.000000', 'consum', 0.0223, 'lps'),
	(590107, 130, '2014-03-15 00:23:26.000000', 'consum', 0.0216, 'lps'),
	(590108, 130, '2014-03-15 00:23:27.000000', 'consum', 0.0217, 'lps'),
	(590109, 130, '2014-03-15 00:23:28.000000', 'consum', 0.0213, 'lps'),
	(590110, 130, '2014-03-15 00:23:29.000000', 'consum', 0.0219, 'lps'),
	(590111, 130, '2014-03-15 00:23:30.000000', 'consum', 0.0215, 'lps'),
	(590112, 130, '2014-03-15 00:23:31.000000', 'consum', 0.0223, 'lps'),
	(590113, 130, '2014-03-15 00:23:32.000000', 'consum', 0.0218, 'lps'),
	(590114, 130, '2014-03-15 00:23:33.000000', 'consum', 0.0224, 'lps'),
	(590115, 130, '2014-03-15 00:23:34.000000', 'consum', 0.0212, 'lps'),
	(590116, 130, '2014-03-15 00:23:35.000000', 'consum', 0.0210, 'lps'),
	(590117, 130, '2014-03-15 00:23:36.000000', 'consum', 0.0220, 'lps'),
	(590118, 130, '2014-03-15 00:23:37.000000', 'consum', 0.0213, 'lps'),
	(590119, 130, '2014-03-15 00:23:38.000000', 'consum', 0.0211, 'lps'),
	(590120, 130, '2014-03-15 00:23:39.000000', 'consum', 0.0221, 'lps'),
	(590121, 130, '2014-03-15 00:23:40.000000', 'consum', 0.0216, 'lps'),
	(590122, 130, '2014-03-15 00:23:41.000000', 'consum', 0.0224, 'lps'),
	(590123, 130, '2014-03-15 00:23:42.000000', 'consum', 0.0219, 'lps'),
	(590124, 130, '2014-03-15 00:23:43.000000', 'consum', 0.0213, 'lps'),
	(590125, 130, '2014-03-15 00:23:44.000000', 'consum', 0.0215, 'lps'),
	(590126, 130, '2014-03-15 00:23:45.000000', 'consum', 0.0223, 'lps'),
	(590127, 130, '2014-03-15 00:23:46.000000', 'consum', 0.0219, 'lps'),
	(590128, 130, '2014-03-15 00:23:47.000000', 'consum', 0.0213, 'lps'),
	(590129, 130, '2014-03-15 00:23:48.000000', 'consum', 0.0216, 'lps'),
	(590130, 130, '2014-03-15 00:23:49.000000', 'consum', 0.0217, 'lps'),
	(590131, 130, '2014-03-15 00:23:50.000000', 'consum', 0.0211, 'lps'),
	(590132, 130, '2014-03-15 00:23:51.000000', 'consum', 0.0212, 'lps'),
	(590133, 130, '2014-03-15 00:23:52.000000', 'consum', 0.0215, 'lps'),
	(590134, 130, '2014-03-15 00:23:53.000000', 'consum', 0.0214, 'lps'),
	(590135, 130, '2014-03-15 00:23:54.000000', 'consum', 0.0215, 'lps'),
	(590136, 130, '2014-03-15 00:23:55.000000', 'consum', 0.0210, 'lps'),
	(590137, 130, '2014-03-15 00:23:56.000000', 'consum', 0.0224, 'lps'),
	(590138, 130, '2014-03-15 00:23:57.000000', 'consum', 0.0222, 'lps'),
	(590139, 130, '2014-03-15 00:23:58.000000', 'consum', 0.0213, 'lps'),
	(590140, 130, '2014-03-15 00:23:59.000000', 'consum', 0.0221, 'lps'),
	(590141, 130, '2014-03-15 00:24:00.000000', 'consum', 0.0211, 'lps'),
	(590142, 130, '2014-03-15 00:24:01.000000', 'consum', 0.0210, 'lps'),
	(590143, 130, '2014-03-15 00:24:02.000000', 'consum', 0.0224, 'lps'),
	(590144, 130, '2014-03-15 00:24:03.000000', 'consum', 0.0222, 'lps'),
	(590145, 130, '2014-03-15 00:24:04.000000', 'consum', 0.0210, 'lps'),
	(590146, 130, '2014-03-15 00:24:05.000000', 'consum', 0.0223, 'lps'),
	(590147, 130, '2014-03-15 00:24:06.000000', 'consum', 0.0214, 'lps'),
	(590148, 130, '2014-03-15 00:24:07.000000', 'consum', 0.0221, 'lps'),
	(590149, 130, '2014-03-15 00:24:08.000000', 'consum', 0.0222, 'lps'),
	(590150, 130, '2014-03-15 00:24:09.000000', 'consum', 0.0224, 'lps'),
	(590151, 130, '2014-03-15 00:24:10.000000', 'consum', 0.0216, 'lps'),
	(590152, 130, '2014-03-15 00:24:11.000000', 'consum', 0.0211, 'lps'),
	(590153, 130, '2014-03-15 00:24:12.000000', 'consum', 0.0214, 'lps'),
	(590154, 130, '2014-03-15 00:24:13.000000', 'consum', 0.0213, 'lps'),
	(590155, 130, '2014-03-15 00:24:14.000000', 'consum', 0.0211, 'lps'),
	(590156, 130, '2014-03-15 00:24:15.000000', 'consum', 0.0223, 'lps'),
	(590157, 130, '2014-03-15 00:24:16.000000', 'consum', 0.0211, 'lps'),
	(590158, 130, '2014-03-15 00:24:17.000000', 'consum', 0.0223, 'lps'),
	(590159, 130, '2014-03-15 00:24:18.000000', 'consum', 0.0211, 'lps'),
	(590160, 130, '2014-03-15 00:24:19.000000', 'consum', 0.0223, 'lps'),
	(590161, 130, '2014-03-15 00:24:20.000000', 'consum', 0.0211, 'lps'),
	(590162, 130, '2014-03-15 00:24:21.000000', 'consum', 0.0224, 'lps'),
	(590163, 130, '2014-03-15 00:24:22.000000', 'consum', 0.0215, 'lps'),
	(590164, 130, '2014-03-15 00:24:23.000000', 'consum', 0.0223, 'lps'),
	(590165, 130, '2014-03-15 00:24:24.000000', 'consum', 0.0218, 'lps'),
	(590166, 130, '2014-03-15 00:24:25.000000', 'consum', 0.0211, 'lps'),
	(590167, 130, '2014-03-15 00:24:26.000000', 'consum', 0.0221, 'lps'),
	(590168, 130, '2014-03-15 00:24:27.000000', 'consum', 0.0216, 'lps'),
	(590169, 130, '2014-03-15 00:24:28.000000', 'consum', 0.0224, 'lps'),
	(590170, 130, '2014-03-15 00:24:29.000000', 'consum', 0.0217, 'lps'),
	(590171, 130, '2014-03-15 00:24:30.000000', 'consum', 0.0218, 'lps'),
	(590172, 130, '2014-03-15 00:24:31.000000', 'consum', 0.0214, 'lps'),
	(590173, 130, '2014-03-15 00:24:32.000000', 'consum', 0.0224, 'lps'),
	(590174, 130, '2014-03-15 00:24:33.000000', 'consum', 0.0221, 'lps'),
	(590175, 130, '2014-03-15 00:24:34.000000', 'consum', 0.0223, 'lps'),
	(590176, 130, '2014-03-15 00:24:35.000000', 'consum', 0.0212, 'lps'),
	(590177, 130, '2014-03-15 00:24:36.000000', 'consum', 0.0211, 'lps'),
	(590178, 130, '2014-03-15 00:24:37.000000', 'consum', 0.0211, 'lps'),
	(590179, 130, '2014-03-15 00:24:38.000000', 'consum', 0.0214, 'lps'),
	(590180, 130, '2014-03-15 00:24:39.000000', 'consum', 0.0210, 'lps'),
	(590181, 130, '2014-03-15 00:24:40.000000', 'consum', 0.0215, 'lps'),
	(590182, 130, '2014-03-15 00:24:41.000000', 'consum', 0.0222, 'lps'),
	(590183, 130, '2014-03-15 00:24:42.000000', 'consum', 0.0222, 'lps'),
	(590184, 130, '2014-03-15 00:24:43.000000', 'consum', 0.0222, 'lps'),
	(590185, 130, '2014-03-15 00:24:44.000000', 'consum', 0.0218, 'lps'),
	(590186, 130, '2014-03-15 00:24:45.000000', 'consum', 0.0213, 'lps'),
	(590187, 130, '2014-03-15 00:24:46.000000', 'consum', 0.0219, 'lps'),
	(590188, 130, '2014-03-15 00:24:47.000000', 'consum', 0.0215, 'lps'),
	(590189, 130, '2014-03-15 00:24:48.000000', 'consum', 0.0223, 'lps'),
	(590190, 130, '2014-03-15 00:24:49.000000', 'consum', 0.0217, 'lps'),
	(590191, 130, '2014-03-15 00:24:50.000000', 'consum', 0.0221, 'lps'),
	(590192, 130, '2014-03-15 00:24:51.000000', 'consum', 0.0214, 'lps'),
	(590193, 130, '2014-03-15 00:24:52.000000', 'consum', 0.0213, 'lps'),
	(590194, 130, '2014-03-15 00:24:53.000000', 'consum', 0.0214, 'lps'),
	(590195, 130, '2014-03-15 00:24:54.000000', 'consum', 0.0223, 'lps'),
	(590196, 130, '2014-03-15 00:24:55.000000', 'consum', 0.0215, 'lps'),
	(590197, 130, '2014-03-15 00:24:56.000000', 'consum', 0.0213, 'lps'),
	(590198, 130, '2014-03-15 00:24:57.000000', 'consum', 0.0212, 'lps'),
	(590199, 130, '2014-03-15 00:24:58.000000', 'consum', 0.0211, 'lps'),
	(590200, 130, '2014-03-15 00:24:59.000000', 'consum', 0.0224, 'lps'),
	(590201, 130, '2014-03-15 00:25:00.000000', 'consum', 0.0216, 'lps'),
	(590202, 130, '2014-03-15 00:25:01.000000', 'consum', 0.0213, 'lps'),
	(590203, 130, '2014-03-15 00:25:02.000000', 'consum', 0.0223, 'lps'),
	(590204, 130, '2014-03-15 00:25:03.000000', 'consum', 0.0222, 'lps'),
	(590205, 130, '2014-03-15 00:25:04.000000', 'consum', 0.0215, 'lps'),
	(590206, 130, '2014-03-15 00:25:05.000000', 'consum', 0.0216, 'lps'),
	(590207, 130, '2014-03-15 00:25:06.000000', 'consum', 0.0210, 'lps'),
	(590208, 130, '2014-03-15 00:25:07.000000', 'consum', 0.0223, 'lps'),
	(590209, 130, '2014-03-15 00:25:08.000000', 'consum', 0.0216, 'lps'),
	(590210, 130, '2014-03-15 00:25:09.000000', 'consum', 0.0217, 'lps'),
	(590211, 130, '2014-03-15 00:25:10.000000', 'consum', 0.0213, 'lps'),
	(590212, 130, '2014-03-15 00:25:11.000000', 'consum', 0.0220, 'lps'),
	(590213, 130, '2014-03-15 00:25:12.000000', 'consum', 0.0219, 'lps'),
	(590214, 130, '2014-03-15 00:25:13.000000', 'consum', 0.0211, 'lps'),
	(590215, 130, '2014-03-15 00:25:14.000000', 'consum', 0.0220, 'lps'),
	(590216, 130, '2014-03-15 00:25:15.000000', 'consum', 0.0210, 'lps'),
	(590217, 130, '2014-03-15 00:25:16.000000', 'consum', 0.0211, 'lps'),
	(590218, 130, '2014-03-15 00:25:17.000000', 'consum', 0.0215, 'lps'),
	(590219, 130, '2014-03-15 00:25:18.000000', 'consum', 0.0217, 'lps'),
	(590220, 130, '2014-03-15 00:25:19.000000', 'consum', 0.0218, 'lps'),
	(590221, 130, '2014-03-15 00:25:20.000000', 'consum', 0.0213, 'lps'),
	(590222, 130, '2014-03-15 00:25:21.000000', 'consum', 0.0218, 'lps'),
	(590223, 130, '2014-03-15 00:25:22.000000', 'consum', 0.0211, 'lps'),
	(590224, 130, '2014-03-15 00:25:23.000000', 'consum', 0.0220, 'lps'),
	(590225, 130, '2014-03-15 00:25:24.000000', 'consum', 0.0212, 'lps'),
	(590226, 130, '2014-03-15 00:25:25.000000', 'consum', 0.0221, 'lps'),
	(590227, 130, '2014-03-15 00:25:26.000000', 'consum', 0.0213, 'lps'),
	(590228, 130, '2014-03-15 00:25:27.000000', 'consum', 0.0224, 'lps'),
	(590229, 130, '2014-03-15 00:25:28.000000', 'consum', 0.0211, 'lps'),
	(590230, 130, '2014-03-15 00:25:29.000000', 'consum', 0.0221, 'lps'),
	(590231, 130, '2014-03-15 00:25:30.000000', 'consum', 0.0215, 'lps'),
	(590232, 130, '2014-03-15 00:25:31.000000', 'consum', 0.0220, 'lps'),
	(590233, 130, '2014-03-15 00:25:32.000000', 'consum', 0.0214, 'lps'),
	(590234, 130, '2014-03-15 00:25:33.000000', 'consum', 0.0216, 'lps'),
	(590235, 130, '2014-03-15 00:25:34.000000', 'consum', 0.0212, 'lps'),
	(590236, 130, '2014-03-15 00:25:35.000000', 'consum', 0.0220, 'lps'),
	(590237, 130, '2014-03-15 00:25:36.000000', 'consum', 0.0222, 'lps'),
	(590238, 130, '2014-03-15 00:25:37.000000', 'consum', 0.0210, 'lps'),
	(590239, 130, '2014-03-15 00:25:38.000000', 'consum', 0.0221, 'lps'),
	(590240, 130, '2014-03-15 00:25:39.000000', 'consum', 0.0222, 'lps'),
	(590241, 130, '2014-03-15 00:25:40.000000', 'consum', 0.0222, 'lps'),
	(590242, 130, '2014-03-15 00:25:41.000000', 'consum', 0.0219, 'lps'),
	(590243, 130, '2014-03-15 00:25:42.000000', 'consum', 0.0221, 'lps'),
	(590244, 130, '2014-03-15 00:25:43.000000', 'consum', 0.0222, 'lps'),
	(590245, 130, '2014-03-15 00:25:44.000000', 'consum', 0.0221, 'lps'),
	(590246, 130, '2014-03-15 00:25:45.000000', 'consum', 0.0214, 'lps'),
	(590247, 130, '2014-03-15 00:25:46.000000', 'consum', 0.0215, 'lps'),
	(590248, 130, '2014-03-15 00:25:47.000000', 'consum', 0.0222, 'lps'),
	(590249, 130, '2014-03-15 00:25:48.000000', 'consum', 0.0211, 'lps'),
	(590250, 130, '2014-03-15 00:25:49.000000', 'consum', 0.0211, 'lps'),
	(590251, 130, '2014-03-15 00:25:50.000000', 'consum', 0.0212, 'lps'),
	(590252, 130, '2014-03-15 00:25:51.000000', 'consum', 0.0215, 'lps'),
	(590253, 130, '2014-03-15 00:25:52.000000', 'consum', 0.0218, 'lps'),
	(590254, 130, '2014-03-15 00:25:53.000000', 'consum', 0.0218, 'lps'),
	(590255, 130, '2014-03-15 00:25:54.000000', 'consum', 0.0211, 'lps'),
	(590256, 130, '2014-03-15 00:25:55.000000', 'consum', 0.0222, 'lps'),
	(590257, 130, '2014-03-15 00:25:56.000000', 'consum', 0.0222, 'lps'),
	(590258, 130, '2014-03-15 00:25:57.000000', 'consum', 0.0221, 'lps'),
	(590259, 130, '2014-03-15 00:25:58.000000', 'consum', 0.0214, 'lps'),
	(590260, 130, '2014-03-15 00:25:59.000000', 'consum', 0.0211, 'lps'),
	(590261, 130, '2014-03-15 00:26:00.000000', 'consum', 0.0219, 'lps'),
	(590262, 130, '2014-03-15 00:26:01.000000', 'consum', 0.0210, 'lps'),
	(590263, 130, '2014-03-15 00:26:02.000000', 'consum', 0.0211, 'lps'),
	(590264, 130, '2014-03-15 00:26:03.000000', 'consum', 0.0217, 'lps'),
	(590265, 130, '2014-03-15 00:26:04.000000', 'consum', 0.0214, 'lps'),
	(590266, 130, '2014-03-15 00:26:05.000000', 'consum', 0.0223, 'lps'),
	(590267, 130, '2014-03-15 00:26:06.000000', 'consum', 0.0219, 'lps'),
	(590268, 130, '2014-03-15 00:26:07.000000', 'consum', 0.0217, 'lps'),
	(590269, 130, '2014-03-15 00:26:08.000000', 'consum', 0.0220, 'lps'),
	(590270, 130, '2014-03-15 00:26:09.000000', 'consum', 0.0221, 'lps'),
	(590271, 130, '2014-03-15 00:26:10.000000', 'consum', 0.0223, 'lps'),
	(590272, 130, '2014-03-15 00:26:11.000000', 'consum', 0.0211, 'lps'),
	(590273, 130, '2014-03-15 00:26:12.000000', 'consum', 0.0222, 'lps'),
	(590274, 130, '2014-03-15 00:26:13.000000', 'consum', 0.0222, 'lps'),
	(590275, 130, '2014-03-15 00:26:14.000000', 'consum', 0.0222, 'lps'),
	(590276, 130, '2014-03-15 00:26:15.000000', 'consum', 0.0216, 'lps'),
	(590277, 130, '2014-03-15 00:26:16.000000', 'consum', 0.0221, 'lps'),
	(590278, 130, '2014-03-15 00:26:17.000000', 'consum', 0.0215, 'lps'),
	(590279, 130, '2014-03-15 00:26:18.000000', 'consum', 0.0221, 'lps'),
	(590280, 130, '2014-03-15 00:26:19.000000', 'consum', 0.0220, 'lps'),
	(590281, 130, '2014-03-15 00:26:20.000000', 'consum', 0.0210, 'lps'),
	(590282, 130, '2014-03-15 00:26:21.000000', 'consum', 0.0212, 'lps'),
	(590283, 130, '2014-03-15 00:26:22.000000', 'consum', 0.0221, 'lps'),
	(590284, 130, '2014-03-15 00:26:23.000000', 'consum', 0.0214, 'lps'),
	(590285, 130, '2014-03-15 00:26:24.000000', 'consum', 0.0212, 'lps'),
	(590286, 130, '2014-03-15 00:26:25.000000', 'consum', 0.0223, 'lps'),
	(590287, 130, '2014-03-15 00:26:26.000000', 'consum', 0.0224, 'lps'),
	(590288, 130, '2014-03-15 00:26:27.000000', 'consum', 0.0214, 'lps'),
	(590289, 130, '2014-03-15 00:26:28.000000', 'consum', 0.0219, 'lps'),
	(590290, 130, '2014-03-15 00:26:29.000000', 'consum', 0.0213, 'lps'),
	(590291, 130, '2014-03-15 00:26:30.000000', 'consum', 0.0211, 'lps'),
	(590292, 130, '2014-03-15 00:26:31.000000', 'consum', 0.0224, 'lps'),
	(590293, 130, '2014-03-15 00:26:32.000000', 'consum', 0.0219, 'lps'),
	(590294, 130, '2014-03-15 00:26:33.000000', 'consum', 0.0211, 'lps'),
	(590295, 130, '2014-03-15 00:26:34.000000', 'consum', 0.0221, 'lps'),
	(590296, 130, '2014-03-15 00:26:35.000000', 'consum', 0.0215, 'lps'),
	(590297, 130, '2014-03-15 00:26:36.000000', 'consum', 0.0220, 'lps'),
	(590298, 130, '2014-03-15 00:26:37.000000', 'consum', 0.0213, 'lps'),
	(590299, 130, '2014-03-15 00:26:38.000000', 'consum', 0.0212, 'lps'),
	(590300, 130, '2014-03-15 00:26:39.000000', 'consum', 0.0213, 'lps'),
	(590301, 130, '2014-03-15 00:26:40.000000', 'consum', 0.0217, 'lps'),
	(590302, 130, '2014-03-15 00:26:41.000000', 'consum', 0.0220, 'lps'),
	(590303, 130, '2014-03-15 00:26:42.000000', 'consum', 0.0213, 'lps'),
	(590304, 130, '2014-03-15 00:26:43.000000', 'consum', 0.0224, 'lps'),
	(590305, 130, '2014-03-15 00:26:44.000000', 'consum', 0.0211, 'lps'),
	(590306, 130, '2014-03-15 00:26:45.000000', 'consum', 0.0217, 'lps'),
	(590307, 130, '2014-03-15 00:26:46.000000', 'consum', 0.0215, 'lps'),
	(590308, 130, '2014-03-15 00:26:47.000000', 'consum', 0.0214, 'lps'),
	(590309, 130, '2014-03-15 00:26:48.000000', 'consum', 0.0217, 'lps'),
	(590310, 130, '2014-03-15 00:26:49.000000', 'consum', 0.0218, 'lps'),
	(590311, 130, '2014-03-15 00:26:50.000000', 'consum', 0.0213, 'lps'),
	(590312, 130, '2014-03-15 00:26:51.000000', 'consum', 0.0217, 'lps'),
	(590313, 130, '2014-03-15 00:26:52.000000', 'consum', 0.0222, 'lps'),
	(590314, 130, '2014-03-15 00:26:53.000000', 'consum', 0.0220, 'lps'),
	(590315, 130, '2014-03-15 00:26:54.000000', 'consum', 0.0224, 'lps'),
	(590316, 130, '2014-03-15 00:26:55.000000', 'consum', 0.0220, 'lps'),
	(590317, 130, '2014-03-15 00:26:56.000000', 'consum', 0.0219, 'lps'),
	(590318, 130, '2014-03-15 00:26:57.000000', 'consum', 0.0212, 'lps'),
	(590319, 130, '2014-03-15 00:26:58.000000', 'consum', 0.0223, 'lps'),
	(590320, 130, '2014-03-15 00:26:59.000000', 'consum', 0.0211, 'lps'),
	(590321, 130, '2014-03-15 00:27:00.000000', 'consum', 0.0221, 'lps'),
	(590322, 130, '2014-03-15 00:27:01.000000', 'consum', 0.0216, 'lps'),
	(590323, 130, '2014-03-15 00:27:02.000000', 'consum', 0.0224, 'lps'),
	(590324, 130, '2014-03-15 00:27:03.000000', 'consum', 0.0215, 'lps'),
	(590325, 130, '2014-03-15 00:27:04.000000', 'consum', 0.0210, 'lps'),
	(590326, 130, '2014-03-15 00:27:05.000000', 'consum', 0.0224, 'lps'),
	(590327, 130, '2014-03-15 00:27:06.000000', 'consum', 0.0222, 'lps'),
	(590328, 130, '2014-03-15 00:27:07.000000', 'consum', 0.0214, 'lps'),
	(590329, 130, '2014-03-15 00:27:08.000000', 'consum', 0.0211, 'lps'),
	(590330, 130, '2014-03-15 00:27:09.000000', 'consum', 0.0215, 'lps'),
	(590331, 130, '2014-03-15 00:27:10.000000', 'consum', 0.0221, 'lps'),
	(590332, 130, '2014-03-15 00:27:11.000000', 'consum', 0.0217, 'lps'),
	(590333, 130, '2014-03-15 00:27:12.000000', 'consum', 0.0214, 'lps'),
	(590334, 130, '2014-03-15 00:27:13.000000', 'consum', 0.0224, 'lps'),
	(590335, 130, '2014-03-15 00:27:14.000000', 'consum', 0.0211, 'lps'),
	(590336, 130, '2014-03-15 00:27:15.000000', 'consum', 0.0217, 'lps'),
	(590337, 130, '2014-03-15 00:27:16.000000', 'consum', 0.0211, 'lps'),
	(590338, 130, '2014-03-15 00:27:17.000000', 'consum', 0.0212, 'lps'),
	(590339, 130, '2014-03-15 00:27:18.000000', 'consum', 0.0218, 'lps'),
	(590340, 130, '2014-03-15 00:27:19.000000', 'consum', 0.0212, 'lps'),
	(590341, 130, '2014-03-15 00:27:20.000000', 'consum', 0.0214, 'lps'),
	(590342, 130, '2014-03-15 00:27:21.000000', 'consum', 0.0210, 'lps'),
	(590343, 130, '2014-03-15 00:27:22.000000', 'consum', 0.0211, 'lps'),
	(590344, 130, '2014-03-15 00:27:23.000000', 'consum', 0.0218, 'lps'),
	(590345, 130, '2014-03-15 00:27:24.000000', 'consum', 0.0217, 'lps'),
	(590346, 130, '2014-03-15 00:27:25.000000', 'consum', 0.0223, 'lps'),
	(590347, 130, '2014-03-15 00:27:26.000000', 'consum', 0.0221, 'lps'),
	(590348, 130, '2014-03-15 00:27:27.000000', 'consum', 0.0214, 'lps'),
	(590349, 130, '2014-03-15 00:27:28.000000', 'consum', 0.0212, 'lps'),
	(590350, 130, '2014-03-15 00:27:29.000000', 'consum', 0.0223, 'lps'),
	(590351, 130, '2014-03-15 00:27:30.000000', 'consum', 0.0224, 'lps'),
	(590352, 130, '2014-03-15 00:27:31.000000', 'consum', 0.0214, 'lps'),
	(590353, 130, '2014-03-15 00:27:32.000000', 'consum', 0.0217, 'lps'),
	(590354, 130, '2014-03-15 00:27:33.000000', 'consum', 0.0220, 'lps'),
	(590355, 130, '2014-03-15 00:27:34.000000', 'consum', 0.0223, 'lps'),
	(590356, 130, '2014-03-15 00:27:35.000000', 'consum', 0.0216, 'lps'),
	(590357, 130, '2014-03-15 00:27:36.000000', 'consum', 0.0216, 'lps'),
	(590358, 130, '2014-03-15 00:27:37.000000', 'consum', 0.0223, 'lps'),
	(590359, 130, '2014-03-15 00:27:38.000000', 'consum', 0.0211, 'lps'),
	(590360, 130, '2014-03-15 00:27:39.000000', 'consum', 0.0224, 'lps'),
	(590361, 130, '2014-03-15 00:27:40.000000', 'consum', 0.0218, 'lps'),
	(590362, 130, '2014-03-15 00:27:41.000000', 'consum', 0.0221, 'lps'),
	(590363, 130, '2014-03-15 00:27:42.000000', 'consum', 0.0212, 'lps'),
	(590364, 130, '2014-03-15 00:27:43.000000', 'consum', 0.0216, 'lps'),
	(590365, 130, '2014-03-15 00:27:44.000000', 'consum', 0.0222, 'lps'),
	(590366, 130, '2014-03-15 00:27:45.000000', 'consum', 0.0222, 'lps'),
	(590367, 130, '2014-03-15 00:27:46.000000', 'consum', 0.0217, 'lps'),
	(590368, 130, '2014-03-15 00:27:47.000000', 'consum', 0.0213, 'lps'),
	(590369, 130, '2014-03-15 00:27:48.000000', 'consum', 0.0218, 'lps'),
	(590370, 130, '2014-03-15 00:27:49.000000', 'consum', 0.0211, 'lps'),
	(590371, 130, '2014-03-15 00:27:50.000000', 'consum', 0.0223, 'lps'),
	(590372, 130, '2014-03-15 00:27:51.000000', 'consum', 0.0211, 'lps'),
	(590373, 130, '2014-03-15 00:27:52.000000', 'consum', 0.0221, 'lps'),
	(590374, 130, '2014-03-15 00:27:53.000000', 'consum', 0.0217, 'lps'),
	(590375, 130, '2014-03-15 00:27:54.000000', 'consum', 0.0214, 'lps'),
	(590376, 130, '2014-03-15 00:27:55.000000', 'consum', 0.0224, 'lps'),
	(590377, 130, '2014-03-15 00:27:56.000000', 'consum', 0.0223, 'lps'),
	(590378, 130, '2014-03-15 00:27:57.000000', 'consum', 0.0220, 'lps'),
	(590379, 130, '2014-03-15 00:27:58.000000', 'consum', 0.0221, 'lps'),
	(590380, 130, '2014-03-15 00:27:59.000000', 'consum', 0.0220, 'lps'),
	(590381, 130, '2014-03-15 00:28:00.000000', 'consum', 0.0212, 'lps'),
	(590382, 130, '2014-03-15 00:28:01.000000', 'consum', 0.0219, 'lps'),
	(590383, 130, '2014-03-15 00:28:02.000000', 'consum', 0.0220, 'lps'),
	(590384, 130, '2014-03-15 00:28:03.000000', 'consum', 0.0221, 'lps'),
	(590385, 130, '2014-03-15 00:28:04.000000', 'consum', 0.0219, 'lps'),
	(590386, 130, '2014-03-15 00:28:05.000000', 'consum', 0.0223, 'lps'),
	(590387, 130, '2014-03-15 00:28:06.000000', 'consum', 0.0218, 'lps'),
	(590388, 130, '2014-03-15 00:28:07.000000', 'consum', 0.0212, 'lps'),
	(590389, 130, '2014-03-15 00:28:08.000000', 'consum', 0.0210, 'lps'),
	(590390, 130, '2014-03-15 00:28:09.000000', 'consum', 0.0220, 'lps'),
	(590391, 130, '2014-03-15 00:28:10.000000', 'consum', 0.0216, 'lps'),
	(590392, 130, '2014-03-15 00:28:11.000000', 'consum', 0.0210, 'lps'),
	(590393, 130, '2014-03-15 00:28:12.000000', 'consum', 0.0221, 'lps'),
	(590394, 130, '2014-03-15 00:28:13.000000', 'consum', 0.0224, 'lps'),
	(590395, 130, '2014-03-15 00:28:14.000000', 'consum', 0.0215, 'lps'),
	(590396, 130, '2014-03-15 00:28:15.000000', 'consum', 0.0210, 'lps'),
	(590397, 130, '2014-03-15 00:28:16.000000', 'consum', 0.0210, 'lps'),
	(590398, 130, '2014-03-15 00:28:17.000000', 'consum', 0.0224, 'lps'),
	(590399, 130, '2014-03-15 00:28:18.000000', 'consum', 0.0220, 'lps'),
	(590400, 130, '2014-03-15 00:28:19.000000', 'consum', 0.0222, 'lps'),
	(590401, 130, '2014-03-15 00:28:20.000000', 'consum', 0.0222, 'lps'),
	(590402, 130, '2014-03-15 00:28:21.000000', 'consum', 0.0221, 'lps'),
	(590403, 130, '2014-03-15 00:28:22.000000', 'consum', 0.0214, 'lps'),
	(590404, 130, '2014-03-15 00:28:23.000000', 'consum', 0.0214, 'lps'),
	(590405, 130, '2014-03-15 00:28:24.000000', 'consum', 0.0219, 'lps'),
	(590406, 130, '2014-03-15 00:28:25.000000', 'consum', 0.0211, 'lps'),
	(590407, 130, '2014-03-15 00:28:26.000000', 'consum', 0.0218, 'lps'),
	(590408, 130, '2014-03-15 00:28:27.000000', 'consum', 0.0221, 'lps'),
	(590409, 130, '2014-03-15 00:28:28.000000', 'consum', 0.0223, 'lps'),
	(590410, 130, '2014-03-15 00:28:29.000000', 'consum', 0.0215, 'lps'),
	(590411, 130, '2014-03-15 00:28:30.000000', 'consum', 0.0211, 'lps'),
	(590412, 130, '2014-03-15 00:28:31.000000', 'consum', 0.0215, 'lps'),
	(590413, 130, '2014-03-15 00:28:32.000000', 'consum', 0.0217, 'lps'),
	(590414, 130, '2014-03-15 00:28:33.000000', 'consum', 0.0217, 'lps'),
	(590415, 130, '2014-03-15 00:28:34.000000', 'consum', 0.0211, 'lps'),
	(590416, 130, '2014-03-15 00:28:35.000000', 'consum', 0.0223, 'lps'),
	(590417, 130, '2014-03-15 00:28:36.000000', 'consum', 0.0211, 'lps'),
	(590418, 130, '2014-03-15 00:28:37.000000', 'consum', 0.0221, 'lps'),
	(590419, 130, '2014-03-15 00:28:38.000000', 'consum', 0.0219, 'lps'),
	(590420, 130, '2014-03-15 00:28:39.000000', 'consum', 0.0223, 'lps'),
	(590421, 130, '2014-03-15 00:28:40.000000', 'consum', 0.0217, 'lps'),
	(590422, 130, '2014-03-15 00:28:41.000000', 'consum', 0.0221, 'lps'),
	(590423, 130, '2014-03-15 00:28:42.000000', 'consum', 0.0214, 'lps'),
	(590424, 130, '2014-03-15 00:28:43.000000', 'consum', 0.0214, 'lps'),
	(590425, 130, '2014-03-15 00:28:44.000000', 'consum', 0.0216, 'lps'),
	(590426, 130, '2014-03-15 00:28:45.000000', 'consum', 0.0216, 'lps'),
	(590427, 130, '2014-03-15 00:28:46.000000', 'consum', 0.0222, 'lps'),
	(590428, 130, '2014-03-15 00:28:47.000000', 'consum', 0.0223, 'lps'),
	(590429, 130, '2014-03-15 00:28:48.000000', 'consum', 0.0224, 'lps'),
	(590430, 130, '2014-03-15 00:28:49.000000', 'consum', 0.0211, 'lps'),
	(590431, 130, '2014-03-15 00:28:50.000000', 'consum', 0.0218, 'lps'),
	(590432, 130, '2014-03-15 00:28:51.000000', 'consum', 0.0217, 'lps'),
	(590433, 130, '2014-03-15 00:28:52.000000', 'consum', 0.0223, 'lps'),
	(590434, 130, '2014-03-15 00:28:53.000000', 'consum', 0.0211, 'lps'),
	(590435, 130, '2014-03-15 00:28:54.000000', 'consum', 0.0218, 'lps'),
	(590436, 130, '2014-03-15 00:28:55.000000', 'consum', 0.0219, 'lps'),
	(590437, 130, '2014-03-15 00:28:56.000000', 'consum', 0.0218, 'lps'),
	(590438, 130, '2014-03-15 00:28:57.000000', 'consum', 0.0223, 'lps'),
	(590439, 130, '2014-03-15 00:28:58.000000', 'consum', 0.0221, 'lps'),
	(590440, 130, '2014-03-15 00:28:59.000000', 'consum', 0.0213, 'lps'),
	(590441, 130, '2014-03-15 00:29:00.000000', 'consum', 0.0221, 'lps'),
	(590442, 130, '2014-03-15 00:29:01.000000', 'consum', 0.0210, 'lps'),
	(590443, 130, '2014-03-15 00:29:02.000000', 'consum', 0.0211, 'lps'),
	(590444, 130, '2014-03-15 00:29:03.000000', 'consum', 0.0212, 'lps'),
	(590445, 130, '2014-03-15 00:29:04.000000', 'consum', 0.0220, 'lps'),
	(590446, 130, '2014-03-15 00:29:05.000000', 'consum', 0.0222, 'lps'),
	(590447, 130, '2014-03-15 00:29:06.000000', 'consum', 0.0213, 'lps'),
	(590448, 130, '2014-03-15 00:29:07.000000', 'consum', 0.0220, 'lps'),
	(590449, 130, '2014-03-15 00:29:08.000000', 'consum', 0.0222, 'lps'),
	(590450, 130, '2014-03-15 00:29:09.000000', 'consum', 0.0211, 'lps'),
	(590451, 130, '2014-03-15 00:29:10.000000', 'consum', 0.0210, 'lps'),
	(590452, 130, '2014-03-15 00:29:11.000000', 'consum', 0.0221, 'lps'),
	(590453, 130, '2014-03-15 00:29:12.000000', 'consum', 0.0220, 'lps'),
	(590454, 130, '2014-03-15 00:29:13.000000', 'consum', 0.0213, 'lps'),
	(590455, 130, '2014-03-15 00:29:14.000000', 'consum', 0.0212, 'lps'),
	(590456, 130, '2014-03-15 00:29:15.000000', 'consum', 0.0210, 'lps'),
	(590457, 130, '2014-03-15 00:29:16.000000', 'consum', 0.0221, 'lps'),
	(590458, 130, '2014-03-15 00:29:17.000000', 'consum', 0.0218, 'lps'),
	(590459, 130, '2014-03-15 00:29:18.000000', 'consum', 0.0218, 'lps'),
	(590460, 130, '2014-03-15 00:29:19.000000', 'consum', 0.0213, 'lps'),
	(590461, 130, '2014-03-15 00:29:20.000000', 'consum', 0.0217, 'lps'),
	(590462, 130, '2014-03-15 00:29:21.000000', 'consum', 0.0221, 'lps'),
	(590463, 130, '2014-03-15 00:29:22.000000', 'consum', 0.0213, 'lps'),
	(590464, 130, '2014-03-15 00:29:23.000000', 'consum', 0.0223, 'lps'),
	(590465, 130, '2014-03-15 00:29:24.000000', 'consum', 0.0223, 'lps'),
	(590466, 130, '2014-03-15 00:29:25.000000', 'consum', 0.0220, 'lps'),
	(590467, 130, '2014-03-15 00:29:26.000000', 'consum', 0.0220, 'lps'),
	(590468, 130, '2014-03-15 00:29:27.000000', 'consum', 0.0217, 'lps'),
	(590469, 130, '2014-03-15 00:29:28.000000', 'consum', 0.0217, 'lps'),
	(590470, 130, '2014-03-15 00:29:29.000000', 'consum', 0.0222, 'lps'),
	(590471, 130, '2014-03-15 00:29:30.000000', 'consum', 0.0222, 'lps'),
	(590472, 130, '2014-03-15 00:29:31.000000', 'consum', 0.0218, 'lps'),
	(590473, 130, '2014-03-15 00:29:32.000000', 'consum', 0.0215, 'lps'),
	(590474, 130, '2014-03-15 00:29:33.000000', 'consum', 0.0212, 'lps'),
	(590475, 130, '2014-03-15 00:29:34.000000', 'consum', 0.0222, 'lps'),
	(590476, 130, '2014-03-15 00:29:35.000000', 'consum', 0.0218, 'lps'),
	(590477, 130, '2014-03-15 00:29:36.000000', 'consum', 0.0214, 'lps'),
	(590478, 130, '2014-03-15 00:29:37.000000', 'consum', 0.0220, 'lps'),
	(590479, 130, '2014-03-15 00:29:38.000000', 'consum', 0.0221, 'lps'),
	(590480, 130, '2014-03-15 00:29:39.000000', 'consum', 0.0219, 'lps'),
	(590481, 130, '2014-03-15 00:29:40.000000', 'consum', 0.0224, 'lps'),
	(590482, 130, '2014-03-15 00:29:41.000000', 'consum', 0.0222, 'lps'),
	(590483, 130, '2014-03-15 00:29:42.000000', 'consum', 0.0212, 'lps'),
	(590484, 130, '2014-03-15 00:29:43.000000', 'consum', 0.0217, 'lps'),
	(590485, 130, '2014-03-15 00:29:44.000000', 'consum', 0.0224, 'lps'),
	(590486, 130, '2014-03-15 00:29:45.000000', 'consum', 0.0214, 'lps'),
	(590487, 130, '2014-03-15 00:29:46.000000', 'consum', 0.0217, 'lps'),
	(590488, 130, '2014-03-15 00:29:47.000000', 'consum', 0.0220, 'lps'),
	(590489, 130, '2014-03-15 00:29:48.000000', 'consum', 0.0223, 'lps'),
	(590490, 130, '2014-03-15 00:29:49.000000', 'consum', 0.0216, 'lps'),
	(590491, 130, '2014-03-15 00:29:50.000000', 'consum', 0.0216, 'lps'),
	(590492, 130, '2014-03-15 00:29:51.000000', 'consum', 0.0224, 'lps'),
	(590493, 130, '2014-03-15 00:29:52.000000', 'consum', 0.0217, 'lps'),
	(590494, 130, '2014-03-15 00:29:53.000000', 'consum', 0.0218, 'lps'),
	(590495, 130, '2014-03-15 00:29:54.000000', 'consum', 0.0217, 'lps'),
	(590496, 130, '2014-03-15 00:29:55.000000', 'consum', 0.0219, 'lps'),
	(590497, 130, '2014-03-15 00:29:56.000000', 'consum', 0.0220, 'lps'),
	(590498, 130, '2014-03-15 00:29:57.000000', 'consum', 0.0217, 'lps'),
	(590499, 130, '2014-03-15 00:29:58.000000', 'consum', 0.0216, 'lps'),
	(590500, 130, '2014-03-15 00:29:59.000000', 'consum', 0.0221, 'lps'),
	(590501, 130, '2014-03-15 00:30:00.000000', 'consum', 0.0215, 'lps'),
	(590502, 130, '2014-03-15 00:30:01.000000', 'consum', 0.0220, 'lps'),
	(590503, 130, '2014-03-15 00:30:02.000000', 'consum', 0.0214, 'lps'),
	(590504, 130, '2014-03-15 00:30:03.000000', 'consum', 0.0216, 'lps'),
	(590505, 130, '2014-03-15 00:30:04.000000', 'consum', 0.0212, 'lps'),
	(590506, 130, '2014-03-15 00:30:05.000000', 'consum', 0.0219, 'lps'),
	(590507, 130, '2014-03-15 00:30:06.000000', 'consum', 0.0219, 'lps'),
	(590508, 130, '2014-03-15 00:30:07.000000', 'consum', 0.0215, 'lps'),
	(590509, 130, '2014-03-15 00:30:08.000000', 'consum', 0.0224, 'lps'),
	(590510, 130, '2014-03-15 00:30:09.000000', 'consum', 0.0219, 'lps'),
	(590511, 130, '2014-03-15 00:30:10.000000', 'consum', 0.0216, 'lps'),
	(590512, 130, '2014-03-15 00:30:11.000000', 'consum', 0.0210, 'lps'),
	(590513, 130, '2014-03-15 00:30:12.000000', 'consum', 0.0224, 'lps'),
	(590514, 130, '2014-03-15 00:30:13.000000', 'consum', 0.0220, 'lps'),
	(590515, 130, '2014-03-15 00:30:14.000000', 'consum', 0.0219, 'lps'),
	(590516, 130, '2014-03-15 00:30:15.000000', 'consum', 0.0224, 'lps'),
	(590517, 130, '2014-03-15 00:30:16.000000', 'consum', 0.0211, 'lps'),
	(590518, 130, '2014-03-15 00:30:17.000000', 'consum', 0.0216, 'lps'),
	(590519, 130, '2014-03-15 00:30:18.000000', 'consum', 0.0223, 'lps'),
	(590520, 130, '2014-03-15 00:30:19.000000', 'consum', 0.0213, 'lps'),
	(590521, 130, '2014-03-15 00:30:20.000000', 'consum', 0.0216, 'lps'),
	(590522, 130, '2014-03-15 00:30:21.000000', 'consum', 0.0219, 'lps'),
	(590523, 130, '2014-03-15 00:30:22.000000', 'consum', 0.0220, 'lps'),
	(590524, 130, '2014-03-15 00:30:23.000000', 'consum', 0.0219, 'lps'),
	(590525, 130, '2014-03-15 00:30:24.000000', 'consum', 0.0211, 'lps'),
	(590526, 130, '2014-03-15 00:30:25.000000', 'consum', 0.0218, 'lps'),
	(590527, 130, '2014-03-15 00:30:26.000000', 'consum', 0.0217, 'lps'),
	(590528, 130, '2014-03-15 00:30:27.000000', 'consum', 0.0220, 'lps'),
	(590529, 130, '2014-03-15 00:30:28.000000', 'consum', 0.0210, 'lps'),
	(590530, 130, '2014-03-15 00:30:29.000000', 'consum', 0.0212, 'lps'),
	(590531, 130, '2014-03-15 00:30:30.000000', 'consum', 0.0221, 'lps'),
	(590532, 130, '2014-03-15 00:30:31.000000', 'consum', 0.0213, 'lps'),
	(590533, 130, '2014-03-15 00:30:32.000000', 'consum', 0.0210, 'lps'),
	(590534, 130, '2014-03-15 00:30:33.000000', 'consum', 0.0213, 'lps'),
	(590535, 130, '2014-03-15 00:30:34.000000', 'consum', 0.0214, 'lps'),
	(590536, 130, '2014-03-15 00:30:35.000000', 'consum', 0.0220, 'lps'),
	(590537, 130, '2014-03-15 00:30:36.000000', 'consum', 0.0220, 'lps'),
	(590538, 130, '2014-03-15 00:30:37.000000', 'consum', 0.0216, 'lps'),
	(590539, 130, '2014-03-15 00:30:38.000000', 'consum', 0.0223, 'lps'),
	(590540, 130, '2014-03-15 00:30:39.000000', 'consum', 0.0214, 'lps'),
	(590541, 130, '2014-03-15 00:30:40.000000', 'consum', 0.0222, 'lps'),
	(590542, 130, '2014-03-15 00:30:41.000000', 'consum', 0.0211, 'lps'),
	(590543, 130, '2014-03-15 00:30:42.000000', 'consum', 0.0212, 'lps'),
	(590544, 130, '2014-03-15 00:30:43.000000', 'consum', 0.0218, 'lps'),
	(590545, 130, '2014-03-15 00:30:44.000000', 'consum', 0.0213, 'lps'),
	(590546, 130, '2014-03-15 00:30:45.000000', 'consum', 0.0217, 'lps'),
	(590547, 130, '2014-03-15 00:30:46.000000', 'consum', 0.0220, 'lps'),
	(590548, 130, '2014-03-15 00:30:47.000000', 'consum', 0.0210, 'lps'),
	(590549, 130, '2014-03-15 00:30:48.000000', 'consum', 0.0211, 'lps'),
	(590550, 130, '2014-03-15 00:30:49.000000', 'consum', 0.0217, 'lps'),
	(590551, 130, '2014-03-15 00:30:50.000000', 'consum', 0.0213, 'lps'),
	(590552, 130, '2014-03-15 00:30:51.000000', 'consum', 0.0218, 'lps'),
	(590553, 130, '2014-03-15 00:30:52.000000', 'consum', 0.0213, 'lps'),
	(590554, 130, '2014-03-15 00:30:53.000000', 'consum', 0.0215, 'lps'),
	(590555, 130, '2014-03-15 00:30:54.000000', 'consum', 0.0211, 'lps'),
	(590556, 130, '2014-03-15 00:30:55.000000', 'consum', 0.0215, 'lps'),
	(590557, 130, '2014-03-15 00:30:56.000000', 'consum', 0.0220, 'lps'),
	(590558, 130, '2014-03-15 00:30:57.000000', 'consum', 0.0213, 'lps'),
	(590559, 130, '2014-03-15 00:30:58.000000', 'consum', 0.0210, 'lps'),
	(590560, 130, '2014-03-15 00:30:59.000000', 'consum', 0.0216, 'lps'),
	(590561, 130, '2014-03-15 00:31:00.000000', 'consum', 0.0212, 'lps'),
	(590562, 130, '2014-03-15 00:31:01.000000', 'consum', 0.0216, 'lps'),
	(590563, 130, '2014-03-15 00:31:02.000000', 'consum', 0.0221, 'lps'),
	(590564, 130, '2014-03-15 00:31:03.000000', 'consum', 0.0215, 'lps'),
	(590565, 130, '2014-03-15 00:31:04.000000', 'consum', 0.0219, 'lps'),
	(590566, 130, '2014-03-15 00:31:05.000000', 'consum', 0.0210, 'lps'),
	(590567, 130, '2014-03-15 00:31:06.000000', 'consum', 0.0215, 'lps'),
	(590568, 130, '2014-03-15 00:31:07.000000', 'consum', 0.0221, 'lps'),
	(590569, 130, '2014-03-15 00:31:08.000000', 'consum', 0.0219, 'lps'),
	(590570, 130, '2014-03-15 00:31:09.000000', 'consum', 0.0210, 'lps'),
	(590571, 130, '2014-03-15 00:31:10.000000', 'consum', 0.0212, 'lps'),
	(590572, 130, '2014-03-15 00:31:11.000000', 'consum', 0.0220, 'lps'),
	(590573, 130, '2014-03-15 00:31:12.000000', 'consum', 0.0224, 'lps'),
	(590574, 130, '2014-03-15 00:31:13.000000', 'consum', 0.0222, 'lps'),
	(590575, 130, '2014-03-15 00:31:14.000000', 'consum', 0.0211, 'lps'),
	(590576, 130, '2014-03-15 00:31:15.000000', 'consum', 0.0212, 'lps'),
	(590577, 130, '2014-03-15 00:31:16.000000', 'consum', 0.0218, 'lps'),
	(590578, 130, '2014-03-15 00:31:17.000000', 'consum', 0.0212, 'lps'),
	(590579, 130, '2014-03-15 00:31:18.000000', 'consum', 0.0214, 'lps'),
	(590580, 130, '2014-03-15 00:31:19.000000', 'consum', 0.0210, 'lps'),
	(590581, 130, '2014-03-15 00:31:20.000000', 'consum', 0.0213, 'lps'),
	(590582, 130, '2014-03-15 00:31:21.000000', 'consum', 0.0224, 'lps'),
	(590583, 130, '2014-03-15 00:31:22.000000', 'consum', 0.0210, 'lps'),
	(590584, 130, '2014-03-15 00:31:23.000000', 'consum', 0.0217, 'lps'),
	(590585, 130, '2014-03-15 00:31:24.000000', 'consum', 0.0214, 'lps'),
	(590586, 130, '2014-03-15 00:31:25.000000', 'consum', 0.0211, 'lps'),
	(590587, 130, '2014-03-15 00:31:26.000000', 'consum', 0.0217, 'lps'),
	(590588, 130, '2014-03-15 00:31:27.000000', 'consum', 0.0213, 'lps'),
	(590589, 130, '2014-03-15 00:31:28.000000', 'consum', 0.0218, 'lps'),
	(590590, 130, '2014-03-15 00:31:29.000000', 'consum', 0.0213, 'lps'),
	(590591, 130, '2014-03-15 00:31:30.000000', 'consum', 0.0218, 'lps'),
	(590592, 130, '2014-03-15 00:31:31.000000', 'consum', 0.0210, 'lps'),
	(590593, 130, '2014-03-15 00:31:32.000000', 'consum', 0.0215, 'lps'),
	(590594, 130, '2014-03-15 00:31:33.000000', 'consum', 0.0221, 'lps'),
	(590595, 130, '2014-03-15 00:31:34.000000', 'consum', 0.0219, 'lps'),
	(590596, 130, '2014-03-15 00:31:35.000000', 'consum', 0.0224, 'lps'),
	(590597, 130, '2014-03-15 00:31:36.000000', 'consum', 0.0223, 'lps'),
	(590598, 130, '2014-03-15 00:31:37.000000', 'consum', 0.0219, 'lps'),
	(590599, 130, '2014-03-15 00:31:38.000000', 'consum', 0.0218, 'lps'),
	(590600, 130, '2014-03-15 00:31:39.000000', 'consum', 0.0223, 'lps'),
	(590601, 130, '2014-03-15 00:31:40.000000', 'consum', 0.0220, 'lps'),
	(590602, 130, '2014-03-15 00:31:41.000000', 'consum', 0.0222, 'lps'),
	(590603, 130, '2014-03-15 00:31:42.000000', 'consum', 0.0210, 'lps'),
	(590604, 130, '2014-03-15 00:31:43.000000', 'consum', 0.0221, 'lps'),
	(590605, 130, '2014-03-15 00:31:44.000000', 'consum', 0.0219, 'lps'),
	(590606, 130, '2014-03-15 00:31:45.000000', 'consum', 0.0224, 'lps'),
	(590607, 130, '2014-03-15 00:31:46.000000', 'consum', 0.0222, 'lps'),
	(590608, 130, '2014-03-15 00:31:47.000000', 'consum', 0.0214, 'lps'),
	(590609, 130, '2014-03-15 00:31:48.000000', 'consum', 0.0224, 'lps'),
	(590610, 130, '2014-03-15 00:31:49.000000', 'consum', 0.0210, 'lps'),
	(590611, 130, '2014-03-15 00:31:50.000000', 'consum', 0.0213, 'lps'),
	(590612, 130, '2014-03-15 00:31:51.000000', 'consum', 0.0210, 'lps'),
	(590613, 130, '2014-03-15 00:31:52.000000', 'consum', 0.0217, 'lps'),
	(590614, 130, '2014-03-15 00:31:53.000000', 'consum', 0.0215, 'lps'),
	(590615, 130, '2014-03-15 00:31:54.000000', 'consum', 0.0214, 'lps'),
	(590616, 130, '2014-03-15 00:31:55.000000', 'consum', 0.0216, 'lps'),
	(590617, 130, '2014-03-15 00:31:56.000000', 'consum', 0.0213, 'lps'),
	(590618, 130, '2014-03-15 00:31:57.000000', 'consum', 0.0222, 'lps'),
	(590619, 130, '2014-03-15 00:31:58.000000', 'consum', 0.0217, 'lps'),
	(590620, 130, '2014-03-15 00:31:59.000000', 'consum', 0.0223, 'lps'),
	(590621, 130, '2014-03-15 00:32:00.000000', 'consum', 0.0212, 'lps'),
	(590622, 130, '2014-03-15 00:32:01.000000', 'consum', 0.0212, 'lps'),
	(590623, 130, '2014-03-15 00:32:02.000000', 'consum', 0.0215, 'lps'),
	(590624, 130, '2014-03-15 00:32:03.000000', 'consum', 0.0215, 'lps'),
	(590625, 130, '2014-03-15 00:32:04.000000', 'consum', 0.0221, 'lps'),
	(590626, 130, '2014-03-15 00:32:05.000000', 'consum', 0.0222, 'lps'),
	(590627, 130, '2014-03-15 00:32:06.000000', 'consum', 0.0219, 'lps'),
	(590628, 130, '2014-03-15 00:32:07.000000', 'consum', 0.0219, 'lps'),
	(590629, 130, '2014-03-15 00:32:08.000000', 'consum', 0.0215, 'lps'),
	(590630, 130, '2014-03-15 00:32:09.000000', 'consum', 0.0222, 'lps'),
	(590631, 130, '2014-03-15 00:32:10.000000', 'consum', 0.0211, 'lps'),
	(590632, 130, '2014-03-15 00:32:11.000000', 'consum', 0.0224, 'lps'),
	(590633, 130, '2014-03-15 00:32:12.000000', 'consum', 0.0219, 'lps'),
	(590634, 130, '2014-03-15 00:32:13.000000', 'consum', 0.0212, 'lps'),
	(590635, 130, '2014-03-15 00:32:14.000000', 'consum', 0.0222, 'lps'),
	(590636, 130, '2014-03-15 00:32:15.000000', 'consum', 0.0222, 'lps'),
	(590637, 130, '2014-03-15 00:32:16.000000', 'consum', 0.0220, 'lps'),
	(590638, 130, '2014-03-15 00:32:17.000000', 'consum', 0.0224, 'lps'),
	(590639, 130, '2014-03-15 00:32:18.000000', 'consum', 0.0222, 'lps'),
	(590640, 130, '2014-03-15 00:32:19.000000', 'consum', 0.0211, 'lps'),
	(590641, 130, '2014-03-15 00:32:20.000000', 'consum', 0.0223, 'lps'),
	(590642, 130, '2014-03-15 00:32:21.000000', 'consum', 0.0215, 'lps'),
	(590643, 130, '2014-03-15 00:32:22.000000', 'consum', 0.0212, 'lps'),
	(590644, 130, '2014-03-15 00:32:23.000000', 'consum', 0.0220, 'lps'),
	(590645, 130, '2014-03-15 00:32:24.000000', 'consum', 0.0223, 'lps'),
	(590646, 130, '2014-03-15 00:32:25.000000', 'consum', 0.0215, 'lps'),
	(590647, 130, '2014-03-15 00:32:26.000000', 'consum', 0.0211, 'lps'),
	(590648, 130, '2014-03-15 00:32:27.000000', 'consum', 0.0217, 'lps'),
	(590649, 130, '2014-03-15 00:32:28.000000', 'consum', 0.0214, 'lps'),
	(590650, 130, '2014-03-15 00:32:29.000000', 'consum', 0.0223, 'lps'),
	(590651, 130, '2014-03-15 00:32:30.000000', 'consum', 0.0217, 'lps'),
	(590652, 130, '2014-03-15 00:32:31.000000', 'consum', 0.0223, 'lps'),
	(590653, 130, '2014-03-15 00:32:32.000000', 'consum', 0.0223, 'lps'),
	(590654, 130, '2014-03-15 00:32:33.000000', 'consum', 0.0223, 'lps'),
	(590655, 130, '2014-03-15 00:32:34.000000', 'consum', 0.0222, 'lps'),
	(590656, 130, '2014-03-15 00:32:35.000000', 'consum', 0.0215, 'lps'),
	(590657, 130, '2014-03-15 00:32:36.000000', 'consum', 0.0214, 'lps'),
	(590658, 130, '2014-03-15 00:32:37.000000', 'consum', 0.0216, 'lps'),
	(590659, 130, '2014-03-15 00:32:38.000000', 'consum', 0.0213, 'lps'),
	(590660, 130, '2014-03-15 00:32:39.000000', 'consum', 0.0221, 'lps'),
	(590661, 130, '2014-03-15 00:32:40.000000', 'consum', 0.0215, 'lps'),
	(590662, 130, '2014-03-15 00:32:41.000000', 'consum', 0.0215, 'lps'),
	(590663, 130, '2014-03-15 00:32:42.000000', 'consum', 0.0220, 'lps'),
	(590664, 130, '2014-03-15 00:32:43.000000', 'consum', 0.0217, 'lps'),
	(590665, 130, '2014-03-15 00:32:44.000000', 'consum', 0.0215, 'lps'),
	(590666, 130, '2014-03-15 00:32:45.000000', 'consum', 0.0212, 'lps'),
	(590667, 130, '2014-03-15 00:32:46.000000', 'consum', 0.0224, 'lps'),
	(590668, 130, '2014-03-15 00:32:47.000000', 'consum', 0.0214, 'lps'),
	(590669, 130, '2014-03-15 00:32:48.000000', 'consum', 0.0219, 'lps'),
	(590670, 130, '2014-03-15 00:32:49.000000', 'consum', 0.0215, 'lps'),
	(590671, 130, '2014-03-15 00:32:50.000000', 'consum', 0.0222, 'lps'),
	(590672, 130, '2014-03-15 00:32:51.000000', 'consum', 0.0224, 'lps'),
	(590673, 130, '2014-03-15 00:32:52.000000', 'consum', 0.0216, 'lps'),
	(590674, 130, '2014-03-15 00:32:53.000000', 'consum', 0.0214, 'lps'),
	(590675, 130, '2014-03-15 00:32:54.000000', 'consum', 0.0210, 'lps'),
	(590676, 130, '2014-03-15 00:32:55.000000', 'consum', 0.0216, 'lps'),
	(590677, 130, '2014-03-15 00:32:56.000000', 'consum', 0.0210, 'lps'),
	(590678, 130, '2014-03-15 00:32:57.000000', 'consum', 0.0220, 'lps'),
	(590679, 130, '2014-03-15 00:32:58.000000', 'consum', 0.0219, 'lps'),
	(590680, 130, '2014-03-15 00:32:59.000000', 'consum', 0.0223, 'lps'),
	(590681, 130, '2014-03-15 00:33:00.000000', 'consum', 0.0218, 'lps'),
	(590682, 130, '2014-03-15 00:33:01.000000', 'consum', 0.0214, 'lps'),
	(590683, 130, '2014-03-15 00:33:02.000000', 'consum', 0.0222, 'lps'),
	(590684, 130, '2014-03-15 00:33:03.000000', 'consum', 0.0214, 'lps'),
	(590685, 130, '2014-03-15 00:33:04.000000', 'consum', 0.0223, 'lps'),
	(590686, 130, '2014-03-15 00:33:05.000000', 'consum', 0.0221, 'lps'),
	(590687, 130, '2014-03-15 00:33:06.000000', 'consum', 0.0224, 'lps'),
	(590688, 130, '2014-03-15 00:33:07.000000', 'consum', 0.0218, 'lps'),
	(590689, 130, '2014-03-15 00:33:08.000000', 'consum', 0.0210, 'lps'),
	(590690, 130, '2014-03-15 00:33:09.000000', 'consum', 0.0218, 'lps'),
	(590691, 130, '2014-03-15 00:33:10.000000', 'consum', 0.0217, 'lps'),
	(590692, 130, '2014-03-15 00:33:11.000000', 'consum', 0.0224, 'lps'),
	(590693, 130, '2014-03-15 00:33:12.000000', 'consum', 0.0212, 'lps'),
	(590694, 130, '2014-03-15 00:33:13.000000', 'consum', 0.0210, 'lps'),
	(590695, 130, '2014-03-15 00:33:14.000000', 'consum', 0.0219, 'lps'),
	(590696, 130, '2014-03-15 00:33:15.000000', 'consum', 0.0224, 'lps'),
	(590697, 130, '2014-03-15 00:33:16.000000', 'consum', 0.0211, 'lps'),
	(590698, 130, '2014-03-15 00:33:17.000000', 'consum', 0.0219, 'lps'),
	(590699, 130, '2014-03-15 00:33:18.000000', 'consum', 0.0221, 'lps'),
	(590700, 130, '2014-03-15 00:33:19.000000', 'consum', 0.0222, 'lps'),
	(590701, 130, '2014-03-15 00:33:20.000000', 'consum', 0.0223, 'lps'),
	(590702, 130, '2014-03-15 00:33:21.000000', 'consum', 0.0223, 'lps'),
	(590703, 130, '2014-03-15 00:33:22.000000', 'consum', 0.0224, 'lps'),
	(590704, 130, '2014-03-15 00:33:23.000000', 'consum', 0.0211, 'lps'),
	(590705, 130, '2014-03-15 00:33:24.000000', 'consum', 0.0219, 'lps'),
	(590706, 130, '2014-03-15 00:33:25.000000', 'consum', 0.0222, 'lps'),
	(590707, 130, '2014-03-15 00:33:26.000000', 'consum', 0.0214, 'lps'),
	(590708, 130, '2014-03-15 00:33:27.000000', 'consum', 0.0211, 'lps'),
	(590709, 130, '2014-03-15 00:33:28.000000', 'consum', 0.0216, 'lps'),
	(590710, 130, '2014-03-15 00:33:29.000000', 'consum', 0.0223, 'lps'),
	(590711, 130, '2014-03-15 00:33:30.000000', 'consum', 0.0212, 'lps'),
	(590712, 130, '2014-03-15 00:33:31.000000', 'consum', 0.0210, 'lps'),
	(590713, 130, '2014-03-15 00:33:32.000000', 'consum', 0.0220, 'lps'),
	(590714, 130, '2014-03-15 00:33:33.000000', 'consum', 0.0218, 'lps'),
	(590715, 130, '2014-03-15 00:33:34.000000', 'consum', 0.0219, 'lps'),
	(590716, 130, '2014-03-15 00:33:35.000000', 'consum', 0.0215, 'lps'),
	(590717, 130, '2014-03-15 00:33:36.000000', 'consum', 0.0211, 'lps'),
	(590718, 130, '2014-03-15 00:33:37.000000', 'consum', 0.0216, 'lps'),
	(590719, 130, '2014-03-15 00:33:38.000000', 'consum', 0.0222, 'lps'),
	(590720, 130, '2014-03-15 00:33:39.000000', 'consum', 0.0223, 'lps'),
	(590721, 130, '2014-03-15 00:33:40.000000', 'consum', 0.0223, 'lps'),
	(590722, 130, '2014-03-15 00:33:41.000000', 'consum', 0.0222, 'lps'),
	(590723, 130, '2014-03-15 00:33:42.000000', 'consum', 0.0216, 'lps'),
	(590724, 130, '2014-03-15 00:33:43.000000', 'consum', 0.0218, 'lps'),
	(590725, 130, '2014-03-15 00:33:44.000000', 'consum', 0.0220, 'lps'),
	(590726, 130, '2014-03-15 00:33:45.000000', 'consum', 0.0221, 'lps'),
	(590727, 130, '2014-03-15 00:33:46.000000', 'consum', 0.0220, 'lps'),
	(590728, 130, '2014-03-15 00:33:47.000000', 'consum', 0.0214, 'lps'),
	(590729, 130, '2014-03-15 00:33:48.000000', 'consum', 0.0216, 'lps'),
	(590730, 130, '2014-03-15 00:33:49.000000', 'consum', 0.0214, 'lps'),
	(590731, 130, '2014-03-15 00:33:50.000000', 'consum', 0.0210, 'lps'),
	(590732, 130, '2014-03-15 00:33:51.000000', 'consum', 0.0216, 'lps'),
	(590733, 130, '2014-03-15 00:33:52.000000', 'consum', 0.0223, 'lps'),
	(590734, 130, '2014-03-15 00:33:53.000000', 'consum', 0.0215, 'lps'),
	(590735, 130, '2014-03-15 00:33:54.000000', 'consum', 0.0211, 'lps'),
	(590736, 130, '2014-03-15 00:33:55.000000', 'consum', 0.0215, 'lps'),
	(590737, 130, '2014-03-15 00:33:56.000000', 'consum', 0.0216, 'lps'),
	(590738, 130, '2014-03-15 00:33:57.000000', 'consum', 0.0213, 'lps'),
	(590739, 130, '2014-03-15 00:33:58.000000', 'consum', 0.0222, 'lps'),
	(590740, 130, '2014-03-15 00:33:59.000000', 'consum', 0.0217, 'lps'),
	(590741, 130, '2014-03-15 00:34:00.000000', 'consum', 0.0223, 'lps'),
	(590742, 130, '2014-03-15 00:34:01.000000', 'consum', 0.0210, 'lps'),
	(590743, 130, '2014-03-15 00:34:02.000000', 'consum', 0.0218, 'lps'),
	(590744, 130, '2014-03-15 00:34:03.000000', 'consum', 0.0219, 'lps'),
	(590745, 130, '2014-03-15 00:34:04.000000', 'consum', 0.0216, 'lps'),
	(590746, 130, '2014-03-15 00:34:05.000000', 'consum', 0.0215, 'lps'),
	(590747, 130, '2014-03-15 00:34:06.000000', 'consum', 0.0216, 'lps'),
	(590748, 130, '2014-03-15 00:34:07.000000', 'consum', 0.0213, 'lps'),
	(590749, 130, '2014-03-15 00:34:08.000000', 'consum', 0.0221, 'lps'),
	(590750, 130, '2014-03-15 00:34:09.000000', 'consum', 0.0210, 'lps'),
	(590751, 130, '2014-03-15 00:34:10.000000', 'consum', 0.0224, 'lps'),
	(590752, 130, '2014-03-15 00:34:11.000000', 'consum', 0.0219, 'lps'),
	(590753, 130, '2014-03-15 00:34:12.000000', 'consum', 0.0215, 'lps'),
	(590754, 130, '2014-03-15 00:34:13.000000', 'consum', 0.0210, 'lps'),
	(590755, 130, '2014-03-15 00:34:14.000000', 'consum', 0.0223, 'lps'),
	(590756, 130, '2014-03-15 00:34:15.000000', 'consum', 0.0218, 'lps'),
	(590757, 130, '2014-03-15 00:34:16.000000', 'consum', 0.0224, 'lps'),
	(590758, 130, '2014-03-15 00:34:17.000000', 'consum', 0.0214, 'lps'),
	(590759, 130, '2014-03-15 00:34:18.000000', 'consum', 0.0218, 'lps'),
	(590760, 130, '2014-03-15 00:34:19.000000', 'consum', 0.0222, 'lps'),
	(590761, 130, '2014-03-15 00:34:20.000000', 'consum', 0.0217, 'lps'),
	(590762, 130, '2014-03-15 00:34:21.000000', 'consum', 0.0223, 'lps'),
	(590763, 130, '2014-03-15 00:34:22.000000', 'consum', 0.0210, 'lps'),
	(590764, 130, '2014-03-15 00:34:23.000000', 'consum', 0.0218, 'lps'),
	(590765, 130, '2014-03-15 00:34:24.000000', 'consum', 0.0221, 'lps'),
	(590766, 130, '2014-03-15 00:34:25.000000', 'consum', 0.0210, 'lps'),
	(590767, 130, '2014-03-15 00:34:26.000000', 'consum', 0.0223, 'lps'),
	(590768, 130, '2014-03-15 00:34:27.000000', 'consum', 0.0217, 'lps'),
	(590769, 130, '2014-03-15 00:34:28.000000', 'consum', 0.0219, 'lps'),
	(590770, 130, '2014-03-15 00:34:29.000000', 'consum', 0.0221, 'lps'),
	(590771, 130, '2014-03-15 00:34:30.000000', 'consum', 0.0223, 'lps'),
	(590772, 130, '2014-03-15 00:34:31.000000', 'consum', 0.0213, 'lps'),
	(590773, 130, '2014-03-15 00:34:32.000000', 'consum', 0.0215, 'lps'),
	(590774, 130, '2014-03-15 00:34:33.000000', 'consum', 0.0214, 'lps'),
	(590775, 130, '2014-03-15 00:34:34.000000', 'consum', 0.0212, 'lps'),
	(590776, 130, '2014-03-15 00:34:35.000000', 'consum', 0.0212, 'lps'),
	(590777, 130, '2014-03-15 00:34:36.000000', 'consum', 0.0213, 'lps'),
	(590778, 130, '2014-03-15 00:34:37.000000', 'consum', 0.0222, 'lps'),
	(590779, 130, '2014-03-15 00:34:38.000000', 'consum', 0.0214, 'lps'),
	(590780, 130, '2014-03-15 00:34:39.000000', 'consum', 0.0210, 'lps'),
	(590781, 130, '2014-03-15 00:34:40.000000', 'consum', 0.0212, 'lps'),
	(590782, 130, '2014-03-15 00:34:41.000000', 'consum', 0.0222, 'lps'),
	(590783, 130, '2014-03-15 00:34:42.000000', 'consum', 0.0219, 'lps'),
	(590784, 130, '2014-03-15 00:34:43.000000', 'consum', 0.0221, 'lps'),
	(590785, 130, '2014-03-15 00:34:44.000000', 'consum', 0.0221, 'lps'),
	(590786, 130, '2014-03-15 00:34:45.000000', 'consum', 0.0220, 'lps'),
	(590787, 130, '2014-03-15 00:34:46.000000', 'consum', 0.0210, 'lps'),
	(590788, 130, '2014-03-15 00:34:47.000000', 'consum', 0.0224, 'lps'),
	(590789, 130, '2014-03-15 00:34:48.000000', 'consum', 0.0224, 'lps'),
	(590790, 130, '2014-03-15 00:34:49.000000', 'consum', 0.0224, 'lps'),
	(590791, 130, '2014-03-15 00:34:50.000000', 'consum', 0.0222, 'lps'),
	(590792, 130, '2014-03-15 00:34:51.000000', 'consum', 0.0213, 'lps'),
	(590793, 130, '2014-03-15 00:34:52.000000', 'consum', 0.0222, 'lps'),
	(590794, 130, '2014-03-15 00:34:53.000000', 'consum', 0.0214, 'lps'),
	(590795, 130, '2014-03-15 00:34:54.000000', 'consum', 0.0212, 'lps'),
	(590796, 130, '2014-03-15 00:34:55.000000', 'consum', 0.0222, 'lps'),
	(590797, 130, '2014-03-15 00:34:56.000000', 'consum', 0.0221, 'lps'),
	(590798, 130, '2014-03-15 00:34:57.000000', 'consum', 0.0214, 'lps'),
	(590799, 130, '2014-03-15 00:34:58.000000', 'consum', 0.0212, 'lps'),
	(590800, 130, '2014-03-15 00:34:59.000000', 'consum', 0.0223, 'lps'),
	(590801, 130, '2014-03-15 00:35:00.000000', 'consum', 0.0212, 'lps'),
	(590802, 130, '2014-03-15 00:35:01.000000', 'consum', 0.0223, 'lps'),
	(590803, 130, '2014-03-15 00:35:02.000000', 'consum', 0.0211, 'lps'),
	(590804, 130, '2014-03-15 00:35:03.000000', 'consum', 0.0221, 'lps'),
	(590805, 130, '2014-03-15 00:35:04.000000', 'consum', 0.0218, 'lps'),
	(590806, 130, '2014-03-15 00:35:05.000000', 'consum', 0.0218, 'lps'),
	(590807, 130, '2014-03-15 00:35:06.000000', 'consum', 0.0213, 'lps'),
	(590808, 130, '2014-03-15 00:35:07.000000', 'consum', 0.0216, 'lps'),
	(590809, 130, '2014-03-15 00:35:08.000000', 'consum', 0.0214, 'lps'),
	(590810, 130, '2014-03-15 00:35:09.000000', 'consum', 0.0215, 'lps'),
	(590811, 130, '2014-03-15 00:35:10.000000', 'consum', 0.0222, 'lps'),
	(590812, 130, '2014-03-15 00:35:11.000000', 'consum', 0.0210, 'lps'),
	(590813, 130, '2014-03-15 00:35:12.000000', 'consum', 0.0221, 'lps'),
	(590814, 130, '2014-03-15 00:35:13.000000', 'consum', 0.0221, 'lps'),
	(590815, 130, '2014-03-15 00:35:14.000000', 'consum', 0.0216, 'lps'),
	(590816, 130, '2014-03-15 00:35:15.000000', 'consum', 0.0221, 'lps'),
	(590817, 130, '2014-03-15 00:35:16.000000', 'consum', 0.0221, 'lps'),
	(590818, 130, '2014-03-15 00:35:17.000000', 'consum', 0.0214, 'lps'),
	(590819, 130, '2014-03-15 00:35:18.000000', 'consum', 0.0214, 'lps'),
	(590820, 130, '2014-03-15 00:35:19.000000', 'consum', 0.0219, 'lps'),
	(590821, 130, '2014-03-15 00:35:20.000000', 'consum', 0.0214, 'lps'),
	(590822, 130, '2014-03-15 00:35:21.000000', 'consum', 0.0219, 'lps'),
	(590823, 130, '2014-03-15 00:35:22.000000', 'consum', 0.0214, 'lps'),
	(590824, 130, '2014-03-15 00:35:23.000000', 'consum', 0.0216, 'lps'),
	(590825, 130, '2014-03-15 00:35:24.000000', 'consum', 0.0216, 'lps'),
	(590826, 130, '2014-03-15 00:35:25.000000', 'consum', 0.0223, 'lps'),
	(590827, 130, '2014-03-15 00:35:26.000000', 'consum', 0.0213, 'lps'),
	(590828, 130, '2014-03-15 00:35:27.000000', 'consum', 0.0216, 'lps'),
	(590829, 130, '2014-03-15 00:35:28.000000', 'consum', 0.0217, 'lps'),
	(590830, 130, '2014-03-15 00:35:29.000000', 'consum', 0.0211, 'lps'),
	(590831, 130, '2014-03-15 00:35:30.000000', 'consum', 0.0211, 'lps'),
	(590832, 130, '2014-03-15 00:35:31.000000', 'consum', 0.0214, 'lps'),
	(590833, 130, '2014-03-15 00:35:32.000000', 'consum', 0.0210, 'lps'),
	(590834, 130, '2014-03-15 00:35:33.000000', 'consum', 0.0214, 'lps'),
	(590835, 130, '2014-03-15 00:35:34.000000', 'consum', 0.0218, 'lps'),
	(590836, 130, '2014-03-15 00:35:35.000000', 'consum', 0.0221, 'lps'),
	(590837, 130, '2014-03-15 00:35:36.000000', 'consum', 0.0211, 'lps'),
	(590838, 130, '2014-03-15 00:35:37.000000', 'consum', 0.0215, 'lps'),
	(590839, 130, '2014-03-15 00:35:38.000000', 'consum', 0.0216, 'lps'),
	(590840, 130, '2014-03-15 00:35:39.000000', 'consum', 0.0224, 'lps'),
	(590841, 130, '2014-03-15 00:35:40.000000', 'consum', 0.0219, 'lps'),
	(590842, 130, '2014-03-15 00:35:41.000000', 'consum', 0.0215, 'lps'),
	(590843, 130, '2014-03-15 00:35:42.000000', 'consum', 0.0222, 'lps'),
	(590844, 130, '2014-03-15 00:35:43.000000', 'consum', 0.0213, 'lps'),
	(590845, 130, '2014-03-15 00:35:44.000000', 'consum', 0.0217, 'lps'),
	(590846, 130, '2014-03-15 00:35:45.000000', 'consum', 0.0223, 'lps'),
	(590847, 130, '2014-03-15 00:35:46.000000', 'consum', 0.0222, 'lps'),
	(590848, 130, '2014-03-15 00:35:47.000000', 'consum', 0.0219, 'lps'),
	(590849, 130, '2014-03-15 00:35:48.000000', 'consum', 0.0218, 'lps'),
	(590850, 130, '2014-03-15 00:35:49.000000', 'consum', 0.0224, 'lps'),
	(590851, 130, '2014-03-15 00:35:50.000000', 'consum', 0.0212, 'lps'),
	(590852, 130, '2014-03-15 00:35:51.000000', 'consum', 0.0210, 'lps'),
	(590853, 130, '2014-03-15 00:35:52.000000', 'consum', 0.0219, 'lps'),
	(590854, 130, '2014-03-15 00:35:53.000000', 'consum', 0.0211, 'lps'),
	(590855, 130, '2014-03-15 00:35:54.000000', 'consum', 0.0218, 'lps'),
	(590856, 130, '2014-03-15 00:35:55.000000', 'consum', 0.0216, 'lps'),
	(590857, 130, '2014-03-15 00:35:56.000000', 'consum', 0.0218, 'lps'),
	(590858, 130, '2014-03-15 00:35:57.000000', 'consum', 0.0217, 'lps'),
	(590859, 130, '2014-03-15 00:35:58.000000', 'consum', 0.0223, 'lps'),
	(590860, 130, '2014-03-15 00:35:59.000000', 'consum', 0.0222, 'lps'),
	(590861, 130, '2014-03-15 00:36:00.000000', 'consum', 0.0218, 'lps'),
	(590862, 130, '2014-03-15 00:36:01.000000', 'consum', 0.0215, 'lps'),
	(590863, 130, '2014-03-15 00:36:02.000000', 'consum', 0.0211, 'lps'),
	(590864, 130, '2014-03-15 00:36:03.000000', 'consum', 0.0214, 'lps'),
	(590865, 130, '2014-03-15 00:36:04.000000', 'consum', 0.0212, 'lps'),
	(590866, 130, '2014-03-15 00:36:05.000000', 'consum', 0.0224, 'lps'),
	(590867, 130, '2014-03-15 00:36:06.000000', 'consum', 0.0216, 'lps'),
	(590868, 130, '2014-03-15 00:36:07.000000', 'consum', 0.0212, 'lps'),
	(590869, 130, '2014-03-15 00:36:08.000000', 'consum', 0.0219, 'lps'),
	(590870, 130, '2014-03-15 00:36:09.000000', 'consum', 0.0219, 'lps'),
	(590871, 130, '2014-03-15 00:36:10.000000', 'consum', 0.0213, 'lps'),
	(590872, 130, '2014-03-15 00:36:11.000000', 'consum', 0.0214, 'lps'),
	(590873, 130, '2014-03-15 00:36:12.000000', 'consum', 0.0221, 'lps'),
	(590874, 130, '2014-03-15 00:36:13.000000', 'consum', 0.0222, 'lps'),
	(590875, 130, '2014-03-15 00:36:14.000000', 'consum', 0.0211, 'lps'),
	(590876, 130, '2014-03-15 00:36:15.000000', 'consum', 0.0222, 'lps'),
	(590877, 130, '2014-03-15 00:36:16.000000', 'consum', 0.0224, 'lps'),
	(590878, 130, '2014-03-15 00:36:17.000000', 'consum', 0.0215, 'lps'),
	(590879, 130, '2014-03-15 00:36:18.000000', 'consum', 0.0224, 'lps'),
	(590880, 130, '2014-03-15 00:36:19.000000', 'consum', 0.0218, 'lps'),
	(590881, 130, '2014-03-15 00:36:20.000000', 'consum', 0.0224, 'lps'),
	(590882, 130, '2014-03-15 00:36:21.000000', 'consum', 0.0211, 'lps'),
	(590883, 130, '2014-03-15 00:36:22.000000', 'consum', 0.0220, 'lps'),
	(590884, 130, '2014-03-15 00:36:23.000000', 'consum', 0.0213, 'lps'),
	(590885, 130, '2014-03-15 00:36:24.000000', 'consum', 0.0210, 'lps'),
	(590886, 130, '2014-03-15 00:36:25.000000', 'consum', 0.0218, 'lps'),
	(590887, 130, '2014-03-15 00:36:26.000000', 'consum', 0.0220, 'lps'),
	(590888, 130, '2014-03-15 00:36:27.000000', 'consum', 0.0219, 'lps'),
	(590889, 130, '2014-03-15 00:36:28.000000', 'consum', 0.0212, 'lps'),
	(590890, 130, '2014-03-15 00:36:29.000000', 'consum', 0.0210, 'lps'),
	(590891, 130, '2014-03-15 00:36:30.000000', 'consum', 0.0220, 'lps'),
	(590892, 130, '2014-03-15 00:36:31.000000', 'consum', 0.0214, 'lps'),
	(590893, 130, '2014-03-15 00:36:32.000000', 'consum', 0.0215, 'lps'),
	(590894, 130, '2014-03-15 00:36:33.000000', 'consum', 0.0222, 'lps'),
	(590895, 130, '2014-03-15 00:36:34.000000', 'consum', 0.0213, 'lps'),
	(590896, 130, '2014-03-15 00:36:35.000000', 'consum', 0.0218, 'lps'),
	(590897, 130, '2014-03-15 00:36:36.000000', 'consum', 0.0210, 'lps'),
	(590898, 130, '2014-03-15 00:36:37.000000', 'consum', 0.0218, 'lps'),
	(590899, 130, '2014-03-15 00:36:38.000000', 'consum', 0.0221, 'lps'),
	(590900, 130, '2014-03-15 00:36:39.000000', 'consum', 0.0211, 'lps'),
	(590901, 130, '2014-03-15 00:36:40.000000', 'consum', 0.0214, 'lps'),
	(590902, 130, '2014-03-15 00:36:41.000000', 'consum', 0.0210, 'lps'),
	(590903, 130, '2014-03-15 00:36:42.000000', 'consum', 0.0214, 'lps'),
	(590904, 130, '2014-03-15 00:36:43.000000', 'consum', 0.0214, 'lps'),
	(590905, 130, '2014-03-15 00:36:44.000000', 'consum', 0.0221, 'lps'),
	(590906, 130, '2014-03-15 00:36:45.000000', 'consum', 0.0223, 'lps'),
	(590907, 130, '2014-03-15 00:36:46.000000', 'consum', 0.0212, 'lps'),
	(590908, 130, '2014-03-15 00:36:47.000000', 'consum', 0.0212, 'lps'),
	(590909, 130, '2014-03-15 00:36:48.000000', 'consum', 0.0216, 'lps'),
	(590910, 130, '2014-03-15 00:36:49.000000', 'consum', 0.0220, 'lps'),
	(590911, 130, '2014-03-15 00:36:50.000000', 'consum', 0.0212, 'lps'),
	(590912, 130, '2014-03-15 00:36:51.000000', 'consum', 0.0219, 'lps'),
	(590913, 130, '2014-03-15 00:36:52.000000', 'consum', 0.0218, 'lps'),
	(590914, 130, '2014-03-15 00:36:53.000000', 'consum', 0.0211, 'lps'),
	(590915, 130, '2014-03-15 00:36:54.000000', 'consum', 0.0222, 'lps'),
	(590916, 130, '2014-03-15 00:36:55.000000', 'consum', 0.0223, 'lps'),
	(590917, 130, '2014-03-15 00:36:56.000000', 'consum', 0.0224, 'lps'),
	(590918, 130, '2014-03-15 00:36:57.000000', 'consum', 0.0213, 'lps'),
	(590919, 130, '2014-03-15 00:36:58.000000', 'consum', 0.0210, 'lps'),
	(590920, 130, '2014-03-15 00:36:59.000000', 'consum', 0.0220, 'lps'),
	(590921, 130, '2014-03-15 00:37:00.000000', 'consum', 0.0212, 'lps'),
	(590922, 130, '2014-03-15 00:37:01.000000', 'consum', 0.0223, 'lps'),
	(590923, 130, '2014-03-15 00:37:02.000000', 'consum', 0.0210, 'lps'),
	(590924, 130, '2014-03-15 00:37:03.000000', 'consum', 0.0217, 'lps'),
	(590925, 130, '2014-03-15 00:37:04.000000', 'consum', 0.0217, 'lps'),
	(590926, 130, '2014-03-15 00:37:05.000000', 'consum', 0.0221, 'lps'),
	(590927, 130, '2014-03-15 00:37:06.000000', 'consum', 0.0216, 'lps'),
	(590928, 130, '2014-03-15 00:37:07.000000', 'consum', 0.0224, 'lps'),
	(590929, 130, '2014-03-15 00:37:08.000000', 'consum', 0.0215, 'lps'),
	(590930, 130, '2014-03-15 00:37:09.000000', 'consum', 0.0224, 'lps'),
	(590931, 130, '2014-03-15 00:37:10.000000', 'consum', 0.0220, 'lps'),
	(590932, 130, '2014-03-15 00:37:11.000000', 'consum', 0.0217, 'lps'),
	(590933, 130, '2014-03-15 00:37:12.000000', 'consum', 0.0219, 'lps'),
	(590934, 130, '2014-03-15 00:37:13.000000', 'consum', 0.0216, 'lps'),
	(590935, 130, '2014-03-15 00:37:14.000000', 'consum', 0.0215, 'lps'),
	(590936, 130, '2014-03-15 00:37:15.000000', 'consum', 0.0216, 'lps'),
	(590937, 130, '2014-03-15 00:37:16.000000', 'consum', 0.0213, 'lps'),
	(590938, 130, '2014-03-15 00:37:17.000000', 'consum', 0.0221, 'lps'),
	(590939, 130, '2014-03-15 00:37:18.000000', 'consum', 0.0211, 'lps'),
	(590940, 130, '2014-03-15 00:37:19.000000', 'consum', 0.0213, 'lps'),
	(590941, 130, '2014-03-15 00:37:20.000000', 'consum', 0.0222, 'lps'),
	(590942, 130, '2014-03-15 00:37:21.000000', 'consum', 0.0215, 'lps'),
	(590943, 130, '2014-03-15 00:37:22.000000', 'consum', 0.0218, 'lps'),
	(590944, 130, '2014-03-15 00:37:23.000000', 'consum', 0.0217, 'lps'),
	(590945, 130, '2014-03-15 00:37:24.000000', 'consum', 0.0224, 'lps'),
	(590946, 130, '2014-03-15 00:37:25.000000', 'consum', 0.0213, 'lps'),
	(590947, 130, '2014-03-15 00:37:26.000000', 'consum', 0.0215, 'lps'),
	(590948, 130, '2014-03-15 00:37:27.000000', 'consum', 0.0210, 'lps'),
	(590949, 130, '2014-03-15 00:37:28.000000', 'consum', 0.0211, 'lps'),
	(590950, 130, '2014-03-15 00:37:29.000000', 'consum', 0.0214, 'lps'),
	(590951, 130, '2014-03-15 00:37:30.000000', 'consum', 0.0216, 'lps'),
	(590952, 130, '2014-03-15 00:37:31.000000', 'consum', 0.0210, 'lps'),
	(590953, 130, '2014-03-15 00:37:32.000000', 'consum', 0.0224, 'lps'),
	(590954, 130, '2014-03-15 00:37:33.000000', 'consum', 0.0221, 'lps'),
	(590955, 130, '2014-03-15 00:37:34.000000', 'consum', 0.0222, 'lps'),
	(590956, 130, '2014-03-15 00:37:35.000000', 'consum', 0.0210, 'lps'),
	(590957, 130, '2014-03-15 00:37:36.000000', 'consum', 0.0219, 'lps'),
	(590958, 130, '2014-03-15 00:37:37.000000', 'consum', 0.0210, 'lps'),
	(590959, 130, '2014-03-15 00:37:38.000000', 'consum', 0.0214, 'lps'),
	(590960, 130, '2014-03-15 00:37:39.000000', 'consum', 0.0217, 'lps'),
	(590961, 130, '2014-03-15 00:37:40.000000', 'consum', 0.0218, 'lps'),
	(590962, 130, '2014-03-15 00:37:41.000000', 'consum', 0.0214, 'lps'),
	(590963, 130, '2014-03-15 00:37:42.000000', 'consum', 0.0220, 'lps'),
	(590964, 130, '2014-03-15 00:37:43.000000', 'consum', 0.0219, 'lps'),
	(590965, 130, '2014-03-15 00:37:44.000000', 'consum', 0.0213, 'lps'),
	(590966, 130, '2014-03-15 00:37:45.000000', 'consum', 0.0211, 'lps'),
	(590967, 130, '2014-03-15 00:37:46.000000', 'consum', 0.0224, 'lps'),
	(590968, 130, '2014-03-15 00:37:47.000000', 'consum', 0.0216, 'lps'),
	(590969, 130, '2014-03-15 00:37:48.000000', 'consum', 0.0215, 'lps'),
	(590970, 130, '2014-03-15 00:37:49.000000', 'consum', 0.0215, 'lps'),
	(590971, 130, '2014-03-15 00:37:50.000000', 'consum', 0.0223, 'lps'),
	(590972, 130, '2014-03-15 00:37:51.000000', 'consum', 0.0213, 'lps'),
	(590973, 130, '2014-03-15 00:37:52.000000', 'consum', 0.0218, 'lps'),
	(590974, 130, '2014-03-15 00:37:53.000000', 'consum', 0.0213, 'lps'),
	(590975, 130, '2014-03-15 00:37:54.000000', 'consum', 0.0215, 'lps'),
	(590976, 130, '2014-03-15 00:37:55.000000', 'consum', 0.0212, 'lps'),
	(590977, 130, '2014-03-15 00:37:56.000000', 'consum', 0.0219, 'lps'),
	(590978, 130, '2014-03-15 00:37:57.000000', 'consum', 0.0220, 'lps'),
	(590979, 130, '2014-03-15 00:37:58.000000', 'consum', 0.0220, 'lps'),
	(590980, 130, '2014-03-15 00:37:59.000000', 'consum', 0.0214, 'lps'),
	(590981, 130, '2014-03-15 00:38:00.000000', 'consum', 0.0216, 'lps'),
	(590982, 130, '2014-03-15 00:38:01.000000', 'consum', 0.0212, 'lps'),
	(590983, 130, '2014-03-15 00:38:02.000000', 'consum', 0.0219, 'lps'),
	(590984, 130, '2014-03-15 00:38:03.000000', 'consum', 0.0218, 'lps'),
	(590985, 130, '2014-03-15 00:38:04.000000', 'consum', 0.0224, 'lps'),
	(590986, 130, '2014-03-15 00:38:05.000000', 'consum', 0.0212, 'lps'),
	(590987, 130, '2014-03-15 00:38:06.000000', 'consum', 0.0224, 'lps'),
	(590988, 130, '2014-03-15 00:38:07.000000', 'consum', 0.0215, 'lps'),
	(590989, 130, '2014-03-15 00:38:08.000000', 'consum', 0.0223, 'lps'),
	(590990, 130, '2014-03-15 00:38:09.000000', 'consum', 0.0214, 'lps'),
	(590991, 130, '2014-03-15 00:38:10.000000', 'consum', 0.0222, 'lps'),
	(590992, 130, '2014-03-15 00:38:11.000000', 'consum', 0.0214, 'lps'),
	(590993, 130, '2014-03-15 00:38:12.000000', 'consum', 0.0224, 'lps'),
	(590994, 130, '2014-03-15 00:38:13.000000', 'consum', 0.0223, 'lps'),
	(590995, 130, '2014-03-15 00:38:14.000000', 'consum', 0.0221, 'lps'),
	(590996, 130, '2014-03-15 00:38:15.000000', 'consum', 0.0210, 'lps'),
	(590997, 130, '2014-03-15 00:38:16.000000', 'consum', 0.0210, 'lps'),
	(590998, 130, '2014-03-15 00:38:17.000000', 'consum', 0.0222, 'lps'),
	(590999, 130, '2014-03-15 00:38:18.000000', 'consum', 0.0212, 'lps'),
	(591000, 130, '2014-03-15 00:38:19.000000', 'consum', 0.0216, 'lps'),
	(591001, 130, '2014-03-15 00:38:20.000000', 'consum', 0.0220, 'lps'),
	(591002, 130, '2014-03-15 00:38:21.000000', 'consum', 0.0210, 'lps'),
	(591003, 130, '2014-03-15 00:38:22.000000', 'consum', 0.0214, 'lps'),
	(591004, 130, '2014-03-15 00:38:23.000000', 'consum', 0.0212, 'lps'),
	(591005, 130, '2014-03-15 00:38:24.000000', 'consum', 0.0223, 'lps'),
	(591006, 130, '2014-03-15 00:38:25.000000', 'consum', 0.0213, 'lps'),
	(591007, 130, '2014-03-15 00:38:26.000000', 'consum', 0.0214, 'lps'),
	(591008, 130, '2014-03-15 00:38:27.000000', 'consum', 0.0222, 'lps'),
	(591009, 130, '2014-03-15 00:38:28.000000', 'consum', 0.0212, 'lps'),
	(591010, 130, '2014-03-15 00:38:29.000000', 'consum', 0.0214, 'lps'),
	(591011, 130, '2014-03-15 00:38:30.000000', 'consum', 0.0211, 'lps'),
	(591012, 130, '2014-03-15 00:38:31.000000', 'consum', 0.0218, 'lps'),
	(591013, 130, '2014-03-15 00:38:32.000000', 'consum', 0.0219, 'lps'),
	(591014, 130, '2014-03-15 00:38:33.000000', 'consum', 0.0218, 'lps'),
	(591015, 130, '2014-03-15 00:38:34.000000', 'consum', 0.0220, 'lps'),
	(591016, 130, '2014-03-15 00:38:35.000000', 'consum', 0.0222, 'lps'),
	(591017, 130, '2014-03-15 00:38:36.000000', 'consum', 0.0224, 'lps'),
	(591018, 130, '2014-03-15 00:38:37.000000', 'consum', 0.0217, 'lps'),
	(591019, 130, '2014-03-15 00:38:38.000000', 'consum', 0.0217, 'lps'),
	(591020, 130, '2014-03-15 00:38:39.000000', 'consum', 0.0224, 'lps'),
	(591021, 130, '2014-03-15 00:38:40.000000', 'consum', 0.0216, 'lps'),
	(591022, 130, '2014-03-15 00:38:41.000000', 'consum', 0.0215, 'lps'),
	(591023, 130, '2014-03-15 00:38:42.000000', 'consum', 0.0214, 'lps'),
	(591024, 130, '2014-03-15 00:38:43.000000', 'consum', 0.0217, 'lps'),
	(591025, 130, '2014-03-15 00:38:44.000000', 'consum', 0.0219, 'lps'),
	(591026, 130, '2014-03-15 00:38:45.000000', 'consum', 0.0221, 'lps'),
	(591027, 130, '2014-03-15 00:38:46.000000', 'consum', 0.0222, 'lps'),
	(591028, 130, '2014-03-15 00:38:47.000000', 'consum', 0.0224, 'lps'),
	(591029, 130, '2014-03-15 00:38:48.000000', 'consum', 0.0215, 'lps'),
	(591030, 130, '2014-03-15 00:38:49.000000', 'consum', 0.0223, 'lps'),
	(591031, 130, '2014-03-15 00:38:50.000000', 'consum', 0.0215, 'lps'),
	(591032, 130, '2014-03-15 00:38:51.000000', 'consum', 0.0212, 'lps'),
	(591033, 130, '2014-03-15 00:38:52.000000', 'consum', 0.0219, 'lps'),
	(591034, 130, '2014-03-15 00:38:53.000000', 'consum', 0.0219, 'lps'),
	(591035, 130, '2014-03-15 00:38:54.000000', 'consum', 0.0212, 'lps'),
	(591036, 130, '2014-03-15 00:38:55.000000', 'consum', 0.0212, 'lps'),
	(591037, 130, '2014-03-15 00:38:56.000000', 'consum', 0.0213, 'lps'),
	(591038, 130, '2014-03-15 00:38:57.000000', 'consum', 0.0219, 'lps'),
	(591039, 130, '2014-03-15 00:38:58.000000', 'consum', 0.0215, 'lps'),
	(591040, 130, '2014-03-15 00:38:59.000000', 'consum', 0.0212, 'lps'),
	(591041, 130, '2014-03-15 00:39:00.000000', 'consum', 0.0217, 'lps'),
	(591042, 130, '2014-03-15 00:39:01.000000', 'consum', 0.0211, 'lps'),
	(591043, 130, '2014-03-15 00:39:02.000000', 'consum', 0.0211, 'lps'),
	(591044, 130, '2014-03-15 00:39:03.000000', 'consum', 0.0211, 'lps'),
	(591045, 130, '2014-03-15 00:39:04.000000', 'consum', 0.0213, 'lps'),
	(591046, 130, '2014-03-15 00:39:05.000000', 'consum', 0.0221, 'lps'),
	(591047, 130, '2014-03-15 00:39:06.000000', 'consum', 0.0211, 'lps'),
	(591048, 130, '2014-03-15 00:39:07.000000', 'consum', 0.0215, 'lps'),
	(591049, 130, '2014-03-15 00:39:08.000000', 'consum', 0.0217, 'lps'),
	(591050, 130, '2014-03-15 00:39:09.000000', 'consum', 0.0216, 'lps'),
	(591051, 130, '2014-03-15 00:39:10.000000', 'consum', 0.0220, 'lps'),
	(591052, 130, '2014-03-15 00:39:11.000000', 'consum', 0.0211, 'lps'),
	(591053, 130, '2014-03-15 00:39:12.000000', 'consum', 0.0217, 'lps'),
	(591054, 130, '2014-03-15 00:39:13.000000', 'consum', 0.0210, 'lps'),
	(591055, 130, '2014-03-15 00:39:14.000000', 'consum', 0.0220, 'lps'),
	(591056, 130, '2014-03-15 00:39:15.000000', 'consum', 0.0214, 'lps'),
	(591057, 130, '2014-03-15 00:39:16.000000', 'consum', 0.0219, 'lps'),
	(591058, 130, '2014-03-15 00:39:17.000000', 'consum', 0.0211, 'lps'),
	(591059, 130, '2014-03-15 00:39:18.000000', 'consum', 0.0219, 'lps'),
	(591060, 130, '2014-03-15 00:39:19.000000', 'consum', 0.0221, 'lps'),
	(591061, 130, '2014-03-15 00:39:20.000000', 'consum', 0.0210, 'lps'),
	(591062, 130, '2014-03-15 00:39:21.000000', 'consum', 0.0221, 'lps'),
	(591063, 130, '2014-03-15 00:39:22.000000', 'consum', 0.0221, 'lps'),
	(591064, 130, '2014-03-15 00:39:23.000000', 'consum', 0.0218, 'lps'),
	(591065, 130, '2014-03-15 00:39:24.000000', 'consum', 0.0219, 'lps'),
	(591066, 130, '2014-03-15 00:39:25.000000', 'consum', 0.0217, 'lps'),
	(591067, 130, '2014-03-15 00:39:26.000000', 'consum', 0.0216, 'lps'),
	(591068, 130, '2014-03-15 00:39:27.000000', 'consum', 0.0221, 'lps'),
	(591069, 130, '2014-03-15 00:39:28.000000', 'consum', 0.0219, 'lps'),
	(591070, 130, '2014-03-15 00:39:29.000000', 'consum', 0.0220, 'lps'),
	(591071, 130, '2014-03-15 00:39:30.000000', 'consum', 0.0221, 'lps'),
	(591072, 130, '2014-03-15 00:39:31.000000', 'consum', 0.0217, 'lps'),
	(591073, 130, '2014-03-15 00:39:32.000000', 'consum', 0.0215, 'lps'),
	(591074, 130, '2014-03-15 00:39:33.000000', 'consum', 0.0215, 'lps'),
	(591075, 130, '2014-03-15 00:39:34.000000', 'consum', 0.0218, 'lps'),
	(591076, 130, '2014-03-15 00:39:35.000000', 'consum', 0.0223, 'lps'),
	(591077, 130, '2014-03-15 00:39:36.000000', 'consum', 0.0220, 'lps'),
	(591078, 130, '2014-03-15 00:39:37.000000', 'consum', 0.0222, 'lps'),
	(591079, 130, '2014-03-15 00:39:38.000000', 'consum', 0.0213, 'lps'),
	(591080, 130, '2014-03-15 00:39:39.000000', 'consum', 0.0216, 'lps'),
	(591081, 130, '2014-03-15 00:39:40.000000', 'consum', 0.0217, 'lps'),
	(591082, 130, '2014-03-15 00:39:41.000000', 'consum', 0.0211, 'lps'),
	(591083, 130, '2014-03-15 00:39:42.000000', 'consum', 0.0213, 'lps'),
	(591084, 130, '2014-03-15 00:39:43.000000', 'consum', 0.0220, 'lps'),
	(591085, 130, '2014-03-15 00:39:44.000000', 'consum', 0.0223, 'lps'),
	(591086, 130, '2014-03-15 00:39:45.000000', 'consum', 0.0214, 'lps'),
	(591087, 130, '2014-03-15 00:39:46.000000', 'consum', 0.0222, 'lps'),
	(591088, 130, '2014-03-15 00:39:47.000000', 'consum', 0.0216, 'lps'),
	(591089, 130, '2014-03-15 00:39:48.000000', 'consum', 0.0217, 'lps'),
	(591090, 130, '2014-03-15 00:39:49.000000', 'consum', 0.0212, 'lps'),
	(591091, 130, '2014-03-15 00:39:50.000000', 'consum', 0.0214, 'lps'),
	(591092, 130, '2014-03-15 00:39:51.000000', 'consum', 0.0224, 'lps'),
	(591093, 130, '2014-03-15 00:39:52.000000', 'consum', 0.0223, 'lps'),
	(591094, 130, '2014-03-15 00:39:53.000000', 'consum', 0.0221, 'lps'),
	(591095, 130, '2014-03-15 00:39:54.000000', 'consum', 0.0212, 'lps'),
	(591096, 130, '2014-03-15 00:39:55.000000', 'consum', 0.0215, 'lps'),
	(591097, 130, '2014-03-15 00:39:56.000000', 'consum', 0.0214, 'lps'),
	(591098, 130, '2014-03-15 00:39:57.000000', 'consum', 0.0217, 'lps'),
	(591099, 130, '2014-03-15 00:39:58.000000', 'consum', 0.0217, 'lps'),
	(591100, 130, '2014-03-15 00:39:59.000000', 'consum', 0.0210, 'lps'),
	(591101, 130, '2014-03-15 00:40:00.000000', 'consum', 0.0219, 'lps'),
	(591102, 130, '2014-03-15 00:40:01.000000', 'consum', 0.0210, 'lps'),
	(591103, 130, '2014-03-15 00:40:02.000000', 'consum', 0.0215, 'lps'),
	(591104, 130, '2014-03-15 00:40:03.000000', 'consum', 0.0218, 'lps'),
	(591105, 130, '2014-03-15 00:40:04.000000', 'consum', 0.0223, 'lps'),
	(591106, 130, '2014-03-15 00:40:05.000000', 'consum', 0.0220, 'lps'),
	(591107, 130, '2014-03-15 00:40:06.000000', 'consum', 0.0222, 'lps'),
	(591108, 130, '2014-03-15 00:40:07.000000', 'consum', 0.0212, 'lps'),
	(591109, 130, '2014-03-15 00:40:08.000000', 'consum', 0.0213, 'lps'),
	(591110, 130, '2014-03-15 00:40:09.000000', 'consum', 0.0218, 'lps'),
	(591111, 130, '2014-03-15 00:40:10.000000', 'consum', 0.0211, 'lps'),
	(591112, 130, '2014-03-15 00:40:11.000000', 'consum', 0.0210, 'lps'),
	(591113, 130, '2014-03-15 00:40:12.000000', 'consum', 0.0220, 'lps'),
	(591114, 130, '2014-03-15 00:40:13.000000', 'consum', 0.0216, 'lps'),
	(591115, 130, '2014-03-15 00:40:14.000000', 'consum', 0.0210, 'lps'),
	(591116, 130, '2014-03-15 00:40:15.000000', 'consum', 0.0223, 'lps'),
	(591117, 130, '2014-03-15 00:40:16.000000', 'consum', 0.0215, 'lps'),
	(591118, 130, '2014-03-15 00:40:17.000000', 'consum', 0.0211, 'lps'),
	(591119, 130, '2014-03-15 00:40:18.000000', 'consum', 0.0215, 'lps'),
	(591120, 130, '2014-03-15 00:40:19.000000', 'consum', 0.0220, 'lps'),
	(591121, 130, '2014-03-15 00:40:20.000000', 'consum', 0.0215, 'lps'),
	(591122, 130, '2014-03-15 00:40:21.000000', 'consum', 0.0221, 'lps'),
	(591123, 130, '2014-03-15 00:40:22.000000', 'consum', 0.0219, 'lps'),
	(591124, 130, '2014-03-15 00:40:23.000000', 'consum', 0.0224, 'lps'),
	(591125, 130, '2014-03-15 00:40:24.000000', 'consum', 0.0224, 'lps'),
	(591126, 130, '2014-03-15 00:40:25.000000', 'consum', 0.0221, 'lps'),
	(591127, 130, '2014-03-15 00:40:26.000000', 'consum', 0.0224, 'lps'),
	(591128, 130, '2014-03-15 00:40:27.000000', 'consum', 0.0218, 'lps'),
	(591129, 130, '2014-03-15 00:40:28.000000', 'consum', 0.0224, 'lps'),
	(591130, 130, '2014-03-15 00:40:29.000000', 'consum', 0.0211, 'lps'),
	(591131, 130, '2014-03-15 00:40:30.000000', 'consum', 0.0217, 'lps'),
	(591132, 130, '2014-03-15 00:40:31.000000', 'consum', 0.0216, 'lps'),
	(591133, 130, '2014-03-15 00:40:32.000000', 'consum', 0.0217, 'lps'),
	(591134, 130, '2014-03-15 00:40:33.000000', 'consum', 0.0212, 'lps'),
	(591135, 130, '2014-03-15 00:40:34.000000', 'consum', 0.0216, 'lps'),
	(591136, 130, '2014-03-15 00:40:35.000000', 'consum', 0.0220, 'lps'),
	(591137, 130, '2014-03-15 00:40:36.000000', 'consum', 0.0213, 'lps'),
	(591138, 130, '2014-03-15 00:40:37.000000', 'consum', 0.0210, 'lps'),
	(591139, 130, '2014-03-15 00:40:38.000000', 'consum', 0.0217, 'lps'),
	(591140, 130, '2014-03-15 00:40:39.000000', 'consum', 0.0215, 'lps'),
	(591141, 130, '2014-03-15 00:40:40.000000', 'consum', 0.0213, 'lps'),
	(591142, 130, '2014-03-15 00:40:41.000000', 'consum', 0.0211, 'lps'),
	(591143, 130, '2014-03-15 00:40:42.000000', 'consum', 0.0221, 'lps'),
	(591144, 130, '2014-03-15 00:40:43.000000', 'consum', 0.0217, 'lps'),
	(591145, 130, '2014-03-15 00:40:44.000000', 'consum', 0.0212, 'lps'),
	(591146, 130, '2014-03-15 00:40:45.000000', 'consum', 0.0217, 'lps'),
	(591147, 130, '2014-03-15 00:40:46.000000', 'consum', 0.0224, 'lps'),
	(591148, 130, '2014-03-15 00:40:47.000000', 'consum', 0.0214, 'lps'),
	(591149, 130, '2014-03-15 00:40:48.000000', 'consum', 0.0218, 'lps'),
	(591150, 130, '2014-03-15 00:40:49.000000', 'consum', 0.0224, 'lps'),
	(591151, 130, '2014-03-15 00:40:50.000000', 'consum', 0.0211, 'lps'),
	(591152, 130, '2014-03-15 00:40:51.000000', 'consum', 0.0218, 'lps'),
	(591153, 130, '2014-03-15 00:40:52.000000', 'consum', 0.0219, 'lps'),
	(591154, 130, '2014-03-15 00:40:53.000000', 'consum', 0.0214, 'lps'),
	(591155, 130, '2014-03-15 00:40:54.000000', 'consum', 0.0221, 'lps'),
	(591156, 130, '2014-03-15 00:40:55.000000', 'consum', 0.0210, 'lps'),
	(591157, 130, '2014-03-15 00:40:56.000000', 'consum', 0.0219, 'lps'),
	(591158, 130, '2014-03-15 00:40:57.000000', 'consum', 0.0211, 'lps'),
	(591159, 130, '2014-03-15 00:40:58.000000', 'consum', 0.0218, 'lps'),
	(591160, 130, '2014-03-15 00:40:59.000000', 'consum', 0.0216, 'lps'),
	(591161, 130, '2014-03-15 00:41:00.000000', 'consum', 0.0219, 'lps'),
	(591162, 130, '2014-03-15 00:41:01.000000', 'consum', 0.0222, 'lps'),
	(591163, 130, '2014-03-15 00:41:02.000000', 'consum', 0.0215, 'lps'),
	(591164, 130, '2014-03-15 00:41:03.000000', 'consum', 0.0215, 'lps'),
	(591165, 130, '2014-03-15 00:41:04.000000', 'consum', 0.0220, 'lps'),
	(591166, 130, '2014-03-15 00:41:05.000000', 'consum', 0.0214, 'lps'),
	(591167, 130, '2014-03-15 00:41:06.000000', 'consum', 0.0217, 'lps'),
	(591168, 130, '2014-03-15 00:41:07.000000', 'consum', 0.0219, 'lps'),
	(591169, 130, '2014-03-15 00:41:08.000000', 'consum', 0.0219, 'lps'),
	(591170, 130, '2014-03-15 00:41:09.000000', 'consum', 0.0214, 'lps'),
	(591171, 130, '2014-03-15 00:41:10.000000', 'consum', 0.0220, 'lps'),
	(591172, 130, '2014-03-15 00:41:11.000000', 'consum', 0.0216, 'lps'),
	(591173, 130, '2014-03-15 00:41:12.000000', 'consum', 0.0211, 'lps'),
	(591174, 130, '2014-03-15 00:41:13.000000', 'consum', 0.0211, 'lps'),
	(591175, 130, '2014-03-15 00:41:14.000000', 'consum', 0.0212, 'lps'),
	(591176, 130, '2014-03-15 00:41:15.000000', 'consum', 0.0219, 'lps'),
	(591177, 130, '2014-03-15 00:41:16.000000', 'consum', 0.0219, 'lps'),
	(591178, 130, '2014-03-15 00:41:17.000000', 'consum', 0.0215, 'lps'),
	(591179, 130, '2014-03-15 00:41:18.000000', 'consum', 0.0221, 'lps'),
	(591180, 130, '2014-03-15 00:41:19.000000', 'consum', 0.0221, 'lps'),
	(591181, 130, '2014-03-15 00:41:20.000000', 'consum', 0.0219, 'lps'),
	(591182, 130, '2014-03-15 00:41:21.000000', 'consum', 0.0223, 'lps'),
	(591183, 130, '2014-03-15 00:41:22.000000', 'consum', 0.0219, 'lps'),
	(591184, 130, '2014-03-15 00:41:23.000000', 'consum', 0.0214, 'lps'),
	(591185, 130, '2014-03-15 00:41:24.000000', 'consum', 0.0221, 'lps'),
	(591186, 130, '2014-03-15 00:41:25.000000', 'consum', 0.0224, 'lps'),
	(591187, 130, '2014-03-15 00:41:26.000000', 'consum', 0.0216, 'lps'),
	(591188, 130, '2014-03-15 00:41:27.000000', 'consum', 0.0212, 'lps'),
	(591189, 130, '2014-03-15 00:41:28.000000', 'consum', 0.0220, 'lps'),
	(591190, 130, '2014-03-15 00:41:29.000000', 'consum', 0.0221, 'lps'),
	(591191, 130, '2014-03-15 00:41:30.000000', 'consum', 0.0224, 'lps'),
	(591192, 130, '2014-03-15 00:41:31.000000', 'consum', 0.0218, 'lps'),
	(591193, 130, '2014-03-15 00:41:32.000000', 'consum', 0.0224, 'lps'),
	(591194, 130, '2014-03-15 00:41:33.000000', 'consum', 0.0211, 'lps'),
	(591195, 130, '2014-03-15 00:41:34.000000', 'consum', 0.0217, 'lps'),
	(591196, 130, '2014-03-15 00:41:35.000000', 'consum', 0.0212, 'lps'),
	(591197, 130, '2014-03-15 00:41:36.000000', 'consum', 0.0217, 'lps'),
	(591198, 130, '2014-03-15 00:41:37.000000', 'consum', 0.0224, 'lps'),
	(591199, 130, '2014-03-15 00:41:38.000000', 'consum', 0.0212, 'lps'),
	(591200, 130, '2014-03-15 00:41:39.000000', 'consum', 0.0210, 'lps'),
	(591201, 130, '2014-03-15 00:41:40.000000', 'consum', 0.0220, 'lps'),
	(591202, 130, '2014-03-15 00:41:41.000000', 'consum', 0.0215, 'lps'),
	(591203, 130, '2014-03-15 00:41:42.000000', 'consum', 0.0222, 'lps'),
	(591204, 130, '2014-03-15 00:41:43.000000', 'consum', 0.0211, 'lps'),
	(591205, 130, '2014-03-15 00:41:44.000000', 'consum', 0.0222, 'lps'),
	(591206, 130, '2014-03-15 00:41:45.000000', 'consum', 0.0222, 'lps'),
	(591207, 130, '2014-03-15 00:41:46.000000', 'consum', 0.0223, 'lps'),
	(591208, 130, '2014-03-15 00:41:47.000000', 'consum', 0.0221, 'lps'),
	(591209, 130, '2014-03-15 00:41:48.000000', 'consum', 0.0213, 'lps'),
	(591210, 130, '2014-03-15 00:41:49.000000', 'consum', 0.0222, 'lps'),
	(591211, 130, '2014-03-15 00:41:50.000000', 'consum', 0.0216, 'lps'),
	(591212, 130, '2014-03-15 00:41:51.000000', 'consum', 0.0219, 'lps'),
	(591213, 130, '2014-03-15 00:41:52.000000', 'consum', 0.0222, 'lps'),
	(591214, 130, '2014-03-15 00:41:53.000000', 'consum', 0.0213, 'lps'),
	(591215, 130, '2014-03-15 00:41:54.000000', 'consum', 0.0220, 'lps'),
	(591216, 130, '2014-03-15 00:41:55.000000', 'consum', 0.0222, 'lps'),
	(591217, 130, '2014-03-15 00:41:56.000000', 'consum', 0.0210, 'lps'),
	(591218, 130, '2014-03-15 00:41:57.000000', 'consum', 0.0219, 'lps'),
	(591219, 130, '2014-03-15 00:41:58.000000', 'consum', 0.0212, 'lps'),
	(591220, 130, '2014-03-15 00:41:59.000000', 'consum', 0.0224, 'lps'),
	(591221, 130, '2014-03-15 00:42:00.000000', 'consum', 0.0215, 'lps'),
	(591222, 130, '2014-03-15 00:42:01.000000', 'consum', 0.0222, 'lps'),
	(591223, 130, '2014-03-15 00:42:02.000000', 'consum', 0.0212, 'lps'),
	(591224, 130, '2014-03-15 00:42:03.000000', 'consum', 0.0215, 'lps'),
	(591225, 130, '2014-03-15 00:42:04.000000', 'consum', 0.0212, 'lps'),
	(591226, 130, '2014-03-15 00:42:05.000000', 'consum', 0.0223, 'lps'),
	(591227, 130, '2014-03-15 00:42:06.000000', 'consum', 0.0210, 'lps'),
	(591228, 130, '2014-03-15 00:42:07.000000', 'consum', 0.0214, 'lps'),
	(591229, 130, '2014-03-15 00:42:08.000000', 'consum', 0.0216, 'lps'),
	(591230, 130, '2014-03-15 00:42:09.000000', 'consum', 0.0214, 'lps'),
	(591231, 130, '2014-03-15 00:42:10.000000', 'consum', 0.0211, 'lps'),
	(591232, 130, '2014-03-15 00:42:11.000000', 'consum', 0.0220, 'lps'),
	(591233, 130, '2014-03-15 00:42:12.000000', 'consum', 0.0212, 'lps'),
	(591234, 130, '2014-03-15 00:42:13.000000', 'consum', 0.0221, 'lps'),
	(591235, 130, '2014-03-15 00:42:14.000000', 'consum', 0.0213, 'lps'),
	(591236, 130, '2014-03-15 00:42:15.000000', 'consum', 0.0222, 'lps'),
	(591237, 130, '2014-03-15 00:42:16.000000', 'consum', 0.0217, 'lps'),
	(591238, 130, '2014-03-15 00:42:17.000000', 'consum', 0.0224, 'lps'),
	(591239, 130, '2014-03-15 00:42:18.000000', 'consum', 0.0215, 'lps'),
	(591240, 130, '2014-03-15 00:42:19.000000', 'consum', 0.0222, 'lps'),
	(591241, 130, '2014-03-15 00:42:20.000000', 'consum', 0.0210, 'lps'),
	(591242, 130, '2014-03-15 00:42:21.000000', 'consum', 0.0220, 'lps'),
	(591243, 130, '2014-03-15 00:42:22.000000', 'consum', 0.0218, 'lps'),
	(591244, 130, '2014-03-15 00:42:23.000000', 'consum', 0.0218, 'lps'),
	(591245, 130, '2014-03-15 00:42:24.000000', 'consum', 0.0214, 'lps'),
	(591246, 130, '2014-03-15 00:42:25.000000', 'consum', 0.0222, 'lps'),
	(591247, 130, '2014-03-15 00:42:26.000000', 'consum', 0.0211, 'lps'),
	(591248, 130, '2014-03-15 00:42:27.000000', 'consum', 0.0212, 'lps'),
	(591249, 130, '2014-03-15 00:42:28.000000', 'consum', 0.0217, 'lps'),
	(591250, 130, '2014-03-15 00:42:29.000000', 'consum', 0.0224, 'lps'),
	(591251, 130, '2014-03-15 00:42:30.000000', 'consum', 0.0215, 'lps'),
	(591252, 130, '2014-03-15 00:42:31.000000', 'consum', 0.0221, 'lps'),
	(591253, 130, '2014-03-15 00:42:32.000000', 'consum', 0.0224, 'lps'),
	(591254, 130, '2014-03-15 00:42:33.000000', 'consum', 0.0216, 'lps'),
	(591255, 130, '2014-03-15 00:42:34.000000', 'consum', 0.0212, 'lps'),
	(591256, 130, '2014-03-15 00:42:35.000000', 'consum', 0.0217, 'lps'),
	(591257, 130, '2014-03-15 00:42:36.000000', 'consum', 0.0212, 'lps'),
	(591258, 130, '2014-03-15 00:42:37.000000', 'consum', 0.0212, 'lps'),
	(591259, 130, '2014-03-15 00:42:38.000000', 'consum', 0.0215, 'lps'),
	(591260, 130, '2014-03-15 00:42:39.000000', 'consum', 0.0216, 'lps'),
	(591261, 130, '2014-03-15 00:42:40.000000', 'consum', 0.0211, 'lps'),
	(591262, 130, '2014-03-15 00:42:41.000000', 'consum', 0.0211, 'lps'),
	(591263, 130, '2014-03-15 00:42:42.000000', 'consum', 0.0214, 'lps'),
	(591264, 130, '2014-03-15 00:42:43.000000', 'consum', 0.0210, 'lps'),
	(591265, 130, '2014-03-15 00:42:44.000000', 'consum', 0.0216, 'lps'),
	(591266, 130, '2014-03-15 00:42:45.000000', 'consum', 0.0224, 'lps'),
	(591267, 130, '2014-03-15 00:42:46.000000', 'consum', 0.0218, 'lps'),
	(591268, 130, '2014-03-15 00:42:47.000000', 'consum', 0.0222, 'lps'),
	(591269, 130, '2014-03-15 00:42:48.000000', 'consum', 0.0219, 'lps'),
	(591270, 130, '2014-03-15 00:42:49.000000', 'consum', 0.0218, 'lps'),
	(591271, 130, '2014-03-15 00:42:50.000000', 'consum', 0.0222, 'lps'),
	(591272, 130, '2014-03-15 00:42:51.000000', 'consum', 0.0218, 'lps'),
	(591273, 130, '2014-03-15 00:42:52.000000', 'consum', 0.0215, 'lps'),
	(591274, 130, '2014-03-15 00:42:53.000000', 'consum', 0.0213, 'lps'),
	(591275, 130, '2014-03-15 00:42:54.000000', 'consum', 0.0223, 'lps'),
	(591276, 130, '2014-03-15 00:42:55.000000', 'consum', 0.0224, 'lps'),
	(591277, 130, '2014-03-15 00:42:56.000000', 'consum', 0.0224, 'lps'),
	(591278, 130, '2014-03-15 00:42:57.000000', 'consum', 0.0210, 'lps'),
	(591279, 130, '2014-03-15 00:42:58.000000', 'consum', 0.0212, 'lps'),
	(591280, 130, '2014-03-15 00:42:59.000000', 'consum', 0.0221, 'lps'),
	(591281, 130, '2014-03-15 00:43:00.000000', 'consum', 0.0217, 'lps'),
	(591282, 130, '2014-03-15 00:43:01.000000', 'consum', 0.0224, 'lps'),
	(591283, 130, '2014-03-15 00:43:02.000000', 'consum', 0.0217, 'lps'),
	(591284, 130, '2014-03-15 00:43:03.000000', 'consum', 0.0216, 'lps'),
	(591285, 130, '2014-03-15 00:43:04.000000', 'consum', 0.0219, 'lps'),
	(591286, 130, '2014-03-15 00:43:05.000000', 'consum', 0.0210, 'lps'),
	(591287, 130, '2014-03-15 00:43:06.000000', 'consum', 0.0214, 'lps'),
	(591288, 130, '2014-03-15 00:43:07.000000', 'consum', 0.0216, 'lps'),
	(591289, 130, '2014-03-15 00:43:08.000000', 'consum', 0.0214, 'lps'),
	(591290, 130, '2014-03-15 00:43:09.000000', 'consum', 0.0213, 'lps'),
	(591291, 130, '2014-03-15 00:43:10.000000', 'consum', 0.0213, 'lps'),
	(591292, 130, '2014-03-15 00:43:11.000000', 'consum', 0.0216, 'lps'),
	(591293, 130, '2014-03-15 00:43:12.000000', 'consum', 0.0216, 'lps'),
	(591294, 130, '2014-03-15 00:43:13.000000', 'consum', 0.0210, 'lps'),
	(591295, 130, '2014-03-15 00:43:14.000000', 'consum', 0.0221, 'lps'),
	(591296, 130, '2014-03-15 00:43:15.000000', 'consum', 0.0219, 'lps'),
	(591297, 130, '2014-03-15 00:43:16.000000', 'consum', 0.0223, 'lps'),
	(591298, 130, '2014-03-15 00:43:17.000000', 'consum', 0.0220, 'lps'),
	(591299, 130, '2014-03-15 00:43:18.000000', 'consum', 0.0219, 'lps'),
	(591300, 130, '2014-03-15 00:43:19.000000', 'consum', 0.0211, 'lps'),
	(591301, 130, '2014-03-15 00:43:20.000000', 'consum', 0.0221, 'lps'),
	(591302, 130, '2014-03-15 00:43:21.000000', 'consum', 0.0215, 'lps'),
	(591303, 130, '2014-03-15 00:43:22.000000', 'consum', 0.0217, 'lps'),
	(591304, 130, '2014-03-15 00:43:23.000000', 'consum', 0.0217, 'lps'),
	(591305, 130, '2014-03-15 00:43:24.000000', 'consum', 0.0211, 'lps'),
	(591306, 130, '2014-03-15 00:43:25.000000', 'consum', 0.0222, 'lps'),
	(591307, 130, '2014-03-15 00:43:26.000000', 'consum', 0.0224, 'lps'),
	(591308, 130, '2014-03-15 00:43:27.000000', 'consum', 0.0214, 'lps'),
	(591309, 130, '2014-03-15 00:43:28.000000', 'consum', 0.0217, 'lps'),
	(591310, 130, '2014-03-15 00:43:29.000000', 'consum', 0.0218, 'lps'),
	(591311, 130, '2014-03-15 00:43:30.000000', 'consum', 0.0218, 'lps'),
	(591312, 130, '2014-03-15 00:43:31.000000', 'consum', 0.0223, 'lps'),
	(591313, 130, '2014-03-15 00:43:32.000000', 'consum', 0.0222, 'lps'),
	(591314, 130, '2014-03-15 00:43:33.000000', 'consum', 0.0216, 'lps'),
	(591315, 130, '2014-03-15 00:43:34.000000', 'consum', 0.0221, 'lps'),
	(591316, 130, '2014-03-15 00:43:35.000000', 'consum', 0.0217, 'lps'),
	(591317, 130, '2014-03-15 00:43:36.000000', 'consum', 0.0211, 'lps'),
	(591318, 130, '2014-03-15 00:43:37.000000', 'consum', 0.0213, 'lps'),
	(591319, 130, '2014-03-15 00:43:38.000000', 'consum', 0.0219, 'lps'),
	(591320, 130, '2014-03-15 00:43:39.000000', 'consum', 0.0217, 'lps'),
	(591321, 130, '2014-03-15 00:43:40.000000', 'consum', 0.0217, 'lps'),
	(591322, 130, '2014-03-15 00:43:41.000000', 'consum', 0.0211, 'lps'),
	(591323, 130, '2014-03-15 00:43:42.000000', 'consum', 0.0211, 'lps'),
	(591324, 130, '2014-03-15 00:43:43.000000', 'consum', 0.0211, 'lps'),
	(591325, 130, '2014-03-15 00:43:44.000000', 'consum', 0.0214, 'lps'),
	(591326, 130, '2014-03-15 00:43:45.000000', 'consum', 0.0212, 'lps'),
	(591327, 130, '2014-03-15 00:43:46.000000', 'consum', 0.0222, 'lps'),
	(591328, 130, '2014-03-15 00:43:47.000000', 'consum', 0.0221, 'lps'),
	(591329, 130, '2014-03-15 00:43:48.000000', 'consum', 0.0212, 'lps'),
	(591330, 130, '2014-03-15 00:43:49.000000', 'consum', 0.0219, 'lps'),
	(591331, 130, '2014-03-15 00:43:50.000000', 'consum', 0.0219, 'lps'),
	(591332, 130, '2014-03-15 00:43:51.000000', 'consum', 0.0212, 'lps'),
	(591333, 130, '2014-03-15 00:43:52.000000', 'consum', 0.0211, 'lps'),
	(591334, 130, '2014-03-15 00:43:53.000000', 'consum', 0.0223, 'lps'),
	(591335, 130, '2014-03-15 00:43:54.000000', 'consum', 0.0213, 'lps'),
	(591336, 130, '2014-03-15 00:43:55.000000', 'consum', 0.0218, 'lps'),
	(591337, 130, '2014-03-15 00:43:56.000000', 'consum', 0.0224, 'lps'),
	(591338, 130, '2014-03-15 00:43:57.000000', 'consum', 0.0212, 'lps'),
	(591339, 130, '2014-03-15 00:43:58.000000', 'consum', 0.0210, 'lps'),
	(591340, 130, '2014-03-15 00:43:59.000000', 'consum', 0.0219, 'lps'),
	(591341, 130, '2014-03-15 00:44:00.000000', 'consum', 0.0224, 'lps'),
	(591342, 130, '2014-03-15 00:44:01.000000', 'consum', 0.0223, 'lps'),
	(591343, 130, '2014-03-15 00:44:02.000000', 'consum', 0.0221, 'lps'),
	(591344, 130, '2014-03-15 00:44:03.000000', 'consum', 0.0212, 'lps'),
	(591345, 130, '2014-03-15 00:44:04.000000', 'consum', 0.0217, 'lps'),
	(591346, 130, '2014-03-15 00:44:05.000000', 'consum', 0.0210, 'lps'),
	(591347, 130, '2014-03-15 00:44:06.000000', 'consum', 0.0219, 'lps'),
	(591348, 130, '2014-03-15 00:44:07.000000', 'consum', 0.0223, 'lps'),
	(591349, 130, '2014-03-15 00:44:08.000000', 'consum', 0.0222, 'lps'),
	(591350, 130, '2014-03-15 00:44:09.000000', 'consum', 0.0216, 'lps'),
	(591351, 130, '2014-03-15 00:44:10.000000', 'consum', 0.0218, 'lps'),
	(591352, 130, '2014-03-15 00:44:11.000000', 'consum', 0.0219, 'lps'),
	(591353, 130, '2014-03-15 00:44:12.000000', 'consum', 0.0215, 'lps'),
	(591354, 130, '2014-03-15 00:44:13.000000', 'consum', 0.0211, 'lps'),
	(591355, 130, '2014-03-15 00:44:14.000000', 'consum', 0.0215, 'lps'),
	(591356, 130, '2014-03-15 00:44:15.000000', 'consum', 0.0218, 'lps'),
	(591357, 130, '2014-03-15 00:44:16.000000', 'consum', 0.0218, 'lps'),
	(591358, 130, '2014-03-15 00:44:17.000000', 'consum', 0.0213, 'lps'),
	(591359, 130, '2014-03-15 00:44:18.000000', 'consum', 0.0218, 'lps'),
	(591360, 130, '2014-03-15 00:44:19.000000', 'consum', 0.0224, 'lps'),
	(591361, 130, '2014-03-15 00:44:20.000000', 'consum', 0.0210, 'lps'),
	(591362, 130, '2014-03-15 00:44:21.000000', 'consum', 0.0217, 'lps'),
	(591363, 130, '2014-03-15 00:44:22.000000', 'consum', 0.0214, 'lps'),
	(591364, 130, '2014-03-15 00:44:23.000000', 'consum', 0.0210, 'lps'),
	(591365, 130, '2014-03-15 00:44:24.000000', 'consum', 0.0215, 'lps'),
	(591366, 130, '2014-03-15 00:44:25.000000', 'consum', 0.0219, 'lps'),
	(591367, 130, '2014-03-15 00:44:26.000000', 'consum', 0.0224, 'lps'),
	(591368, 130, '2014-03-15 00:44:27.000000', 'consum', 0.0224, 'lps'),
	(591369, 130, '2014-03-15 00:44:28.000000', 'consum', 0.0224, 'lps'),
	(591370, 130, '2014-03-15 00:44:29.000000', 'consum', 0.0210, 'lps'),
	(591371, 130, '2014-03-15 00:44:30.000000', 'consum', 0.0213, 'lps'),
	(591372, 130, '2014-03-15 00:44:31.000000', 'consum', 0.0212, 'lps'),
	(591373, 130, '2014-03-15 00:44:32.000000', 'consum', 0.0224, 'lps'),
	(591374, 130, '2014-03-15 00:44:33.000000', 'consum', 0.0217, 'lps'),
	(591375, 130, '2014-03-15 00:44:34.000000', 'consum', 0.0215, 'lps'),
	(591376, 130, '2014-03-15 00:44:35.000000', 'consum', 0.0218, 'lps'),
	(591377, 130, '2014-03-15 00:44:36.000000', 'consum', 0.0219, 'lps'),
	(591378, 130, '2014-03-15 00:44:37.000000', 'consum', 0.0215, 'lps'),
	(591379, 130, '2014-03-15 00:44:38.000000', 'consum', 0.0211, 'lps'),
	(591380, 130, '2014-03-15 00:44:39.000000', 'consum', 0.0214, 'lps'),
	(591381, 130, '2014-03-15 00:44:40.000000', 'consum', 0.0214, 'lps'),
	(591382, 130, '2014-03-15 00:44:41.000000', 'consum', 0.0216, 'lps'),
	(591383, 130, '2014-03-15 00:44:42.000000', 'consum', 0.0213, 'lps'),
	(591384, 130, '2014-03-15 00:44:43.000000', 'consum', 0.0211, 'lps'),
	(591385, 130, '2014-03-15 00:44:44.000000', 'consum', 0.0219, 'lps'),
	(591386, 130, '2014-03-15 00:44:45.000000', 'consum', 0.0223, 'lps'),
	(591387, 130, '2014-03-15 00:44:46.000000', 'consum', 0.0219, 'lps'),
	(591388, 130, '2014-03-15 00:44:47.000000', 'consum', 0.0217, 'lps'),
	(591389, 130, '2014-03-15 00:44:48.000000', 'consum', 0.0220, 'lps'),
	(591390, 130, '2014-03-15 00:44:49.000000', 'consum', 0.0223, 'lps'),
	(591391, 130, '2014-03-15 00:44:50.000000', 'consum', 0.0217, 'lps'),
	(591392, 130, '2014-03-15 00:44:51.000000', 'consum', 0.0222, 'lps'),
	(591393, 130, '2014-03-15 00:44:52.000000', 'consum', 0.0220, 'lps'),
	(591394, 130, '2014-03-15 00:44:53.000000', 'consum', 0.0210, 'lps'),
	(591395, 130, '2014-03-15 00:44:54.000000', 'consum', 0.0211, 'lps'),
	(591396, 130, '2014-03-15 00:44:55.000000', 'consum', 0.0215, 'lps'),
	(591397, 130, '2014-03-15 00:44:56.000000', 'consum', 0.0215, 'lps'),
	(591398, 130, '2014-03-15 00:44:57.000000', 'consum', 0.0222, 'lps'),
	(591399, 130, '2014-03-15 00:44:58.000000', 'consum', 0.0211, 'lps'),
	(591400, 130, '2014-03-15 00:44:59.000000', 'consum', 0.0210, 'lps'),
	(591401, 130, '2014-03-15 00:45:00.000000', 'consum', 0.0222, 'lps'),
	(591402, 130, '2014-03-15 00:45:01.000000', 'consum', 0.0210, 'lps'),
	(591403, 130, '2014-03-15 00:45:02.000000', 'consum', 0.0218, 'lps'),
	(591404, 130, '2014-03-15 00:45:03.000000', 'consum', 0.0222, 'lps'),
	(591405, 130, '2014-03-15 00:45:04.000000', 'consum', 0.0214, 'lps'),
	(591406, 130, '2014-03-15 00:45:05.000000', 'consum', 0.0212, 'lps'),
	(591407, 130, '2014-03-15 00:45:06.000000', 'consum', 0.0224, 'lps'),
	(591408, 130, '2014-03-15 00:45:07.000000', 'consum', 0.0216, 'lps'),
	(591409, 130, '2014-03-15 00:45:08.000000', 'consum', 0.0210, 'lps'),
	(591410, 130, '2014-03-15 00:45:09.000000', 'consum', 0.0224, 'lps'),
	(591411, 130, '2014-03-15 00:45:10.000000', 'consum', 0.0221, 'lps'),
	(591412, 130, '2014-03-15 00:45:11.000000', 'consum', 0.0223, 'lps'),
	(591413, 130, '2014-03-15 00:45:12.000000', 'consum', 0.0213, 'lps'),
	(591414, 130, '2014-03-15 00:45:13.000000', 'consum', 0.0218, 'lps'),
	(591415, 130, '2014-03-15 00:45:14.000000', 'consum', 0.0211, 'lps'),
	(591416, 130, '2014-03-15 00:45:15.000000', 'consum', 0.0221, 'lps'),
	(591417, 130, '2014-03-15 00:45:16.000000', 'consum', 0.0217, 'lps'),
	(591418, 130, '2014-03-15 00:45:17.000000', 'consum', 0.0212, 'lps'),
	(591419, 130, '2014-03-15 00:45:18.000000', 'consum', 0.0214, 'lps'),
	(591420, 130, '2014-03-15 00:45:19.000000', 'consum', 0.0210, 'lps'),
	(591421, 130, '2014-03-15 00:45:20.000000', 'consum', 0.0212, 'lps'),
	(591422, 130, '2014-03-15 00:45:21.000000', 'consum', 0.0222, 'lps'),
	(591423, 130, '2014-03-15 00:45:22.000000', 'consum', 0.0220, 'lps'),
	(591424, 130, '2014-03-15 00:45:23.000000', 'consum', 0.0210, 'lps'),
	(591425, 130, '2014-03-15 00:45:24.000000', 'consum', 0.0210, 'lps'),
	(591426, 130, '2014-03-15 00:45:25.000000', 'consum', 0.0210, 'lps'),
	(591427, 130, '2014-03-15 00:45:26.000000', 'consum', 0.0211, 'lps'),
	(591428, 130, '2014-03-15 00:45:27.000000', 'consum', 0.0214, 'lps'),
	(591429, 130, '2014-03-15 00:45:28.000000', 'consum', 0.0212, 'lps'),
	(591430, 130, '2014-03-15 00:45:29.000000', 'consum', 0.0211, 'lps'),
	(591431, 130, '2014-03-15 00:45:30.000000', 'consum', 0.0210, 'lps'),
	(591432, 130, '2014-03-15 00:45:31.000000', 'consum', 0.0221, 'lps'),
	(591433, 130, '2014-03-15 00:45:32.000000', 'consum', 0.0221, 'lps'),
	(591434, 130, '2014-03-15 00:45:33.000000', 'consum', 0.0219, 'lps'),
	(591435, 130, '2014-03-15 00:45:34.000000', 'consum', 0.0223, 'lps'),
	(591436, 130, '2014-03-15 00:45:35.000000', 'consum', 0.0217, 'lps'),
	(591437, 130, '2014-03-15 00:45:36.000000', 'consum', 0.0223, 'lps'),
	(591438, 130, '2014-03-15 00:45:37.000000', 'consum', 0.0224, 'lps'),
	(591439, 130, '2014-03-15 00:45:38.000000', 'consum', 0.0213, 'lps'),
	(591440, 130, '2014-03-15 00:45:39.000000', 'consum', 0.0213, 'lps'),
	(591441, 130, '2014-03-15 00:45:40.000000', 'consum', 0.0214, 'lps'),
	(591442, 130, '2014-03-15 00:45:41.000000', 'consum', 0.0224, 'lps'),
	(591443, 130, '2014-03-15 00:45:42.000000', 'consum', 0.0222, 'lps'),
	(591444, 130, '2014-03-15 00:45:43.000000', 'consum', 0.0214, 'lps'),
	(591445, 130, '2014-03-15 00:45:44.000000', 'consum', 0.0224, 'lps'),
	(591446, 130, '2014-03-15 00:45:45.000000', 'consum', 0.0211, 'lps'),
	(591447, 130, '2014-03-15 00:45:46.000000', 'consum', 0.0216, 'lps'),
	(591448, 130, '2014-03-15 00:45:47.000000', 'consum', 0.0224, 'lps'),
	(591449, 130, '2014-03-15 00:45:48.000000', 'consum', 0.0216, 'lps'),
	(591450, 130, '2014-03-15 00:45:49.000000', 'consum', 0.0213, 'lps'),
	(591451, 130, '2014-03-15 00:45:50.000000', 'consum', 0.0221, 'lps'),
	(591452, 130, '2014-03-15 00:45:51.000000', 'consum', 0.0214, 'lps'),
	(591453, 130, '2014-03-15 00:45:52.000000', 'consum', 0.0213, 'lps'),
	(591454, 130, '2014-03-15 00:45:53.000000', 'consum', 0.0213, 'lps'),
	(591455, 130, '2014-03-15 00:45:54.000000', 'consum', 0.0215, 'lps'),
	(591456, 130, '2014-03-15 00:45:55.000000', 'consum', 0.0214, 'lps'),
	(591457, 130, '2014-03-15 00:45:56.000000', 'consum', 0.0215, 'lps'),
	(591458, 130, '2014-03-15 00:45:57.000000', 'consum', 0.0224, 'lps'),
	(591459, 130, '2014-03-15 00:45:58.000000', 'consum', 0.0218, 'lps'),
	(591460, 130, '2014-03-15 00:45:59.000000', 'consum', 0.0210, 'lps'),
	(591461, 130, '2014-03-15 00:46:00.000000', 'consum', 0.0218, 'lps'),
	(591462, 130, '2014-03-15 00:46:01.000000', 'consum', 0.0220, 'lps'),
	(591463, 130, '2014-03-15 00:46:02.000000', 'consum', 0.0223, 'lps'),
	(591464, 130, '2014-03-15 00:46:03.000000', 'consum', 0.0213, 'lps'),
	(591465, 130, '2014-03-15 00:46:04.000000', 'consum', 0.0219, 'lps'),
	(591466, 130, '2014-03-15 00:46:05.000000', 'consum', 0.0214, 'lps'),
	(591467, 130, '2014-03-15 00:46:06.000000', 'consum', 0.0218, 'lps'),
	(591468, 130, '2014-03-15 00:46:07.000000', 'consum', 0.0223, 'lps'),
	(591469, 130, '2014-03-15 00:46:08.000000', 'consum', 0.0222, 'lps'),
	(591470, 130, '2014-03-15 00:46:09.000000', 'consum', 0.0217, 'lps'),
	(591471, 130, '2014-03-15 00:46:10.000000', 'consum', 0.0211, 'lps'),
	(591472, 130, '2014-03-15 00:46:11.000000', 'consum', 0.0223, 'lps'),
	(591473, 130, '2014-03-15 00:46:12.000000', 'consum', 0.0212, 'lps'),
	(591474, 130, '2014-03-15 00:46:13.000000', 'consum', 0.0213, 'lps'),
	(591475, 130, '2014-03-15 00:46:14.000000', 'consum', 0.0217, 'lps'),
	(591476, 130, '2014-03-15 00:46:15.000000', 'consum', 0.0223, 'lps'),
	(591477, 130, '2014-03-15 00:46:16.000000', 'consum', 0.0224, 'lps'),
	(591478, 130, '2014-03-15 00:46:17.000000', 'consum', 0.0210, 'lps'),
	(591479, 130, '2014-03-15 00:46:18.000000', 'consum', 0.0216, 'lps'),
	(591480, 130, '2014-03-15 00:46:19.000000', 'consum', 0.0210, 'lps'),
	(591481, 130, '2014-03-15 00:46:20.000000', 'consum', 0.0223, 'lps'),
	(591482, 130, '2014-03-15 00:46:21.000000', 'consum', 0.0214, 'lps'),
	(591483, 130, '2014-03-15 00:46:22.000000', 'consum', 0.0222, 'lps'),
	(591484, 130, '2014-03-15 00:46:23.000000', 'consum', 0.0214, 'lps'),
	(591485, 130, '2014-03-15 00:46:24.000000', 'consum', 0.0224, 'lps'),
	(591486, 130, '2014-03-15 00:46:25.000000', 'consum', 0.0223, 'lps'),
	(591487, 130, '2014-03-15 00:46:26.000000', 'consum', 0.0220, 'lps'),
	(591488, 130, '2014-03-15 00:46:27.000000', 'consum', 0.0222, 'lps'),
	(591489, 130, '2014-03-15 00:46:28.000000', 'consum', 0.0212, 'lps'),
	(591490, 130, '2014-03-15 00:46:29.000000', 'consum', 0.0212, 'lps'),
	(591491, 130, '2014-03-15 00:46:30.000000', 'consum', 0.0214, 'lps'),
	(591492, 130, '2014-03-15 00:46:31.000000', 'consum', 0.0211, 'lps'),
	(591493, 130, '2014-03-15 00:46:32.000000', 'consum', 0.0217, 'lps'),
	(591494, 130, '2014-03-15 00:46:33.000000', 'consum', 0.0214, 'lps'),
	(591495, 130, '2014-03-15 00:46:34.000000', 'consum', 0.0222, 'lps'),
	(591496, 130, '2014-03-15 00:46:35.000000', 'consum', 0.0217, 'lps'),
	(591497, 130, '2014-03-15 00:46:36.000000', 'consum', 0.0222, 'lps'),
	(591498, 130, '2014-03-15 00:46:37.000000', 'consum', 0.0220, 'lps'),
	(591499, 130, '2014-03-15 00:46:38.000000', 'consum', 0.0223, 'lps'),
	(591500, 130, '2014-03-15 00:46:39.000000', 'consum', 0.0215, 'lps'),
	(591501, 130, '2014-03-15 00:46:40.000000', 'consum', 0.0215, 'lps'),
	(591502, 130, '2014-03-15 00:46:41.000000', 'consum', 0.0218, 'lps'),
	(591503, 130, '2014-03-15 00:46:42.000000', 'consum', 0.0219, 'lps'),
	(591504, 130, '2014-03-15 00:46:43.000000', 'consum', 0.0219, 'lps'),
	(591505, 130, '2014-03-15 00:46:44.000000', 'consum', 0.0213, 'lps'),
	(591506, 130, '2014-03-15 00:46:45.000000', 'consum', 0.0214, 'lps'),
	(591507, 130, '2014-03-15 00:46:46.000000', 'consum', 0.0221, 'lps'),
	(591508, 130, '2014-03-15 00:46:47.000000', 'consum', 0.0222, 'lps'),
	(591509, 130, '2014-03-15 00:46:48.000000', 'consum', 0.0222, 'lps'),
	(591510, 130, '2014-03-15 00:46:49.000000', 'consum', 0.0220, 'lps'),
	(591511, 130, '2014-03-15 00:46:50.000000', 'consum', 0.0224, 'lps'),
	(591512, 130, '2014-03-15 00:46:51.000000', 'consum', 0.0223, 'lps'),
	(591513, 130, '2014-03-15 00:46:52.000000', 'consum', 0.0215, 'lps'),
	(591514, 130, '2014-03-15 00:46:53.000000', 'consum', 0.0213, 'lps'),
	(591515, 130, '2014-03-15 00:46:54.000000', 'consum', 0.0212, 'lps'),
	(591516, 130, '2014-03-15 00:46:55.000000', 'consum', 0.0210, 'lps'),
	(591517, 130, '2014-03-15 00:46:56.000000', 'consum', 0.0219, 'lps'),
	(591518, 130, '2014-03-15 00:46:57.000000', 'consum', 0.0213, 'lps'),
	(591519, 130, '2014-03-15 00:46:58.000000', 'consum', 0.0213, 'lps'),
	(591520, 130, '2014-03-15 00:46:59.000000', 'consum', 0.0216, 'lps'),
	(591521, 130, '2014-03-15 00:47:00.000000', 'consum', 0.0215, 'lps'),
	(591522, 130, '2014-03-15 00:47:01.000000', 'consum', 0.0219, 'lps'),
	(591523, 130, '2014-03-15 00:47:02.000000', 'consum', 0.0211, 'lps'),
	(591524, 130, '2014-03-15 00:47:03.000000', 'consum', 0.0219, 'lps'),
	(591525, 130, '2014-03-15 00:47:04.000000', 'consum', 0.0223, 'lps'),
	(591526, 130, '2014-03-15 00:47:05.000000', 'consum', 0.0219, 'lps'),
	(591527, 130, '2014-03-15 00:47:06.000000', 'consum', 0.0217, 'lps'),
	(591528, 130, '2014-03-15 00:47:07.000000', 'consum', 0.0218, 'lps'),
	(591529, 130, '2014-03-15 00:47:08.000000', 'consum', 0.0216, 'lps'),
	(591530, 130, '2014-03-15 00:47:09.000000', 'consum', 0.0216, 'lps'),
	(591531, 130, '2014-03-15 00:47:10.000000', 'consum', 0.0222, 'lps'),
	(591532, 130, '2014-03-15 00:47:11.000000', 'consum', 0.0222, 'lps'),
	(591533, 130, '2014-03-15 00:47:12.000000', 'consum', 0.0222, 'lps'),
	(591534, 130, '2014-03-15 00:47:13.000000', 'consum', 0.0218, 'lps'),
	(591535, 130, '2014-03-15 00:47:14.000000', 'consum', 0.0213, 'lps'),
	(591536, 130, '2014-03-15 00:47:15.000000', 'consum', 0.0219, 'lps'),
	(591537, 130, '2014-03-15 00:47:16.000000', 'consum', 0.0216, 'lps'),
	(591538, 130, '2014-03-15 00:47:17.000000', 'consum', 0.0213, 'lps'),
	(591539, 130, '2014-03-15 00:47:18.000000', 'consum', 0.0221, 'lps'),
	(591540, 130, '2014-03-15 00:47:19.000000', 'consum', 0.0212, 'lps'),
	(591541, 130, '2014-03-15 00:47:20.000000', 'consum', 0.0217, 'lps'),
	(591542, 130, '2014-03-15 00:47:21.000000', 'consum', 0.0223, 'lps'),
	(591543, 130, '2014-03-15 00:47:22.000000', 'consum', 0.0212, 'lps'),
	(591544, 130, '2014-03-15 00:47:23.000000', 'consum', 0.0224, 'lps'),
	(591545, 130, '2014-03-15 00:47:24.000000', 'consum', 0.0215, 'lps'),
	(591546, 130, '2014-03-15 00:47:25.000000', 'consum', 0.0210, 'lps'),
	(591547, 130, '2014-03-15 00:47:26.000000', 'consum', 0.0210, 'lps'),
	(591548, 130, '2014-03-15 00:47:27.000000', 'consum', 0.0210, 'lps'),
	(591549, 130, '2014-03-15 00:47:28.000000', 'consum', 0.0212, 'lps'),
	(591550, 130, '2014-03-15 00:47:29.000000', 'consum', 0.0222, 'lps'),
	(591551, 130, '2014-03-15 00:47:30.000000', 'consum', 0.0216, 'lps'),
	(591552, 130, '2014-03-15 00:47:31.000000', 'consum', 0.0220, 'lps'),
	(591553, 130, '2014-03-15 00:47:32.000000', 'consum', 0.0213, 'lps'),
	(591554, 130, '2014-03-15 00:47:33.000000', 'consum', 0.0211, 'lps'),
	(591555, 130, '2014-03-15 00:47:34.000000', 'consum', 0.0222, 'lps'),
	(591556, 130, '2014-03-15 00:47:35.000000', 'consum', 0.0223, 'lps'),
	(591557, 130, '2014-03-15 00:47:36.000000', 'consum', 0.0224, 'lps'),
	(591558, 130, '2014-03-15 00:47:37.000000', 'consum', 0.0213, 'lps'),
	(591559, 130, '2014-03-15 00:47:38.000000', 'consum', 0.0214, 'lps'),
	(591560, 130, '2014-03-15 00:47:39.000000', 'consum', 0.0218, 'lps'),
	(591561, 130, '2014-03-15 00:47:40.000000', 'consum', 0.0212, 'lps'),
	(591562, 130, '2014-03-15 00:47:41.000000', 'consum', 0.0210, 'lps'),
	(591563, 130, '2014-03-15 00:47:42.000000', 'consum', 0.0222, 'lps'),
	(591564, 130, '2014-03-15 00:47:43.000000', 'consum', 0.0223, 'lps'),
	(591565, 130, '2014-03-15 00:47:44.000000', 'consum', 0.0210, 'lps'),
	(591566, 130, '2014-03-15 00:47:45.000000', 'consum', 0.0215, 'lps'),
	(591567, 130, '2014-03-15 00:47:46.000000', 'consum', 0.0220, 'lps'),
	(591568, 130, '2014-03-15 00:47:47.000000', 'consum', 0.0218, 'lps'),
	(591569, 130, '2014-03-15 00:47:48.000000', 'consum', 0.0217, 'lps'),
	(591570, 130, '2014-03-15 00:47:49.000000', 'consum', 0.0210, 'lps'),
	(591571, 130, '2014-03-15 00:47:50.000000', 'consum', 0.0220, 'lps'),
	(591572, 130, '2014-03-15 00:47:51.000000', 'consum', 0.0213, 'lps'),
	(591573, 130, '2014-03-15 00:47:52.000000', 'consum', 0.0213, 'lps'),
	(591574, 130, '2014-03-15 00:47:53.000000', 'consum', 0.0217, 'lps'),
	(591575, 130, '2014-03-15 00:47:54.000000', 'consum', 0.0222, 'lps'),
	(591576, 130, '2014-03-15 00:47:55.000000', 'consum', 0.0216, 'lps'),
	(591577, 130, '2014-03-15 00:47:56.000000', 'consum', 0.0223, 'lps'),
	(591578, 130, '2014-03-15 00:47:57.000000', 'consum', 0.0212, 'lps'),
	(591579, 130, '2014-03-15 00:47:58.000000', 'consum', 0.0210, 'lps'),
	(591580, 130, '2014-03-15 00:47:59.000000', 'consum', 0.0222, 'lps'),
	(591581, 130, '2014-03-15 00:48:00.000000', 'consum', 0.0210, 'lps'),
	(591582, 130, '2014-03-15 00:48:01.000000', 'consum', 0.0217, 'lps'),
	(591583, 130, '2014-03-15 00:48:02.000000', 'consum', 0.0217, 'lps'),
	(591584, 130, '2014-03-15 00:48:03.000000', 'consum', 0.0212, 'lps'),
	(591585, 130, '2014-03-15 00:48:04.000000', 'consum', 0.0211, 'lps'),
	(591586, 130, '2014-03-15 00:48:05.000000', 'consum', 0.0210, 'lps'),
	(591587, 130, '2014-03-15 00:48:06.000000', 'consum', 0.0221, 'lps'),
	(591588, 130, '2014-03-15 00:48:07.000000', 'consum', 0.0223, 'lps'),
	(591589, 130, '2014-03-15 00:48:08.000000', 'consum', 0.0212, 'lps'),
	(591590, 130, '2014-03-15 00:48:09.000000', 'consum', 0.0211, 'lps'),
	(591591, 130, '2014-03-15 00:48:10.000000', 'consum', 0.0224, 'lps'),
	(591592, 130, '2014-03-15 00:48:11.000000', 'consum', 0.0219, 'lps'),
	(591593, 130, '2014-03-15 00:48:12.000000', 'consum', 0.0215, 'lps'),
	(591594, 130, '2014-03-15 00:48:13.000000', 'consum', 0.0220, 'lps'),
	(591595, 130, '2014-03-15 00:48:14.000000', 'consum', 0.0217, 'lps'),
	(591596, 130, '2014-03-15 00:48:15.000000', 'consum', 0.0215, 'lps'),
	(591597, 130, '2014-03-15 00:48:16.000000', 'consum', 0.0215, 'lps'),
	(591598, 130, '2014-03-15 00:48:17.000000', 'consum', 0.0221, 'lps'),
	(591599, 130, '2014-03-15 00:48:18.000000', 'consum', 0.0221, 'lps'),
	(591600, 130, '2014-03-15 00:48:19.000000', 'consum', 0.0215, 'lps'),
	(591601, 130, '2014-03-15 00:48:20.000000', 'consum', 0.0218, 'lps'),
	(591602, 130, '2014-03-15 00:48:21.000000', 'consum', 0.0222, 'lps'),
	(591603, 130, '2014-03-15 00:48:22.000000', 'consum', 0.0216, 'lps'),
	(591604, 130, '2014-03-15 00:48:23.000000', 'consum', 0.0217, 'lps'),
	(591605, 130, '2014-03-15 00:48:24.000000', 'consum', 0.0216, 'lps'),
	(591606, 130, '2014-03-15 00:48:25.000000', 'consum', 0.0216, 'lps'),
	(591607, 130, '2014-03-15 00:48:26.000000', 'consum', 0.0210, 'lps'),
	(591608, 130, '2014-03-15 00:48:27.000000', 'consum', 0.0222, 'lps'),
	(591609, 130, '2014-03-15 00:48:28.000000', 'consum', 0.0210, 'lps'),
	(591610, 130, '2014-03-15 00:48:29.000000', 'consum', 0.0221, 'lps'),
	(591611, 130, '2014-03-15 00:48:30.000000', 'consum', 0.0218, 'lps'),
	(591612, 130, '2014-03-15 00:48:31.000000', 'consum', 0.0220, 'lps'),
	(591613, 130, '2014-03-15 00:48:32.000000', 'consum', 0.0219, 'lps'),
	(591614, 130, '2014-03-15 00:48:33.000000', 'consum', 0.0214, 'lps'),
	(591615, 130, '2014-03-15 00:48:34.000000', 'consum', 0.0216, 'lps'),
	(591616, 130, '2014-03-15 00:48:35.000000', 'consum', 0.0212, 'lps'),
	(591617, 130, '2014-03-15 00:48:36.000000', 'consum', 0.0219, 'lps'),
	(591618, 130, '2014-03-15 00:48:37.000000', 'consum', 0.0218, 'lps'),
	(591619, 130, '2014-03-15 00:48:38.000000', 'consum', 0.0210, 'lps'),
	(591620, 130, '2014-03-15 00:48:39.000000', 'consum', 0.0218, 'lps'),
	(591621, 130, '2014-03-15 00:48:40.000000', 'consum', 0.0218, 'lps'),
	(591622, 130, '2014-03-15 00:48:41.000000', 'consum', 0.0213, 'lps'),
	(591623, 130, '2014-03-15 00:48:42.000000', 'consum', 0.0215, 'lps'),
	(591624, 130, '2014-03-15 00:48:43.000000', 'consum', 0.0213, 'lps'),
	(591625, 130, '2014-03-15 00:48:44.000000', 'consum', 0.0224, 'lps'),
	(591626, 130, '2014-03-15 00:48:45.000000', 'consum', 0.0214, 'lps'),
	(591627, 130, '2014-03-15 00:48:46.000000', 'consum', 0.0216, 'lps'),
	(591628, 130, '2014-03-15 00:48:47.000000', 'consum', 0.0216, 'lps'),
	(591629, 130, '2014-03-15 00:48:48.000000', 'consum', 0.0220, 'lps'),
	(591630, 130, '2014-03-15 00:48:49.000000', 'consum', 0.0215, 'lps'),
	(591631, 130, '2014-03-15 00:48:50.000000', 'consum', 0.0218, 'lps'),
	(591632, 130, '2014-03-15 00:48:51.000000', 'consum', 0.0221, 'lps'),
	(591633, 130, '2014-03-15 00:48:52.000000', 'consum', 0.0211, 'lps'),
	(591634, 130, '2014-03-15 00:48:53.000000', 'consum', 0.0212, 'lps'),
	(591635, 130, '2014-03-15 00:48:54.000000', 'consum', 0.0220, 'lps'),
	(591636, 130, '2014-03-15 00:48:55.000000', 'consum', 0.0222, 'lps'),
	(591637, 130, '2014-03-15 00:48:56.000000', 'consum', 0.0210, 'lps'),
	(591638, 130, '2014-03-15 00:48:57.000000', 'consum', 0.0221, 'lps'),
	(591639, 130, '2014-03-15 00:48:58.000000', 'consum', 0.0218, 'lps'),
	(591640, 130, '2014-03-15 00:48:59.000000', 'consum', 0.0220, 'lps'),
	(591641, 130, '2014-03-15 00:49:00.000000', 'consum', 0.0219, 'lps'),
	(591642, 130, '2014-03-15 00:49:01.000000', 'consum', 0.0213, 'lps'),
	(591643, 130, '2014-03-15 00:49:02.000000', 'consum', 0.0211, 'lps'),
	(591644, 130, '2014-03-15 00:49:03.000000', 'consum', 0.0223, 'lps'),
	(591645, 130, '2014-03-15 00:49:04.000000', 'consum', 0.0212, 'lps'),
	(591646, 130, '2014-03-15 00:49:05.000000', 'consum', 0.0214, 'lps'),
	(591647, 130, '2014-03-15 00:49:06.000000', 'consum', 0.0221, 'lps'),
	(591648, 130, '2014-03-15 00:49:07.000000', 'consum', 0.0224, 'lps'),
	(591649, 130, '2014-03-15 00:49:08.000000', 'consum', 0.0219, 'lps'),
	(591650, 130, '2014-03-15 00:49:09.000000', 'consum', 0.0214, 'lps'),
	(591651, 130, '2014-03-15 00:49:10.000000', 'consum', 0.0219, 'lps'),
	(591652, 130, '2014-03-15 00:49:11.000000', 'consum', 0.0212, 'lps'),
	(591653, 130, '2014-03-15 00:49:12.000000', 'consum', 0.0223, 'lps'),
	(591654, 130, '2014-03-15 00:49:13.000000', 'consum', 0.0212, 'lps'),
	(591655, 130, '2014-03-15 00:49:14.000000', 'consum', 0.0224, 'lps'),
	(591656, 130, '2014-03-15 00:49:15.000000', 'consum', 0.0217, 'lps'),
	(591657, 130, '2014-03-15 00:49:16.000000', 'consum', 0.0218, 'lps'),
	(591658, 130, '2014-03-15 00:49:17.000000', 'consum', 0.0216, 'lps'),
	(591659, 130, '2014-03-15 00:49:18.000000', 'consum', 0.0213, 'lps'),
	(591660, 130, '2014-03-15 00:49:19.000000', 'consum', 0.0211, 'lps'),
	(591661, 130, '2014-03-15 00:49:20.000000', 'consum', 0.0219, 'lps'),
	(591662, 130, '2014-03-15 00:49:21.000000', 'consum', 0.0210, 'lps'),
	(591663, 130, '2014-03-15 00:49:22.000000', 'consum', 0.0214, 'lps'),
	(591664, 130, '2014-03-15 00:49:23.000000', 'consum', 0.0214, 'lps'),
	(591665, 130, '2014-03-15 00:49:24.000000', 'consum', 0.0217, 'lps'),
	(591666, 130, '2014-03-15 00:49:25.000000', 'consum', 0.0218, 'lps'),
	(591667, 130, '2014-03-15 00:49:26.000000', 'consum', 0.0218, 'lps'),
	(591668, 130, '2014-03-15 00:49:27.000000', 'consum', 0.0223, 'lps'),
	(591669, 130, '2014-03-15 00:49:28.000000', 'consum', 0.0222, 'lps'),
	(591670, 130, '2014-03-15 00:49:29.000000', 'consum', 0.0217, 'lps'),
	(591671, 130, '2014-03-15 00:49:30.000000', 'consum', 0.0211, 'lps'),
	(591672, 130, '2014-03-15 00:49:31.000000', 'consum', 0.0222, 'lps'),
	(591673, 130, '2014-03-15 00:49:32.000000', 'consum', 0.0211, 'lps'),
	(591674, 130, '2014-03-15 00:49:33.000000', 'consum', 0.0221, 'lps'),
	(591675, 130, '2014-03-15 00:49:34.000000', 'consum', 0.0218, 'lps'),
	(591676, 130, '2014-03-15 00:49:35.000000', 'consum', 0.0216, 'lps'),
	(591677, 130, '2014-03-15 00:49:36.000000', 'consum', 0.0219, 'lps'),
	(591678, 130, '2014-03-15 00:49:37.000000', 'consum', 0.0220, 'lps'),
	(591679, 130, '2014-03-15 00:49:38.000000', 'consum', 0.0219, 'lps'),
	(591680, 130, '2014-03-15 00:49:39.000000', 'consum', 0.0211, 'lps'),
	(591681, 130, '2014-03-15 00:49:40.000000', 'consum', 0.0217, 'lps'),
	(591682, 130, '2014-03-15 00:49:41.000000', 'consum', 0.0213, 'lps'),
	(591683, 130, '2014-03-15 00:49:42.000000', 'consum', 0.0218, 'lps'),
	(591684, 130, '2014-03-15 00:49:43.000000', 'consum', 0.0212, 'lps'),
	(591685, 130, '2014-03-15 00:49:44.000000', 'consum', 0.0214, 'lps'),
	(591686, 130, '2014-03-15 00:49:45.000000', 'consum', 0.0222, 'lps'),
	(591687, 130, '2014-03-15 00:49:46.000000', 'consum', 0.0213, 'lps'),
	(591688, 130, '2014-03-15 00:49:47.000000', 'consum', 0.0221, 'lps'),
	(591689, 130, '2014-03-15 00:49:48.000000', 'consum', 0.0211, 'lps'),
	(591690, 130, '2014-03-15 00:49:49.000000', 'consum', 0.0214, 'lps'),
	(591691, 130, '2014-03-15 00:49:50.000000', 'consum', 0.0212, 'lps'),
	(591692, 130, '2014-03-15 00:49:51.000000', 'consum', 0.0221, 'lps'),
	(591693, 130, '2014-03-15 00:49:52.000000', 'consum', 0.0217, 'lps'),
	(591694, 130, '2014-03-15 00:49:53.000000', 'consum', 0.0210, 'lps'),
	(591695, 130, '2014-03-15 00:49:54.000000', 'consum', 0.0222, 'lps'),
	(591696, 130, '2014-03-15 00:49:55.000000', 'consum', 0.0224, 'lps'),
	(591697, 130, '2014-03-15 00:49:56.000000', 'consum', 0.0217, 'lps'),
	(591698, 130, '2014-03-15 00:49:57.000000', 'consum', 0.0217, 'lps'),
	(591699, 130, '2014-03-15 00:49:58.000000', 'consum', 0.0210, 'lps'),
	(591700, 130, '2014-03-15 00:49:59.000000', 'consum', 0.0220, 'lps'),
	(591701, 130, '2014-03-15 00:50:00.000000', 'consum', 0.0215, 'lps'),
	(591702, 130, '2014-03-15 00:50:01.000000', 'consum', 0.0220, 'lps'),
	(591703, 130, '2014-03-15 00:50:02.000000', 'consum', 0.0216, 'lps'),
	(591704, 130, '2014-03-15 00:50:03.000000', 'consum', 0.0211, 'lps'),
	(591705, 130, '2014-03-15 00:50:04.000000', 'consum', 0.0213, 'lps'),
	(591706, 130, '2014-03-15 00:50:05.000000', 'consum', 0.0222, 'lps'),
	(591707, 130, '2014-03-15 00:50:06.000000', 'consum', 0.0216, 'lps'),
	(591708, 130, '2014-03-15 00:50:07.000000', 'consum', 0.0221, 'lps'),
	(591709, 130, '2014-03-15 00:50:08.000000', 'consum', 0.0218, 'lps'),
	(591710, 130, '2014-03-15 00:50:09.000000', 'consum', 0.0218, 'lps'),
	(591711, 130, '2014-03-15 00:50:10.000000', 'consum', 0.0212, 'lps'),
	(591712, 130, '2014-03-15 00:50:11.000000', 'consum', 0.0212, 'lps'),
	(591713, 130, '2014-03-15 00:50:12.000000', 'consum', 0.0215, 'lps'),
	(591714, 130, '2014-03-15 00:50:13.000000', 'consum', 0.0213, 'lps'),
	(591715, 130, '2014-03-15 00:50:14.000000', 'consum', 0.0212, 'lps'),
	(591716, 130, '2014-03-15 00:50:15.000000', 'consum', 0.0210, 'lps'),
	(591717, 130, '2014-03-15 00:50:16.000000', 'consum', 0.0218, 'lps'),
	(591718, 130, '2014-03-15 00:50:17.000000', 'consum', 0.0224, 'lps'),
	(591719, 130, '2014-03-15 00:50:18.000000', 'consum', 0.0224, 'lps'),
	(591720, 130, '2014-03-15 00:50:19.000000', 'consum', 0.0223, 'lps'),
	(591721, 130, '2014-03-15 00:50:20.000000', 'consum', 0.0219, 'lps'),
	(591722, 130, '2014-03-15 00:50:21.000000', 'consum', 0.0216, 'lps'),
	(591723, 130, '2014-03-15 00:50:22.000000', 'consum', 0.0214, 'lps'),
	(591724, 130, '2014-03-15 00:50:23.000000', 'consum', 0.0211, 'lps'),
	(591725, 130, '2014-03-15 00:50:24.000000', 'consum', 0.0218, 'lps'),
	(591726, 130, '2014-03-15 00:50:25.000000', 'consum', 0.0217, 'lps'),
	(591727, 130, '2014-03-15 00:50:26.000000', 'consum', 0.0222, 'lps'),
	(591728, 130, '2014-03-15 00:50:27.000000', 'consum', 0.0222, 'lps'),
	(591729, 130, '2014-03-15 00:50:28.000000', 'consum', 0.0218, 'lps'),
	(591730, 130, '2014-03-15 00:50:29.000000', 'consum', 0.0213, 'lps'),
	(591731, 130, '2014-03-15 00:50:30.000000', 'consum', 0.0217, 'lps'),
	(591732, 130, '2014-03-15 00:50:31.000000', 'consum', 0.0221, 'lps'),
	(591733, 130, '2014-03-15 00:50:32.000000', 'consum', 0.0214, 'lps'),
	(591734, 130, '2014-03-15 00:50:33.000000', 'consum', 0.0213, 'lps'),
	(591735, 130, '2014-03-15 00:50:34.000000', 'consum', 0.0212, 'lps'),
	(591736, 130, '2014-03-15 00:50:35.000000', 'consum', 0.0211, 'lps'),
	(591737, 130, '2014-03-15 00:50:36.000000', 'consum', 0.0210, 'lps'),
	(591738, 130, '2014-03-15 00:50:37.000000', 'consum', 0.0223, 'lps'),
	(591739, 130, '2014-03-15 00:50:38.000000', 'consum', 0.0217, 'lps'),
	(591740, 130, '2014-03-15 00:50:39.000000', 'consum', 0.0220, 'lps'),
	(591741, 130, '2014-03-15 00:50:40.000000', 'consum', 0.0210, 'lps'),
	(591742, 130, '2014-03-15 00:50:41.000000', 'consum', 0.0224, 'lps'),
	(591743, 130, '2014-03-15 00:50:42.000000', 'consum', 0.0221, 'lps'),
	(591744, 130, '2014-03-15 00:50:43.000000', 'consum', 0.0211, 'lps'),
	(591745, 130, '2014-03-15 00:50:44.000000', 'consum', 0.0210, 'lps'),
	(591746, 130, '2014-03-15 00:50:45.000000', 'consum', 0.0223, 'lps'),
	(591747, 130, '2014-03-15 00:50:46.000000', 'consum', 0.0214, 'lps'),
	(591748, 130, '2014-03-15 00:50:47.000000', 'consum', 0.0221, 'lps'),
	(591749, 130, '2014-03-15 00:50:48.000000', 'consum', 0.0211, 'lps'),
	(591750, 130, '2014-03-15 00:50:49.000000', 'consum', 0.0211, 'lps'),
	(591751, 130, '2014-03-15 00:50:50.000000', 'consum', 0.0212, 'lps'),
	(591752, 130, '2014-03-15 00:50:51.000000', 'consum', 0.0220, 'lps'),
	(591753, 130, '2014-03-15 00:50:52.000000', 'consum', 0.0222, 'lps'),
	(591754, 130, '2014-03-15 00:50:53.000000', 'consum', 0.0210, 'lps'),
	(591755, 130, '2014-03-15 00:50:54.000000', 'consum', 0.0222, 'lps'),
	(591756, 130, '2014-03-15 00:50:55.000000', 'consum', 0.0211, 'lps'),
	(591757, 130, '2014-03-15 00:50:56.000000', 'consum', 0.0222, 'lps'),
	(591758, 130, '2014-03-15 00:50:57.000000', 'consum', 0.0224, 'lps'),
	(591759, 130, '2014-03-15 00:50:58.000000', 'consum', 0.0215, 'lps'),
	(591760, 130, '2014-03-15 00:50:59.000000', 'consum', 0.0224, 'lps'),
	(591761, 130, '2014-03-15 00:51:00.000000', 'consum', 0.0221, 'lps'),
	(591762, 130, '2014-03-15 00:51:01.000000', 'consum', 0.0222, 'lps'),
	(591763, 130, '2014-03-15 00:51:02.000000', 'consum', 0.0222, 'lps'),
	(591764, 130, '2014-03-15 00:51:03.000000', 'consum', 0.0219, 'lps'),
	(591765, 130, '2014-03-15 00:51:04.000000', 'consum', 0.0219, 'lps'),
	(591766, 130, '2014-03-15 00:51:05.000000', 'consum', 0.0213, 'lps'),
	(591767, 130, '2014-03-15 00:51:06.000000', 'consum', 0.0216, 'lps'),
	(591768, 130, '2014-03-15 00:51:07.000000', 'consum', 0.0214, 'lps'),
	(591769, 130, '2014-03-15 00:51:08.000000', 'consum', 0.0215, 'lps'),
	(591770, 130, '2014-03-15 00:51:09.000000', 'consum', 0.0223, 'lps'),
	(591771, 130, '2014-03-15 00:51:10.000000', 'consum', 0.0217, 'lps'),
	(591772, 130, '2014-03-15 00:51:11.000000', 'consum', 0.0221, 'lps'),
	(591773, 130, '2014-03-15 00:51:12.000000', 'consum', 0.0214, 'lps'),
	(591774, 130, '2014-03-15 00:51:13.000000', 'consum', 0.0212, 'lps'),
	(591775, 130, '2014-03-15 00:51:14.000000', 'consum', 0.0223, 'lps'),
	(591776, 130, '2014-03-15 00:51:15.000000', 'consum', 0.0210, 'lps'),
	(591777, 130, '2014-03-15 00:51:16.000000', 'consum', 0.0215, 'lps'),
	(591778, 130, '2014-03-15 00:51:17.000000', 'consum', 0.0221, 'lps'),
	(591779, 130, '2014-03-15 00:51:18.000000', 'consum', 0.0221, 'lps'),
	(591780, 130, '2014-03-15 00:51:19.000000', 'consum', 0.0216, 'lps'),
	(591781, 130, '2014-03-15 00:51:20.000000', 'consum', 0.0224, 'lps'),
	(591782, 130, '2014-03-15 00:51:21.000000', 'consum', 0.0218, 'lps'),
	(591783, 130, '2014-03-15 00:51:22.000000', 'consum', 0.0222, 'lps'),
	(591784, 130, '2014-03-15 00:51:23.000000', 'consum', 0.0216, 'lps'),
	(591785, 130, '2014-03-15 00:51:24.000000', 'consum', 0.0221, 'lps'),
	(591786, 130, '2014-03-15 00:51:25.000000', 'consum', 0.0218, 'lps'),
	(591787, 130, '2014-03-15 00:51:26.000000', 'consum', 0.0215, 'lps'),
	(591788, 130, '2014-03-15 00:51:27.000000', 'consum', 0.0212, 'lps'),
	(591789, 130, '2014-03-15 00:51:28.000000', 'consum', 0.0219, 'lps'),
	(591790, 130, '2014-03-15 00:51:29.000000', 'consum', 0.0221, 'lps'),
	(591791, 130, '2014-03-15 00:51:30.000000', 'consum', 0.0222, 'lps'),
	(591792, 130, '2014-03-15 00:51:31.000000', 'consum', 0.0222, 'lps'),
	(591793, 130, '2014-03-15 00:51:32.000000', 'consum', 0.0223, 'lps'),
	(591794, 130, '2014-03-15 00:51:33.000000', 'consum', 0.0221, 'lps'),
	(591795, 130, '2014-03-15 00:51:34.000000', 'consum', 0.0213, 'lps'),
	(591796, 130, '2014-03-15 00:51:35.000000', 'consum', 0.0222, 'lps'),
	(591797, 130, '2014-03-15 00:51:36.000000', 'consum', 0.0217, 'lps'),
	(591798, 130, '2014-03-15 00:51:37.000000', 'consum', 0.0210, 'lps'),
	(591799, 130, '2014-03-15 00:51:38.000000', 'consum', 0.0219, 'lps'),
	(591800, 130, '2014-03-15 00:51:39.000000', 'consum', 0.0212, 'lps'),
	(591801, 130, '2014-03-15 00:51:40.000000', 'consum', 0.0221, 'lps'),
	(591802, 130, '2014-03-15 00:51:41.000000', 'consum', 0.0216, 'lps'),
	(591803, 130, '2014-03-15 00:51:42.000000', 'consum', 0.0223, 'lps'),
	(591804, 130, '2014-03-15 00:51:43.000000', 'consum', 0.0211, 'lps'),
	(591805, 130, '2014-03-15 00:51:44.000000', 'consum', 0.0221, 'lps'),
	(591806, 130, '2014-03-15 00:51:45.000000', 'consum', 0.0216, 'lps'),
	(591807, 130, '2014-03-15 00:51:46.000000', 'consum', 0.0210, 'lps'),
	(591808, 130, '2014-03-15 00:51:47.000000', 'consum', 0.0223, 'lps'),
	(591809, 130, '2014-03-15 00:51:48.000000', 'consum', 0.0215, 'lps'),
	(591810, 130, '2014-03-15 00:51:49.000000', 'consum', 0.0212, 'lps'),
	(591811, 130, '2014-03-15 00:51:50.000000', 'consum', 0.0219, 'lps'),
	(591812, 130, '2014-03-15 00:51:51.000000', 'consum', 0.0221, 'lps'),
	(591813, 130, '2014-03-15 00:51:52.000000', 'consum', 0.0222, 'lps'),
	(591814, 130, '2014-03-15 00:51:53.000000', 'consum', 0.0224, 'lps'),
	(591815, 130, '2014-03-15 00:51:54.000000', 'consum', 0.0215, 'lps'),
	(591816, 130, '2014-03-15 00:51:55.000000', 'consum', 0.0224, 'lps'),
	(591817, 130, '2014-03-15 00:51:56.000000', 'consum', 0.0219, 'lps'),
	(591818, 130, '2014-03-15 00:51:57.000000', 'consum', 0.0214, 'lps'),
	(591819, 130, '2014-03-15 00:51:58.000000', 'consum', 0.0220, 'lps'),
	(591820, 130, '2014-03-15 00:51:59.000000', 'consum', 0.0218, 'lps'),
	(591821, 130, '2014-03-15 00:52:00.000000', 'consum', 0.0220, 'lps'),
	(591822, 130, '2014-03-15 00:52:01.000000', 'consum', 0.0222, 'lps'),
	(591823, 130, '2014-03-15 00:52:02.000000', 'consum', 0.0211, 'lps'),
	(591824, 130, '2014-03-15 00:52:03.000000', 'consum', 0.0223, 'lps'),
	(591825, 130, '2014-03-15 00:52:04.000000', 'consum', 0.0214, 'lps'),
	(591826, 130, '2014-03-15 00:52:05.000000', 'consum', 0.0222, 'lps'),
	(591827, 130, '2014-03-15 00:52:06.000000', 'consum', 0.0214, 'lps'),
	(591828, 130, '2014-03-15 00:52:07.000000', 'consum', 0.0223, 'lps'),
	(591829, 130, '2014-03-15 00:52:08.000000', 'consum', 0.0217, 'lps'),
	(591830, 130, '2014-03-15 00:52:09.000000', 'consum', 0.0224, 'lps'),
	(591831, 130, '2014-03-15 00:52:10.000000', 'consum', 0.0212, 'lps'),
	(591832, 130, '2014-03-15 00:52:11.000000', 'consum', 0.0211, 'lps'),
	(591833, 130, '2014-03-15 00:52:12.000000', 'consum', 0.0221, 'lps'),
	(591834, 130, '2014-03-15 00:52:13.000000', 'consum', 0.0221, 'lps'),
	(591835, 130, '2014-03-15 00:52:14.000000', 'consum', 0.0218, 'lps'),
	(591836, 130, '2014-03-15 00:52:15.000000', 'consum', 0.0216, 'lps'),
	(591837, 130, '2014-03-15 00:52:16.000000', 'consum', 0.0215, 'lps'),
	(591838, 130, '2014-03-15 00:52:17.000000', 'consum', 0.0218, 'lps'),
	(591839, 130, '2014-03-15 00:52:18.000000', 'consum', 0.0219, 'lps'),
	(591840, 130, '2014-03-15 00:52:19.000000', 'consum', 0.0218, 'lps'),
	(591841, 130, '2014-03-15 00:52:20.000000', 'consum', 0.0223, 'lps'),
	(591842, 130, '2014-03-15 00:52:21.000000', 'consum', 0.0224, 'lps'),
	(591843, 130, '2014-03-15 00:52:22.000000', 'consum', 0.0224, 'lps'),
	(591844, 130, '2014-03-15 00:52:23.000000', 'consum', 0.0210, 'lps'),
	(591845, 130, '2014-03-15 00:52:24.000000', 'consum', 0.0212, 'lps'),
	(591846, 130, '2014-03-15 00:52:25.000000', 'consum', 0.0221, 'lps'),
	(591847, 130, '2014-03-15 00:52:26.000000', 'consum', 0.0213, 'lps'),
	(591848, 130, '2014-03-15 00:52:27.000000', 'consum', 0.0222, 'lps'),
	(591849, 130, '2014-03-15 00:52:28.000000', 'consum', 0.0218, 'lps'),
	(591850, 130, '2014-03-15 00:52:29.000000', 'consum', 0.0214, 'lps'),
	(591851, 130, '2014-03-15 00:52:30.000000', 'consum', 0.0220, 'lps'),
	(591852, 130, '2014-03-15 00:52:31.000000', 'consum', 0.0221, 'lps'),
	(591853, 130, '2014-03-15 00:52:32.000000', 'consum', 0.0221, 'lps'),
	(591854, 130, '2014-03-15 00:52:33.000000', 'consum', 0.0215, 'lps'),
	(591855, 130, '2014-03-15 00:52:34.000000', 'consum', 0.0218, 'lps'),
	(591856, 130, '2014-03-15 00:52:35.000000', 'consum', 0.0221, 'lps'),
	(591857, 130, '2014-03-15 00:52:36.000000', 'consum', 0.0212, 'lps'),
	(591858, 130, '2014-03-15 00:52:37.000000', 'consum', 0.0215, 'lps'),
	(591859, 130, '2014-03-15 00:52:38.000000', 'consum', 0.0216, 'lps'),
	(591860, 130, '2014-03-15 00:52:39.000000', 'consum', 0.0212, 'lps'),
	(591861, 130, '2014-03-15 00:52:40.000000', 'consum', 0.0215, 'lps'),
	(591862, 130, '2014-03-15 00:52:41.000000', 'consum', 0.0216, 'lps'),
	(591863, 130, '2014-03-15 00:52:42.000000', 'consum', 0.0224, 'lps'),
	(591864, 130, '2014-03-15 00:52:43.000000', 'consum', 0.0219, 'lps'),
	(591865, 130, '2014-03-15 00:52:44.000000', 'consum', 0.0211, 'lps'),
	(591866, 130, '2014-03-15 00:52:45.000000', 'consum', 0.0221, 'lps'),
	(591867, 130, '2014-03-15 00:52:46.000000', 'consum', 0.0218, 'lps'),
	(591868, 130, '2014-03-15 00:52:47.000000', 'consum', 0.0219, 'lps'),
	(591869, 130, '2014-03-15 00:52:48.000000', 'consum', 0.0213, 'lps'),
	(591870, 130, '2014-03-15 00:52:49.000000', 'consum', 0.0216, 'lps'),
	(591871, 130, '2014-03-15 00:52:50.000000', 'consum', 0.0214, 'lps'),
	(591872, 130, '2014-03-15 00:52:51.000000', 'consum', 0.0216, 'lps'),
	(591873, 130, '2014-03-15 00:52:52.000000', 'consum', 0.0210, 'lps'),
	(591874, 130, '2014-03-15 00:52:53.000000', 'consum', 0.0210, 'lps'),
	(591875, 130, '2014-03-15 00:52:54.000000', 'consum', 0.0223, 'lps'),
	(591876, 130, '2014-03-15 00:52:55.000000', 'consum', 0.0219, 'lps'),
	(591877, 130, '2014-03-15 00:52:56.000000', 'consum', 0.0214, 'lps'),
	(591878, 130, '2014-03-15 00:52:57.000000', 'consum', 0.0217, 'lps'),
	(591879, 130, '2014-03-15 00:52:58.000000', 'consum', 0.0221, 'lps'),
	(591880, 130, '2014-03-15 00:52:59.000000', 'consum', 0.0212, 'lps'),
	(591881, 130, '2014-03-15 00:53:00.000000', 'consum', 0.0218, 'lps'),
	(591882, 130, '2014-03-15 00:53:01.000000', 'consum', 0.0216, 'lps'),
	(591883, 130, '2014-03-15 00:53:02.000000', 'consum', 0.0216, 'lps'),
	(591884, 130, '2014-03-15 00:53:03.000000', 'consum', 0.0223, 'lps'),
	(591885, 130, '2014-03-15 00:53:04.000000', 'consum', 0.0212, 'lps'),
	(591886, 130, '2014-03-15 00:53:05.000000', 'consum', 0.0213, 'lps'),
	(591887, 130, '2014-03-15 00:53:06.000000', 'consum', 0.0217, 'lps'),
	(591888, 130, '2014-03-15 00:53:07.000000', 'consum', 0.0224, 'lps'),
	(591889, 130, '2014-03-15 00:53:08.000000', 'consum', 0.0212, 'lps'),
	(591890, 130, '2014-03-15 00:53:09.000000', 'consum', 0.0210, 'lps'),
	(591891, 130, '2014-03-15 00:53:10.000000', 'consum', 0.0221, 'lps'),
	(591892, 130, '2014-03-15 00:53:11.000000', 'consum', 0.0219, 'lps'),
	(591893, 130, '2014-03-15 00:53:12.000000', 'consum', 0.0224, 'lps'),
	(591894, 130, '2014-03-15 00:53:13.000000', 'consum', 0.0222, 'lps'),
	(591895, 130, '2014-03-15 00:53:14.000000', 'consum', 0.0216, 'lps'),
	(591896, 130, '2014-03-15 00:53:15.000000', 'consum', 0.0216, 'lps'),
	(591897, 130, '2014-03-15 00:53:16.000000', 'consum', 0.0224, 'lps'),
	(591898, 130, '2014-03-15 00:53:17.000000', 'consum', 0.0219, 'lps'),
	(591899, 130, '2014-03-15 00:53:18.000000', 'consum', 0.0212, 'lps'),
	(591900, 130, '2014-03-15 00:53:19.000000', 'consum', 0.0223, 'lps'),
	(591901, 130, '2014-03-15 00:53:20.000000', 'consum', 0.0210, 'lps'),
	(591902, 130, '2014-03-15 00:53:21.000000', 'consum', 0.0218, 'lps'),
	(591903, 130, '2014-03-15 00:53:22.000000', 'consum', 0.0220, 'lps'),
	(591904, 130, '2014-03-15 00:53:23.000000', 'consum', 0.0219, 'lps'),
	(591905, 130, '2014-03-15 00:53:24.000000', 'consum', 0.0212, 'lps'),
	(591906, 130, '2014-03-15 00:53:25.000000', 'consum', 0.0210, 'lps'),
	(591907, 130, '2014-03-15 00:53:26.000000', 'consum', 0.0218, 'lps'),
	(591908, 130, '2014-03-15 00:53:27.000000', 'consum', 0.0221, 'lps'),
	(591909, 130, '2014-03-15 00:53:28.000000', 'consum', 0.0211, 'lps'),
	(591910, 130, '2014-03-15 00:53:29.000000', 'consum', 0.0212, 'lps'),
	(591911, 130, '2014-03-15 00:53:30.000000', 'consum', 0.0217, 'lps'),
	(591912, 130, '2014-03-15 00:53:31.000000', 'consum', 0.0211, 'lps'),
	(591913, 130, '2014-03-15 00:53:32.000000', 'consum', 0.0222, 'lps'),
	(591914, 130, '2014-03-15 00:53:33.000000', 'consum', 0.0210, 'lps'),
	(591915, 130, '2014-03-15 00:53:34.000000', 'consum', 0.0219, 'lps'),
	(591916, 130, '2014-03-15 00:53:35.000000', 'consum', 0.0224, 'lps'),
	(591917, 130, '2014-03-15 00:53:36.000000', 'consum', 0.0222, 'lps'),
	(591918, 130, '2014-03-15 00:53:37.000000', 'consum', 0.0216, 'lps'),
	(591919, 130, '2014-03-15 00:53:38.000000', 'consum', 0.0221, 'lps'),
	(591920, 130, '2014-03-15 00:53:39.000000', 'consum', 0.0215, 'lps'),
	(591921, 130, '2014-03-15 00:53:40.000000', 'consum', 0.0216, 'lps'),
	(591922, 130, '2014-03-15 00:53:41.000000', 'consum', 0.0214, 'lps'),
	(591923, 130, '2014-03-15 00:53:42.000000', 'consum', 0.0212, 'lps'),
	(591924, 130, '2014-03-15 00:53:43.000000', 'consum', 0.0222, 'lps'),
	(591925, 130, '2014-03-15 00:53:44.000000', 'consum', 0.0219, 'lps'),
	(591926, 130, '2014-03-15 00:53:45.000000', 'consum', 0.0220, 'lps'),
	(591927, 130, '2014-03-15 00:53:46.000000', 'consum', 0.0217, 'lps'),
	(591928, 130, '2014-03-15 00:53:47.000000', 'consum', 0.0216, 'lps'),
	(591929, 130, '2014-03-15 00:53:48.000000', 'consum', 0.0222, 'lps'),
	(591930, 130, '2014-03-15 00:53:49.000000', 'consum', 0.0222, 'lps'),
	(591931, 130, '2014-03-15 00:53:50.000000', 'consum', 0.0217, 'lps'),
	(591932, 130, '2014-03-15 00:53:51.000000', 'consum', 0.0211, 'lps'),
	(591933, 130, '2014-03-15 00:53:52.000000', 'consum', 0.0223, 'lps'),
	(591934, 130, '2014-03-15 00:53:53.000000', 'consum', 0.0214, 'lps'),
	(591935, 130, '2014-03-15 00:53:54.000000', 'consum', 0.0220, 'lps'),
	(591936, 130, '2014-03-15 00:53:55.000000', 'consum', 0.0217, 'lps'),
	(591937, 130, '2014-03-15 00:53:56.000000', 'consum', 0.0218, 'lps'),
	(591938, 130, '2014-03-15 00:53:57.000000', 'consum', 0.0213, 'lps'),
	(591939, 130, '2014-03-15 00:53:58.000000', 'consum', 0.0218, 'lps'),
	(591940, 130, '2014-03-15 00:53:59.000000', 'consum', 0.0211, 'lps'),
	(591941, 130, '2014-03-15 00:54:00.000000', 'consum', 0.0221, 'lps'),
	(591942, 130, '2014-03-15 00:54:01.000000', 'consum', 0.0219, 'lps'),
	(591943, 130, '2014-03-15 00:54:02.000000', 'consum', 0.0221, 'lps'),
	(591944, 130, '2014-03-15 00:54:03.000000', 'consum', 0.0222, 'lps'),
	(591945, 130, '2014-03-15 00:54:04.000000', 'consum', 0.0224, 'lps'),
	(591946, 130, '2014-03-15 00:54:05.000000', 'consum', 0.0213, 'lps'),
	(591947, 130, '2014-03-15 00:54:06.000000', 'consum', 0.0216, 'lps'),
	(591948, 130, '2014-03-15 00:54:07.000000', 'consum', 0.0217, 'lps'),
	(591949, 130, '2014-03-15 00:54:08.000000', 'consum', 0.0211, 'lps'),
	(591950, 130, '2014-03-15 00:54:09.000000', 'consum', 0.0211, 'lps'),
	(591951, 130, '2014-03-15 00:54:10.000000', 'consum', 0.0212, 'lps'),
	(591952, 130, '2014-03-15 00:54:11.000000', 'consum', 0.0217, 'lps'),
	(591953, 130, '2014-03-15 00:54:12.000000', 'consum', 0.0211, 'lps'),
	(591954, 130, '2014-03-15 00:54:13.000000', 'consum', 0.0224, 'lps'),
	(591955, 130, '2014-03-15 00:54:14.000000', 'consum', 0.0219, 'lps'),
	(591956, 130, '2014-03-15 00:54:15.000000', 'consum', 0.0211, 'lps'),
	(591957, 130, '2014-03-15 00:54:16.000000', 'consum', 0.0220, 'lps'),
	(591958, 130, '2014-03-15 00:54:17.000000', 'consum', 0.0214, 'lps'),
	(591959, 130, '2014-03-15 00:54:18.000000', 'consum', 0.0213, 'lps'),
	(591960, 130, '2014-03-15 00:54:19.000000', 'consum', 0.0216, 'lps'),
	(591961, 130, '2014-03-15 00:54:20.000000', 'consum', 0.0216, 'lps'),
	(591962, 130, '2014-03-15 00:54:21.000000', 'consum', 0.0222, 'lps'),
	(591963, 130, '2014-03-15 00:54:22.000000', 'consum', 0.0224, 'lps'),
	(591964, 130, '2014-03-15 00:54:23.000000', 'consum', 0.0214, 'lps'),
	(591965, 130, '2014-03-15 00:54:24.000000', 'consum', 0.0220, 'lps'),
	(591966, 130, '2014-03-15 00:54:25.000000', 'consum', 0.0217, 'lps'),
	(591967, 130, '2014-03-15 00:54:26.000000', 'consum', 0.0216, 'lps'),
	(591968, 130, '2014-03-15 00:54:27.000000', 'consum', 0.0218, 'lps'),
	(591969, 130, '2014-03-15 00:54:28.000000', 'consum', 0.0219, 'lps'),
	(591970, 130, '2014-03-15 00:54:29.000000', 'consum', 0.0216, 'lps'),
	(591971, 130, '2014-03-15 00:54:30.000000', 'consum', 0.0212, 'lps'),
	(591972, 130, '2014-03-15 00:54:31.000000', 'consum', 0.0218, 'lps'),
	(591973, 130, '2014-03-15 00:54:32.000000', 'consum', 0.0214, 'lps'),
	(591974, 130, '2014-03-15 00:54:33.000000', 'consum', 0.0223, 'lps'),
	(591975, 130, '2014-03-15 00:54:34.000000', 'consum', 0.0218, 'lps'),
	(591976, 130, '2014-03-15 00:54:35.000000', 'consum', 0.0211, 'lps'),
	(591977, 130, '2014-03-15 00:54:36.000000', 'consum', 0.0221, 'lps'),
	(591978, 130, '2014-03-15 00:54:37.000000', 'consum', 0.0218, 'lps'),
	(591979, 130, '2014-03-15 00:54:38.000000', 'consum', 0.0216, 'lps'),
	(591980, 130, '2014-03-15 00:54:39.000000', 'consum', 0.0216, 'lps'),
	(591981, 130, '2014-03-15 00:54:40.000000', 'consum', 0.0223, 'lps'),
	(591982, 130, '2014-03-15 00:54:41.000000', 'consum', 0.0214, 'lps'),
	(591983, 130, '2014-03-15 00:54:42.000000', 'consum', 0.0220, 'lps'),
	(591984, 130, '2014-03-15 00:54:43.000000', 'consum', 0.0220, 'lps'),
	(591985, 130, '2014-03-15 00:54:44.000000', 'consum', 0.0213, 'lps'),
	(591986, 130, '2014-03-15 00:54:45.000000', 'consum', 0.0212, 'lps'),
	(591987, 130, '2014-03-15 00:54:46.000000', 'consum', 0.0213, 'lps'),
	(591988, 130, '2014-03-15 00:54:47.000000', 'consum', 0.0217, 'lps'),
	(591989, 130, '2014-03-15 00:54:48.000000', 'consum', 0.0221, 'lps'),
	(591990, 130, '2014-03-15 00:54:49.000000', 'consum', 0.0215, 'lps'),
	(591991, 130, '2014-03-15 00:54:50.000000', 'consum', 0.0219, 'lps'),
	(591992, 130, '2014-03-15 00:54:51.000000', 'consum', 0.0212, 'lps'),
	(591993, 130, '2014-03-15 00:54:52.000000', 'consum', 0.0220, 'lps'),
	(591994, 130, '2014-03-15 00:54:53.000000', 'consum', 0.0210, 'lps'),
	(591995, 130, '2014-03-15 00:54:54.000000', 'consum', 0.0211, 'lps'),
	(591996, 130, '2014-03-15 00:54:55.000000', 'consum', 0.0215, 'lps'),
	(591997, 130, '2014-03-15 00:54:56.000000', 'consum', 0.0220, 'lps'),
	(591998, 130, '2014-03-15 00:54:57.000000', 'consum', 0.0213, 'lps'),
	(591999, 130, '2014-03-15 00:54:58.000000', 'consum', 0.0210, 'lps'),
	(592000, 130, '2014-03-15 00:54:59.000000', 'consum', 0.0215, 'lps'),
	(592001, 130, '2014-03-15 00:55:00.000000', 'consum', 0.0223, 'lps'),
	(592002, 130, '2014-03-15 00:55:01.000000', 'consum', 0.0215, 'lps'),
	(592003, 130, '2014-03-15 00:55:02.000000', 'consum', 0.0211, 'lps'),
	(592004, 130, '2014-03-15 00:55:03.000000', 'consum', 0.0214, 'lps'),
	(592005, 130, '2014-03-15 00:55:04.000000', 'consum', 0.0215, 'lps'),
	(592006, 130, '2014-03-15 00:55:05.000000', 'consum', 0.0223, 'lps'),
	(592007, 130, '2014-03-15 00:55:06.000000', 'consum', 0.0217, 'lps'),
	(592008, 130, '2014-03-15 00:55:07.000000', 'consum', 0.0219, 'lps'),
	(592009, 130, '2014-03-15 00:55:08.000000', 'consum', 0.0218, 'lps'),
	(592010, 130, '2014-03-15 00:55:09.000000', 'consum', 0.0212, 'lps'),
	(592011, 130, '2014-03-15 00:55:10.000000', 'consum', 0.0224, 'lps'),
	(592012, 130, '2014-03-15 00:55:11.000000', 'consum', 0.0213, 'lps'),
	(592013, 130, '2014-03-15 00:55:12.000000', 'consum', 0.0217, 'lps'),
	(592014, 130, '2014-03-15 00:55:13.000000', 'consum', 0.0220, 'lps'),
	(592015, 130, '2014-03-15 00:55:14.000000', 'consum', 0.0211, 'lps'),
	(592016, 130, '2014-03-15 00:55:15.000000', 'consum', 0.0216, 'lps'),
	(592017, 130, '2014-03-15 00:55:16.000000', 'consum', 0.0220, 'lps'),
	(592018, 130, '2014-03-15 00:55:17.000000', 'consum', 0.0213, 'lps'),
	(592019, 130, '2014-03-15 00:55:18.000000', 'consum', 0.0212, 'lps'),
	(592020, 130, '2014-03-15 00:55:19.000000', 'consum', 0.0213, 'lps'),
	(592021, 130, '2014-03-15 00:55:20.000000', 'consum', 0.0217, 'lps'),
	(592022, 130, '2014-03-15 00:55:21.000000', 'consum', 0.0222, 'lps'),
	(592023, 130, '2014-03-15 00:55:22.000000', 'consum', 0.0220, 'lps'),
	(592024, 130, '2014-03-15 00:55:23.000000', 'consum', 0.0211, 'lps'),
	(592025, 130, '2014-03-15 00:55:24.000000', 'consum', 0.0215, 'lps'),
	(592026, 130, '2014-03-15 00:55:25.000000', 'consum', 0.0216, 'lps'),
	(592027, 130, '2014-03-15 00:55:26.000000', 'consum', 0.0213, 'lps'),
	(592028, 130, '2014-03-15 00:55:27.000000', 'consum', 0.0221, 'lps'),
	(592029, 130, '2014-03-15 00:55:28.000000', 'consum', 0.0210, 'lps'),
	(592030, 130, '2014-03-15 00:55:29.000000', 'consum', 0.0223, 'lps'),
	(592031, 130, '2014-03-15 00:55:30.000000', 'consum', 0.0218, 'lps'),
	(592032, 130, '2014-03-15 00:55:31.000000', 'consum', 0.0210, 'lps'),
	(592033, 130, '2014-03-15 00:55:32.000000', 'consum', 0.0216, 'lps'),
	(592034, 130, '2014-03-15 00:55:33.000000', 'consum', 0.0224, 'lps'),
	(592035, 130, '2014-03-15 00:55:34.000000', 'consum', 0.0219, 'lps'),
	(592036, 130, '2014-03-15 00:55:35.000000', 'consum', 0.0213, 'lps'),
	(592037, 130, '2014-03-15 00:55:36.000000', 'consum', 0.0212, 'lps'),
	(592038, 130, '2014-03-15 00:55:37.000000', 'consum', 0.0212, 'lps'),
	(592039, 130, '2014-03-15 00:55:38.000000', 'consum', 0.0216, 'lps'),
	(592040, 130, '2014-03-15 00:55:39.000000', 'consum', 0.0219, 'lps'),
	(592041, 130, '2014-03-15 00:55:40.000000', 'consum', 0.0220, 'lps'),
	(592042, 130, '2014-03-15 00:55:41.000000', 'consum', 0.0222, 'lps'),
	(592043, 130, '2014-03-15 00:55:42.000000', 'consum', 0.0224, 'lps'),
	(592044, 130, '2014-03-15 00:55:43.000000', 'consum', 0.0214, 'lps'),
	(592045, 130, '2014-03-15 00:55:44.000000', 'consum', 0.0218, 'lps'),
	(592046, 130, '2014-03-15 00:55:45.000000', 'consum', 0.0211, 'lps'),
	(592047, 130, '2014-03-15 00:55:46.000000', 'consum', 0.0221, 'lps'),
	(592048, 130, '2014-03-15 00:55:47.000000', 'consum', 0.0218, 'lps'),
	(592049, 130, '2014-03-15 00:55:48.000000', 'consum', 0.0215, 'lps'),
	(592050, 130, '2014-03-15 00:55:49.000000', 'consum', 0.0212, 'lps'),
	(592051, 130, '2014-03-15 00:55:50.000000', 'consum', 0.0220, 'lps'),
	(592052, 130, '2014-03-15 00:55:51.000000', 'consum', 0.0210, 'lps'),
	(592053, 130, '2014-03-15 00:55:52.000000', 'consum', 0.0212, 'lps'),
	(592054, 130, '2014-03-15 00:55:53.000000', 'consum', 0.0220, 'lps'),
	(592055, 130, '2014-03-15 00:55:54.000000', 'consum', 0.0210, 'lps'),
	(592056, 130, '2014-03-15 00:55:55.000000', 'consum', 0.0211, 'lps'),
	(592057, 130, '2014-03-15 00:55:56.000000', 'consum', 0.0216, 'lps'),
	(592058, 130, '2014-03-15 00:55:57.000000', 'consum', 0.0220, 'lps'),
	(592059, 130, '2014-03-15 00:55:58.000000', 'consum', 0.0216, 'lps'),
	(592060, 130, '2014-03-15 00:55:59.000000', 'consum', 0.0223, 'lps'),
	(592061, 130, '2014-03-15 00:56:00.000000', 'consum', 0.0211, 'lps'),
	(592062, 130, '2014-03-15 00:56:01.000000', 'consum', 0.0223, 'lps'),
	(592063, 130, '2014-03-15 00:56:02.000000', 'consum', 0.0212, 'lps'),
	(592064, 130, '2014-03-15 00:56:03.000000', 'consum', 0.0211, 'lps'),
	(592065, 130, '2014-03-15 00:56:04.000000', 'consum', 0.0224, 'lps'),
	(592066, 130, '2014-03-15 00:56:05.000000', 'consum', 0.0217, 'lps'),
	(592067, 130, '2014-03-15 00:56:06.000000', 'consum', 0.0220, 'lps'),
	(592068, 130, '2014-03-15 00:56:07.000000', 'consum', 0.0224, 'lps'),
	(592069, 130, '2014-03-15 00:56:08.000000', 'consum', 0.0219, 'lps'),
	(592070, 130, '2014-03-15 00:56:09.000000', 'consum', 0.0213, 'lps'),
	(592071, 130, '2014-03-15 00:56:10.000000', 'consum', 0.0215, 'lps'),
	(592072, 130, '2014-03-15 00:56:11.000000', 'consum', 0.0212, 'lps'),
	(592073, 130, '2014-03-15 00:56:12.000000', 'consum', 0.0218, 'lps'),
	(592074, 130, '2014-03-15 00:56:13.000000', 'consum', 0.0217, 'lps'),
	(592075, 130, '2014-03-15 00:56:14.000000', 'consum', 0.0221, 'lps'),
	(592076, 130, '2014-03-15 00:56:15.000000', 'consum', 0.0212, 'lps'),
	(592077, 130, '2014-03-15 00:56:16.000000', 'consum', 0.0221, 'lps'),
	(592078, 130, '2014-03-15 00:56:17.000000', 'consum', 0.0214, 'lps'),
	(592079, 130, '2014-03-15 00:56:18.000000', 'consum', 0.0210, 'lps'),
	(592080, 130, '2014-03-15 00:56:19.000000', 'consum', 0.0216, 'lps'),
	(592081, 130, '2014-03-15 00:56:20.000000', 'consum', 0.0212, 'lps'),
	(592082, 130, '2014-03-15 00:56:21.000000', 'consum', 0.0214, 'lps'),
	(592083, 130, '2014-03-15 00:56:22.000000', 'consum', 0.0213, 'lps'),
	(592084, 130, '2014-03-15 00:56:23.000000', 'consum', 0.0211, 'lps'),
	(592085, 130, '2014-03-15 00:56:24.000000', 'consum', 0.0223, 'lps'),
	(592086, 130, '2014-03-15 00:56:25.000000', 'consum', 0.0211, 'lps'),
	(592087, 130, '2014-03-15 00:56:26.000000', 'consum', 0.0221, 'lps'),
	(592088, 130, '2014-03-15 00:56:27.000000', 'consum', 0.0220, 'lps'),
	(592089, 130, '2014-03-15 00:56:28.000000', 'consum', 0.0212, 'lps'),
	(592090, 130, '2014-03-15 00:56:29.000000', 'consum', 0.0222, 'lps'),
	(592091, 130, '2014-03-15 00:56:30.000000', 'consum', 0.0218, 'lps'),
	(592092, 130, '2014-03-15 00:56:31.000000', 'consum', 0.0213, 'lps'),
	(592093, 130, '2014-03-15 00:56:32.000000', 'consum', 0.0219, 'lps'),
	(592094, 130, '2014-03-15 00:56:33.000000', 'consum', 0.0216, 'lps'),
	(592095, 130, '2014-03-15 00:56:34.000000', 'consum', 0.0213, 'lps'),
	(592096, 130, '2014-03-15 00:56:35.000000', 'consum', 0.0222, 'lps'),
	(592097, 130, '2014-03-15 00:56:36.000000', 'consum', 0.0217, 'lps'),
	(592098, 130, '2014-03-15 00:56:37.000000', 'consum', 0.0223, 'lps'),
	(592099, 130, '2014-03-15 00:56:38.000000', 'consum', 0.0212, 'lps'),
	(592100, 130, '2014-03-15 00:56:39.000000', 'consum', 0.0212, 'lps'),
	(592101, 130, '2014-03-15 00:56:40.000000', 'consum', 0.0213, 'lps'),
	(592102, 130, '2014-03-15 00:56:41.000000', 'consum', 0.0221, 'lps'),
	(592103, 130, '2014-03-15 00:56:42.000000', 'consum', 0.0212, 'lps'),
	(592104, 130, '2014-03-15 00:56:43.000000', 'consum', 0.0218, 'lps'),
	(592105, 130, '2014-03-15 00:56:44.000000', 'consum', 0.0212, 'lps'),
	(592106, 130, '2014-03-15 00:56:45.000000', 'consum', 0.0211, 'lps'),
	(592107, 130, '2014-03-15 00:56:46.000000', 'consum', 0.0224, 'lps'),
	(592108, 130, '2014-03-15 00:56:47.000000', 'consum', 0.0217, 'lps'),
	(592109, 130, '2014-03-15 00:56:48.000000', 'consum', 0.0220, 'lps'),
	(592110, 130, '2014-03-15 00:56:49.000000', 'consum', 0.0223, 'lps'),
	(592111, 130, '2014-03-15 00:56:50.000000', 'consum', 0.0215, 'lps'),
	(592112, 130, '2014-03-15 00:56:51.000000', 'consum', 0.0211, 'lps'),
	(592113, 130, '2014-03-15 00:56:52.000000', 'consum', 0.0215, 'lps'),
	(592114, 130, '2014-03-15 00:56:53.000000', 'consum', 0.0218, 'lps'),
	(592115, 130, '2014-03-15 00:56:54.000000', 'consum', 0.0222, 'lps'),
	(592116, 130, '2014-03-15 00:56:55.000000', 'consum', 0.0217, 'lps'),
	(592117, 130, '2014-03-15 00:56:56.000000', 'consum', 0.0210, 'lps'),
	(592118, 130, '2014-03-15 00:56:57.000000', 'consum', 0.0217, 'lps'),
	(592119, 130, '2014-03-15 00:56:58.000000', 'consum', 0.0218, 'lps'),
	(592120, 130, '2014-03-15 00:56:59.000000', 'consum', 0.0216, 'lps'),
	(592121, 130, '2014-03-15 00:57:00.000000', 'consum', 0.0213, 'lps'),
	(592122, 130, '2014-03-15 00:57:01.000000', 'consum', 0.0223, 'lps'),
	(592123, 130, '2014-03-15 00:57:02.000000', 'consum', 0.0224, 'lps'),
	(592124, 130, '2014-03-15 00:57:03.000000', 'consum', 0.0223, 'lps'),
	(592125, 130, '2014-03-15 00:57:04.000000', 'consum', 0.0220, 'lps'),
	(592126, 130, '2014-03-15 00:57:05.000000', 'consum', 0.0222, 'lps'),
	(592127, 130, '2014-03-15 00:57:06.000000', 'consum', 0.0224, 'lps'),
	(592128, 130, '2014-03-15 00:57:07.000000', 'consum', 0.0214, 'lps'),
	(592129, 130, '2014-03-15 00:57:08.000000', 'consum', 0.0221, 'lps'),
	(592130, 130, '2014-03-15 00:57:09.000000', 'consum', 0.0223, 'lps'),
	(592131, 130, '2014-03-15 00:57:10.000000', 'consum', 0.0211, 'lps'),
	(592132, 130, '2014-03-15 00:57:11.000000', 'consum', 0.0221, 'lps'),
	(592133, 130, '2014-03-15 00:57:12.000000', 'consum', 0.0217, 'lps'),
	(592134, 130, '2014-03-15 00:57:13.000000', 'consum', 0.0212, 'lps'),
	(592135, 130, '2014-03-15 00:57:14.000000', 'consum', 0.0216, 'lps'),
	(592136, 130, '2014-03-15 00:57:15.000000', 'consum', 0.0220, 'lps'),
	(592137, 130, '2014-03-15 00:57:16.000000', 'consum', 0.0213, 'lps'),
	(592138, 130, '2014-03-15 00:57:17.000000', 'consum', 0.0212, 'lps'),
	(592139, 130, '2014-03-15 00:57:18.000000', 'consum', 0.0224, 'lps'),
	(592140, 130, '2014-03-15 00:57:19.000000', 'consum', 0.0215, 'lps'),
	(592141, 130, '2014-03-15 00:57:20.000000', 'consum', 0.0224, 'lps'),
	(592142, 130, '2014-03-15 00:57:21.000000', 'consum', 0.0222, 'lps'),
	(592143, 130, '2014-03-15 00:57:22.000000', 'consum', 0.0211, 'lps'),
	(592144, 130, '2014-03-15 00:57:23.000000', 'consum', 0.0224, 'lps'),
	(592145, 130, '2014-03-15 00:57:24.000000', 'consum', 0.0217, 'lps'),
	(592146, 130, '2014-03-15 00:57:25.000000', 'consum', 0.0219, 'lps'),
	(592147, 130, '2014-03-15 00:57:26.000000', 'consum', 0.0221, 'lps'),
	(592148, 130, '2014-03-15 00:57:27.000000', 'consum', 0.0210, 'lps'),
	(592149, 130, '2014-03-15 00:57:28.000000', 'consum', 0.0219, 'lps'),
	(592150, 130, '2014-03-15 00:57:29.000000', 'consum', 0.0214, 'lps'),
	(592151, 130, '2014-03-15 00:57:30.000000', 'consum', 0.0216, 'lps'),
	(592152, 130, '2014-03-15 00:57:31.000000', 'consum', 0.0213, 'lps'),
	(592153, 130, '2014-03-15 00:57:32.000000', 'consum', 0.0222, 'lps'),
	(592154, 130, '2014-03-15 00:57:33.000000', 'consum', 0.0217, 'lps'),
	(592155, 130, '2014-03-15 00:57:34.000000', 'consum', 0.0224, 'lps'),
	(592156, 130, '2014-03-15 00:57:35.000000', 'consum', 0.0213, 'lps'),
	(592157, 130, '2014-03-15 00:57:36.000000', 'consum', 0.0216, 'lps'),
	(592158, 130, '2014-03-15 00:57:37.000000', 'consum', 0.0215, 'lps'),
	(592159, 130, '2014-03-15 00:57:38.000000', 'consum', 0.0217, 'lps'),
	(592160, 130, '2014-03-15 00:57:39.000000', 'consum', 0.0214, 'lps'),
	(592161, 130, '2014-03-15 00:57:40.000000', 'consum', 0.0213, 'lps'),
	(592162, 130, '2014-03-15 00:57:41.000000', 'consum', 0.0213, 'lps'),
	(592163, 130, '2014-03-15 00:57:42.000000', 'consum', 0.0215, 'lps'),
	(592164, 130, '2014-03-15 00:57:43.000000', 'consum', 0.0212, 'lps'),
	(592165, 130, '2014-03-15 00:57:44.000000', 'consum', 0.0221, 'lps'),
	(592166, 130, '2014-03-15 00:57:45.000000', 'consum', 0.0214, 'lps'),
	(592167, 130, '2014-03-15 00:57:46.000000', 'consum', 0.0213, 'lps'),
	(592168, 130, '2014-03-15 00:57:47.000000', 'consum', 0.0213, 'lps'),
	(592169, 130, '2014-03-15 00:57:48.000000', 'consum', 0.0216, 'lps'),
	(592170, 130, '2014-03-15 00:57:49.000000', 'consum', 0.0215, 'lps'),
	(592171, 130, '2014-03-15 00:57:50.000000', 'consum', 0.0219, 'lps'),
	(592172, 130, '2014-03-15 00:57:51.000000', 'consum', 0.0210, 'lps'),
	(592173, 130, '2014-03-15 00:57:52.000000', 'consum', 0.0212, 'lps'),
	(592174, 130, '2014-03-15 00:57:53.000000', 'consum', 0.0222, 'lps'),
	(592175, 130, '2014-03-15 00:57:54.000000', 'consum', 0.0218, 'lps'),
	(592176, 130, '2014-03-15 00:57:55.000000', 'consum', 0.0216, 'lps'),
	(592177, 130, '2014-03-15 00:57:56.000000', 'consum', 0.0216, 'lps'),
	(592178, 130, '2014-03-15 00:57:57.000000', 'consum', 0.0224, 'lps'),
	(592179, 130, '2014-03-15 00:57:58.000000', 'consum', 0.0217, 'lps'),
	(592180, 130, '2014-03-15 00:57:59.000000', 'consum', 0.0218, 'lps'),
	(592181, 130, '2014-03-15 00:58:00.000000', 'consum', 0.0214, 'lps'),
	(592182, 130, '2014-03-15 00:58:01.000000', 'consum', 0.0221, 'lps'),
	(592183, 130, '2014-03-15 00:58:02.000000', 'consum', 0.0224, 'lps'),
	(592184, 130, '2014-03-15 00:58:03.000000', 'consum', 0.0216, 'lps'),
	(592185, 130, '2014-03-15 00:58:04.000000', 'consum', 0.0215, 'lps'),
	(592186, 130, '2014-03-15 00:58:05.000000', 'consum', 0.0216, 'lps'),
	(592187, 130, '2014-03-15 00:58:06.000000', 'consum', 0.0212, 'lps'),
	(592188, 130, '2014-03-15 00:58:07.000000', 'consum', 0.0217, 'lps'),
	(592189, 130, '2014-03-15 00:58:08.000000', 'consum', 0.0224, 'lps'),
	(592190, 130, '2014-03-15 00:58:09.000000', 'consum', 0.0215, 'lps'),
	(592191, 130, '2014-03-15 00:58:10.000000', 'consum', 0.0222, 'lps'),
	(592192, 130, '2014-03-15 00:58:11.000000', 'consum', 0.0213, 'lps'),
	(592193, 130, '2014-03-15 00:58:12.000000', 'consum', 0.0217, 'lps'),
	(592194, 130, '2014-03-15 00:58:13.000000', 'consum', 0.0224, 'lps'),
	(592195, 130, '2014-03-15 00:58:14.000000', 'consum', 0.0214, 'lps'),
	(592196, 130, '2014-03-15 00:58:15.000000', 'consum', 0.0218, 'lps'),
	(592197, 130, '2014-03-15 00:58:16.000000', 'consum', 0.0224, 'lps'),
	(592198, 130, '2014-03-15 00:58:17.000000', 'consum', 0.0210, 'lps'),
	(592199, 130, '2014-03-15 00:58:18.000000', 'consum', 0.0214, 'lps'),
	(592200, 130, '2014-03-15 00:58:19.000000', 'consum', 0.0214, 'lps'),
	(592201, 130, '2014-03-15 00:58:20.000000', 'consum', 0.0218, 'lps'),
	(592202, 130, '2014-03-15 00:58:21.000000', 'consum', 0.0211, 'lps'),
	(592203, 130, '2014-03-15 00:58:22.000000', 'consum', 0.0222, 'lps'),
	(592204, 130, '2014-03-15 00:58:23.000000', 'consum', 0.0220, 'lps'),
	(592205, 130, '2014-03-15 00:58:24.000000', 'consum', 0.0211, 'lps'),
	(592206, 130, '2014-03-15 00:58:25.000000', 'consum', 0.0217, 'lps'),
	(592207, 130, '2014-03-15 00:58:26.000000', 'consum', 0.0212, 'lps'),
	(592208, 130, '2014-03-15 00:58:27.000000', 'consum', 0.0213, 'lps'),
	(592209, 130, '2014-03-15 00:58:28.000000', 'consum', 0.0219, 'lps'),
	(592210, 130, '2014-03-15 00:58:29.000000', 'consum', 0.0217, 'lps'),
	(592211, 130, '2014-03-15 00:58:30.000000', 'consum', 0.0219, 'lps'),
	(592212, 130, '2014-03-15 00:58:31.000000', 'consum', 0.0220, 'lps'),
	(592213, 130, '2014-03-15 00:58:32.000000', 'consum', 0.0217, 'lps'),
	(592214, 130, '2014-03-15 00:58:33.000000', 'consum', 0.0215, 'lps'),
	(592215, 130, '2014-03-15 00:58:34.000000', 'consum', 0.0217, 'lps'),
	(592216, 130, '2014-03-15 00:58:35.000000', 'consum', 0.0215, 'lps'),
	(592217, 130, '2014-03-15 00:58:36.000000', 'consum', 0.0214, 'lps'),
	(592218, 130, '2014-03-15 00:58:37.000000', 'consum', 0.0217, 'lps'),
	(592219, 130, '2014-03-15 00:58:38.000000', 'consum', 0.0219, 'lps'),
	(592220, 130, '2014-03-15 00:58:39.000000', 'consum', 0.0218, 'lps'),
	(592221, 130, '2014-03-15 00:58:40.000000', 'consum', 0.0222, 'lps'),
	(592222, 130, '2014-03-15 00:58:41.000000', 'consum', 0.0219, 'lps'),
	(592223, 130, '2014-03-15 00:58:42.000000', 'consum', 0.0217, 'lps'),
	(592224, 130, '2014-03-15 00:58:43.000000', 'consum', 0.0219, 'lps'),
	(592225, 130, '2014-03-15 00:58:44.000000', 'consum', 0.0219, 'lps'),
	(592226, 130, '2014-03-15 00:58:45.000000', 'consum', 0.0214, 'lps'),
	(592227, 130, '2014-03-15 00:58:46.000000', 'consum', 0.0217, 'lps'),
	(592228, 130, '2014-03-15 00:58:47.000000', 'consum', 0.0220, 'lps'),
	(592229, 130, '2014-03-15 00:58:48.000000', 'consum', 0.0210, 'lps'),
	(592230, 130, '2014-03-15 00:58:49.000000', 'consum', 0.0223, 'lps'),
	(592231, 130, '2014-03-15 00:58:50.000000', 'consum', 0.0217, 'lps'),
	(592232, 130, '2014-03-15 00:58:51.000000', 'consum', 0.0222, 'lps'),
	(592233, 130, '2014-03-15 00:58:52.000000', 'consum', 0.0218, 'lps'),
	(592234, 130, '2014-03-15 00:58:53.000000', 'consum', 0.0214, 'lps'),
	(592235, 130, '2014-03-15 00:58:54.000000', 'consum', 0.0221, 'lps'),
	(592236, 130, '2014-03-15 00:58:55.000000', 'consum', 0.0224, 'lps'),
	(592237, 130, '2014-03-15 00:58:56.000000', 'consum', 0.0217, 'lps'),
	(592238, 130, '2014-03-15 00:58:57.000000', 'consum', 0.0221, 'lps'),
	(592239, 130, '2014-03-15 00:58:58.000000', 'consum', 0.0211, 'lps'),
	(592240, 130, '2014-03-15 00:58:59.000000', 'consum', 0.0215, 'lps'),
	(592241, 130, '2014-03-15 00:59:00.000000', 'consum', 0.0217, 'lps'),
	(592242, 130, '2014-03-15 00:59:01.000000', 'consum', 0.0217, 'lps'),
	(592243, 130, '2014-03-15 00:59:02.000000', 'consum', 0.0221, 'lps'),
	(592244, 130, '2014-03-15 00:59:03.000000', 'consum', 0.0217, 'lps'),
	(592245, 130, '2014-03-15 00:59:04.000000', 'consum', 0.0212, 'lps'),
	(592246, 130, '2014-03-15 00:59:05.000000', 'consum', 0.0215, 'lps'),
	(592247, 130, '2014-03-15 00:59:06.000000', 'consum', 0.0216, 'lps'),
	(592248, 130, '2014-03-15 00:59:07.000000', 'consum', 0.0224, 'lps'),
	(592249, 130, '2014-03-15 00:59:08.000000', 'consum', 0.0216, 'lps'),
	(592250, 130, '2014-03-15 00:59:09.000000', 'consum', 0.0213, 'lps'),
	(592251, 130, '2014-03-15 00:59:10.000000', 'consum', 0.0224, 'lps'),
	(592252, 130, '2014-03-15 00:59:11.000000', 'consum', 0.0211, 'lps'),
	(592253, 130, '2014-03-15 00:59:12.000000', 'consum', 0.0220, 'lps'),
	(592254, 130, '2014-03-15 00:59:13.000000', 'consum', 0.0210, 'lps'),
	(592255, 130, '2014-03-15 00:59:14.000000', 'consum', 0.0212, 'lps'),
	(592256, 130, '2014-03-15 00:59:15.000000', 'consum', 0.0221, 'lps'),
	(592257, 130, '2014-03-15 00:59:16.000000', 'consum', 0.0215, 'lps'),
	(592258, 130, '2014-03-15 00:59:17.000000', 'consum', 0.0215, 'lps'),
	(592259, 130, '2014-03-15 00:59:18.000000', 'consum', 0.0221, 'lps'),
	(592260, 130, '2014-03-15 00:59:19.000000', 'consum', 0.0223, 'lps'),
	(592261, 130, '2014-03-15 00:59:20.000000', 'consum', 0.0224, 'lps'),
	(592262, 130, '2014-03-15 00:59:21.000000', 'consum', 0.0213, 'lps'),
	(592263, 130, '2014-03-15 00:59:22.000000', 'consum', 0.0213, 'lps'),
	(592264, 130, '2014-03-15 00:59:23.000000', 'consum', 0.0216, 'lps'),
	(592265, 130, '2014-03-15 00:59:24.000000', 'consum', 0.0215, 'lps'),
	(592266, 130, '2014-03-15 00:59:25.000000', 'consum', 0.0220, 'lps'),
	(592267, 130, '2014-03-15 00:59:26.000000', 'consum', 0.0213, 'lps'),
	(592268, 130, '2014-03-15 00:59:27.000000', 'consum', 0.0210, 'lps'),
	(592269, 130, '2014-03-15 00:59:28.000000', 'consum', 0.0219, 'lps'),
	(592270, 130, '2014-03-15 00:59:29.000000', 'consum', 0.0211, 'lps'),
	(592271, 130, '2014-03-15 00:59:30.000000', 'consum', 0.0216, 'lps'),
	(592272, 130, '2014-03-15 00:59:31.000000', 'consum', 0.0224, 'lps'),
	(592273, 130, '2014-03-15 00:59:32.000000', 'consum', 0.0216, 'lps'),
	(592274, 130, '2014-03-15 00:59:33.000000', 'consum', 0.0215, 'lps'),
	(592275, 130, '2014-03-15 00:59:34.000000', 'consum', 0.0218, 'lps'),
	(592276, 130, '2014-03-15 00:59:35.000000', 'consum', 0.0219, 'lps'),
	(592277, 130, '2014-03-15 00:59:36.000000', 'consum', 0.0218, 'lps'),
	(592278, 130, '2014-03-15 00:59:37.000000', 'consum', 0.0210, 'lps'),
	(592279, 130, '2014-03-15 00:59:38.000000', 'consum', 0.0213, 'lps'),
	(592280, 130, '2014-03-15 00:59:39.000000', 'consum', 0.0212, 'lps'),
	(592281, 130, '2014-03-15 00:59:40.000000', 'consum', 0.0211, 'lps'),
	(592282, 130, '2014-03-15 00:59:41.000000', 'consum', 0.0211, 'lps'),
	(592283, 130, '2014-03-15 00:59:42.000000', 'consum', 0.0211, 'lps'),
	(592284, 130, '2014-03-15 00:59:43.000000', 'consum', 0.0213, 'lps'),
	(592285, 130, '2014-03-15 00:59:44.000000', 'consum', 0.0224, 'lps'),
	(592286, 130, '2014-03-15 00:59:45.000000', 'consum', 0.0224, 'lps'),
	(592287, 130, '2014-03-15 00:59:46.000000', 'consum', 0.0211, 'lps'),
	(592288, 130, '2014-03-15 00:59:47.000000', 'consum', 0.0217, 'lps'),
	(592289, 130, '2014-03-15 00:59:48.000000', 'consum', 0.0211, 'lps'),
	(592290, 130, '2014-03-15 00:59:49.000000', 'consum', 0.0212, 'lps'),
	(592291, 130, '2014-03-15 00:59:50.000000', 'consum', 0.0218, 'lps'),
	(592292, 130, '2014-03-15 00:59:51.000000', 'consum', 0.0215, 'lps'),
	(592293, 130, '2014-03-15 00:59:52.000000', 'consum', 0.0211, 'lps'),
	(592294, 130, '2014-03-15 00:59:53.000000', 'consum', 0.0216, 'lps'),
	(592295, 130, '2014-03-15 00:59:54.000000', 'consum', 0.0221, 'lps'),
	(592296, 130, '2014-03-15 00:59:55.000000', 'consum', 0.0218, 'lps'),
	(592297, 130, '2014-03-15 00:59:56.000000', 'consum', 0.0218, 'lps'),
	(592298, 130, '2014-03-15 00:59:57.000000', 'consum', 0.0212, 'lps'),
	(592299, 130, '2014-03-15 00:59:58.000000', 'consum', 0.0210, 'lps'),
	(592300, 130, '2014-03-15 00:59:59.000000', 'consum', 0.0221, 'lps'),
	(592301, 130, '2014-03-15 01:00:00.000000', 'consum', 0.0221, 'lps'),
	(592302, 130, '2014-03-15 01:00:01.000000', 'consum', 0.0215, 'lps'),
	(592303, 130, '2014-03-15 01:00:02.000000', 'consum', 0.0220, 'lps'),
	(592304, 130, '2014-03-15 01:00:03.000000', 'consum', 0.0215, 'lps'),
	(592305, 130, '2014-03-15 01:00:04.000000', 'consum', 0.0222, 'lps'),
	(592306, 130, '2014-03-15 01:00:05.000000', 'consum', 0.0224, 'lps'),
	(592307, 130, '2014-03-15 01:00:06.000000', 'consum', 0.0216, 'lps'),
	(592308, 130, '2014-03-15 01:00:07.000000', 'consum', 0.0212, 'lps'),
	(592309, 130, '2014-03-15 01:00:08.000000', 'consum', 0.0217, 'lps'),
	(592310, 130, '2014-03-15 01:00:09.000000', 'consum', 0.0224, 'lps'),
	(592311, 130, '2014-03-15 01:00:10.000000', 'consum', 0.0217, 'lps'),
	(592312, 130, '2014-03-15 01:00:11.000000', 'consum', 0.0219, 'lps'),
	(592313, 130, '2014-03-15 01:00:12.000000', 'consum', 0.0217, 'lps'),
	(592314, 130, '2014-03-15 01:00:13.000000', 'consum', 0.0219, 'lps'),
	(592315, 130, '2014-03-15 01:00:14.000000', 'consum', 0.0219, 'lps'),
	(592316, 130, '2014-03-15 01:00:15.000000', 'consum', 0.0214, 'lps'),
	(592317, 130, '2014-03-15 01:00:16.000000', 'consum', 0.0220, 'lps'),
	(592318, 130, '2014-03-15 01:00:17.000000', 'consum', 0.0217, 'lps'),
	(592319, 130, '2014-03-15 01:00:18.000000', 'consum', 0.0216, 'lps'),
	(592320, 130, '2014-03-15 01:00:19.000000', 'consum', 0.0221, 'lps'),
	(592321, 130, '2014-03-15 01:00:20.000000', 'consum', 0.0217, 'lps'),
	(592322, 130, '2014-03-15 01:00:21.000000', 'consum', 0.0213, 'lps'),
	(592323, 130, '2014-03-15 01:00:22.000000', 'consum', 0.0218, 'lps'),
	(592324, 130, '2014-03-15 01:00:23.000000', 'consum', 0.0211, 'lps'),
	(592325, 130, '2014-03-15 01:00:24.000000', 'consum', 0.0223, 'lps'),
	(592326, 130, '2014-03-15 01:00:25.000000', 'consum', 0.0212, 'lps'),
	(592327, 130, '2014-03-15 01:00:26.000000', 'consum', 0.0224, 'lps'),
	(592328, 130, '2014-03-15 01:00:27.000000', 'consum', 0.0218, 'lps'),
	(592329, 130, '2014-03-15 01:00:28.000000', 'consum', 0.0221, 'lps'),
	(592330, 130, '2014-03-15 01:00:29.000000', 'consum', 0.0214, 'lps'),
	(592331, 130, '2014-03-15 01:00:30.000000', 'consum', 0.0212, 'lps'),
	(592332, 130, '2014-03-15 01:00:31.000000', 'consum', 0.0222, 'lps'),
	(592333, 130, '2014-03-15 01:00:32.000000', 'consum', 0.0219, 'lps'),
	(592334, 130, '2014-03-15 01:00:33.000000', 'consum', 0.0222, 'lps'),
	(592335, 130, '2014-03-15 01:00:34.000000', 'consum', 0.0214, 'lps'),
	(592336, 130, '2014-03-15 01:00:35.000000', 'consum', 0.0224, 'lps'),
	(592337, 130, '2014-03-15 01:00:36.000000', 'consum', 0.0224, 'lps'),
	(592338, 130, '2014-03-15 01:00:37.000000', 'consum', 0.0222, 'lps'),
	(592339, 130, '2014-03-15 01:00:38.000000', 'consum', 0.0216, 'lps'),
	(592340, 130, '2014-03-15 01:00:39.000000', 'consum', 0.0217, 'lps'),
	(592341, 130, '2014-03-15 01:00:40.000000', 'consum', 0.0213, 'lps'),
	(592342, 130, '2014-03-15 01:00:41.000000', 'consum', 0.0218, 'lps'),
	(592343, 130, '2014-03-15 01:00:42.000000', 'consum', 0.0211, 'lps'),
	(592344, 130, '2014-03-15 01:00:43.000000', 'consum', 0.0222, 'lps'),
	(592345, 130, '2014-03-15 01:00:44.000000', 'consum', 0.0224, 'lps'),
	(592346, 130, '2014-03-15 01:00:45.000000', 'consum', 0.0212, 'lps'),
	(592347, 130, '2014-03-15 01:00:46.000000', 'consum', 0.0224, 'lps'),
	(592348, 130, '2014-03-15 01:00:47.000000', 'consum', 0.0216, 'lps'),
	(592349, 130, '2014-03-15 01:00:48.000000', 'consum', 0.0212, 'lps'),
	(592350, 130, '2014-03-15 01:00:49.000000', 'consum', 0.0218, 'lps'),
	(592351, 130, '2014-03-15 01:00:50.000000', 'consum', 0.0214, 'lps'),
	(592352, 130, '2014-03-15 01:00:51.000000', 'consum', 0.0224, 'lps'),
	(592353, 130, '2014-03-15 01:00:52.000000', 'consum', 0.0221, 'lps'),
	(592354, 130, '2014-03-15 01:00:53.000000', 'consum', 0.0211, 'lps'),
	(592355, 130, '2014-03-15 01:00:54.000000', 'consum', 0.0210, 'lps'),
	(592356, 130, '2014-03-15 01:00:55.000000', 'consum', 0.0224, 'lps'),
	(592357, 130, '2014-03-15 01:00:56.000000', 'consum', 0.0221, 'lps'),
	(592358, 130, '2014-03-15 01:00:57.000000', 'consum', 0.0222, 'lps'),
	(592359, 130, '2014-03-15 01:00:58.000000', 'consum', 0.0222, 'lps'),
	(592360, 130, '2014-03-15 01:00:59.000000', 'consum', 0.0220, 'lps'),
	(592361, 130, '2014-03-15 01:01:00.000000', 'consum', 0.0223, 'lps'),
	(592362, 130, '2014-03-15 01:01:01.000000', 'consum', 0.0217, 'lps'),
	(592363, 130, '2014-03-15 01:01:02.000000', 'consum', 0.0222, 'lps'),
	(592364, 130, '2014-03-15 01:01:03.000000', 'consum', 0.0218, 'lps'),
	(592365, 130, '2014-03-15 01:01:04.000000', 'consum', 0.0216, 'lps'),
	(592366, 130, '2014-03-15 01:01:05.000000', 'consum', 0.0216, 'lps'),
	(592367, 130, '2014-03-15 01:01:06.000000', 'consum', 0.0221, 'lps'),
	(592368, 130, '2014-03-15 01:01:07.000000', 'consum', 0.0218, 'lps'),
	(592369, 130, '2014-03-15 01:01:08.000000', 'consum', 0.0218, 'lps'),
	(592370, 130, '2014-03-15 01:01:09.000000', 'consum', 0.0210, 'lps'),
	(592371, 130, '2014-03-15 01:01:10.000000', 'consum', 0.0218, 'lps'),
	(592372, 130, '2014-03-15 01:01:11.000000', 'consum', 0.0220, 'lps'),
	(592373, 130, '2014-03-15 01:01:12.000000', 'consum', 0.0222, 'lps'),
	(592374, 130, '2014-03-15 01:01:13.000000', 'consum', 0.0211, 'lps'),
	(592375, 130, '2014-03-15 01:01:14.000000', 'consum', 0.0211, 'lps'),
	(592376, 130, '2014-03-15 01:01:15.000000', 'consum', 0.0210, 'lps'),
	(592377, 130, '2014-03-15 01:01:16.000000', 'consum', 0.0224, 'lps'),
	(592378, 130, '2014-03-15 01:01:17.000000', 'consum', 0.0219, 'lps'),
	(592379, 130, '2014-03-15 01:01:18.000000', 'consum', 0.0216, 'lps'),
	(592380, 130, '2014-03-15 01:01:19.000000', 'consum', 0.0210, 'lps'),
	(592381, 130, '2014-03-15 01:01:20.000000', 'consum', 0.0210, 'lps'),
	(592382, 130, '2014-03-15 01:01:21.000000', 'consum', 0.0211, 'lps'),
	(592383, 130, '2014-03-15 01:01:22.000000', 'consum', 0.0216, 'lps'),
	(592384, 130, '2014-03-15 01:01:23.000000', 'consum', 0.0223, 'lps'),
	(592385, 130, '2014-03-15 01:01:24.000000', 'consum', 0.0210, 'lps'),
	(592386, 130, '2014-03-15 01:01:25.000000', 'consum', 0.0216, 'lps'),
	(592387, 130, '2014-03-15 01:01:26.000000', 'consum', 0.0212, 'lps'),
	(592388, 130, '2014-03-15 01:01:27.000000', 'consum', 0.0217, 'lps'),
	(592389, 130, '2014-03-15 01:01:28.000000', 'consum', 0.0211, 'lps'),
	(592390, 130, '2014-03-15 01:01:29.000000', 'consum', 0.0210, 'lps'),
	(592391, 130, '2014-03-15 01:01:30.000000', 'consum', 0.0220, 'lps'),
	(592392, 130, '2014-03-15 01:01:31.000000', 'consum', 0.0217, 'lps'),
	(592393, 130, '2014-03-15 01:01:32.000000', 'consum', 0.0215, 'lps'),
	(592394, 130, '2014-03-15 01:01:33.000000', 'consum', 0.0214, 'lps'),
	(592395, 130, '2014-03-15 01:01:34.000000', 'consum', 0.0215, 'lps'),
	(592396, 130, '2014-03-15 01:01:35.000000', 'consum', 0.0224, 'lps'),
	(592397, 130, '2014-03-15 01:01:36.000000', 'consum', 0.0221, 'lps'),
	(592398, 130, '2014-03-15 01:01:37.000000', 'consum', 0.0224, 'lps'),
	(592399, 130, '2014-03-15 01:01:38.000000', 'consum', 0.0215, 'lps'),
	(592400, 130, '2014-03-15 01:01:39.000000', 'consum', 0.0224, 'lps'),
	(592401, 130, '2014-03-15 01:01:40.000000', 'consum', 0.0222, 'lps'),
	(592402, 130, '2014-03-15 01:01:41.000000', 'consum', 0.0214, 'lps'),
	(592403, 130, '2014-03-15 01:01:42.000000', 'consum', 0.0210, 'lps'),
	(592404, 130, '2014-03-15 01:01:43.000000', 'consum', 0.0213, 'lps'),
	(592405, 130, '2014-03-15 01:01:44.000000', 'consum', 0.0212, 'lps'),
	(592406, 130, '2014-03-15 01:01:45.000000', 'consum', 0.0211, 'lps'),
	(592407, 130, '2014-03-15 01:01:46.000000', 'consum', 0.0222, 'lps'),
	(592408, 130, '2014-03-15 01:01:47.000000', 'consum', 0.0224, 'lps'),
	(592409, 130, '2014-03-15 01:01:48.000000', 'consum', 0.0215, 'lps'),
	(592410, 130, '2014-03-15 01:01:49.000000', 'consum', 0.0223, 'lps'),
	(592411, 130, '2014-03-15 01:01:50.000000', 'consum', 0.0217, 'lps'),
	(592412, 130, '2014-03-15 01:01:51.000000', 'consum', 0.0219, 'lps'),
	(592413, 130, '2014-03-15 01:01:52.000000', 'consum', 0.0220, 'lps'),
	(592414, 130, '2014-03-15 01:01:53.000000', 'consum', 0.0221, 'lps'),
	(592415, 130, '2014-03-15 01:01:54.000000', 'consum', 0.0219, 'lps'),
	(592416, 130, '2014-03-15 01:01:55.000000', 'consum', 0.0222, 'lps'),
	(592417, 130, '2014-03-15 01:01:56.000000', 'consum', 0.0214, 'lps'),
	(592418, 130, '2014-03-15 01:01:57.000000', 'consum', 0.0210, 'lps'),
	(592419, 130, '2014-03-15 01:01:58.000000', 'consum', 0.0211, 'lps'),
	(592420, 130, '2014-03-15 01:01:59.000000', 'consum', 0.0218, 'lps'),
	(592421, 130, '2014-03-15 01:02:00.000000', 'consum', 0.0216, 'lps'),
	(592422, 130, '2014-03-15 01:02:01.000000', 'consum', 0.0219, 'lps'),
	(592423, 130, '2014-03-15 01:02:02.000000', 'consum', 0.0220, 'lps'),
	(592424, 130, '2014-03-15 01:02:03.000000', 'consum', 0.0221, 'lps'),
	(592425, 130, '2014-03-15 01:02:04.000000', 'consum', 0.0219, 'lps'),
	(592426, 130, '2014-03-15 01:02:05.000000', 'consum', 0.0221, 'lps'),
	(592427, 130, '2014-03-15 01:02:06.000000', 'consum', 0.0212, 'lps'),
	(592428, 130, '2014-03-15 01:02:07.000000', 'consum', 0.0214, 'lps'),
	(592429, 130, '2014-03-15 01:02:08.000000', 'consum', 0.0212, 'lps'),
	(592430, 130, '2014-03-15 01:02:09.000000', 'consum', 0.0222, 'lps'),
	(592431, 130, '2014-03-15 01:02:10.000000', 'consum', 0.0221, 'lps'),
	(592432, 130, '2014-03-15 01:02:11.000000', 'consum', 0.0213, 'lps'),
	(592433, 130, '2014-03-15 01:02:12.000000', 'consum', 0.0223, 'lps'),
	(592434, 130, '2014-03-15 01:02:13.000000', 'consum', 0.0223, 'lps'),
	(592435, 130, '2014-03-15 01:02:14.000000', 'consum', 0.0222, 'lps'),
	(592436, 130, '2014-03-15 01:02:15.000000', 'consum', 0.0215, 'lps'),
	(592437, 130, '2014-03-15 01:02:16.000000', 'consum', 0.0215, 'lps'),
	(592438, 130, '2014-03-15 01:02:17.000000', 'consum', 0.0220, 'lps'),
	(592439, 130, '2014-03-15 01:02:18.000000', 'consum', 0.0217, 'lps'),
	(592440, 130, '2014-03-15 01:02:19.000000', 'consum', 0.0216, 'lps'),
	(592441, 130, '2014-03-15 01:02:20.000000', 'consum', 0.0219, 'lps'),
	(592442, 130, '2014-03-15 01:02:21.000000', 'consum', 0.0221, 'lps'),
	(592443, 130, '2014-03-15 01:02:22.000000', 'consum', 0.0224, 'lps'),
	(592444, 130, '2014-03-15 01:02:23.000000', 'consum', 0.0217, 'lps'),
	(592445, 130, '2014-03-15 01:02:24.000000', 'consum', 0.0217, 'lps'),
	(592446, 130, '2014-03-15 01:02:25.000000', 'consum', 0.0211, 'lps'),
	(592447, 130, '2014-03-15 01:02:26.000000', 'consum', 0.0210, 'lps'),
	(592448, 130, '2014-03-15 01:02:27.000000', 'consum', 0.0223, 'lps'),
	(592449, 130, '2014-03-15 01:02:28.000000', 'consum', 0.0214, 'lps'),
	(592450, 130, '2014-03-15 01:02:29.000000', 'consum', 0.0223, 'lps'),
	(592451, 130, '2014-03-15 01:02:30.000000', 'consum', 0.0216, 'lps'),
	(592452, 130, '2014-03-15 01:02:31.000000', 'consum', 0.0217, 'lps'),
	(592453, 130, '2014-03-15 01:02:32.000000', 'consum', 0.0214, 'lps'),
	(592454, 130, '2014-03-15 01:02:33.000000', 'consum', 0.0223, 'lps'),
	(592455, 130, '2014-03-15 01:02:34.000000', 'consum', 0.0221, 'lps'),
	(592456, 130, '2014-03-15 01:02:35.000000', 'consum', 0.0210, 'lps'),
	(592457, 130, '2014-03-15 01:02:36.000000', 'consum', 0.0224, 'lps'),
	(592458, 130, '2014-03-15 01:02:37.000000', 'consum', 0.0221, 'lps'),
	(592459, 130, '2014-03-15 01:02:38.000000', 'consum', 0.0221, 'lps'),
	(592460, 130, '2014-03-15 01:02:39.000000', 'consum', 0.0218, 'lps'),
	(592461, 130, '2014-03-15 01:02:40.000000', 'consum', 0.0219, 'lps'),
	(592462, 130, '2014-03-15 01:02:41.000000', 'consum', 0.0216, 'lps'),
	(592463, 130, '2014-03-15 01:02:42.000000', 'consum', 0.0215, 'lps'),
	(592464, 130, '2014-03-15 01:02:43.000000', 'consum', 0.0218, 'lps'),
	(592465, 130, '2014-03-15 01:02:44.000000', 'consum', 0.0219, 'lps'),
	(592466, 130, '2014-03-15 01:02:45.000000', 'consum', 0.0217, 'lps'),
	(592467, 130, '2014-03-15 01:02:46.000000', 'consum', 0.0220, 'lps'),
	(592468, 130, '2014-03-15 01:02:47.000000', 'consum', 0.0224, 'lps'),
	(592469, 130, '2014-03-15 01:02:48.000000', 'consum', 0.0222, 'lps'),
	(592470, 130, '2014-03-15 01:02:49.000000', 'consum', 0.0212, 'lps'),
	(592471, 130, '2014-03-15 01:02:50.000000', 'consum', 0.0213, 'lps'),
	(592472, 130, '2014-03-15 01:02:51.000000', 'consum', 0.0221, 'lps'),
	(592473, 130, '2014-03-15 01:02:52.000000', 'consum', 0.0213, 'lps'),
	(592474, 130, '2014-03-15 01:02:53.000000', 'consum', 0.0219, 'lps'),
	(592475, 130, '2014-03-15 01:02:54.000000', 'consum', 0.0219, 'lps'),
	(592476, 130, '2014-03-15 01:02:55.000000', 'consum', 0.0211, 'lps'),
	(592477, 130, '2014-03-15 01:02:56.000000', 'consum', 0.0220, 'lps'),
	(592478, 130, '2014-03-15 01:02:57.000000', 'consum', 0.0211, 'lps'),
	(592479, 130, '2014-03-15 01:02:58.000000', 'consum', 0.0215, 'lps'),
	(592480, 130, '2014-03-15 01:02:59.000000', 'consum', 0.0218, 'lps'),
	(592481, 130, '2014-03-15 01:03:00.000000', 'consum', 0.0219, 'lps'),
	(592482, 130, '2014-03-15 01:03:01.000000', 'consum', 0.0217, 'lps'),
	(592483, 130, '2014-03-15 01:03:02.000000', 'consum', 0.0218, 'lps'),
	(592484, 130, '2014-03-15 01:03:03.000000', 'consum', 0.0214, 'lps'),
	(592485, 130, '2014-03-15 01:03:04.000000', 'consum', 0.0224, 'lps'),
	(592486, 130, '2014-03-15 01:03:05.000000', 'consum', 0.0224, 'lps'),
	(592487, 130, '2014-03-15 01:03:06.000000', 'consum', 0.0221, 'lps'),
	(592488, 130, '2014-03-15 01:03:07.000000', 'consum', 0.0210, 'lps'),
	(592489, 130, '2014-03-15 01:03:08.000000', 'consum', 0.0220, 'lps'),
	(592490, 130, '2014-03-15 01:03:09.000000', 'consum', 0.0218, 'lps'),
	(592491, 130, '2014-03-15 01:03:10.000000', 'consum', 0.0218, 'lps'),
	(592492, 130, '2014-03-15 01:03:11.000000', 'consum', 0.0213, 'lps'),
	(592493, 130, '2014-03-15 01:03:12.000000', 'consum', 0.0218, 'lps'),
	(592494, 130, '2014-03-15 01:03:13.000000', 'consum', 0.0212, 'lps'),
	(592495, 130, '2014-03-15 01:03:14.000000', 'consum', 0.0210, 'lps'),
	(592496, 130, '2014-03-15 01:03:15.000000', 'consum', 0.0222, 'lps'),
	(592497, 130, '2014-03-15 01:03:16.000000', 'consum', 0.0222, 'lps'),
	(592498, 130, '2014-03-15 01:03:17.000000', 'consum', 0.0223, 'lps'),
	(592499, 130, '2014-03-15 01:03:18.000000', 'consum', 0.0222, 'lps'),
	(592500, 130, '2014-03-15 01:03:19.000000', 'consum', 0.0216, 'lps'),
	(592501, 130, '2014-03-15 01:03:20.000000', 'consum', 0.0219, 'lps'),
	(592502, 130, '2014-03-15 01:03:21.000000', 'consum', 0.0224, 'lps'),
	(592503, 130, '2014-03-15 01:03:22.000000', 'consum', 0.0222, 'lps'),
	(592504, 130, '2014-03-15 01:03:23.000000', 'consum', 0.0215, 'lps'),
	(592505, 130, '2014-03-15 01:03:24.000000', 'consum', 0.0213, 'lps'),
	(592506, 130, '2014-03-15 01:03:25.000000', 'consum', 0.0211, 'lps'),
	(592507, 130, '2014-03-15 01:03:26.000000', 'consum', 0.0223, 'lps'),
	(592508, 130, '2014-03-15 01:03:27.000000', 'consum', 0.0213, 'lps'),
	(592509, 130, '2014-03-15 01:03:28.000000', 'consum', 0.0214, 'lps'),
	(592510, 130, '2014-03-15 01:03:29.000000', 'consum', 0.0223, 'lps'),
	(592511, 130, '2014-03-15 01:03:30.000000', 'consum', 0.0217, 'lps'),
	(592512, 130, '2014-03-15 01:03:31.000000', 'consum', 0.0222, 'lps'),
	(592513, 130, '2014-03-15 01:03:32.000000', 'consum', 0.0218, 'lps'),
	(592514, 130, '2014-03-15 01:03:33.000000', 'consum', 0.0216, 'lps'),
	(592515, 130, '2014-03-15 01:03:34.000000', 'consum', 0.0216, 'lps'),
	(592516, 130, '2014-03-15 01:03:35.000000', 'consum', 0.0224, 'lps'),
	(592517, 130, '2014-03-15 01:03:36.000000', 'consum', 0.0218, 'lps'),
	(592518, 130, '2014-03-15 01:03:37.000000', 'consum', 0.0223, 'lps'),
	(592519, 130, '2014-03-15 01:03:38.000000', 'consum', 0.0220, 'lps'),
	(592520, 130, '2014-03-15 01:03:39.000000', 'consum', 0.0223, 'lps'),
	(592521, 130, '2014-03-15 01:03:40.000000', 'consum', 0.0213, 'lps'),
	(592522, 130, '2014-03-15 01:03:41.000000', 'consum', 0.0219, 'lps'),
	(592523, 130, '2014-03-15 01:03:42.000000', 'consum', 0.0216, 'lps'),
	(592524, 130, '2014-03-15 01:03:43.000000', 'consum', 0.0212, 'lps'),
	(592525, 130, '2014-03-15 01:03:44.000000', 'consum', 0.0218, 'lps'),
	(592526, 130, '2014-03-15 01:03:45.000000', 'consum', 0.0216, 'lps'),
	(592527, 130, '2014-03-15 01:03:46.000000', 'consum', 0.0214, 'lps'),
	(592528, 130, '2014-03-15 01:03:47.000000', 'consum', 0.0215, 'lps'),
	(592529, 130, '2014-03-15 01:03:48.000000', 'consum', 0.0223, 'lps'),
	(592530, 130, '2014-03-15 01:03:49.000000', 'consum', 0.0217, 'lps'),
	(592531, 130, '2014-03-15 01:03:50.000000', 'consum', 0.0219, 'lps'),
	(592532, 130, '2014-03-15 01:03:51.000000', 'consum', 0.0220, 'lps'),
	(592533, 130, '2014-03-15 01:03:52.000000', 'consum', 0.0220, 'lps'),
	(592534, 130, '2014-03-15 01:03:53.000000', 'consum', 0.0216, 'lps'),
	(592535, 130, '2014-03-15 01:03:54.000000', 'consum', 0.0223, 'lps'),
	(592536, 130, '2014-03-15 01:03:55.000000', 'consum', 0.0215, 'lps'),
	(592537, 130, '2014-03-15 01:03:56.000000', 'consum', 0.0210, 'lps'),
	(592538, 130, '2014-03-15 01:03:57.000000', 'consum', 0.0210, 'lps'),
	(592539, 130, '2014-03-15 01:03:58.000000', 'consum', 0.0212, 'lps'),
	(592540, 130, '2014-03-15 01:03:59.000000', 'consum', 0.0221, 'lps'),
	(592541, 130, '2014-03-15 01:04:00.000000', 'consum', 0.0212, 'lps'),
	(592542, 130, '2014-03-15 01:04:01.000000', 'consum', 0.0217, 'lps'),
	(592543, 130, '2014-03-15 01:04:02.000000', 'consum', 0.0212, 'lps'),
	(592544, 130, '2014-03-15 01:04:03.000000', 'consum', 0.0214, 'lps'),
	(592545, 130, '2014-03-15 01:04:04.000000', 'consum', 0.0210, 'lps'),
	(592546, 130, '2014-03-15 01:04:05.000000', 'consum', 0.0213, 'lps'),
	(592547, 130, '2014-03-15 01:04:06.000000', 'consum', 0.0210, 'lps'),
	(592548, 130, '2014-03-15 01:04:07.000000', 'consum', 0.0215, 'lps'),
	(592549, 130, '2014-03-15 01:04:08.000000', 'consum', 0.0221, 'lps'),
	(592550, 130, '2014-03-15 01:04:09.000000', 'consum', 0.0221, 'lps'),
	(592551, 130, '2014-03-15 01:04:10.000000', 'consum', 0.0217, 'lps'),
	(592552, 130, '2014-03-15 01:04:11.000000', 'consum', 0.0213, 'lps'),
	(592553, 130, '2014-03-15 01:04:12.000000', 'consum', 0.0217, 'lps'),
	(592554, 130, '2014-03-15 01:04:13.000000', 'consum', 0.0210, 'lps'),
	(592555, 130, '2014-03-15 01:04:14.000000', 'consum', 0.0218, 'lps'),
	(592556, 130, '2014-03-15 01:04:15.000000', 'consum', 0.0222, 'lps'),
	(592557, 130, '2014-03-15 01:04:16.000000', 'consum', 0.0217, 'lps'),
	(592558, 130, '2014-03-15 01:04:17.000000', 'consum', 0.0224, 'lps'),
	(592559, 130, '2014-03-15 01:04:18.000000', 'consum', 0.0216, 'lps'),
	(592560, 130, '2014-03-15 01:04:19.000000', 'consum', 0.0213, 'lps'),
	(592561, 130, '2014-03-15 01:04:20.000000', 'consum', 0.0222, 'lps'),
	(592562, 130, '2014-03-15 01:04:21.000000', 'consum', 0.0215, 'lps'),
	(592563, 130, '2014-03-15 01:04:22.000000', 'consum', 0.0217, 'lps'),
	(592564, 130, '2014-03-15 01:04:23.000000', 'consum', 0.0216, 'lps'),
	(592565, 130, '2014-03-15 01:04:24.000000', 'consum', 0.0216, 'lps'),
	(592566, 130, '2014-03-15 01:04:25.000000', 'consum', 0.0211, 'lps'),
	(592567, 130, '2014-03-15 01:04:26.000000', 'consum', 0.0211, 'lps'),
	(592568, 130, '2014-03-15 01:04:27.000000', 'consum', 0.0213, 'lps'),
	(592569, 130, '2014-03-15 01:04:28.000000', 'consum', 0.0224, 'lps'),
	(592570, 130, '2014-03-15 01:04:29.000000', 'consum', 0.0211, 'lps'),
	(592571, 130, '2014-03-15 01:04:30.000000', 'consum', 0.0218, 'lps'),
	(592572, 130, '2014-03-15 01:04:31.000000', 'consum', 0.0219, 'lps'),
	(592573, 130, '2014-03-15 01:04:32.000000', 'consum', 0.0214, 'lps'),
	(592574, 130, '2014-03-15 01:04:33.000000', 'consum', 0.0220, 'lps'),
	(592575, 130, '2014-03-15 01:04:34.000000', 'consum', 0.0220, 'lps'),
	(592576, 130, '2014-03-15 01:04:35.000000', 'consum', 0.0215, 'lps'),
	(592577, 130, '2014-03-15 01:04:36.000000', 'consum', 0.0222, 'lps'),
	(592578, 130, '2014-03-15 01:04:37.000000', 'consum', 0.0224, 'lps'),
	(592579, 130, '2014-03-15 01:04:38.000000', 'consum', 0.0213, 'lps'),
	(592580, 130, '2014-03-15 01:04:39.000000', 'consum', 0.0213, 'lps'),
	(592581, 130, '2014-03-15 01:04:40.000000', 'consum', 0.0218, 'lps'),
	(592582, 130, '2014-03-15 01:04:41.000000', 'consum', 0.0213, 'lps'),
	(592583, 130, '2014-03-15 01:04:42.000000', 'consum', 0.0214, 'lps'),
	(592584, 130, '2014-03-15 01:04:43.000000', 'consum', 0.0223, 'lps'),
	(592585, 130, '2014-03-15 01:04:44.000000', 'consum', 0.0218, 'lps'),
	(592586, 130, '2014-03-15 01:04:45.000000', 'consum', 0.0211, 'lps'),
	(592587, 130, '2014-03-15 01:04:46.000000', 'consum', 0.0222, 'lps'),
	(592588, 130, '2014-03-15 01:04:47.000000', 'consum', 0.0222, 'lps'),
	(592589, 130, '2014-03-15 01:04:48.000000', 'consum', 0.0221, 'lps'),
	(592590, 130, '2014-03-15 01:04:49.000000', 'consum', 0.0215, 'lps'),
	(592591, 130, '2014-03-15 01:04:50.000000', 'consum', 0.0217, 'lps'),
	(592592, 130, '2014-03-15 01:04:51.000000', 'consum', 0.0214, 'lps'),
	(592593, 130, '2014-03-15 01:04:52.000000', 'consum', 0.0224, 'lps'),
	(592594, 130, '2014-03-15 01:04:53.000000', 'consum', 0.0224, 'lps'),
	(592595, 130, '2014-03-15 01:04:54.000000', 'consum', 0.0222, 'lps'),
	(592596, 130, '2014-03-15 01:04:55.000000', 'consum', 0.0217, 'lps'),
	(592597, 130, '2014-03-15 01:04:56.000000', 'consum', 0.0221, 'lps'),
	(592598, 130, '2014-03-15 01:04:57.000000', 'consum', 0.0216, 'lps'),
	(592599, 130, '2014-03-15 01:04:58.000000', 'consum', 0.0220, 'lps'),
	(592600, 130, '2014-03-15 01:04:59.000000', 'consum', 0.0216, 'lps'),
	(592601, 130, '2014-03-15 01:05:00.000000', 'consum', 0.0210, 'lps'),
	(592602, 130, '2014-03-15 01:05:01.000000', 'consum', 0.0220, 'lps'),
	(592603, 130, '2014-03-15 01:05:02.000000', 'consum', 0.0218, 'lps'),
	(592604, 130, '2014-03-15 01:05:03.000000', 'consum', 0.0221, 'lps'),
	(592605, 130, '2014-03-15 01:05:04.000000', 'consum', 0.0212, 'lps'),
	(592606, 130, '2014-03-15 01:05:05.000000', 'consum', 0.0217, 'lps'),
	(592607, 130, '2014-03-15 01:05:06.000000', 'consum', 0.0224, 'lps'),
	(592608, 130, '2014-03-15 01:05:07.000000', 'consum', 0.0217, 'lps'),
	(592609, 130, '2014-03-15 01:05:08.000000', 'consum', 0.0215, 'lps'),
	(592610, 130, '2014-03-15 01:05:09.000000', 'consum', 0.0217, 'lps'),
	(592611, 130, '2014-03-15 01:05:10.000000', 'consum', 0.0213, 'lps'),
	(592612, 130, '2014-03-15 01:05:11.000000', 'consum', 0.0219, 'lps'),
	(592613, 130, '2014-03-15 01:05:12.000000', 'consum', 0.0218, 'lps'),
	(592614, 130, '2014-03-15 01:05:13.000000', 'consum', 0.0223, 'lps'),
	(592615, 130, '2014-03-15 01:05:14.000000', 'consum', 0.0220, 'lps'),
	(592616, 130, '2014-03-15 01:05:15.000000', 'consum', 0.0222, 'lps'),
	(592617, 130, '2014-03-15 01:05:16.000000', 'consum', 0.0210, 'lps'),
	(592618, 130, '2014-03-15 01:05:17.000000', 'consum', 0.0220, 'lps'),
	(592619, 130, '2014-03-15 01:05:18.000000', 'consum', 0.0216, 'lps'),
	(592620, 130, '2014-03-15 01:05:19.000000', 'consum', 0.0210, 'lps'),
	(592621, 130, '2014-03-15 01:05:20.000000', 'consum', 0.0210, 'lps'),
	(592622, 130, '2014-03-15 01:05:21.000000', 'consum', 0.0222, 'lps'),
	(592623, 130, '2014-03-15 01:05:22.000000', 'consum', 0.0212, 'lps'),
	(592624, 130, '2014-03-15 01:05:23.000000', 'consum', 0.0214, 'lps'),
	(592625, 130, '2014-03-15 01:05:24.000000', 'consum', 0.0210, 'lps'),
	(592626, 130, '2014-03-15 01:05:25.000000', 'consum', 0.0214, 'lps'),
	(592627, 130, '2014-03-15 01:05:26.000000', 'consum', 0.0214, 'lps'),
	(592628, 130, '2014-03-15 01:05:27.000000', 'consum', 0.0219, 'lps'),
	(592629, 130, '2014-03-15 01:05:28.000000', 'consum', 0.0214, 'lps'),
	(592630, 130, '2014-03-15 01:05:29.000000', 'consum', 0.0218, 'lps'),
	(592631, 130, '2014-03-15 01:05:30.000000', 'consum', 0.0224, 'lps'),
	(592632, 130, '2014-03-15 01:05:31.000000', 'consum', 0.0213, 'lps'),
	(592633, 130, '2014-03-15 01:05:32.000000', 'consum', 0.0213, 'lps'),
	(592634, 130, '2014-03-15 01:05:33.000000', 'consum', 0.0214, 'lps'),
	(592635, 130, '2014-03-15 01:05:34.000000', 'consum', 0.0223, 'lps'),
	(592636, 130, '2014-03-15 01:05:35.000000', 'consum', 0.0218, 'lps'),
	(592637, 130, '2014-03-15 01:05:36.000000', 'consum', 0.0211, 'lps'),
	(592638, 130, '2014-03-15 01:05:37.000000', 'consum', 0.0222, 'lps'),
	(592639, 130, '2014-03-15 01:05:38.000000', 'consum', 0.0221, 'lps'),
	(592640, 130, '2014-03-15 01:05:39.000000', 'consum', 0.0217, 'lps'),
	(592641, 130, '2014-03-15 01:05:40.000000', 'consum', 0.0224, 'lps'),
	(592642, 130, '2014-03-15 01:05:41.000000', 'consum', 0.0218, 'lps'),
	(592643, 130, '2014-03-15 01:05:42.000000', 'consum', 0.0223, 'lps'),
	(592644, 130, '2014-03-15 01:05:43.000000', 'consum', 0.0221, 'lps'),
	(592645, 130, '2014-03-15 01:05:44.000000', 'consum', 0.0224, 'lps'),
	(592646, 130, '2014-03-15 01:05:45.000000', 'consum', 0.0221, 'lps'),
	(592647, 130, '2014-03-15 01:05:46.000000', 'consum', 0.0221, 'lps'),
	(592648, 130, '2014-03-15 01:05:47.000000', 'consum', 0.0220, 'lps'),
	(592649, 130, '2014-03-15 01:05:48.000000', 'consum', 0.0214, 'lps'),
	(592650, 130, '2014-03-15 01:05:49.000000', 'consum', 0.0212, 'lps'),
	(592651, 130, '2014-03-15 01:05:50.000000', 'consum', 0.0223, 'lps'),
	(592652, 130, '2014-03-15 01:05:51.000000', 'consum', 0.0211, 'lps'),
	(592653, 130, '2014-03-15 01:05:52.000000', 'consum', 0.0220, 'lps'),
	(592654, 130, '2014-03-15 01:05:53.000000', 'consum', 0.0215, 'lps'),
	(592655, 130, '2014-03-15 01:05:54.000000', 'consum', 0.0221, 'lps'),
	(592656, 130, '2014-03-15 01:05:55.000000', 'consum', 0.0221, 'lps'),
	(592657, 130, '2014-03-15 01:05:56.000000', 'consum', 0.0217, 'lps'),
	(592658, 130, '2014-03-15 01:05:57.000000', 'consum', 0.0211, 'lps'),
	(592659, 130, '2014-03-15 01:05:58.000000', 'consum', 0.0223, 'lps'),
	(592660, 130, '2014-03-15 01:05:59.000000', 'consum', 0.0215, 'lps'),
	(592661, 130, '2014-03-15 01:06:00.000000', 'consum', 0.0213, 'lps'),
	(592662, 130, '2014-03-15 01:06:01.000000', 'consum', 0.0222, 'lps'),
	(592663, 130, '2014-03-15 01:06:02.000000', 'consum', 0.0218, 'lps'),
	(592664, 130, '2014-03-15 01:06:03.000000', 'consum', 0.0215, 'lps'),
	(592665, 130, '2014-03-15 01:06:04.000000', 'consum', 0.0224, 'lps'),
	(592666, 130, '2014-03-15 01:06:05.000000', 'consum', 0.0222, 'lps'),
	(592667, 130, '2014-03-15 01:06:06.000000', 'consum', 0.0212, 'lps'),
	(592668, 130, '2014-03-15 01:06:07.000000', 'consum', 0.0217, 'lps'),
	(592669, 130, '2014-03-15 01:06:08.000000', 'consum', 0.0224, 'lps'),
	(592670, 130, '2014-03-15 01:06:09.000000', 'consum', 0.0212, 'lps'),
	(592671, 130, '2014-03-15 01:06:10.000000', 'consum', 0.0210, 'lps'),
	(592672, 130, '2014-03-15 01:06:11.000000', 'consum', 0.0221, 'lps'),
	(592673, 130, '2014-03-15 01:06:12.000000', 'consum', 0.0218, 'lps'),
	(592674, 130, '2014-03-15 01:06:13.000000', 'consum', 0.0220, 'lps'),
	(592675, 130, '2014-03-15 01:06:14.000000', 'consum', 0.0220, 'lps'),
	(592676, 130, '2014-03-15 01:06:15.000000', 'consum', 0.0216, 'lps'),
	(592677, 130, '2014-03-15 01:06:16.000000', 'consum', 0.0210, 'lps'),
	(592678, 130, '2014-03-15 01:06:17.000000', 'consum', 0.0221, 'lps'),
	(592679, 130, '2014-03-15 01:06:18.000000', 'consum', 0.0224, 'lps'),
	(592680, 130, '2014-03-15 01:06:19.000000', 'consum', 0.0215, 'lps'),
	(592681, 130, '2014-03-15 01:06:20.000000', 'consum', 0.0210, 'lps'),
	(592682, 130, '2014-03-15 01:06:21.000000', 'consum', 0.0210, 'lps'),
	(592683, 130, '2014-03-15 01:06:22.000000', 'consum', 0.0211, 'lps'),
	(592684, 130, '2014-03-15 01:06:23.000000', 'consum', 0.0217, 'lps'),
	(592685, 130, '2014-03-15 01:06:24.000000', 'consum', 0.0210, 'lps'),
	(592686, 130, '2014-03-15 01:06:25.000000', 'consum', 0.0221, 'lps'),
	(592687, 130, '2014-03-15 01:06:26.000000', 'consum', 0.0221, 'lps'),
	(592688, 130, '2014-03-15 01:06:27.000000', 'consum', 0.0216, 'lps'),
	(592689, 130, '2014-03-15 01:06:28.000000', 'consum', 0.0221, 'lps'),
	(592690, 130, '2014-03-15 01:06:29.000000', 'consum', 0.0219, 'lps'),
	(592691, 130, '2014-03-15 01:06:30.000000', 'consum', 0.0221, 'lps'),
	(592692, 130, '2014-03-15 01:06:31.000000', 'consum', 0.0210, 'lps'),
	(592693, 130, '2014-03-15 01:06:32.000000', 'consum', 0.0221, 'lps'),
	(592694, 130, '2014-03-15 01:06:33.000000', 'consum', 0.0223, 'lps'),
	(592695, 130, '2014-03-15 01:06:34.000000', 'consum', 0.0212, 'lps'),
	(592696, 130, '2014-03-15 01:06:35.000000', 'consum', 0.0224, 'lps'),
	(592697, 130, '2014-03-15 01:06:36.000000', 'consum', 0.0216, 'lps'),
	(592698, 130, '2014-03-15 01:06:37.000000', 'consum', 0.0214, 'lps'),
	(592699, 130, '2014-03-15 01:06:38.000000', 'consum', 0.0212, 'lps'),
	(592700, 130, '2014-03-15 01:06:39.000000', 'consum', 0.0222, 'lps'),
	(592701, 130, '2014-03-15 01:06:40.000000', 'consum', 0.0220, 'lps'),
	(592702, 130, '2014-03-15 01:06:41.000000', 'consum', 0.0223, 'lps'),
	(592703, 130, '2014-03-15 01:06:42.000000', 'consum', 0.0219, 'lps'),
	(592704, 130, '2014-03-15 01:06:43.000000', 'consum', 0.0214, 'lps'),
	(592705, 130, '2014-03-15 01:06:44.000000', 'consum', 0.0218, 'lps'),
	(592706, 130, '2014-03-15 01:06:45.000000', 'consum', 0.0211, 'lps'),
	(592707, 130, '2014-03-15 01:06:46.000000', 'consum', 0.0219, 'lps'),
	(592708, 130, '2014-03-15 01:06:47.000000', 'consum', 0.0210, 'lps'),
	(592709, 130, '2014-03-15 01:06:48.000000', 'consum', 0.0211, 'lps'),
	(592710, 130, '2014-03-15 01:06:49.000000', 'consum', 0.0217, 'lps'),
	(592711, 130, '2014-03-15 01:06:50.000000', 'consum', 0.0210, 'lps'),
	(592712, 130, '2014-03-15 01:06:51.000000', 'consum', 0.0221, 'lps'),
	(592713, 130, '2014-03-15 01:06:52.000000', 'consum', 0.0220, 'lps'),
	(592714, 130, '2014-03-15 01:06:53.000000', 'consum', 0.0214, 'lps'),
	(592715, 130, '2014-03-15 01:06:54.000000', 'consum', 0.0216, 'lps'),
	(592716, 130, '2014-03-15 01:06:55.000000', 'consum', 0.0212, 'lps'),
	(592717, 130, '2014-03-15 01:06:56.000000', 'consum', 0.0219, 'lps'),
	(592718, 130, '2014-03-15 01:06:57.000000', 'consum', 0.0219, 'lps'),
	(592719, 130, '2014-03-15 01:06:58.000000', 'consum', 0.0215, 'lps'),
	(592720, 130, '2014-03-15 01:06:59.000000', 'consum', 0.0223, 'lps'),
	(592721, 130, '2014-03-15 01:07:00.000000', 'consum', 0.0215, 'lps'),
	(592722, 130, '2014-03-15 01:07:01.000000', 'consum', 0.0211, 'lps'),
	(592723, 130, '2014-03-15 01:07:02.000000', 'consum', 0.0214, 'lps'),
	(592724, 130, '2014-03-15 01:07:03.000000', 'consum', 0.0215, 'lps'),
	(592725, 130, '2014-03-15 01:07:04.000000', 'consum', 0.0222, 'lps'),
	(592726, 130, '2014-03-15 01:07:05.000000', 'consum', 0.0211, 'lps'),
	(592727, 130, '2014-03-15 01:07:06.000000', 'consum', 0.0224, 'lps'),
	(592728, 130, '2014-03-15 01:07:07.000000', 'consum', 0.0218, 'lps'),
	(592729, 130, '2014-03-15 01:07:08.000000', 'consum', 0.0223, 'lps'),
	(592730, 130, '2014-03-15 01:07:09.000000', 'consum', 0.0222, 'lps'),
	(592731, 130, '2014-03-15 01:07:10.000000', 'consum', 0.0217, 'lps'),
	(592732, 130, '2014-03-15 01:07:11.000000', 'consum', 0.0224, 'lps'),
	(592733, 130, '2014-03-15 01:07:12.000000', 'consum', 0.0213, 'lps'),
	(592734, 130, '2014-03-15 01:07:13.000000', 'consum', 0.0214, 'lps'),
	(592735, 130, '2014-03-15 01:07:14.000000', 'consum', 0.0220, 'lps'),
	(592736, 130, '2014-03-15 01:07:15.000000', 'consum', 0.0221, 'lps'),
	(592737, 130, '2014-03-15 01:07:16.000000', 'consum', 0.0219, 'lps'),
	(592738, 130, '2014-03-15 01:07:17.000000', 'consum', 0.0210, 'lps'),
	(592739, 130, '2014-03-15 01:07:18.000000', 'consum', 0.0211, 'lps'),
	(592740, 130, '2014-03-15 01:07:19.000000', 'consum', 0.0217, 'lps'),
	(592741, 130, '2014-03-15 01:07:20.000000', 'consum', 0.0213, 'lps'),
	(592742, 130, '2014-03-15 01:07:21.000000', 'consum', 0.0218, 'lps'),
	(592743, 130, '2014-03-15 01:07:22.000000', 'consum', 0.0213, 'lps'),
	(592744, 130, '2014-03-15 01:07:23.000000', 'consum', 0.0214, 'lps'),
	(592745, 130, '2014-03-15 01:07:24.000000', 'consum', 0.0223, 'lps'),
	(592746, 130, '2014-03-15 01:07:25.000000', 'consum', 0.0219, 'lps'),
	(592747, 130, '2014-03-15 01:07:26.000000', 'consum', 0.0214, 'lps'),
	(592748, 130, '2014-03-15 01:07:27.000000', 'consum', 0.0221, 'lps'),
	(592749, 130, '2014-03-15 01:07:28.000000', 'consum', 0.0224, 'lps'),
	(592750, 130, '2014-03-15 01:07:29.000000', 'consum', 0.0217, 'lps'),
	(592751, 130, '2014-03-15 01:07:30.000000', 'consum', 0.0219, 'lps'),
	(592752, 130, '2014-03-15 01:07:31.000000', 'consum', 0.0218, 'lps'),
	(592753, 130, '2014-03-15 01:07:32.000000', 'consum', 0.0211, 'lps'),
	(592754, 130, '2014-03-15 01:07:33.000000', 'consum', 0.0220, 'lps'),
	(592755, 130, '2014-03-15 01:07:34.000000', 'consum', 0.0211, 'lps'),
	(592756, 130, '2014-03-15 01:07:35.000000', 'consum', 0.0216, 'lps'),
	(592757, 130, '2014-03-15 01:07:36.000000', 'consum', 0.0222, 'lps'),
	(592758, 130, '2014-03-15 01:07:37.000000', 'consum', 0.0223, 'lps'),
	(592759, 130, '2014-03-15 01:07:38.000000', 'consum', 0.0210, 'lps'),
	(592760, 130, '2014-03-15 01:07:39.000000', 'consum', 0.0215, 'lps'),
	(592761, 130, '2014-03-15 01:07:40.000000', 'consum', 0.0221, 'lps'),
	(592762, 130, '2014-03-15 01:07:41.000000', 'consum', 0.0219, 'lps'),
	(592763, 130, '2014-03-15 01:07:42.000000', 'consum', 0.0210, 'lps'),
	(592764, 130, '2014-03-15 01:07:43.000000', 'consum', 0.0214, 'lps'),
	(592765, 130, '2014-03-15 01:07:44.000000', 'consum', 0.0215, 'lps'),
	(592766, 130, '2014-03-15 01:07:45.000000', 'consum', 0.0210, 'lps'),
	(592767, 130, '2014-03-15 01:07:46.000000', 'consum', 0.0210, 'lps'),
	(592768, 130, '2014-03-15 01:07:47.000000', 'consum', 0.0210, 'lps'),
	(592769, 130, '2014-03-15 01:07:48.000000', 'consum', 0.0211, 'lps'),
	(592770, 130, '2014-03-15 01:07:49.000000', 'consum', 0.0217, 'lps'),
	(592771, 130, '2014-03-15 01:07:50.000000', 'consum', 0.0212, 'lps'),
	(592772, 130, '2014-03-15 01:07:51.000000', 'consum', 0.0212, 'lps'),
	(592773, 130, '2014-03-15 01:07:52.000000', 'consum', 0.0216, 'lps'),
	(592774, 130, '2014-03-15 01:07:53.000000', 'consum', 0.0218, 'lps'),
	(592775, 130, '2014-03-15 01:07:54.000000', 'consum', 0.0217, 'lps'),
	(592776, 130, '2014-03-15 01:07:55.000000', 'consum', 0.0222, 'lps'),
	(592777, 130, '2014-03-15 01:07:56.000000', 'consum', 0.0221, 'lps'),
	(592778, 130, '2014-03-15 01:07:57.000000', 'consum', 0.0214, 'lps'),
	(592779, 130, '2014-03-15 01:07:58.000000', 'consum', 0.0214, 'lps'),
	(592780, 130, '2014-03-15 01:07:59.000000', 'consum', 0.0219, 'lps'),
	(592781, 130, '2014-03-15 01:08:00.000000', 'consum', 0.0210, 'lps'),
	(592782, 130, '2014-03-15 01:08:01.000000', 'consum', 0.0216, 'lps'),
	(592783, 130, '2014-03-15 01:08:02.000000', 'consum', 0.0210, 'lps'),
	(592784, 130, '2014-03-15 01:08:03.000000', 'consum', 0.0222, 'lps'),
	(592785, 130, '2014-03-15 01:08:04.000000', 'consum', 0.0224, 'lps'),
	(592786, 130, '2014-03-15 01:08:05.000000', 'consum', 0.0214, 'lps'),
	(592787, 130, '2014-03-15 01:08:06.000000', 'consum', 0.0221, 'lps'),
	(592788, 130, '2014-03-15 01:08:07.000000', 'consum', 0.0224, 'lps'),
	(592789, 130, '2014-03-15 01:08:08.000000', 'consum', 0.0218, 'lps'),
	(592790, 130, '2014-03-15 01:08:09.000000', 'consum', 0.0224, 'lps'),
	(592791, 130, '2014-03-15 01:08:10.000000', 'consum', 0.0223, 'lps'),
	(592792, 130, '2014-03-15 01:08:11.000000', 'consum', 0.0222, 'lps'),
	(592793, 130, '2014-03-15 01:08:12.000000', 'consum', 0.0216, 'lps'),
	(592794, 130, '2014-03-15 01:08:13.000000', 'consum', 0.0217, 'lps'),
	(592795, 130, '2014-03-15 01:08:14.000000', 'consum', 0.0214, 'lps'),
	(592796, 130, '2014-03-15 01:08:15.000000', 'consum', 0.0224, 'lps'),
	(592797, 130, '2014-03-15 01:08:16.000000', 'consum', 0.0223, 'lps'),
	(592798, 130, '2014-03-15 01:08:17.000000', 'consum', 0.0217, 'lps'),
	(592799, 130, '2014-03-15 01:08:18.000000', 'consum', 0.0223, 'lps'),
	(592800, 130, '2014-03-15 01:08:19.000000', 'consum', 0.0210, 'lps'),
	(592801, 130, '2014-03-15 01:08:20.000000', 'consum', 0.0214, 'lps'),
	(592802, 130, '2014-03-15 01:08:21.000000', 'consum', 0.0218, 'lps'),
	(592803, 130, '2014-03-15 01:08:22.000000', 'consum', 0.0221, 'lps'),
	(592804, 130, '2014-03-15 01:08:23.000000', 'consum', 0.0211, 'lps'),
	(592805, 130, '2014-03-15 01:08:24.000000', 'consum', 0.0215, 'lps'),
	(592806, 130, '2014-03-15 01:08:25.000000', 'consum', 0.0217, 'lps'),
	(592807, 130, '2014-03-15 01:08:26.000000', 'consum', 0.0213, 'lps'),
	(592808, 130, '2014-03-15 01:08:27.000000', 'consum', 0.0223, 'lps'),
	(592809, 130, '2014-03-15 01:08:28.000000', 'consum', 0.0220, 'lps'),
	(592810, 130, '2014-03-15 01:08:29.000000', 'consum', 0.0220, 'lps'),
	(592811, 130, '2014-03-15 01:08:30.000000', 'consum', 0.0216, 'lps'),
	(592812, 130, '2014-03-15 01:08:31.000000', 'consum', 0.0210, 'lps'),
	(592813, 130, '2014-03-15 01:08:32.000000', 'consum', 0.0221, 'lps'),
	(592814, 130, '2014-03-15 01:08:33.000000', 'consum', 0.0223, 'lps'),
	(592815, 130, '2014-03-15 01:08:34.000000', 'consum', 0.0213, 'lps'),
	(592816, 130, '2014-03-15 01:08:35.000000', 'consum', 0.0216, 'lps'),
	(592817, 130, '2014-03-15 01:08:36.000000', 'consum', 0.0215, 'lps'),
	(592818, 130, '2014-03-15 01:08:37.000000', 'consum', 0.0219, 'lps'),
	(592819, 130, '2014-03-15 01:08:38.000000', 'consum', 0.0211, 'lps'),
	(592820, 130, '2014-03-15 01:08:39.000000', 'consum', 0.0220, 'lps'),
	(592821, 130, '2014-03-15 01:08:40.000000', 'consum', 0.0210, 'lps'),
	(592822, 130, '2014-03-15 01:08:41.000000', 'consum', 0.0213, 'lps'),
	(592823, 130, '2014-03-15 01:08:42.000000', 'consum', 0.0223, 'lps'),
	(592824, 130, '2014-03-15 01:08:43.000000', 'consum', 0.0223, 'lps'),
	(592825, 130, '2014-03-15 01:08:44.000000', 'consum', 0.0220, 'lps'),
	(592826, 130, '2014-03-15 01:08:45.000000', 'consum', 0.0223, 'lps'),
	(592827, 130, '2014-03-15 01:08:46.000000', 'consum', 0.0213, 'lps'),
	(592828, 130, '2014-03-15 01:08:47.000000', 'consum', 0.0218, 'lps'),
	(592829, 130, '2014-03-15 01:08:48.000000', 'consum', 0.0211, 'lps'),
	(592830, 130, '2014-03-15 01:08:49.000000', 'consum', 0.0221, 'lps'),
	(592831, 130, '2014-03-15 01:08:50.000000', 'consum', 0.0219, 'lps'),
	(592832, 130, '2014-03-15 01:08:51.000000', 'consum', 0.0220, 'lps'),
	(592833, 130, '2014-03-15 01:08:52.000000', 'consum', 0.0220, 'lps'),
	(592834, 130, '2014-03-15 01:08:53.000000', 'consum', 0.0214, 'lps'),
	(592835, 130, '2014-03-15 01:08:54.000000', 'consum', 0.0216, 'lps'),
	(592836, 130, '2014-03-15 01:08:55.000000', 'consum', 0.0213, 'lps'),
	(592837, 130, '2014-03-15 01:08:56.000000', 'consum', 0.0222, 'lps'),
	(592838, 130, '2014-03-15 01:08:57.000000', 'consum', 0.0215, 'lps'),
	(592839, 130, '2014-03-15 01:08:58.000000', 'consum', 0.0218, 'lps'),
	(592840, 130, '2014-03-15 01:08:59.000000', 'consum', 0.0218, 'lps'),
	(592841, 130, '2014-03-15 01:09:00.000000', 'consum', 0.0212, 'lps'),
	(592842, 130, '2014-03-15 01:09:01.000000', 'consum', 0.0211, 'lps'),
	(592843, 130, '2014-03-15 01:09:02.000000', 'consum', 0.0211, 'lps'),
	(592844, 130, '2014-03-15 01:09:03.000000', 'consum', 0.0213, 'lps'),
	(592845, 130, '2014-03-15 01:09:04.000000', 'consum', 0.0223, 'lps'),
	(592846, 130, '2014-03-15 01:09:05.000000', 'consum', 0.0221, 'lps'),
	(592847, 130, '2014-03-15 01:09:06.000000', 'consum', 0.0210, 'lps'),
	(592848, 130, '2014-03-15 01:09:07.000000', 'consum', 0.0222, 'lps'),
	(592849, 130, '2014-03-15 01:09:08.000000', 'consum', 0.0211, 'lps'),
	(592850, 130, '2014-03-15 01:09:09.000000', 'consum', 0.0211, 'lps'),
	(592851, 130, '2014-03-15 01:09:10.000000', 'consum', 0.0212, 'lps'),
	(592852, 130, '2014-03-15 01:09:11.000000', 'consum', 0.0216, 'lps'),
	(592853, 130, '2014-03-15 01:09:12.000000', 'consum', 0.0219, 'lps'),
	(592854, 130, '2014-03-15 01:09:13.000000', 'consum', 0.0222, 'lps'),
	(592855, 130, '2014-03-15 01:09:14.000000', 'consum', 0.0216, 'lps'),
	(592856, 130, '2014-03-15 01:09:15.000000', 'consum', 0.0220, 'lps'),
	(592857, 130, '2014-03-15 01:09:16.000000', 'consum', 0.0211, 'lps'),
	(592858, 130, '2014-03-15 01:09:17.000000', 'consum', 0.0217, 'lps'),
	(592859, 130, '2014-03-15 01:09:18.000000', 'consum', 0.0213, 'lps'),
	(592860, 130, '2014-03-15 01:09:19.000000', 'consum', 0.0217, 'lps'),
	(592861, 130, '2014-03-15 01:09:20.000000', 'consum', 0.0224, 'lps'),
	(592862, 130, '2014-03-15 01:09:21.000000', 'consum', 0.0216, 'lps'),
	(592863, 130, '2014-03-15 01:09:22.000000', 'consum', 0.0210, 'lps'),
	(592864, 130, '2014-03-15 01:09:23.000000', 'consum', 0.0223, 'lps'),
	(592865, 130, '2014-03-15 01:09:24.000000', 'consum', 0.0214, 'lps'),
	(592866, 130, '2014-03-15 01:09:25.000000', 'consum', 0.0210, 'lps'),
	(592867, 130, '2014-03-15 01:09:26.000000', 'consum', 0.0210, 'lps'),
	(592868, 130, '2014-03-15 01:09:27.000000', 'consum', 0.0213, 'lps'),
	(592869, 130, '2014-03-15 01:09:28.000000', 'consum', 0.0224, 'lps'),
	(592870, 130, '2014-03-15 01:09:29.000000', 'consum', 0.0212, 'lps'),
	(592871, 130, '2014-03-15 01:09:30.000000', 'consum', 0.0224, 'lps'),
	(592872, 130, '2014-03-15 01:09:31.000000', 'consum', 0.0215, 'lps'),
	(592873, 130, '2014-03-15 01:09:32.000000', 'consum', 0.0221, 'lps'),
	(592874, 130, '2014-03-15 01:09:33.000000', 'consum', 0.0222, 'lps'),
	(592875, 130, '2014-03-15 01:09:34.000000', 'consum', 0.0224, 'lps'),
	(592876, 130, '2014-03-15 01:09:35.000000', 'consum', 0.0213, 'lps'),
	(592877, 130, '2014-03-15 01:09:36.000000', 'consum', 0.0215, 'lps'),
	(592878, 130, '2014-03-15 01:09:37.000000', 'consum', 0.0224, 'lps'),
	(592879, 130, '2014-03-15 01:09:38.000000', 'consum', 0.0222, 'lps'),
	(592880, 130, '2014-03-15 01:09:39.000000', 'consum', 0.0215, 'lps'),
	(592881, 130, '2014-03-15 01:09:40.000000', 'consum', 0.0211, 'lps'),
	(592882, 130, '2014-03-15 01:09:41.000000', 'consum', 0.0218, 'lps'),
	(592883, 130, '2014-03-15 01:09:42.000000', 'consum', 0.0218, 'lps'),
	(592884, 130, '2014-03-15 01:09:43.000000', 'consum', 0.0224, 'lps'),
	(592885, 130, '2014-03-15 01:09:44.000000', 'consum', 0.0211, 'lps'),
	(592886, 130, '2014-03-15 01:09:45.000000', 'consum', 0.0221, 'lps'),
	(592887, 130, '2014-03-15 01:09:46.000000', 'consum', 0.0215, 'lps'),
	(592888, 130, '2014-03-15 01:09:47.000000', 'consum', 0.0217, 'lps'),
	(592889, 130, '2014-03-15 01:09:48.000000', 'consum', 0.0218, 'lps'),
	(592890, 130, '2014-03-15 01:09:49.000000', 'consum', 0.0215, 'lps'),
	(592891, 130, '2014-03-15 01:09:50.000000', 'consum', 0.0212, 'lps'),
	(592892, 130, '2014-03-15 01:09:51.000000', 'consum', 0.0219, 'lps'),
	(592893, 130, '2014-03-15 01:09:52.000000', 'consum', 0.0220, 'lps'),
	(592894, 130, '2014-03-15 01:09:53.000000', 'consum', 0.0219, 'lps'),
	(592895, 130, '2014-03-15 01:09:54.000000', 'consum', 0.0224, 'lps'),
	(592896, 130, '2014-03-15 01:09:55.000000', 'consum', 0.0223, 'lps'),
	(592897, 130, '2014-03-15 01:09:56.000000', 'consum', 0.0219, 'lps'),
	(592898, 130, '2014-03-15 01:09:57.000000', 'consum', 0.0217, 'lps'),
	(592899, 130, '2014-03-15 01:09:58.000000', 'consum', 0.0219, 'lps'),
	(592900, 130, '2014-03-15 01:09:59.000000', 'consum', 0.0219, 'lps'),
	(592901, 130, '2014-03-15 01:10:00.000000', 'consum', 0.0213, 'lps'),
	(592902, 130, '2014-03-15 01:10:01.000000', 'consum', 0.0216, 'lps'),
	(592903, 130, '2014-03-15 01:10:02.000000', 'consum', 0.0214, 'lps'),
	(592904, 130, '2014-03-15 01:10:03.000000', 'consum', 0.0214, 'lps'),
	(592905, 130, '2014-03-15 01:10:04.000000', 'consum', 0.0219, 'lps'),
	(592906, 130, '2014-03-15 01:10:05.000000', 'consum', 0.0214, 'lps'),
	(592907, 130, '2014-03-15 01:10:06.000000', 'consum', 0.0216, 'lps'),
	(592908, 130, '2014-03-15 01:10:07.000000', 'consum', 0.0215, 'lps'),
	(592909, 130, '2014-03-15 01:10:08.000000', 'consum', 0.0219, 'lps'),
	(592910, 130, '2014-03-15 01:10:09.000000', 'consum', 0.0210, 'lps'),
	(592911, 130, '2014-03-15 01:10:10.000000', 'consum', 0.0214, 'lps'),
	(592912, 130, '2014-03-15 01:10:11.000000', 'consum', 0.0216, 'lps'),
	(592913, 130, '2014-03-15 01:10:12.000000', 'consum', 0.0213, 'lps'),
	(592914, 130, '2014-03-15 01:10:13.000000', 'consum', 0.0220, 'lps'),
	(592915, 130, '2014-03-15 01:10:14.000000', 'consum', 0.0224, 'lps'),
	(592916, 130, '2014-03-15 01:10:15.000000', 'consum', 0.0220, 'lps'),
	(592917, 130, '2014-03-15 01:10:16.000000', 'consum', 0.0219, 'lps'),
	(592918, 130, '2014-03-15 01:10:17.000000', 'consum', 0.0211, 'lps'),
	(592919, 130, '2014-03-15 01:10:18.000000', 'consum', 0.0216, 'lps'),
	(592920, 130, '2014-03-15 01:10:19.000000', 'consum', 0.0223, 'lps'),
	(592921, 130, '2014-03-15 01:10:20.000000', 'consum', 0.0211, 'lps'),
	(592922, 130, '2014-03-15 01:10:21.000000', 'consum', 0.0224, 'lps'),
	(592923, 130, '2014-03-15 01:10:22.000000', 'consum', 0.0217, 'lps'),
	(592924, 130, '2014-03-15 01:10:23.000000', 'consum', 0.0218, 'lps'),
	(592925, 130, '2014-03-15 01:10:24.000000', 'consum', 0.0216, 'lps'),
	(592926, 130, '2014-03-15 01:10:25.000000', 'consum', 0.0214, 'lps'),
	(592927, 130, '2014-03-15 01:10:26.000000', 'consum', 0.0214, 'lps'),
	(592928, 130, '2014-03-15 01:10:27.000000', 'consum', 0.0219, 'lps'),
	(592929, 130, '2014-03-15 01:10:28.000000', 'consum', 0.0215, 'lps'),
	(592930, 130, '2014-03-15 01:10:29.000000', 'consum', 0.0220, 'lps'),
	(592931, 130, '2014-03-15 01:10:30.000000', 'consum', 0.0218, 'lps'),
	(592932, 130, '2014-03-15 01:10:31.000000', 'consum', 0.0221, 'lps'),
	(592933, 130, '2014-03-15 01:10:32.000000', 'consum', 0.0224, 'lps'),
	(592934, 130, '2014-03-15 01:10:33.000000', 'consum', 0.0221, 'lps'),
	(592935, 130, '2014-03-15 01:10:34.000000', 'consum', 0.0221, 'lps'),
	(592936, 130, '2014-03-15 01:10:35.000000', 'consum', 0.0218, 'lps'),
	(592937, 130, '2014-03-15 01:10:36.000000', 'consum', 0.0217, 'lps'),
	(592938, 130, '2014-03-15 01:10:37.000000', 'consum', 0.0221, 'lps'),
	(592939, 130, '2014-03-15 01:10:38.000000', 'consum', 0.0217, 'lps'),
	(592940, 130, '2014-03-15 01:10:39.000000', 'consum', 0.0210, 'lps'),
	(592941, 130, '2014-03-15 01:10:40.000000', 'consum', 0.0222, 'lps'),
	(592942, 130, '2014-03-15 01:10:41.000000', 'consum', 0.0211, 'lps'),
	(592943, 130, '2014-03-15 01:10:42.000000', 'consum', 0.0221, 'lps'),
	(592944, 130, '2014-03-15 01:10:43.000000', 'consum', 0.0220, 'lps'),
	(592945, 130, '2014-03-15 01:10:44.000000', 'consum', 0.0213, 'lps'),
	(592946, 130, '2014-03-15 01:10:45.000000', 'consum', 0.0211, 'lps'),
	(592947, 130, '2014-03-15 01:10:46.000000', 'consum', 0.0222, 'lps'),
	(592948, 130, '2014-03-15 01:10:47.000000', 'consum', 0.0220, 'lps'),
	(592949, 130, '2014-03-15 01:10:48.000000', 'consum', 0.0210, 'lps'),
	(592950, 130, '2014-03-15 01:10:49.000000', 'consum', 0.0210, 'lps'),
	(592951, 130, '2014-03-15 01:10:50.000000', 'consum', 0.0212, 'lps'),
	(592952, 130, '2014-03-15 01:10:51.000000', 'consum', 0.0219, 'lps'),
	(592953, 130, '2014-03-15 01:10:52.000000', 'consum', 0.0221, 'lps'),
	(592954, 130, '2014-03-15 01:10:53.000000', 'consum', 0.0210, 'lps'),
	(592955, 130, '2014-03-15 01:10:54.000000', 'consum', 0.0220, 'lps'),
	(592956, 130, '2014-03-15 01:10:55.000000', 'consum', 0.0218, 'lps'),
	(592957, 130, '2014-03-15 01:10:56.000000', 'consum', 0.0217, 'lps'),
	(592958, 130, '2014-03-15 01:10:57.000000', 'consum', 0.0210, 'lps'),
	(592959, 130, '2014-03-15 01:10:58.000000', 'consum', 0.0216, 'lps'),
	(592960, 130, '2014-03-15 01:10:59.000000', 'consum', 0.0212, 'lps'),
	(592961, 130, '2014-03-15 01:11:00.000000', 'consum', 0.0218, 'lps'),
	(592962, 130, '2014-03-15 01:11:01.000000', 'consum', 0.0214, 'lps'),
	(592963, 130, '2014-03-15 01:11:02.000000', 'consum', 0.0221, 'lps'),
	(592964, 130, '2014-03-15 01:11:03.000000', 'consum', 0.0210, 'lps'),
	(592965, 130, '2014-03-15 01:11:04.000000', 'consum', 0.0221, 'lps'),
	(592966, 130, '2014-03-15 01:11:05.000000', 'consum', 0.0221, 'lps'),
	(592967, 130, '2014-03-15 01:11:06.000000', 'consum', 0.0219, 'lps'),
	(592968, 130, '2014-03-15 01:11:07.000000', 'consum', 0.0222, 'lps'),
	(592969, 130, '2014-03-15 01:11:08.000000', 'consum', 0.0213, 'lps'),
	(592970, 130, '2014-03-15 01:11:09.000000', 'consum', 0.0221, 'lps'),
	(592971, 130, '2014-03-15 01:11:10.000000', 'consum', 0.0212, 'lps'),
	(592972, 130, '2014-03-15 01:11:11.000000', 'consum', 0.0216, 'lps'),
	(592973, 130, '2014-03-15 01:11:12.000000', 'consum', 0.0220, 'lps'),
	(592974, 130, '2014-03-15 01:11:13.000000', 'consum', 0.0214, 'lps'),
	(592975, 130, '2014-03-15 01:11:14.000000', 'consum', 0.0213, 'lps'),
	(592976, 130, '2014-03-15 01:11:15.000000', 'consum', 0.0214, 'lps'),
	(592977, 130, '2014-03-15 01:11:16.000000', 'consum', 0.0220, 'lps'),
	(592978, 130, '2014-03-15 01:11:17.000000', 'consum', 0.0220, 'lps'),
	(592979, 130, '2014-03-15 01:11:18.000000', 'consum', 0.0217, 'lps'),
	(592980, 130, '2014-03-15 01:11:19.000000', 'consum', 0.0216, 'lps'),
	(592981, 130, '2014-03-15 01:11:20.000000', 'consum', 0.0217, 'lps'),
	(592982, 130, '2014-03-15 01:11:21.000000', 'consum', 0.0215, 'lps'),
	(592983, 130, '2014-03-15 01:11:22.000000', 'consum', 0.0214, 'lps'),
	(592984, 130, '2014-03-15 01:11:23.000000', 'consum', 0.0217, 'lps'),
	(592985, 130, '2014-03-15 01:11:24.000000', 'consum', 0.0217, 'lps'),
	(592986, 130, '2014-03-15 01:11:25.000000', 'consum', 0.0224, 'lps'),
	(592987, 130, '2014-03-15 01:11:26.000000', 'consum', 0.0213, 'lps'),
	(592988, 130, '2014-03-15 01:11:27.000000', 'consum', 0.0214, 'lps'),
	(592989, 130, '2014-03-15 01:11:28.000000', 'consum', 0.0223, 'lps'),
	(592990, 130, '2014-03-15 01:11:29.000000', 'consum', 0.0216, 'lps'),
	(592991, 130, '2014-03-15 01:11:30.000000', 'consum', 0.0219, 'lps'),
	(592992, 130, '2014-03-15 01:11:31.000000', 'consum', 0.0224, 'lps'),
	(592993, 130, '2014-03-15 01:11:32.000000', 'consum', 0.0220, 'lps'),
	(592994, 130, '2014-03-15 01:11:33.000000', 'consum', 0.0220, 'lps'),
	(592995, 130, '2014-03-15 01:11:34.000000', 'consum', 0.0216, 'lps'),
	(592996, 130, '2014-03-15 01:11:35.000000', 'consum', 0.0224, 'lps'),
	(592997, 130, '2014-03-15 01:11:36.000000', 'consum', 0.0218, 'lps'),
	(592998, 130, '2014-03-15 01:11:37.000000', 'consum', 0.0222, 'lps'),
	(592999, 130, '2014-03-15 01:11:38.000000', 'consum', 0.0219, 'lps'),
	(593000, 130, '2014-03-15 01:11:39.000000', 'consum', 0.0220, 'lps'),
	(593001, 130, '2014-03-15 01:11:40.000000', 'consum', 0.0215, 'lps'),
	(593002, 130, '2014-03-15 01:11:41.000000', 'consum', 0.0224, 'lps'),
	(593003, 130, '2014-03-15 01:11:42.000000', 'consum', 0.0221, 'lps'),
	(593004, 130, '2014-03-15 01:11:43.000000', 'consum', 0.0221, 'lps'),
	(593005, 130, '2014-03-15 01:11:44.000000', 'consum', 0.0217, 'lps'),
	(593006, 130, '2014-03-15 01:11:45.000000', 'consum', 0.0215, 'lps'),
	(593007, 130, '2014-03-15 01:11:46.000000', 'consum', 0.0213, 'lps'),
	(593008, 130, '2014-03-15 01:11:47.000000', 'consum', 0.0211, 'lps'),
	(593009, 130, '2014-03-15 01:11:48.000000', 'consum', 0.0222, 'lps'),
	(593010, 130, '2014-03-15 01:11:49.000000', 'consum', 0.0221, 'lps'),
	(593011, 130, '2014-03-15 01:11:50.000000', 'consum', 0.0216, 'lps'),
	(593012, 130, '2014-03-15 01:11:51.000000', 'consum', 0.0222, 'lps'),
	(593013, 130, '2014-03-15 01:11:52.000000', 'consum', 0.0221, 'lps'),
	(593014, 130, '2014-03-15 01:11:53.000000', 'consum', 0.0214, 'lps'),
	(593015, 130, '2014-03-15 01:11:54.000000', 'consum', 0.0212, 'lps'),
	(593016, 130, '2014-03-15 01:11:55.000000', 'consum', 0.0224, 'lps'),
	(593017, 130, '2014-03-15 01:11:56.000000', 'consum', 0.0213, 'lps'),
	(593018, 130, '2014-03-15 01:11:57.000000', 'consum', 0.0216, 'lps'),
	(593019, 130, '2014-03-15 01:11:58.000000', 'consum', 0.0216, 'lps'),
	(593020, 130, '2014-03-15 01:11:59.000000', 'consum', 0.0224, 'lps'),
	(593021, 130, '2014-03-15 01:12:00.000000', 'consum', 0.0215, 'lps'),
	(593022, 130, '2014-03-15 01:12:01.000000', 'consum', 0.0211, 'lps'),
	(593023, 130, '2014-03-15 01:12:02.000000', 'consum', 0.0215, 'lps'),
	(593024, 130, '2014-03-15 01:12:03.000000', 'consum', 0.0219, 'lps'),
	(593025, 130, '2014-03-15 01:12:04.000000', 'consum', 0.0224, 'lps'),
	(593026, 130, '2014-03-15 01:12:05.000000', 'consum', 0.0224, 'lps'),
	(593027, 130, '2014-03-15 01:12:06.000000', 'consum', 0.0224, 'lps'),
	(593028, 130, '2014-03-15 01:12:07.000000', 'consum', 0.0224, 'lps'),
	(593029, 130, '2014-03-15 01:12:08.000000', 'consum', 0.0221, 'lps'),
	(593030, 130, '2014-03-15 01:12:09.000000', 'consum', 0.0224, 'lps'),
	(593031, 130, '2014-03-15 01:12:10.000000', 'consum', 0.0220, 'lps'),
	(593032, 130, '2014-03-15 01:12:11.000000', 'consum', 0.0216, 'lps'),
	(593033, 130, '2014-03-15 01:12:12.000000', 'consum', 0.0211, 'lps'),
	(593034, 130, '2014-03-15 01:12:13.000000', 'consum', 0.0213, 'lps'),
	(593035, 130, '2014-03-15 01:12:14.000000', 'consum', 0.0221, 'lps'),
	(593036, 130, '2014-03-15 01:12:15.000000', 'consum', 0.0214, 'lps'),
	(593037, 130, '2014-03-15 01:12:16.000000', 'consum', 0.0213, 'lps'),
	(593038, 130, '2014-03-15 01:12:17.000000', 'consum', 0.0211, 'lps'),
	(593039, 130, '2014-03-15 01:12:18.000000', 'consum', 0.0222, 'lps'),
	(593040, 130, '2014-03-15 01:12:19.000000', 'consum', 0.0224, 'lps'),
	(593041, 130, '2014-03-15 01:12:20.000000', 'consum', 0.0213, 'lps'),
	(593042, 130, '2014-03-15 01:12:21.000000', 'consum', 0.0212, 'lps'),
	(593043, 130, '2014-03-15 01:12:22.000000', 'consum', 0.0215, 'lps'),
	(593044, 130, '2014-03-15 01:12:23.000000', 'consum', 0.0212, 'lps'),
	(593045, 130, '2014-03-15 01:12:24.000000', 'consum', 0.0223, 'lps'),
	(593046, 130, '2014-03-15 01:12:25.000000', 'consum', 0.0221, 'lps'),
	(593047, 130, '2014-03-15 01:12:26.000000', 'consum', 0.0214, 'lps'),
	(593048, 130, '2014-03-15 01:12:27.000000', 'consum', 0.0213, 'lps'),
	(593049, 130, '2014-03-15 01:12:28.000000', 'consum', 0.0214, 'lps'),
	(593050, 130, '2014-03-15 01:12:29.000000', 'consum', 0.0221, 'lps'),
	(593051, 130, '2014-03-15 01:12:30.000000', 'consum', 0.0210, 'lps'),
	(593052, 130, '2014-03-15 01:12:31.000000', 'consum', 0.0220, 'lps'),
	(593053, 130, '2014-03-15 01:12:32.000000', 'consum', 0.0217, 'lps'),
	(593054, 130, '2014-03-15 01:12:33.000000', 'consum', 0.0215, 'lps'),
	(593055, 130, '2014-03-15 01:12:34.000000', 'consum', 0.0217, 'lps'),
	(593056, 130, '2014-03-15 01:12:35.000000', 'consum', 0.0212, 'lps'),
	(593057, 130, '2014-03-15 01:12:36.000000', 'consum', 0.0215, 'lps'),
	(593058, 130, '2014-03-15 01:12:37.000000', 'consum', 0.0216, 'lps'),
	(593059, 130, '2014-03-15 01:12:38.000000', 'consum', 0.0224, 'lps'),
	(593060, 130, '2014-03-15 01:12:39.000000', 'consum', 0.0217, 'lps'),
	(593061, 130, '2014-03-15 01:12:40.000000', 'consum', 0.0217, 'lps'),
	(593062, 130, '2014-03-15 01:12:41.000000', 'consum', 0.0212, 'lps'),
	(593063, 130, '2014-03-15 01:12:42.000000', 'consum', 0.0212, 'lps'),
	(593064, 130, '2014-03-15 01:12:43.000000', 'consum', 0.0217, 'lps'),
	(593065, 130, '2014-03-15 01:12:44.000000', 'consum', 0.0210, 'lps'),
	(593066, 130, '2014-03-15 01:12:45.000000', 'consum', 0.0219, 'lps'),
	(593067, 130, '2014-03-15 01:12:46.000000', 'consum', 0.0211, 'lps'),
	(593068, 130, '2014-03-15 01:12:47.000000', 'consum', 0.0217, 'lps'),
	(593069, 130, '2014-03-15 01:12:48.000000', 'consum', 0.0213, 'lps'),
	(593070, 130, '2014-03-15 01:12:49.000000', 'consum', 0.0219, 'lps'),
	(593071, 130, '2014-03-15 01:12:50.000000', 'consum', 0.0217, 'lps'),
	(593072, 130, '2014-03-15 01:12:51.000000', 'consum', 0.0219, 'lps'),
	(593073, 130, '2014-03-15 01:12:52.000000', 'consum', 0.0217, 'lps'),
	(593074, 130, '2014-03-15 01:12:53.000000', 'consum', 0.0221, 'lps'),
	(593075, 130, '2014-03-15 01:12:54.000000', 'consum', 0.0214, 'lps'),
	(593076, 130, '2014-03-15 01:12:55.000000', 'consum', 0.0211, 'lps'),
	(593077, 130, '2014-03-15 01:12:56.000000', 'consum', 0.0221, 'lps'),
	(593078, 130, '2014-03-15 01:12:57.000000', 'consum', 0.0215, 'lps'),
	(593079, 130, '2014-03-15 01:12:58.000000', 'consum', 0.0218, 'lps'),
	(593080, 130, '2014-03-15 01:12:59.000000', 'consum', 0.0220, 'lps'),
	(593081, 130, '2014-03-15 01:13:00.000000', 'consum', 0.0222, 'lps'),
	(593082, 130, '2014-03-15 01:13:01.000000', 'consum', 0.0212, 'lps'),
	(593083, 130, '2014-03-15 01:13:02.000000', 'consum', 0.0213, 'lps'),
	(593084, 130, '2014-03-15 01:13:03.000000', 'consum', 0.0221, 'lps'),
	(593085, 130, '2014-03-15 01:13:04.000000', 'consum', 0.0212, 'lps'),
	(593086, 130, '2014-03-15 01:13:05.000000', 'consum', 0.0216, 'lps'),
	(593087, 130, '2014-03-15 01:13:06.000000', 'consum', 0.0221, 'lps'),
	(593088, 130, '2014-03-15 01:13:07.000000', 'consum', 0.0217, 'lps'),
	(593089, 130, '2014-03-15 01:13:08.000000', 'consum', 0.0211, 'lps'),
	(593090, 130, '2014-03-15 01:13:09.000000', 'consum', 0.0211, 'lps'),
	(593091, 130, '2014-03-15 01:13:10.000000', 'consum', 0.0213, 'lps'),
	(593092, 130, '2014-03-15 01:13:11.000000', 'consum', 0.0223, 'lps'),
	(593093, 130, '2014-03-15 01:13:12.000000', 'consum', 0.0220, 'lps'),
	(593094, 130, '2014-03-15 01:13:13.000000', 'consum', 0.0222, 'lps'),
	(593095, 130, '2014-03-15 01:13:14.000000', 'consum', 0.0224, 'lps'),
	(593096, 130, '2014-03-15 01:13:15.000000', 'consum', 0.0214, 'lps'),
	(593097, 130, '2014-03-15 01:13:16.000000', 'consum', 0.0219, 'lps'),
	(593098, 130, '2014-03-15 01:13:17.000000', 'consum', 0.0214, 'lps'),
	(593099, 130, '2014-03-15 01:13:18.000000', 'consum', 0.0217, 'lps'),
	(593100, 130, '2014-03-15 01:13:19.000000', 'consum', 0.0220, 'lps'),
	(593101, 130, '2014-03-15 01:13:20.000000', 'consum', 0.0210, 'lps'),
	(593102, 130, '2014-03-15 01:13:21.000000', 'consum', 0.0211, 'lps'),
	(593103, 130, '2014-03-15 01:13:22.000000', 'consum', 0.0217, 'lps'),
	(593104, 130, '2014-03-15 01:13:23.000000', 'consum', 0.0224, 'lps'),
	(593105, 130, '2014-03-15 01:13:24.000000', 'consum', 0.0216, 'lps'),
	(593106, 130, '2014-03-15 01:13:25.000000', 'consum', 0.0214, 'lps'),
	(593107, 130, '2014-03-15 01:13:26.000000', 'consum', 0.0212, 'lps'),
	(593108, 130, '2014-03-15 01:13:27.000000', 'consum', 0.0221, 'lps'),
	(593109, 130, '2014-03-15 01:13:28.000000', 'consum', 0.0218, 'lps'),
	(593110, 130, '2014-03-15 01:13:29.000000', 'consum', 0.0217, 'lps'),
	(593111, 130, '2014-03-15 01:13:30.000000', 'consum', 0.0220, 'lps'),
	(593112, 130, '2014-03-15 01:13:31.000000', 'consum', 0.0224, 'lps'),
	(593113, 130, '2014-03-15 01:13:32.000000', 'consum', 0.0220, 'lps'),
	(593114, 130, '2014-03-15 01:13:33.000000', 'consum', 0.0217, 'lps'),
	(593115, 130, '2014-03-15 01:13:34.000000', 'consum', 0.0219, 'lps'),
	(593116, 130, '2014-03-15 01:13:35.000000', 'consum', 0.0219, 'lps'),
	(593117, 130, '2014-03-15 01:13:36.000000', 'consum', 0.0214, 'lps'),
	(593118, 130, '2014-03-15 01:13:37.000000', 'consum', 0.0216, 'lps'),
	(593119, 130, '2014-03-15 01:13:38.000000', 'consum', 0.0215, 'lps'),
	(593120, 130, '2014-03-15 01:13:39.000000', 'consum', 0.0216, 'lps'),
	(593121, 130, '2014-03-15 01:13:40.000000', 'consum', 0.0210, 'lps'),
	(593122, 130, '2014-03-15 01:13:41.000000', 'consum', 0.0210, 'lps'),
	(593123, 130, '2014-03-15 01:13:42.000000', 'consum', 0.0223, 'lps'),
	(593124, 130, '2014-03-15 01:13:43.000000', 'consum', 0.0216, 'lps'),
	(593125, 130, '2014-03-15 01:13:44.000000', 'consum', 0.0219, 'lps'),
	(593126, 130, '2014-03-15 01:13:45.000000', 'consum', 0.0220, 'lps'),
	(593127, 130, '2014-03-15 01:13:46.000000', 'consum', 0.0221, 'lps'),
	(593128, 130, '2014-03-15 01:13:47.000000', 'consum', 0.0218, 'lps'),
	(593129, 130, '2014-03-15 01:13:48.000000', 'consum', 0.0218, 'lps'),
	(593130, 130, '2014-03-15 01:13:49.000000', 'consum', 0.0213, 'lps'),
	(593131, 130, '2014-03-15 01:13:50.000000', 'consum', 0.0215, 'lps'),
	(593132, 130, '2014-03-15 01:13:51.000000', 'consum', 0.0213, 'lps'),
	(593133, 130, '2014-03-15 01:13:52.000000', 'consum', 0.0210, 'lps'),
	(593134, 130, '2014-03-15 01:13:53.000000', 'consum', 0.0218, 'lps'),
	(593135, 130, '2014-03-15 01:13:54.000000', 'consum', 0.0221, 'lps'),
	(593136, 130, '2014-03-15 01:13:55.000000', 'consum', 0.0211, 'lps'),
	(593137, 130, '2014-03-15 01:13:56.000000', 'consum', 0.0212, 'lps'),
	(593138, 130, '2014-03-15 01:13:57.000000', 'consum', 0.0217, 'lps'),
	(593139, 130, '2014-03-15 01:13:58.000000', 'consum', 0.0224, 'lps'),
	(593140, 130, '2014-03-15 01:13:59.000000', 'consum', 0.0217, 'lps'),
	(593141, 130, '2014-03-15 01:14:00.000000', 'consum', 0.0215, 'lps'),
	(593142, 130, '2014-03-15 01:14:01.000000', 'consum', 0.0217, 'lps'),
	(593143, 130, '2014-03-15 01:14:02.000000', 'consum', 0.0216, 'lps'),
	(593144, 130, '2014-03-15 01:14:03.000000', 'consum', 0.0219, 'lps'),
	(593145, 130, '2014-03-15 01:14:04.000000', 'consum', 0.0222, 'lps'),
	(593146, 130, '2014-03-15 01:14:05.000000', 'consum', 0.0212, 'lps'),
	(593147, 130, '2014-03-15 01:14:06.000000', 'consum', 0.0216, 'lps'),
	(593148, 130, '2014-03-15 01:14:07.000000', 'consum', 0.0221, 'lps'),
	(593149, 130, '2014-03-15 01:14:08.000000', 'consum', 0.0214, 'lps'),
	(593150, 130, '2014-03-15 01:14:09.000000', 'consum', 0.0215, 'lps'),
	(593151, 130, '2014-03-15 01:14:10.000000', 'consum', 0.0224, 'lps'),
	(593152, 130, '2014-03-15 01:14:11.000000', 'consum', 0.0220, 'lps'),
	(593153, 130, '2014-03-15 01:14:12.000000', 'consum', 0.0218, 'lps'),
	(593154, 130, '2014-03-15 01:14:13.000000', 'consum', 0.0220, 'lps'),
	(593155, 130, '2014-03-15 01:14:14.000000', 'consum', 0.0221, 'lps'),
	(593156, 130, '2014-03-15 01:14:15.000000', 'consum', 0.0221, 'lps'),
	(593157, 130, '2014-03-15 01:14:16.000000', 'consum', 0.0216, 'lps'),
	(593158, 130, '2014-03-15 01:14:17.000000', 'consum', 0.0224, 'lps'),
	(593159, 130, '2014-03-15 01:14:18.000000', 'consum', 0.0219, 'lps'),
	(593160, 130, '2014-03-15 01:14:19.000000', 'consum', 0.0211, 'lps'),
	(593161, 130, '2014-03-15 01:14:20.000000', 'consum', 0.0221, 'lps'),
	(593162, 130, '2014-03-15 01:14:21.000000', 'consum', 0.0215, 'lps'),
	(593163, 130, '2014-03-15 01:14:22.000000', 'consum', 0.0220, 'lps'),
	(593164, 130, '2014-03-15 01:14:23.000000', 'consum', 0.0216, 'lps'),
	(593165, 130, '2014-03-15 01:14:24.000000', 'consum', 0.0223, 'lps'),
	(593166, 130, '2014-03-15 01:14:25.000000', 'consum', 0.0215, 'lps'),
	(593167, 130, '2014-03-15 01:14:26.000000', 'consum', 0.0212, 'lps'),
	(593168, 130, '2014-03-15 01:14:27.000000', 'consum', 0.0221, 'lps'),
	(593169, 130, '2014-03-15 01:14:28.000000', 'consum', 0.0213, 'lps'),
	(593170, 130, '2014-03-15 01:14:29.000000', 'consum', 0.0221, 'lps'),
	(593171, 130, '2014-03-15 01:14:30.000000', 'consum', 0.0213, 'lps'),
	(593172, 130, '2014-03-15 01:14:31.000000', 'consum', 0.0224, 'lps'),
	(593173, 130, '2014-03-15 01:14:32.000000', 'consum', 0.0211, 'lps'),
	(593174, 130, '2014-03-15 01:14:33.000000', 'consum', 0.0219, 'lps'),
	(593175, 130, '2014-03-15 01:14:34.000000', 'consum', 0.0220, 'lps'),
	(593176, 130, '2014-03-15 01:14:35.000000', 'consum', 0.0219, 'lps'),
	(593177, 130, '2014-03-15 01:14:36.000000', 'consum', 0.0210, 'lps'),
	(593178, 130, '2014-03-15 01:14:37.000000', 'consum', 0.0212, 'lps'),
	(593179, 130, '2014-03-15 01:14:38.000000', 'consum', 0.0224, 'lps'),
	(593180, 130, '2014-03-15 01:14:39.000000', 'consum', 0.0214, 'lps'),
	(593181, 130, '2014-03-15 01:14:40.000000', 'consum', 0.0217, 'lps'),
	(593182, 130, '2014-03-15 01:14:41.000000', 'consum', 0.0219, 'lps'),
	(593183, 130, '2014-03-15 01:14:42.000000', 'consum', 0.0220, 'lps'),
	(593184, 130, '2014-03-15 01:14:43.000000', 'consum', 0.0219, 'lps'),
	(593185, 130, '2014-03-15 01:14:44.000000', 'consum', 0.0212, 'lps'),
	(593186, 130, '2014-03-15 01:14:45.000000', 'consum', 0.0221, 'lps'),
	(593187, 130, '2014-03-15 01:14:46.000000', 'consum', 0.0217, 'lps'),
	(593188, 130, '2014-03-15 01:14:47.000000', 'consum', 0.0210, 'lps'),
	(593189, 130, '2014-03-15 01:14:48.000000', 'consum', 0.0219, 'lps'),
	(593190, 130, '2014-03-15 01:14:49.000000', 'consum', 0.0211, 'lps'),
	(593191, 130, '2014-03-15 01:14:50.000000', 'consum', 0.0220, 'lps'),
	(593192, 130, '2014-03-15 01:14:51.000000', 'consum', 0.0211, 'lps'),
	(593193, 130, '2014-03-15 01:14:52.000000', 'consum', 0.0216, 'lps'),
	(593194, 130, '2014-03-15 01:14:53.000000', 'consum', 0.0210, 'lps'),
	(593195, 130, '2014-03-15 01:14:54.000000', 'consum', 0.0219, 'lps'),
	(593196, 130, '2014-03-15 01:14:55.000000', 'consum', 0.0211, 'lps'),
	(593197, 130, '2014-03-15 01:14:56.000000', 'consum', 0.0221, 'lps'),
	(593198, 130, '2014-03-15 01:14:57.000000', 'consum', 0.0216, 'lps'),
	(593199, 130, '2014-03-15 01:14:58.000000', 'consum', 0.0224, 'lps'),
	(593200, 130, '2014-03-15 01:14:59.000000', 'consum', 0.0216, 'lps'),
	(593201, 130, '2014-03-15 01:15:00.000000', 'consum', 0.0215, 'lps'),
	(593202, 130, '2014-03-15 01:15:01.000000', 'consum', 0.0215, 'lps'),
	(593203, 130, '2014-03-15 01:15:02.000000', 'consum', 0.0220, 'lps'),
	(593204, 130, '2014-03-15 01:15:03.000000', 'consum', 0.0216, 'lps'),
	(593205, 130, '2014-03-15 01:15:04.000000', 'consum', 0.0212, 'lps'),
	(593206, 130, '2014-03-15 01:15:05.000000', 'consum', 0.0216, 'lps'),
	(593207, 130, '2014-03-15 01:15:06.000000', 'consum', 0.0220, 'lps'),
	(593208, 130, '2014-03-15 01:15:07.000000', 'consum', 0.0212, 'lps'),
	(593209, 130, '2014-03-15 01:15:08.000000', 'consum', 0.0219, 'lps'),
	(593210, 130, '2014-03-15 01:15:09.000000', 'consum', 0.0220, 'lps'),
	(593211, 130, '2014-03-15 01:15:10.000000', 'consum', 0.0218, 'lps'),
	(593212, 130, '2014-03-15 01:15:11.000000', 'consum', 0.0223, 'lps'),
	(593213, 130, '2014-03-15 01:15:12.000000', 'consum', 0.0220, 'lps'),
	(593214, 130, '2014-03-15 01:15:13.000000', 'consum', 0.0220, 'lps'),
	(593215, 130, '2014-03-15 01:15:14.000000', 'consum', 0.0218, 'lps'),
	(593216, 130, '2014-03-15 01:15:15.000000', 'consum', 0.0218, 'lps'),
	(593217, 130, '2014-03-15 01:15:16.000000', 'consum', 0.0212, 'lps'),
	(593218, 130, '2014-03-15 01:15:17.000000', 'consum', 0.0212, 'lps'),
	(593219, 130, '2014-03-15 01:15:18.000000', 'consum', 0.0215, 'lps'),
	(593220, 130, '2014-03-15 01:15:19.000000', 'consum', 0.0213, 'lps'),
	(593221, 130, '2014-03-15 01:15:20.000000', 'consum', 0.0211, 'lps'),
	(593222, 130, '2014-03-15 01:15:21.000000', 'consum', 0.0224, 'lps'),
	(593223, 130, '2014-03-15 01:15:22.000000', 'consum', 0.0215, 'lps'),
	(593224, 130, '2014-03-15 01:15:23.000000', 'consum', 0.0210, 'lps'),
	(593225, 130, '2014-03-15 01:15:24.000000', 'consum', 0.0210, 'lps'),
	(593226, 130, '2014-03-15 01:15:25.000000', 'consum', 0.0224, 'lps'),
	(593227, 130, '2014-03-15 01:15:26.000000', 'consum', 0.0222, 'lps'),
	(593228, 130, '2014-03-15 01:15:27.000000', 'consum', 0.0214, 'lps'),
	(593229, 130, '2014-03-15 01:15:28.000000', 'consum', 0.0223, 'lps'),
	(593230, 130, '2014-03-15 01:15:29.000000', 'consum', 0.0220, 'lps'),
	(593231, 130, '2014-03-15 01:15:30.000000', 'consum', 0.0220, 'lps'),
	(593232, 130, '2014-03-15 01:15:31.000000', 'consum', 0.0218, 'lps'),
	(593233, 130, '2014-03-15 01:15:32.000000', 'consum', 0.0219, 'lps'),
	(593234, 130, '2014-03-15 01:15:33.000000', 'consum', 0.0218, 'lps'),
	(593235, 130, '2014-03-15 01:15:34.000000', 'consum', 0.0210, 'lps'),
	(593236, 130, '2014-03-15 01:15:35.000000', 'consum', 0.0213, 'lps'),
	(593237, 130, '2014-03-15 01:15:36.000000', 'consum', 0.0211, 'lps'),
	(593238, 130, '2014-03-15 01:15:37.000000', 'consum', 0.0222, 'lps'),
	(593239, 130, '2014-03-15 01:15:38.000000', 'consum', 0.0224, 'lps'),
	(593240, 130, '2014-03-15 01:15:39.000000', 'consum', 0.0211, 'lps'),
	(593241, 130, '2014-03-15 01:15:40.000000', 'consum', 0.0222, 'lps'),
	(593242, 130, '2014-03-15 01:15:41.000000', 'consum', 0.0223, 'lps'),
	(593243, 130, '2014-03-15 01:15:42.000000', 'consum', 0.0222, 'lps'),
	(593244, 130, '2014-03-15 01:15:43.000000', 'consum', 0.0217, 'lps'),
	(593245, 130, '2014-03-15 01:15:44.000000', 'consum', 0.0211, 'lps'),
	(593246, 130, '2014-03-15 01:15:45.000000', 'consum', 0.0211, 'lps'),
	(593247, 130, '2014-03-15 01:15:46.000000', 'consum', 0.0210, 'lps'),
	(593248, 130, '2014-03-15 01:15:47.000000', 'consum', 0.0222, 'lps'),
	(593249, 130, '2014-03-15 01:15:48.000000', 'consum', 0.0224, 'lps'),
	(593250, 130, '2014-03-15 01:15:49.000000', 'consum', 0.0218, 'lps'),
	(593251, 130, '2014-03-15 01:15:50.000000', 'consum', 0.0222, 'lps'),
	(593252, 130, '2014-03-15 01:15:51.000000', 'consum', 0.0215, 'lps'),
	(593253, 130, '2014-03-15 01:15:52.000000', 'consum', 0.0218, 'lps'),
	(593254, 130, '2014-03-15 01:15:53.000000', 'consum', 0.0218, 'lps'),
	(593255, 130, '2014-03-15 01:15:54.000000', 'consum', 0.0211, 'lps'),
	(593256, 130, '2014-03-15 01:15:55.000000', 'consum', 0.0221, 'lps'),
	(593257, 130, '2014-03-15 01:15:56.000000', 'consum', 0.0218, 'lps'),
	(593258, 130, '2014-03-15 01:15:57.000000', 'consum', 0.0217, 'lps'),
	(593259, 130, '2014-03-15 01:15:58.000000', 'consum', 0.0221, 'lps'),
	(593260, 130, '2014-03-15 01:15:59.000000', 'consum', 0.0214, 'lps'),
	(593261, 130, '2014-03-15 01:16:00.000000', 'consum', 0.0215, 'lps'),
	(593262, 130, '2014-03-15 01:16:01.000000', 'consum', 0.0223, 'lps'),
	(593263, 130, '2014-03-15 01:16:02.000000', 'consum', 0.0214, 'lps'),
	(593264, 130, '2014-03-15 01:16:03.000000', 'consum', 0.0222, 'lps'),
	(593265, 130, '2014-03-15 01:16:04.000000', 'consum', 0.0215, 'lps'),
	(593266, 130, '2014-03-15 01:16:05.000000', 'consum', 0.0215, 'lps'),
	(593267, 130, '2014-03-15 01:16:06.000000', 'consum', 0.0221, 'lps'),
	(593268, 130, '2014-03-15 01:16:07.000000', 'consum', 0.0222, 'lps'),
	(593269, 130, '2014-03-15 01:16:08.000000', 'consum', 0.0219, 'lps'),
	(593270, 130, '2014-03-15 01:16:09.000000', 'consum', 0.0221, 'lps'),
	(593271, 130, '2014-03-15 01:16:10.000000', 'consum', 0.0221, 'lps'),
	(593272, 130, '2014-03-15 01:16:11.000000', 'consum', 0.0220, 'lps'),
	(593273, 130, '2014-03-15 01:16:12.000000', 'consum', 0.0211, 'lps'),
	(593274, 130, '2014-03-15 01:16:13.000000', 'consum', 0.0215, 'lps'),
	(593275, 130, '2014-03-15 01:16:14.000000', 'consum', 0.0220, 'lps'),
	(593276, 130, '2014-03-15 01:16:15.000000', 'consum', 0.0216, 'lps'),
	(593277, 130, '2014-03-15 01:16:16.000000', 'consum', 0.0223, 'lps'),
	(593278, 130, '2014-03-15 01:16:17.000000', 'consum', 0.0212, 'lps'),
	(593279, 130, '2014-03-15 01:16:18.000000', 'consum', 0.0213, 'lps'),
	(593280, 130, '2014-03-15 01:16:19.000000', 'consum', 0.0218, 'lps'),
	(593281, 130, '2014-03-15 01:16:20.000000', 'consum', 0.0212, 'lps'),
	(593282, 130, '2014-03-15 01:16:21.000000', 'consum', 0.0211, 'lps'),
	(593283, 130, '2014-03-15 01:16:22.000000', 'consum', 0.0224, 'lps'),
	(593284, 130, '2014-03-15 01:16:23.000000', 'consum', 0.0217, 'lps'),
	(593285, 130, '2014-03-15 01:16:24.000000', 'consum', 0.0217, 'lps'),
	(593286, 130, '2014-03-15 01:16:25.000000', 'consum', 0.0213, 'lps'),
	(593287, 130, '2014-03-15 01:16:26.000000', 'consum', 0.0218, 'lps'),
	(593288, 130, '2014-03-15 01:16:27.000000', 'consum', 0.0210, 'lps'),
	(593289, 130, '2014-03-15 01:16:28.000000', 'consum', 0.0218, 'lps'),
	(593290, 130, '2014-03-15 01:16:29.000000', 'consum', 0.0219, 'lps'),
	(593291, 130, '2014-03-15 01:16:30.000000', 'consum', 0.0216, 'lps'),
	(593292, 130, '2014-03-15 01:16:31.000000', 'consum', 0.0217, 'lps'),
	(593293, 130, '2014-03-15 01:16:32.000000', 'consum', 0.0224, 'lps'),
	(593294, 130, '2014-03-15 01:16:33.000000', 'consum', 0.0214, 'lps'),
	(593295, 130, '2014-03-15 01:16:34.000000', 'consum', 0.0220, 'lps'),
	(593296, 130, '2014-03-15 01:16:35.000000', 'consum', 0.0219, 'lps'),
	(593297, 130, '2014-03-15 01:16:36.000000', 'consum', 0.0211, 'lps'),
	(593298, 130, '2014-03-15 01:16:37.000000', 'consum', 0.0219, 'lps'),
	(593299, 130, '2014-03-15 01:16:38.000000', 'consum', 0.0221, 'lps'),
	(593300, 130, '2014-03-15 01:16:39.000000', 'consum', 0.0211, 'lps'),
	(593301, 130, '2014-03-15 01:16:40.000000', 'consum', 0.0210, 'lps'),
	(593302, 130, '2014-03-15 01:16:41.000000', 'consum', 0.0210, 'lps'),
	(593303, 130, '2014-03-15 01:16:42.000000', 'consum', 0.0210, 'lps'),
	(593304, 130, '2014-03-15 01:16:43.000000', 'consum', 0.0223, 'lps'),
	(593305, 130, '2014-03-15 01:16:44.000000', 'consum', 0.0217, 'lps'),
	(593306, 130, '2014-03-15 01:16:45.000000', 'consum', 0.0221, 'lps'),
	(593307, 130, '2014-03-15 01:16:46.000000', 'consum', 0.0213, 'lps'),
	(593308, 130, '2014-03-15 01:16:47.000000', 'consum', 0.0210, 'lps'),
	(593309, 130, '2014-03-15 01:16:48.000000', 'consum', 0.0217, 'lps'),
	(593310, 130, '2014-03-15 01:16:49.000000', 'consum', 0.0213, 'lps'),
	(593311, 130, '2014-03-15 01:16:50.000000', 'consum', 0.0219, 'lps'),
	(593312, 130, '2014-03-15 01:16:51.000000', 'consum', 0.0218, 'lps'),
	(593313, 130, '2014-03-15 01:16:52.000000', 'consum', 0.0221, 'lps'),
	(593314, 130, '2014-03-15 01:16:53.000000', 'consum', 0.0214, 'lps'),
	(593315, 130, '2014-03-15 01:16:54.000000', 'consum', 0.0211, 'lps'),
	(593316, 130, '2014-03-15 01:16:55.000000', 'consum', 0.0219, 'lps'),
	(593317, 130, '2014-03-15 01:16:56.000000', 'consum', 0.0223, 'lps'),
	(593318, 130, '2014-03-15 01:16:57.000000', 'consum', 0.0216, 'lps'),
	(593319, 130, '2014-03-15 01:16:58.000000', 'consum', 0.0218, 'lps'),
	(593320, 130, '2014-03-15 01:16:59.000000', 'consum', 0.0219, 'lps'),
	(593321, 130, '2014-03-15 01:17:00.000000', 'consum', 0.0215, 'lps'),
	(593322, 130, '2014-03-15 01:17:01.000000', 'consum', 0.0224, 'lps'),
	(593323, 130, '2014-03-15 01:17:02.000000', 'consum', 0.0220, 'lps'),
	(593324, 130, '2014-03-15 01:17:03.000000', 'consum', 0.0219, 'lps'),
	(593325, 130, '2014-03-15 01:17:04.000000', 'consum', 0.0224, 'lps'),
	(593326, 130, '2014-03-15 01:17:05.000000', 'consum', 0.0211, 'lps'),
	(593327, 130, '2014-03-15 01:17:06.000000', 'consum', 0.0218, 'lps'),
	(593328, 130, '2014-03-15 01:17:07.000000', 'consum', 0.0215, 'lps'),
	(593329, 130, '2014-03-15 01:17:08.000000', 'consum', 0.0214, 'lps'),
	(593330, 130, '2014-03-15 01:17:09.000000', 'consum', 0.0215, 'lps'),
	(593331, 130, '2014-03-15 01:17:10.000000', 'consum', 0.0222, 'lps'),
	(593332, 130, '2014-03-15 01:17:11.000000', 'consum', 0.0212, 'lps'),
	(593333, 130, '2014-03-15 01:17:12.000000', 'consum', 0.0215, 'lps'),
	(593334, 130, '2014-03-15 01:17:13.000000', 'consum', 0.0215, 'lps'),
	(593335, 130, '2014-03-15 01:17:14.000000', 'consum', 0.0221, 'lps'),
	(593336, 130, '2014-03-15 01:17:15.000000', 'consum', 0.0221, 'lps'),
	(593337, 130, '2014-03-15 01:17:16.000000', 'consum', 0.0216, 'lps'),
	(593338, 130, '2014-03-15 01:17:17.000000', 'consum', 0.0223, 'lps'),
	(593339, 130, '2014-03-15 01:17:18.000000', 'consum', 0.0213, 'lps'),
	(593340, 130, '2014-03-15 01:17:19.000000', 'consum', 0.0215, 'lps'),
	(593341, 130, '2014-03-15 01:17:20.000000', 'consum', 0.0212, 'lps'),
	(593342, 130, '2014-03-15 01:17:21.000000', 'consum', 0.0219, 'lps'),
	(593343, 130, '2014-03-15 01:17:22.000000', 'consum', 0.0219, 'lps'),
	(593344, 130, '2014-03-15 01:17:23.000000', 'consum', 0.0215, 'lps'),
	(593345, 130, '2014-03-15 01:17:24.000000', 'consum', 0.0224, 'lps'),
	(593346, 130, '2014-03-15 01:17:25.000000', 'consum', 0.0221, 'lps'),
	(593347, 130, '2014-03-15 01:17:26.000000', 'consum', 0.0224, 'lps'),
	(593348, 130, '2014-03-15 01:17:27.000000', 'consum', 0.0215, 'lps'),
	(593349, 130, '2014-03-15 01:17:28.000000', 'consum', 0.0212, 'lps'),
	(593350, 130, '2014-03-15 01:17:29.000000', 'consum', 0.0217, 'lps'),
	(593351, 130, '2014-03-15 01:17:30.000000', 'consum', 0.0210, 'lps'),
	(593352, 130, '2014-03-15 01:17:31.000000', 'consum', 0.0221, 'lps'),
	(593353, 130, '2014-03-15 01:17:32.000000', 'consum', 0.0221, 'lps'),
	(593354, 130, '2014-03-15 01:17:33.000000', 'consum', 0.0215, 'lps'),
	(593355, 130, '2014-03-15 01:17:34.000000', 'consum', 0.0219, 'lps'),
	(593356, 130, '2014-03-15 01:17:35.000000', 'consum', 0.0211, 'lps'),
	(593357, 130, '2014-03-15 01:17:36.000000', 'consum', 0.0216, 'lps'),
	(593358, 130, '2014-03-15 01:17:37.000000', 'consum', 0.0210, 'lps'),
	(593359, 130, '2014-03-15 01:17:38.000000', 'consum', 0.0221, 'lps'),
	(593360, 130, '2014-03-15 01:17:39.000000', 'consum', 0.0221, 'lps'),
	(593361, 130, '2014-03-15 01:17:40.000000', 'consum', 0.0217, 'lps'),
	(593362, 130, '2014-03-15 01:17:41.000000', 'consum', 0.0214, 'lps'),
	(593363, 130, '2014-03-15 01:17:42.000000', 'consum', 0.0223, 'lps'),
	(593364, 130, '2014-03-15 01:17:43.000000', 'consum', 0.0217, 'lps'),
	(593365, 130, '2014-03-15 01:17:44.000000', 'consum', 0.0222, 'lps'),
	(593366, 130, '2014-03-15 01:17:45.000000', 'consum', 0.0222, 'lps'),
	(593367, 130, '2014-03-15 01:17:46.000000', 'consum', 0.0219, 'lps'),
	(593368, 130, '2014-03-15 01:17:47.000000', 'consum', 0.0217, 'lps'),
	(593369, 130, '2014-03-15 01:17:48.000000', 'consum', 0.0221, 'lps'),
	(593370, 130, '2014-03-15 01:17:49.000000', 'consum', 0.0213, 'lps'),
	(593371, 130, '2014-03-15 01:17:50.000000', 'consum', 0.0222, 'lps'),
	(593372, 130, '2014-03-15 01:17:51.000000', 'consum', 0.0219, 'lps'),
	(593373, 130, '2014-03-15 01:17:52.000000', 'consum', 0.0219, 'lps'),
	(593374, 130, '2014-03-15 01:17:53.000000', 'consum', 0.0214, 'lps'),
	(593375, 130, '2014-03-15 01:17:54.000000', 'consum', 0.0218, 'lps'),
	(593376, 130, '2014-03-15 01:17:55.000000', 'consum', 0.0223, 'lps'),
	(593377, 130, '2014-03-15 01:17:56.000000', 'consum', 0.0224, 'lps'),
	(593378, 130, '2014-03-15 01:17:57.000000', 'consum', 0.0224, 'lps'),
	(593379, 130, '2014-03-15 01:17:58.000000', 'consum', 0.0211, 'lps'),
	(593380, 130, '2014-03-15 01:17:59.000000', 'consum', 0.0216, 'lps'),
	(593381, 130, '2014-03-15 01:18:00.000000', 'consum', 0.0222, 'lps'),
	(593382, 130, '2014-03-15 01:18:01.000000', 'consum', 0.0224, 'lps'),
	(593383, 130, '2014-03-15 01:18:02.000000', 'consum', 0.0216, 'lps'),
	(593384, 130, '2014-03-15 01:18:03.000000', 'consum', 0.0212, 'lps'),
	(593385, 130, '2014-03-15 01:18:04.000000', 'consum', 0.0217, 'lps'),
	(593386, 130, '2014-03-15 01:18:05.000000', 'consum', 0.0211, 'lps'),
	(593387, 130, '2014-03-15 01:18:06.000000', 'consum', 0.0224, 'lps'),
	(593388, 130, '2014-03-15 01:18:07.000000', 'consum', 0.0219, 'lps'),
	(593389, 130, '2014-03-15 01:18:08.000000', 'consum', 0.0211, 'lps'),
	(593390, 130, '2014-03-15 01:18:09.000000', 'consum', 0.0220, 'lps'),
	(593391, 130, '2014-03-15 01:18:10.000000', 'consum', 0.0213, 'lps'),
	(593392, 130, '2014-03-15 01:18:11.000000', 'consum', 0.0224, 'lps'),
	(593393, 130, '2014-03-15 01:18:12.000000', 'consum', 0.0212, 'lps'),
	(593394, 130, '2014-03-15 01:18:13.000000', 'consum', 0.0222, 'lps'),
	(593395, 130, '2014-03-15 01:18:14.000000', 'consum', 0.0220, 'lps'),
	(593396, 130, '2014-03-15 01:18:15.000000', 'consum', 0.0224, 'lps'),
	(593397, 130, '2014-03-15 01:18:16.000000', 'consum', 0.0222, 'lps'),
	(593398, 130, '2014-03-15 01:18:17.000000', 'consum', 0.0213, 'lps'),
	(593399, 130, '2014-03-15 01:18:18.000000', 'consum', 0.0217, 'lps'),
	(593400, 130, '2014-03-15 01:18:19.000000', 'consum', 0.0210, 'lps'),
	(593401, 130, '2014-03-15 01:18:20.000000', 'consum', 0.0219, 'lps'),
	(593402, 130, '2014-03-15 01:18:21.000000', 'consum', 0.0212, 'lps'),
	(593403, 130, '2014-03-15 01:18:22.000000', 'consum', 0.0221, 'lps'),
	(593404, 130, '2014-03-15 01:18:23.000000', 'consum', 0.0214, 'lps'),
	(593405, 130, '2014-03-15 01:18:24.000000', 'consum', 0.0212, 'lps'),
	(593406, 130, '2014-03-15 01:18:25.000000', 'consum', 0.0210, 'lps'),
	(593407, 130, '2014-03-15 01:18:26.000000', 'consum', 0.0219, 'lps'),
	(593408, 130, '2014-03-15 01:18:27.000000', 'consum', 0.0224, 'lps'),
	(593409, 130, '2014-03-15 01:18:28.000000', 'consum', 0.0224, 'lps'),
	(593410, 130, '2014-03-15 01:18:29.000000', 'consum', 0.0210, 'lps'),
	(593411, 130, '2014-03-15 01:18:30.000000', 'consum', 0.0214, 'lps'),
	(593412, 130, '2014-03-15 01:18:31.000000', 'consum', 0.0214, 'lps'),
	(593413, 130, '2014-03-15 01:18:32.000000', 'consum', 0.0219, 'lps'),
	(593414, 130, '2014-03-15 01:18:33.000000', 'consum', 0.0214, 'lps'),
	(593415, 130, '2014-03-15 01:18:34.000000', 'consum', 0.0220, 'lps'),
	(593416, 130, '2014-03-15 01:18:35.000000', 'consum', 0.0215, 'lps'),
	(593417, 130, '2014-03-15 01:18:36.000000', 'consum', 0.0223, 'lps'),
	(593418, 130, '2014-03-15 01:18:37.000000', 'consum', 0.0213, 'lps'),
	(593419, 130, '2014-03-15 01:18:38.000000', 'consum', 0.0217, 'lps'),
	(593420, 130, '2014-03-15 01:18:39.000000', 'consum', 0.0221, 'lps'),
	(593421, 130, '2014-03-15 01:18:40.000000', 'consum', 0.0217, 'lps'),
	(593422, 130, '2014-03-15 01:18:41.000000', 'consum', 0.0211, 'lps'),
	(593423, 130, '2014-03-15 01:18:42.000000', 'consum', 0.0224, 'lps'),
	(593424, 130, '2014-03-15 01:18:43.000000', 'consum', 0.0217, 'lps'),
	(593425, 130, '2014-03-15 01:18:44.000000', 'consum', 0.0219, 'lps'),
	(593426, 130, '2014-03-15 01:18:45.000000', 'consum', 0.0221, 'lps'),
	(593427, 130, '2014-03-15 01:18:46.000000', 'consum', 0.0221, 'lps'),
	(593428, 130, '2014-03-15 01:18:47.000000', 'consum', 0.0217, 'lps'),
	(593429, 130, '2014-03-15 01:18:48.000000', 'consum', 0.0215, 'lps'),
	(593430, 130, '2014-03-15 01:18:49.000000', 'consum', 0.0212, 'lps'),
	(593431, 130, '2014-03-15 01:18:50.000000', 'consum', 0.0221, 'lps'),
	(593432, 130, '2014-03-15 01:18:51.000000', 'consum', 0.0213, 'lps'),
	(593433, 130, '2014-03-15 01:18:52.000000', 'consum', 0.0210, 'lps'),
	(593434, 130, '2014-03-15 01:18:53.000000', 'consum', 0.0214, 'lps'),
	(593435, 130, '2014-03-15 01:18:54.000000', 'consum', 0.0217, 'lps'),
	(593436, 130, '2014-03-15 01:18:55.000000', 'consum', 0.0218, 'lps'),
	(593437, 130, '2014-03-15 01:18:56.000000', 'consum', 0.0216, 'lps'),
	(593438, 130, '2014-03-15 01:18:57.000000', 'consum', 0.0214, 'lps'),
	(593439, 130, '2014-03-15 01:18:58.000000', 'consum', 0.0216, 'lps'),
	(593440, 130, '2014-03-15 01:18:59.000000', 'consum', 0.0210, 'lps'),
	(593441, 130, '2014-03-15 01:19:00.000000', 'consum', 0.0210, 'lps'),
	(593442, 130, '2014-03-15 01:19:01.000000', 'consum', 0.0223, 'lps'),
	(593443, 130, '2014-03-15 01:19:02.000000', 'consum', 0.0215, 'lps'),
	(593444, 130, '2014-03-15 01:19:03.000000', 'consum', 0.0214, 'lps'),
	(593445, 130, '2014-03-15 01:19:04.000000', 'consum', 0.0215, 'lps'),
	(593446, 130, '2014-03-15 01:19:05.000000', 'consum', 0.0224, 'lps'),
	(593447, 130, '2014-03-15 01:19:06.000000', 'consum', 0.0221, 'lps'),
	(593448, 130, '2014-03-15 01:19:07.000000', 'consum', 0.0223, 'lps'),
	(593449, 130, '2014-03-15 01:19:08.000000', 'consum', 0.0212, 'lps'),
	(593450, 130, '2014-03-15 01:19:09.000000', 'consum', 0.0214, 'lps'),
	(593451, 130, '2014-03-15 01:19:10.000000', 'consum', 0.0222, 'lps'),
	(593452, 130, '2014-03-15 01:19:11.000000', 'consum', 0.0212, 'lps'),
	(593453, 130, '2014-03-15 01:19:12.000000', 'consum', 0.0218, 'lps'),
	(593454, 130, '2014-03-15 01:19:13.000000', 'consum', 0.0213, 'lps'),
	(593455, 130, '2014-03-15 01:19:14.000000', 'consum', 0.0215, 'lps'),
	(593456, 130, '2014-03-15 01:19:15.000000', 'consum', 0.0213, 'lps'),
	(593457, 130, '2014-03-15 01:19:16.000000', 'consum', 0.0212, 'lps'),
	(593458, 130, '2014-03-15 01:19:17.000000', 'consum', 0.0224, 'lps'),
	(593459, 130, '2014-03-15 01:19:18.000000', 'consum', 0.0214, 'lps'),
	(593460, 130, '2014-03-15 01:19:19.000000', 'consum', 0.0218, 'lps'),
	(593461, 130, '2014-03-15 01:19:20.000000', 'consum', 0.0224, 'lps'),
	(593462, 130, '2014-03-15 01:19:21.000000', 'consum', 0.0213, 'lps'),
	(593463, 130, '2014-03-15 01:19:22.000000', 'consum', 0.0211, 'lps'),
	(593464, 130, '2014-03-15 01:19:23.000000', 'consum', 0.0210, 'lps'),
	(593465, 130, '2014-03-15 01:19:24.000000', 'consum', 0.0219, 'lps'),
	(593466, 130, '2014-03-15 01:19:25.000000', 'consum', 0.0213, 'lps'),
	(593467, 130, '2014-03-15 01:19:26.000000', 'consum', 0.0214, 'lps'),
	(593468, 130, '2014-03-15 01:19:27.000000', 'consum', 0.0220, 'lps'),
	(593469, 130, '2014-03-15 01:19:28.000000', 'consum', 0.0219, 'lps'),
	(593470, 130, '2014-03-15 01:19:29.000000', 'consum', 0.0210, 'lps'),
	(593471, 130, '2014-03-15 01:19:30.000000', 'consum', 0.0214, 'lps'),
	(593472, 130, '2014-03-15 01:19:31.000000', 'consum', 0.0214, 'lps'),
	(593473, 130, '2014-03-15 01:19:32.000000', 'consum', 0.0219, 'lps'),
	(593474, 130, '2014-03-15 01:19:33.000000', 'consum', 0.0214, 'lps'),
	(593475, 130, '2014-03-15 01:19:34.000000', 'consum', 0.0220, 'lps'),
	(593476, 130, '2014-03-15 01:19:35.000000', 'consum', 0.0215, 'lps'),
	(593477, 130, '2014-03-15 01:19:36.000000', 'consum', 0.0224, 'lps'),
	(593478, 130, '2014-03-15 01:19:37.000000', 'consum', 0.0217, 'lps'),
	(593479, 130, '2014-03-15 01:19:38.000000', 'consum', 0.0221, 'lps'),
	(593480, 130, '2014-03-15 01:19:39.000000', 'consum', 0.0214, 'lps'),
	(593481, 130, '2014-03-15 01:19:40.000000', 'consum', 0.0211, 'lps'),
	(593482, 130, '2014-03-15 01:19:41.000000', 'consum', 0.0218, 'lps'),
	(593483, 130, '2014-03-15 01:19:42.000000', 'consum', 0.0219, 'lps'),
	(593484, 130, '2014-03-15 01:19:43.000000', 'consum', 0.0216, 'lps'),
	(593485, 130, '2014-03-15 01:19:44.000000', 'consum', 0.0213, 'lps'),
	(593486, 130, '2014-03-15 01:19:45.000000', 'consum', 0.0223, 'lps'),
	(593487, 130, '2014-03-15 01:19:46.000000', 'consum', 0.0220, 'lps'),
	(593488, 130, '2014-03-15 01:19:47.000000', 'consum', 0.0224, 'lps'),
	(593489, 130, '2014-03-15 01:19:48.000000', 'consum', 0.0218, 'lps'),
	(593490, 130, '2014-03-15 01:19:49.000000', 'consum', 0.0223, 'lps'),
	(593491, 130, '2014-03-15 01:19:50.000000', 'consum', 0.0224, 'lps'),
	(593492, 130, '2014-03-15 01:19:51.000000', 'consum', 0.0210, 'lps'),
	(593493, 130, '2014-03-15 01:19:52.000000', 'consum', 0.0213, 'lps'),
	(593494, 130, '2014-03-15 01:19:53.000000', 'consum', 0.0211, 'lps'),
	(593495, 130, '2014-03-15 01:19:54.000000', 'consum', 0.0220, 'lps'),
	(593496, 130, '2014-03-15 01:19:55.000000', 'consum', 0.0214, 'lps'),
	(593497, 130, '2014-03-15 01:19:56.000000', 'consum', 0.0214, 'lps'),
	(593498, 130, '2014-03-15 01:19:57.000000', 'consum', 0.0221, 'lps'),
	(593499, 130, '2014-03-15 01:19:58.000000', 'consum', 0.0221, 'lps'),
	(593500, 130, '2014-03-15 01:19:59.000000', 'consum', 0.0217, 'lps'),
	(593501, 130, '2014-03-15 01:20:00.000000', 'consum', 0.0215, 'lps'),
	(593502, 130, '2014-03-15 01:20:01.000000', 'consum', 0.0215, 'lps'),
	(593503, 130, '2014-03-15 01:20:02.000000', 'consum', 0.0220, 'lps'),
	(593504, 130, '2014-03-15 01:20:03.000000', 'consum', 0.0214, 'lps'),
	(593505, 130, '2014-03-15 01:20:04.000000', 'consum', 0.0215, 'lps'),
	(593506, 130, '2014-03-15 01:20:05.000000', 'consum', 0.0210, 'lps'),
	(593507, 130, '2014-03-15 01:20:06.000000', 'consum', 0.0211, 'lps'),
	(593508, 130, '2014-03-15 01:20:07.000000', 'consum', 0.0215, 'lps'),
	(593509, 130, '2014-03-15 01:20:08.000000', 'consum', 0.0218, 'lps'),
	(593510, 130, '2014-03-15 01:20:09.000000', 'consum', 0.0221, 'lps'),
	(593511, 130, '2014-03-15 01:20:10.000000', 'consum', 0.0213, 'lps'),
	(593512, 130, '2014-03-15 01:20:11.000000', 'consum', 0.0221, 'lps'),
	(593513, 130, '2014-03-15 01:20:12.000000', 'consum', 0.0211, 'lps'),
	(593514, 130, '2014-03-15 01:20:13.000000', 'consum', 0.0213, 'lps'),
	(593515, 130, '2014-03-15 01:20:14.000000', 'consum', 0.0224, 'lps'),
	(593516, 130, '2014-03-15 01:20:15.000000', 'consum', 0.0211, 'lps'),
	(593517, 130, '2014-03-15 01:20:16.000000', 'consum', 0.0217, 'lps'),
	(593518, 130, '2014-03-15 01:20:17.000000', 'consum', 0.0215, 'lps'),
	(593519, 130, '2014-03-15 01:20:18.000000', 'consum', 0.0212, 'lps'),
	(593520, 130, '2014-03-15 01:20:19.000000', 'consum', 0.0219, 'lps'),
	(593521, 130, '2014-03-15 01:20:20.000000', 'consum', 0.0223, 'lps'),
	(593522, 130, '2014-03-15 01:20:21.000000', 'consum', 0.0218, 'lps'),
	(593523, 130, '2014-03-15 01:20:22.000000', 'consum', 0.0212, 'lps'),
	(593524, 130, '2014-03-15 01:20:23.000000', 'consum', 0.0224, 'lps'),
	(593525, 130, '2014-03-15 01:20:24.000000', 'consum', 0.0215, 'lps'),
	(593526, 130, '2014-03-15 01:20:25.000000', 'consum', 0.0211, 'lps'),
	(593527, 130, '2014-03-15 01:20:26.000000', 'consum', 0.0215, 'lps'),
	(593528, 130, '2014-03-15 01:20:27.000000', 'consum', 0.0215, 'lps'),
	(593529, 130, '2014-03-15 01:20:28.000000', 'consum', 0.0222, 'lps'),
	(593530, 130, '2014-03-15 01:20:29.000000', 'consum', 0.0224, 'lps'),
	(593531, 130, '2014-03-15 01:20:30.000000', 'consum', 0.0214, 'lps'),
	(593532, 130, '2014-03-15 01:20:31.000000', 'consum', 0.0218, 'lps'),
	(593533, 130, '2014-03-15 01:20:32.000000', 'consum', 0.0223, 'lps'),
	(593534, 130, '2014-03-15 01:20:33.000000', 'consum', 0.0221, 'lps'),
	(593535, 130, '2014-03-15 01:20:34.000000', 'consum', 0.0215, 'lps'),
	(593536, 130, '2014-03-15 01:20:35.000000', 'consum', 0.0215, 'lps'),
	(593537, 130, '2014-03-15 01:20:36.000000', 'consum', 0.0219, 'lps'),
	(593538, 130, '2014-03-15 01:20:37.000000', 'consum', 0.0213, 'lps'),
	(593539, 130, '2014-03-15 01:20:38.000000', 'consum', 0.0214, 'lps'),
	(593540, 130, '2014-03-15 01:20:39.000000', 'consum', 0.0221, 'lps'),
	(593541, 130, '2014-03-15 01:20:40.000000', 'consum', 0.0210, 'lps'),
	(593542, 130, '2014-03-15 01:20:41.000000', 'consum', 0.0221, 'lps'),
	(593543, 130, '2014-03-15 01:20:42.000000', 'consum', 0.0222, 'lps'),
	(593544, 130, '2014-03-15 01:20:43.000000', 'consum', 0.0219, 'lps'),
	(593545, 130, '2014-03-15 01:20:44.000000', 'consum', 0.0223, 'lps'),
	(593546, 130, '2014-03-15 01:20:45.000000', 'consum', 0.0219, 'lps'),
	(593547, 130, '2014-03-15 01:20:46.000000', 'consum', 0.0216, 'lps'),
	(593548, 130, '2014-03-15 01:20:47.000000', 'consum', 0.0212, 'lps'),
	(593549, 130, '2014-03-15 01:20:48.000000', 'consum', 0.0217, 'lps'),
	(593550, 130, '2014-03-15 01:20:49.000000', 'consum', 0.0211, 'lps'),
	(593551, 130, '2014-03-15 01:20:50.000000', 'consum', 0.0223, 'lps'),
	(593552, 130, '2014-03-15 01:20:51.000000', 'consum', 0.0214, 'lps'),
	(593553, 130, '2014-03-15 01:20:52.000000', 'consum', 0.0219, 'lps'),
	(593554, 130, '2014-03-15 01:20:53.000000', 'consum', 0.0216, 'lps'),
	(593555, 130, '2014-03-15 01:20:54.000000', 'consum', 0.0214, 'lps'),
	(593556, 130, '2014-03-15 01:20:55.000000', 'consum', 0.0210, 'lps'),
	(593557, 130, '2014-03-15 01:20:56.000000', 'consum', 0.0214, 'lps'),
	(593558, 130, '2014-03-15 01:20:57.000000', 'consum', 0.0217, 'lps'),
	(593559, 130, '2014-03-15 01:20:58.000000', 'consum', 0.0217, 'lps'),
	(593560, 130, '2014-03-15 01:20:59.000000', 'consum', 0.0224, 'lps'),
	(593561, 130, '2014-03-15 01:21:00.000000', 'consum', 0.0214, 'lps'),
	(593562, 130, '2014-03-15 01:21:01.000000', 'consum', 0.0220, 'lps'),
	(593563, 130, '2014-03-15 01:21:02.000000', 'consum', 0.0217, 'lps'),
	(593564, 130, '2014-03-15 01:21:03.000000', 'consum', 0.0214, 'lps'),
	(593565, 130, '2014-03-15 01:21:04.000000', 'consum', 0.0213, 'lps'),
	(593566, 130, '2014-03-15 01:21:05.000000', 'consum', 0.0212, 'lps'),
	(593567, 130, '2014-03-15 01:21:06.000000', 'consum', 0.0211, 'lps'),
	(593568, 130, '2014-03-15 01:21:07.000000', 'consum', 0.0212, 'lps'),
	(593569, 130, '2014-03-15 01:21:08.000000', 'consum', 0.0216, 'lps'),
	(593570, 130, '2014-03-15 01:21:09.000000', 'consum', 0.0220, 'lps'),
	(593571, 130, '2014-03-15 01:21:10.000000', 'consum', 0.0212, 'lps'),
	(593572, 130, '2014-03-15 01:21:11.000000', 'consum', 0.0221, 'lps'),
	(593573, 130, '2014-03-15 01:21:12.000000', 'consum', 0.0213, 'lps'),
	(593574, 130, '2014-03-15 01:21:13.000000', 'consum', 0.0224, 'lps'),
	(593575, 130, '2014-03-15 01:21:14.000000', 'consum', 0.0224, 'lps'),
	(593576, 130, '2014-03-15 01:21:15.000000', 'consum', 0.0211, 'lps'),
	(593577, 130, '2014-03-15 01:21:16.000000', 'consum', 0.0220, 'lps'),
	(593578, 130, '2014-03-15 01:21:17.000000', 'consum', 0.0224, 'lps'),
	(593579, 130, '2014-03-15 01:21:18.000000', 'consum', 0.0223, 'lps'),
	(593580, 130, '2014-03-15 01:21:19.000000', 'consum', 0.0217, 'lps'),
	(593581, 130, '2014-03-15 01:21:20.000000', 'consum', 0.0222, 'lps'),
	(593582, 130, '2014-03-15 01:21:21.000000', 'consum', 0.0222, 'lps'),
	(593583, 130, '2014-03-15 01:21:22.000000', 'consum', 0.0216, 'lps'),
	(593584, 130, '2014-03-15 01:21:23.000000', 'consum', 0.0220, 'lps'),
	(593585, 130, '2014-03-15 01:21:24.000000', 'consum', 0.0212, 'lps'),
	(593586, 130, '2014-03-15 01:21:25.000000', 'consum', 0.0221, 'lps'),
	(593587, 130, '2014-03-15 01:21:26.000000', 'consum', 0.0215, 'lps'),
	(593588, 130, '2014-03-15 01:21:27.000000', 'consum', 0.0215, 'lps'),
	(593589, 130, '2014-03-15 01:21:28.000000', 'consum', 0.0224, 'lps'),
	(593590, 130, '2014-03-15 01:21:29.000000', 'consum', 0.0219, 'lps'),
	(593591, 130, '2014-03-15 01:21:30.000000', 'consum', 0.0213, 'lps'),
	(593592, 130, '2014-03-15 01:21:31.000000', 'consum', 0.0215, 'lps'),
	(593593, 130, '2014-03-15 01:21:32.000000', 'consum', 0.0210, 'lps'),
	(593594, 130, '2014-03-15 01:21:33.000000', 'consum', 0.0212, 'lps'),
	(593595, 130, '2014-03-15 01:21:34.000000', 'consum', 0.0221, 'lps'),
	(593596, 130, '2014-03-15 01:21:35.000000', 'consum', 0.0215, 'lps'),
	(593597, 130, '2014-03-15 01:21:36.000000', 'consum', 0.0215, 'lps'),
	(593598, 130, '2014-03-15 01:21:37.000000', 'consum', 0.0220, 'lps'),
	(593599, 130, '2014-03-15 01:21:38.000000', 'consum', 0.0218, 'lps'),
	(593600, 130, '2014-03-15 01:21:39.000000', 'consum', 0.0218, 'lps'),
	(593601, 130, '2014-03-15 01:21:40.000000', 'consum', 0.0212, 'lps'),
	(593602, 130, '2014-03-15 01:21:41.000000', 'consum', 0.0213, 'lps'),
	(593603, 130, '2014-03-15 01:21:42.000000', 'consum', 0.0217, 'lps'),
	(593604, 130, '2014-03-15 01:21:43.000000', 'consum', 0.0210, 'lps'),
	(593605, 130, '2014-03-15 01:21:44.000000', 'consum', 0.0216, 'lps'),
	(593606, 130, '2014-03-15 01:21:45.000000', 'consum', 0.0211, 'lps'),
	(593607, 130, '2014-03-15 01:21:46.000000', 'consum', 0.0212, 'lps'),
	(593608, 130, '2014-03-15 01:21:47.000000', 'consum', 0.0220, 'lps'),
	(593609, 130, '2014-03-15 01:21:48.000000', 'consum', 0.0223, 'lps'),
	(593610, 130, '2014-03-15 01:21:49.000000', 'consum', 0.0217, 'lps'),
	(593611, 130, '2014-03-15 01:21:50.000000', 'consum', 0.0222, 'lps'),
	(593612, 130, '2014-03-15 01:21:51.000000', 'consum', 0.0220, 'lps'),
	(593613, 130, '2014-03-15 01:21:52.000000', 'consum', 0.0210, 'lps'),
	(593614, 130, '2014-03-15 01:21:53.000000', 'consum', 0.0210, 'lps'),
	(593615, 130, '2014-03-15 01:21:54.000000', 'consum', 0.0224, 'lps'),
	(593616, 130, '2014-03-15 01:21:55.000000', 'consum', 0.0220, 'lps'),
	(593617, 130, '2014-03-15 01:21:56.000000', 'consum', 0.0218, 'lps'),
	(593618, 130, '2014-03-15 01:21:57.000000', 'consum', 0.0220, 'lps'),
	(593619, 130, '2014-03-15 01:21:58.000000', 'consum', 0.0223, 'lps'),
	(593620, 130, '2014-03-15 01:21:59.000000', 'consum', 0.0215, 'lps'),
	(593621, 130, '2014-03-15 01:22:00.000000', 'consum', 0.0211, 'lps'),
	(593622, 130, '2014-03-15 01:22:01.000000', 'consum', 0.0218, 'lps'),
	(593623, 130, '2014-03-15 01:22:02.000000', 'consum', 0.0216, 'lps'),
	(593624, 130, '2014-03-15 01:22:03.000000', 'consum', 0.0217, 'lps'),
	(593625, 130, '2014-03-15 01:22:04.000000', 'consum', 0.0211, 'lps'),
	(593626, 130, '2014-03-15 01:22:05.000000', 'consum', 0.0224, 'lps'),
	(593627, 130, '2014-03-15 01:22:06.000000', 'consum', 0.0218, 'lps'),
	(593628, 130, '2014-03-15 01:22:07.000000', 'consum', 0.0210, 'lps'),
	(593629, 130, '2014-03-15 01:22:08.000000', 'consum', 0.0215, 'lps'),
	(593630, 130, '2014-03-15 01:22:09.000000', 'consum', 0.0221, 'lps'),
	(593631, 130, '2014-03-15 01:22:10.000000', 'consum', 0.0221, 'lps'),
	(593632, 130, '2014-03-15 01:22:11.000000', 'consum', 0.0218, 'lps'),
	(593633, 130, '2014-03-15 01:22:12.000000', 'consum', 0.0217, 'lps'),
	(593634, 130, '2014-03-15 01:22:13.000000', 'consum', 0.0220, 'lps'),
	(593635, 130, '2014-03-15 01:22:14.000000', 'consum', 0.0210, 'lps'),
	(593636, 130, '2014-03-15 01:22:15.000000', 'consum', 0.0211, 'lps'),
	(593637, 130, '2014-03-15 01:22:16.000000', 'consum', 0.0215, 'lps'),
	(593638, 130, '2014-03-15 01:22:17.000000', 'consum', 0.0218, 'lps'),
	(593639, 130, '2014-03-15 01:22:18.000000', 'consum', 0.0222, 'lps'),
	(593640, 130, '2014-03-15 01:22:19.000000', 'consum', 0.0215, 'lps'),
	(593641, 130, '2014-03-15 01:22:20.000000', 'consum', 0.0214, 'lps'),
	(593642, 130, '2014-03-15 01:22:21.000000', 'consum', 0.0218, 'lps'),
	(593643, 130, '2014-03-15 01:22:22.000000', 'consum', 0.0222, 'lps'),
	(593644, 130, '2014-03-15 01:22:23.000000', 'consum', 0.0217, 'lps'),
	(593645, 130, '2014-03-15 01:22:24.000000', 'consum', 0.0211, 'lps'),
	(593646, 130, '2014-03-15 01:22:25.000000', 'consum', 0.0223, 'lps'),
	(593647, 130, '2014-03-15 01:22:26.000000', 'consum', 0.0211, 'lps'),
	(593648, 130, '2014-03-15 01:22:27.000000', 'consum', 0.0222, 'lps'),
	(593649, 130, '2014-03-15 01:22:28.000000', 'consum', 0.0221, 'lps'),
	(593650, 130, '2014-03-15 01:22:29.000000', 'consum', 0.0218, 'lps'),
	(593651, 130, '2014-03-15 01:22:30.000000', 'consum', 0.0216, 'lps'),
	(593652, 130, '2014-03-15 01:22:31.000000', 'consum', 0.0215, 'lps'),
	(593653, 130, '2014-03-15 01:22:32.000000', 'consum', 0.0220, 'lps'),
	(593654, 130, '2014-03-15 01:22:33.000000', 'consum', 0.0215, 'lps'),
	(593655, 130, '2014-03-15 01:22:34.000000', 'consum', 0.0220, 'lps'),
	(593656, 130, '2014-03-15 01:22:35.000000', 'consum', 0.0214, 'lps'),
	(593657, 130, '2014-03-15 01:22:36.000000', 'consum', 0.0218, 'lps'),
	(593658, 130, '2014-03-15 01:22:37.000000', 'consum', 0.0210, 'lps'),
	(593659, 130, '2014-03-15 01:22:38.000000', 'consum', 0.0213, 'lps'),
	(593660, 130, '2014-03-15 01:22:39.000000', 'consum', 0.0213, 'lps'),
	(593661, 130, '2014-03-15 01:22:40.000000', 'consum', 0.0214, 'lps'),
	(593662, 130, '2014-03-15 01:22:41.000000', 'consum', 0.0223, 'lps'),
	(593663, 130, '2014-03-15 01:22:42.000000', 'consum', 0.0216, 'lps'),
	(593664, 130, '2014-03-15 01:22:43.000000', 'consum', 0.0220, 'lps'),
	(593665, 130, '2014-03-15 01:22:44.000000', 'consum', 0.0210, 'lps'),
	(593666, 130, '2014-03-15 01:22:45.000000', 'consum', 0.0212, 'lps'),
	(593667, 130, '2014-03-15 01:22:46.000000', 'consum', 0.0222, 'lps'),
	(593668, 130, '2014-03-15 01:22:47.000000', 'consum', 0.0216, 'lps'),
	(593669, 130, '2014-03-15 01:22:48.000000', 'consum', 0.0221, 'lps'),
	(593670, 130, '2014-03-15 01:22:49.000000', 'consum', 0.0219, 'lps'),
	(593671, 130, '2014-03-15 01:22:50.000000', 'consum', 0.0222, 'lps'),
	(593672, 130, '2014-03-15 01:22:51.000000', 'consum', 0.0213, 'lps'),
	(593673, 130, '2014-03-15 01:22:52.000000', 'consum', 0.0219, 'lps'),
	(593674, 130, '2014-03-15 01:22:53.000000', 'consum', 0.0216, 'lps'),
	(593675, 130, '2014-03-15 01:22:54.000000', 'consum', 0.0212, 'lps'),
	(593676, 130, '2014-03-15 01:22:55.000000', 'consum', 0.0220, 'lps'),
	(593677, 130, '2014-03-15 01:22:56.000000', 'consum', 0.0210, 'lps'),
	(593678, 130, '2014-03-15 01:22:57.000000', 'consum', 0.0212, 'lps'),
	(593679, 130, '2014-03-15 01:22:58.000000', 'consum', 0.0218, 'lps'),
	(593680, 130, '2014-03-15 01:22:59.000000', 'consum', 0.0213, 'lps'),
	(593681, 130, '2014-03-15 01:23:00.000000', 'consum', 0.0219, 'lps'),
	(593682, 130, '2014-03-15 01:23:01.000000', 'consum', 0.0218, 'lps'),
	(593683, 130, '2014-03-15 01:23:02.000000', 'consum', 0.0222, 'lps'),
	(593684, 130, '2014-03-15 01:23:03.000000', 'consum', 0.0215, 'lps'),
	(593685, 130, '2014-03-15 01:23:04.000000', 'consum', 0.0215, 'lps'),
	(593686, 130, '2014-03-15 01:23:05.000000', 'consum', 0.0220, 'lps'),
	(593687, 130, '2014-03-15 01:23:06.000000', 'consum', 0.0217, 'lps'),
	(593688, 130, '2014-03-15 01:23:07.000000', 'consum', 0.0213, 'lps'),
	(593689, 130, '2014-03-15 01:23:08.000000', 'consum', 0.0220, 'lps'),
	(593690, 130, '2014-03-15 01:23:09.000000', 'consum', 0.0221, 'lps'),
	(593691, 130, '2014-03-15 01:23:10.000000', 'consum', 0.0220, 'lps'),
	(593692, 130, '2014-03-15 01:23:11.000000', 'consum', 0.0211, 'lps'),
	(593693, 130, '2014-03-15 01:23:12.000000', 'consum', 0.0219, 'lps'),
	(593694, 130, '2014-03-15 01:23:13.000000', 'consum', 0.0221, 'lps'),
	(593695, 130, '2014-03-15 01:23:14.000000', 'consum', 0.0210, 'lps'),
	(593696, 130, '2014-03-15 01:23:15.000000', 'consum', 0.0221, 'lps'),
	(593697, 130, '2014-03-15 01:23:16.000000', 'consum', 0.0222, 'lps'),
	(593698, 130, '2014-03-15 01:23:17.000000', 'consum', 0.0223, 'lps'),
	(593699, 130, '2014-03-15 01:23:18.000000', 'consum', 0.0223, 'lps'),
	(593700, 130, '2014-03-15 01:23:19.000000', 'consum', 0.0224, 'lps'),
	(593701, 130, '2014-03-15 01:23:20.000000', 'consum', 0.0210, 'lps'),
	(593702, 130, '2014-03-15 01:23:21.000000', 'consum', 0.0215, 'lps'),
	(593703, 130, '2014-03-15 01:23:22.000000', 'consum', 0.0219, 'lps'),
	(593704, 130, '2014-03-15 01:23:23.000000', 'consum', 0.0210, 'lps'),
	(593705, 130, '2014-03-15 01:23:24.000000', 'consum', 0.0213, 'lps'),
	(593706, 130, '2014-03-15 01:23:25.000000', 'consum', 0.0211, 'lps'),
	(593707, 130, '2014-03-15 01:23:26.000000', 'consum', 0.0223, 'lps'),
	(593708, 130, '2014-03-15 01:23:27.000000', 'consum', 0.0211, 'lps'),
	(593709, 130, '2014-03-15 01:23:28.000000', 'consum', 0.0222, 'lps'),
	(593710, 130, '2014-03-15 01:23:29.000000', 'consum', 0.0223, 'lps'),
	(593711, 130, '2014-03-15 01:23:30.000000', 'consum', 0.0211, 'lps'),
	(593712, 130, '2014-03-15 01:23:31.000000', 'consum', 0.0219, 'lps'),
	(593713, 130, '2014-03-15 01:23:32.000000', 'consum', 0.0221, 'lps'),
	(593714, 130, '2014-03-15 01:23:33.000000', 'consum', 0.0211, 'lps'),
	(593715, 130, '2014-03-15 01:23:34.000000', 'consum', 0.0213, 'lps'),
	(593716, 130, '2014-03-15 01:23:35.000000', 'consum', 0.0220, 'lps'),
	(593717, 130, '2014-03-15 01:23:36.000000', 'consum', 0.0221, 'lps'),
	(593718, 130, '2014-03-15 01:23:37.000000', 'consum', 0.0222, 'lps'),
	(593719, 130, '2014-03-15 01:23:38.000000', 'consum', 0.0224, 'lps'),
	(593720, 130, '2014-03-15 01:23:39.000000', 'consum', 0.0213, 'lps'),
	(593721, 130, '2014-03-15 01:23:40.000000', 'consum', 0.0212, 'lps'),
	(593722, 130, '2014-03-15 01:23:41.000000', 'consum', 0.0214, 'lps'),
	(593723, 130, '2014-03-15 01:23:42.000000', 'consum', 0.0210, 'lps'),
	(593724, 130, '2014-03-15 01:23:43.000000', 'consum', 0.0211, 'lps'),
	(593725, 130, '2014-03-15 01:23:44.000000', 'consum', 0.0216, 'lps'),
	(593726, 130, '2014-03-15 01:23:45.000000', 'consum', 0.0222, 'lps'),
	(593727, 130, '2014-03-15 01:23:46.000000', 'consum', 0.0224, 'lps'),
	(593728, 130, '2014-03-15 01:23:47.000000', 'consum', 0.0215, 'lps'),
	(593729, 130, '2014-03-15 01:23:48.000000', 'consum', 0.0221, 'lps'),
	(593730, 130, '2014-03-15 01:23:49.000000', 'consum', 0.0223, 'lps'),
	(593731, 130, '2014-03-15 01:23:50.000000', 'consum', 0.0213, 'lps'),
	(593732, 130, '2014-03-15 01:23:51.000000', 'consum', 0.0216, 'lps'),
	(593733, 130, '2014-03-15 01:23:52.000000', 'consum', 0.0214, 'lps'),
	(593734, 130, '2014-03-15 01:23:53.000000', 'consum', 0.0214, 'lps'),
	(593735, 130, '2014-03-15 01:23:54.000000', 'consum', 0.0219, 'lps'),
	(593736, 130, '2014-03-15 01:23:55.000000', 'consum', 0.0213, 'lps'),
	(593737, 130, '2014-03-15 01:23:56.000000', 'consum', 0.0213, 'lps'),
	(593738, 130, '2014-03-15 01:23:57.000000', 'consum', 0.0215, 'lps'),
	(593739, 130, '2014-03-15 01:23:58.000000', 'consum', 0.0214, 'lps'),
	(593740, 130, '2014-03-15 01:23:59.000000', 'consum', 0.0216, 'lps'),
	(593741, 130, '2014-03-15 01:24:00.000000', 'consum', 0.0214, 'lps'),
	(593742, 130, '2014-03-15 01:24:01.000000', 'consum', 0.0212, 'lps'),
	(593743, 130, '2014-03-15 01:24:02.000000', 'consum', 0.0210, 'lps'),
	(593744, 130, '2014-03-15 01:24:03.000000', 'consum', 0.0219, 'lps'),
	(593745, 130, '2014-03-15 01:24:04.000000', 'consum', 0.0223, 'lps'),
	(593746, 130, '2014-03-15 01:24:05.000000', 'consum', 0.0220, 'lps'),
	(593747, 130, '2014-03-15 01:24:06.000000', 'consum', 0.0222, 'lps'),
	(593748, 130, '2014-03-15 01:24:07.000000', 'consum', 0.0211, 'lps'),
	(593749, 130, '2014-03-15 01:24:08.000000', 'consum', 0.0223, 'lps'),
	(593750, 130, '2014-03-15 01:24:09.000000', 'consum', 0.0215, 'lps'),
	(593751, 130, '2014-03-15 01:24:10.000000', 'consum', 0.0224, 'lps'),
	(593752, 130, '2014-03-15 01:24:11.000000', 'consum', 0.0222, 'lps'),
	(593753, 130, '2014-03-15 01:24:12.000000', 'consum', 0.0213, 'lps'),
	(593754, 130, '2014-03-15 01:24:13.000000', 'consum', 0.0219, 'lps'),
	(593755, 130, '2014-03-15 01:24:14.000000', 'consum', 0.0218, 'lps'),
	(593756, 130, '2014-03-15 01:24:15.000000', 'consum', 0.0223, 'lps'),
	(593757, 130, '2014-03-15 01:24:16.000000', 'consum', 0.0221, 'lps'),
	(593758, 130, '2014-03-15 01:24:17.000000', 'consum', 0.0212, 'lps'),
	(593759, 130, '2014-03-15 01:24:18.000000', 'consum', 0.0216, 'lps'),
	(593760, 130, '2014-03-15 01:24:19.000000', 'consum', 0.0220, 'lps'),
	(593761, 130, '2014-03-15 01:24:20.000000', 'consum', 0.0212, 'lps'),
	(593762, 130, '2014-03-15 01:24:21.000000', 'consum', 0.0221, 'lps'),
	(593763, 130, '2014-03-15 01:24:22.000000', 'consum', 0.0215, 'lps'),
	(593764, 130, '2014-03-15 01:24:23.000000', 'consum', 0.0215, 'lps'),
	(593765, 130, '2014-03-15 01:24:24.000000', 'consum', 0.0224, 'lps'),
	(593766, 130, '2014-03-15 01:24:25.000000', 'consum', 0.0218, 'lps'),
	(593767, 130, '2014-03-15 01:24:26.000000', 'consum', 0.0223, 'lps'),
	(593768, 130, '2014-03-15 01:24:27.000000', 'consum', 0.0222, 'lps'),
	(593769, 130, '2014-03-15 01:24:28.000000', 'consum', 0.0215, 'lps'),
	(593770, 130, '2014-03-15 01:24:29.000000', 'consum', 0.0218, 'lps'),
	(593771, 130, '2014-03-15 01:24:30.000000', 'consum', 0.0218, 'lps'),
	(593772, 130, '2014-03-15 01:24:31.000000', 'consum', 0.0211, 'lps'),
	(593773, 130, '2014-03-15 01:24:32.000000', 'consum', 0.0224, 'lps'),
	(593774, 130, '2014-03-15 01:24:33.000000', 'consum', 0.0217, 'lps'),
	(593775, 130, '2014-03-15 01:24:34.000000', 'consum', 0.0217, 'lps'),
	(593776, 130, '2014-03-15 01:24:35.000000', 'consum', 0.0224, 'lps'),
	(593777, 130, '2014-03-15 01:24:36.000000', 'consum', 0.0216, 'lps'),
	(593778, 130, '2014-03-15 01:24:37.000000', 'consum', 0.0212, 'lps'),
	(593779, 130, '2014-03-15 01:24:38.000000', 'consum', 0.0220, 'lps'),
	(593780, 130, '2014-03-15 01:24:39.000000', 'consum', 0.0223, 'lps'),
	(593781, 130, '2014-03-15 01:24:40.000000', 'consum', 0.0215, 'lps'),
	(593782, 130, '2014-03-15 01:24:41.000000', 'consum', 0.0214, 'lps'),
	(593783, 130, '2014-03-15 01:24:42.000000', 'consum', 0.0214, 'lps'),
	(593784, 130, '2014-03-15 01:24:43.000000', 'consum', 0.0220, 'lps'),
	(593785, 130, '2014-03-15 01:24:44.000000', 'consum', 0.0217, 'lps'),
	(593786, 130, '2014-03-15 01:24:45.000000', 'consum', 0.0217, 'lps'),
	(593787, 130, '2014-03-15 01:24:46.000000', 'consum', 0.0224, 'lps'),
	(593788, 130, '2014-03-15 01:24:47.000000', 'consum', 0.0216, 'lps'),
	(593789, 130, '2014-03-15 01:24:48.000000', 'consum', 0.0210, 'lps'),
	(593790, 130, '2014-03-15 01:24:49.000000', 'consum', 0.0210, 'lps'),
	(593791, 130, '2014-03-15 01:24:50.000000', 'consum', 0.0211, 'lps'),
	(593792, 130, '2014-03-15 01:24:51.000000', 'consum', 0.0216, 'lps'),
	(593793, 130, '2014-03-15 01:24:52.000000', 'consum', 0.0222, 'lps'),
	(593794, 130, '2014-03-15 01:24:53.000000', 'consum', 0.0222, 'lps'),
	(593795, 130, '2014-03-15 01:24:54.000000', 'consum', 0.0220, 'lps'),
	(593796, 130, '2014-03-15 01:24:55.000000', 'consum', 0.0211, 'lps'),
	(593797, 130, '2014-03-15 01:24:56.000000', 'consum', 0.0214, 'lps'),
	(593798, 130, '2014-03-15 01:24:57.000000', 'consum', 0.0213, 'lps'),
	(593799, 130, '2014-03-15 01:24:58.000000', 'consum', 0.0213, 'lps'),
	(593800, 130, '2014-03-15 01:24:59.000000', 'consum', 0.0215, 'lps'),
	(593801, 130, '2014-03-15 01:25:00.000000', 'consum', 0.0212, 'lps'),
	(593802, 130, '2014-03-15 01:25:01.000000', 'consum', 0.0222, 'lps'),
	(593803, 130, '2014-03-15 01:25:02.000000', 'consum', 0.0218, 'lps'),
	(593804, 130, '2014-03-15 01:25:03.000000', 'consum', 0.0213, 'lps'),
	(593805, 130, '2014-03-15 01:25:04.000000', 'consum', 0.0220, 'lps'),
	(593806, 130, '2014-03-15 01:25:05.000000', 'consum', 0.0220, 'lps'),
	(593807, 130, '2014-03-15 01:25:06.000000', 'consum', 0.0215, 'lps'),
	(593808, 130, '2014-03-15 01:25:07.000000', 'consum', 0.0221, 'lps'),
	(593809, 130, '2014-03-15 01:25:08.000000', 'consum', 0.0219, 'lps'),
	(593810, 130, '2014-03-15 01:25:09.000000', 'consum', 0.0223, 'lps'),
	(593811, 130, '2014-03-15 01:25:10.000000', 'consum', 0.0219, 'lps'),
	(593812, 130, '2014-03-15 01:25:11.000000', 'consum', 0.0216, 'lps'),
	(593813, 130, '2014-03-15 01:25:12.000000', 'consum', 0.0212, 'lps'),
	(593814, 130, '2014-03-15 01:25:13.000000', 'consum', 0.0221, 'lps'),
	(593815, 130, '2014-03-15 01:25:14.000000', 'consum', 0.0211, 'lps'),
	(593816, 130, '2014-03-15 01:25:15.000000', 'consum', 0.0215, 'lps'),
	(593817, 130, '2014-03-15 01:25:16.000000', 'consum', 0.0219, 'lps'),
	(593818, 130, '2014-03-15 01:25:17.000000', 'consum', 0.0223, 'lps'),
	(593819, 130, '2014-03-15 01:25:18.000000', 'consum', 0.0218, 'lps'),
	(593820, 130, '2014-03-15 01:25:19.000000', 'consum', 0.0210, 'lps'),
	(593821, 130, '2014-03-15 01:25:20.000000', 'consum', 0.0219, 'lps'),
	(593822, 130, '2014-03-15 01:25:21.000000', 'consum', 0.0224, 'lps'),
	(593823, 130, '2014-03-15 01:25:22.000000', 'consum', 0.0211, 'lps'),
	(593824, 130, '2014-03-15 01:25:23.000000', 'consum', 0.0216, 'lps'),
	(593825, 130, '2014-03-15 01:25:24.000000', 'consum', 0.0222, 'lps'),
	(593826, 130, '2014-03-15 01:25:25.000000', 'consum', 0.0223, 'lps'),
	(593827, 130, '2014-03-15 01:25:26.000000', 'consum', 0.0224, 'lps'),
	(593828, 130, '2014-03-15 01:25:27.000000', 'consum', 0.0210, 'lps'),
	(593829, 130, '2014-03-15 01:25:28.000000', 'consum', 0.0215, 'lps'),
	(593830, 130, '2014-03-15 01:25:29.000000', 'consum', 0.0219, 'lps'),
	(593831, 130, '2014-03-15 01:25:30.000000', 'consum', 0.0212, 'lps'),
	(593832, 130, '2014-03-15 01:25:31.000000', 'consum', 0.0224, 'lps'),
	(593833, 130, '2014-03-15 01:25:32.000000', 'consum', 0.0214, 'lps'),
	(593834, 130, '2014-03-15 01:25:33.000000', 'consum', 0.0218, 'lps'),
	(593835, 130, '2014-03-15 01:25:34.000000', 'consum', 0.0222, 'lps'),
	(593836, 130, '2014-03-15 01:25:35.000000', 'consum', 0.0218, 'lps'),
	(593837, 130, '2014-03-15 01:25:36.000000', 'consum', 0.0216, 'lps'),
	(593838, 130, '2014-03-15 01:25:37.000000', 'consum', 0.0217, 'lps'),
	(593839, 130, '2014-03-15 01:25:38.000000', 'consum', 0.0213, 'lps'),
	(593840, 130, '2014-03-15 01:25:39.000000', 'consum', 0.0217, 'lps'),
	(593841, 130, '2014-03-15 01:25:40.000000', 'consum', 0.0222, 'lps'),
	(593842, 130, '2014-03-15 01:25:41.000000', 'consum', 0.0219, 'lps'),
	(593843, 130, '2014-03-15 01:25:42.000000', 'consum', 0.0219, 'lps'),
	(593844, 130, '2014-03-15 01:25:43.000000', 'consum', 0.0213, 'lps'),
	(593845, 130, '2014-03-15 01:25:44.000000', 'consum', 0.0212, 'lps'),
	(593846, 130, '2014-03-15 01:25:45.000000', 'consum', 0.0214, 'lps'),
	(593847, 130, '2014-03-15 01:25:46.000000', 'consum', 0.0210, 'lps'),
	(593848, 130, '2014-03-15 01:25:47.000000', 'consum', 0.0213, 'lps'),
	(593849, 130, '2014-03-15 01:25:48.000000', 'consum', 0.0224, 'lps'),
	(593850, 130, '2014-03-15 01:25:49.000000', 'consum', 0.0211, 'lps'),
	(593851, 130, '2014-03-15 01:25:50.000000', 'consum', 0.0221, 'lps'),
	(593852, 130, '2014-03-15 01:25:51.000000', 'consum', 0.0216, 'lps'),
	(593853, 130, '2014-03-15 01:25:52.000000', 'consum', 0.0210, 'lps'),
	(593854, 130, '2014-03-15 01:25:53.000000', 'consum', 0.0220, 'lps'),
	(593855, 130, '2014-03-15 01:25:54.000000', 'consum', 0.0218, 'lps'),
	(593856, 130, '2014-03-15 01:25:55.000000', 'consum', 0.0218, 'lps'),
	(593857, 130, '2014-03-15 01:25:56.000000', 'consum', 0.0212, 'lps'),
	(593858, 130, '2014-03-15 01:25:57.000000', 'consum', 0.0213, 'lps'),
	(593859, 130, '2014-03-15 01:25:58.000000', 'consum', 0.0217, 'lps'),
	(593860, 130, '2014-03-15 01:25:59.000000', 'consum', 0.0210, 'lps'),
	(593861, 130, '2014-03-15 01:26:00.000000', 'consum', 0.0216, 'lps'),
	(593862, 130, '2014-03-15 01:26:01.000000', 'consum', 0.0214, 'lps'),
	(593863, 130, '2014-03-15 01:26:02.000000', 'consum', 0.0210, 'lps'),
	(593864, 130, '2014-03-15 01:26:03.000000', 'consum', 0.0216, 'lps'),
	(593865, 130, '2014-03-15 01:26:04.000000', 'consum', 0.0224, 'lps'),
	(593866, 130, '2014-03-15 01:26:05.000000', 'consum', 0.0216, 'lps'),
	(593867, 130, '2014-03-15 01:26:06.000000', 'consum', 0.0214, 'lps'),
	(593868, 130, '2014-03-15 01:26:07.000000', 'consum', 0.0215, 'lps'),
	(593869, 130, '2014-03-15 01:26:08.000000', 'consum', 0.0222, 'lps'),
	(593870, 130, '2014-03-15 01:26:09.000000', 'consum', 0.0210, 'lps'),
	(593871, 130, '2014-03-15 01:26:10.000000', 'consum', 0.0222, 'lps'),
	(593872, 130, '2014-03-15 01:26:11.000000', 'consum', 0.0224, 'lps'),
	(593873, 130, '2014-03-15 01:26:12.000000', 'consum', 0.0214, 'lps'),
	(593874, 130, '2014-03-15 01:26:13.000000', 'consum', 0.0219, 'lps'),
	(593875, 130, '2014-03-15 01:26:14.000000', 'consum', 0.0212, 'lps'),
	(593876, 130, '2014-03-15 01:26:15.000000', 'consum', 0.0222, 'lps'),
	(593877, 130, '2014-03-15 01:26:16.000000', 'consum', 0.0223, 'lps'),
	(593878, 130, '2014-03-15 01:26:17.000000', 'consum', 0.0224, 'lps'),
	(593879, 130, '2014-03-15 01:26:18.000000', 'consum', 0.0213, 'lps'),
	(593880, 130, '2014-03-15 01:26:19.000000', 'consum', 0.0212, 'lps'),
	(593881, 130, '2014-03-15 01:26:20.000000', 'consum', 0.0211, 'lps'),
	(593882, 130, '2014-03-15 01:26:21.000000', 'consum', 0.0210, 'lps'),
	(593883, 130, '2014-03-15 01:26:22.000000', 'consum', 0.0224, 'lps'),
	(593884, 130, '2014-03-15 01:26:23.000000', 'consum', 0.0221, 'lps'),
	(593885, 130, '2014-03-15 01:26:24.000000', 'consum', 0.0221, 'lps'),
	(593886, 130, '2014-03-15 01:26:25.000000', 'consum', 0.0219, 'lps'),
	(593887, 130, '2014-03-15 01:26:26.000000', 'consum', 0.0222, 'lps'),
	(593888, 130, '2014-03-15 01:26:27.000000', 'consum', 0.0211, 'lps'),
	(593889, 130, '2014-03-15 01:26:28.000000', 'consum', 0.0213, 'lps'),
	(593890, 130, '2014-03-15 01:26:29.000000', 'consum', 0.0223, 'lps'),
	(593891, 130, '2014-03-15 01:26:30.000000', 'consum', 0.0221, 'lps'),
	(593892, 130, '2014-03-15 01:26:31.000000', 'consum', 0.0212, 'lps'),
	(593893, 130, '2014-03-15 01:26:32.000000', 'consum', 0.0218, 'lps'),
	(593894, 130, '2014-03-15 01:26:33.000000', 'consum', 0.0214, 'lps'),
	(593895, 130, '2014-03-15 01:26:34.000000', 'consum', 0.0219, 'lps'),
	(593896, 130, '2014-03-15 01:26:35.000000', 'consum', 0.0216, 'lps'),
	(593897, 130, '2014-03-15 01:26:36.000000', 'consum', 0.0215, 'lps'),
	(593898, 130, '2014-03-15 01:26:37.000000', 'consum', 0.0216, 'lps'),
	(593899, 130, '2014-03-15 01:26:38.000000', 'consum', 0.0224, 'lps'),
	(593900, 130, '2014-03-15 01:26:39.000000', 'consum', 0.0219, 'lps'),
	(593901, 130, '2014-03-15 01:26:40.000000', 'consum', 0.0211, 'lps'),
	(593902, 130, '2014-03-15 01:26:41.000000', 'consum', 0.0220, 'lps'),
	(593903, 130, '2014-03-15 01:26:42.000000', 'consum', 0.0214, 'lps'),
	(593904, 130, '2014-03-15 01:26:43.000000', 'consum', 0.0212, 'lps'),
	(593905, 130, '2014-03-15 01:26:44.000000', 'consum', 0.0212, 'lps'),
	(593906, 130, '2014-03-15 01:26:45.000000', 'consum', 0.0212, 'lps'),
	(593907, 130, '2014-03-15 01:26:46.000000', 'consum', 0.0217, 'lps'),
	(593908, 130, '2014-03-15 01:26:47.000000', 'consum', 0.0210, 'lps'),
	(593909, 130, '2014-03-15 01:26:48.000000', 'consum', 0.0219, 'lps'),
	(593910, 130, '2014-03-15 01:26:49.000000', 'consum', 0.0223, 'lps'),
	(593911, 130, '2014-03-15 01:26:50.000000', 'consum', 0.0222, 'lps'),
	(593912, 130, '2014-03-15 01:26:51.000000', 'consum', 0.0215, 'lps'),
	(593913, 130, '2014-03-15 01:26:52.000000', 'consum', 0.0214, 'lps'),
	(593914, 130, '2014-03-15 01:26:53.000000', 'consum', 0.0218, 'lps'),
	(593915, 130, '2014-03-15 01:26:54.000000', 'consum', 0.0222, 'lps'),
	(593916, 130, '2014-03-15 01:26:55.000000', 'consum', 0.0215, 'lps'),
	(593917, 130, '2014-03-15 01:26:56.000000', 'consum', 0.0215, 'lps'),
	(593918, 130, '2014-03-15 01:26:57.000000', 'consum', 0.0220, 'lps'),
	(593919, 130, '2014-03-15 01:26:58.000000', 'consum', 0.0215, 'lps'),
	(593920, 130, '2014-03-15 01:26:59.000000', 'consum', 0.0222, 'lps'),
	(593921, 130, '2014-03-15 01:27:00.000000', 'consum', 0.0210, 'lps'),
	(593922, 130, '2014-03-15 01:27:01.000000', 'consum', 0.0220, 'lps'),
	(593923, 130, '2014-03-15 01:27:02.000000', 'consum', 0.0216, 'lps'),
	(593924, 130, '2014-03-15 01:27:03.000000', 'consum', 0.0212, 'lps'),
	(593925, 130, '2014-03-15 01:27:04.000000', 'consum', 0.0216, 'lps'),
	(593926, 130, '2014-03-15 01:27:05.000000', 'consum', 0.0218, 'lps'),
	(593927, 130, '2014-03-15 01:27:06.000000', 'consum', 0.0218, 'lps'),
	(593928, 130, '2014-03-15 01:27:07.000000', 'consum', 0.0210, 'lps'),
	(593929, 130, '2014-03-15 01:27:08.000000', 'consum', 0.0218, 'lps'),
	(593930, 130, '2014-03-15 01:27:09.000000', 'consum', 0.0221, 'lps'),
	(593931, 130, '2014-03-15 01:27:10.000000', 'consum', 0.0211, 'lps'),
	(593932, 130, '2014-03-15 01:27:11.000000', 'consum', 0.0213, 'lps'),
	(593933, 130, '2014-03-15 01:27:12.000000', 'consum', 0.0223, 'lps'),
	(593934, 130, '2014-03-15 01:27:13.000000', 'consum', 0.0222, 'lps'),
	(593935, 130, '2014-03-15 01:27:14.000000', 'consum', 0.0214, 'lps'),
	(593936, 130, '2014-03-15 01:27:15.000000', 'consum', 0.0212, 'lps'),
	(593937, 130, '2014-03-15 01:27:16.000000', 'consum', 0.0221, 'lps'),
	(593938, 130, '2014-03-15 01:27:17.000000', 'consum', 0.0213, 'lps'),
	(593939, 130, '2014-03-15 01:27:18.000000', 'consum', 0.0211, 'lps'),
	(593940, 130, '2014-03-15 01:27:19.000000', 'consum', 0.0222, 'lps'),
	(593941, 130, '2014-03-15 01:27:20.000000', 'consum', 0.0223, 'lps'),
	(593942, 130, '2014-03-15 01:27:21.000000', 'consum', 0.0222, 'lps'),
	(593943, 130, '2014-03-15 01:27:22.000000', 'consum', 0.0218, 'lps'),
	(593944, 130, '2014-03-15 01:27:23.000000', 'consum', 0.0214, 'lps'),
	(593945, 130, '2014-03-15 01:27:24.000000', 'consum', 0.0221, 'lps'),
	(593946, 130, '2014-03-15 01:27:25.000000', 'consum', 0.0211, 'lps'),
	(593947, 130, '2014-03-15 01:27:26.000000', 'consum', 0.0224, 'lps'),
	(593948, 130, '2014-03-15 01:27:27.000000', 'consum', 0.0221, 'lps'),
	(593949, 130, '2014-03-15 01:27:28.000000', 'consum', 0.0221, 'lps'),
	(593950, 130, '2014-03-15 01:27:29.000000', 'consum', 0.0220, 'lps'),
	(593951, 130, '2014-03-15 01:27:30.000000', 'consum', 0.0213, 'lps'),
	(593952, 130, '2014-03-15 01:27:31.000000', 'consum', 0.0222, 'lps'),
	(593953, 130, '2014-03-15 01:27:32.000000', 'consum', 0.0219, 'lps'),
	(593954, 130, '2014-03-15 01:27:33.000000', 'consum', 0.0219, 'lps'),
	(593955, 130, '2014-03-15 01:27:34.000000', 'consum', 0.0212, 'lps'),
	(593956, 130, '2014-03-15 01:27:35.000000', 'consum', 0.0210, 'lps'),
	(593957, 130, '2014-03-15 01:27:36.000000', 'consum', 0.0219, 'lps'),
	(593958, 130, '2014-03-15 01:27:37.000000', 'consum', 0.0212, 'lps'),
	(593959, 130, '2014-03-15 01:27:38.000000', 'consum', 0.0224, 'lps'),
	(593960, 130, '2014-03-15 01:27:39.000000', 'consum', 0.0215, 'lps'),
	(593961, 130, '2014-03-15 01:27:40.000000', 'consum', 0.0224, 'lps'),
	(593962, 130, '2014-03-15 01:27:41.000000', 'consum', 0.0217, 'lps'),
	(593963, 130, '2014-03-15 01:27:42.000000', 'consum', 0.0222, 'lps'),
	(593964, 130, '2014-03-15 01:27:43.000000', 'consum', 0.0218, 'lps'),
	(593965, 130, '2014-03-15 01:27:44.000000', 'consum', 0.0216, 'lps'),
	(593966, 130, '2014-03-15 01:27:45.000000', 'consum', 0.0218, 'lps'),
	(593967, 130, '2014-03-15 01:27:46.000000', 'consum', 0.0214, 'lps'),
	(593968, 130, '2014-03-15 01:27:47.000000', 'consum', 0.0223, 'lps'),
	(593969, 130, '2014-03-15 01:27:48.000000', 'consum', 0.0218, 'lps'),
	(593970, 130, '2014-03-15 01:27:49.000000', 'consum', 0.0210, 'lps'),
	(593971, 130, '2014-03-15 01:27:50.000000', 'consum', 0.0216, 'lps'),
	(593972, 130, '2014-03-15 01:27:51.000000', 'consum', 0.0213, 'lps'),
	(593973, 130, '2014-03-15 01:27:52.000000', 'consum', 0.0223, 'lps'),
	(593974, 130, '2014-03-15 01:27:53.000000', 'consum', 0.0219, 'lps'),
	(593975, 130, '2014-03-15 01:27:54.000000', 'consum', 0.0218, 'lps'),
	(593976, 130, '2014-03-15 01:27:55.000000', 'consum', 0.0210, 'lps'),
	(593977, 130, '2014-03-15 01:27:56.000000', 'consum', 0.0214, 'lps'),
	(593978, 130, '2014-03-15 01:27:57.000000', 'consum', 0.0215, 'lps'),
	(593979, 130, '2014-03-15 01:27:58.000000', 'consum', 0.0211, 'lps'),
	(593980, 130, '2014-03-15 01:27:59.000000', 'consum', 0.0213, 'lps'),
	(593981, 130, '2014-03-15 01:28:00.000000', 'consum', 0.0224, 'lps'),
	(593982, 130, '2014-03-15 01:28:01.000000', 'consum', 0.0212, 'lps'),
	(593983, 130, '2014-03-15 01:28:02.000000', 'consum', 0.0221, 'lps'),
	(593984, 130, '2014-03-15 01:28:03.000000', 'consum', 0.0217, 'lps'),
	(593985, 130, '2014-03-15 01:28:04.000000', 'consum', 0.0210, 'lps'),
	(593986, 130, '2014-03-15 01:28:05.000000', 'consum', 0.0221, 'lps'),
	(593987, 130, '2014-03-15 01:28:06.000000', 'consum', 0.0220, 'lps'),
	(593988, 130, '2014-03-15 01:28:07.000000', 'consum', 0.0214, 'lps'),
	(593989, 130, '2014-03-15 01:28:08.000000', 'consum', 0.0216, 'lps'),
	(593990, 130, '2014-03-15 01:28:09.000000', 'consum', 0.0214, 'lps'),
	(593991, 130, '2014-03-15 01:28:10.000000', 'consum', 0.0212, 'lps'),
	(593992, 130, '2014-03-15 01:28:11.000000', 'consum', 0.0222, 'lps'),
	(593993, 130, '2014-03-15 01:28:12.000000', 'consum', 0.0219, 'lps'),
	(593994, 130, '2014-03-15 01:28:13.000000', 'consum', 0.0221, 'lps'),
	(593995, 130, '2014-03-15 01:28:14.000000', 'consum', 0.0223, 'lps'),
	(593996, 130, '2014-03-15 01:28:15.000000', 'consum', 0.0213, 'lps'),
	(593997, 130, '2014-03-15 01:28:16.000000', 'consum', 0.0218, 'lps'),
	(593998, 130, '2014-03-15 01:28:17.000000', 'consum', 0.0212, 'lps'),
	(593999, 130, '2014-03-15 01:28:18.000000', 'consum', 0.0223, 'lps'),
	(594000, 130, '2014-03-15 01:28:19.000000', 'consum', 0.0213, 'lps'),
	(594001, 130, '2014-03-15 01:28:20.000000', 'consum', 0.0214, 'lps'),
	(594002, 130, '2014-03-15 01:28:21.000000', 'consum', 0.0222, 'lps'),
	(594003, 130, '2014-03-15 01:28:22.000000', 'consum', 0.0214, 'lps'),
	(594004, 130, '2014-03-15 01:28:23.000000', 'consum', 0.0211, 'lps'),
	(594005, 130, '2014-03-15 01:28:24.000000', 'consum', 0.0219, 'lps'),
	(594006, 130, '2014-03-15 01:28:25.000000', 'consum', 0.0221, 'lps'),
	(594007, 130, '2014-03-15 01:28:26.000000', 'consum', 0.0222, 'lps'),
	(594008, 130, '2014-03-15 01:28:27.000000', 'consum', 0.0222, 'lps'),
	(594009, 130, '2014-03-15 01:28:28.000000', 'consum', 0.0221, 'lps'),
	(594010, 130, '2014-03-15 01:28:29.000000', 'consum', 0.0214, 'lps'),
	(594011, 130, '2014-03-15 01:28:30.000000', 'consum', 0.0212, 'lps'),
	(594012, 130, '2014-03-15 01:28:31.000000', 'consum', 0.0210, 'lps'),
	(594013, 130, '2014-03-15 01:28:32.000000', 'consum', 0.0219, 'lps'),
	(594014, 130, '2014-03-15 01:28:33.000000', 'consum', 0.0224, 'lps'),
	(594015, 130, '2014-03-15 01:28:34.000000', 'consum', 0.0210, 'lps'),
	(594016, 130, '2014-03-15 01:28:35.000000', 'consum', 0.0212, 'lps'),
	(594017, 130, '2014-03-15 01:28:36.000000', 'consum', 0.0220, 'lps'),
	(594018, 130, '2014-03-15 01:28:37.000000', 'consum', 0.0211, 'lps'),
	(594019, 130, '2014-03-15 01:28:38.000000', 'consum', 0.0216, 'lps'),
	(594020, 130, '2014-03-15 01:28:39.000000', 'consum', 0.0222, 'lps'),
	(594021, 130, '2014-03-15 01:28:40.000000', 'consum', 0.0223, 'lps'),
	(594022, 130, '2014-03-15 01:28:41.000000', 'consum', 0.0210, 'lps'),
	(594023, 130, '2014-03-15 01:28:42.000000', 'consum', 0.0215, 'lps'),
	(594024, 130, '2014-03-15 01:28:43.000000', 'consum', 0.0221, 'lps'),
	(594025, 130, '2014-03-15 01:28:44.000000', 'consum', 0.0218, 'lps'),
	(594026, 130, '2014-03-15 01:28:45.000000', 'consum', 0.0221, 'lps'),
	(594027, 130, '2014-03-15 01:28:46.000000', 'consum', 0.0211, 'lps'),
	(594028, 130, '2014-03-15 01:28:47.000000', 'consum', 0.0211, 'lps'),
	(594029, 130, '2014-03-15 01:28:48.000000', 'consum', 0.0214, 'lps'),
	(594030, 130, '2014-03-15 01:28:49.000000', 'consum', 0.0213, 'lps'),
	(594031, 130, '2014-03-15 01:28:50.000000', 'consum', 0.0212, 'lps'),
	(594032, 130, '2014-03-15 01:28:51.000000', 'consum', 0.0213, 'lps'),
	(594033, 130, '2014-03-15 01:28:52.000000', 'consum', 0.0217, 'lps'),
	(594034, 130, '2014-03-15 01:28:53.000000', 'consum', 0.0223, 'lps'),
	(594035, 130, '2014-03-15 01:28:54.000000', 'consum', 0.0211, 'lps'),
	(594036, 130, '2014-03-15 01:28:55.000000', 'consum', 0.0221, 'lps'),
	(594037, 130, '2014-03-15 01:28:56.000000', 'consum', 0.0217, 'lps'),
	(594038, 130, '2014-03-15 01:28:57.000000', 'consum', 0.0214, 'lps'),
	(594039, 130, '2014-03-15 01:28:58.000000', 'consum', 0.0210, 'lps'),
	(594040, 130, '2014-03-15 01:28:59.000000', 'consum', 0.0210, 'lps'),
	(594041, 130, '2014-03-15 01:29:00.000000', 'consum', 0.0214, 'lps'),
	(594042, 130, '2014-03-15 01:29:01.000000', 'consum', 0.0213, 'lps'),
	(594043, 130, '2014-03-15 01:29:02.000000', 'consum', 0.0216, 'lps'),
	(594044, 130, '2014-03-15 01:29:03.000000', 'consum', 0.0217, 'lps'),
	(594045, 130, '2014-03-15 01:29:04.000000', 'consum', 0.0213, 'lps'),
	(594046, 130, '2014-03-15 01:29:05.000000', 'consum', 0.0220, 'lps'),
	(594047, 130, '2014-03-15 01:29:06.000000', 'consum', 0.0222, 'lps'),
	(594048, 130, '2014-03-15 01:29:07.000000', 'consum', 0.0211, 'lps'),
	(594049, 130, '2014-03-15 01:29:08.000000', 'consum', 0.0210, 'lps'),
	(594050, 130, '2014-03-15 01:29:09.000000', 'consum', 0.0223, 'lps'),
	(594051, 130, '2014-03-15 01:29:10.000000', 'consum', 0.0214, 'lps'),
	(594052, 130, '2014-03-15 01:29:11.000000', 'consum', 0.0222, 'lps'),
	(594053, 130, '2014-03-15 01:29:12.000000', 'consum', 0.0213, 'lps'),
	(594054, 130, '2014-03-15 01:29:13.000000', 'consum', 0.0219, 'lps'),
	(594055, 130, '2014-03-15 01:29:14.000000', 'consum', 0.0218, 'lps'),
	(594056, 130, '2014-03-15 01:29:15.000000', 'consum', 0.0210, 'lps'),
	(594057, 130, '2014-03-15 01:29:16.000000', 'consum', 0.0214, 'lps'),
	(594058, 130, '2014-03-15 01:29:17.000000', 'consum', 0.0214, 'lps'),
	(594059, 130, '2014-03-15 01:29:18.000000', 'consum', 0.0221, 'lps'),
	(594060, 130, '2014-03-15 01:29:19.000000', 'consum', 0.0222, 'lps'),
	(594061, 130, '2014-03-15 01:29:20.000000', 'consum', 0.0210, 'lps'),
	(594062, 130, '2014-03-15 01:29:21.000000', 'consum', 0.0218, 'lps'),
	(594063, 130, '2014-03-15 01:29:22.000000', 'consum', 0.0220, 'lps'),
	(594064, 130, '2014-03-15 01:29:23.000000', 'consum', 0.0222, 'lps'),
	(594065, 130, '2014-03-15 01:29:24.000000', 'consum', 0.0224, 'lps'),
	(594066, 130, '2014-03-15 01:29:25.000000', 'consum', 0.0217, 'lps'),
	(594067, 130, '2014-03-15 01:29:26.000000', 'consum', 0.0217, 'lps'),
	(594068, 130, '2014-03-15 01:29:27.000000', 'consum', 0.0224, 'lps'),
	(594069, 130, '2014-03-15 01:29:28.000000', 'consum', 0.0213, 'lps'),
	(594070, 130, '2014-03-15 01:29:29.000000', 'consum', 0.0215, 'lps'),
	(594071, 130, '2014-03-15 01:29:30.000000', 'consum', 0.0212, 'lps'),
	(594072, 130, '2014-03-15 01:29:31.000000', 'consum', 0.0220, 'lps'),
	(594073, 130, '2014-03-15 01:29:32.000000', 'consum', 0.0224, 'lps'),
	(594074, 130, '2014-03-15 01:29:33.000000', 'consum', 0.0219, 'lps'),
	(594075, 130, '2014-03-15 01:29:34.000000', 'consum', 0.0217, 'lps'),
	(594076, 130, '2014-03-15 01:29:35.000000', 'consum', 0.0215, 'lps'),
	(594077, 130, '2014-03-15 01:29:36.000000', 'consum', 0.0215, 'lps'),
	(594078, 130, '2014-03-15 01:29:37.000000', 'consum', 0.0223, 'lps'),
	(594079, 130, '2014-03-15 01:29:38.000000', 'consum', 0.0212, 'lps'),
	(594080, 130, '2014-03-15 01:29:39.000000', 'consum', 0.0213, 'lps'),
	(594081, 130, '2014-03-15 01:29:40.000000', 'consum', 0.0221, 'lps'),
	(594082, 130, '2014-03-15 01:29:41.000000', 'consum', 0.0211, 'lps'),
	(594083, 130, '2014-03-15 01:29:42.000000', 'consum', 0.0210, 'lps'),
	(594084, 130, '2014-03-15 01:29:43.000000', 'consum', 0.0210, 'lps'),
	(594085, 130, '2014-03-15 01:29:44.000000', 'consum', 0.0210, 'lps'),
	(594086, 130, '2014-03-15 01:29:45.000000', 'consum', 0.0210, 'lps'),
	(594087, 130, '2014-03-15 01:29:46.000000', 'consum', 0.0212, 'lps'),
	(594088, 130, '2014-03-15 01:29:47.000000', 'consum', 0.0218, 'lps'),
	(594089, 130, '2014-03-15 01:29:48.000000', 'consum', 0.0217, 'lps'),
	(594090, 130, '2014-03-15 01:29:49.000000', 'consum', 0.0221, 'lps'),
	(594091, 130, '2014-03-15 01:29:50.000000', 'consum', 0.0213, 'lps'),
	(594092, 130, '2014-03-15 01:29:51.000000', 'consum', 0.0223, 'lps'),
	(594093, 130, '2014-03-15 01:29:52.000000', 'consum', 0.0221, 'lps'),
	(594094, 130, '2014-03-15 01:29:53.000000', 'consum', 0.0212, 'lps'),
	(594095, 130, '2014-03-15 01:29:54.000000', 'consum', 0.0219, 'lps'),
	(594096, 130, '2014-03-15 01:29:55.000000', 'consum', 0.0218, 'lps'),
	(594097, 130, '2014-03-15 01:29:56.000000', 'consum', 0.0211, 'lps'),
	(594098, 130, '2014-03-15 01:29:57.000000', 'consum', 0.0219, 'lps'),
	(594099, 130, '2014-03-15 01:29:58.000000', 'consum', 0.0222, 'lps'),
	(594100, 130, '2014-03-15 01:29:59.000000', 'consum', 0.0216, 'lps'),
	(594101, 130, '2014-03-15 01:30:00.000000', 'consum', 0.0220, 'lps'),
	(594102, 130, '2014-03-15 01:30:01.000000', 'consum', 0.0212, 'lps'),
	(594103, 130, '2014-03-15 01:30:02.000000', 'consum', 0.0220, 'lps'),
	(594104, 130, '2014-03-15 01:30:03.000000', 'consum', 0.0224, 'lps'),
	(594105, 130, '2014-03-15 01:30:04.000000', 'consum', 0.0221, 'lps'),
	(594106, 130, '2014-03-15 01:30:05.000000', 'consum', 0.0210, 'lps'),
	(594107, 130, '2014-03-15 01:30:06.000000', 'consum', 0.0220, 'lps'),
	(594108, 130, '2014-03-15 01:30:07.000000', 'consum', 0.0215, 'lps'),
	(594109, 130, '2014-03-15 01:30:08.000000', 'consum', 0.0221, 'lps'),
	(594110, 130, '2014-03-15 01:30:09.000000', 'consum', 0.0220, 'lps'),
	(594111, 130, '2014-03-15 01:30:10.000000', 'consum', 0.0212, 'lps'),
	(594112, 130, '2014-03-15 01:30:11.000000', 'consum', 0.0221, 'lps'),
	(594113, 130, '2014-03-15 01:30:12.000000', 'consum', 0.0214, 'lps'),
	(594114, 130, '2014-03-15 01:30:13.000000', 'consum', 0.0211, 'lps'),
	(594115, 130, '2014-03-15 01:30:14.000000', 'consum', 0.0221, 'lps'),
	(594116, 130, '2014-03-15 01:30:15.000000', 'consum', 0.0215, 'lps'),
	(594117, 130, '2014-03-15 01:30:16.000000', 'consum', 0.0220, 'lps'),
	(594118, 130, '2014-03-15 01:30:17.000000', 'consum', 0.0216, 'lps'),
	(594119, 130, '2014-03-15 01:30:18.000000', 'consum', 0.0210, 'lps'),
	(594120, 130, '2014-03-15 01:30:19.000000', 'consum', 0.0224, 'lps'),
	(594121, 130, '2014-03-15 01:30:20.000000', 'consum', 0.0217, 'lps'),
	(594122, 130, '2014-03-15 01:30:21.000000', 'consum', 0.0222, 'lps'),
	(594123, 130, '2014-03-15 01:30:22.000000', 'consum', 0.0217, 'lps'),
	(594124, 130, '2014-03-15 01:30:23.000000', 'consum', 0.0212, 'lps'),
	(594125, 130, '2014-03-15 01:30:24.000000', 'consum', 0.0212, 'lps'),
	(594126, 130, '2014-03-15 01:30:25.000000', 'consum', 0.0217, 'lps'),
	(594127, 130, '2014-03-15 01:30:26.000000', 'consum', 0.0224, 'lps'),
	(594128, 130, '2014-03-15 01:30:27.000000', 'consum', 0.0213, 'lps'),
	(594129, 130, '2014-03-15 01:30:28.000000', 'consum', 0.0216, 'lps'),
	(594130, 130, '2014-03-15 01:30:29.000000', 'consum', 0.0213, 'lps'),
	(594131, 130, '2014-03-15 01:30:30.000000', 'consum', 0.0210, 'lps'),
	(594132, 130, '2014-03-15 01:30:31.000000', 'consum', 0.0218, 'lps'),
	(594133, 130, '2014-03-15 01:30:32.000000', 'consum', 0.0218, 'lps'),
	(594134, 130, '2014-03-15 01:30:33.000000', 'consum', 0.0213, 'lps'),
	(594135, 130, '2014-03-15 01:30:34.000000', 'consum', 0.0214, 'lps'),
	(594136, 130, '2014-03-15 01:30:35.000000', 'consum', 0.0222, 'lps'),
	(594137, 130, '2014-03-15 01:30:36.000000', 'consum', 0.0215, 'lps'),
	(594138, 130, '2014-03-15 01:30:37.000000', 'consum', 0.0214, 'lps'),
	(594139, 130, '2014-03-15 01:30:38.000000', 'consum', 0.0215, 'lps'),
	(594140, 130, '2014-03-15 01:30:39.000000', 'consum', 0.0224, 'lps'),
	(594141, 130, '2014-03-15 01:30:40.000000', 'consum', 0.0220, 'lps'),
	(594142, 130, '2014-03-15 01:30:41.000000', 'consum', 0.0217, 'lps'),
	(594143, 130, '2014-03-15 01:30:42.000000', 'consum', 0.0218, 'lps'),
	(594144, 130, '2014-03-15 01:30:43.000000', 'consum', 0.0214, 'lps'),
	(594145, 131, '2014-03-15 00:00:00.000000', 'consum', 0.0216, 'lps'),
	(594146, 131, '2014-03-15 00:00:01.000000', 'consum', 0.0219, 'lps'),
	(594147, 131, '2014-03-15 00:00:02.000000', 'consum', 0.0212, 'lps'),
	(594148, 131, '2014-03-15 00:00:03.000000', 'consum', 0.0219, 'lps'),
	(594149, 131, '2014-03-15 00:00:04.000000', 'consum', 0.0224, 'lps'),
	(594150, 131, '2014-03-15 00:00:05.000000', 'consum', 0.0226, 'lps'),
	(594151, 131, '2014-03-15 00:00:06.000000', 'consum', 0.0220, 'lps'),
	(594152, 131, '2014-03-15 00:00:07.000000', 'consum', 0.0214, 'lps'),
	(594153, 131, '2014-03-15 00:00:08.000000', 'consum', 0.0226, 'lps'),
	(594154, 131, '2014-03-15 00:00:09.000000', 'consum', 0.0222, 'lps'),
	(594155, 131, '2014-03-15 00:00:10.000000', 'consum', 0.0223, 'lps'),
	(594156, 131, '2014-03-15 00:00:11.000000', 'consum', 0.0214, 'lps'),
	(594157, 131, '2014-03-15 00:00:12.000000', 'consum', 0.0216, 'lps'),
	(594158, 131, '2014-03-15 00:00:13.000000', 'consum', 0.0230, 'lps'),
	(594159, 131, '2014-03-15 00:00:14.000000', 'consum', 0.0210, 'lps'),
	(594160, 131, '2014-03-15 00:00:15.000000', 'consum', 0.0234, 'lps'),
	(594161, 131, '2014-03-15 00:00:16.000000', 'consum', 0.0219, 'lps'),
	(594162, 131, '2014-03-15 00:00:17.000000', 'consum', 0.0211, 'lps'),
	(594163, 131, '2014-03-15 00:00:18.000000', 'consum', 0.0215, 'lps'),
	(594164, 131, '2014-03-15 00:00:19.000000', 'consum', 0.0232, 'lps'),
	(594165, 131, '2014-03-15 00:00:20.000000', 'consum', 0.0224, 'lps'),
	(594166, 131, '2014-03-15 00:00:21.000000', 'consum', 0.0214, 'lps'),
	(594167, 131, '2014-03-15 00:00:22.000000', 'consum', 0.0217, 'lps'),
	(594168, 131, '2014-03-15 00:00:23.000000', 'consum', 0.0235, 'lps'),
	(594169, 131, '2014-03-15 00:00:24.000000', 'consum', 0.0228, 'lps'),
	(594170, 131, '2014-03-15 00:00:25.000000', 'consum', 0.0226, 'lps'),
	(594171, 131, '2014-03-15 00:00:26.000000', 'consum', 0.0210, 'lps'),
	(594172, 131, '2014-03-15 00:00:27.000000', 'consum', 0.0219, 'lps'),
	(594173, 131, '2014-03-15 00:00:28.000000', 'consum', 0.0228, 'lps'),
	(594174, 131, '2014-03-15 00:00:29.000000', 'consum', 0.0217, 'lps'),
	(594175, 131, '2014-03-15 00:00:30.000000', 'consum', 0.0218, 'lps'),
	(594176, 131, '2014-03-15 00:00:31.000000', 'consum', 0.0229, 'lps'),
	(594177, 131, '2014-03-15 00:00:32.000000', 'consum', 0.0226, 'lps'),
	(594178, 131, '2014-03-15 00:00:33.000000', 'consum', 0.0235, 'lps'),
	(594179, 131, '2014-03-15 00:00:34.000000', 'consum', 0.0230, 'lps'),
	(594180, 131, '2014-03-15 00:00:35.000000', 'consum', 0.0210, 'lps'),
	(594181, 131, '2014-03-15 00:00:36.000000', 'consum', 0.0233, 'lps'),
	(594182, 131, '2014-03-15 00:00:37.000000', 'consum', 0.0215, 'lps'),
	(594183, 131, '2014-03-15 00:00:38.000000', 'consum', 0.0223, 'lps'),
	(594184, 131, '2014-03-15 00:00:39.000000', 'consum', 0.0231, 'lps'),
	(594185, 131, '2014-03-15 00:00:40.000000', 'consum', 0.0222, 'lps'),
	(594186, 131, '2014-03-15 00:00:41.000000', 'consum', 0.0233, 'lps'),
	(594187, 131, '2014-03-15 00:00:42.000000', 'consum', 0.0235, 'lps'),
	(594188, 131, '2014-03-15 00:00:43.000000', 'consum', 0.0212, 'lps'),
	(594189, 131, '2014-03-15 00:00:44.000000', 'consum', 0.0227, 'lps'),
	(594190, 131, '2014-03-15 00:00:45.000000', 'consum', 0.0235, 'lps'),
	(594191, 131, '2014-03-15 00:00:46.000000', 'consum', 0.0229, 'lps'),
	(594192, 131, '2014-03-15 00:00:47.000000', 'consum', 0.0232, 'lps'),
	(594193, 131, '2014-03-15 00:00:48.000000', 'consum', 0.0232, 'lps'),
	(594194, 131, '2014-03-15 00:00:49.000000', 'consum', 0.0229, 'lps'),
	(594195, 131, '2014-03-15 00:00:50.000000', 'consum', 0.0211, 'lps'),
	(594196, 131, '2014-03-15 00:00:51.000000', 'consum', 0.0215, 'lps'),
	(594197, 131, '2014-03-15 00:00:52.000000', 'consum', 0.0233, 'lps'),
	(594198, 131, '2014-03-15 00:00:53.000000', 'consum', 0.0228, 'lps'),
	(594199, 131, '2014-03-15 00:00:54.000000', 'consum', 0.0230, 'lps'),
	(594200, 131, '2014-03-15 00:00:55.000000', 'consum', 0.0227, 'lps'),
	(594201, 131, '2014-03-15 00:00:56.000000', 'consum', 0.0210, 'lps'),
	(594202, 131, '2014-03-15 00:00:57.000000', 'consum', 0.0216, 'lps'),
	(594203, 131, '2014-03-15 00:00:58.000000', 'consum', 0.0210, 'lps'),
	(594204, 131, '2014-03-15 00:00:59.000000', 'consum', 0.0220, 'lps'),
	(594205, 131, '2014-03-15 00:01:00.000000', 'consum', 0.0235, 'lps'),
	(594206, 131, '2014-03-15 00:01:01.000000', 'consum', 0.0222, 'lps'),
	(594207, 131, '2014-03-15 00:01:02.000000', 'consum', 0.0224, 'lps'),
	(594208, 131, '2014-03-15 00:01:03.000000', 'consum', 0.0216, 'lps'),
	(594209, 131, '2014-03-15 00:01:04.000000', 'consum', 0.0224, 'lps'),
	(594210, 131, '2014-03-15 00:01:05.000000', 'consum', 0.0210, 'lps'),
	(594211, 131, '2014-03-15 00:01:06.000000', 'consum', 0.0223, 'lps'),
	(594212, 131, '2014-03-15 00:01:07.000000', 'consum', 0.0220, 'lps'),
	(594213, 131, '2014-03-15 00:01:08.000000', 'consum', 0.0219, 'lps'),
	(594214, 131, '2014-03-15 00:01:09.000000', 'consum', 0.0228, 'lps'),
	(594215, 131, '2014-03-15 00:01:10.000000', 'consum', 0.0216, 'lps'),
	(594216, 131, '2014-03-15 00:01:11.000000', 'consum', 0.0214, 'lps'),
	(594217, 131, '2014-03-15 00:01:12.000000', 'consum', 0.0211, 'lps'),
	(594218, 131, '2014-03-15 00:01:13.000000', 'consum', 0.0234, 'lps'),
	(594219, 131, '2014-03-15 00:01:14.000000', 'consum', 0.0217, 'lps'),
	(594220, 131, '2014-03-15 00:01:15.000000', 'consum', 0.0227, 'lps'),
	(594221, 131, '2014-03-15 00:01:16.000000', 'consum', 0.0218, 'lps'),
	(594222, 131, '2014-03-15 00:01:17.000000', 'consum', 0.0229, 'lps'),
	(594223, 131, '2014-03-15 00:01:18.000000', 'consum', 0.0224, 'lps'),
	(594224, 131, '2014-03-15 00:01:19.000000', 'consum', 0.0222, 'lps'),
	(594225, 131, '2014-03-15 00:01:20.000000', 'consum', 0.0231, 'lps'),
	(594226, 131, '2014-03-15 00:01:21.000000', 'consum', 0.0222, 'lps'),
	(594227, 131, '2014-03-15 00:01:22.000000', 'consum', 0.0236, 'lps'),
	(594228, 131, '2014-03-15 00:01:23.000000', 'consum', 0.0221, 'lps'),
	(594229, 131, '2014-03-15 00:01:24.000000', 'consum', 0.0216, 'lps'),
	(594230, 131, '2014-03-15 00:01:25.000000', 'consum', 0.0235, 'lps'),
	(594231, 131, '2014-03-15 00:01:26.000000', 'consum', 0.0235, 'lps'),
	(594232, 131, '2014-03-15 00:01:27.000000', 'consum', 0.0231, 'lps'),
	(594233, 131, '2014-03-15 00:01:28.000000', 'consum', 0.0215, 'lps'),
	(594234, 131, '2014-03-15 00:01:29.000000', 'consum', 0.0226, 'lps'),
	(594235, 131, '2014-03-15 00:01:30.000000', 'consum', 0.0219, 'lps'),
	(594236, 131, '2014-03-15 00:01:31.000000', 'consum', 0.0210, 'lps'),
	(594237, 131, '2014-03-15 00:01:32.000000', 'consum', 0.0211, 'lps'),
	(594238, 131, '2014-03-15 00:01:33.000000', 'consum', 0.0213, 'lps'),
	(594239, 131, '2014-03-15 00:01:34.000000', 'consum', 0.0226, 'lps'),
	(594240, 131, '2014-03-15 00:01:35.000000', 'consum', 0.0224, 'lps'),
	(594241, 131, '2014-03-15 00:01:36.000000', 'consum', 0.0231, 'lps'),
	(594242, 131, '2014-03-15 00:01:37.000000', 'consum', 0.0220, 'lps'),
	(594243, 131, '2014-03-15 00:01:38.000000', 'consum', 0.0224, 'lps'),
	(594244, 131, '2014-03-15 00:01:39.000000', 'consum', 0.0224, 'lps'),
	(594245, 131, '2014-03-15 00:01:40.000000', 'consum', 0.0210, 'lps'),
	(594246, 131, '2014-03-15 00:01:41.000000', 'consum', 0.0224, 'lps'),
	(594247, 131, '2014-03-15 00:01:42.000000', 'consum', 0.0226, 'lps'),
	(594248, 131, '2014-03-15 00:01:43.000000', 'consum', 0.0221, 'lps'),
	(594249, 131, '2014-03-15 00:01:44.000000', 'consum', 0.0217, 'lps'),
	(594250, 131, '2014-03-15 00:01:45.000000', 'consum', 0.0213, 'lps'),
	(594251, 131, '2014-03-15 00:01:46.000000', 'consum', 0.0233, 'lps'),
	(594252, 131, '2014-03-15 00:01:47.000000', 'consum', 0.0230, 'lps'),
	(594253, 131, '2014-03-15 00:01:48.000000', 'consum', 0.0216, 'lps'),
	(594254, 131, '2014-03-15 00:01:49.000000', 'consum', 0.0210, 'lps'),
	(594255, 131, '2014-03-15 00:01:50.000000', 'consum', 0.0217, 'lps'),
	(594256, 131, '2014-03-15 00:01:51.000000', 'consum', 0.0219, 'lps'),
	(594257, 131, '2014-03-15 00:01:52.000000', 'consum', 0.0235, 'lps'),
	(594258, 131, '2014-03-15 00:01:53.000000', 'consum', 0.0224, 'lps'),
	(594259, 131, '2014-03-15 00:01:54.000000', 'consum', 0.0235, 'lps'),
	(594260, 131, '2014-03-15 00:01:55.000000', 'consum', 0.0210, 'lps'),
	(594261, 131, '2014-03-15 00:01:56.000000', 'consum', 0.0219, 'lps'),
	(594262, 131, '2014-03-15 00:01:57.000000', 'consum', 0.0227, 'lps'),
	(594263, 131, '2014-03-15 00:01:58.000000', 'consum', 0.0214, 'lps'),
	(594264, 131, '2014-03-15 00:01:59.000000', 'consum', 0.0233, 'lps'),
	(594265, 131, '2014-03-15 00:02:00.000000', 'consum', 0.0231, 'lps'),
	(594266, 131, '2014-03-15 00:02:01.000000', 'consum', 0.0217, 'lps'),
	(594267, 131, '2014-03-15 00:02:02.000000', 'consum', 0.0211, 'lps'),
	(594268, 131, '2014-03-15 00:02:03.000000', 'consum', 0.0221, 'lps'),
	(594269, 131, '2014-03-15 00:02:04.000000', 'consum', 0.0237, 'lps'),
	(594270, 131, '2014-03-15 00:02:05.000000', 'consum', 0.0229, 'lps'),
	(594271, 131, '2014-03-15 00:02:06.000000', 'consum', 0.0224, 'lps'),
	(594272, 131, '2014-03-15 00:02:07.000000', 'consum', 0.0221, 'lps'),
	(594273, 131, '2014-03-15 00:02:08.000000', 'consum', 0.0225, 'lps'),
	(594274, 131, '2014-03-15 00:02:09.000000', 'consum', 0.0226, 'lps'),
	(594275, 131, '2014-03-15 00:02:10.000000', 'consum', 0.0215, 'lps'),
	(594276, 131, '2014-03-15 00:02:11.000000', 'consum', 0.0215, 'lps'),
	(594277, 131, '2014-03-15 00:02:12.000000', 'consum', 0.0221, 'lps'),
	(594278, 131, '2014-03-15 00:02:13.000000', 'consum', 0.0223, 'lps'),
	(594279, 131, '2014-03-15 00:02:14.000000', 'consum', 0.0216, 'lps'),
	(594280, 131, '2014-03-15 00:02:15.000000', 'consum', 0.0229, 'lps'),
	(594281, 131, '2014-03-15 00:02:16.000000', 'consum', 0.0232, 'lps'),
	(594282, 131, '2014-03-15 00:02:17.000000', 'consum', 0.0234, 'lps'),
	(594283, 131, '2014-03-15 00:02:18.000000', 'consum', 0.0210, 'lps'),
	(594284, 131, '2014-03-15 00:02:19.000000', 'consum', 0.0220, 'lps'),
	(594285, 131, '2014-03-15 00:02:20.000000', 'consum', 0.0234, 'lps'),
	(594286, 131, '2014-03-15 00:02:21.000000', 'consum', 0.0216, 'lps'),
	(594287, 131, '2014-03-15 00:02:22.000000', 'consum', 0.0225, 'lps'),
	(594288, 131, '2014-03-15 00:02:23.000000', 'consum', 0.0213, 'lps'),
	(594289, 131, '2014-03-15 00:02:24.000000', 'consum', 0.0235, 'lps'),
	(594290, 131, '2014-03-15 00:02:25.000000', 'consum', 0.0213, 'lps'),
	(594291, 131, '2014-03-15 00:02:26.000000', 'consum', 0.0237, 'lps'),
	(594292, 131, '2014-03-15 00:02:27.000000', 'consum', 0.0222, 'lps'),
	(594293, 131, '2014-03-15 00:02:28.000000', 'consum', 0.0218, 'lps'),
	(594294, 131, '2014-03-15 00:02:29.000000', 'consum', 0.0217, 'lps'),
	(594295, 131, '2014-03-15 00:02:30.000000', 'consum', 0.0219, 'lps'),
	(594296, 131, '2014-03-15 00:02:31.000000', 'consum', 0.0236, 'lps'),
	(594297, 131, '2014-03-15 00:02:32.000000', 'consum', 0.0228, 'lps'),
	(594298, 131, '2014-03-15 00:02:33.000000', 'consum', 0.0222, 'lps'),
	(594299, 131, '2014-03-15 00:02:34.000000', 'consum', 0.0216, 'lps'),
	(594300, 131, '2014-03-15 00:02:35.000000', 'consum', 0.0232, 'lps'),
	(594301, 131, '2014-03-15 00:02:36.000000', 'consum', 0.0221, 'lps'),
	(594302, 131, '2014-03-15 00:02:37.000000', 'consum', 0.0225, 'lps'),
	(594303, 131, '2014-03-15 00:02:38.000000', 'consum', 0.0224, 'lps'),
	(594304, 131, '2014-03-15 00:02:39.000000', 'consum', 0.0210, 'lps'),
	(594305, 131, '2014-03-15 00:02:40.000000', 'consum', 0.0225, 'lps'),
	(594306, 131, '2014-03-15 00:02:41.000000', 'consum', 0.0230, 'lps'),
	(594307, 131, '2014-03-15 00:02:42.000000', 'consum', 0.0236, 'lps'),
	(594308, 131, '2014-03-15 00:02:43.000000', 'consum', 0.0224, 'lps'),
	(594309, 131, '2014-03-15 00:02:44.000000', 'consum', 0.0231, 'lps'),
	(594310, 131, '2014-03-15 00:02:45.000000', 'consum', 0.0218, 'lps'),
	(594311, 131, '2014-03-15 00:02:46.000000', 'consum', 0.0214, 'lps'),
	(594312, 131, '2014-03-15 00:02:47.000000', 'consum', 0.0234, 'lps'),
	(594313, 131, '2014-03-15 00:02:48.000000', 'consum', 0.0234, 'lps'),
	(594314, 131, '2014-03-15 00:02:49.000000', 'consum', 0.0230, 'lps'),
	(594315, 131, '2014-03-15 00:02:50.000000', 'consum', 0.0213, 'lps'),
	(594316, 131, '2014-03-15 00:02:51.000000', 'consum', 0.0221, 'lps'),
	(594317, 131, '2014-03-15 00:02:52.000000', 'consum', 0.0227, 'lps'),
	(594318, 131, '2014-03-15 00:02:53.000000', 'consum', 0.0234, 'lps'),
	(594319, 131, '2014-03-15 00:02:54.000000', 'consum', 0.0224, 'lps'),
	(594320, 131, '2014-03-15 00:02:55.000000', 'consum', 0.0236, 'lps'),
	(594321, 131, '2014-03-15 00:02:56.000000', 'consum', 0.0217, 'lps'),
	(594322, 131, '2014-03-15 00:02:57.000000', 'consum', 0.0221, 'lps'),
	(594323, 131, '2014-03-15 00:02:58.000000', 'consum', 0.0217, 'lps'),
	(594324, 131, '2014-03-15 00:02:59.000000', 'consum', 0.0212, 'lps'),
	(594325, 131, '2014-03-15 00:03:00.000000', 'consum', 0.0229, 'lps'),
	(594326, 131, '2014-03-15 00:03:01.000000', 'consum', 0.0213, 'lps'),
	(594327, 131, '2014-03-15 00:03:02.000000', 'consum', 0.0227, 'lps'),
	(594328, 131, '2014-03-15 00:03:03.000000', 'consum', 0.0229, 'lps'),
	(594329, 131, '2014-03-15 00:03:04.000000', 'consum', 0.0229, 'lps'),
	(594330, 131, '2014-03-15 00:03:05.000000', 'consum', 0.0219, 'lps'),
	(594331, 131, '2014-03-15 00:03:06.000000', 'consum', 0.0225, 'lps'),
	(594332, 131, '2014-03-15 00:03:07.000000', 'consum', 0.0233, 'lps'),
	(594333, 131, '2014-03-15 00:03:08.000000', 'consum', 0.0222, 'lps'),
	(594334, 131, '2014-03-15 00:03:09.000000', 'consum', 0.0233, 'lps'),
	(594335, 131, '2014-03-15 00:03:10.000000', 'consum', 0.0230, 'lps'),
	(594336, 131, '2014-03-15 00:03:11.000000', 'consum', 0.0216, 'lps'),
	(594337, 131, '2014-03-15 00:03:12.000000', 'consum', 0.0235, 'lps'),
	(594338, 131, '2014-03-15 00:03:13.000000', 'consum', 0.0232, 'lps'),
	(594339, 131, '2014-03-15 00:03:14.000000', 'consum', 0.0219, 'lps'),
	(594340, 131, '2014-03-15 00:03:15.000000', 'consum', 0.0218, 'lps'),
	(594341, 131, '2014-03-15 00:03:16.000000', 'consum', 0.0225, 'lps'),
	(594342, 131, '2014-03-15 00:03:17.000000', 'consum', 0.0231, 'lps'),
	(594343, 131, '2014-03-15 00:03:18.000000', 'consum', 0.0214, 'lps'),
	(594344, 131, '2014-03-15 00:03:19.000000', 'consum', 0.0226, 'lps'),
	(594345, 131, '2014-03-15 00:03:20.000000', 'consum', 0.0220, 'lps'),
	(594346, 131, '2014-03-15 00:03:21.000000', 'consum', 0.0212, 'lps'),
	(594347, 131, '2014-03-15 00:03:22.000000', 'consum', 0.0219, 'lps'),
	(594348, 131, '2014-03-15 00:03:23.000000', 'consum', 0.0224, 'lps'),
	(594349, 131, '2014-03-15 00:03:24.000000', 'consum', 0.0224, 'lps'),
	(594350, 131, '2014-03-15 00:03:25.000000', 'consum', 0.0236, 'lps'),
	(594351, 131, '2014-03-15 00:03:26.000000', 'consum', 0.0218, 'lps'),
	(594352, 131, '2014-03-15 00:03:27.000000', 'consum', 0.0227, 'lps'),
	(594353, 131, '2014-03-15 00:03:28.000000', 'consum', 0.0214, 'lps'),
	(594354, 131, '2014-03-15 00:03:29.000000', 'consum', 0.0236, 'lps'),
	(594355, 131, '2014-03-15 00:03:30.000000', 'consum', 0.0217, 'lps'),
	(594356, 131, '2014-03-15 00:03:31.000000', 'consum', 0.0224, 'lps'),
	(594357, 131, '2014-03-15 00:03:32.000000', 'consum', 0.0232, 'lps'),
	(594358, 131, '2014-03-15 00:03:33.000000', 'consum', 0.0223, 'lps'),
	(594359, 131, '2014-03-15 00:03:34.000000', 'consum', 0.0237, 'lps'),
	(594360, 131, '2014-03-15 00:03:35.000000', 'consum', 0.0224, 'lps'),
	(594361, 131, '2014-03-15 00:03:36.000000', 'consum', 0.0226, 'lps'),
	(594362, 131, '2014-03-15 00:03:37.000000', 'consum', 0.0219, 'lps'),
	(594363, 131, '2014-03-15 00:03:38.000000', 'consum', 0.0211, 'lps'),
	(594364, 131, '2014-03-15 00:03:39.000000', 'consum', 0.0213, 'lps'),
	(594365, 131, '2014-03-15 00:03:40.000000', 'consum', 0.0223, 'lps'),
	(594366, 131, '2014-03-15 00:03:41.000000', 'consum', 0.0213, 'lps'),
	(594367, 131, '2014-03-15 00:03:42.000000', 'consum', 0.0212, 'lps'),
	(594368, 131, '2014-03-15 00:03:43.000000', 'consum', 0.0212, 'lps'),
	(594369, 131, '2014-03-15 00:03:44.000000', 'consum', 0.0216, 'lps'),
	(594370, 131, '2014-03-15 00:03:45.000000', 'consum', 0.0231, 'lps'),
	(594371, 131, '2014-03-15 00:03:46.000000', 'consum', 0.0217, 'lps'),
	(594372, 131, '2014-03-15 00:03:47.000000', 'consum', 0.0211, 'lps'),
	(594373, 131, '2014-03-15 00:03:48.000000', 'consum', 0.0223, 'lps'),
	(594374, 131, '2014-03-15 00:03:49.000000', 'consum', 0.0214, 'lps'),
	(594375, 131, '2014-03-15 00:03:50.000000', 'consum', 0.0221, 'lps'),
	(594376, 131, '2014-03-15 00:03:51.000000', 'consum', 0.0226, 'lps'),
	(594377, 131, '2014-03-15 00:03:52.000000', 'consum', 0.0227, 'lps'),
	(594378, 131, '2014-03-15 00:03:53.000000', 'consum', 0.0223, 'lps'),
	(594379, 131, '2014-03-15 00:03:54.000000', 'consum', 0.0223, 'lps'),
	(594380, 131, '2014-03-15 00:03:55.000000', 'consum', 0.0235, 'lps'),
	(594381, 131, '2014-03-15 00:03:56.000000', 'consum', 0.0215, 'lps'),
	(594382, 131, '2014-03-15 00:03:57.000000', 'consum', 0.0215, 'lps'),
	(594383, 131, '2014-03-15 00:03:58.000000', 'consum', 0.0222, 'lps'),
	(594384, 131, '2014-03-15 00:03:59.000000', 'consum', 0.0227, 'lps'),
	(594385, 131, '2014-03-15 00:04:00.000000', 'consum', 0.0231, 'lps'),
	(594386, 131, '2014-03-15 00:04:01.000000', 'consum', 0.0237, 'lps'),
	(594387, 131, '2014-03-15 00:04:02.000000', 'consum', 0.0226, 'lps'),
	(594388, 131, '2014-03-15 00:04:03.000000', 'consum', 0.0211, 'lps'),
	(594389, 131, '2014-03-15 00:04:04.000000', 'consum', 0.0223, 'lps'),
	(594390, 131, '2014-03-15 00:04:05.000000', 'consum', 0.0218, 'lps'),
	(594391, 131, '2014-03-15 00:04:06.000000', 'consum', 0.0236, 'lps'),
	(594392, 131, '2014-03-15 00:04:07.000000', 'consum', 0.0235, 'lps'),
	(594393, 131, '2014-03-15 00:04:08.000000', 'consum', 0.0227, 'lps'),
	(594394, 131, '2014-03-15 00:04:09.000000', 'consum', 0.0221, 'lps'),
	(594395, 131, '2014-03-15 00:04:10.000000', 'consum', 0.0216, 'lps'),
	(594396, 131, '2014-03-15 00:04:11.000000', 'consum', 0.0237, 'lps'),
	(594397, 131, '2014-03-15 00:04:12.000000', 'consum', 0.0212, 'lps'),
	(594398, 131, '2014-03-15 00:04:13.000000', 'consum', 0.0226, 'lps'),
	(594399, 131, '2014-03-15 00:04:14.000000', 'consum', 0.0230, 'lps'),
	(594400, 131, '2014-03-15 00:04:15.000000', 'consum', 0.0232, 'lps'),
	(594401, 131, '2014-03-15 00:04:16.000000', 'consum', 0.0232, 'lps'),
	(594402, 131, '2014-03-15 00:04:17.000000', 'consum', 0.0226, 'lps'),
	(594403, 131, '2014-03-15 00:04:18.000000', 'consum', 0.0224, 'lps'),
	(594404, 131, '2014-03-15 00:04:19.000000', 'consum', 0.0233, 'lps'),
	(594405, 131, '2014-03-15 00:04:20.000000', 'consum', 0.0229, 'lps'),
	(594406, 131, '2014-03-15 00:04:21.000000', 'consum', 0.0234, 'lps'),
	(594407, 131, '2014-03-15 00:04:22.000000', 'consum', 0.0218, 'lps'),
	(594408, 131, '2014-03-15 00:04:23.000000', 'consum', 0.0235, 'lps'),
	(594409, 131, '2014-03-15 00:04:24.000000', 'consum', 0.0226, 'lps'),
	(594410, 131, '2014-03-15 00:04:25.000000', 'consum', 0.0216, 'lps'),
	(594411, 131, '2014-03-15 00:04:26.000000', 'consum', 0.0222, 'lps'),
	(594412, 131, '2014-03-15 00:04:27.000000', 'consum', 0.0224, 'lps'),
	(594413, 131, '2014-03-15 00:04:28.000000', 'consum', 0.0218, 'lps'),
	(594414, 131, '2014-03-15 00:04:29.000000', 'consum', 0.0235, 'lps'),
	(594415, 131, '2014-03-15 00:04:30.000000', 'consum', 0.0227, 'lps'),
	(594416, 131, '2014-03-15 00:04:31.000000', 'consum', 0.0221, 'lps'),
	(594417, 131, '2014-03-15 00:04:32.000000', 'consum', 0.0214, 'lps'),
	(594418, 131, '2014-03-15 00:04:33.000000', 'consum', 0.0225, 'lps'),
	(594419, 131, '2014-03-15 00:04:34.000000', 'consum', 0.0216, 'lps'),
	(594420, 131, '2014-03-15 00:04:35.000000', 'consum', 0.0226, 'lps'),
	(594421, 131, '2014-03-15 00:04:36.000000', 'consum', 0.0217, 'lps'),
	(594422, 131, '2014-03-15 00:04:37.000000', 'consum', 0.0224, 'lps'),
	(594423, 131, '2014-03-15 00:04:38.000000', 'consum', 0.0231, 'lps'),
	(594424, 131, '2014-03-15 00:04:39.000000', 'consum', 0.0217, 'lps'),
	(594425, 131, '2014-03-15 00:04:40.000000', 'consum', 0.0213, 'lps'),
	(594426, 131, '2014-03-15 00:04:41.000000', 'consum', 0.0232, 'lps'),
	(594427, 131, '2014-03-15 00:04:42.000000', 'consum', 0.0225, 'lps'),
	(594428, 131, '2014-03-15 00:04:43.000000', 'consum', 0.0221, 'lps'),
	(594429, 131, '2014-03-15 00:04:44.000000', 'consum', 0.0221, 'lps'),
	(594430, 131, '2014-03-15 00:04:45.000000', 'consum', 0.0233, 'lps'),
	(594431, 131, '2014-03-15 00:04:46.000000', 'consum', 0.0236, 'lps'),
	(594432, 131, '2014-03-15 00:04:47.000000', 'consum', 0.0213, 'lps'),
	(594433, 131, '2014-03-15 00:04:48.000000', 'consum', 0.0234, 'lps'),
	(594434, 131, '2014-03-15 00:04:49.000000', 'consum', 0.0211, 'lps'),
	(594435, 131, '2014-03-15 00:04:50.000000', 'consum', 0.0225, 'lps'),
	(594436, 131, '2014-03-15 00:04:51.000000', 'consum', 0.0228, 'lps'),
	(594437, 131, '2014-03-15 00:04:52.000000', 'consum', 0.0226, 'lps'),
	(594438, 131, '2014-03-15 00:04:53.000000', 'consum', 0.0237, 'lps'),
	(594439, 131, '2014-03-15 00:04:54.000000', 'consum', 0.0213, 'lps'),
	(594440, 131, '2014-03-15 00:04:55.000000', 'consum', 0.0230, 'lps'),
	(594441, 131, '2014-03-15 00:04:56.000000', 'consum', 0.0216, 'lps'),
	(594442, 131, '2014-03-15 00:04:57.000000', 'consum', 0.0210, 'lps'),
	(594443, 131, '2014-03-15 00:04:58.000000', 'consum', 0.0218, 'lps'),
	(594444, 131, '2014-03-15 00:04:59.000000', 'consum', 0.0222, 'lps'),
	(594445, 131, '2014-03-15 00:05:00.000000', 'consum', 0.0222, 'lps'),
	(594446, 131, '2014-03-15 00:05:01.000000', 'consum', 0.0232, 'lps'),
	(594447, 131, '2014-03-15 00:05:02.000000', 'consum', 0.0227, 'lps'),
	(594448, 131, '2014-03-15 00:05:03.000000', 'consum', 0.0231, 'lps'),
	(594449, 131, '2014-03-15 00:05:04.000000', 'consum', 0.0210, 'lps'),
	(594450, 131, '2014-03-15 00:05:05.000000', 'consum', 0.0228, 'lps'),
	(594451, 131, '2014-03-15 00:05:06.000000', 'consum', 0.0220, 'lps'),
	(594452, 131, '2014-03-15 00:05:07.000000', 'consum', 0.0233, 'lps'),
	(594453, 131, '2014-03-15 00:05:08.000000', 'consum', 0.0212, 'lps'),
	(594454, 131, '2014-03-15 00:05:09.000000', 'consum', 0.0236, 'lps'),
	(594455, 131, '2014-03-15 00:05:10.000000', 'consum', 0.0223, 'lps'),
	(594456, 131, '2014-03-15 00:05:11.000000', 'consum', 0.0223, 'lps'),
	(594457, 131, '2014-03-15 00:05:12.000000', 'consum', 0.0236, 'lps'),
	(594458, 131, '2014-03-15 00:05:13.000000', 'consum', 0.0221, 'lps'),
	(594459, 131, '2014-03-15 00:05:14.000000', 'consum', 0.0213, 'lps'),
	(594460, 131, '2014-03-15 00:05:15.000000', 'consum', 0.0221, 'lps'),
	(594461, 131, '2014-03-15 00:05:16.000000', 'consum', 0.0227, 'lps'),
	(594462, 131, '2014-03-15 00:05:17.000000', 'consum', 0.0236, 'lps'),
	(594463, 131, '2014-03-15 00:05:18.000000', 'consum', 0.0231, 'lps'),
	(594464, 131, '2014-03-15 00:05:19.000000', 'consum', 0.0212, 'lps'),
	(594465, 131, '2014-03-15 00:05:20.000000', 'consum', 0.0214, 'lps'),
	(594466, 131, '2014-03-15 00:05:21.000000', 'consum', 0.0224, 'lps'),
	(594467, 131, '2014-03-15 00:05:22.000000', 'consum', 0.0213, 'lps'),
	(594468, 131, '2014-03-15 00:05:23.000000', 'consum', 0.0213, 'lps'),
	(594469, 131, '2014-03-15 00:05:24.000000', 'consum', 0.0215, 'lps'),
	(594470, 131, '2014-03-15 00:05:25.000000', 'consum', 0.0226, 'lps'),
	(594471, 131, '2014-03-15 00:05:26.000000', 'consum', 0.0220, 'lps'),
	(594472, 131, '2014-03-15 00:05:27.000000', 'consum', 0.0213, 'lps'),
	(594473, 131, '2014-03-15 00:05:28.000000', 'consum', 0.0225, 'lps'),
	(594474, 131, '2014-03-15 00:05:29.000000', 'consum', 0.0220, 'lps'),
	(594475, 131, '2014-03-15 00:05:30.000000', 'consum', 0.0213, 'lps'),
	(594476, 131, '2014-03-15 00:05:31.000000', 'consum', 0.0226, 'lps'),
	(594477, 131, '2014-03-15 00:05:32.000000', 'consum', 0.0225, 'lps'),
	(594478, 131, '2014-03-15 00:05:33.000000', 'consum', 0.0211, 'lps'),
	(594479, 131, '2014-03-15 00:05:34.000000', 'consum', 0.0224, 'lps'),
	(594480, 131, '2014-03-15 00:05:35.000000', 'consum', 0.0220, 'lps'),
	(594481, 131, '2014-03-15 00:05:36.000000', 'consum', 0.0222, 'lps'),
	(594482, 131, '2014-03-15 00:05:37.000000', 'consum', 0.0212, 'lps'),
	(594483, 131, '2014-03-15 00:05:38.000000', 'consum', 0.0213, 'lps'),
	(594484, 131, '2014-03-15 00:05:39.000000', 'consum', 0.0217, 'lps'),
	(594485, 131, '2014-03-15 00:05:40.000000', 'consum', 0.0212, 'lps'),
	(594486, 131, '2014-03-15 00:05:41.000000', 'consum', 0.0225, 'lps'),
	(594487, 131, '2014-03-15 00:05:42.000000', 'consum', 0.0226, 'lps'),
	(594488, 131, '2014-03-15 00:05:43.000000', 'consum', 0.0215, 'lps'),
	(594489, 131, '2014-03-15 00:05:44.000000', 'consum', 0.0215, 'lps'),
	(594490, 131, '2014-03-15 00:05:45.000000', 'consum', 0.0221, 'lps'),
	(594491, 131, '2014-03-15 00:05:46.000000', 'consum', 0.0221, 'lps'),
	(594492, 131, '2014-03-15 00:05:47.000000', 'consum', 0.0234, 'lps'),
	(594493, 131, '2014-03-15 00:05:48.000000', 'consum', 0.0213, 'lps'),
	(594494, 131, '2014-03-15 00:05:49.000000', 'consum', 0.0210, 'lps'),
	(594495, 131, '2014-03-15 00:05:50.000000', 'consum', 0.0230, 'lps'),
	(594496, 131, '2014-03-15 00:05:51.000000', 'consum', 0.0228, 'lps'),
	(594497, 131, '2014-03-15 00:05:52.000000', 'consum', 0.0212, 'lps'),
	(594498, 131, '2014-03-15 00:05:53.000000', 'consum', 0.0221, 'lps'),
	(594499, 131, '2014-03-15 00:05:54.000000', 'consum', 0.0230, 'lps'),
	(594500, 131, '2014-03-15 00:05:55.000000', 'consum', 0.0224, 'lps'),
	(594501, 131, '2014-03-15 00:05:56.000000', 'consum', 0.0221, 'lps'),
	(594502, 131, '2014-03-15 00:05:57.000000', 'consum', 0.0221, 'lps'),
	(594503, 131, '2014-03-15 00:05:58.000000', 'consum', 0.0233, 'lps'),
	(594504, 131, '2014-03-15 00:05:59.000000', 'consum', 0.0211, 'lps'),
	(594505, 131, '2014-03-15 00:06:00.000000', 'consum', 0.0229, 'lps'),
	(594506, 131, '2014-03-15 00:06:01.000000', 'consum', 0.0217, 'lps'),
	(594507, 131, '2014-03-15 00:06:02.000000', 'consum', 0.0216, 'lps'),
	(594508, 131, '2014-03-15 00:06:03.000000', 'consum', 0.0222, 'lps'),
	(594509, 131, '2014-03-15 00:06:04.000000', 'consum', 0.0223, 'lps'),
	(594510, 131, '2014-03-15 00:06:05.000000', 'consum', 0.0210, 'lps'),
	(594511, 131, '2014-03-15 00:06:06.000000', 'consum', 0.0229, 'lps'),
	(594512, 131, '2014-03-15 00:06:07.000000', 'consum', 0.0222, 'lps'),
	(594513, 131, '2014-03-15 00:06:08.000000', 'consum', 0.0213, 'lps'),
	(594514, 131, '2014-03-15 00:06:09.000000', 'consum', 0.0219, 'lps'),
	(594515, 131, '2014-03-15 00:06:10.000000', 'consum', 0.0219, 'lps'),
	(594516, 131, '2014-03-15 00:06:11.000000', 'consum', 0.0229, 'lps'),
	(594517, 131, '2014-03-15 00:06:12.000000', 'consum', 0.0222, 'lps'),
	(594518, 131, '2014-03-15 00:06:13.000000', 'consum', 0.0215, 'lps'),
	(594519, 131, '2014-03-15 00:06:14.000000', 'consum', 0.0226, 'lps'),
	(594520, 131, '2014-03-15 00:06:15.000000', 'consum', 0.0219, 'lps'),
	(594521, 131, '2014-03-15 00:06:16.000000', 'consum', 0.0235, 'lps'),
	(594522, 131, '2014-03-15 00:06:17.000000', 'consum', 0.0227, 'lps'),
	(594523, 131, '2014-03-15 00:06:18.000000', 'consum', 0.0220, 'lps'),
	(594524, 131, '2014-03-15 00:06:19.000000', 'consum', 0.0211, 'lps'),
	(594525, 131, '2014-03-15 00:06:20.000000', 'consum', 0.0212, 'lps'),
	(594526, 131, '2014-03-15 00:06:21.000000', 'consum', 0.0217, 'lps'),
	(594527, 131, '2014-03-15 00:06:22.000000', 'consum', 0.0210, 'lps'),
	(594528, 131, '2014-03-15 00:06:23.000000', 'consum', 0.0218, 'lps'),
	(594529, 131, '2014-03-15 00:06:24.000000', 'consum', 0.0223, 'lps'),
	(594530, 131, '2014-03-15 00:06:25.000000', 'consum', 0.0225, 'lps'),
	(594531, 131, '2014-03-15 00:06:26.000000', 'consum', 0.0217, 'lps'),
	(594532, 131, '2014-03-15 00:06:27.000000', 'consum', 0.0230, 'lps'),
	(594533, 131, '2014-03-15 00:06:28.000000', 'consum', 0.0232, 'lps'),
	(594534, 131, '2014-03-15 00:06:29.000000', 'consum', 0.0234, 'lps'),
	(594535, 131, '2014-03-15 00:06:30.000000', 'consum', 0.0235, 'lps'),
	(594536, 131, '2014-03-15 00:06:31.000000', 'consum', 0.0235, 'lps'),
	(594537, 131, '2014-03-15 00:06:32.000000', 'consum', 0.0232, 'lps'),
	(594538, 131, '2014-03-15 00:06:33.000000', 'consum', 0.0220, 'lps'),
	(594539, 131, '2014-03-15 00:06:34.000000', 'consum', 0.0223, 'lps'),
	(594540, 131, '2014-03-15 00:06:35.000000', 'consum', 0.0215, 'lps'),
	(594541, 131, '2014-03-15 00:06:36.000000', 'consum', 0.0226, 'lps'),
	(594542, 131, '2014-03-15 00:06:37.000000', 'consum', 0.0220, 'lps'),
	(594543, 131, '2014-03-15 00:06:38.000000', 'consum', 0.0211, 'lps'),
	(594544, 131, '2014-03-15 00:06:39.000000', 'consum', 0.0213, 'lps'),
	(594545, 131, '2014-03-15 00:06:40.000000', 'consum', 0.0223, 'lps'),
	(594546, 131, '2014-03-15 00:06:41.000000', 'consum', 0.0237, 'lps'),
	(594547, 131, '2014-03-15 00:06:42.000000', 'consum', 0.0225, 'lps'),
	(594548, 131, '2014-03-15 00:06:43.000000', 'consum', 0.0231, 'lps'),
	(594549, 131, '2014-03-15 00:06:44.000000', 'consum', 0.0214, 'lps'),
	(594550, 131, '2014-03-15 00:06:45.000000', 'consum', 0.0223, 'lps'),
	(594551, 131, '2014-03-15 00:06:46.000000', 'consum', 0.0234, 'lps'),
	(594552, 131, '2014-03-15 00:06:47.000000', 'consum', 0.0211, 'lps'),
	(594553, 131, '2014-03-15 00:06:48.000000', 'consum', 0.0227, 'lps'),
	(594554, 131, '2014-03-15 00:06:49.000000', 'consum', 0.0234, 'lps'),
	(594555, 131, '2014-03-15 00:06:50.000000', 'consum', 0.0226, 'lps'),
	(594556, 131, '2014-03-15 00:06:51.000000', 'consum', 0.0218, 'lps'),
	(594557, 131, '2014-03-15 00:06:52.000000', 'consum', 0.0231, 'lps'),
	(594558, 131, '2014-03-15 00:06:53.000000', 'consum', 0.0236, 'lps'),
	(594559, 131, '2014-03-15 00:06:54.000000', 'consum', 0.0221, 'lps'),
	(594560, 131, '2014-03-15 00:06:55.000000', 'consum', 0.0215, 'lps'),
	(594561, 131, '2014-03-15 00:06:56.000000', 'consum', 0.0231, 'lps'),
	(594562, 131, '2014-03-15 00:06:57.000000', 'consum', 0.0218, 'lps'),
	(594563, 131, '2014-03-15 00:06:58.000000', 'consum', 0.0212, 'lps'),
	(594564, 131, '2014-03-15 00:06:59.000000', 'consum', 0.0228, 'lps'),
	(594565, 131, '2014-03-15 00:07:00.000000', 'consum', 0.0210, 'lps'),
	(594566, 131, '2014-03-15 00:07:01.000000', 'consum', 0.0210, 'lps'),
	(594567, 131, '2014-03-15 00:07:02.000000', 'consum', 0.0213, 'lps'),
	(594568, 131, '2014-03-15 00:07:03.000000', 'consum', 0.0225, 'lps'),
	(594569, 131, '2014-03-15 00:07:04.000000', 'consum', 0.0220, 'lps'),
	(594570, 131, '2014-03-15 00:07:05.000000', 'consum', 0.0215, 'lps'),
	(594571, 131, '2014-03-15 00:07:06.000000', 'consum', 0.0234, 'lps'),
	(594572, 131, '2014-03-15 00:07:07.000000', 'consum', 0.0231, 'lps'),
	(594573, 131, '2014-03-15 00:07:08.000000', 'consum', 0.0217, 'lps'),
	(594574, 131, '2014-03-15 00:07:09.000000', 'consum', 0.0212, 'lps'),
	(594575, 131, '2014-03-15 00:07:10.000000', 'consum', 0.0224, 'lps'),
	(594576, 131, '2014-03-15 00:07:11.000000', 'consum', 0.0219, 'lps'),
	(594577, 131, '2014-03-15 00:07:12.000000', 'consum', 0.0213, 'lps'),
	(594578, 131, '2014-03-15 00:07:13.000000', 'consum', 0.0227, 'lps'),
	(594579, 131, '2014-03-15 00:07:14.000000', 'consum', 0.0231, 'lps'),
	(594580, 131, '2014-03-15 00:07:15.000000', 'consum', 0.0236, 'lps'),
	(594581, 131, '2014-03-15 00:07:16.000000', 'consum', 0.0221, 'lps'),
	(594582, 131, '2014-03-15 00:07:17.000000', 'consum', 0.0214, 'lps'),
	(594583, 131, '2014-03-15 00:07:18.000000', 'consum', 0.0229, 'lps'),
	(594584, 131, '2014-03-15 00:07:19.000000', 'consum', 0.0235, 'lps'),
	(594585, 131, '2014-03-15 00:07:20.000000', 'consum', 0.0224, 'lps'),
	(594586, 131, '2014-03-15 00:07:21.000000', 'consum', 0.0235, 'lps'),
	(594587, 131, '2014-03-15 00:07:22.000000', 'consum', 0.0235, 'lps'),
	(594588, 131, '2014-03-15 00:07:23.000000', 'consum', 0.0234, 'lps'),
	(594589, 131, '2014-03-15 00:07:24.000000', 'consum', 0.0227, 'lps'),
	(594590, 131, '2014-03-15 00:07:25.000000', 'consum', 0.0222, 'lps'),
	(594591, 131, '2014-03-15 00:07:26.000000', 'consum', 0.0219, 'lps'),
	(594592, 131, '2014-03-15 00:07:27.000000', 'consum', 0.0222, 'lps'),
	(594593, 131, '2014-03-15 00:07:28.000000', 'consum', 0.0214, 'lps'),
	(594594, 131, '2014-03-15 00:07:29.000000', 'consum', 0.0224, 'lps'),
	(594595, 131, '2014-03-15 00:07:30.000000', 'consum', 0.0211, 'lps'),
	(594596, 131, '2014-03-15 00:07:31.000000', 'consum', 0.0231, 'lps'),
	(594597, 131, '2014-03-15 00:07:32.000000', 'consum', 0.0226, 'lps'),
	(594598, 131, '2014-03-15 00:07:33.000000', 'consum', 0.0229, 'lps'),
	(594599, 131, '2014-03-15 00:07:34.000000', 'consum', 0.0231, 'lps'),
	(594600, 131, '2014-03-15 00:07:35.000000', 'consum', 0.0229, 'lps'),
	(594601, 131, '2014-03-15 00:07:36.000000', 'consum', 0.0213, 'lps'),
	(594602, 131, '2014-03-15 00:07:37.000000', 'consum', 0.0227, 'lps'),
	(594603, 131, '2014-03-15 00:07:38.000000', 'consum', 0.0230, 'lps'),
	(594604, 131, '2014-03-15 00:07:39.000000', 'consum', 0.0230, 'lps'),
	(594605, 131, '2014-03-15 00:07:40.000000', 'consum', 0.0222, 'lps'),
	(594606, 131, '2014-03-15 00:07:41.000000', 'consum', 0.0210, 'lps'),
	(594607, 131, '2014-03-15 00:07:42.000000', 'consum', 0.0232, 'lps'),
	(594608, 131, '2014-03-15 00:07:43.000000', 'consum', 0.0210, 'lps'),
	(594609, 131, '2014-03-15 00:07:44.000000', 'consum', 0.0227, 'lps'),
	(594610, 131, '2014-03-15 00:07:45.000000', 'consum', 0.0213, 'lps'),
	(594611, 131, '2014-03-15 00:07:46.000000', 'consum', 0.0231, 'lps'),
	(594612, 131, '2014-03-15 00:07:47.000000', 'consum', 0.0220, 'lps'),
	(594613, 131, '2014-03-15 00:07:48.000000', 'consum', 0.0226, 'lps'),
	(594614, 131, '2014-03-15 00:07:49.000000', 'consum', 0.0234, 'lps'),
	(594615, 131, '2014-03-15 00:07:50.000000', 'consum', 0.0228, 'lps'),
	(594616, 131, '2014-03-15 00:07:51.000000', 'consum', 0.0226, 'lps'),
	(594617, 131, '2014-03-15 00:07:52.000000', 'consum', 0.0237, 'lps'),
	(594618, 131, '2014-03-15 00:07:53.000000', 'consum', 0.0212, 'lps'),
	(594619, 131, '2014-03-15 00:07:54.000000', 'consum', 0.0224, 'lps'),
	(594620, 131, '2014-03-15 00:07:55.000000', 'consum', 0.0218, 'lps'),
	(594621, 131, '2014-03-15 00:07:56.000000', 'consum', 0.0237, 'lps'),
	(594622, 131, '2014-03-15 00:07:57.000000', 'consum', 0.0237, 'lps'),
	(594623, 131, '2014-03-15 00:07:58.000000', 'consum', 0.0210, 'lps'),
	(594624, 131, '2014-03-15 00:07:59.000000', 'consum', 0.0212, 'lps'),
	(594625, 131, '2014-03-15 00:08:00.000000', 'consum', 0.0221, 'lps'),
	(594626, 131, '2014-03-15 00:08:01.000000', 'consum', 0.0230, 'lps'),
	(594627, 131, '2014-03-15 00:08:02.000000', 'consum', 0.0223, 'lps'),
	(594628, 131, '2014-03-15 00:08:03.000000', 'consum', 0.0216, 'lps'),
	(594629, 131, '2014-03-15 00:08:04.000000', 'consum', 0.0227, 'lps'),
	(594630, 131, '2014-03-15 00:08:05.000000', 'consum', 0.0223, 'lps'),
	(594631, 131, '2014-03-15 00:08:06.000000', 'consum', 0.0225, 'lps'),
	(594632, 131, '2014-03-15 00:08:07.000000', 'consum', 0.0218, 'lps'),
	(594633, 131, '2014-03-15 00:08:08.000000', 'consum', 0.0232, 'lps'),
	(594634, 131, '2014-03-15 00:08:09.000000', 'consum', 0.0215, 'lps'),
	(594635, 131, '2014-03-15 00:08:10.000000', 'consum', 0.0225, 'lps'),
	(594636, 131, '2014-03-15 00:08:11.000000', 'consum', 0.0214, 'lps'),
	(594637, 131, '2014-03-15 00:08:12.000000', 'consum', 0.0212, 'lps'),
	(594638, 131, '2014-03-15 00:08:13.000000', 'consum', 0.0210, 'lps'),
	(594639, 131, '2014-03-15 00:08:14.000000', 'consum', 0.0233, 'lps'),
	(594640, 131, '2014-03-15 00:08:15.000000', 'consum', 0.0214, 'lps'),
	(594641, 131, '2014-03-15 00:08:16.000000', 'consum', 0.0216, 'lps'),
	(594642, 131, '2014-03-15 00:08:17.000000', 'consum', 0.0230, 'lps'),
	(594643, 131, '2014-03-15 00:08:18.000000', 'consum', 0.0236, 'lps'),
	(594644, 131, '2014-03-15 00:08:19.000000', 'consum', 0.0224, 'lps'),
	(594645, 131, '2014-03-15 00:08:20.000000', 'consum', 0.0229, 'lps'),
	(594646, 131, '2014-03-15 00:08:21.000000', 'consum', 0.0236, 'lps'),
	(594647, 131, '2014-03-15 00:08:22.000000', 'consum', 0.0229, 'lps'),
	(594648, 131, '2014-03-15 00:08:23.000000', 'consum', 0.0226, 'lps'),
	(594649, 131, '2014-03-15 00:08:24.000000', 'consum', 0.0236, 'lps'),
	(594650, 131, '2014-03-15 00:08:25.000000', 'consum', 0.0235, 'lps'),
	(594651, 131, '2014-03-15 00:08:26.000000', 'consum', 0.0231, 'lps'),
	(594652, 131, '2014-03-15 00:08:27.000000', 'consum', 0.0213, 'lps'),
	(594653, 131, '2014-03-15 00:08:28.000000', 'consum', 0.0219, 'lps'),
	(594654, 131, '2014-03-15 00:08:29.000000', 'consum', 0.0219, 'lps'),
	(594655, 131, '2014-03-15 00:08:30.000000', 'consum', 0.0227, 'lps'),
	(594656, 131, '2014-03-15 00:08:31.000000', 'consum', 0.0214, 'lps'),
	(594657, 131, '2014-03-15 00:08:32.000000', 'consum', 0.0234, 'lps'),
	(594658, 131, '2014-03-15 00:08:33.000000', 'consum', 0.0234, 'lps'),
	(594659, 131, '2014-03-15 00:08:34.000000', 'consum', 0.0231, 'lps'),
	(594660, 131, '2014-03-15 00:08:35.000000', 'consum', 0.0214, 'lps'),
	(594661, 131, '2014-03-15 00:08:36.000000', 'consum', 0.0225, 'lps'),
	(594662, 131, '2014-03-15 00:08:37.000000', 'consum', 0.0216, 'lps'),
	(594663, 131, '2014-03-15 00:08:38.000000', 'consum', 0.0225, 'lps'),
	(594664, 131, '2014-03-15 00:08:39.000000', 'consum', 0.0213, 'lps'),
	(594665, 131, '2014-03-15 00:08:40.000000', 'consum', 0.0235, 'lps'),
	(594666, 131, '2014-03-15 00:08:41.000000', 'consum', 0.0214, 'lps'),
	(594667, 131, '2014-03-15 00:08:42.000000', 'consum', 0.0213, 'lps'),
	(594668, 131, '2014-03-15 00:08:43.000000', 'consum', 0.0212, 'lps'),
	(594669, 131, '2014-03-15 00:08:44.000000', 'consum', 0.0214, 'lps'),
	(594670, 131, '2014-03-15 00:08:45.000000', 'consum', 0.0224, 'lps'),
	(594671, 131, '2014-03-15 00:08:46.000000', 'consum', 0.0210, 'lps'),
	(594672, 131, '2014-03-15 00:08:47.000000', 'consum', 0.0225, 'lps'),
	(594673, 131, '2014-03-15 00:08:48.000000', 'consum', 0.0231, 'lps'),
	(594674, 131, '2014-03-15 00:08:49.000000', 'consum', 0.0216, 'lps'),
	(594675, 131, '2014-03-15 00:08:50.000000', 'consum', 0.0231, 'lps'),
	(594676, 131, '2014-03-15 00:08:51.000000', 'consum', 0.0215, 'lps'),
	(594677, 131, '2014-03-15 00:08:52.000000', 'consum', 0.0227, 'lps'),
	(594678, 131, '2014-03-15 00:08:53.000000', 'consum', 0.0226, 'lps'),
	(594679, 131, '2014-03-15 00:08:54.000000', 'consum', 0.0210, 'lps'),
	(594680, 131, '2014-03-15 00:08:55.000000', 'consum', 0.0218, 'lps'),
	(594681, 131, '2014-03-15 00:08:56.000000', 'consum', 0.0225, 'lps'),
	(594682, 131, '2014-03-15 00:08:57.000000', 'consum', 0.0231, 'lps'),
	(594683, 131, '2014-03-15 00:08:58.000000', 'consum', 0.0215, 'lps'),
	(594684, 131, '2014-03-15 00:08:59.000000', 'consum', 0.0230, 'lps'),
	(594685, 131, '2014-03-15 00:09:00.000000', 'consum', 0.0212, 'lps'),
	(594686, 131, '2014-03-15 00:09:01.000000', 'consum', 0.0216, 'lps'),
	(594687, 131, '2014-03-15 00:09:02.000000', 'consum', 0.0235, 'lps'),
	(594688, 131, '2014-03-15 00:09:03.000000', 'consum', 0.0234, 'lps'),
	(594689, 131, '2014-03-15 00:09:04.000000', 'consum', 0.0227, 'lps'),
	(594690, 131, '2014-03-15 00:09:05.000000', 'consum', 0.0222, 'lps'),
	(594691, 131, '2014-03-15 00:09:06.000000', 'consum', 0.0221, 'lps'),
	(594692, 131, '2014-03-15 00:09:07.000000', 'consum', 0.0229, 'lps'),
	(594693, 131, '2014-03-15 00:09:08.000000', 'consum', 0.0215, 'lps'),
	(594694, 131, '2014-03-15 00:09:09.000000', 'consum', 0.0235, 'lps'),
	(594695, 131, '2014-03-15 00:09:10.000000', 'consum', 0.0211, 'lps'),
	(594696, 131, '2014-03-15 00:09:11.000000', 'consum', 0.0221, 'lps'),
	(594697, 131, '2014-03-15 00:09:12.000000', 'consum', 0.0237, 'lps'),
	(594698, 131, '2014-03-15 00:09:13.000000', 'consum', 0.0228, 'lps'),
	(594699, 131, '2014-03-15 00:09:14.000000', 'consum', 0.0219, 'lps'),
	(594700, 131, '2014-03-15 00:09:15.000000', 'consum', 0.0230, 'lps'),
	(594701, 131, '2014-03-15 00:09:16.000000', 'consum', 0.0229, 'lps'),
	(594702, 131, '2014-03-15 00:09:17.000000', 'consum', 0.0218, 'lps'),
	(594703, 131, '2014-03-15 00:09:18.000000', 'consum', 0.0220, 'lps'),
	(594704, 131, '2014-03-15 00:09:19.000000', 'consum', 0.0237, 'lps'),
	(594705, 131, '2014-03-15 00:09:20.000000', 'consum', 0.0230, 'lps'),
	(594706, 131, '2014-03-15 00:09:21.000000', 'consum', 0.0229, 'lps'),
	(594707, 131, '2014-03-15 00:09:22.000000', 'consum', 0.0220, 'lps'),
	(594708, 131, '2014-03-15 00:09:23.000000', 'consum', 0.0230, 'lps'),
	(594709, 131, '2014-03-15 00:09:24.000000', 'consum', 0.0223, 'lps'),
	(594710, 131, '2014-03-15 00:09:25.000000', 'consum', 0.0218, 'lps'),
	(594711, 131, '2014-03-15 00:09:26.000000', 'consum', 0.0236, 'lps'),
	(594712, 131, '2014-03-15 00:09:27.000000', 'consum', 0.0236, 'lps'),
	(594713, 131, '2014-03-15 00:09:28.000000', 'consum', 0.0235, 'lps'),
	(594714, 131, '2014-03-15 00:09:29.000000', 'consum', 0.0230, 'lps'),
	(594715, 131, '2014-03-15 00:09:30.000000', 'consum', 0.0233, 'lps'),
	(594716, 131, '2014-03-15 00:09:31.000000', 'consum', 0.0211, 'lps'),
	(594717, 131, '2014-03-15 00:09:32.000000', 'consum', 0.0230, 'lps'),
	(594718, 131, '2014-03-15 00:09:33.000000', 'consum', 0.0223, 'lps'),
	(594719, 131, '2014-03-15 00:09:34.000000', 'consum', 0.0217, 'lps'),
	(594720, 131, '2014-03-15 00:09:35.000000', 'consum', 0.0235, 'lps'),
	(594721, 131, '2014-03-15 00:09:36.000000', 'consum', 0.0228, 'lps'),
	(594722, 131, '2014-03-15 00:09:37.000000', 'consum', 0.0228, 'lps'),
	(594723, 131, '2014-03-15 00:09:38.000000', 'consum', 0.0220, 'lps'),
	(594724, 131, '2014-03-15 00:09:39.000000', 'consum', 0.0231, 'lps'),
	(594725, 131, '2014-03-15 00:09:40.000000', 'consum', 0.0230, 'lps'),
	(594726, 131, '2014-03-15 00:09:41.000000', 'consum', 0.0221, 'lps'),
	(594727, 131, '2014-03-15 00:09:42.000000', 'consum', 0.0231, 'lps'),
	(594728, 131, '2014-03-15 00:09:43.000000', 'consum', 0.0228, 'lps'),
	(594729, 131, '2014-03-15 00:09:44.000000', 'consum', 0.0210, 'lps'),
	(594730, 131, '2014-03-15 00:09:45.000000', 'consum', 0.0213, 'lps'),
	(594731, 131, '2014-03-15 00:09:46.000000', 'consum', 0.0223, 'lps'),
	(594732, 131, '2014-03-15 00:09:47.000000', 'consum', 0.0214, 'lps'),
	(594733, 131, '2014-03-15 00:09:48.000000', 'consum', 0.0217, 'lps'),
	(594734, 131, '2014-03-15 00:09:49.000000', 'consum', 0.0235, 'lps'),
	(594735, 131, '2014-03-15 00:09:50.000000', 'consum', 0.0229, 'lps'),
	(594736, 131, '2014-03-15 00:09:51.000000', 'consum', 0.0229, 'lps'),
	(594737, 131, '2014-03-15 00:09:52.000000', 'consum', 0.0223, 'lps'),
	(594738, 131, '2014-03-15 00:09:53.000000', 'consum', 0.0217, 'lps'),
	(594739, 131, '2014-03-15 00:09:54.000000', 'consum', 0.0237, 'lps'),
	(594740, 131, '2014-03-15 00:09:55.000000', 'consum', 0.0237, 'lps'),
	(594741, 131, '2014-03-15 00:09:56.000000', 'consum', 0.0212, 'lps'),
	(594742, 131, '2014-03-15 00:09:57.000000', 'consum', 0.0223, 'lps'),
	(594743, 131, '2014-03-15 00:09:58.000000', 'consum', 0.0211, 'lps'),
	(594744, 131, '2014-03-15 00:09:59.000000', 'consum', 0.0233, 'lps'),
	(594745, 131, '2014-03-15 00:10:00.000000', 'consum', 0.0213, 'lps'),
	(594746, 131, '2014-03-15 00:10:01.000000', 'consum', 0.0237, 'lps'),
	(594747, 131, '2014-03-15 00:10:02.000000', 'consum', 0.0226, 'lps'),
	(594748, 131, '2014-03-15 00:10:03.000000', 'consum', 0.0211, 'lps'),
	(594749, 131, '2014-03-15 00:10:04.000000', 'consum', 0.0225, 'lps'),
	(594750, 131, '2014-03-15 00:10:05.000000', 'consum', 0.0223, 'lps'),
	(594751, 131, '2014-03-15 00:10:06.000000', 'consum', 0.0231, 'lps'),
	(594752, 131, '2014-03-15 00:10:07.000000', 'consum', 0.0221, 'lps'),
	(594753, 131, '2014-03-15 00:10:08.000000', 'consum', 0.0230, 'lps'),
	(594754, 131, '2014-03-15 00:10:09.000000', 'consum', 0.0222, 'lps'),
	(594755, 131, '2014-03-15 00:10:10.000000', 'consum', 0.0210, 'lps'),
	(594756, 131, '2014-03-15 00:10:11.000000', 'consum', 0.0230, 'lps'),
	(594757, 131, '2014-03-15 00:10:12.000000', 'consum', 0.0226, 'lps'),
	(594758, 131, '2014-03-15 00:10:13.000000', 'consum', 0.0232, 'lps'),
	(594759, 131, '2014-03-15 00:10:14.000000', 'consum', 0.0215, 'lps'),
	(594760, 131, '2014-03-15 00:10:15.000000', 'consum', 0.0225, 'lps'),
	(594761, 131, '2014-03-15 00:10:16.000000', 'consum', 0.0215, 'lps'),
	(594762, 131, '2014-03-15 00:10:17.000000', 'consum', 0.0218, 'lps'),
	(594763, 131, '2014-03-15 00:10:18.000000', 'consum', 0.0234, 'lps'),
	(594764, 131, '2014-03-15 00:10:19.000000', 'consum', 0.0224, 'lps'),
	(594765, 131, '2014-03-15 00:10:20.000000', 'consum', 0.0235, 'lps'),
	(594766, 131, '2014-03-15 00:10:21.000000', 'consum', 0.0211, 'lps'),
	(594767, 131, '2014-03-15 00:10:22.000000', 'consum', 0.0225, 'lps'),
	(594768, 131, '2014-03-15 00:10:23.000000', 'consum', 0.0226, 'lps'),
	(594769, 131, '2014-03-15 00:10:24.000000', 'consum', 0.0216, 'lps'),
	(594770, 131, '2014-03-15 00:10:25.000000', 'consum', 0.0222, 'lps'),
	(594771, 131, '2014-03-15 00:10:26.000000', 'consum', 0.0226, 'lps'),
	(594772, 131, '2014-03-15 00:10:27.000000', 'consum', 0.0225, 'lps'),
	(594773, 131, '2014-03-15 00:10:28.000000', 'consum', 0.0211, 'lps'),
	(594774, 131, '2014-03-15 00:10:29.000000', 'consum', 0.0224, 'lps'),
	(594775, 131, '2014-03-15 00:10:30.000000', 'consum', 0.0223, 'lps'),
	(594776, 131, '2014-03-15 00:10:31.000000', 'consum', 0.0233, 'lps'),
	(594777, 131, '2014-03-15 00:10:32.000000', 'consum', 0.0229, 'lps'),
	(594778, 131, '2014-03-15 00:10:33.000000', 'consum', 0.0237, 'lps'),
	(594779, 131, '2014-03-15 00:10:34.000000', 'consum', 0.0231, 'lps'),
	(594780, 131, '2014-03-15 00:10:35.000000', 'consum', 0.0210, 'lps'),
	(594781, 131, '2014-03-15 00:10:36.000000', 'consum', 0.0229, 'lps'),
	(594782, 131, '2014-03-15 00:10:37.000000', 'consum', 0.0223, 'lps'),
	(594783, 131, '2014-03-15 00:10:38.000000', 'consum', 0.0218, 'lps'),
	(594784, 131, '2014-03-15 00:10:39.000000', 'consum', 0.0210, 'lps'),
	(594785, 131, '2014-03-15 00:10:40.000000', 'consum', 0.0215, 'lps'),
	(594786, 131, '2014-03-15 00:10:41.000000', 'consum', 0.0237, 'lps'),
	(594787, 131, '2014-03-15 00:10:42.000000', 'consum', 0.0218, 'lps'),
	(594788, 131, '2014-03-15 00:10:43.000000', 'consum', 0.0225, 'lps'),
	(594789, 131, '2014-03-15 00:10:44.000000', 'consum', 0.0235, 'lps'),
	(594790, 131, '2014-03-15 00:10:45.000000', 'consum', 0.0235, 'lps'),
	(594791, 131, '2014-03-15 00:10:46.000000', 'consum', 0.0231, 'lps'),
	(594792, 131, '2014-03-15 00:10:47.000000', 'consum', 0.0214, 'lps'),
	(594793, 131, '2014-03-15 00:10:48.000000', 'consum', 0.0224, 'lps'),
	(594794, 131, '2014-03-15 00:10:49.000000', 'consum', 0.0211, 'lps'),
	(594795, 131, '2014-03-15 00:10:50.000000', 'consum', 0.0231, 'lps'),
	(594796, 131, '2014-03-15 00:10:51.000000', 'consum', 0.0228, 'lps'),
	(594797, 131, '2014-03-15 00:10:52.000000', 'consum', 0.0210, 'lps'),
	(594798, 131, '2014-03-15 00:10:53.000000', 'consum', 0.0212, 'lps'),
	(594799, 131, '2014-03-15 00:10:54.000000', 'consum', 0.0221, 'lps'),
	(594800, 131, '2014-03-15 00:10:55.000000', 'consum', 0.0232, 'lps'),
	(594801, 131, '2014-03-15 00:10:56.000000', 'consum', 0.0229, 'lps'),
	(594802, 131, '2014-03-15 00:10:57.000000', 'consum', 0.0212, 'lps'),
	(594803, 131, '2014-03-15 00:10:58.000000', 'consum', 0.0222, 'lps'),
	(594804, 131, '2014-03-15 00:10:59.000000', 'consum', 0.0235, 'lps'),
	(594805, 131, '2014-03-15 00:11:00.000000', 'consum', 0.0216, 'lps'),
	(594806, 131, '2014-03-15 00:11:01.000000', 'consum', 0.0222, 'lps'),
	(594807, 131, '2014-03-15 00:11:02.000000', 'consum', 0.0225, 'lps'),
	(594808, 131, '2014-03-15 00:11:03.000000', 'consum', 0.0219, 'lps'),
	(594809, 131, '2014-03-15 00:11:04.000000', 'consum', 0.0214, 'lps'),
	(594810, 131, '2014-03-15 00:11:05.000000', 'consum', 0.0229, 'lps'),
	(594811, 131, '2014-03-15 00:11:06.000000', 'consum', 0.0211, 'lps'),
	(594812, 131, '2014-03-15 00:11:07.000000', 'consum', 0.0215, 'lps'),
	(594813, 131, '2014-03-15 00:11:08.000000', 'consum', 0.0233, 'lps'),
	(594814, 131, '2014-03-15 00:11:09.000000', 'consum', 0.0224, 'lps'),
	(594815, 131, '2014-03-15 00:11:10.000000', 'consum', 0.0213, 'lps'),
	(594816, 131, '2014-03-15 00:11:11.000000', 'consum', 0.0210, 'lps'),
	(594817, 131, '2014-03-15 00:11:12.000000', 'consum', 0.0231, 'lps'),
	(594818, 131, '2014-03-15 00:11:13.000000', 'consum', 0.0231, 'lps'),
	(594819, 131, '2014-03-15 00:11:14.000000', 'consum', 0.0225, 'lps'),
	(594820, 131, '2014-03-15 00:11:15.000000', 'consum', 0.0223, 'lps'),
	(594821, 131, '2014-03-15 00:11:16.000000', 'consum', 0.0230, 'lps'),
	(594822, 131, '2014-03-15 00:11:17.000000', 'consum', 0.0215, 'lps'),
	(594823, 131, '2014-03-15 00:11:18.000000', 'consum', 0.0230, 'lps'),
	(594824, 131, '2014-03-15 00:11:19.000000', 'consum', 0.0213, 'lps'),
	(594825, 131, '2014-03-15 00:11:20.000000', 'consum', 0.0221, 'lps'),
	(594826, 131, '2014-03-15 00:11:21.000000', 'consum', 0.0229, 'lps'),
	(594827, 131, '2014-03-15 00:11:22.000000', 'consum', 0.0216, 'lps'),
	(594828, 131, '2014-03-15 00:11:23.000000', 'consum', 0.0212, 'lps'),
	(594829, 131, '2014-03-15 00:11:24.000000', 'consum', 0.0231, 'lps'),
	(594830, 131, '2014-03-15 00:11:25.000000', 'consum', 0.0226, 'lps'),
	(594831, 131, '2014-03-15 00:11:26.000000', 'consum', 0.0229, 'lps'),
	(594832, 131, '2014-03-15 00:11:27.000000', 'consum', 0.0227, 'lps'),
	(594833, 131, '2014-03-15 00:11:28.000000', 'consum', 0.0237, 'lps'),
	(594834, 131, '2014-03-15 00:11:29.000000', 'consum', 0.0213, 'lps'),
	(594835, 131, '2014-03-15 00:11:30.000000', 'consum', 0.0227, 'lps'),
	(594836, 131, '2014-03-15 00:11:31.000000', 'consum', 0.0232, 'lps'),
	(594837, 131, '2014-03-15 00:11:32.000000', 'consum', 0.0215, 'lps'),
	(594838, 131, '2014-03-15 00:11:33.000000', 'consum', 0.0222, 'lps'),
	(594839, 131, '2014-03-15 00:11:34.000000', 'consum', 0.0228, 'lps'),
	(594840, 131, '2014-03-15 00:11:35.000000', 'consum', 0.0211, 'lps'),
	(594841, 131, '2014-03-15 00:11:36.000000', 'consum', 0.0217, 'lps'),
	(594842, 131, '2014-03-15 00:11:37.000000', 'consum', 0.0215, 'lps'),
	(594843, 131, '2014-03-15 00:11:38.000000', 'consum', 0.0216, 'lps'),
	(594844, 131, '2014-03-15 00:11:39.000000', 'consum', 0.0222, 'lps'),
	(594845, 131, '2014-03-15 00:11:40.000000', 'consum', 0.0226, 'lps'),
	(594846, 131, '2014-03-15 00:11:41.000000', 'consum', 0.0225, 'lps'),
	(594847, 131, '2014-03-15 00:11:42.000000', 'consum', 0.0212, 'lps'),
	(594848, 131, '2014-03-15 00:11:43.000000', 'consum', 0.0232, 'lps'),
	(594849, 131, '2014-03-15 00:11:44.000000', 'consum', 0.0229, 'lps'),
	(594850, 131, '2014-03-15 00:11:45.000000', 'consum', 0.0214, 'lps'),
	(594851, 131, '2014-03-15 00:11:46.000000', 'consum', 0.0226, 'lps'),
	(594852, 131, '2014-03-15 00:11:47.000000', 'consum', 0.0223, 'lps'),
	(594853, 131, '2014-03-15 00:11:48.000000', 'consum', 0.0230, 'lps'),
	(594854, 131, '2014-03-15 00:11:49.000000', 'consum', 0.0213, 'lps'),
	(594855, 131, '2014-03-15 00:11:50.000000', 'consum', 0.0224, 'lps'),
	(594856, 131, '2014-03-15 00:11:51.000000', 'consum', 0.0214, 'lps'),
	(594857, 131, '2014-03-15 00:11:52.000000', 'consum', 0.0215, 'lps'),
	(594858, 131, '2014-03-15 00:11:53.000000', 'consum', 0.0225, 'lps'),
	(594859, 131, '2014-03-15 00:11:54.000000', 'consum', 0.0216, 'lps'),
	(594860, 131, '2014-03-15 00:11:55.000000', 'consum', 0.0221, 'lps'),
	(594861, 131, '2014-03-15 00:11:56.000000', 'consum', 0.0221, 'lps'),
	(594862, 131, '2014-03-15 00:11:57.000000', 'consum', 0.0231, 'lps'),
	(594863, 131, '2014-03-15 00:11:58.000000', 'consum', 0.0228, 'lps'),
	(594864, 131, '2014-03-15 00:11:59.000000', 'consum', 0.0237, 'lps'),
	(594865, 131, '2014-03-15 00:12:00.000000', 'consum', 0.0233, 'lps'),
	(594866, 131, '2014-03-15 00:12:01.000000', 'consum', 0.0220, 'lps'),
	(594867, 131, '2014-03-15 00:12:02.000000', 'consum', 0.0218, 'lps'),
	(594868, 131, '2014-03-15 00:12:03.000000', 'consum', 0.0222, 'lps'),
	(594869, 131, '2014-03-15 00:12:04.000000', 'consum', 0.0218, 'lps'),
	(594870, 131, '2014-03-15 00:12:05.000000', 'consum', 0.0215, 'lps'),
	(594871, 131, '2014-03-15 00:12:06.000000', 'consum', 0.0213, 'lps'),
	(594872, 131, '2014-03-15 00:12:07.000000', 'consum', 0.0237, 'lps'),
	(594873, 131, '2014-03-15 00:12:08.000000', 'consum', 0.0226, 'lps'),
	(594874, 131, '2014-03-15 00:12:09.000000', 'consum', 0.0235, 'lps'),
	(594875, 131, '2014-03-15 00:12:10.000000', 'consum', 0.0231, 'lps'),
	(594876, 131, '2014-03-15 00:12:11.000000', 'consum', 0.0212, 'lps'),
	(594877, 131, '2014-03-15 00:12:12.000000', 'consum', 0.0216, 'lps'),
	(594878, 131, '2014-03-15 00:12:13.000000', 'consum', 0.0233, 'lps'),
	(594879, 131, '2014-03-15 00:12:14.000000', 'consum', 0.0222, 'lps'),
	(594880, 131, '2014-03-15 00:12:15.000000', 'consum', 0.0230, 'lps'),
	(594881, 131, '2014-03-15 00:12:16.000000', 'consum', 0.0218, 'lps'),
	(594882, 131, '2014-03-15 00:12:17.000000', 'consum', 0.0221, 'lps'),
	(594883, 131, '2014-03-15 00:12:18.000000', 'consum', 0.0210, 'lps'),
	(594884, 131, '2014-03-15 00:12:19.000000', 'consum', 0.0237, 'lps'),
	(594885, 131, '2014-03-15 00:12:20.000000', 'consum', 0.0232, 'lps'),
	(594886, 131, '2014-03-15 00:12:21.000000', 'consum', 0.0211, 'lps'),
	(594887, 131, '2014-03-15 00:12:22.000000', 'consum', 0.0235, 'lps'),
	(594888, 131, '2014-03-15 00:12:23.000000', 'consum', 0.0219, 'lps'),
	(594889, 131, '2014-03-15 00:12:24.000000', 'consum', 0.0237, 'lps'),
	(594890, 131, '2014-03-15 00:12:25.000000', 'consum', 0.0234, 'lps'),
	(594891, 131, '2014-03-15 00:12:26.000000', 'consum', 0.0220, 'lps'),
	(594892, 131, '2014-03-15 00:12:27.000000', 'consum', 0.0218, 'lps'),
	(594893, 131, '2014-03-15 00:12:28.000000', 'consum', 0.0219, 'lps'),
	(594894, 131, '2014-03-15 00:12:29.000000', 'consum', 0.0234, 'lps'),
	(594895, 131, '2014-03-15 00:12:30.000000', 'consum', 0.0220, 'lps'),
	(594896, 131, '2014-03-15 00:12:31.000000', 'consum', 0.0213, 'lps'),
	(594897, 131, '2014-03-15 00:12:32.000000', 'consum', 0.0227, 'lps'),
	(594898, 131, '2014-03-15 00:12:33.000000', 'consum', 0.0230, 'lps'),
	(594899, 131, '2014-03-15 00:12:34.000000', 'consum', 0.0232, 'lps'),
	(594900, 131, '2014-03-15 00:12:35.000000', 'consum', 0.0231, 'lps'),
	(594901, 131, '2014-03-15 00:12:36.000000', 'consum', 0.0223, 'lps'),
	(594902, 131, '2014-03-15 00:12:37.000000', 'consum', 0.0210, 'lps'),
	(594903, 131, '2014-03-15 00:12:38.000000', 'consum', 0.0230, 'lps'),
	(594904, 131, '2014-03-15 00:12:39.000000', 'consum', 0.0227, 'lps'),
	(594905, 131, '2014-03-15 00:12:40.000000', 'consum', 0.0234, 'lps'),
	(594906, 131, '2014-03-15 00:12:41.000000', 'consum', 0.0223, 'lps'),
	(594907, 131, '2014-03-15 00:12:42.000000', 'consum', 0.0234, 'lps'),
	(594908, 131, '2014-03-15 00:12:43.000000', 'consum', 0.0232, 'lps'),
	(594909, 131, '2014-03-15 00:12:44.000000', 'consum', 0.0224, 'lps'),
	(594910, 131, '2014-03-15 00:12:45.000000', 'consum', 0.0214, 'lps'),
	(594911, 131, '2014-03-15 00:12:46.000000', 'consum', 0.0215, 'lps'),
	(594912, 131, '2014-03-15 00:12:47.000000', 'consum', 0.0222, 'lps'),
	(594913, 131, '2014-03-15 00:12:48.000000', 'consum', 0.0230, 'lps'),
	(594914, 131, '2014-03-15 00:12:49.000000', 'consum', 0.0219, 'lps'),
	(594915, 131, '2014-03-15 00:12:50.000000', 'consum', 0.0222, 'lps'),
	(594916, 131, '2014-03-15 00:12:51.000000', 'consum', 0.0214, 'lps'),
	(594917, 131, '2014-03-15 00:12:52.000000', 'consum', 0.0224, 'lps'),
	(594918, 131, '2014-03-15 00:12:53.000000', 'consum', 0.0211, 'lps'),
	(594919, 131, '2014-03-15 00:12:54.000000', 'consum', 0.0231, 'lps'),
	(594920, 131, '2014-03-15 00:12:55.000000', 'consum', 0.0226, 'lps'),
	(594921, 131, '2014-03-15 00:12:56.000000', 'consum', 0.0231, 'lps'),
	(594922, 131, '2014-03-15 00:12:57.000000', 'consum', 0.0210, 'lps'),
	(594923, 131, '2014-03-15 00:12:58.000000', 'consum', 0.0231, 'lps'),
	(594924, 131, '2014-03-15 00:12:59.000000', 'consum', 0.0234, 'lps'),
	(594925, 131, '2014-03-15 00:13:00.000000', 'consum', 0.0237, 'lps'),
	(594926, 131, '2014-03-15 00:13:01.000000', 'consum', 0.0218, 'lps'),
	(594927, 131, '2014-03-15 00:13:02.000000', 'consum', 0.0227, 'lps'),
	(594928, 131, '2014-03-15 00:13:03.000000', 'consum', 0.0213, 'lps'),
	(594929, 131, '2014-03-15 00:13:04.000000', 'consum', 0.0231, 'lps'),
	(594930, 131, '2014-03-15 00:13:05.000000', 'consum', 0.0222, 'lps'),
	(594931, 131, '2014-03-15 00:13:06.000000', 'consum', 0.0236, 'lps'),
	(594932, 131, '2014-03-15 00:13:07.000000', 'consum', 0.0219, 'lps'),
	(594933, 131, '2014-03-15 00:13:08.000000', 'consum', 0.0236, 'lps'),
	(594934, 131, '2014-03-15 00:13:09.000000', 'consum', 0.0227, 'lps'),
	(594935, 131, '2014-03-15 00:13:10.000000', 'consum', 0.0217, 'lps'),
	(594936, 131, '2014-03-15 00:13:11.000000', 'consum', 0.0222, 'lps'),
	(594937, 131, '2014-03-15 00:13:12.000000', 'consum', 0.0221, 'lps'),
	(594938, 131, '2014-03-15 00:13:13.000000', 'consum', 0.0231, 'lps'),
	(594939, 131, '2014-03-15 00:13:14.000000', 'consum', 0.0226, 'lps'),
	(594940, 131, '2014-03-15 00:13:15.000000', 'consum', 0.0230, 'lps'),
	(594941, 131, '2014-03-15 00:13:16.000000', 'consum', 0.0231, 'lps'),
	(594942, 131, '2014-03-15 00:13:17.000000', 'consum', 0.0229, 'lps'),
	(594943, 131, '2014-03-15 00:13:18.000000', 'consum', 0.0212, 'lps'),
	(594944, 131, '2014-03-15 00:13:19.000000', 'consum', 0.0222, 'lps'),
	(594945, 131, '2014-03-15 00:13:20.000000', 'consum', 0.0237, 'lps'),
	(594946, 131, '2014-03-15 00:13:21.000000', 'consum', 0.0226, 'lps'),
	(594947, 131, '2014-03-15 00:13:22.000000', 'consum', 0.0236, 'lps'),
	(594948, 131, '2014-03-15 00:13:23.000000', 'consum', 0.0210, 'lps'),
	(594949, 131, '2014-03-15 00:13:24.000000', 'consum', 0.0215, 'lps'),
	(594950, 131, '2014-03-15 00:13:25.000000', 'consum', 0.0236, 'lps'),
	(594951, 131, '2014-03-15 00:13:26.000000', 'consum', 0.0212, 'lps'),
	(594952, 131, '2014-03-15 00:13:27.000000', 'consum', 0.0228, 'lps'),
	(594953, 131, '2014-03-15 00:13:28.000000', 'consum', 0.0212, 'lps'),
	(594954, 131, '2014-03-15 00:13:29.000000', 'consum', 0.0221, 'lps'),
	(594955, 131, '2014-03-15 00:13:30.000000', 'consum', 0.0231, 'lps'),
	(594956, 131, '2014-03-15 00:13:31.000000', 'consum', 0.0229, 'lps'),
	(594957, 131, '2014-03-15 00:13:32.000000', 'consum', 0.0212, 'lps'),
	(594958, 131, '2014-03-15 00:13:33.000000', 'consum', 0.0220, 'lps'),
	(594959, 131, '2014-03-15 00:13:34.000000', 'consum', 0.0227, 'lps'),
	(594960, 131, '2014-03-15 00:13:35.000000', 'consum', 0.0237, 'lps'),
	(594961, 131, '2014-03-15 00:13:36.000000', 'consum', 0.0211, 'lps'),
	(594962, 131, '2014-03-15 00:13:37.000000', 'consum', 0.0217, 'lps'),
	(594963, 131, '2014-03-15 00:13:38.000000', 'consum', 0.0217, 'lps'),
	(594964, 131, '2014-03-15 00:13:39.000000', 'consum', 0.0223, 'lps'),
	(594965, 131, '2014-03-15 00:13:40.000000', 'consum', 0.0229, 'lps'),
	(594966, 131, '2014-03-15 00:13:41.000000', 'consum', 0.0235, 'lps'),
	(594967, 131, '2014-03-15 00:13:42.000000', 'consum', 0.0226, 'lps'),
	(594968, 131, '2014-03-15 00:13:43.000000', 'consum', 0.0213, 'lps'),
	(594969, 131, '2014-03-15 00:13:44.000000', 'consum', 0.0233, 'lps'),
	(594970, 131, '2014-03-15 00:13:45.000000', 'consum', 0.0232, 'lps'),
	(594971, 131, '2014-03-15 00:13:46.000000', 'consum', 0.0223, 'lps'),
	(594972, 131, '2014-03-15 00:13:47.000000', 'consum', 0.0212, 'lps'),
	(594973, 131, '2014-03-15 00:13:48.000000', 'consum', 0.0210, 'lps'),
	(594974, 131, '2014-03-15 00:13:49.000000', 'consum', 0.0233, 'lps'),
	(594975, 131, '2014-03-15 00:13:50.000000', 'consum', 0.0212, 'lps'),
	(594976, 131, '2014-03-15 00:13:51.000000', 'consum', 0.0235, 'lps'),
	(594977, 131, '2014-03-15 00:13:52.000000', 'consum', 0.0218, 'lps'),
	(594978, 131, '2014-03-15 00:13:53.000000', 'consum', 0.0233, 'lps'),
	(594979, 131, '2014-03-15 00:13:54.000000', 'consum', 0.0218, 'lps'),
	(594980, 131, '2014-03-15 00:13:55.000000', 'consum', 0.0210, 'lps'),
	(594981, 131, '2014-03-15 00:13:56.000000', 'consum', 0.0213, 'lps'),
	(594982, 131, '2014-03-15 00:13:57.000000', 'consum', 0.0228, 'lps'),
	(594983, 131, '2014-03-15 00:13:58.000000', 'consum', 0.0232, 'lps'),
	(594984, 131, '2014-03-15 00:13:59.000000', 'consum', 0.0213, 'lps'),
	(594985, 131, '2014-03-15 00:14:00.000000', 'consum', 0.0217, 'lps'),
	(594986, 131, '2014-03-15 00:14:01.000000', 'consum', 0.0233, 'lps'),
	(594987, 131, '2014-03-15 00:14:02.000000', 'consum', 0.0222, 'lps'),
	(594988, 131, '2014-03-15 00:14:03.000000', 'consum', 0.0231, 'lps'),
	(594989, 131, '2014-03-15 00:14:04.000000', 'consum', 0.0221, 'lps'),
	(594990, 131, '2014-03-15 00:14:05.000000', 'consum', 0.0232, 'lps'),
	(594991, 131, '2014-03-15 00:14:06.000000', 'consum', 0.0229, 'lps'),
	(594992, 131, '2014-03-15 00:14:07.000000', 'consum', 0.0214, 'lps'),
	(594993, 131, '2014-03-15 00:14:08.000000', 'consum', 0.0230, 'lps'),
	(594994, 131, '2014-03-15 00:14:09.000000', 'consum', 0.0213, 'lps'),
	(594995, 131, '2014-03-15 00:14:10.000000', 'consum', 0.0221, 'lps'),
	(594996, 131, '2014-03-15 00:14:11.000000', 'consum', 0.0231, 'lps'),
	(594997, 131, '2014-03-15 00:14:12.000000', 'consum', 0.0226, 'lps'),
	(594998, 131, '2014-03-15 00:14:13.000000', 'consum', 0.0226, 'lps'),
	(594999, 131, '2014-03-15 00:14:14.000000', 'consum', 0.0217, 'lps'),
	(595000, 131, '2014-03-15 00:14:15.000000', 'consum', 0.0223, 'lps'),
	(595001, 131, '2014-03-15 00:14:16.000000', 'consum', 0.0228, 'lps'),
	(595002, 131, '2014-03-15 00:14:17.000000', 'consum', 0.0235, 'lps'),
	(595003, 131, '2014-03-15 00:14:18.000000', 'consum', 0.0224, 'lps'),
	(595004, 131, '2014-03-15 00:14:19.000000', 'consum', 0.0233, 'lps'),
	(595005, 131, '2014-03-15 00:14:20.000000', 'consum', 0.0230, 'lps'),
	(595006, 131, '2014-03-15 00:14:21.000000', 'consum', 0.0211, 'lps'),
	(595007, 131, '2014-03-15 00:14:22.000000', 'consum', 0.0211, 'lps'),
	(595008, 131, '2014-03-15 00:14:23.000000', 'consum', 0.0213, 'lps'),
	(595009, 131, '2014-03-15 00:14:24.000000', 'consum', 0.0223, 'lps'),
	(595010, 131, '2014-03-15 00:14:25.000000', 'consum', 0.0212, 'lps'),
	(595011, 131, '2014-03-15 00:14:26.000000', 'consum', 0.0235, 'lps'),
	(595012, 131, '2014-03-15 00:14:27.000000', 'consum', 0.0217, 'lps'),
	(595013, 131, '2014-03-15 00:14:28.000000', 'consum', 0.0228, 'lps'),
	(595014, 131, '2014-03-15 00:14:29.000000', 'consum', 0.0225, 'lps'),
	(595015, 131, '2014-03-15 00:14:30.000000', 'consum', 0.0231, 'lps'),
	(595016, 131, '2014-03-15 00:14:31.000000', 'consum', 0.0215, 'lps'),
	(595017, 131, '2014-03-15 00:14:32.000000', 'consum', 0.0229, 'lps'),
	(595018, 131, '2014-03-15 00:14:33.000000', 'consum', 0.0235, 'lps'),
	(595019, 131, '2014-03-15 00:14:34.000000', 'consum', 0.0223, 'lps'),
	(595020, 131, '2014-03-15 00:14:35.000000', 'consum', 0.0229, 'lps'),
	(595021, 131, '2014-03-15 00:14:36.000000', 'consum', 0.0235, 'lps'),
	(595022, 131, '2014-03-15 00:14:37.000000', 'consum', 0.0226, 'lps'),
	(595023, 131, '2014-03-15 00:14:38.000000', 'consum', 0.0216, 'lps'),
	(595024, 131, '2014-03-15 00:14:39.000000', 'consum', 0.0218, 'lps'),
	(595025, 131, '2014-03-15 00:14:40.000000', 'consum', 0.0235, 'lps'),
	(595026, 131, '2014-03-15 00:14:41.000000', 'consum', 0.0225, 'lps'),
	(595027, 131, '2014-03-15 00:14:42.000000', 'consum', 0.0210, 'lps'),
	(595028, 131, '2014-03-15 00:14:43.000000', 'consum', 0.0224, 'lps'),
	(595029, 131, '2014-03-15 00:14:44.000000', 'consum', 0.0223, 'lps'),
	(595030, 131, '2014-03-15 00:14:45.000000', 'consum', 0.0234, 'lps'),
	(595031, 131, '2014-03-15 00:14:46.000000', 'consum', 0.0236, 'lps'),
	(595032, 131, '2014-03-15 00:14:47.000000', 'consum', 0.0214, 'lps'),
	(595033, 131, '2014-03-15 00:14:48.000000', 'consum', 0.0236, 'lps'),
	(595034, 131, '2014-03-15 00:14:49.000000', 'consum', 0.0215, 'lps'),
	(595035, 131, '2014-03-15 00:14:50.000000', 'consum', 0.0213, 'lps'),
	(595036, 131, '2014-03-15 00:14:51.000000', 'consum', 0.0212, 'lps'),
	(595037, 131, '2014-03-15 00:14:52.000000', 'consum', 0.0213, 'lps'),
	(595038, 131, '2014-03-15 00:14:53.000000', 'consum', 0.0216, 'lps'),
	(595039, 131, '2014-03-15 00:14:54.000000', 'consum', 0.0233, 'lps'),
	(595040, 131, '2014-03-15 00:14:55.000000', 'consum', 0.0224, 'lps'),
	(595041, 131, '2014-03-15 00:14:56.000000', 'consum', 0.0211, 'lps'),
	(595042, 131, '2014-03-15 00:14:57.000000', 'consum', 0.0230, 'lps'),
	(595043, 131, '2014-03-15 00:14:58.000000', 'consum', 0.0225, 'lps'),
	(595044, 131, '2014-03-15 00:14:59.000000', 'consum', 0.0225, 'lps'),
	(595045, 131, '2014-03-15 00:15:00.000000', 'consum', 0.0212, 'lps'),
	(595046, 131, '2014-03-15 00:15:01.000000', 'consum', 0.0230, 'lps'),
	(595047, 131, '2014-03-15 00:15:02.000000', 'consum', 0.0221, 'lps'),
	(595048, 131, '2014-03-15 00:15:03.000000', 'consum', 0.0235, 'lps'),
	(595049, 131, '2014-03-15 00:15:04.000000', 'consum', 0.0220, 'lps'),
	(595050, 131, '2014-03-15 00:15:05.000000', 'consum', 0.0210, 'lps'),
	(595051, 131, '2014-03-15 00:15:06.000000', 'consum', 0.0211, 'lps'),
	(595052, 131, '2014-03-15 00:15:07.000000', 'consum', 0.0215, 'lps'),
	(595053, 131, '2014-03-15 00:15:08.000000', 'consum', 0.0232, 'lps'),
	(595054, 131, '2014-03-15 00:15:09.000000', 'consum', 0.0221, 'lps'),
	(595055, 131, '2014-03-15 00:15:10.000000', 'consum', 0.0227, 'lps'),
	(595056, 131, '2014-03-15 00:15:11.000000', 'consum', 0.0237, 'lps'),
	(595057, 131, '2014-03-15 00:15:12.000000', 'consum', 0.0236, 'lps'),
	(595058, 131, '2014-03-15 00:15:13.000000', 'consum', 0.0233, 'lps'),
	(595059, 131, '2014-03-15 00:15:14.000000', 'consum', 0.0219, 'lps'),
	(595060, 131, '2014-03-15 00:15:15.000000', 'consum', 0.0215, 'lps'),
	(595061, 131, '2014-03-15 00:15:16.000000', 'consum', 0.0210, 'lps'),
	(595062, 131, '2014-03-15 00:15:17.000000', 'consum', 0.0223, 'lps'),
	(595063, 131, '2014-03-15 00:15:18.000000', 'consum', 0.0219, 'lps'),
	(595064, 131, '2014-03-15 00:15:19.000000', 'consum', 0.0215, 'lps'),
	(595065, 131, '2014-03-15 00:15:20.000000', 'consum', 0.0211, 'lps'),
	(595066, 131, '2014-03-15 00:15:21.000000', 'consum', 0.0229, 'lps'),
	(595067, 131, '2014-03-15 00:15:22.000000', 'consum', 0.0219, 'lps'),
	(595068, 131, '2014-03-15 00:15:23.000000', 'consum', 0.0223, 'lps'),
	(595069, 131, '2014-03-15 00:15:24.000000', 'consum', 0.0223, 'lps'),
	(595070, 131, '2014-03-15 00:15:25.000000', 'consum', 0.0210, 'lps'),
	(595071, 131, '2014-03-15 00:15:26.000000', 'consum', 0.0224, 'lps'),
	(595072, 131, '2014-03-15 00:15:27.000000', 'consum', 0.0226, 'lps'),
	(595073, 131, '2014-03-15 00:15:28.000000', 'consum', 0.0220, 'lps'),
	(595074, 131, '2014-03-15 00:15:29.000000', 'consum', 0.0212, 'lps'),
	(595075, 131, '2014-03-15 00:15:30.000000', 'consum', 0.0221, 'lps'),
	(595076, 131, '2014-03-15 00:15:31.000000', 'consum', 0.0229, 'lps'),
	(595077, 131, '2014-03-15 00:15:32.000000', 'consum', 0.0217, 'lps'),
	(595078, 131, '2014-03-15 00:15:33.000000', 'consum', 0.0215, 'lps'),
	(595079, 131, '2014-03-15 00:15:34.000000', 'consum', 0.0217, 'lps'),
	(595080, 131, '2014-03-15 00:15:35.000000', 'consum', 0.0230, 'lps'),
	(595081, 131, '2014-03-15 00:15:36.000000', 'consum', 0.0231, 'lps'),
	(595082, 131, '2014-03-15 00:15:37.000000', 'consum', 0.0230, 'lps'),
	(595083, 131, '2014-03-15 00:15:38.000000', 'consum', 0.0217, 'lps'),
	(595084, 131, '2014-03-15 00:15:39.000000', 'consum', 0.0216, 'lps'),
	(595085, 131, '2014-03-15 00:15:40.000000', 'consum', 0.0220, 'lps'),
	(595086, 131, '2014-03-15 00:15:41.000000', 'consum', 0.0215, 'lps'),
	(595087, 131, '2014-03-15 00:15:42.000000', 'consum', 0.0231, 'lps'),
	(595088, 131, '2014-03-15 00:15:43.000000', 'consum', 0.0217, 'lps'),
	(595089, 131, '2014-03-15 00:15:44.000000', 'consum', 0.0211, 'lps'),
	(595090, 131, '2014-03-15 00:15:45.000000', 'consum', 0.0223, 'lps'),
	(595091, 131, '2014-03-15 00:15:46.000000', 'consum', 0.0218, 'lps'),
	(595092, 131, '2014-03-15 00:15:47.000000', 'consum', 0.0210, 'lps'),
	(595093, 131, '2014-03-15 00:15:48.000000', 'consum', 0.0214, 'lps'),
	(595094, 131, '2014-03-15 00:15:49.000000', 'consum', 0.0233, 'lps'),
	(595095, 131, '2014-03-15 00:15:50.000000', 'consum', 0.0227, 'lps'),
	(595096, 131, '2014-03-15 00:15:51.000000', 'consum', 0.0229, 'lps'),
	(595097, 131, '2014-03-15 00:15:52.000000', 'consum', 0.0225, 'lps'),
	(595098, 131, '2014-03-15 00:15:53.000000', 'consum', 0.0227, 'lps'),
	(595099, 131, '2014-03-15 00:15:54.000000', 'consum', 0.0223, 'lps'),
	(595100, 131, '2014-03-15 00:15:55.000000', 'consum', 0.0224, 'lps'),
	(595101, 131, '2014-03-15 00:15:56.000000', 'consum', 0.0212, 'lps'),
	(595102, 131, '2014-03-15 00:15:57.000000', 'consum', 0.0237, 'lps'),
	(595103, 131, '2014-03-15 00:15:58.000000', 'consum', 0.0225, 'lps'),
	(595104, 131, '2014-03-15 00:15:59.000000', 'consum', 0.0235, 'lps'),
	(595105, 131, '2014-03-15 00:16:00.000000', 'consum', 0.0233, 'lps'),
	(595106, 131, '2014-03-15 00:16:01.000000', 'consum', 0.0221, 'lps'),
	(595107, 131, '2014-03-15 00:16:02.000000', 'consum', 0.0226, 'lps'),
	(595108, 131, '2014-03-15 00:16:03.000000', 'consum', 0.0231, 'lps'),
	(595109, 131, '2014-03-15 00:16:04.000000', 'consum', 0.0213, 'lps'),
	(595110, 131, '2014-03-15 00:16:05.000000', 'consum', 0.0215, 'lps'),
	(595111, 131, '2014-03-15 00:16:06.000000', 'consum', 0.0226, 'lps'),
	(595112, 131, '2014-03-15 00:16:07.000000', 'consum', 0.0222, 'lps'),
	(595113, 131, '2014-03-15 00:16:08.000000', 'consum', 0.0221, 'lps'),
	(595114, 131, '2014-03-15 00:16:09.000000', 'consum', 0.0230, 'lps'),
	(595115, 131, '2014-03-15 00:16:10.000000', 'consum', 0.0221, 'lps'),
	(595116, 131, '2014-03-15 00:16:11.000000', 'consum', 0.0233, 'lps'),
	(595117, 131, '2014-03-15 00:16:12.000000', 'consum', 0.0210, 'lps'),
	(595118, 131, '2014-03-15 00:16:13.000000', 'consum', 0.0227, 'lps'),
	(595119, 131, '2014-03-15 00:16:14.000000', 'consum', 0.0237, 'lps'),
	(595120, 131, '2014-03-15 00:16:15.000000', 'consum', 0.0212, 'lps'),
	(595121, 131, '2014-03-15 00:16:16.000000', 'consum', 0.0224, 'lps'),
	(595122, 131, '2014-03-15 00:16:17.000000', 'consum', 0.0216, 'lps'),
	(595123, 131, '2014-03-15 00:16:18.000000', 'consum', 0.0229, 'lps'),
	(595124, 131, '2014-03-15 00:16:19.000000', 'consum', 0.0231, 'lps'),
	(595125, 131, '2014-03-15 00:16:20.000000', 'consum', 0.0229, 'lps'),
	(595126, 131, '2014-03-15 00:16:21.000000', 'consum', 0.0216, 'lps'),
	(595127, 131, '2014-03-15 00:16:22.000000', 'consum', 0.0211, 'lps'),
	(595128, 131, '2014-03-15 00:16:23.000000', 'consum', 0.0226, 'lps'),
	(595129, 131, '2014-03-15 00:16:24.000000', 'consum', 0.0229, 'lps'),
	(595130, 131, '2014-03-15 00:16:25.000000', 'consum', 0.0232, 'lps'),
	(595131, 131, '2014-03-15 00:16:26.000000', 'consum', 0.0235, 'lps'),
	(595132, 131, '2014-03-15 00:16:27.000000', 'consum', 0.0212, 'lps'),
	(595133, 131, '2014-03-15 00:16:28.000000', 'consum', 0.0231, 'lps'),
	(595134, 131, '2014-03-15 00:16:29.000000', 'consum', 0.0225, 'lps'),
	(595135, 131, '2014-03-15 00:16:30.000000', 'consum', 0.0221, 'lps'),
	(595136, 131, '2014-03-15 00:16:31.000000', 'consum', 0.0221, 'lps'),
	(595137, 131, '2014-03-15 00:16:32.000000', 'consum', 0.0232, 'lps'),
	(595138, 131, '2014-03-15 00:16:33.000000', 'consum', 0.0234, 'lps'),
	(595139, 131, '2014-03-15 00:16:34.000000', 'consum', 0.0236, 'lps'),
	(595140, 131, '2014-03-15 00:16:35.000000', 'consum', 0.0210, 'lps'),
	(595141, 131, '2014-03-15 00:16:36.000000', 'consum', 0.0219, 'lps'),
	(595142, 131, '2014-03-15 00:16:37.000000', 'consum', 0.0226, 'lps'),
	(595143, 131, '2014-03-15 00:16:38.000000', 'consum', 0.0234, 'lps'),
	(595144, 131, '2014-03-15 00:16:39.000000', 'consum', 0.0229, 'lps'),
	(595145, 131, '2014-03-15 00:16:40.000000', 'consum', 0.0231, 'lps'),
	(595146, 131, '2014-03-15 00:16:41.000000', 'consum', 0.0230, 'lps'),
	(595147, 131, '2014-03-15 00:16:42.000000', 'consum', 0.0221, 'lps'),
	(595148, 131, '2014-03-15 00:16:43.000000', 'consum', 0.0233, 'lps'),
	(595149, 131, '2014-03-15 00:16:44.000000', 'consum', 0.0236, 'lps'),
	(595150, 131, '2014-03-15 00:16:45.000000', 'consum', 0.0217, 'lps'),
	(595151, 131, '2014-03-15 00:16:46.000000', 'consum', 0.0222, 'lps'),
	(595152, 131, '2014-03-15 00:16:47.000000', 'consum', 0.0220, 'lps'),
	(595153, 131, '2014-03-15 00:16:48.000000', 'consum', 0.0227, 'lps'),
	(595154, 131, '2014-03-15 00:16:49.000000', 'consum', 0.0210, 'lps'),
	(595155, 131, '2014-03-15 00:16:50.000000', 'consum', 0.0213, 'lps'),
	(595156, 131, '2014-03-15 00:16:51.000000', 'consum', 0.0225, 'lps'),
	(595157, 131, '2014-03-15 00:16:52.000000', 'consum', 0.0221, 'lps'),
	(595158, 131, '2014-03-15 00:16:53.000000', 'consum', 0.0222, 'lps'),
	(595159, 131, '2014-03-15 00:16:54.000000', 'consum', 0.0236, 'lps'),
	(595160, 131, '2014-03-15 00:16:55.000000', 'consum', 0.0222, 'lps'),
	(595161, 131, '2014-03-15 00:16:56.000000', 'consum', 0.0220, 'lps'),
	(595162, 131, '2014-03-15 00:16:57.000000', 'consum', 0.0226, 'lps'),
	(595163, 131, '2014-03-15 00:16:58.000000', 'consum', 0.0232, 'lps'),
	(595164, 131, '2014-03-15 00:16:59.000000', 'consum', 0.0217, 'lps'),
	(595165, 131, '2014-03-15 00:17:00.000000', 'consum', 0.0235, 'lps'),
	(595166, 131, '2014-03-15 00:17:01.000000', 'consum', 0.0231, 'lps'),
	(595167, 131, '2014-03-15 00:17:02.000000', 'consum', 0.0213, 'lps'),
	(595168, 131, '2014-03-15 00:17:03.000000', 'consum', 0.0218, 'lps'),
	(595169, 131, '2014-03-15 00:17:04.000000', 'consum', 0.0215, 'lps'),
	(595170, 131, '2014-03-15 00:17:05.000000', 'consum', 0.0237, 'lps'),
	(595171, 131, '2014-03-15 00:17:06.000000', 'consum', 0.0222, 'lps'),
	(595172, 131, '2014-03-15 00:17:07.000000', 'consum', 0.0214, 'lps'),
	(595173, 131, '2014-03-15 00:17:08.000000', 'consum', 0.0223, 'lps'),
	(595174, 131, '2014-03-15 00:17:09.000000', 'consum', 0.0236, 'lps'),
	(595175, 131, '2014-03-15 00:17:10.000000', 'consum', 0.0218, 'lps'),
	(595176, 131, '2014-03-15 00:17:11.000000', 'consum', 0.0229, 'lps'),
	(595177, 131, '2014-03-15 00:17:12.000000', 'consum', 0.0225, 'lps'),
	(595178, 131, '2014-03-15 00:17:13.000000', 'consum', 0.0228, 'lps'),
	(595179, 131, '2014-03-15 00:17:14.000000', 'consum', 0.0229, 'lps'),
	(595180, 131, '2014-03-15 00:17:15.000000', 'consum', 0.0222, 'lps'),
	(595181, 131, '2014-03-15 00:17:16.000000', 'consum', 0.0213, 'lps'),
	(595182, 131, '2014-03-15 00:17:17.000000', 'consum', 0.0219, 'lps'),
	(595183, 131, '2014-03-15 00:17:18.000000', 'consum', 0.0219, 'lps'),
	(595184, 131, '2014-03-15 00:17:19.000000', 'consum', 0.0228, 'lps'),
	(595185, 131, '2014-03-15 00:17:20.000000', 'consum', 0.0219, 'lps'),
	(595186, 131, '2014-03-15 00:17:21.000000', 'consum', 0.0229, 'lps'),
	(595187, 131, '2014-03-15 00:17:22.000000', 'consum', 0.0221, 'lps'),
	(595188, 131, '2014-03-15 00:17:23.000000', 'consum', 0.0210, 'lps'),
	(595189, 131, '2014-03-15 00:17:24.000000', 'consum', 0.0233, 'lps'),
	(595190, 131, '2014-03-15 00:17:25.000000', 'consum', 0.0216, 'lps'),
	(595191, 131, '2014-03-15 00:17:26.000000', 'consum', 0.0224, 'lps'),
	(595192, 131, '2014-03-15 00:17:27.000000', 'consum', 0.0235, 'lps'),
	(595193, 131, '2014-03-15 00:17:28.000000', 'consum', 0.0210, 'lps'),
	(595194, 131, '2014-03-15 00:17:29.000000', 'consum', 0.0220, 'lps'),
	(595195, 131, '2014-03-15 00:17:30.000000', 'consum', 0.0233, 'lps'),
	(595196, 131, '2014-03-15 00:17:31.000000', 'consum', 0.0210, 'lps'),
	(595197, 131, '2014-03-15 00:17:32.000000', 'consum', 0.0228, 'lps'),
	(595198, 131, '2014-03-15 00:17:33.000000', 'consum', 0.0213, 'lps'),
	(595199, 131, '2014-03-15 00:17:34.000000', 'consum', 0.0231, 'lps'),
	(595200, 131, '2014-03-15 00:17:35.000000', 'consum', 0.0222, 'lps'),
	(595201, 131, '2014-03-15 00:17:36.000000', 'consum', 0.0234, 'lps'),
	(595202, 131, '2014-03-15 00:17:37.000000', 'consum', 0.0212, 'lps'),
	(595203, 131, '2014-03-15 00:17:38.000000', 'consum', 0.0231, 'lps'),
	(595204, 131, '2014-03-15 00:17:39.000000', 'consum', 0.0227, 'lps'),
	(595205, 131, '2014-03-15 00:17:40.000000', 'consum', 0.0231, 'lps'),
	(595206, 131, '2014-03-15 00:17:41.000000', 'consum', 0.0210, 'lps'),
	(595207, 131, '2014-03-15 00:17:42.000000', 'consum', 0.0231, 'lps'),
	(595208, 131, '2014-03-15 00:17:43.000000', 'consum', 0.0230, 'lps'),
	(595209, 131, '2014-03-15 00:17:44.000000', 'consum', 0.0222, 'lps'),
	(595210, 131, '2014-03-15 00:17:45.000000', 'consum', 0.0237, 'lps'),
	(595211, 131, '2014-03-15 00:17:46.000000', 'consum', 0.0225, 'lps'),
	(595212, 131, '2014-03-15 00:17:47.000000', 'consum', 0.0233, 'lps'),
	(595213, 131, '2014-03-15 00:17:48.000000', 'consum', 0.0226, 'lps'),
	(595214, 131, '2014-03-15 00:17:49.000000', 'consum', 0.0220, 'lps'),
	(595215, 131, '2014-03-15 00:17:50.000000', 'consum', 0.0211, 'lps'),
	(595216, 131, '2014-03-15 00:17:51.000000', 'consum', 0.0215, 'lps'),
	(595217, 131, '2014-03-15 00:17:52.000000', 'consum', 0.0231, 'lps'),
	(595218, 131, '2014-03-15 00:17:53.000000', 'consum', 0.0219, 'lps'),
	(595219, 131, '2014-03-15 00:17:54.000000', 'consum', 0.0218, 'lps'),
	(595220, 131, '2014-03-15 00:17:55.000000', 'consum', 0.0225, 'lps'),
	(595221, 131, '2014-03-15 00:17:56.000000', 'consum', 0.0234, 'lps'),
	(595222, 131, '2014-03-15 00:17:57.000000', 'consum', 0.0231, 'lps'),
	(595223, 131, '2014-03-15 00:17:58.000000', 'consum', 0.0214, 'lps'),
	(595224, 131, '2014-03-15 00:17:59.000000', 'consum', 0.0222, 'lps'),
	(595225, 131, '2014-03-15 00:18:00.000000', 'consum', 0.0232, 'lps'),
	(595226, 131, '2014-03-15 00:18:01.000000', 'consum', 0.0230, 'lps'),
	(595227, 131, '2014-03-15 00:18:02.000000', 'consum', 0.0214, 'lps'),
	(595228, 131, '2014-03-15 00:18:03.000000', 'consum', 0.0229, 'lps'),
	(595229, 131, '2014-03-15 00:18:04.000000', 'consum', 0.0210, 'lps'),
	(595230, 131, '2014-03-15 00:18:05.000000', 'consum', 0.0235, 'lps'),
	(595231, 131, '2014-03-15 00:18:06.000000', 'consum', 0.0223, 'lps'),
	(595232, 131, '2014-03-15 00:18:07.000000', 'consum', 0.0230, 'lps'),
	(595233, 131, '2014-03-15 00:18:08.000000', 'consum', 0.0217, 'lps'),
	(595234, 131, '2014-03-15 00:18:09.000000', 'consum', 0.0214, 'lps'),
	(595235, 131, '2014-03-15 00:18:10.000000', 'consum', 0.0234, 'lps'),
	(595236, 131, '2014-03-15 00:18:11.000000', 'consum', 0.0237, 'lps'),
	(595237, 131, '2014-03-15 00:18:12.000000', 'consum', 0.0217, 'lps'),
	(595238, 131, '2014-03-15 00:18:13.000000', 'consum', 0.0220, 'lps'),
	(595239, 131, '2014-03-15 00:18:14.000000', 'consum', 0.0213, 'lps'),
	(595240, 131, '2014-03-15 00:18:15.000000', 'consum', 0.0225, 'lps'),
	(595241, 131, '2014-03-15 00:18:16.000000', 'consum', 0.0217, 'lps'),
	(595242, 131, '2014-03-15 00:18:17.000000', 'consum', 0.0230, 'lps'),
	(595243, 131, '2014-03-15 00:18:18.000000', 'consum', 0.0231, 'lps'),
	(595244, 131, '2014-03-15 00:18:19.000000', 'consum', 0.0231, 'lps'),
	(595245, 131, '2014-03-15 00:18:20.000000', 'consum', 0.0221, 'lps'),
	(595246, 131, '2014-03-15 00:18:21.000000', 'consum', 0.0234, 'lps'),
	(595247, 131, '2014-03-15 00:18:22.000000', 'consum', 0.0212, 'lps'),
	(595248, 131, '2014-03-15 00:18:23.000000', 'consum', 0.0233, 'lps'),
	(595249, 131, '2014-03-15 00:18:24.000000', 'consum', 0.0236, 'lps'),
	(595250, 131, '2014-03-15 00:18:25.000000', 'consum', 0.0217, 'lps'),
	(595251, 131, '2014-03-15 00:18:26.000000', 'consum', 0.0222, 'lps'),
	(595252, 131, '2014-03-15 00:18:27.000000', 'consum', 0.0223, 'lps'),
	(595253, 131, '2014-03-15 00:18:28.000000', 'consum', 0.0212, 'lps'),
	(595254, 131, '2014-03-15 00:18:29.000000', 'consum', 0.0237, 'lps'),
	(595255, 131, '2014-03-15 00:18:30.000000', 'consum', 0.0229, 'lps'),
	(595256, 131, '2014-03-15 00:18:31.000000', 'consum', 0.0222, 'lps'),
	(595257, 131, '2014-03-15 00:18:32.000000', 'consum', 0.0216, 'lps'),
	(595258, 131, '2014-03-15 00:18:33.000000', 'consum', 0.0232, 'lps'),
	(595259, 131, '2014-03-15 00:18:34.000000', 'consum', 0.0217, 'lps'),
	(595260, 131, '2014-03-15 00:18:35.000000', 'consum', 0.0234, 'lps'),
	(595261, 131, '2014-03-15 00:18:36.000000', 'consum', 0.0227, 'lps'),
	(595262, 131, '2014-03-15 00:18:37.000000', 'consum', 0.0225, 'lps'),
	(595263, 131, '2014-03-15 00:18:38.000000', 'consum', 0.0235, 'lps'),
	(595264, 131, '2014-03-15 00:18:39.000000', 'consum', 0.0233, 'lps'),
	(595265, 131, '2014-03-15 00:18:40.000000', 'consum', 0.0222, 'lps'),
	(595266, 131, '2014-03-15 00:18:41.000000', 'consum', 0.0230, 'lps'),
	(595267, 131, '2014-03-15 00:18:42.000000', 'consum', 0.0219, 'lps'),
	(595268, 131, '2014-03-15 00:18:43.000000', 'consum', 0.0225, 'lps'),
	(595269, 131, '2014-03-15 00:18:44.000000', 'consum', 0.0229, 'lps'),
	(595270, 131, '2014-03-15 00:18:45.000000', 'consum', 0.0234, 'lps'),
	(595271, 131, '2014-03-15 00:18:46.000000', 'consum', 0.0218, 'lps'),
	(595272, 131, '2014-03-15 00:18:47.000000', 'consum', 0.0235, 'lps'),
	(595273, 131, '2014-03-15 00:18:48.000000', 'consum', 0.0228, 'lps'),
	(595274, 131, '2014-03-15 00:18:49.000000', 'consum', 0.0223, 'lps'),
	(595275, 131, '2014-03-15 00:18:50.000000', 'consum', 0.0221, 'lps'),
	(595276, 131, '2014-03-15 00:18:51.000000', 'consum', 0.0227, 'lps'),
	(595277, 131, '2014-03-15 00:18:52.000000', 'consum', 0.0235, 'lps'),
	(595278, 131, '2014-03-15 00:18:53.000000', 'consum', 0.0228, 'lps'),
	(595279, 131, '2014-03-15 00:18:54.000000', 'consum', 0.0225, 'lps'),
	(595280, 131, '2014-03-15 00:18:55.000000', 'consum', 0.0231, 'lps'),
	(595281, 131, '2014-03-15 00:18:56.000000', 'consum', 0.0217, 'lps'),
	(595282, 131, '2014-03-15 00:18:57.000000', 'consum', 0.0235, 'lps'),
	(595283, 131, '2014-03-15 00:18:58.000000', 'consum', 0.0233, 'lps'),
	(595284, 131, '2014-03-15 00:18:59.000000', 'consum', 0.0222, 'lps'),
	(595285, 131, '2014-03-15 00:19:00.000000', 'consum', 0.0230, 'lps'),
	(595286, 131, '2014-03-15 00:19:01.000000', 'consum', 0.0217, 'lps'),
	(595287, 131, '2014-03-15 00:19:02.000000', 'consum', 0.0215, 'lps'),
	(595288, 131, '2014-03-15 00:19:03.000000', 'consum', 0.0212, 'lps'),
	(595289, 131, '2014-03-15 00:19:04.000000', 'consum', 0.0237, 'lps'),
	(595290, 131, '2014-03-15 00:19:05.000000', 'consum', 0.0224, 'lps'),
	(595291, 131, '2014-03-15 00:19:06.000000', 'consum', 0.0231, 'lps'),
	(595292, 131, '2014-03-15 00:19:07.000000', 'consum', 0.0214, 'lps'),
	(595293, 131, '2014-03-15 00:19:08.000000', 'consum', 0.0225, 'lps'),
	(595294, 131, '2014-03-15 00:19:09.000000', 'consum', 0.0216, 'lps'),
	(595295, 131, '2014-03-15 00:19:10.000000', 'consum', 0.0224, 'lps'),
	(595296, 131, '2014-03-15 00:19:11.000000', 'consum', 0.0235, 'lps'),
	(595297, 131, '2014-03-15 00:19:12.000000', 'consum', 0.0237, 'lps'),
	(595298, 131, '2014-03-15 00:19:13.000000', 'consum', 0.0214, 'lps'),
	(595299, 131, '2014-03-15 00:19:14.000000', 'consum', 0.0233, 'lps'),
	(595300, 131, '2014-03-15 00:19:15.000000', 'consum', 0.0231, 'lps'),
	(595301, 131, '2014-03-15 00:19:16.000000', 'consum', 0.0218, 'lps'),
	(595302, 131, '2014-03-15 00:19:17.000000', 'consum', 0.0215, 'lps'),
	(595303, 131, '2014-03-15 00:19:18.000000', 'consum', 0.0213, 'lps'),
	(595304, 131, '2014-03-15 00:19:19.000000', 'consum', 0.0211, 'lps'),
	(595305, 131, '2014-03-15 00:19:20.000000', 'consum', 0.0234, 'lps'),
	(595306, 131, '2014-03-15 00:19:21.000000', 'consum', 0.0216, 'lps'),
	(595307, 131, '2014-03-15 00:19:22.000000', 'consum', 0.0223, 'lps'),
	(595308, 131, '2014-03-15 00:19:23.000000', 'consum', 0.0229, 'lps'),
	(595309, 131, '2014-03-15 00:19:24.000000', 'consum', 0.0212, 'lps'),
	(595310, 131, '2014-03-15 00:19:25.000000', 'consum', 0.0220, 'lps'),
	(595311, 131, '2014-03-15 00:19:26.000000', 'consum', 0.0226, 'lps'),
	(595312, 131, '2014-03-15 00:19:27.000000', 'consum', 0.0231, 'lps'),
	(595313, 131, '2014-03-15 00:19:28.000000', 'consum', 0.0211, 'lps'),
	(595314, 131, '2014-03-15 00:19:29.000000', 'consum', 0.0210, 'lps'),
	(595315, 131, '2014-03-15 00:19:30.000000', 'consum', 0.0233, 'lps'),
	(595316, 131, '2014-03-15 00:19:31.000000', 'consum', 0.0216, 'lps'),
	(595317, 131, '2014-03-15 00:19:32.000000', 'consum', 0.0226, 'lps'),
	(595318, 131, '2014-03-15 00:19:33.000000', 'consum', 0.0218, 'lps'),
	(595319, 131, '2014-03-15 00:19:34.000000', 'consum', 0.0232, 'lps'),
	(595320, 131, '2014-03-15 00:19:35.000000', 'consum', 0.0210, 'lps'),
	(595321, 131, '2014-03-15 00:19:36.000000', 'consum', 0.0229, 'lps'),
	(595322, 131, '2014-03-15 00:19:37.000000', 'consum', 0.0223, 'lps'),
	(595323, 131, '2014-03-15 00:19:38.000000', 'consum', 0.0219, 'lps'),
	(595324, 131, '2014-03-15 00:19:39.000000', 'consum', 0.0216, 'lps'),
	(595325, 131, '2014-03-15 00:19:40.000000', 'consum', 0.0213, 'lps'),
	(595326, 131, '2014-03-15 00:19:41.000000', 'consum', 0.0234, 'lps'),
	(595327, 131, '2014-03-15 00:19:42.000000', 'consum', 0.0212, 'lps'),
	(595328, 131, '2014-03-15 00:19:43.000000', 'consum', 0.0230, 'lps'),
	(595329, 131, '2014-03-15 00:19:44.000000', 'consum', 0.0221, 'lps'),
	(595330, 131, '2014-03-15 00:19:45.000000', 'consum', 0.0233, 'lps'),
	(595331, 131, '2014-03-15 00:19:46.000000', 'consum', 0.0236, 'lps'),
	(595332, 131, '2014-03-15 00:19:47.000000', 'consum', 0.0216, 'lps'),
	(595333, 131, '2014-03-15 00:19:48.000000', 'consum', 0.0217, 'lps'),
	(595334, 131, '2014-03-15 00:19:49.000000', 'consum', 0.0228, 'lps'),
	(595335, 131, '2014-03-15 00:19:50.000000', 'consum', 0.0224, 'lps'),
	(595336, 131, '2014-03-15 00:19:51.000000', 'consum', 0.0225, 'lps'),
	(595337, 131, '2014-03-15 00:19:52.000000', 'consum', 0.0218, 'lps'),
	(595338, 131, '2014-03-15 00:19:53.000000', 'consum', 0.0234, 'lps'),
	(595339, 131, '2014-03-15 00:19:54.000000', 'consum', 0.0223, 'lps'),
	(595340, 131, '2014-03-15 00:19:55.000000', 'consum', 0.0232, 'lps'),
	(595341, 131, '2014-03-15 00:19:56.000000', 'consum', 0.0224, 'lps'),
	(595342, 131, '2014-03-15 00:19:57.000000', 'consum', 0.0214, 'lps'),
	(595343, 131, '2014-03-15 00:19:58.000000', 'consum', 0.0215, 'lps'),
	(595344, 131, '2014-03-15 00:19:59.000000', 'consum', 0.0226, 'lps'),
	(595345, 131, '2014-03-15 00:20:00.000000', 'consum', 0.0218, 'lps'),
	(595346, 131, '2014-03-15 00:20:01.000000', 'consum', 0.0232, 'lps'),
	(595347, 131, '2014-03-15 00:20:02.000000', 'consum', 0.0211, 'lps'),
	(595348, 131, '2014-03-15 00:20:03.000000', 'consum', 0.0234, 'lps'),
	(595349, 131, '2014-03-15 00:20:04.000000', 'consum', 0.0215, 'lps'),
	(595350, 131, '2014-03-15 00:20:05.000000', 'consum', 0.0222, 'lps'),
	(595351, 131, '2014-03-15 00:20:06.000000', 'consum', 0.0225, 'lps'),
	(595352, 131, '2014-03-15 00:20:07.000000', 'consum', 0.0220, 'lps'),
	(595353, 131, '2014-03-15 00:20:08.000000', 'consum', 0.0217, 'lps'),
	(595354, 131, '2014-03-15 00:20:09.000000', 'consum', 0.0217, 'lps'),
	(595355, 131, '2014-03-15 00:20:10.000000', 'consum', 0.0225, 'lps'),
	(595356, 131, '2014-03-15 00:20:11.000000', 'consum', 0.0234, 'lps'),
	(595357, 131, '2014-03-15 00:20:12.000000', 'consum', 0.0230, 'lps'),
	(595358, 131, '2014-03-15 00:20:13.000000', 'consum', 0.0210, 'lps'),
	(595359, 131, '2014-03-15 00:20:14.000000', 'consum', 0.0235, 'lps'),
	(595360, 131, '2014-03-15 00:20:15.000000', 'consum', 0.0223, 'lps'),
	(595361, 131, '2014-03-15 00:20:16.000000', 'consum', 0.0228, 'lps'),
	(595362, 131, '2014-03-15 00:20:17.000000', 'consum', 0.0233, 'lps'),
	(595363, 131, '2014-03-15 00:20:18.000000', 'consum', 0.0216, 'lps'),
	(595364, 131, '2014-03-15 00:20:19.000000', 'consum', 0.0227, 'lps'),
	(595365, 131, '2014-03-15 00:20:20.000000', 'consum', 0.0222, 'lps'),
	(595366, 131, '2014-03-15 00:20:21.000000', 'consum', 0.0218, 'lps'),
	(595367, 131, '2014-03-15 00:20:22.000000', 'consum', 0.0216, 'lps'),
	(595368, 131, '2014-03-15 00:20:23.000000', 'consum', 0.0217, 'lps'),
	(595369, 131, '2014-03-15 00:20:24.000000', 'consum', 0.0227, 'lps'),
	(595370, 131, '2014-03-15 00:20:25.000000', 'consum', 0.0220, 'lps'),
	(595371, 131, '2014-03-15 00:20:26.000000', 'consum', 0.0234, 'lps'),
	(595372, 131, '2014-03-15 00:20:27.000000', 'consum', 0.0220, 'lps'),
	(595373, 131, '2014-03-15 00:20:28.000000', 'consum', 0.0215, 'lps'),
	(595374, 131, '2014-03-15 00:20:29.000000', 'consum', 0.0236, 'lps'),
	(595375, 131, '2014-03-15 00:20:30.000000', 'consum', 0.0210, 'lps'),
	(595376, 131, '2014-03-15 00:20:31.000000', 'consum', 0.0220, 'lps'),
	(595377, 131, '2014-03-15 00:20:32.000000', 'consum', 0.0230, 'lps'),
	(595378, 131, '2014-03-15 00:20:33.000000', 'consum', 0.0226, 'lps'),
	(595379, 131, '2014-03-15 00:20:34.000000', 'consum', 0.0231, 'lps'),
	(595380, 131, '2014-03-15 00:20:35.000000', 'consum', 0.0212, 'lps'),
	(595381, 131, '2014-03-15 00:20:36.000000', 'consum', 0.0214, 'lps'),
	(595382, 131, '2014-03-15 00:20:37.000000', 'consum', 0.0226, 'lps'),
	(595383, 131, '2014-03-15 00:20:38.000000', 'consum', 0.0219, 'lps'),
	(595384, 131, '2014-03-15 00:20:39.000000', 'consum', 0.0235, 'lps'),
	(595385, 131, '2014-03-15 00:20:40.000000', 'consum', 0.0227, 'lps'),
	(595386, 131, '2014-03-15 00:20:41.000000', 'consum', 0.0219, 'lps'),
	(595387, 131, '2014-03-15 00:20:42.000000', 'consum', 0.0231, 'lps'),
	(595388, 131, '2014-03-15 00:20:43.000000', 'consum', 0.0236, 'lps'),
	(595389, 131, '2014-03-15 00:20:44.000000', 'consum', 0.0220, 'lps'),
	(595390, 131, '2014-03-15 00:20:45.000000', 'consum', 0.0210, 'lps'),
	(595391, 131, '2014-03-15 00:20:46.000000', 'consum', 0.0237, 'lps'),
	(595392, 131, '2014-03-15 00:20:47.000000', 'consum', 0.0234, 'lps'),
	(595393, 131, '2014-03-15 00:20:48.000000', 'consum', 0.0220, 'lps'),
	(595394, 131, '2014-03-15 00:20:49.000000', 'consum', 0.0219, 'lps'),
	(595395, 131, '2014-03-15 00:20:50.000000', 'consum', 0.0226, 'lps'),
	(595396, 131, '2014-03-15 00:20:51.000000', 'consum', 0.0232, 'lps'),
	(595397, 131, '2014-03-15 00:20:52.000000', 'consum', 0.0219, 'lps'),
	(595398, 131, '2014-03-15 00:20:53.000000', 'consum', 0.0218, 'lps'),
	(595399, 131, '2014-03-15 00:20:54.000000', 'consum', 0.0224, 'lps'),
	(595400, 131, '2014-03-15 00:20:55.000000', 'consum', 0.0229, 'lps'),
	(595401, 131, '2014-03-15 00:20:56.000000', 'consum', 0.0233, 'lps'),
	(595402, 131, '2014-03-15 00:20:57.000000', 'consum', 0.0213, 'lps'),
	(595403, 131, '2014-03-15 00:20:58.000000', 'consum', 0.0214, 'lps'),
	(595404, 131, '2014-03-15 00:20:59.000000', 'consum', 0.0219, 'lps'),
	(595405, 131, '2014-03-15 00:21:00.000000', 'consum', 0.0217, 'lps'),
	(595406, 131, '2014-03-15 00:21:01.000000', 'consum', 0.0219, 'lps'),
	(595407, 131, '2014-03-15 00:21:02.000000', 'consum', 0.0233, 'lps'),
	(595408, 131, '2014-03-15 00:21:03.000000', 'consum', 0.0213, 'lps'),
	(595409, 131, '2014-03-15 00:21:04.000000', 'consum', 0.0216, 'lps'),
	(595410, 131, '2014-03-15 00:21:05.000000', 'consum', 0.0230, 'lps'),
	(595411, 131, '2014-03-15 00:21:06.000000', 'consum', 0.0237, 'lps'),
	(595412, 131, '2014-03-15 00:21:07.000000', 'consum', 0.0231, 'lps'),
	(595413, 131, '2014-03-15 00:21:08.000000', 'consum', 0.0234, 'lps'),
	(595414, 131, '2014-03-15 00:21:09.000000', 'consum', 0.0237, 'lps'),
	(595415, 131, '2014-03-15 00:21:10.000000', 'consum', 0.0219, 'lps'),
	(595416, 131, '2014-03-15 00:21:11.000000', 'consum', 0.0231, 'lps'),
	(595417, 131, '2014-03-15 00:21:12.000000', 'consum', 0.0233, 'lps'),
	(595418, 131, '2014-03-15 00:21:13.000000', 'consum', 0.0233, 'lps'),
	(595419, 131, '2014-03-15 00:21:14.000000', 'consum', 0.0230, 'lps'),
	(595420, 131, '2014-03-15 00:21:15.000000', 'consum', 0.0213, 'lps'),
	(595421, 131, '2014-03-15 00:21:16.000000', 'consum', 0.0222, 'lps'),
	(595422, 131, '2014-03-15 00:21:17.000000', 'consum', 0.0233, 'lps'),
	(595423, 131, '2014-03-15 00:21:18.000000', 'consum', 0.0232, 'lps'),
	(595424, 131, '2014-03-15 00:21:19.000000', 'consum', 0.0225, 'lps'),
	(595425, 131, '2014-03-15 00:21:20.000000', 'consum', 0.0218, 'lps'),
	(595426, 131, '2014-03-15 00:21:21.000000', 'consum', 0.0233, 'lps'),
	(595427, 131, '2014-03-15 00:21:22.000000', 'consum', 0.0217, 'lps'),
	(595428, 131, '2014-03-15 00:21:23.000000', 'consum', 0.0232, 'lps'),
	(595429, 131, '2014-03-15 00:21:24.000000', 'consum', 0.0215, 'lps'),
	(595430, 131, '2014-03-15 00:21:25.000000', 'consum', 0.0226, 'lps'),
	(595431, 131, '2014-03-15 00:21:26.000000', 'consum', 0.0220, 'lps'),
	(595432, 131, '2014-03-15 00:21:27.000000', 'consum', 0.0214, 'lps'),
	(595433, 131, '2014-03-15 00:21:28.000000', 'consum', 0.0228, 'lps'),
	(595434, 131, '2014-03-15 00:21:29.000000', 'consum', 0.0230, 'lps'),
	(595435, 131, '2014-03-15 00:21:30.000000', 'consum', 0.0230, 'lps'),
	(595436, 131, '2014-03-15 00:21:31.000000', 'consum', 0.0221, 'lps'),
	(595437, 131, '2014-03-15 00:21:32.000000', 'consum', 0.0235, 'lps'),
	(595438, 131, '2014-03-15 00:21:33.000000', 'consum', 0.0219, 'lps'),
	(595439, 131, '2014-03-15 00:21:34.000000', 'consum', 0.0237, 'lps'),
	(595440, 131, '2014-03-15 00:21:35.000000', 'consum', 0.0235, 'lps'),
	(595441, 131, '2014-03-15 00:21:36.000000', 'consum', 0.0225, 'lps'),
	(595442, 131, '2014-03-15 00:21:37.000000', 'consum', 0.0210, 'lps'),
	(595443, 131, '2014-03-15 00:21:38.000000', 'consum', 0.0220, 'lps'),
	(595444, 131, '2014-03-15 00:21:39.000000', 'consum', 0.0235, 'lps'),
	(595445, 131, '2014-03-15 00:21:40.000000', 'consum', 0.0220, 'lps'),
	(595446, 131, '2014-03-15 00:21:41.000000', 'consum', 0.0215, 'lps'),
	(595447, 131, '2014-03-15 00:21:42.000000', 'consum', 0.0232, 'lps'),
	(595448, 131, '2014-03-15 00:21:43.000000', 'consum', 0.0223, 'lps'),
	(595449, 131, '2014-03-15 00:21:44.000000', 'consum', 0.0236, 'lps'),
	(595450, 131, '2014-03-15 00:21:45.000000', 'consum', 0.0216, 'lps'),
	(595451, 131, '2014-03-15 00:21:46.000000', 'consum', 0.0222, 'lps'),
	(595452, 131, '2014-03-15 00:21:47.000000', 'consum', 0.0223, 'lps'),
	(595453, 131, '2014-03-15 00:21:48.000000', 'consum', 0.0213, 'lps'),
	(595454, 131, '2014-03-15 00:21:49.000000', 'consum', 0.0213, 'lps'),
	(595455, 131, '2014-03-15 00:21:50.000000', 'consum', 0.0215, 'lps'),
	(595456, 131, '2014-03-15 00:21:51.000000', 'consum', 0.0230, 'lps'),
	(595457, 131, '2014-03-15 00:21:52.000000', 'consum', 0.0237, 'lps'),
	(595458, 131, '2014-03-15 00:21:53.000000', 'consum', 0.0232, 'lps'),
	(595459, 131, '2014-03-15 00:21:54.000000', 'consum', 0.0212, 'lps'),
	(595460, 131, '2014-03-15 00:21:55.000000', 'consum', 0.0235, 'lps'),
	(595461, 131, '2014-03-15 00:21:56.000000', 'consum', 0.0220, 'lps'),
	(595462, 131, '2014-03-15 00:21:57.000000', 'consum', 0.0214, 'lps'),
	(595463, 131, '2014-03-15 00:21:58.000000', 'consum', 0.0227, 'lps'),
	(595464, 131, '2014-03-15 00:21:59.000000', 'consum', 0.0229, 'lps'),
	(595465, 131, '2014-03-15 00:22:00.000000', 'consum', 0.0227, 'lps'),
	(595466, 131, '2014-03-15 00:22:01.000000', 'consum', 0.0211, 'lps'),
	(595467, 131, '2014-03-15 00:22:02.000000', 'consum', 0.0218, 'lps'),
	(595468, 131, '2014-03-15 00:22:03.000000', 'consum', 0.0220, 'lps'),
	(595469, 131, '2014-03-15 00:22:04.000000', 'consum', 0.0210, 'lps'),
	(595470, 131, '2014-03-15 00:22:05.000000', 'consum', 0.0234, 'lps'),
	(595471, 131, '2014-03-15 00:22:06.000000', 'consum', 0.0220, 'lps'),
	(595472, 131, '2014-03-15 00:22:07.000000', 'consum', 0.0215, 'lps'),
	(595473, 131, '2014-03-15 00:22:08.000000', 'consum', 0.0233, 'lps'),
	(595474, 131, '2014-03-15 00:22:09.000000', 'consum', 0.0228, 'lps'),
	(595475, 131, '2014-03-15 00:22:10.000000', 'consum', 0.0229, 'lps'),
	(595476, 131, '2014-03-15 00:22:11.000000', 'consum', 0.0225, 'lps'),
	(595477, 131, '2014-03-15 00:22:12.000000', 'consum', 0.0230, 'lps'),
	(595478, 131, '2014-03-15 00:22:13.000000', 'consum', 0.0210, 'lps'),
	(595479, 131, '2014-03-15 00:22:14.000000', 'consum', 0.0234, 'lps'),
	(595480, 131, '2014-03-15 00:22:15.000000', 'consum', 0.0220, 'lps'),
	(595481, 131, '2014-03-15 00:22:16.000000', 'consum', 0.0215, 'lps'),
	(595482, 131, '2014-03-15 00:22:17.000000', 'consum', 0.0234, 'lps'),
	(595483, 131, '2014-03-15 00:22:18.000000', 'consum', 0.0231, 'lps'),
	(595484, 131, '2014-03-15 00:22:19.000000', 'consum', 0.0217, 'lps'),
	(595485, 131, '2014-03-15 00:22:20.000000', 'consum', 0.0210, 'lps'),
	(595486, 131, '2014-03-15 00:22:21.000000', 'consum', 0.0216, 'lps'),
	(595487, 131, '2014-03-15 00:22:22.000000', 'consum', 0.0215, 'lps'),
	(595488, 131, '2014-03-15 00:22:23.000000', 'consum', 0.0216, 'lps'),
	(595489, 131, '2014-03-15 00:22:24.000000', 'consum', 0.0224, 'lps'),
	(595490, 131, '2014-03-15 00:22:25.000000', 'consum', 0.0235, 'lps'),
	(595491, 131, '2014-03-15 00:22:26.000000', 'consum', 0.0212, 'lps'),
	(595492, 131, '2014-03-15 00:22:27.000000', 'consum', 0.0229, 'lps'),
	(595493, 131, '2014-03-15 00:22:28.000000', 'consum', 0.0213, 'lps'),
	(595494, 131, '2014-03-15 00:22:29.000000', 'consum', 0.0226, 'lps'),
	(595495, 131, '2014-03-15 00:22:30.000000', 'consum', 0.0224, 'lps'),
	(595496, 131, '2014-03-15 00:22:31.000000', 'consum', 0.0233, 'lps'),
	(595497, 131, '2014-03-15 00:22:32.000000', 'consum', 0.0228, 'lps'),
	(595498, 131, '2014-03-15 00:22:33.000000', 'consum', 0.0232, 'lps'),
	(595499, 131, '2014-03-15 00:22:34.000000', 'consum', 0.0211, 'lps'),
	(595500, 131, '2014-03-15 00:22:35.000000', 'consum', 0.0234, 'lps'),
	(595501, 131, '2014-03-15 00:22:36.000000', 'consum', 0.0214, 'lps'),
	(595502, 131, '2014-03-15 00:22:37.000000', 'consum', 0.0215, 'lps'),
	(595503, 131, '2014-03-15 00:22:38.000000', 'consum', 0.0223, 'lps'),
	(595504, 131, '2014-03-15 00:22:39.000000', 'consum', 0.0233, 'lps'),
	(595505, 131, '2014-03-15 00:22:40.000000', 'consum', 0.0232, 'lps'),
	(595506, 131, '2014-03-15 00:22:41.000000', 'consum', 0.0220, 'lps'),
	(595507, 131, '2014-03-15 00:22:42.000000', 'consum', 0.0225, 'lps'),
	(595508, 131, '2014-03-15 00:22:43.000000', 'consum', 0.0229, 'lps'),
	(595509, 131, '2014-03-15 00:22:44.000000', 'consum', 0.0230, 'lps'),
	(595510, 131, '2014-03-15 00:22:45.000000', 'consum', 0.0225, 'lps'),
	(595511, 131, '2014-03-15 00:22:46.000000', 'consum', 0.0226, 'lps'),
	(595512, 131, '2014-03-15 00:22:47.000000', 'consum', 0.0218, 'lps'),
	(595513, 131, '2014-03-15 00:22:48.000000', 'consum', 0.0231, 'lps'),
	(595514, 131, '2014-03-15 00:22:49.000000', 'consum', 0.0234, 'lps'),
	(595515, 131, '2014-03-15 00:22:50.000000', 'consum', 0.0212, 'lps'),
	(595516, 131, '2014-03-15 00:22:51.000000', 'consum', 0.0231, 'lps'),
	(595517, 131, '2014-03-15 00:22:52.000000', 'consum', 0.0225, 'lps'),
	(595518, 131, '2014-03-15 00:22:53.000000', 'consum', 0.0224, 'lps'),
	(595519, 131, '2014-03-15 00:22:54.000000', 'consum', 0.0235, 'lps'),
	(595520, 131, '2014-03-15 00:22:55.000000', 'consum', 0.0210, 'lps'),
	(595521, 131, '2014-03-15 00:22:56.000000', 'consum', 0.0219, 'lps'),
	(595522, 131, '2014-03-15 00:22:57.000000', 'consum', 0.0230, 'lps'),
	(595523, 131, '2014-03-15 00:22:58.000000', 'consum', 0.0225, 'lps'),
	(595524, 131, '2014-03-15 00:22:59.000000', 'consum', 0.0225, 'lps'),
	(595525, 131, '2014-03-15 00:23:00.000000', 'consum', 0.0214, 'lps'),
	(595526, 131, '2014-03-15 00:23:01.000000', 'consum', 0.0212, 'lps'),
	(595527, 131, '2014-03-15 00:23:02.000000', 'consum', 0.0211, 'lps'),
	(595528, 131, '2014-03-15 00:23:03.000000', 'consum', 0.0236, 'lps'),
	(595529, 131, '2014-03-15 00:23:04.000000', 'consum', 0.0226, 'lps'),
	(595530, 131, '2014-03-15 00:23:05.000000', 'consum', 0.0212, 'lps'),
	(595531, 131, '2014-03-15 00:23:06.000000', 'consum', 0.0231, 'lps'),
	(595532, 131, '2014-03-15 00:23:07.000000', 'consum', 0.0223, 'lps'),
	(595533, 131, '2014-03-15 00:23:08.000000', 'consum', 0.0213, 'lps'),
	(595534, 131, '2014-03-15 00:23:09.000000', 'consum', 0.0214, 'lps'),
	(595535, 131, '2014-03-15 00:23:10.000000', 'consum', 0.0220, 'lps'),
	(595536, 131, '2014-03-15 00:23:11.000000', 'consum', 0.0224, 'lps'),
	(595537, 131, '2014-03-15 00:23:12.000000', 'consum', 0.0220, 'lps'),
	(595538, 131, '2014-03-15 00:23:13.000000', 'consum', 0.0221, 'lps'),
	(595539, 131, '2014-03-15 00:23:14.000000', 'consum', 0.0235, 'lps'),
	(595540, 131, '2014-03-15 00:23:15.000000', 'consum', 0.0219, 'lps'),
	(595541, 131, '2014-03-15 00:23:16.000000', 'consum', 0.0237, 'lps'),
	(595542, 131, '2014-03-15 00:23:17.000000', 'consum', 0.0233, 'lps'),
	(595543, 131, '2014-03-15 00:23:18.000000', 'consum', 0.0218, 'lps'),
	(595544, 131, '2014-03-15 00:23:19.000000', 'consum', 0.0237, 'lps'),
	(595545, 131, '2014-03-15 00:23:20.000000', 'consum', 0.0211, 'lps'),
	(595546, 131, '2014-03-15 00:23:21.000000', 'consum', 0.0218, 'lps'),
	(595547, 131, '2014-03-15 00:23:22.000000', 'consum', 0.0221, 'lps'),
	(595548, 131, '2014-03-15 00:23:23.000000', 'consum', 0.0210, 'lps'),
	(595549, 131, '2014-03-15 00:23:24.000000', 'consum', 0.0236, 'lps'),
	(595550, 131, '2014-03-15 00:23:25.000000', 'consum', 0.0228, 'lps'),
	(595551, 131, '2014-03-15 00:23:26.000000', 'consum', 0.0224, 'lps'),
	(595552, 131, '2014-03-15 00:23:27.000000', 'consum', 0.0227, 'lps'),
	(595553, 131, '2014-03-15 00:23:28.000000', 'consum', 0.0226, 'lps'),
	(595554, 131, '2014-03-15 00:23:29.000000', 'consum', 0.0211, 'lps'),
	(595555, 131, '2014-03-15 00:23:30.000000', 'consum', 0.0221, 'lps'),
	(595556, 131, '2014-03-15 00:23:31.000000', 'consum', 0.0237, 'lps'),
	(595557, 131, '2014-03-15 00:23:32.000000', 'consum', 0.0228, 'lps'),
	(595558, 131, '2014-03-15 00:23:33.000000', 'consum', 0.0219, 'lps'),
	(595559, 131, '2014-03-15 00:23:34.000000', 'consum', 0.0229, 'lps'),
	(595560, 131, '2014-03-15 00:23:35.000000', 'consum', 0.0221, 'lps'),
	(595561, 131, '2014-03-15 00:23:36.000000', 'consum', 0.0211, 'lps'),
	(595562, 131, '2014-03-15 00:23:37.000000', 'consum', 0.0210, 'lps'),
	(595563, 131, '2014-03-15 00:23:38.000000', 'consum', 0.0235, 'lps'),
	(595564, 131, '2014-03-15 00:23:39.000000', 'consum', 0.0223, 'lps'),
	(595565, 131, '2014-03-15 00:23:40.000000', 'consum', 0.0227, 'lps'),
	(595566, 131, '2014-03-15 00:23:41.000000', 'consum', 0.0230, 'lps'),
	(595567, 131, '2014-03-15 00:23:42.000000', 'consum', 0.0231, 'lps'),
	(595568, 131, '2014-03-15 00:23:43.000000', 'consum', 0.0228, 'lps'),
	(595569, 131, '2014-03-15 00:23:44.000000', 'consum', 0.0236, 'lps'),
	(595570, 131, '2014-03-15 00:23:45.000000', 'consum', 0.0231, 'lps'),
	(595571, 131, '2014-03-15 00:23:46.000000', 'consum', 0.0211, 'lps'),
	(595572, 131, '2014-03-15 00:23:47.000000', 'consum', 0.0235, 'lps'),
	(595573, 131, '2014-03-15 00:23:48.000000', 'consum', 0.0223, 'lps'),
	(595574, 131, '2014-03-15 00:23:49.000000', 'consum', 0.0226, 'lps'),
	(595575, 131, '2014-03-15 00:23:50.000000', 'consum', 0.0223, 'lps'),
	(595576, 131, '2014-03-15 00:23:51.000000', 'consum', 0.0229, 'lps'),
	(595577, 131, '2014-03-15 00:23:52.000000', 'consum', 0.0210, 'lps'),
	(595578, 131, '2014-03-15 00:23:53.000000', 'consum', 0.0210, 'lps'),
	(595579, 131, '2014-03-15 00:23:54.000000', 'consum', 0.0237, 'lps'),
	(595580, 131, '2014-03-15 00:23:55.000000', 'consum', 0.0235, 'lps'),
	(595581, 131, '2014-03-15 00:23:56.000000', 'consum', 0.0228, 'lps'),
	(595582, 131, '2014-03-15 00:23:57.000000', 'consum', 0.0222, 'lps'),
	(595583, 131, '2014-03-15 00:23:58.000000', 'consum', 0.0220, 'lps'),
	(595584, 131, '2014-03-15 00:23:59.000000', 'consum', 0.0223, 'lps'),
	(595585, 131, '2014-03-15 00:24:00.000000', 'consum', 0.0220, 'lps'),
	(595586, 131, '2014-03-15 00:24:01.000000', 'consum', 0.0218, 'lps'),
	(595587, 131, '2014-03-15 00:24:02.000000', 'consum', 0.0223, 'lps'),
	(595588, 131, '2014-03-15 00:24:03.000000', 'consum', 0.0224, 'lps'),
	(595589, 131, '2014-03-15 00:24:04.000000', 'consum', 0.0212, 'lps'),
	(595590, 131, '2014-03-15 00:24:05.000000', 'consum', 0.0236, 'lps'),
	(595591, 131, '2014-03-15 00:24:06.000000', 'consum', 0.0221, 'lps'),
	(595592, 131, '2014-03-15 00:24:07.000000', 'consum', 0.0214, 'lps'),
	(595593, 131, '2014-03-15 00:24:08.000000', 'consum', 0.0227, 'lps'),
	(595594, 131, '2014-03-15 00:24:09.000000', 'consum', 0.0229, 'lps'),
	(595595, 131, '2014-03-15 00:24:10.000000', 'consum', 0.0226, 'lps'),
	(595596, 131, '2014-03-15 00:24:11.000000', 'consum', 0.0231, 'lps'),
	(595597, 131, '2014-03-15 00:24:12.000000', 'consum', 0.0214, 'lps'),
	(595598, 131, '2014-03-15 00:24:13.000000', 'consum', 0.0221, 'lps'),
	(595599, 131, '2014-03-15 00:24:14.000000', 'consum', 0.0226, 'lps'),
	(595600, 131, '2014-03-15 00:24:15.000000', 'consum', 0.0231, 'lps'),
	(595601, 131, '2014-03-15 00:24:16.000000', 'consum', 0.0213, 'lps'),
	(595602, 131, '2014-03-15 00:24:17.000000', 'consum', 0.0216, 'lps'),
	(595603, 131, '2014-03-15 00:24:18.000000', 'consum', 0.0234, 'lps'),
	(595604, 131, '2014-03-15 00:24:19.000000', 'consum', 0.0227, 'lps'),
	(595605, 131, '2014-03-15 00:24:20.000000', 'consum', 0.0223, 'lps'),
	(595606, 131, '2014-03-15 00:24:21.000000', 'consum', 0.0225, 'lps'),
	(595607, 131, '2014-03-15 00:24:22.000000', 'consum', 0.0219, 'lps'),
	(595608, 131, '2014-03-15 00:24:23.000000', 'consum', 0.0237, 'lps'),
	(595609, 131, '2014-03-15 00:24:24.000000', 'consum', 0.0237, 'lps'),
	(595610, 131, '2014-03-15 00:24:25.000000', 'consum', 0.0237, 'lps'),
	(595611, 131, '2014-03-15 00:24:26.000000', 'consum', 0.0236, 'lps'),
	(595612, 131, '2014-03-15 00:24:27.000000', 'consum', 0.0230, 'lps'),
	(595613, 131, '2014-03-15 00:24:28.000000', 'consum', 0.0235, 'lps'),
	(595614, 131, '2014-03-15 00:24:29.000000', 'consum', 0.0219, 'lps'),
	(595615, 131, '2014-03-15 00:24:30.000000', 'consum', 0.0235, 'lps'),
	(595616, 131, '2014-03-15 00:24:31.000000', 'consum', 0.0224, 'lps'),
	(595617, 131, '2014-03-15 00:24:32.000000', 'consum', 0.0236, 'lps'),
	(595618, 131, '2014-03-15 00:24:33.000000', 'consum', 0.0212, 'lps'),
	(595619, 131, '2014-03-15 00:24:34.000000', 'consum', 0.0226, 'lps'),
	(595620, 131, '2014-03-15 00:24:35.000000', 'consum', 0.0231, 'lps'),
	(595621, 131, '2014-03-15 00:24:36.000000', 'consum', 0.0237, 'lps'),
	(595622, 131, '2014-03-15 00:24:37.000000', 'consum', 0.0229, 'lps'),
	(595623, 131, '2014-03-15 00:24:38.000000', 'consum', 0.0223, 'lps'),
	(595624, 131, '2014-03-15 00:24:39.000000', 'consum', 0.0217, 'lps'),
	(595625, 131, '2014-03-15 00:24:40.000000', 'consum', 0.0236, 'lps'),
	(595626, 131, '2014-03-15 00:24:41.000000', 'consum', 0.0236, 'lps'),
	(595627, 131, '2014-03-15 00:24:42.000000', 'consum', 0.0234, 'lps'),
	(595628, 131, '2014-03-15 00:24:43.000000', 'consum', 0.0227, 'lps'),
	(595629, 131, '2014-03-15 00:24:44.000000', 'consum', 0.0220, 'lps'),
	(595630, 131, '2014-03-15 00:24:45.000000', 'consum', 0.0211, 'lps'),
	(595631, 131, '2014-03-15 00:24:46.000000', 'consum', 0.0212, 'lps'),
	(595632, 131, '2014-03-15 00:24:47.000000', 'consum', 0.0216, 'lps'),
	(595633, 131, '2014-03-15 00:24:48.000000', 'consum', 0.0237, 'lps'),
	(595634, 131, '2014-03-15 00:24:49.000000', 'consum', 0.0217, 'lps'),
	(595635, 131, '2014-03-15 00:24:50.000000', 'consum', 0.0219, 'lps'),
	(595636, 131, '2014-03-15 00:24:51.000000', 'consum', 0.0236, 'lps'),
	(595637, 131, '2014-03-15 00:24:52.000000', 'consum', 0.0227, 'lps'),
	(595638, 131, '2014-03-15 00:24:53.000000', 'consum', 0.0217, 'lps'),
	(595639, 131, '2014-03-15 00:24:54.000000', 'consum', 0.0223, 'lps'),
	(595640, 131, '2014-03-15 00:24:55.000000', 'consum', 0.0225, 'lps'),
	(595641, 131, '2014-03-15 00:24:56.000000', 'consum', 0.0219, 'lps'),
	(595642, 131, '2014-03-15 00:24:57.000000', 'consum', 0.0212, 'lps'),
	(595643, 131, '2014-03-15 00:24:58.000000', 'consum', 0.0221, 'lps'),
	(595644, 131, '2014-03-15 00:24:59.000000', 'consum', 0.0230, 'lps'),
	(595645, 131, '2014-03-15 00:25:00.000000', 'consum', 0.0223, 'lps'),
	(595646, 131, '2014-03-15 00:25:01.000000', 'consum', 0.0213, 'lps'),
	(595647, 131, '2014-03-15 00:25:02.000000', 'consum', 0.0217, 'lps'),
	(595648, 131, '2014-03-15 00:25:03.000000', 'consum', 0.0234, 'lps'),
	(595649, 131, '2014-03-15 00:25:04.000000', 'consum', 0.0226, 'lps'),
	(595650, 131, '2014-03-15 00:25:05.000000', 'consum', 0.0220, 'lps'),
	(595651, 131, '2014-03-15 00:25:06.000000', 'consum', 0.0212, 'lps'),
	(595652, 131, '2014-03-15 00:25:07.000000', 'consum', 0.0219, 'lps'),
	(595653, 131, '2014-03-15 00:25:08.000000', 'consum', 0.0221, 'lps'),
	(595654, 131, '2014-03-15 00:25:09.000000', 'consum', 0.0237, 'lps'),
	(595655, 131, '2014-03-15 00:25:10.000000', 'consum', 0.0230, 'lps'),
	(595656, 131, '2014-03-15 00:25:11.000000', 'consum', 0.0231, 'lps'),
	(595657, 131, '2014-03-15 00:25:12.000000', 'consum', 0.0225, 'lps'),
	(595658, 131, '2014-03-15 00:25:13.000000', 'consum', 0.0222, 'lps'),
	(595659, 131, '2014-03-15 00:25:14.000000', 'consum', 0.0225, 'lps'),
	(595660, 131, '2014-03-15 00:25:15.000000', 'consum', 0.0222, 'lps'),
	(595661, 131, '2014-03-15 00:25:16.000000', 'consum', 0.0226, 'lps'),
	(595662, 131, '2014-03-15 00:25:17.000000', 'consum', 0.0228, 'lps'),
	(595663, 131, '2014-03-15 00:25:18.000000', 'consum', 0.0225, 'lps'),
	(595664, 131, '2014-03-15 00:25:19.000000', 'consum', 0.0230, 'lps'),
	(595665, 131, '2014-03-15 00:25:20.000000', 'consum', 0.0212, 'lps'),
	(595666, 131, '2014-03-15 00:25:21.000000', 'consum', 0.0214, 'lps'),
	(595667, 131, '2014-03-15 00:25:22.000000', 'consum', 0.0223, 'lps'),
	(595668, 131, '2014-03-15 00:25:23.000000', 'consum', 0.0210, 'lps'),
	(595669, 131, '2014-03-15 00:25:24.000000', 'consum', 0.0227, 'lps'),
	(595670, 131, '2014-03-15 00:25:25.000000', 'consum', 0.0211, 'lps'),
	(595671, 131, '2014-03-15 00:25:26.000000', 'consum', 0.0219, 'lps'),
	(595672, 131, '2014-03-15 00:25:27.000000', 'consum', 0.0227, 'lps'),
	(595673, 131, '2014-03-15 00:25:28.000000', 'consum', 0.0210, 'lps'),
	(595674, 131, '2014-03-15 00:25:29.000000', 'consum', 0.0215, 'lps'),
	(595675, 131, '2014-03-15 00:25:30.000000', 'consum', 0.0210, 'lps'),
	(595676, 131, '2014-03-15 00:25:31.000000', 'consum', 0.0223, 'lps'),
	(595677, 131, '2014-03-15 00:25:32.000000', 'consum', 0.0217, 'lps'),
	(595678, 131, '2014-03-15 00:25:33.000000', 'consum', 0.0237, 'lps'),
	(595679, 131, '2014-03-15 00:25:34.000000', 'consum', 0.0212, 'lps'),
	(595680, 131, '2014-03-15 00:25:35.000000', 'consum', 0.0222, 'lps'),
	(595681, 131, '2014-03-15 00:25:36.000000', 'consum', 0.0211, 'lps'),
	(595682, 131, '2014-03-15 00:25:37.000000', 'consum', 0.0233, 'lps'),
	(595683, 131, '2014-03-15 00:25:38.000000', 'consum', 0.0212, 'lps'),
	(595684, 131, '2014-03-15 00:25:39.000000', 'consum', 0.0235, 'lps'),
	(595685, 131, '2014-03-15 00:25:40.000000', 'consum', 0.0218, 'lps'),
	(595686, 131, '2014-03-15 00:25:41.000000', 'consum', 0.0232, 'lps'),
	(595687, 131, '2014-03-15 00:25:42.000000', 'consum', 0.0212, 'lps'),
	(595688, 131, '2014-03-15 00:25:43.000000', 'consum', 0.0210, 'lps'),
	(595689, 131, '2014-03-15 00:25:44.000000', 'consum', 0.0234, 'lps'),
	(595690, 131, '2014-03-15 00:25:45.000000', 'consum', 0.0219, 'lps'),
	(595691, 131, '2014-03-15 00:25:46.000000', 'consum', 0.0213, 'lps'),
	(595692, 131, '2014-03-15 00:25:47.000000', 'consum', 0.0223, 'lps'),
	(595693, 131, '2014-03-15 00:25:48.000000', 'consum', 0.0213, 'lps'),
	(595694, 131, '2014-03-15 00:25:49.000000', 'consum', 0.0212, 'lps'),
	(595695, 131, '2014-03-15 00:25:50.000000', 'consum', 0.0213, 'lps'),
	(595696, 131, '2014-03-15 00:25:51.000000', 'consum', 0.0219, 'lps'),
	(595697, 131, '2014-03-15 00:25:52.000000', 'consum', 0.0219, 'lps'),
	(595698, 131, '2014-03-15 00:25:53.000000', 'consum', 0.0227, 'lps'),
	(595699, 131, '2014-03-15 00:25:54.000000', 'consum', 0.0215, 'lps'),
	(595700, 131, '2014-03-15 00:25:55.000000', 'consum', 0.0210, 'lps'),
	(595701, 131, '2014-03-15 00:25:56.000000', 'consum', 0.0223, 'lps'),
	(595702, 131, '2014-03-15 00:25:57.000000', 'consum', 0.0220, 'lps'),
	(595703, 131, '2014-03-15 00:25:58.000000', 'consum', 0.0222, 'lps'),
	(595704, 131, '2014-03-15 00:25:59.000000', 'consum', 0.0212, 'lps'),
	(595705, 131, '2014-03-15 00:26:00.000000', 'consum', 0.0214, 'lps'),
	(595706, 131, '2014-03-15 00:26:01.000000', 'consum', 0.0223, 'lps'),
	(595707, 131, '2014-03-15 00:26:02.000000', 'consum', 0.0235, 'lps'),
	(595708, 131, '2014-03-15 00:26:03.000000', 'consum', 0.0213, 'lps'),
	(595709, 131, '2014-03-15 00:26:04.000000', 'consum', 0.0236, 'lps'),
	(595710, 131, '2014-03-15 00:26:05.000000', 'consum', 0.0220, 'lps'),
	(595711, 131, '2014-03-15 00:26:06.000000', 'consum', 0.0236, 'lps'),
	(595712, 131, '2014-03-15 00:26:07.000000', 'consum', 0.0226, 'lps'),
	(595713, 131, '2014-03-15 00:26:08.000000', 'consum', 0.0214, 'lps'),
	(595714, 131, '2014-03-15 00:26:09.000000', 'consum', 0.0236, 'lps'),
	(595715, 131, '2014-03-15 00:26:10.000000', 'consum', 0.0219, 'lps'),
	(595716, 131, '2014-03-15 00:26:11.000000', 'consum', 0.0233, 'lps'),
	(595717, 131, '2014-03-15 00:26:12.000000', 'consum', 0.0215, 'lps'),
	(595718, 131, '2014-03-15 00:26:13.000000', 'consum', 0.0221, 'lps'),
	(595719, 131, '2014-03-15 00:26:14.000000', 'consum', 0.0221, 'lps'),
	(595720, 131, '2014-03-15 00:26:15.000000', 'consum', 0.0235, 'lps'),
	(595721, 131, '2014-03-15 00:26:16.000000', 'consum', 0.0218, 'lps'),
	(595722, 131, '2014-03-15 00:26:17.000000', 'consum', 0.0230, 'lps'),
	(595723, 131, '2014-03-15 00:26:18.000000', 'consum', 0.0232, 'lps'),
	(595724, 131, '2014-03-15 00:26:19.000000', 'consum', 0.0233, 'lps'),
	(595725, 131, '2014-03-15 00:26:20.000000', 'consum', 0.0232, 'lps'),
	(595726, 131, '2014-03-15 00:26:21.000000', 'consum', 0.0224, 'lps'),
	(595727, 131, '2014-03-15 00:26:22.000000', 'consum', 0.0212, 'lps'),
	(595728, 131, '2014-03-15 00:26:23.000000', 'consum', 0.0210, 'lps'),
	(595729, 131, '2014-03-15 00:26:24.000000', 'consum', 0.0229, 'lps'),
	(595730, 131, '2014-03-15 00:26:25.000000', 'consum', 0.0224, 'lps'),
	(595731, 131, '2014-03-15 00:26:26.000000', 'consum', 0.0222, 'lps'),
	(595732, 131, '2014-03-15 00:26:27.000000', 'consum', 0.0230, 'lps'),
	(595733, 131, '2014-03-15 00:26:28.000000', 'consum', 0.0217, 'lps'),
	(595734, 131, '2014-03-15 00:26:29.000000', 'consum', 0.0212, 'lps'),
	(595735, 131, '2014-03-15 00:26:30.000000', 'consum', 0.0229, 'lps'),
	(595736, 131, '2014-03-15 00:26:31.000000', 'consum', 0.0216, 'lps'),
	(595737, 131, '2014-03-15 00:26:32.000000', 'consum', 0.0212, 'lps'),
	(595738, 131, '2014-03-15 00:26:33.000000', 'consum', 0.0229, 'lps'),
	(595739, 131, '2014-03-15 00:26:34.000000', 'consum', 0.0217, 'lps'),
	(595740, 131, '2014-03-15 00:26:35.000000', 'consum', 0.0217, 'lps'),
	(595741, 131, '2014-03-15 00:26:36.000000', 'consum', 0.0224, 'lps'),
	(595742, 131, '2014-03-15 00:26:37.000000', 'consum', 0.0232, 'lps'),
	(595743, 131, '2014-03-15 00:26:38.000000', 'consum', 0.0222, 'lps'),
	(595744, 131, '2014-03-15 00:26:39.000000', 'consum', 0.0233, 'lps'),
	(595745, 131, '2014-03-15 00:26:40.000000', 'consum', 0.0231, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(595746, 131, '2014-03-15 00:26:41.000000', 'consum', 0.0221, 'lps'),
	(595747, 131, '2014-03-15 00:26:42.000000', 'consum', 0.0228, 'lps'),
	(595748, 131, '2014-03-15 00:26:43.000000', 'consum', 0.0214, 'lps'),
	(595749, 131, '2014-03-15 00:26:44.000000', 'consum', 0.0230, 'lps'),
	(595750, 131, '2014-03-15 00:26:45.000000', 'consum', 0.0217, 'lps'),
	(595751, 131, '2014-03-15 00:26:46.000000', 'consum', 0.0214, 'lps'),
	(595752, 131, '2014-03-15 00:26:47.000000', 'consum', 0.0235, 'lps'),
	(595753, 131, '2014-03-15 00:26:48.000000', 'consum', 0.0213, 'lps'),
	(595754, 131, '2014-03-15 00:26:49.000000', 'consum', 0.0235, 'lps'),
	(595755, 131, '2014-03-15 00:26:50.000000', 'consum', 0.0212, 'lps'),
	(595756, 131, '2014-03-15 00:26:51.000000', 'consum', 0.0232, 'lps'),
	(595757, 131, '2014-03-15 00:26:52.000000', 'consum', 0.0230, 'lps'),
	(595758, 131, '2014-03-15 00:26:53.000000', 'consum', 0.0217, 'lps'),
	(595759, 131, '2014-03-15 00:26:54.000000', 'consum', 0.0214, 'lps'),
	(595760, 131, '2014-03-15 00:26:55.000000', 'consum', 0.0236, 'lps'),
	(595761, 131, '2014-03-15 00:26:56.000000', 'consum', 0.0215, 'lps'),
	(595762, 131, '2014-03-15 00:26:57.000000', 'consum', 0.0217, 'lps'),
	(595763, 131, '2014-03-15 00:26:58.000000', 'consum', 0.0227, 'lps'),
	(595764, 131, '2014-03-15 00:26:59.000000', 'consum', 0.0222, 'lps'),
	(595765, 131, '2014-03-15 00:27:00.000000', 'consum', 0.0216, 'lps'),
	(595766, 131, '2014-03-15 00:27:01.000000', 'consum', 0.0236, 'lps'),
	(595767, 131, '2014-03-15 00:27:02.000000', 'consum', 0.0235, 'lps'),
	(595768, 131, '2014-03-15 00:27:03.000000', 'consum', 0.0231, 'lps'),
	(595769, 131, '2014-03-15 00:27:04.000000', 'consum', 0.0211, 'lps'),
	(595770, 131, '2014-03-15 00:27:05.000000', 'consum', 0.0211, 'lps'),
	(595771, 131, '2014-03-15 00:27:06.000000', 'consum', 0.0210, 'lps'),
	(595772, 131, '2014-03-15 00:27:07.000000', 'consum', 0.0210, 'lps'),
	(595773, 131, '2014-03-15 00:27:08.000000', 'consum', 0.0236, 'lps'),
	(595774, 131, '2014-03-15 00:27:09.000000', 'consum', 0.0231, 'lps'),
	(595775, 131, '2014-03-15 00:27:10.000000', 'consum', 0.0236, 'lps'),
	(595776, 131, '2014-03-15 00:27:11.000000', 'consum', 0.0220, 'lps'),
	(595777, 131, '2014-03-15 00:27:12.000000', 'consum', 0.0212, 'lps'),
	(595778, 131, '2014-03-15 00:27:13.000000', 'consum', 0.0220, 'lps'),
	(595779, 131, '2014-03-15 00:27:14.000000', 'consum', 0.0225, 'lps'),
	(595780, 131, '2014-03-15 00:27:15.000000', 'consum', 0.0230, 'lps'),
	(595781, 131, '2014-03-15 00:27:16.000000', 'consum', 0.0234, 'lps'),
	(595782, 131, '2014-03-15 00:27:17.000000', 'consum', 0.0216, 'lps'),
	(595783, 131, '2014-03-15 00:27:18.000000', 'consum', 0.0224, 'lps'),
	(595784, 131, '2014-03-15 00:27:19.000000', 'consum', 0.0236, 'lps'),
	(595785, 131, '2014-03-15 00:27:20.000000', 'consum', 0.0215, 'lps'),
	(595786, 131, '2014-03-15 00:27:21.000000', 'consum', 0.0211, 'lps'),
	(595787, 131, '2014-03-15 00:27:22.000000', 'consum', 0.0228, 'lps'),
	(595788, 131, '2014-03-15 00:27:23.000000', 'consum', 0.0214, 'lps'),
	(595789, 131, '2014-03-15 00:27:24.000000', 'consum', 0.0233, 'lps'),
	(595790, 131, '2014-03-15 00:27:25.000000', 'consum', 0.0229, 'lps'),
	(595791, 131, '2014-03-15 00:27:26.000000', 'consum', 0.0237, 'lps'),
	(595792, 131, '2014-03-15 00:27:27.000000', 'consum', 0.0231, 'lps'),
	(595793, 131, '2014-03-15 00:27:28.000000', 'consum', 0.0237, 'lps'),
	(595794, 131, '2014-03-15 00:27:29.000000', 'consum', 0.0226, 'lps'),
	(595795, 131, '2014-03-15 00:27:30.000000', 'consum', 0.0211, 'lps'),
	(595796, 131, '2014-03-15 00:27:31.000000', 'consum', 0.0222, 'lps'),
	(595797, 131, '2014-03-15 00:27:32.000000', 'consum', 0.0211, 'lps'),
	(595798, 131, '2014-03-15 00:27:33.000000', 'consum', 0.0237, 'lps'),
	(595799, 131, '2014-03-15 00:27:34.000000', 'consum', 0.0229, 'lps'),
	(595800, 131, '2014-03-15 00:27:35.000000', 'consum', 0.0225, 'lps'),
	(595801, 131, '2014-03-15 00:27:36.000000', 'consum', 0.0231, 'lps'),
	(595802, 131, '2014-03-15 00:27:37.000000', 'consum', 0.0211, 'lps'),
	(595803, 131, '2014-03-15 00:27:38.000000', 'consum', 0.0211, 'lps'),
	(595804, 131, '2014-03-15 00:27:39.000000', 'consum', 0.0211, 'lps'),
	(595805, 131, '2014-03-15 00:27:40.000000', 'consum', 0.0212, 'lps'),
	(595806, 131, '2014-03-15 00:27:41.000000', 'consum', 0.0220, 'lps'),
	(595807, 131, '2014-03-15 00:27:42.000000', 'consum', 0.0224, 'lps'),
	(595808, 131, '2014-03-15 00:27:43.000000', 'consum', 0.0222, 'lps'),
	(595809, 131, '2014-03-15 00:27:44.000000', 'consum', 0.0228, 'lps'),
	(595810, 131, '2014-03-15 00:27:45.000000', 'consum', 0.0211, 'lps'),
	(595811, 131, '2014-03-15 00:27:46.000000', 'consum', 0.0216, 'lps'),
	(595812, 131, '2014-03-15 00:27:47.000000', 'consum', 0.0211, 'lps'),
	(595813, 131, '2014-03-15 00:27:48.000000', 'consum', 0.0225, 'lps'),
	(595814, 131, '2014-03-15 00:27:49.000000', 'consum', 0.0226, 'lps'),
	(595815, 131, '2014-03-15 00:27:50.000000', 'consum', 0.0218, 'lps'),
	(595816, 131, '2014-03-15 00:27:51.000000', 'consum', 0.0231, 'lps'),
	(595817, 131, '2014-03-15 00:27:52.000000', 'consum', 0.0236, 'lps'),
	(595818, 131, '2014-03-15 00:27:53.000000', 'consum', 0.0221, 'lps'),
	(595819, 131, '2014-03-15 00:27:54.000000', 'consum', 0.0217, 'lps'),
	(595820, 131, '2014-03-15 00:27:55.000000', 'consum', 0.0213, 'lps'),
	(595821, 131, '2014-03-15 00:27:56.000000', 'consum', 0.0231, 'lps'),
	(595822, 131, '2014-03-15 00:27:57.000000', 'consum', 0.0223, 'lps'),
	(595823, 131, '2014-03-15 00:27:58.000000', 'consum', 0.0211, 'lps'),
	(595824, 131, '2014-03-15 00:27:59.000000', 'consum', 0.0234, 'lps'),
	(595825, 131, '2014-03-15 00:28:00.000000', 'consum', 0.0216, 'lps'),
	(595826, 131, '2014-03-15 00:28:01.000000', 'consum', 0.0224, 'lps'),
	(595827, 131, '2014-03-15 00:28:02.000000', 'consum', 0.0234, 'lps'),
	(595828, 131, '2014-03-15 00:28:03.000000', 'consum', 0.0233, 'lps'),
	(595829, 131, '2014-03-15 00:28:04.000000', 'consum', 0.0227, 'lps'),
	(595830, 131, '2014-03-15 00:28:05.000000', 'consum', 0.0227, 'lps'),
	(595831, 131, '2014-03-15 00:28:06.000000', 'consum', 0.0216, 'lps'),
	(595832, 131, '2014-03-15 00:28:07.000000', 'consum', 0.0219, 'lps'),
	(595833, 131, '2014-03-15 00:28:08.000000', 'consum', 0.0235, 'lps'),
	(595834, 131, '2014-03-15 00:28:09.000000', 'consum', 0.0225, 'lps'),
	(595835, 131, '2014-03-15 00:28:10.000000', 'consum', 0.0210, 'lps'),
	(595836, 131, '2014-03-15 00:28:11.000000', 'consum', 0.0220, 'lps'),
	(595837, 131, '2014-03-15 00:28:12.000000', 'consum', 0.0236, 'lps'),
	(595838, 131, '2014-03-15 00:28:13.000000', 'consum', 0.0224, 'lps'),
	(595839, 131, '2014-03-15 00:28:14.000000', 'consum', 0.0232, 'lps'),
	(595840, 131, '2014-03-15 00:28:15.000000', 'consum', 0.0223, 'lps'),
	(595841, 131, '2014-03-15 00:28:16.000000', 'consum', 0.0210, 'lps'),
	(595842, 131, '2014-03-15 00:28:17.000000', 'consum', 0.0229, 'lps'),
	(595843, 131, '2014-03-15 00:28:18.000000', 'consum', 0.0219, 'lps'),
	(595844, 131, '2014-03-15 00:28:19.000000', 'consum', 0.0226, 'lps'),
	(595845, 131, '2014-03-15 00:28:20.000000', 'consum', 0.0210, 'lps'),
	(595846, 131, '2014-03-15 00:28:21.000000', 'consum', 0.0217, 'lps'),
	(595847, 131, '2014-03-15 00:28:22.000000', 'consum', 0.0217, 'lps'),
	(595848, 131, '2014-03-15 00:28:23.000000', 'consum', 0.0226, 'lps'),
	(595849, 131, '2014-03-15 00:28:24.000000', 'consum', 0.0212, 'lps'),
	(595850, 131, '2014-03-15 00:28:25.000000', 'consum', 0.0228, 'lps'),
	(595851, 131, '2014-03-15 00:28:26.000000', 'consum', 0.0212, 'lps'),
	(595852, 131, '2014-03-15 00:28:27.000000', 'consum', 0.0221, 'lps'),
	(595853, 131, '2014-03-15 00:28:28.000000', 'consum', 0.0233, 'lps'),
	(595854, 131, '2014-03-15 00:28:29.000000', 'consum', 0.0234, 'lps'),
	(595855, 131, '2014-03-15 00:28:30.000000', 'consum', 0.0235, 'lps'),
	(595856, 131, '2014-03-15 00:28:31.000000', 'consum', 0.0236, 'lps'),
	(595857, 131, '2014-03-15 00:28:32.000000', 'consum', 0.0210, 'lps'),
	(595858, 131, '2014-03-15 00:28:33.000000', 'consum', 0.0214, 'lps'),
	(595859, 131, '2014-03-15 00:28:34.000000', 'consum', 0.0232, 'lps'),
	(595860, 131, '2014-03-15 00:28:35.000000', 'consum', 0.0223, 'lps'),
	(595861, 131, '2014-03-15 00:28:36.000000', 'consum', 0.0211, 'lps'),
	(595862, 131, '2014-03-15 00:28:37.000000', 'consum', 0.0233, 'lps'),
	(595863, 131, '2014-03-15 00:28:38.000000', 'consum', 0.0211, 'lps'),
	(595864, 131, '2014-03-15 00:28:39.000000', 'consum', 0.0229, 'lps'),
	(595865, 131, '2014-03-15 00:28:40.000000', 'consum', 0.0220, 'lps'),
	(595866, 131, '2014-03-15 00:28:41.000000', 'consum', 0.0229, 'lps'),
	(595867, 131, '2014-03-15 00:28:42.000000', 'consum', 0.0221, 'lps'),
	(595868, 131, '2014-03-15 00:28:43.000000', 'consum', 0.0237, 'lps'),
	(595869, 131, '2014-03-15 00:28:44.000000', 'consum', 0.0229, 'lps'),
	(595870, 131, '2014-03-15 00:28:45.000000', 'consum', 0.0223, 'lps'),
	(595871, 131, '2014-03-15 00:28:46.000000', 'consum', 0.0217, 'lps'),
	(595872, 131, '2014-03-15 00:28:47.000000', 'consum', 0.0210, 'lps'),
	(595873, 131, '2014-03-15 00:28:48.000000', 'consum', 0.0216, 'lps'),
	(595874, 131, '2014-03-15 00:28:49.000000', 'consum', 0.0211, 'lps'),
	(595875, 131, '2014-03-15 00:28:50.000000', 'consum', 0.0226, 'lps'),
	(595876, 131, '2014-03-15 00:28:51.000000', 'consum', 0.0232, 'lps'),
	(595877, 131, '2014-03-15 00:28:52.000000', 'consum', 0.0217, 'lps'),
	(595878, 131, '2014-03-15 00:28:53.000000', 'consum', 0.0235, 'lps'),
	(595879, 131, '2014-03-15 00:28:54.000000', 'consum', 0.0230, 'lps'),
	(595880, 131, '2014-03-15 00:28:55.000000', 'consum', 0.0235, 'lps'),
	(595881, 131, '2014-03-15 00:28:56.000000', 'consum', 0.0218, 'lps'),
	(595882, 131, '2014-03-15 00:28:57.000000', 'consum', 0.0234, 'lps'),
	(595883, 131, '2014-03-15 00:28:58.000000', 'consum', 0.0220, 'lps'),
	(595884, 131, '2014-03-15 00:28:59.000000', 'consum', 0.0219, 'lps'),
	(595885, 131, '2014-03-15 00:29:00.000000', 'consum', 0.0223, 'lps'),
	(595886, 131, '2014-03-15 00:29:01.000000', 'consum', 0.0221, 'lps'),
	(595887, 131, '2014-03-15 00:29:02.000000', 'consum', 0.0229, 'lps'),
	(595888, 131, '2014-03-15 00:29:03.000000', 'consum', 0.0213, 'lps'),
	(595889, 131, '2014-03-15 00:29:04.000000', 'consum', 0.0226, 'lps'),
	(595890, 131, '2014-03-15 00:29:05.000000', 'consum', 0.0228, 'lps'),
	(595891, 131, '2014-03-15 00:29:06.000000', 'consum', 0.0221, 'lps'),
	(595892, 131, '2014-03-15 00:29:07.000000', 'consum', 0.0211, 'lps'),
	(595893, 131, '2014-03-15 00:29:08.000000', 'consum', 0.0211, 'lps'),
	(595894, 131, '2014-03-15 00:29:09.000000', 'consum', 0.0214, 'lps'),
	(595895, 131, '2014-03-15 00:29:10.000000', 'consum', 0.0228, 'lps'),
	(595896, 131, '2014-03-15 00:29:11.000000', 'consum', 0.0231, 'lps'),
	(595897, 131, '2014-03-15 00:29:12.000000', 'consum', 0.0232, 'lps'),
	(595898, 131, '2014-03-15 00:29:13.000000', 'consum', 0.0232, 'lps'),
	(595899, 131, '2014-03-15 00:29:14.000000', 'consum', 0.0227, 'lps'),
	(595900, 131, '2014-03-15 00:29:15.000000', 'consum', 0.0227, 'lps'),
	(595901, 131, '2014-03-15 00:29:16.000000', 'consum', 0.0218, 'lps'),
	(595902, 131, '2014-03-15 00:29:17.000000', 'consum', 0.0229, 'lps'),
	(595903, 131, '2014-03-15 00:29:18.000000', 'consum', 0.0226, 'lps'),
	(595904, 131, '2014-03-15 00:29:19.000000', 'consum', 0.0231, 'lps'),
	(595905, 131, '2014-03-15 00:29:20.000000', 'consum', 0.0212, 'lps'),
	(595906, 131, '2014-03-15 00:29:21.000000', 'consum', 0.0212, 'lps'),
	(595907, 131, '2014-03-15 00:29:22.000000', 'consum', 0.0215, 'lps'),
	(595908, 131, '2014-03-15 00:29:23.000000', 'consum', 0.0232, 'lps'),
	(595909, 131, '2014-03-15 00:29:24.000000', 'consum', 0.0221, 'lps'),
	(595910, 131, '2014-03-15 00:29:25.000000', 'consum', 0.0226, 'lps'),
	(595911, 131, '2014-03-15 00:29:26.000000', 'consum', 0.0231, 'lps'),
	(595912, 131, '2014-03-15 00:29:27.000000', 'consum', 0.0237, 'lps'),
	(595913, 131, '2014-03-15 00:29:28.000000', 'consum', 0.0227, 'lps'),
	(595914, 131, '2014-03-15 00:29:29.000000', 'consum', 0.0217, 'lps'),
	(595915, 131, '2014-03-15 00:29:30.000000', 'consum', 0.0221, 'lps'),
	(595916, 131, '2014-03-15 00:29:31.000000', 'consum', 0.0218, 'lps'),
	(595917, 131, '2014-03-15 00:29:32.000000', 'consum', 0.0216, 'lps'),
	(595918, 131, '2014-03-15 00:29:33.000000', 'consum', 0.0216, 'lps'),
	(595919, 131, '2014-03-15 00:29:34.000000', 'consum', 0.0223, 'lps'),
	(595920, 131, '2014-03-15 00:29:35.000000', 'consum', 0.0229, 'lps'),
	(595921, 131, '2014-03-15 00:29:36.000000', 'consum', 0.0237, 'lps'),
	(595922, 131, '2014-03-15 00:29:37.000000', 'consum', 0.0233, 'lps'),
	(595923, 131, '2014-03-15 00:29:38.000000', 'consum', 0.0218, 'lps'),
	(595924, 131, '2014-03-15 00:29:39.000000', 'consum', 0.0235, 'lps'),
	(595925, 131, '2014-03-15 00:29:40.000000', 'consum', 0.0231, 'lps'),
	(595926, 131, '2014-03-15 00:29:41.000000', 'consum', 0.0237, 'lps'),
	(595927, 131, '2014-03-15 00:29:42.000000', 'consum', 0.0229, 'lps'),
	(595928, 131, '2014-03-15 00:29:43.000000', 'consum', 0.0223, 'lps'),
	(595929, 131, '2014-03-15 00:29:44.000000', 'consum', 0.0218, 'lps'),
	(595930, 131, '2014-03-15 00:29:45.000000', 'consum', 0.0213, 'lps'),
	(595931, 131, '2014-03-15 00:29:46.000000', 'consum', 0.0229, 'lps'),
	(595932, 131, '2014-03-15 00:29:47.000000', 'consum', 0.0212, 'lps'),
	(595933, 131, '2014-03-15 00:29:48.000000', 'consum', 0.0222, 'lps'),
	(595934, 131, '2014-03-15 00:29:49.000000', 'consum', 0.0233, 'lps'),
	(595935, 131, '2014-03-15 00:29:50.000000', 'consum', 0.0236, 'lps'),
	(595936, 131, '2014-03-15 00:29:51.000000', 'consum', 0.0215, 'lps'),
	(595937, 131, '2014-03-15 00:29:52.000000', 'consum', 0.0212, 'lps'),
	(595938, 131, '2014-03-15 00:29:53.000000', 'consum', 0.0235, 'lps'),
	(595939, 131, '2014-03-15 00:29:54.000000', 'consum', 0.0218, 'lps'),
	(595940, 131, '2014-03-15 00:29:55.000000', 'consum', 0.0233, 'lps'),
	(595941, 131, '2014-03-15 00:29:56.000000', 'consum', 0.0214, 'lps'),
	(595942, 131, '2014-03-15 00:29:57.000000', 'consum', 0.0219, 'lps'),
	(595943, 131, '2014-03-15 00:29:58.000000', 'consum', 0.0215, 'lps'),
	(595944, 131, '2014-03-15 00:29:59.000000', 'consum', 0.0235, 'lps'),
	(595945, 131, '2014-03-15 00:30:00.000000', 'consum', 0.0211, 'lps'),
	(595946, 131, '2014-03-15 00:30:01.000000', 'consum', 0.0224, 'lps'),
	(595947, 131, '2014-03-15 00:30:02.000000', 'consum', 0.0223, 'lps'),
	(595948, 131, '2014-03-15 00:30:03.000000', 'consum', 0.0233, 'lps'),
	(595949, 131, '2014-03-15 00:30:04.000000', 'consum', 0.0229, 'lps'),
	(595950, 131, '2014-03-15 00:30:05.000000', 'consum', 0.0237, 'lps'),
	(595951, 131, '2014-03-15 00:30:06.000000', 'consum', 0.0231, 'lps'),
	(595952, 131, '2014-03-15 00:30:07.000000', 'consum', 0.0210, 'lps'),
	(595953, 131, '2014-03-15 00:30:08.000000', 'consum', 0.0228, 'lps'),
	(595954, 131, '2014-03-15 00:30:09.000000', 'consum', 0.0219, 'lps'),
	(595955, 131, '2014-03-15 00:30:10.000000', 'consum', 0.0229, 'lps'),
	(595956, 131, '2014-03-15 00:30:11.000000', 'consum', 0.0221, 'lps'),
	(595957, 131, '2014-03-15 00:30:12.000000', 'consum', 0.0237, 'lps'),
	(595958, 131, '2014-03-15 00:30:13.000000', 'consum', 0.0230, 'lps'),
	(595959, 131, '2014-03-15 00:30:14.000000', 'consum', 0.0228, 'lps'),
	(595960, 131, '2014-03-15 00:30:15.000000', 'consum', 0.0213, 'lps'),
	(595961, 131, '2014-03-15 00:30:16.000000', 'consum', 0.0227, 'lps'),
	(595962, 131, '2014-03-15 00:30:17.000000', 'consum', 0.0231, 'lps'),
	(595963, 131, '2014-03-15 00:30:18.000000', 'consum', 0.0235, 'lps'),
	(595964, 131, '2014-03-15 00:30:19.000000', 'consum', 0.0216, 'lps'),
	(595965, 131, '2014-03-15 00:30:20.000000', 'consum', 0.0221, 'lps'),
	(595966, 131, '2014-03-15 00:30:21.000000', 'consum', 0.0220, 'lps'),
	(595967, 131, '2014-03-15 00:30:22.000000', 'consum', 0.0229, 'lps'),
	(595968, 131, '2014-03-15 00:30:23.000000', 'consum', 0.0217, 'lps'),
	(595969, 131, '2014-03-15 00:30:24.000000', 'consum', 0.0218, 'lps'),
	(595970, 131, '2014-03-15 00:30:25.000000', 'consum', 0.0231, 'lps'),
	(595971, 131, '2014-03-15 00:30:26.000000', 'consum', 0.0233, 'lps'),
	(595972, 131, '2014-03-15 00:30:27.000000', 'consum', 0.0235, 'lps'),
	(595973, 131, '2014-03-15 00:30:28.000000', 'consum', 0.0237, 'lps'),
	(595974, 131, '2014-03-15 00:30:29.000000', 'consum', 0.0216, 'lps'),
	(595975, 131, '2014-03-15 00:30:30.000000', 'consum', 0.0215, 'lps'),
	(595976, 131, '2014-03-15 00:30:31.000000', 'consum', 0.0219, 'lps'),
	(595977, 131, '2014-03-15 00:30:32.000000', 'consum', 0.0213, 'lps'),
	(595978, 131, '2014-03-15 00:30:33.000000', 'consum', 0.0227, 'lps'),
	(595979, 131, '2014-03-15 00:30:34.000000', 'consum', 0.0228, 'lps'),
	(595980, 131, '2014-03-15 00:30:35.000000', 'consum', 0.0222, 'lps'),
	(595981, 131, '2014-03-15 00:30:36.000000', 'consum', 0.0216, 'lps'),
	(595982, 131, '2014-03-15 00:30:37.000000', 'consum', 0.0232, 'lps'),
	(595983, 131, '2014-03-15 00:30:38.000000', 'consum', 0.0219, 'lps'),
	(595984, 131, '2014-03-15 00:30:39.000000', 'consum', 0.0218, 'lps'),
	(595985, 131, '2014-03-15 00:30:40.000000', 'consum', 0.0221, 'lps'),
	(595986, 131, '2014-03-15 00:30:41.000000', 'consum', 0.0216, 'lps'),
	(595987, 131, '2014-03-15 00:30:42.000000', 'consum', 0.0235, 'lps'),
	(595988, 131, '2014-03-15 00:30:43.000000', 'consum', 0.0233, 'lps'),
	(595989, 131, '2014-03-15 00:30:44.000000', 'consum', 0.0222, 'lps'),
	(595990, 131, '2014-03-15 00:30:45.000000', 'consum', 0.0231, 'lps'),
	(595991, 131, '2014-03-15 00:30:46.000000', 'consum', 0.0224, 'lps'),
	(595992, 131, '2014-03-15 00:30:47.000000', 'consum', 0.0216, 'lps'),
	(595993, 131, '2014-03-15 00:30:48.000000', 'consum', 0.0227, 'lps'),
	(595994, 131, '2014-03-15 00:30:49.000000', 'consum', 0.0222, 'lps'),
	(595995, 131, '2014-03-15 00:30:50.000000', 'consum', 0.0217, 'lps'),
	(595996, 131, '2014-03-15 00:30:51.000000', 'consum', 0.0211, 'lps'),
	(595997, 131, '2014-03-15 00:30:52.000000', 'consum', 0.0223, 'lps'),
	(595998, 131, '2014-03-15 00:30:53.000000', 'consum', 0.0218, 'lps'),
	(595999, 131, '2014-03-15 00:30:54.000000', 'consum', 0.0210, 'lps'),
	(596000, 131, '2014-03-15 00:30:55.000000', 'consum', 0.0214, 'lps'),
	(596001, 131, '2014-03-15 00:30:56.000000', 'consum', 0.0231, 'lps'),
	(596002, 131, '2014-03-15 00:30:57.000000', 'consum', 0.0218, 'lps'),
	(596003, 131, '2014-03-15 00:30:58.000000', 'consum', 0.0217, 'lps'),
	(596004, 131, '2014-03-15 00:30:59.000000', 'consum', 0.0223, 'lps'),
	(596005, 131, '2014-03-15 00:31:00.000000', 'consum', 0.0225, 'lps'),
	(596006, 131, '2014-03-15 00:31:01.000000', 'consum', 0.0217, 'lps'),
	(596007, 131, '2014-03-15 00:31:02.000000', 'consum', 0.0228, 'lps'),
	(596008, 131, '2014-03-15 00:31:03.000000', 'consum', 0.0225, 'lps'),
	(596009, 131, '2014-03-15 00:31:04.000000', 'consum', 0.0230, 'lps'),
	(596010, 131, '2014-03-15 00:31:05.000000', 'consum', 0.0211, 'lps'),
	(596011, 131, '2014-03-15 00:31:06.000000', 'consum', 0.0213, 'lps'),
	(596012, 131, '2014-03-15 00:31:07.000000', 'consum', 0.0221, 'lps'),
	(596013, 131, '2014-03-15 00:31:08.000000', 'consum', 0.0228, 'lps'),
	(596014, 131, '2014-03-15 00:31:09.000000', 'consum', 0.0214, 'lps'),
	(596015, 131, '2014-03-15 00:31:10.000000', 'consum', 0.0231, 'lps'),
	(596016, 131, '2014-03-15 00:31:11.000000', 'consum', 0.0220, 'lps'),
	(596017, 131, '2014-03-15 00:31:12.000000', 'consum', 0.0227, 'lps'),
	(596018, 131, '2014-03-15 00:31:13.000000', 'consum', 0.0237, 'lps'),
	(596019, 131, '2014-03-15 00:31:14.000000', 'consum', 0.0210, 'lps'),
	(596020, 131, '2014-03-15 00:31:15.000000', 'consum', 0.0214, 'lps'),
	(596021, 131, '2014-03-15 00:31:16.000000', 'consum', 0.0229, 'lps'),
	(596022, 131, '2014-03-15 00:31:17.000000', 'consum', 0.0210, 'lps'),
	(596023, 131, '2014-03-15 00:31:18.000000', 'consum', 0.0211, 'lps'),
	(596024, 131, '2014-03-15 00:31:19.000000', 'consum', 0.0215, 'lps'),
	(596025, 131, '2014-03-15 00:31:20.000000', 'consum', 0.0232, 'lps'),
	(596026, 131, '2014-03-15 00:31:21.000000', 'consum', 0.0220, 'lps'),
	(596027, 131, '2014-03-15 00:31:22.000000', 'consum', 0.0225, 'lps'),
	(596028, 131, '2014-03-15 00:31:23.000000', 'consum', 0.0228, 'lps'),
	(596029, 131, '2014-03-15 00:31:24.000000', 'consum', 0.0225, 'lps'),
	(596030, 131, '2014-03-15 00:31:25.000000', 'consum', 0.0234, 'lps'),
	(596031, 131, '2014-03-15 00:31:26.000000', 'consum', 0.0230, 'lps'),
	(596032, 131, '2014-03-15 00:31:27.000000', 'consum', 0.0211, 'lps'),
	(596033, 131, '2014-03-15 00:31:28.000000', 'consum', 0.0212, 'lps'),
	(596034, 131, '2014-03-15 00:31:29.000000', 'consum', 0.0215, 'lps'),
	(596035, 131, '2014-03-15 00:31:30.000000', 'consum', 0.0230, 'lps'),
	(596036, 131, '2014-03-15 00:31:31.000000', 'consum', 0.0211, 'lps'),
	(596037, 131, '2014-03-15 00:31:32.000000', 'consum', 0.0212, 'lps'),
	(596038, 131, '2014-03-15 00:31:33.000000', 'consum', 0.0217, 'lps'),
	(596039, 131, '2014-03-15 00:31:34.000000', 'consum', 0.0214, 'lps'),
	(596040, 131, '2014-03-15 00:31:35.000000', 'consum', 0.0234, 'lps'),
	(596041, 131, '2014-03-15 00:31:36.000000', 'consum', 0.0210, 'lps'),
	(596042, 131, '2014-03-15 00:31:37.000000', 'consum', 0.0220, 'lps'),
	(596043, 131, '2014-03-15 00:31:38.000000', 'consum', 0.0234, 'lps'),
	(596044, 131, '2014-03-15 00:31:39.000000', 'consum', 0.0217, 'lps'),
	(596045, 131, '2014-03-15 00:31:40.000000', 'consum', 0.0231, 'lps'),
	(596046, 131, '2014-03-15 00:31:41.000000', 'consum', 0.0235, 'lps'),
	(596047, 131, '2014-03-15 00:31:42.000000', 'consum', 0.0219, 'lps'),
	(596048, 131, '2014-03-15 00:31:43.000000', 'consum', 0.0234, 'lps'),
	(596049, 131, '2014-03-15 00:31:44.000000', 'consum', 0.0219, 'lps'),
	(596050, 131, '2014-03-15 00:31:45.000000', 'consum', 0.0212, 'lps'),
	(596051, 131, '2014-03-15 00:31:46.000000', 'consum', 0.0223, 'lps'),
	(596052, 131, '2014-03-15 00:31:47.000000', 'consum', 0.0215, 'lps'),
	(596053, 131, '2014-03-15 00:31:48.000000', 'consum', 0.0221, 'lps'),
	(596054, 131, '2014-03-15 00:31:49.000000', 'consum', 0.0223, 'lps'),
	(596055, 131, '2014-03-15 00:31:50.000000', 'consum', 0.0216, 'lps'),
	(596056, 131, '2014-03-15 00:31:51.000000', 'consum', 0.0228, 'lps'),
	(596057, 131, '2014-03-15 00:31:52.000000', 'consum', 0.0228, 'lps'),
	(596058, 131, '2014-03-15 00:31:53.000000', 'consum', 0.0217, 'lps'),
	(596059, 131, '2014-03-15 00:31:54.000000', 'consum', 0.0221, 'lps'),
	(596060, 131, '2014-03-15 00:31:55.000000', 'consum', 0.0214, 'lps'),
	(596061, 131, '2014-03-15 00:31:56.000000', 'consum', 0.0228, 'lps'),
	(596062, 131, '2014-03-15 00:31:57.000000', 'consum', 0.0230, 'lps'),
	(596063, 131, '2014-03-15 00:31:58.000000', 'consum', 0.0232, 'lps'),
	(596064, 131, '2014-03-15 00:31:59.000000', 'consum', 0.0229, 'lps'),
	(596065, 131, '2014-03-15 00:32:00.000000', 'consum', 0.0212, 'lps'),
	(596066, 131, '2014-03-15 00:32:01.000000', 'consum', 0.0222, 'lps'),
	(596067, 131, '2014-03-15 00:32:02.000000', 'consum', 0.0235, 'lps'),
	(596068, 131, '2014-03-15 00:32:03.000000', 'consum', 0.0213, 'lps'),
	(596069, 131, '2014-03-15 00:32:04.000000', 'consum', 0.0210, 'lps'),
	(596070, 131, '2014-03-15 00:32:05.000000', 'consum', 0.0230, 'lps'),
	(596071, 131, '2014-03-15 00:32:06.000000', 'consum', 0.0225, 'lps'),
	(596072, 131, '2014-03-15 00:32:07.000000', 'consum', 0.0227, 'lps'),
	(596073, 131, '2014-03-15 00:32:08.000000', 'consum', 0.0222, 'lps'),
	(596074, 131, '2014-03-15 00:32:09.000000', 'consum', 0.0219, 'lps'),
	(596075, 131, '2014-03-15 00:32:10.000000', 'consum', 0.0219, 'lps'),
	(596076, 131, '2014-03-15 00:32:11.000000', 'consum', 0.0230, 'lps'),
	(596077, 131, '2014-03-15 00:32:12.000000', 'consum', 0.0225, 'lps'),
	(596078, 131, '2014-03-15 00:32:13.000000', 'consum', 0.0225, 'lps'),
	(596079, 131, '2014-03-15 00:32:14.000000', 'consum', 0.0215, 'lps'),
	(596080, 131, '2014-03-15 00:32:15.000000', 'consum', 0.0218, 'lps'),
	(596081, 131, '2014-03-15 00:32:16.000000', 'consum', 0.0237, 'lps'),
	(596082, 131, '2014-03-15 00:32:17.000000', 'consum', 0.0235, 'lps'),
	(596083, 131, '2014-03-15 00:32:18.000000', 'consum', 0.0227, 'lps'),
	(596084, 131, '2014-03-15 00:32:19.000000', 'consum', 0.0219, 'lps'),
	(596085, 131, '2014-03-15 00:32:20.000000', 'consum', 0.0233, 'lps'),
	(596086, 131, '2014-03-15 00:32:21.000000', 'consum', 0.0214, 'lps'),
	(596087, 131, '2014-03-15 00:32:22.000000', 'consum', 0.0216, 'lps'),
	(596088, 131, '2014-03-15 00:32:23.000000', 'consum', 0.0231, 'lps'),
	(596089, 131, '2014-03-15 00:32:24.000000', 'consum', 0.0212, 'lps'),
	(596090, 131, '2014-03-15 00:32:25.000000', 'consum', 0.0213, 'lps'),
	(596091, 131, '2014-03-15 00:32:26.000000', 'consum', 0.0219, 'lps'),
	(596092, 131, '2014-03-15 00:32:27.000000', 'consum', 0.0221, 'lps'),
	(596093, 131, '2014-03-15 00:32:28.000000', 'consum', 0.0236, 'lps'),
	(596094, 131, '2014-03-15 00:32:29.000000', 'consum', 0.0223, 'lps'),
	(596095, 131, '2014-03-15 00:32:30.000000', 'consum', 0.0228, 'lps'),
	(596096, 131, '2014-03-15 00:32:31.000000', 'consum', 0.0233, 'lps'),
	(596097, 131, '2014-03-15 00:32:32.000000', 'consum', 0.0215, 'lps'),
	(596098, 131, '2014-03-15 00:32:33.000000', 'consum', 0.0222, 'lps'),
	(596099, 131, '2014-03-15 00:32:34.000000', 'consum', 0.0229, 'lps'),
	(596100, 131, '2014-03-15 00:32:35.000000', 'consum', 0.0211, 'lps'),
	(596101, 131, '2014-03-15 00:32:36.000000', 'consum', 0.0218, 'lps'),
	(596102, 131, '2014-03-15 00:32:37.000000', 'consum', 0.0217, 'lps'),
	(596103, 131, '2014-03-15 00:32:38.000000', 'consum', 0.0221, 'lps'),
	(596104, 131, '2014-03-15 00:32:39.000000', 'consum', 0.0216, 'lps'),
	(596105, 131, '2014-03-15 00:32:40.000000', 'consum', 0.0236, 'lps'),
	(596106, 131, '2014-03-15 00:32:41.000000', 'consum', 0.0212, 'lps'),
	(596107, 131, '2014-03-15 00:32:42.000000', 'consum', 0.0225, 'lps'),
	(596108, 131, '2014-03-15 00:32:43.000000', 'consum', 0.0223, 'lps'),
	(596109, 131, '2014-03-15 00:32:44.000000', 'consum', 0.0231, 'lps'),
	(596110, 131, '2014-03-15 00:32:45.000000', 'consum', 0.0221, 'lps'),
	(596111, 131, '2014-03-15 00:32:46.000000', 'consum', 0.0230, 'lps'),
	(596112, 131, '2014-03-15 00:32:47.000000', 'consum', 0.0222, 'lps'),
	(596113, 131, '2014-03-15 00:32:48.000000', 'consum', 0.0211, 'lps'),
	(596114, 131, '2014-03-15 00:32:49.000000', 'consum', 0.0233, 'lps'),
	(596115, 131, '2014-03-15 00:32:50.000000', 'consum', 0.0213, 'lps'),
	(596116, 131, '2014-03-15 00:32:51.000000', 'consum', 0.0211, 'lps'),
	(596117, 131, '2014-03-15 00:32:52.000000', 'consum', 0.0233, 'lps'),
	(596118, 131, '2014-03-15 00:32:53.000000', 'consum', 0.0212, 'lps'),
	(596119, 131, '2014-03-15 00:32:54.000000', 'consum', 0.0236, 'lps'),
	(596120, 131, '2014-03-15 00:32:55.000000', 'consum', 0.0221, 'lps'),
	(596121, 131, '2014-03-15 00:32:56.000000', 'consum', 0.0215, 'lps'),
	(596122, 131, '2014-03-15 00:32:57.000000', 'consum', 0.0232, 'lps'),
	(596123, 131, '2014-03-15 00:32:58.000000', 'consum', 0.0220, 'lps'),
	(596124, 131, '2014-03-15 00:32:59.000000', 'consum', 0.0225, 'lps'),
	(596125, 131, '2014-03-15 00:33:00.000000', 'consum', 0.0226, 'lps'),
	(596126, 131, '2014-03-15 00:33:01.000000', 'consum', 0.0219, 'lps'),
	(596127, 131, '2014-03-15 00:33:02.000000', 'consum', 0.0236, 'lps'),
	(596128, 131, '2014-03-15 00:33:03.000000', 'consum', 0.0230, 'lps'),
	(596129, 131, '2014-03-15 00:33:04.000000', 'consum', 0.0231, 'lps'),
	(596130, 131, '2014-03-15 00:33:05.000000', 'consum', 0.0228, 'lps'),
	(596131, 131, '2014-03-15 00:33:06.000000', 'consum', 0.0237, 'lps'),
	(596132, 131, '2014-03-15 00:33:07.000000', 'consum', 0.0237, 'lps'),
	(596133, 131, '2014-03-15 00:33:08.000000', 'consum', 0.0236, 'lps'),
	(596134, 131, '2014-03-15 00:33:09.000000', 'consum', 0.0231, 'lps'),
	(596135, 131, '2014-03-15 00:33:10.000000', 'consum', 0.0236, 'lps'),
	(596136, 131, '2014-03-15 00:33:11.000000', 'consum', 0.0225, 'lps'),
	(596137, 131, '2014-03-15 00:33:12.000000', 'consum', 0.0233, 'lps'),
	(596138, 131, '2014-03-15 00:33:13.000000', 'consum', 0.0225, 'lps'),
	(596139, 131, '2014-03-15 00:33:14.000000', 'consum', 0.0215, 'lps'),
	(596140, 131, '2014-03-15 00:33:15.000000', 'consum', 0.0218, 'lps'),
	(596141, 131, '2014-03-15 00:33:16.000000', 'consum', 0.0236, 'lps'),
	(596142, 131, '2014-03-15 00:33:17.000000', 'consum', 0.0231, 'lps'),
	(596143, 131, '2014-03-15 00:33:18.000000', 'consum', 0.0213, 'lps'),
	(596144, 131, '2014-03-15 00:33:19.000000', 'consum', 0.0216, 'lps'),
	(596145, 131, '2014-03-15 00:33:20.000000', 'consum', 0.0233, 'lps'),
	(596146, 131, '2014-03-15 00:33:21.000000', 'consum', 0.0221, 'lps'),
	(596147, 131, '2014-03-15 00:33:22.000000', 'consum', 0.0226, 'lps'),
	(596148, 131, '2014-03-15 00:33:23.000000', 'consum', 0.0231, 'lps'),
	(596149, 131, '2014-03-15 00:33:24.000000', 'consum', 0.0212, 'lps'),
	(596150, 131, '2014-03-15 00:33:25.000000', 'consum', 0.0211, 'lps'),
	(596151, 131, '2014-03-15 00:33:26.000000', 'consum', 0.0212, 'lps'),
	(596152, 131, '2014-03-15 00:33:27.000000', 'consum', 0.0217, 'lps'),
	(596153, 131, '2014-03-15 00:33:28.000000', 'consum', 0.0210, 'lps'),
	(596154, 131, '2014-03-15 00:33:29.000000', 'consum', 0.0220, 'lps'),
	(596155, 131, '2014-03-15 00:33:30.000000', 'consum', 0.0231, 'lps'),
	(596156, 131, '2014-03-15 00:33:31.000000', 'consum', 0.0230, 'lps'),
	(596157, 131, '2014-03-15 00:33:32.000000', 'consum', 0.0221, 'lps'),
	(596158, 131, '2014-03-15 00:33:33.000000', 'consum', 0.0231, 'lps'),
	(596159, 131, '2014-03-15 00:33:34.000000', 'consum', 0.0227, 'lps'),
	(596160, 131, '2014-03-15 00:33:35.000000', 'consum', 0.0232, 'lps'),
	(596161, 131, '2014-03-15 00:33:36.000000', 'consum', 0.0212, 'lps'),
	(596162, 131, '2014-03-15 00:33:37.000000', 'consum', 0.0211, 'lps'),
	(596163, 131, '2014-03-15 00:33:38.000000', 'consum', 0.0212, 'lps'),
	(596164, 131, '2014-03-15 00:33:39.000000', 'consum', 0.0217, 'lps'),
	(596165, 131, '2014-03-15 00:33:40.000000', 'consum', 0.0213, 'lps'),
	(596166, 131, '2014-03-15 00:33:41.000000', 'consum', 0.0230, 'lps'),
	(596167, 131, '2014-03-15 00:33:42.000000', 'consum', 0.0219, 'lps'),
	(596168, 131, '2014-03-15 00:33:43.000000', 'consum', 0.0224, 'lps'),
	(596169, 131, '2014-03-15 00:33:44.000000', 'consum', 0.0223, 'lps'),
	(596170, 131, '2014-03-15 00:33:45.000000', 'consum', 0.0233, 'lps'),
	(596171, 131, '2014-03-15 00:33:46.000000', 'consum', 0.0233, 'lps'),
	(596172, 131, '2014-03-15 00:33:47.000000', 'consum', 0.0229, 'lps'),
	(596173, 131, '2014-03-15 00:33:48.000000', 'consum', 0.0236, 'lps'),
	(596174, 131, '2014-03-15 00:33:49.000000', 'consum', 0.0229, 'lps'),
	(596175, 131, '2014-03-15 00:33:50.000000', 'consum', 0.0227, 'lps'),
	(596176, 131, '2014-03-15 00:33:51.000000', 'consum', 0.0237, 'lps'),
	(596177, 131, '2014-03-15 00:33:52.000000', 'consum', 0.0211, 'lps'),
	(596178, 131, '2014-03-15 00:33:53.000000', 'consum', 0.0217, 'lps'),
	(596179, 131, '2014-03-15 00:33:54.000000', 'consum', 0.0214, 'lps'),
	(596180, 131, '2014-03-15 00:33:55.000000', 'consum', 0.0211, 'lps'),
	(596181, 131, '2014-03-15 00:33:56.000000', 'consum', 0.0231, 'lps'),
	(596182, 131, '2014-03-15 00:33:57.000000', 'consum', 0.0228, 'lps'),
	(596183, 131, '2014-03-15 00:33:58.000000', 'consum', 0.0211, 'lps'),
	(596184, 131, '2014-03-15 00:33:59.000000', 'consum', 0.0215, 'lps'),
	(596185, 131, '2014-03-15 00:34:00.000000', 'consum', 0.0234, 'lps'),
	(596186, 131, '2014-03-15 00:34:01.000000', 'consum', 0.0231, 'lps'),
	(596187, 131, '2014-03-15 00:34:02.000000', 'consum', 0.0217, 'lps'),
	(596188, 131, '2014-03-15 00:34:03.000000', 'consum', 0.0237, 'lps'),
	(596189, 131, '2014-03-15 00:34:04.000000', 'consum', 0.0215, 'lps'),
	(596190, 131, '2014-03-15 00:34:05.000000', 'consum', 0.0237, 'lps'),
	(596191, 131, '2014-03-15 00:34:06.000000', 'consum', 0.0220, 'lps'),
	(596192, 131, '2014-03-15 00:34:07.000000', 'consum', 0.0232, 'lps'),
	(596193, 131, '2014-03-15 00:34:08.000000', 'consum', 0.0210, 'lps'),
	(596194, 131, '2014-03-15 00:34:09.000000', 'consum', 0.0227, 'lps'),
	(596195, 131, '2014-03-15 00:34:10.000000', 'consum', 0.0213, 'lps'),
	(596196, 131, '2014-03-15 00:34:11.000000', 'consum', 0.0229, 'lps'),
	(596197, 131, '2014-03-15 00:34:12.000000', 'consum', 0.0213, 'lps'),
	(596198, 131, '2014-03-15 00:34:13.000000', 'consum', 0.0226, 'lps'),
	(596199, 131, '2014-03-15 00:34:14.000000', 'consum', 0.0223, 'lps'),
	(596200, 131, '2014-03-15 00:34:15.000000', 'consum', 0.0231, 'lps'),
	(596201, 131, '2014-03-15 00:34:16.000000', 'consum', 0.0217, 'lps'),
	(596202, 131, '2014-03-15 00:34:17.000000', 'consum', 0.0212, 'lps'),
	(596203, 131, '2014-03-15 00:34:18.000000', 'consum', 0.0226, 'lps'),
	(596204, 131, '2014-03-15 00:34:19.000000', 'consum', 0.0228, 'lps'),
	(596205, 131, '2014-03-15 00:34:20.000000', 'consum', 0.0226, 'lps'),
	(596206, 131, '2014-03-15 00:34:21.000000', 'consum', 0.0235, 'lps'),
	(596207, 131, '2014-03-15 00:34:22.000000', 'consum', 0.0234, 'lps'),
	(596208, 131, '2014-03-15 00:34:23.000000', 'consum', 0.0227, 'lps'),
	(596209, 131, '2014-03-15 00:34:24.000000', 'consum', 0.0224, 'lps'),
	(596210, 131, '2014-03-15 00:34:25.000000', 'consum', 0.0231, 'lps'),
	(596211, 131, '2014-03-15 00:34:26.000000', 'consum', 0.0214, 'lps'),
	(596212, 131, '2014-03-15 00:34:27.000000', 'consum', 0.0224, 'lps'),
	(596213, 131, '2014-03-15 00:34:28.000000', 'consum', 0.0215, 'lps'),
	(596214, 131, '2014-03-15 00:34:29.000000', 'consum', 0.0221, 'lps'),
	(596215, 131, '2014-03-15 00:34:30.000000', 'consum', 0.0221, 'lps'),
	(596216, 131, '2014-03-15 00:34:31.000000', 'consum', 0.0231, 'lps'),
	(596217, 131, '2014-03-15 00:34:32.000000', 'consum', 0.0228, 'lps'),
	(596218, 131, '2014-03-15 00:34:33.000000', 'consum', 0.0211, 'lps'),
	(596219, 131, '2014-03-15 00:34:34.000000', 'consum', 0.0218, 'lps'),
	(596220, 131, '2014-03-15 00:34:35.000000', 'consum', 0.0216, 'lps'),
	(596221, 131, '2014-03-15 00:34:36.000000', 'consum', 0.0220, 'lps'),
	(596222, 131, '2014-03-15 00:34:37.000000', 'consum', 0.0215, 'lps'),
	(596223, 131, '2014-03-15 00:34:38.000000', 'consum', 0.0230, 'lps'),
	(596224, 131, '2014-03-15 00:34:39.000000', 'consum', 0.0214, 'lps'),
	(596225, 131, '2014-03-15 00:34:40.000000', 'consum', 0.0225, 'lps'),
	(596226, 131, '2014-03-15 00:34:41.000000', 'consum', 0.0219, 'lps'),
	(596227, 131, '2014-03-15 00:34:42.000000', 'consum', 0.0237, 'lps'),
	(596228, 131, '2014-03-15 00:34:43.000000', 'consum', 0.0233, 'lps'),
	(596229, 131, '2014-03-15 00:34:44.000000', 'consum', 0.0219, 'lps'),
	(596230, 131, '2014-03-15 00:34:45.000000', 'consum', 0.0213, 'lps'),
	(596231, 131, '2014-03-15 00:34:46.000000', 'consum', 0.0229, 'lps'),
	(596232, 131, '2014-03-15 00:34:47.000000', 'consum', 0.0212, 'lps'),
	(596233, 131, '2014-03-15 00:34:48.000000', 'consum', 0.0218, 'lps'),
	(596234, 131, '2014-03-15 00:34:49.000000', 'consum', 0.0216, 'lps'),
	(596235, 131, '2014-03-15 00:34:50.000000', 'consum', 0.0216, 'lps'),
	(596236, 131, '2014-03-15 00:34:51.000000', 'consum', 0.0225, 'lps'),
	(596237, 131, '2014-03-15 00:34:52.000000', 'consum', 0.0210, 'lps'),
	(596238, 131, '2014-03-15 00:34:53.000000', 'consum', 0.0220, 'lps'),
	(596239, 131, '2014-03-15 00:34:54.000000', 'consum', 0.0235, 'lps'),
	(596240, 131, '2014-03-15 00:34:55.000000', 'consum', 0.0222, 'lps'),
	(596241, 131, '2014-03-15 00:34:56.000000', 'consum', 0.0224, 'lps'),
	(596242, 131, '2014-03-15 00:34:57.000000', 'consum', 0.0216, 'lps'),
	(596243, 131, '2014-03-15 00:34:58.000000', 'consum', 0.0224, 'lps'),
	(596244, 131, '2014-03-15 00:34:59.000000', 'consum', 0.0236, 'lps'),
	(596245, 131, '2014-03-15 00:35:00.000000', 'consum', 0.0217, 'lps'),
	(596246, 131, '2014-03-15 00:35:01.000000', 'consum', 0.0220, 'lps'),
	(596247, 131, '2014-03-15 00:35:02.000000', 'consum', 0.0214, 'lps'),
	(596248, 131, '2014-03-15 00:35:03.000000', 'consum', 0.0226, 'lps'),
	(596249, 131, '2014-03-15 00:35:04.000000', 'consum', 0.0222, 'lps'),
	(596250, 131, '2014-03-15 00:35:05.000000', 'consum', 0.0224, 'lps'),
	(596251, 131, '2014-03-15 00:35:06.000000', 'consum', 0.0217, 'lps'),
	(596252, 131, '2014-03-15 00:35:07.000000', 'consum', 0.0231, 'lps'),
	(596253, 131, '2014-03-15 00:35:08.000000', 'consum', 0.0211, 'lps'),
	(596254, 131, '2014-03-15 00:35:09.000000', 'consum', 0.0235, 'lps'),
	(596255, 131, '2014-03-15 00:35:10.000000', 'consum', 0.0223, 'lps'),
	(596256, 131, '2014-03-15 00:35:11.000000', 'consum', 0.0226, 'lps'),
	(596257, 131, '2014-03-15 00:35:12.000000', 'consum', 0.0226, 'lps'),
	(596258, 131, '2014-03-15 00:35:13.000000', 'consum', 0.0215, 'lps'),
	(596259, 131, '2014-03-15 00:35:14.000000', 'consum', 0.0216, 'lps'),
	(596260, 131, '2014-03-15 00:35:15.000000', 'consum', 0.0226, 'lps'),
	(596261, 131, '2014-03-15 00:35:16.000000', 'consum', 0.0215, 'lps'),
	(596262, 131, '2014-03-15 00:35:17.000000', 'consum', 0.0216, 'lps'),
	(596263, 131, '2014-03-15 00:35:18.000000', 'consum', 0.0225, 'lps'),
	(596264, 131, '2014-03-15 00:35:19.000000', 'consum', 0.0213, 'lps'),
	(596265, 131, '2014-03-15 00:35:20.000000', 'consum', 0.0236, 'lps'),
	(596266, 131, '2014-03-15 00:35:21.000000', 'consum', 0.0219, 'lps'),
	(596267, 131, '2014-03-15 00:35:22.000000', 'consum', 0.0235, 'lps'),
	(596268, 131, '2014-03-15 00:35:23.000000', 'consum', 0.0224, 'lps'),
	(596269, 131, '2014-03-15 00:35:24.000000', 'consum', 0.0232, 'lps'),
	(596270, 131, '2014-03-15 00:35:25.000000', 'consum', 0.0221, 'lps'),
	(596271, 131, '2014-03-15 00:35:26.000000', 'consum', 0.0230, 'lps'),
	(596272, 131, '2014-03-15 00:35:27.000000', 'consum', 0.0222, 'lps'),
	(596273, 131, '2014-03-15 00:35:28.000000', 'consum', 0.0211, 'lps'),
	(596274, 131, '2014-03-15 00:35:29.000000', 'consum', 0.0233, 'lps'),
	(596275, 131, '2014-03-15 00:35:30.000000', 'consum', 0.0212, 'lps'),
	(596276, 131, '2014-03-15 00:35:31.000000', 'consum', 0.0234, 'lps'),
	(596277, 131, '2014-03-15 00:35:32.000000', 'consum', 0.0211, 'lps'),
	(596278, 131, '2014-03-15 00:35:33.000000', 'consum', 0.0231, 'lps'),
	(596279, 131, '2014-03-15 00:35:34.000000', 'consum', 0.0227, 'lps'),
	(596280, 131, '2014-03-15 00:35:35.000000', 'consum', 0.0233, 'lps'),
	(596281, 131, '2014-03-15 00:35:36.000000', 'consum', 0.0219, 'lps'),
	(596282, 131, '2014-03-15 00:35:37.000000', 'consum', 0.0216, 'lps'),
	(596283, 131, '2014-03-15 00:35:38.000000', 'consum', 0.0211, 'lps'),
	(596284, 131, '2014-03-15 00:35:39.000000', 'consum', 0.0228, 'lps'),
	(596285, 131, '2014-03-15 00:35:40.000000', 'consum', 0.0211, 'lps'),
	(596286, 131, '2014-03-15 00:35:41.000000', 'consum', 0.0218, 'lps'),
	(596287, 131, '2014-03-15 00:35:42.000000', 'consum', 0.0219, 'lps'),
	(596288, 131, '2014-03-15 00:35:43.000000', 'consum', 0.0231, 'lps'),
	(596289, 131, '2014-03-15 00:35:44.000000', 'consum', 0.0232, 'lps'),
	(596290, 131, '2014-03-15 00:35:45.000000', 'consum', 0.0228, 'lps'),
	(596291, 131, '2014-03-15 00:35:46.000000', 'consum', 0.0237, 'lps'),
	(596292, 131, '2014-03-15 00:35:47.000000', 'consum', 0.0237, 'lps'),
	(596293, 131, '2014-03-15 00:35:48.000000', 'consum', 0.0233, 'lps'),
	(596294, 131, '2014-03-15 00:35:49.000000', 'consum', 0.0218, 'lps'),
	(596295, 131, '2014-03-15 00:35:50.000000', 'consum', 0.0211, 'lps'),
	(596296, 131, '2014-03-15 00:35:51.000000', 'consum', 0.0218, 'lps'),
	(596297, 131, '2014-03-15 00:35:52.000000', 'consum', 0.0220, 'lps'),
	(596298, 131, '2014-03-15 00:35:53.000000', 'consum', 0.0237, 'lps'),
	(596299, 131, '2014-03-15 00:35:54.000000', 'consum', 0.0231, 'lps'),
	(596300, 131, '2014-03-15 00:35:55.000000', 'consum', 0.0233, 'lps'),
	(596301, 131, '2014-03-15 00:35:56.000000', 'consum', 0.0235, 'lps'),
	(596302, 131, '2014-03-15 00:35:57.000000', 'consum', 0.0237, 'lps'),
	(596303, 131, '2014-03-15 00:35:58.000000', 'consum', 0.0215, 'lps'),
	(596304, 131, '2014-03-15 00:35:59.000000', 'consum', 0.0213, 'lps'),
	(596305, 131, '2014-03-15 00:36:00.000000', 'consum', 0.0237, 'lps'),
	(596306, 131, '2014-03-15 00:36:01.000000', 'consum', 0.0223, 'lps'),
	(596307, 131, '2014-03-15 00:36:02.000000', 'consum', 0.0224, 'lps'),
	(596308, 131, '2014-03-15 00:36:03.000000', 'consum', 0.0215, 'lps'),
	(596309, 131, '2014-03-15 00:36:04.000000', 'consum', 0.0219, 'lps'),
	(596310, 131, '2014-03-15 00:36:05.000000', 'consum', 0.0212, 'lps'),
	(596311, 131, '2014-03-15 00:36:06.000000', 'consum', 0.0222, 'lps'),
	(596312, 131, '2014-03-15 00:36:07.000000', 'consum', 0.0211, 'lps'),
	(596313, 131, '2014-03-15 00:36:08.000000', 'consum', 0.0233, 'lps'),
	(596314, 131, '2014-03-15 00:36:09.000000', 'consum', 0.0211, 'lps'),
	(596315, 131, '2014-03-15 00:36:10.000000', 'consum', 0.0231, 'lps'),
	(596316, 131, '2014-03-15 00:36:11.000000', 'consum', 0.0230, 'lps'),
	(596317, 131, '2014-03-15 00:36:12.000000', 'consum', 0.0218, 'lps'),
	(596318, 131, '2014-03-15 00:36:13.000000', 'consum', 0.0221, 'lps'),
	(596319, 131, '2014-03-15 00:36:14.000000', 'consum', 0.0211, 'lps'),
	(596320, 131, '2014-03-15 00:36:15.000000', 'consum', 0.0212, 'lps'),
	(596321, 131, '2014-03-15 00:36:16.000000', 'consum', 0.0215, 'lps'),
	(596322, 131, '2014-03-15 00:36:17.000000', 'consum', 0.0232, 'lps'),
	(596323, 131, '2014-03-15 00:36:18.000000', 'consum', 0.0220, 'lps'),
	(596324, 131, '2014-03-15 00:36:19.000000', 'consum', 0.0222, 'lps'),
	(596325, 131, '2014-03-15 00:36:20.000000', 'consum', 0.0214, 'lps'),
	(596326, 131, '2014-03-15 00:36:21.000000', 'consum', 0.0221, 'lps'),
	(596327, 131, '2014-03-15 00:36:22.000000', 'consum', 0.0227, 'lps'),
	(596328, 131, '2014-03-15 00:36:23.000000', 'consum', 0.0235, 'lps'),
	(596329, 131, '2014-03-15 00:36:24.000000', 'consum', 0.0228, 'lps'),
	(596330, 131, '2014-03-15 00:36:25.000000', 'consum', 0.0224, 'lps'),
	(596331, 131, '2014-03-15 00:36:26.000000', 'consum', 0.0227, 'lps'),
	(596332, 131, '2014-03-15 00:36:27.000000', 'consum', 0.0225, 'lps'),
	(596333, 131, '2014-03-15 00:36:28.000000', 'consum', 0.0236, 'lps'),
	(596334, 131, '2014-03-15 00:36:29.000000', 'consum', 0.0212, 'lps'),
	(596335, 131, '2014-03-15 00:36:30.000000', 'consum', 0.0224, 'lps'),
	(596336, 131, '2014-03-15 00:36:31.000000', 'consum', 0.0218, 'lps'),
	(596337, 131, '2014-03-15 00:36:32.000000', 'consum', 0.0211, 'lps'),
	(596338, 131, '2014-03-15 00:36:33.000000', 'consum', 0.0220, 'lps'),
	(596339, 131, '2014-03-15 00:36:34.000000', 'consum', 0.0230, 'lps'),
	(596340, 131, '2014-03-15 00:36:35.000000', 'consum', 0.0225, 'lps'),
	(596341, 131, '2014-03-15 00:36:36.000000', 'consum', 0.0226, 'lps'),
	(596342, 131, '2014-03-15 00:36:37.000000', 'consum', 0.0215, 'lps'),
	(596343, 131, '2014-03-15 00:36:38.000000', 'consum', 0.0214, 'lps'),
	(596344, 131, '2014-03-15 00:36:39.000000', 'consum', 0.0219, 'lps'),
	(596345, 131, '2014-03-15 00:36:40.000000', 'consum', 0.0214, 'lps'),
	(596346, 131, '2014-03-15 00:36:41.000000', 'consum', 0.0230, 'lps'),
	(596347, 131, '2014-03-15 00:36:42.000000', 'consum', 0.0214, 'lps'),
	(596348, 131, '2014-03-15 00:36:43.000000', 'consum', 0.0227, 'lps'),
	(596349, 131, '2014-03-15 00:36:44.000000', 'consum', 0.0226, 'lps'),
	(596350, 131, '2014-03-15 00:36:45.000000', 'consum', 0.0214, 'lps'),
	(596351, 131, '2014-03-15 00:36:46.000000', 'consum', 0.0212, 'lps'),
	(596352, 131, '2014-03-15 00:36:47.000000', 'consum', 0.0233, 'lps'),
	(596353, 131, '2014-03-15 00:36:48.000000', 'consum', 0.0236, 'lps'),
	(596354, 131, '2014-03-15 00:36:49.000000', 'consum', 0.0215, 'lps'),
	(596355, 131, '2014-03-15 00:36:50.000000', 'consum', 0.0216, 'lps'),
	(596356, 131, '2014-03-15 00:36:51.000000', 'consum', 0.0223, 'lps'),
	(596357, 131, '2014-03-15 00:36:52.000000', 'consum', 0.0229, 'lps'),
	(596358, 131, '2014-03-15 00:36:53.000000', 'consum', 0.0211, 'lps'),
	(596359, 131, '2014-03-15 00:36:54.000000', 'consum', 0.0214, 'lps'),
	(596360, 131, '2014-03-15 00:36:55.000000', 'consum', 0.0229, 'lps'),
	(596361, 131, '2014-03-15 00:36:56.000000', 'consum', 0.0236, 'lps'),
	(596362, 131, '2014-03-15 00:36:57.000000', 'consum', 0.0226, 'lps'),
	(596363, 131, '2014-03-15 00:36:58.000000', 'consum', 0.0216, 'lps'),
	(596364, 131, '2014-03-15 00:36:59.000000', 'consum', 0.0218, 'lps'),
	(596365, 131, '2014-03-15 00:37:00.000000', 'consum', 0.0232, 'lps'),
	(596366, 131, '2014-03-15 00:37:01.000000', 'consum', 0.0215, 'lps'),
	(596367, 131, '2014-03-15 00:37:02.000000', 'consum', 0.0224, 'lps'),
	(596368, 131, '2014-03-15 00:37:03.000000', 'consum', 0.0210, 'lps'),
	(596369, 131, '2014-03-15 00:37:04.000000', 'consum', 0.0225, 'lps'),
	(596370, 131, '2014-03-15 00:37:05.000000', 'consum', 0.0231, 'lps'),
	(596371, 131, '2014-03-15 00:37:06.000000', 'consum', 0.0213, 'lps'),
	(596372, 131, '2014-03-15 00:37:07.000000', 'consum', 0.0218, 'lps'),
	(596373, 131, '2014-03-15 00:37:08.000000', 'consum', 0.0215, 'lps'),
	(596374, 131, '2014-03-15 00:37:09.000000', 'consum', 0.0210, 'lps'),
	(596375, 131, '2014-03-15 00:37:10.000000', 'consum', 0.0224, 'lps'),
	(596376, 131, '2014-03-15 00:37:11.000000', 'consum', 0.0224, 'lps'),
	(596377, 131, '2014-03-15 00:37:12.000000', 'consum', 0.0211, 'lps'),
	(596378, 131, '2014-03-15 00:37:13.000000', 'consum', 0.0231, 'lps'),
	(596379, 131, '2014-03-15 00:37:14.000000', 'consum', 0.0227, 'lps'),
	(596380, 131, '2014-03-15 00:37:15.000000', 'consum', 0.0234, 'lps'),
	(596381, 131, '2014-03-15 00:37:16.000000', 'consum', 0.0225, 'lps'),
	(596382, 131, '2014-03-15 00:37:17.000000', 'consum', 0.0210, 'lps'),
	(596383, 131, '2014-03-15 00:37:18.000000', 'consum', 0.0222, 'lps'),
	(596384, 131, '2014-03-15 00:37:19.000000', 'consum', 0.0217, 'lps'),
	(596385, 131, '2014-03-15 00:37:20.000000', 'consum', 0.0235, 'lps'),
	(596386, 131, '2014-03-15 00:37:21.000000', 'consum', 0.0232, 'lps'),
	(596387, 131, '2014-03-15 00:37:22.000000', 'consum', 0.0216, 'lps'),
	(596388, 131, '2014-03-15 00:37:23.000000', 'consum', 0.0231, 'lps'),
	(596389, 131, '2014-03-15 00:37:24.000000', 'consum', 0.0212, 'lps'),
	(596390, 131, '2014-03-15 00:37:25.000000', 'consum', 0.0217, 'lps'),
	(596391, 131, '2014-03-15 00:37:26.000000', 'consum', 0.0236, 'lps'),
	(596392, 131, '2014-03-15 00:37:27.000000', 'consum', 0.0210, 'lps'),
	(596393, 131, '2014-03-15 00:37:28.000000', 'consum', 0.0216, 'lps'),
	(596394, 131, '2014-03-15 00:37:29.000000', 'consum', 0.0211, 'lps'),
	(596395, 131, '2014-03-15 00:37:30.000000', 'consum', 0.0225, 'lps'),
	(596396, 131, '2014-03-15 00:37:31.000000', 'consum', 0.0226, 'lps'),
	(596397, 131, '2014-03-15 00:37:32.000000', 'consum', 0.0220, 'lps'),
	(596398, 131, '2014-03-15 00:37:33.000000', 'consum', 0.0210, 'lps'),
	(596399, 131, '2014-03-15 00:37:34.000000', 'consum', 0.0237, 'lps'),
	(596400, 131, '2014-03-15 00:37:35.000000', 'consum', 0.0235, 'lps'),
	(596401, 131, '2014-03-15 00:37:36.000000', 'consum', 0.0224, 'lps'),
	(596402, 131, '2014-03-15 00:37:37.000000', 'consum', 0.0236, 'lps'),
	(596403, 131, '2014-03-15 00:37:38.000000', 'consum', 0.0215, 'lps'),
	(596404, 131, '2014-03-15 00:37:39.000000', 'consum', 0.0210, 'lps'),
	(596405, 131, '2014-03-15 00:37:40.000000', 'consum', 0.0227, 'lps'),
	(596406, 131, '2014-03-15 00:37:41.000000', 'consum', 0.0210, 'lps'),
	(596407, 131, '2014-03-15 00:37:42.000000', 'consum', 0.0217, 'lps'),
	(596408, 131, '2014-03-15 00:37:43.000000', 'consum', 0.0218, 'lps'),
	(596409, 131, '2014-03-15 00:37:44.000000', 'consum', 0.0230, 'lps'),
	(596410, 131, '2014-03-15 00:37:45.000000', 'consum', 0.0229, 'lps'),
	(596411, 131, '2014-03-15 00:37:46.000000', 'consum', 0.0217, 'lps'),
	(596412, 131, '2014-03-15 00:37:47.000000', 'consum', 0.0219, 'lps'),
	(596413, 131, '2014-03-15 00:37:48.000000', 'consum', 0.0233, 'lps'),
	(596414, 131, '2014-03-15 00:37:49.000000', 'consum', 0.0215, 'lps'),
	(596415, 131, '2014-03-15 00:37:50.000000', 'consum', 0.0222, 'lps'),
	(596416, 131, '2014-03-15 00:37:51.000000', 'consum', 0.0228, 'lps'),
	(596417, 131, '2014-03-15 00:37:52.000000', 'consum', 0.0236, 'lps'),
	(596418, 131, '2014-03-15 00:37:53.000000', 'consum', 0.0232, 'lps'),
	(596419, 131, '2014-03-15 00:37:54.000000', 'consum', 0.0214, 'lps'),
	(596420, 131, '2014-03-15 00:37:55.000000', 'consum', 0.0221, 'lps'),
	(596421, 131, '2014-03-15 00:37:56.000000', 'consum', 0.0226, 'lps'),
	(596422, 131, '2014-03-15 00:37:57.000000', 'consum', 0.0228, 'lps'),
	(596423, 131, '2014-03-15 00:37:58.000000', 'consum', 0.0223, 'lps'),
	(596424, 131, '2014-03-15 00:37:59.000000', 'consum', 0.0223, 'lps'),
	(596425, 131, '2014-03-15 00:38:00.000000', 'consum', 0.0236, 'lps'),
	(596426, 131, '2014-03-15 00:38:01.000000', 'consum', 0.0217, 'lps'),
	(596427, 131, '2014-03-15 00:38:02.000000', 'consum', 0.0222, 'lps'),
	(596428, 131, '2014-03-15 00:38:03.000000', 'consum', 0.0224, 'lps'),
	(596429, 131, '2014-03-15 00:38:04.000000', 'consum', 0.0217, 'lps'),
	(596430, 131, '2014-03-15 00:38:05.000000', 'consum', 0.0230, 'lps'),
	(596431, 131, '2014-03-15 00:38:06.000000', 'consum', 0.0234, 'lps'),
	(596432, 131, '2014-03-15 00:38:07.000000', 'consum', 0.0214, 'lps'),
	(596433, 131, '2014-03-15 00:38:08.000000', 'consum', 0.0213, 'lps'),
	(596434, 131, '2014-03-15 00:38:09.000000', 'consum', 0.0216, 'lps'),
	(596435, 131, '2014-03-15 00:38:10.000000', 'consum', 0.0230, 'lps'),
	(596436, 131, '2014-03-15 00:38:11.000000', 'consum', 0.0237, 'lps'),
	(596437, 131, '2014-03-15 00:38:12.000000', 'consum', 0.0228, 'lps'),
	(596438, 131, '2014-03-15 00:38:13.000000', 'consum', 0.0219, 'lps'),
	(596439, 131, '2014-03-15 00:38:14.000000', 'consum', 0.0230, 'lps'),
	(596440, 131, '2014-03-15 00:38:15.000000', 'consum', 0.0228, 'lps'),
	(596441, 131, '2014-03-15 00:38:16.000000', 'consum', 0.0214, 'lps'),
	(596442, 131, '2014-03-15 00:38:17.000000', 'consum', 0.0230, 'lps'),
	(596443, 131, '2014-03-15 00:38:18.000000', 'consum', 0.0217, 'lps'),
	(596444, 131, '2014-03-15 00:38:19.000000', 'consum', 0.0211, 'lps'),
	(596445, 131, '2014-03-15 00:38:20.000000', 'consum', 0.0222, 'lps'),
	(596446, 131, '2014-03-15 00:38:21.000000', 'consum', 0.0214, 'lps'),
	(596447, 131, '2014-03-15 00:38:22.000000', 'consum', 0.0221, 'lps'),
	(596448, 131, '2014-03-15 00:38:23.000000', 'consum', 0.0226, 'lps'),
	(596449, 131, '2014-03-15 00:38:24.000000', 'consum', 0.0231, 'lps'),
	(596450, 131, '2014-03-15 00:38:25.000000', 'consum', 0.0212, 'lps'),
	(596451, 131, '2014-03-15 00:38:26.000000', 'consum', 0.0213, 'lps'),
	(596452, 131, '2014-03-15 00:38:27.000000', 'consum', 0.0219, 'lps'),
	(596453, 131, '2014-03-15 00:38:28.000000', 'consum', 0.0218, 'lps'),
	(596454, 131, '2014-03-15 00:38:29.000000', 'consum', 0.0225, 'lps'),
	(596455, 131, '2014-03-15 00:38:30.000000', 'consum', 0.0234, 'lps'),
	(596456, 131, '2014-03-15 00:38:31.000000', 'consum', 0.0230, 'lps'),
	(596457, 131, '2014-03-15 00:38:32.000000', 'consum', 0.0236, 'lps'),
	(596458, 131, '2014-03-15 00:38:33.000000', 'consum', 0.0226, 'lps'),
	(596459, 131, '2014-03-15 00:38:34.000000', 'consum', 0.0212, 'lps'),
	(596460, 131, '2014-03-15 00:38:35.000000', 'consum', 0.0231, 'lps'),
	(596461, 131, '2014-03-15 00:38:36.000000', 'consum', 0.0222, 'lps'),
	(596462, 131, '2014-03-15 00:38:37.000000', 'consum', 0.0236, 'lps'),
	(596463, 131, '2014-03-15 00:38:38.000000', 'consum', 0.0223, 'lps'),
	(596464, 131, '2014-03-15 00:38:39.000000', 'consum', 0.0224, 'lps'),
	(596465, 131, '2014-03-15 00:38:40.000000', 'consum', 0.0215, 'lps'),
	(596466, 131, '2014-03-15 00:38:41.000000', 'consum', 0.0220, 'lps'),
	(596467, 131, '2014-03-15 00:38:42.000000', 'consum', 0.0216, 'lps'),
	(596468, 131, '2014-03-15 00:38:43.000000', 'consum', 0.0212, 'lps'),
	(596469, 131, '2014-03-15 00:38:44.000000', 'consum', 0.0228, 'lps'),
	(596470, 131, '2014-03-15 00:38:45.000000', 'consum', 0.0213, 'lps'),
	(596471, 131, '2014-03-15 00:38:46.000000', 'consum', 0.0227, 'lps'),
	(596472, 131, '2014-03-15 00:38:47.000000', 'consum', 0.0232, 'lps'),
	(596473, 131, '2014-03-15 00:38:48.000000', 'consum', 0.0212, 'lps'),
	(596474, 131, '2014-03-15 00:38:49.000000', 'consum', 0.0210, 'lps'),
	(596475, 131, '2014-03-15 00:38:50.000000', 'consum', 0.0234, 'lps'),
	(596476, 131, '2014-03-15 00:38:51.000000', 'consum', 0.0219, 'lps'),
	(596477, 131, '2014-03-15 00:38:52.000000', 'consum', 0.0237, 'lps'),
	(596478, 131, '2014-03-15 00:38:53.000000', 'consum', 0.0234, 'lps'),
	(596479, 131, '2014-03-15 00:38:54.000000', 'consum', 0.0222, 'lps'),
	(596480, 131, '2014-03-15 00:38:55.000000', 'consum', 0.0226, 'lps'),
	(596481, 131, '2014-03-15 00:38:56.000000', 'consum', 0.0226, 'lps'),
	(596482, 131, '2014-03-15 00:38:57.000000', 'consum', 0.0213, 'lps'),
	(596483, 131, '2014-03-15 00:38:58.000000', 'consum', 0.0236, 'lps'),
	(596484, 131, '2014-03-15 00:38:59.000000', 'consum', 0.0221, 'lps'),
	(596485, 131, '2014-03-15 00:39:00.000000', 'consum', 0.0213, 'lps'),
	(596486, 131, '2014-03-15 00:39:01.000000', 'consum', 0.0222, 'lps'),
	(596487, 131, '2014-03-15 00:39:02.000000', 'consum', 0.0231, 'lps'),
	(596488, 131, '2014-03-15 00:39:03.000000', 'consum', 0.0226, 'lps'),
	(596489, 131, '2014-03-15 00:39:04.000000', 'consum', 0.0229, 'lps'),
	(596490, 131, '2014-03-15 00:39:05.000000', 'consum', 0.0227, 'lps'),
	(596491, 131, '2014-03-15 00:39:06.000000', 'consum', 0.0211, 'lps'),
	(596492, 131, '2014-03-15 00:39:07.000000', 'consum', 0.0219, 'lps'),
	(596493, 131, '2014-03-15 00:39:08.000000', 'consum', 0.0224, 'lps'),
	(596494, 131, '2014-03-15 00:39:09.000000', 'consum', 0.0225, 'lps'),
	(596495, 131, '2014-03-15 00:39:10.000000', 'consum', 0.0218, 'lps'),
	(596496, 131, '2014-03-15 00:39:11.000000', 'consum', 0.0232, 'lps'),
	(596497, 131, '2014-03-15 00:39:12.000000', 'consum', 0.0211, 'lps'),
	(596498, 131, '2014-03-15 00:39:13.000000', 'consum', 0.0236, 'lps'),
	(596499, 131, '2014-03-15 00:39:14.000000', 'consum', 0.0225, 'lps'),
	(596500, 131, '2014-03-15 00:39:15.000000', 'consum', 0.0233, 'lps'),
	(596501, 131, '2014-03-15 00:39:16.000000', 'consum', 0.0228, 'lps'),
	(596502, 131, '2014-03-15 00:39:17.000000', 'consum', 0.0228, 'lps'),
	(596503, 131, '2014-03-15 00:39:18.000000', 'consum', 0.0221, 'lps'),
	(596504, 131, '2014-03-15 00:39:19.000000', 'consum', 0.0237, 'lps'),
	(596505, 131, '2014-03-15 00:39:20.000000', 'consum', 0.0232, 'lps'),
	(596506, 131, '2014-03-15 00:39:21.000000', 'consum', 0.0237, 'lps'),
	(596507, 131, '2014-03-15 00:39:22.000000', 'consum', 0.0223, 'lps'),
	(596508, 131, '2014-03-15 00:39:23.000000', 'consum', 0.0225, 'lps'),
	(596509, 131, '2014-03-15 00:39:24.000000', 'consum', 0.0216, 'lps'),
	(596510, 131, '2014-03-15 00:39:25.000000', 'consum', 0.0224, 'lps'),
	(596511, 131, '2014-03-15 00:39:26.000000', 'consum', 0.0233, 'lps'),
	(596512, 131, '2014-03-15 00:39:27.000000', 'consum', 0.0228, 'lps'),
	(596513, 131, '2014-03-15 00:39:28.000000', 'consum', 0.0233, 'lps'),
	(596514, 131, '2014-03-15 00:39:29.000000', 'consum', 0.0214, 'lps'),
	(596515, 131, '2014-03-15 00:39:30.000000', 'consum', 0.0216, 'lps'),
	(596516, 131, '2014-03-15 00:39:31.000000', 'consum', 0.0231, 'lps'),
	(596517, 131, '2014-03-15 00:39:32.000000', 'consum', 0.0213, 'lps'),
	(596518, 131, '2014-03-15 00:39:33.000000', 'consum', 0.0218, 'lps'),
	(596519, 131, '2014-03-15 00:39:34.000000', 'consum', 0.0213, 'lps'),
	(596520, 131, '2014-03-15 00:39:35.000000', 'consum', 0.0229, 'lps'),
	(596521, 131, '2014-03-15 00:39:36.000000', 'consum', 0.0214, 'lps'),
	(596522, 131, '2014-03-15 00:39:37.000000', 'consum', 0.0229, 'lps'),
	(596523, 131, '2014-03-15 00:39:38.000000', 'consum', 0.0236, 'lps'),
	(596524, 131, '2014-03-15 00:39:39.000000', 'consum', 0.0229, 'lps'),
	(596525, 131, '2014-03-15 00:39:40.000000', 'consum', 0.0229, 'lps'),
	(596526, 131, '2014-03-15 00:39:41.000000', 'consum', 0.0218, 'lps'),
	(596527, 131, '2014-03-15 00:39:42.000000', 'consum', 0.0224, 'lps'),
	(596528, 131, '2014-03-15 00:39:43.000000', 'consum', 0.0229, 'lps'),
	(596529, 131, '2014-03-15 00:39:44.000000', 'consum', 0.0235, 'lps'),
	(596530, 131, '2014-03-15 00:39:45.000000', 'consum', 0.0224, 'lps'),
	(596531, 131, '2014-03-15 00:39:46.000000', 'consum', 0.0233, 'lps'),
	(596532, 131, '2014-03-15 00:39:47.000000', 'consum', 0.0225, 'lps'),
	(596533, 131, '2014-03-15 00:39:48.000000', 'consum', 0.0218, 'lps'),
	(596534, 131, '2014-03-15 00:39:49.000000', 'consum', 0.0232, 'lps'),
	(596535, 131, '2014-03-15 00:39:50.000000', 'consum', 0.0212, 'lps'),
	(596536, 131, '2014-03-15 00:39:51.000000', 'consum', 0.0213, 'lps'),
	(596537, 131, '2014-03-15 00:39:52.000000', 'consum', 0.0218, 'lps'),
	(596538, 131, '2014-03-15 00:39:53.000000', 'consum', 0.0215, 'lps'),
	(596539, 131, '2014-03-15 00:39:54.000000', 'consum', 0.0237, 'lps'),
	(596540, 131, '2014-03-15 00:39:55.000000', 'consum', 0.0221, 'lps'),
	(596541, 131, '2014-03-15 00:39:56.000000', 'consum', 0.0211, 'lps'),
	(596542, 131, '2014-03-15 00:39:57.000000', 'consum', 0.0237, 'lps'),
	(596543, 131, '2014-03-15 00:39:58.000000', 'consum', 0.0233, 'lps'),
	(596544, 131, '2014-03-15 00:39:59.000000', 'consum', 0.0214, 'lps'),
	(596545, 131, '2014-03-15 00:40:00.000000', 'consum', 0.0221, 'lps'),
	(596546, 131, '2014-03-15 00:40:01.000000', 'consum', 0.0222, 'lps'),
	(596547, 131, '2014-03-15 00:40:02.000000', 'consum', 0.0211, 'lps'),
	(596548, 131, '2014-03-15 00:40:03.000000', 'consum', 0.0234, 'lps'),
	(596549, 131, '2014-03-15 00:40:04.000000', 'consum', 0.0216, 'lps'),
	(596550, 131, '2014-03-15 00:40:05.000000', 'consum', 0.0224, 'lps'),
	(596551, 131, '2014-03-15 00:40:06.000000', 'consum', 0.0235, 'lps'),
	(596552, 131, '2014-03-15 00:40:07.000000', 'consum', 0.0211, 'lps'),
	(596553, 131, '2014-03-15 00:40:08.000000', 'consum', 0.0224, 'lps'),
	(596554, 131, '2014-03-15 00:40:09.000000', 'consum', 0.0223, 'lps'),
	(596555, 131, '2014-03-15 00:40:10.000000', 'consum', 0.0231, 'lps'),
	(596556, 131, '2014-03-15 00:40:11.000000', 'consum', 0.0222, 'lps'),
	(596557, 131, '2014-03-15 00:40:12.000000', 'consum', 0.0235, 'lps'),
	(596558, 131, '2014-03-15 00:40:13.000000', 'consum', 0.0216, 'lps'),
	(596559, 131, '2014-03-15 00:40:14.000000', 'consum', 0.0221, 'lps'),
	(596560, 131, '2014-03-15 00:40:15.000000', 'consum', 0.0221, 'lps'),
	(596561, 131, '2014-03-15 00:40:16.000000', 'consum', 0.0232, 'lps'),
	(596562, 131, '2014-03-15 00:40:17.000000', 'consum', 0.0232, 'lps'),
	(596563, 131, '2014-03-15 00:40:18.000000', 'consum', 0.0227, 'lps'),
	(596564, 131, '2014-03-15 00:40:19.000000', 'consum', 0.0228, 'lps'),
	(596565, 131, '2014-03-15 00:40:20.000000', 'consum', 0.0221, 'lps'),
	(596566, 131, '2014-03-15 00:40:21.000000', 'consum', 0.0213, 'lps'),
	(596567, 131, '2014-03-15 00:40:22.000000', 'consum', 0.0220, 'lps'),
	(596568, 131, '2014-03-15 00:40:23.000000', 'consum', 0.0221, 'lps'),
	(596569, 131, '2014-03-15 00:40:24.000000', 'consum', 0.0211, 'lps'),
	(596570, 131, '2014-03-15 00:40:25.000000', 'consum', 0.0237, 'lps'),
	(596571, 131, '2014-03-15 00:40:26.000000', 'consum', 0.0229, 'lps'),
	(596572, 131, '2014-03-15 00:40:27.000000', 'consum', 0.0227, 'lps'),
	(596573, 131, '2014-03-15 00:40:28.000000', 'consum', 0.0236, 'lps'),
	(596574, 131, '2014-03-15 00:40:29.000000', 'consum', 0.0233, 'lps'),
	(596575, 131, '2014-03-15 00:40:30.000000', 'consum', 0.0222, 'lps'),
	(596576, 131, '2014-03-15 00:40:31.000000', 'consum', 0.0227, 'lps'),
	(596577, 131, '2014-03-15 00:40:32.000000', 'consum', 0.0234, 'lps'),
	(596578, 131, '2014-03-15 00:40:33.000000', 'consum', 0.0222, 'lps'),
	(596579, 131, '2014-03-15 00:40:34.000000', 'consum', 0.0227, 'lps'),
	(596580, 131, '2014-03-15 00:40:35.000000', 'consum', 0.0230, 'lps'),
	(596581, 131, '2014-03-15 00:40:36.000000', 'consum', 0.0234, 'lps'),
	(596582, 131, '2014-03-15 00:40:37.000000', 'consum', 0.0211, 'lps'),
	(596583, 131, '2014-03-15 00:40:38.000000', 'consum', 0.0231, 'lps'),
	(596584, 131, '2014-03-15 00:40:39.000000', 'consum', 0.0226, 'lps'),
	(596585, 131, '2014-03-15 00:40:40.000000', 'consum', 0.0229, 'lps'),
	(596586, 131, '2014-03-15 00:40:41.000000', 'consum', 0.0228, 'lps'),
	(596587, 131, '2014-03-15 00:40:42.000000', 'consum', 0.0214, 'lps'),
	(596588, 131, '2014-03-15 00:40:43.000000', 'consum', 0.0236, 'lps'),
	(596589, 131, '2014-03-15 00:40:44.000000', 'consum', 0.0214, 'lps'),
	(596590, 131, '2014-03-15 00:40:45.000000', 'consum', 0.0210, 'lps'),
	(596591, 131, '2014-03-15 00:40:46.000000', 'consum', 0.0225, 'lps'),
	(596592, 131, '2014-03-15 00:40:47.000000', 'consum', 0.0231, 'lps'),
	(596593, 131, '2014-03-15 00:40:48.000000', 'consum', 0.0214, 'lps'),
	(596594, 131, '2014-03-15 00:40:49.000000', 'consum', 0.0225, 'lps'),
	(596595, 131, '2014-03-15 00:40:50.000000', 'consum', 0.0218, 'lps'),
	(596596, 131, '2014-03-15 00:40:51.000000', 'consum', 0.0234, 'lps'),
	(596597, 131, '2014-03-15 00:40:52.000000', 'consum', 0.0223, 'lps'),
	(596598, 131, '2014-03-15 00:40:53.000000', 'consum', 0.0231, 'lps'),
	(596599, 131, '2014-03-15 00:40:54.000000', 'consum', 0.0221, 'lps'),
	(596600, 131, '2014-03-15 00:40:55.000000', 'consum', 0.0230, 'lps'),
	(596601, 131, '2014-03-15 00:40:56.000000', 'consum', 0.0221, 'lps'),
	(596602, 131, '2014-03-15 00:40:57.000000', 'consum', 0.0234, 'lps'),
	(596603, 131, '2014-03-15 00:40:58.000000', 'consum', 0.0215, 'lps'),
	(596604, 131, '2014-03-15 00:40:59.000000', 'consum', 0.0217, 'lps'),
	(596605, 131, '2014-03-15 00:41:00.000000', 'consum', 0.0229, 'lps'),
	(596606, 131, '2014-03-15 00:41:01.000000', 'consum', 0.0232, 'lps'),
	(596607, 131, '2014-03-15 00:41:02.000000', 'consum', 0.0233, 'lps'),
	(596608, 131, '2014-03-15 00:41:03.000000', 'consum', 0.0233, 'lps'),
	(596609, 131, '2014-03-15 00:41:04.000000', 'consum', 0.0228, 'lps'),
	(596610, 131, '2014-03-15 00:41:05.000000', 'consum', 0.0234, 'lps'),
	(596611, 131, '2014-03-15 00:41:06.000000', 'consum', 0.0217, 'lps'),
	(596612, 131, '2014-03-15 00:41:07.000000', 'consum', 0.0231, 'lps'),
	(596613, 131, '2014-03-15 00:41:08.000000', 'consum', 0.0236, 'lps'),
	(596614, 131, '2014-03-15 00:41:09.000000', 'consum', 0.0225, 'lps'),
	(596615, 131, '2014-03-15 00:41:10.000000', 'consum', 0.0233, 'lps'),
	(596616, 131, '2014-03-15 00:41:11.000000', 'consum', 0.0226, 'lps'),
	(596617, 131, '2014-03-15 00:41:12.000000', 'consum', 0.0221, 'lps'),
	(596618, 131, '2014-03-15 00:41:13.000000', 'consum', 0.0219, 'lps'),
	(596619, 131, '2014-03-15 00:41:14.000000', 'consum', 0.0221, 'lps'),
	(596620, 131, '2014-03-15 00:41:15.000000', 'consum', 0.0211, 'lps'),
	(596621, 131, '2014-03-15 00:41:16.000000', 'consum', 0.0211, 'lps'),
	(596622, 131, '2014-03-15 00:41:17.000000', 'consum', 0.0213, 'lps'),
	(596623, 131, '2014-03-15 00:41:18.000000', 'consum', 0.0222, 'lps'),
	(596624, 131, '2014-03-15 00:41:19.000000', 'consum', 0.0231, 'lps'),
	(596625, 131, '2014-03-15 00:41:20.000000', 'consum', 0.0226, 'lps'),
	(596626, 131, '2014-03-15 00:41:21.000000', 'consum', 0.0228, 'lps'),
	(596627, 131, '2014-03-15 00:41:22.000000', 'consum', 0.0226, 'lps'),
	(596628, 131, '2014-03-15 00:41:23.000000', 'consum', 0.0234, 'lps'),
	(596629, 131, '2014-03-15 00:41:24.000000', 'consum', 0.0229, 'lps'),
	(596630, 131, '2014-03-15 00:41:25.000000', 'consum', 0.0232, 'lps'),
	(596631, 131, '2014-03-15 00:41:26.000000', 'consum', 0.0210, 'lps'),
	(596632, 131, '2014-03-15 00:41:27.000000', 'consum', 0.0225, 'lps'),
	(596633, 131, '2014-03-15 00:41:28.000000', 'consum', 0.0232, 'lps'),
	(596634, 131, '2014-03-15 00:41:29.000000', 'consum', 0.0218, 'lps'),
	(596635, 131, '2014-03-15 00:41:30.000000', 'consum', 0.0211, 'lps'),
	(596636, 131, '2014-03-15 00:41:31.000000', 'consum', 0.0222, 'lps'),
	(596637, 131, '2014-03-15 00:41:32.000000', 'consum', 0.0212, 'lps'),
	(596638, 131, '2014-03-15 00:41:33.000000', 'consum', 0.0213, 'lps'),
	(596639, 131, '2014-03-15 00:41:34.000000', 'consum', 0.0217, 'lps'),
	(596640, 131, '2014-03-15 00:41:35.000000', 'consum', 0.0236, 'lps'),
	(596641, 131, '2014-03-15 00:41:36.000000', 'consum', 0.0235, 'lps'),
	(596642, 131, '2014-03-15 00:41:37.000000', 'consum', 0.0231, 'lps'),
	(596643, 131, '2014-03-15 00:41:38.000000', 'consum', 0.0213, 'lps'),
	(596644, 131, '2014-03-15 00:41:39.000000', 'consum', 0.0219, 'lps'),
	(596645, 131, '2014-03-15 00:41:40.000000', 'consum', 0.0218, 'lps'),
	(596646, 131, '2014-03-15 00:41:41.000000', 'consum', 0.0224, 'lps'),
	(596647, 131, '2014-03-15 00:41:42.000000', 'consum', 0.0226, 'lps'),
	(596648, 131, '2014-03-15 00:41:43.000000', 'consum', 0.0223, 'lps'),
	(596649, 131, '2014-03-15 00:41:44.000000', 'consum', 0.0227, 'lps'),
	(596650, 131, '2014-03-15 00:41:45.000000', 'consum', 0.0226, 'lps'),
	(596651, 131, '2014-03-15 00:41:46.000000', 'consum', 0.0214, 'lps'),
	(596652, 131, '2014-03-15 00:41:47.000000', 'consum', 0.0237, 'lps'),
	(596653, 131, '2014-03-15 00:41:48.000000', 'consum', 0.0224, 'lps'),
	(596654, 131, '2014-03-15 00:41:49.000000', 'consum', 0.0224, 'lps'),
	(596655, 131, '2014-03-15 00:41:50.000000', 'consum', 0.0214, 'lps'),
	(596656, 131, '2014-03-15 00:41:51.000000', 'consum', 0.0213, 'lps'),
	(596657, 131, '2014-03-15 00:41:52.000000', 'consum', 0.0217, 'lps'),
	(596658, 131, '2014-03-15 00:41:53.000000', 'consum', 0.0234, 'lps'),
	(596659, 131, '2014-03-15 00:41:54.000000', 'consum', 0.0226, 'lps'),
	(596660, 131, '2014-03-15 00:41:55.000000', 'consum', 0.0220, 'lps'),
	(596661, 131, '2014-03-15 00:41:56.000000', 'consum', 0.0210, 'lps'),
	(596662, 131, '2014-03-15 00:41:57.000000', 'consum', 0.0237, 'lps'),
	(596663, 131, '2014-03-15 00:41:58.000000', 'consum', 0.0234, 'lps'),
	(596664, 131, '2014-03-15 00:41:59.000000', 'consum', 0.0220, 'lps'),
	(596665, 131, '2014-03-15 00:42:00.000000', 'consum', 0.0216, 'lps'),
	(596666, 131, '2014-03-15 00:42:01.000000', 'consum', 0.0212, 'lps'),
	(596667, 131, '2014-03-15 00:42:02.000000', 'consum', 0.0232, 'lps'),
	(596668, 131, '2014-03-15 00:42:03.000000', 'consum', 0.0227, 'lps'),
	(596669, 131, '2014-03-15 00:42:04.000000', 'consum', 0.0232, 'lps'),
	(596670, 131, '2014-03-15 00:42:05.000000', 'consum', 0.0214, 'lps'),
	(596671, 131, '2014-03-15 00:42:06.000000', 'consum', 0.0219, 'lps'),
	(596672, 131, '2014-03-15 00:42:07.000000', 'consum', 0.0214, 'lps'),
	(596673, 131, '2014-03-15 00:42:08.000000', 'consum', 0.0235, 'lps'),
	(596674, 131, '2014-03-15 00:42:09.000000', 'consum', 0.0237, 'lps'),
	(596675, 131, '2014-03-15 00:42:10.000000', 'consum', 0.0216, 'lps'),
	(596676, 131, '2014-03-15 00:42:11.000000', 'consum', 0.0215, 'lps'),
	(596677, 131, '2014-03-15 00:42:12.000000', 'consum', 0.0218, 'lps'),
	(596678, 131, '2014-03-15 00:42:13.000000', 'consum', 0.0235, 'lps'),
	(596679, 131, '2014-03-15 00:42:14.000000', 'consum', 0.0228, 'lps'),
	(596680, 131, '2014-03-15 00:42:15.000000', 'consum', 0.0227, 'lps'),
	(596681, 131, '2014-03-15 00:42:16.000000', 'consum', 0.0213, 'lps'),
	(596682, 131, '2014-03-15 00:42:17.000000', 'consum', 0.0229, 'lps'),
	(596683, 131, '2014-03-15 00:42:18.000000', 'consum', 0.0214, 'lps'),
	(596684, 131, '2014-03-15 00:42:19.000000', 'consum', 0.0228, 'lps'),
	(596685, 131, '2014-03-15 00:42:20.000000', 'consum', 0.0235, 'lps'),
	(596686, 131, '2014-03-15 00:42:21.000000', 'consum', 0.0223, 'lps'),
	(596687, 131, '2014-03-15 00:42:22.000000', 'consum', 0.0229, 'lps'),
	(596688, 131, '2014-03-15 00:42:23.000000', 'consum', 0.0211, 'lps'),
	(596689, 131, '2014-03-15 00:42:24.000000', 'consum', 0.0215, 'lps'),
	(596690, 131, '2014-03-15 00:42:25.000000', 'consum', 0.0231, 'lps'),
	(596691, 131, '2014-03-15 00:42:26.000000', 'consum', 0.0217, 'lps'),
	(596692, 131, '2014-03-15 00:42:27.000000', 'consum', 0.0212, 'lps'),
	(596693, 131, '2014-03-15 00:42:28.000000', 'consum', 0.0226, 'lps'),
	(596694, 131, '2014-03-15 00:42:29.000000', 'consum', 0.0231, 'lps'),
	(596695, 131, '2014-03-15 00:42:30.000000', 'consum', 0.0210, 'lps'),
	(596696, 131, '2014-03-15 00:42:31.000000', 'consum', 0.0232, 'lps'),
	(596697, 131, '2014-03-15 00:42:32.000000', 'consum', 0.0234, 'lps'),
	(596698, 131, '2014-03-15 00:42:33.000000', 'consum', 0.0211, 'lps'),
	(596699, 131, '2014-03-15 00:42:34.000000', 'consum', 0.0229, 'lps'),
	(596700, 131, '2014-03-15 00:42:35.000000', 'consum', 0.0215, 'lps'),
	(596701, 131, '2014-03-15 00:42:36.000000', 'consum', 0.0236, 'lps'),
	(596702, 131, '2014-03-15 00:42:37.000000', 'consum', 0.0215, 'lps'),
	(596703, 131, '2014-03-15 00:42:38.000000', 'consum', 0.0211, 'lps'),
	(596704, 131, '2014-03-15 00:42:39.000000', 'consum', 0.0232, 'lps'),
	(596705, 131, '2014-03-15 00:42:40.000000', 'consum', 0.0230, 'lps'),
	(596706, 131, '2014-03-15 00:42:41.000000', 'consum', 0.0218, 'lps'),
	(596707, 131, '2014-03-15 00:42:42.000000', 'consum', 0.0217, 'lps'),
	(596708, 131, '2014-03-15 00:42:43.000000', 'consum', 0.0224, 'lps'),
	(596709, 131, '2014-03-15 00:42:44.000000', 'consum', 0.0231, 'lps'),
	(596710, 131, '2014-03-15 00:42:45.000000', 'consum', 0.0216, 'lps'),
	(596711, 131, '2014-03-15 00:42:46.000000', 'consum', 0.0233, 'lps'),
	(596712, 131, '2014-03-15 00:42:47.000000', 'consum', 0.0223, 'lps'),
	(596713, 131, '2014-03-15 00:42:48.000000', 'consum', 0.0233, 'lps'),
	(596714, 131, '2014-03-15 00:42:49.000000', 'consum', 0.0234, 'lps'),
	(596715, 131, '2014-03-15 00:42:50.000000', 'consum', 0.0234, 'lps'),
	(596716, 131, '2014-03-15 00:42:51.000000', 'consum', 0.0227, 'lps'),
	(596717, 131, '2014-03-15 00:42:52.000000', 'consum', 0.0226, 'lps'),
	(596718, 131, '2014-03-15 00:42:53.000000', 'consum', 0.0212, 'lps'),
	(596719, 131, '2014-03-15 00:42:54.000000', 'consum', 0.0227, 'lps'),
	(596720, 131, '2014-03-15 00:42:55.000000', 'consum', 0.0232, 'lps'),
	(596721, 131, '2014-03-15 00:42:56.000000', 'consum', 0.0215, 'lps'),
	(596722, 131, '2014-03-15 00:42:57.000000', 'consum', 0.0225, 'lps'),
	(596723, 131, '2014-03-15 00:42:58.000000', 'consum', 0.0216, 'lps'),
	(596724, 131, '2014-03-15 00:42:59.000000', 'consum', 0.0222, 'lps'),
	(596725, 131, '2014-03-15 00:43:00.000000', 'consum', 0.0227, 'lps'),
	(596726, 131, '2014-03-15 00:43:01.000000', 'consum', 0.0230, 'lps'),
	(596727, 131, '2014-03-15 00:43:02.000000', 'consum', 0.0233, 'lps'),
	(596728, 131, '2014-03-15 00:43:03.000000', 'consum', 0.0237, 'lps'),
	(596729, 131, '2014-03-15 00:43:04.000000', 'consum', 0.0221, 'lps'),
	(596730, 131, '2014-03-15 00:43:05.000000', 'consum', 0.0213, 'lps'),
	(596731, 131, '2014-03-15 00:43:06.000000', 'consum', 0.0221, 'lps'),
	(596732, 131, '2014-03-15 00:43:07.000000', 'consum', 0.0229, 'lps'),
	(596733, 131, '2014-03-15 00:43:08.000000', 'consum', 0.0214, 'lps'),
	(596734, 131, '2014-03-15 00:43:09.000000', 'consum', 0.0232, 'lps'),
	(596735, 131, '2014-03-15 00:43:10.000000', 'consum', 0.0224, 'lps'),
	(596736, 131, '2014-03-15 00:43:11.000000', 'consum', 0.0215, 'lps'),
	(596737, 131, '2014-03-15 00:43:12.000000', 'consum', 0.0223, 'lps'),
	(596738, 131, '2014-03-15 00:43:13.000000', 'consum', 0.0230, 'lps'),
	(596739, 131, '2014-03-15 00:43:14.000000', 'consum', 0.0216, 'lps'),
	(596740, 131, '2014-03-15 00:43:15.000000', 'consum', 0.0235, 'lps'),
	(596741, 131, '2014-03-15 00:43:16.000000', 'consum', 0.0236, 'lps'),
	(596742, 131, '2014-03-15 00:43:17.000000', 'consum', 0.0236, 'lps'),
	(596743, 131, '2014-03-15 00:43:18.000000', 'consum', 0.0235, 'lps'),
	(596744, 131, '2014-03-15 00:43:19.000000', 'consum', 0.0229, 'lps'),
	(596745, 131, '2014-03-15 00:43:20.000000', 'consum', 0.0233, 'lps'),
	(596746, 131, '2014-03-15 00:43:21.000000', 'consum', 0.0237, 'lps'),
	(596747, 131, '2014-03-15 00:43:22.000000', 'consum', 0.0221, 'lps'),
	(596748, 131, '2014-03-15 00:43:23.000000', 'consum', 0.0215, 'lps'),
	(596749, 131, '2014-03-15 00:43:24.000000', 'consum', 0.0230, 'lps'),
	(596750, 131, '2014-03-15 00:43:25.000000', 'consum', 0.0212, 'lps'),
	(596751, 131, '2014-03-15 00:43:26.000000', 'consum', 0.0214, 'lps'),
	(596752, 131, '2014-03-15 00:43:27.000000', 'consum', 0.0227, 'lps'),
	(596753, 131, '2014-03-15 00:43:28.000000', 'consum', 0.0226, 'lps'),
	(596754, 131, '2014-03-15 00:43:29.000000', 'consum', 0.0210, 'lps'),
	(596755, 131, '2014-03-15 00:43:30.000000', 'consum', 0.0221, 'lps'),
	(596756, 131, '2014-03-15 00:43:31.000000', 'consum', 0.0210, 'lps'),
	(596757, 131, '2014-03-15 00:43:32.000000', 'consum', 0.0233, 'lps'),
	(596758, 131, '2014-03-15 00:43:33.000000', 'consum', 0.0212, 'lps'),
	(596759, 131, '2014-03-15 00:43:34.000000', 'consum', 0.0235, 'lps'),
	(596760, 131, '2014-03-15 00:43:35.000000', 'consum', 0.0216, 'lps'),
	(596761, 131, '2014-03-15 00:43:36.000000', 'consum', 0.0225, 'lps'),
	(596762, 131, '2014-03-15 00:43:37.000000', 'consum', 0.0211, 'lps'),
	(596763, 131, '2014-03-15 00:43:38.000000', 'consum', 0.0226, 'lps'),
	(596764, 131, '2014-03-15 00:43:39.000000', 'consum', 0.0230, 'lps'),
	(596765, 131, '2014-03-15 00:43:40.000000', 'consum', 0.0234, 'lps'),
	(596766, 131, '2014-03-15 00:43:41.000000', 'consum', 0.0215, 'lps'),
	(596767, 131, '2014-03-15 00:43:42.000000', 'consum', 0.0220, 'lps'),
	(596768, 131, '2014-03-15 00:43:43.000000', 'consum', 0.0220, 'lps'),
	(596769, 131, '2014-03-15 00:43:44.000000', 'consum', 0.0227, 'lps'),
	(596770, 131, '2014-03-15 00:43:45.000000', 'consum', 0.0237, 'lps'),
	(596771, 131, '2014-03-15 00:43:46.000000', 'consum', 0.0212, 'lps'),
	(596772, 131, '2014-03-15 00:43:47.000000', 'consum', 0.0224, 'lps'),
	(596773, 131, '2014-03-15 00:43:48.000000', 'consum', 0.0218, 'lps'),
	(596774, 131, '2014-03-15 00:43:49.000000', 'consum', 0.0236, 'lps'),
	(596775, 131, '2014-03-15 00:43:50.000000', 'consum', 0.0234, 'lps'),
	(596776, 131, '2014-03-15 00:43:51.000000', 'consum', 0.0222, 'lps'),
	(596777, 131, '2014-03-15 00:43:52.000000', 'consum', 0.0227, 'lps'),
	(596778, 131, '2014-03-15 00:43:53.000000', 'consum', 0.0233, 'lps'),
	(596779, 131, '2014-03-15 00:43:54.000000', 'consum', 0.0220, 'lps'),
	(596780, 131, '2014-03-15 00:43:55.000000', 'consum', 0.0217, 'lps'),
	(596781, 131, '2014-03-15 00:43:56.000000', 'consum', 0.0217, 'lps'),
	(596782, 131, '2014-03-15 00:43:57.000000', 'consum', 0.0224, 'lps'),
	(596783, 131, '2014-03-15 00:43:58.000000', 'consum', 0.0232, 'lps'),
	(596784, 131, '2014-03-15 00:43:59.000000', 'consum', 0.0221, 'lps'),
	(596785, 131, '2014-03-15 00:44:00.000000', 'consum', 0.0229, 'lps'),
	(596786, 131, '2014-03-15 00:44:01.000000', 'consum', 0.0216, 'lps'),
	(596787, 131, '2014-03-15 00:44:02.000000', 'consum', 0.0211, 'lps'),
	(596788, 131, '2014-03-15 00:44:03.000000', 'consum', 0.0227, 'lps'),
	(596789, 131, '2014-03-15 00:44:04.000000', 'consum', 0.0210, 'lps'),
	(596790, 131, '2014-03-15 00:44:05.000000', 'consum', 0.0213, 'lps'),
	(596791, 131, '2014-03-15 00:44:06.000000', 'consum', 0.0226, 'lps'),
	(596792, 131, '2014-03-15 00:44:07.000000', 'consum', 0.0227, 'lps'),
	(596793, 131, '2014-03-15 00:44:08.000000', 'consum', 0.0219, 'lps'),
	(596794, 131, '2014-03-15 00:44:09.000000', 'consum', 0.0231, 'lps'),
	(596795, 131, '2014-03-15 00:44:10.000000', 'consum', 0.0232, 'lps'),
	(596796, 131, '2014-03-15 00:44:11.000000', 'consum', 0.0229, 'lps'),
	(596797, 131, '2014-03-15 00:44:12.000000', 'consum', 0.0213, 'lps'),
	(596798, 131, '2014-03-15 00:44:13.000000', 'consum', 0.0224, 'lps'),
	(596799, 131, '2014-03-15 00:44:14.000000', 'consum', 0.0214, 'lps'),
	(596800, 131, '2014-03-15 00:44:15.000000', 'consum', 0.0216, 'lps'),
	(596801, 131, '2014-03-15 00:44:16.000000', 'consum', 0.0228, 'lps'),
	(596802, 131, '2014-03-15 00:44:17.000000', 'consum', 0.0227, 'lps'),
	(596803, 131, '2014-03-15 00:44:18.000000', 'consum', 0.0216, 'lps'),
	(596804, 131, '2014-03-15 00:44:19.000000', 'consum', 0.0214, 'lps'),
	(596805, 131, '2014-03-15 00:44:20.000000', 'consum', 0.0215, 'lps'),
	(596806, 131, '2014-03-15 00:44:21.000000', 'consum', 0.0221, 'lps'),
	(596807, 131, '2014-03-15 00:44:22.000000', 'consum', 0.0223, 'lps'),
	(596808, 131, '2014-03-15 00:44:23.000000', 'consum', 0.0216, 'lps'),
	(596809, 131, '2014-03-15 00:44:24.000000', 'consum', 0.0227, 'lps'),
	(596810, 131, '2014-03-15 00:44:25.000000', 'consum', 0.0222, 'lps'),
	(596811, 131, '2014-03-15 00:44:26.000000', 'consum', 0.0219, 'lps'),
	(596812, 131, '2014-03-15 00:44:27.000000', 'consum', 0.0221, 'lps'),
	(596813, 131, '2014-03-15 00:44:28.000000', 'consum', 0.0236, 'lps'),
	(596814, 131, '2014-03-15 00:44:29.000000', 'consum', 0.0224, 'lps'),
	(596815, 131, '2014-03-15 00:44:30.000000', 'consum', 0.0233, 'lps'),
	(596816, 131, '2014-03-15 00:44:31.000000', 'consum', 0.0227, 'lps'),
	(596817, 131, '2014-03-15 00:44:32.000000', 'consum', 0.0224, 'lps'),
	(596818, 131, '2014-03-15 00:44:33.000000', 'consum', 0.0231, 'lps'),
	(596819, 131, '2014-03-15 00:44:34.000000', 'consum', 0.0219, 'lps'),
	(596820, 131, '2014-03-15 00:44:35.000000', 'consum', 0.0221, 'lps'),
	(596821, 131, '2014-03-15 00:44:36.000000', 'consum', 0.0237, 'lps'),
	(596822, 131, '2014-03-15 00:44:37.000000', 'consum', 0.0228, 'lps'),
	(596823, 131, '2014-03-15 00:44:38.000000', 'consum', 0.0220, 'lps'),
	(596824, 131, '2014-03-15 00:44:39.000000', 'consum', 0.0234, 'lps'),
	(596825, 131, '2014-03-15 00:44:40.000000', 'consum', 0.0216, 'lps'),
	(596826, 131, '2014-03-15 00:44:41.000000', 'consum', 0.0226, 'lps'),
	(596827, 131, '2014-03-15 00:44:42.000000', 'consum', 0.0215, 'lps'),
	(596828, 131, '2014-03-15 00:44:43.000000', 'consum', 0.0214, 'lps'),
	(596829, 131, '2014-03-15 00:44:44.000000', 'consum', 0.0219, 'lps'),
	(596830, 131, '2014-03-15 00:44:45.000000', 'consum', 0.0213, 'lps'),
	(596831, 131, '2014-03-15 00:44:46.000000', 'consum', 0.0227, 'lps'),
	(596832, 131, '2014-03-15 00:44:47.000000', 'consum', 0.0229, 'lps'),
	(596833, 131, '2014-03-15 00:44:48.000000', 'consum', 0.0227, 'lps'),
	(596834, 131, '2014-03-15 00:44:49.000000', 'consum', 0.0237, 'lps'),
	(596835, 131, '2014-03-15 00:44:50.000000', 'consum', 0.0213, 'lps'),
	(596836, 131, '2014-03-15 00:44:51.000000', 'consum', 0.0227, 'lps'),
	(596837, 131, '2014-03-15 00:44:52.000000', 'consum', 0.0232, 'lps'),
	(596838, 131, '2014-03-15 00:44:53.000000', 'consum', 0.0212, 'lps'),
	(596839, 131, '2014-03-15 00:44:54.000000', 'consum', 0.0237, 'lps'),
	(596840, 131, '2014-03-15 00:44:55.000000', 'consum', 0.0229, 'lps'),
	(596841, 131, '2014-03-15 00:44:56.000000', 'consum', 0.0224, 'lps'),
	(596842, 131, '2014-03-15 00:44:57.000000', 'consum', 0.0224, 'lps'),
	(596843, 131, '2014-03-15 00:44:58.000000', 'consum', 0.0210, 'lps'),
	(596844, 131, '2014-03-15 00:44:59.000000', 'consum', 0.0223, 'lps'),
	(596845, 131, '2014-03-15 00:45:00.000000', 'consum', 0.0220, 'lps'),
	(596846, 131, '2014-03-15 00:45:01.000000', 'consum', 0.0224, 'lps'),
	(596847, 131, '2014-03-15 00:45:02.000000', 'consum', 0.0221, 'lps'),
	(596848, 131, '2014-03-15 00:45:03.000000', 'consum', 0.0225, 'lps'),
	(596849, 131, '2014-03-15 00:45:04.000000', 'consum', 0.0223, 'lps'),
	(596850, 131, '2014-03-15 00:45:05.000000', 'consum', 0.0233, 'lps'),
	(596851, 131, '2014-03-15 00:45:06.000000', 'consum', 0.0227, 'lps'),
	(596852, 131, '2014-03-15 00:45:07.000000', 'consum', 0.0229, 'lps'),
	(596853, 131, '2014-03-15 00:45:08.000000', 'consum', 0.0228, 'lps'),
	(596854, 131, '2014-03-15 00:45:09.000000', 'consum', 0.0212, 'lps'),
	(596855, 131, '2014-03-15 00:45:10.000000', 'consum', 0.0225, 'lps'),
	(596856, 131, '2014-03-15 00:45:11.000000', 'consum', 0.0224, 'lps'),
	(596857, 131, '2014-03-15 00:45:12.000000', 'consum', 0.0235, 'lps'),
	(596858, 131, '2014-03-15 00:45:13.000000', 'consum', 0.0237, 'lps'),
	(596859, 131, '2014-03-15 00:45:14.000000', 'consum', 0.0216, 'lps'),
	(596860, 131, '2014-03-15 00:45:15.000000', 'consum', 0.0215, 'lps'),
	(596861, 131, '2014-03-15 00:45:16.000000', 'consum', 0.0215, 'lps'),
	(596862, 131, '2014-03-15 00:45:17.000000', 'consum', 0.0223, 'lps'),
	(596863, 131, '2014-03-15 00:45:18.000000', 'consum', 0.0231, 'lps'),
	(596864, 131, '2014-03-15 00:45:19.000000', 'consum', 0.0222, 'lps'),
	(596865, 131, '2014-03-15 00:45:20.000000', 'consum', 0.0234, 'lps'),
	(596866, 131, '2014-03-15 00:45:21.000000', 'consum', 0.0210, 'lps'),
	(596867, 131, '2014-03-15 00:45:22.000000', 'consum', 0.0221, 'lps'),
	(596868, 131, '2014-03-15 00:45:23.000000', 'consum', 0.0212, 'lps'),
	(596869, 131, '2014-03-15 00:45:24.000000', 'consum', 0.0216, 'lps'),
	(596870, 131, '2014-03-15 00:45:25.000000', 'consum', 0.0232, 'lps'),
	(596871, 131, '2014-03-15 00:45:26.000000', 'consum', 0.0219, 'lps'),
	(596872, 131, '2014-03-15 00:45:27.000000', 'consum', 0.0218, 'lps'),
	(596873, 131, '2014-03-15 00:45:28.000000', 'consum', 0.0225, 'lps'),
	(596874, 131, '2014-03-15 00:45:29.000000', 'consum', 0.0232, 'lps'),
	(596875, 131, '2014-03-15 00:45:30.000000', 'consum', 0.0222, 'lps'),
	(596876, 131, '2014-03-15 00:45:31.000000', 'consum', 0.0230, 'lps'),
	(596877, 131, '2014-03-15 00:45:32.000000', 'consum', 0.0218, 'lps'),
	(596878, 131, '2014-03-15 00:45:33.000000', 'consum', 0.0217, 'lps'),
	(596879, 131, '2014-03-15 00:45:34.000000', 'consum', 0.0224, 'lps'),
	(596880, 131, '2014-03-15 00:45:35.000000', 'consum', 0.0232, 'lps'),
	(596881, 131, '2014-03-15 00:45:36.000000', 'consum', 0.0223, 'lps'),
	(596882, 131, '2014-03-15 00:45:37.000000', 'consum', 0.0235, 'lps'),
	(596883, 131, '2014-03-15 00:45:38.000000', 'consum', 0.0212, 'lps'),
	(596884, 131, '2014-03-15 00:45:39.000000', 'consum', 0.0229, 'lps'),
	(596885, 131, '2014-03-15 00:45:40.000000', 'consum', 0.0215, 'lps'),
	(596886, 131, '2014-03-15 00:45:41.000000', 'consum', 0.0235, 'lps'),
	(596887, 131, '2014-03-15 00:45:42.000000', 'consum', 0.0235, 'lps'),
	(596888, 131, '2014-03-15 00:45:43.000000', 'consum', 0.0233, 'lps'),
	(596889, 131, '2014-03-15 00:45:44.000000', 'consum', 0.0224, 'lps'),
	(596890, 131, '2014-03-15 00:45:45.000000', 'consum', 0.0212, 'lps'),
	(596891, 131, '2014-03-15 00:45:46.000000', 'consum', 0.0234, 'lps'),
	(596892, 131, '2014-03-15 00:45:47.000000', 'consum', 0.0210, 'lps'),
	(596893, 131, '2014-03-15 00:45:48.000000', 'consum', 0.0225, 'lps'),
	(596894, 131, '2014-03-15 00:45:49.000000', 'consum', 0.0229, 'lps'),
	(596895, 131, '2014-03-15 00:45:50.000000', 'consum', 0.0232, 'lps'),
	(596896, 131, '2014-03-15 00:45:51.000000', 'consum', 0.0236, 'lps'),
	(596897, 131, '2014-03-15 00:45:52.000000', 'consum', 0.0218, 'lps'),
	(596898, 131, '2014-03-15 00:45:53.000000', 'consum', 0.0229, 'lps'),
	(596899, 131, '2014-03-15 00:45:54.000000', 'consum', 0.0226, 'lps'),
	(596900, 131, '2014-03-15 00:45:55.000000', 'consum', 0.0233, 'lps'),
	(596901, 131, '2014-03-15 00:45:56.000000', 'consum', 0.0221, 'lps'),
	(596902, 131, '2014-03-15 00:45:57.000000', 'consum', 0.0223, 'lps'),
	(596903, 131, '2014-03-15 00:45:58.000000', 'consum', 0.0215, 'lps'),
	(596904, 131, '2014-03-15 00:45:59.000000', 'consum', 0.0225, 'lps'),
	(596905, 131, '2014-03-15 00:46:00.000000', 'consum', 0.0213, 'lps'),
	(596906, 131, '2014-03-15 00:46:01.000000', 'consum', 0.0237, 'lps'),
	(596907, 131, '2014-03-15 00:46:02.000000', 'consum', 0.0226, 'lps'),
	(596908, 131, '2014-03-15 00:46:03.000000', 'consum', 0.0237, 'lps'),
	(596909, 131, '2014-03-15 00:46:04.000000', 'consum', 0.0211, 'lps'),
	(596910, 131, '2014-03-15 00:46:05.000000', 'consum', 0.0222, 'lps'),
	(596911, 131, '2014-03-15 00:46:06.000000', 'consum', 0.0237, 'lps'),
	(596912, 131, '2014-03-15 00:46:07.000000', 'consum', 0.0228, 'lps'),
	(596913, 131, '2014-03-15 00:46:08.000000', 'consum', 0.0219, 'lps'),
	(596914, 131, '2014-03-15 00:46:09.000000', 'consum', 0.0230, 'lps'),
	(596915, 131, '2014-03-15 00:46:10.000000', 'consum', 0.0226, 'lps'),
	(596916, 131, '2014-03-15 00:46:11.000000', 'consum', 0.0230, 'lps'),
	(596917, 131, '2014-03-15 00:46:12.000000', 'consum', 0.0233, 'lps'),
	(596918, 131, '2014-03-15 00:46:13.000000', 'consum', 0.0212, 'lps'),
	(596919, 131, '2014-03-15 00:46:14.000000', 'consum', 0.0235, 'lps'),
	(596920, 131, '2014-03-15 00:46:15.000000', 'consum', 0.0218, 'lps'),
	(596921, 131, '2014-03-15 00:46:16.000000', 'consum', 0.0229, 'lps'),
	(596922, 131, '2014-03-15 00:46:17.000000', 'consum', 0.0229, 'lps'),
	(596923, 131, '2014-03-15 00:46:18.000000', 'consum', 0.0218, 'lps'),
	(596924, 131, '2014-03-15 00:46:19.000000', 'consum', 0.0224, 'lps'),
	(596925, 131, '2014-03-15 00:46:20.000000', 'consum', 0.0227, 'lps'),
	(596926, 131, '2014-03-15 00:46:21.000000', 'consum', 0.0225, 'lps'),
	(596927, 131, '2014-03-15 00:46:22.000000', 'consum', 0.0237, 'lps'),
	(596928, 131, '2014-03-15 00:46:23.000000', 'consum', 0.0215, 'lps'),
	(596929, 131, '2014-03-15 00:46:24.000000', 'consum', 0.0237, 'lps'),
	(596930, 131, '2014-03-15 00:46:25.000000', 'consum', 0.0220, 'lps'),
	(596931, 131, '2014-03-15 00:46:26.000000', 'consum', 0.0235, 'lps'),
	(596932, 131, '2014-03-15 00:46:27.000000', 'consum', 0.0221, 'lps'),
	(596933, 131, '2014-03-15 00:46:28.000000', 'consum', 0.0218, 'lps'),
	(596934, 131, '2014-03-15 00:46:29.000000', 'consum', 0.0217, 'lps'),
	(596935, 131, '2014-03-15 00:46:30.000000', 'consum', 0.0223, 'lps'),
	(596936, 131, '2014-03-15 00:46:31.000000', 'consum', 0.0226, 'lps'),
	(596937, 131, '2014-03-15 00:46:32.000000', 'consum', 0.0224, 'lps'),
	(596938, 131, '2014-03-15 00:46:33.000000', 'consum', 0.0233, 'lps'),
	(596939, 131, '2014-03-15 00:46:34.000000', 'consum', 0.0228, 'lps'),
	(596940, 131, '2014-03-15 00:46:35.000000', 'consum', 0.0232, 'lps'),
	(596941, 131, '2014-03-15 00:46:36.000000', 'consum', 0.0210, 'lps'),
	(596942, 131, '2014-03-15 00:46:37.000000', 'consum', 0.0230, 'lps'),
	(596943, 131, '2014-03-15 00:46:38.000000', 'consum', 0.0224, 'lps'),
	(596944, 131, '2014-03-15 00:46:39.000000', 'consum', 0.0223, 'lps'),
	(596945, 131, '2014-03-15 00:46:40.000000', 'consum', 0.0232, 'lps'),
	(596946, 131, '2014-03-15 00:46:41.000000', 'consum', 0.0226, 'lps'),
	(596947, 131, '2014-03-15 00:46:42.000000', 'consum', 0.0226, 'lps'),
	(596948, 131, '2014-03-15 00:46:43.000000', 'consum', 0.0214, 'lps'),
	(596949, 131, '2014-03-15 00:46:44.000000', 'consum', 0.0210, 'lps'),
	(596950, 131, '2014-03-15 00:46:45.000000', 'consum', 0.0227, 'lps'),
	(596951, 131, '2014-03-15 00:46:46.000000', 'consum', 0.0213, 'lps'),
	(596952, 131, '2014-03-15 00:46:47.000000', 'consum', 0.0230, 'lps'),
	(596953, 131, '2014-03-15 00:46:48.000000', 'consum', 0.0219, 'lps'),
	(596954, 131, '2014-03-15 00:46:49.000000', 'consum', 0.0221, 'lps'),
	(596955, 131, '2014-03-15 00:46:50.000000', 'consum', 0.0213, 'lps'),
	(596956, 131, '2014-03-15 00:46:51.000000', 'consum', 0.0221, 'lps'),
	(596957, 131, '2014-03-15 00:46:52.000000', 'consum', 0.0227, 'lps'),
	(596958, 131, '2014-03-15 00:46:53.000000', 'consum', 0.0235, 'lps'),
	(596959, 131, '2014-03-15 00:46:54.000000', 'consum', 0.0228, 'lps'),
	(596960, 131, '2014-03-15 00:46:55.000000', 'consum', 0.0226, 'lps'),
	(596961, 131, '2014-03-15 00:46:56.000000', 'consum', 0.0235, 'lps'),
	(596962, 131, '2014-03-15 00:46:57.000000', 'consum', 0.0232, 'lps'),
	(596963, 131, '2014-03-15 00:46:58.000000', 'consum', 0.0219, 'lps'),
	(596964, 131, '2014-03-15 00:46:59.000000', 'consum', 0.0217, 'lps'),
	(596965, 131, '2014-03-15 00:47:00.000000', 'consum', 0.0218, 'lps'),
	(596966, 131, '2014-03-15 00:47:01.000000', 'consum', 0.0231, 'lps'),
	(596967, 131, '2014-03-15 00:47:02.000000', 'consum', 0.0233, 'lps'),
	(596968, 131, '2014-03-15 00:47:03.000000', 'consum', 0.0235, 'lps'),
	(596969, 131, '2014-03-15 00:47:04.000000', 'consum', 0.0210, 'lps'),
	(596970, 131, '2014-03-15 00:47:05.000000', 'consum', 0.0220, 'lps'),
	(596971, 131, '2014-03-15 00:47:06.000000', 'consum', 0.0231, 'lps'),
	(596972, 131, '2014-03-15 00:47:07.000000', 'consum', 0.0229, 'lps'),
	(596973, 131, '2014-03-15 00:47:08.000000', 'consum', 0.0214, 'lps'),
	(596974, 131, '2014-03-15 00:47:09.000000', 'consum', 0.0231, 'lps'),
	(596975, 131, '2014-03-15 00:47:10.000000', 'consum', 0.0220, 'lps'),
	(596976, 131, '2014-03-15 00:47:11.000000', 'consum', 0.0226, 'lps'),
	(596977, 131, '2014-03-15 00:47:12.000000', 'consum', 0.0230, 'lps'),
	(596978, 131, '2014-03-15 00:47:13.000000', 'consum', 0.0237, 'lps'),
	(596979, 131, '2014-03-15 00:47:14.000000', 'consum', 0.0229, 'lps'),
	(596980, 131, '2014-03-15 00:47:15.000000', 'consum', 0.0225, 'lps'),
	(596981, 131, '2014-03-15 00:47:16.000000', 'consum', 0.0230, 'lps'),
	(596982, 131, '2014-03-15 00:47:17.000000', 'consum', 0.0237, 'lps'),
	(596983, 131, '2014-03-15 00:47:18.000000', 'consum', 0.0227, 'lps'),
	(596984, 131, '2014-03-15 00:47:19.000000', 'consum', 0.0215, 'lps'),
	(596985, 131, '2014-03-15 00:47:20.000000', 'consum', 0.0214, 'lps'),
	(596986, 131, '2014-03-15 00:47:21.000000', 'consum', 0.0214, 'lps'),
	(596987, 131, '2014-03-15 00:47:22.000000', 'consum', 0.0221, 'lps'),
	(596988, 131, '2014-03-15 00:47:23.000000', 'consum', 0.0224, 'lps'),
	(596989, 131, '2014-03-15 00:47:24.000000', 'consum', 0.0219, 'lps'),
	(596990, 131, '2014-03-15 00:47:25.000000', 'consum', 0.0215, 'lps'),
	(596991, 131, '2014-03-15 00:47:26.000000', 'consum', 0.0234, 'lps'),
	(596992, 131, '2014-03-15 00:47:27.000000', 'consum', 0.0235, 'lps'),
	(596993, 131, '2014-03-15 00:47:28.000000', 'consum', 0.0233, 'lps'),
	(596994, 131, '2014-03-15 00:47:29.000000', 'consum', 0.0225, 'lps'),
	(596995, 131, '2014-03-15 00:47:30.000000', 'consum', 0.0213, 'lps'),
	(596996, 131, '2014-03-15 00:47:31.000000', 'consum', 0.0211, 'lps'),
	(596997, 131, '2014-03-15 00:47:32.000000', 'consum', 0.0236, 'lps'),
	(596998, 131, '2014-03-15 00:47:33.000000', 'consum', 0.0223, 'lps'),
	(596999, 131, '2014-03-15 00:47:34.000000', 'consum', 0.0226, 'lps'),
	(597000, 131, '2014-03-15 00:47:35.000000', 'consum', 0.0226, 'lps'),
	(597001, 131, '2014-03-15 00:47:36.000000', 'consum', 0.0211, 'lps'),
	(597002, 131, '2014-03-15 00:47:37.000000', 'consum', 0.0227, 'lps'),
	(597003, 131, '2014-03-15 00:47:38.000000', 'consum', 0.0234, 'lps'),
	(597004, 131, '2014-03-15 00:47:39.000000', 'consum', 0.0223, 'lps'),
	(597005, 131, '2014-03-15 00:47:40.000000', 'consum', 0.0233, 'lps'),
	(597006, 131, '2014-03-15 00:47:41.000000', 'consum', 0.0231, 'lps'),
	(597007, 131, '2014-03-15 00:47:42.000000', 'consum', 0.0217, 'lps'),
	(597008, 131, '2014-03-15 00:47:43.000000', 'consum', 0.0211, 'lps'),
	(597009, 131, '2014-03-15 00:47:44.000000', 'consum', 0.0221, 'lps'),
	(597010, 131, '2014-03-15 00:47:45.000000', 'consum', 0.0234, 'lps'),
	(597011, 131, '2014-03-15 00:47:46.000000', 'consum', 0.0216, 'lps'),
	(597012, 131, '2014-03-15 00:47:47.000000', 'consum', 0.0223, 'lps'),
	(597013, 131, '2014-03-15 00:47:48.000000', 'consum', 0.0229, 'lps'),
	(597014, 131, '2014-03-15 00:47:49.000000', 'consum', 0.0237, 'lps'),
	(597015, 131, '2014-03-15 00:47:50.000000', 'consum', 0.0235, 'lps'),
	(597016, 131, '2014-03-15 00:47:51.000000', 'consum', 0.0224, 'lps'),
	(597017, 131, '2014-03-15 00:47:52.000000', 'consum', 0.0235, 'lps'),
	(597018, 131, '2014-03-15 00:47:53.000000', 'consum', 0.0210, 'lps'),
	(597019, 131, '2014-03-15 00:47:54.000000', 'consum', 0.0217, 'lps'),
	(597020, 131, '2014-03-15 00:47:55.000000', 'consum', 0.0219, 'lps'),
	(597021, 131, '2014-03-15 00:47:56.000000', 'consum', 0.0235, 'lps'),
	(597022, 131, '2014-03-15 00:47:57.000000', 'consum', 0.0225, 'lps'),
	(597023, 131, '2014-03-15 00:47:58.000000', 'consum', 0.0210, 'lps'),
	(597024, 131, '2014-03-15 00:47:59.000000', 'consum', 0.0223, 'lps'),
	(597025, 131, '2014-03-15 00:48:00.000000', 'consum', 0.0220, 'lps'),
	(597026, 131, '2014-03-15 00:48:01.000000', 'consum', 0.0220, 'lps'),
	(597027, 131, '2014-03-15 00:48:02.000000', 'consum', 0.0233, 'lps'),
	(597028, 131, '2014-03-15 00:48:03.000000', 'consum', 0.0237, 'lps'),
	(597029, 131, '2014-03-15 00:48:04.000000', 'consum', 0.0219, 'lps'),
	(597030, 131, '2014-03-15 00:48:05.000000', 'consum', 0.0232, 'lps'),
	(597031, 131, '2014-03-15 00:48:06.000000', 'consum', 0.0210, 'lps'),
	(597032, 131, '2014-03-15 00:48:07.000000', 'consum', 0.0227, 'lps'),
	(597033, 131, '2014-03-15 00:48:08.000000', 'consum', 0.0211, 'lps'),
	(597034, 131, '2014-03-15 00:48:09.000000', 'consum', 0.0220, 'lps'),
	(597035, 131, '2014-03-15 00:48:10.000000', 'consum', 0.0232, 'lps'),
	(597036, 131, '2014-03-15 00:48:11.000000', 'consum', 0.0232, 'lps'),
	(597037, 131, '2014-03-15 00:48:12.000000', 'consum', 0.0229, 'lps'),
	(597038, 131, '2014-03-15 00:48:13.000000', 'consum', 0.0237, 'lps'),
	(597039, 131, '2014-03-15 00:48:14.000000', 'consum', 0.0234, 'lps'),
	(597040, 131, '2014-03-15 00:48:15.000000', 'consum', 0.0223, 'lps'),
	(597041, 131, '2014-03-15 00:48:16.000000', 'consum', 0.0230, 'lps'),
	(597042, 131, '2014-03-15 00:48:17.000000', 'consum', 0.0214, 'lps'),
	(597043, 131, '2014-03-15 00:48:18.000000', 'consum', 0.0230, 'lps'),
	(597044, 131, '2014-03-15 00:48:19.000000', 'consum', 0.0211, 'lps'),
	(597045, 131, '2014-03-15 00:48:20.000000', 'consum', 0.0214, 'lps'),
	(597046, 131, '2014-03-15 00:48:21.000000', 'consum', 0.0225, 'lps'),
	(597047, 131, '2014-03-15 00:48:22.000000', 'consum', 0.0220, 'lps'),
	(597048, 131, '2014-03-15 00:48:23.000000', 'consum', 0.0215, 'lps'),
	(597049, 131, '2014-03-15 00:48:24.000000', 'consum', 0.0234, 'lps'),
	(597050, 131, '2014-03-15 00:48:25.000000', 'consum', 0.0232, 'lps'),
	(597051, 131, '2014-03-15 00:48:26.000000', 'consum', 0.0218, 'lps'),
	(597052, 131, '2014-03-15 00:48:27.000000', 'consum', 0.0216, 'lps'),
	(597053, 131, '2014-03-15 00:48:28.000000', 'consum', 0.0213, 'lps'),
	(597054, 131, '2014-03-15 00:48:29.000000', 'consum', 0.0237, 'lps'),
	(597055, 131, '2014-03-15 00:48:30.000000', 'consum', 0.0226, 'lps'),
	(597056, 131, '2014-03-15 00:48:31.000000', 'consum', 0.0210, 'lps'),
	(597057, 131, '2014-03-15 00:48:32.000000', 'consum', 0.0219, 'lps'),
	(597058, 131, '2014-03-15 00:48:33.000000', 'consum', 0.0226, 'lps'),
	(597059, 131, '2014-03-15 00:48:34.000000', 'consum', 0.0210, 'lps'),
	(597060, 131, '2014-03-15 00:48:35.000000', 'consum', 0.0216, 'lps'),
	(597061, 131, '2014-03-15 00:48:36.000000', 'consum', 0.0211, 'lps'),
	(597062, 131, '2014-03-15 00:48:37.000000', 'consum', 0.0228, 'lps'),
	(597063, 131, '2014-03-15 00:48:38.000000', 'consum', 0.0212, 'lps'),
	(597064, 131, '2014-03-15 00:48:39.000000', 'consum', 0.0221, 'lps'),
	(597065, 131, '2014-03-15 00:48:40.000000', 'consum', 0.0233, 'lps'),
	(597066, 131, '2014-03-15 00:48:41.000000', 'consum', 0.0237, 'lps'),
	(597067, 131, '2014-03-15 00:48:42.000000', 'consum', 0.0221, 'lps'),
	(597068, 131, '2014-03-15 00:48:43.000000', 'consum', 0.0210, 'lps'),
	(597069, 131, '2014-03-15 00:48:44.000000', 'consum', 0.0234, 'lps'),
	(597070, 131, '2014-03-15 00:48:45.000000', 'consum', 0.0218, 'lps'),
	(597071, 131, '2014-03-15 00:48:46.000000', 'consum', 0.0235, 'lps'),
	(597072, 131, '2014-03-15 00:48:47.000000', 'consum', 0.0227, 'lps'),
	(597073, 131, '2014-03-15 00:48:48.000000', 'consum', 0.0220, 'lps'),
	(597074, 131, '2014-03-15 00:48:49.000000', 'consum', 0.0211, 'lps'),
	(597075, 131, '2014-03-15 00:48:50.000000', 'consum', 0.0213, 'lps'),
	(597076, 131, '2014-03-15 00:48:51.000000', 'consum', 0.0222, 'lps'),
	(597077, 131, '2014-03-15 00:48:52.000000', 'consum', 0.0232, 'lps'),
	(597078, 131, '2014-03-15 00:48:53.000000', 'consum', 0.0231, 'lps'),
	(597079, 131, '2014-03-15 00:48:54.000000', 'consum', 0.0220, 'lps'),
	(597080, 131, '2014-03-15 00:48:55.000000', 'consum', 0.0227, 'lps'),
	(597081, 131, '2014-03-15 00:48:56.000000', 'consum', 0.0210, 'lps'),
	(597082, 131, '2014-03-15 00:48:57.000000', 'consum', 0.0213, 'lps'),
	(597083, 131, '2014-03-15 00:48:58.000000', 'consum', 0.0228, 'lps'),
	(597084, 131, '2014-03-15 00:48:59.000000', 'consum', 0.0236, 'lps'),
	(597085, 131, '2014-03-15 00:49:00.000000', 'consum', 0.0228, 'lps'),
	(597086, 131, '2014-03-15 00:49:01.000000', 'consum', 0.0226, 'lps'),
	(597087, 131, '2014-03-15 00:49:02.000000', 'consum', 0.0233, 'lps'),
	(597088, 131, '2014-03-15 00:49:03.000000', 'consum', 0.0224, 'lps'),
	(597089, 131, '2014-03-15 00:49:04.000000', 'consum', 0.0211, 'lps'),
	(597090, 131, '2014-03-15 00:49:05.000000', 'consum', 0.0229, 'lps'),
	(597091, 131, '2014-03-15 00:49:06.000000', 'consum', 0.0218, 'lps'),
	(597092, 131, '2014-03-15 00:49:07.000000', 'consum', 0.0220, 'lps'),
	(597093, 131, '2014-03-15 00:49:08.000000', 'consum', 0.0211, 'lps'),
	(597094, 131, '2014-03-15 00:49:09.000000', 'consum', 0.0214, 'lps'),
	(597095, 131, '2014-03-15 00:49:10.000000', 'consum', 0.0225, 'lps'),
	(597096, 131, '2014-03-15 00:49:11.000000', 'consum', 0.0221, 'lps'),
	(597097, 131, '2014-03-15 00:49:12.000000', 'consum', 0.0217, 'lps'),
	(597098, 131, '2014-03-15 00:49:13.000000', 'consum', 0.0214, 'lps'),
	(597099, 131, '2014-03-15 00:49:14.000000', 'consum', 0.0237, 'lps'),
	(597100, 131, '2014-03-15 00:49:15.000000', 'consum', 0.0224, 'lps'),
	(597101, 131, '2014-03-15 00:49:16.000000', 'consum', 0.0224, 'lps'),
	(597102, 131, '2014-03-15 00:49:17.000000', 'consum', 0.0211, 'lps'),
	(597103, 131, '2014-03-15 00:49:18.000000', 'consum', 0.0231, 'lps'),
	(597104, 131, '2014-03-15 00:49:19.000000', 'consum', 0.0229, 'lps'),
	(597105, 131, '2014-03-15 00:49:20.000000', 'consum', 0.0212, 'lps'),
	(597106, 131, '2014-03-15 00:49:21.000000', 'consum', 0.0222, 'lps'),
	(597107, 131, '2014-03-15 00:49:22.000000', 'consum', 0.0237, 'lps'),
	(597108, 131, '2014-03-15 00:49:23.000000', 'consum', 0.0225, 'lps'),
	(597109, 131, '2014-03-15 00:49:24.000000', 'consum', 0.0232, 'lps'),
	(597110, 131, '2014-03-15 00:49:25.000000', 'consum', 0.0220, 'lps'),
	(597111, 131, '2014-03-15 00:49:26.000000', 'consum', 0.0222, 'lps'),
	(597112, 131, '2014-03-15 00:49:27.000000', 'consum', 0.0213, 'lps'),
	(597113, 131, '2014-03-15 00:49:28.000000', 'consum', 0.0217, 'lps'),
	(597114, 131, '2014-03-15 00:49:29.000000', 'consum', 0.0210, 'lps'),
	(597115, 131, '2014-03-15 00:49:30.000000', 'consum', 0.0216, 'lps'),
	(597116, 131, '2014-03-15 00:49:31.000000', 'consum', 0.0214, 'lps'),
	(597117, 131, '2014-03-15 00:49:32.000000', 'consum', 0.0210, 'lps'),
	(597118, 131, '2014-03-15 00:49:33.000000', 'consum', 0.0228, 'lps'),
	(597119, 131, '2014-03-15 00:49:34.000000', 'consum', 0.0217, 'lps'),
	(597120, 131, '2014-03-15 00:49:35.000000', 'consum', 0.0217, 'lps'),
	(597121, 131, '2014-03-15 00:49:36.000000', 'consum', 0.0227, 'lps'),
	(597122, 131, '2014-03-15 00:49:37.000000', 'consum', 0.0217, 'lps'),
	(597123, 131, '2014-03-15 00:49:38.000000', 'consum', 0.0224, 'lps'),
	(597124, 131, '2014-03-15 00:49:39.000000', 'consum', 0.0229, 'lps'),
	(597125, 131, '2014-03-15 00:49:40.000000', 'consum', 0.0237, 'lps'),
	(597126, 131, '2014-03-15 00:49:41.000000', 'consum', 0.0232, 'lps'),
	(597127, 131, '2014-03-15 00:49:42.000000', 'consum', 0.0213, 'lps'),
	(597128, 131, '2014-03-15 00:49:43.000000', 'consum', 0.0214, 'lps'),
	(597129, 131, '2014-03-15 00:49:44.000000', 'consum', 0.0220, 'lps'),
	(597130, 131, '2014-03-15 00:49:45.000000', 'consum', 0.0223, 'lps'),
	(597131, 131, '2014-03-15 00:49:46.000000', 'consum', 0.0218, 'lps'),
	(597132, 131, '2014-03-15 00:49:47.000000', 'consum', 0.0212, 'lps'),
	(597133, 131, '2014-03-15 00:49:48.000000', 'consum', 0.0223, 'lps'),
	(597134, 131, '2014-03-15 00:49:49.000000', 'consum', 0.0215, 'lps'),
	(597135, 131, '2014-03-15 00:49:50.000000', 'consum', 0.0225, 'lps'),
	(597136, 131, '2014-03-15 00:49:51.000000', 'consum', 0.0214, 'lps'),
	(597137, 131, '2014-03-15 00:49:52.000000', 'consum', 0.0213, 'lps'),
	(597138, 131, '2014-03-15 00:49:53.000000', 'consum', 0.0212, 'lps'),
	(597139, 131, '2014-03-15 00:49:54.000000', 'consum', 0.0213, 'lps'),
	(597140, 131, '2014-03-15 00:49:55.000000', 'consum', 0.0219, 'lps'),
	(597141, 131, '2014-03-15 00:49:56.000000', 'consum', 0.0219, 'lps'),
	(597142, 131, '2014-03-15 00:49:57.000000', 'consum', 0.0229, 'lps'),
	(597143, 131, '2014-03-15 00:49:58.000000', 'consum', 0.0224, 'lps'),
	(597144, 131, '2014-03-15 00:49:59.000000', 'consum', 0.0222, 'lps'),
	(597145, 131, '2014-03-15 00:50:00.000000', 'consum', 0.0230, 'lps'),
	(597146, 131, '2014-03-15 00:50:01.000000', 'consum', 0.0220, 'lps'),
	(597147, 131, '2014-03-15 00:50:02.000000', 'consum', 0.0225, 'lps'),
	(597148, 131, '2014-03-15 00:50:03.000000', 'consum', 0.0227, 'lps'),
	(597149, 131, '2014-03-15 00:50:04.000000', 'consum', 0.0225, 'lps'),
	(597150, 131, '2014-03-15 00:50:05.000000', 'consum', 0.0233, 'lps'),
	(597151, 131, '2014-03-15 00:50:06.000000', 'consum', 0.0224, 'lps'),
	(597152, 131, '2014-03-15 00:50:07.000000', 'consum', 0.0214, 'lps'),
	(597153, 131, '2014-03-15 00:50:08.000000', 'consum', 0.0216, 'lps'),
	(597154, 131, '2014-03-15 00:50:09.000000', 'consum', 0.0227, 'lps'),
	(597155, 131, '2014-03-15 00:50:10.000000', 'consum', 0.0223, 'lps'),
	(597156, 131, '2014-03-15 00:50:11.000000', 'consum', 0.0224, 'lps'),
	(597157, 131, '2014-03-15 00:50:12.000000', 'consum', 0.0215, 'lps'),
	(597158, 131, '2014-03-15 00:50:13.000000', 'consum', 0.0222, 'lps'),
	(597159, 131, '2014-03-15 00:50:14.000000', 'consum', 0.0226, 'lps'),
	(597160, 131, '2014-03-15 00:50:15.000000', 'consum', 0.0227, 'lps'),
	(597161, 131, '2014-03-15 00:50:16.000000', 'consum', 0.0218, 'lps'),
	(597162, 131, '2014-03-15 00:50:17.000000', 'consum', 0.0228, 'lps'),
	(597163, 131, '2014-03-15 00:50:18.000000', 'consum', 0.0221, 'lps'),
	(597164, 131, '2014-03-15 00:50:19.000000', 'consum', 0.0212, 'lps'),
	(597165, 131, '2014-03-15 00:50:20.000000', 'consum', 0.0214, 'lps'),
	(597166, 131, '2014-03-15 00:50:21.000000', 'consum', 0.0226, 'lps'),
	(597167, 131, '2014-03-15 00:50:22.000000', 'consum', 0.0221, 'lps'),
	(597168, 131, '2014-03-15 00:50:23.000000', 'consum', 0.0217, 'lps'),
	(597169, 131, '2014-03-15 00:50:24.000000', 'consum', 0.0212, 'lps'),
	(597170, 131, '2014-03-15 00:50:25.000000', 'consum', 0.0229, 'lps'),
	(597171, 131, '2014-03-15 00:50:26.000000', 'consum', 0.0216, 'lps'),
	(597172, 131, '2014-03-15 00:50:27.000000', 'consum', 0.0237, 'lps'),
	(597173, 131, '2014-03-15 00:50:28.000000', 'consum', 0.0218, 'lps'),
	(597174, 131, '2014-03-15 00:50:29.000000', 'consum', 0.0223, 'lps'),
	(597175, 131, '2014-03-15 00:50:30.000000', 'consum', 0.0225, 'lps'),
	(597176, 131, '2014-03-15 00:50:31.000000', 'consum', 0.0219, 'lps'),
	(597177, 131, '2014-03-15 00:50:32.000000', 'consum', 0.0210, 'lps'),
	(597178, 131, '2014-03-15 00:50:33.000000', 'consum', 0.0213, 'lps'),
	(597179, 131, '2014-03-15 00:50:34.000000', 'consum', 0.0223, 'lps'),
	(597180, 131, '2014-03-15 00:50:35.000000', 'consum', 0.0211, 'lps'),
	(597181, 131, '2014-03-15 00:50:36.000000', 'consum', 0.0231, 'lps'),
	(597182, 131, '2014-03-15 00:50:37.000000', 'consum', 0.0229, 'lps'),
	(597183, 131, '2014-03-15 00:50:38.000000', 'consum', 0.0214, 'lps'),
	(597184, 131, '2014-03-15 00:50:39.000000', 'consum', 0.0230, 'lps'),
	(597185, 131, '2014-03-15 00:50:40.000000', 'consum', 0.0215, 'lps'),
	(597186, 131, '2014-03-15 00:50:41.000000', 'consum', 0.0232, 'lps'),
	(597187, 131, '2014-03-15 00:50:42.000000', 'consum', 0.0222, 'lps'),
	(597188, 131, '2014-03-15 00:50:43.000000', 'consum', 0.0230, 'lps'),
	(597189, 131, '2014-03-15 00:50:44.000000', 'consum', 0.0221, 'lps'),
	(597190, 131, '2014-03-15 00:50:45.000000', 'consum', 0.0234, 'lps'),
	(597191, 131, '2014-03-15 00:50:46.000000', 'consum', 0.0212, 'lps'),
	(597192, 131, '2014-03-15 00:50:47.000000', 'consum', 0.0234, 'lps'),
	(597193, 131, '2014-03-15 00:50:48.000000', 'consum', 0.0212, 'lps'),
	(597194, 131, '2014-03-15 00:50:49.000000', 'consum', 0.0234, 'lps'),
	(597195, 131, '2014-03-15 00:50:50.000000', 'consum', 0.0212, 'lps'),
	(597196, 131, '2014-03-15 00:50:51.000000', 'consum', 0.0232, 'lps'),
	(597197, 131, '2014-03-15 00:50:52.000000', 'consum', 0.0232, 'lps'),
	(597198, 131, '2014-03-15 00:50:53.000000', 'consum', 0.0224, 'lps'),
	(597199, 131, '2014-03-15 00:50:54.000000', 'consum', 0.0214, 'lps'),
	(597200, 131, '2014-03-15 00:50:55.000000', 'consum', 0.0216, 'lps'),
	(597201, 131, '2014-03-15 00:50:56.000000', 'consum', 0.0228, 'lps'),
	(597202, 131, '2014-03-15 00:50:57.000000', 'consum', 0.0227, 'lps'),
	(597203, 131, '2014-03-15 00:50:58.000000', 'consum', 0.0212, 'lps'),
	(597204, 131, '2014-03-15 00:50:59.000000', 'consum', 0.0226, 'lps'),
	(597205, 131, '2014-03-15 00:51:00.000000', 'consum', 0.0229, 'lps'),
	(597206, 131, '2014-03-15 00:51:01.000000', 'consum', 0.0231, 'lps'),
	(597207, 131, '2014-03-15 00:51:02.000000', 'consum', 0.0229, 'lps'),
	(597208, 131, '2014-03-15 00:51:03.000000', 'consum', 0.0213, 'lps'),
	(597209, 131, '2014-03-15 00:51:04.000000', 'consum', 0.0227, 'lps'),
	(597210, 131, '2014-03-15 00:51:05.000000', 'consum', 0.0231, 'lps'),
	(597211, 131, '2014-03-15 00:51:06.000000', 'consum', 0.0236, 'lps'),
	(597212, 131, '2014-03-15 00:51:07.000000', 'consum', 0.0223, 'lps'),
	(597213, 131, '2014-03-15 00:51:08.000000', 'consum', 0.0226, 'lps'),
	(597214, 131, '2014-03-15 00:51:09.000000', 'consum', 0.0221, 'lps'),
	(597215, 131, '2014-03-15 00:51:10.000000', 'consum', 0.0218, 'lps'),
	(597216, 131, '2014-03-15 00:51:11.000000', 'consum', 0.0218, 'lps'),
	(597217, 131, '2014-03-15 00:51:12.000000', 'consum', 0.0227, 'lps'),
	(597218, 131, '2014-03-15 00:51:13.000000', 'consum', 0.0215, 'lps'),
	(597219, 131, '2014-03-15 00:51:14.000000', 'consum', 0.0212, 'lps'),
	(597220, 131, '2014-03-15 00:51:15.000000', 'consum', 0.0232, 'lps'),
	(597221, 131, '2014-03-15 00:51:16.000000', 'consum', 0.0232, 'lps'),
	(597222, 131, '2014-03-15 00:51:17.000000', 'consum', 0.0227, 'lps'),
	(597223, 131, '2014-03-15 00:51:18.000000', 'consum', 0.0229, 'lps'),
	(597224, 131, '2014-03-15 00:51:19.000000', 'consum', 0.0225, 'lps'),
	(597225, 131, '2014-03-15 00:51:20.000000', 'consum', 0.0230, 'lps'),
	(597226, 131, '2014-03-15 00:51:21.000000', 'consum', 0.0211, 'lps'),
	(597227, 131, '2014-03-15 00:51:22.000000', 'consum', 0.0211, 'lps'),
	(597228, 131, '2014-03-15 00:51:23.000000', 'consum', 0.0214, 'lps'),
	(597229, 131, '2014-03-15 00:51:24.000000', 'consum', 0.0225, 'lps'),
	(597230, 131, '2014-03-15 00:51:25.000000', 'consum', 0.0219, 'lps'),
	(597231, 131, '2014-03-15 00:51:26.000000', 'consum', 0.0236, 'lps'),
	(597232, 131, '2014-03-15 00:51:27.000000', 'consum', 0.0231, 'lps'),
	(597233, 131, '2014-03-15 00:51:28.000000', 'consum', 0.0211, 'lps'),
	(597234, 131, '2014-03-15 00:51:29.000000', 'consum', 0.0234, 'lps'),
	(597235, 131, '2014-03-15 00:51:30.000000', 'consum', 0.0215, 'lps'),
	(597236, 131, '2014-03-15 00:51:31.000000', 'consum', 0.0219, 'lps'),
	(597237, 131, '2014-03-15 00:51:32.000000', 'consum', 0.0215, 'lps'),
	(597238, 131, '2014-03-15 00:51:33.000000', 'consum', 0.0237, 'lps'),
	(597239, 131, '2014-03-15 00:51:34.000000', 'consum', 0.0217, 'lps'),
	(597240, 131, '2014-03-15 00:51:35.000000', 'consum', 0.0222, 'lps'),
	(597241, 131, '2014-03-15 00:51:36.000000', 'consum', 0.0222, 'lps'),
	(597242, 131, '2014-03-15 00:51:37.000000', 'consum', 0.0233, 'lps'),
	(597243, 131, '2014-03-15 00:51:38.000000', 'consum', 0.0233, 'lps'),
	(597244, 131, '2014-03-15 00:51:39.000000', 'consum', 0.0230, 'lps'),
	(597245, 131, '2014-03-15 00:51:40.000000', 'consum', 0.0215, 'lps'),
	(597246, 131, '2014-03-15 00:51:41.000000', 'consum', 0.0230, 'lps'),
	(597247, 131, '2014-03-15 00:51:42.000000', 'consum', 0.0212, 'lps'),
	(597248, 131, '2014-03-15 00:51:43.000000', 'consum', 0.0215, 'lps'),
	(597249, 131, '2014-03-15 00:51:44.000000', 'consum', 0.0230, 'lps'),
	(597250, 131, '2014-03-15 00:51:45.000000', 'consum', 0.0212, 'lps'),
	(597251, 131, '2014-03-15 00:51:46.000000', 'consum', 0.0215, 'lps'),
	(597252, 131, '2014-03-15 00:51:47.000000', 'consum', 0.0232, 'lps'),
	(597253, 131, '2014-03-15 00:51:48.000000', 'consum', 0.0221, 'lps'),
	(597254, 131, '2014-03-15 00:51:49.000000', 'consum', 0.0225, 'lps'),
	(597255, 131, '2014-03-15 00:51:50.000000', 'consum', 0.0227, 'lps'),
	(597256, 131, '2014-03-15 00:51:51.000000', 'consum', 0.0221, 'lps'),
	(597257, 131, '2014-03-15 00:51:52.000000', 'consum', 0.0213, 'lps'),
	(597258, 131, '2014-03-15 00:51:53.000000', 'consum', 0.0222, 'lps'),
	(597259, 131, '2014-03-15 00:51:54.000000', 'consum', 0.0233, 'lps'),
	(597260, 131, '2014-03-15 00:51:55.000000', 'consum', 0.0234, 'lps'),
	(597261, 131, '2014-03-15 00:51:56.000000', 'consum', 0.0235, 'lps'),
	(597262, 131, '2014-03-15 00:51:57.000000', 'consum', 0.0234, 'lps'),
	(597263, 131, '2014-03-15 00:51:58.000000', 'consum', 0.0229, 'lps'),
	(597264, 131, '2014-03-15 00:51:59.000000', 'consum', 0.0233, 'lps'),
	(597265, 131, '2014-03-15 00:52:00.000000', 'consum', 0.0213, 'lps'),
	(597266, 131, '2014-03-15 00:52:01.000000', 'consum', 0.0212, 'lps'),
	(597267, 131, '2014-03-15 00:52:02.000000', 'consum', 0.0213, 'lps'),
	(597268, 131, '2014-03-15 00:52:03.000000', 'consum', 0.0218, 'lps'),
	(597269, 131, '2014-03-15 00:52:04.000000', 'consum', 0.0215, 'lps'),
	(597270, 131, '2014-03-15 00:52:05.000000', 'consum', 0.0212, 'lps'),
	(597271, 131, '2014-03-15 00:52:06.000000', 'consum', 0.0231, 'lps'),
	(597272, 131, '2014-03-15 00:52:07.000000', 'consum', 0.0225, 'lps'),
	(597273, 131, '2014-03-15 00:52:08.000000', 'consum', 0.0225, 'lps'),
	(597274, 131, '2014-03-15 00:52:09.000000', 'consum', 0.0237, 'lps'),
	(597275, 131, '2014-03-15 00:52:10.000000', 'consum', 0.0220, 'lps'),
	(597276, 131, '2014-03-15 00:52:11.000000', 'consum', 0.0234, 'lps'),
	(597277, 131, '2014-03-15 00:52:12.000000', 'consum', 0.0218, 'lps'),
	(597278, 131, '2014-03-15 00:52:13.000000', 'consum', 0.0233, 'lps'),
	(597279, 131, '2014-03-15 00:52:14.000000', 'consum', 0.0219, 'lps'),
	(597280, 131, '2014-03-15 00:52:15.000000', 'consum', 0.0216, 'lps'),
	(597281, 131, '2014-03-15 00:52:16.000000', 'consum', 0.0211, 'lps'),
	(597282, 131, '2014-03-15 00:52:17.000000', 'consum', 0.0225, 'lps'),
	(597283, 131, '2014-03-15 00:52:18.000000', 'consum', 0.0228, 'lps'),
	(597284, 131, '2014-03-15 00:52:19.000000', 'consum', 0.0228, 'lps'),
	(597285, 131, '2014-03-15 00:52:20.000000', 'consum', 0.0217, 'lps'),
	(597286, 131, '2014-03-15 00:52:21.000000', 'consum', 0.0220, 'lps'),
	(597287, 131, '2014-03-15 00:52:22.000000', 'consum', 0.0213, 'lps'),
	(597288, 131, '2014-03-15 00:52:23.000000', 'consum', 0.0221, 'lps'),
	(597289, 131, '2014-03-15 00:52:24.000000', 'consum', 0.0231, 'lps'),
	(597290, 131, '2014-03-15 00:52:25.000000', 'consum', 0.0225, 'lps'),
	(597291, 131, '2014-03-15 00:52:26.000000', 'consum', 0.0225, 'lps'),
	(597292, 131, '2014-03-15 00:52:27.000000', 'consum', 0.0237, 'lps'),
	(597293, 131, '2014-03-15 00:52:28.000000', 'consum', 0.0219, 'lps'),
	(597294, 131, '2014-03-15 00:52:29.000000', 'consum', 0.0231, 'lps'),
	(597295, 131, '2014-03-15 00:52:30.000000', 'consum', 0.0232, 'lps'),
	(597296, 131, '2014-03-15 00:52:31.000000', 'consum', 0.0228, 'lps'),
	(597297, 131, '2014-03-15 00:52:32.000000', 'consum', 0.0236, 'lps'),
	(597298, 131, '2014-03-15 00:52:33.000000', 'consum', 0.0230, 'lps'),
	(597299, 131, '2014-03-15 00:52:34.000000', 'consum', 0.0230, 'lps'),
	(597300, 131, '2014-03-15 00:52:35.000000', 'consum', 0.0226, 'lps'),
	(597301, 131, '2014-03-15 00:52:36.000000', 'consum', 0.0231, 'lps'),
	(597302, 131, '2014-03-15 00:52:37.000000', 'consum', 0.0237, 'lps'),
	(597303, 131, '2014-03-15 00:52:38.000000', 'consum', 0.0225, 'lps'),
	(597304, 131, '2014-03-15 00:52:39.000000', 'consum', 0.0236, 'lps'),
	(597305, 131, '2014-03-15 00:52:40.000000', 'consum', 0.0210, 'lps'),
	(597306, 131, '2014-03-15 00:52:41.000000', 'consum', 0.0216, 'lps'),
	(597307, 131, '2014-03-15 00:52:42.000000', 'consum', 0.0215, 'lps'),
	(597308, 131, '2014-03-15 00:52:43.000000', 'consum', 0.0214, 'lps'),
	(597309, 131, '2014-03-15 00:52:44.000000', 'consum', 0.0217, 'lps'),
	(597310, 131, '2014-03-15 00:52:45.000000', 'consum', 0.0234, 'lps'),
	(597311, 131, '2014-03-15 00:52:46.000000', 'consum', 0.0224, 'lps'),
	(597312, 131, '2014-03-15 00:52:47.000000', 'consum', 0.0237, 'lps'),
	(597313, 131, '2014-03-15 00:52:48.000000', 'consum', 0.0220, 'lps'),
	(597314, 131, '2014-03-15 00:52:49.000000', 'consum', 0.0235, 'lps'),
	(597315, 131, '2014-03-15 00:52:50.000000', 'consum', 0.0223, 'lps'),
	(597316, 131, '2014-03-15 00:52:51.000000', 'consum', 0.0229, 'lps'),
	(597317, 131, '2014-03-15 00:52:52.000000', 'consum', 0.0237, 'lps'),
	(597318, 131, '2014-03-15 00:52:53.000000', 'consum', 0.0235, 'lps'),
	(597319, 131, '2014-03-15 00:52:54.000000', 'consum', 0.0223, 'lps'),
	(597320, 131, '2014-03-15 00:52:55.000000', 'consum', 0.0230, 'lps'),
	(597321, 131, '2014-03-15 00:52:56.000000', 'consum', 0.0215, 'lps'),
	(597322, 131, '2014-03-15 00:52:57.000000', 'consum', 0.0232, 'lps'),
	(597323, 131, '2014-03-15 00:52:58.000000', 'consum', 0.0223, 'lps'),
	(597324, 131, '2014-03-15 00:52:59.000000', 'consum', 0.0210, 'lps'),
	(597325, 131, '2014-03-15 00:53:00.000000', 'consum', 0.0224, 'lps'),
	(597326, 131, '2014-03-15 00:53:01.000000', 'consum', 0.0228, 'lps'),
	(597327, 131, '2014-03-15 00:53:02.000000', 'consum', 0.0228, 'lps'),
	(597328, 131, '2014-03-15 00:53:03.000000', 'consum', 0.0221, 'lps'),
	(597329, 131, '2014-03-15 00:53:04.000000', 'consum', 0.0237, 'lps'),
	(597330, 131, '2014-03-15 00:53:05.000000', 'consum', 0.0228, 'lps'),
	(597331, 131, '2014-03-15 00:53:06.000000', 'consum', 0.0220, 'lps'),
	(597332, 131, '2014-03-15 00:53:07.000000', 'consum', 0.0235, 'lps'),
	(597333, 131, '2014-03-15 00:53:08.000000', 'consum', 0.0223, 'lps'),
	(597334, 131, '2014-03-15 00:53:09.000000', 'consum', 0.0226, 'lps'),
	(597335, 131, '2014-03-15 00:53:10.000000', 'consum', 0.0225, 'lps'),
	(597336, 131, '2014-03-15 00:53:11.000000', 'consum', 0.0236, 'lps'),
	(597337, 131, '2014-03-15 00:53:12.000000', 'consum', 0.0210, 'lps'),
	(597338, 131, '2014-03-15 00:53:13.000000', 'consum', 0.0219, 'lps'),
	(597339, 131, '2014-03-15 00:53:14.000000', 'consum', 0.0228, 'lps'),
	(597340, 131, '2014-03-15 00:53:15.000000', 'consum', 0.0215, 'lps'),
	(597341, 131, '2014-03-15 00:53:16.000000', 'consum', 0.0213, 'lps'),
	(597342, 131, '2014-03-15 00:53:17.000000', 'consum', 0.0235, 'lps'),
	(597343, 131, '2014-03-15 00:53:18.000000', 'consum', 0.0217, 'lps'),
	(597344, 131, '2014-03-15 00:53:19.000000', 'consum', 0.0227, 'lps'),
	(597345, 131, '2014-03-15 00:53:20.000000', 'consum', 0.0216, 'lps'),
	(597346, 131, '2014-03-15 00:53:21.000000', 'consum', 0.0219, 'lps'),
	(597347, 131, '2014-03-15 00:53:22.000000', 'consum', 0.0210, 'lps'),
	(597348, 131, '2014-03-15 00:53:23.000000', 'consum', 0.0210, 'lps'),
	(597349, 131, '2014-03-15 00:53:24.000000', 'consum', 0.0213, 'lps'),
	(597350, 131, '2014-03-15 00:53:25.000000', 'consum', 0.0225, 'lps'),
	(597351, 131, '2014-03-15 00:53:26.000000', 'consum', 0.0220, 'lps'),
	(597352, 131, '2014-03-15 00:53:27.000000', 'consum', 0.0217, 'lps'),
	(597353, 131, '2014-03-15 00:53:28.000000', 'consum', 0.0213, 'lps'),
	(597354, 131, '2014-03-15 00:53:29.000000', 'consum', 0.0232, 'lps'),
	(597355, 131, '2014-03-15 00:53:30.000000', 'consum', 0.0228, 'lps'),
	(597356, 131, '2014-03-15 00:53:31.000000', 'consum', 0.0233, 'lps'),
	(597357, 131, '2014-03-15 00:53:32.000000', 'consum', 0.0219, 'lps'),
	(597358, 131, '2014-03-15 00:53:33.000000', 'consum', 0.0211, 'lps'),
	(597359, 131, '2014-03-15 00:53:34.000000', 'consum', 0.0217, 'lps'),
	(597360, 131, '2014-03-15 00:53:35.000000', 'consum', 0.0217, 'lps'),
	(597361, 131, '2014-03-15 00:53:36.000000', 'consum', 0.0222, 'lps'),
	(597362, 131, '2014-03-15 00:53:37.000000', 'consum', 0.0223, 'lps'),
	(597363, 131, '2014-03-15 00:53:38.000000', 'consum', 0.0212, 'lps'),
	(597364, 131, '2014-03-15 00:53:39.000000', 'consum', 0.0237, 'lps'),
	(597365, 131, '2014-03-15 00:53:40.000000', 'consum', 0.0227, 'lps'),
	(597366, 131, '2014-03-15 00:53:41.000000', 'consum', 0.0215, 'lps'),
	(597367, 131, '2014-03-15 00:53:42.000000', 'consum', 0.0212, 'lps'),
	(597368, 131, '2014-03-15 00:53:43.000000', 'consum', 0.0235, 'lps'),
	(597369, 131, '2014-03-15 00:53:44.000000', 'consum', 0.0218, 'lps'),
	(597370, 131, '2014-03-15 00:53:45.000000', 'consum', 0.0231, 'lps'),
	(597371, 131, '2014-03-15 00:53:46.000000', 'consum', 0.0234, 'lps'),
	(597372, 131, '2014-03-15 00:53:47.000000', 'consum', 0.0213, 'lps'),
	(597373, 131, '2014-03-15 00:53:48.000000', 'consum', 0.0237, 'lps'),
	(597374, 131, '2014-03-15 00:53:49.000000', 'consum', 0.0224, 'lps'),
	(597375, 131, '2014-03-15 00:53:50.000000', 'consum', 0.0229, 'lps'),
	(597376, 131, '2014-03-15 00:53:51.000000', 'consum', 0.0234, 'lps'),
	(597377, 131, '2014-03-15 00:53:52.000000', 'consum', 0.0216, 'lps'),
	(597378, 131, '2014-03-15 00:53:53.000000', 'consum', 0.0227, 'lps'),
	(597379, 131, '2014-03-15 00:53:54.000000', 'consum', 0.0219, 'lps'),
	(597380, 131, '2014-03-15 00:53:55.000000', 'consum', 0.0234, 'lps'),
	(597381, 131, '2014-03-15 00:53:56.000000', 'consum', 0.0221, 'lps'),
	(597382, 131, '2014-03-15 00:53:57.000000', 'consum', 0.0220, 'lps'),
	(597383, 131, '2014-03-15 00:53:58.000000', 'consum', 0.0226, 'lps'),
	(597384, 131, '2014-03-15 00:53:59.000000', 'consum', 0.0233, 'lps'),
	(597385, 131, '2014-03-15 00:54:00.000000', 'consum', 0.0221, 'lps'),
	(597386, 131, '2014-03-15 00:54:01.000000', 'consum', 0.0225, 'lps'),
	(597387, 131, '2014-03-15 00:54:02.000000', 'consum', 0.0225, 'lps'),
	(597388, 131, '2014-03-15 00:54:03.000000', 'consum', 0.0211, 'lps'),
	(597389, 131, '2014-03-15 00:54:04.000000', 'consum', 0.0225, 'lps'),
	(597390, 131, '2014-03-15 00:54:05.000000', 'consum', 0.0229, 'lps'),
	(597391, 131, '2014-03-15 00:54:06.000000', 'consum', 0.0234, 'lps'),
	(597392, 131, '2014-03-15 00:54:07.000000', 'consum', 0.0215, 'lps'),
	(597393, 131, '2014-03-15 00:54:08.000000', 'consum', 0.0218, 'lps'),
	(597394, 131, '2014-03-15 00:54:09.000000', 'consum', 0.0210, 'lps'),
	(597395, 131, '2014-03-15 00:54:10.000000', 'consum', 0.0215, 'lps'),
	(597396, 131, '2014-03-15 00:54:11.000000', 'consum', 0.0233, 'lps'),
	(597397, 131, '2014-03-15 00:54:12.000000', 'consum', 0.0229, 'lps'),
	(597398, 131, '2014-03-15 00:54:13.000000', 'consum', 0.0235, 'lps'),
	(597399, 131, '2014-03-15 00:54:14.000000', 'consum', 0.0224, 'lps'),
	(597400, 131, '2014-03-15 00:54:15.000000', 'consum', 0.0233, 'lps'),
	(597401, 131, '2014-03-15 00:54:16.000000', 'consum', 0.0225, 'lps'),
	(597402, 131, '2014-03-15 00:54:17.000000', 'consum', 0.0220, 'lps'),
	(597403, 131, '2014-03-15 00:54:18.000000', 'consum', 0.0213, 'lps'),
	(597404, 131, '2014-03-15 00:54:19.000000', 'consum', 0.0225, 'lps'),
	(597405, 131, '2014-03-15 00:54:20.000000', 'consum', 0.0219, 'lps'),
	(597406, 131, '2014-03-15 00:54:21.000000', 'consum', 0.0211, 'lps'),
	(597407, 131, '2014-03-15 00:54:22.000000', 'consum', 0.0218, 'lps'),
	(597408, 131, '2014-03-15 00:54:23.000000', 'consum', 0.0220, 'lps'),
	(597409, 131, '2014-03-15 00:54:24.000000', 'consum', 0.0237, 'lps'),
	(597410, 131, '2014-03-15 00:54:25.000000', 'consum', 0.0232, 'lps'),
	(597411, 131, '2014-03-15 00:54:26.000000', 'consum', 0.0212, 'lps'),
	(597412, 131, '2014-03-15 00:54:27.000000', 'consum', 0.0210, 'lps'),
	(597413, 131, '2014-03-15 00:54:28.000000', 'consum', 0.0231, 'lps'),
	(597414, 131, '2014-03-15 00:54:29.000000', 'consum', 0.0231, 'lps'),
	(597415, 131, '2014-03-15 00:54:30.000000', 'consum', 0.0225, 'lps'),
	(597416, 131, '2014-03-15 00:54:31.000000', 'consum', 0.0224, 'lps'),
	(597417, 131, '2014-03-15 00:54:32.000000', 'consum', 0.0233, 'lps'),
	(597418, 131, '2014-03-15 00:54:33.000000', 'consum', 0.0230, 'lps'),
	(597419, 131, '2014-03-15 00:54:34.000000', 'consum', 0.0212, 'lps'),
	(597420, 131, '2014-03-15 00:54:35.000000', 'consum', 0.0219, 'lps'),
	(597421, 131, '2014-03-15 00:54:36.000000', 'consum', 0.0220, 'lps'),
	(597422, 131, '2014-03-15 00:54:37.000000', 'consum', 0.0233, 'lps'),
	(597423, 131, '2014-03-15 00:54:38.000000', 'consum', 0.0212, 'lps'),
	(597424, 131, '2014-03-15 00:54:39.000000', 'consum', 0.0235, 'lps'),
	(597425, 131, '2014-03-15 00:54:40.000000', 'consum', 0.0220, 'lps'),
	(597426, 131, '2014-03-15 00:54:41.000000', 'consum', 0.0210, 'lps'),
	(597427, 131, '2014-03-15 00:54:42.000000', 'consum', 0.0212, 'lps'),
	(597428, 131, '2014-03-15 00:54:43.000000', 'consum', 0.0219, 'lps'),
	(597429, 131, '2014-03-15 00:54:44.000000', 'consum', 0.0221, 'lps'),
	(597430, 131, '2014-03-15 00:54:45.000000', 'consum', 0.0237, 'lps'),
	(597431, 131, '2014-03-15 00:54:46.000000', 'consum', 0.0231, 'lps'),
	(597432, 131, '2014-03-15 00:54:47.000000', 'consum', 0.0235, 'lps'),
	(597433, 131, '2014-03-15 00:54:48.000000', 'consum', 0.0216, 'lps'),
	(597434, 131, '2014-03-15 00:54:49.000000', 'consum', 0.0220, 'lps'),
	(597435, 131, '2014-03-15 00:54:50.000000', 'consum', 0.0214, 'lps'),
	(597436, 131, '2014-03-15 00:54:51.000000', 'consum', 0.0227, 'lps'),
	(597437, 131, '2014-03-15 00:54:52.000000', 'consum', 0.0231, 'lps'),
	(597438, 131, '2014-03-15 00:54:53.000000', 'consum', 0.0235, 'lps'),
	(597439, 131, '2014-03-15 00:54:54.000000', 'consum', 0.0215, 'lps'),
	(597440, 131, '2014-03-15 00:54:55.000000', 'consum', 0.0218, 'lps'),
	(597441, 131, '2014-03-15 00:54:56.000000', 'consum', 0.0236, 'lps'),
	(597442, 131, '2014-03-15 00:54:57.000000', 'consum', 0.0231, 'lps'),
	(597443, 131, '2014-03-15 00:54:58.000000', 'consum', 0.0236, 'lps'),
	(597444, 131, '2014-03-15 00:54:59.000000', 'consum', 0.0224, 'lps'),
	(597445, 131, '2014-03-15 00:55:00.000000', 'consum', 0.0229, 'lps'),
	(597446, 131, '2014-03-15 00:55:01.000000', 'consum', 0.0235, 'lps'),
	(597447, 131, '2014-03-15 00:55:02.000000', 'consum', 0.0223, 'lps'),
	(597448, 131, '2014-03-15 00:55:03.000000', 'consum', 0.0230, 'lps'),
	(597449, 131, '2014-03-15 00:55:04.000000', 'consum', 0.0215, 'lps'),
	(597450, 131, '2014-03-15 00:55:05.000000', 'consum', 0.0232, 'lps'),
	(597451, 131, '2014-03-15 00:55:06.000000', 'consum', 0.0221, 'lps'),
	(597452, 131, '2014-03-15 00:55:07.000000', 'consum', 0.0229, 'lps'),
	(597453, 131, '2014-03-15 00:55:08.000000', 'consum', 0.0215, 'lps'),
	(597454, 131, '2014-03-15 00:55:09.000000', 'consum', 0.0236, 'lps'),
	(597455, 131, '2014-03-15 00:55:10.000000', 'consum', 0.0211, 'lps'),
	(597456, 131, '2014-03-15 00:55:11.000000', 'consum', 0.0221, 'lps'),
	(597457, 131, '2014-03-15 00:55:12.000000', 'consum', 0.0234, 'lps'),
	(597458, 131, '2014-03-15 00:55:13.000000', 'consum', 0.0216, 'lps'),
	(597459, 131, '2014-03-15 00:55:14.000000', 'consum', 0.0223, 'lps'),
	(597460, 131, '2014-03-15 00:55:15.000000', 'consum', 0.0231, 'lps'),
	(597461, 131, '2014-03-15 00:55:16.000000', 'consum', 0.0220, 'lps'),
	(597462, 131, '2014-03-15 00:55:17.000000', 'consum', 0.0227, 'lps'),
	(597463, 131, '2014-03-15 00:55:18.000000', 'consum', 0.0236, 'lps'),
	(597464, 131, '2014-03-15 00:55:19.000000', 'consum', 0.0233, 'lps'),
	(597465, 131, '2014-03-15 00:55:20.000000', 'consum', 0.0219, 'lps'),
	(597466, 131, '2014-03-15 00:55:21.000000', 'consum', 0.0216, 'lps'),
	(597467, 131, '2014-03-15 00:55:22.000000', 'consum', 0.0211, 'lps'),
	(597468, 131, '2014-03-15 00:55:23.000000', 'consum', 0.0228, 'lps'),
	(597469, 131, '2014-03-15 00:55:24.000000', 'consum', 0.0212, 'lps'),
	(597470, 131, '2014-03-15 00:55:25.000000', 'consum', 0.0222, 'lps'),
	(597471, 131, '2014-03-15 00:55:26.000000', 'consum', 0.0211, 'lps'),
	(597472, 131, '2014-03-15 00:55:27.000000', 'consum', 0.0235, 'lps'),
	(597473, 131, '2014-03-15 00:55:28.000000', 'consum', 0.0221, 'lps'),
	(597474, 131, '2014-03-15 00:55:29.000000', 'consum', 0.0217, 'lps'),
	(597475, 131, '2014-03-15 00:55:30.000000', 'consum', 0.0215, 'lps'),
	(597476, 131, '2014-03-15 00:55:31.000000', 'consum', 0.0212, 'lps'),
	(597477, 131, '2014-03-15 00:55:32.000000', 'consum', 0.0235, 'lps'),
	(597478, 131, '2014-03-15 00:55:33.000000', 'consum', 0.0217, 'lps'),
	(597479, 131, '2014-03-15 00:55:34.000000', 'consum', 0.0229, 'lps'),
	(597480, 131, '2014-03-15 00:55:35.000000', 'consum', 0.0225, 'lps'),
	(597481, 131, '2014-03-15 00:55:36.000000', 'consum', 0.0231, 'lps'),
	(597482, 131, '2014-03-15 00:55:37.000000', 'consum', 0.0212, 'lps'),
	(597483, 131, '2014-03-15 00:55:38.000000', 'consum', 0.0213, 'lps'),
	(597484, 131, '2014-03-15 00:55:39.000000', 'consum', 0.0221, 'lps'),
	(597485, 131, '2014-03-15 00:55:40.000000', 'consum', 0.0227, 'lps'),
	(597486, 131, '2014-03-15 00:55:41.000000', 'consum', 0.0236, 'lps'),
	(597487, 131, '2014-03-15 00:55:42.000000', 'consum', 0.0234, 'lps'),
	(597488, 131, '2014-03-15 00:55:43.000000', 'consum', 0.0226, 'lps'),
	(597489, 131, '2014-03-15 00:55:44.000000', 'consum', 0.0215, 'lps'),
	(597490, 131, '2014-03-15 00:55:45.000000', 'consum', 0.0216, 'lps'),
	(597491, 131, '2014-03-15 00:55:46.000000', 'consum', 0.0228, 'lps'),
	(597492, 131, '2014-03-15 00:55:47.000000', 'consum', 0.0223, 'lps'),
	(597493, 131, '2014-03-15 00:55:48.000000', 'consum', 0.0225, 'lps'),
	(597494, 131, '2014-03-15 00:55:49.000000', 'consum', 0.0216, 'lps'),
	(597495, 131, '2014-03-15 00:55:50.000000', 'consum', 0.0223, 'lps'),
	(597496, 131, '2014-03-15 00:55:51.000000', 'consum', 0.0232, 'lps'),
	(597497, 131, '2014-03-15 00:55:52.000000', 'consum', 0.0225, 'lps'),
	(597498, 131, '2014-03-15 00:55:53.000000', 'consum', 0.0218, 'lps'),
	(597499, 131, '2014-03-15 00:55:54.000000', 'consum', 0.0234, 'lps'),
	(597500, 131, '2014-03-15 00:55:55.000000', 'consum', 0.0221, 'lps'),
	(597501, 131, '2014-03-15 00:55:56.000000', 'consum', 0.0223, 'lps'),
	(597502, 131, '2014-03-15 00:55:57.000000', 'consum', 0.0214, 'lps'),
	(597503, 131, '2014-03-15 00:55:58.000000', 'consum', 0.0222, 'lps'),
	(597504, 131, '2014-03-15 00:55:59.000000', 'consum', 0.0228, 'lps'),
	(597505, 131, '2014-03-15 00:56:00.000000', 'consum', 0.0235, 'lps'),
	(597506, 131, '2014-03-15 00:56:01.000000', 'consum', 0.0229, 'lps'),
	(597507, 131, '2014-03-15 00:56:02.000000', 'consum', 0.0227, 'lps'),
	(597508, 131, '2014-03-15 00:56:03.000000', 'consum', 0.0213, 'lps'),
	(597509, 131, '2014-03-15 00:56:04.000000', 'consum', 0.0230, 'lps'),
	(597510, 131, '2014-03-15 00:56:05.000000', 'consum', 0.0216, 'lps'),
	(597511, 131, '2014-03-15 00:56:06.000000', 'consum', 0.0236, 'lps'),
	(597512, 131, '2014-03-15 00:56:07.000000', 'consum', 0.0212, 'lps'),
	(597513, 131, '2014-03-15 00:56:08.000000', 'consum', 0.0228, 'lps'),
	(597514, 131, '2014-03-15 00:56:09.000000', 'consum', 0.0236, 'lps'),
	(597515, 131, '2014-03-15 00:56:10.000000', 'consum', 0.0232, 'lps'),
	(597516, 131, '2014-03-15 00:56:11.000000', 'consum', 0.0214, 'lps'),
	(597517, 131, '2014-03-15 00:56:12.000000', 'consum', 0.0222, 'lps'),
	(597518, 131, '2014-03-15 00:56:13.000000', 'consum', 0.0230, 'lps'),
	(597519, 131, '2014-03-15 00:56:14.000000', 'consum', 0.0216, 'lps'),
	(597520, 131, '2014-03-15 00:56:15.000000', 'consum', 0.0211, 'lps'),
	(597521, 131, '2014-03-15 00:56:16.000000', 'consum', 0.0224, 'lps'),
	(597522, 131, '2014-03-15 00:56:17.000000', 'consum', 0.0220, 'lps'),
	(597523, 131, '2014-03-15 00:56:18.000000', 'consum', 0.0221, 'lps'),
	(597524, 131, '2014-03-15 00:56:19.000000', 'consum', 0.0236, 'lps'),
	(597525, 131, '2014-03-15 00:56:20.000000', 'consum', 0.0223, 'lps'),
	(597526, 131, '2014-03-15 00:56:21.000000', 'consum', 0.0227, 'lps'),
	(597527, 131, '2014-03-15 00:56:22.000000', 'consum', 0.0227, 'lps'),
	(597528, 131, '2014-03-15 00:56:23.000000', 'consum', 0.0216, 'lps'),
	(597529, 131, '2014-03-15 00:56:24.000000', 'consum', 0.0219, 'lps'),
	(597530, 131, '2014-03-15 00:56:25.000000', 'consum', 0.0235, 'lps'),
	(597531, 131, '2014-03-15 00:56:26.000000', 'consum', 0.0226, 'lps'),
	(597532, 131, '2014-03-15 00:56:27.000000', 'consum', 0.0217, 'lps'),
	(597533, 131, '2014-03-15 00:56:28.000000', 'consum', 0.0226, 'lps'),
	(597534, 131, '2014-03-15 00:56:29.000000', 'consum', 0.0212, 'lps'),
	(597535, 131, '2014-03-15 00:56:30.000000', 'consum', 0.0229, 'lps'),
	(597536, 131, '2014-03-15 00:56:31.000000', 'consum', 0.0215, 'lps'),
	(597537, 131, '2014-03-15 00:56:32.000000', 'consum', 0.0235, 'lps'),
	(597538, 131, '2014-03-15 00:56:33.000000', 'consum', 0.0236, 'lps'),
	(597539, 131, '2014-03-15 00:56:34.000000', 'consum', 0.0210, 'lps'),
	(597540, 131, '2014-03-15 00:56:35.000000', 'consum', 0.0215, 'lps'),
	(597541, 131, '2014-03-15 00:56:36.000000', 'consum', 0.0210, 'lps'),
	(597542, 131, '2014-03-15 00:56:37.000000', 'consum', 0.0220, 'lps'),
	(597543, 131, '2014-03-15 00:56:38.000000', 'consum', 0.0236, 'lps'),
	(597544, 131, '2014-03-15 00:56:39.000000', 'consum', 0.0225, 'lps'),
	(597545, 131, '2014-03-15 00:56:40.000000', 'consum', 0.0235, 'lps'),
	(597546, 131, '2014-03-15 00:56:41.000000', 'consum', 0.0236, 'lps'),
	(597547, 131, '2014-03-15 00:56:42.000000', 'consum', 0.0237, 'lps'),
	(597548, 131, '2014-03-15 00:56:43.000000', 'consum', 0.0211, 'lps'),
	(597549, 131, '2014-03-15 00:56:44.000000', 'consum', 0.0219, 'lps'),
	(597550, 131, '2014-03-15 00:56:45.000000', 'consum', 0.0225, 'lps'),
	(597551, 131, '2014-03-15 00:56:46.000000', 'consum', 0.0231, 'lps'),
	(597552, 131, '2014-03-15 00:56:47.000000', 'consum', 0.0213, 'lps'),
	(597553, 131, '2014-03-15 00:56:48.000000', 'consum', 0.0221, 'lps'),
	(597554, 131, '2014-03-15 00:56:49.000000', 'consum', 0.0226, 'lps'),
	(597555, 131, '2014-03-15 00:56:50.000000', 'consum', 0.0232, 'lps'),
	(597556, 131, '2014-03-15 00:56:51.000000', 'consum', 0.0214, 'lps'),
	(597557, 131, '2014-03-15 00:56:52.000000', 'consum', 0.0222, 'lps'),
	(597558, 131, '2014-03-15 00:56:53.000000', 'consum', 0.0232, 'lps'),
	(597559, 131, '2014-03-15 00:56:54.000000', 'consum', 0.0225, 'lps'),
	(597560, 131, '2014-03-15 00:56:55.000000', 'consum', 0.0222, 'lps'),
	(597561, 131, '2014-03-15 00:56:56.000000', 'consum', 0.0227, 'lps'),
	(597562, 131, '2014-03-15 00:56:57.000000', 'consum', 0.0229, 'lps'),
	(597563, 131, '2014-03-15 00:56:58.000000', 'consum', 0.0228, 'lps'),
	(597564, 131, '2014-03-15 00:56:59.000000', 'consum', 0.0213, 'lps'),
	(597565, 131, '2014-03-15 00:57:00.000000', 'consum', 0.0231, 'lps'),
	(597566, 131, '2014-03-15 00:57:01.000000', 'consum', 0.0221, 'lps'),
	(597567, 131, '2014-03-15 00:57:02.000000', 'consum', 0.0229, 'lps'),
	(597568, 131, '2014-03-15 00:57:03.000000', 'consum', 0.0216, 'lps'),
	(597569, 131, '2014-03-15 00:57:04.000000', 'consum', 0.0213, 'lps'),
	(597570, 131, '2014-03-15 00:57:05.000000', 'consum', 0.0235, 'lps'),
	(597571, 131, '2014-03-15 00:57:06.000000', 'consum', 0.0215, 'lps'),
	(597572, 131, '2014-03-15 00:57:07.000000', 'consum', 0.0215, 'lps'),
	(597573, 131, '2014-03-15 00:57:08.000000', 'consum', 0.0223, 'lps'),
	(597574, 131, '2014-03-15 00:57:09.000000', 'consum', 0.0231, 'lps'),
	(597575, 131, '2014-03-15 00:57:10.000000', 'consum', 0.0219, 'lps'),
	(597576, 131, '2014-03-15 00:57:11.000000', 'consum', 0.0223, 'lps'),
	(597577, 131, '2014-03-15 00:57:12.000000', 'consum', 0.0218, 'lps'),
	(597578, 131, '2014-03-15 00:57:13.000000', 'consum', 0.0214, 'lps'),
	(597579, 131, '2014-03-15 00:57:14.000000', 'consum', 0.0232, 'lps'),
	(597580, 131, '2014-03-15 00:57:15.000000', 'consum', 0.0224, 'lps'),
	(597581, 131, '2014-03-15 00:57:16.000000', 'consum', 0.0214, 'lps'),
	(597582, 131, '2014-03-15 00:57:17.000000', 'consum', 0.0219, 'lps'),
	(597583, 131, '2014-03-15 00:57:18.000000', 'consum', 0.0214, 'lps'),
	(597584, 131, '2014-03-15 00:57:19.000000', 'consum', 0.0231, 'lps'),
	(597585, 131, '2014-03-15 00:57:20.000000', 'consum', 0.0222, 'lps'),
	(597586, 131, '2014-03-15 00:57:21.000000', 'consum', 0.0235, 'lps'),
	(597587, 131, '2014-03-15 00:57:22.000000', 'consum', 0.0214, 'lps'),
	(597588, 131, '2014-03-15 00:57:23.000000', 'consum', 0.0211, 'lps'),
	(597589, 131, '2014-03-15 00:57:24.000000', 'consum', 0.0232, 'lps'),
	(597590, 131, '2014-03-15 00:57:25.000000', 'consum', 0.0235, 'lps'),
	(597591, 131, '2014-03-15 00:57:26.000000', 'consum', 0.0214, 'lps'),
	(597592, 131, '2014-03-15 00:57:27.000000', 'consum', 0.0237, 'lps'),
	(597593, 131, '2014-03-15 00:57:28.000000', 'consum', 0.0221, 'lps'),
	(597594, 131, '2014-03-15 00:57:29.000000', 'consum', 0.0212, 'lps'),
	(597595, 131, '2014-03-15 00:57:30.000000', 'consum', 0.0218, 'lps'),
	(597596, 131, '2014-03-15 00:57:31.000000', 'consum', 0.0215, 'lps'),
	(597597, 131, '2014-03-15 00:57:32.000000', 'consum', 0.0210, 'lps'),
	(597598, 131, '2014-03-15 00:57:33.000000', 'consum', 0.0227, 'lps'),
	(597599, 131, '2014-03-15 00:57:34.000000', 'consum', 0.0237, 'lps'),
	(597600, 131, '2014-03-15 00:57:35.000000', 'consum', 0.0212, 'lps'),
	(597601, 131, '2014-03-15 00:57:36.000000', 'consum', 0.0223, 'lps'),
	(597602, 131, '2014-03-15 00:57:37.000000', 'consum', 0.0215, 'lps'),
	(597603, 131, '2014-03-15 00:57:38.000000', 'consum', 0.0221, 'lps'),
	(597604, 131, '2014-03-15 00:57:39.000000', 'consum', 0.0226, 'lps'),
	(597605, 131, '2014-03-15 00:57:40.000000', 'consum', 0.0228, 'lps'),
	(597606, 131, '2014-03-15 00:57:41.000000', 'consum', 0.0226, 'lps'),
	(597607, 131, '2014-03-15 00:57:42.000000', 'consum', 0.0236, 'lps'),
	(597608, 131, '2014-03-15 00:57:43.000000', 'consum', 0.0210, 'lps'),
	(597609, 131, '2014-03-15 00:57:44.000000', 'consum', 0.0216, 'lps'),
	(597610, 131, '2014-03-15 00:57:45.000000', 'consum', 0.0213, 'lps'),
	(597611, 131, '2014-03-15 00:57:46.000000', 'consum', 0.0236, 'lps'),
	(597612, 131, '2014-03-15 00:57:47.000000', 'consum', 0.0220, 'lps'),
	(597613, 131, '2014-03-15 00:57:48.000000', 'consum', 0.0210, 'lps'),
	(597614, 131, '2014-03-15 00:57:49.000000', 'consum', 0.0235, 'lps'),
	(597615, 131, '2014-03-15 00:57:50.000000', 'consum', 0.0224, 'lps'),
	(597616, 131, '2014-03-15 00:57:51.000000', 'consum', 0.0232, 'lps'),
	(597617, 131, '2014-03-15 00:57:52.000000', 'consum', 0.0222, 'lps'),
	(597618, 131, '2014-03-15 00:57:53.000000', 'consum', 0.0236, 'lps'),
	(597619, 131, '2014-03-15 00:57:54.000000', 'consum', 0.0218, 'lps'),
	(597620, 131, '2014-03-15 00:57:55.000000', 'consum', 0.0227, 'lps'),
	(597621, 131, '2014-03-15 00:57:56.000000', 'consum', 0.0217, 'lps'),
	(597622, 131, '2014-03-15 00:57:57.000000', 'consum', 0.0223, 'lps'),
	(597623, 131, '2014-03-15 00:57:58.000000', 'consum', 0.0228, 'lps'),
	(597624, 131, '2014-03-15 00:57:59.000000', 'consum', 0.0231, 'lps'),
	(597625, 131, '2014-03-15 00:58:00.000000', 'consum', 0.0235, 'lps'),
	(597626, 131, '2014-03-15 00:58:01.000000', 'consum', 0.0214, 'lps'),
	(597627, 131, '2014-03-15 00:58:02.000000', 'consum', 0.0214, 'lps'),
	(597628, 131, '2014-03-15 00:58:03.000000', 'consum', 0.0217, 'lps'),
	(597629, 131, '2014-03-15 00:58:04.000000', 'consum', 0.0236, 'lps'),
	(597630, 131, '2014-03-15 00:58:05.000000', 'consum', 0.0234, 'lps'),
	(597631, 131, '2014-03-15 00:58:06.000000', 'consum', 0.0225, 'lps'),
	(597632, 131, '2014-03-15 00:58:07.000000', 'consum', 0.0214, 'lps'),
	(597633, 131, '2014-03-15 00:58:08.000000', 'consum', 0.0212, 'lps'),
	(597634, 131, '2014-03-15 00:58:09.000000', 'consum', 0.0235, 'lps'),
	(597635, 131, '2014-03-15 00:58:10.000000', 'consum', 0.0219, 'lps'),
	(597636, 131, '2014-03-15 00:58:11.000000', 'consum', 0.0237, 'lps'),
	(597637, 131, '2014-03-15 00:58:12.000000', 'consum', 0.0234, 'lps'),
	(597638, 131, '2014-03-15 00:58:13.000000', 'consum', 0.0222, 'lps'),
	(597639, 131, '2014-03-15 00:58:14.000000', 'consum', 0.0224, 'lps'),
	(597640, 131, '2014-03-15 00:58:15.000000', 'consum', 0.0220, 'lps'),
	(597641, 131, '2014-03-15 00:58:16.000000', 'consum', 0.0217, 'lps'),
	(597642, 131, '2014-03-15 00:58:17.000000', 'consum', 0.0215, 'lps'),
	(597643, 131, '2014-03-15 00:58:18.000000', 'consum', 0.0214, 'lps'),
	(597644, 131, '2014-03-15 00:58:19.000000', 'consum', 0.0216, 'lps'),
	(597645, 131, '2014-03-15 00:58:20.000000', 'consum', 0.0228, 'lps'),
	(597646, 131, '2014-03-15 00:58:21.000000', 'consum', 0.0227, 'lps'),
	(597647, 131, '2014-03-15 00:58:22.000000', 'consum', 0.0215, 'lps'),
	(597648, 131, '2014-03-15 00:58:23.000000', 'consum', 0.0210, 'lps'),
	(597649, 131, '2014-03-15 00:58:24.000000', 'consum', 0.0226, 'lps'),
	(597650, 131, '2014-03-15 00:58:25.000000', 'consum', 0.0231, 'lps'),
	(597651, 131, '2014-03-15 00:58:26.000000', 'consum', 0.0215, 'lps'),
	(597652, 131, '2014-03-15 00:58:27.000000', 'consum', 0.0228, 'lps'),
	(597653, 131, '2014-03-15 00:58:28.000000', 'consum', 0.0229, 'lps'),
	(597654, 131, '2014-03-15 00:58:29.000000', 'consum', 0.0221, 'lps'),
	(597655, 131, '2014-03-15 00:58:30.000000', 'consum', 0.0212, 'lps'),
	(597656, 131, '2014-03-15 00:58:31.000000', 'consum', 0.0216, 'lps'),
	(597657, 131, '2014-03-15 00:58:32.000000', 'consum', 0.0232, 'lps'),
	(597658, 131, '2014-03-15 00:58:33.000000', 'consum', 0.0220, 'lps'),
	(597659, 131, '2014-03-15 00:58:34.000000', 'consum', 0.0221, 'lps'),
	(597660, 131, '2014-03-15 00:58:35.000000', 'consum', 0.0236, 'lps'),
	(597661, 131, '2014-03-15 00:58:36.000000', 'consum', 0.0223, 'lps'),
	(597662, 131, '2014-03-15 00:58:37.000000', 'consum', 0.0224, 'lps'),
	(597663, 131, '2014-03-15 00:58:38.000000', 'consum', 0.0217, 'lps'),
	(597664, 131, '2014-03-15 00:58:39.000000', 'consum', 0.0228, 'lps'),
	(597665, 131, '2014-03-15 00:58:40.000000', 'consum', 0.0226, 'lps'),
	(597666, 131, '2014-03-15 00:58:41.000000', 'consum', 0.0234, 'lps'),
	(597667, 131, '2014-03-15 00:58:42.000000', 'consum', 0.0228, 'lps'),
	(597668, 131, '2014-03-15 00:58:43.000000', 'consum', 0.0229, 'lps'),
	(597669, 131, '2014-03-15 00:58:44.000000', 'consum', 0.0221, 'lps'),
	(597670, 131, '2014-03-15 00:58:45.000000', 'consum', 0.0212, 'lps'),
	(597671, 131, '2014-03-15 00:58:46.000000', 'consum', 0.0212, 'lps'),
	(597672, 131, '2014-03-15 00:58:47.000000', 'consum', 0.0216, 'lps'),
	(597673, 131, '2014-03-15 00:58:48.000000', 'consum', 0.0234, 'lps'),
	(597674, 131, '2014-03-15 00:58:49.000000', 'consum', 0.0231, 'lps'),
	(597675, 131, '2014-03-15 00:58:50.000000', 'consum', 0.0213, 'lps'),
	(597676, 131, '2014-03-15 00:58:51.000000', 'consum', 0.0220, 'lps'),
	(597677, 131, '2014-03-15 00:58:52.000000', 'consum', 0.0223, 'lps'),
	(597678, 131, '2014-03-15 00:58:53.000000', 'consum', 0.0218, 'lps'),
	(597679, 131, '2014-03-15 00:58:54.000000', 'consum', 0.0213, 'lps'),
	(597680, 131, '2014-03-15 00:58:55.000000', 'consum', 0.0229, 'lps'),
	(597681, 131, '2014-03-15 00:58:56.000000', 'consum', 0.0212, 'lps'),
	(597682, 131, '2014-03-15 00:58:57.000000', 'consum', 0.0218, 'lps'),
	(597683, 131, '2014-03-15 00:58:58.000000', 'consum', 0.0216, 'lps'),
	(597684, 131, '2014-03-15 00:58:59.000000', 'consum', 0.0220, 'lps'),
	(597685, 131, '2014-03-15 00:59:00.000000', 'consum', 0.0211, 'lps'),
	(597686, 131, '2014-03-15 00:59:01.000000', 'consum', 0.0215, 'lps'),
	(597687, 131, '2014-03-15 00:59:02.000000', 'consum', 0.0234, 'lps'),
	(597688, 131, '2014-03-15 00:59:03.000000', 'consum', 0.0232, 'lps'),
	(597689, 131, '2014-03-15 00:59:04.000000', 'consum', 0.0219, 'lps'),
	(597690, 131, '2014-03-15 00:59:05.000000', 'consum', 0.0219, 'lps'),
	(597691, 131, '2014-03-15 00:59:06.000000', 'consum', 0.0227, 'lps'),
	(597692, 131, '2014-03-15 00:59:07.000000', 'consum', 0.0213, 'lps'),
	(597693, 131, '2014-03-15 00:59:08.000000', 'consum', 0.0229, 'lps'),
	(597694, 131, '2014-03-15 00:59:09.000000', 'consum', 0.0213, 'lps'),
	(597695, 131, '2014-03-15 00:59:10.000000', 'consum', 0.0225, 'lps'),
	(597696, 131, '2014-03-15 00:59:11.000000', 'consum', 0.0221, 'lps'),
	(597697, 131, '2014-03-15 00:59:12.000000', 'consum', 0.0221, 'lps'),
	(597698, 131, '2014-03-15 00:59:13.000000', 'consum', 0.0231, 'lps'),
	(597699, 131, '2014-03-15 00:59:14.000000', 'consum', 0.0227, 'lps'),
	(597700, 131, '2014-03-15 00:59:15.000000', 'consum', 0.0231, 'lps'),
	(597701, 131, '2014-03-15 00:59:16.000000', 'consum', 0.0212, 'lps'),
	(597702, 131, '2014-03-15 00:59:17.000000', 'consum', 0.0210, 'lps'),
	(597703, 131, '2014-03-15 00:59:18.000000', 'consum', 0.0233, 'lps'),
	(597704, 131, '2014-03-15 00:59:19.000000', 'consum', 0.0215, 'lps'),
	(597705, 131, '2014-03-15 00:59:20.000000', 'consum', 0.0221, 'lps'),
	(597706, 131, '2014-03-15 00:59:21.000000', 'consum', 0.0225, 'lps'),
	(597707, 131, '2014-03-15 00:59:22.000000', 'consum', 0.0223, 'lps'),
	(597708, 131, '2014-03-15 00:59:23.000000', 'consum', 0.0230, 'lps'),
	(597709, 131, '2014-03-15 00:59:24.000000', 'consum', 0.0217, 'lps'),
	(597710, 131, '2014-03-15 00:59:25.000000', 'consum', 0.0213, 'lps'),
	(597711, 131, '2014-03-15 00:59:26.000000', 'consum', 0.0230, 'lps'),
	(597712, 131, '2014-03-15 00:59:27.000000', 'consum', 0.0221, 'lps'),
	(597713, 131, '2014-03-15 00:59:28.000000', 'consum', 0.0230, 'lps'),
	(597714, 131, '2014-03-15 00:59:29.000000', 'consum', 0.0223, 'lps'),
	(597715, 131, '2014-03-15 00:59:30.000000', 'consum', 0.0217, 'lps'),
	(597716, 131, '2014-03-15 00:59:31.000000', 'consum', 0.0233, 'lps'),
	(597717, 131, '2014-03-15 00:59:32.000000', 'consum', 0.0221, 'lps'),
	(597718, 131, '2014-03-15 00:59:33.000000', 'consum', 0.0226, 'lps'),
	(597719, 131, '2014-03-15 00:59:34.000000', 'consum', 0.0228, 'lps'),
	(597720, 131, '2014-03-15 00:59:35.000000', 'consum', 0.0223, 'lps'),
	(597721, 131, '2014-03-15 00:59:36.000000', 'consum', 0.0225, 'lps'),
	(597722, 131, '2014-03-15 00:59:37.000000', 'consum', 0.0216, 'lps'),
	(597723, 131, '2014-03-15 00:59:38.000000', 'consum', 0.0223, 'lps'),
	(597724, 131, '2014-03-15 00:59:39.000000', 'consum', 0.0230, 'lps'),
	(597725, 131, '2014-03-15 00:59:40.000000', 'consum', 0.0215, 'lps'),
	(597726, 131, '2014-03-15 00:59:41.000000', 'consum', 0.0230, 'lps'),
	(597727, 131, '2014-03-15 00:59:42.000000', 'consum', 0.0215, 'lps'),
	(597728, 131, '2014-03-15 00:59:43.000000', 'consum', 0.0230, 'lps'),
	(597729, 131, '2014-03-15 00:59:44.000000', 'consum', 0.0212, 'lps'),
	(597730, 131, '2014-03-15 00:59:45.000000', 'consum', 0.0215, 'lps'),
	(597731, 131, '2014-03-15 00:59:46.000000', 'consum', 0.0232, 'lps'),
	(597732, 131, '2014-03-15 00:59:47.000000', 'consum', 0.0219, 'lps'),
	(597733, 131, '2014-03-15 00:59:48.000000', 'consum', 0.0220, 'lps'),
	(597734, 131, '2014-03-15 00:59:49.000000', 'consum', 0.0231, 'lps'),
	(597735, 131, '2014-03-15 00:59:50.000000', 'consum', 0.0230, 'lps'),
	(597736, 131, '2014-03-15 00:59:51.000000', 'consum', 0.0221, 'lps'),
	(597737, 131, '2014-03-15 00:59:52.000000', 'consum', 0.0234, 'lps'),
	(597738, 131, '2014-03-15 00:59:53.000000', 'consum', 0.0211, 'lps'),
	(597739, 131, '2014-03-15 00:59:54.000000', 'consum', 0.0229, 'lps'),
	(597740, 131, '2014-03-15 00:59:55.000000', 'consum', 0.0219, 'lps'),
	(597741, 131, '2014-03-15 00:59:56.000000', 'consum', 0.0225, 'lps'),
	(597742, 131, '2014-03-15 00:59:57.000000', 'consum', 0.0232, 'lps'),
	(597743, 131, '2014-03-15 00:59:58.000000', 'consum', 0.0218, 'lps'),
	(597744, 131, '2014-03-15 00:59:59.000000', 'consum', 0.0213, 'lps'),
	(597745, 131, '2014-03-15 01:00:00.000000', 'consum', 0.0229, 'lps'),
	(597746, 131, '2014-03-15 01:00:01.000000', 'consum', 0.0212, 'lps'),
	(597747, 131, '2014-03-15 01:00:02.000000', 'consum', 0.0220, 'lps'),
	(597748, 131, '2014-03-15 01:00:03.000000', 'consum', 0.0228, 'lps'),
	(597749, 131, '2014-03-15 01:00:04.000000', 'consum', 0.0212, 'lps'),
	(597750, 131, '2014-03-15 01:00:05.000000', 'consum', 0.0225, 'lps'),
	(597751, 131, '2014-03-15 01:00:06.000000', 'consum', 0.0223, 'lps'),
	(597752, 131, '2014-03-15 01:00:07.000000', 'consum', 0.0228, 'lps'),
	(597753, 131, '2014-03-15 01:00:08.000000', 'consum', 0.0236, 'lps'),
	(597754, 131, '2014-03-15 01:00:09.000000', 'consum', 0.0230, 'lps'),
	(597755, 131, '2014-03-15 01:00:10.000000', 'consum', 0.0233, 'lps'),
	(597756, 131, '2014-03-15 01:00:11.000000', 'consum', 0.0210, 'lps'),
	(597757, 131, '2014-03-15 01:00:12.000000', 'consum', 0.0223, 'lps'),
	(597758, 131, '2014-03-15 01:00:13.000000', 'consum', 0.0220, 'lps'),
	(597759, 131, '2014-03-15 01:00:14.000000', 'consum', 0.0223, 'lps'),
	(597760, 131, '2014-03-15 01:00:15.000000', 'consum', 0.0217, 'lps'),
	(597761, 131, '2014-03-15 01:00:16.000000', 'consum', 0.0236, 'lps'),
	(597762, 131, '2014-03-15 01:00:17.000000', 'consum', 0.0233, 'lps'),
	(597763, 131, '2014-03-15 01:00:18.000000', 'consum', 0.0220, 'lps'),
	(597764, 131, '2014-03-15 01:00:19.000000', 'consum', 0.0219, 'lps'),
	(597765, 131, '2014-03-15 01:00:20.000000', 'consum', 0.0224, 'lps'),
	(597766, 131, '2014-03-15 01:00:21.000000', 'consum', 0.0228, 'lps'),
	(597767, 131, '2014-03-15 01:00:22.000000', 'consum', 0.0228, 'lps'),
	(597768, 131, '2014-03-15 01:00:23.000000', 'consum', 0.0218, 'lps'),
	(597769, 131, '2014-03-15 01:00:24.000000', 'consum', 0.0226, 'lps'),
	(597770, 131, '2014-03-15 01:00:25.000000', 'consum', 0.0210, 'lps'),
	(597771, 131, '2014-03-15 01:00:26.000000', 'consum', 0.0220, 'lps'),
	(597772, 131, '2014-03-15 01:00:27.000000', 'consum', 0.0231, 'lps'),
	(597773, 131, '2014-03-15 01:00:28.000000', 'consum', 0.0231, 'lps'),
	(597774, 131, '2014-03-15 01:00:29.000000', 'consum', 0.0222, 'lps'),
	(597775, 131, '2014-03-15 01:00:30.000000', 'consum', 0.0235, 'lps'),
	(597776, 131, '2014-03-15 01:00:31.000000', 'consum', 0.0217, 'lps'),
	(597777, 131, '2014-03-15 01:00:32.000000', 'consum', 0.0226, 'lps'),
	(597778, 131, '2014-03-15 01:00:33.000000', 'consum', 0.0214, 'lps'),
	(597779, 131, '2014-03-15 01:00:34.000000', 'consum', 0.0210, 'lps'),
	(597780, 131, '2014-03-15 01:00:35.000000', 'consum', 0.0227, 'lps'),
	(597781, 131, '2014-03-15 01:00:36.000000', 'consum', 0.0212, 'lps'),
	(597782, 131, '2014-03-15 01:00:37.000000', 'consum', 0.0223, 'lps'),
	(597783, 131, '2014-03-15 01:00:38.000000', 'consum', 0.0215, 'lps'),
	(597784, 131, '2014-03-15 01:00:39.000000', 'consum', 0.0225, 'lps'),
	(597785, 131, '2014-03-15 01:00:40.000000', 'consum', 0.0215, 'lps'),
	(597786, 131, '2014-03-15 01:00:41.000000', 'consum', 0.0220, 'lps'),
	(597787, 131, '2014-03-15 01:00:42.000000', 'consum', 0.0215, 'lps'),
	(597788, 131, '2014-03-15 01:00:43.000000', 'consum', 0.0233, 'lps'),
	(597789, 131, '2014-03-15 01:00:44.000000', 'consum', 0.0228, 'lps'),
	(597790, 131, '2014-03-15 01:00:45.000000', 'consum', 0.0231, 'lps'),
	(597791, 131, '2014-03-15 01:00:46.000000', 'consum', 0.0232, 'lps'),
	(597792, 131, '2014-03-15 01:00:47.000000', 'consum', 0.0230, 'lps'),
	(597793, 131, '2014-03-15 01:00:48.000000', 'consum', 0.0217, 'lps'),
	(597794, 131, '2014-03-15 01:00:49.000000', 'consum', 0.0212, 'lps'),
	(597795, 131, '2014-03-15 01:00:50.000000', 'consum', 0.0230, 'lps'),
	(597796, 131, '2014-03-15 01:00:51.000000', 'consum', 0.0221, 'lps'),
	(597797, 131, '2014-03-15 01:00:52.000000', 'consum', 0.0232, 'lps'),
	(597798, 131, '2014-03-15 01:00:53.000000', 'consum', 0.0232, 'lps'),
	(597799, 131, '2014-03-15 01:00:54.000000', 'consum', 0.0228, 'lps'),
	(597800, 131, '2014-03-15 01:00:55.000000', 'consum', 0.0235, 'lps'),
	(597801, 131, '2014-03-15 01:00:56.000000', 'consum', 0.0224, 'lps'),
	(597802, 131, '2014-03-15 01:00:57.000000', 'consum', 0.0233, 'lps'),
	(597803, 131, '2014-03-15 01:00:58.000000', 'consum', 0.0226, 'lps'),
	(597804, 131, '2014-03-15 01:00:59.000000', 'consum', 0.0225, 'lps'),
	(597805, 131, '2014-03-15 01:01:00.000000', 'consum', 0.0235, 'lps'),
	(597806, 131, '2014-03-15 01:01:01.000000', 'consum', 0.0237, 'lps'),
	(597807, 131, '2014-03-15 01:01:02.000000', 'consum', 0.0212, 'lps'),
	(597808, 131, '2014-03-15 01:01:03.000000', 'consum', 0.0223, 'lps'),
	(597809, 131, '2014-03-15 01:01:04.000000', 'consum', 0.0215, 'lps'),
	(597810, 131, '2014-03-15 01:01:05.000000', 'consum', 0.0225, 'lps'),
	(597811, 131, '2014-03-15 01:01:06.000000', 'consum', 0.0214, 'lps'),
	(597812, 131, '2014-03-15 01:01:07.000000', 'consum', 0.0214, 'lps'),
	(597813, 131, '2014-03-15 01:01:08.000000', 'consum', 0.0220, 'lps'),
	(597814, 131, '2014-03-15 01:01:09.000000', 'consum', 0.0217, 'lps'),
	(597815, 131, '2014-03-15 01:01:10.000000', 'consum', 0.0218, 'lps'),
	(597816, 131, '2014-03-15 01:01:11.000000', 'consum', 0.0230, 'lps'),
	(597817, 131, '2014-03-15 01:01:12.000000', 'consum', 0.0230, 'lps'),
	(597818, 131, '2014-03-15 01:01:13.000000', 'consum', 0.0223, 'lps'),
	(597819, 131, '2014-03-15 01:01:14.000000', 'consum', 0.0215, 'lps'),
	(597820, 131, '2014-03-15 01:01:15.000000', 'consum', 0.0226, 'lps'),
	(597821, 131, '2014-03-15 01:01:16.000000', 'consum', 0.0220, 'lps'),
	(597822, 131, '2014-03-15 01:01:17.000000', 'consum', 0.0210, 'lps'),
	(597823, 131, '2014-03-15 01:01:18.000000', 'consum', 0.0236, 'lps'),
	(597824, 131, '2014-03-15 01:01:19.000000', 'consum', 0.0228, 'lps'),
	(597825, 131, '2014-03-15 01:01:20.000000', 'consum', 0.0225, 'lps'),
	(597826, 131, '2014-03-15 01:01:21.000000', 'consum', 0.0230, 'lps'),
	(597827, 131, '2014-03-15 01:01:22.000000', 'consum', 0.0212, 'lps'),
	(597828, 131, '2014-03-15 01:01:23.000000', 'consum', 0.0215, 'lps'),
	(597829, 131, '2014-03-15 01:01:24.000000', 'consum', 0.0229, 'lps'),
	(597830, 131, '2014-03-15 01:01:25.000000', 'consum', 0.0235, 'lps'),
	(597831, 131, '2014-03-15 01:01:26.000000', 'consum', 0.0222, 'lps'),
	(597832, 131, '2014-03-15 01:01:27.000000', 'consum', 0.0224, 'lps'),
	(597833, 131, '2014-03-15 01:01:28.000000', 'consum', 0.0218, 'lps'),
	(597834, 131, '2014-03-15 01:01:29.000000', 'consum', 0.0234, 'lps'),
	(597835, 131, '2014-03-15 01:01:30.000000', 'consum', 0.0222, 'lps'),
	(597836, 131, '2014-03-15 01:01:31.000000', 'consum', 0.0229, 'lps'),
	(597837, 131, '2014-03-15 01:01:32.000000', 'consum', 0.0213, 'lps'),
	(597838, 131, '2014-03-15 01:01:33.000000', 'consum', 0.0226, 'lps'),
	(597839, 131, '2014-03-15 01:01:34.000000', 'consum', 0.0223, 'lps'),
	(597840, 131, '2014-03-15 01:01:35.000000', 'consum', 0.0229, 'lps'),
	(597841, 131, '2014-03-15 01:01:36.000000', 'consum', 0.0212, 'lps'),
	(597842, 131, '2014-03-15 01:01:37.000000', 'consum', 0.0217, 'lps'),
	(597843, 131, '2014-03-15 01:01:38.000000', 'consum', 0.0213, 'lps'),
	(597844, 131, '2014-03-15 01:01:39.000000', 'consum', 0.0233, 'lps'),
	(597845, 131, '2014-03-15 01:01:40.000000', 'consum', 0.0232, 'lps'),
	(597846, 131, '2014-03-15 01:01:41.000000', 'consum', 0.0222, 'lps'),
	(597847, 131, '2014-03-15 01:01:42.000000', 'consum', 0.0235, 'lps'),
	(597848, 131, '2014-03-15 01:01:43.000000', 'consum', 0.0213, 'lps'),
	(597849, 131, '2014-03-15 01:01:44.000000', 'consum', 0.0235, 'lps'),
	(597850, 131, '2014-03-15 01:01:45.000000', 'consum', 0.0214, 'lps'),
	(597851, 131, '2014-03-15 01:01:46.000000', 'consum', 0.0212, 'lps'),
	(597852, 131, '2014-03-15 01:01:47.000000', 'consum', 0.0210, 'lps'),
	(597853, 131, '2014-03-15 01:01:48.000000', 'consum', 0.0232, 'lps'),
	(597854, 131, '2014-03-15 01:01:49.000000', 'consum', 0.0210, 'lps'),
	(597855, 131, '2014-03-15 01:01:50.000000', 'consum', 0.0228, 'lps'),
	(597856, 131, '2014-03-15 01:01:51.000000', 'consum', 0.0216, 'lps'),
	(597857, 131, '2014-03-15 01:01:52.000000', 'consum', 0.0213, 'lps'),
	(597858, 131, '2014-03-15 01:01:53.000000', 'consum', 0.0236, 'lps'),
	(597859, 131, '2014-03-15 01:01:54.000000', 'consum', 0.0220, 'lps'),
	(597860, 131, '2014-03-15 01:01:55.000000', 'consum', 0.0212, 'lps'),
	(597861, 131, '2014-03-15 01:01:56.000000', 'consum', 0.0218, 'lps'),
	(597862, 131, '2014-03-15 01:01:57.000000', 'consum', 0.0215, 'lps'),
	(597863, 131, '2014-03-15 01:01:58.000000', 'consum', 0.0211, 'lps'),
	(597864, 131, '2014-03-15 01:01:59.000000', 'consum', 0.0228, 'lps'),
	(597865, 131, '2014-03-15 01:02:00.000000', 'consum', 0.0213, 'lps'),
	(597866, 131, '2014-03-15 01:02:01.000000', 'consum', 0.0228, 'lps'),
	(597867, 131, '2014-03-15 01:02:02.000000', 'consum', 0.0237, 'lps'),
	(597868, 131, '2014-03-15 01:02:03.000000', 'consum', 0.0236, 'lps'),
	(597869, 131, '2014-03-15 01:02:04.000000', 'consum', 0.0230, 'lps'),
	(597870, 131, '2014-03-15 01:02:05.000000', 'consum', 0.0231, 'lps'),
	(597871, 131, '2014-03-15 01:02:06.000000', 'consum', 0.0229, 'lps'),
	(597872, 131, '2014-03-15 01:02:07.000000', 'consum', 0.0216, 'lps'),
	(597873, 131, '2014-03-15 01:02:08.000000', 'consum', 0.0210, 'lps'),
	(597874, 131, '2014-03-15 01:02:09.000000', 'consum', 0.0220, 'lps'),
	(597875, 131, '2014-03-15 01:02:10.000000', 'consum', 0.0235, 'lps'),
	(597876, 131, '2014-03-15 01:02:11.000000', 'consum', 0.0218, 'lps'),
	(597877, 131, '2014-03-15 01:02:12.000000', 'consum', 0.0234, 'lps'),
	(597878, 131, '2014-03-15 01:02:13.000000', 'consum', 0.0222, 'lps'),
	(597879, 131, '2014-03-15 01:02:14.000000', 'consum', 0.0227, 'lps'),
	(597880, 131, '2014-03-15 01:02:15.000000', 'consum', 0.0233, 'lps'),
	(597881, 131, '2014-03-15 01:02:16.000000', 'consum', 0.0217, 'lps'),
	(597882, 131, '2014-03-15 01:02:17.000000', 'consum', 0.0231, 'lps'),
	(597883, 131, '2014-03-15 01:02:18.000000', 'consum', 0.0210, 'lps'),
	(597884, 131, '2014-03-15 01:02:19.000000', 'consum', 0.0230, 'lps'),
	(597885, 131, '2014-03-15 01:02:20.000000', 'consum', 0.0230, 'lps'),
	(597886, 131, '2014-03-15 01:02:21.000000', 'consum', 0.0223, 'lps'),
	(597887, 131, '2014-03-15 01:02:22.000000', 'consum', 0.0214, 'lps'),
	(597888, 131, '2014-03-15 01:02:23.000000', 'consum', 0.0222, 'lps'),
	(597889, 131, '2014-03-15 01:02:24.000000', 'consum', 0.0227, 'lps'),
	(597890, 131, '2014-03-15 01:02:25.000000', 'consum', 0.0232, 'lps'),
	(597891, 131, '2014-03-15 01:02:26.000000', 'consum', 0.0216, 'lps'),
	(597892, 131, '2014-03-15 01:02:27.000000', 'consum', 0.0229, 'lps'),
	(597893, 131, '2014-03-15 01:02:28.000000', 'consum', 0.0233, 'lps'),
	(597894, 131, '2014-03-15 01:02:29.000000', 'consum', 0.0211, 'lps'),
	(597895, 131, '2014-03-15 01:02:30.000000', 'consum', 0.0229, 'lps'),
	(597896, 131, '2014-03-15 01:02:31.000000', 'consum', 0.0219, 'lps'),
	(597897, 131, '2014-03-15 01:02:32.000000', 'consum', 0.0229, 'lps'),
	(597898, 131, '2014-03-15 01:02:33.000000', 'consum', 0.0221, 'lps'),
	(597899, 131, '2014-03-15 01:02:34.000000', 'consum', 0.0211, 'lps'),
	(597900, 131, '2014-03-15 01:02:35.000000', 'consum', 0.0236, 'lps'),
	(597901, 131, '2014-03-15 01:02:36.000000', 'consum', 0.0225, 'lps'),
	(597902, 131, '2014-03-15 01:02:37.000000', 'consum', 0.0235, 'lps'),
	(597903, 131, '2014-03-15 01:02:38.000000', 'consum', 0.0234, 'lps'),
	(597904, 131, '2014-03-15 01:02:39.000000', 'consum', 0.0229, 'lps'),
	(597905, 131, '2014-03-15 01:02:40.000000', 'consum', 0.0234, 'lps'),
	(597906, 131, '2014-03-15 01:02:41.000000', 'consum', 0.0218, 'lps'),
	(597907, 131, '2014-03-15 01:02:42.000000', 'consum', 0.0232, 'lps'),
	(597908, 131, '2014-03-15 01:02:43.000000', 'consum', 0.0213, 'lps'),
	(597909, 131, '2014-03-15 01:02:44.000000', 'consum', 0.0215, 'lps'),
	(597910, 131, '2014-03-15 01:02:45.000000', 'consum', 0.0227, 'lps'),
	(597911, 131, '2014-03-15 01:02:46.000000', 'consum', 0.0225, 'lps'),
	(597912, 131, '2014-03-15 01:02:47.000000', 'consum', 0.0235, 'lps'),
	(597913, 131, '2014-03-15 01:02:48.000000', 'consum', 0.0235, 'lps'),
	(597914, 131, '2014-03-15 01:02:49.000000', 'consum', 0.0233, 'lps'),
	(597915, 131, '2014-03-15 01:02:50.000000', 'consum', 0.0223, 'lps'),
	(597916, 131, '2014-03-15 01:02:51.000000', 'consum', 0.0234, 'lps'),
	(597917, 131, '2014-03-15 01:02:52.000000', 'consum', 0.0237, 'lps'),
	(597918, 131, '2014-03-15 01:02:53.000000', 'consum', 0.0218, 'lps'),
	(597919, 131, '2014-03-15 01:02:54.000000', 'consum', 0.0223, 'lps'),
	(597920, 131, '2014-03-15 01:02:55.000000', 'consum', 0.0223, 'lps'),
	(597921, 131, '2014-03-15 01:02:56.000000', 'consum', 0.0210, 'lps'),
	(597922, 131, '2014-03-15 01:02:57.000000', 'consum', 0.0226, 'lps'),
	(597923, 131, '2014-03-15 01:02:58.000000', 'consum', 0.0237, 'lps'),
	(597924, 131, '2014-03-15 01:02:59.000000', 'consum', 0.0211, 'lps'),
	(597925, 131, '2014-03-15 01:03:00.000000', 'consum', 0.0218, 'lps'),
	(597926, 131, '2014-03-15 01:03:01.000000', 'consum', 0.0219, 'lps'),
	(597927, 131, '2014-03-15 01:03:02.000000', 'consum', 0.0233, 'lps'),
	(597928, 131, '2014-03-15 01:03:03.000000', 'consum', 0.0212, 'lps'),
	(597929, 131, '2014-03-15 01:03:04.000000', 'consum', 0.0237, 'lps'),
	(597930, 131, '2014-03-15 01:03:05.000000', 'consum', 0.0229, 'lps'),
	(597931, 131, '2014-03-15 01:03:06.000000', 'consum', 0.0225, 'lps'),
	(597932, 131, '2014-03-15 01:03:07.000000', 'consum', 0.0227, 'lps'),
	(597933, 131, '2014-03-15 01:03:08.000000', 'consum', 0.0225, 'lps'),
	(597934, 131, '2014-03-15 01:03:09.000000', 'consum', 0.0231, 'lps'),
	(597935, 131, '2014-03-15 01:03:10.000000', 'consum', 0.0217, 'lps'),
	(597936, 131, '2014-03-15 01:03:11.000000', 'consum', 0.0212, 'lps'),
	(597937, 131, '2014-03-15 01:03:12.000000', 'consum', 0.0224, 'lps'),
	(597938, 131, '2014-03-15 01:03:13.000000', 'consum', 0.0219, 'lps'),
	(597939, 131, '2014-03-15 01:03:14.000000', 'consum', 0.0214, 'lps'),
	(597940, 131, '2014-03-15 01:03:15.000000', 'consum', 0.0230, 'lps'),
	(597941, 131, '2014-03-15 01:03:16.000000', 'consum', 0.0216, 'lps'),
	(597942, 131, '2014-03-15 01:03:17.000000', 'consum', 0.0236, 'lps'),
	(597943, 131, '2014-03-15 01:03:18.000000', 'consum', 0.0237, 'lps'),
	(597944, 131, '2014-03-15 01:03:19.000000', 'consum', 0.0215, 'lps'),
	(597945, 131, '2014-03-15 01:03:20.000000', 'consum', 0.0235, 'lps'),
	(597946, 131, '2014-03-15 01:03:21.000000', 'consum', 0.0211, 'lps'),
	(597947, 131, '2014-03-15 01:03:22.000000', 'consum', 0.0223, 'lps'),
	(597948, 131, '2014-03-15 01:03:23.000000', 'consum', 0.0218, 'lps'),
	(597949, 131, '2014-03-15 01:03:24.000000', 'consum', 0.0211, 'lps'),
	(597950, 131, '2014-03-15 01:03:25.000000', 'consum', 0.0221, 'lps'),
	(597951, 131, '2014-03-15 01:03:26.000000', 'consum', 0.0235, 'lps'),
	(597952, 131, '2014-03-15 01:03:27.000000', 'consum', 0.0219, 'lps'),
	(597953, 131, '2014-03-15 01:03:28.000000', 'consum', 0.0234, 'lps'),
	(597954, 131, '2014-03-15 01:03:29.000000', 'consum', 0.0220, 'lps'),
	(597955, 131, '2014-03-15 01:03:30.000000', 'consum', 0.0217, 'lps'),
	(597956, 131, '2014-03-15 01:03:31.000000', 'consum', 0.0216, 'lps'),
	(597957, 131, '2014-03-15 01:03:32.000000', 'consum', 0.0218, 'lps'),
	(597958, 131, '2014-03-15 01:03:33.000000', 'consum', 0.0232, 'lps'),
	(597959, 131, '2014-03-15 01:03:34.000000', 'consum', 0.0214, 'lps'),
	(597960, 131, '2014-03-15 01:03:35.000000', 'consum', 0.0220, 'lps'),
	(597961, 131, '2014-03-15 01:03:36.000000', 'consum', 0.0222, 'lps'),
	(597962, 131, '2014-03-15 01:03:37.000000', 'consum', 0.0212, 'lps'),
	(597963, 131, '2014-03-15 01:03:38.000000', 'consum', 0.0211, 'lps'),
	(597964, 131, '2014-03-15 01:03:39.000000', 'consum', 0.0211, 'lps'),
	(597965, 131, '2014-03-15 01:03:40.000000', 'consum', 0.0214, 'lps'),
	(597966, 131, '2014-03-15 01:03:41.000000', 'consum', 0.0225, 'lps'),
	(597967, 131, '2014-03-15 01:03:42.000000', 'consum', 0.0218, 'lps'),
	(597968, 131, '2014-03-15 01:03:43.000000', 'consum', 0.0232, 'lps'),
	(597969, 131, '2014-03-15 01:03:44.000000', 'consum', 0.0213, 'lps'),
	(597970, 131, '2014-03-15 01:03:45.000000', 'consum', 0.0214, 'lps'),
	(597971, 131, '2014-03-15 01:03:46.000000', 'consum', 0.0225, 'lps'),
	(597972, 131, '2014-03-15 01:03:47.000000', 'consum', 0.0214, 'lps'),
	(597973, 131, '2014-03-15 01:03:48.000000', 'consum', 0.0215, 'lps'),
	(597974, 131, '2014-03-15 01:03:49.000000', 'consum', 0.0224, 'lps'),
	(597975, 131, '2014-03-15 01:03:50.000000', 'consum', 0.0237, 'lps'),
	(597976, 131, '2014-03-15 01:03:51.000000', 'consum', 0.0221, 'lps'),
	(597977, 131, '2014-03-15 01:03:52.000000', 'consum', 0.0210, 'lps'),
	(597978, 131, '2014-03-15 01:03:53.000000', 'consum', 0.0233, 'lps'),
	(597979, 131, '2014-03-15 01:03:54.000000', 'consum', 0.0215, 'lps'),
	(597980, 131, '2014-03-15 01:03:55.000000', 'consum', 0.0221, 'lps'),
	(597981, 131, '2014-03-15 01:03:56.000000', 'consum', 0.0221, 'lps'),
	(597982, 131, '2014-03-15 01:03:57.000000', 'consum', 0.0235, 'lps'),
	(597983, 131, '2014-03-15 01:03:58.000000', 'consum', 0.0218, 'lps'),
	(597984, 131, '2014-03-15 01:03:59.000000', 'consum', 0.0230, 'lps'),
	(597985, 131, '2014-03-15 01:04:00.000000', 'consum', 0.0232, 'lps'),
	(597986, 131, '2014-03-15 01:04:01.000000', 'consum', 0.0233, 'lps'),
	(597987, 131, '2014-03-15 01:04:02.000000', 'consum', 0.0229, 'lps'),
	(597988, 131, '2014-03-15 01:04:03.000000', 'consum', 0.0237, 'lps'),
	(597989, 131, '2014-03-15 01:04:04.000000', 'consum', 0.0235, 'lps'),
	(597990, 131, '2014-03-15 01:04:05.000000', 'consum', 0.0223, 'lps'),
	(597991, 131, '2014-03-15 01:04:06.000000', 'consum', 0.0230, 'lps'),
	(597992, 131, '2014-03-15 01:04:07.000000', 'consum', 0.0216, 'lps'),
	(597993, 131, '2014-03-15 01:04:08.000000', 'consum', 0.0237, 'lps'),
	(597994, 131, '2014-03-15 01:04:09.000000', 'consum', 0.0216, 'lps'),
	(597995, 131, '2014-03-15 01:04:10.000000', 'consum', 0.0217, 'lps'),
	(597996, 131, '2014-03-15 01:04:11.000000', 'consum', 0.0225, 'lps'),
	(597997, 131, '2014-03-15 01:04:12.000000', 'consum', 0.0236, 'lps'),
	(597998, 131, '2014-03-15 01:04:13.000000', 'consum', 0.0213, 'lps'),
	(597999, 131, '2014-03-15 01:04:14.000000', 'consum', 0.0230, 'lps'),
	(598000, 131, '2014-03-15 01:04:15.000000', 'consum', 0.0216, 'lps'),
	(598001, 131, '2014-03-15 01:04:16.000000', 'consum', 0.0212, 'lps'),
	(598002, 131, '2014-03-15 01:04:17.000000', 'consum', 0.0227, 'lps'),
	(598003, 131, '2014-03-15 01:04:18.000000', 'consum', 0.0235, 'lps'),
	(598004, 131, '2014-03-15 01:04:19.000000', 'consum', 0.0230, 'lps'),
	(598005, 131, '2014-03-15 01:04:20.000000', 'consum', 0.0233, 'lps'),
	(598006, 131, '2014-03-15 01:04:21.000000', 'consum', 0.0210, 'lps'),
	(598007, 131, '2014-03-15 01:04:22.000000', 'consum', 0.0224, 'lps'),
	(598008, 131, '2014-03-15 01:04:23.000000', 'consum', 0.0225, 'lps'),
	(598009, 131, '2014-03-15 01:04:24.000000', 'consum', 0.0218, 'lps'),
	(598010, 131, '2014-03-15 01:04:25.000000', 'consum', 0.0231, 'lps'),
	(598011, 131, '2014-03-15 01:04:26.000000', 'consum', 0.0235, 'lps'),
	(598012, 131, '2014-03-15 01:04:27.000000', 'consum', 0.0219, 'lps'),
	(598013, 131, '2014-03-15 01:04:28.000000', 'consum', 0.0237, 'lps'),
	(598014, 131, '2014-03-15 01:04:29.000000', 'consum', 0.0232, 'lps'),
	(598015, 131, '2014-03-15 01:04:30.000000', 'consum', 0.0212, 'lps'),
	(598016, 131, '2014-03-15 01:04:31.000000', 'consum', 0.0210, 'lps'),
	(598017, 131, '2014-03-15 01:04:32.000000', 'consum', 0.0231, 'lps'),
	(598018, 131, '2014-03-15 01:04:33.000000', 'consum', 0.0234, 'lps'),
	(598019, 131, '2014-03-15 01:04:34.000000', 'consum', 0.0210, 'lps'),
	(598020, 131, '2014-03-15 01:04:35.000000', 'consum', 0.0224, 'lps'),
	(598021, 131, '2014-03-15 01:04:36.000000', 'consum', 0.0222, 'lps'),
	(598022, 131, '2014-03-15 01:04:37.000000', 'consum', 0.0230, 'lps'),
	(598023, 131, '2014-03-15 01:04:38.000000', 'consum', 0.0217, 'lps'),
	(598024, 131, '2014-03-15 01:04:39.000000', 'consum', 0.0215, 'lps'),
	(598025, 131, '2014-03-15 01:04:40.000000', 'consum', 0.0213, 'lps'),
	(598026, 131, '2014-03-15 01:04:41.000000', 'consum', 0.0210, 'lps'),
	(598027, 131, '2014-03-15 01:04:42.000000', 'consum', 0.0231, 'lps'),
	(598028, 131, '2014-03-15 01:04:43.000000', 'consum', 0.0232, 'lps'),
	(598029, 131, '2014-03-15 01:04:44.000000', 'consum', 0.0227, 'lps'),
	(598030, 131, '2014-03-15 01:04:45.000000', 'consum', 0.0231, 'lps'),
	(598031, 131, '2014-03-15 01:04:46.000000', 'consum', 0.0210, 'lps'),
	(598032, 131, '2014-03-15 01:04:47.000000', 'consum', 0.0231, 'lps'),
	(598033, 131, '2014-03-15 01:04:48.000000', 'consum', 0.0231, 'lps'),
	(598034, 131, '2014-03-15 01:04:49.000000', 'consum', 0.0223, 'lps'),
	(598035, 131, '2014-03-15 01:04:50.000000', 'consum', 0.0214, 'lps'),
	(598036, 131, '2014-03-15 01:04:51.000000', 'consum', 0.0217, 'lps'),
	(598037, 131, '2014-03-15 01:04:52.000000', 'consum', 0.0236, 'lps'),
	(598038, 131, '2014-03-15 01:04:53.000000', 'consum', 0.0236, 'lps'),
	(598039, 131, '2014-03-15 01:04:54.000000', 'consum', 0.0234, 'lps'),
	(598040, 131, '2014-03-15 01:04:55.000000', 'consum', 0.0223, 'lps'),
	(598041, 131, '2014-03-15 01:04:56.000000', 'consum', 0.0231, 'lps'),
	(598042, 131, '2014-03-15 01:04:57.000000', 'consum', 0.0223, 'lps'),
	(598043, 131, '2014-03-15 01:04:58.000000', 'consum', 0.0237, 'lps'),
	(598044, 131, '2014-03-15 01:04:59.000000', 'consum', 0.0226, 'lps'),
	(598045, 131, '2014-03-15 01:05:00.000000', 'consum', 0.0236, 'lps'),
	(598046, 131, '2014-03-15 01:05:01.000000', 'consum', 0.0235, 'lps'),
	(598047, 131, '2014-03-15 01:05:02.000000', 'consum', 0.0232, 'lps'),
	(598048, 131, '2014-03-15 01:05:03.000000', 'consum', 0.0217, 'lps'),
	(598049, 131, '2014-03-15 01:05:04.000000', 'consum', 0.0234, 'lps'),
	(598050, 131, '2014-03-15 01:05:05.000000', 'consum', 0.0225, 'lps'),
	(598051, 131, '2014-03-15 01:05:06.000000', 'consum', 0.0213, 'lps'),
	(598052, 131, '2014-03-15 01:05:07.000000', 'consum', 0.0237, 'lps'),
	(598053, 131, '2014-03-15 01:05:08.000000', 'consum', 0.0224, 'lps'),
	(598054, 131, '2014-03-15 01:05:09.000000', 'consum', 0.0230, 'lps'),
	(598055, 131, '2014-03-15 01:05:10.000000', 'consum', 0.0210, 'lps'),
	(598056, 131, '2014-03-15 01:05:11.000000', 'consum', 0.0237, 'lps'),
	(598057, 131, '2014-03-15 01:05:12.000000', 'consum', 0.0231, 'lps'),
	(598058, 131, '2014-03-15 01:05:13.000000', 'consum', 0.0237, 'lps'),
	(598059, 131, '2014-03-15 01:05:14.000000', 'consum', 0.0223, 'lps'),
	(598060, 131, '2014-03-15 01:05:15.000000', 'consum', 0.0226, 'lps'),
	(598061, 131, '2014-03-15 01:05:16.000000', 'consum', 0.0222, 'lps'),
	(598062, 131, '2014-03-15 01:05:17.000000', 'consum', 0.0221, 'lps'),
	(598063, 131, '2014-03-15 01:05:18.000000', 'consum', 0.0232, 'lps'),
	(598064, 131, '2014-03-15 01:05:19.000000', 'consum', 0.0229, 'lps'),
	(598065, 131, '2014-03-15 01:05:20.000000', 'consum', 0.0211, 'lps'),
	(598066, 131, '2014-03-15 01:05:21.000000', 'consum', 0.0217, 'lps'),
	(598067, 131, '2014-03-15 01:05:22.000000', 'consum', 0.0213, 'lps'),
	(598068, 131, '2014-03-15 01:05:23.000000', 'consum', 0.0234, 'lps'),
	(598069, 131, '2014-03-15 01:05:24.000000', 'consum', 0.0236, 'lps'),
	(598070, 131, '2014-03-15 01:05:25.000000', 'consum', 0.0213, 'lps'),
	(598071, 131, '2014-03-15 01:05:26.000000', 'consum', 0.0231, 'lps'),
	(598072, 131, '2014-03-15 01:05:27.000000', 'consum', 0.0225, 'lps'),
	(598073, 131, '2014-03-15 01:05:28.000000', 'consum', 0.0220, 'lps'),
	(598074, 131, '2014-03-15 01:05:29.000000', 'consum', 0.0218, 'lps'),
	(598075, 131, '2014-03-15 01:05:30.000000', 'consum', 0.0220, 'lps'),
	(598076, 131, '2014-03-15 01:05:31.000000', 'consum', 0.0235, 'lps'),
	(598077, 131, '2014-03-15 01:05:32.000000', 'consum', 0.0223, 'lps'),
	(598078, 131, '2014-03-15 01:05:33.000000', 'consum', 0.0230, 'lps'),
	(598079, 131, '2014-03-15 01:05:34.000000', 'consum', 0.0212, 'lps'),
	(598080, 131, '2014-03-15 01:05:35.000000', 'consum', 0.0219, 'lps'),
	(598081, 131, '2014-03-15 01:05:36.000000', 'consum', 0.0221, 'lps'),
	(598082, 131, '2014-03-15 01:05:37.000000', 'consum', 0.0210, 'lps'),
	(598083, 131, '2014-03-15 01:05:38.000000', 'consum', 0.0234, 'lps'),
	(598084, 131, '2014-03-15 01:05:39.000000', 'consum', 0.0217, 'lps'),
	(598085, 131, '2014-03-15 01:05:40.000000', 'consum', 0.0232, 'lps'),
	(598086, 131, '2014-03-15 01:05:41.000000', 'consum', 0.0214, 'lps'),
	(598087, 131, '2014-03-15 01:05:42.000000', 'consum', 0.0219, 'lps'),
	(598088, 131, '2014-03-15 01:05:43.000000', 'consum', 0.0218, 'lps'),
	(598089, 131, '2014-03-15 01:05:44.000000', 'consum', 0.0222, 'lps'),
	(598090, 131, '2014-03-15 01:05:45.000000', 'consum', 0.0219, 'lps'),
	(598091, 131, '2014-03-15 01:05:46.000000', 'consum', 0.0220, 'lps'),
	(598092, 131, '2014-03-15 01:05:47.000000', 'consum', 0.0233, 'lps'),
	(598093, 131, '2014-03-15 01:05:48.000000', 'consum', 0.0211, 'lps'),
	(598094, 131, '2014-03-15 01:05:49.000000', 'consum', 0.0233, 'lps'),
	(598095, 131, '2014-03-15 01:05:50.000000', 'consum', 0.0235, 'lps'),
	(598096, 131, '2014-03-15 01:05:51.000000', 'consum', 0.0213, 'lps'),
	(598097, 131, '2014-03-15 01:05:52.000000', 'consum', 0.0234, 'lps'),
	(598098, 131, '2014-03-15 01:05:53.000000', 'consum', 0.0211, 'lps'),
	(598099, 131, '2014-03-15 01:05:54.000000', 'consum', 0.0228, 'lps'),
	(598100, 131, '2014-03-15 01:05:55.000000', 'consum', 0.0213, 'lps'),
	(598101, 131, '2014-03-15 01:05:56.000000', 'consum', 0.0226, 'lps'),
	(598102, 131, '2014-03-15 01:05:57.000000', 'consum', 0.0228, 'lps'),
	(598103, 131, '2014-03-15 01:05:58.000000', 'consum', 0.0223, 'lps'),
	(598104, 131, '2014-03-15 01:05:59.000000', 'consum', 0.0223, 'lps'),
	(598105, 131, '2014-03-15 01:06:00.000000', 'consum', 0.0234, 'lps'),
	(598106, 131, '2014-03-15 01:06:01.000000', 'consum', 0.0235, 'lps'),
	(598107, 131, '2014-03-15 01:06:02.000000', 'consum', 0.0211, 'lps'),
	(598108, 131, '2014-03-15 01:06:03.000000', 'consum', 0.0221, 'lps'),
	(598109, 131, '2014-03-15 01:06:04.000000', 'consum', 0.0235, 'lps'),
	(598110, 131, '2014-03-15 01:06:05.000000', 'consum', 0.0218, 'lps'),
	(598111, 131, '2014-03-15 01:06:06.000000', 'consum', 0.0234, 'lps'),
	(598112, 131, '2014-03-15 01:06:07.000000', 'consum', 0.0221, 'lps'),
	(598113, 131, '2014-03-15 01:06:08.000000', 'consum', 0.0222, 'lps'),
	(598114, 131, '2014-03-15 01:06:09.000000', 'consum', 0.0236, 'lps'),
	(598115, 131, '2014-03-15 01:06:10.000000', 'consum', 0.0223, 'lps'),
	(598116, 131, '2014-03-15 01:06:11.000000', 'consum', 0.0226, 'lps'),
	(598117, 131, '2014-03-15 01:06:12.000000', 'consum', 0.0225, 'lps'),
	(598118, 131, '2014-03-15 01:06:13.000000', 'consum', 0.0234, 'lps'),
	(598119, 131, '2014-03-15 01:06:14.000000', 'consum', 0.0229, 'lps'),
	(598120, 131, '2014-03-15 01:06:15.000000', 'consum', 0.0234, 'lps'),
	(598121, 131, '2014-03-15 01:06:16.000000', 'consum', 0.0217, 'lps'),
	(598122, 131, '2014-03-15 01:06:17.000000', 'consum', 0.0232, 'lps'),
	(598123, 131, '2014-03-15 01:06:18.000000', 'consum', 0.0215, 'lps'),
	(598124, 131, '2014-03-15 01:06:19.000000', 'consum', 0.0226, 'lps'),
	(598125, 131, '2014-03-15 01:06:20.000000', 'consum', 0.0220, 'lps'),
	(598126, 131, '2014-03-15 01:06:21.000000', 'consum', 0.0213, 'lps'),
	(598127, 131, '2014-03-15 01:06:22.000000', 'consum', 0.0224, 'lps'),
	(598128, 131, '2014-03-15 01:06:23.000000', 'consum', 0.0216, 'lps'),
	(598129, 131, '2014-03-15 01:06:24.000000', 'consum', 0.0225, 'lps'),
	(598130, 131, '2014-03-15 01:06:25.000000', 'consum', 0.0211, 'lps'),
	(598131, 131, '2014-03-15 01:06:26.000000', 'consum', 0.0228, 'lps'),
	(598132, 131, '2014-03-15 01:06:27.000000', 'consum', 0.0211, 'lps'),
	(598133, 131, '2014-03-15 01:06:28.000000', 'consum', 0.0218, 'lps'),
	(598134, 131, '2014-03-15 01:06:29.000000', 'consum', 0.0219, 'lps'),
	(598135, 131, '2014-03-15 01:06:30.000000', 'consum', 0.0233, 'lps'),
	(598136, 131, '2014-03-15 01:06:31.000000', 'consum', 0.0214, 'lps'),
	(598137, 131, '2014-03-15 01:06:32.000000', 'consum', 0.0217, 'lps'),
	(598138, 131, '2014-03-15 01:06:33.000000', 'consum', 0.0232, 'lps'),
	(598139, 131, '2014-03-15 01:06:34.000000', 'consum', 0.0218, 'lps'),
	(598140, 131, '2014-03-15 01:06:35.000000', 'consum', 0.0210, 'lps'),
	(598141, 131, '2014-03-15 01:06:36.000000', 'consum', 0.0217, 'lps'),
	(598142, 131, '2014-03-15 01:06:37.000000', 'consum', 0.0216, 'lps'),
	(598143, 131, '2014-03-15 01:06:38.000000', 'consum', 0.0221, 'lps'),
	(598144, 131, '2014-03-15 01:06:39.000000', 'consum', 0.0220, 'lps'),
	(598145, 131, '2014-03-15 01:06:40.000000', 'consum', 0.0226, 'lps'),
	(598146, 131, '2014-03-15 01:06:41.000000', 'consum', 0.0233, 'lps'),
	(598147, 131, '2014-03-15 01:06:42.000000', 'consum', 0.0222, 'lps'),
	(598148, 131, '2014-03-15 01:06:43.000000', 'consum', 0.0229, 'lps'),
	(598149, 131, '2014-03-15 01:06:44.000000', 'consum', 0.0213, 'lps'),
	(598150, 131, '2014-03-15 01:06:45.000000', 'consum', 0.0223, 'lps'),
	(598151, 131, '2014-03-15 01:06:46.000000', 'consum', 0.0212, 'lps'),
	(598152, 131, '2014-03-15 01:06:47.000000', 'consum', 0.0237, 'lps'),
	(598153, 131, '2014-03-15 01:06:48.000000', 'consum', 0.0227, 'lps'),
	(598154, 131, '2014-03-15 01:06:49.000000', 'consum', 0.0213, 'lps'),
	(598155, 131, '2014-03-15 01:06:50.000000', 'consum', 0.0232, 'lps'),
	(598156, 131, '2014-03-15 01:06:51.000000', 'consum', 0.0226, 'lps'),
	(598157, 131, '2014-03-15 01:06:52.000000', 'consum', 0.0226, 'lps'),
	(598158, 131, '2014-03-15 01:06:53.000000', 'consum', 0.0214, 'lps'),
	(598159, 131, '2014-03-15 01:06:54.000000', 'consum', 0.0212, 'lps'),
	(598160, 131, '2014-03-15 01:06:55.000000', 'consum', 0.0235, 'lps'),
	(598161, 131, '2014-03-15 01:06:56.000000', 'consum', 0.0217, 'lps'),
	(598162, 131, '2014-03-15 01:06:57.000000', 'consum', 0.0228, 'lps'),
	(598163, 131, '2014-03-15 01:06:58.000000', 'consum', 0.0224, 'lps'),
	(598164, 131, '2014-03-15 01:06:59.000000', 'consum', 0.0227, 'lps'),
	(598165, 131, '2014-03-15 01:07:00.000000', 'consum', 0.0224, 'lps'),
	(598166, 131, '2014-03-15 01:07:01.000000', 'consum', 0.0229, 'lps'),
	(598167, 131, '2014-03-15 01:07:02.000000', 'consum', 0.0210, 'lps'),
	(598168, 131, '2014-03-15 01:07:03.000000', 'consum', 0.0236, 'lps'),
	(598169, 131, '2014-03-15 01:07:04.000000', 'consum', 0.0227, 'lps'),
	(598170, 131, '2014-03-15 01:07:05.000000', 'consum', 0.0217, 'lps'),
	(598171, 131, '2014-03-15 01:07:06.000000', 'consum', 0.0224, 'lps'),
	(598172, 131, '2014-03-15 01:07:07.000000', 'consum', 0.0231, 'lps'),
	(598173, 131, '2014-03-15 01:07:08.000000', 'consum', 0.0217, 'lps'),
	(598174, 131, '2014-03-15 01:07:09.000000', 'consum', 0.0210, 'lps'),
	(598175, 131, '2014-03-15 01:07:10.000000', 'consum', 0.0217, 'lps'),
	(598176, 131, '2014-03-15 01:07:11.000000', 'consum', 0.0217, 'lps'),
	(598177, 131, '2014-03-15 01:07:12.000000', 'consum', 0.0226, 'lps'),
	(598178, 131, '2014-03-15 01:07:13.000000', 'consum', 0.0213, 'lps'),
	(598179, 131, '2014-03-15 01:07:14.000000', 'consum', 0.0235, 'lps'),
	(598180, 131, '2014-03-15 01:07:15.000000', 'consum', 0.0213, 'lps'),
	(598181, 131, '2014-03-15 01:07:16.000000', 'consum', 0.0234, 'lps'),
	(598182, 131, '2014-03-15 01:07:17.000000', 'consum', 0.0236, 'lps'),
	(598183, 131, '2014-03-15 01:07:18.000000', 'consum', 0.0216, 'lps'),
	(598184, 131, '2014-03-15 01:07:19.000000', 'consum', 0.0216, 'lps'),
	(598185, 131, '2014-03-15 01:07:20.000000', 'consum', 0.0223, 'lps'),
	(598186, 131, '2014-03-15 01:07:21.000000', 'consum', 0.0231, 'lps'),
	(598187, 131, '2014-03-15 01:07:22.000000', 'consum', 0.0217, 'lps'),
	(598188, 131, '2014-03-15 01:07:23.000000', 'consum', 0.0214, 'lps'),
	(598189, 131, '2014-03-15 01:07:24.000000', 'consum', 0.0237, 'lps'),
	(598190, 131, '2014-03-15 01:07:25.000000', 'consum', 0.0222, 'lps'),
	(598191, 131, '2014-03-15 01:07:26.000000', 'consum', 0.0219, 'lps'),
	(598192, 131, '2014-03-15 01:07:27.000000', 'consum', 0.0217, 'lps'),
	(598193, 131, '2014-03-15 01:07:28.000000', 'consum', 0.0218, 'lps'),
	(598194, 131, '2014-03-15 01:07:29.000000', 'consum', 0.0229, 'lps'),
	(598195, 131, '2014-03-15 01:07:30.000000', 'consum', 0.0224, 'lps'),
	(598196, 131, '2014-03-15 01:07:31.000000', 'consum', 0.0227, 'lps'),
	(598197, 131, '2014-03-15 01:07:32.000000', 'consum', 0.0225, 'lps'),
	(598198, 131, '2014-03-15 01:07:33.000000', 'consum', 0.0234, 'lps'),
	(598199, 131, '2014-03-15 01:07:34.000000', 'consum', 0.0231, 'lps'),
	(598200, 131, '2014-03-15 01:07:35.000000', 'consum', 0.0214, 'lps'),
	(598201, 131, '2014-03-15 01:07:36.000000', 'consum', 0.0222, 'lps'),
	(598202, 131, '2014-03-15 01:07:37.000000', 'consum', 0.0232, 'lps'),
	(598203, 131, '2014-03-15 01:07:38.000000', 'consum', 0.0228, 'lps'),
	(598204, 131, '2014-03-15 01:07:39.000000', 'consum', 0.0236, 'lps'),
	(598205, 131, '2014-03-15 01:07:40.000000', 'consum', 0.0231, 'lps'),
	(598206, 131, '2014-03-15 01:07:41.000000', 'consum', 0.0235, 'lps'),
	(598207, 131, '2014-03-15 01:07:42.000000', 'consum', 0.0217, 'lps'),
	(598208, 131, '2014-03-15 01:07:43.000000', 'consum', 0.0228, 'lps'),
	(598209, 131, '2014-03-15 01:07:44.000000', 'consum', 0.0224, 'lps'),
	(598210, 131, '2014-03-15 01:07:45.000000', 'consum', 0.0228, 'lps'),
	(598211, 131, '2014-03-15 01:07:46.000000', 'consum', 0.0228, 'lps'),
	(598212, 131, '2014-03-15 01:07:47.000000', 'consum', 0.0218, 'lps'),
	(598213, 131, '2014-03-15 01:07:48.000000', 'consum', 0.0225, 'lps'),
	(598214, 131, '2014-03-15 01:07:49.000000', 'consum', 0.0232, 'lps'),
	(598215, 131, '2014-03-15 01:07:50.000000', 'consum', 0.0221, 'lps'),
	(598216, 131, '2014-03-15 01:07:51.000000', 'consum', 0.0226, 'lps'),
	(598217, 131, '2014-03-15 01:07:52.000000', 'consum', 0.0232, 'lps'),
	(598218, 131, '2014-03-15 01:07:53.000000', 'consum', 0.0217, 'lps'),
	(598219, 131, '2014-03-15 01:07:54.000000', 'consum', 0.0235, 'lps'),
	(598220, 131, '2014-03-15 01:07:55.000000', 'consum', 0.0232, 'lps'),
	(598221, 131, '2014-03-15 01:07:56.000000', 'consum', 0.0215, 'lps'),
	(598222, 131, '2014-03-15 01:07:57.000000', 'consum', 0.0228, 'lps'),
	(598223, 131, '2014-03-15 01:07:58.000000', 'consum', 0.0229, 'lps'),
	(598224, 131, '2014-03-15 01:07:59.000000', 'consum', 0.0224, 'lps'),
	(598225, 131, '2014-03-15 01:08:00.000000', 'consum', 0.0223, 'lps'),
	(598226, 131, '2014-03-15 01:08:01.000000', 'consum', 0.0232, 'lps'),
	(598227, 131, '2014-03-15 01:08:02.000000', 'consum', 0.0226, 'lps'),
	(598228, 131, '2014-03-15 01:08:03.000000', 'consum', 0.0226, 'lps'),
	(598229, 131, '2014-03-15 01:08:04.000000', 'consum', 0.0215, 'lps'),
	(598230, 131, '2014-03-15 01:08:05.000000', 'consum', 0.0216, 'lps'),
	(598231, 131, '2014-03-15 01:08:06.000000', 'consum', 0.0225, 'lps'),
	(598232, 131, '2014-03-15 01:08:07.000000', 'consum', 0.0211, 'lps'),
	(598233, 131, '2014-03-15 01:08:08.000000', 'consum', 0.0227, 'lps'),
	(598234, 131, '2014-03-15 01:08:09.000000', 'consum', 0.0235, 'lps'),
	(598235, 131, '2014-03-15 01:08:10.000000', 'consum', 0.0230, 'lps'),
	(598236, 131, '2014-03-15 01:08:11.000000', 'consum', 0.0235, 'lps'),
	(598237, 131, '2014-03-15 01:08:12.000000', 'consum', 0.0219, 'lps'),
	(598238, 131, '2014-03-15 01:08:13.000000', 'consum', 0.0211, 'lps'),
	(598239, 131, '2014-03-15 01:08:14.000000', 'consum', 0.0215, 'lps'),
	(598240, 131, '2014-03-15 01:08:15.000000', 'consum', 0.0232, 'lps'),
	(598241, 131, '2014-03-15 01:08:16.000000', 'consum', 0.0224, 'lps'),
	(598242, 131, '2014-03-15 01:08:17.000000', 'consum', 0.0213, 'lps'),
	(598243, 131, '2014-03-15 01:08:18.000000', 'consum', 0.0211, 'lps'),
	(598244, 131, '2014-03-15 01:08:19.000000', 'consum', 0.0234, 'lps'),
	(598245, 131, '2014-03-15 01:08:20.000000', 'consum', 0.0217, 'lps'),
	(598246, 131, '2014-03-15 01:08:21.000000', 'consum', 0.0231, 'lps'),
	(598247, 131, '2014-03-15 01:08:22.000000', 'consum', 0.0236, 'lps'),
	(598248, 131, '2014-03-15 01:08:23.000000', 'consum', 0.0220, 'lps'),
	(598249, 131, '2014-03-15 01:08:24.000000', 'consum', 0.0213, 'lps'),
	(598250, 131, '2014-03-15 01:08:25.000000', 'consum', 0.0224, 'lps'),
	(598251, 131, '2014-03-15 01:08:26.000000', 'consum', 0.0214, 'lps'),
	(598252, 131, '2014-03-15 01:08:27.000000', 'consum', 0.0216, 'lps'),
	(598253, 131, '2014-03-15 01:08:28.000000', 'consum', 0.0228, 'lps'),
	(598254, 131, '2014-03-15 01:08:29.000000', 'consum', 0.0228, 'lps'),
	(598255, 131, '2014-03-15 01:08:30.000000', 'consum', 0.0218, 'lps'),
	(598256, 131, '2014-03-15 01:08:31.000000', 'consum', 0.0226, 'lps'),
	(598257, 131, '2014-03-15 01:08:32.000000', 'consum', 0.0237, 'lps'),
	(598258, 131, '2014-03-15 01:08:33.000000', 'consum', 0.0212, 'lps'),
	(598259, 131, '2014-03-15 01:08:34.000000', 'consum', 0.0226, 'lps'),
	(598260, 131, '2014-03-15 01:08:35.000000', 'consum', 0.0226, 'lps'),
	(598261, 131, '2014-03-15 01:08:36.000000', 'consum', 0.0214, 'lps'),
	(598262, 131, '2014-03-15 01:08:37.000000', 'consum', 0.0212, 'lps'),
	(598263, 131, '2014-03-15 01:08:38.000000', 'consum', 0.0237, 'lps'),
	(598264, 131, '2014-03-15 01:08:39.000000', 'consum', 0.0225, 'lps'),
	(598265, 131, '2014-03-15 01:08:40.000000', 'consum', 0.0235, 'lps'),
	(598266, 131, '2014-03-15 01:08:41.000000', 'consum', 0.0233, 'lps'),
	(598267, 131, '2014-03-15 01:08:42.000000', 'consum', 0.0221, 'lps'),
	(598268, 131, '2014-03-15 01:08:43.000000', 'consum', 0.0226, 'lps'),
	(598269, 131, '2014-03-15 01:08:44.000000', 'consum', 0.0231, 'lps'),
	(598270, 131, '2014-03-15 01:08:45.000000', 'consum', 0.0212, 'lps'),
	(598271, 131, '2014-03-15 01:08:46.000000', 'consum', 0.0212, 'lps'),
	(598272, 131, '2014-03-15 01:08:47.000000', 'consum', 0.0216, 'lps'),
	(598273, 131, '2014-03-15 01:08:48.000000', 'consum', 0.0233, 'lps'),
	(598274, 131, '2014-03-15 01:08:49.000000', 'consum', 0.0226, 'lps'),
	(598275, 131, '2014-03-15 01:08:50.000000', 'consum', 0.0218, 'lps'),
	(598276, 131, '2014-03-15 01:08:51.000000', 'consum', 0.0232, 'lps'),
	(598277, 131, '2014-03-15 01:08:52.000000', 'consum', 0.0213, 'lps'),
	(598278, 131, '2014-03-15 01:08:53.000000', 'consum', 0.0214, 'lps'),
	(598279, 131, '2014-03-15 01:08:54.000000', 'consum', 0.0224, 'lps'),
	(598280, 131, '2014-03-15 01:08:55.000000', 'consum', 0.0210, 'lps'),
	(598281, 131, '2014-03-15 01:08:56.000000', 'consum', 0.0226, 'lps'),
	(598282, 131, '2014-03-15 01:08:57.000000', 'consum', 0.0234, 'lps'),
	(598283, 131, '2014-03-15 01:08:58.000000', 'consum', 0.0227, 'lps'),
	(598284, 131, '2014-03-15 01:08:59.000000', 'consum', 0.0224, 'lps'),
	(598285, 131, '2014-03-15 01:09:00.000000', 'consum', 0.0229, 'lps'),
	(598286, 131, '2014-03-15 01:09:01.000000', 'consum', 0.0235, 'lps'),
	(598287, 131, '2014-03-15 01:09:02.000000', 'consum', 0.0223, 'lps'),
	(598288, 131, '2014-03-15 01:09:03.000000', 'consum', 0.0229, 'lps'),
	(598289, 131, '2014-03-15 01:09:04.000000', 'consum', 0.0236, 'lps'),
	(598290, 131, '2014-03-15 01:09:05.000000', 'consum', 0.0229, 'lps'),
	(598291, 131, '2014-03-15 01:09:06.000000', 'consum', 0.0226, 'lps'),
	(598292, 131, '2014-03-15 01:09:07.000000', 'consum', 0.0235, 'lps'),
	(598293, 131, '2014-03-15 01:09:08.000000', 'consum', 0.0231, 'lps'),
	(598294, 131, '2014-03-15 01:09:09.000000', 'consum', 0.0212, 'lps'),
	(598295, 131, '2014-03-15 01:09:10.000000', 'consum', 0.0213, 'lps'),
	(598296, 131, '2014-03-15 01:09:11.000000', 'consum', 0.0221, 'lps'),
	(598297, 131, '2014-03-15 01:09:12.000000', 'consum', 0.0229, 'lps'),
	(598298, 131, '2014-03-15 01:09:13.000000', 'consum', 0.0216, 'lps'),
	(598299, 131, '2014-03-15 01:09:14.000000', 'consum', 0.0210, 'lps'),
	(598300, 131, '2014-03-15 01:09:15.000000', 'consum', 0.0220, 'lps'),
	(598301, 131, '2014-03-15 01:09:16.000000', 'consum', 0.0234, 'lps'),
	(598302, 131, '2014-03-15 01:09:17.000000', 'consum', 0.0215, 'lps'),
	(598303, 131, '2014-03-15 01:09:18.000000', 'consum', 0.0219, 'lps'),
	(598304, 131, '2014-03-15 01:09:19.000000', 'consum', 0.0215, 'lps'),
	(598305, 131, '2014-03-15 01:09:20.000000', 'consum', 0.0235, 'lps'),
	(598306, 131, '2014-03-15 01:09:21.000000', 'consum', 0.0235, 'lps'),
	(598307, 131, '2014-03-15 01:09:22.000000', 'consum', 0.0236, 'lps'),
	(598308, 131, '2014-03-15 01:09:23.000000', 'consum', 0.0234, 'lps'),
	(598309, 131, '2014-03-15 01:09:24.000000', 'consum', 0.0226, 'lps'),
	(598310, 131, '2014-03-15 01:09:25.000000', 'consum', 0.0219, 'lps'),
	(598311, 131, '2014-03-15 01:09:26.000000', 'consum', 0.0235, 'lps'),
	(598312, 131, '2014-03-15 01:09:27.000000', 'consum', 0.0226, 'lps'),
	(598313, 131, '2014-03-15 01:09:28.000000', 'consum', 0.0214, 'lps'),
	(598314, 131, '2014-03-15 01:09:29.000000', 'consum', 0.0211, 'lps'),
	(598315, 131, '2014-03-15 01:09:30.000000', 'consum', 0.0231, 'lps'),
	(598316, 131, '2014-03-15 01:09:31.000000', 'consum', 0.0231, 'lps'),
	(598317, 131, '2014-03-15 01:09:32.000000', 'consum', 0.0221, 'lps'),
	(598318, 131, '2014-03-15 01:09:33.000000', 'consum', 0.0231, 'lps'),
	(598319, 131, '2014-03-15 01:09:34.000000', 'consum', 0.0227, 'lps'),
	(598320, 131, '2014-03-15 01:09:35.000000', 'consum', 0.0233, 'lps'),
	(598321, 131, '2014-03-15 01:09:36.000000', 'consum', 0.0220, 'lps'),
	(598322, 131, '2014-03-15 01:09:37.000000', 'consum', 0.0217, 'lps'),
	(598323, 131, '2014-03-15 01:09:38.000000', 'consum', 0.0217, 'lps'),
	(598324, 131, '2014-03-15 01:09:39.000000', 'consum', 0.0225, 'lps'),
	(598325, 131, '2014-03-15 01:09:40.000000', 'consum', 0.0236, 'lps'),
	(598326, 131, '2014-03-15 01:09:41.000000', 'consum', 0.0213, 'lps'),
	(598327, 131, '2014-03-15 01:09:42.000000', 'consum', 0.0232, 'lps'),
	(598328, 131, '2014-03-15 01:09:43.000000', 'consum', 0.0226, 'lps'),
	(598329, 131, '2014-03-15 01:09:44.000000', 'consum', 0.0224, 'lps'),
	(598330, 131, '2014-03-15 01:09:45.000000', 'consum', 0.0235, 'lps'),
	(598331, 131, '2014-03-15 01:09:46.000000', 'consum', 0.0235, 'lps'),
	(598332, 131, '2014-03-15 01:09:47.000000', 'consum', 0.0235, 'lps'),
	(598333, 131, '2014-03-15 01:09:48.000000', 'consum', 0.0232, 'lps'),
	(598334, 131, '2014-03-15 01:09:49.000000', 'consum', 0.0215, 'lps'),
	(598335, 131, '2014-03-15 01:09:50.000000', 'consum', 0.0229, 'lps'),
	(598336, 131, '2014-03-15 01:09:51.000000', 'consum', 0.0233, 'lps'),
	(598337, 131, '2014-03-15 01:09:52.000000', 'consum', 0.0212, 'lps'),
	(598338, 131, '2014-03-15 01:09:53.000000', 'consum', 0.0210, 'lps'),
	(598339, 131, '2014-03-15 01:09:54.000000', 'consum', 0.0229, 'lps'),
	(598340, 131, '2014-03-15 01:09:55.000000', 'consum', 0.0225, 'lps'),
	(598341, 131, '2014-03-15 01:09:56.000000', 'consum', 0.0227, 'lps'),
	(598342, 131, '2014-03-15 01:09:57.000000', 'consum', 0.0222, 'lps'),
	(598343, 131, '2014-03-15 01:09:58.000000', 'consum', 0.0219, 'lps'),
	(598344, 131, '2014-03-15 01:09:59.000000', 'consum', 0.0218, 'lps'),
	(598345, 131, '2014-03-15 01:10:00.000000', 'consum', 0.0226, 'lps'),
	(598346, 131, '2014-03-15 01:10:01.000000', 'consum', 0.0210, 'lps'),
	(598347, 131, '2014-03-15 01:10:02.000000', 'consum', 0.0220, 'lps'),
	(598348, 131, '2014-03-15 01:10:03.000000', 'consum', 0.0232, 'lps'),
	(598349, 131, '2014-03-15 01:10:04.000000', 'consum', 0.0235, 'lps'),
	(598350, 131, '2014-03-15 01:10:05.000000', 'consum', 0.0212, 'lps'),
	(598351, 131, '2014-03-15 01:10:06.000000', 'consum', 0.0230, 'lps'),
	(598352, 131, '2014-03-15 01:10:07.000000', 'consum', 0.0220, 'lps'),
	(598353, 131, '2014-03-15 01:10:08.000000', 'consum', 0.0228, 'lps'),
	(598354, 131, '2014-03-15 01:10:09.000000', 'consum', 0.0214, 'lps'),
	(598355, 131, '2014-03-15 01:10:10.000000', 'consum', 0.0233, 'lps'),
	(598356, 131, '2014-03-15 01:10:11.000000', 'consum', 0.0230, 'lps'),
	(598357, 131, '2014-03-15 01:10:12.000000', 'consum', 0.0214, 'lps'),
	(598358, 131, '2014-03-15 01:10:13.000000', 'consum', 0.0226, 'lps'),
	(598359, 131, '2014-03-15 01:10:14.000000', 'consum', 0.0220, 'lps'),
	(598360, 131, '2014-03-15 01:10:15.000000', 'consum', 0.0216, 'lps'),
	(598361, 131, '2014-03-15 01:10:16.000000', 'consum', 0.0237, 'lps'),
	(598362, 131, '2014-03-15 01:10:17.000000', 'consum', 0.0216, 'lps'),
	(598363, 131, '2014-03-15 01:10:18.000000', 'consum', 0.0217, 'lps'),
	(598364, 131, '2014-03-15 01:10:19.000000', 'consum', 0.0225, 'lps'),
	(598365, 131, '2014-03-15 01:10:20.000000', 'consum', 0.0211, 'lps'),
	(598366, 131, '2014-03-15 01:10:21.000000', 'consum', 0.0225, 'lps'),
	(598367, 131, '2014-03-15 01:10:22.000000', 'consum', 0.0227, 'lps'),
	(598368, 131, '2014-03-15 01:10:23.000000', 'consum', 0.0222, 'lps'),
	(598369, 131, '2014-03-15 01:10:24.000000', 'consum', 0.0221, 'lps'),
	(598370, 131, '2014-03-15 01:10:25.000000', 'consum', 0.0227, 'lps'),
	(598371, 131, '2014-03-15 01:10:26.000000', 'consum', 0.0237, 'lps'),
	(598372, 131, '2014-03-15 01:10:27.000000', 'consum', 0.0211, 'lps'),
	(598373, 131, '2014-03-15 01:10:28.000000', 'consum', 0.0216, 'lps'),
	(598374, 131, '2014-03-15 01:10:29.000000', 'consum', 0.0211, 'lps'),
	(598375, 131, '2014-03-15 01:10:30.000000', 'consum', 0.0226, 'lps'),
	(598376, 131, '2014-03-15 01:10:31.000000', 'consum', 0.0229, 'lps'),
	(598377, 131, '2014-03-15 01:10:32.000000', 'consum', 0.0233, 'lps'),
	(598378, 131, '2014-03-15 01:10:33.000000', 'consum', 0.0237, 'lps'),
	(598379, 131, '2014-03-15 01:10:34.000000', 'consum', 0.0224, 'lps'),
	(598380, 131, '2014-03-15 01:10:35.000000', 'consum', 0.0225, 'lps'),
	(598381, 131, '2014-03-15 01:10:36.000000', 'consum', 0.0217, 'lps'),
	(598382, 131, '2014-03-15 01:10:37.000000', 'consum', 0.0229, 'lps'),
	(598383, 131, '2014-03-15 01:10:38.000000', 'consum', 0.0227, 'lps'),
	(598384, 131, '2014-03-15 01:10:39.000000', 'consum', 0.0211, 'lps'),
	(598385, 131, '2014-03-15 01:10:40.000000', 'consum', 0.0221, 'lps'),
	(598386, 131, '2014-03-15 01:10:41.000000', 'consum', 0.0236, 'lps'),
	(598387, 131, '2014-03-15 01:10:42.000000', 'consum', 0.0220, 'lps'),
	(598388, 131, '2014-03-15 01:10:43.000000', 'consum', 0.0213, 'lps'),
	(598389, 131, '2014-03-15 01:10:44.000000', 'consum', 0.0222, 'lps'),
	(598390, 131, '2014-03-15 01:10:45.000000', 'consum', 0.0234, 'lps'),
	(598391, 131, '2014-03-15 01:10:46.000000', 'consum', 0.0237, 'lps'),
	(598392, 131, '2014-03-15 01:10:47.000000', 'consum', 0.0220, 'lps'),
	(598393, 131, '2014-03-15 01:10:48.000000', 'consum', 0.0234, 'lps'),
	(598394, 131, '2014-03-15 01:10:49.000000', 'consum', 0.0216, 'lps'),
	(598395, 131, '2014-03-15 01:10:50.000000', 'consum', 0.0223, 'lps'),
	(598396, 131, '2014-03-15 01:10:51.000000', 'consum', 0.0231, 'lps'),
	(598397, 131, '2014-03-15 01:10:52.000000', 'consum', 0.0220, 'lps'),
	(598398, 131, '2014-03-15 01:10:53.000000', 'consum', 0.0227, 'lps'),
	(598399, 131, '2014-03-15 01:10:54.000000', 'consum', 0.0235, 'lps'),
	(598400, 131, '2014-03-15 01:10:55.000000', 'consum', 0.0231, 'lps'),
	(598401, 131, '2014-03-15 01:10:56.000000', 'consum', 0.0214, 'lps'),
	(598402, 131, '2014-03-15 01:10:57.000000', 'consum', 0.0220, 'lps'),
	(598403, 131, '2014-03-15 01:10:58.000000', 'consum', 0.0223, 'lps'),
	(598404, 131, '2014-03-15 01:10:59.000000', 'consum', 0.0218, 'lps'),
	(598405, 131, '2014-03-15 01:11:00.000000', 'consum', 0.0211, 'lps'),
	(598406, 131, '2014-03-15 01:11:01.000000', 'consum', 0.0221, 'lps'),
	(598407, 131, '2014-03-15 01:11:02.000000', 'consum', 0.0232, 'lps'),
	(598408, 131, '2014-03-15 01:11:03.000000', 'consum', 0.0234, 'lps'),
	(598409, 131, '2014-03-15 01:11:04.000000', 'consum', 0.0234, 'lps'),
	(598410, 131, '2014-03-15 01:11:05.000000', 'consum', 0.0233, 'lps'),
	(598411, 131, '2014-03-15 01:11:06.000000', 'consum', 0.0224, 'lps'),
	(598412, 131, '2014-03-15 01:11:07.000000', 'consum', 0.0212, 'lps'),
	(598413, 131, '2014-03-15 01:11:08.000000', 'consum', 0.0236, 'lps'),
	(598414, 131, '2014-03-15 01:11:09.000000', 'consum', 0.0220, 'lps'),
	(598415, 131, '2014-03-15 01:11:10.000000', 'consum', 0.0213, 'lps'),
	(598416, 131, '2014-03-15 01:11:11.000000', 'consum', 0.0220, 'lps'),
	(598417, 131, '2014-03-15 01:11:12.000000', 'consum', 0.0227, 'lps'),
	(598418, 131, '2014-03-15 01:11:13.000000', 'consum', 0.0235, 'lps'),
	(598419, 131, '2014-03-15 01:11:14.000000', 'consum', 0.0231, 'lps'),
	(598420, 131, '2014-03-15 01:11:15.000000', 'consum', 0.0213, 'lps'),
	(598421, 131, '2014-03-15 01:11:16.000000', 'consum', 0.0215, 'lps'),
	(598422, 131, '2014-03-15 01:11:17.000000', 'consum', 0.0229, 'lps'),
	(598423, 131, '2014-03-15 01:11:18.000000', 'consum', 0.0234, 'lps'),
	(598424, 131, '2014-03-15 01:11:19.000000', 'consum', 0.0219, 'lps'),
	(598425, 131, '2014-03-15 01:11:20.000000', 'consum', 0.0211, 'lps'),
	(598426, 131, '2014-03-15 01:11:21.000000', 'consum', 0.0217, 'lps'),
	(598427, 131, '2014-03-15 01:11:22.000000', 'consum', 0.0215, 'lps'),
	(598428, 131, '2014-03-15 01:11:23.000000', 'consum', 0.0212, 'lps'),
	(598429, 131, '2014-03-15 01:11:24.000000', 'consum', 0.0236, 'lps'),
	(598430, 131, '2014-03-15 01:11:25.000000', 'consum', 0.0220, 'lps'),
	(598431, 131, '2014-03-15 01:11:26.000000', 'consum', 0.0210, 'lps'),
	(598432, 131, '2014-03-15 01:11:27.000000', 'consum', 0.0237, 'lps'),
	(598433, 131, '2014-03-15 01:11:28.000000', 'consum', 0.0232, 'lps'),
	(598434, 131, '2014-03-15 01:11:29.000000', 'consum', 0.0213, 'lps'),
	(598435, 131, '2014-03-15 01:11:30.000000', 'consum', 0.0217, 'lps'),
	(598436, 131, '2014-03-15 01:11:31.000000', 'consum', 0.0234, 'lps'),
	(598437, 131, '2014-03-15 01:11:32.000000', 'consum', 0.0225, 'lps'),
	(598438, 131, '2014-03-15 01:11:33.000000', 'consum', 0.0216, 'lps'),
	(598439, 131, '2014-03-15 01:11:34.000000', 'consum', 0.0221, 'lps'),
	(598440, 131, '2014-03-15 01:11:35.000000', 'consum', 0.0219, 'lps'),
	(598441, 131, '2014-03-15 01:11:36.000000', 'consum', 0.0225, 'lps'),
	(598442, 131, '2014-03-15 01:11:37.000000', 'consum', 0.0229, 'lps'),
	(598443, 131, '2014-03-15 01:11:38.000000', 'consum', 0.0231, 'lps'),
	(598444, 131, '2014-03-15 01:11:39.000000', 'consum', 0.0232, 'lps'),
	(598445, 131, '2014-03-15 01:11:40.000000', 'consum', 0.0230, 'lps'),
	(598446, 131, '2014-03-15 01:11:41.000000', 'consum', 0.0216, 'lps'),
	(598447, 131, '2014-03-15 01:11:42.000000', 'consum', 0.0236, 'lps'),
	(598448, 131, '2014-03-15 01:11:43.000000', 'consum', 0.0211, 'lps'),
	(598449, 131, '2014-03-15 01:11:44.000000', 'consum', 0.0222, 'lps'),
	(598450, 131, '2014-03-15 01:11:45.000000', 'consum', 0.0210, 'lps'),
	(598451, 131, '2014-03-15 01:11:46.000000', 'consum', 0.0232, 'lps'),
	(598452, 131, '2014-03-15 01:11:47.000000', 'consum', 0.0236, 'lps'),
	(598453, 131, '2014-03-15 01:11:48.000000', 'consum', 0.0219, 'lps'),
	(598454, 131, '2014-03-15 01:11:49.000000', 'consum', 0.0234, 'lps'),
	(598455, 131, '2014-03-15 01:11:50.000000', 'consum', 0.0218, 'lps'),
	(598456, 131, '2014-03-15 01:11:51.000000', 'consum', 0.0234, 'lps'),
	(598457, 131, '2014-03-15 01:11:52.000000', 'consum', 0.0224, 'lps'),
	(598458, 131, '2014-03-15 01:11:53.000000', 'consum', 0.0236, 'lps'),
	(598459, 131, '2014-03-15 01:11:54.000000', 'consum', 0.0214, 'lps'),
	(598460, 131, '2014-03-15 01:11:55.000000', 'consum', 0.0237, 'lps'),
	(598461, 131, '2014-03-15 01:11:56.000000', 'consum', 0.0221, 'lps'),
	(598462, 131, '2014-03-15 01:11:57.000000', 'consum', 0.0211, 'lps'),
	(598463, 131, '2014-03-15 01:11:58.000000', 'consum', 0.0213, 'lps'),
	(598464, 131, '2014-03-15 01:11:59.000000', 'consum', 0.0220, 'lps'),
	(598465, 131, '2014-03-15 01:12:00.000000', 'consum', 0.0227, 'lps'),
	(598466, 131, '2014-03-15 01:12:01.000000', 'consum', 0.0234, 'lps'),
	(598467, 131, '2014-03-15 01:12:02.000000', 'consum', 0.0225, 'lps'),
	(598468, 131, '2014-03-15 01:12:03.000000', 'consum', 0.0212, 'lps'),
	(598469, 131, '2014-03-15 01:12:04.000000', 'consum', 0.0231, 'lps'),
	(598470, 131, '2014-03-15 01:12:05.000000', 'consum', 0.0226, 'lps'),
	(598471, 131, '2014-03-15 01:12:06.000000', 'consum', 0.0228, 'lps'),
	(598472, 131, '2014-03-15 01:12:07.000000', 'consum', 0.0226, 'lps'),
	(598473, 131, '2014-03-15 01:12:08.000000', 'consum', 0.0235, 'lps'),
	(598474, 131, '2014-03-15 01:12:09.000000', 'consum', 0.0234, 'lps'),
	(598475, 131, '2014-03-15 01:12:10.000000', 'consum', 0.0225, 'lps'),
	(598476, 131, '2014-03-15 01:12:11.000000', 'consum', 0.0213, 'lps'),
	(598477, 131, '2014-03-15 01:12:12.000000', 'consum', 0.0211, 'lps'),
	(598478, 131, '2014-03-15 01:12:13.000000', 'consum', 0.0234, 'lps'),
	(598479, 131, '2014-03-15 01:12:14.000000', 'consum', 0.0215, 'lps'),
	(598480, 131, '2014-03-15 01:12:15.000000', 'consum', 0.0217, 'lps'),
	(598481, 131, '2014-03-15 01:12:16.000000', 'consum', 0.0234, 'lps'),
	(598482, 131, '2014-03-15 01:12:17.000000', 'consum', 0.0225, 'lps'),
	(598483, 131, '2014-03-15 01:12:18.000000', 'consum', 0.0211, 'lps'),
	(598484, 131, '2014-03-15 01:12:19.000000', 'consum', 0.0229, 'lps'),
	(598485, 131, '2014-03-15 01:12:20.000000', 'consum', 0.0218, 'lps'),
	(598486, 131, '2014-03-15 01:12:21.000000', 'consum', 0.0220, 'lps'),
	(598487, 131, '2014-03-15 01:12:22.000000', 'consum', 0.0236, 'lps'),
	(598488, 131, '2014-03-15 01:12:23.000000', 'consum', 0.0226, 'lps'),
	(598489, 131, '2014-03-15 01:12:24.000000', 'consum', 0.0215, 'lps'),
	(598490, 131, '2014-03-15 01:12:25.000000', 'consum', 0.0215, 'lps'),
	(598491, 131, '2014-03-15 01:12:26.000000', 'consum', 0.0219, 'lps'),
	(598492, 131, '2014-03-15 01:12:27.000000', 'consum', 0.0212, 'lps'),
	(598493, 131, '2014-03-15 01:12:28.000000', 'consum', 0.0221, 'lps'),
	(598494, 131, '2014-03-15 01:12:29.000000', 'consum', 0.0232, 'lps'),
	(598495, 131, '2014-03-15 01:12:30.000000', 'consum', 0.0232, 'lps'),
	(598496, 131, '2014-03-15 01:12:31.000000', 'consum', 0.0225, 'lps'),
	(598497, 131, '2014-03-15 01:12:32.000000', 'consum', 0.0219, 'lps'),
	(598498, 131, '2014-03-15 01:12:33.000000', 'consum', 0.0211, 'lps'),
	(598499, 131, '2014-03-15 01:12:34.000000', 'consum', 0.0217, 'lps'),
	(598500, 131, '2014-03-15 01:12:35.000000', 'consum', 0.0214, 'lps'),
	(598501, 131, '2014-03-15 01:12:36.000000', 'consum', 0.0210, 'lps'),
	(598502, 131, '2014-03-15 01:12:37.000000', 'consum', 0.0227, 'lps'),
	(598503, 131, '2014-03-15 01:12:38.000000', 'consum', 0.0211, 'lps'),
	(598504, 131, '2014-03-15 01:12:39.000000', 'consum', 0.0218, 'lps'),
	(598505, 131, '2014-03-15 01:12:40.000000', 'consum', 0.0223, 'lps'),
	(598506, 131, '2014-03-15 01:12:41.000000', 'consum', 0.0224, 'lps'),
	(598507, 131, '2014-03-15 01:12:42.000000', 'consum', 0.0210, 'lps'),
	(598508, 131, '2014-03-15 01:12:43.000000', 'consum', 0.0228, 'lps'),
	(598509, 131, '2014-03-15 01:12:44.000000', 'consum', 0.0215, 'lps'),
	(598510, 131, '2014-03-15 01:12:45.000000', 'consum', 0.0210, 'lps'),
	(598511, 131, '2014-03-15 01:12:46.000000', 'consum', 0.0222, 'lps'),
	(598512, 131, '2014-03-15 01:12:47.000000', 'consum', 0.0217, 'lps'),
	(598513, 131, '2014-03-15 01:12:48.000000', 'consum', 0.0236, 'lps'),
	(598514, 131, '2014-03-15 01:12:49.000000', 'consum', 0.0235, 'lps'),
	(598515, 131, '2014-03-15 01:12:50.000000', 'consum', 0.0230, 'lps'),
	(598516, 131, '2014-03-15 01:12:51.000000', 'consum', 0.0235, 'lps'),
	(598517, 131, '2014-03-15 01:12:52.000000', 'consum', 0.0222, 'lps'),
	(598518, 131, '2014-03-15 01:12:53.000000', 'consum', 0.0222, 'lps'),
	(598519, 131, '2014-03-15 01:12:54.000000', 'consum', 0.0234, 'lps'),
	(598520, 131, '2014-03-15 01:12:55.000000', 'consum', 0.0212, 'lps'),
	(598521, 131, '2014-03-15 01:12:56.000000', 'consum', 0.0233, 'lps'),
	(598522, 131, '2014-03-15 01:12:57.000000', 'consum', 0.0236, 'lps'),
	(598523, 131, '2014-03-15 01:12:58.000000', 'consum', 0.0215, 'lps'),
	(598524, 131, '2014-03-15 01:12:59.000000', 'consum', 0.0213, 'lps'),
	(598525, 131, '2014-03-15 01:13:00.000000', 'consum', 0.0210, 'lps'),
	(598526, 131, '2014-03-15 01:13:01.000000', 'consum', 0.0232, 'lps'),
	(598527, 131, '2014-03-15 01:13:02.000000', 'consum', 0.0233, 'lps'),
	(598528, 131, '2014-03-15 01:13:03.000000', 'consum', 0.0234, 'lps'),
	(598529, 131, '2014-03-15 01:13:04.000000', 'consum', 0.0231, 'lps'),
	(598530, 131, '2014-03-15 01:13:05.000000', 'consum', 0.0219, 'lps'),
	(598531, 131, '2014-03-15 01:13:06.000000', 'consum', 0.0217, 'lps'),
	(598532, 131, '2014-03-15 01:13:07.000000', 'consum', 0.0219, 'lps'),
	(598533, 131, '2014-03-15 01:13:08.000000', 'consum', 0.0235, 'lps'),
	(598534, 131, '2014-03-15 01:13:09.000000', 'consum', 0.0225, 'lps'),
	(598535, 131, '2014-03-15 01:13:10.000000', 'consum', 0.0236, 'lps'),
	(598536, 131, '2014-03-15 01:13:11.000000', 'consum', 0.0214, 'lps'),
	(598537, 131, '2014-03-15 01:13:12.000000', 'consum', 0.0236, 'lps'),
	(598538, 131, '2014-03-15 01:13:13.000000', 'consum', 0.0215, 'lps'),
	(598539, 131, '2014-03-15 01:13:14.000000', 'consum', 0.0213, 'lps'),
	(598540, 131, '2014-03-15 01:13:15.000000', 'consum', 0.0213, 'lps'),
	(598541, 131, '2014-03-15 01:13:16.000000', 'consum', 0.0214, 'lps'),
	(598542, 131, '2014-03-15 01:13:17.000000', 'consum', 0.0221, 'lps'),
	(598543, 131, '2014-03-15 01:13:18.000000', 'consum', 0.0227, 'lps'),
	(598544, 131, '2014-03-15 01:13:19.000000', 'consum', 0.0234, 'lps'),
	(598545, 131, '2014-03-15 01:13:20.000000', 'consum', 0.0224, 'lps'),
	(598546, 131, '2014-03-15 01:13:21.000000', 'consum', 0.0237, 'lps'),
	(598547, 131, '2014-03-15 01:13:22.000000', 'consum', 0.0221, 'lps'),
	(598548, 131, '2014-03-15 01:13:23.000000', 'consum', 0.0211, 'lps'),
	(598549, 131, '2014-03-15 01:13:24.000000', 'consum', 0.0212, 'lps'),
	(598550, 131, '2014-03-15 01:13:25.000000', 'consum', 0.0218, 'lps'),
	(598551, 131, '2014-03-15 01:13:26.000000', 'consum', 0.0216, 'lps'),
	(598552, 131, '2014-03-15 01:13:27.000000', 'consum', 0.0217, 'lps'),
	(598553, 131, '2014-03-15 01:13:28.000000', 'consum', 0.0229, 'lps'),
	(598554, 131, '2014-03-15 01:13:29.000000', 'consum', 0.0226, 'lps'),
	(598555, 131, '2014-03-15 01:13:30.000000', 'consum', 0.0235, 'lps'),
	(598556, 131, '2014-03-15 01:13:31.000000', 'consum', 0.0231, 'lps'),
	(598557, 131, '2014-03-15 01:13:32.000000', 'consum', 0.0215, 'lps'),
	(598558, 131, '2014-03-15 01:13:33.000000', 'consum', 0.0225, 'lps'),
	(598559, 131, '2014-03-15 01:13:34.000000', 'consum', 0.0215, 'lps'),
	(598560, 131, '2014-03-15 01:13:35.000000', 'consum', 0.0220, 'lps'),
	(598561, 131, '2014-03-15 01:13:36.000000', 'consum', 0.0217, 'lps'),
	(598562, 131, '2014-03-15 01:13:37.000000', 'consum', 0.0217, 'lps'),
	(598563, 131, '2014-03-15 01:13:38.000000', 'consum', 0.0224, 'lps'),
	(598564, 131, '2014-03-15 01:13:39.000000', 'consum', 0.0229, 'lps'),
	(598565, 131, '2014-03-15 01:13:40.000000', 'consum', 0.0210, 'lps'),
	(598566, 131, '2014-03-15 01:13:41.000000', 'consum', 0.0210, 'lps'),
	(598567, 131, '2014-03-15 01:13:42.000000', 'consum', 0.0237, 'lps'),
	(598568, 131, '2014-03-15 01:13:43.000000', 'consum', 0.0233, 'lps'),
	(598569, 131, '2014-03-15 01:13:44.000000', 'consum', 0.0217, 'lps'),
	(598570, 131, '2014-03-15 01:13:45.000000', 'consum', 0.0232, 'lps'),
	(598571, 131, '2014-03-15 01:13:46.000000', 'consum', 0.0216, 'lps'),
	(598572, 131, '2014-03-15 01:13:47.000000', 'consum', 0.0232, 'lps'),
	(598573, 131, '2014-03-15 01:13:48.000000', 'consum', 0.0219, 'lps'),
	(598574, 131, '2014-03-15 01:13:49.000000', 'consum', 0.0215, 'lps'),
	(598575, 131, '2014-03-15 01:13:50.000000', 'consum', 0.0237, 'lps'),
	(598576, 131, '2014-03-15 01:13:51.000000', 'consum', 0.0217, 'lps'),
	(598577, 131, '2014-03-15 01:13:52.000000', 'consum', 0.0224, 'lps'),
	(598578, 131, '2014-03-15 01:13:53.000000', 'consum', 0.0228, 'lps'),
	(598579, 131, '2014-03-15 01:13:54.000000', 'consum', 0.0232, 'lps'),
	(598580, 131, '2014-03-15 01:13:55.000000', 'consum', 0.0211, 'lps'),
	(598581, 131, '2014-03-15 01:13:56.000000', 'consum', 0.0234, 'lps'),
	(598582, 131, '2014-03-15 01:13:57.000000', 'consum', 0.0216, 'lps'),
	(598583, 131, '2014-03-15 01:13:58.000000', 'consum', 0.0222, 'lps'),
	(598584, 131, '2014-03-15 01:13:59.000000', 'consum', 0.0227, 'lps'),
	(598585, 131, '2014-03-15 01:14:00.000000', 'consum', 0.0231, 'lps'),
	(598586, 131, '2014-03-15 01:14:01.000000', 'consum', 0.0234, 'lps'),
	(598587, 131, '2014-03-15 01:14:02.000000', 'consum', 0.0215, 'lps'),
	(598588, 131, '2014-03-15 01:14:03.000000', 'consum', 0.0218, 'lps'),
	(598589, 131, '2014-03-15 01:14:04.000000', 'consum', 0.0235, 'lps'),
	(598590, 131, '2014-03-15 01:14:05.000000', 'consum', 0.0229, 'lps'),
	(598591, 131, '2014-03-15 01:14:06.000000', 'consum', 0.0230, 'lps'),
	(598592, 131, '2014-03-15 01:14:07.000000', 'consum', 0.0224, 'lps'),
	(598593, 131, '2014-03-15 01:14:08.000000', 'consum', 0.0223, 'lps'),
	(598594, 131, '2014-03-15 01:14:09.000000', 'consum', 0.0231, 'lps'),
	(598595, 131, '2014-03-15 01:14:10.000000', 'consum', 0.0221, 'lps'),
	(598596, 131, '2014-03-15 01:14:11.000000', 'consum', 0.0233, 'lps'),
	(598597, 131, '2014-03-15 01:14:12.000000', 'consum', 0.0235, 'lps'),
	(598598, 131, '2014-03-15 01:14:13.000000', 'consum', 0.0210, 'lps'),
	(598599, 131, '2014-03-15 01:14:14.000000', 'consum', 0.0218, 'lps'),
	(598600, 131, '2014-03-15 01:14:15.000000', 'consum', 0.0223, 'lps'),
	(598601, 131, '2014-03-15 01:14:16.000000', 'consum', 0.0226, 'lps'),
	(598602, 131, '2014-03-15 01:14:17.000000', 'consum', 0.0222, 'lps'),
	(598603, 131, '2014-03-15 01:14:18.000000', 'consum', 0.0223, 'lps'),
	(598604, 131, '2014-03-15 01:14:19.000000', 'consum', 0.0210, 'lps'),
	(598605, 131, '2014-03-15 01:14:20.000000', 'consum', 0.0227, 'lps'),
	(598606, 131, '2014-03-15 01:14:21.000000', 'consum', 0.0214, 'lps'),
	(598607, 131, '2014-03-15 01:14:22.000000', 'consum', 0.0234, 'lps'),
	(598608, 131, '2014-03-15 01:14:23.000000', 'consum', 0.0234, 'lps'),
	(598609, 131, '2014-03-15 01:14:24.000000', 'consum', 0.0233, 'lps'),
	(598610, 131, '2014-03-15 01:14:25.000000', 'consum', 0.0224, 'lps'),
	(598611, 131, '2014-03-15 01:14:26.000000', 'consum', 0.0210, 'lps'),
	(598612, 131, '2014-03-15 01:14:27.000000', 'consum', 0.0224, 'lps'),
	(598613, 131, '2014-03-15 01:14:28.000000', 'consum', 0.0224, 'lps'),
	(598614, 131, '2014-03-15 01:14:29.000000', 'consum', 0.0211, 'lps'),
	(598615, 131, '2014-03-15 01:14:30.000000', 'consum', 0.0230, 'lps'),
	(598616, 131, '2014-03-15 01:14:31.000000', 'consum', 0.0223, 'lps'),
	(598617, 131, '2014-03-15 01:14:32.000000', 'consum', 0.0218, 'lps'),
	(598618, 131, '2014-03-15 01:14:33.000000', 'consum', 0.0237, 'lps'),
	(598619, 131, '2014-03-15 01:14:34.000000', 'consum', 0.0211, 'lps'),
	(598620, 131, '2014-03-15 01:14:35.000000', 'consum', 0.0219, 'lps'),
	(598621, 131, '2014-03-15 01:14:36.000000', 'consum', 0.0223, 'lps'),
	(598622, 131, '2014-03-15 01:14:37.000000', 'consum', 0.0222, 'lps'),
	(598623, 131, '2014-03-15 01:14:38.000000', 'consum', 0.0229, 'lps'),
	(598624, 131, '2014-03-15 01:14:39.000000', 'consum', 0.0214, 'lps'),
	(598625, 131, '2014-03-15 01:14:40.000000', 'consum', 0.0229, 'lps'),
	(598626, 131, '2014-03-15 01:14:41.000000', 'consum', 0.0212, 'lps'),
	(598627, 131, '2014-03-15 01:14:42.000000', 'consum', 0.0219, 'lps'),
	(598628, 131, '2014-03-15 01:14:43.000000', 'consum', 0.0219, 'lps'),
	(598629, 131, '2014-03-15 01:14:44.000000', 'consum', 0.0231, 'lps'),
	(598630, 131, '2014-03-15 01:14:45.000000', 'consum', 0.0233, 'lps'),
	(598631, 131, '2014-03-15 01:14:46.000000', 'consum', 0.0235, 'lps'),
	(598632, 131, '2014-03-15 01:14:47.000000', 'consum', 0.0236, 'lps'),
	(598633, 131, '2014-03-15 01:14:48.000000', 'consum', 0.0212, 'lps'),
	(598634, 131, '2014-03-15 01:14:49.000000', 'consum', 0.0224, 'lps'),
	(598635, 131, '2014-03-15 01:14:50.000000', 'consum', 0.0221, 'lps'),
	(598636, 131, '2014-03-15 01:14:51.000000', 'consum', 0.0224, 'lps'),
	(598637, 131, '2014-03-15 01:14:52.000000', 'consum', 0.0219, 'lps'),
	(598638, 131, '2014-03-15 01:14:53.000000', 'consum', 0.0212, 'lps'),
	(598639, 131, '2014-03-15 01:14:54.000000', 'consum', 0.0224, 'lps'),
	(598640, 131, '2014-03-15 01:14:55.000000', 'consum', 0.0217, 'lps'),
	(598641, 131, '2014-03-15 01:14:56.000000', 'consum', 0.0233, 'lps'),
	(598642, 131, '2014-03-15 01:14:57.000000', 'consum', 0.0221, 'lps'),
	(598643, 131, '2014-03-15 01:14:58.000000', 'consum', 0.0225, 'lps'),
	(598644, 131, '2014-03-15 01:14:59.000000', 'consum', 0.0225, 'lps'),
	(598645, 131, '2014-03-15 01:15:00.000000', 'consum', 0.0210, 'lps'),
	(598646, 131, '2014-03-15 01:15:01.000000', 'consum', 0.0224, 'lps'),
	(598647, 131, '2014-03-15 01:15:02.000000', 'consum', 0.0226, 'lps'),
	(598648, 131, '2014-03-15 01:15:03.000000', 'consum', 0.0217, 'lps'),
	(598649, 131, '2014-03-15 01:15:04.000000', 'consum', 0.0227, 'lps'),
	(598650, 131, '2014-03-15 01:15:05.000000', 'consum', 0.0217, 'lps'),
	(598651, 131, '2014-03-15 01:15:06.000000', 'consum', 0.0223, 'lps'),
	(598652, 131, '2014-03-15 01:15:07.000000', 'consum', 0.0227, 'lps'),
	(598653, 131, '2014-03-15 01:15:08.000000', 'consum', 0.0230, 'lps'),
	(598654, 131, '2014-03-15 01:15:09.000000', 'consum', 0.0230, 'lps'),
	(598655, 131, '2014-03-15 01:15:10.000000', 'consum', 0.0222, 'lps'),
	(598656, 131, '2014-03-15 01:15:11.000000', 'consum', 0.0212, 'lps'),
	(598657, 131, '2014-03-15 01:15:12.000000', 'consum', 0.0210, 'lps'),
	(598658, 131, '2014-03-15 01:15:13.000000', 'consum', 0.0234, 'lps'),
	(598659, 131, '2014-03-15 01:15:14.000000', 'consum', 0.0218, 'lps'),
	(598660, 131, '2014-03-15 01:15:15.000000', 'consum', 0.0235, 'lps'),
	(598661, 131, '2014-03-15 01:15:16.000000', 'consum', 0.0226, 'lps'),
	(598662, 131, '2014-03-15 01:15:17.000000', 'consum', 0.0217, 'lps'),
	(598663, 131, '2014-03-15 01:15:18.000000', 'consum', 0.0226, 'lps'),
	(598664, 131, '2014-03-15 01:15:19.000000', 'consum', 0.0214, 'lps'),
	(598665, 131, '2014-03-15 01:15:20.000000', 'consum', 0.0237, 'lps'),
	(598666, 131, '2014-03-15 01:15:21.000000', 'consum', 0.0223, 'lps'),
	(598667, 131, '2014-03-15 01:15:22.000000', 'consum', 0.0223, 'lps'),
	(598668, 131, '2014-03-15 01:15:23.000000', 'consum', 0.0235, 'lps'),
	(598669, 131, '2014-03-15 01:15:24.000000', 'consum', 0.0214, 'lps'),
	(598670, 131, '2014-03-15 01:15:25.000000', 'consum', 0.0212, 'lps'),
	(598671, 131, '2014-03-15 01:15:26.000000', 'consum', 0.0234, 'lps'),
	(598672, 131, '2014-03-15 01:15:27.000000', 'consum', 0.0214, 'lps'),
	(598673, 131, '2014-03-15 01:15:28.000000', 'consum', 0.0213, 'lps'),
	(598674, 131, '2014-03-15 01:15:29.000000', 'consum', 0.0216, 'lps'),
	(598675, 131, '2014-03-15 01:15:30.000000', 'consum', 0.0230, 'lps'),
	(598676, 131, '2014-03-15 01:15:31.000000', 'consum', 0.0236, 'lps'),
	(598677, 131, '2014-03-15 01:15:32.000000', 'consum', 0.0224, 'lps'),
	(598678, 131, '2014-03-15 01:15:33.000000', 'consum', 0.0233, 'lps'),
	(598679, 131, '2014-03-15 01:15:34.000000', 'consum', 0.0224, 'lps'),
	(598680, 131, '2014-03-15 01:15:35.000000', 'consum', 0.0215, 'lps'),
	(598681, 131, '2014-03-15 01:15:36.000000', 'consum', 0.0221, 'lps'),
	(598682, 131, '2014-03-15 01:15:37.000000', 'consum', 0.0222, 'lps'),
	(598683, 131, '2014-03-15 01:15:38.000000', 'consum', 0.0236, 'lps'),
	(598684, 131, '2014-03-15 01:15:39.000000', 'consum', 0.0222, 'lps'),
	(598685, 131, '2014-03-15 01:15:40.000000', 'consum', 0.0222, 'lps'),
	(598686, 131, '2014-03-15 01:15:41.000000', 'consum', 0.0231, 'lps'),
	(598687, 131, '2014-03-15 01:15:42.000000', 'consum', 0.0226, 'lps'),
	(598688, 131, '2014-03-15 01:15:43.000000', 'consum', 0.0227, 'lps'),
	(598689, 131, '2014-03-15 01:15:44.000000', 'consum', 0.0218, 'lps'),
	(598690, 131, '2014-03-15 01:15:45.000000', 'consum', 0.0230, 'lps'),
	(598691, 131, '2014-03-15 01:15:46.000000', 'consum', 0.0227, 'lps'),
	(598692, 131, '2014-03-15 01:15:47.000000', 'consum', 0.0211, 'lps'),
	(598693, 131, '2014-03-15 01:15:48.000000', 'consum', 0.0219, 'lps'),
	(598694, 131, '2014-03-15 01:15:49.000000', 'consum', 0.0224, 'lps'),
	(598695, 131, '2014-03-15 01:15:50.000000', 'consum', 0.0226, 'lps'),
	(598696, 131, '2014-03-15 01:15:51.000000', 'consum', 0.0219, 'lps'),
	(598697, 131, '2014-03-15 01:15:52.000000', 'consum', 0.0235, 'lps'),
	(598698, 131, '2014-03-15 01:15:53.000000', 'consum', 0.0227, 'lps'),
	(598699, 131, '2014-03-15 01:15:54.000000', 'consum', 0.0218, 'lps'),
	(598700, 131, '2014-03-15 01:15:55.000000', 'consum', 0.0228, 'lps'),
	(598701, 131, '2014-03-15 01:15:56.000000', 'consum', 0.0220, 'lps'),
	(598702, 131, '2014-03-15 01:15:57.000000', 'consum', 0.0236, 'lps'),
	(598703, 131, '2014-03-15 01:15:58.000000', 'consum', 0.0225, 'lps'),
	(598704, 131, '2014-03-15 01:15:59.000000', 'consum', 0.0237, 'lps'),
	(598705, 131, '2014-03-15 01:16:00.000000', 'consum', 0.0217, 'lps'),
	(598706, 131, '2014-03-15 01:16:01.000000', 'consum', 0.0221, 'lps'),
	(598707, 131, '2014-03-15 01:16:02.000000', 'consum', 0.0217, 'lps'),
	(598708, 131, '2014-03-15 01:16:03.000000', 'consum', 0.0210, 'lps'),
	(598709, 131, '2014-03-15 01:16:04.000000', 'consum', 0.0220, 'lps'),
	(598710, 131, '2014-03-15 01:16:05.000000', 'consum', 0.0233, 'lps'),
	(598711, 131, '2014-03-15 01:16:06.000000', 'consum', 0.0210, 'lps'),
	(598712, 131, '2014-03-15 01:16:07.000000', 'consum', 0.0227, 'lps'),
	(598713, 131, '2014-03-15 01:16:08.000000', 'consum', 0.0237, 'lps'),
	(598714, 131, '2014-03-15 01:16:09.000000', 'consum', 0.0212, 'lps'),
	(598715, 131, '2014-03-15 01:16:10.000000', 'consum', 0.0224, 'lps'),
	(598716, 131, '2014-03-15 01:16:11.000000', 'consum', 0.0218, 'lps'),
	(598717, 131, '2014-03-15 01:16:12.000000', 'consum', 0.0237, 'lps'),
	(598718, 131, '2014-03-15 01:16:13.000000', 'consum', 0.0210, 'lps'),
	(598719, 131, '2014-03-15 01:16:14.000000', 'consum', 0.0215, 'lps'),
	(598720, 131, '2014-03-15 01:16:15.000000', 'consum', 0.0233, 'lps'),
	(598721, 131, '2014-03-15 01:16:16.000000', 'consum', 0.0227, 'lps'),
	(598722, 131, '2014-03-15 01:16:17.000000', 'consum', 0.0227, 'lps'),
	(598723, 131, '2014-03-15 01:16:18.000000', 'consum', 0.0218, 'lps'),
	(598724, 131, '2014-03-15 01:16:19.000000', 'consum', 0.0227, 'lps'),
	(598725, 131, '2014-03-15 01:16:20.000000', 'consum', 0.0215, 'lps'),
	(598726, 131, '2014-03-15 01:16:21.000000', 'consum', 0.0210, 'lps'),
	(598727, 131, '2014-03-15 01:16:22.000000', 'consum', 0.0227, 'lps'),
	(598728, 131, '2014-03-15 01:16:23.000000', 'consum', 0.0211, 'lps'),
	(598729, 131, '2014-03-15 01:16:24.000000', 'consum', 0.0222, 'lps'),
	(598730, 131, '2014-03-15 01:16:25.000000', 'consum', 0.0210, 'lps'),
	(598731, 131, '2014-03-15 01:16:26.000000', 'consum', 0.0232, 'lps'),
	(598732, 131, '2014-03-15 01:16:27.000000', 'consum', 0.0233, 'lps'),
	(598733, 131, '2014-03-15 01:16:28.000000', 'consum', 0.0235, 'lps'),
	(598734, 131, '2014-03-15 01:16:29.000000', 'consum', 0.0211, 'lps'),
	(598735, 131, '2014-03-15 01:16:30.000000', 'consum', 0.0222, 'lps'),
	(598736, 131, '2014-03-15 01:16:31.000000', 'consum', 0.0214, 'lps'),
	(598737, 131, '2014-03-15 01:16:32.000000', 'consum', 0.0222, 'lps'),
	(598738, 131, '2014-03-15 01:16:33.000000', 'consum', 0.0231, 'lps'),
	(598739, 131, '2014-03-15 01:16:34.000000', 'consum', 0.0221, 'lps'),
	(598740, 131, '2014-03-15 01:16:35.000000', 'consum', 0.0232, 'lps'),
	(598741, 131, '2014-03-15 01:16:36.000000', 'consum', 0.0232, 'lps'),
	(598742, 131, '2014-03-15 01:16:37.000000', 'consum', 0.0226, 'lps'),
	(598743, 131, '2014-03-15 01:16:38.000000', 'consum', 0.0226, 'lps'),
	(598744, 131, '2014-03-15 01:16:39.000000', 'consum', 0.0213, 'lps'),
	(598745, 131, '2014-03-15 01:16:40.000000', 'consum', 0.0235, 'lps'),
	(598746, 131, '2014-03-15 01:16:41.000000', 'consum', 0.0214, 'lps'),
	(598747, 131, '2014-03-15 01:16:42.000000', 'consum', 0.0211, 'lps'),
	(598748, 131, '2014-03-15 01:16:43.000000', 'consum', 0.0233, 'lps'),
	(598749, 131, '2014-03-15 01:16:44.000000', 'consum', 0.0237, 'lps'),
	(598750, 131, '2014-03-15 01:16:45.000000', 'consum', 0.0219, 'lps'),
	(598751, 131, '2014-03-15 01:16:46.000000', 'consum', 0.0233, 'lps'),
	(598752, 131, '2014-03-15 01:16:47.000000', 'consum', 0.0213, 'lps'),
	(598753, 131, '2014-03-15 01:16:48.000000', 'consum', 0.0212, 'lps'),
	(598754, 131, '2014-03-15 01:16:49.000000', 'consum', 0.0213, 'lps'),
	(598755, 131, '2014-03-15 01:16:50.000000', 'consum', 0.0218, 'lps'),
	(598756, 131, '2014-03-15 01:16:51.000000', 'consum', 0.0212, 'lps'),
	(598757, 131, '2014-03-15 01:16:52.000000', 'consum', 0.0226, 'lps'),
	(598758, 131, '2014-03-15 01:16:53.000000', 'consum', 0.0230, 'lps'),
	(598759, 131, '2014-03-15 01:16:54.000000', 'consum', 0.0232, 'lps'),
	(598760, 131, '2014-03-15 01:16:55.000000', 'consum', 0.0233, 'lps'),
	(598761, 131, '2014-03-15 01:16:56.000000', 'consum', 0.0230, 'lps'),
	(598762, 131, '2014-03-15 01:16:57.000000', 'consum', 0.0214, 'lps'),
	(598763, 131, '2014-03-15 01:16:58.000000', 'consum', 0.0227, 'lps'),
	(598764, 131, '2014-03-15 01:16:59.000000', 'consum', 0.0226, 'lps'),
	(598765, 131, '2014-03-15 01:17:00.000000', 'consum', 0.0213, 'lps'),
	(598766, 131, '2014-03-15 01:17:01.000000', 'consum', 0.0234, 'lps'),
	(598767, 131, '2014-03-15 01:17:02.000000', 'consum', 0.0235, 'lps'),
	(598768, 131, '2014-03-15 01:17:03.000000', 'consum', 0.0237, 'lps'),
	(598769, 131, '2014-03-15 01:17:04.000000', 'consum', 0.0214, 'lps'),
	(598770, 131, '2014-03-15 01:17:05.000000', 'consum', 0.0235, 'lps'),
	(598771, 131, '2014-03-15 01:17:06.000000', 'consum', 0.0237, 'lps'),
	(598772, 131, '2014-03-15 01:17:07.000000', 'consum', 0.0215, 'lps'),
	(598773, 131, '2014-03-15 01:17:08.000000', 'consum', 0.0210, 'lps'),
	(598774, 131, '2014-03-15 01:17:09.000000', 'consum', 0.0225, 'lps'),
	(598775, 131, '2014-03-15 01:17:10.000000', 'consum', 0.0227, 'lps'),
	(598776, 131, '2014-03-15 01:17:11.000000', 'consum', 0.0225, 'lps'),
	(598777, 131, '2014-03-15 01:17:12.000000', 'consum', 0.0233, 'lps'),
	(598778, 131, '2014-03-15 01:17:13.000000', 'consum', 0.0224, 'lps'),
	(598779, 131, '2014-03-15 01:17:14.000000', 'consum', 0.0210, 'lps'),
	(598780, 131, '2014-03-15 01:17:15.000000', 'consum', 0.0228, 'lps'),
	(598781, 131, '2014-03-15 01:17:16.000000', 'consum', 0.0214, 'lps'),
	(598782, 131, '2014-03-15 01:17:17.000000', 'consum', 0.0232, 'lps'),
	(598783, 131, '2014-03-15 01:17:18.000000', 'consum', 0.0227, 'lps'),
	(598784, 131, '2014-03-15 01:17:19.000000', 'consum', 0.0230, 'lps'),
	(598785, 131, '2014-03-15 01:17:20.000000', 'consum', 0.0231, 'lps'),
	(598786, 131, '2014-03-15 01:17:21.000000', 'consum', 0.0226, 'lps'),
	(598787, 131, '2014-03-15 01:17:22.000000', 'consum', 0.0229, 'lps'),
	(598788, 131, '2014-03-15 01:17:23.000000', 'consum', 0.0228, 'lps'),
	(598789, 131, '2014-03-15 01:17:24.000000', 'consum', 0.0215, 'lps'),
	(598790, 131, '2014-03-15 01:17:25.000000', 'consum', 0.0236, 'lps'),
	(598791, 131, '2014-03-15 01:17:26.000000', 'consum', 0.0217, 'lps'),
	(598792, 131, '2014-03-15 01:17:27.000000', 'consum', 0.0221, 'lps'),
	(598793, 131, '2014-03-15 01:17:28.000000', 'consum', 0.0215, 'lps'),
	(598794, 131, '2014-03-15 01:17:29.000000', 'consum', 0.0233, 'lps'),
	(598795, 131, '2014-03-15 01:17:30.000000', 'consum', 0.0226, 'lps'),
	(598796, 131, '2014-03-15 01:17:31.000000', 'consum', 0.0223, 'lps'),
	(598797, 131, '2014-03-15 01:17:32.000000', 'consum', 0.0228, 'lps'),
	(598798, 131, '2014-03-15 01:17:33.000000', 'consum', 0.0232, 'lps'),
	(598799, 131, '2014-03-15 01:17:34.000000', 'consum', 0.0211, 'lps'),
	(598800, 131, '2014-03-15 01:17:35.000000', 'consum', 0.0235, 'lps'),
	(598801, 131, '2014-03-15 01:17:36.000000', 'consum', 0.0217, 'lps'),
	(598802, 131, '2014-03-15 01:17:37.000000', 'consum', 0.0230, 'lps'),
	(598803, 131, '2014-03-15 01:17:38.000000', 'consum', 0.0230, 'lps'),
	(598804, 131, '2014-03-15 01:17:39.000000', 'consum', 0.0225, 'lps'),
	(598805, 131, '2014-03-15 01:17:40.000000', 'consum', 0.0224, 'lps'),
	(598806, 131, '2014-03-15 01:17:41.000000', 'consum', 0.0236, 'lps'),
	(598807, 131, '2014-03-15 01:17:42.000000', 'consum', 0.0213, 'lps'),
	(598808, 131, '2014-03-15 01:17:43.000000', 'consum', 0.0231, 'lps'),
	(598809, 131, '2014-03-15 01:17:44.000000', 'consum', 0.0225, 'lps'),
	(598810, 131, '2014-03-15 01:17:45.000000', 'consum', 0.0223, 'lps'),
	(598811, 131, '2014-03-15 01:17:46.000000', 'consum', 0.0229, 'lps'),
	(598812, 131, '2014-03-15 01:17:47.000000', 'consum', 0.0213, 'lps'),
	(598813, 131, '2014-03-15 01:17:48.000000', 'consum', 0.0223, 'lps'),
	(598814, 131, '2014-03-15 01:17:49.000000', 'consum', 0.0237, 'lps'),
	(598815, 131, '2014-03-15 01:17:50.000000', 'consum', 0.0221, 'lps'),
	(598816, 131, '2014-03-15 01:17:51.000000', 'consum', 0.0216, 'lps'),
	(598817, 131, '2014-03-15 01:17:52.000000', 'consum', 0.0235, 'lps'),
	(598818, 131, '2014-03-15 01:17:53.000000', 'consum', 0.0232, 'lps'),
	(598819, 131, '2014-03-15 01:17:54.000000', 'consum', 0.0217, 'lps'),
	(598820, 131, '2014-03-15 01:17:55.000000', 'consum', 0.0235, 'lps'),
	(598821, 131, '2014-03-15 01:17:56.000000', 'consum', 0.0232, 'lps'),
	(598822, 131, '2014-03-15 01:17:57.000000', 'consum', 0.0219, 'lps'),
	(598823, 131, '2014-03-15 01:17:58.000000', 'consum', 0.0217, 'lps'),
	(598824, 131, '2014-03-15 01:17:59.000000', 'consum', 0.0219, 'lps'),
	(598825, 131, '2014-03-15 01:18:00.000000', 'consum', 0.0234, 'lps'),
	(598826, 131, '2014-03-15 01:18:01.000000', 'consum', 0.0218, 'lps'),
	(598827, 131, '2014-03-15 01:18:02.000000', 'consum', 0.0237, 'lps'),
	(598828, 131, '2014-03-15 01:18:03.000000', 'consum', 0.0235, 'lps'),
	(598829, 131, '2014-03-15 01:18:04.000000', 'consum', 0.0228, 'lps'),
	(598830, 131, '2014-03-15 01:18:05.000000', 'consum', 0.0223, 'lps'),
	(598831, 131, '2014-03-15 01:18:06.000000', 'consum', 0.0225, 'lps'),
	(598832, 131, '2014-03-15 01:18:07.000000', 'consum', 0.0217, 'lps'),
	(598833, 131, '2014-03-15 01:18:08.000000', 'consum', 0.0227, 'lps'),
	(598834, 131, '2014-03-15 01:18:09.000000', 'consum', 0.0219, 'lps'),
	(598835, 131, '2014-03-15 01:18:10.000000', 'consum', 0.0233, 'lps'),
	(598836, 131, '2014-03-15 01:18:11.000000', 'consum', 0.0214, 'lps'),
	(598837, 131, '2014-03-15 01:18:12.000000', 'consum', 0.0218, 'lps'),
	(598838, 131, '2014-03-15 01:18:13.000000', 'consum', 0.0237, 'lps'),
	(598839, 131, '2014-03-15 01:18:14.000000', 'consum', 0.0211, 'lps'),
	(598840, 131, '2014-03-15 01:18:15.000000', 'consum', 0.0218, 'lps'),
	(598841, 131, '2014-03-15 01:18:16.000000', 'consum', 0.0219, 'lps'),
	(598842, 131, '2014-03-15 01:18:17.000000', 'consum', 0.0230, 'lps'),
	(598843, 131, '2014-03-15 01:18:18.000000', 'consum', 0.0231, 'lps'),
	(598844, 131, '2014-03-15 01:18:19.000000', 'consum', 0.0225, 'lps'),
	(598845, 131, '2014-03-15 01:18:20.000000', 'consum', 0.0223, 'lps'),
	(598846, 131, '2014-03-15 01:18:21.000000', 'consum', 0.0230, 'lps'),
	(598847, 131, '2014-03-15 01:18:22.000000', 'consum', 0.0218, 'lps'),
	(598848, 131, '2014-03-15 01:18:23.000000', 'consum', 0.0217, 'lps'),
	(598849, 131, '2014-03-15 01:18:24.000000', 'consum', 0.0220, 'lps'),
	(598850, 131, '2014-03-15 01:18:25.000000', 'consum', 0.0211, 'lps'),
	(598851, 131, '2014-03-15 01:18:26.000000', 'consum', 0.0216, 'lps'),
	(598852, 131, '2014-03-15 01:18:27.000000', 'consum', 0.0210, 'lps'),
	(598853, 131, '2014-03-15 01:18:28.000000', 'consum', 0.0220, 'lps'),
	(598854, 131, '2014-03-15 01:18:29.000000', 'consum', 0.0233, 'lps'),
	(598855, 131, '2014-03-15 01:18:30.000000', 'consum', 0.0210, 'lps'),
	(598856, 131, '2014-03-15 01:18:31.000000', 'consum', 0.0226, 'lps'),
	(598857, 131, '2014-03-15 01:18:32.000000', 'consum', 0.0236, 'lps'),
	(598858, 131, '2014-03-15 01:18:33.000000', 'consum', 0.0237, 'lps'),
	(598859, 131, '2014-03-15 01:18:34.000000', 'consum', 0.0210, 'lps'),
	(598860, 131, '2014-03-15 01:18:35.000000', 'consum', 0.0213, 'lps'),
	(598861, 131, '2014-03-15 01:18:36.000000', 'consum', 0.0226, 'lps'),
	(598862, 131, '2014-03-15 01:18:37.000000', 'consum', 0.0226, 'lps'),
	(598863, 131, '2014-03-15 01:18:38.000000', 'consum', 0.0213, 'lps'),
	(598864, 131, '2014-03-15 01:18:39.000000', 'consum', 0.0235, 'lps'),
	(598865, 131, '2014-03-15 01:18:40.000000', 'consum', 0.0214, 'lps'),
	(598866, 131, '2014-03-15 01:18:41.000000', 'consum', 0.0211, 'lps'),
	(598867, 131, '2014-03-15 01:18:42.000000', 'consum', 0.0232, 'lps'),
	(598868, 131, '2014-03-15 01:18:43.000000', 'consum', 0.0235, 'lps'),
	(598869, 131, '2014-03-15 01:18:44.000000', 'consum', 0.0212, 'lps'),
	(598870, 131, '2014-03-15 01:18:45.000000', 'consum', 0.0228, 'lps'),
	(598871, 131, '2014-03-15 01:18:46.000000', 'consum', 0.0211, 'lps'),
	(598872, 131, '2014-03-15 01:18:47.000000', 'consum', 0.0219, 'lps'),
	(598873, 131, '2014-03-15 01:18:48.000000', 'consum', 0.0225, 'lps'),
	(598874, 131, '2014-03-15 01:18:49.000000', 'consum', 0.0229, 'lps'),
	(598875, 131, '2014-03-15 01:18:50.000000', 'consum', 0.0232, 'lps'),
	(598876, 131, '2014-03-15 01:18:51.000000', 'consum', 0.0236, 'lps'),
	(598877, 131, '2014-03-15 01:18:52.000000', 'consum', 0.0220, 'lps'),
	(598878, 131, '2014-03-15 01:18:53.000000', 'consum', 0.0211, 'lps'),
	(598879, 131, '2014-03-15 01:18:54.000000', 'consum', 0.0214, 'lps'),
	(598880, 131, '2014-03-15 01:18:55.000000', 'consum', 0.0229, 'lps'),
	(598881, 131, '2014-03-15 01:18:56.000000', 'consum', 0.0234, 'lps'),
	(598882, 131, '2014-03-15 01:18:57.000000', 'consum', 0.0218, 'lps'),
	(598883, 131, '2014-03-15 01:18:58.000000', 'consum', 0.0237, 'lps'),
	(598884, 131, '2014-03-15 01:18:59.000000', 'consum', 0.0236, 'lps'),
	(598885, 131, '2014-03-15 01:19:00.000000', 'consum', 0.0231, 'lps'),
	(598886, 131, '2014-03-15 01:19:01.000000', 'consum', 0.0236, 'lps'),
	(598887, 131, '2014-03-15 01:19:02.000000', 'consum', 0.0222, 'lps'),
	(598888, 131, '2014-03-15 01:19:03.000000', 'consum', 0.0220, 'lps'),
	(598889, 131, '2014-03-15 01:19:04.000000', 'consum', 0.0226, 'lps'),
	(598890, 131, '2014-03-15 01:19:05.000000', 'consum', 0.0234, 'lps'),
	(598891, 131, '2014-03-15 01:19:06.000000', 'consum', 0.0223, 'lps'),
	(598892, 131, '2014-03-15 01:19:07.000000', 'consum', 0.0234, 'lps'),
	(598893, 131, '2014-03-15 01:19:08.000000', 'consum', 0.0236, 'lps'),
	(598894, 131, '2014-03-15 01:19:09.000000', 'consum', 0.0213, 'lps'),
	(598895, 131, '2014-03-15 01:19:10.000000', 'consum', 0.0231, 'lps'),
	(598896, 131, '2014-03-15 01:19:11.000000', 'consum', 0.0223, 'lps'),
	(598897, 131, '2014-03-15 01:19:12.000000', 'consum', 0.0211, 'lps'),
	(598898, 131, '2014-03-15 01:19:13.000000', 'consum', 0.0234, 'lps'),
	(598899, 131, '2014-03-15 01:19:14.000000', 'consum', 0.0214, 'lps'),
	(598900, 131, '2014-03-15 01:19:15.000000', 'consum', 0.0216, 'lps'),
	(598901, 131, '2014-03-15 01:19:16.000000', 'consum', 0.0227, 'lps'),
	(598902, 131, '2014-03-15 01:19:17.000000', 'consum', 0.0222, 'lps'),
	(598903, 131, '2014-03-15 01:19:18.000000', 'consum', 0.0221, 'lps'),
	(598904, 131, '2014-03-15 01:19:19.000000', 'consum', 0.0228, 'lps'),
	(598905, 131, '2014-03-15 01:19:20.000000', 'consum', 0.0210, 'lps'),
	(598906, 131, '2014-03-15 01:19:21.000000', 'consum', 0.0215, 'lps'),
	(598907, 131, '2014-03-15 01:19:22.000000', 'consum', 0.0237, 'lps'),
	(598908, 131, '2014-03-15 01:19:23.000000', 'consum', 0.0215, 'lps'),
	(598909, 131, '2014-03-15 01:19:24.000000', 'consum', 0.0212, 'lps'),
	(598910, 131, '2014-03-15 01:19:25.000000', 'consum', 0.0232, 'lps'),
	(598911, 131, '2014-03-15 01:19:26.000000', 'consum', 0.0231, 'lps'),
	(598912, 131, '2014-03-15 01:19:27.000000', 'consum', 0.0221, 'lps'),
	(598913, 131, '2014-03-15 01:19:28.000000', 'consum', 0.0230, 'lps'),
	(598914, 131, '2014-03-15 01:19:29.000000', 'consum', 0.0223, 'lps'),
	(598915, 131, '2014-03-15 01:19:30.000000', 'consum', 0.0215, 'lps'),
	(598916, 131, '2014-03-15 01:19:31.000000', 'consum', 0.0223, 'lps'),
	(598917, 131, '2014-03-15 01:19:32.000000', 'consum', 0.0234, 'lps'),
	(598918, 131, '2014-03-15 01:19:33.000000', 'consum', 0.0237, 'lps'),
	(598919, 131, '2014-03-15 01:19:34.000000', 'consum', 0.0215, 'lps'),
	(598920, 131, '2014-03-15 01:19:35.000000', 'consum', 0.0237, 'lps'),
	(598921, 131, '2014-03-15 01:19:36.000000', 'consum', 0.0222, 'lps'),
	(598922, 131, '2014-03-15 01:19:37.000000', 'consum', 0.0214, 'lps'),
	(598923, 131, '2014-03-15 01:19:38.000000', 'consum', 0.0224, 'lps'),
	(598924, 131, '2014-03-15 01:19:39.000000', 'consum', 0.0214, 'lps'),
	(598925, 131, '2014-03-15 01:19:40.000000', 'consum', 0.0215, 'lps'),
	(598926, 131, '2014-03-15 01:19:41.000000', 'consum', 0.0222, 'lps'),
	(598927, 131, '2014-03-15 01:19:42.000000', 'consum', 0.0229, 'lps'),
	(598928, 131, '2014-03-15 01:19:43.000000', 'consum', 0.0213, 'lps'),
	(598929, 131, '2014-03-15 01:19:44.000000', 'consum', 0.0226, 'lps'),
	(598930, 131, '2014-03-15 01:19:45.000000', 'consum', 0.0224, 'lps'),
	(598931, 131, '2014-03-15 01:19:46.000000', 'consum', 0.0231, 'lps'),
	(598932, 131, '2014-03-15 01:19:47.000000', 'consum', 0.0219, 'lps'),
	(598933, 131, '2014-03-15 01:19:48.000000', 'consum', 0.0219, 'lps'),
	(598934, 131, '2014-03-15 01:19:49.000000', 'consum', 0.0230, 'lps'),
	(598935, 127, '2014-04-01 00:00:00.000000', 'consum', 0.0217, 'lps'),
	(598936, 127, '2014-04-01 00:00:01.000000', 'consum', 0.0213, 'lps'),
	(598937, 127, '2014-04-01 00:00:02.000000', 'consum', 0.0228, 'lps'),
	(598938, 127, '2014-04-01 00:00:03.000000', 'consum', 0.0224, 'lps'),
	(598939, 127, '2014-04-01 00:00:04.000000', 'consum', 0.0229, 'lps'),
	(598940, 127, '2014-04-01 00:00:05.000000', 'consum', 0.0219, 'lps'),
	(598941, 127, '2014-04-01 00:00:06.000000', 'consum', 0.0219, 'lps'),
	(598942, 127, '2014-04-01 00:00:07.000000', 'consum', 0.0227, 'lps'),
	(598943, 127, '2014-04-01 00:00:08.000000', 'consum', 0.0228, 'lps'),
	(598944, 127, '2014-04-01 00:00:09.000000', 'consum', 0.0224, 'lps'),
	(598945, 127, '2014-04-01 00:00:10.000000', 'consum', 0.0229, 'lps'),
	(598946, 127, '2014-04-01 00:00:11.000000', 'consum', 0.0220, 'lps'),
	(598947, 127, '2014-04-01 00:00:12.000000', 'consum', 0.0226, 'lps'),
	(598948, 127, '2014-04-01 00:00:13.000000', 'consum', 0.0216, 'lps'),
	(598949, 127, '2014-04-01 00:00:14.000000', 'consum', 0.0215, 'lps'),
	(598950, 127, '2014-04-01 00:00:15.000000', 'consum', 0.0218, 'lps'),
	(598951, 127, '2014-04-01 00:00:16.000000', 'consum', 0.0214, 'lps'),
	(598952, 127, '2014-04-01 00:00:17.000000', 'consum', 0.0230, 'lps'),
	(598953, 127, '2014-04-01 00:00:18.000000', 'consum', 0.0229, 'lps'),
	(598954, 127, '2014-04-01 00:00:19.000000', 'consum', 0.0226, 'lps'),
	(598955, 127, '2014-04-01 00:00:20.000000', 'consum', 0.0210, 'lps'),
	(598956, 127, '2014-04-01 00:00:21.000000', 'consum', 0.0231, 'lps'),
	(598957, 127, '2014-04-01 00:00:22.000000', 'consum', 0.0225, 'lps'),
	(598958, 127, '2014-04-01 00:00:23.000000', 'consum', 0.0221, 'lps'),
	(598959, 127, '2014-04-01 00:00:24.000000', 'consum', 0.0223, 'lps'),
	(598960, 127, '2014-04-01 00:00:25.000000', 'consum', 0.0221, 'lps'),
	(598961, 127, '2014-04-01 00:00:26.000000', 'consum', 0.0225, 'lps'),
	(598962, 127, '2014-04-01 00:00:27.000000', 'consum', 0.0210, 'lps'),
	(598963, 127, '2014-04-01 00:00:28.000000', 'consum', 0.0231, 'lps'),
	(598964, 127, '2014-04-01 00:00:29.000000', 'consum', 0.0226, 'lps'),
	(598965, 127, '2014-04-01 00:00:30.000000', 'consum', 0.0230, 'lps'),
	(598966, 127, '2014-04-01 00:00:31.000000', 'consum', 0.0217, 'lps'),
	(598967, 127, '2014-04-01 00:00:32.000000', 'consum', 0.0210, 'lps'),
	(598968, 127, '2014-04-01 00:00:33.000000', 'consum', 0.0231, 'lps'),
	(598969, 127, '2014-04-01 00:00:34.000000', 'consum', 0.0228, 'lps'),
	(598970, 127, '2014-04-01 00:00:35.000000', 'consum', 0.0217, 'lps'),
	(598971, 127, '2014-04-01 00:00:36.000000', 'consum', 0.0211, 'lps'),
	(598972, 127, '2014-04-01 00:00:37.000000', 'consum', 0.0216, 'lps'),
	(598973, 127, '2014-04-01 00:00:38.000000', 'consum', 0.0215, 'lps'),
	(598974, 127, '2014-04-01 00:00:39.000000', 'consum', 0.0220, 'lps'),
	(598975, 127, '2014-04-01 00:00:40.000000', 'consum', 0.0222, 'lps'),
	(598976, 127, '2014-04-01 00:00:41.000000', 'consum', 0.0218, 'lps'),
	(598977, 127, '2014-04-01 00:00:42.000000', 'consum', 0.0213, 'lps'),
	(598978, 127, '2014-04-01 00:00:43.000000', 'consum', 0.0226, 'lps'),
	(598979, 127, '2014-04-01 00:00:44.000000', 'consum', 0.0214, 'lps'),
	(598980, 127, '2014-04-01 00:00:45.000000', 'consum', 0.0226, 'lps'),
	(598981, 127, '2014-04-01 00:00:46.000000', 'consum', 0.0211, 'lps'),
	(598982, 127, '2014-04-01 00:00:47.000000', 'consum', 0.0214, 'lps'),
	(598983, 127, '2014-04-01 00:00:48.000000', 'consum', 0.0228, 'lps'),
	(598984, 127, '2014-04-01 00:00:49.000000', 'consum', 0.0223, 'lps'),
	(598985, 127, '2014-04-01 00:00:50.000000', 'consum', 0.0219, 'lps'),
	(598986, 127, '2014-04-01 00:00:51.000000', 'consum', 0.0218, 'lps'),
	(598987, 127, '2014-04-01 00:00:52.000000', 'consum', 0.0222, 'lps'),
	(598988, 127, '2014-04-01 00:00:53.000000', 'consum', 0.0225, 'lps'),
	(598989, 127, '2014-04-01 00:00:54.000000', 'consum', 0.0228, 'lps'),
	(598990, 127, '2014-04-01 00:00:55.000000', 'consum', 0.0211, 'lps'),
	(598991, 127, '2014-04-01 00:00:56.000000', 'consum', 0.0229, 'lps'),
	(598992, 127, '2014-04-01 00:00:57.000000', 'consum', 0.0214, 'lps'),
	(598993, 127, '2014-04-01 00:00:58.000000', 'consum', 0.0219, 'lps'),
	(598994, 127, '2014-04-01 00:00:59.000000', 'consum', 0.0220, 'lps'),
	(598995, 127, '2014-04-01 00:01:00.000000', 'consum', 0.0210, 'lps'),
	(598996, 127, '2014-04-01 00:01:01.000000', 'consum', 0.0227, 'lps'),
	(598997, 127, '2014-04-01 00:01:02.000000', 'consum', 0.0227, 'lps'),
	(598998, 127, '2014-04-01 00:01:03.000000', 'consum', 0.0224, 'lps'),
	(598999, 127, '2014-04-01 00:01:04.000000', 'consum', 0.0228, 'lps'),
	(599000, 127, '2014-04-01 00:01:05.000000', 'consum', 0.0214, 'lps'),
	(599001, 127, '2014-04-01 00:01:06.000000', 'consum', 0.0221, 'lps'),
	(599002, 127, '2014-04-01 00:01:07.000000', 'consum', 0.0211, 'lps'),
	(599003, 127, '2014-04-01 00:01:08.000000', 'consum', 0.0225, 'lps'),
	(599004, 127, '2014-04-01 00:01:09.000000', 'consum', 0.0215, 'lps'),
	(599005, 127, '2014-04-01 00:01:10.000000', 'consum', 0.0215, 'lps'),
	(599006, 127, '2014-04-01 00:01:11.000000', 'consum', 0.0220, 'lps'),
	(599007, 127, '2014-04-01 00:01:12.000000', 'consum', 0.0222, 'lps'),
	(599008, 127, '2014-04-01 00:01:13.000000', 'consum', 0.0218, 'lps'),
	(599009, 127, '2014-04-01 00:01:14.000000', 'consum', 0.0214, 'lps'),
	(599010, 127, '2014-04-01 00:01:15.000000', 'consum', 0.0210, 'lps'),
	(599011, 127, '2014-04-01 00:01:16.000000', 'consum', 0.0217, 'lps'),
	(599012, 127, '2014-04-01 00:01:17.000000', 'consum', 0.0225, 'lps'),
	(599013, 127, '2014-04-01 00:01:18.000000', 'consum', 0.0222, 'lps'),
	(599014, 127, '2014-04-01 00:01:19.000000', 'consum', 0.0223, 'lps'),
	(599015, 127, '2014-04-01 00:01:20.000000', 'consum', 0.0219, 'lps'),
	(599016, 127, '2014-04-01 00:01:21.000000', 'consum', 0.0216, 'lps'),
	(599017, 127, '2014-04-01 00:01:22.000000', 'consum', 0.0215, 'lps'),
	(599018, 127, '2014-04-01 00:01:23.000000', 'consum', 0.0218, 'lps'),
	(599019, 127, '2014-04-01 00:01:24.000000', 'consum', 0.0213, 'lps'),
	(599020, 127, '2014-04-01 00:01:25.000000', 'consum', 0.0224, 'lps'),
	(599021, 127, '2014-04-01 00:01:26.000000', 'consum', 0.0225, 'lps'),
	(599022, 127, '2014-04-01 00:01:27.000000', 'consum', 0.0223, 'lps'),
	(599023, 127, '2014-04-01 00:01:28.000000', 'consum', 0.0210, 'lps'),
	(599024, 127, '2014-04-01 00:01:29.000000', 'consum', 0.0216, 'lps'),
	(599025, 127, '2014-04-01 00:01:30.000000', 'consum', 0.0218, 'lps'),
	(599026, 127, '2014-04-01 00:01:31.000000', 'consum', 0.0230, 'lps'),
	(599027, 127, '2014-04-01 00:01:32.000000', 'consum', 0.0223, 'lps'),
	(599028, 127, '2014-04-01 00:01:33.000000', 'consum', 0.0215, 'lps'),
	(599029, 127, '2014-04-01 00:01:34.000000', 'consum', 0.0217, 'lps'),
	(599030, 127, '2014-04-01 00:01:35.000000', 'consum', 0.0231, 'lps'),
	(599031, 127, '2014-04-01 00:01:36.000000', 'consum', 0.0228, 'lps'),
	(599032, 127, '2014-04-01 00:01:37.000000', 'consum', 0.0218, 'lps'),
	(599033, 127, '2014-04-01 00:01:38.000000', 'consum', 0.0216, 'lps'),
	(599034, 127, '2014-04-01 00:01:39.000000', 'consum', 0.0218, 'lps'),
	(599035, 127, '2014-04-01 00:01:40.000000', 'consum', 0.0210, 'lps'),
	(599036, 127, '2014-04-01 00:01:41.000000', 'consum', 0.0210, 'lps'),
	(599037, 127, '2014-04-01 00:01:42.000000', 'consum', 0.0210, 'lps'),
	(599038, 127, '2014-04-01 00:01:43.000000', 'consum', 0.0231, 'lps'),
	(599039, 127, '2014-04-01 00:01:44.000000', 'consum', 0.0226, 'lps'),
	(599040, 127, '2014-04-01 00:01:45.000000', 'consum', 0.0230, 'lps'),
	(599041, 127, '2014-04-01 00:01:46.000000', 'consum', 0.0219, 'lps'),
	(599042, 127, '2014-04-01 00:01:47.000000', 'consum', 0.0215, 'lps'),
	(599043, 127, '2014-04-01 00:01:48.000000', 'consum', 0.0211, 'lps'),
	(599044, 127, '2014-04-01 00:01:49.000000', 'consum', 0.0220, 'lps'),
	(599045, 127, '2014-04-01 00:01:50.000000', 'consum', 0.0213, 'lps'),
	(599046, 127, '2014-04-01 00:01:51.000000', 'consum', 0.0218, 'lps'),
	(599047, 127, '2014-04-01 00:01:52.000000', 'consum', 0.0220, 'lps'),
	(599048, 127, '2014-04-01 00:01:53.000000', 'consum', 0.0213, 'lps'),
	(599049, 127, '2014-04-01 00:01:54.000000', 'consum', 0.0219, 'lps'),
	(599050, 127, '2014-04-01 00:01:55.000000', 'consum', 0.0225, 'lps'),
	(599051, 127, '2014-04-01 00:01:56.000000', 'consum', 0.0213, 'lps'),
	(599052, 127, '2014-04-01 00:01:57.000000', 'consum', 0.0227, 'lps'),
	(599053, 127, '2014-04-01 00:01:58.000000', 'consum', 0.0217, 'lps'),
	(599054, 127, '2014-04-01 00:01:59.000000', 'consum', 0.0220, 'lps'),
	(599055, 127, '2014-04-01 00:02:00.000000', 'consum', 0.0217, 'lps'),
	(599056, 127, '2014-04-01 00:02:01.000000', 'consum', 0.0213, 'lps'),
	(599057, 127, '2014-04-01 00:02:02.000000', 'consum', 0.0228, 'lps'),
	(599058, 127, '2014-04-01 00:02:03.000000', 'consum', 0.0224, 'lps'),
	(599059, 127, '2014-04-01 00:02:04.000000', 'consum', 0.0228, 'lps'),
	(599060, 127, '2014-04-01 00:02:05.000000', 'consum', 0.0214, 'lps'),
	(599061, 127, '2014-04-01 00:02:06.000000', 'consum', 0.0221, 'lps'),
	(599062, 127, '2014-04-01 00:02:07.000000', 'consum', 0.0210, 'lps'),
	(599063, 127, '2014-04-01 00:02:08.000000', 'consum', 0.0221, 'lps'),
	(599064, 127, '2014-04-01 00:02:09.000000', 'consum', 0.0222, 'lps'),
	(599065, 127, '2014-04-01 00:02:10.000000', 'consum', 0.0213, 'lps'),
	(599066, 127, '2014-04-01 00:02:11.000000', 'consum', 0.0214, 'lps'),
	(599067, 127, '2014-04-01 00:02:12.000000', 'consum', 0.0221, 'lps'),
	(599068, 127, '2014-04-01 00:02:13.000000', 'consum', 0.0211, 'lps'),
	(599069, 127, '2014-04-01 00:02:14.000000', 'consum', 0.0227, 'lps'),
	(599070, 127, '2014-04-01 00:02:15.000000', 'consum', 0.0223, 'lps'),
	(599071, 127, '2014-04-01 00:02:16.000000', 'consum', 0.0227, 'lps'),
	(599072, 127, '2014-04-01 00:02:17.000000', 'consum', 0.0214, 'lps'),
	(599073, 127, '2014-04-01 00:02:18.000000', 'consum', 0.0222, 'lps'),
	(599074, 127, '2014-04-01 00:02:19.000000', 'consum', 0.0213, 'lps'),
	(599075, 127, '2014-04-01 00:02:20.000000', 'consum', 0.0213, 'lps'),
	(599076, 127, '2014-04-01 00:02:21.000000', 'consum', 0.0215, 'lps'),
	(599077, 127, '2014-04-01 00:02:22.000000', 'consum', 0.0226, 'lps'),
	(599078, 127, '2014-04-01 00:02:23.000000', 'consum', 0.0213, 'lps'),
	(599079, 127, '2014-04-01 00:02:24.000000', 'consum', 0.0218, 'lps'),
	(599080, 127, '2014-04-01 00:02:25.000000', 'consum', 0.0219, 'lps'),
	(599081, 127, '2014-04-01 00:02:26.000000', 'consum', 0.0211, 'lps'),
	(599082, 127, '2014-04-01 00:02:27.000000', 'consum', 0.0212, 'lps'),
	(599083, 127, '2014-04-01 00:02:28.000000', 'consum', 0.0218, 'lps'),
	(599084, 127, '2014-04-01 00:02:29.000000', 'consum', 0.0220, 'lps'),
	(599085, 127, '2014-04-01 00:02:30.000000', 'consum', 0.0213, 'lps'),
	(599086, 127, '2014-04-01 00:02:31.000000', 'consum', 0.0221, 'lps'),
	(599087, 127, '2014-04-01 00:02:32.000000', 'consum', 0.0212, 'lps'),
	(599088, 127, '2014-04-01 00:02:33.000000', 'consum', 0.0210, 'lps'),
	(599089, 127, '2014-04-01 00:02:34.000000', 'consum', 0.0227, 'lps'),
	(599090, 127, '2014-04-01 00:02:35.000000', 'consum', 0.0229, 'lps'),
	(599091, 127, '2014-04-01 00:02:36.000000', 'consum', 0.0210, 'lps'),
	(599092, 127, '2014-04-01 00:02:37.000000', 'consum', 0.0219, 'lps'),
	(599093, 127, '2014-04-01 00:02:38.000000', 'consum', 0.0210, 'lps'),
	(599094, 127, '2014-04-01 00:02:39.000000', 'consum', 0.0229, 'lps'),
	(599095, 127, '2014-04-01 00:02:40.000000', 'consum', 0.0219, 'lps'),
	(599096, 127, '2014-04-01 00:02:41.000000', 'consum', 0.0218, 'lps'),
	(599097, 127, '2014-04-01 00:02:42.000000', 'consum', 0.0226, 'lps'),
	(599098, 127, '2014-04-01 00:02:43.000000', 'consum', 0.0221, 'lps'),
	(599099, 127, '2014-04-01 00:02:44.000000', 'consum', 0.0217, 'lps'),
	(599100, 127, '2014-04-01 00:02:45.000000', 'consum', 0.0212, 'lps'),
	(599101, 127, '2014-04-01 00:02:46.000000', 'consum', 0.0221, 'lps'),
	(599102, 127, '2014-04-01 00:02:47.000000', 'consum', 0.0217, 'lps'),
	(599103, 127, '2014-04-01 00:02:48.000000', 'consum', 0.0212, 'lps'),
	(599104, 127, '2014-04-01 00:02:49.000000', 'consum', 0.0222, 'lps'),
	(599105, 127, '2014-04-01 00:02:50.000000', 'consum', 0.0218, 'lps'),
	(599106, 127, '2014-04-01 00:02:51.000000', 'consum', 0.0217, 'lps'),
	(599107, 127, '2014-04-01 00:02:52.000000', 'consum', 0.0219, 'lps'),
	(599108, 127, '2014-04-01 00:02:53.000000', 'consum', 0.0213, 'lps'),
	(599109, 127, '2014-04-01 00:02:54.000000', 'consum', 0.0220, 'lps'),
	(599110, 127, '2014-04-01 00:02:55.000000', 'consum', 0.0231, 'lps'),
	(599111, 127, '2014-04-01 00:02:56.000000', 'consum', 0.0219, 'lps'),
	(599112, 127, '2014-04-01 00:02:57.000000', 'consum', 0.0215, 'lps'),
	(599113, 127, '2014-04-01 00:02:58.000000', 'consum', 0.0231, 'lps'),
	(599114, 127, '2014-04-01 00:02:59.000000', 'consum', 0.0213, 'lps'),
	(599115, 127, '2014-04-01 00:03:00.000000', 'consum', 0.0230, 'lps'),
	(599116, 127, '2014-04-01 00:03:01.000000', 'consum', 0.0211, 'lps'),
	(599117, 127, '2014-04-01 00:03:02.000000', 'consum', 0.0221, 'lps'),
	(599118, 127, '2014-04-01 00:03:03.000000', 'consum', 0.0217, 'lps'),
	(599119, 127, '2014-04-01 00:03:04.000000', 'consum', 0.0216, 'lps'),
	(599120, 127, '2014-04-01 00:03:05.000000', 'consum', 0.0219, 'lps'),
	(599121, 127, '2014-04-01 00:03:06.000000', 'consum', 0.0214, 'lps'),
	(599122, 127, '2014-04-01 00:03:07.000000', 'consum', 0.0228, 'lps'),
	(599123, 127, '2014-04-01 00:03:08.000000', 'consum', 0.0220, 'lps'),
	(599124, 127, '2014-04-01 00:03:09.000000', 'consum', 0.0230, 'lps'),
	(599125, 127, '2014-04-01 00:03:10.000000', 'consum', 0.0213, 'lps'),
	(599126, 127, '2014-04-01 00:03:11.000000', 'consum', 0.0210, 'lps'),
	(599127, 127, '2014-04-01 00:03:12.000000', 'consum', 0.0226, 'lps'),
	(599128, 127, '2014-04-01 00:03:13.000000', 'consum', 0.0221, 'lps'),
	(599129, 127, '2014-04-01 00:03:14.000000', 'consum', 0.0220, 'lps'),
	(599130, 127, '2014-04-01 00:03:15.000000', 'consum', 0.0228, 'lps'),
	(599131, 127, '2014-04-01 00:03:16.000000', 'consum', 0.0225, 'lps'),
	(599132, 127, '2014-04-01 00:03:17.000000', 'consum', 0.0231, 'lps'),
	(599133, 127, '2014-04-01 00:03:18.000000', 'consum', 0.0226, 'lps'),
	(599134, 127, '2014-04-01 00:03:19.000000', 'consum', 0.0226, 'lps'),
	(599135, 127, '2014-04-01 00:03:20.000000', 'consum', 0.0223, 'lps'),
	(599136, 127, '2014-04-01 00:03:21.000000', 'consum', 0.0229, 'lps'),
	(599137, 127, '2014-04-01 00:03:22.000000', 'consum', 0.0221, 'lps'),
	(599138, 127, '2014-04-01 00:03:23.000000', 'consum', 0.0230, 'lps'),
	(599139, 127, '2014-04-01 00:03:24.000000', 'consum', 0.0212, 'lps'),
	(599140, 127, '2014-04-01 00:03:25.000000', 'consum', 0.0225, 'lps'),
	(599141, 127, '2014-04-01 00:03:26.000000', 'consum', 0.0217, 'lps'),
	(599142, 127, '2014-04-01 00:03:27.000000', 'consum', 0.0219, 'lps'),
	(599143, 127, '2014-04-01 00:03:28.000000', 'consum', 0.0212, 'lps'),
	(599144, 127, '2014-04-01 00:03:29.000000', 'consum', 0.0219, 'lps'),
	(599145, 127, '2014-04-01 00:03:30.000000', 'consum', 0.0224, 'lps'),
	(599146, 127, '2014-04-01 00:03:31.000000', 'consum', 0.0212, 'lps'),
	(599147, 127, '2014-04-01 00:03:32.000000', 'consum', 0.0220, 'lps'),
	(599148, 127, '2014-04-01 00:03:33.000000', 'consum', 0.0210, 'lps'),
	(599149, 127, '2014-04-01 00:03:34.000000', 'consum', 0.0226, 'lps'),
	(599150, 127, '2014-04-01 00:03:35.000000', 'consum', 0.0223, 'lps'),
	(599151, 127, '2014-04-01 00:03:36.000000', 'consum', 0.0230, 'lps'),
	(599152, 127, '2014-04-01 00:03:37.000000', 'consum', 0.0224, 'lps'),
	(599153, 127, '2014-04-01 00:03:38.000000', 'consum', 0.0224, 'lps'),
	(599154, 127, '2014-04-01 00:03:39.000000', 'consum', 0.0216, 'lps'),
	(599155, 127, '2014-04-01 00:03:40.000000', 'consum', 0.0219, 'lps'),
	(599156, 127, '2014-04-01 00:03:41.000000', 'consum', 0.0215, 'lps'),
	(599157, 127, '2014-04-01 00:03:42.000000', 'consum', 0.0229, 'lps'),
	(599158, 127, '2014-04-01 00:03:43.000000', 'consum', 0.0227, 'lps'),
	(599159, 127, '2014-04-01 00:03:44.000000', 'consum', 0.0217, 'lps'),
	(599160, 127, '2014-04-01 00:03:45.000000', 'consum', 0.0217, 'lps'),
	(599161, 127, '2014-04-01 00:03:46.000000', 'consum', 0.0222, 'lps'),
	(599162, 127, '2014-04-01 00:03:47.000000', 'consum', 0.0227, 'lps'),
	(599163, 127, '2014-04-01 00:03:48.000000', 'consum', 0.0214, 'lps'),
	(599164, 127, '2014-04-01 00:03:49.000000', 'consum', 0.0227, 'lps'),
	(599165, 127, '2014-04-01 00:03:50.000000', 'consum', 0.0218, 'lps'),
	(599166, 127, '2014-04-01 00:03:51.000000', 'consum', 0.0222, 'lps'),
	(599167, 127, '2014-04-01 00:03:52.000000', 'consum', 0.0221, 'lps'),
	(599168, 127, '2014-04-01 00:03:53.000000', 'consum', 0.0211, 'lps'),
	(599169, 127, '2014-04-01 00:03:54.000000', 'consum', 0.0224, 'lps'),
	(599170, 127, '2014-04-01 00:03:55.000000', 'consum', 0.0213, 'lps'),
	(599171, 127, '2014-04-01 00:03:56.000000', 'consum', 0.0229, 'lps'),
	(599172, 127, '2014-04-01 00:03:57.000000', 'consum', 0.0229, 'lps'),
	(599173, 127, '2014-04-01 00:03:58.000000', 'consum', 0.0228, 'lps'),
	(599174, 127, '2014-04-01 00:03:59.000000', 'consum', 0.0222, 'lps'),
	(599175, 127, '2014-04-01 00:04:00.000000', 'consum', 0.0214, 'lps'),
	(599176, 127, '2014-04-01 00:04:01.000000', 'consum', 0.0219, 'lps'),
	(599177, 127, '2014-04-01 00:04:02.000000', 'consum', 0.0221, 'lps'),
	(599178, 127, '2014-04-01 00:04:03.000000', 'consum', 0.0216, 'lps'),
	(599179, 127, '2014-04-01 00:04:04.000000', 'consum', 0.0230, 'lps'),
	(599180, 127, '2014-04-01 00:04:05.000000', 'consum', 0.0226, 'lps'),
	(599181, 127, '2014-04-01 00:04:06.000000', 'consum', 0.0210, 'lps'),
	(599182, 127, '2014-04-01 00:04:07.000000', 'consum', 0.0228, 'lps'),
	(599183, 127, '2014-04-01 00:04:08.000000', 'consum', 0.0212, 'lps'),
	(599184, 127, '2014-04-01 00:04:09.000000', 'consum', 0.0211, 'lps'),
	(599185, 127, '2014-04-01 00:04:10.000000', 'consum', 0.0210, 'lps'),
	(599186, 127, '2014-04-01 00:04:11.000000', 'consum', 0.0229, 'lps'),
	(599187, 127, '2014-04-01 00:04:12.000000', 'consum', 0.0216, 'lps'),
	(599188, 127, '2014-04-01 00:04:13.000000', 'consum', 0.0228, 'lps'),
	(599189, 127, '2014-04-01 00:04:14.000000', 'consum', 0.0216, 'lps'),
	(599190, 127, '2014-04-01 00:04:15.000000', 'consum', 0.0210, 'lps'),
	(599191, 127, '2014-04-01 00:04:16.000000', 'consum', 0.0215, 'lps'),
	(599192, 127, '2014-04-01 00:04:17.000000', 'consum', 0.0213, 'lps'),
	(599193, 127, '2014-04-01 00:04:18.000000', 'consum', 0.0212, 'lps'),
	(599194, 127, '2014-04-01 00:04:19.000000', 'consum', 0.0231, 'lps'),
	(599195, 127, '2014-04-01 00:04:20.000000', 'consum', 0.0223, 'lps'),
	(599196, 127, '2014-04-01 00:04:21.000000', 'consum', 0.0211, 'lps'),
	(599197, 127, '2014-04-01 00:04:22.000000', 'consum', 0.0222, 'lps'),
	(599198, 127, '2014-04-01 00:04:23.000000', 'consum', 0.0224, 'lps'),
	(599199, 127, '2014-04-01 00:04:24.000000', 'consum', 0.0222, 'lps'),
	(599200, 127, '2014-04-01 00:04:25.000000', 'consum', 0.0228, 'lps'),
	(599201, 127, '2014-04-01 00:04:26.000000', 'consum', 0.0219, 'lps'),
	(599202, 127, '2014-04-01 00:04:27.000000', 'consum', 0.0225, 'lps'),
	(599203, 127, '2014-04-01 00:04:28.000000', 'consum', 0.0214, 'lps'),
	(599204, 127, '2014-04-01 00:04:29.000000', 'consum', 0.0228, 'lps'),
	(599205, 127, '2014-04-01 00:04:30.000000', 'consum', 0.0225, 'lps'),
	(599206, 127, '2014-04-01 00:04:31.000000', 'consum', 0.0231, 'lps'),
	(599207, 127, '2014-04-01 00:04:32.000000', 'consum', 0.0225, 'lps'),
	(599208, 127, '2014-04-01 00:04:33.000000', 'consum', 0.0223, 'lps'),
	(599209, 127, '2014-04-01 00:04:34.000000', 'consum', 0.0229, 'lps'),
	(599210, 127, '2014-04-01 00:04:35.000000', 'consum', 0.0222, 'lps'),
	(599211, 127, '2014-04-01 00:04:36.000000', 'consum', 0.0215, 'lps'),
	(599212, 127, '2014-04-01 00:04:37.000000', 'consum', 0.0220, 'lps'),
	(599213, 127, '2014-04-01 00:04:38.000000', 'consum', 0.0226, 'lps'),
	(599214, 127, '2014-04-01 00:04:39.000000', 'consum', 0.0214, 'lps'),
	(599215, 127, '2014-04-01 00:04:40.000000', 'consum', 0.0226, 'lps'),
	(599216, 127, '2014-04-01 00:04:41.000000', 'consum', 0.0215, 'lps'),
	(599217, 127, '2014-04-01 00:04:42.000000', 'consum', 0.0229, 'lps'),
	(599218, 127, '2014-04-01 00:04:43.000000', 'consum', 0.0226, 'lps'),
	(599219, 127, '2014-04-01 00:04:44.000000', 'consum', 0.0213, 'lps'),
	(599220, 127, '2014-04-01 00:04:45.000000', 'consum', 0.0220, 'lps'),
	(599221, 127, '2014-04-01 00:04:46.000000', 'consum', 0.0230, 'lps'),
	(599222, 127, '2014-04-01 00:04:47.000000', 'consum', 0.0216, 'lps'),
	(599223, 127, '2014-04-01 00:04:48.000000', 'consum', 0.0225, 'lps'),
	(599224, 127, '2014-04-01 00:04:49.000000', 'consum', 0.0221, 'lps'),
	(599225, 127, '2014-04-01 00:04:50.000000', 'consum', 0.0222, 'lps'),
	(599226, 127, '2014-04-01 00:04:51.000000', 'consum', 0.0217, 'lps'),
	(599227, 127, '2014-04-01 00:04:52.000000', 'consum', 0.0230, 'lps'),
	(599228, 127, '2014-04-01 00:04:53.000000', 'consum', 0.0224, 'lps'),
	(599229, 127, '2014-04-01 00:04:54.000000', 'consum', 0.0221, 'lps'),
	(599230, 127, '2014-04-01 00:04:55.000000', 'consum', 0.0223, 'lps'),
	(599231, 127, '2014-04-01 00:04:56.000000', 'consum', 0.0221, 'lps'),
	(599232, 127, '2014-04-01 00:04:57.000000', 'consum', 0.0224, 'lps'),
	(599233, 127, '2014-04-01 00:04:58.000000', 'consum', 0.0229, 'lps'),
	(599234, 127, '2014-04-01 00:04:59.000000', 'consum', 0.0216, 'lps'),
	(599235, 127, '2014-04-01 00:05:00.000000', 'consum', 0.0229, 'lps'),
	(599236, 127, '2014-04-01 00:05:01.000000', 'consum', 0.0221, 'lps'),
	(599237, 127, '2014-04-01 00:05:02.000000', 'consum', 0.0210, 'lps'),
	(599238, 127, '2014-04-01 00:05:03.000000', 'consum', 0.0220, 'lps'),
	(599239, 127, '2014-04-01 00:05:04.000000', 'consum', 0.0215, 'lps'),
	(599240, 127, '2014-04-01 00:05:05.000000', 'consum', 0.0228, 'lps'),
	(599241, 127, '2014-04-01 00:05:06.000000', 'consum', 0.0221, 'lps'),
	(599242, 127, '2014-04-01 00:05:07.000000', 'consum', 0.0210, 'lps'),
	(599243, 127, '2014-04-01 00:05:08.000000', 'consum', 0.0220, 'lps'),
	(599244, 127, '2014-04-01 00:05:09.000000', 'consum', 0.0219, 'lps'),
	(599245, 127, '2014-04-01 00:05:10.000000', 'consum', 0.0225, 'lps'),
	(599246, 127, '2014-04-01 00:05:11.000000', 'consum', 0.0216, 'lps'),
	(599247, 127, '2014-04-01 00:05:12.000000', 'consum', 0.0218, 'lps'),
	(599248, 127, '2014-04-01 00:05:13.000000', 'consum', 0.0230, 'lps'),
	(599249, 127, '2014-04-01 00:05:14.000000', 'consum', 0.0221, 'lps'),
	(599250, 127, '2014-04-01 00:05:15.000000', 'consum', 0.0226, 'lps'),
	(599251, 127, '2014-04-01 00:05:16.000000', 'consum', 0.0214, 'lps'),
	(599252, 127, '2014-04-01 00:05:17.000000', 'consum', 0.0228, 'lps'),
	(599253, 127, '2014-04-01 00:05:18.000000', 'consum', 0.0223, 'lps'),
	(599254, 127, '2014-04-01 00:05:19.000000', 'consum', 0.0219, 'lps'),
	(599255, 127, '2014-04-01 00:05:20.000000', 'consum', 0.0218, 'lps'),
	(599256, 127, '2014-04-01 00:05:21.000000', 'consum', 0.0224, 'lps'),
	(599257, 127, '2014-04-01 00:05:22.000000', 'consum', 0.0214, 'lps'),
	(599258, 127, '2014-04-01 00:05:23.000000', 'consum', 0.0210, 'lps'),
	(599259, 127, '2014-04-01 00:05:24.000000', 'consum', 0.0218, 'lps'),
	(599260, 127, '2014-04-01 00:05:25.000000', 'consum', 0.0210, 'lps'),
	(599261, 127, '2014-04-01 00:05:26.000000', 'consum', 0.0228, 'lps'),
	(599262, 127, '2014-04-01 00:05:27.000000', 'consum', 0.0215, 'lps'),
	(599263, 127, '2014-04-01 00:05:28.000000', 'consum', 0.0224, 'lps'),
	(599264, 127, '2014-04-01 00:05:29.000000', 'consum', 0.0223, 'lps'),
	(599265, 127, '2014-04-01 00:05:30.000000', 'consum', 0.0210, 'lps'),
	(599266, 127, '2014-04-01 00:05:31.000000', 'consum', 0.0217, 'lps'),
	(599267, 127, '2014-04-01 00:05:32.000000', 'consum', 0.0225, 'lps'),
	(599268, 127, '2014-04-01 00:05:33.000000', 'consum', 0.0218, 'lps'),
	(599269, 127, '2014-04-01 00:05:34.000000', 'consum', 0.0226, 'lps'),
	(599270, 127, '2014-04-01 00:05:35.000000', 'consum', 0.0225, 'lps'),
	(599271, 127, '2014-04-01 00:05:36.000000', 'consum', 0.0216, 'lps'),
	(599272, 127, '2014-04-01 00:05:37.000000', 'consum', 0.0218, 'lps'),
	(599273, 127, '2014-04-01 00:05:38.000000', 'consum', 0.0231, 'lps'),
	(599274, 127, '2014-04-01 00:05:39.000000', 'consum', 0.0228, 'lps'),
	(599275, 127, '2014-04-01 00:05:40.000000', 'consum', 0.0212, 'lps'),
	(599276, 127, '2014-04-01 00:05:41.000000', 'consum', 0.0213, 'lps'),
	(599277, 127, '2014-04-01 00:05:42.000000', 'consum', 0.0218, 'lps'),
	(599278, 127, '2014-04-01 00:05:43.000000', 'consum', 0.0222, 'lps'),
	(599279, 127, '2014-04-01 00:05:44.000000', 'consum', 0.0224, 'lps'),
	(599280, 127, '2014-04-01 00:05:45.000000', 'consum', 0.0221, 'lps'),
	(599281, 127, '2014-04-01 00:05:46.000000', 'consum', 0.0223, 'lps'),
	(599282, 127, '2014-04-01 00:05:47.000000', 'consum', 0.0223, 'lps'),
	(599283, 127, '2014-04-01 00:05:48.000000', 'consum', 0.0213, 'lps'),
	(599284, 127, '2014-04-01 00:05:49.000000', 'consum', 0.0210, 'lps'),
	(599285, 127, '2014-04-01 00:05:50.000000', 'consum', 0.0225, 'lps'),
	(599286, 127, '2014-04-01 00:05:51.000000', 'consum', 0.0216, 'lps'),
	(599287, 127, '2014-04-01 00:05:52.000000', 'consum', 0.0220, 'lps'),
	(599288, 127, '2014-04-01 00:05:53.000000', 'consum', 0.0219, 'lps'),
	(599289, 127, '2014-04-01 00:05:54.000000', 'consum', 0.0225, 'lps'),
	(599290, 127, '2014-04-01 00:05:55.000000', 'consum', 0.0215, 'lps'),
	(599291, 127, '2014-04-01 00:05:56.000000', 'consum', 0.0214, 'lps'),
	(599292, 127, '2014-04-01 00:05:57.000000', 'consum', 0.0216, 'lps'),
	(599293, 127, '2014-04-01 00:05:58.000000', 'consum', 0.0229, 'lps'),
	(599294, 127, '2014-04-01 00:05:59.000000', 'consum', 0.0219, 'lps'),
	(599295, 127, '2014-04-01 00:06:00.000000', 'consum', 0.0223, 'lps'),
	(599296, 127, '2014-04-01 00:06:01.000000', 'consum', 0.0228, 'lps'),
	(599297, 127, '2014-04-01 00:06:02.000000', 'consum', 0.0214, 'lps'),
	(599298, 127, '2014-04-01 00:06:03.000000', 'consum', 0.0222, 'lps'),
	(599299, 127, '2014-04-01 00:06:04.000000', 'consum', 0.0213, 'lps'),
	(599300, 127, '2014-04-01 00:06:05.000000', 'consum', 0.0214, 'lps'),
	(599301, 127, '2014-04-01 00:06:06.000000', 'consum', 0.0221, 'lps'),
	(599302, 127, '2014-04-01 00:06:07.000000', 'consum', 0.0229, 'lps'),
	(599303, 127, '2014-04-01 00:06:08.000000', 'consum', 0.0230, 'lps'),
	(599304, 127, '2014-04-01 00:06:09.000000', 'consum', 0.0231, 'lps'),
	(599305, 127, '2014-04-01 00:06:10.000000', 'consum', 0.0214, 'lps'),
	(599306, 127, '2014-04-01 00:06:11.000000', 'consum', 0.0230, 'lps'),
	(599307, 127, '2014-04-01 00:06:12.000000', 'consum', 0.0212, 'lps'),
	(599308, 127, '2014-04-01 00:06:13.000000', 'consum', 0.0228, 'lps'),
	(599309, 127, '2014-04-01 00:06:14.000000', 'consum', 0.0226, 'lps'),
	(599310, 127, '2014-04-01 00:06:15.000000', 'consum', 0.0216, 'lps'),
	(599311, 127, '2014-04-01 00:06:16.000000', 'consum', 0.0214, 'lps'),
	(599312, 127, '2014-04-01 00:06:17.000000', 'consum', 0.0214, 'lps'),
	(599313, 127, '2014-04-01 00:06:18.000000', 'consum', 0.0217, 'lps'),
	(599314, 127, '2014-04-01 00:06:19.000000', 'consum', 0.0211, 'lps'),
	(599315, 127, '2014-04-01 00:06:20.000000', 'consum', 0.0217, 'lps'),
	(599316, 127, '2014-04-01 00:06:21.000000', 'consum', 0.0219, 'lps'),
	(599317, 127, '2014-04-01 00:06:22.000000', 'consum', 0.0215, 'lps'),
	(599318, 127, '2014-04-01 00:06:23.000000', 'consum', 0.0231, 'lps'),
	(599319, 127, '2014-04-01 00:06:24.000000', 'consum', 0.0211, 'lps'),
	(599320, 127, '2014-04-01 00:06:25.000000', 'consum', 0.0220, 'lps'),
	(599321, 127, '2014-04-01 00:06:26.000000', 'consum', 0.0211, 'lps'),
	(599322, 127, '2014-04-01 00:06:27.000000', 'consum', 0.0210, 'lps'),
	(599323, 127, '2014-04-01 00:06:28.000000', 'consum', 0.0228, 'lps'),
	(599324, 127, '2014-04-01 00:06:29.000000', 'consum', 0.0212, 'lps'),
	(599325, 127, '2014-04-01 00:06:30.000000', 'consum', 0.0231, 'lps'),
	(599326, 127, '2014-04-01 00:06:31.000000', 'consum', 0.0223, 'lps'),
	(599327, 127, '2014-04-01 00:06:32.000000', 'consum', 0.0214, 'lps'),
	(599328, 127, '2014-04-01 00:06:33.000000', 'consum', 0.0215, 'lps'),
	(599329, 127, '2014-04-01 00:06:34.000000', 'consum', 0.0220, 'lps'),
	(599330, 127, '2014-04-01 00:06:35.000000', 'consum', 0.0224, 'lps'),
	(599331, 127, '2014-04-01 00:06:36.000000', 'consum', 0.0228, 'lps'),
	(599332, 127, '2014-04-01 00:06:37.000000', 'consum', 0.0217, 'lps'),
	(599333, 127, '2014-04-01 00:06:38.000000', 'consum', 0.0210, 'lps'),
	(599334, 127, '2014-04-01 00:06:39.000000', 'consum', 0.0215, 'lps'),
	(599335, 127, '2014-04-01 00:06:40.000000', 'consum', 0.0211, 'lps'),
	(599336, 127, '2014-04-01 00:06:41.000000', 'consum', 0.0224, 'lps'),
	(599337, 127, '2014-04-01 00:06:42.000000', 'consum', 0.0213, 'lps'),
	(599338, 127, '2014-04-01 00:06:43.000000', 'consum', 0.0226, 'lps'),
	(599339, 127, '2014-04-01 00:06:44.000000', 'consum', 0.0215, 'lps'),
	(599340, 127, '2014-04-01 00:06:45.000000', 'consum', 0.0211, 'lps'),
	(599341, 127, '2014-04-01 00:06:46.000000', 'consum', 0.0221, 'lps'),
	(599342, 127, '2014-04-01 00:06:47.000000', 'consum', 0.0218, 'lps'),
	(599343, 127, '2014-04-01 00:06:48.000000', 'consum', 0.0217, 'lps'),
	(599344, 127, '2014-04-01 00:06:49.000000', 'consum', 0.0222, 'lps'),
	(599345, 127, '2014-04-01 00:06:50.000000', 'consum', 0.0228, 'lps'),
	(599346, 127, '2014-04-01 00:06:51.000000', 'consum', 0.0219, 'lps'),
	(599347, 127, '2014-04-01 00:06:52.000000', 'consum', 0.0224, 'lps'),
	(599348, 127, '2014-04-01 00:06:53.000000', 'consum', 0.0211, 'lps'),
	(599349, 127, '2014-04-01 00:06:54.000000', 'consum', 0.0216, 'lps'),
	(599350, 127, '2014-04-01 00:06:55.000000', 'consum', 0.0214, 'lps'),
	(599351, 127, '2014-04-01 00:06:56.000000', 'consum', 0.0216, 'lps'),
	(599352, 127, '2014-04-01 00:06:57.000000', 'consum', 0.0226, 'lps'),
	(599353, 127, '2014-04-01 00:06:58.000000', 'consum', 0.0229, 'lps'),
	(599354, 127, '2014-04-01 00:06:59.000000', 'consum', 0.0214, 'lps'),
	(599355, 127, '2014-04-01 00:07:00.000000', 'consum', 0.0219, 'lps'),
	(599356, 127, '2014-04-01 00:07:01.000000', 'consum', 0.0220, 'lps'),
	(599357, 127, '2014-04-01 00:07:02.000000', 'consum', 0.0212, 'lps'),
	(599358, 127, '2014-04-01 00:07:03.000000', 'consum', 0.0212, 'lps'),
	(599359, 127, '2014-04-01 00:07:04.000000', 'consum', 0.0215, 'lps'),
	(599360, 127, '2014-04-01 00:07:05.000000', 'consum', 0.0230, 'lps'),
	(599361, 127, '2014-04-01 00:07:06.000000', 'consum', 0.0230, 'lps'),
	(599362, 127, '2014-04-01 00:07:07.000000', 'consum', 0.0228, 'lps'),
	(599363, 127, '2014-04-01 00:07:08.000000', 'consum', 0.0219, 'lps'),
	(599364, 127, '2014-04-01 00:07:09.000000', 'consum', 0.0223, 'lps'),
	(599365, 127, '2014-04-01 00:07:10.000000', 'consum', 0.0226, 'lps'),
	(599366, 127, '2014-04-01 00:07:11.000000', 'consum', 0.0210, 'lps'),
	(599367, 127, '2014-04-01 00:07:12.000000', 'consum', 0.0226, 'lps'),
	(599368, 127, '2014-04-01 00:07:13.000000', 'consum', 0.0227, 'lps'),
	(599369, 127, '2014-04-01 00:07:14.000000', 'consum', 0.0224, 'lps'),
	(599370, 127, '2014-04-01 00:07:15.000000', 'consum', 0.0229, 'lps'),
	(599371, 127, '2014-04-01 00:07:16.000000', 'consum', 0.0221, 'lps'),
	(599372, 127, '2014-04-01 00:07:17.000000', 'consum', 0.0231, 'lps'),
	(599373, 127, '2014-04-01 00:07:18.000000', 'consum', 0.0215, 'lps'),
	(599374, 127, '2014-04-01 00:07:19.000000', 'consum', 0.0217, 'lps'),
	(599375, 127, '2014-04-01 00:07:20.000000', 'consum', 0.0231, 'lps'),
	(599376, 127, '2014-04-01 00:07:21.000000', 'consum', 0.0228, 'lps'),
	(599377, 127, '2014-04-01 00:07:22.000000', 'consum', 0.0216, 'lps'),
	(599378, 127, '2014-04-01 00:07:23.000000', 'consum', 0.0230, 'lps'),
	(599379, 127, '2014-04-01 00:07:24.000000', 'consum', 0.0227, 'lps'),
	(599380, 127, '2014-04-01 00:07:25.000000', 'consum', 0.0212, 'lps'),
	(599381, 127, '2014-04-01 00:07:26.000000', 'consum', 0.0214, 'lps'),
	(599382, 127, '2014-04-01 00:07:27.000000', 'consum', 0.0224, 'lps'),
	(599383, 127, '2014-04-01 00:07:28.000000', 'consum', 0.0226, 'lps'),
	(599384, 127, '2014-04-01 00:07:29.000000', 'consum', 0.0226, 'lps'),
	(599385, 127, '2014-04-01 00:07:30.000000', 'consum', 0.0221, 'lps'),
	(599386, 127, '2014-04-01 00:07:31.000000', 'consum', 0.0219, 'lps'),
	(599387, 127, '2014-04-01 00:07:32.000000', 'consum', 0.0221, 'lps'),
	(599388, 127, '2014-04-01 00:07:33.000000', 'consum', 0.0215, 'lps'),
	(599389, 127, '2014-04-01 00:07:34.000000', 'consum', 0.0226, 'lps'),
	(599390, 127, '2014-04-01 00:07:35.000000', 'consum', 0.0230, 'lps'),
	(599391, 127, '2014-04-01 00:07:36.000000', 'consum', 0.0219, 'lps'),
	(599392, 127, '2014-04-01 00:07:37.000000', 'consum', 0.0217, 'lps'),
	(599393, 127, '2014-04-01 00:07:38.000000', 'consum', 0.0220, 'lps'),
	(599394, 127, '2014-04-01 00:07:39.000000', 'consum', 0.0216, 'lps'),
	(599395, 127, '2014-04-01 00:07:40.000000', 'consum', 0.0212, 'lps'),
	(599396, 127, '2014-04-01 00:07:41.000000', 'consum', 0.0226, 'lps'),
	(599397, 127, '2014-04-01 00:07:42.000000', 'consum', 0.0216, 'lps'),
	(599398, 127, '2014-04-01 00:07:43.000000', 'consum', 0.0215, 'lps'),
	(599399, 127, '2014-04-01 00:07:44.000000', 'consum', 0.0218, 'lps'),
	(599400, 127, '2014-04-01 00:07:45.000000', 'consum', 0.0215, 'lps'),
	(599401, 127, '2014-04-01 00:07:46.000000', 'consum', 0.0211, 'lps'),
	(599402, 127, '2014-04-01 00:07:47.000000', 'consum', 0.0221, 'lps'),
	(599403, 127, '2014-04-01 00:07:48.000000', 'consum', 0.0219, 'lps'),
	(599404, 127, '2014-04-01 00:07:49.000000', 'consum', 0.0221, 'lps'),
	(599405, 127, '2014-04-01 00:07:50.000000', 'consum', 0.0216, 'lps'),
	(599406, 127, '2014-04-01 00:07:51.000000', 'consum', 0.0210, 'lps'),
	(599407, 127, '2014-04-01 00:07:52.000000', 'consum', 0.0212, 'lps'),
	(599408, 127, '2014-04-01 00:07:53.000000', 'consum', 0.0219, 'lps'),
	(599409, 127, '2014-04-01 00:07:54.000000', 'consum', 0.0231, 'lps'),
	(599410, 127, '2014-04-01 00:07:55.000000', 'consum', 0.0223, 'lps'),
	(599411, 127, '2014-04-01 00:07:56.000000', 'consum', 0.0210, 'lps'),
	(599412, 127, '2014-04-01 00:07:57.000000', 'consum', 0.0216, 'lps'),
	(599413, 127, '2014-04-01 00:07:58.000000', 'consum', 0.0218, 'lps'),
	(599414, 127, '2014-04-01 00:07:59.000000', 'consum', 0.0213, 'lps'),
	(599415, 127, '2014-04-01 00:08:00.000000', 'consum', 0.0221, 'lps'),
	(599416, 127, '2014-04-01 00:08:01.000000', 'consum', 0.0212, 'lps'),
	(599417, 127, '2014-04-01 00:08:02.000000', 'consum', 0.0230, 'lps'),
	(599418, 127, '2014-04-01 00:08:03.000000', 'consum', 0.0220, 'lps'),
	(599419, 127, '2014-04-01 00:08:04.000000', 'consum', 0.0221, 'lps'),
	(599420, 127, '2014-04-01 00:08:05.000000', 'consum', 0.0213, 'lps'),
	(599421, 127, '2014-04-01 00:08:06.000000', 'consum', 0.0215, 'lps'),
	(599422, 127, '2014-04-01 00:08:07.000000', 'consum', 0.0226, 'lps'),
	(599423, 127, '2014-04-01 00:08:08.000000', 'consum', 0.0230, 'lps'),
	(599424, 127, '2014-04-01 00:08:09.000000', 'consum', 0.0220, 'lps'),
	(599425, 127, '2014-04-01 00:08:10.000000', 'consum', 0.0224, 'lps'),
	(599426, 127, '2014-04-01 00:08:11.000000', 'consum', 0.0228, 'lps'),
	(599427, 127, '2014-04-01 00:08:12.000000', 'consum', 0.0216, 'lps'),
	(599428, 127, '2014-04-01 00:08:13.000000', 'consum', 0.0229, 'lps'),
	(599429, 127, '2014-04-01 00:08:14.000000', 'consum', 0.0220, 'lps'),
	(599430, 127, '2014-04-01 00:08:15.000000', 'consum', 0.0225, 'lps'),
	(599431, 127, '2014-04-01 00:08:16.000000', 'consum', 0.0213, 'lps'),
	(599432, 127, '2014-04-01 00:08:17.000000', 'consum', 0.0226, 'lps'),
	(599433, 127, '2014-04-01 00:08:18.000000', 'consum', 0.0214, 'lps'),
	(599434, 127, '2014-04-01 00:08:19.000000', 'consum', 0.0226, 'lps'),
	(599435, 127, '2014-04-01 00:08:20.000000', 'consum', 0.0214, 'lps'),
	(599436, 127, '2014-04-01 00:08:21.000000', 'consum', 0.0225, 'lps'),
	(599437, 127, '2014-04-01 00:08:22.000000', 'consum', 0.0230, 'lps'),
	(599438, 127, '2014-04-01 00:08:23.000000', 'consum', 0.0221, 'lps'),
	(599439, 127, '2014-04-01 00:08:24.000000', 'consum', 0.0227, 'lps'),
	(599440, 127, '2014-04-01 00:08:25.000000', 'consum', 0.0220, 'lps'),
	(599441, 127, '2014-04-01 00:08:26.000000', 'consum', 0.0230, 'lps'),
	(599442, 127, '2014-04-01 00:08:27.000000', 'consum', 0.0213, 'lps'),
	(599443, 127, '2014-04-01 00:08:28.000000', 'consum', 0.0212, 'lps'),
	(599444, 127, '2014-04-01 00:08:29.000000', 'consum', 0.0211, 'lps'),
	(599445, 127, '2014-04-01 00:08:30.000000', 'consum', 0.0230, 'lps'),
	(599446, 127, '2014-04-01 00:08:31.000000', 'consum', 0.0220, 'lps'),
	(599447, 127, '2014-04-01 00:08:32.000000', 'consum', 0.0222, 'lps'),
	(599448, 127, '2014-04-01 00:08:33.000000', 'consum', 0.0218, 'lps'),
	(599449, 127, '2014-04-01 00:08:34.000000', 'consum', 0.0216, 'lps'),
	(599450, 127, '2014-04-01 00:08:35.000000', 'consum', 0.0216, 'lps'),
	(599451, 127, '2014-04-01 00:08:36.000000', 'consum', 0.0224, 'lps'),
	(599452, 127, '2014-04-01 00:08:37.000000', 'consum', 0.0219, 'lps'),
	(599453, 127, '2014-04-01 00:08:38.000000', 'consum', 0.0211, 'lps'),
	(599454, 127, '2014-04-01 00:08:39.000000', 'consum', 0.0213, 'lps'),
	(599455, 127, '2014-04-01 00:08:40.000000', 'consum', 0.0221, 'lps'),
	(599456, 127, '2014-04-01 00:08:41.000000', 'consum', 0.0214, 'lps'),
	(599457, 127, '2014-04-01 00:08:42.000000', 'consum', 0.0220, 'lps'),
	(599458, 127, '2014-04-01 00:08:43.000000', 'consum', 0.0225, 'lps'),
	(599459, 127, '2014-04-01 00:08:44.000000', 'consum', 0.0211, 'lps'),
	(599460, 127, '2014-04-01 00:08:45.000000', 'consum', 0.0213, 'lps'),
	(599461, 127, '2014-04-01 00:08:46.000000', 'consum', 0.0226, 'lps'),
	(599462, 127, '2014-04-01 00:08:47.000000', 'consum', 0.0214, 'lps'),
	(599463, 127, '2014-04-01 00:08:48.000000', 'consum', 0.0227, 'lps'),
	(599464, 127, '2014-04-01 00:08:49.000000', 'consum', 0.0218, 'lps'),
	(599465, 127, '2014-04-01 00:08:50.000000', 'consum', 0.0223, 'lps'),
	(599466, 127, '2014-04-01 00:08:51.000000', 'consum', 0.0227, 'lps'),
	(599467, 127, '2014-04-01 00:08:52.000000', 'consum', 0.0215, 'lps'),
	(599468, 127, '2014-04-01 00:08:53.000000', 'consum', 0.0226, 'lps'),
	(599469, 127, '2014-04-01 00:08:54.000000', 'consum', 0.0231, 'lps'),
	(599470, 127, '2014-04-01 00:08:55.000000', 'consum', 0.0225, 'lps'),
	(599471, 127, '2014-04-01 00:08:56.000000', 'consum', 0.0221, 'lps'),
	(599472, 127, '2014-04-01 00:08:57.000000', 'consum', 0.0221, 'lps'),
	(599473, 127, '2014-04-01 00:08:58.000000', 'consum', 0.0212, 'lps'),
	(599474, 127, '2014-04-01 00:08:59.000000', 'consum', 0.0231, 'lps'),
	(599475, 127, '2014-04-01 00:09:00.000000', 'consum', 0.0219, 'lps'),
	(599476, 127, '2014-04-01 00:09:01.000000', 'consum', 0.0218, 'lps'),
	(599477, 127, '2014-04-01 00:09:02.000000', 'consum', 0.0222, 'lps'),
	(599478, 127, '2014-04-01 00:09:03.000000', 'consum', 0.0226, 'lps'),
	(599479, 127, '2014-04-01 00:09:04.000000', 'consum', 0.0210, 'lps'),
	(599480, 127, '2014-04-01 00:09:05.000000', 'consum', 0.0230, 'lps'),
	(599481, 127, '2014-04-01 00:09:06.000000', 'consum', 0.0220, 'lps'),
	(599482, 127, '2014-04-01 00:09:07.000000', 'consum', 0.0221, 'lps'),
	(599483, 127, '2014-04-01 00:09:08.000000', 'consum', 0.0216, 'lps'),
	(599484, 127, '2014-04-01 00:09:09.000000', 'consum', 0.0230, 'lps'),
	(599485, 127, '2014-04-01 00:09:10.000000', 'consum', 0.0227, 'lps'),
	(599486, 127, '2014-04-01 00:09:11.000000', 'consum', 0.0213, 'lps'),
	(599487, 127, '2014-04-01 00:09:12.000000', 'consum', 0.0217, 'lps'),
	(599488, 127, '2014-04-01 00:09:13.000000', 'consum', 0.0217, 'lps'),
	(599489, 127, '2014-04-01 00:09:14.000000', 'consum', 0.0223, 'lps'),
	(599490, 127, '2014-04-01 00:09:15.000000', 'consum', 0.0210, 'lps'),
	(599491, 127, '2014-04-01 00:09:16.000000', 'consum', 0.0217, 'lps'),
	(599492, 127, '2014-04-01 00:09:17.000000', 'consum', 0.0224, 'lps'),
	(599493, 127, '2014-04-01 00:09:18.000000', 'consum', 0.0215, 'lps'),
	(599494, 127, '2014-04-01 00:09:19.000000', 'consum', 0.0216, 'lps'),
	(599495, 127, '2014-04-01 00:09:20.000000', 'consum', 0.0226, 'lps'),
	(599496, 127, '2014-04-01 00:09:21.000000', 'consum', 0.0229, 'lps'),
	(599497, 127, '2014-04-01 00:09:22.000000', 'consum', 0.0212, 'lps'),
	(599498, 127, '2014-04-01 00:09:23.000000', 'consum', 0.0228, 'lps'),
	(599499, 127, '2014-04-01 00:09:24.000000', 'consum', 0.0230, 'lps'),
	(599500, 127, '2014-04-01 00:09:25.000000', 'consum', 0.0211, 'lps'),
	(599501, 127, '2014-04-01 00:09:26.000000', 'consum', 0.0223, 'lps'),
	(599502, 127, '2014-04-01 00:09:27.000000', 'consum', 0.0228, 'lps'),
	(599503, 127, '2014-04-01 00:09:28.000000', 'consum', 0.0215, 'lps'),
	(599504, 127, '2014-04-01 00:09:29.000000', 'consum', 0.0229, 'lps'),
	(599505, 127, '2014-04-01 00:09:30.000000', 'consum', 0.0225, 'lps'),
	(599506, 127, '2014-04-01 00:09:31.000000', 'consum', 0.0226, 'lps'),
	(599507, 127, '2014-04-01 00:09:32.000000', 'consum', 0.0224, 'lps'),
	(599508, 127, '2014-04-01 00:09:33.000000', 'consum', 0.0212, 'lps'),
	(599509, 127, '2014-04-01 00:09:34.000000', 'consum', 0.0220, 'lps'),
	(599510, 127, '2014-04-01 00:09:35.000000', 'consum', 0.0212, 'lps'),
	(599511, 127, '2014-04-01 00:09:36.000000', 'consum', 0.0214, 'lps'),
	(599512, 127, '2014-04-01 00:09:37.000000', 'consum', 0.0222, 'lps'),
	(599513, 127, '2014-04-01 00:09:38.000000', 'consum', 0.0215, 'lps'),
	(599514, 127, '2014-04-01 00:09:39.000000', 'consum', 0.0222, 'lps'),
	(599515, 127, '2014-04-01 00:09:40.000000', 'consum', 0.0210, 'lps'),
	(599516, 127, '2014-04-01 00:09:41.000000', 'consum', 0.0218, 'lps'),
	(599517, 127, '2014-04-01 00:09:42.000000', 'consum', 0.0230, 'lps'),
	(599518, 127, '2014-04-01 00:09:43.000000', 'consum', 0.0218, 'lps'),
	(599519, 127, '2014-04-01 00:09:44.000000', 'consum', 0.0216, 'lps'),
	(599520, 127, '2014-04-01 00:09:45.000000', 'consum', 0.0213, 'lps'),
	(599521, 127, '2014-04-01 00:09:46.000000', 'consum', 0.0210, 'lps'),
	(599522, 127, '2014-04-01 00:09:47.000000', 'consum', 0.0221, 'lps'),
	(599523, 127, '2014-04-01 00:09:48.000000', 'consum', 0.0222, 'lps'),
	(599524, 127, '2014-04-01 00:09:49.000000', 'consum', 0.0215, 'lps'),
	(599525, 127, '2014-04-01 00:09:50.000000', 'consum', 0.0222, 'lps'),
	(599526, 127, '2014-04-01 00:09:51.000000', 'consum', 0.0212, 'lps'),
	(599527, 127, '2014-04-01 00:09:52.000000', 'consum', 0.0228, 'lps'),
	(599528, 127, '2014-04-01 00:09:53.000000', 'consum', 0.0228, 'lps'),
	(599529, 127, '2014-04-01 00:09:54.000000', 'consum', 0.0225, 'lps'),
	(599530, 127, '2014-04-01 00:09:55.000000', 'consum', 0.0210, 'lps'),
	(599531, 127, '2014-04-01 00:09:56.000000', 'consum', 0.0211, 'lps'),
	(599532, 127, '2014-04-01 00:09:57.000000', 'consum', 0.0212, 'lps'),
	(599533, 127, '2014-04-01 00:09:58.000000', 'consum', 0.0220, 'lps'),
	(599534, 127, '2014-04-01 00:09:59.000000', 'consum', 0.0230, 'lps'),
	(599535, 127, '2014-04-01 00:10:00.000000', 'consum', 0.0217, 'lps'),
	(599536, 127, '2014-04-01 00:10:01.000000', 'consum', 0.0228, 'lps'),
	(599537, 127, '2014-04-01 00:10:02.000000', 'consum', 0.0215, 'lps'),
	(599538, 127, '2014-04-01 00:10:03.000000', 'consum', 0.0223, 'lps'),
	(599539, 127, '2014-04-01 00:10:04.000000', 'consum', 0.0219, 'lps'),
	(599540, 127, '2014-04-01 00:10:05.000000', 'consum', 0.0217, 'lps'),
	(599541, 127, '2014-04-01 00:10:06.000000', 'consum', 0.0217, 'lps'),
	(599542, 127, '2014-04-01 00:10:07.000000', 'consum', 0.0223, 'lps'),
	(599543, 127, '2014-04-01 00:10:08.000000', 'consum', 0.0214, 'lps'),
	(599544, 127, '2014-04-01 00:10:09.000000', 'consum', 0.0211, 'lps'),
	(599545, 127, '2014-04-01 00:10:10.000000', 'consum', 0.0226, 'lps'),
	(599546, 127, '2014-04-01 00:10:11.000000', 'consum', 0.0220, 'lps'),
	(599547, 127, '2014-04-01 00:10:12.000000', 'consum', 0.0211, 'lps'),
	(599548, 127, '2014-04-01 00:10:13.000000', 'consum', 0.0211, 'lps'),
	(599549, 127, '2014-04-01 00:10:14.000000', 'consum', 0.0213, 'lps'),
	(599550, 127, '2014-04-01 00:10:15.000000', 'consum', 0.0222, 'lps'),
	(599551, 127, '2014-04-01 00:10:16.000000', 'consum', 0.0216, 'lps'),
	(599552, 127, '2014-04-01 00:10:17.000000', 'consum', 0.0227, 'lps'),
	(599553, 127, '2014-04-01 00:10:18.000000', 'consum', 0.0212, 'lps'),
	(599554, 127, '2014-04-01 00:10:19.000000', 'consum', 0.0215, 'lps'),
	(599555, 127, '2014-04-01 00:10:20.000000', 'consum', 0.0230, 'lps'),
	(599556, 127, '2014-04-01 00:10:21.000000', 'consum', 0.0228, 'lps'),
	(599557, 127, '2014-04-01 00:10:22.000000', 'consum', 0.0219, 'lps'),
	(599558, 127, '2014-04-01 00:10:23.000000', 'consum', 0.0222, 'lps'),
	(599559, 127, '2014-04-01 00:10:24.000000', 'consum', 0.0221, 'lps'),
	(599560, 127, '2014-04-01 00:10:25.000000', 'consum', 0.0210, 'lps'),
	(599561, 127, '2014-04-01 00:10:26.000000', 'consum', 0.0222, 'lps'),
	(599562, 127, '2014-04-01 00:10:27.000000', 'consum', 0.0225, 'lps'),
	(599563, 127, '2014-04-01 00:10:28.000000', 'consum', 0.0228, 'lps'),
	(599564, 127, '2014-04-01 00:10:29.000000', 'consum', 0.0212, 'lps'),
	(599565, 127, '2014-04-01 00:10:30.000000', 'consum', 0.0230, 'lps'),
	(599566, 127, '2014-04-01 00:10:31.000000', 'consum', 0.0219, 'lps'),
	(599567, 127, '2014-04-01 00:10:32.000000', 'consum', 0.0216, 'lps'),
	(599568, 127, '2014-04-01 00:10:33.000000', 'consum', 0.0213, 'lps'),
	(599569, 127, '2014-04-01 00:10:34.000000', 'consum', 0.0210, 'lps'),
	(599570, 127, '2014-04-01 00:10:35.000000', 'consum', 0.0221, 'lps'),
	(599571, 127, '2014-04-01 00:10:36.000000', 'consum', 0.0223, 'lps'),
	(599572, 127, '2014-04-01 00:10:37.000000', 'consum', 0.0219, 'lps'),
	(599573, 127, '2014-04-01 00:10:38.000000', 'consum', 0.0217, 'lps'),
	(599574, 127, '2014-04-01 00:10:39.000000', 'consum', 0.0220, 'lps'),
	(599575, 127, '2014-04-01 00:10:40.000000', 'consum', 0.0215, 'lps'),
	(599576, 127, '2014-04-01 00:10:41.000000', 'consum', 0.0228, 'lps'),
	(599577, 127, '2014-04-01 00:10:42.000000', 'consum', 0.0220, 'lps'),
	(599578, 127, '2014-04-01 00:10:43.000000', 'consum', 0.0228, 'lps'),
	(599579, 127, '2014-04-01 00:10:44.000000', 'consum', 0.0228, 'lps'),
	(599580, 127, '2014-04-01 00:10:45.000000', 'consum', 0.0224, 'lps'),
	(599581, 127, '2014-04-01 00:10:46.000000', 'consum', 0.0226, 'lps'),
	(599582, 127, '2014-04-01 00:10:47.000000', 'consum', 0.0225, 'lps'),
	(599583, 127, '2014-04-01 00:10:48.000000', 'consum', 0.0216, 'lps'),
	(599584, 127, '2014-04-01 00:10:49.000000', 'consum', 0.0216, 'lps'),
	(599585, 127, '2014-04-01 00:10:50.000000', 'consum', 0.0225, 'lps'),
	(599586, 127, '2014-04-01 00:10:51.000000', 'consum', 0.0221, 'lps'),
	(599587, 127, '2014-04-01 00:10:52.000000', 'consum', 0.0223, 'lps'),
	(599588, 127, '2014-04-01 00:10:53.000000', 'consum', 0.0218, 'lps'),
	(599589, 127, '2014-04-01 00:10:54.000000', 'consum', 0.0214, 'lps'),
	(599590, 127, '2014-04-01 00:10:55.000000', 'consum', 0.0229, 'lps'),
	(599591, 127, '2014-04-01 00:10:56.000000', 'consum', 0.0224, 'lps'),
	(599592, 127, '2014-04-01 00:10:57.000000', 'consum', 0.0227, 'lps'),
	(599593, 127, '2014-04-01 00:10:58.000000', 'consum', 0.0229, 'lps'),
	(599594, 127, '2014-04-01 00:10:59.000000', 'consum', 0.0211, 'lps'),
	(599595, 127, '2014-04-01 00:11:00.000000', 'consum', 0.0223, 'lps'),
	(599596, 127, '2014-04-01 00:11:01.000000', 'consum', 0.0231, 'lps'),
	(599597, 127, '2014-04-01 00:11:02.000000', 'consum', 0.0231, 'lps'),
	(599598, 127, '2014-04-01 00:11:03.000000', 'consum', 0.0211, 'lps'),
	(599599, 127, '2014-04-01 00:11:04.000000', 'consum', 0.0216, 'lps'),
	(599600, 127, '2014-04-01 00:11:05.000000', 'consum', 0.0214, 'lps'),
	(599601, 127, '2014-04-01 00:11:06.000000', 'consum', 0.0215, 'lps'),
	(599602, 127, '2014-04-01 00:11:07.000000', 'consum', 0.0222, 'lps'),
	(599603, 127, '2014-04-01 00:11:08.000000', 'consum', 0.0211, 'lps'),
	(599604, 127, '2014-04-01 00:11:09.000000', 'consum', 0.0223, 'lps'),
	(599605, 127, '2014-04-01 00:11:10.000000', 'consum', 0.0228, 'lps'),
	(599606, 127, '2014-04-01 00:11:11.000000', 'consum', 0.0219, 'lps'),
	(599607, 127, '2014-04-01 00:11:12.000000', 'consum', 0.0224, 'lps'),
	(599608, 127, '2014-04-01 00:11:13.000000', 'consum', 0.0210, 'lps'),
	(599609, 127, '2014-04-01 00:11:14.000000', 'consum', 0.0211, 'lps'),
	(599610, 127, '2014-04-01 00:11:15.000000', 'consum', 0.0217, 'lps'),
	(599611, 127, '2014-04-01 00:11:16.000000', 'consum', 0.0222, 'lps'),
	(599612, 127, '2014-04-01 00:11:17.000000', 'consum', 0.0225, 'lps'),
	(599613, 127, '2014-04-01 00:11:18.000000', 'consum', 0.0229, 'lps'),
	(599614, 127, '2014-04-01 00:11:19.000000', 'consum', 0.0215, 'lps'),
	(599615, 127, '2014-04-01 00:11:20.000000', 'consum', 0.0225, 'lps'),
	(599616, 127, '2014-04-01 00:11:21.000000', 'consum', 0.0225, 'lps'),
	(599617, 127, '2014-04-01 00:11:22.000000', 'consum', 0.0219, 'lps'),
	(599618, 127, '2014-04-01 00:11:23.000000', 'consum', 0.0211, 'lps'),
	(599619, 127, '2014-04-01 00:11:24.000000', 'consum', 0.0212, 'lps'),
	(599620, 127, '2014-04-01 00:11:25.000000', 'consum', 0.0215, 'lps'),
	(599621, 127, '2014-04-01 00:11:26.000000', 'consum', 0.0231, 'lps'),
	(599622, 127, '2014-04-01 00:11:27.000000', 'consum', 0.0213, 'lps'),
	(599623, 127, '2014-04-01 00:11:28.000000', 'consum', 0.0228, 'lps'),
	(599624, 127, '2014-04-01 00:11:29.000000', 'consum', 0.0226, 'lps'),
	(599625, 127, '2014-04-01 00:11:30.000000', 'consum', 0.0216, 'lps'),
	(599626, 127, '2014-04-01 00:11:31.000000', 'consum', 0.0213, 'lps'),
	(599627, 127, '2014-04-01 00:11:32.000000', 'consum', 0.0231, 'lps'),
	(599628, 127, '2014-04-01 00:11:33.000000', 'consum', 0.0218, 'lps'),
	(599629, 127, '2014-04-01 00:11:34.000000', 'consum', 0.0210, 'lps'),
	(599630, 127, '2014-04-01 00:11:35.000000', 'consum', 0.0228, 'lps'),
	(599631, 127, '2014-04-01 00:11:36.000000', 'consum', 0.0213, 'lps'),
	(599632, 127, '2014-04-01 00:11:37.000000', 'consum', 0.0218, 'lps'),
	(599633, 127, '2014-04-01 00:11:38.000000', 'consum', 0.0217, 'lps'),
	(599634, 127, '2014-04-01 00:11:39.000000', 'consum', 0.0222, 'lps'),
	(599635, 127, '2014-04-01 00:11:40.000000', 'consum', 0.0226, 'lps'),
	(599636, 127, '2014-04-01 00:11:41.000000', 'consum', 0.0214, 'lps'),
	(599637, 127, '2014-04-01 00:11:42.000000', 'consum', 0.0223, 'lps'),
	(599638, 127, '2014-04-01 00:11:43.000000', 'consum', 0.0223, 'lps'),
	(599639, 127, '2014-04-01 00:11:44.000000', 'consum', 0.0211, 'lps'),
	(599640, 127, '2014-04-01 00:11:45.000000', 'consum', 0.0223, 'lps'),
	(599641, 127, '2014-04-01 00:11:46.000000', 'consum', 0.0228, 'lps'),
	(599642, 127, '2014-04-01 00:11:47.000000', 'consum', 0.0218, 'lps'),
	(599643, 127, '2014-04-01 00:11:48.000000', 'consum', 0.0217, 'lps'),
	(599644, 127, '2014-04-01 00:11:49.000000', 'consum', 0.0224, 'lps'),
	(599645, 127, '2014-04-01 00:11:50.000000', 'consum', 0.0212, 'lps'),
	(599646, 127, '2014-04-01 00:11:51.000000', 'consum', 0.0225, 'lps'),
	(599647, 127, '2014-04-01 00:11:52.000000', 'consum', 0.0211, 'lps'),
	(599648, 127, '2014-04-01 00:11:53.000000', 'consum', 0.0215, 'lps'),
	(599649, 127, '2014-04-01 00:11:54.000000', 'consum', 0.0211, 'lps'),
	(599650, 127, '2014-04-01 00:11:55.000000', 'consum', 0.0223, 'lps'),
	(599651, 127, '2014-04-01 00:11:56.000000', 'consum', 0.0229, 'lps'),
	(599652, 127, '2014-04-01 00:11:57.000000', 'consum', 0.0220, 'lps'),
	(599653, 127, '2014-04-01 00:11:58.000000', 'consum', 0.0227, 'lps'),
	(599654, 127, '2014-04-01 00:11:59.000000', 'consum', 0.0221, 'lps'),
	(599655, 127, '2014-04-01 00:12:00.000000', 'consum', 0.0217, 'lps'),
	(599656, 127, '2014-04-01 00:12:01.000000', 'consum', 0.0210, 'lps'),
	(599657, 127, '2014-04-01 00:12:02.000000', 'consum', 0.0213, 'lps'),
	(599658, 127, '2014-04-01 00:12:03.000000', 'consum', 0.0224, 'lps'),
	(599659, 127, '2014-04-01 00:12:04.000000', 'consum', 0.0230, 'lps'),
	(599660, 127, '2014-04-01 00:12:05.000000', 'consum', 0.0223, 'lps'),
	(599661, 127, '2014-04-01 00:12:06.000000', 'consum', 0.0217, 'lps'),
	(599662, 127, '2014-04-01 00:12:07.000000', 'consum', 0.0228, 'lps'),
	(599663, 127, '2014-04-01 00:12:08.000000', 'consum', 0.0213, 'lps'),
	(599664, 127, '2014-04-01 00:12:09.000000', 'consum', 0.0215, 'lps'),
	(599665, 127, '2014-04-01 00:12:10.000000', 'consum', 0.0226, 'lps'),
	(599666, 127, '2014-04-01 00:12:11.000000', 'consum', 0.0210, 'lps'),
	(599667, 127, '2014-04-01 00:12:12.000000', 'consum', 0.0227, 'lps'),
	(599668, 127, '2014-04-01 00:12:13.000000', 'consum', 0.0230, 'lps'),
	(599669, 127, '2014-04-01 00:12:14.000000', 'consum', 0.0217, 'lps'),
	(599670, 127, '2014-04-01 00:12:15.000000', 'consum', 0.0228, 'lps'),
	(599671, 127, '2014-04-01 00:12:16.000000', 'consum', 0.0214, 'lps'),
	(599672, 127, '2014-04-01 00:12:17.000000', 'consum', 0.0220, 'lps'),
	(599673, 127, '2014-04-01 00:12:18.000000', 'consum', 0.0228, 'lps'),
	(599674, 127, '2014-04-01 00:12:19.000000', 'consum', 0.0228, 'lps'),
	(599675, 127, '2014-04-01 00:12:20.000000', 'consum', 0.0222, 'lps'),
	(599676, 127, '2014-04-01 00:12:21.000000', 'consum', 0.0217, 'lps'),
	(599677, 127, '2014-04-01 00:12:22.000000', 'consum', 0.0231, 'lps'),
	(599678, 127, '2014-04-01 00:12:23.000000', 'consum', 0.0231, 'lps'),
	(599679, 127, '2014-04-01 00:12:24.000000', 'consum', 0.0227, 'lps'),
	(599680, 127, '2014-04-01 00:12:25.000000', 'consum', 0.0212, 'lps'),
	(599681, 127, '2014-04-01 00:12:26.000000', 'consum', 0.0212, 'lps'),
	(599682, 127, '2014-04-01 00:12:27.000000', 'consum', 0.0216, 'lps'),
	(599683, 127, '2014-04-01 00:12:28.000000', 'consum', 0.0214, 'lps'),
	(599684, 127, '2014-04-01 00:12:29.000000', 'consum', 0.0212, 'lps'),
	(599685, 127, '2014-04-01 00:12:30.000000', 'consum', 0.0229, 'lps'),
	(599686, 127, '2014-04-01 00:12:31.000000', 'consum', 0.0212, 'lps'),
	(599687, 127, '2014-04-01 00:12:32.000000', 'consum', 0.0230, 'lps'),
	(599688, 127, '2014-04-01 00:12:33.000000', 'consum', 0.0216, 'lps'),
	(599689, 127, '2014-04-01 00:12:34.000000', 'consum', 0.0224, 'lps'),
	(599690, 127, '2014-04-01 00:12:35.000000', 'consum', 0.0217, 'lps'),
	(599691, 127, '2014-04-01 00:12:36.000000', 'consum', 0.0229, 'lps'),
	(599692, 127, '2014-04-01 00:12:37.000000', 'consum', 0.0216, 'lps'),
	(599693, 127, '2014-04-01 00:12:38.000000', 'consum', 0.0230, 'lps'),
	(599694, 127, '2014-04-01 00:12:39.000000', 'consum', 0.0225, 'lps'),
	(599695, 127, '2014-04-01 00:12:40.000000', 'consum', 0.0225, 'lps'),
	(599696, 127, '2014-04-01 00:12:41.000000', 'consum', 0.0219, 'lps'),
	(599697, 127, '2014-04-01 00:12:42.000000', 'consum', 0.0212, 'lps'),
	(599698, 127, '2014-04-01 00:12:43.000000', 'consum', 0.0215, 'lps'),
	(599699, 127, '2014-04-01 00:12:44.000000', 'consum', 0.0227, 'lps'),
	(599700, 127, '2014-04-01 00:12:45.000000', 'consum', 0.0218, 'lps'),
	(599701, 127, '2014-04-01 00:12:46.000000', 'consum', 0.0218, 'lps'),
	(599702, 127, '2014-04-01 00:12:47.000000', 'consum', 0.0229, 'lps'),
	(599703, 127, '2014-04-01 00:12:48.000000', 'consum', 0.0214, 'lps'),
	(599704, 127, '2014-04-01 00:12:49.000000', 'consum', 0.0220, 'lps'),
	(599705, 127, '2014-04-01 00:12:50.000000', 'consum', 0.0226, 'lps'),
	(599706, 127, '2014-04-01 00:12:51.000000', 'consum', 0.0215, 'lps'),
	(599707, 127, '2014-04-01 00:12:52.000000', 'consum', 0.0231, 'lps'),
	(599708, 127, '2014-04-01 00:12:53.000000', 'consum', 0.0215, 'lps'),
	(599709, 127, '2014-04-01 00:12:54.000000', 'consum', 0.0213, 'lps'),
	(599710, 127, '2014-04-01 00:12:55.000000', 'consum', 0.0213, 'lps'),
	(599711, 127, '2014-04-01 00:12:56.000000', 'consum', 0.0216, 'lps'),
	(599712, 127, '2014-04-01 00:12:57.000000', 'consum', 0.0229, 'lps'),
	(599713, 127, '2014-04-01 00:12:58.000000', 'consum', 0.0224, 'lps'),
	(599714, 127, '2014-04-01 00:12:59.000000', 'consum', 0.0225, 'lps'),
	(599715, 127, '2014-04-01 00:13:00.000000', 'consum', 0.0219, 'lps'),
	(599716, 127, '2014-04-01 00:13:01.000000', 'consum', 0.0211, 'lps'),
	(599717, 127, '2014-04-01 00:13:02.000000', 'consum', 0.0210, 'lps'),
	(599718, 127, '2014-04-01 00:13:03.000000', 'consum', 0.0210, 'lps'),
	(599719, 127, '2014-04-01 00:13:04.000000', 'consum', 0.0230, 'lps'),
	(599720, 127, '2014-04-01 00:13:05.000000', 'consum', 0.0223, 'lps'),
	(599721, 127, '2014-04-01 00:13:06.000000', 'consum', 0.0216, 'lps'),
	(599722, 127, '2014-04-01 00:13:07.000000', 'consum', 0.0224, 'lps'),
	(599723, 127, '2014-04-01 00:13:08.000000', 'consum', 0.0218, 'lps'),
	(599724, 127, '2014-04-01 00:13:09.000000', 'consum', 0.0230, 'lps'),
	(599725, 127, '2014-04-01 00:13:10.000000', 'consum', 0.0221, 'lps'),
	(599726, 127, '2014-04-01 00:13:11.000000', 'consum', 0.0228, 'lps'),
	(599727, 127, '2014-04-01 00:13:12.000000', 'consum', 0.0222, 'lps'),
	(599728, 127, '2014-04-01 00:13:13.000000', 'consum', 0.0216, 'lps'),
	(599729, 127, '2014-04-01 00:13:14.000000', 'consum', 0.0225, 'lps'),
	(599730, 127, '2014-04-01 00:13:15.000000', 'consum', 0.0227, 'lps'),
	(599731, 127, '2014-04-01 00:13:16.000000', 'consum', 0.0228, 'lps'),
	(599732, 127, '2014-04-01 00:13:17.000000', 'consum', 0.0227, 'lps'),
	(599733, 127, '2014-04-01 00:13:18.000000', 'consum', 0.0219, 'lps'),
	(599734, 127, '2014-04-01 00:13:19.000000', 'consum', 0.0226, 'lps'),
	(599735, 127, '2014-04-01 00:13:20.000000', 'consum', 0.0220, 'lps'),
	(599736, 127, '2014-04-01 00:13:21.000000', 'consum', 0.0211, 'lps'),
	(599737, 127, '2014-04-01 00:13:22.000000', 'consum', 0.0210, 'lps'),
	(599738, 127, '2014-04-01 00:13:23.000000', 'consum', 0.0228, 'lps'),
	(599739, 127, '2014-04-01 00:13:24.000000', 'consum', 0.0215, 'lps'),
	(599740, 127, '2014-04-01 00:13:25.000000', 'consum', 0.0223, 'lps'),
	(599741, 127, '2014-04-01 00:13:26.000000', 'consum', 0.0216, 'lps'),
	(599742, 127, '2014-04-01 00:13:27.000000', 'consum', 0.0225, 'lps'),
	(599743, 127, '2014-04-01 00:13:28.000000', 'consum', 0.0224, 'lps'),
	(599744, 127, '2014-04-01 00:13:29.000000', 'consum', 0.0213, 'lps'),
	(599745, 127, '2014-04-01 00:13:30.000000', 'consum', 0.0227, 'lps'),
	(599746, 127, '2014-04-01 00:13:31.000000', 'consum', 0.0220, 'lps'),
	(599747, 127, '2014-04-01 00:13:32.000000', 'consum', 0.0211, 'lps'),
	(599748, 127, '2014-04-01 00:13:33.000000', 'consum', 0.0228, 'lps'),
	(599749, 127, '2014-04-01 00:13:34.000000', 'consum', 0.0211, 'lps'),
	(599750, 127, '2014-04-01 00:13:35.000000', 'consum', 0.0228, 'lps'),
	(599751, 127, '2014-04-01 00:13:36.000000', 'consum', 0.0231, 'lps'),
	(599752, 127, '2014-04-01 00:13:37.000000', 'consum', 0.0215, 'lps'),
	(599753, 127, '2014-04-01 00:13:38.000000', 'consum', 0.0219, 'lps'),
	(599754, 127, '2014-04-01 00:13:39.000000', 'consum', 0.0217, 'lps'),
	(599755, 127, '2014-04-01 00:13:40.000000', 'consum', 0.0218, 'lps'),
	(599756, 127, '2014-04-01 00:13:41.000000', 'consum', 0.0229, 'lps'),
	(599757, 127, '2014-04-01 00:13:42.000000', 'consum', 0.0218, 'lps'),
	(599758, 127, '2014-04-01 00:13:43.000000', 'consum', 0.0212, 'lps'),
	(599759, 127, '2014-04-01 00:13:44.000000', 'consum', 0.0221, 'lps'),
	(599760, 127, '2014-04-01 00:13:45.000000', 'consum', 0.0216, 'lps'),
	(599761, 127, '2014-04-01 00:13:46.000000', 'consum', 0.0229, 'lps'),
	(599762, 127, '2014-04-01 00:13:47.000000', 'consum', 0.0222, 'lps'),
	(599763, 127, '2014-04-01 00:13:48.000000', 'consum', 0.0214, 'lps'),
	(599764, 127, '2014-04-01 00:13:49.000000', 'consum', 0.0218, 'lps'),
	(599765, 127, '2014-04-01 00:13:50.000000', 'consum', 0.0213, 'lps'),
	(599766, 127, '2014-04-01 00:13:51.000000', 'consum', 0.0225, 'lps'),
	(599767, 127, '2014-04-01 00:13:52.000000', 'consum', 0.0212, 'lps'),
	(599768, 127, '2014-04-01 00:13:53.000000', 'consum', 0.0217, 'lps'),
	(599769, 127, '2014-04-01 00:13:54.000000', 'consum', 0.0218, 'lps'),
	(599770, 127, '2014-04-01 00:13:55.000000', 'consum', 0.0229, 'lps'),
	(599771, 127, '2014-04-01 00:13:56.000000', 'consum', 0.0217, 'lps'),
	(599772, 127, '2014-04-01 00:13:57.000000', 'consum', 0.0210, 'lps'),
	(599773, 127, '2014-04-01 00:13:58.000000', 'consum', 0.0212, 'lps'),
	(599774, 127, '2014-04-01 00:13:59.000000', 'consum', 0.0220, 'lps'),
	(599775, 127, '2014-04-01 00:14:00.000000', 'consum', 0.0211, 'lps'),
	(599776, 127, '2014-04-01 00:14:01.000000', 'consum', 0.0228, 'lps'),
	(599777, 127, '2014-04-01 00:14:02.000000', 'consum', 0.0211, 'lps'),
	(599778, 127, '2014-04-01 00:14:03.000000', 'consum', 0.0226, 'lps'),
	(599779, 127, '2014-04-01 00:14:04.000000', 'consum', 0.0222, 'lps'),
	(599780, 127, '2014-04-01 00:14:05.000000', 'consum', 0.0222, 'lps'),
	(599781, 127, '2014-04-01 00:14:06.000000', 'consum', 0.0213, 'lps'),
	(599782, 127, '2014-04-01 00:14:07.000000', 'consum', 0.0210, 'lps'),
	(599783, 127, '2014-04-01 00:14:08.000000', 'consum', 0.0226, 'lps'),
	(599784, 127, '2014-04-01 00:14:09.000000', 'consum', 0.0224, 'lps'),
	(599785, 127, '2014-04-01 00:14:10.000000', 'consum', 0.0212, 'lps'),
	(599786, 127, '2014-04-01 00:14:11.000000', 'consum', 0.0219, 'lps'),
	(599787, 127, '2014-04-01 00:14:12.000000', 'consum', 0.0230, 'lps'),
	(599788, 127, '2014-04-01 00:14:13.000000', 'consum', 0.0219, 'lps'),
	(599789, 127, '2014-04-01 00:14:14.000000', 'consum', 0.0214, 'lps'),
	(599790, 127, '2014-04-01 00:14:15.000000', 'consum', 0.0229, 'lps'),
	(599791, 127, '2014-04-01 00:14:16.000000', 'consum', 0.0225, 'lps'),
	(599792, 127, '2014-04-01 00:14:17.000000', 'consum', 0.0229, 'lps'),
	(599793, 127, '2014-04-01 00:14:18.000000', 'consum', 0.0218, 'lps'),
	(599794, 127, '2014-04-01 00:14:19.000000', 'consum', 0.0214, 'lps'),
	(599795, 127, '2014-04-01 00:14:20.000000', 'consum', 0.0230, 'lps'),
	(599796, 127, '2014-04-01 00:14:21.000000', 'consum', 0.0230, 'lps'),
	(599797, 127, '2014-04-01 00:14:22.000000', 'consum', 0.0231, 'lps'),
	(599798, 127, '2014-04-01 00:14:23.000000', 'consum', 0.0210, 'lps'),
	(599799, 127, '2014-04-01 00:14:24.000000', 'consum', 0.0212, 'lps'),
	(599800, 127, '2014-04-01 00:14:25.000000', 'consum', 0.0223, 'lps'),
	(599801, 127, '2014-04-01 00:14:26.000000', 'consum', 0.0226, 'lps'),
	(599802, 127, '2014-04-01 00:14:27.000000', 'consum', 0.0228, 'lps'),
	(599803, 127, '2014-04-01 00:14:28.000000', 'consum', 0.0210, 'lps'),
	(599804, 127, '2014-04-01 00:14:29.000000', 'consum', 0.0222, 'lps'),
	(599805, 127, '2014-04-01 00:14:30.000000', 'consum', 0.0226, 'lps'),
	(599806, 127, '2014-04-01 00:14:31.000000', 'consum', 0.0231, 'lps'),
	(599807, 127, '2014-04-01 00:14:32.000000', 'consum', 0.0224, 'lps'),
	(599808, 127, '2014-04-01 00:14:33.000000', 'consum', 0.0217, 'lps'),
	(599809, 127, '2014-04-01 00:14:34.000000', 'consum', 0.0225, 'lps'),
	(599810, 127, '2014-04-01 00:14:35.000000', 'consum', 0.0219, 'lps'),
	(599811, 127, '2014-04-01 00:14:36.000000', 'consum', 0.0213, 'lps'),
	(599812, 127, '2014-04-01 00:14:37.000000', 'consum', 0.0220, 'lps'),
	(599813, 127, '2014-04-01 00:14:38.000000', 'consum', 0.0228, 'lps'),
	(599814, 127, '2014-04-01 00:14:39.000000', 'consum', 0.0229, 'lps'),
	(599815, 127, '2014-04-01 00:14:40.000000', 'consum', 0.0228, 'lps'),
	(599816, 127, '2014-04-01 00:14:41.000000', 'consum', 0.0221, 'lps'),
	(599817, 127, '2014-04-01 00:14:42.000000', 'consum', 0.0213, 'lps'),
	(599818, 127, '2014-04-01 00:14:43.000000', 'consum', 0.0212, 'lps'),
	(599819, 127, '2014-04-01 00:14:44.000000', 'consum', 0.0215, 'lps'),
	(599820, 127, '2014-04-01 00:14:45.000000', 'consum', 0.0227, 'lps'),
	(599821, 127, '2014-04-01 00:14:46.000000', 'consum', 0.0216, 'lps'),
	(599822, 127, '2014-04-01 00:14:47.000000', 'consum', 0.0210, 'lps'),
	(599823, 127, '2014-04-01 00:14:48.000000', 'consum', 0.0216, 'lps'),
	(599824, 127, '2014-04-01 00:14:49.000000', 'consum', 0.0217, 'lps'),
	(599825, 127, '2014-04-01 00:14:50.000000', 'consum', 0.0228, 'lps'),
	(599826, 127, '2014-04-01 00:14:51.000000', 'consum', 0.0212, 'lps'),
	(599827, 127, '2014-04-01 00:14:52.000000', 'consum', 0.0210, 'lps'),
	(599828, 127, '2014-04-01 00:14:53.000000', 'consum', 0.0229, 'lps'),
	(599829, 127, '2014-04-01 00:14:54.000000', 'consum', 0.0217, 'lps'),
	(599830, 127, '2014-04-01 00:14:55.000000', 'consum', 0.0211, 'lps'),
	(599831, 127, '2014-04-01 00:14:56.000000', 'consum', 0.0216, 'lps'),
	(599832, 127, '2014-04-01 00:14:57.000000', 'consum', 0.0216, 'lps'),
	(599833, 127, '2014-04-01 00:14:58.000000', 'consum', 0.0223, 'lps'),
	(599834, 127, '2014-04-01 00:14:59.000000', 'consum', 0.0213, 'lps'),
	(599835, 127, '2014-04-01 00:15:00.000000', 'consum', 0.0230, 'lps'),
	(599836, 127, '2014-04-01 00:15:01.000000', 'consum', 0.0213, 'lps'),
	(599837, 127, '2014-04-01 00:15:02.000000', 'consum', 0.0211, 'lps'),
	(599838, 127, '2014-04-01 00:15:03.000000', 'consum', 0.0226, 'lps'),
	(599839, 127, '2014-04-01 00:15:04.000000', 'consum', 0.0222, 'lps'),
	(599840, 127, '2014-04-01 00:15:05.000000', 'consum', 0.0224, 'lps'),
	(599841, 127, '2014-04-01 00:15:06.000000', 'consum', 0.0223, 'lps'),
	(599842, 127, '2014-04-01 00:15:07.000000', 'consum', 0.0231, 'lps'),
	(599843, 127, '2014-04-01 00:15:08.000000', 'consum', 0.0212, 'lps'),
	(599844, 127, '2014-04-01 00:15:09.000000', 'consum', 0.0224, 'lps'),
	(599845, 127, '2014-04-01 00:15:10.000000', 'consum', 0.0229, 'lps'),
	(599846, 127, '2014-04-01 00:15:11.000000', 'consum', 0.0219, 'lps'),
	(599847, 127, '2014-04-01 00:15:12.000000', 'consum', 0.0222, 'lps'),
	(599848, 127, '2014-04-01 00:15:13.000000', 'consum', 0.0222, 'lps'),
	(599849, 127, '2014-04-01 00:15:14.000000', 'consum', 0.0212, 'lps'),
	(599850, 127, '2014-04-01 00:15:15.000000', 'consum', 0.0229, 'lps'),
	(599851, 127, '2014-04-01 00:15:16.000000', 'consum', 0.0210, 'lps'),
	(599852, 127, '2014-04-01 00:15:17.000000', 'consum', 0.0221, 'lps'),
	(599853, 127, '2014-04-01 00:15:18.000000', 'consum', 0.0220, 'lps'),
	(599854, 127, '2014-04-01 00:15:19.000000', 'consum', 0.0230, 'lps'),
	(599855, 127, '2014-04-01 00:15:20.000000', 'consum', 0.0214, 'lps'),
	(599856, 127, '2014-04-01 00:15:21.000000', 'consum', 0.0215, 'lps'),
	(599857, 127, '2014-04-01 00:15:22.000000', 'consum', 0.0225, 'lps'),
	(599858, 127, '2014-04-01 00:15:23.000000', 'consum', 0.0224, 'lps'),
	(599859, 127, '2014-04-01 00:15:24.000000', 'consum', 0.0213, 'lps'),
	(599860, 127, '2014-04-01 00:15:25.000000', 'consum', 0.0230, 'lps'),
	(599861, 127, '2014-04-01 00:15:26.000000', 'consum', 0.0213, 'lps'),
	(599862, 127, '2014-04-01 00:15:27.000000', 'consum', 0.0210, 'lps'),
	(599863, 127, '2014-04-01 00:15:28.000000', 'consum', 0.0221, 'lps'),
	(599864, 127, '2014-04-01 00:15:29.000000', 'consum', 0.0225, 'lps'),
	(599865, 127, '2014-04-01 00:15:30.000000', 'consum', 0.0228, 'lps'),
	(599866, 127, '2014-04-01 00:15:31.000000', 'consum', 0.0211, 'lps'),
	(599867, 127, '2014-04-01 00:15:32.000000', 'consum', 0.0228, 'lps'),
	(599868, 127, '2014-04-01 00:15:33.000000', 'consum', 0.0210, 'lps'),
	(599869, 127, '2014-04-01 00:15:34.000000', 'consum', 0.0222, 'lps'),
	(599870, 127, '2014-04-01 00:15:35.000000', 'consum', 0.0225, 'lps'),
	(599871, 127, '2014-04-01 00:15:36.000000', 'consum', 0.0228, 'lps'),
	(599872, 127, '2014-04-01 00:15:37.000000', 'consum', 0.0213, 'lps'),
	(599873, 127, '2014-04-01 00:15:38.000000', 'consum', 0.0217, 'lps'),
	(599874, 127, '2014-04-01 00:15:39.000000', 'consum', 0.0211, 'lps'),
	(599875, 127, '2014-04-01 00:15:40.000000', 'consum', 0.0218, 'lps'),
	(599876, 127, '2014-04-01 00:15:41.000000', 'consum', 0.0226, 'lps'),
	(599877, 127, '2014-04-01 00:15:42.000000', 'consum', 0.0224, 'lps'),
	(599878, 127, '2014-04-01 00:15:43.000000', 'consum', 0.0231, 'lps'),
	(599879, 127, '2014-04-01 00:15:44.000000', 'consum', 0.0230, 'lps'),
	(599880, 127, '2014-04-01 00:15:45.000000', 'consum', 0.0227, 'lps'),
	(599881, 127, '2014-04-01 00:15:46.000000', 'consum', 0.0211, 'lps'),
	(599882, 127, '2014-04-01 00:15:47.000000', 'consum', 0.0229, 'lps'),
	(599883, 127, '2014-04-01 00:15:48.000000', 'consum', 0.0218, 'lps'),
	(599884, 127, '2014-04-01 00:15:49.000000', 'consum', 0.0213, 'lps'),
	(599885, 127, '2014-04-01 00:15:50.000000', 'consum', 0.0223, 'lps'),
	(599886, 127, '2014-04-01 00:15:51.000000', 'consum', 0.0224, 'lps'),
	(599887, 127, '2014-04-01 00:15:52.000000', 'consum', 0.0219, 'lps'),
	(599888, 127, '2014-04-01 00:15:53.000000', 'consum', 0.0215, 'lps'),
	(599889, 127, '2014-04-01 00:15:54.000000', 'consum', 0.0229, 'lps'),
	(599890, 127, '2014-04-01 00:15:55.000000', 'consum', 0.0224, 'lps'),
	(599891, 127, '2014-04-01 00:15:56.000000', 'consum', 0.0222, 'lps'),
	(599892, 127, '2014-04-01 00:15:57.000000', 'consum', 0.0231, 'lps'),
	(599893, 127, '2014-04-01 00:15:58.000000', 'consum', 0.0214, 'lps'),
	(599894, 127, '2014-04-01 00:15:59.000000', 'consum', 0.0210, 'lps'),
	(599895, 127, '2014-04-01 00:16:00.000000', 'consum', 0.0222, 'lps'),
	(599896, 127, '2014-04-01 00:16:01.000000', 'consum', 0.0228, 'lps'),
	(599897, 127, '2014-04-01 00:16:02.000000', 'consum', 0.0218, 'lps'),
	(599898, 127, '2014-04-01 00:16:03.000000', 'consum', 0.0219, 'lps'),
	(599899, 127, '2014-04-01 00:16:04.000000', 'consum', 0.0210, 'lps'),
	(599900, 127, '2014-04-01 00:16:05.000000', 'consum', 0.0226, 'lps'),
	(599901, 127, '2014-04-01 00:16:06.000000', 'consum', 0.0227, 'lps'),
	(599902, 127, '2014-04-01 00:16:07.000000', 'consum', 0.0226, 'lps'),
	(599903, 127, '2014-04-01 00:16:08.000000', 'consum', 0.0216, 'lps'),
	(599904, 127, '2014-04-01 00:16:09.000000', 'consum', 0.0214, 'lps'),
	(599905, 127, '2014-04-01 00:16:10.000000', 'consum', 0.0211, 'lps'),
	(599906, 127, '2014-04-01 00:16:11.000000', 'consum', 0.0227, 'lps'),
	(599907, 127, '2014-04-01 00:16:12.000000', 'consum', 0.0227, 'lps'),
	(599908, 127, '2014-04-01 00:16:13.000000', 'consum', 0.0221, 'lps'),
	(599909, 127, '2014-04-01 00:16:14.000000', 'consum', 0.0215, 'lps'),
	(599910, 127, '2014-04-01 00:16:15.000000', 'consum', 0.0223, 'lps'),
	(599911, 127, '2014-04-01 00:16:16.000000', 'consum', 0.0217, 'lps'),
	(599912, 127, '2014-04-01 00:16:17.000000', 'consum', 0.0229, 'lps'),
	(599913, 127, '2014-04-01 00:16:18.000000', 'consum', 0.0218, 'lps'),
	(599914, 127, '2014-04-01 00:16:19.000000', 'consum', 0.0218, 'lps'),
	(599915, 127, '2014-04-01 00:16:20.000000', 'consum', 0.0223, 'lps'),
	(599916, 127, '2014-04-01 00:16:21.000000', 'consum', 0.0231, 'lps'),
	(599917, 127, '2014-04-01 00:16:22.000000', 'consum', 0.0211, 'lps'),
	(599918, 127, '2014-04-01 00:16:23.000000', 'consum', 0.0217, 'lps'),
	(599919, 127, '2014-04-01 00:16:24.000000', 'consum', 0.0219, 'lps'),
	(599920, 127, '2014-04-01 00:16:25.000000', 'consum', 0.0215, 'lps'),
	(599921, 127, '2014-04-01 00:16:26.000000', 'consum', 0.0230, 'lps'),
	(599922, 127, '2014-04-01 00:16:27.000000', 'consum', 0.0231, 'lps'),
	(599923, 127, '2014-04-01 00:16:28.000000', 'consum', 0.0211, 'lps'),
	(599924, 127, '2014-04-01 00:16:29.000000', 'consum', 0.0218, 'lps'),
	(599925, 127, '2014-04-01 00:16:30.000000', 'consum', 0.0225, 'lps'),
	(599926, 127, '2014-04-01 00:16:31.000000', 'consum', 0.0219, 'lps'),
	(599927, 127, '2014-04-01 00:16:32.000000', 'consum', 0.0231, 'lps'),
	(599928, 127, '2014-04-01 00:16:33.000000', 'consum', 0.0221, 'lps'),
	(599929, 127, '2014-04-01 00:16:34.000000', 'consum', 0.0227, 'lps'),
	(599930, 127, '2014-04-01 00:16:35.000000', 'consum', 0.0217, 'lps'),
	(599931, 127, '2014-04-01 00:16:36.000000', 'consum', 0.0215, 'lps'),
	(599932, 127, '2014-04-01 00:16:37.000000', 'consum', 0.0218, 'lps'),
	(599933, 127, '2014-04-01 00:16:38.000000', 'consum', 0.0212, 'lps'),
	(599934, 127, '2014-04-01 00:16:39.000000', 'consum', 0.0219, 'lps'),
	(599935, 127, '2014-04-01 00:16:40.000000', 'consum', 0.0229, 'lps'),
	(599936, 127, '2014-04-01 00:16:41.000000', 'consum', 0.0211, 'lps'),
	(599937, 127, '2014-04-01 00:16:42.000000', 'consum', 0.0225, 'lps'),
	(599938, 127, '2014-04-01 00:16:43.000000', 'consum', 0.0216, 'lps'),
	(599939, 127, '2014-04-01 00:16:44.000000', 'consum', 0.0219, 'lps'),
	(599940, 127, '2014-04-01 00:16:45.000000', 'consum', 0.0216, 'lps'),
	(599941, 127, '2014-04-01 00:16:46.000000', 'consum', 0.0211, 'lps'),
	(599942, 127, '2014-04-01 00:16:47.000000', 'consum', 0.0221, 'lps'),
	(599943, 127, '2014-04-01 00:16:48.000000', 'consum', 0.0217, 'lps'),
	(599944, 127, '2014-04-01 00:16:49.000000', 'consum', 0.0214, 'lps'),
	(599945, 127, '2014-04-01 00:16:50.000000', 'consum', 0.0230, 'lps'),
	(599946, 127, '2014-04-01 00:16:51.000000', 'consum', 0.0211, 'lps'),
	(599947, 127, '2014-04-01 00:16:52.000000', 'consum', 0.0224, 'lps'),
	(599948, 127, '2014-04-01 00:16:53.000000', 'consum', 0.0231, 'lps'),
	(599949, 127, '2014-04-01 00:16:54.000000', 'consum', 0.0228, 'lps'),
	(599950, 127, '2014-04-01 00:16:55.000000', 'consum', 0.0219, 'lps'),
	(599951, 127, '2014-04-01 00:16:56.000000', 'consum', 0.0221, 'lps'),
	(599952, 127, '2014-04-01 00:16:57.000000', 'consum', 0.0216, 'lps'),
	(599953, 127, '2014-04-01 00:16:58.000000', 'consum', 0.0229, 'lps'),
	(599954, 127, '2014-04-01 00:16:59.000000', 'consum', 0.0221, 'lps'),
	(599955, 127, '2014-04-01 00:17:00.000000', 'consum', 0.0231, 'lps'),
	(599956, 127, '2014-04-01 00:17:01.000000', 'consum', 0.0219, 'lps'),
	(599957, 127, '2014-04-01 00:17:02.000000', 'consum', 0.0212, 'lps'),
	(599958, 127, '2014-04-01 00:17:03.000000', 'consum', 0.0216, 'lps'),
	(599959, 127, '2014-04-01 00:17:04.000000', 'consum', 0.0211, 'lps'),
	(599960, 127, '2014-04-01 00:17:05.000000', 'consum', 0.0219, 'lps'),
	(599961, 127, '2014-04-01 00:17:06.000000', 'consum', 0.0230, 'lps'),
	(599962, 127, '2014-04-01 00:17:07.000000', 'consum', 0.0220, 'lps'),
	(599963, 127, '2014-04-01 00:17:08.000000', 'consum', 0.0220, 'lps'),
	(599964, 127, '2014-04-01 00:17:09.000000', 'consum', 0.0230, 'lps'),
	(599965, 127, '2014-04-01 00:17:10.000000', 'consum', 0.0215, 'lps'),
	(599966, 127, '2014-04-01 00:17:11.000000', 'consum', 0.0219, 'lps'),
	(599967, 127, '2014-04-01 00:17:12.000000', 'consum', 0.0218, 'lps'),
	(599968, 127, '2014-04-01 00:17:13.000000', 'consum', 0.0225, 'lps'),
	(599969, 127, '2014-04-01 00:17:14.000000', 'consum', 0.0217, 'lps'),
	(599970, 127, '2014-04-01 00:17:15.000000', 'consum', 0.0224, 'lps'),
	(599971, 127, '2014-04-01 00:17:16.000000', 'consum', 0.0213, 'lps'),
	(599972, 127, '2014-04-01 00:17:17.000000', 'consum', 0.0227, 'lps'),
	(599973, 127, '2014-04-01 00:17:18.000000', 'consum', 0.0222, 'lps'),
	(599974, 127, '2014-04-01 00:17:19.000000', 'consum', 0.0220, 'lps'),
	(599975, 127, '2014-04-01 00:17:20.000000', 'consum', 0.0223, 'lps'),
	(599976, 127, '2014-04-01 00:17:21.000000', 'consum', 0.0222, 'lps'),
	(599977, 127, '2014-04-01 00:17:22.000000', 'consum', 0.0212, 'lps'),
	(599978, 127, '2014-04-01 00:17:23.000000', 'consum', 0.0228, 'lps'),
	(599979, 127, '2014-04-01 00:17:24.000000', 'consum', 0.0228, 'lps'),
	(599980, 127, '2014-04-01 00:17:25.000000', 'consum', 0.0226, 'lps'),
	(599981, 127, '2014-04-01 00:17:26.000000', 'consum', 0.0215, 'lps'),
	(599982, 127, '2014-04-01 00:17:27.000000', 'consum', 0.0230, 'lps'),
	(599983, 127, '2014-04-01 00:17:28.000000', 'consum', 0.0231, 'lps'),
	(599984, 127, '2014-04-01 00:17:29.000000', 'consum', 0.0212, 'lps'),
	(599985, 127, '2014-04-01 00:17:30.000000', 'consum', 0.0223, 'lps'),
	(599986, 127, '2014-04-01 00:17:31.000000', 'consum', 0.0225, 'lps'),
	(599987, 127, '2014-04-01 00:17:32.000000', 'consum', 0.0226, 'lps'),
	(599988, 127, '2014-04-01 00:17:33.000000', 'consum', 0.0224, 'lps'),
	(599989, 127, '2014-04-01 00:17:34.000000', 'consum', 0.0210, 'lps'),
	(599990, 127, '2014-04-01 00:17:35.000000', 'consum', 0.0212, 'lps'),
	(599991, 127, '2014-04-01 00:17:36.000000', 'consum', 0.0222, 'lps'),
	(599992, 127, '2014-04-01 00:17:37.000000', 'consum', 0.0218, 'lps'),
	(599993, 127, '2014-04-01 00:17:38.000000', 'consum', 0.0217, 'lps'),
	(599994, 127, '2014-04-01 00:17:39.000000', 'consum', 0.0219, 'lps'),
	(599995, 127, '2014-04-01 00:17:40.000000', 'consum', 0.0215, 'lps'),
	(599996, 127, '2014-04-01 00:17:41.000000', 'consum', 0.0229, 'lps'),
	(599997, 127, '2014-04-01 00:17:42.000000', 'consum', 0.0227, 'lps'),
	(599998, 127, '2014-04-01 00:17:43.000000', 'consum', 0.0213, 'lps'),
	(599999, 127, '2014-04-01 00:17:44.000000', 'consum', 0.0220, 'lps'),
	(600000, 127, '2014-04-01 00:17:45.000000', 'consum', 0.0228, 'lps'),
	(600001, 127, '2014-04-01 00:17:46.000000', 'consum', 0.0228, 'lps'),
	(600002, 127, '2014-04-01 00:17:47.000000', 'consum', 0.0225, 'lps'),
	(600003, 127, '2014-04-01 00:17:48.000000', 'consum', 0.0231, 'lps'),
	(600004, 127, '2014-04-01 00:17:49.000000', 'consum', 0.0226, 'lps'),
	(600005, 127, '2014-04-01 00:17:50.000000', 'consum', 0.0229, 'lps'),
	(600006, 127, '2014-04-01 00:17:51.000000', 'consum', 0.0212, 'lps'),
	(600007, 127, '2014-04-01 00:17:52.000000', 'consum', 0.0229, 'lps'),
	(600008, 127, '2014-04-01 00:17:53.000000', 'consum', 0.0213, 'lps'),
	(600009, 127, '2014-04-01 00:17:54.000000', 'consum', 0.0211, 'lps'),
	(600010, 127, '2014-04-01 00:17:55.000000', 'consum', 0.0229, 'lps'),
	(600011, 127, '2014-04-01 00:17:56.000000', 'consum', 0.0214, 'lps'),
	(600012, 127, '2014-04-01 00:17:57.000000', 'consum', 0.0216, 'lps'),
	(600013, 127, '2014-04-01 00:17:58.000000', 'consum', 0.0229, 'lps'),
	(600014, 127, '2014-04-01 00:17:59.000000', 'consum', 0.0223, 'lps'),
	(600015, 127, '2014-04-01 00:18:00.000000', 'consum', 0.0220, 'lps'),
	(600016, 127, '2014-04-01 00:18:01.000000', 'consum', 0.0219, 'lps'),
	(600017, 127, '2014-04-01 00:18:02.000000', 'consum', 0.0226, 'lps'),
	(600018, 127, '2014-04-01 00:18:03.000000', 'consum', 0.0220, 'lps'),
	(600019, 127, '2014-04-01 00:18:04.000000', 'consum', 0.0211, 'lps'),
	(600020, 127, '2014-04-01 00:18:05.000000', 'consum', 0.0231, 'lps'),
	(600021, 127, '2014-04-01 00:18:06.000000', 'consum', 0.0224, 'lps'),
	(600022, 127, '2014-04-01 00:18:07.000000', 'consum', 0.0217, 'lps'),
	(600023, 127, '2014-04-01 00:18:08.000000', 'consum', 0.0225, 'lps'),
	(600024, 127, '2014-04-01 00:18:09.000000', 'consum', 0.0219, 'lps'),
	(600025, 127, '2014-04-01 00:18:10.000000', 'consum', 0.0213, 'lps'),
	(600026, 127, '2014-04-01 00:18:11.000000', 'consum', 0.0220, 'lps'),
	(600027, 127, '2014-04-01 00:18:12.000000', 'consum', 0.0229, 'lps'),
	(600028, 127, '2014-04-01 00:18:13.000000', 'consum', 0.0210, 'lps'),
	(600029, 127, '2014-04-01 00:18:14.000000', 'consum', 0.0221, 'lps'),
	(600030, 127, '2014-04-01 00:18:15.000000', 'consum', 0.0220, 'lps'),
	(600031, 127, '2014-04-01 00:18:16.000000', 'consum', 0.0228, 'lps'),
	(600032, 127, '2014-04-01 00:18:17.000000', 'consum', 0.0228, 'lps'),
	(600033, 127, '2014-04-01 00:18:18.000000', 'consum', 0.0222, 'lps'),
	(600034, 127, '2014-04-01 00:18:19.000000', 'consum', 0.0218, 'lps'),
	(600035, 127, '2014-04-01 00:18:20.000000', 'consum', 0.0215, 'lps'),
	(600036, 127, '2014-04-01 00:18:21.000000', 'consum', 0.0231, 'lps'),
	(600037, 127, '2014-04-01 00:18:22.000000', 'consum', 0.0214, 'lps'),
	(600038, 127, '2014-04-01 00:18:23.000000', 'consum', 0.0211, 'lps'),
	(600039, 127, '2014-04-01 00:18:24.000000', 'consum', 0.0227, 'lps'),
	(600040, 127, '2014-04-01 00:18:25.000000', 'consum', 0.0226, 'lps'),
	(600041, 127, '2014-04-01 00:18:26.000000', 'consum', 0.0218, 'lps'),
	(600042, 127, '2014-04-01 00:18:27.000000', 'consum', 0.0224, 'lps'),
	(600043, 127, '2014-04-01 00:18:28.000000', 'consum', 0.0210, 'lps'),
	(600044, 127, '2014-04-01 00:18:29.000000', 'consum', 0.0216, 'lps'),
	(600045, 127, '2014-04-01 00:18:30.000000', 'consum', 0.0216, 'lps'),
	(600046, 127, '2014-04-01 00:18:31.000000', 'consum', 0.0225, 'lps'),
	(600047, 127, '2014-04-01 00:18:32.000000', 'consum', 0.0221, 'lps'),
	(600048, 127, '2014-04-01 00:18:33.000000', 'consum', 0.0224, 'lps'),
	(600049, 127, '2014-04-01 00:18:34.000000', 'consum', 0.0222, 'lps'),
	(600050, 127, '2014-04-01 00:18:35.000000', 'consum', 0.0230, 'lps'),
	(600051, 127, '2014-04-01 00:18:36.000000', 'consum', 0.0230, 'lps'),
	(600052, 127, '2014-04-01 00:18:37.000000', 'consum', 0.0227, 'lps'),
	(600053, 127, '2014-04-01 00:18:38.000000', 'consum', 0.0214, 'lps'),
	(600054, 127, '2014-04-01 00:18:39.000000', 'consum', 0.0224, 'lps'),
	(600055, 127, '2014-04-01 00:18:40.000000', 'consum', 0.0226, 'lps'),
	(600056, 127, '2014-04-01 00:18:41.000000', 'consum', 0.0226, 'lps'),
	(600057, 127, '2014-04-01 00:18:42.000000', 'consum', 0.0221, 'lps'),
	(600058, 127, '2014-04-01 00:18:43.000000', 'consum', 0.0216, 'lps'),
	(600059, 127, '2014-04-01 00:18:44.000000', 'consum', 0.0210, 'lps'),
	(600060, 127, '2014-04-01 00:18:45.000000', 'consum', 0.0214, 'lps'),
	(600061, 127, '2014-04-01 00:18:46.000000', 'consum', 0.0230, 'lps'),
	(600062, 127, '2014-04-01 00:18:47.000000', 'consum', 0.0212, 'lps'),
	(600063, 127, '2014-04-01 00:18:48.000000', 'consum', 0.0225, 'lps'),
	(600064, 127, '2014-04-01 00:18:49.000000', 'consum', 0.0214, 'lps'),
	(600065, 127, '2014-04-01 00:18:50.000000', 'consum', 0.0230, 'lps'),
	(600066, 127, '2014-04-01 00:18:51.000000', 'consum', 0.0230, 'lps'),
	(600067, 127, '2014-04-01 00:18:52.000000', 'consum', 0.0231, 'lps'),
	(600068, 127, '2014-04-01 00:18:53.000000', 'consum', 0.0210, 'lps'),
	(600069, 127, '2014-04-01 00:18:54.000000', 'consum', 0.0216, 'lps'),
	(600070, 127, '2014-04-01 00:18:55.000000', 'consum', 0.0217, 'lps'),
	(600071, 127, '2014-04-01 00:18:56.000000', 'consum', 0.0226, 'lps'),
	(600072, 127, '2014-04-01 00:18:57.000000', 'consum', 0.0228, 'lps'),
	(600073, 127, '2014-04-01 00:18:58.000000', 'consum', 0.0229, 'lps'),
	(600074, 127, '2014-04-01 00:18:59.000000', 'consum', 0.0228, 'lps'),
	(600075, 127, '2014-04-01 00:19:00.000000', 'consum', 0.0222, 'lps'),
	(600076, 127, '2014-04-01 00:19:01.000000', 'consum', 0.0217, 'lps'),
	(600077, 127, '2014-04-01 00:19:02.000000', 'consum', 0.0211, 'lps'),
	(600078, 127, '2014-04-01 00:19:03.000000', 'consum', 0.0215, 'lps'),
	(600079, 127, '2014-04-01 00:19:04.000000', 'consum', 0.0213, 'lps'),
	(600080, 127, '2014-04-01 00:19:05.000000', 'consum', 0.0230, 'lps'),
	(600081, 127, '2014-04-01 00:19:06.000000', 'consum', 0.0214, 'lps'),
	(600082, 127, '2014-04-01 00:19:07.000000', 'consum', 0.0215, 'lps'),
	(600083, 127, '2014-04-01 00:19:08.000000', 'consum', 0.0223, 'lps'),
	(600084, 127, '2014-04-01 00:19:09.000000', 'consum', 0.0218, 'lps'),
	(600085, 127, '2014-04-01 00:19:10.000000', 'consum', 0.0212, 'lps'),
	(600086, 127, '2014-04-01 00:19:11.000000', 'consum', 0.0219, 'lps'),
	(600087, 127, '2014-04-01 00:19:12.000000', 'consum', 0.0225, 'lps'),
	(600088, 127, '2014-04-01 00:19:13.000000', 'consum', 0.0217, 'lps'),
	(600089, 127, '2014-04-01 00:19:14.000000', 'consum', 0.0221, 'lps'),
	(600090, 127, '2014-04-01 00:19:15.000000', 'consum', 0.0224, 'lps'),
	(600091, 127, '2014-04-01 00:19:16.000000', 'consum', 0.0225, 'lps'),
	(600092, 127, '2014-04-01 00:19:17.000000', 'consum', 0.0222, 'lps'),
	(600093, 127, '2014-04-01 00:19:18.000000', 'consum', 0.0227, 'lps'),
	(600094, 127, '2014-04-01 00:19:19.000000', 'consum', 0.0215, 'lps'),
	(600095, 127, '2014-04-01 00:19:20.000000', 'consum', 0.0226, 'lps'),
	(600096, 127, '2014-04-01 00:19:21.000000', 'consum', 0.0212, 'lps'),
	(600097, 127, '2014-04-01 00:19:22.000000', 'consum', 0.0216, 'lps'),
	(600098, 127, '2014-04-01 00:19:23.000000', 'consum', 0.0212, 'lps'),
	(600099, 127, '2014-04-01 00:19:24.000000', 'consum', 0.0227, 'lps'),
	(600100, 127, '2014-04-01 00:19:25.000000', 'consum', 0.0220, 'lps'),
	(600101, 127, '2014-04-01 00:19:26.000000', 'consum', 0.0212, 'lps'),
	(600102, 127, '2014-04-01 00:19:27.000000', 'consum', 0.0211, 'lps'),
	(600103, 127, '2014-04-01 00:19:28.000000', 'consum', 0.0210, 'lps'),
	(600104, 127, '2014-04-01 00:19:29.000000', 'consum', 0.0230, 'lps'),
	(600105, 127, '2014-04-01 00:19:30.000000', 'consum', 0.0221, 'lps'),
	(600106, 127, '2014-04-01 00:19:31.000000', 'consum', 0.0230, 'lps'),
	(600107, 127, '2014-04-01 00:19:32.000000', 'consum', 0.0211, 'lps'),
	(600108, 127, '2014-04-01 00:19:33.000000', 'consum', 0.0222, 'lps'),
	(600109, 127, '2014-04-01 00:19:34.000000', 'consum', 0.0225, 'lps'),
	(600110, 127, '2014-04-01 00:19:35.000000', 'consum', 0.0225, 'lps'),
	(600111, 127, '2014-04-01 00:19:36.000000', 'consum', 0.0219, 'lps'),
	(600112, 127, '2014-04-01 00:19:37.000000', 'consum', 0.0213, 'lps'),
	(600113, 127, '2014-04-01 00:19:38.000000', 'consum', 0.0218, 'lps'),
	(600114, 127, '2014-04-01 00:19:39.000000', 'consum', 0.0219, 'lps'),
	(600115, 127, '2014-04-01 00:19:40.000000', 'consum', 0.0211, 'lps'),
	(600116, 127, '2014-04-01 00:19:41.000000', 'consum', 0.0231, 'lps'),
	(600117, 127, '2014-04-01 00:19:42.000000', 'consum', 0.0226, 'lps'),
	(600118, 127, '2014-04-01 00:19:43.000000', 'consum', 0.0226, 'lps'),
	(600119, 127, '2014-04-01 00:19:44.000000', 'consum', 0.0223, 'lps'),
	(600120, 127, '2014-04-01 00:19:45.000000', 'consum', 0.0227, 'lps'),
	(600121, 127, '2014-04-01 00:19:46.000000', 'consum', 0.0211, 'lps'),
	(600122, 127, '2014-04-01 00:19:47.000000', 'consum', 0.0210, 'lps'),
	(600123, 127, '2014-04-01 00:19:48.000000', 'consum', 0.0228, 'lps'),
	(600124, 127, '2014-04-01 00:19:49.000000', 'consum', 0.0212, 'lps'),
	(600125, 127, '2014-04-01 00:19:50.000000', 'consum', 0.0211, 'lps'),
	(600126, 127, '2014-04-01 00:19:51.000000', 'consum', 0.0230, 'lps'),
	(600127, 127, '2014-04-01 00:19:52.000000', 'consum', 0.0222, 'lps'),
	(600128, 127, '2014-04-01 00:19:53.000000', 'consum', 0.0231, 'lps'),
	(600129, 127, '2014-04-01 00:19:54.000000', 'consum', 0.0214, 'lps'),
	(600130, 127, '2014-04-01 00:19:55.000000', 'consum', 0.0211, 'lps'),
	(600131, 127, '2014-04-01 00:19:56.000000', 'consum', 0.0224, 'lps'),
	(600132, 127, '2014-04-01 00:19:57.000000', 'consum', 0.0211, 'lps'),
	(600133, 127, '2014-04-01 00:19:58.000000', 'consum', 0.0221, 'lps'),
	(600134, 127, '2014-04-01 00:19:59.000000', 'consum', 0.0216, 'lps'),
	(600135, 127, '2014-04-01 00:20:00.000000', 'consum', 0.0229, 'lps'),
	(600136, 127, '2014-04-01 00:20:01.000000', 'consum', 0.0224, 'lps'),
	(600137, 127, '2014-04-01 00:20:02.000000', 'consum', 0.0222, 'lps'),
	(600138, 127, '2014-04-01 00:20:03.000000', 'consum', 0.0228, 'lps'),
	(600139, 127, '2014-04-01 00:20:04.000000', 'consum', 0.0221, 'lps'),
	(600140, 127, '2014-04-01 00:20:05.000000', 'consum', 0.0211, 'lps'),
	(600141, 127, '2014-04-01 00:20:06.000000', 'consum', 0.0225, 'lps'),
	(600142, 127, '2014-04-01 00:20:07.000000', 'consum', 0.0217, 'lps'),
	(600143, 127, '2014-04-01 00:20:08.000000', 'consum', 0.0222, 'lps'),
	(600144, 127, '2014-04-01 00:20:09.000000', 'consum', 0.0228, 'lps'),
	(600145, 127, '2014-04-01 00:20:10.000000', 'consum', 0.0222, 'lps'),
	(600146, 127, '2014-04-01 00:20:11.000000', 'consum', 0.0216, 'lps'),
	(600147, 127, '2014-04-01 00:20:12.000000', 'consum', 0.0225, 'lps'),
	(600148, 127, '2014-04-01 00:20:13.000000', 'consum', 0.0226, 'lps'),
	(600149, 127, '2014-04-01 00:20:14.000000', 'consum', 0.0224, 'lps'),
	(600150, 127, '2014-04-01 00:20:15.000000', 'consum', 0.0230, 'lps'),
	(600151, 127, '2014-04-01 00:20:16.000000', 'consum', 0.0224, 'lps'),
	(600152, 127, '2014-04-01 00:20:17.000000', 'consum', 0.0223, 'lps'),
	(600153, 127, '2014-04-01 00:20:18.000000', 'consum', 0.0212, 'lps'),
	(600154, 127, '2014-04-01 00:20:19.000000', 'consum', 0.0223, 'lps'),
	(600155, 127, '2014-04-01 00:20:20.000000', 'consum', 0.0228, 'lps'),
	(600156, 127, '2014-04-01 00:20:21.000000', 'consum', 0.0215, 'lps'),
	(600157, 127, '2014-04-01 00:20:22.000000', 'consum', 0.0225, 'lps'),
	(600158, 127, '2014-04-01 00:20:23.000000', 'consum', 0.0225, 'lps'),
	(600159, 127, '2014-04-01 00:20:24.000000', 'consum', 0.0222, 'lps'),
	(600160, 127, '2014-04-01 00:20:25.000000', 'consum', 0.0226, 'lps'),
	(600161, 127, '2014-04-01 00:20:26.000000', 'consum', 0.0229, 'lps'),
	(600162, 127, '2014-04-01 00:20:27.000000', 'consum', 0.0217, 'lps'),
	(600163, 127, '2014-04-01 00:20:28.000000', 'consum', 0.0210, 'lps'),
	(600164, 127, '2014-04-01 00:20:29.000000', 'consum', 0.0212, 'lps'),
	(600165, 127, '2014-04-01 00:20:30.000000', 'consum', 0.0218, 'lps'),
	(600166, 127, '2014-04-01 00:20:31.000000', 'consum', 0.0226, 'lps'),
	(600167, 127, '2014-04-01 00:20:32.000000', 'consum', 0.0220, 'lps'),
	(600168, 127, '2014-04-01 00:20:33.000000', 'consum', 0.0211, 'lps'),
	(600169, 127, '2014-04-01 00:20:34.000000', 'consum', 0.0231, 'lps'),
	(600170, 127, '2014-04-01 00:20:35.000000', 'consum', 0.0226, 'lps'),
	(600171, 127, '2014-04-01 00:20:36.000000', 'consum', 0.0226, 'lps'),
	(600172, 127, '2014-04-01 00:20:37.000000', 'consum', 0.0220, 'lps'),
	(600173, 127, '2014-04-01 00:20:38.000000', 'consum', 0.0215, 'lps'),
	(600174, 127, '2014-04-01 00:20:39.000000', 'consum', 0.0225, 'lps'),
	(600175, 127, '2014-04-01 00:20:40.000000', 'consum', 0.0226, 'lps'),
	(600176, 127, '2014-04-01 00:20:41.000000', 'consum', 0.0224, 'lps'),
	(600177, 127, '2014-04-01 00:20:42.000000', 'consum', 0.0231, 'lps'),
	(600178, 127, '2014-04-01 00:20:43.000000', 'consum', 0.0230, 'lps'),
	(600179, 127, '2014-04-01 00:20:44.000000', 'consum', 0.0227, 'lps'),
	(600180, 127, '2014-04-01 00:20:45.000000', 'consum', 0.0215, 'lps'),
	(600181, 127, '2014-04-01 00:20:46.000000', 'consum', 0.0226, 'lps'),
	(600182, 127, '2014-04-01 00:20:47.000000', 'consum', 0.0210, 'lps'),
	(600183, 127, '2014-04-01 00:20:48.000000', 'consum', 0.0231, 'lps'),
	(600184, 127, '2014-04-01 00:20:49.000000', 'consum', 0.0225, 'lps'),
	(600185, 127, '2014-04-01 00:20:50.000000', 'consum', 0.0222, 'lps'),
	(600186, 127, '2014-04-01 00:20:51.000000', 'consum', 0.0225, 'lps'),
	(600187, 127, '2014-04-01 00:20:52.000000', 'consum', 0.0228, 'lps'),
	(600188, 127, '2014-04-01 00:20:53.000000', 'consum', 0.0213, 'lps'),
	(600189, 127, '2014-04-01 00:20:54.000000', 'consum', 0.0216, 'lps'),
	(600190, 127, '2014-04-01 00:20:55.000000', 'consum', 0.0210, 'lps'),
	(600191, 127, '2014-04-01 00:20:56.000000', 'consum', 0.0215, 'lps'),
	(600192, 127, '2014-04-01 00:20:57.000000', 'consum', 0.0213, 'lps'),
	(600193, 127, '2014-04-01 00:20:58.000000', 'consum', 0.0210, 'lps'),
	(600194, 127, '2014-04-01 00:20:59.000000', 'consum', 0.0222, 'lps'),
	(600195, 127, '2014-04-01 00:21:00.000000', 'consum', 0.0227, 'lps'),
	(600196, 127, '2014-04-01 00:21:01.000000', 'consum', 0.0218, 'lps'),
	(600197, 127, '2014-04-01 00:21:02.000000', 'consum', 0.0220, 'lps'),
	(600198, 127, '2014-04-01 00:21:03.000000', 'consum', 0.0213, 'lps'),
	(600199, 127, '2014-04-01 00:21:04.000000', 'consum', 0.0217, 'lps'),
	(600200, 127, '2014-04-01 00:21:05.000000', 'consum', 0.0214, 'lps'),
	(600201, 127, '2014-04-01 00:21:06.000000', 'consum', 0.0231, 'lps'),
	(600202, 127, '2014-04-01 00:21:07.000000', 'consum', 0.0217, 'lps'),
	(600203, 127, '2014-04-01 00:21:08.000000', 'consum', 0.0225, 'lps'),
	(600204, 127, '2014-04-01 00:21:09.000000', 'consum', 0.0221, 'lps'),
	(600205, 127, '2014-04-01 00:21:10.000000', 'consum', 0.0220, 'lps'),
	(600206, 127, '2014-04-01 00:21:11.000000', 'consum', 0.0227, 'lps'),
	(600207, 127, '2014-04-01 00:21:12.000000', 'consum', 0.0223, 'lps'),
	(600208, 127, '2014-04-01 00:21:13.000000', 'consum', 0.0225, 'lps'),
	(600209, 127, '2014-04-01 00:21:14.000000', 'consum', 0.0226, 'lps'),
	(600210, 127, '2014-04-01 00:21:15.000000', 'consum', 0.0221, 'lps'),
	(600211, 127, '2014-04-01 00:21:16.000000', 'consum', 0.0219, 'lps'),
	(600212, 127, '2014-04-01 00:21:17.000000', 'consum', 0.0223, 'lps'),
	(600213, 127, '2014-04-01 00:21:18.000000', 'consum', 0.0224, 'lps'),
	(600214, 127, '2014-04-01 00:21:19.000000', 'consum', 0.0220, 'lps'),
	(600215, 127, '2014-04-01 00:21:20.000000', 'consum', 0.0218, 'lps'),
	(600216, 127, '2014-04-01 00:21:21.000000', 'consum', 0.0221, 'lps'),
	(600217, 127, '2014-04-01 00:21:22.000000', 'consum', 0.0219, 'lps'),
	(600218, 127, '2014-04-01 00:21:23.000000', 'consum', 0.0224, 'lps'),
	(600219, 127, '2014-04-01 00:21:24.000000', 'consum', 0.0230, 'lps'),
	(600220, 127, '2014-04-01 00:21:25.000000', 'consum', 0.0225, 'lps'),
	(600221, 127, '2014-04-01 00:21:26.000000', 'consum', 0.0225, 'lps'),
	(600222, 127, '2014-04-01 00:21:27.000000', 'consum', 0.0217, 'lps'),
	(600223, 127, '2014-04-01 00:21:28.000000', 'consum', 0.0223, 'lps'),
	(600224, 127, '2014-04-01 00:21:29.000000', 'consum', 0.0211, 'lps'),
	(600225, 127, '2014-04-01 00:21:30.000000', 'consum', 0.0220, 'lps'),
	(600226, 127, '2014-04-01 00:21:31.000000', 'consum', 0.0213, 'lps'),
	(600227, 127, '2014-04-01 00:21:32.000000', 'consum', 0.0217, 'lps'),
	(600228, 127, '2014-04-01 00:21:33.000000', 'consum', 0.0215, 'lps'),
	(600229, 127, '2014-04-01 00:21:34.000000', 'consum', 0.0213, 'lps'),
	(600230, 127, '2014-04-01 00:21:35.000000', 'consum', 0.0213, 'lps'),
	(600231, 127, '2014-04-01 00:21:36.000000', 'consum', 0.0216, 'lps'),
	(600232, 127, '2014-04-01 00:21:37.000000', 'consum', 0.0230, 'lps'),
	(600233, 127, '2014-04-01 00:21:38.000000', 'consum', 0.0225, 'lps'),
	(600234, 127, '2014-04-01 00:21:39.000000', 'consum', 0.0229, 'lps'),
	(600235, 127, '2014-04-01 00:21:40.000000', 'consum', 0.0214, 'lps'),
	(600236, 127, '2014-04-01 00:21:41.000000', 'consum', 0.0219, 'lps'),
	(600237, 127, '2014-04-01 00:21:42.000000', 'consum', 0.0220, 'lps'),
	(600238, 127, '2014-04-01 00:21:43.000000', 'consum', 0.0212, 'lps'),
	(600239, 127, '2014-04-01 00:21:44.000000', 'consum', 0.0214, 'lps'),
	(600240, 127, '2014-04-01 00:21:45.000000', 'consum', 0.0226, 'lps'),
	(600241, 127, '2014-04-01 00:21:46.000000', 'consum', 0.0231, 'lps'),
	(600242, 127, '2014-04-01 00:21:47.000000', 'consum', 0.0224, 'lps'),
	(600243, 127, '2014-04-01 00:21:48.000000', 'consum', 0.0216, 'lps'),
	(600244, 127, '2014-04-01 00:21:49.000000', 'consum', 0.0222, 'lps'),
	(600245, 127, '2014-04-01 00:21:50.000000', 'consum', 0.0231, 'lps'),
	(600246, 127, '2014-04-01 00:21:51.000000', 'consum', 0.0215, 'lps'),
	(600247, 127, '2014-04-01 00:21:52.000000', 'consum', 0.0214, 'lps'),
	(600248, 127, '2014-04-01 00:21:53.000000', 'consum', 0.0215, 'lps'),
	(600249, 127, '2014-04-01 00:21:54.000000', 'consum', 0.0225, 'lps'),
	(600250, 127, '2014-04-01 00:21:55.000000', 'consum', 0.0227, 'lps'),
	(600251, 127, '2014-04-01 00:21:56.000000', 'consum', 0.0230, 'lps'),
	(600252, 127, '2014-04-01 00:21:57.000000', 'consum', 0.0213, 'lps'),
	(600253, 127, '2014-04-01 00:21:58.000000', 'consum', 0.0230, 'lps'),
	(600254, 127, '2014-04-01 00:21:59.000000', 'consum', 0.0216, 'lps'),
	(600255, 127, '2014-04-01 00:22:00.000000', 'consum', 0.0225, 'lps'),
	(600256, 127, '2014-04-01 00:22:01.000000', 'consum', 0.0223, 'lps'),
	(600257, 127, '2014-04-01 00:22:02.000000', 'consum', 0.0231, 'lps'),
	(600258, 127, '2014-04-01 00:22:03.000000', 'consum', 0.0211, 'lps'),
	(600259, 127, '2014-04-01 00:22:04.000000', 'consum', 0.0220, 'lps'),
	(600260, 127, '2014-04-01 00:22:05.000000', 'consum', 0.0211, 'lps'),
	(600261, 127, '2014-04-01 00:22:06.000000', 'consum', 0.0231, 'lps'),
	(600262, 127, '2014-04-01 00:22:07.000000', 'consum', 0.0225, 'lps'),
	(600263, 127, '2014-04-01 00:22:08.000000', 'consum', 0.0222, 'lps'),
	(600264, 127, '2014-04-01 00:22:09.000000', 'consum', 0.0226, 'lps'),
	(600265, 127, '2014-04-01 00:22:10.000000', 'consum', 0.0211, 'lps'),
	(600266, 127, '2014-04-01 00:22:11.000000', 'consum', 0.0210, 'lps'),
	(600267, 127, '2014-04-01 00:22:12.000000', 'consum', 0.0210, 'lps'),
	(600268, 127, '2014-04-01 00:22:13.000000', 'consum', 0.0231, 'lps'),
	(600269, 127, '2014-04-01 00:22:14.000000', 'consum', 0.0227, 'lps'),
	(600270, 127, '2014-04-01 00:22:15.000000', 'consum', 0.0212, 'lps'),
	(600271, 127, '2014-04-01 00:22:16.000000', 'consum', 0.0211, 'lps'),
	(600272, 127, '2014-04-01 00:22:17.000000', 'consum', 0.0231, 'lps'),
	(600273, 127, '2014-04-01 00:22:18.000000', 'consum', 0.0227, 'lps'),
	(600274, 127, '2014-04-01 00:22:19.000000', 'consum', 0.0211, 'lps'),
	(600275, 127, '2014-04-01 00:22:20.000000', 'consum', 0.0228, 'lps'),
	(600276, 127, '2014-04-01 00:22:21.000000', 'consum', 0.0211, 'lps'),
	(600277, 127, '2014-04-01 00:22:22.000000', 'consum', 0.0227, 'lps'),
	(600278, 127, '2014-04-01 00:22:23.000000', 'consum', 0.0228, 'lps'),
	(600279, 127, '2014-04-01 00:22:24.000000', 'consum', 0.0227, 'lps'),
	(600280, 127, '2014-04-01 00:22:25.000000', 'consum', 0.0217, 'lps'),
	(600281, 127, '2014-04-01 00:22:26.000000', 'consum', 0.0220, 'lps'),
	(600282, 127, '2014-04-01 00:22:27.000000', 'consum', 0.0214, 'lps'),
	(600283, 127, '2014-04-01 00:22:28.000000', 'consum', 0.0225, 'lps'),
	(600284, 127, '2014-04-01 00:22:29.000000', 'consum', 0.0229, 'lps'),
	(600285, 127, '2014-04-01 00:22:30.000000', 'consum', 0.0218, 'lps'),
	(600286, 127, '2014-04-01 00:22:31.000000', 'consum', 0.0216, 'lps'),
	(600287, 127, '2014-04-01 00:22:32.000000', 'consum', 0.0216, 'lps'),
	(600288, 127, '2014-04-01 00:22:33.000000', 'consum', 0.0220, 'lps'),
	(600289, 127, '2014-04-01 00:22:34.000000', 'consum', 0.0224, 'lps'),
	(600290, 127, '2014-04-01 00:22:35.000000', 'consum', 0.0226, 'lps'),
	(600291, 127, '2014-04-01 00:22:36.000000', 'consum', 0.0226, 'lps'),
	(600292, 127, '2014-04-01 00:22:37.000000', 'consum', 0.0221, 'lps'),
	(600293, 127, '2014-04-01 00:22:38.000000', 'consum', 0.0217, 'lps'),
	(600294, 127, '2014-04-01 00:22:39.000000', 'consum', 0.0213, 'lps'),
	(600295, 127, '2014-04-01 00:22:40.000000', 'consum', 0.0226, 'lps'),
	(600296, 127, '2014-04-01 00:22:41.000000', 'consum', 0.0216, 'lps'),
	(600297, 127, '2014-04-01 00:22:42.000000', 'consum', 0.0215, 'lps'),
	(600298, 127, '2014-04-01 00:22:43.000000', 'consum', 0.0218, 'lps'),
	(600299, 127, '2014-04-01 00:22:44.000000', 'consum', 0.0214, 'lps'),
	(600300, 127, '2014-04-01 00:22:45.000000', 'consum', 0.0229, 'lps'),
	(600301, 127, '2014-04-01 00:22:46.000000', 'consum', 0.0225, 'lps'),
	(600302, 127, '2014-04-01 00:22:47.000000', 'consum', 0.0228, 'lps'),
	(600303, 127, '2014-04-01 00:22:48.000000', 'consum', 0.0213, 'lps'),
	(600304, 127, '2014-04-01 00:22:49.000000', 'consum', 0.0213, 'lps'),
	(600305, 127, '2014-04-01 00:22:50.000000', 'consum', 0.0220, 'lps'),
	(600306, 127, '2014-04-01 00:22:51.000000', 'consum', 0.0227, 'lps'),
	(600307, 127, '2014-04-01 00:22:52.000000', 'consum', 0.0224, 'lps'),
	(600308, 127, '2014-04-01 00:22:53.000000', 'consum', 0.0227, 'lps'),
	(600309, 127, '2014-04-01 00:22:54.000000', 'consum', 0.0211, 'lps'),
	(600310, 127, '2014-04-01 00:22:55.000000', 'consum', 0.0231, 'lps'),
	(600311, 127, '2014-04-01 00:22:56.000000', 'consum', 0.0226, 'lps'),
	(600312, 127, '2014-04-01 00:22:57.000000', 'consum', 0.0225, 'lps'),
	(600313, 127, '2014-04-01 00:22:58.000000', 'consum', 0.0217, 'lps'),
	(600314, 127, '2014-04-01 00:22:59.000000', 'consum', 0.0223, 'lps'),
	(600315, 127, '2014-04-01 00:23:00.000000', 'consum', 0.0231, 'lps'),
	(600316, 127, '2014-04-01 00:23:01.000000', 'consum', 0.0212, 'lps'),
	(600317, 127, '2014-04-01 00:23:02.000000', 'consum', 0.0225, 'lps'),
	(600318, 127, '2014-04-01 00:23:03.000000', 'consum', 0.0211, 'lps'),
	(600319, 127, '2014-04-01 00:23:04.000000', 'consum', 0.0214, 'lps'),
	(600320, 127, '2014-04-01 00:23:05.000000', 'consum', 0.0228, 'lps'),
	(600321, 127, '2014-04-01 00:23:06.000000', 'consum', 0.0222, 'lps'),
	(600322, 127, '2014-04-01 00:23:07.000000', 'consum', 0.0215, 'lps'),
	(600323, 127, '2014-04-01 00:23:08.000000', 'consum', 0.0224, 'lps'),
	(600324, 127, '2014-04-01 00:23:09.000000', 'consum', 0.0222, 'lps'),
	(600325, 127, '2014-04-01 00:23:10.000000', 'consum', 0.0227, 'lps'),
	(600326, 127, '2014-04-01 00:23:11.000000', 'consum', 0.0216, 'lps'),
	(600327, 127, '2014-04-01 00:23:12.000000', 'consum', 0.0210, 'lps'),
	(600328, 127, '2014-04-01 00:23:13.000000', 'consum', 0.0215, 'lps'),
	(600329, 127, '2014-04-01 00:23:14.000000', 'consum', 0.0215, 'lps'),
	(600330, 127, '2014-04-01 00:23:15.000000', 'consum', 0.0221, 'lps'),
	(600331, 127, '2014-04-01 00:23:16.000000', 'consum', 0.0228, 'lps'),
	(600332, 127, '2014-04-01 00:23:17.000000', 'consum', 0.0222, 'lps'),
	(600333, 127, '2014-04-01 00:23:18.000000', 'consum', 0.0217, 'lps'),
	(600334, 127, '2014-04-01 00:23:19.000000', 'consum', 0.0231, 'lps'),
	(600335, 127, '2014-04-01 00:23:20.000000', 'consum', 0.0230, 'lps'),
	(600336, 127, '2014-04-01 00:23:21.000000', 'consum', 0.0226, 'lps'),
	(600337, 127, '2014-04-01 00:23:22.000000', 'consum', 0.0228, 'lps'),
	(600338, 127, '2014-04-01 00:23:23.000000', 'consum', 0.0231, 'lps'),
	(600339, 127, '2014-04-01 00:23:24.000000', 'consum', 0.0218, 'lps'),
	(600340, 127, '2014-04-01 00:23:25.000000', 'consum', 0.0231, 'lps'),
	(600341, 127, '2014-04-01 00:23:26.000000', 'consum', 0.0225, 'lps'),
	(600342, 127, '2014-04-01 00:23:27.000000', 'consum', 0.0224, 'lps'),
	(600343, 127, '2014-04-01 00:23:28.000000', 'consum', 0.0211, 'lps'),
	(600344, 127, '2014-04-01 00:23:29.000000', 'consum', 0.0218, 'lps'),
	(600345, 127, '2014-04-01 00:23:30.000000', 'consum', 0.0225, 'lps'),
	(600346, 127, '2014-04-01 00:23:31.000000', 'consum', 0.0220, 'lps'),
	(600347, 127, '2014-04-01 00:23:32.000000', 'consum', 0.0212, 'lps'),
	(600348, 127, '2014-04-01 00:23:33.000000', 'consum', 0.0216, 'lps'),
	(600349, 127, '2014-04-01 00:23:34.000000', 'consum', 0.0211, 'lps'),
	(600350, 127, '2014-04-01 00:23:35.000000', 'consum', 0.0222, 'lps'),
	(600351, 127, '2014-04-01 00:23:36.000000', 'consum', 0.0220, 'lps'),
	(600352, 127, '2014-04-01 00:23:37.000000', 'consum', 0.0225, 'lps'),
	(600353, 127, '2014-04-01 00:23:38.000000', 'consum', 0.0212, 'lps'),
	(600354, 127, '2014-04-01 00:23:39.000000', 'consum', 0.0221, 'lps'),
	(600355, 127, '2014-04-01 00:23:40.000000', 'consum', 0.0213, 'lps'),
	(600356, 127, '2014-04-01 00:23:41.000000', 'consum', 0.0217, 'lps'),
	(600357, 127, '2014-04-01 00:23:42.000000', 'consum', 0.0216, 'lps'),
	(600358, 127, '2014-04-01 00:23:43.000000', 'consum', 0.0216, 'lps'),
	(600359, 127, '2014-04-01 00:23:44.000000', 'consum', 0.0224, 'lps'),
	(600360, 127, '2014-04-01 00:23:45.000000', 'consum', 0.0217, 'lps'),
	(600361, 127, '2014-04-01 00:23:46.000000', 'consum', 0.0225, 'lps'),
	(600362, 127, '2014-04-01 00:23:47.000000', 'consum', 0.0221, 'lps'),
	(600363, 127, '2014-04-01 00:23:48.000000', 'consum', 0.0221, 'lps'),
	(600364, 127, '2014-04-01 00:23:49.000000', 'consum', 0.0212, 'lps'),
	(600365, 127, '2014-04-01 00:23:50.000000', 'consum', 0.0229, 'lps'),
	(600366, 127, '2014-04-01 00:23:51.000000', 'consum', 0.0210, 'lps'),
	(600367, 127, '2014-04-01 00:23:52.000000', 'consum', 0.0223, 'lps'),
	(600368, 127, '2014-04-01 00:23:53.000000', 'consum', 0.0229, 'lps'),
	(600369, 127, '2014-04-01 00:23:54.000000', 'consum', 0.0224, 'lps'),
	(600370, 127, '2014-04-01 00:23:55.000000', 'consum', 0.0223, 'lps'),
	(600371, 127, '2014-04-01 00:23:56.000000', 'consum', 0.0211, 'lps'),
	(600372, 127, '2014-04-01 00:23:57.000000', 'consum', 0.0223, 'lps'),
	(600373, 127, '2014-04-01 00:23:58.000000', 'consum', 0.0227, 'lps'),
	(600374, 127, '2014-04-01 00:23:59.000000', 'consum', 0.0212, 'lps'),
	(600375, 127, '2014-04-01 00:24:00.000000', 'consum', 0.0213, 'lps'),
	(600376, 127, '2014-04-01 00:24:01.000000', 'consum', 0.0222, 'lps'),
	(600377, 127, '2014-04-01 00:24:02.000000', 'consum', 0.0214, 'lps'),
	(600378, 127, '2014-04-01 00:24:03.000000', 'consum', 0.0218, 'lps'),
	(600379, 127, '2014-04-01 00:24:04.000000', 'consum', 0.0217, 'lps'),
	(600380, 127, '2014-04-01 00:24:05.000000', 'consum', 0.0222, 'lps'),
	(600381, 127, '2014-04-01 00:24:06.000000', 'consum', 0.0228, 'lps'),
	(600382, 127, '2014-04-01 00:24:07.000000', 'consum', 0.0218, 'lps'),
	(600383, 127, '2014-04-01 00:24:08.000000', 'consum', 0.0219, 'lps'),
	(600384, 127, '2014-04-01 00:24:09.000000', 'consum', 0.0210, 'lps'),
	(600385, 127, '2014-04-01 00:24:10.000000', 'consum', 0.0227, 'lps'),
	(600386, 127, '2014-04-01 00:24:11.000000', 'consum', 0.0231, 'lps'),
	(600387, 127, '2014-04-01 00:24:12.000000', 'consum', 0.0218, 'lps'),
	(600388, 127, '2014-04-01 00:24:13.000000', 'consum', 0.0213, 'lps'),
	(600389, 127, '2014-04-01 00:24:14.000000', 'consum', 0.0220, 'lps'),
	(600390, 127, '2014-04-01 00:24:15.000000', 'consum', 0.0211, 'lps'),
	(600391, 127, '2014-04-01 00:24:16.000000', 'consum', 0.0227, 'lps'),
	(600392, 127, '2014-04-01 00:24:17.000000', 'consum', 0.0228, 'lps'),
	(600393, 127, '2014-04-01 00:24:18.000000', 'consum', 0.0226, 'lps'),
	(600394, 127, '2014-04-01 00:24:19.000000', 'consum', 0.0217, 'lps'),
	(600395, 127, '2014-04-01 00:24:20.000000', 'consum', 0.0216, 'lps'),
	(600396, 127, '2014-04-01 00:24:21.000000', 'consum', 0.0222, 'lps'),
	(600397, 127, '2014-04-01 00:24:22.000000', 'consum', 0.0228, 'lps'),
	(600398, 127, '2014-04-01 00:24:23.000000', 'consum', 0.0223, 'lps'),
	(600399, 127, '2014-04-01 00:24:24.000000', 'consum', 0.0220, 'lps'),
	(600400, 127, '2014-04-01 00:24:25.000000', 'consum', 0.0220, 'lps'),
	(600401, 127, '2014-04-01 00:24:26.000000', 'consum', 0.0211, 'lps'),
	(600402, 127, '2014-04-01 00:24:27.000000', 'consum', 0.0227, 'lps'),
	(600403, 127, '2014-04-01 00:24:28.000000', 'consum', 0.0227, 'lps'),
	(600404, 127, '2014-04-01 00:24:29.000000', 'consum', 0.0223, 'lps'),
	(600405, 127, '2014-04-01 00:24:30.000000', 'consum', 0.0223, 'lps'),
	(600406, 127, '2014-04-01 00:24:31.000000', 'consum', 0.0217, 'lps'),
	(600407, 127, '2014-04-01 00:24:32.000000', 'consum', 0.0228, 'lps'),
	(600408, 127, '2014-04-01 00:24:33.000000', 'consum', 0.0213, 'lps'),
	(600409, 127, '2014-04-01 00:24:34.000000', 'consum', 0.0217, 'lps'),
	(600410, 127, '2014-04-01 00:24:35.000000', 'consum', 0.0212, 'lps'),
	(600411, 127, '2014-04-01 00:24:36.000000', 'consum', 0.0222, 'lps'),
	(600412, 127, '2014-04-01 00:24:37.000000', 'consum', 0.0222, 'lps'),
	(600413, 127, '2014-04-01 00:24:38.000000', 'consum', 0.0212, 'lps'),
	(600414, 127, '2014-04-01 00:24:39.000000', 'consum', 0.0228, 'lps'),
	(600415, 127, '2014-04-01 00:24:40.000000', 'consum', 0.0229, 'lps'),
	(600416, 127, '2014-04-01 00:24:41.000000', 'consum', 0.0231, 'lps'),
	(600417, 127, '2014-04-01 00:24:42.000000', 'consum', 0.0215, 'lps'),
	(600418, 127, '2014-04-01 00:24:43.000000', 'consum', 0.0216, 'lps'),
	(600419, 127, '2014-04-01 00:24:44.000000', 'consum', 0.0225, 'lps'),
	(600420, 127, '2014-04-01 00:24:45.000000', 'consum', 0.0224, 'lps'),
	(600421, 127, '2014-04-01 00:24:46.000000', 'consum', 0.0214, 'lps'),
	(600422, 127, '2014-04-01 00:24:47.000000', 'consum', 0.0230, 'lps'),
	(600423, 127, '2014-04-01 00:24:48.000000', 'consum', 0.0212, 'lps'),
	(600424, 127, '2014-04-01 00:24:49.000000', 'consum', 0.0226, 'lps'),
	(600425, 127, '2014-04-01 00:24:50.000000', 'consum', 0.0217, 'lps'),
	(600426, 127, '2014-04-01 00:24:51.000000', 'consum', 0.0222, 'lps'),
	(600427, 127, '2014-04-01 00:24:52.000000', 'consum', 0.0225, 'lps'),
	(600428, 127, '2014-04-01 00:24:53.000000', 'consum', 0.0230, 'lps'),
	(600429, 127, '2014-04-01 00:24:54.000000', 'consum', 0.0219, 'lps'),
	(600430, 127, '2014-04-01 00:24:55.000000', 'consum', 0.0219, 'lps'),
	(600431, 127, '2014-04-01 00:24:56.000000', 'consum', 0.0230, 'lps'),
	(600432, 127, '2014-04-01 00:24:57.000000', 'consum', 0.0215, 'lps'),
	(600433, 127, '2014-04-01 00:24:58.000000', 'consum', 0.0219, 'lps'),
	(600434, 127, '2014-04-01 00:24:59.000000', 'consum', 0.0221, 'lps'),
	(600435, 127, '2014-04-01 00:25:00.000000', 'consum', 0.0216, 'lps'),
	(600436, 127, '2014-04-01 00:25:01.000000', 'consum', 0.0229, 'lps'),
	(600437, 127, '2014-04-01 00:25:02.000000', 'consum', 0.0220, 'lps'),
	(600438, 127, '2014-04-01 00:25:03.000000', 'consum', 0.0226, 'lps'),
	(600439, 127, '2014-04-01 00:25:04.000000', 'consum', 0.0218, 'lps'),
	(600440, 127, '2014-04-01 00:25:05.000000', 'consum', 0.0224, 'lps'),
	(600441, 127, '2014-04-01 00:25:06.000000', 'consum', 0.0211, 'lps'),
	(600442, 127, '2014-04-01 00:25:07.000000', 'consum', 0.0217, 'lps'),
	(600443, 127, '2014-04-01 00:25:08.000000', 'consum', 0.0223, 'lps'),
	(600444, 127, '2014-04-01 00:25:09.000000', 'consum', 0.0231, 'lps'),
	(600445, 127, '2014-04-01 00:25:10.000000', 'consum', 0.0213, 'lps'),
	(600446, 127, '2014-04-01 00:25:11.000000', 'consum', 0.0226, 'lps'),
	(600447, 127, '2014-04-01 00:25:12.000000', 'consum', 0.0218, 'lps'),
	(600448, 127, '2014-04-01 00:25:13.000000', 'consum', 0.0221, 'lps'),
	(600449, 127, '2014-04-01 00:25:14.000000', 'consum', 0.0222, 'lps'),
	(600450, 127, '2014-04-01 00:25:15.000000', 'consum', 0.0214, 'lps'),
	(600451, 127, '2014-04-01 00:25:16.000000', 'consum', 0.0219, 'lps'),
	(600452, 127, '2014-04-01 00:25:17.000000', 'consum', 0.0221, 'lps'),
	(600453, 127, '2014-04-01 00:25:18.000000', 'consum', 0.0215, 'lps'),
	(600454, 127, '2014-04-01 00:25:19.000000', 'consum', 0.0225, 'lps'),
	(600455, 127, '2014-04-01 00:25:20.000000', 'consum', 0.0227, 'lps'),
	(600456, 127, '2014-04-01 00:25:21.000000', 'consum', 0.0228, 'lps'),
	(600457, 127, '2014-04-01 00:25:22.000000', 'consum', 0.0228, 'lps'),
	(600458, 127, '2014-04-01 00:25:23.000000', 'consum', 0.0223, 'lps'),
	(600459, 127, '2014-04-01 00:25:24.000000', 'consum', 0.0220, 'lps'),
	(600460, 127, '2014-04-01 00:25:25.000000', 'consum', 0.0225, 'lps'),
	(600461, 127, '2014-04-01 00:25:26.000000', 'consum', 0.0230, 'lps'),
	(600462, 127, '2014-04-01 00:25:27.000000', 'consum', 0.0225, 'lps'),
	(600463, 127, '2014-04-01 00:25:28.000000', 'consum', 0.0224, 'lps'),
	(600464, 127, '2014-04-01 00:25:29.000000', 'consum', 0.0215, 'lps'),
	(600465, 127, '2014-04-01 00:25:30.000000', 'consum', 0.0214, 'lps'),
	(600466, 127, '2014-04-01 00:25:31.000000', 'consum', 0.0216, 'lps'),
	(600467, 127, '2014-04-01 00:25:32.000000', 'consum', 0.0228, 'lps'),
	(600468, 127, '2014-04-01 00:25:33.000000', 'consum', 0.0217, 'lps'),
	(600469, 127, '2014-04-01 00:25:34.000000', 'consum', 0.0212, 'lps'),
	(600470, 127, '2014-04-01 00:25:35.000000', 'consum', 0.0221, 'lps'),
	(600471, 127, '2014-04-01 00:25:36.000000', 'consum', 0.0217, 'lps'),
	(600472, 127, '2014-04-01 00:25:37.000000', 'consum', 0.0214, 'lps'),
	(600473, 127, '2014-04-01 00:25:38.000000', 'consum', 0.0229, 'lps'),
	(600474, 127, '2014-04-01 00:25:39.000000', 'consum', 0.0229, 'lps'),
	(600475, 127, '2014-04-01 00:25:40.000000', 'consum', 0.0227, 'lps'),
	(600476, 127, '2014-04-01 00:25:41.000000', 'consum', 0.0218, 'lps'),
	(600477, 127, '2014-04-01 00:25:42.000000', 'consum', 0.0219, 'lps'),
	(600478, 127, '2014-04-01 00:25:43.000000', 'consum', 0.0230, 'lps'),
	(600479, 127, '2014-04-01 00:25:44.000000', 'consum', 0.0219, 'lps'),
	(600480, 127, '2014-04-01 00:25:45.000000', 'consum', 0.0220, 'lps'),
	(600481, 127, '2014-04-01 00:25:46.000000', 'consum', 0.0230, 'lps'),
	(600482, 127, '2014-04-01 00:25:47.000000', 'consum', 0.0214, 'lps'),
	(600483, 127, '2014-04-01 00:25:48.000000', 'consum', 0.0218, 'lps'),
	(600484, 127, '2014-04-01 00:25:49.000000', 'consum', 0.0214, 'lps'),
	(600485, 127, '2014-04-01 00:25:50.000000', 'consum', 0.0230, 'lps'),
	(600486, 127, '2014-04-01 00:25:51.000000', 'consum', 0.0230, 'lps'),
	(600487, 127, '2014-04-01 00:25:52.000000', 'consum', 0.0210, 'lps'),
	(600488, 127, '2014-04-01 00:25:53.000000', 'consum', 0.0215, 'lps'),
	(600489, 127, '2014-04-01 00:25:54.000000', 'consum', 0.0212, 'lps'),
	(600490, 127, '2014-04-01 00:25:55.000000', 'consum', 0.0229, 'lps'),
	(600491, 127, '2014-04-01 00:25:56.000000', 'consum', 0.0210, 'lps'),
	(600492, 127, '2014-04-01 00:25:57.000000', 'consum', 0.0222, 'lps'),
	(600493, 127, '2014-04-01 00:25:58.000000', 'consum', 0.0227, 'lps'),
	(600494, 127, '2014-04-01 00:25:59.000000', 'consum', 0.0214, 'lps'),
	(600495, 127, '2014-04-01 00:26:00.000000', 'consum', 0.0225, 'lps'),
	(600496, 127, '2014-04-01 00:26:01.000000', 'consum', 0.0228, 'lps'),
	(600497, 127, '2014-04-01 00:26:02.000000', 'consum', 0.0210, 'lps'),
	(600498, 127, '2014-04-01 00:26:03.000000', 'consum', 0.0224, 'lps'),
	(600499, 127, '2014-04-01 00:26:04.000000', 'consum', 0.0216, 'lps'),
	(600500, 127, '2014-04-01 00:26:05.000000', 'consum', 0.0220, 'lps'),
	(600501, 127, '2014-04-01 00:26:06.000000', 'consum', 0.0219, 'lps'),
	(600502, 127, '2014-04-01 00:26:07.000000', 'consum', 0.0227, 'lps'),
	(600503, 127, '2014-04-01 00:26:08.000000', 'consum', 0.0226, 'lps'),
	(600504, 127, '2014-04-01 00:26:09.000000', 'consum', 0.0215, 'lps'),
	(600505, 127, '2014-04-01 00:26:10.000000', 'consum', 0.0212, 'lps'),
	(600506, 127, '2014-04-01 00:26:11.000000', 'consum', 0.0228, 'lps'),
	(600507, 127, '2014-04-01 00:26:12.000000', 'consum', 0.0225, 'lps'),
	(600508, 127, '2014-04-01 00:26:13.000000', 'consum', 0.0212, 'lps'),
	(600509, 127, '2014-04-01 00:26:14.000000', 'consum', 0.0219, 'lps'),
	(600510, 127, '2014-04-01 00:26:15.000000', 'consum', 0.0228, 'lps'),
	(600511, 127, '2014-04-01 00:26:16.000000', 'consum', 0.0228, 'lps'),
	(600512, 127, '2014-04-01 00:26:17.000000', 'consum', 0.0224, 'lps'),
	(600513, 127, '2014-04-01 00:26:18.000000', 'consum', 0.0226, 'lps'),
	(600514, 127, '2014-04-01 00:26:19.000000', 'consum', 0.0227, 'lps'),
	(600515, 127, '2014-04-01 00:26:20.000000', 'consum', 0.0226, 'lps'),
	(600516, 127, '2014-04-01 00:26:21.000000', 'consum', 0.0219, 'lps'),
	(600517, 127, '2014-04-01 00:26:22.000000', 'consum', 0.0227, 'lps'),
	(600518, 127, '2014-04-01 00:26:23.000000', 'consum', 0.0225, 'lps'),
	(600519, 127, '2014-04-01 00:26:24.000000', 'consum', 0.0211, 'lps'),
	(600520, 127, '2014-04-01 00:26:25.000000', 'consum', 0.0215, 'lps'),
	(600521, 127, '2014-04-01 00:26:26.000000', 'consum', 0.0211, 'lps'),
	(600522, 127, '2014-04-01 00:26:27.000000', 'consum', 0.0221, 'lps'),
	(600523, 127, '2014-04-01 00:26:28.000000', 'consum', 0.0219, 'lps'),
	(600524, 127, '2014-04-01 00:26:29.000000', 'consum', 0.0224, 'lps'),
	(600525, 127, '2014-04-01 00:26:30.000000', 'consum', 0.0229, 'lps'),
	(600526, 127, '2014-04-01 00:26:31.000000', 'consum', 0.0222, 'lps'),
	(600527, 127, '2014-04-01 00:26:32.000000', 'consum', 0.0211, 'lps'),
	(600528, 127, '2014-04-01 00:26:33.000000', 'consum', 0.0223, 'lps'),
	(600529, 127, '2014-04-01 00:26:34.000000', 'consum', 0.0230, 'lps'),
	(600530, 127, '2014-04-01 00:26:35.000000', 'consum', 0.0229, 'lps'),
	(600531, 127, '2014-04-01 00:26:36.000000', 'consum', 0.0222, 'lps'),
	(600532, 127, '2014-04-01 00:26:37.000000', 'consum', 0.0215, 'lps'),
	(600533, 127, '2014-04-01 00:26:38.000000', 'consum', 0.0222, 'lps'),
	(600534, 127, '2014-04-01 00:26:39.000000', 'consum', 0.0231, 'lps'),
	(600535, 127, '2014-04-01 00:26:40.000000', 'consum', 0.0215, 'lps'),
	(600536, 127, '2014-04-01 00:26:41.000000', 'consum', 0.0215, 'lps'),
	(600537, 127, '2014-04-01 00:26:42.000000', 'consum', 0.0220, 'lps'),
	(600538, 127, '2014-04-01 00:26:43.000000', 'consum', 0.0224, 'lps'),
	(600539, 127, '2014-04-01 00:26:44.000000', 'consum', 0.0230, 'lps'),
	(600540, 127, '2014-04-01 00:26:45.000000', 'consum', 0.0224, 'lps'),
	(600541, 127, '2014-04-01 00:26:46.000000', 'consum', 0.0222, 'lps'),
	(600542, 127, '2014-04-01 00:26:47.000000', 'consum', 0.0228, 'lps'),
	(600543, 127, '2014-04-01 00:26:48.000000', 'consum', 0.0220, 'lps'),
	(600544, 127, '2014-04-01 00:26:49.000000', 'consum', 0.0228, 'lps'),
	(600545, 127, '2014-04-01 00:26:50.000000', 'consum', 0.0227, 'lps'),
	(600546, 127, '2014-04-01 00:26:51.000000', 'consum', 0.0218, 'lps'),
	(600547, 127, '2014-04-01 00:26:52.000000', 'consum', 0.0221, 'lps'),
	(600548, 127, '2014-04-01 00:26:53.000000', 'consum', 0.0221, 'lps'),
	(600549, 127, '2014-04-01 00:26:54.000000', 'consum', 0.0231, 'lps'),
	(600550, 127, '2014-04-01 00:26:55.000000', 'consum', 0.0219, 'lps'),
	(600551, 127, '2014-04-01 00:26:56.000000', 'consum', 0.0215, 'lps'),
	(600552, 127, '2014-04-01 00:26:57.000000', 'consum', 0.0228, 'lps'),
	(600553, 127, '2014-04-01 00:26:58.000000', 'consum', 0.0221, 'lps'),
	(600554, 127, '2014-04-01 00:26:59.000000', 'consum', 0.0210, 'lps'),
	(600555, 127, '2014-04-01 00:27:00.000000', 'consum', 0.0222, 'lps'),
	(600556, 127, '2014-04-01 00:27:01.000000', 'consum', 0.0228, 'lps'),
	(600557, 127, '2014-04-01 00:27:02.000000', 'consum', 0.0222, 'lps'),
	(600558, 127, '2014-04-01 00:27:03.000000', 'consum', 0.0213, 'lps'),
	(600559, 127, '2014-04-01 00:27:04.000000', 'consum', 0.0213, 'lps'),
	(600560, 127, '2014-04-01 00:27:05.000000', 'consum', 0.0218, 'lps'),
	(600561, 127, '2014-04-01 00:27:06.000000', 'consum', 0.0220, 'lps'),
	(600562, 127, '2014-04-01 00:27:07.000000', 'consum', 0.0211, 'lps'),
	(600563, 127, '2014-04-01 00:27:08.000000', 'consum', 0.0211, 'lps'),
	(600564, 127, '2014-04-01 00:27:09.000000', 'consum', 0.0211, 'lps'),
	(600565, 127, '2014-04-01 00:27:10.000000', 'consum', 0.0215, 'lps'),
	(600566, 127, '2014-04-01 00:27:11.000000', 'consum', 0.0229, 'lps'),
	(600567, 127, '2014-04-01 00:27:12.000000', 'consum', 0.0225, 'lps'),
	(600568, 127, '2014-04-01 00:27:13.000000', 'consum', 0.0227, 'lps'),
	(600569, 127, '2014-04-01 00:27:14.000000', 'consum', 0.0231, 'lps'),
	(600570, 127, '2014-04-01 00:27:15.000000', 'consum', 0.0220, 'lps'),
	(600571, 127, '2014-04-01 00:27:16.000000', 'consum', 0.0218, 'lps'),
	(600572, 127, '2014-04-01 00:27:17.000000', 'consum', 0.0222, 'lps'),
	(600573, 127, '2014-04-01 00:27:18.000000', 'consum', 0.0226, 'lps'),
	(600574, 127, '2014-04-01 00:27:19.000000', 'consum', 0.0231, 'lps'),
	(600575, 127, '2014-04-01 00:27:20.000000', 'consum', 0.0225, 'lps'),
	(600576, 127, '2014-04-01 00:27:21.000000', 'consum', 0.0223, 'lps'),
	(600577, 127, '2014-04-01 00:27:22.000000', 'consum', 0.0230, 'lps'),
	(600578, 127, '2014-04-01 00:27:23.000000', 'consum', 0.0229, 'lps'),
	(600579, 127, '2014-04-01 00:27:24.000000', 'consum', 0.0222, 'lps'),
	(600580, 127, '2014-04-01 00:27:25.000000', 'consum', 0.0214, 'lps'),
	(600581, 127, '2014-04-01 00:27:26.000000', 'consum', 0.0218, 'lps'),
	(600582, 127, '2014-04-01 00:27:27.000000', 'consum', 0.0215, 'lps'),
	(600583, 127, '2014-04-01 00:27:28.000000', 'consum', 0.0210, 'lps'),
	(600584, 127, '2014-04-01 00:27:29.000000', 'consum', 0.0221, 'lps'),
	(600585, 127, '2014-04-01 00:27:30.000000', 'consum', 0.0219, 'lps'),
	(600586, 127, '2014-04-01 00:27:31.000000', 'consum', 0.0223, 'lps'),
	(600587, 127, '2014-04-01 00:27:32.000000', 'consum', 0.0225, 'lps'),
	(600588, 127, '2014-04-01 00:27:33.000000', 'consum', 0.0224, 'lps'),
	(600589, 127, '2014-04-01 00:27:34.000000', 'consum', 0.0213, 'lps'),
	(600590, 127, '2014-04-01 00:27:35.000000', 'consum', 0.0227, 'lps'),
	(600591, 127, '2014-04-01 00:27:36.000000', 'consum', 0.0220, 'lps'),
	(600592, 127, '2014-04-01 00:27:37.000000', 'consum', 0.0212, 'lps'),
	(600593, 127, '2014-04-01 00:27:38.000000', 'consum', 0.0210, 'lps'),
	(600594, 127, '2014-04-01 00:27:39.000000', 'consum', 0.0226, 'lps'),
	(600595, 127, '2014-04-01 00:27:40.000000', 'consum', 0.0226, 'lps'),
	(600596, 127, '2014-04-01 00:27:41.000000', 'consum', 0.0219, 'lps'),
	(600597, 127, '2014-04-01 00:27:42.000000', 'consum', 0.0230, 'lps'),
	(600598, 127, '2014-04-01 00:27:43.000000', 'consum', 0.0217, 'lps'),
	(600599, 127, '2014-04-01 00:27:44.000000', 'consum', 0.0231, 'lps'),
	(600600, 127, '2014-04-01 00:27:45.000000', 'consum', 0.0228, 'lps'),
	(600601, 127, '2014-04-01 00:27:46.000000', 'consum', 0.0215, 'lps'),
	(600602, 127, '2014-04-01 00:27:47.000000', 'consum', 0.0224, 'lps'),
	(600603, 127, '2014-04-01 00:27:48.000000', 'consum', 0.0224, 'lps'),
	(600604, 127, '2014-04-01 00:27:49.000000', 'consum', 0.0217, 'lps'),
	(600605, 127, '2014-04-01 00:27:50.000000', 'consum', 0.0226, 'lps'),
	(600606, 127, '2014-04-01 00:27:51.000000', 'consum', 0.0225, 'lps'),
	(600607, 127, '2014-04-01 00:27:52.000000', 'consum', 0.0216, 'lps'),
	(600608, 127, '2014-04-01 00:27:53.000000', 'consum', 0.0218, 'lps'),
	(600609, 127, '2014-04-01 00:27:54.000000', 'consum', 0.0210, 'lps'),
	(600610, 127, '2014-04-01 00:27:55.000000', 'consum', 0.0229, 'lps'),
	(600611, 127, '2014-04-01 00:27:56.000000', 'consum', 0.0220, 'lps'),
	(600612, 127, '2014-04-01 00:27:57.000000', 'consum', 0.0226, 'lps'),
	(600613, 127, '2014-04-01 00:27:58.000000', 'consum', 0.0215, 'lps'),
	(600614, 127, '2014-04-01 00:27:59.000000', 'consum', 0.0210, 'lps'),
	(600615, 127, '2014-04-01 00:28:00.000000', 'consum', 0.0218, 'lps'),
	(600616, 127, '2014-04-01 00:28:01.000000', 'consum', 0.0228, 'lps'),
	(600617, 127, '2014-04-01 00:28:02.000000', 'consum', 0.0211, 'lps'),
	(600618, 127, '2014-04-01 00:28:03.000000', 'consum', 0.0225, 'lps'),
	(600619, 127, '2014-04-01 00:28:04.000000', 'consum', 0.0220, 'lps'),
	(600620, 127, '2014-04-01 00:28:05.000000', 'consum', 0.0213, 'lps'),
	(600621, 127, '2014-04-01 00:28:06.000000', 'consum', 0.0218, 'lps'),
	(600622, 127, '2014-04-01 00:28:07.000000', 'consum', 0.0219, 'lps'),
	(600623, 127, '2014-04-01 00:28:08.000000', 'consum', 0.0212, 'lps'),
	(600624, 127, '2014-04-01 00:28:09.000000', 'consum', 0.0213, 'lps'),
	(600625, 127, '2014-04-01 00:28:10.000000', 'consum', 0.0222, 'lps'),
	(600626, 127, '2014-04-01 00:28:11.000000', 'consum', 0.0218, 'lps'),
	(600627, 127, '2014-04-01 00:28:12.000000', 'consum', 0.0214, 'lps'),
	(600628, 127, '2014-04-01 00:28:13.000000', 'consum', 0.0226, 'lps'),
	(600629, 127, '2014-04-01 00:28:14.000000', 'consum', 0.0213, 'lps'),
	(600630, 127, '2014-04-01 00:28:15.000000', 'consum', 0.0224, 'lps'),
	(600631, 127, '2014-04-01 00:28:16.000000', 'consum', 0.0224, 'lps'),
	(600632, 127, '2014-04-01 00:28:17.000000', 'consum', 0.0219, 'lps'),
	(600633, 127, '2014-04-01 00:28:18.000000', 'consum', 0.0213, 'lps'),
	(600634, 127, '2014-04-01 00:28:19.000000', 'consum', 0.0219, 'lps'),
	(600635, 127, '2014-04-01 00:28:20.000000', 'consum', 0.0224, 'lps'),
	(600636, 127, '2014-04-01 00:28:21.000000', 'consum', 0.0231, 'lps'),
	(600637, 127, '2014-04-01 00:28:22.000000', 'consum', 0.0230, 'lps'),
	(600638, 127, '2014-04-01 00:28:23.000000', 'consum', 0.0228, 'lps'),
	(600639, 127, '2014-04-01 00:28:24.000000', 'consum', 0.0217, 'lps'),
	(600640, 127, '2014-04-01 00:28:25.000000', 'consum', 0.0213, 'lps'),
	(600641, 127, '2014-04-01 00:28:26.000000', 'consum', 0.0227, 'lps'),
	(600642, 127, '2014-04-01 00:28:27.000000', 'consum', 0.0222, 'lps'),
	(600643, 127, '2014-04-01 00:28:28.000000', 'consum', 0.0218, 'lps'),
	(600644, 127, '2014-04-01 00:28:29.000000', 'consum', 0.0214, 'lps'),
	(600645, 127, '2014-04-01 00:28:30.000000', 'consum', 0.0231, 'lps'),
	(600646, 127, '2014-04-01 00:28:31.000000', 'consum', 0.0214, 'lps'),
	(600647, 127, '2014-04-01 00:28:32.000000', 'consum', 0.0212, 'lps'),
	(600648, 127, '2014-04-01 00:28:33.000000', 'consum', 0.0231, 'lps'),
	(600649, 127, '2014-04-01 00:28:34.000000', 'consum', 0.0219, 'lps'),
	(600650, 127, '2014-04-01 00:28:35.000000', 'consum', 0.0217, 'lps'),
	(600651, 127, '2014-04-01 00:28:36.000000', 'consum', 0.0219, 'lps'),
	(600652, 127, '2014-04-01 00:28:37.000000', 'consum', 0.0211, 'lps'),
	(600653, 127, '2014-04-01 00:28:38.000000', 'consum', 0.0210, 'lps'),
	(600654, 127, '2014-04-01 00:28:39.000000', 'consum', 0.0230, 'lps'),
	(600655, 127, '2014-04-01 00:28:40.000000', 'consum', 0.0221, 'lps'),
	(600656, 127, '2014-04-01 00:28:41.000000', 'consum', 0.0229, 'lps'),
	(600657, 127, '2014-04-01 00:28:42.000000', 'consum', 0.0228, 'lps'),
	(600658, 127, '2014-04-01 00:28:43.000000', 'consum', 0.0224, 'lps'),
	(600659, 127, '2014-04-01 00:28:44.000000', 'consum', 0.0224, 'lps'),
	(600660, 127, '2014-04-01 00:28:45.000000', 'consum', 0.0215, 'lps'),
	(600661, 127, '2014-04-01 00:28:46.000000', 'consum', 0.0217, 'lps'),
	(600662, 127, '2014-04-01 00:28:47.000000', 'consum', 0.0231, 'lps'),
	(600663, 127, '2014-04-01 00:28:48.000000', 'consum', 0.0227, 'lps'),
	(600664, 127, '2014-04-01 00:28:49.000000', 'consum', 0.0231, 'lps'),
	(600665, 127, '2014-04-01 00:28:50.000000', 'consum', 0.0223, 'lps'),
	(600666, 127, '2014-04-01 00:28:51.000000', 'consum', 0.0213, 'lps'),
	(600667, 127, '2014-04-01 00:28:52.000000', 'consum', 0.0230, 'lps'),
	(600668, 127, '2014-04-01 00:28:53.000000', 'consum', 0.0214, 'lps'),
	(600669, 127, '2014-04-01 00:28:54.000000', 'consum', 0.0214, 'lps'),
	(600670, 127, '2014-04-01 00:28:55.000000', 'consum', 0.0218, 'lps'),
	(600671, 127, '2014-04-01 00:28:56.000000', 'consum', 0.0217, 'lps'),
	(600672, 127, '2014-04-01 00:28:57.000000', 'consum', 0.0221, 'lps'),
	(600673, 127, '2014-04-01 00:28:58.000000', 'consum', 0.0222, 'lps'),
	(600674, 127, '2014-04-01 00:28:59.000000', 'consum', 0.0214, 'lps'),
	(600675, 127, '2014-04-01 00:29:00.000000', 'consum', 0.0218, 'lps'),
	(600676, 127, '2014-04-01 00:29:01.000000', 'consum', 0.0215, 'lps'),
	(600677, 127, '2014-04-01 00:29:02.000000', 'consum', 0.0213, 'lps'),
	(600678, 127, '2014-04-01 00:29:03.000000', 'consum', 0.0210, 'lps'),
	(600679, 127, '2014-04-01 00:29:04.000000', 'consum', 0.0225, 'lps'),
	(600680, 127, '2014-04-01 00:29:05.000000', 'consum', 0.0220, 'lps'),
	(600681, 127, '2014-04-01 00:29:06.000000', 'consum', 0.0213, 'lps'),
	(600682, 127, '2014-04-01 00:29:07.000000', 'consum', 0.0219, 'lps'),
	(600683, 127, '2014-04-01 00:29:08.000000', 'consum', 0.0226, 'lps'),
	(600684, 127, '2014-04-01 00:29:09.000000', 'consum', 0.0219, 'lps'),
	(600685, 127, '2014-04-01 00:29:10.000000', 'consum', 0.0229, 'lps'),
	(600686, 127, '2014-04-01 00:29:11.000000', 'consum', 0.0211, 'lps'),
	(600687, 127, '2014-04-01 00:29:12.000000', 'consum', 0.0227, 'lps'),
	(600688, 127, '2014-04-01 00:29:13.000000', 'consum', 0.0224, 'lps'),
	(600689, 127, '2014-04-01 00:29:14.000000', 'consum', 0.0231, 'lps'),
	(600690, 127, '2014-04-01 00:29:15.000000', 'consum', 0.0229, 'lps'),
	(600691, 127, '2014-04-01 00:29:16.000000', 'consum', 0.0221, 'lps'),
	(600692, 127, '2014-04-01 00:29:17.000000', 'consum', 0.0228, 'lps'),
	(600693, 127, '2014-04-01 00:29:18.000000', 'consum', 0.0226, 'lps'),
	(600694, 127, '2014-04-01 00:29:19.000000', 'consum', 0.0212, 'lps'),
	(600695, 127, '2014-04-01 00:29:20.000000', 'consum', 0.0219, 'lps'),
	(600696, 127, '2014-04-01 00:29:21.000000', 'consum', 0.0226, 'lps'),
	(600697, 127, '2014-04-01 00:29:22.000000', 'consum', 0.0221, 'lps'),
	(600698, 127, '2014-04-01 00:29:23.000000', 'consum', 0.0215, 'lps'),
	(600699, 127, '2014-04-01 00:29:24.000000', 'consum', 0.0225, 'lps'),
	(600700, 127, '2014-04-01 00:29:25.000000', 'consum', 0.0226, 'lps'),
	(600701, 127, '2014-04-01 00:29:26.000000', 'consum', 0.0222, 'lps'),
	(600702, 127, '2014-04-01 00:29:27.000000', 'consum', 0.0225, 'lps'),
	(600703, 127, '2014-04-01 00:29:28.000000', 'consum', 0.0229, 'lps'),
	(600704, 127, '2014-04-01 00:29:29.000000', 'consum', 0.0214, 'lps'),
	(600705, 127, '2014-04-01 00:29:30.000000', 'consum', 0.0219, 'lps'),
	(600706, 127, '2014-04-01 00:29:31.000000', 'consum', 0.0222, 'lps'),
	(600707, 127, '2014-04-01 00:29:32.000000', 'consum', 0.0221, 'lps'),
	(600708, 127, '2014-04-01 00:29:33.000000', 'consum', 0.0228, 'lps'),
	(600709, 127, '2014-04-01 00:29:34.000000', 'consum', 0.0225, 'lps'),
	(600710, 127, '2014-04-01 00:29:35.000000', 'consum', 0.0229, 'lps'),
	(600711, 127, '2014-04-01 00:29:36.000000', 'consum', 0.0218, 'lps'),
	(600712, 127, '2014-04-01 00:29:37.000000', 'consum', 0.0215, 'lps'),
	(600713, 127, '2014-04-01 00:29:38.000000', 'consum', 0.0213, 'lps'),
	(600714, 127, '2014-04-01 00:29:39.000000', 'consum', 0.0230, 'lps'),
	(600715, 127, '2014-04-01 00:29:40.000000', 'consum', 0.0214, 'lps'),
	(600716, 127, '2014-04-01 00:29:41.000000', 'consum', 0.0214, 'lps'),
	(600717, 127, '2014-04-01 00:29:42.000000', 'consum', 0.0217, 'lps'),
	(600718, 127, '2014-04-01 00:29:43.000000', 'consum', 0.0215, 'lps'),
	(600719, 127, '2014-04-01 00:29:44.000000', 'consum', 0.0213, 'lps'),
	(600720, 127, '2014-04-01 00:29:45.000000', 'consum', 0.0212, 'lps'),
	(600721, 127, '2014-04-01 00:29:46.000000', 'consum', 0.0211, 'lps'),
	(600722, 127, '2014-04-01 00:29:47.000000', 'consum', 0.0230, 'lps'),
	(600723, 127, '2014-04-01 00:29:48.000000', 'consum', 0.0219, 'lps'),
	(600724, 127, '2014-04-01 00:29:49.000000', 'consum', 0.0217, 'lps'),
	(600725, 127, '2014-04-01 00:29:50.000000', 'consum', 0.0220, 'lps'),
	(600726, 127, '2014-04-01 00:29:51.000000', 'consum', 0.0218, 'lps'),
	(600727, 127, '2014-04-01 00:29:52.000000', 'consum', 0.0218, 'lps'),
	(600728, 127, '2014-04-01 00:29:53.000000', 'consum', 0.0227, 'lps'),
	(600729, 127, '2014-04-01 00:29:54.000000', 'consum', 0.0230, 'lps'),
	(600730, 127, '2014-04-01 00:29:55.000000', 'consum', 0.0214, 'lps'),
	(600731, 127, '2014-04-01 00:29:56.000000', 'consum', 0.0214, 'lps'),
	(600732, 127, '2014-04-01 00:29:57.000000', 'consum', 0.0219, 'lps'),
	(600733, 127, '2014-04-01 00:29:58.000000', 'consum', 0.0223, 'lps'),
	(600734, 127, '2014-04-01 00:29:59.000000', 'consum', 0.0224, 'lps'),
	(600735, 127, '2014-04-01 00:30:00.000000', 'consum', 0.0219, 'lps'),
	(600736, 127, '2014-04-01 00:30:01.000000', 'consum', 0.0215, 'lps'),
	(600737, 127, '2014-04-01 00:30:02.000000', 'consum', 0.0230, 'lps'),
	(600738, 127, '2014-04-01 00:30:03.000000', 'consum', 0.0230, 'lps'),
	(600739, 127, '2014-04-01 00:30:04.000000', 'consum', 0.0228, 'lps'),
	(600740, 127, '2014-04-01 00:30:05.000000', 'consum', 0.0219, 'lps'),
	(600741, 127, '2014-04-01 00:30:06.000000', 'consum', 0.0221, 'lps'),
	(600742, 127, '2014-04-01 00:30:07.000000', 'consum', 0.0220, 'lps'),
	(600743, 127, '2014-04-01 00:30:08.000000', 'consum', 0.0227, 'lps'),
	(600744, 127, '2014-04-01 00:30:09.000000', 'consum', 0.0219, 'lps'),
	(600745, 127, '2014-04-01 00:30:10.000000', 'consum', 0.0227, 'lps'),
	(600746, 127, '2014-04-01 00:30:11.000000', 'consum', 0.0225, 'lps'),
	(600747, 127, '2014-04-01 00:30:12.000000', 'consum', 0.0213, 'lps'),
	(600748, 127, '2014-04-01 00:30:13.000000', 'consum', 0.0223, 'lps'),
	(600749, 127, '2014-04-01 00:30:14.000000', 'consum', 0.0222, 'lps'),
	(600750, 127, '2014-04-01 00:30:15.000000', 'consum', 0.0210, 'lps'),
	(600751, 127, '2014-04-01 00:30:16.000000', 'consum', 0.0217, 'lps'),
	(600752, 127, '2014-04-01 00:30:17.000000', 'consum', 0.0225, 'lps'),
	(600753, 127, '2014-04-01 00:30:18.000000', 'consum', 0.0219, 'lps'),
	(600754, 127, '2014-04-01 00:30:19.000000', 'consum', 0.0212, 'lps'),
	(600755, 127, '2014-04-01 00:30:20.000000', 'consum', 0.0215, 'lps'),
	(600756, 127, '2014-04-01 00:30:21.000000', 'consum', 0.0230, 'lps'),
	(600757, 127, '2014-04-01 00:30:22.000000', 'consum', 0.0228, 'lps'),
	(600758, 127, '2014-04-01 00:30:23.000000', 'consum', 0.0219, 'lps'),
	(600759, 127, '2014-04-01 00:30:24.000000', 'consum', 0.0224, 'lps'),
	(600760, 127, '2014-04-01 00:30:25.000000', 'consum', 0.0210, 'lps'),
	(600761, 127, '2014-04-01 00:30:26.000000', 'consum', 0.0210, 'lps'),
	(600762, 127, '2014-04-01 00:30:27.000000', 'consum', 0.0214, 'lps'),
	(600763, 127, '2014-04-01 00:30:28.000000', 'consum', 0.0227, 'lps'),
	(600764, 127, '2014-04-01 00:30:29.000000', 'consum', 0.0219, 'lps'),
	(600765, 127, '2014-04-01 00:30:30.000000', 'consum', 0.0225, 'lps'),
	(600766, 127, '2014-04-01 00:30:31.000000', 'consum', 0.0216, 'lps'),
	(600767, 127, '2014-04-01 00:30:32.000000', 'consum', 0.0217, 'lps'),
	(600768, 127, '2014-04-01 00:30:33.000000', 'consum', 0.0228, 'lps'),
	(600769, 127, '2014-04-01 00:30:34.000000', 'consum', 0.0215, 'lps'),
	(600770, 127, '2014-04-01 00:30:35.000000', 'consum', 0.0223, 'lps'),
	(600771, 127, '2014-04-01 00:30:36.000000', 'consum', 0.0217, 'lps'),
	(600772, 127, '2014-04-01 00:30:37.000000', 'consum', 0.0228, 'lps'),
	(600773, 127, '2014-04-01 00:30:38.000000', 'consum', 0.0214, 'lps'),
	(600774, 127, '2014-04-01 00:30:39.000000', 'consum', 0.0219, 'lps'),
	(600775, 127, '2014-04-01 00:30:40.000000', 'consum', 0.0223, 'lps'),
	(600776, 127, '2014-04-01 00:30:41.000000', 'consum', 0.0227, 'lps'),
	(600777, 127, '2014-04-01 00:30:42.000000', 'consum', 0.0211, 'lps'),
	(600778, 127, '2014-04-01 00:30:43.000000', 'consum', 0.0229, 'lps'),
	(600779, 127, '2014-04-01 00:30:44.000000', 'consum', 0.0218, 'lps'),
	(600780, 127, '2014-04-01 00:30:45.000000', 'consum', 0.0213, 'lps'),
	(600781, 127, '2014-04-01 00:30:46.000000', 'consum', 0.0225, 'lps'),
	(600782, 127, '2014-04-01 00:30:47.000000', 'consum', 0.0212, 'lps'),
	(600783, 127, '2014-04-01 00:30:48.000000', 'consum', 0.0217, 'lps'),
	(600784, 127, '2014-04-01 00:30:49.000000', 'consum', 0.0218, 'lps'),
	(600785, 127, '2014-04-01 00:30:50.000000', 'consum', 0.0210, 'lps'),
	(600786, 127, '2014-04-01 00:30:51.000000', 'consum', 0.0228, 'lps'),
	(600787, 127, '2014-04-01 00:30:52.000000', 'consum', 0.0213, 'lps'),
	(600788, 127, '2014-04-01 00:30:53.000000', 'consum', 0.0214, 'lps'),
	(600789, 127, '2014-04-01 00:30:54.000000', 'consum', 0.0224, 'lps'),
	(600790, 127, '2014-04-01 00:30:55.000000', 'consum', 0.0222, 'lps'),
	(600791, 127, '2014-04-01 00:30:56.000000', 'consum', 0.0228, 'lps'),
	(600792, 127, '2014-04-01 00:30:57.000000', 'consum', 0.0223, 'lps'),
	(600793, 127, '2014-04-01 00:30:58.000000', 'consum', 0.0220, 'lps'),
	(600794, 127, '2014-04-01 00:30:59.000000', 'consum', 0.0223, 'lps'),
	(600795, 127, '2014-04-01 00:31:00.000000', 'consum', 0.0221, 'lps'),
	(600796, 127, '2014-04-01 00:31:01.000000', 'consum', 0.0229, 'lps'),
	(600797, 127, '2014-04-01 00:31:02.000000', 'consum', 0.0226, 'lps'),
	(600798, 127, '2014-04-01 00:31:03.000000', 'consum', 0.0213, 'lps'),
	(600799, 127, '2014-04-01 00:31:04.000000', 'consum', 0.0223, 'lps'),
	(600800, 127, '2014-04-01 00:31:05.000000', 'consum', 0.0220, 'lps'),
	(600801, 127, '2014-04-01 00:31:06.000000', 'consum', 0.0224, 'lps'),
	(600802, 127, '2014-04-01 00:31:07.000000', 'consum', 0.0226, 'lps'),
	(600803, 127, '2014-04-01 00:31:08.000000', 'consum', 0.0227, 'lps'),
	(600804, 127, '2014-04-01 00:31:09.000000', 'consum', 0.0227, 'lps'),
	(600805, 127, '2014-04-01 00:31:10.000000', 'consum', 0.0222, 'lps'),
	(600806, 127, '2014-04-01 00:31:11.000000', 'consum', 0.0218, 'lps'),
	(600807, 127, '2014-04-01 00:31:12.000000', 'consum', 0.0216, 'lps'),
	(600808, 127, '2014-04-01 00:31:13.000000', 'consum', 0.0216, 'lps'),
	(600809, 127, '2014-04-01 00:31:14.000000', 'consum', 0.0224, 'lps'),
	(600810, 127, '2014-04-01 00:31:15.000000', 'consum', 0.0217, 'lps'),
	(600811, 127, '2014-04-01 00:31:16.000000', 'consum', 0.0226, 'lps'),
	(600812, 127, '2014-04-01 00:31:17.000000', 'consum', 0.0227, 'lps'),
	(600813, 127, '2014-04-01 00:31:18.000000', 'consum', 0.0223, 'lps'),
	(600814, 127, '2014-04-01 00:31:19.000000', 'consum', 0.0225, 'lps'),
	(600815, 127, '2014-04-01 00:31:20.000000', 'consum', 0.0225, 'lps'),
	(600816, 127, '2014-04-01 00:31:21.000000', 'consum', 0.0217, 'lps'),
	(600817, 127, '2014-04-01 00:31:22.000000', 'consum', 0.0224, 'lps'),
	(600818, 127, '2014-04-01 00:31:23.000000', 'consum', 0.0213, 'lps'),
	(600819, 127, '2014-04-01 00:31:24.000000', 'consum', 0.0230, 'lps'),
	(600820, 127, '2014-04-01 00:31:25.000000', 'consum', 0.0211, 'lps'),
	(600821, 127, '2014-04-01 00:31:26.000000', 'consum', 0.0223, 'lps'),
	(600822, 127, '2014-04-01 00:31:27.000000', 'consum', 0.0228, 'lps'),
	(600823, 127, '2014-04-01 00:31:28.000000', 'consum', 0.0217, 'lps'),
	(600824, 127, '2014-04-01 00:31:29.000000', 'consum', 0.0213, 'lps'),
	(600825, 127, '2014-04-01 00:31:30.000000', 'consum', 0.0228, 'lps'),
	(600826, 127, '2014-04-01 00:31:31.000000', 'consum', 0.0225, 'lps'),
	(600827, 127, '2014-04-01 00:31:32.000000', 'consum', 0.0210, 'lps'),
	(600828, 127, '2014-04-01 00:31:33.000000', 'consum', 0.0230, 'lps'),
	(600829, 127, '2014-04-01 00:31:34.000000', 'consum', 0.0225, 'lps'),
	(600830, 127, '2014-04-01 00:31:35.000000', 'consum', 0.0224, 'lps'),
	(600831, 127, '2014-04-01 00:31:36.000000', 'consum', 0.0212, 'lps'),
	(600832, 127, '2014-04-01 00:31:37.000000', 'consum', 0.0225, 'lps'),
	(600833, 127, '2014-04-01 00:31:38.000000', 'consum', 0.0212, 'lps'),
	(600834, 127, '2014-04-01 00:31:39.000000', 'consum', 0.0219, 'lps'),
	(600835, 127, '2014-04-01 00:31:40.000000', 'consum', 0.0227, 'lps'),
	(600836, 127, '2014-04-01 00:31:41.000000', 'consum', 0.0224, 'lps'),
	(600837, 127, '2014-04-01 00:31:42.000000', 'consum', 0.0210, 'lps'),
	(600838, 127, '2014-04-01 00:31:43.000000', 'consum', 0.0210, 'lps'),
	(600839, 127, '2014-04-01 00:31:44.000000', 'consum', 0.0212, 'lps'),
	(600840, 127, '2014-04-01 00:31:45.000000', 'consum', 0.0219, 'lps'),
	(600841, 127, '2014-04-01 00:31:46.000000', 'consum', 0.0227, 'lps'),
	(600842, 127, '2014-04-01 00:31:47.000000', 'consum', 0.0223, 'lps'),
	(600843, 127, '2014-04-01 00:31:48.000000', 'consum', 0.0227, 'lps'),
	(600844, 127, '2014-04-01 00:31:49.000000', 'consum', 0.0214, 'lps'),
	(600845, 127, '2014-04-01 00:31:50.000000', 'consum', 0.0222, 'lps'),
	(600846, 127, '2014-04-01 00:31:51.000000', 'consum', 0.0216, 'lps'),
	(600847, 127, '2014-04-01 00:31:52.000000', 'consum', 0.0225, 'lps'),
	(600848, 127, '2014-04-01 00:31:53.000000', 'consum', 0.0225, 'lps'),
	(600849, 127, '2014-04-01 00:31:54.000000', 'consum', 0.0218, 'lps'),
	(600850, 127, '2014-04-01 00:31:55.000000', 'consum', 0.0227, 'lps'),
	(600851, 127, '2014-04-01 00:31:56.000000', 'consum', 0.0229, 'lps'),
	(600852, 127, '2014-04-01 00:31:57.000000', 'consum', 0.0210, 'lps'),
	(600853, 127, '2014-04-01 00:31:58.000000', 'consum', 0.0220, 'lps'),
	(600854, 127, '2014-04-01 00:31:59.000000', 'consum', 0.0218, 'lps'),
	(600855, 127, '2014-04-01 00:32:00.000000', 'consum', 0.0218, 'lps'),
	(600856, 127, '2014-04-01 00:32:01.000000', 'consum', 0.0227, 'lps'),
	(600857, 127, '2014-04-01 00:32:02.000000', 'consum', 0.0226, 'lps'),
	(600858, 127, '2014-04-01 00:32:03.000000', 'consum', 0.0218, 'lps'),
	(600859, 127, '2014-04-01 00:32:04.000000', 'consum', 0.0223, 'lps'),
	(600860, 127, '2014-04-01 00:32:05.000000', 'consum', 0.0231, 'lps'),
	(600861, 127, '2014-04-01 00:32:06.000000', 'consum', 0.0212, 'lps'),
	(600862, 127, '2014-04-01 00:32:07.000000', 'consum', 0.0224, 'lps'),
	(600863, 127, '2014-04-01 00:32:08.000000', 'consum', 0.0231, 'lps'),
	(600864, 127, '2014-04-01 00:32:09.000000', 'consum', 0.0230, 'lps'),
	(600865, 127, '2014-04-01 00:32:10.000000', 'consum', 0.0223, 'lps'),
	(600866, 127, '2014-04-01 00:32:11.000000', 'consum', 0.0217, 'lps'),
	(600867, 127, '2014-04-01 00:32:12.000000', 'consum', 0.0226, 'lps'),
	(600868, 127, '2014-04-01 00:32:13.000000', 'consum', 0.0229, 'lps'),
	(600869, 127, '2014-04-01 00:32:14.000000', 'consum', 0.0210, 'lps'),
	(600870, 127, '2014-04-01 00:32:15.000000', 'consum', 0.0221, 'lps'),
	(600871, 127, '2014-04-01 00:32:16.000000', 'consum', 0.0220, 'lps'),
	(600872, 127, '2014-04-01 00:32:17.000000', 'consum', 0.0229, 'lps'),
	(600873, 127, '2014-04-01 00:32:18.000000', 'consum', 0.0211, 'lps'),
	(600874, 127, '2014-04-01 00:32:19.000000', 'consum', 0.0224, 'lps'),
	(600875, 127, '2014-04-01 00:32:20.000000', 'consum', 0.0213, 'lps'),
	(600876, 127, '2014-04-01 00:32:21.000000', 'consum', 0.0226, 'lps'),
	(600877, 127, '2014-04-01 00:32:22.000000', 'consum', 0.0214, 'lps'),
	(600878, 127, '2014-04-01 00:32:23.000000', 'consum', 0.0226, 'lps'),
	(600879, 127, '2014-04-01 00:32:24.000000', 'consum', 0.0212, 'lps'),
	(600880, 127, '2014-04-01 00:32:25.000000', 'consum', 0.0218, 'lps'),
	(600881, 127, '2014-04-01 00:32:26.000000', 'consum', 0.0223, 'lps'),
	(600882, 127, '2014-04-01 00:32:27.000000', 'consum', 0.0228, 'lps'),
	(600883, 127, '2014-04-01 00:32:28.000000', 'consum', 0.0219, 'lps'),
	(600884, 127, '2014-04-01 00:32:29.000000', 'consum', 0.0223, 'lps'),
	(600885, 127, '2014-04-01 00:32:30.000000', 'consum', 0.0228, 'lps'),
	(600886, 127, '2014-04-01 00:32:31.000000', 'consum', 0.0215, 'lps'),
	(600887, 127, '2014-04-01 00:32:32.000000', 'consum', 0.0228, 'lps'),
	(600888, 127, '2014-04-01 00:32:33.000000', 'consum', 0.0220, 'lps'),
	(600889, 127, '2014-04-01 00:32:34.000000', 'consum', 0.0226, 'lps'),
	(600890, 127, '2014-04-01 00:32:35.000000', 'consum', 0.0216, 'lps'),
	(600891, 127, '2014-04-01 00:32:36.000000', 'consum', 0.0216, 'lps'),
	(600892, 127, '2014-04-01 00:32:37.000000', 'consum', 0.0221, 'lps'),
	(600893, 127, '2014-04-01 00:32:38.000000', 'consum', 0.0226, 'lps'),
	(600894, 127, '2014-04-01 00:32:39.000000', 'consum', 0.0214, 'lps'),
	(600895, 127, '2014-04-01 00:32:40.000000', 'consum', 0.0227, 'lps'),
	(600896, 127, '2014-04-01 00:32:41.000000', 'consum', 0.0219, 'lps'),
	(600897, 127, '2014-04-01 00:32:42.000000', 'consum', 0.0225, 'lps'),
	(600898, 127, '2014-04-01 00:32:43.000000', 'consum', 0.0213, 'lps'),
	(600899, 127, '2014-04-01 00:32:44.000000', 'consum', 0.0226, 'lps'),
	(600900, 127, '2014-04-01 00:32:45.000000', 'consum', 0.0213, 'lps'),
	(600901, 127, '2014-04-01 00:32:46.000000', 'consum', 0.0224, 'lps'),
	(600902, 127, '2014-04-01 00:32:47.000000', 'consum', 0.0226, 'lps'),
	(600903, 127, '2014-04-01 00:32:48.000000', 'consum', 0.0228, 'lps'),
	(600904, 127, '2014-04-01 00:32:49.000000', 'consum', 0.0228, 'lps'),
	(600905, 127, '2014-04-01 00:32:50.000000', 'consum', 0.0227, 'lps'),
	(600906, 127, '2014-04-01 00:32:51.000000', 'consum', 0.0220, 'lps'),
	(600907, 127, '2014-04-01 00:32:52.000000', 'consum', 0.0210, 'lps'),
	(600908, 127, '2014-04-01 00:32:53.000000', 'consum', 0.0224, 'lps'),
	(600909, 127, '2014-04-01 00:32:54.000000', 'consum', 0.0216, 'lps'),
	(600910, 127, '2014-04-01 00:32:55.000000', 'consum', 0.0218, 'lps'),
	(600911, 127, '2014-04-01 00:32:56.000000', 'consum', 0.0213, 'lps'),
	(600912, 127, '2014-04-01 00:32:57.000000', 'consum', 0.0224, 'lps'),
	(600913, 127, '2014-04-01 00:32:58.000000', 'consum', 0.0227, 'lps'),
	(600914, 127, '2014-04-01 00:32:59.000000', 'consum', 0.0230, 'lps'),
	(600915, 127, '2014-04-01 00:33:00.000000', 'consum', 0.0217, 'lps'),
	(600916, 127, '2014-04-01 00:33:01.000000', 'consum', 0.0229, 'lps'),
	(600917, 127, '2014-04-01 00:33:02.000000', 'consum', 0.0219, 'lps'),
	(600918, 127, '2014-04-01 00:33:03.000000', 'consum', 0.0218, 'lps'),
	(600919, 127, '2014-04-01 00:33:04.000000', 'consum', 0.0225, 'lps'),
	(600920, 127, '2014-04-01 00:33:05.000000', 'consum', 0.0219, 'lps'),
	(600921, 127, '2014-04-01 00:33:06.000000', 'consum', 0.0210, 'lps'),
	(600922, 127, '2014-04-01 00:33:07.000000', 'consum', 0.0226, 'lps'),
	(600923, 127, '2014-04-01 00:33:08.000000', 'consum', 0.0227, 'lps'),
	(600924, 127, '2014-04-01 00:33:09.000000', 'consum', 0.0224, 'lps'),
	(600925, 127, '2014-04-01 00:33:10.000000', 'consum', 0.0228, 'lps'),
	(600926, 127, '2014-04-01 00:33:11.000000', 'consum', 0.0216, 'lps'),
	(600927, 127, '2014-04-01 00:33:12.000000', 'consum', 0.0230, 'lps'),
	(600928, 127, '2014-04-01 00:33:13.000000', 'consum', 0.0225, 'lps'),
	(600929, 127, '2014-04-01 00:33:14.000000', 'consum', 0.0226, 'lps'),
	(600930, 127, '2014-04-01 00:33:15.000000', 'consum', 0.0225, 'lps'),
	(600931, 127, '2014-04-01 00:33:16.000000', 'consum', 0.0213, 'lps'),
	(600932, 127, '2014-04-01 00:33:17.000000', 'consum', 0.0227, 'lps'),
	(600933, 127, '2014-04-01 00:33:18.000000', 'consum', 0.0219, 'lps'),
	(600934, 127, '2014-04-01 00:33:19.000000', 'consum', 0.0229, 'lps'),
	(600935, 127, '2014-04-01 00:33:20.000000', 'consum', 0.0231, 'lps'),
	(600936, 127, '2014-04-01 00:33:21.000000', 'consum', 0.0217, 'lps'),
	(600937, 127, '2014-04-01 00:33:22.000000', 'consum', 0.0225, 'lps'),
	(600938, 127, '2014-04-01 00:33:23.000000', 'consum', 0.0222, 'lps'),
	(600939, 127, '2014-04-01 00:33:24.000000', 'consum', 0.0223, 'lps'),
	(600940, 127, '2014-04-01 00:33:25.000000', 'consum', 0.0219, 'lps'),
	(600941, 127, '2014-04-01 00:33:26.000000', 'consum', 0.0218, 'lps'),
	(600942, 127, '2014-04-01 00:33:27.000000', 'consum', 0.0220, 'lps'),
	(600943, 127, '2014-04-01 00:33:28.000000', 'consum', 0.0217, 'lps'),
	(600944, 127, '2014-04-01 00:33:29.000000', 'consum', 0.0216, 'lps'),
	(600945, 127, '2014-04-01 00:33:30.000000', 'consum', 0.0220, 'lps'),
	(600946, 127, '2014-04-01 00:33:31.000000', 'consum', 0.0221, 'lps'),
	(600947, 127, '2014-04-01 00:33:32.000000', 'consum', 0.0213, 'lps'),
	(600948, 127, '2014-04-01 00:33:33.000000', 'consum', 0.0212, 'lps'),
	(600949, 127, '2014-04-01 00:33:34.000000', 'consum', 0.0214, 'lps'),
	(600950, 127, '2014-04-01 00:33:35.000000', 'consum', 0.0224, 'lps'),
	(600951, 127, '2014-04-01 00:33:36.000000', 'consum', 0.0224, 'lps'),
	(600952, 127, '2014-04-01 00:33:37.000000', 'consum', 0.0219, 'lps'),
	(600953, 127, '2014-04-01 00:33:38.000000', 'consum', 0.0210, 'lps'),
	(600954, 127, '2014-04-01 00:33:39.000000', 'consum', 0.0231, 'lps'),
	(600955, 127, '2014-04-01 00:33:40.000000', 'consum', 0.0224, 'lps'),
	(600956, 127, '2014-04-01 00:33:41.000000', 'consum', 0.0221, 'lps'),
	(600957, 127, '2014-04-01 00:33:42.000000', 'consum', 0.0221, 'lps'),
	(600958, 127, '2014-04-01 00:33:43.000000', 'consum', 0.0210, 'lps'),
	(600959, 127, '2014-04-01 00:33:44.000000', 'consum', 0.0221, 'lps'),
	(600960, 127, '2014-04-01 00:33:45.000000', 'consum', 0.0223, 'lps'),
	(600961, 127, '2014-04-01 00:33:46.000000', 'consum', 0.0221, 'lps'),
	(600962, 127, '2014-04-01 00:33:47.000000', 'consum', 0.0225, 'lps'),
	(600963, 127, '2014-04-01 00:33:48.000000', 'consum', 0.0231, 'lps'),
	(600964, 127, '2014-04-01 00:33:49.000000', 'consum', 0.0226, 'lps'),
	(600965, 127, '2014-04-01 00:33:50.000000', 'consum', 0.0227, 'lps'),
	(600966, 127, '2014-04-01 00:33:51.000000', 'consum', 0.0225, 'lps'),
	(600967, 127, '2014-04-01 00:33:52.000000', 'consum', 0.0213, 'lps'),
	(600968, 127, '2014-04-01 00:33:53.000000', 'consum', 0.0223, 'lps'),
	(600969, 127, '2014-04-01 00:33:54.000000', 'consum', 0.0224, 'lps'),
	(600970, 127, '2014-04-01 00:33:55.000000', 'consum', 0.0220, 'lps'),
	(600971, 127, '2014-04-01 00:33:56.000000', 'consum', 0.0217, 'lps'),
	(600972, 127, '2014-04-01 00:33:57.000000', 'consum', 0.0217, 'lps'),
	(600973, 127, '2014-04-01 00:33:58.000000', 'consum', 0.0224, 'lps'),
	(600974, 127, '2014-04-01 00:33:59.000000', 'consum', 0.0215, 'lps'),
	(600975, 127, '2014-04-01 00:34:00.000000', 'consum', 0.0218, 'lps'),
	(600976, 127, '2014-04-01 00:34:01.000000', 'consum', 0.0210, 'lps'),
	(600977, 127, '2014-04-01 00:34:02.000000', 'consum', 0.0211, 'lps'),
	(600978, 127, '2014-04-01 00:34:03.000000', 'consum', 0.0215, 'lps'),
	(600979, 127, '2014-04-01 00:34:04.000000', 'consum', 0.0230, 'lps'),
	(600980, 127, '2014-04-01 00:34:05.000000', 'consum', 0.0210, 'lps'),
	(600981, 127, '2014-04-01 00:34:06.000000', 'consum', 0.0218, 'lps'),
	(600982, 127, '2014-04-01 00:34:07.000000', 'consum', 0.0225, 'lps'),
	(600983, 127, '2014-04-01 00:34:08.000000', 'consum', 0.0219, 'lps'),
	(600984, 127, '2014-04-01 00:34:09.000000', 'consum', 0.0231, 'lps'),
	(600985, 127, '2014-04-01 00:34:10.000000', 'consum', 0.0225, 'lps'),
	(600986, 127, '2014-04-01 00:34:11.000000', 'consum', 0.0221, 'lps'),
	(600987, 127, '2014-04-01 00:34:12.000000', 'consum', 0.0222, 'lps'),
	(600988, 127, '2014-04-01 00:34:13.000000', 'consum', 0.0213, 'lps'),
	(600989, 127, '2014-04-01 00:34:14.000000', 'consum', 0.0214, 'lps'),
	(600990, 127, '2014-04-01 00:34:15.000000', 'consum', 0.0222, 'lps'),
	(600991, 127, '2014-04-01 00:34:16.000000', 'consum', 0.0213, 'lps'),
	(600992, 127, '2014-04-01 00:34:17.000000', 'consum', 0.0212, 'lps'),
	(600993, 127, '2014-04-01 00:34:18.000000', 'consum', 0.0213, 'lps'),
	(600994, 127, '2014-04-01 00:34:19.000000', 'consum', 0.0218, 'lps'),
	(600995, 127, '2014-04-01 00:34:20.000000', 'consum', 0.0220, 'lps'),
	(600996, 127, '2014-04-01 00:34:21.000000', 'consum', 0.0212, 'lps'),
	(600997, 127, '2014-04-01 00:34:22.000000', 'consum', 0.0215, 'lps'),
	(600998, 127, '2014-04-01 00:34:23.000000', 'consum', 0.0230, 'lps'),
	(600999, 127, '2014-04-01 00:34:24.000000', 'consum', 0.0230, 'lps'),
	(601000, 127, '2014-04-01 00:34:25.000000', 'consum', 0.0229, 'lps'),
	(601001, 127, '2014-04-01 00:34:26.000000', 'consum', 0.0225, 'lps'),
	(601002, 127, '2014-04-01 00:34:27.000000', 'consum', 0.0225, 'lps'),
	(601003, 127, '2014-04-01 00:34:28.000000', 'consum', 0.0221, 'lps'),
	(601004, 127, '2014-04-01 00:34:29.000000', 'consum', 0.0218, 'lps'),
	(601005, 127, '2014-04-01 00:34:30.000000', 'consum', 0.0219, 'lps'),
	(601006, 127, '2014-04-01 00:34:31.000000', 'consum', 0.0230, 'lps'),
	(601007, 127, '2014-04-01 00:34:32.000000', 'consum', 0.0218, 'lps'),
	(601008, 127, '2014-04-01 00:34:33.000000', 'consum', 0.0212, 'lps'),
	(601009, 127, '2014-04-01 00:34:34.000000', 'consum', 0.0218, 'lps'),
	(601010, 127, '2014-04-01 00:34:35.000000', 'consum', 0.0224, 'lps'),
	(601011, 127, '2014-04-01 00:34:36.000000', 'consum', 0.0214, 'lps'),
	(601012, 127, '2014-04-01 00:34:37.000000', 'consum', 0.0231, 'lps'),
	(601013, 127, '2014-04-01 00:34:38.000000', 'consum', 0.0216, 'lps'),
	(601014, 127, '2014-04-01 00:34:39.000000', 'consum', 0.0223, 'lps'),
	(601015, 127, '2014-04-01 00:34:40.000000', 'consum', 0.0213, 'lps'),
	(601016, 127, '2014-04-01 00:34:41.000000', 'consum', 0.0231, 'lps'),
	(601017, 127, '2014-04-01 00:34:42.000000', 'consum', 0.0218, 'lps'),
	(601018, 127, '2014-04-01 00:34:43.000000', 'consum', 0.0231, 'lps'),
	(601019, 127, '2014-04-01 00:34:44.000000', 'consum', 0.0226, 'lps'),
	(601020, 127, '2014-04-01 00:34:45.000000', 'consum', 0.0229, 'lps'),
	(601021, 127, '2014-04-01 00:34:46.000000', 'consum', 0.0211, 'lps'),
	(601022, 127, '2014-04-01 00:34:47.000000', 'consum', 0.0225, 'lps'),
	(601023, 127, '2014-04-01 00:34:48.000000', 'consum', 0.0215, 'lps'),
	(601024, 127, '2014-04-01 00:34:49.000000', 'consum', 0.0214, 'lps'),
	(601025, 127, '2014-04-01 00:34:50.000000', 'consum', 0.0215, 'lps'),
	(601026, 127, '2014-04-01 00:34:51.000000', 'consum', 0.0225, 'lps'),
	(601027, 127, '2014-04-01 00:34:52.000000', 'consum', 0.0225, 'lps'),
	(601028, 127, '2014-04-01 00:34:53.000000', 'consum', 0.0220, 'lps'),
	(601029, 127, '2014-04-01 00:34:54.000000', 'consum', 0.0217, 'lps'),
	(601030, 127, '2014-04-01 00:34:55.000000', 'consum', 0.0213, 'lps'),
	(601031, 127, '2014-04-01 00:34:56.000000', 'consum', 0.0228, 'lps'),
	(601032, 127, '2014-04-01 00:34:57.000000', 'consum', 0.0223, 'lps'),
	(601033, 127, '2014-04-01 00:34:58.000000', 'consum', 0.0223, 'lps'),
	(601034, 127, '2014-04-01 00:34:59.000000', 'consum', 0.0214, 'lps'),
	(601035, 127, '2014-04-01 00:35:00.000000', 'consum', 0.0216, 'lps'),
	(601036, 127, '2014-04-01 00:35:01.000000', 'consum', 0.0225, 'lps'),
	(601037, 127, '2014-04-01 00:35:02.000000', 'consum', 0.0225, 'lps'),
	(601038, 127, '2014-04-01 00:35:03.000000', 'consum', 0.0216, 'lps'),
	(601039, 127, '2014-04-01 00:35:04.000000', 'consum', 0.0221, 'lps'),
	(601040, 127, '2014-04-01 00:35:05.000000', 'consum', 0.0225, 'lps'),
	(601041, 127, '2014-04-01 00:35:06.000000', 'consum', 0.0229, 'lps'),
	(601042, 127, '2014-04-01 00:35:07.000000', 'consum', 0.0216, 'lps'),
	(601043, 127, '2014-04-01 00:35:08.000000', 'consum', 0.0227, 'lps'),
	(601044, 127, '2014-04-01 00:35:09.000000', 'consum', 0.0212, 'lps'),
	(601045, 127, '2014-04-01 00:35:10.000000', 'consum', 0.0214, 'lps'),
	(601046, 127, '2014-04-01 00:35:11.000000', 'consum', 0.0224, 'lps'),
	(601047, 127, '2014-04-01 00:35:12.000000', 'consum', 0.0227, 'lps'),
	(601048, 127, '2014-04-01 00:35:13.000000', 'consum', 0.0229, 'lps'),
	(601049, 127, '2014-04-01 00:35:14.000000', 'consum', 0.0211, 'lps'),
	(601050, 127, '2014-04-01 00:35:15.000000', 'consum', 0.0225, 'lps'),
	(601051, 127, '2014-04-01 00:35:16.000000', 'consum', 0.0217, 'lps'),
	(601052, 127, '2014-04-01 00:35:17.000000', 'consum', 0.0223, 'lps'),
	(601053, 127, '2014-04-01 00:35:18.000000', 'consum', 0.0231, 'lps'),
	(601054, 127, '2014-04-01 00:35:19.000000', 'consum', 0.0210, 'lps'),
	(601055, 127, '2014-04-01 00:35:20.000000', 'consum', 0.0215, 'lps'),
	(601056, 127, '2014-04-01 00:35:21.000000', 'consum', 0.0213, 'lps'),
	(601057, 127, '2014-04-01 00:35:22.000000', 'consum', 0.0211, 'lps'),
	(601058, 127, '2014-04-01 00:35:23.000000', 'consum', 0.0226, 'lps'),
	(601059, 127, '2014-04-01 00:35:24.000000', 'consum', 0.0223, 'lps'),
	(601060, 127, '2014-04-01 00:35:25.000000', 'consum', 0.0229, 'lps'),
	(601061, 127, '2014-04-01 00:35:26.000000', 'consum', 0.0220, 'lps'),
	(601062, 127, '2014-04-01 00:35:27.000000', 'consum', 0.0226, 'lps'),
	(601063, 127, '2014-04-01 00:35:28.000000', 'consum', 0.0218, 'lps'),
	(601064, 127, '2014-04-01 00:35:29.000000', 'consum', 0.0224, 'lps'),
	(601065, 127, '2014-04-01 00:35:30.000000', 'consum', 0.0214, 'lps'),
	(601066, 127, '2014-04-01 00:35:31.000000', 'consum', 0.0210, 'lps'),
	(601067, 127, '2014-04-01 00:35:32.000000', 'consum', 0.0221, 'lps'),
	(601068, 127, '2014-04-01 00:35:33.000000', 'consum', 0.0221, 'lps'),
	(601069, 127, '2014-04-01 00:35:34.000000', 'consum', 0.0212, 'lps'),
	(601070, 127, '2014-04-01 00:35:35.000000', 'consum', 0.0228, 'lps'),
	(601071, 127, '2014-04-01 00:35:36.000000', 'consum', 0.0210, 'lps'),
	(601072, 127, '2014-04-01 00:35:37.000000', 'consum', 0.0221, 'lps'),
	(601073, 127, '2014-04-01 00:35:38.000000', 'consum', 0.0222, 'lps'),
	(601074, 127, '2014-04-01 00:35:39.000000', 'consum', 0.0214, 'lps'),
	(601075, 127, '2014-04-01 00:35:40.000000', 'consum', 0.0216, 'lps'),
	(601076, 127, '2014-04-01 00:35:41.000000', 'consum', 0.0229, 'lps'),
	(601077, 127, '2014-04-01 00:35:42.000000', 'consum', 0.0223, 'lps'),
	(601078, 127, '2014-04-01 00:35:43.000000', 'consum', 0.0218, 'lps'),
	(601079, 127, '2014-04-01 00:35:44.000000', 'consum', 0.0211, 'lps'),
	(601080, 127, '2014-04-01 00:35:45.000000', 'consum', 0.0213, 'lps'),
	(601081, 127, '2014-04-01 00:35:46.000000', 'consum', 0.0224, 'lps'),
	(601082, 127, '2014-04-01 00:35:47.000000', 'consum', 0.0226, 'lps'),
	(601083, 127, '2014-04-01 00:35:48.000000', 'consum', 0.0226, 'lps'),
	(601084, 127, '2014-04-01 00:35:49.000000', 'consum', 0.0221, 'lps'),
	(601085, 127, '2014-04-01 00:35:50.000000', 'consum', 0.0217, 'lps'),
	(601086, 127, '2014-04-01 00:35:51.000000', 'consum', 0.0213, 'lps'),
	(601087, 127, '2014-04-01 00:35:52.000000', 'consum', 0.0228, 'lps'),
	(601088, 127, '2014-04-01 00:35:53.000000', 'consum', 0.0224, 'lps'),
	(601089, 127, '2014-04-01 00:35:54.000000', 'consum', 0.0228, 'lps'),
	(601090, 127, '2014-04-01 00:35:55.000000', 'consum', 0.0213, 'lps'),
	(601091, 127, '2014-04-01 00:35:56.000000', 'consum', 0.0216, 'lps'),
	(601092, 127, '2014-04-01 00:35:57.000000', 'consum', 0.0210, 'lps'),
	(601093, 127, '2014-04-01 00:35:58.000000', 'consum', 0.0216, 'lps'),
	(601094, 127, '2014-04-01 00:35:59.000000', 'consum', 0.0216, 'lps'),
	(601095, 127, '2014-04-01 00:36:00.000000', 'consum', 0.0224, 'lps'),
	(601096, 127, '2014-04-01 00:36:01.000000', 'consum', 0.0218, 'lps'),
	(601097, 127, '2014-04-01 00:36:02.000000', 'consum', 0.0210, 'lps'),
	(601098, 127, '2014-04-01 00:36:03.000000', 'consum', 0.0228, 'lps'),
	(601099, 127, '2014-04-01 00:36:04.000000', 'consum', 0.0215, 'lps'),
	(601100, 127, '2014-04-01 00:36:05.000000', 'consum', 0.0225, 'lps'),
	(601101, 127, '2014-04-01 00:36:06.000000', 'consum', 0.0228, 'lps'),
	(601102, 127, '2014-04-01 00:36:07.000000', 'consum', 0.0210, 'lps'),
	(601103, 127, '2014-04-01 00:36:08.000000', 'consum', 0.0224, 'lps'),
	(601104, 127, '2014-04-01 00:36:09.000000', 'consum', 0.0216, 'lps'),
	(601105, 127, '2014-04-01 00:36:10.000000', 'consum', 0.0217, 'lps'),
	(601106, 127, '2014-04-01 00:36:11.000000', 'consum', 0.0231, 'lps'),
	(601107, 127, '2014-04-01 00:36:12.000000', 'consum', 0.0226, 'lps'),
	(601108, 127, '2014-04-01 00:36:13.000000', 'consum', 0.0228, 'lps'),
	(601109, 127, '2014-04-01 00:36:14.000000', 'consum', 0.0231, 'lps'),
	(601110, 127, '2014-04-01 00:36:15.000000', 'consum', 0.0217, 'lps'),
	(601111, 127, '2014-04-01 00:36:16.000000', 'consum', 0.0226, 'lps'),
	(601112, 127, '2014-04-01 00:36:17.000000', 'consum', 0.0228, 'lps'),
	(601113, 127, '2014-04-01 00:36:18.000000', 'consum', 0.0228, 'lps'),
	(601114, 127, '2014-04-01 00:36:19.000000', 'consum', 0.0224, 'lps'),
	(601115, 127, '2014-04-01 00:36:20.000000', 'consum', 0.0227, 'lps'),
	(601116, 127, '2014-04-01 00:36:21.000000', 'consum', 0.0231, 'lps'),
	(601117, 127, '2014-04-01 00:36:22.000000', 'consum', 0.0220, 'lps'),
	(601118, 127, '2014-04-01 00:36:23.000000', 'consum', 0.0220, 'lps'),
	(601119, 127, '2014-04-01 00:36:24.000000', 'consum', 0.0231, 'lps'),
	(601120, 127, '2014-04-01 00:36:25.000000', 'consum', 0.0218, 'lps'),
	(601121, 127, '2014-04-01 00:36:26.000000', 'consum', 0.0230, 'lps'),
	(601122, 127, '2014-04-01 00:36:27.000000', 'consum', 0.0223, 'lps'),
	(601123, 127, '2014-04-01 00:36:28.000000', 'consum', 0.0216, 'lps'),
	(601124, 127, '2014-04-01 00:36:29.000000', 'consum', 0.0223, 'lps'),
	(601125, 127, '2014-04-01 00:36:30.000000', 'consum', 0.0212, 'lps'),
	(601126, 127, '2014-04-01 00:36:31.000000', 'consum', 0.0226, 'lps'),
	(601127, 127, '2014-04-01 00:36:32.000000', 'consum', 0.0219, 'lps'),
	(601128, 127, '2014-04-01 00:36:33.000000', 'consum', 0.0229, 'lps'),
	(601129, 127, '2014-04-01 00:36:34.000000', 'consum', 0.0215, 'lps'),
	(601130, 127, '2014-04-01 00:36:35.000000', 'consum', 0.0220, 'lps'),
	(601131, 127, '2014-04-01 00:36:36.000000', 'consum', 0.0225, 'lps'),
	(601132, 127, '2014-04-01 00:36:37.000000', 'consum', 0.0211, 'lps'),
	(601133, 127, '2014-04-01 00:36:38.000000', 'consum', 0.0216, 'lps'),
	(601134, 127, '2014-04-01 00:36:39.000000', 'consum', 0.0214, 'lps'),
	(601135, 127, '2014-04-01 00:36:40.000000', 'consum', 0.0212, 'lps'),
	(601136, 127, '2014-04-01 00:36:41.000000', 'consum', 0.0210, 'lps'),
	(601137, 127, '2014-04-01 00:36:42.000000', 'consum', 0.0228, 'lps'),
	(601138, 127, '2014-04-01 00:36:43.000000', 'consum', 0.0210, 'lps'),
	(601139, 127, '2014-04-01 00:36:44.000000', 'consum', 0.0222, 'lps'),
	(601140, 127, '2014-04-01 00:36:45.000000', 'consum', 0.0229, 'lps'),
	(601141, 127, '2014-04-01 00:36:46.000000', 'consum', 0.0226, 'lps'),
	(601142, 127, '2014-04-01 00:36:47.000000', 'consum', 0.0231, 'lps'),
	(601143, 127, '2014-04-01 00:36:48.000000', 'consum', 0.0224, 'lps'),
	(601144, 127, '2014-04-01 00:36:49.000000', 'consum', 0.0219, 'lps'),
	(601145, 127, '2014-04-01 00:36:50.000000', 'consum', 0.0212, 'lps'),
	(601146, 127, '2014-04-01 00:36:51.000000', 'consum', 0.0215, 'lps'),
	(601147, 127, '2014-04-01 00:36:52.000000', 'consum', 0.0210, 'lps'),
	(601148, 127, '2014-04-01 00:36:53.000000', 'consum', 0.0216, 'lps'),
	(601149, 127, '2014-04-01 00:36:54.000000', 'consum', 0.0217, 'lps'),
	(601150, 127, '2014-04-01 00:36:55.000000', 'consum', 0.0229, 'lps'),
	(601151, 127, '2014-04-01 00:36:56.000000', 'consum', 0.0218, 'lps'),
	(601152, 127, '2014-04-01 00:36:57.000000', 'consum', 0.0214, 'lps'),
	(601153, 127, '2014-04-01 00:36:58.000000', 'consum', 0.0231, 'lps'),
	(601154, 127, '2014-04-01 00:36:59.000000', 'consum', 0.0214, 'lps'),
	(601155, 127, '2014-04-01 00:37:00.000000', 'consum', 0.0210, 'lps'),
	(601156, 127, '2014-04-01 00:37:01.000000', 'consum', 0.0223, 'lps'),
	(601157, 127, '2014-04-01 00:37:02.000000', 'consum', 0.0210, 'lps'),
	(601158, 127, '2014-04-01 00:37:03.000000', 'consum', 0.0213, 'lps'),
	(601159, 127, '2014-04-01 00:37:04.000000', 'consum', 0.0228, 'lps'),
	(601160, 127, '2014-04-01 00:37:05.000000', 'consum', 0.0224, 'lps'),
	(601161, 127, '2014-04-01 00:37:06.000000', 'consum', 0.0228, 'lps'),
	(601162, 127, '2014-04-01 00:37:07.000000', 'consum', 0.0213, 'lps'),
	(601163, 127, '2014-04-01 00:37:08.000000', 'consum', 0.0216, 'lps'),
	(601164, 127, '2014-04-01 00:37:09.000000', 'consum', 0.0211, 'lps'),
	(601165, 127, '2014-04-01 00:37:10.000000', 'consum', 0.0217, 'lps'),
	(601166, 127, '2014-04-01 00:37:11.000000', 'consum', 0.0221, 'lps'),
	(601167, 127, '2014-04-01 00:37:12.000000', 'consum', 0.0224, 'lps'),
	(601168, 127, '2014-04-01 00:37:13.000000', 'consum', 0.0224, 'lps'),
	(601169, 127, '2014-04-01 00:37:14.000000', 'consum', 0.0215, 'lps'),
	(601170, 127, '2014-04-01 00:37:15.000000', 'consum', 0.0217, 'lps'),
	(601171, 127, '2014-04-01 00:37:16.000000', 'consum', 0.0210, 'lps'),
	(601172, 127, '2014-04-01 00:37:17.000000', 'consum', 0.0231, 'lps'),
	(601173, 127, '2014-04-01 00:37:18.000000', 'consum', 0.0230, 'lps'),
	(601174, 127, '2014-04-01 00:37:19.000000', 'consum', 0.0223, 'lps'),
	(601175, 127, '2014-04-01 00:37:20.000000', 'consum', 0.0219, 'lps'),
	(601176, 127, '2014-04-01 00:37:21.000000', 'consum', 0.0213, 'lps'),
	(601177, 127, '2014-04-01 00:37:22.000000', 'consum', 0.0222, 'lps'),
	(601178, 127, '2014-04-01 00:37:23.000000', 'consum', 0.0219, 'lps'),
	(601179, 127, '2014-04-01 00:37:24.000000', 'consum', 0.0217, 'lps'),
	(601180, 127, '2014-04-01 00:37:25.000000', 'consum', 0.0218, 'lps'),
	(601181, 127, '2014-04-01 00:37:26.000000', 'consum', 0.0210, 'lps'),
	(601182, 127, '2014-04-01 00:37:27.000000', 'consum', 0.0230, 'lps'),
	(601183, 127, '2014-04-01 00:37:28.000000', 'consum', 0.0224, 'lps'),
	(601184, 127, '2014-04-01 00:37:29.000000', 'consum', 0.0219, 'lps'),
	(601185, 127, '2014-04-01 00:37:30.000000', 'consum', 0.0211, 'lps'),
	(601186, 127, '2014-04-01 00:37:31.000000', 'consum', 0.0214, 'lps'),
	(601187, 127, '2014-04-01 00:37:32.000000', 'consum', 0.0228, 'lps'),
	(601188, 127, '2014-04-01 00:37:33.000000', 'consum', 0.0222, 'lps'),
	(601189, 127, '2014-04-01 00:37:34.000000', 'consum', 0.0214, 'lps'),
	(601190, 127, '2014-04-01 00:37:35.000000', 'consum', 0.0217, 'lps'),
	(601191, 127, '2014-04-01 00:37:36.000000', 'consum', 0.0214, 'lps'),
	(601192, 127, '2014-04-01 00:37:37.000000', 'consum', 0.0231, 'lps'),
	(601193, 127, '2014-04-01 00:37:38.000000', 'consum', 0.0215, 'lps'),
	(601194, 127, '2014-04-01 00:37:39.000000', 'consum', 0.0217, 'lps'),
	(601195, 127, '2014-04-01 00:37:40.000000', 'consum', 0.0231, 'lps'),
	(601196, 127, '2014-04-01 00:37:41.000000', 'consum', 0.0226, 'lps'),
	(601197, 127, '2014-04-01 00:37:42.000000', 'consum', 0.0229, 'lps'),
	(601198, 127, '2014-04-01 00:37:43.000000', 'consum', 0.0212, 'lps'),
	(601199, 127, '2014-04-01 00:37:44.000000', 'consum', 0.0210, 'lps'),
	(601200, 127, '2014-04-01 00:37:45.000000', 'consum', 0.0228, 'lps'),
	(601201, 127, '2014-04-01 00:37:46.000000', 'consum', 0.0231, 'lps'),
	(601202, 127, '2014-04-01 00:37:47.000000', 'consum', 0.0217, 'lps'),
	(601203, 127, '2014-04-01 00:37:48.000000', 'consum', 0.0229, 'lps'),
	(601204, 127, '2014-04-01 00:37:49.000000', 'consum', 0.0217, 'lps'),
	(601205, 127, '2014-04-01 00:37:50.000000', 'consum', 0.0212, 'lps'),
	(601206, 127, '2014-04-01 00:37:51.000000', 'consum', 0.0222, 'lps'),
	(601207, 127, '2014-04-01 00:37:52.000000', 'consum', 0.0221, 'lps'),
	(601208, 127, '2014-04-01 00:37:53.000000', 'consum', 0.0227, 'lps'),
	(601209, 127, '2014-04-01 00:37:54.000000', 'consum', 0.0221, 'lps'),
	(601210, 127, '2014-04-01 00:37:55.000000', 'consum', 0.0211, 'lps'),
	(601211, 127, '2014-04-01 00:37:56.000000', 'consum', 0.0230, 'lps'),
	(601212, 127, '2014-04-01 00:37:57.000000', 'consum', 0.0218, 'lps'),
	(601213, 127, '2014-04-01 00:37:58.000000', 'consum', 0.0211, 'lps'),
	(601214, 127, '2014-04-01 00:37:59.000000', 'consum', 0.0216, 'lps'),
	(601215, 127, '2014-04-01 00:38:00.000000', 'consum', 0.0213, 'lps'),
	(601216, 127, '2014-04-01 00:38:01.000000', 'consum', 0.0229, 'lps'),
	(601217, 127, '2014-04-01 00:38:02.000000', 'consum', 0.0210, 'lps'),
	(601218, 127, '2014-04-01 00:38:03.000000', 'consum', 0.0219, 'lps'),
	(601219, 127, '2014-04-01 00:38:04.000000', 'consum', 0.0211, 'lps'),
	(601220, 127, '2014-04-01 00:38:05.000000', 'consum', 0.0211, 'lps'),
	(601221, 127, '2014-04-01 00:38:06.000000', 'consum', 0.0212, 'lps'),
	(601222, 127, '2014-04-01 00:38:07.000000', 'consum', 0.0219, 'lps'),
	(601223, 127, '2014-04-01 00:38:08.000000', 'consum', 0.0227, 'lps'),
	(601224, 127, '2014-04-01 00:38:09.000000', 'consum', 0.0224, 'lps'),
	(601225, 127, '2014-04-01 00:38:10.000000', 'consum', 0.0230, 'lps'),
	(601226, 127, '2014-04-01 00:38:11.000000', 'consum', 0.0223, 'lps'),
	(601227, 127, '2014-04-01 00:38:12.000000', 'consum', 0.0218, 'lps'),
	(601228, 127, '2014-04-01 00:38:13.000000', 'consum', 0.0210, 'lps'),
	(601229, 127, '2014-04-01 00:38:14.000000', 'consum', 0.0211, 'lps'),
	(601230, 127, '2014-04-01 00:38:15.000000', 'consum', 0.0212, 'lps'),
	(601231, 127, '2014-04-01 00:38:16.000000', 'consum', 0.0221, 'lps'),
	(601232, 127, '2014-04-01 00:38:17.000000', 'consum', 0.0213, 'lps'),
	(601233, 127, '2014-04-01 00:38:18.000000', 'consum', 0.0215, 'lps'),
	(601234, 127, '2014-04-01 00:38:19.000000', 'consum', 0.0228, 'lps'),
	(601235, 127, '2014-04-01 00:38:20.000000', 'consum', 0.0217, 'lps'),
	(601236, 127, '2014-04-01 00:38:21.000000', 'consum', 0.0213, 'lps'),
	(601237, 127, '2014-04-01 00:38:22.000000', 'consum', 0.0228, 'lps'),
	(601238, 127, '2014-04-01 00:38:23.000000', 'consum', 0.0224, 'lps'),
	(601239, 127, '2014-04-01 00:38:24.000000', 'consum', 0.0226, 'lps'),
	(601240, 127, '2014-04-01 00:38:25.000000', 'consum', 0.0227, 'lps'),
	(601241, 127, '2014-04-01 00:38:26.000000', 'consum', 0.0228, 'lps'),
	(601242, 127, '2014-04-01 00:38:27.000000', 'consum', 0.0224, 'lps'),
	(601243, 127, '2014-04-01 00:38:28.000000', 'consum', 0.0229, 'lps'),
	(601244, 127, '2014-04-01 00:38:29.000000', 'consum', 0.0221, 'lps'),
	(601245, 127, '2014-04-01 00:38:30.000000', 'consum', 0.0228, 'lps'),
	(601246, 127, '2014-04-01 00:38:31.000000', 'consum', 0.0223, 'lps'),
	(601247, 127, '2014-04-01 00:38:32.000000', 'consum', 0.0224, 'lps'),
	(601248, 127, '2014-04-01 00:38:33.000000', 'consum', 0.0219, 'lps'),
	(601249, 127, '2014-04-01 00:38:34.000000', 'consum', 0.0211, 'lps'),
	(601250, 127, '2014-04-01 00:38:35.000000', 'consum', 0.0214, 'lps'),
	(601251, 127, '2014-04-01 00:38:36.000000', 'consum', 0.0224, 'lps'),
	(601252, 127, '2014-04-01 00:38:37.000000', 'consum', 0.0227, 'lps'),
	(601253, 127, '2014-04-01 00:38:38.000000', 'consum', 0.0210, 'lps'),
	(601254, 127, '2014-04-01 00:38:39.000000', 'consum', 0.0225, 'lps'),
	(601255, 127, '2014-04-01 00:38:40.000000', 'consum', 0.0221, 'lps'),
	(601256, 127, '2014-04-01 00:38:41.000000', 'consum', 0.0218, 'lps'),
	(601257, 127, '2014-04-01 00:38:42.000000', 'consum', 0.0219, 'lps'),
	(601258, 127, '2014-04-01 00:38:43.000000', 'consum', 0.0210, 'lps'),
	(601259, 127, '2014-04-01 00:38:44.000000', 'consum', 0.0227, 'lps'),
	(601260, 127, '2014-04-01 00:38:45.000000', 'consum', 0.0227, 'lps'),
	(601261, 127, '2014-04-01 00:38:46.000000', 'consum', 0.0226, 'lps'),
	(601262, 127, '2014-04-01 00:38:47.000000', 'consum', 0.0216, 'lps'),
	(601263, 127, '2014-04-01 00:38:48.000000', 'consum', 0.0215, 'lps'),
	(601264, 127, '2014-04-01 00:38:49.000000', 'consum', 0.0219, 'lps'),
	(601265, 127, '2014-04-01 00:38:50.000000', 'consum', 0.0217, 'lps'),
	(601266, 127, '2014-04-01 00:38:51.000000', 'consum', 0.0219, 'lps'),
	(601267, 127, '2014-04-01 00:38:52.000000', 'consum', 0.0214, 'lps'),
	(601268, 127, '2014-04-01 00:38:53.000000', 'consum', 0.0223, 'lps'),
	(601269, 127, '2014-04-01 00:38:54.000000', 'consum', 0.0221, 'lps'),
	(601270, 127, '2014-04-01 00:38:55.000000', 'consum', 0.0226, 'lps'),
	(601271, 127, '2014-04-01 00:38:56.000000', 'consum', 0.0214, 'lps'),
	(601272, 127, '2014-04-01 00:38:57.000000', 'consum', 0.0226, 'lps'),
	(601273, 127, '2014-04-01 00:38:58.000000', 'consum', 0.0214, 'lps'),
	(601274, 127, '2014-04-01 00:38:59.000000', 'consum', 0.0225, 'lps'),
	(601275, 127, '2014-04-01 00:39:00.000000', 'consum', 0.0230, 'lps'),
	(601276, 127, '2014-04-01 00:39:01.000000', 'consum', 0.0220, 'lps'),
	(601277, 127, '2014-04-01 00:39:02.000000', 'consum', 0.0222, 'lps'),
	(601278, 127, '2014-04-01 00:39:03.000000', 'consum', 0.0221, 'lps'),
	(601279, 127, '2014-04-01 00:39:04.000000', 'consum', 0.0226, 'lps'),
	(601280, 127, '2014-04-01 00:39:05.000000', 'consum', 0.0217, 'lps'),
	(601281, 127, '2014-04-01 00:39:06.000000', 'consum', 0.0220, 'lps'),
	(601282, 127, '2014-04-01 00:39:07.000000', 'consum', 0.0214, 'lps'),
	(601283, 127, '2014-04-01 00:39:08.000000', 'consum', 0.0225, 'lps'),
	(601284, 127, '2014-04-01 00:39:09.000000', 'consum', 0.0231, 'lps'),
	(601285, 127, '2014-04-01 00:39:10.000000', 'consum', 0.0224, 'lps'),
	(601286, 127, '2014-04-01 00:39:11.000000', 'consum', 0.0220, 'lps'),
	(601287, 127, '2014-04-01 00:39:12.000000', 'consum', 0.0215, 'lps'),
	(601288, 127, '2014-04-01 00:39:13.000000', 'consum', 0.0230, 'lps'),
	(601289, 127, '2014-04-01 00:39:14.000000', 'consum', 0.0229, 'lps'),
	(601290, 127, '2014-04-01 00:39:15.000000', 'consum', 0.0225, 'lps'),
	(601291, 127, '2014-04-01 00:39:16.000000', 'consum', 0.0229, 'lps'),
	(601292, 127, '2014-04-01 00:39:17.000000', 'consum', 0.0214, 'lps'),
	(601293, 127, '2014-04-01 00:39:18.000000', 'consum', 0.0219, 'lps'),
	(601294, 127, '2014-04-01 00:39:19.000000', 'consum', 0.0222, 'lps'),
	(601295, 127, '2014-04-01 00:39:20.000000', 'consum', 0.0219, 'lps'),
	(601296, 127, '2014-04-01 00:39:21.000000', 'consum', 0.0221, 'lps'),
	(601297, 127, '2014-04-01 00:39:22.000000', 'consum', 0.0214, 'lps'),
	(601298, 127, '2014-04-01 00:39:23.000000', 'consum', 0.0223, 'lps'),
	(601299, 127, '2014-04-01 00:39:24.000000', 'consum', 0.0218, 'lps'),
	(601300, 127, '2014-04-01 00:39:25.000000', 'consum', 0.0210, 'lps'),
	(601301, 127, '2014-04-01 00:39:26.000000', 'consum', 0.0211, 'lps'),
	(601302, 127, '2014-04-01 00:39:27.000000', 'consum', 0.0216, 'lps'),
	(601303, 127, '2014-04-01 00:39:28.000000', 'consum', 0.0216, 'lps'),
	(601304, 127, '2014-04-01 00:39:29.000000', 'consum', 0.0222, 'lps'),
	(601305, 127, '2014-04-01 00:39:30.000000', 'consum', 0.0229, 'lps'),
	(601306, 127, '2014-04-01 00:39:31.000000', 'consum', 0.0228, 'lps'),
	(601307, 127, '2014-04-01 00:39:32.000000', 'consum', 0.0218, 'lps'),
	(601308, 127, '2014-04-01 00:39:33.000000', 'consum', 0.0222, 'lps'),
	(601309, 127, '2014-04-01 00:39:34.000000', 'consum', 0.0222, 'lps'),
	(601310, 127, '2014-04-01 00:39:35.000000', 'consum', 0.0213, 'lps'),
	(601311, 127, '2014-04-01 00:39:36.000000', 'consum', 0.0211, 'lps'),
	(601312, 127, '2014-04-01 00:39:37.000000', 'consum', 0.0230, 'lps'),
	(601313, 127, '2014-04-01 00:39:38.000000', 'consum', 0.0221, 'lps'),
	(601314, 127, '2014-04-01 00:39:39.000000', 'consum', 0.0224, 'lps'),
	(601315, 127, '2014-04-01 00:39:40.000000', 'consum', 0.0227, 'lps'),
	(601316, 127, '2014-04-01 00:39:41.000000', 'consum', 0.0231, 'lps'),
	(601317, 127, '2014-04-01 00:39:42.000000', 'consum', 0.0220, 'lps'),
	(601318, 127, '2014-04-01 00:39:43.000000', 'consum', 0.0221, 'lps'),
	(601319, 127, '2014-04-01 00:39:44.000000', 'consum', 0.0214, 'lps'),
	(601320, 127, '2014-04-01 00:39:45.000000', 'consum', 0.0217, 'lps'),
	(601321, 127, '2014-04-01 00:39:46.000000', 'consum', 0.0214, 'lps'),
	(601322, 127, '2014-04-01 00:39:47.000000', 'consum', 0.0229, 'lps'),
	(601323, 127, '2014-04-01 00:39:48.000000', 'consum', 0.0228, 'lps'),
	(601324, 127, '2014-04-01 00:39:49.000000', 'consum', 0.0220, 'lps'),
	(601325, 127, '2014-04-01 00:39:50.000000', 'consum', 0.0229, 'lps'),
	(601326, 127, '2014-04-01 00:39:51.000000', 'consum', 0.0231, 'lps'),
	(601327, 127, '2014-04-01 00:39:52.000000', 'consum', 0.0217, 'lps'),
	(601328, 127, '2014-04-01 00:39:53.000000', 'consum', 0.0225, 'lps'),
	(601329, 127, '2014-04-01 00:39:54.000000', 'consum', 0.0223, 'lps'),
	(601330, 127, '2014-04-01 00:39:55.000000', 'consum', 0.0227, 'lps'),
	(601331, 127, '2014-04-01 00:39:56.000000', 'consum', 0.0216, 'lps'),
	(601332, 127, '2014-04-01 00:39:57.000000', 'consum', 0.0210, 'lps'),
	(601333, 127, '2014-04-01 00:39:58.000000', 'consum', 0.0212, 'lps'),
	(601334, 127, '2014-04-01 00:39:59.000000', 'consum', 0.0224, 'lps'),
	(601335, 127, '2014-04-01 00:40:00.000000', 'consum', 0.0229, 'lps'),
	(601336, 127, '2014-04-01 00:40:01.000000', 'consum', 0.0220, 'lps'),
	(601337, 127, '2014-04-01 00:40:02.000000', 'consum', 0.0226, 'lps'),
	(601338, 127, '2014-04-01 00:40:03.000000', 'consum', 0.0216, 'lps'),
	(601339, 127, '2014-04-01 00:40:04.000000', 'consum', 0.0215, 'lps'),
	(601340, 127, '2014-04-01 00:40:05.000000', 'consum', 0.0218, 'lps'),
	(601341, 127, '2014-04-01 00:40:06.000000', 'consum', 0.0214, 'lps'),
	(601342, 127, '2014-04-01 00:40:07.000000', 'consum', 0.0228, 'lps'),
	(601343, 127, '2014-04-01 00:40:08.000000', 'consum', 0.0224, 'lps'),
	(601344, 127, '2014-04-01 00:40:09.000000', 'consum', 0.0226, 'lps'),
	(601345, 127, '2014-04-01 00:40:10.000000', 'consum', 0.0227, 'lps'),
	(601346, 127, '2014-04-01 00:40:11.000000', 'consum', 0.0227, 'lps'),
	(601347, 127, '2014-04-01 00:40:12.000000', 'consum', 0.0221, 'lps'),
	(601348, 127, '2014-04-01 00:40:13.000000', 'consum', 0.0214, 'lps'),
	(601349, 127, '2014-04-01 00:40:14.000000', 'consum', 0.0218, 'lps'),
	(601350, 127, '2014-04-01 00:40:15.000000', 'consum', 0.0217, 'lps'),
	(601351, 127, '2014-04-01 00:40:16.000000', 'consum', 0.0223, 'lps'),
	(601352, 127, '2014-04-01 00:40:17.000000', 'consum', 0.0231, 'lps'),
	(601353, 127, '2014-04-01 00:40:18.000000', 'consum', 0.0231, 'lps'),
	(601354, 127, '2014-04-01 00:40:19.000000', 'consum', 0.0211, 'lps'),
	(601355, 127, '2014-04-01 00:40:20.000000', 'consum', 0.0218, 'lps'),
	(601356, 127, '2014-04-01 00:40:21.000000', 'consum', 0.0224, 'lps'),
	(601357, 127, '2014-04-01 00:40:22.000000', 'consum', 0.0214, 'lps'),
	(601358, 127, '2014-04-01 00:40:23.000000', 'consum', 0.0212, 'lps'),
	(601359, 127, '2014-04-01 00:40:24.000000', 'consum', 0.0227, 'lps'),
	(601360, 127, '2014-04-01 00:40:25.000000', 'consum', 0.0226, 'lps'),
	(601361, 127, '2014-04-01 00:40:26.000000', 'consum', 0.0217, 'lps'),
	(601362, 127, '2014-04-01 00:40:27.000000', 'consum', 0.0218, 'lps'),
	(601363, 127, '2014-04-01 00:40:28.000000', 'consum', 0.0230, 'lps'),
	(601364, 127, '2014-04-01 00:40:29.000000', 'consum', 0.0219, 'lps'),
	(601365, 127, '2014-04-01 00:40:30.000000', 'consum', 0.0218, 'lps'),
	(601366, 127, '2014-04-01 00:40:31.000000', 'consum', 0.0223, 'lps'),
	(601367, 127, '2014-04-01 00:40:32.000000', 'consum', 0.0230, 'lps'),
	(601368, 127, '2014-04-01 00:40:33.000000', 'consum', 0.0227, 'lps'),
	(601369, 127, '2014-04-01 00:40:34.000000', 'consum', 0.0214, 'lps'),
	(601370, 127, '2014-04-01 00:40:35.000000', 'consum', 0.0223, 'lps'),
	(601371, 127, '2014-04-01 00:40:36.000000', 'consum', 0.0220, 'lps'),
	(601372, 127, '2014-04-01 00:40:37.000000', 'consum', 0.0220, 'lps'),
	(601373, 127, '2014-04-01 00:40:38.000000', 'consum', 0.0230, 'lps'),
	(601374, 127, '2014-04-01 00:40:39.000000', 'consum', 0.0217, 'lps'),
	(601375, 127, '2014-04-01 00:40:40.000000', 'consum', 0.0230, 'lps'),
	(601376, 127, '2014-04-01 00:40:41.000000', 'consum', 0.0224, 'lps'),
	(601377, 127, '2014-04-01 00:40:42.000000', 'consum', 0.0218, 'lps'),
	(601378, 127, '2014-04-01 00:40:43.000000', 'consum', 0.0230, 'lps'),
	(601379, 127, '2014-04-01 00:40:44.000000', 'consum', 0.0224, 'lps'),
	(601380, 127, '2014-04-01 00:40:45.000000', 'consum', 0.0217, 'lps'),
	(601381, 127, '2014-04-01 00:40:46.000000', 'consum', 0.0225, 'lps'),
	(601382, 127, '2014-04-01 00:40:47.000000', 'consum', 0.0222, 'lps'),
	(601383, 127, '2014-04-01 00:40:48.000000', 'consum', 0.0227, 'lps'),
	(601384, 127, '2014-04-01 00:40:49.000000', 'consum', 0.0216, 'lps'),
	(601385, 127, '2014-04-01 00:40:50.000000', 'consum', 0.0231, 'lps'),
	(601386, 127, '2014-04-01 00:40:51.000000', 'consum', 0.0211, 'lps'),
	(601387, 127, '2014-04-01 00:40:52.000000', 'consum', 0.0216, 'lps'),
	(601388, 127, '2014-04-01 00:40:53.000000', 'consum', 0.0217, 'lps'),
	(601389, 127, '2014-04-01 00:40:54.000000', 'consum', 0.0228, 'lps'),
	(601390, 127, '2014-04-01 00:40:55.000000', 'consum', 0.0211, 'lps'),
	(601391, 127, '2014-04-01 00:40:56.000000', 'consum', 0.0229, 'lps'),
	(601392, 127, '2014-04-01 00:40:57.000000', 'consum', 0.0216, 'lps'),
	(601393, 127, '2014-04-01 00:40:58.000000', 'consum', 0.0227, 'lps'),
	(601394, 127, '2014-04-01 00:40:59.000000', 'consum', 0.0211, 'lps'),
	(601395, 127, '2014-04-01 00:41:00.000000', 'consum', 0.0230, 'lps'),
	(601396, 127, '2014-04-01 00:41:01.000000', 'consum', 0.0220, 'lps'),
	(601397, 127, '2014-04-01 00:41:02.000000', 'consum', 0.0221, 'lps'),
	(601398, 127, '2014-04-01 00:41:03.000000', 'consum', 0.0216, 'lps'),
	(601399, 127, '2014-04-01 00:41:04.000000', 'consum', 0.0226, 'lps'),
	(601400, 127, '2014-04-01 00:41:05.000000', 'consum', 0.0210, 'lps'),
	(601401, 127, '2014-04-01 00:41:06.000000', 'consum', 0.0228, 'lps'),
	(601402, 127, '2014-04-01 00:41:07.000000', 'consum', 0.0212, 'lps'),
	(601403, 127, '2014-04-01 00:41:08.000000', 'consum', 0.0210, 'lps'),
	(601404, 127, '2014-04-01 00:41:09.000000', 'consum', 0.0228, 'lps'),
	(601405, 127, '2014-04-01 00:41:10.000000', 'consum', 0.0211, 'lps'),
	(601406, 127, '2014-04-01 00:41:11.000000', 'consum', 0.0230, 'lps'),
	(601407, 127, '2014-04-01 00:41:12.000000', 'consum', 0.0218, 'lps'),
	(601408, 127, '2014-04-01 00:41:13.000000', 'consum', 0.0211, 'lps'),
	(601409, 127, '2014-04-01 00:41:14.000000', 'consum', 0.0215, 'lps'),
	(601410, 127, '2014-04-01 00:41:15.000000', 'consum', 0.0212, 'lps'),
	(601411, 127, '2014-04-01 00:41:16.000000', 'consum', 0.0227, 'lps'),
	(601412, 127, '2014-04-01 00:41:17.000000', 'consum', 0.0222, 'lps'),
	(601413, 127, '2014-04-01 00:41:18.000000', 'consum', 0.0221, 'lps'),
	(601414, 127, '2014-04-01 00:41:19.000000', 'consum', 0.0228, 'lps'),
	(601415, 127, '2014-04-01 00:41:20.000000', 'consum', 0.0225, 'lps'),
	(601416, 127, '2014-04-01 00:41:21.000000', 'consum', 0.0229, 'lps'),
	(601417, 127, '2014-04-01 00:41:22.000000', 'consum', 0.0219, 'lps'),
	(601418, 127, '2014-04-01 00:41:23.000000', 'consum', 0.0222, 'lps'),
	(601419, 127, '2014-04-01 00:41:24.000000', 'consum', 0.0219, 'lps'),
	(601420, 127, '2014-04-01 00:41:25.000000', 'consum', 0.0219, 'lps'),
	(601421, 127, '2014-04-01 00:41:26.000000', 'consum', 0.0228, 'lps'),
	(601422, 127, '2014-04-01 00:41:27.000000', 'consum', 0.0230, 'lps'),
	(601423, 127, '2014-04-01 00:41:28.000000', 'consum', 0.0214, 'lps'),
	(601424, 127, '2014-04-01 00:41:29.000000', 'consum', 0.0212, 'lps'),
	(601425, 127, '2014-04-01 00:41:30.000000', 'consum', 0.0210, 'lps'),
	(601426, 127, '2014-04-01 00:41:31.000000', 'consum', 0.0226, 'lps'),
	(601427, 127, '2014-04-01 00:41:32.000000', 'consum', 0.0223, 'lps'),
	(601428, 127, '2014-04-01 00:41:33.000000', 'consum', 0.0227, 'lps'),
	(601429, 127, '2014-04-01 00:41:34.000000', 'consum', 0.0215, 'lps'),
	(601430, 127, '2014-04-01 00:41:35.000000', 'consum', 0.0226, 'lps'),
	(601431, 127, '2014-04-01 00:41:36.000000', 'consum', 0.0231, 'lps'),
	(601432, 127, '2014-04-01 00:41:37.000000', 'consum', 0.0224, 'lps'),
	(601433, 127, '2014-04-01 00:41:38.000000', 'consum', 0.0219, 'lps'),
	(601434, 127, '2014-04-01 00:41:39.000000', 'consum', 0.0212, 'lps'),
	(601435, 127, '2014-04-01 00:41:40.000000', 'consum', 0.0214, 'lps'),
	(601436, 127, '2014-04-01 00:41:41.000000', 'consum', 0.0225, 'lps'),
	(601437, 127, '2014-04-01 00:41:42.000000', 'consum', 0.0210, 'lps'),
	(601438, 127, '2014-04-01 00:41:43.000000', 'consum', 0.0229, 'lps'),
	(601439, 127, '2014-04-01 00:41:44.000000', 'consum', 0.0218, 'lps'),
	(601440, 127, '2014-04-01 00:41:45.000000', 'consum', 0.0216, 'lps'),
	(601441, 127, '2014-04-01 00:41:46.000000', 'consum', 0.0215, 'lps'),
	(601442, 127, '2014-04-01 00:41:47.000000', 'consum', 0.0218, 'lps'),
	(601443, 127, '2014-04-01 00:41:48.000000', 'consum', 0.0214, 'lps'),
	(601444, 127, '2014-04-01 00:41:49.000000', 'consum', 0.0227, 'lps'),
	(601445, 127, '2014-04-01 00:41:50.000000', 'consum', 0.0219, 'lps'),
	(601446, 127, '2014-04-01 00:41:51.000000', 'consum', 0.0226, 'lps'),
	(601447, 127, '2014-04-01 00:41:52.000000', 'consum', 0.0219, 'lps'),
	(601448, 127, '2014-04-01 00:41:53.000000', 'consum', 0.0231, 'lps'),
	(601449, 127, '2014-04-01 00:41:54.000000', 'consum', 0.0221, 'lps'),
	(601450, 127, '2014-04-01 00:41:55.000000', 'consum', 0.0225, 'lps'),
	(601451, 127, '2014-04-01 00:41:56.000000', 'consum', 0.0230, 'lps'),
	(601452, 127, '2014-04-01 00:41:57.000000', 'consum', 0.0220, 'lps'),
	(601453, 127, '2014-04-01 00:41:58.000000', 'consum', 0.0223, 'lps'),
	(601454, 127, '2014-04-01 00:41:59.000000', 'consum', 0.0225, 'lps'),
	(601455, 127, '2014-04-01 00:42:00.000000', 'consum', 0.0225, 'lps'),
	(601456, 127, '2014-04-01 00:42:01.000000', 'consum', 0.0218, 'lps'),
	(601457, 127, '2014-04-01 00:42:02.000000', 'consum', 0.0228, 'lps'),
	(601458, 127, '2014-04-01 00:42:03.000000', 'consum', 0.0212, 'lps'),
	(601459, 127, '2014-04-01 00:42:04.000000', 'consum', 0.0230, 'lps'),
	(601460, 127, '2014-04-01 00:42:05.000000', 'consum', 0.0216, 'lps'),
	(601461, 127, '2014-04-01 00:42:06.000000', 'consum', 0.0227, 'lps'),
	(601462, 127, '2014-04-01 00:42:07.000000', 'consum', 0.0231, 'lps'),
	(601463, 127, '2014-04-01 00:42:08.000000', 'consum', 0.0223, 'lps'),
	(601464, 127, '2014-04-01 00:42:09.000000', 'consum', 0.0213, 'lps'),
	(601465, 127, '2014-04-01 00:42:10.000000', 'consum', 0.0231, 'lps'),
	(601466, 127, '2014-04-01 00:42:11.000000', 'consum', 0.0219, 'lps'),
	(601467, 127, '2014-04-01 00:42:12.000000', 'consum', 0.0211, 'lps'),
	(601468, 127, '2014-04-01 00:42:13.000000', 'consum', 0.0214, 'lps'),
	(601469, 127, '2014-04-01 00:42:14.000000', 'consum', 0.0226, 'lps'),
	(601470, 127, '2014-04-01 00:42:15.000000', 'consum', 0.0215, 'lps'),
	(601471, 127, '2014-04-01 00:42:16.000000', 'consum', 0.0228, 'lps'),
	(601472, 127, '2014-04-01 00:42:17.000000', 'consum', 0.0220, 'lps'),
	(601473, 127, '2014-04-01 00:42:18.000000', 'consum', 0.0229, 'lps'),
	(601474, 127, '2014-04-01 00:42:19.000000', 'consum', 0.0229, 'lps'),
	(601475, 127, '2014-04-01 00:42:20.000000', 'consum', 0.0230, 'lps'),
	(601476, 127, '2014-04-01 00:42:21.000000', 'consum', 0.0210, 'lps'),
	(601477, 127, '2014-04-01 00:42:22.000000', 'consum', 0.0216, 'lps'),
	(601478, 127, '2014-04-01 00:42:23.000000', 'consum', 0.0216, 'lps'),
	(601479, 127, '2014-04-01 00:42:24.000000', 'consum', 0.0226, 'lps'),
	(601480, 127, '2014-04-01 00:42:25.000000', 'consum', 0.0225, 'lps'),
	(601481, 127, '2014-04-01 00:42:26.000000', 'consum', 0.0218, 'lps'),
	(601482, 127, '2014-04-01 00:42:27.000000', 'consum', 0.0228, 'lps'),
	(601483, 127, '2014-04-01 00:42:28.000000', 'consum', 0.0210, 'lps'),
	(601484, 127, '2014-04-01 00:42:29.000000', 'consum', 0.0223, 'lps'),
	(601485, 127, '2014-04-01 00:42:30.000000', 'consum', 0.0211, 'lps'),
	(601486, 127, '2014-04-01 00:42:31.000000', 'consum', 0.0218, 'lps'),
	(601487, 127, '2014-04-01 00:42:32.000000', 'consum', 0.0224, 'lps'),
	(601488, 127, '2014-04-01 00:42:33.000000', 'consum', 0.0215, 'lps'),
	(601489, 127, '2014-04-01 00:42:34.000000', 'consum', 0.0216, 'lps'),
	(601490, 127, '2014-04-01 00:42:35.000000', 'consum', 0.0224, 'lps'),
	(601491, 127, '2014-04-01 00:42:36.000000', 'consum', 0.0218, 'lps'),
	(601492, 127, '2014-04-01 00:42:37.000000', 'consum', 0.0231, 'lps'),
	(601493, 127, '2014-04-01 00:42:38.000000', 'consum', 0.0228, 'lps'),
	(601494, 127, '2014-04-01 00:42:39.000000', 'consum', 0.0212, 'lps'),
	(601495, 127, '2014-04-01 00:42:40.000000', 'consum', 0.0212, 'lps'),
	(601496, 127, '2014-04-01 00:42:41.000000', 'consum', 0.0216, 'lps'),
	(601497, 127, '2014-04-01 00:42:42.000000', 'consum', 0.0213, 'lps'),
	(601498, 127, '2014-04-01 00:42:43.000000', 'consum', 0.0227, 'lps'),
	(601499, 127, '2014-04-01 00:42:44.000000', 'consum', 0.0223, 'lps'),
	(601500, 127, '2014-04-01 00:42:45.000000', 'consum', 0.0222, 'lps'),
	(601501, 127, '2014-04-01 00:42:46.000000', 'consum', 0.0231, 'lps'),
	(601502, 127, '2014-04-01 00:42:47.000000', 'consum', 0.0213, 'lps'),
	(601503, 127, '2014-04-01 00:42:48.000000', 'consum', 0.0231, 'lps'),
	(601504, 127, '2014-04-01 00:42:49.000000', 'consum', 0.0219, 'lps'),
	(601505, 127, '2014-04-01 00:42:50.000000', 'consum', 0.0215, 'lps'),
	(601506, 127, '2014-04-01 00:42:51.000000', 'consum', 0.0230, 'lps'),
	(601507, 127, '2014-04-01 00:42:52.000000', 'consum', 0.0230, 'lps'),
	(601508, 127, '2014-04-01 00:42:53.000000', 'consum', 0.0228, 'lps'),
	(601509, 127, '2014-04-01 00:42:54.000000', 'consum', 0.0218, 'lps'),
	(601510, 127, '2014-04-01 00:42:55.000000', 'consum', 0.0218, 'lps'),
	(601511, 127, '2014-04-01 00:42:56.000000', 'consum', 0.0226, 'lps'),
	(601512, 127, '2014-04-01 00:42:57.000000', 'consum', 0.0224, 'lps'),
	(601513, 127, '2014-04-01 00:42:58.000000', 'consum', 0.0210, 'lps'),
	(601514, 127, '2014-04-01 00:42:59.000000', 'consum', 0.0212, 'lps'),
	(601515, 127, '2014-04-01 00:43:00.000000', 'consum', 0.0221, 'lps'),
	(601516, 127, '2014-04-01 00:43:01.000000', 'consum', 0.0216, 'lps'),
	(601517, 127, '2014-04-01 00:43:02.000000', 'consum', 0.0230, 'lps'),
	(601518, 127, '2014-04-01 00:43:03.000000', 'consum', 0.0224, 'lps'),
	(601519, 127, '2014-04-01 00:43:04.000000', 'consum', 0.0223, 'lps'),
	(601520, 127, '2014-04-01 00:43:05.000000', 'consum', 0.0212, 'lps'),
	(601521, 127, '2014-04-01 00:43:06.000000', 'consum', 0.0223, 'lps'),
	(601522, 127, '2014-04-01 00:43:07.000000', 'consum', 0.0227, 'lps'),
	(601523, 127, '2014-04-01 00:43:08.000000', 'consum', 0.0212, 'lps'),
	(601524, 127, '2014-04-01 00:43:09.000000', 'consum', 0.0213, 'lps'),
	(601525, 127, '2014-04-01 00:43:10.000000', 'consum', 0.0218, 'lps'),
	(601526, 127, '2014-04-01 00:43:11.000000', 'consum', 0.0222, 'lps'),
	(601527, 127, '2014-04-01 00:43:12.000000', 'consum', 0.0223, 'lps'),
	(601528, 127, '2014-04-01 00:43:13.000000', 'consum', 0.0217, 'lps'),
	(601529, 127, '2014-04-01 00:43:14.000000', 'consum', 0.0227, 'lps'),
	(601530, 127, '2014-04-01 00:43:15.000000', 'consum', 0.0212, 'lps'),
	(601531, 127, '2014-04-01 00:43:16.000000', 'consum', 0.0210, 'lps'),
	(601532, 127, '2014-04-01 00:43:17.000000', 'consum', 0.0230, 'lps'),
	(601533, 127, '2014-04-01 00:43:18.000000', 'consum', 0.0220, 'lps'),
	(601534, 127, '2014-04-01 00:43:19.000000', 'consum', 0.0224, 'lps'),
	(601535, 127, '2014-04-01 00:43:20.000000', 'consum', 0.0229, 'lps'),
	(601536, 127, '2014-04-01 00:43:21.000000', 'consum', 0.0220, 'lps'),
	(601537, 127, '2014-04-01 00:43:22.000000', 'consum', 0.0226, 'lps'),
	(601538, 127, '2014-04-01 00:43:23.000000', 'consum', 0.0214, 'lps'),
	(601539, 127, '2014-04-01 00:43:24.000000', 'consum', 0.0229, 'lps'),
	(601540, 127, '2014-04-01 00:43:25.000000', 'consum', 0.0226, 'lps'),
	(601541, 127, '2014-04-01 00:43:26.000000', 'consum', 0.0212, 'lps'),
	(601542, 127, '2014-04-01 00:43:27.000000', 'consum', 0.0217, 'lps'),
	(601543, 127, '2014-04-01 00:43:28.000000', 'consum', 0.0218, 'lps'),
	(601544, 127, '2014-04-01 00:43:29.000000', 'consum', 0.0230, 'lps'),
	(601545, 127, '2014-04-01 00:43:30.000000', 'consum', 0.0221, 'lps'),
	(601546, 127, '2014-04-01 00:43:31.000000', 'consum', 0.0228, 'lps'),
	(601547, 127, '2014-04-01 00:43:32.000000', 'consum', 0.0222, 'lps'),
	(601548, 127, '2014-04-01 00:43:33.000000', 'consum', 0.0219, 'lps'),
	(601549, 127, '2014-04-01 00:43:34.000000', 'consum', 0.0217, 'lps'),
	(601550, 127, '2014-04-01 00:43:35.000000', 'consum', 0.0221, 'lps'),
	(601551, 127, '2014-04-01 00:43:36.000000', 'consum', 0.0219, 'lps'),
	(601552, 127, '2014-04-01 00:43:37.000000', 'consum', 0.0225, 'lps'),
	(601553, 127, '2014-04-01 00:43:38.000000', 'consum', 0.0214, 'lps'),
	(601554, 127, '2014-04-01 00:43:39.000000', 'consum', 0.0228, 'lps'),
	(601555, 127, '2014-04-01 00:43:40.000000', 'consum', 0.0222, 'lps'),
	(601556, 127, '2014-04-01 00:43:41.000000', 'consum', 0.0216, 'lps'),
	(601557, 127, '2014-04-01 00:43:42.000000', 'consum', 0.0226, 'lps'),
	(601558, 127, '2014-04-01 00:43:43.000000', 'consum', 0.0228, 'lps'),
	(601559, 127, '2014-04-01 00:43:44.000000', 'consum', 0.0231, 'lps'),
	(601560, 127, '2014-04-01 00:43:45.000000', 'consum', 0.0219, 'lps'),
	(601561, 127, '2014-04-01 00:43:46.000000', 'consum', 0.0215, 'lps'),
	(601562, 127, '2014-04-01 00:43:47.000000', 'consum', 0.0231, 'lps'),
	(601563, 127, '2014-04-01 00:43:48.000000', 'consum', 0.0212, 'lps'),
	(601564, 127, '2014-04-01 00:43:49.000000', 'consum', 0.0223, 'lps'),
	(601565, 127, '2014-04-01 00:43:50.000000', 'consum', 0.0226, 'lps'),
	(601566, 127, '2014-04-01 00:43:51.000000', 'consum', 0.0229, 'lps'),
	(601567, 127, '2014-04-01 00:43:52.000000', 'consum', 0.0213, 'lps'),
	(601568, 127, '2014-04-01 00:43:53.000000', 'consum', 0.0213, 'lps'),
	(601569, 127, '2014-04-01 00:43:54.000000', 'consum', 0.0217, 'lps'),
	(601570, 127, '2014-04-01 00:43:55.000000', 'consum', 0.0212, 'lps'),
	(601571, 127, '2014-04-01 00:43:56.000000', 'consum', 0.0225, 'lps'),
	(601572, 127, '2014-04-01 00:43:57.000000', 'consum', 0.0211, 'lps'),
	(601573, 127, '2014-04-01 00:43:58.000000', 'consum', 0.0215, 'lps'),
	(601574, 127, '2014-04-01 00:43:59.000000', 'consum', 0.0211, 'lps'),
	(601575, 127, '2014-04-01 00:44:00.000000', 'consum', 0.0222, 'lps'),
	(601576, 127, '2014-04-01 00:44:01.000000', 'consum', 0.0225, 'lps'),
	(601577, 127, '2014-04-01 00:44:02.000000', 'consum', 0.0227, 'lps'),
	(601578, 127, '2014-04-01 00:44:03.000000', 'consum', 0.0229, 'lps'),
	(601579, 127, '2014-04-01 00:44:04.000000', 'consum', 0.0211, 'lps'),
	(601580, 127, '2014-04-01 00:44:05.000000', 'consum', 0.0224, 'lps'),
	(601581, 127, '2014-04-01 00:44:06.000000', 'consum', 0.0210, 'lps'),
	(601582, 127, '2014-04-01 00:44:07.000000', 'consum', 0.0214, 'lps'),
	(601583, 127, '2014-04-01 00:44:08.000000', 'consum', 0.0210, 'lps'),
	(601584, 127, '2014-04-01 00:44:09.000000', 'consum', 0.0218, 'lps'),
	(601585, 127, '2014-04-01 00:44:10.000000', 'consum', 0.0229, 'lps'),
	(601586, 127, '2014-04-01 00:44:11.000000', 'consum', 0.0215, 'lps'),
	(601587, 127, '2014-04-01 00:44:12.000000', 'consum', 0.0223, 'lps'),
	(601588, 127, '2014-04-01 00:44:13.000000', 'consum', 0.0215, 'lps'),
	(601589, 127, '2014-04-01 00:44:14.000000', 'consum', 0.0218, 'lps'),
	(601590, 127, '2014-04-01 00:44:15.000000', 'consum', 0.0214, 'lps'),
	(601591, 127, '2014-04-01 00:44:16.000000', 'consum', 0.0230, 'lps'),
	(601592, 127, '2014-04-01 00:44:17.000000', 'consum', 0.0210, 'lps'),
	(601593, 127, '2014-04-01 00:44:18.000000', 'consum', 0.0217, 'lps'),
	(601594, 127, '2014-04-01 00:44:19.000000', 'consum', 0.0221, 'lps'),
	(601595, 127, '2014-04-01 00:44:20.000000', 'consum', 0.0224, 'lps'),
	(601596, 127, '2014-04-01 00:44:21.000000', 'consum', 0.0225, 'lps'),
	(601597, 127, '2014-04-01 00:44:22.000000', 'consum', 0.0223, 'lps'),
	(601598, 127, '2014-04-01 00:44:23.000000', 'consum', 0.0229, 'lps'),
	(601599, 127, '2014-04-01 00:44:24.000000', 'consum', 0.0222, 'lps'),
	(601600, 127, '2014-04-01 00:44:25.000000', 'consum', 0.0213, 'lps'),
	(601601, 127, '2014-04-01 00:44:26.000000', 'consum', 0.0214, 'lps'),
	(601602, 127, '2014-04-01 00:44:27.000000', 'consum', 0.0221, 'lps'),
	(601603, 127, '2014-04-01 00:44:28.000000', 'consum', 0.0231, 'lps'),
	(601604, 127, '2014-04-01 00:44:29.000000', 'consum', 0.0217, 'lps'),
	(601605, 127, '2014-04-01 00:44:30.000000', 'consum', 0.0225, 'lps'),
	(601606, 127, '2014-04-01 00:44:31.000000', 'consum', 0.0221, 'lps'),
	(601607, 127, '2014-04-01 00:44:32.000000', 'consum', 0.0222, 'lps'),
	(601608, 127, '2014-04-01 00:44:33.000000', 'consum', 0.0214, 'lps'),
	(601609, 127, '2014-04-01 00:44:34.000000', 'consum', 0.0216, 'lps'),
	(601610, 127, '2014-04-01 00:44:35.000000', 'consum', 0.0227, 'lps'),
	(601611, 127, '2014-04-01 00:44:36.000000', 'consum', 0.0214, 'lps'),
	(601612, 127, '2014-04-01 00:44:37.000000', 'consum', 0.0223, 'lps'),
	(601613, 127, '2014-04-01 00:44:38.000000', 'consum', 0.0221, 'lps'),
	(601614, 127, '2014-04-01 00:44:39.000000', 'consum', 0.0224, 'lps'),
	(601615, 127, '2014-04-01 00:44:40.000000', 'consum', 0.0225, 'lps'),
	(601616, 127, '2014-04-01 00:44:41.000000', 'consum', 0.0221, 'lps'),
	(601617, 127, '2014-04-01 00:44:42.000000', 'consum', 0.0222, 'lps'),
	(601618, 127, '2014-04-01 00:44:43.000000', 'consum', 0.0217, 'lps'),
	(601619, 127, '2014-04-01 00:44:44.000000', 'consum', 0.0231, 'lps'),
	(601620, 127, '2014-04-01 00:44:45.000000', 'consum', 0.0230, 'lps'),
	(601621, 127, '2014-04-01 00:44:46.000000', 'consum', 0.0222, 'lps'),
	(601622, 127, '2014-04-01 00:44:47.000000', 'consum', 0.0213, 'lps'),
	(601623, 127, '2014-04-01 00:44:48.000000', 'consum', 0.0231, 'lps'),
	(601624, 127, '2014-04-01 00:44:49.000000', 'consum', 0.0220, 'lps'),
	(601625, 127, '2014-04-01 00:44:50.000000', 'consum', 0.0219, 'lps'),
	(601626, 127, '2014-04-01 00:44:51.000000', 'consum', 0.0227, 'lps'),
	(601627, 127, '2014-04-01 00:44:52.000000', 'consum', 0.0223, 'lps'),
	(601628, 127, '2014-04-01 00:44:53.000000', 'consum', 0.0226, 'lps'),
	(601629, 127, '2014-04-01 00:44:54.000000', 'consum', 0.0229, 'lps'),
	(601630, 127, '2014-04-01 00:44:55.000000', 'consum', 0.0212, 'lps'),
	(601631, 127, '2014-04-01 00:44:56.000000', 'consum', 0.0230, 'lps'),
	(601632, 127, '2014-04-01 00:44:57.000000', 'consum', 0.0215, 'lps'),
	(601633, 127, '2014-04-01 00:44:58.000000', 'consum', 0.0220, 'lps'),
	(601634, 127, '2014-04-01 00:44:59.000000', 'consum', 0.0224, 'lps'),
	(601635, 127, '2014-04-01 00:45:00.000000', 'consum', 0.0228, 'lps'),
	(601636, 127, '2014-04-01 00:45:01.000000', 'consum', 0.0214, 'lps'),
	(601637, 127, '2014-04-01 00:45:02.000000', 'consum', 0.0221, 'lps'),
	(601638, 127, '2014-04-01 00:45:03.000000', 'consum', 0.0231, 'lps'),
	(601639, 127, '2014-04-01 00:45:04.000000', 'consum', 0.0218, 'lps'),
	(601640, 127, '2014-04-01 00:45:05.000000', 'consum', 0.0231, 'lps'),
	(601641, 127, '2014-04-01 00:45:06.000000', 'consum', 0.0223, 'lps'),
	(601642, 127, '2014-04-01 00:45:07.000000', 'consum', 0.0215, 'lps'),
	(601643, 127, '2014-04-01 00:45:08.000000', 'consum', 0.0217, 'lps'),
	(601644, 127, '2014-04-01 00:45:09.000000', 'consum', 0.0210, 'lps'),
	(601645, 127, '2014-04-01 00:45:10.000000', 'consum', 0.0212, 'lps'),
	(601646, 127, '2014-04-01 00:45:11.000000', 'consum', 0.0219, 'lps'),
	(601647, 127, '2014-04-01 00:45:12.000000', 'consum', 0.0228, 'lps'),
	(601648, 127, '2014-04-01 00:45:13.000000', 'consum', 0.0228, 'lps'),
	(601649, 127, '2014-04-01 00:45:14.000000', 'consum', 0.0227, 'lps'),
	(601650, 127, '2014-04-01 00:45:15.000000', 'consum', 0.0220, 'lps'),
	(601651, 127, '2014-04-01 00:45:16.000000', 'consum', 0.0230, 'lps'),
	(601652, 127, '2014-04-01 00:45:17.000000', 'consum', 0.0217, 'lps'),
	(601653, 127, '2014-04-01 00:45:18.000000', 'consum', 0.0226, 'lps'),
	(601654, 127, '2014-04-01 00:45:19.000000', 'consum', 0.0227, 'lps'),
	(601655, 127, '2014-04-01 00:45:20.000000', 'consum', 0.0225, 'lps'),
	(601656, 127, '2014-04-01 00:45:21.000000', 'consum', 0.0212, 'lps'),
	(601657, 127, '2014-04-01 00:45:22.000000', 'consum', 0.0221, 'lps'),
	(601658, 127, '2014-04-01 00:45:23.000000', 'consum', 0.0216, 'lps'),
	(601659, 127, '2014-04-01 00:45:24.000000', 'consum', 0.0228, 'lps'),
	(601660, 127, '2014-04-01 00:45:25.000000', 'consum', 0.0217, 'lps'),
	(601661, 127, '2014-04-01 00:45:26.000000', 'consum', 0.0215, 'lps'),
	(601662, 127, '2014-04-01 00:45:27.000000', 'consum', 0.0215, 'lps'),
	(601663, 127, '2014-04-01 00:45:28.000000', 'consum', 0.0219, 'lps'),
	(601664, 127, '2014-04-01 00:45:29.000000', 'consum', 0.0219, 'lps'),
	(601665, 127, '2014-04-01 00:45:30.000000', 'consum', 0.0228, 'lps'),
	(601666, 127, '2014-04-01 00:45:31.000000', 'consum', 0.0230, 'lps'),
	(601667, 127, '2014-04-01 00:45:32.000000', 'consum', 0.0212, 'lps'),
	(601668, 127, '2014-04-01 00:45:33.000000', 'consum', 0.0228, 'lps'),
	(601669, 127, '2014-04-01 00:45:34.000000', 'consum', 0.0227, 'lps'),
	(601670, 127, '2014-04-01 00:45:35.000000', 'consum', 0.0219, 'lps'),
	(601671, 127, '2014-04-01 00:45:36.000000', 'consum', 0.0229, 'lps'),
	(601672, 127, '2014-04-01 00:45:37.000000', 'consum', 0.0210, 'lps'),
	(601673, 127, '2014-04-01 00:45:38.000000', 'consum', 0.0222, 'lps'),
	(601674, 127, '2014-04-01 00:45:39.000000', 'consum', 0.0224, 'lps'),
	(601675, 127, '2014-04-01 00:45:40.000000', 'consum', 0.0222, 'lps'),
	(601676, 127, '2014-04-01 00:45:41.000000', 'consum', 0.0231, 'lps'),
	(601677, 127, '2014-04-01 00:45:42.000000', 'consum', 0.0212, 'lps'),
	(601678, 127, '2014-04-01 00:45:43.000000', 'consum', 0.0222, 'lps'),
	(601679, 127, '2014-04-01 00:45:44.000000', 'consum', 0.0220, 'lps'),
	(601680, 127, '2014-04-01 00:45:45.000000', 'consum', 0.0228, 'lps'),
	(601681, 127, '2014-04-01 00:45:46.000000', 'consum', 0.0223, 'lps'),
	(601682, 127, '2014-04-01 00:45:47.000000', 'consum', 0.0224, 'lps'),
	(601683, 127, '2014-04-01 00:45:48.000000', 'consum', 0.0218, 'lps'),
	(601684, 127, '2014-04-01 00:45:49.000000', 'consum', 0.0229, 'lps'),
	(601685, 127, '2014-04-01 00:45:50.000000', 'consum', 0.0218, 'lps'),
	(601686, 127, '2014-04-01 00:45:51.000000', 'consum', 0.0214, 'lps'),
	(601687, 127, '2014-04-01 00:45:52.000000', 'consum', 0.0229, 'lps'),
	(601688, 127, '2014-04-01 00:45:53.000000', 'consum', 0.0226, 'lps'),
	(601689, 127, '2014-04-01 00:45:54.000000', 'consum', 0.0213, 'lps'),
	(601690, 127, '2014-04-01 00:45:55.000000', 'consum', 0.0222, 'lps'),
	(601691, 127, '2014-04-01 00:45:56.000000', 'consum', 0.0217, 'lps'),
	(601692, 127, '2014-04-01 00:45:57.000000', 'consum', 0.0230, 'lps'),
	(601693, 127, '2014-04-01 00:45:58.000000', 'consum', 0.0223, 'lps'),
	(601694, 127, '2014-04-01 00:45:59.000000', 'consum', 0.0217, 'lps'),
	(601695, 127, '2014-04-01 00:46:00.000000', 'consum', 0.0227, 'lps'),
	(601696, 127, '2014-04-01 00:46:01.000000', 'consum', 0.0230, 'lps'),
	(601697, 127, '2014-04-01 00:46:02.000000', 'consum', 0.0216, 'lps'),
	(601698, 127, '2014-04-01 00:46:03.000000', 'consum', 0.0226, 'lps'),
	(601699, 127, '2014-04-01 00:46:04.000000', 'consum', 0.0230, 'lps'),
	(601700, 127, '2014-04-01 00:46:05.000000', 'consum', 0.0215, 'lps'),
	(601701, 127, '2014-04-01 00:46:06.000000', 'consum', 0.0222, 'lps'),
	(601702, 127, '2014-04-01 00:46:07.000000', 'consum', 0.0212, 'lps'),
	(601703, 127, '2014-04-01 00:46:08.000000', 'consum', 0.0229, 'lps'),
	(601704, 127, '2014-04-01 00:46:09.000000', 'consum', 0.0211, 'lps'),
	(601705, 127, '2014-04-01 00:46:10.000000', 'consum', 0.0223, 'lps'),
	(601706, 127, '2014-04-01 00:46:11.000000', 'consum', 0.0230, 'lps'),
	(601707, 127, '2014-04-01 00:46:12.000000', 'consum', 0.0226, 'lps'),
	(601708, 127, '2014-04-01 00:46:13.000000', 'consum', 0.0231, 'lps'),
	(601709, 127, '2014-04-01 00:46:14.000000', 'consum', 0.0223, 'lps'),
	(601710, 127, '2014-04-01 00:46:15.000000', 'consum', 0.0213, 'lps'),
	(601711, 127, '2014-04-01 00:46:16.000000', 'consum', 0.0228, 'lps'),
	(601712, 127, '2014-04-01 00:46:17.000000', 'consum', 0.0229, 'lps'),
	(601713, 127, '2014-04-01 00:46:18.000000', 'consum', 0.0228, 'lps'),
	(601714, 127, '2014-04-01 00:46:19.000000', 'consum', 0.0223, 'lps'),
	(601715, 127, '2014-04-01 00:46:20.000000', 'consum', 0.0221, 'lps'),
	(601716, 127, '2014-04-01 00:46:21.000000', 'consum', 0.0228, 'lps'),
	(601717, 127, '2014-04-01 00:46:22.000000', 'consum', 0.0223, 'lps'),
	(601718, 127, '2014-04-01 00:46:23.000000', 'consum', 0.0220, 'lps'),
	(601719, 127, '2014-04-01 00:46:24.000000', 'consum', 0.0224, 'lps'),
	(601720, 127, '2014-04-01 00:46:25.000000', 'consum', 0.0227, 'lps'),
	(601721, 127, '2014-04-01 00:46:26.000000', 'consum', 0.0231, 'lps'),
	(601722, 127, '2014-04-01 00:46:27.000000', 'consum', 0.0221, 'lps'),
	(601723, 127, '2014-04-01 00:46:28.000000', 'consum', 0.0222, 'lps'),
	(601724, 127, '2014-04-01 00:46:29.000000', 'consum', 0.0219, 'lps'),
	(601725, 127, '2014-04-01 00:46:30.000000', 'consum', 0.0219, 'lps'),
	(601726, 127, '2014-04-01 00:46:31.000000', 'consum', 0.0229, 'lps'),
	(601727, 127, '2014-04-01 00:46:32.000000', 'consum', 0.0212, 'lps'),
	(601728, 127, '2014-04-01 00:46:33.000000', 'consum', 0.0228, 'lps'),
	(601729, 127, '2014-04-01 00:46:34.000000', 'consum', 0.0228, 'lps'),
	(601730, 127, '2014-04-01 00:46:35.000000', 'consum', 0.0224, 'lps'),
	(601731, 127, '2014-04-01 00:46:36.000000', 'consum', 0.0228, 'lps'),
	(601732, 127, '2014-04-01 00:46:37.000000', 'consum', 0.0214, 'lps'),
	(601733, 127, '2014-04-01 00:46:38.000000', 'consum', 0.0221, 'lps'),
	(601734, 127, '2014-04-01 00:46:39.000000', 'consum', 0.0230, 'lps'),
	(601735, 127, '2014-04-01 00:46:40.000000', 'consum', 0.0214, 'lps'),
	(601736, 127, '2014-04-01 00:46:41.000000', 'consum', 0.0215, 'lps'),
	(601737, 127, '2014-04-01 00:46:42.000000', 'consum', 0.0221, 'lps'),
	(601738, 127, '2014-04-01 00:46:43.000000', 'consum', 0.0229, 'lps'),
	(601739, 127, '2014-04-01 00:46:44.000000', 'consum', 0.0227, 'lps'),
	(601740, 127, '2014-04-01 00:46:45.000000', 'consum', 0.0220, 'lps'),
	(601741, 127, '2014-04-01 00:46:46.000000', 'consum', 0.0229, 'lps'),
	(601742, 127, '2014-04-01 00:46:47.000000', 'consum', 0.0230, 'lps'),
	(601743, 127, '2014-04-01 00:46:48.000000', 'consum', 0.0213, 'lps'),
	(601744, 127, '2014-04-01 00:46:49.000000', 'consum', 0.0228, 'lps'),
	(601745, 127, '2014-04-01 00:46:50.000000', 'consum', 0.0227, 'lps'),
	(601746, 127, '2014-04-01 00:46:51.000000', 'consum', 0.0219, 'lps'),
	(601747, 127, '2014-04-01 00:46:52.000000', 'consum', 0.0225, 'lps'),
	(601748, 127, '2014-04-01 00:46:53.000000', 'consum', 0.0217, 'lps'),
	(601749, 127, '2014-04-01 00:46:54.000000', 'consum', 0.0222, 'lps'),
	(601750, 127, '2014-04-01 00:46:55.000000', 'consum', 0.0228, 'lps'),
	(601751, 127, '2014-04-01 00:46:56.000000', 'consum', 0.0218, 'lps'),
	(601752, 127, '2014-04-01 00:46:57.000000', 'consum', 0.0221, 'lps'),
	(601753, 127, '2014-04-01 00:46:58.000000', 'consum', 0.0218, 'lps'),
	(601754, 127, '2014-04-01 00:46:59.000000', 'consum', 0.0218, 'lps'),
	(601755, 127, '2014-04-01 00:47:00.000000', 'consum', 0.0225, 'lps'),
	(601756, 127, '2014-04-01 00:47:01.000000', 'consum', 0.0218, 'lps'),
	(601757, 127, '2014-04-01 00:47:02.000000', 'consum', 0.0226, 'lps'),
	(601758, 127, '2014-04-01 00:47:03.000000', 'consum', 0.0223, 'lps'),
	(601759, 127, '2014-04-01 00:47:04.000000', 'consum', 0.0229, 'lps'),
	(601760, 127, '2014-04-01 00:47:05.000000', 'consum', 0.0224, 'lps'),
	(601761, 127, '2014-04-01 00:47:06.000000', 'consum', 0.0221, 'lps'),
	(601762, 127, '2014-04-01 00:47:07.000000', 'consum', 0.0225, 'lps'),
	(601763, 127, '2014-04-01 00:47:08.000000', 'consum', 0.0228, 'lps'),
	(601764, 127, '2014-04-01 00:47:09.000000', 'consum', 0.0214, 'lps'),
	(601765, 127, '2014-04-01 00:47:10.000000', 'consum', 0.0219, 'lps'),
	(601766, 127, '2014-04-01 00:47:11.000000', 'consum', 0.0222, 'lps'),
	(601767, 127, '2014-04-01 00:47:12.000000', 'consum', 0.0219, 'lps'),
	(601768, 127, '2014-04-01 00:47:13.000000', 'consum', 0.0223, 'lps'),
	(601769, 127, '2014-04-01 00:47:14.000000', 'consum', 0.0225, 'lps'),
	(601770, 127, '2014-04-01 00:47:15.000000', 'consum', 0.0225, 'lps'),
	(601771, 127, '2014-04-01 00:47:16.000000', 'consum', 0.0220, 'lps'),
	(601772, 127, '2014-04-01 00:47:17.000000', 'consum', 0.0213, 'lps'),
	(601773, 127, '2014-04-01 00:47:18.000000', 'consum', 0.0221, 'lps'),
	(601774, 127, '2014-04-01 00:47:19.000000', 'consum', 0.0231, 'lps'),
	(601775, 127, '2014-04-01 00:47:20.000000', 'consum', 0.0217, 'lps'),
	(601776, 127, '2014-04-01 00:47:21.000000', 'consum', 0.0226, 'lps'),
	(601777, 127, '2014-04-01 00:47:22.000000', 'consum', 0.0225, 'lps'),
	(601778, 127, '2014-04-01 00:47:23.000000', 'consum', 0.0218, 'lps'),
	(601779, 127, '2014-04-01 00:47:24.000000', 'consum', 0.0228, 'lps'),
	(601780, 127, '2014-04-01 00:47:25.000000', 'consum', 0.0231, 'lps'),
	(601781, 127, '2014-04-01 00:47:26.000000', 'consum', 0.0217, 'lps'),
	(601782, 127, '2014-04-01 00:47:27.000000', 'consum', 0.0226, 'lps'),
	(601783, 127, '2014-04-01 00:47:28.000000', 'consum', 0.0225, 'lps'),
	(601784, 127, '2014-04-01 00:47:29.000000', 'consum', 0.0218, 'lps'),
	(601785, 127, '2014-04-01 00:47:30.000000', 'consum', 0.0225, 'lps'),
	(601786, 127, '2014-04-01 00:47:31.000000', 'consum', 0.0220, 'lps'),
	(601787, 127, '2014-04-01 00:47:32.000000', 'consum', 0.0215, 'lps'),
	(601788, 127, '2014-04-01 00:47:33.000000', 'consum', 0.0229, 'lps'),
	(601789, 127, '2014-04-01 00:47:34.000000', 'consum', 0.0223, 'lps'),
	(601790, 127, '2014-04-01 00:47:35.000000', 'consum', 0.0220, 'lps'),
	(601791, 127, '2014-04-01 00:47:36.000000', 'consum', 0.0222, 'lps'),
	(601792, 127, '2014-04-01 00:47:37.000000', 'consum', 0.0218, 'lps'),
	(601793, 127, '2014-04-01 00:47:38.000000', 'consum', 0.0214, 'lps'),
	(601794, 127, '2014-04-01 00:47:39.000000', 'consum', 0.0229, 'lps'),
	(601795, 127, '2014-04-01 00:47:40.000000', 'consum', 0.0225, 'lps'),
	(601796, 127, '2014-04-01 00:47:41.000000', 'consum', 0.0210, 'lps'),
	(601797, 127, '2014-04-01 00:47:42.000000', 'consum', 0.0230, 'lps'),
	(601798, 127, '2014-04-01 00:47:43.000000', 'consum', 0.0221, 'lps'),
	(601799, 127, '2014-04-01 00:47:44.000000', 'consum', 0.0229, 'lps'),
	(601800, 127, '2014-04-01 00:47:45.000000', 'consum', 0.0227, 'lps'),
	(601801, 127, '2014-04-01 00:47:46.000000', 'consum', 0.0218, 'lps'),
	(601802, 127, '2014-04-01 00:47:47.000000', 'consum', 0.0220, 'lps'),
	(601803, 127, '2014-04-01 00:47:48.000000', 'consum', 0.0215, 'lps'),
	(601804, 127, '2014-04-01 00:47:49.000000', 'consum', 0.0229, 'lps'),
	(601805, 127, '2014-04-01 00:47:50.000000', 'consum', 0.0223, 'lps'),
	(601806, 127, '2014-04-01 00:47:51.000000', 'consum', 0.0220, 'lps'),
	(601807, 127, '2014-04-01 00:47:52.000000', 'consum', 0.0222, 'lps'),
	(601808, 127, '2014-04-01 00:47:53.000000', 'consum', 0.0216, 'lps'),
	(601809, 127, '2014-04-01 00:47:54.000000', 'consum', 0.0228, 'lps'),
	(601810, 127, '2014-04-01 00:47:55.000000', 'consum', 0.0215, 'lps'),
	(601811, 127, '2014-04-01 00:47:56.000000', 'consum', 0.0225, 'lps'),
	(601812, 127, '2014-04-01 00:47:57.000000', 'consum', 0.0228, 'lps'),
	(601813, 127, '2014-04-01 00:47:58.000000', 'consum', 0.0212, 'lps'),
	(601814, 127, '2014-04-01 00:47:59.000000', 'consum', 0.0211, 'lps'),
	(601815, 127, '2014-04-01 00:48:00.000000', 'consum', 0.0210, 'lps'),
	(601816, 127, '2014-04-01 00:48:01.000000', 'consum', 0.0229, 'lps'),
	(601817, 127, '2014-04-01 00:48:02.000000', 'consum', 0.0217, 'lps'),
	(601818, 127, '2014-04-01 00:48:03.000000', 'consum', 0.0231, 'lps'),
	(601819, 127, '2014-04-01 00:48:04.000000', 'consum', 0.0229, 'lps'),
	(601820, 127, '2014-04-01 00:48:05.000000', 'consum', 0.0219, 'lps'),
	(601821, 127, '2014-04-01 00:48:06.000000', 'consum', 0.0222, 'lps'),
	(601822, 127, '2014-04-01 00:48:07.000000', 'consum', 0.0220, 'lps'),
	(601823, 127, '2014-04-01 00:48:08.000000', 'consum', 0.0225, 'lps'),
	(601824, 127, '2014-04-01 00:48:09.000000', 'consum', 0.0210, 'lps'),
	(601825, 127, '2014-04-01 00:48:10.000000', 'consum', 0.0213, 'lps'),
	(601826, 127, '2014-04-01 00:48:11.000000', 'consum', 0.0222, 'lps'),
	(601827, 127, '2014-04-01 00:48:12.000000', 'consum', 0.0220, 'lps'),
	(601828, 127, '2014-04-01 00:48:13.000000', 'consum', 0.0225, 'lps'),
	(601829, 127, '2014-04-01 00:48:14.000000', 'consum', 0.0212, 'lps'),
	(601830, 127, '2014-04-01 00:48:15.000000', 'consum', 0.0217, 'lps'),
	(601831, 127, '2014-04-01 00:48:16.000000', 'consum', 0.0220, 'lps'),
	(601832, 127, '2014-04-01 00:48:17.000000', 'consum', 0.0216, 'lps'),
	(601833, 127, '2014-04-01 00:48:18.000000', 'consum', 0.0210, 'lps'),
	(601834, 127, '2014-04-01 00:48:19.000000', 'consum', 0.0216, 'lps'),
	(601835, 127, '2014-04-01 00:48:20.000000', 'consum', 0.0218, 'lps'),
	(601836, 127, '2014-04-01 00:48:21.000000', 'consum', 0.0212, 'lps'),
	(601837, 127, '2014-04-01 00:48:22.000000', 'consum', 0.0216, 'lps'),
	(601838, 127, '2014-04-01 00:48:23.000000', 'consum', 0.0214, 'lps'),
	(601839, 127, '2014-04-01 00:48:24.000000', 'consum', 0.0213, 'lps'),
	(601840, 127, '2014-04-01 00:48:25.000000', 'consum', 0.0212, 'lps'),
	(601841, 127, '2014-04-01 00:48:26.000000', 'consum', 0.0212, 'lps'),
	(601842, 127, '2014-04-01 00:48:27.000000', 'consum', 0.0217, 'lps'),
	(601843, 127, '2014-04-01 00:48:28.000000', 'consum', 0.0214, 'lps'),
	(601844, 127, '2014-04-01 00:48:29.000000', 'consum', 0.0212, 'lps'),
	(601845, 127, '2014-04-01 00:48:30.000000', 'consum', 0.0230, 'lps'),
	(601846, 127, '2014-04-01 00:48:31.000000', 'consum', 0.0216, 'lps'),
	(601847, 127, '2014-04-01 00:48:32.000000', 'consum', 0.0224, 'lps'),
	(601848, 127, '2014-04-01 00:48:33.000000', 'consum', 0.0219, 'lps'),
	(601849, 127, '2014-04-01 00:48:34.000000', 'consum', 0.0215, 'lps'),
	(601850, 127, '2014-04-01 00:48:35.000000', 'consum', 0.0231, 'lps'),
	(601851, 127, '2014-04-01 00:48:36.000000', 'consum', 0.0212, 'lps'),
	(601852, 127, '2014-04-01 00:48:37.000000', 'consum', 0.0222, 'lps'),
	(601853, 127, '2014-04-01 00:48:38.000000', 'consum', 0.0220, 'lps'),
	(601854, 127, '2014-04-01 00:48:39.000000', 'consum', 0.0226, 'lps'),
	(601855, 127, '2014-04-01 00:48:40.000000', 'consum', 0.0217, 'lps'),
	(601856, 127, '2014-04-01 00:48:41.000000', 'consum', 0.0219, 'lps'),
	(601857, 127, '2014-04-01 00:48:42.000000', 'consum', 0.0212, 'lps'),
	(601858, 127, '2014-04-01 00:48:43.000000', 'consum', 0.0215, 'lps'),
	(601859, 127, '2014-04-01 00:48:44.000000', 'consum', 0.0231, 'lps'),
	(601860, 127, '2014-04-01 00:48:45.000000', 'consum', 0.0210, 'lps'),
	(601861, 127, '2014-04-01 00:48:46.000000', 'consum', 0.0215, 'lps'),
	(601862, 127, '2014-04-01 00:48:47.000000', 'consum', 0.0213, 'lps'),
	(601863, 127, '2014-04-01 00:48:48.000000', 'consum', 0.0231, 'lps'),
	(601864, 127, '2014-04-01 00:48:49.000000', 'consum', 0.0220, 'lps'),
	(601865, 127, '2014-04-01 00:48:50.000000', 'consum', 0.0221, 'lps'),
	(601866, 127, '2014-04-01 00:48:51.000000', 'consum', 0.0212, 'lps'),
	(601867, 127, '2014-04-01 00:48:52.000000', 'consum', 0.0212, 'lps'),
	(601868, 127, '2014-04-01 00:48:53.000000', 'consum', 0.0212, 'lps'),
	(601869, 127, '2014-04-01 00:48:54.000000', 'consum', 0.0216, 'lps'),
	(601870, 127, '2014-04-01 00:48:55.000000', 'consum', 0.0213, 'lps'),
	(601871, 127, '2014-04-01 00:48:56.000000', 'consum', 0.0228, 'lps'),
	(601872, 127, '2014-04-01 00:48:57.000000', 'consum', 0.0227, 'lps'),
	(601873, 127, '2014-04-01 00:48:58.000000', 'consum', 0.0218, 'lps'),
	(601874, 127, '2014-04-01 00:48:59.000000', 'consum', 0.0223, 'lps'),
	(601875, 127, '2014-04-01 00:49:00.000000', 'consum', 0.0230, 'lps'),
	(601876, 127, '2014-04-01 00:49:01.000000', 'consum', 0.0225, 'lps'),
	(601877, 127, '2014-04-01 00:49:02.000000', 'consum', 0.0228, 'lps'),
	(601878, 127, '2014-04-01 00:49:03.000000', 'consum', 0.0212, 'lps'),
	(601879, 127, '2014-04-01 00:49:04.000000', 'consum', 0.0230, 'lps'),
	(601880, 127, '2014-04-01 00:49:05.000000', 'consum', 0.0217, 'lps'),
	(601881, 127, '2014-04-01 00:49:06.000000', 'consum', 0.0229, 'lps'),
	(601882, 127, '2014-04-01 00:49:07.000000', 'consum', 0.0220, 'lps'),
	(601883, 127, '2014-04-01 00:49:08.000000', 'consum', 0.0225, 'lps'),
	(601884, 127, '2014-04-01 00:49:09.000000', 'consum', 0.0211, 'lps'),
	(601885, 127, '2014-04-01 00:49:10.000000', 'consum', 0.0216, 'lps'),
	(601886, 127, '2014-04-01 00:49:11.000000', 'consum', 0.0215, 'lps'),
	(601887, 127, '2014-04-01 00:49:12.000000', 'consum', 0.0217, 'lps'),
	(601888, 127, '2014-04-01 00:49:13.000000', 'consum', 0.0210, 'lps'),
	(601889, 127, '2014-04-01 00:49:14.000000', 'consum', 0.0213, 'lps'),
	(601890, 127, '2014-04-01 00:49:15.000000', 'consum', 0.0222, 'lps'),
	(601891, 127, '2014-04-01 00:49:16.000000', 'consum', 0.0220, 'lps'),
	(601892, 127, '2014-04-01 00:49:17.000000', 'consum', 0.0223, 'lps'),
	(601893, 127, '2014-04-01 00:49:18.000000', 'consum', 0.0223, 'lps'),
	(601894, 127, '2014-04-01 00:49:19.000000', 'consum', 0.0216, 'lps'),
	(601895, 127, '2014-04-01 00:49:20.000000', 'consum', 0.0221, 'lps'),
	(601896, 127, '2014-04-01 00:49:21.000000', 'consum', 0.0228, 'lps'),
	(601897, 127, '2014-04-01 00:49:22.000000', 'consum', 0.0223, 'lps'),
	(601898, 127, '2014-04-01 00:49:23.000000', 'consum', 0.0221, 'lps'),
	(601899, 127, '2014-04-01 00:49:24.000000', 'consum', 0.0228, 'lps'),
	(601900, 127, '2014-04-01 00:49:25.000000', 'consum', 0.0222, 'lps'),
	(601901, 127, '2014-04-01 00:49:26.000000', 'consum', 0.0219, 'lps'),
	(601902, 127, '2014-04-01 00:49:27.000000', 'consum', 0.0216, 'lps'),
	(601903, 127, '2014-04-01 00:49:28.000000', 'consum', 0.0215, 'lps'),
	(601904, 127, '2014-04-01 00:49:29.000000', 'consum', 0.0218, 'lps'),
	(601905, 127, '2014-04-01 00:49:30.000000', 'consum', 0.0214, 'lps'),
	(601906, 127, '2014-04-01 00:49:31.000000', 'consum', 0.0228, 'lps'),
	(601907, 127, '2014-04-01 00:49:32.000000', 'consum', 0.0222, 'lps'),
	(601908, 127, '2014-04-01 00:49:33.000000', 'consum', 0.0218, 'lps'),
	(601909, 127, '2014-04-01 00:49:34.000000', 'consum', 0.0213, 'lps'),
	(601910, 127, '2014-04-01 00:49:35.000000', 'consum', 0.0223, 'lps'),
	(601911, 127, '2014-04-01 00:49:36.000000', 'consum', 0.0222, 'lps'),
	(601912, 127, '2014-04-01 00:49:37.000000', 'consum', 0.0210, 'lps'),
	(601913, 127, '2014-04-01 00:49:38.000000', 'consum', 0.0220, 'lps'),
	(601914, 127, '2014-04-01 00:49:39.000000', 'consum', 0.0216, 'lps'),
	(601915, 127, '2014-04-01 00:49:40.000000', 'consum', 0.0231, 'lps'),
	(601916, 127, '2014-04-01 00:49:41.000000', 'consum', 0.0211, 'lps'),
	(601917, 127, '2014-04-01 00:49:42.000000', 'consum', 0.0216, 'lps'),
	(601918, 127, '2014-04-01 00:49:43.000000', 'consum', 0.0217, 'lps'),
	(601919, 127, '2014-04-01 00:49:44.000000', 'consum', 0.0226, 'lps'),
	(601920, 127, '2014-04-01 00:49:45.000000', 'consum', 0.0228, 'lps'),
	(601921, 127, '2014-04-01 00:49:46.000000', 'consum', 0.0230, 'lps'),
	(601922, 127, '2014-04-01 00:49:47.000000', 'consum', 0.0211, 'lps'),
	(601923, 127, '2014-04-01 00:49:48.000000', 'consum', 0.0220, 'lps'),
	(601924, 127, '2014-04-01 00:49:49.000000', 'consum', 0.0216, 'lps'),
	(601925, 127, '2014-04-01 00:49:50.000000', 'consum', 0.0211, 'lps'),
	(601926, 127, '2014-04-01 00:49:51.000000', 'consum', 0.0218, 'lps'),
	(601927, 127, '2014-04-01 00:49:52.000000', 'consum', 0.0227, 'lps'),
	(601928, 127, '2014-04-01 00:49:53.000000', 'consum', 0.0225, 'lps'),
	(601929, 127, '2014-04-01 00:49:54.000000', 'consum', 0.0215, 'lps'),
	(601930, 127, '2014-04-01 00:49:55.000000', 'consum', 0.0213, 'lps'),
	(601931, 127, '2014-04-01 00:49:56.000000', 'consum', 0.0231, 'lps'),
	(601932, 127, '2014-04-01 00:49:57.000000', 'consum', 0.0220, 'lps'),
	(601933, 127, '2014-04-01 00:49:58.000000', 'consum', 0.0218, 'lps'),
	(601934, 127, '2014-04-01 00:49:59.000000', 'consum', 0.0221, 'lps'),
	(601935, 127, '2014-04-01 00:50:00.000000', 'consum', 0.0221, 'lps'),
	(601936, 127, '2014-04-01 00:50:01.000000', 'consum', 0.0231, 'lps'),
	(601937, 127, '2014-04-01 00:50:02.000000', 'consum', 0.0218, 'lps'),
	(601938, 127, '2014-04-01 00:50:03.000000', 'consum', 0.0210, 'lps'),
	(601939, 127, '2014-04-01 00:50:04.000000', 'consum', 0.0229, 'lps'),
	(601940, 127, '2014-04-01 00:50:05.000000', 'consum', 0.0218, 'lps'),
	(601941, 127, '2014-04-01 00:50:06.000000', 'consum', 0.0214, 'lps'),
	(601942, 127, '2014-04-01 00:50:07.000000', 'consum', 0.0227, 'lps'),
	(601943, 127, '2014-04-01 00:50:08.000000', 'consum', 0.0221, 'lps'),
	(601944, 127, '2014-04-01 00:50:09.000000', 'consum', 0.0214, 'lps'),
	(601945, 127, '2014-04-01 00:50:10.000000', 'consum', 0.0218, 'lps'),
	(601946, 127, '2014-04-01 00:50:11.000000', 'consum', 0.0218, 'lps'),
	(601947, 127, '2014-04-01 00:50:12.000000', 'consum', 0.0228, 'lps'),
	(601948, 127, '2014-04-01 00:50:13.000000', 'consum', 0.0231, 'lps'),
	(601949, 127, '2014-04-01 00:50:14.000000', 'consum', 0.0217, 'lps'),
	(601950, 127, '2014-04-01 00:50:15.000000', 'consum', 0.0228, 'lps'),
	(601951, 127, '2014-04-01 00:50:16.000000', 'consum', 0.0214, 'lps'),
	(601952, 127, '2014-04-01 00:50:17.000000', 'consum', 0.0219, 'lps'),
	(601953, 127, '2014-04-01 00:50:18.000000', 'consum', 0.0224, 'lps'),
	(601954, 127, '2014-04-01 00:50:19.000000', 'consum', 0.0228, 'lps'),
	(601955, 127, '2014-04-01 00:50:20.000000', 'consum', 0.0217, 'lps'),
	(601956, 127, '2014-04-01 00:50:21.000000', 'consum', 0.0213, 'lps'),
	(601957, 127, '2014-04-01 00:50:22.000000', 'consum', 0.0227, 'lps'),
	(601958, 127, '2014-04-01 00:50:23.000000', 'consum', 0.0219, 'lps'),
	(601959, 127, '2014-04-01 00:50:24.000000', 'consum', 0.0228, 'lps'),
	(601960, 127, '2014-04-01 00:50:25.000000', 'consum', 0.0227, 'lps'),
	(601961, 127, '2014-04-01 00:50:26.000000', 'consum', 0.0222, 'lps'),
	(601962, 127, '2014-04-01 00:50:27.000000', 'consum', 0.0220, 'lps'),
	(601963, 127, '2014-04-01 00:50:28.000000', 'consum', 0.0224, 'lps'),
	(601964, 127, '2014-04-01 00:50:29.000000', 'consum', 0.0227, 'lps'),
	(601965, 127, '2014-04-01 00:50:30.000000', 'consum', 0.0230, 'lps'),
	(601966, 127, '2014-04-01 00:50:31.000000', 'consum', 0.0219, 'lps'),
	(601967, 127, '2014-04-01 00:50:32.000000', 'consum', 0.0217, 'lps'),
	(601968, 127, '2014-04-01 00:50:33.000000', 'consum', 0.0218, 'lps'),
	(601969, 127, '2014-04-01 00:50:34.000000', 'consum', 0.0227, 'lps'),
	(601970, 127, '2014-04-01 00:50:35.000000', 'consum', 0.0231, 'lps'),
	(601971, 127, '2014-04-01 00:50:36.000000', 'consum', 0.0218, 'lps'),
	(601972, 127, '2014-04-01 00:50:37.000000', 'consum', 0.0210, 'lps'),
	(601973, 127, '2014-04-01 00:50:38.000000', 'consum', 0.0229, 'lps'),
	(601974, 127, '2014-04-01 00:50:39.000000', 'consum', 0.0221, 'lps'),
	(601975, 127, '2014-04-01 00:50:40.000000', 'consum', 0.0227, 'lps'),
	(601976, 127, '2014-04-01 00:50:41.000000', 'consum', 0.0221, 'lps'),
	(601977, 127, '2014-04-01 00:50:42.000000', 'consum', 0.0214, 'lps'),
	(601978, 127, '2014-04-01 00:50:43.000000', 'consum', 0.0221, 'lps'),
	(601979, 127, '2014-04-01 00:50:44.000000', 'consum', 0.0231, 'lps'),
	(601980, 127, '2014-04-01 00:50:45.000000', 'consum', 0.0217, 'lps'),
	(601981, 127, '2014-04-01 00:50:46.000000', 'consum', 0.0226, 'lps'),
	(601982, 127, '2014-04-01 00:50:47.000000', 'consum', 0.0227, 'lps'),
	(601983, 127, '2014-04-01 00:50:48.000000', 'consum', 0.0224, 'lps'),
	(601984, 127, '2014-04-01 00:50:49.000000', 'consum', 0.0230, 'lps'),
	(601985, 127, '2014-04-01 00:50:50.000000', 'consum', 0.0224, 'lps'),
	(601986, 127, '2014-04-01 00:50:51.000000', 'consum', 0.0221, 'lps'),
	(601987, 127, '2014-04-01 00:50:52.000000', 'consum', 0.0222, 'lps'),
	(601988, 127, '2014-04-01 00:50:53.000000', 'consum', 0.0214, 'lps'),
	(601989, 127, '2014-04-01 00:50:54.000000', 'consum', 0.0220, 'lps'),
	(601990, 127, '2014-04-01 00:50:55.000000', 'consum', 0.0223, 'lps'),
	(601991, 127, '2014-04-01 00:50:56.000000', 'consum', 0.0226, 'lps'),
	(601992, 127, '2014-04-01 00:50:57.000000', 'consum', 0.0227, 'lps'),
	(601993, 127, '2014-04-01 00:50:58.000000', 'consum', 0.0228, 'lps'),
	(601994, 127, '2014-04-01 00:50:59.000000', 'consum', 0.0228, 'lps'),
	(601995, 127, '2014-04-01 00:51:00.000000', 'consum', 0.0223, 'lps'),
	(601996, 127, '2014-04-01 00:51:01.000000', 'consum', 0.0220, 'lps'),
	(601997, 127, '2014-04-01 00:51:02.000000', 'consum', 0.0223, 'lps'),
	(601998, 127, '2014-04-01 00:51:03.000000', 'consum', 0.0223, 'lps'),
	(601999, 127, '2014-04-01 00:51:04.000000', 'consum', 0.0216, 'lps'),
	(602000, 127, '2014-04-01 00:51:05.000000', 'consum', 0.0225, 'lps'),
	(602001, 127, '2014-04-01 00:51:06.000000', 'consum', 0.0221, 'lps'),
	(602002, 127, '2014-04-01 00:51:07.000000', 'consum', 0.0219, 'lps'),
	(602003, 127, '2014-04-01 00:51:08.000000', 'consum', 0.0225, 'lps'),
	(602004, 127, '2014-04-01 00:51:09.000000', 'consum', 0.0216, 'lps'),
	(602005, 127, '2014-04-01 00:51:10.000000', 'consum', 0.0214, 'lps'),
	(602006, 127, '2014-04-01 00:51:11.000000', 'consum', 0.0213, 'lps'),
	(602007, 127, '2014-04-01 00:51:12.000000', 'consum', 0.0215, 'lps'),
	(602008, 127, '2014-04-01 00:51:13.000000', 'consum', 0.0226, 'lps'),
	(602009, 127, '2014-04-01 00:51:14.000000', 'consum', 0.0210, 'lps'),
	(602010, 127, '2014-04-01 00:51:15.000000', 'consum', 0.0226, 'lps'),
	(602011, 127, '2014-04-01 00:51:16.000000', 'consum', 0.0227, 'lps'),
	(602012, 127, '2014-04-01 00:51:17.000000', 'consum', 0.0224, 'lps'),
	(602013, 127, '2014-04-01 00:51:18.000000', 'consum', 0.0230, 'lps'),
	(602014, 127, '2014-04-01 00:51:19.000000', 'consum', 0.0225, 'lps'),
	(602015, 127, '2014-04-01 00:51:20.000000', 'consum', 0.0227, 'lps'),
	(602016, 127, '2014-04-01 00:51:21.000000', 'consum', 0.0225, 'lps'),
	(602017, 127, '2014-04-01 00:51:22.000000', 'consum', 0.0215, 'lps'),
	(602018, 127, '2014-04-01 00:51:23.000000', 'consum', 0.0211, 'lps'),
	(602019, 127, '2014-04-01 00:51:24.000000', 'consum', 0.0225, 'lps'),
	(602020, 127, '2014-04-01 00:51:25.000000', 'consum', 0.0215, 'lps'),
	(602021, 127, '2014-04-01 00:51:26.000000', 'consum', 0.0213, 'lps'),
	(602022, 127, '2014-04-01 00:51:27.000000', 'consum', 0.0212, 'lps'),
	(602023, 127, '2014-04-01 00:51:28.000000', 'consum', 0.0210, 'lps'),
	(602024, 127, '2014-04-01 00:51:29.000000', 'consum', 0.0225, 'lps'),
	(602025, 127, '2014-04-01 00:51:30.000000', 'consum', 0.0219, 'lps'),
	(602026, 127, '2014-04-01 00:51:31.000000', 'consum', 0.0211, 'lps'),
	(602027, 127, '2014-04-01 00:51:32.000000', 'consum', 0.0211, 'lps'),
	(602028, 127, '2014-04-01 00:51:33.000000', 'consum', 0.0213, 'lps'),
	(602029, 127, '2014-04-01 00:51:34.000000', 'consum', 0.0221, 'lps'),
	(602030, 127, '2014-04-01 00:51:35.000000', 'consum', 0.0215, 'lps'),
	(602031, 127, '2014-04-01 00:51:36.000000', 'consum', 0.0225, 'lps'),
	(602032, 127, '2014-04-01 00:51:37.000000', 'consum', 0.0225, 'lps'),
	(602033, 127, '2014-04-01 00:51:38.000000', 'consum', 0.0218, 'lps'),
	(602034, 127, '2014-04-01 00:51:39.000000', 'consum', 0.0227, 'lps'),
	(602035, 127, '2014-04-01 00:51:40.000000', 'consum', 0.0227, 'lps'),
	(602036, 127, '2014-04-01 00:51:41.000000', 'consum', 0.0224, 'lps'),
	(602037, 127, '2014-04-01 00:51:42.000000', 'consum', 0.0228, 'lps'),
	(602038, 127, '2014-04-01 00:51:43.000000', 'consum', 0.0216, 'lps'),
	(602039, 127, '2014-04-01 00:51:44.000000', 'consum', 0.0230, 'lps'),
	(602040, 127, '2014-04-01 00:51:45.000000', 'consum', 0.0225, 'lps'),
	(602041, 127, '2014-04-01 00:51:46.000000', 'consum', 0.0225, 'lps'),
	(602042, 127, '2014-04-01 00:51:47.000000', 'consum', 0.0219, 'lps'),
	(602043, 127, '2014-04-01 00:51:48.000000', 'consum', 0.0211, 'lps'),
	(602044, 127, '2014-04-01 00:51:49.000000', 'consum', 0.0210, 'lps'),
	(602045, 127, '2014-04-01 00:51:50.000000', 'consum', 0.0228, 'lps'),
	(602046, 127, '2014-04-01 00:51:51.000000', 'consum', 0.0214, 'lps'),
	(602047, 127, '2014-04-01 00:51:52.000000', 'consum', 0.0219, 'lps'),
	(602048, 127, '2014-04-01 00:51:53.000000', 'consum', 0.0224, 'lps'),
	(602049, 127, '2014-04-01 00:51:54.000000', 'consum', 0.0231, 'lps'),
	(602050, 127, '2014-04-01 00:51:55.000000', 'consum', 0.0228, 'lps'),
	(602051, 127, '2014-04-01 00:51:56.000000', 'consum', 0.0215, 'lps'),
	(602052, 127, '2014-04-01 00:51:57.000000', 'consum', 0.0228, 'lps'),
	(602053, 127, '2014-04-01 00:51:58.000000', 'consum', 0.0219, 'lps'),
	(602054, 127, '2014-04-01 00:51:59.000000', 'consum', 0.0224, 'lps'),
	(602055, 127, '2014-04-01 00:52:00.000000', 'consum', 0.0231, 'lps'),
	(602056, 127, '2014-04-01 00:52:01.000000', 'consum', 0.0228, 'lps'),
	(602057, 127, '2014-04-01 00:52:02.000000', 'consum', 0.0217, 'lps'),
	(602058, 127, '2014-04-01 00:52:03.000000', 'consum', 0.0214, 'lps'),
	(602059, 127, '2014-04-01 00:52:04.000000', 'consum', 0.0210, 'lps'),
	(602060, 127, '2014-04-01 00:52:05.000000', 'consum', 0.0222, 'lps'),
	(602061, 127, '2014-04-01 00:52:06.000000', 'consum', 0.0223, 'lps'),
	(602062, 127, '2014-04-01 00:52:07.000000', 'consum', 0.0220, 'lps'),
	(602063, 127, '2014-04-01 00:52:08.000000', 'consum', 0.0219, 'lps'),
	(602064, 127, '2014-04-01 00:52:09.000000', 'consum', 0.0228, 'lps'),
	(602065, 127, '2014-04-01 00:52:10.000000', 'consum', 0.0227, 'lps'),
	(602066, 127, '2014-04-01 00:52:11.000000', 'consum', 0.0222, 'lps'),
	(602067, 127, '2014-04-01 00:52:12.000000', 'consum', 0.0217, 'lps'),
	(602068, 127, '2014-04-01 00:52:13.000000', 'consum', 0.0210, 'lps'),
	(602069, 127, '2014-04-01 00:52:14.000000', 'consum', 0.0212, 'lps'),
	(602070, 127, '2014-04-01 00:52:15.000000', 'consum', 0.0220, 'lps'),
	(602071, 127, '2014-04-01 00:52:16.000000', 'consum', 0.0211, 'lps'),
	(602072, 127, '2014-04-01 00:52:17.000000', 'consum', 0.0231, 'lps'),
	(602073, 127, '2014-04-01 00:52:18.000000', 'consum', 0.0222, 'lps'),
	(602074, 127, '2014-04-01 00:52:19.000000', 'consum', 0.0210, 'lps'),
	(602075, 127, '2014-04-01 00:52:20.000000', 'consum', 0.0217, 'lps'),
	(602076, 127, '2014-04-01 00:52:21.000000', 'consum', 0.0223, 'lps'),
	(602077, 127, '2014-04-01 00:52:22.000000', 'consum', 0.0210, 'lps'),
	(602078, 127, '2014-04-01 00:52:23.000000', 'consum', 0.0216, 'lps'),
	(602079, 127, '2014-04-01 00:52:24.000000', 'consum', 0.0220, 'lps'),
	(602080, 127, '2014-04-01 00:52:25.000000', 'consum', 0.0219, 'lps'),
	(602081, 127, '2014-04-01 00:52:26.000000', 'consum', 0.0225, 'lps'),
	(602082, 127, '2014-04-01 00:52:27.000000', 'consum', 0.0213, 'lps'),
	(602083, 127, '2014-04-01 00:52:28.000000', 'consum', 0.0228, 'lps'),
	(602084, 127, '2014-04-01 00:52:29.000000', 'consum', 0.0222, 'lps'),
	(602085, 127, '2014-04-01 00:52:30.000000', 'consum', 0.0218, 'lps'),
	(602086, 127, '2014-04-01 00:52:31.000000', 'consum', 0.0215, 'lps'),
	(602087, 127, '2014-04-01 00:52:32.000000', 'consum', 0.0210, 'lps'),
	(602088, 127, '2014-04-01 00:52:33.000000', 'consum', 0.0217, 'lps'),
	(602089, 127, '2014-04-01 00:52:34.000000', 'consum', 0.0224, 'lps'),
	(602090, 127, '2014-04-01 00:52:35.000000', 'consum', 0.0216, 'lps'),
	(602091, 127, '2014-04-01 00:52:36.000000', 'consum', 0.0220, 'lps'),
	(602092, 127, '2014-04-01 00:52:37.000000', 'consum', 0.0220, 'lps'),
	(602093, 127, '2014-04-01 00:52:38.000000', 'consum', 0.0230, 'lps'),
	(602094, 127, '2014-04-01 00:52:39.000000', 'consum', 0.0215, 'lps'),
	(602095, 127, '2014-04-01 00:52:40.000000', 'consum', 0.0221, 'lps'),
	(602096, 127, '2014-04-01 00:52:41.000000', 'consum', 0.0226, 'lps'),
	(602097, 127, '2014-04-01 00:52:42.000000', 'consum', 0.0213, 'lps'),
	(602098, 127, '2014-04-01 00:52:43.000000', 'consum', 0.0222, 'lps'),
	(602099, 127, '2014-04-01 00:52:44.000000', 'consum', 0.0219, 'lps'),
	(602100, 127, '2014-04-01 00:52:45.000000', 'consum', 0.0219, 'lps'),
	(602101, 127, '2014-04-01 00:52:46.000000', 'consum', 0.0226, 'lps'),
	(602102, 127, '2014-04-01 00:52:47.000000', 'consum', 0.0223, 'lps'),
	(602103, 127, '2014-04-01 00:52:48.000000', 'consum', 0.0225, 'lps'),
	(602104, 127, '2014-04-01 00:52:49.000000', 'consum', 0.0224, 'lps'),
	(602105, 127, '2014-04-01 00:52:50.000000', 'consum', 0.0213, 'lps'),
	(602106, 127, '2014-04-01 00:52:51.000000', 'consum', 0.0228, 'lps'),
	(602107, 127, '2014-04-01 00:52:52.000000', 'consum', 0.0226, 'lps'),
	(602108, 127, '2014-04-01 00:52:53.000000', 'consum', 0.0214, 'lps'),
	(602109, 127, '2014-04-01 00:52:54.000000', 'consum', 0.0227, 'lps'),
	(602110, 127, '2014-04-01 00:52:55.000000', 'consum', 0.0218, 'lps'),
	(602111, 127, '2014-04-01 00:52:56.000000', 'consum', 0.0222, 'lps'),
	(602112, 127, '2014-04-01 00:52:57.000000', 'consum', 0.0225, 'lps'),
	(602113, 127, '2014-04-01 00:52:58.000000', 'consum', 0.0226, 'lps'),
	(602114, 127, '2014-04-01 00:52:59.000000', 'consum', 0.0226, 'lps'),
	(602115, 127, '2014-04-01 00:53:00.000000', 'consum', 0.0219, 'lps'),
	(602116, 127, '2014-04-01 00:53:01.000000', 'consum', 0.0228, 'lps'),
	(602117, 127, '2014-04-01 00:53:02.000000', 'consum', 0.0229, 'lps'),
	(602118, 127, '2014-04-01 00:53:03.000000', 'consum', 0.0210, 'lps'),
	(602119, 127, '2014-04-01 00:53:04.000000', 'consum', 0.0217, 'lps'),
	(602120, 127, '2014-04-01 00:53:05.000000', 'consum', 0.0226, 'lps'),
	(602121, 127, '2014-04-01 00:53:06.000000', 'consum', 0.0224, 'lps'),
	(602122, 127, '2014-04-01 00:53:07.000000', 'consum', 0.0210, 'lps'),
	(602123, 127, '2014-04-01 00:53:08.000000', 'consum', 0.0213, 'lps'),
	(602124, 127, '2014-04-01 00:53:09.000000', 'consum', 0.0226, 'lps'),
	(602125, 127, '2014-04-01 00:53:10.000000', 'consum', 0.0217, 'lps'),
	(602126, 127, '2014-04-01 00:53:11.000000', 'consum', 0.0219, 'lps'),
	(602127, 127, '2014-04-01 00:53:12.000000', 'consum', 0.0210, 'lps'),
	(602128, 127, '2014-04-01 00:53:13.000000', 'consum', 0.0229, 'lps'),
	(602129, 127, '2014-04-01 00:53:14.000000', 'consum', 0.0219, 'lps'),
	(602130, 127, '2014-04-01 00:53:15.000000', 'consum', 0.0217, 'lps'),
	(602131, 127, '2014-04-01 00:53:16.000000', 'consum', 0.0222, 'lps'),
	(602132, 127, '2014-04-01 00:53:17.000000', 'consum', 0.0227, 'lps'),
	(602133, 127, '2014-04-01 00:53:18.000000', 'consum', 0.0217, 'lps'),
	(602134, 127, '2014-04-01 00:53:19.000000', 'consum', 0.0213, 'lps'),
	(602135, 127, '2014-04-01 00:53:20.000000', 'consum', 0.0230, 'lps'),
	(602136, 127, '2014-04-01 00:53:21.000000', 'consum', 0.0212, 'lps'),
	(602137, 127, '2014-04-01 00:53:22.000000', 'consum', 0.0226, 'lps'),
	(602138, 127, '2014-04-01 00:53:23.000000', 'consum', 0.0219, 'lps'),
	(602139, 127, '2014-04-01 00:53:24.000000', 'consum', 0.0228, 'lps'),
	(602140, 127, '2014-04-01 00:53:25.000000', 'consum', 0.0231, 'lps'),
	(602141, 127, '2014-04-01 00:53:26.000000', 'consum', 0.0219, 'lps'),
	(602142, 127, '2014-04-01 00:53:27.000000', 'consum', 0.0213, 'lps'),
	(602143, 127, '2014-04-01 00:53:28.000000', 'consum', 0.0219, 'lps'),
	(602144, 127, '2014-04-01 00:53:29.000000', 'consum', 0.0227, 'lps'),
	(602145, 127, '2014-04-01 00:53:30.000000', 'consum', 0.0222, 'lps'),
	(602146, 127, '2014-04-01 00:53:31.000000', 'consum', 0.0220, 'lps'),
	(602147, 127, '2014-04-01 00:53:32.000000', 'consum', 0.0226, 'lps'),
	(602148, 127, '2014-04-01 00:53:33.000000', 'consum', 0.0216, 'lps'),
	(602149, 127, '2014-04-01 00:53:34.000000', 'consum', 0.0212, 'lps'),
	(602150, 127, '2014-04-01 00:53:35.000000', 'consum', 0.0228, 'lps'),
	(602151, 127, '2014-04-01 00:53:36.000000', 'consum', 0.0226, 'lps'),
	(602152, 127, '2014-04-01 00:53:37.000000', 'consum', 0.0217, 'lps'),
	(602153, 127, '2014-04-01 00:53:38.000000', 'consum', 0.0219, 'lps'),
	(602154, 127, '2014-04-01 00:53:39.000000', 'consum', 0.0213, 'lps'),
	(602155, 127, '2014-04-01 00:53:40.000000', 'consum', 0.0218, 'lps'),
	(602156, 127, '2014-04-01 00:53:41.000000', 'consum', 0.0222, 'lps'),
	(602157, 127, '2014-04-01 00:53:42.000000', 'consum', 0.0225, 'lps'),
	(602158, 127, '2014-04-01 00:53:43.000000', 'consum', 0.0228, 'lps'),
	(602159, 127, '2014-04-01 00:53:44.000000', 'consum', 0.0212, 'lps'),
	(602160, 127, '2014-04-01 00:53:45.000000', 'consum', 0.0230, 'lps'),
	(602161, 127, '2014-04-01 00:53:46.000000', 'consum', 0.0219, 'lps'),
	(602162, 127, '2014-04-01 00:53:47.000000', 'consum', 0.0216, 'lps'),
	(602163, 127, '2014-04-01 00:53:48.000000', 'consum', 0.0215, 'lps'),
	(602164, 127, '2014-04-01 00:53:49.000000', 'consum', 0.0216, 'lps'),
	(602165, 127, '2014-04-01 00:53:50.000000', 'consum', 0.0226, 'lps'),
	(602166, 127, '2014-04-01 00:53:51.000000', 'consum', 0.0230, 'lps'),
	(602167, 127, '2014-04-01 00:53:52.000000', 'consum', 0.0216, 'lps'),
	(602168, 127, '2014-04-01 00:53:53.000000', 'consum', 0.0224, 'lps'),
	(602169, 127, '2014-04-01 00:53:54.000000', 'consum', 0.0218, 'lps'),
	(602170, 127, '2014-04-01 00:53:55.000000', 'consum', 0.0210, 'lps'),
	(602171, 127, '2014-04-01 00:53:56.000000', 'consum', 0.0228, 'lps'),
	(602172, 127, '2014-04-01 00:53:57.000000', 'consum', 0.0215, 'lps'),
	(602173, 127, '2014-04-01 00:53:58.000000', 'consum', 0.0223, 'lps'),
	(602174, 127, '2014-04-01 00:53:59.000000', 'consum', 0.0219, 'lps'),
	(602175, 127, '2014-04-01 00:54:00.000000', 'consum', 0.0216, 'lps'),
	(602176, 127, '2014-04-01 00:54:01.000000', 'consum', 0.0212, 'lps'),
	(602177, 127, '2014-04-01 00:54:02.000000', 'consum', 0.0226, 'lps'),
	(602178, 127, '2014-04-01 00:54:03.000000', 'consum', 0.0220, 'lps'),
	(602179, 127, '2014-04-01 00:54:04.000000', 'consum', 0.0210, 'lps'),
	(602180, 127, '2014-04-01 00:54:05.000000', 'consum', 0.0226, 'lps'),
	(602181, 127, '2014-04-01 00:54:06.000000', 'consum', 0.0224, 'lps'),
	(602182, 127, '2014-04-01 00:54:07.000000', 'consum', 0.0212, 'lps'),
	(602183, 127, '2014-04-01 00:54:08.000000', 'consum', 0.0223, 'lps'),
	(602184, 127, '2014-04-01 00:54:09.000000', 'consum', 0.0223, 'lps'),
	(602185, 127, '2014-04-01 00:54:10.000000', 'consum', 0.0214, 'lps'),
	(602186, 127, '2014-04-01 00:54:11.000000', 'consum', 0.0214, 'lps'),
	(602187, 127, '2014-04-01 00:54:12.000000', 'consum', 0.0219, 'lps'),
	(602188, 127, '2014-04-01 00:54:13.000000', 'consum', 0.0222, 'lps'),
	(602189, 127, '2014-04-01 00:54:14.000000', 'consum', 0.0223, 'lps'),
	(602190, 127, '2014-04-01 00:54:15.000000', 'consum', 0.0214, 'lps'),
	(602191, 127, '2014-04-01 00:54:16.000000', 'consum', 0.0217, 'lps'),
	(602192, 127, '2014-04-01 00:54:17.000000', 'consum', 0.0230, 'lps'),
	(602193, 127, '2014-04-01 00:54:18.000000', 'consum', 0.0226, 'lps'),
	(602194, 127, '2014-04-01 00:54:19.000000', 'consum', 0.0228, 'lps'),
	(602195, 127, '2014-04-01 00:54:20.000000', 'consum', 0.0211, 'lps'),
	(602196, 127, '2014-04-01 00:54:21.000000', 'consum', 0.0227, 'lps'),
	(602197, 127, '2014-04-01 00:54:22.000000', 'consum', 0.0224, 'lps'),
	(602198, 127, '2014-04-01 00:54:23.000000', 'consum', 0.0210, 'lps'),
	(602199, 127, '2014-04-01 00:54:24.000000', 'consum', 0.0213, 'lps'),
	(602200, 127, '2014-04-01 00:54:25.000000', 'consum', 0.0227, 'lps'),
	(602201, 127, '2014-04-01 00:54:26.000000', 'consum', 0.0217, 'lps'),
	(602202, 127, '2014-04-01 00:54:27.000000', 'consum', 0.0218, 'lps'),
	(602203, 127, '2014-04-01 00:54:28.000000', 'consum', 0.0229, 'lps'),
	(602204, 127, '2014-04-01 00:54:29.000000', 'consum', 0.0216, 'lps'),
	(602205, 127, '2014-04-01 00:54:30.000000', 'consum', 0.0226, 'lps'),
	(602206, 127, '2014-04-01 00:54:31.000000', 'consum', 0.0229, 'lps'),
	(602207, 127, '2014-04-01 00:54:32.000000', 'consum', 0.0212, 'lps'),
	(602208, 127, '2014-04-01 00:54:33.000000', 'consum', 0.0211, 'lps'),
	(602209, 127, '2014-04-01 00:54:34.000000', 'consum', 0.0228, 'lps'),
	(602210, 127, '2014-04-01 00:54:35.000000', 'consum', 0.0212, 'lps'),
	(602211, 127, '2014-04-01 00:54:36.000000', 'consum', 0.0230, 'lps'),
	(602212, 127, '2014-04-01 00:54:37.000000', 'consum', 0.0216, 'lps'),
	(602213, 127, '2014-04-01 00:54:38.000000', 'consum', 0.0225, 'lps'),
	(602214, 127, '2014-04-01 00:54:39.000000', 'consum', 0.0223, 'lps'),
	(602215, 127, '2014-04-01 00:54:40.000000', 'consum', 0.0231, 'lps'),
	(602216, 127, '2014-04-01 00:54:41.000000', 'consum', 0.0210, 'lps'),
	(602217, 127, '2014-04-01 00:54:42.000000', 'consum', 0.0214, 'lps'),
	(602218, 127, '2014-04-01 00:54:43.000000', 'consum', 0.0210, 'lps'),
	(602219, 127, '2014-04-01 00:54:44.000000', 'consum', 0.0220, 'lps'),
	(602220, 127, '2014-04-01 00:54:45.000000', 'consum', 0.0216, 'lps'),
	(602221, 127, '2014-04-01 00:54:46.000000', 'consum', 0.0212, 'lps'),
	(602222, 127, '2014-04-01 00:54:47.000000', 'consum', 0.0225, 'lps'),
	(602223, 127, '2014-04-01 00:54:48.000000', 'consum', 0.0213, 'lps'),
	(602224, 127, '2014-04-01 00:54:49.000000', 'consum', 0.0224, 'lps'),
	(602225, 127, '2014-04-01 00:54:50.000000', 'consum', 0.0228, 'lps'),
	(602226, 127, '2014-04-01 00:54:51.000000', 'consum', 0.0213, 'lps'),
	(602227, 127, '2014-04-01 00:54:52.000000', 'consum', 0.0217, 'lps'),
	(602228, 127, '2014-04-01 00:54:53.000000', 'consum', 0.0214, 'lps'),
	(602229, 127, '2014-04-01 00:54:54.000000', 'consum', 0.0229, 'lps'),
	(602230, 127, '2014-04-01 00:54:55.000000', 'consum', 0.0231, 'lps'),
	(602231, 127, '2014-04-01 00:54:56.000000', 'consum', 0.0215, 'lps'),
	(602232, 127, '2014-04-01 00:54:57.000000', 'consum', 0.0213, 'lps'),
	(602233, 127, '2014-04-01 00:54:58.000000', 'consum', 0.0213, 'lps'),
	(602234, 127, '2014-04-01 00:54:59.000000', 'consum', 0.0218, 'lps'),
	(602235, 127, '2014-04-01 00:55:00.000000', 'consum', 0.0217, 'lps'),
	(602236, 127, '2014-04-01 00:55:01.000000', 'consum', 0.0220, 'lps'),
	(602237, 127, '2014-04-01 00:55:02.000000', 'consum', 0.0220, 'lps'),
	(602238, 127, '2014-04-01 00:55:03.000000', 'consum', 0.0231, 'lps'),
	(602239, 127, '2014-04-01 00:55:04.000000', 'consum', 0.0218, 'lps'),
	(602240, 127, '2014-04-01 00:55:05.000000', 'consum', 0.0230, 'lps'),
	(602241, 127, '2014-04-01 00:55:06.000000', 'consum', 0.0224, 'lps'),
	(602242, 127, '2014-04-01 00:55:07.000000', 'consum', 0.0218, 'lps'),
	(602243, 127, '2014-04-01 00:55:08.000000', 'consum', 0.0230, 'lps'),
	(602244, 127, '2014-04-01 00:55:09.000000', 'consum', 0.0222, 'lps'),
	(602245, 127, '2014-04-01 00:55:10.000000', 'consum', 0.0231, 'lps'),
	(602246, 127, '2014-04-01 00:55:11.000000', 'consum', 0.0213, 'lps'),
	(602247, 127, '2014-04-01 00:55:12.000000', 'consum', 0.0229, 'lps'),
	(602248, 127, '2014-04-01 00:55:13.000000', 'consum', 0.0210, 'lps'),
	(602249, 127, '2014-04-01 00:55:14.000000', 'consum', 0.0219, 'lps'),
	(602250, 127, '2014-04-01 00:55:15.000000', 'consum', 0.0231, 'lps'),
	(602251, 127, '2014-04-01 00:55:16.000000', 'consum', 0.0226, 'lps'),
	(602252, 127, '2014-04-01 00:55:17.000000', 'consum', 0.0225, 'lps'),
	(602253, 127, '2014-04-01 00:55:18.000000', 'consum', 0.0214, 'lps'),
	(602254, 127, '2014-04-01 00:55:19.000000', 'consum', 0.0211, 'lps'),
	(602255, 127, '2014-04-01 00:55:20.000000', 'consum', 0.0225, 'lps'),
	(602256, 127, '2014-04-01 00:55:21.000000', 'consum', 0.0215, 'lps'),
	(602257, 127, '2014-04-01 00:55:22.000000', 'consum', 0.0213, 'lps'),
	(602258, 127, '2014-04-01 00:55:23.000000', 'consum', 0.0210, 'lps'),
	(602259, 127, '2014-04-01 00:55:24.000000', 'consum', 0.0226, 'lps'),
	(602260, 127, '2014-04-01 00:55:25.000000', 'consum', 0.0221, 'lps'),
	(602261, 127, '2014-04-01 00:55:26.000000', 'consum', 0.0220, 'lps'),
	(602262, 127, '2014-04-01 00:55:27.000000', 'consum', 0.0227, 'lps'),
	(602263, 127, '2014-04-01 00:55:28.000000', 'consum', 0.0221, 'lps'),
	(602264, 127, '2014-04-01 00:55:29.000000', 'consum', 0.0217, 'lps'),
	(602265, 127, '2014-04-01 00:55:30.000000', 'consum', 0.0210, 'lps'),
	(602266, 127, '2014-04-01 00:55:31.000000', 'consum', 0.0212, 'lps'),
	(602267, 127, '2014-04-01 00:55:32.000000', 'consum', 0.0220, 'lps'),
	(602268, 127, '2014-04-01 00:55:33.000000', 'consum', 0.0213, 'lps'),
	(602269, 127, '2014-04-01 00:55:34.000000', 'consum', 0.0216, 'lps'),
	(602270, 127, '2014-04-01 00:55:35.000000', 'consum', 0.0210, 'lps'),
	(602271, 127, '2014-04-01 00:55:36.000000', 'consum', 0.0213, 'lps'),
	(602272, 127, '2014-04-01 00:55:37.000000', 'consum', 0.0225, 'lps'),
	(602273, 127, '2014-04-01 00:55:38.000000', 'consum', 0.0231, 'lps'),
	(602274, 127, '2014-04-01 00:55:39.000000', 'consum', 0.0230, 'lps'),
	(602275, 127, '2014-04-01 00:55:40.000000', 'consum', 0.0224, 'lps'),
	(602276, 127, '2014-04-01 00:55:41.000000', 'consum', 0.0221, 'lps'),
	(602277, 127, '2014-04-01 00:55:42.000000', 'consum', 0.0224, 'lps'),
	(602278, 127, '2014-04-01 00:55:43.000000', 'consum', 0.0226, 'lps'),
	(602279, 127, '2014-04-01 00:55:44.000000', 'consum', 0.0226, 'lps'),
	(602280, 127, '2014-04-01 00:55:45.000000', 'consum', 0.0219, 'lps'),
	(602281, 127, '2014-04-01 00:55:46.000000', 'consum', 0.0229, 'lps'),
	(602282, 127, '2014-04-01 00:55:47.000000', 'consum', 0.0216, 'lps'),
	(602283, 127, '2014-04-01 00:55:48.000000', 'consum', 0.0224, 'lps'),
	(602284, 127, '2014-04-01 00:55:49.000000', 'consum', 0.0219, 'lps'),
	(602285, 127, '2014-04-01 00:55:50.000000', 'consum', 0.0212, 'lps'),
	(602286, 127, '2014-04-01 00:55:51.000000', 'consum', 0.0218, 'lps'),
	(602287, 127, '2014-04-01 00:55:52.000000', 'consum', 0.0222, 'lps'),
	(602288, 127, '2014-04-01 00:55:53.000000', 'consum', 0.0222, 'lps'),
	(602289, 127, '2014-04-01 00:55:54.000000', 'consum', 0.0215, 'lps'),
	(602290, 127, '2014-04-01 00:55:55.000000', 'consum', 0.0222, 'lps'),
	(602291, 127, '2014-04-01 00:55:56.000000', 'consum', 0.0231, 'lps'),
	(602292, 127, '2014-04-01 00:55:57.000000', 'consum', 0.0214, 'lps'),
	(602293, 127, '2014-04-01 00:55:58.000000', 'consum', 0.0211, 'lps'),
	(602294, 127, '2014-04-01 00:55:59.000000', 'consum', 0.0225, 'lps'),
	(602295, 127, '2014-04-01 00:56:00.000000', 'consum', 0.0216, 'lps'),
	(602296, 127, '2014-04-01 00:56:01.000000', 'consum', 0.0218, 'lps'),
	(602297, 127, '2014-04-01 00:56:02.000000', 'consum', 0.0211, 'lps'),
	(602298, 127, '2014-04-01 00:56:03.000000', 'consum', 0.0215, 'lps'),
	(602299, 127, '2014-04-01 00:56:04.000000', 'consum', 0.0210, 'lps'),
	(602300, 127, '2014-04-01 00:56:05.000000', 'consum', 0.0219, 'lps'),
	(602301, 127, '2014-04-01 00:56:06.000000', 'consum', 0.0210, 'lps'),
	(602302, 127, '2014-04-01 00:56:07.000000', 'consum', 0.0226, 'lps'),
	(602303, 127, '2014-04-01 00:56:08.000000', 'consum', 0.0224, 'lps'),
	(602304, 127, '2014-04-01 00:56:09.000000', 'consum', 0.0211, 'lps'),
	(602305, 127, '2014-04-01 00:56:10.000000', 'consum', 0.0218, 'lps'),
	(602306, 127, '2014-04-01 00:56:11.000000', 'consum', 0.0226, 'lps'),
	(602307, 127, '2014-04-01 00:56:12.000000', 'consum', 0.0220, 'lps'),
	(602308, 127, '2014-04-01 00:56:13.000000', 'consum', 0.0215, 'lps'),
	(602309, 127, '2014-04-01 00:56:14.000000', 'consum', 0.0225, 'lps'),
	(602310, 127, '2014-04-01 00:56:15.000000', 'consum', 0.0227, 'lps'),
	(602311, 127, '2014-04-01 00:56:16.000000', 'consum', 0.0229, 'lps'),
	(602312, 127, '2014-04-01 00:56:17.000000', 'consum', 0.0212, 'lps'),
	(602313, 127, '2014-04-01 00:56:18.000000', 'consum', 0.0227, 'lps'),
	(602314, 127, '2014-04-01 00:56:19.000000', 'consum', 0.0224, 'lps'),
	(602315, 127, '2014-04-01 00:56:20.000000', 'consum', 0.0228, 'lps'),
	(602316, 127, '2014-04-01 00:56:21.000000', 'consum', 0.0215, 'lps'),
	(602317, 127, '2014-04-01 00:56:22.000000', 'consum', 0.0226, 'lps'),
	(602318, 127, '2014-04-01 00:56:23.000000', 'consum', 0.0229, 'lps'),
	(602319, 127, '2014-04-01 00:56:24.000000', 'consum', 0.0217, 'lps'),
	(602320, 127, '2014-04-01 00:56:25.000000', 'consum', 0.0211, 'lps'),
	(602321, 127, '2014-04-01 00:56:26.000000', 'consum', 0.0216, 'lps'),
	(602322, 127, '2014-04-01 00:56:27.000000', 'consum', 0.0214, 'lps'),
	(602323, 127, '2014-04-01 00:56:28.000000', 'consum', 0.0212, 'lps'),
	(602324, 127, '2014-04-01 00:56:29.000000', 'consum', 0.0211, 'lps'),
	(602325, 127, '2014-04-01 00:56:30.000000', 'consum', 0.0231, 'lps'),
	(602326, 127, '2014-04-01 00:56:31.000000', 'consum', 0.0224, 'lps'),
	(602327, 127, '2014-04-01 00:56:32.000000', 'consum', 0.0215, 'lps'),
	(602328, 127, '2014-04-01 00:56:33.000000', 'consum', 0.0219, 'lps'),
	(602329, 127, '2014-04-01 00:56:34.000000', 'consum', 0.0217, 'lps'),
	(602330, 127, '2014-04-01 00:56:35.000000', 'consum', 0.0220, 'lps'),
	(602331, 127, '2014-04-01 00:56:36.000000', 'consum', 0.0219, 'lps'),
	(602332, 127, '2014-04-01 00:56:37.000000', 'consum', 0.0223, 'lps'),
	(602333, 127, '2014-04-01 00:56:38.000000', 'consum', 0.0225, 'lps'),
	(602334, 127, '2014-04-01 00:56:39.000000', 'consum', 0.0227, 'lps'),
	(602335, 127, '2014-04-01 00:56:40.000000', 'consum', 0.0227, 'lps'),
	(602336, 127, '2014-04-01 00:56:41.000000', 'consum', 0.0223, 'lps'),
	(602337, 127, '2014-04-01 00:56:42.000000', 'consum', 0.0223, 'lps'),
	(602338, 127, '2014-04-01 00:56:43.000000', 'consum', 0.0215, 'lps'),
	(602339, 127, '2014-04-01 00:56:44.000000', 'consum', 0.0220, 'lps'),
	(602340, 127, '2014-04-01 00:56:45.000000', 'consum', 0.0222, 'lps'),
	(602341, 127, '2014-04-01 00:56:46.000000', 'consum', 0.0217, 'lps'),
	(602342, 127, '2014-04-01 00:56:47.000000', 'consum', 0.0212, 'lps'),
	(602343, 127, '2014-04-01 00:56:48.000000', 'consum', 0.0220, 'lps'),
	(602344, 127, '2014-04-01 00:56:49.000000', 'consum', 0.0211, 'lps'),
	(602345, 127, '2014-04-01 00:56:50.000000', 'consum', 0.0231, 'lps'),
	(602346, 127, '2014-04-01 00:56:51.000000', 'consum', 0.0226, 'lps'),
	(602347, 127, '2014-04-01 00:56:52.000000', 'consum', 0.0224, 'lps'),
	(602348, 127, '2014-04-01 00:56:53.000000', 'consum', 0.0212, 'lps'),
	(602349, 127, '2014-04-01 00:56:54.000000', 'consum', 0.0222, 'lps'),
	(602350, 127, '2014-04-01 00:56:55.000000', 'consum', 0.0220, 'lps'),
	(602351, 127, '2014-04-01 00:56:56.000000', 'consum', 0.0226, 'lps'),
	(602352, 127, '2014-04-01 00:56:57.000000', 'consum', 0.0216, 'lps'),
	(602353, 127, '2014-04-01 00:56:58.000000', 'consum', 0.0216, 'lps'),
	(602354, 127, '2014-04-01 00:56:59.000000', 'consum', 0.0220, 'lps'),
	(602355, 127, '2014-04-01 00:57:00.000000', 'consum', 0.0223, 'lps'),
	(602356, 127, '2014-04-01 00:57:01.000000', 'consum', 0.0224, 'lps'),
	(602357, 127, '2014-04-01 00:57:02.000000', 'consum', 0.0218, 'lps'),
	(602358, 127, '2014-04-01 00:57:03.000000', 'consum', 0.0231, 'lps'),
	(602359, 127, '2014-04-01 00:57:04.000000', 'consum', 0.0223, 'lps'),
	(602360, 127, '2014-04-01 00:57:05.000000', 'consum', 0.0216, 'lps'),
	(602361, 127, '2014-04-01 00:57:06.000000', 'consum', 0.0221, 'lps'),
	(602362, 127, '2014-04-01 00:57:07.000000', 'consum', 0.0225, 'lps'),
	(602363, 127, '2014-04-01 00:57:08.000000', 'consum', 0.0231, 'lps'),
	(602364, 127, '2014-04-01 00:57:09.000000', 'consum', 0.0225, 'lps'),
	(602365, 127, '2014-04-01 00:57:10.000000', 'consum', 0.0223, 'lps'),
	(602366, 127, '2014-04-01 00:57:11.000000', 'consum', 0.0231, 'lps'),
	(602367, 127, '2014-04-01 00:57:12.000000', 'consum', 0.0210, 'lps'),
	(602368, 127, '2014-04-01 00:57:13.000000', 'consum', 0.0215, 'lps'),
	(602369, 127, '2014-04-01 00:57:14.000000', 'consum', 0.0214, 'lps'),
	(602370, 127, '2014-04-01 00:57:15.000000', 'consum', 0.0214, 'lps'),
	(602371, 127, '2014-04-01 00:57:16.000000', 'consum', 0.0219, 'lps'),
	(602372, 127, '2014-04-01 00:57:17.000000', 'consum', 0.0221, 'lps'),
	(602373, 127, '2014-04-01 00:57:18.000000', 'consum', 0.0217, 'lps'),
	(602374, 127, '2014-04-01 00:57:19.000000', 'consum', 0.0212, 'lps'),
	(602375, 127, '2014-04-01 00:57:20.000000', 'consum', 0.0223, 'lps'),
	(602376, 127, '2014-04-01 00:57:21.000000', 'consum', 0.0226, 'lps'),
	(602377, 127, '2014-04-01 00:57:22.000000', 'consum', 0.0228, 'lps'),
	(602378, 127, '2014-04-01 00:57:23.000000', 'consum', 0.0211, 'lps'),
	(602379, 127, '2014-04-01 00:57:24.000000', 'consum', 0.0226, 'lps'),
	(602380, 127, '2014-04-01 00:57:25.000000', 'consum', 0.0220, 'lps'),
	(602381, 127, '2014-04-01 00:57:26.000000', 'consum', 0.0215, 'lps'),
	(602382, 127, '2014-04-01 00:57:27.000000', 'consum', 0.0227, 'lps'),
	(602383, 127, '2014-04-01 00:57:28.000000', 'consum', 0.0213, 'lps'),
	(602384, 127, '2014-04-01 00:57:29.000000', 'consum', 0.0221, 'lps'),
	(602385, 127, '2014-04-01 00:57:30.000000', 'consum', 0.0210, 'lps'),
	(602386, 127, '2014-04-01 00:57:31.000000', 'consum', 0.0221, 'lps'),
	(602387, 127, '2014-04-01 00:57:32.000000', 'consum', 0.0223, 'lps'),
	(602388, 127, '2014-04-01 00:57:33.000000', 'consum', 0.0220, 'lps'),
	(602389, 127, '2014-04-01 00:57:34.000000', 'consum', 0.0222, 'lps'),
	(602390, 127, '2014-04-01 00:57:35.000000', 'consum', 0.0218, 'lps'),
	(602391, 127, '2014-04-01 00:57:36.000000', 'consum', 0.0213, 'lps'),
	(602392, 127, '2014-04-01 00:57:37.000000', 'consum', 0.0224, 'lps'),
	(602393, 127, '2014-04-01 00:57:38.000000', 'consum', 0.0229, 'lps'),
	(602394, 127, '2014-04-01 00:57:39.000000', 'consum', 0.0217, 'lps'),
	(602395, 127, '2014-04-01 00:57:40.000000', 'consum', 0.0212, 'lps'),
	(602396, 127, '2014-04-01 00:57:41.000000', 'consum', 0.0221, 'lps'),
	(602397, 127, '2014-04-01 00:57:42.000000', 'consum', 0.0216, 'lps'),
	(602398, 127, '2014-04-01 00:57:43.000000', 'consum', 0.0228, 'lps'),
	(602399, 127, '2014-04-01 00:57:44.000000', 'consum', 0.0217, 'lps'),
	(602400, 127, '2014-04-01 00:57:45.000000', 'consum', 0.0215, 'lps'),
	(602401, 127, '2014-04-01 00:57:46.000000', 'consum', 0.0212, 'lps'),
	(602402, 127, '2014-04-01 00:57:47.000000', 'consum', 0.0227, 'lps'),
	(602403, 127, '2014-04-01 00:57:48.000000', 'consum', 0.0223, 'lps'),
	(602404, 127, '2014-04-01 00:57:49.000000', 'consum', 0.0224, 'lps'),
	(602405, 127, '2014-04-01 00:57:50.000000', 'consum', 0.0219, 'lps'),
	(602406, 127, '2014-04-01 00:57:51.000000', 'consum', 0.0216, 'lps'),
	(602407, 127, '2014-04-01 00:57:52.000000', 'consum', 0.0214, 'lps'),
	(602408, 127, '2014-04-01 00:57:53.000000', 'consum', 0.0231, 'lps'),
	(602409, 127, '2014-04-01 00:57:54.000000', 'consum', 0.0219, 'lps'),
	(602410, 127, '2014-04-01 00:57:55.000000', 'consum', 0.0214, 'lps'),
	(602411, 127, '2014-04-01 00:57:56.000000', 'consum', 0.0226, 'lps'),
	(602412, 127, '2014-04-01 00:57:57.000000', 'consum', 0.0214, 'lps'),
	(602413, 127, '2014-04-01 00:57:58.000000', 'consum', 0.0224, 'lps'),
	(602414, 127, '2014-04-01 00:57:59.000000', 'consum', 0.0224, 'lps'),
	(602415, 127, '2014-04-01 00:58:00.000000', 'consum', 0.0216, 'lps'),
	(602416, 127, '2014-04-01 00:58:01.000000', 'consum', 0.0220, 'lps'),
	(602417, 127, '2014-04-01 00:58:02.000000', 'consum', 0.0220, 'lps'),
	(602418, 127, '2014-04-01 00:58:03.000000', 'consum', 0.0231, 'lps'),
	(602419, 127, '2014-04-01 00:58:04.000000', 'consum', 0.0222, 'lps'),
	(602420, 127, '2014-04-01 00:58:05.000000', 'consum', 0.0227, 'lps'),
	(602421, 127, '2014-04-01 00:58:06.000000', 'consum', 0.0215, 'lps'),
	(602422, 127, '2014-04-01 00:58:07.000000', 'consum', 0.0229, 'lps'),
	(602423, 127, '2014-04-01 00:58:08.000000', 'consum', 0.0224, 'lps'),
	(602424, 127, '2014-04-01 00:58:09.000000', 'consum', 0.0223, 'lps'),
	(602425, 127, '2014-04-01 00:58:10.000000', 'consum', 0.0210, 'lps'),
	(602426, 127, '2014-04-01 00:58:11.000000', 'consum', 0.0218, 'lps'),
	(602427, 127, '2014-04-01 00:58:12.000000', 'consum', 0.0228, 'lps'),
	(602428, 127, '2014-04-01 00:58:13.000000', 'consum', 0.0212, 'lps'),
	(602429, 127, '2014-04-01 00:58:14.000000', 'consum', 0.0210, 'lps'),
	(602430, 127, '2014-04-01 00:58:15.000000', 'consum', 0.0225, 'lps'),
	(602431, 127, '2014-04-01 00:58:16.000000', 'consum', 0.0219, 'lps'),
	(602432, 127, '2014-04-01 00:58:17.000000', 'consum', 0.0210, 'lps'),
	(602433, 127, '2014-04-01 00:58:18.000000', 'consum', 0.0229, 'lps'),
	(602434, 127, '2014-04-01 00:58:19.000000', 'consum', 0.0218, 'lps'),
	(602435, 127, '2014-04-01 00:58:20.000000', 'consum', 0.0213, 'lps'),
	(602436, 127, '2014-04-01 00:58:21.000000', 'consum', 0.0224, 'lps'),
	(602437, 127, '2014-04-01 00:58:22.000000', 'consum', 0.0227, 'lps'),
	(602438, 127, '2014-04-01 00:58:23.000000', 'consum', 0.0231, 'lps'),
	(602439, 127, '2014-04-01 00:58:24.000000', 'consum', 0.0221, 'lps'),
	(602440, 127, '2014-04-01 00:58:25.000000', 'consum', 0.0226, 'lps'),
	(602441, 127, '2014-04-01 00:58:26.000000', 'consum', 0.0211, 'lps'),
	(602442, 127, '2014-04-01 00:58:27.000000', 'consum', 0.0214, 'lps'),
	(602443, 127, '2014-04-01 00:58:28.000000', 'consum', 0.0228, 'lps'),
	(602444, 127, '2014-04-01 00:58:29.000000', 'consum', 0.0221, 'lps'),
	(602445, 127, '2014-04-01 00:58:30.000000', 'consum', 0.0213, 'lps'),
	(602446, 127, '2014-04-01 00:58:31.000000', 'consum', 0.0215, 'lps'),
	(602447, 127, '2014-04-01 00:58:32.000000', 'consum', 0.0227, 'lps'),
	(602448, 127, '2014-04-01 00:58:33.000000', 'consum', 0.0212, 'lps'),
	(602449, 127, '2014-04-01 00:58:34.000000', 'consum', 0.0213, 'lps'),
	(602450, 127, '2014-04-01 00:58:35.000000', 'consum', 0.0219, 'lps'),
	(602451, 127, '2014-04-01 00:58:36.000000', 'consum', 0.0224, 'lps'),
	(602452, 127, '2014-04-01 00:58:37.000000', 'consum', 0.0231, 'lps'),
	(602453, 127, '2014-04-01 00:58:38.000000', 'consum', 0.0230, 'lps'),
	(602454, 127, '2014-04-01 00:58:39.000000', 'consum', 0.0227, 'lps'),
	(602455, 127, '2014-04-01 00:58:40.000000', 'consum', 0.0212, 'lps'),
	(602456, 127, '2014-04-01 00:58:41.000000', 'consum', 0.0213, 'lps'),
	(602457, 127, '2014-04-01 00:58:42.000000', 'consum', 0.0222, 'lps'),
	(602458, 127, '2014-04-01 00:58:43.000000', 'consum', 0.0217, 'lps'),
	(602459, 127, '2014-04-01 00:58:44.000000', 'consum', 0.0229, 'lps'),
	(602460, 127, '2014-04-01 00:58:45.000000', 'consum', 0.0221, 'lps'),
	(602461, 127, '2014-04-01 00:58:46.000000', 'consum', 0.0228, 'lps'),
	(602462, 127, '2014-04-01 00:58:47.000000', 'consum', 0.0223, 'lps'),
	(602463, 127, '2014-04-01 00:58:48.000000', 'consum', 0.0222, 'lps'),
	(602464, 127, '2014-04-01 00:58:49.000000', 'consum', 0.0210, 'lps'),
	(602465, 127, '2014-04-01 00:58:50.000000', 'consum', 0.0220, 'lps'),
	(602466, 127, '2014-04-01 00:58:51.000000', 'consum', 0.0217, 'lps'),
	(602467, 127, '2014-04-01 00:58:52.000000', 'consum', 0.0213, 'lps'),
	(602468, 127, '2014-04-01 00:58:53.000000', 'consum', 0.0229, 'lps'),
	(602469, 127, '2014-04-01 00:58:54.000000', 'consum', 0.0228, 'lps'),
	(602470, 127, '2014-04-01 00:58:55.000000', 'consum', 0.0223, 'lps'),
	(602471, 127, '2014-04-01 00:58:56.000000', 'consum', 0.0222, 'lps'),
	(602472, 127, '2014-04-01 00:58:57.000000', 'consum', 0.0230, 'lps'),
	(602473, 127, '2014-04-01 00:58:58.000000', 'consum', 0.0231, 'lps'),
	(602474, 127, '2014-04-01 00:58:59.000000', 'consum', 0.0211, 'lps'),
	(602475, 127, '2014-04-01 00:59:00.000000', 'consum', 0.0217, 'lps'),
	(602476, 127, '2014-04-01 00:59:01.000000', 'consum', 0.0223, 'lps'),
	(602477, 127, '2014-04-01 00:59:02.000000', 'consum', 0.0231, 'lps'),
	(602478, 127, '2014-04-01 00:59:03.000000', 'consum', 0.0211, 'lps'),
	(602479, 127, '2014-04-01 00:59:04.000000', 'consum', 0.0220, 'lps'),
	(602480, 127, '2014-04-01 00:59:05.000000', 'consum', 0.0214, 'lps'),
	(602481, 127, '2014-04-01 00:59:06.000000', 'consum', 0.0221, 'lps'),
	(602482, 127, '2014-04-01 00:59:07.000000', 'consum', 0.0210, 'lps'),
	(602483, 127, '2014-04-01 00:59:08.000000', 'consum', 0.0221, 'lps'),
	(602484, 127, '2014-04-01 00:59:09.000000', 'consum', 0.0223, 'lps'),
	(602485, 127, '2014-04-01 00:59:10.000000', 'consum', 0.0221, 'lps'),
	(602486, 127, '2014-04-01 00:59:11.000000', 'consum', 0.0226, 'lps'),
	(602487, 127, '2014-04-01 00:59:12.000000', 'consum', 0.0212, 'lps'),
	(602488, 127, '2014-04-01 00:59:13.000000', 'consum', 0.0216, 'lps'),
	(602489, 127, '2014-04-01 00:59:14.000000', 'consum', 0.0212, 'lps'),
	(602490, 127, '2014-04-01 00:59:15.000000', 'consum', 0.0227, 'lps'),
	(602491, 127, '2014-04-01 00:59:16.000000', 'consum', 0.0221, 'lps'),
	(602492, 127, '2014-04-01 00:59:17.000000', 'consum', 0.0214, 'lps'),
	(602493, 127, '2014-04-01 00:59:18.000000', 'consum', 0.0219, 'lps'),
	(602494, 127, '2014-04-01 00:59:19.000000', 'consum', 0.0225, 'lps'),
	(602495, 127, '2014-04-01 00:59:20.000000', 'consum', 0.0211, 'lps'),
	(602496, 127, '2014-04-01 00:59:21.000000', 'consum', 0.0214, 'lps'),
	(602497, 127, '2014-04-01 00:59:22.000000', 'consum', 0.0230, 'lps'),
	(602498, 127, '2014-04-01 00:59:23.000000', 'consum', 0.0211, 'lps'),
	(602499, 127, '2014-04-01 00:59:24.000000', 'consum', 0.0222, 'lps'),
	(602500, 127, '2014-04-01 00:59:25.000000', 'consum', 0.0222, 'lps'),
	(602501, 127, '2014-04-01 00:59:26.000000', 'consum', 0.0214, 'lps'),
	(602502, 127, '2014-04-01 00:59:27.000000', 'consum', 0.0217, 'lps'),
	(602503, 127, '2014-04-01 00:59:28.000000', 'consum', 0.0210, 'lps'),
	(602504, 127, '2014-04-01 00:59:29.000000', 'consum', 0.0211, 'lps'),
	(602505, 127, '2014-04-01 00:59:30.000000', 'consum', 0.0217, 'lps'),
	(602506, 127, '2014-04-01 00:59:31.000000', 'consum', 0.0222, 'lps'),
	(602507, 127, '2014-04-01 00:59:32.000000', 'consum', 0.0224, 'lps'),
	(602508, 127, '2014-04-01 00:59:33.000000', 'consum', 0.0224, 'lps'),
	(602509, 127, '2014-04-01 00:59:34.000000', 'consum', 0.0215, 'lps'),
	(602510, 127, '2014-04-01 00:59:35.000000', 'consum', 0.0217, 'lps'),
	(602511, 127, '2014-04-01 00:59:36.000000', 'consum', 0.0210, 'lps'),
	(602512, 127, '2014-04-01 00:59:37.000000', 'consum', 0.0231, 'lps'),
	(602513, 127, '2014-04-01 00:59:38.000000', 'consum', 0.0226, 'lps'),
	(602514, 127, '2014-04-01 00:59:39.000000', 'consum', 0.0231, 'lps'),
	(602515, 127, '2014-04-01 00:59:40.000000', 'consum', 0.0223, 'lps'),
	(602516, 127, '2014-04-01 00:59:41.000000', 'consum', 0.0212, 'lps'),
	(602517, 127, '2014-04-01 00:59:42.000000', 'consum', 0.0226, 'lps'),
	(602518, 127, '2014-04-01 00:59:43.000000', 'consum', 0.0218, 'lps'),
	(602519, 127, '2014-04-01 00:59:44.000000', 'consum', 0.0223, 'lps'),
	(602520, 127, '2014-04-01 00:59:45.000000', 'consum', 0.0229, 'lps'),
	(602521, 127, '2014-04-01 00:59:46.000000', 'consum', 0.0222, 'lps'),
	(602522, 127, '2014-04-01 00:59:47.000000', 'consum', 0.0216, 'lps'),
	(602523, 127, '2014-04-01 00:59:48.000000', 'consum', 0.0227, 'lps'),
	(602524, 127, '2014-04-01 00:59:49.000000', 'consum', 0.0212, 'lps'),
	(602525, 127, '2014-04-01 00:59:50.000000', 'consum', 0.0214, 'lps'),
	(602526, 127, '2014-04-01 00:59:51.000000', 'consum', 0.0223, 'lps'),
	(602527, 127, '2014-04-01 00:59:52.000000', 'consum', 0.0218, 'lps'),
	(602528, 127, '2014-04-01 00:59:53.000000', 'consum', 0.0213, 'lps'),
	(602529, 127, '2014-04-01 00:59:54.000000', 'consum', 0.0223, 'lps'),
	(602530, 127, '2014-04-01 00:59:55.000000', 'consum', 0.0224, 'lps'),
	(602531, 127, '2014-04-01 00:59:56.000000', 'consum', 0.0219, 'lps'),
	(602532, 127, '2014-04-01 00:59:57.000000', 'consum', 0.0215, 'lps'),
	(602533, 127, '2014-04-01 00:59:58.000000', 'consum', 0.0229, 'lps'),
	(602534, 127, '2014-04-01 00:59:59.000000', 'consum', 0.0225, 'lps'),
	(602535, 127, '2014-04-01 01:00:00.000000', 'consum', 0.0227, 'lps'),
	(602536, 127, '2014-04-01 01:00:01.000000', 'consum', 0.0229, 'lps'),
	(602537, 127, '2014-04-01 01:00:02.000000', 'consum', 0.0212, 'lps'),
	(602538, 127, '2014-04-01 01:00:03.000000', 'consum', 0.0228, 'lps'),
	(602539, 127, '2014-04-01 01:00:04.000000', 'consum', 0.0227, 'lps'),
	(602540, 127, '2014-04-01 01:00:05.000000', 'consum', 0.0221, 'lps'),
	(602541, 127, '2014-04-01 01:00:06.000000', 'consum', 0.0215, 'lps'),
	(602542, 127, '2014-04-01 01:00:07.000000', 'consum', 0.0222, 'lps'),
	(602543, 127, '2014-04-01 01:00:08.000000', 'consum', 0.0214, 'lps'),
	(602544, 127, '2014-04-01 01:00:09.000000', 'consum', 0.0218, 'lps'),
	(602545, 127, '2014-04-01 01:00:10.000000', 'consum', 0.0214, 'lps'),
	(602546, 127, '2014-04-01 01:00:11.000000', 'consum', 0.0229, 'lps'),
	(602547, 127, '2014-04-01 01:00:12.000000', 'consum', 0.0228, 'lps'),
	(602548, 127, '2014-04-01 01:00:13.000000', 'consum', 0.0223, 'lps'),
	(602549, 127, '2014-04-01 01:00:14.000000', 'consum', 0.0222, 'lps'),
	(602550, 127, '2014-04-01 01:00:15.000000', 'consum', 0.0228, 'lps'),
	(602551, 127, '2014-04-01 01:00:16.000000', 'consum', 0.0224, 'lps'),
	(602552, 127, '2014-04-01 01:00:17.000000', 'consum', 0.0226, 'lps'),
	(602553, 127, '2014-04-01 01:00:18.000000', 'consum', 0.0227, 'lps'),
	(602554, 127, '2014-04-01 01:00:19.000000', 'consum', 0.0223, 'lps'),
	(602555, 127, '2014-04-01 01:00:20.000000', 'consum', 0.0225, 'lps'),
	(602556, 127, '2014-04-01 01:00:21.000000', 'consum', 0.0224, 'lps'),
	(602557, 127, '2014-04-01 01:00:22.000000', 'consum', 0.0216, 'lps'),
	(602558, 127, '2014-04-01 01:00:23.000000', 'consum', 0.0219, 'lps'),
	(602559, 127, '2014-04-01 01:00:24.000000', 'consum', 0.0216, 'lps'),
	(602560, 127, '2014-04-01 01:00:25.000000', 'consum', 0.0214, 'lps'),
	(602561, 127, '2014-04-01 01:00:26.000000', 'consum', 0.0214, 'lps'),
	(602562, 127, '2014-04-01 01:00:27.000000', 'consum', 0.0217, 'lps'),
	(602563, 127, '2014-04-01 01:00:28.000000', 'consum', 0.0210, 'lps'),
	(602564, 127, '2014-04-01 01:00:29.000000', 'consum', 0.0214, 'lps'),
	(602565, 127, '2014-04-01 01:00:30.000000', 'consum', 0.0210, 'lps'),
	(602566, 127, '2014-04-01 01:00:31.000000', 'consum', 0.0217, 'lps'),
	(602567, 127, '2014-04-01 01:00:32.000000', 'consum', 0.0226, 'lps'),
	(602568, 127, '2014-04-01 01:00:33.000000', 'consum', 0.0225, 'lps'),
	(602569, 127, '2014-04-01 01:00:34.000000', 'consum', 0.0217, 'lps'),
	(602570, 127, '2014-04-01 01:00:35.000000', 'consum', 0.0222, 'lps'),
	(602571, 127, '2014-04-01 01:00:36.000000', 'consum', 0.0225, 'lps'),
	(602572, 127, '2014-04-01 01:00:37.000000', 'consum', 0.0231, 'lps'),
	(602573, 127, '2014-04-01 01:00:38.000000', 'consum', 0.0225, 'lps'),
	(602574, 127, '2014-04-01 01:00:39.000000', 'consum', 0.0221, 'lps'),
	(602575, 127, '2014-04-01 01:00:40.000000', 'consum', 0.0221, 'lps'),
	(602576, 127, '2014-04-01 01:00:41.000000', 'consum', 0.0211, 'lps'),
	(602577, 127, '2014-04-01 01:00:42.000000', 'consum', 0.0228, 'lps'),
	(602578, 127, '2014-04-01 01:00:43.000000', 'consum', 0.0228, 'lps'),
	(602579, 127, '2014-04-01 01:00:44.000000', 'consum', 0.0228, 'lps'),
	(602580, 127, '2014-04-01 01:00:45.000000', 'consum', 0.0225, 'lps'),
	(602581, 127, '2014-04-01 01:00:46.000000', 'consum', 0.0229, 'lps'),
	(602582, 127, '2014-04-01 01:00:47.000000', 'consum', 0.0215, 'lps'),
	(602583, 127, '2014-04-01 01:00:48.000000', 'consum', 0.0226, 'lps'),
	(602584, 127, '2014-04-01 01:00:49.000000', 'consum', 0.0231, 'lps'),
	(602585, 127, '2014-04-01 01:00:50.000000', 'consum', 0.0223, 'lps'),
	(602586, 127, '2014-04-01 01:00:51.000000', 'consum', 0.0213, 'lps'),
	(602587, 127, '2014-04-01 01:00:52.000000', 'consum', 0.0228, 'lps'),
	(602588, 127, '2014-04-01 01:00:53.000000', 'consum', 0.0229, 'lps'),
	(602589, 127, '2014-04-01 01:00:54.000000', 'consum', 0.0226, 'lps'),
	(602590, 127, '2014-04-01 01:00:55.000000', 'consum', 0.0214, 'lps'),
	(602591, 127, '2014-04-01 01:00:56.000000', 'consum', 0.0227, 'lps'),
	(602592, 127, '2014-04-01 01:00:57.000000', 'consum', 0.0218, 'lps'),
	(602593, 127, '2014-04-01 01:00:58.000000', 'consum', 0.0222, 'lps'),
	(602594, 127, '2014-04-01 01:00:59.000000', 'consum', 0.0222, 'lps'),
	(602595, 127, '2014-04-01 01:01:00.000000', 'consum', 0.0212, 'lps'),
	(602596, 127, '2014-04-01 01:01:01.000000', 'consum', 0.0229, 'lps'),
	(602597, 127, '2014-04-01 01:01:02.000000', 'consum', 0.0210, 'lps'),
	(602598, 127, '2014-04-01 01:01:03.000000', 'consum', 0.0221, 'lps'),
	(602599, 127, '2014-04-01 01:01:04.000000', 'consum', 0.0223, 'lps'),
	(602600, 127, '2014-04-01 01:01:05.000000', 'consum', 0.0219, 'lps'),
	(602601, 127, '2014-04-01 01:01:06.000000', 'consum', 0.0218, 'lps'),
	(602602, 127, '2014-04-01 01:01:07.000000', 'consum', 0.0222, 'lps'),
	(602603, 127, '2014-04-01 01:01:08.000000', 'consum', 0.0223, 'lps'),
	(602604, 127, '2014-04-01 01:01:09.000000', 'consum', 0.0220, 'lps'),
	(602605, 127, '2014-04-01 01:01:10.000000', 'consum', 0.0223, 'lps'),
	(602606, 127, '2014-04-01 01:01:11.000000', 'consum', 0.0220, 'lps'),
	(602607, 127, '2014-04-01 01:01:12.000000', 'consum', 0.0223, 'lps'),
	(602608, 127, '2014-04-01 01:01:13.000000', 'consum', 0.0225, 'lps'),
	(602609, 127, '2014-04-01 01:01:14.000000', 'consum', 0.0222, 'lps'),
	(602610, 127, '2014-04-01 01:01:15.000000', 'consum', 0.0226, 'lps'),
	(602611, 127, '2014-04-01 01:01:16.000000', 'consum', 0.0211, 'lps'),
	(602612, 127, '2014-04-01 01:01:17.000000', 'consum', 0.0211, 'lps'),
	(602613, 127, '2014-04-01 01:01:18.000000', 'consum', 0.0211, 'lps'),
	(602614, 127, '2014-04-01 01:01:19.000000', 'consum', 0.0214, 'lps'),
	(602615, 127, '2014-04-01 01:01:20.000000', 'consum', 0.0227, 'lps'),
	(602616, 127, '2014-04-01 01:01:21.000000', 'consum', 0.0217, 'lps'),
	(602617, 127, '2014-04-01 01:01:22.000000', 'consum', 0.0217, 'lps'),
	(602618, 127, '2014-04-01 01:01:23.000000', 'consum', 0.0225, 'lps'),
	(602619, 127, '2014-04-01 01:01:24.000000', 'consum', 0.0221, 'lps'),
	(602620, 127, '2014-04-01 01:01:25.000000', 'consum', 0.0222, 'lps'),
	(602621, 127, '2014-04-01 01:01:26.000000', 'consum', 0.0213, 'lps'),
	(602622, 127, '2014-04-01 01:01:27.000000', 'consum', 0.0212, 'lps'),
	(602623, 127, '2014-04-01 01:01:28.000000', 'consum', 0.0213, 'lps'),
	(602624, 127, '2014-04-01 01:01:29.000000', 'consum', 0.0220, 'lps'),
	(602625, 127, '2014-04-01 01:01:30.000000', 'consum', 0.0229, 'lps'),
	(602626, 127, '2014-04-01 01:01:31.000000', 'consum', 0.0211, 'lps'),
	(602627, 127, '2014-04-01 01:01:32.000000', 'consum', 0.0224, 'lps'),
	(602628, 127, '2014-04-01 01:01:33.000000', 'consum', 0.0213, 'lps'),
	(602629, 127, '2014-04-01 01:01:34.000000', 'consum', 0.0225, 'lps'),
	(602630, 127, '2014-04-01 01:01:35.000000', 'consum', 0.0213, 'lps'),
	(602631, 127, '2014-04-01 01:01:36.000000', 'consum', 0.0224, 'lps'),
	(602632, 127, '2014-04-01 01:01:37.000000', 'consum', 0.0228, 'lps'),
	(602633, 127, '2014-04-01 01:01:38.000000', 'consum', 0.0215, 'lps'),
	(602634, 127, '2014-04-01 01:01:39.000000', 'consum', 0.0225, 'lps'),
	(602635, 127, '2014-04-01 01:01:40.000000', 'consum', 0.0228, 'lps'),
	(602636, 127, '2014-04-01 01:01:41.000000', 'consum', 0.0210, 'lps'),
	(602637, 127, '2014-04-01 01:01:42.000000', 'consum', 0.0222, 'lps'),
	(602638, 127, '2014-04-01 01:01:43.000000', 'consum', 0.0225, 'lps'),
	(602639, 127, '2014-04-01 01:01:44.000000', 'consum', 0.0229, 'lps'),
	(602640, 127, '2014-04-01 01:01:45.000000', 'consum', 0.0216, 'lps'),
	(602641, 127, '2014-04-01 01:01:46.000000', 'consum', 0.0229, 'lps'),
	(602642, 127, '2014-04-01 01:01:47.000000', 'consum', 0.0222, 'lps'),
	(602643, 127, '2014-04-01 01:01:48.000000', 'consum', 0.0212, 'lps'),
	(602644, 127, '2014-04-01 01:01:49.000000', 'consum', 0.0231, 'lps'),
	(602645, 127, '2014-04-01 01:01:50.000000', 'consum', 0.0220, 'lps'),
	(602646, 127, '2014-04-01 01:01:51.000000', 'consum', 0.0218, 'lps'),
	(602647, 127, '2014-04-01 01:01:52.000000', 'consum', 0.0220, 'lps'),
	(602648, 127, '2014-04-01 01:01:53.000000', 'consum', 0.0214, 'lps'),
	(602649, 127, '2014-04-01 01:01:54.000000', 'consum', 0.0224, 'lps'),
	(602650, 127, '2014-04-01 01:01:55.000000', 'consum', 0.0223, 'lps'),
	(602651, 127, '2014-04-01 01:01:56.000000', 'consum', 0.0213, 'lps'),
	(602652, 127, '2014-04-01 01:01:57.000000', 'consum', 0.0228, 'lps'),
	(602653, 127, '2014-04-01 01:01:58.000000', 'consum', 0.0227, 'lps'),
	(602654, 127, '2014-04-01 01:01:59.000000', 'consum', 0.0220, 'lps'),
	(602655, 127, '2014-04-01 01:02:00.000000', 'consum', 0.0231, 'lps'),
	(602656, 127, '2014-04-01 01:02:01.000000', 'consum', 0.0221, 'lps'),
	(602657, 127, '2014-04-01 01:02:02.000000', 'consum', 0.0223, 'lps'),
	(602658, 127, '2014-04-01 01:02:03.000000', 'consum', 0.0222, 'lps'),
	(602659, 127, '2014-04-01 01:02:04.000000', 'consum', 0.0229, 'lps'),
	(602660, 127, '2014-04-01 01:02:05.000000', 'consum', 0.0226, 'lps'),
	(602661, 127, '2014-04-01 01:02:06.000000', 'consum', 0.0210, 'lps'),
	(602662, 127, '2014-04-01 01:02:07.000000', 'consum', 0.0231, 'lps'),
	(602663, 127, '2014-04-01 01:02:08.000000', 'consum', 0.0227, 'lps'),
	(602664, 127, '2014-04-01 01:02:09.000000', 'consum', 0.0210, 'lps'),
	(602665, 127, '2014-04-01 01:02:10.000000', 'consum', 0.0225, 'lps'),
	(602666, 127, '2014-04-01 01:02:11.000000', 'consum', 0.0220, 'lps'),
	(602667, 127, '2014-04-01 01:02:12.000000', 'consum', 0.0216, 'lps'),
	(602668, 127, '2014-04-01 01:02:13.000000', 'consum', 0.0230, 'lps'),
	(602669, 127, '2014-04-01 01:02:14.000000', 'consum', 0.0228, 'lps'),
	(602670, 127, '2014-04-01 01:02:15.000000', 'consum', 0.0219, 'lps'),
	(602671, 127, '2014-04-01 01:02:16.000000', 'consum', 0.0224, 'lps'),
	(602672, 127, '2014-04-01 01:02:17.000000', 'consum', 0.0231, 'lps'),
	(602673, 127, '2014-04-01 01:02:18.000000', 'consum', 0.0228, 'lps'),
	(602674, 127, '2014-04-01 01:02:19.000000', 'consum', 0.0218, 'lps'),
	(602675, 127, '2014-04-01 01:02:20.000000', 'consum', 0.0218, 'lps'),
	(602676, 127, '2014-04-01 01:02:21.000000', 'consum', 0.0227, 'lps'),
	(602677, 127, '2014-04-01 01:02:22.000000', 'consum', 0.0226, 'lps'),
	(602678, 127, '2014-04-01 01:02:23.000000', 'consum', 0.0218, 'lps'),
	(602679, 127, '2014-04-01 01:02:24.000000', 'consum', 0.0226, 'lps'),
	(602680, 127, '2014-04-01 01:02:25.000000', 'consum', 0.0222, 'lps'),
	(602681, 127, '2014-04-01 01:02:26.000000', 'consum', 0.0220, 'lps'),
	(602682, 127, '2014-04-01 01:02:27.000000', 'consum', 0.0227, 'lps'),
	(602683, 127, '2014-04-01 01:02:28.000000', 'consum', 0.0222, 'lps'),
	(602684, 127, '2014-04-01 01:02:29.000000', 'consum', 0.0218, 'lps'),
	(602685, 127, '2014-04-01 01:02:30.000000', 'consum', 0.0213, 'lps'),
	(602686, 127, '2014-04-01 01:02:31.000000', 'consum', 0.0225, 'lps'),
	(602687, 127, '2014-04-01 01:02:32.000000', 'consum', 0.0210, 'lps'),
	(602688, 127, '2014-04-01 01:02:33.000000', 'consum', 0.0210, 'lps'),
	(602689, 127, '2014-04-01 01:02:34.000000', 'consum', 0.0211, 'lps'),
	(602690, 127, '2014-04-01 01:02:35.000000', 'consum', 0.0217, 'lps'),
	(602691, 127, '2014-04-01 01:02:36.000000', 'consum', 0.0218, 'lps'),
	(602692, 127, '2014-04-01 01:02:37.000000', 'consum', 0.0229, 'lps'),
	(602693, 127, '2014-04-01 01:02:38.000000', 'consum', 0.0215, 'lps'),
	(602694, 127, '2014-04-01 01:02:39.000000', 'consum', 0.0224, 'lps'),
	(602695, 127, '2014-04-01 01:02:40.000000', 'consum', 0.0220, 'lps'),
	(602696, 127, '2014-04-01 01:02:41.000000', 'consum', 0.0221, 'lps'),
	(602697, 127, '2014-04-01 01:02:42.000000', 'consum', 0.0212, 'lps'),
	(602698, 127, '2014-04-01 01:02:43.000000', 'consum', 0.0231, 'lps'),
	(602699, 127, '2014-04-01 01:02:44.000000', 'consum', 0.0220, 'lps'),
	(602700, 127, '2014-04-01 01:02:45.000000', 'consum', 0.0221, 'lps'),
	(602701, 127, '2014-04-01 01:02:46.000000', 'consum', 0.0212, 'lps'),
	(602702, 127, '2014-04-01 01:02:47.000000', 'consum', 0.0211, 'lps'),
	(602703, 127, '2014-04-01 01:02:48.000000', 'consum', 0.0229, 'lps'),
	(602704, 127, '2014-04-01 01:02:49.000000', 'consum', 0.0218, 'lps'),
	(602705, 127, '2014-04-01 01:02:50.000000', 'consum', 0.0214, 'lps'),
	(602706, 127, '2014-04-01 01:02:51.000000', 'consum', 0.0228, 'lps'),
	(602707, 127, '2014-04-01 01:02:52.000000', 'consum', 0.0224, 'lps'),
	(602708, 127, '2014-04-01 01:02:53.000000', 'consum', 0.0225, 'lps'),
	(602709, 127, '2014-04-01 01:02:54.000000', 'consum', 0.0221, 'lps'),
	(602710, 127, '2014-04-01 01:02:55.000000', 'consum', 0.0222, 'lps'),
	(602711, 127, '2014-04-01 01:02:56.000000', 'consum', 0.0216, 'lps'),
	(602712, 127, '2014-04-01 01:02:57.000000', 'consum', 0.0227, 'lps'),
	(602713, 127, '2014-04-01 01:02:58.000000', 'consum', 0.0212, 'lps'),
	(602714, 127, '2014-04-01 01:02:59.000000', 'consum', 0.0214, 'lps'),
	(602715, 127, '2014-04-01 01:03:00.000000', 'consum', 0.0223, 'lps'),
	(602716, 127, '2014-04-01 01:03:01.000000', 'consum', 0.0221, 'lps'),
	(602717, 127, '2014-04-01 01:03:02.000000', 'consum', 0.0228, 'lps'),
	(602718, 127, '2014-04-01 01:03:03.000000', 'consum', 0.0220, 'lps'),
	(602719, 127, '2014-04-01 01:03:04.000000', 'consum', 0.0229, 'lps'),
	(602720, 127, '2014-04-01 01:03:05.000000', 'consum', 0.0211, 'lps'),
	(602721, 127, '2014-04-01 01:03:06.000000', 'consum', 0.0222, 'lps'),
	(602722, 127, '2014-04-01 01:03:07.000000', 'consum', 0.0224, 'lps'),
	(602723, 127, '2014-04-01 01:03:08.000000', 'consum', 0.0222, 'lps'),
	(602724, 127, '2014-04-01 01:03:09.000000', 'consum', 0.0228, 'lps'),
	(602725, 127, '2014-04-01 01:03:10.000000', 'consum', 0.0223, 'lps'),
	(602726, 127, '2014-04-01 01:03:11.000000', 'consum', 0.0221, 'lps'),
	(602727, 127, '2014-04-01 01:03:12.000000', 'consum', 0.0227, 'lps'),
	(602728, 127, '2014-04-01 01:03:13.000000', 'consum', 0.0218, 'lps'),
	(602729, 127, '2014-04-01 01:03:14.000000', 'consum', 0.0223, 'lps'),
	(602730, 127, '2014-04-01 01:03:15.000000', 'consum', 0.0227, 'lps'),
	(602731, 127, '2014-04-01 01:03:16.000000', 'consum', 0.0214, 'lps'),
	(602732, 127, '2014-04-01 01:03:17.000000', 'consum', 0.0223, 'lps'),
	(602733, 127, '2014-04-01 01:03:18.000000', 'consum', 0.0218, 'lps'),
	(602734, 127, '2014-04-01 01:03:19.000000', 'consum', 0.0210, 'lps'),
	(602735, 127, '2014-04-01 01:03:20.000000', 'consum', 0.0212, 'lps'),
	(602736, 127, '2014-04-01 01:03:21.000000', 'consum', 0.0221, 'lps'),
	(602737, 127, '2014-04-01 01:03:22.000000', 'consum', 0.0214, 'lps'),
	(602738, 127, '2014-04-01 01:03:23.000000', 'consum', 0.0218, 'lps'),
	(602739, 127, '2014-04-01 01:03:24.000000', 'consum', 0.0218, 'lps'),
	(602740, 127, '2014-04-01 01:03:25.000000', 'consum', 0.0225, 'lps'),
	(602741, 127, '2014-04-01 01:03:26.000000', 'consum', 0.0218, 'lps'),
	(602742, 127, '2014-04-01 01:03:27.000000', 'consum', 0.0227, 'lps'),
	(602743, 127, '2014-04-01 01:03:28.000000', 'consum', 0.0227, 'lps'),
	(602744, 127, '2014-04-01 01:03:29.000000', 'consum', 0.0222, 'lps'),
	(602745, 127, '2014-04-01 01:03:30.000000', 'consum', 0.0219, 'lps'),
	(602746, 127, '2014-04-01 01:03:31.000000', 'consum', 0.0222, 'lps'),
	(602747, 127, '2014-04-01 01:03:32.000000', 'consum', 0.0222, 'lps'),
	(602748, 127, '2014-04-01 01:03:33.000000', 'consum', 0.0212, 'lps'),
	(602749, 127, '2014-04-01 01:03:34.000000', 'consum', 0.0230, 'lps'),
	(602750, 127, '2014-04-01 01:03:35.000000', 'consum', 0.0214, 'lps'),
	(602751, 127, '2014-04-01 01:03:36.000000', 'consum', 0.0216, 'lps'),
	(602752, 127, '2014-04-01 01:03:37.000000', 'consum', 0.0228, 'lps'),
	(602753, 127, '2014-04-01 01:03:38.000000', 'consum', 0.0215, 'lps'),
	(602754, 127, '2014-04-01 01:03:39.000000', 'consum', 0.0226, 'lps'),
	(602755, 127, '2014-04-01 01:03:40.000000', 'consum', 0.0211, 'lps'),
	(602756, 127, '2014-04-01 01:03:41.000000', 'consum', 0.0211, 'lps'),
	(602757, 127, '2014-04-01 01:03:42.000000', 'consum', 0.0211, 'lps'),
	(602758, 127, '2014-04-01 01:03:43.000000', 'consum', 0.0214, 'lps'),
	(602759, 127, '2014-04-01 01:03:44.000000', 'consum', 0.0225, 'lps'),
	(602760, 127, '2014-04-01 01:03:45.000000', 'consum', 0.0231, 'lps'),
	(602761, 127, '2014-04-01 01:03:46.000000', 'consum', 0.0225, 'lps'),
	(602762, 127, '2014-04-01 01:03:47.000000', 'consum', 0.0225, 'lps'),
	(602763, 127, '2014-04-01 01:03:48.000000', 'consum', 0.0220, 'lps'),
	(602764, 127, '2014-04-01 01:03:49.000000', 'consum', 0.0212, 'lps'),
	(602765, 127, '2014-04-01 01:03:50.000000', 'consum', 0.0213, 'lps'),
	(602766, 127, '2014-04-01 01:03:51.000000', 'consum', 0.0220, 'lps'),
	(602767, 127, '2014-04-01 01:03:52.000000', 'consum', 0.0230, 'lps'),
	(602768, 127, '2014-04-01 01:03:53.000000', 'consum', 0.0216, 'lps'),
	(602769, 127, '2014-04-01 01:03:54.000000', 'consum', 0.0222, 'lps'),
	(602770, 127, '2014-04-01 01:03:55.000000', 'consum', 0.0210, 'lps'),
	(602771, 127, '2014-04-01 01:03:56.000000', 'consum', 0.0218, 'lps'),
	(602772, 127, '2014-04-01 01:03:57.000000', 'consum', 0.0227, 'lps'),
	(602773, 127, '2014-04-01 01:03:58.000000', 'consum', 0.0230, 'lps'),
	(602774, 127, '2014-04-01 01:03:59.000000', 'consum', 0.0216, 'lps'),
	(602775, 127, '2014-04-01 01:04:00.000000', 'consum', 0.0222, 'lps'),
	(602776, 127, '2014-04-01 01:04:01.000000', 'consum', 0.0211, 'lps'),
	(602777, 127, '2014-04-01 01:04:02.000000', 'consum', 0.0223, 'lps'),
	(602778, 127, '2014-04-01 01:04:03.000000', 'consum', 0.0227, 'lps'),
	(602779, 127, '2014-04-01 01:04:04.000000', 'consum', 0.0215, 'lps'),
	(602780, 127, '2014-04-01 01:04:05.000000', 'consum', 0.0225, 'lps'),
	(602781, 127, '2014-04-01 01:04:06.000000', 'consum', 0.0229, 'lps'),
	(602782, 127, '2014-04-01 01:04:07.000000', 'consum', 0.0216, 'lps'),
	(602783, 127, '2014-04-01 01:04:08.000000', 'consum', 0.0227, 'lps'),
	(602784, 127, '2014-04-01 01:04:09.000000', 'consum', 0.0214, 'lps'),
	(602785, 127, '2014-04-01 01:04:10.000000', 'consum', 0.0221, 'lps'),
	(602786, 127, '2014-04-01 01:04:11.000000', 'consum', 0.0231, 'lps'),
	(602787, 127, '2014-04-01 01:04:12.000000', 'consum', 0.0217, 'lps'),
	(602788, 127, '2014-04-01 01:04:13.000000', 'consum', 0.0225, 'lps'),
	(602789, 127, '2014-04-01 01:04:14.000000', 'consum', 0.0223, 'lps'),
	(602790, 127, '2014-04-01 01:04:15.000000', 'consum', 0.0230, 'lps'),
	(602791, 127, '2014-04-01 01:04:16.000000', 'consum', 0.0227, 'lps'),
	(602792, 127, '2014-04-01 01:04:17.000000', 'consum', 0.0214, 'lps'),
	(602793, 127, '2014-04-01 01:04:18.000000', 'consum', 0.0222, 'lps'),
	(602794, 127, '2014-04-01 01:04:19.000000', 'consum', 0.0216, 'lps'),
	(602795, 127, '2014-04-01 01:04:20.000000', 'consum', 0.0226, 'lps'),
	(602796, 127, '2014-04-01 01:04:21.000000', 'consum', 0.0228, 'lps'),
	(602797, 127, '2014-04-01 01:04:22.000000', 'consum', 0.0211, 'lps'),
	(602798, 127, '2014-04-01 01:04:23.000000', 'consum', 0.0226, 'lps'),
	(602799, 127, '2014-04-01 01:04:24.000000', 'consum', 0.0221, 'lps'),
	(602800, 127, '2014-04-01 01:04:25.000000', 'consum', 0.0218, 'lps'),
	(602801, 127, '2014-04-01 01:04:26.000000', 'consum', 0.0219, 'lps'),
	(602802, 127, '2014-04-01 01:04:27.000000', 'consum', 0.0228, 'lps'),
	(602803, 127, '2014-04-01 01:04:28.000000', 'consum', 0.0211, 'lps'),
	(602804, 127, '2014-04-01 01:04:29.000000', 'consum', 0.0227, 'lps'),
	(602805, 127, '2014-04-01 01:04:30.000000', 'consum', 0.0225, 'lps'),
	(602806, 127, '2014-04-01 01:04:31.000000', 'consum', 0.0213, 'lps'),
	(602807, 127, '2014-04-01 01:04:32.000000', 'consum', 0.0226, 'lps'),
	(602808, 127, '2014-04-01 01:04:33.000000', 'consum', 0.0215, 'lps'),
	(602809, 127, '2014-04-01 01:04:34.000000', 'consum', 0.0210, 'lps'),
	(602810, 127, '2014-04-01 01:04:35.000000', 'consum', 0.0216, 'lps'),
	(602811, 127, '2014-04-01 01:04:36.000000', 'consum', 0.0220, 'lps'),
	(602812, 127, '2014-04-01 01:04:37.000000', 'consum', 0.0221, 'lps'),
	(602813, 127, '2014-04-01 01:04:38.000000', 'consum', 0.0212, 'lps'),
	(602814, 127, '2014-04-01 01:04:39.000000', 'consum', 0.0210, 'lps'),
	(602815, 127, '2014-04-01 01:04:40.000000', 'consum', 0.0226, 'lps'),
	(602816, 127, '2014-04-01 01:04:41.000000', 'consum', 0.0223, 'lps'),
	(602817, 127, '2014-04-01 01:04:42.000000', 'consum', 0.0229, 'lps'),
	(602818, 127, '2014-04-01 01:04:43.000000', 'consum', 0.0223, 'lps'),
	(602819, 127, '2014-04-01 01:04:44.000000', 'consum', 0.0219, 'lps'),
	(602820, 127, '2014-04-01 01:04:45.000000', 'consum', 0.0214, 'lps'),
	(602821, 127, '2014-04-01 01:04:46.000000', 'consum', 0.0227, 'lps'),
	(602822, 127, '2014-04-01 01:04:47.000000', 'consum', 0.0217, 'lps'),
	(602823, 127, '2014-04-01 01:04:48.000000', 'consum', 0.0216, 'lps'),
	(602824, 127, '2014-04-01 01:04:49.000000', 'consum', 0.0221, 'lps'),
	(602825, 127, '2014-04-01 01:04:50.000000', 'consum', 0.0224, 'lps'),
	(602826, 127, '2014-04-01 01:04:51.000000', 'consum', 0.0227, 'lps'),
	(602827, 127, '2014-04-01 01:04:52.000000', 'consum', 0.0211, 'lps'),
	(602828, 127, '2014-04-01 01:04:53.000000', 'consum', 0.0229, 'lps'),
	(602829, 127, '2014-04-01 01:04:54.000000', 'consum', 0.0214, 'lps'),
	(602830, 127, '2014-04-01 01:04:55.000000', 'consum', 0.0216, 'lps'),
	(602831, 127, '2014-04-01 01:04:56.000000', 'consum', 0.0229, 'lps'),
	(602832, 127, '2014-04-01 01:04:57.000000', 'consum', 0.0224, 'lps'),
	(602833, 127, '2014-04-01 01:04:58.000000', 'consum', 0.0221, 'lps'),
	(602834, 127, '2014-04-01 01:04:59.000000', 'consum', 0.0225, 'lps'),
	(602835, 127, '2014-04-01 01:05:00.000000', 'consum', 0.0231, 'lps'),
	(602836, 127, '2014-04-01 01:05:01.000000', 'consum', 0.0227, 'lps'),
	(602837, 127, '2014-04-01 01:05:02.000000', 'consum', 0.0210, 'lps'),
	(602838, 127, '2014-04-01 01:05:03.000000', 'consum', 0.0226, 'lps'),
	(602839, 127, '2014-04-01 01:05:04.000000', 'consum', 0.0223, 'lps'),
	(602840, 127, '2014-04-01 01:05:05.000000', 'consum', 0.0230, 'lps'),
	(602841, 127, '2014-04-01 01:05:06.000000', 'consum', 0.0226, 'lps'),
	(602842, 127, '2014-04-01 01:05:07.000000', 'consum', 0.0229, 'lps'),
	(602843, 127, '2014-04-01 01:05:08.000000', 'consum', 0.0215, 'lps'),
	(602844, 127, '2014-04-01 01:05:09.000000', 'consum', 0.0223, 'lps'),
	(602845, 127, '2014-04-01 01:05:10.000000', 'consum', 0.0216, 'lps'),
	(602846, 127, '2014-04-01 01:05:11.000000', 'consum', 0.0222, 'lps'),
	(602847, 127, '2014-04-01 01:05:12.000000', 'consum', 0.0212, 'lps'),
	(602848, 127, '2014-04-01 01:05:13.000000', 'consum', 0.0225, 'lps'),
	(602849, 127, '2014-04-01 01:05:14.000000', 'consum', 0.0214, 'lps'),
	(602850, 127, '2014-04-01 01:05:15.000000', 'consum', 0.0231, 'lps'),
	(602851, 127, '2014-04-01 01:05:16.000000', 'consum', 0.0215, 'lps'),
	(602852, 127, '2014-04-01 01:05:17.000000', 'consum', 0.0217, 'lps'),
	(602853, 127, '2014-04-01 01:05:18.000000', 'consum', 0.0231, 'lps'),
	(602854, 127, '2014-04-01 01:05:19.000000', 'consum', 0.0228, 'lps'),
	(602855, 127, '2014-04-01 01:05:20.000000', 'consum', 0.0214, 'lps'),
	(602856, 127, '2014-04-01 01:05:21.000000', 'consum', 0.0220, 'lps'),
	(602857, 127, '2014-04-01 01:05:22.000000', 'consum', 0.0226, 'lps'),
	(602858, 127, '2014-04-01 01:05:23.000000', 'consum', 0.0219, 'lps'),
	(602859, 127, '2014-04-01 01:05:24.000000', 'consum', 0.0229, 'lps'),
	(602860, 127, '2014-04-01 01:05:25.000000', 'consum', 0.0210, 'lps'),
	(602861, 127, '2014-04-01 01:05:26.000000', 'consum', 0.0221, 'lps'),
	(602862, 127, '2014-04-01 01:05:27.000000', 'consum', 0.0223, 'lps'),
	(602863, 127, '2014-04-01 01:05:28.000000', 'consum', 0.0218, 'lps'),
	(602864, 127, '2014-04-01 01:05:29.000000', 'consum', 0.0213, 'lps'),
	(602865, 127, '2014-04-01 01:05:30.000000', 'consum', 0.0223, 'lps'),
	(602866, 127, '2014-04-01 01:05:31.000000', 'consum', 0.0223, 'lps'),
	(602867, 127, '2014-04-01 01:05:32.000000', 'consum', 0.0213, 'lps'),
	(602868, 127, '2014-04-01 01:05:33.000000', 'consum', 0.0230, 'lps'),
	(602869, 127, '2014-04-01 01:05:34.000000', 'consum', 0.0216, 'lps'),
	(602870, 127, '2014-04-01 01:05:35.000000', 'consum', 0.0225, 'lps'),
	(602871, 127, '2014-04-01 01:05:36.000000', 'consum', 0.0222, 'lps'),
	(602872, 127, '2014-04-01 01:05:37.000000', 'consum', 0.0227, 'lps'),
	(602873, 127, '2014-04-01 01:05:38.000000', 'consum', 0.0213, 'lps'),
	(602874, 127, '2014-04-01 01:05:39.000000', 'consum', 0.0221, 'lps'),
	(602875, 127, '2014-04-01 01:05:40.000000', 'consum', 0.0212, 'lps'),
	(602876, 127, '2014-04-01 01:05:41.000000', 'consum', 0.0210, 'lps'),
	(602877, 127, '2014-04-01 01:05:42.000000', 'consum', 0.0228, 'lps'),
	(602878, 127, '2014-04-01 01:05:43.000000', 'consum', 0.0231, 'lps'),
	(602879, 127, '2014-04-01 01:05:44.000000', 'consum', 0.0219, 'lps'),
	(602880, 127, '2014-04-01 01:05:45.000000', 'consum', 0.0213, 'lps'),
	(602881, 127, '2014-04-01 01:05:46.000000', 'consum', 0.0223, 'lps'),
	(602882, 127, '2014-04-01 01:05:47.000000', 'consum', 0.0223, 'lps'),
	(602883, 127, '2014-04-01 01:05:48.000000', 'consum', 0.0214, 'lps'),
	(602884, 127, '2014-04-01 01:05:49.000000', 'consum', 0.0214, 'lps'),
	(602885, 127, '2014-04-01 01:05:50.000000', 'consum', 0.0218, 'lps'),
	(602886, 127, '2014-04-01 01:05:51.000000', 'consum', 0.0218, 'lps'),
	(602887, 127, '2014-04-01 01:05:52.000000', 'consum', 0.0225, 'lps'),
	(602888, 127, '2014-04-01 01:05:53.000000', 'consum', 0.0217, 'lps'),
	(602889, 127, '2014-04-01 01:05:54.000000', 'consum', 0.0222, 'lps'),
	(602890, 127, '2014-04-01 01:05:55.000000', 'consum', 0.0226, 'lps'),
	(602891, 127, '2014-04-01 01:05:56.000000', 'consum', 0.0213, 'lps'),
	(602892, 127, '2014-04-01 01:05:57.000000', 'consum', 0.0221, 'lps'),
	(602893, 127, '2014-04-01 01:05:58.000000', 'consum', 0.0214, 'lps'),
	(602894, 127, '2014-04-01 01:05:59.000000', 'consum', 0.0217, 'lps'),
	(602895, 127, '2014-04-01 01:06:00.000000', 'consum', 0.0213, 'lps'),
	(602896, 127, '2014-04-01 01:06:01.000000', 'consum', 0.0226, 'lps'),
	(602897, 127, '2014-04-01 01:06:02.000000', 'consum', 0.0217, 'lps'),
	(602898, 127, '2014-04-01 01:06:03.000000', 'consum', 0.0220, 'lps'),
	(602899, 127, '2014-04-01 01:06:04.000000', 'consum', 0.0216, 'lps'),
	(602900, 127, '2014-04-01 01:06:05.000000', 'consum', 0.0212, 'lps'),
	(602901, 127, '2014-04-01 01:06:06.000000', 'consum', 0.0225, 'lps'),
	(602902, 127, '2014-04-01 01:06:07.000000', 'consum', 0.0212, 'lps'),
	(602903, 127, '2014-04-01 01:06:08.000000', 'consum', 0.0221, 'lps'),
	(602904, 127, '2014-04-01 01:06:09.000000', 'consum', 0.0216, 'lps'),
	(602905, 127, '2014-04-01 01:06:10.000000', 'consum', 0.0231, 'lps'),
	(602906, 127, '2014-04-01 01:06:11.000000', 'consum', 0.0228, 'lps'),
	(602907, 127, '2014-04-01 01:06:12.000000', 'consum', 0.0216, 'lps'),
	(602908, 127, '2014-04-01 01:06:13.000000', 'consum', 0.0210, 'lps'),
	(602909, 127, '2014-04-01 01:06:14.000000', 'consum', 0.0212, 'lps'),
	(602910, 127, '2014-04-01 01:06:15.000000', 'consum', 0.0221, 'lps'),
	(602911, 127, '2014-04-01 01:06:16.000000', 'consum', 0.0217, 'lps'),
	(602912, 127, '2014-04-01 01:06:17.000000', 'consum', 0.0211, 'lps'),
	(602913, 127, '2014-04-01 01:06:18.000000', 'consum', 0.0219, 'lps'),
	(602914, 127, '2014-04-01 01:06:19.000000', 'consum', 0.0228, 'lps'),
	(602915, 127, '2014-04-01 01:06:20.000000', 'consum', 0.0231, 'lps'),
	(602916, 127, '2014-04-01 01:06:21.000000', 'consum', 0.0216, 'lps'),
	(602917, 127, '2014-04-01 01:06:22.000000', 'consum', 0.0224, 'lps'),
	(602918, 127, '2014-04-01 01:06:23.000000', 'consum', 0.0218, 'lps'),
	(602919, 127, '2014-04-01 01:06:24.000000', 'consum', 0.0230, 'lps'),
	(602920, 127, '2014-04-01 01:06:25.000000', 'consum', 0.0222, 'lps'),
	(602921, 127, '2014-04-01 01:06:26.000000', 'consum', 0.0231, 'lps'),
	(602922, 127, '2014-04-01 01:06:27.000000', 'consum', 0.0214, 'lps'),
	(602923, 127, '2014-04-01 01:06:28.000000', 'consum', 0.0212, 'lps'),
	(602924, 127, '2014-04-01 01:06:29.000000', 'consum', 0.0231, 'lps'),
	(602925, 127, '2014-04-01 01:06:30.000000', 'consum', 0.0220, 'lps'),
	(602926, 127, '2014-04-01 01:06:31.000000', 'consum', 0.0218, 'lps'),
	(602927, 127, '2014-04-01 01:06:32.000000', 'consum', 0.0222, 'lps'),
	(602928, 127, '2014-04-01 01:06:33.000000', 'consum', 0.0226, 'lps'),
	(602929, 127, '2014-04-01 01:06:34.000000', 'consum', 0.0211, 'lps'),
	(602930, 127, '2014-04-01 01:06:35.000000', 'consum', 0.0212, 'lps'),
	(602931, 127, '2014-04-01 01:06:36.000000', 'consum', 0.0214, 'lps'),
	(602932, 127, '2014-04-01 01:06:37.000000', 'consum', 0.0228, 'lps'),
	(602933, 127, '2014-04-01 01:06:38.000000', 'consum', 0.0221, 'lps'),
	(602934, 127, '2014-04-01 01:06:39.000000', 'consum', 0.0211, 'lps'),
	(602935, 127, '2014-04-01 01:06:40.000000', 'consum', 0.0226, 'lps'),
	(602936, 127, '2014-04-01 01:06:41.000000', 'consum', 0.0223, 'lps'),
	(602937, 127, '2014-04-01 01:06:42.000000', 'consum', 0.0226, 'lps'),
	(602938, 127, '2014-04-01 01:06:43.000000', 'consum', 0.0229, 'lps'),
	(602939, 127, '2014-04-01 01:06:44.000000', 'consum', 0.0212, 'lps'),
	(602940, 127, '2014-04-01 01:06:45.000000', 'consum', 0.0210, 'lps'),
	(602941, 127, '2014-04-01 01:06:46.000000', 'consum', 0.0226, 'lps'),
	(602942, 127, '2014-04-01 01:06:47.000000', 'consum', 0.0225, 'lps'),
	(602943, 127, '2014-04-01 01:06:48.000000', 'consum', 0.0216, 'lps'),
	(602944, 127, '2014-04-01 01:06:49.000000', 'consum', 0.0216, 'lps'),
	(602945, 127, '2014-04-01 01:06:50.000000', 'consum', 0.0221, 'lps'),
	(602946, 127, '2014-04-01 01:06:51.000000', 'consum', 0.0228, 'lps'),
	(602947, 127, '2014-04-01 01:06:52.000000', 'consum', 0.0224, 'lps'),
	(602948, 127, '2014-04-01 01:06:53.000000', 'consum', 0.0228, 'lps'),
	(602949, 127, '2014-04-01 01:06:54.000000', 'consum', 0.0212, 'lps'),
	(602950, 127, '2014-04-01 01:06:55.000000', 'consum', 0.0210, 'lps'),
	(602951, 127, '2014-04-01 01:06:56.000000', 'consum', 0.0227, 'lps'),
	(602952, 127, '2014-04-01 01:06:57.000000', 'consum', 0.0229, 'lps'),
	(602953, 127, '2014-04-01 01:06:58.000000', 'consum', 0.0212, 'lps'),
	(602954, 127, '2014-04-01 01:06:59.000000', 'consum', 0.0230, 'lps'),
	(602955, 127, '2014-04-01 01:07:00.000000', 'consum', 0.0214, 'lps'),
	(602956, 127, '2014-04-01 01:07:01.000000', 'consum', 0.0215, 'lps'),
	(602957, 127, '2014-04-01 01:07:02.000000', 'consum', 0.0223, 'lps'),
	(602958, 127, '2014-04-01 01:07:03.000000', 'consum', 0.0217, 'lps'),
	(602959, 127, '2014-04-01 01:07:04.000000', 'consum', 0.0229, 'lps'),
	(602960, 127, '2014-04-01 01:07:05.000000', 'consum', 0.0216, 'lps'),
	(602961, 127, '2014-04-01 01:07:06.000000', 'consum', 0.0231, 'lps'),
	(602962, 127, '2014-04-01 01:07:07.000000', 'consum', 0.0229, 'lps'),
	(602963, 127, '2014-04-01 01:07:08.000000', 'consum', 0.0220, 'lps'),
	(602964, 127, '2014-04-01 01:07:09.000000', 'consum', 0.0224, 'lps'),
	(602965, 127, '2014-04-01 01:07:10.000000', 'consum', 0.0210, 'lps'),
	(602966, 127, '2014-04-01 01:07:11.000000', 'consum', 0.0211, 'lps'),
	(602967, 127, '2014-04-01 01:07:12.000000', 'consum', 0.0215, 'lps'),
	(602968, 127, '2014-04-01 01:07:13.000000', 'consum', 0.0211, 'lps'),
	(602969, 127, '2014-04-01 01:07:14.000000', 'consum', 0.0222, 'lps'),
	(602970, 127, '2014-04-01 01:07:15.000000', 'consum', 0.0225, 'lps'),
	(602971, 127, '2014-04-01 01:07:16.000000', 'consum', 0.0228, 'lps'),
	(602972, 127, '2014-04-01 01:07:17.000000', 'consum', 0.0210, 'lps'),
	(602973, 127, '2014-04-01 01:07:18.000000', 'consum', 0.0223, 'lps'),
	(602974, 127, '2014-04-01 01:07:19.000000', 'consum', 0.0230, 'lps'),
	(602975, 127, '2014-04-01 01:07:20.000000', 'consum', 0.0229, 'lps'),
	(602976, 127, '2014-04-01 01:07:21.000000', 'consum', 0.0222, 'lps'),
	(602977, 127, '2014-04-01 01:07:22.000000', 'consum', 0.0215, 'lps'),
	(602978, 127, '2014-04-01 01:07:23.000000', 'consum', 0.0222, 'lps'),
	(602979, 127, '2014-04-01 01:07:24.000000', 'consum', 0.0231, 'lps'),
	(602980, 127, '2014-04-01 01:07:25.000000', 'consum', 0.0215, 'lps'),
	(602981, 127, '2014-04-01 01:07:26.000000', 'consum', 0.0217, 'lps'),
	(602982, 127, '2014-04-01 01:07:27.000000', 'consum', 0.0229, 'lps'),
	(602983, 127, '2014-04-01 01:07:28.000000', 'consum', 0.0219, 'lps'),
	(602984, 127, '2014-04-01 01:07:29.000000', 'consum', 0.0222, 'lps'),
	(602985, 127, '2014-04-01 01:07:30.000000', 'consum', 0.0222, 'lps'),
	(602986, 127, '2014-04-01 01:07:31.000000', 'consum', 0.0210, 'lps'),
	(602987, 127, '2014-04-01 01:07:32.000000', 'consum', 0.0218, 'lps'),
	(602988, 127, '2014-04-01 01:07:33.000000', 'consum', 0.0231, 'lps'),
	(602989, 127, '2014-04-01 01:07:34.000000', 'consum', 0.0223, 'lps'),
	(602990, 127, '2014-04-01 01:07:35.000000', 'consum', 0.0214, 'lps'),
	(602991, 127, '2014-04-01 01:07:36.000000', 'consum', 0.0211, 'lps'),
	(602992, 127, '2014-04-01 01:07:37.000000', 'consum', 0.0229, 'lps'),
	(602993, 127, '2014-04-01 01:07:38.000000', 'consum', 0.0212, 'lps'),
	(602994, 127, '2014-04-01 01:07:39.000000', 'consum', 0.0229, 'lps'),
	(602995, 127, '2014-04-01 01:07:40.000000', 'consum', 0.0211, 'lps'),
	(602996, 127, '2014-04-01 01:07:41.000000', 'consum', 0.0227, 'lps'),
	(602997, 127, '2014-04-01 01:07:42.000000', 'consum', 0.0227, 'lps'),
	(602998, 127, '2014-04-01 01:07:43.000000', 'consum', 0.0220, 'lps'),
	(602999, 127, '2014-04-01 01:07:44.000000', 'consum', 0.0211, 'lps'),
	(603000, 127, '2014-04-01 01:07:45.000000', 'consum', 0.0231, 'lps'),
	(603001, 127, '2014-04-01 01:07:46.000000', 'consum', 0.0221, 'lps'),
	(603002, 127, '2014-04-01 01:07:47.000000', 'consum', 0.0227, 'lps'),
	(603003, 127, '2014-04-01 01:07:48.000000', 'consum', 0.0219, 'lps'),
	(603004, 127, '2014-04-01 01:07:49.000000', 'consum', 0.0224, 'lps'),
	(603005, 127, '2014-04-01 01:07:50.000000', 'consum', 0.0210, 'lps'),
	(603006, 127, '2014-04-01 01:07:51.000000', 'consum', 0.0213, 'lps'),
	(603007, 127, '2014-04-01 01:07:52.000000', 'consum', 0.0223, 'lps'),
	(603008, 127, '2014-04-01 01:07:53.000000', 'consum', 0.0226, 'lps'),
	(603009, 127, '2014-04-01 01:07:54.000000', 'consum', 0.0227, 'lps'),
	(603010, 127, '2014-04-01 01:07:55.000000', 'consum', 0.0227, 'lps'),
	(603011, 127, '2014-04-01 01:07:56.000000', 'consum', 0.0222, 'lps'),
	(603012, 127, '2014-04-01 01:07:57.000000', 'consum', 0.0220, 'lps'),
	(603013, 127, '2014-04-01 01:07:58.000000', 'consum', 0.0223, 'lps'),
	(603014, 127, '2014-04-01 01:07:59.000000', 'consum', 0.0224, 'lps'),
	(603015, 127, '2014-04-01 01:08:00.000000', 'consum', 0.0219, 'lps'),
	(603016, 127, '2014-04-01 01:08:01.000000', 'consum', 0.0216, 'lps'),
	(603017, 127, '2014-04-01 01:08:02.000000', 'consum', 0.0210, 'lps'),
	(603018, 127, '2014-04-01 01:08:03.000000', 'consum', 0.0217, 'lps'),
	(603019, 127, '2014-04-01 01:08:04.000000', 'consum', 0.0224, 'lps'),
	(603020, 127, '2014-04-01 01:08:05.000000', 'consum', 0.0215, 'lps'),
	(603021, 127, '2014-04-01 01:08:06.000000', 'consum', 0.0215, 'lps'),
	(603022, 127, '2014-04-01 01:08:07.000000', 'consum', 0.0219, 'lps'),
	(603023, 127, '2014-04-01 01:08:08.000000', 'consum', 0.0220, 'lps'),
	(603024, 127, '2014-04-01 01:08:09.000000', 'consum', 0.0213, 'lps'),
	(603025, 127, '2014-04-01 01:08:10.000000', 'consum', 0.0217, 'lps'),
	(603026, 127, '2014-04-01 01:08:11.000000', 'consum', 0.0212, 'lps'),
	(603027, 127, '2014-04-01 01:08:12.000000', 'consum', 0.0224, 'lps'),
	(603028, 127, '2014-04-01 01:08:13.000000', 'consum', 0.0229, 'lps'),
	(603029, 127, '2014-04-01 01:08:14.000000', 'consum', 0.0220, 'lps'),
	(603030, 127, '2014-04-01 01:08:15.000000', 'consum', 0.0228, 'lps'),
	(603031, 127, '2014-04-01 01:08:16.000000', 'consum', 0.0223, 'lps'),
	(603032, 127, '2014-04-01 01:08:17.000000', 'consum', 0.0222, 'lps'),
	(603033, 127, '2014-04-01 01:08:18.000000', 'consum', 0.0231, 'lps'),
	(603034, 127, '2014-04-01 01:08:19.000000', 'consum', 0.0215, 'lps'),
	(603035, 127, '2014-04-01 01:08:20.000000', 'consum', 0.0214, 'lps'),
	(603036, 127, '2014-04-01 01:08:21.000000', 'consum', 0.0218, 'lps'),
	(603037, 127, '2014-04-01 01:08:22.000000', 'consum', 0.0214, 'lps'),
	(603038, 127, '2014-04-01 01:08:23.000000', 'consum', 0.0228, 'lps'),
	(603039, 127, '2014-04-01 01:08:24.000000', 'consum', 0.0223, 'lps'),
	(603040, 127, '2014-04-01 01:08:25.000000', 'consum', 0.0223, 'lps'),
	(603041, 127, '2014-04-01 01:08:26.000000', 'consum', 0.0214, 'lps'),
	(603042, 127, '2014-04-01 01:08:27.000000', 'consum', 0.0214, 'lps'),
	(603043, 127, '2014-04-01 01:08:28.000000', 'consum', 0.0218, 'lps'),
	(603044, 127, '2014-04-01 01:08:29.000000', 'consum', 0.0215, 'lps'),
	(603045, 127, '2014-04-01 01:08:30.000000', 'consum', 0.0212, 'lps'),
	(603046, 127, '2014-04-01 01:08:31.000000', 'consum', 0.0230, 'lps'),
	(603047, 127, '2014-04-01 01:08:32.000000', 'consum', 0.0213, 'lps'),
	(603048, 127, '2014-04-01 01:08:33.000000', 'consum', 0.0212, 'lps'),
	(603049, 127, '2014-04-01 01:08:34.000000', 'consum', 0.0210, 'lps'),
	(603050, 127, '2014-04-01 01:08:35.000000', 'consum', 0.0227, 'lps'),
	(603051, 127, '2014-04-01 01:08:36.000000', 'consum', 0.0229, 'lps'),
	(603052, 127, '2014-04-01 01:08:37.000000', 'consum', 0.0212, 'lps'),
	(603053, 127, '2014-04-01 01:08:38.000000', 'consum', 0.0231, 'lps'),
	(603054, 127, '2014-04-01 01:08:39.000000', 'consum', 0.0218, 'lps'),
	(603055, 127, '2014-04-01 01:08:40.000000', 'consum', 0.0210, 'lps'),
	(603056, 127, '2014-04-01 01:08:41.000000', 'consum', 0.0231, 'lps'),
	(603057, 127, '2014-04-01 01:08:42.000000', 'consum', 0.0226, 'lps'),
	(603058, 127, '2014-04-01 01:08:43.000000', 'consum', 0.0230, 'lps'),
	(603059, 127, '2014-04-01 01:08:44.000000', 'consum', 0.0217, 'lps'),
	(603060, 127, '2014-04-01 01:08:45.000000', 'consum', 0.0230, 'lps'),
	(603061, 127, '2014-04-01 01:08:46.000000', 'consum', 0.0223, 'lps'),
	(603062, 127, '2014-04-01 01:08:47.000000', 'consum', 0.0215, 'lps'),
	(603063, 127, '2014-04-01 01:08:48.000000', 'consum', 0.0221, 'lps'),
	(603064, 127, '2014-04-01 01:08:49.000000', 'consum', 0.0227, 'lps'),
	(603065, 127, '2014-04-01 01:08:50.000000', 'consum', 0.0220, 'lps'),
	(603066, 127, '2014-04-01 01:08:51.000000', 'consum', 0.0229, 'lps'),
	(603067, 127, '2014-04-01 01:08:52.000000', 'consum', 0.0210, 'lps'),
	(603068, 127, '2014-04-01 01:08:53.000000', 'consum', 0.0220, 'lps'),
	(603069, 127, '2014-04-01 01:08:54.000000', 'consum', 0.0216, 'lps'),
	(603070, 127, '2014-04-01 01:08:55.000000', 'consum', 0.0211, 'lps'),
	(603071, 127, '2014-04-01 01:08:56.000000', 'consum', 0.0220, 'lps'),
	(603072, 127, '2014-04-01 01:08:57.000000', 'consum', 0.0211, 'lps'),
	(603073, 127, '2014-04-01 01:08:58.000000', 'consum', 0.0211, 'lps'),
	(603074, 127, '2014-04-01 01:08:59.000000', 'consum', 0.0210, 'lps'),
	(603075, 127, '2014-04-01 01:09:00.000000', 'consum', 0.0230, 'lps'),
	(603076, 127, '2014-04-01 01:09:01.000000', 'consum', 0.0221, 'lps'),
	(603077, 127, '2014-04-01 01:09:02.000000', 'consum', 0.0230, 'lps'),
	(603078, 127, '2014-04-01 01:09:03.000000', 'consum', 0.0211, 'lps'),
	(603079, 127, '2014-04-01 01:09:04.000000', 'consum', 0.0222, 'lps'),
	(603080, 127, '2014-04-01 01:09:05.000000', 'consum', 0.0225, 'lps'),
	(603081, 127, '2014-04-01 01:09:06.000000', 'consum', 0.0226, 'lps'),
	(603082, 127, '2014-04-01 01:09:07.000000', 'consum', 0.0223, 'lps'),
	(603083, 127, '2014-04-01 01:09:08.000000', 'consum', 0.0227, 'lps'),
	(603084, 127, '2014-04-01 01:09:09.000000', 'consum', 0.0213, 'lps'),
	(603085, 127, '2014-04-01 01:09:10.000000', 'consum', 0.0221, 'lps'),
	(603086, 127, '2014-04-01 01:09:11.000000', 'consum', 0.0231, 'lps'),
	(603087, 127, '2014-04-01 01:09:12.000000', 'consum', 0.0218, 'lps'),
	(603088, 127, '2014-04-01 01:09:13.000000', 'consum', 0.0210, 'lps'),
	(603089, 127, '2014-04-01 01:09:14.000000', 'consum', 0.0231, 'lps'),
	(603090, 127, '2014-04-01 01:09:15.000000', 'consum', 0.0228, 'lps'),
	(603091, 127, '2014-04-01 01:09:16.000000', 'consum', 0.0216, 'lps'),
	(603092, 127, '2014-04-01 01:09:17.000000', 'consum', 0.0229, 'lps'),
	(603093, 127, '2014-04-01 01:09:18.000000', 'consum', 0.0222, 'lps'),
	(603094, 127, '2014-04-01 01:09:19.000000', 'consum', 0.0214, 'lps'),
	(603095, 127, '2014-04-01 01:09:20.000000', 'consum', 0.0218, 'lps'),
	(603096, 127, '2014-04-01 01:09:21.000000', 'consum', 0.0215, 'lps'),
	(603097, 127, '2014-04-01 01:09:22.000000', 'consum', 0.0212, 'lps'),
	(603098, 127, '2014-04-01 01:09:23.000000', 'consum', 0.0227, 'lps'),
	(603099, 127, '2014-04-01 01:09:24.000000', 'consum', 0.0224, 'lps'),
	(603100, 127, '2014-04-01 01:09:25.000000', 'consum', 0.0228, 'lps'),
	(603101, 127, '2014-04-01 01:09:26.000000', 'consum', 0.0215, 'lps'),
	(603102, 127, '2014-04-01 01:09:27.000000', 'consum', 0.0228, 'lps'),
	(603103, 127, '2014-04-01 01:09:28.000000', 'consum', 0.0217, 'lps'),
	(603104, 127, '2014-04-01 01:09:29.000000', 'consum', 0.0213, 'lps'),
	(603105, 127, '2014-04-01 01:09:30.000000', 'consum', 0.0226, 'lps'),
	(603106, 127, '2014-04-01 01:09:31.000000', 'consum', 0.0218, 'lps'),
	(603107, 127, '2014-04-01 01:09:32.000000', 'consum', 0.0221, 'lps'),
	(603108, 127, '2014-04-01 01:09:33.000000', 'consum', 0.0223, 'lps'),
	(603109, 127, '2014-04-01 01:09:34.000000', 'consum', 0.0218, 'lps'),
	(603110, 127, '2014-04-01 01:09:35.000000', 'consum', 0.0213, 'lps'),
	(603111, 127, '2014-04-01 01:09:36.000000', 'consum', 0.0221, 'lps'),
	(603112, 127, '2014-04-01 01:09:37.000000', 'consum', 0.0214, 'lps'),
	(603113, 127, '2014-04-01 01:09:38.000000', 'consum', 0.0218, 'lps'),
	(603114, 127, '2014-04-01 01:09:39.000000', 'consum', 0.0218, 'lps'),
	(603115, 127, '2014-04-01 01:09:40.000000', 'consum', 0.0227, 'lps'),
	(603116, 127, '2014-04-01 01:09:41.000000', 'consum', 0.0229, 'lps'),
	(603117, 127, '2014-04-01 01:09:42.000000', 'consum', 0.0230, 'lps'),
	(603118, 127, '2014-04-01 01:09:43.000000', 'consum', 0.0210, 'lps'),
	(603119, 127, '2014-04-01 01:09:44.000000', 'consum', 0.0216, 'lps'),
	(603120, 127, '2014-04-01 01:09:45.000000', 'consum', 0.0221, 'lps'),
	(603121, 127, '2014-04-01 01:09:46.000000', 'consum', 0.0223, 'lps'),
	(603122, 127, '2014-04-01 01:09:47.000000', 'consum', 0.0221, 'lps'),
	(603123, 127, '2014-04-01 01:09:48.000000', 'consum', 0.0228, 'lps'),
	(603124, 127, '2014-04-01 01:09:49.000000', 'consum', 0.0225, 'lps'),
	(603125, 127, '2014-04-01 01:09:50.000000', 'consum', 0.0229, 'lps'),
	(603126, 127, '2014-04-01 01:09:51.000000', 'consum', 0.0215, 'lps'),
	(603127, 127, '2014-04-01 01:09:52.000000', 'consum', 0.0225, 'lps'),
	(603128, 127, '2014-04-01 01:09:53.000000', 'consum', 0.0228, 'lps'),
	(603129, 127, '2014-04-01 01:09:54.000000', 'consum', 0.0210, 'lps'),
	(603130, 127, '2014-04-01 01:09:55.000000', 'consum', 0.0221, 'lps'),
	(603131, 127, '2014-04-01 01:09:56.000000', 'consum', 0.0221, 'lps'),
	(603132, 127, '2014-04-01 01:09:57.000000', 'consum', 0.0210, 'lps'),
	(603133, 127, '2014-04-01 01:09:58.000000', 'consum', 0.0223, 'lps'),
	(603134, 127, '2014-04-01 01:09:59.000000', 'consum', 0.0230, 'lps'),
	(603135, 127, '2014-04-01 01:10:00.000000', 'consum', 0.0228, 'lps'),
	(603136, 127, '2014-04-01 01:10:01.000000', 'consum', 0.0220, 'lps'),
	(603137, 127, '2014-04-01 01:10:02.000000', 'consum', 0.0227, 'lps'),
	(603138, 127, '2014-04-01 01:10:03.000000', 'consum', 0.0222, 'lps'),
	(603139, 127, '2014-04-01 01:10:04.000000', 'consum', 0.0218, 'lps'),
	(603140, 127, '2014-04-01 01:10:05.000000', 'consum', 0.0216, 'lps'),
	(603141, 127, '2014-04-01 01:10:06.000000', 'consum', 0.0217, 'lps'),
	(603142, 127, '2014-04-01 01:10:07.000000', 'consum', 0.0229, 'lps'),
	(603143, 127, '2014-04-01 01:10:08.000000', 'consum', 0.0216, 'lps'),
	(603144, 127, '2014-04-01 01:10:09.000000', 'consum', 0.0227, 'lps'),
	(603145, 127, '2014-04-01 01:10:10.000000', 'consum', 0.0214, 'lps'),
	(603146, 127, '2014-04-01 01:10:11.000000', 'consum', 0.0223, 'lps'),
	(603147, 127, '2014-04-01 01:10:12.000000', 'consum', 0.0217, 'lps'),
	(603148, 127, '2014-04-01 01:10:13.000000', 'consum', 0.0210, 'lps'),
	(603149, 127, '2014-04-01 01:10:14.000000', 'consum', 0.0231, 'lps'),
	(603150, 127, '2014-04-01 01:10:15.000000', 'consum', 0.0229, 'lps'),
	(603151, 127, '2014-04-01 01:10:16.000000', 'consum', 0.0219, 'lps'),
	(603152, 127, '2014-04-01 01:10:17.000000', 'consum', 0.0223, 'lps'),
	(603153, 127, '2014-04-01 01:10:18.000000', 'consum', 0.0226, 'lps'),
	(603154, 127, '2014-04-01 01:10:19.000000', 'consum', 0.0228, 'lps'),
	(603155, 127, '2014-04-01 01:10:20.000000', 'consum', 0.0229, 'lps'),
	(603156, 127, '2014-04-01 01:10:21.000000', 'consum', 0.0211, 'lps'),
	(603157, 127, '2014-04-01 01:10:22.000000', 'consum', 0.0224, 'lps'),
	(603158, 127, '2014-04-01 01:10:23.000000', 'consum', 0.0231, 'lps'),
	(603159, 127, '2014-04-01 01:10:24.000000', 'consum', 0.0230, 'lps'),
	(603160, 127, '2014-04-01 01:10:25.000000', 'consum', 0.0227, 'lps'),
	(603161, 127, '2014-04-01 01:10:26.000000', 'consum', 0.0214, 'lps'),
	(603162, 127, '2014-04-01 01:10:27.000000', 'consum', 0.0221, 'lps'),
	(603163, 127, '2014-04-01 01:10:28.000000', 'consum', 0.0211, 'lps'),
	(603164, 127, '2014-04-01 01:10:29.000000', 'consum', 0.0228, 'lps'),
	(603165, 127, '2014-04-01 01:10:30.000000', 'consum', 0.0231, 'lps'),
	(603166, 127, '2014-04-01 01:10:31.000000', 'consum', 0.0219, 'lps'),
	(603167, 127, '2014-04-01 01:10:32.000000', 'consum', 0.0212, 'lps'),
	(603168, 127, '2014-04-01 01:10:33.000000', 'consum', 0.0215, 'lps'),
	(603169, 127, '2014-04-01 01:10:34.000000', 'consum', 0.0231, 'lps'),
	(603170, 127, '2014-04-01 01:10:35.000000', 'consum', 0.0211, 'lps'),
	(603171, 127, '2014-04-01 01:10:36.000000', 'consum', 0.0220, 'lps'),
	(603172, 127, '2014-04-01 01:10:37.000000', 'consum', 0.0215, 'lps'),
	(603173, 127, '2014-04-01 01:10:38.000000', 'consum', 0.0225, 'lps'),
	(603174, 127, '2014-04-01 01:10:39.000000', 'consum', 0.0228, 'lps'),
	(603175, 127, '2014-04-01 01:10:40.000000', 'consum', 0.0210, 'lps'),
	(603176, 127, '2014-04-01 01:10:41.000000', 'consum', 0.0223, 'lps'),
	(603177, 127, '2014-04-01 01:10:42.000000', 'consum', 0.0211, 'lps'),
	(603178, 127, '2014-04-01 01:10:43.000000', 'consum', 0.0220, 'lps'),
	(603179, 127, '2014-04-01 01:10:44.000000', 'consum', 0.0213, 'lps'),
	(603180, 127, '2014-04-01 01:10:45.000000', 'consum', 0.0217, 'lps'),
	(603181, 127, '2014-04-01 01:10:46.000000', 'consum', 0.0215, 'lps'),
	(603182, 127, '2014-04-01 01:10:47.000000', 'consum', 0.0213, 'lps'),
	(603183, 127, '2014-04-01 01:10:48.000000', 'consum', 0.0213, 'lps'),
	(603184, 127, '2014-04-01 01:10:49.000000', 'consum', 0.0215, 'lps'),
	(603185, 127, '2014-04-01 01:10:50.000000', 'consum', 0.0229, 'lps'),
	(603186, 127, '2014-04-01 01:10:51.000000', 'consum', 0.0221, 'lps'),
	(603187, 127, '2014-04-01 01:10:52.000000', 'consum', 0.0231, 'lps'),
	(603188, 127, '2014-04-01 01:10:53.000000', 'consum', 0.0219, 'lps'),
	(603189, 127, '2014-04-01 01:10:54.000000', 'consum', 0.0212, 'lps'),
	(603190, 127, '2014-04-01 01:10:55.000000', 'consum', 0.0217, 'lps'),
	(603191, 127, '2014-04-01 01:10:56.000000', 'consum', 0.0218, 'lps'),
	(603192, 127, '2014-04-01 01:10:57.000000', 'consum', 0.0230, 'lps'),
	(603193, 127, '2014-04-01 01:10:58.000000', 'consum', 0.0220, 'lps'),
	(603194, 127, '2014-04-01 01:10:59.000000', 'consum', 0.0220, 'lps'),
	(603195, 127, '2014-04-01 01:11:00.000000', 'consum', 0.0212, 'lps'),
	(603196, 127, '2014-04-01 01:11:01.000000', 'consum', 0.0212, 'lps'),
	(603197, 127, '2014-04-01 01:11:02.000000', 'consum', 0.0214, 'lps'),
	(603198, 127, '2014-04-01 01:11:03.000000', 'consum', 0.0226, 'lps'),
	(603199, 127, '2014-04-01 01:11:04.000000', 'consum', 0.0212, 'lps'),
	(603200, 127, '2014-04-01 01:11:05.000000', 'consum', 0.0218, 'lps'),
	(603201, 127, '2014-04-01 01:11:06.000000', 'consum', 0.0222, 'lps'),
	(603202, 127, '2014-04-01 01:11:07.000000', 'consum', 0.0223, 'lps'),
	(603203, 127, '2014-04-01 01:11:08.000000', 'consum', 0.0219, 'lps'),
	(603204, 127, '2014-04-01 01:11:09.000000', 'consum', 0.0214, 'lps'),
	(603205, 127, '2014-04-01 01:11:10.000000', 'consum', 0.0228, 'lps'),
	(603206, 127, '2014-04-01 01:11:11.000000', 'consum', 0.0223, 'lps'),
	(603207, 127, '2014-04-01 01:11:12.000000', 'consum', 0.0221, 'lps'),
	(603208, 127, '2014-04-01 01:11:13.000000', 'consum', 0.0225, 'lps'),
	(603209, 127, '2014-04-01 01:11:14.000000', 'consum', 0.0211, 'lps'),
	(603210, 127, '2014-04-01 01:11:15.000000', 'consum', 0.0211, 'lps'),
	(603211, 127, '2014-04-01 01:11:16.000000', 'consum', 0.0216, 'lps'),
	(603212, 127, '2014-04-01 01:11:17.000000', 'consum', 0.0213, 'lps'),
	(603213, 127, '2014-04-01 01:11:18.000000', 'consum', 0.0230, 'lps'),
	(603214, 127, '2014-04-01 01:11:19.000000', 'consum', 0.0212, 'lps'),
	(603215, 127, '2014-04-01 01:11:20.000000', 'consum', 0.0228, 'lps'),
	(603216, 127, '2014-04-01 01:11:21.000000', 'consum', 0.0226, 'lps'),
	(603217, 127, '2014-04-01 01:11:22.000000', 'consum', 0.0217, 'lps'),
	(603218, 127, '2014-04-01 01:11:23.000000', 'consum', 0.0219, 'lps'),
	(603219, 127, '2014-04-01 01:11:24.000000', 'consum', 0.0212, 'lps'),
	(603220, 127, '2014-04-01 01:11:25.000000', 'consum', 0.0214, 'lps'),
	(603221, 127, '2014-04-01 01:11:26.000000', 'consum', 0.0224, 'lps'),
	(603222, 127, '2014-04-01 01:11:27.000000', 'consum', 0.0227, 'lps'),
	(603223, 127, '2014-04-01 01:11:28.000000', 'consum', 0.0229, 'lps'),
	(603224, 127, '2014-04-01 01:11:29.000000', 'consum', 0.0212, 'lps'),
	(603225, 127, '2014-04-01 01:11:30.000000', 'consum', 0.0228, 'lps'),
	(603226, 127, '2014-04-01 01:11:31.000000', 'consum', 0.0231, 'lps'),
	(603227, 127, '2014-04-01 01:11:32.000000', 'consum', 0.0218, 'lps'),
	(603228, 127, '2014-04-01 01:11:33.000000', 'consum', 0.0231, 'lps'),
	(603229, 127, '2014-04-01 01:11:34.000000', 'consum', 0.0226, 'lps'),
	(603230, 127, '2014-04-01 01:11:35.000000', 'consum', 0.0225, 'lps'),
	(603231, 127, '2014-04-01 01:11:36.000000', 'consum', 0.0217, 'lps'),
	(603232, 127, '2014-04-01 01:11:37.000000', 'consum', 0.0224, 'lps'),
	(603233, 127, '2014-04-01 01:11:38.000000', 'consum', 0.0215, 'lps'),
	(603234, 127, '2014-04-01 01:11:39.000000', 'consum', 0.0213, 'lps'),
	(603235, 127, '2014-04-01 01:11:40.000000', 'consum', 0.0212, 'lps'),
	(603236, 127, '2014-04-01 01:11:41.000000', 'consum', 0.0213, 'lps'),
	(603237, 127, '2014-04-01 01:11:42.000000', 'consum', 0.0219, 'lps'),
	(603238, 127, '2014-04-01 01:11:43.000000', 'consum', 0.0225, 'lps'),
	(603239, 127, '2014-04-01 01:11:44.000000', 'consum', 0.0212, 'lps'),
	(603240, 127, '2014-04-01 01:11:45.000000', 'consum', 0.0222, 'lps'),
	(603241, 127, '2014-04-01 01:11:46.000000', 'consum', 0.0221, 'lps'),
	(603242, 127, '2014-04-01 01:11:47.000000', 'consum', 0.0228, 'lps'),
	(603243, 127, '2014-04-01 01:11:48.000000', 'consum', 0.0225, 'lps'),
	(603244, 127, '2014-04-01 01:11:49.000000', 'consum', 0.0211, 'lps'),
	(603245, 127, '2014-04-01 01:11:50.000000', 'consum', 0.0211, 'lps'),
	(603246, 127, '2014-04-01 01:11:51.000000', 'consum', 0.0215, 'lps'),
	(603247, 127, '2014-04-01 01:11:52.000000', 'consum', 0.0211, 'lps'),
	(603248, 127, '2014-04-01 01:11:53.000000', 'consum', 0.0220, 'lps'),
	(603249, 127, '2014-04-01 01:11:54.000000', 'consum', 0.0214, 'lps'),
	(603250, 127, '2014-04-01 01:11:55.000000', 'consum', 0.0221, 'lps'),
	(603251, 127, '2014-04-01 01:11:56.000000', 'consum', 0.0213, 'lps'),
	(603252, 127, '2014-04-01 01:11:57.000000', 'consum', 0.0212, 'lps'),
	(603253, 127, '2014-04-01 01:11:58.000000', 'consum', 0.0210, 'lps'),
	(603254, 127, '2014-04-01 01:11:59.000000', 'consum', 0.0230, 'lps'),
	(603255, 127, '2014-04-01 01:12:00.000000', 'consum', 0.0219, 'lps'),
	(603256, 127, '2014-04-01 01:12:01.000000', 'consum', 0.0219, 'lps'),
	(603257, 127, '2014-04-01 01:12:02.000000', 'consum', 0.0228, 'lps'),
	(603258, 127, '2014-04-01 01:12:03.000000', 'consum', 0.0230, 'lps'),
	(603259, 127, '2014-04-01 01:12:04.000000', 'consum', 0.0213, 'lps'),
	(603260, 127, '2014-04-01 01:12:05.000000', 'consum', 0.0229, 'lps'),
	(603261, 127, '2014-04-01 01:12:06.000000', 'consum', 0.0210, 'lps'),
	(603262, 127, '2014-04-01 01:12:07.000000', 'consum', 0.0219, 'lps'),
	(603263, 127, '2014-04-01 01:12:08.000000', 'consum', 0.0213, 'lps'),
	(603264, 127, '2014-04-01 01:12:09.000000', 'consum', 0.0221, 'lps'),
	(603265, 127, '2014-04-01 01:12:10.000000', 'consum', 0.0211, 'lps'),
	(603266, 127, '2014-04-01 01:12:11.000000', 'consum', 0.0225, 'lps'),
	(603267, 127, '2014-04-01 01:12:12.000000', 'consum', 0.0219, 'lps'),
	(603268, 127, '2014-04-01 01:12:13.000000', 'consum', 0.0231, 'lps'),
	(603269, 127, '2014-04-01 01:12:14.000000', 'consum', 0.0221, 'lps'),
	(603270, 127, '2014-04-01 01:12:15.000000', 'consum', 0.0227, 'lps'),
	(603271, 127, '2014-04-01 01:12:16.000000', 'consum', 0.0219, 'lps'),
	(603272, 127, '2014-04-01 01:12:17.000000', 'consum', 0.0227, 'lps'),
	(603273, 127, '2014-04-01 01:12:18.000000', 'consum', 0.0224, 'lps'),
	(603274, 127, '2014-04-01 01:12:19.000000', 'consum', 0.0230, 'lps'),
	(603275, 127, '2014-04-01 01:12:20.000000', 'consum', 0.0223, 'lps'),
	(603276, 127, '2014-04-01 01:12:21.000000', 'consum', 0.0217, 'lps'),
	(603277, 127, '2014-04-01 01:12:22.000000', 'consum', 0.0228, 'lps'),
	(603278, 127, '2014-04-01 01:12:23.000000', 'consum', 0.0211, 'lps'),
	(603279, 127, '2014-04-01 01:12:24.000000', 'consum', 0.0231, 'lps'),
	(603280, 127, '2014-04-01 01:12:25.000000', 'consum', 0.0223, 'lps'),
	(603281, 127, '2014-04-01 01:12:26.000000', 'consum', 0.0214, 'lps'),
	(603282, 127, '2014-04-01 01:12:27.000000', 'consum', 0.0212, 'lps'),
	(603283, 127, '2014-04-01 01:12:28.000000', 'consum', 0.0229, 'lps'),
	(603284, 127, '2014-04-01 01:12:29.000000', 'consum', 0.0213, 'lps'),
	(603285, 127, '2014-04-01 01:12:30.000000', 'consum', 0.0214, 'lps'),
	(603286, 127, '2014-04-01 01:12:31.000000', 'consum', 0.0221, 'lps'),
	(603287, 127, '2014-04-01 01:12:32.000000', 'consum', 0.0211, 'lps'),
	(603288, 127, '2014-04-01 01:12:33.000000', 'consum', 0.0225, 'lps'),
	(603289, 127, '2014-04-01 01:12:34.000000', 'consum', 0.0219, 'lps'),
	(603290, 127, '2014-04-01 01:12:35.000000', 'consum', 0.0230, 'lps'),
	(603291, 127, '2014-04-01 01:12:36.000000', 'consum', 0.0217, 'lps'),
	(603292, 127, '2014-04-01 01:12:37.000000', 'consum', 0.0229, 'lps'),
	(603293, 127, '2014-04-01 01:12:38.000000', 'consum', 0.0218, 'lps'),
	(603294, 127, '2014-04-01 01:12:39.000000', 'consum', 0.0217, 'lps'),
	(603295, 127, '2014-04-01 01:12:40.000000', 'consum', 0.0222, 'lps'),
	(603296, 127, '2014-04-01 01:12:41.000000', 'consum', 0.0228, 'lps'),
	(603297, 127, '2014-04-01 01:12:42.000000', 'consum', 0.0220, 'lps'),
	(603298, 127, '2014-04-01 01:12:43.000000', 'consum', 0.0228, 'lps'),
	(603299, 127, '2014-04-01 01:12:44.000000', 'consum', 0.0225, 'lps'),
	(603300, 127, '2014-04-01 01:12:45.000000', 'consum', 0.0211, 'lps'),
	(603301, 127, '2014-04-01 01:12:46.000000', 'consum', 0.0213, 'lps'),
	(603302, 127, '2014-04-01 01:12:47.000000', 'consum', 0.0225, 'lps'),
	(603303, 127, '2014-04-01 01:12:48.000000', 'consum', 0.0230, 'lps'),
	(603304, 127, '2014-04-01 01:12:49.000000', 'consum', 0.0222, 'lps'),
	(603305, 127, '2014-04-01 01:12:50.000000', 'consum', 0.0211, 'lps'),
	(603306, 127, '2014-04-01 01:12:51.000000', 'consum', 0.0222, 'lps'),
	(603307, 127, '2014-04-01 01:12:52.000000', 'consum', 0.0223, 'lps'),
	(603308, 127, '2014-04-01 01:12:53.000000', 'consum', 0.0218, 'lps'),
	(603309, 127, '2014-04-01 01:12:54.000000', 'consum', 0.0213, 'lps'),
	(603310, 127, '2014-04-01 01:12:55.000000', 'consum', 0.0221, 'lps'),
	(603311, 127, '2014-04-01 01:12:56.000000', 'consum', 0.0215, 'lps'),
	(603312, 127, '2014-04-01 01:12:57.000000', 'consum', 0.0223, 'lps'),
	(603313, 127, '2014-04-01 01:12:58.000000', 'consum', 0.0218, 'lps'),
	(603314, 127, '2014-04-01 01:12:59.000000', 'consum', 0.0211, 'lps'),
	(603315, 127, '2014-04-01 01:13:00.000000', 'consum', 0.0212, 'lps'),
	(603316, 127, '2014-04-01 01:13:01.000000', 'consum', 0.0216, 'lps'),
	(603317, 127, '2014-04-01 01:13:02.000000', 'consum', 0.0216, 'lps'),
	(603318, 127, '2014-04-01 01:13:03.000000', 'consum', 0.0222, 'lps'),
	(603319, 127, '2014-04-01 01:13:04.000000', 'consum', 0.0228, 'lps'),
	(603320, 127, '2014-04-01 01:13:05.000000', 'consum', 0.0223, 'lps'),
	(603321, 127, '2014-04-01 01:13:06.000000', 'consum', 0.0220, 'lps'),
	(603322, 127, '2014-04-01 01:13:07.000000', 'consum', 0.0223, 'lps'),
	(603323, 127, '2014-04-01 01:13:08.000000', 'consum', 0.0221, 'lps'),
	(603324, 127, '2014-04-01 01:13:09.000000', 'consum', 0.0226, 'lps'),
	(603325, 127, '2014-04-01 01:13:10.000000', 'consum', 0.0216, 'lps'),
	(603326, 127, '2014-04-01 01:13:11.000000', 'consum', 0.0214, 'lps'),
	(603327, 127, '2014-04-01 01:13:12.000000', 'consum', 0.0211, 'lps'),
	(603328, 127, '2014-04-01 01:13:13.000000', 'consum', 0.0227, 'lps'),
	(603329, 127, '2014-04-01 01:13:14.000000', 'consum', 0.0225, 'lps'),
	(603330, 127, '2014-04-01 01:13:15.000000', 'consum', 0.0211, 'lps'),
	(603331, 127, '2014-04-01 01:13:16.000000', 'consum', 0.0217, 'lps'),
	(603332, 127, '2014-04-01 01:13:17.000000', 'consum', 0.0221, 'lps'),
	(603333, 127, '2014-04-01 01:13:18.000000', 'consum', 0.0221, 'lps'),
	(603334, 127, '2014-04-01 01:13:19.000000', 'consum', 0.0210, 'lps'),
	(603335, 127, '2014-04-01 01:13:20.000000', 'consum', 0.0222, 'lps'),
	(603336, 127, '2014-04-01 01:13:21.000000', 'consum', 0.0227, 'lps'),
	(603337, 127, '2014-04-01 01:13:22.000000', 'consum', 0.0216, 'lps'),
	(603338, 127, '2014-04-01 01:13:23.000000', 'consum', 0.0211, 'lps'),
	(603339, 127, '2014-04-01 01:13:24.000000', 'consum', 0.0218, 'lps'),
	(603340, 127, '2014-04-01 01:13:25.000000', 'consum', 0.0228, 'lps'),
	(603341, 127, '2014-04-01 01:13:26.000000', 'consum', 0.0211, 'lps'),
	(603342, 127, '2014-04-01 01:13:27.000000', 'consum', 0.0225, 'lps'),
	(603343, 127, '2014-04-01 01:13:28.000000', 'consum', 0.0217, 'lps'),
	(603344, 127, '2014-04-01 01:13:29.000000', 'consum', 0.0224, 'lps'),
	(603345, 127, '2014-04-01 01:13:30.000000', 'consum', 0.0215, 'lps'),
	(603346, 127, '2014-04-01 01:13:31.000000', 'consum', 0.0214, 'lps'),
	(603347, 127, '2014-04-01 01:13:32.000000', 'consum', 0.0216, 'lps'),
	(603348, 127, '2014-04-01 01:13:33.000000', 'consum', 0.0227, 'lps'),
	(603349, 127, '2014-04-01 01:13:34.000000', 'consum', 0.0213, 'lps'),
	(603350, 127, '2014-04-01 01:13:35.000000', 'consum', 0.0216, 'lps'),
	(603351, 127, '2014-04-01 01:13:36.000000', 'consum', 0.0213, 'lps'),
	(603352, 127, '2014-04-01 01:13:37.000000', 'consum', 0.0229, 'lps'),
	(603353, 127, '2014-04-01 01:13:38.000000', 'consum', 0.0231, 'lps'),
	(603354, 127, '2014-04-01 01:13:39.000000', 'consum', 0.0212, 'lps'),
	(603355, 127, '2014-04-01 01:13:40.000000', 'consum', 0.0223, 'lps'),
	(603356, 127, '2014-04-01 01:13:41.000000', 'consum', 0.0228, 'lps'),
	(603357, 127, '2014-04-01 01:13:42.000000', 'consum', 0.0215, 'lps'),
	(603358, 127, '2014-04-01 01:13:43.000000', 'consum', 0.0225, 'lps'),
	(603359, 127, '2014-04-01 01:13:44.000000', 'consum', 0.0227, 'lps'),
	(603360, 127, '2014-04-01 01:13:45.000000', 'consum', 0.0231, 'lps'),
	(603361, 127, '2014-04-01 01:13:46.000000', 'consum', 0.0219, 'lps'),
	(603362, 127, '2014-04-01 01:13:47.000000', 'consum', 0.0215, 'lps'),
	(603363, 127, '2014-04-01 01:13:48.000000', 'consum', 0.0229, 'lps'),
	(603364, 127, '2014-04-01 01:13:49.000000', 'consum', 0.0227, 'lps'),
	(603365, 127, '2014-04-01 01:13:50.000000', 'consum', 0.0215, 'lps'),
	(603366, 127, '2014-04-01 01:13:51.000000', 'consum', 0.0229, 'lps'),
	(603367, 127, '2014-04-01 01:13:52.000000', 'consum', 0.0224, 'lps'),
	(603368, 127, '2014-04-01 01:13:53.000000', 'consum', 0.0225, 'lps'),
	(603369, 127, '2014-04-01 01:13:54.000000', 'consum', 0.0219, 'lps'),
	(603370, 127, '2014-04-01 01:13:55.000000', 'consum', 0.0211, 'lps'),
	(603371, 127, '2014-04-01 01:13:56.000000', 'consum', 0.0212, 'lps'),
	(603372, 127, '2014-04-01 01:13:57.000000', 'consum', 0.0216, 'lps'),
	(603373, 127, '2014-04-01 01:13:58.000000', 'consum', 0.0215, 'lps'),
	(603374, 127, '2014-04-01 01:13:59.000000', 'consum', 0.0214, 'lps'),
	(603375, 127, '2014-04-01 01:14:00.000000', 'consum', 0.0218, 'lps'),
	(603376, 127, '2014-04-01 01:14:01.000000', 'consum', 0.0214, 'lps'),
	(603377, 127, '2014-04-01 01:14:02.000000', 'consum', 0.0210, 'lps'),
	(603378, 127, '2014-04-01 01:14:03.000000', 'consum', 0.0218, 'lps'),
	(603379, 127, '2014-04-01 01:14:04.000000', 'consum', 0.0231, 'lps'),
	(603380, 127, '2014-04-01 01:14:05.000000', 'consum', 0.0222, 'lps'),
	(603381, 127, '2014-04-01 01:14:06.000000', 'consum', 0.0210, 'lps'),
	(603382, 127, '2014-04-01 01:14:07.000000', 'consum', 0.0217, 'lps'),
	(603383, 127, '2014-04-01 01:14:08.000000', 'consum', 0.0226, 'lps'),
	(603384, 127, '2014-04-01 01:14:09.000000', 'consum', 0.0224, 'lps'),
	(603385, 127, '2014-04-01 01:14:10.000000', 'consum', 0.0212, 'lps'),
	(603386, 127, '2014-04-01 01:14:11.000000', 'consum', 0.0223, 'lps'),
	(603387, 127, '2014-04-01 01:14:12.000000', 'consum', 0.0225, 'lps'),
	(603388, 127, '2014-04-01 01:14:13.000000', 'consum', 0.0224, 'lps'),
	(603389, 127, '2014-04-01 01:14:14.000000', 'consum', 0.0212, 'lps'),
	(603390, 127, '2014-04-01 01:14:15.000000', 'consum', 0.0225, 'lps'),
	(603391, 127, '2014-04-01 01:14:16.000000', 'consum', 0.0214, 'lps'),
	(603392, 127, '2014-04-01 01:14:17.000000', 'consum', 0.0227, 'lps'),
	(603393, 127, '2014-04-01 01:14:18.000000', 'consum', 0.0220, 'lps'),
	(603394, 127, '2014-04-01 01:14:19.000000', 'consum', 0.0210, 'lps'),
	(603395, 127, '2014-04-01 01:14:20.000000', 'consum', 0.0225, 'lps'),
	(603396, 127, '2014-04-01 01:14:21.000000', 'consum', 0.0217, 'lps'),
	(603397, 127, '2014-04-01 01:14:22.000000', 'consum', 0.0222, 'lps'),
	(603398, 127, '2014-04-01 01:14:23.000000', 'consum', 0.0227, 'lps'),
	(603399, 127, '2014-04-01 01:14:24.000000', 'consum', 0.0215, 'lps'),
	(603400, 127, '2014-04-01 01:14:25.000000', 'consum', 0.0228, 'lps'),
	(603401, 127, '2014-04-01 01:14:26.000000', 'consum', 0.0219, 'lps'),
	(603402, 127, '2014-04-01 01:14:27.000000', 'consum', 0.0223, 'lps'),
	(603403, 127, '2014-04-01 01:14:28.000000', 'consum', 0.0229, 'lps'),
	(603404, 127, '2014-04-01 01:14:29.000000', 'consum', 0.0223, 'lps'),
	(603405, 127, '2014-04-01 01:14:30.000000', 'consum', 0.0218, 'lps'),
	(603406, 127, '2014-04-01 01:14:31.000000', 'consum', 0.0212, 'lps'),
	(603407, 127, '2014-04-01 01:14:32.000000', 'consum', 0.0218, 'lps'),
	(603408, 127, '2014-04-01 01:14:33.000000', 'consum', 0.0224, 'lps'),
	(603409, 127, '2014-04-01 01:14:34.000000', 'consum', 0.0231, 'lps'),
	(603410, 127, '2014-04-01 01:14:35.000000', 'consum', 0.0211, 'lps'),
	(603411, 127, '2014-04-01 01:14:36.000000', 'consum', 0.0217, 'lps'),
	(603412, 127, '2014-04-01 01:14:37.000000', 'consum', 0.0222, 'lps'),
	(603413, 127, '2014-04-01 01:14:38.000000', 'consum', 0.0228, 'lps'),
	(603414, 127, '2014-04-01 01:14:39.000000', 'consum', 0.0221, 'lps'),
	(603415, 127, '2014-04-01 01:14:40.000000', 'consum', 0.0231, 'lps'),
	(603416, 127, '2014-04-01 01:14:41.000000', 'consum', 0.0216, 'lps'),
	(603417, 127, '2014-04-01 01:14:42.000000', 'consum', 0.0222, 'lps'),
	(603418, 127, '2014-04-01 01:14:43.000000', 'consum', 0.0210, 'lps'),
	(603419, 127, '2014-04-01 01:14:44.000000', 'consum', 0.0216, 'lps'),
	(603420, 127, '2014-04-01 01:14:45.000000', 'consum', 0.0220, 'lps'),
	(603421, 127, '2014-04-01 01:14:46.000000', 'consum', 0.0221, 'lps'),
	(603422, 127, '2014-04-01 01:14:47.000000', 'consum', 0.0213, 'lps'),
	(603423, 127, '2014-04-01 01:14:48.000000', 'consum', 0.0213, 'lps'),
	(603424, 127, '2014-04-01 01:14:49.000000', 'consum', 0.0216, 'lps'),
	(603425, 127, '2014-04-01 01:14:50.000000', 'consum', 0.0231, 'lps'),
	(603426, 127, '2014-04-01 01:14:51.000000', 'consum', 0.0211, 'lps'),
	(603427, 127, '2014-04-01 01:14:52.000000', 'consum', 0.0217, 'lps'),
	(603428, 127, '2014-04-01 01:14:53.000000', 'consum', 0.0219, 'lps'),
	(603429, 127, '2014-04-01 01:14:54.000000', 'consum', 0.0216, 'lps'),
	(603430, 127, '2014-04-01 01:14:55.000000', 'consum', 0.0211, 'lps'),
	(603431, 127, '2014-04-01 01:14:56.000000', 'consum', 0.0222, 'lps'),
	(603432, 127, '2014-04-01 01:14:57.000000', 'consum', 0.0223, 'lps'),
	(603433, 127, '2014-04-01 01:14:58.000000', 'consum', 0.0219, 'lps'),
	(603434, 127, '2014-04-01 01:14:59.000000', 'consum', 0.0214, 'lps'),
	(603435, 127, '2014-04-01 01:15:00.000000', 'consum', 0.0226, 'lps'),
	(603436, 127, '2014-04-01 01:15:01.000000', 'consum', 0.0215, 'lps'),
	(603437, 127, '2014-04-01 01:15:02.000000', 'consum', 0.0229, 'lps'),
	(603438, 127, '2014-04-01 01:15:03.000000', 'consum', 0.0225, 'lps'),
	(603439, 127, '2014-04-01 01:15:04.000000', 'consum', 0.0229, 'lps'),
	(603440, 127, '2014-04-01 01:15:05.000000', 'consum', 0.0214, 'lps'),
	(603441, 127, '2014-04-01 01:15:06.000000', 'consum', 0.0220, 'lps'),
	(603442, 127, '2014-04-01 01:15:07.000000', 'consum', 0.0227, 'lps'),
	(603443, 127, '2014-04-01 01:15:08.000000', 'consum', 0.0222, 'lps'),
	(603444, 127, '2014-04-01 01:15:09.000000', 'consum', 0.0218, 'lps'),
	(603445, 127, '2014-04-01 01:15:10.000000', 'consum', 0.0217, 'lps'),
	(603446, 127, '2014-04-01 01:15:11.000000', 'consum', 0.0219, 'lps'),
	(603447, 127, '2014-04-01 01:15:12.000000', 'consum', 0.0212, 'lps'),
	(603448, 127, '2014-04-01 01:15:13.000000', 'consum', 0.0215, 'lps'),
	(603449, 127, '2014-04-01 01:15:14.000000', 'consum', 0.0230, 'lps'),
	(603450, 127, '2014-04-01 01:15:15.000000', 'consum', 0.0230, 'lps'),
	(603451, 127, '2014-04-01 01:15:16.000000', 'consum', 0.0229, 'lps'),
	(603452, 127, '2014-04-01 01:15:17.000000', 'consum', 0.0222, 'lps'),
	(603453, 127, '2014-04-01 01:15:18.000000', 'consum', 0.0215, 'lps'),
	(603454, 127, '2014-04-01 01:15:19.000000', 'consum', 0.0221, 'lps'),
	(603455, 127, '2014-04-01 01:15:20.000000', 'consum', 0.0228, 'lps'),
	(603456, 127, '2014-04-01 01:15:21.000000', 'consum', 0.0223, 'lps'),
	(603457, 127, '2014-04-01 01:15:22.000000', 'consum', 0.0220, 'lps'),
	(603458, 127, '2014-04-01 01:15:23.000000', 'consum', 0.0224, 'lps'),
	(603459, 127, '2014-04-01 01:15:24.000000', 'consum', 0.0228, 'lps'),
	(603460, 127, '2014-04-01 01:15:25.000000', 'consum', 0.0215, 'lps'),
	(603461, 127, '2014-04-01 01:15:26.000000', 'consum', 0.0225, 'lps'),
	(603462, 127, '2014-04-01 01:15:27.000000', 'consum', 0.0228, 'lps'),
	(603463, 127, '2014-04-01 01:15:28.000000', 'consum', 0.0231, 'lps'),
	(603464, 127, '2014-04-01 01:15:29.000000', 'consum', 0.0219, 'lps'),
	(603465, 127, '2014-04-01 01:15:30.000000', 'consum', 0.0214, 'lps'),
	(603466, 127, '2014-04-01 01:15:31.000000', 'consum', 0.0224, 'lps'),
	(603467, 127, '2014-04-01 01:15:32.000000', 'consum', 0.0225, 'lps'),
	(603468, 127, '2014-04-01 01:15:33.000000', 'consum', 0.0223, 'lps'),
	(603469, 127, '2014-04-01 01:15:34.000000', 'consum', 0.0231, 'lps'),
	(603470, 127, '2014-04-01 01:15:35.000000', 'consum', 0.0230, 'lps'),
	(603471, 127, '2014-04-01 01:15:36.000000', 'consum', 0.0228, 'lps'),
	(603472, 127, '2014-04-01 01:15:37.000000', 'consum', 0.0217, 'lps'),
	(603473, 127, '2014-04-01 01:15:38.000000', 'consum', 0.0212, 'lps'),
	(603474, 127, '2014-04-01 01:15:39.000000', 'consum', 0.0224, 'lps'),
	(603475, 127, '2014-04-01 01:15:40.000000', 'consum', 0.0228, 'lps'),
	(603476, 127, '2014-04-01 01:15:41.000000', 'consum', 0.0218, 'lps'),
	(603477, 127, '2014-04-01 01:15:42.000000', 'consum', 0.0216, 'lps'),
	(603478, 127, '2014-04-01 01:15:43.000000', 'consum', 0.0217, 'lps'),
	(603479, 127, '2014-04-01 01:15:44.000000', 'consum', 0.0229, 'lps'),
	(603480, 127, '2014-04-01 01:15:45.000000', 'consum', 0.0216, 'lps'),
	(603481, 127, '2014-04-01 01:15:46.000000', 'consum', 0.0227, 'lps'),
	(603482, 127, '2014-04-01 01:15:47.000000', 'consum', 0.0213, 'lps'),
	(603483, 127, '2014-04-01 01:15:48.000000', 'consum', 0.0219, 'lps'),
	(603484, 127, '2014-04-01 01:15:49.000000', 'consum', 0.0225, 'lps'),
	(603485, 127, '2014-04-01 01:15:50.000000', 'consum', 0.0214, 'lps'),
	(603486, 127, '2014-04-01 01:15:51.000000', 'consum', 0.0228, 'lps'),
	(603487, 127, '2014-04-01 01:15:52.000000', 'consum', 0.0222, 'lps'),
	(603488, 127, '2014-04-01 01:15:53.000000', 'consum', 0.0218, 'lps'),
	(603489, 127, '2014-04-01 01:15:54.000000', 'consum', 0.0214, 'lps'),
	(603490, 127, '2014-04-01 01:15:55.000000', 'consum', 0.0231, 'lps'),
	(603491, 127, '2014-04-01 01:15:56.000000', 'consum', 0.0212, 'lps'),
	(603492, 127, '2014-04-01 01:15:57.000000', 'consum', 0.0226, 'lps'),
	(603493, 127, '2014-04-01 01:15:58.000000', 'consum', 0.0216, 'lps'),
	(603494, 127, '2014-04-01 01:15:59.000000', 'consum', 0.0214, 'lps'),
	(603495, 127, '2014-04-01 01:16:00.000000', 'consum', 0.0215, 'lps'),
	(603496, 127, '2014-04-01 01:16:01.000000', 'consum', 0.0222, 'lps'),
	(603497, 127, '2014-04-01 01:16:02.000000', 'consum', 0.0210, 'lps'),
	(603498, 127, '2014-04-01 01:16:03.000000', 'consum', 0.0220, 'lps'),
	(603499, 127, '2014-04-01 01:16:04.000000', 'consum', 0.0217, 'lps'),
	(603500, 127, '2014-04-01 01:16:05.000000', 'consum', 0.0215, 'lps'),
	(603501, 127, '2014-04-01 01:16:06.000000', 'consum', 0.0214, 'lps'),
	(603502, 127, '2014-04-01 01:16:07.000000', 'consum', 0.0214, 'lps'),
	(603503, 127, '2014-04-01 01:16:08.000000', 'consum', 0.0220, 'lps'),
	(603504, 127, '2014-04-01 01:16:09.000000', 'consum', 0.0224, 'lps'),
	(603505, 127, '2014-04-01 01:16:10.000000', 'consum', 0.0210, 'lps'),
	(603506, 127, '2014-04-01 01:16:11.000000', 'consum', 0.0210, 'lps'),
	(603507, 127, '2014-04-01 01:16:12.000000', 'consum', 0.0211, 'lps'),
	(603508, 127, '2014-04-01 01:16:13.000000', 'consum', 0.0216, 'lps'),
	(603509, 127, '2014-04-01 01:16:14.000000', 'consum', 0.0216, 'lps'),
	(603510, 127, '2014-04-01 01:16:15.000000', 'consum', 0.0223, 'lps'),
	(603511, 127, '2014-04-01 01:16:16.000000', 'consum', 0.0215, 'lps'),
	(603512, 127, '2014-04-01 01:16:17.000000', 'consum', 0.0215, 'lps'),
	(603513, 127, '2014-04-01 01:16:18.000000', 'consum', 0.0223, 'lps'),
	(603514, 127, '2014-04-01 01:16:19.000000', 'consum', 0.0218, 'lps'),
	(603515, 127, '2014-04-01 01:16:20.000000', 'consum', 0.0230, 'lps'),
	(603516, 127, '2014-04-01 01:16:21.000000', 'consum', 0.0223, 'lps'),
	(603517, 127, '2014-04-01 01:16:22.000000', 'consum', 0.0214, 'lps'),
	(603518, 127, '2014-04-01 01:16:23.000000', 'consum', 0.0216, 'lps'),
	(603519, 127, '2014-04-01 01:16:24.000000', 'consum', 0.0227, 'lps'),
	(603520, 127, '2014-04-01 01:16:25.000000', 'consum', 0.0213, 'lps'),
	(603521, 127, '2014-04-01 01:16:26.000000', 'consum', 0.0217, 'lps'),
	(603522, 127, '2014-04-01 01:16:27.000000', 'consum', 0.0215, 'lps'),
	(603523, 127, '2014-04-01 01:16:28.000000', 'consum', 0.0213, 'lps'),
	(603524, 127, '2014-04-01 01:16:29.000000', 'consum', 0.0211, 'lps'),
	(603525, 127, '2014-04-01 01:16:30.000000', 'consum', 0.0229, 'lps'),
	(603526, 127, '2014-04-01 01:16:31.000000', 'consum', 0.0215, 'lps'),
	(603527, 127, '2014-04-01 01:16:32.000000', 'consum', 0.0220, 'lps'),
	(603528, 127, '2014-04-01 01:16:33.000000', 'consum', 0.0227, 'lps'),
	(603529, 127, '2014-04-01 01:16:34.000000', 'consum', 0.0220, 'lps'),
	(603530, 127, '2014-04-01 01:16:35.000000', 'consum', 0.0211, 'lps'),
	(603531, 127, '2014-04-01 01:16:36.000000', 'consum', 0.0227, 'lps'),
	(603532, 127, '2014-04-01 01:16:37.000000', 'consum', 0.0226, 'lps'),
	(603533, 127, '2014-04-01 01:16:38.000000', 'consum', 0.0220, 'lps'),
	(603534, 127, '2014-04-01 01:16:39.000000', 'consum', 0.0213, 'lps'),
	(603535, 127, '2014-04-01 01:16:40.000000', 'consum', 0.0218, 'lps'),
	(603536, 127, '2014-04-01 01:16:41.000000', 'consum', 0.0217, 'lps'),
	(603537, 127, '2014-04-01 01:16:42.000000', 'consum', 0.0222, 'lps'),
	(603538, 127, '2014-04-01 01:16:43.000000', 'consum', 0.0228, 'lps'),
	(603539, 127, '2014-04-01 01:16:44.000000', 'consum', 0.0222, 'lps'),
	(603540, 127, '2014-04-01 01:16:45.000000', 'consum', 0.0216, 'lps'),
	(603541, 127, '2014-04-01 01:16:46.000000', 'consum', 0.0224, 'lps'),
	(603542, 127, '2014-04-01 01:16:47.000000', 'consum', 0.0221, 'lps'),
	(603543, 127, '2014-04-01 01:16:48.000000', 'consum', 0.0221, 'lps'),
	(603544, 127, '2014-04-01 01:16:49.000000', 'consum', 0.0212, 'lps'),
	(603545, 127, '2014-04-01 01:16:50.000000', 'consum', 0.0229, 'lps'),
	(603546, 127, '2014-04-01 01:16:51.000000', 'consum', 0.0214, 'lps'),
	(603547, 127, '2014-04-01 01:16:52.000000', 'consum', 0.0216, 'lps'),
	(603548, 127, '2014-04-01 01:16:53.000000', 'consum', 0.0231, 'lps'),
	(603549, 127, '2014-04-01 01:16:54.000000', 'consum', 0.0228, 'lps'),
	(603550, 127, '2014-04-01 01:16:55.000000', 'consum', 0.0219, 'lps'),
	(603551, 127, '2014-04-01 01:16:56.000000', 'consum', 0.0220, 'lps'),
	(603552, 127, '2014-04-01 01:16:57.000000', 'consum', 0.0215, 'lps'),
	(603553, 127, '2014-04-01 01:16:58.000000', 'consum', 0.0224, 'lps'),
	(603554, 127, '2014-04-01 01:16:59.000000', 'consum', 0.0225, 'lps'),
	(603555, 127, '2014-04-01 01:17:00.000000', 'consum', 0.0218, 'lps'),
	(603556, 127, '2014-04-01 01:17:01.000000', 'consum', 0.0231, 'lps'),
	(603557, 127, '2014-04-01 01:17:02.000000', 'consum', 0.0224, 'lps'),
	(603558, 127, '2014-04-01 01:17:03.000000', 'consum', 0.0216, 'lps'),
	(603559, 127, '2014-04-01 01:17:04.000000', 'consum', 0.0223, 'lps'),
	(603560, 127, '2014-04-01 01:17:05.000000', 'consum', 0.0213, 'lps'),
	(603561, 127, '2014-04-01 01:17:06.000000', 'consum', 0.0229, 'lps'),
	(603562, 127, '2014-04-01 01:17:07.000000', 'consum', 0.0231, 'lps'),
	(603563, 127, '2014-04-01 01:17:08.000000', 'consum', 0.0217, 'lps'),
	(603564, 127, '2014-04-01 01:17:09.000000', 'consum', 0.0223, 'lps'),
	(603565, 127, '2014-04-01 01:17:10.000000', 'consum', 0.0214, 'lps'),
	(603566, 127, '2014-04-01 01:17:11.000000', 'consum', 0.0212, 'lps'),
	(603567, 127, '2014-04-01 01:17:12.000000', 'consum', 0.0229, 'lps'),
	(603568, 127, '2014-04-01 01:17:13.000000', 'consum', 0.0215, 'lps'),
	(603569, 127, '2014-04-01 01:17:14.000000', 'consum', 0.0219, 'lps'),
	(603570, 127, '2014-04-01 01:17:15.000000', 'consum', 0.0220, 'lps'),
	(603571, 127, '2014-04-01 01:17:16.000000', 'consum', 0.0213, 'lps'),
	(603572, 127, '2014-04-01 01:17:17.000000', 'consum', 0.0215, 'lps'),
	(603573, 127, '2014-04-01 01:17:18.000000', 'consum', 0.0226, 'lps'),
	(603574, 127, '2014-04-01 01:17:19.000000', 'consum', 0.0212, 'lps'),
	(603575, 127, '2014-04-01 01:17:20.000000', 'consum', 0.0217, 'lps'),
	(603576, 127, '2014-04-01 01:17:21.000000', 'consum', 0.0216, 'lps'),
	(603577, 127, '2014-04-01 01:17:22.000000', 'consum', 0.0218, 'lps'),
	(603578, 127, '2014-04-01 01:17:23.000000', 'consum', 0.0212, 'lps'),
	(603579, 127, '2014-04-01 01:17:24.000000', 'consum', 0.0218, 'lps'),
	(603580, 127, '2014-04-01 01:17:25.000000', 'consum', 0.0224, 'lps'),
	(603581, 127, '2014-04-01 01:17:26.000000', 'consum', 0.0210, 'lps'),
	(603582, 127, '2014-04-01 01:17:27.000000', 'consum', 0.0212, 'lps'),
	(603583, 127, '2014-04-01 01:17:28.000000', 'consum', 0.0223, 'lps'),
	(603584, 127, '2014-04-01 01:17:29.000000', 'consum', 0.0225, 'lps'),
	(603585, 127, '2014-04-01 01:17:30.000000', 'consum', 0.0223, 'lps'),
	(603586, 127, '2014-04-01 01:17:31.000000', 'consum', 0.0211, 'lps'),
	(603587, 127, '2014-04-01 01:17:32.000000', 'consum', 0.0218, 'lps'),
	(603588, 127, '2014-04-01 01:17:33.000000', 'consum', 0.0228, 'lps'),
	(603589, 127, '2014-04-01 01:17:34.000000', 'consum', 0.0230, 'lps'),
	(603590, 127, '2014-04-01 01:17:35.000000', 'consum', 0.0213, 'lps'),
	(603591, 127, '2014-04-01 01:17:36.000000', 'consum', 0.0231, 'lps'),
	(603592, 127, '2014-04-01 01:17:37.000000', 'consum', 0.0217, 'lps'),
	(603593, 127, '2014-04-01 01:17:38.000000', 'consum', 0.0230, 'lps'),
	(603594, 127, '2014-04-01 01:17:39.000000', 'consum', 0.0220, 'lps'),
	(603595, 127, '2014-04-01 01:17:40.000000', 'consum', 0.0225, 'lps'),
	(603596, 127, '2014-04-01 01:17:41.000000', 'consum', 0.0212, 'lps'),
	(603597, 127, '2014-04-01 01:17:42.000000', 'consum', 0.0217, 'lps'),
	(603598, 127, '2014-04-01 01:17:43.000000', 'consum', 0.0218, 'lps'),
	(603599, 127, '2014-04-01 01:17:44.000000', 'consum', 0.0210, 'lps'),
	(603600, 127, '2014-04-01 01:17:45.000000', 'consum', 0.0227, 'lps'),
	(603601, 127, '2014-04-01 01:17:46.000000', 'consum', 0.0210, 'lps'),
	(603602, 127, '2014-04-01 01:17:47.000000', 'consum', 0.0223, 'lps'),
	(603603, 127, '2014-04-01 01:17:48.000000', 'consum', 0.0231, 'lps'),
	(603604, 127, '2014-04-01 01:17:49.000000', 'consum', 0.0213, 'lps'),
	(603605, 127, '2014-04-01 01:17:50.000000', 'consum', 0.0227, 'lps'),
	(603606, 127, '2014-04-01 01:17:51.000000', 'consum', 0.0223, 'lps'),
	(603607, 127, '2014-04-01 01:17:52.000000', 'consum', 0.0222, 'lps'),
	(603608, 127, '2014-04-01 01:17:53.000000', 'consum', 0.0211, 'lps'),
	(603609, 127, '2014-04-01 01:17:54.000000', 'consum', 0.0222, 'lps'),
	(603610, 127, '2014-04-01 01:17:55.000000', 'consum', 0.0225, 'lps'),
	(603611, 127, '2014-04-01 01:17:56.000000', 'consum', 0.0226, 'lps'),
	(603612, 127, '2014-04-01 01:17:57.000000', 'consum', 0.0226, 'lps'),
	(603613, 127, '2014-04-01 01:17:58.000000', 'consum', 0.0220, 'lps'),
	(603614, 127, '2014-04-01 01:17:59.000000', 'consum', 0.0213, 'lps'),
	(603615, 127, '2014-04-01 01:18:00.000000', 'consum', 0.0215, 'lps'),
	(603616, 127, '2014-04-01 01:18:01.000000', 'consum', 0.0226, 'lps'),
	(603617, 127, '2014-04-01 01:18:02.000000', 'consum', 0.0211, 'lps'),
	(603618, 127, '2014-04-01 01:18:03.000000', 'consum', 0.0212, 'lps'),
	(603619, 127, '2014-04-01 01:18:04.000000', 'consum', 0.0217, 'lps'),
	(603620, 127, '2014-04-01 01:18:05.000000', 'consum', 0.0219, 'lps'),
	(603621, 127, '2014-04-01 01:18:06.000000', 'consum', 0.0212, 'lps'),
	(603622, 127, '2014-04-01 01:18:07.000000', 'consum', 0.0214, 'lps'),
	(603623, 127, '2014-04-01 01:18:08.000000', 'consum', 0.0225, 'lps'),
	(603624, 127, '2014-04-01 01:18:09.000000', 'consum', 0.0231, 'lps'),
	(603625, 127, '2014-04-01 01:18:10.000000', 'consum', 0.0224, 'lps'),
	(603626, 127, '2014-04-01 01:18:11.000000', 'consum', 0.0219, 'lps'),
	(603627, 127, '2014-04-01 01:18:12.000000', 'consum', 0.0213, 'lps'),
	(603628, 127, '2014-04-01 01:18:13.000000', 'consum', 0.0220, 'lps'),
	(603629, 127, '2014-04-01 01:18:14.000000', 'consum', 0.0210, 'lps'),
	(603630, 127, '2014-04-01 01:18:15.000000', 'consum', 0.0223, 'lps'),
	(603631, 127, '2014-04-01 01:18:16.000000', 'consum', 0.0230, 'lps'),
	(603632, 127, '2014-04-01 01:18:17.000000', 'consum', 0.0228, 'lps'),
	(603633, 127, '2014-04-01 01:18:18.000000', 'consum', 0.0220, 'lps'),
	(603634, 127, '2014-04-01 01:18:19.000000', 'consum', 0.0226, 'lps'),
	(603635, 127, '2014-04-01 01:18:20.000000', 'consum', 0.0219, 'lps'),
	(603636, 127, '2014-04-01 01:18:21.000000', 'consum', 0.0228, 'lps'),
	(603637, 127, '2014-04-01 01:18:22.000000', 'consum', 0.0228, 'lps'),
	(603638, 127, '2014-04-01 01:18:23.000000', 'consum', 0.0228, 'lps'),
	(603639, 127, '2014-04-01 01:18:24.000000', 'consum', 0.0222, 'lps'),
	(603640, 127, '2014-04-01 01:18:25.000000', 'consum', 0.0219, 'lps'),
	(603641, 127, '2014-04-01 01:18:26.000000', 'consum', 0.0217, 'lps'),
	(603642, 127, '2014-04-01 01:18:27.000000', 'consum', 0.0219, 'lps'),
	(603643, 127, '2014-04-01 01:18:28.000000', 'consum', 0.0213, 'lps'),
	(603644, 127, '2014-04-01 01:18:29.000000', 'consum', 0.0221, 'lps'),
	(603645, 127, '2014-04-01 01:18:30.000000', 'consum', 0.0210, 'lps'),
	(603646, 127, '2014-04-01 01:18:31.000000', 'consum', 0.0223, 'lps'),
	(603647, 127, '2014-04-01 01:18:32.000000', 'consum', 0.0230, 'lps'),
	(603648, 127, '2014-04-01 01:18:33.000000', 'consum', 0.0228, 'lps'),
	(603649, 127, '2014-04-01 01:18:34.000000', 'consum', 0.0217, 'lps'),
	(603650, 127, '2014-04-01 01:18:35.000000', 'consum', 0.0214, 'lps'),
	(603651, 127, '2014-04-01 01:18:36.000000', 'consum', 0.0230, 'lps'),
	(603652, 127, '2014-04-01 01:18:37.000000', 'consum', 0.0213, 'lps'),
	(603653, 127, '2014-04-01 01:18:38.000000', 'consum', 0.0230, 'lps'),
	(603654, 127, '2014-04-01 01:18:39.000000', 'consum', 0.0216, 'lps'),
	(603655, 127, '2014-04-01 01:18:40.000000', 'consum', 0.0222, 'lps'),
	(603656, 127, '2014-04-01 01:18:41.000000', 'consum', 0.0210, 'lps'),
	(603657, 127, '2014-04-01 01:18:42.000000', 'consum', 0.0219, 'lps'),
	(603658, 127, '2014-04-01 01:18:43.000000', 'consum', 0.0231, 'lps'),
	(603659, 127, '2014-04-01 01:18:44.000000', 'consum', 0.0226, 'lps'),
	(603660, 127, '2014-04-01 01:18:45.000000', 'consum', 0.0225, 'lps'),
	(603661, 127, '2014-04-01 01:18:46.000000', 'consum', 0.0214, 'lps'),
	(603662, 127, '2014-04-01 01:18:47.000000', 'consum', 0.0231, 'lps'),
	(603663, 127, '2014-04-01 01:18:48.000000', 'consum', 0.0217, 'lps'),
	(603664, 127, '2014-04-01 01:18:49.000000', 'consum', 0.0224, 'lps'),
	(603665, 127, '2014-04-01 01:18:50.000000', 'consum', 0.0217, 'lps'),
	(603666, 127, '2014-04-01 01:18:51.000000', 'consum', 0.0224, 'lps'),
	(603667, 127, '2014-04-01 01:18:52.000000', 'consum', 0.0214, 'lps'),
	(603668, 127, '2014-04-01 01:18:53.000000', 'consum', 0.0214, 'lps'),
	(603669, 127, '2014-04-01 01:18:54.000000', 'consum', 0.0216, 'lps'),
	(603670, 127, '2014-04-01 01:18:55.000000', 'consum', 0.0231, 'lps'),
	(603671, 127, '2014-04-01 01:18:56.000000', 'consum', 0.0229, 'lps'),
	(603672, 127, '2014-04-01 01:18:57.000000', 'consum', 0.0221, 'lps'),
	(603673, 127, '2014-04-01 01:18:58.000000', 'consum', 0.0231, 'lps'),
	(603674, 127, '2014-04-01 01:18:59.000000', 'consum', 0.0218, 'lps'),
	(603675, 127, '2014-04-01 01:19:00.000000', 'consum', 0.0231, 'lps'),
	(603676, 127, '2014-04-01 01:19:01.000000', 'consum', 0.0225, 'lps'),
	(603677, 127, '2014-04-01 01:19:02.000000', 'consum', 0.0223, 'lps'),
	(603678, 127, '2014-04-01 01:19:03.000000', 'consum', 0.0230, 'lps'),
	(603679, 127, '2014-04-01 01:19:04.000000', 'consum', 0.0229, 'lps'),
	(603680, 127, '2014-04-01 01:19:05.000000', 'consum', 0.0221, 'lps'),
	(603681, 127, '2014-04-01 01:19:06.000000', 'consum', 0.0212, 'lps'),
	(603682, 127, '2014-04-01 01:19:07.000000', 'consum', 0.0228, 'lps'),
	(603683, 127, '2014-04-01 01:19:08.000000', 'consum', 0.0229, 'lps'),
	(603684, 127, '2014-04-01 01:19:09.000000', 'consum', 0.0230, 'lps'),
	(603685, 127, '2014-04-01 01:19:10.000000', 'consum', 0.0211, 'lps'),
	(603686, 127, '2014-04-01 01:19:11.000000', 'consum', 0.0222, 'lps'),
	(603687, 127, '2014-04-01 01:19:12.000000', 'consum', 0.0222, 'lps'),
	(603688, 127, '2014-04-01 01:19:13.000000', 'consum', 0.0211, 'lps'),
	(603689, 127, '2014-04-01 01:19:14.000000', 'consum', 0.0225, 'lps'),
	(603690, 127, '2014-04-01 01:19:15.000000', 'consum', 0.0215, 'lps'),
	(603691, 127, '2014-04-01 01:19:16.000000', 'consum', 0.0214, 'lps'),
	(603692, 127, '2014-04-01 01:19:17.000000', 'consum', 0.0217, 'lps'),
	(603693, 127, '2014-04-01 01:19:18.000000', 'consum', 0.0211, 'lps'),
	(603694, 127, '2014-04-01 01:19:19.000000', 'consum', 0.0217, 'lps'),
	(603695, 127, '2014-04-01 01:19:20.000000', 'consum', 0.0219, 'lps'),
	(603696, 127, '2014-04-01 01:19:21.000000', 'consum', 0.0212, 'lps'),
	(603697, 127, '2014-04-01 01:19:22.000000', 'consum', 0.0215, 'lps'),
	(603698, 127, '2014-04-01 01:19:23.000000', 'consum', 0.0231, 'lps'),
	(603699, 127, '2014-04-01 01:19:24.000000', 'consum', 0.0211, 'lps'),
	(603700, 127, '2014-04-01 01:19:25.000000', 'consum', 0.0219, 'lps'),
	(603701, 127, '2014-04-01 01:19:26.000000', 'consum', 0.0231, 'lps'),
	(603702, 127, '2014-04-01 01:19:27.000000', 'consum', 0.0220, 'lps'),
	(603703, 127, '2014-04-01 01:19:28.000000', 'consum', 0.0223, 'lps'),
	(603704, 127, '2014-04-01 01:19:29.000000', 'consum', 0.0221, 'lps'),
	(603705, 127, '2014-04-01 01:19:30.000000', 'consum', 0.0229, 'lps'),
	(603706, 127, '2014-04-01 01:19:31.000000', 'consum', 0.0229, 'lps'),
	(603707, 127, '2014-04-01 01:19:32.000000', 'consum', 0.0224, 'lps'),
	(603708, 127, '2014-04-01 01:19:33.000000', 'consum', 0.0226, 'lps'),
	(603709, 127, '2014-04-01 01:19:34.000000', 'consum', 0.0228, 'lps'),
	(603710, 127, '2014-04-01 01:19:35.000000', 'consum', 0.0227, 'lps'),
	(603711, 127, '2014-04-01 01:19:36.000000', 'consum', 0.0219, 'lps'),
	(603712, 127, '2014-04-01 01:19:37.000000', 'consum', 0.0229, 'lps'),
	(603713, 127, '2014-04-01 01:19:38.000000', 'consum', 0.0214, 'lps'),
	(603714, 127, '2014-04-01 01:19:39.000000', 'consum', 0.0214, 'lps'),
	(603715, 127, '2014-04-01 01:19:40.000000', 'consum', 0.0221, 'lps'),
	(603716, 127, '2014-04-01 01:19:41.000000', 'consum', 0.0230, 'lps'),
	(603717, 127, '2014-04-01 01:19:42.000000', 'consum', 0.0211, 'lps'),
	(603718, 127, '2014-04-01 01:19:43.000000', 'consum', 0.0223, 'lps'),
	(603719, 127, '2014-04-01 01:19:44.000000', 'consum', 0.0229, 'lps'),
	(603720, 127, '2014-04-01 01:19:45.000000', 'consum', 0.0220, 'lps'),
	(603721, 127, '2014-04-01 01:19:46.000000', 'consum', 0.0227, 'lps'),
	(603722, 127, '2014-04-01 01:19:47.000000', 'consum', 0.0222, 'lps'),
	(603723, 127, '2014-04-01 01:19:48.000000', 'consum', 0.0220, 'lps'),
	(603724, 127, '2014-04-01 01:19:49.000000', 'consum', 0.0222, 'lps'),
	(603725, 127, '2014-04-01 01:19:50.000000', 'consum', 0.0222, 'lps'),
	(603726, 127, '2014-04-01 01:19:51.000000', 'consum', 0.0210, 'lps'),
	(603727, 127, '2014-04-01 01:19:52.000000', 'consum', 0.0220, 'lps'),
	(603728, 127, '2014-04-01 01:19:53.000000', 'consum', 0.0218, 'lps'),
	(603729, 127, '2014-04-01 01:19:54.000000', 'consum', 0.0218, 'lps'),
	(603730, 127, '2014-04-01 01:19:55.000000', 'consum', 0.0225, 'lps'),
	(603731, 127, '2014-04-01 01:19:56.000000', 'consum', 0.0220, 'lps'),
	(603732, 127, '2014-04-01 01:19:57.000000', 'consum', 0.0216, 'lps'),
	(603733, 127, '2014-04-01 01:19:58.000000', 'consum', 0.0212, 'lps'),
	(603734, 127, '2014-04-01 01:19:59.000000', 'consum', 0.0222, 'lps'),
	(603735, 127, '2014-04-01 01:20:00.000000', 'consum', 0.0220, 'lps'),
	(603736, 127, '2014-04-01 01:20:01.000000', 'consum', 0.0227, 'lps'),
	(603737, 127, '2014-04-01 01:20:02.000000', 'consum', 0.0222, 'lps'),
	(603738, 127, '2014-04-01 01:20:03.000000', 'consum', 0.0217, 'lps'),
	(603739, 127, '2014-04-01 01:20:04.000000', 'consum', 0.0210, 'lps'),
	(603740, 127, '2014-04-01 01:20:05.000000', 'consum', 0.0211, 'lps'),
	(603741, 127, '2014-04-01 01:20:06.000000', 'consum', 0.0215, 'lps'),
	(603742, 127, '2014-04-01 01:20:07.000000', 'consum', 0.0213, 'lps'),
	(603743, 127, '2014-04-01 01:20:08.000000', 'consum', 0.0231, 'lps'),
	(603744, 127, '2014-04-01 01:20:09.000000', 'consum', 0.0218, 'lps'),
	(603745, 127, '2014-04-01 01:20:10.000000', 'consum', 0.0210, 'lps'),
	(603746, 127, '2014-04-01 01:20:11.000000', 'consum', 0.0231, 'lps'),
	(603747, 127, '2014-04-01 01:20:12.000000', 'consum', 0.0228, 'lps'),
	(603748, 127, '2014-04-01 01:20:13.000000', 'consum', 0.0217, 'lps'),
	(603749, 127, '2014-04-01 01:20:14.000000', 'consum', 0.0210, 'lps'),
	(603750, 127, '2014-04-01 01:20:15.000000', 'consum', 0.0214, 'lps'),
	(603751, 127, '2014-04-01 01:20:16.000000', 'consum', 0.0230, 'lps'),
	(603752, 127, '2014-04-01 01:20:17.000000', 'consum', 0.0210, 'lps'),
	(603753, 127, '2014-04-01 01:20:18.000000', 'consum', 0.0218, 'lps'),
	(603754, 127, '2014-04-01 01:20:19.000000', 'consum', 0.0228, 'lps'),
	(603755, 127, '2014-04-01 01:20:20.000000', 'consum', 0.0211, 'lps'),
	(603756, 127, '2014-04-01 01:20:21.000000', 'consum', 0.0226, 'lps'),
	(603757, 127, '2014-04-01 01:20:22.000000', 'consum', 0.0224, 'lps'),
	(603758, 127, '2014-04-01 01:20:23.000000', 'consum', 0.0210, 'lps'),
	(603759, 127, '2014-04-01 01:20:24.000000', 'consum', 0.0214, 'lps'),
	(603760, 127, '2014-04-01 01:20:25.000000', 'consum', 0.0228, 'lps'),
	(603761, 127, '2014-04-01 01:20:26.000000', 'consum', 0.0225, 'lps'),
	(603762, 127, '2014-04-01 01:20:27.000000', 'consum', 0.0230, 'lps'),
	(603763, 127, '2014-04-01 01:20:28.000000', 'consum', 0.0220, 'lps'),
	(603764, 127, '2014-04-01 01:20:29.000000', 'consum', 0.0224, 'lps'),
	(603765, 127, '2014-04-01 01:20:30.000000', 'consum', 0.0229, 'lps'),
	(603766, 127, '2014-04-01 01:20:31.000000', 'consum', 0.0221, 'lps'),
	(603767, 127, '2014-04-01 01:20:32.000000', 'consum', 0.0229, 'lps'),
	(603768, 127, '2014-04-01 01:20:33.000000', 'consum', 0.0230, 'lps'),
	(603769, 127, '2014-04-01 01:20:34.000000', 'consum', 0.0229, 'lps'),
	(603770, 127, '2014-04-01 01:20:35.000000', 'consum', 0.0225, 'lps'),
	(603771, 127, '2014-04-01 01:20:36.000000', 'consum', 0.0228, 'lps'),
	(603772, 127, '2014-04-01 01:20:37.000000', 'consum', 0.0210, 'lps'),
	(603773, 127, '2014-04-01 01:20:38.000000', 'consum', 0.0224, 'lps'),
	(603774, 127, '2014-04-01 01:20:39.000000', 'consum', 0.0216, 'lps'),
	(603775, 127, '2014-04-01 01:20:40.000000', 'consum', 0.0219, 'lps'),
	(603776, 127, '2014-04-01 01:20:41.000000', 'consum', 0.0215, 'lps'),
	(603777, 127, '2014-04-01 01:20:42.000000', 'consum', 0.0210, 'lps'),
	(603778, 127, '2014-04-01 01:20:43.000000', 'consum', 0.0219, 'lps'),
	(603779, 127, '2014-04-01 01:20:44.000000', 'consum', 0.0231, 'lps'),
	(603780, 127, '2014-04-01 01:20:45.000000', 'consum', 0.0222, 'lps'),
	(603781, 127, '2014-04-01 01:20:46.000000', 'consum', 0.0231, 'lps'),
	(603782, 127, '2014-04-01 01:20:47.000000', 'consum', 0.0214, 'lps'),
	(603783, 127, '2014-04-01 01:20:48.000000', 'consum', 0.0211, 'lps'),
	(603784, 127, '2014-04-01 01:20:49.000000', 'consum', 0.0226, 'lps'),
	(603785, 127, '2014-04-01 01:20:50.000000', 'consum', 0.0220, 'lps'),
	(603786, 127, '2014-04-01 01:20:51.000000', 'consum', 0.0214, 'lps'),
	(603787, 127, '2014-04-01 01:20:52.000000', 'consum', 0.0220, 'lps'),
	(603788, 127, '2014-04-01 01:20:53.000000', 'consum', 0.0228, 'lps'),
	(603789, 127, '2014-04-01 01:20:54.000000', 'consum', 0.0225, 'lps'),
	(603790, 127, '2014-04-01 01:20:55.000000', 'consum', 0.0230, 'lps'),
	(603791, 127, '2014-04-01 01:20:56.000000', 'consum', 0.0225, 'lps'),
	(603792, 127, '2014-04-01 01:20:57.000000', 'consum', 0.0225, 'lps'),
	(603793, 127, '2014-04-01 01:20:58.000000', 'consum', 0.0217, 'lps'),
	(603794, 127, '2014-04-01 01:20:59.000000', 'consum', 0.0224, 'lps'),
	(603795, 127, '2014-04-01 01:21:00.000000', 'consum', 0.0216, 'lps'),
	(603796, 127, '2014-04-01 01:21:01.000000', 'consum', 0.0219, 'lps'),
	(603797, 127, '2014-04-01 01:21:02.000000', 'consum', 0.0214, 'lps'),
	(603798, 127, '2014-04-01 01:21:03.000000', 'consum', 0.0227, 'lps'),
	(603799, 127, '2014-04-01 01:21:04.000000', 'consum', 0.0217, 'lps'),
	(603800, 127, '2014-04-01 01:21:05.000000', 'consum', 0.0215, 'lps'),
	(603801, 127, '2014-04-01 01:21:06.000000', 'consum', 0.0217, 'lps'),
	(603802, 127, '2014-04-01 01:21:07.000000', 'consum', 0.0229, 'lps'),
	(603803, 127, '2014-04-01 01:21:08.000000', 'consum', 0.0220, 'lps'),
	(603804, 127, '2014-04-01 01:21:09.000000', 'consum', 0.0223, 'lps'),
	(603805, 127, '2014-04-01 01:21:10.000000', 'consum', 0.0224, 'lps'),
	(603806, 127, '2014-04-01 01:21:11.000000', 'consum', 0.0219, 'lps'),
	(603807, 127, '2014-04-01 01:21:12.000000', 'consum', 0.0212, 'lps'),
	(603808, 127, '2014-04-01 01:21:13.000000', 'consum', 0.0219, 'lps'),
	(603809, 127, '2014-04-01 01:21:14.000000', 'consum', 0.0224, 'lps'),
	(603810, 127, '2014-04-01 01:21:15.000000', 'consum', 0.0212, 'lps'),
	(603811, 127, '2014-04-01 01:21:16.000000', 'consum', 0.0222, 'lps'),
	(603812, 127, '2014-04-01 01:21:17.000000', 'consum', 0.0219, 'lps'),
	(603813, 127, '2014-04-01 01:21:18.000000', 'consum', 0.0221, 'lps'),
	(603814, 127, '2014-04-01 01:21:19.000000', 'consum', 0.0217, 'lps'),
	(603815, 127, '2014-04-01 01:21:20.000000', 'consum', 0.0210, 'lps'),
	(603816, 127, '2014-04-01 01:21:21.000000', 'consum', 0.0212, 'lps'),
	(603817, 127, '2014-04-01 01:21:22.000000', 'consum', 0.0222, 'lps'),
	(603818, 127, '2014-04-01 01:21:23.000000', 'consum', 0.0220, 'lps'),
	(603819, 127, '2014-04-01 01:21:24.000000', 'consum', 0.0223, 'lps'),
	(603820, 127, '2014-04-01 01:21:25.000000', 'consum', 0.0226, 'lps'),
	(603821, 127, '2014-04-01 01:21:26.000000', 'consum', 0.0227, 'lps'),
	(603822, 127, '2014-04-01 01:21:27.000000', 'consum', 0.0225, 'lps'),
	(603823, 127, '2014-04-01 01:21:28.000000', 'consum', 0.0212, 'lps'),
	(603824, 127, '2014-04-01 01:21:29.000000', 'consum', 0.0221, 'lps'),
	(603825, 127, '2014-04-01 01:21:30.000000', 'consum', 0.0214, 'lps'),
	(603826, 127, '2014-04-01 01:21:31.000000', 'consum', 0.0221, 'lps'),
	(603827, 127, '2014-04-01 01:21:32.000000', 'consum', 0.0230, 'lps'),
	(603828, 127, '2014-04-01 01:21:33.000000', 'consum', 0.0210, 'lps'),
	(603829, 127, '2014-04-01 01:21:34.000000', 'consum', 0.0219, 'lps'),
	(603830, 127, '2014-04-01 01:21:35.000000', 'consum', 0.0212, 'lps'),
	(603831, 127, '2014-04-01 01:21:36.000000', 'consum', 0.0213, 'lps'),
	(603832, 127, '2014-04-01 01:21:37.000000', 'consum', 0.0223, 'lps'),
	(603833, 127, '2014-04-01 01:21:38.000000', 'consum', 0.0219, 'lps'),
	(603834, 127, '2014-04-01 01:21:39.000000', 'consum', 0.0218, 'lps'),
	(603835, 127, '2014-04-01 01:21:40.000000', 'consum', 0.0224, 'lps'),
	(603836, 127, '2014-04-01 01:21:41.000000', 'consum', 0.0213, 'lps'),
	(603837, 127, '2014-04-01 01:21:42.000000', 'consum', 0.0228, 'lps'),
	(603838, 127, '2014-04-01 01:21:43.000000', 'consum', 0.0223, 'lps'),
	(603839, 127, '2014-04-01 01:21:44.000000', 'consum', 0.0225, 'lps'),
	(603840, 127, '2014-04-01 01:21:45.000000', 'consum', 0.0221, 'lps'),
	(603841, 127, '2014-04-01 01:21:46.000000', 'consum', 0.0223, 'lps'),
	(603842, 127, '2014-04-01 01:21:47.000000', 'consum', 0.0221, 'lps'),
	(603843, 127, '2014-04-01 01:21:48.000000', 'consum', 0.0227, 'lps'),
	(603844, 127, '2014-04-01 01:21:49.000000', 'consum', 0.0215, 'lps'),
	(603845, 127, '2014-04-01 01:21:50.000000', 'consum', 0.0210, 'lps'),
	(603846, 127, '2014-04-01 01:21:51.000000', 'consum', 0.0216, 'lps'),
	(603847, 127, '2014-04-01 01:21:52.000000', 'consum', 0.0221, 'lps'),
	(603848, 127, '2014-04-01 01:21:53.000000', 'consum', 0.0222, 'lps'),
	(603849, 127, '2014-04-01 01:21:54.000000', 'consum', 0.0216, 'lps'),
	(603850, 127, '2014-04-01 01:21:55.000000', 'consum', 0.0228, 'lps'),
	(603851, 127, '2014-04-01 01:21:56.000000', 'consum', 0.0218, 'lps'),
	(603852, 127, '2014-04-01 01:21:57.000000', 'consum', 0.0217, 'lps'),
	(603853, 127, '2014-04-01 01:21:58.000000', 'consum', 0.0220, 'lps'),
	(603854, 127, '2014-04-01 01:21:59.000000', 'consum', 0.0220, 'lps'),
	(603855, 127, '2014-04-01 01:22:00.000000', 'consum', 0.0230, 'lps'),
	(603856, 127, '2014-04-01 01:22:01.000000', 'consum', 0.0213, 'lps'),
	(603857, 127, '2014-04-01 01:22:02.000000', 'consum', 0.0211, 'lps'),
	(603858, 127, '2014-04-01 01:22:03.000000', 'consum', 0.0228, 'lps'),
	(603859, 127, '2014-04-01 01:22:04.000000', 'consum', 0.0231, 'lps'),
	(603860, 127, '2014-04-01 01:22:05.000000', 'consum', 0.0218, 'lps'),
	(603861, 127, '2014-04-01 01:22:06.000000', 'consum', 0.0231, 'lps'),
	(603862, 127, '2014-04-01 01:22:07.000000', 'consum', 0.0225, 'lps'),
	(603863, 127, '2014-04-01 01:22:08.000000', 'consum', 0.0222, 'lps'),
	(603864, 127, '2014-04-01 01:22:09.000000', 'consum', 0.0227, 'lps'),
	(603865, 127, '2014-04-01 01:22:10.000000', 'consum', 0.0215, 'lps'),
	(603866, 127, '2014-04-01 01:22:11.000000', 'consum', 0.0227, 'lps'),
	(603867, 127, '2014-04-01 01:22:12.000000', 'consum', 0.0214, 'lps'),
	(603868, 127, '2014-04-01 01:22:13.000000', 'consum', 0.0223, 'lps'),
	(603869, 127, '2014-04-01 01:22:14.000000', 'consum', 0.0221, 'lps'),
	(603870, 127, '2014-04-01 01:22:15.000000', 'consum', 0.0227, 'lps'),
	(603871, 127, '2014-04-01 01:22:16.000000', 'consum', 0.0218, 'lps'),
	(603872, 127, '2014-04-01 01:22:17.000000', 'consum', 0.0223, 'lps'),
	(603873, 127, '2014-04-01 01:22:18.000000', 'consum', 0.0230, 'lps'),
	(603874, 127, '2014-04-01 01:22:19.000000', 'consum', 0.0228, 'lps'),
	(603875, 127, '2014-04-01 01:22:20.000000', 'consum', 0.0216, 'lps'),
	(603876, 127, '2014-04-01 01:22:21.000000', 'consum', 0.0210, 'lps'),
	(603877, 127, '2014-04-01 01:22:22.000000', 'consum', 0.0215, 'lps'),
	(603878, 127, '2014-04-01 01:22:23.000000', 'consum', 0.0213, 'lps'),
	(603879, 127, '2014-04-01 01:22:24.000000', 'consum', 0.0212, 'lps'),
	(603880, 127, '2014-04-01 01:22:25.000000', 'consum', 0.0210, 'lps'),
	(603881, 127, '2014-04-01 01:22:26.000000', 'consum', 0.0226, 'lps'),
	(603882, 127, '2014-04-01 01:22:27.000000', 'consum', 0.0225, 'lps'),
	(603883, 127, '2014-04-01 01:22:28.000000', 'consum', 0.0215, 'lps'),
	(603884, 127, '2014-04-01 01:22:29.000000', 'consum', 0.0214, 'lps'),
	(603885, 127, '2014-04-01 01:22:30.000000', 'consum', 0.0217, 'lps'),
	(603886, 127, '2014-04-01 01:22:31.000000', 'consum', 0.0230, 'lps'),
	(603887, 127, '2014-04-01 01:22:32.000000', 'consum', 0.0224, 'lps'),
	(603888, 127, '2014-04-01 01:22:33.000000', 'consum', 0.0222, 'lps'),
	(603889, 127, '2014-04-01 01:22:34.000000', 'consum', 0.0227, 'lps'),
	(603890, 127, '2014-04-01 01:22:35.000000', 'consum', 0.0215, 'lps'),
	(603891, 127, '2014-04-01 01:22:36.000000', 'consum', 0.0231, 'lps'),
	(603892, 127, '2014-04-01 01:22:37.000000', 'consum', 0.0211, 'lps'),
	(603893, 127, '2014-04-01 01:22:38.000000', 'consum', 0.0219, 'lps'),
	(603894, 127, '2014-04-01 01:22:39.000000', 'consum', 0.0210, 'lps'),
	(603895, 127, '2014-04-01 01:22:40.000000', 'consum', 0.0228, 'lps'),
	(603896, 127, '2014-04-01 01:22:41.000000', 'consum', 0.0211, 'lps'),
	(603897, 127, '2014-04-01 01:22:42.000000', 'consum', 0.0230, 'lps'),
	(603898, 127, '2014-04-01 01:22:43.000000', 'consum', 0.0217, 'lps'),
	(603899, 127, '2014-04-01 01:22:44.000000', 'consum', 0.0229, 'lps'),
	(603900, 127, '2014-04-01 01:22:45.000000', 'consum', 0.0219, 'lps'),
	(603901, 127, '2014-04-01 01:22:46.000000', 'consum', 0.0223, 'lps'),
	(603902, 127, '2014-04-01 01:22:47.000000', 'consum', 0.0223, 'lps'),
	(603903, 127, '2014-04-01 01:22:48.000000', 'consum', 0.0215, 'lps'),
	(603904, 127, '2014-04-01 01:22:49.000000', 'consum', 0.0221, 'lps'),
	(603905, 127, '2014-04-01 01:22:50.000000', 'consum', 0.0228, 'lps'),
	(603906, 127, '2014-04-01 01:22:51.000000', 'consum', 0.0221, 'lps'),
	(603907, 127, '2014-04-01 01:22:52.000000', 'consum', 0.0213, 'lps'),
	(603908, 127, '2014-04-01 01:22:53.000000', 'consum', 0.0215, 'lps'),
	(603909, 127, '2014-04-01 01:22:54.000000', 'consum', 0.0224, 'lps'),
	(603910, 127, '2014-04-01 01:22:55.000000', 'consum', 0.0223, 'lps'),
	(603911, 127, '2014-04-01 01:22:56.000000', 'consum', 0.0210, 'lps'),
	(603912, 127, '2014-04-01 01:22:57.000000', 'consum', 0.0217, 'lps'),
	(603913, 127, '2014-04-01 01:22:58.000000', 'consum', 0.0222, 'lps'),
	(603914, 127, '2014-04-01 01:22:59.000000', 'consum', 0.0228, 'lps'),
	(603915, 127, '2014-04-01 01:23:00.000000', 'consum', 0.0222, 'lps'),
	(603916, 127, '2014-04-01 01:23:01.000000', 'consum', 0.0214, 'lps'),
	(603917, 127, '2014-04-01 01:23:02.000000', 'consum', 0.0216, 'lps'),
	(603918, 127, '2014-04-01 01:23:03.000000', 'consum', 0.0230, 'lps'),
	(603919, 127, '2014-04-01 01:23:04.000000', 'consum', 0.0224, 'lps'),
	(603920, 127, '2014-04-01 01:23:05.000000', 'consum', 0.0223, 'lps'),
	(603921, 127, '2014-04-01 01:23:06.000000', 'consum', 0.0211, 'lps'),
	(603922, 127, '2014-04-01 01:23:07.000000', 'consum', 0.0219, 'lps'),
	(603923, 127, '2014-04-01 01:23:08.000000', 'consum', 0.0231, 'lps'),
	(603924, 127, '2014-04-01 01:23:09.000000', 'consum', 0.0222, 'lps'),
	(603925, 127, '2014-04-01 01:23:10.000000', 'consum', 0.0231, 'lps'),
	(603926, 127, '2014-04-01 01:23:11.000000', 'consum', 0.0212, 'lps'),
	(603927, 127, '2014-04-01 01:23:12.000000', 'consum', 0.0226, 'lps'),
	(603928, 127, '2014-04-01 01:23:13.000000', 'consum', 0.0216, 'lps'),
	(603929, 127, '2014-04-01 01:23:14.000000', 'consum', 0.0213, 'lps'),
	(603930, 127, '2014-04-01 01:23:15.000000', 'consum', 0.0211, 'lps'),
	(603931, 127, '2014-04-01 01:23:16.000000', 'consum', 0.0228, 'lps'),
	(603932, 127, '2014-04-01 01:23:17.000000', 'consum', 0.0230, 'lps'),
	(603933, 127, '2014-04-01 01:23:18.000000', 'consum', 0.0214, 'lps'),
	(603934, 127, '2014-04-01 01:23:19.000000', 'consum', 0.0214, 'lps'),
	(603935, 127, '2014-04-01 01:23:20.000000', 'consum', 0.0218, 'lps'),
	(603936, 127, '2014-04-01 01:23:21.000000', 'consum', 0.0217, 'lps'),
	(603937, 127, '2014-04-01 01:23:22.000000', 'consum', 0.0222, 'lps'),
	(603938, 127, '2014-04-01 01:23:23.000000', 'consum', 0.0229, 'lps'),
	(603939, 127, '2014-04-01 01:23:24.000000', 'consum', 0.0222, 'lps'),
	(603940, 127, '2014-04-01 01:23:25.000000', 'consum', 0.0216, 'lps'),
	(603941, 127, '2014-04-01 01:23:26.000000', 'consum', 0.0226, 'lps'),
	(603942, 127, '2014-04-01 01:23:27.000000', 'consum', 0.0229, 'lps'),
	(603943, 127, '2014-04-01 01:23:28.000000', 'consum', 0.0215, 'lps'),
	(603944, 127, '2014-04-01 01:23:29.000000', 'consum', 0.0219, 'lps'),
	(603945, 127, '2014-04-01 01:23:30.000000', 'consum', 0.0222, 'lps'),
	(603946, 127, '2014-04-01 01:23:31.000000', 'consum', 0.0218, 'lps'),
	(603947, 127, '2014-04-01 01:23:32.000000', 'consum', 0.0216, 'lps'),
	(603948, 127, '2014-04-01 01:23:33.000000', 'consum', 0.0218, 'lps'),
	(603949, 127, '2014-04-01 01:23:34.000000', 'consum', 0.0211, 'lps'),
	(603950, 127, '2014-04-01 01:23:35.000000', 'consum', 0.0210, 'lps'),
	(603951, 127, '2014-04-01 01:23:36.000000', 'consum', 0.0211, 'lps'),
	(603952, 127, '2014-04-01 01:23:37.000000', 'consum', 0.0214, 'lps'),
	(603953, 127, '2014-04-01 01:23:38.000000', 'consum', 0.0226, 'lps'),
	(603954, 127, '2014-04-01 01:23:39.000000', 'consum', 0.0215, 'lps'),
	(603955, 127, '2014-04-01 01:23:40.000000', 'consum', 0.0210, 'lps'),
	(603956, 127, '2014-04-01 01:23:41.000000', 'consum', 0.0217, 'lps'),
	(603957, 127, '2014-04-01 01:23:42.000000', 'consum', 0.0222, 'lps'),
	(603958, 127, '2014-04-01 01:23:43.000000', 'consum', 0.0229, 'lps'),
	(603959, 127, '2014-04-01 01:23:44.000000', 'consum', 0.0223, 'lps'),
	(603960, 127, '2014-04-01 01:23:45.000000', 'consum', 0.0219, 'lps'),
	(603961, 127, '2014-04-01 01:23:46.000000', 'consum', 0.0219, 'lps'),
	(603962, 127, '2014-04-01 01:23:47.000000', 'consum', 0.0227, 'lps'),
	(603963, 127, '2014-04-01 01:23:48.000000', 'consum', 0.0224, 'lps'),
	(603964, 127, '2014-04-01 01:23:49.000000', 'consum', 0.0229, 'lps'),
	(603965, 127, '2014-04-01 01:23:50.000000', 'consum', 0.0222, 'lps'),
	(603966, 127, '2014-04-01 01:23:51.000000', 'consum', 0.0210, 'lps'),
	(603967, 127, '2014-04-01 01:23:52.000000', 'consum', 0.0222, 'lps'),
	(603968, 127, '2014-04-01 01:23:53.000000', 'consum', 0.0224, 'lps'),
	(603969, 127, '2014-04-01 01:23:54.000000', 'consum', 0.0223, 'lps'),
	(603970, 127, '2014-04-01 01:23:55.000000', 'consum', 0.0212, 'lps'),
	(603971, 127, '2014-04-01 01:23:56.000000', 'consum', 0.0225, 'lps'),
	(603972, 127, '2014-04-01 01:23:57.000000', 'consum', 0.0212, 'lps'),
	(603973, 127, '2014-04-01 01:23:58.000000', 'consum', 0.0221, 'lps'),
	(603974, 127, '2014-04-01 01:23:59.000000', 'consum', 0.0213, 'lps'),
	(603975, 127, '2014-04-01 01:24:00.000000', 'consum', 0.0218, 'lps'),
	(603976, 127, '2014-04-01 01:24:01.000000', 'consum', 0.0218, 'lps'),
	(603977, 127, '2014-04-01 01:24:02.000000', 'consum', 0.0228, 'lps'),
	(603978, 127, '2014-04-01 01:24:03.000000', 'consum', 0.0210, 'lps'),
	(603979, 127, '2014-04-01 01:24:04.000000', 'consum', 0.0223, 'lps'),
	(603980, 127, '2014-04-01 01:24:05.000000', 'consum', 0.0231, 'lps'),
	(603981, 127, '2014-04-01 01:24:06.000000', 'consum', 0.0210, 'lps'),
	(603982, 127, '2014-04-01 01:24:07.000000', 'consum', 0.0215, 'lps'),
	(603983, 127, '2014-04-01 01:24:08.000000', 'consum', 0.0213, 'lps'),
	(603984, 127, '2014-04-01 01:24:09.000000', 'consum', 0.0210, 'lps'),
	(603985, 127, '2014-04-01 01:24:10.000000', 'consum', 0.0223, 'lps'),
	(603986, 127, '2014-04-01 01:24:11.000000', 'consum', 0.0211, 'lps'),
	(603987, 127, '2014-04-01 01:24:12.000000', 'consum', 0.0220, 'lps'),
	(603988, 127, '2014-04-01 01:24:13.000000', 'consum', 0.0212, 'lps'),
	(603989, 127, '2014-04-01 01:24:14.000000', 'consum', 0.0215, 'lps'),
	(603990, 127, '2014-04-01 01:24:15.000000', 'consum', 0.0227, 'lps'),
	(603991, 127, '2014-04-01 01:24:16.000000', 'consum', 0.0216, 'lps'),
	(603992, 127, '2014-04-01 01:24:17.000000', 'consum', 0.0211, 'lps'),
	(603993, 127, '2014-04-01 01:24:18.000000', 'consum', 0.0218, 'lps'),
	(603994, 127, '2014-04-01 01:24:19.000000', 'consum', 0.0228, 'lps'),
	(603995, 127, '2014-04-01 01:24:20.000000', 'consum', 0.0211, 'lps'),
	(603996, 127, '2014-04-01 01:24:21.000000', 'consum', 0.0227, 'lps'),
	(603997, 127, '2014-04-01 01:24:22.000000', 'consum', 0.0225, 'lps'),
	(603998, 127, '2014-04-01 01:24:23.000000', 'consum', 0.0212, 'lps'),
	(603999, 127, '2014-04-01 01:24:24.000000', 'consum', 0.0222, 'lps'),
	(604000, 127, '2014-04-01 01:24:25.000000', 'consum', 0.0219, 'lps'),
	(604001, 127, '2014-04-01 01:24:26.000000', 'consum', 0.0219, 'lps'),
	(604002, 127, '2014-04-01 01:24:27.000000', 'consum', 0.0229, 'lps'),
	(604003, 127, '2014-04-01 01:24:28.000000', 'consum', 0.0215, 'lps'),
	(604004, 127, '2014-04-01 01:24:29.000000', 'consum', 0.0219, 'lps'),
	(604005, 127, '2014-04-01 01:24:30.000000', 'consum', 0.0218, 'lps'),
	(604006, 127, '2014-04-01 01:24:31.000000', 'consum', 0.0226, 'lps'),
	(604007, 127, '2014-04-01 01:24:32.000000', 'consum', 0.0220, 'lps'),
	(604008, 127, '2014-04-01 01:24:33.000000', 'consum', 0.0214, 'lps'),
	(604009, 127, '2014-04-01 01:24:34.000000', 'consum', 0.0223, 'lps'),
	(604010, 127, '2014-04-01 01:24:35.000000', 'consum', 0.0218, 'lps'),
	(604011, 127, '2014-04-01 01:24:36.000000', 'consum', 0.0214, 'lps'),
	(604012, 127, '2014-04-01 01:24:37.000000', 'consum', 0.0225, 'lps'),
	(604013, 127, '2014-04-01 01:24:38.000000', 'consum', 0.0211, 'lps'),
	(604014, 127, '2014-04-01 01:24:39.000000', 'consum', 0.0213, 'lps'),
	(604015, 127, '2014-04-01 01:24:40.000000', 'consum', 0.0223, 'lps'),
	(604016, 127, '2014-04-01 01:24:41.000000', 'consum', 0.0220, 'lps'),
	(604017, 127, '2014-04-01 01:24:42.000000', 'consum', 0.0225, 'lps'),
	(604018, 127, '2014-04-01 01:24:43.000000', 'consum', 0.0230, 'lps'),
	(604019, 127, '2014-04-01 01:24:44.000000', 'consum', 0.0224, 'lps'),
	(604020, 127, '2014-04-01 01:24:45.000000', 'consum', 0.0220, 'lps'),
	(604021, 127, '2014-04-01 01:24:46.000000', 'consum', 0.0218, 'lps'),
	(604022, 127, '2014-04-01 01:24:47.000000', 'consum', 0.0221, 'lps'),
	(604023, 127, '2014-04-01 01:24:48.000000', 'consum', 0.0218, 'lps'),
	(604024, 127, '2014-04-01 01:24:49.000000', 'consum', 0.0219, 'lps'),
	(604025, 127, '2014-04-01 01:24:50.000000', 'consum', 0.0231, 'lps'),
	(604026, 127, '2014-04-01 01:24:51.000000', 'consum', 0.0223, 'lps'),
	(604027, 127, '2014-04-01 01:24:52.000000', 'consum', 0.0210, 'lps'),
	(604028, 127, '2014-04-01 01:24:53.000000', 'consum', 0.0218, 'lps'),
	(604029, 127, '2014-04-01 01:24:54.000000', 'consum', 0.0226, 'lps'),
	(604030, 127, '2014-04-01 01:24:55.000000', 'consum', 0.0224, 'lps'),
	(604031, 127, '2014-04-01 01:24:56.000000', 'consum', 0.0230, 'lps'),
	(604032, 127, '2014-04-01 01:24:57.000000', 'consum', 0.0228, 'lps'),
	(604033, 127, '2014-04-01 01:24:58.000000', 'consum', 0.0216, 'lps'),
	(604034, 127, '2014-04-01 01:24:59.000000', 'consum', 0.0229, 'lps'),
	(604035, 127, '2014-04-01 01:25:00.000000', 'consum', 0.0225, 'lps'),
	(604036, 127, '2014-04-01 01:25:01.000000', 'consum', 0.0226, 'lps'),
	(604037, 127, '2014-04-01 01:25:02.000000', 'consum', 0.0225, 'lps'),
	(604038, 127, '2014-04-01 01:25:03.000000', 'consum', 0.0216, 'lps'),
	(604039, 127, '2014-04-01 01:25:04.000000', 'consum', 0.0218, 'lps'),
	(604040, 127, '2014-04-01 01:25:05.000000', 'consum', 0.0210, 'lps'),
	(604041, 127, '2014-04-01 01:25:06.000000', 'consum', 0.0210, 'lps'),
	(604042, 127, '2014-04-01 01:25:07.000000', 'consum', 0.0229, 'lps'),
	(604043, 127, '2014-04-01 01:25:08.000000', 'consum', 0.0221, 'lps'),
	(604044, 127, '2014-04-01 01:25:09.000000', 'consum', 0.0227, 'lps'),
	(604045, 127, '2014-04-01 01:25:10.000000', 'consum', 0.0221, 'lps'),
	(604046, 127, '2014-04-01 01:25:11.000000', 'consum', 0.0215, 'lps'),
	(604047, 127, '2014-04-01 01:25:12.000000', 'consum', 0.0226, 'lps'),
	(604048, 127, '2014-04-01 01:25:13.000000', 'consum', 0.0229, 'lps'),
	(604049, 127, '2014-04-01 01:25:14.000000', 'consum', 0.0212, 'lps'),
	(604050, 127, '2014-04-01 01:25:15.000000', 'consum', 0.0231, 'lps'),
	(604051, 127, '2014-04-01 01:25:16.000000', 'consum', 0.0222, 'lps'),
	(604052, 127, '2014-04-01 01:25:17.000000', 'consum', 0.0228, 'lps'),
	(604053, 127, '2014-04-01 01:25:18.000000', 'consum', 0.0219, 'lps'),
	(604054, 127, '2014-04-01 01:25:19.000000', 'consum', 0.0227, 'lps'),
	(604055, 127, '2014-04-01 01:25:20.000000', 'consum', 0.0223, 'lps'),
	(604056, 127, '2014-04-01 01:25:21.000000', 'consum', 0.0226, 'lps'),
	(604057, 127, '2014-04-01 01:25:22.000000', 'consum', 0.0229, 'lps'),
	(604058, 127, '2014-04-01 01:25:23.000000', 'consum', 0.0211, 'lps'),
	(604059, 127, '2014-04-01 01:25:24.000000', 'consum', 0.0228, 'lps'),
	(604060, 127, '2014-04-01 01:25:25.000000', 'consum', 0.0229, 'lps'),
	(604061, 127, '2014-04-01 01:25:26.000000', 'consum', 0.0231, 'lps'),
	(604062, 127, '2014-04-01 01:25:27.000000', 'consum', 0.0212, 'lps'),
	(604063, 127, '2014-04-01 01:25:28.000000', 'consum', 0.0225, 'lps'),
	(604064, 127, '2014-04-01 01:25:29.000000', 'consum', 0.0214, 'lps'),
	(604065, 127, '2014-04-01 01:25:30.000000', 'consum', 0.0230, 'lps'),
	(604066, 127, '2014-04-01 01:25:31.000000', 'consum', 0.0210, 'lps'),
	(604067, 127, '2014-04-01 01:25:32.000000', 'consum', 0.0218, 'lps'),
	(604068, 127, '2014-04-01 01:25:33.000000', 'consum', 0.0227, 'lps'),
	(604069, 127, '2014-04-01 01:25:34.000000', 'consum', 0.0227, 'lps'),
	(604070, 127, '2014-04-01 01:25:35.000000', 'consum', 0.0224, 'lps'),
	(604071, 127, '2014-04-01 01:25:36.000000', 'consum', 0.0227, 'lps'),
	(604072, 127, '2014-04-01 01:25:37.000000', 'consum', 0.0211, 'lps'),
	(604073, 127, '2014-04-01 01:25:38.000000', 'consum', 0.0210, 'lps'),
	(604074, 127, '2014-04-01 01:25:39.000000', 'consum', 0.0229, 'lps'),
	(604075, 127, '2014-04-01 01:25:40.000000', 'consum', 0.0215, 'lps'),
	(604076, 127, '2014-04-01 01:25:41.000000', 'consum', 0.0224, 'lps'),
	(604077, 127, '2014-04-01 01:25:42.000000', 'consum', 0.0220, 'lps'),
	(604078, 127, '2014-04-01 01:25:43.000000', 'consum', 0.0218, 'lps'),
	(604079, 127, '2014-04-01 01:25:44.000000', 'consum', 0.0220, 'lps'),
	(604080, 127, '2014-04-01 01:25:45.000000', 'consum', 0.0213, 'lps'),
	(604081, 127, '2014-04-01 01:25:46.000000', 'consum', 0.0221, 'lps'),
	(604082, 127, '2014-04-01 01:25:47.000000', 'consum', 0.0213, 'lps'),
	(604083, 127, '2014-04-01 01:25:48.000000', 'consum', 0.0214, 'lps'),
	(604084, 127, '2014-04-01 01:25:49.000000', 'consum', 0.0222, 'lps'),
	(604085, 127, '2014-04-01 01:25:50.000000', 'consum', 0.0215, 'lps'),
	(604086, 127, '2014-04-01 01:25:51.000000', 'consum', 0.0219, 'lps'),
	(604087, 127, '2014-04-01 01:25:52.000000', 'consum', 0.0221, 'lps'),
	(604088, 127, '2014-04-01 01:25:53.000000', 'consum', 0.0214, 'lps'),
	(604089, 127, '2014-04-01 01:25:54.000000', 'consum', 0.0222, 'lps'),
	(604090, 127, '2014-04-01 01:25:55.000000', 'consum', 0.0214, 'lps'),
	(604091, 127, '2014-04-01 01:25:56.000000', 'consum', 0.0216, 'lps'),
	(604092, 127, '2014-04-01 01:25:57.000000', 'consum', 0.0228, 'lps'),
	(604093, 127, '2014-04-01 01:25:58.000000', 'consum', 0.0218, 'lps'),
	(604094, 127, '2014-04-01 01:25:59.000000', 'consum', 0.0218, 'lps'),
	(604095, 127, '2014-04-01 01:26:00.000000', 'consum', 0.0225, 'lps'),
	(604096, 127, '2014-04-01 01:26:01.000000', 'consum', 0.0220, 'lps'),
	(604097, 127, '2014-04-01 01:26:02.000000', 'consum', 0.0215, 'lps'),
	(604098, 127, '2014-04-01 01:26:03.000000', 'consum', 0.0228, 'lps'),
	(604099, 127, '2014-04-01 01:26:04.000000', 'consum', 0.0218, 'lps'),
	(604100, 127, '2014-04-01 01:26:05.000000', 'consum', 0.0220, 'lps'),
	(604101, 127, '2014-04-01 01:26:06.000000', 'consum', 0.0213, 'lps'),
	(604102, 127, '2014-04-01 01:26:07.000000', 'consum', 0.0220, 'lps'),
	(604103, 127, '2014-04-01 01:26:08.000000', 'consum', 0.0229, 'lps'),
	(604104, 127, '2014-04-01 01:26:09.000000', 'consum', 0.0231, 'lps'),
	(604105, 127, '2014-04-01 01:26:10.000000', 'consum', 0.0216, 'lps'),
	(604106, 127, '2014-04-01 01:26:11.000000', 'consum', 0.0222, 'lps'),
	(604107, 127, '2014-04-01 01:26:12.000000', 'consum', 0.0230, 'lps'),
	(604108, 127, '2014-04-01 01:26:13.000000', 'consum', 0.0210, 'lps'),
	(604109, 127, '2014-04-01 01:26:14.000000', 'consum', 0.0213, 'lps'),
	(604110, 127, '2014-04-01 01:26:15.000000', 'consum', 0.0228, 'lps'),
	(604111, 127, '2014-04-01 01:26:16.000000', 'consum', 0.0226, 'lps'),
	(604112, 127, '2014-04-01 01:26:17.000000', 'consum', 0.0213, 'lps'),
	(604113, 127, '2014-04-01 01:26:18.000000', 'consum', 0.0220, 'lps'),
	(604114, 127, '2014-04-01 01:26:19.000000', 'consum', 0.0231, 'lps'),
	(604115, 127, '2014-04-01 01:26:20.000000', 'consum', 0.0221, 'lps'),
	(604116, 127, '2014-04-01 01:26:21.000000', 'consum', 0.0222, 'lps'),
	(604117, 127, '2014-04-01 01:26:22.000000', 'consum', 0.0214, 'lps'),
	(604118, 127, '2014-04-01 01:26:23.000000', 'consum', 0.0220, 'lps'),
	(604119, 127, '2014-04-01 01:26:24.000000', 'consum', 0.0225, 'lps'),
	(604120, 127, '2014-04-01 01:26:25.000000', 'consum', 0.0210, 'lps'),
	(604121, 127, '2014-04-01 01:26:26.000000', 'consum', 0.0212, 'lps'),
	(604122, 127, '2014-04-01 01:26:27.000000', 'consum', 0.0222, 'lps'),
	(604123, 127, '2014-04-01 01:26:28.000000', 'consum', 0.0217, 'lps'),
	(604124, 127, '2014-04-01 01:26:29.000000', 'consum', 0.0212, 'lps'),
	(604125, 127, '2014-04-01 01:26:30.000000', 'consum', 0.0221, 'lps'),
	(604126, 127, '2014-04-01 01:26:31.000000', 'consum', 0.0213, 'lps'),
	(604127, 127, '2014-04-01 01:26:32.000000', 'consum', 0.0217, 'lps'),
	(604128, 127, '2014-04-01 01:26:33.000000', 'consum', 0.0215, 'lps'),
	(604129, 127, '2014-04-01 01:26:34.000000', 'consum', 0.0214, 'lps'),
	(604130, 127, '2014-04-01 01:26:35.000000', 'consum', 0.0214, 'lps'),
	(604131, 127, '2014-04-01 01:26:36.000000', 'consum', 0.0218, 'lps'),
	(604132, 127, '2014-04-01 01:26:37.000000', 'consum', 0.0218, 'lps'),
	(604133, 127, '2014-04-01 01:26:38.000000', 'consum', 0.0226, 'lps'),
	(604134, 127, '2014-04-01 01:26:39.000000', 'consum', 0.0221, 'lps'),
	(604135, 127, '2014-04-01 01:26:40.000000', 'consum', 0.0219, 'lps'),
	(604136, 127, '2014-04-01 01:26:41.000000', 'consum', 0.0223, 'lps'),
	(604137, 127, '2014-04-01 01:26:42.000000', 'consum', 0.0227, 'lps'),
	(604138, 127, '2014-04-01 01:26:43.000000', 'consum', 0.0211, 'lps'),
	(604139, 127, '2014-04-01 01:26:44.000000', 'consum', 0.0230, 'lps'),
	(604140, 127, '2014-04-01 01:26:45.000000', 'consum', 0.0222, 'lps'),
	(604141, 127, '2014-04-01 01:26:46.000000', 'consum', 0.0231, 'lps'),
	(604142, 127, '2014-04-01 01:26:47.000000', 'consum', 0.0212, 'lps'),
	(604143, 127, '2014-04-01 01:26:48.000000', 'consum', 0.0226, 'lps'),
	(604144, 127, '2014-04-01 01:26:49.000000', 'consum', 0.0219, 'lps'),
	(604145, 127, '2014-04-01 01:26:50.000000', 'consum', 0.0231, 'lps'),
	(604146, 127, '2014-04-01 01:26:51.000000', 'consum', 0.0219, 'lps'),
	(604147, 127, '2014-04-01 01:26:52.000000', 'consum', 0.0216, 'lps'),
	(604148, 127, '2014-04-01 01:26:53.000000', 'consum', 0.0213, 'lps'),
	(604149, 127, '2014-04-01 01:26:54.000000', 'consum', 0.0230, 'lps'),
	(604150, 127, '2014-04-01 01:26:55.000000', 'consum', 0.0215, 'lps'),
	(604151, 127, '2014-04-01 01:26:56.000000', 'consum', 0.0217, 'lps'),
	(604152, 127, '2014-04-01 01:26:57.000000', 'consum', 0.0231, 'lps'),
	(604153, 127, '2014-04-01 01:26:58.000000', 'consum', 0.0229, 'lps'),
	(604154, 127, '2014-04-01 01:26:59.000000', 'consum', 0.0220, 'lps'),
	(604155, 127, '2014-04-01 01:27:00.000000', 'consum', 0.0226, 'lps'),
	(604156, 127, '2014-04-01 01:27:01.000000', 'consum', 0.0215, 'lps'),
	(604157, 127, '2014-04-01 01:27:02.000000', 'consum', 0.0231, 'lps'),
	(604158, 127, '2014-04-01 01:27:03.000000', 'consum', 0.0215, 'lps'),
	(604159, 127, '2014-04-01 01:27:04.000000', 'consum', 0.0215, 'lps'),
	(604160, 127, '2014-04-01 01:27:05.000000', 'consum', 0.0219, 'lps'),
	(604161, 127, '2014-04-01 01:27:06.000000', 'consum', 0.0221, 'lps'),
	(604162, 127, '2014-04-01 01:27:07.000000', 'consum', 0.0218, 'lps'),
	(604163, 127, '2014-04-01 01:27:08.000000', 'consum', 0.0214, 'lps'),
	(604164, 127, '2014-04-01 01:27:09.000000', 'consum', 0.0231, 'lps'),
	(604165, 127, '2014-04-01 01:27:10.000000', 'consum', 0.0213, 'lps'),
	(604166, 127, '2014-04-01 01:27:11.000000', 'consum', 0.0229, 'lps'),
	(604167, 127, '2014-04-01 01:27:12.000000', 'consum', 0.0229, 'lps'),
	(604168, 127, '2014-04-01 01:27:13.000000', 'consum', 0.0229, 'lps'),
	(604169, 127, '2014-04-01 01:27:14.000000', 'consum', 0.0225, 'lps'),
	(604170, 127, '2014-04-01 01:27:15.000000', 'consum', 0.0229, 'lps'),
	(604171, 127, '2014-04-01 01:27:16.000000', 'consum', 0.0216, 'lps'),
	(604172, 127, '2014-04-01 01:27:17.000000', 'consum', 0.0228, 'lps'),
	(604173, 127, '2014-04-01 01:27:18.000000', 'consum', 0.0218, 'lps'),
	(604174, 127, '2014-04-01 01:27:19.000000', 'consum', 0.0218, 'lps'),
	(604175, 127, '2014-04-01 01:27:20.000000', 'consum', 0.0228, 'lps'),
	(604176, 127, '2014-04-01 01:27:21.000000', 'consum', 0.0231, 'lps'),
	(604177, 127, '2014-04-01 01:27:22.000000', 'consum', 0.0217, 'lps'),
	(604178, 127, '2014-04-01 01:27:23.000000', 'consum', 0.0227, 'lps'),
	(604179, 127, '2014-04-01 01:27:24.000000', 'consum', 0.0230, 'lps'),
	(604180, 127, '2014-04-01 01:27:25.000000', 'consum', 0.0216, 'lps'),
	(604181, 127, '2014-04-01 01:27:26.000000', 'consum', 0.0225, 'lps'),
	(604182, 127, '2014-04-01 01:27:27.000000', 'consum', 0.0222, 'lps'),
	(604183, 127, '2014-04-01 01:27:28.000000', 'consum', 0.0226, 'lps'),
	(604184, 127, '2014-04-01 01:27:29.000000', 'consum', 0.0212, 'lps'),
	(604185, 127, '2014-04-01 01:27:30.000000', 'consum', 0.0213, 'lps'),
	(604186, 127, '2014-04-01 01:27:31.000000', 'consum', 0.0223, 'lps'),
	(604187, 127, '2014-04-01 01:27:32.000000', 'consum', 0.0222, 'lps'),
	(604188, 127, '2014-04-01 01:27:33.000000', 'consum', 0.0231, 'lps'),
	(604189, 127, '2014-04-01 01:27:34.000000', 'consum', 0.0213, 'lps'),
	(604190, 127, '2014-04-01 01:27:35.000000', 'consum', 0.0228, 'lps'),
	(604191, 127, '2014-04-01 01:27:36.000000', 'consum', 0.0228, 'lps'),
	(604192, 127, '2014-04-01 01:27:37.000000', 'consum', 0.0224, 'lps'),
	(604193, 127, '2014-04-01 01:27:38.000000', 'consum', 0.0225, 'lps'),
	(604194, 127, '2014-04-01 01:27:39.000000', 'consum', 0.0223, 'lps'),
	(604195, 127, '2014-04-01 01:27:40.000000', 'consum', 0.0230, 'lps'),
	(604196, 127, '2014-04-01 01:27:41.000000', 'consum', 0.0225, 'lps'),
	(604197, 127, '2014-04-01 01:27:42.000000', 'consum', 0.0229, 'lps'),
	(604198, 127, '2014-04-01 01:27:43.000000', 'consum', 0.0216, 'lps'),
	(604199, 127, '2014-04-01 01:27:44.000000', 'consum', 0.0227, 'lps'),
	(604200, 127, '2014-04-01 01:27:45.000000', 'consum', 0.0212, 'lps'),
	(604201, 127, '2014-04-01 01:27:46.000000', 'consum', 0.0211, 'lps'),
	(604202, 127, '2014-04-01 01:27:47.000000', 'consum', 0.0211, 'lps'),
	(604203, 127, '2014-04-01 01:27:48.000000', 'consum', 0.0214, 'lps'),
	(604204, 127, '2014-04-01 01:27:49.000000', 'consum', 0.0228, 'lps'),
	(604205, 127, '2014-04-01 01:27:50.000000', 'consum', 0.0222, 'lps'),
	(604206, 127, '2014-04-01 01:27:51.000000', 'consum', 0.0216, 'lps'),
	(604207, 127, '2014-04-01 01:27:52.000000', 'consum', 0.0225, 'lps'),
	(604208, 127, '2014-04-01 01:27:53.000000', 'consum', 0.0226, 'lps'),
	(604209, 127, '2014-04-01 01:27:54.000000', 'consum', 0.0223, 'lps'),
	(604210, 127, '2014-04-01 01:27:55.000000', 'consum', 0.0228, 'lps'),
	(604211, 127, '2014-04-01 01:27:56.000000', 'consum', 0.0215, 'lps'),
	(604212, 127, '2014-04-01 01:27:57.000000', 'consum', 0.0227, 'lps'),
	(604213, 127, '2014-04-01 01:27:58.000000', 'consum', 0.0216, 'lps'),
	(604214, 127, '2014-04-01 01:27:59.000000', 'consum', 0.0231, 'lps'),
	(604215, 127, '2014-04-01 01:28:00.000000', 'consum', 0.0230, 'lps'),
	(604216, 127, '2014-04-01 01:28:01.000000', 'consum', 0.0229, 'lps'),
	(604217, 127, '2014-04-01 01:28:02.000000', 'consum', 0.0221, 'lps'),
	(604218, 127, '2014-04-01 01:28:03.000000', 'consum', 0.0211, 'lps'),
	(604219, 127, '2014-04-01 01:28:04.000000', 'consum', 0.0224, 'lps'),
	(604220, 127, '2014-04-01 01:28:05.000000', 'consum', 0.0213, 'lps'),
	(604221, 127, '2014-04-01 01:28:06.000000', 'consum', 0.0228, 'lps'),
	(604222, 127, '2014-04-01 01:28:07.000000', 'consum', 0.0226, 'lps'),
	(604223, 127, '2014-04-01 01:28:08.000000', 'consum', 0.0214, 'lps'),
	(604224, 127, '2014-04-01 01:28:09.000000', 'consum', 0.0227, 'lps'),
	(604225, 127, '2014-04-01 01:28:10.000000', 'consum', 0.0217, 'lps'),
	(604226, 127, '2014-04-01 01:28:11.000000', 'consum', 0.0217, 'lps'),
	(604227, 127, '2014-04-01 01:28:12.000000', 'consum', 0.0222, 'lps'),
	(604228, 127, '2014-04-01 01:28:13.000000', 'consum', 0.0230, 'lps'),
	(604229, 127, '2014-04-01 01:28:14.000000', 'consum', 0.0231, 'lps'),
	(604230, 127, '2014-04-01 01:28:15.000000', 'consum', 0.0211, 'lps'),
	(604231, 127, '2014-04-01 01:28:16.000000', 'consum', 0.0218, 'lps'),
	(604232, 127, '2014-04-01 01:28:17.000000', 'consum', 0.0224, 'lps'),
	(604233, 127, '2014-04-01 01:28:18.000000', 'consum', 0.0214, 'lps'),
	(604234, 127, '2014-04-01 01:28:19.000000', 'consum', 0.0210, 'lps'),
	(604235, 127, '2014-04-01 01:28:20.000000', 'consum', 0.0219, 'lps'),
	(604236, 127, '2014-04-01 01:28:21.000000', 'consum', 0.0213, 'lps'),
	(604237, 127, '2014-04-01 01:28:22.000000', 'consum', 0.0219, 'lps'),
	(604238, 127, '2014-04-01 01:28:23.000000', 'consum', 0.0223, 'lps'),
	(604239, 127, '2014-04-01 01:28:24.000000', 'consum', 0.0230, 'lps'),
	(604240, 127, '2014-04-01 01:28:25.000000', 'consum', 0.0227, 'lps'),
	(604241, 127, '2014-04-01 01:28:26.000000', 'consum', 0.0212, 'lps'),
	(604242, 127, '2014-04-01 01:28:27.000000', 'consum', 0.0215, 'lps'),
	(604243, 127, '2014-04-01 01:28:28.000000', 'consum', 0.0230, 'lps'),
	(604244, 127, '2014-04-01 01:28:29.000000', 'consum', 0.0227, 'lps'),
	(604245, 127, '2014-04-01 01:28:30.000000', 'consum', 0.0217, 'lps'),
	(604246, 127, '2014-04-01 01:28:31.000000', 'consum', 0.0214, 'lps'),
	(604247, 127, '2014-04-01 01:28:32.000000', 'consum', 0.0211, 'lps'),
	(604248, 127, '2014-04-01 01:28:33.000000', 'consum', 0.0224, 'lps'),
	(604249, 127, '2014-04-01 01:28:34.000000', 'consum', 0.0211, 'lps'),
	(604250, 127, '2014-04-01 01:28:35.000000', 'consum', 0.0217, 'lps'),
	(604251, 127, '2014-04-01 01:28:36.000000', 'consum', 0.0220, 'lps'),
	(604252, 127, '2014-04-01 01:28:37.000000', 'consum', 0.0217, 'lps'),
	(604253, 127, '2014-04-01 01:28:38.000000', 'consum', 0.0215, 'lps'),
	(604254, 127, '2014-04-01 01:28:39.000000', 'consum', 0.0217, 'lps'),
	(604255, 127, '2014-04-01 01:28:40.000000', 'consum', 0.0229, 'lps'),
	(604256, 127, '2014-04-01 01:28:41.000000', 'consum', 0.0219, 'lps'),
	(604257, 127, '2014-04-01 01:28:42.000000', 'consum', 0.0222, 'lps'),
	(604258, 127, '2014-04-01 01:28:43.000000', 'consum', 0.0220, 'lps'),
	(604259, 127, '2014-04-01 01:28:44.000000', 'consum', 0.0224, 'lps'),
	(604260, 127, '2014-04-01 01:28:45.000000', 'consum', 0.0228, 'lps'),
	(604261, 127, '2014-04-01 01:28:46.000000', 'consum', 0.0214, 'lps'),
	(604262, 127, '2014-04-01 01:28:47.000000', 'consum', 0.0220, 'lps'),
	(604263, 127, '2014-04-01 01:28:48.000000', 'consum', 0.0227, 'lps'),
	(604264, 127, '2014-04-01 01:28:49.000000', 'consum', 0.0221, 'lps'),
	(604265, 127, '2014-04-01 01:28:50.000000', 'consum', 0.0217, 'lps'),
	(604266, 127, '2014-04-01 01:28:51.000000', 'consum', 0.0231, 'lps'),
	(604267, 127, '2014-04-01 01:28:52.000000', 'consum', 0.0210, 'lps'),
	(604268, 127, '2014-04-01 01:28:53.000000', 'consum', 0.0213, 'lps'),
	(604269, 127, '2014-04-01 01:28:54.000000', 'consum', 0.0223, 'lps'),
	(604270, 127, '2014-04-01 01:28:55.000000', 'consum', 0.0225, 'lps'),
	(604271, 127, '2014-04-01 01:28:56.000000', 'consum', 0.0223, 'lps'),
	(604272, 127, '2014-04-01 01:28:57.000000', 'consum', 0.0231, 'lps'),
	(604273, 127, '2014-04-01 01:28:58.000000', 'consum', 0.0210, 'lps'),
	(604274, 127, '2014-04-01 01:28:59.000000', 'consum', 0.0214, 'lps'),
	(604275, 127, '2014-04-01 01:29:00.000000', 'consum', 0.0231, 'lps'),
	(604276, 127, '2014-04-01 01:29:01.000000', 'consum', 0.0216, 'lps'),
	(604277, 127, '2014-04-01 01:29:02.000000', 'consum', 0.0219, 'lps'),
	(604278, 127, '2014-04-01 01:29:03.000000', 'consum', 0.0219, 'lps'),
	(604279, 127, '2014-04-01 01:29:04.000000', 'consum', 0.0226, 'lps'),
	(604280, 127, '2014-04-01 01:29:05.000000', 'consum', 0.0219, 'lps'),
	(604281, 127, '2014-04-01 01:29:06.000000', 'consum', 0.0229, 'lps'),
	(604282, 127, '2014-04-01 01:29:07.000000', 'consum', 0.0212, 'lps'),
	(604283, 127, '2014-04-01 01:29:08.000000', 'consum', 0.0229, 'lps'),
	(604284, 127, '2014-04-01 01:29:09.000000', 'consum', 0.0212, 'lps'),
	(604285, 127, '2014-04-01 01:29:10.000000', 'consum', 0.0231, 'lps'),
	(604286, 127, '2014-04-01 01:29:11.000000', 'consum', 0.0219, 'lps'),
	(604287, 127, '2014-04-01 01:29:12.000000', 'consum', 0.0217, 'lps'),
	(604288, 127, '2014-04-01 01:29:13.000000', 'consum', 0.0218, 'lps'),
	(604289, 127, '2014-04-01 01:29:14.000000', 'consum', 0.0230, 'lps'),
	(604290, 127, '2014-04-01 01:29:15.000000', 'consum', 0.0222, 'lps'),
	(604291, 127, '2014-04-01 01:29:16.000000', 'consum', 0.0231, 'lps'),
	(604292, 127, '2014-04-01 01:29:17.000000', 'consum', 0.0215, 'lps'),
	(604293, 127, '2014-04-01 01:29:18.000000', 'consum', 0.0216, 'lps'),
	(604294, 127, '2014-04-01 01:29:19.000000', 'consum', 0.0224, 'lps'),
	(604295, 127, '2014-04-01 01:29:20.000000', 'consum', 0.0220, 'lps'),
	(604296, 127, '2014-04-01 01:29:21.000000', 'consum', 0.0216, 'lps'),
	(604297, 127, '2014-04-01 01:29:22.000000', 'consum', 0.0214, 'lps'),
	(604298, 127, '2014-04-01 01:29:23.000000', 'consum', 0.0210, 'lps'),
	(604299, 127, '2014-04-01 01:29:24.000000', 'consum', 0.0223, 'lps'),
	(604300, 127, '2014-04-01 01:29:25.000000', 'consum', 0.0230, 'lps'),
	(604301, 127, '2014-04-01 01:29:26.000000', 'consum', 0.0226, 'lps'),
	(604302, 127, '2014-04-01 01:29:27.000000', 'consum', 0.0231, 'lps'),
	(604303, 127, '2014-04-01 01:29:28.000000', 'consum', 0.0224, 'lps'),
	(604304, 127, '2014-04-01 01:29:29.000000', 'consum', 0.0218, 'lps'),
	(604305, 127, '2014-04-01 01:29:30.000000', 'consum', 0.0210, 'lps'),
	(604306, 127, '2014-04-01 01:29:31.000000', 'consum', 0.0229, 'lps'),
	(604307, 127, '2014-04-01 01:29:32.000000', 'consum', 0.0218, 'lps'),
	(604308, 127, '2014-04-01 01:29:33.000000', 'consum', 0.0217, 'lps'),
	(604309, 127, '2014-04-01 01:29:34.000000', 'consum', 0.0221, 'lps'),
	(604310, 127, '2014-04-01 01:29:35.000000', 'consum', 0.0223, 'lps'),
	(604311, 127, '2014-04-01 01:29:36.000000', 'consum', 0.0220, 'lps'),
	(604312, 127, '2014-04-01 01:29:37.000000', 'consum', 0.0221, 'lps'),
	(604313, 127, '2014-04-01 01:29:38.000000', 'consum', 0.0213, 'lps'),
	(604314, 127, '2014-04-01 01:29:39.000000', 'consum', 0.0214, 'lps'),
	(604315, 127, '2014-04-01 01:29:40.000000', 'consum', 0.0222, 'lps'),
	(604316, 127, '2014-04-01 01:29:41.000000', 'consum', 0.0216, 'lps'),
	(604317, 127, '2014-04-01 01:29:42.000000', 'consum', 0.0224, 'lps'),
	(604318, 127, '2014-04-01 01:29:43.000000', 'consum', 0.0221, 'lps'),
	(604319, 127, '2014-04-01 01:29:44.000000', 'consum', 0.0221, 'lps'),
	(604320, 127, '2014-04-01 01:29:45.000000', 'consum', 0.0210, 'lps'),
	(604321, 127, '2014-04-01 01:29:46.000000', 'consum', 0.0221, 'lps'),
	(604322, 127, '2014-04-01 01:29:47.000000', 'consum', 0.0224, 'lps'),
	(604323, 127, '2014-04-01 01:29:48.000000', 'consum', 0.0223, 'lps'),
	(604324, 127, '2014-04-01 01:29:49.000000', 'consum', 0.0213, 'lps'),
	(604325, 127, '2014-04-01 01:29:50.000000', 'consum', 0.0231, 'lps'),
	(604326, 127, '2014-04-01 01:29:51.000000', 'consum', 0.0219, 'lps'),
	(604327, 127, '2014-04-01 01:29:52.000000', 'consum', 0.0216, 'lps'),
	(604328, 127, '2014-04-01 01:29:53.000000', 'consum', 0.0210, 'lps'),
	(604329, 127, '2014-04-01 01:29:54.000000', 'consum', 0.0217, 'lps'),
	(604330, 127, '2014-04-01 01:29:55.000000', 'consum', 0.0224, 'lps'),
	(604331, 127, '2014-04-01 01:29:56.000000', 'consum', 0.0213, 'lps'),
	(604332, 127, '2014-04-01 01:29:57.000000', 'consum', 0.0230, 'lps'),
	(604333, 127, '2014-04-01 01:29:58.000000', 'consum', 0.0212, 'lps'),
	(604334, 127, '2014-04-01 01:29:59.000000', 'consum', 0.0227, 'lps'),
	(604335, 127, '2014-04-01 01:30:00.000000', 'consum', 0.0222, 'lps'),
	(604336, 127, '2014-04-01 01:30:01.000000', 'consum', 0.0222, 'lps'),
	(604337, 127, '2014-04-01 01:30:02.000000', 'consum', 0.0210, 'lps'),
	(604338, 127, '2014-04-01 01:30:03.000000', 'consum', 0.0221, 'lps'),
	(604339, 127, '2014-04-01 01:30:04.000000', 'consum', 0.0222, 'lps'),
	(604340, 127, '2014-04-01 01:30:05.000000', 'consum', 0.0216, 'lps'),
	(604341, 127, '2014-04-01 01:30:06.000000', 'consum', 0.0224, 'lps'),
	(604342, 127, '2014-04-01 01:30:07.000000', 'consum', 0.0218, 'lps'),
	(604343, 127, '2014-04-01 01:30:08.000000', 'consum', 0.0211, 'lps'),
	(604344, 127, '2014-04-01 01:30:09.000000', 'consum', 0.0213, 'lps'),
	(604345, 127, '2014-04-01 01:30:10.000000', 'consum', 0.0221, 'lps'),
	(604346, 127, '2014-04-01 01:30:11.000000', 'consum', 0.0214, 'lps'),
	(604347, 127, '2014-04-01 01:30:12.000000', 'consum', 0.0219, 'lps'),
	(604348, 127, '2014-04-01 01:30:13.000000', 'consum', 0.0223, 'lps'),
	(604349, 127, '2014-04-01 01:30:14.000000', 'consum', 0.0227, 'lps'),
	(604350, 127, '2014-04-01 01:30:15.000000', 'consum', 0.0212, 'lps'),
	(604351, 127, '2014-04-01 01:30:16.000000', 'consum', 0.0213, 'lps'),
	(604352, 127, '2014-04-01 01:30:17.000000', 'consum', 0.0219, 'lps'),
	(604353, 127, '2014-04-01 01:30:18.000000', 'consum', 0.0224, 'lps'),
	(604354, 127, '2014-04-01 01:30:19.000000', 'consum', 0.0210, 'lps'),
	(604355, 127, '2014-04-01 01:30:20.000000', 'consum', 0.0213, 'lps'),
	(604356, 127, '2014-04-01 01:30:21.000000', 'consum', 0.0224, 'lps'),
	(604357, 127, '2014-04-01 01:30:22.000000', 'consum', 0.0228, 'lps'),
	(604358, 127, '2014-04-01 01:30:23.000000', 'consum', 0.0213, 'lps'),
	(604359, 127, '2014-04-01 01:30:24.000000', 'consum', 0.0215, 'lps'),
	(604360, 127, '2014-04-01 01:30:25.000000', 'consum', 0.0230, 'lps'),
	(604361, 127, '2014-04-01 01:30:26.000000', 'consum', 0.0227, 'lps'),
	(604362, 127, '2014-04-01 01:30:27.000000', 'consum', 0.0212, 'lps'),
	(604363, 127, '2014-04-01 01:30:28.000000', 'consum', 0.0215, 'lps'),
	(604364, 127, '2014-04-01 01:30:29.000000', 'consum', 0.0230, 'lps'),
	(604365, 127, '2014-04-01 01:30:30.000000', 'consum', 0.0228, 'lps'),
	(604366, 127, '2014-04-01 01:30:31.000000', 'consum', 0.0221, 'lps'),
	(604367, 127, '2014-04-01 01:30:32.000000', 'consum', 0.0231, 'lps'),
	(604368, 127, '2014-04-01 01:30:33.000000', 'consum', 0.0216, 'lps'),
	(604369, 127, '2014-04-01 01:30:34.000000', 'consum', 0.0224, 'lps'),
	(604370, 127, '2014-04-01 01:30:35.000000', 'consum', 0.0217, 'lps'),
	(604371, 127, '2014-04-01 01:30:36.000000', 'consum', 0.0224, 'lps'),
	(604372, 127, '2014-04-01 01:30:37.000000', 'consum', 0.0217, 'lps'),
	(604373, 127, '2014-04-01 01:30:38.000000', 'consum', 0.0226, 'lps'),
	(604374, 127, '2014-04-01 01:30:39.000000', 'consum', 0.0226, 'lps'),
	(604375, 127, '2014-04-01 01:30:40.000000', 'consum', 0.0219, 'lps'),
	(604376, 127, '2014-04-01 01:30:41.000000', 'consum', 0.0229, 'lps'),
	(604377, 127, '2014-04-01 01:30:42.000000', 'consum', 0.0212, 'lps'),
	(604378, 127, '2014-04-01 01:30:43.000000', 'consum', 0.0228, 'lps'),
	(604379, 127, '2014-04-01 01:30:44.000000', 'consum', 0.0210, 'lps'),
	(604380, 127, '2014-04-01 01:30:45.000000', 'consum', 0.0221, 'lps'),
	(604381, 127, '2014-04-01 01:30:46.000000', 'consum', 0.0221, 'lps'),
	(604382, 127, '2014-04-01 01:30:47.000000', 'consum', 0.0211, 'lps'),
	(604383, 127, '2014-04-01 01:30:48.000000', 'consum', 0.0227, 'lps'),
	(604384, 127, '2014-04-01 01:30:49.000000', 'consum', 0.0228, 'lps'),
	(604385, 127, '2014-04-01 01:30:50.000000', 'consum', 0.0224, 'lps'),
	(604386, 127, '2014-04-01 01:30:51.000000', 'consum', 0.0230, 'lps'),
	(604387, 127, '2014-04-01 01:30:52.000000', 'consum', 0.0222, 'lps'),
	(604388, 127, '2014-04-01 01:30:53.000000', 'consum', 0.0212, 'lps'),
	(604389, 127, '2014-04-01 01:30:54.000000', 'consum', 0.0227, 'lps'),
	(604390, 127, '2014-04-01 01:30:55.000000', 'consum', 0.0223, 'lps'),
	(604391, 127, '2014-04-01 01:30:56.000000', 'consum', 0.0225, 'lps'),
	(604392, 127, '2014-04-01 01:30:57.000000', 'consum', 0.0224, 'lps'),
	(604393, 127, '2014-04-01 01:30:58.000000', 'consum', 0.0216, 'lps'),
	(604394, 127, '2014-04-01 01:30:59.000000', 'consum', 0.0217, 'lps'),
	(604395, 127, '2014-04-01 01:31:00.000000', 'consum', 0.0229, 'lps'),
	(604396, 127, '2014-04-01 01:31:01.000000', 'consum', 0.0220, 'lps'),
	(604397, 127, '2014-04-01 01:31:02.000000', 'consum', 0.0226, 'lps'),
	(604398, 127, '2014-04-01 01:31:03.000000', 'consum', 0.0216, 'lps'),
	(604399, 127, '2014-04-01 01:31:04.000000', 'consum', 0.0213, 'lps'),
	(604400, 127, '2014-04-01 01:31:05.000000', 'consum', 0.0231, 'lps'),
	(604401, 127, '2014-04-01 01:31:06.000000', 'consum', 0.0220, 'lps'),
	(604402, 127, '2014-04-01 01:31:07.000000', 'consum', 0.0218, 'lps'),
	(604403, 127, '2014-04-01 01:31:08.000000', 'consum', 0.0223, 'lps'),
	(604404, 127, '2014-04-01 01:31:09.000000', 'consum', 0.0226, 'lps'),
	(604405, 127, '2014-04-01 01:31:10.000000', 'consum', 0.0210, 'lps'),
	(604406, 127, '2014-04-01 01:31:11.000000', 'consum', 0.0226, 'lps'),
	(604407, 127, '2014-04-01 01:31:12.000000', 'consum', 0.0225, 'lps'),
	(604408, 127, '2014-04-01 01:31:13.000000', 'consum', 0.0215, 'lps'),
	(604409, 127, '2014-04-01 01:31:14.000000', 'consum', 0.0214, 'lps'),
	(604410, 127, '2014-04-01 01:31:15.000000', 'consum', 0.0216, 'lps'),
	(604411, 127, '2014-04-01 01:31:16.000000', 'consum', 0.0226, 'lps'),
	(604412, 128, '2014-04-01 00:00:00.000000', 'consum', 0.0215, 'lps'),
	(604413, 128, '2014-04-01 00:00:01.000000', 'consum', 0.0214, 'lps'),
	(604414, 128, '2014-04-01 00:00:02.000000', 'consum', 0.0218, 'lps'),
	(604415, 128, '2014-04-01 00:00:03.000000', 'consum', 0.0219, 'lps'),
	(604416, 128, '2014-04-01 00:00:04.000000', 'consum', 0.0211, 'lps'),
	(604417, 128, '2014-04-01 00:00:05.000000', 'consum', 0.0218, 'lps'),
	(604418, 128, '2014-04-01 00:00:06.000000', 'consum', 0.0216, 'lps'),
	(604419, 128, '2014-04-01 00:00:07.000000', 'consum', 0.0219, 'lps'),
	(604420, 128, '2014-04-01 00:00:08.000000', 'consum', 0.0215, 'lps'),
	(604421, 128, '2014-04-01 00:00:09.000000', 'consum', 0.0210, 'lps'),
	(604422, 128, '2014-04-01 00:00:10.000000', 'consum', 0.0215, 'lps'),
	(604423, 128, '2014-04-01 00:00:11.000000', 'consum', 0.0215, 'lps'),
	(604424, 128, '2014-04-01 00:00:12.000000', 'consum', 0.0213, 'lps'),
	(604425, 128, '2014-04-01 00:00:13.000000', 'consum', 0.0219, 'lps'),
	(604426, 128, '2014-04-01 00:00:14.000000', 'consum', 0.0217, 'lps'),
	(604427, 128, '2014-04-01 00:00:15.000000', 'consum', 0.0218, 'lps'),
	(604428, 128, '2014-04-01 00:00:16.000000', 'consum', 0.0219, 'lps'),
	(604429, 128, '2014-04-01 00:00:17.000000', 'consum', 0.0212, 'lps'),
	(604430, 128, '2014-04-01 00:00:18.000000', 'consum', 0.0213, 'lps'),
	(604431, 128, '2014-04-01 00:00:19.000000', 'consum', 0.0218, 'lps'),
	(604432, 128, '2014-04-01 00:00:20.000000', 'consum', 0.0213, 'lps'),
	(604433, 128, '2014-04-01 00:00:21.000000', 'consum', 0.0210, 'lps'),
	(604434, 128, '2014-04-01 00:00:22.000000', 'consum', 0.0211, 'lps'),
	(604435, 128, '2014-04-01 00:00:23.000000', 'consum', 0.0215, 'lps'),
	(604436, 128, '2014-04-01 00:00:24.000000', 'consum', 0.0215, 'lps'),
	(604437, 128, '2014-04-01 00:00:25.000000', 'consum', 0.0210, 'lps'),
	(604438, 128, '2014-04-01 00:00:26.000000', 'consum', 0.0214, 'lps'),
	(604439, 128, '2014-04-01 00:00:27.000000', 'consum', 0.0210, 'lps'),
	(604440, 128, '2014-04-01 00:00:28.000000', 'consum', 0.0211, 'lps'),
	(604441, 128, '2014-04-01 00:00:29.000000', 'consum', 0.0214, 'lps'),
	(604442, 128, '2014-04-01 00:00:30.000000', 'consum', 0.0210, 'lps'),
	(604443, 128, '2014-04-01 00:00:31.000000', 'consum', 0.0217, 'lps'),
	(604444, 128, '2014-04-01 00:00:32.000000', 'consum', 0.0213, 'lps'),
	(604445, 128, '2014-04-01 00:00:33.000000', 'consum', 0.0218, 'lps'),
	(604446, 128, '2014-04-01 00:00:34.000000', 'consum', 0.0210, 'lps'),
	(604447, 128, '2014-04-01 00:00:35.000000', 'consum', 0.0219, 'lps'),
	(604448, 128, '2014-04-01 00:00:36.000000', 'consum', 0.0212, 'lps'),
	(604449, 128, '2014-04-01 00:00:37.000000', 'consum', 0.0216, 'lps'),
	(604450, 128, '2014-04-01 00:00:38.000000', 'consum', 0.0213, 'lps'),
	(604451, 128, '2014-04-01 00:00:39.000000', 'consum', 0.0218, 'lps'),
	(604452, 128, '2014-04-01 00:00:40.000000', 'consum', 0.0213, 'lps'),
	(604453, 128, '2014-04-01 00:00:41.000000', 'consum', 0.0219, 'lps'),
	(604454, 128, '2014-04-01 00:00:42.000000', 'consum', 0.0217, 'lps'),
	(604455, 128, '2014-04-01 00:00:43.000000', 'consum', 0.0218, 'lps'),
	(604456, 128, '2014-04-01 00:00:44.000000', 'consum', 0.0211, 'lps'),
	(604457, 128, '2014-04-01 00:00:45.000000', 'consum', 0.0210, 'lps'),
	(604458, 128, '2014-04-01 00:00:46.000000', 'consum', 0.0217, 'lps'),
	(604459, 128, '2014-04-01 00:00:47.000000', 'consum', 0.0217, 'lps'),
	(604460, 128, '2014-04-01 00:00:48.000000', 'consum', 0.0213, 'lps'),
	(604461, 128, '2014-04-01 00:00:49.000000', 'consum', 0.0214, 'lps'),
	(604462, 128, '2014-04-01 00:00:50.000000', 'consum', 0.0213, 'lps'),
	(604463, 128, '2014-04-01 00:00:51.000000', 'consum', 0.0214, 'lps'),
	(604464, 128, '2014-04-01 00:00:52.000000', 'consum', 0.0211, 'lps'),
	(604465, 128, '2014-04-01 00:00:53.000000', 'consum', 0.0212, 'lps'),
	(604466, 128, '2014-04-01 00:00:54.000000', 'consum', 0.0219, 'lps'),
	(604467, 128, '2014-04-01 00:00:55.000000', 'consum', 0.0210, 'lps'),
	(604468, 128, '2014-04-01 00:00:56.000000', 'consum', 0.0212, 'lps'),
	(604469, 128, '2014-04-01 00:00:57.000000', 'consum', 0.0213, 'lps'),
	(604470, 128, '2014-04-01 00:00:58.000000', 'consum', 0.0219, 'lps'),
	(604471, 128, '2014-04-01 00:00:59.000000', 'consum', 0.0214, 'lps'),
	(604472, 128, '2014-04-01 00:01:00.000000', 'consum', 0.0216, 'lps'),
	(604473, 128, '2014-04-01 00:01:01.000000', 'consum', 0.0217, 'lps'),
	(604474, 128, '2014-04-01 00:01:02.000000', 'consum', 0.0218, 'lps'),
	(604475, 128, '2014-04-01 00:01:03.000000', 'consum', 0.0219, 'lps'),
	(604476, 128, '2014-04-01 00:01:04.000000', 'consum', 0.0211, 'lps'),
	(604477, 128, '2014-04-01 00:01:05.000000', 'consum', 0.0218, 'lps'),
	(604478, 128, '2014-04-01 00:01:06.000000', 'consum', 0.0216, 'lps'),
	(604479, 128, '2014-04-01 00:01:07.000000', 'consum', 0.0219, 'lps'),
	(604480, 128, '2014-04-01 00:01:08.000000', 'consum', 0.0219, 'lps'),
	(604481, 128, '2014-04-01 00:01:09.000000', 'consum', 0.0217, 'lps'),
	(604482, 128, '2014-04-01 00:01:10.000000', 'consum', 0.0217, 'lps'),
	(604483, 128, '2014-04-01 00:01:11.000000', 'consum', 0.0217, 'lps'),
	(604484, 128, '2014-04-01 00:01:12.000000', 'consum', 0.0215, 'lps'),
	(604485, 128, '2014-04-01 00:01:13.000000', 'consum', 0.0212, 'lps'),
	(604486, 128, '2014-04-01 00:01:14.000000', 'consum', 0.0216, 'lps'),
	(604487, 128, '2014-04-01 00:01:15.000000', 'consum', 0.0214, 'lps'),
	(604488, 128, '2014-04-01 00:01:16.000000', 'consum', 0.0215, 'lps'),
	(604489, 128, '2014-04-01 00:01:17.000000', 'consum', 0.0211, 'lps'),
	(604490, 128, '2014-04-01 00:01:18.000000', 'consum', 0.0210, 'lps'),
	(604491, 128, '2014-04-01 00:01:19.000000', 'consum', 0.0210, 'lps'),
	(604492, 128, '2014-04-01 00:01:20.000000', 'consum', 0.0210, 'lps'),
	(604493, 128, '2014-04-01 00:01:21.000000', 'consum', 0.0211, 'lps'),
	(604494, 128, '2014-04-01 00:01:22.000000', 'consum', 0.0216, 'lps'),
	(604495, 128, '2014-04-01 00:01:23.000000', 'consum', 0.0216, 'lps'),
	(604496, 128, '2014-04-01 00:01:24.000000', 'consum', 0.0213, 'lps'),
	(604497, 128, '2014-04-01 00:01:25.000000', 'consum', 0.0218, 'lps'),
	(604498, 128, '2014-04-01 00:01:26.000000', 'consum', 0.0219, 'lps'),
	(604499, 128, '2014-04-01 00:01:27.000000', 'consum', 0.0213, 'lps'),
	(604500, 128, '2014-04-01 00:01:28.000000', 'consum', 0.0219, 'lps'),
	(604501, 128, '2014-04-01 00:01:29.000000', 'consum', 0.0215, 'lps'),
	(604502, 128, '2014-04-01 00:01:30.000000', 'consum', 0.0211, 'lps'),
	(604503, 128, '2014-04-01 00:01:31.000000', 'consum', 0.0218, 'lps'),
	(604504, 128, '2014-04-01 00:01:32.000000', 'consum', 0.0218, 'lps'),
	(604505, 128, '2014-04-01 00:01:33.000000', 'consum', 0.0219, 'lps'),
	(604506, 128, '2014-04-01 00:01:34.000000', 'consum', 0.0219, 'lps'),
	(604507, 128, '2014-04-01 00:01:35.000000', 'consum', 0.0210, 'lps'),
	(604508, 128, '2014-04-01 00:01:36.000000', 'consum', 0.0212, 'lps'),
	(604509, 128, '2014-04-01 00:01:37.000000', 'consum', 0.0211, 'lps'),
	(604510, 128, '2014-04-01 00:01:38.000000', 'consum', 0.0218, 'lps'),
	(604511, 128, '2014-04-01 00:01:39.000000', 'consum', 0.0217, 'lps'),
	(604512, 128, '2014-04-01 00:01:40.000000', 'consum', 0.0213, 'lps'),
	(604513, 128, '2014-04-01 00:01:41.000000', 'consum', 0.0216, 'lps'),
	(604514, 128, '2014-04-01 00:01:42.000000', 'consum', 0.0212, 'lps'),
	(604515, 128, '2014-04-01 00:01:43.000000', 'consum', 0.0219, 'lps'),
	(604516, 128, '2014-04-01 00:01:44.000000', 'consum', 0.0213, 'lps'),
	(604517, 128, '2014-04-01 00:01:45.000000', 'consum', 0.0218, 'lps'),
	(604518, 128, '2014-04-01 00:01:46.000000', 'consum', 0.0211, 'lps'),
	(604519, 128, '2014-04-01 00:01:47.000000', 'consum', 0.0211, 'lps'),
	(604520, 128, '2014-04-01 00:01:48.000000', 'consum', 0.0211, 'lps'),
	(604521, 128, '2014-04-01 00:01:49.000000', 'consum', 0.0214, 'lps'),
	(604522, 128, '2014-04-01 00:01:50.000000', 'consum', 0.0218, 'lps'),
	(604523, 128, '2014-04-01 00:01:51.000000', 'consum', 0.0210, 'lps'),
	(604524, 128, '2014-04-01 00:01:52.000000', 'consum', 0.0214, 'lps'),
	(604525, 128, '2014-04-01 00:01:53.000000', 'consum', 0.0212, 'lps'),
	(604526, 128, '2014-04-01 00:01:54.000000', 'consum', 0.0219, 'lps'),
	(604527, 128, '2014-04-01 00:01:55.000000', 'consum', 0.0210, 'lps'),
	(604528, 128, '2014-04-01 00:01:56.000000', 'consum', 0.0212, 'lps'),
	(604529, 128, '2014-04-01 00:01:57.000000', 'consum', 0.0212, 'lps'),
	(604530, 128, '2014-04-01 00:01:58.000000', 'consum', 0.0214, 'lps'),
	(604531, 128, '2014-04-01 00:01:59.000000', 'consum', 0.0213, 'lps'),
	(604532, 128, '2014-04-01 00:02:00.000000', 'consum', 0.0215, 'lps'),
	(604533, 128, '2014-04-01 00:02:01.000000', 'consum', 0.0214, 'lps'),
	(604534, 128, '2014-04-01 00:02:02.000000', 'consum', 0.0219, 'lps'),
	(604535, 128, '2014-04-01 00:02:03.000000', 'consum', 0.0210, 'lps'),
	(604536, 128, '2014-04-01 00:02:04.000000', 'consum', 0.0216, 'lps'),
	(604537, 128, '2014-04-01 00:02:05.000000', 'consum', 0.0219, 'lps'),
	(604538, 128, '2014-04-01 00:02:06.000000', 'consum', 0.0219, 'lps'),
	(604539, 128, '2014-04-01 00:02:07.000000', 'consum', 0.0219, 'lps'),
	(604540, 128, '2014-04-01 00:02:08.000000', 'consum', 0.0219, 'lps'),
	(604541, 128, '2014-04-01 00:02:09.000000', 'consum', 0.0216, 'lps'),
	(604542, 128, '2014-04-01 00:02:10.000000', 'consum', 0.0215, 'lps'),
	(604543, 128, '2014-04-01 00:02:11.000000', 'consum', 0.0217, 'lps'),
	(604544, 128, '2014-04-01 00:02:12.000000', 'consum', 0.0210, 'lps'),
	(604545, 128, '2014-04-01 00:02:13.000000', 'consum', 0.0218, 'lps'),
	(604546, 128, '2014-04-01 00:02:14.000000', 'consum', 0.0213, 'lps'),
	(604547, 128, '2014-04-01 00:02:15.000000', 'consum', 0.0210, 'lps'),
	(604548, 128, '2014-04-01 00:02:16.000000', 'consum', 0.0212, 'lps'),
	(604549, 128, '2014-04-01 00:02:17.000000', 'consum', 0.0218, 'lps'),
	(604550, 128, '2014-04-01 00:02:18.000000', 'consum', 0.0218, 'lps'),
	(604551, 128, '2014-04-01 00:02:19.000000', 'consum', 0.0216, 'lps'),
	(604552, 128, '2014-04-01 00:02:20.000000', 'consum', 0.0216, 'lps'),
	(604553, 128, '2014-04-01 00:02:21.000000', 'consum', 0.0213, 'lps'),
	(604554, 128, '2014-04-01 00:02:22.000000', 'consum', 0.0219, 'lps'),
	(604555, 128, '2014-04-01 00:02:23.000000', 'consum', 0.0215, 'lps'),
	(604556, 128, '2014-04-01 00:02:24.000000', 'consum', 0.0210, 'lps'),
	(604557, 128, '2014-04-01 00:02:25.000000', 'consum', 0.0213, 'lps'),
	(604558, 128, '2014-04-01 00:02:26.000000', 'consum', 0.0219, 'lps'),
	(604559, 128, '2014-04-01 00:02:27.000000', 'consum', 0.0214, 'lps'),
	(604560, 128, '2014-04-01 00:02:28.000000', 'consum', 0.0212, 'lps'),
	(604561, 128, '2014-04-01 00:02:29.000000', 'consum', 0.0211, 'lps'),
	(604562, 128, '2014-04-01 00:02:30.000000', 'consum', 0.0219, 'lps'),
	(604563, 128, '2014-04-01 00:02:31.000000', 'consum', 0.0214, 'lps'),
	(604564, 128, '2014-04-01 00:02:32.000000', 'consum', 0.0212, 'lps'),
	(604565, 128, '2014-04-01 00:02:33.000000', 'consum', 0.0218, 'lps'),
	(604566, 128, '2014-04-01 00:02:34.000000', 'consum', 0.0213, 'lps'),
	(604567, 128, '2014-04-01 00:02:35.000000', 'consum', 0.0214, 'lps'),
	(604568, 128, '2014-04-01 00:02:36.000000', 'consum', 0.0211, 'lps'),
	(604569, 128, '2014-04-01 00:02:37.000000', 'consum', 0.0215, 'lps'),
	(604570, 128, '2014-04-01 00:02:38.000000', 'consum', 0.0210, 'lps'),
	(604571, 128, '2014-04-01 00:02:39.000000', 'consum', 0.0217, 'lps'),
	(604572, 128, '2014-04-01 00:02:40.000000', 'consum', 0.0215, 'lps'),
	(604573, 128, '2014-04-01 00:02:41.000000', 'consum', 0.0214, 'lps'),
	(604574, 128, '2014-04-01 00:02:42.000000', 'consum', 0.0215, 'lps'),
	(604575, 128, '2014-04-01 00:02:43.000000', 'consum', 0.0215, 'lps'),
	(604576, 128, '2014-04-01 00:02:44.000000', 'consum', 0.0211, 'lps'),
	(604577, 128, '2014-04-01 00:02:45.000000', 'consum', 0.0211, 'lps'),
	(604578, 128, '2014-04-01 00:02:46.000000', 'consum', 0.0214, 'lps'),
	(604579, 128, '2014-04-01 00:02:47.000000', 'consum', 0.0214, 'lps'),
	(604580, 128, '2014-04-01 00:02:48.000000', 'consum', 0.0219, 'lps'),
	(604581, 128, '2014-04-01 00:02:49.000000', 'consum', 0.0213, 'lps'),
	(604582, 128, '2014-04-01 00:02:50.000000', 'consum', 0.0217, 'lps'),
	(604583, 128, '2014-04-01 00:02:51.000000', 'consum', 0.0210, 'lps'),
	(604584, 128, '2014-04-01 00:02:52.000000', 'consum', 0.0218, 'lps'),
	(604585, 128, '2014-04-01 00:02:53.000000', 'consum', 0.0210, 'lps'),
	(604586, 128, '2014-04-01 00:02:54.000000', 'consum', 0.0218, 'lps'),
	(604587, 128, '2014-04-01 00:02:55.000000', 'consum', 0.0211, 'lps'),
	(604588, 128, '2014-04-01 00:02:56.000000', 'consum', 0.0212, 'lps'),
	(604589, 128, '2014-04-01 00:02:57.000000', 'consum', 0.0219, 'lps'),
	(604590, 128, '2014-04-01 00:02:58.000000', 'consum', 0.0216, 'lps'),
	(604591, 128, '2014-04-01 00:02:59.000000', 'consum', 0.0216, 'lps'),
	(604592, 128, '2014-04-01 00:03:00.000000', 'consum', 0.0213, 'lps'),
	(604593, 128, '2014-04-01 00:03:01.000000', 'consum', 0.0216, 'lps'),
	(604594, 128, '2014-04-01 00:03:02.000000', 'consum', 0.0210, 'lps'),
	(604595, 128, '2014-04-01 00:03:03.000000', 'consum', 0.0215, 'lps'),
	(604596, 128, '2014-04-01 00:03:04.000000', 'consum', 0.0213, 'lps'),
	(604597, 128, '2014-04-01 00:03:05.000000', 'consum', 0.0213, 'lps'),
	(604598, 128, '2014-04-01 00:03:06.000000', 'consum', 0.0215, 'lps'),
	(604599, 128, '2014-04-01 00:03:07.000000', 'consum', 0.0215, 'lps'),
	(604600, 128, '2014-04-01 00:03:08.000000', 'consum', 0.0213, 'lps'),
	(604601, 128, '2014-04-01 00:03:09.000000', 'consum', 0.0210, 'lps'),
	(604602, 128, '2014-04-01 00:03:10.000000', 'consum', 0.0212, 'lps'),
	(604603, 128, '2014-04-01 00:03:11.000000', 'consum', 0.0212, 'lps'),
	(604604, 128, '2014-04-01 00:03:12.000000', 'consum', 0.0211, 'lps'),
	(604605, 128, '2014-04-01 00:03:13.000000', 'consum', 0.0212, 'lps'),
	(604606, 128, '2014-04-01 00:03:14.000000', 'consum', 0.0219, 'lps'),
	(604607, 128, '2014-04-01 00:03:15.000000', 'consum', 0.0217, 'lps'),
	(604608, 128, '2014-04-01 00:03:16.000000', 'consum', 0.0219, 'lps'),
	(604609, 128, '2014-04-01 00:03:17.000000', 'consum', 0.0213, 'lps'),
	(604610, 128, '2014-04-01 00:03:18.000000', 'consum', 0.0211, 'lps'),
	(604611, 128, '2014-04-01 00:03:19.000000', 'consum', 0.0217, 'lps'),
	(604612, 128, '2014-04-01 00:03:20.000000', 'consum', 0.0211, 'lps'),
	(604613, 128, '2014-04-01 00:03:21.000000', 'consum', 0.0216, 'lps'),
	(604614, 128, '2014-04-01 00:03:22.000000', 'consum', 0.0219, 'lps'),
	(604615, 128, '2014-04-01 00:03:23.000000', 'consum', 0.0215, 'lps'),
	(604616, 128, '2014-04-01 00:03:24.000000', 'consum', 0.0217, 'lps'),
	(604617, 128, '2014-04-01 00:03:25.000000', 'consum', 0.0213, 'lps'),
	(604618, 128, '2014-04-01 00:03:26.000000', 'consum', 0.0215, 'lps'),
	(604619, 128, '2014-04-01 00:03:27.000000', 'consum', 0.0217, 'lps'),
	(604620, 128, '2014-04-01 00:03:28.000000', 'consum', 0.0211, 'lps'),
	(604621, 128, '2014-04-01 00:03:29.000000', 'consum', 0.0214, 'lps'),
	(604622, 128, '2014-04-01 00:03:30.000000', 'consum', 0.0218, 'lps'),
	(604623, 128, '2014-04-01 00:03:31.000000', 'consum', 0.0216, 'lps'),
	(604624, 128, '2014-04-01 00:03:32.000000', 'consum', 0.0217, 'lps'),
	(604625, 128, '2014-04-01 00:03:33.000000', 'consum', 0.0217, 'lps'),
	(604626, 128, '2014-04-01 00:03:34.000000', 'consum', 0.0217, 'lps'),
	(604627, 128, '2014-04-01 00:03:35.000000', 'consum', 0.0212, 'lps'),
	(604628, 128, '2014-04-01 00:03:36.000000', 'consum', 0.0211, 'lps'),
	(604629, 128, '2014-04-01 00:03:37.000000', 'consum', 0.0217, 'lps'),
	(604630, 128, '2014-04-01 00:03:38.000000', 'consum', 0.0216, 'lps'),
	(604631, 128, '2014-04-01 00:03:39.000000', 'consum', 0.0216, 'lps'),
	(604632, 128, '2014-04-01 00:03:40.000000', 'consum', 0.0214, 'lps'),
	(604633, 128, '2014-04-01 00:03:41.000000', 'consum', 0.0211, 'lps'),
	(604634, 128, '2014-04-01 00:03:42.000000', 'consum', 0.0216, 'lps'),
	(604635, 128, '2014-04-01 00:03:43.000000', 'consum', 0.0218, 'lps'),
	(604636, 128, '2014-04-01 00:03:44.000000', 'consum', 0.0210, 'lps'),
	(604637, 128, '2014-04-01 00:03:45.000000', 'consum', 0.0219, 'lps'),
	(604638, 128, '2014-04-01 00:03:46.000000', 'consum', 0.0216, 'lps'),
	(604639, 128, '2014-04-01 00:03:47.000000', 'consum', 0.0213, 'lps'),
	(604640, 128, '2014-04-01 00:03:48.000000', 'consum', 0.0218, 'lps'),
	(604641, 128, '2014-04-01 00:03:49.000000', 'consum', 0.0219, 'lps'),
	(604642, 128, '2014-04-01 00:03:50.000000', 'consum', 0.0212, 'lps'),
	(604643, 128, '2014-04-01 00:03:51.000000', 'consum', 0.0215, 'lps'),
	(604644, 128, '2014-04-01 00:03:52.000000', 'consum', 0.0218, 'lps'),
	(604645, 128, '2014-04-01 00:03:53.000000', 'consum', 0.0216, 'lps'),
	(604646, 128, '2014-04-01 00:03:54.000000', 'consum', 0.0217, 'lps'),
	(604647, 128, '2014-04-01 00:03:55.000000', 'consum', 0.0215, 'lps'),
	(604648, 128, '2014-04-01 00:03:56.000000', 'consum', 0.0218, 'lps'),
	(604649, 128, '2014-04-01 00:03:57.000000', 'consum', 0.0215, 'lps'),
	(604650, 128, '2014-04-01 00:03:58.000000', 'consum', 0.0210, 'lps'),
	(604651, 128, '2014-04-01 00:03:59.000000', 'consum', 0.0215, 'lps'),
	(604652, 128, '2014-04-01 00:04:00.000000', 'consum', 0.0216, 'lps'),
	(604653, 128, '2014-04-01 00:04:01.000000', 'consum', 0.0215, 'lps'),
	(604654, 128, '2014-04-01 00:04:02.000000', 'consum', 0.0219, 'lps'),
	(604655, 128, '2014-04-01 00:04:03.000000', 'consum', 0.0219, 'lps'),
	(604656, 128, '2014-04-01 00:04:04.000000', 'consum', 0.0211, 'lps'),
	(604657, 128, '2014-04-01 00:04:05.000000', 'consum', 0.0215, 'lps'),
	(604658, 128, '2014-04-01 00:04:06.000000', 'consum', 0.0215, 'lps'),
	(604659, 128, '2014-04-01 00:04:07.000000', 'consum', 0.0212, 'lps'),
	(604660, 128, '2014-04-01 00:04:08.000000', 'consum', 0.0213, 'lps'),
	(604661, 128, '2014-04-01 00:04:09.000000', 'consum', 0.0210, 'lps'),
	(604662, 128, '2014-04-01 00:04:10.000000', 'consum', 0.0211, 'lps'),
	(604663, 128, '2014-04-01 00:04:11.000000', 'consum', 0.0216, 'lps'),
	(604664, 128, '2014-04-01 00:04:12.000000', 'consum', 0.0216, 'lps'),
	(604665, 128, '2014-04-01 00:04:13.000000', 'consum', 0.0212, 'lps'),
	(604666, 128, '2014-04-01 00:04:14.000000', 'consum', 0.0215, 'lps'),
	(604667, 128, '2014-04-01 00:04:15.000000', 'consum', 0.0211, 'lps'),
	(604668, 128, '2014-04-01 00:04:16.000000', 'consum', 0.0217, 'lps'),
	(604669, 128, '2014-04-01 00:04:17.000000', 'consum', 0.0214, 'lps'),
	(604670, 128, '2014-04-01 00:04:18.000000', 'consum', 0.0210, 'lps'),
	(604671, 128, '2014-04-01 00:04:19.000000', 'consum', 0.0219, 'lps'),
	(604672, 128, '2014-04-01 00:04:20.000000', 'consum', 0.0214, 'lps'),
	(604673, 128, '2014-04-01 00:04:21.000000', 'consum', 0.0215, 'lps'),
	(604674, 128, '2014-04-01 00:04:22.000000', 'consum', 0.0211, 'lps'),
	(604675, 128, '2014-04-01 00:04:23.000000', 'consum', 0.0214, 'lps'),
	(604676, 128, '2014-04-01 00:04:24.000000', 'consum', 0.0214, 'lps'),
	(604677, 128, '2014-04-01 00:04:25.000000', 'consum', 0.0212, 'lps'),
	(604678, 128, '2014-04-01 00:04:26.000000', 'consum', 0.0216, 'lps'),
	(604679, 128, '2014-04-01 00:04:27.000000', 'consum', 0.0215, 'lps'),
	(604680, 128, '2014-04-01 00:04:28.000000', 'consum', 0.0216, 'lps'),
	(604681, 128, '2014-04-01 00:04:29.000000', 'consum', 0.0216, 'lps'),
	(604682, 128, '2014-04-01 00:04:30.000000', 'consum', 0.0213, 'lps'),
	(604683, 128, '2014-04-01 00:04:31.000000', 'consum', 0.0218, 'lps'),
	(604684, 128, '2014-04-01 00:04:32.000000', 'consum', 0.0210, 'lps'),
	(604685, 128, '2014-04-01 00:04:33.000000', 'consum', 0.0218, 'lps'),
	(604686, 128, '2014-04-01 00:04:34.000000', 'consum', 0.0210, 'lps'),
	(604687, 128, '2014-04-01 00:04:35.000000', 'consum', 0.0218, 'lps'),
	(604688, 128, '2014-04-01 00:04:36.000000', 'consum', 0.0212, 'lps'),
	(604689, 128, '2014-04-01 00:04:37.000000', 'consum', 0.0213, 'lps'),
	(604690, 128, '2014-04-01 00:04:38.000000', 'consum', 0.0210, 'lps'),
	(604691, 128, '2014-04-01 00:04:39.000000', 'consum', 0.0211, 'lps'),
	(604692, 128, '2014-04-01 00:04:40.000000', 'consum', 0.0218, 'lps'),
	(604693, 128, '2014-04-01 00:04:41.000000', 'consum', 0.0216, 'lps'),
	(604694, 128, '2014-04-01 00:04:42.000000', 'consum', 0.0218, 'lps'),
	(604695, 128, '2014-04-01 00:04:43.000000', 'consum', 0.0210, 'lps'),
	(604696, 128, '2014-04-01 00:04:44.000000', 'consum', 0.0219, 'lps'),
	(604697, 128, '2014-04-01 00:04:45.000000', 'consum', 0.0214, 'lps'),
	(604698, 128, '2014-04-01 00:04:46.000000', 'consum', 0.0215, 'lps'),
	(604699, 128, '2014-04-01 00:04:47.000000', 'consum', 0.0213, 'lps'),
	(604700, 128, '2014-04-01 00:04:48.000000', 'consum', 0.0219, 'lps'),
	(604701, 128, '2014-04-01 00:04:49.000000', 'consum', 0.0219, 'lps'),
	(604702, 128, '2014-04-01 00:04:50.000000', 'consum', 0.0216, 'lps'),
	(604703, 128, '2014-04-01 00:04:51.000000', 'consum', 0.0214, 'lps'),
	(604704, 128, '2014-04-01 00:04:52.000000', 'consum', 0.0214, 'lps'),
	(604705, 128, '2014-04-01 00:04:53.000000', 'consum', 0.0218, 'lps'),
	(604706, 128, '2014-04-01 00:04:54.000000', 'consum', 0.0210, 'lps'),
	(604707, 128, '2014-04-01 00:04:55.000000', 'consum', 0.0216, 'lps'),
	(604708, 128, '2014-04-01 00:04:56.000000', 'consum', 0.0211, 'lps'),
	(604709, 128, '2014-04-01 00:04:57.000000', 'consum', 0.0218, 'lps'),
	(604710, 128, '2014-04-01 00:04:58.000000', 'consum', 0.0216, 'lps'),
	(604711, 128, '2014-04-01 00:04:59.000000', 'consum', 0.0216, 'lps'),
	(604712, 128, '2014-04-01 00:05:00.000000', 'consum', 0.0214, 'lps'),
	(604713, 128, '2014-04-01 00:05:01.000000', 'consum', 0.0213, 'lps'),
	(604714, 128, '2014-04-01 00:05:02.000000', 'consum', 0.0211, 'lps'),
	(604715, 128, '2014-04-01 00:05:03.000000', 'consum', 0.0218, 'lps'),
	(604716, 128, '2014-04-01 00:05:04.000000', 'consum', 0.0217, 'lps'),
	(604717, 128, '2014-04-01 00:05:05.000000', 'consum', 0.0213, 'lps'),
	(604718, 128, '2014-04-01 00:05:06.000000', 'consum', 0.0215, 'lps'),
	(604719, 128, '2014-04-01 00:05:07.000000', 'consum', 0.0215, 'lps'),
	(604720, 128, '2014-04-01 00:05:08.000000', 'consum', 0.0210, 'lps'),
	(604721, 128, '2014-04-01 00:05:09.000000', 'consum', 0.0214, 'lps'),
	(604722, 128, '2014-04-01 00:05:10.000000', 'consum', 0.0212, 'lps'),
	(604723, 128, '2014-04-01 00:05:11.000000', 'consum', 0.0218, 'lps'),
	(604724, 128, '2014-04-01 00:05:12.000000', 'consum', 0.0216, 'lps'),
	(604725, 128, '2014-04-01 00:05:13.000000', 'consum', 0.0216, 'lps'),
	(604726, 128, '2014-04-01 00:05:14.000000', 'consum', 0.0214, 'lps'),
	(604727, 128, '2014-04-01 00:05:15.000000', 'consum', 0.0219, 'lps'),
	(604728, 128, '2014-04-01 00:05:16.000000', 'consum', 0.0216, 'lps'),
	(604729, 128, '2014-04-01 00:05:17.000000', 'consum', 0.0214, 'lps'),
	(604730, 128, '2014-04-01 00:05:18.000000', 'consum', 0.0210, 'lps'),
	(604731, 128, '2014-04-01 00:05:19.000000', 'consum', 0.0219, 'lps'),
	(604732, 128, '2014-04-01 00:05:20.000000', 'consum', 0.0215, 'lps'),
	(604733, 128, '2014-04-01 00:05:21.000000', 'consum', 0.0210, 'lps'),
	(604734, 128, '2014-04-01 00:05:22.000000', 'consum', 0.0217, 'lps'),
	(604735, 128, '2014-04-01 00:05:23.000000', 'consum', 0.0213, 'lps'),
	(604736, 128, '2014-04-01 00:05:24.000000', 'consum', 0.0217, 'lps'),
	(604737, 128, '2014-04-01 00:05:25.000000', 'consum', 0.0217, 'lps'),
	(604738, 128, '2014-04-01 00:05:26.000000', 'consum', 0.0213, 'lps'),
	(604739, 128, '2014-04-01 00:05:27.000000', 'consum', 0.0215, 'lps'),
	(604740, 128, '2014-04-01 00:05:28.000000', 'consum', 0.0215, 'lps'),
	(604741, 128, '2014-04-01 00:05:29.000000', 'consum', 0.0212, 'lps'),
	(604742, 128, '2014-04-01 00:05:30.000000', 'consum', 0.0216, 'lps'),
	(604743, 128, '2014-04-01 00:05:31.000000', 'consum', 0.0213, 'lps'),
	(604744, 128, '2014-04-01 00:05:32.000000', 'consum', 0.0218, 'lps'),
	(604745, 128, '2014-04-01 00:05:33.000000', 'consum', 0.0212, 'lps'),
	(604746, 128, '2014-04-01 00:05:34.000000', 'consum', 0.0216, 'lps'),
	(604747, 128, '2014-04-01 00:05:35.000000', 'consum', 0.0215, 'lps'),
	(604748, 128, '2014-04-01 00:05:36.000000', 'consum', 0.0219, 'lps'),
	(604749, 128, '2014-04-01 00:05:37.000000', 'consum', 0.0210, 'lps'),
	(604750, 128, '2014-04-01 00:05:38.000000', 'consum', 0.0215, 'lps'),
	(604751, 128, '2014-04-01 00:05:39.000000', 'consum', 0.0213, 'lps'),
	(604752, 128, '2014-04-01 00:05:40.000000', 'consum', 0.0211, 'lps'),
	(604753, 128, '2014-04-01 00:05:41.000000', 'consum', 0.0219, 'lps'),
	(604754, 128, '2014-04-01 00:05:42.000000', 'consum', 0.0219, 'lps'),
	(604755, 128, '2014-04-01 00:05:43.000000', 'consum', 0.0212, 'lps'),
	(604756, 128, '2014-04-01 00:05:44.000000', 'consum', 0.0211, 'lps'),
	(604757, 128, '2014-04-01 00:05:45.000000', 'consum', 0.0211, 'lps'),
	(604758, 128, '2014-04-01 00:05:46.000000', 'consum', 0.0212, 'lps'),
	(604759, 128, '2014-04-01 00:05:47.000000', 'consum', 0.0218, 'lps'),
	(604760, 128, '2014-04-01 00:05:48.000000', 'consum', 0.0212, 'lps'),
	(604761, 128, '2014-04-01 00:05:49.000000', 'consum', 0.0210, 'lps'),
	(604762, 128, '2014-04-01 00:05:50.000000', 'consum', 0.0213, 'lps'),
	(604763, 128, '2014-04-01 00:05:51.000000', 'consum', 0.0217, 'lps'),
	(604764, 128, '2014-04-01 00:05:52.000000', 'consum', 0.0215, 'lps'),
	(604765, 128, '2014-04-01 00:05:53.000000', 'consum', 0.0215, 'lps'),
	(604766, 128, '2014-04-01 00:05:54.000000', 'consum', 0.0210, 'lps'),
	(604767, 128, '2014-04-01 00:05:55.000000', 'consum', 0.0218, 'lps'),
	(604768, 128, '2014-04-01 00:05:56.000000', 'consum', 0.0217, 'lps'),
	(604769, 128, '2014-04-01 00:05:57.000000', 'consum', 0.0214, 'lps'),
	(604770, 128, '2014-04-01 00:05:58.000000', 'consum', 0.0210, 'lps'),
	(604771, 128, '2014-04-01 00:05:59.000000', 'consum', 0.0216, 'lps'),
	(604772, 128, '2014-04-01 00:06:00.000000', 'consum', 0.0213, 'lps'),
	(604773, 128, '2014-04-01 00:06:01.000000', 'consum', 0.0218, 'lps'),
	(604774, 128, '2014-04-01 00:06:02.000000', 'consum', 0.0218, 'lps'),
	(604775, 128, '2014-04-01 00:06:03.000000', 'consum', 0.0210, 'lps'),
	(604776, 128, '2014-04-01 00:06:04.000000', 'consum', 0.0216, 'lps'),
	(604777, 128, '2014-04-01 00:06:05.000000', 'consum', 0.0211, 'lps'),
	(604778, 128, '2014-04-01 00:06:06.000000', 'consum', 0.0218, 'lps'),
	(604779, 128, '2014-04-01 00:06:07.000000', 'consum', 0.0215, 'lps'),
	(604780, 128, '2014-04-01 00:06:08.000000', 'consum', 0.0212, 'lps'),
	(604781, 128, '2014-04-01 00:06:09.000000', 'consum', 0.0215, 'lps'),
	(604782, 128, '2014-04-01 00:06:10.000000', 'consum', 0.0210, 'lps'),
	(604783, 128, '2014-04-01 00:06:11.000000', 'consum', 0.0217, 'lps'),
	(604784, 128, '2014-04-01 00:06:12.000000', 'consum', 0.0213, 'lps'),
	(604785, 128, '2014-04-01 00:06:13.000000', 'consum', 0.0217, 'lps'),
	(604786, 128, '2014-04-01 00:06:14.000000', 'consum', 0.0217, 'lps'),
	(604787, 128, '2014-04-01 00:06:15.000000', 'consum', 0.0215, 'lps'),
	(604788, 128, '2014-04-01 00:06:16.000000', 'consum', 0.0211, 'lps'),
	(604789, 128, '2014-04-01 00:06:17.000000', 'consum', 0.0214, 'lps'),
	(604790, 128, '2014-04-01 00:06:18.000000', 'consum', 0.0215, 'lps'),
	(604791, 128, '2014-04-01 00:06:19.000000', 'consum', 0.0213, 'lps'),
	(604792, 128, '2014-04-01 00:06:20.000000', 'consum', 0.0210, 'lps'),
	(604793, 128, '2014-04-01 00:06:21.000000', 'consum', 0.0211, 'lps'),
	(604794, 128, '2014-04-01 00:06:22.000000', 'consum', 0.0216, 'lps'),
	(604795, 128, '2014-04-01 00:06:23.000000', 'consum', 0.0217, 'lps'),
	(604796, 128, '2014-04-01 00:06:24.000000', 'consum', 0.0218, 'lps'),
	(604797, 128, '2014-04-01 00:06:25.000000', 'consum', 0.0219, 'lps'),
	(604798, 128, '2014-04-01 00:06:26.000000', 'consum', 0.0212, 'lps'),
	(604799, 128, '2014-04-01 00:06:27.000000', 'consum', 0.0216, 'lps'),
	(604800, 128, '2014-04-01 00:06:28.000000', 'consum', 0.0211, 'lps'),
	(604801, 128, '2014-04-01 00:06:29.000000', 'consum', 0.0218, 'lps'),
	(604802, 128, '2014-04-01 00:06:30.000000', 'consum', 0.0219, 'lps'),
	(604803, 128, '2014-04-01 00:06:31.000000', 'consum', 0.0210, 'lps'),
	(604804, 128, '2014-04-01 00:06:32.000000', 'consum', 0.0214, 'lps'),
	(604805, 128, '2014-04-01 00:06:33.000000', 'consum', 0.0219, 'lps'),
	(604806, 128, '2014-04-01 00:06:34.000000', 'consum', 0.0213, 'lps'),
	(604807, 128, '2014-04-01 00:06:35.000000', 'consum', 0.0219, 'lps'),
	(604808, 128, '2014-04-01 00:06:36.000000', 'consum', 0.0216, 'lps'),
	(604809, 128, '2014-04-01 00:06:37.000000', 'consum', 0.0214, 'lps'),
	(604810, 128, '2014-04-01 00:06:38.000000', 'consum', 0.0212, 'lps'),
	(604811, 128, '2014-04-01 00:06:39.000000', 'consum', 0.0219, 'lps'),
	(604812, 128, '2014-04-01 00:06:40.000000', 'consum', 0.0210, 'lps'),
	(604813, 128, '2014-04-01 00:06:41.000000', 'consum', 0.0213, 'lps'),
	(604814, 128, '2014-04-01 00:06:42.000000', 'consum', 0.0215, 'lps'),
	(604815, 128, '2014-04-01 00:06:43.000000', 'consum', 0.0219, 'lps'),
	(604816, 128, '2014-04-01 00:06:44.000000', 'consum', 0.0217, 'lps'),
	(604817, 128, '2014-04-01 00:06:45.000000', 'consum', 0.0211, 'lps'),
	(604818, 128, '2014-04-01 00:06:46.000000', 'consum', 0.0214, 'lps'),
	(604819, 128, '2014-04-01 00:06:47.000000', 'consum', 0.0215, 'lps'),
	(604820, 128, '2014-04-01 00:06:48.000000', 'consum', 0.0217, 'lps'),
	(604821, 128, '2014-04-01 00:06:49.000000', 'consum', 0.0210, 'lps'),
	(604822, 128, '2014-04-01 00:06:50.000000', 'consum', 0.0219, 'lps'),
	(604823, 128, '2014-04-01 00:06:51.000000', 'consum', 0.0215, 'lps'),
	(604824, 128, '2014-04-01 00:06:52.000000', 'consum', 0.0218, 'lps'),
	(604825, 128, '2014-04-01 00:06:53.000000', 'consum', 0.0217, 'lps'),
	(604826, 128, '2014-04-01 00:06:54.000000', 'consum', 0.0210, 'lps'),
	(604827, 128, '2014-04-01 00:06:55.000000', 'consum', 0.0211, 'lps'),
	(604828, 128, '2014-04-01 00:06:56.000000', 'consum', 0.0215, 'lps'),
	(604829, 128, '2014-04-01 00:06:57.000000', 'consum', 0.0213, 'lps'),
	(604830, 128, '2014-04-01 00:06:58.000000', 'consum', 0.0212, 'lps'),
	(604831, 128, '2014-04-01 00:06:59.000000', 'consum', 0.0211, 'lps'),
	(604832, 128, '2014-04-01 00:07:00.000000', 'consum', 0.0217, 'lps'),
	(604833, 128, '2014-04-01 00:07:01.000000', 'consum', 0.0214, 'lps'),
	(604834, 128, '2014-04-01 00:07:02.000000', 'consum', 0.0219, 'lps'),
	(604835, 128, '2014-04-01 00:07:03.000000', 'consum', 0.0214, 'lps'),
	(604836, 128, '2014-04-01 00:07:04.000000', 'consum', 0.0214, 'lps'),
	(604837, 128, '2014-04-01 00:07:05.000000', 'consum', 0.0219, 'lps'),
	(604838, 128, '2014-04-01 00:07:06.000000', 'consum', 0.0212, 'lps'),
	(604839, 128, '2014-04-01 00:07:07.000000', 'consum', 0.0213, 'lps'),
	(604840, 128, '2014-04-01 00:07:08.000000', 'consum', 0.0212, 'lps'),
	(604841, 128, '2014-04-01 00:07:09.000000', 'consum', 0.0212, 'lps'),
	(604842, 128, '2014-04-01 00:07:10.000000', 'consum', 0.0212, 'lps'),
	(604843, 128, '2014-04-01 00:07:11.000000', 'consum', 0.0216, 'lps'),
	(604844, 128, '2014-04-01 00:07:12.000000', 'consum', 0.0215, 'lps'),
	(604845, 128, '2014-04-01 00:07:13.000000', 'consum', 0.0218, 'lps'),
	(604846, 128, '2014-04-01 00:07:14.000000', 'consum', 0.0215, 'lps'),
	(604847, 128, '2014-04-01 00:07:15.000000', 'consum', 0.0213, 'lps'),
	(604848, 128, '2014-04-01 00:07:16.000000', 'consum', 0.0217, 'lps'),
	(604849, 128, '2014-04-01 00:07:17.000000', 'consum', 0.0219, 'lps'),
	(604850, 128, '2014-04-01 00:07:18.000000', 'consum', 0.0214, 'lps'),
	(604851, 128, '2014-04-01 00:07:19.000000', 'consum', 0.0214, 'lps'),
	(604852, 128, '2014-04-01 00:07:20.000000', 'consum', 0.0217, 'lps'),
	(604853, 128, '2014-04-01 00:07:21.000000', 'consum', 0.0213, 'lps'),
	(604854, 128, '2014-04-01 00:07:22.000000', 'consum', 0.0217, 'lps'),
	(604855, 128, '2014-04-01 00:07:23.000000', 'consum', 0.0216, 'lps'),
	(604856, 128, '2014-04-01 00:07:24.000000', 'consum', 0.0217, 'lps'),
	(604857, 128, '2014-04-01 00:07:25.000000', 'consum', 0.0210, 'lps'),
	(604858, 128, '2014-04-01 00:07:26.000000', 'consum', 0.0217, 'lps'),
	(604859, 128, '2014-04-01 00:07:27.000000', 'consum', 0.0216, 'lps'),
	(604860, 128, '2014-04-01 00:07:28.000000', 'consum', 0.0211, 'lps'),
	(604861, 128, '2014-04-01 00:07:29.000000', 'consum', 0.0218, 'lps'),
	(604862, 128, '2014-04-01 00:07:30.000000', 'consum', 0.0215, 'lps'),
	(604863, 128, '2014-04-01 00:07:31.000000', 'consum', 0.0213, 'lps'),
	(604864, 128, '2014-04-01 00:07:32.000000', 'consum', 0.0210, 'lps'),
	(604865, 128, '2014-04-01 00:07:33.000000', 'consum', 0.0213, 'lps'),
	(604866, 128, '2014-04-01 00:07:34.000000', 'consum', 0.0213, 'lps'),
	(604867, 128, '2014-04-01 00:07:35.000000', 'consum', 0.0219, 'lps'),
	(604868, 128, '2014-04-01 00:07:36.000000', 'consum', 0.0215, 'lps'),
	(604869, 128, '2014-04-01 00:07:37.000000', 'consum', 0.0210, 'lps'),
	(604870, 128, '2014-04-01 00:07:38.000000', 'consum', 0.0215, 'lps'),
	(604871, 128, '2014-04-01 00:07:39.000000', 'consum', 0.0214, 'lps'),
	(604872, 128, '2014-04-01 00:07:40.000000', 'consum', 0.0217, 'lps'),
	(604873, 128, '2014-04-01 00:07:41.000000', 'consum', 0.0214, 'lps'),
	(604874, 128, '2014-04-01 00:07:42.000000', 'consum', 0.0210, 'lps'),
	(604875, 128, '2014-04-01 00:07:43.000000', 'consum', 0.0218, 'lps'),
	(604876, 128, '2014-04-01 00:07:44.000000', 'consum', 0.0219, 'lps'),
	(604877, 128, '2014-04-01 00:07:45.000000', 'consum', 0.0212, 'lps'),
	(604878, 128, '2014-04-01 00:07:46.000000', 'consum', 0.0212, 'lps'),
	(604879, 128, '2014-04-01 00:07:47.000000', 'consum', 0.0218, 'lps'),
	(604880, 128, '2014-04-01 00:07:48.000000', 'consum', 0.0212, 'lps'),
	(604881, 128, '2014-04-01 00:07:49.000000', 'consum', 0.0217, 'lps'),
	(604882, 128, '2014-04-01 00:07:50.000000', 'consum', 0.0210, 'lps'),
	(604883, 128, '2014-04-01 00:07:51.000000', 'consum', 0.0210, 'lps'),
	(604884, 128, '2014-04-01 00:07:52.000000', 'consum', 0.0211, 'lps'),
	(604885, 128, '2014-04-01 00:07:53.000000', 'consum', 0.0215, 'lps'),
	(604886, 128, '2014-04-01 00:07:54.000000', 'consum', 0.0210, 'lps'),
	(604887, 128, '2014-04-01 00:07:55.000000', 'consum', 0.0218, 'lps'),
	(604888, 128, '2014-04-01 00:07:56.000000', 'consum', 0.0211, 'lps'),
	(604889, 128, '2014-04-01 00:07:57.000000', 'consum', 0.0219, 'lps'),
	(604890, 128, '2014-04-01 00:07:58.000000', 'consum', 0.0214, 'lps'),
	(604891, 128, '2014-04-01 00:07:59.000000', 'consum', 0.0215, 'lps'),
	(604892, 128, '2014-04-01 00:08:00.000000', 'consum', 0.0212, 'lps'),
	(604893, 128, '2014-04-01 00:08:01.000000', 'consum', 0.0214, 'lps'),
	(604894, 128, '2014-04-01 00:08:02.000000', 'consum', 0.0216, 'lps'),
	(604895, 128, '2014-04-01 00:08:03.000000', 'consum', 0.0219, 'lps'),
	(604896, 128, '2014-04-01 00:08:04.000000', 'consum', 0.0216, 'lps'),
	(604897, 128, '2014-04-01 00:08:05.000000', 'consum', 0.0216, 'lps'),
	(604898, 128, '2014-04-01 00:08:06.000000', 'consum', 0.0211, 'lps'),
	(604899, 128, '2014-04-01 00:08:07.000000', 'consum', 0.0219, 'lps'),
	(604900, 128, '2014-04-01 00:08:08.000000', 'consum', 0.0211, 'lps'),
	(604901, 128, '2014-04-01 00:08:09.000000', 'consum', 0.0218, 'lps'),
	(604902, 128, '2014-04-01 00:08:10.000000', 'consum', 0.0210, 'lps'),
	(604903, 128, '2014-04-01 00:08:11.000000', 'consum', 0.0215, 'lps'),
	(604904, 128, '2014-04-01 00:08:12.000000', 'consum', 0.0215, 'lps'),
	(604905, 128, '2014-04-01 00:08:13.000000', 'consum', 0.0212, 'lps'),
	(604906, 128, '2014-04-01 00:08:14.000000', 'consum', 0.0215, 'lps'),
	(604907, 128, '2014-04-01 00:08:15.000000', 'consum', 0.0219, 'lps'),
	(604908, 128, '2014-04-01 00:08:16.000000', 'consum', 0.0211, 'lps'),
	(604909, 128, '2014-04-01 00:08:17.000000', 'consum', 0.0218, 'lps'),
	(604910, 128, '2014-04-01 00:08:18.000000', 'consum', 0.0219, 'lps'),
	(604911, 128, '2014-04-01 00:08:19.000000', 'consum', 0.0213, 'lps'),
	(604912, 128, '2014-04-01 00:08:20.000000', 'consum', 0.0215, 'lps'),
	(604913, 128, '2014-04-01 00:08:21.000000', 'consum', 0.0210, 'lps'),
	(604914, 128, '2014-04-01 00:08:22.000000', 'consum', 0.0213, 'lps'),
	(604915, 128, '2014-04-01 00:08:23.000000', 'consum', 0.0215, 'lps'),
	(604916, 128, '2014-04-01 00:08:24.000000', 'consum', 0.0215, 'lps'),
	(604917, 128, '2014-04-01 00:08:25.000000', 'consum', 0.0213, 'lps'),
	(604918, 128, '2014-04-01 00:08:26.000000', 'consum', 0.0219, 'lps'),
	(604919, 128, '2014-04-01 00:08:27.000000', 'consum', 0.0217, 'lps'),
	(604920, 128, '2014-04-01 00:08:28.000000', 'consum', 0.0210, 'lps'),
	(604921, 128, '2014-04-01 00:08:29.000000', 'consum', 0.0210, 'lps'),
	(604922, 128, '2014-04-01 00:08:30.000000', 'consum', 0.0218, 'lps'),
	(604923, 128, '2014-04-01 00:08:31.000000', 'consum', 0.0211, 'lps'),
	(604924, 128, '2014-04-01 00:08:32.000000', 'consum', 0.0210, 'lps'),
	(604925, 128, '2014-04-01 00:08:33.000000', 'consum', 0.0219, 'lps'),
	(604926, 128, '2014-04-01 00:08:34.000000', 'consum', 0.0216, 'lps'),
	(604927, 128, '2014-04-01 00:08:35.000000', 'consum', 0.0214, 'lps'),
	(604928, 128, '2014-04-01 00:08:36.000000', 'consum', 0.0212, 'lps'),
	(604929, 128, '2014-04-01 00:08:37.000000', 'consum', 0.0210, 'lps'),
	(604930, 128, '2014-04-01 00:08:38.000000', 'consum', 0.0212, 'lps'),
	(604931, 128, '2014-04-01 00:08:39.000000', 'consum', 0.0213, 'lps'),
	(604932, 128, '2014-04-01 00:08:40.000000', 'consum', 0.0217, 'lps'),
	(604933, 128, '2014-04-01 00:08:41.000000', 'consum', 0.0218, 'lps'),
	(604934, 128, '2014-04-01 00:08:42.000000', 'consum', 0.0218, 'lps'),
	(604935, 128, '2014-04-01 00:08:43.000000', 'consum', 0.0216, 'lps'),
	(604936, 128, '2014-04-01 00:08:44.000000', 'consum', 0.0215, 'lps'),
	(604937, 128, '2014-04-01 00:08:45.000000', 'consum', 0.0211, 'lps'),
	(604938, 128, '2014-04-01 00:08:46.000000', 'consum', 0.0218, 'lps'),
	(604939, 128, '2014-04-01 00:08:47.000000', 'consum', 0.0218, 'lps'),
	(604940, 128, '2014-04-01 00:08:48.000000', 'consum', 0.0219, 'lps'),
	(604941, 128, '2014-04-01 00:08:49.000000', 'consum', 0.0219, 'lps'),
	(604942, 128, '2014-04-01 00:08:50.000000', 'consum', 0.0211, 'lps'),
	(604943, 128, '2014-04-01 00:08:51.000000', 'consum', 0.0217, 'lps'),
	(604944, 128, '2014-04-01 00:08:52.000000', 'consum', 0.0214, 'lps'),
	(604945, 128, '2014-04-01 00:08:53.000000', 'consum', 0.0210, 'lps'),
	(604946, 128, '2014-04-01 00:08:54.000000', 'consum', 0.0219, 'lps'),
	(604947, 128, '2014-04-01 00:08:55.000000', 'consum', 0.0213, 'lps'),
	(604948, 128, '2014-04-01 00:08:56.000000', 'consum', 0.0218, 'lps'),
	(604949, 128, '2014-04-01 00:08:57.000000', 'consum', 0.0213, 'lps'),
	(604950, 128, '2014-04-01 00:08:58.000000', 'consum', 0.0211, 'lps'),
	(604951, 128, '2014-04-01 00:08:59.000000', 'consum', 0.0215, 'lps'),
	(604952, 128, '2014-04-01 00:09:00.000000', 'consum', 0.0212, 'lps'),
	(604953, 128, '2014-04-01 00:09:01.000000', 'consum', 0.0216, 'lps'),
	(604954, 128, '2014-04-01 00:09:02.000000', 'consum', 0.0213, 'lps'),
	(604955, 128, '2014-04-01 00:09:03.000000', 'consum', 0.0210, 'lps'),
	(604956, 128, '2014-04-01 00:09:04.000000', 'consum', 0.0213, 'lps'),
	(604957, 128, '2014-04-01 00:09:05.000000', 'consum', 0.0212, 'lps'),
	(604958, 128, '2014-04-01 00:09:06.000000', 'consum', 0.0213, 'lps'),
	(604959, 128, '2014-04-01 00:09:07.000000', 'consum', 0.0218, 'lps'),
	(604960, 128, '2014-04-01 00:09:08.000000', 'consum', 0.0213, 'lps'),
	(604961, 128, '2014-04-01 00:09:09.000000', 'consum', 0.0211, 'lps'),
	(604962, 128, '2014-04-01 00:09:10.000000', 'consum', 0.0216, 'lps'),
	(604963, 128, '2014-04-01 00:09:11.000000', 'consum', 0.0218, 'lps'),
	(604964, 128, '2014-04-01 00:09:12.000000', 'consum', 0.0211, 'lps'),
	(604965, 128, '2014-04-01 00:09:13.000000', 'consum', 0.0212, 'lps'),
	(604966, 128, '2014-04-01 00:09:14.000000', 'consum', 0.0219, 'lps'),
	(604967, 128, '2014-04-01 00:09:15.000000', 'consum', 0.0217, 'lps'),
	(604968, 128, '2014-04-01 00:09:16.000000', 'consum', 0.0211, 'lps'),
	(604969, 128, '2014-04-01 00:09:17.000000', 'consum', 0.0214, 'lps'),
	(604970, 128, '2014-04-01 00:09:18.000000', 'consum', 0.0216, 'lps'),
	(604971, 128, '2014-04-01 00:09:19.000000', 'consum', 0.0217, 'lps'),
	(604972, 128, '2014-04-01 00:09:20.000000', 'consum', 0.0210, 'lps'),
	(604973, 128, '2014-04-01 00:09:21.000000', 'consum', 0.0210, 'lps'),
	(604974, 128, '2014-04-01 00:09:22.000000', 'consum', 0.0219, 'lps'),
	(604975, 128, '2014-04-01 00:09:23.000000', 'consum', 0.0217, 'lps'),
	(604976, 128, '2014-04-01 00:09:24.000000', 'consum', 0.0219, 'lps'),
	(604977, 128, '2014-04-01 00:09:25.000000', 'consum', 0.0213, 'lps'),
	(604978, 128, '2014-04-01 00:09:26.000000', 'consum', 0.0210, 'lps'),
	(604979, 128, '2014-04-01 00:09:27.000000', 'consum', 0.0212, 'lps'),
	(604980, 128, '2014-04-01 00:09:28.000000', 'consum', 0.0212, 'lps'),
	(604981, 128, '2014-04-01 00:09:29.000000', 'consum', 0.0211, 'lps'),
	(604982, 128, '2014-04-01 00:09:30.000000', 'consum', 0.0212, 'lps'),
	(604983, 128, '2014-04-01 00:09:31.000000', 'consum', 0.0216, 'lps'),
	(604984, 128, '2014-04-01 00:09:32.000000', 'consum', 0.0214, 'lps'),
	(604985, 128, '2014-04-01 00:09:33.000000', 'consum', 0.0213, 'lps'),
	(604986, 128, '2014-04-01 00:09:34.000000', 'consum', 0.0214, 'lps'),
	(604987, 128, '2014-04-01 00:09:35.000000', 'consum', 0.0219, 'lps'),
	(604988, 128, '2014-04-01 00:09:36.000000', 'consum', 0.0216, 'lps'),
	(604989, 128, '2014-04-01 00:09:37.000000', 'consum', 0.0213, 'lps'),
	(604990, 128, '2014-04-01 00:09:38.000000', 'consum', 0.0219, 'lps'),
	(604991, 128, '2014-04-01 00:09:39.000000', 'consum', 0.0215, 'lps'),
	(604992, 128, '2014-04-01 00:09:40.000000', 'consum', 0.0217, 'lps'),
	(604993, 128, '2014-04-01 00:09:41.000000', 'consum', 0.0213, 'lps'),
	(604994, 128, '2014-04-01 00:09:42.000000', 'consum', 0.0214, 'lps'),
	(604995, 128, '2014-04-01 00:09:43.000000', 'consum', 0.0210, 'lps'),
	(604996, 128, '2014-04-01 00:09:44.000000', 'consum', 0.0211, 'lps'),
	(604997, 128, '2014-04-01 00:09:45.000000', 'consum', 0.0213, 'lps'),
	(604998, 128, '2014-04-01 00:09:46.000000', 'consum', 0.0214, 'lps'),
	(604999, 128, '2014-04-01 00:09:47.000000', 'consum', 0.0212, 'lps'),
	(605000, 128, '2014-04-01 00:09:48.000000', 'consum', 0.0218, 'lps'),
	(605001, 128, '2014-04-01 00:09:49.000000', 'consum', 0.0214, 'lps'),
	(605002, 128, '2014-04-01 00:09:50.000000', 'consum', 0.0215, 'lps'),
	(605003, 128, '2014-04-01 00:09:51.000000', 'consum', 0.0216, 'lps'),
	(605004, 128, '2014-04-01 00:09:52.000000', 'consum', 0.0216, 'lps'),
	(605005, 128, '2014-04-01 00:09:53.000000', 'consum', 0.0210, 'lps'),
	(605006, 128, '2014-04-01 00:09:54.000000', 'consum', 0.0213, 'lps'),
	(605007, 128, '2014-04-01 00:09:55.000000', 'consum', 0.0217, 'lps'),
	(605008, 128, '2014-04-01 00:09:56.000000', 'consum', 0.0215, 'lps'),
	(605009, 128, '2014-04-01 00:09:57.000000', 'consum', 0.0216, 'lps'),
	(605010, 128, '2014-04-01 00:09:58.000000', 'consum', 0.0214, 'lps'),
	(605011, 128, '2014-04-01 00:09:59.000000', 'consum', 0.0213, 'lps'),
	(605012, 128, '2014-04-01 00:10:00.000000', 'consum', 0.0216, 'lps'),
	(605013, 128, '2014-04-01 00:10:01.000000', 'consum', 0.0218, 'lps'),
	(605014, 128, '2014-04-01 00:10:02.000000', 'consum', 0.0215, 'lps'),
	(605015, 128, '2014-04-01 00:10:03.000000', 'consum', 0.0219, 'lps'),
	(605016, 128, '2014-04-01 00:10:04.000000', 'consum', 0.0213, 'lps'),
	(605017, 128, '2014-04-01 00:10:05.000000', 'consum', 0.0210, 'lps'),
	(605018, 128, '2014-04-01 00:10:06.000000', 'consum', 0.0218, 'lps'),
	(605019, 128, '2014-04-01 00:10:07.000000', 'consum', 0.0212, 'lps'),
	(605020, 128, '2014-04-01 00:10:08.000000', 'consum', 0.0217, 'lps'),
	(605021, 128, '2014-04-01 00:10:09.000000', 'consum', 0.0210, 'lps'),
	(605022, 128, '2014-04-01 00:10:10.000000', 'consum', 0.0218, 'lps'),
	(605023, 128, '2014-04-01 00:10:11.000000', 'consum', 0.0212, 'lps'),
	(605024, 128, '2014-04-01 00:10:12.000000', 'consum', 0.0216, 'lps'),
	(605025, 128, '2014-04-01 00:10:13.000000', 'consum', 0.0213, 'lps'),
	(605026, 128, '2014-04-01 00:10:14.000000', 'consum', 0.0218, 'lps'),
	(605027, 128, '2014-04-01 00:10:15.000000', 'consum', 0.0210, 'lps'),
	(605028, 128, '2014-04-01 00:10:16.000000', 'consum', 0.0219, 'lps'),
	(605029, 128, '2014-04-01 00:10:17.000000', 'consum', 0.0215, 'lps'),
	(605030, 128, '2014-04-01 00:10:18.000000', 'consum', 0.0210, 'lps'),
	(605031, 128, '2014-04-01 00:10:19.000000', 'consum', 0.0214, 'lps'),
	(605032, 128, '2014-04-01 00:10:20.000000', 'consum', 0.0213, 'lps'),
	(605033, 128, '2014-04-01 00:10:21.000000', 'consum', 0.0210, 'lps'),
	(605034, 128, '2014-04-01 00:10:22.000000', 'consum', 0.0213, 'lps'),
	(605035, 128, '2014-04-01 00:10:23.000000', 'consum', 0.0214, 'lps'),
	(605036, 128, '2014-04-01 00:10:24.000000', 'consum', 0.0212, 'lps'),
	(605037, 128, '2014-04-01 00:10:25.000000', 'consum', 0.0217, 'lps'),
	(605038, 128, '2014-04-01 00:10:26.000000', 'consum', 0.0211, 'lps'),
	(605039, 128, '2014-04-01 00:10:27.000000', 'consum', 0.0213, 'lps'),
	(605040, 128, '2014-04-01 00:10:28.000000', 'consum', 0.0215, 'lps'),
	(605041, 128, '2014-04-01 00:10:29.000000', 'consum', 0.0217, 'lps'),
	(605042, 128, '2014-04-01 00:10:30.000000', 'consum', 0.0219, 'lps'),
	(605043, 128, '2014-04-01 00:10:31.000000', 'consum', 0.0213, 'lps'),
	(605044, 128, '2014-04-01 00:10:32.000000', 'consum', 0.0212, 'lps'),
	(605045, 128, '2014-04-01 00:10:33.000000', 'consum', 0.0219, 'lps'),
	(605046, 128, '2014-04-01 00:10:34.000000', 'consum', 0.0218, 'lps'),
	(605047, 128, '2014-04-01 00:10:35.000000', 'consum', 0.0215, 'lps'),
	(605048, 128, '2014-04-01 00:10:36.000000', 'consum', 0.0213, 'lps'),
	(605049, 128, '2014-04-01 00:10:37.000000', 'consum', 0.0219, 'lps'),
	(605050, 128, '2014-04-01 00:10:38.000000', 'consum', 0.0216, 'lps'),
	(605051, 128, '2014-04-01 00:10:39.000000', 'consum', 0.0213, 'lps'),
	(605052, 128, '2014-04-01 00:10:40.000000', 'consum', 0.0219, 'lps'),
	(605053, 128, '2014-04-01 00:10:41.000000', 'consum', 0.0218, 'lps'),
	(605054, 128, '2014-04-01 00:10:42.000000', 'consum', 0.0212, 'lps'),
	(605055, 128, '2014-04-01 00:10:43.000000', 'consum', 0.0218, 'lps'),
	(605056, 128, '2014-04-01 00:10:44.000000', 'consum', 0.0212, 'lps'),
	(605057, 128, '2014-04-01 00:10:45.000000', 'consum', 0.0217, 'lps'),
	(605058, 128, '2014-04-01 00:10:46.000000', 'consum', 0.0219, 'lps'),
	(605059, 128, '2014-04-01 00:10:47.000000', 'consum', 0.0215, 'lps'),
	(605060, 128, '2014-04-01 00:10:48.000000', 'consum', 0.0210, 'lps'),
	(605061, 128, '2014-04-01 00:10:49.000000', 'consum', 0.0215, 'lps'),
	(605062, 128, '2014-04-01 00:10:50.000000', 'consum', 0.0217, 'lps'),
	(605063, 128, '2014-04-01 00:10:51.000000', 'consum', 0.0218, 'lps'),
	(605064, 128, '2014-04-01 00:10:52.000000', 'consum', 0.0210, 'lps'),
	(605065, 128, '2014-04-01 00:10:53.000000', 'consum', 0.0215, 'lps'),
	(605066, 128, '2014-04-01 00:10:54.000000', 'consum', 0.0218, 'lps'),
	(605067, 128, '2014-04-01 00:10:55.000000', 'consum', 0.0215, 'lps'),
	(605068, 128, '2014-04-01 00:10:56.000000', 'consum', 0.0213, 'lps'),
	(605069, 128, '2014-04-01 00:10:57.000000', 'consum', 0.0218, 'lps'),
	(605070, 128, '2014-04-01 00:10:58.000000', 'consum', 0.0214, 'lps'),
	(605071, 128, '2014-04-01 00:10:59.000000', 'consum', 0.0215, 'lps'),
	(605072, 128, '2014-04-01 00:11:00.000000', 'consum', 0.0216, 'lps'),
	(605073, 128, '2014-04-01 00:11:01.000000', 'consum', 0.0212, 'lps'),
	(605074, 128, '2014-04-01 00:11:02.000000', 'consum', 0.0214, 'lps'),
	(605075, 128, '2014-04-01 00:11:03.000000', 'consum', 0.0215, 'lps'),
	(605076, 128, '2014-04-01 00:11:04.000000', 'consum', 0.0214, 'lps'),
	(605077, 128, '2014-04-01 00:11:05.000000', 'consum', 0.0215, 'lps'),
	(605078, 128, '2014-04-01 00:11:06.000000', 'consum', 0.0214, 'lps'),
	(605079, 128, '2014-04-01 00:11:07.000000', 'consum', 0.0215, 'lps'),
	(605080, 128, '2014-04-01 00:11:08.000000', 'consum', 0.0212, 'lps'),
	(605081, 128, '2014-04-01 00:11:09.000000', 'consum', 0.0218, 'lps'),
	(605082, 128, '2014-04-01 00:11:10.000000', 'consum', 0.0212, 'lps'),
	(605083, 128, '2014-04-01 00:11:11.000000', 'consum', 0.0217, 'lps'),
	(605084, 128, '2014-04-01 00:11:12.000000', 'consum', 0.0211, 'lps'),
	(605085, 128, '2014-04-01 00:11:13.000000', 'consum', 0.0213, 'lps'),
	(605086, 128, '2014-04-01 00:11:14.000000', 'consum', 0.0211, 'lps'),
	(605087, 128, '2014-04-01 00:11:15.000000', 'consum', 0.0218, 'lps'),
	(605088, 128, '2014-04-01 00:11:16.000000', 'consum', 0.0217, 'lps'),
	(605089, 128, '2014-04-01 00:11:17.000000', 'consum', 0.0210, 'lps'),
	(605090, 128, '2014-04-01 00:11:18.000000', 'consum', 0.0210, 'lps'),
	(605091, 128, '2014-04-01 00:11:19.000000', 'consum', 0.0210, 'lps'),
	(605092, 128, '2014-04-01 00:11:20.000000', 'consum', 0.0211, 'lps'),
	(605093, 128, '2014-04-01 00:11:21.000000', 'consum', 0.0217, 'lps'),
	(605094, 128, '2014-04-01 00:11:22.000000', 'consum', 0.0211, 'lps'),
	(605095, 128, '2014-04-01 00:11:23.000000', 'consum', 0.0213, 'lps'),
	(605096, 128, '2014-04-01 00:11:24.000000', 'consum', 0.0216, 'lps'),
	(605097, 128, '2014-04-01 00:11:25.000000', 'consum', 0.0219, 'lps'),
	(605098, 128, '2014-04-01 00:11:26.000000', 'consum', 0.0219, 'lps'),
	(605099, 128, '2014-04-01 00:11:27.000000', 'consum', 0.0218, 'lps'),
	(605100, 128, '2014-04-01 00:11:28.000000', 'consum', 0.0212, 'lps'),
	(605101, 128, '2014-04-01 00:11:29.000000', 'consum', 0.0217, 'lps'),
	(605102, 128, '2014-04-01 00:11:30.000000', 'consum', 0.0211, 'lps'),
	(605103, 128, '2014-04-01 00:11:31.000000', 'consum', 0.0215, 'lps'),
	(605104, 128, '2014-04-01 00:11:32.000000', 'consum', 0.0211, 'lps'),
	(605105, 128, '2014-04-01 00:11:33.000000', 'consum', 0.0210, 'lps'),
	(605106, 128, '2014-04-01 00:11:34.000000', 'consum', 0.0210, 'lps'),
	(605107, 128, '2014-04-01 00:11:35.000000', 'consum', 0.0219, 'lps'),
	(605108, 128, '2014-04-01 00:11:36.000000', 'consum', 0.0215, 'lps'),
	(605109, 128, '2014-04-01 00:11:37.000000', 'consum', 0.0219, 'lps'),
	(605110, 128, '2014-04-01 00:11:38.000000', 'consum', 0.0211, 'lps'),
	(605111, 128, '2014-04-01 00:11:39.000000', 'consum', 0.0219, 'lps'),
	(605112, 128, '2014-04-01 00:11:40.000000', 'consum', 0.0210, 'lps'),
	(605113, 128, '2014-04-01 00:11:41.000000', 'consum', 0.0216, 'lps'),
	(605114, 128, '2014-04-01 00:11:42.000000', 'consum', 0.0219, 'lps'),
	(605115, 128, '2014-04-01 00:11:43.000000', 'consum', 0.0219, 'lps'),
	(605116, 128, '2014-04-01 00:11:44.000000', 'consum', 0.0218, 'lps'),
	(605117, 128, '2014-04-01 00:11:45.000000', 'consum', 0.0213, 'lps'),
	(605118, 128, '2014-04-01 00:11:46.000000', 'consum', 0.0210, 'lps'),
	(605119, 128, '2014-04-01 00:11:47.000000', 'consum', 0.0213, 'lps'),
	(605120, 128, '2014-04-01 00:11:48.000000', 'consum', 0.0215, 'lps'),
	(605121, 128, '2014-04-01 00:11:49.000000', 'consum', 0.0215, 'lps'),
	(605122, 128, '2014-04-01 00:11:50.000000', 'consum', 0.0212, 'lps'),
	(605123, 128, '2014-04-01 00:11:51.000000', 'consum', 0.0214, 'lps'),
	(605124, 128, '2014-04-01 00:11:52.000000', 'consum', 0.0217, 'lps'),
	(605125, 128, '2014-04-01 00:11:53.000000', 'consum', 0.0212, 'lps'),
	(605126, 128, '2014-04-01 00:11:54.000000', 'consum', 0.0218, 'lps'),
	(605127, 128, '2014-04-01 00:11:55.000000', 'consum', 0.0216, 'lps'),
	(605128, 128, '2014-04-01 00:11:56.000000', 'consum', 0.0218, 'lps'),
	(605129, 128, '2014-04-01 00:11:57.000000', 'consum', 0.0213, 'lps'),
	(605130, 128, '2014-04-01 00:11:58.000000', 'consum', 0.0212, 'lps'),
	(605131, 128, '2014-04-01 00:11:59.000000', 'consum', 0.0219, 'lps'),
	(605132, 128, '2014-04-01 00:12:00.000000', 'consum', 0.0219, 'lps'),
	(605133, 128, '2014-04-01 00:12:01.000000', 'consum', 0.0218, 'lps'),
	(605134, 128, '2014-04-01 00:12:02.000000', 'consum', 0.0213, 'lps'),
	(605135, 128, '2014-04-01 00:12:03.000000', 'consum', 0.0211, 'lps'),
	(605136, 128, '2014-04-01 00:12:04.000000', 'consum', 0.0218, 'lps'),
	(605137, 128, '2014-04-01 00:12:05.000000', 'consum', 0.0217, 'lps'),
	(605138, 128, '2014-04-01 00:12:06.000000', 'consum', 0.0211, 'lps'),
	(605139, 128, '2014-04-01 00:12:07.000000', 'consum', 0.0216, 'lps'),
	(605140, 128, '2014-04-01 00:12:08.000000', 'consum', 0.0216, 'lps'),
	(605141, 128, '2014-04-01 00:12:09.000000', 'consum', 0.0215, 'lps'),
	(605142, 128, '2014-04-01 00:12:10.000000', 'consum', 0.0217, 'lps'),
	(605143, 128, '2014-04-01 00:12:11.000000', 'consum', 0.0218, 'lps'),
	(605144, 128, '2014-04-01 00:12:12.000000', 'consum', 0.0213, 'lps'),
	(605145, 128, '2014-04-01 00:12:13.000000', 'consum', 0.0219, 'lps'),
	(605146, 128, '2014-04-01 00:12:14.000000', 'consum', 0.0218, 'lps'),
	(605147, 128, '2014-04-01 00:12:15.000000', 'consum', 0.0213, 'lps'),
	(605148, 128, '2014-04-01 00:12:16.000000', 'consum', 0.0213, 'lps'),
	(605149, 128, '2014-04-01 00:12:17.000000', 'consum', 0.0217, 'lps'),
	(605150, 128, '2014-04-01 00:12:18.000000', 'consum', 0.0215, 'lps'),
	(605151, 128, '2014-04-01 00:12:19.000000', 'consum', 0.0217, 'lps'),
	(605152, 128, '2014-04-01 00:12:20.000000', 'consum', 0.0218, 'lps'),
	(605153, 128, '2014-04-01 00:12:21.000000', 'consum', 0.0218, 'lps'),
	(605154, 128, '2014-04-01 00:12:22.000000', 'consum', 0.0210, 'lps'),
	(605155, 128, '2014-04-01 00:12:23.000000', 'consum', 0.0214, 'lps'),
	(605156, 128, '2014-04-01 00:12:24.000000', 'consum', 0.0213, 'lps'),
	(605157, 128, '2014-04-01 00:12:25.000000', 'consum', 0.0213, 'lps'),
	(605158, 128, '2014-04-01 00:12:26.000000', 'consum', 0.0215, 'lps'),
	(605159, 128, '2014-04-01 00:12:27.000000', 'consum', 0.0218, 'lps'),
	(605160, 128, '2014-04-01 00:12:28.000000', 'consum', 0.0213, 'lps'),
	(605161, 128, '2014-04-01 00:12:29.000000', 'consum', 0.0212, 'lps'),
	(605162, 128, '2014-04-01 00:12:30.000000', 'consum', 0.0212, 'lps'),
	(605163, 128, '2014-04-01 00:12:31.000000', 'consum', 0.0215, 'lps'),
	(605164, 128, '2014-04-01 00:12:32.000000', 'consum', 0.0219, 'lps'),
	(605165, 128, '2014-04-01 00:12:33.000000', 'consum', 0.0211, 'lps'),
	(605166, 128, '2014-04-01 00:12:34.000000', 'consum', 0.0219, 'lps'),
	(605167, 128, '2014-04-01 00:12:35.000000', 'consum', 0.0212, 'lps'),
	(605168, 128, '2014-04-01 00:12:36.000000', 'consum', 0.0213, 'lps'),
	(605169, 128, '2014-04-01 00:12:37.000000', 'consum', 0.0219, 'lps'),
	(605170, 128, '2014-04-01 00:12:38.000000', 'consum', 0.0218, 'lps'),
	(605171, 128, '2014-04-01 00:12:39.000000', 'consum', 0.0213, 'lps'),
	(605172, 128, '2014-04-01 00:12:40.000000', 'consum', 0.0212, 'lps'),
	(605173, 128, '2014-04-01 00:12:41.000000', 'consum', 0.0212, 'lps'),
	(605174, 128, '2014-04-01 00:12:42.000000', 'consum', 0.0215, 'lps'),
	(605175, 128, '2014-04-01 00:12:43.000000', 'consum', 0.0217, 'lps'),
	(605176, 128, '2014-04-01 00:12:44.000000', 'consum', 0.0211, 'lps'),
	(605177, 128, '2014-04-01 00:12:45.000000', 'consum', 0.0215, 'lps'),
	(605178, 128, '2014-04-01 00:12:46.000000', 'consum', 0.0212, 'lps'),
	(605179, 128, '2014-04-01 00:12:47.000000', 'consum', 0.0214, 'lps'),
	(605180, 128, '2014-04-01 00:12:48.000000', 'consum', 0.0217, 'lps'),
	(605181, 128, '2014-04-01 00:12:49.000000', 'consum', 0.0213, 'lps'),
	(605182, 128, '2014-04-01 00:12:50.000000', 'consum', 0.0214, 'lps'),
	(605183, 128, '2014-04-01 00:12:51.000000', 'consum', 0.0211, 'lps'),
	(605184, 128, '2014-04-01 00:12:52.000000', 'consum', 0.0212, 'lps'),
	(605185, 128, '2014-04-01 00:12:53.000000', 'consum', 0.0211, 'lps'),
	(605186, 128, '2014-04-01 00:12:54.000000', 'consum', 0.0216, 'lps'),
	(605187, 128, '2014-04-01 00:12:55.000000', 'consum', 0.0219, 'lps'),
	(605188, 128, '2014-04-01 00:12:56.000000', 'consum', 0.0215, 'lps'),
	(605189, 128, '2014-04-01 00:12:57.000000', 'consum', 0.0212, 'lps'),
	(605190, 128, '2014-04-01 00:12:58.000000', 'consum', 0.0216, 'lps'),
	(605191, 128, '2014-04-01 00:12:59.000000', 'consum', 0.0212, 'lps'),
	(605192, 128, '2014-04-01 00:13:00.000000', 'consum', 0.0212, 'lps'),
	(605193, 128, '2014-04-01 00:13:01.000000', 'consum', 0.0215, 'lps'),
	(605194, 128, '2014-04-01 00:13:02.000000', 'consum', 0.0219, 'lps'),
	(605195, 128, '2014-04-01 00:13:03.000000', 'consum', 0.0219, 'lps'),
	(605196, 128, '2014-04-01 00:13:04.000000', 'consum', 0.0210, 'lps'),
	(605197, 128, '2014-04-01 00:13:05.000000', 'consum', 0.0213, 'lps'),
	(605198, 128, '2014-04-01 00:13:06.000000', 'consum', 0.0216, 'lps'),
	(605199, 128, '2014-04-01 00:13:07.000000', 'consum', 0.0213, 'lps'),
	(605200, 128, '2014-04-01 00:13:08.000000', 'consum', 0.0218, 'lps'),
	(605201, 128, '2014-04-01 00:13:09.000000', 'consum', 0.0212, 'lps'),
	(605202, 128, '2014-04-01 00:13:10.000000', 'consum', 0.0216, 'lps'),
	(605203, 128, '2014-04-01 00:13:11.000000', 'consum', 0.0216, 'lps'),
	(605204, 128, '2014-04-01 00:13:12.000000', 'consum', 0.0210, 'lps'),
	(605205, 128, '2014-04-01 00:13:13.000000', 'consum', 0.0215, 'lps'),
	(605206, 128, '2014-04-01 00:13:14.000000', 'consum', 0.0214, 'lps'),
	(605207, 128, '2014-04-01 00:13:15.000000', 'consum', 0.0215, 'lps'),
	(605208, 128, '2014-04-01 00:13:16.000000', 'consum', 0.0213, 'lps'),
	(605209, 128, '2014-04-01 00:13:17.000000', 'consum', 0.0210, 'lps'),
	(605210, 128, '2014-04-01 00:13:18.000000', 'consum', 0.0214, 'lps'),
	(605211, 128, '2014-04-01 00:13:19.000000', 'consum', 0.0210, 'lps'),
	(605212, 128, '2014-04-01 00:13:20.000000', 'consum', 0.0218, 'lps'),
	(605213, 128, '2014-04-01 00:13:21.000000', 'consum', 0.0211, 'lps'),
	(605214, 128, '2014-04-01 00:13:22.000000', 'consum', 0.0211, 'lps'),
	(605215, 128, '2014-04-01 00:13:23.000000', 'consum', 0.0211, 'lps'),
	(605216, 128, '2014-04-01 00:13:24.000000', 'consum', 0.0212, 'lps'),
	(605217, 128, '2014-04-01 00:13:25.000000', 'consum', 0.0218, 'lps'),
	(605218, 128, '2014-04-01 00:13:26.000000', 'consum', 0.0215, 'lps'),
	(605219, 128, '2014-04-01 00:13:27.000000', 'consum', 0.0212, 'lps'),
	(605220, 128, '2014-04-01 00:13:28.000000', 'consum', 0.0216, 'lps'),
	(605221, 128, '2014-04-01 00:13:29.000000', 'consum', 0.0216, 'lps'),
	(605222, 128, '2014-04-01 00:13:30.000000', 'consum', 0.0211, 'lps'),
	(605223, 128, '2014-04-01 00:13:31.000000', 'consum', 0.0218, 'lps'),
	(605224, 128, '2014-04-01 00:13:32.000000', 'consum', 0.0216, 'lps'),
	(605225, 128, '2014-04-01 00:13:33.000000', 'consum', 0.0217, 'lps'),
	(605226, 128, '2014-04-01 00:13:34.000000', 'consum', 0.0218, 'lps'),
	(605227, 128, '2014-04-01 00:13:35.000000', 'consum', 0.0219, 'lps'),
	(605228, 128, '2014-04-01 00:13:36.000000', 'consum', 0.0210, 'lps'),
	(605229, 128, '2014-04-01 00:13:37.000000', 'consum', 0.0214, 'lps'),
	(605230, 128, '2014-04-01 00:13:38.000000', 'consum', 0.0211, 'lps'),
	(605231, 128, '2014-04-01 00:13:39.000000', 'consum', 0.0214, 'lps'),
	(605232, 128, '2014-04-01 00:13:40.000000', 'consum', 0.0218, 'lps'),
	(605233, 128, '2014-04-01 00:13:41.000000', 'consum', 0.0219, 'lps'),
	(605234, 128, '2014-04-01 00:13:42.000000', 'consum', 0.0219, 'lps'),
	(605235, 128, '2014-04-01 00:13:43.000000', 'consum', 0.0212, 'lps'),
	(605236, 128, '2014-04-01 00:13:44.000000', 'consum', 0.0210, 'lps'),
	(605237, 128, '2014-04-01 00:13:45.000000', 'consum', 0.0216, 'lps'),
	(605238, 128, '2014-04-01 00:13:46.000000', 'consum', 0.0212, 'lps'),
	(605239, 128, '2014-04-01 00:13:47.000000', 'consum', 0.0212, 'lps'),
	(605240, 128, '2014-04-01 00:13:48.000000', 'consum', 0.0215, 'lps'),
	(605241, 128, '2014-04-01 00:13:49.000000', 'consum', 0.0218, 'lps'),
	(605242, 128, '2014-04-01 00:13:50.000000', 'consum', 0.0215, 'lps'),
	(605243, 128, '2014-04-01 00:13:51.000000', 'consum', 0.0212, 'lps'),
	(605244, 128, '2014-04-01 00:13:52.000000', 'consum', 0.0217, 'lps'),
	(605245, 128, '2014-04-01 00:13:53.000000', 'consum', 0.0217, 'lps'),
	(605246, 128, '2014-04-01 00:13:54.000000', 'consum', 0.0218, 'lps'),
	(605247, 128, '2014-04-01 00:13:55.000000', 'consum', 0.0217, 'lps'),
	(605248, 128, '2014-04-01 00:13:56.000000', 'consum', 0.0211, 'lps'),
	(605249, 128, '2014-04-01 00:13:57.000000', 'consum', 0.0214, 'lps'),
	(605250, 128, '2014-04-01 00:13:58.000000', 'consum', 0.0217, 'lps'),
	(605251, 128, '2014-04-01 00:13:59.000000', 'consum', 0.0216, 'lps'),
	(605252, 128, '2014-04-01 00:14:00.000000', 'consum', 0.0218, 'lps'),
	(605253, 128, '2014-04-01 00:14:01.000000', 'consum', 0.0213, 'lps'),
	(605254, 128, '2014-04-01 00:14:02.000000', 'consum', 0.0210, 'lps'),
	(605255, 128, '2014-04-01 00:14:03.000000', 'consum', 0.0211, 'lps'),
	(605256, 128, '2014-04-01 00:14:04.000000', 'consum', 0.0217, 'lps'),
	(605257, 128, '2014-04-01 00:14:05.000000', 'consum', 0.0211, 'lps'),
	(605258, 128, '2014-04-01 00:14:06.000000', 'consum', 0.0216, 'lps'),
	(605259, 128, '2014-04-01 00:14:07.000000', 'consum', 0.0216, 'lps'),
	(605260, 128, '2014-04-01 00:14:08.000000', 'consum', 0.0215, 'lps'),
	(605261, 128, '2014-04-01 00:14:09.000000', 'consum', 0.0216, 'lps'),
	(605262, 128, '2014-04-01 00:14:10.000000', 'consum', 0.0217, 'lps'),
	(605263, 128, '2014-04-01 00:14:11.000000', 'consum', 0.0217, 'lps'),
	(605264, 128, '2014-04-01 00:14:12.000000', 'consum', 0.0215, 'lps'),
	(605265, 128, '2014-04-01 00:14:13.000000', 'consum', 0.0214, 'lps'),
	(605266, 128, '2014-04-01 00:14:14.000000', 'consum', 0.0216, 'lps'),
	(605267, 128, '2014-04-01 00:14:15.000000', 'consum', 0.0210, 'lps'),
	(605268, 128, '2014-04-01 00:14:16.000000', 'consum', 0.0210, 'lps'),
	(605269, 128, '2014-04-01 00:14:17.000000', 'consum', 0.0213, 'lps'),
	(605270, 128, '2014-04-01 00:14:18.000000', 'consum', 0.0212, 'lps'),
	(605271, 128, '2014-04-01 00:14:19.000000', 'consum', 0.0215, 'lps'),
	(605272, 128, '2014-04-01 00:14:20.000000', 'consum', 0.0219, 'lps'),
	(605273, 128, '2014-04-01 00:14:21.000000', 'consum', 0.0210, 'lps'),
	(605274, 128, '2014-04-01 00:14:22.000000', 'consum', 0.0212, 'lps'),
	(605275, 128, '2014-04-01 00:14:23.000000', 'consum', 0.0213, 'lps'),
	(605276, 128, '2014-04-01 00:14:24.000000', 'consum', 0.0218, 'lps'),
	(605277, 128, '2014-04-01 00:14:25.000000', 'consum', 0.0211, 'lps'),
	(605278, 128, '2014-04-01 00:14:26.000000', 'consum', 0.0211, 'lps'),
	(605279, 128, '2014-04-01 00:14:27.000000', 'consum', 0.0215, 'lps'),
	(605280, 128, '2014-04-01 00:14:28.000000', 'consum', 0.0210, 'lps'),
	(605281, 128, '2014-04-01 00:14:29.000000', 'consum', 0.0215, 'lps'),
	(605282, 128, '2014-04-01 00:14:30.000000', 'consum', 0.0215, 'lps'),
	(605283, 128, '2014-04-01 00:14:31.000000', 'consum', 0.0210, 'lps'),
	(605284, 128, '2014-04-01 00:14:32.000000', 'consum', 0.0216, 'lps'),
	(605285, 128, '2014-04-01 00:14:33.000000', 'consum', 0.0219, 'lps'),
	(605286, 128, '2014-04-01 00:14:34.000000', 'consum', 0.0219, 'lps'),
	(605287, 128, '2014-04-01 00:14:35.000000', 'consum', 0.0218, 'lps'),
	(605288, 128, '2014-04-01 00:14:36.000000', 'consum', 0.0215, 'lps'),
	(605289, 128, '2014-04-01 00:14:37.000000', 'consum', 0.0219, 'lps'),
	(605290, 128, '2014-04-01 00:14:38.000000', 'consum', 0.0213, 'lps'),
	(605291, 128, '2014-04-01 00:14:39.000000', 'consum', 0.0216, 'lps'),
	(605292, 128, '2014-04-01 00:14:40.000000', 'consum', 0.0214, 'lps'),
	(605293, 128, '2014-04-01 00:14:41.000000', 'consum', 0.0212, 'lps'),
	(605294, 128, '2014-04-01 00:14:42.000000', 'consum', 0.0217, 'lps'),
	(605295, 128, '2014-04-01 00:14:43.000000', 'consum', 0.0212, 'lps'),
	(605296, 128, '2014-04-01 00:14:44.000000', 'consum', 0.0218, 'lps'),
	(605297, 128, '2014-04-01 00:14:45.000000', 'consum', 0.0213, 'lps'),
	(605298, 128, '2014-04-01 00:14:46.000000', 'consum', 0.0212, 'lps'),
	(605299, 128, '2014-04-01 00:14:47.000000', 'consum', 0.0213, 'lps'),
	(605300, 128, '2014-04-01 00:14:48.000000', 'consum', 0.0217, 'lps'),
	(605301, 128, '2014-04-01 00:14:49.000000', 'consum', 0.0219, 'lps'),
	(605302, 128, '2014-04-01 00:14:50.000000', 'consum', 0.0213, 'lps'),
	(605303, 128, '2014-04-01 00:14:51.000000', 'consum', 0.0219, 'lps'),
	(605304, 128, '2014-04-01 00:14:52.000000', 'consum', 0.0218, 'lps'),
	(605305, 128, '2014-04-01 00:14:53.000000', 'consum', 0.0214, 'lps'),
	(605306, 128, '2014-04-01 00:14:54.000000', 'consum', 0.0217, 'lps'),
	(605307, 128, '2014-04-01 00:14:55.000000', 'consum', 0.0211, 'lps'),
	(605308, 128, '2014-04-01 00:14:56.000000', 'consum', 0.0214, 'lps'),
	(605309, 128, '2014-04-01 00:14:57.000000', 'consum', 0.0210, 'lps'),
	(605310, 128, '2014-04-01 00:14:58.000000', 'consum', 0.0215, 'lps'),
	(605311, 128, '2014-04-01 00:14:59.000000', 'consum', 0.0219, 'lps'),
	(605312, 128, '2014-04-01 00:15:00.000000', 'consum', 0.0218, 'lps'),
	(605313, 128, '2014-04-01 00:15:01.000000', 'consum', 0.0216, 'lps'),
	(605314, 128, '2014-04-01 00:15:02.000000', 'consum', 0.0216, 'lps'),
	(605315, 128, '2014-04-01 00:15:03.000000', 'consum', 0.0212, 'lps'),
	(605316, 128, '2014-04-01 00:15:04.000000', 'consum', 0.0214, 'lps'),
	(605317, 128, '2014-04-01 00:15:05.000000', 'consum', 0.0213, 'lps'),
	(605318, 128, '2014-04-01 00:15:06.000000', 'consum', 0.0212, 'lps'),
	(605319, 128, '2014-04-01 00:15:07.000000', 'consum', 0.0213, 'lps'),
	(605320, 128, '2014-04-01 00:15:08.000000', 'consum', 0.0210, 'lps'),
	(605321, 128, '2014-04-01 00:15:09.000000', 'consum', 0.0213, 'lps'),
	(605322, 128, '2014-04-01 00:15:10.000000', 'consum', 0.0214, 'lps'),
	(605323, 128, '2014-04-01 00:15:11.000000', 'consum', 0.0210, 'lps'),
	(605324, 128, '2014-04-01 00:15:12.000000', 'consum', 0.0218, 'lps'),
	(605325, 128, '2014-04-01 00:15:13.000000', 'consum', 0.0212, 'lps'),
	(605326, 128, '2014-04-01 00:15:14.000000', 'consum', 0.0217, 'lps'),
	(605327, 128, '2014-04-01 00:15:15.000000', 'consum', 0.0210, 'lps'),
	(605328, 128, '2014-04-01 00:15:16.000000', 'consum', 0.0211, 'lps'),
	(605329, 128, '2014-04-01 00:15:17.000000', 'consum', 0.0214, 'lps'),
	(605330, 128, '2014-04-01 00:15:18.000000', 'consum', 0.0215, 'lps'),
	(605331, 128, '2014-04-01 00:15:19.000000', 'consum', 0.0217, 'lps'),
	(605332, 128, '2014-04-01 00:15:20.000000', 'consum', 0.0219, 'lps'),
	(605333, 128, '2014-04-01 00:15:21.000000', 'consum', 0.0217, 'lps'),
	(605334, 128, '2014-04-01 00:15:22.000000', 'consum', 0.0216, 'lps'),
	(605335, 128, '2014-04-01 00:15:23.000000', 'consum', 0.0211, 'lps'),
	(605336, 128, '2014-04-01 00:15:24.000000', 'consum', 0.0215, 'lps'),
	(605337, 128, '2014-04-01 00:15:25.000000', 'consum', 0.0215, 'lps'),
	(605338, 128, '2014-04-01 00:15:26.000000', 'consum', 0.0211, 'lps'),
	(605339, 128, '2014-04-01 00:15:27.000000', 'consum', 0.0219, 'lps'),
	(605340, 128, '2014-04-01 00:15:28.000000', 'consum', 0.0215, 'lps'),
	(605341, 128, '2014-04-01 00:15:29.000000', 'consum', 0.0217, 'lps'),
	(605342, 128, '2014-04-01 00:15:30.000000', 'consum', 0.0219, 'lps'),
	(605343, 128, '2014-04-01 00:15:31.000000', 'consum', 0.0218, 'lps'),
	(605344, 128, '2014-04-01 00:15:32.000000', 'consum', 0.0210, 'lps'),
	(605345, 128, '2014-04-01 00:15:33.000000', 'consum', 0.0216, 'lps'),
	(605346, 128, '2014-04-01 00:15:34.000000', 'consum', 0.0214, 'lps'),
	(605347, 128, '2014-04-01 00:15:35.000000', 'consum', 0.0210, 'lps'),
	(605348, 128, '2014-04-01 00:15:36.000000', 'consum', 0.0218, 'lps'),
	(605349, 128, '2014-04-01 00:15:37.000000', 'consum', 0.0210, 'lps'),
	(605350, 128, '2014-04-01 00:15:38.000000', 'consum', 0.0219, 'lps'),
	(605351, 128, '2014-04-01 00:15:39.000000', 'consum', 0.0214, 'lps'),
	(605352, 128, '2014-04-01 00:15:40.000000', 'consum', 0.0214, 'lps'),
	(605353, 128, '2014-04-01 00:15:41.000000', 'consum', 0.0217, 'lps'),
	(605354, 128, '2014-04-01 00:15:42.000000', 'consum', 0.0213, 'lps'),
	(605355, 128, '2014-04-01 00:15:43.000000', 'consum', 0.0214, 'lps'),
	(605356, 128, '2014-04-01 00:15:44.000000', 'consum', 0.0212, 'lps'),
	(605357, 128, '2014-04-01 00:15:45.000000', 'consum', 0.0211, 'lps'),
	(605358, 128, '2014-04-01 00:15:46.000000', 'consum', 0.0216, 'lps'),
	(605359, 128, '2014-04-01 00:15:47.000000', 'consum', 0.0210, 'lps'),
	(605360, 128, '2014-04-01 00:15:48.000000', 'consum', 0.0212, 'lps'),
	(605361, 128, '2014-04-01 00:15:49.000000', 'consum', 0.0219, 'lps'),
	(605362, 128, '2014-04-01 00:15:50.000000', 'consum', 0.0218, 'lps'),
	(605363, 128, '2014-04-01 00:15:51.000000', 'consum', 0.0217, 'lps'),
	(605364, 128, '2014-04-01 00:15:52.000000', 'consum', 0.0212, 'lps'),
	(605365, 128, '2014-04-01 00:15:53.000000', 'consum', 0.0216, 'lps'),
	(605366, 128, '2014-04-01 00:15:54.000000', 'consum', 0.0217, 'lps'),
	(605367, 128, '2014-04-01 00:15:55.000000', 'consum', 0.0218, 'lps'),
	(605368, 128, '2014-04-01 00:15:56.000000', 'consum', 0.0219, 'lps'),
	(605369, 128, '2014-04-01 00:15:57.000000', 'consum', 0.0213, 'lps'),
	(605370, 128, '2014-04-01 00:15:58.000000', 'consum', 0.0218, 'lps'),
	(605371, 128, '2014-04-01 00:15:59.000000', 'consum', 0.0213, 'lps'),
	(605372, 128, '2014-04-01 00:16:00.000000', 'consum', 0.0211, 'lps'),
	(605373, 128, '2014-04-01 00:16:01.000000', 'consum', 0.0214, 'lps'),
	(605374, 128, '2014-04-01 00:16:02.000000', 'consum', 0.0218, 'lps'),
	(605375, 128, '2014-04-01 00:16:03.000000', 'consum', 0.0219, 'lps'),
	(605376, 128, '2014-04-01 00:16:04.000000', 'consum', 0.0212, 'lps'),
	(605377, 128, '2014-04-01 00:16:05.000000', 'consum', 0.0215, 'lps'),
	(605378, 128, '2014-04-01 00:16:06.000000', 'consum', 0.0218, 'lps'),
	(605379, 128, '2014-04-01 00:16:07.000000', 'consum', 0.0216, 'lps'),
	(605380, 128, '2014-04-01 00:16:08.000000', 'consum', 0.0215, 'lps'),
	(605381, 128, '2014-04-01 00:16:09.000000', 'consum', 0.0218, 'lps'),
	(605382, 128, '2014-04-01 00:16:10.000000', 'consum', 0.0215, 'lps'),
	(605383, 128, '2014-04-01 00:16:11.000000', 'consum', 0.0213, 'lps'),
	(605384, 128, '2014-04-01 00:16:12.000000', 'consum', 0.0210, 'lps'),
	(605385, 128, '2014-04-01 00:16:13.000000', 'consum', 0.0212, 'lps'),
	(605386, 128, '2014-04-01 00:16:14.000000', 'consum', 0.0218, 'lps'),
	(605387, 128, '2014-04-01 00:16:15.000000', 'consum', 0.0218, 'lps'),
	(605388, 128, '2014-04-01 00:16:16.000000', 'consum', 0.0214, 'lps'),
	(605389, 128, '2014-04-01 00:16:17.000000', 'consum', 0.0216, 'lps'),
	(605390, 128, '2014-04-01 00:16:18.000000', 'consum', 0.0210, 'lps'),
	(605391, 128, '2014-04-01 00:16:19.000000', 'consum', 0.0210, 'lps'),
	(605392, 128, '2014-04-01 00:16:20.000000', 'consum', 0.0213, 'lps'),
	(605393, 128, '2014-04-01 00:16:21.000000', 'consum', 0.0214, 'lps'),
	(605394, 128, '2014-04-01 00:16:22.000000', 'consum', 0.0213, 'lps'),
	(605395, 128, '2014-04-01 00:16:23.000000', 'consum', 0.0211, 'lps'),
	(605396, 128, '2014-04-01 00:16:24.000000', 'consum', 0.0217, 'lps'),
	(605397, 128, '2014-04-01 00:16:25.000000', 'consum', 0.0213, 'lps'),
	(605398, 128, '2014-04-01 00:16:26.000000', 'consum', 0.0214, 'lps'),
	(605399, 128, '2014-04-01 00:16:27.000000', 'consum', 0.0212, 'lps'),
	(605400, 128, '2014-04-01 00:16:28.000000', 'consum', 0.0218, 'lps'),
	(605401, 128, '2014-04-01 00:16:29.000000', 'consum', 0.0217, 'lps'),
	(605402, 128, '2014-04-01 00:16:30.000000', 'consum', 0.0210, 'lps'),
	(605403, 128, '2014-04-01 00:16:31.000000', 'consum', 0.0218, 'lps'),
	(605404, 128, '2014-04-01 00:16:32.000000', 'consum', 0.0211, 'lps'),
	(605405, 128, '2014-04-01 00:16:33.000000', 'consum', 0.0214, 'lps'),
	(605406, 128, '2014-04-01 00:16:34.000000', 'consum', 0.0216, 'lps'),
	(605407, 128, '2014-04-01 00:16:35.000000', 'consum', 0.0217, 'lps'),
	(605408, 128, '2014-04-01 00:16:36.000000', 'consum', 0.0211, 'lps'),
	(605409, 128, '2014-04-01 00:16:37.000000', 'consum', 0.0211, 'lps'),
	(605410, 128, '2014-04-01 00:16:38.000000', 'consum', 0.0215, 'lps'),
	(605411, 128, '2014-04-01 00:16:39.000000', 'consum', 0.0212, 'lps'),
	(605412, 128, '2014-04-01 00:16:40.000000', 'consum', 0.0216, 'lps'),
	(605413, 128, '2014-04-01 00:16:41.000000', 'consum', 0.0213, 'lps'),
	(605414, 128, '2014-04-01 00:16:42.000000', 'consum', 0.0217, 'lps'),
	(605415, 128, '2014-04-01 00:16:43.000000', 'consum', 0.0215, 'lps'),
	(605416, 128, '2014-04-01 00:16:44.000000', 'consum', 0.0217, 'lps'),
	(605417, 128, '2014-04-01 00:16:45.000000', 'consum', 0.0212, 'lps'),
	(605418, 128, '2014-04-01 00:16:46.000000', 'consum', 0.0218, 'lps'),
	(605419, 128, '2014-04-01 00:16:47.000000', 'consum', 0.0213, 'lps'),
	(605420, 128, '2014-04-01 00:16:48.000000', 'consum', 0.0212, 'lps'),
	(605421, 128, '2014-04-01 00:16:49.000000', 'consum', 0.0213, 'lps'),
	(605422, 128, '2014-04-01 00:16:50.000000', 'consum', 0.0217, 'lps'),
	(605423, 128, '2014-04-01 00:16:51.000000', 'consum', 0.0218, 'lps'),
	(605424, 128, '2014-04-01 00:16:52.000000', 'consum', 0.0211, 'lps'),
	(605425, 128, '2014-04-01 00:16:53.000000', 'consum', 0.0219, 'lps'),
	(605426, 128, '2014-04-01 00:16:54.000000', 'consum', 0.0212, 'lps'),
	(605427, 128, '2014-04-01 00:16:55.000000', 'consum', 0.0213, 'lps'),
	(605428, 128, '2014-04-01 00:16:56.000000', 'consum', 0.0211, 'lps'),
	(605429, 128, '2014-04-01 00:16:57.000000', 'consum', 0.0218, 'lps'),
	(605430, 128, '2014-04-01 00:16:58.000000', 'consum', 0.0215, 'lps'),
	(605431, 128, '2014-04-01 00:16:59.000000', 'consum', 0.0212, 'lps'),
	(605432, 128, '2014-04-01 00:17:00.000000', 'consum', 0.0215, 'lps'),
	(605433, 128, '2014-04-01 00:17:01.000000', 'consum', 0.0210, 'lps'),
	(605434, 128, '2014-04-01 00:17:02.000000', 'consum', 0.0215, 'lps'),
	(605435, 128, '2014-04-01 00:17:03.000000', 'consum', 0.0218, 'lps'),
	(605436, 128, '2014-04-01 00:17:04.000000', 'consum', 0.0213, 'lps'),
	(605437, 128, '2014-04-01 00:17:05.000000', 'consum', 0.0213, 'lps'),
	(605438, 128, '2014-04-01 00:17:06.000000', 'consum', 0.0215, 'lps'),
	(605439, 128, '2014-04-01 00:17:07.000000', 'consum', 0.0219, 'lps'),
	(605440, 128, '2014-04-01 00:17:08.000000', 'consum', 0.0219, 'lps'),
	(605441, 128, '2014-04-01 00:17:09.000000', 'consum', 0.0218, 'lps'),
	(605442, 128, '2014-04-01 00:17:10.000000', 'consum', 0.0214, 'lps'),
	(605443, 128, '2014-04-01 00:17:11.000000', 'consum', 0.0217, 'lps'),
	(605444, 128, '2014-04-01 00:17:12.000000', 'consum', 0.0214, 'lps'),
	(605445, 128, '2014-04-01 00:17:13.000000', 'consum', 0.0217, 'lps'),
	(605446, 128, '2014-04-01 00:17:14.000000', 'consum', 0.0214, 'lps'),
	(605447, 128, '2014-04-01 00:17:15.000000', 'consum', 0.0211, 'lps'),
	(605448, 128, '2014-04-01 00:17:16.000000', 'consum', 0.0214, 'lps'),
	(605449, 128, '2014-04-01 00:17:17.000000', 'consum', 0.0215, 'lps'),
	(605450, 128, '2014-04-01 00:17:18.000000', 'consum', 0.0215, 'lps'),
	(605451, 128, '2014-04-01 00:17:19.000000', 'consum', 0.0218, 'lps'),
	(605452, 128, '2014-04-01 00:17:20.000000', 'consum', 0.0218, 'lps'),
	(605453, 128, '2014-04-01 00:17:21.000000', 'consum', 0.0217, 'lps'),
	(605454, 128, '2014-04-01 00:17:22.000000', 'consum', 0.0211, 'lps'),
	(605455, 128, '2014-04-01 00:17:23.000000', 'consum', 0.0216, 'lps'),
	(605456, 128, '2014-04-01 00:17:24.000000', 'consum', 0.0217, 'lps'),
	(605457, 128, '2014-04-01 00:17:25.000000', 'consum', 0.0218, 'lps'),
	(605458, 128, '2014-04-01 00:17:26.000000', 'consum', 0.0217, 'lps'),
	(605459, 128, '2014-04-01 00:17:27.000000', 'consum', 0.0214, 'lps'),
	(605460, 128, '2014-04-01 00:17:28.000000', 'consum', 0.0210, 'lps'),
	(605461, 128, '2014-04-01 00:17:29.000000', 'consum', 0.0218, 'lps'),
	(605462, 128, '2014-04-01 00:17:30.000000', 'consum', 0.0211, 'lps'),
	(605463, 128, '2014-04-01 00:17:31.000000', 'consum', 0.0210, 'lps'),
	(605464, 128, '2014-04-01 00:17:32.000000', 'consum', 0.0216, 'lps'),
	(605465, 128, '2014-04-01 00:17:33.000000', 'consum', 0.0213, 'lps'),
	(605466, 128, '2014-04-01 00:17:34.000000', 'consum', 0.0218, 'lps'),
	(605467, 128, '2014-04-01 00:17:35.000000', 'consum', 0.0210, 'lps'),
	(605468, 128, '2014-04-01 00:17:36.000000', 'consum', 0.0215, 'lps'),
	(605469, 128, '2014-04-01 00:17:37.000000', 'consum', 0.0217, 'lps'),
	(605470, 128, '2014-04-01 00:17:38.000000', 'consum', 0.0211, 'lps'),
	(605471, 128, '2014-04-01 00:17:39.000000', 'consum', 0.0213, 'lps'),
	(605472, 128, '2014-04-01 00:17:40.000000', 'consum', 0.0215, 'lps'),
	(605473, 128, '2014-04-01 00:17:41.000000', 'consum', 0.0214, 'lps'),
	(605474, 128, '2014-04-01 00:17:42.000000', 'consum', 0.0215, 'lps'),
	(605475, 128, '2014-04-01 00:17:43.000000', 'consum', 0.0214, 'lps'),
	(605476, 128, '2014-04-01 00:17:44.000000', 'consum', 0.0216, 'lps'),
	(605477, 128, '2014-04-01 00:17:45.000000', 'consum', 0.0210, 'lps'),
	(605478, 128, '2014-04-01 00:17:46.000000', 'consum', 0.0212, 'lps'),
	(605479, 128, '2014-04-01 00:17:47.000000', 'consum', 0.0219, 'lps'),
	(605480, 128, '2014-04-01 00:17:48.000000', 'consum', 0.0218, 'lps'),
	(605481, 128, '2014-04-01 00:17:49.000000', 'consum', 0.0216, 'lps'),
	(605482, 128, '2014-04-01 00:17:50.000000', 'consum', 0.0215, 'lps'),
	(605483, 128, '2014-04-01 00:17:51.000000', 'consum', 0.0218, 'lps'),
	(605484, 128, '2014-04-01 00:17:52.000000', 'consum', 0.0214, 'lps'),
	(605485, 128, '2014-04-01 00:17:53.000000', 'consum', 0.0219, 'lps'),
	(605486, 128, '2014-04-01 00:17:54.000000', 'consum', 0.0213, 'lps'),
	(605487, 128, '2014-04-01 00:17:55.000000', 'consum', 0.0217, 'lps'),
	(605488, 128, '2014-04-01 00:17:56.000000', 'consum', 0.0215, 'lps'),
	(605489, 128, '2014-04-01 00:17:57.000000', 'consum', 0.0217, 'lps'),
	(605490, 128, '2014-04-01 00:17:58.000000', 'consum', 0.0211, 'lps'),
	(605491, 128, '2014-04-01 00:17:59.000000', 'consum', 0.0213, 'lps'),
	(605492, 128, '2014-04-01 00:18:00.000000', 'consum', 0.0213, 'lps'),
	(605493, 128, '2014-04-01 00:18:01.000000', 'consum', 0.0215, 'lps'),
	(605494, 128, '2014-04-01 00:18:02.000000', 'consum', 0.0219, 'lps'),
	(605495, 128, '2014-04-01 00:18:03.000000', 'consum', 0.0218, 'lps'),
	(605496, 128, '2014-04-01 00:18:04.000000', 'consum', 0.0216, 'lps'),
	(605497, 128, '2014-04-01 00:18:05.000000', 'consum', 0.0214, 'lps'),
	(605498, 128, '2014-04-01 00:18:06.000000', 'consum', 0.0215, 'lps'),
	(605499, 128, '2014-04-01 00:18:07.000000', 'consum', 0.0214, 'lps'),
	(605500, 128, '2014-04-01 00:18:08.000000', 'consum', 0.0213, 'lps'),
	(605501, 128, '2014-04-01 00:18:09.000000', 'consum', 0.0213, 'lps'),
	(605502, 128, '2014-04-01 00:18:10.000000', 'consum', 0.0217, 'lps'),
	(605503, 128, '2014-04-01 00:18:11.000000', 'consum', 0.0217, 'lps'),
	(605504, 128, '2014-04-01 00:18:12.000000', 'consum', 0.0212, 'lps'),
	(605505, 128, '2014-04-01 00:18:13.000000', 'consum', 0.0213, 'lps'),
	(605506, 128, '2014-04-01 00:18:14.000000', 'consum', 0.0217, 'lps'),
	(605507, 128, '2014-04-01 00:18:15.000000', 'consum', 0.0219, 'lps'),
	(605508, 128, '2014-04-01 00:18:16.000000', 'consum', 0.0213, 'lps'),
	(605509, 128, '2014-04-01 00:18:17.000000', 'consum', 0.0217, 'lps'),
	(605510, 128, '2014-04-01 00:18:18.000000', 'consum', 0.0217, 'lps'),
	(605511, 128, '2014-04-01 00:18:19.000000', 'consum', 0.0216, 'lps'),
	(605512, 128, '2014-04-01 00:18:20.000000', 'consum', 0.0211, 'lps'),
	(605513, 128, '2014-04-01 00:18:21.000000', 'consum', 0.0215, 'lps'),
	(605514, 128, '2014-04-01 00:18:22.000000', 'consum', 0.0215, 'lps'),
	(605515, 128, '2014-04-01 00:18:23.000000', 'consum', 0.0210, 'lps'),
	(605516, 128, '2014-04-01 00:18:24.000000', 'consum', 0.0213, 'lps'),
	(605517, 128, '2014-04-01 00:18:25.000000', 'consum', 0.0217, 'lps'),
	(605518, 128, '2014-04-01 00:18:26.000000', 'consum', 0.0215, 'lps'),
	(605519, 128, '2014-04-01 00:18:27.000000', 'consum', 0.0213, 'lps'),
	(605520, 128, '2014-04-01 00:18:28.000000', 'consum', 0.0214, 'lps'),
	(605521, 128, '2014-04-01 00:18:29.000000', 'consum', 0.0210, 'lps'),
	(605522, 128, '2014-04-01 00:18:30.000000', 'consum', 0.0219, 'lps'),
	(605523, 128, '2014-04-01 00:18:31.000000', 'consum', 0.0217, 'lps'),
	(605524, 128, '2014-04-01 00:18:32.000000', 'consum', 0.0219, 'lps'),
	(605525, 128, '2014-04-01 00:18:33.000000', 'consum', 0.0212, 'lps'),
	(605526, 128, '2014-04-01 00:18:34.000000', 'consum', 0.0214, 'lps'),
	(605527, 128, '2014-04-01 00:18:35.000000', 'consum', 0.0216, 'lps'),
	(605528, 128, '2014-04-01 00:18:36.000000', 'consum', 0.0218, 'lps'),
	(605529, 128, '2014-04-01 00:18:37.000000', 'consum', 0.0214, 'lps'),
	(605530, 128, '2014-04-01 00:18:38.000000', 'consum', 0.0215, 'lps'),
	(605531, 128, '2014-04-01 00:18:39.000000', 'consum', 0.0215, 'lps'),
	(605532, 128, '2014-04-01 00:18:40.000000', 'consum', 0.0211, 'lps'),
	(605533, 128, '2014-04-01 00:18:41.000000', 'consum', 0.0211, 'lps'),
	(605534, 128, '2014-04-01 00:18:42.000000', 'consum', 0.0212, 'lps'),
	(605535, 128, '2014-04-01 00:18:43.000000', 'consum', 0.0218, 'lps'),
	(605536, 128, '2014-04-01 00:18:44.000000', 'consum', 0.0213, 'lps'),
	(605537, 128, '2014-04-01 00:18:45.000000', 'consum', 0.0212, 'lps'),
	(605538, 128, '2014-04-01 00:18:46.000000', 'consum', 0.0210, 'lps'),
	(605539, 128, '2014-04-01 00:18:47.000000', 'consum', 0.0218, 'lps'),
	(605540, 128, '2014-04-01 00:18:48.000000', 'consum', 0.0217, 'lps'),
	(605541, 128, '2014-04-01 00:18:49.000000', 'consum', 0.0214, 'lps'),
	(605542, 128, '2014-04-01 00:18:50.000000', 'consum', 0.0219, 'lps'),
	(605543, 128, '2014-04-01 00:18:51.000000', 'consum', 0.0214, 'lps'),
	(605544, 128, '2014-04-01 00:18:52.000000', 'consum', 0.0212, 'lps'),
	(605545, 128, '2014-04-01 00:18:53.000000', 'consum', 0.0219, 'lps'),
	(605546, 128, '2014-04-01 00:18:54.000000', 'consum', 0.0219, 'lps'),
	(605547, 128, '2014-04-01 00:18:55.000000', 'consum', 0.0217, 'lps'),
	(605548, 128, '2014-04-01 00:18:56.000000', 'consum', 0.0212, 'lps'),
	(605549, 128, '2014-04-01 00:18:57.000000', 'consum', 0.0217, 'lps'),
	(605550, 128, '2014-04-01 00:18:58.000000', 'consum', 0.0212, 'lps'),
	(605551, 128, '2014-04-01 00:18:59.000000', 'consum', 0.0217, 'lps'),
	(605552, 128, '2014-04-01 00:19:00.000000', 'consum', 0.0219, 'lps'),
	(605553, 128, '2014-04-01 00:19:01.000000', 'consum', 0.0215, 'lps'),
	(605554, 128, '2014-04-01 00:19:02.000000', 'consum', 0.0210, 'lps'),
	(605555, 128, '2014-04-01 00:19:03.000000', 'consum', 0.0214, 'lps'),
	(605556, 128, '2014-04-01 00:19:04.000000', 'consum', 0.0211, 'lps'),
	(605557, 128, '2014-04-01 00:19:05.000000', 'consum', 0.0214, 'lps'),
	(605558, 128, '2014-04-01 00:19:06.000000', 'consum', 0.0218, 'lps'),
	(605559, 128, '2014-04-01 00:19:07.000000', 'consum', 0.0219, 'lps'),
	(605560, 128, '2014-04-01 00:19:08.000000', 'consum', 0.0210, 'lps'),
	(605561, 128, '2014-04-01 00:19:09.000000', 'consum', 0.0214, 'lps'),
	(605562, 128, '2014-04-01 00:19:10.000000', 'consum', 0.0218, 'lps'),
	(605563, 128, '2014-04-01 00:19:11.000000', 'consum', 0.0212, 'lps'),
	(605564, 128, '2014-04-01 00:19:12.000000', 'consum', 0.0215, 'lps'),
	(605565, 128, '2014-04-01 00:19:13.000000', 'consum', 0.0211, 'lps'),
	(605566, 128, '2014-04-01 00:19:14.000000', 'consum', 0.0218, 'lps'),
	(605567, 128, '2014-04-01 00:19:15.000000', 'consum', 0.0217, 'lps'),
	(605568, 128, '2014-04-01 00:19:16.000000', 'consum', 0.0213, 'lps'),
	(605569, 128, '2014-04-01 00:19:17.000000', 'consum', 0.0213, 'lps'),
	(605570, 128, '2014-04-01 00:19:18.000000', 'consum', 0.0218, 'lps'),
	(605571, 128, '2014-04-01 00:19:19.000000', 'consum', 0.0210, 'lps'),
	(605572, 128, '2014-04-01 00:19:20.000000', 'consum', 0.0216, 'lps'),
	(605573, 128, '2014-04-01 00:19:21.000000', 'consum', 0.0213, 'lps'),
	(605574, 128, '2014-04-01 00:19:22.000000', 'consum', 0.0215, 'lps'),
	(605575, 128, '2014-04-01 00:19:23.000000', 'consum', 0.0218, 'lps'),
	(605576, 128, '2014-04-01 00:19:24.000000', 'consum', 0.0217, 'lps'),
	(605577, 128, '2014-04-01 00:19:25.000000', 'consum', 0.0210, 'lps'),
	(605578, 128, '2014-04-01 00:19:26.000000', 'consum', 0.0211, 'lps'),
	(605579, 128, '2014-04-01 00:19:27.000000', 'consum', 0.0215, 'lps'),
	(605580, 128, '2014-04-01 00:19:28.000000', 'consum', 0.0213, 'lps'),
	(605581, 128, '2014-04-01 00:19:29.000000', 'consum', 0.0219, 'lps'),
	(605582, 128, '2014-04-01 00:19:30.000000', 'consum', 0.0218, 'lps'),
	(605583, 128, '2014-04-01 00:19:31.000000', 'consum', 0.0213, 'lps'),
	(605584, 128, '2014-04-01 00:19:32.000000', 'consum', 0.0210, 'lps'),
	(605585, 128, '2014-04-01 00:19:33.000000', 'consum', 0.0211, 'lps'),
	(605586, 128, '2014-04-01 00:19:34.000000', 'consum', 0.0216, 'lps'),
	(605587, 128, '2014-04-01 00:19:35.000000', 'consum', 0.0216, 'lps'),
	(605588, 128, '2014-04-01 00:19:36.000000', 'consum', 0.0215, 'lps'),
	(605589, 128, '2014-04-01 00:19:37.000000', 'consum', 0.0218, 'lps'),
	(605590, 128, '2014-04-01 00:19:38.000000', 'consum', 0.0216, 'lps'),
	(605591, 128, '2014-04-01 00:19:39.000000', 'consum', 0.0214, 'lps'),
	(605592, 128, '2014-04-01 00:19:40.000000', 'consum', 0.0212, 'lps'),
	(605593, 128, '2014-04-01 00:19:41.000000', 'consum', 0.0219, 'lps'),
	(605594, 128, '2014-04-01 00:19:42.000000', 'consum', 0.0211, 'lps'),
	(605595, 128, '2014-04-01 00:19:43.000000', 'consum', 0.0217, 'lps'),
	(605596, 128, '2014-04-01 00:19:44.000000', 'consum', 0.0213, 'lps'),
	(605597, 128, '2014-04-01 00:19:45.000000', 'consum', 0.0215, 'lps'),
	(605598, 128, '2014-04-01 00:19:46.000000', 'consum', 0.0215, 'lps'),
	(605599, 128, '2014-04-01 00:19:47.000000', 'consum', 0.0212, 'lps'),
	(605600, 128, '2014-04-01 00:19:48.000000', 'consum', 0.0215, 'lps'),
	(605601, 128, '2014-04-01 00:19:49.000000', 'consum', 0.0210, 'lps'),
	(605602, 128, '2014-04-01 00:19:50.000000', 'consum', 0.0214, 'lps'),
	(605603, 128, '2014-04-01 00:19:51.000000', 'consum', 0.0210, 'lps'),
	(605604, 128, '2014-04-01 00:19:52.000000', 'consum', 0.0212, 'lps'),
	(605605, 128, '2014-04-01 00:19:53.000000', 'consum', 0.0217, 'lps'),
	(605606, 128, '2014-04-01 00:19:54.000000', 'consum', 0.0219, 'lps'),
	(605607, 128, '2014-04-01 00:19:55.000000', 'consum', 0.0216, 'lps'),
	(605608, 128, '2014-04-01 00:19:56.000000', 'consum', 0.0213, 'lps'),
	(605609, 128, '2014-04-01 00:19:57.000000', 'consum', 0.0216, 'lps'),
	(605610, 128, '2014-04-01 00:19:58.000000', 'consum', 0.0211, 'lps'),
	(605611, 128, '2014-04-01 00:19:59.000000', 'consum', 0.0218, 'lps'),
	(605612, 128, '2014-04-01 00:20:00.000000', 'consum', 0.0210, 'lps'),
	(605613, 128, '2014-04-01 00:20:01.000000', 'consum', 0.0213, 'lps'),
	(605614, 128, '2014-04-01 00:20:02.000000', 'consum', 0.0218, 'lps'),
	(605615, 128, '2014-04-01 00:20:03.000000', 'consum', 0.0219, 'lps'),
	(605616, 128, '2014-04-01 00:20:04.000000', 'consum', 0.0214, 'lps'),
	(605617, 128, '2014-04-01 00:20:05.000000', 'consum', 0.0212, 'lps'),
	(605618, 128, '2014-04-01 00:20:06.000000', 'consum', 0.0218, 'lps'),
	(605619, 128, '2014-04-01 00:20:07.000000', 'consum', 0.0213, 'lps'),
	(605620, 128, '2014-04-01 00:20:08.000000', 'consum', 0.0214, 'lps'),
	(605621, 128, '2014-04-01 00:20:09.000000', 'consum', 0.0211, 'lps'),
	(605622, 128, '2014-04-01 00:20:10.000000', 'consum', 0.0214, 'lps'),
	(605623, 128, '2014-04-01 00:20:11.000000', 'consum', 0.0216, 'lps'),
	(605624, 128, '2014-04-01 00:20:12.000000', 'consum', 0.0218, 'lps'),
	(605625, 128, '2014-04-01 00:20:13.000000', 'consum', 0.0212, 'lps'),
	(605626, 128, '2014-04-01 00:20:14.000000', 'consum', 0.0216, 'lps'),
	(605627, 128, '2014-04-01 00:20:15.000000', 'consum', 0.0216, 'lps'),
	(605628, 128, '2014-04-01 00:20:16.000000', 'consum', 0.0211, 'lps'),
	(605629, 128, '2014-04-01 00:20:17.000000', 'consum', 0.0217, 'lps'),
	(605630, 128, '2014-04-01 00:20:18.000000', 'consum', 0.0212, 'lps'),
	(605631, 128, '2014-04-01 00:20:19.000000', 'consum', 0.0211, 'lps'),
	(605632, 128, '2014-04-01 00:20:20.000000', 'consum', 0.0219, 'lps'),
	(605633, 128, '2014-04-01 00:20:21.000000', 'consum', 0.0214, 'lps'),
	(605634, 128, '2014-04-01 00:20:22.000000', 'consum', 0.0212, 'lps'),
	(605635, 128, '2014-04-01 00:20:23.000000', 'consum', 0.0211, 'lps'),
	(605636, 128, '2014-04-01 00:20:24.000000', 'consum', 0.0217, 'lps'),
	(605637, 128, '2014-04-01 00:20:25.000000', 'consum', 0.0214, 'lps'),
	(605638, 128, '2014-04-01 00:20:26.000000', 'consum', 0.0211, 'lps'),
	(605639, 128, '2014-04-01 00:20:27.000000', 'consum', 0.0210, 'lps'),
	(605640, 128, '2014-04-01 00:20:28.000000', 'consum', 0.0210, 'lps'),
	(605641, 128, '2014-04-01 00:20:29.000000', 'consum', 0.0219, 'lps'),
	(605642, 128, '2014-04-01 00:20:30.000000', 'consum', 0.0218, 'lps'),
	(605643, 128, '2014-04-01 00:20:31.000000', 'consum', 0.0210, 'lps'),
	(605644, 128, '2014-04-01 00:20:32.000000', 'consum', 0.0219, 'lps'),
	(605645, 128, '2014-04-01 00:20:33.000000', 'consum', 0.0214, 'lps'),
	(605646, 128, '2014-04-01 00:20:34.000000', 'consum', 0.0214, 'lps'),
	(605647, 128, '2014-04-01 00:20:35.000000', 'consum', 0.0218, 'lps'),
	(605648, 128, '2014-04-01 00:20:36.000000', 'consum', 0.0218, 'lps'),
	(605649, 128, '2014-04-01 00:20:37.000000', 'consum', 0.0219, 'lps'),
	(605650, 128, '2014-04-01 00:20:38.000000', 'consum', 0.0211, 'lps'),
	(605651, 128, '2014-04-01 00:20:39.000000', 'consum', 0.0217, 'lps'),
	(605652, 128, '2014-04-01 00:20:40.000000', 'consum', 0.0213, 'lps'),
	(605653, 128, '2014-04-01 00:20:41.000000', 'consum', 0.0214, 'lps'),
	(605654, 128, '2014-04-01 00:20:42.000000', 'consum', 0.0214, 'lps'),
	(605655, 128, '2014-04-01 00:20:43.000000', 'consum', 0.0216, 'lps'),
	(605656, 128, '2014-04-01 00:20:44.000000', 'consum', 0.0219, 'lps'),
	(605657, 128, '2014-04-01 00:20:45.000000', 'consum', 0.0219, 'lps'),
	(605658, 128, '2014-04-01 00:20:46.000000', 'consum', 0.0216, 'lps'),
	(605659, 128, '2014-04-01 00:20:47.000000', 'consum', 0.0215, 'lps'),
	(605660, 128, '2014-04-01 00:20:48.000000', 'consum', 0.0219, 'lps'),
	(605661, 128, '2014-04-01 00:20:49.000000', 'consum', 0.0219, 'lps'),
	(605662, 128, '2014-04-01 00:20:50.000000', 'consum', 0.0217, 'lps'),
	(605663, 128, '2014-04-01 00:20:51.000000', 'consum', 0.0219, 'lps'),
	(605664, 128, '2014-04-01 00:20:52.000000', 'consum', 0.0216, 'lps'),
	(605665, 128, '2014-04-01 00:20:53.000000', 'consum', 0.0213, 'lps'),
	(605666, 128, '2014-04-01 00:20:54.000000', 'consum', 0.0216, 'lps'),
	(605667, 128, '2014-04-01 00:20:55.000000', 'consum', 0.0210, 'lps'),
	(605668, 128, '2014-04-01 00:20:56.000000', 'consum', 0.0215, 'lps'),
	(605669, 128, '2014-04-01 00:20:57.000000', 'consum', 0.0217, 'lps'),
	(605670, 128, '2014-04-01 00:20:58.000000', 'consum', 0.0219, 'lps'),
	(605671, 128, '2014-04-01 00:20:59.000000', 'consum', 0.0217, 'lps'),
	(605672, 128, '2014-04-01 00:21:00.000000', 'consum', 0.0215, 'lps'),
	(605673, 128, '2014-04-01 00:21:01.000000', 'consum', 0.0215, 'lps'),
	(605674, 128, '2014-04-01 00:21:02.000000', 'consum', 0.0211, 'lps'),
	(605675, 128, '2014-04-01 00:21:03.000000', 'consum', 0.0211, 'lps'),
	(605676, 128, '2014-04-01 00:21:04.000000', 'consum', 0.0211, 'lps'),
	(605677, 128, '2014-04-01 00:21:05.000000', 'consum', 0.0212, 'lps'),
	(605678, 128, '2014-04-01 00:21:06.000000', 'consum', 0.0219, 'lps'),
	(605679, 128, '2014-04-01 00:21:07.000000', 'consum', 0.0219, 'lps'),
	(605680, 128, '2014-04-01 00:21:08.000000', 'consum', 0.0211, 'lps'),
	(605681, 128, '2014-04-01 00:21:09.000000', 'consum', 0.0215, 'lps'),
	(605682, 128, '2014-04-01 00:21:10.000000', 'consum', 0.0214, 'lps'),
	(605683, 128, '2014-04-01 00:21:11.000000', 'consum', 0.0214, 'lps'),
	(605684, 128, '2014-04-01 00:21:12.000000', 'consum', 0.0210, 'lps'),
	(605685, 128, '2014-04-01 00:21:13.000000', 'consum', 0.0210, 'lps'),
	(605686, 128, '2014-04-01 00:21:14.000000', 'consum', 0.0210, 'lps'),
	(605687, 128, '2014-04-01 00:21:15.000000', 'consum', 0.0210, 'lps'),
	(605688, 128, '2014-04-01 00:21:16.000000', 'consum', 0.0212, 'lps'),
	(605689, 128, '2014-04-01 00:21:17.000000', 'consum', 0.0219, 'lps'),
	(605690, 128, '2014-04-01 00:21:18.000000', 'consum', 0.0210, 'lps'),
	(605691, 128, '2014-04-01 00:21:19.000000', 'consum', 0.0215, 'lps'),
	(605692, 128, '2014-04-01 00:21:20.000000', 'consum', 0.0214, 'lps'),
	(605693, 128, '2014-04-01 00:21:21.000000', 'consum', 0.0217, 'lps'),
	(605694, 128, '2014-04-01 00:21:22.000000', 'consum', 0.0214, 'lps'),
	(605695, 128, '2014-04-01 00:21:23.000000', 'consum', 0.0217, 'lps'),
	(605696, 128, '2014-04-01 00:21:24.000000', 'consum', 0.0216, 'lps'),
	(605697, 128, '2014-04-01 00:21:25.000000', 'consum', 0.0210, 'lps'),
	(605698, 128, '2014-04-01 00:21:26.000000', 'consum', 0.0210, 'lps'),
	(605699, 128, '2014-04-01 00:21:27.000000', 'consum', 0.0213, 'lps'),
	(605700, 128, '2014-04-01 00:21:28.000000', 'consum', 0.0215, 'lps'),
	(605701, 128, '2014-04-01 00:21:29.000000', 'consum', 0.0217, 'lps'),
	(605702, 128, '2014-04-01 00:21:30.000000', 'consum', 0.0211, 'lps'),
	(605703, 128, '2014-04-01 00:21:31.000000', 'consum', 0.0215, 'lps'),
	(605704, 128, '2014-04-01 00:21:32.000000', 'consum', 0.0214, 'lps'),
	(605705, 128, '2014-04-01 00:21:33.000000', 'consum', 0.0212, 'lps'),
	(605706, 128, '2014-04-01 00:21:34.000000', 'consum', 0.0219, 'lps'),
	(605707, 128, '2014-04-01 00:21:35.000000', 'consum', 0.0219, 'lps'),
	(605708, 128, '2014-04-01 00:21:36.000000', 'consum', 0.0210, 'lps'),
	(605709, 128, '2014-04-01 00:21:37.000000', 'consum', 0.0211, 'lps'),
	(605710, 128, '2014-04-01 00:21:38.000000', 'consum', 0.0219, 'lps'),
	(605711, 128, '2014-04-01 00:21:39.000000', 'consum', 0.0219, 'lps'),
	(605712, 128, '2014-04-01 00:21:40.000000', 'consum', 0.0211, 'lps'),
	(605713, 128, '2014-04-01 00:21:41.000000', 'consum', 0.0217, 'lps'),
	(605714, 128, '2014-04-01 00:21:42.000000', 'consum', 0.0211, 'lps'),
	(605715, 128, '2014-04-01 00:21:43.000000', 'consum', 0.0215, 'lps'),
	(605716, 128, '2014-04-01 00:21:44.000000', 'consum', 0.0215, 'lps'),
	(605717, 128, '2014-04-01 00:21:45.000000', 'consum', 0.0219, 'lps'),
	(605718, 128, '2014-04-01 00:21:46.000000', 'consum', 0.0219, 'lps'),
	(605719, 128, '2014-04-01 00:21:47.000000', 'consum', 0.0219, 'lps'),
	(605720, 128, '2014-04-01 00:21:48.000000', 'consum', 0.0211, 'lps'),
	(605721, 128, '2014-04-01 00:21:49.000000', 'consum', 0.0216, 'lps'),
	(605722, 128, '2014-04-01 00:21:50.000000', 'consum', 0.0217, 'lps'),
	(605723, 128, '2014-04-01 00:21:51.000000', 'consum', 0.0216, 'lps'),
	(605724, 128, '2014-04-01 00:21:52.000000', 'consum', 0.0212, 'lps'),
	(605725, 128, '2014-04-01 00:21:53.000000', 'consum', 0.0213, 'lps'),
	(605726, 128, '2014-04-01 00:21:54.000000', 'consum', 0.0217, 'lps'),
	(605727, 128, '2014-04-01 00:21:55.000000', 'consum', 0.0218, 'lps'),
	(605728, 128, '2014-04-01 00:21:56.000000', 'consum', 0.0217, 'lps'),
	(605729, 128, '2014-04-01 00:21:57.000000', 'consum', 0.0214, 'lps'),
	(605730, 128, '2014-04-01 00:21:58.000000', 'consum', 0.0210, 'lps'),
	(605731, 128, '2014-04-01 00:21:59.000000', 'consum', 0.0216, 'lps'),
	(605732, 128, '2014-04-01 00:22:00.000000', 'consum', 0.0212, 'lps'),
	(605733, 128, '2014-04-01 00:22:01.000000', 'consum', 0.0211, 'lps'),
	(605734, 128, '2014-04-01 00:22:02.000000', 'consum', 0.0211, 'lps'),
	(605735, 128, '2014-04-01 00:22:03.000000', 'consum', 0.0213, 'lps'),
	(605736, 128, '2014-04-01 00:22:04.000000', 'consum', 0.0212, 'lps'),
	(605737, 128, '2014-04-01 00:22:05.000000', 'consum', 0.0213, 'lps'),
	(605738, 128, '2014-04-01 00:22:06.000000', 'consum', 0.0217, 'lps'),
	(605739, 128, '2014-04-01 00:22:07.000000', 'consum', 0.0218, 'lps'),
	(605740, 128, '2014-04-01 00:22:08.000000', 'consum', 0.0210, 'lps'),
	(605741, 128, '2014-04-01 00:22:09.000000', 'consum', 0.0214, 'lps'),
	(605742, 128, '2014-04-01 00:22:10.000000', 'consum', 0.0211, 'lps'),
	(605743, 128, '2014-04-01 00:22:11.000000', 'consum', 0.0216, 'lps'),
	(605744, 128, '2014-04-01 00:22:12.000000', 'consum', 0.0216, 'lps'),
	(605745, 128, '2014-04-01 00:22:13.000000', 'consum', 0.0211, 'lps'),
	(605746, 128, '2014-04-01 00:22:14.000000', 'consum', 0.0218, 'lps'),
	(605747, 128, '2014-04-01 00:22:15.000000', 'consum', 0.0216, 'lps'),
	(605748, 128, '2014-04-01 00:22:16.000000', 'consum', 0.0210, 'lps'),
	(605749, 128, '2014-04-01 00:22:17.000000', 'consum', 0.0210, 'lps'),
	(605750, 128, '2014-04-01 00:22:18.000000', 'consum', 0.0213, 'lps'),
	(605751, 128, '2014-04-01 00:22:19.000000', 'consum', 0.0213, 'lps'),
	(605752, 128, '2014-04-01 00:22:20.000000', 'consum', 0.0219, 'lps'),
	(605753, 128, '2014-04-01 00:22:21.000000', 'consum', 0.0213, 'lps'),
	(605754, 128, '2014-04-01 00:22:22.000000', 'consum', 0.0212, 'lps'),
	(605755, 128, '2014-04-01 00:22:23.000000', 'consum', 0.0219, 'lps'),
	(605756, 128, '2014-04-01 00:22:24.000000', 'consum', 0.0212, 'lps'),
	(605757, 128, '2014-04-01 00:22:25.000000', 'consum', 0.0210, 'lps'),
	(605758, 128, '2014-04-01 00:22:26.000000', 'consum', 0.0217, 'lps'),
	(605759, 128, '2014-04-01 00:22:27.000000', 'consum', 0.0217, 'lps'),
	(605760, 128, '2014-04-01 00:22:28.000000', 'consum', 0.0211, 'lps'),
	(605761, 128, '2014-04-01 00:22:29.000000', 'consum', 0.0218, 'lps'),
	(605762, 128, '2014-04-01 00:22:30.000000', 'consum', 0.0216, 'lps'),
	(605763, 128, '2014-04-01 00:22:31.000000', 'consum', 0.0215, 'lps'),
	(605764, 128, '2014-04-01 00:22:32.000000', 'consum', 0.0219, 'lps'),
	(605765, 128, '2014-04-01 00:22:33.000000', 'consum', 0.0212, 'lps'),
	(605766, 128, '2014-04-01 00:22:34.000000', 'consum', 0.0212, 'lps'),
	(605767, 128, '2014-04-01 00:22:35.000000', 'consum', 0.0213, 'lps'),
	(605768, 128, '2014-04-01 00:22:36.000000', 'consum', 0.0219, 'lps'),
	(605769, 128, '2014-04-01 00:22:37.000000', 'consum', 0.0218, 'lps'),
	(605770, 128, '2014-04-01 00:22:38.000000', 'consum', 0.0214, 'lps'),
	(605771, 128, '2014-04-01 00:22:39.000000', 'consum', 0.0215, 'lps'),
	(605772, 128, '2014-04-01 00:22:40.000000', 'consum', 0.0215, 'lps'),
	(605773, 128, '2014-04-01 00:22:41.000000', 'consum', 0.0218, 'lps'),
	(605774, 128, '2014-04-01 00:22:42.000000', 'consum', 0.0218, 'lps'),
	(605775, 128, '2014-04-01 00:22:43.000000', 'consum', 0.0217, 'lps'),
	(605776, 128, '2014-04-01 00:22:44.000000', 'consum', 0.0219, 'lps'),
	(605777, 128, '2014-04-01 00:22:45.000000', 'consum', 0.0215, 'lps'),
	(605778, 128, '2014-04-01 00:22:46.000000', 'consum', 0.0210, 'lps'),
	(605779, 128, '2014-04-01 00:22:47.000000', 'consum', 0.0214, 'lps'),
	(605780, 128, '2014-04-01 00:22:48.000000', 'consum', 0.0211, 'lps'),
	(605781, 128, '2014-04-01 00:22:49.000000', 'consum', 0.0212, 'lps'),
	(605782, 128, '2014-04-01 00:22:50.000000', 'consum', 0.0218, 'lps'),
	(605783, 128, '2014-04-01 00:22:51.000000', 'consum', 0.0216, 'lps'),
	(605784, 128, '2014-04-01 00:22:52.000000', 'consum', 0.0214, 'lps'),
	(605785, 128, '2014-04-01 00:22:53.000000', 'consum', 0.0215, 'lps'),
	(605786, 128, '2014-04-01 00:22:54.000000', 'consum', 0.0211, 'lps'),
	(605787, 128, '2014-04-01 00:22:55.000000', 'consum', 0.0211, 'lps'),
	(605788, 128, '2014-04-01 00:22:56.000000', 'consum', 0.0215, 'lps'),
	(605789, 128, '2014-04-01 00:22:57.000000', 'consum', 0.0210, 'lps'),
	(605790, 128, '2014-04-01 00:22:58.000000', 'consum', 0.0214, 'lps'),
	(605791, 128, '2014-04-01 00:22:59.000000', 'consum', 0.0212, 'lps'),
	(605792, 128, '2014-04-01 00:23:00.000000', 'consum', 0.0211, 'lps'),
	(605793, 128, '2014-04-01 00:23:01.000000', 'consum', 0.0216, 'lps'),
	(605794, 128, '2014-04-01 00:23:02.000000', 'consum', 0.0218, 'lps'),
	(605795, 128, '2014-04-01 00:23:03.000000', 'consum', 0.0212, 'lps'),
	(605796, 128, '2014-04-01 00:23:04.000000', 'consum', 0.0215, 'lps'),
	(605797, 128, '2014-04-01 00:23:05.000000', 'consum', 0.0213, 'lps'),
	(605798, 128, '2014-04-01 00:23:06.000000', 'consum', 0.0217, 'lps'),
	(605799, 128, '2014-04-01 00:23:07.000000', 'consum', 0.0210, 'lps'),
	(605800, 128, '2014-04-01 00:23:08.000000', 'consum', 0.0217, 'lps'),
	(605801, 128, '2014-04-01 00:23:09.000000', 'consum', 0.0217, 'lps'),
	(605802, 128, '2014-04-01 00:23:10.000000', 'consum', 0.0213, 'lps'),
	(605803, 128, '2014-04-01 00:23:11.000000', 'consum', 0.0217, 'lps'),
	(605804, 128, '2014-04-01 00:23:12.000000', 'consum', 0.0216, 'lps'),
	(605805, 128, '2014-04-01 00:23:13.000000', 'consum', 0.0217, 'lps'),
	(605806, 128, '2014-04-01 00:23:14.000000', 'consum', 0.0210, 'lps'),
	(605807, 128, '2014-04-01 00:23:15.000000', 'consum', 0.0219, 'lps'),
	(605808, 128, '2014-04-01 00:23:16.000000', 'consum', 0.0215, 'lps'),
	(605809, 128, '2014-04-01 00:23:17.000000', 'consum', 0.0211, 'lps'),
	(605810, 128, '2014-04-01 00:23:18.000000', 'consum', 0.0217, 'lps'),
	(605811, 128, '2014-04-01 00:23:19.000000', 'consum', 0.0215, 'lps'),
	(605812, 128, '2014-04-01 00:23:20.000000', 'consum', 0.0213, 'lps'),
	(605813, 128, '2014-04-01 00:23:21.000000', 'consum', 0.0211, 'lps'),
	(605814, 128, '2014-04-01 00:23:22.000000', 'consum', 0.0217, 'lps'),
	(605815, 128, '2014-04-01 00:23:23.000000', 'consum', 0.0214, 'lps'),
	(605816, 128, '2014-04-01 00:23:24.000000', 'consum', 0.0219, 'lps'),
	(605817, 128, '2014-04-01 00:23:25.000000', 'consum', 0.0214, 'lps'),
	(605818, 128, '2014-04-01 00:23:26.000000', 'consum', 0.0211, 'lps'),
	(605819, 128, '2014-04-01 00:23:27.000000', 'consum', 0.0216, 'lps'),
	(605820, 128, '2014-04-01 00:23:28.000000', 'consum', 0.0218, 'lps'),
	(605821, 128, '2014-04-01 00:23:29.000000', 'consum', 0.0211, 'lps'),
	(605822, 128, '2014-04-01 00:23:30.000000', 'consum', 0.0211, 'lps'),
	(605823, 128, '2014-04-01 00:23:31.000000', 'consum', 0.0211, 'lps'),
	(605824, 128, '2014-04-01 00:23:32.000000', 'consum', 0.0215, 'lps'),
	(605825, 128, '2014-04-01 00:23:33.000000', 'consum', 0.0210, 'lps'),
	(605826, 128, '2014-04-01 00:23:34.000000', 'consum', 0.0218, 'lps'),
	(605827, 128, '2014-04-01 00:23:35.000000', 'consum', 0.0210, 'lps'),
	(605828, 128, '2014-04-01 00:23:36.000000', 'consum', 0.0216, 'lps'),
	(605829, 128, '2014-04-01 00:23:37.000000', 'consum', 0.0211, 'lps'),
	(605830, 128, '2014-04-01 00:23:38.000000', 'consum', 0.0216, 'lps'),
	(605831, 128, '2014-04-01 00:23:39.000000', 'consum', 0.0210, 'lps'),
	(605832, 128, '2014-04-01 00:23:40.000000', 'consum', 0.0213, 'lps'),
	(605833, 128, '2014-04-01 00:23:41.000000', 'consum', 0.0213, 'lps'),
	(605834, 128, '2014-04-01 00:23:42.000000', 'consum', 0.0218, 'lps'),
	(605835, 128, '2014-04-01 00:23:43.000000', 'consum', 0.0219, 'lps'),
	(605836, 128, '2014-04-01 00:23:44.000000', 'consum', 0.0215, 'lps'),
	(605837, 128, '2014-04-01 00:23:45.000000', 'consum', 0.0215, 'lps'),
	(605838, 128, '2014-04-01 00:23:46.000000', 'consum', 0.0212, 'lps'),
	(605839, 128, '2014-04-01 00:23:47.000000', 'consum', 0.0216, 'lps'),
	(605840, 128, '2014-04-01 00:23:48.000000', 'consum', 0.0212, 'lps'),
	(605841, 128, '2014-04-01 00:23:49.000000', 'consum', 0.0215, 'lps'),
	(605842, 128, '2014-04-01 00:23:50.000000', 'consum', 0.0219, 'lps'),
	(605843, 128, '2014-04-01 00:23:51.000000', 'consum', 0.0219, 'lps'),
	(605844, 128, '2014-04-01 00:23:52.000000', 'consum', 0.0210, 'lps'),
	(605845, 128, '2014-04-01 00:23:53.000000', 'consum', 0.0213, 'lps'),
	(605846, 128, '2014-04-01 00:23:54.000000', 'consum', 0.0216, 'lps'),
	(605847, 128, '2014-04-01 00:23:55.000000', 'consum', 0.0213, 'lps'),
	(605848, 128, '2014-04-01 00:23:56.000000', 'consum', 0.0215, 'lps'),
	(605849, 128, '2014-04-01 00:23:57.000000', 'consum', 0.0218, 'lps'),
	(605850, 128, '2014-04-01 00:23:58.000000', 'consum', 0.0217, 'lps'),
	(605851, 128, '2014-04-01 00:23:59.000000', 'consum', 0.0211, 'lps'),
	(605852, 128, '2014-04-01 00:24:00.000000', 'consum', 0.0213, 'lps'),
	(605853, 128, '2014-04-01 00:24:01.000000', 'consum', 0.0212, 'lps'),
	(605854, 128, '2014-04-01 00:24:02.000000', 'consum', 0.0213, 'lps'),
	(605855, 128, '2014-04-01 00:24:03.000000', 'consum', 0.0218, 'lps'),
	(605856, 128, '2014-04-01 00:24:04.000000', 'consum', 0.0211, 'lps'),
	(605857, 128, '2014-04-01 00:24:05.000000', 'consum', 0.0214, 'lps'),
	(605858, 128, '2014-04-01 00:24:06.000000', 'consum', 0.0215, 'lps'),
	(605859, 128, '2014-04-01 00:24:07.000000', 'consum', 0.0215, 'lps'),
	(605860, 128, '2014-04-01 00:24:08.000000', 'consum', 0.0210, 'lps'),
	(605861, 128, '2014-04-01 00:24:09.000000', 'consum', 0.0214, 'lps'),
	(605862, 128, '2014-04-01 00:24:10.000000', 'consum', 0.0211, 'lps'),
	(605863, 128, '2014-04-01 00:24:11.000000', 'consum', 0.0216, 'lps'),
	(605864, 128, '2014-04-01 00:24:12.000000', 'consum', 0.0214, 'lps'),
	(605865, 128, '2014-04-01 00:24:13.000000', 'consum', 0.0216, 'lps'),
	(605866, 128, '2014-04-01 00:24:14.000000', 'consum', 0.0217, 'lps'),
	(605867, 128, '2014-04-01 00:24:15.000000', 'consum', 0.0219, 'lps'),
	(605868, 128, '2014-04-01 00:24:16.000000', 'consum', 0.0213, 'lps'),
	(605869, 128, '2014-04-01 00:24:17.000000', 'consum', 0.0219, 'lps'),
	(605870, 128, '2014-04-01 00:24:18.000000', 'consum', 0.0218, 'lps'),
	(605871, 128, '2014-04-01 00:24:19.000000', 'consum', 0.0211, 'lps'),
	(605872, 128, '2014-04-01 00:24:20.000000', 'consum', 0.0213, 'lps'),
	(605873, 128, '2014-04-01 00:24:21.000000', 'consum', 0.0213, 'lps'),
	(605874, 128, '2014-04-01 00:24:22.000000', 'consum', 0.0214, 'lps'),
	(605875, 128, '2014-04-01 00:24:23.000000', 'consum', 0.0214, 'lps'),
	(605876, 128, '2014-04-01 00:24:24.000000', 'consum', 0.0216, 'lps'),
	(605877, 128, '2014-04-01 00:24:25.000000', 'consum', 0.0210, 'lps'),
	(605878, 128, '2014-04-01 00:24:26.000000', 'consum', 0.0213, 'lps'),
	(605879, 128, '2014-04-01 00:24:27.000000', 'consum', 0.0216, 'lps'),
	(605880, 128, '2014-04-01 00:24:28.000000', 'consum', 0.0211, 'lps'),
	(605881, 128, '2014-04-01 00:24:29.000000', 'consum', 0.0217, 'lps'),
	(605882, 128, '2014-04-01 00:24:30.000000', 'consum', 0.0211, 'lps'),
	(605883, 128, '2014-04-01 00:24:31.000000', 'consum', 0.0216, 'lps'),
	(605884, 128, '2014-04-01 00:24:32.000000', 'consum', 0.0217, 'lps'),
	(605885, 128, '2014-04-01 00:24:33.000000', 'consum', 0.0217, 'lps'),
	(605886, 128, '2014-04-01 00:24:34.000000', 'consum', 0.0216, 'lps'),
	(605887, 128, '2014-04-01 00:24:35.000000', 'consum', 0.0218, 'lps'),
	(605888, 128, '2014-04-01 00:24:36.000000', 'consum', 0.0212, 'lps'),
	(605889, 128, '2014-04-01 00:24:37.000000', 'consum', 0.0216, 'lps'),
	(605890, 128, '2014-04-01 00:24:38.000000', 'consum', 0.0214, 'lps'),
	(605891, 128, '2014-04-01 00:24:39.000000', 'consum', 0.0213, 'lps'),
	(605892, 128, '2014-04-01 00:24:40.000000', 'consum', 0.0215, 'lps'),
	(605893, 128, '2014-04-01 00:24:41.000000', 'consum', 0.0215, 'lps'),
	(605894, 128, '2014-04-01 00:24:42.000000', 'consum', 0.0211, 'lps'),
	(605895, 128, '2014-04-01 00:24:43.000000', 'consum', 0.0210, 'lps'),
	(605896, 128, '2014-04-01 00:24:44.000000', 'consum', 0.0216, 'lps'),
	(605897, 128, '2014-04-01 00:24:45.000000', 'consum', 0.0211, 'lps'),
	(605898, 128, '2014-04-01 00:24:46.000000', 'consum', 0.0219, 'lps'),
	(605899, 128, '2014-04-01 00:24:47.000000', 'consum', 0.0210, 'lps'),
	(605900, 128, '2014-04-01 00:24:48.000000', 'consum', 0.0216, 'lps'),
	(605901, 128, '2014-04-01 00:24:49.000000', 'consum', 0.0219, 'lps'),
	(605902, 128, '2014-04-01 00:24:50.000000', 'consum', 0.0210, 'lps'),
	(605903, 128, '2014-04-01 00:24:51.000000', 'consum', 0.0212, 'lps'),
	(605904, 128, '2014-04-01 00:24:52.000000', 'consum', 0.0211, 'lps'),
	(605905, 128, '2014-04-01 00:24:53.000000', 'consum', 0.0211, 'lps'),
	(605906, 128, '2014-04-01 00:24:54.000000', 'consum', 0.0211, 'lps'),
	(605907, 128, '2014-04-01 00:24:55.000000', 'consum', 0.0212, 'lps'),
	(605908, 128, '2014-04-01 00:24:56.000000', 'consum', 0.0219, 'lps'),
	(605909, 128, '2014-04-01 00:24:57.000000', 'consum', 0.0219, 'lps'),
	(605910, 128, '2014-04-01 00:24:58.000000', 'consum', 0.0210, 'lps'),
	(605911, 128, '2014-04-01 00:24:59.000000', 'consum', 0.0211, 'lps'),
	(605912, 128, '2014-04-01 00:25:00.000000', 'consum', 0.0219, 'lps'),
	(605913, 128, '2014-04-01 00:25:01.000000', 'consum', 0.0219, 'lps'),
	(605914, 128, '2014-04-01 00:25:02.000000', 'consum', 0.0219, 'lps'),
	(605915, 128, '2014-04-01 00:25:03.000000', 'consum', 0.0218, 'lps'),
	(605916, 128, '2014-04-01 00:25:04.000000', 'consum', 0.0216, 'lps'),
	(605917, 128, '2014-04-01 00:25:05.000000', 'consum', 0.0215, 'lps'),
	(605918, 128, '2014-04-01 00:25:06.000000', 'consum', 0.0217, 'lps'),
	(605919, 128, '2014-04-01 00:25:07.000000', 'consum', 0.0211, 'lps'),
	(605920, 128, '2014-04-01 00:25:08.000000', 'consum', 0.0214, 'lps'),
	(605921, 128, '2014-04-01 00:25:09.000000', 'consum', 0.0218, 'lps'),
	(605922, 128, '2014-04-01 00:25:10.000000', 'consum', 0.0210, 'lps'),
	(605923, 128, '2014-04-01 00:25:11.000000', 'consum', 0.0214, 'lps'),
	(605924, 128, '2014-04-01 00:25:12.000000', 'consum', 0.0210, 'lps'),
	(605925, 128, '2014-04-01 00:25:13.000000', 'consum', 0.0210, 'lps'),
	(605926, 128, '2014-04-01 00:25:14.000000', 'consum', 0.0210, 'lps'),
	(605927, 128, '2014-04-01 00:25:15.000000', 'consum', 0.0211, 'lps'),
	(605928, 128, '2014-04-01 00:25:16.000000', 'consum', 0.0214, 'lps'),
	(605929, 128, '2014-04-01 00:25:17.000000', 'consum', 0.0217, 'lps'),
	(605930, 128, '2014-04-01 00:25:18.000000', 'consum', 0.0216, 'lps'),
	(605931, 128, '2014-04-01 00:25:19.000000', 'consum', 0.0218, 'lps'),
	(605932, 128, '2014-04-01 00:25:20.000000', 'consum', 0.0213, 'lps'),
	(605933, 128, '2014-04-01 00:25:21.000000', 'consum', 0.0211, 'lps'),
	(605934, 128, '2014-04-01 00:25:22.000000', 'consum', 0.0215, 'lps'),
	(605935, 128, '2014-04-01 00:25:23.000000', 'consum', 0.0214, 'lps'),
	(605936, 128, '2014-04-01 00:25:24.000000', 'consum', 0.0215, 'lps'),
	(605937, 128, '2014-04-01 00:25:25.000000', 'consum', 0.0215, 'lps'),
	(605938, 128, '2014-04-01 00:25:26.000000', 'consum', 0.0219, 'lps'),
	(605939, 128, '2014-04-01 00:25:27.000000', 'consum', 0.0213, 'lps'),
	(605940, 128, '2014-04-01 00:25:28.000000', 'consum', 0.0216, 'lps'),
	(605941, 128, '2014-04-01 00:25:29.000000', 'consum', 0.0211, 'lps'),
	(605942, 128, '2014-04-01 00:25:30.000000', 'consum', 0.0216, 'lps'),
	(605943, 128, '2014-04-01 00:25:31.000000', 'consum', 0.0210, 'lps'),
	(605944, 128, '2014-04-01 00:25:32.000000', 'consum', 0.0214, 'lps'),
	(605945, 128, '2014-04-01 00:25:33.000000', 'consum', 0.0217, 'lps'),
	(605946, 128, '2014-04-01 00:25:34.000000', 'consum', 0.0216, 'lps'),
	(605947, 128, '2014-04-01 00:25:35.000000', 'consum', 0.0217, 'lps'),
	(605948, 128, '2014-04-01 00:25:36.000000', 'consum', 0.0219, 'lps'),
	(605949, 128, '2014-04-01 00:25:37.000000', 'consum', 0.0214, 'lps'),
	(605950, 128, '2014-04-01 00:25:38.000000', 'consum', 0.0214, 'lps'),
	(605951, 128, '2014-04-01 00:25:39.000000', 'consum', 0.0210, 'lps'),
	(605952, 128, '2014-04-01 00:25:40.000000', 'consum', 0.0216, 'lps'),
	(605953, 128, '2014-04-01 00:25:41.000000', 'consum', 0.0213, 'lps'),
	(605954, 128, '2014-04-01 00:25:42.000000', 'consum', 0.0217, 'lps'),
	(605955, 128, '2014-04-01 00:25:43.000000', 'consum', 0.0218, 'lps'),
	(605956, 128, '2014-04-01 00:25:44.000000', 'consum', 0.0217, 'lps'),
	(605957, 128, '2014-04-01 00:25:45.000000', 'consum', 0.0212, 'lps'),
	(605958, 128, '2014-04-01 00:25:46.000000', 'consum', 0.0210, 'lps'),
	(605959, 128, '2014-04-01 00:25:47.000000', 'consum', 0.0215, 'lps'),
	(605960, 128, '2014-04-01 00:25:48.000000', 'consum', 0.0214, 'lps'),
	(605961, 128, '2014-04-01 00:25:49.000000', 'consum', 0.0217, 'lps'),
	(605962, 128, '2014-04-01 00:25:50.000000', 'consum', 0.0213, 'lps'),
	(605963, 128, '2014-04-01 00:25:51.000000', 'consum', 0.0215, 'lps'),
	(605964, 128, '2014-04-01 00:25:52.000000', 'consum', 0.0216, 'lps'),
	(605965, 128, '2014-04-01 00:25:53.000000', 'consum', 0.0218, 'lps'),
	(605966, 128, '2014-04-01 00:25:54.000000', 'consum', 0.0219, 'lps'),
	(605967, 128, '2014-04-01 00:25:55.000000', 'consum', 0.0213, 'lps'),
	(605968, 128, '2014-04-01 00:25:56.000000', 'consum', 0.0219, 'lps'),
	(605969, 128, '2014-04-01 00:25:57.000000', 'consum', 0.0215, 'lps'),
	(605970, 128, '2014-04-01 00:25:58.000000', 'consum', 0.0211, 'lps'),
	(605971, 128, '2014-04-01 00:25:59.000000', 'consum', 0.0211, 'lps'),
	(605972, 128, '2014-04-01 00:26:00.000000', 'consum', 0.0210, 'lps'),
	(605973, 128, '2014-04-01 00:26:01.000000', 'consum', 0.0210, 'lps'),
	(605974, 128, '2014-04-01 00:26:02.000000', 'consum', 0.0210, 'lps'),
	(605975, 128, '2014-04-01 00:26:03.000000', 'consum', 0.0212, 'lps'),
	(605976, 128, '2014-04-01 00:26:04.000000', 'consum', 0.0210, 'lps'),
	(605977, 128, '2014-04-01 00:26:05.000000', 'consum', 0.0212, 'lps'),
	(605978, 128, '2014-04-01 00:26:06.000000', 'consum', 0.0211, 'lps'),
	(605979, 128, '2014-04-01 00:26:07.000000', 'consum', 0.0211, 'lps'),
	(605980, 128, '2014-04-01 00:26:08.000000', 'consum', 0.0212, 'lps'),
	(605981, 128, '2014-04-01 00:26:09.000000', 'consum', 0.0215, 'lps'),
	(605982, 128, '2014-04-01 00:26:10.000000', 'consum', 0.0213, 'lps'),
	(605983, 128, '2014-04-01 00:26:11.000000', 'consum', 0.0218, 'lps'),
	(605984, 128, '2014-04-01 00:26:12.000000', 'consum', 0.0211, 'lps'),
	(605985, 128, '2014-04-01 00:26:13.000000', 'consum', 0.0213, 'lps'),
	(605986, 128, '2014-04-01 00:26:14.000000', 'consum', 0.0210, 'lps'),
	(605987, 128, '2014-04-01 00:26:15.000000', 'consum', 0.0215, 'lps'),
	(605988, 128, '2014-04-01 00:26:16.000000', 'consum', 0.0212, 'lps'),
	(605989, 128, '2014-04-01 00:26:17.000000', 'consum', 0.0217, 'lps'),
	(605990, 128, '2014-04-01 00:26:18.000000', 'consum', 0.0211, 'lps'),
	(605991, 128, '2014-04-01 00:26:19.000000', 'consum', 0.0215, 'lps'),
	(605992, 128, '2014-04-01 00:26:20.000000', 'consum', 0.0212, 'lps'),
	(605993, 128, '2014-04-01 00:26:21.000000', 'consum', 0.0217, 'lps'),
	(605994, 128, '2014-04-01 00:26:22.000000', 'consum', 0.0218, 'lps'),
	(605995, 128, '2014-04-01 00:26:23.000000', 'consum', 0.0211, 'lps'),
	(605996, 128, '2014-04-01 00:26:24.000000', 'consum', 0.0212, 'lps'),
	(605997, 128, '2014-04-01 00:26:25.000000', 'consum', 0.0217, 'lps'),
	(605998, 128, '2014-04-01 00:26:26.000000', 'consum', 0.0210, 'lps'),
	(605999, 128, '2014-04-01 00:26:27.000000', 'consum', 0.0211, 'lps'),
	(606000, 128, '2014-04-01 00:26:28.000000', 'consum', 0.0213, 'lps'),
	(606001, 128, '2014-04-01 00:26:29.000000', 'consum', 0.0215, 'lps'),
	(606002, 128, '2014-04-01 00:26:30.000000', 'consum', 0.0216, 'lps'),
	(606003, 128, '2014-04-01 00:26:31.000000', 'consum', 0.0214, 'lps'),
	(606004, 128, '2014-04-01 00:26:32.000000', 'consum', 0.0212, 'lps'),
	(606005, 128, '2014-04-01 00:26:33.000000', 'consum', 0.0218, 'lps'),
	(606006, 128, '2014-04-01 00:26:34.000000', 'consum', 0.0217, 'lps'),
	(606007, 128, '2014-04-01 00:26:35.000000', 'consum', 0.0219, 'lps'),
	(606008, 128, '2014-04-01 00:26:36.000000', 'consum', 0.0215, 'lps'),
	(606009, 128, '2014-04-01 00:26:37.000000', 'consum', 0.0219, 'lps'),
	(606010, 128, '2014-04-01 00:26:38.000000', 'consum', 0.0211, 'lps'),
	(606011, 128, '2014-04-01 00:26:39.000000', 'consum', 0.0217, 'lps'),
	(606012, 128, '2014-04-01 00:26:40.000000', 'consum', 0.0215, 'lps'),
	(606013, 128, '2014-04-01 00:26:41.000000', 'consum', 0.0214, 'lps'),
	(606014, 128, '2014-04-01 00:26:42.000000', 'consum', 0.0214, 'lps'),
	(606015, 128, '2014-04-01 00:26:43.000000', 'consum', 0.0211, 'lps'),
	(606016, 128, '2014-04-01 00:26:44.000000', 'consum', 0.0214, 'lps'),
	(606017, 128, '2014-04-01 00:26:45.000000', 'consum', 0.0215, 'lps'),
	(606018, 128, '2014-04-01 00:26:46.000000', 'consum', 0.0214, 'lps'),
	(606019, 128, '2014-04-01 00:26:47.000000', 'consum', 0.0216, 'lps'),
	(606020, 128, '2014-04-01 00:26:48.000000', 'consum', 0.0210, 'lps'),
	(606021, 128, '2014-04-01 00:26:49.000000', 'consum', 0.0212, 'lps'),
	(606022, 128, '2014-04-01 00:26:50.000000', 'consum', 0.0210, 'lps'),
	(606023, 128, '2014-04-01 00:26:51.000000', 'consum', 0.0217, 'lps'),
	(606024, 128, '2014-04-01 00:26:52.000000', 'consum', 0.0212, 'lps'),
	(606025, 128, '2014-04-01 00:26:53.000000', 'consum', 0.0211, 'lps'),
	(606026, 128, '2014-04-01 00:26:54.000000', 'consum', 0.0218, 'lps'),
	(606027, 128, '2014-04-01 00:26:55.000000', 'consum', 0.0210, 'lps'),
	(606028, 128, '2014-04-01 00:26:56.000000', 'consum', 0.0217, 'lps'),
	(606029, 128, '2014-04-01 00:26:57.000000', 'consum', 0.0213, 'lps'),
	(606030, 128, '2014-04-01 00:26:58.000000', 'consum', 0.0216, 'lps'),
	(606031, 128, '2014-04-01 00:26:59.000000', 'consum', 0.0212, 'lps'),
	(606032, 128, '2014-04-01 00:27:00.000000', 'consum', 0.0213, 'lps'),
	(606033, 128, '2014-04-01 00:27:01.000000', 'consum', 0.0211, 'lps'),
	(606034, 128, '2014-04-01 00:27:02.000000', 'consum', 0.0213, 'lps'),
	(606035, 128, '2014-04-01 00:27:03.000000', 'consum', 0.0215, 'lps'),
	(606036, 128, '2014-04-01 00:27:04.000000', 'consum', 0.0215, 'lps'),
	(606037, 128, '2014-04-01 00:27:05.000000', 'consum', 0.0212, 'lps'),
	(606038, 128, '2014-04-01 00:27:06.000000', 'consum', 0.0213, 'lps'),
	(606039, 128, '2014-04-01 00:27:07.000000', 'consum', 0.0212, 'lps'),
	(606040, 128, '2014-04-01 00:27:08.000000', 'consum', 0.0210, 'lps'),
	(606041, 128, '2014-04-01 00:27:09.000000', 'consum', 0.0215, 'lps'),
	(606042, 128, '2014-04-01 00:27:10.000000', 'consum', 0.0216, 'lps'),
	(606043, 128, '2014-04-01 00:27:11.000000', 'consum', 0.0216, 'lps'),
	(606044, 128, '2014-04-01 00:27:12.000000', 'consum', 0.0211, 'lps'),
	(606045, 128, '2014-04-01 00:27:13.000000', 'consum', 0.0219, 'lps'),
	(606046, 128, '2014-04-01 00:27:14.000000', 'consum', 0.0211, 'lps'),
	(606047, 128, '2014-04-01 00:27:15.000000', 'consum', 0.0217, 'lps'),
	(606048, 128, '2014-04-01 00:27:16.000000', 'consum', 0.0214, 'lps'),
	(606049, 128, '2014-04-01 00:27:17.000000', 'consum', 0.0211, 'lps'),
	(606050, 128, '2014-04-01 00:27:18.000000', 'consum', 0.0212, 'lps'),
	(606051, 128, '2014-04-01 00:27:19.000000', 'consum', 0.0210, 'lps'),
	(606052, 128, '2014-04-01 00:27:20.000000', 'consum', 0.0211, 'lps'),
	(606053, 128, '2014-04-01 00:27:21.000000', 'consum', 0.0216, 'lps'),
	(606054, 128, '2014-04-01 00:27:22.000000', 'consum', 0.0210, 'lps'),
	(606055, 128, '2014-04-01 00:27:23.000000', 'consum', 0.0211, 'lps'),
	(606056, 128, '2014-04-01 00:27:24.000000', 'consum', 0.0214, 'lps'),
	(606057, 128, '2014-04-01 00:27:25.000000', 'consum', 0.0217, 'lps'),
	(606058, 128, '2014-04-01 00:27:26.000000', 'consum', 0.0217, 'lps'),
	(606059, 128, '2014-04-01 00:27:27.000000', 'consum', 0.0211, 'lps'),
	(606060, 128, '2014-04-01 00:27:28.000000', 'consum', 0.0218, 'lps'),
	(606061, 128, '2014-04-01 00:27:29.000000', 'consum', 0.0214, 'lps'),
	(606062, 128, '2014-04-01 00:27:30.000000', 'consum', 0.0217, 'lps'),
	(606063, 128, '2014-04-01 00:27:31.000000', 'consum', 0.0214, 'lps'),
	(606064, 128, '2014-04-01 00:27:32.000000', 'consum', 0.0212, 'lps'),
	(606065, 128, '2014-04-01 00:27:33.000000', 'consum', 0.0215, 'lps'),
	(606066, 128, '2014-04-01 00:27:34.000000', 'consum', 0.0211, 'lps'),
	(606067, 128, '2014-04-01 00:27:35.000000', 'consum', 0.0210, 'lps'),
	(606068, 128, '2014-04-01 00:27:36.000000', 'consum', 0.0218, 'lps'),
	(606069, 128, '2014-04-01 00:27:37.000000', 'consum', 0.0211, 'lps'),
	(606070, 128, '2014-04-01 00:27:38.000000', 'consum', 0.0212, 'lps'),
	(606071, 128, '2014-04-01 00:27:39.000000', 'consum', 0.0218, 'lps'),
	(606072, 128, '2014-04-01 00:27:40.000000', 'consum', 0.0214, 'lps'),
	(606073, 128, '2014-04-01 00:27:41.000000', 'consum', 0.0217, 'lps'),
	(606074, 128, '2014-04-01 00:27:42.000000', 'consum', 0.0213, 'lps'),
	(606075, 128, '2014-04-01 00:27:43.000000', 'consum', 0.0216, 'lps'),
	(606076, 128, '2014-04-01 00:27:44.000000', 'consum', 0.0218, 'lps'),
	(606077, 128, '2014-04-01 00:27:45.000000', 'consum', 0.0216, 'lps'),
	(606078, 128, '2014-04-01 00:27:46.000000', 'consum', 0.0215, 'lps'),
	(606079, 128, '2014-04-01 00:27:47.000000', 'consum', 0.0216, 'lps'),
	(606080, 128, '2014-04-01 00:27:48.000000', 'consum', 0.0215, 'lps'),
	(606081, 128, '2014-04-01 00:27:49.000000', 'consum', 0.0218, 'lps'),
	(606082, 128, '2014-04-01 00:27:50.000000', 'consum', 0.0216, 'lps'),
	(606083, 128, '2014-04-01 00:27:51.000000', 'consum', 0.0219, 'lps'),
	(606084, 128, '2014-04-01 00:27:52.000000', 'consum', 0.0214, 'lps'),
	(606085, 128, '2014-04-01 00:27:53.000000', 'consum', 0.0214, 'lps'),
	(606086, 128, '2014-04-01 00:27:54.000000', 'consum', 0.0219, 'lps'),
	(606087, 128, '2014-04-01 00:27:55.000000', 'consum', 0.0212, 'lps'),
	(606088, 128, '2014-04-01 00:27:56.000000', 'consum', 0.0217, 'lps'),
	(606089, 128, '2014-04-01 00:27:57.000000', 'consum', 0.0216, 'lps'),
	(606090, 128, '2014-04-01 00:27:58.000000', 'consum', 0.0211, 'lps'),
	(606091, 128, '2014-04-01 00:27:59.000000', 'consum', 0.0219, 'lps'),
	(606092, 128, '2014-04-01 00:28:00.000000', 'consum', 0.0213, 'lps'),
	(606093, 128, '2014-04-01 00:28:01.000000', 'consum', 0.0217, 'lps'),
	(606094, 128, '2014-04-01 00:28:02.000000', 'consum', 0.0216, 'lps'),
	(606095, 128, '2014-04-01 00:28:03.000000', 'consum', 0.0210, 'lps'),
	(606096, 128, '2014-04-01 00:28:04.000000', 'consum', 0.0211, 'lps'),
	(606097, 128, '2014-04-01 00:28:05.000000', 'consum', 0.0218, 'lps'),
	(606098, 128, '2014-04-01 00:28:06.000000', 'consum', 0.0215, 'lps'),
	(606099, 128, '2014-04-01 00:28:07.000000', 'consum', 0.0212, 'lps'),
	(606100, 128, '2014-04-01 00:28:08.000000', 'consum', 0.0216, 'lps'),
	(606101, 128, '2014-04-01 00:28:09.000000', 'consum', 0.0213, 'lps'),
	(606102, 128, '2014-04-01 00:28:10.000000', 'consum', 0.0210, 'lps'),
	(606103, 128, '2014-04-01 00:28:11.000000', 'consum', 0.0218, 'lps'),
	(606104, 128, '2014-04-01 00:28:12.000000', 'consum', 0.0214, 'lps'),
	(606105, 128, '2014-04-01 00:28:13.000000', 'consum', 0.0215, 'lps'),
	(606106, 128, '2014-04-01 00:28:14.000000', 'consum', 0.0213, 'lps'),
	(606107, 128, '2014-04-01 00:28:15.000000', 'consum', 0.0210, 'lps'),
	(606108, 128, '2014-04-01 00:28:16.000000', 'consum', 0.0210, 'lps'),
	(606109, 128, '2014-04-01 00:28:17.000000', 'consum', 0.0214, 'lps'),
	(606110, 128, '2014-04-01 00:28:18.000000', 'consum', 0.0217, 'lps'),
	(606111, 128, '2014-04-01 00:28:19.000000', 'consum', 0.0215, 'lps'),
	(606112, 128, '2014-04-01 00:28:20.000000', 'consum', 0.0215, 'lps'),
	(606113, 128, '2014-04-01 00:28:21.000000', 'consum', 0.0212, 'lps'),
	(606114, 128, '2014-04-01 00:28:22.000000', 'consum', 0.0214, 'lps'),
	(606115, 128, '2014-04-01 00:28:23.000000', 'consum', 0.0214, 'lps'),
	(606116, 128, '2014-04-01 00:28:24.000000', 'consum', 0.0217, 'lps'),
	(606117, 128, '2014-04-01 00:28:25.000000', 'consum', 0.0215, 'lps'),
	(606118, 128, '2014-04-01 00:28:26.000000', 'consum', 0.0216, 'lps'),
	(606119, 128, '2014-04-01 00:28:27.000000', 'consum', 0.0213, 'lps'),
	(606120, 128, '2014-04-01 00:28:28.000000', 'consum', 0.0216, 'lps'),
	(606121, 128, '2014-04-01 00:28:29.000000', 'consum', 0.0215, 'lps'),
	(606122, 128, '2014-04-01 00:28:30.000000', 'consum', 0.0217, 'lps'),
	(606123, 128, '2014-04-01 00:28:31.000000', 'consum', 0.0212, 'lps'),
	(606124, 128, '2014-04-01 00:28:32.000000', 'consum', 0.0218, 'lps'),
	(606125, 128, '2014-04-01 00:28:33.000000', 'consum', 0.0213, 'lps'),
	(606126, 128, '2014-04-01 00:28:34.000000', 'consum', 0.0212, 'lps'),
	(606127, 128, '2014-04-01 00:28:35.000000', 'consum', 0.0210, 'lps'),
	(606128, 128, '2014-04-01 00:28:36.000000', 'consum', 0.0217, 'lps'),
	(606129, 128, '2014-04-01 00:28:37.000000', 'consum', 0.0215, 'lps'),
	(606130, 128, '2014-04-01 00:28:38.000000', 'consum', 0.0213, 'lps'),
	(606131, 128, '2014-04-01 00:28:39.000000', 'consum', 0.0213, 'lps'),
	(606132, 128, '2014-04-01 00:28:40.000000', 'consum', 0.0217, 'lps'),
	(606133, 128, '2014-04-01 00:28:41.000000', 'consum', 0.0217, 'lps'),
	(606134, 128, '2014-04-01 00:28:42.000000', 'consum', 0.0213, 'lps'),
	(606135, 128, '2014-04-01 00:28:43.000000', 'consum', 0.0217, 'lps'),
	(606136, 128, '2014-04-01 00:28:44.000000', 'consum', 0.0213, 'lps'),
	(606137, 128, '2014-04-01 00:28:45.000000', 'consum', 0.0218, 'lps'),
	(606138, 128, '2014-04-01 00:28:46.000000', 'consum', 0.0210, 'lps'),
	(606139, 128, '2014-04-01 00:28:47.000000', 'consum', 0.0215, 'lps'),
	(606140, 128, '2014-04-01 00:28:48.000000', 'consum', 0.0218, 'lps'),
	(606141, 128, '2014-04-01 00:28:49.000000', 'consum', 0.0214, 'lps'),
	(606142, 128, '2014-04-01 00:28:50.000000', 'consum', 0.0217, 'lps'),
	(606143, 128, '2014-04-01 00:28:51.000000', 'consum', 0.0213, 'lps'),
	(606144, 128, '2014-04-01 00:28:52.000000', 'consum', 0.0215, 'lps'),
	(606145, 128, '2014-04-01 00:28:53.000000', 'consum', 0.0216, 'lps'),
	(606146, 128, '2014-04-01 00:28:54.000000', 'consum', 0.0216, 'lps'),
	(606147, 128, '2014-04-01 00:28:55.000000', 'consum', 0.0213, 'lps'),
	(606148, 128, '2014-04-01 00:28:56.000000', 'consum', 0.0217, 'lps'),
	(606149, 128, '2014-04-01 00:28:57.000000', 'consum', 0.0218, 'lps'),
	(606150, 128, '2014-04-01 00:28:58.000000', 'consum', 0.0211, 'lps'),
	(606151, 128, '2014-04-01 00:28:59.000000', 'consum', 0.0218, 'lps'),
	(606152, 128, '2014-04-01 00:29:00.000000', 'consum', 0.0218, 'lps'),
	(606153, 128, '2014-04-01 00:29:01.000000', 'consum', 0.0215, 'lps'),
	(606154, 128, '2014-04-01 00:29:02.000000', 'consum', 0.0213, 'lps'),
	(606155, 128, '2014-04-01 00:29:03.000000', 'consum', 0.0211, 'lps'),
	(606156, 128, '2014-04-01 00:29:04.000000', 'consum', 0.0217, 'lps'),
	(606157, 128, '2014-04-01 00:29:05.000000', 'consum', 0.0214, 'lps'),
	(606158, 128, '2014-04-01 00:29:06.000000', 'consum', 0.0217, 'lps'),
	(606159, 128, '2014-04-01 00:29:07.000000', 'consum', 0.0213, 'lps'),
	(606160, 128, '2014-04-01 00:29:08.000000', 'consum', 0.0217, 'lps'),
	(606161, 128, '2014-04-01 00:29:09.000000', 'consum', 0.0216, 'lps'),
	(606162, 128, '2014-04-01 00:29:10.000000', 'consum', 0.0218, 'lps'),
	(606163, 128, '2014-04-01 00:29:11.000000', 'consum', 0.0214, 'lps'),
	(606164, 128, '2014-04-01 00:29:12.000000', 'consum', 0.0214, 'lps'),
	(606165, 128, '2014-04-01 00:29:13.000000', 'consum', 0.0210, 'lps'),
	(606166, 128, '2014-04-01 00:29:14.000000', 'consum', 0.0217, 'lps'),
	(606167, 128, '2014-04-01 00:29:15.000000', 'consum', 0.0218, 'lps'),
	(606168, 128, '2014-04-01 00:29:16.000000', 'consum', 0.0216, 'lps'),
	(606169, 128, '2014-04-01 00:29:17.000000', 'consum', 0.0219, 'lps'),
	(606170, 128, '2014-04-01 00:29:18.000000', 'consum', 0.0219, 'lps'),
	(606171, 128, '2014-04-01 00:29:19.000000', 'consum', 0.0217, 'lps'),
	(606172, 128, '2014-04-01 00:29:20.000000', 'consum', 0.0217, 'lps'),
	(606173, 128, '2014-04-01 00:29:21.000000', 'consum', 0.0214, 'lps'),
	(606174, 128, '2014-04-01 00:29:22.000000', 'consum', 0.0212, 'lps'),
	(606175, 128, '2014-04-01 00:29:23.000000', 'consum', 0.0218, 'lps'),
	(606176, 128, '2014-04-01 00:29:24.000000', 'consum', 0.0215, 'lps'),
	(606177, 128, '2014-04-01 00:29:25.000000', 'consum', 0.0219, 'lps'),
	(606178, 128, '2014-04-01 00:29:26.000000', 'consum', 0.0213, 'lps'),
	(606179, 128, '2014-04-01 00:29:27.000000', 'consum', 0.0216, 'lps'),
	(606180, 128, '2014-04-01 00:29:28.000000', 'consum', 0.0212, 'lps'),
	(606181, 128, '2014-04-01 00:29:29.000000', 'consum', 0.0213, 'lps'),
	(606182, 128, '2014-04-01 00:29:30.000000', 'consum', 0.0210, 'lps'),
	(606183, 128, '2014-04-01 00:29:31.000000', 'consum', 0.0210, 'lps'),
	(606184, 128, '2014-04-01 00:29:32.000000', 'consum', 0.0212, 'lps'),
	(606185, 128, '2014-04-01 00:29:33.000000', 'consum', 0.0210, 'lps'),
	(606186, 128, '2014-04-01 00:29:34.000000', 'consum', 0.0214, 'lps'),
	(606187, 128, '2014-04-01 00:29:35.000000', 'consum', 0.0212, 'lps'),
	(606188, 128, '2014-04-01 00:29:36.000000', 'consum', 0.0219, 'lps'),
	(606189, 128, '2014-04-01 00:29:37.000000', 'consum', 0.0219, 'lps'),
	(606190, 128, '2014-04-01 00:29:38.000000', 'consum', 0.0217, 'lps'),
	(606191, 128, '2014-04-01 00:29:39.000000', 'consum', 0.0211, 'lps'),
	(606192, 128, '2014-04-01 00:29:40.000000', 'consum', 0.0214, 'lps'),
	(606193, 128, '2014-04-01 00:29:41.000000', 'consum', 0.0219, 'lps'),
	(606194, 128, '2014-04-01 00:29:42.000000', 'consum', 0.0212, 'lps'),
	(606195, 128, '2014-04-01 00:29:43.000000', 'consum', 0.0214, 'lps'),
	(606196, 128, '2014-04-01 00:29:44.000000', 'consum', 0.0216, 'lps'),
	(606197, 128, '2014-04-01 00:29:45.000000', 'consum', 0.0216, 'lps'),
	(606198, 128, '2014-04-01 00:29:46.000000', 'consum', 0.0215, 'lps'),
	(606199, 128, '2014-04-01 00:29:47.000000', 'consum', 0.0217, 'lps'),
	(606200, 128, '2014-04-01 00:29:48.000000', 'consum', 0.0211, 'lps'),
	(606201, 128, '2014-04-01 00:29:49.000000', 'consum', 0.0216, 'lps'),
	(606202, 128, '2014-04-01 00:29:50.000000', 'consum', 0.0215, 'lps'),
	(606203, 128, '2014-04-01 00:29:51.000000', 'consum', 0.0210, 'lps'),
	(606204, 128, '2014-04-01 00:29:52.000000', 'consum', 0.0215, 'lps'),
	(606205, 128, '2014-04-01 00:29:53.000000', 'consum', 0.0215, 'lps'),
	(606206, 128, '2014-04-01 00:29:54.000000', 'consum', 0.0211, 'lps'),
	(606207, 128, '2014-04-01 00:29:55.000000', 'consum', 0.0211, 'lps'),
	(606208, 128, '2014-04-01 00:29:56.000000', 'consum', 0.0213, 'lps'),
	(606209, 128, '2014-04-01 00:29:57.000000', 'consum', 0.0213, 'lps'),
	(606210, 128, '2014-04-01 00:29:58.000000', 'consum', 0.0214, 'lps'),
	(606211, 128, '2014-04-01 00:29:59.000000', 'consum', 0.0214, 'lps'),
	(606212, 128, '2014-04-01 00:30:00.000000', 'consum', 0.0217, 'lps'),
	(606213, 128, '2014-04-01 00:30:01.000000', 'consum', 0.0214, 'lps'),
	(606214, 128, '2014-04-01 00:30:02.000000', 'consum', 0.0218, 'lps'),
	(606215, 128, '2014-04-01 00:30:03.000000', 'consum', 0.0219, 'lps'),
	(606216, 128, '2014-04-01 00:30:04.000000', 'consum', 0.0213, 'lps'),
	(606217, 128, '2014-04-01 00:30:05.000000', 'consum', 0.0216, 'lps'),
	(606218, 128, '2014-04-01 00:30:06.000000', 'consum', 0.0212, 'lps'),
	(606219, 128, '2014-04-01 00:30:07.000000', 'consum', 0.0215, 'lps'),
	(606220, 128, '2014-04-01 00:30:08.000000', 'consum', 0.0218, 'lps'),
	(606221, 128, '2014-04-01 00:30:09.000000', 'consum', 0.0217, 'lps'),
	(606222, 128, '2014-04-01 00:30:10.000000', 'consum', 0.0219, 'lps'),
	(606223, 128, '2014-04-01 00:30:11.000000', 'consum', 0.0218, 'lps'),
	(606224, 128, '2014-04-01 00:30:12.000000', 'consum', 0.0210, 'lps'),
	(606225, 128, '2014-04-01 00:30:13.000000', 'consum', 0.0210, 'lps'),
	(606226, 128, '2014-04-01 00:30:14.000000', 'consum', 0.0218, 'lps'),
	(606227, 128, '2014-04-01 00:30:15.000000', 'consum', 0.0219, 'lps'),
	(606228, 128, '2014-04-01 00:30:16.000000', 'consum', 0.0214, 'lps'),
	(606229, 128, '2014-04-01 00:30:17.000000', 'consum', 0.0213, 'lps'),
	(606230, 128, '2014-04-01 00:30:18.000000', 'consum', 0.0214, 'lps'),
	(606231, 128, '2014-04-01 00:30:19.000000', 'consum', 0.0211, 'lps'),
	(606232, 128, '2014-04-01 00:30:20.000000', 'consum', 0.0214, 'lps'),
	(606233, 128, '2014-04-01 00:30:21.000000', 'consum', 0.0218, 'lps'),
	(606234, 128, '2014-04-01 00:30:22.000000', 'consum', 0.0210, 'lps'),
	(606235, 128, '2014-04-01 00:30:23.000000', 'consum', 0.0214, 'lps'),
	(606236, 128, '2014-04-01 00:30:24.000000', 'consum', 0.0219, 'lps'),
	(606237, 128, '2014-04-01 00:30:25.000000', 'consum', 0.0217, 'lps'),
	(606238, 128, '2014-04-01 00:30:26.000000', 'consum', 0.0216, 'lps'),
	(606239, 128, '2014-04-01 00:30:27.000000', 'consum', 0.0210, 'lps'),
	(606240, 128, '2014-04-01 00:30:28.000000', 'consum', 0.0215, 'lps'),
	(606241, 128, '2014-04-01 00:30:29.000000', 'consum', 0.0212, 'lps'),
	(606242, 128, '2014-04-01 00:30:30.000000', 'consum', 0.0218, 'lps'),
	(606243, 128, '2014-04-01 00:30:31.000000', 'consum', 0.0213, 'lps'),
	(606244, 128, '2014-04-01 00:30:32.000000', 'consum', 0.0214, 'lps'),
	(606245, 128, '2014-04-01 00:30:33.000000', 'consum', 0.0219, 'lps'),
	(606246, 128, '2014-04-01 00:30:34.000000', 'consum', 0.0213, 'lps'),
	(606247, 128, '2014-04-01 00:30:35.000000', 'consum', 0.0210, 'lps'),
	(606248, 128, '2014-04-01 00:30:36.000000', 'consum', 0.0212, 'lps'),
	(606249, 128, '2014-04-01 00:30:37.000000', 'consum', 0.0211, 'lps'),
	(606250, 128, '2014-04-01 00:30:38.000000', 'consum', 0.0218, 'lps'),
	(606251, 128, '2014-04-01 00:30:39.000000', 'consum', 0.0218, 'lps'),
	(606252, 128, '2014-04-01 00:30:40.000000', 'consum', 0.0217, 'lps'),
	(606253, 128, '2014-04-01 00:30:41.000000', 'consum', 0.0210, 'lps'),
	(606254, 128, '2014-04-01 00:30:42.000000', 'consum', 0.0211, 'lps'),
	(606255, 128, '2014-04-01 00:30:43.000000', 'consum', 0.0216, 'lps'),
	(606256, 128, '2014-04-01 00:30:44.000000', 'consum', 0.0216, 'lps'),
	(606257, 128, '2014-04-01 00:30:45.000000', 'consum', 0.0215, 'lps'),
	(606258, 128, '2014-04-01 00:30:46.000000', 'consum', 0.0214, 'lps'),
	(606259, 128, '2014-04-01 00:30:47.000000', 'consum', 0.0219, 'lps'),
	(606260, 128, '2014-04-01 00:30:48.000000', 'consum', 0.0211, 'lps'),
	(606261, 128, '2014-04-01 00:30:49.000000', 'consum', 0.0211, 'lps'),
	(606262, 128, '2014-04-01 00:30:50.000000', 'consum', 0.0213, 'lps'),
	(606263, 128, '2014-04-01 00:30:51.000000', 'consum', 0.0211, 'lps'),
	(606264, 128, '2014-04-01 00:30:52.000000', 'consum', 0.0219, 'lps'),
	(606265, 128, '2014-04-01 00:30:53.000000', 'consum', 0.0219, 'lps'),
	(606266, 128, '2014-04-01 00:30:54.000000', 'consum', 0.0212, 'lps'),
	(606267, 128, '2014-04-01 00:30:55.000000', 'consum', 0.0211, 'lps'),
	(606268, 128, '2014-04-01 00:30:56.000000', 'consum', 0.0211, 'lps'),
	(606269, 128, '2014-04-01 00:30:57.000000', 'consum', 0.0212, 'lps'),
	(606270, 128, '2014-04-01 00:30:58.000000', 'consum', 0.0217, 'lps'),
	(606271, 128, '2014-04-01 00:30:59.000000', 'consum', 0.0212, 'lps'),
	(606272, 128, '2014-04-01 00:31:00.000000', 'consum', 0.0217, 'lps'),
	(606273, 128, '2014-04-01 00:31:01.000000', 'consum', 0.0210, 'lps'),
	(606274, 128, '2014-04-01 00:31:02.000000', 'consum', 0.0218, 'lps'),
	(606275, 128, '2014-04-01 00:31:03.000000', 'consum', 0.0210, 'lps'),
	(606276, 128, '2014-04-01 00:31:04.000000', 'consum', 0.0216, 'lps'),
	(606277, 128, '2014-04-01 00:31:05.000000', 'consum', 0.0214, 'lps'),
	(606278, 128, '2014-04-01 00:31:06.000000', 'consum', 0.0219, 'lps'),
	(606279, 128, '2014-04-01 00:31:07.000000', 'consum', 0.0216, 'lps'),
	(606280, 128, '2014-04-01 00:31:08.000000', 'consum', 0.0211, 'lps'),
	(606281, 128, '2014-04-01 00:31:09.000000', 'consum', 0.0218, 'lps'),
	(606282, 128, '2014-04-01 00:31:10.000000', 'consum', 0.0216, 'lps'),
	(606283, 128, '2014-04-01 00:31:11.000000', 'consum', 0.0219, 'lps'),
	(606284, 128, '2014-04-01 00:31:12.000000', 'consum', 0.0218, 'lps'),
	(606285, 128, '2014-04-01 00:31:13.000000', 'consum', 0.0211, 'lps'),
	(606286, 128, '2014-04-01 00:31:14.000000', 'consum', 0.0214, 'lps'),
	(606287, 128, '2014-04-01 00:31:15.000000', 'consum', 0.0215, 'lps'),
	(606288, 128, '2014-04-01 00:31:16.000000', 'consum', 0.0214, 'lps'),
	(606289, 128, '2014-04-01 00:31:17.000000', 'consum', 0.0217, 'lps'),
	(606290, 128, '2014-04-01 00:31:18.000000', 'consum', 0.0214, 'lps'),
	(606291, 128, '2014-04-01 00:31:19.000000', 'consum', 0.0210, 'lps'),
	(606292, 128, '2014-04-01 00:31:20.000000', 'consum', 0.0217, 'lps'),
	(606293, 128, '2014-04-01 00:31:21.000000', 'consum', 0.0216, 'lps'),
	(606294, 128, '2014-04-01 00:31:22.000000', 'consum', 0.0210, 'lps'),
	(606295, 128, '2014-04-01 00:31:23.000000', 'consum', 0.0214, 'lps'),
	(606296, 128, '2014-04-01 00:31:24.000000', 'consum', 0.0219, 'lps'),
	(606297, 128, '2014-04-01 00:31:25.000000', 'consum', 0.0214, 'lps'),
	(606298, 128, '2014-04-01 00:31:26.000000', 'consum', 0.0215, 'lps'),
	(606299, 128, '2014-04-01 00:31:27.000000', 'consum', 0.0214, 'lps'),
	(606300, 128, '2014-04-01 00:31:28.000000', 'consum', 0.0214, 'lps'),
	(606301, 128, '2014-04-01 00:31:29.000000', 'consum', 0.0217, 'lps'),
	(606302, 128, '2014-04-01 00:31:30.000000', 'consum', 0.0216, 'lps'),
	(606303, 128, '2014-04-01 00:31:31.000000', 'consum', 0.0218, 'lps'),
	(606304, 128, '2014-04-01 00:31:32.000000', 'consum', 0.0212, 'lps'),
	(606305, 128, '2014-04-01 00:31:33.000000', 'consum', 0.0216, 'lps'),
	(606306, 128, '2014-04-01 00:31:34.000000', 'consum', 0.0216, 'lps'),
	(606307, 128, '2014-04-01 00:31:35.000000', 'consum', 0.0211, 'lps'),
	(606308, 128, '2014-04-01 00:31:36.000000', 'consum', 0.0219, 'lps'),
	(606309, 128, '2014-04-01 00:31:37.000000', 'consum', 0.0210, 'lps'),
	(606310, 128, '2014-04-01 00:31:38.000000', 'consum', 0.0216, 'lps'),
	(606311, 128, '2014-04-01 00:31:39.000000', 'consum', 0.0211, 'lps'),
	(606312, 128, '2014-04-01 00:31:40.000000', 'consum', 0.0216, 'lps'),
	(606313, 128, '2014-04-01 00:31:41.000000', 'consum', 0.0216, 'lps'),
	(606314, 128, '2014-04-01 00:31:42.000000', 'consum', 0.0216, 'lps'),
	(606315, 128, '2014-04-01 00:31:43.000000', 'consum', 0.0219, 'lps'),
	(606316, 128, '2014-04-01 00:31:44.000000', 'consum', 0.0211, 'lps'),
	(606317, 128, '2014-04-01 00:31:45.000000', 'consum', 0.0216, 'lps'),
	(606318, 128, '2014-04-01 00:31:46.000000', 'consum', 0.0216, 'lps'),
	(606319, 128, '2014-04-01 00:31:47.000000', 'consum', 0.0216, 'lps'),
	(606320, 128, '2014-04-01 00:31:48.000000', 'consum', 0.0210, 'lps'),
	(606321, 128, '2014-04-01 00:31:49.000000', 'consum', 0.0212, 'lps'),
	(606322, 128, '2014-04-01 00:31:50.000000', 'consum', 0.0211, 'lps'),
	(606323, 128, '2014-04-01 00:31:51.000000', 'consum', 0.0219, 'lps'),
	(606324, 128, '2014-04-01 00:31:52.000000', 'consum', 0.0215, 'lps'),
	(606325, 128, '2014-04-01 00:31:53.000000', 'consum', 0.0218, 'lps'),
	(606326, 128, '2014-04-01 00:31:54.000000', 'consum', 0.0213, 'lps'),
	(606327, 128, '2014-04-01 00:31:55.000000', 'consum', 0.0213, 'lps'),
	(606328, 128, '2014-04-01 00:31:56.000000', 'consum', 0.0218, 'lps'),
	(606329, 128, '2014-04-01 00:31:57.000000', 'consum', 0.0219, 'lps'),
	(606330, 128, '2014-04-01 00:31:58.000000', 'consum', 0.0214, 'lps'),
	(606331, 128, '2014-04-01 00:31:59.000000', 'consum', 0.0215, 'lps'),
	(606332, 128, '2014-04-01 00:32:00.000000', 'consum', 0.0210, 'lps'),
	(606333, 128, '2014-04-01 00:32:01.000000', 'consum', 0.0216, 'lps'),
	(606334, 128, '2014-04-01 00:32:02.000000', 'consum', 0.0210, 'lps'),
	(606335, 128, '2014-04-01 00:32:03.000000', 'consum', 0.0214, 'lps'),
	(606336, 128, '2014-04-01 00:32:04.000000', 'consum', 0.0211, 'lps'),
	(606337, 128, '2014-04-01 00:32:05.000000', 'consum', 0.0211, 'lps'),
	(606338, 128, '2014-04-01 00:32:06.000000', 'consum', 0.0214, 'lps'),
	(606339, 128, '2014-04-01 00:32:07.000000', 'consum', 0.0217, 'lps'),
	(606340, 128, '2014-04-01 00:32:08.000000', 'consum', 0.0215, 'lps'),
	(606341, 128, '2014-04-01 00:32:09.000000', 'consum', 0.0214, 'lps'),
	(606342, 128, '2014-04-01 00:32:10.000000', 'consum', 0.0215, 'lps'),
	(606343, 128, '2014-04-01 00:32:11.000000', 'consum', 0.0212, 'lps'),
	(606344, 128, '2014-04-01 00:32:12.000000', 'consum', 0.0217, 'lps'),
	(606345, 128, '2014-04-01 00:32:13.000000', 'consum', 0.0210, 'lps'),
	(606346, 128, '2014-04-01 00:32:14.000000', 'consum', 0.0210, 'lps'),
	(606347, 128, '2014-04-01 00:32:15.000000', 'consum', 0.0211, 'lps'),
	(606348, 128, '2014-04-01 00:32:16.000000', 'consum', 0.0213, 'lps'),
	(606349, 128, '2014-04-01 00:32:17.000000', 'consum', 0.0214, 'lps'),
	(606350, 128, '2014-04-01 00:32:18.000000', 'consum', 0.0213, 'lps'),
	(606351, 128, '2014-04-01 00:32:19.000000', 'consum', 0.0210, 'lps'),
	(606352, 128, '2014-04-01 00:32:20.000000', 'consum', 0.0214, 'lps'),
	(606353, 128, '2014-04-01 00:32:21.000000', 'consum', 0.0211, 'lps'),
	(606354, 128, '2014-04-01 00:32:22.000000', 'consum', 0.0211, 'lps'),
	(606355, 128, '2014-04-01 00:32:23.000000', 'consum', 0.0215, 'lps'),
	(606356, 128, '2014-04-01 00:32:24.000000', 'consum', 0.0210, 'lps'),
	(606357, 128, '2014-04-01 00:32:25.000000', 'consum', 0.0216, 'lps'),
	(606358, 128, '2014-04-01 00:32:26.000000', 'consum', 0.0211, 'lps'),
	(606359, 128, '2014-04-01 00:32:27.000000', 'consum', 0.0219, 'lps'),
	(606360, 128, '2014-04-01 00:32:28.000000', 'consum', 0.0219, 'lps'),
	(606361, 128, '2014-04-01 00:32:29.000000', 'consum', 0.0211, 'lps'),
	(606362, 128, '2014-04-01 00:32:30.000000', 'consum', 0.0210, 'lps'),
	(606363, 128, '2014-04-01 00:32:31.000000', 'consum', 0.0215, 'lps'),
	(606364, 128, '2014-04-01 00:32:32.000000', 'consum', 0.0217, 'lps'),
	(606365, 128, '2014-04-01 00:32:33.000000', 'consum', 0.0210, 'lps'),
	(606366, 128, '2014-04-01 00:32:34.000000', 'consum', 0.0218, 'lps'),
	(606367, 128, '2014-04-01 00:32:35.000000', 'consum', 0.0213, 'lps'),
	(606368, 128, '2014-04-01 00:32:36.000000', 'consum', 0.0210, 'lps'),
	(606369, 128, '2014-04-01 00:32:37.000000', 'consum', 0.0214, 'lps'),
	(606370, 128, '2014-04-01 00:32:38.000000', 'consum', 0.0218, 'lps'),
	(606371, 128, '2014-04-01 00:32:39.000000', 'consum', 0.0217, 'lps'),
	(606372, 128, '2014-04-01 00:32:40.000000', 'consum', 0.0215, 'lps'),
	(606373, 128, '2014-04-01 00:32:41.000000', 'consum', 0.0213, 'lps'),
	(606374, 128, '2014-04-01 00:32:42.000000', 'consum', 0.0211, 'lps'),
	(606375, 128, '2014-04-01 00:32:43.000000', 'consum', 0.0218, 'lps'),
	(606376, 128, '2014-04-01 00:32:44.000000', 'consum', 0.0215, 'lps'),
	(606377, 128, '2014-04-01 00:32:45.000000', 'consum', 0.0211, 'lps'),
	(606378, 128, '2014-04-01 00:32:46.000000', 'consum', 0.0211, 'lps'),
	(606379, 128, '2014-04-01 00:32:47.000000', 'consum', 0.0213, 'lps'),
	(606380, 128, '2014-04-01 00:32:48.000000', 'consum', 0.0213, 'lps'),
	(606381, 128, '2014-04-01 00:32:49.000000', 'consum', 0.0214, 'lps'),
	(606382, 128, '2014-04-01 00:32:50.000000', 'consum', 0.0214, 'lps'),
	(606383, 128, '2014-04-01 00:32:51.000000', 'consum', 0.0219, 'lps'),
	(606384, 128, '2014-04-01 00:32:52.000000', 'consum', 0.0212, 'lps'),
	(606385, 128, '2014-04-01 00:32:53.000000', 'consum', 0.0213, 'lps'),
	(606386, 128, '2014-04-01 00:32:54.000000', 'consum', 0.0210, 'lps'),
	(606387, 128, '2014-04-01 00:32:55.000000', 'consum', 0.0214, 'lps'),
	(606388, 128, '2014-04-01 00:32:56.000000', 'consum', 0.0217, 'lps'),
	(606389, 128, '2014-04-01 00:32:57.000000', 'consum', 0.0214, 'lps'),
	(606390, 128, '2014-04-01 00:32:58.000000', 'consum', 0.0211, 'lps'),
	(606391, 128, '2014-04-01 00:32:59.000000', 'consum', 0.0214, 'lps'),
	(606392, 128, '2014-04-01 00:33:00.000000', 'consum', 0.0217, 'lps'),
	(606393, 128, '2014-04-01 00:33:01.000000', 'consum', 0.0214, 'lps'),
	(606394, 128, '2014-04-01 00:33:02.000000', 'consum', 0.0219, 'lps'),
	(606395, 128, '2014-04-01 00:33:03.000000', 'consum', 0.0215, 'lps'),
	(606396, 128, '2014-04-01 00:33:04.000000', 'consum', 0.0219, 'lps'),
	(606397, 128, '2014-04-01 00:33:05.000000', 'consum', 0.0217, 'lps'),
	(606398, 128, '2014-04-01 00:33:06.000000', 'consum', 0.0212, 'lps'),
	(606399, 128, '2014-04-01 00:33:07.000000', 'consum', 0.0217, 'lps'),
	(606400, 128, '2014-04-01 00:33:08.000000', 'consum', 0.0211, 'lps'),
	(606401, 128, '2014-04-01 00:33:09.000000', 'consum', 0.0213, 'lps'),
	(606402, 128, '2014-04-01 00:33:10.000000', 'consum', 0.0215, 'lps'),
	(606403, 128, '2014-04-01 00:33:11.000000', 'consum', 0.0216, 'lps'),
	(606404, 128, '2014-04-01 00:33:12.000000', 'consum', 0.0213, 'lps'),
	(606405, 128, '2014-04-01 00:33:13.000000', 'consum', 0.0219, 'lps'),
	(606406, 128, '2014-04-01 00:33:14.000000', 'consum', 0.0215, 'lps'),
	(606407, 128, '2014-04-01 00:33:15.000000', 'consum', 0.0219, 'lps'),
	(606408, 128, '2014-04-01 00:33:16.000000', 'consum', 0.0219, 'lps'),
	(606409, 128, '2014-04-01 00:33:17.000000', 'consum', 0.0210, 'lps'),
	(606410, 128, '2014-04-01 00:33:18.000000', 'consum', 0.0213, 'lps'),
	(606411, 128, '2014-04-01 00:33:19.000000', 'consum', 0.0215, 'lps'),
	(606412, 128, '2014-04-01 00:33:20.000000', 'consum', 0.0217, 'lps'),
	(606413, 128, '2014-04-01 00:33:21.000000', 'consum', 0.0210, 'lps'),
	(606414, 128, '2014-04-01 00:33:22.000000', 'consum', 0.0212, 'lps'),
	(606415, 128, '2014-04-01 00:33:23.000000', 'consum', 0.0218, 'lps'),
	(606416, 128, '2014-04-01 00:33:24.000000', 'consum', 0.0215, 'lps'),
	(606417, 128, '2014-04-01 00:33:25.000000', 'consum', 0.0214, 'lps'),
	(606418, 128, '2014-04-01 00:33:26.000000', 'consum', 0.0213, 'lps'),
	(606419, 128, '2014-04-01 00:33:27.000000', 'consum', 0.0213, 'lps'),
	(606420, 128, '2014-04-01 00:33:28.000000', 'consum', 0.0218, 'lps'),
	(606421, 128, '2014-04-01 00:33:29.000000', 'consum', 0.0210, 'lps'),
	(606422, 128, '2014-04-01 00:33:30.000000', 'consum', 0.0215, 'lps'),
	(606423, 128, '2014-04-01 00:33:31.000000', 'consum', 0.0219, 'lps'),
	(606424, 128, '2014-04-01 00:33:32.000000', 'consum', 0.0219, 'lps'),
	(606425, 128, '2014-04-01 00:33:33.000000', 'consum', 0.0217, 'lps'),
	(606426, 128, '2014-04-01 00:33:34.000000', 'consum', 0.0212, 'lps'),
	(606427, 128, '2014-04-01 00:33:35.000000', 'consum', 0.0216, 'lps'),
	(606428, 128, '2014-04-01 00:33:36.000000', 'consum', 0.0217, 'lps'),
	(606429, 128, '2014-04-01 00:33:37.000000', 'consum', 0.0215, 'lps'),
	(606430, 128, '2014-04-01 00:33:38.000000', 'consum', 0.0214, 'lps'),
	(606431, 128, '2014-04-01 00:33:39.000000', 'consum', 0.0218, 'lps'),
	(606432, 128, '2014-04-01 00:33:40.000000', 'consum', 0.0218, 'lps'),
	(606433, 128, '2014-04-01 00:33:41.000000', 'consum', 0.0215, 'lps'),
	(606434, 128, '2014-04-01 00:33:42.000000', 'consum', 0.0212, 'lps'),
	(606435, 128, '2014-04-01 00:33:43.000000', 'consum', 0.0216, 'lps'),
	(606436, 128, '2014-04-01 00:33:44.000000', 'consum', 0.0216, 'lps'),
	(606437, 128, '2014-04-01 00:33:45.000000', 'consum', 0.0212, 'lps'),
	(606438, 128, '2014-04-01 00:33:46.000000', 'consum', 0.0212, 'lps'),
	(606439, 128, '2014-04-01 00:33:47.000000', 'consum', 0.0214, 'lps'),
	(606440, 128, '2014-04-01 00:33:48.000000', 'consum', 0.0213, 'lps'),
	(606441, 128, '2014-04-01 00:33:49.000000', 'consum', 0.0217, 'lps'),
	(606442, 128, '2014-04-01 00:33:50.000000', 'consum', 0.0213, 'lps'),
	(606443, 128, '2014-04-01 00:33:51.000000', 'consum', 0.0216, 'lps'),
	(606444, 128, '2014-04-01 00:33:52.000000', 'consum', 0.0213, 'lps'),
	(606445, 128, '2014-04-01 00:33:53.000000', 'consum', 0.0217, 'lps'),
	(606446, 128, '2014-04-01 00:33:54.000000', 'consum', 0.0217, 'lps'),
	(606447, 128, '2014-04-01 00:33:55.000000', 'consum', 0.0214, 'lps'),
	(606448, 128, '2014-04-01 00:33:56.000000', 'consum', 0.0211, 'lps'),
	(606449, 128, '2014-04-01 00:33:57.000000', 'consum', 0.0213, 'lps'),
	(606450, 128, '2014-04-01 00:33:58.000000', 'consum', 0.0213, 'lps'),
	(606451, 128, '2014-04-01 00:33:59.000000', 'consum', 0.0215, 'lps'),
	(606452, 128, '2014-04-01 00:34:00.000000', 'consum', 0.0217, 'lps'),
	(606453, 128, '2014-04-01 00:34:01.000000', 'consum', 0.0210, 'lps'),
	(606454, 128, '2014-04-01 00:34:02.000000', 'consum', 0.0218, 'lps'),
	(606455, 128, '2014-04-01 00:34:03.000000', 'consum', 0.0214, 'lps'),
	(606456, 128, '2014-04-01 00:34:04.000000', 'consum', 0.0214, 'lps'),
	(606457, 128, '2014-04-01 00:34:05.000000', 'consum', 0.0210, 'lps'),
	(606458, 128, '2014-04-01 00:34:06.000000', 'consum', 0.0218, 'lps'),
	(606459, 128, '2014-04-01 00:34:07.000000', 'consum', 0.0219, 'lps'),
	(606460, 128, '2014-04-01 00:34:08.000000', 'consum', 0.0213, 'lps'),
	(606461, 128, '2014-04-01 00:34:09.000000', 'consum', 0.0219, 'lps'),
	(606462, 128, '2014-04-01 00:34:10.000000', 'consum', 0.0217, 'lps'),
	(606463, 128, '2014-04-01 00:34:11.000000', 'consum', 0.0219, 'lps'),
	(606464, 128, '2014-04-01 00:34:12.000000', 'consum', 0.0215, 'lps'),
	(606465, 128, '2014-04-01 00:34:13.000000', 'consum', 0.0217, 'lps'),
	(606466, 128, '2014-04-01 00:34:14.000000', 'consum', 0.0213, 'lps'),
	(606467, 128, '2014-04-01 00:34:15.000000', 'consum', 0.0213, 'lps'),
	(606468, 128, '2014-04-01 00:34:16.000000', 'consum', 0.0216, 'lps'),
	(606469, 128, '2014-04-01 00:34:17.000000', 'consum', 0.0213, 'lps'),
	(606470, 128, '2014-04-01 00:34:18.000000', 'consum', 0.0218, 'lps'),
	(606471, 128, '2014-04-01 00:34:19.000000', 'consum', 0.0219, 'lps'),
	(606472, 128, '2014-04-01 00:34:20.000000', 'consum', 0.0211, 'lps'),
	(606473, 128, '2014-04-01 00:34:21.000000', 'consum', 0.0211, 'lps'),
	(606474, 128, '2014-04-01 00:34:22.000000', 'consum', 0.0219, 'lps'),
	(606475, 128, '2014-04-01 00:34:23.000000', 'consum', 0.0216, 'lps'),
	(606476, 128, '2014-04-01 00:34:24.000000', 'consum', 0.0212, 'lps'),
	(606477, 128, '2014-04-01 00:34:25.000000', 'consum', 0.0213, 'lps'),
	(606478, 128, '2014-04-01 00:34:26.000000', 'consum', 0.0211, 'lps'),
	(606479, 128, '2014-04-01 00:34:27.000000', 'consum', 0.0214, 'lps'),
	(606480, 128, '2014-04-01 00:34:28.000000', 'consum', 0.0219, 'lps'),
	(606481, 128, '2014-04-01 00:34:29.000000', 'consum', 0.0215, 'lps'),
	(606482, 128, '2014-04-01 00:34:30.000000', 'consum', 0.0215, 'lps'),
	(606483, 128, '2014-04-01 00:34:31.000000', 'consum', 0.0213, 'lps'),
	(606484, 128, '2014-04-01 00:34:32.000000', 'consum', 0.0211, 'lps'),
	(606485, 128, '2014-04-01 00:34:33.000000', 'consum', 0.0215, 'lps'),
	(606486, 128, '2014-04-01 00:34:34.000000', 'consum', 0.0212, 'lps'),
	(606487, 128, '2014-04-01 00:34:35.000000', 'consum', 0.0216, 'lps'),
	(606488, 128, '2014-04-01 00:34:36.000000', 'consum', 0.0215, 'lps'),
	(606489, 128, '2014-04-01 00:34:37.000000', 'consum', 0.0216, 'lps'),
	(606490, 128, '2014-04-01 00:34:38.000000', 'consum', 0.0217, 'lps'),
	(606491, 128, '2014-04-01 00:34:39.000000', 'consum', 0.0218, 'lps'),
	(606492, 128, '2014-04-01 00:34:40.000000', 'consum', 0.0218, 'lps'),
	(606493, 128, '2014-04-01 00:34:41.000000', 'consum', 0.0217, 'lps'),
	(606494, 128, '2014-04-01 00:34:42.000000', 'consum', 0.0210, 'lps'),
	(606495, 128, '2014-04-01 00:34:43.000000', 'consum', 0.0211, 'lps'),
	(606496, 128, '2014-04-01 00:34:44.000000', 'consum', 0.0214, 'lps'),
	(606497, 128, '2014-04-01 00:34:45.000000', 'consum', 0.0210, 'lps'),
	(606498, 128, '2014-04-01 00:34:46.000000', 'consum', 0.0216, 'lps'),
	(606499, 128, '2014-04-01 00:34:47.000000', 'consum', 0.0211, 'lps'),
	(606500, 128, '2014-04-01 00:34:48.000000', 'consum', 0.0219, 'lps'),
	(606501, 128, '2014-04-01 00:34:49.000000', 'consum', 0.0213, 'lps'),
	(606502, 128, '2014-04-01 00:34:50.000000', 'consum', 0.0216, 'lps'),
	(606503, 128, '2014-04-01 00:34:51.000000', 'consum', 0.0214, 'lps'),
	(606504, 128, '2014-04-01 00:34:52.000000', 'consum', 0.0212, 'lps'),
	(606505, 128, '2014-04-01 00:34:53.000000', 'consum', 0.0218, 'lps'),
	(606506, 128, '2014-04-01 00:34:54.000000', 'consum', 0.0215, 'lps'),
	(606507, 128, '2014-04-01 00:34:55.000000', 'consum', 0.0213, 'lps'),
	(606508, 128, '2014-04-01 00:34:56.000000', 'consum', 0.0218, 'lps'),
	(606509, 128, '2014-04-01 00:34:57.000000', 'consum', 0.0211, 'lps'),
	(606510, 128, '2014-04-01 00:34:58.000000', 'consum', 0.0213, 'lps'),
	(606511, 128, '2014-04-01 00:34:59.000000', 'consum', 0.0212, 'lps'),
	(606512, 128, '2014-04-01 00:35:00.000000', 'consum', 0.0213, 'lps'),
	(606513, 128, '2014-04-01 00:35:01.000000', 'consum', 0.0217, 'lps'),
	(606514, 128, '2014-04-01 00:35:02.000000', 'consum', 0.0216, 'lps'),
	(606515, 128, '2014-04-01 00:35:03.000000', 'consum', 0.0210, 'lps'),
	(606516, 128, '2014-04-01 00:35:04.000000', 'consum', 0.0215, 'lps'),
	(606517, 128, '2014-04-01 00:35:05.000000', 'consum', 0.0214, 'lps'),
	(606518, 128, '2014-04-01 00:35:06.000000', 'consum', 0.0214, 'lps'),
	(606519, 128, '2014-04-01 00:35:07.000000', 'consum', 0.0210, 'lps'),
	(606520, 128, '2014-04-01 00:35:08.000000', 'consum', 0.0217, 'lps'),
	(606521, 128, '2014-04-01 00:35:09.000000', 'consum', 0.0216, 'lps'),
	(606522, 128, '2014-04-01 00:35:10.000000', 'consum', 0.0211, 'lps'),
	(606523, 128, '2014-04-01 00:35:11.000000', 'consum', 0.0215, 'lps'),
	(606524, 128, '2014-04-01 00:35:12.000000', 'consum', 0.0212, 'lps'),
	(606525, 128, '2014-04-01 00:35:13.000000', 'consum', 0.0215, 'lps'),
	(606526, 128, '2014-04-01 00:35:14.000000', 'consum', 0.0212, 'lps'),
	(606527, 128, '2014-04-01 00:35:15.000000', 'consum', 0.0215, 'lps'),
	(606528, 128, '2014-04-01 00:35:16.000000', 'consum', 0.0218, 'lps'),
	(606529, 128, '2014-04-01 00:35:17.000000', 'consum', 0.0215, 'lps'),
	(606530, 128, '2014-04-01 00:35:18.000000', 'consum', 0.0211, 'lps'),
	(606531, 128, '2014-04-01 00:35:19.000000', 'consum', 0.0212, 'lps'),
	(606532, 128, '2014-04-01 00:35:20.000000', 'consum', 0.0217, 'lps'),
	(606533, 128, '2014-04-01 00:35:21.000000', 'consum', 0.0211, 'lps'),
	(606534, 128, '2014-04-01 00:35:22.000000', 'consum', 0.0214, 'lps'),
	(606535, 128, '2014-04-01 00:35:23.000000', 'consum', 0.0218, 'lps'),
	(606536, 128, '2014-04-01 00:35:24.000000', 'consum', 0.0219, 'lps'),
	(606537, 128, '2014-04-01 00:35:25.000000', 'consum', 0.0210, 'lps'),
	(606538, 128, '2014-04-01 00:35:26.000000', 'consum', 0.0215, 'lps'),
	(606539, 128, '2014-04-01 00:35:27.000000', 'consum', 0.0216, 'lps'),
	(606540, 128, '2014-04-01 00:35:28.000000', 'consum', 0.0216, 'lps'),
	(606541, 128, '2014-04-01 00:35:29.000000', 'consum', 0.0211, 'lps'),
	(606542, 128, '2014-04-01 00:35:30.000000', 'consum', 0.0219, 'lps'),
	(606543, 128, '2014-04-01 00:35:31.000000', 'consum', 0.0210, 'lps'),
	(606544, 128, '2014-04-01 00:35:32.000000', 'consum', 0.0213, 'lps'),
	(606545, 128, '2014-04-01 00:35:33.000000', 'consum', 0.0218, 'lps'),
	(606546, 128, '2014-04-01 00:35:34.000000', 'consum', 0.0210, 'lps'),
	(606547, 128, '2014-04-01 00:35:35.000000', 'consum', 0.0216, 'lps'),
	(606548, 128, '2014-04-01 00:35:36.000000', 'consum', 0.0213, 'lps'),
	(606549, 128, '2014-04-01 00:35:37.000000', 'consum', 0.0214, 'lps'),
	(606550, 128, '2014-04-01 00:35:38.000000', 'consum', 0.0215, 'lps'),
	(606551, 128, '2014-04-01 00:35:39.000000', 'consum', 0.0213, 'lps'),
	(606552, 128, '2014-04-01 00:35:40.000000', 'consum', 0.0219, 'lps'),
	(606553, 128, '2014-04-01 00:35:41.000000', 'consum', 0.0217, 'lps'),
	(606554, 128, '2014-04-01 00:35:42.000000', 'consum', 0.0210, 'lps'),
	(606555, 128, '2014-04-01 00:35:43.000000', 'consum', 0.0218, 'lps'),
	(606556, 128, '2014-04-01 00:35:44.000000', 'consum', 0.0212, 'lps'),
	(606557, 128, '2014-04-01 00:35:45.000000', 'consum', 0.0216, 'lps'),
	(606558, 128, '2014-04-01 00:35:46.000000', 'consum', 0.0214, 'lps'),
	(606559, 128, '2014-04-01 00:35:47.000000', 'consum', 0.0214, 'lps'),
	(606560, 128, '2014-04-01 00:35:48.000000', 'consum', 0.0218, 'lps'),
	(606561, 128, '2014-04-01 00:35:49.000000', 'consum', 0.0217, 'lps'),
	(606562, 128, '2014-04-01 00:35:50.000000', 'consum', 0.0213, 'lps'),
	(606563, 128, '2014-04-01 00:35:51.000000', 'consum', 0.0214, 'lps'),
	(606564, 128, '2014-04-01 00:35:52.000000', 'consum', 0.0211, 'lps'),
	(606565, 128, '2014-04-01 00:35:53.000000', 'consum', 0.0215, 'lps'),
	(606566, 128, '2014-04-01 00:35:54.000000', 'consum', 0.0210, 'lps'),
	(606567, 128, '2014-04-01 00:35:55.000000', 'consum', 0.0216, 'lps'),
	(606568, 128, '2014-04-01 00:35:56.000000', 'consum', 0.0219, 'lps'),
	(606569, 128, '2014-04-01 00:35:57.000000', 'consum', 0.0211, 'lps'),
	(606570, 128, '2014-04-01 00:35:58.000000', 'consum', 0.0216, 'lps'),
	(606571, 128, '2014-04-01 00:35:59.000000', 'consum', 0.0218, 'lps'),
	(606572, 128, '2014-04-01 00:36:00.000000', 'consum', 0.0214, 'lps'),
	(606573, 128, '2014-04-01 00:36:01.000000', 'consum', 0.0215, 'lps'),
	(606574, 128, '2014-04-01 00:36:02.000000', 'consum', 0.0213, 'lps'),
	(606575, 128, '2014-04-01 00:36:03.000000', 'consum', 0.0211, 'lps'),
	(606576, 128, '2014-04-01 00:36:04.000000', 'consum', 0.0217, 'lps'),
	(606577, 128, '2014-04-01 00:36:05.000000', 'consum', 0.0210, 'lps'),
	(606578, 128, '2014-04-01 00:36:06.000000', 'consum', 0.0212, 'lps'),
	(606579, 128, '2014-04-01 00:36:07.000000', 'consum', 0.0212, 'lps'),
	(606580, 128, '2014-04-01 00:36:08.000000', 'consum', 0.0211, 'lps'),
	(606581, 128, '2014-04-01 00:36:09.000000', 'consum', 0.0212, 'lps'),
	(606582, 128, '2014-04-01 00:36:10.000000', 'consum', 0.0217, 'lps'),
	(606583, 128, '2014-04-01 00:36:11.000000', 'consum', 0.0211, 'lps'),
	(606584, 128, '2014-04-01 00:36:12.000000', 'consum', 0.0212, 'lps'),
	(606585, 128, '2014-04-01 00:36:13.000000', 'consum', 0.0218, 'lps'),
	(606586, 128, '2014-04-01 00:36:14.000000', 'consum', 0.0214, 'lps'),
	(606587, 128, '2014-04-01 00:36:15.000000', 'consum', 0.0215, 'lps'),
	(606588, 128, '2014-04-01 00:36:16.000000', 'consum', 0.0217, 'lps'),
	(606589, 128, '2014-04-01 00:36:17.000000', 'consum', 0.0218, 'lps'),
	(606590, 128, '2014-04-01 00:36:18.000000', 'consum', 0.0218, 'lps'),
	(606591, 128, '2014-04-01 00:36:19.000000', 'consum', 0.0210, 'lps'),
	(606592, 128, '2014-04-01 00:36:20.000000', 'consum', 0.0215, 'lps'),
	(606593, 128, '2014-04-01 00:36:21.000000', 'consum', 0.0215, 'lps'),
	(606594, 128, '2014-04-01 00:36:22.000000', 'consum', 0.0212, 'lps'),
	(606595, 128, '2014-04-01 00:36:23.000000', 'consum', 0.0216, 'lps'),
	(606596, 128, '2014-04-01 00:36:24.000000', 'consum', 0.0214, 'lps'),
	(606597, 128, '2014-04-01 00:36:25.000000', 'consum', 0.0213, 'lps'),
	(606598, 128, '2014-04-01 00:36:26.000000', 'consum', 0.0215, 'lps'),
	(606599, 128, '2014-04-01 00:36:27.000000', 'consum', 0.0213, 'lps'),
	(606600, 128, '2014-04-01 00:36:28.000000', 'consum', 0.0212, 'lps'),
	(606601, 128, '2014-04-01 00:36:29.000000', 'consum', 0.0212, 'lps'),
	(606602, 128, '2014-04-01 00:36:30.000000', 'consum', 0.0215, 'lps'),
	(606603, 128, '2014-04-01 00:36:31.000000', 'consum', 0.0210, 'lps'),
	(606604, 128, '2014-04-01 00:36:32.000000', 'consum', 0.0213, 'lps'),
	(606605, 128, '2014-04-01 00:36:33.000000', 'consum', 0.0218, 'lps'),
	(606606, 128, '2014-04-01 00:36:34.000000', 'consum', 0.0219, 'lps'),
	(606607, 128, '2014-04-01 00:36:35.000000', 'consum', 0.0215, 'lps'),
	(606608, 128, '2014-04-01 00:36:36.000000', 'consum', 0.0216, 'lps'),
	(606609, 128, '2014-04-01 00:36:37.000000', 'consum', 0.0214, 'lps'),
	(606610, 128, '2014-04-01 00:36:38.000000', 'consum', 0.0215, 'lps'),
	(606611, 128, '2014-04-01 00:36:39.000000', 'consum', 0.0215, 'lps'),
	(606612, 128, '2014-04-01 00:36:40.000000', 'consum', 0.0218, 'lps'),
	(606613, 128, '2014-04-01 00:36:41.000000', 'consum', 0.0218, 'lps'),
	(606614, 128, '2014-04-01 00:36:42.000000', 'consum', 0.0215, 'lps'),
	(606615, 128, '2014-04-01 00:36:43.000000', 'consum', 0.0211, 'lps'),
	(606616, 128, '2014-04-01 00:36:44.000000', 'consum', 0.0219, 'lps'),
	(606617, 128, '2014-04-01 00:36:45.000000', 'consum', 0.0216, 'lps'),
	(606618, 128, '2014-04-01 00:36:46.000000', 'consum', 0.0212, 'lps'),
	(606619, 128, '2014-04-01 00:36:47.000000', 'consum', 0.0213, 'lps'),
	(606620, 128, '2014-04-01 00:36:48.000000', 'consum', 0.0218, 'lps'),
	(606621, 128, '2014-04-01 00:36:49.000000', 'consum', 0.0211, 'lps'),
	(606622, 128, '2014-04-01 00:36:50.000000', 'consum', 0.0211, 'lps'),
	(606623, 128, '2014-04-01 00:36:51.000000', 'consum', 0.0215, 'lps'),
	(606624, 128, '2014-04-01 00:36:52.000000', 'consum', 0.0212, 'lps'),
	(606625, 128, '2014-04-01 00:36:53.000000', 'consum', 0.0216, 'lps'),
	(606626, 128, '2014-04-01 00:36:54.000000', 'consum', 0.0213, 'lps'),
	(606627, 128, '2014-04-01 00:36:55.000000', 'consum', 0.0218, 'lps'),
	(606628, 128, '2014-04-01 00:36:56.000000', 'consum', 0.0212, 'lps'),
	(606629, 128, '2014-04-01 00:36:57.000000', 'consum', 0.0215, 'lps'),
	(606630, 128, '2014-04-01 00:36:58.000000', 'consum', 0.0219, 'lps'),
	(606631, 128, '2014-04-01 00:36:59.000000', 'consum', 0.0211, 'lps'),
	(606632, 128, '2014-04-01 00:37:00.000000', 'consum', 0.0219, 'lps'),
	(606633, 128, '2014-04-01 00:37:01.000000', 'consum', 0.0214, 'lps'),
	(606634, 128, '2014-04-01 00:37:02.000000', 'consum', 0.0213, 'lps'),
	(606635, 128, '2014-04-01 00:37:03.000000', 'consum', 0.0214, 'lps'),
	(606636, 128, '2014-04-01 00:37:04.000000', 'consum', 0.0212, 'lps'),
	(606637, 128, '2014-04-01 00:37:05.000000', 'consum', 0.0216, 'lps'),
	(606638, 128, '2014-04-01 00:37:06.000000', 'consum', 0.0216, 'lps'),
	(606639, 128, '2014-04-01 00:37:07.000000', 'consum', 0.0212, 'lps'),
	(606640, 128, '2014-04-01 00:37:08.000000', 'consum', 0.0215, 'lps'),
	(606641, 128, '2014-04-01 00:37:09.000000', 'consum', 0.0216, 'lps'),
	(606642, 128, '2014-04-01 00:37:10.000000', 'consum', 0.0218, 'lps'),
	(606643, 128, '2014-04-01 00:37:11.000000', 'consum', 0.0212, 'lps'),
	(606644, 128, '2014-04-01 00:37:12.000000', 'consum', 0.0218, 'lps'),
	(606645, 128, '2014-04-01 00:37:13.000000', 'consum', 0.0214, 'lps'),
	(606646, 128, '2014-04-01 00:37:14.000000', 'consum', 0.0218, 'lps'),
	(606647, 128, '2014-04-01 00:37:15.000000', 'consum', 0.0216, 'lps'),
	(606648, 128, '2014-04-01 00:37:16.000000', 'consum', 0.0219, 'lps'),
	(606649, 128, '2014-04-01 00:37:17.000000', 'consum', 0.0214, 'lps'),
	(606650, 128, '2014-04-01 00:37:18.000000', 'consum', 0.0216, 'lps'),
	(606651, 128, '2014-04-01 00:37:19.000000', 'consum', 0.0218, 'lps'),
	(606652, 128, '2014-04-01 00:37:20.000000', 'consum', 0.0213, 'lps'),
	(606653, 128, '2014-04-01 00:37:21.000000', 'consum', 0.0212, 'lps'),
	(606654, 128, '2014-04-01 00:37:22.000000', 'consum', 0.0210, 'lps'),
	(606655, 128, '2014-04-01 00:37:23.000000', 'consum', 0.0216, 'lps'),
	(606656, 128, '2014-04-01 00:37:24.000000', 'consum', 0.0210, 'lps'),
	(606657, 128, '2014-04-01 00:37:25.000000', 'consum', 0.0210, 'lps'),
	(606658, 128, '2014-04-01 00:37:26.000000', 'consum', 0.0213, 'lps'),
	(606659, 128, '2014-04-01 00:37:27.000000', 'consum', 0.0217, 'lps'),
	(606660, 128, '2014-04-01 00:37:28.000000', 'consum', 0.0213, 'lps'),
	(606661, 128, '2014-04-01 00:37:29.000000', 'consum', 0.0217, 'lps'),
	(606662, 128, '2014-04-01 00:37:30.000000', 'consum', 0.0217, 'lps'),
	(606663, 128, '2014-04-01 00:37:31.000000', 'consum', 0.0215, 'lps'),
	(606664, 128, '2014-04-01 00:37:32.000000', 'consum', 0.0212, 'lps'),
	(606665, 128, '2014-04-01 00:37:33.000000', 'consum', 0.0218, 'lps'),
	(606666, 128, '2014-04-01 00:37:34.000000', 'consum', 0.0215, 'lps'),
	(606667, 128, '2014-04-01 00:37:35.000000', 'consum', 0.0211, 'lps'),
	(606668, 128, '2014-04-01 00:37:36.000000', 'consum', 0.0211, 'lps'),
	(606669, 128, '2014-04-01 00:37:37.000000', 'consum', 0.0212, 'lps'),
	(606670, 128, '2014-04-01 00:37:38.000000', 'consum', 0.0215, 'lps'),
	(606671, 128, '2014-04-01 00:37:39.000000', 'consum', 0.0213, 'lps'),
	(606672, 128, '2014-04-01 00:37:40.000000', 'consum', 0.0210, 'lps'),
	(606673, 128, '2014-04-01 00:37:41.000000', 'consum', 0.0210, 'lps'),
	(606674, 128, '2014-04-01 00:37:42.000000', 'consum', 0.0219, 'lps'),
	(606675, 128, '2014-04-01 00:37:43.000000', 'consum', 0.0217, 'lps'),
	(606676, 128, '2014-04-01 00:37:44.000000', 'consum', 0.0219, 'lps'),
	(606677, 128, '2014-04-01 00:37:45.000000', 'consum', 0.0216, 'lps'),
	(606678, 128, '2014-04-01 00:37:46.000000', 'consum', 0.0213, 'lps'),
	(606679, 128, '2014-04-01 00:37:47.000000', 'consum', 0.0216, 'lps'),
	(606680, 128, '2014-04-01 00:37:48.000000', 'consum', 0.0213, 'lps'),
	(606681, 128, '2014-04-01 00:37:49.000000', 'consum', 0.0215, 'lps'),
	(606682, 128, '2014-04-01 00:37:50.000000', 'consum', 0.0218, 'lps'),
	(606683, 128, '2014-04-01 00:37:51.000000', 'consum', 0.0217, 'lps'),
	(606684, 128, '2014-04-01 00:37:52.000000', 'consum', 0.0219, 'lps'),
	(606685, 128, '2014-04-01 00:37:53.000000', 'consum', 0.0214, 'lps'),
	(606686, 128, '2014-04-01 00:37:54.000000', 'consum', 0.0216, 'lps'),
	(606687, 128, '2014-04-01 00:37:55.000000', 'consum', 0.0217, 'lps'),
	(606688, 128, '2014-04-01 00:37:56.000000', 'consum', 0.0217, 'lps'),
	(606689, 128, '2014-04-01 00:37:57.000000', 'consum', 0.0214, 'lps'),
	(606690, 128, '2014-04-01 00:37:58.000000', 'consum', 0.0212, 'lps'),
	(606691, 128, '2014-04-01 00:37:59.000000', 'consum', 0.0217, 'lps'),
	(606692, 128, '2014-04-01 00:38:00.000000', 'consum', 0.0210, 'lps'),
	(606693, 128, '2014-04-01 00:38:01.000000', 'consum', 0.0210, 'lps'),
	(606694, 128, '2014-04-01 00:38:02.000000', 'consum', 0.0211, 'lps'),
	(606695, 128, '2014-04-01 00:38:03.000000', 'consum', 0.0214, 'lps'),
	(606696, 128, '2014-04-01 00:38:04.000000', 'consum', 0.0219, 'lps'),
	(606697, 128, '2014-04-01 00:38:05.000000', 'consum', 0.0212, 'lps'),
	(606698, 128, '2014-04-01 00:38:06.000000', 'consum', 0.0213, 'lps'),
	(606699, 128, '2014-04-01 00:38:07.000000', 'consum', 0.0211, 'lps'),
	(606700, 128, '2014-04-01 00:38:08.000000', 'consum', 0.0218, 'lps'),
	(606701, 128, '2014-04-01 00:38:09.000000', 'consum', 0.0216, 'lps'),
	(606702, 128, '2014-04-01 00:38:10.000000', 'consum', 0.0218, 'lps'),
	(606703, 128, '2014-04-01 00:38:11.000000', 'consum', 0.0212, 'lps'),
	(606704, 128, '2014-04-01 00:38:12.000000', 'consum', 0.0216, 'lps'),
	(606705, 128, '2014-04-01 00:38:13.000000', 'consum', 0.0213, 'lps'),
	(606706, 128, '2014-04-01 00:38:14.000000', 'consum', 0.0218, 'lps'),
	(606707, 128, '2014-04-01 00:38:15.000000', 'consum', 0.0213, 'lps'),
	(606708, 128, '2014-04-01 00:38:16.000000', 'consum', 0.0210, 'lps'),
	(606709, 128, '2014-04-01 00:38:17.000000', 'consum', 0.0212, 'lps'),
	(606710, 128, '2014-04-01 00:38:18.000000', 'consum', 0.0210, 'lps'),
	(606711, 128, '2014-04-01 00:38:19.000000', 'consum', 0.0215, 'lps'),
	(606712, 128, '2014-04-01 00:38:20.000000', 'consum', 0.0214, 'lps'),
	(606713, 128, '2014-04-01 00:38:21.000000', 'consum', 0.0215, 'lps'),
	(606714, 128, '2014-04-01 00:38:22.000000', 'consum', 0.0217, 'lps'),
	(606715, 128, '2014-04-01 00:38:23.000000', 'consum', 0.0217, 'lps'),
	(606716, 128, '2014-04-01 00:38:24.000000', 'consum', 0.0216, 'lps'),
	(606717, 128, '2014-04-01 00:38:25.000000', 'consum', 0.0219, 'lps'),
	(606718, 128, '2014-04-01 00:38:26.000000', 'consum', 0.0210, 'lps'),
	(606719, 128, '2014-04-01 00:38:27.000000', 'consum', 0.0211, 'lps'),
	(606720, 128, '2014-04-01 00:38:28.000000', 'consum', 0.0214, 'lps'),
	(606721, 128, '2014-04-01 00:38:29.000000', 'consum', 0.0210, 'lps'),
	(606722, 128, '2014-04-01 00:38:30.000000', 'consum', 0.0218, 'lps'),
	(606723, 128, '2014-04-01 00:38:31.000000', 'consum', 0.0219, 'lps'),
	(606724, 128, '2014-04-01 00:38:32.000000', 'consum', 0.0213, 'lps'),
	(606725, 128, '2014-04-01 00:38:33.000000', 'consum', 0.0210, 'lps'),
	(606726, 128, '2014-04-01 00:38:34.000000', 'consum', 0.0219, 'lps'),
	(606727, 128, '2014-04-01 00:38:35.000000', 'consum', 0.0218, 'lps'),
	(606728, 128, '2014-04-01 00:38:36.000000', 'consum', 0.0210, 'lps'),
	(606729, 128, '2014-04-01 00:38:37.000000', 'consum', 0.0210, 'lps'),
	(606730, 128, '2014-04-01 00:38:38.000000', 'consum', 0.0219, 'lps'),
	(606731, 128, '2014-04-01 00:38:39.000000', 'consum', 0.0216, 'lps'),
	(606732, 128, '2014-04-01 00:38:40.000000', 'consum', 0.0214, 'lps'),
	(606733, 128, '2014-04-01 00:38:41.000000', 'consum', 0.0213, 'lps'),
	(606734, 128, '2014-04-01 00:38:42.000000', 'consum', 0.0214, 'lps'),
	(606735, 128, '2014-04-01 00:38:43.000000', 'consum', 0.0211, 'lps'),
	(606736, 128, '2014-04-01 00:38:44.000000', 'consum', 0.0215, 'lps'),
	(606737, 128, '2014-04-01 00:38:45.000000', 'consum', 0.0213, 'lps'),
	(606738, 128, '2014-04-01 00:38:46.000000', 'consum', 0.0219, 'lps'),
	(606739, 128, '2014-04-01 00:38:47.000000', 'consum', 0.0219, 'lps'),
	(606740, 128, '2014-04-01 00:38:48.000000', 'consum', 0.0216, 'lps'),
	(606741, 128, '2014-04-01 00:38:49.000000', 'consum', 0.0214, 'lps'),
	(606742, 128, '2014-04-01 00:38:50.000000', 'consum', 0.0211, 'lps'),
	(606743, 128, '2014-04-01 00:38:51.000000', 'consum', 0.0217, 'lps'),
	(606744, 128, '2014-04-01 00:38:52.000000', 'consum', 0.0219, 'lps'),
	(606745, 128, '2014-04-01 00:38:53.000000', 'consum', 0.0216, 'lps'),
	(606746, 128, '2014-04-01 00:38:54.000000', 'consum', 0.0212, 'lps'),
	(606747, 128, '2014-04-01 00:38:55.000000', 'consum', 0.0215, 'lps'),
	(606748, 128, '2014-04-01 00:38:56.000000', 'consum', 0.0219, 'lps'),
	(606749, 128, '2014-04-01 00:38:57.000000', 'consum', 0.0218, 'lps'),
	(606750, 128, '2014-04-01 00:38:58.000000', 'consum', 0.0215, 'lps'),
	(606751, 128, '2014-04-01 00:38:59.000000', 'consum', 0.0213, 'lps'),
	(606752, 128, '2014-04-01 00:39:00.000000', 'consum', 0.0219, 'lps'),
	(606753, 128, '2014-04-01 00:39:01.000000', 'consum', 0.0216, 'lps'),
	(606754, 128, '2014-04-01 00:39:02.000000', 'consum', 0.0216, 'lps'),
	(606755, 128, '2014-04-01 00:39:03.000000', 'consum', 0.0212, 'lps'),
	(606756, 128, '2014-04-01 00:39:04.000000', 'consum', 0.0210, 'lps'),
	(606757, 128, '2014-04-01 00:39:05.000000', 'consum', 0.0216, 'lps'),
	(606758, 128, '2014-04-01 00:39:06.000000', 'consum', 0.0212, 'lps'),
	(606759, 128, '2014-04-01 00:39:07.000000', 'consum', 0.0213, 'lps'),
	(606760, 128, '2014-04-01 00:39:08.000000', 'consum', 0.0219, 'lps'),
	(606761, 128, '2014-04-01 00:39:09.000000', 'consum', 0.0216, 'lps'),
	(606762, 128, '2014-04-01 00:39:10.000000', 'consum', 0.0214, 'lps'),
	(606763, 128, '2014-04-01 00:39:11.000000', 'consum', 0.0214, 'lps'),
	(606764, 128, '2014-04-01 00:39:12.000000', 'consum', 0.0218, 'lps'),
	(606765, 128, '2014-04-01 00:39:13.000000', 'consum', 0.0219, 'lps'),
	(606766, 128, '2014-04-01 00:39:14.000000', 'consum', 0.0210, 'lps'),
	(606767, 128, '2014-04-01 00:39:15.000000', 'consum', 0.0214, 'lps'),
	(606768, 128, '2014-04-01 00:39:16.000000', 'consum', 0.0210, 'lps'),
	(606769, 128, '2014-04-01 00:39:17.000000', 'consum', 0.0217, 'lps'),
	(606770, 128, '2014-04-01 00:39:18.000000', 'consum', 0.0219, 'lps'),
	(606771, 128, '2014-04-01 00:39:19.000000', 'consum', 0.0212, 'lps'),
	(606772, 128, '2014-04-01 00:39:20.000000', 'consum', 0.0214, 'lps'),
	(606773, 128, '2014-04-01 00:39:21.000000', 'consum', 0.0216, 'lps'),
	(606774, 128, '2014-04-01 00:39:22.000000', 'consum', 0.0216, 'lps'),
	(606775, 128, '2014-04-01 00:39:23.000000', 'consum', 0.0213, 'lps'),
	(606776, 128, '2014-04-01 00:39:24.000000', 'consum', 0.0216, 'lps'),
	(606777, 128, '2014-04-01 00:39:25.000000', 'consum', 0.0213, 'lps'),
	(606778, 128, '2014-04-01 00:39:26.000000', 'consum', 0.0218, 'lps'),
	(606779, 128, '2014-04-01 00:39:27.000000', 'consum', 0.0213, 'lps'),
	(606780, 128, '2014-04-01 00:39:28.000000', 'consum', 0.0219, 'lps'),
	(606781, 128, '2014-04-01 00:39:29.000000', 'consum', 0.0219, 'lps'),
	(606782, 128, '2014-04-01 00:39:30.000000', 'consum', 0.0215, 'lps'),
	(606783, 128, '2014-04-01 00:39:31.000000', 'consum', 0.0212, 'lps'),
	(606784, 128, '2014-04-01 00:39:32.000000', 'consum', 0.0212, 'lps'),
	(606785, 128, '2014-04-01 00:39:33.000000', 'consum', 0.0217, 'lps'),
	(606786, 128, '2014-04-01 00:39:34.000000', 'consum', 0.0217, 'lps'),
	(606787, 128, '2014-04-01 00:39:35.000000', 'consum', 0.0215, 'lps'),
	(606788, 128, '2014-04-01 00:39:36.000000', 'consum', 0.0215, 'lps'),
	(606789, 128, '2014-04-01 00:39:37.000000', 'consum', 0.0212, 'lps'),
	(606790, 128, '2014-04-01 00:39:38.000000', 'consum', 0.0216, 'lps'),
	(606791, 128, '2014-04-01 00:39:39.000000', 'consum', 0.0213, 'lps'),
	(606792, 128, '2014-04-01 00:39:40.000000', 'consum', 0.0219, 'lps'),
	(606793, 128, '2014-04-01 00:39:41.000000', 'consum', 0.0217, 'lps'),
	(606794, 128, '2014-04-01 00:39:42.000000', 'consum', 0.0216, 'lps'),
	(606795, 128, '2014-04-01 00:39:43.000000', 'consum', 0.0211, 'lps'),
	(606796, 128, '2014-04-01 00:39:44.000000', 'consum', 0.0217, 'lps'),
	(606797, 128, '2014-04-01 00:39:45.000000', 'consum', 0.0213, 'lps'),
	(606798, 128, '2014-04-01 00:39:46.000000', 'consum', 0.0215, 'lps'),
	(606799, 128, '2014-04-01 00:39:47.000000', 'consum', 0.0217, 'lps'),
	(606800, 128, '2014-04-01 00:39:48.000000', 'consum', 0.0219, 'lps'),
	(606801, 128, '2014-04-01 00:39:49.000000', 'consum', 0.0214, 'lps'),
	(606802, 128, '2014-04-01 00:39:50.000000', 'consum', 0.0215, 'lps'),
	(606803, 128, '2014-04-01 00:39:51.000000', 'consum', 0.0214, 'lps'),
	(606804, 128, '2014-04-01 00:39:52.000000', 'consum', 0.0215, 'lps'),
	(606805, 128, '2014-04-01 00:39:53.000000', 'consum', 0.0212, 'lps'),
	(606806, 128, '2014-04-01 00:39:54.000000', 'consum', 0.0217, 'lps'),
	(606807, 128, '2014-04-01 00:39:55.000000', 'consum', 0.0218, 'lps'),
	(606808, 128, '2014-04-01 00:39:56.000000', 'consum', 0.0210, 'lps'),
	(606809, 128, '2014-04-01 00:39:57.000000', 'consum', 0.0219, 'lps'),
	(606810, 128, '2014-04-01 00:39:58.000000', 'consum', 0.0213, 'lps'),
	(606811, 128, '2014-04-01 00:39:59.000000', 'consum', 0.0217, 'lps'),
	(606812, 128, '2014-04-01 00:40:00.000000', 'consum', 0.0218, 'lps'),
	(606813, 128, '2014-04-01 00:40:01.000000', 'consum', 0.0219, 'lps'),
	(606814, 128, '2014-04-01 00:40:02.000000', 'consum', 0.0214, 'lps'),
	(606815, 128, '2014-04-01 00:40:03.000000', 'consum', 0.0210, 'lps'),
	(606816, 128, '2014-04-01 00:40:04.000000', 'consum', 0.0211, 'lps'),
	(606817, 128, '2014-04-01 00:40:05.000000', 'consum', 0.0214, 'lps'),
	(606818, 128, '2014-04-01 00:40:06.000000', 'consum', 0.0217, 'lps'),
	(606819, 128, '2014-04-01 00:40:07.000000', 'consum', 0.0216, 'lps'),
	(606820, 128, '2014-04-01 00:40:08.000000', 'consum', 0.0219, 'lps'),
	(606821, 128, '2014-04-01 00:40:09.000000', 'consum', 0.0216, 'lps'),
	(606822, 128, '2014-04-01 00:40:10.000000', 'consum', 0.0213, 'lps'),
	(606823, 128, '2014-04-01 00:40:11.000000', 'consum', 0.0210, 'lps'),
	(606824, 128, '2014-04-01 00:40:12.000000', 'consum', 0.0219, 'lps'),
	(606825, 128, '2014-04-01 00:40:13.000000', 'consum', 0.0218, 'lps'),
	(606826, 128, '2014-04-01 00:40:14.000000', 'consum', 0.0211, 'lps'),
	(606827, 128, '2014-04-01 00:40:15.000000', 'consum', 0.0212, 'lps'),
	(606828, 128, '2014-04-01 00:40:16.000000', 'consum', 0.0216, 'lps'),
	(606829, 128, '2014-04-01 00:40:17.000000', 'consum', 0.0218, 'lps'),
	(606830, 128, '2014-04-01 00:40:18.000000', 'consum', 0.0210, 'lps'),
	(606831, 128, '2014-04-01 00:40:19.000000', 'consum', 0.0216, 'lps'),
	(606832, 128, '2014-04-01 00:40:20.000000', 'consum', 0.0210, 'lps'),
	(606833, 128, '2014-04-01 00:40:21.000000', 'consum', 0.0213, 'lps'),
	(606834, 128, '2014-04-01 00:40:22.000000', 'consum', 0.0215, 'lps'),
	(606835, 128, '2014-04-01 00:40:23.000000', 'consum', 0.0216, 'lps'),
	(606836, 128, '2014-04-01 00:40:24.000000', 'consum', 0.0214, 'lps'),
	(606837, 128, '2014-04-01 00:40:25.000000', 'consum', 0.0215, 'lps'),
	(606838, 128, '2014-04-01 00:40:26.000000', 'consum', 0.0212, 'lps'),
	(606839, 128, '2014-04-01 00:40:27.000000', 'consum', 0.0215, 'lps'),
	(606840, 128, '2014-04-01 00:40:28.000000', 'consum', 0.0211, 'lps'),
	(606841, 128, '2014-04-01 00:40:29.000000', 'consum', 0.0210, 'lps'),
	(606842, 128, '2014-04-01 00:40:30.000000', 'consum', 0.0217, 'lps'),
	(606843, 128, '2014-04-01 00:40:31.000000', 'consum', 0.0218, 'lps'),
	(606844, 128, '2014-04-01 00:40:32.000000', 'consum', 0.0216, 'lps'),
	(606845, 128, '2014-04-01 00:40:33.000000', 'consum', 0.0218, 'lps'),
	(606846, 128, '2014-04-01 00:40:34.000000', 'consum', 0.0212, 'lps'),
	(606847, 128, '2014-04-01 00:40:35.000000', 'consum', 0.0216, 'lps'),
	(606848, 128, '2014-04-01 00:40:36.000000', 'consum', 0.0213, 'lps'),
	(606849, 128, '2014-04-01 00:40:37.000000', 'consum', 0.0219, 'lps'),
	(606850, 128, '2014-04-01 00:40:38.000000', 'consum', 0.0217, 'lps'),
	(606851, 128, '2014-04-01 00:40:39.000000', 'consum', 0.0217, 'lps'),
	(606852, 128, '2014-04-01 00:40:40.000000', 'consum', 0.0214, 'lps'),
	(606853, 128, '2014-04-01 00:40:41.000000', 'consum', 0.0219, 'lps'),
	(606854, 128, '2014-04-01 00:40:42.000000', 'consum', 0.0215, 'lps'),
	(606855, 128, '2014-04-01 00:40:43.000000', 'consum', 0.0217, 'lps'),
	(606856, 128, '2014-04-01 00:40:44.000000', 'consum', 0.0212, 'lps'),
	(606857, 128, '2014-04-01 00:40:45.000000', 'consum', 0.0217, 'lps'),
	(606858, 128, '2014-04-01 00:40:46.000000', 'consum', 0.0210, 'lps'),
	(606859, 128, '2014-04-01 00:40:47.000000', 'consum', 0.0211, 'lps'),
	(606860, 128, '2014-04-01 00:40:48.000000', 'consum', 0.0216, 'lps'),
	(606861, 128, '2014-04-01 00:40:49.000000', 'consum', 0.0218, 'lps'),
	(606862, 128, '2014-04-01 00:40:50.000000', 'consum', 0.0211, 'lps'),
	(606863, 128, '2014-04-01 00:40:51.000000', 'consum', 0.0212, 'lps'),
	(606864, 128, '2014-04-01 00:40:52.000000', 'consum', 0.0216, 'lps'),
	(606865, 128, '2014-04-01 00:40:53.000000', 'consum', 0.0217, 'lps'),
	(606866, 128, '2014-04-01 00:40:54.000000', 'consum', 0.0218, 'lps'),
	(606867, 128, '2014-04-01 00:40:55.000000', 'consum', 0.0210, 'lps'),
	(606868, 128, '2014-04-01 00:40:56.000000', 'consum', 0.0217, 'lps'),
	(606869, 128, '2014-04-01 00:40:57.000000', 'consum', 0.0216, 'lps'),
	(606870, 128, '2014-04-01 00:40:58.000000', 'consum', 0.0210, 'lps'),
	(606871, 128, '2014-04-01 00:40:59.000000', 'consum', 0.0213, 'lps'),
	(606872, 128, '2014-04-01 00:41:00.000000', 'consum', 0.0216, 'lps'),
	(606873, 128, '2014-04-01 00:41:01.000000', 'consum', 0.0211, 'lps'),
	(606874, 128, '2014-04-01 00:41:02.000000', 'consum', 0.0219, 'lps'),
	(606875, 128, '2014-04-01 00:41:03.000000', 'consum', 0.0211, 'lps'),
	(606876, 128, '2014-04-01 00:41:04.000000', 'consum', 0.0219, 'lps'),
	(606877, 128, '2014-04-01 00:41:05.000000', 'consum', 0.0213, 'lps'),
	(606878, 128, '2014-04-01 00:41:06.000000', 'consum', 0.0217, 'lps'),
	(606879, 128, '2014-04-01 00:41:07.000000', 'consum', 0.0219, 'lps'),
	(606880, 128, '2014-04-01 00:41:08.000000', 'consum', 0.0212, 'lps'),
	(606881, 128, '2014-04-01 00:41:09.000000', 'consum', 0.0212, 'lps'),
	(606882, 128, '2014-04-01 00:41:10.000000', 'consum', 0.0217, 'lps'),
	(606883, 128, '2014-04-01 00:41:11.000000', 'consum', 0.0211, 'lps'),
	(606884, 128, '2014-04-01 00:41:12.000000', 'consum', 0.0213, 'lps'),
	(606885, 128, '2014-04-01 00:41:13.000000', 'consum', 0.0211, 'lps'),
	(606886, 128, '2014-04-01 00:41:14.000000', 'consum', 0.0217, 'lps'),
	(606887, 128, '2014-04-01 00:41:15.000000', 'consum', 0.0213, 'lps'),
	(606888, 128, '2014-04-01 00:41:16.000000', 'consum', 0.0216, 'lps'),
	(606889, 128, '2014-04-01 00:41:17.000000', 'consum', 0.0219, 'lps'),
	(606890, 128, '2014-04-01 00:41:18.000000', 'consum', 0.0218, 'lps'),
	(606891, 128, '2014-04-01 00:41:19.000000', 'consum', 0.0212, 'lps'),
	(606892, 128, '2014-04-01 00:41:20.000000', 'consum', 0.0218, 'lps'),
	(606893, 128, '2014-04-01 00:41:21.000000', 'consum', 0.0214, 'lps'),
	(606894, 128, '2014-04-01 00:41:22.000000', 'consum', 0.0218, 'lps'),
	(606895, 128, '2014-04-01 00:41:23.000000', 'consum', 0.0217, 'lps'),
	(606896, 128, '2014-04-01 00:41:24.000000', 'consum', 0.0210, 'lps'),
	(606897, 128, '2014-04-01 00:41:25.000000', 'consum', 0.0213, 'lps'),
	(606898, 128, '2014-04-01 00:41:26.000000', 'consum', 0.0213, 'lps'),
	(606899, 128, '2014-04-01 00:41:27.000000', 'consum', 0.0216, 'lps'),
	(606900, 128, '2014-04-01 00:41:28.000000', 'consum', 0.0213, 'lps'),
	(606901, 128, '2014-04-01 00:41:29.000000', 'consum', 0.0217, 'lps'),
	(606902, 128, '2014-04-01 00:41:30.000000', 'consum', 0.0217, 'lps'),
	(606903, 128, '2014-04-01 00:41:31.000000', 'consum', 0.0213, 'lps'),
	(606904, 128, '2014-04-01 00:41:32.000000', 'consum', 0.0214, 'lps'),
	(606905, 128, '2014-04-01 00:41:33.000000', 'consum', 0.0211, 'lps'),
	(606906, 128, '2014-04-01 00:41:34.000000', 'consum', 0.0214, 'lps'),
	(606907, 128, '2014-04-01 00:41:35.000000', 'consum', 0.0218, 'lps'),
	(606908, 128, '2014-04-01 00:41:36.000000', 'consum', 0.0210, 'lps'),
	(606909, 128, '2014-04-01 00:41:37.000000', 'consum', 0.0213, 'lps'),
	(606910, 128, '2014-04-01 00:41:38.000000', 'consum', 0.0219, 'lps'),
	(606911, 128, '2014-04-01 00:41:39.000000', 'consum', 0.0215, 'lps'),
	(606912, 128, '2014-04-01 00:41:40.000000', 'consum', 0.0210, 'lps'),
	(606913, 128, '2014-04-01 00:41:41.000000', 'consum', 0.0216, 'lps'),
	(606914, 128, '2014-04-01 00:41:42.000000', 'consum', 0.0210, 'lps'),
	(606915, 128, '2014-04-01 00:41:43.000000', 'consum', 0.0212, 'lps'),
	(606916, 128, '2014-04-01 00:41:44.000000', 'consum', 0.0210, 'lps'),
	(606917, 128, '2014-04-01 00:41:45.000000', 'consum', 0.0213, 'lps'),
	(606918, 128, '2014-04-01 00:41:46.000000', 'consum', 0.0217, 'lps'),
	(606919, 128, '2014-04-01 00:41:47.000000', 'consum', 0.0218, 'lps'),
	(606920, 128, '2014-04-01 00:41:48.000000', 'consum', 0.0217, 'lps'),
	(606921, 128, '2014-04-01 00:41:49.000000', 'consum', 0.0213, 'lps'),
	(606922, 128, '2014-04-01 00:41:50.000000', 'consum', 0.0215, 'lps'),
	(606923, 128, '2014-04-01 00:41:51.000000', 'consum', 0.0217, 'lps'),
	(606924, 128, '2014-04-01 00:41:52.000000', 'consum', 0.0210, 'lps'),
	(606925, 128, '2014-04-01 00:41:53.000000', 'consum', 0.0218, 'lps'),
	(606926, 128, '2014-04-01 00:41:54.000000', 'consum', 0.0210, 'lps'),
	(606927, 128, '2014-04-01 00:41:55.000000', 'consum', 0.0216, 'lps'),
	(606928, 128, '2014-04-01 00:41:56.000000', 'consum', 0.0211, 'lps'),
	(606929, 128, '2014-04-01 00:41:57.000000', 'consum', 0.0217, 'lps'),
	(606930, 128, '2014-04-01 00:41:58.000000', 'consum', 0.0214, 'lps'),
	(606931, 128, '2014-04-01 00:41:59.000000', 'consum', 0.0218, 'lps'),
	(606932, 128, '2014-04-01 00:42:00.000000', 'consum', 0.0218, 'lps'),
	(606933, 128, '2014-04-01 00:42:01.000000', 'consum', 0.0219, 'lps'),
	(606934, 128, '2014-04-01 00:42:02.000000', 'consum', 0.0210, 'lps'),
	(606935, 128, '2014-04-01 00:42:03.000000', 'consum', 0.0214, 'lps'),
	(606936, 128, '2014-04-01 00:42:04.000000', 'consum', 0.0219, 'lps'),
	(606937, 128, '2014-04-01 00:42:05.000000', 'consum', 0.0212, 'lps'),
	(606938, 128, '2014-04-01 00:42:06.000000', 'consum', 0.0217, 'lps'),
	(606939, 128, '2014-04-01 00:42:07.000000', 'consum', 0.0217, 'lps'),
	(606940, 128, '2014-04-01 00:42:08.000000', 'consum', 0.0215, 'lps'),
	(606941, 128, '2014-04-01 00:42:09.000000', 'consum', 0.0216, 'lps'),
	(606942, 128, '2014-04-01 00:42:10.000000', 'consum', 0.0213, 'lps'),
	(606943, 128, '2014-04-01 00:42:11.000000', 'consum', 0.0210, 'lps'),
	(606944, 128, '2014-04-01 00:42:12.000000', 'consum', 0.0211, 'lps'),
	(606945, 128, '2014-04-01 00:42:13.000000', 'consum', 0.0216, 'lps'),
	(606946, 128, '2014-04-01 00:42:14.000000', 'consum', 0.0215, 'lps'),
	(606947, 128, '2014-04-01 00:42:15.000000', 'consum', 0.0218, 'lps'),
	(606948, 128, '2014-04-01 00:42:16.000000', 'consum', 0.0217, 'lps'),
	(606949, 128, '2014-04-01 00:42:17.000000', 'consum', 0.0212, 'lps'),
	(606950, 128, '2014-04-01 00:42:18.000000', 'consum', 0.0218, 'lps'),
	(606951, 128, '2014-04-01 00:42:19.000000', 'consum', 0.0213, 'lps'),
	(606952, 128, '2014-04-01 00:42:20.000000', 'consum', 0.0215, 'lps'),
	(606953, 128, '2014-04-01 00:42:21.000000', 'consum', 0.0215, 'lps'),
	(606954, 128, '2014-04-01 00:42:22.000000', 'consum', 0.0210, 'lps'),
	(606955, 128, '2014-04-01 00:42:23.000000', 'consum', 0.0214, 'lps'),
	(606956, 128, '2014-04-01 00:42:24.000000', 'consum', 0.0212, 'lps'),
	(606957, 128, '2014-04-01 00:42:25.000000', 'consum', 0.0218, 'lps'),
	(606958, 128, '2014-04-01 00:42:26.000000', 'consum', 0.0215, 'lps'),
	(606959, 128, '2014-04-01 00:42:27.000000', 'consum', 0.0212, 'lps'),
	(606960, 128, '2014-04-01 00:42:28.000000', 'consum', 0.0215, 'lps'),
	(606961, 128, '2014-04-01 00:42:29.000000', 'consum', 0.0217, 'lps'),
	(606962, 128, '2014-04-01 00:42:30.000000', 'consum', 0.0214, 'lps'),
	(606963, 128, '2014-04-01 00:42:31.000000', 'consum', 0.0219, 'lps'),
	(606964, 128, '2014-04-01 00:42:32.000000', 'consum', 0.0213, 'lps'),
	(606965, 128, '2014-04-01 00:42:33.000000', 'consum', 0.0218, 'lps'),
	(606966, 128, '2014-04-01 00:42:34.000000', 'consum', 0.0214, 'lps'),
	(606967, 128, '2014-04-01 00:42:35.000000', 'consum', 0.0214, 'lps'),
	(606968, 128, '2014-04-01 00:42:36.000000', 'consum', 0.0217, 'lps'),
	(606969, 128, '2014-04-01 00:42:37.000000', 'consum', 0.0216, 'lps'),
	(606970, 128, '2014-04-01 00:42:38.000000', 'consum', 0.0210, 'lps'),
	(606971, 128, '2014-04-01 00:42:39.000000', 'consum', 0.0211, 'lps'),
	(606972, 128, '2014-04-01 00:42:40.000000', 'consum', 0.0217, 'lps'),
	(606973, 128, '2014-04-01 00:42:41.000000', 'consum', 0.0214, 'lps'),
	(606974, 128, '2014-04-01 00:42:42.000000', 'consum', 0.0218, 'lps'),
	(606975, 128, '2014-04-01 00:42:43.000000', 'consum', 0.0217, 'lps'),
	(606976, 128, '2014-04-01 00:42:44.000000', 'consum', 0.0213, 'lps'),
	(606977, 128, '2014-04-01 00:42:45.000000', 'consum', 0.0213, 'lps'),
	(606978, 128, '2014-04-01 00:42:46.000000', 'consum', 0.0217, 'lps'),
	(606979, 128, '2014-04-01 00:42:47.000000', 'consum', 0.0215, 'lps'),
	(606980, 128, '2014-04-01 00:42:48.000000', 'consum', 0.0217, 'lps'),
	(606981, 128, '2014-04-01 00:42:49.000000', 'consum', 0.0211, 'lps'),
	(606982, 128, '2014-04-01 00:42:50.000000', 'consum', 0.0214, 'lps'),
	(606983, 128, '2014-04-01 00:42:51.000000', 'consum', 0.0216, 'lps'),
	(606984, 128, '2014-04-01 00:42:52.000000', 'consum', 0.0211, 'lps'),
	(606985, 128, '2014-04-01 00:42:53.000000', 'consum', 0.0217, 'lps'),
	(606986, 128, '2014-04-01 00:42:54.000000', 'consum', 0.0214, 'lps'),
	(606987, 128, '2014-04-01 00:42:55.000000', 'consum', 0.0218, 'lps'),
	(606988, 128, '2014-04-01 00:42:56.000000', 'consum', 0.0210, 'lps'),
	(606989, 128, '2014-04-01 00:42:57.000000', 'consum', 0.0214, 'lps'),
	(606990, 128, '2014-04-01 00:42:58.000000', 'consum', 0.0211, 'lps'),
	(606991, 128, '2014-04-01 00:42:59.000000', 'consum', 0.0214, 'lps'),
	(606992, 128, '2014-04-01 00:43:00.000000', 'consum', 0.0215, 'lps'),
	(606993, 128, '2014-04-01 00:43:01.000000', 'consum', 0.0217, 'lps'),
	(606994, 128, '2014-04-01 00:43:02.000000', 'consum', 0.0217, 'lps'),
	(606995, 128, '2014-04-01 00:43:03.000000', 'consum', 0.0218, 'lps'),
	(606996, 128, '2014-04-01 00:43:04.000000', 'consum', 0.0217, 'lps'),
	(606997, 128, '2014-04-01 00:43:05.000000', 'consum', 0.0211, 'lps'),
	(606998, 128, '2014-04-01 00:43:06.000000', 'consum', 0.0215, 'lps'),
	(606999, 128, '2014-04-01 00:43:07.000000', 'consum', 0.0214, 'lps'),
	(607000, 128, '2014-04-01 00:43:08.000000', 'consum', 0.0214, 'lps'),
	(607001, 128, '2014-04-01 00:43:09.000000', 'consum', 0.0211, 'lps'),
	(607002, 128, '2014-04-01 00:43:10.000000', 'consum', 0.0212, 'lps'),
	(607003, 128, '2014-04-01 00:43:11.000000', 'consum', 0.0210, 'lps'),
	(607004, 128, '2014-04-01 00:43:12.000000', 'consum', 0.0211, 'lps'),
	(607005, 128, '2014-04-01 00:43:13.000000', 'consum', 0.0216, 'lps'),
	(607006, 128, '2014-04-01 00:43:14.000000', 'consum', 0.0218, 'lps'),
	(607007, 128, '2014-04-01 00:43:15.000000', 'consum', 0.0212, 'lps'),
	(607008, 128, '2014-04-01 00:43:16.000000', 'consum', 0.0217, 'lps'),
	(607009, 128, '2014-04-01 00:43:17.000000', 'consum', 0.0218, 'lps'),
	(607010, 128, '2014-04-01 00:43:18.000000', 'consum', 0.0219, 'lps'),
	(607011, 128, '2014-04-01 00:43:19.000000', 'consum', 0.0214, 'lps'),
	(607012, 128, '2014-04-01 00:43:20.000000', 'consum', 0.0214, 'lps'),
	(607013, 128, '2014-04-01 00:43:21.000000', 'consum', 0.0215, 'lps'),
	(607014, 128, '2014-04-01 00:43:22.000000', 'consum', 0.0217, 'lps'),
	(607015, 128, '2014-04-01 00:43:23.000000', 'consum', 0.0210, 'lps'),
	(607016, 128, '2014-04-01 00:43:24.000000', 'consum', 0.0219, 'lps'),
	(607017, 128, '2014-04-01 00:43:25.000000', 'consum', 0.0216, 'lps'),
	(607018, 128, '2014-04-01 00:43:26.000000', 'consum', 0.0215, 'lps'),
	(607019, 128, '2014-04-01 00:43:27.000000', 'consum', 0.0216, 'lps'),
	(607020, 128, '2014-04-01 00:43:28.000000', 'consum', 0.0215, 'lps'),
	(607021, 128, '2014-04-01 00:43:29.000000', 'consum', 0.0216, 'lps'),
	(607022, 128, '2014-04-01 00:43:30.000000', 'consum', 0.0218, 'lps'),
	(607023, 128, '2014-04-01 00:43:31.000000', 'consum', 0.0213, 'lps'),
	(607024, 128, '2014-04-01 00:43:32.000000', 'consum', 0.0212, 'lps'),
	(607025, 128, '2014-04-01 00:43:33.000000', 'consum', 0.0212, 'lps'),
	(607026, 128, '2014-04-01 00:43:34.000000', 'consum', 0.0215, 'lps'),
	(607027, 128, '2014-04-01 00:43:35.000000', 'consum', 0.0218, 'lps'),
	(607028, 128, '2014-04-01 00:43:36.000000', 'consum', 0.0214, 'lps'),
	(607029, 128, '2014-04-01 00:43:37.000000', 'consum', 0.0219, 'lps'),
	(607030, 128, '2014-04-01 00:43:38.000000', 'consum', 0.0214, 'lps'),
	(607031, 128, '2014-04-01 00:43:39.000000', 'consum', 0.0212, 'lps'),
	(607032, 128, '2014-04-01 00:43:40.000000', 'consum', 0.0217, 'lps'),
	(607033, 128, '2014-04-01 00:43:41.000000', 'consum', 0.0210, 'lps'),
	(607034, 128, '2014-04-01 00:43:42.000000', 'consum', 0.0210, 'lps'),
	(607035, 128, '2014-04-01 00:43:43.000000', 'consum', 0.0213, 'lps'),
	(607036, 128, '2014-04-01 00:43:44.000000', 'consum', 0.0212, 'lps'),
	(607037, 128, '2014-04-01 00:43:45.000000', 'consum', 0.0212, 'lps'),
	(607038, 128, '2014-04-01 00:43:46.000000', 'consum', 0.0215, 'lps'),
	(607039, 128, '2014-04-01 00:43:47.000000', 'consum', 0.0211, 'lps'),
	(607040, 128, '2014-04-01 00:43:48.000000', 'consum', 0.0210, 'lps'),
	(607041, 128, '2014-04-01 00:43:49.000000', 'consum', 0.0216, 'lps'),
	(607042, 128, '2014-04-01 00:43:50.000000', 'consum', 0.0211, 'lps'),
	(607043, 128, '2014-04-01 00:43:51.000000', 'consum', 0.0216, 'lps'),
	(607044, 128, '2014-04-01 00:43:52.000000', 'consum', 0.0211, 'lps'),
	(607045, 128, '2014-04-01 00:43:53.000000', 'consum', 0.0214, 'lps'),
	(607046, 128, '2014-04-01 00:43:54.000000', 'consum', 0.0219, 'lps'),
	(607047, 128, '2014-04-01 00:43:55.000000', 'consum', 0.0213, 'lps'),
	(607048, 128, '2014-04-01 00:43:56.000000', 'consum', 0.0219, 'lps'),
	(607049, 128, '2014-04-01 00:43:57.000000', 'consum', 0.0216, 'lps'),
	(607050, 128, '2014-04-01 00:43:58.000000', 'consum', 0.0212, 'lps'),
	(607051, 128, '2014-04-01 00:43:59.000000', 'consum', 0.0213, 'lps'),
	(607052, 128, '2014-04-01 00:44:00.000000', 'consum', 0.0211, 'lps'),
	(607053, 128, '2014-04-01 00:44:01.000000', 'consum', 0.0216, 'lps'),
	(607054, 128, '2014-04-01 00:44:02.000000', 'consum', 0.0217, 'lps'),
	(607055, 128, '2014-04-01 00:44:03.000000', 'consum', 0.0219, 'lps'),
	(607056, 128, '2014-04-01 00:44:04.000000', 'consum', 0.0215, 'lps'),
	(607057, 128, '2014-04-01 00:44:05.000000', 'consum', 0.0218, 'lps'),
	(607058, 128, '2014-04-01 00:44:06.000000', 'consum', 0.0216, 'lps'),
	(607059, 128, '2014-04-01 00:44:07.000000', 'consum', 0.0215, 'lps'),
	(607060, 128, '2014-04-01 00:44:08.000000', 'consum', 0.0216, 'lps'),
	(607061, 128, '2014-04-01 00:44:09.000000', 'consum', 0.0219, 'lps'),
	(607062, 128, '2014-04-01 00:44:10.000000', 'consum', 0.0216, 'lps'),
	(607063, 128, '2014-04-01 00:44:11.000000', 'consum', 0.0213, 'lps'),
	(607064, 128, '2014-04-01 00:44:12.000000', 'consum', 0.0210, 'lps'),
	(607065, 128, '2014-04-01 00:44:13.000000', 'consum', 0.0219, 'lps'),
	(607066, 128, '2014-04-01 00:44:14.000000', 'consum', 0.0215, 'lps'),
	(607067, 128, '2014-04-01 00:44:15.000000', 'consum', 0.0211, 'lps'),
	(607068, 128, '2014-04-01 00:44:16.000000', 'consum', 0.0210, 'lps'),
	(607069, 128, '2014-04-01 00:44:17.000000', 'consum', 0.0216, 'lps'),
	(607070, 128, '2014-04-01 00:44:18.000000', 'consum', 0.0219, 'lps'),
	(607071, 128, '2014-04-01 00:44:19.000000', 'consum', 0.0211, 'lps'),
	(607072, 128, '2014-04-01 00:44:20.000000', 'consum', 0.0216, 'lps'),
	(607073, 128, '2014-04-01 00:44:21.000000', 'consum', 0.0218, 'lps'),
	(607074, 128, '2014-04-01 00:44:22.000000', 'consum', 0.0213, 'lps'),
	(607075, 128, '2014-04-01 00:44:23.000000', 'consum', 0.0212, 'lps'),
	(607076, 128, '2014-04-01 00:44:24.000000', 'consum', 0.0210, 'lps'),
	(607077, 128, '2014-04-01 00:44:25.000000', 'consum', 0.0217, 'lps'),
	(607078, 128, '2014-04-01 00:44:26.000000', 'consum', 0.0213, 'lps'),
	(607079, 128, '2014-04-01 00:44:27.000000', 'consum', 0.0214, 'lps'),
	(607080, 128, '2014-04-01 00:44:28.000000', 'consum', 0.0211, 'lps'),
	(607081, 128, '2014-04-01 00:44:29.000000', 'consum', 0.0215, 'lps'),
	(607082, 128, '2014-04-01 00:44:30.000000', 'consum', 0.0213, 'lps'),
	(607083, 128, '2014-04-01 00:44:31.000000', 'consum', 0.0219, 'lps'),
	(607084, 128, '2014-04-01 00:44:32.000000', 'consum', 0.0216, 'lps'),
	(607085, 128, '2014-04-01 00:44:33.000000', 'consum', 0.0215, 'lps'),
	(607086, 128, '2014-04-01 00:44:34.000000', 'consum', 0.0217, 'lps'),
	(607087, 128, '2014-04-01 00:44:35.000000', 'consum', 0.0210, 'lps'),
	(607088, 128, '2014-04-01 00:44:36.000000', 'consum', 0.0218, 'lps'),
	(607089, 128, '2014-04-01 00:44:37.000000', 'consum', 0.0214, 'lps'),
	(607090, 128, '2014-04-01 00:44:38.000000', 'consum', 0.0214, 'lps'),
	(607091, 128, '2014-04-01 00:44:39.000000', 'consum', 0.0210, 'lps'),
	(607092, 128, '2014-04-01 00:44:40.000000', 'consum', 0.0210, 'lps'),
	(607093, 128, '2014-04-01 00:44:41.000000', 'consum', 0.0219, 'lps'),
	(607094, 128, '2014-04-01 00:44:42.000000', 'consum', 0.0216, 'lps'),
	(607095, 128, '2014-04-01 00:44:43.000000', 'consum', 0.0214, 'lps'),
	(607096, 128, '2014-04-01 00:44:44.000000', 'consum', 0.0212, 'lps'),
	(607097, 128, '2014-04-01 00:44:45.000000', 'consum', 0.0210, 'lps'),
	(607098, 128, '2014-04-01 00:44:46.000000', 'consum', 0.0214, 'lps'),
	(607099, 128, '2014-04-01 00:44:47.000000', 'consum', 0.0219, 'lps'),
	(607100, 128, '2014-04-01 00:44:48.000000', 'consum', 0.0213, 'lps'),
	(607101, 128, '2014-04-01 00:44:49.000000', 'consum', 0.0212, 'lps'),
	(607102, 128, '2014-04-01 00:44:50.000000', 'consum', 0.0218, 'lps'),
	(607103, 128, '2014-04-01 00:44:51.000000', 'consum', 0.0214, 'lps'),
	(607104, 128, '2014-04-01 00:44:52.000000', 'consum', 0.0217, 'lps'),
	(607105, 128, '2014-04-01 00:44:53.000000', 'consum', 0.0213, 'lps'),
	(607106, 128, '2014-04-01 00:44:54.000000', 'consum', 0.0214, 'lps'),
	(607107, 128, '2014-04-01 00:44:55.000000', 'consum', 0.0213, 'lps'),
	(607108, 128, '2014-04-01 00:44:56.000000', 'consum', 0.0212, 'lps'),
	(607109, 128, '2014-04-01 00:44:57.000000', 'consum', 0.0211, 'lps'),
	(607110, 128, '2014-04-01 00:44:58.000000', 'consum', 0.0218, 'lps'),
	(607111, 128, '2014-04-01 00:44:59.000000', 'consum', 0.0211, 'lps'),
	(607112, 128, '2014-04-01 00:45:00.000000', 'consum', 0.0210, 'lps'),
	(607113, 128, '2014-04-01 00:45:01.000000', 'consum', 0.0217, 'lps'),
	(607114, 128, '2014-04-01 00:45:02.000000', 'consum', 0.0218, 'lps'),
	(607115, 128, '2014-04-01 00:45:03.000000', 'consum', 0.0217, 'lps'),
	(607116, 128, '2014-04-01 00:45:04.000000', 'consum', 0.0212, 'lps'),
	(607117, 128, '2014-04-01 00:45:05.000000', 'consum', 0.0210, 'lps'),
	(607118, 128, '2014-04-01 00:45:06.000000', 'consum', 0.0214, 'lps'),
	(607119, 128, '2014-04-01 00:45:07.000000', 'consum', 0.0211, 'lps'),
	(607120, 128, '2014-04-01 00:45:08.000000', 'consum', 0.0214, 'lps'),
	(607121, 128, '2014-04-01 00:45:09.000000', 'consum', 0.0216, 'lps'),
	(607122, 128, '2014-04-01 00:45:10.000000', 'consum', 0.0211, 'lps'),
	(607123, 128, '2014-04-01 00:45:11.000000', 'consum', 0.0218, 'lps'),
	(607124, 128, '2014-04-01 00:45:12.000000', 'consum', 0.0214, 'lps'),
	(607125, 128, '2014-04-01 00:45:13.000000', 'consum', 0.0219, 'lps'),
	(607126, 128, '2014-04-01 00:45:14.000000', 'consum', 0.0212, 'lps'),
	(607127, 128, '2014-04-01 00:45:15.000000', 'consum', 0.0216, 'lps'),
	(607128, 128, '2014-04-01 00:45:16.000000', 'consum', 0.0211, 'lps'),
	(607129, 128, '2014-04-01 00:45:17.000000', 'consum', 0.0210, 'lps'),
	(607130, 128, '2014-04-01 00:45:18.000000', 'consum', 0.0217, 'lps'),
	(607131, 128, '2014-04-01 00:45:19.000000', 'consum', 0.0214, 'lps'),
	(607132, 128, '2014-04-01 00:45:20.000000', 'consum', 0.0219, 'lps'),
	(607133, 128, '2014-04-01 00:45:21.000000', 'consum', 0.0213, 'lps'),
	(607134, 128, '2014-04-01 00:45:22.000000', 'consum', 0.0211, 'lps'),
	(607135, 128, '2014-04-01 00:45:23.000000', 'consum', 0.0214, 'lps'),
	(607136, 128, '2014-04-01 00:45:24.000000', 'consum', 0.0217, 'lps'),
	(607137, 128, '2014-04-01 00:45:25.000000', 'consum', 0.0215, 'lps'),
	(607138, 128, '2014-04-01 00:45:26.000000', 'consum', 0.0212, 'lps'),
	(607139, 128, '2014-04-01 00:45:27.000000', 'consum', 0.0219, 'lps'),
	(607140, 128, '2014-04-01 00:45:28.000000', 'consum', 0.0217, 'lps'),
	(607141, 128, '2014-04-01 00:45:29.000000', 'consum', 0.0211, 'lps'),
	(607142, 128, '2014-04-01 00:45:30.000000', 'consum', 0.0213, 'lps'),
	(607143, 128, '2014-04-01 00:45:31.000000', 'consum', 0.0212, 'lps'),
	(607144, 128, '2014-04-01 00:45:32.000000', 'consum', 0.0211, 'lps'),
	(607145, 128, '2014-04-01 00:45:33.000000', 'consum', 0.0210, 'lps'),
	(607146, 128, '2014-04-01 00:45:34.000000', 'consum', 0.0217, 'lps'),
	(607147, 128, '2014-04-01 00:45:35.000000', 'consum', 0.0214, 'lps'),
	(607148, 128, '2014-04-01 00:45:36.000000', 'consum', 0.0212, 'lps'),
	(607149, 128, '2014-04-01 00:45:37.000000', 'consum', 0.0218, 'lps'),
	(607150, 128, '2014-04-01 00:45:38.000000', 'consum', 0.0213, 'lps'),
	(607151, 128, '2014-04-01 00:45:39.000000', 'consum', 0.0212, 'lps'),
	(607152, 128, '2014-04-01 00:45:40.000000', 'consum', 0.0214, 'lps'),
	(607153, 128, '2014-04-01 00:45:41.000000', 'consum', 0.0211, 'lps'),
	(607154, 128, '2014-04-01 00:45:42.000000', 'consum', 0.0215, 'lps'),
	(607155, 128, '2014-04-01 00:45:43.000000', 'consum', 0.0213, 'lps'),
	(607156, 128, '2014-04-01 00:45:44.000000', 'consum', 0.0219, 'lps'),
	(607157, 128, '2014-04-01 00:45:45.000000', 'consum', 0.0216, 'lps'),
	(607158, 128, '2014-04-01 00:45:46.000000', 'consum', 0.0214, 'lps'),
	(607159, 128, '2014-04-01 00:45:47.000000', 'consum', 0.0214, 'lps'),
	(607160, 128, '2014-04-01 00:45:48.000000', 'consum', 0.0217, 'lps'),
	(607161, 128, '2014-04-01 00:45:49.000000', 'consum', 0.0214, 'lps'),
	(607162, 128, '2014-04-01 00:45:50.000000', 'consum', 0.0218, 'lps'),
	(607163, 128, '2014-04-01 00:45:51.000000', 'consum', 0.0218, 'lps'),
	(607164, 128, '2014-04-01 00:45:52.000000', 'consum', 0.0216, 'lps'),
	(607165, 128, '2014-04-01 00:45:53.000000', 'consum', 0.0217, 'lps'),
	(607166, 128, '2014-04-01 00:45:54.000000', 'consum', 0.0219, 'lps'),
	(607167, 128, '2014-04-01 00:45:55.000000', 'consum', 0.0212, 'lps'),
	(607168, 128, '2014-04-01 00:45:56.000000', 'consum', 0.0215, 'lps'),
	(607169, 128, '2014-04-01 00:45:57.000000', 'consum', 0.0218, 'lps'),
	(607170, 128, '2014-04-01 00:45:58.000000', 'consum', 0.0215, 'lps'),
	(607171, 128, '2014-04-01 00:45:59.000000', 'consum', 0.0211, 'lps'),
	(607172, 128, '2014-04-01 00:46:00.000000', 'consum', 0.0213, 'lps'),
	(607173, 128, '2014-04-01 00:46:01.000000', 'consum', 0.0219, 'lps'),
	(607174, 128, '2014-04-01 00:46:02.000000', 'consum', 0.0210, 'lps'),
	(607175, 128, '2014-04-01 00:46:03.000000', 'consum', 0.0211, 'lps'),
	(607176, 128, '2014-04-01 00:46:04.000000', 'consum', 0.0216, 'lps'),
	(607177, 128, '2014-04-01 00:46:05.000000', 'consum', 0.0219, 'lps'),
	(607178, 128, '2014-04-01 00:46:06.000000', 'consum', 0.0215, 'lps'),
	(607179, 128, '2014-04-01 00:46:07.000000', 'consum', 0.0212, 'lps'),
	(607180, 128, '2014-04-01 00:46:08.000000', 'consum', 0.0213, 'lps'),
	(607181, 128, '2014-04-01 00:46:09.000000', 'consum', 0.0219, 'lps'),
	(607182, 128, '2014-04-01 00:46:10.000000', 'consum', 0.0217, 'lps'),
	(607183, 128, '2014-04-01 00:46:11.000000', 'consum', 0.0218, 'lps'),
	(607184, 128, '2014-04-01 00:46:12.000000', 'consum', 0.0218, 'lps'),
	(607185, 128, '2014-04-01 00:46:13.000000', 'consum', 0.0219, 'lps'),
	(607186, 128, '2014-04-01 00:46:14.000000', 'consum', 0.0211, 'lps'),
	(607187, 128, '2014-04-01 00:46:15.000000', 'consum', 0.0219, 'lps'),
	(607188, 128, '2014-04-01 00:46:16.000000', 'consum', 0.0211, 'lps'),
	(607189, 128, '2014-04-01 00:46:17.000000', 'consum', 0.0210, 'lps'),
	(607190, 128, '2014-04-01 00:46:18.000000', 'consum', 0.0217, 'lps'),
	(607191, 128, '2014-04-01 00:46:19.000000', 'consum', 0.0214, 'lps'),
	(607192, 128, '2014-04-01 00:46:20.000000', 'consum', 0.0219, 'lps'),
	(607193, 128, '2014-04-01 00:46:21.000000', 'consum', 0.0213, 'lps'),
	(607194, 128, '2014-04-01 00:46:22.000000', 'consum', 0.0211, 'lps'),
	(607195, 128, '2014-04-01 00:46:23.000000', 'consum', 0.0214, 'lps'),
	(607196, 128, '2014-04-01 00:46:24.000000', 'consum', 0.0218, 'lps'),
	(607197, 128, '2014-04-01 00:46:25.000000', 'consum', 0.0218, 'lps'),
	(607198, 128, '2014-04-01 00:46:26.000000', 'consum', 0.0216, 'lps'),
	(607199, 128, '2014-04-01 00:46:27.000000', 'consum', 0.0217, 'lps'),
	(607200, 128, '2014-04-01 00:46:28.000000', 'consum', 0.0216, 'lps'),
	(607201, 128, '2014-04-01 00:46:29.000000', 'consum', 0.0219, 'lps'),
	(607202, 128, '2014-04-01 00:46:30.000000', 'consum', 0.0211, 'lps'),
	(607203, 128, '2014-04-01 00:46:31.000000', 'consum', 0.0216, 'lps'),
	(607204, 128, '2014-04-01 00:46:32.000000', 'consum', 0.0216, 'lps'),
	(607205, 128, '2014-04-01 00:46:33.000000', 'consum', 0.0216, 'lps'),
	(607206, 128, '2014-04-01 00:46:34.000000', 'consum', 0.0219, 'lps'),
	(607207, 128, '2014-04-01 00:46:35.000000', 'consum', 0.0211, 'lps'),
	(607208, 128, '2014-04-01 00:46:36.000000', 'consum', 0.0218, 'lps'),
	(607209, 128, '2014-04-01 00:46:37.000000', 'consum', 0.0215, 'lps'),
	(607210, 128, '2014-04-01 00:46:38.000000', 'consum', 0.0212, 'lps'),
	(607211, 128, '2014-04-01 00:46:39.000000', 'consum', 0.0215, 'lps'),
	(607212, 128, '2014-04-01 00:46:40.000000', 'consum', 0.0219, 'lps'),
	(607213, 128, '2014-04-01 00:46:41.000000', 'consum', 0.0213, 'lps'),
	(607214, 128, '2014-04-01 00:46:42.000000', 'consum', 0.0216, 'lps'),
	(607215, 128, '2014-04-01 00:46:43.000000', 'consum', 0.0212, 'lps'),
	(607216, 128, '2014-04-01 00:46:44.000000', 'consum', 0.0214, 'lps'),
	(607217, 128, '2014-04-01 00:46:45.000000', 'consum', 0.0214, 'lps'),
	(607218, 128, '2014-04-01 00:46:46.000000', 'consum', 0.0210, 'lps'),
	(607219, 128, '2014-04-01 00:46:47.000000', 'consum', 0.0217, 'lps'),
	(607220, 128, '2014-04-01 00:46:48.000000', 'consum', 0.0216, 'lps'),
	(607221, 128, '2014-04-01 00:46:49.000000', 'consum', 0.0211, 'lps'),
	(607222, 128, '2014-04-01 00:46:50.000000', 'consum', 0.0218, 'lps'),
	(607223, 128, '2014-04-01 00:46:51.000000', 'consum', 0.0216, 'lps'),
	(607224, 128, '2014-04-01 00:46:52.000000', 'consum', 0.0218, 'lps'),
	(607225, 128, '2014-04-01 00:46:53.000000', 'consum', 0.0213, 'lps'),
	(607226, 128, '2014-04-01 00:46:54.000000', 'consum', 0.0219, 'lps'),
	(607227, 128, '2014-04-01 00:46:55.000000', 'consum', 0.0216, 'lps'),
	(607228, 128, '2014-04-01 00:46:56.000000', 'consum', 0.0213, 'lps'),
	(607229, 128, '2014-04-01 00:46:57.000000', 'consum', 0.0219, 'lps'),
	(607230, 128, '2014-04-01 00:46:58.000000', 'consum', 0.0216, 'lps'),
	(607231, 128, '2014-04-01 00:46:59.000000', 'consum', 0.0213, 'lps'),
	(607232, 128, '2014-04-01 00:47:00.000000', 'consum', 0.0218, 'lps'),
	(607233, 128, '2014-04-01 00:47:01.000000', 'consum', 0.0211, 'lps'),
	(607234, 128, '2014-04-01 00:47:02.000000', 'consum', 0.0213, 'lps'),
	(607235, 128, '2014-04-01 00:47:03.000000', 'consum', 0.0213, 'lps'),
	(607236, 128, '2014-04-01 00:47:04.000000', 'consum', 0.0217, 'lps'),
	(607237, 128, '2014-04-01 00:47:05.000000', 'consum', 0.0215, 'lps'),
	(607238, 128, '2014-04-01 00:47:06.000000', 'consum', 0.0214, 'lps'),
	(607239, 128, '2014-04-01 00:47:07.000000', 'consum', 0.0217, 'lps'),
	(607240, 128, '2014-04-01 00:47:08.000000', 'consum', 0.0214, 'lps'),
	(607241, 128, '2014-04-01 00:47:09.000000', 'consum', 0.0218, 'lps'),
	(607242, 128, '2014-04-01 00:47:10.000000', 'consum', 0.0218, 'lps'),
	(607243, 128, '2014-04-01 00:47:11.000000', 'consum', 0.0217, 'lps'),
	(607244, 128, '2014-04-01 00:47:12.000000', 'consum', 0.0210, 'lps'),
	(607245, 128, '2014-04-01 00:47:13.000000', 'consum', 0.0212, 'lps'),
	(607246, 128, '2014-04-01 00:47:14.000000', 'consum', 0.0210, 'lps'),
	(607247, 128, '2014-04-01 00:47:15.000000', 'consum', 0.0215, 'lps'),
	(607248, 128, '2014-04-01 00:47:16.000000', 'consum', 0.0216, 'lps'),
	(607249, 128, '2014-04-01 00:47:17.000000', 'consum', 0.0213, 'lps'),
	(607250, 128, '2014-04-01 00:47:18.000000', 'consum', 0.0219, 'lps'),
	(607251, 128, '2014-04-01 00:47:19.000000', 'consum', 0.0216, 'lps'),
	(607252, 128, '2014-04-01 00:47:20.000000', 'consum', 0.0215, 'lps'),
	(607253, 128, '2014-04-01 00:47:21.000000', 'consum', 0.0216, 'lps'),
	(607254, 128, '2014-04-01 00:47:22.000000', 'consum', 0.0215, 'lps'),
	(607255, 128, '2014-04-01 00:47:23.000000', 'consum', 0.0217, 'lps'),
	(607256, 128, '2014-04-01 00:47:24.000000', 'consum', 0.0213, 'lps'),
	(607257, 128, '2014-04-01 00:47:25.000000', 'consum', 0.0215, 'lps'),
	(607258, 128, '2014-04-01 00:47:26.000000', 'consum', 0.0216, 'lps'),
	(607259, 128, '2014-04-01 00:47:27.000000', 'consum', 0.0216, 'lps'),
	(607260, 128, '2014-04-01 00:47:28.000000', 'consum', 0.0210, 'lps'),
	(607261, 128, '2014-04-01 00:47:29.000000', 'consum', 0.0212, 'lps'),
	(607262, 128, '2014-04-01 00:47:30.000000', 'consum', 0.0213, 'lps'),
	(607263, 128, '2014-04-01 00:47:31.000000', 'consum', 0.0210, 'lps'),
	(607264, 128, '2014-04-01 00:47:32.000000', 'consum', 0.0219, 'lps'),
	(607265, 128, '2014-04-01 00:47:33.000000', 'consum', 0.0219, 'lps'),
	(607266, 128, '2014-04-01 00:47:34.000000', 'consum', 0.0215, 'lps'),
	(607267, 128, '2014-04-01 00:47:35.000000', 'consum', 0.0219, 'lps'),
	(607268, 128, '2014-04-01 00:47:36.000000', 'consum', 0.0212, 'lps'),
	(607269, 128, '2014-04-01 00:47:37.000000', 'consum', 0.0214, 'lps'),
	(607270, 128, '2014-04-01 00:47:38.000000', 'consum', 0.0216, 'lps'),
	(607271, 128, '2014-04-01 00:47:39.000000', 'consum', 0.0216, 'lps'),
	(607272, 128, '2014-04-01 00:47:40.000000', 'consum', 0.0213, 'lps'),
	(607273, 128, '2014-04-01 00:47:41.000000', 'consum', 0.0216, 'lps'),
	(607274, 128, '2014-04-01 00:47:42.000000', 'consum', 0.0212, 'lps'),
	(607275, 128, '2014-04-01 00:47:43.000000', 'consum', 0.0211, 'lps'),
	(607276, 128, '2014-04-01 00:47:44.000000', 'consum', 0.0213, 'lps'),
	(607277, 128, '2014-04-01 00:47:45.000000', 'consum', 0.0219, 'lps'),
	(607278, 128, '2014-04-01 00:47:46.000000', 'consum', 0.0219, 'lps'),
	(607279, 128, '2014-04-01 00:47:47.000000', 'consum', 0.0216, 'lps'),
	(607280, 128, '2014-04-01 00:47:48.000000', 'consum', 0.0216, 'lps'),
	(607281, 128, '2014-04-01 00:47:49.000000', 'consum', 0.0212, 'lps'),
	(607282, 128, '2014-04-01 00:47:50.000000', 'consum', 0.0214, 'lps'),
	(607283, 128, '2014-04-01 00:47:51.000000', 'consum', 0.0214, 'lps'),
	(607284, 128, '2014-04-01 00:47:52.000000', 'consum', 0.0219, 'lps'),
	(607285, 128, '2014-04-01 00:47:53.000000', 'consum', 0.0214, 'lps'),
	(607286, 128, '2014-04-01 00:47:54.000000', 'consum', 0.0213, 'lps'),
	(607287, 128, '2014-04-01 00:47:55.000000', 'consum', 0.0214, 'lps'),
	(607288, 128, '2014-04-01 00:47:56.000000', 'consum', 0.0212, 'lps'),
	(607289, 128, '2014-04-01 00:47:57.000000', 'consum', 0.0218, 'lps'),
	(607290, 128, '2014-04-01 00:47:58.000000', 'consum', 0.0215, 'lps'),
	(607291, 128, '2014-04-01 00:47:59.000000', 'consum', 0.0219, 'lps'),
	(607292, 128, '2014-04-01 00:48:00.000000', 'consum', 0.0212, 'lps'),
	(607293, 128, '2014-04-01 00:48:01.000000', 'consum', 0.0215, 'lps'),
	(607294, 128, '2014-04-01 00:48:02.000000', 'consum', 0.0216, 'lps'),
	(607295, 128, '2014-04-01 00:48:03.000000', 'consum', 0.0218, 'lps'),
	(607296, 128, '2014-04-01 00:48:04.000000', 'consum', 0.0214, 'lps'),
	(607297, 128, '2014-04-01 00:48:05.000000', 'consum', 0.0215, 'lps'),
	(607298, 128, '2014-04-01 00:48:06.000000', 'consum', 0.0214, 'lps'),
	(607299, 128, '2014-04-01 00:48:07.000000', 'consum', 0.0215, 'lps'),
	(607300, 128, '2014-04-01 00:48:08.000000', 'consum', 0.0215, 'lps'),
	(607301, 128, '2014-04-01 00:48:09.000000', 'consum', 0.0211, 'lps'),
	(607302, 128, '2014-04-01 00:48:10.000000', 'consum', 0.0217, 'lps'),
	(607303, 128, '2014-04-01 00:48:11.000000', 'consum', 0.0216, 'lps'),
	(607304, 128, '2014-04-01 00:48:12.000000', 'consum', 0.0210, 'lps'),
	(607305, 128, '2014-04-01 00:48:13.000000', 'consum', 0.0210, 'lps'),
	(607306, 128, '2014-04-01 00:48:14.000000', 'consum', 0.0211, 'lps'),
	(607307, 128, '2014-04-01 00:48:15.000000', 'consum', 0.0216, 'lps'),
	(607308, 128, '2014-04-01 00:48:16.000000', 'consum', 0.0216, 'lps'),
	(607309, 128, '2014-04-01 00:48:17.000000', 'consum', 0.0213, 'lps'),
	(607310, 128, '2014-04-01 00:48:18.000000', 'consum', 0.0216, 'lps'),
	(607311, 128, '2014-04-01 00:48:19.000000', 'consum', 0.0212, 'lps'),
	(607312, 128, '2014-04-01 00:48:20.000000', 'consum', 0.0212, 'lps'),
	(607313, 128, '2014-04-01 00:48:21.000000', 'consum', 0.0215, 'lps'),
	(607314, 128, '2014-04-01 00:48:22.000000', 'consum', 0.0210, 'lps'),
	(607315, 128, '2014-04-01 00:48:23.000000', 'consum', 0.0216, 'lps'),
	(607316, 128, '2014-04-01 00:48:24.000000', 'consum', 0.0210, 'lps'),
	(607317, 128, '2014-04-01 00:48:25.000000', 'consum', 0.0211, 'lps'),
	(607318, 128, '2014-04-01 00:48:26.000000', 'consum', 0.0216, 'lps'),
	(607319, 128, '2014-04-01 00:48:27.000000', 'consum', 0.0217, 'lps'),
	(607320, 128, '2014-04-01 00:48:28.000000', 'consum', 0.0210, 'lps'),
	(607321, 128, '2014-04-01 00:48:29.000000', 'consum', 0.0217, 'lps'),
	(607322, 128, '2014-04-01 00:48:30.000000', 'consum', 0.0218, 'lps'),
	(607323, 128, '2014-04-01 00:48:31.000000', 'consum', 0.0218, 'lps'),
	(607324, 128, '2014-04-01 00:48:32.000000', 'consum', 0.0218, 'lps'),
	(607325, 128, '2014-04-01 00:48:33.000000', 'consum', 0.0214, 'lps'),
	(607326, 128, '2014-04-01 00:48:34.000000', 'consum', 0.0219, 'lps'),
	(607327, 128, '2014-04-01 00:48:35.000000', 'consum', 0.0212, 'lps'),
	(607328, 128, '2014-04-01 00:48:36.000000', 'consum', 0.0214, 'lps'),
	(607329, 128, '2014-04-01 00:48:37.000000', 'consum', 0.0214, 'lps'),
	(607330, 128, '2014-04-01 00:48:38.000000', 'consum', 0.0219, 'lps'),
	(607331, 128, '2014-04-01 00:48:39.000000', 'consum', 0.0213, 'lps'),
	(607332, 128, '2014-04-01 00:48:40.000000', 'consum', 0.0219, 'lps'),
	(607333, 128, '2014-04-01 00:48:41.000000', 'consum', 0.0217, 'lps'),
	(607334, 128, '2014-04-01 00:48:42.000000', 'consum', 0.0218, 'lps'),
	(607335, 128, '2014-04-01 00:48:43.000000', 'consum', 0.0218, 'lps'),
	(607336, 128, '2014-04-01 00:48:44.000000', 'consum', 0.0217, 'lps'),
	(607337, 128, '2014-04-01 00:48:45.000000', 'consum', 0.0214, 'lps'),
	(607338, 128, '2014-04-01 00:48:46.000000', 'consum', 0.0218, 'lps'),
	(607339, 128, '2014-04-01 00:48:47.000000', 'consum', 0.0219, 'lps'),
	(607340, 128, '2014-04-01 00:48:48.000000', 'consum', 0.0210, 'lps'),
	(607341, 128, '2014-04-01 00:48:49.000000', 'consum', 0.0213, 'lps'),
	(607342, 128, '2014-04-01 00:48:50.000000', 'consum', 0.0218, 'lps'),
	(607343, 128, '2014-04-01 00:48:51.000000', 'consum', 0.0211, 'lps'),
	(607344, 128, '2014-04-01 00:48:52.000000', 'consum', 0.0210, 'lps'),
	(607345, 128, '2014-04-01 00:48:53.000000', 'consum', 0.0219, 'lps'),
	(607346, 128, '2014-04-01 00:48:54.000000', 'consum', 0.0217, 'lps'),
	(607347, 128, '2014-04-01 00:48:55.000000', 'consum', 0.0217, 'lps'),
	(607348, 128, '2014-04-01 00:48:56.000000', 'consum', 0.0213, 'lps'),
	(607349, 128, '2014-04-01 00:48:57.000000', 'consum', 0.0215, 'lps'),
	(607350, 128, '2014-04-01 00:48:58.000000', 'consum', 0.0217, 'lps'),
	(607351, 128, '2014-04-01 00:48:59.000000', 'consum', 0.0212, 'lps'),
	(607352, 128, '2014-04-01 00:49:00.000000', 'consum', 0.0217, 'lps'),
	(607353, 128, '2014-04-01 00:49:01.000000', 'consum', 0.0219, 'lps'),
	(607354, 128, '2014-04-01 00:49:02.000000', 'consum', 0.0216, 'lps'),
	(607355, 128, '2014-04-01 00:49:03.000000', 'consum', 0.0211, 'lps'),
	(607356, 128, '2014-04-01 00:49:04.000000', 'consum', 0.0210, 'lps'),
	(607357, 128, '2014-04-01 00:49:05.000000', 'consum', 0.0216, 'lps'),
	(607358, 128, '2014-04-01 00:49:06.000000', 'consum', 0.0211, 'lps'),
	(607359, 128, '2014-04-01 00:49:07.000000', 'consum', 0.0218, 'lps'),
	(607360, 128, '2014-04-01 00:49:08.000000', 'consum', 0.0216, 'lps'),
	(607361, 128, '2014-04-01 00:49:09.000000', 'consum', 0.0217, 'lps'),
	(607362, 128, '2014-04-01 00:49:10.000000', 'consum', 0.0217, 'lps'),
	(607363, 128, '2014-04-01 00:49:11.000000', 'consum', 0.0217, 'lps'),
	(607364, 128, '2014-04-01 00:49:12.000000', 'consum', 0.0212, 'lps'),
	(607365, 128, '2014-04-01 00:49:13.000000', 'consum', 0.0219, 'lps'),
	(607366, 128, '2014-04-01 00:49:14.000000', 'consum', 0.0210, 'lps'),
	(607367, 128, '2014-04-01 00:49:15.000000', 'consum', 0.0214, 'lps'),
	(607368, 128, '2014-04-01 00:49:16.000000', 'consum', 0.0210, 'lps'),
	(607369, 128, '2014-04-01 00:49:17.000000', 'consum', 0.0210, 'lps'),
	(607370, 128, '2014-04-01 00:49:18.000000', 'consum', 0.0218, 'lps'),
	(607371, 128, '2014-04-01 00:49:19.000000', 'consum', 0.0213, 'lps'),
	(607372, 128, '2014-04-01 00:49:20.000000', 'consum', 0.0210, 'lps'),
	(607373, 128, '2014-04-01 00:49:21.000000', 'consum', 0.0211, 'lps'),
	(607374, 128, '2014-04-01 00:49:22.000000', 'consum', 0.0214, 'lps'),
	(607375, 128, '2014-04-01 00:49:23.000000', 'consum', 0.0210, 'lps'),
	(607376, 128, '2014-04-01 00:49:24.000000', 'consum', 0.0218, 'lps'),
	(607377, 128, '2014-04-01 00:49:25.000000', 'consum', 0.0211, 'lps'),
	(607378, 128, '2014-04-01 00:49:26.000000', 'consum', 0.0219, 'lps'),
	(607379, 128, '2014-04-01 00:49:27.000000', 'consum', 0.0214, 'lps'),
	(607380, 128, '2014-04-01 00:49:28.000000', 'consum', 0.0214, 'lps'),
	(607381, 128, '2014-04-01 00:49:29.000000', 'consum', 0.0219, 'lps'),
	(607382, 128, '2014-04-01 00:49:30.000000', 'consum', 0.0212, 'lps'),
	(607383, 128, '2014-04-01 00:49:31.000000', 'consum', 0.0213, 'lps'),
	(607384, 128, '2014-04-01 00:49:32.000000', 'consum', 0.0210, 'lps'),
	(607385, 128, '2014-04-01 00:49:33.000000', 'consum', 0.0212, 'lps'),
	(607386, 128, '2014-04-01 00:49:34.000000', 'consum', 0.0210, 'lps'),
	(607387, 128, '2014-04-01 00:49:35.000000', 'consum', 0.0216, 'lps'),
	(607388, 128, '2014-04-01 00:49:36.000000', 'consum', 0.0219, 'lps'),
	(607389, 128, '2014-04-01 00:49:37.000000', 'consum', 0.0216, 'lps'),
	(607390, 128, '2014-04-01 00:49:38.000000', 'consum', 0.0216, 'lps'),
	(607391, 128, '2014-04-01 00:49:39.000000', 'consum', 0.0210, 'lps'),
	(607392, 128, '2014-04-01 00:49:40.000000', 'consum', 0.0214, 'lps'),
	(607393, 128, '2014-04-01 00:49:41.000000', 'consum', 0.0219, 'lps'),
	(607394, 128, '2014-04-01 00:49:42.000000', 'consum', 0.0214, 'lps'),
	(607395, 128, '2014-04-01 00:49:43.000000', 'consum', 0.0214, 'lps'),
	(607396, 128, '2014-04-01 00:49:44.000000', 'consum', 0.0216, 'lps'),
	(607397, 128, '2014-04-01 00:49:45.000000', 'consum', 0.0211, 'lps'),
	(607398, 128, '2014-04-01 00:49:46.000000', 'consum', 0.0217, 'lps'),
	(607399, 128, '2014-04-01 00:49:47.000000', 'consum', 0.0212, 'lps'),
	(607400, 128, '2014-04-01 00:49:48.000000', 'consum', 0.0211, 'lps'),
	(607401, 128, '2014-04-01 00:49:49.000000', 'consum', 0.0211, 'lps'),
	(607402, 128, '2014-04-01 00:49:50.000000', 'consum', 0.0219, 'lps'),
	(607403, 128, '2014-04-01 00:49:51.000000', 'consum', 0.0216, 'lps'),
	(607404, 128, '2014-04-01 00:49:52.000000', 'consum', 0.0211, 'lps'),
	(607405, 128, '2014-04-01 00:49:53.000000', 'consum', 0.0218, 'lps'),
	(607406, 128, '2014-04-01 00:49:54.000000', 'consum', 0.0219, 'lps'),
	(607407, 128, '2014-04-01 00:49:55.000000', 'consum', 0.0213, 'lps'),
	(607408, 128, '2014-04-01 00:49:56.000000', 'consum', 0.0215, 'lps'),
	(607409, 128, '2014-04-01 00:49:57.000000', 'consum', 0.0219, 'lps'),
	(607410, 128, '2014-04-01 00:49:58.000000', 'consum', 0.0211, 'lps'),
	(607411, 128, '2014-04-01 00:49:59.000000', 'consum', 0.0219, 'lps'),
	(607412, 128, '2014-04-01 00:50:00.000000', 'consum', 0.0211, 'lps'),
	(607413, 128, '2014-04-01 00:50:01.000000', 'consum', 0.0210, 'lps'),
	(607414, 128, '2014-04-01 00:50:02.000000', 'consum', 0.0215, 'lps'),
	(607415, 128, '2014-04-01 00:50:03.000000', 'consum', 0.0217, 'lps'),
	(607416, 128, '2014-04-01 00:50:04.000000', 'consum', 0.0211, 'lps'),
	(607417, 128, '2014-04-01 00:50:05.000000', 'consum', 0.0216, 'lps'),
	(607418, 128, '2014-04-01 00:50:06.000000', 'consum', 0.0215, 'lps'),
	(607419, 128, '2014-04-01 00:50:07.000000', 'consum', 0.0219, 'lps'),
	(607420, 128, '2014-04-01 00:50:08.000000', 'consum', 0.0218, 'lps'),
	(607421, 128, '2014-04-01 00:50:09.000000', 'consum', 0.0214, 'lps'),
	(607422, 128, '2014-04-01 00:50:10.000000', 'consum', 0.0219, 'lps'),
	(607423, 128, '2014-04-01 00:50:11.000000', 'consum', 0.0211, 'lps'),
	(607424, 128, '2014-04-01 00:50:12.000000', 'consum', 0.0210, 'lps'),
	(607425, 128, '2014-04-01 00:50:13.000000', 'consum', 0.0219, 'lps'),
	(607426, 128, '2014-04-01 00:50:14.000000', 'consum', 0.0213, 'lps'),
	(607427, 128, '2014-04-01 00:50:15.000000', 'consum', 0.0219, 'lps'),
	(607428, 128, '2014-04-01 00:50:16.000000', 'consum', 0.0218, 'lps'),
	(607429, 128, '2014-04-01 00:50:17.000000', 'consum', 0.0214, 'lps'),
	(607430, 128, '2014-04-01 00:50:18.000000', 'consum', 0.0216, 'lps'),
	(607431, 128, '2014-04-01 00:50:19.000000', 'consum', 0.0218, 'lps'),
	(607432, 128, '2014-04-01 00:50:20.000000', 'consum', 0.0212, 'lps'),
	(607433, 128, '2014-04-01 00:50:21.000000', 'consum', 0.0216, 'lps'),
	(607434, 128, '2014-04-01 00:50:22.000000', 'consum', 0.0215, 'lps'),
	(607435, 128, '2014-04-01 00:50:23.000000', 'consum', 0.0219, 'lps'),
	(607436, 128, '2014-04-01 00:50:24.000000', 'consum', 0.0218, 'lps'),
	(607437, 128, '2014-04-01 00:50:25.000000', 'consum', 0.0213, 'lps'),
	(607438, 128, '2014-04-01 00:50:26.000000', 'consum', 0.0214, 'lps'),
	(607439, 128, '2014-04-01 00:50:27.000000', 'consum', 0.0212, 'lps'),
	(607440, 128, '2014-04-01 00:50:28.000000', 'consum', 0.0217, 'lps'),
	(607441, 128, '2014-04-01 00:50:29.000000', 'consum', 0.0219, 'lps'),
	(607442, 128, '2014-04-01 00:50:30.000000', 'consum', 0.0217, 'lps'),
	(607443, 128, '2014-04-01 00:50:31.000000', 'consum', 0.0217, 'lps'),
	(607444, 128, '2014-04-01 00:50:32.000000', 'consum', 0.0216, 'lps'),
	(607445, 128, '2014-04-01 00:50:33.000000', 'consum', 0.0217, 'lps'),
	(607446, 128, '2014-04-01 00:50:34.000000', 'consum', 0.0218, 'lps'),
	(607447, 128, '2014-04-01 00:50:35.000000', 'consum', 0.0218, 'lps'),
	(607448, 128, '2014-04-01 00:50:36.000000', 'consum', 0.0218, 'lps'),
	(607449, 128, '2014-04-01 00:50:37.000000', 'consum', 0.0216, 'lps'),
	(607450, 128, '2014-04-01 00:50:38.000000', 'consum', 0.0216, 'lps'),
	(607451, 128, '2014-04-01 00:50:39.000000', 'consum', 0.0213, 'lps'),
	(607452, 128, '2014-04-01 00:50:40.000000', 'consum', 0.0219, 'lps'),
	(607453, 128, '2014-04-01 00:50:41.000000', 'consum', 0.0214, 'lps'),
	(607454, 128, '2014-04-01 00:50:42.000000', 'consum', 0.0217, 'lps'),
	(607455, 128, '2014-04-01 00:50:43.000000', 'consum', 0.0210, 'lps'),
	(607456, 128, '2014-04-01 00:50:44.000000', 'consum', 0.0211, 'lps'),
	(607457, 128, '2014-04-01 00:50:45.000000', 'consum', 0.0216, 'lps'),
	(607458, 128, '2014-04-01 00:50:46.000000', 'consum', 0.0215, 'lps'),
	(607459, 128, '2014-04-01 00:50:47.000000', 'consum', 0.0219, 'lps'),
	(607460, 128, '2014-04-01 00:50:48.000000', 'consum', 0.0211, 'lps'),
	(607461, 128, '2014-04-01 00:50:49.000000', 'consum', 0.0218, 'lps'),
	(607462, 128, '2014-04-01 00:50:50.000000', 'consum', 0.0216, 'lps'),
	(607463, 128, '2014-04-01 00:50:51.000000', 'consum', 0.0219, 'lps'),
	(607464, 128, '2014-04-01 00:50:52.000000', 'consum', 0.0217, 'lps'),
	(607465, 128, '2014-04-01 00:50:53.000000', 'consum', 0.0217, 'lps'),
	(607466, 128, '2014-04-01 00:50:54.000000', 'consum', 0.0217, 'lps'),
	(607467, 128, '2014-04-01 00:50:55.000000', 'consum', 0.0214, 'lps'),
	(607468, 128, '2014-04-01 00:50:56.000000', 'consum', 0.0211, 'lps'),
	(607469, 128, '2014-04-01 00:50:57.000000', 'consum', 0.0212, 'lps'),
	(607470, 128, '2014-04-01 00:50:58.000000', 'consum', 0.0216, 'lps'),
	(607471, 128, '2014-04-01 00:50:59.000000', 'consum', 0.0216, 'lps'),
	(607472, 128, '2014-04-01 00:51:00.000000', 'consum', 0.0214, 'lps'),
	(607473, 128, '2014-04-01 00:51:01.000000', 'consum', 0.0212, 'lps'),
	(607474, 128, '2014-04-01 00:51:02.000000', 'consum', 0.0218, 'lps'),
	(607475, 128, '2014-04-01 00:51:03.000000', 'consum', 0.0214, 'lps'),
	(607476, 128, '2014-04-01 00:51:04.000000', 'consum', 0.0217, 'lps'),
	(607477, 128, '2014-04-01 00:51:05.000000', 'consum', 0.0213, 'lps'),
	(607478, 128, '2014-04-01 00:51:06.000000', 'consum', 0.0215, 'lps'),
	(607479, 128, '2014-04-01 00:51:07.000000', 'consum', 0.0218, 'lps'),
	(607480, 128, '2014-04-01 00:51:08.000000', 'consum', 0.0212, 'lps'),
	(607481, 128, '2014-04-01 00:51:09.000000', 'consum', 0.0210, 'lps'),
	(607482, 128, '2014-04-01 00:51:10.000000', 'consum', 0.0213, 'lps'),
	(607483, 128, '2014-04-01 00:51:11.000000', 'consum', 0.0216, 'lps'),
	(607484, 128, '2014-04-01 00:51:12.000000', 'consum', 0.0211, 'lps'),
	(607485, 128, '2014-04-01 00:51:13.000000', 'consum', 0.0219, 'lps'),
	(607486, 128, '2014-04-01 00:51:14.000000', 'consum', 0.0213, 'lps'),
	(607487, 128, '2014-04-01 00:51:15.000000', 'consum', 0.0217, 'lps'),
	(607488, 128, '2014-04-01 00:51:16.000000', 'consum', 0.0218, 'lps'),
	(607489, 128, '2014-04-01 00:51:17.000000', 'consum', 0.0217, 'lps'),
	(607490, 128, '2014-04-01 00:51:18.000000', 'consum', 0.0213, 'lps'),
	(607491, 128, '2014-04-01 00:51:19.000000', 'consum', 0.0215, 'lps'),
	(607492, 128, '2014-04-01 00:51:20.000000', 'consum', 0.0215, 'lps'),
	(607493, 128, '2014-04-01 00:51:21.000000', 'consum', 0.0211, 'lps'),
	(607494, 128, '2014-04-01 00:51:22.000000', 'consum', 0.0219, 'lps'),
	(607495, 128, '2014-04-01 00:51:23.000000', 'consum', 0.0214, 'lps'),
	(607496, 128, '2014-04-01 00:51:24.000000', 'consum', 0.0213, 'lps'),
	(607497, 128, '2014-04-01 00:51:25.000000', 'consum', 0.0214, 'lps'),
	(607498, 128, '2014-04-01 00:51:26.000000', 'consum', 0.0211, 'lps'),
	(607499, 128, '2014-04-01 00:51:27.000000', 'consum', 0.0212, 'lps'),
	(607500, 128, '2014-04-01 00:51:28.000000', 'consum', 0.0219, 'lps'),
	(607501, 128, '2014-04-01 00:51:29.000000', 'consum', 0.0218, 'lps'),
	(607502, 128, '2014-04-01 00:51:30.000000', 'consum', 0.0214, 'lps'),
	(607503, 128, '2014-04-01 00:51:31.000000', 'consum', 0.0215, 'lps'),
	(607504, 128, '2014-04-01 00:51:32.000000', 'consum', 0.0214, 'lps'),
	(607505, 128, '2014-04-01 00:51:33.000000', 'consum', 0.0217, 'lps'),
	(607506, 128, '2014-04-01 00:51:34.000000', 'consum', 0.0212, 'lps'),
	(607507, 128, '2014-04-01 00:51:35.000000', 'consum', 0.0219, 'lps'),
	(607508, 128, '2014-04-01 00:51:36.000000', 'consum', 0.0210, 'lps'),
	(607509, 128, '2014-04-01 00:51:37.000000', 'consum', 0.0213, 'lps'),
	(607510, 128, '2014-04-01 00:51:38.000000', 'consum', 0.0217, 'lps'),
	(607511, 128, '2014-04-01 00:51:39.000000', 'consum', 0.0217, 'lps'),
	(607512, 128, '2014-04-01 00:51:40.000000', 'consum', 0.0212, 'lps'),
	(607513, 128, '2014-04-01 00:51:41.000000', 'consum', 0.0212, 'lps'),
	(607514, 128, '2014-04-01 00:51:42.000000', 'consum', 0.0216, 'lps'),
	(607515, 128, '2014-04-01 00:51:43.000000', 'consum', 0.0211, 'lps'),
	(607516, 128, '2014-04-01 00:51:44.000000', 'consum', 0.0218, 'lps'),
	(607517, 128, '2014-04-01 00:51:45.000000', 'consum', 0.0218, 'lps'),
	(607518, 128, '2014-04-01 00:51:46.000000', 'consum', 0.0216, 'lps'),
	(607519, 128, '2014-04-01 00:51:47.000000', 'consum', 0.0216, 'lps'),
	(607520, 128, '2014-04-01 00:51:48.000000', 'consum', 0.0211, 'lps'),
	(607521, 128, '2014-04-01 00:51:49.000000', 'consum', 0.0211, 'lps'),
	(607522, 128, '2014-04-01 00:51:50.000000', 'consum', 0.0219, 'lps'),
	(607523, 128, '2014-04-01 00:51:51.000000', 'consum', 0.0215, 'lps'),
	(607524, 128, '2014-04-01 00:51:52.000000', 'consum', 0.0219, 'lps'),
	(607525, 128, '2014-04-01 00:51:53.000000', 'consum', 0.0210, 'lps'),
	(607526, 128, '2014-04-01 00:51:54.000000', 'consum', 0.0212, 'lps'),
	(607527, 128, '2014-04-01 00:51:55.000000', 'consum', 0.0211, 'lps'),
	(607528, 128, '2014-04-01 00:51:56.000000', 'consum', 0.0211, 'lps'),
	(607529, 128, '2014-04-01 00:51:57.000000', 'consum', 0.0213, 'lps'),
	(607530, 128, '2014-04-01 00:51:58.000000', 'consum', 0.0213, 'lps'),
	(607531, 128, '2014-04-01 00:51:59.000000', 'consum', 0.0215, 'lps'),
	(607532, 128, '2014-04-01 00:52:00.000000', 'consum', 0.0217, 'lps'),
	(607533, 128, '2014-04-01 00:52:01.000000', 'consum', 0.0219, 'lps'),
	(607534, 128, '2014-04-01 00:52:02.000000', 'consum', 0.0216, 'lps'),
	(607535, 128, '2014-04-01 00:52:03.000000', 'consum', 0.0215, 'lps'),
	(607536, 128, '2014-04-01 00:52:04.000000', 'consum', 0.0215, 'lps'),
	(607537, 128, '2014-04-01 00:52:05.000000', 'consum', 0.0212, 'lps'),
	(607538, 128, '2014-04-01 00:52:06.000000', 'consum', 0.0214, 'lps'),
	(607539, 128, '2014-04-01 00:52:07.000000', 'consum', 0.0216, 'lps'),
	(607540, 128, '2014-04-01 00:52:08.000000', 'consum', 0.0218, 'lps'),
	(607541, 128, '2014-04-01 00:52:09.000000', 'consum', 0.0214, 'lps'),
	(607542, 128, '2014-04-01 00:52:10.000000', 'consum', 0.0215, 'lps'),
	(607543, 128, '2014-04-01 00:52:11.000000', 'consum', 0.0213, 'lps'),
	(607544, 128, '2014-04-01 00:52:12.000000', 'consum', 0.0211, 'lps'),
	(607545, 128, '2014-04-01 00:52:13.000000', 'consum', 0.0215, 'lps'),
	(607546, 128, '2014-04-01 00:52:14.000000', 'consum', 0.0215, 'lps'),
	(607547, 128, '2014-04-01 00:52:15.000000', 'consum', 0.0211, 'lps'),
	(607548, 128, '2014-04-01 00:52:16.000000', 'consum', 0.0218, 'lps'),
	(607549, 128, '2014-04-01 00:52:17.000000', 'consum', 0.0218, 'lps'),
	(607550, 128, '2014-04-01 00:52:18.000000', 'consum', 0.0216, 'lps'),
	(607551, 128, '2014-04-01 00:52:19.000000', 'consum', 0.0218, 'lps'),
	(607552, 128, '2014-04-01 00:52:20.000000', 'consum', 0.0210, 'lps'),
	(607553, 128, '2014-04-01 00:52:21.000000', 'consum', 0.0219, 'lps'),
	(607554, 128, '2014-04-01 00:52:22.000000', 'consum', 0.0215, 'lps'),
	(607555, 128, '2014-04-01 00:52:23.000000', 'consum', 0.0219, 'lps'),
	(607556, 128, '2014-04-01 00:52:24.000000', 'consum', 0.0212, 'lps'),
	(607557, 128, '2014-04-01 00:52:25.000000', 'consum', 0.0210, 'lps'),
	(607558, 128, '2014-04-01 00:52:26.000000', 'consum', 0.0217, 'lps'),
	(607559, 128, '2014-04-01 00:52:27.000000', 'consum', 0.0217, 'lps'),
	(607560, 128, '2014-04-01 00:52:28.000000', 'consum', 0.0212, 'lps'),
	(607561, 128, '2014-04-01 00:52:29.000000', 'consum', 0.0210, 'lps'),
	(607562, 128, '2014-04-01 00:52:30.000000', 'consum', 0.0213, 'lps'),
	(607563, 128, '2014-04-01 00:52:31.000000', 'consum', 0.0215, 'lps'),
	(607564, 128, '2014-04-01 00:52:32.000000', 'consum', 0.0218, 'lps'),
	(607565, 128, '2014-04-01 00:52:33.000000', 'consum', 0.0214, 'lps'),
	(607566, 128, '2014-04-01 00:52:34.000000', 'consum', 0.0219, 'lps'),
	(607567, 128, '2014-04-01 00:52:35.000000', 'consum', 0.0214, 'lps'),
	(607568, 128, '2014-04-01 00:52:36.000000', 'consum', 0.0211, 'lps'),
	(607569, 128, '2014-04-01 00:52:37.000000', 'consum', 0.0216, 'lps'),
	(607570, 128, '2014-04-01 00:52:38.000000', 'consum', 0.0216, 'lps'),
	(607571, 128, '2014-04-01 00:52:39.000000', 'consum', 0.0213, 'lps'),
	(607572, 128, '2014-04-01 00:52:40.000000', 'consum', 0.0218, 'lps'),
	(607573, 128, '2014-04-01 00:52:41.000000', 'consum', 0.0212, 'lps'),
	(607574, 128, '2014-04-01 00:52:42.000000', 'consum', 0.0216, 'lps'),
	(607575, 128, '2014-04-01 00:52:43.000000', 'consum', 0.0216, 'lps'),
	(607576, 128, '2014-04-01 00:52:44.000000', 'consum', 0.0210, 'lps'),
	(607577, 128, '2014-04-01 00:52:45.000000', 'consum', 0.0213, 'lps'),
	(607578, 128, '2014-04-01 00:52:46.000000', 'consum', 0.0217, 'lps'),
	(607579, 128, '2014-04-01 00:52:47.000000', 'consum', 0.0216, 'lps'),
	(607580, 128, '2014-04-01 00:52:48.000000', 'consum', 0.0218, 'lps'),
	(607581, 128, '2014-04-01 00:52:49.000000', 'consum', 0.0211, 'lps'),
	(607582, 128, '2014-04-01 00:52:50.000000', 'consum', 0.0215, 'lps'),
	(607583, 128, '2014-04-01 00:52:51.000000', 'consum', 0.0210, 'lps'),
	(607584, 128, '2014-04-01 00:52:52.000000', 'consum', 0.0217, 'lps'),
	(607585, 128, '2014-04-01 00:52:53.000000', 'consum', 0.0213, 'lps'),
	(607586, 128, '2014-04-01 00:52:54.000000', 'consum', 0.0218, 'lps'),
	(607587, 128, '2014-04-01 00:52:55.000000', 'consum', 0.0210, 'lps'),
	(607588, 128, '2014-04-01 00:52:56.000000', 'consum', 0.0215, 'lps'),
	(607589, 128, '2014-04-01 00:52:57.000000', 'consum', 0.0217, 'lps'),
	(607590, 128, '2014-04-01 00:52:58.000000', 'consum', 0.0211, 'lps'),
	(607591, 128, '2014-04-01 00:52:59.000000', 'consum', 0.0213, 'lps'),
	(607592, 128, '2014-04-01 00:53:00.000000', 'consum', 0.0213, 'lps'),
	(607593, 128, '2014-04-01 00:53:01.000000', 'consum', 0.0216, 'lps'),
	(607594, 128, '2014-04-01 00:53:02.000000', 'consum', 0.0210, 'lps'),
	(607595, 128, '2014-04-01 00:53:03.000000', 'consum', 0.0213, 'lps'),
	(607596, 128, '2014-04-01 00:53:04.000000', 'consum', 0.0218, 'lps'),
	(607597, 128, '2014-04-01 00:53:05.000000', 'consum', 0.0218, 'lps'),
	(607598, 128, '2014-04-01 00:53:06.000000', 'consum', 0.0219, 'lps'),
	(607599, 128, '2014-04-01 00:53:07.000000', 'consum', 0.0212, 'lps'),
	(607600, 128, '2014-04-01 00:53:08.000000', 'consum', 0.0214, 'lps'),
	(607601, 128, '2014-04-01 00:53:09.000000', 'consum', 0.0212, 'lps'),
	(607602, 128, '2014-04-01 00:53:10.000000', 'consum', 0.0218, 'lps'),
	(607603, 128, '2014-04-01 00:53:11.000000', 'consum', 0.0215, 'lps'),
	(607604, 128, '2014-04-01 00:53:12.000000', 'consum', 0.0211, 'lps'),
	(607605, 128, '2014-04-01 00:53:13.000000', 'consum', 0.0210, 'lps'),
	(607606, 128, '2014-04-01 00:53:14.000000', 'consum', 0.0217, 'lps'),
	(607607, 128, '2014-04-01 00:53:15.000000', 'consum', 0.0214, 'lps'),
	(607608, 128, '2014-04-01 00:53:16.000000', 'consum', 0.0213, 'lps'),
	(607609, 128, '2014-04-01 00:53:17.000000', 'consum', 0.0210, 'lps'),
	(607610, 128, '2014-04-01 00:53:18.000000', 'consum', 0.0214, 'lps'),
	(607611, 128, '2014-04-01 00:53:19.000000', 'consum', 0.0211, 'lps'),
	(607612, 128, '2014-04-01 00:53:20.000000', 'consum', 0.0213, 'lps'),
	(607613, 128, '2014-04-01 00:53:21.000000', 'consum', 0.0214, 'lps'),
	(607614, 128, '2014-04-01 00:53:22.000000', 'consum', 0.0211, 'lps'),
	(607615, 128, '2014-04-01 00:53:23.000000', 'consum', 0.0212, 'lps'),
	(607616, 128, '2014-04-01 00:53:24.000000', 'consum', 0.0219, 'lps'),
	(607617, 128, '2014-04-01 00:53:25.000000', 'consum', 0.0218, 'lps'),
	(607618, 128, '2014-04-01 00:53:26.000000', 'consum', 0.0214, 'lps'),
	(607619, 128, '2014-04-01 00:53:27.000000', 'consum', 0.0215, 'lps'),
	(607620, 128, '2014-04-01 00:53:28.000000', 'consum', 0.0214, 'lps'),
	(607621, 128, '2014-04-01 00:53:29.000000', 'consum', 0.0216, 'lps'),
	(607622, 128, '2014-04-01 00:53:30.000000', 'consum', 0.0218, 'lps'),
	(607623, 128, '2014-04-01 00:53:31.000000', 'consum', 0.0214, 'lps'),
	(607624, 128, '2014-04-01 00:53:32.000000', 'consum', 0.0216, 'lps'),
	(607625, 128, '2014-04-01 00:53:33.000000', 'consum', 0.0210, 'lps'),
	(607626, 128, '2014-04-01 00:53:34.000000', 'consum', 0.0212, 'lps'),
	(607627, 128, '2014-04-01 00:53:35.000000', 'consum', 0.0211, 'lps'),
	(607628, 128, '2014-04-01 00:53:36.000000', 'consum', 0.0217, 'lps'),
	(607629, 128, '2014-04-01 00:53:37.000000', 'consum', 0.0214, 'lps'),
	(607630, 128, '2014-04-01 00:53:38.000000', 'consum', 0.0219, 'lps'),
	(607631, 128, '2014-04-01 00:53:39.000000', 'consum', 0.0213, 'lps'),
	(607632, 128, '2014-04-01 00:53:40.000000', 'consum', 0.0210, 'lps'),
	(607633, 128, '2014-04-01 00:53:41.000000', 'consum', 0.0211, 'lps'),
	(607634, 128, '2014-04-01 00:53:42.000000', 'consum', 0.0215, 'lps'),
	(607635, 128, '2014-04-01 00:53:43.000000', 'consum', 0.0214, 'lps'),
	(607636, 128, '2014-04-01 00:53:44.000000', 'consum', 0.0214, 'lps'),
	(607637, 128, '2014-04-01 00:53:45.000000', 'consum', 0.0219, 'lps'),
	(607638, 128, '2014-04-01 00:53:46.000000', 'consum', 0.0212, 'lps'),
	(607639, 128, '2014-04-01 00:53:47.000000', 'consum', 0.0214, 'lps'),
	(607640, 128, '2014-04-01 00:53:48.000000', 'consum', 0.0214, 'lps'),
	(607641, 128, '2014-04-01 00:53:49.000000', 'consum', 0.0211, 'lps'),
	(607642, 128, '2014-04-01 00:53:50.000000', 'consum', 0.0213, 'lps'),
	(607643, 128, '2014-04-01 00:53:51.000000', 'consum', 0.0211, 'lps'),
	(607644, 128, '2014-04-01 00:53:52.000000', 'consum', 0.0216, 'lps'),
	(607645, 128, '2014-04-01 00:53:53.000000', 'consum', 0.0217, 'lps'),
	(607646, 128, '2014-04-01 00:53:54.000000', 'consum', 0.0218, 'lps'),
	(607647, 128, '2014-04-01 00:53:55.000000', 'consum', 0.0211, 'lps'),
	(607648, 128, '2014-04-01 00:53:56.000000', 'consum', 0.0211, 'lps'),
	(607649, 128, '2014-04-01 00:53:57.000000', 'consum', 0.0212, 'lps'),
	(607650, 128, '2014-04-01 00:53:58.000000', 'consum', 0.0216, 'lps'),
	(607651, 128, '2014-04-01 00:53:59.000000', 'consum', 0.0215, 'lps'),
	(607652, 128, '2014-04-01 00:54:00.000000', 'consum', 0.0218, 'lps'),
	(607653, 128, '2014-04-01 00:54:01.000000', 'consum', 0.0214, 'lps'),
	(607654, 128, '2014-04-01 00:54:02.000000', 'consum', 0.0217, 'lps'),
	(607655, 128, '2014-04-01 00:54:03.000000', 'consum', 0.0213, 'lps'),
	(607656, 128, '2014-04-01 00:54:04.000000', 'consum', 0.0214, 'lps'),
	(607657, 128, '2014-04-01 00:54:05.000000', 'consum', 0.0211, 'lps'),
	(607658, 128, '2014-04-01 00:54:06.000000', 'consum', 0.0215, 'lps'),
	(607659, 128, '2014-04-01 00:54:07.000000', 'consum', 0.0210, 'lps'),
	(607660, 128, '2014-04-01 00:54:08.000000', 'consum', 0.0218, 'lps'),
	(607661, 128, '2014-04-01 00:54:09.000000', 'consum', 0.0219, 'lps'),
	(607662, 128, '2014-04-01 00:54:10.000000', 'consum', 0.0211, 'lps'),
	(607663, 128, '2014-04-01 00:54:11.000000', 'consum', 0.0210, 'lps'),
	(607664, 128, '2014-04-01 00:54:12.000000', 'consum', 0.0218, 'lps'),
	(607665, 128, '2014-04-01 00:54:13.000000', 'consum', 0.0211, 'lps'),
	(607666, 128, '2014-04-01 00:54:14.000000', 'consum', 0.0219, 'lps'),
	(607667, 128, '2014-04-01 00:54:15.000000', 'consum', 0.0212, 'lps'),
	(607668, 128, '2014-04-01 00:54:16.000000', 'consum', 0.0216, 'lps'),
	(607669, 128, '2014-04-01 00:54:17.000000', 'consum', 0.0212, 'lps'),
	(607670, 128, '2014-04-01 00:54:18.000000', 'consum', 0.0213, 'lps'),
	(607671, 128, '2014-04-01 00:54:19.000000', 'consum', 0.0210, 'lps'),
	(607672, 128, '2014-04-01 00:54:20.000000', 'consum', 0.0213, 'lps'),
	(607673, 128, '2014-04-01 00:54:21.000000', 'consum', 0.0212, 'lps'),
	(607674, 128, '2014-04-01 00:54:22.000000', 'consum', 0.0214, 'lps'),
	(607675, 128, '2014-04-01 00:54:23.000000', 'consum', 0.0216, 'lps'),
	(607676, 128, '2014-04-01 00:54:24.000000', 'consum', 0.0215, 'lps'),
	(607677, 128, '2014-04-01 00:54:25.000000', 'consum', 0.0211, 'lps'),
	(607678, 128, '2014-04-01 00:54:26.000000', 'consum', 0.0217, 'lps'),
	(607679, 128, '2014-04-01 00:54:27.000000', 'consum', 0.0215, 'lps'),
	(607680, 128, '2014-04-01 00:54:28.000000', 'consum', 0.0213, 'lps'),
	(607681, 128, '2014-04-01 00:54:29.000000', 'consum', 0.0211, 'lps'),
	(607682, 128, '2014-04-01 00:54:30.000000', 'consum', 0.0218, 'lps'),
	(607683, 128, '2014-04-01 00:54:31.000000', 'consum', 0.0217, 'lps'),
	(607684, 128, '2014-04-01 00:54:32.000000', 'consum', 0.0211, 'lps'),
	(607685, 128, '2014-04-01 00:54:33.000000', 'consum', 0.0213, 'lps'),
	(607686, 128, '2014-04-01 00:54:34.000000', 'consum', 0.0213, 'lps'),
	(607687, 128, '2014-04-01 00:54:35.000000', 'consum', 0.0217, 'lps'),
	(607688, 128, '2014-04-01 00:54:36.000000', 'consum', 0.0216, 'lps'),
	(607689, 128, '2014-04-01 00:54:37.000000', 'consum', 0.0218, 'lps'),
	(607690, 128, '2014-04-01 00:54:38.000000', 'consum', 0.0216, 'lps'),
	(607691, 128, '2014-04-01 00:54:39.000000', 'consum', 0.0214, 'lps'),
	(607692, 128, '2014-04-01 00:54:40.000000', 'consum', 0.0213, 'lps'),
	(607693, 128, '2014-04-01 00:54:41.000000', 'consum', 0.0214, 'lps'),
	(607694, 128, '2014-04-01 00:54:42.000000', 'consum', 0.0210, 'lps'),
	(607695, 128, '2014-04-01 00:54:43.000000', 'consum', 0.0211, 'lps'),
	(607696, 128, '2014-04-01 00:54:44.000000', 'consum', 0.0216, 'lps'),
	(607697, 128, '2014-04-01 00:54:45.000000', 'consum', 0.0215, 'lps'),
	(607698, 128, '2014-04-01 00:54:46.000000', 'consum', 0.0217, 'lps'),
	(607699, 128, '2014-04-01 00:54:47.000000', 'consum', 0.0213, 'lps'),
	(607700, 128, '2014-04-01 00:54:48.000000', 'consum', 0.0213, 'lps'),
	(607701, 128, '2014-04-01 00:54:49.000000', 'consum', 0.0216, 'lps'),
	(607702, 128, '2014-04-01 00:54:50.000000', 'consum', 0.0211, 'lps'),
	(607703, 128, '2014-04-01 00:54:51.000000', 'consum', 0.0218, 'lps'),
	(607704, 128, '2014-04-01 00:54:52.000000', 'consum', 0.0218, 'lps'),
	(607705, 128, '2014-04-01 00:54:53.000000', 'consum', 0.0218, 'lps'),
	(607706, 128, '2014-04-01 00:54:54.000000', 'consum', 0.0214, 'lps'),
	(607707, 128, '2014-04-01 00:54:55.000000', 'consum', 0.0217, 'lps'),
	(607708, 128, '2014-04-01 00:54:56.000000', 'consum', 0.0212, 'lps'),
	(607709, 128, '2014-04-01 00:54:57.000000', 'consum', 0.0212, 'lps'),
	(607710, 128, '2014-04-01 00:54:58.000000', 'consum', 0.0212, 'lps'),
	(607711, 128, '2014-04-01 00:54:59.000000', 'consum', 0.0217, 'lps'),
	(607712, 128, '2014-04-01 00:55:00.000000', 'consum', 0.0219, 'lps'),
	(607713, 128, '2014-04-01 00:55:01.000000', 'consum', 0.0214, 'lps'),
	(607714, 128, '2014-04-01 00:55:02.000000', 'consum', 0.0212, 'lps'),
	(607715, 128, '2014-04-01 00:55:03.000000', 'consum', 0.0218, 'lps'),
	(607716, 128, '2014-04-01 00:55:04.000000', 'consum', 0.0218, 'lps'),
	(607717, 128, '2014-04-01 00:55:05.000000', 'consum', 0.0214, 'lps'),
	(607718, 128, '2014-04-01 00:55:06.000000', 'consum', 0.0215, 'lps'),
	(607719, 128, '2014-04-01 00:55:07.000000', 'consum', 0.0217, 'lps'),
	(607720, 128, '2014-04-01 00:55:08.000000', 'consum', 0.0219, 'lps'),
	(607721, 128, '2014-04-01 00:55:09.000000', 'consum', 0.0214, 'lps'),
	(607722, 128, '2014-04-01 00:55:10.000000', 'consum', 0.0214, 'lps'),
	(607723, 128, '2014-04-01 00:55:11.000000', 'consum', 0.0210, 'lps'),
	(607724, 128, '2014-04-01 00:55:12.000000', 'consum', 0.0218, 'lps'),
	(607725, 128, '2014-04-01 00:55:13.000000', 'consum', 0.0212, 'lps'),
	(607726, 128, '2014-04-01 00:55:14.000000', 'consum', 0.0216, 'lps'),
	(607727, 128, '2014-04-01 00:55:15.000000', 'consum', 0.0213, 'lps'),
	(607728, 128, '2014-04-01 00:55:16.000000', 'consum', 0.0217, 'lps'),
	(607729, 128, '2014-04-01 00:55:17.000000', 'consum', 0.0218, 'lps'),
	(607730, 128, '2014-04-01 00:55:18.000000', 'consum', 0.0210, 'lps'),
	(607731, 128, '2014-04-01 00:55:19.000000', 'consum', 0.0215, 'lps'),
	(607732, 128, '2014-04-01 00:55:20.000000', 'consum', 0.0217, 'lps'),
	(607733, 128, '2014-04-01 00:55:21.000000', 'consum', 0.0218, 'lps'),
	(607734, 128, '2014-04-01 00:55:22.000000', 'consum', 0.0213, 'lps'),
	(607735, 128, '2014-04-01 00:55:23.000000', 'consum', 0.0218, 'lps'),
	(607736, 128, '2014-04-01 00:55:24.000000', 'consum', 0.0214, 'lps'),
	(607737, 128, '2014-04-01 00:55:25.000000', 'consum', 0.0214, 'lps'),
	(607738, 128, '2014-04-01 00:55:26.000000', 'consum', 0.0211, 'lps'),
	(607739, 128, '2014-04-01 00:55:27.000000', 'consum', 0.0211, 'lps'),
	(607740, 128, '2014-04-01 00:55:28.000000', 'consum', 0.0214, 'lps'),
	(607741, 128, '2014-04-01 00:55:29.000000', 'consum', 0.0218, 'lps'),
	(607742, 128, '2014-04-01 00:55:30.000000', 'consum', 0.0210, 'lps'),
	(607743, 128, '2014-04-01 00:55:31.000000', 'consum', 0.0214, 'lps'),
	(607744, 128, '2014-04-01 00:55:32.000000', 'consum', 0.0211, 'lps'),
	(607745, 128, '2014-04-01 00:55:33.000000', 'consum', 0.0215, 'lps'),
	(607746, 128, '2014-04-01 00:55:34.000000', 'consum', 0.0210, 'lps'),
	(607747, 128, '2014-04-01 00:55:35.000000', 'consum', 0.0215, 'lps'),
	(607748, 128, '2014-04-01 00:55:36.000000', 'consum', 0.0216, 'lps'),
	(607749, 128, '2014-04-01 00:55:37.000000', 'consum', 0.0214, 'lps'),
	(607750, 128, '2014-04-01 00:55:38.000000', 'consum', 0.0216, 'lps'),
	(607751, 128, '2014-04-01 00:55:39.000000', 'consum', 0.0217, 'lps'),
	(607752, 128, '2014-04-01 00:55:40.000000', 'consum', 0.0216, 'lps'),
	(607753, 128, '2014-04-01 00:55:41.000000', 'consum', 0.0210, 'lps'),
	(607754, 128, '2014-04-01 00:55:42.000000', 'consum', 0.0214, 'lps'),
	(607755, 128, '2014-04-01 00:55:43.000000', 'consum', 0.0218, 'lps'),
	(607756, 128, '2014-04-01 00:55:44.000000', 'consum', 0.0218, 'lps'),
	(607757, 128, '2014-04-01 00:55:45.000000', 'consum', 0.0218, 'lps'),
	(607758, 128, '2014-04-01 00:55:46.000000', 'consum', 0.0217, 'lps'),
	(607759, 128, '2014-04-01 00:55:47.000000', 'consum', 0.0212, 'lps'),
	(607760, 128, '2014-04-01 00:55:48.000000', 'consum', 0.0210, 'lps'),
	(607761, 128, '2014-04-01 00:55:49.000000', 'consum', 0.0213, 'lps'),
	(607762, 128, '2014-04-01 00:55:50.000000', 'consum', 0.0214, 'lps'),
	(607763, 128, '2014-04-01 00:55:51.000000', 'consum', 0.0214, 'lps'),
	(607764, 128, '2014-04-01 00:55:52.000000', 'consum', 0.0218, 'lps'),
	(607765, 128, '2014-04-01 00:55:53.000000', 'consum', 0.0210, 'lps'),
	(607766, 128, '2014-04-01 00:55:54.000000', 'consum', 0.0216, 'lps'),
	(607767, 128, '2014-04-01 00:55:55.000000', 'consum', 0.0211, 'lps'),
	(607768, 128, '2014-04-01 00:55:56.000000', 'consum', 0.0217, 'lps'),
	(607769, 128, '2014-04-01 00:55:57.000000', 'consum', 0.0213, 'lps'),
	(607770, 128, '2014-04-01 00:55:58.000000', 'consum', 0.0213, 'lps'),
	(607771, 128, '2014-04-01 00:55:59.000000', 'consum', 0.0216, 'lps'),
	(607772, 128, '2014-04-01 00:56:00.000000', 'consum', 0.0214, 'lps'),
	(607773, 128, '2014-04-01 00:56:01.000000', 'consum', 0.0213, 'lps'),
	(607774, 128, '2014-04-01 00:56:02.000000', 'consum', 0.0212, 'lps'),
	(607775, 128, '2014-04-01 00:56:03.000000', 'consum', 0.0210, 'lps'),
	(607776, 128, '2014-04-01 00:56:04.000000', 'consum', 0.0215, 'lps'),
	(607777, 128, '2014-04-01 00:56:05.000000', 'consum', 0.0217, 'lps'),
	(607778, 128, '2014-04-01 00:56:06.000000', 'consum', 0.0210, 'lps'),
	(607779, 128, '2014-04-01 00:56:07.000000', 'consum', 0.0211, 'lps'),
	(607780, 128, '2014-04-01 00:56:08.000000', 'consum', 0.0216, 'lps'),
	(607781, 128, '2014-04-01 00:56:09.000000', 'consum', 0.0215, 'lps'),
	(607782, 128, '2014-04-01 00:56:10.000000', 'consum', 0.0210, 'lps'),
	(607783, 128, '2014-04-01 00:56:11.000000', 'consum', 0.0214, 'lps'),
	(607784, 128, '2014-04-01 00:56:12.000000', 'consum', 0.0212, 'lps'),
	(607785, 128, '2014-04-01 00:56:13.000000', 'consum', 0.0216, 'lps'),
	(607786, 128, '2014-04-01 00:56:14.000000', 'consum', 0.0214, 'lps'),
	(607787, 128, '2014-04-01 00:56:15.000000', 'consum', 0.0212, 'lps'),
	(607788, 128, '2014-04-01 00:56:16.000000', 'consum', 0.0218, 'lps'),
	(607789, 128, '2014-04-01 00:56:17.000000', 'consum', 0.0216, 'lps'),
	(607790, 128, '2014-04-01 00:56:18.000000', 'consum', 0.0217, 'lps'),
	(607791, 128, '2014-04-01 00:56:19.000000', 'consum', 0.0218, 'lps'),
	(607792, 128, '2014-04-01 00:56:20.000000', 'consum', 0.0217, 'lps'),
	(607793, 128, '2014-04-01 00:56:21.000000', 'consum', 0.0212, 'lps'),
	(607794, 128, '2014-04-01 00:56:22.000000', 'consum', 0.0219, 'lps'),
	(607795, 128, '2014-04-01 00:56:23.000000', 'consum', 0.0219, 'lps'),
	(607796, 128, '2014-04-01 00:56:24.000000', 'consum', 0.0219, 'lps'),
	(607797, 128, '2014-04-01 00:56:25.000000', 'consum', 0.0210, 'lps'),
	(607798, 128, '2014-04-01 00:56:26.000000', 'consum', 0.0214, 'lps'),
	(607799, 128, '2014-04-01 00:56:27.000000', 'consum', 0.0212, 'lps'),
	(607800, 128, '2014-04-01 00:56:28.000000', 'consum', 0.0215, 'lps'),
	(607801, 128, '2014-04-01 00:56:29.000000', 'consum', 0.0210, 'lps'),
	(607802, 128, '2014-04-01 00:56:30.000000', 'consum', 0.0217, 'lps'),
	(607803, 128, '2014-04-01 00:56:31.000000', 'consum', 0.0214, 'lps'),
	(607804, 128, '2014-04-01 00:56:32.000000', 'consum', 0.0218, 'lps'),
	(607805, 128, '2014-04-01 00:56:33.000000', 'consum', 0.0211, 'lps'),
	(607806, 128, '2014-04-01 00:56:34.000000', 'consum', 0.0211, 'lps'),
	(607807, 128, '2014-04-01 00:56:35.000000', 'consum', 0.0214, 'lps'),
	(607808, 128, '2014-04-01 00:56:36.000000', 'consum', 0.0217, 'lps'),
	(607809, 128, '2014-04-01 00:56:37.000000', 'consum', 0.0214, 'lps'),
	(607810, 128, '2014-04-01 00:56:38.000000', 'consum', 0.0219, 'lps'),
	(607811, 128, '2014-04-01 00:56:39.000000', 'consum', 0.0215, 'lps'),
	(607812, 128, '2014-04-01 00:56:40.000000', 'consum', 0.0218, 'lps'),
	(607813, 128, '2014-04-01 00:56:41.000000', 'consum', 0.0215, 'lps'),
	(607814, 128, '2014-04-01 00:56:42.000000', 'consum', 0.0210, 'lps'),
	(607815, 128, '2014-04-01 00:56:43.000000', 'consum', 0.0216, 'lps'),
	(607816, 128, '2014-04-01 00:56:44.000000', 'consum', 0.0211, 'lps'),
	(607817, 128, '2014-04-01 00:56:45.000000', 'consum', 0.0218, 'lps'),
	(607818, 128, '2014-04-01 00:56:46.000000', 'consum', 0.0218, 'lps'),
	(607819, 128, '2014-04-01 00:56:47.000000', 'consum', 0.0214, 'lps'),
	(607820, 128, '2014-04-01 00:56:48.000000', 'consum', 0.0218, 'lps'),
	(607821, 128, '2014-04-01 00:56:49.000000', 'consum', 0.0217, 'lps'),
	(607822, 128, '2014-04-01 00:56:50.000000', 'consum', 0.0213, 'lps'),
	(607823, 128, '2014-04-01 00:56:51.000000', 'consum', 0.0216, 'lps'),
	(607824, 128, '2014-04-01 00:56:52.000000', 'consum', 0.0210, 'lps'),
	(607825, 128, '2014-04-01 00:56:53.000000', 'consum', 0.0214, 'lps'),
	(607826, 128, '2014-04-01 00:56:54.000000', 'consum', 0.0212, 'lps'),
	(607827, 128, '2014-04-01 00:56:55.000000', 'consum', 0.0215, 'lps'),
	(607828, 128, '2014-04-01 00:56:56.000000', 'consum', 0.0212, 'lps'),
	(607829, 128, '2014-04-01 00:56:57.000000', 'consum', 0.0213, 'lps'),
	(607830, 128, '2014-04-01 00:56:58.000000', 'consum', 0.0211, 'lps'),
	(607831, 128, '2014-04-01 00:56:59.000000', 'consum', 0.0216, 'lps'),
	(607832, 128, '2014-04-01 00:57:00.000000', 'consum', 0.0217, 'lps'),
	(607833, 128, '2014-04-01 00:57:01.000000', 'consum', 0.0218, 'lps'),
	(607834, 128, '2014-04-01 00:57:02.000000', 'consum', 0.0211, 'lps'),
	(607835, 128, '2014-04-01 00:57:03.000000', 'consum', 0.0212, 'lps'),
	(607836, 128, '2014-04-01 00:57:04.000000', 'consum', 0.0218, 'lps'),
	(607837, 128, '2014-04-01 00:57:05.000000', 'consum', 0.0215, 'lps'),
	(607838, 128, '2014-04-01 00:57:06.000000', 'consum', 0.0219, 'lps'),
	(607839, 128, '2014-04-01 00:57:07.000000', 'consum', 0.0211, 'lps'),
	(607840, 128, '2014-04-01 00:57:08.000000', 'consum', 0.0218, 'lps'),
	(607841, 128, '2014-04-01 00:57:09.000000', 'consum', 0.0216, 'lps'),
	(607842, 128, '2014-04-01 00:57:10.000000', 'consum', 0.0210, 'lps'),
	(607843, 128, '2014-04-01 00:57:11.000000', 'consum', 0.0211, 'lps'),
	(607844, 128, '2014-04-01 00:57:12.000000', 'consum', 0.0213, 'lps'),
	(607845, 128, '2014-04-01 00:57:13.000000', 'consum', 0.0216, 'lps'),
	(607846, 128, '2014-04-01 00:57:14.000000', 'consum', 0.0212, 'lps'),
	(607847, 128, '2014-04-01 00:57:15.000000', 'consum', 0.0210, 'lps'),
	(607848, 128, '2014-04-01 00:57:16.000000', 'consum', 0.0215, 'lps'),
	(607849, 128, '2014-04-01 00:57:17.000000', 'consum', 0.0217, 'lps'),
	(607850, 128, '2014-04-01 00:57:18.000000', 'consum', 0.0218, 'lps'),
	(607851, 128, '2014-04-01 00:57:19.000000', 'consum', 0.0210, 'lps'),
	(607852, 128, '2014-04-01 00:57:20.000000', 'consum', 0.0219, 'lps'),
	(607853, 128, '2014-04-01 00:57:21.000000', 'consum', 0.0212, 'lps'),
	(607854, 128, '2014-04-01 00:57:22.000000', 'consum', 0.0216, 'lps'),
	(607855, 128, '2014-04-01 00:57:23.000000', 'consum', 0.0215, 'lps'),
	(607856, 128, '2014-04-01 00:57:24.000000', 'consum', 0.0218, 'lps'),
	(607857, 128, '2014-04-01 00:57:25.000000', 'consum', 0.0213, 'lps'),
	(607858, 128, '2014-04-01 00:57:26.000000', 'consum', 0.0212, 'lps'),
	(607859, 128, '2014-04-01 00:57:27.000000', 'consum', 0.0210, 'lps'),
	(607860, 128, '2014-04-01 00:57:28.000000', 'consum', 0.0217, 'lps'),
	(607861, 128, '2014-04-01 00:57:29.000000', 'consum', 0.0214, 'lps'),
	(607862, 128, '2014-04-01 00:57:30.000000', 'consum', 0.0212, 'lps'),
	(607863, 128, '2014-04-01 00:57:31.000000', 'consum', 0.0216, 'lps'),
	(607864, 128, '2014-04-01 00:57:32.000000', 'consum', 0.0214, 'lps'),
	(607865, 128, '2014-04-01 00:57:33.000000', 'consum', 0.0213, 'lps'),
	(607866, 128, '2014-04-01 00:57:34.000000', 'consum', 0.0215, 'lps'),
	(607867, 128, '2014-04-01 00:57:35.000000', 'consum', 0.0214, 'lps'),
	(607868, 128, '2014-04-01 00:57:36.000000', 'consum', 0.0216, 'lps'),
	(607869, 128, '2014-04-01 00:57:37.000000', 'consum', 0.0219, 'lps'),
	(607870, 128, '2014-04-01 00:57:38.000000', 'consum', 0.0216, 'lps'),
	(607871, 128, '2014-04-01 00:57:39.000000', 'consum', 0.0214, 'lps'),
	(607872, 128, '2014-04-01 00:57:40.000000', 'consum', 0.0213, 'lps'),
	(607873, 128, '2014-04-01 00:57:41.000000', 'consum', 0.0212, 'lps'),
	(607874, 128, '2014-04-01 00:57:42.000000', 'consum', 0.0211, 'lps'),
	(607875, 128, '2014-04-01 00:57:43.000000', 'consum', 0.0219, 'lps'),
	(607876, 128, '2014-04-01 00:57:44.000000', 'consum', 0.0213, 'lps'),
	(607877, 128, '2014-04-01 00:57:45.000000', 'consum', 0.0211, 'lps'),
	(607878, 128, '2014-04-01 00:57:46.000000', 'consum', 0.0214, 'lps'),
	(607879, 128, '2014-04-01 00:57:47.000000', 'consum', 0.0217, 'lps'),
	(607880, 128, '2014-04-01 00:57:48.000000', 'consum', 0.0213, 'lps'),
	(607881, 128, '2014-04-01 00:57:49.000000', 'consum', 0.0215, 'lps'),
	(607882, 128, '2014-04-01 00:57:50.000000', 'consum', 0.0215, 'lps'),
	(607883, 128, '2014-04-01 00:57:51.000000', 'consum', 0.0211, 'lps'),
	(607884, 128, '2014-04-01 00:57:52.000000', 'consum', 0.0211, 'lps'),
	(607885, 128, '2014-04-01 00:57:53.000000', 'consum', 0.0211, 'lps'),
	(607886, 128, '2014-04-01 00:57:54.000000', 'consum', 0.0212, 'lps'),
	(607887, 128, '2014-04-01 00:57:55.000000', 'consum', 0.0218, 'lps'),
	(607888, 128, '2014-04-01 00:57:56.000000', 'consum', 0.0215, 'lps'),
	(607889, 128, '2014-04-01 00:57:57.000000', 'consum', 0.0210, 'lps'),
	(607890, 128, '2014-04-01 00:57:58.000000', 'consum', 0.0218, 'lps'),
	(607891, 128, '2014-04-01 00:57:59.000000', 'consum', 0.0210, 'lps'),
	(607892, 128, '2014-04-01 00:58:00.000000', 'consum', 0.0215, 'lps'),
	(607893, 128, '2014-04-01 00:58:01.000000', 'consum', 0.0214, 'lps'),
	(607894, 128, '2014-04-01 00:58:02.000000', 'consum', 0.0219, 'lps'),
	(607895, 128, '2014-04-01 00:58:03.000000', 'consum', 0.0211, 'lps'),
	(607896, 128, '2014-04-01 00:58:04.000000', 'consum', 0.0210, 'lps'),
	(607897, 128, '2014-04-01 00:58:05.000000', 'consum', 0.0217, 'lps'),
	(607898, 128, '2014-04-01 00:58:06.000000', 'consum', 0.0214, 'lps'),
	(607899, 128, '2014-04-01 00:58:07.000000', 'consum', 0.0212, 'lps'),
	(607900, 128, '2014-04-01 00:58:08.000000', 'consum', 0.0218, 'lps'),
	(607901, 128, '2014-04-01 00:58:09.000000', 'consum', 0.0215, 'lps'),
	(607902, 128, '2014-04-01 00:58:10.000000', 'consum', 0.0219, 'lps'),
	(607903, 128, '2014-04-01 00:58:11.000000', 'consum', 0.0211, 'lps'),
	(607904, 128, '2014-04-01 00:58:12.000000', 'consum', 0.0219, 'lps'),
	(607905, 128, '2014-04-01 00:58:13.000000', 'consum', 0.0213, 'lps'),
	(607906, 128, '2014-04-01 00:58:14.000000', 'consum', 0.0219, 'lps'),
	(607907, 128, '2014-04-01 00:58:15.000000', 'consum', 0.0216, 'lps'),
	(607908, 128, '2014-04-01 00:58:16.000000', 'consum', 0.0213, 'lps'),
	(607909, 128, '2014-04-01 00:58:17.000000', 'consum', 0.0217, 'lps'),
	(607910, 128, '2014-04-01 00:58:18.000000', 'consum', 0.0218, 'lps'),
	(607911, 128, '2014-04-01 00:58:19.000000', 'consum', 0.0211, 'lps'),
	(607912, 128, '2014-04-01 00:58:20.000000', 'consum', 0.0219, 'lps'),
	(607913, 128, '2014-04-01 00:58:21.000000', 'consum', 0.0214, 'lps'),
	(607914, 128, '2014-04-01 00:58:22.000000', 'consum', 0.0212, 'lps'),
	(607915, 128, '2014-04-01 00:58:23.000000', 'consum', 0.0217, 'lps'),
	(607916, 128, '2014-04-01 00:58:24.000000', 'consum', 0.0211, 'lps'),
	(607917, 128, '2014-04-01 00:58:25.000000', 'consum', 0.0216, 'lps'),
	(607918, 128, '2014-04-01 00:58:26.000000', 'consum', 0.0216, 'lps'),
	(607919, 128, '2014-04-01 00:58:27.000000', 'consum', 0.0212, 'lps'),
	(607920, 128, '2014-04-01 00:58:28.000000', 'consum', 0.0215, 'lps'),
	(607921, 128, '2014-04-01 00:58:29.000000', 'consum', 0.0216, 'lps'),
	(607922, 128, '2014-04-01 00:58:30.000000', 'consum', 0.0218, 'lps'),
	(607923, 128, '2014-04-01 00:58:31.000000', 'consum', 0.0214, 'lps'),
	(607924, 128, '2014-04-01 00:58:32.000000', 'consum', 0.0214, 'lps'),
	(607925, 128, '2014-04-01 00:58:33.000000', 'consum', 0.0219, 'lps'),
	(607926, 128, '2014-04-01 00:58:34.000000', 'consum', 0.0212, 'lps'),
	(607927, 128, '2014-04-01 00:58:35.000000', 'consum', 0.0214, 'lps'),
	(607928, 128, '2014-04-01 00:58:36.000000', 'consum', 0.0215, 'lps'),
	(607929, 128, '2014-04-01 00:58:37.000000', 'consum', 0.0215, 'lps'),
	(607930, 128, '2014-04-01 00:58:38.000000', 'consum', 0.0218, 'lps'),
	(607931, 128, '2014-04-01 00:58:39.000000', 'consum', 0.0218, 'lps'),
	(607932, 128, '2014-04-01 00:58:40.000000', 'consum', 0.0217, 'lps'),
	(607933, 128, '2014-04-01 00:58:41.000000', 'consum', 0.0212, 'lps'),
	(607934, 128, '2014-04-01 00:58:42.000000', 'consum', 0.0216, 'lps'),
	(607935, 128, '2014-04-01 00:58:43.000000', 'consum', 0.0217, 'lps'),
	(607936, 128, '2014-04-01 00:58:44.000000', 'consum', 0.0219, 'lps'),
	(607937, 128, '2014-04-01 00:58:45.000000', 'consum', 0.0211, 'lps'),
	(607938, 128, '2014-04-01 00:58:46.000000', 'consum', 0.0212, 'lps'),
	(607939, 128, '2014-04-01 00:58:47.000000', 'consum', 0.0216, 'lps'),
	(607940, 128, '2014-04-01 00:58:48.000000', 'consum', 0.0214, 'lps'),
	(607941, 128, '2014-04-01 00:58:49.000000', 'consum', 0.0212, 'lps'),
	(607942, 128, '2014-04-01 00:58:50.000000', 'consum', 0.0219, 'lps'),
	(607943, 128, '2014-04-01 00:58:51.000000', 'consum', 0.0211, 'lps'),
	(607944, 128, '2014-04-01 00:58:52.000000', 'consum', 0.0218, 'lps'),
	(607945, 128, '2014-04-01 00:58:53.000000', 'consum', 0.0216, 'lps'),
	(607946, 128, '2014-04-01 00:58:54.000000', 'consum', 0.0218, 'lps'),
	(607947, 128, '2014-04-01 00:58:55.000000', 'consum', 0.0213, 'lps'),
	(607948, 128, '2014-04-01 00:58:56.000000', 'consum', 0.0210, 'lps'),
	(607949, 128, '2014-04-01 00:58:57.000000', 'consum', 0.0210, 'lps'),
	(607950, 128, '2014-04-01 00:58:58.000000', 'consum', 0.0212, 'lps'),
	(607951, 128, '2014-04-01 00:58:59.000000', 'consum', 0.0211, 'lps'),
	(607952, 128, '2014-04-01 00:59:00.000000', 'consum', 0.0210, 'lps'),
	(607953, 128, '2014-04-01 00:59:01.000000', 'consum', 0.0218, 'lps'),
	(607954, 128, '2014-04-01 00:59:02.000000', 'consum', 0.0210, 'lps'),
	(607955, 128, '2014-04-01 00:59:03.000000', 'consum', 0.0216, 'lps'),
	(607956, 128, '2014-04-01 00:59:04.000000', 'consum', 0.0211, 'lps'),
	(607957, 128, '2014-04-01 00:59:05.000000', 'consum', 0.0218, 'lps'),
	(607958, 128, '2014-04-01 00:59:06.000000', 'consum', 0.0218, 'lps'),
	(607959, 128, '2014-04-01 00:59:07.000000', 'consum', 0.0216, 'lps'),
	(607960, 128, '2014-04-01 00:59:08.000000', 'consum', 0.0217, 'lps'),
	(607961, 128, '2014-04-01 00:59:09.000000', 'consum', 0.0218, 'lps'),
	(607962, 128, '2014-04-01 00:59:10.000000', 'consum', 0.0210, 'lps'),
	(607963, 128, '2014-04-01 00:59:11.000000', 'consum', 0.0215, 'lps'),
	(607964, 128, '2014-04-01 00:59:12.000000', 'consum', 0.0215, 'lps'),
	(607965, 128, '2014-04-01 00:59:13.000000', 'consum', 0.0213, 'lps'),
	(607966, 128, '2014-04-01 00:59:14.000000', 'consum', 0.0219, 'lps'),
	(607967, 128, '2014-04-01 00:59:15.000000', 'consum', 0.0215, 'lps'),
	(607968, 128, '2014-04-01 00:59:16.000000', 'consum', 0.0212, 'lps'),
	(607969, 128, '2014-04-01 00:59:17.000000', 'consum', 0.0213, 'lps'),
	(607970, 128, '2014-04-01 00:59:18.000000', 'consum', 0.0210, 'lps'),
	(607971, 128, '2014-04-01 00:59:19.000000', 'consum', 0.0213, 'lps'),
	(607972, 128, '2014-04-01 00:59:20.000000', 'consum', 0.0214, 'lps'),
	(607973, 128, '2014-04-01 00:59:21.000000', 'consum', 0.0210, 'lps'),
	(607974, 128, '2014-04-01 00:59:22.000000', 'consum', 0.0210, 'lps'),
	(607975, 128, '2014-04-01 00:59:23.000000', 'consum', 0.0211, 'lps'),
	(607976, 128, '2014-04-01 00:59:24.000000', 'consum', 0.0214, 'lps'),
	(607977, 128, '2014-04-01 00:59:25.000000', 'consum', 0.0210, 'lps'),
	(607978, 128, '2014-04-01 00:59:26.000000', 'consum', 0.0218, 'lps'),
	(607979, 128, '2014-04-01 00:59:27.000000', 'consum', 0.0211, 'lps'),
	(607980, 128, '2014-04-01 00:59:28.000000', 'consum', 0.0212, 'lps'),
	(607981, 128, '2014-04-01 00:59:29.000000', 'consum', 0.0216, 'lps'),
	(607982, 128, '2014-04-01 00:59:30.000000', 'consum', 0.0214, 'lps'),
	(607983, 128, '2014-04-01 00:59:31.000000', 'consum', 0.0213, 'lps'),
	(607984, 128, '2014-04-01 00:59:32.000000', 'consum', 0.0212, 'lps'),
	(607985, 128, '2014-04-01 00:59:33.000000', 'consum', 0.0214, 'lps'),
	(607986, 128, '2014-04-01 00:59:34.000000', 'consum', 0.0214, 'lps'),
	(607987, 128, '2014-04-01 00:59:35.000000', 'consum', 0.0210, 'lps'),
	(607988, 128, '2014-04-01 00:59:36.000000', 'consum', 0.0218, 'lps'),
	(607989, 128, '2014-04-01 00:59:37.000000', 'consum', 0.0212, 'lps'),
	(607990, 128, '2014-04-01 00:59:38.000000', 'consum', 0.0215, 'lps'),
	(607991, 128, '2014-04-01 00:59:39.000000', 'consum', 0.0211, 'lps'),
	(607992, 128, '2014-04-01 00:59:40.000000', 'consum', 0.0219, 'lps'),
	(607993, 128, '2014-04-01 00:59:41.000000', 'consum', 0.0211, 'lps'),
	(607994, 128, '2014-04-01 00:59:42.000000', 'consum', 0.0219, 'lps'),
	(607995, 128, '2014-04-01 00:59:43.000000', 'consum', 0.0211, 'lps'),
	(607996, 128, '2014-04-01 00:59:44.000000', 'consum', 0.0212, 'lps'),
	(607997, 128, '2014-04-01 00:59:45.000000', 'consum', 0.0215, 'lps'),
	(607998, 128, '2014-04-01 00:59:46.000000', 'consum', 0.0210, 'lps'),
	(607999, 128, '2014-04-01 00:59:47.000000', 'consum', 0.0216, 'lps'),
	(608000, 128, '2014-04-01 00:59:48.000000', 'consum', 0.0212, 'lps'),
	(608001, 128, '2014-04-01 00:59:49.000000', 'consum', 0.0213, 'lps'),
	(608002, 128, '2014-04-01 00:59:50.000000', 'consum', 0.0219, 'lps'),
	(608003, 128, '2014-04-01 00:59:51.000000', 'consum', 0.0214, 'lps'),
	(608004, 128, '2014-04-01 00:59:52.000000', 'consum', 0.0216, 'lps'),
	(608005, 128, '2014-04-01 00:59:53.000000', 'consum', 0.0218, 'lps'),
	(608006, 128, '2014-04-01 00:59:54.000000', 'consum', 0.0211, 'lps'),
	(608007, 128, '2014-04-01 00:59:55.000000', 'consum', 0.0212, 'lps'),
	(608008, 128, '2014-04-01 00:59:56.000000', 'consum', 0.0218, 'lps'),
	(608009, 128, '2014-04-01 00:59:57.000000', 'consum', 0.0213, 'lps'),
	(608010, 128, '2014-04-01 00:59:58.000000', 'consum', 0.0211, 'lps'),
	(608011, 128, '2014-04-01 00:59:59.000000', 'consum', 0.0217, 'lps'),
	(608012, 128, '2014-04-01 01:00:00.000000', 'consum', 0.0212, 'lps'),
	(608013, 128, '2014-04-01 01:00:01.000000', 'consum', 0.0219, 'lps'),
	(608014, 128, '2014-04-01 01:00:02.000000', 'consum', 0.0212, 'lps'),
	(608015, 128, '2014-04-01 01:00:03.000000', 'consum', 0.0211, 'lps'),
	(608016, 128, '2014-04-01 01:00:04.000000', 'consum', 0.0212, 'lps'),
	(608017, 128, '2014-04-01 01:00:05.000000', 'consum', 0.0214, 'lps'),
	(608018, 128, '2014-04-01 01:00:06.000000', 'consum', 0.0218, 'lps'),
	(608019, 128, '2014-04-01 01:00:07.000000', 'consum', 0.0215, 'lps'),
	(608020, 128, '2014-04-01 01:00:08.000000', 'consum', 0.0214, 'lps'),
	(608021, 128, '2014-04-01 01:00:09.000000', 'consum', 0.0217, 'lps'),
	(608022, 128, '2014-04-01 01:00:10.000000', 'consum', 0.0210, 'lps'),
	(608023, 128, '2014-04-01 01:00:11.000000', 'consum', 0.0212, 'lps'),
	(608024, 128, '2014-04-01 01:00:12.000000', 'consum', 0.0219, 'lps'),
	(608025, 128, '2014-04-01 01:00:13.000000', 'consum', 0.0211, 'lps'),
	(608026, 128, '2014-04-01 01:00:14.000000', 'consum', 0.0219, 'lps'),
	(608027, 128, '2014-04-01 01:00:15.000000', 'consum', 0.0212, 'lps'),
	(608028, 128, '2014-04-01 01:00:16.000000', 'consum', 0.0212, 'lps'),
	(608029, 128, '2014-04-01 01:00:17.000000', 'consum', 0.0214, 'lps'),
	(608030, 128, '2014-04-01 01:00:18.000000', 'consum', 0.0217, 'lps'),
	(608031, 128, '2014-04-01 01:00:19.000000', 'consum', 0.0213, 'lps'),
	(608032, 128, '2014-04-01 01:00:20.000000', 'consum', 0.0213, 'lps'),
	(608033, 128, '2014-04-01 01:00:21.000000', 'consum', 0.0216, 'lps'),
	(608034, 128, '2014-04-01 01:00:22.000000', 'consum', 0.0211, 'lps'),
	(608035, 128, '2014-04-01 01:00:23.000000', 'consum', 0.0219, 'lps'),
	(608036, 128, '2014-04-01 01:00:24.000000', 'consum', 0.0213, 'lps'),
	(608037, 128, '2014-04-01 01:00:25.000000', 'consum', 0.0217, 'lps'),
	(608038, 128, '2014-04-01 01:00:26.000000', 'consum', 0.0217, 'lps'),
	(608039, 128, '2014-04-01 01:00:27.000000', 'consum', 0.0216, 'lps'),
	(608040, 128, '2014-04-01 01:00:28.000000', 'consum', 0.0218, 'lps'),
	(608041, 128, '2014-04-01 01:00:29.000000', 'consum', 0.0213, 'lps'),
	(608042, 128, '2014-04-01 01:00:30.000000', 'consum', 0.0210, 'lps'),
	(608043, 128, '2014-04-01 01:00:31.000000', 'consum', 0.0214, 'lps'),
	(608044, 128, '2014-04-01 01:00:32.000000', 'consum', 0.0217, 'lps'),
	(608045, 128, '2014-04-01 01:00:33.000000', 'consum', 0.0217, 'lps'),
	(608046, 128, '2014-04-01 01:00:34.000000', 'consum', 0.0213, 'lps'),
	(608047, 128, '2014-04-01 01:00:35.000000', 'consum', 0.0215, 'lps'),
	(608048, 128, '2014-04-01 01:00:36.000000', 'consum', 0.0214, 'lps'),
	(608049, 128, '2014-04-01 01:00:37.000000', 'consum', 0.0218, 'lps'),
	(608050, 128, '2014-04-01 01:00:38.000000', 'consum', 0.0218, 'lps'),
	(608051, 128, '2014-04-01 01:00:39.000000', 'consum', 0.0216, 'lps'),
	(608052, 128, '2014-04-01 01:00:40.000000', 'consum', 0.0217, 'lps'),
	(608053, 128, '2014-04-01 01:00:41.000000', 'consum', 0.0215, 'lps'),
	(608054, 128, '2014-04-01 01:00:42.000000', 'consum', 0.0217, 'lps'),
	(608055, 128, '2014-04-01 01:00:43.000000', 'consum', 0.0210, 'lps'),
	(608056, 128, '2014-04-01 01:00:44.000000', 'consum', 0.0219, 'lps'),
	(608057, 128, '2014-04-01 01:00:45.000000', 'consum', 0.0215, 'lps'),
	(608058, 128, '2014-04-01 01:00:46.000000', 'consum', 0.0210, 'lps'),
	(608059, 128, '2014-04-01 01:00:47.000000', 'consum', 0.0214, 'lps'),
	(608060, 128, '2014-04-01 01:00:48.000000', 'consum', 0.0219, 'lps'),
	(608061, 128, '2014-04-01 01:00:49.000000', 'consum', 0.0215, 'lps'),
	(608062, 128, '2014-04-01 01:00:50.000000', 'consum', 0.0219, 'lps'),
	(608063, 128, '2014-04-01 01:00:51.000000', 'consum', 0.0219, 'lps'),
	(608064, 128, '2014-04-01 01:00:52.000000', 'consum', 0.0218, 'lps'),
	(608065, 128, '2014-04-01 01:00:53.000000', 'consum', 0.0212, 'lps'),
	(608066, 128, '2014-04-01 01:00:54.000000', 'consum', 0.0210, 'lps'),
	(608067, 128, '2014-04-01 01:00:55.000000', 'consum', 0.0215, 'lps'),
	(608068, 128, '2014-04-01 01:00:56.000000', 'consum', 0.0212, 'lps'),
	(608069, 128, '2014-04-01 01:00:57.000000', 'consum', 0.0218, 'lps'),
	(608070, 128, '2014-04-01 01:00:58.000000', 'consum', 0.0213, 'lps'),
	(608071, 128, '2014-04-01 01:00:59.000000', 'consum', 0.0213, 'lps'),
	(608072, 128, '2014-04-01 01:01:00.000000', 'consum', 0.0214, 'lps'),
	(608073, 128, '2014-04-01 01:01:01.000000', 'consum', 0.0212, 'lps'),
	(608074, 128, '2014-04-01 01:01:02.000000', 'consum', 0.0217, 'lps'),
	(608075, 128, '2014-04-01 01:01:03.000000', 'consum', 0.0213, 'lps'),
	(608076, 128, '2014-04-01 01:01:04.000000', 'consum', 0.0212, 'lps'),
	(608077, 128, '2014-04-01 01:01:05.000000', 'consum', 0.0213, 'lps'),
	(608078, 128, '2014-04-01 01:01:06.000000', 'consum', 0.0217, 'lps'),
	(608079, 128, '2014-04-01 01:01:07.000000', 'consum', 0.0219, 'lps'),
	(608080, 128, '2014-04-01 01:01:08.000000', 'consum', 0.0215, 'lps'),
	(608081, 128, '2014-04-01 01:01:09.000000', 'consum', 0.0218, 'lps'),
	(608082, 128, '2014-04-01 01:01:10.000000', 'consum', 0.0217, 'lps'),
	(608083, 128, '2014-04-01 01:01:11.000000', 'consum', 0.0211, 'lps'),
	(608084, 128, '2014-04-01 01:01:12.000000', 'consum', 0.0213, 'lps'),
	(608085, 128, '2014-04-01 01:01:13.000000', 'consum', 0.0215, 'lps'),
	(608086, 128, '2014-04-01 01:01:14.000000', 'consum', 0.0214, 'lps'),
	(608087, 128, '2014-04-01 01:01:15.000000', 'consum', 0.0216, 'lps'),
	(608088, 128, '2014-04-01 01:01:16.000000', 'consum', 0.0211, 'lps'),
	(608089, 128, '2014-04-01 01:01:17.000000', 'consum', 0.0214, 'lps'),
	(608090, 128, '2014-04-01 01:01:18.000000', 'consum', 0.0210, 'lps'),
	(608091, 128, '2014-04-01 01:01:19.000000', 'consum', 0.0219, 'lps'),
	(608092, 128, '2014-04-01 01:01:20.000000', 'consum', 0.0215, 'lps'),
	(608093, 128, '2014-04-01 01:01:21.000000', 'consum', 0.0217, 'lps'),
	(608094, 128, '2014-04-01 01:01:22.000000', 'consum', 0.0210, 'lps'),
	(608095, 128, '2014-04-01 01:01:23.000000', 'consum', 0.0211, 'lps'),
	(608096, 128, '2014-04-01 01:01:24.000000', 'consum', 0.0216, 'lps'),
	(608097, 128, '2014-04-01 01:01:25.000000', 'consum', 0.0215, 'lps'),
	(608098, 128, '2014-04-01 01:01:26.000000', 'consum', 0.0218, 'lps'),
	(608099, 128, '2014-04-01 01:01:27.000000', 'consum', 0.0215, 'lps'),
	(608100, 128, '2014-04-01 01:01:28.000000', 'consum', 0.0214, 'lps'),
	(608101, 128, '2014-04-01 01:01:29.000000', 'consum', 0.0213, 'lps'),
	(608102, 128, '2014-04-01 01:01:30.000000', 'consum', 0.0216, 'lps'),
	(608103, 128, '2014-04-01 01:01:31.000000', 'consum', 0.0219, 'lps'),
	(608104, 128, '2014-04-01 01:01:32.000000', 'consum', 0.0219, 'lps'),
	(608105, 128, '2014-04-01 01:01:33.000000', 'consum', 0.0217, 'lps'),
	(608106, 128, '2014-04-01 01:01:34.000000', 'consum', 0.0219, 'lps'),
	(608107, 128, '2014-04-01 01:01:35.000000', 'consum', 0.0214, 'lps'),
	(608108, 128, '2014-04-01 01:01:36.000000', 'consum', 0.0213, 'lps'),
	(608109, 128, '2014-04-01 01:01:37.000000', 'consum', 0.0213, 'lps'),
	(608110, 128, '2014-04-01 01:01:38.000000', 'consum', 0.0218, 'lps'),
	(608111, 128, '2014-04-01 01:01:39.000000', 'consum', 0.0210, 'lps'),
	(608112, 128, '2014-04-01 01:01:40.000000', 'consum', 0.0218, 'lps'),
	(608113, 128, '2014-04-01 01:01:41.000000', 'consum', 0.0210, 'lps'),
	(608114, 128, '2014-04-01 01:01:42.000000', 'consum', 0.0216, 'lps'),
	(608115, 128, '2014-04-01 01:01:43.000000', 'consum', 0.0211, 'lps'),
	(608116, 128, '2014-04-01 01:01:44.000000', 'consum', 0.0216, 'lps'),
	(608117, 128, '2014-04-01 01:01:45.000000', 'consum', 0.0217, 'lps'),
	(608118, 128, '2014-04-01 01:01:46.000000', 'consum', 0.0219, 'lps'),
	(608119, 128, '2014-04-01 01:01:47.000000', 'consum', 0.0215, 'lps'),
	(608120, 128, '2014-04-01 01:01:48.000000', 'consum', 0.0217, 'lps'),
	(608121, 128, '2014-04-01 01:01:49.000000', 'consum', 0.0213, 'lps'),
	(608122, 128, '2014-04-01 01:01:50.000000', 'consum', 0.0211, 'lps'),
	(608123, 128, '2014-04-01 01:01:51.000000', 'consum', 0.0219, 'lps'),
	(608124, 128, '2014-04-01 01:01:52.000000', 'consum', 0.0210, 'lps'),
	(608125, 128, '2014-04-01 01:01:53.000000', 'consum', 0.0214, 'lps'),
	(608126, 128, '2014-04-01 01:01:54.000000', 'consum', 0.0210, 'lps'),
	(608127, 128, '2014-04-01 01:01:55.000000', 'consum', 0.0218, 'lps'),
	(608128, 128, '2014-04-01 01:01:56.000000', 'consum', 0.0213, 'lps'),
	(608129, 128, '2014-04-01 01:01:57.000000', 'consum', 0.0212, 'lps'),
	(608130, 128, '2014-04-01 01:01:58.000000', 'consum', 0.0211, 'lps'),
	(608131, 128, '2014-04-01 01:01:59.000000', 'consum', 0.0218, 'lps'),
	(608132, 128, '2014-04-01 01:02:00.000000', 'consum', 0.0210, 'lps'),
	(608133, 128, '2014-04-01 01:02:01.000000', 'consum', 0.0214, 'lps'),
	(608134, 128, '2014-04-01 01:02:02.000000', 'consum', 0.0219, 'lps'),
	(608135, 128, '2014-04-01 01:02:03.000000', 'consum', 0.0217, 'lps'),
	(608136, 128, '2014-04-01 01:02:04.000000', 'consum', 0.0216, 'lps'),
	(608137, 128, '2014-04-01 01:02:05.000000', 'consum', 0.0212, 'lps'),
	(608138, 128, '2014-04-01 01:02:06.000000', 'consum', 0.0211, 'lps'),
	(608139, 128, '2014-04-01 01:02:07.000000', 'consum', 0.0219, 'lps'),
	(608140, 128, '2014-04-01 01:02:08.000000', 'consum', 0.0213, 'lps'),
	(608141, 128, '2014-04-01 01:02:09.000000', 'consum', 0.0219, 'lps'),
	(608142, 128, '2014-04-01 01:02:10.000000', 'consum', 0.0218, 'lps'),
	(608143, 128, '2014-04-01 01:02:11.000000', 'consum', 0.0212, 'lps'),
	(608144, 128, '2014-04-01 01:02:12.000000', 'consum', 0.0218, 'lps'),
	(608145, 128, '2014-04-01 01:02:13.000000', 'consum', 0.0215, 'lps'),
	(608146, 128, '2014-04-01 01:02:14.000000', 'consum', 0.0213, 'lps'),
	(608147, 128, '2014-04-01 01:02:15.000000', 'consum', 0.0217, 'lps'),
	(608148, 128, '2014-04-01 01:02:16.000000', 'consum', 0.0217, 'lps'),
	(608149, 128, '2014-04-01 01:02:17.000000', 'consum', 0.0214, 'lps'),
	(608150, 128, '2014-04-01 01:02:18.000000', 'consum', 0.0219, 'lps'),
	(608151, 128, '2014-04-01 01:02:19.000000', 'consum', 0.0213, 'lps'),
	(608152, 128, '2014-04-01 01:02:20.000000', 'consum', 0.0210, 'lps'),
	(608153, 128, '2014-04-01 01:02:21.000000', 'consum', 0.0213, 'lps'),
	(608154, 128, '2014-04-01 01:02:22.000000', 'consum', 0.0213, 'lps'),
	(608155, 128, '2014-04-01 01:02:23.000000', 'consum', 0.0219, 'lps'),
	(608156, 128, '2014-04-01 01:02:24.000000', 'consum', 0.0217, 'lps'),
	(608157, 128, '2014-04-01 01:02:25.000000', 'consum', 0.0218, 'lps'),
	(608158, 128, '2014-04-01 01:02:26.000000', 'consum', 0.0211, 'lps'),
	(608159, 128, '2014-04-01 01:02:27.000000', 'consum', 0.0211, 'lps'),
	(608160, 128, '2014-04-01 01:02:28.000000', 'consum', 0.0210, 'lps'),
	(608161, 128, '2014-04-01 01:02:29.000000', 'consum', 0.0210, 'lps'),
	(608162, 128, '2014-04-01 01:02:30.000000', 'consum', 0.0211, 'lps'),
	(608163, 128, '2014-04-01 01:02:31.000000', 'consum', 0.0215, 'lps'),
	(608164, 128, '2014-04-01 01:02:32.000000', 'consum', 0.0212, 'lps'),
	(608165, 128, '2014-04-01 01:02:33.000000', 'consum', 0.0214, 'lps'),
	(608166, 128, '2014-04-01 01:02:34.000000', 'consum', 0.0217, 'lps'),
	(608167, 128, '2014-04-01 01:02:35.000000', 'consum', 0.0212, 'lps'),
	(608168, 128, '2014-04-01 01:02:36.000000', 'consum', 0.0219, 'lps'),
	(608169, 128, '2014-04-01 01:02:37.000000', 'consum', 0.0211, 'lps'),
	(608170, 128, '2014-04-01 01:02:38.000000', 'consum', 0.0219, 'lps'),
	(608171, 128, '2014-04-01 01:02:39.000000', 'consum', 0.0210, 'lps'),
	(608172, 128, '2014-04-01 01:02:40.000000', 'consum', 0.0214, 'lps'),
	(608173, 128, '2014-04-01 01:02:41.000000', 'consum', 0.0212, 'lps'),
	(608174, 128, '2014-04-01 01:02:42.000000', 'consum', 0.0216, 'lps'),
	(608175, 128, '2014-04-01 01:02:43.000000', 'consum', 0.0217, 'lps'),
	(608176, 128, '2014-04-01 01:02:44.000000', 'consum', 0.0217, 'lps'),
	(608177, 128, '2014-04-01 01:02:45.000000', 'consum', 0.0214, 'lps'),
	(608178, 128, '2014-04-01 01:02:46.000000', 'consum', 0.0218, 'lps'),
	(608179, 128, '2014-04-01 01:02:47.000000', 'consum', 0.0211, 'lps'),
	(608180, 128, '2014-04-01 01:02:48.000000', 'consum', 0.0210, 'lps'),
	(608181, 128, '2014-04-01 01:02:49.000000', 'consum', 0.0216, 'lps'),
	(608182, 128, '2014-04-01 01:02:50.000000', 'consum', 0.0212, 'lps'),
	(608183, 128, '2014-04-01 01:02:51.000000', 'consum', 0.0211, 'lps'),
	(608184, 128, '2014-04-01 01:02:52.000000', 'consum', 0.0219, 'lps'),
	(608185, 128, '2014-04-01 01:02:53.000000', 'consum', 0.0212, 'lps'),
	(608186, 128, '2014-04-01 01:02:54.000000', 'consum', 0.0213, 'lps'),
	(608187, 128, '2014-04-01 01:02:55.000000', 'consum', 0.0219, 'lps'),
	(608188, 128, '2014-04-01 01:02:56.000000', 'consum', 0.0218, 'lps'),
	(608189, 128, '2014-04-01 01:02:57.000000', 'consum', 0.0213, 'lps'),
	(608190, 128, '2014-04-01 01:02:58.000000', 'consum', 0.0213, 'lps'),
	(608191, 128, '2014-04-01 01:02:59.000000', 'consum', 0.0217, 'lps'),
	(608192, 128, '2014-04-01 01:03:00.000000', 'consum', 0.0217, 'lps'),
	(608193, 128, '2014-04-01 01:03:01.000000', 'consum', 0.0214, 'lps'),
	(608194, 128, '2014-04-01 01:03:02.000000', 'consum', 0.0218, 'lps'),
	(608195, 128, '2014-04-01 01:03:03.000000', 'consum', 0.0219, 'lps'),
	(608196, 128, '2014-04-01 01:03:04.000000', 'consum', 0.0212, 'lps'),
	(608197, 128, '2014-04-01 01:03:05.000000', 'consum', 0.0214, 'lps'),
	(608198, 128, '2014-04-01 01:03:06.000000', 'consum', 0.0214, 'lps'),
	(608199, 128, '2014-04-01 01:03:07.000000', 'consum', 0.0216, 'lps'),
	(608200, 128, '2014-04-01 01:03:08.000000', 'consum', 0.0212, 'lps'),
	(608201, 128, '2014-04-01 01:03:09.000000', 'consum', 0.0211, 'lps'),
	(608202, 128, '2014-04-01 01:03:10.000000', 'consum', 0.0212, 'lps'),
	(608203, 128, '2014-04-01 01:03:11.000000', 'consum', 0.0214, 'lps'),
	(608204, 128, '2014-04-01 01:03:12.000000', 'consum', 0.0218, 'lps'),
	(608205, 128, '2014-04-01 01:03:13.000000', 'consum', 0.0216, 'lps'),
	(608206, 128, '2014-04-01 01:03:14.000000', 'consum', 0.0215, 'lps'),
	(608207, 128, '2014-04-01 01:03:15.000000', 'consum', 0.0210, 'lps'),
	(608208, 128, '2014-04-01 01:03:16.000000', 'consum', 0.0214, 'lps'),
	(608209, 128, '2014-04-01 01:03:17.000000', 'consum', 0.0211, 'lps'),
	(608210, 128, '2014-04-01 01:03:18.000000', 'consum', 0.0214, 'lps'),
	(608211, 128, '2014-04-01 01:03:19.000000', 'consum', 0.0216, 'lps'),
	(608212, 128, '2014-04-01 01:03:20.000000', 'consum', 0.0210, 'lps'),
	(608213, 128, '2014-04-01 01:03:21.000000', 'consum', 0.0214, 'lps'),
	(608214, 128, '2014-04-01 01:03:22.000000', 'consum', 0.0217, 'lps'),
	(608215, 128, '2014-04-01 01:03:23.000000', 'consum', 0.0216, 'lps'),
	(608216, 128, '2014-04-01 01:03:24.000000', 'consum', 0.0217, 'lps'),
	(608217, 128, '2014-04-01 01:03:25.000000', 'consum', 0.0218, 'lps'),
	(608218, 128, '2014-04-01 01:03:26.000000', 'consum', 0.0210, 'lps'),
	(608219, 128, '2014-04-01 01:03:27.000000', 'consum', 0.0217, 'lps'),
	(608220, 128, '2014-04-01 01:03:28.000000', 'consum', 0.0215, 'lps'),
	(608221, 128, '2014-04-01 01:03:29.000000', 'consum', 0.0215, 'lps'),
	(608222, 128, '2014-04-01 01:03:30.000000', 'consum', 0.0210, 'lps'),
	(608223, 128, '2014-04-01 01:03:31.000000', 'consum', 0.0215, 'lps'),
	(608224, 128, '2014-04-01 01:03:32.000000', 'consum', 0.0214, 'lps'),
	(608225, 128, '2014-04-01 01:03:33.000000', 'consum', 0.0219, 'lps'),
	(608226, 128, '2014-04-01 01:03:34.000000', 'consum', 0.0211, 'lps'),
	(608227, 128, '2014-04-01 01:03:35.000000', 'consum', 0.0217, 'lps'),
	(608228, 128, '2014-04-01 01:03:36.000000', 'consum', 0.0215, 'lps'),
	(608229, 128, '2014-04-01 01:03:37.000000', 'consum', 0.0214, 'lps'),
	(608230, 128, '2014-04-01 01:03:38.000000', 'consum', 0.0214, 'lps'),
	(608231, 128, '2014-04-01 01:03:39.000000', 'consum', 0.0219, 'lps'),
	(608232, 128, '2014-04-01 01:03:40.000000', 'consum', 0.0213, 'lps'),
	(608233, 128, '2014-04-01 01:03:41.000000', 'consum', 0.0219, 'lps'),
	(608234, 128, '2014-04-01 01:03:42.000000', 'consum', 0.0216, 'lps'),
	(608235, 128, '2014-04-01 01:03:43.000000', 'consum', 0.0214, 'lps'),
	(608236, 128, '2014-04-01 01:03:44.000000', 'consum', 0.0214, 'lps'),
	(608237, 128, '2014-04-01 01:03:45.000000', 'consum', 0.0218, 'lps'),
	(608238, 128, '2014-04-01 01:03:46.000000', 'consum', 0.0219, 'lps'),
	(608239, 128, '2014-04-01 01:03:47.000000', 'consum', 0.0212, 'lps'),
	(608240, 128, '2014-04-01 01:03:48.000000', 'consum', 0.0213, 'lps'),
	(608241, 128, '2014-04-01 01:03:49.000000', 'consum', 0.0217, 'lps'),
	(608242, 128, '2014-04-01 01:03:50.000000', 'consum', 0.0219, 'lps'),
	(608243, 128, '2014-04-01 01:03:51.000000', 'consum', 0.0213, 'lps'),
	(608244, 128, '2014-04-01 01:03:52.000000', 'consum', 0.0211, 'lps'),
	(608245, 128, '2014-04-01 01:03:53.000000', 'consum', 0.0216, 'lps'),
	(608246, 128, '2014-04-01 01:03:54.000000', 'consum', 0.0216, 'lps'),
	(608247, 128, '2014-04-01 01:03:55.000000', 'consum', 0.0214, 'lps'),
	(608248, 128, '2014-04-01 01:03:56.000000', 'consum', 0.0212, 'lps'),
	(608249, 128, '2014-04-01 01:03:57.000000', 'consum', 0.0219, 'lps'),
	(608250, 128, '2014-04-01 01:03:58.000000', 'consum', 0.0218, 'lps'),
	(608251, 128, '2014-04-01 01:03:59.000000', 'consum', 0.0213, 'lps'),
	(608252, 128, '2014-04-01 01:04:00.000000', 'consum', 0.0212, 'lps'),
	(608253, 128, '2014-04-01 01:04:01.000000', 'consum', 0.0212, 'lps'),
	(608254, 128, '2014-04-01 01:04:02.000000', 'consum', 0.0215, 'lps'),
	(608255, 128, '2014-04-01 01:04:03.000000', 'consum', 0.0210, 'lps'),
	(608256, 128, '2014-04-01 01:04:04.000000', 'consum', 0.0213, 'lps'),
	(608257, 128, '2014-04-01 01:04:05.000000', 'consum', 0.0216, 'lps'),
	(608258, 128, '2014-04-01 01:04:06.000000', 'consum', 0.0213, 'lps'),
	(608259, 128, '2014-04-01 01:04:07.000000', 'consum', 0.0218, 'lps'),
	(608260, 128, '2014-04-01 01:04:08.000000', 'consum', 0.0211, 'lps'),
	(608261, 128, '2014-04-01 01:04:09.000000', 'consum', 0.0213, 'lps'),
	(608262, 128, '2014-04-01 01:04:10.000000', 'consum', 0.0210, 'lps'),
	(608263, 128, '2014-04-01 01:04:11.000000', 'consum', 0.0214, 'lps'),
	(608264, 128, '2014-04-01 01:04:12.000000', 'consum', 0.0219, 'lps'),
	(608265, 128, '2014-04-01 01:04:13.000000', 'consum', 0.0213, 'lps'),
	(608266, 128, '2014-04-01 01:04:14.000000', 'consum', 0.0210, 'lps'),
	(608267, 128, '2014-04-01 01:04:15.000000', 'consum', 0.0211, 'lps'),
	(608268, 128, '2014-04-01 01:04:16.000000', 'consum', 0.0215, 'lps'),
	(608269, 128, '2014-04-01 01:04:17.000000', 'consum', 0.0211, 'lps'),
	(608270, 128, '2014-04-01 01:04:18.000000', 'consum', 0.0212, 'lps'),
	(608271, 128, '2014-04-01 01:04:19.000000', 'consum', 0.0216, 'lps'),
	(608272, 128, '2014-04-01 01:04:20.000000', 'consum', 0.0217, 'lps'),
	(608273, 128, '2014-04-01 01:04:21.000000', 'consum', 0.0218, 'lps'),
	(608274, 128, '2014-04-01 01:04:22.000000', 'consum', 0.0210, 'lps'),
	(608275, 128, '2014-04-01 01:04:23.000000', 'consum', 0.0216, 'lps'),
	(608276, 128, '2014-04-01 01:04:24.000000', 'consum', 0.0218, 'lps'),
	(608277, 128, '2014-04-01 01:04:25.000000', 'consum', 0.0216, 'lps'),
	(608278, 128, '2014-04-01 01:04:26.000000', 'consum', 0.0215, 'lps'),
	(608279, 128, '2014-04-01 01:04:27.000000', 'consum', 0.0219, 'lps'),
	(608280, 128, '2014-04-01 01:04:28.000000', 'consum', 0.0219, 'lps'),
	(608281, 128, '2014-04-01 01:04:29.000000', 'consum', 0.0218, 'lps'),
	(608282, 128, '2014-04-01 01:04:30.000000', 'consum', 0.0216, 'lps'),
	(608283, 128, '2014-04-01 01:04:31.000000', 'consum', 0.0215, 'lps'),
	(608284, 128, '2014-04-01 01:04:32.000000', 'consum', 0.0219, 'lps'),
	(608285, 128, '2014-04-01 01:04:33.000000', 'consum', 0.0210, 'lps'),
	(608286, 128, '2014-04-01 01:04:34.000000', 'consum', 0.0212, 'lps'),
	(608287, 128, '2014-04-01 01:04:35.000000', 'consum', 0.0210, 'lps'),
	(608288, 128, '2014-04-01 01:04:36.000000', 'consum', 0.0217, 'lps'),
	(608289, 128, '2014-04-01 01:04:37.000000', 'consum', 0.0215, 'lps'),
	(608290, 128, '2014-04-01 01:04:38.000000', 'consum', 0.0216, 'lps'),
	(608291, 128, '2014-04-01 01:04:39.000000', 'consum', 0.0214, 'lps'),
	(608292, 128, '2014-04-01 01:04:40.000000', 'consum', 0.0211, 'lps'),
	(608293, 128, '2014-04-01 01:04:41.000000', 'consum', 0.0214, 'lps'),
	(608294, 128, '2014-04-01 01:04:42.000000', 'consum', 0.0219, 'lps'),
	(608295, 128, '2014-04-01 01:04:43.000000', 'consum', 0.0212, 'lps'),
	(608296, 128, '2014-04-01 01:04:44.000000', 'consum', 0.0214, 'lps'),
	(608297, 128, '2014-04-01 01:04:45.000000', 'consum', 0.0214, 'lps'),
	(608298, 128, '2014-04-01 01:04:46.000000', 'consum', 0.0219, 'lps'),
	(608299, 128, '2014-04-01 01:04:47.000000', 'consum', 0.0212, 'lps'),
	(608300, 128, '2014-04-01 01:04:48.000000', 'consum', 0.0215, 'lps'),
	(608301, 128, '2014-04-01 01:04:49.000000', 'consum', 0.0219, 'lps'),
	(608302, 128, '2014-04-01 01:04:50.000000', 'consum', 0.0212, 'lps'),
	(608303, 128, '2014-04-01 01:04:51.000000', 'consum', 0.0211, 'lps'),
	(608304, 128, '2014-04-01 01:04:52.000000', 'consum', 0.0212, 'lps'),
	(608305, 128, '2014-04-01 01:04:53.000000', 'consum', 0.0218, 'lps'),
	(608306, 128, '2014-04-01 01:04:54.000000', 'consum', 0.0212, 'lps'),
	(608307, 128, '2014-04-01 01:04:55.000000', 'consum', 0.0217, 'lps'),
	(608308, 128, '2014-04-01 01:04:56.000000', 'consum', 0.0211, 'lps'),
	(608309, 128, '2014-04-01 01:04:57.000000', 'consum', 0.0216, 'lps'),
	(608310, 128, '2014-04-01 01:04:58.000000', 'consum', 0.0215, 'lps'),
	(608311, 128, '2014-04-01 01:04:59.000000', 'consum', 0.0218, 'lps'),
	(608312, 128, '2014-04-01 01:05:00.000000', 'consum', 0.0215, 'lps'),
	(608313, 128, '2014-04-01 01:05:01.000000', 'consum', 0.0211, 'lps'),
	(608314, 128, '2014-04-01 01:05:02.000000', 'consum', 0.0219, 'lps'),
	(608315, 128, '2014-04-01 01:05:03.000000', 'consum', 0.0215, 'lps'),
	(608316, 128, '2014-04-01 01:05:04.000000', 'consum', 0.0218, 'lps'),
	(608317, 128, '2014-04-01 01:05:05.000000', 'consum', 0.0215, 'lps'),
	(608318, 128, '2014-04-01 01:05:06.000000', 'consum', 0.0210, 'lps'),
	(608319, 128, '2014-04-01 01:05:07.000000', 'consum', 0.0216, 'lps'),
	(608320, 128, '2014-04-01 01:05:08.000000', 'consum', 0.0211, 'lps'),
	(608321, 128, '2014-04-01 01:05:09.000000', 'consum', 0.0218, 'lps'),
	(608322, 128, '2014-04-01 01:05:10.000000', 'consum', 0.0219, 'lps'),
	(608323, 128, '2014-04-01 01:05:11.000000', 'consum', 0.0211, 'lps'),
	(608324, 128, '2014-04-01 01:05:12.000000', 'consum', 0.0216, 'lps'),
	(608325, 128, '2014-04-01 01:05:13.000000', 'consum', 0.0211, 'lps'),
	(608326, 128, '2014-04-01 01:05:14.000000', 'consum', 0.0214, 'lps'),
	(608327, 128, '2014-04-01 01:05:15.000000', 'consum', 0.0218, 'lps'),
	(608328, 128, '2014-04-01 01:05:16.000000', 'consum', 0.0210, 'lps'),
	(608329, 128, '2014-04-01 01:05:17.000000', 'consum', 0.0217, 'lps'),
	(608330, 128, '2014-04-01 01:05:18.000000', 'consum', 0.0216, 'lps'),
	(608331, 128, '2014-04-01 01:05:19.000000', 'consum', 0.0210, 'lps'),
	(608332, 128, '2014-04-01 01:05:20.000000', 'consum', 0.0211, 'lps'),
	(608333, 128, '2014-04-01 01:05:21.000000', 'consum', 0.0216, 'lps'),
	(608334, 128, '2014-04-01 01:05:22.000000', 'consum', 0.0215, 'lps'),
	(608335, 128, '2014-04-01 01:05:23.000000', 'consum', 0.0211, 'lps'),
	(608336, 128, '2014-04-01 01:05:24.000000', 'consum', 0.0210, 'lps'),
	(608337, 128, '2014-04-01 01:05:25.000000', 'consum', 0.0216, 'lps'),
	(608338, 128, '2014-04-01 01:05:26.000000', 'consum', 0.0210, 'lps'),
	(608339, 128, '2014-04-01 01:05:27.000000', 'consum', 0.0214, 'lps'),
	(608340, 128, '2014-04-01 01:05:28.000000', 'consum', 0.0211, 'lps'),
	(608341, 128, '2014-04-01 01:05:29.000000', 'consum', 0.0213, 'lps'),
	(608342, 128, '2014-04-01 01:05:30.000000', 'consum', 0.0212, 'lps'),
	(608343, 128, '2014-04-01 01:05:31.000000', 'consum', 0.0210, 'lps'),
	(608344, 128, '2014-04-01 01:05:32.000000', 'consum', 0.0214, 'lps'),
	(608345, 128, '2014-04-01 01:05:33.000000', 'consum', 0.0213, 'lps'),
	(608346, 128, '2014-04-01 01:05:34.000000', 'consum', 0.0212, 'lps'),
	(608347, 128, '2014-04-01 01:05:35.000000', 'consum', 0.0211, 'lps'),
	(608348, 128, '2014-04-01 01:05:36.000000', 'consum', 0.0211, 'lps'),
	(608349, 128, '2014-04-01 01:05:37.000000', 'consum', 0.0211, 'lps'),
	(608350, 128, '2014-04-01 01:05:38.000000', 'consum', 0.0215, 'lps'),
	(608351, 128, '2014-04-01 01:05:39.000000', 'consum', 0.0210, 'lps'),
	(608352, 128, '2014-04-01 01:05:40.000000', 'consum', 0.0215, 'lps'),
	(608353, 128, '2014-04-01 01:05:41.000000', 'consum', 0.0216, 'lps'),
	(608354, 128, '2014-04-01 01:05:42.000000', 'consum', 0.0217, 'lps'),
	(608355, 128, '2014-04-01 01:05:43.000000', 'consum', 0.0215, 'lps'),
	(608356, 128, '2014-04-01 01:05:44.000000', 'consum', 0.0217, 'lps'),
	(608357, 128, '2014-04-01 01:05:45.000000', 'consum', 0.0219, 'lps'),
	(608358, 128, '2014-04-01 01:05:46.000000', 'consum', 0.0216, 'lps'),
	(608359, 128, '2014-04-01 01:05:47.000000', 'consum', 0.0213, 'lps'),
	(608360, 128, '2014-04-01 01:05:48.000000', 'consum', 0.0218, 'lps'),
	(608361, 128, '2014-04-01 01:05:49.000000', 'consum', 0.0213, 'lps'),
	(608362, 128, '2014-04-01 01:05:50.000000', 'consum', 0.0210, 'lps'),
	(608363, 128, '2014-04-01 01:05:51.000000', 'consum', 0.0211, 'lps'),
	(608364, 128, '2014-04-01 01:05:52.000000', 'consum', 0.0217, 'lps'),
	(608365, 128, '2014-04-01 01:05:53.000000', 'consum', 0.0213, 'lps'),
	(608366, 128, '2014-04-01 01:05:54.000000', 'consum', 0.0215, 'lps'),
	(608367, 128, '2014-04-01 01:05:55.000000', 'consum', 0.0213, 'lps'),
	(608368, 128, '2014-04-01 01:05:56.000000', 'consum', 0.0214, 'lps'),
	(608369, 128, '2014-04-01 01:05:57.000000', 'consum', 0.0212, 'lps'),
	(608370, 128, '2014-04-01 01:05:58.000000', 'consum', 0.0217, 'lps'),
	(608371, 128, '2014-04-01 01:05:59.000000', 'consum', 0.0211, 'lps'),
	(608372, 128, '2014-04-01 01:06:00.000000', 'consum', 0.0213, 'lps'),
	(608373, 128, '2014-04-01 01:06:01.000000', 'consum', 0.0211, 'lps'),
	(608374, 128, '2014-04-01 01:06:02.000000', 'consum', 0.0219, 'lps'),
	(608375, 128, '2014-04-01 01:06:03.000000', 'consum', 0.0210, 'lps'),
	(608376, 128, '2014-04-01 01:06:04.000000', 'consum', 0.0214, 'lps'),
	(608377, 128, '2014-04-01 01:06:05.000000', 'consum', 0.0213, 'lps'),
	(608378, 128, '2014-04-01 01:06:06.000000', 'consum', 0.0211, 'lps'),
	(608379, 128, '2014-04-01 01:06:07.000000', 'consum', 0.0219, 'lps'),
	(608380, 128, '2014-04-01 01:06:08.000000', 'consum', 0.0210, 'lps'),
	(608381, 128, '2014-04-01 01:06:09.000000', 'consum', 0.0215, 'lps'),
	(608382, 128, '2014-04-01 01:06:10.000000', 'consum', 0.0215, 'lps'),
	(608383, 128, '2014-04-01 01:06:11.000000', 'consum', 0.0210, 'lps'),
	(608384, 128, '2014-04-01 01:06:12.000000', 'consum', 0.0215, 'lps'),
	(608385, 128, '2014-04-01 01:06:13.000000', 'consum', 0.0217, 'lps'),
	(608386, 128, '2014-04-01 01:06:14.000000', 'consum', 0.0210, 'lps'),
	(608387, 128, '2014-04-01 01:06:15.000000', 'consum', 0.0218, 'lps'),
	(608388, 128, '2014-04-01 01:06:16.000000', 'consum', 0.0210, 'lps'),
	(608389, 128, '2014-04-01 01:06:17.000000', 'consum', 0.0218, 'lps'),
	(608390, 128, '2014-04-01 01:06:18.000000', 'consum', 0.0219, 'lps'),
	(608391, 128, '2014-04-01 01:06:19.000000', 'consum', 0.0210, 'lps'),
	(608392, 128, '2014-04-01 01:06:20.000000', 'consum', 0.0216, 'lps'),
	(608393, 128, '2014-04-01 01:06:21.000000', 'consum', 0.0211, 'lps'),
	(608394, 128, '2014-04-01 01:06:22.000000', 'consum', 0.0215, 'lps'),
	(608395, 128, '2014-04-01 01:06:23.000000', 'consum', 0.0215, 'lps'),
	(608396, 128, '2014-04-01 01:06:24.000000', 'consum', 0.0218, 'lps'),
	(608397, 128, '2014-04-01 01:06:25.000000', 'consum', 0.0218, 'lps'),
	(608398, 128, '2014-04-01 01:06:26.000000', 'consum', 0.0214, 'lps'),
	(608399, 128, '2014-04-01 01:06:27.000000', 'consum', 0.0219, 'lps'),
	(608400, 128, '2014-04-01 01:06:28.000000', 'consum', 0.0214, 'lps'),
	(608401, 128, '2014-04-01 01:06:29.000000', 'consum', 0.0213, 'lps'),
	(608402, 128, '2014-04-01 01:06:30.000000', 'consum', 0.0214, 'lps'),
	(608403, 128, '2014-04-01 01:06:31.000000', 'consum', 0.0219, 'lps'),
	(608404, 128, '2014-04-01 01:06:32.000000', 'consum', 0.0216, 'lps'),
	(608405, 128, '2014-04-01 01:06:33.000000', 'consum', 0.0212, 'lps'),
	(608406, 128, '2014-04-01 01:06:34.000000', 'consum', 0.0214, 'lps'),
	(608407, 128, '2014-04-01 01:06:35.000000', 'consum', 0.0216, 'lps'),
	(608408, 128, '2014-04-01 01:06:36.000000', 'consum', 0.0217, 'lps'),
	(608409, 128, '2014-04-01 01:06:37.000000', 'consum', 0.0216, 'lps'),
	(608410, 128, '2014-04-01 01:06:38.000000', 'consum', 0.0210, 'lps'),
	(608411, 128, '2014-04-01 01:06:39.000000', 'consum', 0.0211, 'lps'),
	(608412, 128, '2014-04-01 01:06:40.000000', 'consum', 0.0219, 'lps'),
	(608413, 128, '2014-04-01 01:06:41.000000', 'consum', 0.0210, 'lps'),
	(608414, 128, '2014-04-01 01:06:42.000000', 'consum', 0.0216, 'lps'),
	(608415, 128, '2014-04-01 01:06:43.000000', 'consum', 0.0219, 'lps'),
	(608416, 128, '2014-04-01 01:06:44.000000', 'consum', 0.0218, 'lps'),
	(608417, 128, '2014-04-01 01:06:45.000000', 'consum', 0.0215, 'lps'),
	(608418, 128, '2014-04-01 01:06:46.000000', 'consum', 0.0210, 'lps'),
	(608419, 128, '2014-04-01 01:06:47.000000', 'consum', 0.0214, 'lps'),
	(608420, 128, '2014-04-01 01:06:48.000000', 'consum', 0.0212, 'lps'),
	(608421, 128, '2014-04-01 01:06:49.000000', 'consum', 0.0219, 'lps'),
	(608422, 128, '2014-04-01 01:06:50.000000', 'consum', 0.0218, 'lps'),
	(608423, 128, '2014-04-01 01:06:51.000000', 'consum', 0.0215, 'lps'),
	(608424, 128, '2014-04-01 01:06:52.000000', 'consum', 0.0213, 'lps'),
	(608425, 128, '2014-04-01 01:06:53.000000', 'consum', 0.0219, 'lps'),
	(608426, 128, '2014-04-01 01:06:54.000000', 'consum', 0.0216, 'lps'),
	(608427, 128, '2014-04-01 01:06:55.000000', 'consum', 0.0214, 'lps'),
	(608428, 128, '2014-04-01 01:06:56.000000', 'consum', 0.0214, 'lps'),
	(608429, 128, '2014-04-01 01:06:57.000000', 'consum', 0.0219, 'lps'),
	(608430, 128, '2014-04-01 01:06:58.000000', 'consum', 0.0214, 'lps'),
	(608431, 128, '2014-04-01 01:06:59.000000', 'consum', 0.0210, 'lps'),
	(608432, 128, '2014-04-01 01:07:00.000000', 'consum', 0.0211, 'lps'),
	(608433, 128, '2014-04-01 01:07:01.000000', 'consum', 0.0217, 'lps'),
	(608434, 128, '2014-04-01 01:07:02.000000', 'consum', 0.0219, 'lps'),
	(608435, 128, '2014-04-01 01:07:03.000000', 'consum', 0.0217, 'lps'),
	(608436, 128, '2014-04-01 01:07:04.000000', 'consum', 0.0210, 'lps'),
	(608437, 128, '2014-04-01 01:07:05.000000', 'consum', 0.0217, 'lps'),
	(608438, 128, '2014-04-01 01:07:06.000000', 'consum', 0.0217, 'lps'),
	(608439, 128, '2014-04-01 01:07:07.000000', 'consum', 0.0215, 'lps'),
	(608440, 128, '2014-04-01 01:07:08.000000', 'consum', 0.0214, 'lps'),
	(608441, 128, '2014-04-01 01:07:09.000000', 'consum', 0.0215, 'lps'),
	(608442, 128, '2014-04-01 01:07:10.000000', 'consum', 0.0213, 'lps'),
	(608443, 128, '2014-04-01 01:07:11.000000', 'consum', 0.0211, 'lps'),
	(608444, 128, '2014-04-01 01:07:12.000000', 'consum', 0.0215, 'lps'),
	(608445, 128, '2014-04-01 01:07:13.000000', 'consum', 0.0213, 'lps'),
	(608446, 128, '2014-04-01 01:07:14.000000', 'consum', 0.0213, 'lps'),
	(608447, 128, '2014-04-01 01:07:15.000000', 'consum', 0.0215, 'lps'),
	(608448, 128, '2014-04-01 01:07:16.000000', 'consum', 0.0217, 'lps'),
	(608449, 128, '2014-04-01 01:07:17.000000', 'consum', 0.0218, 'lps'),
	(608450, 128, '2014-04-01 01:07:18.000000', 'consum', 0.0212, 'lps'),
	(608451, 128, '2014-04-01 01:07:19.000000', 'consum', 0.0216, 'lps'),
	(608452, 128, '2014-04-01 01:07:20.000000', 'consum', 0.0215, 'lps'),
	(608453, 128, '2014-04-01 01:07:21.000000', 'consum', 0.0218, 'lps'),
	(608454, 128, '2014-04-01 01:07:22.000000', 'consum', 0.0213, 'lps'),
	(608455, 128, '2014-04-01 01:07:23.000000', 'consum', 0.0212, 'lps'),
	(608456, 128, '2014-04-01 01:07:24.000000', 'consum', 0.0210, 'lps'),
	(608457, 128, '2014-04-01 01:07:25.000000', 'consum', 0.0217, 'lps'),
	(608458, 128, '2014-04-01 01:07:26.000000', 'consum', 0.0213, 'lps'),
	(608459, 128, '2014-04-01 01:07:27.000000', 'consum', 0.0217, 'lps'),
	(608460, 128, '2014-04-01 01:07:28.000000', 'consum', 0.0214, 'lps'),
	(608461, 128, '2014-04-01 01:07:29.000000', 'consum', 0.0219, 'lps'),
	(608462, 128, '2014-04-01 01:07:30.000000', 'consum', 0.0214, 'lps'),
	(608463, 128, '2014-04-01 01:07:31.000000', 'consum', 0.0216, 'lps'),
	(608464, 128, '2014-04-01 01:07:32.000000', 'consum', 0.0215, 'lps'),
	(608465, 128, '2014-04-01 01:07:33.000000', 'consum', 0.0219, 'lps'),
	(608466, 128, '2014-04-01 01:07:34.000000', 'consum', 0.0212, 'lps'),
	(608467, 128, '2014-04-01 01:07:35.000000', 'consum', 0.0214, 'lps'),
	(608468, 128, '2014-04-01 01:07:36.000000', 'consum', 0.0215, 'lps'),
	(608469, 128, '2014-04-01 01:07:37.000000', 'consum', 0.0211, 'lps'),
	(608470, 128, '2014-04-01 01:07:38.000000', 'consum', 0.0213, 'lps'),
	(608471, 128, '2014-04-01 01:07:39.000000', 'consum', 0.0210, 'lps'),
	(608472, 128, '2014-04-01 01:07:40.000000', 'consum', 0.0213, 'lps'),
	(608473, 128, '2014-04-01 01:07:41.000000', 'consum', 0.0214, 'lps'),
	(608474, 128, '2014-04-01 01:07:42.000000', 'consum', 0.0211, 'lps'),
	(608475, 128, '2014-04-01 01:07:43.000000', 'consum', 0.0214, 'lps'),
	(608476, 128, '2014-04-01 01:07:44.000000', 'consum', 0.0217, 'lps'),
	(608477, 128, '2014-04-01 01:07:45.000000', 'consum', 0.0216, 'lps'),
	(608478, 128, '2014-04-01 01:07:46.000000', 'consum', 0.0218, 'lps'),
	(608479, 128, '2014-04-01 01:07:47.000000', 'consum', 0.0213, 'lps'),
	(608480, 128, '2014-04-01 01:07:48.000000', 'consum', 0.0219, 'lps'),
	(608481, 128, '2014-04-01 01:07:49.000000', 'consum', 0.0219, 'lps'),
	(608482, 128, '2014-04-01 01:07:50.000000', 'consum', 0.0216, 'lps'),
	(608483, 128, '2014-04-01 01:07:51.000000', 'consum', 0.0216, 'lps'),
	(608484, 128, '2014-04-01 01:07:52.000000', 'consum', 0.0213, 'lps'),
	(608485, 128, '2014-04-01 01:07:53.000000', 'consum', 0.0219, 'lps'),
	(608486, 128, '2014-04-01 01:07:54.000000', 'consum', 0.0213, 'lps'),
	(608487, 128, '2014-04-01 01:07:55.000000', 'consum', 0.0211, 'lps'),
	(608488, 128, '2014-04-01 01:07:56.000000', 'consum', 0.0216, 'lps'),
	(608489, 128, '2014-04-01 01:07:57.000000', 'consum', 0.0219, 'lps'),
	(608490, 128, '2014-04-01 01:07:58.000000', 'consum', 0.0214, 'lps'),
	(608491, 128, '2014-04-01 01:07:59.000000', 'consum', 0.0217, 'lps'),
	(608492, 128, '2014-04-01 01:08:00.000000', 'consum', 0.0212, 'lps'),
	(608493, 128, '2014-04-01 01:08:01.000000', 'consum', 0.0211, 'lps'),
	(608494, 128, '2014-04-01 01:08:02.000000', 'consum', 0.0216, 'lps'),
	(608495, 128, '2014-04-01 01:08:03.000000', 'consum', 0.0211, 'lps'),
	(608496, 128, '2014-04-01 01:08:04.000000', 'consum', 0.0217, 'lps'),
	(608497, 128, '2014-04-01 01:08:05.000000', 'consum', 0.0210, 'lps'),
	(608498, 128, '2014-04-01 01:08:06.000000', 'consum', 0.0211, 'lps'),
	(608499, 128, '2014-04-01 01:08:07.000000', 'consum', 0.0217, 'lps'),
	(608500, 128, '2014-04-01 01:08:08.000000', 'consum', 0.0213, 'lps'),
	(608501, 128, '2014-04-01 01:08:09.000000', 'consum', 0.0213, 'lps'),
	(608502, 128, '2014-04-01 01:08:10.000000', 'consum', 0.0216, 'lps'),
	(608503, 128, '2014-04-01 01:08:11.000000', 'consum', 0.0211, 'lps'),
	(608504, 128, '2014-04-01 01:08:12.000000', 'consum', 0.0218, 'lps'),
	(608505, 128, '2014-04-01 01:08:13.000000', 'consum', 0.0216, 'lps'),
	(608506, 128, '2014-04-01 01:08:14.000000', 'consum', 0.0216, 'lps'),
	(608507, 128, '2014-04-01 01:08:15.000000', 'consum', 0.0214, 'lps'),
	(608508, 128, '2014-04-01 01:08:16.000000', 'consum', 0.0212, 'lps'),
	(608509, 128, '2014-04-01 01:08:17.000000', 'consum', 0.0218, 'lps'),
	(608510, 128, '2014-04-01 01:08:18.000000', 'consum', 0.0216, 'lps'),
	(608511, 128, '2014-04-01 01:08:19.000000', 'consum', 0.0216, 'lps'),
	(608512, 128, '2014-04-01 01:08:20.000000', 'consum', 0.0211, 'lps'),
	(608513, 128, '2014-04-01 01:08:21.000000', 'consum', 0.0210, 'lps'),
	(608514, 128, '2014-04-01 01:08:22.000000', 'consum', 0.0218, 'lps'),
	(608515, 128, '2014-04-01 01:08:23.000000', 'consum', 0.0211, 'lps'),
	(608516, 128, '2014-04-01 01:08:24.000000', 'consum', 0.0211, 'lps'),
	(608517, 128, '2014-04-01 01:08:25.000000', 'consum', 0.0213, 'lps'),
	(608518, 128, '2014-04-01 01:08:26.000000', 'consum', 0.0213, 'lps'),
	(608519, 128, '2014-04-01 01:08:27.000000', 'consum', 0.0214, 'lps'),
	(608520, 128, '2014-04-01 01:08:28.000000', 'consum', 0.0212, 'lps'),
	(608521, 128, '2014-04-01 01:08:29.000000', 'consum', 0.0217, 'lps'),
	(608522, 128, '2014-04-01 01:08:30.000000', 'consum', 0.0211, 'lps'),
	(608523, 128, '2014-04-01 01:08:31.000000', 'consum', 0.0214, 'lps'),
	(608524, 128, '2014-04-01 01:08:32.000000', 'consum', 0.0218, 'lps'),
	(608525, 128, '2014-04-01 01:08:33.000000', 'consum', 0.0218, 'lps'),
	(608526, 128, '2014-04-01 01:08:34.000000', 'consum', 0.0216, 'lps'),
	(608527, 128, '2014-04-01 01:08:35.000000', 'consum', 0.0216, 'lps'),
	(608528, 128, '2014-04-01 01:08:36.000000', 'consum', 0.0215, 'lps'),
	(608529, 128, '2014-04-01 01:08:37.000000', 'consum', 0.0216, 'lps'),
	(608530, 128, '2014-04-01 01:08:38.000000', 'consum', 0.0217, 'lps'),
	(608531, 128, '2014-04-01 01:08:39.000000', 'consum', 0.0218, 'lps'),
	(608532, 128, '2014-04-01 01:08:40.000000', 'consum', 0.0218, 'lps'),
	(608533, 128, '2014-04-01 01:08:41.000000', 'consum', 0.0217, 'lps'),
	(608534, 128, '2014-04-01 01:08:42.000000', 'consum', 0.0214, 'lps'),
	(608535, 128, '2014-04-01 01:08:43.000000', 'consum', 0.0216, 'lps'),
	(608536, 128, '2014-04-01 01:08:44.000000', 'consum', 0.0218, 'lps'),
	(608537, 128, '2014-04-01 01:08:45.000000', 'consum', 0.0214, 'lps'),
	(608538, 128, '2014-04-01 01:08:46.000000', 'consum', 0.0215, 'lps'),
	(608539, 128, '2014-04-01 01:08:47.000000', 'consum', 0.0213, 'lps'),
	(608540, 128, '2014-04-01 01:08:48.000000', 'consum', 0.0219, 'lps'),
	(608541, 128, '2014-04-01 01:08:49.000000', 'consum', 0.0210, 'lps'),
	(608542, 128, '2014-04-01 01:08:50.000000', 'consum', 0.0213, 'lps'),
	(608543, 128, '2014-04-01 01:08:51.000000', 'consum', 0.0215, 'lps'),
	(608544, 128, '2014-04-01 01:08:52.000000', 'consum', 0.0217, 'lps'),
	(608545, 128, '2014-04-01 01:08:53.000000', 'consum', 0.0219, 'lps'),
	(608546, 128, '2014-04-01 01:08:54.000000', 'consum', 0.0215, 'lps'),
	(608547, 128, '2014-04-01 01:08:55.000000', 'consum', 0.0219, 'lps'),
	(608548, 128, '2014-04-01 01:08:56.000000', 'consum', 0.0219, 'lps'),
	(608549, 128, '2014-04-01 01:08:57.000000', 'consum', 0.0211, 'lps'),
	(608550, 128, '2014-04-01 01:08:58.000000', 'consum', 0.0217, 'lps'),
	(608551, 128, '2014-04-01 01:08:59.000000', 'consum', 0.0213, 'lps'),
	(608552, 128, '2014-04-01 01:09:00.000000', 'consum', 0.0216, 'lps'),
	(608553, 128, '2014-04-01 01:09:01.000000', 'consum', 0.0219, 'lps'),
	(608554, 128, '2014-04-01 01:09:02.000000', 'consum', 0.0217, 'lps'),
	(608555, 128, '2014-04-01 01:09:03.000000', 'consum', 0.0210, 'lps'),
	(608556, 128, '2014-04-01 01:09:04.000000', 'consum', 0.0219, 'lps'),
	(608557, 128, '2014-04-01 01:09:05.000000', 'consum', 0.0218, 'lps'),
	(608558, 128, '2014-04-01 01:09:06.000000', 'consum', 0.0210, 'lps'),
	(608559, 128, '2014-04-01 01:09:07.000000', 'consum', 0.0217, 'lps'),
	(608560, 128, '2014-04-01 01:09:08.000000', 'consum', 0.0217, 'lps'),
	(608561, 128, '2014-04-01 01:09:09.000000', 'consum', 0.0215, 'lps'),
	(608562, 128, '2014-04-01 01:09:10.000000', 'consum', 0.0214, 'lps'),
	(608563, 128, '2014-04-01 01:09:11.000000', 'consum', 0.0214, 'lps'),
	(608564, 128, '2014-04-01 01:09:12.000000', 'consum', 0.0210, 'lps'),
	(608565, 128, '2014-04-01 01:09:13.000000', 'consum', 0.0219, 'lps'),
	(608566, 128, '2014-04-01 01:09:14.000000', 'consum', 0.0216, 'lps'),
	(608567, 128, '2014-04-01 01:09:15.000000', 'consum', 0.0211, 'lps'),
	(608568, 128, '2014-04-01 01:09:16.000000', 'consum', 0.0217, 'lps'),
	(608569, 128, '2014-04-01 01:09:17.000000', 'consum', 0.0213, 'lps'),
	(608570, 128, '2014-04-01 01:09:18.000000', 'consum', 0.0215, 'lps'),
	(608571, 128, '2014-04-01 01:09:19.000000', 'consum', 0.0215, 'lps'),
	(608572, 128, '2014-04-01 01:09:20.000000', 'consum', 0.0211, 'lps'),
	(608573, 128, '2014-04-01 01:09:21.000000', 'consum', 0.0212, 'lps'),
	(608574, 128, '2014-04-01 01:09:22.000000', 'consum', 0.0217, 'lps'),
	(608575, 128, '2014-04-01 01:09:23.000000', 'consum', 0.0210, 'lps'),
	(608576, 128, '2014-04-01 01:09:24.000000', 'consum', 0.0219, 'lps'),
	(608577, 128, '2014-04-01 01:09:25.000000', 'consum', 0.0216, 'lps'),
	(608578, 128, '2014-04-01 01:09:26.000000', 'consum', 0.0213, 'lps'),
	(608579, 128, '2014-04-01 01:09:27.000000', 'consum', 0.0217, 'lps'),
	(608580, 128, '2014-04-01 01:09:28.000000', 'consum', 0.0218, 'lps'),
	(608581, 128, '2014-04-01 01:09:29.000000', 'consum', 0.0219, 'lps'),
	(608582, 128, '2014-04-01 01:09:30.000000', 'consum', 0.0211, 'lps'),
	(608583, 128, '2014-04-01 01:09:31.000000', 'consum', 0.0218, 'lps'),
	(608584, 128, '2014-04-01 01:09:32.000000', 'consum', 0.0210, 'lps'),
	(608585, 128, '2014-04-01 01:09:33.000000', 'consum', 0.0215, 'lps'),
	(608586, 128, '2014-04-01 01:09:34.000000', 'consum', 0.0217, 'lps'),
	(608587, 128, '2014-04-01 01:09:35.000000', 'consum', 0.0218, 'lps'),
	(608588, 128, '2014-04-01 01:09:36.000000', 'consum', 0.0212, 'lps'),
	(608589, 128, '2014-04-01 01:09:37.000000', 'consum', 0.0216, 'lps'),
	(608590, 128, '2014-04-01 01:09:38.000000', 'consum', 0.0213, 'lps'),
	(608591, 128, '2014-04-01 01:09:39.000000', 'consum', 0.0219, 'lps'),
	(608592, 128, '2014-04-01 01:09:40.000000', 'consum', 0.0216, 'lps'),
	(608593, 128, '2014-04-01 01:09:41.000000', 'consum', 0.0214, 'lps'),
	(608594, 128, '2014-04-01 01:09:42.000000', 'consum', 0.0210, 'lps'),
	(608595, 128, '2014-04-01 01:09:43.000000', 'consum', 0.0210, 'lps'),
	(608596, 128, '2014-04-01 01:09:44.000000', 'consum', 0.0213, 'lps'),
	(608597, 128, '2014-04-01 01:09:45.000000', 'consum', 0.0212, 'lps'),
	(608598, 128, '2014-04-01 01:09:46.000000', 'consum', 0.0211, 'lps'),
	(608599, 128, '2014-04-01 01:09:47.000000', 'consum', 0.0212, 'lps'),
	(608600, 128, '2014-04-01 01:09:48.000000', 'consum', 0.0215, 'lps'),
	(608601, 128, '2014-04-01 01:09:49.000000', 'consum', 0.0219, 'lps'),
	(608602, 128, '2014-04-01 01:09:50.000000', 'consum', 0.0214, 'lps'),
	(608603, 128, '2014-04-01 01:09:51.000000', 'consum', 0.0210, 'lps'),
	(608604, 128, '2014-04-01 01:09:52.000000', 'consum', 0.0219, 'lps'),
	(608605, 128, '2014-04-01 01:09:53.000000', 'consum', 0.0217, 'lps'),
	(608606, 128, '2014-04-01 01:09:54.000000', 'consum', 0.0217, 'lps'),
	(608607, 128, '2014-04-01 01:09:55.000000', 'consum', 0.0215, 'lps'),
	(608608, 128, '2014-04-01 01:09:56.000000', 'consum', 0.0214, 'lps'),
	(608609, 128, '2014-04-01 01:09:57.000000', 'consum', 0.0217, 'lps'),
	(608610, 128, '2014-04-01 01:09:58.000000', 'consum', 0.0211, 'lps'),
	(608611, 128, '2014-04-01 01:09:59.000000', 'consum', 0.0214, 'lps'),
	(608612, 128, '2014-04-01 01:10:00.000000', 'consum', 0.0211, 'lps'),
	(608613, 128, '2014-04-01 01:10:01.000000', 'consum', 0.0210, 'lps'),
	(608614, 128, '2014-04-01 01:10:02.000000', 'consum', 0.0218, 'lps'),
	(608615, 128, '2014-04-01 01:10:03.000000', 'consum', 0.0212, 'lps'),
	(608616, 128, '2014-04-01 01:10:04.000000', 'consum', 0.0217, 'lps'),
	(608617, 128, '2014-04-01 01:10:05.000000', 'consum', 0.0218, 'lps'),
	(608618, 128, '2014-04-01 01:10:06.000000', 'consum', 0.0218, 'lps'),
	(608619, 128, '2014-04-01 01:10:07.000000', 'consum', 0.0219, 'lps'),
	(608620, 128, '2014-04-01 01:10:08.000000', 'consum', 0.0211, 'lps'),
	(608621, 128, '2014-04-01 01:10:09.000000', 'consum', 0.0219, 'lps'),
	(608622, 128, '2014-04-01 01:10:10.000000', 'consum', 0.0210, 'lps'),
	(608623, 128, '2014-04-01 01:10:11.000000', 'consum', 0.0216, 'lps'),
	(608624, 128, '2014-04-01 01:10:12.000000', 'consum', 0.0210, 'lps'),
	(608625, 128, '2014-04-01 01:10:13.000000', 'consum', 0.0211, 'lps'),
	(608626, 128, '2014-04-01 01:10:14.000000', 'consum', 0.0217, 'lps'),
	(608627, 128, '2014-04-01 01:10:15.000000', 'consum', 0.0210, 'lps'),
	(608628, 128, '2014-04-01 01:10:16.000000', 'consum', 0.0212, 'lps'),
	(608629, 128, '2014-04-01 01:10:17.000000', 'consum', 0.0219, 'lps'),
	(608630, 128, '2014-04-01 01:10:18.000000', 'consum', 0.0219, 'lps'),
	(608631, 128, '2014-04-01 01:10:19.000000', 'consum', 0.0210, 'lps'),
	(608632, 128, '2014-04-01 01:10:20.000000', 'consum', 0.0212, 'lps'),
	(608633, 128, '2014-04-01 01:10:21.000000', 'consum', 0.0210, 'lps'),
	(608634, 128, '2014-04-01 01:10:22.000000', 'consum', 0.0217, 'lps'),
	(608635, 128, '2014-04-01 01:10:23.000000', 'consum', 0.0214, 'lps'),
	(608636, 128, '2014-04-01 01:10:24.000000', 'consum', 0.0219, 'lps'),
	(608637, 128, '2014-04-01 01:10:25.000000', 'consum', 0.0216, 'lps'),
	(608638, 128, '2014-04-01 01:10:26.000000', 'consum', 0.0210, 'lps'),
	(608639, 128, '2014-04-01 01:10:27.000000', 'consum', 0.0216, 'lps'),
	(608640, 128, '2014-04-01 01:10:28.000000', 'consum', 0.0218, 'lps'),
	(608641, 128, '2014-04-01 01:10:29.000000', 'consum', 0.0212, 'lps'),
	(608642, 128, '2014-04-01 01:10:30.000000', 'consum', 0.0218, 'lps'),
	(608643, 128, '2014-04-01 01:10:31.000000', 'consum', 0.0215, 'lps'),
	(608644, 128, '2014-04-01 01:10:32.000000', 'consum', 0.0219, 'lps'),
	(608645, 128, '2014-04-01 01:10:33.000000', 'consum', 0.0214, 'lps'),
	(608646, 128, '2014-04-01 01:10:34.000000', 'consum', 0.0211, 'lps'),
	(608647, 128, '2014-04-01 01:10:35.000000', 'consum', 0.0214, 'lps'),
	(608648, 128, '2014-04-01 01:10:36.000000', 'consum', 0.0216, 'lps'),
	(608649, 128, '2014-04-01 01:10:37.000000', 'consum', 0.0211, 'lps'),
	(608650, 128, '2014-04-01 01:10:38.000000', 'consum', 0.0218, 'lps'),
	(608651, 128, '2014-04-01 01:10:39.000000', 'consum', 0.0216, 'lps'),
	(608652, 128, '2014-04-01 01:10:40.000000', 'consum', 0.0217, 'lps'),
	(608653, 128, '2014-04-01 01:10:41.000000', 'consum', 0.0217, 'lps'),
	(608654, 128, '2014-04-01 01:10:42.000000', 'consum', 0.0217, 'lps'),
	(608655, 128, '2014-04-01 01:10:43.000000', 'consum', 0.0211, 'lps'),
	(608656, 128, '2014-04-01 01:10:44.000000', 'consum', 0.0216, 'lps'),
	(608657, 128, '2014-04-01 01:10:45.000000', 'consum', 0.0219, 'lps'),
	(608658, 128, '2014-04-01 01:10:46.000000', 'consum', 0.0218, 'lps'),
	(608659, 128, '2014-04-01 01:10:47.000000', 'consum', 0.0213, 'lps'),
	(608660, 128, '2014-04-01 01:10:48.000000', 'consum', 0.0211, 'lps'),
	(608661, 128, '2014-04-01 01:10:49.000000', 'consum', 0.0217, 'lps'),
	(608662, 128, '2014-04-01 01:10:50.000000', 'consum', 0.0210, 'lps'),
	(608663, 128, '2014-04-01 01:10:51.000000', 'consum', 0.0212, 'lps'),
	(608664, 128, '2014-04-01 01:10:52.000000', 'consum', 0.0218, 'lps'),
	(608665, 128, '2014-04-01 01:10:53.000000', 'consum', 0.0216, 'lps'),
	(608666, 128, '2014-04-01 01:10:54.000000', 'consum', 0.0215, 'lps'),
	(608667, 128, '2014-04-01 01:10:55.000000', 'consum', 0.0217, 'lps'),
	(608668, 128, '2014-04-01 01:10:56.000000', 'consum', 0.0213, 'lps'),
	(608669, 128, '2014-04-01 01:10:57.000000', 'consum', 0.0215, 'lps'),
	(608670, 128, '2014-04-01 01:10:58.000000', 'consum', 0.0214, 'lps'),
	(608671, 128, '2014-04-01 01:10:59.000000', 'consum', 0.0217, 'lps'),
	(608672, 128, '2014-04-01 01:11:00.000000', 'consum', 0.0214, 'lps'),
	(608673, 128, '2014-04-01 01:11:01.000000', 'consum', 0.0218, 'lps'),
	(608674, 128, '2014-04-01 01:11:02.000000', 'consum', 0.0218, 'lps'),
	(608675, 128, '2014-04-01 01:11:03.000000', 'consum', 0.0216, 'lps'),
	(608676, 128, '2014-04-01 01:11:04.000000', 'consum', 0.0219, 'lps'),
	(608677, 128, '2014-04-01 01:11:05.000000', 'consum', 0.0215, 'lps'),
	(608678, 128, '2014-04-01 01:11:06.000000', 'consum', 0.0219, 'lps'),
	(608679, 128, '2014-04-01 01:11:07.000000', 'consum', 0.0219, 'lps'),
	(608680, 128, '2014-04-01 01:11:08.000000', 'consum', 0.0219, 'lps'),
	(608681, 128, '2014-04-01 01:11:09.000000', 'consum', 0.0210, 'lps'),
	(608682, 128, '2014-04-01 01:11:10.000000', 'consum', 0.0212, 'lps'),
	(608683, 128, '2014-04-01 01:11:11.000000', 'consum', 0.0211, 'lps'),
	(608684, 128, '2014-04-01 01:11:12.000000', 'consum', 0.0218, 'lps'),
	(608685, 128, '2014-04-01 01:11:13.000000', 'consum', 0.0217, 'lps'),
	(608686, 128, '2014-04-01 01:11:14.000000', 'consum', 0.0212, 'lps'),
	(608687, 128, '2014-04-01 01:11:15.000000', 'consum', 0.0218, 'lps'),
	(608688, 128, '2014-04-01 01:11:16.000000', 'consum', 0.0218, 'lps'),
	(608689, 128, '2014-04-01 01:11:17.000000', 'consum', 0.0214, 'lps'),
	(608690, 128, '2014-04-01 01:11:18.000000', 'consum', 0.0215, 'lps'),
	(608691, 128, '2014-04-01 01:11:19.000000', 'consum', 0.0217, 'lps'),
	(608692, 128, '2014-04-01 01:11:20.000000', 'consum', 0.0218, 'lps'),
	(608693, 128, '2014-04-01 01:11:21.000000', 'consum', 0.0210, 'lps'),
	(608694, 128, '2014-04-01 01:11:22.000000', 'consum', 0.0216, 'lps'),
	(608695, 128, '2014-04-01 01:11:23.000000', 'consum', 0.0210, 'lps'),
	(608696, 128, '2014-04-01 01:11:24.000000', 'consum', 0.0213, 'lps'),
	(608697, 128, '2014-04-01 01:11:25.000000', 'consum', 0.0215, 'lps'),
	(608698, 128, '2014-04-01 01:11:26.000000', 'consum', 0.0217, 'lps'),
	(608699, 128, '2014-04-01 01:11:27.000000', 'consum', 0.0219, 'lps'),
	(608700, 128, '2014-04-01 01:11:28.000000', 'consum', 0.0213, 'lps'),
	(608701, 128, '2014-04-01 01:11:29.000000', 'consum', 0.0212, 'lps'),
	(608702, 128, '2014-04-01 01:11:30.000000', 'consum', 0.0211, 'lps'),
	(608703, 128, '2014-04-01 01:11:31.000000', 'consum', 0.0217, 'lps'),
	(608704, 128, '2014-04-01 01:11:32.000000', 'consum', 0.0215, 'lps'),
	(608705, 128, '2014-04-01 01:11:33.000000', 'consum', 0.0216, 'lps'),
	(608706, 128, '2014-04-01 01:11:34.000000', 'consum', 0.0213, 'lps'),
	(608707, 128, '2014-04-01 01:11:35.000000', 'consum', 0.0219, 'lps'),
	(608708, 128, '2014-04-01 01:11:36.000000', 'consum', 0.0216, 'lps'),
	(608709, 128, '2014-04-01 01:11:37.000000', 'consum', 0.0213, 'lps'),
	(608710, 128, '2014-04-01 01:11:38.000000', 'consum', 0.0216, 'lps'),
	(608711, 128, '2014-04-01 01:11:39.000000', 'consum', 0.0211, 'lps'),
	(608712, 128, '2014-04-01 01:11:40.000000', 'consum', 0.0211, 'lps'),
	(608713, 128, '2014-04-01 01:11:41.000000', 'consum', 0.0210, 'lps'),
	(608714, 128, '2014-04-01 01:11:42.000000', 'consum', 0.0217, 'lps'),
	(608715, 128, '2014-04-01 01:11:43.000000', 'consum', 0.0216, 'lps'),
	(608716, 128, '2014-04-01 01:11:44.000000', 'consum', 0.0218, 'lps'),
	(608717, 128, '2014-04-01 01:11:45.000000', 'consum', 0.0213, 'lps'),
	(608718, 128, '2014-04-01 01:11:46.000000', 'consum', 0.0214, 'lps'),
	(608719, 128, '2014-04-01 01:11:47.000000', 'consum', 0.0219, 'lps'),
	(608720, 128, '2014-04-01 01:11:48.000000', 'consum', 0.0213, 'lps'),
	(608721, 128, '2014-04-01 01:11:49.000000', 'consum', 0.0219, 'lps'),
	(608722, 128, '2014-04-01 01:11:50.000000', 'consum', 0.0218, 'lps'),
	(608723, 128, '2014-04-01 01:11:51.000000', 'consum', 0.0212, 'lps'),
	(608724, 128, '2014-04-01 01:11:52.000000', 'consum', 0.0218, 'lps'),
	(608725, 128, '2014-04-01 01:11:53.000000', 'consum', 0.0216, 'lps'),
	(608726, 128, '2014-04-01 01:11:54.000000', 'consum', 0.0213, 'lps'),
	(608727, 128, '2014-04-01 01:11:55.000000', 'consum', 0.0211, 'lps'),
	(608728, 128, '2014-04-01 01:11:56.000000', 'consum', 0.0213, 'lps'),
	(608729, 128, '2014-04-01 01:11:57.000000', 'consum', 0.0215, 'lps'),
	(608730, 128, '2014-04-01 01:11:58.000000', 'consum', 0.0214, 'lps'),
	(608731, 128, '2014-04-01 01:11:59.000000', 'consum', 0.0218, 'lps'),
	(608732, 128, '2014-04-01 01:12:00.000000', 'consum', 0.0218, 'lps'),
	(608733, 128, '2014-04-01 01:12:01.000000', 'consum', 0.0217, 'lps'),
	(608734, 128, '2014-04-01 01:12:02.000000', 'consum', 0.0211, 'lps'),
	(608735, 128, '2014-04-01 01:12:03.000000', 'consum', 0.0214, 'lps'),
	(608736, 128, '2014-04-01 01:12:04.000000', 'consum', 0.0218, 'lps'),
	(608737, 128, '2014-04-01 01:12:05.000000', 'consum', 0.0210, 'lps'),
	(608738, 128, '2014-04-01 01:12:06.000000', 'consum', 0.0216, 'lps'),
	(608739, 128, '2014-04-01 01:12:07.000000', 'consum', 0.0219, 'lps'),
	(608740, 128, '2014-04-01 01:12:08.000000', 'consum', 0.0217, 'lps'),
	(608741, 128, '2014-04-01 01:12:09.000000', 'consum', 0.0210, 'lps'),
	(608742, 128, '2014-04-01 01:12:10.000000', 'consum', 0.0210, 'lps'),
	(608743, 128, '2014-04-01 01:12:11.000000', 'consum', 0.0211, 'lps'),
	(608744, 128, '2014-04-01 01:12:12.000000', 'consum', 0.0215, 'lps'),
	(608745, 128, '2014-04-01 01:12:13.000000', 'consum', 0.0211, 'lps'),
	(608746, 128, '2014-04-01 01:12:14.000000', 'consum', 0.0211, 'lps'),
	(608747, 128, '2014-04-01 01:12:15.000000', 'consum', 0.0211, 'lps'),
	(608748, 128, '2014-04-01 01:12:16.000000', 'consum', 0.0213, 'lps'),
	(608749, 128, '2014-04-01 01:12:17.000000', 'consum', 0.0213, 'lps'),
	(608750, 128, '2014-04-01 01:12:18.000000', 'consum', 0.0218, 'lps'),
	(608751, 128, '2014-04-01 01:12:19.000000', 'consum', 0.0219, 'lps'),
	(608752, 128, '2014-04-01 01:12:20.000000', 'consum', 0.0212, 'lps'),
	(608753, 128, '2014-04-01 01:12:21.000000', 'consum', 0.0214, 'lps'),
	(608754, 128, '2014-04-01 01:12:22.000000', 'consum', 0.0213, 'lps'),
	(608755, 128, '2014-04-01 01:12:23.000000', 'consum', 0.0213, 'lps'),
	(608756, 128, '2014-04-01 01:12:24.000000', 'consum', 0.0219, 'lps'),
	(608757, 128, '2014-04-01 01:12:25.000000', 'consum', 0.0215, 'lps'),
	(608758, 128, '2014-04-01 01:12:26.000000', 'consum', 0.0218, 'lps'),
	(608759, 128, '2014-04-01 01:12:27.000000', 'consum', 0.0216, 'lps'),
	(608760, 128, '2014-04-01 01:12:28.000000', 'consum', 0.0216, 'lps'),
	(608761, 128, '2014-04-01 01:12:29.000000', 'consum', 0.0211, 'lps'),
	(608762, 128, '2014-04-01 01:12:30.000000', 'consum', 0.0219, 'lps'),
	(608763, 128, '2014-04-01 01:12:31.000000', 'consum', 0.0210, 'lps'),
	(608764, 128, '2014-04-01 01:12:32.000000', 'consum', 0.0217, 'lps'),
	(608765, 128, '2014-04-01 01:12:33.000000', 'consum', 0.0214, 'lps'),
	(608766, 128, '2014-04-01 01:12:34.000000', 'consum', 0.0218, 'lps'),
	(608767, 128, '2014-04-01 01:12:35.000000', 'consum', 0.0219, 'lps'),
	(608768, 128, '2014-04-01 01:12:36.000000', 'consum', 0.0213, 'lps'),
	(608769, 128, '2014-04-01 01:12:37.000000', 'consum', 0.0218, 'lps'),
	(608770, 128, '2014-04-01 01:12:38.000000', 'consum', 0.0210, 'lps'),
	(608771, 128, '2014-04-01 01:12:39.000000', 'consum', 0.0218, 'lps'),
	(608772, 128, '2014-04-01 01:12:40.000000', 'consum', 0.0212, 'lps'),
	(608773, 128, '2014-04-01 01:12:41.000000', 'consum', 0.0216, 'lps'),
	(608774, 128, '2014-04-01 01:12:42.000000', 'consum', 0.0214, 'lps'),
	(608775, 128, '2014-04-01 01:12:43.000000', 'consum', 0.0212, 'lps'),
	(608776, 128, '2014-04-01 01:12:44.000000', 'consum', 0.0211, 'lps'),
	(608777, 128, '2014-04-01 01:12:45.000000', 'consum', 0.0216, 'lps'),
	(608778, 128, '2014-04-01 01:12:46.000000', 'consum', 0.0211, 'lps'),
	(608779, 128, '2014-04-01 01:12:47.000000', 'consum', 0.0216, 'lps'),
	(608780, 128, '2014-04-01 01:12:48.000000', 'consum', 0.0216, 'lps'),
	(608781, 128, '2014-04-01 01:12:49.000000', 'consum', 0.0212, 'lps'),
	(608782, 128, '2014-04-01 01:12:50.000000', 'consum', 0.0213, 'lps'),
	(608783, 128, '2014-04-01 01:12:51.000000', 'consum', 0.0218, 'lps'),
	(608784, 128, '2014-04-01 01:12:52.000000', 'consum', 0.0212, 'lps'),
	(608785, 128, '2014-04-01 01:12:53.000000', 'consum', 0.0216, 'lps'),
	(608786, 128, '2014-04-01 01:12:54.000000', 'consum', 0.0217, 'lps'),
	(608787, 128, '2014-04-01 01:12:55.000000', 'consum', 0.0218, 'lps'),
	(608788, 128, '2014-04-01 01:12:56.000000', 'consum', 0.0217, 'lps'),
	(608789, 128, '2014-04-01 01:12:57.000000', 'consum', 0.0213, 'lps'),
	(608790, 128, '2014-04-01 01:12:58.000000', 'consum', 0.0213, 'lps'),
	(608791, 128, '2014-04-01 01:12:59.000000', 'consum', 0.0215, 'lps'),
	(608792, 128, '2014-04-01 01:13:00.000000', 'consum', 0.0219, 'lps'),
	(608793, 128, '2014-04-01 01:13:01.000000', 'consum', 0.0218, 'lps'),
	(608794, 128, '2014-04-01 01:13:02.000000', 'consum', 0.0215, 'lps'),
	(608795, 128, '2014-04-01 01:13:03.000000', 'consum', 0.0212, 'lps'),
	(608796, 128, '2014-04-01 01:13:04.000000', 'consum', 0.0215, 'lps'),
	(608797, 128, '2014-04-01 01:13:05.000000', 'consum', 0.0211, 'lps'),
	(608798, 128, '2014-04-01 01:13:06.000000', 'consum', 0.0211, 'lps'),
	(608799, 128, '2014-04-01 01:13:07.000000', 'consum', 0.0213, 'lps'),
	(608800, 128, '2014-04-01 01:13:08.000000', 'consum', 0.0212, 'lps'),
	(608801, 128, '2014-04-01 01:13:09.000000', 'consum', 0.0212, 'lps'),
	(608802, 128, '2014-04-01 01:13:10.000000', 'consum', 0.0213, 'lps'),
	(608803, 128, '2014-04-01 01:13:11.000000', 'consum', 0.0212, 'lps'),
	(608804, 128, '2014-04-01 01:13:12.000000', 'consum', 0.0218, 'lps'),
	(608805, 128, '2014-04-01 01:13:13.000000', 'consum', 0.0217, 'lps'),
	(608806, 128, '2014-04-01 01:13:14.000000', 'consum', 0.0211, 'lps'),
	(608807, 128, '2014-04-01 01:13:15.000000', 'consum', 0.0213, 'lps'),
	(608808, 128, '2014-04-01 01:13:16.000000', 'consum', 0.0214, 'lps'),
	(608809, 128, '2014-04-01 01:13:17.000000', 'consum', 0.0211, 'lps'),
	(608810, 128, '2014-04-01 01:13:18.000000', 'consum', 0.0213, 'lps'),
	(608811, 128, '2014-04-01 01:13:19.000000', 'consum', 0.0213, 'lps'),
	(608812, 128, '2014-04-01 01:13:20.000000', 'consum', 0.0216, 'lps'),
	(608813, 128, '2014-04-01 01:13:21.000000', 'consum', 0.0210, 'lps'),
	(608814, 128, '2014-04-01 01:13:22.000000', 'consum', 0.0213, 'lps'),
	(608815, 128, '2014-04-01 01:13:23.000000', 'consum', 0.0215, 'lps'),
	(608816, 128, '2014-04-01 01:13:24.000000', 'consum', 0.0219, 'lps'),
	(608817, 128, '2014-04-01 01:13:25.000000', 'consum', 0.0219, 'lps'),
	(608818, 128, '2014-04-01 01:13:26.000000', 'consum', 0.0218, 'lps'),
	(608819, 128, '2014-04-01 01:13:27.000000', 'consum', 0.0212, 'lps'),
	(608820, 128, '2014-04-01 01:13:28.000000', 'consum', 0.0210, 'lps'),
	(608821, 128, '2014-04-01 01:13:29.000000', 'consum', 0.0212, 'lps'),
	(608822, 128, '2014-04-01 01:13:30.000000', 'consum', 0.0211, 'lps'),
	(608823, 128, '2014-04-01 01:13:31.000000', 'consum', 0.0211, 'lps'),
	(608824, 128, '2014-04-01 01:13:32.000000', 'consum', 0.0213, 'lps'),
	(608825, 128, '2014-04-01 01:13:33.000000', 'consum', 0.0213, 'lps'),
	(608826, 128, '2014-04-01 01:13:34.000000', 'consum', 0.0215, 'lps'),
	(608827, 128, '2014-04-01 01:13:35.000000', 'consum', 0.0216, 'lps'),
	(608828, 128, '2014-04-01 01:13:36.000000', 'consum', 0.0215, 'lps'),
	(608829, 128, '2014-04-01 01:13:37.000000', 'consum', 0.0210, 'lps'),
	(608830, 128, '2014-04-01 01:13:38.000000', 'consum', 0.0213, 'lps'),
	(608831, 128, '2014-04-01 01:13:39.000000', 'consum', 0.0215, 'lps'),
	(608832, 128, '2014-04-01 01:13:40.000000', 'consum', 0.0217, 'lps'),
	(608833, 128, '2014-04-01 01:13:41.000000', 'consum', 0.0219, 'lps'),
	(608834, 128, '2014-04-01 01:13:42.000000', 'consum', 0.0214, 'lps'),
	(608835, 128, '2014-04-01 01:13:43.000000', 'consum', 0.0216, 'lps'),
	(608836, 128, '2014-04-01 01:13:44.000000', 'consum', 0.0210, 'lps'),
	(608837, 128, '2014-04-01 01:13:45.000000', 'consum', 0.0210, 'lps'),
	(608838, 128, '2014-04-01 01:13:46.000000', 'consum', 0.0219, 'lps'),
	(608839, 128, '2014-04-01 01:13:47.000000', 'consum', 0.0217, 'lps'),
	(608840, 128, '2014-04-01 01:13:48.000000', 'consum', 0.0210, 'lps'),
	(608841, 128, '2014-04-01 01:13:49.000000', 'consum', 0.0218, 'lps'),
	(608842, 128, '2014-04-01 01:13:50.000000', 'consum', 0.0219, 'lps'),
	(608843, 128, '2014-04-01 01:13:51.000000', 'consum', 0.0212, 'lps'),
	(608844, 128, '2014-04-01 01:13:52.000000', 'consum', 0.0215, 'lps'),
	(608845, 128, '2014-04-01 01:13:53.000000', 'consum', 0.0218, 'lps'),
	(608846, 128, '2014-04-01 01:13:54.000000', 'consum', 0.0217, 'lps'),
	(608847, 128, '2014-04-01 01:13:55.000000', 'consum', 0.0219, 'lps'),
	(608848, 128, '2014-04-01 01:13:56.000000', 'consum', 0.0215, 'lps'),
	(608849, 128, '2014-04-01 01:13:57.000000', 'consum', 0.0218, 'lps'),
	(608850, 128, '2014-04-01 01:13:58.000000', 'consum', 0.0216, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(608851, 128, '2014-04-01 01:13:59.000000', 'consum', 0.0215, 'lps'),
	(608852, 128, '2014-04-01 01:14:00.000000', 'consum', 0.0210, 'lps'),
	(608853, 128, '2014-04-01 01:14:01.000000', 'consum', 0.0214, 'lps'),
	(608854, 128, '2014-04-01 01:14:02.000000', 'consum', 0.0213, 'lps'),
	(608855, 128, '2014-04-01 01:14:03.000000', 'consum', 0.0212, 'lps'),
	(608856, 128, '2014-04-01 01:14:04.000000', 'consum', 0.0210, 'lps'),
	(608857, 128, '2014-04-01 01:14:05.000000', 'consum', 0.0217, 'lps'),
	(608858, 128, '2014-04-01 01:14:06.000000', 'consum', 0.0214, 'lps'),
	(608859, 128, '2014-04-01 01:14:07.000000', 'consum', 0.0219, 'lps'),
	(608860, 128, '2014-04-01 01:14:08.000000', 'consum', 0.0212, 'lps'),
	(608861, 128, '2014-04-01 01:14:09.000000', 'consum', 0.0216, 'lps'),
	(608862, 128, '2014-04-01 01:14:10.000000', 'consum', 0.0215, 'lps'),
	(608863, 128, '2014-04-01 01:14:11.000000', 'consum', 0.0218, 'lps'),
	(608864, 128, '2014-04-01 01:14:12.000000', 'consum', 0.0213, 'lps'),
	(608865, 128, '2014-04-01 01:14:13.000000', 'consum', 0.0213, 'lps'),
	(608866, 128, '2014-04-01 01:14:14.000000', 'consum', 0.0216, 'lps'),
	(608867, 128, '2014-04-01 01:14:15.000000', 'consum', 0.0212, 'lps'),
	(608868, 128, '2014-04-01 01:14:16.000000', 'consum', 0.0213, 'lps'),
	(608869, 128, '2014-04-01 01:14:17.000000', 'consum', 0.0210, 'lps'),
	(608870, 128, '2014-04-01 01:14:18.000000', 'consum', 0.0211, 'lps'),
	(608871, 128, '2014-04-01 01:14:19.000000', 'consum', 0.0217, 'lps'),
	(608872, 128, '2014-04-01 01:14:20.000000', 'consum', 0.0210, 'lps'),
	(608873, 128, '2014-04-01 01:14:21.000000', 'consum', 0.0218, 'lps'),
	(608874, 128, '2014-04-01 01:14:22.000000', 'consum', 0.0214, 'lps'),
	(608875, 128, '2014-04-01 01:14:23.000000', 'consum', 0.0215, 'lps'),
	(608876, 128, '2014-04-01 01:14:24.000000', 'consum', 0.0212, 'lps'),
	(608877, 128, '2014-04-01 01:14:25.000000', 'consum', 0.0217, 'lps'),
	(608878, 128, '2014-04-01 01:14:26.000000', 'consum', 0.0219, 'lps'),
	(608879, 128, '2014-04-01 01:14:27.000000', 'consum', 0.0213, 'lps'),
	(608880, 128, '2014-04-01 01:14:28.000000', 'consum', 0.0211, 'lps'),
	(608881, 128, '2014-04-01 01:14:29.000000', 'consum', 0.0215, 'lps'),
	(608882, 128, '2014-04-01 01:14:30.000000', 'consum', 0.0211, 'lps'),
	(608883, 128, '2014-04-01 01:14:31.000000', 'consum', 0.0212, 'lps'),
	(608884, 128, '2014-04-01 01:14:32.000000', 'consum', 0.0219, 'lps'),
	(608885, 128, '2014-04-01 01:14:33.000000', 'consum', 0.0218, 'lps'),
	(608886, 128, '2014-04-01 01:14:34.000000', 'consum', 0.0212, 'lps'),
	(608887, 128, '2014-04-01 01:14:35.000000', 'consum', 0.0219, 'lps'),
	(608888, 128, '2014-04-01 01:14:36.000000', 'consum', 0.0217, 'lps'),
	(608889, 128, '2014-04-01 01:14:37.000000', 'consum', 0.0211, 'lps'),
	(608890, 128, '2014-04-01 01:14:38.000000', 'consum', 0.0213, 'lps'),
	(608891, 128, '2014-04-01 01:14:39.000000', 'consum', 0.0215, 'lps'),
	(608892, 128, '2014-04-01 01:14:40.000000', 'consum', 0.0214, 'lps'),
	(608893, 128, '2014-04-01 01:14:41.000000', 'consum', 0.0217, 'lps'),
	(608894, 128, '2014-04-01 01:14:42.000000', 'consum', 0.0213, 'lps'),
	(608895, 128, '2014-04-01 01:14:43.000000', 'consum', 0.0213, 'lps'),
	(608896, 128, '2014-04-01 01:14:44.000000', 'consum', 0.0216, 'lps'),
	(608897, 128, '2014-04-01 01:14:45.000000', 'consum', 0.0213, 'lps'),
	(608898, 128, '2014-04-01 01:14:46.000000', 'consum', 0.0216, 'lps'),
	(608899, 128, '2014-04-01 01:14:47.000000', 'consum', 0.0210, 'lps'),
	(608900, 128, '2014-04-01 01:14:48.000000', 'consum', 0.0216, 'lps'),
	(608901, 128, '2014-04-01 01:14:49.000000', 'consum', 0.0217, 'lps'),
	(608902, 128, '2014-04-01 01:14:50.000000', 'consum', 0.0211, 'lps'),
	(608903, 128, '2014-04-01 01:14:51.000000', 'consum', 0.0211, 'lps'),
	(608904, 128, '2014-04-01 01:14:52.000000', 'consum', 0.0216, 'lps'),
	(608905, 128, '2014-04-01 01:14:53.000000', 'consum', 0.0216, 'lps'),
	(608906, 128, '2014-04-01 01:14:54.000000', 'consum', 0.0212, 'lps'),
	(608907, 128, '2014-04-01 01:14:55.000000', 'consum', 0.0212, 'lps'),
	(608908, 128, '2014-04-01 01:14:56.000000', 'consum', 0.0214, 'lps'),
	(608909, 128, '2014-04-01 01:14:57.000000', 'consum', 0.0214, 'lps'),
	(608910, 128, '2014-04-01 01:14:58.000000', 'consum', 0.0211, 'lps'),
	(608911, 128, '2014-04-01 01:14:59.000000', 'consum', 0.0211, 'lps'),
	(608912, 128, '2014-04-01 01:15:00.000000', 'consum', 0.0213, 'lps'),
	(608913, 128, '2014-04-01 01:15:01.000000', 'consum', 0.0211, 'lps'),
	(608914, 128, '2014-04-01 01:15:02.000000', 'consum', 0.0217, 'lps'),
	(608915, 128, '2014-04-01 01:15:03.000000', 'consum', 0.0215, 'lps'),
	(608916, 128, '2014-04-01 01:15:04.000000', 'consum', 0.0213, 'lps'),
	(608917, 128, '2014-04-01 01:15:05.000000', 'consum', 0.0219, 'lps'),
	(608918, 128, '2014-04-01 01:15:06.000000', 'consum', 0.0218, 'lps'),
	(608919, 128, '2014-04-01 01:15:07.000000', 'consum', 0.0213, 'lps'),
	(608920, 128, '2014-04-01 01:15:08.000000', 'consum', 0.0213, 'lps'),
	(608921, 128, '2014-04-01 01:15:09.000000', 'consum', 0.0217, 'lps'),
	(608922, 128, '2014-04-01 01:15:10.000000', 'consum', 0.0217, 'lps'),
	(608923, 128, '2014-04-01 01:15:11.000000', 'consum', 0.0215, 'lps'),
	(608924, 128, '2014-04-01 01:15:12.000000', 'consum', 0.0213, 'lps'),
	(608925, 128, '2014-04-01 01:15:13.000000', 'consum', 0.0211, 'lps'),
	(608926, 128, '2014-04-01 01:15:14.000000', 'consum', 0.0217, 'lps'),
	(608927, 128, '2014-04-01 01:15:15.000000', 'consum', 0.0213, 'lps'),
	(608928, 128, '2014-04-01 01:15:16.000000', 'consum', 0.0214, 'lps'),
	(608929, 128, '2014-04-01 01:15:17.000000', 'consum', 0.0210, 'lps'),
	(608930, 128, '2014-04-01 01:15:18.000000', 'consum', 0.0218, 'lps'),
	(608931, 128, '2014-04-01 01:15:19.000000', 'consum', 0.0210, 'lps'),
	(608932, 128, '2014-04-01 01:15:20.000000', 'consum', 0.0218, 'lps'),
	(608933, 128, '2014-04-01 01:15:21.000000', 'consum', 0.0218, 'lps'),
	(608934, 128, '2014-04-01 01:15:22.000000', 'consum', 0.0219, 'lps'),
	(608935, 128, '2014-04-01 01:15:23.000000', 'consum', 0.0211, 'lps'),
	(608936, 128, '2014-04-01 01:15:24.000000', 'consum', 0.0217, 'lps'),
	(608937, 128, '2014-04-01 01:15:25.000000', 'consum', 0.0214, 'lps'),
	(608938, 128, '2014-04-01 01:15:26.000000', 'consum', 0.0219, 'lps'),
	(608939, 128, '2014-04-01 01:15:27.000000', 'consum', 0.0212, 'lps'),
	(608940, 128, '2014-04-01 01:15:28.000000', 'consum', 0.0214, 'lps'),
	(608941, 128, '2014-04-01 01:15:29.000000', 'consum', 0.0214, 'lps'),
	(608942, 128, '2014-04-01 01:15:30.000000', 'consum', 0.0210, 'lps'),
	(608943, 128, '2014-04-01 01:15:31.000000', 'consum', 0.0218, 'lps'),
	(608944, 128, '2014-04-01 01:15:32.000000', 'consum', 0.0211, 'lps'),
	(608945, 128, '2014-04-01 01:15:33.000000', 'consum', 0.0211, 'lps'),
	(608946, 128, '2014-04-01 01:15:34.000000', 'consum', 0.0213, 'lps'),
	(608947, 128, '2014-04-01 01:15:35.000000', 'consum', 0.0212, 'lps'),
	(608948, 128, '2014-04-01 01:15:36.000000', 'consum', 0.0210, 'lps'),
	(608949, 128, '2014-04-01 01:15:37.000000', 'consum', 0.0218, 'lps'),
	(608950, 128, '2014-04-01 01:15:38.000000', 'consum', 0.0218, 'lps'),
	(608951, 128, '2014-04-01 01:15:39.000000', 'consum', 0.0216, 'lps'),
	(608952, 128, '2014-04-01 01:15:40.000000', 'consum', 0.0219, 'lps'),
	(608953, 128, '2014-04-01 01:15:41.000000', 'consum', 0.0214, 'lps'),
	(608954, 128, '2014-04-01 01:15:42.000000', 'consum', 0.0217, 'lps'),
	(608955, 128, '2014-04-01 01:15:43.000000', 'consum', 0.0212, 'lps'),
	(608956, 128, '2014-04-01 01:15:44.000000', 'consum', 0.0218, 'lps'),
	(608957, 128, '2014-04-01 01:15:45.000000', 'consum', 0.0218, 'lps'),
	(608958, 128, '2014-04-01 01:15:46.000000', 'consum', 0.0213, 'lps'),
	(608959, 128, '2014-04-01 01:15:47.000000', 'consum', 0.0212, 'lps'),
	(608960, 128, '2014-04-01 01:15:48.000000', 'consum', 0.0212, 'lps'),
	(608961, 128, '2014-04-01 01:15:49.000000', 'consum', 0.0213, 'lps'),
	(608962, 128, '2014-04-01 01:15:50.000000', 'consum', 0.0211, 'lps'),
	(608963, 128, '2014-04-01 01:15:51.000000', 'consum', 0.0218, 'lps'),
	(608964, 128, '2014-04-01 01:15:52.000000', 'consum', 0.0215, 'lps'),
	(608965, 128, '2014-04-01 01:15:53.000000', 'consum', 0.0212, 'lps'),
	(608966, 128, '2014-04-01 01:15:54.000000', 'consum', 0.0214, 'lps'),
	(608967, 128, '2014-04-01 01:15:55.000000', 'consum', 0.0217, 'lps'),
	(608968, 128, '2014-04-01 01:15:56.000000', 'consum', 0.0213, 'lps'),
	(608969, 128, '2014-04-01 01:15:57.000000', 'consum', 0.0215, 'lps'),
	(608970, 128, '2014-04-01 01:15:58.000000', 'consum', 0.0217, 'lps'),
	(608971, 128, '2014-04-01 01:15:59.000000', 'consum', 0.0218, 'lps'),
	(608972, 128, '2014-04-01 01:16:00.000000', 'consum', 0.0210, 'lps'),
	(608973, 128, '2014-04-01 01:16:01.000000', 'consum', 0.0217, 'lps'),
	(608974, 128, '2014-04-01 01:16:02.000000', 'consum', 0.0217, 'lps'),
	(608975, 128, '2014-04-01 01:16:03.000000', 'consum', 0.0213, 'lps'),
	(608976, 128, '2014-04-01 01:16:04.000000', 'consum', 0.0217, 'lps'),
	(608977, 128, '2014-04-01 01:16:05.000000', 'consum', 0.0214, 'lps'),
	(608978, 128, '2014-04-01 01:16:06.000000', 'consum', 0.0212, 'lps'),
	(608979, 128, '2014-04-01 01:16:07.000000', 'consum', 0.0215, 'lps'),
	(608980, 128, '2014-04-01 01:16:08.000000', 'consum', 0.0212, 'lps'),
	(608981, 128, '2014-04-01 01:16:09.000000', 'consum', 0.0213, 'lps'),
	(608982, 128, '2014-04-01 01:16:10.000000', 'consum', 0.0212, 'lps'),
	(608983, 128, '2014-04-01 01:16:11.000000', 'consum', 0.0219, 'lps'),
	(608984, 128, '2014-04-01 01:16:12.000000', 'consum', 0.0212, 'lps'),
	(608985, 128, '2014-04-01 01:16:13.000000', 'consum', 0.0213, 'lps'),
	(608986, 128, '2014-04-01 01:16:14.000000', 'consum', 0.0210, 'lps'),
	(608987, 128, '2014-04-01 01:16:15.000000', 'consum', 0.0213, 'lps'),
	(608988, 128, '2014-04-01 01:16:16.000000', 'consum', 0.0212, 'lps'),
	(608989, 128, '2014-04-01 01:16:17.000000', 'consum', 0.0213, 'lps'),
	(608990, 128, '2014-04-01 01:16:18.000000', 'consum', 0.0219, 'lps'),
	(608991, 128, '2014-04-01 01:16:19.000000', 'consum', 0.0215, 'lps'),
	(608992, 128, '2014-04-01 01:16:20.000000', 'consum', 0.0212, 'lps'),
	(608993, 128, '2014-04-01 01:16:21.000000', 'consum', 0.0213, 'lps'),
	(608994, 128, '2014-04-01 01:16:22.000000', 'consum', 0.0212, 'lps'),
	(608995, 128, '2014-04-01 01:16:23.000000', 'consum', 0.0210, 'lps'),
	(608996, 128, '2014-04-01 01:16:24.000000', 'consum', 0.0214, 'lps'),
	(608997, 128, '2014-04-01 01:16:25.000000', 'consum', 0.0212, 'lps'),
	(608998, 128, '2014-04-01 01:16:26.000000', 'consum', 0.0216, 'lps'),
	(608999, 128, '2014-04-01 01:16:27.000000', 'consum', 0.0214, 'lps'),
	(609000, 128, '2014-04-01 01:16:28.000000', 'consum', 0.0214, 'lps'),
	(609001, 128, '2014-04-01 01:16:29.000000', 'consum', 0.0219, 'lps'),
	(609002, 128, '2014-04-01 01:16:30.000000', 'consum', 0.0213, 'lps'),
	(609003, 128, '2014-04-01 01:16:31.000000', 'consum', 0.0218, 'lps'),
	(609004, 128, '2014-04-01 01:16:32.000000', 'consum', 0.0211, 'lps'),
	(609005, 128, '2014-04-01 01:16:33.000000', 'consum', 0.0212, 'lps'),
	(609006, 128, '2014-04-01 01:16:34.000000', 'consum', 0.0219, 'lps'),
	(609007, 128, '2014-04-01 01:16:35.000000', 'consum', 0.0219, 'lps'),
	(609008, 128, '2014-04-01 01:16:36.000000', 'consum', 0.0218, 'lps'),
	(609009, 128, '2014-04-01 01:16:37.000000', 'consum', 0.0212, 'lps'),
	(609010, 128, '2014-04-01 01:16:38.000000', 'consum', 0.0216, 'lps'),
	(609011, 128, '2014-04-01 01:16:39.000000', 'consum', 0.0217, 'lps'),
	(609012, 128, '2014-04-01 01:16:40.000000', 'consum', 0.0217, 'lps'),
	(609013, 128, '2014-04-01 01:16:41.000000', 'consum', 0.0214, 'lps'),
	(609014, 128, '2014-04-01 01:16:42.000000', 'consum', 0.0218, 'lps'),
	(609015, 128, '2014-04-01 01:16:43.000000', 'consum', 0.0218, 'lps'),
	(609016, 128, '2014-04-01 01:16:44.000000', 'consum', 0.0219, 'lps'),
	(609017, 128, '2014-04-01 01:16:45.000000', 'consum', 0.0210, 'lps'),
	(609018, 128, '2014-04-01 01:16:46.000000', 'consum', 0.0214, 'lps'),
	(609019, 128, '2014-04-01 01:16:47.000000', 'consum', 0.0210, 'lps'),
	(609020, 128, '2014-04-01 01:16:48.000000', 'consum', 0.0219, 'lps'),
	(609021, 128, '2014-04-01 01:16:49.000000', 'consum', 0.0217, 'lps'),
	(609022, 128, '2014-04-01 01:16:50.000000', 'consum', 0.0215, 'lps'),
	(609023, 128, '2014-04-01 01:16:51.000000', 'consum', 0.0218, 'lps'),
	(609024, 128, '2014-04-01 01:16:52.000000', 'consum', 0.0215, 'lps'),
	(609025, 128, '2014-04-01 01:16:53.000000', 'consum', 0.0211, 'lps'),
	(609026, 128, '2014-04-01 01:16:54.000000', 'consum', 0.0212, 'lps'),
	(609027, 128, '2014-04-01 01:16:55.000000', 'consum', 0.0217, 'lps'),
	(609028, 128, '2014-04-01 01:16:56.000000', 'consum', 0.0211, 'lps'),
	(609029, 128, '2014-04-01 01:16:57.000000', 'consum', 0.0214, 'lps'),
	(609030, 128, '2014-04-01 01:16:58.000000', 'consum', 0.0215, 'lps'),
	(609031, 128, '2014-04-01 01:16:59.000000', 'consum', 0.0215, 'lps'),
	(609032, 128, '2014-04-01 01:17:00.000000', 'consum', 0.0212, 'lps'),
	(609033, 128, '2014-04-01 01:17:01.000000', 'consum', 0.0213, 'lps'),
	(609034, 128, '2014-04-01 01:17:02.000000', 'consum', 0.0211, 'lps'),
	(609035, 128, '2014-04-01 01:17:03.000000', 'consum', 0.0215, 'lps'),
	(609036, 128, '2014-04-01 01:17:04.000000', 'consum', 0.0214, 'lps'),
	(609037, 128, '2014-04-01 01:17:05.000000', 'consum', 0.0215, 'lps'),
	(609038, 128, '2014-04-01 01:17:06.000000', 'consum', 0.0214, 'lps'),
	(609039, 128, '2014-04-01 01:17:07.000000', 'consum', 0.0215, 'lps'),
	(609040, 128, '2014-04-01 01:17:08.000000', 'consum', 0.0215, 'lps'),
	(609041, 128, '2014-04-01 01:17:09.000000', 'consum', 0.0218, 'lps'),
	(609042, 128, '2014-04-01 01:17:10.000000', 'consum', 0.0216, 'lps'),
	(609043, 128, '2014-04-01 01:17:11.000000', 'consum', 0.0219, 'lps'),
	(609044, 128, '2014-04-01 01:17:12.000000', 'consum', 0.0215, 'lps'),
	(609045, 128, '2014-04-01 01:17:13.000000', 'consum', 0.0219, 'lps'),
	(609046, 128, '2014-04-01 01:17:14.000000', 'consum', 0.0219, 'lps'),
	(609047, 128, '2014-04-01 01:17:15.000000', 'consum', 0.0211, 'lps'),
	(609048, 128, '2014-04-01 01:17:16.000000', 'consum', 0.0216, 'lps'),
	(609049, 128, '2014-04-01 01:17:17.000000', 'consum', 0.0217, 'lps'),
	(609050, 128, '2014-04-01 01:17:18.000000', 'consum', 0.0219, 'lps'),
	(609051, 128, '2014-04-01 01:17:19.000000', 'consum', 0.0216, 'lps'),
	(609052, 128, '2014-04-01 01:17:20.000000', 'consum', 0.0211, 'lps'),
	(609053, 128, '2014-04-01 01:17:21.000000', 'consum', 0.0219, 'lps'),
	(609054, 128, '2014-04-01 01:17:22.000000', 'consum', 0.0212, 'lps'),
	(609055, 128, '2014-04-01 01:17:23.000000', 'consum', 0.0213, 'lps'),
	(609056, 128, '2014-04-01 01:17:24.000000', 'consum', 0.0219, 'lps'),
	(609057, 128, '2014-04-01 01:17:25.000000', 'consum', 0.0218, 'lps'),
	(609058, 128, '2014-04-01 01:17:26.000000', 'consum', 0.0213, 'lps'),
	(609059, 128, '2014-04-01 01:17:27.000000', 'consum', 0.0210, 'lps'),
	(609060, 128, '2014-04-01 01:17:28.000000', 'consum', 0.0212, 'lps'),
	(609061, 128, '2014-04-01 01:17:29.000000', 'consum', 0.0219, 'lps'),
	(609062, 128, '2014-04-01 01:17:30.000000', 'consum', 0.0212, 'lps'),
	(609063, 128, '2014-04-01 01:17:31.000000', 'consum', 0.0211, 'lps'),
	(609064, 128, '2014-04-01 01:17:32.000000', 'consum', 0.0211, 'lps'),
	(609065, 128, '2014-04-01 01:17:33.000000', 'consum', 0.0212, 'lps'),
	(609066, 128, '2014-04-01 01:17:34.000000', 'consum', 0.0216, 'lps'),
	(609067, 128, '2014-04-01 01:17:35.000000', 'consum', 0.0214, 'lps'),
	(609068, 128, '2014-04-01 01:17:36.000000', 'consum', 0.0214, 'lps'),
	(609069, 128, '2014-04-01 01:17:37.000000', 'consum', 0.0219, 'lps'),
	(609070, 128, '2014-04-01 01:17:38.000000', 'consum', 0.0212, 'lps'),
	(609071, 128, '2014-04-01 01:17:39.000000', 'consum', 0.0214, 'lps'),
	(609072, 128, '2014-04-01 01:17:40.000000', 'consum', 0.0216, 'lps'),
	(609073, 128, '2014-04-01 01:17:41.000000', 'consum', 0.0215, 'lps'),
	(609074, 128, '2014-04-01 01:17:42.000000', 'consum', 0.0211, 'lps'),
	(609075, 128, '2014-04-01 01:17:43.000000', 'consum', 0.0219, 'lps'),
	(609076, 128, '2014-04-01 01:17:44.000000', 'consum', 0.0215, 'lps'),
	(609077, 128, '2014-04-01 01:17:45.000000', 'consum', 0.0215, 'lps'),
	(609078, 128, '2014-04-01 01:17:46.000000', 'consum', 0.0212, 'lps'),
	(609079, 128, '2014-04-01 01:17:47.000000', 'consum', 0.0215, 'lps'),
	(609080, 128, '2014-04-01 01:17:48.000000', 'consum', 0.0210, 'lps'),
	(609081, 128, '2014-04-01 01:17:49.000000', 'consum', 0.0216, 'lps'),
	(609082, 128, '2014-04-01 01:17:50.000000', 'consum', 0.0211, 'lps'),
	(609083, 128, '2014-04-01 01:17:51.000000', 'consum', 0.0215, 'lps'),
	(609084, 128, '2014-04-01 01:17:52.000000', 'consum', 0.0215, 'lps'),
	(609085, 128, '2014-04-01 01:17:53.000000', 'consum', 0.0219, 'lps'),
	(609086, 128, '2014-04-01 01:17:54.000000', 'consum', 0.0211, 'lps'),
	(609087, 128, '2014-04-01 01:17:55.000000', 'consum', 0.0218, 'lps'),
	(609088, 128, '2014-04-01 01:17:56.000000', 'consum', 0.0218, 'lps'),
	(609089, 128, '2014-04-01 01:17:57.000000', 'consum', 0.0218, 'lps'),
	(609090, 128, '2014-04-01 01:17:58.000000', 'consum', 0.0214, 'lps'),
	(609091, 128, '2014-04-01 01:17:59.000000', 'consum', 0.0218, 'lps'),
	(609092, 128, '2014-04-01 01:18:00.000000', 'consum', 0.0218, 'lps'),
	(609093, 128, '2014-04-01 01:18:01.000000', 'consum', 0.0217, 'lps'),
	(609094, 128, '2014-04-01 01:18:02.000000', 'consum', 0.0219, 'lps'),
	(609095, 128, '2014-04-01 01:18:03.000000', 'consum', 0.0218, 'lps'),
	(609096, 128, '2014-04-01 01:18:04.000000', 'consum', 0.0212, 'lps'),
	(609097, 128, '2014-04-01 01:18:05.000000', 'consum', 0.0215, 'lps'),
	(609098, 128, '2014-04-01 01:18:06.000000', 'consum', 0.0212, 'lps'),
	(609099, 128, '2014-04-01 01:18:07.000000', 'consum', 0.0213, 'lps'),
	(609100, 128, '2014-04-01 01:18:08.000000', 'consum', 0.0219, 'lps'),
	(609101, 128, '2014-04-01 01:18:09.000000', 'consum', 0.0218, 'lps'),
	(609102, 128, '2014-04-01 01:18:10.000000', 'consum', 0.0215, 'lps'),
	(609103, 128, '2014-04-01 01:18:11.000000', 'consum', 0.0219, 'lps'),
	(609104, 128, '2014-04-01 01:18:12.000000', 'consum', 0.0212, 'lps'),
	(609105, 128, '2014-04-01 01:18:13.000000', 'consum', 0.0213, 'lps'),
	(609106, 128, '2014-04-01 01:18:14.000000', 'consum', 0.0219, 'lps'),
	(609107, 128, '2014-04-01 01:18:15.000000', 'consum', 0.0215, 'lps'),
	(609108, 128, '2014-04-01 01:18:16.000000', 'consum', 0.0212, 'lps'),
	(609109, 128, '2014-04-01 01:18:17.000000', 'consum', 0.0212, 'lps'),
	(609110, 128, '2014-04-01 01:18:18.000000', 'consum', 0.0216, 'lps'),
	(609111, 128, '2014-04-01 01:18:19.000000', 'consum', 0.0212, 'lps'),
	(609112, 128, '2014-04-01 01:18:20.000000', 'consum', 0.0216, 'lps'),
	(609113, 128, '2014-04-01 01:18:21.000000', 'consum', 0.0215, 'lps'),
	(609114, 128, '2014-04-01 01:18:22.000000', 'consum', 0.0215, 'lps'),
	(609115, 128, '2014-04-01 01:18:23.000000', 'consum', 0.0210, 'lps'),
	(609116, 128, '2014-04-01 01:18:24.000000', 'consum', 0.0214, 'lps'),
	(609117, 128, '2014-04-01 01:18:25.000000', 'consum', 0.0214, 'lps'),
	(609118, 128, '2014-04-01 01:18:26.000000', 'consum', 0.0216, 'lps'),
	(609119, 128, '2014-04-01 01:18:27.000000', 'consum', 0.0219, 'lps'),
	(609120, 128, '2014-04-01 01:18:28.000000', 'consum', 0.0218, 'lps'),
	(609121, 128, '2014-04-01 01:18:29.000000', 'consum', 0.0211, 'lps'),
	(609122, 128, '2014-04-01 01:18:30.000000', 'consum', 0.0214, 'lps'),
	(609123, 128, '2014-04-01 01:18:31.000000', 'consum', 0.0218, 'lps'),
	(609124, 128, '2014-04-01 01:18:32.000000', 'consum', 0.0219, 'lps'),
	(609125, 128, '2014-04-01 01:18:33.000000', 'consum', 0.0210, 'lps'),
	(609126, 128, '2014-04-01 01:18:34.000000', 'consum', 0.0213, 'lps'),
	(609127, 128, '2014-04-01 01:18:35.000000', 'consum', 0.0217, 'lps'),
	(609128, 128, '2014-04-01 01:18:36.000000', 'consum', 0.0217, 'lps'),
	(609129, 128, '2014-04-01 01:18:37.000000', 'consum', 0.0213, 'lps'),
	(609130, 128, '2014-04-01 01:18:38.000000', 'consum', 0.0217, 'lps'),
	(609131, 128, '2014-04-01 01:18:39.000000', 'consum', 0.0215, 'lps'),
	(609132, 128, '2014-04-01 01:18:40.000000', 'consum', 0.0213, 'lps'),
	(609133, 128, '2014-04-01 01:18:41.000000', 'consum', 0.0212, 'lps'),
	(609134, 128, '2014-04-01 01:18:42.000000', 'consum', 0.0212, 'lps'),
	(609135, 128, '2014-04-01 01:18:43.000000', 'consum', 0.0214, 'lps'),
	(609136, 128, '2014-04-01 01:18:44.000000', 'consum', 0.0214, 'lps'),
	(609137, 128, '2014-04-01 01:18:45.000000', 'consum', 0.0219, 'lps'),
	(609138, 128, '2014-04-01 01:18:46.000000', 'consum', 0.0214, 'lps'),
	(609139, 128, '2014-04-01 01:18:47.000000', 'consum', 0.0214, 'lps'),
	(609140, 128, '2014-04-01 01:18:48.000000', 'consum', 0.0219, 'lps'),
	(609141, 128, '2014-04-01 01:18:49.000000', 'consum', 0.0212, 'lps'),
	(609142, 128, '2014-04-01 01:18:50.000000', 'consum', 0.0214, 'lps'),
	(609143, 128, '2014-04-01 01:18:51.000000', 'consum', 0.0215, 'lps'),
	(609144, 128, '2014-04-01 01:18:52.000000', 'consum', 0.0213, 'lps'),
	(609145, 128, '2014-04-01 01:18:53.000000', 'consum', 0.0210, 'lps'),
	(609146, 128, '2014-04-01 01:18:54.000000', 'consum', 0.0212, 'lps'),
	(609147, 128, '2014-04-01 01:18:55.000000', 'consum', 0.0211, 'lps'),
	(609148, 128, '2014-04-01 01:18:56.000000', 'consum', 0.0219, 'lps'),
	(609149, 128, '2014-04-01 01:18:57.000000', 'consum', 0.0213, 'lps'),
	(609150, 128, '2014-04-01 01:18:58.000000', 'consum', 0.0218, 'lps'),
	(609151, 128, '2014-04-01 01:18:59.000000', 'consum', 0.0212, 'lps'),
	(609152, 128, '2014-04-01 01:19:00.000000', 'consum', 0.0215, 'lps'),
	(609153, 128, '2014-04-01 01:19:01.000000', 'consum', 0.0218, 'lps'),
	(609154, 128, '2014-04-01 01:19:02.000000', 'consum', 0.0219, 'lps'),
	(609155, 128, '2014-04-01 01:19:03.000000', 'consum', 0.0219, 'lps'),
	(609156, 128, '2014-04-01 01:19:04.000000', 'consum', 0.0217, 'lps'),
	(609157, 128, '2014-04-01 01:19:05.000000', 'consum', 0.0212, 'lps'),
	(609158, 128, '2014-04-01 01:19:06.000000', 'consum', 0.0218, 'lps'),
	(609159, 128, '2014-04-01 01:19:07.000000', 'consum', 0.0215, 'lps'),
	(609160, 128, '2014-04-01 01:19:08.000000', 'consum', 0.0212, 'lps'),
	(609161, 128, '2014-04-01 01:19:09.000000', 'consum', 0.0215, 'lps'),
	(609162, 128, '2014-04-01 01:19:10.000000', 'consum', 0.0210, 'lps'),
	(609163, 128, '2014-04-01 01:19:11.000000', 'consum', 0.0213, 'lps'),
	(609164, 128, '2014-04-01 01:19:12.000000', 'consum', 0.0218, 'lps'),
	(609165, 128, '2014-04-01 01:19:13.000000', 'consum', 0.0211, 'lps'),
	(609166, 128, '2014-04-01 01:19:14.000000', 'consum', 0.0212, 'lps'),
	(609167, 128, '2014-04-01 01:19:15.000000', 'consum', 0.0215, 'lps'),
	(609168, 128, '2014-04-01 01:19:16.000000', 'consum', 0.0211, 'lps'),
	(609169, 128, '2014-04-01 01:19:17.000000', 'consum', 0.0210, 'lps'),
	(609170, 128, '2014-04-01 01:19:18.000000', 'consum', 0.0210, 'lps'),
	(609171, 128, '2014-04-01 01:19:19.000000', 'consum', 0.0217, 'lps'),
	(609172, 128, '2014-04-01 01:19:20.000000', 'consum', 0.0218, 'lps'),
	(609173, 128, '2014-04-01 01:19:21.000000', 'consum', 0.0219, 'lps'),
	(609174, 128, '2014-04-01 01:19:22.000000', 'consum', 0.0210, 'lps'),
	(609175, 128, '2014-04-01 01:19:23.000000', 'consum', 0.0214, 'lps'),
	(609176, 128, '2014-04-01 01:19:24.000000', 'consum', 0.0211, 'lps'),
	(609177, 128, '2014-04-01 01:19:25.000000', 'consum', 0.0215, 'lps'),
	(609178, 128, '2014-04-01 01:19:26.000000', 'consum', 0.0211, 'lps'),
	(609179, 128, '2014-04-01 01:19:27.000000', 'consum', 0.0213, 'lps'),
	(609180, 128, '2014-04-01 01:19:28.000000', 'consum', 0.0219, 'lps'),
	(609181, 128, '2014-04-01 01:19:29.000000', 'consum', 0.0219, 'lps'),
	(609182, 128, '2014-04-01 01:19:30.000000', 'consum', 0.0216, 'lps'),
	(609183, 128, '2014-04-01 01:19:31.000000', 'consum', 0.0214, 'lps'),
	(609184, 128, '2014-04-01 01:19:32.000000', 'consum', 0.0212, 'lps'),
	(609185, 128, '2014-04-01 01:19:33.000000', 'consum', 0.0210, 'lps'),
	(609186, 128, '2014-04-01 01:19:34.000000', 'consum', 0.0215, 'lps'),
	(609187, 128, '2014-04-01 01:19:35.000000', 'consum', 0.0216, 'lps'),
	(609188, 128, '2014-04-01 01:19:36.000000', 'consum', 0.0213, 'lps'),
	(609189, 128, '2014-04-01 01:19:37.000000', 'consum', 0.0210, 'lps'),
	(609190, 128, '2014-04-01 01:19:38.000000', 'consum', 0.0219, 'lps'),
	(609191, 128, '2014-04-01 01:19:39.000000', 'consum', 0.0218, 'lps'),
	(609192, 128, '2014-04-01 01:19:40.000000', 'consum', 0.0213, 'lps'),
	(609193, 128, '2014-04-01 01:19:41.000000', 'consum', 0.0211, 'lps'),
	(609194, 128, '2014-04-01 01:19:42.000000', 'consum', 0.0215, 'lps'),
	(609195, 128, '2014-04-01 01:19:43.000000', 'consum', 0.0214, 'lps'),
	(609196, 128, '2014-04-01 01:19:44.000000', 'consum', 0.0217, 'lps'),
	(609197, 128, '2014-04-01 01:19:45.000000', 'consum', 0.0214, 'lps'),
	(609198, 128, '2014-04-01 01:19:46.000000', 'consum', 0.0216, 'lps'),
	(609199, 128, '2014-04-01 01:19:47.000000', 'consum', 0.0212, 'lps'),
	(609200, 128, '2014-04-01 01:19:48.000000', 'consum', 0.0211, 'lps'),
	(609201, 128, '2014-04-01 01:19:49.000000', 'consum', 0.0218, 'lps'),
	(609202, 128, '2014-04-01 01:19:50.000000', 'consum', 0.0217, 'lps'),
	(609203, 128, '2014-04-01 01:19:51.000000', 'consum', 0.0213, 'lps'),
	(609204, 128, '2014-04-01 01:19:52.000000', 'consum', 0.0213, 'lps'),
	(609205, 128, '2014-04-01 01:19:53.000000', 'consum', 0.0217, 'lps'),
	(609206, 128, '2014-04-01 01:19:54.000000', 'consum', 0.0216, 'lps'),
	(609207, 128, '2014-04-01 01:19:55.000000', 'consum', 0.0218, 'lps'),
	(609208, 128, '2014-04-01 01:19:56.000000', 'consum', 0.0215, 'lps'),
	(609209, 128, '2014-04-01 01:19:57.000000', 'consum', 0.0212, 'lps'),
	(609210, 128, '2014-04-01 01:19:58.000000', 'consum', 0.0216, 'lps'),
	(609211, 128, '2014-04-01 01:19:59.000000', 'consum', 0.0213, 'lps'),
	(609212, 128, '2014-04-01 01:20:00.000000', 'consum', 0.0219, 'lps'),
	(609213, 128, '2014-04-01 01:20:01.000000', 'consum', 0.0217, 'lps'),
	(609214, 128, '2014-04-01 01:20:02.000000', 'consum', 0.0217, 'lps'),
	(609215, 128, '2014-04-01 01:20:03.000000', 'consum', 0.0216, 'lps'),
	(609216, 128, '2014-04-01 01:20:04.000000', 'consum', 0.0210, 'lps'),
	(609217, 128, '2014-04-01 01:20:05.000000', 'consum', 0.0210, 'lps'),
	(609218, 128, '2014-04-01 01:20:06.000000', 'consum', 0.0211, 'lps'),
	(609219, 128, '2014-04-01 01:20:07.000000', 'consum', 0.0215, 'lps'),
	(609220, 128, '2014-04-01 01:20:08.000000', 'consum', 0.0213, 'lps'),
	(609221, 128, '2014-04-01 01:20:09.000000', 'consum', 0.0212, 'lps'),
	(609222, 128, '2014-04-01 01:20:10.000000', 'consum', 0.0211, 'lps'),
	(609223, 128, '2014-04-01 01:20:11.000000', 'consum', 0.0218, 'lps'),
	(609224, 128, '2014-04-01 01:20:12.000000', 'consum', 0.0219, 'lps'),
	(609225, 128, '2014-04-01 01:20:13.000000', 'consum', 0.0212, 'lps'),
	(609226, 128, '2014-04-01 01:20:14.000000', 'consum', 0.0211, 'lps'),
	(609227, 128, '2014-04-01 01:20:15.000000', 'consum', 0.0212, 'lps'),
	(609228, 128, '2014-04-01 01:20:16.000000', 'consum', 0.0215, 'lps'),
	(609229, 128, '2014-04-01 01:20:17.000000', 'consum', 0.0210, 'lps'),
	(609230, 128, '2014-04-01 01:20:18.000000', 'consum', 0.0218, 'lps'),
	(609231, 128, '2014-04-01 01:20:19.000000', 'consum', 0.0218, 'lps'),
	(609232, 128, '2014-04-01 01:20:20.000000', 'consum', 0.0217, 'lps'),
	(609233, 128, '2014-04-01 01:20:21.000000', 'consum', 0.0212, 'lps'),
	(609234, 128, '2014-04-01 01:20:22.000000', 'consum', 0.0218, 'lps'),
	(609235, 128, '2014-04-01 01:20:23.000000', 'consum', 0.0215, 'lps'),
	(609236, 128, '2014-04-01 01:20:24.000000', 'consum', 0.0212, 'lps'),
	(609237, 128, '2014-04-01 01:20:25.000000', 'consum', 0.0213, 'lps'),
	(609238, 128, '2014-04-01 01:20:26.000000', 'consum', 0.0213, 'lps'),
	(609239, 128, '2014-04-01 01:20:27.000000', 'consum', 0.0216, 'lps'),
	(609240, 128, '2014-04-01 01:20:28.000000', 'consum', 0.0211, 'lps'),
	(609241, 128, '2014-04-01 01:20:29.000000', 'consum', 0.0219, 'lps'),
	(609242, 128, '2014-04-01 01:20:30.000000', 'consum', 0.0210, 'lps'),
	(609243, 128, '2014-04-01 01:20:31.000000', 'consum', 0.0215, 'lps'),
	(609244, 128, '2014-04-01 01:20:32.000000', 'consum', 0.0215, 'lps'),
	(609245, 128, '2014-04-01 01:20:33.000000', 'consum', 0.0210, 'lps'),
	(609246, 128, '2014-04-01 01:20:34.000000', 'consum', 0.0218, 'lps'),
	(609247, 128, '2014-04-01 01:20:35.000000', 'consum', 0.0219, 'lps'),
	(609248, 128, '2014-04-01 01:20:36.000000', 'consum', 0.0210, 'lps'),
	(609249, 128, '2014-04-01 01:20:37.000000', 'consum', 0.0216, 'lps'),
	(609250, 128, '2014-04-01 01:20:38.000000', 'consum', 0.0210, 'lps'),
	(609251, 128, '2014-04-01 01:20:39.000000', 'consum', 0.0211, 'lps'),
	(609252, 128, '2014-04-01 01:20:40.000000', 'consum', 0.0216, 'lps'),
	(609253, 128, '2014-04-01 01:20:41.000000', 'consum', 0.0216, 'lps'),
	(609254, 128, '2014-04-01 01:20:42.000000', 'consum', 0.0214, 'lps'),
	(609255, 128, '2014-04-01 01:20:43.000000', 'consum', 0.0212, 'lps'),
	(609256, 128, '2014-04-01 01:20:44.000000', 'consum', 0.0219, 'lps'),
	(609257, 128, '2014-04-01 01:20:45.000000', 'consum', 0.0218, 'lps'),
	(609258, 128, '2014-04-01 01:20:46.000000', 'consum', 0.0215, 'lps'),
	(609259, 128, '2014-04-01 01:20:47.000000', 'consum', 0.0213, 'lps'),
	(609260, 128, '2014-04-01 01:20:48.000000', 'consum', 0.0219, 'lps'),
	(609261, 128, '2014-04-01 01:20:49.000000', 'consum', 0.0218, 'lps'),
	(609262, 128, '2014-04-01 01:20:50.000000', 'consum', 0.0214, 'lps'),
	(609263, 128, '2014-04-01 01:20:51.000000', 'consum', 0.0217, 'lps'),
	(609264, 128, '2014-04-01 01:20:52.000000', 'consum', 0.0211, 'lps'),
	(609265, 128, '2014-04-01 01:20:53.000000', 'consum', 0.0217, 'lps'),
	(609266, 128, '2014-04-01 01:20:54.000000', 'consum', 0.0210, 'lps'),
	(609267, 128, '2014-04-01 01:20:55.000000', 'consum', 0.0212, 'lps'),
	(609268, 128, '2014-04-01 01:20:56.000000', 'consum', 0.0218, 'lps'),
	(609269, 128, '2014-04-01 01:20:57.000000', 'consum', 0.0214, 'lps'),
	(609270, 128, '2014-04-01 01:20:58.000000', 'consum', 0.0219, 'lps'),
	(609271, 128, '2014-04-01 01:20:59.000000', 'consum', 0.0212, 'lps'),
	(609272, 128, '2014-04-01 01:21:00.000000', 'consum', 0.0214, 'lps'),
	(609273, 128, '2014-04-01 01:21:01.000000', 'consum', 0.0213, 'lps'),
	(609274, 128, '2014-04-01 01:21:02.000000', 'consum', 0.0213, 'lps'),
	(609275, 128, '2014-04-01 01:21:03.000000', 'consum', 0.0218, 'lps'),
	(609276, 128, '2014-04-01 01:21:04.000000', 'consum', 0.0212, 'lps'),
	(609277, 128, '2014-04-01 01:21:05.000000', 'consum', 0.0215, 'lps'),
	(609278, 128, '2014-04-01 01:21:06.000000', 'consum', 0.0211, 'lps'),
	(609279, 128, '2014-04-01 01:21:07.000000', 'consum', 0.0210, 'lps'),
	(609280, 128, '2014-04-01 01:21:08.000000', 'consum', 0.0216, 'lps'),
	(609281, 128, '2014-04-01 01:21:09.000000', 'consum', 0.0211, 'lps'),
	(609282, 128, '2014-04-01 01:21:10.000000', 'consum', 0.0218, 'lps'),
	(609283, 128, '2014-04-01 01:21:11.000000', 'consum', 0.0219, 'lps'),
	(609284, 128, '2014-04-01 01:21:12.000000', 'consum', 0.0212, 'lps'),
	(609285, 128, '2014-04-01 01:21:13.000000', 'consum', 0.0214, 'lps'),
	(609286, 128, '2014-04-01 01:21:14.000000', 'consum', 0.0215, 'lps'),
	(609287, 128, '2014-04-01 01:21:15.000000', 'consum', 0.0211, 'lps'),
	(609288, 128, '2014-04-01 01:21:16.000000', 'consum', 0.0219, 'lps'),
	(609289, 128, '2014-04-01 01:21:17.000000', 'consum', 0.0216, 'lps'),
	(609290, 128, '2014-04-01 01:21:18.000000', 'consum', 0.0211, 'lps'),
	(609291, 128, '2014-04-01 01:21:19.000000', 'consum', 0.0218, 'lps'),
	(609292, 128, '2014-04-01 01:21:20.000000', 'consum', 0.0218, 'lps'),
	(609293, 128, '2014-04-01 01:21:21.000000', 'consum', 0.0216, 'lps'),
	(609294, 128, '2014-04-01 01:21:22.000000', 'consum', 0.0216, 'lps'),
	(609295, 128, '2014-04-01 01:21:23.000000', 'consum', 0.0213, 'lps'),
	(609296, 128, '2014-04-01 01:21:24.000000', 'consum', 0.0217, 'lps'),
	(609297, 128, '2014-04-01 01:21:25.000000', 'consum', 0.0216, 'lps'),
	(609298, 128, '2014-04-01 01:21:26.000000', 'consum', 0.0210, 'lps'),
	(609299, 128, '2014-04-01 01:21:27.000000', 'consum', 0.0214, 'lps'),
	(609300, 128, '2014-04-01 01:21:28.000000', 'consum', 0.0219, 'lps'),
	(609301, 128, '2014-04-01 01:21:29.000000', 'consum', 0.0215, 'lps'),
	(609302, 128, '2014-04-01 01:21:30.000000', 'consum', 0.0218, 'lps'),
	(609303, 128, '2014-04-01 01:21:31.000000', 'consum', 0.0216, 'lps'),
	(609304, 128, '2014-04-01 01:21:32.000000', 'consum', 0.0216, 'lps'),
	(609305, 128, '2014-04-01 01:21:33.000000', 'consum', 0.0212, 'lps'),
	(609306, 128, '2014-04-01 01:21:34.000000', 'consum', 0.0212, 'lps'),
	(609307, 128, '2014-04-01 01:21:35.000000', 'consum', 0.0215, 'lps'),
	(609308, 128, '2014-04-01 01:21:36.000000', 'consum', 0.0218, 'lps'),
	(609309, 128, '2014-04-01 01:21:37.000000', 'consum', 0.0219, 'lps'),
	(609310, 128, '2014-04-01 01:21:38.000000', 'consum', 0.0219, 'lps'),
	(609311, 128, '2014-04-01 01:21:39.000000', 'consum', 0.0217, 'lps'),
	(609312, 128, '2014-04-01 01:21:40.000000', 'consum', 0.0212, 'lps'),
	(609313, 128, '2014-04-01 01:21:41.000000', 'consum', 0.0218, 'lps'),
	(609314, 128, '2014-04-01 01:21:42.000000', 'consum', 0.0214, 'lps'),
	(609315, 128, '2014-04-01 01:21:43.000000', 'consum', 0.0217, 'lps'),
	(609316, 128, '2014-04-01 01:21:44.000000', 'consum', 0.0211, 'lps'),
	(609317, 128, '2014-04-01 01:21:45.000000', 'consum', 0.0218, 'lps'),
	(609318, 128, '2014-04-01 01:21:46.000000', 'consum', 0.0215, 'lps'),
	(609319, 128, '2014-04-01 01:21:47.000000', 'consum', 0.0214, 'lps'),
	(609320, 128, '2014-04-01 01:21:48.000000', 'consum', 0.0214, 'lps'),
	(609321, 128, '2014-04-01 01:21:49.000000', 'consum', 0.0217, 'lps'),
	(609322, 128, '2014-04-01 01:21:50.000000', 'consum', 0.0213, 'lps'),
	(609323, 128, '2014-04-01 01:21:51.000000', 'consum', 0.0217, 'lps'),
	(609324, 128, '2014-04-01 01:21:52.000000', 'consum', 0.0215, 'lps'),
	(609325, 128, '2014-04-01 01:21:53.000000', 'consum', 0.0215, 'lps'),
	(609326, 128, '2014-04-01 01:21:54.000000', 'consum', 0.0219, 'lps'),
	(609327, 128, '2014-04-01 01:21:55.000000', 'consum', 0.0210, 'lps'),
	(609328, 128, '2014-04-01 01:21:56.000000', 'consum', 0.0214, 'lps'),
	(609329, 128, '2014-04-01 01:21:57.000000', 'consum', 0.0219, 'lps'),
	(609330, 128, '2014-04-01 01:21:58.000000', 'consum', 0.0214, 'lps'),
	(609331, 128, '2014-04-01 01:21:59.000000', 'consum', 0.0215, 'lps'),
	(609332, 128, '2014-04-01 01:22:00.000000', 'consum', 0.0214, 'lps'),
	(609333, 128, '2014-04-01 01:22:01.000000', 'consum', 0.0213, 'lps'),
	(609334, 128, '2014-04-01 01:22:02.000000', 'consum', 0.0216, 'lps'),
	(609335, 128, '2014-04-01 01:22:03.000000', 'consum', 0.0219, 'lps'),
	(609336, 128, '2014-04-01 01:22:04.000000', 'consum', 0.0210, 'lps'),
	(609337, 128, '2014-04-01 01:22:05.000000', 'consum', 0.0213, 'lps'),
	(609338, 128, '2014-04-01 01:22:06.000000', 'consum', 0.0216, 'lps'),
	(609339, 128, '2014-04-01 01:22:07.000000', 'consum', 0.0212, 'lps'),
	(609340, 128, '2014-04-01 01:22:08.000000', 'consum', 0.0212, 'lps'),
	(609341, 128, '2014-04-01 01:22:09.000000', 'consum', 0.0214, 'lps'),
	(609342, 128, '2014-04-01 01:22:10.000000', 'consum', 0.0213, 'lps'),
	(609343, 128, '2014-04-01 01:22:11.000000', 'consum', 0.0213, 'lps'),
	(609344, 128, '2014-04-01 01:22:12.000000', 'consum', 0.0218, 'lps'),
	(609345, 128, '2014-04-01 01:22:13.000000', 'consum', 0.0211, 'lps'),
	(609346, 128, '2014-04-01 01:22:14.000000', 'consum', 0.0211, 'lps'),
	(609347, 128, '2014-04-01 01:22:15.000000', 'consum', 0.0213, 'lps'),
	(609348, 128, '2014-04-01 01:22:16.000000', 'consum', 0.0214, 'lps'),
	(609349, 128, '2014-04-01 01:22:17.000000', 'consum', 0.0210, 'lps'),
	(609350, 128, '2014-04-01 01:22:18.000000', 'consum', 0.0218, 'lps'),
	(609351, 128, '2014-04-01 01:22:19.000000', 'consum', 0.0212, 'lps'),
	(609352, 128, '2014-04-01 01:22:20.000000', 'consum', 0.0218, 'lps'),
	(609353, 128, '2014-04-01 01:22:21.000000', 'consum', 0.0211, 'lps'),
	(609354, 128, '2014-04-01 01:22:22.000000', 'consum', 0.0215, 'lps'),
	(609355, 128, '2014-04-01 01:22:23.000000', 'consum', 0.0219, 'lps'),
	(609356, 128, '2014-04-01 01:22:24.000000', 'consum', 0.0212, 'lps'),
	(609357, 128, '2014-04-01 01:22:25.000000', 'consum', 0.0215, 'lps'),
	(609358, 128, '2014-04-01 01:22:26.000000', 'consum', 0.0217, 'lps'),
	(609359, 128, '2014-04-01 01:22:27.000000', 'consum', 0.0213, 'lps'),
	(609360, 128, '2014-04-01 01:22:28.000000', 'consum', 0.0214, 'lps'),
	(609361, 128, '2014-04-01 01:22:29.000000', 'consum', 0.0212, 'lps'),
	(609362, 128, '2014-04-01 01:22:30.000000', 'consum', 0.0219, 'lps'),
	(609363, 128, '2014-04-01 01:22:31.000000', 'consum', 0.0211, 'lps'),
	(609364, 128, '2014-04-01 01:22:32.000000', 'consum', 0.0216, 'lps'),
	(609365, 128, '2014-04-01 01:22:33.000000', 'consum', 0.0217, 'lps'),
	(609366, 128, '2014-04-01 01:22:34.000000', 'consum', 0.0217, 'lps'),
	(609367, 128, '2014-04-01 01:22:35.000000', 'consum', 0.0216, 'lps'),
	(609368, 128, '2014-04-01 01:22:36.000000', 'consum', 0.0218, 'lps'),
	(609369, 128, '2014-04-01 01:22:37.000000', 'consum', 0.0212, 'lps'),
	(609370, 128, '2014-04-01 01:22:38.000000', 'consum', 0.0219, 'lps'),
	(609371, 128, '2014-04-01 01:22:39.000000', 'consum', 0.0218, 'lps'),
	(609372, 128, '2014-04-01 01:22:40.000000', 'consum', 0.0215, 'lps'),
	(609373, 128, '2014-04-01 01:22:41.000000', 'consum', 0.0211, 'lps'),
	(609374, 128, '2014-04-01 01:22:42.000000', 'consum', 0.0210, 'lps'),
	(609375, 128, '2014-04-01 01:22:43.000000', 'consum', 0.0218, 'lps'),
	(609376, 128, '2014-04-01 01:22:44.000000', 'consum', 0.0212, 'lps'),
	(609377, 128, '2014-04-01 01:22:45.000000', 'consum', 0.0213, 'lps'),
	(609378, 128, '2014-04-01 01:22:46.000000', 'consum', 0.0212, 'lps'),
	(609379, 128, '2014-04-01 01:22:47.000000', 'consum', 0.0212, 'lps'),
	(609380, 128, '2014-04-01 01:22:48.000000', 'consum', 0.0212, 'lps'),
	(609381, 128, '2014-04-01 01:22:49.000000', 'consum', 0.0215, 'lps'),
	(609382, 128, '2014-04-01 01:22:50.000000', 'consum', 0.0211, 'lps'),
	(609383, 128, '2014-04-01 01:22:51.000000', 'consum', 0.0219, 'lps'),
	(609384, 128, '2014-04-01 01:22:52.000000', 'consum', 0.0215, 'lps'),
	(609385, 128, '2014-04-01 01:22:53.000000', 'consum', 0.0218, 'lps'),
	(609386, 128, '2014-04-01 01:22:54.000000', 'consum', 0.0213, 'lps'),
	(609387, 128, '2014-04-01 01:22:55.000000', 'consum', 0.0214, 'lps'),
	(609388, 128, '2014-04-01 01:22:56.000000', 'consum', 0.0211, 'lps'),
	(609389, 128, '2014-04-01 01:22:57.000000', 'consum', 0.0215, 'lps'),
	(609390, 128, '2014-04-01 01:22:58.000000', 'consum', 0.0210, 'lps'),
	(609391, 128, '2014-04-01 01:22:59.000000', 'consum', 0.0214, 'lps'),
	(609392, 128, '2014-04-01 01:23:00.000000', 'consum', 0.0214, 'lps'),
	(609393, 128, '2014-04-01 01:23:01.000000', 'consum', 0.0217, 'lps'),
	(609394, 128, '2014-04-01 01:23:02.000000', 'consum', 0.0213, 'lps'),
	(609395, 128, '2014-04-01 01:23:03.000000', 'consum', 0.0217, 'lps'),
	(609396, 128, '2014-04-01 01:23:04.000000', 'consum', 0.0213, 'lps'),
	(609397, 128, '2014-04-01 01:23:05.000000', 'consum', 0.0218, 'lps'),
	(609398, 128, '2014-04-01 01:23:06.000000', 'consum', 0.0219, 'lps'),
	(609399, 128, '2014-04-01 01:23:07.000000', 'consum', 0.0212, 'lps'),
	(609400, 128, '2014-04-01 01:23:08.000000', 'consum', 0.0214, 'lps'),
	(609401, 128, '2014-04-01 01:23:09.000000', 'consum', 0.0216, 'lps'),
	(609402, 128, '2014-04-01 01:23:10.000000', 'consum', 0.0217, 'lps'),
	(609403, 128, '2014-04-01 01:23:11.000000', 'consum', 0.0210, 'lps'),
	(609404, 128, '2014-04-01 01:23:12.000000', 'consum', 0.0216, 'lps'),
	(609405, 128, '2014-04-01 01:23:13.000000', 'consum', 0.0213, 'lps'),
	(609406, 128, '2014-04-01 01:23:14.000000', 'consum', 0.0216, 'lps'),
	(609407, 128, '2014-04-01 01:23:15.000000', 'consum', 0.0211, 'lps'),
	(609408, 128, '2014-04-01 01:23:16.000000', 'consum', 0.0219, 'lps'),
	(609409, 128, '2014-04-01 01:23:17.000000', 'consum', 0.0210, 'lps'),
	(609410, 128, '2014-04-01 01:23:18.000000', 'consum', 0.0214, 'lps'),
	(609411, 128, '2014-04-01 01:23:19.000000', 'consum', 0.0213, 'lps'),
	(609412, 128, '2014-04-01 01:23:20.000000', 'consum', 0.0211, 'lps'),
	(609413, 128, '2014-04-01 01:23:21.000000', 'consum', 0.0217, 'lps'),
	(609414, 128, '2014-04-01 01:23:22.000000', 'consum', 0.0213, 'lps'),
	(609415, 128, '2014-04-01 01:23:23.000000', 'consum', 0.0213, 'lps'),
	(609416, 128, '2014-04-01 01:23:24.000000', 'consum', 0.0217, 'lps'),
	(609417, 128, '2014-04-01 01:23:25.000000', 'consum', 0.0216, 'lps'),
	(609418, 128, '2014-04-01 01:23:26.000000', 'consum', 0.0212, 'lps'),
	(609419, 128, '2014-04-01 01:23:27.000000', 'consum', 0.0210, 'lps'),
	(609420, 128, '2014-04-01 01:23:28.000000', 'consum', 0.0213, 'lps'),
	(609421, 128, '2014-04-01 01:23:29.000000', 'consum', 0.0219, 'lps'),
	(609422, 128, '2014-04-01 01:23:30.000000', 'consum', 0.0213, 'lps'),
	(609423, 128, '2014-04-01 01:23:31.000000', 'consum', 0.0212, 'lps'),
	(609424, 128, '2014-04-01 01:23:32.000000', 'consum', 0.0219, 'lps'),
	(609425, 128, '2014-04-01 01:23:33.000000', 'consum', 0.0219, 'lps'),
	(609426, 128, '2014-04-01 01:23:34.000000', 'consum', 0.0219, 'lps'),
	(609427, 128, '2014-04-01 01:23:35.000000', 'consum', 0.0218, 'lps'),
	(609428, 128, '2014-04-01 01:23:36.000000', 'consum', 0.0215, 'lps'),
	(609429, 128, '2014-04-01 01:23:37.000000', 'consum', 0.0212, 'lps'),
	(609430, 128, '2014-04-01 01:23:38.000000', 'consum', 0.0213, 'lps'),
	(609431, 128, '2014-04-01 01:23:39.000000', 'consum', 0.0219, 'lps'),
	(609432, 128, '2014-04-01 01:23:40.000000', 'consum', 0.0217, 'lps'),
	(609433, 128, '2014-04-01 01:23:41.000000', 'consum', 0.0217, 'lps'),
	(609434, 128, '2014-04-01 01:23:42.000000', 'consum', 0.0216, 'lps'),
	(609435, 128, '2014-04-01 01:23:43.000000', 'consum', 0.0211, 'lps'),
	(609436, 128, '2014-04-01 01:23:44.000000', 'consum', 0.0216, 'lps'),
	(609437, 128, '2014-04-01 01:23:45.000000', 'consum', 0.0216, 'lps'),
	(609438, 128, '2014-04-01 01:23:46.000000', 'consum', 0.0214, 'lps'),
	(609439, 128, '2014-04-01 01:23:47.000000', 'consum', 0.0212, 'lps'),
	(609440, 128, '2014-04-01 01:23:48.000000', 'consum', 0.0210, 'lps'),
	(609441, 128, '2014-04-01 01:23:49.000000', 'consum', 0.0216, 'lps'),
	(609442, 128, '2014-04-01 01:23:50.000000', 'consum', 0.0217, 'lps'),
	(609443, 128, '2014-04-01 01:23:51.000000', 'consum', 0.0210, 'lps'),
	(609444, 128, '2014-04-01 01:23:52.000000', 'consum', 0.0219, 'lps'),
	(609445, 128, '2014-04-01 01:23:53.000000', 'consum', 0.0214, 'lps'),
	(609446, 128, '2014-04-01 01:23:54.000000', 'consum', 0.0213, 'lps'),
	(609447, 128, '2014-04-01 01:23:55.000000', 'consum', 0.0216, 'lps'),
	(609448, 128, '2014-04-01 01:23:56.000000', 'consum', 0.0219, 'lps'),
	(609449, 128, '2014-04-01 01:23:57.000000', 'consum', 0.0219, 'lps'),
	(609450, 128, '2014-04-01 01:23:58.000000', 'consum', 0.0218, 'lps'),
	(609451, 128, '2014-04-01 01:23:59.000000', 'consum', 0.0214, 'lps'),
	(609452, 128, '2014-04-01 01:24:00.000000', 'consum', 0.0218, 'lps'),
	(609453, 128, '2014-04-01 01:24:01.000000', 'consum', 0.0218, 'lps'),
	(609454, 128, '2014-04-01 01:24:02.000000', 'consum', 0.0215, 'lps'),
	(609455, 128, '2014-04-01 01:24:03.000000', 'consum', 0.0210, 'lps'),
	(609456, 128, '2014-04-01 01:24:04.000000', 'consum', 0.0218, 'lps'),
	(609457, 128, '2014-04-01 01:24:05.000000', 'consum', 0.0212, 'lps'),
	(609458, 128, '2014-04-01 01:24:06.000000', 'consum', 0.0214, 'lps'),
	(609459, 128, '2014-04-01 01:24:07.000000', 'consum', 0.0214, 'lps'),
	(609460, 128, '2014-04-01 01:24:08.000000', 'consum', 0.0211, 'lps'),
	(609461, 128, '2014-04-01 01:24:09.000000', 'consum', 0.0212, 'lps'),
	(609462, 128, '2014-04-01 01:24:10.000000', 'consum', 0.0217, 'lps'),
	(609463, 128, '2014-04-01 01:24:11.000000', 'consum', 0.0210, 'lps'),
	(609464, 128, '2014-04-01 01:24:12.000000', 'consum', 0.0211, 'lps'),
	(609465, 128, '2014-04-01 01:24:13.000000', 'consum', 0.0213, 'lps'),
	(609466, 128, '2014-04-01 01:24:14.000000', 'consum', 0.0212, 'lps'),
	(609467, 128, '2014-04-01 01:24:15.000000', 'consum', 0.0211, 'lps'),
	(609468, 128, '2014-04-01 01:24:16.000000', 'consum', 0.0211, 'lps'),
	(609469, 128, '2014-04-01 01:24:17.000000', 'consum', 0.0212, 'lps'),
	(609470, 128, '2014-04-01 01:24:18.000000', 'consum', 0.0219, 'lps'),
	(609471, 128, '2014-04-01 01:24:19.000000', 'consum', 0.0210, 'lps'),
	(609472, 128, '2014-04-01 01:24:20.000000', 'consum', 0.0213, 'lps'),
	(609473, 128, '2014-04-01 01:24:21.000000', 'consum', 0.0214, 'lps'),
	(609474, 128, '2014-04-01 01:24:22.000000', 'consum', 0.0211, 'lps'),
	(609475, 128, '2014-04-01 01:24:23.000000', 'consum', 0.0215, 'lps'),
	(609476, 128, '2014-04-01 01:24:24.000000', 'consum', 0.0214, 'lps'),
	(609477, 128, '2014-04-01 01:24:25.000000', 'consum', 0.0213, 'lps'),
	(609478, 128, '2014-04-01 01:24:26.000000', 'consum', 0.0216, 'lps'),
	(609479, 128, '2014-04-01 01:24:27.000000', 'consum', 0.0212, 'lps'),
	(609480, 128, '2014-04-01 01:24:28.000000', 'consum', 0.0210, 'lps'),
	(609481, 128, '2014-04-01 01:24:29.000000', 'consum', 0.0216, 'lps'),
	(609482, 128, '2014-04-01 01:24:30.000000', 'consum', 0.0211, 'lps'),
	(609483, 128, '2014-04-01 01:24:31.000000', 'consum', 0.0216, 'lps'),
	(609484, 128, '2014-04-01 01:24:32.000000', 'consum', 0.0218, 'lps'),
	(609485, 128, '2014-04-01 01:24:33.000000', 'consum', 0.0212, 'lps'),
	(609486, 128, '2014-04-01 01:24:34.000000', 'consum', 0.0216, 'lps'),
	(609487, 128, '2014-04-01 01:24:35.000000', 'consum', 0.0214, 'lps'),
	(609488, 128, '2014-04-01 01:24:36.000000', 'consum', 0.0215, 'lps'),
	(609489, 128, '2014-04-01 01:24:37.000000', 'consum', 0.0213, 'lps'),
	(609490, 128, '2014-04-01 01:24:38.000000', 'consum', 0.0211, 'lps'),
	(609491, 128, '2014-04-01 01:24:39.000000', 'consum', 0.0215, 'lps'),
	(609492, 128, '2014-04-01 01:24:40.000000', 'consum', 0.0213, 'lps'),
	(609493, 128, '2014-04-01 01:24:41.000000', 'consum', 0.0211, 'lps'),
	(609494, 128, '2014-04-01 01:24:42.000000', 'consum', 0.0215, 'lps'),
	(609495, 128, '2014-04-01 01:24:43.000000', 'consum', 0.0211, 'lps'),
	(609496, 128, '2014-04-01 01:24:44.000000', 'consum', 0.0214, 'lps'),
	(609497, 128, '2014-04-01 01:24:45.000000', 'consum', 0.0217, 'lps'),
	(609498, 128, '2014-04-01 01:24:46.000000', 'consum', 0.0212, 'lps'),
	(609499, 128, '2014-04-01 01:24:47.000000', 'consum', 0.0219, 'lps'),
	(609500, 128, '2014-04-01 01:24:48.000000', 'consum', 0.0212, 'lps'),
	(609501, 128, '2014-04-01 01:24:49.000000', 'consum', 0.0211, 'lps'),
	(609502, 128, '2014-04-01 01:24:50.000000', 'consum', 0.0212, 'lps'),
	(609503, 128, '2014-04-01 01:24:51.000000', 'consum', 0.0215, 'lps'),
	(609504, 128, '2014-04-01 01:24:52.000000', 'consum', 0.0212, 'lps'),
	(609505, 128, '2014-04-01 01:24:53.000000', 'consum', 0.0213, 'lps'),
	(609506, 128, '2014-04-01 01:24:54.000000', 'consum', 0.0210, 'lps'),
	(609507, 128, '2014-04-01 01:24:55.000000', 'consum', 0.0211, 'lps'),
	(609508, 128, '2014-04-01 01:24:56.000000', 'consum', 0.0217, 'lps'),
	(609509, 128, '2014-04-01 01:24:57.000000', 'consum', 0.0213, 'lps'),
	(609510, 128, '2014-04-01 01:24:58.000000', 'consum', 0.0213, 'lps'),
	(609511, 128, '2014-04-01 01:24:59.000000', 'consum', 0.0215, 'lps'),
	(609512, 128, '2014-04-01 01:25:00.000000', 'consum', 0.0218, 'lps'),
	(609513, 128, '2014-04-01 01:25:01.000000', 'consum', 0.0216, 'lps'),
	(609514, 128, '2014-04-01 01:25:02.000000', 'consum', 0.0215, 'lps'),
	(609515, 128, '2014-04-01 01:25:03.000000', 'consum', 0.0217, 'lps'),
	(609516, 128, '2014-04-01 01:25:04.000000', 'consum', 0.0210, 'lps'),
	(609517, 128, '2014-04-01 01:25:05.000000', 'consum', 0.0212, 'lps'),
	(609518, 128, '2014-04-01 01:25:06.000000', 'consum', 0.0211, 'lps'),
	(609519, 128, '2014-04-01 01:25:07.000000', 'consum', 0.0210, 'lps'),
	(609520, 128, '2014-04-01 01:25:08.000000', 'consum', 0.0218, 'lps'),
	(609521, 128, '2014-04-01 01:25:09.000000', 'consum', 0.0210, 'lps'),
	(609522, 128, '2014-04-01 01:25:10.000000', 'consum', 0.0218, 'lps'),
	(609523, 128, '2014-04-01 01:25:11.000000', 'consum', 0.0219, 'lps'),
	(609524, 128, '2014-04-01 01:25:12.000000', 'consum', 0.0214, 'lps'),
	(609525, 128, '2014-04-01 01:25:13.000000', 'consum', 0.0210, 'lps'),
	(609526, 128, '2014-04-01 01:25:14.000000', 'consum', 0.0212, 'lps'),
	(609527, 128, '2014-04-01 01:25:15.000000', 'consum', 0.0217, 'lps'),
	(609528, 128, '2014-04-01 01:25:16.000000', 'consum', 0.0212, 'lps'),
	(609529, 128, '2014-04-01 01:25:17.000000', 'consum', 0.0218, 'lps'),
	(609530, 129, '2014-04-01 00:00:00.000000', 'consum', 0.0233, 'lps'),
	(609531, 129, '2014-04-01 00:00:01.000000', 'consum', 0.0228, 'lps'),
	(609532, 129, '2014-04-01 00:00:02.000000', 'consum', 0.0230, 'lps'),
	(609533, 129, '2014-04-01 00:00:03.000000', 'consum', 0.0233, 'lps'),
	(609534, 129, '2014-04-01 00:00:04.000000', 'consum', 0.0216, 'lps'),
	(609535, 129, '2014-04-01 00:00:05.000000', 'consum', 0.0222, 'lps'),
	(609536, 129, '2014-04-01 00:00:06.000000', 'consum', 0.0229, 'lps'),
	(609537, 129, '2014-04-01 00:00:07.000000', 'consum', 0.0219, 'lps'),
	(609538, 129, '2014-04-01 00:00:08.000000', 'consum', 0.0224, 'lps'),
	(609539, 129, '2014-04-01 00:00:09.000000', 'consum', 0.0228, 'lps'),
	(609540, 129, '2014-04-01 00:00:10.000000', 'consum', 0.0212, 'lps'),
	(609541, 129, '2014-04-01 00:00:11.000000', 'consum', 0.0216, 'lps'),
	(609542, 129, '2014-04-01 00:00:12.000000', 'consum', 0.0231, 'lps'),
	(609543, 129, '2014-04-01 00:00:13.000000', 'consum', 0.0229, 'lps'),
	(609544, 129, '2014-04-01 00:00:14.000000', 'consum', 0.0215, 'lps'),
	(609545, 129, '2014-04-01 00:00:15.000000', 'consum', 0.0229, 'lps'),
	(609546, 129, '2014-04-01 00:00:16.000000', 'consum', 0.0220, 'lps'),
	(609547, 129, '2014-04-01 00:00:17.000000', 'consum', 0.0225, 'lps'),
	(609548, 129, '2014-04-01 00:00:18.000000', 'consum', 0.0232, 'lps'),
	(609549, 129, '2014-04-01 00:00:19.000000', 'consum', 0.0229, 'lps'),
	(609550, 129, '2014-04-01 00:00:20.000000', 'consum', 0.0214, 'lps'),
	(609551, 129, '2014-04-01 00:00:21.000000', 'consum', 0.0220, 'lps'),
	(609552, 129, '2014-04-01 00:00:22.000000', 'consum', 0.0228, 'lps'),
	(609553, 129, '2014-04-01 00:00:23.000000', 'consum', 0.0220, 'lps'),
	(609554, 129, '2014-04-01 00:00:24.000000', 'consum', 0.0233, 'lps'),
	(609555, 129, '2014-04-01 00:00:25.000000', 'consum', 0.0223, 'lps'),
	(609556, 129, '2014-04-01 00:00:26.000000', 'consum', 0.0229, 'lps'),
	(609557, 129, '2014-04-01 00:00:27.000000', 'consum', 0.0217, 'lps'),
	(609558, 129, '2014-04-01 00:00:28.000000', 'consum', 0.0215, 'lps'),
	(609559, 129, '2014-04-01 00:00:29.000000', 'consum', 0.0215, 'lps'),
	(609560, 129, '2014-04-01 00:00:30.000000', 'consum', 0.0219, 'lps'),
	(609561, 129, '2014-04-01 00:00:31.000000', 'consum', 0.0215, 'lps'),
	(609562, 129, '2014-04-01 00:00:32.000000', 'consum', 0.0233, 'lps'),
	(609563, 129, '2014-04-01 00:00:33.000000', 'consum', 0.0217, 'lps'),
	(609564, 129, '2014-04-01 00:00:34.000000', 'consum', 0.0222, 'lps'),
	(609565, 129, '2014-04-01 00:00:35.000000', 'consum', 0.0226, 'lps'),
	(609566, 129, '2014-04-01 00:00:36.000000', 'consum', 0.0229, 'lps'),
	(609567, 129, '2014-04-01 00:00:37.000000', 'consum', 0.0212, 'lps'),
	(609568, 129, '2014-04-01 00:00:38.000000', 'consum', 0.0210, 'lps'),
	(609569, 129, '2014-04-01 00:00:39.000000', 'consum', 0.0231, 'lps'),
	(609570, 129, '2014-04-01 00:00:40.000000', 'consum', 0.0217, 'lps'),
	(609571, 129, '2014-04-01 00:00:41.000000', 'consum', 0.0233, 'lps'),
	(609572, 129, '2014-04-01 00:00:42.000000', 'consum', 0.0230, 'lps'),
	(609573, 129, '2014-04-01 00:00:43.000000', 'consum', 0.0217, 'lps'),
	(609574, 129, '2014-04-01 00:00:44.000000', 'consum', 0.0210, 'lps'),
	(609575, 129, '2014-04-01 00:00:45.000000', 'consum', 0.0213, 'lps'),
	(609576, 129, '2014-04-01 00:00:46.000000', 'consum', 0.0224, 'lps'),
	(609577, 129, '2014-04-01 00:00:47.000000', 'consum', 0.0225, 'lps'),
	(609578, 129, '2014-04-01 00:00:48.000000', 'consum', 0.0220, 'lps'),
	(609579, 129, '2014-04-01 00:00:49.000000', 'consum', 0.0213, 'lps'),
	(609580, 129, '2014-04-01 00:00:50.000000', 'consum', 0.0222, 'lps'),
	(609581, 129, '2014-04-01 00:00:51.000000', 'consum', 0.0213, 'lps'),
	(609582, 129, '2014-04-01 00:00:52.000000', 'consum', 0.0215, 'lps'),
	(609583, 129, '2014-04-01 00:00:53.000000', 'consum', 0.0227, 'lps'),
	(609584, 129, '2014-04-01 00:00:54.000000', 'consum', 0.0230, 'lps'),
	(609585, 129, '2014-04-01 00:00:55.000000', 'consum', 0.0212, 'lps'),
	(609586, 129, '2014-04-01 00:00:56.000000', 'consum', 0.0233, 'lps'),
	(609587, 129, '2014-04-01 00:00:57.000000', 'consum', 0.0225, 'lps'),
	(609588, 129, '2014-04-01 00:00:58.000000', 'consum', 0.0217, 'lps'),
	(609589, 129, '2014-04-01 00:00:59.000000', 'consum', 0.0221, 'lps'),
	(609590, 129, '2014-04-01 00:01:00.000000', 'consum', 0.0224, 'lps'),
	(609591, 129, '2014-04-01 00:01:01.000000', 'consum', 0.0221, 'lps'),
	(609592, 129, '2014-04-01 00:01:02.000000', 'consum', 0.0225, 'lps'),
	(609593, 129, '2014-04-01 00:01:03.000000', 'consum', 0.0228, 'lps'),
	(609594, 129, '2014-04-01 00:01:04.000000', 'consum', 0.0231, 'lps'),
	(609595, 129, '2014-04-01 00:01:05.000000', 'consum', 0.0216, 'lps'),
	(609596, 129, '2014-04-01 00:01:06.000000', 'consum', 0.0224, 'lps'),
	(609597, 129, '2014-04-01 00:01:07.000000', 'consum', 0.0214, 'lps'),
	(609598, 129, '2014-04-01 00:01:08.000000', 'consum', 0.0214, 'lps'),
	(609599, 129, '2014-04-01 00:01:09.000000', 'consum', 0.0216, 'lps'),
	(609600, 129, '2014-04-01 00:01:10.000000', 'consum', 0.0230, 'lps'),
	(609601, 129, '2014-04-01 00:01:11.000000', 'consum', 0.0222, 'lps'),
	(609602, 129, '2014-04-01 00:01:12.000000', 'consum', 0.0233, 'lps'),
	(609603, 129, '2014-04-01 00:01:13.000000', 'consum', 0.0218, 'lps'),
	(609604, 129, '2014-04-01 00:01:14.000000', 'consum', 0.0230, 'lps'),
	(609605, 129, '2014-04-01 00:01:15.000000', 'consum', 0.0212, 'lps'),
	(609606, 129, '2014-04-01 00:01:16.000000', 'consum', 0.0210, 'lps'),
	(609607, 129, '2014-04-01 00:01:17.000000', 'consum', 0.0230, 'lps'),
	(609608, 129, '2014-04-01 00:01:18.000000', 'consum', 0.0212, 'lps'),
	(609609, 129, '2014-04-01 00:01:19.000000', 'consum', 0.0233, 'lps'),
	(609610, 129, '2014-04-01 00:01:20.000000', 'consum', 0.0225, 'lps'),
	(609611, 129, '2014-04-01 00:01:21.000000', 'consum', 0.0216, 'lps'),
	(609612, 129, '2014-04-01 00:01:22.000000', 'consum', 0.0220, 'lps'),
	(609613, 129, '2014-04-01 00:01:23.000000', 'consum', 0.0217, 'lps'),
	(609614, 129, '2014-04-01 00:01:24.000000', 'consum', 0.0218, 'lps'),
	(609615, 129, '2014-04-01 00:01:25.000000', 'consum', 0.0227, 'lps'),
	(609616, 129, '2014-04-01 00:01:26.000000', 'consum', 0.0225, 'lps'),
	(609617, 129, '2014-04-01 00:01:27.000000', 'consum', 0.0210, 'lps'),
	(609618, 129, '2014-04-01 00:01:28.000000', 'consum', 0.0212, 'lps'),
	(609619, 129, '2014-04-01 00:01:29.000000', 'consum', 0.0221, 'lps'),
	(609620, 129, '2014-04-01 00:01:30.000000', 'consum', 0.0210, 'lps'),
	(609621, 129, '2014-04-01 00:01:31.000000', 'consum', 0.0229, 'lps'),
	(609622, 129, '2014-04-01 00:01:32.000000', 'consum', 0.0232, 'lps'),
	(609623, 129, '2014-04-01 00:01:33.000000', 'consum', 0.0214, 'lps'),
	(609624, 129, '2014-04-01 00:01:34.000000', 'consum', 0.0215, 'lps'),
	(609625, 129, '2014-04-01 00:01:35.000000', 'consum', 0.0225, 'lps'),
	(609626, 129, '2014-04-01 00:01:36.000000', 'consum', 0.0219, 'lps'),
	(609627, 129, '2014-04-01 00:01:37.000000', 'consum', 0.0211, 'lps'),
	(609628, 129, '2014-04-01 00:01:38.000000', 'consum', 0.0212, 'lps'),
	(609629, 129, '2014-04-01 00:01:39.000000', 'consum', 0.0219, 'lps'),
	(609630, 129, '2014-04-01 00:01:40.000000', 'consum', 0.0223, 'lps'),
	(609631, 129, '2014-04-01 00:01:41.000000', 'consum', 0.0226, 'lps'),
	(609632, 129, '2014-04-01 00:01:42.000000', 'consum', 0.0226, 'lps'),
	(609633, 129, '2014-04-01 00:01:43.000000', 'consum', 0.0217, 'lps'),
	(609634, 129, '2014-04-01 00:01:44.000000', 'consum', 0.0225, 'lps'),
	(609635, 129, '2014-04-01 00:01:45.000000', 'consum', 0.0216, 'lps'),
	(609636, 129, '2014-04-01 00:01:46.000000', 'consum', 0.0218, 'lps'),
	(609637, 129, '2014-04-01 00:01:47.000000', 'consum', 0.0231, 'lps'),
	(609638, 129, '2014-04-01 00:01:48.000000', 'consum', 0.0223, 'lps'),
	(609639, 129, '2014-04-01 00:01:49.000000', 'consum', 0.0233, 'lps'),
	(609640, 129, '2014-04-01 00:01:50.000000', 'consum', 0.0217, 'lps'),
	(609641, 129, '2014-04-01 00:01:51.000000', 'consum', 0.0226, 'lps'),
	(609642, 129, '2014-04-01 00:01:52.000000', 'consum', 0.0219, 'lps'),
	(609643, 129, '2014-04-01 00:01:53.000000', 'consum', 0.0232, 'lps'),
	(609644, 129, '2014-04-01 00:01:54.000000', 'consum', 0.0224, 'lps'),
	(609645, 129, '2014-04-01 00:01:55.000000', 'consum', 0.0211, 'lps'),
	(609646, 129, '2014-04-01 00:01:56.000000', 'consum', 0.0225, 'lps'),
	(609647, 129, '2014-04-01 00:01:57.000000', 'consum', 0.0232, 'lps'),
	(609648, 129, '2014-04-01 00:01:58.000000', 'consum', 0.0229, 'lps'),
	(609649, 129, '2014-04-01 00:01:59.000000', 'consum', 0.0215, 'lps'),
	(609650, 129, '2014-04-01 00:02:00.000000', 'consum', 0.0228, 'lps'),
	(609651, 129, '2014-04-01 00:02:01.000000', 'consum', 0.0211, 'lps'),
	(609652, 129, '2014-04-01 00:02:02.000000', 'consum', 0.0233, 'lps'),
	(609653, 129, '2014-04-01 00:02:03.000000', 'consum', 0.0230, 'lps'),
	(609654, 129, '2014-04-01 00:02:04.000000', 'consum', 0.0214, 'lps'),
	(609655, 129, '2014-04-01 00:02:05.000000', 'consum', 0.0221, 'lps'),
	(609656, 129, '2014-04-01 00:02:06.000000', 'consum', 0.0230, 'lps'),
	(609657, 129, '2014-04-01 00:02:07.000000', 'consum', 0.0228, 'lps'),
	(609658, 129, '2014-04-01 00:02:08.000000', 'consum', 0.0219, 'lps'),
	(609659, 129, '2014-04-01 00:02:09.000000', 'consum', 0.0223, 'lps'),
	(609660, 129, '2014-04-01 00:02:10.000000', 'consum', 0.0225, 'lps'),
	(609661, 129, '2014-04-01 00:02:11.000000', 'consum', 0.0224, 'lps'),
	(609662, 129, '2014-04-01 00:02:12.000000', 'consum', 0.0233, 'lps'),
	(609663, 129, '2014-04-01 00:02:13.000000', 'consum', 0.0210, 'lps'),
	(609664, 129, '2014-04-01 00:02:14.000000', 'consum', 0.0217, 'lps'),
	(609665, 129, '2014-04-01 00:02:15.000000', 'consum', 0.0222, 'lps'),
	(609666, 129, '2014-04-01 00:02:16.000000', 'consum', 0.0224, 'lps'),
	(609667, 129, '2014-04-01 00:02:17.000000', 'consum', 0.0220, 'lps'),
	(609668, 129, '2014-04-01 00:02:18.000000', 'consum', 0.0218, 'lps'),
	(609669, 129, '2014-04-01 00:02:19.000000', 'consum', 0.0222, 'lps'),
	(609670, 129, '2014-04-01 00:02:20.000000', 'consum', 0.0220, 'lps'),
	(609671, 129, '2014-04-01 00:02:21.000000', 'consum', 0.0228, 'lps'),
	(609672, 129, '2014-04-01 00:02:22.000000', 'consum', 0.0219, 'lps'),
	(609673, 129, '2014-04-01 00:02:23.000000', 'consum', 0.0229, 'lps'),
	(609674, 129, '2014-04-01 00:02:24.000000', 'consum', 0.0227, 'lps'),
	(609675, 129, '2014-04-01 00:02:25.000000', 'consum', 0.0218, 'lps'),
	(609676, 129, '2014-04-01 00:02:26.000000', 'consum', 0.0222, 'lps'),
	(609677, 129, '2014-04-01 00:02:27.000000', 'consum', 0.0223, 'lps'),
	(609678, 129, '2014-04-01 00:02:28.000000', 'consum', 0.0216, 'lps'),
	(609679, 129, '2014-04-01 00:02:29.000000', 'consum', 0.0223, 'lps'),
	(609680, 129, '2014-04-01 00:02:30.000000', 'consum', 0.0210, 'lps'),
	(609681, 129, '2014-04-01 00:02:31.000000', 'consum', 0.0222, 'lps'),
	(609682, 129, '2014-04-01 00:02:32.000000', 'consum', 0.0221, 'lps'),
	(609683, 129, '2014-04-01 00:02:33.000000', 'consum', 0.0232, 'lps'),
	(609684, 129, '2014-04-01 00:02:34.000000', 'consum', 0.0213, 'lps'),
	(609685, 129, '2014-04-01 00:02:35.000000', 'consum', 0.0231, 'lps'),
	(609686, 129, '2014-04-01 00:02:36.000000', 'consum', 0.0210, 'lps'),
	(609687, 129, '2014-04-01 00:02:37.000000', 'consum', 0.0221, 'lps'),
	(609688, 129, '2014-04-01 00:02:38.000000', 'consum', 0.0216, 'lps'),
	(609689, 129, '2014-04-01 00:02:39.000000', 'consum', 0.0210, 'lps'),
	(609690, 129, '2014-04-01 00:02:40.000000', 'consum', 0.0213, 'lps'),
	(609691, 129, '2014-04-01 00:02:41.000000', 'consum', 0.0228, 'lps'),
	(609692, 129, '2014-04-01 00:02:42.000000', 'consum', 0.0219, 'lps'),
	(609693, 129, '2014-04-01 00:02:43.000000', 'consum', 0.0224, 'lps'),
	(609694, 129, '2014-04-01 00:02:44.000000', 'consum', 0.0232, 'lps'),
	(609695, 129, '2014-04-01 00:02:45.000000', 'consum', 0.0228, 'lps'),
	(609696, 129, '2014-04-01 00:02:46.000000', 'consum', 0.0233, 'lps'),
	(609697, 129, '2014-04-01 00:02:47.000000', 'consum', 0.0227, 'lps'),
	(609698, 129, '2014-04-01 00:02:48.000000', 'consum', 0.0224, 'lps'),
	(609699, 129, '2014-04-01 00:02:49.000000', 'consum', 0.0232, 'lps'),
	(609700, 129, '2014-04-01 00:02:50.000000', 'consum', 0.0231, 'lps'),
	(609701, 129, '2014-04-01 00:02:51.000000', 'consum', 0.0223, 'lps'),
	(609702, 129, '2014-04-01 00:02:52.000000', 'consum', 0.0213, 'lps'),
	(609703, 129, '2014-04-01 00:02:53.000000', 'consum', 0.0212, 'lps'),
	(609704, 129, '2014-04-01 00:02:54.000000', 'consum', 0.0211, 'lps'),
	(609705, 129, '2014-04-01 00:02:55.000000', 'consum', 0.0211, 'lps'),
	(609706, 129, '2014-04-01 00:02:56.000000', 'consum', 0.0212, 'lps'),
	(609707, 129, '2014-04-01 00:02:57.000000', 'consum', 0.0218, 'lps'),
	(609708, 129, '2014-04-01 00:02:58.000000', 'consum', 0.0218, 'lps'),
	(609709, 129, '2014-04-01 00:02:59.000000', 'consum', 0.0229, 'lps'),
	(609710, 129, '2014-04-01 00:03:00.000000', 'consum', 0.0210, 'lps'),
	(609711, 129, '2014-04-01 00:03:01.000000', 'consum', 0.0222, 'lps'),
	(609712, 129, '2014-04-01 00:03:02.000000', 'consum', 0.0226, 'lps'),
	(609713, 129, '2014-04-01 00:03:03.000000', 'consum', 0.0229, 'lps'),
	(609714, 129, '2014-04-01 00:03:04.000000', 'consum', 0.0211, 'lps'),
	(609715, 129, '2014-04-01 00:03:05.000000', 'consum', 0.0231, 'lps'),
	(609716, 129, '2014-04-01 00:03:06.000000', 'consum', 0.0215, 'lps'),
	(609717, 129, '2014-04-01 00:03:07.000000', 'consum', 0.0223, 'lps'),
	(609718, 129, '2014-04-01 00:03:08.000000', 'consum', 0.0233, 'lps'),
	(609719, 129, '2014-04-01 00:03:09.000000', 'consum', 0.0216, 'lps'),
	(609720, 129, '2014-04-01 00:03:10.000000', 'consum', 0.0218, 'lps'),
	(609721, 129, '2014-04-01 00:03:11.000000', 'consum', 0.0210, 'lps'),
	(609722, 129, '2014-04-01 00:03:12.000000', 'consum', 0.0210, 'lps'),
	(609723, 129, '2014-04-01 00:03:13.000000', 'consum', 0.0211, 'lps'),
	(609724, 129, '2014-04-01 00:03:14.000000', 'consum', 0.0216, 'lps'),
	(609725, 129, '2014-04-01 00:03:15.000000', 'consum', 0.0213, 'lps'),
	(609726, 129, '2014-04-01 00:03:16.000000', 'consum', 0.0232, 'lps'),
	(609727, 129, '2014-04-01 00:03:17.000000', 'consum', 0.0215, 'lps'),
	(609728, 129, '2014-04-01 00:03:18.000000', 'consum', 0.0216, 'lps'),
	(609729, 129, '2014-04-01 00:03:19.000000', 'consum', 0.0225, 'lps'),
	(609730, 129, '2014-04-01 00:03:20.000000', 'consum', 0.0220, 'lps'),
	(609731, 129, '2014-04-01 00:03:21.000000', 'consum', 0.0214, 'lps'),
	(609732, 129, '2014-04-01 00:03:22.000000', 'consum', 0.0227, 'lps'),
	(609733, 129, '2014-04-01 00:03:23.000000', 'consum', 0.0210, 'lps'),
	(609734, 129, '2014-04-01 00:03:24.000000', 'consum', 0.0231, 'lps'),
	(609735, 129, '2014-04-01 00:03:25.000000', 'consum', 0.0222, 'lps'),
	(609736, 129, '2014-04-01 00:03:26.000000', 'consum', 0.0229, 'lps'),
	(609737, 129, '2014-04-01 00:03:27.000000', 'consum', 0.0222, 'lps'),
	(609738, 129, '2014-04-01 00:03:28.000000', 'consum', 0.0212, 'lps'),
	(609739, 129, '2014-04-01 00:03:29.000000', 'consum', 0.0211, 'lps'),
	(609740, 129, '2014-04-01 00:03:30.000000', 'consum', 0.0231, 'lps'),
	(609741, 129, '2014-04-01 00:03:31.000000', 'consum', 0.0218, 'lps'),
	(609742, 129, '2014-04-01 00:03:32.000000', 'consum', 0.0212, 'lps'),
	(609743, 129, '2014-04-01 00:03:33.000000', 'consum', 0.0222, 'lps'),
	(609744, 129, '2014-04-01 00:03:34.000000', 'consum', 0.0214, 'lps'),
	(609745, 129, '2014-04-01 00:03:35.000000', 'consum', 0.0219, 'lps'),
	(609746, 129, '2014-04-01 00:03:36.000000', 'consum', 0.0220, 'lps'),
	(609747, 129, '2014-04-01 00:03:37.000000', 'consum', 0.0211, 'lps'),
	(609748, 129, '2014-04-01 00:03:38.000000', 'consum', 0.0231, 'lps'),
	(609749, 129, '2014-04-01 00:03:39.000000', 'consum', 0.0219, 'lps'),
	(609750, 129, '2014-04-01 00:03:40.000000', 'consum', 0.0216, 'lps'),
	(609751, 129, '2014-04-01 00:03:41.000000', 'consum', 0.0212, 'lps'),
	(609752, 129, '2014-04-01 00:03:42.000000', 'consum', 0.0227, 'lps'),
	(609753, 129, '2014-04-01 00:03:43.000000', 'consum', 0.0218, 'lps'),
	(609754, 129, '2014-04-01 00:03:44.000000', 'consum', 0.0224, 'lps'),
	(609755, 129, '2014-04-01 00:03:45.000000', 'consum', 0.0231, 'lps'),
	(609756, 129, '2014-04-01 00:03:46.000000', 'consum', 0.0226, 'lps'),
	(609757, 129, '2014-04-01 00:03:47.000000', 'consum', 0.0228, 'lps'),
	(609758, 129, '2014-04-01 00:03:48.000000', 'consum', 0.0229, 'lps'),
	(609759, 129, '2014-04-01 00:03:49.000000', 'consum', 0.0227, 'lps'),
	(609760, 129, '2014-04-01 00:03:50.000000', 'consum', 0.0213, 'lps'),
	(609761, 129, '2014-04-01 00:03:51.000000', 'consum', 0.0224, 'lps'),
	(609762, 129, '2014-04-01 00:03:52.000000', 'consum', 0.0222, 'lps'),
	(609763, 129, '2014-04-01 00:03:53.000000', 'consum', 0.0229, 'lps'),
	(609764, 129, '2014-04-01 00:03:54.000000', 'consum', 0.0221, 'lps'),
	(609765, 129, '2014-04-01 00:03:55.000000', 'consum', 0.0233, 'lps'),
	(609766, 129, '2014-04-01 00:03:56.000000', 'consum', 0.0218, 'lps'),
	(609767, 129, '2014-04-01 00:03:57.000000', 'consum', 0.0233, 'lps'),
	(609768, 129, '2014-04-01 00:03:58.000000', 'consum', 0.0230, 'lps'),
	(609769, 129, '2014-04-01 00:03:59.000000', 'consum', 0.0216, 'lps'),
	(609770, 129, '2014-04-01 00:04:00.000000', 'consum', 0.0227, 'lps'),
	(609771, 129, '2014-04-01 00:04:01.000000', 'consum', 0.0232, 'lps'),
	(609772, 129, '2014-04-01 00:04:02.000000', 'consum', 0.0218, 'lps'),
	(609773, 129, '2014-04-01 00:04:03.000000', 'consum', 0.0212, 'lps'),
	(609774, 129, '2014-04-01 00:04:04.000000', 'consum', 0.0221, 'lps'),
	(609775, 129, '2014-04-01 00:04:05.000000', 'consum', 0.0233, 'lps'),
	(609776, 129, '2014-04-01 00:04:06.000000', 'consum', 0.0222, 'lps'),
	(609777, 129, '2014-04-01 00:04:07.000000', 'consum', 0.0224, 'lps'),
	(609778, 129, '2014-04-01 00:04:08.000000', 'consum', 0.0222, 'lps'),
	(609779, 129, '2014-04-01 00:04:09.000000', 'consum', 0.0227, 'lps'),
	(609780, 129, '2014-04-01 00:04:10.000000', 'consum', 0.0213, 'lps'),
	(609781, 129, '2014-04-01 00:04:11.000000', 'consum', 0.0222, 'lps'),
	(609782, 129, '2014-04-01 00:04:12.000000', 'consum', 0.0212, 'lps'),
	(609783, 129, '2014-04-01 00:04:13.000000', 'consum', 0.0233, 'lps'),
	(609784, 129, '2014-04-01 00:04:14.000000', 'consum', 0.0222, 'lps'),
	(609785, 129, '2014-04-01 00:04:15.000000', 'consum', 0.0226, 'lps'),
	(609786, 129, '2014-04-01 00:04:16.000000', 'consum', 0.0232, 'lps'),
	(609787, 129, '2014-04-01 00:04:17.000000', 'consum', 0.0224, 'lps'),
	(609788, 129, '2014-04-01 00:04:18.000000', 'consum', 0.0215, 'lps'),
	(609789, 129, '2014-04-01 00:04:19.000000', 'consum', 0.0218, 'lps'),
	(609790, 129, '2014-04-01 00:04:20.000000', 'consum', 0.0233, 'lps'),
	(609791, 129, '2014-04-01 00:04:21.000000', 'consum', 0.0231, 'lps'),
	(609792, 129, '2014-04-01 00:04:22.000000', 'consum', 0.0224, 'lps'),
	(609793, 129, '2014-04-01 00:04:23.000000', 'consum', 0.0215, 'lps'),
	(609794, 129, '2014-04-01 00:04:24.000000', 'consum', 0.0219, 'lps'),
	(609795, 129, '2014-04-01 00:04:25.000000', 'consum', 0.0216, 'lps'),
	(609796, 129, '2014-04-01 00:04:26.000000', 'consum', 0.0216, 'lps'),
	(609797, 129, '2014-04-01 00:04:27.000000', 'consum', 0.0219, 'lps'),
	(609798, 129, '2014-04-01 00:04:28.000000', 'consum', 0.0215, 'lps'),
	(609799, 129, '2014-04-01 00:04:29.000000', 'consum', 0.0210, 'lps'),
	(609800, 129, '2014-04-01 00:04:30.000000', 'consum', 0.0217, 'lps'),
	(609801, 129, '2014-04-01 00:04:31.000000', 'consum', 0.0224, 'lps'),
	(609802, 129, '2014-04-01 00:04:32.000000', 'consum', 0.0212, 'lps'),
	(609803, 129, '2014-04-01 00:04:33.000000', 'consum', 0.0224, 'lps'),
	(609804, 129, '2014-04-01 00:04:34.000000', 'consum', 0.0226, 'lps'),
	(609805, 129, '2014-04-01 00:04:35.000000', 'consum', 0.0224, 'lps'),
	(609806, 129, '2014-04-01 00:04:36.000000', 'consum', 0.0212, 'lps'),
	(609807, 129, '2014-04-01 00:04:37.000000', 'consum', 0.0223, 'lps'),
	(609808, 129, '2014-04-01 00:04:38.000000', 'consum', 0.0222, 'lps'),
	(609809, 129, '2014-04-01 00:04:39.000000', 'consum', 0.0233, 'lps'),
	(609810, 129, '2014-04-01 00:04:40.000000', 'consum', 0.0219, 'lps'),
	(609811, 129, '2014-04-01 00:04:41.000000', 'consum', 0.0232, 'lps'),
	(609812, 129, '2014-04-01 00:04:42.000000', 'consum', 0.0224, 'lps'),
	(609813, 129, '2014-04-01 00:04:43.000000', 'consum', 0.0214, 'lps'),
	(609814, 129, '2014-04-01 00:04:44.000000', 'consum', 0.0214, 'lps'),
	(609815, 129, '2014-04-01 00:04:45.000000', 'consum', 0.0216, 'lps'),
	(609816, 129, '2014-04-01 00:04:46.000000', 'consum', 0.0231, 'lps'),
	(609817, 129, '2014-04-01 00:04:47.000000', 'consum', 0.0222, 'lps'),
	(609818, 129, '2014-04-01 00:04:48.000000', 'consum', 0.0211, 'lps'),
	(609819, 129, '2014-04-01 00:04:49.000000', 'consum', 0.0227, 'lps'),
	(609820, 129, '2014-04-01 00:04:50.000000', 'consum', 0.0220, 'lps'),
	(609821, 129, '2014-04-01 00:04:51.000000', 'consum', 0.0231, 'lps'),
	(609822, 129, '2014-04-01 00:04:52.000000', 'consum', 0.0217, 'lps'),
	(609823, 129, '2014-04-01 00:04:53.000000', 'consum', 0.0228, 'lps'),
	(609824, 129, '2014-04-01 00:04:54.000000', 'consum', 0.0210, 'lps'),
	(609825, 129, '2014-04-01 00:04:55.000000', 'consum', 0.0226, 'lps'),
	(609826, 129, '2014-04-01 00:04:56.000000', 'consum', 0.0221, 'lps'),
	(609827, 129, '2014-04-01 00:04:57.000000', 'consum', 0.0218, 'lps'),
	(609828, 129, '2014-04-01 00:04:58.000000', 'consum', 0.0218, 'lps'),
	(609829, 129, '2014-04-01 00:04:59.000000', 'consum', 0.0224, 'lps'),
	(609830, 129, '2014-04-01 00:05:00.000000', 'consum', 0.0232, 'lps'),
	(609831, 129, '2014-04-01 00:05:01.000000', 'consum', 0.0232, 'lps'),
	(609832, 129, '2014-04-01 00:05:02.000000', 'consum', 0.0229, 'lps'),
	(609833, 129, '2014-04-01 00:05:03.000000', 'consum', 0.0218, 'lps'),
	(609834, 129, '2014-04-01 00:05:04.000000', 'consum', 0.0215, 'lps'),
	(609835, 129, '2014-04-01 00:05:05.000000', 'consum', 0.0214, 'lps'),
	(609836, 129, '2014-04-01 00:05:06.000000', 'consum', 0.0215, 'lps'),
	(609837, 129, '2014-04-01 00:05:07.000000', 'consum', 0.0221, 'lps'),
	(609838, 129, '2014-04-01 00:05:08.000000', 'consum', 0.0229, 'lps'),
	(609839, 129, '2014-04-01 00:05:09.000000', 'consum', 0.0224, 'lps'),
	(609840, 129, '2014-04-01 00:05:10.000000', 'consum', 0.0222, 'lps'),
	(609841, 129, '2014-04-01 00:05:11.000000', 'consum', 0.0228, 'lps'),
	(609842, 129, '2014-04-01 00:05:12.000000', 'consum', 0.0219, 'lps'),
	(609843, 129, '2014-04-01 00:05:13.000000', 'consum', 0.0225, 'lps'),
	(609844, 129, '2014-04-01 00:05:14.000000', 'consum', 0.0210, 'lps'),
	(609845, 129, '2014-04-01 00:05:15.000000', 'consum', 0.0211, 'lps'),
	(609846, 129, '2014-04-01 00:05:16.000000', 'consum', 0.0219, 'lps'),
	(609847, 129, '2014-04-01 00:05:17.000000', 'consum', 0.0228, 'lps'),
	(609848, 129, '2014-04-01 00:05:18.000000', 'consum', 0.0226, 'lps'),
	(609849, 129, '2014-04-01 00:05:19.000000', 'consum', 0.0211, 'lps'),
	(609850, 129, '2014-04-01 00:05:20.000000', 'consum', 0.0216, 'lps'),
	(609851, 129, '2014-04-01 00:05:21.000000', 'consum', 0.0211, 'lps'),
	(609852, 129, '2014-04-01 00:05:22.000000', 'consum', 0.0225, 'lps'),
	(609853, 129, '2014-04-01 00:05:23.000000', 'consum', 0.0233, 'lps'),
	(609854, 129, '2014-04-01 00:05:24.000000', 'consum', 0.0210, 'lps'),
	(609855, 129, '2014-04-01 00:05:25.000000', 'consum', 0.0213, 'lps'),
	(609856, 129, '2014-04-01 00:05:26.000000', 'consum', 0.0224, 'lps'),
	(609857, 129, '2014-04-01 00:05:27.000000', 'consum', 0.0226, 'lps'),
	(609858, 129, '2014-04-01 00:05:28.000000', 'consum', 0.0223, 'lps'),
	(609859, 129, '2014-04-01 00:05:29.000000', 'consum', 0.0228, 'lps'),
	(609860, 129, '2014-04-01 00:05:30.000000', 'consum', 0.0214, 'lps'),
	(609861, 129, '2014-04-01 00:05:31.000000', 'consum', 0.0224, 'lps'),
	(609862, 129, '2014-04-01 00:05:32.000000', 'consum', 0.0222, 'lps'),
	(609863, 129, '2014-04-01 00:05:33.000000', 'consum', 0.0228, 'lps'),
	(609864, 129, '2014-04-01 00:05:34.000000', 'consum', 0.0214, 'lps'),
	(609865, 129, '2014-04-01 00:05:35.000000', 'consum', 0.0226, 'lps'),
	(609866, 129, '2014-04-01 00:05:36.000000', 'consum', 0.0231, 'lps'),
	(609867, 129, '2014-04-01 00:05:37.000000', 'consum', 0.0219, 'lps'),
	(609868, 129, '2014-04-01 00:05:38.000000', 'consum', 0.0215, 'lps'),
	(609869, 129, '2014-04-01 00:05:39.000000', 'consum', 0.0210, 'lps'),
	(609870, 129, '2014-04-01 00:05:40.000000', 'consum', 0.0221, 'lps'),
	(609871, 129, '2014-04-01 00:05:41.000000', 'consum', 0.0215, 'lps'),
	(609872, 129, '2014-04-01 00:05:42.000000', 'consum', 0.0225, 'lps'),
	(609873, 129, '2014-04-01 00:05:43.000000', 'consum', 0.0226, 'lps'),
	(609874, 129, '2014-04-01 00:05:44.000000', 'consum', 0.0221, 'lps'),
	(609875, 129, '2014-04-01 00:05:45.000000', 'consum', 0.0217, 'lps'),
	(609876, 129, '2014-04-01 00:05:46.000000', 'consum', 0.0212, 'lps'),
	(609877, 129, '2014-04-01 00:05:47.000000', 'consum', 0.0223, 'lps'),
	(609878, 129, '2014-04-01 00:05:48.000000', 'consum', 0.0220, 'lps'),
	(609879, 129, '2014-04-01 00:05:49.000000', 'consum', 0.0223, 'lps'),
	(609880, 129, '2014-04-01 00:05:50.000000', 'consum', 0.0222, 'lps'),
	(609881, 129, '2014-04-01 00:05:51.000000', 'consum', 0.0231, 'lps'),
	(609882, 129, '2014-04-01 00:05:52.000000', 'consum', 0.0231, 'lps'),
	(609883, 129, '2014-04-01 00:05:53.000000', 'consum', 0.0230, 'lps'),
	(609884, 129, '2014-04-01 00:05:54.000000', 'consum', 0.0225, 'lps'),
	(609885, 129, '2014-04-01 00:05:55.000000', 'consum', 0.0222, 'lps'),
	(609886, 129, '2014-04-01 00:05:56.000000', 'consum', 0.0227, 'lps'),
	(609887, 129, '2014-04-01 00:05:57.000000', 'consum', 0.0211, 'lps'),
	(609888, 129, '2014-04-01 00:05:58.000000', 'consum', 0.0214, 'lps'),
	(609889, 129, '2014-04-01 00:05:59.000000', 'consum', 0.0225, 'lps'),
	(609890, 129, '2014-04-01 00:06:00.000000', 'consum', 0.0226, 'lps'),
	(609891, 129, '2014-04-01 00:06:01.000000', 'consum', 0.0222, 'lps'),
	(609892, 129, '2014-04-01 00:06:02.000000', 'consum', 0.0224, 'lps'),
	(609893, 129, '2014-04-01 00:06:03.000000', 'consum', 0.0219, 'lps'),
	(609894, 129, '2014-04-01 00:06:04.000000', 'consum', 0.0216, 'lps'),
	(609895, 129, '2014-04-01 00:06:05.000000', 'consum', 0.0211, 'lps'),
	(609896, 129, '2014-04-01 00:06:06.000000', 'consum', 0.0221, 'lps'),
	(609897, 129, '2014-04-01 00:06:07.000000', 'consum', 0.0214, 'lps'),
	(609898, 129, '2014-04-01 00:06:08.000000', 'consum', 0.0222, 'lps'),
	(609899, 129, '2014-04-01 00:06:09.000000', 'consum', 0.0213, 'lps'),
	(609900, 129, '2014-04-01 00:06:10.000000', 'consum', 0.0211, 'lps'),
	(609901, 129, '2014-04-01 00:06:11.000000', 'consum', 0.0230, 'lps'),
	(609902, 129, '2014-04-01 00:06:12.000000', 'consum', 0.0212, 'lps'),
	(609903, 129, '2014-04-01 00:06:13.000000', 'consum', 0.0233, 'lps'),
	(609904, 129, '2014-04-01 00:06:14.000000', 'consum', 0.0224, 'lps'),
	(609905, 129, '2014-04-01 00:06:15.000000', 'consum', 0.0212, 'lps'),
	(609906, 129, '2014-04-01 00:06:16.000000', 'consum', 0.0228, 'lps'),
	(609907, 129, '2014-04-01 00:06:17.000000', 'consum', 0.0219, 'lps'),
	(609908, 129, '2014-04-01 00:06:18.000000', 'consum', 0.0227, 'lps'),
	(609909, 129, '2014-04-01 00:06:19.000000', 'consum', 0.0220, 'lps'),
	(609910, 129, '2014-04-01 00:06:20.000000', 'consum', 0.0232, 'lps'),
	(609911, 129, '2014-04-01 00:06:21.000000', 'consum', 0.0221, 'lps'),
	(609912, 129, '2014-04-01 00:06:22.000000', 'consum', 0.0221, 'lps'),
	(609913, 129, '2014-04-01 00:06:23.000000', 'consum', 0.0212, 'lps'),
	(609914, 129, '2014-04-01 00:06:24.000000', 'consum', 0.0233, 'lps'),
	(609915, 129, '2014-04-01 00:06:25.000000', 'consum', 0.0223, 'lps'),
	(609916, 129, '2014-04-01 00:06:26.000000', 'consum', 0.0232, 'lps'),
	(609917, 129, '2014-04-01 00:06:27.000000', 'consum', 0.0232, 'lps'),
	(609918, 129, '2014-04-01 00:06:28.000000', 'consum', 0.0233, 'lps'),
	(609919, 129, '2014-04-01 00:06:29.000000', 'consum', 0.0210, 'lps'),
	(609920, 129, '2014-04-01 00:06:30.000000', 'consum', 0.0215, 'lps'),
	(609921, 129, '2014-04-01 00:06:31.000000', 'consum', 0.0212, 'lps'),
	(609922, 129, '2014-04-01 00:06:32.000000', 'consum', 0.0229, 'lps'),
	(609923, 129, '2014-04-01 00:06:33.000000', 'consum', 0.0229, 'lps'),
	(609924, 129, '2014-04-01 00:06:34.000000', 'consum', 0.0222, 'lps'),
	(609925, 129, '2014-04-01 00:06:35.000000', 'consum', 0.0212, 'lps'),
	(609926, 129, '2014-04-01 00:06:36.000000', 'consum', 0.0212, 'lps'),
	(609927, 129, '2014-04-01 00:06:37.000000', 'consum', 0.0213, 'lps'),
	(609928, 129, '2014-04-01 00:06:38.000000', 'consum', 0.0218, 'lps'),
	(609929, 129, '2014-04-01 00:06:39.000000', 'consum', 0.0220, 'lps'),
	(609930, 129, '2014-04-01 00:06:40.000000', 'consum', 0.0210, 'lps'),
	(609931, 129, '2014-04-01 00:06:41.000000', 'consum', 0.0230, 'lps'),
	(609932, 129, '2014-04-01 00:06:42.000000', 'consum', 0.0216, 'lps'),
	(609933, 129, '2014-04-01 00:06:43.000000', 'consum', 0.0225, 'lps'),
	(609934, 129, '2014-04-01 00:06:44.000000', 'consum', 0.0222, 'lps'),
	(609935, 129, '2014-04-01 00:06:45.000000', 'consum', 0.0226, 'lps'),
	(609936, 129, '2014-04-01 00:06:46.000000', 'consum', 0.0232, 'lps'),
	(609937, 129, '2014-04-01 00:06:47.000000', 'consum', 0.0221, 'lps'),
	(609938, 129, '2014-04-01 00:06:48.000000', 'consum', 0.0225, 'lps'),
	(609939, 129, '2014-04-01 00:06:49.000000', 'consum', 0.0226, 'lps'),
	(609940, 129, '2014-04-01 00:06:50.000000', 'consum', 0.0225, 'lps'),
	(609941, 129, '2014-04-01 00:06:51.000000', 'consum', 0.0212, 'lps'),
	(609942, 129, '2014-04-01 00:06:52.000000', 'consum', 0.0224, 'lps'),
	(609943, 129, '2014-04-01 00:06:53.000000', 'consum', 0.0224, 'lps'),
	(609944, 129, '2014-04-01 00:06:54.000000', 'consum', 0.0218, 'lps'),
	(609945, 129, '2014-04-01 00:06:55.000000', 'consum', 0.0232, 'lps'),
	(609946, 129, '2014-04-01 00:06:56.000000', 'consum', 0.0224, 'lps'),
	(609947, 129, '2014-04-01 00:06:57.000000', 'consum', 0.0214, 'lps'),
	(609948, 129, '2014-04-01 00:06:58.000000', 'consum', 0.0212, 'lps'),
	(609949, 129, '2014-04-01 00:06:59.000000', 'consum', 0.0232, 'lps'),
	(609950, 129, '2014-04-01 00:07:00.000000', 'consum', 0.0221, 'lps'),
	(609951, 129, '2014-04-01 00:07:01.000000', 'consum', 0.0223, 'lps'),
	(609952, 129, '2014-04-01 00:07:02.000000', 'consum', 0.0218, 'lps'),
	(609953, 129, '2014-04-01 00:07:03.000000', 'consum', 0.0211, 'lps'),
	(609954, 129, '2014-04-01 00:07:04.000000', 'consum', 0.0216, 'lps'),
	(609955, 129, '2014-04-01 00:07:05.000000', 'consum', 0.0214, 'lps'),
	(609956, 129, '2014-04-01 00:07:06.000000', 'consum', 0.0214, 'lps'),
	(609957, 129, '2014-04-01 00:07:07.000000', 'consum', 0.0216, 'lps'),
	(609958, 129, '2014-04-01 00:07:08.000000', 'consum', 0.0230, 'lps'),
	(609959, 129, '2014-04-01 00:07:09.000000', 'consum', 0.0220, 'lps'),
	(609960, 129, '2014-04-01 00:07:10.000000', 'consum', 0.0224, 'lps'),
	(609961, 129, '2014-04-01 00:07:11.000000', 'consum', 0.0227, 'lps'),
	(609962, 129, '2014-04-01 00:07:12.000000', 'consum', 0.0230, 'lps'),
	(609963, 129, '2014-04-01 00:07:13.000000', 'consum', 0.0233, 'lps'),
	(609964, 129, '2014-04-01 00:07:14.000000', 'consum', 0.0219, 'lps'),
	(609965, 129, '2014-04-01 00:07:15.000000', 'consum', 0.0212, 'lps'),
	(609966, 129, '2014-04-01 00:07:16.000000', 'consum', 0.0218, 'lps'),
	(609967, 129, '2014-04-01 00:07:17.000000', 'consum', 0.0221, 'lps'),
	(609968, 129, '2014-04-01 00:07:18.000000', 'consum', 0.0218, 'lps'),
	(609969, 129, '2014-04-01 00:07:19.000000', 'consum', 0.0218, 'lps'),
	(609970, 129, '2014-04-01 00:07:20.000000', 'consum', 0.0226, 'lps'),
	(609971, 129, '2014-04-01 00:07:21.000000', 'consum', 0.0217, 'lps'),
	(609972, 129, '2014-04-01 00:07:22.000000', 'consum', 0.0221, 'lps'),
	(609973, 129, '2014-04-01 00:07:23.000000', 'consum', 0.0222, 'lps'),
	(609974, 129, '2014-04-01 00:07:24.000000', 'consum', 0.0213, 'lps'),
	(609975, 129, '2014-04-01 00:07:25.000000', 'consum', 0.0215, 'lps'),
	(609976, 129, '2014-04-01 00:07:26.000000', 'consum', 0.0226, 'lps'),
	(609977, 129, '2014-04-01 00:07:27.000000', 'consum', 0.0225, 'lps'),
	(609978, 129, '2014-04-01 00:07:28.000000', 'consum', 0.0216, 'lps'),
	(609979, 129, '2014-04-01 00:07:29.000000', 'consum', 0.0219, 'lps'),
	(609980, 129, '2014-04-01 00:07:30.000000', 'consum', 0.0215, 'lps'),
	(609981, 129, '2014-04-01 00:07:31.000000', 'consum', 0.0232, 'lps'),
	(609982, 129, '2014-04-01 00:07:32.000000', 'consum', 0.0211, 'lps'),
	(609983, 129, '2014-04-01 00:07:33.000000', 'consum', 0.0218, 'lps'),
	(609984, 129, '2014-04-01 00:07:34.000000', 'consum', 0.0227, 'lps'),
	(609985, 129, '2014-04-01 00:07:35.000000', 'consum', 0.0221, 'lps'),
	(609986, 129, '2014-04-01 00:07:36.000000', 'consum', 0.0217, 'lps'),
	(609987, 129, '2014-04-01 00:07:37.000000', 'consum', 0.0212, 'lps'),
	(609988, 129, '2014-04-01 00:07:38.000000', 'consum', 0.0222, 'lps'),
	(609989, 129, '2014-04-01 00:07:39.000000', 'consum', 0.0218, 'lps'),
	(609990, 129, '2014-04-01 00:07:40.000000', 'consum', 0.0214, 'lps'),
	(609991, 129, '2014-04-01 00:07:41.000000', 'consum', 0.0231, 'lps'),
	(609992, 129, '2014-04-01 00:07:42.000000', 'consum', 0.0232, 'lps'),
	(609993, 129, '2014-04-01 00:07:43.000000', 'consum', 0.0231, 'lps'),
	(609994, 129, '2014-04-01 00:07:44.000000', 'consum', 0.0227, 'lps'),
	(609995, 129, '2014-04-01 00:07:45.000000', 'consum', 0.0233, 'lps'),
	(609996, 129, '2014-04-01 00:07:46.000000', 'consum', 0.0227, 'lps'),
	(609997, 129, '2014-04-01 00:07:47.000000', 'consum', 0.0227, 'lps'),
	(609998, 129, '2014-04-01 00:07:48.000000', 'consum', 0.0218, 'lps'),
	(609999, 129, '2014-04-01 00:07:49.000000', 'consum', 0.0226, 'lps'),
	(610000, 129, '2014-04-01 00:07:50.000000', 'consum', 0.0217, 'lps'),
	(610001, 129, '2014-04-01 00:07:51.000000', 'consum', 0.0224, 'lps'),
	(610002, 129, '2014-04-01 00:07:52.000000', 'consum', 0.0210, 'lps'),
	(610003, 129, '2014-04-01 00:07:53.000000', 'consum', 0.0215, 'lps'),
	(610004, 129, '2014-04-01 00:07:54.000000', 'consum', 0.0213, 'lps'),
	(610005, 129, '2014-04-01 00:07:55.000000', 'consum', 0.0232, 'lps'),
	(610006, 129, '2014-04-01 00:07:56.000000', 'consum', 0.0218, 'lps'),
	(610007, 129, '2014-04-01 00:07:57.000000', 'consum', 0.0233, 'lps'),
	(610008, 129, '2014-04-01 00:07:58.000000', 'consum', 0.0230, 'lps'),
	(610009, 129, '2014-04-01 00:07:59.000000', 'consum', 0.0218, 'lps'),
	(610010, 129, '2014-04-01 00:08:00.000000', 'consum', 0.0213, 'lps'),
	(610011, 129, '2014-04-01 00:08:01.000000', 'consum', 0.0226, 'lps'),
	(610012, 129, '2014-04-01 00:08:02.000000', 'consum', 0.0233, 'lps'),
	(610013, 129, '2014-04-01 00:08:03.000000', 'consum', 0.0230, 'lps'),
	(610014, 129, '2014-04-01 00:08:04.000000', 'consum', 0.0215, 'lps'),
	(610015, 129, '2014-04-01 00:08:05.000000', 'consum', 0.0226, 'lps'),
	(610016, 129, '2014-04-01 00:08:06.000000', 'consum', 0.0227, 'lps'),
	(610017, 129, '2014-04-01 00:08:07.000000', 'consum', 0.0223, 'lps'),
	(610018, 129, '2014-04-01 00:08:08.000000', 'consum', 0.0225, 'lps'),
	(610019, 129, '2014-04-01 00:08:09.000000', 'consum', 0.0223, 'lps'),
	(610020, 129, '2014-04-01 00:08:10.000000', 'consum', 0.0231, 'lps'),
	(610021, 129, '2014-04-01 00:08:11.000000', 'consum', 0.0226, 'lps'),
	(610022, 129, '2014-04-01 00:08:12.000000', 'consum', 0.0229, 'lps'),
	(610023, 129, '2014-04-01 00:08:13.000000', 'consum', 0.0231, 'lps'),
	(610024, 129, '2014-04-01 00:08:14.000000', 'consum', 0.0214, 'lps'),
	(610025, 129, '2014-04-01 00:08:15.000000', 'consum', 0.0214, 'lps'),
	(610026, 129, '2014-04-01 00:08:16.000000', 'consum', 0.0217, 'lps'),
	(610027, 129, '2014-04-01 00:08:17.000000', 'consum', 0.0211, 'lps'),
	(610028, 129, '2014-04-01 00:08:18.000000', 'consum', 0.0219, 'lps'),
	(610029, 129, '2014-04-01 00:08:19.000000', 'consum', 0.0228, 'lps'),
	(610030, 129, '2014-04-01 00:08:20.000000', 'consum', 0.0227, 'lps'),
	(610031, 129, '2014-04-01 00:08:21.000000', 'consum', 0.0218, 'lps'),
	(610032, 129, '2014-04-01 00:08:22.000000', 'consum', 0.0222, 'lps'),
	(610033, 129, '2014-04-01 00:08:23.000000', 'consum', 0.0224, 'lps'),
	(610034, 129, '2014-04-01 00:08:24.000000', 'consum', 0.0219, 'lps'),
	(610035, 129, '2014-04-01 00:08:25.000000', 'consum', 0.0212, 'lps'),
	(610036, 129, '2014-04-01 00:08:26.000000', 'consum', 0.0219, 'lps'),
	(610037, 129, '2014-04-01 00:08:27.000000', 'consum', 0.0226, 'lps'),
	(610038, 129, '2014-04-01 00:08:28.000000', 'consum', 0.0213, 'lps'),
	(610039, 129, '2014-04-01 00:08:29.000000', 'consum', 0.0227, 'lps'),
	(610040, 129, '2014-04-01 00:08:30.000000', 'consum', 0.0215, 'lps'),
	(610041, 129, '2014-04-01 00:08:31.000000', 'consum', 0.0232, 'lps'),
	(610042, 129, '2014-04-01 00:08:32.000000', 'consum', 0.0210, 'lps'),
	(610043, 129, '2014-04-01 00:08:33.000000', 'consum', 0.0217, 'lps'),
	(610044, 129, '2014-04-01 00:08:34.000000', 'consum', 0.0221, 'lps'),
	(610045, 129, '2014-04-01 00:08:35.000000', 'consum', 0.0219, 'lps'),
	(610046, 129, '2014-04-01 00:08:36.000000', 'consum', 0.0223, 'lps'),
	(610047, 129, '2014-04-01 00:08:37.000000', 'consum', 0.0224, 'lps'),
	(610048, 129, '2014-04-01 00:08:38.000000', 'consum', 0.0220, 'lps'),
	(610049, 129, '2014-04-01 00:08:39.000000', 'consum', 0.0216, 'lps'),
	(610050, 129, '2014-04-01 00:08:40.000000', 'consum', 0.0211, 'lps'),
	(610051, 129, '2014-04-01 00:08:41.000000', 'consum', 0.0220, 'lps'),
	(610052, 129, '2014-04-01 00:08:42.000000', 'consum', 0.0211, 'lps'),
	(610053, 129, '2014-04-01 00:08:43.000000', 'consum', 0.0210, 'lps'),
	(610054, 129, '2014-04-01 00:08:44.000000', 'consum', 0.0233, 'lps'),
	(610055, 129, '2014-04-01 00:08:45.000000', 'consum', 0.0227, 'lps'),
	(610056, 129, '2014-04-01 00:08:46.000000', 'consum', 0.0226, 'lps'),
	(610057, 129, '2014-04-01 00:08:47.000000', 'consum', 0.0215, 'lps'),
	(610058, 129, '2014-04-01 00:08:48.000000', 'consum', 0.0212, 'lps'),
	(610059, 129, '2014-04-01 00:08:49.000000', 'consum', 0.0231, 'lps'),
	(610060, 129, '2014-04-01 00:08:50.000000', 'consum', 0.0214, 'lps'),
	(610061, 129, '2014-04-01 00:08:51.000000', 'consum', 0.0214, 'lps'),
	(610062, 129, '2014-04-01 00:08:52.000000', 'consum', 0.0220, 'lps'),
	(610063, 129, '2014-04-01 00:08:53.000000', 'consum', 0.0225, 'lps'),
	(610064, 129, '2014-04-01 00:08:54.000000', 'consum', 0.0232, 'lps'),
	(610065, 129, '2014-04-01 00:08:55.000000', 'consum', 0.0227, 'lps'),
	(610066, 129, '2014-04-01 00:08:56.000000', 'consum', 0.0229, 'lps'),
	(610067, 129, '2014-04-01 00:08:57.000000', 'consum', 0.0231, 'lps'),
	(610068, 129, '2014-04-01 00:08:58.000000', 'consum', 0.0212, 'lps'),
	(610069, 129, '2014-04-01 00:08:59.000000', 'consum', 0.0228, 'lps'),
	(610070, 129, '2014-04-01 00:09:00.000000', 'consum', 0.0223, 'lps'),
	(610071, 129, '2014-04-01 00:09:01.000000', 'consum', 0.0220, 'lps'),
	(610072, 129, '2014-04-01 00:09:02.000000', 'consum', 0.0222, 'lps'),
	(610073, 129, '2014-04-01 00:09:03.000000', 'consum', 0.0216, 'lps'),
	(610074, 129, '2014-04-01 00:09:04.000000', 'consum', 0.0228, 'lps'),
	(610075, 129, '2014-04-01 00:09:05.000000', 'consum', 0.0210, 'lps'),
	(610076, 129, '2014-04-01 00:09:06.000000', 'consum', 0.0228, 'lps'),
	(610077, 129, '2014-04-01 00:09:07.000000', 'consum', 0.0229, 'lps'),
	(610078, 129, '2014-04-01 00:09:08.000000', 'consum', 0.0227, 'lps'),
	(610079, 129, '2014-04-01 00:09:09.000000', 'consum', 0.0214, 'lps'),
	(610080, 129, '2014-04-01 00:09:10.000000', 'consum', 0.0226, 'lps'),
	(610081, 129, '2014-04-01 00:09:11.000000', 'consum', 0.0233, 'lps'),
	(610082, 129, '2014-04-01 00:09:12.000000', 'consum', 0.0228, 'lps'),
	(610083, 129, '2014-04-01 00:09:13.000000', 'consum', 0.0232, 'lps'),
	(610084, 129, '2014-04-01 00:09:14.000000', 'consum', 0.0217, 'lps'),
	(610085, 129, '2014-04-01 00:09:15.000000', 'consum', 0.0230, 'lps'),
	(610086, 129, '2014-04-01 00:09:16.000000', 'consum', 0.0216, 'lps'),
	(610087, 129, '2014-04-01 00:09:17.000000', 'consum', 0.0228, 'lps'),
	(610088, 129, '2014-04-01 00:09:18.000000', 'consum', 0.0213, 'lps'),
	(610089, 129, '2014-04-01 00:09:19.000000', 'consum', 0.0217, 'lps'),
	(610090, 129, '2014-04-01 00:09:20.000000', 'consum', 0.0213, 'lps'),
	(610091, 129, '2014-04-01 00:09:21.000000', 'consum', 0.0228, 'lps'),
	(610092, 129, '2014-04-01 00:09:22.000000', 'consum', 0.0220, 'lps'),
	(610093, 129, '2014-04-01 00:09:23.000000', 'consum', 0.0232, 'lps'),
	(610094, 129, '2014-04-01 00:09:24.000000', 'consum', 0.0216, 'lps'),
	(610095, 129, '2014-04-01 00:09:25.000000', 'consum', 0.0222, 'lps'),
	(610096, 129, '2014-04-01 00:09:26.000000', 'consum', 0.0230, 'lps'),
	(610097, 129, '2014-04-01 00:09:27.000000', 'consum', 0.0226, 'lps'),
	(610098, 129, '2014-04-01 00:09:28.000000', 'consum', 0.0233, 'lps'),
	(610099, 129, '2014-04-01 00:09:29.000000', 'consum', 0.0226, 'lps'),
	(610100, 129, '2014-04-01 00:09:30.000000', 'consum', 0.0222, 'lps'),
	(610101, 129, '2014-04-01 00:09:31.000000', 'consum', 0.0221, 'lps'),
	(610102, 129, '2014-04-01 00:09:32.000000', 'consum', 0.0233, 'lps'),
	(610103, 129, '2014-04-01 00:09:33.000000', 'consum', 0.0218, 'lps'),
	(610104, 129, '2014-04-01 00:09:34.000000', 'consum', 0.0231, 'lps'),
	(610105, 129, '2014-04-01 00:09:35.000000', 'consum', 0.0219, 'lps'),
	(610106, 129, '2014-04-01 00:09:36.000000', 'consum', 0.0216, 'lps'),
	(610107, 129, '2014-04-01 00:09:37.000000', 'consum', 0.0214, 'lps'),
	(610108, 129, '2014-04-01 00:09:38.000000', 'consum', 0.0213, 'lps'),
	(610109, 129, '2014-04-01 00:09:39.000000', 'consum', 0.0212, 'lps'),
	(610110, 129, '2014-04-01 00:09:40.000000', 'consum', 0.0211, 'lps'),
	(610111, 129, '2014-04-01 00:09:41.000000', 'consum', 0.0233, 'lps'),
	(610112, 129, '2014-04-01 00:09:42.000000', 'consum', 0.0229, 'lps'),
	(610113, 129, '2014-04-01 00:09:43.000000', 'consum', 0.0210, 'lps'),
	(610114, 129, '2014-04-01 00:09:44.000000', 'consum', 0.0227, 'lps'),
	(610115, 129, '2014-04-01 00:09:45.000000', 'consum', 0.0223, 'lps'),
	(610116, 129, '2014-04-01 00:09:46.000000', 'consum', 0.0225, 'lps'),
	(610117, 129, '2014-04-01 00:09:47.000000', 'consum', 0.0220, 'lps'),
	(610118, 129, '2014-04-01 00:09:48.000000', 'consum', 0.0219, 'lps'),
	(610119, 129, '2014-04-01 00:09:49.000000', 'consum', 0.0225, 'lps'),
	(610120, 129, '2014-04-01 00:09:50.000000', 'consum', 0.0232, 'lps'),
	(610121, 129, '2014-04-01 00:09:51.000000', 'consum', 0.0229, 'lps'),
	(610122, 129, '2014-04-01 00:09:52.000000', 'consum', 0.0217, 'lps'),
	(610123, 129, '2014-04-01 00:09:53.000000', 'consum', 0.0213, 'lps'),
	(610124, 129, '2014-04-01 00:09:54.000000', 'consum', 0.0225, 'lps'),
	(610125, 129, '2014-04-01 00:09:55.000000', 'consum', 0.0232, 'lps'),
	(610126, 129, '2014-04-01 00:09:56.000000', 'consum', 0.0225, 'lps'),
	(610127, 129, '2014-04-01 00:09:57.000000', 'consum', 0.0220, 'lps'),
	(610128, 129, '2014-04-01 00:09:58.000000', 'consum', 0.0214, 'lps'),
	(610129, 129, '2014-04-01 00:09:59.000000', 'consum', 0.0227, 'lps'),
	(610130, 129, '2014-04-01 00:10:00.000000', 'consum', 0.0233, 'lps'),
	(610131, 129, '2014-04-01 00:10:01.000000', 'consum', 0.0229, 'lps'),
	(610132, 129, '2014-04-01 00:10:02.000000', 'consum', 0.0212, 'lps'),
	(610133, 129, '2014-04-01 00:10:03.000000', 'consum', 0.0211, 'lps'),
	(610134, 129, '2014-04-01 00:10:04.000000', 'consum', 0.0211, 'lps'),
	(610135, 129, '2014-04-01 00:10:05.000000', 'consum', 0.0211, 'lps'),
	(610136, 129, '2014-04-01 00:10:06.000000', 'consum', 0.0212, 'lps'),
	(610137, 129, '2014-04-01 00:10:07.000000', 'consum', 0.0217, 'lps'),
	(610138, 129, '2014-04-01 00:10:08.000000', 'consum', 0.0217, 'lps'),
	(610139, 129, '2014-04-01 00:10:09.000000', 'consum', 0.0223, 'lps'),
	(610140, 129, '2014-04-01 00:10:10.000000', 'consum', 0.0232, 'lps'),
	(610141, 129, '2014-04-01 00:10:11.000000', 'consum', 0.0210, 'lps'),
	(610142, 129, '2014-04-01 00:10:12.000000', 'consum', 0.0216, 'lps'),
	(610143, 129, '2014-04-01 00:10:13.000000', 'consum', 0.0218, 'lps'),
	(610144, 129, '2014-04-01 00:10:14.000000', 'consum', 0.0231, 'lps'),
	(610145, 129, '2014-04-01 00:10:15.000000', 'consum', 0.0219, 'lps'),
	(610146, 129, '2014-04-01 00:10:16.000000', 'consum', 0.0217, 'lps'),
	(610147, 129, '2014-04-01 00:10:17.000000', 'consum', 0.0217, 'lps'),
	(610148, 129, '2014-04-01 00:10:18.000000', 'consum', 0.0224, 'lps'),
	(610149, 129, '2014-04-01 00:10:19.000000', 'consum', 0.0211, 'lps'),
	(610150, 129, '2014-04-01 00:10:20.000000', 'consum', 0.0223, 'lps'),
	(610151, 129, '2014-04-01 00:10:21.000000', 'consum', 0.0224, 'lps'),
	(610152, 129, '2014-04-01 00:10:22.000000', 'consum', 0.0218, 'lps'),
	(610153, 129, '2014-04-01 00:10:23.000000', 'consum', 0.0210, 'lps'),
	(610154, 129, '2014-04-01 00:10:24.000000', 'consum', 0.0210, 'lps'),
	(610155, 129, '2014-04-01 00:10:25.000000', 'consum', 0.0210, 'lps'),
	(610156, 129, '2014-04-01 00:10:26.000000', 'consum', 0.0212, 'lps'),
	(610157, 129, '2014-04-01 00:10:27.000000', 'consum', 0.0218, 'lps'),
	(610158, 129, '2014-04-01 00:10:28.000000', 'consum', 0.0223, 'lps'),
	(610159, 129, '2014-04-01 00:10:29.000000', 'consum', 0.0227, 'lps'),
	(610160, 129, '2014-04-01 00:10:30.000000', 'consum', 0.0231, 'lps'),
	(610161, 129, '2014-04-01 00:10:31.000000', 'consum', 0.0217, 'lps'),
	(610162, 129, '2014-04-01 00:10:32.000000', 'consum', 0.0233, 'lps'),
	(610163, 129, '2014-04-01 00:10:33.000000', 'consum', 0.0229, 'lps'),
	(610164, 129, '2014-04-01 00:10:34.000000', 'consum', 0.0215, 'lps'),
	(610165, 129, '2014-04-01 00:10:35.000000', 'consum', 0.0227, 'lps'),
	(610166, 129, '2014-04-01 00:10:36.000000', 'consum', 0.0231, 'lps'),
	(610167, 129, '2014-04-01 00:10:37.000000', 'consum', 0.0218, 'lps'),
	(610168, 129, '2014-04-01 00:10:38.000000', 'consum', 0.0212, 'lps'),
	(610169, 129, '2014-04-01 00:10:39.000000', 'consum', 0.0218, 'lps'),
	(610170, 129, '2014-04-01 00:10:40.000000', 'consum', 0.0220, 'lps'),
	(610171, 129, '2014-04-01 00:10:41.000000', 'consum', 0.0214, 'lps'),
	(610172, 129, '2014-04-01 00:10:42.000000', 'consum', 0.0224, 'lps'),
	(610173, 129, '2014-04-01 00:10:43.000000', 'consum', 0.0222, 'lps'),
	(610174, 129, '2014-04-01 00:10:44.000000', 'consum', 0.0229, 'lps'),
	(610175, 129, '2014-04-01 00:10:45.000000', 'consum', 0.0220, 'lps'),
	(610176, 129, '2014-04-01 00:10:46.000000', 'consum', 0.0230, 'lps'),
	(610177, 129, '2014-04-01 00:10:47.000000', 'consum', 0.0229, 'lps'),
	(610178, 129, '2014-04-01 00:10:48.000000', 'consum', 0.0223, 'lps'),
	(610179, 129, '2014-04-01 00:10:49.000000', 'consum', 0.0218, 'lps'),
	(610180, 129, '2014-04-01 00:10:50.000000', 'consum', 0.0211, 'lps'),
	(610181, 129, '2014-04-01 00:10:51.000000', 'consum', 0.0216, 'lps'),
	(610182, 129, '2014-04-01 00:10:52.000000', 'consum', 0.0211, 'lps'),
	(610183, 129, '2014-04-01 00:10:53.000000', 'consum', 0.0225, 'lps'),
	(610184, 129, '2014-04-01 00:10:54.000000', 'consum', 0.0211, 'lps'),
	(610185, 129, '2014-04-01 00:10:55.000000', 'consum', 0.0218, 'lps'),
	(610186, 129, '2014-04-01 00:10:56.000000', 'consum', 0.0221, 'lps'),
	(610187, 129, '2014-04-01 00:10:57.000000', 'consum', 0.0219, 'lps'),
	(610188, 129, '2014-04-01 00:10:58.000000', 'consum', 0.0223, 'lps'),
	(610189, 129, '2014-04-01 00:10:59.000000', 'consum', 0.0223, 'lps'),
	(610190, 129, '2014-04-01 00:11:00.000000', 'consum', 0.0211, 'lps'),
	(610191, 129, '2014-04-01 00:11:01.000000', 'consum', 0.0227, 'lps'),
	(610192, 129, '2014-04-01 00:11:02.000000', 'consum', 0.0220, 'lps'),
	(610193, 129, '2014-04-01 00:11:03.000000', 'consum', 0.0233, 'lps'),
	(610194, 129, '2014-04-01 00:11:04.000000', 'consum', 0.0222, 'lps'),
	(610195, 129, '2014-04-01 00:11:05.000000', 'consum', 0.0226, 'lps'),
	(610196, 129, '2014-04-01 00:11:06.000000', 'consum', 0.0232, 'lps'),
	(610197, 129, '2014-04-01 00:11:07.000000', 'consum', 0.0225, 'lps'),
	(610198, 129, '2014-04-01 00:11:08.000000', 'consum', 0.0217, 'lps'),
	(610199, 129, '2014-04-01 00:11:09.000000', 'consum', 0.0227, 'lps'),
	(610200, 129, '2014-04-01 00:11:10.000000', 'consum', 0.0226, 'lps'),
	(610201, 129, '2014-04-01 00:11:11.000000', 'consum', 0.0216, 'lps'),
	(610202, 129, '2014-04-01 00:11:12.000000', 'consum', 0.0216, 'lps'),
	(610203, 129, '2014-04-01 00:11:13.000000', 'consum', 0.0221, 'lps'),
	(610204, 129, '2014-04-01 00:11:14.000000', 'consum', 0.0224, 'lps'),
	(610205, 129, '2014-04-01 00:11:15.000000', 'consum', 0.0224, 'lps'),
	(610206, 129, '2014-04-01 00:11:16.000000', 'consum', 0.0214, 'lps'),
	(610207, 129, '2014-04-01 00:11:17.000000', 'consum', 0.0213, 'lps'),
	(610208, 129, '2014-04-01 00:11:18.000000', 'consum', 0.0215, 'lps'),
	(610209, 129, '2014-04-01 00:11:19.000000', 'consum', 0.0227, 'lps'),
	(610210, 129, '2014-04-01 00:11:20.000000', 'consum', 0.0233, 'lps'),
	(610211, 129, '2014-04-01 00:11:21.000000', 'consum', 0.0223, 'lps'),
	(610212, 129, '2014-04-01 00:11:22.000000', 'consum', 0.0210, 'lps'),
	(610213, 129, '2014-04-01 00:11:23.000000', 'consum', 0.0219, 'lps'),
	(610214, 129, '2014-04-01 00:11:24.000000', 'consum', 0.0230, 'lps'),
	(610215, 129, '2014-04-01 00:11:25.000000', 'consum', 0.0211, 'lps'),
	(610216, 129, '2014-04-01 00:11:26.000000', 'consum', 0.0229, 'lps'),
	(610217, 129, '2014-04-01 00:11:27.000000', 'consum', 0.0229, 'lps'),
	(610218, 129, '2014-04-01 00:11:28.000000', 'consum', 0.0225, 'lps'),
	(610219, 129, '2014-04-01 00:11:29.000000', 'consum', 0.0229, 'lps'),
	(610220, 129, '2014-04-01 00:11:30.000000', 'consum', 0.0210, 'lps'),
	(610221, 129, '2014-04-01 00:11:31.000000', 'consum', 0.0229, 'lps'),
	(610222, 129, '2014-04-01 00:11:32.000000', 'consum', 0.0231, 'lps'),
	(610223, 129, '2014-04-01 00:11:33.000000', 'consum', 0.0211, 'lps'),
	(610224, 129, '2014-04-01 00:11:34.000000', 'consum', 0.0225, 'lps'),
	(610225, 129, '2014-04-01 00:11:35.000000', 'consum', 0.0210, 'lps'),
	(610226, 129, '2014-04-01 00:11:36.000000', 'consum', 0.0213, 'lps'),
	(610227, 129, '2014-04-01 00:11:37.000000', 'consum', 0.0228, 'lps'),
	(610228, 129, '2014-04-01 00:11:38.000000', 'consum', 0.0218, 'lps'),
	(610229, 129, '2014-04-01 00:11:39.000000', 'consum', 0.0220, 'lps'),
	(610230, 129, '2014-04-01 00:11:40.000000', 'consum', 0.0214, 'lps'),
	(610231, 129, '2014-04-01 00:11:41.000000', 'consum', 0.0224, 'lps'),
	(610232, 129, '2014-04-01 00:11:42.000000', 'consum', 0.0221, 'lps'),
	(610233, 129, '2014-04-01 00:11:43.000000', 'consum', 0.0223, 'lps'),
	(610234, 129, '2014-04-01 00:11:44.000000', 'consum', 0.0220, 'lps'),
	(610235, 129, '2014-04-01 00:11:45.000000', 'consum', 0.0222, 'lps'),
	(610236, 129, '2014-04-01 00:11:46.000000', 'consum', 0.0217, 'lps'),
	(610237, 129, '2014-04-01 00:11:47.000000', 'consum', 0.0210, 'lps'),
	(610238, 129, '2014-04-01 00:11:48.000000', 'consum', 0.0214, 'lps'),
	(610239, 129, '2014-04-01 00:11:49.000000', 'consum', 0.0227, 'lps'),
	(610240, 129, '2014-04-01 00:11:50.000000', 'consum', 0.0215, 'lps'),
	(610241, 129, '2014-04-01 00:11:51.000000', 'consum', 0.0231, 'lps'),
	(610242, 129, '2014-04-01 00:11:52.000000', 'consum', 0.0230, 'lps'),
	(610243, 129, '2014-04-01 00:11:53.000000', 'consum', 0.0225, 'lps'),
	(610244, 129, '2014-04-01 00:11:54.000000', 'consum', 0.0222, 'lps'),
	(610245, 129, '2014-04-01 00:11:55.000000', 'consum', 0.0226, 'lps'),
	(610246, 129, '2014-04-01 00:11:56.000000', 'consum', 0.0229, 'lps'),
	(610247, 129, '2014-04-01 00:11:57.000000', 'consum', 0.0211, 'lps'),
	(610248, 129, '2014-04-01 00:11:58.000000', 'consum', 0.0231, 'lps'),
	(610249, 129, '2014-04-01 00:11:59.000000', 'consum', 0.0217, 'lps'),
	(610250, 129, '2014-04-01 00:12:00.000000', 'consum', 0.0229, 'lps'),
	(610251, 129, '2014-04-01 00:12:01.000000', 'consum', 0.0214, 'lps'),
	(610252, 129, '2014-04-01 00:12:02.000000', 'consum', 0.0220, 'lps'),
	(610253, 129, '2014-04-01 00:12:03.000000', 'consum', 0.0227, 'lps'),
	(610254, 129, '2014-04-01 00:12:04.000000', 'consum', 0.0217, 'lps'),
	(610255, 129, '2014-04-01 00:12:05.000000', 'consum', 0.0217, 'lps'),
	(610256, 129, '2014-04-01 00:12:06.000000', 'consum', 0.0226, 'lps'),
	(610257, 129, '2014-04-01 00:12:07.000000', 'consum', 0.0221, 'lps'),
	(610258, 129, '2014-04-01 00:12:08.000000', 'consum', 0.0218, 'lps'),
	(610259, 129, '2014-04-01 00:12:09.000000', 'consum', 0.0217, 'lps'),
	(610260, 129, '2014-04-01 00:12:10.000000', 'consum', 0.0220, 'lps'),
	(610261, 129, '2014-04-01 00:12:11.000000', 'consum', 0.0215, 'lps'),
	(610262, 129, '2014-04-01 00:12:12.000000', 'consum', 0.0229, 'lps'),
	(610263, 129, '2014-04-01 00:12:13.000000', 'consum', 0.0221, 'lps'),
	(610264, 129, '2014-04-01 00:12:14.000000', 'consum', 0.0230, 'lps'),
	(610265, 129, '2014-04-01 00:12:15.000000', 'consum', 0.0230, 'lps'),
	(610266, 129, '2014-04-01 00:12:16.000000', 'consum', 0.0226, 'lps'),
	(610267, 129, '2014-04-01 00:12:17.000000', 'consum', 0.0231, 'lps'),
	(610268, 129, '2014-04-01 00:12:18.000000', 'consum', 0.0221, 'lps'),
	(610269, 129, '2014-04-01 00:12:19.000000', 'consum', 0.0224, 'lps'),
	(610270, 129, '2014-04-01 00:12:20.000000', 'consum', 0.0226, 'lps'),
	(610271, 129, '2014-04-01 00:12:21.000000', 'consum', 0.0226, 'lps'),
	(610272, 129, '2014-04-01 00:12:22.000000', 'consum', 0.0215, 'lps'),
	(610273, 129, '2014-04-01 00:12:23.000000', 'consum', 0.0213, 'lps'),
	(610274, 129, '2014-04-01 00:12:24.000000', 'consum', 0.0233, 'lps'),
	(610275, 129, '2014-04-01 00:12:25.000000', 'consum', 0.0223, 'lps'),
	(610276, 129, '2014-04-01 00:12:26.000000', 'consum', 0.0230, 'lps'),
	(610277, 129, '2014-04-01 00:12:27.000000', 'consum', 0.0224, 'lps'),
	(610278, 129, '2014-04-01 00:12:28.000000', 'consum', 0.0222, 'lps'),
	(610279, 129, '2014-04-01 00:12:29.000000', 'consum', 0.0225, 'lps'),
	(610280, 129, '2014-04-01 00:12:30.000000', 'consum', 0.0229, 'lps'),
	(610281, 129, '2014-04-01 00:12:31.000000', 'consum', 0.0211, 'lps'),
	(610282, 129, '2014-04-01 00:12:32.000000', 'consum', 0.0229, 'lps'),
	(610283, 129, '2014-04-01 00:12:33.000000', 'consum', 0.0230, 'lps'),
	(610284, 129, '2014-04-01 00:12:34.000000', 'consum', 0.0231, 'lps'),
	(610285, 129, '2014-04-01 00:12:35.000000', 'consum', 0.0229, 'lps'),
	(610286, 129, '2014-04-01 00:12:36.000000', 'consum', 0.0221, 'lps'),
	(610287, 129, '2014-04-01 00:12:37.000000', 'consum', 0.0231, 'lps'),
	(610288, 129, '2014-04-01 00:12:38.000000', 'consum', 0.0212, 'lps'),
	(610289, 129, '2014-04-01 00:12:39.000000', 'consum', 0.0228, 'lps'),
	(610290, 129, '2014-04-01 00:12:40.000000', 'consum', 0.0222, 'lps'),
	(610291, 129, '2014-04-01 00:12:41.000000', 'consum', 0.0218, 'lps'),
	(610292, 129, '2014-04-01 00:12:42.000000', 'consum', 0.0213, 'lps'),
	(610293, 129, '2014-04-01 00:12:43.000000', 'consum', 0.0226, 'lps'),
	(610294, 129, '2014-04-01 00:12:44.000000', 'consum', 0.0211, 'lps'),
	(610295, 129, '2014-04-01 00:12:45.000000', 'consum', 0.0213, 'lps'),
	(610296, 129, '2014-04-01 00:12:46.000000', 'consum', 0.0222, 'lps'),
	(610297, 129, '2014-04-01 00:12:47.000000', 'consum', 0.0216, 'lps'),
	(610298, 129, '2014-04-01 00:12:48.000000', 'consum', 0.0228, 'lps'),
	(610299, 129, '2014-04-01 00:12:49.000000', 'consum', 0.0212, 'lps'),
	(610300, 129, '2014-04-01 00:12:50.000000', 'consum', 0.0211, 'lps'),
	(610301, 129, '2014-04-01 00:12:51.000000', 'consum', 0.0212, 'lps'),
	(610302, 129, '2014-04-01 00:12:52.000000', 'consum', 0.0215, 'lps'),
	(610303, 129, '2014-04-01 00:12:53.000000', 'consum', 0.0232, 'lps'),
	(610304, 129, '2014-04-01 00:12:54.000000', 'consum', 0.0233, 'lps'),
	(610305, 129, '2014-04-01 00:12:55.000000', 'consum', 0.0211, 'lps'),
	(610306, 129, '2014-04-01 00:12:56.000000', 'consum', 0.0218, 'lps'),
	(610307, 129, '2014-04-01 00:12:57.000000', 'consum', 0.0222, 'lps'),
	(610308, 129, '2014-04-01 00:12:58.000000', 'consum', 0.0225, 'lps'),
	(610309, 129, '2014-04-01 00:12:59.000000', 'consum', 0.0223, 'lps'),
	(610310, 129, '2014-04-01 00:13:00.000000', 'consum', 0.0210, 'lps'),
	(610311, 129, '2014-04-01 00:13:01.000000', 'consum', 0.0216, 'lps'),
	(610312, 129, '2014-04-01 00:13:02.000000', 'consum', 0.0220, 'lps'),
	(610313, 129, '2014-04-01 00:13:03.000000', 'consum', 0.0217, 'lps'),
	(610314, 129, '2014-04-01 00:13:04.000000', 'consum', 0.0214, 'lps'),
	(610315, 129, '2014-04-01 00:13:05.000000', 'consum', 0.0210, 'lps'),
	(610316, 129, '2014-04-01 00:13:06.000000', 'consum', 0.0222, 'lps'),
	(610317, 129, '2014-04-01 00:13:07.000000', 'consum', 0.0222, 'lps'),
	(610318, 129, '2014-04-01 00:13:08.000000', 'consum', 0.0210, 'lps'),
	(610319, 129, '2014-04-01 00:13:09.000000', 'consum', 0.0222, 'lps'),
	(610320, 129, '2014-04-01 00:13:10.000000', 'consum', 0.0223, 'lps'),
	(610321, 129, '2014-04-01 00:13:11.000000', 'consum', 0.0217, 'lps'),
	(610322, 129, '2014-04-01 00:13:12.000000', 'consum', 0.0228, 'lps'),
	(610323, 129, '2014-04-01 00:13:13.000000', 'consum', 0.0233, 'lps'),
	(610324, 129, '2014-04-01 00:13:14.000000', 'consum', 0.0222, 'lps'),
	(610325, 129, '2014-04-01 00:13:15.000000', 'consum', 0.0226, 'lps'),
	(610326, 129, '2014-04-01 00:13:16.000000', 'consum', 0.0231, 'lps'),
	(610327, 129, '2014-04-01 00:13:17.000000', 'consum', 0.0219, 'lps'),
	(610328, 129, '2014-04-01 00:13:18.000000', 'consum', 0.0218, 'lps'),
	(610329, 129, '2014-04-01 00:13:19.000000', 'consum', 0.0225, 'lps'),
	(610330, 129, '2014-04-01 00:13:20.000000', 'consum', 0.0210, 'lps'),
	(610331, 129, '2014-04-01 00:13:21.000000', 'consum', 0.0216, 'lps'),
	(610332, 129, '2014-04-01 00:13:22.000000', 'consum', 0.0215, 'lps'),
	(610333, 129, '2014-04-01 00:13:23.000000', 'consum', 0.0217, 'lps'),
	(610334, 129, '2014-04-01 00:13:24.000000', 'consum', 0.0231, 'lps'),
	(610335, 129, '2014-04-01 00:13:25.000000', 'consum', 0.0224, 'lps'),
	(610336, 129, '2014-04-01 00:13:26.000000', 'consum', 0.0219, 'lps'),
	(610337, 129, '2014-04-01 00:13:27.000000', 'consum', 0.0210, 'lps'),
	(610338, 129, '2014-04-01 00:13:28.000000', 'consum', 0.0233, 'lps'),
	(610339, 129, '2014-04-01 00:13:29.000000', 'consum', 0.0227, 'lps'),
	(610340, 129, '2014-04-01 00:13:30.000000', 'consum', 0.0229, 'lps'),
	(610341, 129, '2014-04-01 00:13:31.000000', 'consum', 0.0230, 'lps'),
	(610342, 129, '2014-04-01 00:13:32.000000', 'consum', 0.0230, 'lps'),
	(610343, 129, '2014-04-01 00:13:33.000000', 'consum', 0.0225, 'lps'),
	(610344, 129, '2014-04-01 00:13:34.000000', 'consum', 0.0225, 'lps'),
	(610345, 129, '2014-04-01 00:13:35.000000', 'consum', 0.0219, 'lps'),
	(610346, 129, '2014-04-01 00:13:36.000000', 'consum', 0.0210, 'lps'),
	(610347, 129, '2014-04-01 00:13:37.000000', 'consum', 0.0230, 'lps'),
	(610348, 129, '2014-04-01 00:13:38.000000', 'consum', 0.0216, 'lps'),
	(610349, 129, '2014-04-01 00:13:39.000000', 'consum', 0.0228, 'lps'),
	(610350, 129, '2014-04-01 00:13:40.000000', 'consum', 0.0210, 'lps'),
	(610351, 129, '2014-04-01 00:13:41.000000', 'consum', 0.0230, 'lps'),
	(610352, 129, '2014-04-01 00:13:42.000000', 'consum', 0.0214, 'lps'),
	(610353, 129, '2014-04-01 00:13:43.000000', 'consum', 0.0217, 'lps'),
	(610354, 129, '2014-04-01 00:13:44.000000', 'consum', 0.0212, 'lps'),
	(610355, 129, '2014-04-01 00:13:45.000000', 'consum', 0.0221, 'lps'),
	(610356, 129, '2014-04-01 00:13:46.000000', 'consum', 0.0212, 'lps'),
	(610357, 129, '2014-04-01 00:13:47.000000', 'consum', 0.0210, 'lps'),
	(610358, 129, '2014-04-01 00:13:48.000000', 'consum', 0.0232, 'lps'),
	(610359, 129, '2014-04-01 00:13:49.000000', 'consum', 0.0222, 'lps'),
	(610360, 129, '2014-04-01 00:13:50.000000', 'consum', 0.0229, 'lps'),
	(610361, 129, '2014-04-01 00:13:51.000000', 'consum', 0.0220, 'lps'),
	(610362, 129, '2014-04-01 00:13:52.000000', 'consum', 0.0227, 'lps'),
	(610363, 129, '2014-04-01 00:13:53.000000', 'consum', 0.0220, 'lps'),
	(610364, 129, '2014-04-01 00:13:54.000000', 'consum', 0.0231, 'lps'),
	(610365, 129, '2014-04-01 00:13:55.000000', 'consum', 0.0214, 'lps'),
	(610366, 129, '2014-04-01 00:13:56.000000', 'consum', 0.0217, 'lps'),
	(610367, 129, '2014-04-01 00:13:57.000000', 'consum', 0.0232, 'lps'),
	(610368, 129, '2014-04-01 00:13:58.000000', 'consum', 0.0230, 'lps'),
	(610369, 129, '2014-04-01 00:13:59.000000', 'consum', 0.0219, 'lps'),
	(610370, 129, '2014-04-01 00:14:00.000000', 'consum', 0.0221, 'lps'),
	(610371, 129, '2014-04-01 00:14:01.000000', 'consum', 0.0212, 'lps'),
	(610372, 129, '2014-04-01 00:14:02.000000', 'consum', 0.0213, 'lps'),
	(610373, 129, '2014-04-01 00:14:03.000000', 'consum', 0.0218, 'lps'),
	(610374, 129, '2014-04-01 00:14:04.000000', 'consum', 0.0219, 'lps'),
	(610375, 129, '2014-04-01 00:14:05.000000', 'consum', 0.0229, 'lps'),
	(610376, 129, '2014-04-01 00:14:06.000000', 'consum', 0.0233, 'lps'),
	(610377, 129, '2014-04-01 00:14:07.000000', 'consum', 0.0218, 'lps'),
	(610378, 129, '2014-04-01 00:14:08.000000', 'consum', 0.0232, 'lps'),
	(610379, 129, '2014-04-01 00:14:09.000000', 'consum', 0.0226, 'lps'),
	(610380, 129, '2014-04-01 00:14:10.000000', 'consum', 0.0222, 'lps'),
	(610381, 129, '2014-04-01 00:14:11.000000', 'consum', 0.0221, 'lps'),
	(610382, 129, '2014-04-01 00:14:12.000000', 'consum', 0.0231, 'lps'),
	(610383, 129, '2014-04-01 00:14:13.000000', 'consum', 0.0211, 'lps'),
	(610384, 129, '2014-04-01 00:14:14.000000', 'consum', 0.0223, 'lps'),
	(610385, 129, '2014-04-01 00:14:15.000000', 'consum', 0.0227, 'lps'),
	(610386, 129, '2014-04-01 00:14:16.000000', 'consum', 0.0230, 'lps'),
	(610387, 129, '2014-04-01 00:14:17.000000', 'consum', 0.0211, 'lps'),
	(610388, 129, '2014-04-01 00:14:18.000000', 'consum', 0.0228, 'lps'),
	(610389, 129, '2014-04-01 00:14:19.000000', 'consum', 0.0225, 'lps'),
	(610390, 129, '2014-04-01 00:14:20.000000', 'consum', 0.0230, 'lps'),
	(610391, 129, '2014-04-01 00:14:21.000000', 'consum', 0.0220, 'lps'),
	(610392, 129, '2014-04-01 00:14:22.000000', 'consum', 0.0225, 'lps'),
	(610393, 129, '2014-04-01 00:14:23.000000', 'consum', 0.0231, 'lps'),
	(610394, 129, '2014-04-01 00:14:24.000000', 'consum', 0.0224, 'lps'),
	(610395, 129, '2014-04-01 00:14:25.000000', 'consum', 0.0217, 'lps'),
	(610396, 129, '2014-04-01 00:14:26.000000', 'consum', 0.0226, 'lps'),
	(610397, 129, '2014-04-01 00:14:27.000000', 'consum', 0.0223, 'lps'),
	(610398, 129, '2014-04-01 00:14:28.000000', 'consum', 0.0228, 'lps'),
	(610399, 129, '2014-04-01 00:14:29.000000', 'consum', 0.0211, 'lps'),
	(610400, 129, '2014-04-01 00:14:30.000000', 'consum', 0.0213, 'lps'),
	(610401, 129, '2014-04-01 00:14:31.000000', 'consum', 0.0219, 'lps'),
	(610402, 129, '2014-04-01 00:14:32.000000', 'consum', 0.0224, 'lps'),
	(610403, 129, '2014-04-01 00:14:33.000000', 'consum', 0.0229, 'lps'),
	(610404, 129, '2014-04-01 00:14:34.000000', 'consum', 0.0216, 'lps'),
	(610405, 129, '2014-04-01 00:14:35.000000', 'consum', 0.0232, 'lps'),
	(610406, 129, '2014-04-01 00:14:36.000000', 'consum', 0.0230, 'lps'),
	(610407, 129, '2014-04-01 00:14:37.000000', 'consum', 0.0221, 'lps'),
	(610408, 129, '2014-04-01 00:14:38.000000', 'consum', 0.0231, 'lps'),
	(610409, 129, '2014-04-01 00:14:39.000000', 'consum', 0.0233, 'lps'),
	(610410, 129, '2014-04-01 00:14:40.000000', 'consum', 0.0213, 'lps'),
	(610411, 129, '2014-04-01 00:14:41.000000', 'consum', 0.0230, 'lps'),
	(610412, 129, '2014-04-01 00:14:42.000000', 'consum', 0.0230, 'lps'),
	(610413, 129, '2014-04-01 00:14:43.000000', 'consum', 0.0228, 'lps'),
	(610414, 129, '2014-04-01 00:14:44.000000', 'consum', 0.0215, 'lps'),
	(610415, 129, '2014-04-01 00:14:45.000000', 'consum', 0.0230, 'lps'),
	(610416, 129, '2014-04-01 00:14:46.000000', 'consum', 0.0223, 'lps'),
	(610417, 129, '2014-04-01 00:14:47.000000', 'consum', 0.0217, 'lps'),
	(610418, 129, '2014-04-01 00:14:48.000000', 'consum', 0.0230, 'lps'),
	(610419, 129, '2014-04-01 00:14:49.000000', 'consum', 0.0218, 'lps'),
	(610420, 129, '2014-04-01 00:14:50.000000', 'consum', 0.0213, 'lps'),
	(610421, 129, '2014-04-01 00:14:51.000000', 'consum', 0.0226, 'lps'),
	(610422, 129, '2014-04-01 00:14:52.000000', 'consum', 0.0212, 'lps'),
	(610423, 129, '2014-04-01 00:14:53.000000', 'consum', 0.0217, 'lps'),
	(610424, 129, '2014-04-01 00:14:54.000000', 'consum', 0.0218, 'lps'),
	(610425, 129, '2014-04-01 00:14:55.000000', 'consum', 0.0230, 'lps'),
	(610426, 129, '2014-04-01 00:14:56.000000', 'consum', 0.0212, 'lps'),
	(610427, 129, '2014-04-01 00:14:57.000000', 'consum', 0.0232, 'lps'),
	(610428, 129, '2014-04-01 00:14:58.000000', 'consum', 0.0221, 'lps'),
	(610429, 129, '2014-04-01 00:14:59.000000', 'consum', 0.0224, 'lps'),
	(610430, 129, '2014-04-01 00:15:00.000000', 'consum', 0.0223, 'lps'),
	(610431, 129, '2014-04-01 00:15:01.000000', 'consum', 0.0232, 'lps'),
	(610432, 129, '2014-04-01 00:15:02.000000', 'consum', 0.0233, 'lps'),
	(610433, 129, '2014-04-01 00:15:03.000000', 'consum', 0.0214, 'lps'),
	(610434, 129, '2014-04-01 00:15:04.000000', 'consum', 0.0230, 'lps'),
	(610435, 129, '2014-04-01 00:15:05.000000', 'consum', 0.0229, 'lps'),
	(610436, 129, '2014-04-01 00:15:06.000000', 'consum', 0.0222, 'lps'),
	(610437, 129, '2014-04-01 00:15:07.000000', 'consum', 0.0211, 'lps'),
	(610438, 129, '2014-04-01 00:15:08.000000', 'consum', 0.0230, 'lps'),
	(610439, 129, '2014-04-01 00:15:09.000000', 'consum', 0.0211, 'lps'),
	(610440, 129, '2014-04-01 00:15:10.000000', 'consum', 0.0227, 'lps'),
	(610441, 129, '2014-04-01 00:15:11.000000', 'consum', 0.0222, 'lps'),
	(610442, 129, '2014-04-01 00:15:12.000000', 'consum', 0.0217, 'lps'),
	(610443, 129, '2014-04-01 00:15:13.000000', 'consum', 0.0211, 'lps'),
	(610444, 129, '2014-04-01 00:15:14.000000', 'consum', 0.0220, 'lps'),
	(610445, 129, '2014-04-01 00:15:15.000000', 'consum', 0.0231, 'lps'),
	(610446, 129, '2014-04-01 00:15:16.000000', 'consum', 0.0214, 'lps'),
	(610447, 129, '2014-04-01 00:15:17.000000', 'consum', 0.0217, 'lps'),
	(610448, 129, '2014-04-01 00:15:18.000000', 'consum', 0.0231, 'lps'),
	(610449, 129, '2014-04-01 00:15:19.000000', 'consum', 0.0224, 'lps'),
	(610450, 129, '2014-04-01 00:15:20.000000', 'consum', 0.0218, 'lps'),
	(610451, 129, '2014-04-01 00:15:21.000000', 'consum', 0.0231, 'lps'),
	(610452, 129, '2014-04-01 00:15:22.000000', 'consum', 0.0219, 'lps'),
	(610453, 129, '2014-04-01 00:15:23.000000', 'consum', 0.0218, 'lps'),
	(610454, 129, '2014-04-01 00:15:24.000000', 'consum', 0.0224, 'lps'),
	(610455, 129, '2014-04-01 00:15:25.000000', 'consum', 0.0233, 'lps'),
	(610456, 129, '2014-04-01 00:15:26.000000', 'consum', 0.0211, 'lps'),
	(610457, 129, '2014-04-01 00:15:27.000000', 'consum', 0.0217, 'lps'),
	(610458, 129, '2014-04-01 00:15:28.000000', 'consum', 0.0219, 'lps'),
	(610459, 129, '2014-04-01 00:15:29.000000', 'consum', 0.0210, 'lps'),
	(610460, 129, '2014-04-01 00:15:30.000000', 'consum', 0.0210, 'lps'),
	(610461, 129, '2014-04-01 00:15:31.000000', 'consum', 0.0231, 'lps'),
	(610462, 129, '2014-04-01 00:15:32.000000', 'consum', 0.0222, 'lps'),
	(610463, 129, '2014-04-01 00:15:33.000000', 'consum', 0.0233, 'lps'),
	(610464, 129, '2014-04-01 00:15:34.000000', 'consum', 0.0215, 'lps'),
	(610465, 129, '2014-04-01 00:15:35.000000', 'consum', 0.0216, 'lps'),
	(610466, 129, '2014-04-01 00:15:36.000000', 'consum', 0.0226, 'lps'),
	(610467, 129, '2014-04-01 00:15:37.000000', 'consum', 0.0225, 'lps'),
	(610468, 129, '2014-04-01 00:15:38.000000', 'consum', 0.0212, 'lps'),
	(610469, 129, '2014-04-01 00:15:39.000000', 'consum', 0.0226, 'lps'),
	(610470, 129, '2014-04-01 00:15:40.000000', 'consum', 0.0210, 'lps'),
	(610471, 129, '2014-04-01 00:15:41.000000', 'consum', 0.0212, 'lps'),
	(610472, 129, '2014-04-01 00:15:42.000000', 'consum', 0.0221, 'lps'),
	(610473, 129, '2014-04-01 00:15:43.000000', 'consum', 0.0211, 'lps'),
	(610474, 129, '2014-04-01 00:15:44.000000', 'consum', 0.0229, 'lps'),
	(610475, 129, '2014-04-01 00:15:45.000000', 'consum', 0.0232, 'lps'),
	(610476, 129, '2014-04-01 00:15:46.000000', 'consum', 0.0217, 'lps'),
	(610477, 129, '2014-04-01 00:15:47.000000', 'consum', 0.0225, 'lps'),
	(610478, 129, '2014-04-01 00:15:48.000000', 'consum', 0.0216, 'lps'),
	(610479, 129, '2014-04-01 00:15:49.000000', 'consum', 0.0220, 'lps'),
	(610480, 129, '2014-04-01 00:15:50.000000', 'consum', 0.0219, 'lps'),
	(610481, 129, '2014-04-01 00:15:51.000000', 'consum', 0.0224, 'lps'),
	(610482, 129, '2014-04-01 00:15:52.000000', 'consum', 0.0229, 'lps'),
	(610483, 129, '2014-04-01 00:15:53.000000', 'consum', 0.0218, 'lps'),
	(610484, 129, '2014-04-01 00:15:54.000000', 'consum', 0.0218, 'lps'),
	(610485, 129, '2014-04-01 00:15:55.000000', 'consum', 0.0223, 'lps'),
	(610486, 129, '2014-04-01 00:15:56.000000', 'consum', 0.0231, 'lps'),
	(610487, 129, '2014-04-01 00:15:57.000000', 'consum', 0.0227, 'lps'),
	(610488, 129, '2014-04-01 00:15:58.000000', 'consum', 0.0231, 'lps'),
	(610489, 129, '2014-04-01 00:15:59.000000', 'consum', 0.0216, 'lps'),
	(610490, 129, '2014-04-01 00:16:00.000000', 'consum', 0.0228, 'lps'),
	(610491, 129, '2014-04-01 00:16:01.000000', 'consum', 0.0232, 'lps'),
	(610492, 129, '2014-04-01 00:16:02.000000', 'consum', 0.0218, 'lps'),
	(610493, 129, '2014-04-01 00:16:03.000000', 'consum', 0.0211, 'lps'),
	(610494, 129, '2014-04-01 00:16:04.000000', 'consum', 0.0213, 'lps'),
	(610495, 129, '2014-04-01 00:16:05.000000', 'consum', 0.0226, 'lps'),
	(610496, 129, '2014-04-01 00:16:06.000000', 'consum', 0.0230, 'lps'),
	(610497, 129, '2014-04-01 00:16:07.000000', 'consum', 0.0215, 'lps'),
	(610498, 129, '2014-04-01 00:16:08.000000', 'consum', 0.0225, 'lps'),
	(610499, 129, '2014-04-01 00:16:09.000000', 'consum', 0.0221, 'lps'),
	(610500, 129, '2014-04-01 00:16:10.000000', 'consum', 0.0222, 'lps'),
	(610501, 129, '2014-04-01 00:16:11.000000', 'consum', 0.0213, 'lps'),
	(610502, 129, '2014-04-01 00:16:12.000000', 'consum', 0.0212, 'lps'),
	(610503, 129, '2014-04-01 00:16:13.000000', 'consum', 0.0212, 'lps'),
	(610504, 129, '2014-04-01 00:16:14.000000', 'consum', 0.0213, 'lps'),
	(610505, 129, '2014-04-01 00:16:15.000000', 'consum', 0.0221, 'lps'),
	(610506, 129, '2014-04-01 00:16:16.000000', 'consum', 0.0233, 'lps'),
	(610507, 129, '2014-04-01 00:16:17.000000', 'consum', 0.0221, 'lps'),
	(610508, 129, '2014-04-01 00:16:18.000000', 'consum', 0.0219, 'lps'),
	(610509, 129, '2014-04-01 00:16:19.000000', 'consum', 0.0221, 'lps'),
	(610510, 129, '2014-04-01 00:16:20.000000', 'consum', 0.0217, 'lps'),
	(610511, 129, '2014-04-01 00:16:21.000000', 'consum', 0.0210, 'lps'),
	(610512, 129, '2014-04-01 00:16:22.000000', 'consum', 0.0214, 'lps'),
	(610513, 129, '2014-04-01 00:16:23.000000', 'consum', 0.0233, 'lps'),
	(610514, 129, '2014-04-01 00:16:24.000000', 'consum', 0.0215, 'lps'),
	(610515, 129, '2014-04-01 00:16:25.000000', 'consum', 0.0217, 'lps'),
	(610516, 129, '2014-04-01 00:16:26.000000', 'consum', 0.0231, 'lps'),
	(610517, 129, '2014-04-01 00:16:27.000000', 'consum', 0.0219, 'lps'),
	(610518, 129, '2014-04-01 00:16:28.000000', 'consum', 0.0220, 'lps'),
	(610519, 129, '2014-04-01 00:16:29.000000', 'consum', 0.0231, 'lps'),
	(610520, 129, '2014-04-01 00:16:30.000000', 'consum', 0.0216, 'lps'),
	(610521, 129, '2014-04-01 00:16:31.000000', 'consum', 0.0224, 'lps'),
	(610522, 129, '2014-04-01 00:16:32.000000', 'consum', 0.0215, 'lps'),
	(610523, 129, '2014-04-01 00:16:33.000000', 'consum', 0.0216, 'lps'),
	(610524, 129, '2014-04-01 00:16:34.000000', 'consum', 0.0226, 'lps'),
	(610525, 129, '2014-04-01 00:16:35.000000', 'consum', 0.0225, 'lps'),
	(610526, 129, '2014-04-01 00:16:36.000000', 'consum', 0.0215, 'lps'),
	(610527, 129, '2014-04-01 00:16:37.000000', 'consum', 0.0213, 'lps'),
	(610528, 129, '2014-04-01 00:16:38.000000', 'consum', 0.0213, 'lps'),
	(610529, 129, '2014-04-01 00:16:39.000000', 'consum', 0.0213, 'lps'),
	(610530, 129, '2014-04-01 00:16:40.000000', 'consum', 0.0219, 'lps'),
	(610531, 129, '2014-04-01 00:16:41.000000', 'consum', 0.0222, 'lps'),
	(610532, 129, '2014-04-01 00:16:42.000000', 'consum', 0.0219, 'lps'),
	(610533, 129, '2014-04-01 00:16:43.000000', 'consum', 0.0222, 'lps'),
	(610534, 129, '2014-04-01 00:16:44.000000', 'consum', 0.0217, 'lps'),
	(610535, 129, '2014-04-01 00:16:45.000000', 'consum', 0.0210, 'lps'),
	(610536, 129, '2014-04-01 00:16:46.000000', 'consum', 0.0212, 'lps'),
	(610537, 129, '2014-04-01 00:16:47.000000', 'consum', 0.0220, 'lps'),
	(610538, 129, '2014-04-01 00:16:48.000000', 'consum', 0.0230, 'lps'),
	(610539, 129, '2014-04-01 00:16:49.000000', 'consum', 0.0233, 'lps'),
	(610540, 129, '2014-04-01 00:16:50.000000', 'consum', 0.0218, 'lps'),
	(610541, 129, '2014-04-01 00:16:51.000000', 'consum', 0.0231, 'lps'),
	(610542, 129, '2014-04-01 00:16:52.000000', 'consum', 0.0219, 'lps'),
	(610543, 129, '2014-04-01 00:16:53.000000', 'consum', 0.0218, 'lps'),
	(610544, 129, '2014-04-01 00:16:54.000000', 'consum', 0.0223, 'lps'),
	(610545, 129, '2014-04-01 00:16:55.000000', 'consum', 0.0226, 'lps'),
	(610546, 129, '2014-04-01 00:16:56.000000', 'consum', 0.0230, 'lps'),
	(610547, 129, '2014-04-01 00:16:57.000000', 'consum', 0.0214, 'lps'),
	(610548, 129, '2014-04-01 00:16:58.000000', 'consum', 0.0219, 'lps'),
	(610549, 129, '2014-04-01 00:16:59.000000', 'consum', 0.0220, 'lps'),
	(610550, 129, '2014-04-01 00:17:00.000000', 'consum', 0.0233, 'lps'),
	(610551, 129, '2014-04-01 00:17:01.000000', 'consum', 0.0223, 'lps'),
	(610552, 129, '2014-04-01 00:17:02.000000', 'consum', 0.0231, 'lps'),
	(610553, 129, '2014-04-01 00:17:03.000000', 'consum', 0.0229, 'lps'),
	(610554, 129, '2014-04-01 00:17:04.000000', 'consum', 0.0217, 'lps'),
	(610555, 129, '2014-04-01 00:17:05.000000', 'consum', 0.0214, 'lps'),
	(610556, 129, '2014-04-01 00:17:06.000000', 'consum', 0.0233, 'lps'),
	(610557, 129, '2014-04-01 00:17:07.000000', 'consum', 0.0216, 'lps'),
	(610558, 129, '2014-04-01 00:17:08.000000', 'consum', 0.0221, 'lps'),
	(610559, 129, '2014-04-01 00:17:09.000000', 'consum', 0.0221, 'lps'),
	(610560, 129, '2014-04-01 00:17:10.000000', 'consum', 0.0211, 'lps'),
	(610561, 129, '2014-04-01 00:17:11.000000', 'consum', 0.0230, 'lps'),
	(610562, 129, '2014-04-01 00:17:12.000000', 'consum', 0.0233, 'lps'),
	(610563, 129, '2014-04-01 00:17:13.000000', 'consum', 0.0221, 'lps'),
	(610564, 129, '2014-04-01 00:17:14.000000', 'consum', 0.0219, 'lps'),
	(610565, 129, '2014-04-01 00:17:15.000000', 'consum', 0.0221, 'lps'),
	(610566, 129, '2014-04-01 00:17:16.000000', 'consum', 0.0214, 'lps'),
	(610567, 129, '2014-04-01 00:17:17.000000', 'consum', 0.0225, 'lps'),
	(610568, 129, '2014-04-01 00:17:18.000000', 'consum', 0.0223, 'lps'),
	(610569, 129, '2014-04-01 00:17:19.000000', 'consum', 0.0230, 'lps'),
	(610570, 129, '2014-04-01 00:17:20.000000', 'consum', 0.0226, 'lps'),
	(610571, 129, '2014-04-01 00:17:21.000000', 'consum', 0.0229, 'lps'),
	(610572, 129, '2014-04-01 00:17:22.000000', 'consum', 0.0211, 'lps'),
	(610573, 129, '2014-04-01 00:17:23.000000', 'consum', 0.0230, 'lps'),
	(610574, 129, '2014-04-01 00:17:24.000000', 'consum', 0.0211, 'lps'),
	(610575, 129, '2014-04-01 00:17:25.000000', 'consum', 0.0226, 'lps'),
	(610576, 129, '2014-04-01 00:17:26.000000', 'consum', 0.0217, 'lps'),
	(610577, 129, '2014-04-01 00:17:27.000000', 'consum', 0.0220, 'lps'),
	(610578, 129, '2014-04-01 00:17:28.000000', 'consum', 0.0215, 'lps'),
	(610579, 129, '2014-04-01 00:17:29.000000', 'consum', 0.0229, 'lps'),
	(610580, 129, '2014-04-01 00:17:30.000000', 'consum', 0.0220, 'lps'),
	(610581, 129, '2014-04-01 00:17:31.000000', 'consum', 0.0227, 'lps'),
	(610582, 129, '2014-04-01 00:17:32.000000', 'consum', 0.0218, 'lps'),
	(610583, 129, '2014-04-01 00:17:33.000000', 'consum', 0.0223, 'lps'),
	(610584, 129, '2014-04-01 00:17:34.000000', 'consum', 0.0227, 'lps'),
	(610585, 129, '2014-04-01 00:17:35.000000', 'consum', 0.0233, 'lps'),
	(610586, 129, '2014-04-01 00:17:36.000000', 'consum', 0.0226, 'lps'),
	(610587, 129, '2014-04-01 00:17:37.000000', 'consum', 0.0223, 'lps'),
	(610588, 129, '2014-04-01 00:17:38.000000', 'consum', 0.0227, 'lps'),
	(610589, 129, '2014-04-01 00:17:39.000000', 'consum', 0.0230, 'lps'),
	(610590, 129, '2014-04-01 00:17:40.000000', 'consum', 0.0215, 'lps'),
	(610591, 129, '2014-04-01 00:17:41.000000', 'consum', 0.0220, 'lps'),
	(610592, 129, '2014-04-01 00:17:42.000000', 'consum', 0.0224, 'lps'),
	(610593, 129, '2014-04-01 00:17:43.000000', 'consum', 0.0227, 'lps'),
	(610594, 129, '2014-04-01 00:17:44.000000', 'consum', 0.0227, 'lps'),
	(610595, 129, '2014-04-01 00:17:45.000000', 'consum', 0.0223, 'lps'),
	(610596, 129, '2014-04-01 00:17:46.000000', 'consum', 0.0222, 'lps'),
	(610597, 129, '2014-04-01 00:17:47.000000', 'consum', 0.0233, 'lps'),
	(610598, 129, '2014-04-01 00:17:48.000000', 'consum', 0.0219, 'lps'),
	(610599, 129, '2014-04-01 00:17:49.000000', 'consum', 0.0231, 'lps'),
	(610600, 129, '2014-04-01 00:17:50.000000', 'consum', 0.0219, 'lps'),
	(610601, 129, '2014-04-01 00:17:51.000000', 'consum', 0.0217, 'lps'),
	(610602, 129, '2014-04-01 00:17:52.000000', 'consum', 0.0219, 'lps'),
	(610603, 129, '2014-04-01 00:17:53.000000', 'consum', 0.0212, 'lps'),
	(610604, 129, '2014-04-01 00:17:54.000000', 'consum', 0.0215, 'lps'),
	(610605, 129, '2014-04-01 00:17:55.000000', 'consum', 0.0228, 'lps'),
	(610606, 129, '2014-04-01 00:17:56.000000', 'consum', 0.0217, 'lps'),
	(610607, 129, '2014-04-01 00:17:57.000000', 'consum', 0.0214, 'lps'),
	(610608, 129, '2014-04-01 00:17:58.000000', 'consum', 0.0233, 'lps'),
	(610609, 129, '2014-04-01 00:17:59.000000', 'consum', 0.0220, 'lps'),
	(610610, 129, '2014-04-01 00:18:00.000000', 'consum', 0.0213, 'lps'),
	(610611, 129, '2014-04-01 00:18:01.000000', 'consum', 0.0221, 'lps'),
	(610612, 129, '2014-04-01 00:18:02.000000', 'consum', 0.0232, 'lps'),
	(610613, 129, '2014-04-01 00:18:03.000000', 'consum', 0.0217, 'lps'),
	(610614, 129, '2014-04-01 00:18:04.000000', 'consum', 0.0225, 'lps'),
	(610615, 129, '2014-04-01 00:18:05.000000', 'consum', 0.0218, 'lps'),
	(610616, 129, '2014-04-01 00:18:06.000000', 'consum', 0.0229, 'lps'),
	(610617, 129, '2014-04-01 00:18:07.000000', 'consum', 0.0210, 'lps'),
	(610618, 129, '2014-04-01 00:18:08.000000', 'consum', 0.0224, 'lps'),
	(610619, 129, '2014-04-01 00:18:09.000000', 'consum', 0.0232, 'lps'),
	(610620, 129, '2014-04-01 00:18:10.000000', 'consum', 0.0230, 'lps'),
	(610621, 129, '2014-04-01 00:18:11.000000', 'consum', 0.0221, 'lps'),
	(610622, 129, '2014-04-01 00:18:12.000000', 'consum', 0.0228, 'lps'),
	(610623, 129, '2014-04-01 00:18:13.000000', 'consum', 0.0220, 'lps'),
	(610624, 129, '2014-04-01 00:18:14.000000', 'consum', 0.0232, 'lps'),
	(610625, 129, '2014-04-01 00:18:15.000000', 'consum', 0.0216, 'lps'),
	(610626, 129, '2014-04-01 00:18:16.000000', 'consum', 0.0224, 'lps'),
	(610627, 129, '2014-04-01 00:18:17.000000', 'consum', 0.0215, 'lps'),
	(610628, 129, '2014-04-01 00:18:18.000000', 'consum', 0.0219, 'lps'),
	(610629, 129, '2014-04-01 00:18:19.000000', 'consum', 0.0215, 'lps'),
	(610630, 129, '2014-04-01 00:18:20.000000', 'consum', 0.0210, 'lps'),
	(610631, 129, '2014-04-01 00:18:21.000000', 'consum', 0.0218, 'lps'),
	(610632, 129, '2014-04-01 00:18:22.000000', 'consum', 0.0229, 'lps'),
	(610633, 129, '2014-04-01 00:18:23.000000', 'consum', 0.0232, 'lps'),
	(610634, 129, '2014-04-01 00:18:24.000000', 'consum', 0.0214, 'lps'),
	(610635, 129, '2014-04-01 00:18:25.000000', 'consum', 0.0213, 'lps'),
	(610636, 129, '2014-04-01 00:18:26.000000', 'consum', 0.0212, 'lps'),
	(610637, 129, '2014-04-01 00:18:27.000000', 'consum', 0.0215, 'lps'),
	(610638, 129, '2014-04-01 00:18:28.000000', 'consum', 0.0226, 'lps'),
	(610639, 129, '2014-04-01 00:18:29.000000', 'consum', 0.0229, 'lps'),
	(610640, 129, '2014-04-01 00:18:30.000000', 'consum', 0.0211, 'lps'),
	(610641, 129, '2014-04-01 00:18:31.000000', 'consum', 0.0231, 'lps'),
	(610642, 129, '2014-04-01 00:18:32.000000', 'consum', 0.0216, 'lps'),
	(610643, 129, '2014-04-01 00:18:33.000000', 'consum', 0.0224, 'lps'),
	(610644, 129, '2014-04-01 00:18:34.000000', 'consum', 0.0213, 'lps'),
	(610645, 129, '2014-04-01 00:18:35.000000', 'consum', 0.0210, 'lps'),
	(610646, 129, '2014-04-01 00:18:36.000000', 'consum', 0.0226, 'lps'),
	(610647, 129, '2014-04-01 00:18:37.000000', 'consum', 0.0219, 'lps'),
	(610648, 129, '2014-04-01 00:18:38.000000', 'consum', 0.0231, 'lps'),
	(610649, 129, '2014-04-01 00:18:39.000000', 'consum', 0.0218, 'lps'),
	(610650, 129, '2014-04-01 00:18:40.000000', 'consum', 0.0233, 'lps'),
	(610651, 129, '2014-04-01 00:18:41.000000', 'consum', 0.0230, 'lps'),
	(610652, 129, '2014-04-01 00:18:42.000000', 'consum', 0.0218, 'lps'),
	(610653, 129, '2014-04-01 00:18:43.000000', 'consum', 0.0213, 'lps'),
	(610654, 129, '2014-04-01 00:18:44.000000', 'consum', 0.0228, 'lps'),
	(610655, 129, '2014-04-01 00:18:45.000000', 'consum', 0.0218, 'lps'),
	(610656, 129, '2014-04-01 00:18:46.000000', 'consum', 0.0220, 'lps'),
	(610657, 129, '2014-04-01 00:18:47.000000', 'consum', 0.0212, 'lps'),
	(610658, 129, '2014-04-01 00:18:48.000000', 'consum', 0.0216, 'lps'),
	(610659, 129, '2014-04-01 00:18:49.000000', 'consum', 0.0233, 'lps'),
	(610660, 129, '2014-04-01 00:18:50.000000', 'consum', 0.0212, 'lps'),
	(610661, 129, '2014-04-01 00:18:51.000000', 'consum', 0.0222, 'lps'),
	(610662, 129, '2014-04-01 00:18:52.000000', 'consum', 0.0219, 'lps'),
	(610663, 129, '2014-04-01 00:18:53.000000', 'consum', 0.0217, 'lps'),
	(610664, 129, '2014-04-01 00:18:54.000000', 'consum', 0.0221, 'lps'),
	(610665, 129, '2014-04-01 00:18:55.000000', 'consum', 0.0221, 'lps'),
	(610666, 129, '2014-04-01 00:18:56.000000', 'consum', 0.0233, 'lps'),
	(610667, 129, '2014-04-01 00:18:57.000000', 'consum', 0.0218, 'lps'),
	(610668, 129, '2014-04-01 00:18:58.000000', 'consum', 0.0231, 'lps'),
	(610669, 129, '2014-04-01 00:18:59.000000', 'consum', 0.0219, 'lps'),
	(610670, 129, '2014-04-01 00:19:00.000000', 'consum', 0.0217, 'lps'),
	(610671, 129, '2014-04-01 00:19:01.000000', 'consum', 0.0218, 'lps'),
	(610672, 129, '2014-04-01 00:19:02.000000', 'consum', 0.0230, 'lps'),
	(610673, 129, '2014-04-01 00:19:03.000000', 'consum', 0.0216, 'lps'),
	(610674, 129, '2014-04-01 00:19:04.000000', 'consum', 0.0226, 'lps'),
	(610675, 129, '2014-04-01 00:19:05.000000', 'consum', 0.0226, 'lps'),
	(610676, 129, '2014-04-01 00:19:06.000000', 'consum', 0.0217, 'lps'),
	(610677, 129, '2014-04-01 00:19:07.000000', 'consum', 0.0223, 'lps'),
	(610678, 129, '2014-04-01 00:19:08.000000', 'consum', 0.0231, 'lps'),
	(610679, 129, '2014-04-01 00:19:09.000000', 'consum', 0.0229, 'lps'),
	(610680, 129, '2014-04-01 00:19:10.000000', 'consum', 0.0216, 'lps'),
	(610681, 129, '2014-04-01 00:19:11.000000', 'consum', 0.0231, 'lps'),
	(610682, 129, '2014-04-01 00:19:12.000000', 'consum', 0.0226, 'lps'),
	(610683, 129, '2014-04-01 00:19:13.000000', 'consum', 0.0227, 'lps'),
	(610684, 129, '2014-04-01 00:19:14.000000', 'consum', 0.0226, 'lps'),
	(610685, 129, '2014-04-01 00:19:15.000000', 'consum', 0.0212, 'lps'),
	(610686, 129, '2014-04-01 00:19:16.000000', 'consum', 0.0222, 'lps'),
	(610687, 129, '2014-04-01 00:19:17.000000', 'consum', 0.0219, 'lps'),
	(610688, 129, '2014-04-01 00:19:18.000000', 'consum', 0.0216, 'lps'),
	(610689, 129, '2014-04-01 00:19:19.000000', 'consum', 0.0213, 'lps'),
	(610690, 129, '2014-04-01 00:19:20.000000', 'consum', 0.0210, 'lps'),
	(610691, 129, '2014-04-01 00:19:21.000000', 'consum', 0.0225, 'lps'),
	(610692, 129, '2014-04-01 00:19:22.000000', 'consum', 0.0214, 'lps'),
	(610693, 129, '2014-04-01 00:19:23.000000', 'consum', 0.0210, 'lps'),
	(610694, 129, '2014-04-01 00:19:24.000000', 'consum', 0.0221, 'lps'),
	(610695, 129, '2014-04-01 00:19:25.000000', 'consum', 0.0219, 'lps'),
	(610696, 129, '2014-04-01 00:19:26.000000', 'consum', 0.0221, 'lps'),
	(610697, 129, '2014-04-01 00:19:27.000000', 'consum', 0.0215, 'lps'),
	(610698, 129, '2014-04-01 00:19:28.000000', 'consum', 0.0226, 'lps'),
	(610699, 129, '2014-04-01 00:19:29.000000', 'consum', 0.0226, 'lps'),
	(610700, 129, '2014-04-01 00:19:30.000000', 'consum', 0.0221, 'lps'),
	(610701, 129, '2014-04-01 00:19:31.000000', 'consum', 0.0218, 'lps'),
	(610702, 129, '2014-04-01 00:19:32.000000', 'consum', 0.0218, 'lps'),
	(610703, 129, '2014-04-01 00:19:33.000000', 'consum', 0.0226, 'lps'),
	(610704, 129, '2014-04-01 00:19:34.000000', 'consum', 0.0219, 'lps'),
	(610705, 129, '2014-04-01 00:19:35.000000', 'consum', 0.0230, 'lps'),
	(610706, 129, '2014-04-01 00:19:36.000000', 'consum', 0.0213, 'lps'),
	(610707, 129, '2014-04-01 00:19:37.000000', 'consum', 0.0212, 'lps'),
	(610708, 129, '2014-04-01 00:19:38.000000', 'consum', 0.0213, 'lps'),
	(610709, 129, '2014-04-01 00:19:39.000000', 'consum', 0.0220, 'lps'),
	(610710, 129, '2014-04-01 00:19:40.000000', 'consum', 0.0228, 'lps'),
	(610711, 129, '2014-04-01 00:19:41.000000', 'consum', 0.0220, 'lps'),
	(610712, 129, '2014-04-01 00:19:42.000000', 'consum', 0.0231, 'lps'),
	(610713, 129, '2014-04-01 00:19:43.000000', 'consum', 0.0216, 'lps'),
	(610714, 129, '2014-04-01 00:19:44.000000', 'consum', 0.0223, 'lps'),
	(610715, 129, '2014-04-01 00:19:45.000000', 'consum', 0.0233, 'lps'),
	(610716, 129, '2014-04-01 00:19:46.000000', 'consum', 0.0213, 'lps'),
	(610717, 129, '2014-04-01 00:19:47.000000', 'consum', 0.0232, 'lps'),
	(610718, 129, '2014-04-01 00:19:48.000000', 'consum', 0.0213, 'lps'),
	(610719, 129, '2014-04-01 00:19:49.000000', 'consum', 0.0232, 'lps'),
	(610720, 129, '2014-04-01 00:19:50.000000', 'consum', 0.0214, 'lps'),
	(610721, 129, '2014-04-01 00:19:51.000000', 'consum', 0.0214, 'lps'),
	(610722, 129, '2014-04-01 00:19:52.000000', 'consum', 0.0218, 'lps'),
	(610723, 129, '2014-04-01 00:19:53.000000', 'consum', 0.0216, 'lps'),
	(610724, 129, '2014-04-01 00:19:54.000000', 'consum', 0.0217, 'lps'),
	(610725, 129, '2014-04-01 00:19:55.000000', 'consum', 0.0225, 'lps'),
	(610726, 129, '2014-04-01 00:19:56.000000', 'consum', 0.0216, 'lps'),
	(610727, 129, '2014-04-01 00:19:57.000000', 'consum', 0.0221, 'lps'),
	(610728, 129, '2014-04-01 00:19:58.000000', 'consum', 0.0222, 'lps'),
	(610729, 129, '2014-04-01 00:19:59.000000', 'consum', 0.0215, 'lps'),
	(610730, 129, '2014-04-01 00:20:00.000000', 'consum', 0.0224, 'lps'),
	(610731, 129, '2014-04-01 00:20:01.000000', 'consum', 0.0217, 'lps'),
	(610732, 129, '2014-04-01 00:20:02.000000', 'consum', 0.0228, 'lps'),
	(610733, 129, '2014-04-01 00:20:03.000000', 'consum', 0.0230, 'lps'),
	(610734, 129, '2014-04-01 00:20:04.000000', 'consum', 0.0232, 'lps'),
	(610735, 129, '2014-04-01 00:20:05.000000', 'consum', 0.0215, 'lps'),
	(610736, 129, '2014-04-01 00:20:06.000000', 'consum', 0.0218, 'lps'),
	(610737, 129, '2014-04-01 00:20:07.000000', 'consum', 0.0210, 'lps'),
	(610738, 129, '2014-04-01 00:20:08.000000', 'consum', 0.0233, 'lps'),
	(610739, 129, '2014-04-01 00:20:09.000000', 'consum', 0.0231, 'lps'),
	(610740, 129, '2014-04-01 00:20:10.000000', 'consum', 0.0223, 'lps'),
	(610741, 129, '2014-04-01 00:20:11.000000', 'consum', 0.0211, 'lps'),
	(610742, 129, '2014-04-01 00:20:12.000000', 'consum', 0.0224, 'lps'),
	(610743, 129, '2014-04-01 00:20:13.000000', 'consum', 0.0230, 'lps'),
	(610744, 129, '2014-04-01 00:20:14.000000', 'consum', 0.0221, 'lps'),
	(610745, 129, '2014-04-01 00:20:15.000000', 'consum', 0.0228, 'lps'),
	(610746, 129, '2014-04-01 00:20:16.000000', 'consum', 0.0222, 'lps'),
	(610747, 129, '2014-04-01 00:20:17.000000', 'consum', 0.0216, 'lps'),
	(610748, 129, '2014-04-01 00:20:18.000000', 'consum', 0.0229, 'lps'),
	(610749, 129, '2014-04-01 00:20:19.000000', 'consum', 0.0214, 'lps'),
	(610750, 129, '2014-04-01 00:20:20.000000', 'consum', 0.0222, 'lps'),
	(610751, 129, '2014-04-01 00:20:21.000000', 'consum', 0.0212, 'lps'),
	(610752, 129, '2014-04-01 00:20:22.000000', 'consum', 0.0210, 'lps'),
	(610753, 129, '2014-04-01 00:20:23.000000', 'consum', 0.0225, 'lps'),
	(610754, 129, '2014-04-01 00:20:24.000000', 'consum', 0.0215, 'lps'),
	(610755, 129, '2014-04-01 00:20:25.000000', 'consum', 0.0215, 'lps'),
	(610756, 129, '2014-04-01 00:20:26.000000', 'consum', 0.0221, 'lps'),
	(610757, 129, '2014-04-01 00:20:27.000000', 'consum', 0.0225, 'lps'),
	(610758, 129, '2014-04-01 00:20:28.000000', 'consum', 0.0229, 'lps'),
	(610759, 129, '2014-04-01 00:20:29.000000', 'consum', 0.0211, 'lps'),
	(610760, 129, '2014-04-01 00:20:30.000000', 'consum', 0.0230, 'lps'),
	(610761, 129, '2014-04-01 00:20:31.000000', 'consum', 0.0212, 'lps'),
	(610762, 129, '2014-04-01 00:20:32.000000', 'consum', 0.0210, 'lps'),
	(610763, 129, '2014-04-01 00:20:33.000000', 'consum', 0.0230, 'lps'),
	(610764, 129, '2014-04-01 00:20:34.000000', 'consum', 0.0212, 'lps'),
	(610765, 129, '2014-04-01 00:20:35.000000', 'consum', 0.0232, 'lps'),
	(610766, 129, '2014-04-01 00:20:36.000000', 'consum', 0.0220, 'lps'),
	(610767, 129, '2014-04-01 00:20:37.000000', 'consum', 0.0216, 'lps'),
	(610768, 129, '2014-04-01 00:20:38.000000', 'consum', 0.0214, 'lps'),
	(610769, 129, '2014-04-01 00:20:39.000000', 'consum', 0.0211, 'lps'),
	(610770, 129, '2014-04-01 00:20:40.000000', 'consum', 0.0227, 'lps'),
	(610771, 129, '2014-04-01 00:20:41.000000', 'consum', 0.0222, 'lps'),
	(610772, 129, '2014-04-01 00:20:42.000000', 'consum', 0.0221, 'lps'),
	(610773, 129, '2014-04-01 00:20:43.000000', 'consum', 0.0226, 'lps'),
	(610774, 129, '2014-04-01 00:20:44.000000', 'consum', 0.0211, 'lps'),
	(610775, 129, '2014-04-01 00:20:45.000000', 'consum', 0.0217, 'lps'),
	(610776, 129, '2014-04-01 00:20:46.000000', 'consum', 0.0217, 'lps'),
	(610777, 129, '2014-04-01 00:20:47.000000', 'consum', 0.0225, 'lps'),
	(610778, 129, '2014-04-01 00:20:48.000000', 'consum', 0.0214, 'lps'),
	(610779, 129, '2014-04-01 00:20:49.000000', 'consum', 0.0213, 'lps'),
	(610780, 129, '2014-04-01 00:20:50.000000', 'consum', 0.0212, 'lps'),
	(610781, 129, '2014-04-01 00:20:51.000000', 'consum', 0.0211, 'lps'),
	(610782, 129, '2014-04-01 00:20:52.000000', 'consum', 0.0233, 'lps'),
	(610783, 129, '2014-04-01 00:20:53.000000', 'consum', 0.0229, 'lps'),
	(610784, 129, '2014-04-01 00:20:54.000000', 'consum', 0.0212, 'lps'),
	(610785, 129, '2014-04-01 00:20:55.000000', 'consum', 0.0233, 'lps'),
	(610786, 129, '2014-04-01 00:20:56.000000', 'consum', 0.0225, 'lps'),
	(610787, 129, '2014-04-01 00:20:57.000000', 'consum', 0.0215, 'lps'),
	(610788, 129, '2014-04-01 00:20:58.000000', 'consum', 0.0215, 'lps'),
	(610789, 129, '2014-04-01 00:20:59.000000', 'consum', 0.0221, 'lps'),
	(610790, 129, '2014-04-01 00:21:00.000000', 'consum', 0.0225, 'lps'),
	(610791, 129, '2014-04-01 00:21:01.000000', 'consum', 0.0231, 'lps'),
	(610792, 129, '2014-04-01 00:21:02.000000', 'consum', 0.0222, 'lps'),
	(610793, 129, '2014-04-01 00:21:03.000000', 'consum', 0.0230, 'lps'),
	(610794, 129, '2014-04-01 00:21:04.000000', 'consum', 0.0227, 'lps'),
	(610795, 129, '2014-04-01 00:21:05.000000', 'consum', 0.0213, 'lps'),
	(610796, 129, '2014-04-01 00:21:06.000000', 'consum', 0.0222, 'lps'),
	(610797, 129, '2014-04-01 00:21:07.000000', 'consum', 0.0215, 'lps'),
	(610798, 129, '2014-04-01 00:21:08.000000', 'consum', 0.0222, 'lps'),
	(610799, 129, '2014-04-01 00:21:09.000000', 'consum', 0.0210, 'lps'),
	(610800, 129, '2014-04-01 00:21:10.000000', 'consum', 0.0219, 'lps'),
	(610801, 129, '2014-04-01 00:21:11.000000', 'consum', 0.0233, 'lps'),
	(610802, 129, '2014-04-01 00:21:12.000000', 'consum', 0.0225, 'lps'),
	(610803, 129, '2014-04-01 00:21:13.000000', 'consum', 0.0217, 'lps'),
	(610804, 129, '2014-04-01 00:21:14.000000', 'consum', 0.0224, 'lps'),
	(610805, 129, '2014-04-01 00:21:15.000000', 'consum', 0.0212, 'lps'),
	(610806, 129, '2014-04-01 00:21:16.000000', 'consum', 0.0227, 'lps'),
	(610807, 129, '2014-04-01 00:21:17.000000', 'consum', 0.0217, 'lps'),
	(610808, 129, '2014-04-01 00:21:18.000000', 'consum', 0.0220, 'lps'),
	(610809, 129, '2014-04-01 00:21:19.000000', 'consum', 0.0215, 'lps'),
	(610810, 129, '2014-04-01 00:21:20.000000', 'consum', 0.0227, 'lps'),
	(610811, 129, '2014-04-01 00:21:21.000000', 'consum', 0.0211, 'lps'),
	(610812, 129, '2014-04-01 00:21:22.000000', 'consum', 0.0210, 'lps'),
	(610813, 129, '2014-04-01 00:21:23.000000', 'consum', 0.0232, 'lps'),
	(610814, 129, '2014-04-01 00:21:24.000000', 'consum', 0.0226, 'lps'),
	(610815, 129, '2014-04-01 00:21:25.000000', 'consum', 0.0223, 'lps'),
	(610816, 129, '2014-04-01 00:21:26.000000', 'consum', 0.0229, 'lps'),
	(610817, 129, '2014-04-01 00:21:27.000000', 'consum', 0.0220, 'lps'),
	(610818, 129, '2014-04-01 00:21:28.000000', 'consum', 0.0225, 'lps'),
	(610819, 129, '2014-04-01 00:21:29.000000', 'consum', 0.0210, 'lps'),
	(610820, 129, '2014-04-01 00:21:30.000000', 'consum', 0.0214, 'lps'),
	(610821, 129, '2014-04-01 00:21:31.000000', 'consum', 0.0228, 'lps'),
	(610822, 129, '2014-04-01 00:21:32.000000', 'consum', 0.0217, 'lps'),
	(610823, 129, '2014-04-01 00:21:33.000000', 'consum', 0.0215, 'lps'),
	(610824, 129, '2014-04-01 00:21:34.000000', 'consum', 0.0215, 'lps'),
	(610825, 129, '2014-04-01 00:21:35.000000', 'consum', 0.0222, 'lps'),
	(610826, 129, '2014-04-01 00:21:36.000000', 'consum', 0.0230, 'lps'),
	(610827, 129, '2014-04-01 00:21:37.000000', 'consum', 0.0227, 'lps'),
	(610828, 129, '2014-04-01 00:21:38.000000', 'consum', 0.0212, 'lps'),
	(610829, 129, '2014-04-01 00:21:39.000000', 'consum', 0.0215, 'lps'),
	(610830, 129, '2014-04-01 00:21:40.000000', 'consum', 0.0231, 'lps'),
	(610831, 129, '2014-04-01 00:21:41.000000', 'consum', 0.0228, 'lps'),
	(610832, 129, '2014-04-01 00:21:42.000000', 'consum', 0.0213, 'lps'),
	(610833, 129, '2014-04-01 00:21:43.000000', 'consum', 0.0220, 'lps'),
	(610834, 129, '2014-04-01 00:21:44.000000', 'consum', 0.0226, 'lps'),
	(610835, 129, '2014-04-01 00:21:45.000000', 'consum', 0.0214, 'lps'),
	(610836, 129, '2014-04-01 00:21:46.000000', 'consum', 0.0231, 'lps'),
	(610837, 129, '2014-04-01 00:21:47.000000', 'consum', 0.0230, 'lps'),
	(610838, 129, '2014-04-01 00:21:48.000000', 'consum', 0.0225, 'lps'),
	(610839, 129, '2014-04-01 00:21:49.000000', 'consum', 0.0226, 'lps'),
	(610840, 129, '2014-04-01 00:21:50.000000', 'consum', 0.0222, 'lps'),
	(610841, 129, '2014-04-01 00:21:51.000000', 'consum', 0.0223, 'lps'),
	(610842, 129, '2014-04-01 00:21:52.000000', 'consum', 0.0213, 'lps'),
	(610843, 129, '2014-04-01 00:21:53.000000', 'consum', 0.0214, 'lps'),
	(610844, 129, '2014-04-01 00:21:54.000000', 'consum', 0.0219, 'lps'),
	(610845, 129, '2014-04-01 00:21:55.000000', 'consum', 0.0218, 'lps'),
	(610846, 129, '2014-04-01 00:21:56.000000', 'consum', 0.0225, 'lps'),
	(610847, 129, '2014-04-01 00:21:57.000000', 'consum', 0.0214, 'lps'),
	(610848, 129, '2014-04-01 00:21:58.000000', 'consum', 0.0211, 'lps'),
	(610849, 129, '2014-04-01 00:21:59.000000', 'consum', 0.0226, 'lps'),
	(610850, 129, '2014-04-01 00:22:00.000000', 'consum', 0.0216, 'lps'),
	(610851, 129, '2014-04-01 00:22:01.000000', 'consum', 0.0217, 'lps'),
	(610852, 129, '2014-04-01 00:22:02.000000', 'consum', 0.0228, 'lps'),
	(610853, 129, '2014-04-01 00:22:03.000000', 'consum', 0.0229, 'lps'),
	(610854, 129, '2014-04-01 00:22:04.000000', 'consum', 0.0227, 'lps'),
	(610855, 129, '2014-04-01 00:22:05.000000', 'consum', 0.0216, 'lps'),
	(610856, 129, '2014-04-01 00:22:06.000000', 'consum', 0.0215, 'lps'),
	(610857, 129, '2014-04-01 00:22:07.000000', 'consum', 0.0218, 'lps'),
	(610858, 129, '2014-04-01 00:22:08.000000', 'consum', 0.0211, 'lps'),
	(610859, 129, '2014-04-01 00:22:09.000000', 'consum', 0.0217, 'lps'),
	(610860, 129, '2014-04-01 00:22:10.000000', 'consum', 0.0216, 'lps'),
	(610861, 129, '2014-04-01 00:22:11.000000', 'consum', 0.0222, 'lps'),
	(610862, 129, '2014-04-01 00:22:12.000000', 'consum', 0.0225, 'lps'),
	(610863, 129, '2014-04-01 00:22:13.000000', 'consum', 0.0228, 'lps'),
	(610864, 129, '2014-04-01 00:22:14.000000', 'consum', 0.0230, 'lps'),
	(610865, 129, '2014-04-01 00:22:15.000000', 'consum', 0.0211, 'lps'),
	(610866, 129, '2014-04-01 00:22:16.000000', 'consum', 0.0226, 'lps'),
	(610867, 129, '2014-04-01 00:22:17.000000', 'consum', 0.0213, 'lps'),
	(610868, 129, '2014-04-01 00:22:18.000000', 'consum', 0.0229, 'lps'),
	(610869, 129, '2014-04-01 00:22:19.000000', 'consum', 0.0225, 'lps'),
	(610870, 129, '2014-04-01 00:22:20.000000', 'consum', 0.0228, 'lps'),
	(610871, 129, '2014-04-01 00:22:21.000000', 'consum', 0.0231, 'lps'),
	(610872, 129, '2014-04-01 00:22:22.000000', 'consum', 0.0211, 'lps'),
	(610873, 129, '2014-04-01 00:22:23.000000', 'consum', 0.0228, 'lps'),
	(610874, 129, '2014-04-01 00:22:24.000000', 'consum', 0.0224, 'lps'),
	(610875, 129, '2014-04-01 00:22:25.000000', 'consum', 0.0227, 'lps'),
	(610876, 129, '2014-04-01 00:22:26.000000', 'consum', 0.0228, 'lps'),
	(610877, 129, '2014-04-01 00:22:27.000000', 'consum', 0.0227, 'lps'),
	(610878, 129, '2014-04-01 00:22:28.000000', 'consum', 0.0216, 'lps'),
	(610879, 129, '2014-04-01 00:22:29.000000', 'consum', 0.0216, 'lps'),
	(610880, 129, '2014-04-01 00:22:30.000000', 'consum', 0.0220, 'lps'),
	(610881, 129, '2014-04-01 00:22:31.000000', 'consum', 0.0219, 'lps'),
	(610882, 129, '2014-04-01 00:22:32.000000', 'consum', 0.0225, 'lps'),
	(610883, 129, '2014-04-01 00:22:33.000000', 'consum', 0.0210, 'lps'),
	(610884, 129, '2014-04-01 00:22:34.000000', 'consum', 0.0216, 'lps'),
	(610885, 129, '2014-04-01 00:22:35.000000', 'consum', 0.0216, 'lps'),
	(610886, 129, '2014-04-01 00:22:36.000000', 'consum', 0.0224, 'lps'),
	(610887, 129, '2014-04-01 00:22:37.000000', 'consum', 0.0213, 'lps'),
	(610888, 129, '2014-04-01 00:22:38.000000', 'consum', 0.0230, 'lps'),
	(610889, 129, '2014-04-01 00:22:39.000000', 'consum', 0.0233, 'lps'),
	(610890, 129, '2014-04-01 00:22:40.000000', 'consum', 0.0214, 'lps'),
	(610891, 129, '2014-04-01 00:22:41.000000', 'consum', 0.0212, 'lps'),
	(610892, 129, '2014-04-01 00:22:42.000000', 'consum', 0.0230, 'lps'),
	(610893, 129, '2014-04-01 00:22:43.000000', 'consum', 0.0210, 'lps'),
	(610894, 129, '2014-04-01 00:22:44.000000', 'consum', 0.0221, 'lps'),
	(610895, 129, '2014-04-01 00:22:45.000000', 'consum', 0.0217, 'lps'),
	(610896, 129, '2014-04-01 00:22:46.000000', 'consum', 0.0212, 'lps'),
	(610897, 129, '2014-04-01 00:22:47.000000', 'consum', 0.0225, 'lps'),
	(610898, 129, '2014-04-01 00:22:48.000000', 'consum', 0.0230, 'lps'),
	(610899, 129, '2014-04-01 00:22:49.000000', 'consum', 0.0219, 'lps'),
	(610900, 129, '2014-04-01 00:22:50.000000', 'consum', 0.0219, 'lps'),
	(610901, 129, '2014-04-01 00:22:51.000000', 'consum', 0.0229, 'lps'),
	(610902, 129, '2014-04-01 00:22:52.000000', 'consum', 0.0230, 'lps'),
	(610903, 129, '2014-04-01 00:22:53.000000', 'consum', 0.0231, 'lps'),
	(610904, 129, '2014-04-01 00:22:54.000000', 'consum', 0.0233, 'lps'),
	(610905, 129, '2014-04-01 00:22:55.000000', 'consum', 0.0211, 'lps'),
	(610906, 129, '2014-04-01 00:22:56.000000', 'consum', 0.0218, 'lps'),
	(610907, 129, '2014-04-01 00:22:57.000000', 'consum', 0.0226, 'lps'),
	(610908, 129, '2014-04-01 00:22:58.000000', 'consum', 0.0219, 'lps'),
	(610909, 129, '2014-04-01 00:22:59.000000', 'consum', 0.0230, 'lps'),
	(610910, 129, '2014-04-01 00:23:00.000000', 'consum', 0.0211, 'lps'),
	(610911, 129, '2014-04-01 00:23:01.000000', 'consum', 0.0227, 'lps'),
	(610912, 129, '2014-04-01 00:23:02.000000', 'consum', 0.0222, 'lps'),
	(610913, 129, '2014-04-01 00:23:03.000000', 'consum', 0.0218, 'lps'),
	(610914, 129, '2014-04-01 00:23:04.000000', 'consum', 0.0217, 'lps'),
	(610915, 129, '2014-04-01 00:23:05.000000', 'consum', 0.0221, 'lps'),
	(610916, 129, '2014-04-01 00:23:06.000000', 'consum', 0.0222, 'lps'),
	(610917, 129, '2014-04-01 00:23:07.000000', 'consum', 0.0212, 'lps'),
	(610918, 129, '2014-04-01 00:23:08.000000', 'consum', 0.0232, 'lps'),
	(610919, 129, '2014-04-01 00:23:09.000000', 'consum', 0.0218, 'lps'),
	(610920, 129, '2014-04-01 00:23:10.000000', 'consum', 0.0232, 'lps'),
	(610921, 129, '2014-04-01 00:23:11.000000', 'consum', 0.0227, 'lps'),
	(610922, 129, '2014-04-01 00:23:12.000000', 'consum', 0.0227, 'lps'),
	(610923, 129, '2014-04-01 00:23:13.000000', 'consum', 0.0221, 'lps'),
	(610924, 129, '2014-04-01 00:23:14.000000', 'consum', 0.0216, 'lps'),
	(610925, 129, '2014-04-01 00:23:15.000000', 'consum', 0.0233, 'lps'),
	(610926, 129, '2014-04-01 00:23:16.000000', 'consum', 0.0232, 'lps'),
	(610927, 129, '2014-04-01 00:23:17.000000', 'consum', 0.0228, 'lps'),
	(610928, 129, '2014-04-01 00:23:18.000000', 'consum', 0.0212, 'lps'),
	(610929, 129, '2014-04-01 00:23:19.000000', 'consum', 0.0216, 'lps'),
	(610930, 129, '2014-04-01 00:23:20.000000', 'consum', 0.0232, 'lps'),
	(610931, 129, '2014-04-01 00:23:21.000000', 'consum', 0.0232, 'lps'),
	(610932, 129, '2014-04-01 00:23:22.000000', 'consum', 0.0230, 'lps'),
	(610933, 129, '2014-04-01 00:23:23.000000', 'consum', 0.0219, 'lps'),
	(610934, 129, '2014-04-01 00:23:24.000000', 'consum', 0.0219, 'lps'),
	(610935, 129, '2014-04-01 00:23:25.000000', 'consum', 0.0228, 'lps'),
	(610936, 129, '2014-04-01 00:23:26.000000', 'consum', 0.0226, 'lps'),
	(610937, 129, '2014-04-01 00:23:27.000000', 'consum', 0.0211, 'lps'),
	(610938, 129, '2014-04-01 00:23:28.000000', 'consum', 0.0217, 'lps'),
	(610939, 129, '2014-04-01 00:23:29.000000', 'consum', 0.0219, 'lps'),
	(610940, 129, '2014-04-01 00:23:30.000000', 'consum', 0.0212, 'lps'),
	(610941, 129, '2014-04-01 00:23:31.000000', 'consum', 0.0215, 'lps'),
	(610942, 129, '2014-04-01 00:23:32.000000', 'consum', 0.0232, 'lps'),
	(610943, 129, '2014-04-01 00:23:33.000000', 'consum', 0.0230, 'lps'),
	(610944, 129, '2014-04-01 00:23:34.000000', 'consum', 0.0224, 'lps'),
	(610945, 129, '2014-04-01 00:23:35.000000', 'consum', 0.0219, 'lps'),
	(610946, 129, '2014-04-01 00:23:36.000000', 'consum', 0.0215, 'lps'),
	(610947, 129, '2014-04-01 00:23:37.000000', 'consum', 0.0230, 'lps'),
	(610948, 129, '2014-04-01 00:23:38.000000', 'consum', 0.0223, 'lps'),
	(610949, 129, '2014-04-01 00:23:39.000000', 'consum', 0.0216, 'lps'),
	(610950, 129, '2014-04-01 00:23:40.000000', 'consum', 0.0224, 'lps'),
	(610951, 129, '2014-04-01 00:23:41.000000', 'consum', 0.0217, 'lps'),
	(610952, 129, '2014-04-01 00:23:42.000000', 'consum', 0.0228, 'lps'),
	(610953, 129, '2014-04-01 00:23:43.000000', 'consum', 0.0232, 'lps'),
	(610954, 129, '2014-04-01 00:23:44.000000', 'consum', 0.0217, 'lps'),
	(610955, 129, '2014-04-01 00:23:45.000000', 'consum', 0.0227, 'lps'),
	(610956, 129, '2014-04-01 00:23:46.000000', 'consum', 0.0225, 'lps'),
	(610957, 129, '2014-04-01 00:23:47.000000', 'consum', 0.0214, 'lps'),
	(610958, 129, '2014-04-01 00:23:48.000000', 'consum', 0.0231, 'lps'),
	(610959, 129, '2014-04-01 00:23:49.000000', 'consum', 0.0231, 'lps'),
	(610960, 129, '2014-04-01 00:23:50.000000', 'consum', 0.0229, 'lps'),
	(610961, 129, '2014-04-01 00:23:51.000000', 'consum', 0.0220, 'lps'),
	(610962, 129, '2014-04-01 00:23:52.000000', 'consum', 0.0225, 'lps'),
	(610963, 129, '2014-04-01 00:23:53.000000', 'consum', 0.0232, 'lps'),
	(610964, 129, '2014-04-01 00:23:54.000000', 'consum', 0.0227, 'lps'),
	(610965, 129, '2014-04-01 00:23:55.000000', 'consum', 0.0229, 'lps'),
	(610966, 129, '2014-04-01 00:23:56.000000', 'consum', 0.0232, 'lps'),
	(610967, 129, '2014-04-01 00:23:57.000000', 'consum', 0.0214, 'lps'),
	(610968, 129, '2014-04-01 00:23:58.000000', 'consum', 0.0214, 'lps'),
	(610969, 129, '2014-04-01 00:23:59.000000', 'consum', 0.0217, 'lps'),
	(610970, 129, '2014-04-01 00:24:00.000000', 'consum', 0.0233, 'lps'),
	(610971, 129, '2014-04-01 00:24:01.000000', 'consum', 0.0232, 'lps'),
	(610972, 129, '2014-04-01 00:24:02.000000', 'consum', 0.0229, 'lps'),
	(610973, 129, '2014-04-01 00:24:03.000000', 'consum', 0.0216, 'lps'),
	(610974, 129, '2014-04-01 00:24:04.000000', 'consum', 0.0231, 'lps'),
	(610975, 129, '2014-04-01 00:24:05.000000', 'consum', 0.0224, 'lps'),
	(610976, 129, '2014-04-01 00:24:06.000000', 'consum', 0.0217, 'lps'),
	(610977, 129, '2014-04-01 00:24:07.000000', 'consum', 0.0226, 'lps'),
	(610978, 129, '2014-04-01 00:24:08.000000', 'consum', 0.0225, 'lps'),
	(610979, 129, '2014-04-01 00:24:09.000000', 'consum', 0.0213, 'lps'),
	(610980, 129, '2014-04-01 00:24:10.000000', 'consum', 0.0230, 'lps'),
	(610981, 129, '2014-04-01 00:24:11.000000', 'consum', 0.0227, 'lps'),
	(610982, 129, '2014-04-01 00:24:12.000000', 'consum', 0.0213, 'lps'),
	(610983, 129, '2014-04-01 00:24:13.000000', 'consum', 0.0220, 'lps'),
	(610984, 129, '2014-04-01 00:24:14.000000', 'consum', 0.0231, 'lps'),
	(610985, 129, '2014-04-01 00:24:15.000000', 'consum', 0.0212, 'lps'),
	(610986, 129, '2014-04-01 00:24:16.000000', 'consum', 0.0230, 'lps'),
	(610987, 129, '2014-04-01 00:24:17.000000', 'consum', 0.0231, 'lps'),
	(610988, 129, '2014-04-01 00:24:18.000000', 'consum', 0.0232, 'lps'),
	(610989, 129, '2014-04-01 00:24:19.000000', 'consum', 0.0210, 'lps'),
	(610990, 129, '2014-04-01 00:24:20.000000', 'consum', 0.0217, 'lps'),
	(610991, 129, '2014-04-01 00:24:21.000000', 'consum', 0.0220, 'lps'),
	(610992, 129, '2014-04-01 00:24:22.000000', 'consum', 0.0218, 'lps'),
	(610993, 129, '2014-04-01 00:24:23.000000', 'consum', 0.0218, 'lps'),
	(610994, 129, '2014-04-01 00:24:24.000000', 'consum', 0.0227, 'lps'),
	(610995, 129, '2014-04-01 00:24:25.000000', 'consum', 0.0225, 'lps'),
	(610996, 129, '2014-04-01 00:24:26.000000', 'consum', 0.0232, 'lps'),
	(610997, 129, '2014-04-01 00:24:27.000000', 'consum', 0.0228, 'lps'),
	(610998, 129, '2014-04-01 00:24:28.000000', 'consum', 0.0212, 'lps'),
	(610999, 129, '2014-04-01 00:24:29.000000', 'consum', 0.0215, 'lps'),
	(611000, 129, '2014-04-01 00:24:30.000000', 'consum', 0.0227, 'lps'),
	(611001, 129, '2014-04-01 00:24:31.000000', 'consum', 0.0211, 'lps'),
	(611002, 129, '2014-04-01 00:24:32.000000', 'consum', 0.0210, 'lps'),
	(611003, 129, '2014-04-01 00:24:33.000000', 'consum', 0.0231, 'lps'),
	(611004, 129, '2014-04-01 00:24:34.000000', 'consum', 0.0219, 'lps'),
	(611005, 129, '2014-04-01 00:24:35.000000', 'consum', 0.0220, 'lps'),
	(611006, 129, '2014-04-01 00:24:36.000000', 'consum', 0.0230, 'lps'),
	(611007, 129, '2014-04-01 00:24:37.000000', 'consum', 0.0233, 'lps'),
	(611008, 129, '2014-04-01 00:24:38.000000', 'consum', 0.0219, 'lps'),
	(611009, 129, '2014-04-01 00:24:39.000000', 'consum', 0.0233, 'lps'),
	(611010, 129, '2014-04-01 00:24:40.000000', 'consum', 0.0229, 'lps'),
	(611011, 129, '2014-04-01 00:24:41.000000', 'consum', 0.0210, 'lps'),
	(611012, 129, '2014-04-01 00:24:42.000000', 'consum', 0.0225, 'lps'),
	(611013, 129, '2014-04-01 00:24:43.000000', 'consum', 0.0213, 'lps'),
	(611014, 129, '2014-04-01 00:24:44.000000', 'consum', 0.0231, 'lps'),
	(611015, 129, '2014-04-01 00:24:45.000000', 'consum', 0.0210, 'lps'),
	(611016, 129, '2014-04-01 00:24:46.000000', 'consum', 0.0220, 'lps'),
	(611017, 129, '2014-04-01 00:24:47.000000', 'consum', 0.0211, 'lps'),
	(611018, 129, '2014-04-01 00:24:48.000000', 'consum', 0.0210, 'lps'),
	(611019, 129, '2014-04-01 00:24:49.000000', 'consum', 0.0230, 'lps'),
	(611020, 129, '2014-04-01 00:24:50.000000', 'consum', 0.0214, 'lps'),
	(611021, 129, '2014-04-01 00:24:51.000000', 'consum', 0.0221, 'lps'),
	(611022, 129, '2014-04-01 00:24:52.000000', 'consum', 0.0230, 'lps'),
	(611023, 129, '2014-04-01 00:24:53.000000', 'consum', 0.0229, 'lps'),
	(611024, 129, '2014-04-01 00:24:54.000000', 'consum', 0.0222, 'lps'),
	(611025, 129, '2014-04-01 00:24:55.000000', 'consum', 0.0211, 'lps'),
	(611026, 129, '2014-04-01 00:24:56.000000', 'consum', 0.0231, 'lps'),
	(611027, 129, '2014-04-01 00:24:57.000000', 'consum', 0.0214, 'lps'),
	(611028, 129, '2014-04-01 00:24:58.000000', 'consum', 0.0216, 'lps'),
	(611029, 129, '2014-04-01 00:24:59.000000', 'consum', 0.0230, 'lps'),
	(611030, 129, '2014-04-01 00:25:00.000000', 'consum', 0.0217, 'lps'),
	(611031, 129, '2014-04-01 00:25:01.000000', 'consum', 0.0213, 'lps'),
	(611032, 129, '2014-04-01 00:25:02.000000', 'consum', 0.0229, 'lps'),
	(611033, 129, '2014-04-01 00:25:03.000000', 'consum', 0.0223, 'lps'),
	(611034, 129, '2014-04-01 00:25:04.000000', 'consum', 0.0221, 'lps'),
	(611035, 129, '2014-04-01 00:25:05.000000', 'consum', 0.0223, 'lps'),
	(611036, 129, '2014-04-01 00:25:06.000000', 'consum', 0.0219, 'lps'),
	(611037, 129, '2014-04-01 00:25:07.000000', 'consum', 0.0219, 'lps'),
	(611038, 129, '2014-04-01 00:25:08.000000', 'consum', 0.0225, 'lps'),
	(611039, 129, '2014-04-01 00:25:09.000000', 'consum', 0.0213, 'lps'),
	(611040, 129, '2014-04-01 00:25:10.000000', 'consum', 0.0226, 'lps'),
	(611041, 129, '2014-04-01 00:25:11.000000', 'consum', 0.0211, 'lps'),
	(611042, 129, '2014-04-01 00:25:12.000000', 'consum', 0.0213, 'lps'),
	(611043, 129, '2014-04-01 00:25:13.000000', 'consum', 0.0226, 'lps'),
	(611044, 129, '2014-04-01 00:25:14.000000', 'consum', 0.0233, 'lps'),
	(611045, 129, '2014-04-01 00:25:15.000000', 'consum', 0.0227, 'lps'),
	(611046, 129, '2014-04-01 00:25:16.000000', 'consum', 0.0228, 'lps'),
	(611047, 129, '2014-04-01 00:25:17.000000', 'consum', 0.0227, 'lps'),
	(611048, 129, '2014-04-01 00:25:18.000000', 'consum', 0.0215, 'lps'),
	(611049, 129, '2014-04-01 00:25:19.000000', 'consum', 0.0233, 'lps'),
	(611050, 129, '2014-04-01 00:25:20.000000', 'consum', 0.0216, 'lps'),
	(611051, 129, '2014-04-01 00:25:21.000000', 'consum', 0.0217, 'lps'),
	(611052, 129, '2014-04-01 00:25:22.000000', 'consum', 0.0228, 'lps'),
	(611053, 129, '2014-04-01 00:25:23.000000', 'consum', 0.0232, 'lps'),
	(611054, 129, '2014-04-01 00:25:24.000000', 'consum', 0.0217, 'lps'),
	(611055, 129, '2014-04-01 00:25:25.000000', 'consum', 0.0231, 'lps'),
	(611056, 129, '2014-04-01 00:25:26.000000', 'consum', 0.0219, 'lps'),
	(611057, 129, '2014-04-01 00:25:27.000000', 'consum', 0.0218, 'lps'),
	(611058, 129, '2014-04-01 00:25:28.000000', 'consum', 0.0225, 'lps'),
	(611059, 129, '2014-04-01 00:25:29.000000', 'consum', 0.0212, 'lps'),
	(611060, 129, '2014-04-01 00:25:30.000000', 'consum', 0.0222, 'lps'),
	(611061, 129, '2014-04-01 00:25:31.000000', 'consum', 0.0218, 'lps'),
	(611062, 129, '2014-04-01 00:25:32.000000', 'consum', 0.0214, 'lps'),
	(611063, 129, '2014-04-01 00:25:33.000000', 'consum', 0.0231, 'lps'),
	(611064, 129, '2014-04-01 00:25:34.000000', 'consum', 0.0233, 'lps'),
	(611065, 129, '2014-04-01 00:25:35.000000', 'consum', 0.0214, 'lps'),
	(611066, 129, '2014-04-01 00:25:36.000000', 'consum', 0.0211, 'lps'),
	(611067, 129, '2014-04-01 00:25:37.000000', 'consum', 0.0226, 'lps'),
	(611068, 129, '2014-04-01 00:25:38.000000', 'consum', 0.0218, 'lps'),
	(611069, 129, '2014-04-01 00:25:39.000000', 'consum', 0.0223, 'lps'),
	(611070, 129, '2014-04-01 00:25:40.000000', 'consum', 0.0231, 'lps'),
	(611071, 129, '2014-04-01 00:25:41.000000', 'consum', 0.0225, 'lps'),
	(611072, 129, '2014-04-01 00:25:42.000000', 'consum', 0.0225, 'lps'),
	(611073, 129, '2014-04-01 00:25:43.000000', 'consum', 0.0214, 'lps'),
	(611074, 129, '2014-04-01 00:25:44.000000', 'consum', 0.0211, 'lps'),
	(611075, 129, '2014-04-01 00:25:45.000000', 'consum', 0.0228, 'lps'),
	(611076, 129, '2014-04-01 00:25:46.000000', 'consum', 0.0224, 'lps'),
	(611077, 129, '2014-04-01 00:25:47.000000', 'consum', 0.0228, 'lps'),
	(611078, 129, '2014-04-01 00:25:48.000000', 'consum', 0.0210, 'lps'),
	(611079, 129, '2014-04-01 00:25:49.000000', 'consum', 0.0230, 'lps'),
	(611080, 129, '2014-04-01 00:25:50.000000', 'consum', 0.0214, 'lps'),
	(611081, 129, '2014-04-01 00:25:51.000000', 'consum', 0.0219, 'lps'),
	(611082, 129, '2014-04-01 00:25:52.000000', 'consum', 0.0217, 'lps'),
	(611083, 129, '2014-04-01 00:25:53.000000', 'consum', 0.0220, 'lps'),
	(611084, 129, '2014-04-01 00:25:54.000000', 'consum', 0.0215, 'lps'),
	(611085, 129, '2014-04-01 00:25:55.000000', 'consum', 0.0230, 'lps'),
	(611086, 129, '2014-04-01 00:25:56.000000', 'consum', 0.0225, 'lps'),
	(611087, 129, '2014-04-01 00:25:57.000000', 'consum', 0.0225, 'lps'),
	(611088, 129, '2014-04-01 00:25:58.000000', 'consum', 0.0215, 'lps'),
	(611089, 129, '2014-04-01 00:25:59.000000', 'consum', 0.0216, 'lps'),
	(611090, 129, '2014-04-01 00:26:00.000000', 'consum', 0.0227, 'lps'),
	(611091, 129, '2014-04-01 00:26:01.000000', 'consum', 0.0228, 'lps'),
	(611092, 129, '2014-04-01 00:26:02.000000', 'consum', 0.0224, 'lps'),
	(611093, 129, '2014-04-01 00:26:03.000000', 'consum', 0.0228, 'lps'),
	(611094, 129, '2014-04-01 00:26:04.000000', 'consum', 0.0232, 'lps'),
	(611095, 129, '2014-04-01 00:26:05.000000', 'consum', 0.0220, 'lps'),
	(611096, 129, '2014-04-01 00:26:06.000000', 'consum', 0.0220, 'lps'),
	(611097, 129, '2014-04-01 00:26:07.000000', 'consum', 0.0230, 'lps'),
	(611098, 129, '2014-04-01 00:26:08.000000', 'consum', 0.0233, 'lps'),
	(611099, 129, '2014-04-01 00:26:09.000000', 'consum', 0.0215, 'lps'),
	(611100, 129, '2014-04-01 00:26:10.000000', 'consum', 0.0218, 'lps'),
	(611101, 129, '2014-04-01 00:26:11.000000', 'consum', 0.0233, 'lps'),
	(611102, 129, '2014-04-01 00:26:12.000000', 'consum', 0.0229, 'lps'),
	(611103, 129, '2014-04-01 00:26:13.000000', 'consum', 0.0213, 'lps'),
	(611104, 129, '2014-04-01 00:26:14.000000', 'consum', 0.0217, 'lps'),
	(611105, 129, '2014-04-01 00:26:15.000000', 'consum', 0.0211, 'lps'),
	(611106, 129, '2014-04-01 00:26:16.000000', 'consum', 0.0220, 'lps'),
	(611107, 129, '2014-04-01 00:26:17.000000', 'consum', 0.0232, 'lps'),
	(611108, 129, '2014-04-01 00:26:18.000000', 'consum', 0.0217, 'lps'),
	(611109, 129, '2014-04-01 00:26:19.000000', 'consum', 0.0230, 'lps'),
	(611110, 129, '2014-04-01 00:26:20.000000', 'consum', 0.0218, 'lps'),
	(611111, 129, '2014-04-01 00:26:21.000000', 'consum', 0.0212, 'lps'),
	(611112, 129, '2014-04-01 00:26:22.000000', 'consum', 0.0222, 'lps'),
	(611113, 129, '2014-04-01 00:26:23.000000', 'consum', 0.0217, 'lps'),
	(611114, 129, '2014-04-01 00:26:24.000000', 'consum', 0.0231, 'lps'),
	(611115, 129, '2014-04-01 00:26:25.000000', 'consum', 0.0225, 'lps'),
	(611116, 129, '2014-04-01 00:26:26.000000', 'consum', 0.0222, 'lps'),
	(611117, 129, '2014-04-01 00:26:27.000000', 'consum', 0.0226, 'lps'),
	(611118, 129, '2014-04-01 00:26:28.000000', 'consum', 0.0228, 'lps'),
	(611119, 129, '2014-04-01 00:26:29.000000', 'consum', 0.0231, 'lps'),
	(611120, 129, '2014-04-01 00:26:30.000000', 'consum', 0.0213, 'lps'),
	(611121, 129, '2014-04-01 00:26:31.000000', 'consum', 0.0210, 'lps'),
	(611122, 129, '2014-04-01 00:26:32.000000', 'consum', 0.0224, 'lps'),
	(611123, 129, '2014-04-01 00:26:33.000000', 'consum', 0.0211, 'lps'),
	(611124, 129, '2014-04-01 00:26:34.000000', 'consum', 0.0221, 'lps'),
	(611125, 129, '2014-04-01 00:26:35.000000', 'consum', 0.0214, 'lps'),
	(611126, 129, '2014-04-01 00:26:36.000000', 'consum', 0.0222, 'lps'),
	(611127, 129, '2014-04-01 00:26:37.000000', 'consum', 0.0210, 'lps'),
	(611128, 129, '2014-04-01 00:26:38.000000', 'consum', 0.0222, 'lps'),
	(611129, 129, '2014-04-01 00:26:39.000000', 'consum', 0.0225, 'lps'),
	(611130, 129, '2014-04-01 00:26:40.000000', 'consum', 0.0223, 'lps'),
	(611131, 129, '2014-04-01 00:26:41.000000', 'consum', 0.0229, 'lps'),
	(611132, 129, '2014-04-01 00:26:42.000000', 'consum', 0.0222, 'lps'),
	(611133, 129, '2014-04-01 00:26:43.000000', 'consum', 0.0213, 'lps'),
	(611134, 129, '2014-04-01 00:26:44.000000', 'consum', 0.0213, 'lps'),
	(611135, 129, '2014-04-01 00:26:45.000000', 'consum', 0.0217, 'lps'),
	(611136, 129, '2014-04-01 00:26:46.000000', 'consum', 0.0213, 'lps'),
	(611137, 129, '2014-04-01 00:26:47.000000', 'consum', 0.0228, 'lps'),
	(611138, 129, '2014-04-01 00:26:48.000000', 'consum', 0.0221, 'lps'),
	(611139, 129, '2014-04-01 00:26:49.000000', 'consum', 0.0212, 'lps'),
	(611140, 129, '2014-04-01 00:26:50.000000', 'consum', 0.0211, 'lps'),
	(611141, 129, '2014-04-01 00:26:51.000000', 'consum', 0.0232, 'lps'),
	(611142, 129, '2014-04-01 00:26:52.000000', 'consum', 0.0221, 'lps'),
	(611143, 129, '2014-04-01 00:26:53.000000', 'consum', 0.0225, 'lps'),
	(611144, 129, '2014-04-01 00:26:54.000000', 'consum', 0.0227, 'lps'),
	(611145, 129, '2014-04-01 00:26:55.000000', 'consum', 0.0227, 'lps'),
	(611146, 129, '2014-04-01 00:26:56.000000', 'consum', 0.0222, 'lps'),
	(611147, 129, '2014-04-01 00:26:57.000000', 'consum', 0.0217, 'lps'),
	(611148, 129, '2014-04-01 00:26:58.000000', 'consum', 0.0211, 'lps'),
	(611149, 129, '2014-04-01 00:26:59.000000', 'consum', 0.0218, 'lps'),
	(611150, 129, '2014-04-01 00:27:00.000000', 'consum', 0.0223, 'lps'),
	(611151, 129, '2014-04-01 00:27:01.000000', 'consum', 0.0228, 'lps'),
	(611152, 129, '2014-04-01 00:27:02.000000', 'consum', 0.0213, 'lps'),
	(611153, 129, '2014-04-01 00:27:03.000000', 'consum', 0.0221, 'lps'),
	(611154, 129, '2014-04-01 00:27:04.000000', 'consum', 0.0233, 'lps'),
	(611155, 129, '2014-04-01 00:27:05.000000', 'consum', 0.0221, 'lps'),
	(611156, 129, '2014-04-01 00:27:06.000000', 'consum', 0.0218, 'lps'),
	(611157, 129, '2014-04-01 00:27:07.000000', 'consum', 0.0217, 'lps'),
	(611158, 129, '2014-04-01 00:27:08.000000', 'consum', 0.0223, 'lps'),
	(611159, 129, '2014-04-01 00:27:09.000000', 'consum', 0.0229, 'lps'),
	(611160, 129, '2014-04-01 00:27:10.000000', 'consum', 0.0220, 'lps'),
	(611161, 129, '2014-04-01 00:27:11.000000', 'consum', 0.0228, 'lps'),
	(611162, 129, '2014-04-01 00:27:12.000000', 'consum', 0.0220, 'lps'),
	(611163, 129, '2014-04-01 00:27:13.000000', 'consum', 0.0210, 'lps'),
	(611164, 129, '2014-04-01 00:27:14.000000', 'consum', 0.0226, 'lps'),
	(611165, 129, '2014-04-01 00:27:15.000000', 'consum', 0.0218, 'lps'),
	(611166, 129, '2014-04-01 00:27:16.000000', 'consum', 0.0228, 'lps'),
	(611167, 129, '2014-04-01 00:27:17.000000', 'consum', 0.0227, 'lps'),
	(611168, 129, '2014-04-01 00:27:18.000000', 'consum', 0.0218, 'lps'),
	(611169, 129, '2014-04-01 00:27:19.000000', 'consum', 0.0223, 'lps'),
	(611170, 129, '2014-04-01 00:27:20.000000', 'consum', 0.0229, 'lps'),
	(611171, 129, '2014-04-01 00:27:21.000000', 'consum', 0.0217, 'lps'),
	(611172, 129, '2014-04-01 00:27:22.000000', 'consum', 0.0212, 'lps'),
	(611173, 129, '2014-04-01 00:27:23.000000', 'consum', 0.0222, 'lps'),
	(611174, 129, '2014-04-01 00:27:24.000000', 'consum', 0.0219, 'lps'),
	(611175, 129, '2014-04-01 00:27:25.000000', 'consum', 0.0217, 'lps'),
	(611176, 129, '2014-04-01 00:27:26.000000', 'consum', 0.0221, 'lps'),
	(611177, 129, '2014-04-01 00:27:27.000000', 'consum', 0.0218, 'lps'),
	(611178, 129, '2014-04-01 00:27:28.000000', 'consum', 0.0220, 'lps'),
	(611179, 129, '2014-04-01 00:27:29.000000', 'consum', 0.0212, 'lps'),
	(611180, 129, '2014-04-01 00:27:30.000000', 'consum', 0.0214, 'lps'),
	(611181, 129, '2014-04-01 00:27:31.000000', 'consum', 0.0227, 'lps'),
	(611182, 129, '2014-04-01 00:27:32.000000', 'consum', 0.0233, 'lps'),
	(611183, 129, '2014-04-01 00:27:33.000000', 'consum', 0.0227, 'lps'),
	(611184, 129, '2014-04-01 00:27:34.000000', 'consum', 0.0225, 'lps'),
	(611185, 129, '2014-04-01 00:27:35.000000', 'consum', 0.0212, 'lps'),
	(611186, 129, '2014-04-01 00:27:36.000000', 'consum', 0.0223, 'lps'),
	(611187, 129, '2014-04-01 00:27:37.000000', 'consum', 0.0221, 'lps'),
	(611188, 129, '2014-04-01 00:27:38.000000', 'consum', 0.0229, 'lps'),
	(611189, 129, '2014-04-01 00:27:39.000000', 'consum', 0.0223, 'lps'),
	(611190, 129, '2014-04-01 00:27:40.000000', 'consum', 0.0220, 'lps'),
	(611191, 129, '2014-04-01 00:27:41.000000', 'consum', 0.0220, 'lps'),
	(611192, 129, '2014-04-01 00:27:42.000000', 'consum', 0.0232, 'lps'),
	(611193, 129, '2014-04-01 00:27:43.000000', 'consum', 0.0217, 'lps'),
	(611194, 129, '2014-04-01 00:27:44.000000', 'consum', 0.0229, 'lps'),
	(611195, 129, '2014-04-01 00:27:45.000000', 'consum', 0.0214, 'lps'),
	(611196, 129, '2014-04-01 00:27:46.000000', 'consum', 0.0219, 'lps'),
	(611197, 129, '2014-04-01 00:27:47.000000', 'consum', 0.0219, 'lps'),
	(611198, 129, '2014-04-01 00:27:48.000000', 'consum', 0.0231, 'lps'),
	(611199, 129, '2014-04-01 00:27:49.000000', 'consum', 0.0216, 'lps'),
	(611200, 129, '2014-04-01 00:27:50.000000', 'consum', 0.0224, 'lps'),
	(611201, 129, '2014-04-01 00:27:51.000000', 'consum', 0.0217, 'lps'),
	(611202, 129, '2014-04-01 00:27:52.000000', 'consum', 0.0226, 'lps'),
	(611203, 129, '2014-04-01 00:27:53.000000', 'consum', 0.0224, 'lps'),
	(611204, 129, '2014-04-01 00:27:54.000000', 'consum', 0.0229, 'lps'),
	(611205, 129, '2014-04-01 00:27:55.000000', 'consum', 0.0218, 'lps'),
	(611206, 129, '2014-04-01 00:27:56.000000', 'consum', 0.0216, 'lps'),
	(611207, 129, '2014-04-01 00:27:57.000000', 'consum', 0.0217, 'lps'),
	(611208, 129, '2014-04-01 00:27:58.000000', 'consum', 0.0226, 'lps'),
	(611209, 129, '2014-04-01 00:27:59.000000', 'consum', 0.0223, 'lps'),
	(611210, 129, '2014-04-01 00:28:00.000000', 'consum', 0.0226, 'lps'),
	(611211, 129, '2014-04-01 00:28:01.000000', 'consum', 0.0229, 'lps'),
	(611212, 129, '2014-04-01 00:28:02.000000', 'consum', 0.0232, 'lps'),
	(611213, 129, '2014-04-01 00:28:03.000000', 'consum', 0.0216, 'lps'),
	(611214, 129, '2014-04-01 00:28:04.000000', 'consum', 0.0224, 'lps'),
	(611215, 129, '2014-04-01 00:28:05.000000', 'consum', 0.0213, 'lps'),
	(611216, 129, '2014-04-01 00:28:06.000000', 'consum', 0.0230, 'lps'),
	(611217, 129, '2014-04-01 00:28:07.000000', 'consum', 0.0231, 'lps'),
	(611218, 129, '2014-04-01 00:28:08.000000', 'consum', 0.0229, 'lps'),
	(611219, 129, '2014-04-01 00:28:09.000000', 'consum', 0.0222, 'lps'),
	(611220, 129, '2014-04-01 00:28:10.000000', 'consum', 0.0211, 'lps'),
	(611221, 129, '2014-04-01 00:28:11.000000', 'consum', 0.0227, 'lps'),
	(611222, 129, '2014-04-01 00:28:12.000000', 'consum', 0.0223, 'lps'),
	(611223, 129, '2014-04-01 00:28:13.000000', 'consum', 0.0225, 'lps'),
	(611224, 129, '2014-04-01 00:28:14.000000', 'consum', 0.0221, 'lps'),
	(611225, 129, '2014-04-01 00:28:15.000000', 'consum', 0.0221, 'lps'),
	(611226, 129, '2014-04-01 00:28:16.000000', 'consum', 0.0232, 'lps'),
	(611227, 129, '2014-04-01 00:28:17.000000', 'consum', 0.0215, 'lps'),
	(611228, 129, '2014-04-01 00:28:18.000000', 'consum', 0.0219, 'lps'),
	(611229, 129, '2014-04-01 00:28:19.000000', 'consum', 0.0215, 'lps'),
	(611230, 129, '2014-04-01 00:28:20.000000', 'consum', 0.0210, 'lps'),
	(611231, 129, '2014-04-01 00:28:21.000000', 'consum', 0.0220, 'lps'),
	(611232, 129, '2014-04-01 00:28:22.000000', 'consum', 0.0212, 'lps'),
	(611233, 129, '2014-04-01 00:28:23.000000', 'consum', 0.0215, 'lps'),
	(611234, 129, '2014-04-01 00:28:24.000000', 'consum', 0.0229, 'lps'),
	(611235, 129, '2014-04-01 00:28:25.000000', 'consum', 0.0220, 'lps'),
	(611236, 129, '2014-04-01 00:28:26.000000', 'consum', 0.0226, 'lps'),
	(611237, 129, '2014-04-01 00:28:27.000000', 'consum', 0.0211, 'lps'),
	(611238, 129, '2014-04-01 00:28:28.000000', 'consum', 0.0217, 'lps'),
	(611239, 129, '2014-04-01 00:28:29.000000', 'consum', 0.0218, 'lps'),
	(611240, 129, '2014-04-01 00:28:30.000000', 'consum', 0.0230, 'lps'),
	(611241, 129, '2014-04-01 00:28:31.000000', 'consum', 0.0216, 'lps'),
	(611242, 129, '2014-04-01 00:28:32.000000', 'consum', 0.0227, 'lps'),
	(611243, 129, '2014-04-01 00:28:33.000000', 'consum', 0.0231, 'lps'),
	(611244, 129, '2014-04-01 00:28:34.000000', 'consum', 0.0214, 'lps'),
	(611245, 129, '2014-04-01 00:28:35.000000', 'consum', 0.0215, 'lps'),
	(611246, 129, '2014-04-01 00:28:36.000000', 'consum', 0.0226, 'lps'),
	(611247, 129, '2014-04-01 00:28:37.000000', 'consum', 0.0226, 'lps'),
	(611248, 129, '2014-04-01 00:28:38.000000', 'consum', 0.0219, 'lps'),
	(611249, 129, '2014-04-01 00:28:39.000000', 'consum', 0.0233, 'lps'),
	(611250, 129, '2014-04-01 00:28:40.000000', 'consum', 0.0226, 'lps'),
	(611251, 129, '2014-04-01 00:28:41.000000', 'consum', 0.0222, 'lps'),
	(611252, 129, '2014-04-01 00:28:42.000000', 'consum', 0.0221, 'lps'),
	(611253, 129, '2014-04-01 00:28:43.000000', 'consum', 0.0232, 'lps'),
	(611254, 129, '2014-04-01 00:28:44.000000', 'consum', 0.0212, 'lps'),
	(611255, 129, '2014-04-01 00:28:45.000000', 'consum', 0.0229, 'lps'),
	(611256, 129, '2014-04-01 00:28:46.000000', 'consum', 0.0228, 'lps'),
	(611257, 129, '2014-04-01 00:28:47.000000', 'consum', 0.0220, 'lps'),
	(611258, 129, '2014-04-01 00:28:48.000000', 'consum', 0.0228, 'lps'),
	(611259, 129, '2014-04-01 00:28:49.000000', 'consum', 0.0224, 'lps'),
	(611260, 129, '2014-04-01 00:28:50.000000', 'consum', 0.0225, 'lps'),
	(611261, 129, '2014-04-01 00:28:51.000000', 'consum', 0.0219, 'lps'),
	(611262, 129, '2014-04-01 00:28:52.000000', 'consum', 0.0213, 'lps'),
	(611263, 129, '2014-04-01 00:28:53.000000', 'consum', 0.0223, 'lps'),
	(611264, 129, '2014-04-01 00:28:54.000000', 'consum', 0.0218, 'lps'),
	(611265, 129, '2014-04-01 00:28:55.000000', 'consum', 0.0212, 'lps'),
	(611266, 129, '2014-04-01 00:28:56.000000', 'consum', 0.0219, 'lps'),
	(611267, 129, '2014-04-01 00:28:57.000000', 'consum', 0.0226, 'lps'),
	(611268, 129, '2014-04-01 00:28:58.000000', 'consum', 0.0216, 'lps'),
	(611269, 129, '2014-04-01 00:28:59.000000', 'consum', 0.0216, 'lps'),
	(611270, 129, '2014-04-01 00:29:00.000000', 'consum', 0.0224, 'lps'),
	(611271, 129, '2014-04-01 00:29:01.000000', 'consum', 0.0212, 'lps'),
	(611272, 129, '2014-04-01 00:29:02.000000', 'consum', 0.0227, 'lps'),
	(611273, 129, '2014-04-01 00:29:03.000000', 'consum', 0.0216, 'lps'),
	(611274, 129, '2014-04-01 00:29:04.000000', 'consum', 0.0216, 'lps'),
	(611275, 129, '2014-04-01 00:29:05.000000', 'consum', 0.0222, 'lps'),
	(611276, 129, '2014-04-01 00:29:06.000000', 'consum', 0.0226, 'lps'),
	(611277, 129, '2014-04-01 00:29:07.000000', 'consum', 0.0210, 'lps'),
	(611278, 129, '2014-04-01 00:29:08.000000', 'consum', 0.0210, 'lps'),
	(611279, 129, '2014-04-01 00:29:09.000000', 'consum', 0.0210, 'lps'),
	(611280, 129, '2014-04-01 00:29:10.000000', 'consum', 0.0211, 'lps'),
	(611281, 129, '2014-04-01 00:29:11.000000', 'consum', 0.0214, 'lps'),
	(611282, 129, '2014-04-01 00:29:12.000000', 'consum', 0.0229, 'lps'),
	(611283, 129, '2014-04-01 00:29:13.000000', 'consum', 0.0221, 'lps'),
	(611284, 129, '2014-04-01 00:29:14.000000', 'consum', 0.0231, 'lps'),
	(611285, 129, '2014-04-01 00:29:15.000000', 'consum', 0.0210, 'lps'),
	(611286, 129, '2014-04-01 00:29:16.000000', 'consum', 0.0220, 'lps'),
	(611287, 129, '2014-04-01 00:29:17.000000', 'consum', 0.0214, 'lps'),
	(611288, 129, '2014-04-01 00:29:18.000000', 'consum', 0.0225, 'lps'),
	(611289, 129, '2014-04-01 00:29:19.000000', 'consum', 0.0226, 'lps'),
	(611290, 129, '2014-04-01 00:29:20.000000', 'consum', 0.0221, 'lps'),
	(611291, 129, '2014-04-01 00:29:21.000000', 'consum', 0.0215, 'lps'),
	(611292, 129, '2014-04-01 00:29:22.000000', 'consum', 0.0229, 'lps'),
	(611293, 129, '2014-04-01 00:29:23.000000', 'consum', 0.0220, 'lps'),
	(611294, 129, '2014-04-01 00:29:24.000000', 'consum', 0.0225, 'lps'),
	(611295, 129, '2014-04-01 00:29:25.000000', 'consum', 0.0232, 'lps'),
	(611296, 129, '2014-04-01 00:29:26.000000', 'consum', 0.0229, 'lps'),
	(611297, 129, '2014-04-01 00:29:27.000000', 'consum', 0.0215, 'lps'),
	(611298, 129, '2014-04-01 00:29:28.000000', 'consum', 0.0228, 'lps'),
	(611299, 129, '2014-04-01 00:29:29.000000', 'consum', 0.0213, 'lps'),
	(611300, 129, '2014-04-01 00:29:30.000000', 'consum', 0.0218, 'lps'),
	(611301, 129, '2014-04-01 00:29:31.000000', 'consum', 0.0219, 'lps'),
	(611302, 129, '2014-04-01 00:29:32.000000', 'consum', 0.0231, 'lps'),
	(611303, 129, '2014-04-01 00:29:33.000000', 'consum', 0.0215, 'lps'),
	(611304, 129, '2014-04-01 00:29:34.000000', 'consum', 0.0222, 'lps'),
	(611305, 129, '2014-04-01 00:29:35.000000', 'consum', 0.0233, 'lps'),
	(611306, 129, '2014-04-01 00:29:36.000000', 'consum', 0.0216, 'lps'),
	(611307, 129, '2014-04-01 00:29:37.000000', 'consum', 0.0222, 'lps'),
	(611308, 129, '2014-04-01 00:29:38.000000', 'consum', 0.0225, 'lps'),
	(611309, 129, '2014-04-01 00:29:39.000000', 'consum', 0.0229, 'lps'),
	(611310, 129, '2014-04-01 00:29:40.000000', 'consum', 0.0210, 'lps'),
	(611311, 129, '2014-04-01 00:29:41.000000', 'consum', 0.0228, 'lps'),
	(611312, 129, '2014-04-01 00:29:42.000000', 'consum', 0.0226, 'lps'),
	(611313, 129, '2014-04-01 00:29:43.000000', 'consum', 0.0214, 'lps'),
	(611314, 129, '2014-04-01 00:29:44.000000', 'consum', 0.0230, 'lps'),
	(611315, 129, '2014-04-01 00:29:45.000000', 'consum', 0.0228, 'lps'),
	(611316, 129, '2014-04-01 00:29:46.000000', 'consum', 0.0213, 'lps'),
	(611317, 129, '2014-04-01 00:29:47.000000', 'consum', 0.0223, 'lps'),
	(611318, 129, '2014-04-01 00:29:48.000000', 'consum', 0.0216, 'lps'),
	(611319, 129, '2014-04-01 00:29:49.000000', 'consum', 0.0225, 'lps'),
	(611320, 129, '2014-04-01 00:29:50.000000', 'consum', 0.0223, 'lps'),
	(611321, 129, '2014-04-01 00:29:51.000000', 'consum', 0.0227, 'lps'),
	(611322, 129, '2014-04-01 00:29:52.000000', 'consum', 0.0233, 'lps'),
	(611323, 129, '2014-04-01 00:29:53.000000', 'consum', 0.0225, 'lps'),
	(611324, 129, '2014-04-01 00:29:54.000000', 'consum', 0.0219, 'lps'),
	(611325, 129, '2014-04-01 00:29:55.000000', 'consum', 0.0233, 'lps'),
	(611326, 129, '2014-04-01 00:29:56.000000', 'consum', 0.0226, 'lps'),
	(611327, 129, '2014-04-01 00:29:57.000000', 'consum', 0.0223, 'lps'),
	(611328, 129, '2014-04-01 00:29:58.000000', 'consum', 0.0227, 'lps'),
	(611329, 129, '2014-04-01 00:29:59.000000', 'consum', 0.0231, 'lps'),
	(611330, 129, '2014-04-01 00:30:00.000000', 'consum', 0.0219, 'lps'),
	(611331, 129, '2014-04-01 00:30:01.000000', 'consum', 0.0216, 'lps'),
	(611332, 129, '2014-04-01 00:30:02.000000', 'consum', 0.0213, 'lps'),
	(611333, 129, '2014-04-01 00:30:03.000000', 'consum', 0.0232, 'lps'),
	(611334, 129, '2014-04-01 00:30:04.000000', 'consum', 0.0216, 'lps'),
	(611335, 129, '2014-04-01 00:30:05.000000', 'consum', 0.0221, 'lps'),
	(611336, 129, '2014-04-01 00:30:06.000000', 'consum', 0.0222, 'lps'),
	(611337, 129, '2014-04-01 00:30:07.000000', 'consum', 0.0216, 'lps'),
	(611338, 129, '2014-04-01 00:30:08.000000', 'consum', 0.0227, 'lps'),
	(611339, 129, '2014-04-01 00:30:09.000000', 'consum', 0.0228, 'lps'),
	(611340, 129, '2014-04-01 00:30:10.000000', 'consum', 0.0228, 'lps'),
	(611341, 129, '2014-04-01 00:30:11.000000', 'consum', 0.0221, 'lps'),
	(611342, 129, '2014-04-01 00:30:12.000000', 'consum', 0.0210, 'lps'),
	(611343, 129, '2014-04-01 00:30:13.000000', 'consum', 0.0227, 'lps'),
	(611344, 129, '2014-04-01 00:30:14.000000', 'consum', 0.0222, 'lps'),
	(611345, 129, '2014-04-01 00:30:15.000000', 'consum', 0.0221, 'lps'),
	(611346, 129, '2014-04-01 00:30:16.000000', 'consum', 0.0231, 'lps'),
	(611347, 129, '2014-04-01 00:30:17.000000', 'consum', 0.0231, 'lps'),
	(611348, 129, '2014-04-01 00:30:18.000000', 'consum', 0.0231, 'lps'),
	(611349, 129, '2014-04-01 00:30:19.000000', 'consum', 0.0230, 'lps'),
	(611350, 129, '2014-04-01 00:30:20.000000', 'consum', 0.0221, 'lps'),
	(611351, 129, '2014-04-01 00:30:21.000000', 'consum', 0.0230, 'lps'),
	(611352, 129, '2014-04-01 00:30:22.000000', 'consum', 0.0231, 'lps'),
	(611353, 129, '2014-04-01 00:30:23.000000', 'consum', 0.0232, 'lps'),
	(611354, 129, '2014-04-01 00:30:24.000000', 'consum', 0.0233, 'lps'),
	(611355, 129, '2014-04-01 00:30:25.000000', 'consum', 0.0210, 'lps'),
	(611356, 129, '2014-04-01 00:30:26.000000', 'consum', 0.0212, 'lps'),
	(611357, 129, '2014-04-01 00:30:27.000000', 'consum', 0.0224, 'lps'),
	(611358, 129, '2014-04-01 00:30:28.000000', 'consum', 0.0224, 'lps'),
	(611359, 129, '2014-04-01 00:30:29.000000', 'consum', 0.0216, 'lps'),
	(611360, 129, '2014-04-01 00:30:30.000000', 'consum', 0.0220, 'lps'),
	(611361, 129, '2014-04-01 00:30:31.000000', 'consum', 0.0220, 'lps'),
	(611362, 129, '2014-04-01 00:30:32.000000', 'consum', 0.0230, 'lps'),
	(611363, 129, '2014-04-01 00:30:33.000000', 'consum', 0.0231, 'lps'),
	(611364, 129, '2014-04-01 00:30:34.000000', 'consum', 0.0232, 'lps'),
	(611365, 129, '2014-04-01 00:30:35.000000', 'consum', 0.0211, 'lps'),
	(611366, 129, '2014-04-01 00:30:36.000000', 'consum', 0.0222, 'lps'),
	(611367, 129, '2014-04-01 00:30:37.000000', 'consum', 0.0218, 'lps'),
	(611368, 129, '2014-04-01 00:30:38.000000', 'consum', 0.0217, 'lps'),
	(611369, 129, '2014-04-01 00:30:39.000000', 'consum', 0.0218, 'lps'),
	(611370, 129, '2014-04-01 00:30:40.000000', 'consum', 0.0231, 'lps'),
	(611371, 129, '2014-04-01 00:30:41.000000', 'consum', 0.0218, 'lps'),
	(611372, 129, '2014-04-01 00:30:42.000000', 'consum', 0.0213, 'lps'),
	(611373, 129, '2014-04-01 00:30:43.000000', 'consum', 0.0227, 'lps'),
	(611374, 129, '2014-04-01 00:30:44.000000', 'consum', 0.0214, 'lps'),
	(611375, 129, '2014-04-01 00:30:45.000000', 'consum', 0.0226, 'lps'),
	(611376, 129, '2014-04-01 00:30:46.000000', 'consum', 0.0233, 'lps'),
	(611377, 129, '2014-04-01 00:30:47.000000', 'consum', 0.0227, 'lps'),
	(611378, 129, '2014-04-01 00:30:48.000000', 'consum', 0.0229, 'lps'),
	(611379, 129, '2014-04-01 00:30:49.000000', 'consum', 0.0228, 'lps'),
	(611380, 129, '2014-04-01 00:30:50.000000', 'consum', 0.0222, 'lps'),
	(611381, 129, '2014-04-01 00:30:51.000000', 'consum', 0.0213, 'lps'),
	(611382, 129, '2014-04-01 00:30:52.000000', 'consum', 0.0217, 'lps'),
	(611383, 129, '2014-04-01 00:30:53.000000', 'consum', 0.0210, 'lps'),
	(611384, 129, '2014-04-01 00:30:54.000000', 'consum', 0.0213, 'lps'),
	(611385, 129, '2014-04-01 00:30:55.000000', 'consum', 0.0227, 'lps'),
	(611386, 129, '2014-04-01 00:30:56.000000', 'consum', 0.0215, 'lps'),
	(611387, 129, '2014-04-01 00:30:57.000000', 'consum', 0.0233, 'lps'),
	(611388, 129, '2014-04-01 00:30:58.000000', 'consum', 0.0214, 'lps'),
	(611389, 129, '2014-04-01 00:30:59.000000', 'consum', 0.0231, 'lps'),
	(611390, 129, '2014-04-01 00:31:00.000000', 'consum', 0.0211, 'lps'),
	(611391, 129, '2014-04-01 00:31:01.000000', 'consum', 0.0223, 'lps'),
	(611392, 129, '2014-04-01 00:31:02.000000', 'consum', 0.0224, 'lps'),
	(611393, 129, '2014-04-01 00:31:03.000000', 'consum', 0.0220, 'lps'),
	(611394, 129, '2014-04-01 00:31:04.000000', 'consum', 0.0216, 'lps'),
	(611395, 129, '2014-04-01 00:31:05.000000', 'consum', 0.0233, 'lps'),
	(611396, 129, '2014-04-01 00:31:06.000000', 'consum', 0.0214, 'lps'),
	(611397, 129, '2014-04-01 00:31:07.000000', 'consum', 0.0210, 'lps'),
	(611398, 129, '2014-04-01 00:31:08.000000', 'consum', 0.0221, 'lps'),
	(611399, 129, '2014-04-01 00:31:09.000000', 'consum', 0.0218, 'lps'),
	(611400, 129, '2014-04-01 00:31:10.000000', 'consum', 0.0216, 'lps'),
	(611401, 129, '2014-04-01 00:31:11.000000', 'consum', 0.0216, 'lps'),
	(611402, 129, '2014-04-01 00:31:12.000000', 'consum', 0.0225, 'lps'),
	(611403, 129, '2014-04-01 00:31:13.000000', 'consum', 0.0218, 'lps'),
	(611404, 129, '2014-04-01 00:31:14.000000', 'consum', 0.0230, 'lps'),
	(611405, 129, '2014-04-01 00:31:15.000000', 'consum', 0.0214, 'lps'),
	(611406, 129, '2014-04-01 00:31:16.000000', 'consum', 0.0219, 'lps'),
	(611407, 129, '2014-04-01 00:31:17.000000', 'consum', 0.0219, 'lps'),
	(611408, 129, '2014-04-01 00:31:18.000000', 'consum', 0.0227, 'lps'),
	(611409, 129, '2014-04-01 00:31:19.000000', 'consum', 0.0221, 'lps'),
	(611410, 129, '2014-04-01 00:31:20.000000', 'consum', 0.0214, 'lps'),
	(611411, 129, '2014-04-01 00:31:21.000000', 'consum', 0.0222, 'lps'),
	(611412, 129, '2014-04-01 00:31:22.000000', 'consum', 0.0212, 'lps'),
	(611413, 129, '2014-04-01 00:31:23.000000', 'consum', 0.0230, 'lps'),
	(611414, 129, '2014-04-01 00:31:24.000000', 'consum', 0.0232, 'lps'),
	(611415, 129, '2014-04-01 00:31:25.000000', 'consum', 0.0212, 'lps'),
	(611416, 129, '2014-04-01 00:31:26.000000', 'consum', 0.0228, 'lps'),
	(611417, 129, '2014-04-01 00:31:27.000000', 'consum', 0.0224, 'lps'),
	(611418, 129, '2014-04-01 00:31:28.000000', 'consum', 0.0225, 'lps'),
	(611419, 129, '2014-04-01 00:31:29.000000', 'consum', 0.0219, 'lps'),
	(611420, 129, '2014-04-01 00:31:30.000000', 'consum', 0.0211, 'lps'),
	(611421, 129, '2014-04-01 00:31:31.000000', 'consum', 0.0210, 'lps'),
	(611422, 129, '2014-04-01 00:31:32.000000', 'consum', 0.0211, 'lps'),
	(611423, 129, '2014-04-01 00:31:33.000000', 'consum', 0.0215, 'lps'),
	(611424, 129, '2014-04-01 00:31:34.000000', 'consum', 0.0230, 'lps'),
	(611425, 129, '2014-04-01 00:31:35.000000', 'consum', 0.0226, 'lps'),
	(611426, 129, '2014-04-01 00:31:36.000000', 'consum', 0.0228, 'lps'),
	(611427, 129, '2014-04-01 00:31:37.000000', 'consum', 0.0229, 'lps'),
	(611428, 129, '2014-04-01 00:31:38.000000', 'consum', 0.0230, 'lps'),
	(611429, 129, '2014-04-01 00:31:39.000000', 'consum', 0.0226, 'lps'),
	(611430, 129, '2014-04-01 00:31:40.000000', 'consum', 0.0210, 'lps'),
	(611431, 129, '2014-04-01 00:31:41.000000', 'consum', 0.0233, 'lps'),
	(611432, 129, '2014-04-01 00:31:42.000000', 'consum', 0.0231, 'lps'),
	(611433, 129, '2014-04-01 00:31:43.000000', 'consum', 0.0221, 'lps'),
	(611434, 129, '2014-04-01 00:31:44.000000', 'consum', 0.0226, 'lps'),
	(611435, 129, '2014-04-01 00:31:45.000000', 'consum', 0.0233, 'lps'),
	(611436, 129, '2014-04-01 00:31:46.000000', 'consum', 0.0230, 'lps'),
	(611437, 129, '2014-04-01 00:31:47.000000', 'consum', 0.0218, 'lps'),
	(611438, 129, '2014-04-01 00:31:48.000000', 'consum', 0.0216, 'lps'),
	(611439, 129, '2014-04-01 00:31:49.000000', 'consum', 0.0214, 'lps'),
	(611440, 129, '2014-04-01 00:31:50.000000', 'consum', 0.0212, 'lps'),
	(611441, 129, '2014-04-01 00:31:51.000000', 'consum', 0.0210, 'lps'),
	(611442, 129, '2014-04-01 00:31:52.000000', 'consum', 0.0229, 'lps'),
	(611443, 129, '2014-04-01 00:31:53.000000', 'consum', 0.0232, 'lps'),
	(611444, 129, '2014-04-01 00:31:54.000000', 'consum', 0.0215, 'lps'),
	(611445, 129, '2014-04-01 00:31:55.000000', 'consum', 0.0218, 'lps'),
	(611446, 129, '2014-04-01 00:31:56.000000', 'consum', 0.0211, 'lps'),
	(611447, 129, '2014-04-01 00:31:57.000000', 'consum', 0.0216, 'lps'),
	(611448, 129, '2014-04-01 00:31:58.000000', 'consum', 0.0214, 'lps'),
	(611449, 129, '2014-04-01 00:31:59.000000', 'consum', 0.0211, 'lps'),
	(611450, 129, '2014-04-01 00:32:00.000000', 'consum', 0.0229, 'lps'),
	(611451, 129, '2014-04-01 00:32:01.000000', 'consum', 0.0231, 'lps'),
	(611452, 129, '2014-04-01 00:32:02.000000', 'consum', 0.0233, 'lps'),
	(611453, 129, '2014-04-01 00:32:03.000000', 'consum', 0.0213, 'lps'),
	(611454, 129, '2014-04-01 00:32:04.000000', 'consum', 0.0230, 'lps'),
	(611455, 129, '2014-04-01 00:32:05.000000', 'consum', 0.0229, 'lps'),
	(611456, 129, '2014-04-01 00:32:06.000000', 'consum', 0.0224, 'lps'),
	(611457, 129, '2014-04-01 00:32:07.000000', 'consum', 0.0221, 'lps'),
	(611458, 129, '2014-04-01 00:32:08.000000', 'consum', 0.0222, 'lps'),
	(611459, 129, '2014-04-01 00:32:09.000000', 'consum', 0.0217, 'lps'),
	(611460, 129, '2014-04-01 00:32:10.000000', 'consum', 0.0233, 'lps'),
	(611461, 129, '2014-04-01 00:32:11.000000', 'consum', 0.0230, 'lps'),
	(611462, 129, '2014-04-01 00:32:12.000000', 'consum', 0.0219, 'lps'),
	(611463, 129, '2014-04-01 00:32:13.000000', 'consum', 0.0219, 'lps'),
	(611464, 129, '2014-04-01 00:32:14.000000', 'consum', 0.0227, 'lps'),
	(611465, 129, '2014-04-01 00:32:15.000000', 'consum', 0.0221, 'lps'),
	(611466, 129, '2014-04-01 00:32:16.000000', 'consum', 0.0217, 'lps'),
	(611467, 129, '2014-04-01 00:32:17.000000', 'consum', 0.0233, 'lps'),
	(611468, 129, '2014-04-01 00:32:18.000000', 'consum', 0.0212, 'lps'),
	(611469, 129, '2014-04-01 00:32:19.000000', 'consum', 0.0223, 'lps'),
	(611470, 129, '2014-04-01 00:32:20.000000', 'consum', 0.0219, 'lps'),
	(611471, 129, '2014-04-01 00:32:21.000000', 'consum', 0.0218, 'lps'),
	(611472, 129, '2014-04-01 00:32:22.000000', 'consum', 0.0223, 'lps'),
	(611473, 129, '2014-04-01 00:32:23.000000', 'consum', 0.0227, 'lps'),
	(611474, 129, '2014-04-01 00:32:24.000000', 'consum', 0.0211, 'lps'),
	(611475, 129, '2014-04-01 00:32:25.000000', 'consum', 0.0211, 'lps'),
	(611476, 129, '2014-04-01 00:32:26.000000', 'consum', 0.0211, 'lps'),
	(611477, 129, '2014-04-01 00:32:27.000000', 'consum', 0.0212, 'lps'),
	(611478, 129, '2014-04-01 00:32:28.000000', 'consum', 0.0220, 'lps'),
	(611479, 129, '2014-04-01 00:32:29.000000', 'consum', 0.0228, 'lps'),
	(611480, 129, '2014-04-01 00:32:30.000000', 'consum', 0.0223, 'lps'),
	(611481, 129, '2014-04-01 00:32:31.000000', 'consum', 0.0221, 'lps'),
	(611482, 129, '2014-04-01 00:32:32.000000', 'consum', 0.0229, 'lps'),
	(611483, 129, '2014-04-01 00:32:33.000000', 'consum', 0.0223, 'lps'),
	(611484, 129, '2014-04-01 00:32:34.000000', 'consum', 0.0218, 'lps'),
	(611485, 129, '2014-04-01 00:32:35.000000', 'consum', 0.0212, 'lps'),
	(611486, 129, '2014-04-01 00:32:36.000000', 'consum', 0.0222, 'lps'),
	(611487, 129, '2014-04-01 00:32:37.000000', 'consum', 0.0214, 'lps'),
	(611488, 129, '2014-04-01 00:32:38.000000', 'consum', 0.0220, 'lps'),
	(611489, 129, '2014-04-01 00:32:39.000000', 'consum', 0.0224, 'lps'),
	(611490, 129, '2014-04-01 00:32:40.000000', 'consum', 0.0227, 'lps'),
	(611491, 129, '2014-04-01 00:32:41.000000', 'consum', 0.0228, 'lps'),
	(611492, 129, '2014-04-01 00:32:42.000000', 'consum', 0.0227, 'lps'),
	(611493, 129, '2014-04-01 00:32:43.000000', 'consum', 0.0218, 'lps'),
	(611494, 129, '2014-04-01 00:32:44.000000', 'consum', 0.0222, 'lps'),
	(611495, 129, '2014-04-01 00:32:45.000000', 'consum', 0.0222, 'lps'),
	(611496, 129, '2014-04-01 00:32:46.000000', 'consum', 0.0212, 'lps'),
	(611497, 129, '2014-04-01 00:32:47.000000', 'consum', 0.0231, 'lps'),
	(611498, 129, '2014-04-01 00:32:48.000000', 'consum', 0.0215, 'lps'),
	(611499, 129, '2014-04-01 00:32:49.000000', 'consum', 0.0219, 'lps'),
	(611500, 129, '2014-04-01 00:32:50.000000', 'consum', 0.0218, 'lps'),
	(611501, 129, '2014-04-01 00:32:51.000000', 'consum', 0.0223, 'lps'),
	(611502, 129, '2014-04-01 00:32:52.000000', 'consum', 0.0229, 'lps'),
	(611503, 129, '2014-04-01 00:32:53.000000', 'consum', 0.0218, 'lps'),
	(611504, 129, '2014-04-01 00:32:54.000000', 'consum', 0.0217, 'lps'),
	(611505, 129, '2014-04-01 00:32:55.000000', 'consum', 0.0223, 'lps'),
	(611506, 129, '2014-04-01 00:32:56.000000', 'consum', 0.0230, 'lps'),
	(611507, 129, '2014-04-01 00:32:57.000000', 'consum', 0.0225, 'lps'),
	(611508, 129, '2014-04-01 00:32:58.000000', 'consum', 0.0224, 'lps'),
	(611509, 129, '2014-04-01 00:32:59.000000', 'consum', 0.0210, 'lps'),
	(611510, 129, '2014-04-01 00:33:00.000000', 'consum', 0.0217, 'lps'),
	(611511, 129, '2014-04-01 00:33:01.000000', 'consum', 0.0222, 'lps'),
	(611512, 129, '2014-04-01 00:33:02.000000', 'consum', 0.0227, 'lps'),
	(611513, 129, '2014-04-01 00:33:03.000000', 'consum', 0.0212, 'lps'),
	(611514, 129, '2014-04-01 00:33:04.000000', 'consum', 0.0214, 'lps'),
	(611515, 129, '2014-04-01 00:33:05.000000', 'consum', 0.0228, 'lps'),
	(611516, 129, '2014-04-01 00:33:06.000000', 'consum', 0.0216, 'lps'),
	(611517, 129, '2014-04-01 00:33:07.000000', 'consum', 0.0210, 'lps'),
	(611518, 129, '2014-04-01 00:33:08.000000', 'consum', 0.0216, 'lps'),
	(611519, 129, '2014-04-01 00:33:09.000000', 'consum', 0.0218, 'lps'),
	(611520, 129, '2014-04-01 00:33:10.000000', 'consum', 0.0230, 'lps'),
	(611521, 129, '2014-04-01 00:33:11.000000', 'consum', 0.0214, 'lps'),
	(611522, 129, '2014-04-01 00:33:12.000000', 'consum', 0.0221, 'lps'),
	(611523, 129, '2014-04-01 00:33:13.000000', 'consum', 0.0229, 'lps'),
	(611524, 129, '2014-04-01 00:33:14.000000', 'consum', 0.0226, 'lps'),
	(611525, 129, '2014-04-01 00:33:15.000000', 'consum', 0.0232, 'lps'),
	(611526, 129, '2014-04-01 00:33:16.000000', 'consum', 0.0224, 'lps'),
	(611527, 129, '2014-04-01 00:33:17.000000', 'consum', 0.0214, 'lps'),
	(611528, 129, '2014-04-01 00:33:18.000000', 'consum', 0.0214, 'lps'),
	(611529, 129, '2014-04-01 00:33:19.000000', 'consum', 0.0217, 'lps'),
	(611530, 129, '2014-04-01 00:33:20.000000', 'consum', 0.0211, 'lps'),
	(611531, 129, '2014-04-01 00:33:21.000000', 'consum', 0.0217, 'lps'),
	(611532, 129, '2014-04-01 00:33:22.000000', 'consum', 0.0220, 'lps'),
	(611533, 129, '2014-04-01 00:33:23.000000', 'consum', 0.0217, 'lps'),
	(611534, 129, '2014-04-01 00:33:24.000000', 'consum', 0.0213, 'lps'),
	(611535, 129, '2014-04-01 00:33:25.000000', 'consum', 0.0229, 'lps'),
	(611536, 129, '2014-04-01 00:33:26.000000', 'consum', 0.0227, 'lps'),
	(611537, 129, '2014-04-01 00:33:27.000000', 'consum', 0.0212, 'lps'),
	(611538, 129, '2014-04-01 00:33:28.000000', 'consum', 0.0218, 'lps'),
	(611539, 129, '2014-04-01 00:33:29.000000', 'consum', 0.0219, 'lps'),
	(611540, 129, '2014-04-01 00:33:30.000000', 'consum', 0.0231, 'lps'),
	(611541, 129, '2014-04-01 00:33:31.000000', 'consum', 0.0220, 'lps'),
	(611542, 129, '2014-04-01 00:33:32.000000', 'consum', 0.0219, 'lps'),
	(611543, 129, '2014-04-01 00:33:33.000000', 'consum', 0.0224, 'lps'),
	(611544, 129, '2014-04-01 00:33:34.000000', 'consum', 0.0231, 'lps'),
	(611545, 129, '2014-04-01 00:33:35.000000', 'consum', 0.0226, 'lps'),
	(611546, 129, '2014-04-01 00:33:36.000000', 'consum', 0.0227, 'lps'),
	(611547, 129, '2014-04-01 00:33:37.000000', 'consum', 0.0222, 'lps'),
	(611548, 129, '2014-04-01 00:33:38.000000', 'consum', 0.0219, 'lps'),
	(611549, 129, '2014-04-01 00:33:39.000000', 'consum', 0.0222, 'lps'),
	(611550, 129, '2014-04-01 00:33:40.000000', 'consum', 0.0218, 'lps'),
	(611551, 129, '2014-04-01 00:33:41.000000', 'consum', 0.0216, 'lps'),
	(611552, 129, '2014-04-01 00:33:42.000000', 'consum', 0.0214, 'lps'),
	(611553, 129, '2014-04-01 00:33:43.000000', 'consum', 0.0215, 'lps'),
	(611554, 129, '2014-04-01 00:33:44.000000', 'consum', 0.0222, 'lps'),
	(611555, 129, '2014-04-01 00:33:45.000000', 'consum', 0.0233, 'lps'),
	(611556, 129, '2014-04-01 00:33:46.000000', 'consum', 0.0215, 'lps'),
	(611557, 129, '2014-04-01 00:33:47.000000', 'consum', 0.0216, 'lps'),
	(611558, 129, '2014-04-01 00:33:48.000000', 'consum', 0.0224, 'lps'),
	(611559, 129, '2014-04-01 00:33:49.000000', 'consum', 0.0217, 'lps'),
	(611560, 129, '2014-04-01 00:33:50.000000', 'consum', 0.0228, 'lps'),
	(611561, 129, '2014-04-01 00:33:51.000000', 'consum', 0.0231, 'lps'),
	(611562, 129, '2014-04-01 00:33:52.000000', 'consum', 0.0214, 'lps'),
	(611563, 129, '2014-04-01 00:33:53.000000', 'consum', 0.0215, 'lps'),
	(611564, 129, '2014-04-01 00:33:54.000000', 'consum', 0.0225, 'lps'),
	(611565, 129, '2014-04-01 00:33:55.000000', 'consum', 0.0223, 'lps'),
	(611566, 129, '2014-04-01 00:33:56.000000', 'consum', 0.0229, 'lps'),
	(611567, 129, '2014-04-01 00:33:57.000000', 'consum', 0.0219, 'lps'),
	(611568, 129, '2014-04-01 00:33:58.000000', 'consum', 0.0220, 'lps'),
	(611569, 129, '2014-04-01 00:33:59.000000', 'consum', 0.0212, 'lps'),
	(611570, 129, '2014-04-01 00:34:00.000000', 'consum', 0.0214, 'lps'),
	(611571, 129, '2014-04-01 00:34:01.000000', 'consum', 0.0226, 'lps'),
	(611572, 129, '2014-04-01 00:34:02.000000', 'consum', 0.0230, 'lps'),
	(611573, 129, '2014-04-01 00:34:03.000000', 'consum', 0.0214, 'lps'),
	(611574, 129, '2014-04-01 00:34:04.000000', 'consum', 0.0221, 'lps'),
	(611575, 129, '2014-04-01 00:34:05.000000', 'consum', 0.0226, 'lps'),
	(611576, 129, '2014-04-01 00:34:06.000000', 'consum', 0.0212, 'lps'),
	(611577, 129, '2014-04-01 00:34:07.000000', 'consum', 0.0218, 'lps'),
	(611578, 129, '2014-04-01 00:34:08.000000', 'consum', 0.0220, 'lps'),
	(611579, 129, '2014-04-01 00:34:09.000000', 'consum', 0.0215, 'lps'),
	(611580, 129, '2014-04-01 00:34:10.000000', 'consum', 0.0229, 'lps'),
	(611581, 129, '2014-04-01 00:34:11.000000', 'consum', 0.0218, 'lps'),
	(611582, 129, '2014-04-01 00:34:12.000000', 'consum', 0.0217, 'lps'),
	(611583, 129, '2014-04-01 00:34:13.000000', 'consum', 0.0222, 'lps'),
	(611584, 129, '2014-04-01 00:34:14.000000', 'consum', 0.0225, 'lps'),
	(611585, 129, '2014-04-01 00:34:15.000000', 'consum', 0.0227, 'lps'),
	(611586, 129, '2014-04-01 00:34:16.000000', 'consum', 0.0226, 'lps'),
	(611587, 129, '2014-04-01 00:34:17.000000', 'consum', 0.0215, 'lps'),
	(611588, 129, '2014-04-01 00:34:18.000000', 'consum', 0.0212, 'lps'),
	(611589, 129, '2014-04-01 00:34:19.000000', 'consum', 0.0229, 'lps'),
	(611590, 129, '2014-04-01 00:34:20.000000', 'consum', 0.0228, 'lps'),
	(611591, 129, '2014-04-01 00:34:21.000000', 'consum', 0.0221, 'lps'),
	(611592, 129, '2014-04-01 00:34:22.000000', 'consum', 0.0212, 'lps'),
	(611593, 129, '2014-04-01 00:34:23.000000', 'consum', 0.0210, 'lps'),
	(611594, 129, '2014-04-01 00:34:24.000000', 'consum', 0.0230, 'lps'),
	(611595, 129, '2014-04-01 00:34:25.000000', 'consum', 0.0215, 'lps'),
	(611596, 129, '2014-04-01 00:34:26.000000', 'consum', 0.0224, 'lps'),
	(611597, 129, '2014-04-01 00:34:27.000000', 'consum', 0.0215, 'lps'),
	(611598, 129, '2014-04-01 00:34:28.000000', 'consum', 0.0220, 'lps'),
	(611599, 129, '2014-04-01 00:34:29.000000', 'consum', 0.0221, 'lps'),
	(611600, 129, '2014-04-01 00:34:30.000000', 'consum', 0.0210, 'lps'),
	(611601, 129, '2014-04-01 00:34:31.000000', 'consum', 0.0225, 'lps'),
	(611602, 129, '2014-04-01 00:34:32.000000', 'consum', 0.0215, 'lps'),
	(611603, 129, '2014-04-01 00:34:33.000000', 'consum', 0.0216, 'lps'),
	(611604, 129, '2014-04-01 00:34:34.000000', 'consum', 0.0224, 'lps'),
	(611605, 129, '2014-04-01 00:34:35.000000', 'consum', 0.0214, 'lps'),
	(611606, 129, '2014-04-01 00:34:36.000000', 'consum', 0.0213, 'lps'),
	(611607, 129, '2014-04-01 00:34:37.000000', 'consum', 0.0215, 'lps'),
	(611608, 129, '2014-04-01 00:34:38.000000', 'consum', 0.0224, 'lps'),
	(611609, 129, '2014-04-01 00:34:39.000000', 'consum', 0.0219, 'lps'),
	(611610, 129, '2014-04-01 00:34:40.000000', 'consum', 0.0215, 'lps'),
	(611611, 129, '2014-04-01 00:34:41.000000', 'consum', 0.0232, 'lps'),
	(611612, 129, '2014-04-01 00:34:42.000000', 'consum', 0.0211, 'lps'),
	(611613, 129, '2014-04-01 00:34:43.000000', 'consum', 0.0219, 'lps'),
	(611614, 129, '2014-04-01 00:34:44.000000', 'consum', 0.0229, 'lps'),
	(611615, 129, '2014-04-01 00:34:45.000000', 'consum', 0.0231, 'lps'),
	(611616, 129, '2014-04-01 00:34:46.000000', 'consum', 0.0211, 'lps'),
	(611617, 129, '2014-04-01 00:34:47.000000', 'consum', 0.0224, 'lps'),
	(611618, 129, '2014-04-01 00:34:48.000000', 'consum', 0.0228, 'lps'),
	(611619, 129, '2014-04-01 00:34:49.000000', 'consum', 0.0213, 'lps'),
	(611620, 129, '2014-04-01 00:34:50.000000', 'consum', 0.0217, 'lps'),
	(611621, 129, '2014-04-01 00:34:51.000000', 'consum', 0.0211, 'lps'),
	(611622, 129, '2014-04-01 00:34:52.000000', 'consum', 0.0222, 'lps'),
	(611623, 129, '2014-04-01 00:34:53.000000', 'consum', 0.0219, 'lps'),
	(611624, 129, '2014-04-01 00:34:54.000000', 'consum', 0.0221, 'lps'),
	(611625, 129, '2014-04-01 00:34:55.000000', 'consum', 0.0211, 'lps'),
	(611626, 129, '2014-04-01 00:34:56.000000', 'consum', 0.0233, 'lps'),
	(611627, 129, '2014-04-01 00:34:57.000000', 'consum', 0.0227, 'lps'),
	(611628, 129, '2014-04-01 00:34:58.000000', 'consum', 0.0228, 'lps'),
	(611629, 129, '2014-04-01 00:34:59.000000', 'consum', 0.0223, 'lps'),
	(611630, 129, '2014-04-01 00:35:00.000000', 'consum', 0.0222, 'lps'),
	(611631, 129, '2014-04-01 00:35:01.000000', 'consum', 0.0230, 'lps'),
	(611632, 129, '2014-04-01 00:35:02.000000', 'consum', 0.0228, 'lps'),
	(611633, 129, '2014-04-01 00:35:03.000000', 'consum', 0.0217, 'lps'),
	(611634, 129, '2014-04-01 00:35:04.000000', 'consum', 0.0214, 'lps'),
	(611635, 129, '2014-04-01 00:35:05.000000', 'consum', 0.0233, 'lps'),
	(611636, 129, '2014-04-01 00:35:06.000000', 'consum', 0.0218, 'lps'),
	(611637, 129, '2014-04-01 00:35:07.000000', 'consum', 0.0231, 'lps'),
	(611638, 129, '2014-04-01 00:35:08.000000', 'consum', 0.0217, 'lps'),
	(611639, 129, '2014-04-01 00:35:09.000000', 'consum', 0.0232, 'lps'),
	(611640, 129, '2014-04-01 00:35:10.000000', 'consum', 0.0229, 'lps'),
	(611641, 129, '2014-04-01 00:35:11.000000', 'consum', 0.0215, 'lps'),
	(611642, 129, '2014-04-01 00:35:12.000000', 'consum', 0.0224, 'lps'),
	(611643, 129, '2014-04-01 00:35:13.000000', 'consum', 0.0221, 'lps'),
	(611644, 129, '2014-04-01 00:35:14.000000', 'consum', 0.0220, 'lps'),
	(611645, 129, '2014-04-01 00:35:15.000000', 'consum', 0.0229, 'lps'),
	(611646, 129, '2014-04-01 00:35:16.000000', 'consum', 0.0226, 'lps'),
	(611647, 129, '2014-04-01 00:35:17.000000', 'consum', 0.0233, 'lps'),
	(611648, 129, '2014-04-01 00:35:18.000000', 'consum', 0.0230, 'lps'),
	(611649, 129, '2014-04-01 00:35:19.000000', 'consum', 0.0217, 'lps'),
	(611650, 129, '2014-04-01 00:35:20.000000', 'consum', 0.0211, 'lps'),
	(611651, 129, '2014-04-01 00:35:21.000000', 'consum', 0.0218, 'lps'),
	(611652, 129, '2014-04-01 00:35:22.000000', 'consum', 0.0221, 'lps'),
	(611653, 129, '2014-04-01 00:35:23.000000', 'consum', 0.0220, 'lps'),
	(611654, 129, '2014-04-01 00:35:24.000000', 'consum', 0.0229, 'lps'),
	(611655, 129, '2014-04-01 00:35:25.000000', 'consum', 0.0225, 'lps'),
	(611656, 129, '2014-04-01 00:35:26.000000', 'consum', 0.0227, 'lps'),
	(611657, 129, '2014-04-01 00:35:27.000000', 'consum', 0.0230, 'lps'),
	(611658, 129, '2014-04-01 00:35:28.000000', 'consum', 0.0210, 'lps'),
	(611659, 129, '2014-04-01 00:35:29.000000', 'consum', 0.0222, 'lps'),
	(611660, 129, '2014-04-01 00:35:30.000000', 'consum', 0.0225, 'lps'),
	(611661, 129, '2014-04-01 00:35:31.000000', 'consum', 0.0224, 'lps'),
	(611662, 129, '2014-04-01 00:35:32.000000', 'consum', 0.0210, 'lps'),
	(611663, 129, '2014-04-01 00:35:33.000000', 'consum', 0.0216, 'lps'),
	(611664, 129, '2014-04-01 00:35:34.000000', 'consum', 0.0219, 'lps'),
	(611665, 129, '2014-04-01 00:35:35.000000', 'consum', 0.0214, 'lps'),
	(611666, 129, '2014-04-01 00:35:36.000000', 'consum', 0.0226, 'lps'),
	(611667, 129, '2014-04-01 00:35:37.000000', 'consum', 0.0233, 'lps'),
	(611668, 129, '2014-04-01 00:35:38.000000', 'consum', 0.0226, 'lps'),
	(611669, 129, '2014-04-01 00:35:39.000000', 'consum', 0.0224, 'lps'),
	(611670, 129, '2014-04-01 00:35:40.000000', 'consum', 0.0231, 'lps'),
	(611671, 129, '2014-04-01 00:35:41.000000', 'consum', 0.0227, 'lps'),
	(611672, 129, '2014-04-01 00:35:42.000000', 'consum', 0.0230, 'lps'),
	(611673, 129, '2014-04-01 00:35:43.000000', 'consum', 0.0213, 'lps'),
	(611674, 129, '2014-04-01 00:35:44.000000', 'consum', 0.0214, 'lps'),
	(611675, 129, '2014-04-01 00:35:45.000000', 'consum', 0.0221, 'lps'),
	(611676, 129, '2014-04-01 00:35:46.000000', 'consum', 0.0231, 'lps'),
	(611677, 129, '2014-04-01 00:35:47.000000', 'consum', 0.0232, 'lps'),
	(611678, 129, '2014-04-01 00:35:48.000000', 'consum', 0.0211, 'lps'),
	(611679, 129, '2014-04-01 00:35:49.000000', 'consum', 0.0220, 'lps'),
	(611680, 129, '2014-04-01 00:35:50.000000', 'consum', 0.0210, 'lps'),
	(611681, 129, '2014-04-01 00:35:51.000000', 'consum', 0.0228, 'lps'),
	(611682, 129, '2014-04-01 00:35:52.000000', 'consum', 0.0227, 'lps'),
	(611683, 129, '2014-04-01 00:35:53.000000', 'consum', 0.0219, 'lps'),
	(611684, 129, '2014-04-01 00:35:54.000000', 'consum', 0.0227, 'lps'),
	(611685, 129, '2014-04-01 00:35:55.000000', 'consum', 0.0221, 'lps'),
	(611686, 129, '2014-04-01 00:35:56.000000', 'consum', 0.0213, 'lps'),
	(611687, 129, '2014-04-01 00:35:57.000000', 'consum', 0.0218, 'lps'),
	(611688, 129, '2014-04-01 00:35:58.000000', 'consum', 0.0215, 'lps'),
	(611689, 129, '2014-04-01 00:35:59.000000', 'consum', 0.0215, 'lps'),
	(611690, 129, '2014-04-01 00:36:00.000000', 'consum', 0.0220, 'lps'),
	(611691, 129, '2014-04-01 00:36:01.000000', 'consum', 0.0221, 'lps'),
	(611692, 129, '2014-04-01 00:36:02.000000', 'consum', 0.0211, 'lps'),
	(611693, 129, '2014-04-01 00:36:03.000000', 'consum', 0.0229, 'lps'),
	(611694, 129, '2014-04-01 00:36:04.000000', 'consum', 0.0231, 'lps'),
	(611695, 129, '2014-04-01 00:36:05.000000', 'consum', 0.0211, 'lps'),
	(611696, 129, '2014-04-01 00:36:06.000000', 'consum', 0.0223, 'lps'),
	(611697, 129, '2014-04-01 00:36:07.000000', 'consum', 0.0224, 'lps'),
	(611698, 129, '2014-04-01 00:36:08.000000', 'consum', 0.0219, 'lps'),
	(611699, 129, '2014-04-01 00:36:09.000000', 'consum', 0.0212, 'lps'),
	(611700, 129, '2014-04-01 00:36:10.000000', 'consum', 0.0219, 'lps'),
	(611701, 129, '2014-04-01 00:36:11.000000', 'consum', 0.0224, 'lps'),
	(611702, 129, '2014-04-01 00:36:12.000000', 'consum', 0.0232, 'lps'),
	(611703, 129, '2014-04-01 00:36:13.000000', 'consum', 0.0230, 'lps'),
	(611704, 129, '2014-04-01 00:36:14.000000', 'consum', 0.0219, 'lps'),
	(611705, 129, '2014-04-01 00:36:15.000000', 'consum', 0.0220, 'lps'),
	(611706, 129, '2014-04-01 00:36:16.000000', 'consum', 0.0232, 'lps'),
	(611707, 129, '2014-04-01 00:36:17.000000', 'consum', 0.0220, 'lps'),
	(611708, 129, '2014-04-01 00:36:18.000000', 'consum', 0.0219, 'lps'),
	(611709, 129, '2014-04-01 00:36:19.000000', 'consum', 0.0224, 'lps'),
	(611710, 129, '2014-04-01 00:36:20.000000', 'consum', 0.0231, 'lps'),
	(611711, 129, '2014-04-01 00:36:21.000000', 'consum', 0.0227, 'lps'),
	(611712, 129, '2014-04-01 00:36:22.000000', 'consum', 0.0230, 'lps'),
	(611713, 129, '2014-04-01 00:36:23.000000', 'consum', 0.0214, 'lps'),
	(611714, 129, '2014-04-01 00:36:24.000000', 'consum', 0.0216, 'lps'),
	(611715, 129, '2014-04-01 00:36:25.000000', 'consum', 0.0229, 'lps'),
	(611716, 129, '2014-04-01 00:36:26.000000', 'consum', 0.0215, 'lps'),
	(611717, 129, '2014-04-01 00:36:27.000000', 'consum', 0.0229, 'lps'),
	(611718, 129, '2014-04-01 00:36:28.000000', 'consum', 0.0216, 'lps'),
	(611719, 129, '2014-04-01 00:36:29.000000', 'consum', 0.0233, 'lps'),
	(611720, 129, '2014-04-01 00:36:30.000000', 'consum', 0.0233, 'lps'),
	(611721, 129, '2014-04-01 00:36:31.000000', 'consum', 0.0212, 'lps'),
	(611722, 129, '2014-04-01 00:36:32.000000', 'consum', 0.0221, 'lps'),
	(611723, 129, '2014-04-01 00:36:33.000000', 'consum', 0.0212, 'lps'),
	(611724, 129, '2014-04-01 00:36:34.000000', 'consum', 0.0213, 'lps'),
	(611725, 129, '2014-04-01 00:36:35.000000', 'consum', 0.0219, 'lps'),
	(611726, 129, '2014-04-01 00:36:36.000000', 'consum', 0.0223, 'lps'),
	(611727, 129, '2014-04-01 00:36:37.000000', 'consum', 0.0224, 'lps'),
	(611728, 129, '2014-04-01 00:36:38.000000', 'consum', 0.0219, 'lps'),
	(611729, 129, '2014-04-01 00:36:39.000000', 'consum', 0.0212, 'lps'),
	(611730, 129, '2014-04-01 00:36:40.000000', 'consum', 0.0216, 'lps'),
	(611731, 129, '2014-04-01 00:36:41.000000', 'consum', 0.0214, 'lps'),
	(611732, 129, '2014-04-01 00:36:42.000000', 'consum', 0.0210, 'lps'),
	(611733, 129, '2014-04-01 00:36:43.000000', 'consum', 0.0225, 'lps'),
	(611734, 129, '2014-04-01 00:36:44.000000', 'consum', 0.0213, 'lps'),
	(611735, 129, '2014-04-01 00:36:45.000000', 'consum', 0.0229, 'lps'),
	(611736, 129, '2014-04-01 00:36:46.000000', 'consum', 0.0226, 'lps'),
	(611737, 129, '2014-04-01 00:36:47.000000', 'consum', 0.0230, 'lps'),
	(611738, 129, '2014-04-01 00:36:48.000000', 'consum', 0.0218, 'lps'),
	(611739, 129, '2014-04-01 00:36:49.000000', 'consum', 0.0212, 'lps'),
	(611740, 129, '2014-04-01 00:36:50.000000', 'consum', 0.0221, 'lps'),
	(611741, 129, '2014-04-01 00:36:51.000000', 'consum', 0.0211, 'lps'),
	(611742, 129, '2014-04-01 00:36:52.000000', 'consum', 0.0232, 'lps'),
	(611743, 129, '2014-04-01 00:36:53.000000', 'consum', 0.0223, 'lps'),
	(611744, 129, '2014-04-01 00:36:54.000000', 'consum', 0.0231, 'lps'),
	(611745, 129, '2014-04-01 00:36:55.000000', 'consum', 0.0229, 'lps'),
	(611746, 129, '2014-04-01 00:36:56.000000', 'consum', 0.0218, 'lps'),
	(611747, 129, '2014-04-01 00:36:57.000000', 'consum', 0.0216, 'lps'),
	(611748, 129, '2014-04-01 00:36:58.000000', 'consum', 0.0219, 'lps'),
	(611749, 129, '2014-04-01 00:36:59.000000', 'consum', 0.0211, 'lps'),
	(611750, 129, '2014-04-01 00:37:00.000000', 'consum', 0.0212, 'lps'),
	(611751, 129, '2014-04-01 00:37:01.000000', 'consum', 0.0219, 'lps'),
	(611752, 129, '2014-04-01 00:37:02.000000', 'consum', 0.0226, 'lps'),
	(611753, 129, '2014-04-01 00:37:03.000000', 'consum', 0.0215, 'lps'),
	(611754, 129, '2014-04-01 00:37:04.000000', 'consum', 0.0211, 'lps'),
	(611755, 129, '2014-04-01 00:37:05.000000', 'consum', 0.0226, 'lps'),
	(611756, 129, '2014-04-01 00:37:06.000000', 'consum', 0.0215, 'lps'),
	(611757, 129, '2014-04-01 00:37:07.000000', 'consum', 0.0233, 'lps'),
	(611758, 129, '2014-04-01 00:37:08.000000', 'consum', 0.0217, 'lps'),
	(611759, 129, '2014-04-01 00:37:09.000000', 'consum', 0.0223, 'lps'),
	(611760, 129, '2014-04-01 00:37:10.000000', 'consum', 0.0230, 'lps'),
	(611761, 129, '2014-04-01 00:37:11.000000', 'consum', 0.0223, 'lps'),
	(611762, 129, '2014-04-01 00:37:12.000000', 'consum', 0.0216, 'lps'),
	(611763, 129, '2014-04-01 00:37:13.000000', 'consum', 0.0226, 'lps'),
	(611764, 129, '2014-04-01 00:37:14.000000', 'consum', 0.0224, 'lps'),
	(611765, 129, '2014-04-01 00:37:15.000000', 'consum', 0.0233, 'lps'),
	(611766, 129, '2014-04-01 00:37:16.000000', 'consum', 0.0212, 'lps'),
	(611767, 129, '2014-04-01 00:37:17.000000', 'consum', 0.0224, 'lps'),
	(611768, 129, '2014-04-01 00:37:18.000000', 'consum', 0.0228, 'lps'),
	(611769, 129, '2014-04-01 00:37:19.000000', 'consum', 0.0231, 'lps'),
	(611770, 129, '2014-04-01 00:37:20.000000', 'consum', 0.0216, 'lps'),
	(611771, 129, '2014-04-01 00:37:21.000000', 'consum', 0.0224, 'lps'),
	(611772, 129, '2014-04-01 00:37:22.000000', 'consum', 0.0215, 'lps'),
	(611773, 129, '2014-04-01 00:37:23.000000', 'consum', 0.0219, 'lps'),
	(611774, 129, '2014-04-01 00:37:24.000000', 'consum', 0.0213, 'lps'),
	(611775, 129, '2014-04-01 00:37:25.000000', 'consum', 0.0226, 'lps'),
	(611776, 129, '2014-04-01 00:37:26.000000', 'consum', 0.0231, 'lps'),
	(611777, 129, '2014-04-01 00:37:27.000000', 'consum', 0.0221, 'lps'),
	(611778, 129, '2014-04-01 00:37:28.000000', 'consum', 0.0226, 'lps'),
	(611779, 129, '2014-04-01 00:37:29.000000', 'consum', 0.0232, 'lps'),
	(611780, 129, '2014-04-01 00:37:30.000000', 'consum', 0.0226, 'lps'),
	(611781, 129, '2014-04-01 00:37:31.000000', 'consum', 0.0223, 'lps'),
	(611782, 129, '2014-04-01 00:37:32.000000', 'consum', 0.0227, 'lps'),
	(611783, 129, '2014-04-01 00:37:33.000000', 'consum', 0.0210, 'lps'),
	(611784, 129, '2014-04-01 00:37:34.000000', 'consum', 0.0229, 'lps'),
	(611785, 129, '2014-04-01 00:37:35.000000', 'consum', 0.0212, 'lps'),
	(611786, 129, '2014-04-01 00:37:36.000000', 'consum', 0.0233, 'lps'),
	(611787, 129, '2014-04-01 00:37:37.000000', 'consum', 0.0226, 'lps'),
	(611788, 129, '2014-04-01 00:37:38.000000', 'consum', 0.0223, 'lps'),
	(611789, 129, '2014-04-01 00:37:39.000000', 'consum', 0.0224, 'lps'),
	(611790, 129, '2014-04-01 00:37:40.000000', 'consum', 0.0218, 'lps'),
	(611791, 129, '2014-04-01 00:37:41.000000', 'consum', 0.0232, 'lps'),
	(611792, 129, '2014-04-01 00:37:42.000000', 'consum', 0.0224, 'lps'),
	(611793, 129, '2014-04-01 00:37:43.000000', 'consum', 0.0215, 'lps'),
	(611794, 129, '2014-04-01 00:37:44.000000', 'consum', 0.0218, 'lps'),
	(611795, 129, '2014-04-01 00:37:45.000000', 'consum', 0.0211, 'lps'),
	(611796, 129, '2014-04-01 00:37:46.000000', 'consum', 0.0216, 'lps'),
	(611797, 129, '2014-04-01 00:37:47.000000', 'consum', 0.0214, 'lps'),
	(611798, 129, '2014-04-01 00:37:48.000000', 'consum', 0.0210, 'lps'),
	(611799, 129, '2014-04-01 00:37:49.000000', 'consum', 0.0224, 'lps'),
	(611800, 129, '2014-04-01 00:37:50.000000', 'consum', 0.0231, 'lps'),
	(611801, 129, '2014-04-01 00:37:51.000000', 'consum', 0.0225, 'lps'),
	(611802, 129, '2014-04-01 00:37:52.000000', 'consum', 0.0223, 'lps'),
	(611803, 129, '2014-04-01 00:37:53.000000', 'consum', 0.0230, 'lps'),
	(611804, 129, '2014-04-01 00:37:54.000000', 'consum', 0.0223, 'lps'),
	(611805, 129, '2014-04-01 00:37:55.000000', 'consum', 0.0218, 'lps'),
	(611806, 129, '2014-04-01 00:37:56.000000', 'consum', 0.0210, 'lps'),
	(611807, 129, '2014-04-01 00:37:57.000000', 'consum', 0.0233, 'lps'),
	(611808, 129, '2014-04-01 00:37:58.000000', 'consum', 0.0232, 'lps'),
	(611809, 129, '2014-04-01 00:37:59.000000', 'consum', 0.0227, 'lps'),
	(611810, 129, '2014-04-01 00:38:00.000000', 'consum', 0.0229, 'lps'),
	(611811, 129, '2014-04-01 00:38:01.000000', 'consum', 0.0232, 'lps'),
	(611812, 129, '2014-04-01 00:38:02.000000', 'consum', 0.0216, 'lps'),
	(611813, 129, '2014-04-01 00:38:03.000000', 'consum', 0.0223, 'lps'),
	(611814, 129, '2014-04-01 00:38:04.000000', 'consum', 0.0210, 'lps'),
	(611815, 129, '2014-04-01 00:38:05.000000', 'consum', 0.0220, 'lps'),
	(611816, 129, '2014-04-01 00:38:06.000000', 'consum', 0.0213, 'lps'),
	(611817, 129, '2014-04-01 00:38:07.000000', 'consum', 0.0220, 'lps'),
	(611818, 129, '2014-04-01 00:38:08.000000', 'consum', 0.0226, 'lps'),
	(611819, 129, '2014-04-01 00:38:09.000000', 'consum', 0.0214, 'lps'),
	(611820, 129, '2014-04-01 00:38:10.000000', 'consum', 0.0228, 'lps'),
	(611821, 129, '2014-04-01 00:38:11.000000', 'consum', 0.0217, 'lps'),
	(611822, 129, '2014-04-01 00:38:12.000000', 'consum', 0.0216, 'lps'),
	(611823, 129, '2014-04-01 00:38:13.000000', 'consum', 0.0220, 'lps'),
	(611824, 129, '2014-04-01 00:38:14.000000', 'consum', 0.0218, 'lps'),
	(611825, 129, '2014-04-01 00:38:15.000000', 'consum', 0.0220, 'lps'),
	(611826, 129, '2014-04-01 00:38:16.000000', 'consum', 0.0213, 'lps'),
	(611827, 129, '2014-04-01 00:38:17.000000', 'consum', 0.0218, 'lps'),
	(611828, 129, '2014-04-01 00:38:18.000000', 'consum', 0.0220, 'lps'),
	(611829, 129, '2014-04-01 00:38:19.000000', 'consum', 0.0212, 'lps'),
	(611830, 129, '2014-04-01 00:38:20.000000', 'consum', 0.0216, 'lps'),
	(611831, 129, '2014-04-01 00:38:21.000000', 'consum', 0.0233, 'lps'),
	(611832, 129, '2014-04-01 00:38:22.000000', 'consum', 0.0212, 'lps'),
	(611833, 129, '2014-04-01 00:38:23.000000', 'consum', 0.0222, 'lps'),
	(611834, 129, '2014-04-01 00:38:24.000000', 'consum', 0.0218, 'lps'),
	(611835, 129, '2014-04-01 00:38:25.000000', 'consum', 0.0215, 'lps'),
	(611836, 129, '2014-04-01 00:38:26.000000', 'consum', 0.0211, 'lps'),
	(611837, 129, '2014-04-01 00:38:27.000000', 'consum', 0.0223, 'lps'),
	(611838, 129, '2014-04-01 00:38:28.000000', 'consum', 0.0227, 'lps'),
	(611839, 129, '2014-04-01 00:38:29.000000', 'consum', 0.0231, 'lps'),
	(611840, 129, '2014-04-01 00:38:30.000000', 'consum', 0.0217, 'lps'),
	(611841, 129, '2014-04-01 00:38:31.000000', 'consum', 0.0231, 'lps'),
	(611842, 129, '2014-04-01 00:38:32.000000', 'consum', 0.0222, 'lps'),
	(611843, 129, '2014-04-01 00:38:33.000000', 'consum', 0.0231, 'lps'),
	(611844, 129, '2014-04-01 00:38:34.000000', 'consum', 0.0230, 'lps'),
	(611845, 129, '2014-04-01 00:38:35.000000', 'consum', 0.0227, 'lps'),
	(611846, 129, '2014-04-01 00:38:36.000000', 'consum', 0.0232, 'lps'),
	(611847, 129, '2014-04-01 00:38:37.000000', 'consum', 0.0225, 'lps'),
	(611848, 129, '2014-04-01 00:38:38.000000', 'consum', 0.0218, 'lps'),
	(611849, 129, '2014-04-01 00:38:39.000000', 'consum', 0.0229, 'lps'),
	(611850, 129, '2014-04-01 00:38:40.000000', 'consum', 0.0233, 'lps'),
	(611851, 129, '2014-04-01 00:38:41.000000', 'consum', 0.0219, 'lps'),
	(611852, 129, '2014-04-01 00:38:42.000000', 'consum', 0.0212, 'lps'),
	(611853, 129, '2014-04-01 00:38:43.000000', 'consum', 0.0218, 'lps'),
	(611854, 129, '2014-04-01 00:38:44.000000', 'consum', 0.0218, 'lps'),
	(611855, 129, '2014-04-01 00:38:45.000000', 'consum', 0.0230, 'lps'),
	(611856, 129, '2014-04-01 00:38:46.000000', 'consum', 0.0213, 'lps'),
	(611857, 129, '2014-04-01 00:38:47.000000', 'consum', 0.0215, 'lps'),
	(611858, 129, '2014-04-01 00:38:48.000000', 'consum', 0.0227, 'lps'),
	(611859, 129, '2014-04-01 00:38:49.000000', 'consum', 0.0232, 'lps'),
	(611860, 129, '2014-04-01 00:38:50.000000', 'consum', 0.0221, 'lps'),
	(611861, 129, '2014-04-01 00:38:51.000000', 'consum', 0.0224, 'lps'),
	(611862, 129, '2014-04-01 00:38:52.000000', 'consum', 0.0225, 'lps'),
	(611863, 129, '2014-04-01 00:38:53.000000', 'consum', 0.0216, 'lps'),
	(611864, 129, '2014-04-01 00:38:54.000000', 'consum', 0.0223, 'lps'),
	(611865, 129, '2014-04-01 00:38:55.000000', 'consum', 0.0231, 'lps'),
	(611866, 129, '2014-04-01 00:38:56.000000', 'consum', 0.0231, 'lps'),
	(611867, 129, '2014-04-01 00:38:57.000000', 'consum', 0.0226, 'lps'),
	(611868, 129, '2014-04-01 00:38:58.000000', 'consum', 0.0230, 'lps'),
	(611869, 129, '2014-04-01 00:38:59.000000', 'consum', 0.0215, 'lps'),
	(611870, 129, '2014-04-01 00:39:00.000000', 'consum', 0.0222, 'lps'),
	(611871, 129, '2014-04-01 00:39:01.000000', 'consum', 0.0233, 'lps'),
	(611872, 129, '2014-04-01 00:39:02.000000', 'consum', 0.0217, 'lps'),
	(611873, 129, '2014-04-01 00:39:03.000000', 'consum', 0.0224, 'lps'),
	(611874, 129, '2014-04-01 00:39:04.000000', 'consum', 0.0212, 'lps'),
	(611875, 129, '2014-04-01 00:39:05.000000', 'consum', 0.0228, 'lps'),
	(611876, 129, '2014-04-01 00:39:06.000000', 'consum', 0.0222, 'lps'),
	(611877, 129, '2014-04-01 00:39:07.000000', 'consum', 0.0217, 'lps'),
	(611878, 129, '2014-04-01 00:39:08.000000', 'consum', 0.0231, 'lps'),
	(611879, 129, '2014-04-01 00:39:09.000000', 'consum', 0.0225, 'lps'),
	(611880, 129, '2014-04-01 00:39:10.000000', 'consum', 0.0220, 'lps'),
	(611881, 129, '2014-04-01 00:39:11.000000', 'consum', 0.0217, 'lps'),
	(611882, 129, '2014-04-01 00:39:12.000000', 'consum', 0.0216, 'lps'),
	(611883, 129, '2014-04-01 00:39:13.000000', 'consum', 0.0219, 'lps'),
	(611884, 129, '2014-04-01 00:39:14.000000', 'consum', 0.0212, 'lps'),
	(611885, 129, '2014-04-01 00:39:15.000000', 'consum', 0.0219, 'lps'),
	(611886, 129, '2014-04-01 00:39:16.000000', 'consum', 0.0225, 'lps'),
	(611887, 129, '2014-04-01 00:39:17.000000', 'consum', 0.0212, 'lps'),
	(611888, 129, '2014-04-01 00:39:18.000000', 'consum', 0.0221, 'lps'),
	(611889, 129, '2014-04-01 00:39:19.000000', 'consum', 0.0214, 'lps'),
	(611890, 129, '2014-04-01 00:39:20.000000', 'consum', 0.0218, 'lps'),
	(611891, 129, '2014-04-01 00:39:21.000000', 'consum', 0.0218, 'lps'),
	(611892, 129, '2014-04-01 00:39:22.000000', 'consum', 0.0226, 'lps'),
	(611893, 129, '2014-04-01 00:39:23.000000', 'consum', 0.0220, 'lps'),
	(611894, 129, '2014-04-01 00:39:24.000000', 'consum', 0.0233, 'lps'),
	(611895, 129, '2014-04-01 00:39:25.000000', 'consum', 0.0225, 'lps'),
	(611896, 129, '2014-04-01 00:39:26.000000', 'consum', 0.0217, 'lps'),
	(611897, 129, '2014-04-01 00:39:27.000000', 'consum', 0.0224, 'lps'),
	(611898, 129, '2014-04-01 00:39:28.000000', 'consum', 0.0213, 'lps'),
	(611899, 129, '2014-04-01 00:39:29.000000', 'consum', 0.0232, 'lps'),
	(611900, 129, '2014-04-01 00:39:30.000000', 'consum', 0.0215, 'lps'),
	(611901, 129, '2014-04-01 00:39:31.000000', 'consum', 0.0219, 'lps'),
	(611902, 129, '2014-04-01 00:39:32.000000', 'consum', 0.0214, 'lps'),
	(611903, 129, '2014-04-01 00:39:33.000000', 'consum', 0.0229, 'lps'),
	(611904, 129, '2014-04-01 00:39:34.000000', 'consum', 0.0222, 'lps'),
	(611905, 129, '2014-04-01 00:39:35.000000', 'consum', 0.0212, 'lps'),
	(611906, 129, '2014-04-01 00:39:36.000000', 'consum', 0.0231, 'lps'),
	(611907, 129, '2014-04-01 00:39:37.000000', 'consum', 0.0217, 'lps'),
	(611908, 129, '2014-04-01 00:39:38.000000', 'consum', 0.0229, 'lps'),
	(611909, 129, '2014-04-01 00:39:39.000000', 'consum', 0.0211, 'lps'),
	(611910, 129, '2014-04-01 00:39:40.000000', 'consum', 0.0231, 'lps'),
	(611911, 129, '2014-04-01 00:39:41.000000', 'consum', 0.0215, 'lps'),
	(611912, 129, '2014-04-01 00:39:42.000000', 'consum', 0.0223, 'lps'),
	(611913, 129, '2014-04-01 00:39:43.000000', 'consum', 0.0212, 'lps'),
	(611914, 129, '2014-04-01 00:39:44.000000', 'consum', 0.0231, 'lps'),
	(611915, 129, '2014-04-01 00:39:45.000000', 'consum', 0.0214, 'lps'),
	(611916, 129, '2014-04-01 00:39:46.000000', 'consum', 0.0214, 'lps'),
	(611917, 129, '2014-04-01 00:39:47.000000', 'consum', 0.0220, 'lps'),
	(611918, 129, '2014-04-01 00:39:48.000000', 'consum', 0.0223, 'lps'),
	(611919, 129, '2014-04-01 00:39:49.000000', 'consum', 0.0221, 'lps'),
	(611920, 129, '2014-04-01 00:39:50.000000', 'consum', 0.0229, 'lps'),
	(611921, 129, '2014-04-01 00:39:51.000000', 'consum', 0.0224, 'lps'),
	(611922, 129, '2014-04-01 00:39:52.000000', 'consum', 0.0225, 'lps'),
	(611923, 129, '2014-04-01 00:39:53.000000', 'consum', 0.0217, 'lps'),
	(611924, 129, '2014-04-01 00:39:54.000000', 'consum', 0.0226, 'lps'),
	(611925, 129, '2014-04-01 00:39:55.000000', 'consum', 0.0223, 'lps'),
	(611926, 129, '2014-04-01 00:39:56.000000', 'consum', 0.0226, 'lps'),
	(611927, 129, '2014-04-01 00:39:57.000000', 'consum', 0.0228, 'lps'),
	(611928, 129, '2014-04-01 00:39:58.000000', 'consum', 0.0228, 'lps'),
	(611929, 129, '2014-04-01 00:39:59.000000', 'consum', 0.0224, 'lps'),
	(611930, 129, '2014-04-01 00:40:00.000000', 'consum', 0.0225, 'lps'),
	(611931, 129, '2014-04-01 00:40:01.000000', 'consum', 0.0221, 'lps'),
	(611932, 129, '2014-04-01 00:40:02.000000', 'consum', 0.0220, 'lps'),
	(611933, 129, '2014-04-01 00:40:03.000000', 'consum', 0.0228, 'lps'),
	(611934, 129, '2014-04-01 00:40:04.000000', 'consum', 0.0222, 'lps'),
	(611935, 129, '2014-04-01 00:40:05.000000', 'consum', 0.0217, 'lps'),
	(611936, 129, '2014-04-01 00:40:06.000000', 'consum', 0.0233, 'lps'),
	(611937, 129, '2014-04-01 00:40:07.000000', 'consum', 0.0211, 'lps'),
	(611938, 129, '2014-04-01 00:40:08.000000', 'consum', 0.0215, 'lps'),
	(611939, 129, '2014-04-01 00:40:09.000000', 'consum', 0.0211, 'lps'),
	(611940, 129, '2014-04-01 00:40:10.000000', 'consum', 0.0225, 'lps'),
	(611941, 129, '2014-04-01 00:40:11.000000', 'consum', 0.0210, 'lps'),
	(611942, 129, '2014-04-01 00:40:12.000000', 'consum', 0.0214, 'lps'),
	(611943, 129, '2014-04-01 00:40:13.000000', 'consum', 0.0228, 'lps'),
	(611944, 129, '2014-04-01 00:40:14.000000', 'consum', 0.0219, 'lps'),
	(611945, 129, '2014-04-01 00:40:15.000000', 'consum', 0.0227, 'lps'),
	(611946, 129, '2014-04-01 00:40:16.000000', 'consum', 0.0218, 'lps'),
	(611947, 129, '2014-04-01 00:40:17.000000', 'consum', 0.0223, 'lps'),
	(611948, 129, '2014-04-01 00:40:18.000000', 'consum', 0.0229, 'lps'),
	(611949, 129, '2014-04-01 00:40:19.000000', 'consum', 0.0217, 'lps'),
	(611950, 129, '2014-04-01 00:40:20.000000', 'consum', 0.0213, 'lps'),
	(611951, 129, '2014-04-01 00:40:21.000000', 'consum', 0.0228, 'lps'),
	(611952, 129, '2014-04-01 00:40:22.000000', 'consum', 0.0219, 'lps'),
	(611953, 129, '2014-04-01 00:40:23.000000', 'consum', 0.0227, 'lps'),
	(611954, 129, '2014-04-01 00:40:24.000000', 'consum', 0.0219, 'lps'),
	(611955, 129, '2014-04-01 00:40:25.000000', 'consum', 0.0231, 'lps'),
	(611956, 129, '2014-04-01 00:40:26.000000', 'consum', 0.0215, 'lps'),
	(611957, 129, '2014-04-01 00:40:27.000000', 'consum', 0.0223, 'lps'),
	(611958, 129, '2014-04-01 00:40:28.000000', 'consum', 0.0233, 'lps'),
	(611959, 129, '2014-04-01 00:40:29.000000', 'consum', 0.0216, 'lps'),
	(611960, 129, '2014-04-01 00:40:30.000000', 'consum', 0.0220, 'lps'),
	(611961, 129, '2014-04-01 00:40:31.000000', 'consum', 0.0217, 'lps'),
	(611962, 129, '2014-04-01 00:40:32.000000', 'consum', 0.0217, 'lps'),
	(611963, 129, '2014-04-01 00:40:33.000000', 'consum', 0.0224, 'lps'),
	(611964, 129, '2014-04-01 00:40:34.000000', 'consum', 0.0213, 'lps'),
	(611965, 129, '2014-04-01 00:40:35.000000', 'consum', 0.0230, 'lps'),
	(611966, 129, '2014-04-01 00:40:36.000000', 'consum', 0.0230, 'lps'),
	(611967, 129, '2014-04-01 00:40:37.000000', 'consum', 0.0228, 'lps'),
	(611968, 129, '2014-04-01 00:40:38.000000', 'consum', 0.0216, 'lps'),
	(611969, 129, '2014-04-01 00:40:39.000000', 'consum', 0.0211, 'lps'),
	(611970, 129, '2014-04-01 00:40:40.000000', 'consum', 0.0219, 'lps'),
	(611971, 129, '2014-04-01 00:40:41.000000', 'consum', 0.0230, 'lps'),
	(611972, 129, '2014-04-01 00:40:42.000000', 'consum', 0.0210, 'lps'),
	(611973, 129, '2014-04-01 00:40:43.000000', 'consum', 0.0223, 'lps'),
	(611974, 129, '2014-04-01 00:40:44.000000', 'consum', 0.0226, 'lps'),
	(611975, 129, '2014-04-01 00:40:45.000000', 'consum', 0.0231, 'lps'),
	(611976, 129, '2014-04-01 00:40:46.000000', 'consum', 0.0216, 'lps'),
	(611977, 129, '2014-04-01 00:40:47.000000', 'consum', 0.0228, 'lps'),
	(611978, 129, '2014-04-01 00:40:48.000000', 'consum', 0.0233, 'lps'),
	(611979, 129, '2014-04-01 00:40:49.000000', 'consum', 0.0222, 'lps'),
	(611980, 129, '2014-04-01 00:40:50.000000', 'consum', 0.0227, 'lps'),
	(611981, 129, '2014-04-01 00:40:51.000000', 'consum', 0.0211, 'lps'),
	(611982, 129, '2014-04-01 00:40:52.000000', 'consum', 0.0212, 'lps'),
	(611983, 129, '2014-04-01 00:40:53.000000', 'consum', 0.0219, 'lps'),
	(611984, 129, '2014-04-01 00:40:54.000000', 'consum', 0.0223, 'lps'),
	(611985, 129, '2014-04-01 00:40:55.000000', 'consum', 0.0224, 'lps'),
	(611986, 129, '2014-04-01 00:40:56.000000', 'consum', 0.0221, 'lps'),
	(611987, 129, '2014-04-01 00:40:57.000000', 'consum', 0.0221, 'lps'),
	(611988, 129, '2014-04-01 00:40:58.000000', 'consum', 0.0233, 'lps'),
	(611989, 129, '2014-04-01 00:40:59.000000', 'consum', 0.0222, 'lps'),
	(611990, 129, '2014-04-01 00:41:00.000000', 'consum', 0.0225, 'lps'),
	(611991, 129, '2014-04-01 00:41:01.000000', 'consum', 0.0225, 'lps'),
	(611992, 129, '2014-04-01 00:41:02.000000', 'consum', 0.0217, 'lps'),
	(611993, 129, '2014-04-01 00:41:03.000000', 'consum', 0.0223, 'lps'),
	(611994, 129, '2014-04-01 00:41:04.000000', 'consum', 0.0233, 'lps'),
	(611995, 129, '2014-04-01 00:41:05.000000', 'consum', 0.0212, 'lps'),
	(611996, 129, '2014-04-01 00:41:06.000000', 'consum', 0.0226, 'lps'),
	(611997, 129, '2014-04-01 00:41:07.000000', 'consum', 0.0212, 'lps'),
	(611998, 129, '2014-04-01 00:41:08.000000', 'consum', 0.0220, 'lps'),
	(611999, 129, '2014-04-01 00:41:09.000000', 'consum', 0.0230, 'lps'),
	(612000, 129, '2014-04-01 00:41:10.000000', 'consum', 0.0233, 'lps'),
	(612001, 129, '2014-04-01 00:41:11.000000', 'consum', 0.0216, 'lps'),
	(612002, 129, '2014-04-01 00:41:12.000000', 'consum', 0.0222, 'lps'),
	(612003, 129, '2014-04-01 00:41:13.000000', 'consum', 0.0229, 'lps'),
	(612004, 129, '2014-04-01 00:41:14.000000', 'consum', 0.0222, 'lps'),
	(612005, 129, '2014-04-01 00:41:15.000000', 'consum', 0.0212, 'lps'),
	(612006, 129, '2014-04-01 00:41:16.000000', 'consum', 0.0210, 'lps'),
	(612007, 129, '2014-04-01 00:41:17.000000', 'consum', 0.0228, 'lps'),
	(612008, 129, '2014-04-01 00:41:18.000000', 'consum', 0.0229, 'lps'),
	(612009, 129, '2014-04-01 00:41:19.000000', 'consum', 0.0226, 'lps'),
	(612010, 129, '2014-04-01 00:41:20.000000', 'consum', 0.0212, 'lps'),
	(612011, 129, '2014-04-01 00:41:21.000000', 'consum', 0.0220, 'lps'),
	(612012, 129, '2014-04-01 00:41:22.000000', 'consum', 0.0230, 'lps'),
	(612013, 129, '2014-04-01 00:41:23.000000', 'consum', 0.0233, 'lps'),
	(612014, 129, '2014-04-01 00:41:24.000000', 'consum', 0.0218, 'lps'),
	(612015, 129, '2014-04-01 00:41:25.000000', 'consum', 0.0229, 'lps'),
	(612016, 129, '2014-04-01 00:41:26.000000', 'consum', 0.0232, 'lps'),
	(612017, 129, '2014-04-01 00:41:27.000000', 'consum', 0.0218, 'lps'),
	(612018, 129, '2014-04-01 00:41:28.000000', 'consum', 0.0231, 'lps'),
	(612019, 129, '2014-04-01 00:41:29.000000', 'consum', 0.0219, 'lps'),
	(612020, 129, '2014-04-01 00:41:30.000000', 'consum', 0.0217, 'lps'),
	(612021, 129, '2014-04-01 00:41:31.000000', 'consum', 0.0219, 'lps'),
	(612022, 129, '2014-04-01 00:41:32.000000', 'consum', 0.0210, 'lps'),
	(612023, 129, '2014-04-01 00:41:33.000000', 'consum', 0.0210, 'lps'),
	(612024, 129, '2014-04-01 00:41:34.000000', 'consum', 0.0231, 'lps'),
	(612025, 129, '2014-04-01 00:41:35.000000', 'consum', 0.0223, 'lps'),
	(612026, 129, '2014-04-01 00:41:36.000000', 'consum', 0.0210, 'lps'),
	(612027, 129, '2014-04-01 00:41:37.000000', 'consum', 0.0222, 'lps'),
	(612028, 129, '2014-04-01 00:41:38.000000', 'consum', 0.0220, 'lps'),
	(612029, 129, '2014-04-01 00:41:39.000000', 'consum', 0.0225, 'lps'),
	(612030, 129, '2014-04-01 00:41:40.000000', 'consum', 0.0231, 'lps'),
	(612031, 129, '2014-04-01 00:41:41.000000', 'consum', 0.0224, 'lps'),
	(612032, 129, '2014-04-01 00:41:42.000000', 'consum', 0.0218, 'lps'),
	(612033, 129, '2014-04-01 00:41:43.000000', 'consum', 0.0231, 'lps'),
	(612034, 129, '2014-04-01 00:41:44.000000', 'consum', 0.0218, 'lps'),
	(612035, 129, '2014-04-01 00:41:45.000000', 'consum', 0.0212, 'lps'),
	(612036, 129, '2014-04-01 00:41:46.000000', 'consum', 0.0223, 'lps'),
	(612037, 129, '2014-04-01 00:41:47.000000', 'consum', 0.0219, 'lps'),
	(612038, 129, '2014-04-01 00:41:48.000000', 'consum', 0.0218, 'lps'),
	(612039, 129, '2014-04-01 00:41:49.000000', 'consum', 0.0223, 'lps'),
	(612040, 129, '2014-04-01 00:41:50.000000', 'consum', 0.0227, 'lps'),
	(612041, 129, '2014-04-01 00:41:51.000000', 'consum', 0.0232, 'lps'),
	(612042, 129, '2014-04-01 00:41:52.000000', 'consum', 0.0222, 'lps'),
	(612043, 129, '2014-04-01 00:41:53.000000', 'consum', 0.0227, 'lps'),
	(612044, 129, '2014-04-01 00:41:54.000000', 'consum', 0.0212, 'lps'),
	(612045, 129, '2014-04-01 00:41:55.000000', 'consum', 0.0219, 'lps'),
	(612046, 129, '2014-04-01 00:41:56.000000', 'consum', 0.0223, 'lps'),
	(612047, 129, '2014-04-01 00:41:57.000000', 'consum', 0.0225, 'lps'),
	(612048, 129, '2014-04-01 00:41:58.000000', 'consum', 0.0221, 'lps'),
	(612049, 129, '2014-04-01 00:41:59.000000', 'consum', 0.0222, 'lps'),
	(612050, 129, '2014-04-01 00:42:00.000000', 'consum', 0.0214, 'lps'),
	(612051, 129, '2014-04-01 00:42:01.000000', 'consum', 0.0219, 'lps'),
	(612052, 129, '2014-04-01 00:42:02.000000', 'consum', 0.0220, 'lps'),
	(612053, 129, '2014-04-01 00:42:03.000000', 'consum', 0.0233, 'lps'),
	(612054, 129, '2014-04-01 00:42:04.000000', 'consum', 0.0225, 'lps'),
	(612055, 129, '2014-04-01 00:42:05.000000', 'consum', 0.0215, 'lps'),
	(612056, 129, '2014-04-01 00:42:06.000000', 'consum', 0.0213, 'lps'),
	(612057, 129, '2014-04-01 00:42:07.000000', 'consum', 0.0213, 'lps'),
	(612058, 129, '2014-04-01 00:42:08.000000', 'consum', 0.0214, 'lps'),
	(612059, 129, '2014-04-01 00:42:09.000000', 'consum', 0.0223, 'lps'),
	(612060, 129, '2014-04-01 00:42:10.000000', 'consum', 0.0215, 'lps'),
	(612061, 129, '2014-04-01 00:42:11.000000', 'consum', 0.0220, 'lps'),
	(612062, 129, '2014-04-01 00:42:12.000000', 'consum', 0.0220, 'lps'),
	(612063, 129, '2014-04-01 00:42:13.000000', 'consum', 0.0210, 'lps'),
	(612064, 129, '2014-04-01 00:42:14.000000', 'consum', 0.0227, 'lps'),
	(612065, 129, '2014-04-01 00:42:15.000000', 'consum', 0.0223, 'lps'),
	(612066, 129, '2014-04-01 00:42:16.000000', 'consum', 0.0223, 'lps'),
	(612067, 129, '2014-04-01 00:42:17.000000', 'consum', 0.0215, 'lps'),
	(612068, 129, '2014-04-01 00:42:18.000000', 'consum', 0.0219, 'lps'),
	(612069, 129, '2014-04-01 00:42:19.000000', 'consum', 0.0216, 'lps'),
	(612070, 129, '2014-04-01 00:42:20.000000', 'consum', 0.0213, 'lps'),
	(612071, 129, '2014-04-01 00:42:21.000000', 'consum', 0.0232, 'lps'),
	(612072, 129, '2014-04-01 00:42:22.000000', 'consum', 0.0217, 'lps'),
	(612073, 129, '2014-04-01 00:42:23.000000', 'consum', 0.0228, 'lps'),
	(612074, 129, '2014-04-01 00:42:24.000000', 'consum', 0.0230, 'lps'),
	(612075, 129, '2014-04-01 00:42:25.000000', 'consum', 0.0233, 'lps'),
	(612076, 129, '2014-04-01 00:42:26.000000', 'consum', 0.0215, 'lps'),
	(612077, 129, '2014-04-01 00:42:27.000000', 'consum', 0.0218, 'lps'),
	(612078, 129, '2014-04-01 00:42:28.000000', 'consum', 0.0233, 'lps'),
	(612079, 129, '2014-04-01 00:42:29.000000', 'consum', 0.0229, 'lps'),
	(612080, 129, '2014-04-01 00:42:30.000000', 'consum', 0.0213, 'lps'),
	(612081, 129, '2014-04-01 00:42:31.000000', 'consum', 0.0218, 'lps'),
	(612082, 129, '2014-04-01 00:42:32.000000', 'consum', 0.0217, 'lps'),
	(612083, 129, '2014-04-01 00:42:33.000000', 'consum', 0.0221, 'lps'),
	(612084, 129, '2014-04-01 00:42:34.000000', 'consum', 0.0221, 'lps'),
	(612085, 129, '2014-04-01 00:42:35.000000', 'consum', 0.0210, 'lps'),
	(612086, 129, '2014-04-01 00:42:36.000000', 'consum', 0.0222, 'lps'),
	(612087, 129, '2014-04-01 00:42:37.000000', 'consum', 0.0225, 'lps'),
	(612088, 129, '2014-04-01 00:42:38.000000', 'consum', 0.0226, 'lps'),
	(612089, 129, '2014-04-01 00:42:39.000000', 'consum', 0.0222, 'lps'),
	(612090, 129, '2014-04-01 00:42:40.000000', 'consum', 0.0221, 'lps'),
	(612091, 129, '2014-04-01 00:42:41.000000', 'consum', 0.0231, 'lps'),
	(612092, 129, '2014-04-01 00:42:42.000000', 'consum', 0.0232, 'lps'),
	(612093, 129, '2014-04-01 00:42:43.000000', 'consum', 0.0213, 'lps'),
	(612094, 129, '2014-04-01 00:42:44.000000', 'consum', 0.0228, 'lps'),
	(612095, 129, '2014-04-01 00:42:45.000000', 'consum', 0.0223, 'lps'),
	(612096, 129, '2014-04-01 00:42:46.000000', 'consum', 0.0218, 'lps'),
	(612097, 129, '2014-04-01 00:42:47.000000', 'consum', 0.0213, 'lps'),
	(612098, 129, '2014-04-01 00:42:48.000000', 'consum', 0.0226, 'lps'),
	(612099, 129, '2014-04-01 00:42:49.000000', 'consum', 0.0233, 'lps'),
	(612100, 129, '2014-04-01 00:42:50.000000', 'consum', 0.0231, 'lps'),
	(612101, 129, '2014-04-01 00:42:51.000000', 'consum', 0.0222, 'lps'),
	(612102, 129, '2014-04-01 00:42:52.000000', 'consum', 0.0231, 'lps'),
	(612103, 129, '2014-04-01 00:42:53.000000', 'consum', 0.0231, 'lps'),
	(612104, 129, '2014-04-01 00:42:54.000000', 'consum', 0.0228, 'lps'),
	(612105, 129, '2014-04-01 00:42:55.000000', 'consum', 0.0214, 'lps'),
	(612106, 129, '2014-04-01 00:42:56.000000', 'consum', 0.0225, 'lps'),
	(612107, 129, '2014-04-01 00:42:57.000000', 'consum', 0.0226, 'lps'),
	(612108, 129, '2014-04-01 00:42:58.000000', 'consum', 0.0222, 'lps'),
	(612109, 129, '2014-04-01 00:42:59.000000', 'consum', 0.0221, 'lps'),
	(612110, 129, '2014-04-01 00:43:00.000000', 'consum', 0.0232, 'lps'),
	(612111, 129, '2014-04-01 00:43:01.000000', 'consum', 0.0213, 'lps'),
	(612112, 129, '2014-04-01 00:43:02.000000', 'consum', 0.0232, 'lps'),
	(612113, 129, '2014-04-01 00:43:03.000000', 'consum', 0.0216, 'lps'),
	(612114, 129, '2014-04-01 00:43:04.000000', 'consum', 0.0220, 'lps'),
	(612115, 129, '2014-04-01 00:43:05.000000', 'consum', 0.0221, 'lps'),
	(612116, 129, '2014-04-01 00:43:06.000000', 'consum', 0.0212, 'lps'),
	(612117, 129, '2014-04-01 00:43:07.000000', 'consum', 0.0233, 'lps'),
	(612118, 129, '2014-04-01 00:43:08.000000', 'consum', 0.0226, 'lps'),
	(612119, 129, '2014-04-01 00:43:09.000000', 'consum', 0.0220, 'lps'),
	(612120, 129, '2014-04-01 00:43:10.000000', 'consum', 0.0212, 'lps'),
	(612121, 129, '2014-04-01 00:43:11.000000', 'consum', 0.0215, 'lps'),
	(612122, 129, '2014-04-01 00:43:12.000000', 'consum', 0.0230, 'lps'),
	(612123, 129, '2014-04-01 00:43:13.000000', 'consum', 0.0222, 'lps'),
	(612124, 129, '2014-04-01 00:43:14.000000', 'consum', 0.0212, 'lps'),
	(612125, 129, '2014-04-01 00:43:15.000000', 'consum', 0.0210, 'lps'),
	(612126, 129, '2014-04-01 00:43:16.000000', 'consum', 0.0226, 'lps'),
	(612127, 129, '2014-04-01 00:43:17.000000', 'consum', 0.0220, 'lps'),
	(612128, 129, '2014-04-01 00:43:18.000000', 'consum', 0.0213, 'lps'),
	(612129, 129, '2014-04-01 00:43:19.000000', 'consum', 0.0219, 'lps'),
	(612130, 129, '2014-04-01 00:43:20.000000', 'consum', 0.0223, 'lps'),
	(612131, 129, '2014-04-01 00:43:21.000000', 'consum', 0.0224, 'lps'),
	(612132, 129, '2014-04-01 00:43:22.000000', 'consum', 0.0218, 'lps'),
	(612133, 129, '2014-04-01 00:43:23.000000', 'consum', 0.0210, 'lps'),
	(612134, 129, '2014-04-01 00:43:24.000000', 'consum', 0.0233, 'lps'),
	(612135, 129, '2014-04-01 00:43:25.000000', 'consum', 0.0231, 'lps'),
	(612136, 129, '2014-04-01 00:43:26.000000', 'consum', 0.0223, 'lps'),
	(612137, 129, '2014-04-01 00:43:27.000000', 'consum', 0.0210, 'lps'),
	(612138, 129, '2014-04-01 00:43:28.000000', 'consum', 0.0220, 'lps'),
	(612139, 129, '2014-04-01 00:43:29.000000', 'consum', 0.0214, 'lps'),
	(612140, 129, '2014-04-01 00:43:30.000000', 'consum', 0.0223, 'lps'),
	(612141, 129, '2014-04-01 00:43:31.000000', 'consum', 0.0215, 'lps'),
	(612142, 129, '2014-04-01 00:43:32.000000', 'consum', 0.0220, 'lps'),
	(612143, 129, '2014-04-01 00:43:33.000000', 'consum', 0.0223, 'lps'),
	(612144, 129, '2014-04-01 00:43:34.000000', 'consum', 0.0220, 'lps'),
	(612145, 129, '2014-04-01 00:43:35.000000', 'consum', 0.0221, 'lps'),
	(612146, 129, '2014-04-01 00:43:36.000000', 'consum', 0.0213, 'lps'),
	(612147, 129, '2014-04-01 00:43:37.000000', 'consum', 0.0218, 'lps'),
	(612148, 129, '2014-04-01 00:43:38.000000', 'consum', 0.0215, 'lps'),
	(612149, 129, '2014-04-01 00:43:39.000000', 'consum', 0.0210, 'lps'),
	(612150, 129, '2014-04-01 00:43:40.000000', 'consum', 0.0222, 'lps'),
	(612151, 129, '2014-04-01 00:43:41.000000', 'consum', 0.0224, 'lps'),
	(612152, 129, '2014-04-01 00:43:42.000000', 'consum', 0.0219, 'lps'),
	(612153, 129, '2014-04-01 00:43:43.000000', 'consum', 0.0213, 'lps'),
	(612154, 129, '2014-04-01 00:43:44.000000', 'consum', 0.0221, 'lps'),
	(612155, 129, '2014-04-01 00:43:45.000000', 'consum', 0.0212, 'lps'),
	(612156, 129, '2014-04-01 00:43:46.000000', 'consum', 0.0233, 'lps'),
	(612157, 129, '2014-04-01 00:43:47.000000', 'consum', 0.0225, 'lps'),
	(612158, 129, '2014-04-01 00:43:48.000000', 'consum', 0.0215, 'lps'),
	(612159, 129, '2014-04-01 00:43:49.000000', 'consum', 0.0216, 'lps'),
	(612160, 129, '2014-04-01 00:43:50.000000', 'consum', 0.0227, 'lps'),
	(612161, 129, '2014-04-01 00:43:51.000000', 'consum', 0.0228, 'lps'),
	(612162, 129, '2014-04-01 00:43:52.000000', 'consum', 0.0224, 'lps'),
	(612163, 129, '2014-04-01 00:43:53.000000', 'consum', 0.0227, 'lps'),
	(612164, 129, '2014-04-01 00:43:54.000000', 'consum', 0.0228, 'lps'),
	(612165, 129, '2014-04-01 00:43:55.000000', 'consum', 0.0227, 'lps'),
	(612166, 129, '2014-04-01 00:43:56.000000', 'consum', 0.0219, 'lps'),
	(612167, 129, '2014-04-01 00:43:57.000000', 'consum', 0.0226, 'lps'),
	(612168, 129, '2014-04-01 00:43:58.000000', 'consum', 0.0218, 'lps'),
	(612169, 129, '2014-04-01 00:43:59.000000', 'consum', 0.0224, 'lps'),
	(612170, 129, '2014-04-01 00:44:00.000000', 'consum', 0.0232, 'lps'),
	(612171, 129, '2014-04-01 00:44:01.000000', 'consum', 0.0230, 'lps'),
	(612172, 129, '2014-04-01 00:44:02.000000', 'consum', 0.0222, 'lps'),
	(612173, 129, '2014-04-01 00:44:03.000000', 'consum', 0.0233, 'lps'),
	(612174, 129, '2014-04-01 00:44:04.000000', 'consum', 0.0216, 'lps'),
	(612175, 129, '2014-04-01 00:44:05.000000', 'consum', 0.0222, 'lps'),
	(612176, 129, '2014-04-01 00:44:06.000000', 'consum', 0.0230, 'lps'),
	(612177, 129, '2014-04-01 00:44:07.000000', 'consum', 0.0223, 'lps'),
	(612178, 129, '2014-04-01 00:44:08.000000', 'consum', 0.0219, 'lps'),
	(612179, 129, '2014-04-01 00:44:09.000000', 'consum', 0.0215, 'lps'),
	(612180, 129, '2014-04-01 00:44:10.000000', 'consum', 0.0232, 'lps'),
	(612181, 129, '2014-04-01 00:44:11.000000', 'consum', 0.0210, 'lps'),
	(612182, 129, '2014-04-01 00:44:12.000000', 'consum', 0.0217, 'lps'),
	(612183, 129, '2014-04-01 00:44:13.000000', 'consum', 0.0223, 'lps'),
	(612184, 129, '2014-04-01 00:44:14.000000', 'consum', 0.0229, 'lps'),
	(612185, 129, '2014-04-01 00:44:15.000000', 'consum', 0.0219, 'lps'),
	(612186, 129, '2014-04-01 00:44:16.000000', 'consum', 0.0220, 'lps'),
	(612187, 129, '2014-04-01 00:44:17.000000', 'consum', 0.0212, 'lps'),
	(612188, 129, '2014-04-01 00:44:18.000000', 'consum', 0.0212, 'lps'),
	(612189, 129, '2014-04-01 00:44:19.000000', 'consum', 0.0215, 'lps'),
	(612190, 129, '2014-04-01 00:44:20.000000', 'consum', 0.0230, 'lps'),
	(612191, 129, '2014-04-01 00:44:21.000000', 'consum', 0.0225, 'lps'),
	(612192, 129, '2014-04-01 00:44:22.000000', 'consum', 0.0226, 'lps'),
	(612193, 129, '2014-04-01 00:44:23.000000', 'consum', 0.0221, 'lps'),
	(612194, 129, '2014-04-01 00:44:24.000000', 'consum', 0.0216, 'lps'),
	(612195, 129, '2014-04-01 00:44:25.000000', 'consum', 0.0210, 'lps'),
	(612196, 129, '2014-04-01 00:44:26.000000', 'consum', 0.0217, 'lps'),
	(612197, 129, '2014-04-01 00:44:27.000000', 'consum', 0.0220, 'lps'),
	(612198, 129, '2014-04-01 00:44:28.000000', 'consum', 0.0217, 'lps'),
	(612199, 129, '2014-04-01 00:44:29.000000', 'consum', 0.0214, 'lps'),
	(612200, 129, '2014-04-01 00:44:30.000000', 'consum', 0.0211, 'lps'),
	(612201, 129, '2014-04-01 00:44:31.000000', 'consum', 0.0226, 'lps'),
	(612202, 129, '2014-04-01 00:44:32.000000', 'consum', 0.0216, 'lps'),
	(612203, 129, '2014-04-01 00:44:33.000000', 'consum', 0.0217, 'lps'),
	(612204, 129, '2014-04-01 00:44:34.000000', 'consum', 0.0228, 'lps'),
	(612205, 129, '2014-04-01 00:44:35.000000', 'consum', 0.0231, 'lps'),
	(612206, 129, '2014-04-01 00:44:36.000000', 'consum', 0.0215, 'lps'),
	(612207, 129, '2014-04-01 00:44:37.000000', 'consum', 0.0218, 'lps'),
	(612208, 129, '2014-04-01 00:44:38.000000', 'consum', 0.0211, 'lps'),
	(612209, 129, '2014-04-01 00:44:39.000000', 'consum', 0.0215, 'lps'),
	(612210, 129, '2014-04-01 00:44:40.000000', 'consum', 0.0210, 'lps'),
	(612211, 129, '2014-04-01 00:44:41.000000', 'consum', 0.0218, 'lps'),
	(612212, 129, '2014-04-01 00:44:42.000000', 'consum', 0.0228, 'lps'),
	(612213, 129, '2014-04-01 00:44:43.000000', 'consum', 0.0229, 'lps'),
	(612214, 129, '2014-04-01 00:44:44.000000', 'consum', 0.0228, 'lps'),
	(612215, 129, '2014-04-01 00:44:45.000000', 'consum', 0.0217, 'lps'),
	(612216, 129, '2014-04-01 00:44:46.000000', 'consum', 0.0216, 'lps'),
	(612217, 129, '2014-04-01 00:44:47.000000', 'consum', 0.0222, 'lps'),
	(612218, 129, '2014-04-01 00:44:48.000000', 'consum', 0.0225, 'lps'),
	(612219, 129, '2014-04-01 00:44:49.000000', 'consum', 0.0227, 'lps'),
	(612220, 129, '2014-04-01 00:44:50.000000', 'consum', 0.0225, 'lps'),
	(612221, 129, '2014-04-01 00:44:51.000000', 'consum', 0.0212, 'lps'),
	(612222, 129, '2014-04-01 00:44:52.000000', 'consum', 0.0224, 'lps'),
	(612223, 129, '2014-04-01 00:44:53.000000', 'consum', 0.0228, 'lps'),
	(612224, 129, '2014-04-01 00:44:54.000000', 'consum', 0.0232, 'lps'),
	(612225, 129, '2014-04-01 00:44:55.000000', 'consum', 0.0220, 'lps'),
	(612226, 129, '2014-04-01 00:44:56.000000', 'consum', 0.0219, 'lps'),
	(612227, 129, '2014-04-01 00:44:57.000000', 'consum', 0.0225, 'lps'),
	(612228, 129, '2014-04-01 00:44:58.000000', 'consum', 0.0212, 'lps'),
	(612229, 129, '2014-04-01 00:44:59.000000', 'consum', 0.0222, 'lps'),
	(612230, 129, '2014-04-01 00:45:00.000000', 'consum', 0.0217, 'lps'),
	(612231, 129, '2014-04-01 00:45:01.000000', 'consum', 0.0233, 'lps'),
	(612232, 129, '2014-04-01 00:45:02.000000', 'consum', 0.0231, 'lps'),
	(612233, 129, '2014-04-01 00:45:03.000000', 'consum', 0.0223, 'lps'),
	(612234, 129, '2014-04-01 00:45:04.000000', 'consum', 0.0213, 'lps'),
	(612235, 129, '2014-04-01 00:45:05.000000', 'consum', 0.0211, 'lps'),
	(612236, 129, '2014-04-01 00:45:06.000000', 'consum', 0.0230, 'lps'),
	(612237, 129, '2014-04-01 00:45:07.000000', 'consum', 0.0213, 'lps'),
	(612238, 129, '2014-04-01 00:45:08.000000', 'consum', 0.0215, 'lps'),
	(612239, 129, '2014-04-01 00:45:09.000000', 'consum', 0.0223, 'lps'),
	(612240, 129, '2014-04-01 00:45:10.000000', 'consum', 0.0215, 'lps'),
	(612241, 129, '2014-04-01 00:45:11.000000', 'consum', 0.0220, 'lps'),
	(612242, 129, '2014-04-01 00:45:12.000000', 'consum', 0.0223, 'lps'),
	(612243, 129, '2014-04-01 00:45:13.000000', 'consum', 0.0220, 'lps'),
	(612244, 129, '2014-04-01 00:45:14.000000', 'consum', 0.0222, 'lps'),
	(612245, 129, '2014-04-01 00:45:15.000000', 'consum', 0.0214, 'lps'),
	(612246, 129, '2014-04-01 00:45:16.000000', 'consum', 0.0221, 'lps'),
	(612247, 129, '2014-04-01 00:45:17.000000', 'consum', 0.0230, 'lps'),
	(612248, 129, '2014-04-01 00:45:18.000000', 'consum', 0.0230, 'lps'),
	(612249, 129, '2014-04-01 00:45:19.000000', 'consum', 0.0224, 'lps'),
	(612250, 129, '2014-04-01 00:45:20.000000', 'consum', 0.0224, 'lps'),
	(612251, 129, '2014-04-01 00:45:21.000000', 'consum', 0.0211, 'lps'),
	(612252, 129, '2014-04-01 00:45:22.000000', 'consum', 0.0223, 'lps'),
	(612253, 129, '2014-04-01 00:45:23.000000', 'consum', 0.0223, 'lps'),
	(612254, 129, '2014-04-01 00:45:24.000000', 'consum', 0.0212, 'lps'),
	(612255, 129, '2014-04-01 00:45:25.000000', 'consum', 0.0230, 'lps'),
	(612256, 129, '2014-04-01 00:45:26.000000', 'consum', 0.0231, 'lps'),
	(612257, 129, '2014-04-01 00:45:27.000000', 'consum', 0.0233, 'lps'),
	(612258, 129, '2014-04-01 00:45:28.000000', 'consum', 0.0215, 'lps'),
	(612259, 129, '2014-04-01 00:45:29.000000', 'consum', 0.0212, 'lps'),
	(612260, 129, '2014-04-01 00:45:30.000000', 'consum', 0.0232, 'lps'),
	(612261, 129, '2014-04-01 00:45:31.000000', 'consum', 0.0218, 'lps'),
	(612262, 129, '2014-04-01 00:45:32.000000', 'consum', 0.0233, 'lps'),
	(612263, 129, '2014-04-01 00:45:33.000000', 'consum', 0.0230, 'lps'),
	(612264, 129, '2014-04-01 00:45:34.000000', 'consum', 0.0215, 'lps'),
	(612265, 129, '2014-04-01 00:45:35.000000', 'consum', 0.0226, 'lps'),
	(612266, 129, '2014-04-01 00:45:36.000000', 'consum', 0.0229, 'lps'),
	(612267, 129, '2014-04-01 00:45:37.000000', 'consum', 0.0230, 'lps'),
	(612268, 129, '2014-04-01 00:45:38.000000', 'consum', 0.0230, 'lps'),
	(612269, 129, '2014-04-01 00:45:39.000000', 'consum', 0.0226, 'lps'),
	(612270, 129, '2014-04-01 00:45:40.000000', 'consum', 0.0232, 'lps'),
	(612271, 129, '2014-04-01 00:45:41.000000', 'consum', 0.0223, 'lps'),
	(612272, 129, '2014-04-01 00:45:42.000000', 'consum', 0.0233, 'lps'),
	(612273, 129, '2014-04-01 00:45:43.000000', 'consum', 0.0214, 'lps'),
	(612274, 129, '2014-04-01 00:45:44.000000', 'consum', 0.0212, 'lps'),
	(612275, 129, '2014-04-01 00:45:45.000000', 'consum', 0.0230, 'lps'),
	(612276, 129, '2014-04-01 00:45:46.000000', 'consum', 0.0232, 'lps'),
	(612277, 129, '2014-04-01 00:45:47.000000', 'consum', 0.0211, 'lps'),
	(612278, 129, '2014-04-01 00:45:48.000000', 'consum', 0.0225, 'lps'),
	(612279, 129, '2014-04-01 00:45:49.000000', 'consum', 0.0210, 'lps'),
	(612280, 129, '2014-04-01 00:45:50.000000', 'consum', 0.0211, 'lps'),
	(612281, 129, '2014-04-01 00:45:51.000000', 'consum', 0.0218, 'lps'),
	(612282, 129, '2014-04-01 00:45:52.000000', 'consum', 0.0222, 'lps'),
	(612283, 129, '2014-04-01 00:45:53.000000', 'consum', 0.0223, 'lps'),
	(612284, 129, '2014-04-01 00:45:54.000000', 'consum', 0.0217, 'lps'),
	(612285, 129, '2014-04-01 00:45:55.000000', 'consum', 0.0229, 'lps'),
	(612286, 129, '2014-04-01 00:45:56.000000', 'consum', 0.0212, 'lps'),
	(612287, 129, '2014-04-01 00:45:57.000000', 'consum', 0.0211, 'lps'),
	(612288, 129, '2014-04-01 00:45:58.000000', 'consum', 0.0212, 'lps'),
	(612289, 129, '2014-04-01 00:45:59.000000', 'consum', 0.0215, 'lps'),
	(612290, 129, '2014-04-01 00:46:00.000000', 'consum', 0.0230, 'lps'),
	(612291, 129, '2014-04-01 00:46:01.000000', 'consum', 0.0223, 'lps'),
	(612292, 129, '2014-04-01 00:46:02.000000', 'consum', 0.0217, 'lps'),
	(612293, 129, '2014-04-01 00:46:03.000000', 'consum', 0.0232, 'lps'),
	(612294, 129, '2014-04-01 00:46:04.000000', 'consum', 0.0225, 'lps'),
	(612295, 129, '2014-04-01 00:46:05.000000', 'consum', 0.0220, 'lps'),
	(612296, 129, '2014-04-01 00:46:06.000000', 'consum', 0.0214, 'lps'),
	(612297, 129, '2014-04-01 00:46:07.000000', 'consum', 0.0226, 'lps'),
	(612298, 129, '2014-04-01 00:46:08.000000', 'consum', 0.0230, 'lps'),
	(612299, 129, '2014-04-01 00:46:09.000000', 'consum', 0.0214, 'lps'),
	(612300, 129, '2014-04-01 00:46:10.000000', 'consum', 0.0219, 'lps'),
	(612301, 129, '2014-04-01 00:46:11.000000', 'consum', 0.0218, 'lps'),
	(612302, 129, '2014-04-01 00:46:12.000000', 'consum', 0.0224, 'lps'),
	(612303, 129, '2014-04-01 00:46:13.000000', 'consum', 0.0231, 'lps'),
	(612304, 129, '2014-04-01 00:46:14.000000', 'consum', 0.0226, 'lps'),
	(612305, 129, '2014-04-01 00:46:15.000000', 'consum', 0.0227, 'lps'),
	(612306, 129, '2014-04-01 00:46:16.000000', 'consum', 0.0226, 'lps'),
	(612307, 129, '2014-04-01 00:46:17.000000', 'consum', 0.0214, 'lps'),
	(612308, 129, '2014-04-01 00:46:18.000000', 'consum', 0.0233, 'lps'),
	(612309, 129, '2014-04-01 00:46:19.000000', 'consum', 0.0215, 'lps'),
	(612310, 129, '2014-04-01 00:46:20.000000', 'consum', 0.0213, 'lps'),
	(612311, 129, '2014-04-01 00:46:21.000000', 'consum', 0.0213, 'lps'),
	(612312, 129, '2014-04-01 00:46:22.000000', 'consum', 0.0215, 'lps'),
	(612313, 129, '2014-04-01 00:46:23.000000', 'consum', 0.0226, 'lps'),
	(612314, 129, '2014-04-01 00:46:24.000000', 'consum', 0.0230, 'lps'),
	(612315, 129, '2014-04-01 00:46:25.000000', 'consum', 0.0212, 'lps'),
	(612316, 129, '2014-04-01 00:46:26.000000', 'consum', 0.0233, 'lps'),
	(612317, 129, '2014-04-01 00:46:27.000000', 'consum', 0.0223, 'lps'),
	(612318, 129, '2014-04-01 00:46:28.000000', 'consum', 0.0231, 'lps'),
	(612319, 129, '2014-04-01 00:46:29.000000', 'consum', 0.0227, 'lps'),
	(612320, 129, '2014-04-01 00:46:30.000000', 'consum', 0.0210, 'lps'),
	(612321, 129, '2014-04-01 00:46:31.000000', 'consum', 0.0231, 'lps'),
	(612322, 129, '2014-04-01 00:46:32.000000', 'consum', 0.0221, 'lps'),
	(612323, 129, '2014-04-01 00:46:33.000000', 'consum', 0.0227, 'lps'),
	(612324, 129, '2014-04-01 00:46:34.000000', 'consum', 0.0213, 'lps'),
	(612325, 129, '2014-04-01 00:46:35.000000', 'consum', 0.0222, 'lps'),
	(612326, 129, '2014-04-01 00:46:36.000000', 'consum', 0.0216, 'lps'),
	(612327, 129, '2014-04-01 00:46:37.000000', 'consum', 0.0227, 'lps'),
	(612328, 129, '2014-04-01 00:46:38.000000', 'consum', 0.0229, 'lps'),
	(612329, 129, '2014-04-01 00:46:39.000000', 'consum', 0.0229, 'lps'),
	(612330, 129, '2014-04-01 00:46:40.000000', 'consum', 0.0227, 'lps'),
	(612331, 129, '2014-04-01 00:46:41.000000', 'consum', 0.0212, 'lps'),
	(612332, 129, '2014-04-01 00:46:42.000000', 'consum', 0.0220, 'lps'),
	(612333, 129, '2014-04-01 00:46:43.000000', 'consum', 0.0229, 'lps'),
	(612334, 129, '2014-04-01 00:46:44.000000', 'consum', 0.0226, 'lps'),
	(612335, 129, '2014-04-01 00:46:45.000000', 'consum', 0.0212, 'lps'),
	(612336, 129, '2014-04-01 00:46:46.000000', 'consum', 0.0218, 'lps'),
	(612337, 129, '2014-04-01 00:46:47.000000', 'consum', 0.0224, 'lps'),
	(612338, 129, '2014-04-01 00:46:48.000000', 'consum', 0.0230, 'lps'),
	(612339, 129, '2014-04-01 00:46:49.000000', 'consum', 0.0221, 'lps'),
	(612340, 129, '2014-04-01 00:46:50.000000', 'consum', 0.0230, 'lps'),
	(612341, 129, '2014-04-01 00:46:51.000000', 'consum', 0.0229, 'lps'),
	(612342, 129, '2014-04-01 00:46:52.000000', 'consum', 0.0222, 'lps'),
	(612343, 129, '2014-04-01 00:46:53.000000', 'consum', 0.0214, 'lps'),
	(612344, 129, '2014-04-01 00:46:54.000000', 'consum', 0.0219, 'lps'),
	(612345, 129, '2014-04-01 00:46:55.000000', 'consum', 0.0220, 'lps'),
	(612346, 129, '2014-04-01 00:46:56.000000', 'consum', 0.0231, 'lps'),
	(612347, 129, '2014-04-01 00:46:57.000000', 'consum', 0.0215, 'lps'),
	(612348, 129, '2014-04-01 00:46:58.000000', 'consum', 0.0219, 'lps'),
	(612349, 129, '2014-04-01 00:46:59.000000', 'consum', 0.0216, 'lps'),
	(612350, 129, '2014-04-01 00:47:00.000000', 'consum', 0.0213, 'lps'),
	(612351, 129, '2014-04-01 00:47:01.000000', 'consum', 0.0232, 'lps'),
	(612352, 129, '2014-04-01 00:47:02.000000', 'consum', 0.0215, 'lps'),
	(612353, 129, '2014-04-01 00:47:03.000000', 'consum', 0.0218, 'lps'),
	(612354, 129, '2014-04-01 00:47:04.000000', 'consum', 0.0212, 'lps'),
	(612355, 129, '2014-04-01 00:47:05.000000', 'consum', 0.0218, 'lps'),
	(612356, 129, '2014-04-01 00:47:06.000000', 'consum', 0.0224, 'lps'),
	(612357, 129, '2014-04-01 00:47:07.000000', 'consum', 0.0232, 'lps'),
	(612358, 129, '2014-04-01 00:47:08.000000', 'consum', 0.0228, 'lps'),
	(612359, 129, '2014-04-01 00:47:09.000000', 'consum', 0.0213, 'lps'),
	(612360, 129, '2014-04-01 00:47:10.000000', 'consum', 0.0218, 'lps'),
	(612361, 129, '2014-04-01 00:47:11.000000', 'consum', 0.0219, 'lps'),
	(612362, 129, '2014-04-01 00:47:12.000000', 'consum', 0.0231, 'lps'),
	(612363, 129, '2014-04-01 00:47:13.000000', 'consum', 0.0215, 'lps'),
	(612364, 129, '2014-04-01 00:47:14.000000', 'consum', 0.0220, 'lps'),
	(612365, 129, '2014-04-01 00:47:15.000000', 'consum', 0.0222, 'lps'),
	(612366, 129, '2014-04-01 00:47:16.000000', 'consum', 0.0217, 'lps'),
	(612367, 129, '2014-04-01 00:47:17.000000', 'consum', 0.0231, 'lps'),
	(612368, 129, '2014-04-01 00:47:18.000000', 'consum', 0.0226, 'lps'),
	(612369, 129, '2014-04-01 00:47:19.000000', 'consum', 0.0225, 'lps'),
	(612370, 129, '2014-04-01 00:47:20.000000', 'consum', 0.0215, 'lps'),
	(612371, 129, '2014-04-01 00:47:21.000000', 'consum', 0.0215, 'lps'),
	(612372, 129, '2014-04-01 00:47:22.000000', 'consum', 0.0220, 'lps'),
	(612373, 129, '2014-04-01 00:47:23.000000', 'consum', 0.0221, 'lps'),
	(612374, 129, '2014-04-01 00:47:24.000000', 'consum', 0.0210, 'lps'),
	(612375, 129, '2014-04-01 00:47:25.000000', 'consum', 0.0226, 'lps'),
	(612376, 129, '2014-04-01 00:47:26.000000', 'consum', 0.0218, 'lps'),
	(612377, 129, '2014-04-01 00:47:27.000000', 'consum', 0.0229, 'lps'),
	(612378, 129, '2014-04-01 00:47:28.000000', 'consum', 0.0232, 'lps'),
	(612379, 129, '2014-04-01 00:47:29.000000', 'consum', 0.0216, 'lps'),
	(612380, 129, '2014-04-01 00:47:30.000000', 'consum', 0.0220, 'lps'),
	(612381, 129, '2014-04-01 00:47:31.000000', 'consum', 0.0221, 'lps'),
	(612382, 129, '2014-04-01 00:47:32.000000', 'consum', 0.0212, 'lps'),
	(612383, 129, '2014-04-01 00:47:33.000000', 'consum', 0.0233, 'lps'),
	(612384, 129, '2014-04-01 00:47:34.000000', 'consum', 0.0223, 'lps'),
	(612385, 129, '2014-04-01 00:47:35.000000', 'consum', 0.0232, 'lps'),
	(612386, 129, '2014-04-01 00:47:36.000000', 'consum', 0.0210, 'lps'),
	(612387, 129, '2014-04-01 00:47:37.000000', 'consum', 0.0216, 'lps'),
	(612388, 129, '2014-04-01 00:47:38.000000', 'consum', 0.0217, 'lps'),
	(612389, 129, '2014-04-01 00:47:39.000000', 'consum', 0.0228, 'lps'),
	(612390, 129, '2014-04-01 00:47:40.000000', 'consum', 0.0232, 'lps'),
	(612391, 129, '2014-04-01 00:47:41.000000', 'consum', 0.0218, 'lps'),
	(612392, 129, '2014-04-01 00:47:42.000000', 'consum', 0.0231, 'lps'),
	(612393, 129, '2014-04-01 00:47:43.000000', 'consum', 0.0220, 'lps'),
	(612394, 129, '2014-04-01 00:47:44.000000', 'consum', 0.0222, 'lps'),
	(612395, 129, '2014-04-01 00:47:45.000000', 'consum', 0.0217, 'lps'),
	(612396, 129, '2014-04-01 00:47:46.000000', 'consum', 0.0231, 'lps'),
	(612397, 129, '2014-04-01 00:47:47.000000', 'consum', 0.0224, 'lps'),
	(612398, 129, '2014-04-01 00:47:48.000000', 'consum', 0.0217, 'lps'),
	(612399, 129, '2014-04-01 00:47:49.000000', 'consum', 0.0229, 'lps'),
	(612400, 129, '2014-04-01 00:47:50.000000', 'consum', 0.0210, 'lps'),
	(612401, 129, '2014-04-01 00:47:51.000000', 'consum', 0.0227, 'lps'),
	(612402, 129, '2014-04-01 00:47:52.000000', 'consum', 0.0222, 'lps'),
	(612403, 129, '2014-04-01 00:47:53.000000', 'consum', 0.0221, 'lps'),
	(612404, 129, '2014-04-01 00:47:54.000000', 'consum', 0.0227, 'lps'),
	(612405, 129, '2014-04-01 00:47:55.000000', 'consum', 0.0216, 'lps'),
	(612406, 129, '2014-04-01 00:47:56.000000', 'consum', 0.0215, 'lps'),
	(612407, 129, '2014-04-01 00:47:57.000000', 'consum', 0.0216, 'lps'),
	(612408, 129, '2014-04-01 00:47:58.000000', 'consum', 0.0226, 'lps'),
	(612409, 129, '2014-04-01 00:47:59.000000', 'consum', 0.0223, 'lps'),
	(612410, 129, '2014-04-01 00:48:00.000000', 'consum', 0.0229, 'lps'),
	(612411, 129, '2014-04-01 00:48:01.000000', 'consum', 0.0218, 'lps'),
	(612412, 129, '2014-04-01 00:48:02.000000', 'consum', 0.0216, 'lps'),
	(612413, 129, '2014-04-01 00:48:03.000000', 'consum', 0.0218, 'lps'),
	(612414, 129, '2014-04-01 00:48:04.000000', 'consum', 0.0210, 'lps'),
	(612415, 129, '2014-04-01 00:48:05.000000', 'consum', 0.0211, 'lps'),
	(612416, 129, '2014-04-01 00:48:06.000000', 'consum', 0.0213, 'lps'),
	(612417, 129, '2014-04-01 00:48:07.000000', 'consum', 0.0222, 'lps'),
	(612418, 129, '2014-04-01 00:48:08.000000', 'consum', 0.0216, 'lps'),
	(612419, 129, '2014-04-01 00:48:09.000000', 'consum', 0.0226, 'lps'),
	(612420, 129, '2014-04-01 00:48:10.000000', 'consum', 0.0225, 'lps'),
	(612421, 129, '2014-04-01 00:48:11.000000', 'consum', 0.0212, 'lps'),
	(612422, 129, '2014-04-01 00:48:12.000000', 'consum', 0.0224, 'lps'),
	(612423, 129, '2014-04-01 00:48:13.000000', 'consum', 0.0226, 'lps'),
	(612424, 129, '2014-04-01 00:48:14.000000', 'consum', 0.0223, 'lps'),
	(612425, 129, '2014-04-01 00:48:15.000000', 'consum', 0.0230, 'lps'),
	(612426, 129, '2014-04-01 00:48:16.000000', 'consum', 0.0221, 'lps'),
	(612427, 129, '2014-04-01 00:48:17.000000', 'consum', 0.0233, 'lps'),
	(612428, 129, '2014-04-01 00:48:18.000000', 'consum', 0.0217, 'lps'),
	(612429, 129, '2014-04-01 00:48:19.000000', 'consum', 0.0227, 'lps'),
	(612430, 129, '2014-04-01 00:48:20.000000', 'consum', 0.0224, 'lps'),
	(612431, 129, '2014-04-01 00:48:21.000000', 'consum', 0.0233, 'lps'),
	(612432, 129, '2014-04-01 00:48:22.000000', 'consum', 0.0232, 'lps'),
	(612433, 129, '2014-04-01 00:48:23.000000', 'consum', 0.0230, 'lps'),
	(612434, 129, '2014-04-01 00:48:24.000000', 'consum', 0.0221, 'lps'),
	(612435, 129, '2014-04-01 00:48:25.000000', 'consum', 0.0228, 'lps'),
	(612436, 129, '2014-04-01 00:48:26.000000', 'consum', 0.0219, 'lps'),
	(612437, 129, '2014-04-01 00:48:27.000000', 'consum', 0.0224, 'lps'),
	(612438, 129, '2014-04-01 00:48:28.000000', 'consum', 0.0233, 'lps'),
	(612439, 129, '2014-04-01 00:48:29.000000', 'consum', 0.0210, 'lps'),
	(612440, 129, '2014-04-01 00:48:30.000000', 'consum', 0.0215, 'lps'),
	(612441, 129, '2014-04-01 00:48:31.000000', 'consum', 0.0210, 'lps'),
	(612442, 129, '2014-04-01 00:48:32.000000', 'consum', 0.0220, 'lps'),
	(612443, 129, '2014-04-01 00:48:33.000000', 'consum', 0.0211, 'lps'),
	(612444, 129, '2014-04-01 00:48:34.000000', 'consum', 0.0210, 'lps'),
	(612445, 129, '2014-04-01 00:48:35.000000', 'consum', 0.0230, 'lps'),
	(612446, 129, '2014-04-01 00:48:36.000000', 'consum', 0.0215, 'lps'),
	(612447, 129, '2014-04-01 00:48:37.000000', 'consum', 0.0223, 'lps'),
	(612448, 129, '2014-04-01 00:48:38.000000', 'consum', 0.0212, 'lps'),
	(612449, 129, '2014-04-01 00:48:39.000000', 'consum', 0.0232, 'lps'),
	(612450, 129, '2014-04-01 00:48:40.000000', 'consum', 0.0217, 'lps'),
	(612451, 129, '2014-04-01 00:48:41.000000', 'consum', 0.0226, 'lps'),
	(612452, 129, '2014-04-01 00:48:42.000000', 'consum', 0.0224, 'lps'),
	(612453, 129, '2014-04-01 00:48:43.000000', 'consum', 0.0233, 'lps'),
	(612454, 129, '2014-04-01 00:48:44.000000', 'consum', 0.0210, 'lps'),
	(612455, 129, '2014-04-01 00:48:45.000000', 'consum', 0.0212, 'lps'),
	(612456, 129, '2014-04-01 00:48:46.000000', 'consum', 0.0221, 'lps'),
	(612457, 129, '2014-04-01 00:48:47.000000', 'consum', 0.0213, 'lps'),
	(612458, 129, '2014-04-01 00:48:48.000000', 'consum', 0.0215, 'lps'),
	(612459, 129, '2014-04-01 00:48:49.000000', 'consum', 0.0229, 'lps'),
	(612460, 129, '2014-04-01 00:48:50.000000', 'consum', 0.0215, 'lps'),
	(612461, 129, '2014-04-01 00:48:51.000000', 'consum', 0.0230, 'lps'),
	(612462, 129, '2014-04-01 00:48:52.000000', 'consum', 0.0222, 'lps'),
	(612463, 129, '2014-04-01 00:48:53.000000', 'consum', 0.0233, 'lps'),
	(612464, 129, '2014-04-01 00:48:54.000000', 'consum', 0.0220, 'lps'),
	(612465, 129, '2014-04-01 00:48:55.000000', 'consum', 0.0217, 'lps'),
	(612466, 129, '2014-04-01 00:48:56.000000', 'consum', 0.0212, 'lps'),
	(612467, 129, '2014-04-01 00:48:57.000000', 'consum', 0.0225, 'lps'),
	(612468, 129, '2014-04-01 00:48:58.000000', 'consum', 0.0233, 'lps'),
	(612469, 129, '2014-04-01 00:48:59.000000', 'consum', 0.0233, 'lps'),
	(612470, 129, '2014-04-01 00:49:00.000000', 'consum', 0.0231, 'lps'),
	(612471, 129, '2014-04-01 00:49:01.000000', 'consum', 0.0223, 'lps'),
	(612472, 129, '2014-04-01 00:49:02.000000', 'consum', 0.0212, 'lps'),
	(612473, 129, '2014-04-01 00:49:03.000000', 'consum', 0.0229, 'lps'),
	(612474, 129, '2014-04-01 00:49:04.000000', 'consum', 0.0228, 'lps'),
	(612475, 129, '2014-04-01 00:49:05.000000', 'consum', 0.0220, 'lps'),
	(612476, 129, '2014-04-01 00:49:06.000000', 'consum', 0.0228, 'lps'),
	(612477, 129, '2014-04-01 00:49:07.000000', 'consum', 0.0224, 'lps'),
	(612478, 129, '2014-04-01 00:49:08.000000', 'consum', 0.0227, 'lps'),
	(612479, 129, '2014-04-01 00:49:09.000000', 'consum', 0.0230, 'lps'),
	(612480, 129, '2014-04-01 00:49:10.000000', 'consum', 0.0233, 'lps'),
	(612481, 129, '2014-04-01 00:49:11.000000', 'consum', 0.0220, 'lps'),
	(612482, 129, '2014-04-01 00:49:12.000000', 'consum', 0.0216, 'lps'),
	(612483, 129, '2014-04-01 00:49:13.000000', 'consum', 0.0210, 'lps'),
	(612484, 129, '2014-04-01 00:49:14.000000', 'consum', 0.0216, 'lps'),
	(612485, 129, '2014-04-01 00:49:15.000000', 'consum', 0.0217, 'lps'),
	(612486, 129, '2014-04-01 00:49:16.000000', 'consum', 0.0228, 'lps'),
	(612487, 129, '2014-04-01 00:49:17.000000', 'consum', 0.0231, 'lps'),
	(612488, 129, '2014-04-01 00:49:18.000000', 'consum', 0.0213, 'lps'),
	(612489, 129, '2014-04-01 00:49:19.000000', 'consum', 0.0212, 'lps'),
	(612490, 129, '2014-04-01 00:49:20.000000', 'consum', 0.0211, 'lps'),
	(612491, 129, '2014-04-01 00:49:21.000000', 'consum', 0.0232, 'lps'),
	(612492, 129, '2014-04-01 00:49:22.000000', 'consum', 0.0224, 'lps'),
	(612493, 129, '2014-04-01 00:49:23.000000', 'consum', 0.0212, 'lps'),
	(612494, 129, '2014-04-01 00:49:24.000000', 'consum', 0.0228, 'lps'),
	(612495, 129, '2014-04-01 00:49:25.000000', 'consum', 0.0223, 'lps'),
	(612496, 129, '2014-04-01 00:49:26.000000', 'consum', 0.0222, 'lps'),
	(612497, 129, '2014-04-01 00:49:27.000000', 'consum', 0.0229, 'lps'),
	(612498, 129, '2014-04-01 00:49:28.000000', 'consum', 0.0221, 'lps'),
	(612499, 129, '2014-04-01 00:49:29.000000', 'consum', 0.0233, 'lps'),
	(612500, 129, '2014-04-01 00:49:30.000000', 'consum', 0.0223, 'lps'),
	(612501, 129, '2014-04-01 00:49:31.000000', 'consum', 0.0227, 'lps'),
	(612502, 129, '2014-04-01 00:49:32.000000', 'consum', 0.0211, 'lps'),
	(612503, 129, '2014-04-01 00:49:33.000000', 'consum', 0.0212, 'lps'),
	(612504, 129, '2014-04-01 00:49:34.000000', 'consum', 0.0216, 'lps'),
	(612505, 129, '2014-04-01 00:49:35.000000', 'consum', 0.0212, 'lps'),
	(612506, 129, '2014-04-01 00:49:36.000000', 'consum', 0.0226, 'lps'),
	(612507, 129, '2014-04-01 00:49:37.000000', 'consum', 0.0211, 'lps'),
	(612508, 129, '2014-04-01 00:49:38.000000', 'consum', 0.0216, 'lps'),
	(612509, 129, '2014-04-01 00:49:39.000000', 'consum', 0.0215, 'lps'),
	(612510, 129, '2014-04-01 00:49:40.000000', 'consum', 0.0216, 'lps'),
	(612511, 129, '2014-04-01 00:49:41.000000', 'consum', 0.0224, 'lps'),
	(612512, 129, '2014-04-01 00:49:42.000000', 'consum', 0.0218, 'lps'),
	(612513, 129, '2014-04-01 00:49:43.000000', 'consum', 0.0230, 'lps'),
	(612514, 129, '2014-04-01 00:49:44.000000', 'consum', 0.0215, 'lps'),
	(612515, 129, '2014-04-01 00:49:45.000000', 'consum', 0.0225, 'lps'),
	(612516, 129, '2014-04-01 00:49:46.000000', 'consum', 0.0223, 'lps'),
	(612517, 129, '2014-04-01 00:49:47.000000', 'consum', 0.0229, 'lps'),
	(612518, 129, '2014-04-01 00:49:48.000000', 'consum', 0.0217, 'lps'),
	(612519, 129, '2014-04-01 00:49:49.000000', 'consum', 0.0216, 'lps'),
	(612520, 129, '2014-04-01 00:49:50.000000', 'consum', 0.0217, 'lps'),
	(612521, 129, '2014-04-01 00:49:51.000000', 'consum', 0.0229, 'lps'),
	(612522, 129, '2014-04-01 00:49:52.000000', 'consum', 0.0210, 'lps'),
	(612523, 129, '2014-04-01 00:49:53.000000', 'consum', 0.0228, 'lps'),
	(612524, 129, '2014-04-01 00:49:54.000000', 'consum', 0.0226, 'lps'),
	(612525, 129, '2014-04-01 00:49:55.000000', 'consum', 0.0213, 'lps'),
	(612526, 129, '2014-04-01 00:49:56.000000', 'consum', 0.0228, 'lps'),
	(612527, 129, '2014-04-01 00:49:57.000000', 'consum', 0.0217, 'lps'),
	(612528, 129, '2014-04-01 00:49:58.000000', 'consum', 0.0216, 'lps'),
	(612529, 129, '2014-04-01 00:49:59.000000', 'consum', 0.0218, 'lps'),
	(612530, 129, '2014-04-01 00:50:00.000000', 'consum', 0.0233, 'lps'),
	(612531, 129, '2014-04-01 00:50:01.000000', 'consum', 0.0231, 'lps'),
	(612532, 129, '2014-04-01 00:50:02.000000', 'consum', 0.0221, 'lps'),
	(612533, 129, '2014-04-01 00:50:03.000000', 'consum', 0.0225, 'lps'),
	(612534, 129, '2014-04-01 00:50:04.000000', 'consum', 0.0230, 'lps'),
	(612535, 129, '2014-04-01 00:50:05.000000', 'consum', 0.0219, 'lps'),
	(612536, 129, '2014-04-01 00:50:06.000000', 'consum', 0.0220, 'lps'),
	(612537, 129, '2014-04-01 00:50:07.000000', 'consum', 0.0233, 'lps'),
	(612538, 129, '2014-04-01 00:50:08.000000', 'consum', 0.0222, 'lps'),
	(612539, 129, '2014-04-01 00:50:09.000000', 'consum', 0.0225, 'lps'),
	(612540, 129, '2014-04-01 00:50:10.000000', 'consum', 0.0228, 'lps'),
	(612541, 129, '2014-04-01 00:50:11.000000', 'consum', 0.0230, 'lps'),
	(612542, 129, '2014-04-01 00:50:12.000000', 'consum', 0.0233, 'lps'),
	(612543, 129, '2014-04-01 00:50:13.000000', 'consum', 0.0217, 'lps'),
	(612544, 129, '2014-04-01 00:50:14.000000', 'consum', 0.0225, 'lps'),
	(612545, 129, '2014-04-01 00:50:15.000000', 'consum', 0.0215, 'lps'),
	(612546, 129, '2014-04-01 00:50:16.000000', 'consum', 0.0217, 'lps'),
	(612547, 129, '2014-04-01 00:50:17.000000', 'consum', 0.0228, 'lps'),
	(612548, 129, '2014-04-01 00:50:18.000000', 'consum', 0.0232, 'lps'),
	(612549, 129, '2014-04-01 00:50:19.000000', 'consum', 0.0220, 'lps'),
	(612550, 129, '2014-04-01 00:50:20.000000', 'consum', 0.0216, 'lps'),
	(612551, 129, '2014-04-01 00:50:21.000000', 'consum', 0.0210, 'lps'),
	(612552, 129, '2014-04-01 00:50:22.000000', 'consum', 0.0218, 'lps'),
	(612553, 129, '2014-04-01 00:50:23.000000', 'consum', 0.0225, 'lps'),
	(612554, 129, '2014-04-01 00:50:24.000000', 'consum', 0.0213, 'lps'),
	(612555, 129, '2014-04-01 00:50:25.000000', 'consum', 0.0229, 'lps'),
	(612556, 129, '2014-04-01 00:50:26.000000', 'consum', 0.0226, 'lps'),
	(612557, 129, '2014-04-01 00:50:27.000000', 'consum', 0.0231, 'lps'),
	(612558, 129, '2014-04-01 00:50:28.000000', 'consum', 0.0220, 'lps'),
	(612559, 129, '2014-04-01 00:50:29.000000', 'consum', 0.0223, 'lps'),
	(612560, 129, '2014-04-01 00:50:30.000000', 'consum', 0.0222, 'lps'),
	(612561, 129, '2014-04-01 00:50:31.000000', 'consum', 0.0230, 'lps'),
	(612562, 129, '2014-04-01 00:50:32.000000', 'consum', 0.0227, 'lps'),
	(612563, 129, '2014-04-01 00:50:33.000000', 'consum', 0.0210, 'lps'),
	(612564, 129, '2014-04-01 00:50:34.000000', 'consum', 0.0232, 'lps'),
	(612565, 129, '2014-04-01 00:50:35.000000', 'consum', 0.0223, 'lps'),
	(612566, 129, '2014-04-01 00:50:36.000000', 'consum', 0.0212, 'lps'),
	(612567, 129, '2014-04-01 00:50:37.000000', 'consum', 0.0228, 'lps'),
	(612568, 129, '2014-04-01 00:50:38.000000', 'consum', 0.0224, 'lps'),
	(612569, 129, '2014-04-01 00:50:39.000000', 'consum', 0.0227, 'lps'),
	(612570, 129, '2014-04-01 00:50:40.000000', 'consum', 0.0229, 'lps'),
	(612571, 129, '2014-04-01 00:50:41.000000', 'consum', 0.0232, 'lps'),
	(612572, 129, '2014-04-01 00:50:42.000000', 'consum', 0.0213, 'lps'),
	(612573, 129, '2014-04-01 00:50:43.000000', 'consum', 0.0232, 'lps'),
	(612574, 129, '2014-04-01 00:50:44.000000', 'consum', 0.0214, 'lps'),
	(612575, 129, '2014-04-01 00:50:45.000000', 'consum', 0.0215, 'lps'),
	(612576, 129, '2014-04-01 00:50:46.000000', 'consum', 0.0224, 'lps'),
	(612577, 129, '2014-04-01 00:50:47.000000', 'consum', 0.0217, 'lps'),
	(612578, 129, '2014-04-01 00:50:48.000000', 'consum', 0.0229, 'lps'),
	(612579, 129, '2014-04-01 00:50:49.000000', 'consum', 0.0210, 'lps'),
	(612580, 129, '2014-04-01 00:50:50.000000', 'consum', 0.0225, 'lps'),
	(612581, 129, '2014-04-01 00:50:51.000000', 'consum', 0.0213, 'lps'),
	(612582, 129, '2014-04-01 00:50:52.000000', 'consum', 0.0229, 'lps'),
	(612583, 129, '2014-04-01 00:50:53.000000', 'consum', 0.0227, 'lps'),
	(612584, 129, '2014-04-01 00:50:54.000000', 'consum', 0.0213, 'lps'),
	(612585, 129, '2014-04-01 00:50:55.000000', 'consum', 0.0221, 'lps'),
	(612586, 129, '2014-04-01 00:50:56.000000', 'consum', 0.0232, 'lps'),
	(612587, 129, '2014-04-01 00:50:57.000000', 'consum', 0.0216, 'lps'),
	(612588, 129, '2014-04-01 00:50:58.000000', 'consum', 0.0224, 'lps'),
	(612589, 129, '2014-04-01 00:50:59.000000', 'consum', 0.0214, 'lps'),
	(612590, 129, '2014-04-01 00:51:00.000000', 'consum', 0.0213, 'lps'),
	(612591, 129, '2014-04-01 00:51:01.000000', 'consum', 0.0214, 'lps'),
	(612592, 129, '2014-04-01 00:51:02.000000', 'consum', 0.0219, 'lps'),
	(612593, 129, '2014-04-01 00:51:03.000000', 'consum', 0.0220, 'lps'),
	(612594, 129, '2014-04-01 00:51:04.000000', 'consum', 0.0211, 'lps'),
	(612595, 129, '2014-04-01 00:51:05.000000', 'consum', 0.0232, 'lps'),
	(612596, 129, '2014-04-01 00:51:06.000000', 'consum', 0.0220, 'lps'),
	(612597, 129, '2014-04-01 00:51:07.000000', 'consum', 0.0220, 'lps'),
	(612598, 129, '2014-04-01 00:51:08.000000', 'consum', 0.0229, 'lps'),
	(612599, 129, '2014-04-01 00:51:09.000000', 'consum', 0.0229, 'lps'),
	(612600, 129, '2014-04-01 00:51:10.000000', 'consum', 0.0225, 'lps'),
	(612601, 129, '2014-04-01 00:51:11.000000', 'consum', 0.0228, 'lps'),
	(612602, 129, '2014-04-01 00:51:12.000000', 'consum', 0.0231, 'lps'),
	(612603, 129, '2014-04-01 00:51:13.000000', 'consum', 0.0212, 'lps'),
	(612604, 129, '2014-04-01 00:51:14.000000', 'consum', 0.0233, 'lps'),
	(612605, 129, '2014-04-01 00:51:15.000000', 'consum', 0.0220, 'lps'),
	(612606, 129, '2014-04-01 00:51:16.000000', 'consum', 0.0217, 'lps'),
	(612607, 129, '2014-04-01 00:51:17.000000', 'consum', 0.0215, 'lps'),
	(612608, 129, '2014-04-01 00:51:18.000000', 'consum', 0.0217, 'lps'),
	(612609, 129, '2014-04-01 00:51:19.000000', 'consum', 0.0227, 'lps'),
	(612610, 129, '2014-04-01 00:51:20.000000', 'consum', 0.0230, 'lps'),
	(612611, 129, '2014-04-01 00:51:21.000000', 'consum', 0.0210, 'lps'),
	(612612, 129, '2014-04-01 00:51:22.000000', 'consum', 0.0223, 'lps'),
	(612613, 129, '2014-04-01 00:51:23.000000', 'consum', 0.0226, 'lps'),
	(612614, 129, '2014-04-01 00:51:24.000000', 'consum', 0.0226, 'lps'),
	(612615, 129, '2014-04-01 00:51:25.000000', 'consum', 0.0221, 'lps'),
	(612616, 129, '2014-04-01 00:51:26.000000', 'consum', 0.0217, 'lps'),
	(612617, 129, '2014-04-01 00:51:27.000000', 'consum', 0.0211, 'lps'),
	(612618, 129, '2014-04-01 00:51:28.000000', 'consum', 0.0220, 'lps'),
	(612619, 129, '2014-04-01 00:51:29.000000', 'consum', 0.0231, 'lps'),
	(612620, 129, '2014-04-01 00:51:30.000000', 'consum', 0.0216, 'lps'),
	(612621, 129, '2014-04-01 00:51:31.000000', 'consum', 0.0223, 'lps'),
	(612622, 129, '2014-04-01 00:51:32.000000', 'consum', 0.0211, 'lps'),
	(612623, 129, '2014-04-01 00:51:33.000000', 'consum', 0.0225, 'lps'),
	(612624, 129, '2014-04-01 00:51:34.000000', 'consum', 0.0232, 'lps'),
	(612625, 129, '2014-04-01 00:51:35.000000', 'consum', 0.0230, 'lps'),
	(612626, 129, '2014-04-01 00:51:36.000000', 'consum', 0.0218, 'lps'),
	(612627, 129, '2014-04-01 00:51:37.000000', 'consum', 0.0215, 'lps'),
	(612628, 129, '2014-04-01 00:51:38.000000', 'consum', 0.0214, 'lps'),
	(612629, 129, '2014-04-01 00:51:39.000000', 'consum', 0.0213, 'lps'),
	(612630, 129, '2014-04-01 00:51:40.000000', 'consum', 0.0216, 'lps'),
	(612631, 129, '2014-04-01 00:51:41.000000', 'consum', 0.0231, 'lps'),
	(612632, 129, '2014-04-01 00:51:42.000000', 'consum', 0.0224, 'lps'),
	(612633, 129, '2014-04-01 00:51:43.000000', 'consum', 0.0220, 'lps'),
	(612634, 129, '2014-04-01 00:51:44.000000', 'consum', 0.0217, 'lps'),
	(612635, 129, '2014-04-01 00:51:45.000000', 'consum', 0.0214, 'lps'),
	(612636, 129, '2014-04-01 00:51:46.000000', 'consum', 0.0210, 'lps'),
	(612637, 129, '2014-04-01 00:51:47.000000', 'consum', 0.0224, 'lps'),
	(612638, 129, '2014-04-01 00:51:48.000000', 'consum', 0.0210, 'lps'),
	(612639, 129, '2014-04-01 00:51:49.000000', 'consum', 0.0213, 'lps'),
	(612640, 129, '2014-04-01 00:51:50.000000', 'consum', 0.0227, 'lps'),
	(612641, 129, '2014-04-01 00:51:51.000000', 'consum', 0.0213, 'lps'),
	(612642, 129, '2014-04-01 00:51:52.000000', 'consum', 0.0225, 'lps'),
	(612643, 129, '2014-04-01 00:51:53.000000', 'consum', 0.0229, 'lps'),
	(612644, 129, '2014-04-01 00:51:54.000000', 'consum', 0.0213, 'lps'),
	(612645, 129, '2014-04-01 00:51:55.000000', 'consum', 0.0215, 'lps'),
	(612646, 129, '2014-04-01 00:51:56.000000', 'consum', 0.0226, 'lps'),
	(612647, 129, '2014-04-01 00:51:57.000000', 'consum', 0.0227, 'lps'),
	(612648, 129, '2014-04-01 00:51:58.000000', 'consum', 0.0223, 'lps'),
	(612649, 129, '2014-04-01 00:51:59.000000', 'consum', 0.0225, 'lps'),
	(612650, 129, '2014-04-01 00:52:00.000000', 'consum', 0.0225, 'lps'),
	(612651, 129, '2014-04-01 00:52:01.000000', 'consum', 0.0213, 'lps'),
	(612652, 129, '2014-04-01 00:52:02.000000', 'consum', 0.0230, 'lps'),
	(612653, 129, '2014-04-01 00:52:03.000000', 'consum', 0.0231, 'lps'),
	(612654, 129, '2014-04-01 00:52:04.000000', 'consum', 0.0230, 'lps'),
	(612655, 129, '2014-04-01 00:52:05.000000', 'consum', 0.0222, 'lps'),
	(612656, 129, '2014-04-01 00:52:06.000000', 'consum', 0.0213, 'lps'),
	(612657, 129, '2014-04-01 00:52:07.000000', 'consum', 0.0213, 'lps'),
	(612658, 129, '2014-04-01 00:52:08.000000', 'consum', 0.0217, 'lps'),
	(612659, 130, '2014-04-01 00:00:00.000000', 'consum', 0.0219, 'lps'),
	(612660, 130, '2014-04-01 00:00:01.000000', 'consum', 0.0210, 'lps'),
	(612661, 130, '2014-04-01 00:00:02.000000', 'consum', 0.0218, 'lps'),
	(612662, 130, '2014-04-01 00:00:03.000000', 'consum', 0.0217, 'lps'),
	(612663, 130, '2014-04-01 00:00:04.000000', 'consum', 0.0221, 'lps'),
	(612664, 130, '2014-04-01 00:00:05.000000', 'consum', 0.0220, 'lps'),
	(612665, 130, '2014-04-01 00:00:06.000000', 'consum', 0.0215, 'lps'),
	(612666, 130, '2014-04-01 00:00:07.000000', 'consum', 0.0217, 'lps'),
	(612667, 130, '2014-04-01 00:00:08.000000', 'consum', 0.0218, 'lps'),
	(612668, 130, '2014-04-01 00:00:09.000000', 'consum', 0.0217, 'lps'),
	(612669, 130, '2014-04-01 00:00:10.000000', 'consum', 0.0221, 'lps'),
	(612670, 130, '2014-04-01 00:00:11.000000', 'consum', 0.0212, 'lps'),
	(612671, 130, '2014-04-01 00:00:12.000000', 'consum', 0.0220, 'lps'),
	(612672, 130, '2014-04-01 00:00:13.000000', 'consum', 0.0221, 'lps'),
	(612673, 130, '2014-04-01 00:00:14.000000', 'consum', 0.0221, 'lps'),
	(612674, 130, '2014-04-01 00:00:15.000000', 'consum', 0.0220, 'lps'),
	(612675, 130, '2014-04-01 00:00:16.000000', 'consum', 0.0215, 'lps'),
	(612676, 130, '2014-04-01 00:00:17.000000', 'consum', 0.0220, 'lps'),
	(612677, 130, '2014-04-01 00:00:18.000000', 'consum', 0.0221, 'lps'),
	(612678, 130, '2014-04-01 00:00:19.000000', 'consum', 0.0213, 'lps'),
	(612679, 130, '2014-04-01 00:00:20.000000', 'consum', 0.0214, 'lps'),
	(612680, 130, '2014-04-01 00:00:21.000000', 'consum', 0.0210, 'lps'),
	(612681, 130, '2014-04-01 00:00:22.000000', 'consum', 0.0213, 'lps'),
	(612682, 130, '2014-04-01 00:00:23.000000', 'consum', 0.0211, 'lps'),
	(612683, 130, '2014-04-01 00:00:24.000000', 'consum', 0.0219, 'lps'),
	(612684, 130, '2014-04-01 00:00:25.000000', 'consum', 0.0215, 'lps'),
	(612685, 130, '2014-04-01 00:00:26.000000', 'consum', 0.0221, 'lps'),
	(612686, 130, '2014-04-01 00:00:27.000000', 'consum', 0.0213, 'lps'),
	(612687, 130, '2014-04-01 00:00:28.000000', 'consum', 0.0218, 'lps'),
	(612688, 130, '2014-04-01 00:00:29.000000', 'consum', 0.0217, 'lps'),
	(612689, 130, '2014-04-01 00:00:30.000000', 'consum', 0.0211, 'lps'),
	(612690, 130, '2014-04-01 00:00:31.000000', 'consum', 0.0216, 'lps'),
	(612691, 130, '2014-04-01 00:00:32.000000', 'consum', 0.0213, 'lps'),
	(612692, 130, '2014-04-01 00:00:33.000000', 'consum', 0.0210, 'lps'),
	(612693, 130, '2014-04-01 00:00:34.000000', 'consum', 0.0211, 'lps'),
	(612694, 130, '2014-04-01 00:00:35.000000', 'consum', 0.0219, 'lps'),
	(612695, 130, '2014-04-01 00:00:36.000000', 'consum', 0.0213, 'lps'),
	(612696, 130, '2014-04-01 00:00:37.000000', 'consum', 0.0211, 'lps'),
	(612697, 130, '2014-04-01 00:00:38.000000', 'consum', 0.0221, 'lps'),
	(612698, 130, '2014-04-01 00:00:39.000000', 'consum', 0.0213, 'lps'),
	(612699, 130, '2014-04-01 00:00:40.000000', 'consum', 0.0218, 'lps'),
	(612700, 130, '2014-04-01 00:00:41.000000', 'consum', 0.0217, 'lps'),
	(612701, 130, '2014-04-01 00:00:42.000000', 'consum', 0.0211, 'lps'),
	(612702, 130, '2014-04-01 00:00:43.000000', 'consum', 0.0215, 'lps'),
	(612703, 130, '2014-04-01 00:00:44.000000', 'consum', 0.0211, 'lps'),
	(612704, 130, '2014-04-01 00:00:45.000000', 'consum', 0.0213, 'lps'),
	(612705, 130, '2014-04-01 00:00:46.000000', 'consum', 0.0221, 'lps'),
	(612706, 130, '2014-04-01 00:00:47.000000', 'consum', 0.0210, 'lps'),
	(612707, 130, '2014-04-01 00:00:48.000000', 'consum', 0.0215, 'lps'),
	(612708, 130, '2014-04-01 00:00:49.000000', 'consum', 0.0221, 'lps'),
	(612709, 130, '2014-04-01 00:00:50.000000', 'consum', 0.0216, 'lps'),
	(612710, 130, '2014-04-01 00:00:51.000000', 'consum', 0.0221, 'lps'),
	(612711, 130, '2014-04-01 00:00:52.000000', 'consum', 0.0221, 'lps'),
	(612712, 130, '2014-04-01 00:00:53.000000', 'consum', 0.0210, 'lps'),
	(612713, 130, '2014-04-01 00:00:54.000000', 'consum', 0.0214, 'lps'),
	(612714, 130, '2014-04-01 00:00:55.000000', 'consum', 0.0218, 'lps'),
	(612715, 130, '2014-04-01 00:00:56.000000', 'consum', 0.0215, 'lps'),
	(612716, 130, '2014-04-01 00:00:57.000000', 'consum', 0.0221, 'lps'),
	(612717, 130, '2014-04-01 00:00:58.000000', 'consum', 0.0216, 'lps'),
	(612718, 130, '2014-04-01 00:00:59.000000', 'consum', 0.0219, 'lps'),
	(612719, 130, '2014-04-01 00:01:00.000000', 'consum', 0.0216, 'lps'),
	(612720, 130, '2014-04-01 00:01:01.000000', 'consum', 0.0210, 'lps'),
	(612721, 130, '2014-04-01 00:01:02.000000', 'consum', 0.0217, 'lps'),
	(612722, 130, '2014-04-01 00:01:03.000000', 'consum', 0.0212, 'lps'),
	(612723, 130, '2014-04-01 00:01:04.000000', 'consum', 0.0211, 'lps'),
	(612724, 130, '2014-04-01 00:01:05.000000', 'consum', 0.0210, 'lps'),
	(612725, 130, '2014-04-01 00:01:06.000000', 'consum', 0.0219, 'lps'),
	(612726, 130, '2014-04-01 00:01:07.000000', 'consum', 0.0221, 'lps'),
	(612727, 130, '2014-04-01 00:01:08.000000', 'consum', 0.0212, 'lps'),
	(612728, 130, '2014-04-01 00:01:09.000000', 'consum', 0.0211, 'lps'),
	(612729, 130, '2014-04-01 00:01:10.000000', 'consum', 0.0211, 'lps'),
	(612730, 130, '2014-04-01 00:01:11.000000', 'consum', 0.0214, 'lps'),
	(612731, 130, '2014-04-01 00:01:12.000000', 'consum', 0.0212, 'lps'),
	(612732, 130, '2014-04-01 00:01:13.000000', 'consum', 0.0211, 'lps'),
	(612733, 130, '2014-04-01 00:01:14.000000', 'consum', 0.0220, 'lps'),
	(612734, 130, '2014-04-01 00:01:15.000000', 'consum', 0.0221, 'lps'),
	(612735, 130, '2014-04-01 00:01:16.000000', 'consum', 0.0214, 'lps'),
	(612736, 130, '2014-04-01 00:01:17.000000', 'consum', 0.0221, 'lps'),
	(612737, 130, '2014-04-01 00:01:18.000000', 'consum', 0.0216, 'lps'),
	(612738, 130, '2014-04-01 00:01:19.000000', 'consum', 0.0210, 'lps'),
	(612739, 130, '2014-04-01 00:01:20.000000', 'consum', 0.0214, 'lps'),
	(612740, 130, '2014-04-01 00:01:21.000000', 'consum', 0.0218, 'lps'),
	(612741, 130, '2014-04-01 00:01:22.000000', 'consum', 0.0216, 'lps'),
	(612742, 130, '2014-04-01 00:01:23.000000', 'consum', 0.0214, 'lps'),
	(612743, 130, '2014-04-01 00:01:24.000000', 'consum', 0.0215, 'lps'),
	(612744, 130, '2014-04-01 00:01:25.000000', 'consum', 0.0212, 'lps'),
	(612745, 130, '2014-04-01 00:01:26.000000', 'consum', 0.0219, 'lps'),
	(612746, 130, '2014-04-01 00:01:27.000000', 'consum', 0.0210, 'lps'),
	(612747, 130, '2014-04-01 00:01:28.000000', 'consum', 0.0220, 'lps'),
	(612748, 130, '2014-04-01 00:01:29.000000', 'consum', 0.0215, 'lps'),
	(612749, 130, '2014-04-01 00:01:30.000000', 'consum', 0.0216, 'lps'),
	(612750, 130, '2014-04-01 00:01:31.000000', 'consum', 0.0215, 'lps'),
	(612751, 130, '2014-04-01 00:01:32.000000', 'consum', 0.0217, 'lps'),
	(612752, 130, '2014-04-01 00:01:33.000000', 'consum', 0.0218, 'lps'),
	(612753, 130, '2014-04-01 00:01:34.000000', 'consum', 0.0219, 'lps'),
	(612754, 130, '2014-04-01 00:01:35.000000', 'consum', 0.0220, 'lps'),
	(612755, 130, '2014-04-01 00:01:36.000000', 'consum', 0.0210, 'lps'),
	(612756, 130, '2014-04-01 00:01:37.000000', 'consum', 0.0216, 'lps'),
	(612757, 130, '2014-04-01 00:01:38.000000', 'consum', 0.0216, 'lps'),
	(612758, 130, '2014-04-01 00:01:39.000000', 'consum', 0.0210, 'lps'),
	(612759, 130, '2014-04-01 00:01:40.000000', 'consum', 0.0217, 'lps'),
	(612760, 130, '2014-04-01 00:01:41.000000', 'consum', 0.0211, 'lps'),
	(612761, 130, '2014-04-01 00:01:42.000000', 'consum', 0.0218, 'lps'),
	(612762, 130, '2014-04-01 00:01:43.000000', 'consum', 0.0211, 'lps'),
	(612763, 130, '2014-04-01 00:01:44.000000', 'consum', 0.0218, 'lps'),
	(612764, 130, '2014-04-01 00:01:45.000000', 'consum', 0.0220, 'lps'),
	(612765, 130, '2014-04-01 00:01:46.000000', 'consum', 0.0214, 'lps'),
	(612766, 130, '2014-04-01 00:01:47.000000', 'consum', 0.0213, 'lps'),
	(612767, 130, '2014-04-01 00:01:48.000000', 'consum', 0.0214, 'lps'),
	(612768, 130, '2014-04-01 00:01:49.000000', 'consum', 0.0211, 'lps'),
	(612769, 130, '2014-04-01 00:01:50.000000', 'consum', 0.0212, 'lps'),
	(612770, 130, '2014-04-01 00:01:51.000000', 'consum', 0.0219, 'lps'),
	(612771, 130, '2014-04-01 00:01:52.000000', 'consum', 0.0213, 'lps'),
	(612772, 130, '2014-04-01 00:01:53.000000', 'consum', 0.0210, 'lps'),
	(612773, 130, '2014-04-01 00:01:54.000000', 'consum', 0.0212, 'lps'),
	(612774, 130, '2014-04-01 00:01:55.000000', 'consum', 0.0210, 'lps'),
	(612775, 130, '2014-04-01 00:01:56.000000', 'consum', 0.0218, 'lps'),
	(612776, 130, '2014-04-01 00:01:57.000000', 'consum', 0.0213, 'lps'),
	(612777, 130, '2014-04-01 00:01:58.000000', 'consum', 0.0215, 'lps'),
	(612778, 130, '2014-04-01 00:01:59.000000', 'consum', 0.0213, 'lps'),
	(612779, 130, '2014-04-01 00:02:00.000000', 'consum', 0.0211, 'lps'),
	(612780, 130, '2014-04-01 00:02:01.000000', 'consum', 0.0220, 'lps'),
	(612781, 130, '2014-04-01 00:02:02.000000', 'consum', 0.0211, 'lps'),
	(612782, 130, '2014-04-01 00:02:03.000000', 'consum', 0.0218, 'lps'),
	(612783, 130, '2014-04-01 00:02:04.000000', 'consum', 0.0212, 'lps'),
	(612784, 130, '2014-04-01 00:02:05.000000', 'consum', 0.0220, 'lps'),
	(612785, 130, '2014-04-01 00:02:06.000000', 'consum', 0.0217, 'lps'),
	(612786, 130, '2014-04-01 00:02:07.000000', 'consum', 0.0218, 'lps'),
	(612787, 130, '2014-04-01 00:02:08.000000', 'consum', 0.0217, 'lps'),
	(612788, 130, '2014-04-01 00:02:09.000000', 'consum', 0.0220, 'lps'),
	(612789, 130, '2014-04-01 00:02:10.000000', 'consum', 0.0217, 'lps'),
	(612790, 130, '2014-04-01 00:02:11.000000', 'consum', 0.0215, 'lps'),
	(612791, 130, '2014-04-01 00:02:12.000000', 'consum', 0.0213, 'lps'),
	(612792, 130, '2014-04-01 00:02:13.000000', 'consum', 0.0212, 'lps'),
	(612793, 130, '2014-04-01 00:02:14.000000', 'consum', 0.0211, 'lps'),
	(612794, 130, '2014-04-01 00:02:15.000000', 'consum', 0.0220, 'lps'),
	(612795, 130, '2014-04-01 00:02:16.000000', 'consum', 0.0211, 'lps'),
	(612796, 130, '2014-04-01 00:02:17.000000', 'consum', 0.0211, 'lps'),
	(612797, 130, '2014-04-01 00:02:18.000000', 'consum', 0.0213, 'lps'),
	(612798, 130, '2014-04-01 00:02:19.000000', 'consum', 0.0219, 'lps'),
	(612799, 130, '2014-04-01 00:02:20.000000', 'consum', 0.0214, 'lps'),
	(612800, 130, '2014-04-01 00:02:21.000000', 'consum', 0.0214, 'lps'),
	(612801, 130, '2014-04-01 00:02:22.000000', 'consum', 0.0217, 'lps'),
	(612802, 130, '2014-04-01 00:02:23.000000', 'consum', 0.0211, 'lps'),
	(612803, 130, '2014-04-01 00:02:24.000000', 'consum', 0.0219, 'lps'),
	(612804, 130, '2014-04-01 00:02:25.000000', 'consum', 0.0217, 'lps'),
	(612805, 130, '2014-04-01 00:02:26.000000', 'consum', 0.0216, 'lps'),
	(612806, 130, '2014-04-01 00:02:27.000000', 'consum', 0.0221, 'lps'),
	(612807, 130, '2014-04-01 00:02:28.000000', 'consum', 0.0210, 'lps'),
	(612808, 130, '2014-04-01 00:02:29.000000', 'consum', 0.0214, 'lps'),
	(612809, 130, '2014-04-01 00:02:30.000000', 'consum', 0.0219, 'lps'),
	(612810, 130, '2014-04-01 00:02:31.000000', 'consum', 0.0218, 'lps'),
	(612811, 130, '2014-04-01 00:02:32.000000', 'consum', 0.0213, 'lps'),
	(612812, 130, '2014-04-01 00:02:33.000000', 'consum', 0.0215, 'lps'),
	(612813, 130, '2014-04-01 00:02:34.000000', 'consum', 0.0214, 'lps'),
	(612814, 130, '2014-04-01 00:02:35.000000', 'consum', 0.0213, 'lps'),
	(612815, 130, '2014-04-01 00:02:36.000000', 'consum', 0.0215, 'lps'),
	(612816, 130, '2014-04-01 00:02:37.000000', 'consum', 0.0214, 'lps'),
	(612817, 130, '2014-04-01 00:02:38.000000', 'consum', 0.0216, 'lps'),
	(612818, 130, '2014-04-01 00:02:39.000000', 'consum', 0.0214, 'lps'),
	(612819, 130, '2014-04-01 00:02:40.000000', 'consum', 0.0215, 'lps'),
	(612820, 130, '2014-04-01 00:02:41.000000', 'consum', 0.0212, 'lps'),
	(612821, 130, '2014-04-01 00:02:42.000000', 'consum', 0.0218, 'lps'),
	(612822, 130, '2014-04-01 00:02:43.000000', 'consum', 0.0218, 'lps'),
	(612823, 130, '2014-04-01 00:02:44.000000', 'consum', 0.0216, 'lps'),
	(612824, 130, '2014-04-01 00:02:45.000000', 'consum', 0.0217, 'lps'),
	(612825, 130, '2014-04-01 00:02:46.000000', 'consum', 0.0216, 'lps'),
	(612826, 130, '2014-04-01 00:02:47.000000', 'consum', 0.0219, 'lps'),
	(612827, 130, '2014-04-01 00:02:48.000000', 'consum', 0.0212, 'lps'),
	(612828, 130, '2014-04-01 00:02:49.000000', 'consum', 0.0220, 'lps'),
	(612829, 130, '2014-04-01 00:02:50.000000', 'consum', 0.0219, 'lps'),
	(612830, 130, '2014-04-01 00:02:51.000000', 'consum', 0.0211, 'lps'),
	(612831, 130, '2014-04-01 00:02:52.000000', 'consum', 0.0213, 'lps'),
	(612832, 130, '2014-04-01 00:02:53.000000', 'consum', 0.0213, 'lps'),
	(612833, 130, '2014-04-01 00:02:54.000000', 'consum', 0.0214, 'lps'),
	(612834, 130, '2014-04-01 00:02:55.000000', 'consum', 0.0210, 'lps'),
	(612835, 130, '2014-04-01 00:02:56.000000', 'consum', 0.0212, 'lps'),
	(612836, 130, '2014-04-01 00:02:57.000000', 'consum', 0.0220, 'lps'),
	(612837, 130, '2014-04-01 00:02:58.000000', 'consum', 0.0218, 'lps'),
	(612838, 130, '2014-04-01 00:02:59.000000', 'consum', 0.0210, 'lps'),
	(612839, 130, '2014-04-01 00:03:00.000000', 'consum', 0.0211, 'lps'),
	(612840, 130, '2014-04-01 00:03:01.000000', 'consum', 0.0212, 'lps'),
	(612841, 130, '2014-04-01 00:03:02.000000', 'consum', 0.0221, 'lps'),
	(612842, 130, '2014-04-01 00:03:03.000000', 'consum', 0.0210, 'lps'),
	(612843, 130, '2014-04-01 00:03:04.000000', 'consum', 0.0213, 'lps'),
	(612844, 130, '2014-04-01 00:03:05.000000', 'consum', 0.0212, 'lps'),
	(612845, 130, '2014-04-01 00:03:06.000000', 'consum', 0.0215, 'lps'),
	(612846, 130, '2014-04-01 00:03:07.000000', 'consum', 0.0215, 'lps'),
	(612847, 130, '2014-04-01 00:03:08.000000', 'consum', 0.0210, 'lps'),
	(612848, 130, '2014-04-01 00:03:09.000000', 'consum', 0.0219, 'lps'),
	(612849, 130, '2014-04-01 00:03:10.000000', 'consum', 0.0221, 'lps'),
	(612850, 130, '2014-04-01 00:03:11.000000', 'consum', 0.0212, 'lps'),
	(612851, 130, '2014-04-01 00:03:12.000000', 'consum', 0.0214, 'lps'),
	(612852, 130, '2014-04-01 00:03:13.000000', 'consum', 0.0211, 'lps'),
	(612853, 130, '2014-04-01 00:03:14.000000', 'consum', 0.0215, 'lps'),
	(612854, 130, '2014-04-01 00:03:15.000000', 'consum', 0.0210, 'lps'),
	(612855, 130, '2014-04-01 00:03:16.000000', 'consum', 0.0220, 'lps'),
	(612856, 130, '2014-04-01 00:03:17.000000', 'consum', 0.0210, 'lps'),
	(612857, 130, '2014-04-01 00:03:18.000000', 'consum', 0.0218, 'lps'),
	(612858, 130, '2014-04-01 00:03:19.000000', 'consum', 0.0216, 'lps'),
	(612859, 130, '2014-04-01 00:03:20.000000', 'consum', 0.0214, 'lps'),
	(612860, 130, '2014-04-01 00:03:21.000000', 'consum', 0.0215, 'lps'),
	(612861, 130, '2014-04-01 00:03:22.000000', 'consum', 0.0212, 'lps'),
	(612862, 130, '2014-04-01 00:03:23.000000', 'consum', 0.0215, 'lps'),
	(612863, 130, '2014-04-01 00:03:24.000000', 'consum', 0.0217, 'lps'),
	(612864, 130, '2014-04-01 00:03:25.000000', 'consum', 0.0221, 'lps'),
	(612865, 130, '2014-04-01 00:03:26.000000', 'consum', 0.0219, 'lps'),
	(612866, 130, '2014-04-01 00:03:27.000000', 'consum', 0.0210, 'lps'),
	(612867, 130, '2014-04-01 00:03:28.000000', 'consum', 0.0219, 'lps'),
	(612868, 130, '2014-04-01 00:03:29.000000', 'consum', 0.0218, 'lps'),
	(612869, 130, '2014-04-01 00:03:30.000000', 'consum', 0.0215, 'lps'),
	(612870, 130, '2014-04-01 00:03:31.000000', 'consum', 0.0210, 'lps'),
	(612871, 130, '2014-04-01 00:03:32.000000', 'consum', 0.0219, 'lps'),
	(612872, 130, '2014-04-01 00:03:33.000000', 'consum', 0.0221, 'lps'),
	(612873, 130, '2014-04-01 00:03:34.000000', 'consum', 0.0214, 'lps'),
	(612874, 130, '2014-04-01 00:03:35.000000', 'consum', 0.0221, 'lps'),
	(612875, 130, '2014-04-01 00:03:36.000000', 'consum', 0.0218, 'lps'),
	(612876, 130, '2014-04-01 00:03:37.000000', 'consum', 0.0217, 'lps'),
	(612877, 130, '2014-04-01 00:03:38.000000', 'consum', 0.0220, 'lps'),
	(612878, 130, '2014-04-01 00:03:39.000000', 'consum', 0.0216, 'lps'),
	(612879, 130, '2014-04-01 00:03:40.000000', 'consum', 0.0211, 'lps'),
	(612880, 130, '2014-04-01 00:03:41.000000', 'consum', 0.0210, 'lps'),
	(612881, 130, '2014-04-01 00:03:42.000000', 'consum', 0.0221, 'lps'),
	(612882, 130, '2014-04-01 00:03:43.000000', 'consum', 0.0216, 'lps'),
	(612883, 130, '2014-04-01 00:03:44.000000', 'consum', 0.0218, 'lps'),
	(612884, 130, '2014-04-01 00:03:45.000000', 'consum', 0.0220, 'lps'),
	(612885, 130, '2014-04-01 00:03:46.000000', 'consum', 0.0213, 'lps'),
	(612886, 130, '2014-04-01 00:03:47.000000', 'consum', 0.0218, 'lps'),
	(612887, 130, '2014-04-01 00:03:48.000000', 'consum', 0.0220, 'lps'),
	(612888, 130, '2014-04-01 00:03:49.000000', 'consum', 0.0210, 'lps'),
	(612889, 130, '2014-04-01 00:03:50.000000', 'consum', 0.0218, 'lps'),
	(612890, 130, '2014-04-01 00:03:51.000000', 'consum', 0.0215, 'lps'),
	(612891, 130, '2014-04-01 00:03:52.000000', 'consum', 0.0213, 'lps'),
	(612892, 130, '2014-04-01 00:03:53.000000', 'consum', 0.0221, 'lps'),
	(612893, 130, '2014-04-01 00:03:54.000000', 'consum', 0.0221, 'lps'),
	(612894, 130, '2014-04-01 00:03:55.000000', 'consum', 0.0220, 'lps'),
	(612895, 130, '2014-04-01 00:03:56.000000', 'consum', 0.0214, 'lps'),
	(612896, 130, '2014-04-01 00:03:57.000000', 'consum', 0.0212, 'lps'),
	(612897, 130, '2014-04-01 00:03:58.000000', 'consum', 0.0221, 'lps'),
	(612898, 130, '2014-04-01 00:03:59.000000', 'consum', 0.0212, 'lps'),
	(612899, 130, '2014-04-01 00:04:00.000000', 'consum', 0.0213, 'lps'),
	(612900, 130, '2014-04-01 00:04:01.000000', 'consum', 0.0220, 'lps'),
	(612901, 130, '2014-04-01 00:04:02.000000', 'consum', 0.0214, 'lps'),
	(612902, 130, '2014-04-01 00:04:03.000000', 'consum', 0.0213, 'lps'),
	(612903, 130, '2014-04-01 00:04:04.000000', 'consum', 0.0214, 'lps'),
	(612904, 130, '2014-04-01 00:04:05.000000', 'consum', 0.0220, 'lps'),
	(612905, 130, '2014-04-01 00:04:06.000000', 'consum', 0.0213, 'lps'),
	(612906, 130, '2014-04-01 00:04:07.000000', 'consum', 0.0219, 'lps'),
	(612907, 130, '2014-04-01 00:04:08.000000', 'consum', 0.0210, 'lps'),
	(612908, 130, '2014-04-01 00:04:09.000000', 'consum', 0.0221, 'lps'),
	(612909, 130, '2014-04-01 00:04:10.000000', 'consum', 0.0216, 'lps'),
	(612910, 130, '2014-04-01 00:04:11.000000', 'consum', 0.0210, 'lps'),
	(612911, 130, '2014-04-01 00:04:12.000000', 'consum', 0.0215, 'lps'),
	(612912, 130, '2014-04-01 00:04:13.000000', 'consum', 0.0210, 'lps'),
	(612913, 130, '2014-04-01 00:04:14.000000', 'consum', 0.0221, 'lps'),
	(612914, 130, '2014-04-01 00:04:15.000000', 'consum', 0.0215, 'lps'),
	(612915, 130, '2014-04-01 00:04:16.000000', 'consum', 0.0217, 'lps'),
	(612916, 130, '2014-04-01 00:04:17.000000', 'consum', 0.0218, 'lps'),
	(612917, 130, '2014-04-01 00:04:18.000000', 'consum', 0.0217, 'lps'),
	(612918, 130, '2014-04-01 00:04:19.000000', 'consum', 0.0211, 'lps'),
	(612919, 130, '2014-04-01 00:04:20.000000', 'consum', 0.0218, 'lps'),
	(612920, 130, '2014-04-01 00:04:21.000000', 'consum', 0.0221, 'lps'),
	(612921, 130, '2014-04-01 00:04:22.000000', 'consum', 0.0220, 'lps'),
	(612922, 130, '2014-04-01 00:04:23.000000', 'consum', 0.0215, 'lps'),
	(612923, 130, '2014-04-01 00:04:24.000000', 'consum', 0.0217, 'lps'),
	(612924, 130, '2014-04-01 00:04:25.000000', 'consum', 0.0220, 'lps'),
	(612925, 130, '2014-04-01 00:04:26.000000', 'consum', 0.0214, 'lps'),
	(612926, 130, '2014-04-01 00:04:27.000000', 'consum', 0.0215, 'lps'),
	(612927, 130, '2014-04-01 00:04:28.000000', 'consum', 0.0221, 'lps'),
	(612928, 130, '2014-04-01 00:04:29.000000', 'consum', 0.0214, 'lps'),
	(612929, 130, '2014-04-01 00:04:30.000000', 'consum', 0.0210, 'lps'),
	(612930, 130, '2014-04-01 00:04:31.000000', 'consum', 0.0221, 'lps'),
	(612931, 130, '2014-04-01 00:04:32.000000', 'consum', 0.0219, 'lps'),
	(612932, 130, '2014-04-01 00:04:33.000000', 'consum', 0.0212, 'lps'),
	(612933, 130, '2014-04-01 00:04:34.000000', 'consum', 0.0216, 'lps'),
	(612934, 130, '2014-04-01 00:04:35.000000', 'consum', 0.0221, 'lps'),
	(612935, 130, '2014-04-01 00:04:36.000000', 'consum', 0.0213, 'lps'),
	(612936, 130, '2014-04-01 00:04:37.000000', 'consum', 0.0216, 'lps'),
	(612937, 130, '2014-04-01 00:04:38.000000', 'consum', 0.0210, 'lps'),
	(612938, 130, '2014-04-01 00:04:39.000000', 'consum', 0.0214, 'lps'),
	(612939, 130, '2014-04-01 00:04:40.000000', 'consum', 0.0217, 'lps'),
	(612940, 130, '2014-04-01 00:04:41.000000', 'consum', 0.0211, 'lps'),
	(612941, 130, '2014-04-01 00:04:42.000000', 'consum', 0.0219, 'lps'),
	(612942, 130, '2014-04-01 00:04:43.000000', 'consum', 0.0218, 'lps'),
	(612943, 130, '2014-04-01 00:04:44.000000', 'consum', 0.0211, 'lps'),
	(612944, 130, '2014-04-01 00:04:45.000000', 'consum', 0.0215, 'lps'),
	(612945, 130, '2014-04-01 00:04:46.000000', 'consum', 0.0220, 'lps'),
	(612946, 130, '2014-04-01 00:04:47.000000', 'consum', 0.0221, 'lps'),
	(612947, 130, '2014-04-01 00:04:48.000000', 'consum', 0.0214, 'lps'),
	(612948, 130, '2014-04-01 00:04:49.000000', 'consum', 0.0221, 'lps'),
	(612949, 130, '2014-04-01 00:04:50.000000', 'consum', 0.0216, 'lps'),
	(612950, 130, '2014-04-01 00:04:51.000000', 'consum', 0.0221, 'lps'),
	(612951, 130, '2014-04-01 00:04:52.000000', 'consum', 0.0213, 'lps'),
	(612952, 130, '2014-04-01 00:04:53.000000', 'consum', 0.0214, 'lps'),
	(612953, 130, '2014-04-01 00:04:54.000000', 'consum', 0.0212, 'lps'),
	(612954, 130, '2014-04-01 00:04:55.000000', 'consum', 0.0220, 'lps'),
	(612955, 130, '2014-04-01 00:04:56.000000', 'consum', 0.0219, 'lps'),
	(612956, 130, '2014-04-01 00:04:57.000000', 'consum', 0.0212, 'lps'),
	(612957, 130, '2014-04-01 00:04:58.000000', 'consum', 0.0217, 'lps'),
	(612958, 130, '2014-04-01 00:04:59.000000', 'consum', 0.0217, 'lps'),
	(612959, 130, '2014-04-01 00:05:00.000000', 'consum', 0.0214, 'lps'),
	(612960, 130, '2014-04-01 00:05:01.000000', 'consum', 0.0219, 'lps'),
	(612961, 130, '2014-04-01 00:05:02.000000', 'consum', 0.0221, 'lps'),
	(612962, 130, '2014-04-01 00:05:03.000000', 'consum', 0.0213, 'lps'),
	(612963, 130, '2014-04-01 00:05:04.000000', 'consum', 0.0218, 'lps'),
	(612964, 130, '2014-04-01 00:05:05.000000', 'consum', 0.0216, 'lps'),
	(612965, 130, '2014-04-01 00:05:06.000000', 'consum', 0.0216, 'lps'),
	(612966, 130, '2014-04-01 00:05:07.000000', 'consum', 0.0213, 'lps'),
	(612967, 130, '2014-04-01 00:05:08.000000', 'consum', 0.0220, 'lps'),
	(612968, 130, '2014-04-01 00:05:09.000000', 'consum', 0.0213, 'lps'),
	(612969, 130, '2014-04-01 00:05:10.000000', 'consum', 0.0221, 'lps'),
	(612970, 130, '2014-04-01 00:05:11.000000', 'consum', 0.0221, 'lps'),
	(612971, 130, '2014-04-01 00:05:12.000000', 'consum', 0.0219, 'lps'),
	(612972, 130, '2014-04-01 00:05:13.000000', 'consum', 0.0221, 'lps'),
	(612973, 130, '2014-04-01 00:05:14.000000', 'consum', 0.0218, 'lps'),
	(612974, 130, '2014-04-01 00:05:15.000000', 'consum', 0.0215, 'lps'),
	(612975, 130, '2014-04-01 00:05:16.000000', 'consum', 0.0213, 'lps'),
	(612976, 130, '2014-04-01 00:05:17.000000', 'consum', 0.0210, 'lps'),
	(612977, 130, '2014-04-01 00:05:18.000000', 'consum', 0.0215, 'lps'),
	(612978, 130, '2014-04-01 00:05:19.000000', 'consum', 0.0221, 'lps'),
	(612979, 130, '2014-04-01 00:05:20.000000', 'consum', 0.0215, 'lps'),
	(612980, 130, '2014-04-01 00:05:21.000000', 'consum', 0.0215, 'lps'),
	(612981, 130, '2014-04-01 00:05:22.000000', 'consum', 0.0220, 'lps'),
	(612982, 130, '2014-04-01 00:05:23.000000', 'consum', 0.0212, 'lps'),
	(612983, 130, '2014-04-01 00:05:24.000000', 'consum', 0.0211, 'lps'),
	(612984, 130, '2014-04-01 00:05:25.000000', 'consum', 0.0211, 'lps'),
	(612985, 130, '2014-04-01 00:05:26.000000', 'consum', 0.0214, 'lps'),
	(612986, 130, '2014-04-01 00:05:27.000000', 'consum', 0.0215, 'lps'),
	(612987, 130, '2014-04-01 00:05:28.000000', 'consum', 0.0213, 'lps'),
	(612988, 130, '2014-04-01 00:05:29.000000', 'consum', 0.0221, 'lps'),
	(612989, 130, '2014-04-01 00:05:30.000000', 'consum', 0.0221, 'lps'),
	(612990, 130, '2014-04-01 00:05:31.000000', 'consum', 0.0210, 'lps'),
	(612991, 130, '2014-04-01 00:05:32.000000', 'consum', 0.0213, 'lps'),
	(612992, 130, '2014-04-01 00:05:33.000000', 'consum', 0.0215, 'lps'),
	(612993, 130, '2014-04-01 00:05:34.000000', 'consum', 0.0212, 'lps'),
	(612994, 130, '2014-04-01 00:05:35.000000', 'consum', 0.0218, 'lps'),
	(612995, 130, '2014-04-01 00:05:36.000000', 'consum', 0.0220, 'lps'),
	(612996, 130, '2014-04-01 00:05:37.000000', 'consum', 0.0214, 'lps'),
	(612997, 130, '2014-04-01 00:05:38.000000', 'consum', 0.0213, 'lps'),
	(612998, 130, '2014-04-01 00:05:39.000000', 'consum', 0.0214, 'lps'),
	(612999, 130, '2014-04-01 00:05:40.000000', 'consum', 0.0221, 'lps'),
	(613000, 130, '2014-04-01 00:05:41.000000', 'consum', 0.0216, 'lps'),
	(613001, 130, '2014-04-01 00:05:42.000000', 'consum', 0.0220, 'lps'),
	(613002, 130, '2014-04-01 00:05:43.000000', 'consum', 0.0219, 'lps'),
	(613003, 130, '2014-04-01 00:05:44.000000', 'consum', 0.0214, 'lps'),
	(613004, 130, '2014-04-01 00:05:45.000000', 'consum', 0.0214, 'lps'),
	(613005, 130, '2014-04-01 00:05:46.000000', 'consum', 0.0220, 'lps'),
	(613006, 130, '2014-04-01 00:05:47.000000', 'consum', 0.0213, 'lps'),
	(613007, 130, '2014-04-01 00:05:48.000000', 'consum', 0.0219, 'lps'),
	(613008, 130, '2014-04-01 00:05:49.000000', 'consum', 0.0212, 'lps'),
	(613009, 130, '2014-04-01 00:05:50.000000', 'consum', 0.0215, 'lps'),
	(613010, 130, '2014-04-01 00:05:51.000000', 'consum', 0.0220, 'lps'),
	(613011, 130, '2014-04-01 00:05:52.000000', 'consum', 0.0219, 'lps'),
	(613012, 130, '2014-04-01 00:05:53.000000', 'consum', 0.0213, 'lps'),
	(613013, 130, '2014-04-01 00:05:54.000000', 'consum', 0.0210, 'lps'),
	(613014, 130, '2014-04-01 00:05:55.000000', 'consum', 0.0214, 'lps'),
	(613015, 130, '2014-04-01 00:05:56.000000', 'consum', 0.0220, 'lps'),
	(613016, 130, '2014-04-01 00:05:57.000000', 'consum', 0.0212, 'lps'),
	(613017, 130, '2014-04-01 00:05:58.000000', 'consum', 0.0214, 'lps'),
	(613018, 130, '2014-04-01 00:05:59.000000', 'consum', 0.0214, 'lps'),
	(613019, 130, '2014-04-01 00:06:00.000000', 'consum', 0.0218, 'lps'),
	(613020, 130, '2014-04-01 00:06:01.000000', 'consum', 0.0216, 'lps'),
	(613021, 130, '2014-04-01 00:06:02.000000', 'consum', 0.0216, 'lps'),
	(613022, 130, '2014-04-01 00:06:03.000000', 'consum', 0.0220, 'lps'),
	(613023, 130, '2014-04-01 00:06:04.000000', 'consum', 0.0210, 'lps'),
	(613024, 130, '2014-04-01 00:06:05.000000', 'consum', 0.0213, 'lps'),
	(613025, 130, '2014-04-01 00:06:06.000000', 'consum', 0.0217, 'lps'),
	(613026, 130, '2014-04-01 00:06:07.000000', 'consum', 0.0211, 'lps'),
	(613027, 130, '2014-04-01 00:06:08.000000', 'consum', 0.0218, 'lps'),
	(613028, 130, '2014-04-01 00:06:09.000000', 'consum', 0.0212, 'lps'),
	(613029, 130, '2014-04-01 00:06:10.000000', 'consum', 0.0219, 'lps'),
	(613030, 130, '2014-04-01 00:06:11.000000', 'consum', 0.0215, 'lps'),
	(613031, 130, '2014-04-01 00:06:12.000000', 'consum', 0.0220, 'lps'),
	(613032, 130, '2014-04-01 00:06:13.000000', 'consum', 0.0210, 'lps'),
	(613033, 130, '2014-04-01 00:06:14.000000', 'consum', 0.0218, 'lps'),
	(613034, 130, '2014-04-01 00:06:15.000000', 'consum', 0.0213, 'lps'),
	(613035, 130, '2014-04-01 00:06:16.000000', 'consum', 0.0214, 'lps'),
	(613036, 130, '2014-04-01 00:06:17.000000', 'consum', 0.0220, 'lps'),
	(613037, 130, '2014-04-01 00:06:18.000000', 'consum', 0.0212, 'lps'),
	(613038, 130, '2014-04-01 00:06:19.000000', 'consum', 0.0214, 'lps'),
	(613039, 130, '2014-04-01 00:06:20.000000', 'consum', 0.0215, 'lps'),
	(613040, 130, '2014-04-01 00:06:21.000000', 'consum', 0.0210, 'lps'),
	(613041, 130, '2014-04-01 00:06:22.000000', 'consum', 0.0219, 'lps'),
	(613042, 130, '2014-04-01 00:06:23.000000', 'consum', 0.0220, 'lps'),
	(613043, 130, '2014-04-01 00:06:24.000000', 'consum', 0.0210, 'lps'),
	(613044, 130, '2014-04-01 00:06:25.000000', 'consum', 0.0217, 'lps'),
	(613045, 130, '2014-04-01 00:06:26.000000', 'consum', 0.0221, 'lps'),
	(613046, 130, '2014-04-01 00:06:27.000000', 'consum', 0.0219, 'lps'),
	(613047, 130, '2014-04-01 00:06:28.000000', 'consum', 0.0213, 'lps'),
	(613048, 130, '2014-04-01 00:06:29.000000', 'consum', 0.0220, 'lps'),
	(613049, 130, '2014-04-01 00:06:30.000000', 'consum', 0.0215, 'lps'),
	(613050, 130, '2014-04-01 00:06:31.000000', 'consum', 0.0217, 'lps'),
	(613051, 130, '2014-04-01 00:06:32.000000', 'consum', 0.0221, 'lps'),
	(613052, 130, '2014-04-01 00:06:33.000000', 'consum', 0.0220, 'lps'),
	(613053, 130, '2014-04-01 00:06:34.000000', 'consum', 0.0216, 'lps'),
	(613054, 130, '2014-04-01 00:06:35.000000', 'consum', 0.0211, 'lps'),
	(613055, 130, '2014-04-01 00:06:36.000000', 'consum', 0.0219, 'lps'),
	(613056, 130, '2014-04-01 00:06:37.000000', 'consum', 0.0217, 'lps'),
	(613057, 130, '2014-04-01 00:06:38.000000', 'consum', 0.0217, 'lps'),
	(613058, 130, '2014-04-01 00:06:39.000000', 'consum', 0.0214, 'lps'),
	(613059, 130, '2014-04-01 00:06:40.000000', 'consum', 0.0221, 'lps'),
	(613060, 130, '2014-04-01 00:06:41.000000', 'consum', 0.0219, 'lps'),
	(613061, 130, '2014-04-01 00:06:42.000000', 'consum', 0.0210, 'lps'),
	(613062, 130, '2014-04-01 00:06:43.000000', 'consum', 0.0220, 'lps'),
	(613063, 130, '2014-04-01 00:06:44.000000', 'consum', 0.0213, 'lps'),
	(613064, 130, '2014-04-01 00:06:45.000000', 'consum', 0.0217, 'lps'),
	(613065, 130, '2014-04-01 00:06:46.000000', 'consum', 0.0215, 'lps'),
	(613066, 130, '2014-04-01 00:06:47.000000', 'consum', 0.0215, 'lps'),
	(613067, 130, '2014-04-01 00:06:48.000000', 'consum', 0.0221, 'lps'),
	(613068, 130, '2014-04-01 00:06:49.000000', 'consum', 0.0215, 'lps'),
	(613069, 130, '2014-04-01 00:06:50.000000', 'consum', 0.0214, 'lps'),
	(613070, 130, '2014-04-01 00:06:51.000000', 'consum', 0.0214, 'lps'),
	(613071, 130, '2014-04-01 00:06:52.000000', 'consum', 0.0221, 'lps'),
	(613072, 130, '2014-04-01 00:06:53.000000', 'consum', 0.0216, 'lps'),
	(613073, 130, '2014-04-01 00:06:54.000000', 'consum', 0.0221, 'lps'),
	(613074, 130, '2014-04-01 00:06:55.000000', 'consum', 0.0212, 'lps'),
	(613075, 130, '2014-04-01 00:06:56.000000', 'consum', 0.0213, 'lps'),
	(613076, 130, '2014-04-01 00:06:57.000000', 'consum', 0.0216, 'lps'),
	(613077, 130, '2014-04-01 00:06:58.000000', 'consum', 0.0210, 'lps'),
	(613078, 130, '2014-04-01 00:06:59.000000', 'consum', 0.0214, 'lps'),
	(613079, 130, '2014-04-01 00:07:00.000000', 'consum', 0.0221, 'lps'),
	(613080, 130, '2014-04-01 00:07:01.000000', 'consum', 0.0217, 'lps'),
	(613081, 130, '2014-04-01 00:07:02.000000', 'consum', 0.0212, 'lps'),
	(613082, 130, '2014-04-01 00:07:03.000000', 'consum', 0.0211, 'lps'),
	(613083, 130, '2014-04-01 00:07:04.000000', 'consum', 0.0210, 'lps'),
	(613084, 130, '2014-04-01 00:07:05.000000', 'consum', 0.0221, 'lps'),
	(613085, 130, '2014-04-01 00:07:06.000000', 'consum', 0.0217, 'lps'),
	(613086, 130, '2014-04-01 00:07:07.000000', 'consum', 0.0214, 'lps'),
	(613087, 130, '2014-04-01 00:07:08.000000', 'consum', 0.0220, 'lps'),
	(613088, 130, '2014-04-01 00:07:09.000000', 'consum', 0.0212, 'lps'),
	(613089, 130, '2014-04-01 00:07:10.000000', 'consum', 0.0215, 'lps'),
	(613090, 130, '2014-04-01 00:07:11.000000', 'consum', 0.0217, 'lps'),
	(613091, 130, '2014-04-01 00:07:12.000000', 'consum', 0.0221, 'lps'),
	(613092, 130, '2014-04-01 00:07:13.000000', 'consum', 0.0218, 'lps'),
	(613093, 130, '2014-04-01 00:07:14.000000', 'consum', 0.0218, 'lps'),
	(613094, 130, '2014-04-01 00:07:15.000000', 'consum', 0.0213, 'lps'),
	(613095, 130, '2014-04-01 00:07:16.000000', 'consum', 0.0216, 'lps'),
	(613096, 130, '2014-04-01 00:07:17.000000', 'consum', 0.0221, 'lps'),
	(613097, 130, '2014-04-01 00:07:18.000000', 'consum', 0.0220, 'lps'),
	(613098, 130, '2014-04-01 00:07:19.000000', 'consum', 0.0218, 'lps'),
	(613099, 130, '2014-04-01 00:07:20.000000', 'consum', 0.0221, 'lps'),
	(613100, 130, '2014-04-01 00:07:21.000000', 'consum', 0.0216, 'lps'),
	(613101, 130, '2014-04-01 00:07:22.000000', 'consum', 0.0219, 'lps'),
	(613102, 130, '2014-04-01 00:07:23.000000', 'consum', 0.0215, 'lps'),
	(613103, 130, '2014-04-01 00:07:24.000000', 'consum', 0.0220, 'lps'),
	(613104, 130, '2014-04-01 00:07:25.000000', 'consum', 0.0220, 'lps'),
	(613105, 130, '2014-04-01 00:07:26.000000', 'consum', 0.0220, 'lps'),
	(613106, 130, '2014-04-01 00:07:27.000000', 'consum', 0.0218, 'lps'),
	(613107, 130, '2014-04-01 00:07:28.000000', 'consum', 0.0210, 'lps'),
	(613108, 130, '2014-04-01 00:07:29.000000', 'consum', 0.0220, 'lps'),
	(613109, 130, '2014-04-01 00:07:30.000000', 'consum', 0.0213, 'lps'),
	(613110, 130, '2014-04-01 00:07:31.000000', 'consum', 0.0218, 'lps'),
	(613111, 130, '2014-04-01 00:07:32.000000', 'consum', 0.0219, 'lps'),
	(613112, 130, '2014-04-01 00:07:33.000000', 'consum', 0.0220, 'lps'),
	(613113, 130, '2014-04-01 00:07:34.000000', 'consum', 0.0219, 'lps'),
	(613114, 130, '2014-04-01 00:07:35.000000', 'consum', 0.0215, 'lps'),
	(613115, 130, '2014-04-01 00:07:36.000000', 'consum', 0.0210, 'lps'),
	(613116, 130, '2014-04-01 00:07:37.000000', 'consum', 0.0220, 'lps'),
	(613117, 130, '2014-04-01 00:07:38.000000', 'consum', 0.0213, 'lps'),
	(613118, 130, '2014-04-01 00:07:39.000000', 'consum', 0.0217, 'lps'),
	(613119, 130, '2014-04-01 00:07:40.000000', 'consum', 0.0215, 'lps'),
	(613120, 130, '2014-04-01 00:07:41.000000', 'consum', 0.0215, 'lps'),
	(613121, 130, '2014-04-01 00:07:42.000000', 'consum', 0.0219, 'lps'),
	(613122, 130, '2014-04-01 00:07:43.000000', 'consum', 0.0217, 'lps'),
	(613123, 130, '2014-04-01 00:07:44.000000', 'consum', 0.0217, 'lps'),
	(613124, 130, '2014-04-01 00:07:45.000000', 'consum', 0.0214, 'lps'),
	(613125, 130, '2014-04-01 00:07:46.000000', 'consum', 0.0221, 'lps'),
	(613126, 130, '2014-04-01 00:07:47.000000', 'consum', 0.0217, 'lps'),
	(613127, 130, '2014-04-01 00:07:48.000000', 'consum', 0.0214, 'lps'),
	(613128, 130, '2014-04-01 00:07:49.000000', 'consum', 0.0221, 'lps'),
	(613129, 130, '2014-04-01 00:07:50.000000', 'consum', 0.0217, 'lps'),
	(613130, 130, '2014-04-01 00:07:51.000000', 'consum', 0.0211, 'lps'),
	(613131, 130, '2014-04-01 00:07:52.000000', 'consum', 0.0218, 'lps'),
	(613132, 130, '2014-04-01 00:07:53.000000', 'consum', 0.0213, 'lps'),
	(613133, 130, '2014-04-01 00:07:54.000000', 'consum', 0.0214, 'lps'),
	(613134, 130, '2014-04-01 00:07:55.000000', 'consum', 0.0221, 'lps'),
	(613135, 130, '2014-04-01 00:07:56.000000', 'consum', 0.0219, 'lps'),
	(613136, 130, '2014-04-01 00:07:57.000000', 'consum', 0.0211, 'lps'),
	(613137, 130, '2014-04-01 00:07:58.000000', 'consum', 0.0211, 'lps'),
	(613138, 130, '2014-04-01 00:07:59.000000', 'consum', 0.0215, 'lps'),
	(613139, 130, '2014-04-01 00:08:00.000000', 'consum', 0.0219, 'lps'),
	(613140, 130, '2014-04-01 00:08:01.000000', 'consum', 0.0214, 'lps'),
	(613141, 130, '2014-04-01 00:08:02.000000', 'consum', 0.0219, 'lps'),
	(613142, 130, '2014-04-01 00:08:03.000000', 'consum', 0.0218, 'lps'),
	(613143, 130, '2014-04-01 00:08:04.000000', 'consum', 0.0213, 'lps'),
	(613144, 130, '2014-04-01 00:08:05.000000', 'consum', 0.0214, 'lps'),
	(613145, 130, '2014-04-01 00:08:06.000000', 'consum', 0.0219, 'lps'),
	(613146, 130, '2014-04-01 00:08:07.000000', 'consum', 0.0219, 'lps'),
	(613147, 130, '2014-04-01 00:08:08.000000', 'consum', 0.0217, 'lps'),
	(613148, 130, '2014-04-01 00:08:09.000000', 'consum', 0.0218, 'lps'),
	(613149, 130, '2014-04-01 00:08:10.000000', 'consum', 0.0218, 'lps'),
	(613150, 130, '2014-04-01 00:08:11.000000', 'consum', 0.0216, 'lps'),
	(613151, 130, '2014-04-01 00:08:12.000000', 'consum', 0.0216, 'lps'),
	(613152, 130, '2014-04-01 00:08:13.000000', 'consum', 0.0221, 'lps'),
	(613153, 130, '2014-04-01 00:08:14.000000', 'consum', 0.0212, 'lps'),
	(613154, 130, '2014-04-01 00:08:15.000000', 'consum', 0.0211, 'lps'),
	(613155, 130, '2014-04-01 00:08:16.000000', 'consum', 0.0220, 'lps'),
	(613156, 130, '2014-04-01 00:08:17.000000', 'consum', 0.0212, 'lps'),
	(613157, 130, '2014-04-01 00:08:18.000000', 'consum', 0.0216, 'lps'),
	(613158, 130, '2014-04-01 00:08:19.000000', 'consum', 0.0219, 'lps'),
	(613159, 130, '2014-04-01 00:08:20.000000', 'consum', 0.0215, 'lps'),
	(613160, 130, '2014-04-01 00:08:21.000000', 'consum', 0.0219, 'lps'),
	(613161, 130, '2014-04-01 00:08:22.000000', 'consum', 0.0218, 'lps'),
	(613162, 130, '2014-04-01 00:08:23.000000', 'consum', 0.0221, 'lps'),
	(613163, 130, '2014-04-01 00:08:24.000000', 'consum', 0.0219, 'lps'),
	(613164, 130, '2014-04-01 00:08:25.000000', 'consum', 0.0211, 'lps'),
	(613165, 130, '2014-04-01 00:08:26.000000', 'consum', 0.0212, 'lps'),
	(613166, 130, '2014-04-01 00:08:27.000000', 'consum', 0.0219, 'lps'),
	(613167, 130, '2014-04-01 00:08:28.000000', 'consum', 0.0210, 'lps'),
	(613168, 130, '2014-04-01 00:08:29.000000', 'consum', 0.0211, 'lps'),
	(613169, 130, '2014-04-01 00:08:30.000000', 'consum', 0.0215, 'lps'),
	(613170, 130, '2014-04-01 00:08:31.000000', 'consum', 0.0210, 'lps'),
	(613171, 130, '2014-04-01 00:08:32.000000', 'consum', 0.0216, 'lps'),
	(613172, 130, '2014-04-01 00:08:33.000000', 'consum', 0.0219, 'lps'),
	(613173, 130, '2014-04-01 00:08:34.000000', 'consum', 0.0214, 'lps'),
	(613174, 130, '2014-04-01 00:08:35.000000', 'consum', 0.0213, 'lps'),
	(613175, 130, '2014-04-01 00:08:36.000000', 'consum', 0.0217, 'lps'),
	(613176, 130, '2014-04-01 00:08:37.000000', 'consum', 0.0221, 'lps'),
	(613177, 130, '2014-04-01 00:08:38.000000', 'consum', 0.0221, 'lps'),
	(613178, 130, '2014-04-01 00:08:39.000000', 'consum', 0.0210, 'lps'),
	(613179, 130, '2014-04-01 00:08:40.000000', 'consum', 0.0214, 'lps'),
	(613180, 130, '2014-04-01 00:08:41.000000', 'consum', 0.0218, 'lps'),
	(613181, 130, '2014-04-01 00:08:42.000000', 'consum', 0.0213, 'lps'),
	(613182, 130, '2014-04-01 00:08:43.000000', 'consum', 0.0214, 'lps'),
	(613183, 130, '2014-04-01 00:08:44.000000', 'consum', 0.0220, 'lps'),
	(613184, 130, '2014-04-01 00:08:45.000000', 'consum', 0.0212, 'lps'),
	(613185, 130, '2014-04-01 00:08:46.000000', 'consum', 0.0216, 'lps'),
	(613186, 130, '2014-04-01 00:08:47.000000', 'consum', 0.0211, 'lps'),
	(613187, 130, '2014-04-01 00:08:48.000000', 'consum', 0.0211, 'lps'),
	(613188, 130, '2014-04-01 00:08:49.000000', 'consum', 0.0210, 'lps'),
	(613189, 130, '2014-04-01 00:08:50.000000', 'consum', 0.0210, 'lps'),
	(613190, 130, '2014-04-01 00:08:51.000000', 'consum', 0.0211, 'lps'),
	(613191, 130, '2014-04-01 00:08:52.000000', 'consum', 0.0213, 'lps'),
	(613192, 130, '2014-04-01 00:08:53.000000', 'consum', 0.0213, 'lps'),
	(613193, 130, '2014-04-01 00:08:54.000000', 'consum', 0.0215, 'lps'),
	(613194, 130, '2014-04-01 00:08:55.000000', 'consum', 0.0216, 'lps'),
	(613195, 130, '2014-04-01 00:08:56.000000', 'consum', 0.0213, 'lps'),
	(613196, 130, '2014-04-01 00:08:57.000000', 'consum', 0.0217, 'lps'),
	(613197, 130, '2014-04-01 00:08:58.000000', 'consum', 0.0216, 'lps'),
	(613198, 130, '2014-04-01 00:08:59.000000', 'consum', 0.0218, 'lps'),
	(613199, 130, '2014-04-01 00:09:00.000000', 'consum', 0.0220, 'lps'),
	(613200, 130, '2014-04-01 00:09:01.000000', 'consum', 0.0213, 'lps'),
	(613201, 130, '2014-04-01 00:09:02.000000', 'consum', 0.0219, 'lps'),
	(613202, 130, '2014-04-01 00:09:03.000000', 'consum', 0.0211, 'lps'),
	(613203, 130, '2014-04-01 00:09:04.000000', 'consum', 0.0213, 'lps'),
	(613204, 130, '2014-04-01 00:09:05.000000', 'consum', 0.0211, 'lps'),
	(613205, 130, '2014-04-01 00:09:06.000000', 'consum', 0.0217, 'lps'),
	(613206, 130, '2014-04-01 00:09:07.000000', 'consum', 0.0218, 'lps'),
	(613207, 130, '2014-04-01 00:09:08.000000', 'consum', 0.0219, 'lps'),
	(613208, 130, '2014-04-01 00:09:09.000000', 'consum', 0.0221, 'lps'),
	(613209, 130, '2014-04-01 00:09:10.000000', 'consum', 0.0213, 'lps'),
	(613210, 130, '2014-04-01 00:09:11.000000', 'consum', 0.0216, 'lps'),
	(613211, 130, '2014-04-01 00:09:12.000000', 'consum', 0.0221, 'lps'),
	(613212, 130, '2014-04-01 00:09:13.000000', 'consum', 0.0213, 'lps'),
	(613213, 130, '2014-04-01 00:09:14.000000', 'consum', 0.0213, 'lps'),
	(613214, 130, '2014-04-01 00:09:15.000000', 'consum', 0.0219, 'lps'),
	(613215, 130, '2014-04-01 00:09:16.000000', 'consum', 0.0220, 'lps'),
	(613216, 130, '2014-04-01 00:09:17.000000', 'consum', 0.0212, 'lps'),
	(613217, 130, '2014-04-01 00:09:18.000000', 'consum', 0.0213, 'lps'),
	(613218, 130, '2014-04-01 00:09:19.000000', 'consum', 0.0220, 'lps'),
	(613219, 130, '2014-04-01 00:09:20.000000', 'consum', 0.0214, 'lps'),
	(613220, 130, '2014-04-01 00:09:21.000000', 'consum', 0.0214, 'lps'),
	(613221, 130, '2014-04-01 00:09:22.000000', 'consum', 0.0216, 'lps'),
	(613222, 130, '2014-04-01 00:09:23.000000', 'consum', 0.0219, 'lps'),
	(613223, 130, '2014-04-01 00:09:24.000000', 'consum', 0.0212, 'lps'),
	(613224, 130, '2014-04-01 00:09:25.000000', 'consum', 0.0217, 'lps'),
	(613225, 130, '2014-04-01 00:09:26.000000', 'consum', 0.0218, 'lps'),
	(613226, 130, '2014-04-01 00:09:27.000000', 'consum', 0.0217, 'lps'),
	(613227, 130, '2014-04-01 00:09:28.000000', 'consum', 0.0219, 'lps'),
	(613228, 130, '2014-04-01 00:09:29.000000', 'consum', 0.0212, 'lps'),
	(613229, 130, '2014-04-01 00:09:30.000000', 'consum', 0.0216, 'lps'),
	(613230, 130, '2014-04-01 00:09:31.000000', 'consum', 0.0212, 'lps'),
	(613231, 130, '2014-04-01 00:09:32.000000', 'consum', 0.0214, 'lps'),
	(613232, 130, '2014-04-01 00:09:33.000000', 'consum', 0.0214, 'lps'),
	(613233, 130, '2014-04-01 00:09:34.000000', 'consum', 0.0219, 'lps'),
	(613234, 130, '2014-04-01 00:09:35.000000', 'consum', 0.0219, 'lps'),
	(613235, 130, '2014-04-01 00:09:36.000000', 'consum', 0.0217, 'lps'),
	(613236, 130, '2014-04-01 00:09:37.000000', 'consum', 0.0216, 'lps'),
	(613237, 130, '2014-04-01 00:09:38.000000', 'consum', 0.0220, 'lps'),
	(613238, 130, '2014-04-01 00:09:39.000000', 'consum', 0.0221, 'lps'),
	(613239, 130, '2014-04-01 00:09:40.000000', 'consum', 0.0210, 'lps'),
	(613240, 130, '2014-04-01 00:09:41.000000', 'consum', 0.0212, 'lps'),
	(613241, 130, '2014-04-01 00:09:42.000000', 'consum', 0.0210, 'lps'),
	(613242, 130, '2014-04-01 00:09:43.000000', 'consum', 0.0216, 'lps'),
	(613243, 130, '2014-04-01 00:09:44.000000', 'consum', 0.0215, 'lps'),
	(613244, 130, '2014-04-01 00:09:45.000000', 'consum', 0.0219, 'lps'),
	(613245, 130, '2014-04-01 00:09:46.000000', 'consum', 0.0217, 'lps'),
	(613246, 130, '2014-04-01 00:09:47.000000', 'consum', 0.0220, 'lps'),
	(613247, 130, '2014-04-01 00:09:48.000000', 'consum', 0.0212, 'lps'),
	(613248, 130, '2014-04-01 00:09:49.000000', 'consum', 0.0217, 'lps'),
	(613249, 130, '2014-04-01 00:09:50.000000', 'consum', 0.0213, 'lps'),
	(613250, 130, '2014-04-01 00:09:51.000000', 'consum', 0.0216, 'lps'),
	(613251, 130, '2014-04-01 00:09:52.000000', 'consum', 0.0210, 'lps'),
	(613252, 130, '2014-04-01 00:09:53.000000', 'consum', 0.0216, 'lps'),
	(613253, 130, '2014-04-01 00:09:54.000000', 'consum', 0.0218, 'lps'),
	(613254, 130, '2014-04-01 00:09:55.000000', 'consum', 0.0219, 'lps'),
	(613255, 130, '2014-04-01 00:09:56.000000', 'consum', 0.0221, 'lps'),
	(613256, 130, '2014-04-01 00:09:57.000000', 'consum', 0.0214, 'lps'),
	(613257, 130, '2014-04-01 00:09:58.000000', 'consum', 0.0220, 'lps'),
	(613258, 130, '2014-04-01 00:09:59.000000', 'consum', 0.0212, 'lps'),
	(613259, 130, '2014-04-01 00:10:00.000000', 'consum', 0.0216, 'lps'),
	(613260, 130, '2014-04-01 00:10:01.000000', 'consum', 0.0220, 'lps'),
	(613261, 130, '2014-04-01 00:10:02.000000', 'consum', 0.0220, 'lps'),
	(613262, 130, '2014-04-01 00:10:03.000000', 'consum', 0.0218, 'lps'),
	(613263, 130, '2014-04-01 00:10:04.000000', 'consum', 0.0220, 'lps'),
	(613264, 130, '2014-04-01 00:10:05.000000', 'consum', 0.0214, 'lps'),
	(613265, 130, '2014-04-01 00:10:06.000000', 'consum', 0.0214, 'lps'),
	(613266, 130, '2014-04-01 00:10:07.000000', 'consum', 0.0215, 'lps'),
	(613267, 130, '2014-04-01 00:10:08.000000', 'consum', 0.0215, 'lps'),
	(613268, 130, '2014-04-01 00:10:09.000000', 'consum', 0.0218, 'lps'),
	(613269, 130, '2014-04-01 00:10:10.000000', 'consum', 0.0211, 'lps'),
	(613270, 130, '2014-04-01 00:10:11.000000', 'consum', 0.0216, 'lps'),
	(613271, 130, '2014-04-01 00:10:12.000000', 'consum', 0.0213, 'lps'),
	(613272, 130, '2014-04-01 00:10:13.000000', 'consum', 0.0221, 'lps'),
	(613273, 130, '2014-04-01 00:10:14.000000', 'consum', 0.0221, 'lps'),
	(613274, 130, '2014-04-01 00:10:15.000000', 'consum', 0.0221, 'lps'),
	(613275, 130, '2014-04-01 00:10:16.000000', 'consum', 0.0219, 'lps'),
	(613276, 130, '2014-04-01 00:10:17.000000', 'consum', 0.0213, 'lps'),
	(613277, 130, '2014-04-01 00:10:18.000000', 'consum', 0.0220, 'lps'),
	(613278, 130, '2014-04-01 00:10:19.000000', 'consum', 0.0215, 'lps'),
	(613279, 130, '2014-04-01 00:10:20.000000', 'consum', 0.0216, 'lps'),
	(613280, 130, '2014-04-01 00:10:21.000000', 'consum', 0.0217, 'lps'),
	(613281, 130, '2014-04-01 00:10:22.000000', 'consum', 0.0215, 'lps'),
	(613282, 130, '2014-04-01 00:10:23.000000', 'consum', 0.0215, 'lps'),
	(613283, 130, '2014-04-01 00:10:24.000000', 'consum', 0.0218, 'lps'),
	(613284, 130, '2014-04-01 00:10:25.000000', 'consum', 0.0212, 'lps'),
	(613285, 130, '2014-04-01 00:10:26.000000', 'consum', 0.0219, 'lps'),
	(613286, 130, '2014-04-01 00:10:27.000000', 'consum', 0.0215, 'lps'),
	(613287, 130, '2014-04-01 00:10:28.000000', 'consum', 0.0219, 'lps'),
	(613288, 130, '2014-04-01 00:10:29.000000', 'consum', 0.0216, 'lps'),
	(613289, 130, '2014-04-01 00:10:30.000000', 'consum', 0.0213, 'lps'),
	(613290, 130, '2014-04-01 00:10:31.000000', 'consum', 0.0219, 'lps'),
	(613291, 130, '2014-04-01 00:10:32.000000', 'consum', 0.0210, 'lps'),
	(613292, 130, '2014-04-01 00:10:33.000000', 'consum', 0.0221, 'lps'),
	(613293, 130, '2014-04-01 00:10:34.000000', 'consum', 0.0219, 'lps'),
	(613294, 130, '2014-04-01 00:10:35.000000', 'consum', 0.0220, 'lps'),
	(613295, 130, '2014-04-01 00:10:36.000000', 'consum', 0.0212, 'lps'),
	(613296, 130, '2014-04-01 00:10:37.000000', 'consum', 0.0212, 'lps'),
	(613297, 130, '2014-04-01 00:10:38.000000', 'consum', 0.0217, 'lps'),
	(613298, 130, '2014-04-01 00:10:39.000000', 'consum', 0.0213, 'lps'),
	(613299, 130, '2014-04-01 00:10:40.000000', 'consum', 0.0216, 'lps'),
	(613300, 130, '2014-04-01 00:10:41.000000', 'consum', 0.0220, 'lps'),
	(613301, 130, '2014-04-01 00:10:42.000000', 'consum', 0.0221, 'lps'),
	(613302, 130, '2014-04-01 00:10:43.000000', 'consum', 0.0221, 'lps'),
	(613303, 130, '2014-04-01 00:10:44.000000', 'consum', 0.0210, 'lps'),
	(613304, 130, '2014-04-01 00:10:45.000000', 'consum', 0.0214, 'lps'),
	(613305, 130, '2014-04-01 00:10:46.000000', 'consum', 0.0219, 'lps'),
	(613306, 130, '2014-04-01 00:10:47.000000', 'consum', 0.0219, 'lps'),
	(613307, 130, '2014-04-01 00:10:48.000000', 'consum', 0.0217, 'lps'),
	(613308, 130, '2014-04-01 00:10:49.000000', 'consum', 0.0217, 'lps'),
	(613309, 130, '2014-04-01 00:10:50.000000', 'consum', 0.0215, 'lps'),
	(613310, 130, '2014-04-01 00:10:51.000000', 'consum', 0.0212, 'lps'),
	(613311, 130, '2014-04-01 00:10:52.000000', 'consum', 0.0217, 'lps'),
	(613312, 130, '2014-04-01 00:10:53.000000', 'consum', 0.0217, 'lps'),
	(613313, 130, '2014-04-01 00:10:54.000000', 'consum', 0.0210, 'lps'),
	(613314, 130, '2014-04-01 00:10:55.000000', 'consum', 0.0217, 'lps'),
	(613315, 130, '2014-04-01 00:10:56.000000', 'consum', 0.0220, 'lps'),
	(613316, 130, '2014-04-01 00:10:57.000000', 'consum', 0.0216, 'lps'),
	(613317, 130, '2014-04-01 00:10:58.000000', 'consum', 0.0210, 'lps'),
	(613318, 130, '2014-04-01 00:10:59.000000', 'consum', 0.0219, 'lps'),
	(613319, 130, '2014-04-01 00:11:00.000000', 'consum', 0.0217, 'lps'),
	(613320, 130, '2014-04-01 00:11:01.000000', 'consum', 0.0218, 'lps'),
	(613321, 130, '2014-04-01 00:11:02.000000', 'consum', 0.0219, 'lps'),
	(613322, 130, '2014-04-01 00:11:03.000000', 'consum', 0.0218, 'lps'),
	(613323, 130, '2014-04-01 00:11:04.000000', 'consum', 0.0212, 'lps'),
	(613324, 130, '2014-04-01 00:11:05.000000', 'consum', 0.0221, 'lps'),
	(613325, 130, '2014-04-01 00:11:06.000000', 'consum', 0.0212, 'lps'),
	(613326, 130, '2014-04-01 00:11:07.000000', 'consum', 0.0210, 'lps'),
	(613327, 130, '2014-04-01 00:11:08.000000', 'consum', 0.0217, 'lps'),
	(613328, 130, '2014-04-01 00:11:09.000000', 'consum', 0.0210, 'lps'),
	(613329, 130, '2014-04-01 00:11:10.000000', 'consum', 0.0211, 'lps'),
	(613330, 130, '2014-04-01 00:11:11.000000', 'consum', 0.0219, 'lps'),
	(613331, 130, '2014-04-01 00:11:12.000000', 'consum', 0.0213, 'lps'),
	(613332, 130, '2014-04-01 00:11:13.000000', 'consum', 0.0213, 'lps'),
	(613333, 130, '2014-04-01 00:11:14.000000', 'consum', 0.0216, 'lps'),
	(613334, 130, '2014-04-01 00:11:15.000000', 'consum', 0.0219, 'lps'),
	(613335, 130, '2014-04-01 00:11:16.000000', 'consum', 0.0215, 'lps'),
	(613336, 130, '2014-04-01 00:11:17.000000', 'consum', 0.0218, 'lps'),
	(613337, 130, '2014-04-01 00:11:18.000000', 'consum', 0.0213, 'lps'),
	(613338, 130, '2014-04-01 00:11:19.000000', 'consum', 0.0214, 'lps'),
	(613339, 130, '2014-04-01 00:11:20.000000', 'consum', 0.0211, 'lps'),
	(613340, 130, '2014-04-01 00:11:21.000000', 'consum', 0.0214, 'lps'),
	(613341, 130, '2014-04-01 00:11:22.000000', 'consum', 0.0214, 'lps'),
	(613342, 130, '2014-04-01 00:11:23.000000', 'consum', 0.0220, 'lps'),
	(613343, 130, '2014-04-01 00:11:24.000000', 'consum', 0.0213, 'lps'),
	(613344, 130, '2014-04-01 00:11:25.000000', 'consum', 0.0218, 'lps'),
	(613345, 130, '2014-04-01 00:11:26.000000', 'consum', 0.0219, 'lps'),
	(613346, 130, '2014-04-01 00:11:27.000000', 'consum', 0.0218, 'lps'),
	(613347, 130, '2014-04-01 00:11:28.000000', 'consum', 0.0212, 'lps'),
	(613348, 130, '2014-04-01 00:11:29.000000', 'consum', 0.0210, 'lps'),
	(613349, 130, '2014-04-01 00:11:30.000000', 'consum', 0.0217, 'lps'),
	(613350, 130, '2014-04-01 00:11:31.000000', 'consum', 0.0219, 'lps'),
	(613351, 130, '2014-04-01 00:11:32.000000', 'consum', 0.0214, 'lps'),
	(613352, 130, '2014-04-01 00:11:33.000000', 'consum', 0.0212, 'lps'),
	(613353, 130, '2014-04-01 00:11:34.000000', 'consum', 0.0221, 'lps'),
	(613354, 130, '2014-04-01 00:11:35.000000', 'consum', 0.0212, 'lps'),
	(613355, 130, '2014-04-01 00:11:36.000000', 'consum', 0.0211, 'lps'),
	(613356, 130, '2014-04-01 00:11:37.000000', 'consum', 0.0221, 'lps'),
	(613357, 130, '2014-04-01 00:11:38.000000', 'consum', 0.0217, 'lps'),
	(613358, 130, '2014-04-01 00:11:39.000000', 'consum', 0.0210, 'lps'),
	(613359, 130, '2014-04-01 00:11:40.000000', 'consum', 0.0213, 'lps'),
	(613360, 130, '2014-04-01 00:11:41.000000', 'consum', 0.0215, 'lps'),
	(613361, 130, '2014-04-01 00:11:42.000000', 'consum', 0.0215, 'lps'),
	(613362, 130, '2014-04-01 00:11:43.000000', 'consum', 0.0218, 'lps'),
	(613363, 130, '2014-04-01 00:11:44.000000', 'consum', 0.0213, 'lps'),
	(613364, 130, '2014-04-01 00:11:45.000000', 'consum', 0.0215, 'lps'),
	(613365, 130, '2014-04-01 00:11:46.000000', 'consum', 0.0213, 'lps'),
	(613366, 130, '2014-04-01 00:11:47.000000', 'consum', 0.0213, 'lps'),
	(613367, 130, '2014-04-01 00:11:48.000000', 'consum', 0.0214, 'lps'),
	(613368, 130, '2014-04-01 00:11:49.000000', 'consum', 0.0221, 'lps'),
	(613369, 130, '2014-04-01 00:11:50.000000', 'consum', 0.0217, 'lps'),
	(613370, 130, '2014-04-01 00:11:51.000000', 'consum', 0.0213, 'lps'),
	(613371, 130, '2014-04-01 00:11:52.000000', 'consum', 0.0215, 'lps'),
	(613372, 130, '2014-04-01 00:11:53.000000', 'consum', 0.0218, 'lps'),
	(613373, 130, '2014-04-01 00:11:54.000000', 'consum', 0.0220, 'lps'),
	(613374, 130, '2014-04-01 00:11:55.000000', 'consum', 0.0215, 'lps'),
	(613375, 130, '2014-04-01 00:11:56.000000', 'consum', 0.0215, 'lps'),
	(613376, 130, '2014-04-01 00:11:57.000000', 'consum', 0.0212, 'lps'),
	(613377, 130, '2014-04-01 00:11:58.000000', 'consum', 0.0215, 'lps'),
	(613378, 130, '2014-04-01 00:11:59.000000', 'consum', 0.0217, 'lps'),
	(613379, 130, '2014-04-01 00:12:00.000000', 'consum', 0.0221, 'lps'),
	(613380, 130, '2014-04-01 00:12:01.000000', 'consum', 0.0220, 'lps'),
	(613381, 130, '2014-04-01 00:12:02.000000', 'consum', 0.0213, 'lps'),
	(613382, 130, '2014-04-01 00:12:03.000000', 'consum', 0.0210, 'lps'),
	(613383, 130, '2014-04-01 00:12:04.000000', 'consum', 0.0214, 'lps'),
	(613384, 130, '2014-04-01 00:12:05.000000', 'consum', 0.0216, 'lps'),
	(613385, 130, '2014-04-01 00:12:06.000000', 'consum', 0.0216, 'lps'),
	(613386, 130, '2014-04-01 00:12:07.000000', 'consum', 0.0212, 'lps'),
	(613387, 130, '2014-04-01 00:12:08.000000', 'consum', 0.0214, 'lps'),
	(613388, 130, '2014-04-01 00:12:09.000000', 'consum', 0.0213, 'lps'),
	(613389, 130, '2014-04-01 00:12:10.000000', 'consum', 0.0212, 'lps'),
	(613390, 130, '2014-04-01 00:12:11.000000', 'consum', 0.0212, 'lps'),
	(613391, 130, '2014-04-01 00:12:12.000000', 'consum', 0.0216, 'lps'),
	(613392, 130, '2014-04-01 00:12:13.000000', 'consum', 0.0221, 'lps'),
	(613393, 130, '2014-04-01 00:12:14.000000', 'consum', 0.0214, 'lps'),
	(613394, 130, '2014-04-01 00:12:15.000000', 'consum', 0.0218, 'lps'),
	(613395, 130, '2014-04-01 00:12:16.000000', 'consum', 0.0216, 'lps'),
	(613396, 130, '2014-04-01 00:12:17.000000', 'consum', 0.0216, 'lps'),
	(613397, 130, '2014-04-01 00:12:18.000000', 'consum', 0.0221, 'lps'),
	(613398, 130, '2014-04-01 00:12:19.000000', 'consum', 0.0213, 'lps'),
	(613399, 130, '2014-04-01 00:12:20.000000', 'consum', 0.0218, 'lps'),
	(613400, 130, '2014-04-01 00:12:21.000000', 'consum', 0.0218, 'lps'),
	(613401, 130, '2014-04-01 00:12:22.000000', 'consum', 0.0215, 'lps'),
	(613402, 130, '2014-04-01 00:12:23.000000', 'consum', 0.0220, 'lps'),
	(613403, 130, '2014-04-01 00:12:24.000000', 'consum', 0.0212, 'lps'),
	(613404, 130, '2014-04-01 00:12:25.000000', 'consum', 0.0215, 'lps'),
	(613405, 130, '2014-04-01 00:12:26.000000', 'consum', 0.0217, 'lps'),
	(613406, 130, '2014-04-01 00:12:27.000000', 'consum', 0.0217, 'lps'),
	(613407, 130, '2014-04-01 00:12:28.000000', 'consum', 0.0215, 'lps'),
	(613408, 130, '2014-04-01 00:12:29.000000', 'consum', 0.0215, 'lps'),
	(613409, 130, '2014-04-01 00:12:30.000000', 'consum', 0.0219, 'lps'),
	(613410, 130, '2014-04-01 00:12:31.000000', 'consum', 0.0217, 'lps'),
	(613411, 130, '2014-04-01 00:12:32.000000', 'consum', 0.0217, 'lps'),
	(613412, 130, '2014-04-01 00:12:33.000000', 'consum', 0.0215, 'lps'),
	(613413, 130, '2014-04-01 00:12:34.000000', 'consum', 0.0215, 'lps'),
	(613414, 130, '2014-04-01 00:12:35.000000', 'consum', 0.0221, 'lps'),
	(613415, 130, '2014-04-01 00:12:36.000000', 'consum', 0.0214, 'lps'),
	(613416, 130, '2014-04-01 00:12:37.000000', 'consum', 0.0220, 'lps'),
	(613417, 130, '2014-04-01 00:12:38.000000', 'consum', 0.0212, 'lps'),
	(613418, 130, '2014-04-01 00:12:39.000000', 'consum', 0.0213, 'lps'),
	(613419, 130, '2014-04-01 00:12:40.000000', 'consum', 0.0210, 'lps'),
	(613420, 130, '2014-04-01 00:12:41.000000', 'consum', 0.0215, 'lps'),
	(613421, 130, '2014-04-01 00:12:42.000000', 'consum', 0.0210, 'lps'),
	(613422, 130, '2014-04-01 00:12:43.000000', 'consum', 0.0219, 'lps'),
	(613423, 130, '2014-04-01 00:12:44.000000', 'consum', 0.0218, 'lps'),
	(613424, 130, '2014-04-01 00:12:45.000000', 'consum', 0.0214, 'lps'),
	(613425, 130, '2014-04-01 00:12:46.000000', 'consum', 0.0216, 'lps'),
	(613426, 130, '2014-04-01 00:12:47.000000', 'consum', 0.0218, 'lps'),
	(613427, 130, '2014-04-01 00:12:48.000000', 'consum', 0.0221, 'lps'),
	(613428, 130, '2014-04-01 00:12:49.000000', 'consum', 0.0218, 'lps'),
	(613429, 130, '2014-04-01 00:12:50.000000', 'consum', 0.0216, 'lps'),
	(613430, 130, '2014-04-01 00:12:51.000000', 'consum', 0.0219, 'lps'),
	(613431, 130, '2014-04-01 00:12:52.000000', 'consum', 0.0212, 'lps'),
	(613432, 130, '2014-04-01 00:12:53.000000', 'consum', 0.0219, 'lps'),
	(613433, 130, '2014-04-01 00:12:54.000000', 'consum', 0.0211, 'lps'),
	(613434, 130, '2014-04-01 00:12:55.000000', 'consum', 0.0215, 'lps'),
	(613435, 130, '2014-04-01 00:12:56.000000', 'consum', 0.0219, 'lps'),
	(613436, 130, '2014-04-01 00:12:57.000000', 'consum', 0.0217, 'lps'),
	(613437, 130, '2014-04-01 00:12:58.000000', 'consum', 0.0218, 'lps'),
	(613438, 130, '2014-04-01 00:12:59.000000', 'consum', 0.0217, 'lps'),
	(613439, 130, '2014-04-01 00:13:00.000000', 'consum', 0.0211, 'lps'),
	(613440, 130, '2014-04-01 00:13:01.000000', 'consum', 0.0218, 'lps'),
	(613441, 130, '2014-04-01 00:13:02.000000', 'consum', 0.0212, 'lps'),
	(613442, 130, '2014-04-01 00:13:03.000000', 'consum', 0.0210, 'lps'),
	(613443, 130, '2014-04-01 00:13:04.000000', 'consum', 0.0215, 'lps'),
	(613444, 130, '2014-04-01 00:13:05.000000', 'consum', 0.0213, 'lps'),
	(613445, 130, '2014-04-01 00:13:06.000000', 'consum', 0.0210, 'lps'),
	(613446, 130, '2014-04-01 00:13:07.000000', 'consum', 0.0212, 'lps'),
	(613447, 130, '2014-04-01 00:13:08.000000', 'consum', 0.0210, 'lps'),
	(613448, 130, '2014-04-01 00:13:09.000000', 'consum', 0.0217, 'lps'),
	(613449, 130, '2014-04-01 00:13:10.000000', 'consum', 0.0221, 'lps'),
	(613450, 130, '2014-04-01 00:13:11.000000', 'consum', 0.0210, 'lps'),
	(613451, 130, '2014-04-01 00:13:12.000000', 'consum', 0.0211, 'lps'),
	(613452, 130, '2014-04-01 00:13:13.000000', 'consum', 0.0219, 'lps'),
	(613453, 130, '2014-04-01 00:13:14.000000', 'consum', 0.0213, 'lps'),
	(613454, 130, '2014-04-01 00:13:15.000000', 'consum', 0.0210, 'lps'),
	(613455, 130, '2014-04-01 00:13:16.000000', 'consum', 0.0215, 'lps'),
	(613456, 130, '2014-04-01 00:13:17.000000', 'consum', 0.0212, 'lps'),
	(613457, 130, '2014-04-01 00:13:18.000000', 'consum', 0.0216, 'lps'),
	(613458, 130, '2014-04-01 00:13:19.000000', 'consum', 0.0210, 'lps'),
	(613459, 130, '2014-04-01 00:13:20.000000', 'consum', 0.0217, 'lps'),
	(613460, 130, '2014-04-01 00:13:21.000000', 'consum', 0.0210, 'lps'),
	(613461, 130, '2014-04-01 00:13:22.000000', 'consum', 0.0215, 'lps'),
	(613462, 130, '2014-04-01 00:13:23.000000', 'consum', 0.0212, 'lps'),
	(613463, 130, '2014-04-01 00:13:24.000000', 'consum', 0.0217, 'lps'),
	(613464, 130, '2014-04-01 00:13:25.000000', 'consum', 0.0215, 'lps'),
	(613465, 130, '2014-04-01 00:13:26.000000', 'consum', 0.0217, 'lps'),
	(613466, 130, '2014-04-01 00:13:27.000000', 'consum', 0.0215, 'lps'),
	(613467, 130, '2014-04-01 00:13:28.000000', 'consum', 0.0217, 'lps'),
	(613468, 130, '2014-04-01 00:13:29.000000', 'consum', 0.0217, 'lps'),
	(613469, 130, '2014-04-01 00:13:30.000000', 'consum', 0.0213, 'lps'),
	(613470, 130, '2014-04-01 00:13:31.000000', 'consum', 0.0216, 'lps'),
	(613471, 130, '2014-04-01 00:13:32.000000', 'consum', 0.0219, 'lps'),
	(613472, 130, '2014-04-01 00:13:33.000000', 'consum', 0.0214, 'lps'),
	(613473, 130, '2014-04-01 00:13:34.000000', 'consum', 0.0216, 'lps'),
	(613474, 130, '2014-04-01 00:13:35.000000', 'consum', 0.0218, 'lps'),
	(613475, 130, '2014-04-01 00:13:36.000000', 'consum', 0.0217, 'lps'),
	(613476, 130, '2014-04-01 00:13:37.000000', 'consum', 0.0213, 'lps'),
	(613477, 130, '2014-04-01 00:13:38.000000', 'consum', 0.0214, 'lps'),
	(613478, 130, '2014-04-01 00:13:39.000000', 'consum', 0.0211, 'lps'),
	(613479, 130, '2014-04-01 00:13:40.000000', 'consum', 0.0213, 'lps'),
	(613480, 130, '2014-04-01 00:13:41.000000', 'consum', 0.0214, 'lps'),
	(613481, 130, '2014-04-01 00:13:42.000000', 'consum', 0.0220, 'lps'),
	(613482, 130, '2014-04-01 00:13:43.000000', 'consum', 0.0213, 'lps'),
	(613483, 130, '2014-04-01 00:13:44.000000', 'consum', 0.0220, 'lps'),
	(613484, 130, '2014-04-01 00:13:45.000000', 'consum', 0.0213, 'lps'),
	(613485, 130, '2014-04-01 00:13:46.000000', 'consum', 0.0220, 'lps'),
	(613486, 130, '2014-04-01 00:13:47.000000', 'consum', 0.0218, 'lps'),
	(613487, 130, '2014-04-01 00:13:48.000000', 'consum', 0.0218, 'lps'),
	(613488, 130, '2014-04-01 00:13:49.000000', 'consum', 0.0216, 'lps'),
	(613489, 130, '2014-04-01 00:13:50.000000', 'consum', 0.0216, 'lps'),
	(613490, 130, '2014-04-01 00:13:51.000000', 'consum', 0.0212, 'lps'),
	(613491, 130, '2014-04-01 00:13:52.000000', 'consum', 0.0211, 'lps'),
	(613492, 130, '2014-04-01 00:13:53.000000', 'consum', 0.0213, 'lps'),
	(613493, 130, '2014-04-01 00:13:54.000000', 'consum', 0.0210, 'lps'),
	(613494, 130, '2014-04-01 00:13:55.000000', 'consum', 0.0214, 'lps'),
	(613495, 130, '2014-04-01 00:13:56.000000', 'consum', 0.0219, 'lps'),
	(613496, 130, '2014-04-01 00:13:57.000000', 'consum', 0.0219, 'lps'),
	(613497, 130, '2014-04-01 00:13:58.000000', 'consum', 0.0215, 'lps'),
	(613498, 130, '2014-04-01 00:13:59.000000', 'consum', 0.0220, 'lps'),
	(613499, 130, '2014-04-01 00:14:00.000000', 'consum', 0.0210, 'lps'),
	(613500, 130, '2014-04-01 00:14:01.000000', 'consum', 0.0217, 'lps'),
	(613501, 130, '2014-04-01 00:14:02.000000', 'consum', 0.0220, 'lps'),
	(613502, 130, '2014-04-01 00:14:03.000000', 'consum', 0.0216, 'lps'),
	(613503, 130, '2014-04-01 00:14:04.000000', 'consum', 0.0213, 'lps'),
	(613504, 130, '2014-04-01 00:14:05.000000', 'consum', 0.0217, 'lps'),
	(613505, 130, '2014-04-01 00:14:06.000000', 'consum', 0.0215, 'lps'),
	(613506, 130, '2014-04-01 00:14:07.000000', 'consum', 0.0213, 'lps'),
	(613507, 130, '2014-04-01 00:14:08.000000', 'consum', 0.0210, 'lps'),
	(613508, 130, '2014-04-01 00:14:09.000000', 'consum', 0.0214, 'lps'),
	(613509, 130, '2014-04-01 00:14:10.000000', 'consum', 0.0217, 'lps'),
	(613510, 130, '2014-04-01 00:14:11.000000', 'consum', 0.0221, 'lps'),
	(613511, 130, '2014-04-01 00:14:12.000000', 'consum', 0.0211, 'lps'),
	(613512, 130, '2014-04-01 00:14:13.000000', 'consum', 0.0219, 'lps'),
	(613513, 130, '2014-04-01 00:14:14.000000', 'consum', 0.0217, 'lps'),
	(613514, 130, '2014-04-01 00:14:15.000000', 'consum', 0.0216, 'lps'),
	(613515, 130, '2014-04-01 00:14:16.000000', 'consum', 0.0210, 'lps'),
	(613516, 130, '2014-04-01 00:14:17.000000', 'consum', 0.0217, 'lps'),
	(613517, 130, '2014-04-01 00:14:18.000000', 'consum', 0.0219, 'lps'),
	(613518, 130, '2014-04-01 00:14:19.000000', 'consum', 0.0210, 'lps'),
	(613519, 130, '2014-04-01 00:14:20.000000', 'consum', 0.0221, 'lps'),
	(613520, 130, '2014-04-01 00:14:21.000000', 'consum', 0.0216, 'lps'),
	(613521, 130, '2014-04-01 00:14:22.000000', 'consum', 0.0219, 'lps'),
	(613522, 130, '2014-04-01 00:14:23.000000', 'consum', 0.0214, 'lps'),
	(613523, 130, '2014-04-01 00:14:24.000000', 'consum', 0.0214, 'lps'),
	(613524, 130, '2014-04-01 00:14:25.000000', 'consum', 0.0210, 'lps'),
	(613525, 130, '2014-04-01 00:14:26.000000', 'consum', 0.0219, 'lps'),
	(613526, 130, '2014-04-01 00:14:27.000000', 'consum', 0.0221, 'lps'),
	(613527, 130, '2014-04-01 00:14:28.000000', 'consum', 0.0214, 'lps'),
	(613528, 130, '2014-04-01 00:14:29.000000', 'consum', 0.0212, 'lps'),
	(613529, 130, '2014-04-01 00:14:30.000000', 'consum', 0.0217, 'lps'),
	(613530, 130, '2014-04-01 00:14:31.000000', 'consum', 0.0217, 'lps'),
	(613531, 130, '2014-04-01 00:14:32.000000', 'consum', 0.0211, 'lps'),
	(613532, 130, '2014-04-01 00:14:33.000000', 'consum', 0.0221, 'lps'),
	(613533, 130, '2014-04-01 00:14:34.000000', 'consum', 0.0213, 'lps'),
	(613534, 130, '2014-04-01 00:14:35.000000', 'consum', 0.0218, 'lps'),
	(613535, 130, '2014-04-01 00:14:36.000000', 'consum', 0.0216, 'lps'),
	(613536, 130, '2014-04-01 00:14:37.000000', 'consum', 0.0218, 'lps'),
	(613537, 130, '2014-04-01 00:14:38.000000', 'consum', 0.0220, 'lps'),
	(613538, 130, '2014-04-01 00:14:39.000000', 'consum', 0.0214, 'lps'),
	(613539, 130, '2014-04-01 00:14:40.000000', 'consum', 0.0212, 'lps'),
	(613540, 130, '2014-04-01 00:14:41.000000', 'consum', 0.0219, 'lps'),
	(613541, 130, '2014-04-01 00:14:42.000000', 'consum', 0.0215, 'lps'),
	(613542, 130, '2014-04-01 00:14:43.000000', 'consum', 0.0219, 'lps'),
	(613543, 130, '2014-04-01 00:14:44.000000', 'consum', 0.0217, 'lps'),
	(613544, 130, '2014-04-01 00:14:45.000000', 'consum', 0.0218, 'lps'),
	(613545, 130, '2014-04-01 00:14:46.000000', 'consum', 0.0220, 'lps'),
	(613546, 130, '2014-04-01 00:14:47.000000', 'consum', 0.0211, 'lps'),
	(613547, 130, '2014-04-01 00:14:48.000000', 'consum', 0.0210, 'lps'),
	(613548, 130, '2014-04-01 00:14:49.000000', 'consum', 0.0218, 'lps'),
	(613549, 130, '2014-04-01 00:14:50.000000', 'consum', 0.0213, 'lps'),
	(613550, 130, '2014-04-01 00:14:51.000000', 'consum', 0.0217, 'lps'),
	(613551, 130, '2014-04-01 00:14:52.000000', 'consum', 0.0212, 'lps'),
	(613552, 130, '2014-04-01 00:14:53.000000', 'consum', 0.0212, 'lps'),
	(613553, 130, '2014-04-01 00:14:54.000000', 'consum', 0.0212, 'lps'),
	(613554, 130, '2014-04-01 00:14:55.000000', 'consum', 0.0215, 'lps'),
	(613555, 130, '2014-04-01 00:14:56.000000', 'consum', 0.0218, 'lps'),
	(613556, 130, '2014-04-01 00:14:57.000000', 'consum', 0.0210, 'lps'),
	(613557, 130, '2014-04-01 00:14:58.000000', 'consum', 0.0210, 'lps'),
	(613558, 130, '2014-04-01 00:14:59.000000', 'consum', 0.0210, 'lps'),
	(613559, 130, '2014-04-01 00:15:00.000000', 'consum', 0.0213, 'lps'),
	(613560, 130, '2014-04-01 00:15:01.000000', 'consum', 0.0212, 'lps'),
	(613561, 130, '2014-04-01 00:15:02.000000', 'consum', 0.0211, 'lps'),
	(613562, 130, '2014-04-01 00:15:03.000000', 'consum', 0.0221, 'lps'),
	(613563, 130, '2014-04-01 00:15:04.000000', 'consum', 0.0216, 'lps'),
	(613564, 130, '2014-04-01 00:15:05.000000', 'consum', 0.0219, 'lps'),
	(613565, 130, '2014-04-01 00:15:06.000000', 'consum', 0.0213, 'lps'),
	(613566, 130, '2014-04-01 00:15:07.000000', 'consum', 0.0213, 'lps'),
	(613567, 130, '2014-04-01 00:15:08.000000', 'consum', 0.0213, 'lps'),
	(613568, 130, '2014-04-01 00:15:09.000000', 'consum', 0.0219, 'lps'),
	(613569, 130, '2014-04-01 00:15:10.000000', 'consum', 0.0221, 'lps'),
	(613570, 130, '2014-04-01 00:15:11.000000', 'consum', 0.0214, 'lps'),
	(613571, 130, '2014-04-01 00:15:12.000000', 'consum', 0.0212, 'lps'),
	(613572, 130, '2014-04-01 00:15:13.000000', 'consum', 0.0219, 'lps'),
	(613573, 130, '2014-04-01 00:15:14.000000', 'consum', 0.0213, 'lps'),
	(613574, 130, '2014-04-01 00:15:15.000000', 'consum', 0.0212, 'lps'),
	(613575, 130, '2014-04-01 00:15:16.000000', 'consum', 0.0211, 'lps'),
	(613576, 130, '2014-04-01 00:15:17.000000', 'consum', 0.0221, 'lps'),
	(613577, 130, '2014-04-01 00:15:18.000000', 'consum', 0.0213, 'lps'),
	(613578, 130, '2014-04-01 00:15:19.000000', 'consum', 0.0217, 'lps'),
	(613579, 130, '2014-04-01 00:15:20.000000', 'consum', 0.0215, 'lps'),
	(613580, 130, '2014-04-01 00:15:21.000000', 'consum', 0.0213, 'lps'),
	(613581, 130, '2014-04-01 00:15:22.000000', 'consum', 0.0212, 'lps'),
	(613582, 130, '2014-04-01 00:15:23.000000', 'consum', 0.0211, 'lps'),
	(613583, 130, '2014-04-01 00:15:24.000000', 'consum', 0.0221, 'lps'),
	(613584, 130, '2014-04-01 00:15:25.000000', 'consum', 0.0214, 'lps'),
	(613585, 130, '2014-04-01 00:15:26.000000', 'consum', 0.0221, 'lps'),
	(613586, 130, '2014-04-01 00:15:27.000000', 'consum', 0.0220, 'lps'),
	(613587, 130, '2014-04-01 00:15:28.000000', 'consum', 0.0213, 'lps'),
	(613588, 130, '2014-04-01 00:15:29.000000', 'consum', 0.0220, 'lps'),
	(613589, 130, '2014-04-01 00:15:30.000000', 'consum', 0.0217, 'lps'),
	(613590, 130, '2014-04-01 00:15:31.000000', 'consum', 0.0214, 'lps'),
	(613591, 130, '2014-04-01 00:15:32.000000', 'consum', 0.0212, 'lps'),
	(613592, 130, '2014-04-01 00:15:33.000000', 'consum', 0.0218, 'lps'),
	(613593, 130, '2014-04-01 00:15:34.000000', 'consum', 0.0220, 'lps'),
	(613594, 130, '2014-04-01 00:15:35.000000', 'consum', 0.0215, 'lps'),
	(613595, 130, '2014-04-01 00:15:36.000000', 'consum', 0.0217, 'lps'),
	(613596, 130, '2014-04-01 00:15:37.000000', 'consum', 0.0218, 'lps'),
	(613597, 130, '2014-04-01 00:15:38.000000', 'consum', 0.0217, 'lps'),
	(613598, 130, '2014-04-01 00:15:39.000000', 'consum', 0.0220, 'lps'),
	(613599, 130, '2014-04-01 00:15:40.000000', 'consum', 0.0219, 'lps'),
	(613600, 130, '2014-04-01 00:15:41.000000', 'consum', 0.0210, 'lps'),
	(613601, 130, '2014-04-01 00:15:42.000000', 'consum', 0.0210, 'lps'),
	(613602, 130, '2014-04-01 00:15:43.000000', 'consum', 0.0221, 'lps'),
	(613603, 130, '2014-04-01 00:15:44.000000', 'consum', 0.0217, 'lps'),
	(613604, 130, '2014-04-01 00:15:45.000000', 'consum', 0.0213, 'lps'),
	(613605, 130, '2014-04-01 00:15:46.000000', 'consum', 0.0218, 'lps'),
	(613606, 130, '2014-04-01 00:15:47.000000', 'consum', 0.0218, 'lps'),
	(613607, 130, '2014-04-01 00:15:48.000000', 'consum', 0.0215, 'lps'),
	(613608, 130, '2014-04-01 00:15:49.000000', 'consum', 0.0210, 'lps'),
	(613609, 130, '2014-04-01 00:15:50.000000', 'consum', 0.0219, 'lps'),
	(613610, 130, '2014-04-01 00:15:51.000000', 'consum', 0.0219, 'lps'),
	(613611, 130, '2014-04-01 00:15:52.000000', 'consum', 0.0215, 'lps'),
	(613612, 130, '2014-04-01 00:15:53.000000', 'consum', 0.0212, 'lps'),
	(613613, 130, '2014-04-01 00:15:54.000000', 'consum', 0.0214, 'lps'),
	(613614, 130, '2014-04-01 00:15:55.000000', 'consum', 0.0216, 'lps'),
	(613615, 130, '2014-04-01 00:15:56.000000', 'consum', 0.0214, 'lps'),
	(613616, 130, '2014-04-01 00:15:57.000000', 'consum', 0.0213, 'lps'),
	(613617, 130, '2014-04-01 00:15:58.000000', 'consum', 0.0213, 'lps'),
	(613618, 130, '2014-04-01 00:15:59.000000', 'consum', 0.0218, 'lps'),
	(613619, 130, '2014-04-01 00:16:00.000000', 'consum', 0.0217, 'lps'),
	(613620, 130, '2014-04-01 00:16:01.000000', 'consum', 0.0220, 'lps'),
	(613621, 130, '2014-04-01 00:16:02.000000', 'consum', 0.0217, 'lps'),
	(613622, 130, '2014-04-01 00:16:03.000000', 'consum', 0.0217, 'lps'),
	(613623, 130, '2014-04-01 00:16:04.000000', 'consum', 0.0210, 'lps'),
	(613624, 130, '2014-04-01 00:16:05.000000', 'consum', 0.0215, 'lps'),
	(613625, 130, '2014-04-01 00:16:06.000000', 'consum', 0.0211, 'lps'),
	(613626, 130, '2014-04-01 00:16:07.000000', 'consum', 0.0212, 'lps'),
	(613627, 130, '2014-04-01 00:16:08.000000', 'consum', 0.0217, 'lps'),
	(613628, 130, '2014-04-01 00:16:09.000000', 'consum', 0.0215, 'lps'),
	(613629, 130, '2014-04-01 00:16:10.000000', 'consum', 0.0217, 'lps'),
	(613630, 130, '2014-04-01 00:16:11.000000', 'consum', 0.0217, 'lps'),
	(613631, 130, '2014-04-01 00:16:12.000000', 'consum', 0.0213, 'lps'),
	(613632, 130, '2014-04-01 00:16:13.000000', 'consum', 0.0216, 'lps'),
	(613633, 130, '2014-04-01 00:16:14.000000', 'consum', 0.0220, 'lps'),
	(613634, 130, '2014-04-01 00:16:15.000000', 'consum', 0.0218, 'lps'),
	(613635, 130, '2014-04-01 00:16:16.000000', 'consum', 0.0210, 'lps'),
	(613636, 130, '2014-04-01 00:16:17.000000', 'consum', 0.0210, 'lps'),
	(613637, 130, '2014-04-01 00:16:18.000000', 'consum', 0.0212, 'lps'),
	(613638, 130, '2014-04-01 00:16:19.000000', 'consum', 0.0219, 'lps'),
	(613639, 130, '2014-04-01 00:16:20.000000', 'consum', 0.0215, 'lps'),
	(613640, 130, '2014-04-01 00:16:21.000000', 'consum', 0.0220, 'lps'),
	(613641, 130, '2014-04-01 00:16:22.000000', 'consum', 0.0210, 'lps'),
	(613642, 130, '2014-04-01 00:16:23.000000', 'consum', 0.0216, 'lps'),
	(613643, 130, '2014-04-01 00:16:24.000000', 'consum', 0.0215, 'lps'),
	(613644, 130, '2014-04-01 00:16:25.000000', 'consum', 0.0217, 'lps'),
	(613645, 130, '2014-04-01 00:16:26.000000', 'consum', 0.0220, 'lps'),
	(613646, 130, '2014-04-01 00:16:27.000000', 'consum', 0.0216, 'lps'),
	(613647, 130, '2014-04-01 00:16:28.000000', 'consum', 0.0210, 'lps'),
	(613648, 130, '2014-04-01 00:16:29.000000', 'consum', 0.0215, 'lps'),
	(613649, 130, '2014-04-01 00:16:30.000000', 'consum', 0.0212, 'lps'),
	(613650, 130, '2014-04-01 00:16:31.000000', 'consum', 0.0218, 'lps'),
	(613651, 130, '2014-04-01 00:16:32.000000', 'consum', 0.0220, 'lps'),
	(613652, 130, '2014-04-01 00:16:33.000000', 'consum', 0.0212, 'lps'),
	(613653, 130, '2014-04-01 00:16:34.000000', 'consum', 0.0214, 'lps'),
	(613654, 130, '2014-04-01 00:16:35.000000', 'consum', 0.0214, 'lps'),
	(613655, 130, '2014-04-01 00:16:36.000000', 'consum', 0.0219, 'lps'),
	(613656, 130, '2014-04-01 00:16:37.000000', 'consum', 0.0219, 'lps'),
	(613657, 130, '2014-04-01 00:16:38.000000', 'consum', 0.0215, 'lps'),
	(613658, 130, '2014-04-01 00:16:39.000000', 'consum', 0.0210, 'lps'),
	(613659, 130, '2014-04-01 00:16:40.000000', 'consum', 0.0218, 'lps'),
	(613660, 130, '2014-04-01 00:16:41.000000', 'consum', 0.0215, 'lps'),
	(613661, 130, '2014-04-01 00:16:42.000000', 'consum', 0.0212, 'lps'),
	(613662, 130, '2014-04-01 00:16:43.000000', 'consum', 0.0218, 'lps'),
	(613663, 130, '2014-04-01 00:16:44.000000', 'consum', 0.0221, 'lps'),
	(613664, 130, '2014-04-01 00:16:45.000000', 'consum', 0.0217, 'lps'),
	(613665, 130, '2014-04-01 00:16:46.000000', 'consum', 0.0213, 'lps'),
	(613666, 130, '2014-04-01 00:16:47.000000', 'consum', 0.0217, 'lps'),
	(613667, 130, '2014-04-01 00:16:48.000000', 'consum', 0.0213, 'lps'),
	(613668, 130, '2014-04-01 00:16:49.000000', 'consum', 0.0214, 'lps'),
	(613669, 130, '2014-04-01 00:16:50.000000', 'consum', 0.0212, 'lps'),
	(613670, 130, '2014-04-01 00:16:51.000000', 'consum', 0.0220, 'lps'),
	(613671, 130, '2014-04-01 00:16:52.000000', 'consum', 0.0219, 'lps'),
	(613672, 130, '2014-04-01 00:16:53.000000', 'consum', 0.0213, 'lps'),
	(613673, 130, '2014-04-01 00:16:54.000000', 'consum', 0.0221, 'lps'),
	(613674, 130, '2014-04-01 00:16:55.000000', 'consum', 0.0221, 'lps'),
	(613675, 130, '2014-04-01 00:16:56.000000', 'consum', 0.0211, 'lps'),
	(613676, 130, '2014-04-01 00:16:57.000000', 'consum', 0.0216, 'lps'),
	(613677, 130, '2014-04-01 00:16:58.000000', 'consum', 0.0213, 'lps'),
	(613678, 130, '2014-04-01 00:16:59.000000', 'consum', 0.0210, 'lps'),
	(613679, 130, '2014-04-01 00:17:00.000000', 'consum', 0.0211, 'lps'),
	(613680, 130, '2014-04-01 00:17:01.000000', 'consum', 0.0215, 'lps'),
	(613681, 130, '2014-04-01 00:17:02.000000', 'consum', 0.0221, 'lps'),
	(613682, 130, '2014-04-01 00:17:03.000000', 'consum', 0.0213, 'lps'),
	(613683, 130, '2014-04-01 00:17:04.000000', 'consum', 0.0218, 'lps'),
	(613684, 130, '2014-04-01 00:17:05.000000', 'consum', 0.0219, 'lps'),
	(613685, 130, '2014-04-01 00:17:06.000000', 'consum', 0.0218, 'lps'),
	(613686, 130, '2014-04-01 00:17:07.000000', 'consum', 0.0214, 'lps'),
	(613687, 130, '2014-04-01 00:17:08.000000', 'consum', 0.0215, 'lps'),
	(613688, 130, '2014-04-01 00:17:09.000000', 'consum', 0.0214, 'lps'),
	(613689, 130, '2014-04-01 00:17:10.000000', 'consum', 0.0216, 'lps'),
	(613690, 130, '2014-04-01 00:17:11.000000', 'consum', 0.0217, 'lps'),
	(613691, 130, '2014-04-01 00:17:12.000000', 'consum', 0.0213, 'lps'),
	(613692, 130, '2014-04-01 00:17:13.000000', 'consum', 0.0216, 'lps'),
	(613693, 130, '2014-04-01 00:17:14.000000', 'consum', 0.0220, 'lps'),
	(613694, 130, '2014-04-01 00:17:15.000000', 'consum', 0.0218, 'lps'),
	(613695, 130, '2014-04-01 00:17:16.000000', 'consum', 0.0221, 'lps'),
	(613696, 130, '2014-04-01 00:17:17.000000', 'consum', 0.0217, 'lps'),
	(613697, 130, '2014-04-01 00:17:18.000000', 'consum', 0.0213, 'lps'),
	(613698, 130, '2014-04-01 00:17:19.000000', 'consum', 0.0216, 'lps'),
	(613699, 130, '2014-04-01 00:17:20.000000', 'consum', 0.0220, 'lps'),
	(613700, 130, '2014-04-01 00:17:21.000000', 'consum', 0.0219, 'lps'),
	(613701, 130, '2014-04-01 00:17:22.000000', 'consum', 0.0213, 'lps'),
	(613702, 130, '2014-04-01 00:17:23.000000', 'consum', 0.0221, 'lps'),
	(613703, 130, '2014-04-01 00:17:24.000000', 'consum', 0.0210, 'lps'),
	(613704, 130, '2014-04-01 00:17:25.000000', 'consum', 0.0214, 'lps'),
	(613705, 130, '2014-04-01 00:17:26.000000', 'consum', 0.0217, 'lps'),
	(613706, 130, '2014-04-01 00:17:27.000000', 'consum', 0.0212, 'lps'),
	(613707, 130, '2014-04-01 00:17:28.000000', 'consum', 0.0211, 'lps'),
	(613708, 130, '2014-04-01 00:17:29.000000', 'consum', 0.0210, 'lps'),
	(613709, 130, '2014-04-01 00:17:30.000000', 'consum', 0.0217, 'lps'),
	(613710, 130, '2014-04-01 00:17:31.000000', 'consum', 0.0212, 'lps'),
	(613711, 130, '2014-04-01 00:17:32.000000', 'consum', 0.0221, 'lps'),
	(613712, 130, '2014-04-01 00:17:33.000000', 'consum', 0.0211, 'lps'),
	(613713, 130, '2014-04-01 00:17:34.000000', 'consum', 0.0218, 'lps'),
	(613714, 130, '2014-04-01 00:17:35.000000', 'consum', 0.0212, 'lps'),
	(613715, 130, '2014-04-01 00:17:36.000000', 'consum', 0.0221, 'lps'),
	(613716, 130, '2014-04-01 00:17:37.000000', 'consum', 0.0211, 'lps'),
	(613717, 130, '2014-04-01 00:17:38.000000', 'consum', 0.0219, 'lps'),
	(613718, 130, '2014-04-01 00:17:39.000000', 'consum', 0.0217, 'lps'),
	(613719, 130, '2014-04-01 00:17:40.000000', 'consum', 0.0219, 'lps'),
	(613720, 130, '2014-04-01 00:17:41.000000', 'consum', 0.0220, 'lps'),
	(613721, 130, '2014-04-01 00:17:42.000000', 'consum', 0.0210, 'lps'),
	(613722, 130, '2014-04-01 00:17:43.000000', 'consum', 0.0218, 'lps'),
	(613723, 130, '2014-04-01 00:17:44.000000', 'consum', 0.0213, 'lps'),
	(613724, 130, '2014-04-01 00:17:45.000000', 'consum', 0.0215, 'lps'),
	(613725, 130, '2014-04-01 00:17:46.000000', 'consum', 0.0216, 'lps'),
	(613726, 130, '2014-04-01 00:17:47.000000', 'consum', 0.0212, 'lps'),
	(613727, 130, '2014-04-01 00:17:48.000000', 'consum', 0.0213, 'lps'),
	(613728, 130, '2014-04-01 00:17:49.000000', 'consum', 0.0218, 'lps'),
	(613729, 130, '2014-04-01 00:17:50.000000', 'consum', 0.0221, 'lps'),
	(613730, 130, '2014-04-01 00:17:51.000000', 'consum', 0.0217, 'lps'),
	(613731, 130, '2014-04-01 00:17:52.000000', 'consum', 0.0212, 'lps'),
	(613732, 130, '2014-04-01 00:17:53.000000', 'consum', 0.0211, 'lps'),
	(613733, 130, '2014-04-01 00:17:54.000000', 'consum', 0.0220, 'lps'),
	(613734, 130, '2014-04-01 00:17:55.000000', 'consum', 0.0211, 'lps'),
	(613735, 130, '2014-04-01 00:17:56.000000', 'consum', 0.0210, 'lps'),
	(613736, 130, '2014-04-01 00:17:57.000000', 'consum', 0.0217, 'lps'),
	(613737, 130, '2014-04-01 00:17:58.000000', 'consum', 0.0213, 'lps'),
	(613738, 130, '2014-04-01 00:17:59.000000', 'consum', 0.0213, 'lps'),
	(613739, 130, '2014-04-01 00:18:00.000000', 'consum', 0.0218, 'lps'),
	(613740, 130, '2014-04-01 00:18:01.000000', 'consum', 0.0218, 'lps'),
	(613741, 130, '2014-04-01 00:18:02.000000', 'consum', 0.0216, 'lps'),
	(613742, 130, '2014-04-01 00:18:03.000000', 'consum', 0.0216, 'lps'),
	(613743, 130, '2014-04-01 00:18:04.000000', 'consum', 0.0211, 'lps'),
	(613744, 130, '2014-04-01 00:18:05.000000', 'consum', 0.0220, 'lps'),
	(613745, 130, '2014-04-01 00:18:06.000000', 'consum', 0.0212, 'lps'),
	(613746, 130, '2014-04-01 00:18:07.000000', 'consum', 0.0213, 'lps'),
	(613747, 130, '2014-04-01 00:18:08.000000', 'consum', 0.0219, 'lps'),
	(613748, 130, '2014-04-01 00:18:09.000000', 'consum', 0.0213, 'lps'),
	(613749, 130, '2014-04-01 00:18:10.000000', 'consum', 0.0220, 'lps'),
	(613750, 130, '2014-04-01 00:18:11.000000', 'consum', 0.0215, 'lps'),
	(613751, 130, '2014-04-01 00:18:12.000000', 'consum', 0.0219, 'lps'),
	(613752, 130, '2014-04-01 00:18:13.000000', 'consum', 0.0215, 'lps'),
	(613753, 130, '2014-04-01 00:18:14.000000', 'consum', 0.0221, 'lps'),
	(613754, 130, '2014-04-01 00:18:15.000000', 'consum', 0.0214, 'lps'),
	(613755, 130, '2014-04-01 00:18:16.000000', 'consum', 0.0211, 'lps'),
	(613756, 130, '2014-04-01 00:18:17.000000', 'consum', 0.0215, 'lps'),
	(613757, 130, '2014-04-01 00:18:18.000000', 'consum', 0.0210, 'lps'),
	(613758, 130, '2014-04-01 00:18:19.000000', 'consum', 0.0218, 'lps'),
	(613759, 130, '2014-04-01 00:18:20.000000', 'consum', 0.0213, 'lps'),
	(613760, 130, '2014-04-01 00:18:21.000000', 'consum', 0.0215, 'lps'),
	(613761, 130, '2014-04-01 00:18:22.000000', 'consum', 0.0216, 'lps'),
	(613762, 130, '2014-04-01 00:18:23.000000', 'consum', 0.0213, 'lps'),
	(613763, 130, '2014-04-01 00:18:24.000000', 'consum', 0.0219, 'lps'),
	(613764, 130, '2014-04-01 00:18:25.000000', 'consum', 0.0212, 'lps'),
	(613765, 130, '2014-04-01 00:18:26.000000', 'consum', 0.0217, 'lps'),
	(613766, 130, '2014-04-01 00:18:27.000000', 'consum', 0.0216, 'lps'),
	(613767, 130, '2014-04-01 00:18:28.000000', 'consum', 0.0220, 'lps'),
	(613768, 130, '2014-04-01 00:18:29.000000', 'consum', 0.0219, 'lps'),
	(613769, 130, '2014-04-01 00:18:30.000000', 'consum', 0.0214, 'lps'),
	(613770, 130, '2014-04-01 00:18:31.000000', 'consum', 0.0213, 'lps'),
	(613771, 130, '2014-04-01 00:18:32.000000', 'consum', 0.0215, 'lps'),
	(613772, 130, '2014-04-01 00:18:33.000000', 'consum', 0.0214, 'lps'),
	(613773, 130, '2014-04-01 00:18:34.000000', 'consum', 0.0216, 'lps'),
	(613774, 130, '2014-04-01 00:18:35.000000', 'consum', 0.0216, 'lps'),
	(613775, 130, '2014-04-01 00:18:36.000000', 'consum', 0.0221, 'lps'),
	(613776, 130, '2014-04-01 00:18:37.000000', 'consum', 0.0211, 'lps'),
	(613777, 130, '2014-04-01 00:18:38.000000', 'consum', 0.0219, 'lps'),
	(613778, 130, '2014-04-01 00:18:39.000000', 'consum', 0.0217, 'lps'),
	(613779, 130, '2014-04-01 00:18:40.000000', 'consum', 0.0220, 'lps'),
	(613780, 130, '2014-04-01 00:18:41.000000', 'consum', 0.0212, 'lps'),
	(613781, 130, '2014-04-01 00:18:42.000000', 'consum', 0.0218, 'lps'),
	(613782, 130, '2014-04-01 00:18:43.000000', 'consum', 0.0218, 'lps'),
	(613783, 130, '2014-04-01 00:18:44.000000', 'consum', 0.0214, 'lps'),
	(613784, 130, '2014-04-01 00:18:45.000000', 'consum', 0.0210, 'lps'),
	(613785, 130, '2014-04-01 00:18:46.000000', 'consum', 0.0219, 'lps'),
	(613786, 130, '2014-04-01 00:18:47.000000', 'consum', 0.0220, 'lps'),
	(613787, 130, '2014-04-01 00:18:48.000000', 'consum', 0.0211, 'lps'),
	(613788, 130, '2014-04-01 00:18:49.000000', 'consum', 0.0210, 'lps'),
	(613789, 130, '2014-04-01 00:18:50.000000', 'consum', 0.0218, 'lps'),
	(613790, 130, '2014-04-01 00:18:51.000000', 'consum', 0.0215, 'lps'),
	(613791, 130, '2014-04-01 00:18:52.000000', 'consum', 0.0211, 'lps'),
	(613792, 130, '2014-04-01 00:18:53.000000', 'consum', 0.0211, 'lps'),
	(613793, 130, '2014-04-01 00:18:54.000000', 'consum', 0.0214, 'lps'),
	(613794, 130, '2014-04-01 00:18:55.000000', 'consum', 0.0216, 'lps'),
	(613795, 130, '2014-04-01 00:18:56.000000', 'consum', 0.0214, 'lps'),
	(613796, 130, '2014-04-01 00:18:57.000000', 'consum', 0.0214, 'lps'),
	(613797, 130, '2014-04-01 00:18:58.000000', 'consum', 0.0220, 'lps'),
	(613798, 130, '2014-04-01 00:18:59.000000', 'consum', 0.0212, 'lps'),
	(613799, 130, '2014-04-01 00:19:00.000000', 'consum', 0.0216, 'lps'),
	(613800, 130, '2014-04-01 00:19:01.000000', 'consum', 0.0220, 'lps'),
	(613801, 130, '2014-04-01 00:19:02.000000', 'consum', 0.0219, 'lps'),
	(613802, 130, '2014-04-01 00:19:03.000000', 'consum', 0.0215, 'lps'),
	(613803, 130, '2014-04-01 00:19:04.000000', 'consum', 0.0219, 'lps'),
	(613804, 130, '2014-04-01 00:19:05.000000', 'consum', 0.0217, 'lps'),
	(613805, 130, '2014-04-01 00:19:06.000000', 'consum', 0.0220, 'lps'),
	(613806, 130, '2014-04-01 00:19:07.000000', 'consum', 0.0213, 'lps'),
	(613807, 130, '2014-04-01 00:19:08.000000', 'consum', 0.0220, 'lps'),
	(613808, 130, '2014-04-01 00:19:09.000000', 'consum', 0.0214, 'lps'),
	(613809, 130, '2014-04-01 00:19:10.000000', 'consum', 0.0213, 'lps'),
	(613810, 130, '2014-04-01 00:19:11.000000', 'consum', 0.0215, 'lps'),
	(613811, 130, '2014-04-01 00:19:12.000000', 'consum', 0.0212, 'lps'),
	(613812, 130, '2014-04-01 00:19:13.000000', 'consum', 0.0218, 'lps'),
	(613813, 130, '2014-04-01 00:19:14.000000', 'consum', 0.0221, 'lps'),
	(613814, 130, '2014-04-01 00:19:15.000000', 'consum', 0.0218, 'lps'),
	(613815, 130, '2014-04-01 00:19:16.000000', 'consum', 0.0217, 'lps'),
	(613816, 130, '2014-04-01 00:19:17.000000', 'consum', 0.0211, 'lps'),
	(613817, 130, '2014-04-01 00:19:18.000000', 'consum', 0.0219, 'lps'),
	(613818, 130, '2014-04-01 00:19:19.000000', 'consum', 0.0216, 'lps'),
	(613819, 130, '2014-04-01 00:19:20.000000', 'consum', 0.0214, 'lps'),
	(613820, 130, '2014-04-01 00:19:21.000000', 'consum', 0.0214, 'lps'),
	(613821, 130, '2014-04-01 00:19:22.000000', 'consum', 0.0216, 'lps'),
	(613822, 130, '2014-04-01 00:19:23.000000', 'consum', 0.0218, 'lps'),
	(613823, 130, '2014-04-01 00:19:24.000000', 'consum', 0.0221, 'lps'),
	(613824, 130, '2014-04-01 00:19:25.000000', 'consum', 0.0215, 'lps'),
	(613825, 130, '2014-04-01 00:19:26.000000', 'consum', 0.0218, 'lps'),
	(613826, 130, '2014-04-01 00:19:27.000000', 'consum', 0.0220, 'lps'),
	(613827, 130, '2014-04-01 00:19:28.000000', 'consum', 0.0213, 'lps'),
	(613828, 130, '2014-04-01 00:19:29.000000', 'consum', 0.0220, 'lps'),
	(613829, 130, '2014-04-01 00:19:30.000000', 'consum', 0.0217, 'lps'),
	(613830, 130, '2014-04-01 00:19:31.000000', 'consum', 0.0214, 'lps'),
	(613831, 130, '2014-04-01 00:19:32.000000', 'consum', 0.0221, 'lps'),
	(613832, 130, '2014-04-01 00:19:33.000000', 'consum', 0.0220, 'lps'),
	(613833, 130, '2014-04-01 00:19:34.000000', 'consum', 0.0215, 'lps'),
	(613834, 130, '2014-04-01 00:19:35.000000', 'consum', 0.0216, 'lps'),
	(613835, 130, '2014-04-01 00:19:36.000000', 'consum', 0.0216, 'lps'),
	(613836, 130, '2014-04-01 00:19:37.000000', 'consum', 0.0220, 'lps'),
	(613837, 130, '2014-04-01 00:19:38.000000', 'consum', 0.0218, 'lps'),
	(613838, 130, '2014-04-01 00:19:39.000000', 'consum', 0.0211, 'lps'),
	(613839, 130, '2014-04-01 00:19:40.000000', 'consum', 0.0213, 'lps'),
	(613840, 130, '2014-04-01 00:19:41.000000', 'consum', 0.0211, 'lps'),
	(613841, 130, '2014-04-01 00:19:42.000000', 'consum', 0.0218, 'lps'),
	(613842, 130, '2014-04-01 00:19:43.000000', 'consum', 0.0212, 'lps'),
	(613843, 130, '2014-04-01 00:19:44.000000', 'consum', 0.0210, 'lps'),
	(613844, 130, '2014-04-01 00:19:45.000000', 'consum', 0.0217, 'lps'),
	(613845, 130, '2014-04-01 00:19:46.000000', 'consum', 0.0220, 'lps'),
	(613846, 130, '2014-04-01 00:19:47.000000', 'consum', 0.0218, 'lps'),
	(613847, 130, '2014-04-01 00:19:48.000000', 'consum', 0.0218, 'lps'),
	(613848, 130, '2014-04-01 00:19:49.000000', 'consum', 0.0214, 'lps'),
	(613849, 130, '2014-04-01 00:19:50.000000', 'consum', 0.0220, 'lps'),
	(613850, 130, '2014-04-01 00:19:51.000000', 'consum', 0.0214, 'lps'),
	(613851, 130, '2014-04-01 00:19:52.000000', 'consum', 0.0211, 'lps'),
	(613852, 130, '2014-04-01 00:19:53.000000', 'consum', 0.0215, 'lps'),
	(613853, 130, '2014-04-01 00:19:54.000000', 'consum', 0.0210, 'lps'),
	(613854, 130, '2014-04-01 00:19:55.000000', 'consum', 0.0221, 'lps'),
	(613855, 130, '2014-04-01 00:19:56.000000', 'consum', 0.0215, 'lps'),
	(613856, 130, '2014-04-01 00:19:57.000000', 'consum', 0.0216, 'lps'),
	(613857, 130, '2014-04-01 00:19:58.000000', 'consum', 0.0211, 'lps'),
	(613858, 130, '2014-04-01 00:19:59.000000', 'consum', 0.0211, 'lps'),
	(613859, 130, '2014-04-01 00:20:00.000000', 'consum', 0.0213, 'lps'),
	(613860, 130, '2014-04-01 00:20:01.000000', 'consum', 0.0211, 'lps'),
	(613861, 130, '2014-04-01 00:20:02.000000', 'consum', 0.0219, 'lps'),
	(613862, 130, '2014-04-01 00:20:03.000000', 'consum', 0.0215, 'lps'),
	(613863, 130, '2014-04-01 00:20:04.000000', 'consum', 0.0210, 'lps'),
	(613864, 130, '2014-04-01 00:20:05.000000', 'consum', 0.0220, 'lps'),
	(613865, 130, '2014-04-01 00:20:06.000000', 'consum', 0.0212, 'lps'),
	(613866, 130, '2014-04-01 00:20:07.000000', 'consum', 0.0216, 'lps'),
	(613867, 130, '2014-04-01 00:20:08.000000', 'consum', 0.0210, 'lps'),
	(613868, 130, '2014-04-01 00:20:09.000000', 'consum', 0.0214, 'lps'),
	(613869, 130, '2014-04-01 00:20:10.000000', 'consum', 0.0220, 'lps'),
	(613870, 130, '2014-04-01 00:20:11.000000', 'consum', 0.0211, 'lps'),
	(613871, 130, '2014-04-01 00:20:12.000000', 'consum', 0.0221, 'lps'),
	(613872, 130, '2014-04-01 00:20:13.000000', 'consum', 0.0213, 'lps'),
	(613873, 130, '2014-04-01 00:20:14.000000', 'consum', 0.0220, 'lps'),
	(613874, 130, '2014-04-01 00:20:15.000000', 'consum', 0.0216, 'lps'),
	(613875, 130, '2014-04-01 00:20:16.000000', 'consum', 0.0221, 'lps'),
	(613876, 130, '2014-04-01 00:20:17.000000', 'consum', 0.0213, 'lps'),
	(613877, 130, '2014-04-01 00:20:18.000000', 'consum', 0.0217, 'lps'),
	(613878, 130, '2014-04-01 00:20:19.000000', 'consum', 0.0213, 'lps'),
	(613879, 130, '2014-04-01 00:20:20.000000', 'consum', 0.0216, 'lps'),
	(613880, 130, '2014-04-01 00:20:21.000000', 'consum', 0.0219, 'lps'),
	(613881, 130, '2014-04-01 00:20:22.000000', 'consum', 0.0212, 'lps'),
	(613882, 130, '2014-04-01 00:20:23.000000', 'consum', 0.0219, 'lps'),
	(613883, 130, '2014-04-01 00:20:24.000000', 'consum', 0.0212, 'lps'),
	(613884, 130, '2014-04-01 00:20:25.000000', 'consum', 0.0218, 'lps'),
	(613885, 130, '2014-04-01 00:20:26.000000', 'consum', 0.0221, 'lps'),
	(613886, 130, '2014-04-01 00:20:27.000000', 'consum', 0.0217, 'lps'),
	(613887, 130, '2014-04-01 00:20:28.000000', 'consum', 0.0211, 'lps'),
	(613888, 130, '2014-04-01 00:20:29.000000', 'consum', 0.0219, 'lps'),
	(613889, 130, '2014-04-01 00:20:30.000000', 'consum', 0.0216, 'lps'),
	(613890, 130, '2014-04-01 00:20:31.000000', 'consum', 0.0213, 'lps'),
	(613891, 130, '2014-04-01 00:20:32.000000', 'consum', 0.0210, 'lps'),
	(613892, 130, '2014-04-01 00:20:33.000000', 'consum', 0.0212, 'lps'),
	(613893, 130, '2014-04-01 00:20:34.000000', 'consum', 0.0210, 'lps'),
	(613894, 130, '2014-04-01 00:20:35.000000', 'consum', 0.0218, 'lps'),
	(613895, 130, '2014-04-01 00:20:36.000000', 'consum', 0.0211, 'lps'),
	(613896, 130, '2014-04-01 00:20:37.000000', 'consum', 0.0219, 'lps'),
	(613897, 130, '2014-04-01 00:20:38.000000', 'consum', 0.0214, 'lps'),
	(613898, 130, '2014-04-01 00:20:39.000000', 'consum', 0.0218, 'lps'),
	(613899, 130, '2014-04-01 00:20:40.000000', 'consum', 0.0211, 'lps'),
	(613900, 130, '2014-04-01 00:20:41.000000', 'consum', 0.0218, 'lps'),
	(613901, 130, '2014-04-01 00:20:42.000000', 'consum', 0.0221, 'lps'),
	(613902, 130, '2014-04-01 00:20:43.000000', 'consum', 0.0219, 'lps'),
	(613903, 130, '2014-04-01 00:20:44.000000', 'consum', 0.0210, 'lps'),
	(613904, 130, '2014-04-01 00:20:45.000000', 'consum', 0.0221, 'lps'),
	(613905, 130, '2014-04-01 00:20:46.000000', 'consum', 0.0218, 'lps'),
	(613906, 130, '2014-04-01 00:20:47.000000', 'consum', 0.0216, 'lps'),
	(613907, 130, '2014-04-01 00:20:48.000000', 'consum', 0.0217, 'lps'),
	(613908, 130, '2014-04-01 00:20:49.000000', 'consum', 0.0214, 'lps'),
	(613909, 130, '2014-04-01 00:20:50.000000', 'consum', 0.0210, 'lps'),
	(613910, 130, '2014-04-01 00:20:51.000000', 'consum', 0.0212, 'lps'),
	(613911, 130, '2014-04-01 00:20:52.000000', 'consum', 0.0219, 'lps'),
	(613912, 130, '2014-04-01 00:20:53.000000', 'consum', 0.0214, 'lps'),
	(613913, 130, '2014-04-01 00:20:54.000000', 'consum', 0.0216, 'lps'),
	(613914, 130, '2014-04-01 00:20:55.000000', 'consum', 0.0217, 'lps'),
	(613915, 130, '2014-04-01 00:20:56.000000', 'consum', 0.0214, 'lps'),
	(613916, 130, '2014-04-01 00:20:57.000000', 'consum', 0.0211, 'lps'),
	(613917, 130, '2014-04-01 00:20:58.000000', 'consum', 0.0217, 'lps'),
	(613918, 130, '2014-04-01 00:20:59.000000', 'consum', 0.0215, 'lps'),
	(613919, 130, '2014-04-01 00:21:00.000000', 'consum', 0.0218, 'lps'),
	(613920, 130, '2014-04-01 00:21:01.000000', 'consum', 0.0210, 'lps'),
	(613921, 130, '2014-04-01 00:21:02.000000', 'consum', 0.0211, 'lps'),
	(613922, 130, '2014-04-01 00:21:03.000000', 'consum', 0.0216, 'lps'),
	(613923, 130, '2014-04-01 00:21:04.000000', 'consum', 0.0212, 'lps'),
	(613924, 130, '2014-04-01 00:21:05.000000', 'consum', 0.0214, 'lps'),
	(613925, 130, '2014-04-01 00:21:06.000000', 'consum', 0.0213, 'lps'),
	(613926, 130, '2014-04-01 00:21:07.000000', 'consum', 0.0213, 'lps'),
	(613927, 130, '2014-04-01 00:21:08.000000', 'consum', 0.0219, 'lps'),
	(613928, 130, '2014-04-01 00:21:09.000000', 'consum', 0.0220, 'lps'),
	(613929, 130, '2014-04-01 00:21:10.000000', 'consum', 0.0210, 'lps'),
	(613930, 130, '2014-04-01 00:21:11.000000', 'consum', 0.0217, 'lps'),
	(613931, 130, '2014-04-01 00:21:12.000000', 'consum', 0.0221, 'lps'),
	(613932, 130, '2014-04-01 00:21:13.000000', 'consum', 0.0221, 'lps'),
	(613933, 130, '2014-04-01 00:21:14.000000', 'consum', 0.0221, 'lps'),
	(613934, 130, '2014-04-01 00:21:15.000000', 'consum', 0.0220, 'lps'),
	(613935, 130, '2014-04-01 00:21:16.000000', 'consum', 0.0217, 'lps'),
	(613936, 130, '2014-04-01 00:21:17.000000', 'consum', 0.0214, 'lps'),
	(613937, 130, '2014-04-01 00:21:18.000000', 'consum', 0.0221, 'lps'),
	(613938, 130, '2014-04-01 00:21:19.000000', 'consum', 0.0220, 'lps'),
	(613939, 130, '2014-04-01 00:21:20.000000', 'consum', 0.0215, 'lps'),
	(613940, 130, '2014-04-01 00:21:21.000000', 'consum', 0.0217, 'lps'),
	(613941, 130, '2014-04-01 00:21:22.000000', 'consum', 0.0220, 'lps'),
	(613942, 130, '2014-04-01 00:21:23.000000', 'consum', 0.0214, 'lps'),
	(613943, 130, '2014-04-01 00:21:24.000000', 'consum', 0.0211, 'lps'),
	(613944, 130, '2014-04-01 00:21:25.000000', 'consum', 0.0216, 'lps'),
	(613945, 130, '2014-04-01 00:21:26.000000', 'consum', 0.0214, 'lps'),
	(613946, 130, '2014-04-01 00:21:27.000000', 'consum', 0.0214, 'lps'),
	(613947, 130, '2014-04-01 00:21:28.000000', 'consum', 0.0217, 'lps'),
	(613948, 130, '2014-04-01 00:21:29.000000', 'consum', 0.0210, 'lps'),
	(613949, 130, '2014-04-01 00:21:30.000000', 'consum', 0.0212, 'lps'),
	(613950, 130, '2014-04-01 00:21:31.000000', 'consum', 0.0210, 'lps'),
	(613951, 130, '2014-04-01 00:21:32.000000', 'consum', 0.0216, 'lps'),
	(613952, 130, '2014-04-01 00:21:33.000000', 'consum', 0.0217, 'lps'),
	(613953, 130, '2014-04-01 00:21:34.000000', 'consum', 0.0217, 'lps'),
	(613954, 130, '2014-04-01 00:21:35.000000', 'consum', 0.0213, 'lps'),
	(613955, 130, '2014-04-01 00:21:36.000000', 'consum', 0.0214, 'lps'),
	(613956, 130, '2014-04-01 00:21:37.000000', 'consum', 0.0211, 'lps'),
	(613957, 130, '2014-04-01 00:21:38.000000', 'consum', 0.0214, 'lps'),
	(613958, 130, '2014-04-01 00:21:39.000000', 'consum', 0.0215, 'lps'),
	(613959, 130, '2014-04-01 00:21:40.000000', 'consum', 0.0214, 'lps'),
	(613960, 130, '2014-04-01 00:21:41.000000', 'consum', 0.0214, 'lps'),
	(613961, 130, '2014-04-01 00:21:42.000000', 'consum', 0.0219, 'lps'),
	(613962, 130, '2014-04-01 00:21:43.000000', 'consum', 0.0218, 'lps'),
	(613963, 130, '2014-04-01 00:21:44.000000', 'consum', 0.0212, 'lps'),
	(613964, 130, '2014-04-01 00:21:45.000000', 'consum', 0.0221, 'lps'),
	(613965, 130, '2014-04-01 00:21:46.000000', 'consum', 0.0210, 'lps'),
	(613966, 130, '2014-04-01 00:21:47.000000', 'consum', 0.0214, 'lps'),
	(613967, 130, '2014-04-01 00:21:48.000000', 'consum', 0.0220, 'lps'),
	(613968, 130, '2014-04-01 00:21:49.000000', 'consum', 0.0214, 'lps'),
	(613969, 130, '2014-04-01 00:21:50.000000', 'consum', 0.0221, 'lps'),
	(613970, 130, '2014-04-01 00:21:51.000000', 'consum', 0.0218, 'lps'),
	(613971, 130, '2014-04-01 00:21:52.000000', 'consum', 0.0218, 'lps'),
	(613972, 130, '2014-04-01 00:21:53.000000', 'consum', 0.0213, 'lps'),
	(613973, 130, '2014-04-01 00:21:54.000000', 'consum', 0.0214, 'lps'),
	(613974, 130, '2014-04-01 00:21:55.000000', 'consum', 0.0210, 'lps'),
	(613975, 130, '2014-04-01 00:21:56.000000', 'consum', 0.0211, 'lps'),
	(613976, 130, '2014-04-01 00:21:57.000000', 'consum', 0.0216, 'lps'),
	(613977, 130, '2014-04-01 00:21:58.000000', 'consum', 0.0211, 'lps'),
	(613978, 130, '2014-04-01 00:21:59.000000', 'consum', 0.0210, 'lps'),
	(613979, 130, '2014-04-01 00:22:00.000000', 'consum', 0.0220, 'lps'),
	(613980, 130, '2014-04-01 00:22:01.000000', 'consum', 0.0212, 'lps'),
	(613981, 130, '2014-04-01 00:22:02.000000', 'consum', 0.0215, 'lps'),
	(613982, 130, '2014-04-01 00:22:03.000000', 'consum', 0.0216, 'lps'),
	(613983, 130, '2014-04-01 00:22:04.000000', 'consum', 0.0216, 'lps'),
	(613984, 130, '2014-04-01 00:22:05.000000', 'consum', 0.0210, 'lps'),
	(613985, 130, '2014-04-01 00:22:06.000000', 'consum', 0.0215, 'lps'),
	(613986, 130, '2014-04-01 00:22:07.000000', 'consum', 0.0214, 'lps'),
	(613987, 130, '2014-04-01 00:22:08.000000', 'consum', 0.0213, 'lps'),
	(613988, 130, '2014-04-01 00:22:09.000000', 'consum', 0.0216, 'lps'),
	(613989, 130, '2014-04-01 00:22:10.000000', 'consum', 0.0219, 'lps'),
	(613990, 130, '2014-04-01 00:22:11.000000', 'consum', 0.0212, 'lps'),
	(613991, 130, '2014-04-01 00:22:12.000000', 'consum', 0.0218, 'lps'),
	(613992, 130, '2014-04-01 00:22:13.000000', 'consum', 0.0220, 'lps'),
	(613993, 130, '2014-04-01 00:22:14.000000', 'consum', 0.0212, 'lps'),
	(613994, 130, '2014-04-01 00:22:15.000000', 'consum', 0.0214, 'lps'),
	(613995, 130, '2014-04-01 00:22:16.000000', 'consum', 0.0212, 'lps'),
	(613996, 130, '2014-04-01 00:22:17.000000', 'consum', 0.0211, 'lps'),
	(613997, 130, '2014-04-01 00:22:18.000000', 'consum', 0.0210, 'lps'),
	(613998, 130, '2014-04-01 00:22:19.000000', 'consum', 0.0219, 'lps'),
	(613999, 130, '2014-04-01 00:22:20.000000', 'consum', 0.0220, 'lps'),
	(614000, 130, '2014-04-01 00:22:21.000000', 'consum', 0.0210, 'lps'),
	(614001, 130, '2014-04-01 00:22:22.000000', 'consum', 0.0216, 'lps'),
	(614002, 130, '2014-04-01 00:22:23.000000', 'consum', 0.0216, 'lps'),
	(614003, 130, '2014-04-01 00:22:24.000000', 'consum', 0.0213, 'lps'),
	(614004, 130, '2014-04-01 00:22:25.000000', 'consum', 0.0217, 'lps'),
	(614005, 130, '2014-04-01 00:22:26.000000', 'consum', 0.0212, 'lps'),
	(614006, 130, '2014-04-01 00:22:27.000000', 'consum', 0.0211, 'lps'),
	(614007, 130, '2014-04-01 00:22:28.000000', 'consum', 0.0211, 'lps'),
	(614008, 130, '2014-04-01 00:22:29.000000', 'consum', 0.0213, 'lps'),
	(614009, 130, '2014-04-01 00:22:30.000000', 'consum', 0.0211, 'lps'),
	(614010, 130, '2014-04-01 00:22:31.000000', 'consum', 0.0219, 'lps'),
	(614011, 130, '2014-04-01 00:22:32.000000', 'consum', 0.0218, 'lps'),
	(614012, 130, '2014-04-01 00:22:33.000000', 'consum', 0.0220, 'lps'),
	(614013, 130, '2014-04-01 00:22:34.000000', 'consum', 0.0212, 'lps'),
	(614014, 130, '2014-04-01 00:22:35.000000', 'consum', 0.0218, 'lps'),
	(614015, 130, '2014-04-01 00:22:36.000000', 'consum', 0.0217, 'lps'),
	(614016, 130, '2014-04-01 00:22:37.000000', 'consum', 0.0211, 'lps'),
	(614017, 130, '2014-04-01 00:22:38.000000', 'consum', 0.0218, 'lps'),
	(614018, 130, '2014-04-01 00:22:39.000000', 'consum', 0.0211, 'lps'),
	(614019, 130, '2014-04-01 00:22:40.000000', 'consum', 0.0217, 'lps'),
	(614020, 130, '2014-04-01 00:22:41.000000', 'consum', 0.0216, 'lps'),
	(614021, 130, '2014-04-01 00:22:42.000000', 'consum', 0.0221, 'lps'),
	(614022, 130, '2014-04-01 00:22:43.000000', 'consum', 0.0210, 'lps'),
	(614023, 130, '2014-04-01 00:22:44.000000', 'consum', 0.0215, 'lps'),
	(614024, 130, '2014-04-01 00:22:45.000000', 'consum', 0.0210, 'lps'),
	(614025, 130, '2014-04-01 00:22:46.000000', 'consum', 0.0210, 'lps'),
	(614026, 130, '2014-04-01 00:22:47.000000', 'consum', 0.0220, 'lps'),
	(614027, 130, '2014-04-01 00:22:48.000000', 'consum', 0.0214, 'lps'),
	(614028, 130, '2014-04-01 00:22:49.000000', 'consum', 0.0210, 'lps'),
	(614029, 130, '2014-04-01 00:22:50.000000', 'consum', 0.0212, 'lps'),
	(614030, 130, '2014-04-01 00:22:51.000000', 'consum', 0.0220, 'lps'),
	(614031, 130, '2014-04-01 00:22:52.000000', 'consum', 0.0219, 'lps'),
	(614032, 130, '2014-04-01 00:22:53.000000', 'consum', 0.0215, 'lps'),
	(614033, 130, '2014-04-01 00:22:54.000000', 'consum', 0.0219, 'lps'),
	(614034, 130, '2014-04-01 00:22:55.000000', 'consum', 0.0217, 'lps'),
	(614035, 130, '2014-04-01 00:22:56.000000', 'consum', 0.0217, 'lps'),
	(614036, 130, '2014-04-01 00:22:57.000000', 'consum', 0.0214, 'lps'),
	(614037, 130, '2014-04-01 00:22:58.000000', 'consum', 0.0220, 'lps'),
	(614038, 130, '2014-04-01 00:22:59.000000', 'consum', 0.0213, 'lps'),
	(614039, 130, '2014-04-01 00:23:00.000000', 'consum', 0.0221, 'lps'),
	(614040, 130, '2014-04-01 00:23:01.000000', 'consum', 0.0219, 'lps'),
	(614041, 130, '2014-04-01 00:23:02.000000', 'consum', 0.0212, 'lps'),
	(614042, 130, '2014-04-01 00:23:03.000000', 'consum', 0.0216, 'lps'),
	(614043, 130, '2014-04-01 00:23:04.000000', 'consum', 0.0221, 'lps'),
	(614044, 130, '2014-04-01 00:23:05.000000', 'consum', 0.0214, 'lps'),
	(614045, 130, '2014-04-01 00:23:06.000000', 'consum', 0.0211, 'lps'),
	(614046, 130, '2014-04-01 00:23:07.000000', 'consum', 0.0213, 'lps'),
	(614047, 130, '2014-04-01 00:23:08.000000', 'consum', 0.0213, 'lps'),
	(614048, 130, '2014-04-01 00:23:09.000000', 'consum', 0.0213, 'lps'),
	(614049, 130, '2014-04-01 00:23:10.000000', 'consum', 0.0218, 'lps'),
	(614050, 130, '2014-04-01 00:23:11.000000', 'consum', 0.0219, 'lps'),
	(614051, 130, '2014-04-01 00:23:12.000000', 'consum', 0.0218, 'lps'),
	(614052, 130, '2014-04-01 00:23:13.000000', 'consum', 0.0212, 'lps'),
	(614053, 130, '2014-04-01 00:23:14.000000', 'consum', 0.0219, 'lps'),
	(614054, 130, '2014-04-01 00:23:15.000000', 'consum', 0.0214, 'lps'),
	(614055, 130, '2014-04-01 00:23:16.000000', 'consum', 0.0216, 'lps'),
	(614056, 130, '2014-04-01 00:23:17.000000', 'consum', 0.0217, 'lps'),
	(614057, 130, '2014-04-01 00:23:18.000000', 'consum', 0.0213, 'lps'),
	(614058, 130, '2014-04-01 00:23:19.000000', 'consum', 0.0218, 'lps'),
	(614059, 130, '2014-04-01 00:23:20.000000', 'consum', 0.0218, 'lps'),
	(614060, 130, '2014-04-01 00:23:21.000000', 'consum', 0.0212, 'lps'),
	(614061, 130, '2014-04-01 00:23:22.000000', 'consum', 0.0211, 'lps'),
	(614062, 130, '2014-04-01 00:23:23.000000', 'consum', 0.0220, 'lps'),
	(614063, 130, '2014-04-01 00:23:24.000000', 'consum', 0.0210, 'lps'),
	(614064, 130, '2014-04-01 00:23:25.000000', 'consum', 0.0219, 'lps'),
	(614065, 130, '2014-04-01 00:23:26.000000', 'consum', 0.0216, 'lps'),
	(614066, 130, '2014-04-01 00:23:27.000000', 'consum', 0.0216, 'lps'),
	(614067, 130, '2014-04-01 00:23:28.000000', 'consum', 0.0220, 'lps'),
	(614068, 130, '2014-04-01 00:23:29.000000', 'consum', 0.0218, 'lps'),
	(614069, 130, '2014-04-01 00:23:30.000000', 'consum', 0.0220, 'lps'),
	(614070, 130, '2014-04-01 00:23:31.000000', 'consum', 0.0212, 'lps'),
	(614071, 130, '2014-04-01 00:23:32.000000', 'consum', 0.0214, 'lps'),
	(614072, 130, '2014-04-01 00:23:33.000000', 'consum', 0.0215, 'lps'),
	(614073, 130, '2014-04-01 00:23:34.000000', 'consum', 0.0212, 'lps'),
	(614074, 130, '2014-04-01 00:23:35.000000', 'consum', 0.0217, 'lps'),
	(614075, 130, '2014-04-01 00:23:36.000000', 'consum', 0.0217, 'lps'),
	(614076, 130, '2014-04-01 00:23:37.000000', 'consum', 0.0210, 'lps'),
	(614077, 130, '2014-04-01 00:23:38.000000', 'consum', 0.0216, 'lps'),
	(614078, 130, '2014-04-01 00:23:39.000000', 'consum', 0.0216, 'lps'),
	(614079, 130, '2014-04-01 00:23:40.000000', 'consum', 0.0221, 'lps'),
	(614080, 130, '2014-04-01 00:23:41.000000', 'consum', 0.0211, 'lps'),
	(614081, 130, '2014-04-01 00:23:42.000000', 'consum', 0.0218, 'lps'),
	(614082, 130, '2014-04-01 00:23:43.000000', 'consum', 0.0210, 'lps'),
	(614083, 130, '2014-04-01 00:23:44.000000', 'consum', 0.0214, 'lps'),
	(614084, 130, '2014-04-01 00:23:45.000000', 'consum', 0.0216, 'lps'),
	(614085, 130, '2014-04-01 00:23:46.000000', 'consum', 0.0216, 'lps'),
	(614086, 130, '2014-04-01 00:23:47.000000', 'consum', 0.0212, 'lps'),
	(614087, 130, '2014-04-01 00:23:48.000000', 'consum', 0.0216, 'lps'),
	(614088, 130, '2014-04-01 00:23:49.000000', 'consum', 0.0210, 'lps'),
	(614089, 130, '2014-04-01 00:23:50.000000', 'consum', 0.0214, 'lps'),
	(614090, 130, '2014-04-01 00:23:51.000000', 'consum', 0.0221, 'lps'),
	(614091, 130, '2014-04-01 00:23:52.000000', 'consum', 0.0216, 'lps'),
	(614092, 130, '2014-04-01 00:23:53.000000', 'consum', 0.0219, 'lps'),
	(614093, 130, '2014-04-01 00:23:54.000000', 'consum', 0.0215, 'lps'),
	(614094, 130, '2014-04-01 00:23:55.000000', 'consum', 0.0221, 'lps'),
	(614095, 130, '2014-04-01 00:23:56.000000', 'consum', 0.0215, 'lps'),
	(614096, 130, '2014-04-01 00:23:57.000000', 'consum', 0.0212, 'lps'),
	(614097, 130, '2014-04-01 00:23:58.000000', 'consum', 0.0217, 'lps'),
	(614098, 130, '2014-04-01 00:23:59.000000', 'consum', 0.0218, 'lps'),
	(614099, 130, '2014-04-01 00:24:00.000000', 'consum', 0.0215, 'lps'),
	(614100, 130, '2014-04-01 00:24:01.000000', 'consum', 0.0211, 'lps'),
	(614101, 130, '2014-04-01 00:24:02.000000', 'consum', 0.0214, 'lps'),
	(614102, 130, '2014-04-01 00:24:03.000000', 'consum', 0.0217, 'lps'),
	(614103, 130, '2014-04-01 00:24:04.000000', 'consum', 0.0221, 'lps'),
	(614104, 130, '2014-04-01 00:24:05.000000', 'consum', 0.0220, 'lps'),
	(614105, 130, '2014-04-01 00:24:06.000000', 'consum', 0.0214, 'lps'),
	(614106, 130, '2014-04-01 00:24:07.000000', 'consum', 0.0213, 'lps'),
	(614107, 130, '2014-04-01 00:24:08.000000', 'consum', 0.0216, 'lps'),
	(614108, 130, '2014-04-01 00:24:09.000000', 'consum', 0.0217, 'lps'),
	(614109, 130, '2014-04-01 00:24:10.000000', 'consum', 0.0217, 'lps'),
	(614110, 130, '2014-04-01 00:24:11.000000', 'consum', 0.0213, 'lps'),
	(614111, 130, '2014-04-01 00:24:12.000000', 'consum', 0.0215, 'lps'),
	(614112, 130, '2014-04-01 00:24:13.000000', 'consum', 0.0216, 'lps'),
	(614113, 130, '2014-04-01 00:24:14.000000', 'consum', 0.0212, 'lps'),
	(614114, 130, '2014-04-01 00:24:15.000000', 'consum', 0.0217, 'lps'),
	(614115, 130, '2014-04-01 00:24:16.000000', 'consum', 0.0215, 'lps'),
	(614116, 130, '2014-04-01 00:24:17.000000', 'consum', 0.0213, 'lps'),
	(614117, 130, '2014-04-01 00:24:18.000000', 'consum', 0.0210, 'lps'),
	(614118, 130, '2014-04-01 00:24:19.000000', 'consum', 0.0215, 'lps'),
	(614119, 130, '2014-04-01 00:24:20.000000', 'consum', 0.0213, 'lps'),
	(614120, 130, '2014-04-01 00:24:21.000000', 'consum', 0.0221, 'lps'),
	(614121, 130, '2014-04-01 00:24:22.000000', 'consum', 0.0220, 'lps'),
	(614122, 130, '2014-04-01 00:24:23.000000', 'consum', 0.0216, 'lps'),
	(614123, 130, '2014-04-01 00:24:24.000000', 'consum', 0.0210, 'lps'),
	(614124, 130, '2014-04-01 00:24:25.000000', 'consum', 0.0215, 'lps'),
	(614125, 130, '2014-04-01 00:24:26.000000', 'consum', 0.0214, 'lps'),
	(614126, 130, '2014-04-01 00:24:27.000000', 'consum', 0.0215, 'lps'),
	(614127, 130, '2014-04-01 00:24:28.000000', 'consum', 0.0213, 'lps'),
	(614128, 130, '2014-04-01 00:24:29.000000', 'consum', 0.0219, 'lps'),
	(614129, 130, '2014-04-01 00:24:30.000000', 'consum', 0.0214, 'lps'),
	(614130, 130, '2014-04-01 00:24:31.000000', 'consum', 0.0213, 'lps'),
	(614131, 130, '2014-04-01 00:24:32.000000', 'consum', 0.0215, 'lps'),
	(614132, 130, '2014-04-01 00:24:33.000000', 'consum', 0.0214, 'lps'),
	(614133, 130, '2014-04-01 00:24:34.000000', 'consum', 0.0217, 'lps'),
	(614134, 130, '2014-04-01 00:24:35.000000', 'consum', 0.0221, 'lps'),
	(614135, 130, '2014-04-01 00:24:36.000000', 'consum', 0.0221, 'lps'),
	(614136, 130, '2014-04-01 00:24:37.000000', 'consum', 0.0218, 'lps'),
	(614137, 130, '2014-04-01 00:24:38.000000', 'consum', 0.0218, 'lps'),
	(614138, 130, '2014-04-01 00:24:39.000000', 'consum', 0.0215, 'lps'),
	(614139, 130, '2014-04-01 00:24:40.000000', 'consum', 0.0210, 'lps'),
	(614140, 130, '2014-04-01 00:24:41.000000', 'consum', 0.0221, 'lps'),
	(614141, 130, '2014-04-01 00:24:42.000000', 'consum', 0.0219, 'lps'),
	(614142, 130, '2014-04-01 00:24:43.000000', 'consum', 0.0220, 'lps'),
	(614143, 130, '2014-04-01 00:24:44.000000', 'consum', 0.0220, 'lps'),
	(614144, 130, '2014-04-01 00:24:45.000000', 'consum', 0.0221, 'lps'),
	(614145, 130, '2014-04-01 00:24:46.000000', 'consum', 0.0212, 'lps'),
	(614146, 130, '2014-04-01 00:24:47.000000', 'consum', 0.0211, 'lps'),
	(614147, 130, '2014-04-01 00:24:48.000000', 'consum', 0.0220, 'lps'),
	(614148, 130, '2014-04-01 00:24:49.000000', 'consum', 0.0211, 'lps'),
	(614149, 130, '2014-04-01 00:24:50.000000', 'consum', 0.0221, 'lps'),
	(614150, 130, '2014-04-01 00:24:51.000000', 'consum', 0.0215, 'lps'),
	(614151, 130, '2014-04-01 00:24:52.000000', 'consum', 0.0213, 'lps'),
	(614152, 130, '2014-04-01 00:24:53.000000', 'consum', 0.0212, 'lps'),
	(614153, 130, '2014-04-01 00:24:54.000000', 'consum', 0.0211, 'lps'),
	(614154, 130, '2014-04-01 00:24:55.000000', 'consum', 0.0221, 'lps'),
	(614155, 130, '2014-04-01 00:24:56.000000', 'consum', 0.0215, 'lps'),
	(614156, 130, '2014-04-01 00:24:57.000000', 'consum', 0.0215, 'lps'),
	(614157, 130, '2014-04-01 00:24:58.000000', 'consum', 0.0219, 'lps'),
	(614158, 130, '2014-04-01 00:24:59.000000', 'consum', 0.0218, 'lps'),
	(614159, 130, '2014-04-01 00:25:00.000000', 'consum', 0.0210, 'lps'),
	(614160, 130, '2014-04-01 00:25:01.000000', 'consum', 0.0211, 'lps'),
	(614161, 130, '2014-04-01 00:25:02.000000', 'consum', 0.0215, 'lps'),
	(614162, 130, '2014-04-01 00:25:03.000000', 'consum', 0.0210, 'lps'),
	(614163, 130, '2014-04-01 00:25:04.000000', 'consum', 0.0217, 'lps'),
	(614164, 130, '2014-04-01 00:25:05.000000', 'consum', 0.0211, 'lps'),
	(614165, 130, '2014-04-01 00:25:06.000000', 'consum', 0.0217, 'lps'),
	(614166, 130, '2014-04-01 00:25:07.000000', 'consum', 0.0217, 'lps'),
	(614167, 130, '2014-04-01 00:25:08.000000', 'consum', 0.0216, 'lps'),
	(614168, 130, '2014-04-01 00:25:09.000000', 'consum', 0.0217, 'lps'),
	(614169, 130, '2014-04-01 00:25:10.000000', 'consum', 0.0218, 'lps'),
	(614170, 130, '2014-04-01 00:25:11.000000', 'consum', 0.0218, 'lps'),
	(614171, 130, '2014-04-01 00:25:12.000000', 'consum', 0.0215, 'lps'),
	(614172, 130, '2014-04-01 00:25:13.000000', 'consum', 0.0212, 'lps'),
	(614173, 130, '2014-04-01 00:25:14.000000', 'consum', 0.0216, 'lps'),
	(614174, 130, '2014-04-01 00:25:15.000000', 'consum', 0.0212, 'lps'),
	(614175, 130, '2014-04-01 00:25:16.000000', 'consum', 0.0213, 'lps'),
	(614176, 130, '2014-04-01 00:25:17.000000', 'consum', 0.0221, 'lps'),
	(614177, 130, '2014-04-01 00:25:18.000000', 'consum', 0.0220, 'lps'),
	(614178, 130, '2014-04-01 00:25:19.000000', 'consum', 0.0216, 'lps'),
	(614179, 130, '2014-04-01 00:25:20.000000', 'consum', 0.0220, 'lps'),
	(614180, 130, '2014-04-01 00:25:21.000000', 'consum', 0.0221, 'lps'),
	(614181, 130, '2014-04-01 00:25:22.000000', 'consum', 0.0212, 'lps'),
	(614182, 130, '2014-04-01 00:25:23.000000', 'consum', 0.0210, 'lps'),
	(614183, 130, '2014-04-01 00:25:24.000000', 'consum', 0.0215, 'lps'),
	(614184, 130, '2014-04-01 00:25:25.000000', 'consum', 0.0212, 'lps'),
	(614185, 130, '2014-04-01 00:25:26.000000', 'consum', 0.0218, 'lps'),
	(614186, 130, '2014-04-01 00:25:27.000000', 'consum', 0.0220, 'lps'),
	(614187, 130, '2014-04-01 00:25:28.000000', 'consum', 0.0212, 'lps'),
	(614188, 130, '2014-04-01 00:25:29.000000', 'consum', 0.0214, 'lps'),
	(614189, 130, '2014-04-01 00:25:30.000000', 'consum', 0.0215, 'lps'),
	(614190, 130, '2014-04-01 00:25:31.000000', 'consum', 0.0221, 'lps'),
	(614191, 130, '2014-04-01 00:25:32.000000', 'consum', 0.0213, 'lps'),
	(614192, 130, '2014-04-01 00:25:33.000000', 'consum', 0.0220, 'lps'),
	(614193, 130, '2014-04-01 00:25:34.000000', 'consum', 0.0214, 'lps'),
	(614194, 130, '2014-04-01 00:25:35.000000', 'consum', 0.0212, 'lps'),
	(614195, 130, '2014-04-01 00:25:36.000000', 'consum', 0.0220, 'lps'),
	(614196, 130, '2014-04-01 00:25:37.000000', 'consum', 0.0219, 'lps'),
	(614197, 130, '2014-04-01 00:25:38.000000', 'consum', 0.0214, 'lps'),
	(614198, 130, '2014-04-01 00:25:39.000000', 'consum', 0.0214, 'lps'),
	(614199, 130, '2014-04-01 00:25:40.000000', 'consum', 0.0220, 'lps'),
	(614200, 130, '2014-04-01 00:25:41.000000', 'consum', 0.0214, 'lps'),
	(614201, 130, '2014-04-01 00:25:42.000000', 'consum', 0.0212, 'lps'),
	(614202, 130, '2014-04-01 00:25:43.000000', 'consum', 0.0219, 'lps'),
	(614203, 130, '2014-04-01 00:25:44.000000', 'consum', 0.0214, 'lps'),
	(614204, 130, '2014-04-01 00:25:45.000000', 'consum', 0.0217, 'lps'),
	(614205, 130, '2014-04-01 00:25:46.000000', 'consum', 0.0220, 'lps'),
	(614206, 130, '2014-04-01 00:25:47.000000', 'consum', 0.0214, 'lps'),
	(614207, 130, '2014-04-01 00:25:48.000000', 'consum', 0.0214, 'lps'),
	(614208, 130, '2014-04-01 00:25:49.000000', 'consum', 0.0220, 'lps'),
	(614209, 130, '2014-04-01 00:25:50.000000', 'consum', 0.0212, 'lps'),
	(614210, 130, '2014-04-01 00:25:51.000000', 'consum', 0.0214, 'lps'),
	(614211, 130, '2014-04-01 00:25:52.000000', 'consum', 0.0212, 'lps'),
	(614212, 130, '2014-04-01 00:25:53.000000', 'consum', 0.0211, 'lps'),
	(614213, 130, '2014-04-01 00:25:54.000000', 'consum', 0.0218, 'lps'),
	(614214, 130, '2014-04-01 00:25:55.000000', 'consum', 0.0215, 'lps'),
	(614215, 130, '2014-04-01 00:25:56.000000', 'consum', 0.0210, 'lps'),
	(614216, 130, '2014-04-01 00:25:57.000000', 'consum', 0.0218, 'lps'),
	(614217, 130, '2014-04-01 00:25:58.000000', 'consum', 0.0216, 'lps'),
	(614218, 130, '2014-04-01 00:25:59.000000', 'consum', 0.0215, 'lps'),
	(614219, 130, '2014-04-01 00:26:00.000000', 'consum', 0.0219, 'lps'),
	(614220, 130, '2014-04-01 00:26:01.000000', 'consum', 0.0215, 'lps'),
	(614221, 130, '2014-04-01 00:26:02.000000', 'consum', 0.0220, 'lps'),
	(614222, 130, '2014-04-01 00:26:03.000000', 'consum', 0.0212, 'lps'),
	(614223, 130, '2014-04-01 00:26:04.000000', 'consum', 0.0213, 'lps'),
	(614224, 130, '2014-04-01 00:26:05.000000', 'consum', 0.0210, 'lps'),
	(614225, 130, '2014-04-01 00:26:06.000000', 'consum', 0.0210, 'lps'),
	(614226, 130, '2014-04-01 00:26:07.000000', 'consum', 0.0213, 'lps'),
	(614227, 130, '2014-04-01 00:26:08.000000', 'consum', 0.0212, 'lps'),
	(614228, 130, '2014-04-01 00:26:09.000000', 'consum', 0.0211, 'lps'),
	(614229, 130, '2014-04-01 00:26:10.000000', 'consum', 0.0210, 'lps'),
	(614230, 130, '2014-04-01 00:26:11.000000', 'consum', 0.0220, 'lps'),
	(614231, 130, '2014-04-01 00:26:12.000000', 'consum', 0.0211, 'lps'),
	(614232, 130, '2014-04-01 00:26:13.000000', 'consum', 0.0210, 'lps'),
	(614233, 130, '2014-04-01 00:26:14.000000', 'consum', 0.0220, 'lps'),
	(614234, 130, '2014-04-01 00:26:15.000000', 'consum', 0.0212, 'lps'),
	(614235, 130, '2014-04-01 00:26:16.000000', 'consum', 0.0216, 'lps'),
	(614236, 130, '2014-04-01 00:26:17.000000', 'consum', 0.0210, 'lps'),
	(614237, 130, '2014-04-01 00:26:18.000000', 'consum', 0.0215, 'lps'),
	(614238, 130, '2014-04-01 00:26:19.000000', 'consum', 0.0213, 'lps'),
	(614239, 130, '2014-04-01 00:26:20.000000', 'consum', 0.0221, 'lps'),
	(614240, 130, '2014-04-01 00:26:21.000000', 'consum', 0.0210, 'lps'),
	(614241, 130, '2014-04-01 00:26:22.000000', 'consum', 0.0215, 'lps'),
	(614242, 130, '2014-04-01 00:26:23.000000', 'consum', 0.0220, 'lps'),
	(614243, 130, '2014-04-01 00:26:24.000000', 'consum', 0.0212, 'lps'),
	(614244, 130, '2014-04-01 00:26:25.000000', 'consum', 0.0213, 'lps'),
	(614245, 130, '2014-04-01 00:26:26.000000', 'consum', 0.0219, 'lps'),
	(614246, 130, '2014-04-01 00:26:27.000000', 'consum', 0.0211, 'lps'),
	(614247, 130, '2014-04-01 00:26:28.000000', 'consum', 0.0212, 'lps'),
	(614248, 130, '2014-04-01 00:26:29.000000', 'consum', 0.0220, 'lps'),
	(614249, 130, '2014-04-01 00:26:30.000000', 'consum', 0.0216, 'lps'),
	(614250, 130, '2014-04-01 00:26:31.000000', 'consum', 0.0212, 'lps'),
	(614251, 130, '2014-04-01 00:26:32.000000', 'consum', 0.0213, 'lps'),
	(614252, 130, '2014-04-01 00:26:33.000000', 'consum', 0.0221, 'lps'),
	(614253, 130, '2014-04-01 00:26:34.000000', 'consum', 0.0210, 'lps'),
	(614254, 130, '2014-04-01 00:26:35.000000', 'consum', 0.0211, 'lps'),
	(614255, 130, '2014-04-01 00:26:36.000000', 'consum', 0.0215, 'lps'),
	(614256, 130, '2014-04-01 00:26:37.000000', 'consum', 0.0210, 'lps'),
	(614257, 130, '2014-04-01 00:26:38.000000', 'consum', 0.0220, 'lps'),
	(614258, 130, '2014-04-01 00:26:39.000000', 'consum', 0.0210, 'lps'),
	(614259, 130, '2014-04-01 00:26:40.000000', 'consum', 0.0219, 'lps'),
	(614260, 130, '2014-04-01 00:26:41.000000', 'consum', 0.0218, 'lps'),
	(614261, 130, '2014-04-01 00:26:42.000000', 'consum', 0.0212, 'lps'),
	(614262, 130, '2014-04-01 00:26:43.000000', 'consum', 0.0210, 'lps'),
	(614263, 130, '2014-04-01 00:26:44.000000', 'consum', 0.0214, 'lps'),
	(614264, 130, '2014-04-01 00:26:45.000000', 'consum', 0.0210, 'lps'),
	(614265, 130, '2014-04-01 00:26:46.000000', 'consum', 0.0219, 'lps'),
	(614266, 130, '2014-04-01 00:26:47.000000', 'consum', 0.0221, 'lps'),
	(614267, 130, '2014-04-01 00:26:48.000000', 'consum', 0.0215, 'lps'),
	(614268, 130, '2014-04-01 00:26:49.000000', 'consum', 0.0214, 'lps'),
	(614269, 130, '2014-04-01 00:26:50.000000', 'consum', 0.0217, 'lps'),
	(614270, 130, '2014-04-01 00:26:51.000000', 'consum', 0.0210, 'lps'),
	(614271, 130, '2014-04-01 00:26:52.000000', 'consum', 0.0211, 'lps'),
	(614272, 130, '2014-04-01 00:26:53.000000', 'consum', 0.0215, 'lps'),
	(614273, 130, '2014-04-01 00:26:54.000000', 'consum', 0.0210, 'lps'),
	(614274, 130, '2014-04-01 00:26:55.000000', 'consum', 0.0221, 'lps'),
	(614275, 130, '2014-04-01 00:26:56.000000', 'consum', 0.0217, 'lps'),
	(614276, 130, '2014-04-01 00:26:57.000000', 'consum', 0.0210, 'lps'),
	(614277, 130, '2014-04-01 00:26:58.000000', 'consum', 0.0216, 'lps'),
	(614278, 130, '2014-04-01 00:26:59.000000', 'consum', 0.0218, 'lps'),
	(614279, 130, '2014-04-01 00:27:00.000000', 'consum', 0.0217, 'lps'),
	(614280, 130, '2014-04-01 00:27:01.000000', 'consum', 0.0211, 'lps'),
	(614281, 130, '2014-04-01 00:27:02.000000', 'consum', 0.0217, 'lps'),
	(614282, 130, '2014-04-01 00:27:03.000000', 'consum', 0.0221, 'lps'),
	(614283, 130, '2014-04-01 00:27:04.000000', 'consum', 0.0218, 'lps'),
	(614284, 130, '2014-04-01 00:27:05.000000', 'consum', 0.0218, 'lps'),
	(614285, 130, '2014-04-01 00:27:06.000000', 'consum', 0.0217, 'lps'),
	(614286, 130, '2014-04-01 00:27:07.000000', 'consum', 0.0219, 'lps'),
	(614287, 130, '2014-04-01 00:27:08.000000', 'consum', 0.0212, 'lps'),
	(614288, 130, '2014-04-01 00:27:09.000000', 'consum', 0.0218, 'lps'),
	(614289, 130, '2014-04-01 00:27:10.000000', 'consum', 0.0219, 'lps'),
	(614290, 130, '2014-04-01 00:27:11.000000', 'consum', 0.0210, 'lps'),
	(614291, 130, '2014-04-01 00:27:12.000000', 'consum', 0.0216, 'lps'),
	(614292, 130, '2014-04-01 00:27:13.000000', 'consum', 0.0219, 'lps'),
	(614293, 130, '2014-04-01 00:27:14.000000', 'consum', 0.0214, 'lps'),
	(614294, 130, '2014-04-01 00:27:15.000000', 'consum', 0.0214, 'lps'),
	(614295, 130, '2014-04-01 00:27:16.000000', 'consum', 0.0217, 'lps'),
	(614296, 130, '2014-04-01 00:27:17.000000', 'consum', 0.0212, 'lps'),
	(614297, 130, '2014-04-01 00:27:18.000000', 'consum', 0.0213, 'lps'),
	(614298, 130, '2014-04-01 00:27:19.000000', 'consum', 0.0217, 'lps'),
	(614299, 130, '2014-04-01 00:27:20.000000', 'consum', 0.0214, 'lps'),
	(614300, 130, '2014-04-01 00:27:21.000000', 'consum', 0.0221, 'lps'),
	(614301, 130, '2014-04-01 00:27:22.000000', 'consum', 0.0219, 'lps'),
	(614302, 130, '2014-04-01 00:27:23.000000', 'consum', 0.0210, 'lps'),
	(614303, 130, '2014-04-01 00:27:24.000000', 'consum', 0.0221, 'lps'),
	(614304, 130, '2014-04-01 00:27:25.000000', 'consum', 0.0217, 'lps'),
	(614305, 130, '2014-04-01 00:27:26.000000', 'consum', 0.0213, 'lps'),
	(614306, 130, '2014-04-01 00:27:27.000000', 'consum', 0.0214, 'lps'),
	(614307, 130, '2014-04-01 00:27:28.000000', 'consum', 0.0211, 'lps'),
	(614308, 130, '2014-04-01 00:27:29.000000', 'consum', 0.0214, 'lps'),
	(614309, 130, '2014-04-01 00:27:30.000000', 'consum', 0.0215, 'lps'),
	(614310, 130, '2014-04-01 00:27:31.000000', 'consum', 0.0211, 'lps'),
	(614311, 130, '2014-04-01 00:27:32.000000', 'consum', 0.0213, 'lps'),
	(614312, 130, '2014-04-01 00:27:33.000000', 'consum', 0.0213, 'lps'),
	(614313, 130, '2014-04-01 00:27:34.000000', 'consum', 0.0213, 'lps'),
	(614314, 130, '2014-04-01 00:27:35.000000', 'consum', 0.0219, 'lps'),
	(614315, 130, '2014-04-01 00:27:36.000000', 'consum', 0.0210, 'lps'),
	(614316, 130, '2014-04-01 00:27:37.000000', 'consum', 0.0218, 'lps'),
	(614317, 130, '2014-04-01 00:27:38.000000', 'consum', 0.0215, 'lps'),
	(614318, 130, '2014-04-01 00:27:39.000000', 'consum', 0.0210, 'lps'),
	(614319, 130, '2014-04-01 00:27:40.000000', 'consum', 0.0220, 'lps'),
	(614320, 130, '2014-04-01 00:27:41.000000', 'consum', 0.0213, 'lps'),
	(614321, 130, '2014-04-01 00:27:42.000000', 'consum', 0.0220, 'lps'),
	(614322, 130, '2014-04-01 00:27:43.000000', 'consum', 0.0216, 'lps'),
	(614323, 130, '2014-04-01 00:27:44.000000', 'consum', 0.0221, 'lps'),
	(614324, 130, '2014-04-01 00:27:45.000000', 'consum', 0.0213, 'lps'),
	(614325, 130, '2014-04-01 00:27:46.000000', 'consum', 0.0217, 'lps'),
	(614326, 130, '2014-04-01 00:27:47.000000', 'consum', 0.0211, 'lps'),
	(614327, 130, '2014-04-01 00:27:48.000000', 'consum', 0.0218, 'lps'),
	(614328, 130, '2014-04-01 00:27:49.000000', 'consum', 0.0213, 'lps'),
	(614329, 130, '2014-04-01 00:27:50.000000', 'consum', 0.0211, 'lps'),
	(614330, 130, '2014-04-01 00:27:51.000000', 'consum', 0.0220, 'lps'),
	(614331, 130, '2014-04-01 00:27:52.000000', 'consum', 0.0219, 'lps'),
	(614332, 130, '2014-04-01 00:27:53.000000', 'consum', 0.0216, 'lps'),
	(614333, 130, '2014-04-01 00:27:54.000000', 'consum', 0.0214, 'lps'),
	(614334, 130, '2014-04-01 00:27:55.000000', 'consum', 0.0213, 'lps'),
	(614335, 130, '2014-04-01 00:27:56.000000', 'consum', 0.0214, 'lps'),
	(614336, 130, '2014-04-01 00:27:57.000000', 'consum', 0.0210, 'lps'),
	(614337, 130, '2014-04-01 00:27:58.000000', 'consum', 0.0220, 'lps'),
	(614338, 130, '2014-04-01 00:27:59.000000', 'consum', 0.0215, 'lps'),
	(614339, 130, '2014-04-01 00:28:00.000000', 'consum', 0.0218, 'lps'),
	(614340, 130, '2014-04-01 00:28:01.000000', 'consum', 0.0211, 'lps'),
	(614341, 130, '2014-04-01 00:28:02.000000', 'consum', 0.0217, 'lps'),
	(614342, 130, '2014-04-01 00:28:03.000000', 'consum', 0.0217, 'lps'),
	(614343, 130, '2014-04-01 00:28:04.000000', 'consum', 0.0212, 'lps'),
	(614344, 130, '2014-04-01 00:28:05.000000', 'consum', 0.0213, 'lps'),
	(614345, 130, '2014-04-01 00:28:06.000000', 'consum', 0.0217, 'lps'),
	(614346, 130, '2014-04-01 00:28:07.000000', 'consum', 0.0215, 'lps'),
	(614347, 130, '2014-04-01 00:28:08.000000', 'consum', 0.0214, 'lps'),
	(614348, 130, '2014-04-01 00:28:09.000000', 'consum', 0.0215, 'lps'),
	(614349, 130, '2014-04-01 00:28:10.000000', 'consum', 0.0210, 'lps'),
	(614350, 130, '2014-04-01 00:28:11.000000', 'consum', 0.0221, 'lps'),
	(614351, 130, '2014-04-01 00:28:12.000000', 'consum', 0.0216, 'lps'),
	(614352, 130, '2014-04-01 00:28:13.000000', 'consum', 0.0221, 'lps'),
	(614353, 130, '2014-04-01 00:28:14.000000', 'consum', 0.0210, 'lps'),
	(614354, 130, '2014-04-01 00:28:15.000000', 'consum', 0.0216, 'lps'),
	(614355, 130, '2014-04-01 00:28:16.000000', 'consum', 0.0214, 'lps'),
	(614356, 130, '2014-04-01 00:28:17.000000', 'consum', 0.0215, 'lps'),
	(614357, 130, '2014-04-01 00:28:18.000000', 'consum', 0.0212, 'lps'),
	(614358, 130, '2014-04-01 00:28:19.000000', 'consum', 0.0216, 'lps'),
	(614359, 130, '2014-04-01 00:28:20.000000', 'consum', 0.0210, 'lps'),
	(614360, 130, '2014-04-01 00:28:21.000000', 'consum', 0.0219, 'lps'),
	(614361, 130, '2014-04-01 00:28:22.000000', 'consum', 0.0218, 'lps'),
	(614362, 130, '2014-04-01 00:28:23.000000', 'consum', 0.0211, 'lps'),
	(614363, 130, '2014-04-01 00:28:24.000000', 'consum', 0.0217, 'lps'),
	(614364, 130, '2014-04-01 00:28:25.000000', 'consum', 0.0217, 'lps'),
	(614365, 130, '2014-04-01 00:28:26.000000', 'consum', 0.0211, 'lps'),
	(614366, 130, '2014-04-01 00:28:27.000000', 'consum', 0.0219, 'lps'),
	(614367, 130, '2014-04-01 00:28:28.000000', 'consum', 0.0219, 'lps'),
	(614368, 130, '2014-04-01 00:28:29.000000', 'consum', 0.0214, 'lps'),
	(614369, 130, '2014-04-01 00:28:30.000000', 'consum', 0.0216, 'lps'),
	(614370, 130, '2014-04-01 00:28:31.000000', 'consum', 0.0218, 'lps'),
	(614371, 130, '2014-04-01 00:28:32.000000', 'consum', 0.0220, 'lps'),
	(614372, 130, '2014-04-01 00:28:33.000000', 'consum', 0.0211, 'lps'),
	(614373, 130, '2014-04-01 00:28:34.000000', 'consum', 0.0221, 'lps'),
	(614374, 130, '2014-04-01 00:28:35.000000', 'consum', 0.0215, 'lps'),
	(614375, 130, '2014-04-01 00:28:36.000000', 'consum', 0.0214, 'lps'),
	(614376, 130, '2014-04-01 00:28:37.000000', 'consum', 0.0216, 'lps'),
	(614377, 130, '2014-04-01 00:28:38.000000', 'consum', 0.0216, 'lps'),
	(614378, 130, '2014-04-01 00:28:39.000000', 'consum', 0.0210, 'lps'),
	(614379, 130, '2014-04-01 00:28:40.000000', 'consum', 0.0218, 'lps'),
	(614380, 130, '2014-04-01 00:28:41.000000', 'consum', 0.0212, 'lps'),
	(614381, 130, '2014-04-01 00:28:42.000000', 'consum', 0.0211, 'lps'),
	(614382, 130, '2014-04-01 00:28:43.000000', 'consum', 0.0210, 'lps'),
	(614383, 130, '2014-04-01 00:28:44.000000', 'consum', 0.0220, 'lps'),
	(614384, 130, '2014-04-01 00:28:45.000000', 'consum', 0.0212, 'lps'),
	(614385, 130, '2014-04-01 00:28:46.000000', 'consum', 0.0214, 'lps'),
	(614386, 130, '2014-04-01 00:28:47.000000', 'consum', 0.0211, 'lps'),
	(614387, 130, '2014-04-01 00:28:48.000000', 'consum', 0.0215, 'lps'),
	(614388, 130, '2014-04-01 00:28:49.000000', 'consum', 0.0211, 'lps'),
	(614389, 130, '2014-04-01 00:28:50.000000', 'consum', 0.0211, 'lps'),
	(614390, 130, '2014-04-01 00:28:51.000000', 'consum', 0.0215, 'lps'),
	(614391, 130, '2014-04-01 00:28:52.000000', 'consum', 0.0218, 'lps'),
	(614392, 130, '2014-04-01 00:28:53.000000', 'consum', 0.0214, 'lps'),
	(614393, 130, '2014-04-01 00:28:54.000000', 'consum', 0.0215, 'lps'),
	(614394, 130, '2014-04-01 00:28:55.000000', 'consum', 0.0214, 'lps'),
	(614395, 130, '2014-04-01 00:28:56.000000', 'consum', 0.0214, 'lps'),
	(614396, 130, '2014-04-01 00:28:57.000000', 'consum', 0.0219, 'lps'),
	(614397, 130, '2014-04-01 00:28:58.000000', 'consum', 0.0219, 'lps'),
	(614398, 130, '2014-04-01 00:28:59.000000', 'consum', 0.0216, 'lps'),
	(614399, 130, '2014-04-01 00:29:00.000000', 'consum', 0.0215, 'lps'),
	(614400, 130, '2014-04-01 00:29:01.000000', 'consum', 0.0216, 'lps'),
	(614401, 130, '2014-04-01 00:29:02.000000', 'consum', 0.0214, 'lps'),
	(614402, 130, '2014-04-01 00:29:03.000000', 'consum', 0.0212, 'lps'),
	(614403, 130, '2014-04-01 00:29:04.000000', 'consum', 0.0221, 'lps'),
	(614404, 130, '2014-04-01 00:29:05.000000', 'consum', 0.0210, 'lps'),
	(614405, 130, '2014-04-01 00:29:06.000000', 'consum', 0.0213, 'lps'),
	(614406, 130, '2014-04-01 00:29:07.000000', 'consum', 0.0214, 'lps'),
	(614407, 130, '2014-04-01 00:29:08.000000', 'consum', 0.0210, 'lps'),
	(614408, 130, '2014-04-01 00:29:09.000000', 'consum', 0.0210, 'lps'),
	(614409, 130, '2014-04-01 00:29:10.000000', 'consum', 0.0212, 'lps'),
	(614410, 130, '2014-04-01 00:29:11.000000', 'consum', 0.0221, 'lps'),
	(614411, 130, '2014-04-01 00:29:12.000000', 'consum', 0.0221, 'lps'),
	(614412, 130, '2014-04-01 00:29:13.000000', 'consum', 0.0221, 'lps'),
	(614413, 130, '2014-04-01 00:29:14.000000', 'consum', 0.0210, 'lps'),
	(614414, 130, '2014-04-01 00:29:15.000000', 'consum', 0.0214, 'lps'),
	(614415, 130, '2014-04-01 00:29:16.000000', 'consum', 0.0219, 'lps'),
	(614416, 130, '2014-04-01 00:29:17.000000', 'consum', 0.0217, 'lps'),
	(614417, 130, '2014-04-01 00:29:18.000000', 'consum', 0.0220, 'lps'),
	(614418, 130, '2014-04-01 00:29:19.000000', 'consum', 0.0216, 'lps'),
	(614419, 130, '2014-04-01 00:29:20.000000', 'consum', 0.0220, 'lps'),
	(614420, 130, '2014-04-01 00:29:21.000000', 'consum', 0.0219, 'lps'),
	(614421, 130, '2014-04-01 00:29:22.000000', 'consum', 0.0215, 'lps'),
	(614422, 130, '2014-04-01 00:29:23.000000', 'consum', 0.0218, 'lps'),
	(614423, 130, '2014-04-01 00:29:24.000000', 'consum', 0.0215, 'lps'),
	(614424, 130, '2014-04-01 00:29:25.000000', 'consum', 0.0221, 'lps'),
	(614425, 130, '2014-04-01 00:29:26.000000', 'consum', 0.0214, 'lps'),
	(614426, 130, '2014-04-01 00:29:27.000000', 'consum', 0.0221, 'lps'),
	(614427, 130, '2014-04-01 00:29:28.000000', 'consum', 0.0219, 'lps'),
	(614428, 130, '2014-04-01 00:29:29.000000', 'consum', 0.0220, 'lps'),
	(614429, 130, '2014-04-01 00:29:30.000000', 'consum', 0.0211, 'lps'),
	(614430, 130, '2014-04-01 00:29:31.000000', 'consum', 0.0210, 'lps'),
	(614431, 130, '2014-04-01 00:29:32.000000', 'consum', 0.0220, 'lps'),
	(614432, 130, '2014-04-01 00:29:33.000000', 'consum', 0.0214, 'lps'),
	(614433, 130, '2014-04-01 00:29:34.000000', 'consum', 0.0210, 'lps'),
	(614434, 130, '2014-04-01 00:29:35.000000', 'consum', 0.0212, 'lps'),
	(614435, 130, '2014-04-01 00:29:36.000000', 'consum', 0.0221, 'lps'),
	(614436, 130, '2014-04-01 00:29:37.000000', 'consum', 0.0210, 'lps'),
	(614437, 130, '2014-04-01 00:29:38.000000', 'consum', 0.0215, 'lps'),
	(614438, 130, '2014-04-01 00:29:39.000000', 'consum', 0.0221, 'lps'),
	(614439, 130, '2014-04-01 00:29:40.000000', 'consum', 0.0217, 'lps'),
	(614440, 130, '2014-04-01 00:29:41.000000', 'consum', 0.0210, 'lps'),
	(614441, 130, '2014-04-01 00:29:42.000000', 'consum', 0.0213, 'lps'),
	(614442, 130, '2014-04-01 00:29:43.000000', 'consum', 0.0213, 'lps'),
	(614443, 130, '2014-04-01 00:29:44.000000', 'consum', 0.0216, 'lps'),
	(614444, 130, '2014-04-01 00:29:45.000000', 'consum', 0.0210, 'lps'),
	(614445, 130, '2014-04-01 00:29:46.000000', 'consum', 0.0217, 'lps'),
	(614446, 130, '2014-04-01 00:29:47.000000', 'consum', 0.0220, 'lps'),
	(614447, 130, '2014-04-01 00:29:48.000000', 'consum', 0.0214, 'lps'),
	(614448, 130, '2014-04-01 00:29:49.000000', 'consum', 0.0214, 'lps'),
	(614449, 130, '2014-04-01 00:29:50.000000', 'consum', 0.0220, 'lps'),
	(614450, 130, '2014-04-01 00:29:51.000000', 'consum', 0.0210, 'lps'),
	(614451, 130, '2014-04-01 00:29:52.000000', 'consum', 0.0218, 'lps'),
	(614452, 130, '2014-04-01 00:29:53.000000', 'consum', 0.0214, 'lps'),
	(614453, 130, '2014-04-01 00:29:54.000000', 'consum', 0.0219, 'lps'),
	(614454, 130, '2014-04-01 00:29:55.000000', 'consum', 0.0221, 'lps'),
	(614455, 130, '2014-04-01 00:29:56.000000', 'consum', 0.0212, 'lps'),
	(614456, 130, '2014-04-01 00:29:57.000000', 'consum', 0.0214, 'lps'),
	(614457, 130, '2014-04-01 00:29:58.000000', 'consum', 0.0213, 'lps'),
	(614458, 130, '2014-04-01 00:29:59.000000', 'consum', 0.0211, 'lps'),
	(614459, 130, '2014-04-01 00:30:00.000000', 'consum', 0.0220, 'lps'),
	(614460, 130, '2014-04-01 00:30:01.000000', 'consum', 0.0219, 'lps'),
	(614461, 130, '2014-04-01 00:30:02.000000', 'consum', 0.0217, 'lps'),
	(614462, 130, '2014-04-01 00:30:03.000000', 'consum', 0.0216, 'lps'),
	(614463, 130, '2014-04-01 00:30:04.000000', 'consum', 0.0220, 'lps'),
	(614464, 130, '2014-04-01 00:30:05.000000', 'consum', 0.0218, 'lps'),
	(614465, 130, '2014-04-01 00:30:06.000000', 'consum', 0.0210, 'lps'),
	(614466, 130, '2014-04-01 00:30:07.000000', 'consum', 0.0221, 'lps'),
	(614467, 130, '2014-04-01 00:30:08.000000', 'consum', 0.0220, 'lps'),
	(614468, 130, '2014-04-01 00:30:09.000000', 'consum', 0.0214, 'lps'),
	(614469, 130, '2014-04-01 00:30:10.000000', 'consum', 0.0215, 'lps'),
	(614470, 130, '2014-04-01 00:30:11.000000', 'consum', 0.0221, 'lps'),
	(614471, 130, '2014-04-01 00:30:12.000000', 'consum', 0.0214, 'lps'),
	(614472, 130, '2014-04-01 00:30:13.000000', 'consum', 0.0221, 'lps'),
	(614473, 130, '2014-04-01 00:30:14.000000', 'consum', 0.0218, 'lps'),
	(614474, 130, '2014-04-01 00:30:15.000000', 'consum', 0.0220, 'lps'),
	(614475, 130, '2014-04-01 00:30:16.000000', 'consum', 0.0221, 'lps'),
	(614476, 130, '2014-04-01 00:30:17.000000', 'consum', 0.0215, 'lps'),
	(614477, 130, '2014-04-01 00:30:18.000000', 'consum', 0.0212, 'lps'),
	(614478, 130, '2014-04-01 00:30:19.000000', 'consum', 0.0219, 'lps'),
	(614479, 130, '2014-04-01 00:30:20.000000', 'consum', 0.0212, 'lps'),
	(614480, 130, '2014-04-01 00:30:21.000000', 'consum', 0.0219, 'lps'),
	(614481, 130, '2014-04-01 00:30:22.000000', 'consum', 0.0211, 'lps'),
	(614482, 130, '2014-04-01 00:30:23.000000', 'consum', 0.0213, 'lps'),
	(614483, 130, '2014-04-01 00:30:24.000000', 'consum', 0.0212, 'lps'),
	(614484, 130, '2014-04-01 00:30:25.000000', 'consum', 0.0212, 'lps'),
	(614485, 130, '2014-04-01 00:30:26.000000', 'consum', 0.0215, 'lps'),
	(614486, 130, '2014-04-01 00:30:27.000000', 'consum', 0.0217, 'lps'),
	(614487, 130, '2014-04-01 00:30:28.000000', 'consum', 0.0219, 'lps'),
	(614488, 130, '2014-04-01 00:30:29.000000', 'consum', 0.0212, 'lps'),
	(614489, 130, '2014-04-01 00:30:30.000000', 'consum', 0.0216, 'lps'),
	(614490, 130, '2014-04-01 00:30:31.000000', 'consum', 0.0211, 'lps'),
	(614491, 130, '2014-04-01 00:30:32.000000', 'consum', 0.0220, 'lps'),
	(614492, 130, '2014-04-01 00:30:33.000000', 'consum', 0.0210, 'lps'),
	(614493, 130, '2014-04-01 00:30:34.000000', 'consum', 0.0218, 'lps'),
	(614494, 130, '2014-04-01 00:30:35.000000', 'consum', 0.0215, 'lps'),
	(614495, 130, '2014-04-01 00:30:36.000000', 'consum', 0.0221, 'lps'),
	(614496, 130, '2014-04-01 00:30:37.000000', 'consum', 0.0214, 'lps'),
	(614497, 130, '2014-04-01 00:30:38.000000', 'consum', 0.0221, 'lps'),
	(614498, 130, '2014-04-01 00:30:39.000000', 'consum', 0.0218, 'lps'),
	(614499, 130, '2014-04-01 00:30:40.000000', 'consum', 0.0216, 'lps'),
	(614500, 130, '2014-04-01 00:30:41.000000', 'consum', 0.0217, 'lps'),
	(614501, 130, '2014-04-01 00:30:42.000000', 'consum', 0.0218, 'lps'),
	(614502, 130, '2014-04-01 00:30:43.000000', 'consum', 0.0216, 'lps'),
	(614503, 130, '2014-04-01 00:30:44.000000', 'consum', 0.0218, 'lps'),
	(614504, 130, '2014-04-01 00:30:45.000000', 'consum', 0.0219, 'lps'),
	(614505, 130, '2014-04-01 00:30:46.000000', 'consum', 0.0221, 'lps'),
	(614506, 130, '2014-04-01 00:30:47.000000', 'consum', 0.0215, 'lps'),
	(614507, 130, '2014-04-01 00:30:48.000000', 'consum', 0.0213, 'lps'),
	(614508, 130, '2014-04-01 00:30:49.000000', 'consum', 0.0212, 'lps'),
	(614509, 130, '2014-04-01 00:30:50.000000', 'consum', 0.0210, 'lps'),
	(614510, 130, '2014-04-01 00:30:51.000000', 'consum', 0.0219, 'lps'),
	(614511, 130, '2014-04-01 00:30:52.000000', 'consum', 0.0218, 'lps'),
	(614512, 130, '2014-04-01 00:30:53.000000', 'consum', 0.0211, 'lps'),
	(614513, 130, '2014-04-01 00:30:54.000000', 'consum', 0.0214, 'lps'),
	(614514, 130, '2014-04-01 00:30:55.000000', 'consum', 0.0216, 'lps'),
	(614515, 130, '2014-04-01 00:30:56.000000', 'consum', 0.0219, 'lps'),
	(614516, 130, '2014-04-01 00:30:57.000000', 'consum', 0.0211, 'lps'),
	(614517, 130, '2014-04-01 00:30:58.000000', 'consum', 0.0213, 'lps'),
	(614518, 130, '2014-04-01 00:30:59.000000', 'consum', 0.0212, 'lps'),
	(614519, 130, '2014-04-01 00:31:00.000000', 'consum', 0.0210, 'lps'),
	(614520, 130, '2014-04-01 00:31:01.000000', 'consum', 0.0215, 'lps'),
	(614521, 130, '2014-04-01 00:31:02.000000', 'consum', 0.0213, 'lps'),
	(614522, 130, '2014-04-01 00:31:03.000000', 'consum', 0.0212, 'lps'),
	(614523, 130, '2014-04-01 00:31:04.000000', 'consum', 0.0221, 'lps'),
	(614524, 130, '2014-04-01 00:31:05.000000', 'consum', 0.0213, 'lps'),
	(614525, 130, '2014-04-01 00:31:06.000000', 'consum', 0.0215, 'lps'),
	(614526, 130, '2014-04-01 00:31:07.000000', 'consum', 0.0215, 'lps'),
	(614527, 130, '2014-04-01 00:31:08.000000', 'consum', 0.0210, 'lps'),
	(614528, 130, '2014-04-01 00:31:09.000000', 'consum', 0.0218, 'lps'),
	(614529, 130, '2014-04-01 00:31:10.000000', 'consum', 0.0213, 'lps'),
	(614530, 130, '2014-04-01 00:31:11.000000', 'consum', 0.0214, 'lps'),
	(614531, 130, '2014-04-01 00:31:12.000000', 'consum', 0.0212, 'lps'),
	(614532, 130, '2014-04-01 00:31:13.000000', 'consum', 0.0220, 'lps'),
	(614533, 130, '2014-04-01 00:31:14.000000', 'consum', 0.0218, 'lps'),
	(614534, 130, '2014-04-01 00:31:15.000000', 'consum', 0.0221, 'lps'),
	(614535, 130, '2014-04-01 00:31:16.000000', 'consum', 0.0215, 'lps'),
	(614536, 130, '2014-04-01 00:31:17.000000', 'consum', 0.0216, 'lps'),
	(614537, 130, '2014-04-01 00:31:18.000000', 'consum', 0.0213, 'lps'),
	(614538, 130, '2014-04-01 00:31:19.000000', 'consum', 0.0221, 'lps'),
	(614539, 130, '2014-04-01 00:31:20.000000', 'consum', 0.0220, 'lps'),
	(614540, 130, '2014-04-01 00:31:21.000000', 'consum', 0.0217, 'lps'),
	(614541, 130, '2014-04-01 00:31:22.000000', 'consum', 0.0213, 'lps'),
	(614542, 130, '2014-04-01 00:31:23.000000', 'consum', 0.0218, 'lps'),
	(614543, 130, '2014-04-01 00:31:24.000000', 'consum', 0.0215, 'lps'),
	(614544, 130, '2014-04-01 00:31:25.000000', 'consum', 0.0214, 'lps'),
	(614545, 130, '2014-04-01 00:31:26.000000', 'consum', 0.0214, 'lps'),
	(614546, 130, '2014-04-01 00:31:27.000000', 'consum', 0.0217, 'lps'),
	(614547, 130, '2014-04-01 00:31:28.000000', 'consum', 0.0211, 'lps'),
	(614548, 130, '2014-04-01 00:31:29.000000', 'consum', 0.0217, 'lps'),
	(614549, 130, '2014-04-01 00:31:30.000000', 'consum', 0.0219, 'lps'),
	(614550, 130, '2014-04-01 00:31:31.000000', 'consum', 0.0221, 'lps'),
	(614551, 130, '2014-04-01 00:31:32.000000', 'consum', 0.0215, 'lps'),
	(614552, 130, '2014-04-01 00:31:33.000000', 'consum', 0.0216, 'lps'),
	(614553, 130, '2014-04-01 00:31:34.000000', 'consum', 0.0211, 'lps'),
	(614554, 130, '2014-04-01 00:31:35.000000', 'consum', 0.0212, 'lps'),
	(614555, 130, '2014-04-01 00:31:36.000000', 'consum', 0.0218, 'lps'),
	(614556, 130, '2014-04-01 00:31:37.000000', 'consum', 0.0219, 'lps'),
	(614557, 130, '2014-04-01 00:31:38.000000', 'consum', 0.0218, 'lps'),
	(614558, 130, '2014-04-01 00:31:39.000000', 'consum', 0.0213, 'lps'),
	(614559, 130, '2014-04-01 00:31:40.000000', 'consum', 0.0212, 'lps'),
	(614560, 130, '2014-04-01 00:31:41.000000', 'consum', 0.0211, 'lps'),
	(614561, 130, '2014-04-01 00:31:42.000000', 'consum', 0.0210, 'lps'),
	(614562, 130, '2014-04-01 00:31:43.000000', 'consum', 0.0221, 'lps'),
	(614563, 130, '2014-04-01 00:31:44.000000', 'consum', 0.0215, 'lps'),
	(614564, 130, '2014-04-01 00:31:45.000000', 'consum', 0.0215, 'lps'),
	(614565, 130, '2014-04-01 00:31:46.000000', 'consum', 0.0221, 'lps'),
	(614566, 130, '2014-04-01 00:31:47.000000', 'consum', 0.0214, 'lps'),
	(614567, 130, '2014-04-01 00:31:48.000000', 'consum', 0.0211, 'lps'),
	(614568, 130, '2014-04-01 00:31:49.000000', 'consum', 0.0213, 'lps'),
	(614569, 130, '2014-04-01 00:31:50.000000', 'consum', 0.0212, 'lps'),
	(614570, 130, '2014-04-01 00:31:51.000000', 'consum', 0.0213, 'lps'),
	(614571, 130, '2014-04-01 00:31:52.000000', 'consum', 0.0219, 'lps'),
	(614572, 130, '2014-04-01 00:31:53.000000', 'consum', 0.0210, 'lps'),
	(614573, 130, '2014-04-01 00:31:54.000000', 'consum', 0.0219, 'lps'),
	(614574, 130, '2014-04-01 00:31:55.000000', 'consum', 0.0220, 'lps'),
	(614575, 130, '2014-04-01 00:31:56.000000', 'consum', 0.0221, 'lps'),
	(614576, 130, '2014-04-01 00:31:57.000000', 'consum', 0.0213, 'lps'),
	(614577, 130, '2014-04-01 00:31:58.000000', 'consum', 0.0218, 'lps'),
	(614578, 130, '2014-04-01 00:31:59.000000', 'consum', 0.0215, 'lps'),
	(614579, 130, '2014-04-01 00:32:00.000000', 'consum', 0.0211, 'lps'),
	(614580, 130, '2014-04-01 00:32:01.000000', 'consum', 0.0212, 'lps'),
	(614581, 130, '2014-04-01 00:32:02.000000', 'consum', 0.0220, 'lps'),
	(614582, 130, '2014-04-01 00:32:03.000000', 'consum', 0.0216, 'lps'),
	(614583, 130, '2014-04-01 00:32:04.000000', 'consum', 0.0210, 'lps'),
	(614584, 130, '2014-04-01 00:32:05.000000', 'consum', 0.0219, 'lps'),
	(614585, 130, '2014-04-01 00:32:06.000000', 'consum', 0.0218, 'lps'),
	(614586, 130, '2014-04-01 00:32:07.000000', 'consum', 0.0214, 'lps'),
	(614587, 130, '2014-04-01 00:32:08.000000', 'consum', 0.0216, 'lps'),
	(614588, 130, '2014-04-01 00:32:09.000000', 'consum', 0.0218, 'lps'),
	(614589, 130, '2014-04-01 00:32:10.000000', 'consum', 0.0221, 'lps'),
	(614590, 130, '2014-04-01 00:32:11.000000', 'consum', 0.0218, 'lps'),
	(614591, 130, '2014-04-01 00:32:12.000000', 'consum', 0.0215, 'lps'),
	(614592, 130, '2014-04-01 00:32:13.000000', 'consum', 0.0215, 'lps'),
	(614593, 130, '2014-04-01 00:32:14.000000', 'consum', 0.0218, 'lps'),
	(614594, 130, '2014-04-01 00:32:15.000000', 'consum', 0.0211, 'lps'),
	(614595, 130, '2014-04-01 00:32:16.000000', 'consum', 0.0218, 'lps'),
	(614596, 130, '2014-04-01 00:32:17.000000', 'consum', 0.0221, 'lps'),
	(614597, 130, '2014-04-01 00:32:18.000000', 'consum', 0.0219, 'lps'),
	(614598, 130, '2014-04-01 00:32:19.000000', 'consum', 0.0220, 'lps'),
	(614599, 130, '2014-04-01 00:32:20.000000', 'consum', 0.0212, 'lps'),
	(614600, 130, '2014-04-01 00:32:21.000000', 'consum', 0.0215, 'lps'),
	(614601, 130, '2014-04-01 00:32:22.000000', 'consum', 0.0216, 'lps'),
	(614602, 130, '2014-04-01 00:32:23.000000', 'consum', 0.0213, 'lps'),
	(614603, 130, '2014-04-01 00:32:24.000000', 'consum', 0.0219, 'lps'),
	(614604, 130, '2014-04-01 00:32:25.000000', 'consum', 0.0211, 'lps'),
	(614605, 130, '2014-04-01 00:32:26.000000', 'consum', 0.0213, 'lps'),
	(614606, 130, '2014-04-01 00:32:27.000000', 'consum', 0.0211, 'lps'),
	(614607, 130, '2014-04-01 00:32:28.000000', 'consum', 0.0217, 'lps'),
	(614608, 130, '2014-04-01 00:32:29.000000', 'consum', 0.0218, 'lps'),
	(614609, 130, '2014-04-01 00:32:30.000000', 'consum', 0.0218, 'lps'),
	(614610, 130, '2014-04-01 00:32:31.000000', 'consum', 0.0217, 'lps'),
	(614611, 130, '2014-04-01 00:32:32.000000', 'consum', 0.0218, 'lps'),
	(614612, 130, '2014-04-01 00:32:33.000000', 'consum', 0.0221, 'lps'),
	(614613, 130, '2014-04-01 00:32:34.000000', 'consum', 0.0214, 'lps'),
	(614614, 130, '2014-04-01 00:32:35.000000', 'consum', 0.0212, 'lps'),
	(614615, 130, '2014-04-01 00:32:36.000000', 'consum', 0.0221, 'lps'),
	(614616, 130, '2014-04-01 00:32:37.000000', 'consum', 0.0221, 'lps'),
	(614617, 130, '2014-04-01 00:32:38.000000', 'consum', 0.0220, 'lps'),
	(614618, 130, '2014-04-01 00:32:39.000000', 'consum', 0.0219, 'lps'),
	(614619, 130, '2014-04-01 00:32:40.000000', 'consum', 0.0210, 'lps'),
	(614620, 130, '2014-04-01 00:32:41.000000', 'consum', 0.0211, 'lps'),
	(614621, 130, '2014-04-01 00:32:42.000000', 'consum', 0.0213, 'lps'),
	(614622, 130, '2014-04-01 00:32:43.000000', 'consum', 0.0221, 'lps'),
	(614623, 130, '2014-04-01 00:32:44.000000', 'consum', 0.0211, 'lps'),
	(614624, 130, '2014-04-01 00:32:45.000000', 'consum', 0.0220, 'lps'),
	(614625, 130, '2014-04-01 00:32:46.000000', 'consum', 0.0219, 'lps'),
	(614626, 130, '2014-04-01 00:32:47.000000', 'consum', 0.0216, 'lps'),
	(614627, 130, '2014-04-01 00:32:48.000000', 'consum', 0.0213, 'lps'),
	(614628, 130, '2014-04-01 00:32:49.000000', 'consum', 0.0218, 'lps'),
	(614629, 130, '2014-04-01 00:32:50.000000', 'consum', 0.0218, 'lps'),
	(614630, 130, '2014-04-01 00:32:51.000000', 'consum', 0.0213, 'lps'),
	(614631, 130, '2014-04-01 00:32:52.000000', 'consum', 0.0215, 'lps'),
	(614632, 130, '2014-04-01 00:32:53.000000', 'consum', 0.0216, 'lps'),
	(614633, 130, '2014-04-01 00:32:54.000000', 'consum', 0.0212, 'lps'),
	(614634, 130, '2014-04-01 00:32:55.000000', 'consum', 0.0216, 'lps'),
	(614635, 130, '2014-04-01 00:32:56.000000', 'consum', 0.0220, 'lps'),
	(614636, 130, '2014-04-01 00:32:57.000000', 'consum', 0.0218, 'lps'),
	(614637, 130, '2014-04-01 00:32:58.000000', 'consum', 0.0211, 'lps'),
	(614638, 130, '2014-04-01 00:32:59.000000', 'consum', 0.0213, 'lps'),
	(614639, 130, '2014-04-01 00:33:00.000000', 'consum', 0.0210, 'lps'),
	(614640, 130, '2014-04-01 00:33:01.000000', 'consum', 0.0214, 'lps'),
	(614641, 130, '2014-04-01 00:33:02.000000', 'consum', 0.0219, 'lps'),
	(614642, 130, '2014-04-01 00:33:03.000000', 'consum', 0.0218, 'lps'),
	(614643, 130, '2014-04-01 00:33:04.000000', 'consum', 0.0215, 'lps'),
	(614644, 130, '2014-04-01 00:33:05.000000', 'consum', 0.0220, 'lps'),
	(614645, 130, '2014-04-01 00:33:06.000000', 'consum', 0.0210, 'lps'),
	(614646, 130, '2014-04-01 00:33:07.000000', 'consum', 0.0215, 'lps'),
	(614647, 130, '2014-04-01 00:33:08.000000', 'consum', 0.0214, 'lps'),
	(614648, 130, '2014-04-01 00:33:09.000000', 'consum', 0.0215, 'lps'),
	(614649, 130, '2014-04-01 00:33:10.000000', 'consum', 0.0213, 'lps'),
	(614650, 130, '2014-04-01 00:33:11.000000', 'consum', 0.0211, 'lps'),
	(614651, 130, '2014-04-01 00:33:12.000000', 'consum', 0.0218, 'lps'),
	(614652, 130, '2014-04-01 00:33:13.000000', 'consum', 0.0212, 'lps'),
	(614653, 130, '2014-04-01 00:33:14.000000', 'consum', 0.0220, 'lps'),
	(614654, 130, '2014-04-01 00:33:15.000000', 'consum', 0.0220, 'lps'),
	(614655, 130, '2014-04-01 00:33:16.000000', 'consum', 0.0218, 'lps'),
	(614656, 130, '2014-04-01 00:33:17.000000', 'consum', 0.0220, 'lps'),
	(614657, 130, '2014-04-01 00:33:18.000000', 'consum', 0.0211, 'lps'),
	(614658, 130, '2014-04-01 00:33:19.000000', 'consum', 0.0211, 'lps'),
	(614659, 130, '2014-04-01 00:33:20.000000', 'consum', 0.0211, 'lps'),
	(614660, 130, '2014-04-01 00:33:21.000000', 'consum', 0.0215, 'lps'),
	(614661, 130, '2014-04-01 00:33:22.000000', 'consum', 0.0218, 'lps'),
	(614662, 130, '2014-04-01 00:33:23.000000', 'consum', 0.0211, 'lps'),
	(614663, 130, '2014-04-01 00:33:24.000000', 'consum', 0.0218, 'lps'),
	(614664, 130, '2014-04-01 00:33:25.000000', 'consum', 0.0210, 'lps'),
	(614665, 130, '2014-04-01 00:33:26.000000', 'consum', 0.0210, 'lps'),
	(614666, 130, '2014-04-01 00:33:27.000000', 'consum', 0.0212, 'lps'),
	(614667, 130, '2014-04-01 00:33:28.000000', 'consum', 0.0221, 'lps'),
	(614668, 130, '2014-04-01 00:33:29.000000', 'consum', 0.0221, 'lps'),
	(614669, 130, '2014-04-01 00:33:30.000000', 'consum', 0.0211, 'lps'),
	(614670, 130, '2014-04-01 00:33:31.000000', 'consum', 0.0217, 'lps'),
	(614671, 130, '2014-04-01 00:33:32.000000', 'consum', 0.0219, 'lps'),
	(614672, 130, '2014-04-01 00:33:33.000000', 'consum', 0.0221, 'lps'),
	(614673, 130, '2014-04-01 00:33:34.000000', 'consum', 0.0214, 'lps'),
	(614674, 130, '2014-04-01 00:33:35.000000', 'consum', 0.0211, 'lps'),
	(614675, 130, '2014-04-01 00:33:36.000000', 'consum', 0.0217, 'lps'),
	(614676, 130, '2014-04-01 00:33:37.000000', 'consum', 0.0218, 'lps'),
	(614677, 130, '2014-04-01 00:33:38.000000', 'consum', 0.0216, 'lps'),
	(614678, 130, '2014-04-01 00:33:39.000000', 'consum', 0.0216, 'lps'),
	(614679, 130, '2014-04-01 00:33:40.000000', 'consum', 0.0213, 'lps'),
	(614680, 130, '2014-04-01 00:33:41.000000', 'consum', 0.0218, 'lps'),
	(614681, 130, '2014-04-01 00:33:42.000000', 'consum', 0.0216, 'lps'),
	(614682, 130, '2014-04-01 00:33:43.000000', 'consum', 0.0219, 'lps'),
	(614683, 130, '2014-04-01 00:33:44.000000', 'consum', 0.0213, 'lps'),
	(614684, 130, '2014-04-01 00:33:45.000000', 'consum', 0.0210, 'lps'),
	(614685, 130, '2014-04-01 00:33:46.000000', 'consum', 0.0215, 'lps'),
	(614686, 130, '2014-04-01 00:33:47.000000', 'consum', 0.0212, 'lps'),
	(614687, 130, '2014-04-01 00:33:48.000000', 'consum', 0.0217, 'lps'),
	(614688, 130, '2014-04-01 00:33:49.000000', 'consum', 0.0214, 'lps'),
	(614689, 130, '2014-04-01 00:33:50.000000', 'consum', 0.0210, 'lps'),
	(614690, 130, '2014-04-01 00:33:51.000000', 'consum', 0.0212, 'lps'),
	(614691, 130, '2014-04-01 00:33:52.000000', 'consum', 0.0219, 'lps'),
	(614692, 130, '2014-04-01 00:33:53.000000', 'consum', 0.0214, 'lps'),
	(614693, 130, '2014-04-01 00:33:54.000000', 'consum', 0.0215, 'lps'),
	(614694, 130, '2014-04-01 00:33:55.000000', 'consum', 0.0213, 'lps'),
	(614695, 130, '2014-04-01 00:33:56.000000', 'consum', 0.0210, 'lps'),
	(614696, 130, '2014-04-01 00:33:57.000000', 'consum', 0.0213, 'lps'),
	(614697, 130, '2014-04-01 00:33:58.000000', 'consum', 0.0215, 'lps'),
	(614698, 130, '2014-04-01 00:33:59.000000', 'consum', 0.0214, 'lps'),
	(614699, 130, '2014-04-01 00:34:00.000000', 'consum', 0.0215, 'lps'),
	(614700, 130, '2014-04-01 00:34:01.000000', 'consum', 0.0214, 'lps'),
	(614701, 130, '2014-04-01 00:34:02.000000', 'consum', 0.0212, 'lps'),
	(614702, 130, '2014-04-01 00:34:03.000000', 'consum', 0.0212, 'lps'),
	(614703, 130, '2014-04-01 00:34:04.000000', 'consum', 0.0211, 'lps'),
	(614704, 130, '2014-04-01 00:34:05.000000', 'consum', 0.0210, 'lps'),
	(614705, 130, '2014-04-01 00:34:06.000000', 'consum', 0.0220, 'lps'),
	(614706, 130, '2014-04-01 00:34:07.000000', 'consum', 0.0214, 'lps'),
	(614707, 130, '2014-04-01 00:34:08.000000', 'consum', 0.0213, 'lps'),
	(614708, 130, '2014-04-01 00:34:09.000000', 'consum', 0.0211, 'lps'),
	(614709, 130, '2014-04-01 00:34:10.000000', 'consum', 0.0219, 'lps'),
	(614710, 130, '2014-04-01 00:34:11.000000', 'consum', 0.0218, 'lps'),
	(614711, 130, '2014-04-01 00:34:12.000000', 'consum', 0.0210, 'lps'),
	(614712, 130, '2014-04-01 00:34:13.000000', 'consum', 0.0210, 'lps'),
	(614713, 130, '2014-04-01 00:34:14.000000', 'consum', 0.0211, 'lps'),
	(614714, 130, '2014-04-01 00:34:15.000000', 'consum', 0.0215, 'lps'),
	(614715, 130, '2014-04-01 00:34:16.000000', 'consum', 0.0220, 'lps'),
	(614716, 130, '2014-04-01 00:34:17.000000', 'consum', 0.0220, 'lps'),
	(614717, 130, '2014-04-01 00:34:18.000000', 'consum', 0.0221, 'lps'),
	(614718, 130, '2014-04-01 00:34:19.000000', 'consum', 0.0213, 'lps'),
	(614719, 130, '2014-04-01 00:34:20.000000', 'consum', 0.0213, 'lps'),
	(614720, 130, '2014-04-01 00:34:21.000000', 'consum', 0.0219, 'lps'),
	(614721, 130, '2014-04-01 00:34:22.000000', 'consum', 0.0211, 'lps'),
	(614722, 130, '2014-04-01 00:34:23.000000', 'consum', 0.0212, 'lps'),
	(614723, 130, '2014-04-01 00:34:24.000000', 'consum', 0.0217, 'lps'),
	(614724, 130, '2014-04-01 00:34:25.000000', 'consum', 0.0217, 'lps'),
	(614725, 130, '2014-04-01 00:34:26.000000', 'consum', 0.0212, 'lps'),
	(614726, 130, '2014-04-01 00:34:27.000000', 'consum', 0.0211, 'lps'),
	(614727, 130, '2014-04-01 00:34:28.000000', 'consum', 0.0221, 'lps'),
	(614728, 130, '2014-04-01 00:34:29.000000', 'consum', 0.0216, 'lps'),
	(614729, 130, '2014-04-01 00:34:30.000000', 'consum', 0.0218, 'lps'),
	(614730, 130, '2014-04-01 00:34:31.000000', 'consum', 0.0220, 'lps'),
	(614731, 130, '2014-04-01 00:34:32.000000', 'consum', 0.0215, 'lps'),
	(614732, 130, '2014-04-01 00:34:33.000000', 'consum', 0.0217, 'lps'),
	(614733, 130, '2014-04-01 00:34:34.000000', 'consum', 0.0218, 'lps'),
	(614734, 130, '2014-04-01 00:34:35.000000', 'consum', 0.0220, 'lps'),
	(614735, 130, '2014-04-01 00:34:36.000000', 'consum', 0.0221, 'lps'),
	(614736, 130, '2014-04-01 00:34:37.000000', 'consum', 0.0212, 'lps'),
	(614737, 130, '2014-04-01 00:34:38.000000', 'consum', 0.0213, 'lps'),
	(614738, 130, '2014-04-01 00:34:39.000000', 'consum', 0.0219, 'lps'),
	(614739, 130, '2014-04-01 00:34:40.000000', 'consum', 0.0210, 'lps'),
	(614740, 130, '2014-04-01 00:34:41.000000', 'consum', 0.0220, 'lps'),
	(614741, 130, '2014-04-01 00:34:42.000000', 'consum', 0.0212, 'lps'),
	(614742, 130, '2014-04-01 00:34:43.000000', 'consum', 0.0214, 'lps'),
	(614743, 130, '2014-04-01 00:34:44.000000', 'consum', 0.0213, 'lps'),
	(614744, 130, '2014-04-01 00:34:45.000000', 'consum', 0.0211, 'lps'),
	(614745, 130, '2014-04-01 00:34:46.000000', 'consum', 0.0210, 'lps'),
	(614746, 130, '2014-04-01 00:34:47.000000', 'consum', 0.0219, 'lps'),
	(614747, 130, '2014-04-01 00:34:48.000000', 'consum', 0.0219, 'lps'),
	(614748, 130, '2014-04-01 00:34:49.000000', 'consum', 0.0216, 'lps'),
	(614749, 130, '2014-04-01 00:34:50.000000', 'consum', 0.0215, 'lps'),
	(614750, 130, '2014-04-01 00:34:51.000000', 'consum', 0.0216, 'lps'),
	(614751, 130, '2014-04-01 00:34:52.000000', 'consum', 0.0214, 'lps'),
	(614752, 130, '2014-04-01 00:34:53.000000', 'consum', 0.0211, 'lps'),
	(614753, 130, '2014-04-01 00:34:54.000000', 'consum', 0.0218, 'lps'),
	(614754, 130, '2014-04-01 00:34:55.000000', 'consum', 0.0221, 'lps'),
	(614755, 130, '2014-04-01 00:34:56.000000', 'consum', 0.0217, 'lps'),
	(614756, 130, '2014-04-01 00:34:57.000000', 'consum', 0.0212, 'lps'),
	(614757, 130, '2014-04-01 00:34:58.000000', 'consum', 0.0214, 'lps'),
	(614758, 130, '2014-04-01 00:34:59.000000', 'consum', 0.0213, 'lps'),
	(614759, 130, '2014-04-01 00:35:00.000000', 'consum', 0.0213, 'lps'),
	(614760, 130, '2014-04-01 00:35:01.000000', 'consum', 0.0218, 'lps'),
	(614761, 130, '2014-04-01 00:35:02.000000', 'consum', 0.0216, 'lps'),
	(614762, 130, '2014-04-01 00:35:03.000000', 'consum', 0.0217, 'lps'),
	(614763, 130, '2014-04-01 00:35:04.000000', 'consum', 0.0217, 'lps'),
	(614764, 130, '2014-04-01 00:35:05.000000', 'consum', 0.0213, 'lps'),
	(614765, 130, '2014-04-01 00:35:06.000000', 'consum', 0.0215, 'lps'),
	(614766, 130, '2014-04-01 00:35:07.000000', 'consum', 0.0214, 'lps'),
	(614767, 130, '2014-04-01 00:35:08.000000', 'consum', 0.0218, 'lps'),
	(614768, 130, '2014-04-01 00:35:09.000000', 'consum', 0.0212, 'lps'),
	(614769, 130, '2014-04-01 00:35:10.000000', 'consum', 0.0221, 'lps'),
	(614770, 130, '2014-04-01 00:35:11.000000', 'consum', 0.0213, 'lps'),
	(614771, 130, '2014-04-01 00:35:12.000000', 'consum', 0.0217, 'lps'),
	(614772, 130, '2014-04-01 00:35:13.000000', 'consum', 0.0212, 'lps'),
	(614773, 130, '2014-04-01 00:35:14.000000', 'consum', 0.0211, 'lps'),
	(614774, 130, '2014-04-01 00:35:15.000000', 'consum', 0.0211, 'lps'),
	(614775, 130, '2014-04-01 00:35:16.000000', 'consum', 0.0212, 'lps'),
	(614776, 130, '2014-04-01 00:35:17.000000', 'consum', 0.0216, 'lps'),
	(614777, 130, '2014-04-01 00:35:18.000000', 'consum', 0.0211, 'lps'),
	(614778, 130, '2014-04-01 00:35:19.000000', 'consum', 0.0221, 'lps'),
	(614779, 130, '2014-04-01 00:35:20.000000', 'consum', 0.0214, 'lps'),
	(614780, 130, '2014-04-01 00:35:21.000000', 'consum', 0.0210, 'lps'),
	(614781, 130, '2014-04-01 00:35:22.000000', 'consum', 0.0211, 'lps'),
	(614782, 130, '2014-04-01 00:35:23.000000', 'consum', 0.0216, 'lps'),
	(614783, 130, '2014-04-01 00:35:24.000000', 'consum', 0.0213, 'lps'),
	(614784, 130, '2014-04-01 00:35:25.000000', 'consum', 0.0218, 'lps'),
	(614785, 130, '2014-04-01 00:35:26.000000', 'consum', 0.0220, 'lps'),
	(614786, 130, '2014-04-01 00:35:27.000000', 'consum', 0.0213, 'lps'),
	(614787, 130, '2014-04-01 00:35:28.000000', 'consum', 0.0217, 'lps'),
	(614788, 130, '2014-04-01 00:35:29.000000', 'consum', 0.0212, 'lps'),
	(614789, 130, '2014-04-01 00:35:30.000000', 'consum', 0.0211, 'lps'),
	(614790, 130, '2014-04-01 00:35:31.000000', 'consum', 0.0221, 'lps'),
	(614791, 130, '2014-04-01 00:35:32.000000', 'consum', 0.0216, 'lps'),
	(614792, 130, '2014-04-01 00:35:33.000000', 'consum', 0.0220, 'lps'),
	(614793, 130, '2014-04-01 00:35:34.000000', 'consum', 0.0219, 'lps'),
	(614794, 130, '2014-04-01 00:35:35.000000', 'consum', 0.0211, 'lps'),
	(614795, 130, '2014-04-01 00:35:36.000000', 'consum', 0.0214, 'lps'),
	(614796, 130, '2014-04-01 00:35:37.000000', 'consum', 0.0217, 'lps'),
	(614797, 130, '2014-04-01 00:35:38.000000', 'consum', 0.0210, 'lps'),
	(614798, 130, '2014-04-01 00:35:39.000000', 'consum', 0.0213, 'lps'),
	(614799, 130, '2014-04-01 00:35:40.000000', 'consum', 0.0215, 'lps'),
	(614800, 130, '2014-04-01 00:35:41.000000', 'consum', 0.0213, 'lps'),
	(614801, 130, '2014-04-01 00:35:42.000000', 'consum', 0.0211, 'lps'),
	(614802, 130, '2014-04-01 00:35:43.000000', 'consum', 0.0217, 'lps'),
	(614803, 130, '2014-04-01 00:35:44.000000', 'consum', 0.0220, 'lps'),
	(614804, 130, '2014-04-01 00:35:45.000000', 'consum', 0.0217, 'lps'),
	(614805, 130, '2014-04-01 00:35:46.000000', 'consum', 0.0213, 'lps'),
	(614806, 130, '2014-04-01 00:35:47.000000', 'consum', 0.0219, 'lps'),
	(614807, 130, '2014-04-01 00:35:48.000000', 'consum', 0.0220, 'lps'),
	(614808, 130, '2014-04-01 00:35:49.000000', 'consum', 0.0221, 'lps'),
	(614809, 130, '2014-04-01 00:35:50.000000', 'consum', 0.0213, 'lps'),
	(614810, 130, '2014-04-01 00:35:51.000000', 'consum', 0.0218, 'lps'),
	(614811, 130, '2014-04-01 00:35:52.000000', 'consum', 0.0215, 'lps'),
	(614812, 130, '2014-04-01 00:35:53.000000', 'consum', 0.0212, 'lps'),
	(614813, 130, '2014-04-01 00:35:54.000000', 'consum', 0.0219, 'lps'),
	(614814, 130, '2014-04-01 00:35:55.000000', 'consum', 0.0213, 'lps'),
	(614815, 130, '2014-04-01 00:35:56.000000', 'consum', 0.0221, 'lps'),
	(614816, 130, '2014-04-01 00:35:57.000000', 'consum', 0.0211, 'lps'),
	(614817, 130, '2014-04-01 00:35:58.000000', 'consum', 0.0218, 'lps'),
	(614818, 130, '2014-04-01 00:35:59.000000', 'consum', 0.0212, 'lps'),
	(614819, 130, '2014-04-01 00:36:00.000000', 'consum', 0.0220, 'lps'),
	(614820, 130, '2014-04-01 00:36:01.000000', 'consum', 0.0218, 'lps'),
	(614821, 130, '2014-04-01 00:36:02.000000', 'consum', 0.0219, 'lps'),
	(614822, 130, '2014-04-01 00:36:03.000000', 'consum', 0.0220, 'lps'),
	(614823, 130, '2014-04-01 00:36:04.000000', 'consum', 0.0220, 'lps'),
	(614824, 130, '2014-04-01 00:36:05.000000', 'consum', 0.0220, 'lps'),
	(614825, 130, '2014-04-01 00:36:06.000000', 'consum', 0.0220, 'lps'),
	(614826, 130, '2014-04-01 00:36:07.000000', 'consum', 0.0216, 'lps'),
	(614827, 130, '2014-04-01 00:36:08.000000', 'consum', 0.0211, 'lps'),
	(614828, 130, '2014-04-01 00:36:09.000000', 'consum', 0.0211, 'lps'),
	(614829, 130, '2014-04-01 00:36:10.000000', 'consum', 0.0211, 'lps'),
	(614830, 130, '2014-04-01 00:36:11.000000', 'consum', 0.0215, 'lps'),
	(614831, 130, '2014-04-01 00:36:12.000000', 'consum', 0.0217, 'lps'),
	(614832, 130, '2014-04-01 00:36:13.000000', 'consum', 0.0221, 'lps'),
	(614833, 130, '2014-04-01 00:36:14.000000', 'consum', 0.0218, 'lps'),
	(614834, 130, '2014-04-01 00:36:15.000000', 'consum', 0.0220, 'lps'),
	(614835, 130, '2014-04-01 00:36:16.000000', 'consum', 0.0210, 'lps'),
	(614836, 130, '2014-04-01 00:36:17.000000', 'consum', 0.0217, 'lps'),
	(614837, 130, '2014-04-01 00:36:18.000000', 'consum', 0.0212, 'lps'),
	(614838, 130, '2014-04-01 00:36:19.000000', 'consum', 0.0210, 'lps'),
	(614839, 130, '2014-04-01 00:36:20.000000', 'consum', 0.0216, 'lps'),
	(614840, 130, '2014-04-01 00:36:21.000000', 'consum', 0.0215, 'lps'),
	(614841, 130, '2014-04-01 00:36:22.000000', 'consum', 0.0218, 'lps'),
	(614842, 130, '2014-04-01 00:36:23.000000', 'consum', 0.0211, 'lps'),
	(614843, 130, '2014-04-01 00:36:24.000000', 'consum', 0.0214, 'lps'),
	(614844, 130, '2014-04-01 00:36:25.000000', 'consum', 0.0219, 'lps'),
	(614845, 130, '2014-04-01 00:36:26.000000', 'consum', 0.0218, 'lps'),
	(614846, 130, '2014-04-01 00:36:27.000000', 'consum', 0.0213, 'lps'),
	(614847, 130, '2014-04-01 00:36:28.000000', 'consum', 0.0211, 'lps'),
	(614848, 130, '2014-04-01 00:36:29.000000', 'consum', 0.0221, 'lps'),
	(614849, 130, '2014-04-01 00:36:30.000000', 'consum', 0.0215, 'lps'),
	(614850, 130, '2014-04-01 00:36:31.000000', 'consum', 0.0216, 'lps'),
	(614851, 130, '2014-04-01 00:36:32.000000', 'consum', 0.0210, 'lps'),
	(614852, 130, '2014-04-01 00:36:33.000000', 'consum', 0.0216, 'lps'),
	(614853, 130, '2014-04-01 00:36:34.000000', 'consum', 0.0219, 'lps'),
	(614854, 130, '2014-04-01 00:36:35.000000', 'consum', 0.0212, 'lps'),
	(614855, 130, '2014-04-01 00:36:36.000000', 'consum', 0.0219, 'lps'),
	(614856, 130, '2014-04-01 00:36:37.000000', 'consum', 0.0212, 'lps'),
	(614857, 130, '2014-04-01 00:36:38.000000', 'consum', 0.0219, 'lps'),
	(614858, 130, '2014-04-01 00:36:39.000000', 'consum', 0.0214, 'lps'),
	(614859, 130, '2014-04-01 00:36:40.000000', 'consum', 0.0214, 'lps'),
	(614860, 130, '2014-04-01 00:36:41.000000', 'consum', 0.0218, 'lps'),
	(614861, 130, '2014-04-01 00:36:42.000000', 'consum', 0.0217, 'lps'),
	(614862, 130, '2014-04-01 00:36:43.000000', 'consum', 0.0220, 'lps'),
	(614863, 130, '2014-04-01 00:36:44.000000', 'consum', 0.0216, 'lps'),
	(614864, 130, '2014-04-01 00:36:45.000000', 'consum', 0.0221, 'lps'),
	(614865, 130, '2014-04-01 00:36:46.000000', 'consum', 0.0211, 'lps'),
	(614866, 130, '2014-04-01 00:36:47.000000', 'consum', 0.0221, 'lps'),
	(614867, 130, '2014-04-01 00:36:48.000000', 'consum', 0.0214, 'lps'),
	(614868, 130, '2014-04-01 00:36:49.000000', 'consum', 0.0219, 'lps'),
	(614869, 130, '2014-04-01 00:36:50.000000', 'consum', 0.0221, 'lps'),
	(614870, 130, '2014-04-01 00:36:51.000000', 'consum', 0.0216, 'lps'),
	(614871, 130, '2014-04-01 00:36:52.000000', 'consum', 0.0217, 'lps'),
	(614872, 130, '2014-04-01 00:36:53.000000', 'consum', 0.0214, 'lps'),
	(614873, 130, '2014-04-01 00:36:54.000000', 'consum', 0.0213, 'lps'),
	(614874, 130, '2014-04-01 00:36:55.000000', 'consum', 0.0211, 'lps'),
	(614875, 130, '2014-04-01 00:36:56.000000', 'consum', 0.0221, 'lps'),
	(614876, 130, '2014-04-01 00:36:57.000000', 'consum', 0.0212, 'lps'),
	(614877, 130, '2014-04-01 00:36:58.000000', 'consum', 0.0214, 'lps'),
	(614878, 130, '2014-04-01 00:36:59.000000', 'consum', 0.0213, 'lps'),
	(614879, 130, '2014-04-01 00:37:00.000000', 'consum', 0.0211, 'lps'),
	(614880, 130, '2014-04-01 00:37:01.000000', 'consum', 0.0220, 'lps'),
	(614881, 130, '2014-04-01 00:37:02.000000', 'consum', 0.0220, 'lps'),
	(614882, 130, '2014-04-01 00:37:03.000000', 'consum', 0.0219, 'lps'),
	(614883, 130, '2014-04-01 00:37:04.000000', 'consum', 0.0214, 'lps'),
	(614884, 130, '2014-04-01 00:37:05.000000', 'consum', 0.0213, 'lps'),
	(614885, 130, '2014-04-01 00:37:06.000000', 'consum', 0.0217, 'lps'),
	(614886, 130, '2014-04-01 00:37:07.000000', 'consum', 0.0212, 'lps'),
	(614887, 130, '2014-04-01 00:37:08.000000', 'consum', 0.0211, 'lps'),
	(614888, 130, '2014-04-01 00:37:09.000000', 'consum', 0.0221, 'lps'),
	(614889, 130, '2014-04-01 00:37:10.000000', 'consum', 0.0216, 'lps'),
	(614890, 130, '2014-04-01 00:37:11.000000', 'consum', 0.0218, 'lps'),
	(614891, 130, '2014-04-01 00:37:12.000000', 'consum', 0.0210, 'lps'),
	(614892, 130, '2014-04-01 00:37:13.000000', 'consum', 0.0211, 'lps'),
	(614893, 130, '2014-04-01 00:37:14.000000', 'consum', 0.0215, 'lps'),
	(614894, 130, '2014-04-01 00:37:15.000000', 'consum', 0.0218, 'lps'),
	(614895, 130, '2014-04-01 00:37:16.000000', 'consum', 0.0215, 'lps'),
	(614896, 130, '2014-04-01 00:37:17.000000', 'consum', 0.0211, 'lps'),
	(614897, 130, '2014-04-01 00:37:18.000000', 'consum', 0.0211, 'lps'),
	(614898, 130, '2014-04-01 00:37:19.000000', 'consum', 0.0215, 'lps'),
	(614899, 130, '2014-04-01 00:37:20.000000', 'consum', 0.0217, 'lps'),
	(614900, 130, '2014-04-01 00:37:21.000000', 'consum', 0.0210, 'lps'),
	(614901, 130, '2014-04-01 00:37:22.000000', 'consum', 0.0213, 'lps'),
	(614902, 130, '2014-04-01 00:37:23.000000', 'consum', 0.0211, 'lps'),
	(614903, 130, '2014-04-01 00:37:24.000000', 'consum', 0.0219, 'lps'),
	(614904, 130, '2014-04-01 00:37:25.000000', 'consum', 0.0218, 'lps'),
	(614905, 130, '2014-04-01 00:37:26.000000', 'consum', 0.0210, 'lps'),
	(614906, 130, '2014-04-01 00:37:27.000000', 'consum', 0.0221, 'lps'),
	(614907, 130, '2014-04-01 00:37:28.000000', 'consum', 0.0221, 'lps'),
	(614908, 130, '2014-04-01 00:37:29.000000', 'consum', 0.0219, 'lps'),
	(614909, 130, '2014-04-01 00:37:30.000000', 'consum', 0.0211, 'lps'),
	(614910, 130, '2014-04-01 00:37:31.000000', 'consum', 0.0211, 'lps'),
	(614911, 130, '2014-04-01 00:37:32.000000', 'consum', 0.0212, 'lps'),
	(614912, 130, '2014-04-01 00:37:33.000000', 'consum', 0.0220, 'lps'),
	(614913, 130, '2014-04-01 00:37:34.000000', 'consum', 0.0218, 'lps'),
	(614914, 130, '2014-04-01 00:37:35.000000', 'consum', 0.0219, 'lps'),
	(614915, 130, '2014-04-01 00:37:36.000000', 'consum', 0.0221, 'lps'),
	(614916, 130, '2014-04-01 00:37:37.000000', 'consum', 0.0213, 'lps'),
	(614917, 130, '2014-04-01 00:37:38.000000', 'consum', 0.0217, 'lps'),
	(614918, 130, '2014-04-01 00:37:39.000000', 'consum', 0.0215, 'lps'),
	(614919, 130, '2014-04-01 00:37:40.000000', 'consum', 0.0212, 'lps'),
	(614920, 130, '2014-04-01 00:37:41.000000', 'consum', 0.0217, 'lps'),
	(614921, 130, '2014-04-01 00:37:42.000000', 'consum', 0.0216, 'lps'),
	(614922, 130, '2014-04-01 00:37:43.000000', 'consum', 0.0218, 'lps'),
	(614923, 130, '2014-04-01 00:37:44.000000', 'consum', 0.0220, 'lps'),
	(614924, 130, '2014-04-01 00:37:45.000000', 'consum', 0.0215, 'lps'),
	(614925, 130, '2014-04-01 00:37:46.000000', 'consum', 0.0218, 'lps'),
	(614926, 130, '2014-04-01 00:37:47.000000', 'consum', 0.0212, 'lps'),
	(614927, 130, '2014-04-01 00:37:48.000000', 'consum', 0.0218, 'lps'),
	(614928, 130, '2014-04-01 00:37:49.000000', 'consum', 0.0210, 'lps'),
	(614929, 130, '2014-04-01 00:37:50.000000', 'consum', 0.0212, 'lps'),
	(614930, 130, '2014-04-01 00:37:51.000000', 'consum', 0.0218, 'lps'),
	(614931, 130, '2014-04-01 00:37:52.000000', 'consum', 0.0220, 'lps'),
	(614932, 130, '2014-04-01 00:37:53.000000', 'consum', 0.0213, 'lps'),
	(614933, 130, '2014-04-01 00:37:54.000000', 'consum', 0.0221, 'lps'),
	(614934, 130, '2014-04-01 00:37:55.000000', 'consum', 0.0220, 'lps'),
	(614935, 130, '2014-04-01 00:37:56.000000', 'consum', 0.0213, 'lps'),
	(614936, 130, '2014-04-01 00:37:57.000000', 'consum', 0.0210, 'lps'),
	(614937, 130, '2014-04-01 00:37:58.000000', 'consum', 0.0212, 'lps'),
	(614938, 130, '2014-04-01 00:37:59.000000', 'consum', 0.0210, 'lps'),
	(614939, 130, '2014-04-01 00:38:00.000000', 'consum', 0.0215, 'lps'),
	(614940, 130, '2014-04-01 00:38:01.000000', 'consum', 0.0210, 'lps'),
	(614941, 130, '2014-04-01 00:38:02.000000', 'consum', 0.0221, 'lps'),
	(614942, 130, '2014-04-01 00:38:03.000000', 'consum', 0.0218, 'lps'),
	(614943, 130, '2014-04-01 00:38:04.000000', 'consum', 0.0217, 'lps'),
	(614944, 130, '2014-04-01 00:38:05.000000', 'consum', 0.0212, 'lps'),
	(614945, 130, '2014-04-01 00:38:06.000000', 'consum', 0.0220, 'lps'),
	(614946, 130, '2014-04-01 00:38:07.000000', 'consum', 0.0221, 'lps'),
	(614947, 130, '2014-04-01 00:38:08.000000', 'consum', 0.0211, 'lps'),
	(614948, 130, '2014-04-01 00:38:09.000000', 'consum', 0.0220, 'lps'),
	(614949, 130, '2014-04-01 00:38:10.000000', 'consum', 0.0220, 'lps'),
	(614950, 130, '2014-04-01 00:38:11.000000', 'consum', 0.0217, 'lps'),
	(614951, 130, '2014-04-01 00:38:12.000000', 'consum', 0.0218, 'lps'),
	(614952, 130, '2014-04-01 00:38:13.000000', 'consum', 0.0217, 'lps'),
	(614953, 130, '2014-04-01 00:38:14.000000', 'consum', 0.0221, 'lps'),
	(614954, 130, '2014-04-01 00:38:15.000000', 'consum', 0.0220, 'lps'),
	(614955, 130, '2014-04-01 00:38:16.000000', 'consum', 0.0217, 'lps'),
	(614956, 130, '2014-04-01 00:38:17.000000', 'consum', 0.0215, 'lps'),
	(614957, 130, '2014-04-01 00:38:18.000000', 'consum', 0.0216, 'lps'),
	(614958, 130, '2014-04-01 00:38:19.000000', 'consum', 0.0214, 'lps'),
	(614959, 130, '2014-04-01 00:38:20.000000', 'consum', 0.0210, 'lps'),
	(614960, 130, '2014-04-01 00:38:21.000000', 'consum', 0.0210, 'lps'),
	(614961, 130, '2014-04-01 00:38:22.000000', 'consum', 0.0210, 'lps'),
	(614962, 130, '2014-04-01 00:38:23.000000', 'consum', 0.0212, 'lps'),
	(614963, 130, '2014-04-01 00:38:24.000000', 'consum', 0.0219, 'lps'),
	(614964, 130, '2014-04-01 00:38:25.000000', 'consum', 0.0216, 'lps'),
	(614965, 130, '2014-04-01 00:38:26.000000', 'consum', 0.0211, 'lps'),
	(614966, 130, '2014-04-01 00:38:27.000000', 'consum', 0.0221, 'lps'),
	(614967, 130, '2014-04-01 00:38:28.000000', 'consum', 0.0216, 'lps'),
	(614968, 130, '2014-04-01 00:38:29.000000', 'consum', 0.0218, 'lps'),
	(614969, 130, '2014-04-01 00:38:30.000000', 'consum', 0.0211, 'lps'),
	(614970, 130, '2014-04-01 00:38:31.000000', 'consum', 0.0216, 'lps'),
	(614971, 130, '2014-04-01 00:38:32.000000', 'consum', 0.0213, 'lps'),
	(614972, 130, '2014-04-01 00:38:33.000000', 'consum', 0.0220, 'lps'),
	(614973, 130, '2014-04-01 00:38:34.000000', 'consum', 0.0215, 'lps'),
	(614974, 130, '2014-04-01 00:38:35.000000', 'consum', 0.0217, 'lps'),
	(614975, 130, '2014-04-01 00:38:36.000000', 'consum', 0.0217, 'lps'),
	(614976, 130, '2014-04-01 00:38:37.000000', 'consum', 0.0213, 'lps'),
	(614977, 130, '2014-04-01 00:38:38.000000', 'consum', 0.0216, 'lps'),
	(614978, 130, '2014-04-01 00:38:39.000000', 'consum', 0.0210, 'lps'),
	(614979, 130, '2014-04-01 00:38:40.000000', 'consum', 0.0216, 'lps'),
	(614980, 130, '2014-04-01 00:38:41.000000', 'consum', 0.0216, 'lps'),
	(614981, 130, '2014-04-01 00:38:42.000000', 'consum', 0.0221, 'lps'),
	(614982, 130, '2014-04-01 00:38:43.000000', 'consum', 0.0211, 'lps'),
	(614983, 130, '2014-04-01 00:38:44.000000', 'consum', 0.0221, 'lps'),
	(614984, 130, '2014-04-01 00:38:45.000000', 'consum', 0.0212, 'lps'),
	(614985, 130, '2014-04-01 00:38:46.000000', 'consum', 0.0212, 'lps'),
	(614986, 130, '2014-04-01 00:38:47.000000', 'consum', 0.0213, 'lps'),
	(614987, 130, '2014-04-01 00:38:48.000000', 'consum', 0.0221, 'lps'),
	(614988, 130, '2014-04-01 00:38:49.000000', 'consum', 0.0210, 'lps'),
	(614989, 130, '2014-04-01 00:38:50.000000', 'consum', 0.0214, 'lps'),
	(614990, 130, '2014-04-01 00:38:51.000000', 'consum', 0.0219, 'lps'),
	(614991, 130, '2014-04-01 00:38:52.000000', 'consum', 0.0219, 'lps'),
	(614992, 130, '2014-04-01 00:38:53.000000', 'consum', 0.0217, 'lps'),
	(614993, 130, '2014-04-01 00:38:54.000000', 'consum', 0.0219, 'lps'),
	(614994, 130, '2014-04-01 00:38:55.000000', 'consum', 0.0220, 'lps'),
	(614995, 130, '2014-04-01 00:38:56.000000', 'consum', 0.0221, 'lps'),
	(614996, 130, '2014-04-01 00:38:57.000000', 'consum', 0.0214, 'lps'),
	(614997, 130, '2014-04-01 00:38:58.000000', 'consum', 0.0220, 'lps'),
	(614998, 130, '2014-04-01 00:38:59.000000', 'consum', 0.0212, 'lps'),
	(614999, 130, '2014-04-01 00:39:00.000000', 'consum', 0.0217, 'lps'),
	(615000, 130, '2014-04-01 00:39:01.000000', 'consum', 0.0214, 'lps'),
	(615001, 130, '2014-04-01 00:39:02.000000', 'consum', 0.0220, 'lps'),
	(615002, 130, '2014-04-01 00:39:03.000000', 'consum', 0.0213, 'lps'),
	(615003, 130, '2014-04-01 00:39:04.000000', 'consum', 0.0220, 'lps'),
	(615004, 130, '2014-04-01 00:39:05.000000', 'consum', 0.0214, 'lps'),
	(615005, 130, '2014-04-01 00:39:06.000000', 'consum', 0.0215, 'lps'),
	(615006, 130, '2014-04-01 00:39:07.000000', 'consum', 0.0221, 'lps'),
	(615007, 130, '2014-04-01 00:39:08.000000', 'consum', 0.0214, 'lps'),
	(615008, 130, '2014-04-01 00:39:09.000000', 'consum', 0.0221, 'lps'),
	(615009, 130, '2014-04-01 00:39:10.000000', 'consum', 0.0221, 'lps'),
	(615010, 130, '2014-04-01 00:39:11.000000', 'consum', 0.0218, 'lps'),
	(615011, 130, '2014-04-01 00:39:12.000000', 'consum', 0.0216, 'lps'),
	(615012, 130, '2014-04-01 00:39:13.000000', 'consum', 0.0219, 'lps'),
	(615013, 130, '2014-04-01 00:39:14.000000', 'consum', 0.0212, 'lps'),
	(615014, 130, '2014-04-01 00:39:15.000000', 'consum', 0.0220, 'lps'),
	(615015, 130, '2014-04-01 00:39:16.000000', 'consum', 0.0217, 'lps'),
	(615016, 130, '2014-04-01 00:39:17.000000', 'consum', 0.0214, 'lps'),
	(615017, 130, '2014-04-01 00:39:18.000000', 'consum', 0.0221, 'lps'),
	(615018, 130, '2014-04-01 00:39:19.000000', 'consum', 0.0218, 'lps'),
	(615019, 130, '2014-04-01 00:39:20.000000', 'consum', 0.0219, 'lps'),
	(615020, 130, '2014-04-01 00:39:21.000000', 'consum', 0.0220, 'lps'),
	(615021, 130, '2014-04-01 00:39:22.000000', 'consum', 0.0220, 'lps'),
	(615022, 130, '2014-04-01 00:39:23.000000', 'consum', 0.0219, 'lps'),
	(615023, 130, '2014-04-01 00:39:24.000000', 'consum', 0.0213, 'lps'),
	(615024, 130, '2014-04-01 00:39:25.000000', 'consum', 0.0211, 'lps'),
	(615025, 130, '2014-04-01 00:39:26.000000', 'consum', 0.0219, 'lps'),
	(615026, 130, '2014-04-01 00:39:27.000000', 'consum', 0.0217, 'lps'),
	(615027, 130, '2014-04-01 00:39:28.000000', 'consum', 0.0219, 'lps'),
	(615028, 130, '2014-04-01 00:39:29.000000', 'consum', 0.0210, 'lps'),
	(615029, 130, '2014-04-01 00:39:30.000000', 'consum', 0.0219, 'lps'),
	(615030, 130, '2014-04-01 00:39:31.000000', 'consum', 0.0219, 'lps'),
	(615031, 130, '2014-04-01 00:39:32.000000', 'consum', 0.0219, 'lps'),
	(615032, 130, '2014-04-01 00:39:33.000000', 'consum', 0.0213, 'lps'),
	(615033, 130, '2014-04-01 00:39:34.000000', 'consum', 0.0213, 'lps'),
	(615034, 130, '2014-04-01 00:39:35.000000', 'consum', 0.0215, 'lps'),
	(615035, 130, '2014-04-01 00:39:36.000000', 'consum', 0.0215, 'lps'),
	(615036, 130, '2014-04-01 00:39:37.000000', 'consum', 0.0221, 'lps'),
	(615037, 130, '2014-04-01 00:39:38.000000', 'consum', 0.0216, 'lps'),
	(615038, 130, '2014-04-01 00:39:39.000000', 'consum', 0.0217, 'lps'),
	(615039, 130, '2014-04-01 00:39:40.000000', 'consum', 0.0218, 'lps'),
	(615040, 130, '2014-04-01 00:39:41.000000', 'consum', 0.0214, 'lps'),
	(615041, 130, '2014-04-01 00:39:42.000000', 'consum', 0.0210, 'lps'),
	(615042, 130, '2014-04-01 00:39:43.000000', 'consum', 0.0221, 'lps'),
	(615043, 130, '2014-04-01 00:39:44.000000', 'consum', 0.0217, 'lps'),
	(615044, 130, '2014-04-01 00:39:45.000000', 'consum', 0.0212, 'lps'),
	(615045, 130, '2014-04-01 00:39:46.000000', 'consum', 0.0211, 'lps'),
	(615046, 130, '2014-04-01 00:39:47.000000', 'consum', 0.0210, 'lps'),
	(615047, 130, '2014-04-01 00:39:48.000000', 'consum', 0.0220, 'lps'),
	(615048, 130, '2014-04-01 00:39:49.000000', 'consum', 0.0213, 'lps'),
	(615049, 130, '2014-04-01 00:39:50.000000', 'consum', 0.0220, 'lps'),
	(615050, 130, '2014-04-01 00:39:51.000000', 'consum', 0.0214, 'lps'),
	(615051, 130, '2014-04-01 00:39:52.000000', 'consum', 0.0213, 'lps'),
	(615052, 130, '2014-04-01 00:39:53.000000', 'consum', 0.0214, 'lps'),
	(615053, 130, '2014-04-01 00:39:54.000000', 'consum', 0.0210, 'lps'),
	(615054, 130, '2014-04-01 00:39:55.000000', 'consum', 0.0211, 'lps'),
	(615055, 130, '2014-04-01 00:39:56.000000', 'consum', 0.0213, 'lps'),
	(615056, 130, '2014-04-01 00:39:57.000000', 'consum', 0.0211, 'lps'),
	(615057, 130, '2014-04-01 00:39:58.000000', 'consum', 0.0217, 'lps'),
	(615058, 130, '2014-04-01 00:39:59.000000', 'consum', 0.0210, 'lps'),
	(615059, 130, '2014-04-01 00:40:00.000000', 'consum', 0.0210, 'lps'),
	(615060, 130, '2014-04-01 00:40:01.000000', 'consum', 0.0211, 'lps'),
	(615061, 130, '2014-04-01 00:40:02.000000', 'consum', 0.0218, 'lps'),
	(615062, 130, '2014-04-01 00:40:03.000000', 'consum', 0.0211, 'lps'),
	(615063, 130, '2014-04-01 00:40:04.000000', 'consum', 0.0216, 'lps'),
	(615064, 130, '2014-04-01 00:40:05.000000', 'consum', 0.0212, 'lps'),
	(615065, 130, '2014-04-01 00:40:06.000000', 'consum', 0.0215, 'lps'),
	(615066, 130, '2014-04-01 00:40:07.000000', 'consum', 0.0218, 'lps'),
	(615067, 130, '2014-04-01 00:40:08.000000', 'consum', 0.0211, 'lps'),
	(615068, 130, '2014-04-01 00:40:09.000000', 'consum', 0.0216, 'lps'),
	(615069, 130, '2014-04-01 00:40:10.000000', 'consum', 0.0213, 'lps'),
	(615070, 130, '2014-04-01 00:40:11.000000', 'consum', 0.0221, 'lps'),
	(615071, 130, '2014-04-01 00:40:12.000000', 'consum', 0.0221, 'lps'),
	(615072, 130, '2014-04-01 00:40:13.000000', 'consum', 0.0221, 'lps'),
	(615073, 130, '2014-04-01 00:40:14.000000', 'consum', 0.0219, 'lps'),
	(615074, 130, '2014-04-01 00:40:15.000000', 'consum', 0.0211, 'lps'),
	(615075, 130, '2014-04-01 00:40:16.000000', 'consum', 0.0211, 'lps'),
	(615076, 130, '2014-04-01 00:40:17.000000', 'consum', 0.0214, 'lps'),
	(615077, 130, '2014-04-01 00:40:18.000000', 'consum', 0.0217, 'lps'),
	(615078, 130, '2014-04-01 00:40:19.000000', 'consum', 0.0219, 'lps'),
	(615079, 130, '2014-04-01 00:40:20.000000', 'consum', 0.0210, 'lps'),
	(615080, 130, '2014-04-01 00:40:21.000000', 'consum', 0.0219, 'lps'),
	(615081, 130, '2014-04-01 00:40:22.000000', 'consum', 0.0220, 'lps'),
	(615082, 130, '2014-04-01 00:40:23.000000', 'consum', 0.0210, 'lps'),
	(615083, 130, '2014-04-01 00:40:24.000000', 'consum', 0.0216, 'lps'),
	(615084, 130, '2014-04-01 00:40:25.000000', 'consum', 0.0217, 'lps'),
	(615085, 130, '2014-04-01 00:40:26.000000', 'consum', 0.0217, 'lps'),
	(615086, 130, '2014-04-01 00:40:27.000000', 'consum', 0.0212, 'lps'),
	(615087, 130, '2014-04-01 00:40:28.000000', 'consum', 0.0212, 'lps'),
	(615088, 130, '2014-04-01 00:40:29.000000', 'consum', 0.0215, 'lps'),
	(615089, 130, '2014-04-01 00:40:30.000000', 'consum', 0.0216, 'lps'),
	(615090, 130, '2014-04-01 00:40:31.000000', 'consum', 0.0214, 'lps'),
	(615091, 130, '2014-04-01 00:40:32.000000', 'consum', 0.0212, 'lps'),
	(615092, 130, '2014-04-01 00:40:33.000000', 'consum', 0.0210, 'lps'),
	(615093, 130, '2014-04-01 00:40:34.000000', 'consum', 0.0217, 'lps'),
	(615094, 130, '2014-04-01 00:40:35.000000', 'consum', 0.0221, 'lps'),
	(615095, 130, '2014-04-01 00:40:36.000000', 'consum', 0.0220, 'lps'),
	(615096, 130, '2014-04-01 00:40:37.000000', 'consum', 0.0215, 'lps'),
	(615097, 130, '2014-04-01 00:40:38.000000', 'consum', 0.0218, 'lps'),
	(615098, 130, '2014-04-01 00:40:39.000000', 'consum', 0.0212, 'lps'),
	(615099, 130, '2014-04-01 00:40:40.000000', 'consum', 0.0221, 'lps'),
	(615100, 130, '2014-04-01 00:40:41.000000', 'consum', 0.0221, 'lps'),
	(615101, 130, '2014-04-01 00:40:42.000000', 'consum', 0.0210, 'lps'),
	(615102, 130, '2014-04-01 00:40:43.000000', 'consum', 0.0212, 'lps'),
	(615103, 130, '2014-04-01 00:40:44.000000', 'consum', 0.0221, 'lps'),
	(615104, 130, '2014-04-01 00:40:45.000000', 'consum', 0.0211, 'lps'),
	(615105, 130, '2014-04-01 00:40:46.000000', 'consum', 0.0219, 'lps'),
	(615106, 130, '2014-04-01 00:40:47.000000', 'consum', 0.0217, 'lps'),
	(615107, 130, '2014-04-01 00:40:48.000000', 'consum', 0.0220, 'lps'),
	(615108, 130, '2014-04-01 00:40:49.000000', 'consum', 0.0213, 'lps'),
	(615109, 130, '2014-04-01 00:40:50.000000', 'consum', 0.0218, 'lps'),
	(615110, 130, '2014-04-01 00:40:51.000000', 'consum', 0.0221, 'lps'),
	(615111, 130, '2014-04-01 00:40:52.000000', 'consum', 0.0215, 'lps'),
	(615112, 130, '2014-04-01 00:40:53.000000', 'consum', 0.0216, 'lps'),
	(615113, 130, '2014-04-01 00:40:54.000000', 'consum', 0.0212, 'lps'),
	(615114, 130, '2014-04-01 00:40:55.000000', 'consum', 0.0215, 'lps'),
	(615115, 130, '2014-04-01 00:40:56.000000', 'consum', 0.0219, 'lps'),
	(615116, 130, '2014-04-01 00:40:57.000000', 'consum', 0.0215, 'lps'),
	(615117, 130, '2014-04-01 00:40:58.000000', 'consum', 0.0219, 'lps'),
	(615118, 130, '2014-04-01 00:40:59.000000', 'consum', 0.0218, 'lps'),
	(615119, 130, '2014-04-01 00:41:00.000000', 'consum', 0.0213, 'lps'),
	(615120, 130, '2014-04-01 00:41:01.000000', 'consum', 0.0214, 'lps'),
	(615121, 130, '2014-04-01 00:41:02.000000', 'consum', 0.0221, 'lps'),
	(615122, 130, '2014-04-01 00:41:03.000000', 'consum', 0.0219, 'lps'),
	(615123, 130, '2014-04-01 00:41:04.000000', 'consum', 0.0219, 'lps'),
	(615124, 130, '2014-04-01 00:41:05.000000', 'consum', 0.0219, 'lps'),
	(615125, 130, '2014-04-01 00:41:06.000000', 'consum', 0.0215, 'lps'),
	(615126, 130, '2014-04-01 00:41:07.000000', 'consum', 0.0211, 'lps'),
	(615127, 130, '2014-04-01 00:41:08.000000', 'consum', 0.0210, 'lps'),
	(615128, 130, '2014-04-01 00:41:09.000000', 'consum', 0.0210, 'lps'),
	(615129, 130, '2014-04-01 00:41:10.000000', 'consum', 0.0210, 'lps'),
	(615130, 130, '2014-04-01 00:41:11.000000', 'consum', 0.0221, 'lps'),
	(615131, 130, '2014-04-01 00:41:12.000000', 'consum', 0.0218, 'lps'),
	(615132, 130, '2014-04-01 00:41:13.000000', 'consum', 0.0219, 'lps'),
	(615133, 130, '2014-04-01 00:41:14.000000', 'consum', 0.0219, 'lps'),
	(615134, 130, '2014-04-01 00:41:15.000000', 'consum', 0.0218, 'lps'),
	(615135, 130, '2014-04-01 00:41:16.000000', 'consum', 0.0210, 'lps'),
	(615136, 130, '2014-04-01 00:41:17.000000', 'consum', 0.0210, 'lps'),
	(615137, 130, '2014-04-01 00:41:18.000000', 'consum', 0.0211, 'lps'),
	(615138, 130, '2014-04-01 00:41:19.000000', 'consum', 0.0214, 'lps'),
	(615139, 130, '2014-04-01 00:41:20.000000', 'consum', 0.0217, 'lps'),
	(615140, 130, '2014-04-01 00:41:21.000000', 'consum', 0.0220, 'lps'),
	(615141, 130, '2014-04-01 00:41:22.000000', 'consum', 0.0215, 'lps'),
	(615142, 130, '2014-04-01 00:41:23.000000', 'consum', 0.0218, 'lps'),
	(615143, 130, '2014-04-01 00:41:24.000000', 'consum', 0.0210, 'lps'),
	(615144, 130, '2014-04-01 00:41:25.000000', 'consum', 0.0212, 'lps'),
	(615145, 130, '2014-04-01 00:41:26.000000', 'consum', 0.0221, 'lps'),
	(615146, 130, '2014-04-01 00:41:27.000000', 'consum', 0.0221, 'lps'),
	(615147, 130, '2014-04-01 00:41:28.000000', 'consum', 0.0210, 'lps'),
	(615148, 130, '2014-04-01 00:41:29.000000', 'consum', 0.0214, 'lps'),
	(615149, 130, '2014-04-01 00:41:30.000000', 'consum', 0.0217, 'lps'),
	(615150, 130, '2014-04-01 00:41:31.000000', 'consum', 0.0220, 'lps'),
	(615151, 130, '2014-04-01 00:41:32.000000', 'consum', 0.0219, 'lps'),
	(615152, 130, '2014-04-01 00:41:33.000000', 'consum', 0.0213, 'lps'),
	(615153, 130, '2014-04-01 00:41:34.000000', 'consum', 0.0211, 'lps'),
	(615154, 130, '2014-04-01 00:41:35.000000', 'consum', 0.0216, 'lps'),
	(615155, 130, '2014-04-01 00:41:36.000000', 'consum', 0.0214, 'lps'),
	(615156, 130, '2014-04-01 00:41:37.000000', 'consum', 0.0212, 'lps'),
	(615157, 130, '2014-04-01 00:41:38.000000', 'consum', 0.0219, 'lps'),
	(615158, 130, '2014-04-01 00:41:39.000000', 'consum', 0.0217, 'lps'),
	(615159, 130, '2014-04-01 00:41:40.000000', 'consum', 0.0216, 'lps'),
	(615160, 130, '2014-04-01 00:41:41.000000', 'consum', 0.0219, 'lps'),
	(615161, 130, '2014-04-01 00:41:42.000000', 'consum', 0.0213, 'lps'),
	(615162, 130, '2014-04-01 00:41:43.000000', 'consum', 0.0210, 'lps'),
	(615163, 130, '2014-04-01 00:41:44.000000', 'consum', 0.0214, 'lps'),
	(615164, 130, '2014-04-01 00:41:45.000000', 'consum', 0.0220, 'lps'),
	(615165, 130, '2014-04-01 00:41:46.000000', 'consum', 0.0210, 'lps'),
	(615166, 130, '2014-04-01 00:41:47.000000', 'consum', 0.0219, 'lps'),
	(615167, 130, '2014-04-01 00:41:48.000000', 'consum', 0.0220, 'lps'),
	(615168, 130, '2014-04-01 00:41:49.000000', 'consum', 0.0221, 'lps'),
	(615169, 130, '2014-04-01 00:41:50.000000', 'consum', 0.0212, 'lps'),
	(615170, 130, '2014-04-01 00:41:51.000000', 'consum', 0.0212, 'lps'),
	(615171, 130, '2014-04-01 00:41:52.000000', 'consum', 0.0214, 'lps'),
	(615172, 130, '2014-04-01 00:41:53.000000', 'consum', 0.0214, 'lps'),
	(615173, 130, '2014-04-01 00:41:54.000000', 'consum', 0.0217, 'lps'),
	(615174, 130, '2014-04-01 00:41:55.000000', 'consum', 0.0221, 'lps'),
	(615175, 130, '2014-04-01 00:41:56.000000', 'consum', 0.0220, 'lps'),
	(615176, 130, '2014-04-01 00:41:57.000000', 'consum', 0.0216, 'lps'),
	(615177, 130, '2014-04-01 00:41:58.000000', 'consum', 0.0212, 'lps'),
	(615178, 130, '2014-04-01 00:41:59.000000', 'consum', 0.0215, 'lps'),
	(615179, 130, '2014-04-01 00:42:00.000000', 'consum', 0.0216, 'lps'),
	(615180, 130, '2014-04-01 00:42:01.000000', 'consum', 0.0213, 'lps'),
	(615181, 130, '2014-04-01 00:42:02.000000', 'consum', 0.0218, 'lps'),
	(615182, 130, '2014-04-01 00:42:03.000000', 'consum', 0.0220, 'lps'),
	(615183, 130, '2014-04-01 00:42:04.000000', 'consum', 0.0214, 'lps'),
	(615184, 130, '2014-04-01 00:42:05.000000', 'consum', 0.0210, 'lps'),
	(615185, 130, '2014-04-01 00:42:06.000000', 'consum', 0.0212, 'lps'),
	(615186, 130, '2014-04-01 00:42:07.000000', 'consum', 0.0220, 'lps'),
	(615187, 130, '2014-04-01 00:42:08.000000', 'consum', 0.0218, 'lps'),
	(615188, 130, '2014-04-01 00:42:09.000000', 'consum', 0.0210, 'lps'),
	(615189, 130, '2014-04-01 00:42:10.000000', 'consum', 0.0220, 'lps'),
	(615190, 130, '2014-04-01 00:42:11.000000', 'consum', 0.0214, 'lps'),
	(615191, 130, '2014-04-01 00:42:12.000000', 'consum', 0.0211, 'lps'),
	(615192, 130, '2014-04-01 00:42:13.000000', 'consum', 0.0216, 'lps'),
	(615193, 130, '2014-04-01 00:42:14.000000', 'consum', 0.0214, 'lps'),
	(615194, 130, '2014-04-01 00:42:15.000000', 'consum', 0.0210, 'lps'),
	(615195, 130, '2014-04-01 00:42:16.000000', 'consum', 0.0214, 'lps'),
	(615196, 130, '2014-04-01 00:42:17.000000', 'consum', 0.0217, 'lps'),
	(615197, 130, '2014-04-01 00:42:18.000000', 'consum', 0.0211, 'lps'),
	(615198, 130, '2014-04-01 00:42:19.000000', 'consum', 0.0217, 'lps'),
	(615199, 130, '2014-04-01 00:42:20.000000', 'consum', 0.0220, 'lps'),
	(615200, 130, '2014-04-01 00:42:21.000000', 'consum', 0.0216, 'lps'),
	(615201, 130, '2014-04-01 00:42:22.000000', 'consum', 0.0220, 'lps'),
	(615202, 130, '2014-04-01 00:42:23.000000', 'consum', 0.0220, 'lps'),
	(615203, 130, '2014-04-01 00:42:24.000000', 'consum', 0.0219, 'lps'),
	(615204, 130, '2014-04-01 00:42:25.000000', 'consum', 0.0211, 'lps'),
	(615205, 130, '2014-04-01 00:42:26.000000', 'consum', 0.0215, 'lps'),
	(615206, 130, '2014-04-01 00:42:27.000000', 'consum', 0.0220, 'lps'),
	(615207, 130, '2014-04-01 00:42:28.000000', 'consum', 0.0221, 'lps'),
	(615208, 130, '2014-04-01 00:42:29.000000', 'consum', 0.0212, 'lps'),
	(615209, 130, '2014-04-01 00:42:30.000000', 'consum', 0.0210, 'lps'),
	(615210, 130, '2014-04-01 00:42:31.000000', 'consum', 0.0216, 'lps'),
	(615211, 130, '2014-04-01 00:42:32.000000', 'consum', 0.0218, 'lps'),
	(615212, 130, '2014-04-01 00:42:33.000000', 'consum', 0.0210, 'lps'),
	(615213, 130, '2014-04-01 00:42:34.000000', 'consum', 0.0210, 'lps'),
	(615214, 130, '2014-04-01 00:42:35.000000', 'consum', 0.0220, 'lps'),
	(615215, 130, '2014-04-01 00:42:36.000000', 'consum', 0.0215, 'lps'),
	(615216, 130, '2014-04-01 00:42:37.000000', 'consum', 0.0218, 'lps'),
	(615217, 130, '2014-04-01 00:42:38.000000', 'consum', 0.0212, 'lps'),
	(615218, 130, '2014-04-01 00:42:39.000000', 'consum', 0.0219, 'lps'),
	(615219, 130, '2014-04-01 00:42:40.000000', 'consum', 0.0215, 'lps'),
	(615220, 130, '2014-04-01 00:42:41.000000', 'consum', 0.0218, 'lps'),
	(615221, 130, '2014-04-01 00:42:42.000000', 'consum', 0.0213, 'lps'),
	(615222, 130, '2014-04-01 00:42:43.000000', 'consum', 0.0212, 'lps'),
	(615223, 130, '2014-04-01 00:42:44.000000', 'consum', 0.0214, 'lps'),
	(615224, 130, '2014-04-01 00:42:45.000000', 'consum', 0.0210, 'lps'),
	(615225, 130, '2014-04-01 00:42:46.000000', 'consum', 0.0212, 'lps'),
	(615226, 130, '2014-04-01 00:42:47.000000', 'consum', 0.0220, 'lps'),
	(615227, 130, '2014-04-01 00:42:48.000000', 'consum', 0.0217, 'lps'),
	(615228, 130, '2014-04-01 00:42:49.000000', 'consum', 0.0217, 'lps'),
	(615229, 130, '2014-04-01 00:42:50.000000', 'consum', 0.0213, 'lps'),
	(615230, 130, '2014-04-01 00:42:51.000000', 'consum', 0.0214, 'lps'),
	(615231, 130, '2014-04-01 00:42:52.000000', 'consum', 0.0211, 'lps'),
	(615232, 130, '2014-04-01 00:42:53.000000', 'consum', 0.0214, 'lps'),
	(615233, 130, '2014-04-01 00:42:54.000000', 'consum', 0.0217, 'lps'),
	(615234, 130, '2014-04-01 00:42:55.000000', 'consum', 0.0221, 'lps'),
	(615235, 130, '2014-04-01 00:42:56.000000', 'consum', 0.0221, 'lps'),
	(615236, 130, '2014-04-01 00:42:57.000000', 'consum', 0.0220, 'lps'),
	(615237, 130, '2014-04-01 00:42:58.000000', 'consum', 0.0216, 'lps'),
	(615238, 130, '2014-04-01 00:42:59.000000', 'consum', 0.0210, 'lps'),
	(615239, 130, '2014-04-01 00:43:00.000000', 'consum', 0.0216, 'lps'),
	(615240, 130, '2014-04-01 00:43:01.000000', 'consum', 0.0219, 'lps'),
	(615241, 130, '2014-04-01 00:43:02.000000', 'consum', 0.0212, 'lps'),
	(615242, 130, '2014-04-01 00:43:03.000000', 'consum', 0.0218, 'lps'),
	(615243, 130, '2014-04-01 00:43:04.000000', 'consum', 0.0219, 'lps'),
	(615244, 130, '2014-04-01 00:43:05.000000', 'consum', 0.0220, 'lps'),
	(615245, 130, '2014-04-01 00:43:06.000000', 'consum', 0.0210, 'lps'),
	(615246, 130, '2014-04-01 00:43:07.000000', 'consum', 0.0214, 'lps'),
	(615247, 130, '2014-04-01 00:43:08.000000', 'consum', 0.0210, 'lps'),
	(615248, 130, '2014-04-01 00:43:09.000000', 'consum', 0.0220, 'lps'),
	(615249, 130, '2014-04-01 00:43:10.000000', 'consum', 0.0213, 'lps'),
	(615250, 130, '2014-04-01 00:43:11.000000', 'consum', 0.0221, 'lps'),
	(615251, 130, '2014-04-01 00:43:12.000000', 'consum', 0.0221, 'lps'),
	(615252, 130, '2014-04-01 00:43:13.000000', 'consum', 0.0219, 'lps'),
	(615253, 130, '2014-04-01 00:43:14.000000', 'consum', 0.0211, 'lps'),
	(615254, 130, '2014-04-01 00:43:15.000000', 'consum', 0.0213, 'lps'),
	(615255, 130, '2014-04-01 00:43:16.000000', 'consum', 0.0221, 'lps'),
	(615256, 130, '2014-04-01 00:43:17.000000', 'consum', 0.0220, 'lps'),
	(615257, 130, '2014-04-01 00:43:18.000000', 'consum', 0.0215, 'lps'),
	(615258, 130, '2014-04-01 00:43:19.000000', 'consum', 0.0220, 'lps'),
	(615259, 130, '2014-04-01 00:43:20.000000', 'consum', 0.0221, 'lps'),
	(615260, 130, '2014-04-01 00:43:21.000000', 'consum', 0.0212, 'lps'),
	(615261, 130, '2014-04-01 00:43:22.000000', 'consum', 0.0212, 'lps'),
	(615262, 130, '2014-04-01 00:43:23.000000', 'consum', 0.0212, 'lps'),
	(615263, 130, '2014-04-01 00:43:24.000000', 'consum', 0.0214, 'lps'),
	(615264, 130, '2014-04-01 00:43:25.000000', 'consum', 0.0215, 'lps'),
	(615265, 130, '2014-04-01 00:43:26.000000', 'consum', 0.0210, 'lps'),
	(615266, 130, '2014-04-01 00:43:27.000000', 'consum', 0.0221, 'lps'),
	(615267, 130, '2014-04-01 00:43:28.000000', 'consum', 0.0215, 'lps'),
	(615268, 130, '2014-04-01 00:43:29.000000', 'consum', 0.0217, 'lps'),
	(615269, 130, '2014-04-01 00:43:30.000000', 'consum', 0.0218, 'lps'),
	(615270, 130, '2014-04-01 00:43:31.000000', 'consum', 0.0218, 'lps'),
	(615271, 130, '2014-04-01 00:43:32.000000', 'consum', 0.0212, 'lps'),
	(615272, 130, '2014-04-01 00:43:33.000000', 'consum', 0.0211, 'lps'),
	(615273, 130, '2014-04-01 00:43:34.000000', 'consum', 0.0211, 'lps'),
	(615274, 130, '2014-04-01 00:43:35.000000', 'consum', 0.0210, 'lps'),
	(615275, 130, '2014-04-01 00:43:36.000000', 'consum', 0.0220, 'lps'),
	(615276, 130, '2014-04-01 00:43:37.000000', 'consum', 0.0212, 'lps'),
	(615277, 130, '2014-04-01 00:43:38.000000', 'consum', 0.0216, 'lps'),
	(615278, 130, '2014-04-01 00:43:39.000000', 'consum', 0.0211, 'lps'),
	(615279, 130, '2014-04-01 00:43:40.000000', 'consum', 0.0220, 'lps'),
	(615280, 130, '2014-04-01 00:43:41.000000', 'consum', 0.0211, 'lps'),
	(615281, 130, '2014-04-01 00:43:42.000000', 'consum', 0.0221, 'lps'),
	(615282, 130, '2014-04-01 00:43:43.000000', 'consum', 0.0215, 'lps'),
	(615283, 130, '2014-04-01 00:43:44.000000', 'consum', 0.0212, 'lps'),
	(615284, 130, '2014-04-01 00:43:45.000000', 'consum', 0.0219, 'lps'),
	(615285, 130, '2014-04-01 00:43:46.000000', 'consum', 0.0212, 'lps'),
	(615286, 130, '2014-04-01 00:43:47.000000', 'consum', 0.0217, 'lps'),
	(615287, 130, '2014-04-01 00:43:48.000000', 'consum', 0.0215, 'lps'),
	(615288, 130, '2014-04-01 00:43:49.000000', 'consum', 0.0217, 'lps'),
	(615289, 130, '2014-04-01 00:43:50.000000', 'consum', 0.0217, 'lps'),
	(615290, 130, '2014-04-01 00:43:51.000000', 'consum', 0.0214, 'lps'),
	(615291, 130, '2014-04-01 00:43:52.000000', 'consum', 0.0219, 'lps'),
	(615292, 130, '2014-04-01 00:43:53.000000', 'consum', 0.0220, 'lps'),
	(615293, 130, '2014-04-01 00:43:54.000000', 'consum', 0.0221, 'lps'),
	(615294, 130, '2014-04-01 00:43:55.000000', 'consum', 0.0214, 'lps'),
	(615295, 130, '2014-04-01 00:43:56.000000', 'consum', 0.0219, 'lps'),
	(615296, 130, '2014-04-01 00:43:57.000000', 'consum', 0.0210, 'lps'),
	(615297, 130, '2014-04-01 00:43:58.000000', 'consum', 0.0220, 'lps'),
	(615298, 130, '2014-04-01 00:43:59.000000', 'consum', 0.0213, 'lps'),
	(615299, 130, '2014-04-01 00:44:00.000000', 'consum', 0.0218, 'lps'),
	(615300, 130, '2014-04-01 00:44:01.000000', 'consum', 0.0216, 'lps'),
	(615301, 130, '2014-04-01 00:44:02.000000', 'consum', 0.0219, 'lps'),
	(615302, 130, '2014-04-01 00:44:03.000000', 'consum', 0.0212, 'lps'),
	(615303, 130, '2014-04-01 00:44:04.000000', 'consum', 0.0218, 'lps'),
	(615304, 130, '2014-04-01 00:44:05.000000', 'consum', 0.0221, 'lps'),
	(615305, 130, '2014-04-01 00:44:06.000000', 'consum', 0.0216, 'lps'),
	(615306, 130, '2014-04-01 00:44:07.000000', 'consum', 0.0210, 'lps'),
	(615307, 130, '2014-04-01 00:44:08.000000', 'consum', 0.0214, 'lps'),
	(615308, 130, '2014-04-01 00:44:09.000000', 'consum', 0.0221, 'lps'),
	(615309, 130, '2014-04-01 00:44:10.000000', 'consum', 0.0217, 'lps'),
	(615310, 130, '2014-04-01 00:44:11.000000', 'consum', 0.0214, 'lps'),
	(615311, 130, '2014-04-01 00:44:12.000000', 'consum', 0.0220, 'lps'),
	(615312, 130, '2014-04-01 00:44:13.000000', 'consum', 0.0212, 'lps'),
	(615313, 130, '2014-04-01 00:44:14.000000', 'consum', 0.0215, 'lps'),
	(615314, 130, '2014-04-01 00:44:15.000000', 'consum', 0.0216, 'lps'),
	(615315, 130, '2014-04-01 00:44:16.000000', 'consum', 0.0214, 'lps'),
	(615316, 130, '2014-04-01 00:44:17.000000', 'consum', 0.0212, 'lps'),
	(615317, 130, '2014-04-01 00:44:18.000000', 'consum', 0.0210, 'lps'),
	(615318, 130, '2014-04-01 00:44:19.000000', 'consum', 0.0215, 'lps'),
	(615319, 130, '2014-04-01 00:44:20.000000', 'consum', 0.0211, 'lps'),
	(615320, 130, '2014-04-01 00:44:21.000000', 'consum', 0.0211, 'lps'),
	(615321, 130, '2014-04-01 00:44:22.000000', 'consum', 0.0215, 'lps'),
	(615322, 130, '2014-04-01 00:44:23.000000', 'consum', 0.0221, 'lps'),
	(615323, 130, '2014-04-01 00:44:24.000000', 'consum', 0.0214, 'lps'),
	(615324, 130, '2014-04-01 00:44:25.000000', 'consum', 0.0220, 'lps'),
	(615325, 130, '2014-04-01 00:44:26.000000', 'consum', 0.0214, 'lps'),
	(615326, 130, '2014-04-01 00:44:27.000000', 'consum', 0.0211, 'lps'),
	(615327, 130, '2014-04-01 00:44:28.000000', 'consum', 0.0216, 'lps'),
	(615328, 130, '2014-04-01 00:44:29.000000', 'consum', 0.0212, 'lps'),
	(615329, 130, '2014-04-01 00:44:30.000000', 'consum', 0.0217, 'lps'),
	(615330, 130, '2014-04-01 00:44:31.000000', 'consum', 0.0213, 'lps'),
	(615331, 130, '2014-04-01 00:44:32.000000', 'consum', 0.0216, 'lps'),
	(615332, 130, '2014-04-01 00:44:33.000000', 'consum', 0.0211, 'lps'),
	(615333, 130, '2014-04-01 00:44:34.000000', 'consum', 0.0218, 'lps'),
	(615334, 130, '2014-04-01 00:44:35.000000', 'consum', 0.0213, 'lps'),
	(615335, 130, '2014-04-01 00:44:36.000000', 'consum', 0.0213, 'lps'),
	(615336, 130, '2014-04-01 00:44:37.000000', 'consum', 0.0218, 'lps'),
	(615337, 130, '2014-04-01 00:44:38.000000', 'consum', 0.0216, 'lps'),
	(615338, 130, '2014-04-01 00:44:39.000000', 'consum', 0.0219, 'lps'),
	(615339, 130, '2014-04-01 00:44:40.000000', 'consum', 0.0210, 'lps'),
	(615340, 130, '2014-04-01 00:44:41.000000', 'consum', 0.0221, 'lps'),
	(615341, 130, '2014-04-01 00:44:42.000000', 'consum', 0.0216, 'lps'),
	(615342, 130, '2014-04-01 00:44:43.000000', 'consum', 0.0210, 'lps'),
	(615343, 130, '2014-04-01 00:44:44.000000', 'consum', 0.0214, 'lps'),
	(615344, 130, '2014-04-01 00:44:45.000000', 'consum', 0.0220, 'lps'),
	(615345, 130, '2014-04-01 00:44:46.000000', 'consum', 0.0212, 'lps'),
	(615346, 130, '2014-04-01 00:44:47.000000', 'consum', 0.0214, 'lps'),
	(615347, 130, '2014-04-01 00:44:48.000000', 'consum', 0.0211, 'lps'),
	(615348, 130, '2014-04-01 00:44:49.000000', 'consum', 0.0218, 'lps'),
	(615349, 130, '2014-04-01 00:44:50.000000', 'consum', 0.0221, 'lps'),
	(615350, 130, '2014-04-01 00:44:51.000000', 'consum', 0.0220, 'lps'),
	(615351, 130, '2014-04-01 00:44:52.000000', 'consum', 0.0212, 'lps'),
	(615352, 130, '2014-04-01 00:44:53.000000', 'consum', 0.0218, 'lps'),
	(615353, 130, '2014-04-01 00:44:54.000000', 'consum', 0.0220, 'lps'),
	(615354, 130, '2014-04-01 00:44:55.000000', 'consum', 0.0213, 'lps'),
	(615355, 130, '2014-04-01 00:44:56.000000', 'consum', 0.0217, 'lps'),
	(615356, 130, '2014-04-01 00:44:57.000000', 'consum', 0.0214, 'lps'),
	(615357, 130, '2014-04-01 00:44:58.000000', 'consum', 0.0211, 'lps'),
	(615358, 130, '2014-04-01 00:44:59.000000', 'consum', 0.0214, 'lps'),
	(615359, 130, '2014-04-01 00:45:00.000000', 'consum', 0.0217, 'lps'),
	(615360, 130, '2014-04-01 00:45:01.000000', 'consum', 0.0220, 'lps'),
	(615361, 130, '2014-04-01 00:45:02.000000', 'consum', 0.0214, 'lps'),
	(615362, 130, '2014-04-01 00:45:03.000000', 'consum', 0.0213, 'lps'),
	(615363, 130, '2014-04-01 00:45:04.000000', 'consum', 0.0215, 'lps'),
	(615364, 130, '2014-04-01 00:45:05.000000', 'consum', 0.0215, 'lps'),
	(615365, 130, '2014-04-01 00:45:06.000000', 'consum', 0.0219, 'lps'),
	(615366, 130, '2014-04-01 00:45:07.000000', 'consum', 0.0218, 'lps'),
	(615367, 130, '2014-04-01 00:45:08.000000', 'consum', 0.0213, 'lps'),
	(615368, 130, '2014-04-01 00:45:09.000000', 'consum', 0.0212, 'lps'),
	(615369, 130, '2014-04-01 00:45:10.000000', 'consum', 0.0210, 'lps'),
	(615370, 130, '2014-04-01 00:45:11.000000', 'consum', 0.0217, 'lps'),
	(615371, 130, '2014-04-01 00:45:12.000000', 'consum', 0.0221, 'lps'),
	(615372, 130, '2014-04-01 00:45:13.000000', 'consum', 0.0221, 'lps'),
	(615373, 130, '2014-04-01 00:45:14.000000', 'consum', 0.0220, 'lps'),
	(615374, 130, '2014-04-01 00:45:15.000000', 'consum', 0.0217, 'lps'),
	(615375, 130, '2014-04-01 00:45:16.000000', 'consum', 0.0215, 'lps'),
	(615376, 130, '2014-04-01 00:45:17.000000', 'consum', 0.0214, 'lps'),
	(615377, 130, '2014-04-01 00:45:18.000000', 'consum', 0.0217, 'lps'),
	(615378, 130, '2014-04-01 00:45:19.000000', 'consum', 0.0220, 'lps'),
	(615379, 130, '2014-04-01 00:45:20.000000', 'consum', 0.0218, 'lps'),
	(615380, 130, '2014-04-01 00:45:21.000000', 'consum', 0.0217, 'lps'),
	(615381, 130, '2014-04-01 00:45:22.000000', 'consum', 0.0213, 'lps'),
	(615382, 130, '2014-04-01 00:45:23.000000', 'consum', 0.0214, 'lps'),
	(615383, 130, '2014-04-01 00:45:24.000000', 'consum', 0.0221, 'lps'),
	(615384, 130, '2014-04-01 00:45:25.000000', 'consum', 0.0219, 'lps'),
	(615385, 130, '2014-04-01 00:45:26.000000', 'consum', 0.0211, 'lps'),
	(615386, 130, '2014-04-01 00:45:27.000000', 'consum', 0.0213, 'lps'),
	(615387, 130, '2014-04-01 00:45:28.000000', 'consum', 0.0211, 'lps'),
	(615388, 130, '2014-04-01 00:45:29.000000', 'consum', 0.0219, 'lps'),
	(615389, 130, '2014-04-01 00:45:30.000000', 'consum', 0.0216, 'lps'),
	(615390, 130, '2014-04-01 00:45:31.000000', 'consum', 0.0215, 'lps'),
	(615391, 130, '2014-04-01 00:45:32.000000', 'consum', 0.0216, 'lps'),
	(615392, 130, '2014-04-01 00:45:33.000000', 'consum', 0.0216, 'lps'),
	(615393, 130, '2014-04-01 00:45:34.000000', 'consum', 0.0219, 'lps'),
	(615394, 130, '2014-04-01 00:45:35.000000', 'consum', 0.0215, 'lps'),
	(615395, 130, '2014-04-01 00:45:36.000000', 'consum', 0.0219, 'lps'),
	(615396, 130, '2014-04-01 00:45:37.000000', 'consum', 0.0216, 'lps'),
	(615397, 130, '2014-04-01 00:45:38.000000', 'consum', 0.0216, 'lps'),
	(615398, 130, '2014-04-01 00:45:39.000000', 'consum', 0.0211, 'lps'),
	(615399, 130, '2014-04-01 00:45:40.000000', 'consum', 0.0218, 'lps'),
	(615400, 130, '2014-04-01 00:45:41.000000', 'consum', 0.0215, 'lps'),
	(615401, 130, '2014-04-01 00:45:42.000000', 'consum', 0.0210, 'lps'),
	(615402, 130, '2014-04-01 00:45:43.000000', 'consum', 0.0219, 'lps'),
	(615403, 130, '2014-04-01 00:45:44.000000', 'consum', 0.0220, 'lps'),
	(615404, 130, '2014-04-01 00:45:45.000000', 'consum', 0.0211, 'lps'),
	(615405, 130, '2014-04-01 00:45:46.000000', 'consum', 0.0220, 'lps'),
	(615406, 130, '2014-04-01 00:45:47.000000', 'consum', 0.0211, 'lps'),
	(615407, 130, '2014-04-01 00:45:48.000000', 'consum', 0.0221, 'lps'),
	(615408, 130, '2014-04-01 00:45:49.000000', 'consum', 0.0216, 'lps'),
	(615409, 130, '2014-04-01 00:45:50.000000', 'consum', 0.0220, 'lps'),
	(615410, 130, '2014-04-01 00:45:51.000000', 'consum', 0.0217, 'lps'),
	(615411, 130, '2014-04-01 00:45:52.000000', 'consum', 0.0214, 'lps'),
	(615412, 130, '2014-04-01 00:45:53.000000', 'consum', 0.0221, 'lps'),
	(615413, 130, '2014-04-01 00:45:54.000000', 'consum', 0.0219, 'lps'),
	(615414, 130, '2014-04-01 00:45:55.000000', 'consum', 0.0221, 'lps'),
	(615415, 130, '2014-04-01 00:45:56.000000', 'consum', 0.0214, 'lps'),
	(615416, 130, '2014-04-01 00:45:57.000000', 'consum', 0.0210, 'lps'),
	(615417, 130, '2014-04-01 00:45:58.000000', 'consum', 0.0212, 'lps'),
	(615418, 130, '2014-04-01 00:45:59.000000', 'consum', 0.0210, 'lps'),
	(615419, 130, '2014-04-01 00:46:00.000000', 'consum', 0.0214, 'lps'),
	(615420, 130, '2014-04-01 00:46:01.000000', 'consum', 0.0220, 'lps'),
	(615421, 130, '2014-04-01 00:46:02.000000', 'consum', 0.0210, 'lps'),
	(615422, 130, '2014-04-01 00:46:03.000000', 'consum', 0.0217, 'lps'),
	(615423, 130, '2014-04-01 00:46:04.000000', 'consum', 0.0221, 'lps'),
	(615424, 130, '2014-04-01 00:46:05.000000', 'consum', 0.0220, 'lps'),
	(615425, 130, '2014-04-01 00:46:06.000000', 'consum', 0.0217, 'lps'),
	(615426, 130, '2014-04-01 00:46:07.000000', 'consum', 0.0215, 'lps'),
	(615427, 130, '2014-04-01 00:46:08.000000', 'consum', 0.0212, 'lps'),
	(615428, 130, '2014-04-01 00:46:09.000000', 'consum', 0.0221, 'lps'),
	(615429, 130, '2014-04-01 00:46:10.000000', 'consum', 0.0212, 'lps'),
	(615430, 130, '2014-04-01 00:46:11.000000', 'consum', 0.0210, 'lps'),
	(615431, 130, '2014-04-01 00:46:12.000000', 'consum', 0.0216, 'lps'),
	(615432, 130, '2014-04-01 00:46:13.000000', 'consum', 0.0216, 'lps'),
	(615433, 130, '2014-04-01 00:46:14.000000', 'consum', 0.0210, 'lps'),
	(615434, 130, '2014-04-01 00:46:15.000000', 'consum', 0.0216, 'lps'),
	(615435, 130, '2014-04-01 00:46:16.000000', 'consum', 0.0216, 'lps'),
	(615436, 130, '2014-04-01 00:46:17.000000', 'consum', 0.0213, 'lps'),
	(615437, 130, '2014-04-01 00:46:18.000000', 'consum', 0.0219, 'lps'),
	(615438, 130, '2014-04-01 00:46:19.000000', 'consum', 0.0210, 'lps'),
	(615439, 130, '2014-04-01 00:46:20.000000', 'consum', 0.0220, 'lps'),
	(615440, 130, '2014-04-01 00:46:21.000000', 'consum', 0.0212, 'lps'),
	(615441, 130, '2014-04-01 00:46:22.000000', 'consum', 0.0215, 'lps'),
	(615442, 130, '2014-04-01 00:46:23.000000', 'consum', 0.0217, 'lps'),
	(615443, 130, '2014-04-01 00:46:24.000000', 'consum', 0.0217, 'lps'),
	(615444, 130, '2014-04-01 00:46:25.000000', 'consum', 0.0214, 'lps'),
	(615445, 130, '2014-04-01 00:46:26.000000', 'consum', 0.0221, 'lps'),
	(615446, 130, '2014-04-01 00:46:27.000000', 'consum', 0.0219, 'lps'),
	(615447, 130, '2014-04-01 00:46:28.000000', 'consum', 0.0211, 'lps'),
	(615448, 130, '2014-04-01 00:46:29.000000', 'consum', 0.0211, 'lps'),
	(615449, 130, '2014-04-01 00:46:30.000000', 'consum', 0.0213, 'lps'),
	(615450, 130, '2014-04-01 00:46:31.000000', 'consum', 0.0212, 'lps'),
	(615451, 130, '2014-04-01 00:46:32.000000', 'consum', 0.0212, 'lps'),
	(615452, 130, '2014-04-01 00:46:33.000000', 'consum', 0.0213, 'lps'),
	(615453, 130, '2014-04-01 00:46:34.000000', 'consum', 0.0218, 'lps'),
	(615454, 130, '2014-04-01 00:46:35.000000', 'consum', 0.0220, 'lps'),
	(615455, 130, '2014-04-01 00:46:36.000000', 'consum', 0.0212, 'lps'),
	(615456, 130, '2014-04-01 00:46:37.000000', 'consum', 0.0212, 'lps'),
	(615457, 130, '2014-04-01 00:46:38.000000', 'consum', 0.0217, 'lps'),
	(615458, 130, '2014-04-01 00:46:39.000000', 'consum', 0.0215, 'lps'),
	(615459, 130, '2014-04-01 00:46:40.000000', 'consum', 0.0215, 'lps'),
	(615460, 130, '2014-04-01 00:46:41.000000', 'consum', 0.0221, 'lps'),
	(615461, 130, '2014-04-01 00:46:42.000000', 'consum', 0.0215, 'lps'),
	(615462, 130, '2014-04-01 00:46:43.000000', 'consum', 0.0212, 'lps'),
	(615463, 130, '2014-04-01 00:46:44.000000', 'consum', 0.0220, 'lps'),
	(615464, 130, '2014-04-01 00:46:45.000000', 'consum', 0.0218, 'lps'),
	(615465, 130, '2014-04-01 00:46:46.000000', 'consum', 0.0220, 'lps'),
	(615466, 130, '2014-04-01 00:46:47.000000', 'consum', 0.0211, 'lps'),
	(615467, 130, '2014-04-01 00:46:48.000000', 'consum', 0.0221, 'lps'),
	(615468, 130, '2014-04-01 00:46:49.000000', 'consum', 0.0216, 'lps'),
	(615469, 130, '2014-04-01 00:46:50.000000', 'consum', 0.0219, 'lps'),
	(615470, 130, '2014-04-01 00:46:51.000000', 'consum', 0.0212, 'lps'),
	(615471, 130, '2014-04-01 00:46:52.000000', 'consum', 0.0219, 'lps'),
	(615472, 130, '2014-04-01 00:46:53.000000', 'consum', 0.0214, 'lps'),
	(615473, 130, '2014-04-01 00:46:54.000000', 'consum', 0.0217, 'lps'),
	(615474, 130, '2014-04-01 00:46:55.000000', 'consum', 0.0218, 'lps'),
	(615475, 130, '2014-04-01 00:46:56.000000', 'consum', 0.0220, 'lps'),
	(615476, 130, '2014-04-01 00:46:57.000000', 'consum', 0.0214, 'lps'),
	(615477, 130, '2014-04-01 00:46:58.000000', 'consum', 0.0210, 'lps'),
	(615478, 130, '2014-04-01 00:46:59.000000', 'consum', 0.0211, 'lps'),
	(615479, 130, '2014-04-01 00:47:00.000000', 'consum', 0.0217, 'lps'),
	(615480, 130, '2014-04-01 00:47:01.000000', 'consum', 0.0219, 'lps'),
	(615481, 130, '2014-04-01 00:47:02.000000', 'consum', 0.0221, 'lps'),
	(615482, 130, '2014-04-01 00:47:03.000000', 'consum', 0.0216, 'lps'),
	(615483, 130, '2014-04-01 00:47:04.000000', 'consum', 0.0217, 'lps'),
	(615484, 130, '2014-04-01 00:47:05.000000', 'consum', 0.0219, 'lps'),
	(615485, 130, '2014-04-01 00:47:06.000000', 'consum', 0.0220, 'lps'),
	(615486, 130, '2014-04-01 00:47:07.000000', 'consum', 0.0210, 'lps'),
	(615487, 130, '2014-04-01 00:47:08.000000', 'consum', 0.0216, 'lps'),
	(615488, 130, '2014-04-01 00:47:09.000000', 'consum', 0.0216, 'lps'),
	(615489, 130, '2014-04-01 00:47:10.000000', 'consum', 0.0210, 'lps'),
	(615490, 130, '2014-04-01 00:47:11.000000', 'consum', 0.0217, 'lps'),
	(615491, 130, '2014-04-01 00:47:12.000000', 'consum', 0.0211, 'lps'),
	(615492, 130, '2014-04-01 00:47:13.000000', 'consum', 0.0219, 'lps'),
	(615493, 130, '2014-04-01 00:47:14.000000', 'consum', 0.0214, 'lps'),
	(615494, 130, '2014-04-01 00:47:15.000000', 'consum', 0.0215, 'lps'),
	(615495, 130, '2014-04-01 00:47:16.000000', 'consum', 0.0212, 'lps'),
	(615496, 130, '2014-04-01 00:47:17.000000', 'consum', 0.0219, 'lps'),
	(615497, 130, '2014-04-01 00:47:18.000000', 'consum', 0.0215, 'lps'),
	(615498, 130, '2014-04-01 00:47:19.000000', 'consum', 0.0217, 'lps'),
	(615499, 130, '2014-04-01 00:47:20.000000', 'consum', 0.0221, 'lps'),
	(615500, 130, '2014-04-01 00:47:21.000000', 'consum', 0.0218, 'lps'),
	(615501, 130, '2014-04-01 00:47:22.000000', 'consum', 0.0220, 'lps'),
	(615502, 130, '2014-04-01 00:47:23.000000', 'consum', 0.0212, 'lps'),
	(615503, 130, '2014-04-01 00:47:24.000000', 'consum', 0.0212, 'lps'),
	(615504, 130, '2014-04-01 00:47:25.000000', 'consum', 0.0217, 'lps'),
	(615505, 130, '2014-04-01 00:47:26.000000', 'consum', 0.0213, 'lps'),
	(615506, 130, '2014-04-01 00:47:27.000000', 'consum', 0.0218, 'lps'),
	(615507, 130, '2014-04-01 00:47:28.000000', 'consum', 0.0216, 'lps'),
	(615508, 130, '2014-04-01 00:47:29.000000', 'consum', 0.0217, 'lps'),
	(615509, 130, '2014-04-01 00:47:30.000000', 'consum', 0.0217, 'lps'),
	(615510, 130, '2014-04-01 00:47:31.000000', 'consum', 0.0210, 'lps'),
	(615511, 130, '2014-04-01 00:47:32.000000', 'consum', 0.0216, 'lps'),
	(615512, 130, '2014-04-01 00:47:33.000000', 'consum', 0.0216, 'lps'),
	(615513, 130, '2014-04-01 00:47:34.000000', 'consum', 0.0211, 'lps'),
	(615514, 130, '2014-04-01 00:47:35.000000', 'consum', 0.0221, 'lps'),
	(615515, 130, '2014-04-01 00:47:36.000000', 'consum', 0.0214, 'lps'),
	(615516, 130, '2014-04-01 00:47:37.000000', 'consum', 0.0220, 'lps'),
	(615517, 130, '2014-04-01 00:47:38.000000', 'consum', 0.0213, 'lps'),
	(615518, 130, '2014-04-01 00:47:39.000000', 'consum', 0.0221, 'lps'),
	(615519, 130, '2014-04-01 00:47:40.000000', 'consum', 0.0218, 'lps'),
	(615520, 130, '2014-04-01 00:47:41.000000', 'consum', 0.0220, 'lps'),
	(615521, 130, '2014-04-01 00:47:42.000000', 'consum', 0.0212, 'lps'),
	(615522, 130, '2014-04-01 00:47:43.000000', 'consum', 0.0213, 'lps'),
	(615523, 130, '2014-04-01 00:47:44.000000', 'consum', 0.0218, 'lps'),
	(615524, 130, '2014-04-01 00:47:45.000000', 'consum', 0.0221, 'lps'),
	(615525, 130, '2014-04-01 00:47:46.000000', 'consum', 0.0216, 'lps'),
	(615526, 130, '2014-04-01 00:47:47.000000', 'consum', 0.0219, 'lps'),
	(615527, 130, '2014-04-01 00:47:48.000000', 'consum', 0.0214, 'lps'),
	(615528, 130, '2014-04-01 00:47:49.000000', 'consum', 0.0216, 'lps'),
	(615529, 130, '2014-04-01 00:47:50.000000', 'consum', 0.0214, 'lps'),
	(615530, 130, '2014-04-01 00:47:51.000000', 'consum', 0.0214, 'lps'),
	(615531, 130, '2014-04-01 00:47:52.000000', 'consum', 0.0220, 'lps'),
	(615532, 130, '2014-04-01 00:47:53.000000', 'consum', 0.0212, 'lps'),
	(615533, 130, '2014-04-01 00:47:54.000000', 'consum', 0.0215, 'lps'),
	(615534, 130, '2014-04-01 00:47:55.000000', 'consum', 0.0219, 'lps'),
	(615535, 130, '2014-04-01 00:47:56.000000', 'consum', 0.0214, 'lps'),
	(615536, 130, '2014-04-01 00:47:57.000000', 'consum', 0.0214, 'lps'),
	(615537, 130, '2014-04-01 00:47:58.000000', 'consum', 0.0221, 'lps'),
	(615538, 130, '2014-04-01 00:47:59.000000', 'consum', 0.0219, 'lps'),
	(615539, 130, '2014-04-01 00:48:00.000000', 'consum', 0.0219, 'lps'),
	(615540, 130, '2014-04-01 00:48:01.000000', 'consum', 0.0219, 'lps'),
	(615541, 130, '2014-04-01 00:48:02.000000', 'consum', 0.0215, 'lps'),
	(615542, 130, '2014-04-01 00:48:03.000000', 'consum', 0.0220, 'lps'),
	(615543, 130, '2014-04-01 00:48:04.000000', 'consum', 0.0221, 'lps'),
	(615544, 130, '2014-04-01 00:48:05.000000', 'consum', 0.0212, 'lps'),
	(615545, 130, '2014-04-01 00:48:06.000000', 'consum', 0.0210, 'lps'),
	(615546, 130, '2014-04-01 00:48:07.000000', 'consum', 0.0219, 'lps'),
	(615547, 130, '2014-04-01 00:48:08.000000', 'consum', 0.0220, 'lps'),
	(615548, 130, '2014-04-01 00:48:09.000000', 'consum', 0.0210, 'lps'),
	(615549, 130, '2014-04-01 00:48:10.000000', 'consum', 0.0217, 'lps'),
	(615550, 130, '2014-04-01 00:48:11.000000', 'consum', 0.0220, 'lps'),
	(615551, 130, '2014-04-01 00:48:12.000000', 'consum', 0.0215, 'lps'),
	(615552, 130, '2014-04-01 00:48:13.000000', 'consum', 0.0218, 'lps'),
	(615553, 130, '2014-04-01 00:48:14.000000', 'consum', 0.0221, 'lps'),
	(615554, 130, '2014-04-01 00:48:15.000000', 'consum', 0.0221, 'lps'),
	(615555, 130, '2014-04-01 00:48:16.000000', 'consum', 0.0220, 'lps'),
	(615556, 130, '2014-04-01 00:48:17.000000', 'consum', 0.0216, 'lps'),
	(615557, 130, '2014-04-01 00:48:18.000000', 'consum', 0.0221, 'lps'),
	(615558, 130, '2014-04-01 00:48:19.000000', 'consum', 0.0212, 'lps'),
	(615559, 130, '2014-04-01 00:48:20.000000', 'consum', 0.0212, 'lps'),
	(615560, 130, '2014-04-01 00:48:21.000000', 'consum', 0.0215, 'lps'),
	(615561, 130, '2014-04-01 00:48:22.000000', 'consum', 0.0217, 'lps'),
	(615562, 130, '2014-04-01 00:48:23.000000', 'consum', 0.0217, 'lps'),
	(615563, 130, '2014-04-01 00:48:24.000000', 'consum', 0.0211, 'lps'),
	(615564, 130, '2014-04-01 00:48:25.000000', 'consum', 0.0210, 'lps'),
	(615565, 130, '2014-04-01 00:48:26.000000', 'consum', 0.0218, 'lps'),
	(615566, 130, '2014-04-01 00:48:27.000000', 'consum', 0.0215, 'lps'),
	(615567, 130, '2014-04-01 00:48:28.000000', 'consum', 0.0212, 'lps'),
	(615568, 130, '2014-04-01 00:48:29.000000', 'consum', 0.0216, 'lps'),
	(615569, 130, '2014-04-01 00:48:30.000000', 'consum', 0.0213, 'lps'),
	(615570, 130, '2014-04-01 00:48:31.000000', 'consum', 0.0217, 'lps'),
	(615571, 130, '2014-04-01 00:48:32.000000', 'consum', 0.0215, 'lps'),
	(615572, 130, '2014-04-01 00:48:33.000000', 'consum', 0.0215, 'lps'),
	(615573, 130, '2014-04-01 00:48:34.000000', 'consum', 0.0218, 'lps'),
	(615574, 130, '2014-04-01 00:48:35.000000', 'consum', 0.0211, 'lps'),
	(615575, 130, '2014-04-01 00:48:36.000000', 'consum', 0.0215, 'lps'),
	(615576, 130, '2014-04-01 00:48:37.000000', 'consum', 0.0219, 'lps'),
	(615577, 130, '2014-04-01 00:48:38.000000', 'consum', 0.0220, 'lps'),
	(615578, 130, '2014-04-01 00:48:39.000000', 'consum', 0.0221, 'lps'),
	(615579, 130, '2014-04-01 00:48:40.000000', 'consum', 0.0210, 'lps'),
	(615580, 130, '2014-04-01 00:48:41.000000', 'consum', 0.0214, 'lps'),
	(615581, 130, '2014-04-01 00:48:42.000000', 'consum', 0.0220, 'lps'),
	(615582, 130, '2014-04-01 00:48:43.000000', 'consum', 0.0211, 'lps'),
	(615583, 130, '2014-04-01 00:48:44.000000', 'consum', 0.0210, 'lps'),
	(615584, 130, '2014-04-01 00:48:45.000000', 'consum', 0.0218, 'lps'),
	(615585, 130, '2014-04-01 00:48:46.000000', 'consum', 0.0217, 'lps'),
	(615586, 130, '2014-04-01 00:48:47.000000', 'consum', 0.0210, 'lps'),
	(615587, 130, '2014-04-01 00:48:48.000000', 'consum', 0.0214, 'lps'),
	(615588, 130, '2014-04-01 00:48:49.000000', 'consum', 0.0219, 'lps'),
	(615589, 130, '2014-04-01 00:48:50.000000', 'consum', 0.0217, 'lps'),
	(615590, 130, '2014-04-01 00:48:51.000000', 'consum', 0.0220, 'lps'),
	(615591, 130, '2014-04-01 00:48:52.000000', 'consum', 0.0217, 'lps'),
	(615592, 130, '2014-04-01 00:48:53.000000', 'consum', 0.0215, 'lps'),
	(615593, 130, '2014-04-01 00:48:54.000000', 'consum', 0.0213, 'lps'),
	(615594, 130, '2014-04-01 00:48:55.000000', 'consum', 0.0211, 'lps'),
	(615595, 130, '2014-04-01 00:48:56.000000', 'consum', 0.0220, 'lps'),
	(615596, 130, '2014-04-01 00:48:57.000000', 'consum', 0.0218, 'lps'),
	(615597, 130, '2014-04-01 00:48:58.000000', 'consum', 0.0212, 'lps'),
	(615598, 130, '2014-04-01 00:48:59.000000', 'consum', 0.0219, 'lps'),
	(615599, 130, '2014-04-01 00:49:00.000000', 'consum', 0.0213, 'lps'),
	(615600, 130, '2014-04-01 00:49:01.000000', 'consum', 0.0212, 'lps'),
	(615601, 130, '2014-04-01 00:49:02.000000', 'consum', 0.0221, 'lps'),
	(615602, 130, '2014-04-01 00:49:03.000000', 'consum', 0.0213, 'lps'),
	(615603, 130, '2014-04-01 00:49:04.000000', 'consum', 0.0215, 'lps'),
	(615604, 130, '2014-04-01 00:49:05.000000', 'consum', 0.0217, 'lps'),
	(615605, 130, '2014-04-01 00:49:06.000000', 'consum', 0.0219, 'lps'),
	(615606, 130, '2014-04-01 00:49:07.000000', 'consum', 0.0220, 'lps'),
	(615607, 130, '2014-04-01 00:49:08.000000', 'consum', 0.0210, 'lps'),
	(615608, 130, '2014-04-01 00:49:09.000000', 'consum', 0.0216, 'lps'),
	(615609, 130, '2014-04-01 00:49:10.000000', 'consum', 0.0218, 'lps'),
	(615610, 130, '2014-04-01 00:49:11.000000', 'consum', 0.0218, 'lps'),
	(615611, 130, '2014-04-01 00:49:12.000000', 'consum', 0.0218, 'lps'),
	(615612, 130, '2014-04-01 00:49:13.000000', 'consum', 0.0212, 'lps'),
	(615613, 130, '2014-04-01 00:49:14.000000', 'consum', 0.0219, 'lps'),
	(615614, 130, '2014-04-01 00:49:15.000000', 'consum', 0.0217, 'lps'),
	(615615, 130, '2014-04-01 00:49:16.000000', 'consum', 0.0217, 'lps'),
	(615616, 130, '2014-04-01 00:49:17.000000', 'consum', 0.0214, 'lps'),
	(615617, 130, '2014-04-01 00:49:18.000000', 'consum', 0.0210, 'lps'),
	(615618, 130, '2014-04-01 00:49:19.000000', 'consum', 0.0210, 'lps'),
	(615619, 130, '2014-04-01 00:49:20.000000', 'consum', 0.0221, 'lps'),
	(615620, 130, '2014-04-01 00:49:21.000000', 'consum', 0.0220, 'lps'),
	(615621, 130, '2014-04-01 00:49:22.000000', 'consum', 0.0214, 'lps'),
	(615622, 130, '2014-04-01 00:49:23.000000', 'consum', 0.0211, 'lps'),
	(615623, 130, '2014-04-01 00:49:24.000000', 'consum', 0.0218, 'lps'),
	(615624, 130, '2014-04-01 00:49:25.000000', 'consum', 0.0210, 'lps'),
	(615625, 130, '2014-04-01 00:49:26.000000', 'consum', 0.0212, 'lps'),
	(615626, 130, '2014-04-01 00:49:27.000000', 'consum', 0.0219, 'lps'),
	(615627, 130, '2014-04-01 00:49:28.000000', 'consum', 0.0212, 'lps'),
	(615628, 130, '2014-04-01 00:49:29.000000', 'consum', 0.0219, 'lps'),
	(615629, 130, '2014-04-01 00:49:30.000000', 'consum', 0.0212, 'lps'),
	(615630, 130, '2014-04-01 00:49:31.000000', 'consum', 0.0221, 'lps'),
	(615631, 130, '2014-04-01 00:49:32.000000', 'consum', 0.0220, 'lps'),
	(615632, 130, '2014-04-01 00:49:33.000000', 'consum', 0.0217, 'lps'),
	(615633, 130, '2014-04-01 00:49:34.000000', 'consum', 0.0214, 'lps'),
	(615634, 130, '2014-04-01 00:49:35.000000', 'consum', 0.0221, 'lps'),
	(615635, 130, '2014-04-01 00:49:36.000000', 'consum', 0.0220, 'lps'),
	(615636, 130, '2014-04-01 00:49:37.000000', 'consum', 0.0213, 'lps'),
	(615637, 130, '2014-04-01 00:49:38.000000', 'consum', 0.0221, 'lps'),
	(615638, 130, '2014-04-01 00:49:39.000000', 'consum', 0.0220, 'lps'),
	(615639, 130, '2014-04-01 00:49:40.000000', 'consum', 0.0217, 'lps'),
	(615640, 130, '2014-04-01 00:49:41.000000', 'consum', 0.0215, 'lps'),
	(615641, 130, '2014-04-01 00:49:42.000000', 'consum', 0.0215, 'lps'),
	(615642, 130, '2014-04-01 00:49:43.000000', 'consum', 0.0210, 'lps'),
	(615643, 130, '2014-04-01 00:49:44.000000', 'consum', 0.0217, 'lps'),
	(615644, 130, '2014-04-01 00:49:45.000000', 'consum', 0.0211, 'lps'),
	(615645, 130, '2014-04-01 00:49:46.000000', 'consum', 0.0219, 'lps'),
	(615646, 130, '2014-04-01 00:49:47.000000', 'consum', 0.0217, 'lps'),
	(615647, 130, '2014-04-01 00:49:48.000000', 'consum', 0.0220, 'lps'),
	(615648, 130, '2014-04-01 00:49:49.000000', 'consum', 0.0213, 'lps'),
	(615649, 130, '2014-04-01 00:49:50.000000', 'consum', 0.0218, 'lps'),
	(615650, 130, '2014-04-01 00:49:51.000000', 'consum', 0.0221, 'lps'),
	(615651, 130, '2014-04-01 00:49:52.000000', 'consum', 0.0216, 'lps'),
	(615652, 130, '2014-04-01 00:49:53.000000', 'consum', 0.0210, 'lps'),
	(615653, 130, '2014-04-01 00:49:54.000000', 'consum', 0.0213, 'lps'),
	(615654, 130, '2014-04-01 00:49:55.000000', 'consum', 0.0217, 'lps'),
	(615655, 130, '2014-04-01 00:49:56.000000', 'consum', 0.0210, 'lps'),
	(615656, 130, '2014-04-01 00:49:57.000000', 'consum', 0.0216, 'lps'),
	(615657, 130, '2014-04-01 00:49:58.000000', 'consum', 0.0213, 'lps'),
	(615658, 130, '2014-04-01 00:49:59.000000', 'consum', 0.0210, 'lps'),
	(615659, 130, '2014-04-01 00:50:00.000000', 'consum', 0.0213, 'lps'),
	(615660, 130, '2014-04-01 00:50:01.000000', 'consum', 0.0213, 'lps'),
	(615661, 130, '2014-04-01 00:50:02.000000', 'consum', 0.0215, 'lps'),
	(615662, 130, '2014-04-01 00:50:03.000000', 'consum', 0.0215, 'lps'),
	(615663, 130, '2014-04-01 00:50:04.000000', 'consum', 0.0219, 'lps'),
	(615664, 130, '2014-04-01 00:50:05.000000', 'consum', 0.0219, 'lps'),
	(615665, 130, '2014-04-01 00:50:06.000000', 'consum', 0.0217, 'lps'),
	(615666, 130, '2014-04-01 00:50:07.000000', 'consum', 0.0218, 'lps'),
	(615667, 130, '2014-04-01 00:50:08.000000', 'consum', 0.0218, 'lps'),
	(615668, 130, '2014-04-01 00:50:09.000000', 'consum', 0.0216, 'lps'),
	(615669, 130, '2014-04-01 00:50:10.000000', 'consum', 0.0214, 'lps'),
	(615670, 130, '2014-04-01 00:50:11.000000', 'consum', 0.0215, 'lps'),
	(615671, 130, '2014-04-01 00:50:12.000000', 'consum', 0.0221, 'lps'),
	(615672, 130, '2014-04-01 00:50:13.000000', 'consum', 0.0214, 'lps'),
	(615673, 130, '2014-04-01 00:50:14.000000', 'consum', 0.0212, 'lps'),
	(615674, 130, '2014-04-01 00:50:15.000000', 'consum', 0.0219, 'lps'),
	(615675, 130, '2014-04-01 00:50:16.000000', 'consum', 0.0213, 'lps'),
	(615676, 130, '2014-04-01 00:50:17.000000', 'consum', 0.0221, 'lps'),
	(615677, 130, '2014-04-01 00:50:18.000000', 'consum', 0.0211, 'lps'),
	(615678, 130, '2014-04-01 00:50:19.000000', 'consum', 0.0217, 'lps'),
	(615679, 130, '2014-04-01 00:50:20.000000', 'consum', 0.0217, 'lps'),
	(615680, 130, '2014-04-01 00:50:21.000000', 'consum', 0.0214, 'lps'),
	(615681, 130, '2014-04-01 00:50:22.000000', 'consum', 0.0211, 'lps'),
	(615682, 130, '2014-04-01 00:50:23.000000', 'consum', 0.0213, 'lps'),
	(615683, 130, '2014-04-01 00:50:24.000000', 'consum', 0.0213, 'lps'),
	(615684, 130, '2014-04-01 00:50:25.000000', 'consum', 0.0215, 'lps'),
	(615685, 130, '2014-04-01 00:50:26.000000', 'consum', 0.0214, 'lps'),
	(615686, 130, '2014-04-01 00:50:27.000000', 'consum', 0.0216, 'lps'),
	(615687, 130, '2014-04-01 00:50:28.000000', 'consum', 0.0218, 'lps'),
	(615688, 130, '2014-04-01 00:50:29.000000', 'consum', 0.0218, 'lps'),
	(615689, 130, '2014-04-01 00:50:30.000000', 'consum', 0.0216, 'lps'),
	(615690, 130, '2014-04-01 00:50:31.000000', 'consum', 0.0218, 'lps'),
	(615691, 130, '2014-04-01 00:50:32.000000', 'consum', 0.0217, 'lps'),
	(615692, 130, '2014-04-01 00:50:33.000000', 'consum', 0.0213, 'lps'),
	(615693, 130, '2014-04-01 00:50:34.000000', 'consum', 0.0213, 'lps'),
	(615694, 130, '2014-04-01 00:50:35.000000', 'consum', 0.0220, 'lps'),
	(615695, 130, '2014-04-01 00:50:36.000000', 'consum', 0.0214, 'lps'),
	(615696, 130, '2014-04-01 00:50:37.000000', 'consum', 0.0212, 'lps'),
	(615697, 130, '2014-04-01 00:50:38.000000', 'consum', 0.0221, 'lps'),
	(615698, 130, '2014-04-01 00:50:39.000000', 'consum', 0.0211, 'lps'),
	(615699, 130, '2014-04-01 00:50:40.000000', 'consum', 0.0218, 'lps'),
	(615700, 130, '2014-04-01 00:50:41.000000', 'consum', 0.0210, 'lps'),
	(615701, 130, '2014-04-01 00:50:42.000000', 'consum', 0.0213, 'lps'),
	(615702, 130, '2014-04-01 00:50:43.000000', 'consum', 0.0212, 'lps'),
	(615703, 130, '2014-04-01 00:50:44.000000', 'consum', 0.0213, 'lps'),
	(615704, 130, '2014-04-01 00:50:45.000000', 'consum', 0.0219, 'lps'),
	(615705, 130, '2014-04-01 00:50:46.000000', 'consum', 0.0211, 'lps'),
	(615706, 130, '2014-04-01 00:50:47.000000', 'consum', 0.0210, 'lps'),
	(615707, 130, '2014-04-01 00:50:48.000000', 'consum', 0.0210, 'lps'),
	(615708, 130, '2014-04-01 00:50:49.000000', 'consum', 0.0212, 'lps'),
	(615709, 130, '2014-04-01 00:50:50.000000', 'consum', 0.0218, 'lps'),
	(615710, 130, '2014-04-01 00:50:51.000000', 'consum', 0.0220, 'lps'),
	(615711, 130, '2014-04-01 00:50:52.000000', 'consum', 0.0213, 'lps'),
	(615712, 130, '2014-04-01 00:50:53.000000', 'consum', 0.0218, 'lps'),
	(615713, 130, '2014-04-01 00:50:54.000000', 'consum', 0.0221, 'lps'),
	(615714, 130, '2014-04-01 00:50:55.000000', 'consum', 0.0215, 'lps'),
	(615715, 130, '2014-04-01 00:50:56.000000', 'consum', 0.0214, 'lps'),
	(615716, 130, '2014-04-01 00:50:57.000000', 'consum', 0.0215, 'lps'),
	(615717, 130, '2014-04-01 00:50:58.000000', 'consum', 0.0212, 'lps'),
	(615718, 130, '2014-04-01 00:50:59.000000', 'consum', 0.0216, 'lps'),
	(615719, 130, '2014-04-01 00:51:00.000000', 'consum', 0.0210, 'lps'),
	(615720, 130, '2014-04-01 00:51:01.000000', 'consum', 0.0219, 'lps'),
	(615721, 130, '2014-04-01 00:51:02.000000', 'consum', 0.0220, 'lps'),
	(615722, 130, '2014-04-01 00:51:03.000000', 'consum', 0.0219, 'lps'),
	(615723, 130, '2014-04-01 00:51:04.000000', 'consum', 0.0213, 'lps'),
	(615724, 130, '2014-04-01 00:51:05.000000', 'consum', 0.0210, 'lps'),
	(615725, 130, '2014-04-01 00:51:06.000000', 'consum', 0.0214, 'lps'),
	(615726, 130, '2014-04-01 00:51:07.000000', 'consum', 0.0219, 'lps'),
	(615727, 130, '2014-04-01 00:51:08.000000', 'consum', 0.0221, 'lps'),
	(615728, 130, '2014-04-01 00:51:09.000000', 'consum', 0.0213, 'lps'),
	(615729, 130, '2014-04-01 00:51:10.000000', 'consum', 0.0219, 'lps'),
	(615730, 130, '2014-04-01 00:51:11.000000', 'consum', 0.0220, 'lps'),
	(615731, 130, '2014-04-01 00:51:12.000000', 'consum', 0.0220, 'lps'),
	(615732, 130, '2014-04-01 00:51:13.000000', 'consum', 0.0220, 'lps'),
	(615733, 130, '2014-04-01 00:51:14.000000', 'consum', 0.0219, 'lps'),
	(615734, 130, '2014-04-01 00:51:15.000000', 'consum', 0.0214, 'lps'),
	(615735, 130, '2014-04-01 00:51:16.000000', 'consum', 0.0213, 'lps'),
	(615736, 130, '2014-04-01 00:51:17.000000', 'consum', 0.0215, 'lps'),
	(615737, 130, '2014-04-01 00:51:18.000000', 'consum', 0.0216, 'lps'),
	(615738, 130, '2014-04-01 00:51:19.000000', 'consum', 0.0211, 'lps'),
	(615739, 130, '2014-04-01 00:51:20.000000', 'consum', 0.0211, 'lps'),
	(615740, 130, '2014-04-01 00:51:21.000000', 'consum', 0.0213, 'lps'),
	(615741, 130, '2014-04-01 00:51:22.000000', 'consum', 0.0211, 'lps'),
	(615742, 130, '2014-04-01 00:51:23.000000', 'consum', 0.0218, 'lps'),
	(615743, 130, '2014-04-01 00:51:24.000000', 'consum', 0.0213, 'lps'),
	(615744, 130, '2014-04-01 00:51:25.000000', 'consum', 0.0211, 'lps'),
	(615745, 130, '2014-04-01 00:51:26.000000', 'consum', 0.0218, 'lps'),
	(615746, 130, '2014-04-01 00:51:27.000000', 'consum', 0.0213, 'lps'),
	(615747, 130, '2014-04-01 00:51:28.000000', 'consum', 0.0211, 'lps'),
	(615748, 130, '2014-04-01 00:51:29.000000', 'consum', 0.0221, 'lps'),
	(615749, 130, '2014-04-01 00:51:30.000000', 'consum', 0.0212, 'lps'),
	(615750, 130, '2014-04-01 00:51:31.000000', 'consum', 0.0212, 'lps'),
	(615751, 130, '2014-04-01 00:51:32.000000', 'consum', 0.0215, 'lps'),
	(615752, 130, '2014-04-01 00:51:33.000000', 'consum', 0.0218, 'lps'),
	(615753, 130, '2014-04-01 00:51:34.000000', 'consum', 0.0221, 'lps'),
	(615754, 130, '2014-04-01 00:51:35.000000', 'consum', 0.0220, 'lps'),
	(615755, 130, '2014-04-01 00:51:36.000000', 'consum', 0.0217, 'lps'),
	(615756, 130, '2014-04-01 00:51:37.000000', 'consum', 0.0214, 'lps'),
	(615757, 130, '2014-04-01 00:51:38.000000', 'consum', 0.0220, 'lps'),
	(615758, 130, '2014-04-01 00:51:39.000000', 'consum', 0.0215, 'lps'),
	(615759, 130, '2014-04-01 00:51:40.000000', 'consum', 0.0219, 'lps'),
	(615760, 130, '2014-04-01 00:51:41.000000', 'consum', 0.0213, 'lps'),
	(615761, 130, '2014-04-01 00:51:42.000000', 'consum', 0.0211, 'lps'),
	(615762, 130, '2014-04-01 00:51:43.000000', 'consum', 0.0220, 'lps'),
	(615763, 130, '2014-04-01 00:51:44.000000', 'consum', 0.0211, 'lps'),
	(615764, 130, '2014-04-01 00:51:45.000000', 'consum', 0.0218, 'lps'),
	(615765, 130, '2014-04-01 00:51:46.000000', 'consum', 0.0212, 'lps'),
	(615766, 130, '2014-04-01 00:51:47.000000', 'consum', 0.0210, 'lps'),
	(615767, 130, '2014-04-01 00:51:48.000000', 'consum', 0.0215, 'lps'),
	(615768, 130, '2014-04-01 00:51:49.000000', 'consum', 0.0212, 'lps'),
	(615769, 130, '2014-04-01 00:51:50.000000', 'consum', 0.0218, 'lps'),
	(615770, 130, '2014-04-01 00:51:51.000000', 'consum', 0.0219, 'lps'),
	(615771, 130, '2014-04-01 00:51:52.000000', 'consum', 0.0210, 'lps'),
	(615772, 130, '2014-04-01 00:51:53.000000', 'consum', 0.0217, 'lps'),
	(615773, 130, '2014-04-01 00:51:54.000000', 'consum', 0.0211, 'lps'),
	(615774, 130, '2014-04-01 00:51:55.000000', 'consum', 0.0216, 'lps'),
	(615775, 130, '2014-04-01 00:51:56.000000', 'consum', 0.0216, 'lps'),
	(615776, 130, '2014-04-01 00:51:57.000000', 'consum', 0.0210, 'lps'),
	(615777, 130, '2014-04-01 00:51:58.000000', 'consum', 0.0214, 'lps'),
	(615778, 130, '2014-04-01 00:51:59.000000', 'consum', 0.0221, 'lps'),
	(615779, 130, '2014-04-01 00:52:00.000000', 'consum', 0.0217, 'lps'),
	(615780, 130, '2014-04-01 00:52:01.000000', 'consum', 0.0213, 'lps'),
	(615781, 130, '2014-04-01 00:52:02.000000', 'consum', 0.0217, 'lps'),
	(615782, 130, '2014-04-01 00:52:03.000000', 'consum', 0.0210, 'lps'),
	(615783, 130, '2014-04-01 00:52:04.000000', 'consum', 0.0217, 'lps'),
	(615784, 130, '2014-04-01 00:52:05.000000', 'consum', 0.0219, 'lps'),
	(615785, 130, '2014-04-01 00:52:06.000000', 'consum', 0.0213, 'lps'),
	(615786, 130, '2014-04-01 00:52:07.000000', 'consum', 0.0221, 'lps'),
	(615787, 130, '2014-04-01 00:52:08.000000', 'consum', 0.0211, 'lps'),
	(615788, 130, '2014-04-01 00:52:09.000000', 'consum', 0.0216, 'lps'),
	(615789, 130, '2014-04-01 00:52:10.000000', 'consum', 0.0213, 'lps'),
	(615790, 130, '2014-04-01 00:52:11.000000', 'consum', 0.0219, 'lps'),
	(615791, 130, '2014-04-01 00:52:12.000000', 'consum', 0.0211, 'lps'),
	(615792, 130, '2014-04-01 00:52:13.000000', 'consum', 0.0213, 'lps'),
	(615793, 130, '2014-04-01 00:52:14.000000', 'consum', 0.0211, 'lps'),
	(615794, 130, '2014-04-01 00:52:15.000000', 'consum', 0.0217, 'lps'),
	(615795, 130, '2014-04-01 00:52:16.000000', 'consum', 0.0219, 'lps'),
	(615796, 130, '2014-04-01 00:52:17.000000', 'consum', 0.0212, 'lps'),
	(615797, 130, '2014-04-01 00:52:18.000000', 'consum', 0.0216, 'lps'),
	(615798, 130, '2014-04-01 00:52:19.000000', 'consum', 0.0213, 'lps'),
	(615799, 130, '2014-04-01 00:52:20.000000', 'consum', 0.0217, 'lps'),
	(615800, 130, '2014-04-01 00:52:21.000000', 'consum', 0.0215, 'lps'),
	(615801, 130, '2014-04-01 00:52:22.000000', 'consum', 0.0215, 'lps'),
	(615802, 130, '2014-04-01 00:52:23.000000', 'consum', 0.0218, 'lps'),
	(615803, 130, '2014-04-01 00:52:24.000000', 'consum', 0.0211, 'lps'),
	(615804, 130, '2014-04-01 00:52:25.000000', 'consum', 0.0215, 'lps'),
	(615805, 130, '2014-04-01 00:52:26.000000', 'consum', 0.0221, 'lps'),
	(615806, 130, '2014-04-01 00:52:27.000000', 'consum', 0.0214, 'lps'),
	(615807, 130, '2014-04-01 00:52:28.000000', 'consum', 0.0221, 'lps'),
	(615808, 130, '2014-04-01 00:52:29.000000', 'consum', 0.0216, 'lps'),
	(615809, 130, '2014-04-01 00:52:30.000000', 'consum', 0.0211, 'lps'),
	(615810, 130, '2014-04-01 00:52:31.000000', 'consum', 0.0219, 'lps'),
	(615811, 130, '2014-04-01 00:52:32.000000', 'consum', 0.0216, 'lps'),
	(615812, 130, '2014-04-01 00:52:33.000000', 'consum', 0.0216, 'lps'),
	(615813, 130, '2014-04-01 00:52:34.000000', 'consum', 0.0211, 'lps'),
	(615814, 130, '2014-04-01 00:52:35.000000', 'consum', 0.0221, 'lps'),
	(615815, 130, '2014-04-01 00:52:36.000000', 'consum', 0.0214, 'lps'),
	(615816, 130, '2014-04-01 00:52:37.000000', 'consum', 0.0211, 'lps'),
	(615817, 130, '2014-04-01 00:52:38.000000', 'consum', 0.0214, 'lps'),
	(615818, 130, '2014-04-01 00:52:39.000000', 'consum', 0.0214, 'lps'),
	(615819, 130, '2014-04-01 00:52:40.000000', 'consum', 0.0219, 'lps'),
	(615820, 130, '2014-04-01 00:52:41.000000', 'consum', 0.0221, 'lps'),
	(615821, 130, '2014-04-01 00:52:42.000000', 'consum', 0.0213, 'lps'),
	(615822, 130, '2014-04-01 00:52:43.000000', 'consum', 0.0216, 'lps'),
	(615823, 130, '2014-04-01 00:52:44.000000', 'consum', 0.0219, 'lps'),
	(615824, 130, '2014-04-01 00:52:45.000000', 'consum', 0.0214, 'lps'),
	(615825, 130, '2014-04-01 00:52:46.000000', 'consum', 0.0217, 'lps'),
	(615826, 130, '2014-04-01 00:52:47.000000', 'consum', 0.0210, 'lps'),
	(615827, 130, '2014-04-01 00:52:48.000000', 'consum', 0.0214, 'lps'),
	(615828, 130, '2014-04-01 00:52:49.000000', 'consum', 0.0220, 'lps'),
	(615829, 130, '2014-04-01 00:52:50.000000', 'consum', 0.0221, 'lps'),
	(615830, 130, '2014-04-01 00:52:51.000000', 'consum', 0.0213, 'lps'),
	(615831, 130, '2014-04-01 00:52:52.000000', 'consum', 0.0218, 'lps'),
	(615832, 130, '2014-04-01 00:52:53.000000', 'consum', 0.0216, 'lps'),
	(615833, 130, '2014-04-01 00:52:54.000000', 'consum', 0.0217, 'lps'),
	(615834, 130, '2014-04-01 00:52:55.000000', 'consum', 0.0215, 'lps'),
	(615835, 130, '2014-04-01 00:52:56.000000', 'consum', 0.0215, 'lps'),
	(615836, 130, '2014-04-01 00:52:57.000000', 'consum', 0.0220, 'lps'),
	(615837, 130, '2014-04-01 00:52:58.000000', 'consum', 0.0210, 'lps'),
	(615838, 130, '2014-04-01 00:52:59.000000', 'consum', 0.0218, 'lps'),
	(615839, 130, '2014-04-01 00:53:00.000000', 'consum', 0.0212, 'lps'),
	(615840, 130, '2014-04-01 00:53:01.000000', 'consum', 0.0220, 'lps'),
	(615841, 130, '2014-04-01 00:53:02.000000', 'consum', 0.0220, 'lps'),
	(615842, 130, '2014-04-01 00:53:03.000000', 'consum', 0.0220, 'lps'),
	(615843, 130, '2014-04-01 00:53:04.000000', 'consum', 0.0217, 'lps'),
	(615844, 130, '2014-04-01 00:53:05.000000', 'consum', 0.0217, 'lps'),
	(615845, 130, '2014-04-01 00:53:06.000000', 'consum', 0.0213, 'lps'),
	(615846, 130, '2014-04-01 00:53:07.000000', 'consum', 0.0215, 'lps'),
	(615847, 130, '2014-04-01 00:53:08.000000', 'consum', 0.0213, 'lps'),
	(615848, 130, '2014-04-01 00:53:09.000000', 'consum', 0.0213, 'lps'),
	(615849, 130, '2014-04-01 00:53:10.000000', 'consum', 0.0215, 'lps'),
	(615850, 130, '2014-04-01 00:53:11.000000', 'consum', 0.0214, 'lps'),
	(615851, 130, '2014-04-01 00:53:12.000000', 'consum', 0.0214, 'lps'),
	(615852, 130, '2014-04-01 00:53:13.000000', 'consum', 0.0210, 'lps'),
	(615853, 130, '2014-04-01 00:53:14.000000', 'consum', 0.0220, 'lps'),
	(615854, 130, '2014-04-01 00:53:15.000000', 'consum', 0.0212, 'lps'),
	(615855, 130, '2014-04-01 00:53:16.000000', 'consum', 0.0215, 'lps'),
	(615856, 130, '2014-04-01 00:53:17.000000', 'consum', 0.0219, 'lps'),
	(615857, 130, '2014-04-01 00:53:18.000000', 'consum', 0.0216, 'lps'),
	(615858, 130, '2014-04-01 00:53:19.000000', 'consum', 0.0214, 'lps'),
	(615859, 130, '2014-04-01 00:53:20.000000', 'consum', 0.0211, 'lps'),
	(615860, 130, '2014-04-01 00:53:21.000000', 'consum', 0.0217, 'lps'),
	(615861, 130, '2014-04-01 00:53:22.000000', 'consum', 0.0218, 'lps'),
	(615862, 130, '2014-04-01 00:53:23.000000', 'consum', 0.0218, 'lps'),
	(615863, 130, '2014-04-01 00:53:24.000000', 'consum', 0.0216, 'lps'),
	(615864, 130, '2014-04-01 00:53:25.000000', 'consum', 0.0214, 'lps'),
	(615865, 130, '2014-04-01 00:53:26.000000', 'consum', 0.0214, 'lps'),
	(615866, 130, '2014-04-01 00:53:27.000000', 'consum', 0.0218, 'lps'),
	(615867, 130, '2014-04-01 00:53:28.000000', 'consum', 0.0214, 'lps'),
	(615868, 130, '2014-04-01 00:53:29.000000', 'consum', 0.0217, 'lps'),
	(615869, 130, '2014-04-01 00:53:30.000000', 'consum', 0.0210, 'lps'),
	(615870, 130, '2014-04-01 00:53:31.000000', 'consum', 0.0215, 'lps'),
	(615871, 130, '2014-04-01 00:53:32.000000', 'consum', 0.0221, 'lps'),
	(615872, 130, '2014-04-01 00:53:33.000000', 'consum', 0.0215, 'lps'),
	(615873, 130, '2014-04-01 00:53:34.000000', 'consum', 0.0214, 'lps'),
	(615874, 130, '2014-04-01 00:53:35.000000', 'consum', 0.0215, 'lps'),
	(615875, 130, '2014-04-01 00:53:36.000000', 'consum', 0.0214, 'lps'),
	(615876, 130, '2014-04-01 00:53:37.000000', 'consum', 0.0214, 'lps'),
	(615877, 130, '2014-04-01 00:53:38.000000', 'consum', 0.0220, 'lps'),
	(615878, 130, '2014-04-01 00:53:39.000000', 'consum', 0.0213, 'lps'),
	(615879, 130, '2014-04-01 00:53:40.000000', 'consum', 0.0217, 'lps'),
	(615880, 130, '2014-04-01 00:53:41.000000', 'consum', 0.0213, 'lps'),
	(615881, 130, '2014-04-01 00:53:42.000000', 'consum', 0.0216, 'lps'),
	(615882, 130, '2014-04-01 00:53:43.000000', 'consum', 0.0218, 'lps'),
	(615883, 130, '2014-04-01 00:53:44.000000', 'consum', 0.0210, 'lps'),
	(615884, 130, '2014-04-01 00:53:45.000000', 'consum', 0.0211, 'lps'),
	(615885, 130, '2014-04-01 00:53:46.000000', 'consum', 0.0217, 'lps'),
	(615886, 130, '2014-04-01 00:53:47.000000', 'consum', 0.0215, 'lps'),
	(615887, 130, '2014-04-01 00:53:48.000000', 'consum', 0.0218, 'lps'),
	(615888, 130, '2014-04-01 00:53:49.000000', 'consum', 0.0211, 'lps'),
	(615889, 130, '2014-04-01 00:53:50.000000', 'consum', 0.0214, 'lps'),
	(615890, 130, '2014-04-01 00:53:51.000000', 'consum', 0.0216, 'lps'),
	(615891, 130, '2014-04-01 00:53:52.000000', 'consum', 0.0217, 'lps'),
	(615892, 130, '2014-04-01 00:53:53.000000', 'consum', 0.0217, 'lps'),
	(615893, 130, '2014-04-01 00:53:54.000000', 'consum', 0.0211, 'lps'),
	(615894, 130, '2014-04-01 00:53:55.000000', 'consum', 0.0217, 'lps'),
	(615895, 130, '2014-04-01 00:53:56.000000', 'consum', 0.0218, 'lps'),
	(615896, 130, '2014-04-01 00:53:57.000000', 'consum', 0.0218, 'lps'),
	(615897, 130, '2014-04-01 00:53:58.000000', 'consum', 0.0215, 'lps'),
	(615898, 130, '2014-04-01 00:53:59.000000', 'consum', 0.0212, 'lps'),
	(615899, 130, '2014-04-01 00:54:00.000000', 'consum', 0.0218, 'lps'),
	(615900, 130, '2014-04-01 00:54:01.000000', 'consum', 0.0219, 'lps'),
	(615901, 130, '2014-04-01 00:54:02.000000', 'consum', 0.0221, 'lps'),
	(615902, 130, '2014-04-01 00:54:03.000000', 'consum', 0.0216, 'lps'),
	(615903, 130, '2014-04-01 00:54:04.000000', 'consum', 0.0218, 'lps'),
	(615904, 130, '2014-04-01 00:54:05.000000', 'consum', 0.0221, 'lps'),
	(615905, 130, '2014-04-01 00:54:06.000000', 'consum', 0.0217, 'lps'),
	(615906, 130, '2014-04-01 00:54:07.000000', 'consum', 0.0213, 'lps'),
	(615907, 130, '2014-04-01 00:54:08.000000', 'consum', 0.0217, 'lps'),
	(615908, 130, '2014-04-01 00:54:09.000000', 'consum', 0.0212, 'lps'),
	(615909, 130, '2014-04-01 00:54:10.000000', 'consum', 0.0211, 'lps'),
	(615910, 130, '2014-04-01 00:54:11.000000', 'consum', 0.0220, 'lps'),
	(615911, 130, '2014-04-01 00:54:12.000000', 'consum', 0.0212, 'lps'),
	(615912, 130, '2014-04-01 00:54:13.000000', 'consum', 0.0214, 'lps'),
	(615913, 130, '2014-04-01 00:54:14.000000', 'consum', 0.0210, 'lps'),
	(615914, 130, '2014-04-01 00:54:15.000000', 'consum', 0.0213, 'lps'),
	(615915, 130, '2014-04-01 00:54:16.000000', 'consum', 0.0213, 'lps'),
	(615916, 130, '2014-04-01 00:54:17.000000', 'consum', 0.0215, 'lps'),
	(615917, 130, '2014-04-01 00:54:18.000000', 'consum', 0.0214, 'lps'),
	(615918, 130, '2014-04-01 00:54:19.000000', 'consum', 0.0217, 'lps'),
	(615919, 130, '2014-04-01 00:54:20.000000', 'consum', 0.0210, 'lps'),
	(615920, 130, '2014-04-01 00:54:21.000000', 'consum', 0.0212, 'lps'),
	(615921, 130, '2014-04-01 00:54:22.000000', 'consum', 0.0220, 'lps'),
	(615922, 130, '2014-04-01 00:54:23.000000', 'consum', 0.0221, 'lps'),
	(615923, 130, '2014-04-01 00:54:24.000000', 'consum', 0.0210, 'lps'),
	(615924, 130, '2014-04-01 00:54:25.000000', 'consum', 0.0213, 'lps'),
	(615925, 130, '2014-04-01 00:54:26.000000', 'consum', 0.0212, 'lps'),
	(615926, 130, '2014-04-01 00:54:27.000000', 'consum', 0.0212, 'lps'),
	(615927, 130, '2014-04-01 00:54:28.000000', 'consum', 0.0216, 'lps'),
	(615928, 130, '2014-04-01 00:54:29.000000', 'consum', 0.0211, 'lps'),
	(615929, 130, '2014-04-01 00:54:30.000000', 'consum', 0.0220, 'lps'),
	(615930, 130, '2014-04-01 00:54:31.000000', 'consum', 0.0220, 'lps'),
	(615931, 130, '2014-04-01 00:54:32.000000', 'consum', 0.0220, 'lps'),
	(615932, 130, '2014-04-01 00:54:33.000000', 'consum', 0.0219, 'lps'),
	(615933, 130, '2014-04-01 00:54:34.000000', 'consum', 0.0215, 'lps'),
	(615934, 130, '2014-04-01 00:54:35.000000', 'consum', 0.0218, 'lps'),
	(615935, 130, '2014-04-01 00:54:36.000000', 'consum', 0.0211, 'lps'),
	(615936, 130, '2014-04-01 00:54:37.000000', 'consum', 0.0218, 'lps'),
	(615937, 130, '2014-04-01 00:54:38.000000', 'consum', 0.0211, 'lps'),
	(615938, 130, '2014-04-01 00:54:39.000000', 'consum', 0.0215, 'lps'),
	(615939, 130, '2014-04-01 00:54:40.000000', 'consum', 0.0210, 'lps'),
	(615940, 130, '2014-04-01 00:54:41.000000', 'consum', 0.0220, 'lps'),
	(615941, 130, '2014-04-01 00:54:42.000000', 'consum', 0.0210, 'lps'),
	(615942, 130, '2014-04-01 00:54:43.000000', 'consum', 0.0219, 'lps'),
	(615943, 130, '2014-04-01 00:54:44.000000', 'consum', 0.0218, 'lps'),
	(615944, 130, '2014-04-01 00:54:45.000000', 'consum', 0.0214, 'lps'),
	(615945, 130, '2014-04-01 00:54:46.000000', 'consum', 0.0217, 'lps'),
	(615946, 130, '2014-04-01 00:54:47.000000', 'consum', 0.0220, 'lps'),
	(615947, 130, '2014-04-01 00:54:48.000000', 'consum', 0.0217, 'lps'),
	(615948, 130, '2014-04-01 00:54:49.000000', 'consum', 0.0216, 'lps'),
	(615949, 130, '2014-04-01 00:54:50.000000', 'consum', 0.0217, 'lps'),
	(615950, 130, '2014-04-01 00:54:51.000000', 'consum', 0.0216, 'lps'),
	(615951, 130, '2014-04-01 00:54:52.000000', 'consum', 0.0221, 'lps'),
	(615952, 130, '2014-04-01 00:54:53.000000', 'consum', 0.0211, 'lps'),
	(615953, 130, '2014-04-01 00:54:54.000000', 'consum', 0.0219, 'lps'),
	(615954, 130, '2014-04-01 00:54:55.000000', 'consum', 0.0218, 'lps'),
	(615955, 130, '2014-04-01 00:54:56.000000', 'consum', 0.0220, 'lps'),
	(615956, 130, '2014-04-01 00:54:57.000000', 'consum', 0.0216, 'lps'),
	(615957, 130, '2014-04-01 00:54:58.000000', 'consum', 0.0219, 'lps'),
	(615958, 130, '2014-04-01 00:54:59.000000', 'consum', 0.0216, 'lps'),
	(615959, 130, '2014-04-01 00:55:00.000000', 'consum', 0.0214, 'lps'),
	(615960, 130, '2014-04-01 00:55:01.000000', 'consum', 0.0214, 'lps'),
	(615961, 130, '2014-04-01 00:55:02.000000', 'consum', 0.0215, 'lps'),
	(615962, 130, '2014-04-01 00:55:03.000000', 'consum', 0.0213, 'lps'),
	(615963, 130, '2014-04-01 00:55:04.000000', 'consum', 0.0211, 'lps'),
	(615964, 130, '2014-04-01 00:55:05.000000', 'consum', 0.0216, 'lps'),
	(615965, 130, '2014-04-01 00:55:06.000000', 'consum', 0.0215, 'lps'),
	(615966, 130, '2014-04-01 00:55:07.000000', 'consum', 0.0216, 'lps'),
	(615967, 130, '2014-04-01 00:55:08.000000', 'consum', 0.0216, 'lps'),
	(615968, 130, '2014-04-01 00:55:09.000000', 'consum', 0.0221, 'lps'),
	(615969, 130, '2014-04-01 00:55:10.000000', 'consum', 0.0211, 'lps'),
	(615970, 130, '2014-04-01 00:55:11.000000', 'consum', 0.0219, 'lps'),
	(615971, 130, '2014-04-01 00:55:12.000000', 'consum', 0.0215, 'lps'),
	(615972, 130, '2014-04-01 00:55:13.000000', 'consum', 0.0211, 'lps'),
	(615973, 130, '2014-04-01 00:55:14.000000', 'consum', 0.0211, 'lps'),
	(615974, 130, '2014-04-01 00:55:15.000000', 'consum', 0.0213, 'lps'),
	(615975, 130, '2014-04-01 00:55:16.000000', 'consum', 0.0212, 'lps'),
	(615976, 130, '2014-04-01 00:55:17.000000', 'consum', 0.0210, 'lps'),
	(615977, 130, '2014-04-01 00:55:18.000000', 'consum', 0.0219, 'lps'),
	(615978, 130, '2014-04-01 00:55:19.000000', 'consum', 0.0217, 'lps'),
	(615979, 130, '2014-04-01 00:55:20.000000', 'consum', 0.0219, 'lps'),
	(615980, 130, '2014-04-01 00:55:21.000000', 'consum', 0.0210, 'lps'),
	(615981, 130, '2014-04-01 00:55:22.000000', 'consum', 0.0221, 'lps'),
	(615982, 130, '2014-04-01 00:55:23.000000', 'consum', 0.0216, 'lps'),
	(615983, 130, '2014-04-01 00:55:24.000000', 'consum', 0.0219, 'lps'),
	(615984, 130, '2014-04-01 00:55:25.000000', 'consum', 0.0213, 'lps'),
	(615985, 130, '2014-04-01 00:55:26.000000', 'consum', 0.0212, 'lps'),
	(615986, 130, '2014-04-01 00:55:27.000000', 'consum', 0.0210, 'lps'),
	(615987, 130, '2014-04-01 00:55:28.000000', 'consum', 0.0218, 'lps'),
	(615988, 130, '2014-04-01 00:55:29.000000', 'consum', 0.0214, 'lps'),
	(615989, 130, '2014-04-01 00:55:30.000000', 'consum', 0.0218, 'lps'),
	(615990, 130, '2014-04-01 00:55:31.000000', 'consum', 0.0215, 'lps'),
	(615991, 130, '2014-04-01 00:55:32.000000', 'consum', 0.0213, 'lps'),
	(615992, 130, '2014-04-01 00:55:33.000000', 'consum', 0.0219, 'lps'),
	(615993, 130, '2014-04-01 00:55:34.000000', 'consum', 0.0214, 'lps'),
	(615994, 130, '2014-04-01 00:55:35.000000', 'consum', 0.0214, 'lps'),
	(615995, 130, '2014-04-01 00:55:36.000000', 'consum', 0.0219, 'lps'),
	(615996, 130, '2014-04-01 00:55:37.000000', 'consum', 0.0220, 'lps'),
	(615997, 130, '2014-04-01 00:55:38.000000', 'consum', 0.0220, 'lps'),
	(615998, 130, '2014-04-01 00:55:39.000000', 'consum', 0.0220, 'lps'),
	(615999, 130, '2014-04-01 00:55:40.000000', 'consum', 0.0220, 'lps'),
	(616000, 130, '2014-04-01 00:55:41.000000', 'consum', 0.0216, 'lps'),
	(616001, 130, '2014-04-01 00:55:42.000000', 'consum', 0.0211, 'lps'),
	(616002, 130, '2014-04-01 00:55:43.000000', 'consum', 0.0221, 'lps'),
	(616003, 130, '2014-04-01 00:55:44.000000', 'consum', 0.0214, 'lps'),
	(616004, 130, '2014-04-01 00:55:45.000000', 'consum', 0.0211, 'lps'),
	(616005, 130, '2014-04-01 00:55:46.000000', 'consum', 0.0216, 'lps'),
	(616006, 130, '2014-04-01 00:55:47.000000', 'consum', 0.0215, 'lps'),
	(616007, 130, '2014-04-01 00:55:48.000000', 'consum', 0.0215, 'lps'),
	(616008, 130, '2014-04-01 00:55:49.000000', 'consum', 0.0211, 'lps'),
	(616009, 130, '2014-04-01 00:55:50.000000', 'consum', 0.0212, 'lps'),
	(616010, 130, '2014-04-01 00:55:51.000000', 'consum', 0.0216, 'lps'),
	(616011, 130, '2014-04-01 00:55:52.000000', 'consum', 0.0211, 'lps'),
	(616012, 130, '2014-04-01 00:55:53.000000', 'consum', 0.0211, 'lps'),
	(616013, 130, '2014-04-01 00:55:54.000000', 'consum', 0.0211, 'lps'),
	(616014, 130, '2014-04-01 00:55:55.000000', 'consum', 0.0214, 'lps'),
	(616015, 130, '2014-04-01 00:55:56.000000', 'consum', 0.0214, 'lps'),
	(616016, 130, '2014-04-01 00:55:57.000000', 'consum', 0.0219, 'lps'),
	(616017, 130, '2014-04-01 00:55:58.000000', 'consum', 0.0221, 'lps'),
	(616018, 130, '2014-04-01 00:55:59.000000', 'consum', 0.0215, 'lps'),
	(616019, 130, '2014-04-01 00:56:00.000000', 'consum', 0.0212, 'lps'),
	(616020, 130, '2014-04-01 00:56:01.000000', 'consum', 0.0217, 'lps'),
	(616021, 130, '2014-04-01 00:56:02.000000', 'consum', 0.0215, 'lps'),
	(616022, 130, '2014-04-01 00:56:03.000000', 'consum', 0.0215, 'lps'),
	(616023, 130, '2014-04-01 00:56:04.000000', 'consum', 0.0220, 'lps'),
	(616024, 130, '2014-04-01 00:56:05.000000', 'consum', 0.0220, 'lps'),
	(616025, 130, '2014-04-01 00:56:06.000000', 'consum', 0.0220, 'lps'),
	(616026, 130, '2014-04-01 00:56:07.000000', 'consum', 0.0220, 'lps'),
	(616027, 130, '2014-04-01 00:56:08.000000', 'consum', 0.0219, 'lps'),
	(616028, 130, '2014-04-01 00:56:09.000000', 'consum', 0.0213, 'lps'),
	(616029, 130, '2014-04-01 00:56:10.000000', 'consum', 0.0210, 'lps'),
	(616030, 130, '2014-04-01 00:56:11.000000', 'consum', 0.0212, 'lps'),
	(616031, 130, '2014-04-01 00:56:12.000000', 'consum', 0.0210, 'lps'),
	(616032, 130, '2014-04-01 00:56:13.000000', 'consum', 0.0215, 'lps'),
	(616033, 130, '2014-04-01 00:56:14.000000', 'consum', 0.0214, 'lps'),
	(616034, 130, '2014-04-01 00:56:15.000000', 'consum', 0.0212, 'lps'),
	(616035, 130, '2014-04-01 00:56:16.000000', 'consum', 0.0212, 'lps'),
	(616036, 130, '2014-04-01 00:56:17.000000', 'consum', 0.0212, 'lps'),
	(616037, 130, '2014-04-01 00:56:18.000000', 'consum', 0.0216, 'lps'),
	(616038, 130, '2014-04-01 00:56:19.000000', 'consum', 0.0211, 'lps'),
	(616039, 130, '2014-04-01 00:56:20.000000', 'consum', 0.0210, 'lps'),
	(616040, 130, '2014-04-01 00:56:21.000000', 'consum', 0.0218, 'lps'),
	(616041, 130, '2014-04-01 00:56:22.000000', 'consum', 0.0214, 'lps'),
	(616042, 130, '2014-04-01 00:56:23.000000', 'consum', 0.0219, 'lps'),
	(616043, 130, '2014-04-01 00:56:24.000000', 'consum', 0.0218, 'lps'),
	(616044, 130, '2014-04-01 00:56:25.000000', 'consum', 0.0213, 'lps'),
	(616045, 130, '2014-04-01 00:56:26.000000', 'consum', 0.0212, 'lps'),
	(616046, 130, '2014-04-01 00:56:27.000000', 'consum', 0.0212, 'lps'),
	(616047, 130, '2014-04-01 00:56:28.000000', 'consum', 0.0213, 'lps'),
	(616048, 130, '2014-04-01 00:56:29.000000', 'consum', 0.0221, 'lps'),
	(616049, 130, '2014-04-01 00:56:30.000000', 'consum', 0.0219, 'lps'),
	(616050, 130, '2014-04-01 00:56:31.000000', 'consum', 0.0213, 'lps'),
	(616051, 130, '2014-04-01 00:56:32.000000', 'consum', 0.0221, 'lps'),
	(616052, 130, '2014-04-01 00:56:33.000000', 'consum', 0.0221, 'lps'),
	(616053, 130, '2014-04-01 00:56:34.000000', 'consum', 0.0219, 'lps'),
	(616054, 130, '2014-04-01 00:56:35.000000', 'consum', 0.0211, 'lps'),
	(616055, 130, '2014-04-01 00:56:36.000000', 'consum', 0.0212, 'lps'),
	(616056, 130, '2014-04-01 00:56:37.000000', 'consum', 0.0216, 'lps'),
	(616057, 130, '2014-04-01 00:56:38.000000', 'consum', 0.0213, 'lps'),
	(616058, 130, '2014-04-01 00:56:39.000000', 'consum', 0.0218, 'lps'),
	(616059, 130, '2014-04-01 00:56:40.000000', 'consum', 0.0218, 'lps'),
	(616060, 130, '2014-04-01 00:56:41.000000', 'consum', 0.0213, 'lps'),
	(616061, 130, '2014-04-01 00:56:42.000000', 'consum', 0.0214, 'lps'),
	(616062, 130, '2014-04-01 00:56:43.000000', 'consum', 0.0220, 'lps'),
	(616063, 130, '2014-04-01 00:56:44.000000', 'consum', 0.0215, 'lps'),
	(616064, 130, '2014-04-01 00:56:45.000000', 'consum', 0.0217, 'lps'),
	(616065, 130, '2014-04-01 00:56:46.000000', 'consum', 0.0217, 'lps'),
	(616066, 130, '2014-04-01 00:56:47.000000', 'consum', 0.0212, 'lps'),
	(616067, 130, '2014-04-01 00:56:48.000000', 'consum', 0.0214, 'lps'),
	(616068, 130, '2014-04-01 00:56:49.000000', 'consum', 0.0221, 'lps'),
	(616069, 130, '2014-04-01 00:56:50.000000', 'consum', 0.0221, 'lps'),
	(616070, 130, '2014-04-01 00:56:51.000000', 'consum', 0.0218, 'lps'),
	(616071, 130, '2014-04-01 00:56:52.000000', 'consum', 0.0217, 'lps'),
	(616072, 130, '2014-04-01 00:56:53.000000', 'consum', 0.0212, 'lps'),
	(616073, 130, '2014-04-01 00:56:54.000000', 'consum', 0.0211, 'lps'),
	(616074, 130, '2014-04-01 00:56:55.000000', 'consum', 0.0220, 'lps'),
	(616075, 130, '2014-04-01 00:56:56.000000', 'consum', 0.0210, 'lps'),
	(616076, 130, '2014-04-01 00:56:57.000000', 'consum', 0.0217, 'lps'),
	(616077, 130, '2014-04-01 00:56:58.000000', 'consum', 0.0221, 'lps'),
	(616078, 130, '2014-04-01 00:56:59.000000', 'consum', 0.0219, 'lps'),
	(616079, 130, '2014-04-01 00:57:00.000000', 'consum', 0.0212, 'lps'),
	(616080, 130, '2014-04-01 00:57:01.000000', 'consum', 0.0216, 'lps'),
	(616081, 130, '2014-04-01 00:57:02.000000', 'consum', 0.0213, 'lps'),
	(616082, 130, '2014-04-01 00:57:03.000000', 'consum', 0.0218, 'lps'),
	(616083, 130, '2014-04-01 00:57:04.000000', 'consum', 0.0219, 'lps'),
	(616084, 130, '2014-04-01 00:57:05.000000', 'consum', 0.0219, 'lps'),
	(616085, 130, '2014-04-01 00:57:06.000000', 'consum', 0.0215, 'lps'),
	(616086, 130, '2014-04-01 00:57:07.000000', 'consum', 0.0210, 'lps'),
	(616087, 130, '2014-04-01 00:57:08.000000', 'consum', 0.0217, 'lps'),
	(616088, 130, '2014-04-01 00:57:09.000000', 'consum', 0.0213, 'lps'),
	(616089, 130, '2014-04-01 00:57:10.000000', 'consum', 0.0215, 'lps'),
	(616090, 130, '2014-04-01 00:57:11.000000', 'consum', 0.0214, 'lps'),
	(616091, 130, '2014-04-01 00:57:12.000000', 'consum', 0.0215, 'lps'),
	(616092, 130, '2014-04-01 00:57:13.000000', 'consum', 0.0213, 'lps'),
	(616093, 130, '2014-04-01 00:57:14.000000', 'consum', 0.0212, 'lps'),
	(616094, 130, '2014-04-01 00:57:15.000000', 'consum', 0.0210, 'lps'),
	(616095, 130, '2014-04-01 00:57:16.000000', 'consum', 0.0215, 'lps'),
	(616096, 130, '2014-04-01 00:57:17.000000', 'consum', 0.0212, 'lps'),
	(616097, 130, '2014-04-01 00:57:18.000000', 'consum', 0.0219, 'lps'),
	(616098, 130, '2014-04-01 00:57:19.000000', 'consum', 0.0212, 'lps'),
	(616099, 130, '2014-04-01 00:57:20.000000', 'consum', 0.0218, 'lps'),
	(616100, 130, '2014-04-01 00:57:21.000000', 'consum', 0.0219, 'lps'),
	(616101, 130, '2014-04-01 00:57:22.000000', 'consum', 0.0220, 'lps'),
	(616102, 130, '2014-04-01 00:57:23.000000', 'consum', 0.0210, 'lps'),
	(616103, 130, '2014-04-01 00:57:24.000000', 'consum', 0.0217, 'lps'),
	(616104, 130, '2014-04-01 00:57:25.000000', 'consum', 0.0221, 'lps'),
	(616105, 130, '2014-04-01 00:57:26.000000', 'consum', 0.0210, 'lps'),
	(616106, 130, '2014-04-01 00:57:27.000000', 'consum', 0.0213, 'lps'),
	(616107, 130, '2014-04-01 00:57:28.000000', 'consum', 0.0214, 'lps'),
	(616108, 130, '2014-04-01 00:57:29.000000', 'consum', 0.0211, 'lps'),
	(616109, 130, '2014-04-01 00:57:30.000000', 'consum', 0.0214, 'lps'),
	(616110, 130, '2014-04-01 00:57:31.000000', 'consum', 0.0215, 'lps'),
	(616111, 130, '2014-04-01 00:57:32.000000', 'consum', 0.0210, 'lps'),
	(616112, 130, '2014-04-01 00:57:33.000000', 'consum', 0.0210, 'lps'),
	(616113, 130, '2014-04-01 00:57:34.000000', 'consum', 0.0211, 'lps'),
	(616114, 130, '2014-04-01 00:57:35.000000', 'consum', 0.0216, 'lps'),
	(616115, 130, '2014-04-01 00:57:36.000000', 'consum', 0.0212, 'lps'),
	(616116, 130, '2014-04-01 00:57:37.000000', 'consum', 0.0215, 'lps'),
	(616117, 130, '2014-04-01 00:57:38.000000', 'consum', 0.0216, 'lps'),
	(616118, 130, '2014-04-01 00:57:39.000000', 'consum', 0.0216, 'lps'),
	(616119, 130, '2014-04-01 00:57:40.000000', 'consum', 0.0221, 'lps'),
	(616120, 130, '2014-04-01 00:57:41.000000', 'consum', 0.0212, 'lps'),
	(616121, 130, '2014-04-01 00:57:42.000000', 'consum', 0.0212, 'lps'),
	(616122, 130, '2014-04-01 00:57:43.000000', 'consum', 0.0214, 'lps'),
	(616123, 130, '2014-04-01 00:57:44.000000', 'consum', 0.0214, 'lps'),
	(616124, 130, '2014-04-01 00:57:45.000000', 'consum', 0.0218, 'lps'),
	(616125, 130, '2014-04-01 00:57:46.000000', 'consum', 0.0216, 'lps'),
	(616126, 130, '2014-04-01 00:57:47.000000', 'consum', 0.0216, 'lps'),
	(616127, 130, '2014-04-01 00:57:48.000000', 'consum', 0.0221, 'lps'),
	(616128, 130, '2014-04-01 00:57:49.000000', 'consum', 0.0211, 'lps'),
	(616129, 130, '2014-04-01 00:57:50.000000', 'consum', 0.0219, 'lps'),
	(616130, 130, '2014-04-01 00:57:51.000000', 'consum', 0.0217, 'lps'),
	(616131, 130, '2014-04-01 00:57:52.000000', 'consum', 0.0216, 'lps'),
	(616132, 130, '2014-04-01 00:57:53.000000', 'consum', 0.0211, 'lps'),
	(616133, 130, '2014-04-01 00:57:54.000000', 'consum', 0.0220, 'lps'),
	(616134, 130, '2014-04-01 00:57:55.000000', 'consum', 0.0221, 'lps'),
	(616135, 130, '2014-04-01 00:57:56.000000', 'consum', 0.0212, 'lps'),
	(616136, 130, '2014-04-01 00:57:57.000000', 'consum', 0.0212, 'lps'),
	(616137, 130, '2014-04-01 00:57:58.000000', 'consum', 0.0213, 'lps'),
	(616138, 130, '2014-04-01 00:57:59.000000', 'consum', 0.0210, 'lps'),
	(616139, 130, '2014-04-01 00:58:00.000000', 'consum', 0.0213, 'lps'),
	(616140, 130, '2014-04-01 00:58:01.000000', 'consum', 0.0213, 'lps'),
	(616141, 130, '2014-04-01 00:58:02.000000', 'consum', 0.0219, 'lps'),
	(616142, 130, '2014-04-01 00:58:03.000000', 'consum', 0.0219, 'lps'),
	(616143, 130, '2014-04-01 00:58:04.000000', 'consum', 0.0216, 'lps'),
	(616144, 130, '2014-04-01 00:58:05.000000', 'consum', 0.0215, 'lps'),
	(616145, 130, '2014-04-01 00:58:06.000000', 'consum', 0.0219, 'lps'),
	(616146, 130, '2014-04-01 00:58:07.000000', 'consum', 0.0216, 'lps'),
	(616147, 130, '2014-04-01 00:58:08.000000', 'consum', 0.0212, 'lps'),
	(616148, 130, '2014-04-01 00:58:09.000000', 'consum', 0.0213, 'lps'),
	(616149, 130, '2014-04-01 00:58:10.000000', 'consum', 0.0210, 'lps'),
	(616150, 130, '2014-04-01 00:58:11.000000', 'consum', 0.0211, 'lps'),
	(616151, 130, '2014-04-01 00:58:12.000000', 'consum', 0.0217, 'lps'),
	(616152, 130, '2014-04-01 00:58:13.000000', 'consum', 0.0219, 'lps'),
	(616153, 130, '2014-04-01 00:58:14.000000', 'consum', 0.0211, 'lps'),
	(616154, 130, '2014-04-01 00:58:15.000000', 'consum', 0.0214, 'lps'),
	(616155, 130, '2014-04-01 00:58:16.000000', 'consum', 0.0214, 'lps'),
	(616156, 130, '2014-04-01 00:58:17.000000', 'consum', 0.0217, 'lps'),
	(616157, 130, '2014-04-01 00:58:18.000000', 'consum', 0.0212, 'lps'),
	(616158, 130, '2014-04-01 00:58:19.000000', 'consum', 0.0212, 'lps'),
	(616159, 130, '2014-04-01 00:58:20.000000', 'consum', 0.0212, 'lps'),
	(616160, 130, '2014-04-01 00:58:21.000000', 'consum', 0.0216, 'lps'),
	(616161, 130, '2014-04-01 00:58:22.000000', 'consum', 0.0220, 'lps'),
	(616162, 130, '2014-04-01 00:58:23.000000', 'consum', 0.0220, 'lps'),
	(616163, 130, '2014-04-01 00:58:24.000000', 'consum', 0.0220, 'lps'),
	(616164, 130, '2014-04-01 00:58:25.000000', 'consum', 0.0216, 'lps'),
	(616165, 130, '2014-04-01 00:58:26.000000', 'consum', 0.0210, 'lps'),
	(616166, 130, '2014-04-01 00:58:27.000000', 'consum', 0.0217, 'lps'),
	(616167, 130, '2014-04-01 00:58:28.000000', 'consum', 0.0212, 'lps'),
	(616168, 130, '2014-04-01 00:58:29.000000', 'consum', 0.0210, 'lps'),
	(616169, 130, '2014-04-01 00:58:30.000000', 'consum', 0.0214, 'lps'),
	(616170, 130, '2014-04-01 00:58:31.000000', 'consum', 0.0210, 'lps'),
	(616171, 130, '2014-04-01 00:58:32.000000', 'consum', 0.0221, 'lps'),
	(616172, 130, '2014-04-01 00:58:33.000000', 'consum', 0.0217, 'lps'),
	(616173, 130, '2014-04-01 00:58:34.000000', 'consum', 0.0215, 'lps'),
	(616174, 130, '2014-04-01 00:58:35.000000', 'consum', 0.0212, 'lps'),
	(616175, 130, '2014-04-01 00:58:36.000000', 'consum', 0.0218, 'lps'),
	(616176, 130, '2014-04-01 00:58:37.000000', 'consum', 0.0211, 'lps'),
	(616177, 130, '2014-04-01 00:58:38.000000', 'consum', 0.0212, 'lps'),
	(616178, 130, '2014-04-01 00:58:39.000000', 'consum', 0.0219, 'lps'),
	(616179, 130, '2014-04-01 00:58:40.000000', 'consum', 0.0213, 'lps'),
	(616180, 130, '2014-04-01 00:58:41.000000', 'consum', 0.0221, 'lps'),
	(616181, 130, '2014-04-01 00:58:42.000000', 'consum', 0.0212, 'lps'),
	(616182, 130, '2014-04-01 00:58:43.000000', 'consum', 0.0220, 'lps'),
	(616183, 130, '2014-04-01 00:58:44.000000', 'consum', 0.0220, 'lps'),
	(616184, 130, '2014-04-01 00:58:45.000000', 'consum', 0.0216, 'lps'),
	(616185, 130, '2014-04-01 00:58:46.000000', 'consum', 0.0213, 'lps'),
	(616186, 130, '2014-04-01 00:58:47.000000', 'consum', 0.0220, 'lps'),
	(616187, 130, '2014-04-01 00:58:48.000000', 'consum', 0.0214, 'lps'),
	(616188, 130, '2014-04-01 00:58:49.000000', 'consum', 0.0215, 'lps'),
	(616189, 130, '2014-04-01 00:58:50.000000', 'consum', 0.0210, 'lps'),
	(616190, 130, '2014-04-01 00:58:51.000000', 'consum', 0.0219, 'lps'),
	(616191, 130, '2014-04-01 00:58:52.000000', 'consum', 0.0221, 'lps'),
	(616192, 130, '2014-04-01 00:58:53.000000', 'consum', 0.0212, 'lps'),
	(616193, 130, '2014-04-01 00:58:54.000000', 'consum', 0.0214, 'lps'),
	(616194, 130, '2014-04-01 00:58:55.000000', 'consum', 0.0210, 'lps'),
	(616195, 130, '2014-04-01 00:58:56.000000', 'consum', 0.0213, 'lps'),
	(616196, 130, '2014-04-01 00:58:57.000000', 'consum', 0.0214, 'lps'),
	(616197, 130, '2014-04-01 00:58:58.000000', 'consum', 0.0220, 'lps'),
	(616198, 130, '2014-04-01 00:58:59.000000', 'consum', 0.0214, 'lps'),
	(616199, 130, '2014-04-01 00:59:00.000000', 'consum', 0.0212, 'lps'),
	(616200, 130, '2014-04-01 00:59:01.000000', 'consum', 0.0221, 'lps'),
	(616201, 130, '2014-04-01 00:59:02.000000', 'consum', 0.0210, 'lps'),
	(616202, 130, '2014-04-01 00:59:03.000000', 'consum', 0.0216, 'lps'),
	(616203, 130, '2014-04-01 00:59:04.000000', 'consum', 0.0214, 'lps'),
	(616204, 130, '2014-04-01 00:59:05.000000', 'consum', 0.0212, 'lps'),
	(616205, 130, '2014-04-01 00:59:06.000000', 'consum', 0.0221, 'lps'),
	(616206, 130, '2014-04-01 00:59:07.000000', 'consum', 0.0211, 'lps'),
	(616207, 130, '2014-04-01 00:59:08.000000', 'consum', 0.0219, 'lps'),
	(616208, 130, '2014-04-01 00:59:09.000000', 'consum', 0.0219, 'lps'),
	(616209, 130, '2014-04-01 00:59:10.000000', 'consum', 0.0213, 'lps'),
	(616210, 130, '2014-04-01 00:59:11.000000', 'consum', 0.0212, 'lps'),
	(616211, 130, '2014-04-01 00:59:12.000000', 'consum', 0.0210, 'lps'),
	(616212, 130, '2014-04-01 00:59:13.000000', 'consum', 0.0217, 'lps'),
	(616213, 130, '2014-04-01 00:59:14.000000', 'consum', 0.0211, 'lps'),
	(616214, 130, '2014-04-01 00:59:15.000000', 'consum', 0.0220, 'lps'),
	(616215, 130, '2014-04-01 00:59:16.000000', 'consum', 0.0218, 'lps'),
	(616216, 130, '2014-04-01 00:59:17.000000', 'consum', 0.0212, 'lps'),
	(616217, 130, '2014-04-01 00:59:18.000000', 'consum', 0.0217, 'lps'),
	(616218, 130, '2014-04-01 00:59:19.000000', 'consum', 0.0217, 'lps'),
	(616219, 130, '2014-04-01 00:59:20.000000', 'consum', 0.0214, 'lps'),
	(616220, 130, '2014-04-01 00:59:21.000000', 'consum', 0.0221, 'lps'),
	(616221, 130, '2014-04-01 00:59:22.000000', 'consum', 0.0217, 'lps'),
	(616222, 130, '2014-04-01 00:59:23.000000', 'consum', 0.0212, 'lps'),
	(616223, 130, '2014-04-01 00:59:24.000000', 'consum', 0.0214, 'lps'),
	(616224, 130, '2014-04-01 00:59:25.000000', 'consum', 0.0210, 'lps'),
	(616225, 130, '2014-04-01 00:59:26.000000', 'consum', 0.0211, 'lps'),
	(616226, 130, '2014-04-01 00:59:27.000000', 'consum', 0.0217, 'lps'),
	(616227, 130, '2014-04-01 00:59:28.000000', 'consum', 0.0216, 'lps'),
	(616228, 130, '2014-04-01 00:59:29.000000', 'consum', 0.0210, 'lps'),
	(616229, 130, '2014-04-01 00:59:30.000000', 'consum', 0.0216, 'lps'),
	(616230, 130, '2014-04-01 00:59:31.000000', 'consum', 0.0215, 'lps'),
	(616231, 130, '2014-04-01 00:59:32.000000', 'consum', 0.0218, 'lps'),
	(616232, 130, '2014-04-01 00:59:33.000000', 'consum', 0.0213, 'lps'),
	(616233, 130, '2014-04-01 00:59:34.000000', 'consum', 0.0212, 'lps'),
	(616234, 130, '2014-04-01 00:59:35.000000', 'consum', 0.0213, 'lps'),
	(616235, 130, '2014-04-01 00:59:36.000000', 'consum', 0.0220, 'lps'),
	(616236, 130, '2014-04-01 00:59:37.000000', 'consum', 0.0215, 'lps'),
	(616237, 130, '2014-04-01 00:59:38.000000', 'consum', 0.0217, 'lps'),
	(616238, 130, '2014-04-01 00:59:39.000000', 'consum', 0.0219, 'lps'),
	(616239, 130, '2014-04-01 00:59:40.000000', 'consum', 0.0212, 'lps'),
	(616240, 130, '2014-04-01 00:59:41.000000', 'consum', 0.0217, 'lps'),
	(616241, 130, '2014-04-01 00:59:42.000000', 'consum', 0.0213, 'lps'),
	(616242, 130, '2014-04-01 00:59:43.000000', 'consum', 0.0220, 'lps'),
	(616243, 130, '2014-04-01 00:59:44.000000', 'consum', 0.0212, 'lps'),
	(616244, 130, '2014-04-01 00:59:45.000000', 'consum', 0.0216, 'lps'),
	(616245, 130, '2014-04-01 00:59:46.000000', 'consum', 0.0212, 'lps'),
	(616246, 130, '2014-04-01 00:59:47.000000', 'consum', 0.0214, 'lps'),
	(616247, 130, '2014-04-01 00:59:48.000000', 'consum', 0.0210, 'lps'),
	(616248, 130, '2014-04-01 00:59:49.000000', 'consum', 0.0212, 'lps'),
	(616249, 130, '2014-04-01 00:59:50.000000', 'consum', 0.0210, 'lps'),
	(616250, 130, '2014-04-01 00:59:51.000000', 'consum', 0.0213, 'lps'),
	(616251, 130, '2014-04-01 00:59:52.000000', 'consum', 0.0217, 'lps'),
	(616252, 130, '2014-04-01 00:59:53.000000', 'consum', 0.0210, 'lps'),
	(616253, 130, '2014-04-01 00:59:54.000000', 'consum', 0.0216, 'lps'),
	(616254, 130, '2014-04-01 00:59:55.000000', 'consum', 0.0216, 'lps'),
	(616255, 130, '2014-04-01 00:59:56.000000', 'consum', 0.0211, 'lps'),
	(616256, 130, '2014-04-01 00:59:57.000000', 'consum', 0.0211, 'lps'),
	(616257, 130, '2014-04-01 00:59:58.000000', 'consum', 0.0221, 'lps'),
	(616258, 130, '2014-04-01 00:59:59.000000', 'consum', 0.0216, 'lps'),
	(616259, 130, '2014-04-01 01:00:00.000000', 'consum', 0.0221, 'lps'),
	(616260, 130, '2014-04-01 01:00:01.000000', 'consum', 0.0212, 'lps'),
	(616261, 130, '2014-04-01 01:00:02.000000', 'consum', 0.0211, 'lps'),
	(616262, 130, '2014-04-01 01:00:03.000000', 'consum', 0.0220, 'lps'),
	(616263, 130, '2014-04-01 01:00:04.000000', 'consum', 0.0212, 'lps'),
	(616264, 130, '2014-04-01 01:00:05.000000', 'consum', 0.0214, 'lps'),
	(616265, 130, '2014-04-01 01:00:06.000000', 'consum', 0.0213, 'lps'),
	(616266, 130, '2014-04-01 01:00:07.000000', 'consum', 0.0212, 'lps'),
	(616267, 130, '2014-04-01 01:00:08.000000', 'consum', 0.0210, 'lps'),
	(616268, 130, '2014-04-01 01:00:09.000000', 'consum', 0.0218, 'lps'),
	(616269, 130, '2014-04-01 01:00:10.000000', 'consum', 0.0216, 'lps'),
	(616270, 130, '2014-04-01 01:00:11.000000', 'consum', 0.0214, 'lps'),
	(616271, 130, '2014-04-01 01:00:12.000000', 'consum', 0.0212, 'lps'),
	(616272, 130, '2014-04-01 01:00:13.000000', 'consum', 0.0210, 'lps'),
	(616273, 130, '2014-04-01 01:00:14.000000', 'consum', 0.0218, 'lps'),
	(616274, 130, '2014-04-01 01:00:15.000000', 'consum', 0.0213, 'lps'),
	(616275, 130, '2014-04-01 01:00:16.000000', 'consum', 0.0214, 'lps'),
	(616276, 130, '2014-04-01 01:00:17.000000', 'consum', 0.0211, 'lps'),
	(616277, 130, '2014-04-01 01:00:18.000000', 'consum', 0.0213, 'lps'),
	(616278, 130, '2014-04-01 01:00:19.000000', 'consum', 0.0212, 'lps'),
	(616279, 130, '2014-04-01 01:00:20.000000', 'consum', 0.0211, 'lps'),
	(616280, 130, '2014-04-01 01:00:21.000000', 'consum', 0.0221, 'lps'),
	(616281, 130, '2014-04-01 01:00:22.000000', 'consum', 0.0214, 'lps'),
	(616282, 130, '2014-04-01 01:00:23.000000', 'consum', 0.0221, 'lps'),
	(616283, 130, '2014-04-01 01:00:24.000000', 'consum', 0.0220, 'lps'),
	(616284, 130, '2014-04-01 01:00:25.000000', 'consum', 0.0212, 'lps'),
	(616285, 130, '2014-04-01 01:00:26.000000', 'consum', 0.0217, 'lps'),
	(616286, 130, '2014-04-01 01:00:27.000000', 'consum', 0.0214, 'lps'),
	(616287, 130, '2014-04-01 01:00:28.000000', 'consum', 0.0212, 'lps'),
	(616288, 130, '2014-04-01 01:00:29.000000', 'consum', 0.0218, 'lps'),
	(616289, 130, '2014-04-01 01:00:30.000000', 'consum', 0.0220, 'lps'),
	(616290, 130, '2014-04-01 01:00:31.000000', 'consum', 0.0215, 'lps'),
	(616291, 130, '2014-04-01 01:00:32.000000', 'consum', 0.0215, 'lps'),
	(616292, 130, '2014-04-01 01:00:33.000000', 'consum', 0.0211, 'lps'),
	(616293, 130, '2014-04-01 01:00:34.000000', 'consum', 0.0211, 'lps'),
	(616294, 130, '2014-04-01 01:00:35.000000', 'consum', 0.0214, 'lps'),
	(616295, 130, '2014-04-01 01:00:36.000000', 'consum', 0.0216, 'lps'),
	(616296, 130, '2014-04-01 01:00:37.000000', 'consum', 0.0214, 'lps'),
	(616297, 130, '2014-04-01 01:00:38.000000', 'consum', 0.0212, 'lps'),
	(616298, 130, '2014-04-01 01:00:39.000000', 'consum', 0.0221, 'lps'),
	(616299, 130, '2014-04-01 01:00:40.000000', 'consum', 0.0214, 'lps'),
	(616300, 130, '2014-04-01 01:00:41.000000', 'consum', 0.0219, 'lps'),
	(616301, 130, '2014-04-01 01:00:42.000000', 'consum', 0.0219, 'lps'),
	(616302, 130, '2014-04-01 01:00:43.000000', 'consum', 0.0217, 'lps'),
	(616303, 130, '2014-04-01 01:00:44.000000', 'consum', 0.0219, 'lps'),
	(616304, 130, '2014-04-01 01:00:45.000000', 'consum', 0.0221, 'lps'),
	(616305, 130, '2014-04-01 01:00:46.000000', 'consum', 0.0216, 'lps'),
	(616306, 130, '2014-04-01 01:00:47.000000', 'consum', 0.0219, 'lps'),
	(616307, 130, '2014-04-01 01:00:48.000000', 'consum', 0.0215, 'lps'),
	(616308, 130, '2014-04-01 01:00:49.000000', 'consum', 0.0218, 'lps'),
	(616309, 130, '2014-04-01 01:00:50.000000', 'consum', 0.0212, 'lps'),
	(616310, 130, '2014-04-01 01:00:51.000000', 'consum', 0.0210, 'lps'),
	(616311, 130, '2014-04-01 01:00:52.000000', 'consum', 0.0214, 'lps'),
	(616312, 130, '2014-04-01 01:00:53.000000', 'consum', 0.0220, 'lps'),
	(616313, 130, '2014-04-01 01:00:54.000000', 'consum', 0.0211, 'lps'),
	(616314, 130, '2014-04-01 01:00:55.000000', 'consum', 0.0211, 'lps'),
	(616315, 130, '2014-04-01 01:00:56.000000', 'consum', 0.0212, 'lps'),
	(616316, 130, '2014-04-01 01:00:57.000000', 'consum', 0.0218, 'lps'),
	(616317, 130, '2014-04-01 01:00:58.000000', 'consum', 0.0220, 'lps'),
	(616318, 130, '2014-04-01 01:00:59.000000', 'consum', 0.0212, 'lps'),
	(616319, 130, '2014-04-01 01:01:00.000000', 'consum', 0.0215, 'lps'),
	(616320, 130, '2014-04-01 01:01:01.000000', 'consum', 0.0216, 'lps'),
	(616321, 130, '2014-04-01 01:01:02.000000', 'consum', 0.0213, 'lps'),
	(616322, 130, '2014-04-01 01:01:03.000000', 'consum', 0.0210, 'lps'),
	(616323, 130, '2014-04-01 01:01:04.000000', 'consum', 0.0211, 'lps'),
	(616324, 130, '2014-04-01 01:01:05.000000', 'consum', 0.0215, 'lps'),
	(616325, 130, '2014-04-01 01:01:06.000000', 'consum', 0.0210, 'lps'),
	(616326, 130, '2014-04-01 01:01:07.000000', 'consum', 0.0217, 'lps'),
	(616327, 130, '2014-04-01 01:01:08.000000', 'consum', 0.0212, 'lps'),
	(616328, 130, '2014-04-01 01:01:09.000000', 'consum', 0.0210, 'lps'),
	(616329, 130, '2014-04-01 01:01:10.000000', 'consum', 0.0215, 'lps'),
	(616330, 130, '2014-04-01 01:01:11.000000', 'consum', 0.0214, 'lps'),
	(616331, 130, '2014-04-01 01:01:12.000000', 'consum', 0.0213, 'lps'),
	(616332, 130, '2014-04-01 01:01:13.000000', 'consum', 0.0216, 'lps'),
	(616333, 130, '2014-04-01 01:01:14.000000', 'consum', 0.0218, 'lps'),
	(616334, 130, '2014-04-01 01:01:15.000000', 'consum', 0.0211, 'lps'),
	(616335, 130, '2014-04-01 01:01:16.000000', 'consum', 0.0212, 'lps'),
	(616336, 130, '2014-04-01 01:01:17.000000', 'consum', 0.0220, 'lps'),
	(616337, 130, '2014-04-01 01:01:18.000000', 'consum', 0.0216, 'lps'),
	(616338, 130, '2014-04-01 01:01:19.000000', 'consum', 0.0210, 'lps'),
	(616339, 130, '2014-04-01 01:01:20.000000', 'consum', 0.0218, 'lps'),
	(616340, 130, '2014-04-01 01:01:21.000000', 'consum', 0.0215, 'lps'),
	(616341, 130, '2014-04-01 01:01:22.000000', 'consum', 0.0210, 'lps'),
	(616342, 130, '2014-04-01 01:01:23.000000', 'consum', 0.0218, 'lps'),
	(616343, 130, '2014-04-01 01:01:24.000000', 'consum', 0.0218, 'lps'),
	(616344, 130, '2014-04-01 01:01:25.000000', 'consum', 0.0213, 'lps'),
	(616345, 130, '2014-04-01 01:01:26.000000', 'consum', 0.0214, 'lps'),
	(616346, 130, '2014-04-01 01:01:27.000000', 'consum', 0.0219, 'lps'),
	(616347, 130, '2014-04-01 01:01:28.000000', 'consum', 0.0211, 'lps'),
	(616348, 130, '2014-04-01 01:01:29.000000', 'consum', 0.0211, 'lps'),
	(616349, 130, '2014-04-01 01:01:30.000000', 'consum', 0.0214, 'lps'),
	(616350, 130, '2014-04-01 01:01:31.000000', 'consum', 0.0216, 'lps'),
	(616351, 130, '2014-04-01 01:01:32.000000', 'consum', 0.0216, 'lps'),
	(616352, 130, '2014-04-01 01:01:33.000000', 'consum', 0.0220, 'lps'),
	(616353, 130, '2014-04-01 01:01:34.000000', 'consum', 0.0221, 'lps'),
	(616354, 130, '2014-04-01 01:01:35.000000', 'consum', 0.0221, 'lps'),
	(616355, 130, '2014-04-01 01:01:36.000000', 'consum', 0.0211, 'lps'),
	(616356, 130, '2014-04-01 01:01:37.000000', 'consum', 0.0217, 'lps'),
	(616357, 130, '2014-04-01 01:01:38.000000', 'consum', 0.0218, 'lps'),
	(616358, 130, '2014-04-01 01:01:39.000000', 'consum', 0.0218, 'lps'),
	(616359, 130, '2014-04-01 01:01:40.000000', 'consum', 0.0213, 'lps'),
	(616360, 130, '2014-04-01 01:01:41.000000', 'consum', 0.0214, 'lps'),
	(616361, 130, '2014-04-01 01:01:42.000000', 'consum', 0.0221, 'lps'),
	(616362, 130, '2014-04-01 01:01:43.000000', 'consum', 0.0217, 'lps'),
	(616363, 130, '2014-04-01 01:01:44.000000', 'consum', 0.0215, 'lps'),
	(616364, 130, '2014-04-01 01:01:45.000000', 'consum', 0.0215, 'lps'),
	(616365, 130, '2014-04-01 01:01:46.000000', 'consum', 0.0217, 'lps'),
	(616366, 130, '2014-04-01 01:01:47.000000', 'consum', 0.0210, 'lps'),
	(616367, 130, '2014-04-01 01:01:48.000000', 'consum', 0.0212, 'lps'),
	(616368, 130, '2014-04-01 01:01:49.000000', 'consum', 0.0210, 'lps'),
	(616369, 130, '2014-04-01 01:01:50.000000', 'consum', 0.0215, 'lps'),
	(616370, 130, '2014-04-01 01:01:51.000000', 'consum', 0.0212, 'lps'),
	(616371, 130, '2014-04-01 01:01:52.000000', 'consum', 0.0217, 'lps'),
	(616372, 130, '2014-04-01 01:01:53.000000', 'consum', 0.0216, 'lps'),
	(616373, 130, '2014-04-01 01:01:54.000000', 'consum', 0.0219, 'lps'),
	(616374, 130, '2014-04-01 01:01:55.000000', 'consum', 0.0214, 'lps'),
	(616375, 130, '2014-04-01 01:01:56.000000', 'consum', 0.0217, 'lps'),
	(616376, 130, '2014-04-01 01:01:57.000000', 'consum', 0.0221, 'lps'),
	(616377, 130, '2014-04-01 01:01:58.000000', 'consum', 0.0210, 'lps'),
	(616378, 130, '2014-04-01 01:01:59.000000', 'consum', 0.0210, 'lps'),
	(616379, 130, '2014-04-01 01:02:00.000000', 'consum', 0.0213, 'lps'),
	(616380, 130, '2014-04-01 01:02:01.000000', 'consum', 0.0214, 'lps'),
	(616381, 130, '2014-04-01 01:02:02.000000', 'consum', 0.0221, 'lps'),
	(616382, 130, '2014-04-01 01:02:03.000000', 'consum', 0.0219, 'lps'),
	(616383, 130, '2014-04-01 01:02:04.000000', 'consum', 0.0210, 'lps'),
	(616384, 130, '2014-04-01 01:02:05.000000', 'consum', 0.0220, 'lps'),
	(616385, 130, '2014-04-01 01:02:06.000000', 'consum', 0.0212, 'lps'),
	(616386, 130, '2014-04-01 01:02:07.000000', 'consum', 0.0213, 'lps'),
	(616387, 130, '2014-04-01 01:02:08.000000', 'consum', 0.0218, 'lps'),
	(616388, 130, '2014-04-01 01:02:09.000000', 'consum', 0.0221, 'lps'),
	(616389, 130, '2014-04-01 01:02:10.000000', 'consum', 0.0215, 'lps'),
	(616390, 130, '2014-04-01 01:02:11.000000', 'consum', 0.0217, 'lps'),
	(616391, 130, '2014-04-01 01:02:12.000000', 'consum', 0.0216, 'lps'),
	(616392, 130, '2014-04-01 01:02:13.000000', 'consum', 0.0220, 'lps'),
	(616393, 130, '2014-04-01 01:02:14.000000', 'consum', 0.0220, 'lps'),
	(616394, 130, '2014-04-01 01:02:15.000000', 'consum', 0.0218, 'lps'),
	(616395, 130, '2014-04-01 01:02:16.000000', 'consum', 0.0218, 'lps'),
	(616396, 130, '2014-04-01 01:02:17.000000', 'consum', 0.0218, 'lps'),
	(616397, 130, '2014-04-01 01:02:18.000000', 'consum', 0.0213, 'lps'),
	(616398, 130, '2014-04-01 01:02:19.000000', 'consum', 0.0215, 'lps'),
	(616399, 130, '2014-04-01 01:02:20.000000', 'consum', 0.0215, 'lps'),
	(616400, 130, '2014-04-01 01:02:21.000000', 'consum', 0.0219, 'lps'),
	(616401, 130, '2014-04-01 01:02:22.000000', 'consum', 0.0218, 'lps'),
	(616402, 130, '2014-04-01 01:02:23.000000', 'consum', 0.0211, 'lps'),
	(616403, 130, '2014-04-01 01:02:24.000000', 'consum', 0.0217, 'lps'),
	(616404, 130, '2014-04-01 01:02:25.000000', 'consum', 0.0215, 'lps'),
	(616405, 130, '2014-04-01 01:02:26.000000', 'consum', 0.0217, 'lps'),
	(616406, 130, '2014-04-01 01:02:27.000000', 'consum', 0.0219, 'lps'),
	(616407, 130, '2014-04-01 01:02:28.000000', 'consum', 0.0211, 'lps'),
	(616408, 130, '2014-04-01 01:02:29.000000', 'consum', 0.0210, 'lps'),
	(616409, 130, '2014-04-01 01:02:30.000000', 'consum', 0.0210, 'lps'),
	(616410, 130, '2014-04-01 01:02:31.000000', 'consum', 0.0220, 'lps'),
	(616411, 130, '2014-04-01 01:02:32.000000', 'consum', 0.0215, 'lps'),
	(616412, 130, '2014-04-01 01:02:33.000000', 'consum', 0.0217, 'lps'),
	(616413, 130, '2014-04-01 01:02:34.000000', 'consum', 0.0216, 'lps'),
	(616414, 130, '2014-04-01 01:02:35.000000', 'consum', 0.0210, 'lps'),
	(616415, 130, '2014-04-01 01:02:36.000000', 'consum', 0.0214, 'lps'),
	(616416, 130, '2014-04-01 01:02:37.000000', 'consum', 0.0221, 'lps'),
	(616417, 130, '2014-04-01 01:02:38.000000', 'consum', 0.0218, 'lps'),
	(616418, 130, '2014-04-01 01:02:39.000000', 'consum', 0.0218, 'lps'),
	(616419, 130, '2014-04-01 01:02:40.000000', 'consum', 0.0212, 'lps'),
	(616420, 130, '2014-04-01 01:02:41.000000', 'consum', 0.0221, 'lps'),
	(616421, 130, '2014-04-01 01:02:42.000000', 'consum', 0.0213, 'lps'),
	(616422, 130, '2014-04-01 01:02:43.000000', 'consum', 0.0215, 'lps'),
	(616423, 130, '2014-04-01 01:02:44.000000', 'consum', 0.0215, 'lps'),
	(616424, 130, '2014-04-01 01:02:45.000000', 'consum', 0.0219, 'lps'),
	(616425, 130, '2014-04-01 01:02:46.000000', 'consum', 0.0216, 'lps'),
	(616426, 130, '2014-04-01 01:02:47.000000', 'consum', 0.0216, 'lps'),
	(616427, 130, '2014-04-01 01:02:48.000000', 'consum', 0.0221, 'lps'),
	(616428, 130, '2014-04-01 01:02:49.000000', 'consum', 0.0211, 'lps'),
	(616429, 130, '2014-04-01 01:02:50.000000', 'consum', 0.0220, 'lps'),
	(616430, 130, '2014-04-01 01:02:51.000000', 'consum', 0.0219, 'lps'),
	(616431, 130, '2014-04-01 01:02:52.000000', 'consum', 0.0215, 'lps'),
	(616432, 130, '2014-04-01 01:02:53.000000', 'consum', 0.0219, 'lps'),
	(616433, 130, '2014-04-01 01:02:54.000000', 'consum', 0.0218, 'lps'),
	(616434, 130, '2014-04-01 01:02:55.000000', 'consum', 0.0212, 'lps'),
	(616435, 130, '2014-04-01 01:02:56.000000', 'consum', 0.0218, 'lps'),
	(616436, 130, '2014-04-01 01:02:57.000000', 'consum', 0.0212, 'lps'),
	(616437, 130, '2014-04-01 01:02:58.000000', 'consum', 0.0217, 'lps'),
	(616438, 130, '2014-04-01 01:02:59.000000', 'consum', 0.0218, 'lps'),
	(616439, 130, '2014-04-01 01:03:00.000000', 'consum', 0.0215, 'lps'),
	(616440, 130, '2014-04-01 01:03:01.000000', 'consum', 0.0212, 'lps'),
	(616441, 130, '2014-04-01 01:03:02.000000', 'consum', 0.0217, 'lps'),
	(616442, 130, '2014-04-01 01:03:03.000000', 'consum', 0.0216, 'lps'),
	(616443, 130, '2014-04-01 01:03:04.000000', 'consum', 0.0221, 'lps'),
	(616444, 130, '2014-04-01 01:03:05.000000', 'consum', 0.0212, 'lps'),
	(616445, 130, '2014-04-01 01:03:06.000000', 'consum', 0.0221, 'lps'),
	(616446, 130, '2014-04-01 01:03:07.000000', 'consum', 0.0213, 'lps'),
	(616447, 130, '2014-04-01 01:03:08.000000', 'consum', 0.0216, 'lps'),
	(616448, 130, '2014-04-01 01:03:09.000000', 'consum', 0.0221, 'lps'),
	(616449, 130, '2014-04-01 01:03:10.000000', 'consum', 0.0210, 'lps'),
	(616450, 130, '2014-04-01 01:03:11.000000', 'consum', 0.0214, 'lps'),
	(616451, 130, '2014-04-01 01:03:12.000000', 'consum', 0.0220, 'lps'),
	(616452, 130, '2014-04-01 01:03:13.000000', 'consum', 0.0212, 'lps'),
	(616453, 130, '2014-04-01 01:03:14.000000', 'consum', 0.0212, 'lps'),
	(616454, 130, '2014-04-01 01:03:15.000000', 'consum', 0.0216, 'lps'),
	(616455, 130, '2014-04-01 01:03:16.000000', 'consum', 0.0211, 'lps'),
	(616456, 130, '2014-04-01 01:03:17.000000', 'consum', 0.0220, 'lps'),
	(616457, 130, '2014-04-01 01:03:18.000000', 'consum', 0.0220, 'lps'),
	(616458, 130, '2014-04-01 01:03:19.000000', 'consum', 0.0210, 'lps'),
	(616459, 130, '2014-04-01 01:03:20.000000', 'consum', 0.0213, 'lps'),
	(616460, 130, '2014-04-01 01:03:21.000000', 'consum', 0.0216, 'lps'),
	(616461, 130, '2014-04-01 01:03:22.000000', 'consum', 0.0220, 'lps'),
	(616462, 130, '2014-04-01 01:03:23.000000', 'consum', 0.0219, 'lps'),
	(616463, 130, '2014-04-01 01:03:24.000000', 'consum', 0.0214, 'lps'),
	(616464, 130, '2014-04-01 01:03:25.000000', 'consum', 0.0215, 'lps'),
	(616465, 130, '2014-04-01 01:03:26.000000', 'consum', 0.0212, 'lps'),
	(616466, 130, '2014-04-01 01:03:27.000000', 'consum', 0.0219, 'lps'),
	(616467, 130, '2014-04-01 01:03:28.000000', 'consum', 0.0210, 'lps'),
	(616468, 130, '2014-04-01 01:03:29.000000', 'consum', 0.0221, 'lps'),
	(616469, 130, '2014-04-01 01:03:30.000000', 'consum', 0.0218, 'lps'),
	(616470, 130, '2014-04-01 01:03:31.000000', 'consum', 0.0217, 'lps'),
	(616471, 130, '2014-04-01 01:03:32.000000', 'consum', 0.0211, 'lps'),
	(616472, 130, '2014-04-01 01:03:33.000000', 'consum', 0.0219, 'lps'),
	(616473, 130, '2014-04-01 01:03:34.000000', 'consum', 0.0217, 'lps'),
	(616474, 130, '2014-04-01 01:03:35.000000', 'consum', 0.0217, 'lps'),
	(616475, 130, '2014-04-01 01:03:36.000000', 'consum', 0.0213, 'lps'),
	(616476, 130, '2014-04-01 01:03:37.000000', 'consum', 0.0216, 'lps'),
	(616477, 130, '2014-04-01 01:03:38.000000', 'consum', 0.0219, 'lps'),
	(616478, 130, '2014-04-01 01:03:39.000000', 'consum', 0.0212, 'lps'),
	(616479, 130, '2014-04-01 01:03:40.000000', 'consum', 0.0219, 'lps'),
	(616480, 130, '2014-04-01 01:03:41.000000', 'consum', 0.0214, 'lps'),
	(616481, 130, '2014-04-01 01:03:42.000000', 'consum', 0.0216, 'lps'),
	(616482, 130, '2014-04-01 01:03:43.000000', 'consum', 0.0215, 'lps'),
	(616483, 130, '2014-04-01 01:03:44.000000', 'consum', 0.0219, 'lps'),
	(616484, 130, '2014-04-01 01:03:45.000000', 'consum', 0.0215, 'lps'),
	(616485, 130, '2014-04-01 01:03:46.000000', 'consum', 0.0220, 'lps'),
	(616486, 130, '2014-04-01 01:03:47.000000', 'consum', 0.0221, 'lps'),
	(616487, 130, '2014-04-01 01:03:48.000000', 'consum', 0.0215, 'lps'),
	(616488, 130, '2014-04-01 01:03:49.000000', 'consum', 0.0211, 'lps'),
	(616489, 130, '2014-04-01 01:03:50.000000', 'consum', 0.0212, 'lps'),
	(616490, 130, '2014-04-01 01:03:51.000000', 'consum', 0.0220, 'lps'),
	(616491, 130, '2014-04-01 01:03:52.000000', 'consum', 0.0216, 'lps'),
	(616492, 130, '2014-04-01 01:03:53.000000', 'consum', 0.0210, 'lps'),
	(616493, 130, '2014-04-01 01:03:54.000000', 'consum', 0.0218, 'lps'),
	(616494, 130, '2014-04-01 01:03:55.000000', 'consum', 0.0215, 'lps'),
	(616495, 130, '2014-04-01 01:03:56.000000', 'consum', 0.0211, 'lps'),
	(616496, 130, '2014-04-01 01:03:57.000000', 'consum', 0.0214, 'lps'),
	(616497, 130, '2014-04-01 01:03:58.000000', 'consum', 0.0215, 'lps'),
	(616498, 130, '2014-04-01 01:03:59.000000', 'consum', 0.0212, 'lps'),
	(616499, 130, '2014-04-01 01:04:00.000000', 'consum', 0.0215, 'lps'),
	(616500, 130, '2014-04-01 01:04:01.000000', 'consum', 0.0218, 'lps'),
	(616501, 130, '2014-04-01 01:04:02.000000', 'consum', 0.0211, 'lps'),
	(616502, 130, '2014-04-01 01:04:03.000000', 'consum', 0.0218, 'lps'),
	(616503, 130, '2014-04-01 01:04:04.000000', 'consum', 0.0211, 'lps'),
	(616504, 130, '2014-04-01 01:04:05.000000', 'consum', 0.0213, 'lps'),
	(616505, 130, '2014-04-01 01:04:06.000000', 'consum', 0.0214, 'lps'),
	(616506, 130, '2014-04-01 01:04:07.000000', 'consum', 0.0219, 'lps'),
	(616507, 130, '2014-04-01 01:04:08.000000', 'consum', 0.0220, 'lps'),
	(616508, 130, '2014-04-01 01:04:09.000000', 'consum', 0.0211, 'lps'),
	(616509, 130, '2014-04-01 01:04:10.000000', 'consum', 0.0210, 'lps'),
	(616510, 130, '2014-04-01 01:04:11.000000', 'consum', 0.0218, 'lps'),
	(616511, 130, '2014-04-01 01:04:12.000000', 'consum', 0.0216, 'lps'),
	(616512, 130, '2014-04-01 01:04:13.000000', 'consum', 0.0217, 'lps'),
	(616513, 130, '2014-04-01 01:04:14.000000', 'consum', 0.0212, 'lps'),
	(616514, 130, '2014-04-01 01:04:15.000000', 'consum', 0.0215, 'lps'),
	(616515, 130, '2014-04-01 01:04:16.000000', 'consum', 0.0218, 'lps'),
	(616516, 130, '2014-04-01 01:04:17.000000', 'consum', 0.0212, 'lps'),
	(616517, 130, '2014-04-01 01:04:18.000000', 'consum', 0.0217, 'lps'),
	(616518, 130, '2014-04-01 01:04:19.000000', 'consum', 0.0219, 'lps'),
	(616519, 130, '2014-04-01 01:04:20.000000', 'consum', 0.0220, 'lps'),
	(616520, 130, '2014-04-01 01:04:21.000000', 'consum', 0.0220, 'lps'),
	(616521, 130, '2014-04-01 01:04:22.000000', 'consum', 0.0221, 'lps'),
	(616522, 130, '2014-04-01 01:04:23.000000', 'consum', 0.0213, 'lps'),
	(616523, 130, '2014-04-01 01:04:24.000000', 'consum', 0.0214, 'lps'),
	(616524, 130, '2014-04-01 01:04:25.000000', 'consum', 0.0212, 'lps'),
	(616525, 130, '2014-04-01 01:04:26.000000', 'consum', 0.0217, 'lps'),
	(616526, 130, '2014-04-01 01:04:27.000000', 'consum', 0.0218, 'lps'),
	(616527, 130, '2014-04-01 01:04:28.000000', 'consum', 0.0218, 'lps'),
	(616528, 130, '2014-04-01 01:04:29.000000', 'consum', 0.0214, 'lps'),
	(616529, 130, '2014-04-01 01:04:30.000000', 'consum', 0.0218, 'lps'),
	(616530, 130, '2014-04-01 01:04:31.000000', 'consum', 0.0214, 'lps'),
	(616531, 130, '2014-04-01 01:04:32.000000', 'consum', 0.0217, 'lps'),
	(616532, 130, '2014-04-01 01:04:33.000000', 'consum', 0.0211, 'lps'),
	(616533, 130, '2014-04-01 01:04:34.000000', 'consum', 0.0217, 'lps'),
	(616534, 130, '2014-04-01 01:04:35.000000', 'consum', 0.0221, 'lps'),
	(616535, 130, '2014-04-01 01:04:36.000000', 'consum', 0.0210, 'lps'),
	(616536, 130, '2014-04-01 01:04:37.000000', 'consum', 0.0210, 'lps'),
	(616537, 130, '2014-04-01 01:04:38.000000', 'consum', 0.0210, 'lps'),
	(616538, 130, '2014-04-01 01:04:39.000000', 'consum', 0.0213, 'lps'),
	(616539, 130, '2014-04-01 01:04:40.000000', 'consum', 0.0212, 'lps'),
	(616540, 130, '2014-04-01 01:04:41.000000', 'consum', 0.0210, 'lps'),
	(616541, 130, '2014-04-01 01:04:42.000000', 'consum', 0.0217, 'lps'),
	(616542, 130, '2014-04-01 01:04:43.000000', 'consum', 0.0211, 'lps'),
	(616543, 130, '2014-04-01 01:04:44.000000', 'consum', 0.0217, 'lps'),
	(616544, 130, '2014-04-01 01:04:45.000000', 'consum', 0.0217, 'lps'),
	(616545, 130, '2014-04-01 01:04:46.000000', 'consum', 0.0214, 'lps'),
	(616546, 130, '2014-04-01 01:04:47.000000', 'consum', 0.0221, 'lps'),
	(616547, 130, '2014-04-01 01:04:48.000000', 'consum', 0.0218, 'lps'),
	(616548, 130, '2014-04-01 01:04:49.000000', 'consum', 0.0218, 'lps'),
	(616549, 130, '2014-04-01 01:04:50.000000', 'consum', 0.0216, 'lps'),
	(616550, 130, '2014-04-01 01:04:51.000000', 'consum', 0.0214, 'lps'),
	(616551, 130, '2014-04-01 01:04:52.000000', 'consum', 0.0212, 'lps'),
	(616552, 130, '2014-04-01 01:04:53.000000', 'consum', 0.0220, 'lps'),
	(616553, 130, '2014-04-01 01:04:54.000000', 'consum', 0.0219, 'lps'),
	(616554, 130, '2014-04-01 01:04:55.000000', 'consum', 0.0212, 'lps'),
	(616555, 130, '2014-04-01 01:04:56.000000', 'consum', 0.0220, 'lps'),
	(616556, 130, '2014-04-01 01:04:57.000000', 'consum', 0.0217, 'lps'),
	(616557, 130, '2014-04-01 01:04:58.000000', 'consum', 0.0214, 'lps'),
	(616558, 130, '2014-04-01 01:04:59.000000', 'consum', 0.0213, 'lps'),
	(616559, 130, '2014-04-01 01:05:00.000000', 'consum', 0.0210, 'lps'),
	(616560, 130, '2014-04-01 01:05:01.000000', 'consum', 0.0216, 'lps'),
	(616561, 130, '2014-04-01 01:05:02.000000', 'consum', 0.0214, 'lps'),
	(616562, 130, '2014-04-01 01:05:03.000000', 'consum', 0.0212, 'lps'),
	(616563, 130, '2014-04-01 01:05:04.000000', 'consum', 0.0221, 'lps'),
	(616564, 130, '2014-04-01 01:05:05.000000', 'consum', 0.0214, 'lps'),
	(616565, 130, '2014-04-01 01:05:06.000000', 'consum', 0.0220, 'lps'),
	(616566, 130, '2014-04-01 01:05:07.000000', 'consum', 0.0213, 'lps'),
	(616567, 130, '2014-04-01 01:05:08.000000', 'consum', 0.0221, 'lps'),
	(616568, 130, '2014-04-01 01:05:09.000000', 'consum', 0.0217, 'lps'),
	(616569, 130, '2014-04-01 01:05:10.000000', 'consum', 0.0215, 'lps'),
	(616570, 130, '2014-04-01 01:05:11.000000', 'consum', 0.0214, 'lps'),
	(616571, 130, '2014-04-01 01:05:12.000000', 'consum', 0.0216, 'lps'),
	(616572, 130, '2014-04-01 01:05:13.000000', 'consum', 0.0215, 'lps'),
	(616573, 130, '2014-04-01 01:05:14.000000', 'consum', 0.0217, 'lps'),
	(616574, 130, '2014-04-01 01:05:15.000000', 'consum', 0.0220, 'lps'),
	(616575, 130, '2014-04-01 01:05:16.000000', 'consum', 0.0217, 'lps'),
	(616576, 130, '2014-04-01 01:05:17.000000', 'consum', 0.0214, 'lps'),
	(616577, 130, '2014-04-01 01:05:18.000000', 'consum', 0.0221, 'lps'),
	(616578, 130, '2014-04-01 01:05:19.000000', 'consum', 0.0218, 'lps'),
	(616579, 130, '2014-04-01 01:05:20.000000', 'consum', 0.0219, 'lps'),
	(616580, 130, '2014-04-01 01:05:21.000000', 'consum', 0.0219, 'lps'),
	(616581, 130, '2014-04-01 01:05:22.000000', 'consum', 0.0216, 'lps'),
	(616582, 130, '2014-04-01 01:05:23.000000', 'consum', 0.0214, 'lps'),
	(616583, 130, '2014-04-01 01:05:24.000000', 'consum', 0.0214, 'lps'),
	(616584, 130, '2014-04-01 01:05:25.000000', 'consum', 0.0215, 'lps'),
	(616585, 130, '2014-04-01 01:05:26.000000', 'consum', 0.0214, 'lps'),
	(616586, 130, '2014-04-01 01:05:27.000000', 'consum', 0.0213, 'lps'),
	(616587, 130, '2014-04-01 01:05:28.000000', 'consum', 0.0215, 'lps'),
	(616588, 130, '2014-04-01 01:05:29.000000', 'consum', 0.0212, 'lps'),
	(616589, 130, '2014-04-01 01:05:30.000000', 'consum', 0.0221, 'lps'),
	(616590, 130, '2014-04-01 01:05:31.000000', 'consum', 0.0211, 'lps'),
	(616591, 130, '2014-04-01 01:05:32.000000', 'consum', 0.0220, 'lps'),
	(616592, 130, '2014-04-01 01:05:33.000000', 'consum', 0.0219, 'lps'),
	(616593, 130, '2014-04-01 01:05:34.000000', 'consum', 0.0214, 'lps'),
	(616594, 130, '2014-04-01 01:05:35.000000', 'consum', 0.0217, 'lps'),
	(616595, 130, '2014-04-01 01:05:36.000000', 'consum', 0.0221, 'lps'),
	(616596, 130, '2014-04-01 01:05:37.000000', 'consum', 0.0221, 'lps'),
	(616597, 130, '2014-04-01 01:05:38.000000', 'consum', 0.0219, 'lps'),
	(616598, 130, '2014-04-01 01:05:39.000000', 'consum', 0.0210, 'lps'),
	(616599, 130, '2014-04-01 01:05:40.000000', 'consum', 0.0221, 'lps'),
	(616600, 130, '2014-04-01 01:05:41.000000', 'consum', 0.0217, 'lps'),
	(616601, 130, '2014-04-01 01:05:42.000000', 'consum', 0.0214, 'lps'),
	(616602, 130, '2014-04-01 01:05:43.000000', 'consum', 0.0219, 'lps'),
	(616603, 130, '2014-04-01 01:05:44.000000', 'consum', 0.0219, 'lps'),
	(616604, 130, '2014-04-01 01:05:45.000000', 'consum', 0.0220, 'lps'),
	(616605, 130, '2014-04-01 01:05:46.000000', 'consum', 0.0218, 'lps'),
	(616606, 130, '2014-04-01 01:05:47.000000', 'consum', 0.0220, 'lps'),
	(616607, 130, '2014-04-01 01:05:48.000000', 'consum', 0.0216, 'lps'),
	(616608, 130, '2014-04-01 01:05:49.000000', 'consum', 0.0220, 'lps'),
	(616609, 130, '2014-04-01 01:05:50.000000', 'consum', 0.0218, 'lps'),
	(616610, 130, '2014-04-01 01:05:51.000000', 'consum', 0.0211, 'lps'),
	(616611, 130, '2014-04-01 01:05:52.000000', 'consum', 0.0214, 'lps'),
	(616612, 130, '2014-04-01 01:05:53.000000', 'consum', 0.0217, 'lps'),
	(616613, 130, '2014-04-01 01:05:54.000000', 'consum', 0.0210, 'lps'),
	(616614, 130, '2014-04-01 01:05:55.000000', 'consum', 0.0213, 'lps'),
	(616615, 130, '2014-04-01 01:05:56.000000', 'consum', 0.0215, 'lps'),
	(616616, 130, '2014-04-01 01:05:57.000000', 'consum', 0.0215, 'lps'),
	(616617, 130, '2014-04-01 01:05:58.000000', 'consum', 0.0217, 'lps'),
	(616618, 130, '2014-04-01 01:05:59.000000', 'consum', 0.0221, 'lps'),
	(616619, 130, '2014-04-01 01:06:00.000000', 'consum', 0.0219, 'lps'),
	(616620, 130, '2014-04-01 01:06:01.000000', 'consum', 0.0210, 'lps'),
	(616621, 130, '2014-04-01 01:06:02.000000', 'consum', 0.0220, 'lps'),
	(616622, 130, '2014-04-01 01:06:03.000000', 'consum', 0.0212, 'lps'),
	(616623, 130, '2014-04-01 01:06:04.000000', 'consum', 0.0213, 'lps'),
	(616624, 130, '2014-04-01 01:06:05.000000', 'consum', 0.0210, 'lps'),
	(616625, 130, '2014-04-01 01:06:06.000000', 'consum', 0.0213, 'lps'),
	(616626, 130, '2014-04-01 01:06:07.000000', 'consum', 0.0215, 'lps'),
	(616627, 130, '2014-04-01 01:06:08.000000', 'consum', 0.0214, 'lps'),
	(616628, 130, '2014-04-01 01:06:09.000000', 'consum', 0.0215, 'lps'),
	(616629, 130, '2014-04-01 01:06:10.000000', 'consum', 0.0214, 'lps'),
	(616630, 130, '2014-04-01 01:06:11.000000', 'consum', 0.0212, 'lps'),
	(616631, 130, '2014-04-01 01:06:12.000000', 'consum', 0.0211, 'lps'),
	(616632, 130, '2014-04-01 01:06:13.000000', 'consum', 0.0219, 'lps'),
	(616633, 130, '2014-04-01 01:06:14.000000', 'consum', 0.0218, 'lps'),
	(616634, 130, '2014-04-01 01:06:15.000000', 'consum', 0.0212, 'lps'),
	(616635, 130, '2014-04-01 01:06:16.000000', 'consum', 0.0218, 'lps'),
	(616636, 130, '2014-04-01 01:06:17.000000', 'consum', 0.0212, 'lps'),
	(616637, 130, '2014-04-01 01:06:18.000000', 'consum', 0.0218, 'lps'),
	(616638, 130, '2014-04-01 01:06:19.000000', 'consum', 0.0221, 'lps'),
	(616639, 130, '2014-04-01 01:06:20.000000', 'consum', 0.0219, 'lps'),
	(616640, 130, '2014-04-01 01:06:21.000000', 'consum', 0.0212, 'lps'),
	(616641, 130, '2014-04-01 01:06:22.000000', 'consum', 0.0214, 'lps'),
	(616642, 130, '2014-04-01 01:06:23.000000', 'consum', 0.0214, 'lps'),
	(616643, 130, '2014-04-01 01:06:24.000000', 'consum', 0.0218, 'lps'),
	(616644, 130, '2014-04-01 01:06:25.000000', 'consum', 0.0214, 'lps'),
	(616645, 130, '2014-04-01 01:06:26.000000', 'consum', 0.0220, 'lps'),
	(616646, 130, '2014-04-01 01:06:27.000000', 'consum', 0.0211, 'lps'),
	(616647, 130, '2014-04-01 01:06:28.000000', 'consum', 0.0211, 'lps'),
	(616648, 130, '2014-04-01 01:06:29.000000', 'consum', 0.0213, 'lps'),
	(616649, 130, '2014-04-01 01:06:30.000000', 'consum', 0.0210, 'lps'),
	(616650, 130, '2014-04-01 01:06:31.000000', 'consum', 0.0212, 'lps'),
	(616651, 130, '2014-04-01 01:06:32.000000', 'consum', 0.0220, 'lps'),
	(616652, 130, '2014-04-01 01:06:33.000000', 'consum', 0.0218, 'lps'),
	(616653, 130, '2014-04-01 01:06:34.000000', 'consum', 0.0220, 'lps'),
	(616654, 130, '2014-04-01 01:06:35.000000', 'consum', 0.0213, 'lps'),
	(616655, 130, '2014-04-01 01:06:36.000000', 'consum', 0.0219, 'lps'),
	(616656, 130, '2014-04-01 01:06:37.000000', 'consum', 0.0212, 'lps'),
	(616657, 130, '2014-04-01 01:06:38.000000', 'consum', 0.0215, 'lps'),
	(616658, 130, '2014-04-01 01:06:39.000000', 'consum', 0.0220, 'lps'),
	(616659, 130, '2014-04-01 01:06:40.000000', 'consum', 0.0210, 'lps'),
	(616660, 130, '2014-04-01 01:06:41.000000', 'consum', 0.0217, 'lps'),
	(616661, 130, '2014-04-01 01:06:42.000000', 'consum', 0.0219, 'lps'),
	(616662, 130, '2014-04-01 01:06:43.000000', 'consum', 0.0213, 'lps'),
	(616663, 130, '2014-04-01 01:06:44.000000', 'consum', 0.0211, 'lps'),
	(616664, 130, '2014-04-01 01:06:45.000000', 'consum', 0.0218, 'lps'),
	(616665, 130, '2014-04-01 01:06:46.000000', 'consum', 0.0213, 'lps'),
	(616666, 130, '2014-04-01 01:06:47.000000', 'consum', 0.0213, 'lps'),
	(616667, 130, '2014-04-01 01:06:48.000000', 'consum', 0.0216, 'lps'),
	(616668, 130, '2014-04-01 01:06:49.000000', 'consum', 0.0219, 'lps'),
	(616669, 130, '2014-04-01 01:06:50.000000', 'consum', 0.0215, 'lps'),
	(616670, 130, '2014-04-01 01:06:51.000000', 'consum', 0.0218, 'lps'),
	(616671, 130, '2014-04-01 01:06:52.000000', 'consum', 0.0212, 'lps'),
	(616672, 130, '2014-04-01 01:06:53.000000', 'consum', 0.0210, 'lps'),
	(616673, 130, '2014-04-01 01:06:54.000000', 'consum', 0.0214, 'lps'),
	(616674, 130, '2014-04-01 01:06:55.000000', 'consum', 0.0219, 'lps'),
	(616675, 130, '2014-04-01 01:06:56.000000', 'consum', 0.0219, 'lps'),
	(616676, 130, '2014-04-01 01:06:57.000000', 'consum', 0.0218, 'lps'),
	(616677, 130, '2014-04-01 01:06:58.000000', 'consum', 0.0221, 'lps'),
	(616678, 130, '2014-04-01 01:06:59.000000', 'consum', 0.0220, 'lps'),
	(616679, 130, '2014-04-01 01:07:00.000000', 'consum', 0.0213, 'lps'),
	(616680, 130, '2014-04-01 01:07:01.000000', 'consum', 0.0219, 'lps'),
	(616681, 130, '2014-04-01 01:07:02.000000', 'consum', 0.0213, 'lps'),
	(616682, 130, '2014-04-01 01:07:03.000000', 'consum', 0.0220, 'lps'),
	(616683, 130, '2014-04-01 01:07:04.000000', 'consum', 0.0218, 'lps'),
	(616684, 130, '2014-04-01 01:07:05.000000', 'consum', 0.0220, 'lps'),
	(616685, 130, '2014-04-01 01:07:06.000000', 'consum', 0.0210, 'lps'),
	(616686, 130, '2014-04-01 01:07:07.000000', 'consum', 0.0219, 'lps'),
	(616687, 130, '2014-04-01 01:07:08.000000', 'consum', 0.0218, 'lps'),
	(616688, 130, '2014-04-01 01:07:09.000000', 'consum', 0.0210, 'lps'),
	(616689, 130, '2014-04-01 01:07:10.000000', 'consum', 0.0212, 'lps'),
	(616690, 130, '2014-04-01 01:07:11.000000', 'consum', 0.0210, 'lps'),
	(616691, 130, '2014-04-01 01:07:12.000000', 'consum', 0.0216, 'lps'),
	(616692, 130, '2014-04-01 01:07:13.000000', 'consum', 0.0216, 'lps'),
	(616693, 130, '2014-04-01 01:07:14.000000', 'consum', 0.0211, 'lps'),
	(616694, 130, '2014-04-01 01:07:15.000000', 'consum', 0.0210, 'lps'),
	(616695, 130, '2014-04-01 01:07:16.000000', 'consum', 0.0220, 'lps'),
	(616696, 130, '2014-04-01 01:07:17.000000', 'consum', 0.0213, 'lps'),
	(616697, 130, '2014-04-01 01:07:18.000000', 'consum', 0.0217, 'lps'),
	(616698, 130, '2014-04-01 01:07:19.000000', 'consum', 0.0213, 'lps'),
	(616699, 130, '2014-04-01 01:07:20.000000', 'consum', 0.0216, 'lps'),
	(616700, 130, '2014-04-01 01:07:21.000000', 'consum', 0.0219, 'lps'),
	(616701, 130, '2014-04-01 01:07:22.000000', 'consum', 0.0212, 'lps'),
	(616702, 130, '2014-04-01 01:07:23.000000', 'consum', 0.0221, 'lps'),
	(616703, 130, '2014-04-01 01:07:24.000000', 'consum', 0.0210, 'lps'),
	(616704, 130, '2014-04-01 01:07:25.000000', 'consum', 0.0215, 'lps'),
	(616705, 130, '2014-04-01 01:07:26.000000', 'consum', 0.0211, 'lps'),
	(616706, 130, '2014-04-01 01:07:27.000000', 'consum', 0.0214, 'lps'),
	(616707, 130, '2014-04-01 01:07:28.000000', 'consum', 0.0214, 'lps'),
	(616708, 130, '2014-04-01 01:07:29.000000', 'consum', 0.0220, 'lps'),
	(616709, 130, '2014-04-01 01:07:30.000000', 'consum', 0.0213, 'lps'),
	(616710, 130, '2014-04-01 01:07:31.000000', 'consum', 0.0218, 'lps'),
	(616711, 130, '2014-04-01 01:07:32.000000', 'consum', 0.0219, 'lps'),
	(616712, 130, '2014-04-01 01:07:33.000000', 'consum', 0.0217, 'lps'),
	(616713, 130, '2014-04-01 01:07:34.000000', 'consum', 0.0220, 'lps'),
	(616714, 130, '2014-04-01 01:07:35.000000', 'consum', 0.0213, 'lps'),
	(616715, 130, '2014-04-01 01:07:36.000000', 'consum', 0.0210, 'lps'),
	(616716, 130, '2014-04-01 01:07:37.000000', 'consum', 0.0214, 'lps'),
	(616717, 130, '2014-04-01 01:07:38.000000', 'consum', 0.0219, 'lps'),
	(616718, 130, '2014-04-01 01:07:39.000000', 'consum', 0.0220, 'lps'),
	(616719, 130, '2014-04-01 01:07:40.000000', 'consum', 0.0219, 'lps'),
	(616720, 130, '2014-04-01 01:07:41.000000', 'consum', 0.0214, 'lps'),
	(616721, 130, '2014-04-01 01:07:42.000000', 'consum', 0.0218, 'lps'),
	(616722, 130, '2014-04-01 01:07:43.000000', 'consum', 0.0211, 'lps'),
	(616723, 130, '2014-04-01 01:07:44.000000', 'consum', 0.0219, 'lps'),
	(616724, 130, '2014-04-01 01:07:45.000000', 'consum', 0.0215, 'lps'),
	(616725, 130, '2014-04-01 01:07:46.000000', 'consum', 0.0221, 'lps'),
	(616726, 130, '2014-04-01 01:07:47.000000', 'consum', 0.0216, 'lps'),
	(616727, 130, '2014-04-01 01:07:48.000000', 'consum', 0.0218, 'lps'),
	(616728, 130, '2014-04-01 01:07:49.000000', 'consum', 0.0221, 'lps'),
	(616729, 130, '2014-04-01 01:07:50.000000', 'consum', 0.0218, 'lps'),
	(616730, 130, '2014-04-01 01:07:51.000000', 'consum', 0.0217, 'lps'),
	(616731, 130, '2014-04-01 01:07:52.000000', 'consum', 0.0211, 'lps'),
	(616732, 130, '2014-04-01 01:07:53.000000', 'consum', 0.0218, 'lps'),
	(616733, 130, '2014-04-01 01:07:54.000000', 'consum', 0.0213, 'lps'),
	(616734, 130, '2014-04-01 01:07:55.000000', 'consum', 0.0211, 'lps'),
	(616735, 130, '2014-04-01 01:07:56.000000', 'consum', 0.0219, 'lps'),
	(616736, 130, '2014-04-01 01:07:57.000000', 'consum', 0.0217, 'lps'),
	(616737, 130, '2014-04-01 01:07:58.000000', 'consum', 0.0218, 'lps'),
	(616738, 130, '2014-04-01 01:07:59.000000', 'consum', 0.0218, 'lps'),
	(616739, 130, '2014-04-01 01:08:00.000000', 'consum', 0.0213, 'lps'),
	(616740, 130, '2014-04-01 01:08:01.000000', 'consum', 0.0215, 'lps'),
	(616741, 130, '2014-04-01 01:08:02.000000', 'consum', 0.0213, 'lps'),
	(616742, 130, '2014-04-01 01:08:03.000000', 'consum', 0.0210, 'lps'),
	(616743, 130, '2014-04-01 01:08:04.000000', 'consum', 0.0216, 'lps'),
	(616744, 130, '2014-04-01 01:08:05.000000', 'consum', 0.0216, 'lps'),
	(616745, 130, '2014-04-01 01:08:06.000000', 'consum', 0.0221, 'lps'),
	(616746, 130, '2014-04-01 01:08:07.000000', 'consum', 0.0210, 'lps'),
	(616747, 130, '2014-04-01 01:08:08.000000', 'consum', 0.0216, 'lps'),
	(616748, 130, '2014-04-01 01:08:09.000000', 'consum', 0.0218, 'lps'),
	(616749, 130, '2014-04-01 01:08:10.000000', 'consum', 0.0218, 'lps'),
	(616750, 130, '2014-04-01 01:08:11.000000', 'consum', 0.0216, 'lps'),
	(616751, 130, '2014-04-01 01:08:12.000000', 'consum', 0.0216, 'lps'),
	(616752, 130, '2014-04-01 01:08:13.000000', 'consum', 0.0210, 'lps'),
	(616753, 130, '2014-04-01 01:08:14.000000', 'consum', 0.0216, 'lps'),
	(616754, 130, '2014-04-01 01:08:15.000000', 'consum', 0.0218, 'lps'),
	(616755, 130, '2014-04-01 01:08:16.000000', 'consum', 0.0218, 'lps'),
	(616756, 130, '2014-04-01 01:08:17.000000', 'consum', 0.0217, 'lps'),
	(616757, 130, '2014-04-01 01:08:18.000000', 'consum', 0.0219, 'lps'),
	(616758, 130, '2014-04-01 01:08:19.000000', 'consum', 0.0214, 'lps'),
	(616759, 130, '2014-04-01 01:08:20.000000', 'consum', 0.0212, 'lps'),
	(616760, 130, '2014-04-01 01:08:21.000000', 'consum', 0.0211, 'lps'),
	(616761, 130, '2014-04-01 01:08:22.000000', 'consum', 0.0210, 'lps'),
	(616762, 130, '2014-04-01 01:08:23.000000', 'consum', 0.0220, 'lps'),
	(616763, 130, '2014-04-01 01:08:24.000000', 'consum', 0.0212, 'lps'),
	(616764, 130, '2014-04-01 01:08:25.000000', 'consum', 0.0215, 'lps'),
	(616765, 130, '2014-04-01 01:08:26.000000', 'consum', 0.0217, 'lps'),
	(616766, 130, '2014-04-01 01:08:27.000000', 'consum', 0.0217, 'lps'),
	(616767, 130, '2014-04-01 01:08:28.000000', 'consum', 0.0213, 'lps'),
	(616768, 130, '2014-04-01 01:08:29.000000', 'consum', 0.0218, 'lps'),
	(616769, 130, '2014-04-01 01:08:30.000000', 'consum', 0.0215, 'lps'),
	(616770, 130, '2014-04-01 01:08:31.000000', 'consum', 0.0214, 'lps'),
	(616771, 130, '2014-04-01 01:08:32.000000', 'consum', 0.0214, 'lps'),
	(616772, 130, '2014-04-01 01:08:33.000000', 'consum', 0.0221, 'lps'),
	(616773, 130, '2014-04-01 01:08:34.000000', 'consum', 0.0216, 'lps'),
	(616774, 130, '2014-04-01 01:08:35.000000', 'consum', 0.0220, 'lps'),
	(616775, 130, '2014-04-01 01:08:36.000000', 'consum', 0.0218, 'lps'),
	(616776, 130, '2014-04-01 01:08:37.000000', 'consum', 0.0218, 'lps'),
	(616777, 130, '2014-04-01 01:08:38.000000', 'consum', 0.0218, 'lps'),
	(616778, 130, '2014-04-01 01:08:39.000000', 'consum', 0.0215, 'lps'),
	(616779, 130, '2014-04-01 01:08:40.000000', 'consum', 0.0211, 'lps'),
	(616780, 130, '2014-04-01 01:08:41.000000', 'consum', 0.0214, 'lps'),
	(616781, 130, '2014-04-01 01:08:42.000000', 'consum', 0.0215, 'lps'),
	(616782, 130, '2014-04-01 01:08:43.000000', 'consum', 0.0221, 'lps'),
	(616783, 130, '2014-04-01 01:08:44.000000', 'consum', 0.0218, 'lps'),
	(616784, 130, '2014-04-01 01:08:45.000000', 'consum', 0.0214, 'lps'),
	(616785, 130, '2014-04-01 01:08:46.000000', 'consum', 0.0220, 'lps'),
	(616786, 130, '2014-04-01 01:08:47.000000', 'consum', 0.0211, 'lps'),
	(616787, 130, '2014-04-01 01:08:48.000000', 'consum', 0.0221, 'lps'),
	(616788, 130, '2014-04-01 01:08:49.000000', 'consum', 0.0217, 'lps'),
	(616789, 130, '2014-04-01 01:08:50.000000', 'consum', 0.0210, 'lps'),
	(616790, 130, '2014-04-01 01:08:51.000000', 'consum', 0.0214, 'lps'),
	(616791, 130, '2014-04-01 01:08:52.000000', 'consum', 0.0220, 'lps'),
	(616792, 130, '2014-04-01 01:08:53.000000', 'consum', 0.0212, 'lps'),
	(616793, 130, '2014-04-01 01:08:54.000000', 'consum', 0.0213, 'lps'),
	(616794, 130, '2014-04-01 01:08:55.000000', 'consum', 0.0221, 'lps'),
	(616795, 130, '2014-04-01 01:08:56.000000', 'consum', 0.0210, 'lps'),
	(616796, 130, '2014-04-01 01:08:57.000000', 'consum', 0.0213, 'lps'),
	(616797, 130, '2014-04-01 01:08:58.000000', 'consum', 0.0211, 'lps'),
	(616798, 130, '2014-04-01 01:08:59.000000', 'consum', 0.0220, 'lps'),
	(616799, 130, '2014-04-01 01:09:00.000000', 'consum', 0.0220, 'lps'),
	(616800, 130, '2014-04-01 01:09:01.000000', 'consum', 0.0221, 'lps'),
	(616801, 130, '2014-04-01 01:09:02.000000', 'consum', 0.0221, 'lps'),
	(616802, 130, '2014-04-01 01:09:03.000000', 'consum', 0.0220, 'lps'),
	(616803, 130, '2014-04-01 01:09:04.000000', 'consum', 0.0217, 'lps'),
	(616804, 130, '2014-04-01 01:09:05.000000', 'consum', 0.0216, 'lps'),
	(616805, 130, '2014-04-01 01:09:06.000000', 'consum', 0.0219, 'lps'),
	(616806, 130, '2014-04-01 01:09:07.000000', 'consum', 0.0215, 'lps'),
	(616807, 130, '2014-04-01 01:09:08.000000', 'consum', 0.0220, 'lps'),
	(616808, 130, '2014-04-01 01:09:09.000000', 'consum', 0.0211, 'lps'),
	(616809, 130, '2014-04-01 01:09:10.000000', 'consum', 0.0219, 'lps'),
	(616810, 130, '2014-04-01 01:09:11.000000', 'consum', 0.0217, 'lps'),
	(616811, 130, '2014-04-01 01:09:12.000000', 'consum', 0.0218, 'lps'),
	(616812, 130, '2014-04-01 01:09:13.000000', 'consum', 0.0218, 'lps'),
	(616813, 130, '2014-04-01 01:09:14.000000', 'consum', 0.0216, 'lps'),
	(616814, 130, '2014-04-01 01:09:15.000000', 'consum', 0.0215, 'lps'),
	(616815, 130, '2014-04-01 01:09:16.000000', 'consum', 0.0220, 'lps'),
	(616816, 130, '2014-04-01 01:09:17.000000', 'consum', 0.0220, 'lps'),
	(616817, 130, '2014-04-01 01:09:18.000000', 'consum', 0.0217, 'lps'),
	(616818, 130, '2014-04-01 01:09:19.000000', 'consum', 0.0216, 'lps'),
	(616819, 130, '2014-04-01 01:09:20.000000', 'consum', 0.0219, 'lps'),
	(616820, 130, '2014-04-01 01:09:21.000000', 'consum', 0.0214, 'lps'),
	(616821, 130, '2014-04-01 01:09:22.000000', 'consum', 0.0215, 'lps'),
	(616822, 130, '2014-04-01 01:09:23.000000', 'consum', 0.0213, 'lps'),
	(616823, 130, '2014-04-01 01:09:24.000000', 'consum', 0.0220, 'lps'),
	(616824, 130, '2014-04-01 01:09:25.000000', 'consum', 0.0218, 'lps'),
	(616825, 130, '2014-04-01 01:09:26.000000', 'consum', 0.0217, 'lps'),
	(616826, 130, '2014-04-01 01:09:27.000000', 'consum', 0.0213, 'lps'),
	(616827, 130, '2014-04-01 01:09:28.000000', 'consum', 0.0217, 'lps'),
	(616828, 130, '2014-04-01 01:09:29.000000', 'consum', 0.0221, 'lps'),
	(616829, 130, '2014-04-01 01:09:30.000000', 'consum', 0.0212, 'lps'),
	(616830, 130, '2014-04-01 01:09:31.000000', 'consum', 0.0210, 'lps'),
	(616831, 130, '2014-04-01 01:09:32.000000', 'consum', 0.0217, 'lps'),
	(616832, 130, '2014-04-01 01:09:33.000000', 'consum', 0.0210, 'lps'),
	(616833, 130, '2014-04-01 01:09:34.000000', 'consum', 0.0214, 'lps'),
	(616834, 130, '2014-04-01 01:09:35.000000', 'consum', 0.0219, 'lps'),
	(616835, 130, '2014-04-01 01:09:36.000000', 'consum', 0.0220, 'lps'),
	(616836, 130, '2014-04-01 01:09:37.000000', 'consum', 0.0219, 'lps'),
	(616837, 130, '2014-04-01 01:09:38.000000', 'consum', 0.0215, 'lps'),
	(616838, 130, '2014-04-01 01:09:39.000000', 'consum', 0.0210, 'lps'),
	(616839, 130, '2014-04-01 01:09:40.000000', 'consum', 0.0218, 'lps'),
	(616840, 130, '2014-04-01 01:09:41.000000', 'consum', 0.0215, 'lps'),
	(616841, 130, '2014-04-01 01:09:42.000000', 'consum', 0.0221, 'lps'),
	(616842, 130, '2014-04-01 01:09:43.000000', 'consum', 0.0218, 'lps'),
	(616843, 130, '2014-04-01 01:09:44.000000', 'consum', 0.0217, 'lps'),
	(616844, 130, '2014-04-01 01:09:45.000000', 'consum', 0.0219, 'lps'),
	(616845, 130, '2014-04-01 01:09:46.000000', 'consum', 0.0211, 'lps'),
	(616846, 130, '2014-04-01 01:09:47.000000', 'consum', 0.0215, 'lps'),
	(616847, 130, '2014-04-01 01:09:48.000000', 'consum', 0.0219, 'lps'),
	(616848, 130, '2014-04-01 01:09:49.000000', 'consum', 0.0217, 'lps'),
	(616849, 130, '2014-04-01 01:09:50.000000', 'consum', 0.0220, 'lps'),
	(616850, 130, '2014-04-01 01:09:51.000000', 'consum', 0.0215, 'lps'),
	(616851, 130, '2014-04-01 01:09:52.000000', 'consum', 0.0215, 'lps'),
	(616852, 130, '2014-04-01 01:09:53.000000', 'consum', 0.0211, 'lps'),
	(616853, 130, '2014-04-01 01:09:54.000000', 'consum', 0.0212, 'lps'),
	(616854, 130, '2014-04-01 01:09:55.000000', 'consum', 0.0219, 'lps'),
	(616855, 130, '2014-04-01 01:09:56.000000', 'consum', 0.0213, 'lps'),
	(616856, 130, '2014-04-01 01:09:57.000000', 'consum', 0.0210, 'lps'),
	(616857, 130, '2014-04-01 01:09:58.000000', 'consum', 0.0212, 'lps'),
	(616858, 130, '2014-04-01 01:09:59.000000', 'consum', 0.0210, 'lps'),
	(616859, 130, '2014-04-01 01:10:00.000000', 'consum', 0.0217, 'lps'),
	(616860, 130, '2014-04-01 01:10:01.000000', 'consum', 0.0220, 'lps'),
	(616861, 130, '2014-04-01 01:10:02.000000', 'consum', 0.0218, 'lps'),
	(616862, 130, '2014-04-01 01:10:03.000000', 'consum', 0.0218, 'lps'),
	(616863, 130, '2014-04-01 01:10:04.000000', 'consum', 0.0217, 'lps'),
	(616864, 130, '2014-04-01 01:10:05.000000', 'consum', 0.0220, 'lps'),
	(616865, 130, '2014-04-01 01:10:06.000000', 'consum', 0.0214, 'lps'),
	(616866, 130, '2014-04-01 01:10:07.000000', 'consum', 0.0214, 'lps'),
	(616867, 130, '2014-04-01 01:10:08.000000', 'consum', 0.0217, 'lps'),
	(616868, 130, '2014-04-01 01:10:09.000000', 'consum', 0.0210, 'lps'),
	(616869, 130, '2014-04-01 01:10:10.000000', 'consum', 0.0213, 'lps'),
	(616870, 130, '2014-04-01 01:10:11.000000', 'consum', 0.0215, 'lps'),
	(616871, 130, '2014-04-01 01:10:12.000000', 'consum', 0.0213, 'lps'),
	(616872, 130, '2014-04-01 01:10:13.000000', 'consum', 0.0210, 'lps'),
	(616873, 130, '2014-04-01 01:10:14.000000', 'consum', 0.0214, 'lps'),
	(616874, 130, '2014-04-01 01:10:15.000000', 'consum', 0.0219, 'lps'),
	(616875, 130, '2014-04-01 01:10:16.000000', 'consum', 0.0220, 'lps'),
	(616876, 130, '2014-04-01 01:10:17.000000', 'consum', 0.0221, 'lps'),
	(616877, 130, '2014-04-01 01:10:18.000000', 'consum', 0.0210, 'lps'),
	(616878, 130, '2014-04-01 01:10:19.000000', 'consum', 0.0215, 'lps'),
	(616879, 130, '2014-04-01 01:10:20.000000', 'consum', 0.0212, 'lps'),
	(616880, 130, '2014-04-01 01:10:21.000000', 'consum', 0.0218, 'lps'),
	(616881, 130, '2014-04-01 01:10:22.000000', 'consum', 0.0219, 'lps'),
	(616882, 130, '2014-04-01 01:10:23.000000', 'consum', 0.0219, 'lps'),
	(616883, 130, '2014-04-01 01:10:24.000000', 'consum', 0.0219, 'lps'),
	(616884, 130, '2014-04-01 01:10:25.000000', 'consum', 0.0214, 'lps'),
	(616885, 130, '2014-04-01 01:10:26.000000', 'consum', 0.0218, 'lps'),
	(616886, 130, '2014-04-01 01:10:27.000000', 'consum', 0.0211, 'lps'),
	(616887, 130, '2014-04-01 01:10:28.000000', 'consum', 0.0219, 'lps'),
	(616888, 130, '2014-04-01 01:10:29.000000', 'consum', 0.0216, 'lps'),
	(616889, 130, '2014-04-01 01:10:30.000000', 'consum', 0.0215, 'lps'),
	(616890, 130, '2014-04-01 01:10:31.000000', 'consum', 0.0216, 'lps'),
	(616891, 130, '2014-04-01 01:10:32.000000', 'consum', 0.0213, 'lps'),
	(616892, 130, '2014-04-01 01:10:33.000000', 'consum', 0.0220, 'lps'),
	(616893, 130, '2014-04-01 01:10:34.000000', 'consum', 0.0214, 'lps'),
	(616894, 130, '2014-04-01 01:10:35.000000', 'consum', 0.0215, 'lps'),
	(616895, 130, '2014-04-01 01:10:36.000000', 'consum', 0.0211, 'lps'),
	(616896, 130, '2014-04-01 01:10:37.000000', 'consum', 0.0210, 'lps'),
	(616897, 130, '2014-04-01 01:10:38.000000', 'consum', 0.0221, 'lps'),
	(616898, 130, '2014-04-01 01:10:39.000000', 'consum', 0.0219, 'lps'),
	(616899, 130, '2014-04-01 01:10:40.000000', 'consum', 0.0210, 'lps'),
	(616900, 130, '2014-04-01 01:10:41.000000', 'consum', 0.0219, 'lps'),
	(616901, 130, '2014-04-01 01:10:42.000000', 'consum', 0.0220, 'lps'),
	(616902, 130, '2014-04-01 01:10:43.000000', 'consum', 0.0211, 'lps'),
	(616903, 130, '2014-04-01 01:10:44.000000', 'consum', 0.0221, 'lps'),
	(616904, 130, '2014-04-01 01:10:45.000000', 'consum', 0.0213, 'lps'),
	(616905, 130, '2014-04-01 01:10:46.000000', 'consum', 0.0219, 'lps'),
	(616906, 130, '2014-04-01 01:10:47.000000', 'consum', 0.0221, 'lps'),
	(616907, 130, '2014-04-01 01:10:48.000000', 'consum', 0.0214, 'lps'),
	(616908, 130, '2014-04-01 01:10:49.000000', 'consum', 0.0221, 'lps'),
	(616909, 130, '2014-04-01 01:10:50.000000', 'consum', 0.0216, 'lps'),
	(616910, 130, '2014-04-01 01:10:51.000000', 'consum', 0.0221, 'lps'),
	(616911, 130, '2014-04-01 01:10:52.000000', 'consum', 0.0213, 'lps'),
	(616912, 130, '2014-04-01 01:10:53.000000', 'consum', 0.0216, 'lps'),
	(616913, 130, '2014-04-01 01:10:54.000000', 'consum', 0.0218, 'lps'),
	(616914, 130, '2014-04-01 01:10:55.000000', 'consum', 0.0221, 'lps'),
	(616915, 130, '2014-04-01 01:10:56.000000', 'consum', 0.0217, 'lps'),
	(616916, 130, '2014-04-01 01:10:57.000000', 'consum', 0.0212, 'lps'),
	(616917, 130, '2014-04-01 01:10:58.000000', 'consum', 0.0211, 'lps'),
	(616918, 130, '2014-04-01 01:10:59.000000', 'consum', 0.0210, 'lps'),
	(616919, 130, '2014-04-01 01:11:00.000000', 'consum', 0.0219, 'lps'),
	(616920, 130, '2014-04-01 01:11:01.000000', 'consum', 0.0219, 'lps'),
	(616921, 130, '2014-04-01 01:11:02.000000', 'consum', 0.0215, 'lps'),
	(616922, 130, '2014-04-01 01:11:03.000000', 'consum', 0.0212, 'lps'),
	(616923, 130, '2014-04-01 01:11:04.000000', 'consum', 0.0215, 'lps'),
	(616924, 130, '2014-04-01 01:11:05.000000', 'consum', 0.0217, 'lps'),
	(616925, 130, '2014-04-01 01:11:06.000000', 'consum', 0.0221, 'lps'),
	(616926, 130, '2014-04-01 01:11:07.000000', 'consum', 0.0218, 'lps'),
	(616927, 130, '2014-04-01 01:11:08.000000', 'consum', 0.0220, 'lps'),
	(616928, 130, '2014-04-01 01:11:09.000000', 'consum', 0.0211, 'lps'),
	(616929, 130, '2014-04-01 01:11:10.000000', 'consum', 0.0220, 'lps'),
	(616930, 130, '2014-04-01 01:11:11.000000', 'consum', 0.0211, 'lps'),
	(616931, 130, '2014-04-01 01:11:12.000000', 'consum', 0.0211, 'lps'),
	(616932, 130, '2014-04-01 01:11:13.000000', 'consum', 0.0211, 'lps'),
	(616933, 130, '2014-04-01 01:11:14.000000', 'consum', 0.0211, 'lps'),
	(616934, 130, '2014-04-01 01:11:15.000000', 'consum', 0.0212, 'lps'),
	(616935, 130, '2014-04-01 01:11:16.000000', 'consum', 0.0219, 'lps'),
	(616936, 130, '2014-04-01 01:11:17.000000', 'consum', 0.0213, 'lps'),
	(616937, 130, '2014-04-01 01:11:18.000000', 'consum', 0.0211, 'lps'),
	(616938, 130, '2014-04-01 01:11:19.000000', 'consum', 0.0217, 'lps'),
	(616939, 130, '2014-04-01 01:11:20.000000', 'consum', 0.0219, 'lps'),
	(616940, 130, '2014-04-01 01:11:21.000000', 'consum', 0.0210, 'lps'),
	(616941, 130, '2014-04-01 01:11:22.000000', 'consum', 0.0219, 'lps'),
	(616942, 130, '2014-04-01 01:11:23.000000', 'consum', 0.0221, 'lps'),
	(616943, 130, '2014-04-01 01:11:24.000000', 'consum', 0.0213, 'lps'),
	(616944, 130, '2014-04-01 01:11:25.000000', 'consum', 0.0217, 'lps'),
	(616945, 130, '2014-04-01 01:11:26.000000', 'consum', 0.0211, 'lps'),
	(616946, 130, '2014-04-01 01:11:27.000000', 'consum', 0.0221, 'lps'),
	(616947, 130, '2014-04-01 01:11:28.000000', 'consum', 0.0212, 'lps'),
	(616948, 130, '2014-04-01 01:11:29.000000', 'consum', 0.0212, 'lps'),
	(616949, 130, '2014-04-01 01:11:30.000000', 'consum', 0.0213, 'lps'),
	(616950, 130, '2014-04-01 01:11:31.000000', 'consum', 0.0210, 'lps'),
	(616951, 130, '2014-04-01 01:11:32.000000', 'consum', 0.0213, 'lps'),
	(616952, 130, '2014-04-01 01:11:33.000000', 'consum', 0.0213, 'lps'),
	(616953, 130, '2014-04-01 01:11:34.000000', 'consum', 0.0217, 'lps'),
	(616954, 130, '2014-04-01 01:11:35.000000', 'consum', 0.0214, 'lps'),
	(616955, 130, '2014-04-01 01:11:36.000000', 'consum', 0.0219, 'lps'),
	(616956, 130, '2014-04-01 01:11:37.000000', 'consum', 0.0220, 'lps'),
	(616957, 130, '2014-04-01 01:11:38.000000', 'consum', 0.0212, 'lps'),
	(616958, 130, '2014-04-01 01:11:39.000000', 'consum', 0.0211, 'lps'),
	(616959, 130, '2014-04-01 01:11:40.000000', 'consum', 0.0210, 'lps'),
	(616960, 130, '2014-04-01 01:11:41.000000', 'consum', 0.0210, 'lps'),
	(616961, 130, '2014-04-01 01:11:42.000000', 'consum', 0.0221, 'lps'),
	(616962, 130, '2014-04-01 01:11:43.000000', 'consum', 0.0217, 'lps'),
	(616963, 130, '2014-04-01 01:11:44.000000', 'consum', 0.0211, 'lps'),
	(616964, 130, '2014-04-01 01:11:45.000000', 'consum', 0.0220, 'lps'),
	(616965, 130, '2014-04-01 01:11:46.000000', 'consum', 0.0210, 'lps'),
	(616966, 130, '2014-04-01 01:11:47.000000', 'consum', 0.0217, 'lps'),
	(616967, 130, '2014-04-01 01:11:48.000000', 'consum', 0.0220, 'lps'),
	(616968, 130, '2014-04-01 01:11:49.000000', 'consum', 0.0216, 'lps'),
	(616969, 130, '2014-04-01 01:11:50.000000', 'consum', 0.0212, 'lps'),
	(616970, 130, '2014-04-01 01:11:51.000000', 'consum', 0.0214, 'lps'),
	(616971, 130, '2014-04-01 01:11:52.000000', 'consum', 0.0213, 'lps'),
	(616972, 130, '2014-04-01 01:11:53.000000', 'consum', 0.0213, 'lps'),
	(616973, 130, '2014-04-01 01:11:54.000000', 'consum', 0.0217, 'lps'),
	(616974, 130, '2014-04-01 01:11:55.000000', 'consum', 0.0212, 'lps'),
	(616975, 130, '2014-04-01 01:11:56.000000', 'consum', 0.0211, 'lps'),
	(616976, 130, '2014-04-01 01:11:57.000000', 'consum', 0.0211, 'lps'),
	(616977, 130, '2014-04-01 01:11:58.000000', 'consum', 0.0212, 'lps'),
	(616978, 130, '2014-04-01 01:11:59.000000', 'consum', 0.0218, 'lps'),
	(616979, 130, '2014-04-01 01:12:00.000000', 'consum', 0.0221, 'lps'),
	(616980, 130, '2014-04-01 01:12:01.000000', 'consum', 0.0216, 'lps'),
	(616981, 130, '2014-04-01 01:12:02.000000', 'consum', 0.0221, 'lps'),
	(616982, 130, '2014-04-01 01:12:03.000000', 'consum', 0.0211, 'lps'),
	(616983, 130, '2014-04-01 01:12:04.000000', 'consum', 0.0219, 'lps'),
	(616984, 130, '2014-04-01 01:12:05.000000', 'consum', 0.0218, 'lps'),
	(616985, 130, '2014-04-01 01:12:06.000000', 'consum', 0.0211, 'lps'),
	(616986, 130, '2014-04-01 01:12:07.000000', 'consum', 0.0213, 'lps'),
	(616987, 130, '2014-04-01 01:12:08.000000', 'consum', 0.0212, 'lps'),
	(616988, 130, '2014-04-01 01:12:09.000000', 'consum', 0.0211, 'lps'),
	(616989, 130, '2014-04-01 01:12:10.000000', 'consum', 0.0220, 'lps'),
	(616990, 130, '2014-04-01 01:12:11.000000', 'consum', 0.0212, 'lps'),
	(616991, 130, '2014-04-01 01:12:12.000000', 'consum', 0.0216, 'lps'),
	(616992, 130, '2014-04-01 01:12:13.000000', 'consum', 0.0220, 'lps'),
	(616993, 130, '2014-04-01 01:12:14.000000', 'consum', 0.0217, 'lps'),
	(616994, 130, '2014-04-01 01:12:15.000000', 'consum', 0.0217, 'lps'),
	(616995, 130, '2014-04-01 01:12:16.000000', 'consum', 0.0213, 'lps'),
	(616996, 130, '2014-04-01 01:12:17.000000', 'consum', 0.0218, 'lps'),
	(616997, 130, '2014-04-01 01:12:18.000000', 'consum', 0.0217, 'lps'),
	(616998, 130, '2014-04-01 01:12:19.000000', 'consum', 0.0221, 'lps'),
	(616999, 130, '2014-04-01 01:12:20.000000', 'consum', 0.0210, 'lps'),
	(617000, 130, '2014-04-01 01:12:21.000000', 'consum', 0.0215, 'lps'),
	(617001, 130, '2014-04-01 01:12:22.000000', 'consum', 0.0220, 'lps'),
	(617002, 130, '2014-04-01 01:12:23.000000', 'consum', 0.0210, 'lps'),
	(617003, 130, '2014-04-01 01:12:24.000000', 'consum', 0.0216, 'lps'),
	(617004, 130, '2014-04-01 01:12:25.000000', 'consum', 0.0216, 'lps'),
	(617005, 130, '2014-04-01 01:12:26.000000', 'consum', 0.0213, 'lps'),
	(617006, 130, '2014-04-01 01:12:27.000000', 'consum', 0.0217, 'lps'),
	(617007, 130, '2014-04-01 01:12:28.000000', 'consum', 0.0212, 'lps'),
	(617008, 130, '2014-04-01 01:12:29.000000', 'consum', 0.0214, 'lps'),
	(617009, 130, '2014-04-01 01:12:30.000000', 'consum', 0.0211, 'lps'),
	(617010, 130, '2014-04-01 01:12:31.000000', 'consum', 0.0214, 'lps'),
	(617011, 130, '2014-04-01 01:12:32.000000', 'consum', 0.0217, 'lps'),
	(617012, 130, '2014-04-01 01:12:33.000000', 'consum', 0.0210, 'lps'),
	(617013, 130, '2014-04-01 01:12:34.000000', 'consum', 0.0215, 'lps'),
	(617014, 130, '2014-04-01 01:12:35.000000', 'consum', 0.0210, 'lps'),
	(617015, 130, '2014-04-01 01:12:36.000000', 'consum', 0.0221, 'lps'),
	(617016, 130, '2014-04-01 01:12:37.000000', 'consum', 0.0215, 'lps'),
	(617017, 130, '2014-04-01 01:12:38.000000', 'consum', 0.0216, 'lps'),
	(617018, 130, '2014-04-01 01:12:39.000000', 'consum', 0.0215, 'lps'),
	(617019, 130, '2014-04-01 01:12:40.000000', 'consum', 0.0216, 'lps'),
	(617020, 130, '2014-04-01 01:12:41.000000', 'consum', 0.0213, 'lps'),
	(617021, 130, '2014-04-01 01:12:42.000000', 'consum', 0.0219, 'lps'),
	(617022, 130, '2014-04-01 01:12:43.000000', 'consum', 0.0212, 'lps'),
	(617023, 130, '2014-04-01 01:12:44.000000', 'consum', 0.0216, 'lps'),
	(617024, 130, '2014-04-01 01:12:45.000000', 'consum', 0.0210, 'lps'),
	(617025, 130, '2014-04-01 01:12:46.000000', 'consum', 0.0217, 'lps'),
	(617026, 130, '2014-04-01 01:12:47.000000', 'consum', 0.0212, 'lps'),
	(617027, 130, '2014-04-01 01:12:48.000000', 'consum', 0.0220, 'lps'),
	(617028, 130, '2014-04-01 01:12:49.000000', 'consum', 0.0220, 'lps'),
	(617029, 130, '2014-04-01 01:12:50.000000', 'consum', 0.0220, 'lps'),
	(617030, 130, '2014-04-01 01:12:51.000000', 'consum', 0.0217, 'lps'),
	(617031, 130, '2014-04-01 01:12:52.000000', 'consum', 0.0215, 'lps'),
	(617032, 130, '2014-04-01 01:12:53.000000', 'consum', 0.0213, 'lps'),
	(617033, 130, '2014-04-01 01:12:54.000000', 'consum', 0.0212, 'lps'),
	(617034, 130, '2014-04-01 01:12:55.000000', 'consum', 0.0213, 'lps'),
	(617035, 130, '2014-04-01 01:12:56.000000', 'consum', 0.0220, 'lps'),
	(617036, 130, '2014-04-01 01:12:57.000000', 'consum', 0.0215, 'lps'),
	(617037, 130, '2014-04-01 01:12:58.000000', 'consum', 0.0215, 'lps'),
	(617038, 130, '2014-04-01 01:12:59.000000', 'consum', 0.0212, 'lps'),
	(617039, 130, '2014-04-01 01:13:00.000000', 'consum', 0.0216, 'lps'),
	(617040, 130, '2014-04-01 01:13:01.000000', 'consum', 0.0213, 'lps'),
	(617041, 130, '2014-04-01 01:13:02.000000', 'consum', 0.0216, 'lps'),
	(617042, 130, '2014-04-01 01:13:03.000000', 'consum', 0.0221, 'lps'),
	(617043, 130, '2014-04-01 01:13:04.000000', 'consum', 0.0211, 'lps'),
	(617044, 130, '2014-04-01 01:13:05.000000', 'consum', 0.0219, 'lps'),
	(617045, 130, '2014-04-01 01:13:06.000000', 'consum', 0.0215, 'lps'),
	(617046, 130, '2014-04-01 01:13:07.000000', 'consum', 0.0211, 'lps'),
	(617047, 130, '2014-04-01 01:13:08.000000', 'consum', 0.0213, 'lps'),
	(617048, 130, '2014-04-01 01:13:09.000000', 'consum', 0.0220, 'lps'),
	(617049, 130, '2014-04-01 01:13:10.000000', 'consum', 0.0216, 'lps'),
	(617050, 130, '2014-04-01 01:13:11.000000', 'consum', 0.0212, 'lps'),
	(617051, 130, '2014-04-01 01:13:12.000000', 'consum', 0.0215, 'lps'),
	(617052, 130, '2014-04-01 01:13:13.000000', 'consum', 0.0219, 'lps'),
	(617053, 130, '2014-04-01 01:13:14.000000', 'consum', 0.0213, 'lps'),
	(617054, 130, '2014-04-01 01:13:15.000000', 'consum', 0.0211, 'lps'),
	(617055, 130, '2014-04-01 01:13:16.000000', 'consum', 0.0218, 'lps'),
	(617056, 130, '2014-04-01 01:13:17.000000', 'consum', 0.0210, 'lps'),
	(617057, 130, '2014-04-01 01:13:18.000000', 'consum', 0.0213, 'lps'),
	(617058, 130, '2014-04-01 01:13:19.000000', 'consum', 0.0214, 'lps'),
	(617059, 130, '2014-04-01 01:13:20.000000', 'consum', 0.0221, 'lps'),
	(617060, 130, '2014-04-01 01:13:21.000000', 'consum', 0.0218, 'lps'),
	(617061, 130, '2014-04-01 01:13:22.000000', 'consum', 0.0215, 'lps'),
	(617062, 130, '2014-04-01 01:13:23.000000', 'consum', 0.0215, 'lps'),
	(617063, 130, '2014-04-01 01:13:24.000000', 'consum', 0.0218, 'lps'),
	(617064, 130, '2014-04-01 01:13:25.000000', 'consum', 0.0210, 'lps'),
	(617065, 130, '2014-04-01 01:13:26.000000', 'consum', 0.0214, 'lps'),
	(617066, 130, '2014-04-01 01:13:27.000000', 'consum', 0.0216, 'lps'),
	(617067, 130, '2014-04-01 01:13:28.000000', 'consum', 0.0216, 'lps'),
	(617068, 130, '2014-04-01 01:13:29.000000', 'consum', 0.0213, 'lps'),
	(617069, 130, '2014-04-01 01:13:30.000000', 'consum', 0.0219, 'lps'),
	(617070, 130, '2014-04-01 01:13:31.000000', 'consum', 0.0211, 'lps'),
	(617071, 130, '2014-04-01 01:13:32.000000', 'consum', 0.0211, 'lps'),
	(617072, 130, '2014-04-01 01:13:33.000000', 'consum', 0.0215, 'lps'),
	(617073, 130, '2014-04-01 01:13:34.000000', 'consum', 0.0217, 'lps'),
	(617074, 130, '2014-04-01 01:13:35.000000', 'consum', 0.0210, 'lps'),
	(617075, 130, '2014-04-01 01:13:36.000000', 'consum', 0.0212, 'lps'),
	(617076, 130, '2014-04-01 01:13:37.000000', 'consum', 0.0210, 'lps'),
	(617077, 130, '2014-04-01 01:13:38.000000', 'consum', 0.0215, 'lps'),
	(617078, 130, '2014-04-01 01:13:39.000000', 'consum', 0.0214, 'lps'),
	(617079, 130, '2014-04-01 01:13:40.000000', 'consum', 0.0213, 'lps'),
	(617080, 130, '2014-04-01 01:13:41.000000', 'consum', 0.0216, 'lps'),
	(617081, 130, '2014-04-01 01:13:42.000000', 'consum', 0.0217, 'lps'),
	(617082, 130, '2014-04-01 01:13:43.000000', 'consum', 0.0215, 'lps'),
	(617083, 130, '2014-04-01 01:13:44.000000', 'consum', 0.0216, 'lps'),
	(617084, 130, '2014-04-01 01:13:45.000000', 'consum', 0.0214, 'lps'),
	(617085, 130, '2014-04-01 01:13:46.000000', 'consum', 0.0211, 'lps'),
	(617086, 130, '2014-04-01 01:13:47.000000', 'consum', 0.0217, 'lps'),
	(617087, 130, '2014-04-01 01:13:48.000000', 'consum', 0.0218, 'lps'),
	(617088, 130, '2014-04-01 01:13:49.000000', 'consum', 0.0219, 'lps'),
	(617089, 130, '2014-04-01 01:13:50.000000', 'consum', 0.0219, 'lps'),
	(617090, 130, '2014-04-01 01:13:51.000000', 'consum', 0.0216, 'lps'),
	(617091, 130, '2014-04-01 01:13:52.000000', 'consum', 0.0212, 'lps'),
	(617092, 130, '2014-04-01 01:13:53.000000', 'consum', 0.0217, 'lps'),
	(617093, 130, '2014-04-01 01:13:54.000000', 'consum', 0.0215, 'lps'),
	(617094, 130, '2014-04-01 01:13:55.000000', 'consum', 0.0215, 'lps'),
	(617095, 130, '2014-04-01 01:13:56.000000', 'consum', 0.0218, 'lps'),
	(617096, 130, '2014-04-01 01:13:57.000000', 'consum', 0.0214, 'lps'),
	(617097, 130, '2014-04-01 01:13:58.000000', 'consum', 0.0217, 'lps'),
	(617098, 130, '2014-04-01 01:13:59.000000', 'consum', 0.0210, 'lps'),
	(617099, 130, '2014-04-01 01:14:00.000000', 'consum', 0.0212, 'lps'),
	(617100, 130, '2014-04-01 01:14:01.000000', 'consum', 0.0220, 'lps'),
	(617101, 130, '2014-04-01 01:14:02.000000', 'consum', 0.0219, 'lps'),
	(617102, 130, '2014-04-01 01:14:03.000000', 'consum', 0.0212, 'lps'),
	(617103, 130, '2014-04-01 01:14:04.000000', 'consum', 0.0218, 'lps'),
	(617104, 130, '2014-04-01 01:14:05.000000', 'consum', 0.0210, 'lps'),
	(617105, 130, '2014-04-01 01:14:06.000000', 'consum', 0.0211, 'lps'),
	(617106, 130, '2014-04-01 01:14:07.000000', 'consum', 0.0214, 'lps'),
	(617107, 130, '2014-04-01 01:14:08.000000', 'consum', 0.0215, 'lps'),
	(617108, 130, '2014-04-01 01:14:09.000000', 'consum', 0.0212, 'lps'),
	(617109, 130, '2014-04-01 01:14:10.000000', 'consum', 0.0219, 'lps'),
	(617110, 130, '2014-04-01 01:14:11.000000', 'consum', 0.0215, 'lps'),
	(617111, 130, '2014-04-01 01:14:12.000000', 'consum', 0.0217, 'lps'),
	(617112, 130, '2014-04-01 01:14:13.000000', 'consum', 0.0220, 'lps'),
	(617113, 130, '2014-04-01 01:14:14.000000', 'consum', 0.0217, 'lps'),
	(617114, 130, '2014-04-01 01:14:15.000000', 'consum', 0.0216, 'lps'),
	(617115, 130, '2014-04-01 01:14:16.000000', 'consum', 0.0219, 'lps'),
	(617116, 130, '2014-04-01 01:14:17.000000', 'consum', 0.0211, 'lps'),
	(617117, 130, '2014-04-01 01:14:18.000000', 'consum', 0.0215, 'lps'),
	(617118, 130, '2014-04-01 01:14:19.000000', 'consum', 0.0210, 'lps'),
	(617119, 130, '2014-04-01 01:14:20.000000', 'consum', 0.0217, 'lps'),
	(617120, 130, '2014-04-01 01:14:21.000000', 'consum', 0.0211, 'lps'),
	(617121, 130, '2014-04-01 01:14:22.000000', 'consum', 0.0218, 'lps'),
	(617122, 130, '2014-04-01 01:14:23.000000', 'consum', 0.0210, 'lps'),
	(617123, 130, '2014-04-01 01:14:24.000000', 'consum', 0.0210, 'lps'),
	(617124, 130, '2014-04-01 01:14:25.000000', 'consum', 0.0210, 'lps'),
	(617125, 130, '2014-04-01 01:14:26.000000', 'consum', 0.0210, 'lps'),
	(617126, 130, '2014-04-01 01:14:27.000000', 'consum', 0.0214, 'lps'),
	(617127, 130, '2014-04-01 01:14:28.000000', 'consum', 0.0216, 'lps'),
	(617128, 130, '2014-04-01 01:14:29.000000', 'consum', 0.0215, 'lps'),
	(617129, 130, '2014-04-01 01:14:30.000000', 'consum', 0.0221, 'lps'),
	(617130, 130, '2014-04-01 01:14:31.000000', 'consum', 0.0212, 'lps'),
	(617131, 130, '2014-04-01 01:14:32.000000', 'consum', 0.0212, 'lps'),
	(617132, 130, '2014-04-01 01:14:33.000000', 'consum', 0.0216, 'lps'),
	(617133, 130, '2014-04-01 01:14:34.000000', 'consum', 0.0211, 'lps'),
	(617134, 130, '2014-04-01 01:14:35.000000', 'consum', 0.0220, 'lps'),
	(617135, 130, '2014-04-01 01:14:36.000000', 'consum', 0.0210, 'lps'),
	(617136, 130, '2014-04-01 01:14:37.000000', 'consum', 0.0216, 'lps'),
	(617137, 130, '2014-04-01 01:14:38.000000', 'consum', 0.0217, 'lps'),
	(617138, 130, '2014-04-01 01:14:39.000000', 'consum', 0.0215, 'lps'),
	(617139, 130, '2014-04-01 01:14:40.000000', 'consum', 0.0213, 'lps'),
	(617140, 130, '2014-04-01 01:14:41.000000', 'consum', 0.0212, 'lps'),
	(617141, 130, '2014-04-01 01:14:42.000000', 'consum', 0.0210, 'lps'),
	(617142, 130, '2014-04-01 01:14:43.000000', 'consum', 0.0216, 'lps'),
	(617143, 130, '2014-04-01 01:14:44.000000', 'consum', 0.0218, 'lps'),
	(617144, 130, '2014-04-01 01:14:45.000000', 'consum', 0.0220, 'lps'),
	(617145, 130, '2014-04-01 01:14:46.000000', 'consum', 0.0214, 'lps'),
	(617146, 130, '2014-04-01 01:14:47.000000', 'consum', 0.0211, 'lps'),
	(617147, 130, '2014-04-01 01:14:48.000000', 'consum', 0.0214, 'lps'),
	(617148, 130, '2014-04-01 01:14:49.000000', 'consum', 0.0216, 'lps'),
	(617149, 130, '2014-04-01 01:14:50.000000', 'consum', 0.0215, 'lps'),
	(617150, 130, '2014-04-01 01:14:51.000000', 'consum', 0.0220, 'lps'),
	(617151, 130, '2014-04-01 01:14:52.000000', 'consum', 0.0221, 'lps'),
	(617152, 130, '2014-04-01 01:14:53.000000', 'consum', 0.0210, 'lps'),
	(617153, 130, '2014-04-01 01:14:54.000000', 'consum', 0.0214, 'lps'),
	(617154, 130, '2014-04-01 01:14:55.000000', 'consum', 0.0220, 'lps'),
	(617155, 130, '2014-04-01 01:14:56.000000', 'consum', 0.0213, 'lps'),
	(617156, 130, '2014-04-01 01:14:57.000000', 'consum', 0.0219, 'lps'),
	(617157, 130, '2014-04-01 01:14:58.000000', 'consum', 0.0212, 'lps'),
	(617158, 130, '2014-04-01 01:14:59.000000', 'consum', 0.0215, 'lps'),
	(617159, 130, '2014-04-01 01:15:00.000000', 'consum', 0.0218, 'lps'),
	(617160, 130, '2014-04-01 01:15:01.000000', 'consum', 0.0213, 'lps'),
	(617161, 130, '2014-04-01 01:15:02.000000', 'consum', 0.0211, 'lps'),
	(617162, 130, '2014-04-01 01:15:03.000000', 'consum', 0.0220, 'lps'),
	(617163, 130, '2014-04-01 01:15:04.000000', 'consum', 0.0219, 'lps'),
	(617164, 130, '2014-04-01 01:15:05.000000', 'consum', 0.0216, 'lps'),
	(617165, 130, '2014-04-01 01:15:06.000000', 'consum', 0.0213, 'lps'),
	(617166, 130, '2014-04-01 01:15:07.000000', 'consum', 0.0217, 'lps'),
	(617167, 130, '2014-04-01 01:15:08.000000', 'consum', 0.0215, 'lps'),
	(617168, 130, '2014-04-01 01:15:09.000000', 'consum', 0.0215, 'lps'),
	(617169, 130, '2014-04-01 01:15:10.000000', 'consum', 0.0221, 'lps'),
	(617170, 130, '2014-04-01 01:15:11.000000', 'consum', 0.0213, 'lps'),
	(617171, 130, '2014-04-01 01:15:12.000000', 'consum', 0.0215, 'lps'),
	(617172, 130, '2014-04-01 01:15:13.000000', 'consum', 0.0217, 'lps'),
	(617173, 130, '2014-04-01 01:15:14.000000', 'consum', 0.0218, 'lps'),
	(617174, 130, '2014-04-01 01:15:15.000000', 'consum', 0.0218, 'lps'),
	(617175, 130, '2014-04-01 01:15:16.000000', 'consum', 0.0216, 'lps'),
	(617176, 130, '2014-04-01 01:15:17.000000', 'consum', 0.0214, 'lps'),
	(617177, 130, '2014-04-01 01:15:18.000000', 'consum', 0.0214, 'lps'),
	(617178, 130, '2014-04-01 01:15:19.000000', 'consum', 0.0220, 'lps'),
	(617179, 130, '2014-04-01 01:15:20.000000', 'consum', 0.0221, 'lps'),
	(617180, 130, '2014-04-01 01:15:21.000000', 'consum', 0.0215, 'lps'),
	(617181, 130, '2014-04-01 01:15:22.000000', 'consum', 0.0211, 'lps'),
	(617182, 130, '2014-04-01 01:15:23.000000', 'consum', 0.0215, 'lps'),
	(617183, 130, '2014-04-01 01:15:24.000000', 'consum', 0.0220, 'lps'),
	(617184, 130, '2014-04-01 01:15:25.000000', 'consum', 0.0221, 'lps'),
	(617185, 130, '2014-04-01 01:15:26.000000', 'consum', 0.0210, 'lps'),
	(617186, 130, '2014-04-01 01:15:27.000000', 'consum', 0.0216, 'lps'),
	(617187, 130, '2014-04-01 01:15:28.000000', 'consum', 0.0216, 'lps'),
	(617188, 130, '2014-04-01 01:15:29.000000', 'consum', 0.0210, 'lps'),
	(617189, 130, '2014-04-01 01:15:30.000000', 'consum', 0.0215, 'lps'),
	(617190, 130, '2014-04-01 01:15:31.000000', 'consum', 0.0211, 'lps'),
	(617191, 130, '2014-04-01 01:15:32.000000', 'consum', 0.0212, 'lps'),
	(617192, 130, '2014-04-01 01:15:33.000000', 'consum', 0.0219, 'lps'),
	(617193, 130, '2014-04-01 01:15:34.000000', 'consum', 0.0213, 'lps'),
	(617194, 130, '2014-04-01 01:15:35.000000', 'consum', 0.0221, 'lps'),
	(617195, 130, '2014-04-01 01:15:36.000000', 'consum', 0.0220, 'lps'),
	(617196, 130, '2014-04-01 01:15:37.000000', 'consum', 0.0217, 'lps'),
	(617197, 130, '2014-04-01 01:15:38.000000', 'consum', 0.0213, 'lps'),
	(617198, 130, '2014-04-01 01:15:39.000000', 'consum', 0.0219, 'lps'),
	(617199, 130, '2014-04-01 01:15:40.000000', 'consum', 0.0221, 'lps'),
	(617200, 130, '2014-04-01 01:15:41.000000', 'consum', 0.0215, 'lps'),
	(617201, 130, '2014-04-01 01:15:42.000000', 'consum', 0.0212, 'lps'),
	(617202, 130, '2014-04-01 01:15:43.000000', 'consum', 0.0221, 'lps'),
	(617203, 130, '2014-04-01 01:15:44.000000', 'consum', 0.0211, 'lps'),
	(617204, 130, '2014-04-01 01:15:45.000000', 'consum', 0.0219, 'lps'),
	(617205, 130, '2014-04-01 01:15:46.000000', 'consum', 0.0217, 'lps'),
	(617206, 130, '2014-04-01 01:15:47.000000', 'consum', 0.0219, 'lps'),
	(617207, 130, '2014-04-01 01:15:48.000000', 'consum', 0.0211, 'lps'),
	(617208, 130, '2014-04-01 01:15:49.000000', 'consum', 0.0212, 'lps'),
	(617209, 130, '2014-04-01 01:15:50.000000', 'consum', 0.0218, 'lps'),
	(617210, 130, '2014-04-01 01:15:51.000000', 'consum', 0.0219, 'lps'),
	(617211, 130, '2014-04-01 01:15:52.000000', 'consum', 0.0218, 'lps'),
	(617212, 130, '2014-04-01 01:15:53.000000', 'consum', 0.0214, 'lps'),
	(617213, 130, '2014-04-01 01:15:54.000000', 'consum', 0.0219, 'lps'),
	(617214, 130, '2014-04-01 01:15:55.000000', 'consum', 0.0219, 'lps'),
	(617215, 130, '2014-04-01 01:15:56.000000', 'consum', 0.0214, 'lps'),
	(617216, 130, '2014-04-01 01:15:57.000000', 'consum', 0.0219, 'lps'),
	(617217, 130, '2014-04-01 01:15:58.000000', 'consum', 0.0217, 'lps'),
	(617218, 130, '2014-04-01 01:15:59.000000', 'consum', 0.0221, 'lps'),
	(617219, 130, '2014-04-01 01:16:00.000000', 'consum', 0.0221, 'lps'),
	(617220, 130, '2014-04-01 01:16:01.000000', 'consum', 0.0217, 'lps'),
	(617221, 130, '2014-04-01 01:16:02.000000', 'consum', 0.0215, 'lps'),
	(617222, 130, '2014-04-01 01:16:03.000000', 'consum', 0.0215, 'lps'),
	(617223, 130, '2014-04-01 01:16:04.000000', 'consum', 0.0218, 'lps'),
	(617224, 130, '2014-04-01 01:16:05.000000', 'consum', 0.0214, 'lps'),
	(617225, 130, '2014-04-01 01:16:06.000000', 'consum', 0.0217, 'lps'),
	(617226, 130, '2014-04-01 01:16:07.000000', 'consum', 0.0211, 'lps'),
	(617227, 130, '2014-04-01 01:16:08.000000', 'consum', 0.0216, 'lps'),
	(617228, 130, '2014-04-01 01:16:09.000000', 'consum', 0.0214, 'lps'),
	(617229, 130, '2014-04-01 01:16:10.000000', 'consum', 0.0212, 'lps'),
	(617230, 130, '2014-04-01 01:16:11.000000', 'consum', 0.0211, 'lps'),
	(617231, 130, '2014-04-01 01:16:12.000000', 'consum', 0.0221, 'lps'),
	(617232, 130, '2014-04-01 01:16:13.000000', 'consum', 0.0212, 'lps'),
	(617233, 130, '2014-04-01 01:16:14.000000', 'consum', 0.0213, 'lps'),
	(617234, 130, '2014-04-01 01:16:15.000000', 'consum', 0.0218, 'lps'),
	(617235, 130, '2014-04-01 01:16:16.000000', 'consum', 0.0220, 'lps'),
	(617236, 130, '2014-04-01 01:16:17.000000', 'consum', 0.0213, 'lps'),
	(617237, 130, '2014-04-01 01:16:18.000000', 'consum', 0.0217, 'lps'),
	(617238, 130, '2014-04-01 01:16:19.000000', 'consum', 0.0213, 'lps'),
	(617239, 130, '2014-04-01 01:16:20.000000', 'consum', 0.0215, 'lps'),
	(617240, 130, '2014-04-01 01:16:21.000000', 'consum', 0.0218, 'lps'),
	(617241, 130, '2014-04-01 01:16:22.000000', 'consum', 0.0220, 'lps'),
	(617242, 130, '2014-04-01 01:16:23.000000', 'consum', 0.0215, 'lps'),
	(617243, 130, '2014-04-01 01:16:24.000000', 'consum', 0.0217, 'lps'),
	(617244, 130, '2014-04-01 01:16:25.000000', 'consum', 0.0220, 'lps'),
	(617245, 130, '2014-04-01 01:16:26.000000', 'consum', 0.0212, 'lps'),
	(617246, 130, '2014-04-01 01:16:27.000000', 'consum', 0.0217, 'lps'),
	(617247, 130, '2014-04-01 01:16:28.000000', 'consum', 0.0217, 'lps'),
	(617248, 130, '2014-04-01 01:16:29.000000', 'consum', 0.0211, 'lps'),
	(617249, 130, '2014-04-01 01:16:30.000000', 'consum', 0.0218, 'lps'),
	(617250, 130, '2014-04-01 01:16:31.000000', 'consum', 0.0211, 'lps'),
	(617251, 130, '2014-04-01 01:16:32.000000', 'consum', 0.0218, 'lps'),
	(617252, 130, '2014-04-01 01:16:33.000000', 'consum', 0.0221, 'lps'),
	(617253, 130, '2014-04-01 01:16:34.000000', 'consum', 0.0219, 'lps'),
	(617254, 130, '2014-04-01 01:16:35.000000', 'consum', 0.0221, 'lps'),
	(617255, 130, '2014-04-01 01:16:36.000000', 'consum', 0.0216, 'lps'),
	(617256, 130, '2014-04-01 01:16:37.000000', 'consum', 0.0221, 'lps'),
	(617257, 130, '2014-04-01 01:16:38.000000', 'consum', 0.0221, 'lps'),
	(617258, 130, '2014-04-01 01:16:39.000000', 'consum', 0.0221, 'lps'),
	(617259, 130, '2014-04-01 01:16:40.000000', 'consum', 0.0219, 'lps'),
	(617260, 130, '2014-04-01 01:16:41.000000', 'consum', 0.0213, 'lps'),
	(617261, 130, '2014-04-01 01:16:42.000000', 'consum', 0.0220, 'lps'),
	(617262, 130, '2014-04-01 01:16:43.000000', 'consum', 0.0217, 'lps'),
	(617263, 130, '2014-04-01 01:16:44.000000', 'consum', 0.0214, 'lps'),
	(617264, 130, '2014-04-01 01:16:45.000000', 'consum', 0.0211, 'lps'),
	(617265, 130, '2014-04-01 01:16:46.000000', 'consum', 0.0215, 'lps'),
	(617266, 130, '2014-04-01 01:16:47.000000', 'consum', 0.0218, 'lps'),
	(617267, 130, '2014-04-01 01:16:48.000000', 'consum', 0.0215, 'lps'),
	(617268, 130, '2014-04-01 01:16:49.000000', 'consum', 0.0211, 'lps'),
	(617269, 130, '2014-04-01 01:16:50.000000', 'consum', 0.0214, 'lps'),
	(617270, 130, '2014-04-01 01:16:51.000000', 'consum', 0.0213, 'lps'),
	(617271, 130, '2014-04-01 01:16:52.000000', 'consum', 0.0216, 'lps'),
	(617272, 130, '2014-04-01 01:16:53.000000', 'consum', 0.0220, 'lps'),
	(617273, 130, '2014-04-01 01:16:54.000000', 'consum', 0.0216, 'lps'),
	(617274, 130, '2014-04-01 01:16:55.000000', 'consum', 0.0210, 'lps'),
	(617275, 130, '2014-04-01 01:16:56.000000', 'consum', 0.0218, 'lps'),
	(617276, 130, '2014-04-01 01:16:57.000000', 'consum', 0.0214, 'lps'),
	(617277, 130, '2014-04-01 01:16:58.000000', 'consum', 0.0217, 'lps'),
	(617278, 130, '2014-04-01 01:16:59.000000', 'consum', 0.0210, 'lps'),
	(617279, 130, '2014-04-01 01:17:00.000000', 'consum', 0.0215, 'lps'),
	(617280, 130, '2014-04-01 01:17:01.000000', 'consum', 0.0211, 'lps'),
	(617281, 130, '2014-04-01 01:17:02.000000', 'consum', 0.0212, 'lps'),
	(617282, 130, '2014-04-01 01:17:03.000000', 'consum', 0.0217, 'lps'),
	(617283, 130, '2014-04-01 01:17:04.000000', 'consum', 0.0217, 'lps'),
	(617284, 130, '2014-04-01 01:17:05.000000', 'consum', 0.0213, 'lps'),
	(617285, 130, '2014-04-01 01:17:06.000000', 'consum', 0.0218, 'lps'),
	(617286, 130, '2014-04-01 01:17:07.000000', 'consum', 0.0215, 'lps'),
	(617287, 130, '2014-04-01 01:17:08.000000', 'consum', 0.0211, 'lps'),
	(617288, 130, '2014-04-01 01:17:09.000000', 'consum', 0.0214, 'lps'),
	(617289, 130, '2014-04-01 01:17:10.000000', 'consum', 0.0216, 'lps'),
	(617290, 130, '2014-04-01 01:17:11.000000', 'consum', 0.0215, 'lps'),
	(617291, 130, '2014-04-01 01:17:12.000000', 'consum', 0.0218, 'lps'),
	(617292, 130, '2014-04-01 01:17:13.000000', 'consum', 0.0211, 'lps'),
	(617293, 130, '2014-04-01 01:17:14.000000', 'consum', 0.0217, 'lps'),
	(617294, 130, '2014-04-01 01:17:15.000000', 'consum', 0.0217, 'lps'),
	(617295, 130, '2014-04-01 01:17:16.000000', 'consum', 0.0213, 'lps'),
	(617296, 130, '2014-04-01 01:17:17.000000', 'consum', 0.0216, 'lps'),
	(617297, 130, '2014-04-01 01:17:18.000000', 'consum', 0.0219, 'lps'),
	(617298, 130, '2014-04-01 01:17:19.000000', 'consum', 0.0216, 'lps'),
	(617299, 130, '2014-04-01 01:17:20.000000', 'consum', 0.0212, 'lps'),
	(617300, 130, '2014-04-01 01:17:21.000000', 'consum', 0.0216, 'lps'),
	(617301, 130, '2014-04-01 01:17:22.000000', 'consum', 0.0220, 'lps'),
	(617302, 130, '2014-04-01 01:17:23.000000', 'consum', 0.0210, 'lps'),
	(617303, 130, '2014-04-01 01:17:24.000000', 'consum', 0.0214, 'lps'),
	(617304, 130, '2014-04-01 01:17:25.000000', 'consum', 0.0217, 'lps'),
	(617305, 130, '2014-04-01 01:17:26.000000', 'consum', 0.0212, 'lps'),
	(617306, 130, '2014-04-01 01:17:27.000000', 'consum', 0.0211, 'lps'),
	(617307, 130, '2014-04-01 01:17:28.000000', 'consum', 0.0210, 'lps'),
	(617308, 130, '2014-04-01 01:17:29.000000', 'consum', 0.0220, 'lps'),
	(617309, 130, '2014-04-01 01:17:30.000000', 'consum', 0.0214, 'lps'),
	(617310, 130, '2014-04-01 01:17:31.000000', 'consum', 0.0210, 'lps'),
	(617311, 130, '2014-04-01 01:17:32.000000', 'consum', 0.0210, 'lps'),
	(617312, 130, '2014-04-01 01:17:33.000000', 'consum', 0.0213, 'lps'),
	(617313, 130, '2014-04-01 01:17:34.000000', 'consum', 0.0213, 'lps'),
	(617314, 130, '2014-04-01 01:17:35.000000', 'consum', 0.0214, 'lps'),
	(617315, 130, '2014-04-01 01:17:36.000000', 'consum', 0.0211, 'lps'),
	(617316, 130, '2014-04-01 01:17:37.000000', 'consum', 0.0214, 'lps'),
	(617317, 130, '2014-04-01 01:17:38.000000', 'consum', 0.0218, 'lps'),
	(617318, 130, '2014-04-01 01:17:39.000000', 'consum', 0.0215, 'lps'),
	(617319, 130, '2014-04-01 01:17:40.000000', 'consum', 0.0211, 'lps'),
	(617320, 130, '2014-04-01 01:17:41.000000', 'consum', 0.0213, 'lps'),
	(617321, 130, '2014-04-01 01:17:42.000000', 'consum', 0.0212, 'lps'),
	(617322, 130, '2014-04-01 01:17:43.000000', 'consum', 0.0221, 'lps'),
	(617323, 130, '2014-04-01 01:17:44.000000', 'consum', 0.0214, 'lps'),
	(617324, 130, '2014-04-01 01:17:45.000000', 'consum', 0.0221, 'lps'),
	(617325, 130, '2014-04-01 01:17:46.000000', 'consum', 0.0219, 'lps'),
	(617326, 130, '2014-04-01 01:17:47.000000', 'consum', 0.0221, 'lps'),
	(617327, 130, '2014-04-01 01:17:48.000000', 'consum', 0.0213, 'lps'),
	(617328, 130, '2014-04-01 01:17:49.000000', 'consum', 0.0216, 'lps'),
	(617329, 130, '2014-04-01 01:17:50.000000', 'consum', 0.0220, 'lps'),
	(617330, 130, '2014-04-01 01:17:51.000000', 'consum', 0.0218, 'lps'),
	(617331, 130, '2014-04-01 01:17:52.000000', 'consum', 0.0220, 'lps'),
	(617332, 130, '2014-04-01 01:17:53.000000', 'consum', 0.0211, 'lps'),
	(617333, 130, '2014-04-01 01:17:54.000000', 'consum', 0.0213, 'lps'),
	(617334, 130, '2014-04-01 01:17:55.000000', 'consum', 0.0210, 'lps'),
	(617335, 130, '2014-04-01 01:17:56.000000', 'consum', 0.0212, 'lps'),
	(617336, 130, '2014-04-01 01:17:57.000000', 'consum', 0.0219, 'lps'),
	(617337, 130, '2014-04-01 01:17:58.000000', 'consum', 0.0216, 'lps'),
	(617338, 130, '2014-04-01 01:17:59.000000', 'consum', 0.0213, 'lps'),
	(617339, 130, '2014-04-01 01:18:00.000000', 'consum', 0.0218, 'lps'),
	(617340, 130, '2014-04-01 01:18:01.000000', 'consum', 0.0219, 'lps'),
	(617341, 130, '2014-04-01 01:18:02.000000', 'consum', 0.0219, 'lps'),
	(617342, 130, '2014-04-01 01:18:03.000000', 'consum', 0.0216, 'lps'),
	(617343, 130, '2014-04-01 01:18:04.000000', 'consum', 0.0213, 'lps'),
	(617344, 130, '2014-04-01 01:18:05.000000', 'consum', 0.0221, 'lps'),
	(617345, 130, '2014-04-01 01:18:06.000000', 'consum', 0.0210, 'lps'),
	(617346, 130, '2014-04-01 01:18:07.000000', 'consum', 0.0212, 'lps'),
	(617347, 130, '2014-04-01 01:18:08.000000', 'consum', 0.0221, 'lps'),
	(617348, 130, '2014-04-01 01:18:09.000000', 'consum', 0.0211, 'lps'),
	(617349, 130, '2014-04-01 01:18:10.000000', 'consum', 0.0218, 'lps'),
	(617350, 130, '2014-04-01 01:18:11.000000', 'consum', 0.0213, 'lps'),
	(617351, 130, '2014-04-01 01:18:12.000000', 'consum', 0.0214, 'lps'),
	(617352, 130, '2014-04-01 01:18:13.000000', 'consum', 0.0220, 'lps'),
	(617353, 130, '2014-04-01 01:18:14.000000', 'consum', 0.0211, 'lps'),
	(617354, 130, '2014-04-01 01:18:15.000000', 'consum', 0.0211, 'lps'),
	(617355, 130, '2014-04-01 01:18:16.000000', 'consum', 0.0211, 'lps'),
	(617356, 130, '2014-04-01 01:18:17.000000', 'consum', 0.0215, 'lps'),
	(617357, 130, '2014-04-01 01:18:18.000000', 'consum', 0.0220, 'lps'),
	(617358, 130, '2014-04-01 01:18:19.000000', 'consum', 0.0211, 'lps'),
	(617359, 130, '2014-04-01 01:18:20.000000', 'consum', 0.0220, 'lps'),
	(617360, 130, '2014-04-01 01:18:21.000000', 'consum', 0.0210, 'lps'),
	(617361, 130, '2014-04-01 01:18:22.000000', 'consum', 0.0216, 'lps'),
	(617362, 130, '2014-04-01 01:18:23.000000', 'consum', 0.0217, 'lps'),
	(617363, 130, '2014-04-01 01:18:24.000000', 'consum', 0.0214, 'lps'),
	(617364, 130, '2014-04-01 01:18:25.000000', 'consum', 0.0212, 'lps'),
	(617365, 130, '2014-04-01 01:18:26.000000', 'consum', 0.0220, 'lps'),
	(617366, 130, '2014-04-01 01:18:27.000000', 'consum', 0.0220, 'lps'),
	(617367, 130, '2014-04-01 01:18:28.000000', 'consum', 0.0216, 'lps'),
	(617368, 130, '2014-04-01 01:18:29.000000', 'consum', 0.0212, 'lps'),
	(617369, 130, '2014-04-01 01:18:30.000000', 'consum', 0.0216, 'lps'),
	(617370, 130, '2014-04-01 01:18:31.000000', 'consum', 0.0221, 'lps'),
	(617371, 130, '2014-04-01 01:18:32.000000', 'consum', 0.0211, 'lps'),
	(617372, 130, '2014-04-01 01:18:33.000000', 'consum', 0.0217, 'lps'),
	(617373, 130, '2014-04-01 01:18:34.000000', 'consum', 0.0220, 'lps'),
	(617374, 130, '2014-04-01 01:18:35.000000', 'consum', 0.0214, 'lps'),
	(617375, 130, '2014-04-01 01:18:36.000000', 'consum', 0.0214, 'lps'),
	(617376, 130, '2014-04-01 01:18:37.000000', 'consum', 0.0217, 'lps'),
	(617377, 130, '2014-04-01 01:18:38.000000', 'consum', 0.0212, 'lps'),
	(617378, 130, '2014-04-01 01:18:39.000000', 'consum', 0.0221, 'lps'),
	(617379, 130, '2014-04-01 01:18:40.000000', 'consum', 0.0211, 'lps'),
	(617380, 130, '2014-04-01 01:18:41.000000', 'consum', 0.0218, 'lps'),
	(617381, 130, '2014-04-01 01:18:42.000000', 'consum', 0.0211, 'lps'),
	(617382, 130, '2014-04-01 01:18:43.000000', 'consum', 0.0217, 'lps'),
	(617383, 130, '2014-04-01 01:18:44.000000', 'consum', 0.0218, 'lps'),
	(617384, 130, '2014-04-01 01:18:45.000000', 'consum', 0.0219, 'lps'),
	(617385, 130, '2014-04-01 01:18:46.000000', 'consum', 0.0220, 'lps'),
	(617386, 130, '2014-04-01 01:18:47.000000', 'consum', 0.0221, 'lps'),
	(617387, 130, '2014-04-01 01:18:48.000000', 'consum', 0.0213, 'lps'),
	(617388, 130, '2014-04-01 01:18:49.000000', 'consum', 0.0216, 'lps'),
	(617389, 130, '2014-04-01 01:18:50.000000', 'consum', 0.0218, 'lps'),
	(617390, 130, '2014-04-01 01:18:51.000000', 'consum', 0.0210, 'lps'),
	(617391, 130, '2014-04-01 01:18:52.000000', 'consum', 0.0210, 'lps'),
	(617392, 130, '2014-04-01 01:18:53.000000', 'consum', 0.0221, 'lps'),
	(617393, 130, '2014-04-01 01:18:54.000000', 'consum', 0.0219, 'lps'),
	(617394, 130, '2014-04-01 01:18:55.000000', 'consum', 0.0221, 'lps'),
	(617395, 130, '2014-04-01 01:18:56.000000', 'consum', 0.0213, 'lps'),
	(617396, 130, '2014-04-01 01:18:57.000000', 'consum', 0.0220, 'lps'),
	(617397, 130, '2014-04-01 01:18:58.000000', 'consum', 0.0215, 'lps'),
	(617398, 130, '2014-04-01 01:18:59.000000', 'consum', 0.0218, 'lps'),
	(617399, 130, '2014-04-01 01:19:00.000000', 'consum', 0.0221, 'lps'),
	(617400, 130, '2014-04-01 01:19:01.000000', 'consum', 0.0221, 'lps'),
	(617401, 130, '2014-04-01 01:19:02.000000', 'consum', 0.0218, 'lps'),
	(617402, 130, '2014-04-01 01:19:03.000000', 'consum', 0.0219, 'lps'),
	(617403, 130, '2014-04-01 01:19:04.000000', 'consum', 0.0217, 'lps'),
	(617404, 130, '2014-04-01 01:19:05.000000', 'consum', 0.0210, 'lps'),
	(617405, 130, '2014-04-01 01:19:06.000000', 'consum', 0.0211, 'lps'),
	(617406, 130, '2014-04-01 01:19:07.000000', 'consum', 0.0217, 'lps'),
	(617407, 130, '2014-04-01 01:19:08.000000', 'consum', 0.0218, 'lps'),
	(617408, 130, '2014-04-01 01:19:09.000000', 'consum', 0.0216, 'lps'),
	(617409, 130, '2014-04-01 01:19:10.000000', 'consum', 0.0216, 'lps'),
	(617410, 130, '2014-04-01 01:19:11.000000', 'consum', 0.0212, 'lps'),
	(617411, 130, '2014-04-01 01:19:12.000000', 'consum', 0.0214, 'lps'),
	(617412, 130, '2014-04-01 01:19:13.000000', 'consum', 0.0211, 'lps'),
	(617413, 130, '2014-04-01 01:19:14.000000', 'consum', 0.0218, 'lps'),
	(617414, 130, '2014-04-01 01:19:15.000000', 'consum', 0.0212, 'lps'),
	(617415, 130, '2014-04-01 01:19:16.000000', 'consum', 0.0219, 'lps'),
	(617416, 130, '2014-04-01 01:19:17.000000', 'consum', 0.0215, 'lps'),
	(617417, 130, '2014-04-01 01:19:18.000000', 'consum', 0.0218, 'lps'),
	(617418, 130, '2014-04-01 01:19:19.000000', 'consum', 0.0211, 'lps'),
	(617419, 130, '2014-04-01 01:19:20.000000', 'consum', 0.0218, 'lps'),
	(617420, 130, '2014-04-01 01:19:21.000000', 'consum', 0.0211, 'lps'),
	(617421, 130, '2014-04-01 01:19:22.000000', 'consum', 0.0214, 'lps'),
	(617422, 130, '2014-04-01 01:19:23.000000', 'consum', 0.0217, 'lps'),
	(617423, 130, '2014-04-01 01:19:24.000000', 'consum', 0.0210, 'lps'),
	(617424, 130, '2014-04-01 01:19:25.000000', 'consum', 0.0213, 'lps'),
	(617425, 130, '2014-04-01 01:19:26.000000', 'consum', 0.0214, 'lps'),
	(617426, 130, '2014-04-01 01:19:27.000000', 'consum', 0.0211, 'lps'),
	(617427, 130, '2014-04-01 01:19:28.000000', 'consum', 0.0215, 'lps'),
	(617428, 130, '2014-04-01 01:19:29.000000', 'consum', 0.0218, 'lps'),
	(617429, 130, '2014-04-01 01:19:30.000000', 'consum', 0.0213, 'lps'),
	(617430, 130, '2014-04-01 01:19:31.000000', 'consum', 0.0213, 'lps'),
	(617431, 130, '2014-04-01 01:19:32.000000', 'consum', 0.0216, 'lps'),
	(617432, 130, '2014-04-01 01:19:33.000000', 'consum', 0.0220, 'lps'),
	(617433, 130, '2014-04-01 01:19:34.000000', 'consum', 0.0220, 'lps'),
	(617434, 130, '2014-04-01 01:19:35.000000', 'consum', 0.0219, 'lps'),
	(617435, 130, '2014-04-01 01:19:36.000000', 'consum', 0.0212, 'lps'),
	(617436, 130, '2014-04-01 01:19:37.000000', 'consum', 0.0216, 'lps'),
	(617437, 130, '2014-04-01 01:19:38.000000', 'consum', 0.0212, 'lps'),
	(617438, 130, '2014-04-01 01:19:39.000000', 'consum', 0.0215, 'lps'),
	(617439, 130, '2014-04-01 01:19:40.000000', 'consum', 0.0218, 'lps'),
	(617440, 130, '2014-04-01 01:19:41.000000', 'consum', 0.0221, 'lps'),
	(617441, 130, '2014-04-01 01:19:42.000000', 'consum', 0.0218, 'lps'),
	(617442, 130, '2014-04-01 01:19:43.000000', 'consum', 0.0219, 'lps'),
	(617443, 130, '2014-04-01 01:19:44.000000', 'consum', 0.0220, 'lps'),
	(617444, 130, '2014-04-01 01:19:45.000000', 'consum', 0.0210, 'lps'),
	(617445, 130, '2014-04-01 01:19:46.000000', 'consum', 0.0215, 'lps'),
	(617446, 130, '2014-04-01 01:19:47.000000', 'consum', 0.0214, 'lps'),
	(617447, 130, '2014-04-01 01:19:48.000000', 'consum', 0.0212, 'lps'),
	(617448, 130, '2014-04-01 01:19:49.000000', 'consum', 0.0210, 'lps'),
	(617449, 130, '2014-04-01 01:19:50.000000', 'consum', 0.0218, 'lps'),
	(617450, 130, '2014-04-01 01:19:51.000000', 'consum', 0.0215, 'lps'),
	(617451, 130, '2014-04-01 01:19:52.000000', 'consum', 0.0220, 'lps'),
	(617452, 130, '2014-04-01 01:19:53.000000', 'consum', 0.0212, 'lps'),
	(617453, 130, '2014-04-01 01:19:54.000000', 'consum', 0.0216, 'lps'),
	(617454, 130, '2014-04-01 01:19:55.000000', 'consum', 0.0221, 'lps'),
	(617455, 130, '2014-04-01 01:19:56.000000', 'consum', 0.0213, 'lps'),
	(617456, 130, '2014-04-01 01:19:57.000000', 'consum', 0.0214, 'lps'),
	(617457, 130, '2014-04-01 01:19:58.000000', 'consum', 0.0221, 'lps'),
	(617458, 130, '2014-04-01 01:19:59.000000', 'consum', 0.0217, 'lps'),
	(617459, 130, '2014-04-01 01:20:00.000000', 'consum', 0.0213, 'lps'),
	(617460, 130, '2014-04-01 01:20:01.000000', 'consum', 0.0217, 'lps'),
	(617461, 130, '2014-04-01 01:20:02.000000', 'consum', 0.0214, 'lps'),
	(617462, 130, '2014-04-01 01:20:03.000000', 'consum', 0.0221, 'lps'),
	(617463, 130, '2014-04-01 01:20:04.000000', 'consum', 0.0218, 'lps'),
	(617464, 130, '2014-04-01 01:20:05.000000', 'consum', 0.0216, 'lps'),
	(617465, 130, '2014-04-01 01:20:06.000000', 'consum', 0.0217, 'lps'),
	(617466, 130, '2014-04-01 01:20:07.000000', 'consum', 0.0216, 'lps'),
	(617467, 130, '2014-04-01 01:20:08.000000', 'consum', 0.0219, 'lps'),
	(617468, 130, '2014-04-01 01:20:09.000000', 'consum', 0.0215, 'lps'),
	(617469, 130, '2014-04-01 01:20:10.000000', 'consum', 0.0219, 'lps'),
	(617470, 130, '2014-04-01 01:20:11.000000', 'consum', 0.0217, 'lps'),
	(617471, 130, '2014-04-01 01:20:12.000000', 'consum', 0.0218, 'lps'),
	(617472, 130, '2014-04-01 01:20:13.000000', 'consum', 0.0218, 'lps'),
	(617473, 130, '2014-04-01 01:20:14.000000', 'consum', 0.0215, 'lps'),
	(617474, 130, '2014-04-01 01:20:15.000000', 'consum', 0.0212, 'lps'),
	(617475, 130, '2014-04-01 01:20:16.000000', 'consum', 0.0218, 'lps'),
	(617476, 130, '2014-04-01 01:20:17.000000', 'consum', 0.0218, 'lps'),
	(617477, 130, '2014-04-01 01:20:18.000000', 'consum', 0.0216, 'lps'),
	(617478, 130, '2014-04-01 01:20:19.000000', 'consum', 0.0214, 'lps'),
	(617479, 130, '2014-04-01 01:20:20.000000', 'consum', 0.0215, 'lps'),
	(617480, 130, '2014-04-01 01:20:21.000000', 'consum', 0.0210, 'lps'),
	(617481, 130, '2014-04-01 01:20:22.000000', 'consum', 0.0220, 'lps'),
	(617482, 130, '2014-04-01 01:20:23.000000', 'consum', 0.0212, 'lps'),
	(617483, 130, '2014-04-01 01:20:24.000000', 'consum', 0.0216, 'lps'),
	(617484, 130, '2014-04-01 01:20:25.000000', 'consum', 0.0220, 'lps'),
	(617485, 130, '2014-04-01 01:20:26.000000', 'consum', 0.0220, 'lps'),
	(617486, 130, '2014-04-01 01:20:27.000000', 'consum', 0.0218, 'lps'),
	(617487, 130, '2014-04-01 01:20:28.000000', 'consum', 0.0220, 'lps'),
	(617488, 130, '2014-04-01 01:20:29.000000', 'consum', 0.0215, 'lps'),
	(617489, 130, '2014-04-01 01:20:30.000000', 'consum', 0.0216, 'lps'),
	(617490, 130, '2014-04-01 01:20:31.000000', 'consum', 0.0213, 'lps'),
	(617491, 130, '2014-04-01 01:20:32.000000', 'consum', 0.0220, 'lps'),
	(617492, 130, '2014-04-01 01:20:33.000000', 'consum', 0.0215, 'lps'),
	(617493, 130, '2014-04-01 01:20:34.000000', 'consum', 0.0218, 'lps'),
	(617494, 130, '2014-04-01 01:20:35.000000', 'consum', 0.0212, 'lps'),
	(617495, 130, '2014-04-01 01:20:36.000000', 'consum', 0.0221, 'lps'),
	(617496, 130, '2014-04-01 01:20:37.000000', 'consum', 0.0210, 'lps'),
	(617497, 130, '2014-04-01 01:20:38.000000', 'consum', 0.0215, 'lps'),
	(617498, 130, '2014-04-01 01:20:39.000000', 'consum', 0.0210, 'lps'),
	(617499, 130, '2014-04-01 01:20:40.000000', 'consum', 0.0221, 'lps'),
	(617500, 130, '2014-04-01 01:20:41.000000', 'consum', 0.0215, 'lps'),
	(617501, 130, '2014-04-01 01:20:42.000000', 'consum', 0.0217, 'lps'),
	(617502, 130, '2014-04-01 01:20:43.000000', 'consum', 0.0218, 'lps'),
	(617503, 130, '2014-04-01 01:20:44.000000', 'consum', 0.0218, 'lps'),
	(617504, 130, '2014-04-01 01:20:45.000000', 'consum', 0.0214, 'lps'),
	(617505, 130, '2014-04-01 01:20:46.000000', 'consum', 0.0218, 'lps'),
	(617506, 130, '2014-04-01 01:20:47.000000', 'consum', 0.0214, 'lps'),
	(617507, 130, '2014-04-01 01:20:48.000000', 'consum', 0.0219, 'lps'),
	(617508, 130, '2014-04-01 01:20:49.000000', 'consum', 0.0217, 'lps'),
	(617509, 130, '2014-04-01 01:20:50.000000', 'consum', 0.0210, 'lps'),
	(617510, 130, '2014-04-01 01:20:51.000000', 'consum', 0.0213, 'lps'),
	(617511, 130, '2014-04-01 01:20:52.000000', 'consum', 0.0213, 'lps'),
	(617512, 130, '2014-04-01 01:20:53.000000', 'consum', 0.0218, 'lps'),
	(617513, 130, '2014-04-01 01:20:54.000000', 'consum', 0.0214, 'lps'),
	(617514, 130, '2014-04-01 01:20:55.000000', 'consum', 0.0210, 'lps'),
	(617515, 130, '2014-04-01 01:20:56.000000', 'consum', 0.0221, 'lps'),
	(617516, 130, '2014-04-01 01:20:57.000000', 'consum', 0.0218, 'lps'),
	(617517, 130, '2014-04-01 01:20:58.000000', 'consum', 0.0217, 'lps'),
	(617518, 130, '2014-04-01 01:20:59.000000', 'consum', 0.0211, 'lps'),
	(617519, 130, '2014-04-01 01:21:00.000000', 'consum', 0.0219, 'lps'),
	(617520, 130, '2014-04-01 01:21:01.000000', 'consum', 0.0216, 'lps'),
	(617521, 130, '2014-04-01 01:21:02.000000', 'consum', 0.0215, 'lps'),
	(617522, 130, '2014-04-01 01:21:03.000000', 'consum', 0.0214, 'lps'),
	(617523, 130, '2014-04-01 01:21:04.000000', 'consum', 0.0219, 'lps'),
	(617524, 130, '2014-04-01 01:21:05.000000', 'consum', 0.0219, 'lps'),
	(617525, 130, '2014-04-01 01:21:06.000000', 'consum', 0.0216, 'lps'),
	(617526, 130, '2014-04-01 01:21:07.000000', 'consum', 0.0213, 'lps'),
	(617527, 130, '2014-04-01 01:21:08.000000', 'consum', 0.0219, 'lps'),
	(617528, 130, '2014-04-01 01:21:09.000000', 'consum', 0.0221, 'lps'),
	(617529, 131, '2014-04-01 00:00:00.000000', 'consum', 0.0229, 'lps'),
	(617530, 131, '2014-04-01 00:00:01.000000', 'consum', 0.0225, 'lps'),
	(617531, 131, '2014-04-01 00:00:02.000000', 'consum', 0.0226, 'lps'),
	(617532, 131, '2014-04-01 00:00:03.000000', 'consum', 0.0229, 'lps'),
	(617533, 131, '2014-04-01 00:00:04.000000', 'consum', 0.0215, 'lps'),
	(617534, 131, '2014-04-01 00:00:05.000000', 'consum', 0.0219, 'lps'),
	(617535, 131, '2014-04-01 00:00:06.000000', 'consum', 0.0223, 'lps'),
	(617536, 131, '2014-04-01 00:00:07.000000', 'consum', 0.0226, 'lps'),
	(617537, 131, '2014-04-01 00:00:08.000000', 'consum', 0.0213, 'lps'),
	(617538, 131, '2014-04-01 00:00:09.000000', 'consum', 0.0217, 'lps'),
	(617539, 131, '2014-04-01 00:00:10.000000', 'consum', 0.0217, 'lps'),
	(617540, 131, '2014-04-01 00:00:11.000000', 'consum', 0.0226, 'lps'),
	(617541, 131, '2014-04-01 00:00:12.000000', 'consum', 0.0227, 'lps'),
	(617542, 131, '2014-04-01 00:00:13.000000', 'consum', 0.0226, 'lps'),
	(617543, 131, '2014-04-01 00:00:14.000000', 'consum', 0.0222, 'lps'),
	(617544, 131, '2014-04-01 00:00:15.000000', 'consum', 0.0223, 'lps'),
	(617545, 131, '2014-04-01 00:00:16.000000', 'consum', 0.0221, 'lps'),
	(617546, 131, '2014-04-01 00:00:17.000000', 'consum', 0.0224, 'lps'),
	(617547, 131, '2014-04-01 00:00:18.000000', 'consum', 0.0228, 'lps'),
	(617548, 131, '2014-04-01 00:00:19.000000', 'consum', 0.0220, 'lps'),
	(617549, 131, '2014-04-01 00:00:20.000000', 'consum', 0.0227, 'lps'),
	(617550, 131, '2014-04-01 00:00:21.000000', 'consum', 0.0223, 'lps'),
	(617551, 131, '2014-04-01 00:00:22.000000', 'consum', 0.0224, 'lps'),
	(617552, 131, '2014-04-01 00:00:23.000000', 'consum', 0.0221, 'lps'),
	(617553, 131, '2014-04-01 00:00:24.000000', 'consum', 0.0225, 'lps'),
	(617554, 131, '2014-04-01 00:00:25.000000', 'consum', 0.0214, 'lps'),
	(617555, 131, '2014-04-01 00:00:26.000000', 'consum', 0.0225, 'lps'),
	(617556, 131, '2014-04-01 00:00:27.000000', 'consum', 0.0213, 'lps'),
	(617557, 131, '2014-04-01 00:00:28.000000', 'consum', 0.0219, 'lps'),
	(617558, 131, '2014-04-01 00:00:29.000000', 'consum', 0.0226, 'lps'),
	(617559, 131, '2014-04-01 00:00:30.000000', 'consum', 0.0223, 'lps'),
	(617560, 131, '2014-04-01 00:00:31.000000', 'consum', 0.0210, 'lps'),
	(617561, 131, '2014-04-01 00:00:32.000000', 'consum', 0.0212, 'lps'),
	(617562, 131, '2014-04-01 00:00:33.000000', 'consum', 0.0221, 'lps'),
	(617563, 131, '2014-04-01 00:00:34.000000', 'consum', 0.0219, 'lps'),
	(617564, 131, '2014-04-01 00:00:35.000000', 'consum', 0.0222, 'lps'),
	(617565, 131, '2014-04-01 00:00:36.000000', 'consum', 0.0223, 'lps'),
	(617566, 131, '2014-04-01 00:00:37.000000', 'consum', 0.0220, 'lps'),
	(617567, 131, '2014-04-01 00:00:38.000000', 'consum', 0.0223, 'lps'),
	(617568, 131, '2014-04-01 00:00:39.000000', 'consum', 0.0223, 'lps'),
	(617569, 131, '2014-04-01 00:00:40.000000', 'consum', 0.0219, 'lps'),
	(617570, 131, '2014-04-01 00:00:41.000000', 'consum', 0.0216, 'lps'),
	(617571, 131, '2014-04-01 00:00:42.000000', 'consum', 0.0213, 'lps'),
	(617572, 131, '2014-04-01 00:00:43.000000', 'consum', 0.0227, 'lps'),
	(617573, 131, '2014-04-01 00:00:44.000000', 'consum', 0.0229, 'lps'),
	(617574, 131, '2014-04-01 00:00:45.000000', 'consum', 0.0211, 'lps'),
	(617575, 131, '2014-04-01 00:00:46.000000', 'consum', 0.0221, 'lps'),
	(617576, 131, '2014-04-01 00:00:47.000000', 'consum', 0.0223, 'lps'),
	(617577, 131, '2014-04-01 00:00:48.000000', 'consum', 0.0222, 'lps'),
	(617578, 131, '2014-04-01 00:00:49.000000', 'consum', 0.0210, 'lps'),
	(617579, 131, '2014-04-01 00:00:50.000000', 'consum', 0.0217, 'lps'),
	(617580, 131, '2014-04-01 00:00:51.000000', 'consum', 0.0223, 'lps'),
	(617581, 131, '2014-04-01 00:00:52.000000', 'consum', 0.0214, 'lps'),
	(617582, 131, '2014-04-01 00:00:53.000000', 'consum', 0.0212, 'lps'),
	(617583, 131, '2014-04-01 00:00:54.000000', 'consum', 0.0210, 'lps'),
	(617584, 131, '2014-04-01 00:00:55.000000', 'consum', 0.0225, 'lps'),
	(617585, 131, '2014-04-01 00:00:56.000000', 'consum', 0.0224, 'lps'),
	(617586, 131, '2014-04-01 00:00:57.000000', 'consum', 0.0215, 'lps'),
	(617587, 131, '2014-04-01 00:00:58.000000', 'consum', 0.0214, 'lps'),
	(617588, 131, '2014-04-01 00:00:59.000000', 'consum', 0.0214, 'lps'),
	(617589, 131, '2014-04-01 00:01:00.000000', 'consum', 0.0218, 'lps'),
	(617590, 131, '2014-04-01 00:01:01.000000', 'consum', 0.0219, 'lps'),
	(617591, 131, '2014-04-01 00:01:02.000000', 'consum', 0.0214, 'lps'),
	(617592, 131, '2014-04-01 00:01:03.000000', 'consum', 0.0220, 'lps'),
	(617593, 131, '2014-04-01 00:01:04.000000', 'consum', 0.0210, 'lps'),
	(617594, 131, '2014-04-01 00:01:05.000000', 'consum', 0.0221, 'lps'),
	(617595, 131, '2014-04-01 00:01:06.000000', 'consum', 0.0225, 'lps'),
	(617596, 131, '2014-04-01 00:01:07.000000', 'consum', 0.0214, 'lps'),
	(617597, 131, '2014-04-01 00:01:08.000000', 'consum', 0.0224, 'lps'),
	(617598, 131, '2014-04-01 00:01:09.000000', 'consum', 0.0210, 'lps'),
	(617599, 131, '2014-04-01 00:01:10.000000', 'consum', 0.0228, 'lps'),
	(617600, 131, '2014-04-01 00:01:11.000000', 'consum', 0.0219, 'lps'),
	(617601, 131, '2014-04-01 00:01:12.000000', 'consum', 0.0221, 'lps'),
	(617602, 131, '2014-04-01 00:01:13.000000', 'consum', 0.0217, 'lps'),
	(617603, 131, '2014-04-01 00:01:14.000000', 'consum', 0.0216, 'lps'),
	(617604, 131, '2014-04-01 00:01:15.000000', 'consum', 0.0219, 'lps'),
	(617605, 131, '2014-04-01 00:01:16.000000', 'consum', 0.0217, 'lps'),
	(617606, 131, '2014-04-01 00:01:17.000000', 'consum', 0.0219, 'lps'),
	(617607, 131, '2014-04-01 00:01:18.000000', 'consum', 0.0215, 'lps'),
	(617608, 131, '2014-04-01 00:01:19.000000', 'consum', 0.0228, 'lps'),
	(617609, 131, '2014-04-01 00:01:20.000000', 'consum', 0.0224, 'lps'),
	(617610, 131, '2014-04-01 00:01:21.000000', 'consum', 0.0228, 'lps'),
	(617611, 131, '2014-04-01 00:01:22.000000', 'consum', 0.0218, 'lps'),
	(617612, 131, '2014-04-01 00:01:23.000000', 'consum', 0.0218, 'lps'),
	(617613, 131, '2014-04-01 00:01:24.000000', 'consum', 0.0223, 'lps'),
	(617614, 131, '2014-04-01 00:01:25.000000', 'consum', 0.0215, 'lps'),
	(617615, 131, '2014-04-01 00:01:26.000000', 'consum', 0.0215, 'lps'),
	(617616, 131, '2014-04-01 00:01:27.000000', 'consum', 0.0221, 'lps'),
	(617617, 131, '2014-04-01 00:01:28.000000', 'consum', 0.0211, 'lps'),
	(617618, 131, '2014-04-01 00:01:29.000000', 'consum', 0.0221, 'lps'),
	(617619, 131, '2014-04-01 00:01:30.000000', 'consum', 0.0222, 'lps'),
	(617620, 131, '2014-04-01 00:01:31.000000', 'consum', 0.0219, 'lps'),
	(617621, 131, '2014-04-01 00:01:32.000000', 'consum', 0.0221, 'lps'),
	(617622, 131, '2014-04-01 00:01:33.000000', 'consum', 0.0216, 'lps'),
	(617623, 131, '2014-04-01 00:01:34.000000', 'consum', 0.0229, 'lps'),
	(617624, 131, '2014-04-01 00:01:35.000000', 'consum', 0.0228, 'lps'),
	(617625, 131, '2014-04-01 00:01:36.000000', 'consum', 0.0223, 'lps'),
	(617626, 131, '2014-04-01 00:01:37.000000', 'consum', 0.0219, 'lps'),
	(617627, 131, '2014-04-01 00:01:38.000000', 'consum', 0.0220, 'lps'),
	(617628, 131, '2014-04-01 00:01:39.000000', 'consum', 0.0212, 'lps'),
	(617629, 131, '2014-04-01 00:01:40.000000', 'consum', 0.0212, 'lps'),
	(617630, 131, '2014-04-01 00:01:41.000000', 'consum', 0.0214, 'lps'),
	(617631, 131, '2014-04-01 00:01:42.000000', 'consum', 0.0223, 'lps'),
	(617632, 131, '2014-04-01 00:01:43.000000', 'consum', 0.0226, 'lps'),
	(617633, 131, '2014-04-01 00:01:44.000000', 'consum', 0.0210, 'lps'),
	(617634, 131, '2014-04-01 00:01:45.000000', 'consum', 0.0221, 'lps'),
	(617635, 131, '2014-04-01 00:01:46.000000', 'consum', 0.0225, 'lps'),
	(617636, 131, '2014-04-01 00:01:47.000000', 'consum', 0.0214, 'lps'),
	(617637, 131, '2014-04-01 00:01:48.000000', 'consum', 0.0225, 'lps'),
	(617638, 131, '2014-04-01 00:01:49.000000', 'consum', 0.0215, 'lps'),
	(617639, 131, '2014-04-01 00:01:50.000000', 'consum', 0.0211, 'lps'),
	(617640, 131, '2014-04-01 00:01:51.000000', 'consum', 0.0221, 'lps'),
	(617641, 131, '2014-04-01 00:01:52.000000', 'consum', 0.0222, 'lps'),
	(617642, 131, '2014-04-01 00:01:53.000000', 'consum', 0.0216, 'lps'),
	(617643, 131, '2014-04-01 00:01:54.000000', 'consum', 0.0224, 'lps'),
	(617644, 131, '2014-04-01 00:01:55.000000', 'consum', 0.0224, 'lps'),
	(617645, 131, '2014-04-01 00:01:56.000000', 'consum', 0.0216, 'lps'),
	(617646, 131, '2014-04-01 00:01:57.000000', 'consum', 0.0221, 'lps'),
	(617647, 131, '2014-04-01 00:01:58.000000', 'consum', 0.0225, 'lps'),
	(617648, 131, '2014-04-01 00:01:59.000000', 'consum', 0.0213, 'lps'),
	(617649, 131, '2014-04-01 00:02:00.000000', 'consum', 0.0221, 'lps'),
	(617650, 131, '2014-04-01 00:02:01.000000', 'consum', 0.0217, 'lps'),
	(617651, 131, '2014-04-01 00:02:02.000000', 'consum', 0.0211, 'lps'),
	(617652, 131, '2014-04-01 00:02:03.000000', 'consum', 0.0214, 'lps'),
	(617653, 131, '2014-04-01 00:02:04.000000', 'consum', 0.0210, 'lps'),
	(617654, 131, '2014-04-01 00:02:05.000000', 'consum', 0.0217, 'lps'),
	(617655, 131, '2014-04-01 00:02:06.000000', 'consum', 0.0226, 'lps'),
	(617656, 131, '2014-04-01 00:02:07.000000', 'consum', 0.0210, 'lps'),
	(617657, 131, '2014-04-01 00:02:08.000000', 'consum', 0.0222, 'lps'),
	(617658, 131, '2014-04-01 00:02:09.000000', 'consum', 0.0229, 'lps'),
	(617659, 131, '2014-04-01 00:02:10.000000', 'consum', 0.0212, 'lps'),
	(617660, 131, '2014-04-01 00:02:11.000000', 'consum', 0.0222, 'lps'),
	(617661, 131, '2014-04-01 00:02:12.000000', 'consum', 0.0223, 'lps'),
	(617662, 131, '2014-04-01 00:02:13.000000', 'consum', 0.0221, 'lps'),
	(617663, 131, '2014-04-01 00:02:14.000000', 'consum', 0.0227, 'lps'),
	(617664, 131, '2014-04-01 00:02:15.000000', 'consum', 0.0223, 'lps'),
	(617665, 131, '2014-04-01 00:02:16.000000', 'consum', 0.0225, 'lps'),
	(617666, 131, '2014-04-01 00:02:17.000000', 'consum', 0.0224, 'lps'),
	(617667, 131, '2014-04-01 00:02:18.000000', 'consum', 0.0216, 'lps'),
	(617668, 131, '2014-04-01 00:02:19.000000', 'consum', 0.0220, 'lps'),
	(617669, 131, '2014-04-01 00:02:20.000000', 'consum', 0.0221, 'lps'),
	(617670, 131, '2014-04-01 00:02:21.000000', 'consum', 0.0218, 'lps'),
	(617671, 131, '2014-04-01 00:02:22.000000', 'consum', 0.0216, 'lps'),
	(617672, 131, '2014-04-01 00:02:23.000000', 'consum', 0.0217, 'lps'),
	(617673, 131, '2014-04-01 00:02:24.000000', 'consum', 0.0229, 'lps'),
	(617674, 131, '2014-04-01 00:02:25.000000', 'consum', 0.0222, 'lps'),
	(617675, 131, '2014-04-01 00:02:26.000000', 'consum', 0.0213, 'lps'),
	(617676, 131, '2014-04-01 00:02:27.000000', 'consum', 0.0212, 'lps'),
	(617677, 131, '2014-04-01 00:02:28.000000', 'consum', 0.0210, 'lps'),
	(617678, 131, '2014-04-01 00:02:29.000000', 'consum', 0.0224, 'lps'),
	(617679, 131, '2014-04-01 00:02:30.000000', 'consum', 0.0221, 'lps'),
	(617680, 131, '2014-04-01 00:02:31.000000', 'consum', 0.0225, 'lps'),
	(617681, 131, '2014-04-01 00:02:32.000000', 'consum', 0.0210, 'lps'),
	(617682, 131, '2014-04-01 00:02:33.000000', 'consum', 0.0226, 'lps'),
	(617683, 131, '2014-04-01 00:02:34.000000', 'consum', 0.0210, 'lps'),
	(617684, 131, '2014-04-01 00:02:35.000000', 'consum', 0.0224, 'lps'),
	(617685, 131, '2014-04-01 00:02:36.000000', 'consum', 0.0220, 'lps'),
	(617686, 131, '2014-04-01 00:02:37.000000', 'consum', 0.0218, 'lps'),
	(617687, 131, '2014-04-01 00:02:38.000000', 'consum', 0.0220, 'lps'),
	(617688, 131, '2014-04-01 00:02:39.000000', 'consum', 0.0219, 'lps'),
	(617689, 131, '2014-04-01 00:02:40.000000', 'consum', 0.0224, 'lps'),
	(617690, 131, '2014-04-01 00:02:41.000000', 'consum', 0.0215, 'lps'),
	(617691, 131, '2014-04-01 00:02:42.000000', 'consum', 0.0212, 'lps'),
	(617692, 131, '2014-04-01 00:02:43.000000', 'consum', 0.0226, 'lps'),
	(617693, 131, '2014-04-01 00:02:44.000000', 'consum', 0.0224, 'lps'),
	(617694, 131, '2014-04-01 00:02:45.000000', 'consum', 0.0211, 'lps'),
	(617695, 131, '2014-04-01 00:02:46.000000', 'consum', 0.0216, 'lps'),
	(617696, 131, '2014-04-01 00:02:47.000000', 'consum', 0.0217, 'lps'),
	(617697, 131, '2014-04-01 00:02:48.000000', 'consum', 0.0227, 'lps'),
	(617698, 131, '2014-04-01 00:02:49.000000', 'consum', 0.0214, 'lps'),
	(617699, 131, '2014-04-01 00:02:50.000000', 'consum', 0.0219, 'lps'),
	(617700, 131, '2014-04-01 00:02:51.000000', 'consum', 0.0223, 'lps'),
	(617701, 131, '2014-04-01 00:02:52.000000', 'consum', 0.0211, 'lps'),
	(617702, 131, '2014-04-01 00:02:53.000000', 'consum', 0.0216, 'lps'),
	(617703, 131, '2014-04-01 00:02:54.000000', 'consum', 0.0219, 'lps'),
	(617704, 131, '2014-04-01 00:02:55.000000', 'consum', 0.0217, 'lps'),
	(617705, 131, '2014-04-01 00:02:56.000000', 'consum', 0.0217, 'lps'),
	(617706, 131, '2014-04-01 00:02:57.000000', 'consum', 0.0225, 'lps'),
	(617707, 131, '2014-04-01 00:02:58.000000', 'consum', 0.0224, 'lps'),
	(617708, 131, '2014-04-01 00:02:59.000000', 'consum', 0.0216, 'lps'),
	(617709, 131, '2014-04-01 00:03:00.000000', 'consum', 0.0217, 'lps'),
	(617710, 131, '2014-04-01 00:03:01.000000', 'consum', 0.0228, 'lps'),
	(617711, 131, '2014-04-01 00:03:02.000000', 'consum', 0.0221, 'lps'),
	(617712, 131, '2014-04-01 00:03:03.000000', 'consum', 0.0210, 'lps'),
	(617713, 131, '2014-04-01 00:03:04.000000', 'consum', 0.0217, 'lps'),
	(617714, 131, '2014-04-01 00:03:05.000000', 'consum', 0.0226, 'lps'),
	(617715, 131, '2014-04-01 00:03:06.000000', 'consum', 0.0211, 'lps'),
	(617716, 131, '2014-04-01 00:03:07.000000', 'consum', 0.0228, 'lps'),
	(617717, 131, '2014-04-01 00:03:08.000000', 'consum', 0.0216, 'lps'),
	(617718, 131, '2014-04-01 00:03:09.000000', 'consum', 0.0229, 'lps'),
	(617719, 131, '2014-04-01 00:03:10.000000', 'consum', 0.0224, 'lps'),
	(617720, 131, '2014-04-01 00:03:11.000000', 'consum', 0.0225, 'lps'),
	(617721, 131, '2014-04-01 00:03:12.000000', 'consum', 0.0224, 'lps'),
	(617722, 131, '2014-04-01 00:03:13.000000', 'consum', 0.0215, 'lps'),
	(617723, 131, '2014-04-01 00:03:14.000000', 'consum', 0.0213, 'lps'),
	(617724, 131, '2014-04-01 00:03:15.000000', 'consum', 0.0212, 'lps'),
	(617725, 131, '2014-04-01 00:03:16.000000', 'consum', 0.0213, 'lps'),
	(617726, 131, '2014-04-01 00:03:17.000000', 'consum', 0.0216, 'lps'),
	(617727, 131, '2014-04-01 00:03:18.000000', 'consum', 0.0215, 'lps'),
	(617728, 131, '2014-04-01 00:03:19.000000', 'consum', 0.0215, 'lps'),
	(617729, 131, '2014-04-01 00:03:20.000000', 'consum', 0.0223, 'lps'),
	(617730, 131, '2014-04-01 00:03:21.000000', 'consum', 0.0218, 'lps'),
	(617731, 131, '2014-04-01 00:03:22.000000', 'consum', 0.0212, 'lps'),
	(617732, 131, '2014-04-01 00:03:23.000000', 'consum', 0.0218, 'lps'),
	(617733, 131, '2014-04-01 00:03:24.000000', 'consum', 0.0222, 'lps'),
	(617734, 131, '2014-04-01 00:03:25.000000', 'consum', 0.0228, 'lps'),
	(617735, 131, '2014-04-01 00:03:26.000000', 'consum', 0.0225, 'lps'),
	(617736, 131, '2014-04-01 00:03:27.000000', 'consum', 0.0210, 'lps'),
	(617737, 131, '2014-04-01 00:03:28.000000', 'consum', 0.0226, 'lps'),
	(617738, 131, '2014-04-01 00:03:29.000000', 'consum', 0.0211, 'lps'),
	(617739, 131, '2014-04-01 00:03:30.000000', 'consum', 0.0226, 'lps'),
	(617740, 131, '2014-04-01 00:03:31.000000', 'consum', 0.0227, 'lps'),
	(617741, 131, '2014-04-01 00:03:32.000000', 'consum', 0.0228, 'lps'),
	(617742, 131, '2014-04-01 00:03:33.000000', 'consum', 0.0229, 'lps'),
	(617743, 131, '2014-04-01 00:03:34.000000', 'consum', 0.0210, 'lps'),
	(617744, 131, '2014-04-01 00:03:35.000000', 'consum', 0.0216, 'lps'),
	(617745, 131, '2014-04-01 00:03:36.000000', 'consum', 0.0218, 'lps'),
	(617746, 131, '2014-04-01 00:03:37.000000', 'consum', 0.0214, 'lps'),
	(617747, 131, '2014-04-01 00:03:38.000000', 'consum', 0.0224, 'lps'),
	(617748, 131, '2014-04-01 00:03:39.000000', 'consum', 0.0212, 'lps'),
	(617749, 131, '2014-04-01 00:03:40.000000', 'consum', 0.0216, 'lps'),
	(617750, 131, '2014-04-01 00:03:41.000000', 'consum', 0.0213, 'lps'),
	(617751, 131, '2014-04-01 00:03:42.000000', 'consum', 0.0211, 'lps'),
	(617752, 131, '2014-04-01 00:03:43.000000', 'consum', 0.0226, 'lps'),
	(617753, 131, '2014-04-01 00:03:44.000000', 'consum', 0.0227, 'lps'),
	(617754, 131, '2014-04-01 00:03:45.000000', 'consum', 0.0226, 'lps'),
	(617755, 131, '2014-04-01 00:03:46.000000', 'consum', 0.0222, 'lps'),
	(617756, 131, '2014-04-01 00:03:47.000000', 'consum', 0.0223, 'lps'),
	(617757, 131, '2014-04-01 00:03:48.000000', 'consum', 0.0217, 'lps'),
	(617758, 131, '2014-04-01 00:03:49.000000', 'consum', 0.0229, 'lps'),
	(617759, 131, '2014-04-01 00:03:50.000000', 'consum', 0.0222, 'lps'),
	(617760, 131, '2014-04-01 00:03:51.000000', 'consum', 0.0213, 'lps'),
	(617761, 131, '2014-04-01 00:03:52.000000', 'consum', 0.0213, 'lps'),
	(617762, 131, '2014-04-01 00:03:53.000000', 'consum', 0.0213, 'lps'),
	(617763, 131, '2014-04-01 00:03:54.000000', 'consum', 0.0217, 'lps'),
	(617764, 131, '2014-04-01 00:03:55.000000', 'consum', 0.0219, 'lps'),
	(617765, 131, '2014-04-01 00:03:56.000000', 'consum', 0.0214, 'lps'),
	(617766, 131, '2014-04-01 00:03:57.000000', 'consum', 0.0222, 'lps'),
	(617767, 131, '2014-04-01 00:03:58.000000', 'consum', 0.0217, 'lps'),
	(617768, 131, '2014-04-01 00:03:59.000000', 'consum', 0.0213, 'lps'),
	(617769, 131, '2014-04-01 00:04:00.000000', 'consum', 0.0223, 'lps'),
	(617770, 131, '2014-04-01 00:04:01.000000', 'consum', 0.0226, 'lps'),
	(617771, 131, '2014-04-01 00:04:02.000000', 'consum', 0.0212, 'lps'),
	(617772, 131, '2014-04-01 00:04:03.000000', 'consum', 0.0211, 'lps'),
	(617773, 131, '2014-04-01 00:04:04.000000', 'consum', 0.0210, 'lps'),
	(617774, 131, '2014-04-01 00:04:05.000000', 'consum', 0.0229, 'lps'),
	(617775, 131, '2014-04-01 00:04:06.000000', 'consum', 0.0224, 'lps'),
	(617776, 131, '2014-04-01 00:04:07.000000', 'consum', 0.0222, 'lps'),
	(617777, 131, '2014-04-01 00:04:08.000000', 'consum', 0.0229, 'lps'),
	(617778, 131, '2014-04-01 00:04:09.000000', 'consum', 0.0211, 'lps'),
	(617779, 131, '2014-04-01 00:04:10.000000', 'consum', 0.0218, 'lps'),
	(617780, 131, '2014-04-01 00:04:11.000000', 'consum', 0.0227, 'lps'),
	(617781, 131, '2014-04-01 00:04:12.000000', 'consum', 0.0212, 'lps'),
	(617782, 131, '2014-04-01 00:04:13.000000', 'consum', 0.0211, 'lps'),
	(617783, 131, '2014-04-01 00:04:14.000000', 'consum', 0.0229, 'lps'),
	(617784, 131, '2014-04-01 00:04:15.000000', 'consum', 0.0220, 'lps'),
	(617785, 131, '2014-04-01 00:04:16.000000', 'consum', 0.0225, 'lps'),
	(617786, 131, '2014-04-01 00:04:17.000000', 'consum', 0.0215, 'lps'),
	(617787, 131, '2014-04-01 00:04:18.000000', 'consum', 0.0212, 'lps'),
	(617788, 131, '2014-04-01 00:04:19.000000', 'consum', 0.0224, 'lps'),
	(617789, 131, '2014-04-01 00:04:20.000000', 'consum', 0.0217, 'lps'),
	(617790, 131, '2014-04-01 00:04:21.000000', 'consum', 0.0222, 'lps'),
	(617791, 131, '2014-04-01 00:04:22.000000', 'consum', 0.0210, 'lps'),
	(617792, 131, '2014-04-01 00:04:23.000000', 'consum', 0.0215, 'lps'),
	(617793, 131, '2014-04-01 00:04:24.000000', 'consum', 0.0213, 'lps'),
	(617794, 131, '2014-04-01 00:04:25.000000', 'consum', 0.0214, 'lps'),
	(617795, 131, '2014-04-01 00:04:26.000000', 'consum', 0.0218, 'lps'),
	(617796, 131, '2014-04-01 00:04:27.000000', 'consum', 0.0220, 'lps'),
	(617797, 131, '2014-04-01 00:04:28.000000', 'consum', 0.0218, 'lps'),
	(617798, 131, '2014-04-01 00:04:29.000000', 'consum', 0.0220, 'lps'),
	(617799, 131, '2014-04-01 00:04:30.000000', 'consum', 0.0218, 'lps'),
	(617800, 131, '2014-04-01 00:04:31.000000', 'consum', 0.0220, 'lps'),
	(617801, 131, '2014-04-01 00:04:32.000000', 'consum', 0.0215, 'lps'),
	(617802, 131, '2014-04-01 00:04:33.000000', 'consum', 0.0226, 'lps'),
	(617803, 131, '2014-04-01 00:04:34.000000', 'consum', 0.0216, 'lps'),
	(617804, 131, '2014-04-01 00:04:35.000000', 'consum', 0.0213, 'lps'),
	(617805, 131, '2014-04-01 00:04:36.000000', 'consum', 0.0225, 'lps'),
	(617806, 131, '2014-04-01 00:04:37.000000', 'consum', 0.0219, 'lps'),
	(617807, 131, '2014-04-01 00:04:38.000000', 'consum', 0.0210, 'lps'),
	(617808, 131, '2014-04-01 00:04:39.000000', 'consum', 0.0223, 'lps'),
	(617809, 131, '2014-04-01 00:04:40.000000', 'consum', 0.0217, 'lps'),
	(617810, 131, '2014-04-01 00:04:41.000000', 'consum', 0.0226, 'lps'),
	(617811, 131, '2014-04-01 00:04:42.000000', 'consum', 0.0228, 'lps'),
	(617812, 131, '2014-04-01 00:04:43.000000', 'consum', 0.0215, 'lps'),
	(617813, 131, '2014-04-01 00:04:44.000000', 'consum', 0.0220, 'lps'),
	(617814, 131, '2014-04-01 00:04:45.000000', 'consum', 0.0226, 'lps'),
	(617815, 131, '2014-04-01 00:04:46.000000', 'consum', 0.0221, 'lps'),
	(617816, 131, '2014-04-01 00:04:47.000000', 'consum', 0.0219, 'lps'),
	(617817, 131, '2014-04-01 00:04:48.000000', 'consum', 0.0220, 'lps'),
	(617818, 131, '2014-04-01 00:04:49.000000', 'consum', 0.0214, 'lps'),
	(617819, 131, '2014-04-01 00:04:50.000000', 'consum', 0.0221, 'lps'),
	(617820, 131, '2014-04-01 00:04:51.000000', 'consum', 0.0214, 'lps'),
	(617821, 131, '2014-04-01 00:04:52.000000', 'consum', 0.0215, 'lps'),
	(617822, 131, '2014-04-01 00:04:53.000000', 'consum', 0.0225, 'lps'),
	(617823, 131, '2014-04-01 00:04:54.000000', 'consum', 0.0210, 'lps'),
	(617824, 131, '2014-04-01 00:04:55.000000', 'consum', 0.0225, 'lps'),
	(617825, 131, '2014-04-01 00:04:56.000000', 'consum', 0.0225, 'lps'),
	(617826, 131, '2014-04-01 00:04:57.000000', 'consum', 0.0222, 'lps'),
	(617827, 131, '2014-04-01 00:04:58.000000', 'consum', 0.0225, 'lps'),
	(617828, 131, '2014-04-01 00:04:59.000000', 'consum', 0.0228, 'lps'),
	(617829, 131, '2014-04-01 00:05:00.000000', 'consum', 0.0215, 'lps'),
	(617830, 131, '2014-04-01 00:05:01.000000', 'consum', 0.0224, 'lps'),
	(617831, 131, '2014-04-01 00:05:02.000000', 'consum', 0.0227, 'lps'),
	(617832, 131, '2014-04-01 00:05:03.000000', 'consum', 0.0210, 'lps'),
	(617833, 131, '2014-04-01 00:05:04.000000', 'consum', 0.0221, 'lps'),
	(617834, 131, '2014-04-01 00:05:05.000000', 'consum', 0.0224, 'lps'),
	(617835, 131, '2014-04-01 00:05:06.000000', 'consum', 0.0227, 'lps'),
	(617836, 131, '2014-04-01 00:05:07.000000', 'consum', 0.0216, 'lps'),
	(617837, 131, '2014-04-01 00:05:08.000000', 'consum', 0.0229, 'lps'),
	(617838, 131, '2014-04-01 00:05:09.000000', 'consum', 0.0228, 'lps'),
	(617839, 131, '2014-04-01 00:05:10.000000', 'consum', 0.0222, 'lps'),
	(617840, 131, '2014-04-01 00:05:11.000000', 'consum', 0.0218, 'lps'),
	(617841, 131, '2014-04-01 00:05:12.000000', 'consum', 0.0212, 'lps'),
	(617842, 131, '2014-04-01 00:05:13.000000', 'consum', 0.0218, 'lps'),
	(617843, 131, '2014-04-01 00:05:14.000000', 'consum', 0.0225, 'lps'),
	(617844, 131, '2014-04-01 00:05:15.000000', 'consum', 0.0221, 'lps'),
	(617845, 131, '2014-04-01 00:05:16.000000', 'consum', 0.0219, 'lps'),
	(617846, 131, '2014-04-01 00:05:17.000000', 'consum', 0.0222, 'lps'),
	(617847, 131, '2014-04-01 00:05:18.000000', 'consum', 0.0224, 'lps'),
	(617848, 131, '2014-04-01 00:05:19.000000', 'consum', 0.0227, 'lps'),
	(617849, 131, '2014-04-01 00:05:20.000000', 'consum', 0.0211, 'lps'),
	(617850, 131, '2014-04-01 00:05:21.000000', 'consum', 0.0225, 'lps'),
	(617851, 131, '2014-04-01 00:05:22.000000', 'consum', 0.0221, 'lps'),
	(617852, 131, '2014-04-01 00:05:23.000000', 'consum', 0.0222, 'lps'),
	(617853, 131, '2014-04-01 00:05:24.000000', 'consum', 0.0219, 'lps'),
	(617854, 131, '2014-04-01 00:05:25.000000', 'consum', 0.0219, 'lps'),
	(617855, 131, '2014-04-01 00:05:26.000000', 'consum', 0.0228, 'lps'),
	(617856, 131, '2014-04-01 00:05:27.000000', 'consum', 0.0214, 'lps'),
	(617857, 131, '2014-04-01 00:05:28.000000', 'consum', 0.0216, 'lps'),
	(617858, 131, '2014-04-01 00:05:29.000000', 'consum', 0.0210, 'lps'),
	(617859, 131, '2014-04-01 00:05:30.000000', 'consum', 0.0210, 'lps'),
	(617860, 131, '2014-04-01 00:05:31.000000', 'consum', 0.0213, 'lps'),
	(617861, 131, '2014-04-01 00:05:32.000000', 'consum', 0.0226, 'lps'),
	(617862, 131, '2014-04-01 00:05:33.000000', 'consum', 0.0222, 'lps'),
	(617863, 131, '2014-04-01 00:05:34.000000', 'consum', 0.0223, 'lps'),
	(617864, 131, '2014-04-01 00:05:35.000000', 'consum', 0.0219, 'lps'),
	(617865, 131, '2014-04-01 00:05:36.000000', 'consum', 0.0218, 'lps'),
	(617866, 131, '2014-04-01 00:05:37.000000', 'consum', 0.0220, 'lps'),
	(617867, 131, '2014-04-01 00:05:38.000000', 'consum', 0.0219, 'lps'),
	(617868, 131, '2014-04-01 00:05:39.000000', 'consum', 0.0225, 'lps'),
	(617869, 131, '2014-04-01 00:05:40.000000', 'consum', 0.0220, 'lps'),
	(617870, 131, '2014-04-01 00:05:41.000000', 'consum', 0.0212, 'lps'),
	(617871, 131, '2014-04-01 00:05:42.000000', 'consum', 0.0214, 'lps'),
	(617872, 131, '2014-04-01 00:05:43.000000', 'consum', 0.0222, 'lps'),
	(617873, 131, '2014-04-01 00:05:44.000000', 'consum', 0.0218, 'lps'),
	(617874, 131, '2014-04-01 00:05:45.000000', 'consum', 0.0217, 'lps'),
	(617875, 131, '2014-04-01 00:05:46.000000', 'consum', 0.0218, 'lps'),
	(617876, 131, '2014-04-01 00:05:47.000000', 'consum', 0.0213, 'lps'),
	(617877, 131, '2014-04-01 00:05:48.000000', 'consum', 0.0218, 'lps'),
	(617878, 131, '2014-04-01 00:05:49.000000', 'consum', 0.0224, 'lps'),
	(617879, 131, '2014-04-01 00:05:50.000000', 'consum', 0.0214, 'lps'),
	(617880, 131, '2014-04-01 00:05:51.000000', 'consum', 0.0229, 'lps'),
	(617881, 131, '2014-04-01 00:05:52.000000', 'consum', 0.0212, 'lps'),
	(617882, 131, '2014-04-01 00:05:53.000000', 'consum', 0.0226, 'lps'),
	(617883, 131, '2014-04-01 00:05:54.000000', 'consum', 0.0226, 'lps'),
	(617884, 131, '2014-04-01 00:05:55.000000', 'consum', 0.0220, 'lps'),
	(617885, 131, '2014-04-01 00:05:56.000000', 'consum', 0.0211, 'lps'),
	(617886, 131, '2014-04-01 00:05:57.000000', 'consum', 0.0228, 'lps'),
	(617887, 131, '2014-04-01 00:05:58.000000', 'consum', 0.0217, 'lps'),
	(617888, 131, '2014-04-01 00:05:59.000000', 'consum', 0.0213, 'lps'),
	(617889, 131, '2014-04-01 00:06:00.000000', 'consum', 0.0221, 'lps'),
	(617890, 131, '2014-04-01 00:06:01.000000', 'consum', 0.0220, 'lps'),
	(617891, 131, '2014-04-01 00:06:02.000000', 'consum', 0.0226, 'lps'),
	(617892, 131, '2014-04-01 00:06:03.000000', 'consum', 0.0220, 'lps'),
	(617893, 131, '2014-04-01 00:06:04.000000', 'consum', 0.0213, 'lps'),
	(617894, 131, '2014-04-01 00:06:05.000000', 'consum', 0.0217, 'lps'),
	(617895, 131, '2014-04-01 00:06:06.000000', 'consum', 0.0216, 'lps'),
	(617896, 131, '2014-04-01 00:06:07.000000', 'consum', 0.0218, 'lps'),
	(617897, 131, '2014-04-01 00:06:08.000000', 'consum', 0.0213, 'lps'),
	(617898, 131, '2014-04-01 00:06:09.000000', 'consum', 0.0222, 'lps'),
	(617899, 131, '2014-04-01 00:06:10.000000', 'consum', 0.0223, 'lps'),
	(617900, 131, '2014-04-01 00:06:11.000000', 'consum', 0.0219, 'lps'),
	(617901, 131, '2014-04-01 00:06:12.000000', 'consum', 0.0214, 'lps'),
	(617902, 131, '2014-04-01 00:06:13.000000', 'consum', 0.0226, 'lps'),
	(617903, 131, '2014-04-01 00:06:14.000000', 'consum', 0.0218, 'lps'),
	(617904, 131, '2014-04-01 00:06:15.000000', 'consum', 0.0223, 'lps'),
	(617905, 131, '2014-04-01 00:06:16.000000', 'consum', 0.0212, 'lps'),
	(617906, 131, '2014-04-01 00:06:17.000000', 'consum', 0.0219, 'lps'),
	(617907, 131, '2014-04-01 00:06:18.000000', 'consum', 0.0213, 'lps'),
	(617908, 131, '2014-04-01 00:06:19.000000', 'consum', 0.0215, 'lps'),
	(617909, 131, '2014-04-01 00:06:20.000000', 'consum', 0.0228, 'lps'),
	(617910, 131, '2014-04-01 00:06:21.000000', 'consum', 0.0225, 'lps'),
	(617911, 131, '2014-04-01 00:06:22.000000', 'consum', 0.0211, 'lps'),
	(617912, 131, '2014-04-01 00:06:23.000000', 'consum', 0.0213, 'lps'),
	(617913, 131, '2014-04-01 00:06:24.000000', 'consum', 0.0220, 'lps'),
	(617914, 131, '2014-04-01 00:06:25.000000', 'consum', 0.0214, 'lps'),
	(617915, 131, '2014-04-01 00:06:26.000000', 'consum', 0.0219, 'lps'),
	(617916, 131, '2014-04-01 00:06:27.000000', 'consum', 0.0223, 'lps'),
	(617917, 131, '2014-04-01 00:06:28.000000', 'consum', 0.0228, 'lps'),
	(617918, 131, '2014-04-01 00:06:29.000000', 'consum', 0.0221, 'lps'),
	(617919, 131, '2014-04-01 00:06:30.000000', 'consum', 0.0212, 'lps'),
	(617920, 131, '2014-04-01 00:06:31.000000', 'consum', 0.0228, 'lps'),
	(617921, 131, '2014-04-01 00:06:32.000000', 'consum', 0.0213, 'lps'),
	(617922, 131, '2014-04-01 00:06:33.000000', 'consum', 0.0213, 'lps'),
	(617923, 131, '2014-04-01 00:06:34.000000', 'consum', 0.0217, 'lps'),
	(617924, 131, '2014-04-01 00:06:35.000000', 'consum', 0.0214, 'lps'),
	(617925, 131, '2014-04-01 00:06:36.000000', 'consum', 0.0211, 'lps'),
	(617926, 131, '2014-04-01 00:06:37.000000', 'consum', 0.0222, 'lps'),
	(617927, 131, '2014-04-01 00:06:38.000000', 'consum', 0.0211, 'lps'),
	(617928, 131, '2014-04-01 00:06:39.000000', 'consum', 0.0216, 'lps'),
	(617929, 131, '2014-04-01 00:06:40.000000', 'consum', 0.0218, 'lps'),
	(617930, 131, '2014-04-01 00:06:41.000000', 'consum', 0.0213, 'lps'),
	(617931, 131, '2014-04-01 00:06:42.000000', 'consum', 0.0220, 'lps'),
	(617932, 131, '2014-04-01 00:06:43.000000', 'consum', 0.0212, 'lps'),
	(617933, 131, '2014-04-01 00:06:44.000000', 'consum', 0.0229, 'lps'),
	(617934, 131, '2014-04-01 00:06:45.000000', 'consum', 0.0222, 'lps'),
	(617935, 131, '2014-04-01 00:06:46.000000', 'consum', 0.0212, 'lps'),
	(617936, 131, '2014-04-01 00:06:47.000000', 'consum', 0.0224, 'lps'),
	(617937, 131, '2014-04-01 00:06:48.000000', 'consum', 0.0216, 'lps'),
	(617938, 131, '2014-04-01 00:06:49.000000', 'consum', 0.0219, 'lps'),
	(617939, 131, '2014-04-01 00:06:50.000000', 'consum', 0.0217, 'lps'),
	(617940, 131, '2014-04-01 00:06:51.000000', 'consum', 0.0218, 'lps'),
	(617941, 131, '2014-04-01 00:06:52.000000', 'consum', 0.0228, 'lps'),
	(617942, 131, '2014-04-01 00:06:53.000000', 'consum', 0.0219, 'lps'),
	(617943, 131, '2014-04-01 00:06:54.000000', 'consum', 0.0222, 'lps'),
	(617944, 131, '2014-04-01 00:06:55.000000', 'consum', 0.0223, 'lps'),
	(617945, 131, '2014-04-01 00:06:56.000000', 'consum', 0.0220, 'lps'),
	(617946, 131, '2014-04-01 00:06:57.000000', 'consum', 0.0222, 'lps'),
	(617947, 131, '2014-04-01 00:06:58.000000', 'consum', 0.0222, 'lps'),
	(617948, 131, '2014-04-01 00:06:59.000000', 'consum', 0.0211, 'lps'),
	(617949, 131, '2014-04-01 00:07:00.000000', 'consum', 0.0220, 'lps'),
	(617950, 131, '2014-04-01 00:07:01.000000', 'consum', 0.0218, 'lps'),
	(617951, 131, '2014-04-01 00:07:02.000000', 'consum', 0.0221, 'lps'),
	(617952, 131, '2014-04-01 00:07:03.000000', 'consum', 0.0221, 'lps'),
	(617953, 131, '2014-04-01 00:07:04.000000', 'consum', 0.0214, 'lps'),
	(617954, 131, '2014-04-01 00:07:05.000000', 'consum', 0.0217, 'lps'),
	(617955, 131, '2014-04-01 00:07:06.000000', 'consum', 0.0212, 'lps'),
	(617956, 131, '2014-04-01 00:07:07.000000', 'consum', 0.0218, 'lps'),
	(617957, 131, '2014-04-01 00:07:08.000000', 'consum', 0.0227, 'lps'),
	(617958, 131, '2014-04-01 00:07:09.000000', 'consum', 0.0212, 'lps'),
	(617959, 131, '2014-04-01 00:07:10.000000', 'consum', 0.0229, 'lps'),
	(617960, 131, '2014-04-01 00:07:11.000000', 'consum', 0.0219, 'lps'),
	(617961, 131, '2014-04-01 00:07:12.000000', 'consum', 0.0219, 'lps'),
	(617962, 131, '2014-04-01 00:07:13.000000', 'consum', 0.0229, 'lps'),
	(617963, 131, '2014-04-01 00:07:14.000000', 'consum', 0.0220, 'lps'),
	(617964, 131, '2014-04-01 00:07:15.000000', 'consum', 0.0222, 'lps'),
	(617965, 131, '2014-04-01 00:07:16.000000', 'consum', 0.0221, 'lps'),
	(617966, 131, '2014-04-01 00:07:17.000000', 'consum', 0.0211, 'lps'),
	(617967, 131, '2014-04-01 00:07:18.000000', 'consum', 0.0223, 'lps'),
	(617968, 131, '2014-04-01 00:07:19.000000', 'consum', 0.0210, 'lps'),
	(617969, 131, '2014-04-01 00:07:20.000000', 'consum', 0.0213, 'lps'),
	(617970, 131, '2014-04-01 00:07:21.000000', 'consum', 0.0223, 'lps'),
	(617971, 131, '2014-04-01 00:07:22.000000', 'consum', 0.0229, 'lps'),
	(617972, 131, '2014-04-01 00:07:23.000000', 'consum', 0.0227, 'lps'),
	(617973, 131, '2014-04-01 00:07:24.000000', 'consum', 0.0218, 'lps'),
	(617974, 131, '2014-04-01 00:07:25.000000', 'consum', 0.0218, 'lps'),
	(617975, 131, '2014-04-01 00:07:26.000000', 'consum', 0.0229, 'lps'),
	(617976, 131, '2014-04-01 00:07:27.000000', 'consum', 0.0219, 'lps'),
	(617977, 131, '2014-04-01 00:07:28.000000', 'consum', 0.0220, 'lps'),
	(617978, 131, '2014-04-01 00:07:29.000000', 'consum', 0.0213, 'lps'),
	(617979, 131, '2014-04-01 00:07:30.000000', 'consum', 0.0215, 'lps'),
	(617980, 131, '2014-04-01 00:07:31.000000', 'consum', 0.0228, 'lps'),
	(617981, 131, '2014-04-01 00:07:32.000000', 'consum', 0.0227, 'lps'),
	(617982, 131, '2014-04-01 00:07:33.000000', 'consum', 0.0219, 'lps'),
	(617983, 131, '2014-04-01 00:07:34.000000', 'consum', 0.0226, 'lps'),
	(617984, 131, '2014-04-01 00:07:35.000000', 'consum', 0.0225, 'lps'),
	(617985, 131, '2014-04-01 00:07:36.000000', 'consum', 0.0215, 'lps'),
	(617986, 131, '2014-04-01 00:07:37.000000', 'consum', 0.0229, 'lps'),
	(617987, 131, '2014-04-01 00:07:38.000000', 'consum', 0.0213, 'lps'),
	(617988, 131, '2014-04-01 00:07:39.000000', 'consum', 0.0227, 'lps'),
	(617989, 131, '2014-04-01 00:07:40.000000', 'consum', 0.0225, 'lps'),
	(617990, 131, '2014-04-01 00:07:41.000000', 'consum', 0.0217, 'lps'),
	(617991, 131, '2014-04-01 00:07:42.000000', 'consum', 0.0220, 'lps'),
	(617992, 131, '2014-04-01 00:07:43.000000', 'consum', 0.0218, 'lps'),
	(617993, 131, '2014-04-01 00:07:44.000000', 'consum', 0.0221, 'lps'),
	(617994, 131, '2014-04-01 00:07:45.000000', 'consum', 0.0221, 'lps'),
	(617995, 131, '2014-04-01 00:07:46.000000', 'consum', 0.0212, 'lps'),
	(617996, 131, '2014-04-01 00:07:47.000000', 'consum', 0.0229, 'lps'),
	(617997, 131, '2014-04-01 00:07:48.000000', 'consum', 0.0221, 'lps'),
	(617998, 131, '2014-04-01 00:07:49.000000', 'consum', 0.0225, 'lps'),
	(617999, 131, '2014-04-01 00:07:50.000000', 'consum', 0.0216, 'lps'),
	(618000, 131, '2014-04-01 00:07:51.000000', 'consum', 0.0214, 'lps'),
	(618001, 131, '2014-04-01 00:07:52.000000', 'consum', 0.0213, 'lps'),
	(618002, 131, '2014-04-01 00:07:53.000000', 'consum', 0.0215, 'lps'),
	(618003, 131, '2014-04-01 00:07:54.000000', 'consum', 0.0225, 'lps'),
	(618004, 131, '2014-04-01 00:07:55.000000', 'consum', 0.0210, 'lps'),
	(618005, 131, '2014-04-01 00:07:56.000000', 'consum', 0.0226, 'lps'),
	(618006, 131, '2014-04-01 00:07:57.000000', 'consum', 0.0211, 'lps'),
	(618007, 131, '2014-04-01 00:07:58.000000', 'consum', 0.0225, 'lps'),
	(618008, 131, '2014-04-01 00:07:59.000000', 'consum', 0.0225, 'lps'),
	(618009, 131, '2014-04-01 00:08:00.000000', 'consum', 0.0221, 'lps'),
	(618010, 131, '2014-04-01 00:08:01.000000', 'consum', 0.0220, 'lps'),
	(618011, 131, '2014-04-01 00:08:02.000000', 'consum', 0.0229, 'lps'),
	(618012, 131, '2014-04-01 00:08:03.000000', 'consum', 0.0213, 'lps'),
	(618013, 131, '2014-04-01 00:08:04.000000', 'consum', 0.0228, 'lps'),
	(618014, 131, '2014-04-01 00:08:05.000000', 'consum', 0.0214, 'lps'),
	(618015, 131, '2014-04-01 00:08:06.000000', 'consum', 0.0217, 'lps'),
	(618016, 131, '2014-04-01 00:08:07.000000', 'consum', 0.0213, 'lps'),
	(618017, 131, '2014-04-01 00:08:08.000000', 'consum', 0.0222, 'lps'),
	(618018, 131, '2014-04-01 00:08:09.000000', 'consum', 0.0223, 'lps'),
	(618019, 131, '2014-04-01 00:08:10.000000', 'consum', 0.0219, 'lps'),
	(618020, 131, '2014-04-01 00:08:11.000000', 'consum', 0.0218, 'lps'),
	(618021, 131, '2014-04-01 00:08:12.000000', 'consum', 0.0224, 'lps'),
	(618022, 131, '2014-04-01 00:08:13.000000', 'consum', 0.0214, 'lps'),
	(618023, 131, '2014-04-01 00:08:14.000000', 'consum', 0.0228, 'lps'),
	(618024, 131, '2014-04-01 00:08:15.000000', 'consum', 0.0229, 'lps'),
	(618025, 131, '2014-04-01 00:08:16.000000', 'consum', 0.0213, 'lps'),
	(618026, 131, '2014-04-01 00:08:17.000000', 'consum', 0.0227, 'lps'),
	(618027, 131, '2014-04-01 00:08:18.000000', 'consum', 0.0227, 'lps'),
	(618028, 131, '2014-04-01 00:08:19.000000', 'consum', 0.0227, 'lps'),
	(618029, 131, '2014-04-01 00:08:20.000000', 'consum', 0.0221, 'lps'),
	(618030, 131, '2014-04-01 00:08:21.000000', 'consum', 0.0215, 'lps'),
	(618031, 131, '2014-04-01 00:08:22.000000', 'consum', 0.0224, 'lps'),
	(618032, 131, '2014-04-01 00:08:23.000000', 'consum', 0.0226, 'lps'),
	(618033, 131, '2014-04-01 00:08:24.000000', 'consum', 0.0229, 'lps'),
	(618034, 131, '2014-04-01 00:08:25.000000', 'consum', 0.0217, 'lps'),
	(618035, 131, '2014-04-01 00:08:26.000000', 'consum', 0.0210, 'lps'),
	(618036, 131, '2014-04-01 00:08:27.000000', 'consum', 0.0210, 'lps'),
	(618037, 131, '2014-04-01 00:08:28.000000', 'consum', 0.0228, 'lps'),
	(618038, 131, '2014-04-01 00:08:29.000000', 'consum', 0.0221, 'lps'),
	(618039, 131, '2014-04-01 00:08:30.000000', 'consum', 0.0212, 'lps'),
	(618040, 131, '2014-04-01 00:08:31.000000', 'consum', 0.0228, 'lps'),
	(618041, 131, '2014-04-01 00:08:32.000000', 'consum', 0.0212, 'lps'),
	(618042, 131, '2014-04-01 00:08:33.000000', 'consum', 0.0228, 'lps'),
	(618043, 131, '2014-04-01 00:08:34.000000', 'consum', 0.0213, 'lps'),
	(618044, 131, '2014-04-01 00:08:35.000000', 'consum', 0.0212, 'lps'),
	(618045, 131, '2014-04-01 00:08:36.000000', 'consum', 0.0211, 'lps'),
	(618046, 131, '2014-04-01 00:08:37.000000', 'consum', 0.0211, 'lps'),
	(618047, 131, '2014-04-01 00:08:38.000000', 'consum', 0.0212, 'lps'),
	(618048, 131, '2014-04-01 00:08:39.000000', 'consum', 0.0216, 'lps'),
	(618049, 131, '2014-04-01 00:08:40.000000', 'consum', 0.0217, 'lps'),
	(618050, 131, '2014-04-01 00:08:41.000000', 'consum', 0.0225, 'lps'),
	(618051, 131, '2014-04-01 00:08:42.000000', 'consum', 0.0225, 'lps'),
	(618052, 131, '2014-04-01 00:08:43.000000', 'consum', 0.0220, 'lps'),
	(618053, 131, '2014-04-01 00:08:44.000000', 'consum', 0.0218, 'lps'),
	(618054, 131, '2014-04-01 00:08:45.000000', 'consum', 0.0220, 'lps'),
	(618055, 131, '2014-04-01 00:08:46.000000', 'consum', 0.0215, 'lps'),
	(618056, 131, '2014-04-01 00:08:47.000000', 'consum', 0.0226, 'lps'),
	(618057, 131, '2014-04-01 00:08:48.000000', 'consum', 0.0214, 'lps'),
	(618058, 131, '2014-04-01 00:08:49.000000', 'consum', 0.0225, 'lps'),
	(618059, 131, '2014-04-01 00:08:50.000000', 'consum', 0.0210, 'lps'),
	(618060, 131, '2014-04-01 00:08:51.000000', 'consum', 0.0229, 'lps'),
	(618061, 131, '2014-04-01 00:08:52.000000', 'consum', 0.0224, 'lps'),
	(618062, 131, '2014-04-01 00:08:53.000000', 'consum', 0.0225, 'lps'),
	(618063, 131, '2014-04-01 00:08:54.000000', 'consum', 0.0223, 'lps'),
	(618064, 131, '2014-04-01 00:08:55.000000', 'consum', 0.0212, 'lps'),
	(618065, 131, '2014-04-01 00:08:56.000000', 'consum', 0.0219, 'lps'),
	(618066, 131, '2014-04-01 00:08:57.000000', 'consum', 0.0228, 'lps'),
	(618067, 131, '2014-04-01 00:08:58.000000', 'consum', 0.0217, 'lps'),
	(618068, 131, '2014-04-01 00:08:59.000000', 'consum', 0.0211, 'lps'),
	(618069, 131, '2014-04-01 00:09:00.000000', 'consum', 0.0213, 'lps'),
	(618070, 131, '2014-04-01 00:09:01.000000', 'consum', 0.0222, 'lps'),
	(618071, 131, '2014-04-01 00:09:02.000000', 'consum', 0.0222, 'lps'),
	(618072, 131, '2014-04-01 00:09:03.000000', 'consum', 0.0216, 'lps'),
	(618073, 131, '2014-04-01 00:09:04.000000', 'consum', 0.0224, 'lps'),
	(618074, 131, '2014-04-01 00:09:05.000000', 'consum', 0.0220, 'lps'),
	(618075, 131, '2014-04-01 00:09:06.000000', 'consum', 0.0221, 'lps'),
	(618076, 131, '2014-04-01 00:09:07.000000', 'consum', 0.0216, 'lps'),
	(618077, 131, '2014-04-01 00:09:08.000000', 'consum', 0.0228, 'lps'),
	(618078, 131, '2014-04-01 00:09:09.000000', 'consum', 0.0223, 'lps'),
	(618079, 131, '2014-04-01 00:09:10.000000', 'consum', 0.0221, 'lps'),
	(618080, 131, '2014-04-01 00:09:11.000000', 'consum', 0.0226, 'lps'),
	(618081, 131, '2014-04-01 00:09:12.000000', 'consum', 0.0220, 'lps'),
	(618082, 131, '2014-04-01 00:09:13.000000', 'consum', 0.0229, 'lps'),
	(618083, 131, '2014-04-01 00:09:14.000000', 'consum', 0.0216, 'lps'),
	(618084, 131, '2014-04-01 00:09:15.000000', 'consum', 0.0225, 'lps'),
	(618085, 131, '2014-04-01 00:09:16.000000', 'consum', 0.0225, 'lps'),
	(618086, 131, '2014-04-01 00:09:17.000000', 'consum', 0.0223, 'lps'),
	(618087, 131, '2014-04-01 00:09:18.000000', 'consum', 0.0228, 'lps'),
	(618088, 131, '2014-04-01 00:09:19.000000', 'consum', 0.0224, 'lps'),
	(618089, 131, '2014-04-01 00:09:20.000000', 'consum', 0.0225, 'lps'),
	(618090, 131, '2014-04-01 00:09:21.000000', 'consum', 0.0223, 'lps'),
	(618091, 131, '2014-04-01 00:09:22.000000', 'consum', 0.0229, 'lps'),
	(618092, 131, '2014-04-01 00:09:23.000000', 'consum', 0.0229, 'lps'),
	(618093, 131, '2014-04-01 00:09:24.000000', 'consum', 0.0227, 'lps'),
	(618094, 131, '2014-04-01 00:09:25.000000', 'consum', 0.0219, 'lps'),
	(618095, 131, '2014-04-01 00:09:26.000000', 'consum', 0.0225, 'lps'),
	(618096, 131, '2014-04-01 00:09:27.000000', 'consum', 0.0220, 'lps'),
	(618097, 131, '2014-04-01 00:09:28.000000', 'consum', 0.0214, 'lps'),
	(618098, 131, '2014-04-01 00:09:29.000000', 'consum', 0.0219, 'lps'),
	(618099, 131, '2014-04-01 00:09:30.000000', 'consum', 0.0226, 'lps'),
	(618100, 131, '2014-04-01 00:09:31.000000', 'consum', 0.0222, 'lps'),
	(618101, 131, '2014-04-01 00:09:32.000000', 'consum', 0.0222, 'lps'),
	(618102, 131, '2014-04-01 00:09:33.000000', 'consum', 0.0215, 'lps'),
	(618103, 131, '2014-04-01 00:09:34.000000', 'consum', 0.0222, 'lps'),
	(618104, 131, '2014-04-01 00:09:35.000000', 'consum', 0.0212, 'lps'),
	(618105, 131, '2014-04-01 00:09:36.000000', 'consum', 0.0225, 'lps'),
	(618106, 131, '2014-04-01 00:09:37.000000', 'consum', 0.0219, 'lps'),
	(618107, 131, '2014-04-01 00:09:38.000000', 'consum', 0.0210, 'lps'),
	(618108, 131, '2014-04-01 00:09:39.000000', 'consum', 0.0226, 'lps'),
	(618109, 131, '2014-04-01 00:09:40.000000', 'consum', 0.0227, 'lps'),
	(618110, 131, '2014-04-01 00:09:41.000000', 'consum', 0.0211, 'lps'),
	(618111, 131, '2014-04-01 00:09:42.000000', 'consum', 0.0223, 'lps'),
	(618112, 131, '2014-04-01 00:09:43.000000', 'consum', 0.0213, 'lps'),
	(618113, 131, '2014-04-01 00:09:44.000000', 'consum', 0.0225, 'lps'),
	(618114, 131, '2014-04-01 00:09:45.000000', 'consum', 0.0218, 'lps'),
	(618115, 131, '2014-04-01 00:09:46.000000', 'consum', 0.0226, 'lps'),
	(618116, 131, '2014-04-01 00:09:47.000000', 'consum', 0.0226, 'lps'),
	(618117, 131, '2014-04-01 00:09:48.000000', 'consum', 0.0221, 'lps'),
	(618118, 131, '2014-04-01 00:09:49.000000', 'consum', 0.0217, 'lps'),
	(618119, 131, '2014-04-01 00:09:50.000000', 'consum', 0.0216, 'lps'),
	(618120, 131, '2014-04-01 00:09:51.000000', 'consum', 0.0216, 'lps'),
	(618121, 131, '2014-04-01 00:09:52.000000', 'consum', 0.0224, 'lps'),
	(618122, 131, '2014-04-01 00:09:53.000000', 'consum', 0.0224, 'lps'),
	(618123, 131, '2014-04-01 00:09:54.000000', 'consum', 0.0215, 'lps'),
	(618124, 131, '2014-04-01 00:09:55.000000', 'consum', 0.0216, 'lps'),
	(618125, 131, '2014-04-01 00:09:56.000000', 'consum', 0.0227, 'lps'),
	(618126, 131, '2014-04-01 00:09:57.000000', 'consum', 0.0215, 'lps'),
	(618127, 131, '2014-04-01 00:09:58.000000', 'consum', 0.0227, 'lps'),
	(618128, 131, '2014-04-01 00:09:59.000000', 'consum', 0.0219, 'lps'),
	(618129, 131, '2014-04-01 00:10:00.000000', 'consum', 0.0224, 'lps'),
	(618130, 131, '2014-04-01 00:10:01.000000', 'consum', 0.0213, 'lps'),
	(618131, 131, '2014-04-01 00:10:02.000000', 'consum', 0.0225, 'lps'),
	(618132, 131, '2014-04-01 00:10:03.000000', 'consum', 0.0216, 'lps'),
	(618133, 131, '2014-04-01 00:10:04.000000', 'consum', 0.0216, 'lps'),
	(618134, 131, '2014-04-01 00:10:05.000000', 'consum', 0.0222, 'lps'),
	(618135, 131, '2014-04-01 00:10:06.000000', 'consum', 0.0213, 'lps'),
	(618136, 131, '2014-04-01 00:10:07.000000', 'consum', 0.0211, 'lps'),
	(618137, 131, '2014-04-01 00:10:08.000000', 'consum', 0.0227, 'lps'),
	(618138, 131, '2014-04-01 00:10:09.000000', 'consum', 0.0210, 'lps'),
	(618139, 131, '2014-04-01 00:10:10.000000', 'consum', 0.0218, 'lps'),
	(618140, 131, '2014-04-01 00:10:11.000000', 'consum', 0.0214, 'lps'),
	(618141, 131, '2014-04-01 00:10:12.000000', 'consum', 0.0224, 'lps'),
	(618142, 131, '2014-04-01 00:10:13.000000', 'consum', 0.0211, 'lps'),
	(618143, 131, '2014-04-01 00:10:14.000000', 'consum', 0.0212, 'lps'),
	(618144, 131, '2014-04-01 00:10:15.000000', 'consum', 0.0218, 'lps'),
	(618145, 131, '2014-04-01 00:10:16.000000', 'consum', 0.0226, 'lps'),
	(618146, 131, '2014-04-01 00:10:17.000000', 'consum', 0.0227, 'lps'),
	(618147, 131, '2014-04-01 00:10:18.000000', 'consum', 0.0228, 'lps'),
	(618148, 131, '2014-04-01 00:10:19.000000', 'consum', 0.0227, 'lps'),
	(618149, 131, '2014-04-01 00:10:20.000000', 'consum', 0.0224, 'lps'),
	(618150, 131, '2014-04-01 00:10:21.000000', 'consum', 0.0210, 'lps'),
	(618151, 131, '2014-04-01 00:10:22.000000', 'consum', 0.0225, 'lps'),
	(618152, 131, '2014-04-01 00:10:23.000000', 'consum', 0.0229, 'lps'),
	(618153, 131, '2014-04-01 00:10:24.000000', 'consum', 0.0220, 'lps'),
	(618154, 131, '2014-04-01 00:10:25.000000', 'consum', 0.0222, 'lps'),
	(618155, 131, '2014-04-01 00:10:26.000000', 'consum', 0.0221, 'lps'),
	(618156, 131, '2014-04-01 00:10:27.000000', 'consum', 0.0229, 'lps'),
	(618157, 131, '2014-04-01 00:10:28.000000', 'consum', 0.0213, 'lps'),
	(618158, 131, '2014-04-01 00:10:29.000000', 'consum', 0.0227, 'lps'),
	(618159, 131, '2014-04-01 00:10:30.000000', 'consum', 0.0226, 'lps'),
	(618160, 131, '2014-04-01 00:10:31.000000', 'consum', 0.0221, 'lps'),
	(618161, 131, '2014-04-01 00:10:32.000000', 'consum', 0.0218, 'lps'),
	(618162, 131, '2014-04-01 00:10:33.000000', 'consum', 0.0219, 'lps'),
	(618163, 131, '2014-04-01 00:10:34.000000', 'consum', 0.0228, 'lps'),
	(618164, 131, '2014-04-01 00:10:35.000000', 'consum', 0.0217, 'lps'),
	(618165, 131, '2014-04-01 00:10:36.000000', 'consum', 0.0210, 'lps'),
	(618166, 131, '2014-04-01 00:10:37.000000', 'consum', 0.0210, 'lps'),
	(618167, 131, '2014-04-01 00:10:38.000000', 'consum', 0.0210, 'lps'),
	(618168, 131, '2014-04-01 00:10:39.000000', 'consum', 0.0229, 'lps'),
	(618169, 131, '2014-04-01 00:10:40.000000', 'consum', 0.0225, 'lps'),
	(618170, 131, '2014-04-01 00:10:41.000000', 'consum', 0.0210, 'lps'),
	(618171, 131, '2014-04-01 00:10:42.000000', 'consum', 0.0227, 'lps'),
	(618172, 131, '2014-04-01 00:10:43.000000', 'consum', 0.0213, 'lps'),
	(618173, 131, '2014-04-01 00:10:44.000000', 'consum', 0.0213, 'lps'),
	(618174, 131, '2014-04-01 00:10:45.000000', 'consum', 0.0220, 'lps'),
	(618175, 131, '2014-04-01 00:10:46.000000', 'consum', 0.0229, 'lps'),
	(618176, 131, '2014-04-01 00:10:47.000000', 'consum', 0.0215, 'lps'),
	(618177, 131, '2014-04-01 00:10:48.000000', 'consum', 0.0218, 'lps'),
	(618178, 131, '2014-04-01 00:10:49.000000', 'consum', 0.0214, 'lps'),
	(618179, 131, '2014-04-01 00:10:50.000000', 'consum', 0.0210, 'lps'),
	(618180, 131, '2014-04-01 00:10:51.000000', 'consum', 0.0219, 'lps'),
	(618181, 131, '2014-04-01 00:10:52.000000', 'consum', 0.0214, 'lps'),
	(618182, 131, '2014-04-01 00:10:53.000000', 'consum', 0.0223, 'lps'),
	(618183, 131, '2014-04-01 00:10:54.000000', 'consum', 0.0223, 'lps'),
	(618184, 131, '2014-04-01 00:10:55.000000', 'consum', 0.0218, 'lps'),
	(618185, 131, '2014-04-01 00:10:56.000000', 'consum', 0.0211, 'lps'),
	(618186, 131, '2014-04-01 00:10:57.000000', 'consum', 0.0213, 'lps'),
	(618187, 131, '2014-04-01 00:10:58.000000', 'consum', 0.0222, 'lps'),
	(618188, 131, '2014-04-01 00:10:59.000000', 'consum', 0.0223, 'lps'),
	(618189, 131, '2014-04-01 00:11:00.000000', 'consum', 0.0219, 'lps'),
	(618190, 131, '2014-04-01 00:11:01.000000', 'consum', 0.0216, 'lps'),
	(618191, 131, '2014-04-01 00:11:02.000000', 'consum', 0.0215, 'lps'),
	(618192, 131, '2014-04-01 00:11:03.000000', 'consum', 0.0216, 'lps'),
	(618193, 131, '2014-04-01 00:11:04.000000', 'consum', 0.0224, 'lps'),
	(618194, 131, '2014-04-01 00:11:05.000000', 'consum', 0.0223, 'lps'),
	(618195, 131, '2014-04-01 00:11:06.000000', 'consum', 0.0215, 'lps'),
	(618196, 131, '2014-04-01 00:11:07.000000', 'consum', 0.0216, 'lps'),
	(618197, 131, '2014-04-01 00:11:08.000000', 'consum', 0.0226, 'lps'),
	(618198, 131, '2014-04-01 00:11:09.000000', 'consum', 0.0213, 'lps'),
	(618199, 131, '2014-04-01 00:11:10.000000', 'consum', 0.0216, 'lps'),
	(618200, 131, '2014-04-01 00:11:11.000000', 'consum', 0.0212, 'lps'),
	(618201, 131, '2014-04-01 00:11:12.000000', 'consum', 0.0223, 'lps'),
	(618202, 131, '2014-04-01 00:11:13.000000', 'consum', 0.0229, 'lps'),
	(618203, 131, '2014-04-01 00:11:14.000000', 'consum', 0.0225, 'lps'),
	(618204, 131, '2014-04-01 00:11:15.000000', 'consum', 0.0210, 'lps'),
	(618205, 131, '2014-04-01 00:11:16.000000', 'consum', 0.0225, 'lps'),
	(618206, 131, '2014-04-01 00:11:17.000000', 'consum', 0.0224, 'lps'),
	(618207, 131, '2014-04-01 00:11:18.000000', 'consum', 0.0215, 'lps'),
	(618208, 131, '2014-04-01 00:11:19.000000', 'consum', 0.0214, 'lps'),
	(618209, 131, '2014-04-01 00:11:20.000000', 'consum', 0.0214, 'lps'),
	(618210, 131, '2014-04-01 00:11:21.000000', 'consum', 0.0219, 'lps'),
	(618211, 131, '2014-04-01 00:11:22.000000', 'consum', 0.0225, 'lps'),
	(618212, 131, '2014-04-01 00:11:23.000000', 'consum', 0.0217, 'lps'),
	(618213, 131, '2014-04-01 00:11:24.000000', 'consum', 0.0220, 'lps'),
	(618214, 131, '2014-04-01 00:11:25.000000', 'consum', 0.0220, 'lps'),
	(618215, 131, '2014-04-01 00:11:26.000000', 'consum', 0.0210, 'lps'),
	(618216, 131, '2014-04-01 00:11:27.000000', 'consum', 0.0221, 'lps'),
	(618217, 131, '2014-04-01 00:11:28.000000', 'consum', 0.0225, 'lps'),
	(618218, 131, '2014-04-01 00:11:29.000000', 'consum', 0.0215, 'lps'),
	(618219, 131, '2014-04-01 00:11:30.000000', 'consum', 0.0227, 'lps'),
	(618220, 131, '2014-04-01 00:11:31.000000', 'consum', 0.0222, 'lps'),
	(618221, 131, '2014-04-01 00:11:32.000000', 'consum', 0.0219, 'lps'),
	(618222, 131, '2014-04-01 00:11:33.000000', 'consum', 0.0220, 'lps'),
	(618223, 131, '2014-04-01 00:11:34.000000', 'consum', 0.0212, 'lps'),
	(618224, 131, '2014-04-01 00:11:35.000000', 'consum', 0.0213, 'lps'),
	(618225, 131, '2014-04-01 00:11:36.000000', 'consum', 0.0217, 'lps'),
	(618226, 131, '2014-04-01 00:11:37.000000', 'consum', 0.0216, 'lps'),
	(618227, 131, '2014-04-01 00:11:38.000000', 'consum', 0.0221, 'lps'),
	(618228, 131, '2014-04-01 00:11:39.000000', 'consum', 0.0227, 'lps'),
	(618229, 131, '2014-04-01 00:11:40.000000', 'consum', 0.0224, 'lps'),
	(618230, 131, '2014-04-01 00:11:41.000000', 'consum', 0.0228, 'lps'),
	(618231, 131, '2014-04-01 00:11:42.000000', 'consum', 0.0220, 'lps'),
	(618232, 131, '2014-04-01 00:11:43.000000', 'consum', 0.0224, 'lps'),
	(618233, 131, '2014-04-01 00:11:44.000000', 'consum', 0.0214, 'lps'),
	(618234, 131, '2014-04-01 00:11:45.000000', 'consum', 0.0225, 'lps'),
	(618235, 131, '2014-04-01 00:11:46.000000', 'consum', 0.0215, 'lps'),
	(618236, 131, '2014-04-01 00:11:47.000000', 'consum', 0.0212, 'lps'),
	(618237, 131, '2014-04-01 00:11:48.000000', 'consum', 0.0224, 'lps'),
	(618238, 131, '2014-04-01 00:11:49.000000', 'consum', 0.0214, 'lps'),
	(618239, 131, '2014-04-01 00:11:50.000000', 'consum', 0.0211, 'lps'),
	(618240, 131, '2014-04-01 00:11:51.000000', 'consum', 0.0221, 'lps'),
	(618241, 131, '2014-04-01 00:11:52.000000', 'consum', 0.0223, 'lps'),
	(618242, 131, '2014-04-01 00:11:53.000000', 'consum', 0.0224, 'lps'),
	(618243, 131, '2014-04-01 00:11:54.000000', 'consum', 0.0220, 'lps'),
	(618244, 131, '2014-04-01 00:11:55.000000', 'consum', 0.0217, 'lps'),
	(618245, 131, '2014-04-01 00:11:56.000000', 'consum', 0.0216, 'lps'),
	(618246, 131, '2014-04-01 00:11:57.000000', 'consum', 0.0221, 'lps'),
	(618247, 131, '2014-04-01 00:11:58.000000', 'consum', 0.0226, 'lps'),
	(618248, 131, '2014-04-01 00:11:59.000000', 'consum', 0.0216, 'lps'),
	(618249, 131, '2014-04-01 00:12:00.000000', 'consum', 0.0214, 'lps'),
	(618250, 131, '2014-04-01 00:12:01.000000', 'consum', 0.0212, 'lps'),
	(618251, 131, '2014-04-01 00:12:02.000000', 'consum', 0.0210, 'lps'),
	(618252, 131, '2014-04-01 00:12:03.000000', 'consum', 0.0224, 'lps'),
	(618253, 131, '2014-04-01 00:12:04.000000', 'consum', 0.0222, 'lps'),
	(618254, 131, '2014-04-01 00:12:05.000000', 'consum', 0.0226, 'lps'),
	(618255, 131, '2014-04-01 00:12:06.000000', 'consum', 0.0217, 'lps'),
	(618256, 131, '2014-04-01 00:12:07.000000', 'consum', 0.0216, 'lps'),
	(618257, 131, '2014-04-01 00:12:08.000000', 'consum', 0.0220, 'lps'),
	(618258, 131, '2014-04-01 00:12:09.000000', 'consum', 0.0221, 'lps'),
	(618259, 131, '2014-04-01 00:12:10.000000', 'consum', 0.0215, 'lps'),
	(618260, 131, '2014-04-01 00:12:11.000000', 'consum', 0.0224, 'lps'),
	(618261, 131, '2014-04-01 00:12:12.000000', 'consum', 0.0226, 'lps'),
	(618262, 131, '2014-04-01 00:12:13.000000', 'consum', 0.0228, 'lps'),
	(618263, 131, '2014-04-01 00:12:14.000000', 'consum', 0.0213, 'lps'),
	(618264, 131, '2014-04-01 00:12:15.000000', 'consum', 0.0210, 'lps'),
	(618265, 131, '2014-04-01 00:12:16.000000', 'consum', 0.0224, 'lps'),
	(618266, 131, '2014-04-01 00:12:17.000000', 'consum', 0.0220, 'lps'),
	(618267, 131, '2014-04-01 00:12:18.000000', 'consum', 0.0217, 'lps'),
	(618268, 131, '2014-04-01 00:12:19.000000', 'consum', 0.0214, 'lps'),
	(618269, 131, '2014-04-01 00:12:20.000000', 'consum', 0.0212, 'lps'),
	(618270, 131, '2014-04-01 00:12:21.000000', 'consum', 0.0226, 'lps'),
	(618271, 131, '2014-04-01 00:12:22.000000', 'consum', 0.0225, 'lps'),
	(618272, 131, '2014-04-01 00:12:23.000000', 'consum', 0.0217, 'lps'),
	(618273, 131, '2014-04-01 00:12:24.000000', 'consum', 0.0223, 'lps'),
	(618274, 131, '2014-04-01 00:12:25.000000', 'consum', 0.0213, 'lps'),
	(618275, 131, '2014-04-01 00:12:26.000000', 'consum', 0.0227, 'lps'),
	(618276, 131, '2014-04-01 00:12:27.000000', 'consum', 0.0225, 'lps'),
	(618277, 131, '2014-04-01 00:12:28.000000', 'consum', 0.0214, 'lps'),
	(618278, 131, '2014-04-01 00:12:29.000000', 'consum', 0.0227, 'lps'),
	(618279, 131, '2014-04-01 00:12:30.000000', 'consum', 0.0222, 'lps'),
	(618280, 131, '2014-04-01 00:12:31.000000', 'consum', 0.0219, 'lps'),
	(618281, 131, '2014-04-01 00:12:32.000000', 'consum', 0.0220, 'lps'),
	(618282, 131, '2014-04-01 00:12:33.000000', 'consum', 0.0215, 'lps'),
	(618283, 131, '2014-04-01 00:12:34.000000', 'consum', 0.0226, 'lps'),
	(618284, 131, '2014-04-01 00:12:35.000000', 'consum', 0.0216, 'lps'),
	(618285, 131, '2014-04-01 00:12:36.000000', 'consum', 0.0212, 'lps'),
	(618286, 131, '2014-04-01 00:12:37.000000', 'consum', 0.0224, 'lps'),
	(618287, 131, '2014-04-01 00:12:38.000000', 'consum', 0.0212, 'lps'),
	(618288, 131, '2014-04-01 00:12:39.000000', 'consum', 0.0219, 'lps'),
	(618289, 131, '2014-04-01 00:12:40.000000', 'consum', 0.0210, 'lps'),
	(618290, 131, '2014-04-01 00:12:41.000000', 'consum', 0.0223, 'lps'),
	(618291, 131, '2014-04-01 00:12:42.000000', 'consum', 0.0215, 'lps'),
	(618292, 131, '2014-04-01 00:12:43.000000', 'consum', 0.0215, 'lps'),
	(618293, 131, '2014-04-01 00:12:44.000000', 'consum', 0.0223, 'lps'),
	(618294, 131, '2014-04-01 00:12:45.000000', 'consum', 0.0218, 'lps'),
	(618295, 131, '2014-04-01 00:12:46.000000', 'consum', 0.0214, 'lps'),
	(618296, 131, '2014-04-01 00:12:47.000000', 'consum', 0.0227, 'lps'),
	(618297, 131, '2014-04-01 00:12:48.000000', 'consum', 0.0221, 'lps'),
	(618298, 131, '2014-04-01 00:12:49.000000', 'consum', 0.0215, 'lps'),
	(618299, 131, '2014-04-01 00:12:50.000000', 'consum', 0.0221, 'lps'),
	(618300, 131, '2014-04-01 00:12:51.000000', 'consum', 0.0214, 'lps'),
	(618301, 131, '2014-04-01 00:12:52.000000', 'consum', 0.0214, 'lps'),
	(618302, 131, '2014-04-01 00:12:53.000000', 'consum', 0.0222, 'lps'),
	(618303, 131, '2014-04-01 00:12:54.000000', 'consum', 0.0215, 'lps'),
	(618304, 131, '2014-04-01 00:12:55.000000', 'consum', 0.0222, 'lps'),
	(618305, 131, '2014-04-01 00:12:56.000000', 'consum', 0.0216, 'lps'),
	(618306, 131, '2014-04-01 00:12:57.000000', 'consum', 0.0225, 'lps'),
	(618307, 131, '2014-04-01 00:12:58.000000', 'consum', 0.0228, 'lps'),
	(618308, 131, '2014-04-01 00:12:59.000000', 'consum', 0.0214, 'lps'),
	(618309, 131, '2014-04-01 00:13:00.000000', 'consum', 0.0219, 'lps'),
	(618310, 131, '2014-04-01 00:13:01.000000', 'consum', 0.0220, 'lps'),
	(618311, 131, '2014-04-01 00:13:02.000000', 'consum', 0.0216, 'lps'),
	(618312, 131, '2014-04-01 00:13:03.000000', 'consum', 0.0229, 'lps'),
	(618313, 131, '2014-04-01 00:13:04.000000', 'consum', 0.0226, 'lps'),
	(618314, 131, '2014-04-01 00:13:05.000000', 'consum', 0.0216, 'lps'),
	(618315, 131, '2014-04-01 00:13:06.000000', 'consum', 0.0212, 'lps'),
	(618316, 131, '2014-04-01 00:13:07.000000', 'consum', 0.0221, 'lps'),
	(618317, 131, '2014-04-01 00:13:08.000000', 'consum', 0.0219, 'lps'),
	(618318, 131, '2014-04-01 00:13:09.000000', 'consum', 0.0222, 'lps'),
	(618319, 131, '2014-04-01 00:13:10.000000', 'consum', 0.0226, 'lps'),
	(618320, 131, '2014-04-01 00:13:11.000000', 'consum', 0.0215, 'lps'),
	(618321, 131, '2014-04-01 00:13:12.000000', 'consum', 0.0226, 'lps'),
	(618322, 131, '2014-04-01 00:13:13.000000', 'consum', 0.0216, 'lps'),
	(618323, 131, '2014-04-01 00:13:14.000000', 'consum', 0.0214, 'lps'),
	(618324, 131, '2014-04-01 00:13:15.000000', 'consum', 0.0211, 'lps'),
	(618325, 131, '2014-04-01 00:13:16.000000', 'consum', 0.0225, 'lps'),
	(618326, 131, '2014-04-01 00:13:17.000000', 'consum', 0.0220, 'lps'),
	(618327, 131, '2014-04-01 00:13:18.000000', 'consum', 0.0219, 'lps'),
	(618328, 131, '2014-04-01 00:13:19.000000', 'consum', 0.0222, 'lps'),
	(618329, 131, '2014-04-01 00:13:20.000000', 'consum', 0.0224, 'lps'),
	(618330, 131, '2014-04-01 00:13:21.000000', 'consum', 0.0223, 'lps'),
	(618331, 131, '2014-04-01 00:13:22.000000', 'consum', 0.0215, 'lps'),
	(618332, 131, '2014-04-01 00:13:23.000000', 'consum', 0.0217, 'lps'),
	(618333, 131, '2014-04-01 00:13:24.000000', 'consum', 0.0210, 'lps'),
	(618334, 131, '2014-04-01 00:13:25.000000', 'consum', 0.0228, 'lps'),
	(618335, 131, '2014-04-01 00:13:26.000000', 'consum', 0.0220, 'lps'),
	(618336, 131, '2014-04-01 00:13:27.000000', 'consum', 0.0227, 'lps'),
	(618337, 131, '2014-04-01 00:13:28.000000', 'consum', 0.0228, 'lps'),
	(618338, 131, '2014-04-01 00:13:29.000000', 'consum', 0.0227, 'lps'),
	(618339, 131, '2014-04-01 00:13:30.000000', 'consum', 0.0220, 'lps'),
	(618340, 131, '2014-04-01 00:13:31.000000', 'consum', 0.0212, 'lps'),
	(618341, 131, '2014-04-01 00:13:32.000000', 'consum', 0.0210, 'lps'),
	(618342, 131, '2014-04-01 00:13:33.000000', 'consum', 0.0225, 'lps'),
	(618343, 131, '2014-04-01 00:13:34.000000', 'consum', 0.0224, 'lps'),
	(618344, 131, '2014-04-01 00:13:35.000000', 'consum', 0.0216, 'lps'),
	(618345, 131, '2014-04-01 00:13:36.000000', 'consum', 0.0219, 'lps'),
	(618346, 131, '2014-04-01 00:13:37.000000', 'consum', 0.0219, 'lps'),
	(618347, 131, '2014-04-01 00:13:38.000000', 'consum', 0.0225, 'lps'),
	(618348, 131, '2014-04-01 00:13:39.000000', 'consum', 0.0221, 'lps'),
	(618349, 131, '2014-04-01 00:13:40.000000', 'consum', 0.0220, 'lps'),
	(618350, 131, '2014-04-01 00:13:41.000000', 'consum', 0.0226, 'lps'),
	(618351, 131, '2014-04-01 00:13:42.000000', 'consum', 0.0222, 'lps'),
	(618352, 131, '2014-04-01 00:13:43.000000', 'consum', 0.0224, 'lps'),
	(618353, 131, '2014-04-01 00:13:44.000000', 'consum', 0.0222, 'lps'),
	(618354, 131, '2014-04-01 00:13:45.000000', 'consum', 0.0210, 'lps'),
	(618355, 131, '2014-04-01 00:13:46.000000', 'consum', 0.0214, 'lps'),
	(618356, 131, '2014-04-01 00:13:47.000000', 'consum', 0.0211, 'lps'),
	(618357, 131, '2014-04-01 00:13:48.000000', 'consum', 0.0222, 'lps'),
	(618358, 131, '2014-04-01 00:13:49.000000', 'consum', 0.0228, 'lps'),
	(618359, 131, '2014-04-01 00:13:50.000000', 'consum', 0.0224, 'lps'),
	(618360, 131, '2014-04-01 00:13:51.000000', 'consum', 0.0228, 'lps'),
	(618361, 131, '2014-04-01 00:13:52.000000', 'consum', 0.0220, 'lps'),
	(618362, 131, '2014-04-01 00:13:53.000000', 'consum', 0.0223, 'lps'),
	(618363, 131, '2014-04-01 00:13:54.000000', 'consum', 0.0226, 'lps'),
	(618364, 131, '2014-04-01 00:13:55.000000', 'consum', 0.0213, 'lps'),
	(618365, 131, '2014-04-01 00:13:56.000000', 'consum', 0.0218, 'lps'),
	(618366, 131, '2014-04-01 00:13:57.000000', 'consum', 0.0221, 'lps'),
	(618367, 131, '2014-04-01 00:13:58.000000', 'consum', 0.0221, 'lps'),
	(618368, 131, '2014-04-01 00:13:59.000000', 'consum', 0.0213, 'lps'),
	(618369, 131, '2014-04-01 00:14:00.000000', 'consum', 0.0210, 'lps'),
	(618370, 131, '2014-04-01 00:14:01.000000', 'consum', 0.0225, 'lps'),
	(618371, 131, '2014-04-01 00:14:02.000000', 'consum', 0.0225, 'lps'),
	(618372, 131, '2014-04-01 00:14:03.000000', 'consum', 0.0220, 'lps'),
	(618373, 131, '2014-04-01 00:14:04.000000', 'consum', 0.0217, 'lps'),
	(618374, 131, '2014-04-01 00:14:05.000000', 'consum', 0.0216, 'lps'),
	(618375, 131, '2014-04-01 00:14:06.000000', 'consum', 0.0217, 'lps'),
	(618376, 131, '2014-04-01 00:14:07.000000', 'consum', 0.0229, 'lps'),
	(618377, 131, '2014-04-01 00:14:08.000000', 'consum', 0.0224, 'lps'),
	(618378, 131, '2014-04-01 00:14:09.000000', 'consum', 0.0222, 'lps'),
	(618379, 131, '2014-04-01 00:14:10.000000', 'consum', 0.0211, 'lps'),
	(618380, 131, '2014-04-01 00:14:11.000000', 'consum', 0.0219, 'lps'),
	(618381, 131, '2014-04-01 00:14:12.000000', 'consum', 0.0213, 'lps'),
	(618382, 131, '2014-04-01 00:14:13.000000', 'consum', 0.0217, 'lps'),
	(618383, 131, '2014-04-01 00:14:14.000000', 'consum', 0.0218, 'lps'),
	(618384, 131, '2014-04-01 00:14:15.000000', 'consum', 0.0228, 'lps'),
	(618385, 131, '2014-04-01 00:14:16.000000', 'consum', 0.0218, 'lps'),
	(618386, 131, '2014-04-01 00:14:17.000000', 'consum', 0.0217, 'lps'),
	(618387, 131, '2014-04-01 00:14:18.000000', 'consum', 0.0222, 'lps'),
	(618388, 131, '2014-04-01 00:14:19.000000', 'consum', 0.0210, 'lps'),
	(618389, 131, '2014-04-01 00:14:20.000000', 'consum', 0.0214, 'lps'),
	(618390, 131, '2014-04-01 00:14:21.000000', 'consum', 0.0212, 'lps'),
	(618391, 131, '2014-04-01 00:14:22.000000', 'consum', 0.0226, 'lps'),
	(618392, 131, '2014-04-01 00:14:23.000000', 'consum', 0.0226, 'lps'),
	(618393, 131, '2014-04-01 00:14:24.000000', 'consum', 0.0222, 'lps'),
	(618394, 131, '2014-04-01 00:14:25.000000', 'consum', 0.0223, 'lps'),
	(618395, 131, '2014-04-01 00:14:26.000000', 'consum', 0.0218, 'lps'),
	(618396, 131, '2014-04-01 00:14:27.000000', 'consum', 0.0212, 'lps'),
	(618397, 131, '2014-04-01 00:14:28.000000', 'consum', 0.0218, 'lps'),
	(618398, 131, '2014-04-01 00:14:29.000000', 'consum', 0.0225, 'lps'),
	(618399, 131, '2014-04-01 00:14:30.000000', 'consum', 0.0221, 'lps'),
	(618400, 131, '2014-04-01 00:14:31.000000', 'consum', 0.0218, 'lps'),
	(618401, 131, '2014-04-01 00:14:32.000000', 'consum', 0.0220, 'lps'),
	(618402, 131, '2014-04-01 00:14:33.000000', 'consum', 0.0216, 'lps'),
	(618403, 131, '2014-04-01 00:14:34.000000', 'consum', 0.0210, 'lps'),
	(618404, 131, '2014-04-01 00:14:35.000000', 'consum', 0.0212, 'lps'),
	(618405, 131, '2014-04-01 00:14:36.000000', 'consum', 0.0221, 'lps'),
	(618406, 131, '2014-04-01 00:14:37.000000', 'consum', 0.0220, 'lps'),
	(618407, 131, '2014-04-01 00:14:38.000000', 'consum', 0.0229, 'lps'),
	(618408, 131, '2014-04-01 00:14:39.000000', 'consum', 0.0213, 'lps'),
	(618409, 131, '2014-04-01 00:14:40.000000', 'consum', 0.0229, 'lps'),
	(618410, 131, '2014-04-01 00:14:41.000000', 'consum', 0.0217, 'lps'),
	(618411, 131, '2014-04-01 00:14:42.000000', 'consum', 0.0227, 'lps'),
	(618412, 131, '2014-04-01 00:14:43.000000', 'consum', 0.0216, 'lps'),
	(618413, 131, '2014-04-01 00:14:44.000000', 'consum', 0.0211, 'lps'),
	(618414, 131, '2014-04-01 00:14:45.000000', 'consum', 0.0216, 'lps'),
	(618415, 131, '2014-04-01 00:14:46.000000', 'consum', 0.0219, 'lps'),
	(618416, 131, '2014-04-01 00:14:47.000000', 'consum', 0.0218, 'lps'),
	(618417, 131, '2014-04-01 00:14:48.000000', 'consum', 0.0221, 'lps'),
	(618418, 131, '2014-04-01 00:14:49.000000', 'consum', 0.0222, 'lps'),
	(618419, 131, '2014-04-01 00:14:50.000000', 'consum', 0.0217, 'lps'),
	(618420, 131, '2014-04-01 00:14:51.000000', 'consum', 0.0229, 'lps'),
	(618421, 131, '2014-04-01 00:14:52.000000', 'consum', 0.0226, 'lps'),
	(618422, 131, '2014-04-01 00:14:53.000000', 'consum', 0.0212, 'lps'),
	(618423, 131, '2014-04-01 00:14:54.000000', 'consum', 0.0213, 'lps'),
	(618424, 131, '2014-04-01 00:14:55.000000', 'consum', 0.0220, 'lps'),
	(618425, 131, '2014-04-01 00:14:56.000000', 'consum', 0.0210, 'lps'),
	(618426, 131, '2014-04-01 00:14:57.000000', 'consum', 0.0221, 'lps'),
	(618427, 131, '2014-04-01 00:14:58.000000', 'consum', 0.0225, 'lps'),
	(618428, 131, '2014-04-01 00:14:59.000000', 'consum', 0.0213, 'lps'),
	(618429, 131, '2014-04-01 00:15:00.000000', 'consum', 0.0221, 'lps'),
	(618430, 131, '2014-04-01 00:15:01.000000', 'consum', 0.0216, 'lps'),
	(618431, 131, '2014-04-01 00:15:02.000000', 'consum', 0.0227, 'lps'),
	(618432, 131, '2014-04-01 00:15:03.000000', 'consum', 0.0219, 'lps'),
	(618433, 131, '2014-04-01 00:15:04.000000', 'consum', 0.0225, 'lps'),
	(618434, 131, '2014-04-01 00:15:05.000000', 'consum', 0.0219, 'lps'),
	(618435, 131, '2014-04-01 00:15:06.000000', 'consum', 0.0228, 'lps'),
	(618436, 131, '2014-04-01 00:15:07.000000', 'consum', 0.0214, 'lps'),
	(618437, 131, '2014-04-01 00:15:08.000000', 'consum', 0.0215, 'lps'),
	(618438, 131, '2014-04-01 00:15:09.000000', 'consum', 0.0226, 'lps'),
	(618439, 131, '2014-04-01 00:15:10.000000', 'consum', 0.0213, 'lps'),
	(618440, 131, '2014-04-01 00:15:11.000000', 'consum', 0.0218, 'lps'),
	(618441, 131, '2014-04-01 00:15:12.000000', 'consum', 0.0223, 'lps'),
	(618442, 131, '2014-04-01 00:15:13.000000', 'consum', 0.0212, 'lps'),
	(618443, 131, '2014-04-01 00:15:14.000000', 'consum', 0.0219, 'lps'),
	(618444, 131, '2014-04-01 00:15:15.000000', 'consum', 0.0212, 'lps'),
	(618445, 131, '2014-04-01 00:15:16.000000', 'consum', 0.0212, 'lps'),
	(618446, 131, '2014-04-01 00:15:17.000000', 'consum', 0.0216, 'lps'),
	(618447, 131, '2014-04-01 00:15:18.000000', 'consum', 0.0212, 'lps'),
	(618448, 131, '2014-04-01 00:15:19.000000', 'consum', 0.0226, 'lps'),
	(618449, 131, '2014-04-01 00:15:20.000000', 'consum', 0.0222, 'lps'),
	(618450, 131, '2014-04-01 00:15:21.000000', 'consum', 0.0223, 'lps'),
	(618451, 131, '2014-04-01 00:15:22.000000', 'consum', 0.0222, 'lps'),
	(618452, 131, '2014-04-01 00:15:23.000000', 'consum', 0.0229, 'lps'),
	(618453, 131, '2014-04-01 00:15:24.000000', 'consum', 0.0229, 'lps'),
	(618454, 131, '2014-04-01 00:15:25.000000', 'consum', 0.0227, 'lps'),
	(618455, 131, '2014-04-01 00:15:26.000000', 'consum', 0.0221, 'lps'),
	(618456, 131, '2014-04-01 00:15:27.000000', 'consum', 0.0212, 'lps'),
	(618457, 131, '2014-04-01 00:15:28.000000', 'consum', 0.0228, 'lps'),
	(618458, 131, '2014-04-01 00:15:29.000000', 'consum', 0.0215, 'lps'),
	(618459, 131, '2014-04-01 00:15:30.000000', 'consum', 0.0220, 'lps'),
	(618460, 131, '2014-04-01 00:15:31.000000', 'consum', 0.0227, 'lps'),
	(618461, 131, '2014-04-01 00:15:32.000000', 'consum', 0.0224, 'lps'),
	(618462, 131, '2014-04-01 00:15:33.000000', 'consum', 0.0210, 'lps'),
	(618463, 131, '2014-04-01 00:15:34.000000', 'consum', 0.0229, 'lps'),
	(618464, 131, '2014-04-01 00:15:35.000000', 'consum', 0.0225, 'lps'),
	(618465, 131, '2014-04-01 00:15:36.000000', 'consum', 0.0211, 'lps'),
	(618466, 131, '2014-04-01 00:15:37.000000', 'consum', 0.0228, 'lps'),
	(618467, 131, '2014-04-01 00:15:38.000000', 'consum', 0.0217, 'lps'),
	(618468, 131, '2014-04-01 00:15:39.000000', 'consum', 0.0211, 'lps'),
	(618469, 131, '2014-04-01 00:15:40.000000', 'consum', 0.0217, 'lps'),
	(618470, 131, '2014-04-01 00:15:41.000000', 'consum', 0.0220, 'lps'),
	(618471, 131, '2014-04-01 00:15:42.000000', 'consum', 0.0220, 'lps'),
	(618472, 131, '2014-04-01 00:15:43.000000', 'consum', 0.0210, 'lps'),
	(618473, 131, '2014-04-01 00:15:44.000000', 'consum', 0.0221, 'lps'),
	(618474, 131, '2014-04-01 00:15:45.000000', 'consum', 0.0226, 'lps'),
	(618475, 131, '2014-04-01 00:15:46.000000', 'consum', 0.0218, 'lps'),
	(618476, 131, '2014-04-01 00:15:47.000000', 'consum', 0.0224, 'lps'),
	(618477, 131, '2014-04-01 00:15:48.000000', 'consum', 0.0214, 'lps'),
	(618478, 131, '2014-04-01 00:15:49.000000', 'consum', 0.0228, 'lps'),
	(618479, 131, '2014-04-01 00:15:50.000000', 'consum', 0.0228, 'lps'),
	(618480, 131, '2014-04-01 00:15:51.000000', 'consum', 0.0226, 'lps'),
	(618481, 131, '2014-04-01 00:15:52.000000', 'consum', 0.0219, 'lps'),
	(618482, 131, '2014-04-01 00:15:53.000000', 'consum', 0.0225, 'lps'),
	(618483, 131, '2014-04-01 00:15:54.000000', 'consum', 0.0218, 'lps'),
	(618484, 131, '2014-04-01 00:15:55.000000', 'consum', 0.0227, 'lps'),
	(618485, 131, '2014-04-01 00:15:56.000000', 'consum', 0.0229, 'lps'),
	(618486, 131, '2014-04-01 00:15:57.000000', 'consum', 0.0217, 'lps'),
	(618487, 131, '2014-04-01 00:15:58.000000', 'consum', 0.0227, 'lps'),
	(618488, 131, '2014-04-01 00:15:59.000000', 'consum', 0.0216, 'lps'),
	(618489, 131, '2014-04-01 00:16:00.000000', 'consum', 0.0229, 'lps'),
	(618490, 131, '2014-04-01 00:16:01.000000', 'consum', 0.0229, 'lps'),
	(618491, 131, '2014-04-01 00:16:02.000000', 'consum', 0.0227, 'lps'),
	(618492, 131, '2014-04-01 00:16:03.000000', 'consum', 0.0217, 'lps'),
	(618493, 131, '2014-04-01 00:16:04.000000', 'consum', 0.0214, 'lps'),
	(618494, 131, '2014-04-01 00:16:05.000000', 'consum', 0.0212, 'lps'),
	(618495, 131, '2014-04-01 00:16:06.000000', 'consum', 0.0226, 'lps'),
	(618496, 131, '2014-04-01 00:16:07.000000', 'consum', 0.0227, 'lps'),
	(618497, 131, '2014-04-01 00:16:08.000000', 'consum', 0.0228, 'lps'),
	(618498, 131, '2014-04-01 00:16:09.000000', 'consum', 0.0229, 'lps'),
	(618499, 131, '2014-04-01 00:16:10.000000', 'consum', 0.0229, 'lps'),
	(618500, 131, '2014-04-01 00:16:11.000000', 'consum', 0.0212, 'lps'),
	(618501, 131, '2014-04-01 00:16:12.000000', 'consum', 0.0220, 'lps'),
	(618502, 131, '2014-04-01 00:16:13.000000', 'consum', 0.0218, 'lps'),
	(618503, 131, '2014-04-01 00:16:14.000000', 'consum', 0.0219, 'lps'),
	(618504, 131, '2014-04-01 00:16:15.000000', 'consum', 0.0214, 'lps'),
	(618505, 131, '2014-04-01 00:16:16.000000', 'consum', 0.0220, 'lps'),
	(618506, 131, '2014-04-01 00:16:17.000000', 'consum', 0.0212, 'lps'),
	(618507, 131, '2014-04-01 00:16:18.000000', 'consum', 0.0228, 'lps'),
	(618508, 131, '2014-04-01 00:16:19.000000', 'consum', 0.0216, 'lps'),
	(618509, 131, '2014-04-01 00:16:20.000000', 'consum', 0.0226, 'lps'),
	(618510, 131, '2014-04-01 00:16:21.000000', 'consum', 0.0214, 'lps'),
	(618511, 131, '2014-04-01 00:16:22.000000', 'consum', 0.0223, 'lps'),
	(618512, 131, '2014-04-01 00:16:23.000000', 'consum', 0.0222, 'lps'),
	(618513, 131, '2014-04-01 00:16:24.000000', 'consum', 0.0210, 'lps'),
	(618514, 131, '2014-04-01 00:16:25.000000', 'consum', 0.0215, 'lps'),
	(618515, 131, '2014-04-01 00:16:26.000000', 'consum', 0.0216, 'lps'),
	(618516, 131, '2014-04-01 00:16:27.000000', 'consum', 0.0224, 'lps'),
	(618517, 131, '2014-04-01 00:16:28.000000', 'consum', 0.0223, 'lps'),
	(618518, 131, '2014-04-01 00:16:29.000000', 'consum', 0.0214, 'lps'),
	(618519, 131, '2014-04-01 00:16:30.000000', 'consum', 0.0211, 'lps'),
	(618520, 131, '2014-04-01 00:16:31.000000', 'consum', 0.0225, 'lps'),
	(618521, 131, '2014-04-01 00:16:32.000000', 'consum', 0.0220, 'lps'),
	(618522, 131, '2014-04-01 00:16:33.000000', 'consum', 0.0215, 'lps'),
	(618523, 131, '2014-04-01 00:16:34.000000', 'consum', 0.0227, 'lps'),
	(618524, 131, '2014-04-01 00:16:35.000000', 'consum', 0.0219, 'lps'),
	(618525, 131, '2014-04-01 00:16:36.000000', 'consum', 0.0226, 'lps'),
	(618526, 131, '2014-04-01 00:16:37.000000', 'consum', 0.0221, 'lps'),
	(618527, 131, '2014-04-01 00:16:38.000000', 'consum', 0.0221, 'lps'),
	(618528, 131, '2014-04-01 00:16:39.000000', 'consum', 0.0210, 'lps'),
	(618529, 131, '2014-04-01 00:16:40.000000', 'consum', 0.0218, 'lps'),
	(618530, 131, '2014-04-01 00:16:41.000000', 'consum', 0.0229, 'lps'),
	(618531, 131, '2014-04-01 00:16:42.000000', 'consum', 0.0221, 'lps'),
	(618532, 131, '2014-04-01 00:16:43.000000', 'consum', 0.0210, 'lps'),
	(618533, 131, '2014-04-01 00:16:44.000000', 'consum', 0.0215, 'lps'),
	(618534, 131, '2014-04-01 00:16:45.000000', 'consum', 0.0219, 'lps'),
	(618535, 131, '2014-04-01 00:16:46.000000', 'consum', 0.0219, 'lps'),
	(618536, 131, '2014-04-01 00:16:47.000000', 'consum', 0.0210, 'lps'),
	(618537, 131, '2014-04-01 00:16:48.000000', 'consum', 0.0224, 'lps'),
	(618538, 131, '2014-04-01 00:16:49.000000', 'consum', 0.0219, 'lps'),
	(618539, 131, '2014-04-01 00:16:50.000000', 'consum', 0.0215, 'lps'),
	(618540, 131, '2014-04-01 00:16:51.000000', 'consum', 0.0226, 'lps'),
	(618541, 131, '2014-04-01 00:16:52.000000', 'consum', 0.0216, 'lps'),
	(618542, 131, '2014-04-01 00:16:53.000000', 'consum', 0.0214, 'lps'),
	(618543, 131, '2014-04-01 00:16:54.000000', 'consum', 0.0212, 'lps'),
	(618544, 131, '2014-04-01 00:16:55.000000', 'consum', 0.0210, 'lps'),
	(618545, 131, '2014-04-01 00:16:56.000000', 'consum', 0.0225, 'lps'),
	(618546, 131, '2014-04-01 00:16:57.000000', 'consum', 0.0226, 'lps'),
	(618547, 131, '2014-04-01 00:16:58.000000', 'consum', 0.0225, 'lps'),
	(618548, 131, '2014-04-01 00:16:59.000000', 'consum', 0.0218, 'lps'),
	(618549, 131, '2014-04-01 00:17:00.000000', 'consum', 0.0225, 'lps'),
	(618550, 131, '2014-04-01 00:17:01.000000', 'consum', 0.0222, 'lps'),
	(618551, 131, '2014-04-01 00:17:02.000000', 'consum', 0.0224, 'lps'),
	(618552, 131, '2014-04-01 00:17:03.000000', 'consum', 0.0224, 'lps'),
	(618553, 131, '2014-04-01 00:17:04.000000', 'consum', 0.0219, 'lps'),
	(618554, 131, '2014-04-01 00:17:05.000000', 'consum', 0.0214, 'lps'),
	(618555, 131, '2014-04-01 00:17:06.000000', 'consum', 0.0223, 'lps'),
	(618556, 131, '2014-04-01 00:17:07.000000', 'consum', 0.0226, 'lps'),
	(618557, 131, '2014-04-01 00:17:08.000000', 'consum', 0.0229, 'lps'),
	(618558, 131, '2014-04-01 00:17:09.000000', 'consum', 0.0219, 'lps'),
	(618559, 131, '2014-04-01 00:17:10.000000', 'consum', 0.0217, 'lps'),
	(618560, 131, '2014-04-01 00:17:11.000000', 'consum', 0.0220, 'lps'),
	(618561, 131, '2014-04-01 00:17:12.000000', 'consum', 0.0220, 'lps'),
	(618562, 131, '2014-04-01 00:17:13.000000', 'consum', 0.0228, 'lps'),
	(618563, 131, '2014-04-01 00:17:14.000000', 'consum', 0.0213, 'lps'),
	(618564, 131, '2014-04-01 00:17:15.000000', 'consum', 0.0211, 'lps'),
	(618565, 131, '2014-04-01 00:17:16.000000', 'consum', 0.0228, 'lps'),
	(618566, 131, '2014-04-01 00:17:17.000000', 'consum', 0.0215, 'lps'),
	(618567, 131, '2014-04-01 00:17:18.000000', 'consum', 0.0224, 'lps'),
	(618568, 131, '2014-04-01 00:17:19.000000', 'consum', 0.0226, 'lps'),
	(618569, 131, '2014-04-01 00:17:20.000000', 'consum', 0.0226, 'lps'),
	(618570, 131, '2014-04-01 00:17:21.000000', 'consum', 0.0223, 'lps'),
	(618571, 131, '2014-04-01 00:17:22.000000', 'consum', 0.0228, 'lps'),
	(618572, 131, '2014-04-01 00:17:23.000000', 'consum', 0.0223, 'lps'),
	(618573, 131, '2014-04-01 00:17:24.000000', 'consum', 0.0219, 'lps'),
	(618574, 131, '2014-04-01 00:17:25.000000', 'consum', 0.0217, 'lps'),
	(618575, 131, '2014-04-01 00:17:26.000000', 'consum', 0.0220, 'lps'),
	(618576, 131, '2014-04-01 00:17:27.000000', 'consum', 0.0218, 'lps'),
	(618577, 131, '2014-04-01 00:17:28.000000', 'consum', 0.0223, 'lps'),
	(618578, 131, '2014-04-01 00:17:29.000000', 'consum', 0.0228, 'lps'),
	(618579, 131, '2014-04-01 00:17:30.000000', 'consum', 0.0225, 'lps'),
	(618580, 131, '2014-04-01 00:17:31.000000', 'consum', 0.0228, 'lps'),
	(618581, 131, '2014-04-01 00:17:32.000000', 'consum', 0.0218, 'lps'),
	(618582, 131, '2014-04-01 00:17:33.000000', 'consum', 0.0216, 'lps'),
	(618583, 131, '2014-04-01 00:17:34.000000', 'consum', 0.0215, 'lps'),
	(618584, 131, '2014-04-01 00:17:35.000000', 'consum', 0.0220, 'lps'),
	(618585, 131, '2014-04-01 00:17:36.000000', 'consum', 0.0224, 'lps'),
	(618586, 131, '2014-04-01 00:17:37.000000', 'consum', 0.0211, 'lps'),
	(618587, 131, '2014-04-01 00:17:38.000000', 'consum', 0.0213, 'lps'),
	(618588, 131, '2014-04-01 00:17:39.000000', 'consum', 0.0223, 'lps'),
	(618589, 131, '2014-04-01 00:17:40.000000', 'consum', 0.0226, 'lps'),
	(618590, 131, '2014-04-01 00:17:41.000000', 'consum', 0.0210, 'lps'),
	(618591, 131, '2014-04-01 00:17:42.000000', 'consum', 0.0223, 'lps'),
	(618592, 131, '2014-04-01 00:17:43.000000', 'consum', 0.0215, 'lps'),
	(618593, 131, '2014-04-01 00:17:44.000000', 'consum', 0.0216, 'lps'),
	(618594, 131, '2014-04-01 00:17:45.000000', 'consum', 0.0225, 'lps'),
	(618595, 131, '2014-04-01 00:17:46.000000', 'consum', 0.0211, 'lps'),
	(618596, 131, '2014-04-01 00:17:47.000000', 'consum', 0.0227, 'lps'),
	(618597, 131, '2014-04-01 00:17:48.000000', 'consum', 0.0212, 'lps'),
	(618598, 131, '2014-04-01 00:17:49.000000', 'consum', 0.0212, 'lps'),
	(618599, 131, '2014-04-01 00:17:50.000000', 'consum', 0.0213, 'lps'),
	(618600, 131, '2014-04-01 00:17:51.000000', 'consum', 0.0222, 'lps'),
	(618601, 131, '2014-04-01 00:17:52.000000', 'consum', 0.0218, 'lps'),
	(618602, 131, '2014-04-01 00:17:53.000000', 'consum', 0.0216, 'lps'),
	(618603, 131, '2014-04-01 00:17:54.000000', 'consum', 0.0215, 'lps'),
	(618604, 131, '2014-04-01 00:17:55.000000', 'consum', 0.0220, 'lps'),
	(618605, 131, '2014-04-01 00:17:56.000000', 'consum', 0.0223, 'lps'),
	(618606, 131, '2014-04-01 00:17:57.000000', 'consum', 0.0226, 'lps'),
	(618607, 131, '2014-04-01 00:17:58.000000', 'consum', 0.0211, 'lps'),
	(618608, 131, '2014-04-01 00:17:59.000000', 'consum', 0.0228, 'lps'),
	(618609, 131, '2014-04-01 00:18:00.000000', 'consum', 0.0216, 'lps'),
	(618610, 131, '2014-04-01 00:18:01.000000', 'consum', 0.0228, 'lps'),
	(618611, 131, '2014-04-01 00:18:02.000000', 'consum', 0.0221, 'lps'),
	(618612, 131, '2014-04-01 00:18:03.000000', 'consum', 0.0214, 'lps'),
	(618613, 131, '2014-04-01 00:18:04.000000', 'consum', 0.0218, 'lps'),
	(618614, 131, '2014-04-01 00:18:05.000000', 'consum', 0.0216, 'lps'),
	(618615, 131, '2014-04-01 00:18:06.000000', 'consum', 0.0219, 'lps'),
	(618616, 131, '2014-04-01 00:18:07.000000', 'consum', 0.0215, 'lps'),
	(618617, 131, '2014-04-01 00:18:08.000000', 'consum', 0.0229, 'lps'),
	(618618, 131, '2014-04-01 00:18:09.000000', 'consum', 0.0212, 'lps'),
	(618619, 131, '2014-04-01 00:18:10.000000', 'consum', 0.0224, 'lps'),
	(618620, 131, '2014-04-01 00:18:11.000000', 'consum', 0.0212, 'lps'),
	(618621, 131, '2014-04-01 00:18:12.000000', 'consum', 0.0221, 'lps'),
	(618622, 131, '2014-04-01 00:18:13.000000', 'consum', 0.0218, 'lps'),
	(618623, 131, '2014-04-01 00:18:14.000000', 'consum', 0.0217, 'lps'),
	(618624, 131, '2014-04-01 00:18:15.000000', 'consum', 0.0223, 'lps'),
	(618625, 131, '2014-04-01 00:18:16.000000', 'consum', 0.0212, 'lps'),
	(618626, 131, '2014-04-01 00:18:17.000000', 'consum', 0.0224, 'lps'),
	(618627, 131, '2014-04-01 00:18:18.000000', 'consum', 0.0213, 'lps'),
	(618628, 131, '2014-04-01 00:18:19.000000', 'consum', 0.0226, 'lps'),
	(618629, 131, '2014-04-01 00:18:20.000000', 'consum', 0.0218, 'lps'),
	(618630, 131, '2014-04-01 00:18:21.000000', 'consum', 0.0226, 'lps'),
	(618631, 131, '2014-04-01 00:18:22.000000', 'consum', 0.0225, 'lps'),
	(618632, 131, '2014-04-01 00:18:23.000000', 'consum', 0.0219, 'lps'),
	(618633, 131, '2014-04-01 00:18:24.000000', 'consum', 0.0228, 'lps'),
	(618634, 131, '2014-04-01 00:18:25.000000', 'consum', 0.0216, 'lps'),
	(618635, 131, '2014-04-01 00:18:26.000000', 'consum', 0.0224, 'lps'),
	(618636, 131, '2014-04-01 00:18:27.000000', 'consum', 0.0223, 'lps'),
	(618637, 131, '2014-04-01 00:18:28.000000', 'consum', 0.0212, 'lps'),
	(618638, 131, '2014-04-01 00:18:29.000000', 'consum', 0.0223, 'lps'),
	(618639, 131, '2014-04-01 00:18:30.000000', 'consum', 0.0228, 'lps'),
	(618640, 131, '2014-04-01 00:18:31.000000', 'consum', 0.0223, 'lps'),
	(618641, 131, '2014-04-01 00:18:32.000000', 'consum', 0.0220, 'lps'),
	(618642, 131, '2014-04-01 00:18:33.000000', 'consum', 0.0221, 'lps'),
	(618643, 131, '2014-04-01 00:18:34.000000', 'consum', 0.0216, 'lps'),
	(618644, 131, '2014-04-01 00:18:35.000000', 'consum', 0.0229, 'lps'),
	(618645, 131, '2014-04-01 00:18:36.000000', 'consum', 0.0225, 'lps'),
	(618646, 131, '2014-04-01 00:18:37.000000', 'consum', 0.0211, 'lps'),
	(618647, 131, '2014-04-01 00:18:38.000000', 'consum', 0.0210, 'lps'),
	(618648, 131, '2014-04-01 00:18:39.000000', 'consum', 0.0229, 'lps'),
	(618649, 131, '2014-04-01 00:18:40.000000', 'consum', 0.0224, 'lps'),
	(618650, 131, '2014-04-01 00:18:41.000000', 'consum', 0.0222, 'lps'),
	(618651, 131, '2014-04-01 00:18:42.000000', 'consum', 0.0228, 'lps'),
	(618652, 131, '2014-04-01 00:18:43.000000', 'consum', 0.0227, 'lps'),
	(618653, 131, '2014-04-01 00:18:44.000000', 'consum', 0.0222, 'lps'),
	(618654, 131, '2014-04-01 00:18:45.000000', 'consum', 0.0218, 'lps'),
	(618655, 131, '2014-04-01 00:18:46.000000', 'consum', 0.0215, 'lps'),
	(618656, 131, '2014-04-01 00:18:47.000000', 'consum', 0.0210, 'lps'),
	(618657, 131, '2014-04-01 00:18:48.000000', 'consum', 0.0217, 'lps'),
	(618658, 131, '2014-04-01 00:18:49.000000', 'consum', 0.0224, 'lps'),
	(618659, 131, '2014-04-01 00:18:50.000000', 'consum', 0.0221, 'lps'),
	(618660, 131, '2014-04-01 00:18:51.000000', 'consum', 0.0223, 'lps'),
	(618661, 131, '2014-04-01 00:18:52.000000', 'consum', 0.0221, 'lps'),
	(618662, 131, '2014-04-01 00:18:53.000000', 'consum', 0.0226, 'lps'),
	(618663, 131, '2014-04-01 00:18:54.000000', 'consum', 0.0220, 'lps'),
	(618664, 131, '2014-04-01 00:18:55.000000', 'consum', 0.0210, 'lps'),
	(618665, 131, '2014-04-01 00:18:56.000000', 'consum', 0.0222, 'lps'),
	(618666, 131, '2014-04-01 00:18:57.000000', 'consum', 0.0229, 'lps'),
	(618667, 131, '2014-04-01 00:18:58.000000', 'consum', 0.0228, 'lps'),
	(618668, 131, '2014-04-01 00:18:59.000000', 'consum', 0.0226, 'lps'),
	(618669, 131, '2014-04-01 00:19:00.000000', 'consum', 0.0217, 'lps'),
	(618670, 131, '2014-04-01 00:19:01.000000', 'consum', 0.0215, 'lps'),
	(618671, 131, '2014-04-01 00:19:02.000000', 'consum', 0.0215, 'lps'),
	(618672, 131, '2014-04-01 00:19:03.000000', 'consum', 0.0222, 'lps'),
	(618673, 131, '2014-04-01 00:19:04.000000', 'consum', 0.0215, 'lps'),
	(618674, 131, '2014-04-01 00:19:05.000000', 'consum', 0.0220, 'lps'),
	(618675, 131, '2014-04-01 00:19:06.000000', 'consum', 0.0226, 'lps'),
	(618676, 131, '2014-04-01 00:19:07.000000', 'consum', 0.0219, 'lps'),
	(618677, 131, '2014-04-01 00:19:08.000000', 'consum', 0.0227, 'lps'),
	(618678, 131, '2014-04-01 00:19:09.000000', 'consum', 0.0210, 'lps'),
	(618679, 131, '2014-04-01 00:19:10.000000', 'consum', 0.0221, 'lps'),
	(618680, 131, '2014-04-01 00:19:11.000000', 'consum', 0.0224, 'lps'),
	(618681, 131, '2014-04-01 00:19:12.000000', 'consum', 0.0228, 'lps'),
	(618682, 131, '2014-04-01 00:19:13.000000', 'consum', 0.0217, 'lps'),
	(618683, 131, '2014-04-01 00:19:14.000000', 'consum', 0.0214, 'lps'),
	(618684, 131, '2014-04-01 00:19:15.000000', 'consum', 0.0228, 'lps'),
	(618685, 131, '2014-04-01 00:19:16.000000', 'consum', 0.0228, 'lps'),
	(618686, 131, '2014-04-01 00:19:17.000000', 'consum', 0.0226, 'lps'),
	(618687, 131, '2014-04-01 00:19:18.000000', 'consum', 0.0217, 'lps'),
	(618688, 131, '2014-04-01 00:19:19.000000', 'consum', 0.0217, 'lps'),
	(618689, 131, '2014-04-01 00:19:20.000000', 'consum', 0.0223, 'lps'),
	(618690, 131, '2014-04-01 00:19:21.000000', 'consum', 0.0217, 'lps'),
	(618691, 131, '2014-04-01 00:19:22.000000', 'consum', 0.0226, 'lps'),
	(618692, 131, '2014-04-01 00:19:23.000000', 'consum', 0.0210, 'lps'),
	(618693, 131, '2014-04-01 00:19:24.000000', 'consum', 0.0224, 'lps'),
	(618694, 131, '2014-04-01 00:19:25.000000', 'consum', 0.0220, 'lps'),
	(618695, 131, '2014-04-01 00:19:26.000000', 'consum', 0.0216, 'lps'),
	(618696, 131, '2014-04-01 00:19:27.000000', 'consum', 0.0213, 'lps'),
	(618697, 131, '2014-04-01 00:19:28.000000', 'consum', 0.0226, 'lps'),
	(618698, 131, '2014-04-01 00:19:29.000000', 'consum', 0.0223, 'lps'),
	(618699, 131, '2014-04-01 00:19:30.000000', 'consum', 0.0228, 'lps'),
	(618700, 131, '2014-04-01 00:19:31.000000', 'consum', 0.0222, 'lps'),
	(618701, 131, '2014-04-01 00:19:32.000000', 'consum', 0.0214, 'lps'),
	(618702, 131, '2014-04-01 00:19:33.000000', 'consum', 0.0215, 'lps'),
	(618703, 131, '2014-04-01 00:19:34.000000', 'consum', 0.0224, 'lps'),
	(618704, 131, '2014-04-01 00:19:35.000000', 'consum', 0.0225, 'lps'),
	(618705, 131, '2014-04-01 00:19:36.000000', 'consum', 0.0224, 'lps'),
	(618706, 131, '2014-04-01 00:19:37.000000', 'consum', 0.0214, 'lps'),
	(618707, 131, '2014-04-01 00:19:38.000000', 'consum', 0.0211, 'lps'),
	(618708, 131, '2014-04-01 00:19:39.000000', 'consum', 0.0223, 'lps'),
	(618709, 131, '2014-04-01 00:19:40.000000', 'consum', 0.0212, 'lps'),
	(618710, 131, '2014-04-01 00:19:41.000000', 'consum', 0.0222, 'lps'),
	(618711, 131, '2014-04-01 00:19:42.000000', 'consum', 0.0223, 'lps'),
	(618712, 131, '2014-04-01 00:19:43.000000', 'consum', 0.0220, 'lps'),
	(618713, 131, '2014-04-01 00:19:44.000000', 'consum', 0.0224, 'lps'),
	(618714, 131, '2014-04-01 00:19:45.000000', 'consum', 0.0227, 'lps'),
	(618715, 131, '2014-04-01 00:19:46.000000', 'consum', 0.0215, 'lps'),
	(618716, 131, '2014-04-01 00:19:47.000000', 'consum', 0.0222, 'lps'),
	(618717, 131, '2014-04-01 00:19:48.000000', 'consum', 0.0219, 'lps'),
	(618718, 131, '2014-04-01 00:19:49.000000', 'consum', 0.0220, 'lps'),
	(618719, 131, '2014-04-01 00:19:50.000000', 'consum', 0.0210, 'lps'),
	(618720, 131, '2014-04-01 00:19:51.000000', 'consum', 0.0223, 'lps'),
	(618721, 131, '2014-04-01 00:19:52.000000', 'consum', 0.0213, 'lps'),
	(618722, 131, '2014-04-01 00:19:53.000000', 'consum', 0.0227, 'lps'),
	(618723, 131, '2014-04-01 00:19:54.000000', 'consum', 0.0229, 'lps'),
	(618724, 131, '2014-04-01 00:19:55.000000', 'consum', 0.0211, 'lps'),
	(618725, 131, '2014-04-01 00:19:56.000000', 'consum', 0.0222, 'lps'),
	(618726, 131, '2014-04-01 00:19:57.000000', 'consum', 0.0227, 'lps'),
	(618727, 131, '2014-04-01 00:19:58.000000', 'consum', 0.0218, 'lps'),
	(618728, 131, '2014-04-01 00:19:59.000000', 'consum', 0.0219, 'lps'),
	(618729, 131, '2014-04-01 00:20:00.000000', 'consum', 0.0211, 'lps'),
	(618730, 131, '2014-04-01 00:20:01.000000', 'consum', 0.0228, 'lps'),
	(618731, 131, '2014-04-01 00:20:02.000000', 'consum', 0.0218, 'lps'),
	(618732, 131, '2014-04-01 00:20:03.000000', 'consum', 0.0218, 'lps'),
	(618733, 131, '2014-04-01 00:20:04.000000', 'consum', 0.0226, 'lps'),
	(618734, 131, '2014-04-01 00:20:05.000000', 'consum', 0.0225, 'lps'),
	(618735, 131, '2014-04-01 00:20:06.000000', 'consum', 0.0217, 'lps'),
	(618736, 131, '2014-04-01 00:20:07.000000', 'consum', 0.0223, 'lps'),
	(618737, 131, '2014-04-01 00:20:08.000000', 'consum', 0.0216, 'lps'),
	(618738, 131, '2014-04-01 00:20:09.000000', 'consum', 0.0218, 'lps'),
	(618739, 131, '2014-04-01 00:20:10.000000', 'consum', 0.0213, 'lps'),
	(618740, 131, '2014-04-01 00:20:11.000000', 'consum', 0.0223, 'lps'),
	(618741, 131, '2014-04-01 00:20:12.000000', 'consum', 0.0228, 'lps'),
	(618742, 131, '2014-04-01 00:20:13.000000', 'consum', 0.0219, 'lps'),
	(618743, 131, '2014-04-01 00:20:14.000000', 'consum', 0.0221, 'lps'),
	(618744, 131, '2014-04-01 00:20:15.000000', 'consum', 0.0220, 'lps'),
	(618745, 131, '2014-04-01 00:20:16.000000', 'consum', 0.0226, 'lps'),
	(618746, 131, '2014-04-01 00:20:17.000000', 'consum', 0.0219, 'lps'),
	(618747, 131, '2014-04-01 00:20:18.000000', 'consum', 0.0211, 'lps'),
	(618748, 131, '2014-04-01 00:20:19.000000', 'consum', 0.0227, 'lps'),
	(618749, 131, '2014-04-01 00:20:20.000000', 'consum', 0.0215, 'lps'),
	(618750, 131, '2014-04-01 00:20:21.000000', 'consum', 0.0222, 'lps'),
	(618751, 131, '2014-04-01 00:20:22.000000', 'consum', 0.0215, 'lps'),
	(618752, 131, '2014-04-01 00:20:23.000000', 'consum', 0.0220, 'lps'),
	(618753, 131, '2014-04-01 00:20:24.000000', 'consum', 0.0225, 'lps'),
	(618754, 131, '2014-04-01 00:20:25.000000', 'consum', 0.0215, 'lps'),
	(618755, 131, '2014-04-01 00:20:26.000000', 'consum', 0.0211, 'lps'),
	(618756, 131, '2014-04-01 00:20:27.000000', 'consum', 0.0222, 'lps'),
	(618757, 131, '2014-04-01 00:20:28.000000', 'consum', 0.0229, 'lps'),
	(618758, 131, '2014-04-01 00:20:29.000000', 'consum', 0.0226, 'lps'),
	(618759, 131, '2014-04-01 00:20:30.000000', 'consum', 0.0215, 'lps'),
	(618760, 131, '2014-04-01 00:20:31.000000', 'consum', 0.0226, 'lps'),
	(618761, 131, '2014-04-01 00:20:32.000000', 'consum', 0.0218, 'lps'),
	(618762, 131, '2014-04-01 00:20:33.000000', 'consum', 0.0220, 'lps'),
	(618763, 131, '2014-04-01 00:20:34.000000', 'consum', 0.0219, 'lps'),
	(618764, 131, '2014-04-01 00:20:35.000000', 'consum', 0.0223, 'lps'),
	(618765, 131, '2014-04-01 00:20:36.000000', 'consum', 0.0229, 'lps'),
	(618766, 131, '2014-04-01 00:20:37.000000', 'consum', 0.0228, 'lps'),
	(618767, 131, '2014-04-01 00:20:38.000000', 'consum', 0.0221, 'lps'),
	(618768, 131, '2014-04-01 00:20:39.000000', 'consum', 0.0213, 'lps'),
	(618769, 131, '2014-04-01 00:20:40.000000', 'consum', 0.0211, 'lps'),
	(618770, 131, '2014-04-01 00:20:41.000000', 'consum', 0.0227, 'lps'),
	(618771, 131, '2014-04-01 00:20:42.000000', 'consum', 0.0213, 'lps'),
	(618772, 131, '2014-04-01 00:20:43.000000', 'consum', 0.0216, 'lps'),
	(618773, 131, '2014-04-01 00:20:44.000000', 'consum', 0.0212, 'lps'),
	(618774, 131, '2014-04-01 00:20:45.000000', 'consum', 0.0220, 'lps'),
	(618775, 131, '2014-04-01 00:20:46.000000', 'consum', 0.0217, 'lps'),
	(618776, 131, '2014-04-01 00:20:47.000000', 'consum', 0.0214, 'lps'),
	(618777, 131, '2014-04-01 00:20:48.000000', 'consum', 0.0228, 'lps'),
	(618778, 131, '2014-04-01 00:20:49.000000', 'consum', 0.0212, 'lps'),
	(618779, 131, '2014-04-01 00:20:50.000000', 'consum', 0.0224, 'lps'),
	(618780, 131, '2014-04-01 00:20:51.000000', 'consum', 0.0216, 'lps'),
	(618781, 131, '2014-04-01 00:20:52.000000', 'consum', 0.0219, 'lps'),
	(618782, 131, '2014-04-01 00:20:53.000000', 'consum', 0.0218, 'lps'),
	(618783, 131, '2014-04-01 00:20:54.000000', 'consum', 0.0223, 'lps'),
	(618784, 131, '2014-04-01 00:20:55.000000', 'consum', 0.0211, 'lps'),
	(618785, 131, '2014-04-01 00:20:56.000000', 'consum', 0.0217, 'lps'),
	(618786, 131, '2014-04-01 00:20:57.000000', 'consum', 0.0224, 'lps'),
	(618787, 131, '2014-04-01 00:20:58.000000', 'consum', 0.0218, 'lps'),
	(618788, 131, '2014-04-01 00:20:59.000000', 'consum', 0.0227, 'lps'),
	(618789, 131, '2014-04-01 00:21:00.000000', 'consum', 0.0211, 'lps'),
	(618790, 131, '2014-04-01 00:21:01.000000', 'consum', 0.0226, 'lps'),
	(618791, 131, '2014-04-01 00:21:02.000000', 'consum', 0.0226, 'lps'),
	(618792, 131, '2014-04-01 00:21:03.000000', 'consum', 0.0224, 'lps'),
	(618793, 131, '2014-04-01 00:21:04.000000', 'consum', 0.0213, 'lps'),
	(618794, 131, '2014-04-01 00:21:05.000000', 'consum', 0.0224, 'lps'),
	(618795, 131, '2014-04-01 00:21:06.000000', 'consum', 0.0229, 'lps'),
	(618796, 131, '2014-04-01 00:21:07.000000', 'consum', 0.0224, 'lps'),
	(618797, 131, '2014-04-01 00:21:08.000000', 'consum', 0.0222, 'lps'),
	(618798, 131, '2014-04-01 00:21:09.000000', 'consum', 0.0210, 'lps'),
	(618799, 131, '2014-04-01 00:21:10.000000', 'consum', 0.0215, 'lps'),
	(618800, 131, '2014-04-01 00:21:11.000000', 'consum', 0.0217, 'lps'),
	(618801, 131, '2014-04-01 00:21:12.000000', 'consum', 0.0228, 'lps'),
	(618802, 131, '2014-04-01 00:21:13.000000', 'consum', 0.0220, 'lps'),
	(618803, 131, '2014-04-01 00:21:14.000000', 'consum', 0.0227, 'lps'),
	(618804, 131, '2014-04-01 00:21:15.000000', 'consum', 0.0225, 'lps'),
	(618805, 131, '2014-04-01 00:21:16.000000', 'consum', 0.0215, 'lps'),
	(618806, 131, '2014-04-01 00:21:17.000000', 'consum', 0.0229, 'lps'),
	(618807, 131, '2014-04-01 00:21:18.000000', 'consum', 0.0211, 'lps'),
	(618808, 131, '2014-04-01 00:21:19.000000', 'consum', 0.0218, 'lps'),
	(618809, 131, '2014-04-01 00:21:20.000000', 'consum', 0.0229, 'lps'),
	(618810, 131, '2014-04-01 00:21:21.000000', 'consum', 0.0222, 'lps'),
	(618811, 131, '2014-04-01 00:21:22.000000', 'consum', 0.0212, 'lps'),
	(618812, 131, '2014-04-01 00:21:23.000000', 'consum', 0.0224, 'lps'),
	(618813, 131, '2014-04-01 00:21:24.000000', 'consum', 0.0216, 'lps'),
	(618814, 131, '2014-04-01 00:21:25.000000', 'consum', 0.0217, 'lps'),
	(618815, 131, '2014-04-01 00:21:26.000000', 'consum', 0.0226, 'lps'),
	(618816, 131, '2014-04-01 00:21:27.000000', 'consum', 0.0211, 'lps'),
	(618817, 131, '2014-04-01 00:21:28.000000', 'consum', 0.0229, 'lps'),
	(618818, 131, '2014-04-01 00:21:29.000000', 'consum', 0.0220, 'lps'),
	(618819, 131, '2014-04-01 00:21:30.000000', 'consum', 0.0223, 'lps'),
	(618820, 131, '2014-04-01 00:21:31.000000', 'consum', 0.0228, 'lps'),
	(618821, 131, '2014-04-01 00:21:32.000000', 'consum', 0.0219, 'lps'),
	(618822, 131, '2014-04-01 00:21:33.000000', 'consum', 0.0225, 'lps'),
	(618823, 131, '2014-04-01 00:21:34.000000', 'consum', 0.0215, 'lps'),
	(618824, 131, '2014-04-01 00:21:35.000000', 'consum', 0.0210, 'lps'),
	(618825, 131, '2014-04-01 00:21:36.000000', 'consum', 0.0218, 'lps'),
	(618826, 131, '2014-04-01 00:21:37.000000', 'consum', 0.0229, 'lps'),
	(618827, 131, '2014-04-01 00:21:38.000000', 'consum', 0.0224, 'lps'),
	(618828, 131, '2014-04-01 00:21:39.000000', 'consum', 0.0221, 'lps'),
	(618829, 131, '2014-04-01 00:21:40.000000', 'consum', 0.0224, 'lps'),
	(618830, 131, '2014-04-01 00:21:41.000000', 'consum', 0.0226, 'lps'),
	(618831, 131, '2014-04-01 00:21:42.000000', 'consum', 0.0229, 'lps'),
	(618832, 131, '2014-04-01 00:21:43.000000', 'consum', 0.0220, 'lps'),
	(618833, 131, '2014-04-01 00:21:44.000000', 'consum', 0.0222, 'lps'),
	(618834, 131, '2014-04-01 00:21:45.000000', 'consum', 0.0222, 'lps'),
	(618835, 131, '2014-04-01 00:21:46.000000', 'consum', 0.0212, 'lps'),
	(618836, 131, '2014-04-01 00:21:47.000000', 'consum', 0.0227, 'lps'),
	(618837, 131, '2014-04-01 00:21:48.000000', 'consum', 0.0228, 'lps'),
	(618838, 131, '2014-04-01 00:21:49.000000', 'consum', 0.0212, 'lps'),
	(618839, 131, '2014-04-01 00:21:50.000000', 'consum', 0.0223, 'lps'),
	(618840, 131, '2014-04-01 00:21:51.000000', 'consum', 0.0212, 'lps'),
	(618841, 131, '2014-04-01 00:21:52.000000', 'consum', 0.0222, 'lps'),
	(618842, 131, '2014-04-01 00:21:53.000000', 'consum', 0.0223, 'lps'),
	(618843, 131, '2014-04-01 00:21:54.000000', 'consum', 0.0221, 'lps'),
	(618844, 131, '2014-04-01 00:21:55.000000', 'consum', 0.0227, 'lps'),
	(618845, 131, '2014-04-01 00:21:56.000000', 'consum', 0.0220, 'lps'),
	(618846, 131, '2014-04-01 00:21:57.000000', 'consum', 0.0229, 'lps'),
	(618847, 131, '2014-04-01 00:21:58.000000', 'consum', 0.0218, 'lps'),
	(618848, 131, '2014-04-01 00:21:59.000000', 'consum', 0.0213, 'lps'),
	(618849, 131, '2014-04-01 00:22:00.000000', 'consum', 0.0220, 'lps'),
	(618850, 131, '2014-04-01 00:22:01.000000', 'consum', 0.0212, 'lps'),
	(618851, 131, '2014-04-01 00:22:02.000000', 'consum', 0.0212, 'lps'),
	(618852, 131, '2014-04-01 00:22:03.000000', 'consum', 0.0215, 'lps'),
	(618853, 131, '2014-04-01 00:22:04.000000', 'consum', 0.0228, 'lps'),
	(618854, 131, '2014-04-01 00:22:05.000000', 'consum', 0.0225, 'lps'),
	(618855, 131, '2014-04-01 00:22:06.000000', 'consum', 0.0212, 'lps'),
	(618856, 131, '2014-04-01 00:22:07.000000', 'consum', 0.0216, 'lps'),
	(618857, 131, '2014-04-01 00:22:08.000000', 'consum', 0.0213, 'lps'),
	(618858, 131, '2014-04-01 00:22:09.000000', 'consum', 0.0228, 'lps'),
	(618859, 131, '2014-04-01 00:22:10.000000', 'consum', 0.0212, 'lps'),
	(618860, 131, '2014-04-01 00:22:11.000000', 'consum', 0.0225, 'lps'),
	(618861, 131, '2014-04-01 00:22:12.000000', 'consum', 0.0219, 'lps'),
	(618862, 131, '2014-04-01 00:22:13.000000', 'consum', 0.0212, 'lps'),
	(618863, 131, '2014-04-01 00:22:14.000000', 'consum', 0.0214, 'lps'),
	(618864, 131, '2014-04-01 00:22:15.000000', 'consum', 0.0222, 'lps'),
	(618865, 131, '2014-04-01 00:22:16.000000', 'consum', 0.0222, 'lps'),
	(618866, 131, '2014-04-01 00:22:17.000000', 'consum', 0.0211, 'lps'),
	(618867, 131, '2014-04-01 00:22:18.000000', 'consum', 0.0223, 'lps'),
	(618868, 131, '2014-04-01 00:22:19.000000', 'consum', 0.0211, 'lps'),
	(618869, 131, '2014-04-01 00:22:20.000000', 'consum', 0.0217, 'lps'),
	(618870, 131, '2014-04-01 00:22:21.000000', 'consum', 0.0221, 'lps'),
	(618871, 131, '2014-04-01 00:22:22.000000', 'consum', 0.0225, 'lps'),
	(618872, 131, '2014-04-01 00:22:23.000000', 'consum', 0.0214, 'lps'),
	(618873, 131, '2014-04-01 00:22:24.000000', 'consum', 0.0223, 'lps'),
	(618874, 131, '2014-04-01 00:22:25.000000', 'consum', 0.0226, 'lps'),
	(618875, 131, '2014-04-01 00:22:26.000000', 'consum', 0.0211, 'lps'),
	(618876, 131, '2014-04-01 00:22:27.000000', 'consum', 0.0228, 'lps'),
	(618877, 131, '2014-04-01 00:22:28.000000', 'consum', 0.0217, 'lps'),
	(618878, 131, '2014-04-01 00:22:29.000000', 'consum', 0.0210, 'lps'),
	(618879, 131, '2014-04-01 00:22:30.000000', 'consum', 0.0211, 'lps'),
	(618880, 131, '2014-04-01 00:22:31.000000', 'consum', 0.0217, 'lps'),
	(618881, 131, '2014-04-01 00:22:32.000000', 'consum', 0.0219, 'lps'),
	(618882, 131, '2014-04-01 00:22:33.000000', 'consum', 0.0217, 'lps'),
	(618883, 131, '2014-04-01 00:22:34.000000', 'consum', 0.0220, 'lps'),
	(618884, 131, '2014-04-01 00:22:35.000000', 'consum', 0.0216, 'lps'),
	(618885, 131, '2014-04-01 00:22:36.000000', 'consum', 0.0211, 'lps'),
	(618886, 131, '2014-04-01 00:22:37.000000', 'consum', 0.0219, 'lps'),
	(618887, 131, '2014-04-01 00:22:38.000000', 'consum', 0.0212, 'lps'),
	(618888, 131, '2014-04-01 00:22:39.000000', 'consum', 0.0214, 'lps'),
	(618889, 131, '2014-04-01 00:22:40.000000', 'consum', 0.0226, 'lps'),
	(618890, 131, '2014-04-01 00:22:41.000000', 'consum', 0.0216, 'lps'),
	(618891, 131, '2014-04-01 00:22:42.000000', 'consum', 0.0213, 'lps'),
	(618892, 131, '2014-04-01 00:22:43.000000', 'consum', 0.0210, 'lps'),
	(618893, 131, '2014-04-01 00:22:44.000000', 'consum', 0.0219, 'lps'),
	(618894, 131, '2014-04-01 00:22:45.000000', 'consum', 0.0217, 'lps'),
	(618895, 131, '2014-04-01 00:22:46.000000', 'consum', 0.0219, 'lps'),
	(618896, 131, '2014-04-01 00:22:47.000000', 'consum', 0.0214, 'lps'),
	(618897, 131, '2014-04-01 00:22:48.000000', 'consum', 0.0222, 'lps'),
	(618898, 131, '2014-04-01 00:22:49.000000', 'consum', 0.0219, 'lps'),
	(618899, 131, '2014-04-01 00:22:50.000000', 'consum', 0.0221, 'lps'),
	(618900, 131, '2014-04-01 00:22:51.000000', 'consum', 0.0218, 'lps'),
	(618901, 131, '2014-04-01 00:22:52.000000', 'consum', 0.0219, 'lps'),
	(618902, 131, '2014-04-01 00:22:53.000000', 'consum', 0.0212, 'lps'),
	(618903, 131, '2014-04-01 00:22:54.000000', 'consum', 0.0212, 'lps'),
	(618904, 131, '2014-04-01 00:22:55.000000', 'consum', 0.0213, 'lps'),
	(618905, 131, '2014-04-01 00:22:56.000000', 'consum', 0.0219, 'lps'),
	(618906, 131, '2014-04-01 00:22:57.000000', 'consum', 0.0229, 'lps'),
	(618907, 131, '2014-04-01 00:22:58.000000', 'consum', 0.0218, 'lps'),
	(618908, 131, '2014-04-01 00:22:59.000000', 'consum', 0.0215, 'lps'),
	(618909, 131, '2014-04-01 00:23:00.000000', 'consum', 0.0210, 'lps'),
	(618910, 131, '2014-04-01 00:23:01.000000', 'consum', 0.0216, 'lps'),
	(618911, 131, '2014-04-01 00:23:02.000000', 'consum', 0.0221, 'lps'),
	(618912, 131, '2014-04-01 00:23:03.000000', 'consum', 0.0226, 'lps'),
	(618913, 131, '2014-04-01 00:23:04.000000', 'consum', 0.0220, 'lps'),
	(618914, 131, '2014-04-01 00:23:05.000000', 'consum', 0.0211, 'lps'),
	(618915, 131, '2014-04-01 00:23:06.000000', 'consum', 0.0224, 'lps'),
	(618916, 131, '2014-04-01 00:23:07.000000', 'consum', 0.0217, 'lps'),
	(618917, 131, '2014-04-01 00:23:08.000000', 'consum', 0.0223, 'lps'),
	(618918, 131, '2014-04-01 00:23:09.000000', 'consum', 0.0217, 'lps'),
	(618919, 131, '2014-04-01 00:23:10.000000', 'consum', 0.0227, 'lps'),
	(618920, 131, '2014-04-01 00:23:11.000000', 'consum', 0.0212, 'lps'),
	(618921, 131, '2014-04-01 00:23:12.000000', 'consum', 0.0210, 'lps'),
	(618922, 131, '2014-04-01 00:23:13.000000', 'consum', 0.0223, 'lps'),
	(618923, 131, '2014-04-01 00:23:14.000000', 'consum', 0.0219, 'lps'),
	(618924, 131, '2014-04-01 00:23:15.000000', 'consum', 0.0214, 'lps'),
	(618925, 131, '2014-04-01 00:23:16.000000', 'consum', 0.0224, 'lps'),
	(618926, 131, '2014-04-01 00:23:17.000000', 'consum', 0.0227, 'lps'),
	(618927, 131, '2014-04-01 00:23:18.000000', 'consum', 0.0214, 'lps'),
	(618928, 131, '2014-04-01 00:23:19.000000', 'consum', 0.0218, 'lps'),
	(618929, 131, '2014-04-01 00:23:20.000000', 'consum', 0.0219, 'lps'),
	(618930, 131, '2014-04-01 00:23:21.000000', 'consum', 0.0212, 'lps'),
	(618931, 131, '2014-04-01 00:23:22.000000', 'consum', 0.0214, 'lps'),
	(618932, 131, '2014-04-01 00:23:23.000000', 'consum', 0.0223, 'lps'),
	(618933, 131, '2014-04-01 00:23:24.000000', 'consum', 0.0223, 'lps'),
	(618934, 131, '2014-04-01 00:23:25.000000', 'consum', 0.0216, 'lps'),
	(618935, 131, '2014-04-01 00:23:26.000000', 'consum', 0.0222, 'lps'),
	(618936, 131, '2014-04-01 00:23:27.000000', 'consum', 0.0214, 'lps'),
	(618937, 131, '2014-04-01 00:23:28.000000', 'consum', 0.0216, 'lps'),
	(618938, 131, '2014-04-01 00:23:29.000000', 'consum', 0.0226, 'lps'),
	(618939, 131, '2014-04-01 00:23:30.000000', 'consum', 0.0213, 'lps'),
	(618940, 131, '2014-04-01 00:23:31.000000', 'consum', 0.0218, 'lps'),
	(618941, 131, '2014-04-01 00:23:32.000000', 'consum', 0.0220, 'lps'),
	(618942, 131, '2014-04-01 00:23:33.000000', 'consum', 0.0217, 'lps'),
	(618943, 131, '2014-04-01 00:23:34.000000', 'consum', 0.0217, 'lps'),
	(618944, 131, '2014-04-01 00:23:35.000000', 'consum', 0.0222, 'lps'),
	(618945, 131, '2014-04-01 00:23:36.000000', 'consum', 0.0213, 'lps'),
	(618946, 131, '2014-04-01 00:23:37.000000', 'consum', 0.0226, 'lps'),
	(618947, 131, '2014-04-01 00:23:38.000000', 'consum', 0.0223, 'lps'),
	(618948, 131, '2014-04-01 00:23:39.000000', 'consum', 0.0226, 'lps'),
	(618949, 131, '2014-04-01 00:23:40.000000', 'consum', 0.0211, 'lps'),
	(618950, 131, '2014-04-01 00:23:41.000000', 'consum', 0.0228, 'lps'),
	(618951, 131, '2014-04-01 00:23:42.000000', 'consum', 0.0220, 'lps'),
	(618952, 131, '2014-04-01 00:23:43.000000', 'consum', 0.0224, 'lps'),
	(618953, 131, '2014-04-01 00:23:44.000000', 'consum', 0.0213, 'lps'),
	(618954, 131, '2014-04-01 00:23:45.000000', 'consum', 0.0224, 'lps'),
	(618955, 131, '2014-04-01 00:23:46.000000', 'consum', 0.0229, 'lps'),
	(618956, 131, '2014-04-01 00:23:47.000000', 'consum', 0.0223, 'lps'),
	(618957, 131, '2014-04-01 00:23:48.000000', 'consum', 0.0220, 'lps'),
	(618958, 131, '2014-04-01 00:23:49.000000', 'consum', 0.0223, 'lps'),
	(618959, 131, '2014-04-01 00:23:50.000000', 'consum', 0.0225, 'lps'),
	(618960, 131, '2014-04-01 00:23:51.000000', 'consum', 0.0227, 'lps'),
	(618961, 131, '2014-04-01 00:23:52.000000', 'consum', 0.0228, 'lps'),
	(618962, 131, '2014-04-01 00:23:53.000000', 'consum', 0.0210, 'lps'),
	(618963, 131, '2014-04-01 00:23:54.000000', 'consum', 0.0217, 'lps'),
	(618964, 131, '2014-04-01 00:23:55.000000', 'consum', 0.0223, 'lps'),
	(618965, 131, '2014-04-01 00:23:56.000000', 'consum', 0.0218, 'lps'),
	(618966, 131, '2014-04-01 00:23:57.000000', 'consum', 0.0211, 'lps'),
	(618967, 131, '2014-04-01 00:23:58.000000', 'consum', 0.0229, 'lps'),
	(618968, 131, '2014-04-01 00:23:59.000000', 'consum', 0.0224, 'lps'),
	(618969, 131, '2014-04-01 00:24:00.000000', 'consum', 0.0222, 'lps'),
	(618970, 131, '2014-04-01 00:24:01.000000', 'consum', 0.0211, 'lps'),
	(618971, 131, '2014-04-01 00:24:02.000000', 'consum', 0.0220, 'lps'),
	(618972, 131, '2014-04-01 00:24:03.000000', 'consum', 0.0217, 'lps'),
	(618973, 131, '2014-04-01 00:24:04.000000', 'consum', 0.0213, 'lps'),
	(618974, 131, '2014-04-01 00:24:05.000000', 'consum', 0.0228, 'lps'),
	(618975, 131, '2014-04-01 00:24:06.000000', 'consum', 0.0228, 'lps'),
	(618976, 131, '2014-04-01 00:24:07.000000', 'consum', 0.0228, 'lps'),
	(618977, 131, '2014-04-01 00:24:08.000000', 'consum', 0.0227, 'lps'),
	(618978, 131, '2014-04-01 00:24:09.000000', 'consum', 0.0220, 'lps'),
	(618979, 131, '2014-04-01 00:24:10.000000', 'consum', 0.0211, 'lps'),
	(618980, 131, '2014-04-01 00:24:11.000000', 'consum', 0.0224, 'lps'),
	(618981, 131, '2014-04-01 00:24:12.000000', 'consum', 0.0219, 'lps'),
	(618982, 131, '2014-04-01 00:24:13.000000', 'consum', 0.0212, 'lps'),
	(618983, 131, '2014-04-01 00:24:14.000000', 'consum', 0.0216, 'lps'),
	(618984, 131, '2014-04-01 00:24:15.000000', 'consum', 0.0214, 'lps'),
	(618985, 131, '2014-04-01 00:24:16.000000', 'consum', 0.0214, 'lps'),
	(618986, 131, '2014-04-01 00:24:17.000000', 'consum', 0.0216, 'lps'),
	(618987, 131, '2014-04-01 00:24:18.000000', 'consum', 0.0211, 'lps'),
	(618988, 131, '2014-04-01 00:24:19.000000', 'consum', 0.0218, 'lps'),
	(618989, 131, '2014-04-01 00:24:20.000000', 'consum', 0.0225, 'lps'),
	(618990, 131, '2014-04-01 00:24:21.000000', 'consum', 0.0221, 'lps'),
	(618991, 131, '2014-04-01 00:24:22.000000', 'consum', 0.0221, 'lps'),
	(618992, 131, '2014-04-01 00:24:23.000000', 'consum', 0.0212, 'lps'),
	(618993, 131, '2014-04-01 00:24:24.000000', 'consum', 0.0227, 'lps'),
	(618994, 131, '2014-04-01 00:24:25.000000', 'consum', 0.0212, 'lps'),
	(618995, 131, '2014-04-01 00:24:26.000000', 'consum', 0.0226, 'lps'),
	(618996, 131, '2014-04-01 00:24:27.000000', 'consum', 0.0227, 'lps'),
	(618997, 131, '2014-04-01 00:24:28.000000', 'consum', 0.0228, 'lps'),
	(618998, 131, '2014-04-01 00:24:29.000000', 'consum', 0.0229, 'lps'),
	(618999, 131, '2014-04-01 00:24:30.000000', 'consum', 0.0211, 'lps'),
	(619000, 131, '2014-04-01 00:24:31.000000', 'consum', 0.0218, 'lps'),
	(619001, 131, '2014-04-01 00:24:32.000000', 'consum', 0.0227, 'lps'),
	(619002, 131, '2014-04-01 00:24:33.000000', 'consum', 0.0211, 'lps'),
	(619003, 131, '2014-04-01 00:24:34.000000', 'consum', 0.0226, 'lps'),
	(619004, 131, '2014-04-01 00:24:35.000000', 'consum', 0.0226, 'lps'),
	(619005, 131, '2014-04-01 00:24:36.000000', 'consum', 0.0224, 'lps'),
	(619006, 131, '2014-04-01 00:24:37.000000', 'consum', 0.0211, 'lps'),
	(619007, 131, '2014-04-01 00:24:38.000000', 'consum', 0.0214, 'lps'),
	(619008, 131, '2014-04-01 00:24:39.000000', 'consum', 0.0227, 'lps'),
	(619009, 131, '2014-04-01 00:24:40.000000', 'consum', 0.0226, 'lps'),
	(619010, 131, '2014-04-01 00:24:41.000000', 'consum', 0.0217, 'lps'),
	(619011, 131, '2014-04-01 00:24:42.000000', 'consum', 0.0220, 'lps'),
	(619012, 131, '2014-04-01 00:24:43.000000', 'consum', 0.0218, 'lps'),
	(619013, 131, '2014-04-01 00:24:44.000000', 'consum', 0.0219, 'lps'),
	(619014, 131, '2014-04-01 00:24:45.000000', 'consum', 0.0211, 'lps'),
	(619015, 131, '2014-04-01 00:24:46.000000', 'consum', 0.0211, 'lps'),
	(619016, 131, '2014-04-01 00:24:47.000000', 'consum', 0.0210, 'lps'),
	(619017, 131, '2014-04-01 00:24:48.000000', 'consum', 0.0228, 'lps'),
	(619018, 131, '2014-04-01 00:24:49.000000', 'consum', 0.0219, 'lps'),
	(619019, 131, '2014-04-01 00:24:50.000000', 'consum', 0.0225, 'lps'),
	(619020, 131, '2014-04-01 00:24:51.000000', 'consum', 0.0215, 'lps'),
	(619021, 131, '2014-04-01 00:24:52.000000', 'consum', 0.0213, 'lps'),
	(619022, 131, '2014-04-01 00:24:53.000000', 'consum', 0.0211, 'lps'),
	(619023, 131, '2014-04-01 00:24:54.000000', 'consum', 0.0225, 'lps'),
	(619024, 131, '2014-04-01 00:24:55.000000', 'consum', 0.0224, 'lps'),
	(619025, 131, '2014-04-01 00:24:56.000000', 'consum', 0.0213, 'lps'),
	(619026, 131, '2014-04-01 00:24:57.000000', 'consum', 0.0223, 'lps'),
	(619027, 131, '2014-04-01 00:24:58.000000', 'consum', 0.0229, 'lps'),
	(619028, 131, '2014-04-01 00:24:59.000000', 'consum', 0.0224, 'lps'),
	(619029, 131, '2014-04-01 00:25:00.000000', 'consum', 0.0226, 'lps'),
	(619030, 131, '2014-04-01 00:25:01.000000', 'consum', 0.0226, 'lps'),
	(619031, 131, '2014-04-01 00:25:02.000000', 'consum', 0.0223, 'lps'),
	(619032, 131, '2014-04-01 00:25:03.000000', 'consum', 0.0227, 'lps'),
	(619033, 131, '2014-04-01 00:25:04.000000', 'consum', 0.0216, 'lps'),
	(619034, 131, '2014-04-01 00:25:05.000000', 'consum', 0.0212, 'lps'),
	(619035, 131, '2014-04-01 00:25:06.000000', 'consum', 0.0220, 'lps'),
	(619036, 131, '2014-04-01 00:25:07.000000', 'consum', 0.0215, 'lps'),
	(619037, 131, '2014-04-01 00:25:08.000000', 'consum', 0.0227, 'lps'),
	(619038, 131, '2014-04-01 00:25:09.000000', 'consum', 0.0219, 'lps'),
	(619039, 131, '2014-04-01 00:25:10.000000', 'consum', 0.0223, 'lps'),
	(619040, 131, '2014-04-01 00:25:11.000000', 'consum', 0.0229, 'lps'),
	(619041, 131, '2014-04-01 00:25:12.000000', 'consum', 0.0228, 'lps'),
	(619042, 131, '2014-04-01 00:25:13.000000', 'consum', 0.0224, 'lps'),
	(619043, 131, '2014-04-01 00:25:14.000000', 'consum', 0.0226, 'lps'),
	(619044, 131, '2014-04-01 00:25:15.000000', 'consum', 0.0228, 'lps'),
	(619045, 131, '2014-04-01 00:25:16.000000', 'consum', 0.0213, 'lps'),
	(619046, 131, '2014-04-01 00:25:17.000000', 'consum', 0.0213, 'lps'),
	(619047, 131, '2014-04-01 00:25:18.000000', 'consum', 0.0214, 'lps'),
	(619048, 131, '2014-04-01 00:25:19.000000', 'consum', 0.0220, 'lps'),
	(619049, 131, '2014-04-01 00:25:20.000000', 'consum', 0.0212, 'lps'),
	(619050, 131, '2014-04-01 00:25:21.000000', 'consum', 0.0210, 'lps'),
	(619051, 131, '2014-04-01 00:25:22.000000', 'consum', 0.0223, 'lps'),
	(619052, 131, '2014-04-01 00:25:23.000000', 'consum', 0.0217, 'lps'),
	(619053, 131, '2014-04-01 00:25:24.000000', 'consum', 0.0225, 'lps'),
	(619054, 131, '2014-04-01 00:25:25.000000', 'consum', 0.0224, 'lps'),
	(619055, 131, '2014-04-01 00:25:26.000000', 'consum', 0.0216, 'lps'),
	(619056, 131, '2014-04-01 00:25:27.000000', 'consum', 0.0219, 'lps'),
	(619057, 131, '2014-04-01 00:25:28.000000', 'consum', 0.0216, 'lps'),
	(619058, 131, '2014-04-01 00:25:29.000000', 'consum', 0.0214, 'lps'),
	(619059, 131, '2014-04-01 00:25:30.000000', 'consum', 0.0214, 'lps'),
	(619060, 131, '2014-04-01 00:25:31.000000', 'consum', 0.0216, 'lps'),
	(619061, 131, '2014-04-01 00:25:32.000000', 'consum', 0.0229, 'lps'),
	(619062, 131, '2014-04-01 00:25:33.000000', 'consum', 0.0227, 'lps'),
	(619063, 131, '2014-04-01 00:25:34.000000', 'consum', 0.0220, 'lps'),
	(619064, 131, '2014-04-01 00:25:35.000000', 'consum', 0.0229, 'lps'),
	(619065, 131, '2014-04-01 00:25:36.000000', 'consum', 0.0214, 'lps'),
	(619066, 131, '2014-04-01 00:25:37.000000', 'consum', 0.0213, 'lps'),
	(619067, 131, '2014-04-01 00:25:38.000000', 'consum', 0.0213, 'lps'),
	(619068, 131, '2014-04-01 00:25:39.000000', 'consum', 0.0218, 'lps'),
	(619069, 131, '2014-04-01 00:25:40.000000', 'consum', 0.0222, 'lps'),
	(619070, 131, '2014-04-01 00:25:41.000000', 'consum', 0.0224, 'lps'),
	(619071, 131, '2014-04-01 00:25:42.000000', 'consum', 0.0225, 'lps'),
	(619072, 131, '2014-04-01 00:25:43.000000', 'consum', 0.0225, 'lps'),
	(619073, 131, '2014-04-01 00:25:44.000000', 'consum', 0.0221, 'lps'),
	(619074, 131, '2014-04-01 00:25:45.000000', 'consum', 0.0220, 'lps'),
	(619075, 131, '2014-04-01 00:25:46.000000', 'consum', 0.0226, 'lps'),
	(619076, 131, '2014-04-01 00:25:47.000000', 'consum', 0.0220, 'lps'),
	(619077, 131, '2014-04-01 00:25:48.000000', 'consum', 0.0212, 'lps'),
	(619078, 131, '2014-04-01 00:25:49.000000', 'consum', 0.0212, 'lps'),
	(619079, 131, '2014-04-01 00:25:50.000000', 'consum', 0.0216, 'lps'),
	(619080, 131, '2014-04-01 00:25:51.000000', 'consum', 0.0215, 'lps'),
	(619081, 131, '2014-04-01 00:25:52.000000', 'consum', 0.0215, 'lps'),
	(619082, 131, '2014-04-01 00:25:53.000000', 'consum', 0.0220, 'lps'),
	(619083, 131, '2014-04-01 00:25:54.000000', 'consum', 0.0225, 'lps'),
	(619084, 131, '2014-04-01 00:25:55.000000', 'consum', 0.0214, 'lps'),
	(619085, 131, '2014-04-01 00:25:56.000000', 'consum', 0.0229, 'lps'),
	(619086, 131, '2014-04-01 00:25:57.000000', 'consum', 0.0213, 'lps'),
	(619087, 131, '2014-04-01 00:25:58.000000', 'consum', 0.0227, 'lps'),
	(619088, 131, '2014-04-01 00:25:59.000000', 'consum', 0.0226, 'lps'),
	(619089, 131, '2014-04-01 00:26:00.000000', 'consum', 0.0222, 'lps'),
	(619090, 131, '2014-04-01 00:26:01.000000', 'consum', 0.0222, 'lps'),
	(619091, 131, '2014-04-01 00:26:02.000000', 'consum', 0.0213, 'lps'),
	(619092, 131, '2014-04-01 00:26:03.000000', 'consum', 0.0212, 'lps'),
	(619093, 131, '2014-04-01 00:26:04.000000', 'consum', 0.0228, 'lps'),
	(619094, 131, '2014-04-01 00:26:05.000000', 'consum', 0.0218, 'lps'),
	(619095, 131, '2014-04-01 00:26:06.000000', 'consum', 0.0216, 'lps'),
	(619096, 131, '2014-04-01 00:26:07.000000', 'consum', 0.0216, 'lps'),
	(619097, 131, '2014-04-01 00:26:08.000000', 'consum', 0.0222, 'lps'),
	(619098, 131, '2014-04-01 00:26:09.000000', 'consum', 0.0213, 'lps'),
	(619099, 131, '2014-04-01 00:26:10.000000', 'consum', 0.0228, 'lps'),
	(619100, 131, '2014-04-01 00:26:11.000000', 'consum', 0.0214, 'lps'),
	(619101, 131, '2014-04-01 00:26:12.000000', 'consum', 0.0215, 'lps'),
	(619102, 131, '2014-04-01 00:26:13.000000', 'consum', 0.0223, 'lps'),
	(619103, 131, '2014-04-01 00:26:14.000000', 'consum', 0.0221, 'lps'),
	(619104, 131, '2014-04-01 00:26:15.000000', 'consum', 0.0226, 'lps'),
	(619105, 131, '2014-04-01 00:26:16.000000', 'consum', 0.0219, 'lps'),
	(619106, 131, '2014-04-01 00:26:17.000000', 'consum', 0.0229, 'lps'),
	(619107, 131, '2014-04-01 00:26:18.000000', 'consum', 0.0215, 'lps'),
	(619108, 131, '2014-04-01 00:26:19.000000', 'consum', 0.0219, 'lps'),
	(619109, 131, '2014-04-01 00:26:20.000000', 'consum', 0.0220, 'lps'),
	(619110, 131, '2014-04-01 00:26:21.000000', 'consum', 0.0216, 'lps'),
	(619111, 131, '2014-04-01 00:26:22.000000', 'consum', 0.0228, 'lps'),
	(619112, 131, '2014-04-01 00:26:23.000000', 'consum', 0.0223, 'lps'),
	(619113, 131, '2014-04-01 00:26:24.000000', 'consum', 0.0223, 'lps'),
	(619114, 131, '2014-04-01 00:26:25.000000', 'consum', 0.0214, 'lps'),
	(619115, 131, '2014-04-01 00:26:26.000000', 'consum', 0.0214, 'lps'),
	(619116, 131, '2014-04-01 00:26:27.000000', 'consum', 0.0216, 'lps'),
	(619117, 131, '2014-04-01 00:26:28.000000', 'consum', 0.0229, 'lps'),
	(619118, 131, '2014-04-01 00:26:29.000000', 'consum', 0.0228, 'lps'),
	(619119, 131, '2014-04-01 00:26:30.000000', 'consum', 0.0222, 'lps'),
	(619120, 131, '2014-04-01 00:26:31.000000', 'consum', 0.0217, 'lps'),
	(619121, 131, '2014-04-01 00:26:32.000000', 'consum', 0.0210, 'lps'),
	(619122, 131, '2014-04-01 00:26:33.000000', 'consum', 0.0228, 'lps'),
	(619123, 131, '2014-04-01 00:26:34.000000', 'consum', 0.0220, 'lps'),
	(619124, 131, '2014-04-01 00:26:35.000000', 'consum', 0.0229, 'lps'),
	(619125, 131, '2014-04-01 00:26:36.000000', 'consum', 0.0214, 'lps'),
	(619126, 131, '2014-04-01 00:26:37.000000', 'consum', 0.0213, 'lps'),
	(619127, 131, '2014-04-01 00:26:38.000000', 'consum', 0.0213, 'lps'),
	(619128, 131, '2014-04-01 00:26:39.000000', 'consum', 0.0215, 'lps'),
	(619129, 131, '2014-04-01 00:26:40.000000', 'consum', 0.0229, 'lps'),
	(619130, 131, '2014-04-01 00:26:41.000000', 'consum', 0.0210, 'lps'),
	(619131, 131, '2014-04-01 00:26:42.000000', 'consum', 0.0212, 'lps'),
	(619132, 131, '2014-04-01 00:26:43.000000', 'consum', 0.0220, 'lps'),
	(619133, 131, '2014-04-01 00:26:44.000000', 'consum', 0.0214, 'lps'),
	(619134, 131, '2014-04-01 00:26:45.000000', 'consum', 0.0221, 'lps'),
	(619135, 131, '2014-04-01 00:26:46.000000', 'consum', 0.0212, 'lps'),
	(619136, 131, '2014-04-01 00:26:47.000000', 'consum', 0.0210, 'lps'),
	(619137, 131, '2014-04-01 00:26:48.000000', 'consum', 0.0225, 'lps'),
	(619138, 131, '2014-04-01 00:26:49.000000', 'consum', 0.0223, 'lps'),
	(619139, 131, '2014-04-01 00:26:50.000000', 'consum', 0.0214, 'lps'),
	(619140, 131, '2014-04-01 00:26:51.000000', 'consum', 0.0228, 'lps'),
	(619141, 131, '2014-04-01 00:26:52.000000', 'consum', 0.0210, 'lps'),
	(619142, 131, '2014-04-01 00:26:53.000000', 'consum', 0.0217, 'lps'),
	(619143, 131, '2014-04-01 00:26:54.000000', 'consum', 0.0226, 'lps'),
	(619144, 131, '2014-04-01 00:26:55.000000', 'consum', 0.0227, 'lps'),
	(619145, 131, '2014-04-01 00:26:56.000000', 'consum', 0.0210, 'lps'),
	(619146, 131, '2014-04-01 00:26:57.000000', 'consum', 0.0220, 'lps'),
	(619147, 131, '2014-04-01 00:26:58.000000', 'consum', 0.0220, 'lps'),
	(619148, 131, '2014-04-01 00:26:59.000000', 'consum', 0.0229, 'lps'),
	(619149, 131, '2014-04-01 00:27:00.000000', 'consum', 0.0214, 'lps'),
	(619150, 131, '2014-04-01 00:27:01.000000', 'consum', 0.0217, 'lps'),
	(619151, 131, '2014-04-01 00:27:02.000000', 'consum', 0.0211, 'lps'),
	(619152, 131, '2014-04-01 00:27:03.000000', 'consum', 0.0214, 'lps'),
	(619153, 131, '2014-04-01 00:27:04.000000', 'consum', 0.0211, 'lps'),
	(619154, 131, '2014-04-01 00:27:05.000000', 'consum', 0.0220, 'lps'),
	(619155, 131, '2014-04-01 00:27:06.000000', 'consum', 0.0218, 'lps'),
	(619156, 131, '2014-04-01 00:27:07.000000', 'consum', 0.0221, 'lps'),
	(619157, 131, '2014-04-01 00:27:08.000000', 'consum', 0.0222, 'lps'),
	(619158, 131, '2014-04-01 00:27:09.000000', 'consum', 0.0216, 'lps'),
	(619159, 131, '2014-04-01 00:27:10.000000', 'consum', 0.0227, 'lps'),
	(619160, 131, '2014-04-01 00:27:11.000000', 'consum', 0.0215, 'lps'),
	(619161, 131, '2014-04-01 00:27:12.000000', 'consum', 0.0225, 'lps'),
	(619162, 131, '2014-04-01 00:27:13.000000', 'consum', 0.0210, 'lps'),
	(619163, 131, '2014-04-01 00:27:14.000000', 'consum', 0.0225, 'lps'),
	(619164, 131, '2014-04-01 00:27:15.000000', 'consum', 0.0226, 'lps'),
	(619165, 131, '2014-04-01 00:27:16.000000', 'consum', 0.0224, 'lps'),
	(619166, 131, '2014-04-01 00:27:17.000000', 'consum', 0.0212, 'lps'),
	(619167, 131, '2014-04-01 00:27:18.000000', 'consum', 0.0219, 'lps'),
	(619168, 131, '2014-04-01 00:27:19.000000', 'consum', 0.0211, 'lps'),
	(619169, 131, '2014-04-01 00:27:20.000000', 'consum', 0.0229, 'lps'),
	(619170, 131, '2014-04-01 00:27:21.000000', 'consum', 0.0223, 'lps'),
	(619171, 131, '2014-04-01 00:27:22.000000', 'consum', 0.0219, 'lps'),
	(619172, 131, '2014-04-01 00:27:23.000000', 'consum', 0.0215, 'lps'),
	(619173, 131, '2014-04-01 00:27:24.000000', 'consum', 0.0210, 'lps'),
	(619174, 131, '2014-04-01 00:27:25.000000', 'consum', 0.0215, 'lps'),
	(619175, 131, '2014-04-01 00:27:26.000000', 'consum', 0.0215, 'lps'),
	(619176, 131, '2014-04-01 00:27:27.000000', 'consum', 0.0222, 'lps'),
	(619177, 131, '2014-04-01 00:27:28.000000', 'consum', 0.0215, 'lps'),
	(619178, 131, '2014-04-01 00:27:29.000000', 'consum', 0.0219, 'lps'),
	(619179, 131, '2014-04-01 00:27:30.000000', 'consum', 0.0221, 'lps'),
	(619180, 131, '2014-04-01 00:27:31.000000', 'consum', 0.0216, 'lps'),
	(619181, 131, '2014-04-01 00:27:32.000000', 'consum', 0.0211, 'lps'),
	(619182, 131, '2014-04-01 00:27:33.000000', 'consum', 0.0214, 'lps'),
	(619183, 131, '2014-04-01 00:27:34.000000', 'consum', 0.0210, 'lps'),
	(619184, 131, '2014-04-01 00:27:35.000000', 'consum', 0.0216, 'lps'),
	(619185, 131, '2014-04-01 00:27:36.000000', 'consum', 0.0223, 'lps'),
	(619186, 131, '2014-04-01 00:27:37.000000', 'consum', 0.0216, 'lps'),
	(619187, 131, '2014-04-01 00:27:38.000000', 'consum', 0.0222, 'lps'),
	(619188, 131, '2014-04-01 00:27:39.000000', 'consum', 0.0212, 'lps'),
	(619189, 131, '2014-04-01 00:27:40.000000', 'consum', 0.0226, 'lps'),
	(619190, 131, '2014-04-01 00:27:41.000000', 'consum', 0.0223, 'lps'),
	(619191, 131, '2014-04-01 00:27:42.000000', 'consum', 0.0210, 'lps'),
	(619192, 131, '2014-04-01 00:27:43.000000', 'consum', 0.0229, 'lps'),
	(619193, 131, '2014-04-01 00:27:44.000000', 'consum', 0.0226, 'lps'),
	(619194, 131, '2014-04-01 00:27:45.000000', 'consum', 0.0215, 'lps'),
	(619195, 131, '2014-04-01 00:27:46.000000', 'consum', 0.0225, 'lps'),
	(619196, 131, '2014-04-01 00:27:47.000000', 'consum', 0.0210, 'lps'),
	(619197, 131, '2014-04-01 00:27:48.000000', 'consum', 0.0227, 'lps'),
	(619198, 131, '2014-04-01 00:27:49.000000', 'consum', 0.0216, 'lps'),
	(619199, 131, '2014-04-01 00:27:50.000000', 'consum', 0.0228, 'lps'),
	(619200, 131, '2014-04-01 00:27:51.000000', 'consum', 0.0221, 'lps'),
	(619201, 131, '2014-04-01 00:27:52.000000', 'consum', 0.0214, 'lps'),
	(619202, 131, '2014-04-01 00:27:53.000000', 'consum', 0.0216, 'lps'),
	(619203, 131, '2014-04-01 00:27:54.000000', 'consum', 0.0228, 'lps'),
	(619204, 131, '2014-04-01 00:27:55.000000', 'consum', 0.0221, 'lps'),
	(619205, 131, '2014-04-01 00:27:56.000000', 'consum', 0.0215, 'lps'),
	(619206, 131, '2014-04-01 00:27:57.000000', 'consum', 0.0222, 'lps'),
	(619207, 131, '2014-04-01 00:27:58.000000', 'consum', 0.0214, 'lps'),
	(619208, 131, '2014-04-01 00:27:59.000000', 'consum', 0.0217, 'lps'),
	(619209, 131, '2014-04-01 00:28:00.000000', 'consum', 0.0212, 'lps'),
	(619210, 131, '2014-04-01 00:28:01.000000', 'consum', 0.0219, 'lps'),
	(619211, 131, '2014-04-01 00:28:02.000000', 'consum', 0.0210, 'lps'),
	(619212, 131, '2014-04-01 00:28:03.000000', 'consum', 0.0222, 'lps'),
	(619213, 131, '2014-04-01 00:28:04.000000', 'consum', 0.0210, 'lps'),
	(619214, 131, '2014-04-01 00:28:05.000000', 'consum', 0.0216, 'lps'),
	(619215, 131, '2014-04-01 00:28:06.000000', 'consum', 0.0221, 'lps'),
	(619216, 131, '2014-04-01 00:28:07.000000', 'consum', 0.0228, 'lps'),
	(619217, 131, '2014-04-01 00:28:08.000000', 'consum', 0.0228, 'lps'),
	(619218, 131, '2014-04-01 00:28:09.000000', 'consum', 0.0228, 'lps'),
	(619219, 131, '2014-04-01 00:28:10.000000', 'consum', 0.0223, 'lps'),
	(619220, 131, '2014-04-01 00:28:11.000000', 'consum', 0.0223, 'lps'),
	(619221, 131, '2014-04-01 00:28:12.000000', 'consum', 0.0214, 'lps'),
	(619222, 131, '2014-04-01 00:28:13.000000', 'consum', 0.0215, 'lps'),
	(619223, 131, '2014-04-01 00:28:14.000000', 'consum', 0.0222, 'lps'),
	(619224, 131, '2014-04-01 00:28:15.000000', 'consum', 0.0216, 'lps'),
	(619225, 131, '2014-04-01 00:28:16.000000', 'consum', 0.0224, 'lps'),
	(619226, 131, '2014-04-01 00:28:17.000000', 'consum', 0.0221, 'lps'),
	(619227, 131, '2014-04-01 00:28:18.000000', 'consum', 0.0224, 'lps'),
	(619228, 131, '2014-04-01 00:28:19.000000', 'consum', 0.0228, 'lps'),
	(619229, 131, '2014-04-01 00:28:20.000000', 'consum', 0.0217, 'lps'),
	(619230, 131, '2014-04-01 00:28:21.000000', 'consum', 0.0214, 'lps'),
	(619231, 131, '2014-04-01 00:28:22.000000', 'consum', 0.0228, 'lps'),
	(619232, 131, '2014-04-01 00:28:23.000000', 'consum', 0.0228, 'lps'),
	(619233, 131, '2014-04-01 00:28:24.000000', 'consum', 0.0227, 'lps'),
	(619234, 131, '2014-04-01 00:28:25.000000', 'consum', 0.0222, 'lps'),
	(619235, 131, '2014-04-01 00:28:26.000000', 'consum', 0.0219, 'lps'),
	(619236, 131, '2014-04-01 00:28:27.000000', 'consum', 0.0220, 'lps'),
	(619237, 131, '2014-04-01 00:28:28.000000', 'consum', 0.0215, 'lps'),
	(619238, 131, '2014-04-01 00:28:29.000000', 'consum', 0.0226, 'lps'),
	(619239, 131, '2014-04-01 00:28:30.000000', 'consum', 0.0212, 'lps'),
	(619240, 131, '2014-04-01 00:28:31.000000', 'consum', 0.0216, 'lps'),
	(619241, 131, '2014-04-01 00:28:32.000000', 'consum', 0.0213, 'lps'),
	(619242, 131, '2014-04-01 00:28:33.000000', 'consum', 0.0226, 'lps'),
	(619243, 131, '2014-04-01 00:28:34.000000', 'consum', 0.0221, 'lps'),
	(619244, 131, '2014-04-01 00:28:35.000000', 'consum', 0.0219, 'lps'),
	(619245, 131, '2014-04-01 00:28:36.000000', 'consum', 0.0223, 'lps'),
	(619246, 131, '2014-04-01 00:28:37.000000', 'consum', 0.0226, 'lps'),
	(619247, 131, '2014-04-01 00:28:38.000000', 'consum', 0.0212, 'lps'),
	(619248, 131, '2014-04-01 00:28:39.000000', 'consum', 0.0215, 'lps'),
	(619249, 131, '2014-04-01 00:28:40.000000', 'consum', 0.0229, 'lps'),
	(619250, 131, '2014-04-01 00:28:41.000000', 'consum', 0.0211, 'lps'),
	(619251, 131, '2014-04-01 00:28:42.000000', 'consum', 0.0218, 'lps'),
	(619252, 131, '2014-04-01 00:28:43.000000', 'consum', 0.0229, 'lps'),
	(619253, 131, '2014-04-01 00:28:44.000000', 'consum', 0.0220, 'lps'),
	(619254, 131, '2014-04-01 00:28:45.000000', 'consum', 0.0224, 'lps'),
	(619255, 131, '2014-04-01 00:28:46.000000', 'consum', 0.0211, 'lps'),
	(619256, 131, '2014-04-01 00:28:47.000000', 'consum', 0.0213, 'lps'),
	(619257, 131, '2014-04-01 00:28:48.000000', 'consum', 0.0221, 'lps'),
	(619258, 131, '2014-04-01 00:28:49.000000', 'consum', 0.0218, 'lps'),
	(619259, 131, '2014-04-01 00:28:50.000000', 'consum', 0.0216, 'lps'),
	(619260, 131, '2014-04-01 00:28:51.000000', 'consum', 0.0216, 'lps'),
	(619261, 131, '2014-04-01 00:28:52.000000', 'consum', 0.0225, 'lps'),
	(619262, 131, '2014-04-01 00:28:53.000000', 'consum', 0.0226, 'lps'),
	(619263, 131, '2014-04-01 00:28:54.000000', 'consum', 0.0227, 'lps'),
	(619264, 131, '2014-04-01 00:28:55.000000', 'consum', 0.0226, 'lps'),
	(619265, 131, '2014-04-01 00:28:56.000000', 'consum', 0.0221, 'lps'),
	(619266, 131, '2014-04-01 00:28:57.000000', 'consum', 0.0216, 'lps'),
	(619267, 131, '2014-04-01 00:28:58.000000', 'consum', 0.0228, 'lps'),
	(619268, 131, '2014-04-01 00:28:59.000000', 'consum', 0.0224, 'lps'),
	(619269, 131, '2014-04-01 00:29:00.000000', 'consum', 0.0225, 'lps'),
	(619270, 131, '2014-04-01 00:29:01.000000', 'consum', 0.0225, 'lps'),
	(619271, 131, '2014-04-01 00:29:02.000000', 'consum', 0.0220, 'lps'),
	(619272, 131, '2014-04-01 00:29:03.000000', 'consum', 0.0213, 'lps'),
	(619273, 131, '2014-04-01 00:29:04.000000', 'consum', 0.0219, 'lps'),
	(619274, 131, '2014-04-01 00:29:05.000000', 'consum', 0.0226, 'lps'),
	(619275, 131, '2014-04-01 00:29:06.000000', 'consum', 0.0222, 'lps'),
	(619276, 131, '2014-04-01 00:29:07.000000', 'consum', 0.0221, 'lps'),
	(619277, 131, '2014-04-01 00:29:08.000000', 'consum', 0.0211, 'lps'),
	(619278, 131, '2014-04-01 00:29:09.000000', 'consum', 0.0223, 'lps'),
	(619279, 131, '2014-04-01 00:29:10.000000', 'consum', 0.0213, 'lps'),
	(619280, 131, '2014-04-01 00:29:11.000000', 'consum', 0.0225, 'lps'),
	(619281, 131, '2014-04-01 00:29:12.000000', 'consum', 0.0218, 'lps'),
	(619282, 131, '2014-04-01 00:29:13.000000', 'consum', 0.0227, 'lps'),
	(619283, 131, '2014-04-01 00:29:14.000000', 'consum', 0.0210, 'lps'),
	(619284, 131, '2014-04-01 00:29:15.000000', 'consum', 0.0220, 'lps'),
	(619285, 131, '2014-04-01 00:29:16.000000', 'consum', 0.0221, 'lps'),
	(619286, 131, '2014-04-01 00:29:17.000000', 'consum', 0.0215, 'lps'),
	(619287, 131, '2014-04-01 00:29:18.000000', 'consum', 0.0221, 'lps'),
	(619288, 131, '2014-04-01 00:29:19.000000', 'consum', 0.0210, 'lps'),
	(619289, 131, '2014-04-01 00:29:20.000000', 'consum', 0.0220, 'lps'),
	(619290, 131, '2014-04-01 00:29:21.000000', 'consum', 0.0221, 'lps'),
	(619291, 131, '2014-04-01 00:29:22.000000', 'consum', 0.0214, 'lps'),
	(619292, 131, '2014-04-01 00:29:23.000000', 'consum', 0.0218, 'lps'),
	(619293, 131, '2014-04-01 00:29:24.000000', 'consum', 0.0217, 'lps'),
	(619294, 131, '2014-04-01 00:29:25.000000', 'consum', 0.0221, 'lps'),
	(619295, 131, '2014-04-01 00:29:26.000000', 'consum', 0.0227, 'lps'),
	(619296, 131, '2014-04-01 00:29:27.000000', 'consum', 0.0220, 'lps'),
	(619297, 131, '2014-04-01 00:29:28.000000', 'consum', 0.0212, 'lps'),
	(619298, 131, '2014-04-01 00:29:29.000000', 'consum', 0.0229, 'lps'),
	(619299, 131, '2014-04-01 00:29:30.000000', 'consum', 0.0221, 'lps'),
	(619300, 131, '2014-04-01 00:29:31.000000', 'consum', 0.0228, 'lps'),
	(619301, 131, '2014-04-01 00:29:32.000000', 'consum', 0.0229, 'lps'),
	(619302, 131, '2014-04-01 00:29:33.000000', 'consum', 0.0229, 'lps'),
	(619303, 131, '2014-04-01 00:29:34.000000', 'consum', 0.0211, 'lps'),
	(619304, 131, '2014-04-01 00:29:35.000000', 'consum', 0.0216, 'lps'),
	(619305, 131, '2014-04-01 00:29:36.000000', 'consum', 0.0217, 'lps'),
	(619306, 131, '2014-04-01 00:29:37.000000', 'consum', 0.0229, 'lps'),
	(619307, 131, '2014-04-01 00:29:38.000000', 'consum', 0.0224, 'lps'),
	(619308, 131, '2014-04-01 00:29:39.000000', 'consum', 0.0224, 'lps'),
	(619309, 131, '2014-04-01 00:29:40.000000', 'consum', 0.0217, 'lps'),
	(619310, 131, '2014-04-01 00:29:41.000000', 'consum', 0.0226, 'lps'),
	(619311, 131, '2014-04-01 00:29:42.000000', 'consum', 0.0227, 'lps'),
	(619312, 131, '2014-04-01 00:29:43.000000', 'consum', 0.0210, 'lps'),
	(619313, 131, '2014-04-01 00:29:44.000000', 'consum', 0.0217, 'lps'),
	(619314, 131, '2014-04-01 00:29:45.000000', 'consum', 0.0227, 'lps'),
	(619315, 131, '2014-04-01 00:29:46.000000', 'consum', 0.0216, 'lps'),
	(619316, 131, '2014-04-01 00:29:47.000000', 'consum', 0.0229, 'lps'),
	(619317, 131, '2014-04-01 00:29:48.000000', 'consum', 0.0226, 'lps'),
	(619318, 131, '2014-04-01 00:29:49.000000', 'consum', 0.0214, 'lps'),
	(619319, 131, '2014-04-01 00:29:50.000000', 'consum', 0.0223, 'lps'),
	(619320, 131, '2014-04-01 00:29:51.000000', 'consum', 0.0225, 'lps'),
	(619321, 131, '2014-04-01 00:29:52.000000', 'consum', 0.0225, 'lps'),
	(619322, 131, '2014-04-01 00:29:53.000000', 'consum', 0.0219, 'lps'),
	(619323, 131, '2014-04-01 00:29:54.000000', 'consum', 0.0212, 'lps'),
	(619324, 131, '2014-04-01 00:29:55.000000', 'consum', 0.0212, 'lps'),
	(619325, 131, '2014-04-01 00:29:56.000000', 'consum', 0.0217, 'lps'),
	(619326, 131, '2014-04-01 00:29:57.000000', 'consum', 0.0217, 'lps'),
	(619327, 131, '2014-04-01 00:29:58.000000', 'consum', 0.0225, 'lps'),
	(619328, 131, '2014-04-01 00:29:59.000000', 'consum', 0.0226, 'lps'),
	(619329, 131, '2014-04-01 00:30:00.000000', 'consum', 0.0224, 'lps'),
	(619330, 131, '2014-04-01 00:30:01.000000', 'consum', 0.0211, 'lps'),
	(619331, 131, '2014-04-01 00:30:02.000000', 'consum', 0.0215, 'lps'),
	(619332, 131, '2014-04-01 00:30:03.000000', 'consum', 0.0213, 'lps'),
	(619333, 131, '2014-04-01 00:30:04.000000', 'consum', 0.0229, 'lps'),
	(619334, 131, '2014-04-01 00:30:05.000000', 'consum', 0.0217, 'lps'),
	(619335, 131, '2014-04-01 00:30:06.000000', 'consum', 0.0210, 'lps'),
	(619336, 131, '2014-04-01 00:30:07.000000', 'consum', 0.0210, 'lps'),
	(619337, 131, '2014-04-01 00:30:08.000000', 'consum', 0.0210, 'lps'),
	(619338, 131, '2014-04-01 00:30:09.000000', 'consum', 0.0211, 'lps'),
	(619339, 131, '2014-04-01 00:30:10.000000', 'consum', 0.0214, 'lps'),
	(619340, 131, '2014-04-01 00:30:11.000000', 'consum', 0.0228, 'lps'),
	(619341, 131, '2014-04-01 00:30:12.000000', 'consum', 0.0229, 'lps'),
	(619342, 131, '2014-04-01 00:30:13.000000', 'consum', 0.0210, 'lps'),
	(619343, 131, '2014-04-01 00:30:14.000000', 'consum', 0.0216, 'lps'),
	(619344, 131, '2014-04-01 00:30:15.000000', 'consum', 0.0218, 'lps'),
	(619345, 131, '2014-04-01 00:30:16.000000', 'consum', 0.0214, 'lps'),
	(619346, 131, '2014-04-01 00:30:17.000000', 'consum', 0.0226, 'lps'),
	(619347, 131, '2014-04-01 00:30:18.000000', 'consum', 0.0218, 'lps'),
	(619348, 131, '2014-04-01 00:30:19.000000', 'consum', 0.0224, 'lps'),
	(619349, 131, '2014-04-01 00:30:20.000000', 'consum', 0.0214, 'lps'),
	(619350, 131, '2014-04-01 00:30:21.000000', 'consum', 0.0212, 'lps'),
	(619351, 131, '2014-04-01 00:30:22.000000', 'consum', 0.0225, 'lps'),
	(619352, 131, '2014-04-01 00:30:23.000000', 'consum', 0.0221, 'lps'),
	(619353, 131, '2014-04-01 00:30:24.000000', 'consum', 0.0221, 'lps'),
	(619354, 131, '2014-04-01 00:30:25.000000', 'consum', 0.0211, 'lps'),
	(619355, 131, '2014-04-01 00:30:26.000000', 'consum', 0.0223, 'lps'),
	(619356, 131, '2014-04-01 00:30:27.000000', 'consum', 0.0214, 'lps'),
	(619357, 131, '2014-04-01 00:30:28.000000', 'consum', 0.0211, 'lps'),
	(619358, 131, '2014-04-01 00:30:29.000000', 'consum', 0.0222, 'lps'),
	(619359, 131, '2014-04-01 00:30:30.000000', 'consum', 0.0210, 'lps'),
	(619360, 131, '2014-04-01 00:30:31.000000', 'consum', 0.0214, 'lps'),
	(619361, 131, '2014-04-01 00:30:32.000000', 'consum', 0.0211, 'lps'),
	(619362, 131, '2014-04-01 00:30:33.000000', 'consum', 0.0224, 'lps'),
	(619363, 131, '2014-04-01 00:30:34.000000', 'consum', 0.0216, 'lps'),
	(619364, 131, '2014-04-01 00:30:35.000000', 'consum', 0.0217, 'lps'),
	(619365, 131, '2014-04-01 00:30:36.000000', 'consum', 0.0229, 'lps'),
	(619366, 131, '2014-04-01 00:30:37.000000', 'consum', 0.0226, 'lps'),
	(619367, 131, '2014-04-01 00:30:38.000000', 'consum', 0.0211, 'lps'),
	(619368, 131, '2014-04-01 00:30:39.000000', 'consum', 0.0210, 'lps'),
	(619369, 131, '2014-04-01 00:30:40.000000', 'consum', 0.0227, 'lps'),
	(619370, 131, '2014-04-01 00:30:41.000000', 'consum', 0.0214, 'lps'),
	(619371, 131, '2014-04-01 00:30:42.000000', 'consum', 0.0221, 'lps'),
	(619372, 131, '2014-04-01 00:30:43.000000', 'consum', 0.0213, 'lps'),
	(619373, 131, '2014-04-01 00:30:44.000000', 'consum', 0.0212, 'lps'),
	(619374, 131, '2014-04-01 00:30:45.000000', 'consum', 0.0212, 'lps'),
	(619375, 131, '2014-04-01 00:30:46.000000', 'consum', 0.0213, 'lps'),
	(619376, 131, '2014-04-01 00:30:47.000000', 'consum', 0.0220, 'lps'),
	(619377, 131, '2014-04-01 00:30:48.000000', 'consum', 0.0213, 'lps'),
	(619378, 131, '2014-04-01 00:30:49.000000', 'consum', 0.0216, 'lps'),
	(619379, 131, '2014-04-01 00:30:50.000000', 'consum', 0.0210, 'lps'),
	(619380, 131, '2014-04-01 00:30:51.000000', 'consum', 0.0215, 'lps'),
	(619381, 131, '2014-04-01 00:30:52.000000', 'consum', 0.0214, 'lps'),
	(619382, 131, '2014-04-01 00:30:53.000000', 'consum', 0.0215, 'lps'),
	(619383, 131, '2014-04-01 00:30:54.000000', 'consum', 0.0225, 'lps'),
	(619384, 131, '2014-04-01 00:30:55.000000', 'consum', 0.0228, 'lps'),
	(619385, 131, '2014-04-01 00:30:56.000000', 'consum', 0.0217, 'lps'),
	(619386, 131, '2014-04-01 00:30:57.000000', 'consum', 0.0210, 'lps'),
	(619387, 131, '2014-04-01 00:30:58.000000', 'consum', 0.0210, 'lps'),
	(619388, 131, '2014-04-01 00:30:59.000000', 'consum', 0.0212, 'lps'),
	(619389, 131, '2014-04-01 00:31:00.000000', 'consum', 0.0220, 'lps'),
	(619390, 131, '2014-04-01 00:31:01.000000', 'consum', 0.0216, 'lps'),
	(619391, 131, '2014-04-01 00:31:02.000000', 'consum', 0.0211, 'lps'),
	(619392, 131, '2014-04-01 00:31:03.000000', 'consum', 0.0214, 'lps'),
	(619393, 131, '2014-04-01 00:31:04.000000', 'consum', 0.0211, 'lps'),
	(619394, 131, '2014-04-01 00:31:05.000000', 'consum', 0.0222, 'lps'),
	(619395, 131, '2014-04-01 00:31:06.000000', 'consum', 0.0229, 'lps'),
	(619396, 131, '2014-04-01 00:31:07.000000', 'consum', 0.0227, 'lps'),
	(619397, 131, '2014-04-01 00:31:08.000000', 'consum', 0.0220, 'lps'),
	(619398, 131, '2014-04-01 00:31:09.000000', 'consum', 0.0229, 'lps'),
	(619399, 131, '2014-04-01 00:31:10.000000', 'consum', 0.0215, 'lps'),
	(619400, 131, '2014-04-01 00:31:11.000000', 'consum', 0.0219, 'lps'),
	(619401, 131, '2014-04-01 00:31:12.000000', 'consum', 0.0219, 'lps'),
	(619402, 131, '2014-04-01 00:31:13.000000', 'consum', 0.0229, 'lps'),
	(619403, 131, '2014-04-01 00:31:14.000000', 'consum', 0.0219, 'lps'),
	(619404, 131, '2014-04-01 00:31:15.000000', 'consum', 0.0217, 'lps'),
	(619405, 131, '2014-04-01 00:31:16.000000', 'consum', 0.0218, 'lps'),
	(619406, 131, '2014-04-01 00:31:17.000000', 'consum', 0.0211, 'lps'),
	(619407, 131, '2014-04-01 00:31:18.000000', 'consum', 0.0213, 'lps'),
	(619408, 131, '2014-04-01 00:31:19.000000', 'consum', 0.0221, 'lps'),
	(619409, 131, '2014-04-01 00:31:20.000000', 'consum', 0.0219, 'lps'),
	(619410, 131, '2014-04-01 00:31:21.000000', 'consum', 0.0219, 'lps'),
	(619411, 131, '2014-04-01 00:31:22.000000', 'consum', 0.0210, 'lps'),
	(619412, 131, '2014-04-01 00:31:23.000000', 'consum', 0.0222, 'lps'),
	(619413, 131, '2014-04-01 00:31:24.000000', 'consum', 0.0214, 'lps'),
	(619414, 131, '2014-04-01 00:31:25.000000', 'consum', 0.0211, 'lps'),
	(619415, 131, '2014-04-01 00:31:26.000000', 'consum', 0.0224, 'lps'),
	(619416, 131, '2014-04-01 00:31:27.000000', 'consum', 0.0217, 'lps'),
	(619417, 131, '2014-04-01 00:31:28.000000', 'consum', 0.0224, 'lps'),
	(619418, 131, '2014-04-01 00:31:29.000000', 'consum', 0.0220, 'lps'),
	(619419, 131, '2014-04-01 00:31:30.000000', 'consum', 0.0218, 'lps'),
	(619420, 131, '2014-04-01 00:31:31.000000', 'consum', 0.0220, 'lps'),
	(619421, 131, '2014-04-01 00:31:32.000000', 'consum', 0.0216, 'lps'),
	(619422, 131, '2014-04-01 00:31:33.000000', 'consum', 0.0213, 'lps'),
	(619423, 131, '2014-04-01 00:31:34.000000', 'consum', 0.0226, 'lps'),
	(619424, 131, '2014-04-01 00:31:35.000000', 'consum', 0.0223, 'lps'),
	(619425, 131, '2014-04-01 00:31:36.000000', 'consum', 0.0229, 'lps'),
	(619426, 131, '2014-04-01 00:31:37.000000', 'consum', 0.0223, 'lps'),
	(619427, 131, '2014-04-01 00:31:38.000000', 'consum', 0.0221, 'lps'),
	(619428, 131, '2014-04-01 00:31:39.000000', 'consum', 0.0226, 'lps'),
	(619429, 131, '2014-04-01 00:31:40.000000', 'consum', 0.0218, 'lps'),
	(619430, 131, '2014-04-01 00:31:41.000000', 'consum', 0.0221, 'lps'),
	(619431, 131, '2014-04-01 00:31:42.000000', 'consum', 0.0220, 'lps'),
	(619432, 131, '2014-04-01 00:31:43.000000', 'consum', 0.0210, 'lps'),
	(619433, 131, '2014-04-01 00:31:44.000000', 'consum', 0.0218, 'lps'),
	(619434, 131, '2014-04-01 00:31:45.000000', 'consum', 0.0211, 'lps'),
	(619435, 131, '2014-04-01 00:31:46.000000', 'consum', 0.0211, 'lps'),
	(619436, 131, '2014-04-01 00:31:47.000000', 'consum', 0.0214, 'lps'),
	(619437, 131, '2014-04-01 00:31:48.000000', 'consum', 0.0228, 'lps'),
	(619438, 131, '2014-04-01 00:31:49.000000', 'consum', 0.0228, 'lps'),
	(619439, 131, '2014-04-01 00:31:50.000000', 'consum', 0.0227, 'lps'),
	(619440, 131, '2014-04-01 00:31:51.000000', 'consum', 0.0222, 'lps'),
	(619441, 131, '2014-04-01 00:31:52.000000', 'consum', 0.0218, 'lps'),
	(619442, 131, '2014-04-01 00:31:53.000000', 'consum', 0.0217, 'lps'),
	(619443, 131, '2014-04-01 00:31:54.000000', 'consum', 0.0220, 'lps'),
	(619444, 131, '2014-04-01 00:31:55.000000', 'consum', 0.0220, 'lps'),
	(619445, 131, '2014-04-01 00:31:56.000000', 'consum', 0.0210, 'lps'),
	(619446, 131, '2014-04-01 00:31:57.000000', 'consum', 0.0220, 'lps'),
	(619447, 131, '2014-04-01 00:31:58.000000', 'consum', 0.0221, 'lps'),
	(619448, 131, '2014-04-01 00:31:59.000000', 'consum', 0.0215, 'lps'),
	(619449, 131, '2014-04-01 00:32:00.000000', 'consum', 0.0223, 'lps'),
	(619450, 131, '2014-04-01 00:32:01.000000', 'consum', 0.0220, 'lps'),
	(619451, 131, '2014-04-01 00:32:02.000000', 'consum', 0.0223, 'lps'),
	(619452, 131, '2014-04-01 00:32:03.000000', 'consum', 0.0226, 'lps'),
	(619453, 131, '2014-04-01 00:32:04.000000', 'consum', 0.0212, 'lps'),
	(619454, 131, '2014-04-01 00:32:05.000000', 'consum', 0.0213, 'lps'),
	(619455, 131, '2014-04-01 00:32:06.000000', 'consum', 0.0219, 'lps'),
	(619456, 131, '2014-04-01 00:32:07.000000', 'consum', 0.0227, 'lps'),
	(619457, 131, '2014-04-01 00:32:08.000000', 'consum', 0.0228, 'lps'),
	(619458, 131, '2014-04-01 00:32:09.000000', 'consum', 0.0210, 'lps'),
	(619459, 131, '2014-04-01 00:32:10.000000', 'consum', 0.0216, 'lps'),
	(619460, 131, '2014-04-01 00:32:11.000000', 'consum', 0.0220, 'lps'),
	(619461, 131, '2014-04-01 00:32:12.000000', 'consum', 0.0222, 'lps'),
	(619462, 131, '2014-04-01 00:32:13.000000', 'consum', 0.0220, 'lps'),
	(619463, 131, '2014-04-01 00:32:14.000000', 'consum', 0.0226, 'lps'),
	(619464, 131, '2014-04-01 00:32:15.000000', 'consum', 0.0219, 'lps'),
	(619465, 131, '2014-04-01 00:32:16.000000', 'consum', 0.0229, 'lps'),
	(619466, 131, '2014-04-01 00:32:17.000000', 'consum', 0.0217, 'lps'),
	(619467, 131, '2014-04-01 00:32:18.000000', 'consum', 0.0210, 'lps'),
	(619468, 131, '2014-04-01 00:32:19.000000', 'consum', 0.0210, 'lps'),
	(619469, 131, '2014-04-01 00:32:20.000000', 'consum', 0.0211, 'lps'),
	(619470, 131, '2014-04-01 00:32:21.000000', 'consum', 0.0216, 'lps'),
	(619471, 131, '2014-04-01 00:32:22.000000', 'consum', 0.0215, 'lps'),
	(619472, 131, '2014-04-01 00:32:23.000000', 'consum', 0.0219, 'lps'),
	(619473, 131, '2014-04-01 00:32:24.000000', 'consum', 0.0221, 'lps'),
	(619474, 131, '2014-04-01 00:32:25.000000', 'consum', 0.0217, 'lps'),
	(619475, 131, '2014-04-01 00:32:26.000000', 'consum', 0.0212, 'lps'),
	(619476, 131, '2014-04-01 00:32:27.000000', 'consum', 0.0220, 'lps'),
	(619477, 131, '2014-04-01 00:32:28.000000', 'consum', 0.0213, 'lps'),
	(619478, 131, '2014-04-01 00:32:29.000000', 'consum', 0.0216, 'lps'),
	(619479, 131, '2014-04-01 00:32:30.000000', 'consum', 0.0212, 'lps'),
	(619480, 131, '2014-04-01 00:32:31.000000', 'consum', 0.0222, 'lps'),
	(619481, 131, '2014-04-01 00:32:32.000000', 'consum', 0.0224, 'lps'),
	(619482, 131, '2014-04-01 00:32:33.000000', 'consum', 0.0223, 'lps'),
	(619483, 131, '2014-04-01 00:32:34.000000', 'consum', 0.0216, 'lps'),
	(619484, 131, '2014-04-01 00:32:35.000000', 'consum', 0.0221, 'lps'),
	(619485, 131, '2014-04-01 00:32:36.000000', 'consum', 0.0228, 'lps'),
	(619486, 131, '2014-04-01 00:32:37.000000', 'consum', 0.0225, 'lps'),
	(619487, 131, '2014-04-01 00:32:38.000000', 'consum', 0.0213, 'lps'),
	(619488, 131, '2014-04-01 00:32:39.000000', 'consum', 0.0220, 'lps'),
	(619489, 131, '2014-04-01 00:32:40.000000', 'consum', 0.0211, 'lps'),
	(619490, 131, '2014-04-01 00:32:41.000000', 'consum', 0.0225, 'lps'),
	(619491, 131, '2014-04-01 00:32:42.000000', 'consum', 0.0221, 'lps'),
	(619492, 131, '2014-04-01 00:32:43.000000', 'consum', 0.0224, 'lps'),
	(619493, 131, '2014-04-01 00:32:44.000000', 'consum', 0.0226, 'lps'),
	(619494, 131, '2014-04-01 00:32:45.000000', 'consum', 0.0229, 'lps'),
	(619495, 131, '2014-04-01 00:32:46.000000', 'consum', 0.0218, 'lps'),
	(619496, 131, '2014-04-01 00:32:47.000000', 'consum', 0.0213, 'lps'),
	(619497, 131, '2014-04-01 00:32:48.000000', 'consum', 0.0223, 'lps'),
	(619498, 131, '2014-04-01 00:32:49.000000', 'consum', 0.0227, 'lps'),
	(619499, 131, '2014-04-01 00:32:50.000000', 'consum', 0.0215, 'lps'),
	(619500, 131, '2014-04-01 00:32:51.000000', 'consum', 0.0223, 'lps'),
	(619501, 131, '2014-04-01 00:32:52.000000', 'consum', 0.0222, 'lps'),
	(619502, 131, '2014-04-01 00:32:53.000000', 'consum', 0.0212, 'lps'),
	(619503, 131, '2014-04-01 00:32:54.000000', 'consum', 0.0224, 'lps'),
	(619504, 131, '2014-04-01 00:32:55.000000', 'consum', 0.0215, 'lps'),
	(619505, 131, '2014-04-01 00:32:56.000000', 'consum', 0.0212, 'lps'),
	(619506, 131, '2014-04-01 00:32:57.000000', 'consum', 0.0225, 'lps'),
	(619507, 131, '2014-04-01 00:32:58.000000', 'consum', 0.0221, 'lps'),
	(619508, 131, '2014-04-01 00:32:59.000000', 'consum', 0.0219, 'lps'),
	(619509, 131, '2014-04-01 00:33:00.000000', 'consum', 0.0224, 'lps'),
	(619510, 131, '2014-04-01 00:33:01.000000', 'consum', 0.0214, 'lps'),
	(619511, 131, '2014-04-01 00:33:02.000000', 'consum', 0.0229, 'lps'),
	(619512, 131, '2014-04-01 00:33:03.000000', 'consum', 0.0214, 'lps'),
	(619513, 131, '2014-04-01 00:33:04.000000', 'consum', 0.0211, 'lps'),
	(619514, 131, '2014-04-01 00:33:05.000000', 'consum', 0.0227, 'lps'),
	(619515, 131, '2014-04-01 00:33:06.000000', 'consum', 0.0229, 'lps'),
	(619516, 131, '2014-04-01 00:33:07.000000', 'consum', 0.0215, 'lps'),
	(619517, 131, '2014-04-01 00:33:08.000000', 'consum', 0.0217, 'lps'),
	(619518, 131, '2014-04-01 00:33:09.000000', 'consum', 0.0212, 'lps'),
	(619519, 131, '2014-04-01 00:33:10.000000', 'consum', 0.0221, 'lps'),
	(619520, 131, '2014-04-01 00:33:11.000000', 'consum', 0.0217, 'lps'),
	(619521, 131, '2014-04-01 00:33:12.000000', 'consum', 0.0214, 'lps'),
	(619522, 131, '2014-04-01 00:33:13.000000', 'consum', 0.0228, 'lps'),
	(619523, 131, '2014-04-01 00:33:14.000000', 'consum', 0.0228, 'lps'),
	(619524, 131, '2014-04-01 00:33:15.000000', 'consum', 0.0229, 'lps'),
	(619525, 131, '2014-04-01 00:33:16.000000', 'consum', 0.0210, 'lps'),
	(619526, 131, '2014-04-01 00:33:17.000000', 'consum', 0.0213, 'lps'),
	(619527, 131, '2014-04-01 00:33:18.000000', 'consum', 0.0225, 'lps'),
	(619528, 131, '2014-04-01 00:33:19.000000', 'consum', 0.0217, 'lps'),
	(619529, 131, '2014-04-01 00:33:20.000000', 'consum', 0.0220, 'lps'),
	(619530, 131, '2014-04-01 00:33:21.000000', 'consum', 0.0220, 'lps'),
	(619531, 131, '2014-04-01 00:33:22.000000', 'consum', 0.0212, 'lps'),
	(619532, 131, '2014-04-01 00:33:23.000000', 'consum', 0.0211, 'lps'),
	(619533, 131, '2014-04-01 00:33:24.000000', 'consum', 0.0228, 'lps'),
	(619534, 131, '2014-04-01 00:33:25.000000', 'consum', 0.0217, 'lps'),
	(619535, 131, '2014-04-01 00:33:26.000000', 'consum', 0.0214, 'lps'),
	(619536, 131, '2014-04-01 00:33:27.000000', 'consum', 0.0226, 'lps'),
	(619537, 131, '2014-04-01 00:33:28.000000', 'consum', 0.0221, 'lps'),
	(619538, 131, '2014-04-01 00:33:29.000000', 'consum', 0.0217, 'lps'),
	(619539, 131, '2014-04-01 00:33:30.000000', 'consum', 0.0212, 'lps'),
	(619540, 131, '2014-04-01 00:33:31.000000', 'consum', 0.0219, 'lps'),
	(619541, 131, '2014-04-01 00:33:32.000000', 'consum', 0.0210, 'lps'),
	(619542, 131, '2014-04-01 00:33:33.000000', 'consum', 0.0222, 'lps'),
	(619543, 131, '2014-04-01 00:33:34.000000', 'consum', 0.0214, 'lps'),
	(619544, 131, '2014-04-01 00:33:35.000000', 'consum', 0.0211, 'lps'),
	(619545, 131, '2014-04-01 00:33:36.000000', 'consum', 0.0226, 'lps'),
	(619546, 131, '2014-04-01 00:33:37.000000', 'consum', 0.0226, 'lps'),
	(619547, 131, '2014-04-01 00:33:38.000000', 'consum', 0.0223, 'lps'),
	(619548, 131, '2014-04-01 00:33:39.000000', 'consum', 0.0229, 'lps'),
	(619549, 131, '2014-04-01 00:33:40.000000', 'consum', 0.0226, 'lps'),
	(619550, 131, '2014-04-01 00:33:41.000000', 'consum', 0.0215, 'lps'),
	(619551, 131, '2014-04-01 00:33:42.000000', 'consum', 0.0227, 'lps'),
	(619552, 131, '2014-04-01 00:33:43.000000', 'consum', 0.0218, 'lps'),
	(619553, 131, '2014-04-01 00:33:44.000000', 'consum', 0.0221, 'lps'),
	(619554, 131, '2014-04-01 00:33:45.000000', 'consum', 0.0222, 'lps'),
	(619555, 131, '2014-04-01 00:33:46.000000', 'consum', 0.0216, 'lps'),
	(619556, 131, '2014-04-01 00:33:47.000000', 'consum', 0.0225, 'lps'),
	(619557, 131, '2014-04-01 00:33:48.000000', 'consum', 0.0227, 'lps'),
	(619558, 131, '2014-04-01 00:33:49.000000', 'consum', 0.0210, 'lps'),
	(619559, 131, '2014-04-01 00:33:50.000000', 'consum', 0.0220, 'lps'),
	(619560, 131, '2014-04-01 00:33:51.000000', 'consum', 0.0222, 'lps'),
	(619561, 131, '2014-04-01 00:33:52.000000', 'consum', 0.0222, 'lps'),
	(619562, 131, '2014-04-01 00:33:53.000000', 'consum', 0.0211, 'lps'),
	(619563, 131, '2014-04-01 00:33:54.000000', 'consum', 0.0222, 'lps'),
	(619564, 131, '2014-04-01 00:33:55.000000', 'consum', 0.0227, 'lps'),
	(619565, 131, '2014-04-01 00:33:56.000000', 'consum', 0.0218, 'lps'),
	(619566, 131, '2014-04-01 00:33:57.000000', 'consum', 0.0220, 'lps'),
	(619567, 131, '2014-04-01 00:33:58.000000', 'consum', 0.0215, 'lps'),
	(619568, 131, '2014-04-01 00:33:59.000000', 'consum', 0.0229, 'lps'),
	(619569, 131, '2014-04-01 00:34:00.000000', 'consum', 0.0228, 'lps'),
	(619570, 131, '2014-04-01 00:34:01.000000', 'consum', 0.0224, 'lps'),
	(619571, 131, '2014-04-01 00:34:02.000000', 'consum', 0.0228, 'lps'),
	(619572, 131, '2014-04-01 00:34:03.000000', 'consum', 0.0216, 'lps'),
	(619573, 131, '2014-04-01 00:34:04.000000', 'consum', 0.0227, 'lps'),
	(619574, 131, '2014-04-01 00:34:05.000000', 'consum', 0.0218, 'lps'),
	(619575, 131, '2014-04-01 00:34:06.000000', 'consum', 0.0221, 'lps'),
	(619576, 131, '2014-04-01 00:34:07.000000', 'consum', 0.0219, 'lps'),
	(619577, 131, '2014-04-01 00:34:08.000000', 'consum', 0.0221, 'lps'),
	(619578, 131, '2014-04-01 00:34:09.000000', 'consum', 0.0222, 'lps'),
	(619579, 131, '2014-04-01 00:34:10.000000', 'consum', 0.0216, 'lps'),
	(619580, 131, '2014-04-01 00:34:11.000000', 'consum', 0.0224, 'lps'),
	(619581, 131, '2014-04-01 00:34:12.000000', 'consum', 0.0224, 'lps'),
	(619582, 131, '2014-04-01 00:34:13.000000', 'consum', 0.0216, 'lps'),
	(619583, 131, '2014-04-01 00:34:14.000000', 'consum', 0.0220, 'lps'),
	(619584, 131, '2014-04-01 00:34:15.000000', 'consum', 0.0222, 'lps'),
	(619585, 131, '2014-04-01 00:34:16.000000', 'consum', 0.0220, 'lps'),
	(619586, 131, '2014-04-01 00:34:17.000000', 'consum', 0.0227, 'lps'),
	(619587, 131, '2014-04-01 00:34:18.000000', 'consum', 0.0223, 'lps'),
	(619588, 131, '2014-04-01 00:34:19.000000', 'consum', 0.0225, 'lps'),
	(619589, 131, '2014-04-01 00:34:20.000000', 'consum', 0.0226, 'lps'),
	(619590, 131, '2014-04-01 00:34:21.000000', 'consum', 0.0226, 'lps'),
	(619591, 131, '2014-04-01 00:34:22.000000', 'consum', 0.0224, 'lps'),
	(619592, 131, '2014-04-01 00:34:23.000000', 'consum', 0.0211, 'lps'),
	(619593, 131, '2014-04-01 00:34:24.000000', 'consum', 0.0215, 'lps'),
	(619594, 131, '2014-04-01 00:34:25.000000', 'consum', 0.0211, 'lps'),
	(619595, 131, '2014-04-01 00:34:26.000000', 'consum', 0.0222, 'lps'),
	(619596, 131, '2014-04-01 00:34:27.000000', 'consum', 0.0227, 'lps'),
	(619597, 131, '2014-04-01 00:34:28.000000', 'consum', 0.0221, 'lps'),
	(619598, 131, '2014-04-01 00:34:29.000000', 'consum', 0.0214, 'lps'),
	(619599, 131, '2014-04-01 00:34:30.000000', 'consum', 0.0215, 'lps'),
	(619600, 131, '2014-04-01 00:34:31.000000', 'consum', 0.0226, 'lps'),
	(619601, 131, '2014-04-01 00:34:32.000000', 'consum', 0.0214, 'lps'),
	(619602, 131, '2014-04-01 00:34:33.000000', 'consum', 0.0222, 'lps'),
	(619603, 131, '2014-04-01 00:34:34.000000', 'consum', 0.0217, 'lps'),
	(619604, 131, '2014-04-01 00:34:35.000000', 'consum', 0.0212, 'lps'),
	(619605, 131, '2014-04-01 00:34:36.000000', 'consum', 0.0217, 'lps'),
	(619606, 131, '2014-04-01 00:34:37.000000', 'consum', 0.0223, 'lps'),
	(619607, 131, '2014-04-01 00:34:38.000000', 'consum', 0.0212, 'lps'),
	(619608, 131, '2014-04-01 00:34:39.000000', 'consum', 0.0223, 'lps'),
	(619609, 131, '2014-04-01 00:34:40.000000', 'consum', 0.0228, 'lps'),
	(619610, 131, '2014-04-01 00:34:41.000000', 'consum', 0.0223, 'lps'),
	(619611, 131, '2014-04-01 00:34:42.000000', 'consum', 0.0220, 'lps'),
	(619612, 131, '2014-04-01 00:34:43.000000', 'consum', 0.0224, 'lps'),
	(619613, 131, '2014-04-01 00:34:44.000000', 'consum', 0.0229, 'lps'),
	(619614, 131, '2014-04-01 00:34:45.000000', 'consum', 0.0223, 'lps'),
	(619615, 131, '2014-04-01 00:34:46.000000', 'consum', 0.0217, 'lps'),
	(619616, 131, '2014-04-01 00:34:47.000000', 'consum', 0.0210, 'lps'),
	(619617, 131, '2014-04-01 00:34:48.000000', 'consum', 0.0226, 'lps'),
	(619618, 131, '2014-04-01 00:34:49.000000', 'consum', 0.0214, 'lps'),
	(619619, 131, '2014-04-01 00:34:50.000000', 'consum', 0.0220, 'lps'),
	(619620, 131, '2014-04-01 00:34:51.000000', 'consum', 0.0210, 'lps'),
	(619621, 131, '2014-04-01 00:34:52.000000', 'consum', 0.0221, 'lps'),
	(619622, 131, '2014-04-01 00:34:53.000000', 'consum', 0.0223, 'lps'),
	(619623, 131, '2014-04-01 00:34:54.000000', 'consum', 0.0224, 'lps'),
	(619624, 131, '2014-04-01 00:34:55.000000', 'consum', 0.0222, 'lps'),
	(619625, 131, '2014-04-01 00:34:56.000000', 'consum', 0.0228, 'lps'),
	(619626, 131, '2014-04-01 00:34:57.000000', 'consum', 0.0226, 'lps'),
	(619627, 131, '2014-04-01 00:34:58.000000', 'consum', 0.0215, 'lps'),
	(619628, 131, '2014-04-01 00:34:59.000000', 'consum', 0.0229, 'lps'),
	(619629, 131, '2014-04-01 00:35:00.000000', 'consum', 0.0229, 'lps'),
	(619630, 131, '2014-04-01 00:35:01.000000', 'consum', 0.0228, 'lps'),
	(619631, 131, '2014-04-01 00:35:02.000000', 'consum', 0.0226, 'lps'),
	(619632, 131, '2014-04-01 00:35:03.000000', 'consum', 0.0215, 'lps'),
	(619633, 131, '2014-04-01 00:35:04.000000', 'consum', 0.0226, 'lps'),
	(619634, 131, '2014-04-01 00:35:05.000000', 'consum', 0.0215, 'lps'),
	(619635, 131, '2014-04-01 00:35:06.000000', 'consum', 0.0210, 'lps'),
	(619636, 131, '2014-04-01 00:35:07.000000', 'consum', 0.0213, 'lps'),
	(619637, 131, '2014-04-01 00:35:08.000000', 'consum', 0.0226, 'lps'),
	(619638, 131, '2014-04-01 00:35:09.000000', 'consum', 0.0223, 'lps'),
	(619639, 131, '2014-04-01 00:35:10.000000', 'consum', 0.0227, 'lps'),
	(619640, 131, '2014-04-01 00:35:11.000000', 'consum', 0.0218, 'lps'),
	(619641, 131, '2014-04-01 00:35:12.000000', 'consum', 0.0219, 'lps'),
	(619642, 131, '2014-04-01 00:35:13.000000', 'consum', 0.0212, 'lps'),
	(619643, 131, '2014-04-01 00:35:14.000000', 'consum', 0.0214, 'lps'),
	(619644, 131, '2014-04-01 00:35:15.000000', 'consum', 0.0224, 'lps'),
	(619645, 131, '2014-04-01 00:35:16.000000', 'consum', 0.0228, 'lps'),
	(619646, 131, '2014-04-01 00:35:17.000000', 'consum', 0.0219, 'lps'),
	(619647, 131, '2014-04-01 00:35:18.000000', 'consum', 0.0221, 'lps'),
	(619648, 131, '2014-04-01 00:35:19.000000', 'consum', 0.0219, 'lps'),
	(619649, 131, '2014-04-01 00:35:20.000000', 'consum', 0.0222, 'lps'),
	(619650, 131, '2014-04-01 00:35:21.000000', 'consum', 0.0223, 'lps'),
	(619651, 131, '2014-04-01 00:35:22.000000', 'consum', 0.0222, 'lps'),
	(619652, 131, '2014-04-01 00:35:23.000000', 'consum', 0.0211, 'lps'),
	(619653, 131, '2014-04-01 00:35:24.000000', 'consum', 0.0217, 'lps'),
	(619654, 131, '2014-04-01 00:35:25.000000', 'consum', 0.0224, 'lps'),
	(619655, 131, '2014-04-01 00:35:26.000000', 'consum', 0.0219, 'lps'),
	(619656, 131, '2014-04-01 00:35:27.000000', 'consum', 0.0215, 'lps'),
	(619657, 131, '2014-04-01 00:35:28.000000', 'consum', 0.0229, 'lps'),
	(619658, 131, '2014-04-01 00:35:29.000000', 'consum', 0.0212, 'lps'),
	(619659, 131, '2014-04-01 00:35:30.000000', 'consum', 0.0220, 'lps'),
	(619660, 131, '2014-04-01 00:35:31.000000', 'consum', 0.0215, 'lps'),
	(619661, 131, '2014-04-01 00:35:32.000000', 'consum', 0.0225, 'lps'),
	(619662, 131, '2014-04-01 00:35:33.000000', 'consum', 0.0210, 'lps'),
	(619663, 131, '2014-04-01 00:35:34.000000', 'consum', 0.0228, 'lps'),
	(619664, 131, '2014-04-01 00:35:35.000000', 'consum', 0.0221, 'lps'),
	(619665, 131, '2014-04-01 00:35:36.000000', 'consum', 0.0212, 'lps'),
	(619666, 131, '2014-04-01 00:35:37.000000', 'consum', 0.0227, 'lps'),
	(619667, 131, '2014-04-01 00:35:38.000000', 'consum', 0.0210, 'lps'),
	(619668, 131, '2014-04-01 00:35:39.000000', 'consum', 0.0220, 'lps'),
	(619669, 131, '2014-04-01 00:35:40.000000', 'consum', 0.0220, 'lps'),
	(619670, 131, '2014-04-01 00:35:41.000000', 'consum', 0.0228, 'lps'),
	(619671, 131, '2014-04-01 00:35:42.000000', 'consum', 0.0214, 'lps'),
	(619672, 131, '2014-04-01 00:35:43.000000', 'consum', 0.0213, 'lps'),
	(619673, 131, '2014-04-01 00:35:44.000000', 'consum', 0.0215, 'lps'),
	(619674, 131, '2014-04-01 00:35:45.000000', 'consum', 0.0228, 'lps'),
	(619675, 131, '2014-04-01 00:35:46.000000', 'consum', 0.0223, 'lps'),
	(619676, 131, '2014-04-01 00:35:47.000000', 'consum', 0.0224, 'lps'),
	(619677, 131, '2014-04-01 00:35:48.000000', 'consum', 0.0218, 'lps'),
	(619678, 131, '2014-04-01 00:35:49.000000', 'consum', 0.0212, 'lps'),
	(619679, 131, '2014-04-01 00:35:50.000000', 'consum', 0.0216, 'lps'),
	(619680, 131, '2014-04-01 00:35:51.000000', 'consum', 0.0213, 'lps'),
	(619681, 131, '2014-04-01 00:35:52.000000', 'consum', 0.0227, 'lps'),
	(619682, 131, '2014-04-01 00:35:53.000000', 'consum', 0.0227, 'lps'),
	(619683, 131, '2014-04-01 00:35:54.000000', 'consum', 0.0226, 'lps'),
	(619684, 131, '2014-04-01 00:35:55.000000', 'consum', 0.0220, 'lps'),
	(619685, 131, '2014-04-01 00:35:56.000000', 'consum', 0.0211, 'lps'),
	(619686, 131, '2014-04-01 00:35:57.000000', 'consum', 0.0225, 'lps'),
	(619687, 131, '2014-04-01 00:35:58.000000', 'consum', 0.0222, 'lps'),
	(619688, 131, '2014-04-01 00:35:59.000000', 'consum', 0.0225, 'lps'),
	(619689, 131, '2014-04-01 00:36:00.000000', 'consum', 0.0212, 'lps'),
	(619690, 131, '2014-04-01 00:36:01.000000', 'consum', 0.0215, 'lps'),
	(619691, 131, '2014-04-01 00:36:02.000000', 'consum', 0.0229, 'lps'),
	(619692, 131, '2014-04-01 00:36:03.000000', 'consum', 0.0210, 'lps'),
	(619693, 131, '2014-04-01 00:36:04.000000', 'consum', 0.0214, 'lps'),
	(619694, 131, '2014-04-01 00:36:05.000000', 'consum', 0.0229, 'lps'),
	(619695, 131, '2014-04-01 00:36:06.000000', 'consum', 0.0215, 'lps'),
	(619696, 131, '2014-04-01 00:36:07.000000', 'consum', 0.0217, 'lps'),
	(619697, 131, '2014-04-01 00:36:08.000000', 'consum', 0.0210, 'lps'),
	(619698, 131, '2014-04-01 00:36:09.000000', 'consum', 0.0210, 'lps'),
	(619699, 131, '2014-04-01 00:36:10.000000', 'consum', 0.0213, 'lps'),
	(619700, 131, '2014-04-01 00:36:11.000000', 'consum', 0.0222, 'lps'),
	(619701, 131, '2014-04-01 00:36:12.000000', 'consum', 0.0224, 'lps'),
	(619702, 131, '2014-04-01 00:36:13.000000', 'consum', 0.0225, 'lps'),
	(619703, 131, '2014-04-01 00:36:14.000000', 'consum', 0.0224, 'lps'),
	(619704, 131, '2014-04-01 00:36:15.000000', 'consum', 0.0214, 'lps'),
	(619705, 131, '2014-04-01 00:36:16.000000', 'consum', 0.0229, 'lps'),
	(619706, 131, '2014-04-01 00:36:17.000000', 'consum', 0.0212, 'lps'),
	(619707, 131, '2014-04-01 00:36:18.000000', 'consum', 0.0225, 'lps'),
	(619708, 131, '2014-04-01 00:36:19.000000', 'consum', 0.0221, 'lps'),
	(619709, 131, '2014-04-01 00:36:20.000000', 'consum', 0.0220, 'lps'),
	(619710, 131, '2014-04-01 00:36:21.000000', 'consum', 0.0228, 'lps'),
	(619711, 131, '2014-04-01 00:36:22.000000', 'consum', 0.0210, 'lps'),
	(619712, 131, '2014-04-01 00:36:23.000000', 'consum', 0.0218, 'lps'),
	(619713, 131, '2014-04-01 00:36:24.000000', 'consum', 0.0228, 'lps'),
	(619714, 131, '2014-04-01 00:36:25.000000', 'consum', 0.0219, 'lps'),
	(619715, 131, '2014-04-01 00:36:26.000000', 'consum', 0.0220, 'lps'),
	(619716, 131, '2014-04-01 00:36:27.000000', 'consum', 0.0213, 'lps'),
	(619717, 131, '2014-04-01 00:36:28.000000', 'consum', 0.0217, 'lps'),
	(619718, 131, '2014-04-01 00:36:29.000000', 'consum', 0.0214, 'lps'),
	(619719, 131, '2014-04-01 00:36:30.000000', 'consum', 0.0211, 'lps'),
	(619720, 131, '2014-04-01 00:36:31.000000', 'consum', 0.0225, 'lps'),
	(619721, 131, '2014-04-01 00:36:32.000000', 'consum', 0.0221, 'lps'),
	(619722, 131, '2014-04-01 00:36:33.000000', 'consum', 0.0221, 'lps'),
	(619723, 131, '2014-04-01 00:36:34.000000', 'consum', 0.0210, 'lps'),
	(619724, 131, '2014-04-01 00:36:35.000000', 'consum', 0.0221, 'lps'),
	(619725, 131, '2014-04-01 00:36:36.000000', 'consum', 0.0225, 'lps'),
	(619726, 131, '2014-04-01 00:36:37.000000', 'consum', 0.0212, 'lps'),
	(619727, 131, '2014-04-01 00:36:38.000000', 'consum', 0.0217, 'lps'),
	(619728, 131, '2014-04-01 00:36:39.000000', 'consum', 0.0218, 'lps'),
	(619729, 131, '2014-04-01 00:36:40.000000', 'consum', 0.0210, 'lps'),
	(619730, 131, '2014-04-01 00:36:41.000000', 'consum', 0.0226, 'lps'),
	(619731, 131, '2014-04-01 00:36:42.000000', 'consum', 0.0211, 'lps'),
	(619732, 131, '2014-04-01 00:36:43.000000', 'consum', 0.0227, 'lps'),
	(619733, 131, '2014-04-01 00:36:44.000000', 'consum', 0.0212, 'lps'),
	(619734, 131, '2014-04-01 00:36:45.000000', 'consum', 0.0211, 'lps'),
	(619735, 131, '2014-04-01 00:36:46.000000', 'consum', 0.0229, 'lps'),
	(619736, 131, '2014-04-01 00:36:47.000000', 'consum', 0.0222, 'lps'),
	(619737, 131, '2014-04-01 00:36:48.000000', 'consum', 0.0214, 'lps'),
	(619738, 131, '2014-04-01 00:36:49.000000', 'consum', 0.0215, 'lps'),
	(619739, 131, '2014-04-01 00:36:50.000000', 'consum', 0.0224, 'lps'),
	(619740, 131, '2014-04-01 00:36:51.000000', 'consum', 0.0226, 'lps'),
	(619741, 131, '2014-04-01 00:36:52.000000', 'consum', 0.0229, 'lps'),
	(619742, 131, '2014-04-01 00:36:53.000000', 'consum', 0.0218, 'lps'),
	(619743, 131, '2014-04-01 00:36:54.000000', 'consum', 0.0214, 'lps'),
	(619744, 131, '2014-04-01 00:36:55.000000', 'consum', 0.0226, 'lps'),
	(619745, 131, '2014-04-01 00:36:56.000000', 'consum', 0.0217, 'lps'),
	(619746, 131, '2014-04-01 00:36:57.000000', 'consum', 0.0220, 'lps'),
	(619747, 131, '2014-04-01 00:36:58.000000', 'consum', 0.0218, 'lps'),
	(619748, 131, '2014-04-01 00:36:59.000000', 'consum', 0.0222, 'lps'),
	(619749, 131, '2014-04-01 00:37:00.000000', 'consum', 0.0227, 'lps'),
	(619750, 131, '2014-04-01 00:37:01.000000', 'consum', 0.0218, 'lps'),
	(619751, 131, '2014-04-01 00:37:02.000000', 'consum', 0.0218, 'lps'),
	(619752, 131, '2014-04-01 00:37:03.000000', 'consum', 0.0227, 'lps'),
	(619753, 131, '2014-04-01 00:37:04.000000', 'consum', 0.0212, 'lps'),
	(619754, 131, '2014-04-01 00:37:05.000000', 'consum', 0.0211, 'lps'),
	(619755, 131, '2014-04-01 00:37:06.000000', 'consum', 0.0229, 'lps'),
	(619756, 131, '2014-04-01 00:37:07.000000', 'consum', 0.0223, 'lps'),
	(619757, 131, '2014-04-01 00:37:08.000000', 'consum', 0.0216, 'lps'),
	(619758, 131, '2014-04-01 00:37:09.000000', 'consum', 0.0225, 'lps'),
	(619759, 131, '2014-04-01 00:37:10.000000', 'consum', 0.0225, 'lps'),
	(619760, 131, '2014-04-01 00:37:11.000000', 'consum', 0.0219, 'lps'),
	(619761, 131, '2014-04-01 00:37:12.000000', 'consum', 0.0213, 'lps'),
	(619762, 131, '2014-04-01 00:37:13.000000', 'consum', 0.0219, 'lps'),
	(619763, 131, '2014-04-01 00:37:14.000000', 'consum', 0.0225, 'lps'),
	(619764, 131, '2014-04-01 00:37:15.000000', 'consum', 0.0220, 'lps'),
	(619765, 131, '2014-04-01 00:37:16.000000', 'consum', 0.0214, 'lps'),
	(619766, 131, '2014-04-01 00:37:17.000000', 'consum', 0.0221, 'lps'),
	(619767, 131, '2014-04-01 00:37:18.000000', 'consum', 0.0212, 'lps'),
	(619768, 131, '2014-04-01 00:37:19.000000', 'consum', 0.0228, 'lps'),
	(619769, 131, '2014-04-01 00:37:20.000000', 'consum', 0.0216, 'lps'),
	(619770, 131, '2014-04-01 00:37:21.000000', 'consum', 0.0225, 'lps'),
	(619771, 131, '2014-04-01 00:37:22.000000', 'consum', 0.0228, 'lps'),
	(619772, 131, '2014-04-01 00:37:23.000000', 'consum', 0.0215, 'lps'),
	(619773, 131, '2014-04-01 00:37:24.000000', 'consum', 0.0224, 'lps'),
	(619774, 131, '2014-04-01 00:37:25.000000', 'consum', 0.0223, 'lps'),
	(619775, 131, '2014-04-01 00:37:26.000000', 'consum', 0.0216, 'lps'),
	(619776, 131, '2014-04-01 00:37:27.000000', 'consum', 0.0221, 'lps'),
	(619777, 131, '2014-04-01 00:37:28.000000', 'consum', 0.0226, 'lps'),
	(619778, 131, '2014-04-01 00:37:29.000000', 'consum', 0.0218, 'lps'),
	(619779, 131, '2014-04-01 00:37:30.000000', 'consum', 0.0224, 'lps'),
	(619780, 131, '2014-04-01 00:37:31.000000', 'consum', 0.0216, 'lps'),
	(619781, 131, '2014-04-01 00:37:32.000000', 'consum', 0.0218, 'lps'),
	(619782, 131, '2014-04-01 00:37:33.000000', 'consum', 0.0215, 'lps'),
	(619783, 131, '2014-04-01 00:37:34.000000', 'consum', 0.0229, 'lps'),
	(619784, 131, '2014-04-01 00:37:35.000000', 'consum', 0.0210, 'lps'),
	(619785, 131, '2014-04-01 00:37:36.000000', 'consum', 0.0216, 'lps'),
	(619786, 131, '2014-04-01 00:37:37.000000', 'consum', 0.0218, 'lps'),
	(619787, 131, '2014-04-01 00:37:38.000000', 'consum', 0.0214, 'lps'),
	(619788, 131, '2014-04-01 00:37:39.000000', 'consum', 0.0226, 'lps'),
	(619789, 131, '2014-04-01 00:37:40.000000', 'consum', 0.0221, 'lps'),
	(619790, 131, '2014-04-01 00:37:41.000000', 'consum', 0.0214, 'lps'),
	(619791, 131, '2014-04-01 00:37:42.000000', 'consum', 0.0219, 'lps'),
	(619792, 131, '2014-04-01 00:37:43.000000', 'consum', 0.0221, 'lps'),
	(619793, 131, '2014-04-01 00:37:44.000000', 'consum', 0.0222, 'lps'),
	(619794, 131, '2014-04-01 00:37:45.000000', 'consum', 0.0217, 'lps'),
	(619795, 131, '2014-04-01 00:37:46.000000', 'consum', 0.0228, 'lps'),
	(619796, 131, '2014-04-01 00:37:47.000000', 'consum', 0.0218, 'lps'),
	(619797, 131, '2014-04-01 00:37:48.000000', 'consum', 0.0219, 'lps'),
	(619798, 131, '2014-04-01 00:37:49.000000', 'consum', 0.0210, 'lps'),
	(619799, 131, '2014-04-01 00:37:50.000000', 'consum', 0.0224, 'lps'),
	(619800, 131, '2014-04-01 00:37:51.000000', 'consum', 0.0219, 'lps'),
	(619801, 131, '2014-04-01 00:37:52.000000', 'consum', 0.0215, 'lps'),
	(619802, 131, '2014-04-01 00:37:53.000000', 'consum', 0.0210, 'lps'),
	(619803, 131, '2014-04-01 00:37:54.000000', 'consum', 0.0214, 'lps'),
	(619804, 131, '2014-04-01 00:37:55.000000', 'consum', 0.0211, 'lps'),
	(619805, 131, '2014-04-01 00:37:56.000000', 'consum', 0.0225, 'lps'),
	(619806, 131, '2014-04-01 00:37:57.000000', 'consum', 0.0222, 'lps'),
	(619807, 131, '2014-04-01 00:37:58.000000', 'consum', 0.0227, 'lps'),
	(619808, 131, '2014-04-01 00:37:59.000000', 'consum', 0.0216, 'lps'),
	(619809, 131, '2014-04-01 00:38:00.000000', 'consum', 0.0211, 'lps'),
	(619810, 131, '2014-04-01 00:38:01.000000', 'consum', 0.0219, 'lps'),
	(619811, 131, '2014-04-01 00:38:02.000000', 'consum', 0.0211, 'lps'),
	(619812, 131, '2014-04-01 00:38:03.000000', 'consum', 0.0227, 'lps'),
	(619813, 131, '2014-04-01 00:38:04.000000', 'consum', 0.0215, 'lps'),
	(619814, 131, '2014-04-01 00:38:05.000000', 'consum', 0.0224, 'lps'),
	(619815, 131, '2014-04-01 00:38:06.000000', 'consum', 0.0224, 'lps'),
	(619816, 131, '2014-04-01 00:38:07.000000', 'consum', 0.0220, 'lps'),
	(619817, 131, '2014-04-01 00:38:08.000000', 'consum', 0.0218, 'lps'),
	(619818, 131, '2014-04-01 00:38:09.000000', 'consum', 0.0222, 'lps'),
	(619819, 131, '2014-04-01 00:38:10.000000', 'consum', 0.0226, 'lps'),
	(619820, 131, '2014-04-01 00:38:11.000000', 'consum', 0.0214, 'lps'),
	(619821, 131, '2014-04-01 00:38:12.000000', 'consum', 0.0223, 'lps'),
	(619822, 131, '2014-04-01 00:38:13.000000', 'consum', 0.0224, 'lps'),
	(619823, 131, '2014-04-01 00:38:14.000000', 'consum', 0.0221, 'lps'),
	(619824, 131, '2014-04-01 00:38:15.000000', 'consum', 0.0224, 'lps'),
	(619825, 131, '2014-04-01 00:38:16.000000', 'consum', 0.0225, 'lps'),
	(619826, 131, '2014-04-01 00:38:17.000000', 'consum', 0.0226, 'lps'),
	(619827, 131, '2014-04-01 00:38:18.000000', 'consum', 0.0224, 'lps'),
	(619828, 131, '2014-04-01 00:38:19.000000', 'consum', 0.0215, 'lps'),
	(619829, 131, '2014-04-01 00:38:20.000000', 'consum', 0.0212, 'lps'),
	(619830, 131, '2014-04-01 00:38:21.000000', 'consum', 0.0225, 'lps'),
	(619831, 131, '2014-04-01 00:38:22.000000', 'consum', 0.0220, 'lps'),
	(619832, 131, '2014-04-01 00:38:23.000000', 'consum', 0.0214, 'lps'),
	(619833, 131, '2014-04-01 00:38:24.000000', 'consum', 0.0223, 'lps'),
	(619834, 131, '2014-04-01 00:38:25.000000', 'consum', 0.0221, 'lps'),
	(619835, 131, '2014-04-01 00:38:26.000000', 'consum', 0.0229, 'lps'),
	(619836, 131, '2014-04-01 00:38:27.000000', 'consum', 0.0210, 'lps'),
	(619837, 131, '2014-04-01 00:38:28.000000', 'consum', 0.0213, 'lps'),
	(619838, 131, '2014-04-01 00:38:29.000000', 'consum', 0.0226, 'lps'),
	(619839, 131, '2014-04-01 00:38:30.000000', 'consum', 0.0223, 'lps'),
	(619840, 131, '2014-04-01 00:38:31.000000', 'consum', 0.0225, 'lps'),
	(619841, 131, '2014-04-01 00:38:32.000000', 'consum', 0.0229, 'lps'),
	(619842, 131, '2014-04-01 00:38:33.000000', 'consum', 0.0219, 'lps'),
	(619843, 131, '2014-04-01 00:38:34.000000', 'consum', 0.0221, 'lps'),
	(619844, 131, '2014-04-01 00:38:35.000000', 'consum', 0.0217, 'lps'),
	(619845, 131, '2014-04-01 00:38:36.000000', 'consum', 0.0212, 'lps'),
	(619846, 131, '2014-04-01 00:38:37.000000', 'consum', 0.0218, 'lps'),
	(619847, 131, '2014-04-01 00:38:38.000000', 'consum', 0.0228, 'lps'),
	(619848, 131, '2014-04-01 00:38:39.000000', 'consum', 0.0215, 'lps'),
	(619849, 131, '2014-04-01 00:38:40.000000', 'consum', 0.0220, 'lps'),
	(619850, 131, '2014-04-01 00:38:41.000000', 'consum', 0.0225, 'lps'),
	(619851, 131, '2014-04-01 00:38:42.000000', 'consum', 0.0218, 'lps'),
	(619852, 131, '2014-04-01 00:38:43.000000', 'consum', 0.0223, 'lps'),
	(619853, 131, '2014-04-01 00:38:44.000000', 'consum', 0.0211, 'lps'),
	(619854, 131, '2014-04-01 00:38:45.000000', 'consum', 0.0218, 'lps'),
	(619855, 131, '2014-04-01 00:38:46.000000', 'consum', 0.0229, 'lps'),
	(619856, 131, '2014-04-01 00:38:47.000000', 'consum', 0.0221, 'lps'),
	(619857, 131, '2014-04-01 00:38:48.000000', 'consum', 0.0229, 'lps'),
	(619858, 131, '2014-04-01 00:38:49.000000', 'consum', 0.0212, 'lps'),
	(619859, 131, '2014-04-01 00:38:50.000000', 'consum', 0.0223, 'lps'),
	(619860, 131, '2014-04-01 00:38:51.000000', 'consum', 0.0229, 'lps'),
	(619861, 131, '2014-04-01 00:38:52.000000', 'consum', 0.0226, 'lps'),
	(619862, 131, '2014-04-01 00:38:53.000000', 'consum', 0.0215, 'lps'),
	(619863, 131, '2014-04-01 00:38:54.000000', 'consum', 0.0227, 'lps'),
	(619864, 131, '2014-04-01 00:38:55.000000', 'consum', 0.0219, 'lps'),
	(619865, 131, '2014-04-01 00:38:56.000000', 'consum', 0.0223, 'lps'),
	(619866, 131, '2014-04-01 00:38:57.000000', 'consum', 0.0212, 'lps'),
	(619867, 131, '2014-04-01 00:38:58.000000', 'consum', 0.0220, 'lps'),
	(619868, 131, '2014-04-01 00:38:59.000000', 'consum', 0.0216, 'lps'),
	(619869, 131, '2014-04-01 00:39:00.000000', 'consum', 0.0228, 'lps'),
	(619870, 131, '2014-04-01 00:39:01.000000', 'consum', 0.0224, 'lps'),
	(619871, 131, '2014-04-01 00:39:02.000000', 'consum', 0.0225, 'lps'),
	(619872, 131, '2014-04-01 00:39:03.000000', 'consum', 0.0222, 'lps'),
	(619873, 131, '2014-04-01 00:39:04.000000', 'consum', 0.0229, 'lps'),
	(619874, 131, '2014-04-01 00:39:05.000000', 'consum', 0.0228, 'lps'),
	(619875, 131, '2014-04-01 00:39:06.000000', 'consum', 0.0225, 'lps'),
	(619876, 131, '2014-04-01 00:39:07.000000', 'consum', 0.0210, 'lps'),
	(619877, 131, '2014-04-01 00:39:08.000000', 'consum', 0.0225, 'lps'),
	(619878, 131, '2014-04-01 00:39:09.000000', 'consum', 0.0224, 'lps'),
	(619879, 131, '2014-04-01 00:39:10.000000', 'consum', 0.0218, 'lps'),
	(619880, 131, '2014-04-01 00:39:11.000000', 'consum', 0.0226, 'lps'),
	(619881, 131, '2014-04-01 00:39:12.000000', 'consum', 0.0227, 'lps'),
	(619882, 131, '2014-04-01 00:39:13.000000', 'consum', 0.0227, 'lps'),
	(619883, 131, '2014-04-01 00:39:14.000000', 'consum', 0.0225, 'lps'),
	(619884, 131, '2014-04-01 00:39:15.000000', 'consum', 0.0213, 'lps'),
	(619885, 131, '2014-04-01 00:39:16.000000', 'consum', 0.0220, 'lps'),
	(619886, 131, '2014-04-01 00:39:17.000000', 'consum', 0.0212, 'lps'),
	(619887, 131, '2014-04-01 00:39:18.000000', 'consum', 0.0212, 'lps'),
	(619888, 131, '2014-04-01 00:39:19.000000', 'consum', 0.0214, 'lps'),
	(619889, 131, '2014-04-01 00:39:20.000000', 'consum', 0.0226, 'lps'),
	(619890, 131, '2014-04-01 00:39:21.000000', 'consum', 0.0215, 'lps'),
	(619891, 131, '2014-04-01 00:39:22.000000', 'consum', 0.0210, 'lps'),
	(619892, 131, '2014-04-01 00:39:23.000000', 'consum', 0.0215, 'lps'),
	(619893, 131, '2014-04-01 00:39:24.000000', 'consum', 0.0216, 'lps'),
	(619894, 131, '2014-04-01 00:39:25.000000', 'consum', 0.0224, 'lps'),
	(619895, 131, '2014-04-01 00:39:26.000000', 'consum', 0.0223, 'lps'),
	(619896, 131, '2014-04-01 00:39:27.000000', 'consum', 0.0215, 'lps'),
	(619897, 131, '2014-04-01 00:39:28.000000', 'consum', 0.0216, 'lps'),
	(619898, 131, '2014-04-01 00:39:29.000000', 'consum', 0.0223, 'lps'),
	(619899, 131, '2014-04-01 00:39:30.000000', 'consum', 0.0220, 'lps'),
	(619900, 131, '2014-04-01 00:39:31.000000', 'consum', 0.0222, 'lps'),
	(619901, 131, '2014-04-01 00:39:32.000000', 'consum', 0.0218, 'lps'),
	(619902, 131, '2014-04-01 00:39:33.000000', 'consum', 0.0215, 'lps'),
	(619903, 131, '2014-04-01 00:39:34.000000', 'consum', 0.0210, 'lps'),
	(619904, 131, '2014-04-01 00:39:35.000000', 'consum', 0.0217, 'lps'),
	(619905, 131, '2014-04-01 00:39:36.000000', 'consum', 0.0226, 'lps'),
	(619906, 131, '2014-04-01 00:39:37.000000', 'consum', 0.0228, 'lps'),
	(619907, 131, '2014-04-01 00:39:38.000000', 'consum', 0.0213, 'lps'),
	(619908, 131, '2014-04-01 00:39:39.000000', 'consum', 0.0211, 'lps'),
	(619909, 131, '2014-04-01 00:39:40.000000', 'consum', 0.0229, 'lps'),
	(619910, 131, '2014-04-01 00:39:41.000000', 'consum', 0.0220, 'lps'),
	(619911, 131, '2014-04-01 00:39:42.000000', 'consum', 0.0225, 'lps'),
	(619912, 131, '2014-04-01 00:39:43.000000', 'consum', 0.0215, 'lps'),
	(619913, 131, '2014-04-01 00:39:44.000000', 'consum', 0.0228, 'lps'),
	(619914, 131, '2014-04-01 00:39:45.000000', 'consum', 0.0229, 'lps'),
	(619915, 131, '2014-04-01 00:39:46.000000', 'consum', 0.0229, 'lps'),
	(619916, 131, '2014-04-01 00:39:47.000000', 'consum', 0.0210, 'lps'),
	(619917, 131, '2014-04-01 00:39:48.000000', 'consum', 0.0213, 'lps'),
	(619918, 131, '2014-04-01 00:39:49.000000', 'consum', 0.0226, 'lps'),
	(619919, 131, '2014-04-01 00:39:50.000000', 'consum', 0.0221, 'lps'),
	(619920, 131, '2014-04-01 00:39:51.000000', 'consum', 0.0219, 'lps'),
	(619921, 131, '2014-04-01 00:39:52.000000', 'consum', 0.0220, 'lps'),
	(619922, 131, '2014-04-01 00:39:53.000000', 'consum', 0.0215, 'lps'),
	(619923, 131, '2014-04-01 00:39:54.000000', 'consum', 0.0226, 'lps'),
	(619924, 131, '2014-04-01 00:39:55.000000', 'consum', 0.0214, 'lps'),
	(619925, 131, '2014-04-01 00:39:56.000000', 'consum', 0.0224, 'lps'),
	(619926, 131, '2014-04-01 00:39:57.000000', 'consum', 0.0227, 'lps'),
	(619927, 131, '2014-04-01 00:39:58.000000', 'consum', 0.0216, 'lps'),
	(619928, 131, '2014-04-01 00:39:59.000000', 'consum', 0.0226, 'lps'),
	(619929, 131, '2014-04-01 00:40:00.000000', 'consum', 0.0216, 'lps'),
	(619930, 131, '2014-04-01 00:40:01.000000', 'consum', 0.0212, 'lps'),
	(619931, 131, '2014-04-01 00:40:02.000000', 'consum', 0.0221, 'lps'),
	(619932, 131, '2014-04-01 00:40:03.000000', 'consum', 0.0220, 'lps'),
	(619933, 131, '2014-04-01 00:40:04.000000', 'consum', 0.0229, 'lps'),
	(619934, 131, '2014-04-01 00:40:05.000000', 'consum', 0.0216, 'lps'),
	(619935, 131, '2014-04-01 00:40:06.000000', 'consum', 0.0221, 'lps'),
	(619936, 131, '2014-04-01 00:40:07.000000', 'consum', 0.0229, 'lps'),
	(619937, 131, '2014-04-01 00:40:08.000000', 'consum', 0.0213, 'lps'),
	(619938, 131, '2014-04-01 00:40:09.000000', 'consum', 0.0228, 'lps'),
	(619939, 131, '2014-04-01 00:40:10.000000', 'consum', 0.0212, 'lps'),
	(619940, 131, '2014-04-01 00:40:11.000000', 'consum', 0.0226, 'lps'),
	(619941, 131, '2014-04-01 00:40:12.000000', 'consum', 0.0223, 'lps'),
	(619942, 131, '2014-04-01 00:40:13.000000', 'consum', 0.0228, 'lps'),
	(619943, 131, '2014-04-01 00:40:14.000000', 'consum', 0.0222, 'lps'),
	(619944, 131, '2014-04-01 00:40:15.000000', 'consum', 0.0215, 'lps'),
	(619945, 131, '2014-04-01 00:40:16.000000', 'consum', 0.0223, 'lps'),
	(619946, 131, '2014-04-01 00:40:17.000000', 'consum', 0.0217, 'lps'),
	(619947, 131, '2014-04-01 00:40:18.000000', 'consum', 0.0228, 'lps'),
	(619948, 131, '2014-04-01 00:40:19.000000', 'consum', 0.0221, 'lps'),
	(619949, 131, '2014-04-01 00:40:20.000000', 'consum', 0.0210, 'lps'),
	(619950, 131, '2014-04-01 00:40:21.000000', 'consum', 0.0216, 'lps'),
	(619951, 131, '2014-04-01 00:40:22.000000', 'consum', 0.0221, 'lps'),
	(619952, 131, '2014-04-01 00:40:23.000000', 'consum', 0.0227, 'lps'),
	(619953, 131, '2014-04-01 00:40:24.000000', 'consum', 0.0224, 'lps'),
	(619954, 131, '2014-04-01 00:40:25.000000', 'consum', 0.0210, 'lps'),
	(619955, 131, '2014-04-01 00:40:26.000000', 'consum', 0.0228, 'lps'),
	(619956, 131, '2014-04-01 00:40:27.000000', 'consum', 0.0220, 'lps'),
	(619957, 131, '2014-04-01 00:40:28.000000', 'consum', 0.0227, 'lps'),
	(619958, 131, '2014-04-01 00:40:29.000000', 'consum', 0.0224, 'lps'),
	(619959, 131, '2014-04-01 00:40:30.000000', 'consum', 0.0211, 'lps'),
	(619960, 131, '2014-04-01 00:40:31.000000', 'consum', 0.0215, 'lps'),
	(619961, 131, '2014-04-01 00:40:32.000000', 'consum', 0.0229, 'lps'),
	(619962, 131, '2014-04-01 00:40:33.000000', 'consum', 0.0213, 'lps'),
	(619963, 131, '2014-04-01 00:40:34.000000', 'consum', 0.0227, 'lps'),
	(619964, 131, '2014-04-01 00:40:35.000000', 'consum', 0.0226, 'lps'),
	(619965, 131, '2014-04-01 00:40:36.000000', 'consum', 0.0221, 'lps'),
	(619966, 131, '2014-04-01 00:40:37.000000', 'consum', 0.0218, 'lps'),
	(619967, 131, '2014-04-01 00:40:38.000000', 'consum', 0.0218, 'lps'),
	(619968, 131, '2014-04-01 00:40:39.000000', 'consum', 0.0225, 'lps'),
	(619969, 131, '2014-04-01 00:40:40.000000', 'consum', 0.0222, 'lps'),
	(619970, 131, '2014-04-01 00:40:41.000000', 'consum', 0.0226, 'lps'),
	(619971, 131, '2014-04-01 00:40:42.000000', 'consum', 0.0213, 'lps'),
	(619972, 131, '2014-04-01 00:40:43.000000', 'consum', 0.0219, 'lps'),
	(619973, 131, '2014-04-01 00:40:44.000000', 'consum', 0.0227, 'lps'),
	(619974, 131, '2014-04-01 00:40:45.000000', 'consum', 0.0228, 'lps'),
	(619975, 131, '2014-04-01 00:40:46.000000', 'consum', 0.0229, 'lps'),
	(619976, 131, '2014-04-01 00:40:47.000000', 'consum', 0.0212, 'lps'),
	(619977, 131, '2014-04-01 00:40:48.000000', 'consum', 0.0223, 'lps'),
	(619978, 131, '2014-04-01 00:40:49.000000', 'consum', 0.0210, 'lps'),
	(619979, 131, '2014-04-01 00:40:50.000000', 'consum', 0.0213, 'lps'),
	(619980, 131, '2014-04-01 00:40:51.000000', 'consum', 0.0226, 'lps'),
	(619981, 131, '2014-04-01 00:40:52.000000', 'consum', 0.0220, 'lps'),
	(619982, 131, '2014-04-01 00:40:53.000000', 'consum', 0.0213, 'lps'),
	(619983, 131, '2014-04-01 00:40:54.000000', 'consum', 0.0216, 'lps'),
	(619984, 131, '2014-04-01 00:40:55.000000', 'consum', 0.0211, 'lps'),
	(619985, 131, '2014-04-01 00:40:56.000000', 'consum', 0.0217, 'lps'),
	(619986, 131, '2014-04-01 00:40:57.000000', 'consum', 0.0221, 'lps'),
	(619987, 131, '2014-04-01 00:40:58.000000', 'consum', 0.0226, 'lps'),
	(619988, 131, '2014-04-01 00:40:59.000000', 'consum', 0.0219, 'lps'),
	(619989, 131, '2014-04-01 00:41:00.000000', 'consum', 0.0227, 'lps'),
	(619990, 131, '2014-04-01 00:41:01.000000', 'consum', 0.0228, 'lps'),
	(619991, 131, '2014-04-01 00:41:02.000000', 'consum', 0.0211, 'lps'),
	(619992, 131, '2014-04-01 00:41:03.000000', 'consum', 0.0222, 'lps'),
	(619993, 131, '2014-04-01 00:41:04.000000', 'consum', 0.0225, 'lps'),
	(619994, 131, '2014-04-01 00:41:05.000000', 'consum', 0.0211, 'lps'),
	(619995, 131, '2014-04-01 00:41:06.000000', 'consum', 0.0228, 'lps'),
	(619996, 131, '2014-04-01 00:41:07.000000', 'consum', 0.0219, 'lps'),
	(619997, 131, '2014-04-01 00:41:08.000000', 'consum', 0.0222, 'lps'),
	(619998, 131, '2014-04-01 00:41:09.000000', 'consum', 0.0223, 'lps'),
	(619999, 131, '2014-04-01 00:41:10.000000', 'consum', 0.0220, 'lps'),
	(620000, 131, '2014-04-01 00:41:11.000000', 'consum', 0.0222, 'lps'),
	(620001, 131, '2014-04-01 00:41:12.000000', 'consum', 0.0221, 'lps'),
	(620002, 131, '2014-04-01 00:41:13.000000', 'consum', 0.0210, 'lps'),
	(620003, 131, '2014-04-01 00:41:14.000000', 'consum', 0.0219, 'lps'),
	(620004, 131, '2014-04-01 00:41:15.000000', 'consum', 0.0213, 'lps'),
	(620005, 131, '2014-04-01 00:41:16.000000', 'consum', 0.0218, 'lps'),
	(620006, 131, '2014-04-01 00:41:17.000000', 'consum', 0.0224, 'lps'),
	(620007, 131, '2014-04-01 00:41:18.000000', 'consum', 0.0214, 'lps'),
	(620008, 131, '2014-04-01 00:41:19.000000', 'consum', 0.0229, 'lps'),
	(620009, 131, '2014-04-01 00:41:20.000000', 'consum', 0.0213, 'lps'),
	(620010, 131, '2014-04-01 00:41:21.000000', 'consum', 0.0210, 'lps'),
	(620011, 131, '2014-04-01 00:41:22.000000', 'consum', 0.0219, 'lps'),
	(620012, 131, '2014-04-01 00:41:23.000000', 'consum', 0.0217, 'lps'),
	(620013, 131, '2014-04-01 00:41:24.000000', 'consum', 0.0220, 'lps'),
	(620014, 131, '2014-04-01 00:41:25.000000', 'consum', 0.0217, 'lps'),
	(620015, 131, '2014-04-01 00:41:26.000000', 'consum', 0.0218, 'lps'),
	(620016, 131, '2014-04-01 00:41:27.000000', 'consum', 0.0227, 'lps'),
	(620017, 131, '2014-04-01 00:41:28.000000', 'consum', 0.0213, 'lps'),
	(620018, 131, '2014-04-01 00:41:29.000000', 'consum', 0.0216, 'lps'),
	(620019, 131, '2014-04-01 00:41:30.000000', 'consum', 0.0229, 'lps'),
	(620020, 131, '2014-04-01 00:41:31.000000', 'consum', 0.0227, 'lps'),
	(620021, 131, '2014-04-01 00:41:32.000000', 'consum', 0.0221, 'lps'),
	(620022, 131, '2014-04-01 00:41:33.000000', 'consum', 0.0214, 'lps'),
	(620023, 131, '2014-04-01 00:41:34.000000', 'consum', 0.0218, 'lps'),
	(620024, 131, '2014-04-01 00:41:35.000000', 'consum', 0.0216, 'lps'),
	(620025, 131, '2014-04-01 00:41:36.000000', 'consum', 0.0219, 'lps'),
	(620026, 131, '2014-04-01 00:41:37.000000', 'consum', 0.0218, 'lps'),
	(620027, 131, '2014-04-01 00:41:38.000000', 'consum', 0.0224, 'lps'),
	(620028, 131, '2014-04-01 00:41:39.000000', 'consum', 0.0214, 'lps'),
	(620029, 131, '2014-04-01 00:41:40.000000', 'consum', 0.0212, 'lps'),
	(620030, 131, '2014-04-01 00:41:41.000000', 'consum', 0.0225, 'lps'),
	(620031, 131, '2014-04-01 00:41:42.000000', 'consum', 0.0222, 'lps'),
	(620032, 131, '2014-04-01 00:41:43.000000', 'consum', 0.0226, 'lps'),
	(620033, 131, '2014-04-01 00:41:44.000000', 'consum', 0.0214, 'lps'),
	(620034, 131, '2014-04-01 00:41:45.000000', 'consum', 0.0222, 'lps'),
	(620035, 131, '2014-04-01 00:41:46.000000', 'consum', 0.0216, 'lps'),
	(620036, 131, '2014-04-01 00:41:47.000000', 'consum', 0.0228, 'lps'),
	(620037, 131, '2014-04-01 00:41:48.000000', 'consum', 0.0223, 'lps'),
	(620038, 131, '2014-04-01 00:41:49.000000', 'consum', 0.0221, 'lps'),
	(620039, 131, '2014-04-01 00:41:50.000000', 'consum', 0.0227, 'lps'),
	(620040, 131, '2014-04-01 00:41:51.000000', 'consum', 0.0222, 'lps'),
	(620041, 131, '2014-04-01 00:41:52.000000', 'consum', 0.0220, 'lps'),
	(620042, 131, '2014-04-01 00:41:53.000000', 'consum', 0.0225, 'lps'),
	(620043, 131, '2014-04-01 00:41:54.000000', 'consum', 0.0217, 'lps'),
	(620044, 131, '2014-04-01 00:41:55.000000', 'consum', 0.0217, 'lps'),
	(620045, 131, '2014-04-01 00:41:56.000000', 'consum', 0.0226, 'lps'),
	(620046, 131, '2014-04-01 00:41:57.000000', 'consum', 0.0228, 'lps'),
	(620047, 131, '2014-04-01 00:41:58.000000', 'consum', 0.0214, 'lps'),
	(620048, 131, '2014-04-01 00:41:59.000000', 'consum', 0.0216, 'lps'),
	(620049, 131, '2014-04-01 00:42:00.000000', 'consum', 0.0210, 'lps'),
	(620050, 131, '2014-04-01 00:42:01.000000', 'consum', 0.0213, 'lps'),
	(620051, 131, '2014-04-01 00:42:02.000000', 'consum', 0.0223, 'lps'),
	(620052, 131, '2014-04-01 00:42:03.000000', 'consum', 0.0229, 'lps'),
	(620053, 131, '2014-04-01 00:42:04.000000', 'consum', 0.0224, 'lps'),
	(620054, 131, '2014-04-01 00:42:05.000000', 'consum', 0.0223, 'lps'),
	(620055, 131, '2014-04-01 00:42:06.000000', 'consum', 0.0216, 'lps'),
	(620056, 131, '2014-04-01 00:42:07.000000', 'consum', 0.0221, 'lps'),
	(620057, 131, '2014-04-01 00:42:08.000000', 'consum', 0.0225, 'lps'),
	(620058, 131, '2014-04-01 00:42:09.000000', 'consum', 0.0215, 'lps'),
	(620059, 131, '2014-04-01 00:42:10.000000', 'consum', 0.0210, 'lps'),
	(620060, 131, '2014-04-01 00:42:11.000000', 'consum', 0.0215, 'lps'),
	(620061, 131, '2014-04-01 00:42:12.000000', 'consum', 0.0217, 'lps'),
	(620062, 131, '2014-04-01 00:42:13.000000', 'consum', 0.0228, 'lps'),
	(620063, 131, '2014-04-01 00:42:14.000000', 'consum', 0.0219, 'lps'),
	(620064, 131, '2014-04-01 00:42:15.000000', 'consum', 0.0221, 'lps'),
	(620065, 131, '2014-04-01 00:42:16.000000', 'consum', 0.0221, 'lps'),
	(620066, 131, '2014-04-01 00:42:17.000000', 'consum', 0.0212, 'lps'),
	(620067, 131, '2014-04-01 00:42:18.000000', 'consum', 0.0227, 'lps'),
	(620068, 131, '2014-04-01 00:42:19.000000', 'consum', 0.0211, 'lps'),
	(620069, 131, '2014-04-01 00:42:20.000000', 'consum', 0.0222, 'lps'),
	(620070, 131, '2014-04-01 00:42:21.000000', 'consum', 0.0229, 'lps'),
	(620071, 131, '2014-04-01 00:42:22.000000', 'consum', 0.0211, 'lps'),
	(620072, 131, '2014-04-01 00:42:23.000000', 'consum', 0.0217, 'lps'),
	(620073, 131, '2014-04-01 00:42:24.000000', 'consum', 0.0222, 'lps'),
	(620074, 131, '2014-04-01 00:42:25.000000', 'consum', 0.0228, 'lps'),
	(620075, 131, '2014-04-01 00:42:26.000000', 'consum', 0.0227, 'lps'),
	(620076, 131, '2014-04-01 00:42:27.000000', 'consum', 0.0219, 'lps'),
	(620077, 131, '2014-04-01 00:42:28.000000', 'consum', 0.0227, 'lps'),
	(620078, 131, '2014-04-01 00:42:29.000000', 'consum', 0.0226, 'lps'),
	(620079, 131, '2014-04-01 00:42:30.000000', 'consum', 0.0219, 'lps'),
	(620080, 131, '2014-04-01 00:42:31.000000', 'consum', 0.0229, 'lps'),
	(620081, 131, '2014-04-01 00:42:32.000000', 'consum', 0.0216, 'lps'),
	(620082, 131, '2014-04-01 00:42:33.000000', 'consum', 0.0227, 'lps'),
	(620083, 131, '2014-04-01 00:42:34.000000', 'consum', 0.0214, 'lps'),
	(620084, 131, '2014-04-01 00:42:35.000000', 'consum', 0.0221, 'lps'),
	(620085, 131, '2014-04-01 00:42:36.000000', 'consum', 0.0213, 'lps'),
	(620086, 131, '2014-04-01 00:42:37.000000', 'consum', 0.0215, 'lps'),
	(620087, 131, '2014-04-01 00:42:38.000000', 'consum', 0.0225, 'lps'),
	(620088, 131, '2014-04-01 00:42:39.000000', 'consum', 0.0229, 'lps'),
	(620089, 131, '2014-04-01 00:42:40.000000', 'consum', 0.0222, 'lps'),
	(620090, 131, '2014-04-01 00:42:41.000000', 'consum', 0.0212, 'lps'),
	(620091, 131, '2014-04-01 00:42:42.000000', 'consum', 0.0226, 'lps'),
	(620092, 131, '2014-04-01 00:42:43.000000', 'consum', 0.0226, 'lps'),
	(620093, 131, '2014-04-01 00:42:44.000000', 'consum', 0.0220, 'lps'),
	(620094, 131, '2014-04-01 00:42:45.000000', 'consum', 0.0213, 'lps'),
	(620095, 131, '2014-04-01 00:42:46.000000', 'consum', 0.0215, 'lps'),
	(620096, 131, '2014-04-01 00:42:47.000000', 'consum', 0.0228, 'lps'),
	(620097, 131, '2014-04-01 00:42:48.000000', 'consum', 0.0227, 'lps'),
	(620098, 131, '2014-04-01 00:42:49.000000', 'consum', 0.0219, 'lps'),
	(620099, 131, '2014-04-01 00:42:50.000000', 'consum', 0.0223, 'lps'),
	(620100, 131, '2014-04-01 00:42:51.000000', 'consum', 0.0211, 'lps'),
	(620101, 131, '2014-04-01 00:42:52.000000', 'consum', 0.0218, 'lps'),
	(620102, 131, '2014-04-01 00:42:53.000000', 'consum', 0.0225, 'lps'),
	(620103, 131, '2014-04-01 00:42:54.000000', 'consum', 0.0221, 'lps'),
	(620104, 131, '2014-04-01 00:42:55.000000', 'consum', 0.0220, 'lps'),
	(620105, 131, '2014-04-01 00:42:56.000000', 'consum', 0.0227, 'lps'),
	(620106, 131, '2014-04-01 00:42:57.000000', 'consum', 0.0225, 'lps'),
	(620107, 131, '2014-04-01 00:42:58.000000', 'consum', 0.0214, 'lps'),
	(620108, 131, '2014-04-01 00:42:59.000000', 'consum', 0.0227, 'lps'),
	(620109, 131, '2014-04-01 00:43:00.000000', 'consum', 0.0222, 'lps'),
	(620110, 131, '2014-04-01 00:43:01.000000', 'consum', 0.0222, 'lps'),
	(620111, 131, '2014-04-01 00:43:02.000000', 'consum', 0.0212, 'lps'),
	(620112, 131, '2014-04-01 00:43:03.000000', 'consum', 0.0226, 'lps'),
	(620113, 131, '2014-04-01 00:43:04.000000', 'consum', 0.0224, 'lps'),
	(620114, 131, '2014-04-01 00:43:05.000000', 'consum', 0.0214, 'lps'),
	(620115, 131, '2014-04-01 00:43:06.000000', 'consum', 0.0228, 'lps'),
	(620116, 131, '2014-04-01 00:43:07.000000', 'consum', 0.0210, 'lps'),
	(620117, 131, '2014-04-01 00:43:08.000000', 'consum', 0.0213, 'lps'),
	(620118, 131, '2014-04-01 00:43:09.000000', 'consum', 0.0229, 'lps'),
	(620119, 131, '2014-04-01 00:43:10.000000', 'consum', 0.0215, 'lps'),
	(620120, 131, '2014-04-01 00:43:11.000000', 'consum', 0.0217, 'lps'),
	(620121, 131, '2014-04-01 00:43:12.000000', 'consum', 0.0213, 'lps'),
	(620122, 131, '2014-04-01 00:43:13.000000', 'consum', 0.0225, 'lps'),
	(620123, 131, '2014-04-01 00:43:14.000000', 'consum', 0.0214, 'lps'),
	(620124, 131, '2014-04-01 00:43:15.000000', 'consum', 0.0227, 'lps'),
	(620125, 131, '2014-04-01 00:43:16.000000', 'consum', 0.0225, 'lps'),
	(620126, 131, '2014-04-01 00:43:17.000000', 'consum', 0.0213, 'lps'),
	(620127, 131, '2014-04-01 00:43:18.000000', 'consum', 0.0219, 'lps'),
	(620128, 131, '2014-04-01 00:43:19.000000', 'consum', 0.0226, 'lps'),
	(620129, 131, '2014-04-01 00:43:20.000000', 'consum', 0.0224, 'lps'),
	(620130, 131, '2014-04-01 00:43:21.000000', 'consum', 0.0214, 'lps'),
	(620131, 131, '2014-04-01 00:43:22.000000', 'consum', 0.0228, 'lps'),
	(620132, 131, '2014-04-01 00:43:23.000000', 'consum', 0.0227, 'lps'),
	(620133, 131, '2014-04-01 00:43:24.000000', 'consum', 0.0223, 'lps'),
	(620134, 131, '2014-04-01 00:43:25.000000', 'consum', 0.0225, 'lps'),
	(620135, 131, '2014-04-01 00:43:26.000000', 'consum', 0.0224, 'lps'),
	(620136, 131, '2014-04-01 00:43:27.000000', 'consum', 0.0218, 'lps'),
	(620137, 131, '2014-04-01 00:43:28.000000', 'consum', 0.0227, 'lps'),
	(620138, 131, '2014-04-01 00:43:29.000000', 'consum', 0.0212, 'lps'),
	(620139, 131, '2014-04-01 00:43:30.000000', 'consum', 0.0211, 'lps'),
	(620140, 131, '2014-04-01 00:43:31.000000', 'consum', 0.0229, 'lps'),
	(620141, 131, '2014-04-01 00:43:32.000000', 'consum', 0.0221, 'lps'),
	(620142, 131, '2014-04-01 00:43:33.000000', 'consum', 0.0228, 'lps'),
	(620143, 131, '2014-04-01 00:43:34.000000', 'consum', 0.0226, 'lps'),
	(620144, 131, '2014-04-01 00:43:35.000000', 'consum', 0.0220, 'lps'),
	(620145, 131, '2014-04-01 00:43:36.000000', 'consum', 0.0212, 'lps'),
	(620146, 131, '2014-04-01 00:43:37.000000', 'consum', 0.0229, 'lps'),
	(620147, 131, '2014-04-01 00:43:38.000000', 'consum', 0.0221, 'lps'),
	(620148, 131, '2014-04-01 00:43:39.000000', 'consum', 0.0229, 'lps'),
	(620149, 131, '2014-04-01 00:43:40.000000', 'consum', 0.0212, 'lps'),
	(620150, 131, '2014-04-01 00:43:41.000000', 'consum', 0.0224, 'lps'),
	(620151, 131, '2014-04-01 00:43:42.000000', 'consum', 0.0213, 'lps'),
	(620152, 131, '2014-04-01 00:43:43.000000', 'consum', 0.0224, 'lps'),
	(620153, 131, '2014-04-01 00:43:44.000000', 'consum', 0.0210, 'lps'),
	(620154, 131, '2014-04-01 00:43:45.000000', 'consum', 0.0210, 'lps'),
	(620155, 131, '2014-04-01 00:43:46.000000', 'consum', 0.0211, 'lps'),
	(620156, 131, '2014-04-01 00:43:47.000000', 'consum', 0.0214, 'lps'),
	(620157, 131, '2014-04-01 00:43:48.000000', 'consum', 0.0227, 'lps'),
	(620158, 131, '2014-04-01 00:43:49.000000', 'consum', 0.0225, 'lps'),
	(620159, 131, '2014-04-01 00:43:50.000000', 'consum', 0.0215, 'lps'),
	(620160, 131, '2014-04-01 00:43:51.000000', 'consum', 0.0229, 'lps'),
	(620161, 131, '2014-04-01 00:43:52.000000', 'consum', 0.0210, 'lps'),
	(620162, 131, '2014-04-01 00:43:53.000000', 'consum', 0.0214, 'lps'),
	(620163, 131, '2014-04-01 00:43:54.000000', 'consum', 0.0229, 'lps'),
	(620164, 131, '2014-04-01 00:43:55.000000', 'consum', 0.0213, 'lps'),
	(620165, 131, '2014-04-01 00:43:56.000000', 'consum', 0.0211, 'lps'),
	(620166, 131, '2014-04-01 00:43:57.000000', 'consum', 0.0227, 'lps'),
	(620167, 131, '2014-04-01 00:43:58.000000', 'consum', 0.0213, 'lps'),
	(620168, 131, '2014-04-01 00:43:59.000000', 'consum', 0.0213, 'lps'),
	(620169, 131, '2014-04-01 00:44:00.000000', 'consum', 0.0215, 'lps'),
	(620170, 131, '2014-04-01 00:44:01.000000', 'consum', 0.0210, 'lps'),
	(620171, 131, '2014-04-01 00:44:02.000000', 'consum', 0.0212, 'lps'),
	(620172, 131, '2014-04-01 00:44:03.000000', 'consum', 0.0222, 'lps'),
	(620173, 131, '2014-04-01 00:44:04.000000', 'consum', 0.0223, 'lps'),
	(620174, 131, '2014-04-01 00:44:05.000000', 'consum', 0.0220, 'lps'),
	(620175, 131, '2014-04-01 00:44:06.000000', 'consum', 0.0224, 'lps'),
	(620176, 131, '2014-04-01 00:44:07.000000', 'consum', 0.0227, 'lps'),
	(620177, 131, '2014-04-01 00:44:08.000000', 'consum', 0.0215, 'lps'),
	(620178, 131, '2014-04-01 00:44:09.000000', 'consum', 0.0224, 'lps'),
	(620179, 131, '2014-04-01 00:44:10.000000', 'consum', 0.0227, 'lps'),
	(620180, 131, '2014-04-01 00:44:11.000000', 'consum', 0.0214, 'lps'),
	(620181, 131, '2014-04-01 00:44:12.000000', 'consum', 0.0217, 'lps'),
	(620182, 131, '2014-04-01 00:44:13.000000', 'consum', 0.0214, 'lps'),
	(620183, 131, '2014-04-01 00:44:14.000000', 'consum', 0.0212, 'lps'),
	(620184, 131, '2014-04-01 00:44:15.000000', 'consum', 0.0227, 'lps'),
	(620185, 131, '2014-04-01 00:44:16.000000', 'consum', 0.0228, 'lps'),
	(620186, 131, '2014-04-01 00:44:17.000000', 'consum', 0.0211, 'lps'),
	(620187, 131, '2014-04-01 00:44:18.000000', 'consum', 0.0222, 'lps'),
	(620188, 131, '2014-04-01 00:44:19.000000', 'consum', 0.0228, 'lps'),
	(620189, 131, '2014-04-01 00:44:20.000000', 'consum', 0.0223, 'lps'),
	(620190, 131, '2014-04-01 00:44:21.000000', 'consum', 0.0223, 'lps'),
	(620191, 131, '2014-04-01 00:44:22.000000', 'consum', 0.0215, 'lps'),
	(620192, 131, '2014-04-01 00:44:23.000000', 'consum', 0.0218, 'lps'),
	(620193, 131, '2014-04-01 00:44:24.000000', 'consum', 0.0215, 'lps'),
	(620194, 131, '2014-04-01 00:44:25.000000', 'consum', 0.0211, 'lps'),
	(620195, 131, '2014-04-01 00:44:26.000000', 'consum', 0.0221, 'lps'),
	(620196, 131, '2014-04-01 00:44:27.000000', 'consum', 0.0224, 'lps'),
	(620197, 131, '2014-04-01 00:44:28.000000', 'consum', 0.0225, 'lps'),
	(620198, 131, '2014-04-01 00:44:29.000000', 'consum', 0.0226, 'lps'),
	(620199, 131, '2014-04-01 00:44:30.000000', 'consum', 0.0224, 'lps'),
	(620200, 131, '2014-04-01 00:44:31.000000', 'consum', 0.0212, 'lps'),
	(620201, 131, '2014-04-01 00:44:32.000000', 'consum', 0.0219, 'lps'),
	(620202, 131, '2014-04-01 00:44:33.000000', 'consum', 0.0228, 'lps'),
	(620203, 131, '2014-04-01 00:44:34.000000', 'consum', 0.0213, 'lps'),
	(620204, 131, '2014-04-01 00:44:35.000000', 'consum', 0.0211, 'lps'),
	(620205, 131, '2014-04-01 00:44:36.000000', 'consum', 0.0227, 'lps'),
	(620206, 131, '2014-04-01 00:44:37.000000', 'consum', 0.0212, 'lps'),
	(620207, 131, '2014-04-01 00:44:38.000000', 'consum', 0.0210, 'lps'),
	(620208, 131, '2014-04-01 00:44:39.000000', 'consum', 0.0224, 'lps'),
	(620209, 131, '2014-04-01 00:44:40.000000', 'consum', 0.0219, 'lps'),
	(620210, 131, '2014-04-01 00:44:41.000000', 'consum', 0.0216, 'lps'),
	(620211, 131, '2014-04-01 00:44:42.000000', 'consum', 0.0213, 'lps'),
	(620212, 131, '2014-04-01 00:44:43.000000', 'consum', 0.0227, 'lps'),
	(620213, 131, '2014-04-01 00:44:44.000000', 'consum', 0.0226, 'lps'),
	(620214, 131, '2014-04-01 00:44:45.000000', 'consum', 0.0218, 'lps'),
	(620215, 131, '2014-04-01 00:44:46.000000', 'consum', 0.0225, 'lps'),
	(620216, 131, '2014-04-01 00:44:47.000000', 'consum', 0.0219, 'lps'),
	(620217, 131, '2014-04-01 00:44:48.000000', 'consum', 0.0211, 'lps'),
	(620218, 131, '2014-04-01 00:44:49.000000', 'consum', 0.0228, 'lps'),
	(620219, 131, '2014-04-01 00:44:50.000000', 'consum', 0.0220, 'lps'),
	(620220, 131, '2014-04-01 00:44:51.000000', 'consum', 0.0226, 'lps'),
	(620221, 131, '2014-04-01 00:44:52.000000', 'consum', 0.0218, 'lps'),
	(620222, 131, '2014-04-01 00:44:53.000000', 'consum', 0.0226, 'lps'),
	(620223, 131, '2014-04-01 00:44:54.000000', 'consum', 0.0224, 'lps'),
	(620224, 131, '2014-04-01 00:44:55.000000', 'consum', 0.0214, 'lps'),
	(620225, 131, '2014-04-01 00:44:56.000000', 'consum', 0.0226, 'lps'),
	(620226, 131, '2014-04-01 00:44:57.000000', 'consum', 0.0220, 'lps'),
	(620227, 131, '2014-04-01 00:44:58.000000', 'consum', 0.0210, 'lps'),
	(620228, 131, '2014-04-01 00:44:59.000000', 'consum', 0.0223, 'lps'),
	(620229, 131, '2014-04-01 00:45:00.000000', 'consum', 0.0217, 'lps'),
	(620230, 131, '2014-04-01 00:45:01.000000', 'consum', 0.0225, 'lps'),
	(620231, 131, '2014-04-01 00:45:02.000000', 'consum', 0.0225, 'lps'),
	(620232, 131, '2014-04-01 00:45:03.000000', 'consum', 0.0219, 'lps'),
	(620233, 131, '2014-04-01 00:45:04.000000', 'consum', 0.0211, 'lps'),
	(620234, 131, '2014-04-01 00:45:05.000000', 'consum', 0.0228, 'lps'),
	(620235, 131, '2014-04-01 00:45:06.000000', 'consum', 0.0218, 'lps'),
	(620236, 131, '2014-04-01 00:45:07.000000', 'consum', 0.0216, 'lps'),
	(620237, 131, '2014-04-01 00:45:08.000000', 'consum', 0.0217, 'lps'),
	(620238, 131, '2014-04-01 00:45:09.000000', 'consum', 0.0227, 'lps'),
	(620239, 131, '2014-04-01 00:45:10.000000', 'consum', 0.0217, 'lps'),
	(620240, 131, '2014-04-01 00:45:11.000000', 'consum', 0.0212, 'lps'),
	(620241, 131, '2014-04-01 00:45:12.000000', 'consum', 0.0221, 'lps'),
	(620242, 131, '2014-04-01 00:45:13.000000', 'consum', 0.0220, 'lps'),
	(620243, 131, '2014-04-01 00:45:14.000000', 'consum', 0.0227, 'lps'),
	(620244, 131, '2014-04-01 00:45:15.000000', 'consum', 0.0225, 'lps'),
	(620245, 131, '2014-04-01 00:45:16.000000', 'consum', 0.0217, 'lps'),
	(620246, 131, '2014-04-01 00:45:17.000000', 'consum', 0.0217, 'lps'),
	(620247, 131, '2014-04-01 00:45:18.000000', 'consum', 0.0227, 'lps'),
	(620248, 131, '2014-04-01 00:45:19.000000', 'consum', 0.0212, 'lps'),
	(620249, 131, '2014-04-01 00:45:20.000000', 'consum', 0.0211, 'lps'),
	(620250, 131, '2014-04-01 00:45:21.000000', 'consum', 0.0229, 'lps'),
	(620251, 131, '2014-04-01 00:45:22.000000', 'consum', 0.0222, 'lps'),
	(620252, 131, '2014-04-01 00:45:23.000000', 'consum', 0.0215, 'lps'),
	(620253, 131, '2014-04-01 00:45:24.000000', 'consum', 0.0217, 'lps'),
	(620254, 131, '2014-04-01 00:45:25.000000', 'consum', 0.0211, 'lps'),
	(620255, 131, '2014-04-01 00:45:26.000000', 'consum', 0.0214, 'lps'),
	(620256, 131, '2014-04-01 00:45:27.000000', 'consum', 0.0227, 'lps'),
	(620257, 131, '2014-04-01 00:45:28.000000', 'consum', 0.0224, 'lps'),
	(620258, 131, '2014-04-01 00:45:29.000000', 'consum', 0.0211, 'lps'),
	(620259, 131, '2014-04-01 00:45:30.000000', 'consum', 0.0214, 'lps'),
	(620260, 131, '2014-04-01 00:45:31.000000', 'consum', 0.0226, 'lps'),
	(620261, 131, '2014-04-01 00:45:32.000000', 'consum', 0.0217, 'lps'),
	(620262, 131, '2014-04-01 00:45:33.000000', 'consum', 0.0218, 'lps'),
	(620263, 131, '2014-04-01 00:45:34.000000', 'consum', 0.0210, 'lps'),
	(620264, 131, '2014-04-01 00:45:35.000000', 'consum', 0.0227, 'lps'),
	(620265, 131, '2014-04-01 00:45:36.000000', 'consum', 0.0215, 'lps'),
	(620266, 131, '2014-04-01 00:45:37.000000', 'consum', 0.0224, 'lps'),
	(620267, 131, '2014-04-01 00:45:38.000000', 'consum', 0.0227, 'lps'),
	(620268, 131, '2014-04-01 00:45:39.000000', 'consum', 0.0212, 'lps'),
	(620269, 131, '2014-04-01 00:45:40.000000', 'consum', 0.0211, 'lps'),
	(620270, 131, '2014-04-01 00:45:41.000000', 'consum', 0.0229, 'lps'),
	(620271, 131, '2014-04-01 00:45:42.000000', 'consum', 0.0221, 'lps'),
	(620272, 131, '2014-04-01 00:45:43.000000', 'consum', 0.0211, 'lps'),
	(620273, 131, '2014-04-01 00:45:44.000000', 'consum', 0.0222, 'lps'),
	(620274, 131, '2014-04-01 00:45:45.000000', 'consum', 0.0227, 'lps'),
	(620275, 131, '2014-04-01 00:45:46.000000', 'consum', 0.0219, 'lps'),
	(620276, 131, '2014-04-01 00:45:47.000000', 'consum', 0.0225, 'lps'),
	(620277, 131, '2014-04-01 00:45:48.000000', 'consum', 0.0217, 'lps'),
	(620278, 131, '2014-04-01 00:45:49.000000', 'consum', 0.0223, 'lps'),
	(620279, 131, '2014-04-01 00:45:50.000000', 'consum', 0.0215, 'lps'),
	(620280, 131, '2014-04-01 00:45:51.000000', 'consum', 0.0217, 'lps'),
	(620281, 131, '2014-04-01 00:45:52.000000', 'consum', 0.0210, 'lps'),
	(620282, 131, '2014-04-01 00:45:53.000000', 'consum', 0.0211, 'lps'),
	(620283, 131, '2014-04-01 00:45:54.000000', 'consum', 0.0215, 'lps'),
	(620284, 131, '2014-04-01 00:45:55.000000', 'consum', 0.0212, 'lps'),
	(620285, 131, '2014-04-01 00:45:56.000000', 'consum', 0.0225, 'lps'),
	(620286, 131, '2014-04-01 00:45:57.000000', 'consum', 0.0221, 'lps'),
	(620287, 131, '2014-04-01 00:45:58.000000', 'consum', 0.0220, 'lps'),
	(620288, 131, '2014-04-01 00:45:59.000000', 'consum', 0.0227, 'lps'),
	(620289, 131, '2014-04-01 00:46:00.000000', 'consum', 0.0226, 'lps'),
	(620290, 131, '2014-04-01 00:46:01.000000', 'consum', 0.0220, 'lps'),
	(620291, 131, '2014-04-01 00:46:02.000000', 'consum', 0.0212, 'lps'),
	(620292, 131, '2014-04-01 00:46:03.000000', 'consum', 0.0210, 'lps'),
	(620293, 131, '2014-04-01 00:46:04.000000', 'consum', 0.0225, 'lps'),
	(620294, 131, '2014-04-01 00:46:05.000000', 'consum', 0.0224, 'lps'),
	(620295, 131, '2014-04-01 00:46:06.000000', 'consum', 0.0219, 'lps'),
	(620296, 131, '2014-04-01 00:46:07.000000', 'consum', 0.0210, 'lps'),
	(620297, 131, '2014-04-01 00:46:08.000000', 'consum', 0.0225, 'lps'),
	(620298, 131, '2014-04-01 00:46:09.000000', 'consum', 0.0224, 'lps'),
	(620299, 131, '2014-04-01 00:46:10.000000', 'consum', 0.0214, 'lps'),
	(620300, 131, '2014-04-01 00:46:11.000000', 'consum', 0.0212, 'lps'),
	(620301, 131, '2014-04-01 00:46:12.000000', 'consum', 0.0227, 'lps'),
	(620302, 131, '2014-04-01 00:46:13.000000', 'consum', 0.0229, 'lps'),
	(620303, 131, '2014-04-01 00:46:14.000000', 'consum', 0.0216, 'lps'),
	(620304, 131, '2014-04-01 00:46:15.000000', 'consum', 0.0222, 'lps'),
	(620305, 131, '2014-04-01 00:46:16.000000', 'consum', 0.0214, 'lps'),
	(620306, 131, '2014-04-01 00:46:17.000000', 'consum', 0.0216, 'lps'),
	(620307, 131, '2014-04-01 00:46:18.000000', 'consum', 0.0226, 'lps'),
	(620308, 131, '2014-04-01 00:46:19.000000', 'consum', 0.0211, 'lps'),
	(620309, 131, '2014-04-01 00:46:20.000000', 'consum', 0.0229, 'lps'),
	(620310, 131, '2014-04-01 00:46:21.000000', 'consum', 0.0223, 'lps'),
	(620311, 131, '2014-04-01 00:46:22.000000', 'consum', 0.0220, 'lps'),
	(620312, 131, '2014-04-01 00:46:23.000000', 'consum', 0.0221, 'lps'),
	(620313, 131, '2014-04-01 00:46:24.000000', 'consum', 0.0213, 'lps'),
	(620314, 131, '2014-04-01 00:46:25.000000', 'consum', 0.0216, 'lps'),
	(620315, 131, '2014-04-01 00:46:26.000000', 'consum', 0.0229, 'lps'),
	(620316, 131, '2014-04-01 00:46:27.000000', 'consum', 0.0226, 'lps'),
	(620317, 131, '2014-04-01 00:46:28.000000', 'consum', 0.0217, 'lps'),
	(620318, 131, '2014-04-01 00:46:29.000000', 'consum', 0.0217, 'lps'),
	(620319, 131, '2014-04-01 00:46:30.000000', 'consum', 0.0222, 'lps'),
	(620320, 131, '2014-04-01 00:46:31.000000', 'consum', 0.0211, 'lps'),
	(620321, 131, '2014-04-01 00:46:32.000000', 'consum', 0.0221, 'lps'),
	(620322, 131, '2014-04-01 00:46:33.000000', 'consum', 0.0219, 'lps'),
	(620323, 131, '2014-04-01 00:46:34.000000', 'consum', 0.0226, 'lps'),
	(620324, 131, '2014-04-01 00:46:35.000000', 'consum', 0.0223, 'lps'),
	(620325, 131, '2014-04-01 00:46:36.000000', 'consum', 0.0227, 'lps'),
	(620326, 131, '2014-04-01 00:46:37.000000', 'consum', 0.0216, 'lps'),
	(620327, 131, '2014-04-01 00:46:38.000000', 'consum', 0.0229, 'lps'),
	(620328, 131, '2014-04-01 00:46:39.000000', 'consum', 0.0229, 'lps'),
	(620329, 131, '2014-04-01 00:46:40.000000', 'consum', 0.0228, 'lps'),
	(620330, 131, '2014-04-01 00:46:41.000000', 'consum', 0.0224, 'lps'),
	(620331, 131, '2014-04-01 00:46:42.000000', 'consum', 0.0225, 'lps'),
	(620332, 131, '2014-04-01 00:46:43.000000', 'consum', 0.0223, 'lps'),
	(620333, 131, '2014-04-01 00:46:44.000000', 'consum', 0.0213, 'lps'),
	(620334, 131, '2014-04-01 00:46:45.000000', 'consum', 0.0227, 'lps'),
	(620335, 131, '2014-04-01 00:46:46.000000', 'consum', 0.0224, 'lps'),
	(620336, 131, '2014-04-01 00:46:47.000000', 'consum', 0.0211, 'lps'),
	(620337, 131, '2014-04-01 00:46:48.000000', 'consum', 0.0215, 'lps'),
	(620338, 131, '2014-04-01 00:46:49.000000', 'consum', 0.0229, 'lps'),
	(620339, 131, '2014-04-01 00:46:50.000000', 'consum', 0.0214, 'lps'),
	(620340, 131, '2014-04-01 00:46:51.000000', 'consum', 0.0213, 'lps'),
	(620341, 131, '2014-04-01 00:46:52.000000', 'consum', 0.0211, 'lps'),
	(620342, 131, '2014-04-01 00:46:53.000000', 'consum', 0.0229, 'lps'),
	(620343, 131, '2014-04-01 00:46:54.000000', 'consum', 0.0221, 'lps'),
	(620344, 131, '2014-04-01 00:46:55.000000', 'consum', 0.0227, 'lps'),
	(620345, 131, '2014-04-01 00:46:56.000000', 'consum', 0.0224, 'lps'),
	(620346, 131, '2014-04-01 00:46:57.000000', 'consum', 0.0210, 'lps'),
	(620347, 131, '2014-04-01 00:46:58.000000', 'consum', 0.0227, 'lps'),
	(620348, 131, '2014-04-01 00:46:59.000000', 'consum', 0.0215, 'lps'),
	(620349, 131, '2014-04-01 00:47:00.000000', 'consum', 0.0226, 'lps'),
	(620350, 131, '2014-04-01 00:47:01.000000', 'consum', 0.0217, 'lps'),
	(620351, 131, '2014-04-01 00:47:02.000000', 'consum', 0.0214, 'lps'),
	(620352, 131, '2014-04-01 00:47:03.000000', 'consum', 0.0211, 'lps'),
	(620353, 131, '2014-04-01 00:47:04.000000', 'consum', 0.0225, 'lps'),
	(620354, 131, '2014-04-01 00:47:05.000000', 'consum', 0.0222, 'lps'),
	(620355, 131, '2014-04-01 00:47:06.000000', 'consum', 0.0223, 'lps'),
	(620356, 131, '2014-04-01 00:47:07.000000', 'consum', 0.0221, 'lps'),
	(620357, 131, '2014-04-01 00:47:08.000000', 'consum', 0.0227, 'lps'),
	(620358, 131, '2014-04-01 00:47:09.000000', 'consum', 0.0224, 'lps'),
	(620359, 131, '2014-04-01 00:47:10.000000', 'consum', 0.0227, 'lps'),
	(620360, 131, '2014-04-01 00:47:11.000000', 'consum', 0.0216, 'lps'),
	(620361, 131, '2014-04-01 00:47:12.000000', 'consum', 0.0229, 'lps'),
	(620362, 131, '2014-04-01 00:47:13.000000', 'consum', 0.0226, 'lps'),
	(620363, 131, '2014-04-01 00:47:14.000000', 'consum', 0.0215, 'lps'),
	(620364, 131, '2014-04-01 00:47:15.000000', 'consum', 0.0227, 'lps'),
	(620365, 131, '2014-04-01 00:47:16.000000', 'consum', 0.0220, 'lps'),
	(620366, 131, '2014-04-01 00:47:17.000000', 'consum', 0.0229, 'lps'),
	(620367, 131, '2014-04-01 00:47:18.000000', 'consum', 0.0215, 'lps'),
	(620368, 131, '2014-04-01 00:47:19.000000', 'consum', 0.0217, 'lps'),
	(620369, 131, '2014-04-01 00:47:20.000000', 'consum', 0.0214, 'lps'),
	(620370, 131, '2014-04-01 00:47:21.000000', 'consum', 0.0228, 'lps'),
	(620371, 131, '2014-04-01 00:47:22.000000', 'consum', 0.0228, 'lps'),
	(620372, 131, '2014-04-01 00:47:23.000000', 'consum', 0.0225, 'lps'),
	(620373, 131, '2014-04-01 00:47:24.000000', 'consum', 0.0212, 'lps'),
	(620374, 131, '2014-04-01 00:47:25.000000', 'consum', 0.0218, 'lps'),
	(620375, 131, '2014-04-01 00:47:26.000000', 'consum', 0.0224, 'lps'),
	(620376, 131, '2014-04-01 00:47:27.000000', 'consum', 0.0214, 'lps'),
	(620377, 131, '2014-04-01 00:47:28.000000', 'consum', 0.0211, 'lps'),
	(620378, 131, '2014-04-01 00:47:29.000000', 'consum', 0.0224, 'lps'),
	(620379, 131, '2014-04-01 00:47:30.000000', 'consum', 0.0217, 'lps'),
	(620380, 131, '2014-04-01 00:47:31.000000', 'consum', 0.0224, 'lps'),
	(620381, 131, '2014-04-01 00:47:32.000000', 'consum', 0.0218, 'lps'),
	(620382, 131, '2014-04-01 00:47:33.000000', 'consum', 0.0210, 'lps'),
	(620383, 131, '2014-04-01 00:47:34.000000', 'consum', 0.0227, 'lps'),
	(620384, 131, '2014-04-01 00:47:35.000000', 'consum', 0.0216, 'lps'),
	(620385, 131, '2014-04-01 00:47:36.000000', 'consum', 0.0210, 'lps'),
	(620386, 131, '2014-04-01 00:47:37.000000', 'consum', 0.0210, 'lps'),
	(620387, 131, '2014-04-01 00:47:38.000000', 'consum', 0.0210, 'lps'),
	(620388, 131, '2014-04-01 00:47:39.000000', 'consum', 0.0213, 'lps'),
	(620389, 131, '2014-04-01 00:47:40.000000', 'consum', 0.0226, 'lps'),
	(620390, 131, '2014-04-01 00:47:41.000000', 'consum', 0.0223, 'lps'),
	(620391, 131, '2014-04-01 00:47:42.000000', 'consum', 0.0224, 'lps'),
	(620392, 131, '2014-04-01 00:47:43.000000', 'consum', 0.0222, 'lps'),
	(620393, 131, '2014-04-01 00:47:44.000000', 'consum', 0.0211, 'lps'),
	(620394, 131, '2014-04-01 00:47:45.000000', 'consum', 0.0219, 'lps'),
	(620395, 131, '2014-04-01 00:47:46.000000', 'consum', 0.0210, 'lps'),
	(620396, 131, '2014-04-01 00:47:47.000000', 'consum', 0.0225, 'lps'),
	(620397, 131, '2014-04-01 00:47:48.000000', 'consum', 0.0225, 'lps'),
	(620398, 131, '2014-04-01 00:47:49.000000', 'consum', 0.0221, 'lps'),
	(620399, 131, '2014-04-01 00:47:50.000000', 'consum', 0.0219, 'lps'),
	(620400, 131, '2014-04-01 00:47:51.000000', 'consum', 0.0221, 'lps'),
	(620401, 131, '2014-04-01 00:47:52.000000', 'consum', 0.0222, 'lps'),
	(620402, 131, '2014-04-01 00:47:53.000000', 'consum', 0.0217, 'lps'),
	(620403, 131, '2014-04-01 00:47:54.000000', 'consum', 0.0228, 'lps'),
	(620404, 131, '2014-04-01 00:47:55.000000', 'consum', 0.0222, 'lps'),
	(620405, 131, '2014-04-01 00:47:56.000000', 'consum', 0.0216, 'lps'),
	(620406, 131, '2014-04-01 00:47:57.000000', 'consum', 0.0223, 'lps'),
	(620407, 131, '2014-04-01 00:47:58.000000', 'consum', 0.0217, 'lps'),
	(620408, 131, '2014-04-01 00:47:59.000000', 'consum', 0.0228, 'lps'),
	(620409, 131, '2014-04-01 00:48:00.000000', 'consum', 0.0221, 'lps'),
	(620410, 131, '2014-04-01 00:48:01.000000', 'consum', 0.0229, 'lps'),
	(620411, 131, '2014-04-01 00:48:02.000000', 'consum', 0.0213, 'lps'),
	(620412, 131, '2014-04-01 00:48:03.000000', 'consum', 0.0228, 'lps'),
	(620413, 131, '2014-04-01 00:48:04.000000', 'consum', 0.0213, 'lps'),
	(620414, 131, '2014-04-01 00:48:05.000000', 'consum', 0.0212, 'lps'),
	(620415, 131, '2014-04-01 00:48:06.000000', 'consum', 0.0210, 'lps'),
	(620416, 131, '2014-04-01 00:48:07.000000', 'consum', 0.0223, 'lps'),
	(620417, 131, '2014-04-01 00:48:08.000000', 'consum', 0.0218, 'lps'),
	(620418, 131, '2014-04-01 00:48:09.000000', 'consum', 0.0229, 'lps'),
	(620419, 131, '2014-04-01 00:48:10.000000', 'consum', 0.0223, 'lps'),
	(620420, 131, '2014-04-01 00:48:11.000000', 'consum', 0.0216, 'lps'),
	(620421, 131, '2014-04-01 00:48:12.000000', 'consum', 0.0225, 'lps'),
	(620422, 131, '2014-04-01 00:48:13.000000', 'consum', 0.0225, 'lps'),
	(620423, 131, '2014-04-01 00:48:14.000000', 'consum', 0.0223, 'lps'),
	(620424, 131, '2014-04-01 00:48:15.000000', 'consum', 0.0229, 'lps'),
	(620425, 131, '2014-04-01 00:48:16.000000', 'consum', 0.0226, 'lps'),
	(620426, 131, '2014-04-01 00:48:17.000000', 'consum', 0.0213, 'lps'),
	(620427, 131, '2014-04-01 00:48:18.000000', 'consum', 0.0218, 'lps'),
	(620428, 131, '2014-04-01 00:48:19.000000', 'consum', 0.0223, 'lps'),
	(620429, 131, '2014-04-01 00:48:20.000000', 'consum', 0.0213, 'lps'),
	(620430, 131, '2014-04-01 00:48:21.000000', 'consum', 0.0223, 'lps'),
	(620431, 131, '2014-04-01 00:48:22.000000', 'consum', 0.0227, 'lps'),
	(620432, 131, '2014-04-01 00:48:23.000000', 'consum', 0.0217, 'lps'),
	(620433, 131, '2014-04-01 00:48:24.000000', 'consum', 0.0217, 'lps'),
	(620434, 131, '2014-04-01 00:48:25.000000', 'consum', 0.0221, 'lps'),
	(620435, 131, '2014-04-01 00:48:26.000000', 'consum', 0.0226, 'lps'),
	(620436, 131, '2014-04-01 00:48:27.000000', 'consum', 0.0216, 'lps'),
	(620437, 131, '2014-04-01 00:48:28.000000', 'consum', 0.0215, 'lps'),
	(620438, 131, '2014-04-01 00:48:29.000000', 'consum', 0.0216, 'lps'),
	(620439, 131, '2014-04-01 00:48:30.000000', 'consum', 0.0225, 'lps'),
	(620440, 131, '2014-04-01 00:48:31.000000', 'consum', 0.0226, 'lps'),
	(620441, 131, '2014-04-01 00:48:32.000000', 'consum', 0.0227, 'lps'),
	(620442, 131, '2014-04-01 00:48:33.000000', 'consum', 0.0227, 'lps'),
	(620443, 131, '2014-04-01 00:48:34.000000', 'consum', 0.0225, 'lps'),
	(620444, 131, '2014-04-01 00:48:35.000000', 'consum', 0.0216, 'lps'),
	(620445, 131, '2014-04-01 00:48:36.000000', 'consum', 0.0214, 'lps'),
	(620446, 131, '2014-04-01 00:48:37.000000', 'consum', 0.0214, 'lps'),
	(620447, 131, '2014-04-01 00:48:38.000000', 'consum', 0.0219, 'lps'),
	(620448, 131, '2014-04-01 00:48:39.000000', 'consum', 0.0224, 'lps'),
	(620449, 131, '2014-04-01 00:48:40.000000', 'consum', 0.0211, 'lps'),
	(620450, 131, '2014-04-01 00:48:41.000000', 'consum', 0.0215, 'lps'),
	(620451, 131, '2014-04-01 00:48:42.000000', 'consum', 0.0212, 'lps'),
	(620452, 131, '2014-04-01 00:48:43.000000', 'consum', 0.0225, 'lps'),
	(620453, 131, '2014-04-01 00:48:44.000000', 'consum', 0.0220, 'lps'),
	(620454, 131, '2014-04-01 00:48:45.000000', 'consum', 0.0215, 'lps'),
	(620455, 131, '2014-04-01 00:48:46.000000', 'consum', 0.0226, 'lps'),
	(620456, 131, '2014-04-01 00:48:47.000000', 'consum', 0.0216, 'lps'),
	(620457, 131, '2014-04-01 00:48:48.000000', 'consum', 0.0213, 'lps'),
	(620458, 131, '2014-04-01 00:48:49.000000', 'consum', 0.0227, 'lps'),
	(620459, 131, '2014-04-01 00:48:50.000000', 'consum', 0.0228, 'lps'),
	(620460, 131, '2014-04-01 00:48:51.000000', 'consum', 0.0229, 'lps'),
	(620461, 131, '2014-04-01 00:48:52.000000', 'consum', 0.0211, 'lps'),
	(620462, 131, '2014-04-01 00:48:53.000000', 'consum', 0.0220, 'lps'),
	(620463, 131, '2014-04-01 00:48:54.000000', 'consum', 0.0217, 'lps'),
	(620464, 131, '2014-04-01 00:48:55.000000', 'consum', 0.0213, 'lps'),
	(620465, 131, '2014-04-01 00:48:56.000000', 'consum', 0.0227, 'lps'),
	(620466, 131, '2014-04-01 00:48:57.000000', 'consum', 0.0228, 'lps'),
	(620467, 131, '2014-04-01 00:48:58.000000', 'consum', 0.0226, 'lps'),
	(620468, 131, '2014-04-01 00:48:59.000000', 'consum', 0.0218, 'lps'),
	(620469, 131, '2014-04-01 00:49:00.000000', 'consum', 0.0224, 'lps'),
	(620470, 131, '2014-04-01 00:49:01.000000', 'consum', 0.0216, 'lps'),
	(620471, 131, '2014-04-01 00:49:02.000000', 'consum', 0.0217, 'lps'),
	(620472, 131, '2014-04-01 00:49:03.000000', 'consum', 0.0227, 'lps'),
	(620473, 131, '2014-04-01 00:49:04.000000', 'consum', 0.0216, 'lps'),
	(620474, 131, '2014-04-01 00:49:05.000000', 'consum', 0.0211, 'lps'),
	(620475, 131, '2014-04-01 00:49:06.000000', 'consum', 0.0214, 'lps'),
	(620476, 131, '2014-04-01 00:49:07.000000', 'consum', 0.0210, 'lps'),
	(620477, 131, '2014-04-01 00:49:08.000000', 'consum', 0.0219, 'lps'),
	(620478, 131, '2014-04-01 00:49:09.000000', 'consum', 0.0213, 'lps'),
	(620479, 131, '2014-04-01 00:49:10.000000', 'consum', 0.0220, 'lps'),
	(620480, 131, '2014-04-01 00:49:11.000000', 'consum', 0.0229, 'lps'),
	(620481, 131, '2014-04-01 00:49:12.000000', 'consum', 0.0219, 'lps'),
	(620482, 131, '2014-04-01 00:49:13.000000', 'consum', 0.0216, 'lps'),
	(620483, 131, '2014-04-01 00:49:14.000000', 'consum', 0.0213, 'lps'),
	(620484, 131, '2014-04-01 00:49:15.000000', 'consum', 0.0227, 'lps'),
	(620485, 131, '2014-04-01 00:49:16.000000', 'consum', 0.0227, 'lps'),
	(620486, 131, '2014-04-01 00:49:17.000000', 'consum', 0.0227, 'lps'),
	(620487, 131, '2014-04-01 00:49:18.000000', 'consum', 0.0222, 'lps'),
	(620488, 131, '2014-04-01 00:49:19.000000', 'consum', 0.0219, 'lps'),
	(620489, 131, '2014-04-01 00:49:20.000000', 'consum', 0.0219, 'lps'),
	(620490, 131, '2014-04-01 00:49:21.000000', 'consum', 0.0210, 'lps'),
	(620491, 131, '2014-04-01 00:49:22.000000', 'consum', 0.0222, 'lps'),
	(620492, 131, '2014-04-01 00:49:23.000000', 'consum', 0.0211, 'lps'),
	(620493, 131, '2014-04-01 00:49:24.000000', 'consum', 0.0219, 'lps'),
	(620494, 131, '2014-04-01 00:49:25.000000', 'consum', 0.0214, 'lps'),
	(620495, 131, '2014-04-01 00:49:26.000000', 'consum', 0.0221, 'lps'),
	(620496, 131, '2014-04-01 00:49:27.000000', 'consum', 0.0214, 'lps'),
	(620497, 131, '2014-04-01 00:49:28.000000', 'consum', 0.0216, 'lps'),
	(620498, 131, '2014-04-01 00:49:29.000000', 'consum', 0.0212, 'lps'),
	(620499, 131, '2014-04-01 00:49:30.000000', 'consum', 0.0221, 'lps'),
	(620500, 131, '2014-04-01 00:49:31.000000', 'consum', 0.0219, 'lps'),
	(620501, 131, '2014-04-01 00:49:32.000000', 'consum', 0.0221, 'lps'),
	(620502, 131, '2014-04-01 00:49:33.000000', 'consum', 0.0222, 'lps'),
	(620503, 131, '2014-04-01 00:49:34.000000', 'consum', 0.0214, 'lps'),
	(620504, 131, '2014-04-01 00:49:35.000000', 'consum', 0.0218, 'lps'),
	(620505, 131, '2014-04-01 00:49:36.000000', 'consum', 0.0215, 'lps'),
	(620506, 131, '2014-04-01 00:49:37.000000', 'consum', 0.0214, 'lps'),
	(620507, 131, '2014-04-01 00:49:38.000000', 'consum', 0.0214, 'lps'),
	(620508, 131, '2014-04-01 00:49:39.000000', 'consum', 0.0217, 'lps'),
	(620509, 131, '2014-04-01 00:49:40.000000', 'consum', 0.0216, 'lps'),
	(620510, 131, '2014-04-01 00:49:41.000000', 'consum', 0.0220, 'lps'),
	(620511, 131, '2014-04-01 00:49:42.000000', 'consum', 0.0221, 'lps'),
	(620512, 131, '2014-04-01 00:49:43.000000', 'consum', 0.0216, 'lps'),
	(620513, 131, '2014-04-01 00:49:44.000000', 'consum', 0.0227, 'lps'),
	(620514, 131, '2014-04-01 00:49:45.000000', 'consum', 0.0218, 'lps'),
	(620515, 131, '2014-04-01 00:49:46.000000', 'consum', 0.0221, 'lps'),
	(620516, 131, '2014-04-01 00:49:47.000000', 'consum', 0.0220, 'lps'),
	(620517, 131, '2014-04-01 00:49:48.000000', 'consum', 0.0229, 'lps'),
	(620518, 131, '2014-04-01 00:49:49.000000', 'consum', 0.0216, 'lps'),
	(620519, 131, '2014-04-01 00:49:50.000000', 'consum', 0.0222, 'lps'),
	(620520, 131, '2014-04-01 00:49:51.000000', 'consum', 0.0212, 'lps'),
	(620521, 131, '2014-04-01 00:49:52.000000', 'consum', 0.0226, 'lps'),
	(620522, 131, '2014-04-01 00:49:53.000000', 'consum', 0.0226, 'lps'),
	(620523, 131, '2014-04-01 00:49:54.000000', 'consum', 0.0221, 'lps'),
	(620524, 131, '2014-04-01 00:49:55.000000', 'consum', 0.0216, 'lps'),
	(620525, 131, '2014-04-01 00:49:56.000000', 'consum', 0.0227, 'lps'),
	(620526, 131, '2014-04-01 00:49:57.000000', 'consum', 0.0216, 'lps'),
	(620527, 131, '2014-04-01 00:49:58.000000', 'consum', 0.0213, 'lps'),
	(620528, 131, '2014-04-01 00:49:59.000000', 'consum', 0.0228, 'lps'),
	(620529, 131, '2014-04-01 00:50:00.000000', 'consum', 0.0211, 'lps'),
	(620530, 131, '2014-04-01 00:50:01.000000', 'consum', 0.0219, 'lps'),
	(620531, 131, '2014-04-01 00:50:02.000000', 'consum', 0.0215, 'lps'),
	(620532, 131, '2014-04-01 00:50:03.000000', 'consum', 0.0226, 'lps'),
	(620533, 131, '2014-04-01 00:50:04.000000', 'consum', 0.0217, 'lps'),
	(620534, 131, '2014-04-01 00:50:05.000000', 'consum', 0.0218, 'lps'),
	(620535, 131, '2014-04-01 00:50:06.000000', 'consum', 0.0228, 'lps'),
	(620536, 131, '2014-04-01 00:50:07.000000', 'consum', 0.0219, 'lps'),
	(620537, 131, '2014-04-01 00:50:08.000000', 'consum', 0.0220, 'lps'),
	(620538, 131, '2014-04-01 00:50:09.000000', 'consum', 0.0213, 'lps'),
	(620539, 131, '2014-04-01 00:50:10.000000', 'consum', 0.0216, 'lps'),
	(620540, 131, '2014-04-01 00:50:11.000000', 'consum', 0.0229, 'lps'),
	(620541, 131, '2014-04-01 00:50:12.000000', 'consum', 0.0211, 'lps'),
	(620542, 131, '2014-04-01 00:50:13.000000', 'consum', 0.0216, 'lps'),
	(620543, 131, '2014-04-01 00:50:14.000000', 'consum', 0.0220, 'lps'),
	(620544, 131, '2014-04-01 00:50:15.000000', 'consum', 0.0222, 'lps'),
	(620545, 131, '2014-04-01 00:50:16.000000', 'consum', 0.0221, 'lps'),
	(620546, 131, '2014-04-01 00:50:17.000000', 'consum', 0.0211, 'lps'),
	(620547, 131, '2014-04-01 00:50:18.000000', 'consum', 0.0221, 'lps'),
	(620548, 131, '2014-04-01 00:50:19.000000', 'consum', 0.0220, 'lps'),
	(620549, 131, '2014-04-01 00:50:20.000000', 'consum', 0.0211, 'lps'),
	(620550, 131, '2014-04-01 00:50:21.000000', 'consum', 0.0224, 'lps'),
	(620551, 131, '2014-04-01 00:50:22.000000', 'consum', 0.0219, 'lps'),
	(620552, 131, '2014-04-01 00:50:23.000000', 'consum', 0.0211, 'lps'),
	(620553, 131, '2014-04-01 00:50:24.000000', 'consum', 0.0210, 'lps'),
	(620554, 131, '2014-04-01 00:50:25.000000', 'consum', 0.0226, 'lps'),
	(620555, 131, '2014-04-01 00:50:26.000000', 'consum', 0.0212, 'lps'),
	(620556, 131, '2014-04-01 00:50:27.000000', 'consum', 0.0214, 'lps'),
	(620557, 131, '2014-04-01 00:50:28.000000', 'consum', 0.0224, 'lps'),
	(620558, 131, '2014-04-01 00:50:29.000000', 'consum', 0.0227, 'lps'),
	(620559, 131, '2014-04-01 00:50:30.000000', 'consum', 0.0213, 'lps'),
	(620560, 131, '2014-04-01 00:50:31.000000', 'consum', 0.0214, 'lps'),
	(620561, 131, '2014-04-01 00:50:32.000000', 'consum', 0.0224, 'lps'),
	(620562, 131, '2014-04-01 00:50:33.000000', 'consum', 0.0225, 'lps'),
	(620563, 131, '2014-04-01 00:50:34.000000', 'consum', 0.0227, 'lps'),
	(620564, 131, '2014-04-01 00:50:35.000000', 'consum', 0.0229, 'lps'),
	(620565, 131, '2014-04-01 00:50:36.000000', 'consum', 0.0215, 'lps'),
	(620566, 131, '2014-04-01 00:50:37.000000', 'consum', 0.0216, 'lps'),
	(620567, 131, '2014-04-01 00:50:38.000000', 'consum', 0.0229, 'lps'),
	(620568, 131, '2014-04-01 00:50:39.000000', 'consum', 0.0227, 'lps'),
	(620569, 131, '2014-04-01 00:50:40.000000', 'consum', 0.0216, 'lps'),
	(620570, 131, '2014-04-01 00:50:41.000000', 'consum', 0.0212, 'lps'),
	(620571, 131, '2014-04-01 00:50:42.000000', 'consum', 0.0223, 'lps'),
	(620572, 131, '2014-04-01 00:50:43.000000', 'consum', 0.0210, 'lps'),
	(620573, 131, '2014-04-01 00:50:44.000000', 'consum', 0.0211, 'lps'),
	(620574, 131, '2014-04-01 00:50:45.000000', 'consum', 0.0213, 'lps'),
	(620575, 131, '2014-04-01 00:50:46.000000', 'consum', 0.0226, 'lps'),
	(620576, 131, '2014-04-01 00:50:47.000000', 'consum', 0.0219, 'lps'),
	(620577, 131, '2014-04-01 00:50:48.000000', 'consum', 0.0229, 'lps'),
	(620578, 131, '2014-04-01 00:50:49.000000', 'consum', 0.0218, 'lps'),
	(620579, 131, '2014-04-01 00:50:50.000000', 'consum', 0.0215, 'lps'),
	(620580, 131, '2014-04-01 00:50:51.000000', 'consum', 0.0211, 'lps'),
	(620581, 131, '2014-04-01 00:50:52.000000', 'consum', 0.0219, 'lps'),
	(620582, 131, '2014-04-01 00:50:53.000000', 'consum', 0.0213, 'lps'),
	(620583, 131, '2014-04-01 00:50:54.000000', 'consum', 0.0217, 'lps'),
	(620584, 131, '2014-04-01 00:50:55.000000', 'consum', 0.0218, 'lps'),
	(620585, 131, '2014-04-01 00:50:56.000000', 'consum', 0.0229, 'lps'),
	(620586, 131, '2014-04-01 00:50:57.000000', 'consum', 0.0220, 'lps'),
	(620587, 131, '2014-04-01 00:50:58.000000', 'consum', 0.0224, 'lps'),
	(620588, 131, '2014-04-01 00:50:59.000000', 'consum', 0.0229, 'lps'),
	(620589, 131, '2014-04-01 00:51:00.000000', 'consum', 0.0226, 'lps'),
	(620590, 131, '2014-04-01 00:51:01.000000', 'consum', 0.0212, 'lps'),
	(620591, 131, '2014-04-01 00:51:02.000000', 'consum', 0.0212, 'lps'),
	(620592, 131, '2014-04-01 00:51:03.000000', 'consum', 0.0215, 'lps'),
	(620593, 131, '2014-04-01 00:51:04.000000', 'consum', 0.0228, 'lps'),
	(620594, 131, '2014-04-01 00:51:05.000000', 'consum', 0.0228, 'lps'),
	(620595, 131, '2014-04-01 00:51:06.000000', 'consum', 0.0224, 'lps'),
	(620596, 131, '2014-04-01 00:51:07.000000', 'consum', 0.0227, 'lps'),
	(620597, 131, '2014-04-01 00:51:08.000000', 'consum', 0.0216, 'lps'),
	(620598, 131, '2014-04-01 00:51:09.000000', 'consum', 0.0228, 'lps'),
	(620599, 131, '2014-04-01 00:51:10.000000', 'consum', 0.0222, 'lps'),
	(620600, 131, '2014-04-01 00:51:11.000000', 'consum', 0.0219, 'lps'),
	(620601, 131, '2014-04-01 00:51:12.000000', 'consum', 0.0217, 'lps'),
	(620602, 131, '2014-04-01 00:51:13.000000', 'consum', 0.0219, 'lps'),
	(620603, 131, '2014-04-01 00:51:14.000000', 'consum', 0.0215, 'lps'),
	(620604, 131, '2014-04-01 00:51:15.000000', 'consum', 0.0228, 'lps'),
	(620605, 131, '2014-04-01 00:51:16.000000', 'consum', 0.0227, 'lps'),
	(620606, 131, '2014-04-01 00:51:17.000000', 'consum', 0.0220, 'lps'),
	(620607, 131, '2014-04-01 00:51:18.000000', 'consum', 0.0210, 'lps'),
	(620608, 131, '2014-04-01 00:51:19.000000', 'consum', 0.0219, 'lps'),
	(620609, 131, '2014-04-01 00:51:20.000000', 'consum', 0.0215, 'lps'),
	(620610, 131, '2014-04-01 00:51:21.000000', 'consum', 0.0228, 'lps'),
	(620611, 131, '2014-04-01 00:51:22.000000', 'consum', 0.0226, 'lps'),
	(620612, 131, '2014-04-01 00:51:23.000000', 'consum', 0.0215, 'lps'),
	(620613, 131, '2014-04-01 00:51:24.000000', 'consum', 0.0229, 'lps'),
	(620614, 131, '2014-04-01 00:51:25.000000', 'consum', 0.0229, 'lps'),
	(620615, 131, '2014-04-01 00:51:26.000000', 'consum', 0.0228, 'lps'),
	(620616, 131, '2014-04-01 00:51:27.000000', 'consum', 0.0224, 'lps'),
	(620617, 131, '2014-04-01 00:51:28.000000', 'consum', 0.0225, 'lps'),
	(620618, 131, '2014-04-01 00:51:29.000000', 'consum', 0.0225, 'lps'),
	(620619, 131, '2014-04-01 00:51:30.000000', 'consum', 0.0220, 'lps'),
	(620620, 131, '2014-04-01 00:51:31.000000', 'consum', 0.0214, 'lps'),
	(620621, 131, '2014-04-01 00:51:32.000000', 'consum', 0.0223, 'lps'),
	(620622, 131, '2014-04-01 00:51:33.000000', 'consum', 0.0221, 'lps'),
	(620623, 131, '2014-04-01 00:51:34.000000', 'consum', 0.0227, 'lps'),
	(620624, 131, '2014-04-01 00:51:35.000000', 'consum', 0.0223, 'lps'),
	(620625, 131, '2014-04-01 00:51:36.000000', 'consum', 0.0224, 'lps'),
	(620626, 131, '2014-04-01 00:51:37.000000', 'consum', 0.0220, 'lps'),
	(620627, 131, '2014-04-01 00:51:38.000000', 'consum', 0.0220, 'lps'),
	(620628, 131, '2014-04-01 00:51:39.000000', 'consum', 0.0211, 'lps'),
	(620629, 131, '2014-04-01 00:51:40.000000', 'consum', 0.0227, 'lps'),
	(620630, 131, '2014-04-01 00:51:41.000000', 'consum', 0.0229, 'lps'),
	(620631, 131, '2014-04-01 00:51:42.000000', 'consum', 0.0218, 'lps'),
	(620632, 131, '2014-04-01 00:51:43.000000', 'consum', 0.0210, 'lps'),
	(620633, 131, '2014-04-01 00:51:44.000000', 'consum', 0.0229, 'lps'),
	(620634, 131, '2014-04-01 00:51:45.000000', 'consum', 0.0225, 'lps'),
	(620635, 131, '2014-04-01 00:51:46.000000', 'consum', 0.0229, 'lps'),
	(620636, 131, '2014-04-01 00:51:47.000000', 'consum', 0.0219, 'lps'),
	(620637, 131, '2014-04-01 00:51:48.000000', 'consum', 0.0218, 'lps'),
	(620638, 131, '2014-04-01 00:51:49.000000', 'consum', 0.0223, 'lps'),
	(620639, 131, '2014-04-01 00:51:50.000000', 'consum', 0.0213, 'lps'),
	(620640, 131, '2014-04-01 00:51:51.000000', 'consum', 0.0227, 'lps'),
	(620641, 131, '2014-04-01 00:51:52.000000', 'consum', 0.0227, 'lps'),
	(620642, 131, '2014-04-01 00:51:53.000000', 'consum', 0.0225, 'lps'),
	(620643, 131, '2014-04-01 00:51:54.000000', 'consum', 0.0215, 'lps'),
	(620644, 131, '2014-04-01 00:51:55.000000', 'consum', 0.0211, 'lps'),
	(620645, 131, '2014-04-01 00:51:56.000000', 'consum', 0.0217, 'lps'),
	(620646, 131, '2014-04-01 00:51:57.000000', 'consum', 0.0226, 'lps'),
	(620647, 131, '2014-04-01 00:51:58.000000', 'consum', 0.0229, 'lps'),
	(620648, 131, '2014-04-01 00:51:59.000000', 'consum', 0.0218, 'lps'),
	(620649, 131, '2014-04-01 00:52:00.000000', 'consum', 0.0211, 'lps'),
	(620650, 131, '2014-04-01 00:52:01.000000', 'consum', 0.0214, 'lps'),
	(620651, 131, '2014-04-01 00:52:02.000000', 'consum', 0.0226, 'lps'),
	(620652, 131, '2014-04-01 00:52:03.000000', 'consum', 0.0218, 'lps'),
	(620653, 131, '2014-04-01 00:52:04.000000', 'consum', 0.0225, 'lps'),
	(620654, 131, '2014-04-01 00:52:05.000000', 'consum', 0.0218, 'lps'),
	(620655, 131, '2014-04-01 00:52:06.000000', 'consum', 0.0227, 'lps'),
	(620656, 131, '2014-04-01 00:52:07.000000', 'consum', 0.0213, 'lps'),
	(620657, 131, '2014-04-01 00:52:08.000000', 'consum', 0.0215, 'lps'),
	(620658, 131, '2014-04-01 00:52:09.000000', 'consum', 0.0226, 'lps'),
	(620659, 131, '2014-04-01 00:52:10.000000', 'consum', 0.0217, 'lps'),
	(620660, 131, '2014-04-01 00:52:11.000000', 'consum', 0.0216, 'lps'),
	(620661, 131, '2014-04-01 00:52:12.000000', 'consum', 0.0219, 'lps'),
	(620662, 131, '2014-04-01 00:52:13.000000', 'consum', 0.0217, 'lps'),
	(620663, 131, '2014-04-01 00:52:14.000000', 'consum', 0.0220, 'lps'),
	(620664, 131, '2014-04-01 00:52:15.000000', 'consum', 0.0220, 'lps'),
	(620665, 131, '2014-04-01 00:52:16.000000', 'consum', 0.0228, 'lps'),
	(620666, 131, '2014-04-01 00:52:17.000000', 'consum', 0.0212, 'lps'),
	(620667, 131, '2014-04-01 00:52:18.000000', 'consum', 0.0226, 'lps'),
	(620668, 131, '2014-04-01 00:52:19.000000', 'consum', 0.0223, 'lps'),
	(620669, 131, '2014-04-01 00:52:20.000000', 'consum', 0.0210, 'lps'),
	(620670, 131, '2014-04-01 00:52:21.000000', 'consum', 0.0212, 'lps'),
	(620671, 131, '2014-04-01 00:52:22.000000', 'consum', 0.0221, 'lps'),
	(620672, 131, '2014-04-01 00:52:23.000000', 'consum', 0.0219, 'lps'),
	(620673, 131, '2014-04-01 00:52:24.000000', 'consum', 0.0222, 'lps'),
	(620674, 131, '2014-04-01 00:52:25.000000', 'consum', 0.0222, 'lps'),
	(620675, 131, '2014-04-01 00:52:26.000000', 'consum', 0.0217, 'lps'),
	(620676, 131, '2014-04-01 00:52:27.000000', 'consum', 0.0227, 'lps'),
	(620677, 131, '2014-04-01 00:52:28.000000', 'consum', 0.0214, 'lps'),
	(620678, 131, '2014-04-01 00:52:29.000000', 'consum', 0.0221, 'lps'),
	(620679, 131, '2014-04-01 00:52:30.000000', 'consum', 0.0215, 'lps'),
	(620680, 131, '2014-04-01 00:52:31.000000', 'consum', 0.0222, 'lps'),
	(620681, 131, '2014-04-01 00:52:32.000000', 'consum', 0.0216, 'lps'),
	(620682, 131, '2014-04-01 00:52:33.000000', 'consum', 0.0223, 'lps'),
	(620683, 131, '2014-04-01 00:52:34.000000', 'consum', 0.0220, 'lps'),
	(620684, 131, '2014-04-01 00:52:35.000000', 'consum', 0.0218, 'lps'),
	(620685, 131, '2014-04-01 00:52:36.000000', 'consum', 0.0223, 'lps'),
	(620686, 131, '2014-04-01 00:52:37.000000', 'consum', 0.0212, 'lps'),
	(620687, 131, '2014-04-01 00:52:38.000000', 'consum', 0.0220, 'lps'),
	(620688, 131, '2014-04-01 00:52:39.000000', 'consum', 0.0216, 'lps'),
	(620689, 131, '2014-04-01 00:52:40.000000', 'consum', 0.0229, 'lps'),
	(620690, 131, '2014-04-01 00:52:41.000000', 'consum', 0.0210, 'lps'),
	(620691, 131, '2014-04-01 00:52:42.000000', 'consum', 0.0212, 'lps'),
	(620692, 131, '2014-04-01 00:52:43.000000', 'consum', 0.0220, 'lps'),
	(620693, 131, '2014-04-01 00:52:44.000000', 'consum', 0.0214, 'lps'),
	(620694, 131, '2014-04-01 00:52:45.000000', 'consum', 0.0220, 'lps'),
	(620695, 131, '2014-04-01 00:52:46.000000', 'consum', 0.0228, 'lps'),
	(620696, 131, '2014-04-01 00:52:47.000000', 'consum', 0.0214, 'lps'),
	(620697, 131, '2014-04-01 00:52:48.000000', 'consum', 0.0213, 'lps'),
	(620698, 131, '2014-04-01 00:52:49.000000', 'consum', 0.0213, 'lps'),
	(620699, 131, '2014-04-01 00:52:50.000000', 'consum', 0.0219, 'lps'),
	(620700, 131, '2014-04-01 00:52:51.000000', 'consum', 0.0226, 'lps'),
	(620701, 131, '2014-04-01 00:52:52.000000', 'consum', 0.0222, 'lps'),
	(620702, 131, '2014-04-01 00:52:53.000000', 'consum', 0.0221, 'lps'),
	(620703, 131, '2014-04-01 00:52:54.000000', 'consum', 0.0212, 'lps'),
	(620704, 131, '2014-04-01 00:52:55.000000', 'consum', 0.0229, 'lps'),
	(620705, 131, '2014-04-01 00:52:56.000000', 'consum', 0.0217, 'lps'),
	(620706, 131, '2014-04-01 00:52:57.000000', 'consum', 0.0211, 'lps'),
	(620707, 131, '2014-04-01 00:52:58.000000', 'consum', 0.0214, 'lps'),
	(620708, 131, '2014-04-01 00:52:59.000000', 'consum', 0.0229, 'lps'),
	(620709, 131, '2014-04-01 00:53:00.000000', 'consum', 0.0211, 'lps'),
	(620710, 131, '2014-04-01 00:53:01.000000', 'consum', 0.0219, 'lps'),
	(620711, 131, '2014-04-01 00:53:02.000000', 'consum', 0.0211, 'lps'),
	(620712, 131, '2014-04-01 00:53:03.000000', 'consum', 0.0229, 'lps'),
	(620713, 131, '2014-04-01 00:53:04.000000', 'consum', 0.0222, 'lps'),
	(620714, 131, '2014-04-01 00:53:05.000000', 'consum', 0.0214, 'lps'),
	(620715, 131, '2014-04-01 00:53:06.000000', 'consum', 0.0215, 'lps'),
	(620716, 131, '2014-04-01 00:53:07.000000', 'consum', 0.0224, 'lps'),
	(620717, 131, '2014-04-01 00:53:08.000000', 'consum', 0.0225, 'lps'),
	(620718, 131, '2014-04-01 00:53:09.000000', 'consum', 0.0224, 'lps'),
	(620719, 131, '2014-04-01 00:53:10.000000', 'consum', 0.0216, 'lps'),
	(620720, 131, '2014-04-01 00:53:11.000000', 'consum', 0.0218, 'lps'),
	(620721, 131, '2014-04-01 00:53:12.000000', 'consum', 0.0212, 'lps'),
	(620722, 131, '2014-04-01 00:53:13.000000', 'consum', 0.0215, 'lps'),
	(620723, 131, '2014-04-01 00:53:14.000000', 'consum', 0.0210, 'lps'),
	(620724, 131, '2014-04-01 00:53:15.000000', 'consum', 0.0215, 'lps'),
	(620725, 131, '2014-04-01 00:53:16.000000', 'consum', 0.0214, 'lps'),
	(620726, 131, '2014-04-01 00:53:17.000000', 'consum', 0.0219, 'lps'),
	(620727, 131, '2014-04-01 00:53:18.000000', 'consum', 0.0222, 'lps'),
	(620728, 131, '2014-04-01 00:53:19.000000', 'consum', 0.0221, 'lps'),
	(620729, 131, '2014-04-01 00:53:20.000000', 'consum', 0.0213, 'lps'),
	(620730, 131, '2014-04-01 00:53:21.000000', 'consum', 0.0213, 'lps'),
	(620731, 131, '2014-04-01 00:53:22.000000', 'consum', 0.0214, 'lps'),
	(620732, 131, '2014-04-01 00:53:23.000000', 'consum', 0.0221, 'lps'),
	(620733, 131, '2014-04-01 00:53:24.000000', 'consum', 0.0214, 'lps'),
	(620734, 131, '2014-04-01 00:53:25.000000', 'consum', 0.0220, 'lps'),
	(620735, 131, '2014-04-01 00:53:26.000000', 'consum', 0.0226, 'lps'),
	(620736, 131, '2014-04-01 00:53:27.000000', 'consum', 0.0222, 'lps'),
	(620737, 131, '2014-04-01 00:53:28.000000', 'consum', 0.0224, 'lps'),
	(620738, 131, '2014-04-01 00:53:29.000000', 'consum', 0.0223, 'lps'),
	(620739, 131, '2014-04-01 00:53:30.000000', 'consum', 0.0215, 'lps'),
	(620740, 131, '2014-04-01 00:53:31.000000', 'consum', 0.0217, 'lps'),
	(620741, 131, '2014-04-01 00:53:32.000000', 'consum', 0.0211, 'lps'),
	(620742, 131, '2014-04-01 00:53:33.000000', 'consum', 0.0213, 'lps'),
	(620743, 131, '2014-04-01 00:53:34.000000', 'consum', 0.0222, 'lps'),
	(620744, 131, '2014-04-01 00:53:35.000000', 'consum', 0.0222, 'lps'),
	(620745, 131, '2014-04-01 00:53:36.000000', 'consum', 0.0213, 'lps'),
	(620746, 131, '2014-04-01 00:53:37.000000', 'consum', 0.0213, 'lps'),
	(620747, 131, '2014-04-01 00:53:38.000000', 'consum', 0.0213, 'lps'),
	(620748, 131, '2014-04-01 00:53:39.000000', 'consum', 0.0217, 'lps'),
	(620749, 131, '2014-04-01 00:53:40.000000', 'consum', 0.0218, 'lps'),
	(620750, 131, '2014-04-01 00:53:41.000000', 'consum', 0.0228, 'lps'),
	(620751, 131, '2014-04-01 00:53:42.000000', 'consum', 0.0218, 'lps'),
	(620752, 131, '2014-04-01 00:53:43.000000', 'consum', 0.0217, 'lps'),
	(620753, 131, '2014-04-01 00:53:44.000000', 'consum', 0.0221, 'lps'),
	(620754, 131, '2014-04-01 00:53:45.000000', 'consum', 0.0226, 'lps'),
	(620755, 131, '2014-04-01 00:53:46.000000', 'consum', 0.0215, 'lps'),
	(620756, 131, '2014-04-01 00:53:47.000000', 'consum', 0.0227, 'lps'),
	(620757, 131, '2014-04-01 00:53:48.000000', 'consum', 0.0223, 'lps'),
	(620758, 131, '2014-04-01 00:53:49.000000', 'consum', 0.0226, 'lps'),
	(620759, 131, '2014-04-01 00:53:50.000000', 'consum', 0.0228, 'lps'),
	(620760, 131, '2014-04-01 00:53:51.000000', 'consum', 0.0214, 'lps'),
	(620761, 131, '2014-04-01 00:53:52.000000', 'consum', 0.0214, 'lps'),
	(620762, 131, '2014-04-01 00:53:53.000000', 'consum', 0.0221, 'lps'),
	(620763, 131, '2014-04-01 00:53:54.000000', 'consum', 0.0212, 'lps'),
	(620764, 131, '2014-04-01 00:53:55.000000', 'consum', 0.0228, 'lps'),
	(620765, 131, '2014-04-01 00:53:56.000000', 'consum', 0.0215, 'lps'),
	(620766, 131, '2014-04-01 00:53:57.000000', 'consum', 0.0220, 'lps'),
	(620767, 131, '2014-04-01 00:53:58.000000', 'consum', 0.0224, 'lps'),
	(620768, 131, '2014-04-01 00:53:59.000000', 'consum', 0.0214, 'lps'),
	(620769, 131, '2014-04-01 00:54:00.000000', 'consum', 0.0226, 'lps'),
	(620770, 131, '2014-04-01 00:54:01.000000', 'consum', 0.0221, 'lps'),
	(620771, 131, '2014-04-01 00:54:02.000000', 'consum', 0.0216, 'lps'),
	(620772, 131, '2014-04-01 00:54:03.000000', 'consum', 0.0226, 'lps'),
	(620773, 131, '2014-04-01 00:54:04.000000', 'consum', 0.0215, 'lps'),
	(620774, 131, '2014-04-01 00:54:05.000000', 'consum', 0.0226, 'lps'),
	(620775, 131, '2014-04-01 00:54:06.000000', 'consum', 0.0216, 'lps'),
	(620776, 131, '2014-04-01 00:54:07.000000', 'consum', 0.0214, 'lps'),
	(620777, 131, '2014-04-01 00:54:08.000000', 'consum', 0.0211, 'lps'),
	(620778, 131, '2014-04-01 00:54:09.000000', 'consum', 0.0225, 'lps'),
	(620779, 131, '2014-04-01 00:54:10.000000', 'consum', 0.0221, 'lps'),
	(620780, 131, '2014-04-01 00:54:11.000000', 'consum', 0.0222, 'lps'),
	(620781, 131, '2014-04-01 00:54:12.000000', 'consum', 0.0216, 'lps'),
	(620782, 131, '2014-04-01 00:54:13.000000', 'consum', 0.0223, 'lps'),
	(620783, 131, '2014-04-01 00:54:14.000000', 'consum', 0.0221, 'lps'),
	(620784, 131, '2014-04-01 00:54:15.000000', 'consum', 0.0223, 'lps'),
	(620785, 131, '2014-04-01 00:54:16.000000', 'consum', 0.0225, 'lps'),
	(620786, 131, '2014-04-01 00:54:17.000000', 'consum', 0.0226, 'lps'),
	(620787, 131, '2014-04-01 00:54:18.000000', 'consum', 0.0223, 'lps'),
	(620788, 131, '2014-04-01 00:54:19.000000', 'consum', 0.0211, 'lps'),
	(620789, 131, '2014-04-01 00:54:20.000000', 'consum', 0.0215, 'lps'),
	(620790, 131, '2014-04-01 00:54:21.000000', 'consum', 0.0212, 'lps'),
	(620791, 131, '2014-04-01 00:54:22.000000', 'consum', 0.0227, 'lps'),
	(620792, 131, '2014-04-01 00:54:23.000000', 'consum', 0.0210, 'lps'),
	(620793, 131, '2014-04-01 00:54:24.000000', 'consum', 0.0218, 'lps'),
	(620794, 131, '2014-04-01 00:54:25.000000', 'consum', 0.0212, 'lps'),
	(620795, 131, '2014-04-01 00:54:26.000000', 'consum', 0.0218, 'lps'),
	(620796, 131, '2014-04-01 00:54:27.000000', 'consum', 0.0222, 'lps'),
	(620797, 131, '2014-04-01 00:54:28.000000', 'consum', 0.0226, 'lps'),
	(620798, 131, '2014-04-01 00:54:29.000000', 'consum', 0.0216, 'lps'),
	(620799, 131, '2014-04-01 00:54:30.000000', 'consum', 0.0213, 'lps'),
	(620800, 131, '2014-04-01 00:54:31.000000', 'consum', 0.0228, 'lps'),
	(620801, 131, '2014-04-01 00:54:32.000000', 'consum', 0.0229, 'lps'),
	(620802, 131, '2014-04-01 00:54:33.000000', 'consum', 0.0213, 'lps'),
	(620803, 131, '2014-04-01 00:54:34.000000', 'consum', 0.0227, 'lps'),
	(620804, 131, '2014-04-01 00:54:35.000000', 'consum', 0.0229, 'lps'),
	(620805, 131, '2014-04-01 00:54:36.000000', 'consum', 0.0215, 'lps'),
	(620806, 131, '2014-04-01 00:54:37.000000', 'consum', 0.0216, 'lps'),
	(620807, 131, '2014-04-01 00:54:38.000000', 'consum', 0.0227, 'lps'),
	(620808, 131, '2014-04-01 00:54:39.000000', 'consum', 0.0219, 'lps'),
	(620809, 131, '2014-04-01 00:54:40.000000', 'consum', 0.0222, 'lps'),
	(620810, 131, '2014-04-01 00:54:41.000000', 'consum', 0.0224, 'lps'),
	(620811, 131, '2014-04-01 00:54:42.000000', 'consum', 0.0226, 'lps'),
	(620812, 131, '2014-04-01 00:54:43.000000', 'consum', 0.0229, 'lps'),
	(620813, 131, '2014-04-01 00:54:44.000000', 'consum', 0.0218, 'lps'),
	(620814, 131, '2014-04-01 00:54:45.000000', 'consum', 0.0212, 'lps'),
	(620815, 131, '2014-04-01 00:54:46.000000', 'consum', 0.0217, 'lps'),
	(620816, 131, '2014-04-01 00:54:47.000000', 'consum', 0.0217, 'lps'),
	(620817, 131, '2014-04-01 00:54:48.000000', 'consum', 0.0228, 'lps'),
	(620818, 131, '2014-04-01 00:54:49.000000', 'consum', 0.0217, 'lps'),
	(620819, 131, '2014-04-01 00:54:50.000000', 'consum', 0.0212, 'lps'),
	(620820, 131, '2014-04-01 00:54:51.000000', 'consum', 0.0222, 'lps'),
	(620821, 131, '2014-04-01 00:54:52.000000', 'consum', 0.0222, 'lps'),
	(620822, 131, '2014-04-01 00:54:53.000000', 'consum', 0.0214, 'lps'),
	(620823, 131, '2014-04-01 00:54:54.000000', 'consum', 0.0215, 'lps'),
	(620824, 131, '2014-04-01 00:54:55.000000', 'consum', 0.0223, 'lps'),
	(620825, 131, '2014-04-01 00:54:56.000000', 'consum', 0.0221, 'lps'),
	(620826, 131, '2014-04-01 00:54:57.000000', 'consum', 0.0228, 'lps'),
	(620827, 131, '2014-04-01 00:54:58.000000', 'consum', 0.0228, 'lps'),
	(620828, 131, '2014-04-01 00:54:59.000000', 'consum', 0.0227, 'lps'),
	(620829, 131, '2014-04-01 00:55:00.000000', 'consum', 0.0221, 'lps'),
	(620830, 131, '2014-04-01 00:55:01.000000', 'consum', 0.0213, 'lps'),
	(620831, 131, '2014-04-01 00:55:02.000000', 'consum', 0.0215, 'lps'),
	(620832, 131, '2014-04-01 00:55:03.000000', 'consum', 0.0226, 'lps'),
	(620833, 131, '2014-04-01 00:55:04.000000', 'consum', 0.0216, 'lps'),
	(620834, 131, '2014-04-01 00:55:05.000000', 'consum', 0.0212, 'lps'),
	(620835, 131, '2014-04-01 00:55:06.000000', 'consum', 0.0223, 'lps'),
	(620836, 131, '2014-04-01 00:55:07.000000', 'consum', 0.0228, 'lps'),
	(620837, 131, '2014-04-01 00:55:08.000000', 'consum', 0.0221, 'lps'),
	(620838, 131, '2014-04-01 00:55:09.000000', 'consum', 0.0212, 'lps'),
	(620839, 131, '2014-04-01 00:55:10.000000', 'consum', 0.0228, 'lps'),
	(620840, 131, '2014-04-01 00:55:11.000000', 'consum', 0.0216, 'lps'),
	(620841, 131, '2014-04-01 00:55:12.000000', 'consum', 0.0227, 'lps'),
	(620842, 131, '2014-04-01 00:55:13.000000', 'consum', 0.0218, 'lps'),
	(620843, 131, '2014-04-01 00:55:14.000000', 'consum', 0.0218, 'lps'),
	(620844, 131, '2014-04-01 00:55:15.000000', 'consum', 0.0227, 'lps'),
	(620845, 131, '2014-04-01 00:55:16.000000', 'consum', 0.0213, 'lps'),
	(620846, 131, '2014-04-01 00:55:17.000000', 'consum', 0.0213, 'lps'),
	(620847, 131, '2014-04-01 00:55:18.000000', 'consum', 0.0219, 'lps'),
	(620848, 131, '2014-04-01 00:55:19.000000', 'consum', 0.0224, 'lps'),
	(620849, 131, '2014-04-01 00:55:20.000000', 'consum', 0.0215, 'lps'),
	(620850, 131, '2014-04-01 00:55:21.000000', 'consum', 0.0212, 'lps'),
	(620851, 131, '2014-04-01 00:55:22.000000', 'consum', 0.0225, 'lps'),
	(620852, 131, '2014-04-01 00:55:23.000000', 'consum', 0.0218, 'lps'),
	(620853, 131, '2014-04-01 00:55:24.000000', 'consum', 0.0228, 'lps'),
	(620854, 131, '2014-04-01 00:55:25.000000', 'consum', 0.0218, 'lps'),
	(620855, 131, '2014-04-01 00:55:26.000000', 'consum', 0.0214, 'lps'),
	(620856, 131, '2014-04-01 00:55:27.000000', 'consum', 0.0229, 'lps'),
	(620857, 131, '2014-04-01 00:55:28.000000', 'consum', 0.0211, 'lps'),
	(620858, 131, '2014-04-01 00:55:29.000000', 'consum', 0.0221, 'lps'),
	(620859, 131, '2014-04-01 00:55:30.000000', 'consum', 0.0223, 'lps'),
	(620860, 131, '2014-04-01 00:55:31.000000', 'consum', 0.0222, 'lps'),
	(620861, 131, '2014-04-01 00:55:32.000000', 'consum', 0.0212, 'lps'),
	(620862, 131, '2014-04-01 00:55:33.000000', 'consum', 0.0224, 'lps'),
	(620863, 131, '2014-04-01 00:55:34.000000', 'consum', 0.0216, 'lps'),
	(620864, 131, '2014-04-01 00:55:35.000000', 'consum', 0.0217, 'lps'),
	(620865, 131, '2014-04-01 00:55:36.000000', 'consum', 0.0228, 'lps'),
	(620866, 131, '2014-04-01 00:55:37.000000', 'consum', 0.0220, 'lps'),
	(620867, 131, '2014-04-01 00:55:38.000000', 'consum', 0.0226, 'lps'),
	(620868, 131, '2014-04-01 00:55:39.000000', 'consum', 0.0222, 'lps'),
	(620869, 131, '2014-04-01 00:55:40.000000', 'consum', 0.0222, 'lps'),
	(620870, 131, '2014-04-01 00:55:41.000000', 'consum', 0.0214, 'lps'),
	(620871, 131, '2014-04-01 00:55:42.000000', 'consum', 0.0214, 'lps'),
	(620872, 131, '2014-04-01 00:55:43.000000', 'consum', 0.0219, 'lps'),
	(620873, 131, '2014-04-01 00:55:44.000000', 'consum', 0.0225, 'lps'),
	(620874, 131, '2014-04-01 00:55:45.000000', 'consum', 0.0219, 'lps'),
	(620875, 131, '2014-04-01 00:55:46.000000', 'consum', 0.0229, 'lps'),
	(620876, 131, '2014-04-01 00:55:47.000000', 'consum', 0.0219, 'lps'),
	(620877, 131, '2014-04-01 00:55:48.000000', 'consum', 0.0218, 'lps'),
	(620878, 131, '2014-04-01 00:55:49.000000', 'consum', 0.0223, 'lps'),
	(620879, 131, '2014-04-01 00:55:50.000000', 'consum', 0.0214, 'lps'),
	(620880, 131, '2014-04-01 00:55:51.000000', 'consum', 0.0229, 'lps'),
	(620881, 131, '2014-04-01 00:55:52.000000', 'consum', 0.0216, 'lps'),
	(620882, 131, '2014-04-01 00:55:53.000000', 'consum', 0.0220, 'lps'),
	(620883, 131, '2014-04-01 00:55:54.000000', 'consum', 0.0225, 'lps'),
	(620884, 131, '2014-04-01 00:55:55.000000', 'consum', 0.0214, 'lps'),
	(620885, 131, '2014-04-01 00:55:56.000000', 'consum', 0.0227, 'lps'),
	(620886, 131, '2014-04-01 00:55:57.000000', 'consum', 0.0222, 'lps'),
	(620887, 131, '2014-04-01 00:55:58.000000', 'consum', 0.0222, 'lps'),
	(620888, 131, '2014-04-01 00:55:59.000000', 'consum', 0.0212, 'lps'),
	(620889, 131, '2014-04-01 00:56:00.000000', 'consum', 0.0225, 'lps'),
	(620890, 131, '2014-04-01 00:56:01.000000', 'consum', 0.0221, 'lps'),
	(620891, 131, '2014-04-01 00:56:02.000000', 'consum', 0.0221, 'lps'),
	(620892, 131, '2014-04-01 00:56:03.000000', 'consum', 0.0210, 'lps'),
	(620893, 131, '2014-04-01 00:56:04.000000', 'consum', 0.0217, 'lps'),
	(620894, 131, '2014-04-01 00:56:05.000000', 'consum', 0.0225, 'lps'),
	(620895, 131, '2014-04-01 00:56:06.000000', 'consum', 0.0224, 'lps'),
	(620896, 131, '2014-04-01 00:56:07.000000', 'consum', 0.0219, 'lps'),
	(620897, 131, '2014-04-01 00:56:08.000000', 'consum', 0.0210, 'lps'),
	(620898, 131, '2014-04-01 00:56:09.000000', 'consum', 0.0225, 'lps'),
	(620899, 131, '2014-04-01 00:56:10.000000', 'consum', 0.0226, 'lps'),
	(620900, 131, '2014-04-01 00:56:11.000000', 'consum', 0.0224, 'lps'),
	(620901, 131, '2014-04-01 00:56:12.000000', 'consum', 0.0214, 'lps'),
	(620902, 131, '2014-04-01 00:56:13.000000', 'consum', 0.0228, 'lps'),
	(620903, 131, '2014-04-01 00:56:14.000000', 'consum', 0.0229, 'lps'),
	(620904, 131, '2014-04-01 00:56:15.000000', 'consum', 0.0211, 'lps'),
	(620905, 131, '2014-04-01 00:56:16.000000', 'consum', 0.0218, 'lps'),
	(620906, 131, '2014-04-01 00:56:17.000000', 'consum', 0.0229, 'lps'),
	(620907, 131, '2014-04-01 00:56:18.000000', 'consum', 0.0222, 'lps'),
	(620908, 131, '2014-04-01 00:56:19.000000', 'consum', 0.0211, 'lps'),
	(620909, 131, '2014-04-01 00:56:20.000000', 'consum', 0.0219, 'lps'),
	(620910, 131, '2014-04-01 00:56:21.000000', 'consum', 0.0214, 'lps'),
	(620911, 131, '2014-04-01 00:56:22.000000', 'consum', 0.0225, 'lps'),
	(620912, 131, '2014-04-01 00:56:23.000000', 'consum', 0.0214, 'lps'),
	(620913, 131, '2014-04-01 00:56:24.000000', 'consum', 0.0223, 'lps'),
	(620914, 131, '2014-04-01 00:56:25.000000', 'consum', 0.0226, 'lps'),
	(620915, 131, '2014-04-01 00:56:26.000000', 'consum', 0.0212, 'lps'),
	(620916, 131, '2014-04-01 00:56:27.000000', 'consum', 0.0212, 'lps'),
	(620917, 131, '2014-04-01 00:56:28.000000', 'consum', 0.0213, 'lps'),
	(620918, 131, '2014-04-01 00:56:29.000000', 'consum', 0.0218, 'lps'),
	(620919, 131, '2014-04-01 00:56:30.000000', 'consum', 0.0224, 'lps'),
	(620920, 131, '2014-04-01 00:56:31.000000', 'consum', 0.0218, 'lps'),
	(620921, 131, '2014-04-01 00:56:32.000000', 'consum', 0.0227, 'lps'),
	(620922, 131, '2014-04-01 00:56:33.000000', 'consum', 0.0211, 'lps'),
	(620923, 131, '2014-04-01 00:56:34.000000', 'consum', 0.0226, 'lps'),
	(620924, 131, '2014-04-01 00:56:35.000000', 'consum', 0.0225, 'lps'),
	(620925, 131, '2014-04-01 00:56:36.000000', 'consum', 0.0218, 'lps'),
	(620926, 131, '2014-04-01 00:56:37.000000', 'consum', 0.0228, 'lps'),
	(620927, 131, '2014-04-01 00:56:38.000000', 'consum', 0.0214, 'lps'),
	(620928, 131, '2014-04-01 00:56:39.000000', 'consum', 0.0216, 'lps'),
	(620929, 131, '2014-04-01 00:56:40.000000', 'consum', 0.0228, 'lps'),
	(620930, 131, '2014-04-01 00:56:41.000000', 'consum', 0.0224, 'lps'),
	(620931, 131, '2014-04-01 00:56:42.000000', 'consum', 0.0226, 'lps'),
	(620932, 131, '2014-04-01 00:56:43.000000', 'consum', 0.0228, 'lps'),
	(620933, 131, '2014-04-01 00:56:44.000000', 'consum', 0.0213, 'lps'),
	(620934, 131, '2014-04-01 00:56:45.000000', 'consum', 0.0213, 'lps'),
	(620935, 131, '2014-04-01 00:56:46.000000', 'consum', 0.0217, 'lps'),
	(620936, 131, '2014-04-01 00:56:47.000000', 'consum', 0.0215, 'lps'),
	(620937, 131, '2014-04-01 00:56:48.000000', 'consum', 0.0215, 'lps'),
	(620938, 131, '2014-04-01 00:56:49.000000', 'consum', 0.0219, 'lps'),
	(620939, 131, '2014-04-01 00:56:50.000000', 'consum', 0.0223, 'lps'),
	(620940, 131, '2014-04-01 00:56:51.000000', 'consum', 0.0227, 'lps'),
	(620941, 131, '2014-04-01 00:56:52.000000', 'consum', 0.0219, 'lps'),
	(620942, 131, '2014-04-01 00:56:53.000000', 'consum', 0.0223, 'lps'),
	(620943, 131, '2014-04-01 00:56:54.000000', 'consum', 0.0227, 'lps'),
	(620944, 131, '2014-04-01 00:56:55.000000', 'consum', 0.0217, 'lps'),
	(620945, 131, '2014-04-01 00:56:56.000000', 'consum', 0.0215, 'lps'),
	(620946, 131, '2014-04-01 00:56:57.000000', 'consum', 0.0216, 'lps'),
	(620947, 131, '2014-04-01 00:56:58.000000', 'consum', 0.0226, 'lps'),
	(620948, 131, '2014-04-01 00:56:59.000000', 'consum', 0.0212, 'lps'),
	(620949, 131, '2014-04-01 00:57:00.000000', 'consum', 0.0212, 'lps'),
	(620950, 131, '2014-04-01 00:57:01.000000', 'consum', 0.0216, 'lps'),
	(620951, 131, '2014-04-01 00:57:02.000000', 'consum', 0.0215, 'lps'),
	(620952, 131, '2014-04-01 00:57:03.000000', 'consum', 0.0215, 'lps'),
	(620953, 131, '2014-04-01 00:57:04.000000', 'consum', 0.0221, 'lps'),
	(620954, 131, '2014-04-01 00:57:05.000000', 'consum', 0.0229, 'lps'),
	(620955, 131, '2014-04-01 00:57:06.000000', 'consum', 0.0215, 'lps'),
	(620956, 131, '2014-04-01 00:57:07.000000', 'consum', 0.0219, 'lps'),
	(620957, 131, '2014-04-01 00:57:08.000000', 'consum', 0.0221, 'lps'),
	(620958, 131, '2014-04-01 00:57:09.000000', 'consum', 0.0218, 'lps'),
	(620959, 131, '2014-04-01 00:57:10.000000', 'consum', 0.0219, 'lps'),
	(620960, 131, '2014-04-01 00:57:11.000000', 'consum', 0.0228, 'lps'),
	(620961, 131, '2014-04-01 00:57:12.000000', 'consum', 0.0216, 'lps'),
	(620962, 131, '2014-04-01 00:57:13.000000', 'consum', 0.0225, 'lps'),
	(620963, 131, '2014-04-01 00:57:14.000000', 'consum', 0.0228, 'lps'),
	(620964, 131, '2014-04-01 00:57:15.000000', 'consum', 0.0213, 'lps'),
	(620965, 131, '2014-04-01 00:57:16.000000', 'consum', 0.0215, 'lps'),
	(620966, 131, '2014-04-01 00:57:17.000000', 'consum', 0.0226, 'lps'),
	(620967, 131, '2014-04-01 00:57:18.000000', 'consum', 0.0213, 'lps'),
	(620968, 131, '2014-04-01 00:57:19.000000', 'consum', 0.0219, 'lps'),
	(620969, 131, '2014-04-01 00:57:20.000000', 'consum', 0.0228, 'lps'),
	(620970, 131, '2014-04-01 00:57:21.000000', 'consum', 0.0213, 'lps'),
	(620971, 131, '2014-04-01 00:57:22.000000', 'consum', 0.0210, 'lps'),
	(620972, 131, '2014-04-01 00:57:23.000000', 'consum', 0.0223, 'lps'),
	(620973, 131, '2014-04-01 00:57:24.000000', 'consum', 0.0217, 'lps'),
	(620974, 131, '2014-04-01 00:57:25.000000', 'consum', 0.0225, 'lps'),
	(620975, 131, '2014-04-01 00:57:26.000000', 'consum', 0.0223, 'lps'),
	(620976, 131, '2014-04-01 00:57:27.000000', 'consum', 0.0213, 'lps'),
	(620977, 131, '2014-04-01 00:57:28.000000', 'consum', 0.0227, 'lps'),
	(620978, 131, '2014-04-01 00:57:29.000000', 'consum', 0.0224, 'lps'),
	(620979, 131, '2014-04-01 00:57:30.000000', 'consum', 0.0211, 'lps'),
	(620980, 131, '2014-04-01 00:57:31.000000', 'consum', 0.0212, 'lps'),
	(620981, 131, '2014-04-01 00:57:32.000000', 'consum', 0.0218, 'lps'),
	(620982, 131, '2014-04-01 00:57:33.000000', 'consum', 0.0225, 'lps'),
	(620983, 131, '2014-04-01 00:57:34.000000', 'consum', 0.0220, 'lps'),
	(620984, 131, '2014-04-01 00:57:35.000000', 'consum', 0.0215, 'lps'),
	(620985, 131, '2014-04-01 00:57:36.000000', 'consum', 0.0228, 'lps'),
	(620986, 131, '2014-04-01 00:57:37.000000', 'consum', 0.0225, 'lps'),
	(620987, 131, '2014-04-01 00:57:38.000000', 'consum', 0.0229, 'lps'),
	(620988, 131, '2014-04-01 00:57:39.000000', 'consum', 0.0222, 'lps'),
	(620989, 131, '2014-04-01 00:57:40.000000', 'consum', 0.0213, 'lps'),
	(620990, 131, '2014-04-01 00:57:41.000000', 'consum', 0.0229, 'lps'),
	(620991, 131, '2014-04-01 00:57:42.000000', 'consum', 0.0216, 'lps'),
	(620992, 131, '2014-04-01 00:57:43.000000', 'consum', 0.0226, 'lps'),
	(620993, 131, '2014-04-01 00:57:44.000000', 'consum', 0.0211, 'lps'),
	(620994, 131, '2014-04-01 00:57:45.000000', 'consum', 0.0228, 'lps'),
	(620995, 131, '2014-04-01 00:57:46.000000', 'consum', 0.0216, 'lps'),
	(620996, 131, '2014-04-01 00:57:47.000000', 'consum', 0.0229, 'lps'),
	(620997, 131, '2014-04-01 00:57:48.000000', 'consum', 0.0226, 'lps'),
	(620998, 131, '2014-04-01 00:57:49.000000', 'consum', 0.0214, 'lps'),
	(620999, 131, '2014-04-01 00:57:50.000000', 'consum', 0.0222, 'lps'),
	(621000, 131, '2014-04-01 00:57:51.000000', 'consum', 0.0218, 'lps'),
	(621001, 131, '2014-04-01 00:57:52.000000', 'consum', 0.0216, 'lps'),
	(621002, 131, '2014-04-01 00:57:53.000000', 'consum', 0.0215, 'lps'),
	(621003, 131, '2014-04-01 00:57:54.000000', 'consum', 0.0219, 'lps'),
	(621004, 131, '2014-04-01 00:57:55.000000', 'consum', 0.0222, 'lps'),
	(621005, 131, '2014-04-01 00:57:56.000000', 'consum', 0.0221, 'lps'),
	(621006, 131, '2014-04-01 00:57:57.000000', 'consum', 0.0228, 'lps'),
	(621007, 131, '2014-04-01 00:57:58.000000', 'consum', 0.0211, 'lps'),
	(621008, 131, '2014-04-01 00:57:59.000000', 'consum', 0.0219, 'lps'),
	(621009, 131, '2014-04-01 00:58:00.000000', 'consum', 0.0213, 'lps'),
	(621010, 131, '2014-04-01 00:58:01.000000', 'consum', 0.0218, 'lps'),
	(621011, 131, '2014-04-01 00:58:02.000000', 'consum', 0.0223, 'lps'),
	(621012, 131, '2014-04-01 00:58:03.000000', 'consum', 0.0229, 'lps'),
	(621013, 131, '2014-04-01 00:58:04.000000', 'consum', 0.0229, 'lps'),
	(621014, 131, '2014-04-01 00:58:05.000000', 'consum', 0.0227, 'lps'),
	(621015, 131, '2014-04-01 00:58:06.000000', 'consum', 0.0218, 'lps'),
	(621016, 131, '2014-04-01 00:58:07.000000', 'consum', 0.0220, 'lps'),
	(621017, 131, '2014-04-01 00:58:08.000000', 'consum', 0.0217, 'lps'),
	(621018, 131, '2014-04-01 00:58:09.000000', 'consum', 0.0214, 'lps'),
	(621019, 131, '2014-04-01 00:58:10.000000', 'consum', 0.0210, 'lps'),
	(621020, 131, '2014-04-01 00:58:11.000000', 'consum', 0.0217, 'lps'),
	(621021, 131, '2014-04-01 00:58:12.000000', 'consum', 0.0229, 'lps'),
	(621022, 131, '2014-04-01 00:58:13.000000', 'consum', 0.0222, 'lps'),
	(621023, 131, '2014-04-01 00:58:14.000000', 'consum', 0.0212, 'lps'),
	(621024, 131, '2014-04-01 00:58:15.000000', 'consum', 0.0228, 'lps'),
	(621025, 131, '2014-04-01 00:58:16.000000', 'consum', 0.0212, 'lps'),
	(621026, 131, '2014-04-01 00:58:17.000000', 'consum', 0.0225, 'lps'),
	(621027, 131, '2014-04-01 00:58:18.000000', 'consum', 0.0223, 'lps'),
	(621028, 131, '2014-04-01 00:58:19.000000', 'consum', 0.0228, 'lps'),
	(621029, 131, '2014-04-01 00:58:20.000000', 'consum', 0.0222, 'lps'),
	(621030, 131, '2014-04-01 00:58:21.000000', 'consum', 0.0218, 'lps'),
	(621031, 131, '2014-04-01 00:58:22.000000', 'consum', 0.0214, 'lps'),
	(621032, 131, '2014-04-01 00:58:23.000000', 'consum', 0.0226, 'lps'),
	(621033, 131, '2014-04-01 00:58:24.000000', 'consum', 0.0220, 'lps'),
	(621034, 131, '2014-04-01 00:58:25.000000', 'consum', 0.0211, 'lps'),
	(621035, 131, '2014-04-01 00:58:26.000000', 'consum', 0.0227, 'lps'),
	(621036, 131, '2014-04-01 00:58:27.000000', 'consum', 0.0210, 'lps'),
	(621037, 131, '2014-04-01 00:58:28.000000', 'consum', 0.0222, 'lps'),
	(621038, 131, '2014-04-01 00:58:29.000000', 'consum', 0.0210, 'lps'),
	(621039, 131, '2014-04-01 00:58:30.000000', 'consum', 0.0212, 'lps'),
	(621040, 131, '2014-04-01 00:58:31.000000', 'consum', 0.0224, 'lps'),
	(621041, 131, '2014-04-01 00:58:32.000000', 'consum', 0.0212, 'lps'),
	(621042, 131, '2014-04-01 00:58:33.000000', 'consum', 0.0220, 'lps'),
	(621043, 131, '2014-04-01 00:58:34.000000', 'consum', 0.0213, 'lps'),
	(621044, 131, '2014-04-01 00:58:35.000000', 'consum', 0.0217, 'lps'),
	(621045, 131, '2014-04-01 00:58:36.000000', 'consum', 0.0215, 'lps'),
	(621046, 131, '2014-04-01 00:58:37.000000', 'consum', 0.0216, 'lps'),
	(621047, 131, '2014-04-01 00:58:38.000000', 'consum', 0.0225, 'lps'),
	(621048, 131, '2014-04-01 00:58:39.000000', 'consum', 0.0226, 'lps'),
	(621049, 131, '2014-04-01 00:58:40.000000', 'consum', 0.0225, 'lps'),
	(621050, 131, '2014-04-01 00:58:41.000000', 'consum', 0.0219, 'lps'),
	(621051, 131, '2014-04-01 00:58:42.000000', 'consum', 0.0210, 'lps'),
	(621052, 131, '2014-04-01 00:58:43.000000', 'consum', 0.0223, 'lps'),
	(621053, 131, '2014-04-01 00:58:44.000000', 'consum', 0.0215, 'lps'),
	(621054, 131, '2014-04-01 00:58:45.000000', 'consum', 0.0215, 'lps'),
	(621055, 131, '2014-04-01 00:58:46.000000', 'consum', 0.0224, 'lps'),
	(621056, 131, '2014-04-01 00:58:47.000000', 'consum', 0.0224, 'lps'),
	(621057, 131, '2014-04-01 00:58:48.000000', 'consum', 0.0219, 'lps'),
	(621058, 131, '2014-04-01 00:58:49.000000', 'consum', 0.0212, 'lps'),
	(621059, 131, '2014-04-01 00:58:50.000000', 'consum', 0.0216, 'lps'),
	(621060, 131, '2014-04-01 00:58:51.000000', 'consum', 0.0215, 'lps'),
	(621061, 131, '2014-04-01 00:58:52.000000', 'consum', 0.0215, 'lps'),
	(621062, 131, '2014-04-01 00:58:53.000000', 'consum', 0.0223, 'lps'),
	(621063, 131, '2014-04-01 00:58:54.000000', 'consum', 0.0218, 'lps'),
	(621064, 131, '2014-04-01 00:58:55.000000', 'consum', 0.0211, 'lps'),
	(621065, 131, '2014-04-01 00:58:56.000000', 'consum', 0.0212, 'lps'),
	(621066, 131, '2014-04-01 00:58:57.000000', 'consum', 0.0217, 'lps'),
	(621067, 131, '2014-04-01 00:58:58.000000', 'consum', 0.0221, 'lps'),
	(621068, 131, '2014-04-01 00:58:59.000000', 'consum', 0.0225, 'lps'),
	(621069, 131, '2014-04-01 00:59:00.000000', 'consum', 0.0212, 'lps'),
	(621070, 131, '2014-04-01 00:59:01.000000', 'consum', 0.0215, 'lps'),
	(621071, 131, '2014-04-01 00:59:02.000000', 'consum', 0.0210, 'lps'),
	(621072, 131, '2014-04-01 00:59:03.000000', 'consum', 0.0217, 'lps'),
	(621073, 131, '2014-04-01 00:59:04.000000', 'consum', 0.0223, 'lps'),
	(621074, 131, '2014-04-01 00:59:05.000000', 'consum', 0.0213, 'lps'),
	(621075, 131, '2014-04-01 00:59:06.000000', 'consum', 0.0210, 'lps'),
	(621076, 131, '2014-04-01 00:59:07.000000', 'consum', 0.0219, 'lps'),
	(621077, 131, '2014-04-01 00:59:08.000000', 'consum', 0.0215, 'lps'),
	(621078, 131, '2014-04-01 00:59:09.000000', 'consum', 0.0229, 'lps'),
	(621079, 131, '2014-04-01 00:59:10.000000', 'consum', 0.0229, 'lps'),
	(621080, 131, '2014-04-01 00:59:11.000000', 'consum', 0.0211, 'lps'),
	(621081, 131, '2014-04-01 00:59:12.000000', 'consum', 0.0216, 'lps'),
	(621082, 131, '2014-04-01 00:59:13.000000', 'consum', 0.0219, 'lps'),
	(621083, 131, '2014-04-01 00:59:14.000000', 'consum', 0.0216, 'lps'),
	(621084, 131, '2014-04-01 00:59:15.000000', 'consum', 0.0216, 'lps'),
	(621085, 131, '2014-04-01 00:59:16.000000', 'consum', 0.0223, 'lps'),
	(621086, 131, '2014-04-01 00:59:17.000000', 'consum', 0.0215, 'lps'),
	(621087, 131, '2014-04-01 00:59:18.000000', 'consum', 0.0215, 'lps'),
	(621088, 131, '2014-04-01 00:59:19.000000', 'consum', 0.0224, 'lps'),
	(621089, 131, '2014-04-01 00:59:20.000000', 'consum', 0.0224, 'lps'),
	(621090, 131, '2014-04-01 00:59:21.000000', 'consum', 0.0219, 'lps'),
	(621091, 131, '2014-04-01 00:59:22.000000', 'consum', 0.0213, 'lps'),
	(621092, 131, '2014-04-01 00:59:23.000000', 'consum', 0.0218, 'lps'),
	(621093, 131, '2014-04-01 00:59:24.000000', 'consum', 0.0222, 'lps'),
	(621094, 131, '2014-04-01 00:59:25.000000', 'consum', 0.0227, 'lps'),
	(621095, 131, '2014-04-01 00:59:26.000000', 'consum', 0.0220, 'lps'),
	(621096, 131, '2014-04-01 00:59:27.000000', 'consum', 0.0227, 'lps'),
	(621097, 131, '2014-04-01 00:59:28.000000', 'consum', 0.0228, 'lps'),
	(621098, 131, '2014-04-01 00:59:29.000000', 'consum', 0.0228, 'lps'),
	(621099, 131, '2014-04-01 00:59:30.000000', 'consum', 0.0228, 'lps'),
	(621100, 131, '2014-04-01 00:59:31.000000', 'consum', 0.0227, 'lps'),
	(621101, 131, '2014-04-01 00:59:32.000000', 'consum', 0.0222, 'lps'),
	(621102, 131, '2014-04-01 00:59:33.000000', 'consum', 0.0217, 'lps'),
	(621103, 131, '2014-04-01 00:59:34.000000', 'consum', 0.0213, 'lps'),
	(621104, 131, '2014-04-01 00:59:35.000000', 'consum', 0.0221, 'lps'),
	(621105, 131, '2014-04-01 00:59:36.000000', 'consum', 0.0219, 'lps'),
	(621106, 131, '2014-04-01 00:59:37.000000', 'consum', 0.0220, 'lps'),
	(621107, 131, '2014-04-01 00:59:38.000000', 'consum', 0.0214, 'lps'),
	(621108, 131, '2014-04-01 00:59:39.000000', 'consum', 0.0219, 'lps'),
	(621109, 131, '2014-04-01 00:59:40.000000', 'consum', 0.0226, 'lps'),
	(621110, 131, '2014-04-01 00:59:41.000000', 'consum', 0.0222, 'lps'),
	(621111, 131, '2014-04-01 00:59:42.000000', 'consum', 0.0223, 'lps'),
	(621112, 131, '2014-04-01 00:59:43.000000', 'consum', 0.0221, 'lps'),
	(621113, 131, '2014-04-01 00:59:44.000000', 'consum', 0.0227, 'lps'),
	(621114, 131, '2014-04-01 00:59:45.000000', 'consum', 0.0222, 'lps'),
	(621115, 131, '2014-04-01 00:59:46.000000', 'consum', 0.0219, 'lps'),
	(621116, 131, '2014-04-01 00:59:47.000000', 'consum', 0.0220, 'lps'),
	(621117, 131, '2014-04-01 00:59:48.000000', 'consum', 0.0213, 'lps'),
	(621118, 131, '2014-04-01 00:59:49.000000', 'consum', 0.0213, 'lps'),
	(621119, 131, '2014-04-01 00:59:50.000000', 'consum', 0.0220, 'lps'),
	(621120, 131, '2014-04-01 00:59:51.000000', 'consum', 0.0212, 'lps'),
	(621121, 131, '2014-04-01 00:59:52.000000', 'consum', 0.0210, 'lps'),
	(621122, 131, '2014-04-01 00:59:53.000000', 'consum', 0.0225, 'lps'),
	(621123, 131, '2014-04-01 00:59:54.000000', 'consum', 0.0227, 'lps'),
	(621124, 131, '2014-04-01 00:59:55.000000', 'consum', 0.0227, 'lps'),
	(621125, 131, '2014-04-01 00:59:56.000000', 'consum', 0.0226, 'lps'),
	(621126, 131, '2014-04-01 00:59:57.000000', 'consum', 0.0221, 'lps'),
	(621127, 131, '2014-04-01 00:59:58.000000', 'consum', 0.0217, 'lps'),
	(621128, 131, '2014-04-01 00:59:59.000000', 'consum', 0.0211, 'lps'),
	(621129, 131, '2014-04-01 01:00:00.000000', 'consum', 0.0215, 'lps'),
	(621130, 131, '2014-04-01 01:00:01.000000', 'consum', 0.0211, 'lps'),
	(621131, 131, '2014-04-01 01:00:02.000000', 'consum', 0.0223, 'lps'),
	(621132, 131, '2014-04-01 01:00:03.000000', 'consum', 0.0212, 'lps'),
	(621133, 131, '2014-04-01 01:00:04.000000', 'consum', 0.0222, 'lps'),
	(621134, 131, '2014-04-01 01:00:05.000000', 'consum', 0.0222, 'lps'),
	(621135, 131, '2014-04-01 01:00:06.000000', 'consum', 0.0216, 'lps'),
	(621136, 131, '2014-04-01 01:00:07.000000', 'consum', 0.0226, 'lps'),
	(621137, 131, '2014-04-01 01:00:08.000000', 'consum', 0.0213, 'lps'),
	(621138, 131, '2014-04-01 01:00:09.000000', 'consum', 0.0215, 'lps'),
	(621139, 131, '2014-04-01 01:00:10.000000', 'consum', 0.0226, 'lps'),
	(621140, 131, '2014-04-01 01:00:11.000000', 'consum', 0.0218, 'lps'),
	(621141, 131, '2014-04-01 01:00:12.000000', 'consum', 0.0220, 'lps'),
	(621142, 131, '2014-04-01 01:00:13.000000', 'consum', 0.0218, 'lps'),
	(621143, 131, '2014-04-01 01:00:14.000000', 'consum', 0.0222, 'lps'),
	(621144, 131, '2014-04-01 01:00:15.000000', 'consum', 0.0225, 'lps'),
	(621145, 131, '2014-04-01 01:00:16.000000', 'consum', 0.0229, 'lps'),
	(621146, 131, '2014-04-01 01:00:17.000000', 'consum', 0.0223, 'lps'),
	(621147, 131, '2014-04-01 01:00:18.000000', 'consum', 0.0217, 'lps'),
	(621148, 131, '2014-04-01 01:00:19.000000', 'consum', 0.0227, 'lps'),
	(621149, 131, '2014-04-01 01:00:20.000000', 'consum', 0.0214, 'lps'),
	(621150, 131, '2014-04-01 01:00:21.000000', 'consum', 0.0220, 'lps'),
	(621151, 131, '2014-04-01 01:00:22.000000', 'consum', 0.0227, 'lps'),
	(621152, 131, '2014-04-01 01:00:23.000000', 'consum', 0.0225, 'lps'),
	(621153, 131, '2014-04-01 01:00:24.000000', 'consum', 0.0217, 'lps'),
	(621154, 131, '2014-04-01 01:00:25.000000', 'consum', 0.0220, 'lps'),
	(621155, 131, '2014-04-01 01:00:26.000000', 'consum', 0.0218, 'lps'),
	(621156, 131, '2014-04-01 01:00:27.000000', 'consum', 0.0222, 'lps'),
	(621157, 131, '2014-04-01 01:00:28.000000', 'consum', 0.0224, 'lps'),
	(621158, 131, '2014-04-01 01:00:29.000000', 'consum', 0.0226, 'lps'),
	(621159, 131, '2014-04-01 01:00:30.000000', 'consum', 0.0228, 'lps'),
	(621160, 131, '2014-04-01 01:00:31.000000', 'consum', 0.0212, 'lps'),
	(621161, 131, '2014-04-01 01:00:32.000000', 'consum', 0.0227, 'lps'),
	(621162, 131, '2014-04-01 01:00:33.000000', 'consum', 0.0227, 'lps'),
	(621163, 131, '2014-04-01 01:00:34.000000', 'consum', 0.0228, 'lps'),
	(621164, 131, '2014-04-01 01:00:35.000000', 'consum', 0.0228, 'lps'),
	(621165, 131, '2014-04-01 01:00:36.000000', 'consum', 0.0229, 'lps'),
	(621166, 131, '2014-04-01 01:00:37.000000', 'consum', 0.0229, 'lps'),
	(621167, 131, '2014-04-01 01:00:38.000000', 'consum', 0.0228, 'lps'),
	(621168, 131, '2014-04-01 01:00:39.000000', 'consum', 0.0222, 'lps'),
	(621169, 131, '2014-04-01 01:00:40.000000', 'consum', 0.0219, 'lps'),
	(621170, 131, '2014-04-01 01:00:41.000000', 'consum', 0.0221, 'lps'),
	(621171, 131, '2014-04-01 01:00:42.000000', 'consum', 0.0215, 'lps'),
	(621172, 131, '2014-04-01 01:00:43.000000', 'consum', 0.0225, 'lps'),
	(621173, 131, '2014-04-01 01:00:44.000000', 'consum', 0.0228, 'lps'),
	(621174, 131, '2014-04-01 01:00:45.000000', 'consum', 0.0219, 'lps'),
	(621175, 131, '2014-04-01 01:00:46.000000', 'consum', 0.0218, 'lps'),
	(621176, 131, '2014-04-01 01:00:47.000000', 'consum', 0.0227, 'lps'),
	(621177, 131, '2014-04-01 01:00:48.000000', 'consum', 0.0229, 'lps'),
	(621178, 131, '2014-04-01 01:00:49.000000', 'consum', 0.0213, 'lps'),
	(621179, 131, '2014-04-01 01:00:50.000000', 'consum', 0.0211, 'lps'),
	(621180, 131, '2014-04-01 01:00:51.000000', 'consum', 0.0224, 'lps'),
	(621181, 131, '2014-04-01 01:00:52.000000', 'consum', 0.0220, 'lps'),
	(621182, 131, '2014-04-01 01:00:53.000000', 'consum', 0.0219, 'lps'),
	(621183, 131, '2014-04-01 01:00:54.000000', 'consum', 0.0225, 'lps'),
	(621184, 131, '2014-04-01 01:00:55.000000', 'consum', 0.0219, 'lps'),
	(621185, 131, '2014-04-01 01:00:56.000000', 'consum', 0.0210, 'lps'),
	(621186, 131, '2014-04-01 01:00:57.000000', 'consum', 0.0224, 'lps'),
	(621187, 131, '2014-04-01 01:00:58.000000', 'consum', 0.0218, 'lps'),
	(621188, 131, '2014-04-01 01:00:59.000000', 'consum', 0.0211, 'lps'),
	(621189, 131, '2014-04-01 01:01:00.000000', 'consum', 0.0210, 'lps'),
	(621190, 131, '2014-04-01 01:01:01.000000', 'consum', 0.0210, 'lps'),
	(621191, 131, '2014-04-01 01:01:02.000000', 'consum', 0.0210, 'lps'),
	(621192, 131, '2014-04-01 01:01:03.000000', 'consum', 0.0229, 'lps'),
	(621193, 131, '2014-04-01 01:01:04.000000', 'consum', 0.0225, 'lps'),
	(621194, 131, '2014-04-01 01:01:05.000000', 'consum', 0.0228, 'lps'),
	(621195, 131, '2014-04-01 01:01:06.000000', 'consum', 0.0216, 'lps'),
	(621196, 131, '2014-04-01 01:01:07.000000', 'consum', 0.0228, 'lps'),
	(621197, 131, '2014-04-01 01:01:08.000000', 'consum', 0.0223, 'lps'),
	(621198, 131, '2014-04-01 01:01:09.000000', 'consum', 0.0220, 'lps'),
	(621199, 131, '2014-04-01 01:01:10.000000', 'consum', 0.0222, 'lps'),
	(621200, 131, '2014-04-01 01:01:11.000000', 'consum', 0.0222, 'lps'),
	(621201, 131, '2014-04-01 01:01:12.000000', 'consum', 0.0212, 'lps'),
	(621202, 131, '2014-04-01 01:01:13.000000', 'consum', 0.0226, 'lps'),
	(621203, 131, '2014-04-01 01:01:14.000000', 'consum', 0.0222, 'lps'),
	(621204, 131, '2014-04-01 01:01:15.000000', 'consum', 0.0225, 'lps'),
	(621205, 131, '2014-04-01 01:01:16.000000', 'consum', 0.0227, 'lps'),
	(621206, 131, '2014-04-01 01:01:17.000000', 'consum', 0.0213, 'lps'),
	(621207, 131, '2014-04-01 01:01:18.000000', 'consum', 0.0212, 'lps'),
	(621208, 131, '2014-04-01 01:01:19.000000', 'consum', 0.0213, 'lps'),
	(621209, 131, '2014-04-01 01:01:20.000000', 'consum', 0.0217, 'lps'),
	(621210, 131, '2014-04-01 01:01:21.000000', 'consum', 0.0219, 'lps'),
	(621211, 131, '2014-04-01 01:01:22.000000', 'consum', 0.0213, 'lps'),
	(621212, 131, '2014-04-01 01:01:23.000000', 'consum', 0.0217, 'lps'),
	(621213, 131, '2014-04-01 01:01:24.000000', 'consum', 0.0218, 'lps'),
	(621214, 131, '2014-04-01 01:01:25.000000', 'consum', 0.0211, 'lps'),
	(621215, 131, '2014-04-01 01:01:26.000000', 'consum', 0.0211, 'lps'),
	(621216, 131, '2014-04-01 01:01:27.000000', 'consum', 0.0211, 'lps'),
	(621217, 131, '2014-04-01 01:01:28.000000', 'consum', 0.0214, 'lps'),
	(621218, 131, '2014-04-01 01:01:29.000000', 'consum', 0.0227, 'lps'),
	(621219, 131, '2014-04-01 01:01:30.000000', 'consum', 0.0222, 'lps'),
	(621220, 131, '2014-04-01 01:01:31.000000', 'consum', 0.0221, 'lps'),
	(621221, 131, '2014-04-01 01:01:32.000000', 'consum', 0.0211, 'lps'),
	(621222, 131, '2014-04-01 01:01:33.000000', 'consum', 0.0221, 'lps'),
	(621223, 131, '2014-04-01 01:01:34.000000', 'consum', 0.0221, 'lps'),
	(621224, 131, '2014-04-01 01:01:35.000000', 'consum', 0.0215, 'lps'),
	(621225, 131, '2014-04-01 01:01:36.000000', 'consum', 0.0220, 'lps'),
	(621226, 131, '2014-04-01 01:01:37.000000', 'consum', 0.0226, 'lps'),
	(621227, 131, '2014-04-01 01:01:38.000000', 'consum', 0.0223, 'lps'),
	(621228, 131, '2014-04-01 01:01:39.000000', 'consum', 0.0225, 'lps'),
	(621229, 131, '2014-04-01 01:01:40.000000', 'consum', 0.0227, 'lps'),
	(621230, 131, '2014-04-01 01:01:41.000000', 'consum', 0.0229, 'lps'),
	(621231, 131, '2014-04-01 01:01:42.000000', 'consum', 0.0218, 'lps'),
	(621232, 131, '2014-04-01 01:01:43.000000', 'consum', 0.0210, 'lps'),
	(621233, 131, '2014-04-01 01:01:44.000000', 'consum', 0.0228, 'lps'),
	(621234, 131, '2014-04-01 01:01:45.000000', 'consum', 0.0221, 'lps'),
	(621235, 131, '2014-04-01 01:01:46.000000', 'consum', 0.0210, 'lps'),
	(621236, 131, '2014-04-01 01:01:47.000000', 'consum', 0.0217, 'lps'),
	(621237, 131, '2014-04-01 01:01:48.000000', 'consum', 0.0225, 'lps'),
	(621238, 131, '2014-04-01 01:01:49.000000', 'consum', 0.0225, 'lps'),
	(621239, 131, '2014-04-01 01:01:50.000000', 'consum', 0.0220, 'lps'),
	(621240, 131, '2014-04-01 01:01:51.000000', 'consum', 0.0217, 'lps'),
	(621241, 131, '2014-04-01 01:01:52.000000', 'consum', 0.0217, 'lps'),
	(621242, 131, '2014-04-01 01:01:53.000000', 'consum', 0.0221, 'lps'),
	(621243, 131, '2014-04-01 01:01:54.000000', 'consum', 0.0226, 'lps'),
	(621244, 131, '2014-04-01 01:01:55.000000', 'consum', 0.0215, 'lps'),
	(621245, 131, '2014-04-01 01:01:56.000000', 'consum', 0.0211, 'lps'),
	(621246, 131, '2014-04-01 01:01:57.000000', 'consum', 0.0220, 'lps'),
	(621247, 131, '2014-04-01 01:01:58.000000', 'consum', 0.0218, 'lps'),
	(621248, 131, '2014-04-01 01:01:59.000000', 'consum', 0.0221, 'lps'),
	(621249, 131, '2014-04-01 01:02:00.000000', 'consum', 0.0222, 'lps'),
	(621250, 131, '2014-04-01 01:02:01.000000', 'consum', 0.0215, 'lps'),
	(621251, 131, '2014-04-01 01:02:02.000000', 'consum', 0.0222, 'lps'),
	(621252, 131, '2014-04-01 01:02:03.000000', 'consum', 0.0217, 'lps'),
	(621253, 131, '2014-04-01 01:02:04.000000', 'consum', 0.0226, 'lps'),
	(621254, 131, '2014-04-01 01:02:05.000000', 'consum', 0.0211, 'lps'),
	(621255, 131, '2014-04-01 01:02:06.000000', 'consum', 0.0228, 'lps'),
	(621256, 131, '2014-04-01 01:02:07.000000', 'consum', 0.0218, 'lps'),
	(621257, 131, '2014-04-01 01:02:08.000000', 'consum', 0.0217, 'lps'),
	(621258, 131, '2014-04-01 01:02:09.000000', 'consum', 0.0222, 'lps'),
	(621259, 131, '2014-04-01 01:02:10.000000', 'consum', 0.0229, 'lps'),
	(621260, 131, '2014-04-01 01:02:11.000000', 'consum', 0.0229, 'lps'),
	(621261, 131, '2014-04-01 01:02:12.000000', 'consum', 0.0210, 'lps'),
	(621262, 131, '2014-04-01 01:02:13.000000', 'consum', 0.0214, 'lps'),
	(621263, 131, '2014-04-01 01:02:14.000000', 'consum', 0.0229, 'lps'),
	(621264, 131, '2014-04-01 01:02:15.000000', 'consum', 0.0214, 'lps'),
	(621265, 131, '2014-04-01 01:02:16.000000', 'consum', 0.0213, 'lps'),
	(621266, 131, '2014-04-01 01:02:17.000000', 'consum', 0.0213, 'lps'),
	(621267, 131, '2014-04-01 01:02:18.000000', 'consum', 0.0218, 'lps'),
	(621268, 131, '2014-04-01 01:02:19.000000', 'consum', 0.0221, 'lps'),
	(621269, 131, '2014-04-01 01:02:20.000000', 'consum', 0.0222, 'lps'),
	(621270, 131, '2014-04-01 01:02:21.000000', 'consum', 0.0218, 'lps'),
	(621271, 131, '2014-04-01 01:02:22.000000', 'consum', 0.0215, 'lps'),
	(621272, 131, '2014-04-01 01:02:23.000000', 'consum', 0.0212, 'lps'),
	(621273, 131, '2014-04-01 01:02:24.000000', 'consum', 0.0224, 'lps'),
	(621274, 131, '2014-04-01 01:02:25.000000', 'consum', 0.0214, 'lps'),
	(621275, 131, '2014-04-01 01:02:26.000000', 'consum', 0.0227, 'lps'),
	(621276, 131, '2014-04-01 01:02:27.000000', 'consum', 0.0226, 'lps'),
	(621277, 131, '2014-04-01 01:02:28.000000', 'consum', 0.0218, 'lps'),
	(621278, 131, '2014-04-01 01:02:29.000000', 'consum', 0.0223, 'lps'),
	(621279, 131, '2014-04-01 01:02:30.000000', 'consum', 0.0211, 'lps'),
	(621280, 131, '2014-04-01 01:02:31.000000', 'consum', 0.0215, 'lps'),
	(621281, 131, '2014-04-01 01:02:32.000000', 'consum', 0.0215, 'lps'),
	(621282, 131, '2014-04-01 01:02:33.000000', 'consum', 0.0218, 'lps'),
	(621283, 131, '2014-04-01 01:02:34.000000', 'consum', 0.0215, 'lps'),
	(621284, 131, '2014-04-01 01:02:35.000000', 'consum', 0.0213, 'lps'),
	(621285, 131, '2014-04-01 01:02:36.000000', 'consum', 0.0229, 'lps'),
	(621286, 131, '2014-04-01 01:02:37.000000', 'consum', 0.0218, 'lps'),
	(621287, 131, '2014-04-01 01:02:38.000000', 'consum', 0.0211, 'lps'),
	(621288, 131, '2014-04-01 01:02:39.000000', 'consum', 0.0215, 'lps'),
	(621289, 131, '2014-04-01 01:02:40.000000', 'consum', 0.0211, 'lps'),
	(621290, 131, '2014-04-01 01:02:41.000000', 'consum', 0.0221, 'lps'),
	(621291, 131, '2014-04-01 01:02:42.000000', 'consum', 0.0222, 'lps'),
	(621292, 131, '2014-04-01 01:02:43.000000', 'consum', 0.0216, 'lps'),
	(621293, 131, '2014-04-01 01:02:44.000000', 'consum', 0.0225, 'lps'),
	(621294, 131, '2014-04-01 01:02:45.000000', 'consum', 0.0229, 'lps'),
	(621295, 131, '2014-04-01 01:02:46.000000', 'consum', 0.0221, 'lps'),
	(621296, 131, '2014-04-01 01:02:47.000000', 'consum', 0.0228, 'lps'),
	(621297, 131, '2014-04-01 01:02:48.000000', 'consum', 0.0229, 'lps'),
	(621298, 131, '2014-04-01 01:02:49.000000', 'consum', 0.0229, 'lps'),
	(621299, 131, '2014-04-01 01:02:50.000000', 'consum', 0.0211, 'lps'),
	(621300, 131, '2014-04-01 01:02:51.000000', 'consum', 0.0216, 'lps'),
	(621301, 131, '2014-04-01 01:02:52.000000', 'consum', 0.0220, 'lps'),
	(621302, 131, '2014-04-01 01:02:53.000000', 'consum', 0.0222, 'lps'),
	(621303, 131, '2014-04-01 01:02:54.000000', 'consum', 0.0222, 'lps'),
	(621304, 131, '2014-04-01 01:02:55.000000', 'consum', 0.0211, 'lps'),
	(621305, 131, '2014-04-01 01:02:56.000000', 'consum', 0.0222, 'lps'),
	(621306, 131, '2014-04-01 01:02:57.000000', 'consum', 0.0227, 'lps'),
	(621307, 131, '2014-04-01 01:02:58.000000', 'consum', 0.0219, 'lps'),
	(621308, 131, '2014-04-01 01:02:59.000000', 'consum', 0.0225, 'lps'),
	(621309, 131, '2014-04-01 01:03:00.000000', 'consum', 0.0220, 'lps'),
	(621310, 131, '2014-04-01 01:03:01.000000', 'consum', 0.0213, 'lps'),
	(621311, 131, '2014-04-01 01:03:02.000000', 'consum', 0.0218, 'lps'),
	(621312, 131, '2014-04-01 01:03:03.000000', 'consum', 0.0222, 'lps'),
	(621313, 131, '2014-04-01 01:03:04.000000', 'consum', 0.0224, 'lps'),
	(621314, 131, '2014-04-01 01:03:05.000000', 'consum', 0.0224, 'lps'),
	(621315, 131, '2014-04-01 01:03:06.000000', 'consum', 0.0220, 'lps'),
	(621316, 131, '2014-04-01 01:03:07.000000', 'consum', 0.0217, 'lps'),
	(621317, 131, '2014-04-01 01:03:08.000000', 'consum', 0.0216, 'lps'),
	(621318, 131, '2014-04-01 01:03:09.000000', 'consum', 0.0218, 'lps'),
	(621319, 131, '2014-04-01 01:03:10.000000', 'consum', 0.0215, 'lps'),
	(621320, 131, '2014-04-01 01:03:11.000000', 'consum', 0.0212, 'lps'),
	(621321, 131, '2014-04-01 01:03:12.000000', 'consum', 0.0225, 'lps'),
	(621322, 131, '2014-04-01 01:03:13.000000', 'consum', 0.0218, 'lps'),
	(621323, 131, '2014-04-01 01:03:14.000000', 'consum', 0.0225, 'lps'),
	(621324, 131, '2014-04-01 01:03:15.000000', 'consum', 0.0224, 'lps'),
	(621325, 131, '2014-04-01 01:03:16.000000', 'consum', 0.0214, 'lps'),
	(621326, 131, '2014-04-01 01:03:17.000000', 'consum', 0.0229, 'lps'),
	(621327, 131, '2014-04-01 01:03:18.000000', 'consum', 0.0213, 'lps'),
	(621328, 131, '2014-04-01 01:03:19.000000', 'consum', 0.0229, 'lps'),
	(621329, 131, '2014-04-01 01:03:20.000000', 'consum', 0.0217, 'lps'),
	(621330, 131, '2014-04-01 01:03:21.000000', 'consum', 0.0229, 'lps'),
	(621331, 131, '2014-04-01 01:03:22.000000', 'consum', 0.0223, 'lps'),
	(621332, 131, '2014-04-01 01:03:23.000000', 'consum', 0.0220, 'lps'),
	(621333, 131, '2014-04-01 01:03:24.000000', 'consum', 0.0222, 'lps'),
	(621334, 131, '2014-04-01 01:03:25.000000', 'consum', 0.0220, 'lps'),
	(621335, 131, '2014-04-01 01:03:26.000000', 'consum', 0.0225, 'lps'),
	(621336, 131, '2014-04-01 01:03:27.000000', 'consum', 0.0216, 'lps'),
	(621337, 131, '2014-04-01 01:03:28.000000', 'consum', 0.0214, 'lps'),
	(621338, 131, '2014-04-01 01:03:29.000000', 'consum', 0.0212, 'lps'),
	(621339, 131, '2014-04-01 01:03:30.000000', 'consum', 0.0211, 'lps'),
	(621340, 131, '2014-04-01 01:03:31.000000', 'consum', 0.0229, 'lps'),
	(621341, 131, '2014-04-01 01:03:32.000000', 'consum', 0.0223, 'lps'),
	(621342, 131, '2014-04-01 01:03:33.000000', 'consum', 0.0218, 'lps'),
	(621343, 131, '2014-04-01 01:03:34.000000', 'consum', 0.0213, 'lps'),
	(621344, 131, '2014-04-01 01:03:35.000000', 'consum', 0.0221, 'lps'),
	(621345, 131, '2014-04-01 01:03:36.000000', 'consum', 0.0217, 'lps'),
	(621346, 131, '2014-04-01 01:03:37.000000', 'consum', 0.0212, 'lps'),
	(621347, 131, '2014-04-01 01:03:38.000000', 'consum', 0.0219, 'lps'),
	(621348, 131, '2014-04-01 01:03:39.000000', 'consum', 0.0228, 'lps'),
	(621349, 131, '2014-04-01 01:03:40.000000', 'consum', 0.0216, 'lps'),
	(621350, 131, '2014-04-01 01:03:41.000000', 'consum', 0.0227, 'lps'),
	(621351, 131, '2014-04-01 01:03:42.000000', 'consum', 0.0219, 'lps'),
	(621352, 131, '2014-04-01 01:03:43.000000', 'consum', 0.0221, 'lps'),
	(621353, 131, '2014-04-01 01:03:44.000000', 'consum', 0.0221, 'lps'),
	(621354, 131, '2014-04-01 01:03:45.000000', 'consum', 0.0213, 'lps'),
	(621355, 131, '2014-04-01 01:03:46.000000', 'consum', 0.0213, 'lps'),
	(621356, 131, '2014-04-01 01:03:47.000000', 'consum', 0.0217, 'lps'),
	(621357, 131, '2014-04-01 01:03:48.000000', 'consum', 0.0215, 'lps'),
	(621358, 131, '2014-04-01 01:03:49.000000', 'consum', 0.0215, 'lps'),
	(621359, 131, '2014-04-01 01:03:50.000000', 'consum', 0.0222, 'lps'),
	(621360, 131, '2014-04-01 01:03:51.000000', 'consum', 0.0215, 'lps'),
	(621361, 131, '2014-04-01 01:03:52.000000', 'consum', 0.0218, 'lps'),
	(621362, 131, '2014-04-01 01:03:53.000000', 'consum', 0.0216, 'lps'),
	(621363, 131, '2014-04-01 01:03:54.000000', 'consum', 0.0216, 'lps'),
	(621364, 131, '2014-04-01 01:03:55.000000', 'consum', 0.0223, 'lps'),
	(621365, 131, '2014-04-01 01:03:56.000000', 'consum', 0.0217, 'lps'),
	(621366, 131, '2014-04-01 01:03:57.000000', 'consum', 0.0228, 'lps'),
	(621367, 131, '2014-04-01 01:03:58.000000', 'consum', 0.0217, 'lps'),
	(621368, 131, '2014-04-01 01:03:59.000000', 'consum', 0.0214, 'lps'),
	(621369, 131, '2014-04-01 01:04:00.000000', 'consum', 0.0229, 'lps'),
	(621370, 131, '2014-04-01 01:04:01.000000', 'consum', 0.0212, 'lps'),
	(621371, 131, '2014-04-01 01:04:02.000000', 'consum', 0.0223, 'lps'),
	(621372, 131, '2014-04-01 01:04:03.000000', 'consum', 0.0212, 'lps'),
	(621373, 131, '2014-04-01 01:04:04.000000', 'consum', 0.0220, 'lps'),
	(621374, 131, '2014-04-01 01:04:05.000000', 'consum', 0.0215, 'lps'),
	(621375, 131, '2014-04-01 01:04:06.000000', 'consum', 0.0225, 'lps'),
	(621376, 131, '2014-04-01 01:04:07.000000', 'consum', 0.0211, 'lps'),
	(621377, 131, '2014-04-01 01:04:08.000000', 'consum', 0.0212, 'lps'),
	(621378, 131, '2014-04-01 01:04:09.000000', 'consum', 0.0217, 'lps'),
	(621379, 131, '2014-04-01 01:04:10.000000', 'consum', 0.0220, 'lps'),
	(621380, 131, '2014-04-01 01:04:11.000000', 'consum', 0.0220, 'lps'),
	(621381, 131, '2014-04-01 01:04:12.000000', 'consum', 0.0229, 'lps'),
	(621382, 131, '2014-04-01 01:04:13.000000', 'consum', 0.0214, 'lps'),
	(621383, 131, '2014-04-01 01:04:14.000000', 'consum', 0.0216, 'lps'),
	(621384, 131, '2014-04-01 01:04:15.000000', 'consum', 0.0229, 'lps'),
	(621385, 131, '2014-04-01 01:04:16.000000', 'consum', 0.0228, 'lps'),
	(621386, 131, '2014-04-01 01:04:17.000000', 'consum', 0.0221, 'lps'),
	(621387, 131, '2014-04-01 01:04:18.000000', 'consum', 0.0212, 'lps'),
	(621388, 131, '2014-04-01 01:04:19.000000', 'consum', 0.0227, 'lps'),
	(621389, 131, '2014-04-01 01:04:20.000000', 'consum', 0.0210, 'lps'),
	(621390, 131, '2014-04-01 01:04:21.000000', 'consum', 0.0220, 'lps'),
	(621391, 131, '2014-04-01 01:04:22.000000', 'consum', 0.0222, 'lps'),
	(621392, 131, '2014-04-01 01:04:23.000000', 'consum', 0.0219, 'lps'),
	(621393, 131, '2014-04-01 01:04:24.000000', 'consum', 0.0221, 'lps'),
	(621394, 131, '2014-04-01 01:04:25.000000', 'consum', 0.0216, 'lps'),
	(621395, 131, '2014-04-01 01:04:26.000000', 'consum', 0.0228, 'lps'),
	(621396, 131, '2014-04-01 01:04:27.000000', 'consum', 0.0222, 'lps'),
	(621397, 131, '2014-04-01 01:04:28.000000', 'consum', 0.0216, 'lps'),
	(621398, 131, '2014-04-01 01:04:29.000000', 'consum', 0.0224, 'lps'),
	(621399, 131, '2014-04-01 01:04:30.000000', 'consum', 0.0224, 'lps'),
	(621400, 131, '2014-04-01 01:04:31.000000', 'consum', 0.0218, 'lps'),
	(621401, 131, '2014-04-01 01:04:32.000000', 'consum', 0.0210, 'lps'),
	(621402, 131, '2014-04-01 01:04:33.000000', 'consum', 0.0227, 'lps'),
	(621403, 131, '2014-04-01 01:04:34.000000', 'consum', 0.0213, 'lps'),
	(621404, 131, '2014-04-01 01:04:35.000000', 'consum', 0.0216, 'lps'),
	(621405, 131, '2014-04-01 01:04:36.000000', 'consum', 0.0213, 'lps'),
	(621406, 131, '2014-04-01 01:04:37.000000', 'consum', 0.0226, 'lps'),
	(621407, 131, '2014-04-01 01:04:38.000000', 'consum', 0.0223, 'lps'),
	(621408, 131, '2014-04-01 01:04:39.000000', 'consum', 0.0228, 'lps'),
	(621409, 131, '2014-04-01 01:04:40.000000', 'consum', 0.0220, 'lps'),
	(621410, 131, '2014-04-01 01:04:41.000000', 'consum', 0.0225, 'lps'),
	(621411, 131, '2014-04-01 01:04:42.000000', 'consum', 0.0217, 'lps'),
	(621412, 131, '2014-04-01 01:04:43.000000', 'consum', 0.0221, 'lps'),
	(621413, 131, '2014-04-01 01:04:44.000000', 'consum', 0.0224, 'lps'),
	(621414, 131, '2014-04-01 01:04:45.000000', 'consum', 0.0228, 'lps'),
	(621415, 131, '2014-04-01 01:04:46.000000', 'consum', 0.0218, 'lps'),
	(621416, 131, '2014-04-01 01:04:47.000000', 'consum', 0.0218, 'lps'),
	(621417, 131, '2014-04-01 01:04:48.000000', 'consum', 0.0224, 'lps'),
	(621418, 131, '2014-04-01 01:04:49.000000', 'consum', 0.0217, 'lps'),
	(621419, 131, '2014-04-01 01:04:50.000000', 'consum', 0.0226, 'lps'),
	(621420, 131, '2014-04-01 01:04:51.000000', 'consum', 0.0226, 'lps'),
	(621421, 131, '2014-04-01 01:04:52.000000', 'consum', 0.0226, 'lps'),
	(621422, 131, '2014-04-01 01:04:53.000000', 'consum', 0.0219, 'lps'),
	(621423, 131, '2014-04-01 01:04:54.000000', 'consum', 0.0211, 'lps'),
	(621424, 131, '2014-04-01 01:04:55.000000', 'consum', 0.0225, 'lps'),
	(621425, 131, '2014-04-01 01:04:56.000000', 'consum', 0.0226, 'lps'),
	(621426, 131, '2014-04-01 01:04:57.000000', 'consum', 0.0223, 'lps'),
	(621427, 131, '2014-04-01 01:04:58.000000', 'consum', 0.0229, 'lps'),
	(621428, 131, '2014-04-01 01:04:59.000000', 'consum', 0.0227, 'lps'),
	(621429, 131, '2014-04-01 01:05:00.000000', 'consum', 0.0219, 'lps'),
	(621430, 131, '2014-04-01 01:05:01.000000', 'consum', 0.0225, 'lps'),
	(621431, 131, '2014-04-01 01:05:02.000000', 'consum', 0.0216, 'lps'),
	(621432, 131, '2014-04-01 01:05:03.000000', 'consum', 0.0219, 'lps'),
	(621433, 131, '2014-04-01 01:05:04.000000', 'consum', 0.0214, 'lps'),
	(621434, 131, '2014-04-01 01:05:05.000000', 'consum', 0.0224, 'lps'),
	(621435, 131, '2014-04-01 01:05:06.000000', 'consum', 0.0229, 'lps'),
	(621436, 131, '2014-04-01 01:05:07.000000', 'consum', 0.0224, 'lps'),
	(621437, 131, '2014-04-01 01:05:08.000000', 'consum', 0.0224, 'lps'),
	(621438, 131, '2014-04-01 01:05:09.000000', 'consum', 0.0220, 'lps'),
	(621439, 131, '2014-04-01 01:05:10.000000', 'consum', 0.0217, 'lps'),
	(621440, 131, '2014-04-01 01:05:11.000000', 'consum', 0.0215, 'lps'),
	(621441, 131, '2014-04-01 01:05:12.000000', 'consum', 0.0216, 'lps'),
	(621442, 131, '2014-04-01 01:05:13.000000', 'consum', 0.0226, 'lps'),
	(621443, 131, '2014-04-01 01:05:14.000000', 'consum', 0.0210, 'lps'),
	(621444, 131, '2014-04-01 01:05:15.000000', 'consum', 0.0225, 'lps'),
	(621445, 131, '2014-04-01 01:05:16.000000', 'consum', 0.0225, 'lps'),
	(621446, 131, '2014-04-01 01:05:17.000000', 'consum', 0.0221, 'lps'),
	(621447, 131, '2014-04-01 01:05:18.000000', 'consum', 0.0219, 'lps'),
	(621448, 131, '2014-04-01 01:05:19.000000', 'consum', 0.0223, 'lps'),
	(621449, 131, '2014-04-01 01:05:20.000000', 'consum', 0.0227, 'lps'),
	(621450, 131, '2014-04-01 01:05:21.000000', 'consum', 0.0217, 'lps'),
	(621451, 131, '2014-04-01 01:05:22.000000', 'consum', 0.0216, 'lps'),
	(621452, 131, '2014-04-01 01:05:23.000000', 'consum', 0.0218, 'lps'),
	(621453, 131, '2014-04-01 01:05:24.000000', 'consum', 0.0213, 'lps'),
	(621454, 131, '2014-04-01 01:05:25.000000', 'consum', 0.0221, 'lps'),
	(621455, 131, '2014-04-01 01:05:26.000000', 'consum', 0.0217, 'lps'),
	(621456, 131, '2014-04-01 01:05:27.000000', 'consum', 0.0212, 'lps'),
	(621457, 131, '2014-04-01 01:05:28.000000', 'consum', 0.0221, 'lps'),
	(621458, 131, '2014-04-01 01:05:29.000000', 'consum', 0.0218, 'lps'),
	(621459, 131, '2014-04-01 01:05:30.000000', 'consum', 0.0219, 'lps'),
	(621460, 131, '2014-04-01 01:05:31.000000', 'consum', 0.0229, 'lps'),
	(621461, 131, '2014-04-01 01:05:32.000000', 'consum', 0.0220, 'lps'),
	(621462, 131, '2014-04-01 01:05:33.000000', 'consum', 0.0222, 'lps'),
	(621463, 131, '2014-04-01 01:05:34.000000', 'consum', 0.0223, 'lps'),
	(621464, 131, '2014-04-01 01:05:35.000000', 'consum', 0.0219, 'lps'),
	(621465, 131, '2014-04-01 01:05:36.000000', 'consum', 0.0216, 'lps'),
	(621466, 131, '2014-04-01 01:05:37.000000', 'consum', 0.0212, 'lps'),
	(621467, 131, '2014-04-01 01:05:38.000000', 'consum', 0.0223, 'lps'),
	(621468, 131, '2014-04-01 01:05:39.000000', 'consum', 0.0211, 'lps'),
	(621469, 131, '2014-04-01 01:05:40.000000', 'consum', 0.0216, 'lps'),
	(621470, 131, '2014-04-01 01:05:41.000000', 'consum', 0.0219, 'lps'),
	(621471, 131, '2014-04-01 01:05:42.000000', 'consum', 0.0215, 'lps'),
	(621472, 131, '2014-04-01 01:05:43.000000', 'consum', 0.0210, 'lps'),
	(621473, 131, '2014-04-01 01:05:44.000000', 'consum', 0.0215, 'lps'),
	(621474, 131, '2014-04-01 01:05:45.000000', 'consum', 0.0214, 'lps'),
	(621475, 131, '2014-04-01 01:05:46.000000', 'consum', 0.0216, 'lps'),
	(621476, 131, '2014-04-01 01:05:47.000000', 'consum', 0.0228, 'lps'),
	(621477, 131, '2014-04-01 01:05:48.000000', 'consum', 0.0222, 'lps'),
	(621478, 131, '2014-04-01 01:05:49.000000', 'consum', 0.0216, 'lps'),
	(621479, 131, '2014-04-01 01:05:50.000000', 'consum', 0.0223, 'lps'),
	(621480, 131, '2014-04-01 01:05:51.000000', 'consum', 0.0221, 'lps'),
	(621481, 131, '2014-04-01 01:05:52.000000', 'consum', 0.0223, 'lps'),
	(621482, 131, '2014-04-01 01:05:53.000000', 'consum', 0.0226, 'lps'),
	(621483, 131, '2014-04-01 01:05:54.000000', 'consum', 0.0229, 'lps'),
	(621484, 131, '2014-04-01 01:05:55.000000', 'consum', 0.0220, 'lps'),
	(621485, 131, '2014-04-01 01:05:56.000000', 'consum', 0.0222, 'lps'),
	(621486, 131, '2014-04-01 01:05:57.000000', 'consum', 0.0219, 'lps'),
	(621487, 131, '2014-04-01 01:05:58.000000', 'consum', 0.0222, 'lps'),
	(621488, 131, '2014-04-01 01:05:59.000000', 'consum', 0.0223, 'lps'),
	(621489, 131, '2014-04-01 01:06:00.000000', 'consum', 0.0220, 'lps'),
	(621490, 131, '2014-04-01 01:06:01.000000', 'consum', 0.0222, 'lps'),
	(621491, 131, '2014-04-01 01:06:02.000000', 'consum', 0.0219, 'lps'),
	(621492, 131, '2014-04-01 01:06:03.000000', 'consum', 0.0220, 'lps'),
	(621493, 131, '2014-04-01 01:06:04.000000', 'consum', 0.0212, 'lps'),
	(621494, 131, '2014-04-01 01:06:05.000000', 'consum', 0.0213, 'lps'),
	(621495, 131, '2014-04-01 01:06:06.000000', 'consum', 0.0218, 'lps'),
	(621496, 131, '2014-04-01 01:06:07.000000', 'consum', 0.0221, 'lps'),
	(621497, 131, '2014-04-01 01:06:08.000000', 'consum', 0.0222, 'lps'),
	(621498, 131, '2014-04-01 01:06:09.000000', 'consum', 0.0218, 'lps'),
	(621499, 131, '2014-04-01 01:06:10.000000', 'consum', 0.0216, 'lps'),
	(621500, 131, '2014-04-01 01:06:11.000000', 'consum', 0.0215, 'lps'),
	(621501, 131, '2014-04-01 01:06:12.000000', 'consum', 0.0218, 'lps'),
	(621502, 131, '2014-04-01 01:06:13.000000', 'consum', 0.0215, 'lps'),
	(621503, 131, '2014-04-01 01:06:14.000000', 'consum', 0.0214, 'lps'),
	(621504, 131, '2014-04-01 01:06:15.000000', 'consum', 0.0212, 'lps'),
	(621505, 131, '2014-04-01 01:06:16.000000', 'consum', 0.0211, 'lps'),
	(621506, 131, '2014-04-01 01:06:17.000000', 'consum', 0.0211, 'lps'),
	(621507, 131, '2014-04-01 01:06:18.000000', 'consum', 0.0229, 'lps'),
	(621508, 131, '2014-04-01 01:06:19.000000', 'consum', 0.0223, 'lps'),
	(621509, 131, '2014-04-01 01:06:20.000000', 'consum', 0.0220, 'lps'),
	(621510, 131, '2014-04-01 01:06:21.000000', 'consum', 0.0222, 'lps'),
	(621511, 131, '2014-04-01 01:06:22.000000', 'consum', 0.0222, 'lps'),
	(621512, 131, '2014-04-01 01:06:23.000000', 'consum', 0.0211, 'lps'),
	(621513, 131, '2014-04-01 01:06:24.000000', 'consum', 0.0222, 'lps'),
	(621514, 131, '2014-04-01 01:06:25.000000', 'consum', 0.0225, 'lps'),
	(621515, 131, '2014-04-01 01:06:26.000000', 'consum', 0.0210, 'lps'),
	(621516, 131, '2014-04-01 01:06:27.000000', 'consum', 0.0227, 'lps'),
	(621517, 131, '2014-04-01 01:06:28.000000', 'consum', 0.0216, 'lps'),
	(621518, 131, '2014-04-01 01:06:29.000000', 'consum', 0.0227, 'lps'),
	(621519, 131, '2014-04-01 01:06:30.000000', 'consum', 0.0217, 'lps'),
	(621520, 131, '2014-04-01 01:06:31.000000', 'consum', 0.0214, 'lps'),
	(621521, 131, '2014-04-01 01:06:32.000000', 'consum', 0.0229, 'lps'),
	(621522, 131, '2014-04-01 01:06:33.000000', 'consum', 0.0214, 'lps'),
	(621523, 131, '2014-04-01 01:06:34.000000', 'consum', 0.0213, 'lps'),
	(621524, 131, '2014-04-01 01:06:35.000000', 'consum', 0.0212, 'lps'),
	(621525, 131, '2014-04-01 01:06:36.000000', 'consum', 0.0215, 'lps'),
	(621526, 131, '2014-04-01 01:06:37.000000', 'consum', 0.0226, 'lps'),
	(621527, 131, '2014-04-01 01:06:38.000000', 'consum', 0.0219, 'lps'),
	(621528, 131, '2014-04-01 01:06:39.000000', 'consum', 0.0226, 'lps'),
	(621529, 131, '2014-04-01 01:06:40.000000', 'consum', 0.0223, 'lps'),
	(621530, 131, '2014-04-01 01:06:41.000000', 'consum', 0.0226, 'lps'),
	(621531, 131, '2014-04-01 01:06:42.000000', 'consum', 0.0213, 'lps'),
	(621532, 131, '2014-04-01 01:06:43.000000', 'consum', 0.0219, 'lps'),
	(621533, 131, '2014-04-01 01:06:44.000000', 'consum', 0.0225, 'lps'),
	(621534, 131, '2014-04-01 01:06:45.000000', 'consum', 0.0217, 'lps'),
	(621535, 131, '2014-04-01 01:06:46.000000', 'consum', 0.0221, 'lps'),
	(621536, 131, '2014-04-01 01:06:47.000000', 'consum', 0.0225, 'lps'),
	(621537, 131, '2014-04-01 01:06:48.000000', 'consum', 0.0214, 'lps'),
	(621538, 131, '2014-04-01 01:06:49.000000', 'consum', 0.0225, 'lps'),
	(621539, 131, '2014-04-01 01:06:50.000000', 'consum', 0.0213, 'lps'),
	(621540, 131, '2014-04-01 01:06:51.000000', 'consum', 0.0222, 'lps'),
	(621541, 131, '2014-04-01 01:06:52.000000', 'consum', 0.0221, 'lps'),
	(621542, 131, '2014-04-01 01:06:53.000000', 'consum', 0.0210, 'lps'),
	(621543, 131, '2014-04-01 01:06:54.000000', 'consum', 0.0216, 'lps'),
	(621544, 131, '2014-04-01 01:06:55.000000', 'consum', 0.0221, 'lps'),
	(621545, 131, '2014-04-01 01:06:56.000000', 'consum', 0.0227, 'lps'),
	(621546, 131, '2014-04-01 01:06:57.000000', 'consum', 0.0224, 'lps'),
	(621547, 131, '2014-04-01 01:06:58.000000', 'consum', 0.0227, 'lps'),
	(621548, 131, '2014-04-01 01:06:59.000000', 'consum', 0.0216, 'lps'),
	(621549, 131, '2014-04-01 01:07:00.000000', 'consum', 0.0210, 'lps'),
	(621550, 131, '2014-04-01 01:07:01.000000', 'consum', 0.0210, 'lps'),
	(621551, 131, '2014-04-01 01:07:02.000000', 'consum', 0.0211, 'lps'),
	(621552, 131, '2014-04-01 01:07:03.000000', 'consum', 0.0215, 'lps'),
	(621553, 131, '2014-04-01 01:07:04.000000', 'consum', 0.0214, 'lps'),
	(621554, 131, '2014-04-01 01:07:05.000000', 'consum', 0.0214, 'lps'),
	(621555, 131, '2014-04-01 01:07:06.000000', 'consum', 0.0218, 'lps'),
	(621556, 131, '2014-04-01 01:07:07.000000', 'consum', 0.0217, 'lps'),
	(621557, 131, '2014-04-01 01:07:08.000000', 'consum', 0.0224, 'lps'),
	(621558, 131, '2014-04-01 01:07:09.000000', 'consum', 0.0218, 'lps'),
	(621559, 131, '2014-04-01 01:07:10.000000', 'consum', 0.0210, 'lps'),
	(621560, 131, '2014-04-01 01:07:11.000000', 'consum', 0.0228, 'lps'),
	(621561, 131, '2014-04-01 01:07:12.000000', 'consum', 0.0217, 'lps'),
	(621562, 131, '2014-04-01 01:07:13.000000', 'consum', 0.0214, 'lps'),
	(621563, 131, '2014-04-01 01:07:14.000000', 'consum', 0.0229, 'lps'),
	(621564, 131, '2014-04-01 01:07:15.000000', 'consum', 0.0214, 'lps'),
	(621565, 131, '2014-04-01 01:07:16.000000', 'consum', 0.0213, 'lps'),
	(621566, 131, '2014-04-01 01:07:17.000000', 'consum', 0.0213, 'lps'),
	(621567, 131, '2014-04-01 01:07:18.000000', 'consum', 0.0217, 'lps'),
	(621568, 131, '2014-04-01 01:07:19.000000', 'consum', 0.0218, 'lps'),
	(621569, 131, '2014-04-01 01:07:20.000000', 'consum', 0.0210, 'lps'),
	(621570, 131, '2014-04-01 01:07:21.000000', 'consum', 0.0224, 'lps'),
	(621571, 131, '2014-04-01 01:07:22.000000', 'consum', 0.0221, 'lps'),
	(621572, 131, '2014-04-01 01:07:23.000000', 'consum', 0.0225, 'lps'),
	(621573, 131, '2014-04-01 01:07:24.000000', 'consum', 0.0211, 'lps'),
	(621574, 131, '2014-04-01 01:07:25.000000', 'consum', 0.0212, 'lps'),
	(621575, 131, '2014-04-01 01:07:26.000000', 'consum', 0.0215, 'lps'),
	(621576, 131, '2014-04-01 01:07:27.000000', 'consum', 0.0213, 'lps'),
	(621577, 131, '2014-04-01 01:07:28.000000', 'consum', 0.0227, 'lps'),
	(621578, 131, '2014-04-01 01:07:29.000000', 'consum', 0.0227, 'lps'),
	(621579, 131, '2014-04-01 01:07:30.000000', 'consum', 0.0226, 'lps'),
	(621580, 131, '2014-04-01 01:07:31.000000', 'consum', 0.0219, 'lps'),
	(621581, 131, '2014-04-01 01:07:32.000000', 'consum', 0.0227, 'lps'),
	(621582, 131, '2014-04-01 01:07:33.000000', 'consum', 0.0211, 'lps'),
	(621583, 131, '2014-04-01 01:07:34.000000', 'consum', 0.0222, 'lps'),
	(621584, 131, '2014-04-01 01:07:35.000000', 'consum', 0.0229, 'lps'),
	(621585, 131, '2014-04-01 01:07:36.000000', 'consum', 0.0210, 'lps'),
	(621586, 131, '2014-04-01 01:07:37.000000', 'consum', 0.0211, 'lps'),
	(621587, 131, '2014-04-01 01:07:38.000000', 'consum', 0.0219, 'lps'),
	(621588, 131, '2014-04-01 01:07:39.000000', 'consum', 0.0229, 'lps'),
	(621589, 131, '2014-04-01 01:07:40.000000', 'consum', 0.0222, 'lps'),
	(621590, 131, '2014-04-01 01:07:41.000000', 'consum', 0.0212, 'lps'),
	(621591, 131, '2014-04-01 01:07:42.000000', 'consum', 0.0223, 'lps'),
	(621592, 131, '2014-04-01 01:07:43.000000', 'consum', 0.0229, 'lps'),
	(621593, 131, '2014-04-01 01:07:44.000000', 'consum', 0.0228, 'lps'),
	(621594, 131, '2014-04-01 01:07:45.000000', 'consum', 0.0224, 'lps'),
	(621595, 131, '2014-04-01 01:07:46.000000', 'consum', 0.0226, 'lps'),
	(621596, 131, '2014-04-01 01:07:47.000000', 'consum', 0.0228, 'lps'),
	(621597, 131, '2014-04-01 01:07:48.000000', 'consum', 0.0213, 'lps'),
	(621598, 131, '2014-04-01 01:07:49.000000', 'consum', 0.0211, 'lps'),
	(621599, 131, '2014-04-01 01:07:50.000000', 'consum', 0.0228, 'lps'),
	(621600, 131, '2014-04-01 01:07:51.000000', 'consum', 0.0215, 'lps'),
	(621601, 131, '2014-04-01 01:07:52.000000', 'consum', 0.0222, 'lps'),
	(621602, 131, '2014-04-01 01:07:53.000000', 'consum', 0.0218, 'lps'),
	(621603, 131, '2014-04-01 01:07:54.000000', 'consum', 0.0211, 'lps'),
	(621604, 131, '2014-04-01 01:07:55.000000', 'consum', 0.0214, 'lps'),
	(621605, 131, '2014-04-01 01:07:56.000000', 'consum', 0.0225, 'lps'),
	(621606, 131, '2014-04-01 01:07:57.000000', 'consum', 0.0216, 'lps'),
	(621607, 131, '2014-04-01 01:07:58.000000', 'consum', 0.0213, 'lps'),
	(621608, 131, '2014-04-01 01:07:59.000000', 'consum', 0.0228, 'lps'),
	(621609, 131, '2014-04-01 01:08:00.000000', 'consum', 0.0212, 'lps'),
	(621610, 131, '2014-04-01 01:08:01.000000', 'consum', 0.0227, 'lps'),
	(621611, 131, '2014-04-01 01:08:02.000000', 'consum', 0.0210, 'lps'),
	(621612, 131, '2014-04-01 01:08:03.000000', 'consum', 0.0217, 'lps'),
	(621613, 131, '2014-04-01 01:08:04.000000', 'consum', 0.0228, 'lps'),
	(621614, 131, '2014-04-01 01:08:05.000000', 'consum', 0.0219, 'lps'),
	(621615, 131, '2014-04-01 01:08:06.000000', 'consum', 0.0220, 'lps'),
	(621616, 131, '2014-04-01 01:08:07.000000', 'consum', 0.0213, 'lps'),
	(621617, 131, '2014-04-01 01:08:08.000000', 'consum', 0.0216, 'lps'),
	(621618, 131, '2014-04-01 01:08:09.000000', 'consum', 0.0211, 'lps'),
	(621619, 131, '2014-04-01 01:08:10.000000', 'consum', 0.0217, 'lps'),
	(621620, 131, '2014-04-01 01:08:11.000000', 'consum', 0.0222, 'lps'),
	(621621, 131, '2014-04-01 01:08:12.000000', 'consum', 0.0229, 'lps'),
	(621622, 131, '2014-04-01 01:08:13.000000', 'consum', 0.0212, 'lps'),
	(621623, 131, '2014-04-01 01:08:14.000000', 'consum', 0.0221, 'lps'),
	(621624, 131, '2014-04-01 01:08:15.000000', 'consum', 0.0222, 'lps'),
	(621625, 131, '2014-04-01 01:08:16.000000', 'consum', 0.0217, 'lps'),
	(621626, 131, '2014-04-01 01:08:17.000000', 'consum', 0.0210, 'lps'),
	(621627, 131, '2014-04-01 01:08:18.000000', 'consum', 0.0210, 'lps'),
	(621628, 131, '2014-04-01 01:08:19.000000', 'consum', 0.0212, 'lps'),
	(621629, 131, '2014-04-01 01:08:20.000000', 'consum', 0.0218, 'lps'),
	(621630, 131, '2014-04-01 01:08:21.000000', 'consum', 0.0225, 'lps'),
	(621631, 131, '2014-04-01 01:08:22.000000', 'consum', 0.0222, 'lps'),
	(621632, 131, '2014-04-01 01:08:23.000000', 'consum', 0.0223, 'lps'),
	(621633, 131, '2014-04-01 01:08:24.000000', 'consum', 0.0222, 'lps'),
	(621634, 131, '2014-04-01 01:08:25.000000', 'consum', 0.0212, 'lps'),
	(621635, 131, '2014-04-01 01:08:26.000000', 'consum', 0.0222, 'lps'),
	(621636, 131, '2014-04-01 01:08:27.000000', 'consum', 0.0226, 'lps'),
	(621637, 131, '2014-04-01 01:08:28.000000', 'consum', 0.0214, 'lps'),
	(621638, 131, '2014-04-01 01:08:29.000000', 'consum', 0.0224, 'lps'),
	(621639, 131, '2014-04-01 01:08:30.000000', 'consum', 0.0228, 'lps'),
	(621640, 131, '2014-04-01 01:08:31.000000', 'consum', 0.0218, 'lps'),
	(621641, 131, '2014-04-01 01:08:32.000000', 'consum', 0.0217, 'lps'),
	(621642, 131, '2014-04-01 01:08:33.000000', 'consum', 0.0222, 'lps'),
	(621643, 131, '2014-04-01 01:08:34.000000', 'consum', 0.0229, 'lps'),
	(621644, 131, '2014-04-01 01:08:35.000000', 'consum', 0.0210, 'lps'),
	(621645, 131, '2014-04-01 01:08:36.000000', 'consum', 0.0213, 'lps'),
	(621646, 131, '2014-04-01 01:08:37.000000', 'consum', 0.0226, 'lps'),
	(621647, 131, '2014-04-01 01:08:38.000000', 'consum', 0.0219, 'lps'),
	(621648, 131, '2014-04-01 01:08:39.000000', 'consum', 0.0210, 'lps'),
	(621649, 131, '2014-04-01 01:08:40.000000', 'consum', 0.0224, 'lps'),
	(621650, 131, '2014-04-01 01:08:41.000000', 'consum', 0.0220, 'lps'),
	(621651, 131, '2014-04-01 01:08:42.000000', 'consum', 0.0217, 'lps'),
	(621652, 131, '2014-04-01 01:08:43.000000', 'consum', 0.0217, 'lps'),
	(621653, 131, '2014-04-01 01:08:44.000000', 'consum', 0.0222, 'lps'),
	(621654, 131, '2014-04-01 01:08:45.000000', 'consum', 0.0211, 'lps'),
	(621655, 131, '2014-04-01 01:08:46.000000', 'consum', 0.0219, 'lps'),
	(621656, 131, '2014-04-01 01:08:47.000000', 'consum', 0.0213, 'lps'),
	(621657, 131, '2014-04-01 01:08:48.000000', 'consum', 0.0220, 'lps'),
	(621658, 131, '2014-04-01 01:08:49.000000', 'consum', 0.0229, 'lps'),
	(621659, 131, '2014-04-01 01:08:50.000000', 'consum', 0.0215, 'lps'),
	(621660, 131, '2014-04-01 01:08:51.000000', 'consum', 0.0219, 'lps'),
	(621661, 131, '2014-04-01 01:08:52.000000', 'consum', 0.0221, 'lps'),
	(621662, 131, '2014-04-01 01:08:53.000000', 'consum', 0.0217, 'lps'),
	(621663, 131, '2014-04-01 01:08:54.000000', 'consum', 0.0213, 'lps'),
	(621664, 131, '2014-04-01 01:08:55.000000', 'consum', 0.0227, 'lps'),
	(621665, 131, '2014-04-01 01:08:56.000000', 'consum', 0.0225, 'lps'),
	(621666, 131, '2014-04-01 01:08:57.000000', 'consum', 0.0213, 'lps'),
	(621667, 131, '2014-04-01 01:08:58.000000', 'consum', 0.0222, 'lps'),
	(621668, 131, '2014-04-01 01:08:59.000000', 'consum', 0.0223, 'lps'),
	(621669, 131, '2014-04-01 01:09:00.000000', 'consum', 0.0217, 'lps'),
	(621670, 131, '2014-04-01 01:09:01.000000', 'consum', 0.0227, 'lps'),
	(621671, 131, '2014-04-01 01:09:02.000000', 'consum', 0.0213, 'lps'),
	(621672, 131, '2014-04-01 01:09:03.000000', 'consum', 0.0216, 'lps'),
	(621673, 131, '2014-04-01 01:09:04.000000', 'consum', 0.0211, 'lps'),
	(621674, 131, '2014-04-01 01:09:05.000000', 'consum', 0.0217, 'lps'),
	(621675, 131, '2014-04-01 01:09:06.000000', 'consum', 0.0225, 'lps'),
	(621676, 131, '2014-04-01 01:09:07.000000', 'consum', 0.0221, 'lps'),
	(621677, 131, '2014-04-01 01:09:08.000000', 'consum', 0.0223, 'lps'),
	(621678, 131, '2014-04-01 01:09:09.000000', 'consum', 0.0220, 'lps'),
	(621679, 131, '2014-04-01 01:09:10.000000', 'consum', 0.0224, 'lps'),
	(621680, 131, '2014-04-01 01:09:11.000000', 'consum', 0.0210, 'lps'),
	(621681, 131, '2014-04-01 01:09:12.000000', 'consum', 0.0227, 'lps'),
	(621682, 131, '2014-04-01 01:09:13.000000', 'consum', 0.0217, 'lps'),
	(621683, 131, '2014-04-01 01:09:14.000000', 'consum', 0.0215, 'lps'),
	(621684, 131, '2014-04-01 01:09:15.000000', 'consum', 0.0213, 'lps'),
	(621685, 131, '2014-04-01 01:09:16.000000', 'consum', 0.0211, 'lps'),
	(621686, 131, '2014-04-01 01:09:17.000000', 'consum', 0.0224, 'lps'),
	(621687, 131, '2014-04-01 01:09:18.000000', 'consum', 0.0221, 'lps'),
	(621688, 131, '2014-04-01 01:09:19.000000', 'consum', 0.0223, 'lps'),
	(621689, 131, '2014-04-01 01:09:20.000000', 'consum', 0.0224, 'lps'),
	(621690, 131, '2014-04-01 01:09:21.000000', 'consum', 0.0218, 'lps'),
	(621691, 131, '2014-04-01 01:09:22.000000', 'consum', 0.0211, 'lps'),
	(621692, 131, '2014-04-01 01:09:23.000000', 'consum', 0.0211, 'lps'),
	(621693, 131, '2014-04-01 01:09:24.000000', 'consum', 0.0212, 'lps'),
	(621694, 131, '2014-04-01 01:09:25.000000', 'consum', 0.0220, 'lps'),
	(621695, 131, '2014-04-01 01:09:26.000000', 'consum', 0.0212, 'lps'),
	(621696, 131, '2014-04-01 01:09:27.000000', 'consum', 0.0211, 'lps'),
	(621697, 131, '2014-04-01 01:09:28.000000', 'consum', 0.0210, 'lps'),
	(621698, 131, '2014-04-01 01:09:29.000000', 'consum', 0.0226, 'lps'),
	(621699, 131, '2014-04-01 01:09:30.000000', 'consum', 0.0213, 'lps'),
	(621700, 131, '2014-04-01 01:09:31.000000', 'consum', 0.0218, 'lps'),
	(621701, 131, '2014-04-01 01:09:32.000000', 'consum', 0.0220, 'lps'),
	(621702, 131, '2014-04-01 01:09:33.000000', 'consum', 0.0217, 'lps'),
	(621703, 131, '2014-04-01 01:09:34.000000', 'consum', 0.0214, 'lps'),
	(621704, 131, '2014-04-01 01:09:35.000000', 'consum', 0.0211, 'lps'),
	(621705, 131, '2014-04-01 01:09:36.000000', 'consum', 0.0224, 'lps'),
	(621706, 131, '2014-04-01 01:09:37.000000', 'consum', 0.0216, 'lps'),
	(621707, 131, '2014-04-01 01:09:38.000000', 'consum', 0.0220, 'lps'),
	(621708, 131, '2014-04-01 01:09:39.000000', 'consum', 0.0222, 'lps'),
	(621709, 131, '2014-04-01 01:09:40.000000', 'consum', 0.0220, 'lps'),
	(621710, 131, '2014-04-01 01:09:41.000000', 'consum', 0.0224, 'lps'),
	(621711, 131, '2014-04-01 01:09:42.000000', 'consum', 0.0212, 'lps'),
	(621712, 131, '2014-04-01 01:09:43.000000', 'consum', 0.0220, 'lps'),
	(621713, 131, '2014-04-01 01:09:44.000000', 'consum', 0.0212, 'lps'),
	(621714, 131, '2014-04-01 01:09:45.000000', 'consum', 0.0212, 'lps'),
	(621715, 131, '2014-04-01 01:09:46.000000', 'consum', 0.0212, 'lps'),
	(621716, 131, '2014-04-01 01:09:47.000000', 'consum', 0.0215, 'lps'),
	(621717, 131, '2014-04-01 01:09:48.000000', 'consum', 0.0212, 'lps'),
	(621718, 131, '2014-04-01 01:09:49.000000', 'consum', 0.0224, 'lps'),
	(621719, 131, '2014-04-01 01:09:50.000000', 'consum', 0.0216, 'lps'),
	(621720, 131, '2014-04-01 01:09:51.000000', 'consum', 0.0216, 'lps'),
	(621721, 131, '2014-04-01 01:09:52.000000', 'consum', 0.0226, 'lps'),
	(621722, 131, '2014-04-01 01:09:53.000000', 'consum', 0.0229, 'lps'),
	(621723, 131, '2014-04-01 01:09:54.000000', 'consum', 0.0220, 'lps'),
	(621724, 131, '2014-04-01 01:09:55.000000', 'consum', 0.0222, 'lps'),
	(621725, 131, '2014-04-01 01:09:56.000000', 'consum', 0.0220, 'lps'),
	(621726, 131, '2014-04-01 01:09:57.000000', 'consum', 0.0226, 'lps'),
	(621727, 131, '2014-04-01 01:09:58.000000', 'consum', 0.0218, 'lps'),
	(621728, 131, '2014-04-01 01:09:59.000000', 'consum', 0.0225, 'lps'),
	(621729, 131, '2014-04-01 01:10:00.000000', 'consum', 0.0221, 'lps'),
	(621730, 131, '2014-04-01 01:10:01.000000', 'consum', 0.0220, 'lps'),
	(621731, 131, '2014-04-01 01:10:02.000000', 'consum', 0.0228, 'lps'),
	(621732, 131, '2014-04-01 01:10:03.000000', 'consum', 0.0211, 'lps'),
	(621733, 131, '2014-04-01 01:10:04.000000', 'consum', 0.0219, 'lps'),
	(621734, 131, '2014-04-01 01:10:05.000000', 'consum', 0.0216, 'lps'),
	(621735, 131, '2014-04-01 01:10:06.000000', 'consum', 0.0210, 'lps'),
	(621736, 131, '2014-04-01 01:10:07.000000', 'consum', 0.0215, 'lps'),
	(621737, 131, '2014-04-01 01:10:08.000000', 'consum', 0.0214, 'lps'),
	(621738, 131, '2014-04-01 01:10:09.000000', 'consum', 0.0214, 'lps'),
	(621739, 131, '2014-04-01 01:10:10.000000', 'consum', 0.0221, 'lps'),
	(621740, 131, '2014-04-01 01:10:11.000000', 'consum', 0.0213, 'lps'),
	(621741, 131, '2014-04-01 01:10:12.000000', 'consum', 0.0212, 'lps'),
	(621742, 131, '2014-04-01 01:10:13.000000', 'consum', 0.0213, 'lps'),
	(621743, 131, '2014-04-01 01:10:14.000000', 'consum', 0.0220, 'lps'),
	(621744, 131, '2014-04-01 01:10:15.000000', 'consum', 0.0211, 'lps'),
	(621745, 131, '2014-04-01 01:10:16.000000', 'consum', 0.0224, 'lps'),
	(621746, 131, '2014-04-01 01:10:17.000000', 'consum', 0.0219, 'lps'),
	(621747, 131, '2014-04-01 01:10:18.000000', 'consum', 0.0213, 'lps'),
	(621748, 131, '2014-04-01 01:10:19.000000', 'consum', 0.0219, 'lps'),
	(621749, 131, '2014-04-01 01:10:20.000000', 'consum', 0.0227, 'lps'),
	(621750, 131, '2014-04-01 01:10:21.000000', 'consum', 0.0228, 'lps'),
	(621751, 131, '2014-04-01 01:10:22.000000', 'consum', 0.0229, 'lps'),
	(621752, 131, '2014-04-01 01:10:23.000000', 'consum', 0.0213, 'lps'),
	(621753, 131, '2014-04-01 01:10:24.000000', 'consum', 0.0228, 'lps'),
	(621754, 131, '2014-04-01 01:10:25.000000', 'consum', 0.0213, 'lps'),
	(621755, 131, '2014-04-01 01:10:26.000000', 'consum', 0.0211, 'lps'),
	(621756, 131, '2014-04-01 01:10:27.000000', 'consum', 0.0227, 'lps'),
	(621757, 131, '2014-04-01 01:10:28.000000', 'consum', 0.0212, 'lps'),
	(621758, 131, '2014-04-01 01:10:29.000000', 'consum', 0.0211, 'lps'),
	(621759, 131, '2014-04-01 01:10:30.000000', 'consum', 0.0227, 'lps'),
	(621760, 131, '2014-04-01 01:10:31.000000', 'consum', 0.0212, 'lps'),
	(621761, 131, '2014-04-01 01:10:32.000000', 'consum', 0.0210, 'lps'),
	(621762, 131, '2014-04-01 01:10:33.000000', 'consum', 0.0224, 'lps'),
	(621763, 131, '2014-04-01 01:10:34.000000', 'consum', 0.0221, 'lps'),
	(621764, 131, '2014-04-01 01:10:35.000000', 'consum', 0.0225, 'lps'),
	(621765, 131, '2014-04-01 01:10:36.000000', 'consum', 0.0212, 'lps'),
	(621766, 131, '2014-04-01 01:10:37.000000', 'consum', 0.0215, 'lps'),
	(621767, 131, '2014-04-01 01:10:38.000000', 'consum', 0.0229, 'lps'),
	(621768, 131, '2014-04-01 01:10:39.000000', 'consum', 0.0212, 'lps'),
	(621769, 131, '2014-04-01 01:10:40.000000', 'consum', 0.0221, 'lps'),
	(621770, 131, '2014-04-01 01:10:41.000000', 'consum', 0.0222, 'lps'),
	(621771, 131, '2014-04-01 01:10:42.000000', 'consum', 0.0218, 'lps'),
	(621772, 131, '2014-04-01 01:10:43.000000', 'consum', 0.0211, 'lps'),
	(621773, 131, '2014-04-01 01:10:44.000000', 'consum', 0.0215, 'lps'),
	(621774, 131, '2014-04-01 01:10:45.000000', 'consum', 0.0211, 'lps'),
	(621775, 131, '2014-04-01 01:10:46.000000', 'consum', 0.0222, 'lps'),
	(621776, 131, '2014-04-01 01:10:47.000000', 'consum', 0.0227, 'lps'),
	(621777, 131, '2014-04-01 01:10:48.000000', 'consum', 0.0221, 'lps'),
	(621778, 131, '2014-04-01 01:10:49.000000', 'consum', 0.0211, 'lps'),
	(621779, 131, '2014-04-01 01:10:50.000000', 'consum', 0.0226, 'lps'),
	(621780, 131, '2014-04-01 01:10:51.000000', 'consum', 0.0225, 'lps'),
	(621781, 131, '2014-04-01 01:10:52.000000', 'consum', 0.0220, 'lps'),
	(621782, 131, '2014-04-01 01:10:53.000000', 'consum', 0.0216, 'lps'),
	(621783, 131, '2014-04-01 01:10:54.000000', 'consum', 0.0228, 'lps'),
	(621784, 131, '2014-04-01 01:10:55.000000', 'consum', 0.0223, 'lps'),
	(621785, 131, '2014-04-01 01:10:56.000000', 'consum', 0.0223, 'lps'),
	(621786, 131, '2014-04-01 01:10:57.000000', 'consum', 0.0217, 'lps'),
	(621787, 131, '2014-04-01 01:10:58.000000', 'consum', 0.0225, 'lps'),
	(621788, 131, '2014-04-01 01:10:59.000000', 'consum', 0.0223, 'lps'),
	(621789, 131, '2014-04-01 01:11:00.000000', 'consum', 0.0213, 'lps'),
	(621790, 131, '2014-04-01 01:11:01.000000', 'consum', 0.0225, 'lps'),
	(621791, 131, '2014-04-01 01:11:02.000000', 'consum', 0.0215, 'lps'),
	(621792, 131, '2014-04-01 01:11:03.000000', 'consum', 0.0214, 'lps'),
	(621793, 131, '2014-04-01 01:11:04.000000', 'consum', 0.0214, 'lps'),
	(621794, 131, '2014-04-01 01:11:05.000000', 'consum', 0.0218, 'lps'),
	(621795, 131, '2014-04-01 01:11:06.000000', 'consum', 0.0220, 'lps'),
	(621796, 131, '2014-04-01 01:11:07.000000', 'consum', 0.0214, 'lps'),
	(621797, 131, '2014-04-01 01:11:08.000000', 'consum', 0.0224, 'lps'),
	(621798, 131, '2014-04-01 01:11:09.000000', 'consum', 0.0225, 'lps'),
	(621799, 131, '2014-04-01 01:11:10.000000', 'consum', 0.0225, 'lps'),
	(621800, 131, '2014-04-01 01:11:11.000000', 'consum', 0.0220, 'lps'),
	(621801, 131, '2014-04-01 01:11:12.000000', 'consum', 0.0217, 'lps'),
	(621802, 131, '2014-04-01 01:11:13.000000', 'consum', 0.0213, 'lps'),
	(621803, 131, '2014-04-01 01:11:14.000000', 'consum', 0.0225, 'lps'),
	(621804, 131, '2014-04-01 01:11:15.000000', 'consum', 0.0216, 'lps'),
	(621805, 131, '2014-04-01 01:11:16.000000', 'consum', 0.0217, 'lps'),
	(621806, 131, '2014-04-01 01:11:17.000000', 'consum', 0.0229, 'lps'),
	(621807, 131, '2014-04-01 01:11:18.000000', 'consum', 0.0221, 'lps'),
	(621808, 131, '2014-04-01 01:11:19.000000', 'consum', 0.0211, 'lps'),
	(621809, 131, '2014-04-01 01:11:20.000000', 'consum', 0.0224, 'lps'),
	(621810, 131, '2014-04-01 01:11:21.000000', 'consum', 0.0214, 'lps'),
	(621811, 131, '2014-04-01 01:11:22.000000', 'consum', 0.0210, 'lps'),
	(621812, 131, '2014-04-01 01:11:23.000000', 'consum', 0.0217, 'lps'),
	(621813, 131, '2014-04-01 01:11:24.000000', 'consum', 0.0227, 'lps'),
	(621814, 131, '2014-04-01 01:11:25.000000', 'consum', 0.0215, 'lps'),
	(621815, 131, '2014-04-01 01:11:26.000000', 'consum', 0.0222, 'lps'),
	(621816, 131, '2014-04-01 01:11:27.000000', 'consum', 0.0218, 'lps'),
	(621817, 131, '2014-04-01 01:11:28.000000', 'consum', 0.0212, 'lps'),
	(621818, 131, '2014-04-01 01:11:29.000000', 'consum', 0.0217, 'lps'),
	(621819, 131, '2014-04-01 01:11:30.000000', 'consum', 0.0219, 'lps'),
	(621820, 131, '2014-04-01 01:11:31.000000', 'consum', 0.0217, 'lps'),
	(621821, 131, '2014-04-01 01:11:32.000000', 'consum', 0.0216, 'lps'),
	(621822, 131, '2014-04-01 01:11:33.000000', 'consum', 0.0221, 'lps'),
	(621823, 131, '2014-04-01 01:11:34.000000', 'consum', 0.0229, 'lps'),
	(621824, 131, '2014-04-01 01:11:35.000000', 'consum', 0.0211, 'lps'),
	(621825, 131, '2014-04-01 01:11:36.000000', 'consum', 0.0217, 'lps'),
	(621826, 131, '2014-04-01 01:11:37.000000', 'consum', 0.0222, 'lps'),
	(621827, 131, '2014-04-01 01:11:38.000000', 'consum', 0.0210, 'lps'),
	(621828, 131, '2014-04-01 01:11:39.000000', 'consum', 0.0215, 'lps'),
	(621829, 131, '2014-04-01 01:11:40.000000', 'consum', 0.0215, 'lps'),
	(621830, 131, '2014-04-01 01:11:41.000000', 'consum', 0.0220, 'lps'),
	(621831, 131, '2014-04-01 01:11:42.000000', 'consum', 0.0225, 'lps'),
	(621832, 131, '2014-04-01 01:11:43.000000', 'consum', 0.0218, 'lps'),
	(621833, 131, '2014-04-01 01:11:44.000000', 'consum', 0.0225, 'lps'),
	(621834, 131, '2014-04-01 01:11:45.000000', 'consum', 0.0219, 'lps'),
	(621835, 131, '2014-04-01 01:11:46.000000', 'consum', 0.0212, 'lps'),
	(621836, 131, '2014-04-01 01:11:47.000000', 'consum', 0.0214, 'lps'),
	(621837, 131, '2014-04-01 01:11:48.000000', 'consum', 0.0223, 'lps'),
	(621838, 131, '2014-04-01 01:11:49.000000', 'consum', 0.0226, 'lps'),
	(621839, 131, '2014-04-01 01:11:50.000000', 'consum', 0.0228, 'lps'),
	(621840, 131, '2014-04-01 01:11:51.000000', 'consum', 0.0215, 'lps'),
	(621841, 131, '2014-04-01 01:11:52.000000', 'consum', 0.0223, 'lps'),
	(621842, 131, '2014-04-01 01:11:53.000000', 'consum', 0.0218, 'lps'),
	(621843, 131, '2014-04-01 01:11:54.000000', 'consum', 0.0214, 'lps'),
	(621844, 131, '2014-04-01 01:11:55.000000', 'consum', 0.0225, 'lps'),
	(621845, 131, '2014-04-01 01:11:56.000000', 'consum', 0.0215, 'lps'),
	(621846, 131, '2014-04-01 01:11:57.000000', 'consum', 0.0227, 'lps'),
	(621847, 131, '2014-04-01 01:11:58.000000', 'consum', 0.0224, 'lps'),
	(621848, 131, '2014-04-01 01:11:59.000000', 'consum', 0.0229, 'lps'),
	(621849, 131, '2014-04-01 01:12:00.000000', 'consum', 0.0225, 'lps'),
	(621850, 131, '2014-04-01 01:12:01.000000', 'consum', 0.0226, 'lps'),
	(621851, 131, '2014-04-01 01:12:02.000000', 'consum', 0.0225, 'lps'),
	(621852, 131, '2014-04-01 01:12:03.000000', 'consum', 0.0219, 'lps'),
	(621853, 131, '2014-04-01 01:12:04.000000', 'consum', 0.0228, 'lps'),
	(621854, 131, '2014-04-01 01:12:05.000000', 'consum', 0.0216, 'lps'),
	(621855, 131, '2014-04-01 01:12:06.000000', 'consum', 0.0224, 'lps'),
	(621856, 131, '2014-04-01 01:12:07.000000', 'consum', 0.0224, 'lps'),
	(621857, 131, '2014-04-01 01:12:08.000000', 'consum', 0.0220, 'lps'),
	(621858, 131, '2014-04-01 01:12:09.000000', 'consum', 0.0217, 'lps'),
	(621859, 131, '2014-04-01 01:12:10.000000', 'consum', 0.0216, 'lps'),
	(621860, 131, '2014-04-01 01:12:11.000000', 'consum', 0.0221, 'lps'),
	(621861, 131, '2014-04-01 01:12:12.000000', 'consum', 0.0227, 'lps'),
	(621862, 131, '2014-04-01 01:12:13.000000', 'consum', 0.0223, 'lps'),
	(621863, 131, '2014-04-01 01:12:14.000000', 'consum', 0.0223, 'lps'),
	(621864, 131, '2014-04-01 01:12:15.000000', 'consum', 0.0215, 'lps'),
	(621865, 131, '2014-04-01 01:12:16.000000', 'consum', 0.0218, 'lps'),
	(621866, 131, '2014-04-01 01:12:17.000000', 'consum', 0.0216, 'lps'),
	(621867, 131, '2014-04-01 01:12:18.000000', 'consum', 0.0218, 'lps'),
	(621868, 131, '2014-04-01 01:12:19.000000', 'consum', 0.0229, 'lps'),
	(621869, 131, '2014-04-01 01:12:20.000000', 'consum', 0.0223, 'lps'),
	(621870, 131, '2014-04-01 01:12:21.000000', 'consum', 0.0221, 'lps'),
	(621871, 131, '2014-04-01 01:12:22.000000', 'consum', 0.0223, 'lps'),
	(621872, 131, '2014-04-01 01:12:23.000000', 'consum', 0.0225, 'lps'),
	(621873, 131, '2014-04-01 01:12:24.000000', 'consum', 0.0226, 'lps'),
	(621874, 131, '2014-04-01 01:12:25.000000', 'consum', 0.0225, 'lps'),
	(621875, 131, '2014-04-01 01:12:26.000000', 'consum', 0.0218, 'lps'),
	(621876, 131, '2014-04-01 01:12:27.000000', 'consum', 0.0227, 'lps'),
	(621877, 131, '2014-04-01 01:12:28.000000', 'consum', 0.0229, 'lps'),
	(621878, 131, '2014-04-01 01:12:29.000000', 'consum', 0.0215, 'lps'),
	(621879, 131, '2014-04-01 01:12:30.000000', 'consum', 0.0220, 'lps'),
	(621880, 131, '2014-04-01 01:12:31.000000', 'consum', 0.0225, 'lps'),
	(621881, 131, '2014-04-01 01:12:32.000000', 'consum', 0.0214, 'lps'),
	(621882, 131, '2014-04-01 01:12:33.000000', 'consum', 0.0227, 'lps'),
	(621883, 131, '2014-04-01 01:12:34.000000', 'consum', 0.0224, 'lps'),
	(621884, 131, '2014-04-01 01:12:35.000000', 'consum', 0.0228, 'lps'),
	(621885, 131, '2014-04-01 01:12:36.000000', 'consum', 0.0218, 'lps'),
	(621886, 131, '2014-04-01 01:12:37.000000', 'consum', 0.0218, 'lps'),
	(621887, 131, '2014-04-01 01:12:38.000000', 'consum', 0.0225, 'lps'),
	(621888, 131, '2014-04-01 01:12:39.000000', 'consum', 0.0223, 'lps'),
	(621889, 131, '2014-04-01 01:12:40.000000', 'consum', 0.0211, 'lps'),
	(621890, 131, '2014-04-01 01:12:41.000000', 'consum', 0.0215, 'lps'),
	(621891, 131, '2014-04-01 01:12:42.000000', 'consum', 0.0213, 'lps'),
	(621892, 131, '2014-04-01 01:12:43.000000', 'consum', 0.0211, 'lps'),
	(621893, 131, '2014-04-01 01:12:44.000000', 'consum', 0.0228, 'lps'),
	(621894, 131, '2014-04-01 01:12:45.000000', 'consum', 0.0217, 'lps'),
	(621895, 131, '2014-04-01 01:12:46.000000', 'consum', 0.0210, 'lps'),
	(621896, 131, '2014-04-01 01:12:47.000000', 'consum', 0.0211, 'lps'),
	(621897, 131, '2014-04-01 01:12:48.000000', 'consum', 0.0213, 'lps'),
	(621898, 131, '2014-04-01 01:12:49.000000', 'consum', 0.0223, 'lps'),
	(621899, 131, '2014-04-01 01:12:50.000000', 'consum', 0.0228, 'lps'),
	(621900, 131, '2014-04-01 01:12:51.000000', 'consum', 0.0219, 'lps'),
	(621901, 131, '2014-04-01 01:12:52.000000', 'consum', 0.0223, 'lps'),
	(621902, 131, '2014-04-01 01:12:53.000000', 'consum', 0.0228, 'lps'),
	(621903, 131, '2014-04-01 01:12:54.000000', 'consum', 0.0223, 'lps'),
	(621904, 131, '2014-04-01 01:12:55.000000', 'consum', 0.0221, 'lps'),
	(621905, 131, '2014-04-01 01:12:56.000000', 'consum', 0.0225, 'lps'),
	(621906, 131, '2014-04-01 01:12:57.000000', 'consum', 0.0214, 'lps'),
	(621907, 131, '2014-04-01 01:12:58.000000', 'consum', 0.0223, 'lps'),
	(621908, 131, '2014-04-01 01:12:59.000000', 'consum', 0.0226, 'lps'),
	(621909, 131, '2014-04-01 01:13:00.000000', 'consum', 0.0211, 'lps'),
	(621910, 131, '2014-04-01 01:13:01.000000', 'consum', 0.0225, 'lps'),
	(621911, 131, '2014-04-01 01:13:02.000000', 'consum', 0.0225, 'lps'),
	(621912, 131, '2014-04-01 01:13:03.000000', 'consum', 0.0221, 'lps'),
	(621913, 131, '2014-04-01 01:13:04.000000', 'consum', 0.0221, 'lps'),
	(621914, 131, '2014-04-01 01:13:05.000000', 'consum', 0.0212, 'lps'),
	(621915, 131, '2014-04-01 01:13:06.000000', 'consum', 0.0226, 'lps'),
	(621916, 131, '2014-04-01 01:13:07.000000', 'consum', 0.0224, 'lps'),
	(621917, 131, '2014-04-01 01:13:08.000000', 'consum', 0.0214, 'lps'),
	(621918, 131, '2014-04-01 01:13:09.000000', 'consum', 0.0227, 'lps'),
	(621919, 131, '2014-04-01 01:13:10.000000', 'consum', 0.0225, 'lps'),
	(621920, 131, '2014-04-01 01:13:11.000000', 'consum', 0.0214, 'lps'),
	(621921, 131, '2014-04-01 01:13:12.000000', 'consum', 0.0227, 'lps'),
	(621922, 131, '2014-04-01 01:13:13.000000', 'consum', 0.0222, 'lps'),
	(621923, 131, '2014-04-01 01:13:14.000000', 'consum', 0.0220, 'lps'),
	(621924, 131, '2014-04-01 01:13:15.000000', 'consum', 0.0223, 'lps'),
	(621925, 131, '2014-04-01 01:13:16.000000', 'consum', 0.0226, 'lps'),
	(621926, 131, '2014-04-01 01:13:17.000000', 'consum', 0.0210, 'lps'),
	(621927, 131, '2014-04-01 01:13:18.000000', 'consum', 0.0223, 'lps'),
	(621928, 131, '2014-04-01 01:13:19.000000', 'consum', 0.0214, 'lps'),
	(621929, 131, '2014-04-01 01:13:20.000000', 'consum', 0.0213, 'lps'),
	(621930, 131, '2014-04-01 01:13:21.000000', 'consum', 0.0213, 'lps'),
	(621931, 131, '2014-04-01 01:13:22.000000', 'consum', 0.0218, 'lps'),
	(621932, 131, '2014-04-01 01:13:23.000000', 'consum', 0.0222, 'lps'),
	(621933, 131, '2014-04-01 01:13:24.000000', 'consum', 0.0227, 'lps'),
	(621934, 131, '2014-04-01 01:13:25.000000', 'consum', 0.0219, 'lps'),
	(621935, 131, '2014-04-01 01:13:26.000000', 'consum', 0.0225, 'lps'),
	(621936, 131, '2014-04-01 01:13:27.000000', 'consum', 0.0219, 'lps'),
	(621937, 131, '2014-04-01 01:13:28.000000', 'consum', 0.0211, 'lps'),
	(621938, 131, '2014-04-01 01:13:29.000000', 'consum', 0.0210, 'lps'),
	(621939, 131, '2014-04-01 01:13:30.000000', 'consum', 0.0225, 'lps'),
	(621940, 131, '2014-04-01 01:13:31.000000', 'consum', 0.0224, 'lps'),
	(621941, 131, '2014-04-01 01:13:32.000000', 'consum', 0.0217, 'lps'),
	(621942, 131, '2014-04-01 01:13:33.000000', 'consum', 0.0222, 'lps'),
	(621943, 131, '2014-04-01 01:13:34.000000', 'consum', 0.0212, 'lps'),
	(621944, 131, '2014-04-01 01:13:35.000000', 'consum', 0.0222, 'lps'),
	(621945, 131, '2014-04-01 01:13:36.000000', 'consum', 0.0227, 'lps'),
	(621946, 131, '2014-04-01 01:13:37.000000', 'consum', 0.0218, 'lps'),
	(621947, 131, '2014-04-01 01:13:38.000000', 'consum', 0.0218, 'lps'),
	(621948, 131, '2014-04-01 01:13:39.000000', 'consum', 0.0228, 'lps'),
	(621949, 131, '2014-04-01 01:13:40.000000', 'consum', 0.0218, 'lps'),
	(621950, 131, '2014-04-01 01:13:41.000000', 'consum', 0.0216, 'lps'),
	(621951, 131, '2014-04-01 01:13:42.000000', 'consum', 0.0218, 'lps'),
	(621952, 131, '2014-04-01 01:13:43.000000', 'consum', 0.0210, 'lps'),
	(621953, 131, '2014-04-01 01:13:44.000000', 'consum', 0.0229, 'lps'),
	(621954, 131, '2014-04-01 01:13:45.000000', 'consum', 0.0226, 'lps'),
	(621955, 131, '2014-04-01 01:13:46.000000', 'consum', 0.0213, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(621956, 131, '2014-04-01 01:13:47.000000', 'consum', 0.0218, 'lps'),
	(621957, 131, '2014-04-01 01:13:48.000000', 'consum', 0.0220, 'lps'),
	(621958, 131, '2014-04-01 01:13:49.000000', 'consum', 0.0216, 'lps'),
	(621959, 131, '2014-04-01 01:13:50.000000', 'consum', 0.0211, 'lps'),
	(621960, 131, '2014-04-01 01:13:51.000000', 'consum', 0.0220, 'lps'),
	(621961, 131, '2014-04-01 01:13:52.000000', 'consum', 0.0214, 'lps'),
	(621962, 131, '2014-04-01 01:13:53.000000', 'consum', 0.0223, 'lps'),
	(621963, 131, '2014-04-01 01:13:54.000000', 'consum', 0.0223, 'lps'),
	(621964, 131, '2014-04-01 01:13:55.000000', 'consum', 0.0217, 'lps'),
	(621965, 131, '2014-04-01 01:13:56.000000', 'consum', 0.0226, 'lps'),
	(621966, 131, '2014-04-01 01:13:57.000000', 'consum', 0.0227, 'lps'),
	(621967, 131, '2014-04-01 01:13:58.000000', 'consum', 0.0211, 'lps'),
	(621968, 131, '2014-04-01 01:13:59.000000', 'consum', 0.0224, 'lps'),
	(621969, 131, '2014-04-01 01:14:00.000000', 'consum', 0.0218, 'lps'),
	(621970, 131, '2014-04-01 01:14:01.000000', 'consum', 0.0227, 'lps'),
	(621971, 131, '2014-04-01 01:14:02.000000', 'consum', 0.0211, 'lps'),
	(621972, 131, '2014-04-01 01:14:03.000000', 'consum', 0.0224, 'lps'),
	(621973, 131, '2014-04-01 01:14:04.000000', 'consum', 0.0218, 'lps'),
	(621974, 131, '2014-04-01 01:14:05.000000', 'consum', 0.0210, 'lps'),
	(621975, 131, '2014-04-01 01:14:06.000000', 'consum', 0.0227, 'lps'),
	(621976, 131, '2014-04-01 01:14:07.000000', 'consum', 0.0213, 'lps'),
	(621977, 131, '2014-04-01 01:14:08.000000', 'consum', 0.0215, 'lps'),
	(621978, 131, '2014-04-01 01:14:09.000000', 'consum', 0.0225, 'lps'),
	(621979, 131, '2014-04-01 01:14:10.000000', 'consum', 0.0213, 'lps'),
	(621980, 131, '2014-04-01 01:14:11.000000', 'consum', 0.0220, 'lps'),
	(621981, 131, '2014-04-01 01:14:12.000000', 'consum', 0.0229, 'lps'),
	(621982, 131, '2014-04-01 01:14:13.000000', 'consum', 0.0219, 'lps'),
	(621983, 131, '2014-04-01 01:14:14.000000', 'consum', 0.0218, 'lps'),
	(621984, 131, '2014-04-01 01:14:15.000000', 'consum', 0.0222, 'lps'),
	(621985, 131, '2014-04-01 01:14:16.000000', 'consum', 0.0229, 'lps'),
	(621986, 131, '2014-04-01 01:14:17.000000', 'consum', 0.0228, 'lps'),
	(621987, 131, '2014-04-01 01:14:18.000000', 'consum', 0.0223, 'lps'),
	(621988, 131, '2014-04-01 01:14:19.000000', 'consum', 0.0222, 'lps'),
	(621989, 131, '2014-04-01 01:14:20.000000', 'consum', 0.0210, 'lps'),
	(621990, 131, '2014-04-01 01:14:21.000000', 'consum', 0.0214, 'lps'),
	(621991, 131, '2014-04-01 01:14:22.000000', 'consum', 0.0210, 'lps'),
	(621992, 131, '2014-04-01 01:14:23.000000', 'consum', 0.0219, 'lps'),
	(621993, 131, '2014-04-01 01:14:24.000000', 'consum', 0.0215, 'lps'),
	(621994, 131, '2014-04-01 01:14:25.000000', 'consum', 0.0229, 'lps'),
	(621995, 131, '2014-04-01 01:14:26.000000', 'consum', 0.0211, 'lps'),
	(621996, 131, '2014-04-01 01:14:27.000000', 'consum', 0.0216, 'lps'),
	(621997, 131, '2014-04-01 01:14:28.000000', 'consum', 0.0220, 'lps'),
	(621998, 131, '2014-04-01 01:14:29.000000', 'consum', 0.0223, 'lps'),
	(621999, 131, '2014-04-01 01:14:30.000000', 'consum', 0.0224, 'lps'),
	(622000, 131, '2014-04-01 01:14:31.000000', 'consum', 0.0220, 'lps'),
	(622001, 131, '2014-04-01 01:14:32.000000', 'consum', 0.0222, 'lps'),
	(622002, 131, '2014-04-01 01:14:33.000000', 'consum', 0.0219, 'lps'),
	(622003, 131, '2014-04-01 01:14:34.000000', 'consum', 0.0220, 'lps'),
	(622004, 131, '2014-04-01 01:14:35.000000', 'consum', 0.0212, 'lps'),
	(622005, 131, '2014-04-01 01:14:36.000000', 'consum', 0.0210, 'lps'),
	(622006, 131, '2014-04-01 01:14:37.000000', 'consum', 0.0224, 'lps'),
	(622007, 131, '2014-04-01 01:14:38.000000', 'consum', 0.0221, 'lps'),
	(622008, 131, '2014-04-01 01:14:39.000000', 'consum', 0.0224, 'lps'),
	(622009, 131, '2014-04-01 01:14:40.000000', 'consum', 0.0227, 'lps'),
	(622010, 131, '2014-04-01 01:14:41.000000', 'consum', 0.0214, 'lps'),
	(622011, 131, '2014-04-01 01:14:42.000000', 'consum', 0.0218, 'lps'),
	(622012, 131, '2014-04-01 01:14:43.000000', 'consum', 0.0217, 'lps'),
	(622013, 131, '2014-04-01 01:14:44.000000', 'consum', 0.0225, 'lps'),
	(622014, 131, '2014-04-01 01:14:45.000000', 'consum', 0.0223, 'lps'),
	(622015, 131, '2014-04-01 01:14:46.000000', 'consum', 0.0210, 'lps'),
	(622016, 131, '2014-04-01 01:14:47.000000', 'consum', 0.0212, 'lps'),
	(622017, 131, '2014-04-01 01:14:48.000000', 'consum', 0.0221, 'lps'),
	(622018, 131, '2014-04-01 01:14:49.000000', 'consum', 0.0220, 'lps'),
	(622019, 131, '2014-04-01 01:14:50.000000', 'consum', 0.0226, 'lps'),
	(622020, 131, '2014-04-01 01:14:51.000000', 'consum', 0.0220, 'lps'),
	(622021, 131, '2014-04-01 01:14:52.000000', 'consum', 0.0213, 'lps'),
	(622022, 131, '2014-04-01 01:14:53.000000', 'consum', 0.0218, 'lps'),
	(622023, 131, '2014-04-01 01:14:54.000000', 'consum', 0.0219, 'lps'),
	(622024, 131, '2014-04-01 01:14:55.000000', 'consum', 0.0212, 'lps'),
	(622025, 131, '2014-04-01 01:14:56.000000', 'consum', 0.0213, 'lps'),
	(622026, 131, '2014-04-01 01:14:57.000000', 'consum', 0.0219, 'lps'),
	(622027, 131, '2014-04-01 01:14:58.000000', 'consum', 0.0227, 'lps'),
	(622028, 131, '2014-04-01 01:14:59.000000', 'consum', 0.0228, 'lps'),
	(622029, 131, '2014-04-01 01:15:00.000000', 'consum', 0.0211, 'lps'),
	(622030, 131, '2014-04-01 01:15:01.000000', 'consum', 0.0220, 'lps'),
	(622031, 131, '2014-04-01 01:15:02.000000', 'consum', 0.0217, 'lps'),
	(622032, 131, '2014-04-01 01:15:03.000000', 'consum', 0.0215, 'lps'),
	(622033, 131, '2014-04-01 01:15:04.000000', 'consum', 0.0217, 'lps'),
	(622034, 131, '2014-04-01 01:15:05.000000', 'consum', 0.0210, 'lps'),
	(622035, 131, '2014-04-01 01:15:06.000000', 'consum', 0.0210, 'lps'),
	(622036, 131, '2014-04-01 01:15:07.000000', 'consum', 0.0211, 'lps'),
	(622037, 131, '2014-04-01 01:15:08.000000', 'consum', 0.0216, 'lps'),
	(622038, 131, '2014-04-01 01:15:09.000000', 'consum', 0.0216, 'lps'),
	(622039, 131, '2014-04-01 01:15:10.000000', 'consum', 0.0224, 'lps'),
	(622040, 131, '2014-04-01 01:15:11.000000', 'consum', 0.0220, 'lps'),
	(622041, 131, '2014-04-01 01:15:12.000000', 'consum', 0.0219, 'lps'),
	(622042, 131, '2014-04-01 01:15:13.000000', 'consum', 0.0227, 'lps'),
	(622043, 131, '2014-04-01 01:15:14.000000', 'consum', 0.0229, 'lps'),
	(622044, 131, '2014-04-01 01:15:15.000000', 'consum', 0.0215, 'lps'),
	(622045, 131, '2014-04-01 01:15:16.000000', 'consum', 0.0216, 'lps'),
	(622046, 131, '2014-04-01 01:15:17.000000', 'consum', 0.0227, 'lps'),
	(622047, 131, '2014-04-01 01:15:18.000000', 'consum', 0.0219, 'lps'),
	(622048, 131, '2014-04-01 01:15:19.000000', 'consum', 0.0223, 'lps'),
	(622049, 131, '2014-04-01 01:15:20.000000', 'consum', 0.0229, 'lps'),
	(622050, 131, '2014-04-01 01:15:21.000000', 'consum', 0.0227, 'lps'),
	(622051, 131, '2014-04-01 01:15:22.000000', 'consum', 0.0219, 'lps'),
	(622052, 131, '2014-04-01 01:15:23.000000', 'consum', 0.0224, 'lps'),
	(622053, 131, '2014-04-01 01:15:24.000000', 'consum', 0.0213, 'lps'),
	(622054, 131, '2014-04-01 01:15:25.000000', 'consum', 0.0224, 'lps'),
	(622055, 131, '2014-04-01 01:15:26.000000', 'consum', 0.0210, 'lps'),
	(622056, 131, '2014-04-01 01:15:27.000000', 'consum', 0.0210, 'lps'),
	(622057, 131, '2014-04-01 01:15:28.000000', 'consum', 0.0210, 'lps'),
	(622058, 131, '2014-04-01 01:15:29.000000', 'consum', 0.0210, 'lps'),
	(622059, 131, '2014-04-01 01:15:30.000000', 'consum', 0.0213, 'lps'),
	(622060, 131, '2014-04-01 01:15:31.000000', 'consum', 0.0222, 'lps'),
	(622061, 131, '2014-04-01 01:15:32.000000', 'consum', 0.0223, 'lps'),
	(622062, 131, '2014-04-01 01:15:33.000000', 'consum', 0.0221, 'lps'),
	(622063, 131, '2014-04-01 01:15:34.000000', 'consum', 0.0224, 'lps'),
	(622064, 131, '2014-04-01 01:15:35.000000', 'consum', 0.0210, 'lps'),
	(622065, 131, '2014-04-01 01:15:36.000000', 'consum', 0.0229, 'lps'),
	(622066, 131, '2014-04-01 01:15:37.000000', 'consum', 0.0225, 'lps'),
	(622067, 131, '2014-04-01 01:15:38.000000', 'consum', 0.0229, 'lps'),
	(622068, 131, '2014-04-01 01:15:39.000000', 'consum', 0.0218, 'lps'),
	(622069, 131, '2014-04-01 01:15:40.000000', 'consum', 0.0216, 'lps'),
	(622070, 131, '2014-04-01 01:15:41.000000', 'consum', 0.0215, 'lps'),
	(622071, 131, '2014-04-01 01:15:42.000000', 'consum', 0.0217, 'lps'),
	(622072, 131, '2014-04-01 01:15:43.000000', 'consum', 0.0211, 'lps'),
	(622073, 131, '2014-04-01 01:15:44.000000', 'consum', 0.0213, 'lps'),
	(622074, 131, '2014-04-01 01:15:45.000000', 'consum', 0.0223, 'lps'),
	(622075, 131, '2014-04-01 01:15:46.000000', 'consum', 0.0228, 'lps'),
	(622076, 131, '2014-04-01 01:15:47.000000', 'consum', 0.0221, 'lps'),
	(622077, 131, '2014-04-01 01:15:48.000000', 'consum', 0.0229, 'lps'),
	(622078, 131, '2014-04-01 01:15:49.000000', 'consum', 0.0216, 'lps'),
	(622079, 131, '2014-04-01 01:15:50.000000', 'consum', 0.0223, 'lps'),
	(622080, 131, '2014-04-01 01:15:51.000000', 'consum', 0.0216, 'lps'),
	(622081, 131, '2014-04-01 01:15:52.000000', 'consum', 0.0224, 'lps'),
	(622082, 131, '2014-04-01 01:15:53.000000', 'consum', 0.0222, 'lps'),
	(622083, 131, '2014-04-01 01:15:54.000000', 'consum', 0.0228, 'lps'),
	(622084, 131, '2014-04-01 01:15:55.000000', 'consum', 0.0225, 'lps'),
	(622085, 131, '2014-04-01 01:15:56.000000', 'consum', 0.0213, 'lps'),
	(622086, 131, '2014-04-01 01:15:57.000000', 'consum', 0.0217, 'lps'),
	(622087, 131, '2014-04-01 01:15:58.000000', 'consum', 0.0220, 'lps'),
	(622088, 131, '2014-04-01 01:15:59.000000', 'consum', 0.0217, 'lps'),
	(622089, 131, '2014-04-01 01:16:00.000000', 'consum', 0.0218, 'lps'),
	(622090, 131, '2014-04-01 01:16:01.000000', 'consum', 0.0227, 'lps'),
	(622091, 131, '2014-04-01 01:16:02.000000', 'consum', 0.0211, 'lps'),
	(622092, 131, '2014-04-01 01:16:03.000000', 'consum', 0.0227, 'lps'),
	(622093, 131, '2014-04-01 01:16:04.000000', 'consum', 0.0212, 'lps'),
	(622094, 131, '2014-04-01 01:16:05.000000', 'consum', 0.0229, 'lps'),
	(622095, 131, '2014-04-01 01:16:06.000000', 'consum', 0.0220, 'lps'),
	(622096, 131, '2014-04-01 01:16:07.000000', 'consum', 0.0224, 'lps'),
	(622097, 131, '2014-04-01 01:16:08.000000', 'consum', 0.0229, 'lps'),
	(622098, 131, '2014-04-01 01:16:09.000000', 'consum', 0.0225, 'lps'),
	(622099, 131, '2014-04-01 01:16:10.000000', 'consum', 0.0229, 'lps'),
	(622100, 131, '2014-04-01 01:16:11.000000', 'consum', 0.0222, 'lps'),
	(622101, 131, '2014-04-01 01:16:12.000000', 'consum', 0.0210, 'lps'),
	(622102, 131, '2014-04-01 01:16:13.000000', 'consum', 0.0216, 'lps'),
	(622103, 131, '2014-04-01 01:16:14.000000', 'consum', 0.0222, 'lps'),
	(622104, 131, '2014-04-01 01:16:15.000000', 'consum', 0.0212, 'lps'),
	(622105, 131, '2014-04-01 01:16:16.000000', 'consum', 0.0222, 'lps'),
	(622106, 131, '2014-04-01 01:16:17.000000', 'consum', 0.0226, 'lps'),
	(622107, 131, '2014-04-01 01:16:18.000000', 'consum', 0.0213, 'lps'),
	(622108, 131, '2014-04-01 01:16:19.000000', 'consum', 0.0220, 'lps'),
	(622109, 131, '2014-04-01 01:16:20.000000', 'consum', 0.0210, 'lps'),
	(622110, 131, '2014-04-01 01:16:21.000000', 'consum', 0.0223, 'lps'),
	(622111, 131, '2014-04-01 01:16:22.000000', 'consum', 0.0213, 'lps'),
	(622112, 131, '2014-04-01 01:16:23.000000', 'consum', 0.0226, 'lps'),
	(622113, 131, '2014-04-01 01:16:24.000000', 'consum', 0.0220, 'lps'),
	(622114, 131, '2014-04-01 01:16:25.000000', 'consum', 0.0215, 'lps'),
	(622115, 131, '2014-04-01 01:16:26.000000', 'consum', 0.0225, 'lps'),
	(622116, 131, '2014-04-01 01:16:27.000000', 'consum', 0.0229, 'lps'),
	(622117, 131, '2014-04-01 01:16:28.000000', 'consum', 0.0220, 'lps'),
	(622118, 131, '2014-04-01 01:16:29.000000', 'consum', 0.0223, 'lps'),
	(622119, 131, '2014-04-01 01:16:30.000000', 'consum', 0.0228, 'lps'),
	(622120, 131, '2014-04-01 01:16:31.000000', 'consum', 0.0222, 'lps'),
	(622121, 131, '2014-04-01 01:16:32.000000', 'consum', 0.0216, 'lps'),
	(622122, 131, '2014-04-01 01:16:33.000000', 'consum', 0.0223, 'lps'),
	(622123, 131, '2014-04-01 01:16:34.000000', 'consum', 0.0218, 'lps'),
	(622124, 131, '2014-04-01 01:16:35.000000', 'consum', 0.0213, 'lps'),
	(622125, 131, '2014-04-01 01:16:36.000000', 'consum', 0.0219, 'lps'),
	(622126, 131, '2014-04-01 01:16:37.000000', 'consum', 0.0229, 'lps'),
	(622127, 131, '2014-04-01 01:16:38.000000', 'consum', 0.0219, 'lps'),
	(622128, 131, '2014-04-01 01:16:39.000000', 'consum', 0.0216, 'lps'),
	(622129, 131, '2014-04-01 01:16:40.000000', 'consum', 0.0213, 'lps'),
	(622130, 131, '2014-04-01 01:16:41.000000', 'consum', 0.0211, 'lps'),
	(622131, 131, '2014-04-01 01:16:42.000000', 'consum', 0.0223, 'lps'),
	(622132, 131, '2014-04-01 01:16:43.000000', 'consum', 0.0213, 'lps'),
	(622133, 131, '2014-04-01 01:16:44.000000', 'consum', 0.0227, 'lps'),
	(622134, 131, '2014-04-01 01:16:45.000000', 'consum', 0.0228, 'lps'),
	(622135, 131, '2014-04-01 01:16:46.000000', 'consum', 0.0228, 'lps'),
	(622136, 131, '2014-04-01 01:16:47.000000', 'consum', 0.0226, 'lps'),
	(622137, 131, '2014-04-01 01:16:48.000000', 'consum', 0.0219, 'lps'),
	(622138, 131, '2014-04-01 01:16:49.000000', 'consum', 0.0226, 'lps'),
	(622139, 131, '2014-04-01 01:16:50.000000', 'consum', 0.0223, 'lps'),
	(622140, 131, '2014-04-01 01:16:51.000000', 'consum', 0.0229, 'lps'),
	(622141, 131, '2014-04-01 01:16:52.000000', 'consum', 0.0226, 'lps'),
	(622142, 131, '2014-04-01 01:16:53.000000', 'consum', 0.0215, 'lps'),
	(622143, 131, '2014-04-01 01:16:54.000000', 'consum', 0.0225, 'lps'),
	(622144, 131, '2014-04-01 01:16:55.000000', 'consum', 0.0213, 'lps'),
	(622145, 131, '2014-04-01 01:16:56.000000', 'consum', 0.0219, 'lps'),
	(622146, 131, '2014-04-01 01:16:57.000000', 'consum', 0.0226, 'lps'),
	(622147, 131, '2014-04-01 01:16:58.000000', 'consum', 0.0224, 'lps'),
	(622148, 131, '2014-04-01 01:16:59.000000', 'consum', 0.0213, 'lps'),
	(622149, 131, '2014-04-01 01:17:00.000000', 'consum', 0.0221, 'lps'),
	(622150, 131, '2014-04-01 01:17:01.000000', 'consum', 0.0219, 'lps'),
	(622151, 131, '2014-04-01 01:17:02.000000', 'consum', 0.0220, 'lps'),
	(622152, 131, '2014-04-01 01:17:03.000000', 'consum', 0.0217, 'lps'),
	(622153, 131, '2014-04-01 01:17:04.000000', 'consum', 0.0213, 'lps'),
	(622154, 131, '2014-04-01 01:17:05.000000', 'consum', 0.0224, 'lps'),
	(622155, 131, '2014-04-01 01:17:06.000000', 'consum', 0.0214, 'lps'),
	(622156, 131, '2014-04-01 01:17:07.000000', 'consum', 0.0229, 'lps'),
	(622157, 131, '2014-04-01 01:17:08.000000', 'consum', 0.0211, 'lps'),
	(622158, 131, '2014-04-01 01:17:09.000000', 'consum', 0.0220, 'lps'),
	(622159, 131, '2014-04-01 01:17:10.000000', 'consum', 0.0218, 'lps'),
	(622160, 131, '2014-04-01 01:17:11.000000', 'consum', 0.0221, 'lps'),
	(622161, 131, '2014-04-01 01:17:12.000000', 'consum', 0.0219, 'lps'),
	(622162, 131, '2014-04-01 01:17:13.000000', 'consum', 0.0222, 'lps'),
	(622163, 131, '2014-04-01 01:17:14.000000', 'consum', 0.0227, 'lps'),
	(622164, 131, '2014-04-01 01:17:15.000000', 'consum', 0.0217, 'lps'),
	(622165, 131, '2014-04-01 01:17:16.000000', 'consum', 0.0215, 'lps'),
	(622166, 131, '2014-04-01 01:17:17.000000', 'consum', 0.0213, 'lps'),
	(622167, 131, '2014-04-01 01:17:18.000000', 'consum', 0.0213, 'lps'),
	(622168, 131, '2014-04-01 01:17:19.000000', 'consum', 0.0217, 'lps'),
	(622169, 131, '2014-04-01 01:17:20.000000', 'consum', 0.0215, 'lps'),
	(622170, 131, '2014-04-01 01:17:21.000000', 'consum', 0.0216, 'lps'),
	(622171, 131, '2014-04-01 01:17:22.000000', 'consum', 0.0227, 'lps'),
	(622172, 131, '2014-04-01 01:17:23.000000', 'consum', 0.0214, 'lps'),
	(622173, 131, '2014-04-01 01:17:24.000000', 'consum', 0.0223, 'lps'),
	(622174, 131, '2014-04-01 01:17:25.000000', 'consum', 0.0221, 'lps'),
	(622175, 131, '2014-04-01 01:17:26.000000', 'consum', 0.0226, 'lps'),
	(622176, 131, '2014-04-01 01:17:27.000000', 'consum', 0.0217, 'lps'),
	(622177, 131, '2014-04-01 01:17:28.000000', 'consum', 0.0217, 'lps'),
	(622178, 131, '2014-04-01 01:17:29.000000', 'consum', 0.0227, 'lps'),
	(622179, 131, '2014-04-01 01:17:30.000000', 'consum', 0.0216, 'lps'),
	(622180, 131, '2014-04-01 01:17:31.000000', 'consum', 0.0226, 'lps'),
	(622181, 131, '2014-04-01 01:17:32.000000', 'consum', 0.0214, 'lps'),
	(622182, 131, '2014-04-01 01:17:33.000000', 'consum', 0.0221, 'lps'),
	(622183, 131, '2014-04-01 01:17:34.000000', 'consum', 0.0213, 'lps'),
	(622184, 131, '2014-04-01 01:17:35.000000', 'consum', 0.0213, 'lps'),
	(622185, 131, '2014-04-01 01:17:36.000000', 'consum', 0.0217, 'lps'),
	(622186, 131, '2014-04-01 01:17:37.000000', 'consum', 0.0215, 'lps'),
	(622187, 131, '2014-04-01 01:17:38.000000', 'consum', 0.0214, 'lps'),
	(622188, 131, '2014-04-01 01:17:39.000000', 'consum', 0.0215, 'lps'),
	(622189, 131, '2014-04-01 01:17:40.000000', 'consum', 0.0226, 'lps'),
	(622190, 131, '2014-04-01 01:17:41.000000', 'consum', 0.0215, 'lps'),
	(622191, 131, '2014-04-01 01:17:42.000000', 'consum', 0.0228, 'lps'),
	(622192, 131, '2014-04-01 01:17:43.000000', 'consum', 0.0227, 'lps'),
	(622193, 131, '2014-04-01 01:17:44.000000', 'consum', 0.0219, 'lps'),
	(622194, 131, '2014-04-01 01:17:45.000000', 'consum', 0.0226, 'lps'),
	(622195, 131, '2014-04-01 01:17:46.000000', 'consum', 0.0221, 'lps'),
	(622196, 131, '2014-04-01 01:17:47.000000', 'consum', 0.0220, 'lps'),
	(622197, 131, '2014-04-01 01:17:48.000000', 'consum', 0.0229, 'lps'),
	(622198, 131, '2014-04-01 01:17:49.000000', 'consum', 0.0212, 'lps'),
	(622199, 131, '2014-04-01 01:17:50.000000', 'consum', 0.0225, 'lps'),
	(622200, 131, '2014-04-01 01:17:51.000000', 'consum', 0.0218, 'lps'),
	(622201, 131, '2014-04-01 01:17:52.000000', 'consum', 0.0228, 'lps'),
	(622202, 131, '2014-04-01 01:17:53.000000', 'consum', 0.0216, 'lps'),
	(622203, 131, '2014-04-01 01:17:54.000000', 'consum', 0.0228, 'lps'),
	(622204, 131, '2014-04-01 01:17:55.000000', 'consum', 0.0220, 'lps'),
	(622205, 131, '2014-04-01 01:17:56.000000', 'consum', 0.0228, 'lps'),
	(622206, 131, '2014-04-01 01:17:57.000000', 'consum', 0.0210, 'lps'),
	(622207, 131, '2014-04-01 01:17:58.000000', 'consum', 0.0218, 'lps'),
	(622208, 131, '2014-04-01 01:17:59.000000', 'consum', 0.0210, 'lps'),
	(622209, 131, '2014-04-01 01:18:00.000000', 'consum', 0.0228, 'lps'),
	(622210, 131, '2014-04-01 01:18:01.000000', 'consum', 0.0218, 'lps'),
	(622211, 131, '2014-04-01 01:18:02.000000', 'consum', 0.0217, 'lps'),
	(622212, 131, '2014-04-01 01:18:03.000000', 'consum', 0.0220, 'lps'),
	(622213, 131, '2014-04-01 01:18:04.000000', 'consum', 0.0221, 'lps'),
	(622214, 131, '2014-04-01 01:18:05.000000', 'consum', 0.0216, 'lps'),
	(622215, 131, '2014-04-01 01:18:06.000000', 'consum', 0.0227, 'lps'),
	(622216, 131, '2014-04-01 01:18:07.000000', 'consum', 0.0215, 'lps'),
	(622217, 131, '2014-04-01 01:18:08.000000', 'consum', 0.0228, 'lps'),
	(622218, 131, '2014-04-01 01:18:09.000000', 'consum', 0.0223, 'lps'),
	(622219, 131, '2014-04-01 01:18:10.000000', 'consum', 0.0224, 'lps'),
	(622220, 131, '2014-04-01 01:18:11.000000', 'consum', 0.0222, 'lps'),
	(622221, 131, '2014-04-01 01:18:12.000000', 'consum', 0.0227, 'lps'),
	(622222, 131, '2014-04-01 01:18:13.000000', 'consum', 0.0221, 'lps'),
	(622223, 131, '2014-04-01 01:18:14.000000', 'consum', 0.0212, 'lps'),
	(622224, 131, '2014-04-01 01:18:15.000000', 'consum', 0.0210, 'lps'),
	(622225, 131, '2014-04-01 01:18:16.000000', 'consum', 0.0223, 'lps'),
	(622226, 131, '2014-04-01 01:18:17.000000', 'consum', 0.0218, 'lps'),
	(622227, 131, '2014-04-01 01:18:18.000000', 'consum', 0.0229, 'lps'),
	(622228, 131, '2014-04-01 01:18:19.000000', 'consum', 0.0222, 'lps'),
	(622229, 131, '2014-04-01 01:18:20.000000', 'consum', 0.0214, 'lps'),
	(622230, 131, '2014-04-01 01:18:21.000000', 'consum', 0.0216, 'lps'),
	(622231, 131, '2014-04-01 01:18:22.000000', 'consum', 0.0229, 'lps'),
	(622232, 131, '2014-04-01 01:18:23.000000', 'consum', 0.0225, 'lps'),
	(622233, 131, '2014-04-01 01:18:24.000000', 'consum', 0.0229, 'lps'),
	(622234, 131, '2014-04-01 01:18:25.000000', 'consum', 0.0220, 'lps'),
	(622235, 131, '2014-04-01 01:18:26.000000', 'consum', 0.0222, 'lps'),
	(622236, 131, '2014-04-01 01:18:27.000000', 'consum', 0.0222, 'lps'),
	(622237, 131, '2014-04-01 01:18:28.000000', 'consum', 0.0214, 'lps'),
	(622238, 131, '2014-04-01 01:18:29.000000', 'consum', 0.0216, 'lps'),
	(622239, 131, '2014-04-01 01:18:30.000000', 'consum', 0.0229, 'lps'),
	(622240, 131, '2014-04-01 01:18:31.000000', 'consum', 0.0228, 'lps'),
	(622241, 131, '2014-04-01 01:18:32.000000', 'consum', 0.0223, 'lps'),
	(622242, 131, '2014-04-01 01:18:33.000000', 'consum', 0.0222, 'lps'),
	(622243, 131, '2014-04-01 01:18:34.000000', 'consum', 0.0211, 'lps'),
	(622244, 131, '2014-04-01 01:18:35.000000', 'consum', 0.0219, 'lps'),
	(622245, 131, '2014-04-01 01:18:36.000000', 'consum', 0.0214, 'lps'),
	(622246, 131, '2014-04-01 01:18:37.000000', 'consum', 0.0224, 'lps'),
	(622247, 131, '2014-04-01 01:18:38.000000', 'consum', 0.0228, 'lps'),
	(622248, 131, '2014-04-01 01:18:39.000000', 'consum', 0.0220, 'lps'),
	(622249, 131, '2014-04-01 01:18:40.000000', 'consum', 0.0224, 'lps'),
	(622250, 131, '2014-04-01 01:18:41.000000', 'consum', 0.0211, 'lps'),
	(622251, 131, '2014-04-01 01:18:42.000000', 'consum', 0.0215, 'lps'),
	(622252, 131, '2014-04-01 01:18:43.000000', 'consum', 0.0229, 'lps'),
	(622253, 131, '2014-04-01 01:18:44.000000', 'consum', 0.0214, 'lps'),
	(622254, 131, '2014-04-01 01:18:45.000000', 'consum', 0.0214, 'lps'),
	(622255, 131, '2014-04-01 01:18:46.000000', 'consum', 0.0218, 'lps'),
	(622256, 131, '2014-04-01 01:18:47.000000', 'consum', 0.0217, 'lps'),
	(622257, 131, '2014-04-01 01:18:48.000000', 'consum', 0.0223, 'lps'),
	(622258, 131, '2014-04-01 01:18:49.000000', 'consum', 0.0215, 'lps'),
	(622259, 131, '2014-04-01 01:18:50.000000', 'consum', 0.0217, 'lps'),
	(622260, 131, '2014-04-01 01:18:51.000000', 'consum', 0.0210, 'lps'),
	(622261, 131, '2014-04-01 01:18:52.000000', 'consum', 0.0229, 'lps'),
	(622262, 131, '2014-04-01 01:18:53.000000', 'consum', 0.0224, 'lps'),
	(622263, 131, '2014-04-01 01:18:54.000000', 'consum', 0.0223, 'lps'),
	(622264, 131, '2014-04-01 01:18:55.000000', 'consum', 0.0215, 'lps'),
	(622265, 131, '2014-04-01 01:18:56.000000', 'consum', 0.0215, 'lps'),
	(622266, 131, '2014-04-01 01:18:57.000000', 'consum', 0.0220, 'lps'),
	(622267, 131, '2014-04-01 01:18:58.000000', 'consum', 0.0226, 'lps'),
	(622268, 131, '2014-04-01 01:18:59.000000', 'consum', 0.0223, 'lps'),
	(622269, 131, '2014-04-01 01:19:00.000000', 'consum', 0.0225, 'lps'),
	(622270, 131, '2014-04-01 01:19:01.000000', 'consum', 0.0228, 'lps'),
	(622271, 131, '2014-04-01 01:19:02.000000', 'consum', 0.0215, 'lps'),
	(622272, 131, '2014-04-01 01:19:03.000000', 'consum', 0.0223, 'lps'),
	(622273, 131, '2014-04-01 01:19:04.000000', 'consum', 0.0220, 'lps'),
	(622274, 131, '2014-04-01 01:19:05.000000', 'consum', 0.0223, 'lps'),
	(622275, 131, '2014-04-01 01:19:06.000000', 'consum', 0.0224, 'lps'),
	(622276, 131, '2014-04-01 01:19:07.000000', 'consum', 0.0221, 'lps'),
	(622277, 131, '2014-04-01 01:19:08.000000', 'consum', 0.0223, 'lps'),
	(622278, 131, '2014-04-01 01:19:09.000000', 'consum', 0.0224, 'lps'),
	(622279, 131, '2014-04-01 01:19:10.000000', 'consum', 0.0223, 'lps'),
	(622280, 131, '2014-04-01 01:19:11.000000', 'consum', 0.0212, 'lps'),
	(622281, 131, '2014-04-01 01:19:12.000000', 'consum', 0.0220, 'lps'),
	(622282, 131, '2014-04-01 01:19:13.000000', 'consum', 0.0215, 'lps'),
	(622283, 131, '2014-04-01 01:19:14.000000', 'consum', 0.0225, 'lps'),
	(622284, 131, '2014-04-01 01:19:15.000000', 'consum', 0.0229, 'lps'),
	(622285, 131, '2014-04-01 01:19:16.000000', 'consum', 0.0223, 'lps'),
	(622286, 131, '2014-04-01 01:19:17.000000', 'consum', 0.0218, 'lps'),
	(622287, 131, '2014-04-01 01:19:18.000000', 'consum', 0.0212, 'lps'),
	(622288, 131, '2014-04-01 01:19:19.000000', 'consum', 0.0215, 'lps'),
	(622289, 131, '2014-04-01 01:19:20.000000', 'consum', 0.0210, 'lps'),
	(622290, 131, '2014-04-01 01:19:21.000000', 'consum', 0.0218, 'lps'),
	(622291, 131, '2014-04-01 01:19:22.000000', 'consum', 0.0227, 'lps'),
	(622292, 131, '2014-04-01 01:19:23.000000', 'consum', 0.0213, 'lps'),
	(622293, 131, '2014-04-01 01:19:24.000000', 'consum', 0.0216, 'lps'),
	(622294, 131, '2014-04-01 01:19:25.000000', 'consum', 0.0229, 'lps'),
	(622295, 131, '2014-04-01 01:19:26.000000', 'consum', 0.0210, 'lps'),
	(622296, 131, '2014-04-01 01:19:27.000000', 'consum', 0.0213, 'lps'),
	(622297, 131, '2014-04-01 01:19:28.000000', 'consum', 0.0227, 'lps'),
	(622298, 131, '2014-04-01 01:19:29.000000', 'consum', 0.0226, 'lps'),
	(622299, 131, '2014-04-01 01:19:30.000000', 'consum', 0.0220, 'lps'),
	(622300, 131, '2014-04-01 01:19:31.000000', 'consum', 0.0211, 'lps'),
	(622301, 131, '2014-04-01 01:19:32.000000', 'consum', 0.0227, 'lps'),
	(622302, 131, '2014-04-01 01:19:33.000000', 'consum', 0.0211, 'lps'),
	(622303, 131, '2014-04-01 01:19:34.000000', 'consum', 0.0224, 'lps'),
	(622304, 131, '2014-04-01 01:19:35.000000', 'consum', 0.0219, 'lps'),
	(622305, 131, '2014-04-01 01:19:36.000000', 'consum', 0.0213, 'lps'),
	(622306, 131, '2014-04-01 01:19:37.000000', 'consum', 0.0218, 'lps'),
	(622307, 131, '2014-04-01 01:19:38.000000', 'consum', 0.0222, 'lps'),
	(622308, 131, '2014-04-01 01:19:39.000000', 'consum', 0.0227, 'lps'),
	(622309, 131, '2014-04-01 01:19:40.000000', 'consum', 0.0219, 'lps'),
	(622310, 131, '2014-04-01 01:19:41.000000', 'consum', 0.0226, 'lps'),
	(622311, 131, '2014-04-01 01:19:42.000000', 'consum', 0.0224, 'lps'),
	(622312, 131, '2014-04-01 01:19:43.000000', 'consum', 0.0210, 'lps'),
	(622313, 131, '2014-04-01 01:19:44.000000', 'consum', 0.0228, 'lps'),
	(622314, 131, '2014-04-01 01:19:45.000000', 'consum', 0.0223, 'lps'),
	(622315, 131, '2014-04-01 01:19:46.000000', 'consum', 0.0222, 'lps'),
	(622316, 131, '2014-04-01 01:19:47.000000', 'consum', 0.0211, 'lps'),
	(622317, 131, '2014-04-01 01:19:48.000000', 'consum', 0.0217, 'lps'),
	(622318, 131, '2014-04-01 01:19:49.000000', 'consum', 0.0224, 'lps'),
	(622319, 131, '2014-04-01 01:19:50.000000', 'consum', 0.0219, 'lps'),
	(622320, 131, '2014-04-01 01:19:51.000000', 'consum', 0.0215, 'lps'),
	(622321, 131, '2014-04-01 01:19:52.000000', 'consum', 0.0226, 'lps'),
	(622322, 131, '2014-04-01 01:19:53.000000', 'consum', 0.0217, 'lps'),
	(622323, 131, '2014-04-01 01:19:54.000000', 'consum', 0.0215, 'lps'),
	(622324, 131, '2014-04-01 01:19:55.000000', 'consum', 0.0217, 'lps'),
	(622325, 131, '2014-04-01 01:19:56.000000', 'consum', 0.0229, 'lps'),
	(622326, 131, '2014-04-01 01:19:57.000000', 'consum', 0.0226, 'lps'),
	(622327, 131, '2014-04-01 01:19:58.000000', 'consum', 0.0211, 'lps'),
	(622328, 131, '2014-04-01 01:19:59.000000', 'consum', 0.0210, 'lps'),
	(622329, 131, '2014-04-01 01:20:00.000000', 'consum', 0.0225, 'lps'),
	(622330, 131, '2014-04-01 01:20:01.000000', 'consum', 0.0228, 'lps'),
	(622331, 131, '2014-04-01 01:20:02.000000', 'consum', 0.0215, 'lps'),
	(622332, 131, '2014-04-01 01:20:03.000000', 'consum', 0.0219, 'lps'),
	(622333, 131, '2014-04-01 01:20:04.000000', 'consum', 0.0224, 'lps'),
	(622334, 131, '2014-04-01 01:20:05.000000', 'consum', 0.0212, 'lps'),
	(622335, 131, '2014-04-01 01:20:06.000000', 'consum', 0.0219, 'lps'),
	(622336, 131, '2014-04-01 01:20:07.000000', 'consum', 0.0210, 'lps'),
	(622337, 131, '2014-04-01 01:20:08.000000', 'consum', 0.0221, 'lps'),
	(622338, 131, '2014-04-01 01:20:09.000000', 'consum', 0.0228, 'lps'),
	(622339, 131, '2014-04-01 01:20:10.000000', 'consum', 0.0225, 'lps'),
	(622340, 131, '2014-04-01 01:20:11.000000', 'consum', 0.0214, 'lps'),
	(622341, 131, '2014-04-01 01:20:12.000000', 'consum', 0.0224, 'lps'),
	(622342, 131, '2014-04-01 01:20:13.000000', 'consum', 0.0227, 'lps'),
	(622343, 131, '2014-04-01 01:20:14.000000', 'consum', 0.0216, 'lps'),
	(622344, 131, '2014-04-01 01:20:15.000000', 'consum', 0.0210, 'lps'),
	(622345, 131, '2014-04-01 01:20:16.000000', 'consum', 0.0213, 'lps'),
	(622346, 131, '2014-04-01 01:20:17.000000', 'consum', 0.0227, 'lps'),
	(622347, 131, '2014-04-01 01:20:18.000000', 'consum', 0.0223, 'lps'),
	(622348, 131, '2014-04-01 01:20:19.000000', 'consum', 0.0225, 'lps'),
	(622349, 131, '2014-04-01 01:20:20.000000', 'consum', 0.0229, 'lps'),
	(622350, 131, '2014-04-01 01:20:21.000000', 'consum', 0.0219, 'lps'),
	(622351, 131, '2014-04-01 01:20:22.000000', 'consum', 0.0220, 'lps'),
	(622352, 131, '2014-04-01 01:20:23.000000', 'consum', 0.0212, 'lps'),
	(622353, 131, '2014-04-01 01:20:24.000000', 'consum', 0.0212, 'lps'),
	(622354, 131, '2014-04-01 01:20:25.000000', 'consum', 0.0212, 'lps'),
	(622355, 131, '2014-04-01 01:20:26.000000', 'consum', 0.0217, 'lps'),
	(622356, 131, '2014-04-01 01:20:27.000000', 'consum', 0.0217, 'lps'),
	(622357, 131, '2014-04-01 01:20:28.000000', 'consum', 0.0226, 'lps'),
	(622358, 131, '2014-04-01 01:20:29.000000', 'consum', 0.0211, 'lps'),
	(622359, 131, '2014-04-01 01:20:30.000000', 'consum', 0.0224, 'lps'),
	(622360, 131, '2014-04-01 01:20:31.000000', 'consum', 0.0220, 'lps'),
	(622361, 131, '2014-04-01 01:20:32.000000', 'consum', 0.0217, 'lps'),
	(622362, 131, '2014-04-01 01:20:33.000000', 'consum', 0.0215, 'lps'),
	(622363, 131, '2014-04-01 01:20:34.000000', 'consum', 0.0215, 'lps'),
	(622364, 131, '2014-04-01 01:20:35.000000', 'consum', 0.0223, 'lps'),
	(622365, 131, '2014-04-01 01:20:36.000000', 'consum', 0.0217, 'lps'),
	(622366, 131, '2014-04-01 01:20:37.000000', 'consum', 0.0227, 'lps'),
	(622367, 131, '2014-04-01 01:20:38.000000', 'consum', 0.0217, 'lps'),
	(622368, 131, '2014-04-01 01:20:39.000000', 'consum', 0.0211, 'lps'),
	(622369, 131, '2014-04-01 01:20:40.000000', 'consum', 0.0217, 'lps'),
	(622370, 131, '2014-04-01 01:20:41.000000', 'consum', 0.0220, 'lps'),
	(622371, 131, '2014-04-01 01:20:42.000000', 'consum', 0.0222, 'lps'),
	(622372, 131, '2014-04-01 01:20:43.000000', 'consum', 0.0219, 'lps'),
	(622373, 131, '2014-04-01 01:20:44.000000', 'consum', 0.0220, 'lps'),
	(622374, 131, '2014-04-01 01:20:45.000000', 'consum', 0.0214, 'lps'),
	(622375, 131, '2014-04-01 01:20:46.000000', 'consum', 0.0221, 'lps'),
	(622376, 131, '2014-04-01 01:20:47.000000', 'consum', 0.0211, 'lps'),
	(622377, 131, '2014-04-01 01:20:48.000000', 'consum', 0.0224, 'lps'),
	(622378, 131, '2014-04-01 01:20:49.000000', 'consum', 0.0219, 'lps'),
	(622379, 131, '2014-04-01 01:20:50.000000', 'consum', 0.0210, 'lps'),
	(622380, 131, '2014-04-01 01:20:51.000000', 'consum', 0.0227, 'lps'),
	(622381, 131, '2014-04-01 01:20:52.000000', 'consum', 0.0215, 'lps'),
	(622382, 131, '2014-04-01 01:20:53.000000', 'consum', 0.0225, 'lps'),
	(622383, 131, '2014-04-01 01:20:54.000000', 'consum', 0.0228, 'lps'),
	(622384, 131, '2014-04-01 01:20:55.000000', 'consum', 0.0218, 'lps'),
	(622385, 131, '2014-04-01 01:20:56.000000', 'consum', 0.0217, 'lps'),
	(622386, 131, '2014-04-01 01:20:57.000000', 'consum', 0.0220, 'lps'),
	(622387, 131, '2014-04-01 01:20:58.000000', 'consum', 0.0220, 'lps'),
	(622388, 131, '2014-04-01 01:20:59.000000', 'consum', 0.0212, 'lps'),
	(622389, 131, '2014-04-01 01:21:00.000000', 'consum', 0.0228, 'lps'),
	(622390, 131, '2014-04-01 01:21:01.000000', 'consum', 0.0217, 'lps'),
	(622391, 131, '2014-04-01 01:21:02.000000', 'consum', 0.0212, 'lps'),
	(622392, 131, '2014-04-01 01:21:03.000000', 'consum', 0.0217, 'lps'),
	(622393, 131, '2014-04-01 01:21:04.000000', 'consum', 0.0221, 'lps'),
	(622394, 131, '2014-04-01 01:21:05.000000', 'consum', 0.0226, 'lps'),
	(622395, 131, '2014-04-01 01:21:06.000000', 'consum', 0.0216, 'lps'),
	(622396, 131, '2014-04-01 01:21:07.000000', 'consum', 0.0213, 'lps'),
	(622397, 131, '2014-04-01 01:21:08.000000', 'consum', 0.0229, 'lps'),
	(622398, 131, '2014-04-01 01:21:09.000000', 'consum', 0.0215, 'lps'),
	(622399, 131, '2014-04-01 01:21:10.000000', 'consum', 0.0220, 'lps'),
	(622400, 131, '2014-04-01 01:21:11.000000', 'consum', 0.0224, 'lps'),
	(622401, 131, '2014-04-01 01:21:12.000000', 'consum', 0.0211, 'lps'),
	(622402, 131, '2014-04-01 01:21:13.000000', 'consum', 0.0215, 'lps'),
	(622403, 131, '2014-04-01 01:21:14.000000', 'consum', 0.0210, 'lps'),
	(622404, 131, '2014-04-01 01:21:15.000000', 'consum', 0.0218, 'lps'),
	(622405, 131, '2014-04-01 01:21:16.000000', 'consum', 0.0210, 'lps'),
	(622406, 131, '2014-04-01 01:21:17.000000', 'consum', 0.0225, 'lps'),
	(622407, 131, '2014-04-01 01:21:18.000000', 'consum', 0.0226, 'lps'),
	(622408, 131, '2014-04-01 01:21:19.000000', 'consum', 0.0227, 'lps'),
	(622409, 131, '2014-04-01 01:21:20.000000', 'consum', 0.0227, 'lps'),
	(622410, 131, '2014-04-01 01:21:21.000000', 'consum', 0.0226, 'lps'),
	(622411, 131, '2014-04-01 01:21:22.000000', 'consum', 0.0217, 'lps'),
	(622412, 131, '2014-04-01 01:21:23.000000', 'consum', 0.0219, 'lps'),
	(622413, 131, '2014-04-01 01:21:24.000000', 'consum', 0.0215, 'lps'),
	(622414, 131, '2014-04-01 01:21:25.000000', 'consum', 0.0210, 'lps'),
	(622415, 131, '2014-04-01 01:21:26.000000', 'consum', 0.0213, 'lps'),
	(622416, 131, '2014-04-01 01:21:27.000000', 'consum', 0.0227, 'lps'),
	(622417, 131, '2014-04-01 01:21:28.000000', 'consum', 0.0225, 'lps'),
	(622418, 131, '2014-04-01 01:21:29.000000', 'consum', 0.0215, 'lps'),
	(622419, 131, '2014-04-01 01:21:30.000000', 'consum', 0.0212, 'lps'),
	(622420, 131, '2014-04-01 01:21:31.000000', 'consum', 0.0226, 'lps'),
	(622421, 131, '2014-04-01 01:21:32.000000', 'consum', 0.0222, 'lps'),
	(622422, 131, '2014-04-01 01:21:33.000000', 'consum', 0.0222, 'lps'),
	(622423, 131, '2014-04-01 01:21:34.000000', 'consum', 0.0215, 'lps'),
	(622424, 131, '2014-04-01 01:21:35.000000', 'consum', 0.0221, 'lps'),
	(622425, 131, '2014-04-01 01:21:36.000000', 'consum', 0.0228, 'lps'),
	(622426, 131, '2014-04-01 01:21:37.000000', 'consum', 0.0211, 'lps'),
	(622427, 131, '2014-04-01 01:21:38.000000', 'consum', 0.0219, 'lps'),
	(622428, 131, '2014-04-01 01:21:39.000000', 'consum', 0.0213, 'lps'),
	(622429, 131, '2014-04-01 01:21:40.000000', 'consum', 0.0220, 'lps'),
	(622430, 131, '2014-04-01 01:21:41.000000', 'consum', 0.0211, 'lps'),
	(622431, 131, '2014-04-01 01:21:42.000000', 'consum', 0.0225, 'lps'),
	(622432, 131, '2014-04-01 01:21:43.000000', 'consum', 0.0221, 'lps'),
	(622433, 131, '2014-04-01 01:21:44.000000', 'consum', 0.0220, 'lps'),
	(622434, 131, '2014-04-01 01:21:45.000000', 'consum', 0.0210, 'lps'),
	(622435, 131, '2014-04-01 01:21:46.000000', 'consum', 0.0220, 'lps'),
	(622436, 131, '2014-04-01 01:21:47.000000', 'consum', 0.0222, 'lps'),
	(622437, 131, '2014-04-01 01:21:48.000000', 'consum', 0.0220, 'lps'),
	(622438, 131, '2014-04-01 01:21:49.000000', 'consum', 0.0225, 'lps'),
	(622439, 131, '2014-04-01 01:21:50.000000', 'consum', 0.0217, 'lps'),
	(622440, 131, '2014-04-01 01:21:51.000000', 'consum', 0.0218, 'lps'),
	(622441, 131, '2014-04-01 01:21:52.000000', 'consum', 0.0229, 'lps'),
	(622442, 131, '2014-04-01 01:21:53.000000', 'consum', 0.0222, 'lps'),
	(622443, 131, '2014-04-01 01:21:54.000000', 'consum', 0.0212, 'lps'),
	(622444, 131, '2014-04-01 01:21:55.000000', 'consum', 0.0226, 'lps'),
	(622445, 131, '2014-04-01 01:21:56.000000', 'consum', 0.0226, 'lps'),
	(622446, 131, '2014-04-01 01:21:57.000000', 'consum', 0.0222, 'lps'),
	(622447, 131, '2014-04-01 01:21:58.000000', 'consum', 0.0223, 'lps'),
	(622448, 131, '2014-04-01 01:21:59.000000', 'consum', 0.0221, 'lps'),
	(622449, 131, '2014-04-01 01:22:00.000000', 'consum', 0.0223, 'lps'),
	(622450, 131, '2014-04-01 01:22:01.000000', 'consum', 0.0224, 'lps'),
	(622451, 131, '2014-04-01 01:22:02.000000', 'consum', 0.0222, 'lps'),
	(622452, 131, '2014-04-01 01:22:03.000000', 'consum', 0.0229, 'lps'),
	(622453, 131, '2014-04-01 01:22:04.000000', 'consum', 0.0227, 'lps'),
	(622454, 131, '2014-04-01 01:22:05.000000', 'consum', 0.0220, 'lps'),
	(622455, 131, '2014-04-01 01:22:06.000000', 'consum', 0.0229, 'lps'),
	(622456, 131, '2014-04-01 01:22:07.000000', 'consum', 0.0214, 'lps'),
	(622457, 131, '2014-04-01 01:22:08.000000', 'consum', 0.0216, 'lps'),
	(622458, 131, '2014-04-01 01:22:09.000000', 'consum', 0.0228, 'lps'),
	(622459, 131, '2014-04-01 01:22:10.000000', 'consum', 0.0222, 'lps'),
	(622460, 131, '2014-04-01 01:22:11.000000', 'consum', 0.0217, 'lps'),
	(622461, 131, '2014-04-01 01:22:12.000000', 'consum', 0.0228, 'lps'),
	(622462, 131, '2014-04-01 01:22:13.000000', 'consum', 0.0219, 'lps'),
	(622463, 131, '2014-04-01 01:22:14.000000', 'consum', 0.0222, 'lps'),
	(622464, 131, '2014-04-01 01:22:15.000000', 'consum', 0.0223, 'lps'),
	(622465, 131, '2014-04-01 01:22:16.000000', 'consum', 0.0222, 'lps'),
	(622466, 131, '2014-04-01 01:22:17.000000', 'consum', 0.0210, 'lps'),
	(622467, 131, '2014-04-01 01:22:18.000000', 'consum', 0.0214, 'lps'),
	(622468, 131, '2014-04-01 01:22:19.000000', 'consum', 0.0210, 'lps'),
	(622469, 131, '2014-04-01 01:22:20.000000', 'consum', 0.0221, 'lps'),
	(622470, 131, '2014-04-01 01:22:21.000000', 'consum', 0.0224, 'lps'),
	(622471, 131, '2014-04-01 01:22:22.000000', 'consum', 0.0229, 'lps'),
	(622472, 131, '2014-04-01 01:22:23.000000', 'consum', 0.0223, 'lps'),
	(622473, 131, '2014-04-01 01:22:24.000000', 'consum', 0.0219, 'lps'),
	(622474, 131, '2014-04-01 01:22:25.000000', 'consum', 0.0214, 'lps'),
	(622475, 131, '2014-04-01 01:22:26.000000', 'consum', 0.0226, 'lps'),
	(622476, 131, '2014-04-01 01:22:27.000000', 'consum', 0.0218, 'lps'),
	(622477, 131, '2014-04-01 01:22:28.000000', 'consum', 0.0222, 'lps'),
	(622478, 131, '2014-04-01 01:22:29.000000', 'consum', 0.0227, 'lps'),
	(622479, 131, '2014-04-01 01:22:30.000000', 'consum', 0.0221, 'lps'),
	(622480, 131, '2014-04-01 01:22:31.000000', 'consum', 0.0212, 'lps'),
	(622481, 131, '2014-04-01 01:22:32.000000', 'consum', 0.0227, 'lps'),
	(622482, 131, '2014-04-01 01:22:33.000000', 'consum', 0.0229, 'lps'),
	(622483, 131, '2014-04-01 01:22:34.000000', 'consum', 0.0217, 'lps'),
	(622484, 131, '2014-04-01 01:22:35.000000', 'consum', 0.0229, 'lps'),
	(622485, 131, '2014-04-01 01:22:36.000000', 'consum', 0.0222, 'lps'),
	(622486, 131, '2014-04-01 01:22:37.000000', 'consum', 0.0214, 'lps'),
	(622487, 131, '2014-04-01 01:22:38.000000', 'consum', 0.0216, 'lps'),
	(622488, 131, '2014-04-01 01:22:39.000000', 'consum', 0.0228, 'lps'),
	(622489, 131, '2014-04-01 01:22:40.000000', 'consum', 0.0224, 'lps'),
	(622490, 131, '2014-04-01 01:22:41.000000', 'consum', 0.0226, 'lps'),
	(622491, 131, '2014-04-01 01:22:42.000000', 'consum', 0.0228, 'lps'),
	(622492, 131, '2014-04-01 01:22:43.000000', 'consum', 0.0213, 'lps'),
	(622493, 131, '2014-04-01 01:22:44.000000', 'consum', 0.0213, 'lps'),
	(622494, 131, '2014-04-01 01:22:45.000000', 'consum', 0.0215, 'lps'),
	(622495, 131, '2014-04-01 01:22:46.000000', 'consum', 0.0225, 'lps'),
	(622496, 131, '2014-04-01 01:22:47.000000', 'consum', 0.0213, 'lps'),
	(622497, 131, '2014-04-01 01:22:48.000000', 'consum', 0.0222, 'lps'),
	(622498, 131, '2014-04-01 01:22:49.000000', 'consum', 0.0218, 'lps'),
	(622499, 131, '2014-04-01 01:22:50.000000', 'consum', 0.0216, 'lps'),
	(622500, 131, '2014-04-01 01:22:51.000000', 'consum', 0.0218, 'lps'),
	(622501, 131, '2014-04-01 01:22:52.000000', 'consum', 0.0212, 'lps'),
	(622502, 131, '2014-04-01 01:22:53.000000', 'consum', 0.0214, 'lps'),
	(622503, 131, '2014-04-01 01:22:54.000000', 'consum', 0.0227, 'lps'),
	(622504, 131, '2014-04-01 01:22:55.000000', 'consum', 0.0224, 'lps'),
	(622505, 131, '2014-04-01 01:22:56.000000', 'consum', 0.0229, 'lps'),
	(622506, 131, '2014-04-01 01:22:57.000000', 'consum', 0.0225, 'lps'),
	(622507, 131, '2014-04-01 01:22:58.000000', 'consum', 0.0227, 'lps'),
	(622508, 131, '2014-04-01 01:22:59.000000', 'consum', 0.0211, 'lps'),
	(622509, 131, '2014-04-01 01:23:00.000000', 'consum', 0.0224, 'lps'),
	(622510, 131, '2014-04-01 01:23:01.000000', 'consum', 0.0216, 'lps'),
	(622511, 131, '2014-04-01 01:23:02.000000', 'consum', 0.0221, 'lps'),
	(622512, 131, '2014-04-01 01:23:03.000000', 'consum', 0.0225, 'lps'),
	(622513, 131, '2014-04-01 01:23:04.000000', 'consum', 0.0212, 'lps'),
	(622514, 131, '2014-04-01 01:23:05.000000', 'consum', 0.0217, 'lps'),
	(622515, 131, '2014-04-01 01:23:06.000000', 'consum', 0.0220, 'lps'),
	(622516, 131, '2014-04-01 01:23:07.000000', 'consum', 0.0221, 'lps'),
	(622517, 131, '2014-04-01 01:23:08.000000', 'consum', 0.0213, 'lps'),
	(622518, 131, '2014-04-01 01:23:09.000000', 'consum', 0.0213, 'lps'),
	(622519, 131, '2014-04-01 01:23:10.000000', 'consum', 0.0217, 'lps'),
	(622520, 131, '2014-04-01 01:23:11.000000', 'consum', 0.0215, 'lps'),
	(622521, 131, '2014-04-01 01:23:12.000000', 'consum', 0.0217, 'lps'),
	(622522, 131, '2014-04-01 01:23:13.000000', 'consum', 0.0229, 'lps'),
	(622523, 131, '2014-04-01 01:23:14.000000', 'consum', 0.0226, 'lps'),
	(622524, 131, '2014-04-01 01:23:15.000000', 'consum', 0.0215, 'lps'),
	(622525, 131, '2014-04-01 01:23:16.000000', 'consum', 0.0225, 'lps'),
	(622526, 131, '2014-04-01 01:23:17.000000', 'consum', 0.0210, 'lps'),
	(622527, 131, '2014-04-01 01:23:18.000000', 'consum', 0.0225, 'lps'),
	(622528, 131, '2014-04-01 01:23:19.000000', 'consum', 0.0224, 'lps'),
	(622529, 131, '2014-04-01 01:23:20.000000', 'consum', 0.0219, 'lps'),
	(622530, 131, '2014-04-01 01:23:21.000000', 'consum', 0.0213, 'lps'),
	(622531, 131, '2014-04-01 01:23:22.000000', 'consum', 0.0217, 'lps'),
	(622532, 131, '2014-04-01 01:23:23.000000', 'consum', 0.0218, 'lps'),
	(622533, 131, '2014-04-01 01:23:24.000000', 'consum', 0.0228, 'lps'),
	(622534, 131, '2014-04-01 01:23:25.000000', 'consum', 0.0219, 'lps'),
	(622535, 131, '2014-04-01 01:23:26.000000', 'consum', 0.0220, 'lps'),
	(622536, 131, '2014-04-01 01:23:27.000000', 'consum', 0.0212, 'lps'),
	(622537, 131, '2014-04-01 01:23:28.000000', 'consum', 0.0213, 'lps'),
	(622538, 131, '2014-04-01 01:23:29.000000', 'consum', 0.0219, 'lps'),
	(622539, 131, '2014-04-01 01:23:30.000000', 'consum', 0.0224, 'lps'),
	(622540, 131, '2014-04-01 01:23:31.000000', 'consum', 0.0215, 'lps'),
	(622541, 131, '2014-04-01 01:23:32.000000', 'consum', 0.0214, 'lps'),
	(622542, 131, '2014-04-01 01:23:33.000000', 'consum', 0.0217, 'lps'),
	(622543, 131, '2014-04-01 01:23:34.000000', 'consum', 0.0213, 'lps'),
	(622544, 131, '2014-04-01 01:23:35.000000', 'consum', 0.0222, 'lps'),
	(622545, 131, '2014-04-01 01:23:36.000000', 'consum', 0.0224, 'lps'),
	(622546, 131, '2014-04-01 01:23:37.000000', 'consum', 0.0222, 'lps'),
	(622547, 131, '2014-04-01 01:23:38.000000', 'consum', 0.0228, 'lps'),
	(622548, 131, '2014-04-01 01:23:39.000000', 'consum', 0.0225, 'lps'),
	(622549, 131, '2014-04-01 01:23:40.000000', 'consum', 0.0211, 'lps'),
	(622550, 131, '2014-04-01 01:23:41.000000', 'consum', 0.0213, 'lps'),
	(622551, 131, '2014-04-01 01:23:42.000000', 'consum', 0.0222, 'lps'),
	(622552, 131, '2014-04-01 01:23:43.000000', 'consum', 0.0222, 'lps'),
	(622553, 131, '2014-04-01 01:23:44.000000', 'consum', 0.0215, 'lps'),
	(622554, 131, '2014-04-01 01:23:45.000000', 'consum', 0.0218, 'lps'),
	(622555, 131, '2014-04-01 01:23:46.000000', 'consum', 0.0215, 'lps'),
	(622556, 131, '2014-04-01 01:23:47.000000', 'consum', 0.0212, 'lps'),
	(622557, 131, '2014-04-01 01:23:48.000000', 'consum', 0.0226, 'lps'),
	(622558, 131, '2014-04-01 01:23:49.000000', 'consum', 0.0226, 'lps'),
	(622559, 131, '2014-04-01 01:23:50.000000', 'consum', 0.0223, 'lps'),
	(622560, 131, '2014-04-01 01:23:51.000000', 'consum', 0.0225, 'lps'),
	(622561, 131, '2014-04-01 01:23:52.000000', 'consum', 0.0228, 'lps'),
	(622562, 131, '2014-04-01 01:23:53.000000', 'consum', 0.0213, 'lps'),
	(622563, 131, '2014-04-01 01:23:54.000000', 'consum', 0.0213, 'lps'),
	(622564, 131, '2014-04-01 01:23:55.000000', 'consum', 0.0219, 'lps'),
	(622565, 131, '2014-04-01 01:23:56.000000', 'consum', 0.0223, 'lps'),
	(622566, 131, '2014-04-01 01:23:57.000000', 'consum', 0.0210, 'lps'),
	(622567, 131, '2014-04-01 01:23:58.000000', 'consum', 0.0211, 'lps'),
	(622568, 131, '2014-04-01 01:23:59.000000', 'consum', 0.0216, 'lps'),
	(622569, 131, '2014-04-01 01:24:00.000000', 'consum', 0.0218, 'lps'),
	(622570, 131, '2014-04-01 01:24:01.000000', 'consum', 0.0213, 'lps'),
	(622571, 131, '2014-04-01 01:24:02.000000', 'consum', 0.0219, 'lps'),
	(622572, 131, '2014-04-01 01:24:03.000000', 'consum', 0.0228, 'lps'),
	(622573, 131, '2014-04-01 01:24:04.000000', 'consum', 0.0213, 'lps'),
	(622574, 131, '2014-04-01 01:24:05.000000', 'consum', 0.0212, 'lps'),
	(622575, 131, '2014-04-01 01:24:06.000000', 'consum', 0.0229, 'lps'),
	(622576, 131, '2014-04-01 01:24:07.000000', 'consum', 0.0223, 'lps'),
	(622577, 131, '2014-04-01 01:24:08.000000', 'consum', 0.0216, 'lps'),
	(622578, 131, '2014-04-01 01:24:09.000000', 'consum', 0.0224, 'lps'),
	(622579, 131, '2014-04-01 01:24:10.000000', 'consum', 0.0221, 'lps'),
	(622580, 131, '2014-04-01 01:24:11.000000', 'consum', 0.0224, 'lps'),
	(622581, 131, '2014-04-01 01:24:12.000000', 'consum', 0.0229, 'lps'),
	(622582, 131, '2014-04-01 01:24:13.000000', 'consum', 0.0223, 'lps'),
	(622583, 131, '2014-04-01 01:24:14.000000', 'consum', 0.0220, 'lps'),
	(622584, 131, '2014-04-01 01:24:15.000000', 'consum', 0.0220, 'lps'),
	(622585, 131, '2014-04-01 01:24:16.000000', 'consum', 0.0213, 'lps'),
	(622586, 131, '2014-04-01 01:24:17.000000', 'consum', 0.0212, 'lps'),
	(622587, 131, '2014-04-01 01:24:18.000000', 'consum', 0.0214, 'lps'),
	(622588, 131, '2014-04-01 01:24:19.000000', 'consum', 0.0223, 'lps'),
	(622589, 131, '2014-04-01 01:24:20.000000', 'consum', 0.0226, 'lps'),
	(622590, 131, '2014-04-01 01:24:21.000000', 'consum', 0.0228, 'lps'),
	(622591, 131, '2014-04-01 01:24:22.000000', 'consum', 0.0214, 'lps'),
	(622592, 131, '2014-04-01 01:24:23.000000', 'consum', 0.0218, 'lps'),
	(622593, 131, '2014-04-01 01:24:24.000000', 'consum', 0.0216, 'lps'),
	(622594, 131, '2014-04-01 01:24:25.000000', 'consum', 0.0216, 'lps'),
	(622595, 131, '2014-04-01 01:24:26.000000', 'consum', 0.0222, 'lps'),
	(622596, 131, '2014-04-01 01:24:27.000000', 'consum', 0.0215, 'lps'),
	(622597, 131, '2014-04-01 01:24:28.000000', 'consum', 0.0218, 'lps'),
	(622598, 131, '2014-04-01 01:24:29.000000', 'consum', 0.0216, 'lps'),
	(622599, 131, '2014-04-01 01:24:30.000000', 'consum', 0.0215, 'lps'),
	(622600, 131, '2014-04-01 01:24:31.000000', 'consum', 0.0219, 'lps'),
	(622601, 131, '2014-04-01 01:24:32.000000', 'consum', 0.0220, 'lps'),
	(622602, 131, '2014-04-01 01:24:33.000000', 'consum', 0.0215, 'lps'),
	(622603, 131, '2014-04-01 01:24:34.000000', 'consum', 0.0225, 'lps'),
	(622604, 131, '2014-04-01 01:24:35.000000', 'consum', 0.0210, 'lps'),
	(622605, 131, '2014-04-01 01:24:36.000000', 'consum', 0.0224, 'lps'),
	(622606, 131, '2014-04-01 01:24:37.000000', 'consum', 0.0223, 'lps'),
	(622607, 131, '2014-04-01 01:24:38.000000', 'consum', 0.0212, 'lps'),
	(622608, 131, '2014-04-01 01:24:39.000000', 'consum', 0.0224, 'lps'),
	(622609, 131, '2014-04-01 01:24:40.000000', 'consum', 0.0212, 'lps'),
	(622610, 131, '2014-04-01 01:24:41.000000', 'consum', 0.0221, 'lps'),
	(622611, 131, '2014-04-01 01:24:42.000000', 'consum', 0.0218, 'lps'),
	(622612, 131, '2014-04-01 01:24:43.000000', 'consum', 0.0219, 'lps'),
	(622613, 131, '2014-04-01 01:24:44.000000', 'consum', 0.0210, 'lps'),
	(622614, 131, '2014-04-01 01:24:45.000000', 'consum', 0.0222, 'lps'),
	(622615, 131, '2014-04-01 01:24:46.000000', 'consum', 0.0213, 'lps'),
	(622616, 131, '2014-04-01 01:24:47.000000', 'consum', 0.0227, 'lps'),
	(622617, 131, '2014-04-01 01:24:48.000000', 'consum', 0.0228, 'lps'),
	(622618, 131, '2014-04-01 01:24:49.000000', 'consum', 0.0211, 'lps'),
	(622619, 131, '2014-04-01 01:24:50.000000', 'consum', 0.0221, 'lps'),
	(622620, 131, '2014-04-01 01:24:51.000000', 'consum', 0.0220, 'lps'),
	(622621, 131, '2014-04-01 01:24:52.000000', 'consum', 0.0229, 'lps'),
	(622622, 131, '2014-04-01 01:24:53.000000', 'consum', 0.0214, 'lps'),
	(622623, 131, '2014-04-01 01:24:54.000000', 'consum', 0.0214, 'lps'),
	(622624, 131, '2014-04-01 01:24:55.000000', 'consum', 0.0219, 'lps'),
	(622625, 131, '2014-04-01 01:24:56.000000', 'consum', 0.0223, 'lps'),
	(622626, 131, '2014-04-01 01:24:57.000000', 'consum', 0.0228, 'lps'),
	(622627, 131, '2014-04-01 01:24:58.000000', 'consum', 0.0224, 'lps'),
	(622628, 131, '2014-04-01 01:24:59.000000', 'consum', 0.0224, 'lps'),
	(622629, 131, '2014-04-01 01:25:00.000000', 'consum', 0.0218, 'lps'),
	(622630, 131, '2014-04-01 01:25:01.000000', 'consum', 0.0228, 'lps'),
	(622631, 131, '2014-04-01 01:25:02.000000', 'consum', 0.0219, 'lps'),
	(622632, 132, '2015-01-01 00:00:00.000000', 'consum', 0.0271, 'lps'),
	(622633, 132, '2015-01-01 00:00:01.000000', 'consum', 0.0231, 'lps'),
	(622634, 132, '2015-01-01 00:00:02.000000', 'consum', 0.0214, 'lps'),
	(622635, 132, '2015-01-01 00:00:03.000000', 'consum', 0.0248, 'lps'),
	(622636, 132, '2015-01-01 00:00:04.000000', 'consum', 0.0229, 'lps'),
	(622637, 132, '2015-01-01 00:00:05.000000', 'consum', 0.0270, 'lps'),
	(622638, 132, '2015-01-01 00:00:06.000000', 'consum', 0.0211, 'lps'),
	(622639, 132, '2015-01-01 00:00:07.000000', 'consum', 0.0277, 'lps'),
	(622640, 132, '2015-01-01 00:00:08.000000', 'consum', 0.0219, 'lps'),
	(622641, 132, '2015-01-01 00:00:09.000000', 'consum', 0.0217, 'lps'),
	(622642, 132, '2015-01-01 00:00:10.000000', 'consum', 0.0220, 'lps'),
	(622643, 132, '2015-01-01 00:00:11.000000', 'consum', 0.0236, 'lps'),
	(622644, 132, '2015-01-01 00:00:12.000000', 'consum', 0.0233, 'lps'),
	(622645, 132, '2015-01-01 00:00:13.000000', 'consum', 0.0247, 'lps'),
	(622646, 132, '2015-01-01 00:00:14.000000', 'consum', 0.0243, 'lps'),
	(622647, 132, '2015-01-01 00:00:15.000000', 'consum', 0.0268, 'lps'),
	(622648, 132, '2015-01-01 00:00:16.000000', 'consum', 0.0236, 'lps'),
	(622649, 132, '2015-01-01 00:00:17.000000', 'consum', 0.0249, 'lps'),
	(622650, 132, '2015-01-01 00:00:18.000000', 'consum', 0.0245, 'lps'),
	(622651, 132, '2015-01-01 00:00:19.000000', 'consum', 0.0268, 'lps'),
	(622652, 132, '2015-01-01 00:00:20.000000', 'consum', 0.0234, 'lps'),
	(622653, 132, '2015-01-01 00:00:21.000000', 'consum', 0.0238, 'lps'),
	(622654, 132, '2015-01-01 00:00:22.000000', 'consum', 0.0278, 'lps'),
	(622655, 132, '2015-01-01 00:00:23.000000', 'consum', 0.0225, 'lps'),
	(622656, 132, '2015-01-01 00:00:24.000000', 'consum', 0.0244, 'lps'),
	(622657, 132, '2015-01-01 00:00:25.000000', 'consum', 0.0253, 'lps'),
	(622658, 132, '2015-01-01 00:00:26.000000', 'consum', 0.0245, 'lps'),
	(622659, 132, '2015-01-01 00:00:27.000000', 'consum', 0.0253, 'lps'),
	(622660, 132, '2015-01-01 00:00:28.000000', 'consum', 0.0241, 'lps'),
	(622661, 132, '2015-01-01 00:00:29.000000', 'consum', 0.0238, 'lps'),
	(622662, 132, '2015-01-01 00:00:30.000000', 'consum', 0.0256, 'lps'),
	(622663, 132, '2015-01-01 00:00:31.000000', 'consum', 0.0278, 'lps'),
	(622664, 132, '2015-01-01 00:00:32.000000', 'consum', 0.0247, 'lps'),
	(622665, 132, '2015-01-01 00:00:33.000000', 'consum', 0.0275, 'lps'),
	(622666, 132, '2015-01-01 00:00:34.000000', 'consum', 0.0261, 'lps'),
	(622667, 132, '2015-01-01 00:00:35.000000', 'consum', 0.0270, 'lps'),
	(622668, 132, '2015-01-01 00:00:36.000000', 'consum', 0.0277, 'lps'),
	(622669, 132, '2015-01-01 00:00:37.000000', 'consum', 0.0283, 'lps'),
	(622670, 132, '2015-01-01 00:00:38.000000', 'consum', 0.0215, 'lps'),
	(622671, 132, '2015-01-01 00:00:39.000000', 'consum', 0.0257, 'lps'),
	(622672, 132, '2015-01-01 00:00:40.000000', 'consum', 0.0268, 'lps'),
	(622673, 132, '2015-01-01 00:00:41.000000', 'consum', 0.0278, 'lps'),
	(622674, 132, '2015-01-01 00:00:42.000000', 'consum', 0.0215, 'lps'),
	(622675, 132, '2015-01-01 00:00:43.000000', 'consum', 0.0275, 'lps'),
	(622676, 132, '2015-01-01 00:00:44.000000', 'consum', 0.0278, 'lps'),
	(622677, 132, '2015-01-01 00:00:45.000000', 'consum', 0.0272, 'lps'),
	(622678, 132, '2015-01-01 00:00:46.000000', 'consum', 0.0237, 'lps'),
	(622679, 132, '2015-01-01 00:00:47.000000', 'consum', 0.0242, 'lps'),
	(622680, 132, '2015-01-01 00:00:48.000000', 'consum', 0.0287, 'lps'),
	(622681, 132, '2015-01-01 00:00:49.000000', 'consum', 0.0257, 'lps'),
	(622682, 132, '2015-01-01 00:00:50.000000', 'consum', 0.0214, 'lps'),
	(622683, 132, '2015-01-01 00:00:51.000000', 'consum', 0.0251, 'lps'),
	(622684, 132, '2015-01-01 00:00:52.000000', 'consum', 0.0241, 'lps'),
	(622685, 132, '2015-01-01 00:00:53.000000', 'consum', 0.0244, 'lps'),
	(622686, 132, '2015-01-01 00:00:54.000000', 'consum', 0.0287, 'lps'),
	(622687, 132, '2015-01-01 00:00:55.000000', 'consum', 0.0250, 'lps'),
	(622688, 132, '2015-01-01 00:00:56.000000', 'consum', 0.0261, 'lps'),
	(622689, 132, '2015-01-01 00:00:57.000000', 'consum', 0.0266, 'lps'),
	(622690, 132, '2015-01-01 00:00:58.000000', 'consum', 0.0257, 'lps'),
	(622691, 132, '2015-01-01 00:00:59.000000', 'consum', 0.0277, 'lps'),
	(622692, 132, '2015-01-01 00:01:00.000000', 'consum', 0.0243, 'lps'),
	(622693, 132, '2015-01-01 00:01:01.000000', 'consum', 0.0255, 'lps'),
	(622694, 132, '2015-01-01 00:01:02.000000', 'consum', 0.0254, 'lps'),
	(622695, 132, '2015-01-01 00:01:03.000000', 'consum', 0.0217, 'lps'),
	(622696, 132, '2015-01-01 00:01:04.000000', 'consum', 0.0275, 'lps'),
	(622697, 132, '2015-01-01 00:01:05.000000', 'consum', 0.0270, 'lps'),
	(622698, 132, '2015-01-01 00:01:06.000000', 'consum', 0.0237, 'lps'),
	(622699, 132, '2015-01-01 00:01:07.000000', 'consum', 0.0244, 'lps'),
	(622700, 132, '2015-01-01 00:01:08.000000', 'consum', 0.0218, 'lps'),
	(622701, 132, '2015-01-01 00:01:09.000000', 'consum', 0.0232, 'lps'),
	(622702, 132, '2015-01-01 00:01:10.000000', 'consum', 0.0215, 'lps'),
	(622703, 132, '2015-01-01 00:01:11.000000', 'consum', 0.0252, 'lps'),
	(622704, 132, '2015-01-01 00:01:12.000000', 'consum', 0.0242, 'lps'),
	(622705, 132, '2015-01-01 00:01:13.000000', 'consum', 0.0243, 'lps'),
	(622706, 132, '2015-01-01 00:01:14.000000', 'consum', 0.0282, 'lps'),
	(622707, 132, '2015-01-01 00:01:15.000000', 'consum', 0.0226, 'lps'),
	(622708, 132, '2015-01-01 00:01:16.000000', 'consum', 0.0237, 'lps'),
	(622709, 132, '2015-01-01 00:01:17.000000', 'consum', 0.0216, 'lps'),
	(622710, 132, '2015-01-01 00:01:18.000000', 'consum', 0.0240, 'lps'),
	(622711, 132, '2015-01-01 00:01:19.000000', 'consum', 0.0264, 'lps'),
	(622712, 132, '2015-01-01 00:01:20.000000', 'consum', 0.0227, 'lps'),
	(622713, 132, '2015-01-01 00:01:21.000000', 'consum', 0.0215, 'lps'),
	(622714, 132, '2015-01-01 00:01:22.000000', 'consum', 0.0265, 'lps'),
	(622715, 132, '2015-01-01 00:01:23.000000', 'consum', 0.0227, 'lps'),
	(622716, 132, '2015-01-01 00:01:24.000000', 'consum', 0.0213, 'lps'),
	(622717, 132, '2015-01-01 00:01:25.000000', 'consum', 0.0256, 'lps'),
	(622718, 132, '2015-01-01 00:01:26.000000', 'consum', 0.0268, 'lps'),
	(622719, 132, '2015-01-01 00:01:27.000000', 'consum', 0.0282, 'lps'),
	(622720, 132, '2015-01-01 00:01:28.000000', 'consum', 0.0234, 'lps'),
	(622721, 132, '2015-01-01 00:01:29.000000', 'consum', 0.0278, 'lps'),
	(622722, 132, '2015-01-01 00:01:30.000000', 'consum', 0.0236, 'lps'),
	(622723, 132, '2015-01-01 00:01:31.000000', 'consum', 0.0218, 'lps'),
	(622724, 132, '2015-01-01 00:01:32.000000', 'consum', 0.0252, 'lps'),
	(622725, 132, '2015-01-01 00:01:33.000000', 'consum', 0.0235, 'lps'),
	(622726, 132, '2015-01-01 00:01:34.000000', 'consum', 0.0289, 'lps'),
	(622727, 132, '2015-01-01 00:01:35.000000', 'consum', 0.0289, 'lps'),
	(622728, 132, '2015-01-01 00:01:36.000000', 'consum', 0.0289, 'lps'),
	(622729, 132, '2015-01-01 00:01:37.000000', 'consum', 0.0285, 'lps'),
	(622730, 132, '2015-01-01 00:01:38.000000', 'consum', 0.0266, 'lps'),
	(622731, 132, '2015-01-01 00:01:39.000000', 'consum', 0.0269, 'lps'),
	(622732, 132, '2015-01-01 00:01:40.000000', 'consum', 0.0256, 'lps'),
	(622733, 132, '2015-01-01 00:01:41.000000', 'consum', 0.0261, 'lps'),
	(622734, 132, '2015-01-01 00:01:42.000000', 'consum', 0.0248, 'lps'),
	(622735, 132, '2015-01-01 00:01:43.000000', 'consum', 0.0247, 'lps'),
	(622736, 132, '2015-01-01 00:01:44.000000', 'consum', 0.0280, 'lps'),
	(622737, 132, '2015-01-01 00:01:45.000000', 'consum', 0.0288, 'lps'),
	(622738, 132, '2015-01-01 00:01:46.000000', 'consum', 0.0227, 'lps'),
	(622739, 132, '2015-01-01 00:01:47.000000', 'consum', 0.0226, 'lps'),
	(622740, 132, '2015-01-01 00:01:48.000000', 'consum', 0.0239, 'lps'),
	(622741, 132, '2015-01-01 00:01:49.000000', 'consum', 0.0227, 'lps'),
	(622742, 132, '2015-01-01 00:01:50.000000', 'consum', 0.0210, 'lps'),
	(622743, 132, '2015-01-01 00:01:51.000000', 'consum', 0.0237, 'lps'),
	(622744, 132, '2015-01-01 00:01:52.000000', 'consum', 0.0268, 'lps'),
	(622745, 132, '2015-01-01 00:01:53.000000', 'consum', 0.0255, 'lps'),
	(622746, 132, '2015-01-01 00:01:54.000000', 'consum', 0.0264, 'lps'),
	(622747, 132, '2015-01-01 00:01:55.000000', 'consum', 0.0262, 'lps'),
	(622748, 132, '2015-01-01 00:01:56.000000', 'consum', 0.0227, 'lps'),
	(622749, 132, '2015-01-01 00:01:57.000000', 'consum', 0.0219, 'lps'),
	(622750, 132, '2015-01-01 00:01:58.000000', 'consum', 0.0289, 'lps'),
	(622751, 132, '2015-01-01 00:01:59.000000', 'consum', 0.0252, 'lps'),
	(622752, 132, '2015-01-01 00:02:00.000000', 'consum', 0.0267, 'lps'),
	(622753, 132, '2015-01-01 00:02:01.000000', 'consum', 0.0289, 'lps'),
	(622754, 132, '2015-01-01 00:02:02.000000', 'consum', 0.0270, 'lps'),
	(622755, 132, '2015-01-01 00:02:03.000000', 'consum', 0.0274, 'lps'),
	(622756, 132, '2015-01-01 00:02:04.000000', 'consum', 0.0268, 'lps'),
	(622757, 132, '2015-01-01 00:02:05.000000', 'consum', 0.0230, 'lps'),
	(622758, 132, '2015-01-01 00:02:06.000000', 'consum', 0.0218, 'lps'),
	(622759, 132, '2015-01-01 00:02:07.000000', 'consum', 0.0270, 'lps'),
	(622760, 132, '2015-01-01 00:02:08.000000', 'consum', 0.0245, 'lps'),
	(622761, 132, '2015-01-01 00:02:09.000000', 'consum', 0.0288, 'lps'),
	(622762, 132, '2015-01-01 00:02:10.000000', 'consum', 0.0250, 'lps'),
	(622763, 132, '2015-01-01 00:02:11.000000', 'consum', 0.0258, 'lps'),
	(622764, 132, '2015-01-01 00:02:12.000000', 'consum', 0.0250, 'lps'),
	(622765, 132, '2015-01-01 00:02:13.000000', 'consum', 0.0266, 'lps'),
	(622766, 132, '2015-01-01 00:02:14.000000', 'consum', 0.0288, 'lps'),
	(622767, 132, '2015-01-01 00:02:15.000000', 'consum', 0.0272, 'lps'),
	(622768, 132, '2015-01-01 00:02:16.000000', 'consum', 0.0287, 'lps'),
	(622769, 132, '2015-01-01 00:02:17.000000', 'consum', 0.0247, 'lps'),
	(622770, 132, '2015-01-01 00:02:18.000000', 'consum', 0.0247, 'lps'),
	(622771, 132, '2015-01-01 00:02:19.000000', 'consum', 0.0285, 'lps'),
	(622772, 132, '2015-01-01 00:02:20.000000', 'consum', 0.0229, 'lps'),
	(622773, 132, '2015-01-01 00:02:21.000000', 'consum', 0.0242, 'lps'),
	(622774, 132, '2015-01-01 00:02:22.000000', 'consum', 0.0235, 'lps'),
	(622775, 132, '2015-01-01 00:02:23.000000', 'consum', 0.0240, 'lps'),
	(622776, 132, '2015-01-01 00:02:24.000000', 'consum', 0.0286, 'lps'),
	(622777, 132, '2015-01-01 00:02:25.000000', 'consum', 0.0258, 'lps'),
	(622778, 132, '2015-01-01 00:02:26.000000', 'consum', 0.0220, 'lps'),
	(622779, 132, '2015-01-01 00:02:27.000000', 'consum', 0.0281, 'lps'),
	(622780, 132, '2015-01-01 00:02:28.000000', 'consum', 0.0212, 'lps'),
	(622781, 132, '2015-01-01 00:02:29.000000', 'consum', 0.0249, 'lps'),
	(622782, 132, '2015-01-01 00:02:30.000000', 'consum', 0.0237, 'lps'),
	(622783, 132, '2015-01-01 00:02:31.000000', 'consum', 0.0229, 'lps'),
	(622784, 132, '2015-01-01 00:02:32.000000', 'consum', 0.0225, 'lps'),
	(622785, 132, '2015-01-01 00:02:33.000000', 'consum', 0.0230, 'lps'),
	(622786, 132, '2015-01-01 00:02:34.000000', 'consum', 0.0265, 'lps'),
	(622787, 132, '2015-01-01 00:02:35.000000', 'consum', 0.0263, 'lps'),
	(622788, 132, '2015-01-01 00:02:36.000000', 'consum', 0.0228, 'lps'),
	(622789, 132, '2015-01-01 00:02:37.000000', 'consum', 0.0225, 'lps'),
	(622790, 132, '2015-01-01 00:02:38.000000', 'consum', 0.0230, 'lps'),
	(622791, 132, '2015-01-01 00:02:39.000000', 'consum', 0.0266, 'lps'),
	(622792, 132, '2015-01-01 00:02:40.000000', 'consum', 0.0270, 'lps'),
	(622793, 132, '2015-01-01 00:02:41.000000', 'consum', 0.0262, 'lps'),
	(622794, 132, '2015-01-01 00:02:42.000000', 'consum', 0.0289, 'lps'),
	(622795, 132, '2015-01-01 00:02:43.000000', 'consum', 0.0287, 'lps'),
	(622796, 132, '2015-01-01 00:02:44.000000', 'consum', 0.0279, 'lps'),
	(622797, 132, '2015-01-01 00:02:45.000000', 'consum', 0.0242, 'lps'),
	(622798, 132, '2015-01-01 00:02:46.000000', 'consum', 0.0245, 'lps'),
	(622799, 132, '2015-01-01 00:02:47.000000', 'consum', 0.0288, 'lps'),
	(622800, 132, '2015-01-01 00:02:48.000000', 'consum', 0.0255, 'lps'),
	(622801, 132, '2015-01-01 00:02:49.000000', 'consum', 0.0280, 'lps'),
	(622802, 132, '2015-01-01 00:02:50.000000', 'consum', 0.0267, 'lps'),
	(622803, 132, '2015-01-01 00:02:51.000000', 'consum', 0.0282, 'lps'),
	(622804, 132, '2015-01-01 00:02:52.000000', 'consum', 0.0239, 'lps'),
	(622805, 132, '2015-01-01 00:02:53.000000', 'consum', 0.0222, 'lps'),
	(622806, 132, '2015-01-01 00:02:54.000000', 'consum', 0.0265, 'lps'),
	(622807, 132, '2015-01-01 00:02:55.000000', 'consum', 0.0285, 'lps'),
	(622808, 132, '2015-01-01 00:02:56.000000', 'consum', 0.0258, 'lps'),
	(622809, 132, '2015-01-01 00:02:57.000000', 'consum', 0.0225, 'lps'),
	(622810, 132, '2015-01-01 00:02:58.000000', 'consum', 0.0221, 'lps'),
	(622811, 132, '2015-01-01 00:02:59.000000', 'consum', 0.0224, 'lps'),
	(622812, 132, '2015-01-01 00:03:00.000000', 'consum', 0.0246, 'lps'),
	(622813, 132, '2015-01-01 00:03:01.000000', 'consum', 0.0268, 'lps'),
	(622814, 132, '2015-01-01 00:03:02.000000', 'consum', 0.0232, 'lps'),
	(622815, 132, '2015-01-01 00:03:03.000000', 'consum', 0.0227, 'lps'),
	(622816, 132, '2015-01-01 00:03:04.000000', 'consum', 0.0228, 'lps'),
	(622817, 132, '2015-01-01 00:03:05.000000', 'consum', 0.0251, 'lps'),
	(622818, 132, '2015-01-01 00:03:06.000000', 'consum', 0.0279, 'lps'),
	(622819, 132, '2015-01-01 00:03:07.000000', 'consum', 0.0271, 'lps'),
	(622820, 132, '2015-01-01 00:03:08.000000', 'consum', 0.0229, 'lps'),
	(622821, 132, '2015-01-01 00:03:09.000000', 'consum', 0.0283, 'lps'),
	(622822, 132, '2015-01-01 00:03:10.000000', 'consum', 0.0274, 'lps'),
	(622823, 132, '2015-01-01 00:03:11.000000', 'consum', 0.0232, 'lps'),
	(622824, 132, '2015-01-01 00:03:12.000000', 'consum', 0.0210, 'lps'),
	(622825, 132, '2015-01-01 00:03:13.000000', 'consum', 0.0225, 'lps'),
	(622826, 132, '2015-01-01 00:03:14.000000', 'consum', 0.0288, 'lps'),
	(622827, 132, '2015-01-01 00:03:15.000000', 'consum', 0.0228, 'lps'),
	(622828, 132, '2015-01-01 00:03:16.000000', 'consum', 0.0229, 'lps'),
	(622829, 132, '2015-01-01 00:03:17.000000', 'consum', 0.0251, 'lps'),
	(622830, 132, '2015-01-01 00:03:18.000000', 'consum', 0.0278, 'lps'),
	(622831, 132, '2015-01-01 00:03:19.000000', 'consum', 0.0264, 'lps'),
	(622832, 132, '2015-01-01 00:03:20.000000', 'consum', 0.0279, 'lps'),
	(622833, 132, '2015-01-01 00:03:21.000000', 'consum', 0.0232, 'lps'),
	(622834, 132, '2015-01-01 00:03:22.000000', 'consum', 0.0276, 'lps'),
	(622835, 132, '2015-01-01 00:03:23.000000', 'consum', 0.0231, 'lps'),
	(622836, 132, '2015-01-01 00:03:24.000000', 'consum', 0.0277, 'lps'),
	(622837, 132, '2015-01-01 00:03:25.000000', 'consum', 0.0242, 'lps'),
	(622838, 132, '2015-01-01 00:03:26.000000', 'consum', 0.0252, 'lps'),
	(622839, 132, '2015-01-01 00:03:27.000000', 'consum', 0.0240, 'lps'),
	(622840, 132, '2015-01-01 00:03:28.000000', 'consum', 0.0235, 'lps'),
	(622841, 132, '2015-01-01 00:03:29.000000', 'consum', 0.0247, 'lps'),
	(622842, 132, '2015-01-01 00:03:30.000000', 'consum', 0.0237, 'lps'),
	(622843, 132, '2015-01-01 00:03:31.000000', 'consum', 0.0235, 'lps'),
	(622844, 132, '2015-01-01 00:03:32.000000', 'consum', 0.0254, 'lps'),
	(622845, 132, '2015-01-01 00:03:33.000000', 'consum', 0.0274, 'lps'),
	(622846, 132, '2015-01-01 00:03:34.000000', 'consum', 0.0238, 'lps'),
	(622847, 132, '2015-01-01 00:03:35.000000', 'consum', 0.0239, 'lps'),
	(622848, 132, '2015-01-01 00:03:36.000000', 'consum', 0.0271, 'lps'),
	(622849, 132, '2015-01-01 00:03:37.000000', 'consum', 0.0266, 'lps'),
	(622850, 132, '2015-01-01 00:03:38.000000', 'consum', 0.0228, 'lps'),
	(622851, 132, '2015-01-01 00:03:39.000000', 'consum', 0.0214, 'lps'),
	(622852, 132, '2015-01-01 00:03:40.000000', 'consum', 0.0257, 'lps'),
	(622853, 132, '2015-01-01 00:03:41.000000', 'consum', 0.0272, 'lps'),
	(622854, 132, '2015-01-01 00:03:42.000000', 'consum', 0.0216, 'lps'),
	(622855, 132, '2015-01-01 00:03:43.000000', 'consum', 0.0216, 'lps'),
	(622856, 132, '2015-01-01 00:03:44.000000', 'consum', 0.0223, 'lps'),
	(622857, 132, '2015-01-01 00:03:45.000000', 'consum', 0.0259, 'lps'),
	(622858, 132, '2015-01-01 00:03:46.000000', 'consum', 0.0254, 'lps'),
	(622859, 132, '2015-01-01 00:03:47.000000', 'consum', 0.0285, 'lps'),
	(622860, 132, '2015-01-01 00:03:48.000000', 'consum', 0.0289, 'lps'),
	(622861, 132, '2015-01-01 00:03:49.000000', 'consum', 0.0221, 'lps'),
	(622862, 132, '2015-01-01 00:03:50.000000', 'consum', 0.0269, 'lps'),
	(622863, 132, '2015-01-01 00:03:51.000000', 'consum', 0.0229, 'lps'),
	(622864, 132, '2015-01-01 00:03:52.000000', 'consum', 0.0290, 'lps'),
	(622865, 132, '2015-01-01 00:03:53.000000', 'consum', 0.0232, 'lps'),
	(622866, 132, '2015-01-01 00:03:54.000000', 'consum', 0.0243, 'lps'),
	(622867, 132, '2015-01-01 00:03:55.000000', 'consum', 0.0228, 'lps'),
	(622868, 132, '2015-01-01 00:03:56.000000', 'consum', 0.0280, 'lps'),
	(622869, 132, '2015-01-01 00:03:57.000000', 'consum', 0.0265, 'lps'),
	(622870, 132, '2015-01-01 00:03:58.000000', 'consum', 0.0278, 'lps'),
	(622871, 132, '2015-01-01 00:03:59.000000', 'consum', 0.0220, 'lps'),
	(622872, 132, '2015-01-01 00:04:00.000000', 'consum', 0.0220, 'lps'),
	(622873, 132, '2015-01-01 00:04:01.000000', 'consum', 0.0231, 'lps'),
	(622874, 132, '2015-01-01 00:04:02.000000', 'consum', 0.0284, 'lps'),
	(622875, 132, '2015-01-01 00:04:03.000000', 'consum', 0.0275, 'lps'),
	(622876, 132, '2015-01-01 00:04:04.000000', 'consum', 0.0232, 'lps'),
	(622877, 132, '2015-01-01 00:04:05.000000', 'consum', 0.0289, 'lps'),
	(622878, 132, '2015-01-01 00:04:06.000000', 'consum', 0.0216, 'lps'),
	(622879, 132, '2015-01-01 00:04:07.000000', 'consum', 0.0246, 'lps'),
	(622880, 132, '2015-01-01 00:04:08.000000', 'consum', 0.0211, 'lps'),
	(622881, 132, '2015-01-01 00:04:09.000000', 'consum', 0.0267, 'lps'),
	(622882, 132, '2015-01-01 00:04:10.000000', 'consum', 0.0250, 'lps'),
	(622883, 132, '2015-01-01 00:04:11.000000', 'consum', 0.0241, 'lps'),
	(622884, 132, '2015-01-01 00:04:12.000000', 'consum', 0.0245, 'lps'),
	(622885, 132, '2015-01-01 00:04:13.000000', 'consum', 0.0211, 'lps'),
	(622886, 132, '2015-01-01 00:04:14.000000', 'consum', 0.0273, 'lps'),
	(622887, 132, '2015-01-01 00:04:15.000000', 'consum', 0.0277, 'lps'),
	(622888, 132, '2015-01-01 00:04:16.000000', 'consum', 0.0279, 'lps'),
	(622889, 132, '2015-01-01 00:04:17.000000', 'consum', 0.0273, 'lps'),
	(622890, 132, '2015-01-01 00:04:18.000000', 'consum', 0.0239, 'lps'),
	(622891, 132, '2015-01-01 00:04:19.000000', 'consum', 0.0246, 'lps'),
	(622892, 132, '2015-01-01 00:04:20.000000', 'consum', 0.0222, 'lps'),
	(622893, 132, '2015-01-01 00:04:21.000000', 'consum', 0.0242, 'lps'),
	(622894, 132, '2015-01-01 00:04:22.000000', 'consum', 0.0255, 'lps'),
	(622895, 132, '2015-01-01 00:04:23.000000', 'consum', 0.0257, 'lps'),
	(622896, 132, '2015-01-01 00:04:24.000000', 'consum', 0.0232, 'lps'),
	(622897, 132, '2015-01-01 00:04:25.000000', 'consum', 0.0261, 'lps'),
	(622898, 132, '2015-01-01 00:04:26.000000', 'consum', 0.0238, 'lps'),
	(622899, 132, '2015-01-01 00:04:27.000000', 'consum', 0.0276, 'lps'),
	(622900, 132, '2015-01-01 00:04:28.000000', 'consum', 0.0215, 'lps'),
	(622901, 132, '2015-01-01 00:04:29.000000', 'consum', 0.0278, 'lps'),
	(622902, 132, '2015-01-01 00:04:30.000000', 'consum', 0.0214, 'lps'),
	(622903, 132, '2015-01-01 00:04:31.000000', 'consum', 0.0267, 'lps'),
	(622904, 132, '2015-01-01 00:04:32.000000', 'consum', 0.0242, 'lps'),
	(622905, 132, '2015-01-01 00:04:33.000000', 'consum', 0.0279, 'lps'),
	(622906, 132, '2015-01-01 00:04:34.000000', 'consum', 0.0219, 'lps'),
	(622907, 132, '2015-01-01 00:04:35.000000', 'consum', 0.0210, 'lps'),
	(622908, 132, '2015-01-01 00:04:36.000000', 'consum', 0.0266, 'lps'),
	(622909, 132, '2015-01-01 00:04:37.000000', 'consum', 0.0246, 'lps'),
	(622910, 132, '2015-01-01 00:04:38.000000', 'consum', 0.0223, 'lps'),
	(622911, 132, '2015-01-01 00:04:39.000000', 'consum', 0.0250, 'lps'),
	(622912, 132, '2015-01-01 00:04:40.000000', 'consum', 0.0288, 'lps'),
	(622913, 132, '2015-01-01 00:04:41.000000', 'consum', 0.0236, 'lps'),
	(622914, 132, '2015-01-01 00:04:42.000000', 'consum', 0.0271, 'lps'),
	(622915, 132, '2015-01-01 00:04:43.000000', 'consum', 0.0277, 'lps'),
	(622916, 132, '2015-01-01 00:04:44.000000', 'consum', 0.0278, 'lps'),
	(622917, 132, '2015-01-01 00:04:45.000000', 'consum', 0.0272, 'lps'),
	(622918, 132, '2015-01-01 00:04:46.000000', 'consum', 0.0233, 'lps'),
	(622919, 132, '2015-01-01 00:04:47.000000', 'consum', 0.0222, 'lps'),
	(622920, 132, '2015-01-01 00:04:48.000000', 'consum', 0.0281, 'lps'),
	(622921, 132, '2015-01-01 00:04:49.000000', 'consum', 0.0286, 'lps'),
	(622922, 132, '2015-01-01 00:04:50.000000', 'consum', 0.0215, 'lps'),
	(622923, 132, '2015-01-01 00:04:51.000000', 'consum', 0.0251, 'lps'),
	(622924, 132, '2015-01-01 00:04:52.000000', 'consum', 0.0237, 'lps'),
	(622925, 132, '2015-01-01 00:04:53.000000', 'consum', 0.0223, 'lps'),
	(622926, 132, '2015-01-01 00:04:54.000000', 'consum', 0.0278, 'lps'),
	(622927, 132, '2015-01-01 00:04:55.000000', 'consum', 0.0267, 'lps'),
	(622928, 132, '2015-01-01 00:04:56.000000', 'consum', 0.0290, 'lps'),
	(622929, 132, '2015-01-01 00:04:57.000000', 'consum', 0.0280, 'lps'),
	(622930, 132, '2015-01-01 00:04:58.000000', 'consum', 0.0240, 'lps'),
	(622931, 132, '2015-01-01 00:04:59.000000', 'consum', 0.0232, 'lps'),
	(622932, 132, '2015-01-01 00:05:00.000000', 'consum', 0.0228, 'lps'),
	(622933, 132, '2015-01-01 00:05:01.000000', 'consum', 0.0237, 'lps'),
	(622934, 132, '2015-01-01 00:05:02.000000', 'consum', 0.0210, 'lps'),
	(622935, 132, '2015-01-01 00:05:03.000000', 'consum', 0.0210, 'lps'),
	(622936, 132, '2015-01-01 00:05:04.000000', 'consum', 0.0290, 'lps'),
	(622937, 132, '2015-01-01 00:05:05.000000', 'consum', 0.0287, 'lps'),
	(622938, 132, '2015-01-01 00:05:06.000000', 'consum', 0.0275, 'lps'),
	(622939, 132, '2015-01-01 00:05:07.000000', 'consum', 0.0225, 'lps'),
	(622940, 132, '2015-01-01 00:05:08.000000', 'consum', 0.0253, 'lps'),
	(622941, 132, '2015-01-01 00:05:09.000000', 'consum', 0.0215, 'lps'),
	(622942, 132, '2015-01-01 00:05:10.000000', 'consum', 0.0272, 'lps'),
	(622943, 132, '2015-01-01 00:05:11.000000', 'consum', 0.0261, 'lps'),
	(622944, 132, '2015-01-01 00:05:12.000000', 'consum', 0.0282, 'lps'),
	(622945, 132, '2015-01-01 00:05:13.000000', 'consum', 0.0253, 'lps'),
	(622946, 132, '2015-01-01 00:05:14.000000', 'consum', 0.0210, 'lps'),
	(622947, 132, '2015-01-01 00:05:15.000000', 'consum', 0.0243, 'lps'),
	(622948, 132, '2015-01-01 00:05:16.000000', 'consum', 0.0213, 'lps'),
	(622949, 132, '2015-01-01 00:05:17.000000', 'consum', 0.0290, 'lps'),
	(622950, 132, '2015-01-01 00:05:18.000000', 'consum', 0.0275, 'lps'),
	(622951, 132, '2015-01-01 00:05:19.000000', 'consum', 0.0216, 'lps'),
	(622952, 132, '2015-01-01 00:05:20.000000', 'consum', 0.0290, 'lps'),
	(622953, 132, '2015-01-01 00:05:21.000000', 'consum', 0.0266, 'lps'),
	(622954, 132, '2015-01-01 00:05:22.000000', 'consum', 0.0252, 'lps'),
	(622955, 132, '2015-01-01 00:05:23.000000', 'consum', 0.0254, 'lps'),
	(622956, 132, '2015-01-01 00:05:24.000000', 'consum', 0.0221, 'lps'),
	(622957, 132, '2015-01-01 00:05:25.000000', 'consum', 0.0215, 'lps'),
	(622958, 132, '2015-01-01 00:05:26.000000', 'consum', 0.0282, 'lps'),
	(622959, 132, '2015-01-01 00:05:27.000000', 'consum', 0.0232, 'lps'),
	(622960, 132, '2015-01-01 00:05:28.000000', 'consum', 0.0269, 'lps'),
	(622961, 132, '2015-01-01 00:05:29.000000', 'consum', 0.0276, 'lps'),
	(622962, 132, '2015-01-01 00:05:30.000000', 'consum', 0.0281, 'lps'),
	(622963, 132, '2015-01-01 00:05:31.000000', 'consum', 0.0288, 'lps'),
	(622964, 132, '2015-01-01 00:05:32.000000', 'consum', 0.0224, 'lps'),
	(622965, 132, '2015-01-01 00:05:33.000000', 'consum', 0.0290, 'lps'),
	(622966, 132, '2015-01-01 00:05:34.000000', 'consum', 0.0243, 'lps'),
	(622967, 132, '2015-01-01 00:05:35.000000', 'consum', 0.0218, 'lps'),
	(622968, 132, '2015-01-01 00:05:36.000000', 'consum', 0.0234, 'lps'),
	(622969, 132, '2015-01-01 00:05:37.000000', 'consum', 0.0225, 'lps'),
	(622970, 132, '2015-01-01 00:05:38.000000', 'consum', 0.0211, 'lps'),
	(622971, 132, '2015-01-01 00:05:39.000000', 'consum', 0.0253, 'lps'),
	(622972, 132, '2015-01-01 00:05:40.000000', 'consum', 0.0261, 'lps'),
	(622973, 132, '2015-01-01 00:05:41.000000', 'consum', 0.0257, 'lps'),
	(622974, 132, '2015-01-01 00:05:42.000000', 'consum', 0.0290, 'lps'),
	(622975, 132, '2015-01-01 00:05:43.000000', 'consum', 0.0227, 'lps'),
	(622976, 132, '2015-01-01 00:05:44.000000', 'consum', 0.0218, 'lps'),
	(622977, 132, '2015-01-01 00:05:45.000000', 'consum', 0.0279, 'lps'),
	(622978, 132, '2015-01-01 00:05:46.000000', 'consum', 0.0210, 'lps'),
	(622979, 132, '2015-01-01 00:05:47.000000', 'consum', 0.0246, 'lps'),
	(622980, 132, '2015-01-01 00:05:48.000000', 'consum', 0.0228, 'lps'),
	(622981, 132, '2015-01-01 00:05:49.000000', 'consum', 0.0273, 'lps'),
	(622982, 132, '2015-01-01 00:05:50.000000', 'consum', 0.0227, 'lps'),
	(622983, 132, '2015-01-01 00:05:51.000000', 'consum', 0.0269, 'lps'),
	(622984, 132, '2015-01-01 00:05:52.000000', 'consum', 0.0212, 'lps'),
	(622985, 132, '2015-01-01 00:05:53.000000', 'consum', 0.0287, 'lps'),
	(622986, 132, '2015-01-01 00:05:54.000000', 'consum', 0.0263, 'lps'),
	(622987, 132, '2015-01-01 00:05:55.000000', 'consum', 0.0247, 'lps'),
	(622988, 132, '2015-01-01 00:05:56.000000', 'consum', 0.0235, 'lps'),
	(622989, 132, '2015-01-01 00:05:57.000000', 'consum', 0.0225, 'lps'),
	(622990, 132, '2015-01-01 00:05:58.000000', 'consum', 0.0211, 'lps'),
	(622991, 132, '2015-01-01 00:05:59.000000', 'consum', 0.0252, 'lps'),
	(622992, 132, '2015-01-01 00:06:00.000000', 'consum', 0.0255, 'lps'),
	(622993, 132, '2015-01-01 00:06:01.000000', 'consum', 0.0230, 'lps'),
	(622994, 132, '2015-01-01 00:06:02.000000', 'consum', 0.0255, 'lps'),
	(622995, 132, '2015-01-01 00:06:03.000000', 'consum', 0.0212, 'lps'),
	(622996, 132, '2015-01-01 00:06:04.000000', 'consum', 0.0248, 'lps'),
	(622997, 132, '2015-01-01 00:06:05.000000', 'consum', 0.0232, 'lps'),
	(622998, 132, '2015-01-01 00:06:06.000000', 'consum', 0.0287, 'lps'),
	(622999, 132, '2015-01-01 00:06:07.000000', 'consum', 0.0288, 'lps'),
	(623000, 132, '2015-01-01 00:06:08.000000', 'consum', 0.0288, 'lps'),
	(623001, 132, '2015-01-01 00:06:09.000000', 'consum', 0.0286, 'lps'),
	(623002, 132, '2015-01-01 00:06:10.000000', 'consum', 0.0275, 'lps'),
	(623003, 132, '2015-01-01 00:06:11.000000', 'consum', 0.0225, 'lps'),
	(623004, 132, '2015-01-01 00:06:12.000000', 'consum', 0.0252, 'lps'),
	(623005, 132, '2015-01-01 00:06:13.000000', 'consum', 0.0214, 'lps'),
	(623006, 132, '2015-01-01 00:06:14.000000', 'consum', 0.0269, 'lps'),
	(623007, 132, '2015-01-01 00:06:15.000000', 'consum', 0.0249, 'lps'),
	(623008, 132, '2015-01-01 00:06:16.000000', 'consum', 0.0230, 'lps'),
	(623009, 132, '2015-01-01 00:06:17.000000', 'consum', 0.0273, 'lps'),
	(623010, 132, '2015-01-01 00:06:18.000000', 'consum', 0.0222, 'lps'),
	(623011, 132, '2015-01-01 00:06:19.000000', 'consum', 0.0246, 'lps'),
	(623012, 132, '2015-01-01 00:06:20.000000', 'consum', 0.0271, 'lps'),
	(623013, 132, '2015-01-01 00:06:21.000000', 'consum', 0.0246, 'lps'),
	(623014, 132, '2015-01-01 00:06:22.000000', 'consum', 0.0290, 'lps'),
	(623015, 132, '2015-01-01 00:06:23.000000', 'consum', 0.0257, 'lps'),
	(623016, 132, '2015-01-01 00:06:24.000000', 'consum', 0.0286, 'lps'),
	(623017, 132, '2015-01-01 00:06:25.000000', 'consum', 0.0288, 'lps'),
	(623018, 132, '2015-01-01 00:06:26.000000', 'consum', 0.0212, 'lps'),
	(623019, 132, '2015-01-01 00:06:27.000000', 'consum', 0.0228, 'lps'),
	(623020, 132, '2015-01-01 00:06:28.000000', 'consum', 0.0215, 'lps'),
	(623021, 132, '2015-01-01 00:06:29.000000', 'consum', 0.0263, 'lps'),
	(623022, 132, '2015-01-01 00:06:30.000000', 'consum', 0.0218, 'lps'),
	(623023, 132, '2015-01-01 00:06:31.000000', 'consum', 0.0253, 'lps'),
	(623024, 132, '2015-01-01 00:06:32.000000', 'consum', 0.0239, 'lps'),
	(623025, 132, '2015-01-01 00:06:33.000000', 'consum', 0.0228, 'lps'),
	(623026, 132, '2015-01-01 00:06:34.000000', 'consum', 0.0213, 'lps'),
	(623027, 132, '2015-01-01 00:06:35.000000', 'consum', 0.0254, 'lps'),
	(623028, 132, '2015-01-01 00:06:36.000000', 'consum', 0.0259, 'lps'),
	(623029, 132, '2015-01-01 00:06:37.000000', 'consum', 0.0241, 'lps'),
	(623030, 132, '2015-01-01 00:06:38.000000', 'consum', 0.0219, 'lps'),
	(623031, 132, '2015-01-01 00:06:39.000000', 'consum', 0.0246, 'lps'),
	(623032, 132, '2015-01-01 00:06:40.000000', 'consum', 0.0279, 'lps'),
	(623033, 132, '2015-01-01 00:06:41.000000', 'consum', 0.0287, 'lps'),
	(623034, 132, '2015-01-01 00:06:42.000000', 'consum', 0.0226, 'lps'),
	(623035, 132, '2015-01-01 00:06:43.000000', 'consum', 0.0222, 'lps'),
	(623036, 132, '2015-01-01 00:06:44.000000', 'consum', 0.0223, 'lps'),
	(623037, 132, '2015-01-01 00:06:45.000000', 'consum', 0.0239, 'lps'),
	(623038, 132, '2015-01-01 00:06:46.000000', 'consum', 0.0238, 'lps'),
	(623039, 132, '2015-01-01 00:06:47.000000', 'consum', 0.0260, 'lps'),
	(623040, 132, '2015-01-01 00:06:48.000000', 'consum', 0.0214, 'lps'),
	(623041, 132, '2015-01-01 00:06:49.000000', 'consum', 0.0245, 'lps'),
	(623042, 132, '2015-01-01 00:06:50.000000', 'consum', 0.0290, 'lps'),
	(623043, 132, '2015-01-01 00:06:51.000000', 'consum', 0.0266, 'lps'),
	(623044, 132, '2015-01-01 00:06:52.000000', 'consum', 0.0247, 'lps'),
	(623045, 132, '2015-01-01 00:06:53.000000', 'consum', 0.0228, 'lps'),
	(623046, 132, '2015-01-01 00:06:54.000000', 'consum', 0.0271, 'lps'),
	(623047, 132, '2015-01-01 00:06:55.000000', 'consum', 0.0217, 'lps'),
	(623048, 132, '2015-01-01 00:06:56.000000', 'consum', 0.0225, 'lps'),
	(623049, 132, '2015-01-01 00:06:57.000000', 'consum', 0.0266, 'lps'),
	(623050, 132, '2015-01-01 00:06:58.000000', 'consum', 0.0283, 'lps'),
	(623051, 132, '2015-01-01 00:06:59.000000', 'consum', 0.0246, 'lps'),
	(623052, 132, '2015-01-01 00:07:00.000000', 'consum', 0.0252, 'lps'),
	(623053, 132, '2015-01-01 00:07:01.000000', 'consum', 0.0232, 'lps'),
	(623054, 132, '2015-01-01 00:07:02.000000', 'consum', 0.0275, 'lps'),
	(623055, 132, '2015-01-01 00:07:03.000000', 'consum', 0.0228, 'lps'),
	(623056, 132, '2015-01-01 00:07:04.000000', 'consum', 0.0267, 'lps'),
	(623057, 132, '2015-01-01 00:07:05.000000', 'consum', 0.0281, 'lps'),
	(623058, 132, '2015-01-01 00:07:06.000000', 'consum', 0.0230, 'lps'),
	(623059, 132, '2015-01-01 00:07:07.000000', 'consum', 0.0262, 'lps'),
	(623060, 132, '2015-01-01 00:07:08.000000', 'consum', 0.0245, 'lps'),
	(623061, 132, '2015-01-01 00:07:09.000000', 'consum', 0.0232, 'lps'),
	(623062, 132, '2015-01-01 00:07:10.000000', 'consum', 0.0215, 'lps'),
	(623063, 132, '2015-01-01 00:07:11.000000', 'consum', 0.0251, 'lps'),
	(623064, 132, '2015-01-01 00:07:12.000000', 'consum', 0.0238, 'lps'),
	(623065, 132, '2015-01-01 00:07:13.000000', 'consum', 0.0228, 'lps'),
	(623066, 132, '2015-01-01 00:07:14.000000', 'consum', 0.0217, 'lps'),
	(623067, 132, '2015-01-01 00:07:15.000000', 'consum', 0.0274, 'lps'),
	(623068, 132, '2015-01-01 00:07:16.000000', 'consum', 0.0265, 'lps'),
	(623069, 132, '2015-01-01 00:07:17.000000', 'consum', 0.0214, 'lps'),
	(623070, 132, '2015-01-01 00:07:18.000000', 'consum', 0.0226, 'lps'),
	(623071, 132, '2015-01-01 00:07:19.000000', 'consum', 0.0278, 'lps'),
	(623072, 132, '2015-01-01 00:07:20.000000', 'consum', 0.0262, 'lps'),
	(623073, 132, '2015-01-01 00:07:21.000000', 'consum', 0.0266, 'lps'),
	(623074, 132, '2015-01-01 00:07:22.000000', 'consum', 0.0253, 'lps'),
	(623075, 132, '2015-01-01 00:07:23.000000', 'consum', 0.0256, 'lps'),
	(623076, 132, '2015-01-01 00:07:24.000000', 'consum', 0.0230, 'lps'),
	(623077, 132, '2015-01-01 00:07:25.000000', 'consum', 0.0253, 'lps'),
	(623078, 132, '2015-01-01 00:07:26.000000', 'consum', 0.0284, 'lps'),
	(623079, 132, '2015-01-01 00:07:27.000000', 'consum', 0.0290, 'lps'),
	(623080, 132, '2015-01-01 00:07:28.000000', 'consum', 0.0228, 'lps'),
	(623081, 132, '2015-01-01 00:07:29.000000', 'consum', 0.0220, 'lps'),
	(623082, 132, '2015-01-01 00:07:30.000000', 'consum', 0.0289, 'lps'),
	(623083, 132, '2015-01-01 00:07:31.000000', 'consum', 0.0249, 'lps'),
	(623084, 132, '2015-01-01 00:07:32.000000', 'consum', 0.0253, 'lps'),
	(623085, 132, '2015-01-01 00:07:33.000000', 'consum', 0.0227, 'lps'),
	(623086, 132, '2015-01-01 00:07:34.000000', 'consum', 0.0246, 'lps'),
	(623087, 132, '2015-01-01 00:07:35.000000', 'consum', 0.0258, 'lps'),
	(623088, 132, '2015-01-01 00:07:36.000000', 'consum', 0.0264, 'lps'),
	(623089, 132, '2015-01-01 00:07:37.000000', 'consum', 0.0253, 'lps'),
	(623090, 132, '2015-01-01 00:07:38.000000', 'consum', 0.0266, 'lps'),
	(623091, 132, '2015-01-01 00:07:39.000000', 'consum', 0.0281, 'lps'),
	(623092, 132, '2015-01-01 00:07:40.000000', 'consum', 0.0235, 'lps'),
	(623093, 132, '2015-01-01 00:07:41.000000', 'consum', 0.0285, 'lps'),
	(623094, 132, '2015-01-01 00:07:42.000000', 'consum', 0.0266, 'lps'),
	(623095, 132, '2015-01-01 00:07:43.000000', 'consum', 0.0264, 'lps'),
	(623096, 132, '2015-01-01 00:07:44.000000', 'consum', 0.0234, 'lps'),
	(623097, 132, '2015-01-01 00:07:45.000000', 'consum', 0.0250, 'lps'),
	(623098, 132, '2015-01-01 00:07:46.000000', 'consum', 0.0255, 'lps'),
	(623099, 132, '2015-01-01 00:07:47.000000', 'consum', 0.0235, 'lps'),
	(623100, 132, '2015-01-01 00:07:48.000000', 'consum', 0.0282, 'lps'),
	(623101, 132, '2015-01-01 00:07:49.000000', 'consum', 0.0253, 'lps'),
	(623102, 132, '2015-01-01 00:07:50.000000', 'consum', 0.0211, 'lps'),
	(623103, 132, '2015-01-01 00:07:51.000000', 'consum', 0.0246, 'lps'),
	(623104, 132, '2015-01-01 00:07:52.000000', 'consum', 0.0228, 'lps'),
	(623105, 132, '2015-01-01 00:07:53.000000', 'consum', 0.0270, 'lps'),
	(623106, 132, '2015-01-01 00:07:54.000000', 'consum', 0.0217, 'lps'),
	(623107, 132, '2015-01-01 00:07:55.000000', 'consum', 0.0227, 'lps'),
	(623108, 132, '2015-01-01 00:07:56.000000', 'consum', 0.0274, 'lps'),
	(623109, 132, '2015-01-01 00:07:57.000000', 'consum', 0.0236, 'lps'),
	(623110, 132, '2015-01-01 00:07:58.000000', 'consum', 0.0232, 'lps'),
	(623111, 132, '2015-01-01 00:07:59.000000', 'consum', 0.0239, 'lps'),
	(623112, 132, '2015-01-01 00:08:00.000000', 'consum', 0.0210, 'lps'),
	(623113, 132, '2015-01-01 00:08:01.000000', 'consum', 0.0286, 'lps'),
	(623114, 132, '2015-01-01 00:08:02.000000', 'consum', 0.0267, 'lps'),
	(623115, 132, '2015-01-01 00:08:03.000000', 'consum', 0.0266, 'lps'),
	(623116, 132, '2015-01-01 00:08:04.000000', 'consum', 0.0239, 'lps'),
	(623117, 132, '2015-01-01 00:08:05.000000', 'consum', 0.0270, 'lps'),
	(623118, 132, '2015-01-01 00:08:06.000000', 'consum', 0.0261, 'lps'),
	(623119, 132, '2015-01-01 00:08:07.000000', 'consum', 0.0286, 'lps'),
	(623120, 132, '2015-01-01 00:08:08.000000', 'consum', 0.0275, 'lps'),
	(623121, 132, '2015-01-01 00:08:09.000000', 'consum', 0.0228, 'lps'),
	(623122, 132, '2015-01-01 00:08:10.000000', 'consum', 0.0268, 'lps'),
	(623123, 132, '2015-01-01 00:08:11.000000', 'consum', 0.0282, 'lps'),
	(623124, 132, '2015-01-01 00:08:12.000000', 'consum', 0.0236, 'lps'),
	(623125, 132, '2015-01-01 00:08:13.000000', 'consum', 0.0284, 'lps'),
	(623126, 132, '2015-01-01 00:08:14.000000', 'consum', 0.0262, 'lps'),
	(623127, 132, '2015-01-01 00:08:15.000000', 'consum', 0.0247, 'lps'),
	(623128, 132, '2015-01-01 00:08:16.000000', 'consum', 0.0241, 'lps'),
	(623129, 132, '2015-01-01 00:08:17.000000', 'consum', 0.0254, 'lps'),
	(623130, 132, '2015-01-01 00:08:18.000000', 'consum', 0.0256, 'lps'),
	(623131, 132, '2015-01-01 00:08:19.000000', 'consum', 0.0226, 'lps'),
	(623132, 132, '2015-01-01 00:08:20.000000', 'consum', 0.0237, 'lps'),
	(623133, 132, '2015-01-01 00:08:21.000000', 'consum', 0.0213, 'lps'),
	(623134, 132, '2015-01-01 00:08:22.000000', 'consum', 0.0226, 'lps'),
	(623135, 132, '2015-01-01 00:08:23.000000', 'consum', 0.0283, 'lps'),
	(623136, 132, '2015-01-01 00:08:24.000000', 'consum', 0.0282, 'lps'),
	(623137, 132, '2015-01-01 00:08:25.000000', 'consum', 0.0271, 'lps'),
	(623138, 132, '2015-01-01 00:08:26.000000', 'consum', 0.0219, 'lps'),
	(623139, 132, '2015-01-01 00:08:27.000000', 'consum', 0.0233, 'lps'),
	(623140, 132, '2015-01-01 00:08:28.000000', 'consum', 0.0219, 'lps'),
	(623141, 132, '2015-01-01 00:08:29.000000', 'consum', 0.0269, 'lps'),
	(623142, 132, '2015-01-01 00:08:30.000000', 'consum', 0.0235, 'lps'),
	(623143, 132, '2015-01-01 00:08:31.000000', 'consum', 0.0241, 'lps'),
	(623144, 132, '2015-01-01 00:08:32.000000', 'consum', 0.0289, 'lps'),
	(623145, 132, '2015-01-01 00:08:33.000000', 'consum', 0.0271, 'lps'),
	(623146, 132, '2015-01-01 00:08:34.000000', 'consum', 0.0277, 'lps'),
	(623147, 132, '2015-01-01 00:08:35.000000', 'consum', 0.0284, 'lps'),
	(623148, 132, '2015-01-01 00:08:36.000000', 'consum', 0.0216, 'lps'),
	(623149, 132, '2015-01-01 00:08:37.000000', 'consum', 0.0260, 'lps'),
	(623150, 132, '2015-01-01 00:08:38.000000', 'consum', 0.0281, 'lps'),
	(623151, 132, '2015-01-01 00:08:39.000000', 'consum', 0.0252, 'lps'),
	(623152, 132, '2015-01-01 00:08:40.000000', 'consum', 0.0289, 'lps'),
	(623153, 132, '2015-01-01 00:08:41.000000', 'consum', 0.0238, 'lps'),
	(623154, 132, '2015-01-01 00:08:42.000000', 'consum', 0.0275, 'lps'),
	(623155, 132, '2015-01-01 00:08:43.000000', 'consum', 0.0289, 'lps'),
	(623156, 132, '2015-01-01 00:08:44.000000', 'consum', 0.0247, 'lps'),
	(623157, 132, '2015-01-01 00:08:45.000000', 'consum', 0.0242, 'lps'),
	(623158, 132, '2015-01-01 00:08:46.000000', 'consum', 0.0260, 'lps'),
	(623159, 132, '2015-01-01 00:08:47.000000', 'consum', 0.0281, 'lps'),
	(623160, 132, '2015-01-01 00:08:48.000000', 'consum', 0.0255, 'lps'),
	(623161, 132, '2015-01-01 00:08:49.000000', 'consum', 0.0222, 'lps'),
	(623162, 132, '2015-01-01 00:08:50.000000', 'consum', 0.0217, 'lps'),
	(623163, 132, '2015-01-01 00:08:51.000000', 'consum', 0.0210, 'lps'),
	(623164, 132, '2015-01-01 00:08:52.000000', 'consum', 0.0268, 'lps'),
	(623165, 132, '2015-01-01 00:08:53.000000', 'consum', 0.0259, 'lps'),
	(623166, 132, '2015-01-01 00:08:54.000000', 'consum', 0.0282, 'lps'),
	(623167, 132, '2015-01-01 00:08:55.000000', 'consum', 0.0261, 'lps'),
	(623168, 132, '2015-01-01 00:08:56.000000', 'consum', 0.0250, 'lps'),
	(623169, 132, '2015-01-01 00:08:57.000000', 'consum', 0.0256, 'lps'),
	(623170, 132, '2015-01-01 00:08:58.000000', 'consum', 0.0242, 'lps'),
	(623171, 132, '2015-01-01 00:08:59.000000', 'consum', 0.0231, 'lps'),
	(623172, 132, '2015-01-01 00:09:00.000000', 'consum', 0.0220, 'lps'),
	(623173, 132, '2015-01-01 00:09:01.000000', 'consum', 0.0280, 'lps'),
	(623174, 132, '2015-01-01 00:09:02.000000', 'consum', 0.0287, 'lps'),
	(623175, 132, '2015-01-01 00:09:03.000000', 'consum', 0.0221, 'lps'),
	(623176, 132, '2015-01-01 00:09:04.000000', 'consum', 0.0279, 'lps'),
	(623177, 132, '2015-01-01 00:09:05.000000', 'consum', 0.0281, 'lps'),
	(623178, 132, '2015-01-01 00:09:06.000000', 'consum', 0.0276, 'lps'),
	(623179, 132, '2015-01-01 00:09:07.000000', 'consum', 0.0248, 'lps'),
	(623180, 132, '2015-01-01 00:09:08.000000', 'consum', 0.0285, 'lps'),
	(623181, 132, '2015-01-01 00:09:09.000000', 'consum', 0.0225, 'lps'),
	(623182, 132, '2015-01-01 00:09:10.000000', 'consum', 0.0225, 'lps'),
	(623183, 132, '2015-01-01 00:09:11.000000', 'consum', 0.0241, 'lps'),
	(623184, 132, '2015-01-01 00:09:12.000000', 'consum', 0.0236, 'lps'),
	(623185, 132, '2015-01-01 00:09:13.000000', 'consum', 0.0251, 'lps'),
	(623186, 132, '2015-01-01 00:09:14.000000', 'consum', 0.0257, 'lps'),
	(623187, 132, '2015-01-01 00:09:15.000000', 'consum', 0.0238, 'lps'),
	(623188, 132, '2015-01-01 00:09:16.000000', 'consum', 0.0212, 'lps'),
	(623189, 132, '2015-01-01 00:09:17.000000', 'consum', 0.0216, 'lps'),
	(623190, 132, '2015-01-01 00:09:18.000000', 'consum', 0.0237, 'lps'),
	(623191, 132, '2015-01-01 00:09:19.000000', 'consum', 0.0246, 'lps'),
	(623192, 132, '2015-01-01 00:09:20.000000', 'consum', 0.0227, 'lps'),
	(623193, 132, '2015-01-01 00:09:21.000000', 'consum', 0.0268, 'lps'),
	(623194, 132, '2015-01-01 00:09:22.000000', 'consum', 0.0289, 'lps'),
	(623195, 132, '2015-01-01 00:09:23.000000', 'consum', 0.0268, 'lps'),
	(623196, 132, '2015-01-01 00:09:24.000000', 'consum', 0.0262, 'lps'),
	(623197, 132, '2015-01-01 00:09:25.000000', 'consum', 0.0218, 'lps'),
	(623198, 132, '2015-01-01 00:09:26.000000', 'consum', 0.0256, 'lps'),
	(623199, 132, '2015-01-01 00:09:27.000000', 'consum', 0.0252, 'lps'),
	(623200, 132, '2015-01-01 00:09:28.000000', 'consum', 0.0286, 'lps'),
	(623201, 132, '2015-01-01 00:09:29.000000', 'consum', 0.0221, 'lps'),
	(623202, 132, '2015-01-01 00:09:30.000000', 'consum', 0.0281, 'lps'),
	(623203, 132, '2015-01-01 00:09:31.000000', 'consum', 0.0288, 'lps'),
	(623204, 132, '2015-01-01 00:09:32.000000', 'consum', 0.0228, 'lps'),
	(623205, 132, '2015-01-01 00:09:33.000000', 'consum', 0.0227, 'lps'),
	(623206, 132, '2015-01-01 00:09:34.000000', 'consum', 0.0243, 'lps'),
	(623207, 132, '2015-01-01 00:09:35.000000', 'consum', 0.0242, 'lps'),
	(623208, 132, '2015-01-01 00:09:36.000000', 'consum', 0.0270, 'lps'),
	(623209, 132, '2015-01-01 00:09:37.000000', 'consum', 0.0256, 'lps'),
	(623210, 132, '2015-01-01 00:09:38.000000', 'consum', 0.0258, 'lps'),
	(623211, 132, '2015-01-01 00:09:39.000000', 'consum', 0.0232, 'lps'),
	(623212, 132, '2015-01-01 00:09:40.000000', 'consum', 0.0260, 'lps'),
	(623213, 132, '2015-01-01 00:09:41.000000', 'consum', 0.0229, 'lps'),
	(623214, 132, '2015-01-01 00:09:42.000000', 'consum', 0.0237, 'lps'),
	(623215, 132, '2015-01-01 00:09:43.000000', 'consum', 0.0289, 'lps'),
	(623216, 132, '2015-01-01 00:09:44.000000', 'consum', 0.0283, 'lps'),
	(623217, 132, '2015-01-01 00:09:45.000000', 'consum', 0.0256, 'lps'),
	(623218, 132, '2015-01-01 00:09:46.000000', 'consum', 0.0222, 'lps'),
	(623219, 132, '2015-01-01 00:09:47.000000', 'consum', 0.0215, 'lps'),
	(623220, 132, '2015-01-01 00:09:48.000000', 'consum', 0.0279, 'lps'),
	(623221, 132, '2015-01-01 00:09:49.000000', 'consum', 0.0216, 'lps'),
	(623222, 132, '2015-01-01 00:09:50.000000', 'consum', 0.0277, 'lps'),
	(623223, 132, '2015-01-01 00:09:51.000000', 'consum', 0.0284, 'lps'),
	(623224, 132, '2015-01-01 00:09:52.000000', 'consum', 0.0219, 'lps'),
	(623225, 132, '2015-01-01 00:09:53.000000', 'consum', 0.0277, 'lps'),
	(623226, 132, '2015-01-01 00:09:54.000000', 'consum', 0.0275, 'lps'),
	(623227, 132, '2015-01-01 00:09:55.000000', 'consum', 0.0252, 'lps'),
	(623228, 132, '2015-01-01 00:09:56.000000', 'consum', 0.0226, 'lps'),
	(623229, 132, '2015-01-01 00:09:57.000000', 'consum', 0.0245, 'lps'),
	(623230, 132, '2015-01-01 00:09:58.000000', 'consum', 0.0258, 'lps'),
	(623231, 132, '2015-01-01 00:09:59.000000', 'consum', 0.0263, 'lps'),
	(623232, 132, '2015-01-01 00:10:00.000000', 'consum', 0.0251, 'lps'),
	(623233, 132, '2015-01-01 00:10:01.000000', 'consum', 0.0258, 'lps'),
	(623234, 132, '2015-01-01 00:10:02.000000', 'consum', 0.0246, 'lps'),
	(623235, 132, '2015-01-01 00:10:03.000000', 'consum', 0.0245, 'lps'),
	(623236, 132, '2015-01-01 00:10:04.000000', 'consum', 0.0280, 'lps'),
	(623237, 132, '2015-01-01 00:10:05.000000', 'consum', 0.0212, 'lps'),
	(623238, 132, '2015-01-01 00:10:06.000000', 'consum', 0.0254, 'lps'),
	(623239, 132, '2015-01-01 00:10:07.000000', 'consum', 0.0263, 'lps'),
	(623240, 132, '2015-01-01 00:10:08.000000', 'consum', 0.0260, 'lps'),
	(623241, 132, '2015-01-01 00:10:09.000000', 'consum', 0.0220, 'lps'),
	(623242, 132, '2015-01-01 00:10:10.000000', 'consum', 0.0274, 'lps'),
	(623243, 132, '2015-01-01 00:10:11.000000', 'consum', 0.0256, 'lps'),
	(623244, 132, '2015-01-01 00:10:12.000000', 'consum', 0.0250, 'lps'),
	(623245, 132, '2015-01-01 00:10:13.000000', 'consum', 0.0273, 'lps'),
	(623246, 132, '2015-01-01 00:10:14.000000', 'consum', 0.0244, 'lps'),
	(623247, 132, '2015-01-01 00:10:15.000000', 'consum', 0.0271, 'lps'),
	(623248, 132, '2015-01-01 00:10:16.000000', 'consum', 0.0253, 'lps'),
	(623249, 132, '2015-01-01 00:10:17.000000', 'consum', 0.0242, 'lps'),
	(623250, 132, '2015-01-01 00:10:18.000000', 'consum', 0.0242, 'lps'),
	(623251, 132, '2015-01-01 00:10:19.000000', 'consum', 0.0276, 'lps'),
	(623252, 132, '2015-01-01 00:10:20.000000', 'consum', 0.0281, 'lps'),
	(623253, 132, '2015-01-01 00:10:21.000000', 'consum', 0.0286, 'lps'),
	(623254, 132, '2015-01-01 00:10:22.000000', 'consum', 0.0216, 'lps'),
	(623255, 132, '2015-01-01 00:10:23.000000', 'consum', 0.0254, 'lps'),
	(623256, 132, '2015-01-01 00:10:24.000000', 'consum', 0.0251, 'lps'),
	(623257, 132, '2015-01-01 00:10:25.000000', 'consum', 0.0283, 'lps'),
	(623258, 132, '2015-01-01 00:10:26.000000', 'consum', 0.0290, 'lps'),
	(623259, 132, '2015-01-01 00:10:27.000000', 'consum', 0.0230, 'lps'),
	(623260, 132, '2015-01-01 00:10:28.000000', 'consum', 0.0231, 'lps'),
	(623261, 132, '2015-01-01 00:10:29.000000', 'consum', 0.0259, 'lps'),
	(623262, 132, '2015-01-01 00:10:30.000000', 'consum', 0.0228, 'lps'),
	(623263, 132, '2015-01-01 00:10:31.000000', 'consum', 0.0235, 'lps'),
	(623264, 132, '2015-01-01 00:10:32.000000', 'consum', 0.0282, 'lps'),
	(623265, 132, '2015-01-01 00:10:33.000000', 'consum', 0.0254, 'lps'),
	(623266, 132, '2015-01-01 00:10:34.000000', 'consum', 0.0213, 'lps'),
	(623267, 132, '2015-01-01 00:10:35.000000', 'consum', 0.0256, 'lps'),
	(623268, 132, '2015-01-01 00:10:36.000000', 'consum', 0.0268, 'lps'),
	(623269, 132, '2015-01-01 00:10:37.000000', 'consum', 0.0285, 'lps'),
	(623270, 132, '2015-01-01 00:10:38.000000', 'consum', 0.0246, 'lps'),
	(623271, 132, '2015-01-01 00:10:39.000000', 'consum', 0.0246, 'lps'),
	(623272, 132, '2015-01-01 00:10:40.000000', 'consum', 0.0282, 'lps'),
	(623273, 132, '2015-01-01 00:10:41.000000', 'consum', 0.0221, 'lps'),
	(623274, 132, '2015-01-01 00:10:42.000000', 'consum', 0.0212, 'lps'),
	(623275, 132, '2015-01-01 00:10:43.000000', 'consum', 0.0269, 'lps'),
	(623276, 132, '2015-01-01 00:10:44.000000', 'consum', 0.0255, 'lps'),
	(623277, 132, '2015-01-01 00:10:45.000000', 'consum', 0.0260, 'lps'),
	(623278, 132, '2015-01-01 00:10:46.000000', 'consum', 0.0242, 'lps'),
	(623279, 132, '2015-01-01 00:10:47.000000', 'consum', 0.0221, 'lps'),
	(623280, 132, '2015-01-01 00:10:48.000000', 'consum', 0.0251, 'lps'),
	(623281, 132, '2015-01-01 00:10:49.000000', 'consum', 0.0221, 'lps'),
	(623282, 132, '2015-01-01 00:10:50.000000', 'consum', 0.0221, 'lps'),
	(623283, 132, '2015-01-01 00:10:51.000000', 'consum', 0.0235, 'lps'),
	(623284, 132, '2015-01-01 00:10:52.000000', 'consum', 0.0223, 'lps'),
	(623285, 132, '2015-01-01 00:10:53.000000', 'consum', 0.0279, 'lps'),
	(623286, 132, '2015-01-01 00:10:54.000000', 'consum', 0.0276, 'lps'),
	(623287, 132, '2015-01-01 00:10:55.000000', 'consum', 0.0251, 'lps'),
	(623288, 132, '2015-01-01 00:10:56.000000', 'consum', 0.0216, 'lps'),
	(623289, 132, '2015-01-01 00:10:57.000000', 'consum', 0.0282, 'lps'),
	(623290, 132, '2015-01-01 00:10:58.000000', 'consum', 0.0228, 'lps'),
	(623291, 132, '2015-01-01 00:10:59.000000', 'consum', 0.0246, 'lps'),
	(623292, 132, '2015-01-01 00:11:00.000000', 'consum', 0.0255, 'lps'),
	(623293, 132, '2015-01-01 00:11:01.000000', 'consum', 0.0245, 'lps'),
	(623294, 132, '2015-01-01 00:11:02.000000', 'consum', 0.0253, 'lps'),
	(623295, 132, '2015-01-01 00:11:03.000000', 'consum', 0.0238, 'lps'),
	(623296, 132, '2015-01-01 00:11:04.000000', 'consum', 0.0222, 'lps'),
	(623297, 132, '2015-01-01 00:11:05.000000', 'consum', 0.0268, 'lps'),
	(623298, 132, '2015-01-01 00:11:06.000000', 'consum', 0.0219, 'lps'),
	(623299, 132, '2015-01-01 00:11:07.000000', 'consum', 0.0247, 'lps'),
	(623300, 132, '2015-01-01 00:11:08.000000', 'consum', 0.0285, 'lps'),
	(623301, 132, '2015-01-01 00:11:09.000000', 'consum', 0.0230, 'lps'),
	(623302, 132, '2015-01-01 00:11:10.000000', 'consum', 0.0250, 'lps'),
	(623303, 132, '2015-01-01 00:11:11.000000', 'consum', 0.0268, 'lps'),
	(623304, 132, '2015-01-01 00:11:12.000000', 'consum', 0.0218, 'lps'),
	(623305, 132, '2015-01-01 00:11:13.000000', 'consum', 0.0239, 'lps'),
	(623306, 132, '2015-01-01 00:11:14.000000', 'consum', 0.0249, 'lps'),
	(623307, 132, '2015-01-01 00:11:15.000000', 'consum', 0.0238, 'lps'),
	(623308, 132, '2015-01-01 00:11:16.000000', 'consum', 0.0233, 'lps'),
	(623309, 132, '2015-01-01 00:11:17.000000', 'consum', 0.0244, 'lps'),
	(623310, 132, '2015-01-01 00:11:18.000000', 'consum', 0.0230, 'lps'),
	(623311, 132, '2015-01-01 00:11:19.000000', 'consum', 0.0288, 'lps'),
	(623312, 132, '2015-01-01 00:11:20.000000', 'consum', 0.0218, 'lps'),
	(623313, 132, '2015-01-01 00:11:21.000000', 'consum', 0.0260, 'lps'),
	(623314, 132, '2015-01-01 00:11:22.000000', 'consum', 0.0273, 'lps'),
	(623315, 132, '2015-01-01 00:11:23.000000', 'consum', 0.0216, 'lps'),
	(623316, 132, '2015-01-01 00:11:24.000000', 'consum', 0.0213, 'lps'),
	(623317, 132, '2015-01-01 00:11:25.000000', 'consum', 0.0286, 'lps'),
	(623318, 132, '2015-01-01 00:11:26.000000', 'consum', 0.0258, 'lps'),
	(623319, 132, '2015-01-01 00:11:27.000000', 'consum', 0.0222, 'lps'),
	(623320, 132, '2015-01-01 00:11:28.000000', 'consum', 0.0210, 'lps'),
	(623321, 132, '2015-01-01 00:11:29.000000', 'consum', 0.0252, 'lps'),
	(623322, 132, '2015-01-01 00:11:30.000000', 'consum', 0.0261, 'lps'),
	(623323, 132, '2015-01-01 00:11:31.000000', 'consum', 0.0257, 'lps'),
	(623324, 132, '2015-01-01 00:11:32.000000', 'consum', 0.0211, 'lps'),
	(623325, 132, '2015-01-01 00:11:33.000000', 'consum', 0.0237, 'lps'),
	(623326, 132, '2015-01-01 00:11:34.000000', 'consum', 0.0263, 'lps'),
	(623327, 132, '2015-01-01 00:11:35.000000', 'consum', 0.0230, 'lps'),
	(623328, 132, '2015-01-01 00:11:36.000000', 'consum', 0.0232, 'lps'),
	(623329, 132, '2015-01-01 00:11:37.000000', 'consum', 0.0262, 'lps'),
	(623330, 132, '2015-01-01 00:11:38.000000', 'consum', 0.0243, 'lps'),
	(623331, 132, '2015-01-01 00:11:39.000000', 'consum', 0.0217, 'lps'),
	(623332, 132, '2015-01-01 00:11:40.000000', 'consum', 0.0230, 'lps'),
	(623333, 132, '2015-01-01 00:11:41.000000', 'consum', 0.0287, 'lps'),
	(623334, 132, '2015-01-01 00:11:42.000000', 'consum', 0.0211, 'lps'),
	(623335, 132, '2015-01-01 00:11:43.000000', 'consum', 0.0228, 'lps'),
	(623336, 132, '2015-01-01 00:11:44.000000', 'consum', 0.0217, 'lps'),
	(623337, 132, '2015-01-01 00:11:45.000000', 'consum', 0.0273, 'lps'),
	(623338, 132, '2015-01-01 00:11:46.000000', 'consum', 0.0262, 'lps'),
	(623339, 132, '2015-01-01 00:11:47.000000', 'consum', 0.0282, 'lps'),
	(623340, 132, '2015-01-01 00:11:48.000000', 'consum', 0.0251, 'lps'),
	(623341, 132, '2015-01-01 00:11:49.000000', 'consum', 0.0279, 'lps'),
	(623342, 132, '2015-01-01 00:11:50.000000', 'consum', 0.0273, 'lps'),
	(623343, 132, '2015-01-01 00:11:51.000000', 'consum', 0.0238, 'lps'),
	(623344, 132, '2015-01-01 00:11:52.000000', 'consum', 0.0242, 'lps'),
	(623345, 132, '2015-01-01 00:11:53.000000', 'consum', 0.0287, 'lps'),
	(623346, 132, '2015-01-01 00:11:54.000000', 'consum', 0.0254, 'lps'),
	(623347, 132, '2015-01-01 00:11:55.000000', 'consum', 0.0282, 'lps'),
	(623348, 132, '2015-01-01 00:11:56.000000', 'consum', 0.0278, 'lps'),
	(623349, 132, '2015-01-01 00:11:57.000000', 'consum', 0.0253, 'lps'),
	(623350, 132, '2015-01-01 00:11:58.000000', 'consum', 0.0223, 'lps'),
	(623351, 132, '2015-01-01 00:11:59.000000', 'consum', 0.0227, 'lps'),
	(623352, 132, '2015-01-01 00:12:00.000000', 'consum', 0.0256, 'lps'),
	(623353, 132, '2015-01-01 00:12:01.000000', 'consum', 0.0226, 'lps'),
	(623354, 132, '2015-01-01 00:12:02.000000', 'consum', 0.0233, 'lps'),
	(623355, 132, '2015-01-01 00:12:03.000000', 'consum', 0.0277, 'lps'),
	(623356, 132, '2015-01-01 00:12:04.000000', 'consum', 0.0236, 'lps'),
	(623357, 132, '2015-01-01 00:12:05.000000', 'consum', 0.0218, 'lps'),
	(623358, 132, '2015-01-01 00:12:06.000000', 'consum', 0.0255, 'lps'),
	(623359, 132, '2015-01-01 00:12:07.000000', 'consum', 0.0249, 'lps'),
	(623360, 132, '2015-01-01 00:12:08.000000', 'consum', 0.0269, 'lps'),
	(623361, 132, '2015-01-01 00:12:09.000000', 'consum', 0.0227, 'lps'),
	(623362, 132, '2015-01-01 00:12:10.000000', 'consum', 0.0280, 'lps'),
	(623363, 132, '2015-01-01 00:12:11.000000', 'consum', 0.0267, 'lps'),
	(623364, 132, '2015-01-01 00:12:12.000000', 'consum', 0.0286, 'lps'),
	(623365, 132, '2015-01-01 00:12:13.000000', 'consum', 0.0258, 'lps'),
	(623366, 132, '2015-01-01 00:12:14.000000', 'consum', 0.0222, 'lps'),
	(623367, 132, '2015-01-01 00:12:15.000000', 'consum', 0.0287, 'lps'),
	(623368, 132, '2015-01-01 00:12:16.000000', 'consum', 0.0236, 'lps'),
	(623369, 132, '2015-01-01 00:12:17.000000', 'consum', 0.0273, 'lps'),
	(623370, 132, '2015-01-01 00:12:18.000000', 'consum', 0.0285, 'lps'),
	(623371, 132, '2015-01-01 00:12:19.000000', 'consum', 0.0234, 'lps'),
	(623372, 132, '2015-01-01 00:12:20.000000', 'consum', 0.0270, 'lps'),
	(623373, 132, '2015-01-01 00:12:21.000000', 'consum', 0.0274, 'lps'),
	(623374, 132, '2015-01-01 00:12:22.000000', 'consum', 0.0269, 'lps'),
	(623375, 132, '2015-01-01 00:12:23.000000', 'consum', 0.0235, 'lps'),
	(623376, 132, '2015-01-01 00:12:24.000000', 'consum', 0.0237, 'lps'),
	(623377, 132, '2015-01-01 00:12:25.000000', 'consum', 0.0270, 'lps'),
	(623378, 132, '2015-01-01 00:12:26.000000', 'consum', 0.0269, 'lps'),
	(623379, 132, '2015-01-01 00:12:27.000000', 'consum', 0.0245, 'lps'),
	(623380, 132, '2015-01-01 00:12:28.000000', 'consum', 0.0288, 'lps'),
	(623381, 132, '2015-01-01 00:12:29.000000', 'consum', 0.0252, 'lps'),
	(623382, 132, '2015-01-01 00:12:30.000000', 'consum', 0.0270, 'lps'),
	(623383, 132, '2015-01-01 00:12:31.000000', 'consum', 0.0220, 'lps'),
	(623384, 132, '2015-01-01 00:12:32.000000', 'consum', 0.0244, 'lps'),
	(623385, 132, '2015-01-01 00:12:33.000000', 'consum', 0.0270, 'lps'),
	(623386, 132, '2015-01-01 00:12:34.000000', 'consum', 0.0244, 'lps'),
	(623387, 132, '2015-01-01 00:12:35.000000', 'consum', 0.0283, 'lps'),
	(623388, 132, '2015-01-01 00:12:36.000000', 'consum', 0.0231, 'lps'),
	(623389, 132, '2015-01-01 00:12:37.000000', 'consum', 0.0260, 'lps'),
	(623390, 132, '2015-01-01 00:12:38.000000', 'consum', 0.0234, 'lps'),
	(623391, 132, '2015-01-01 00:12:39.000000', 'consum', 0.0260, 'lps'),
	(623392, 132, '2015-01-01 00:12:40.000000', 'consum', 0.0229, 'lps'),
	(623393, 132, '2015-01-01 00:12:41.000000', 'consum', 0.0235, 'lps'),
	(623394, 132, '2015-01-01 00:12:42.000000', 'consum', 0.0280, 'lps'),
	(623395, 132, '2015-01-01 00:12:43.000000', 'consum', 0.0244, 'lps'),
	(623396, 132, '2015-01-01 00:12:44.000000', 'consum', 0.0249, 'lps'),
	(623397, 132, '2015-01-01 00:12:45.000000', 'consum', 0.0224, 'lps'),
	(623398, 132, '2015-01-01 00:12:46.000000', 'consum', 0.0243, 'lps'),
	(623399, 132, '2015-01-01 00:12:47.000000', 'consum', 0.0252, 'lps'),
	(623400, 132, '2015-01-01 00:12:48.000000', 'consum', 0.0241, 'lps'),
	(623401, 132, '2015-01-01 00:12:49.000000', 'consum', 0.0239, 'lps'),
	(623402, 132, '2015-01-01 00:12:50.000000', 'consum', 0.0261, 'lps'),
	(623403, 132, '2015-01-01 00:12:51.000000', 'consum', 0.0219, 'lps'),
	(623404, 132, '2015-01-01 00:12:52.000000', 'consum', 0.0262, 'lps'),
	(623405, 132, '2015-01-01 00:12:53.000000', 'consum', 0.0284, 'lps'),
	(623406, 132, '2015-01-01 00:12:54.000000', 'consum', 0.0262, 'lps'),
	(623407, 132, '2015-01-01 00:12:55.000000', 'consum', 0.0248, 'lps'),
	(623408, 132, '2015-01-01 00:12:56.000000', 'consum', 0.0245, 'lps'),
	(623409, 132, '2015-01-01 00:12:57.000000', 'consum', 0.0272, 'lps'),
	(623410, 132, '2015-01-01 00:12:58.000000', 'consum', 0.0254, 'lps'),
	(623411, 132, '2015-01-01 00:12:59.000000', 'consum', 0.0245, 'lps'),
	(623412, 132, '2015-01-01 00:13:00.000000', 'consum', 0.0252, 'lps'),
	(623413, 132, '2015-01-01 00:13:01.000000', 'consum', 0.0236, 'lps'),
	(623414, 132, '2015-01-01 00:13:02.000000', 'consum', 0.0214, 'lps'),
	(623415, 132, '2015-01-01 00:13:03.000000', 'consum', 0.0232, 'lps'),
	(623416, 132, '2015-01-01 00:13:04.000000', 'consum', 0.0227, 'lps'),
	(623417, 132, '2015-01-01 00:13:05.000000', 'consum', 0.0231, 'lps'),
	(623418, 132, '2015-01-01 00:13:06.000000', 'consum', 0.0265, 'lps'),
	(623419, 132, '2015-01-01 00:13:07.000000', 'consum', 0.0262, 'lps'),
	(623420, 132, '2015-01-01 00:13:08.000000', 'consum', 0.0222, 'lps'),
	(623421, 132, '2015-01-01 00:13:09.000000', 'consum', 0.0278, 'lps'),
	(623422, 132, '2015-01-01 00:13:10.000000', 'consum', 0.0273, 'lps'),
	(623423, 132, '2015-01-01 00:13:11.000000', 'consum', 0.0237, 'lps'),
	(623424, 132, '2015-01-01 00:13:12.000000', 'consum', 0.0241, 'lps'),
	(623425, 132, '2015-01-01 00:13:13.000000', 'consum', 0.0283, 'lps'),
	(623426, 132, '2015-01-01 00:13:14.000000', 'consum', 0.0241, 'lps'),
	(623427, 132, '2015-01-01 00:13:15.000000', 'consum', 0.0227, 'lps'),
	(623428, 132, '2015-01-01 00:13:16.000000', 'consum', 0.0285, 'lps'),
	(623429, 132, '2015-01-01 00:13:17.000000', 'consum', 0.0210, 'lps'),
	(623430, 132, '2015-01-01 00:13:18.000000', 'consum', 0.0229, 'lps'),
	(623431, 132, '2015-01-01 00:13:19.000000', 'consum', 0.0222, 'lps'),
	(623432, 132, '2015-01-01 00:13:20.000000', 'consum', 0.0215, 'lps'),
	(623433, 132, '2015-01-01 00:13:21.000000', 'consum', 0.0281, 'lps'),
	(623434, 132, '2015-01-01 00:13:22.000000', 'consum', 0.0225, 'lps'),
	(623435, 132, '2015-01-01 00:13:23.000000', 'consum', 0.0235, 'lps'),
	(623436, 132, '2015-01-01 00:13:24.000000', 'consum', 0.0211, 'lps'),
	(623437, 132, '2015-01-01 00:13:25.000000', 'consum', 0.0221, 'lps'),
	(623438, 132, '2015-01-01 00:13:26.000000', 'consum', 0.0262, 'lps'),
	(623439, 132, '2015-01-01 00:13:27.000000', 'consum', 0.0277, 'lps'),
	(623440, 132, '2015-01-01 00:13:28.000000', 'consum', 0.0225, 'lps'),
	(623441, 132, '2015-01-01 00:13:29.000000', 'consum', 0.0248, 'lps'),
	(623442, 132, '2015-01-01 00:13:30.000000', 'consum', 0.0272, 'lps'),
	(623443, 132, '2015-01-01 00:13:31.000000', 'consum', 0.0247, 'lps'),
	(623444, 132, '2015-01-01 00:13:32.000000', 'consum', 0.0289, 'lps'),
	(623445, 132, '2015-01-01 00:13:33.000000', 'consum', 0.0254, 'lps'),
	(623446, 132, '2015-01-01 00:13:34.000000', 'consum', 0.0273, 'lps'),
	(623447, 132, '2015-01-01 00:13:35.000000', 'consum', 0.0230, 'lps'),
	(623448, 132, '2015-01-01 00:13:36.000000', 'consum', 0.0286, 'lps'),
	(623449, 132, '2015-01-01 00:13:37.000000', 'consum', 0.0286, 'lps'),
	(623450, 132, '2015-01-01 00:13:38.000000', 'consum', 0.0284, 'lps'),
	(623451, 132, '2015-01-01 00:13:39.000000', 'consum', 0.0270, 'lps'),
	(623452, 132, '2015-01-01 00:13:40.000000', 'consum', 0.0287, 'lps'),
	(623453, 132, '2015-01-01 00:13:41.000000', 'consum', 0.0256, 'lps'),
	(623454, 132, '2015-01-01 00:13:42.000000', 'consum', 0.0288, 'lps'),
	(623455, 132, '2015-01-01 00:13:43.000000', 'consum', 0.0221, 'lps'),
	(623456, 132, '2015-01-01 00:13:44.000000', 'consum', 0.0275, 'lps'),
	(623457, 132, '2015-01-01 00:13:45.000000', 'consum', 0.0258, 'lps'),
	(623458, 132, '2015-01-01 00:13:46.000000', 'consum', 0.0255, 'lps'),
	(623459, 132, '2015-01-01 00:13:47.000000', 'consum', 0.0212, 'lps'),
	(623460, 132, '2015-01-01 00:13:48.000000', 'consum', 0.0247, 'lps'),
	(623461, 132, '2015-01-01 00:13:49.000000', 'consum', 0.0228, 'lps'),
	(623462, 132, '2015-01-01 00:13:50.000000', 'consum', 0.0269, 'lps'),
	(623463, 132, '2015-01-01 00:13:51.000000', 'consum', 0.0289, 'lps'),
	(623464, 132, '2015-01-01 00:13:52.000000', 'consum', 0.0267, 'lps'),
	(623465, 132, '2015-01-01 00:13:53.000000', 'consum', 0.0259, 'lps'),
	(623466, 132, '2015-01-01 00:13:54.000000', 'consum', 0.0285, 'lps'),
	(623467, 132, '2015-01-01 00:13:55.000000', 'consum', 0.0275, 'lps'),
	(623468, 132, '2015-01-01 00:13:56.000000', 'consum', 0.0229, 'lps'),
	(623469, 132, '2015-01-01 00:13:57.000000', 'consum', 0.0275, 'lps'),
	(623470, 132, '2015-01-01 00:13:58.000000', 'consum', 0.0236, 'lps'),
	(623471, 132, '2015-01-01 00:13:59.000000', 'consum', 0.0226, 'lps'),
	(623472, 132, '2015-01-01 00:14:00.000000', 'consum', 0.0211, 'lps'),
	(623473, 132, '2015-01-01 00:14:01.000000', 'consum', 0.0250, 'lps'),
	(623474, 132, '2015-01-01 00:14:02.000000', 'consum', 0.0244, 'lps'),
	(623475, 132, '2015-01-01 00:14:03.000000', 'consum', 0.0263, 'lps'),
	(623476, 132, '2015-01-01 00:14:04.000000', 'consum', 0.0211, 'lps'),
	(623477, 132, '2015-01-01 00:14:05.000000', 'consum', 0.0218, 'lps'),
	(623478, 132, '2015-01-01 00:14:06.000000', 'consum', 0.0246, 'lps'),
	(623479, 132, '2015-01-01 00:14:07.000000', 'consum', 0.0285, 'lps'),
	(623480, 132, '2015-01-01 00:14:08.000000', 'consum', 0.0236, 'lps'),
	(623481, 132, '2015-01-01 00:14:09.000000', 'consum', 0.0276, 'lps'),
	(623482, 132, '2015-01-01 00:14:10.000000', 'consum', 0.0221, 'lps'),
	(623483, 132, '2015-01-01 00:14:11.000000', 'consum', 0.0231, 'lps'),
	(623484, 132, '2015-01-01 00:14:12.000000', 'consum', 0.0281, 'lps'),
	(623485, 132, '2015-01-01 00:14:13.000000', 'consum', 0.0260, 'lps'),
	(623486, 132, '2015-01-01 00:14:14.000000', 'consum', 0.0245, 'lps'),
	(623487, 132, '2015-01-01 00:14:15.000000', 'consum', 0.0238, 'lps'),
	(623488, 132, '2015-01-01 00:14:16.000000', 'consum', 0.0247, 'lps'),
	(623489, 132, '2015-01-01 00:14:17.000000', 'consum', 0.0228, 'lps'),
	(623490, 132, '2015-01-01 00:14:18.000000', 'consum', 0.0270, 'lps'),
	(623491, 132, '2015-01-01 00:14:19.000000', 'consum', 0.0215, 'lps'),
	(623492, 132, '2015-01-01 00:14:20.000000', 'consum', 0.0217, 'lps'),
	(623493, 132, '2015-01-01 00:14:21.000000', 'consum', 0.0229, 'lps'),
	(623494, 132, '2015-01-01 00:14:22.000000', 'consum', 0.0284, 'lps'),
	(623495, 132, '2015-01-01 00:14:23.000000', 'consum', 0.0281, 'lps'),
	(623496, 132, '2015-01-01 00:14:24.000000', 'consum', 0.0264, 'lps'),
	(623497, 132, '2015-01-01 00:14:25.000000', 'consum', 0.0266, 'lps'),
	(623498, 132, '2015-01-01 00:14:26.000000', 'consum', 0.0248, 'lps'),
	(623499, 132, '2015-01-01 00:14:27.000000', 'consum', 0.0231, 'lps'),
	(623500, 132, '2015-01-01 00:14:28.000000', 'consum', 0.0283, 'lps'),
	(623501, 132, '2015-01-01 00:14:29.000000', 'consum', 0.0270, 'lps'),
	(623502, 132, '2015-01-01 00:14:30.000000', 'consum', 0.0290, 'lps'),
	(623503, 132, '2015-01-01 00:14:31.000000', 'consum', 0.0269, 'lps'),
	(623504, 132, '2015-01-01 00:14:32.000000', 'consum', 0.0267, 'lps'),
	(623505, 132, '2015-01-01 00:14:33.000000', 'consum', 0.0235, 'lps'),
	(623506, 132, '2015-01-01 00:14:34.000000', 'consum', 0.0247, 'lps'),
	(623507, 132, '2015-01-01 00:14:35.000000', 'consum', 0.0240, 'lps'),
	(623508, 132, '2015-01-01 00:14:36.000000', 'consum', 0.0250, 'lps'),
	(623509, 132, '2015-01-01 00:14:37.000000', 'consum', 0.0237, 'lps'),
	(623510, 132, '2015-01-01 00:14:38.000000', 'consum', 0.0228, 'lps'),
	(623511, 132, '2015-01-01 00:14:39.000000', 'consum', 0.0217, 'lps'),
	(623512, 132, '2015-01-01 00:14:40.000000', 'consum', 0.0275, 'lps'),
	(623513, 132, '2015-01-01 00:14:41.000000', 'consum', 0.0271, 'lps'),
	(623514, 132, '2015-01-01 00:14:42.000000', 'consum', 0.0239, 'lps'),
	(623515, 132, '2015-01-01 00:14:43.000000', 'consum', 0.0252, 'lps'),
	(623516, 132, '2015-01-01 00:14:44.000000', 'consum', 0.0256, 'lps'),
	(623517, 132, '2015-01-01 00:14:45.000000', 'consum', 0.0230, 'lps'),
	(623518, 132, '2015-01-01 00:14:46.000000', 'consum', 0.0254, 'lps'),
	(623519, 132, '2015-01-01 00:14:47.000000', 'consum', 0.0289, 'lps'),
	(623520, 132, '2015-01-01 00:14:48.000000', 'consum', 0.0233, 'lps'),
	(623521, 132, '2015-01-01 00:14:49.000000', 'consum', 0.0248, 'lps'),
	(623522, 132, '2015-01-01 00:14:50.000000', 'consum', 0.0252, 'lps'),
	(623523, 132, '2015-01-01 00:14:51.000000', 'consum', 0.0227, 'lps'),
	(623524, 132, '2015-01-01 00:14:52.000000', 'consum', 0.0247, 'lps'),
	(623525, 132, '2015-01-01 00:14:53.000000', 'consum', 0.0267, 'lps'),
	(623526, 132, '2015-01-01 00:14:54.000000', 'consum', 0.0222, 'lps'),
	(623527, 132, '2015-01-01 00:14:55.000000', 'consum', 0.0259, 'lps'),
	(623528, 132, '2015-01-01 00:14:56.000000', 'consum', 0.0259, 'lps'),
	(623529, 132, '2015-01-01 00:14:57.000000', 'consum', 0.0229, 'lps'),
	(623530, 132, '2015-01-01 00:14:58.000000', 'consum', 0.0238, 'lps'),
	(623531, 132, '2015-01-01 00:14:59.000000', 'consum', 0.0212, 'lps'),
	(623532, 132, '2015-01-01 00:15:00.000000', 'consum', 0.0219, 'lps'),
	(623533, 132, '2015-01-01 00:15:01.000000', 'consum', 0.0250, 'lps'),
	(623534, 132, '2015-01-01 00:15:02.000000', 'consum', 0.0220, 'lps'),
	(623535, 132, '2015-01-01 00:15:03.000000', 'consum', 0.0222, 'lps'),
	(623536, 132, '2015-01-01 00:15:04.000000', 'consum', 0.0241, 'lps'),
	(623537, 132, '2015-01-01 00:15:05.000000', 'consum', 0.0250, 'lps'),
	(623538, 132, '2015-01-01 00:15:06.000000', 'consum', 0.0233, 'lps'),
	(623539, 132, '2015-01-01 00:15:07.000000', 'consum', 0.0289, 'lps'),
	(623540, 132, '2015-01-01 00:15:08.000000', 'consum', 0.0211, 'lps'),
	(623541, 132, '2015-01-01 00:15:09.000000', 'consum', 0.0222, 'lps'),
	(623542, 132, '2015-01-01 00:15:10.000000', 'consum', 0.0266, 'lps'),
	(623543, 132, '2015-01-01 00:15:11.000000', 'consum', 0.0212, 'lps'),
	(623544, 132, '2015-01-01 00:15:12.000000', 'consum', 0.0213, 'lps'),
	(623545, 132, '2015-01-01 00:15:13.000000', 'consum', 0.0220, 'lps'),
	(623546, 132, '2015-01-01 00:15:14.000000', 'consum', 0.0254, 'lps'),
	(623547, 132, '2015-01-01 00:15:15.000000', 'consum', 0.0236, 'lps'),
	(623548, 132, '2015-01-01 00:15:16.000000', 'consum', 0.0289, 'lps'),
	(623549, 132, '2015-01-01 00:15:17.000000', 'consum', 0.0284, 'lps'),
	(623550, 132, '2015-01-01 00:15:18.000000', 'consum', 0.0263, 'lps'),
	(623551, 132, '2015-01-01 00:15:19.000000', 'consum', 0.0255, 'lps'),
	(623552, 132, '2015-01-01 00:15:20.000000', 'consum', 0.0277, 'lps'),
	(623553, 132, '2015-01-01 00:15:21.000000', 'consum', 0.0246, 'lps'),
	(623554, 132, '2015-01-01 00:15:22.000000', 'consum', 0.0270, 'lps'),
	(623555, 132, '2015-01-01 00:15:23.000000', 'consum', 0.0241, 'lps'),
	(623556, 132, '2015-01-01 00:15:24.000000', 'consum', 0.0268, 'lps'),
	(623557, 132, '2015-01-01 00:15:25.000000', 'consum', 0.0244, 'lps'),
	(623558, 132, '2015-01-01 00:15:26.000000', 'consum', 0.0289, 'lps'),
	(623559, 132, '2015-01-01 00:15:27.000000', 'consum', 0.0262, 'lps'),
	(623560, 132, '2015-01-01 00:15:28.000000', 'consum', 0.0230, 'lps'),
	(623561, 132, '2015-01-01 00:15:29.000000', 'consum', 0.0237, 'lps'),
	(623562, 132, '2015-01-01 00:15:30.000000', 'consum', 0.0284, 'lps'),
	(623563, 132, '2015-01-01 00:15:31.000000', 'consum', 0.0259, 'lps'),
	(623564, 132, '2015-01-01 00:15:32.000000', 'consum', 0.0234, 'lps'),
	(623565, 132, '2015-01-01 00:15:33.000000', 'consum', 0.0264, 'lps'),
	(623566, 132, '2015-01-01 00:15:34.000000', 'consum', 0.0246, 'lps'),
	(623567, 132, '2015-01-01 00:15:35.000000', 'consum', 0.0230, 'lps'),
	(623568, 132, '2015-01-01 00:15:36.000000', 'consum', 0.0281, 'lps'),
	(623569, 132, '2015-01-01 00:15:37.000000', 'consum', 0.0262, 'lps'),
	(623570, 132, '2015-01-01 00:15:38.000000', 'consum', 0.0257, 'lps'),
	(623571, 132, '2015-01-01 00:15:39.000000', 'consum', 0.0290, 'lps'),
	(623572, 132, '2015-01-01 00:15:40.000000', 'consum', 0.0227, 'lps'),
	(623573, 132, '2015-01-01 00:15:41.000000', 'consum', 0.0217, 'lps'),
	(623574, 132, '2015-01-01 00:15:42.000000', 'consum', 0.0277, 'lps'),
	(623575, 132, '2015-01-01 00:15:43.000000', 'consum', 0.0280, 'lps'),
	(623576, 132, '2015-01-01 00:15:44.000000', 'consum', 0.0277, 'lps'),
	(623577, 132, '2015-01-01 00:15:45.000000', 'consum', 0.0256, 'lps'),
	(623578, 132, '2015-01-01 00:15:46.000000', 'consum', 0.0241, 'lps'),
	(623579, 132, '2015-01-01 00:15:47.000000', 'consum', 0.0226, 'lps'),
	(623580, 132, '2015-01-01 00:15:48.000000', 'consum', 0.0278, 'lps'),
	(623581, 132, '2015-01-01 00:15:49.000000', 'consum', 0.0260, 'lps'),
	(623582, 132, '2015-01-01 00:15:50.000000', 'consum', 0.0256, 'lps'),
	(623583, 132, '2015-01-01 00:15:51.000000', 'consum', 0.0211, 'lps'),
	(623584, 132, '2015-01-01 00:15:52.000000', 'consum', 0.0240, 'lps'),
	(623585, 132, '2015-01-01 00:15:53.000000', 'consum', 0.0277, 'lps'),
	(623586, 132, '2015-01-01 00:15:54.000000', 'consum', 0.0210, 'lps'),
	(623587, 132, '2015-01-01 00:15:55.000000', 'consum', 0.0255, 'lps'),
	(623588, 132, '2015-01-01 00:15:56.000000', 'consum', 0.0272, 'lps'),
	(623589, 132, '2015-01-01 00:15:57.000000', 'consum', 0.0222, 'lps'),
	(623590, 132, '2015-01-01 00:15:58.000000', 'consum', 0.0247, 'lps'),
	(623591, 132, '2015-01-01 00:15:59.000000', 'consum', 0.0280, 'lps'),
	(623592, 132, '2015-01-01 00:16:00.000000', 'consum', 0.0285, 'lps'),
	(623593, 132, '2015-01-01 00:16:01.000000', 'consum', 0.0216, 'lps'),
	(623594, 132, '2015-01-01 00:16:02.000000', 'consum', 0.0256, 'lps'),
	(623595, 132, '2015-01-01 00:16:03.000000', 'consum', 0.0263, 'lps'),
	(623596, 132, '2015-01-01 00:16:04.000000', 'consum', 0.0254, 'lps'),
	(623597, 132, '2015-01-01 00:16:05.000000', 'consum', 0.0274, 'lps'),
	(623598, 132, '2015-01-01 00:16:06.000000', 'consum', 0.0233, 'lps'),
	(623599, 132, '2015-01-01 00:16:07.000000', 'consum', 0.0218, 'lps'),
	(623600, 132, '2015-01-01 00:16:08.000000', 'consum', 0.0263, 'lps'),
	(623601, 132, '2015-01-01 00:16:09.000000', 'consum', 0.0287, 'lps'),
	(623602, 132, '2015-01-01 00:16:10.000000', 'consum', 0.0275, 'lps'),
	(623603, 132, '2015-01-01 00:16:11.000000', 'consum', 0.0225, 'lps'),
	(623604, 132, '2015-01-01 00:16:12.000000', 'consum', 0.0252, 'lps'),
	(623605, 132, '2015-01-01 00:16:13.000000', 'consum', 0.0211, 'lps'),
	(623606, 132, '2015-01-01 00:16:14.000000', 'consum', 0.0254, 'lps'),
	(623607, 132, '2015-01-01 00:16:15.000000', 'consum', 0.0266, 'lps'),
	(623608, 132, '2015-01-01 00:16:16.000000', 'consum', 0.0277, 'lps'),
	(623609, 132, '2015-01-01 00:16:17.000000', 'consum', 0.0215, 'lps'),
	(623610, 132, '2015-01-01 00:16:18.000000', 'consum', 0.0276, 'lps'),
	(623611, 132, '2015-01-01 00:16:19.000000', 'consum', 0.0283, 'lps'),
	(623612, 132, '2015-01-01 00:16:20.000000', 'consum', 0.0217, 'lps'),
	(623613, 132, '2015-01-01 00:16:21.000000', 'consum', 0.0267, 'lps'),
	(623614, 132, '2015-01-01 00:16:22.000000', 'consum', 0.0231, 'lps'),
	(623615, 132, '2015-01-01 00:16:23.000000', 'consum', 0.0228, 'lps'),
	(623616, 132, '2015-01-01 00:16:24.000000', 'consum', 0.0236, 'lps'),
	(623617, 132, '2015-01-01 00:16:25.000000', 'consum', 0.0288, 'lps'),
	(623618, 132, '2015-01-01 00:16:26.000000', 'consum', 0.0281, 'lps'),
	(623619, 132, '2015-01-01 00:16:27.000000', 'consum', 0.0247, 'lps'),
	(623620, 132, '2015-01-01 00:16:28.000000', 'consum', 0.0264, 'lps'),
	(623621, 132, '2015-01-01 00:16:29.000000', 'consum', 0.0289, 'lps'),
	(623622, 132, '2015-01-01 00:16:30.000000', 'consum', 0.0280, 'lps'),
	(623623, 132, '2015-01-01 00:16:31.000000', 'consum', 0.0245, 'lps'),
	(623624, 132, '2015-01-01 00:16:32.000000', 'consum', 0.0254, 'lps'),
	(623625, 132, '2015-01-01 00:16:33.000000', 'consum', 0.0244, 'lps'),
	(623626, 132, '2015-01-01 00:16:34.000000', 'consum', 0.0250, 'lps'),
	(623627, 132, '2015-01-01 00:16:35.000000', 'consum', 0.0226, 'lps'),
	(623628, 132, '2015-01-01 00:16:36.000000', 'consum', 0.0251, 'lps'),
	(623629, 132, '2015-01-01 00:16:37.000000', 'consum', 0.0289, 'lps'),
	(623630, 132, '2015-01-01 00:16:38.000000', 'consum', 0.0237, 'lps'),
	(623631, 132, '2015-01-01 00:16:39.000000', 'consum', 0.0270, 'lps'),
	(623632, 132, '2015-01-01 00:16:40.000000', 'consum', 0.0269, 'lps'),
	(623633, 132, '2015-01-01 00:16:41.000000', 'consum', 0.0245, 'lps'),
	(623634, 132, '2015-01-01 00:16:42.000000', 'consum', 0.0287, 'lps'),
	(623635, 132, '2015-01-01 00:16:43.000000', 'consum', 0.0250, 'lps'),
	(623636, 132, '2015-01-01 00:16:44.000000', 'consum', 0.0260, 'lps'),
	(623637, 132, '2015-01-01 00:16:45.000000', 'consum', 0.0258, 'lps'),
	(623638, 132, '2015-01-01 00:16:46.000000', 'consum', 0.0221, 'lps'),
	(623639, 132, '2015-01-01 00:16:47.000000', 'consum', 0.0284, 'lps'),
	(623640, 132, '2015-01-01 00:16:48.000000', 'consum', 0.0223, 'lps'),
	(623641, 132, '2015-01-01 00:16:49.000000', 'consum', 0.0215, 'lps'),
	(623642, 132, '2015-01-01 00:16:50.000000', 'consum', 0.0276, 'lps'),
	(623643, 132, '2015-01-01 00:16:51.000000', 'consum', 0.0285, 'lps'),
	(623644, 132, '2015-01-01 00:16:52.000000', 'consum', 0.0226, 'lps'),
	(623645, 132, '2015-01-01 00:16:53.000000', 'consum', 0.0227, 'lps'),
	(623646, 132, '2015-01-01 00:16:54.000000', 'consum', 0.0248, 'lps'),
	(623647, 132, '2015-01-01 00:16:55.000000', 'consum', 0.0267, 'lps'),
	(623648, 132, '2015-01-01 00:16:56.000000', 'consum', 0.0222, 'lps'),
	(623649, 132, '2015-01-01 00:16:57.000000', 'consum', 0.0261, 'lps'),
	(623650, 132, '2015-01-01 00:16:58.000000', 'consum', 0.0269, 'lps'),
	(623651, 132, '2015-01-01 00:16:59.000000', 'consum', 0.0268, 'lps'),
	(623652, 132, '2015-01-01 00:17:00.000000', 'consum', 0.0245, 'lps'),
	(623653, 132, '2015-01-01 00:17:01.000000', 'consum', 0.0210, 'lps'),
	(623654, 132, '2015-01-01 00:17:02.000000', 'consum', 0.0270, 'lps'),
	(623655, 132, '2015-01-01 00:17:03.000000', 'consum', 0.0264, 'lps'),
	(623656, 132, '2015-01-01 00:17:04.000000', 'consum', 0.0222, 'lps'),
	(623657, 132, '2015-01-01 00:17:05.000000', 'consum', 0.0269, 'lps'),
	(623658, 132, '2015-01-01 00:17:06.000000', 'consum', 0.0227, 'lps'),
	(623659, 132, '2015-01-01 00:17:07.000000', 'consum', 0.0281, 'lps'),
	(623660, 132, '2015-01-01 00:17:08.000000', 'consum', 0.0272, 'lps'),
	(623661, 132, '2015-01-01 00:17:09.000000', 'consum', 0.0228, 'lps'),
	(623662, 132, '2015-01-01 00:17:10.000000', 'consum', 0.0275, 'lps'),
	(623663, 132, '2015-01-01 00:17:11.000000', 'consum', 0.0238, 'lps'),
	(623664, 132, '2015-01-01 00:17:12.000000', 'consum', 0.0236, 'lps'),
	(623665, 132, '2015-01-01 00:17:13.000000', 'consum', 0.0255, 'lps'),
	(623666, 132, '2015-01-01 00:17:14.000000', 'consum', 0.0278, 'lps'),
	(623667, 132, '2015-01-01 00:17:15.000000', 'consum', 0.0253, 'lps'),
	(623668, 132, '2015-01-01 00:17:16.000000', 'consum', 0.0223, 'lps'),
	(623669, 132, '2015-01-01 00:17:17.000000', 'consum', 0.0225, 'lps'),
	(623670, 132, '2015-01-01 00:17:18.000000', 'consum', 0.0248, 'lps'),
	(623671, 132, '2015-01-01 00:17:19.000000', 'consum', 0.0274, 'lps'),
	(623672, 132, '2015-01-01 00:17:20.000000', 'consum', 0.0257, 'lps'),
	(623673, 132, '2015-01-01 00:17:21.000000', 'consum', 0.0250, 'lps'),
	(623674, 132, '2015-01-01 00:17:22.000000', 'consum', 0.0273, 'lps'),
	(623675, 132, '2015-01-01 00:17:23.000000', 'consum', 0.0241, 'lps'),
	(623676, 132, '2015-01-01 00:17:24.000000', 'consum', 0.0258, 'lps'),
	(623677, 132, '2015-01-01 00:17:25.000000', 'consum', 0.0276, 'lps'),
	(623678, 132, '2015-01-01 00:17:26.000000', 'consum', 0.0234, 'lps'),
	(623679, 132, '2015-01-01 00:17:27.000000', 'consum', 0.0213, 'lps'),
	(623680, 132, '2015-01-01 00:17:28.000000', 'consum', 0.0235, 'lps'),
	(623681, 132, '2015-01-01 00:17:29.000000', 'consum', 0.0245, 'lps'),
	(623682, 132, '2015-01-01 00:17:30.000000', 'consum', 0.0230, 'lps'),
	(623683, 132, '2015-01-01 00:17:31.000000', 'consum', 0.0285, 'lps'),
	(623684, 132, '2015-01-01 00:17:32.000000', 'consum', 0.0284, 'lps'),
	(623685, 132, '2015-01-01 00:17:33.000000', 'consum', 0.0273, 'lps'),
	(623686, 132, '2015-01-01 00:17:34.000000', 'consum', 0.0222, 'lps'),
	(623687, 132, '2015-01-01 00:17:35.000000', 'consum', 0.0243, 'lps'),
	(623688, 132, '2015-01-01 00:17:36.000000', 'consum', 0.0261, 'lps'),
	(623689, 132, '2015-01-01 00:17:37.000000', 'consum', 0.0284, 'lps'),
	(623690, 132, '2015-01-01 00:17:38.000000', 'consum', 0.0268, 'lps'),
	(623691, 132, '2015-01-01 00:17:39.000000', 'consum', 0.0275, 'lps'),
	(623692, 132, '2015-01-01 00:17:40.000000', 'consum', 0.0283, 'lps'),
	(623693, 132, '2015-01-01 00:17:41.000000', 'consum', 0.0219, 'lps'),
	(623694, 132, '2015-01-01 00:17:42.000000', 'consum', 0.0277, 'lps'),
	(623695, 132, '2015-01-01 00:17:43.000000', 'consum', 0.0276, 'lps'),
	(623696, 132, '2015-01-01 00:17:44.000000', 'consum', 0.0258, 'lps'),
	(623697, 132, '2015-01-01 00:17:45.000000', 'consum', 0.0255, 'lps'),
	(623698, 132, '2015-01-01 00:17:46.000000', 'consum', 0.0290, 'lps'),
	(623699, 132, '2015-01-01 00:17:47.000000', 'consum', 0.0234, 'lps'),
	(623700, 132, '2015-01-01 00:17:48.000000', 'consum', 0.0251, 'lps'),
	(623701, 132, '2015-01-01 00:17:49.000000', 'consum', 0.0264, 'lps'),
	(623702, 132, '2015-01-01 00:17:50.000000', 'consum', 0.0277, 'lps'),
	(623703, 132, '2015-01-01 00:17:51.000000', 'consum', 0.0219, 'lps'),
	(623704, 132, '2015-01-01 00:17:52.000000', 'consum', 0.0218, 'lps'),
	(623705, 132, '2015-01-01 00:17:53.000000', 'consum', 0.0223, 'lps'),
	(623706, 132, '2015-01-01 00:17:54.000000', 'consum', 0.0253, 'lps'),
	(623707, 132, '2015-01-01 00:17:55.000000', 'consum', 0.0223, 'lps'),
	(623708, 132, '2015-01-01 00:17:56.000000', 'consum', 0.0226, 'lps'),
	(623709, 132, '2015-01-01 00:17:57.000000', 'consum', 0.0253, 'lps'),
	(623710, 132, '2015-01-01 00:17:58.000000', 'consum', 0.0214, 'lps'),
	(623711, 132, '2015-01-01 00:17:59.000000', 'consum', 0.0265, 'lps'),
	(623712, 132, '2015-01-01 00:18:00.000000', 'consum', 0.0228, 'lps'),
	(623713, 132, '2015-01-01 00:18:01.000000', 'consum', 0.0218, 'lps'),
	(623714, 132, '2015-01-01 00:18:02.000000', 'consum', 0.0278, 'lps'),
	(623715, 132, '2015-01-01 00:18:03.000000', 'consum', 0.0285, 'lps'),
	(623716, 132, '2015-01-01 00:18:04.000000', 'consum', 0.0217, 'lps'),
	(623717, 132, '2015-01-01 00:18:05.000000', 'consum', 0.0264, 'lps'),
	(623718, 132, '2015-01-01 00:18:06.000000', 'consum', 0.0217, 'lps'),
	(623719, 132, '2015-01-01 00:18:07.000000', 'consum', 0.0243, 'lps'),
	(623720, 132, '2015-01-01 00:18:08.000000', 'consum', 0.0277, 'lps'),
	(623721, 132, '2015-01-01 00:18:09.000000', 'consum', 0.0283, 'lps'),
	(623722, 132, '2015-01-01 00:18:10.000000', 'consum', 0.0214, 'lps'),
	(623723, 132, '2015-01-01 00:18:11.000000', 'consum', 0.0255, 'lps'),
	(623724, 132, '2015-01-01 00:18:12.000000', 'consum', 0.0260, 'lps'),
	(623725, 132, '2015-01-01 00:18:13.000000', 'consum', 0.0244, 'lps'),
	(623726, 132, '2015-01-01 00:18:14.000000', 'consum', 0.0232, 'lps'),
	(623727, 132, '2015-01-01 00:18:15.000000', 'consum', 0.0217, 'lps'),
	(623728, 132, '2015-01-01 00:18:16.000000', 'consum', 0.0262, 'lps'),
	(623729, 132, '2015-01-01 00:18:17.000000', 'consum', 0.0285, 'lps'),
	(623730, 132, '2015-01-01 00:18:18.000000', 'consum', 0.0269, 'lps'),
	(623731, 132, '2015-01-01 00:18:19.000000', 'consum', 0.0282, 'lps'),
	(623732, 132, '2015-01-01 00:18:20.000000', 'consum', 0.0230, 'lps'),
	(623733, 132, '2015-01-01 00:18:21.000000', 'consum', 0.0255, 'lps'),
	(623734, 132, '2015-01-01 00:18:22.000000', 'consum', 0.0216, 'lps'),
	(623735, 132, '2015-01-01 00:18:23.000000', 'consum', 0.0267, 'lps'),
	(623736, 132, '2015-01-01 00:18:24.000000', 'consum', 0.0236, 'lps'),
	(623737, 132, '2015-01-01 00:18:25.000000', 'consum', 0.0249, 'lps'),
	(623738, 132, '2015-01-01 00:18:26.000000', 'consum', 0.0246, 'lps'),
	(623739, 132, '2015-01-01 00:18:27.000000', 'consum', 0.0273, 'lps'),
	(623740, 132, '2015-01-01 00:18:28.000000', 'consum', 0.0255, 'lps'),
	(623741, 132, '2015-01-01 00:18:29.000000', 'consum', 0.0246, 'lps'),
	(623742, 132, '2015-01-01 00:18:30.000000', 'consum', 0.0256, 'lps'),
	(623743, 132, '2015-01-01 00:18:31.000000', 'consum', 0.0252, 'lps'),
	(623744, 132, '2015-01-01 00:18:32.000000', 'consum', 0.0282, 'lps'),
	(623745, 132, '2015-01-01 00:18:33.000000', 'consum', 0.0284, 'lps'),
	(623746, 132, '2015-01-01 00:18:34.000000', 'consum', 0.0282, 'lps'),
	(623747, 132, '2015-01-01 00:18:35.000000', 'consum', 0.0266, 'lps'),
	(623748, 132, '2015-01-01 00:18:36.000000', 'consum', 0.0276, 'lps'),
	(623749, 132, '2015-01-01 00:18:37.000000', 'consum', 0.0211, 'lps'),
	(623750, 132, '2015-01-01 00:18:38.000000', 'consum', 0.0260, 'lps'),
	(623751, 132, '2015-01-01 00:18:39.000000', 'consum', 0.0214, 'lps'),
	(623752, 132, '2015-01-01 00:18:40.000000', 'consum', 0.0244, 'lps'),
	(623753, 132, '2015-01-01 00:18:41.000000', 'consum', 0.0285, 'lps'),
	(623754, 132, '2015-01-01 00:18:42.000000', 'consum', 0.0242, 'lps'),
	(623755, 132, '2015-01-01 00:18:43.000000', 'consum', 0.0226, 'lps'),
	(623756, 132, '2015-01-01 00:18:44.000000', 'consum', 0.0276, 'lps'),
	(623757, 132, '2015-01-01 00:18:45.000000', 'consum', 0.0250, 'lps'),
	(623758, 132, '2015-01-01 00:18:46.000000', 'consum', 0.0212, 'lps'),
	(623759, 132, '2015-01-01 00:18:47.000000', 'consum', 0.0261, 'lps'),
	(623760, 132, '2015-01-01 00:18:48.000000', 'consum', 0.0216, 'lps'),
	(623761, 132, '2015-01-01 00:18:49.000000', 'consum', 0.0249, 'lps'),
	(623762, 132, '2015-01-01 00:18:50.000000', 'consum', 0.0228, 'lps'),
	(623763, 132, '2015-01-01 00:18:51.000000', 'consum', 0.0265, 'lps'),
	(623764, 132, '2015-01-01 00:18:52.000000', 'consum', 0.0271, 'lps'),
	(623765, 132, '2015-01-01 00:18:53.000000', 'consum', 0.0266, 'lps'),
	(623766, 132, '2015-01-01 00:18:54.000000', 'consum', 0.0228, 'lps'),
	(623767, 132, '2015-01-01 00:18:55.000000', 'consum', 0.0212, 'lps'),
	(623768, 132, '2015-01-01 00:18:56.000000', 'consum', 0.0247, 'lps'),
	(623769, 132, '2015-01-01 00:18:57.000000', 'consum', 0.0229, 'lps'),
	(623770, 132, '2015-01-01 00:18:58.000000', 'consum', 0.0276, 'lps'),
	(623771, 132, '2015-01-01 00:18:59.000000', 'consum', 0.0240, 'lps'),
	(623772, 132, '2015-01-01 00:19:00.000000', 'consum', 0.0246, 'lps'),
	(623773, 132, '2015-01-01 00:19:01.000000', 'consum', 0.0216, 'lps'),
	(623774, 132, '2015-01-01 00:19:02.000000', 'consum', 0.0213, 'lps'),
	(623775, 132, '2015-01-01 00:19:03.000000', 'consum', 0.0210, 'lps'),
	(623776, 132, '2015-01-01 00:19:04.000000', 'consum', 0.0280, 'lps'),
	(623777, 132, '2015-01-01 00:19:05.000000', 'consum', 0.0239, 'lps'),
	(623778, 132, '2015-01-01 00:19:06.000000', 'consum', 0.0224, 'lps'),
	(623779, 132, '2015-01-01 00:19:07.000000', 'consum', 0.0273, 'lps'),
	(623780, 132, '2015-01-01 00:19:08.000000', 'consum', 0.0244, 'lps'),
	(623781, 132, '2015-01-01 00:19:09.000000', 'consum', 0.0273, 'lps'),
	(623782, 132, '2015-01-01 00:19:10.000000', 'consum', 0.0260, 'lps'),
	(623783, 132, '2015-01-01 00:19:11.000000', 'consum', 0.0270, 'lps'),
	(623784, 132, '2015-01-01 00:19:12.000000', 'consum', 0.0280, 'lps'),
	(623785, 132, '2015-01-01 00:19:13.000000', 'consum', 0.0218, 'lps'),
	(623786, 132, '2015-01-01 00:19:14.000000', 'consum', 0.0283, 'lps'),
	(623787, 132, '2015-01-01 00:19:15.000000', 'consum', 0.0229, 'lps'),
	(623788, 132, '2015-01-01 00:19:16.000000', 'consum', 0.0246, 'lps'),
	(623789, 132, '2015-01-01 00:19:17.000000', 'consum', 0.0256, 'lps'),
	(623790, 132, '2015-01-01 00:19:18.000000', 'consum', 0.0248, 'lps'),
	(623791, 132, '2015-01-01 00:19:19.000000', 'consum', 0.0264, 'lps'),
	(623792, 132, '2015-01-01 00:19:20.000000', 'consum', 0.0283, 'lps'),
	(623793, 132, '2015-01-01 00:19:21.000000', 'consum', 0.0255, 'lps'),
	(623794, 132, '2015-01-01 00:19:22.000000', 'consum', 0.0216, 'lps'),
	(623795, 132, '2015-01-01 00:19:23.000000', 'consum', 0.0268, 'lps'),
	(623796, 132, '2015-01-01 00:19:24.000000', 'consum', 0.0238, 'lps'),
	(623797, 132, '2015-01-01 00:19:25.000000', 'consum', 0.0259, 'lps'),
	(623798, 132, '2015-01-01 00:19:26.000000', 'consum', 0.0290, 'lps'),
	(623799, 132, '2015-01-01 00:19:27.000000', 'consum', 0.0221, 'lps'),
	(623800, 132, '2015-01-01 00:19:28.000000', 'consum', 0.0268, 'lps'),
	(623801, 132, '2015-01-01 00:19:29.000000', 'consum', 0.0224, 'lps'),
	(623802, 132, '2015-01-01 00:19:30.000000', 'consum', 0.0267, 'lps'),
	(623803, 132, '2015-01-01 00:19:31.000000', 'consum', 0.0212, 'lps'),
	(623804, 132, '2015-01-01 00:19:32.000000', 'consum', 0.0210, 'lps'),
	(623805, 132, '2015-01-01 00:19:33.000000', 'consum', 0.0286, 'lps'),
	(623806, 132, '2015-01-01 00:19:34.000000', 'consum', 0.0266, 'lps'),
	(623807, 132, '2015-01-01 00:19:35.000000', 'consum', 0.0262, 'lps'),
	(623808, 132, '2015-01-01 00:19:36.000000', 'consum', 0.0224, 'lps'),
	(623809, 132, '2015-01-01 00:19:37.000000', 'consum', 0.0286, 'lps'),
	(623810, 132, '2015-01-01 00:19:38.000000', 'consum', 0.0225, 'lps'),
	(623811, 132, '2015-01-01 00:19:39.000000', 'consum', 0.0217, 'lps'),
	(623812, 132, '2015-01-01 00:19:40.000000', 'consum', 0.0283, 'lps'),
	(623813, 132, '2015-01-01 00:19:41.000000', 'consum', 0.0230, 'lps'),
	(623814, 132, '2015-01-01 00:19:42.000000', 'consum', 0.0255, 'lps'),
	(623815, 132, '2015-01-01 00:19:43.000000', 'consum', 0.0211, 'lps'),
	(623816, 132, '2015-01-01 00:19:44.000000', 'consum', 0.0244, 'lps'),
	(623817, 132, '2015-01-01 00:19:45.000000', 'consum', 0.0215, 'lps'),
	(623818, 132, '2015-01-01 00:19:46.000000', 'consum', 0.0215, 'lps'),
	(623819, 132, '2015-01-01 00:19:47.000000', 'consum', 0.0222, 'lps'),
	(623820, 132, '2015-01-01 00:19:48.000000', 'consum', 0.0255, 'lps'),
	(623821, 132, '2015-01-01 00:19:49.000000', 'consum', 0.0239, 'lps'),
	(623822, 132, '2015-01-01 00:19:50.000000', 'consum', 0.0219, 'lps'),
	(623823, 132, '2015-01-01 00:19:51.000000', 'consum', 0.0251, 'lps'),
	(623824, 132, '2015-01-01 00:19:52.000000', 'consum', 0.0227, 'lps'),
	(623825, 132, '2015-01-01 00:19:53.000000', 'consum', 0.0251, 'lps'),
	(623826, 132, '2015-01-01 00:19:54.000000', 'consum', 0.0283, 'lps'),
	(623827, 132, '2015-01-01 00:19:55.000000', 'consum', 0.0210, 'lps'),
	(623828, 132, '2015-01-01 00:19:56.000000', 'consum', 0.0237, 'lps'),
	(623829, 132, '2015-01-01 00:19:57.000000', 'consum', 0.0261, 'lps'),
	(623830, 132, '2015-01-01 00:19:58.000000', 'consum', 0.0225, 'lps'),
	(623831, 132, '2015-01-01 00:19:59.000000', 'consum', 0.0212, 'lps'),
	(623832, 132, '2015-01-01 00:20:00.000000', 'consum', 0.0258, 'lps'),
	(623833, 132, '2015-01-01 00:20:01.000000', 'consum', 0.0283, 'lps'),
	(623834, 132, '2015-01-01 00:20:02.000000', 'consum', 0.0267, 'lps'),
	(623835, 132, '2015-01-01 00:20:03.000000', 'consum', 0.0277, 'lps'),
	(623836, 132, '2015-01-01 00:20:04.000000', 'consum', 0.0215, 'lps'),
	(623837, 132, '2015-01-01 00:20:05.000000', 'consum', 0.0275, 'lps'),
	(623838, 132, '2015-01-01 00:20:06.000000', 'consum', 0.0279, 'lps'),
	(623839, 132, '2015-01-01 00:20:07.000000', 'consum', 0.0277, 'lps'),
	(623840, 132, '2015-01-01 00:20:08.000000', 'consum', 0.0259, 'lps'),
	(623841, 132, '2015-01-01 00:20:09.000000', 'consum', 0.0252, 'lps'),
	(623842, 132, '2015-01-01 00:20:10.000000', 'consum', 0.0277, 'lps'),
	(623843, 132, '2015-01-01 00:20:11.000000', 'consum', 0.0257, 'lps'),
	(623844, 132, '2015-01-01 00:20:12.000000', 'consum', 0.0244, 'lps'),
	(623845, 132, '2015-01-01 00:20:13.000000', 'consum', 0.0239, 'lps'),
	(623846, 132, '2015-01-01 00:20:14.000000', 'consum', 0.0254, 'lps'),
	(623847, 132, '2015-01-01 00:20:15.000000', 'consum', 0.0264, 'lps'),
	(623848, 132, '2015-01-01 00:20:16.000000', 'consum', 0.0268, 'lps'),
	(623849, 132, '2015-01-01 00:20:17.000000', 'consum', 0.0254, 'lps'),
	(623850, 132, '2015-01-01 00:20:18.000000', 'consum', 0.0259, 'lps'),
	(623851, 132, '2015-01-01 00:20:19.000000', 'consum', 0.0244, 'lps'),
	(623852, 132, '2015-01-01 00:20:20.000000', 'consum', 0.0230, 'lps'),
	(623853, 132, '2015-01-01 00:20:21.000000', 'consum', 0.0210, 'lps'),
	(623854, 132, '2015-01-01 00:20:22.000000', 'consum', 0.0233, 'lps'),
	(623855, 132, '2015-01-01 00:20:23.000000', 'consum', 0.0243, 'lps'),
	(623856, 132, '2015-01-01 00:20:24.000000', 'consum', 0.0227, 'lps'),
	(623857, 132, '2015-01-01 00:20:25.000000', 'consum', 0.0277, 'lps'),
	(623858, 132, '2015-01-01 00:20:26.000000', 'consum', 0.0252, 'lps'),
	(623859, 132, '2015-01-01 00:20:27.000000', 'consum', 0.0220, 'lps'),
	(623860, 132, '2015-01-01 00:20:28.000000', 'consum', 0.0213, 'lps'),
	(623861, 132, '2015-01-01 00:20:29.000000', 'consum', 0.0279, 'lps'),
	(623862, 132, '2015-01-01 00:20:30.000000', 'consum', 0.0224, 'lps'),
	(623863, 132, '2015-01-01 00:20:31.000000', 'consum', 0.0232, 'lps'),
	(623864, 132, '2015-01-01 00:20:32.000000', 'consum', 0.0281, 'lps'),
	(623865, 132, '2015-01-01 00:20:33.000000', 'consum', 0.0255, 'lps'),
	(623866, 132, '2015-01-01 00:20:34.000000', 'consum', 0.0224, 'lps'),
	(623867, 132, '2015-01-01 00:20:35.000000', 'consum', 0.0227, 'lps'),
	(623868, 132, '2015-01-01 00:20:36.000000', 'consum', 0.0253, 'lps'),
	(623869, 132, '2015-01-01 00:20:37.000000', 'consum', 0.0214, 'lps'),
	(623870, 132, '2015-01-01 00:20:38.000000', 'consum', 0.0261, 'lps'),
	(623871, 132, '2015-01-01 00:20:39.000000', 'consum', 0.0212, 'lps'),
	(623872, 132, '2015-01-01 00:20:40.000000', 'consum', 0.0231, 'lps'),
	(623873, 132, '2015-01-01 00:20:41.000000', 'consum', 0.0226, 'lps'),
	(623874, 132, '2015-01-01 00:20:42.000000', 'consum', 0.0228, 'lps'),
	(623875, 132, '2015-01-01 00:20:43.000000', 'consum', 0.0255, 'lps'),
	(623876, 132, '2015-01-01 00:20:44.000000', 'consum', 0.0217, 'lps'),
	(623877, 132, '2015-01-01 00:20:45.000000', 'consum', 0.0272, 'lps'),
	(623878, 132, '2015-01-01 00:20:46.000000', 'consum', 0.0259, 'lps'),
	(623879, 132, '2015-01-01 00:20:47.000000', 'consum', 0.0269, 'lps'),
	(623880, 132, '2015-01-01 00:20:48.000000', 'consum', 0.0279, 'lps'),
	(623881, 132, '2015-01-01 00:20:49.000000', 'consum', 0.0213, 'lps'),
	(623882, 132, '2015-01-01 00:20:50.000000', 'consum', 0.0263, 'lps'),
	(623883, 132, '2015-01-01 00:20:51.000000', 'consum', 0.0224, 'lps'),
	(623884, 132, '2015-01-01 00:20:52.000000', 'consum', 0.0284, 'lps'),
	(623885, 132, '2015-01-01 00:20:53.000000', 'consum', 0.0213, 'lps'),
	(623886, 132, '2015-01-01 00:20:54.000000', 'consum', 0.0246, 'lps'),
	(623887, 132, '2015-01-01 00:20:55.000000', 'consum', 0.0219, 'lps'),
	(623888, 132, '2015-01-01 00:20:56.000000', 'consum', 0.0231, 'lps'),
	(623889, 132, '2015-01-01 00:20:57.000000', 'consum', 0.0287, 'lps'),
	(623890, 132, '2015-01-01 00:20:58.000000', 'consum', 0.0289, 'lps'),
	(623891, 132, '2015-01-01 00:20:59.000000', 'consum', 0.0215, 'lps'),
	(623892, 132, '2015-01-01 00:21:00.000000', 'consum', 0.0239, 'lps'),
	(623893, 132, '2015-01-01 00:21:01.000000', 'consum', 0.0261, 'lps'),
	(623894, 132, '2015-01-01 00:21:02.000000', 'consum', 0.0215, 'lps'),
	(623895, 132, '2015-01-01 00:21:03.000000', 'consum', 0.0243, 'lps'),
	(623896, 132, '2015-01-01 00:21:04.000000', 'consum', 0.0282, 'lps'),
	(623897, 132, '2015-01-01 00:21:05.000000', 'consum', 0.0226, 'lps'),
	(623898, 132, '2015-01-01 00:21:06.000000', 'consum', 0.0237, 'lps'),
	(623899, 132, '2015-01-01 00:21:07.000000', 'consum', 0.0219, 'lps'),
	(623900, 132, '2015-01-01 00:21:08.000000', 'consum', 0.0254, 'lps'),
	(623901, 132, '2015-01-01 00:21:09.000000', 'consum', 0.0240, 'lps'),
	(623902, 132, '2015-01-01 00:21:10.000000', 'consum', 0.0228, 'lps'),
	(623903, 132, '2015-01-01 00:21:11.000000', 'consum', 0.0212, 'lps'),
	(623904, 132, '2015-01-01 00:21:12.000000', 'consum', 0.0245, 'lps'),
	(623905, 132, '2015-01-01 00:21:13.000000', 'consum', 0.0221, 'lps'),
	(623906, 132, '2015-01-01 00:21:14.000000', 'consum', 0.0239, 'lps'),
	(623907, 132, '2015-01-01 00:21:15.000000', 'consum', 0.0241, 'lps'),
	(623908, 132, '2015-01-01 00:21:16.000000', 'consum', 0.0279, 'lps'),
	(623909, 132, '2015-01-01 00:21:17.000000', 'consum', 0.0220, 'lps'),
	(623910, 132, '2015-01-01 00:21:18.000000', 'consum', 0.0216, 'lps'),
	(623911, 132, '2015-01-01 00:21:19.000000', 'consum', 0.0289, 'lps'),
	(623912, 132, '2015-01-01 00:21:20.000000', 'consum', 0.0265, 'lps'),
	(623913, 132, '2015-01-01 00:21:21.000000', 'consum', 0.0250, 'lps'),
	(623914, 132, '2015-01-01 00:21:22.000000', 'consum', 0.0245, 'lps'),
	(623915, 132, '2015-01-01 00:21:23.000000', 'consum', 0.0265, 'lps'),
	(623916, 132, '2015-01-01 00:21:24.000000', 'consum', 0.0220, 'lps'),
	(623917, 132, '2015-01-01 00:21:25.000000', 'consum', 0.0257, 'lps'),
	(623918, 132, '2015-01-01 00:21:26.000000', 'consum', 0.0251, 'lps'),
	(623919, 132, '2015-01-01 00:21:27.000000', 'consum', 0.0277, 'lps'),
	(623920, 132, '2015-01-01 00:21:28.000000', 'consum', 0.0262, 'lps'),
	(623921, 132, '2015-01-01 00:21:29.000000', 'consum', 0.0267, 'lps'),
	(623922, 132, '2015-01-01 00:21:30.000000', 'consum', 0.0260, 'lps'),
	(623923, 132, '2015-01-01 00:21:31.000000', 'consum', 0.0287, 'lps'),
	(623924, 132, '2015-01-01 00:21:32.000000', 'consum', 0.0284, 'lps'),
	(623925, 132, '2015-01-01 00:21:33.000000', 'consum', 0.0269, 'lps'),
	(623926, 132, '2015-01-01 00:21:34.000000', 'consum', 0.0285, 'lps'),
	(623927, 132, '2015-01-01 00:21:35.000000', 'consum', 0.0246, 'lps'),
	(623928, 132, '2015-01-01 00:21:36.000000', 'consum', 0.0247, 'lps'),
	(623929, 132, '2015-01-01 00:21:37.000000', 'consum', 0.0285, 'lps'),
	(623930, 132, '2015-01-01 00:21:38.000000', 'consum', 0.0235, 'lps'),
	(623931, 132, '2015-01-01 00:21:39.000000', 'consum', 0.0270, 'lps'),
	(623932, 132, '2015-01-01 00:21:40.000000', 'consum', 0.0273, 'lps'),
	(623933, 132, '2015-01-01 00:21:41.000000', 'consum', 0.0264, 'lps'),
	(623934, 132, '2015-01-01 00:21:42.000000', 'consum', 0.0210, 'lps'),
	(623935, 132, '2015-01-01 00:21:43.000000', 'consum', 0.0211, 'lps'),
	(623936, 132, '2015-01-01 00:21:44.000000', 'consum', 0.0215, 'lps'),
	(623937, 132, '2015-01-01 00:21:45.000000', 'consum', 0.0234, 'lps'),
	(623938, 132, '2015-01-01 00:21:46.000000', 'consum', 0.0234, 'lps'),
	(623939, 132, '2015-01-01 00:21:47.000000', 'consum', 0.0257, 'lps'),
	(623940, 132, '2015-01-01 00:21:48.000000', 'consum', 0.0213, 'lps'),
	(623941, 132, '2015-01-01 00:21:49.000000', 'consum', 0.0245, 'lps'),
	(623942, 132, '2015-01-01 00:21:50.000000', 'consum', 0.0213, 'lps'),
	(623943, 132, '2015-01-01 00:21:51.000000', 'consum', 0.0285, 'lps'),
	(623944, 132, '2015-01-01 00:21:52.000000', 'consum', 0.0253, 'lps'),
	(623945, 132, '2015-01-01 00:21:53.000000', 'consum', 0.0280, 'lps'),
	(623946, 132, '2015-01-01 00:21:54.000000', 'consum', 0.0269, 'lps'),
	(623947, 132, '2015-01-01 00:21:55.000000', 'consum', 0.0215, 'lps'),
	(623948, 132, '2015-01-01 00:21:56.000000', 'consum', 0.0221, 'lps'),
	(623949, 132, '2015-01-01 00:21:57.000000', 'consum', 0.0249, 'lps'),
	(623950, 132, '2015-01-01 00:21:58.000000', 'consum', 0.0212, 'lps'),
	(623951, 132, '2015-01-01 00:21:59.000000', 'consum', 0.0266, 'lps'),
	(623952, 132, '2015-01-01 00:22:00.000000', 'consum', 0.0242, 'lps'),
	(623953, 132, '2015-01-01 00:22:01.000000', 'consum', 0.0285, 'lps'),
	(623954, 132, '2015-01-01 00:22:02.000000', 'consum', 0.0244, 'lps'),
	(623955, 132, '2015-01-01 00:22:03.000000', 'consum', 0.0237, 'lps'),
	(623956, 132, '2015-01-01 00:22:04.000000', 'consum', 0.0242, 'lps'),
	(623957, 132, '2015-01-01 00:22:05.000000', 'consum', 0.0290, 'lps'),
	(623958, 132, '2015-01-01 00:22:06.000000', 'consum', 0.0271, 'lps'),
	(623959, 132, '2015-01-01 00:22:07.000000', 'consum', 0.0274, 'lps'),
	(623960, 132, '2015-01-01 00:22:08.000000', 'consum', 0.0269, 'lps'),
	(623961, 132, '2015-01-01 00:22:09.000000', 'consum', 0.0231, 'lps'),
	(623962, 132, '2015-01-01 00:22:10.000000', 'consum', 0.0219, 'lps'),
	(623963, 132, '2015-01-01 00:22:11.000000', 'consum', 0.0273, 'lps'),
	(623964, 132, '2015-01-01 00:22:12.000000', 'consum', 0.0256, 'lps'),
	(623965, 132, '2015-01-01 00:22:13.000000', 'consum', 0.0252, 'lps'),
	(623966, 132, '2015-01-01 00:22:14.000000', 'consum', 0.0280, 'lps'),
	(623967, 132, '2015-01-01 00:22:15.000000', 'consum', 0.0276, 'lps'),
	(623968, 132, '2015-01-01 00:22:16.000000', 'consum', 0.0247, 'lps'),
	(623969, 132, '2015-01-01 00:22:17.000000', 'consum', 0.0278, 'lps'),
	(623970, 132, '2015-01-01 00:22:18.000000', 'consum', 0.0280, 'lps'),
	(623971, 132, '2015-01-01 00:22:19.000000', 'consum', 0.0276, 'lps'),
	(623972, 132, '2015-01-01 00:22:20.000000', 'consum', 0.0250, 'lps'),
	(623973, 132, '2015-01-01 00:22:21.000000', 'consum', 0.0210, 'lps'),
	(623974, 132, '2015-01-01 00:22:22.000000', 'consum', 0.0252, 'lps'),
	(623975, 132, '2015-01-01 00:22:23.000000', 'consum', 0.0259, 'lps'),
	(623976, 132, '2015-01-01 00:22:24.000000', 'consum', 0.0247, 'lps'),
	(623977, 132, '2015-01-01 00:22:25.000000', 'consum', 0.0249, 'lps'),
	(623978, 132, '2015-01-01 00:22:26.000000', 'consum', 0.0215, 'lps'),
	(623979, 132, '2015-01-01 00:22:27.000000', 'consum', 0.0278, 'lps'),
	(623980, 132, '2015-01-01 00:22:28.000000', 'consum', 0.0211, 'lps'),
	(623981, 132, '2015-01-01 00:22:29.000000', 'consum', 0.0258, 'lps'),
	(623982, 132, '2015-01-01 00:22:30.000000', 'consum', 0.0283, 'lps'),
	(623983, 132, '2015-01-01 00:22:31.000000', 'consum', 0.0272, 'lps'),
	(623984, 132, '2015-01-01 00:22:32.000000', 'consum', 0.0218, 'lps'),
	(623985, 132, '2015-01-01 00:22:33.000000', 'consum', 0.0226, 'lps'),
	(623986, 132, '2015-01-01 00:22:34.000000', 'consum', 0.0269, 'lps'),
	(623987, 132, '2015-01-01 00:22:35.000000', 'consum', 0.0214, 'lps'),
	(623988, 132, '2015-01-01 00:22:36.000000', 'consum', 0.0216, 'lps'),
	(623989, 132, '2015-01-01 00:22:37.000000', 'consum', 0.0226, 'lps'),
	(623990, 132, '2015-01-01 00:22:38.000000', 'consum', 0.0276, 'lps'),
	(623991, 132, '2015-01-01 00:22:39.000000', 'consum', 0.0247, 'lps'),
	(623992, 132, '2015-01-01 00:22:40.000000', 'consum', 0.0280, 'lps'),
	(623993, 132, '2015-01-01 00:22:41.000000', 'consum', 0.0286, 'lps'),
	(623994, 132, '2015-01-01 00:22:42.000000', 'consum', 0.0219, 'lps'),
	(623995, 132, '2015-01-01 00:22:43.000000', 'consum', 0.0269, 'lps'),
	(623996, 132, '2015-01-01 00:22:44.000000', 'consum', 0.0237, 'lps'),
	(623997, 132, '2015-01-01 00:22:45.000000', 'consum', 0.0251, 'lps'),
	(623998, 132, '2015-01-01 00:22:46.000000', 'consum', 0.0251, 'lps'),
	(623999, 132, '2015-01-01 00:22:47.000000', 'consum', 0.0211, 'lps'),
	(624000, 132, '2015-01-01 00:22:48.000000', 'consum', 0.0255, 'lps'),
	(624001, 132, '2015-01-01 00:22:49.000000', 'consum', 0.0271, 'lps'),
	(624002, 132, '2015-01-01 00:22:50.000000', 'consum', 0.0218, 'lps'),
	(624003, 132, '2015-01-01 00:22:51.000000', 'consum', 0.0229, 'lps'),
	(624004, 132, '2015-01-01 00:22:52.000000', 'consum', 0.0284, 'lps'),
	(624005, 132, '2015-01-01 00:22:53.000000', 'consum', 0.0280, 'lps'),
	(624006, 132, '2015-01-01 00:22:54.000000', 'consum', 0.0256, 'lps'),
	(624007, 132, '2015-01-01 00:22:55.000000', 'consum', 0.0232, 'lps'),
	(624008, 132, '2015-01-01 00:22:56.000000', 'consum', 0.0261, 'lps'),
	(624009, 132, '2015-01-01 00:22:57.000000', 'consum', 0.0238, 'lps'),
	(624010, 132, '2015-01-01 00:22:58.000000', 'consum', 0.0278, 'lps'),
	(624011, 132, '2015-01-01 00:22:59.000000', 'consum', 0.0224, 'lps'),
	(624012, 132, '2015-01-01 00:23:00.000000', 'consum', 0.0238, 'lps'),
	(624013, 132, '2015-01-01 00:23:01.000000', 'consum', 0.0228, 'lps'),
	(624014, 132, '2015-01-01 00:23:02.000000', 'consum', 0.0215, 'lps'),
	(624015, 132, '2015-01-01 00:23:03.000000', 'consum', 0.0264, 'lps'),
	(624016, 132, '2015-01-01 00:23:04.000000', 'consum', 0.0224, 'lps'),
	(624017, 132, '2015-01-01 00:23:05.000000', 'consum', 0.0279, 'lps'),
	(624018, 132, '2015-01-01 00:23:06.000000', 'consum', 0.0271, 'lps'),
	(624019, 132, '2015-01-01 00:23:07.000000', 'consum', 0.0229, 'lps'),
	(624020, 132, '2015-01-01 00:23:08.000000', 'consum', 0.0284, 'lps'),
	(624021, 132, '2015-01-01 00:23:09.000000', 'consum', 0.0280, 'lps'),
	(624022, 132, '2015-01-01 00:23:10.000000', 'consum', 0.0259, 'lps'),
	(624023, 132, '2015-01-01 00:23:11.000000', 'consum', 0.0246, 'lps'),
	(624024, 132, '2015-01-01 00:23:12.000000', 'consum', 0.0243, 'lps'),
	(624025, 132, '2015-01-01 00:23:13.000000', 'consum', 0.0266, 'lps'),
	(624026, 132, '2015-01-01 00:23:14.000000', 'consum', 0.0232, 'lps'),
	(624027, 132, '2015-01-01 00:23:15.000000', 'consum', 0.0231, 'lps'),
	(624028, 132, '2015-01-01 00:23:16.000000', 'consum', 0.0249, 'lps'),
	(624029, 132, '2015-01-01 00:23:17.000000', 'consum', 0.0263, 'lps'),
	(624030, 132, '2015-01-01 00:23:18.000000', 'consum', 0.0278, 'lps'),
	(624031, 132, '2015-01-01 00:23:19.000000', 'consum', 0.0227, 'lps'),
	(624032, 132, '2015-01-01 00:23:20.000000', 'consum', 0.0257, 'lps'),
	(624033, 132, '2015-01-01 00:23:21.000000', 'consum', 0.0229, 'lps'),
	(624034, 132, '2015-01-01 00:23:22.000000', 'consum', 0.0247, 'lps'),
	(624035, 132, '2015-01-01 00:23:23.000000', 'consum', 0.0256, 'lps'),
	(624036, 132, '2015-01-01 00:23:24.000000', 'consum', 0.0249, 'lps'),
	(624037, 132, '2015-01-01 00:23:25.000000', 'consum', 0.0266, 'lps'),
	(624038, 132, '2015-01-01 00:23:26.000000', 'consum', 0.0212, 'lps'),
	(624039, 132, '2015-01-01 00:23:27.000000', 'consum', 0.0216, 'lps'),
	(624040, 132, '2015-01-01 00:23:28.000000', 'consum', 0.0234, 'lps'),
	(624041, 132, '2015-01-01 00:23:29.000000', 'consum', 0.0231, 'lps'),
	(624042, 132, '2015-01-01 00:23:30.000000', 'consum', 0.0245, 'lps'),
	(624043, 132, '2015-01-01 00:23:31.000000', 'consum', 0.0243, 'lps'),
	(624044, 132, '2015-01-01 00:23:32.000000', 'consum', 0.0268, 'lps'),
	(624045, 132, '2015-01-01 00:23:33.000000', 'consum', 0.0240, 'lps'),
	(624046, 132, '2015-01-01 00:23:34.000000', 'consum', 0.0266, 'lps'),
	(624047, 132, '2015-01-01 00:23:35.000000', 'consum', 0.0240, 'lps'),
	(624048, 132, '2015-01-01 00:23:36.000000', 'consum', 0.0273, 'lps'),
	(624049, 132, '2015-01-01 00:23:37.000000', 'consum', 0.0274, 'lps'),
	(624050, 132, '2015-01-01 00:23:38.000000', 'consum', 0.0260, 'lps'),
	(624051, 132, '2015-01-01 00:23:39.000000', 'consum', 0.0269, 'lps'),
	(624052, 132, '2015-01-01 00:23:40.000000', 'consum', 0.0275, 'lps'),
	(624053, 132, '2015-01-01 00:23:41.000000', 'consum', 0.0275, 'lps'),
	(624054, 132, '2015-01-01 00:23:42.000000', 'consum', 0.0262, 'lps'),
	(624055, 132, '2015-01-01 00:23:43.000000', 'consum', 0.0275, 'lps'),
	(624056, 132, '2015-01-01 00:23:44.000000', 'consum', 0.0217, 'lps'),
	(624057, 132, '2015-01-01 00:23:45.000000', 'consum', 0.0215, 'lps'),
	(624058, 132, '2015-01-01 00:23:46.000000', 'consum', 0.0211, 'lps'),
	(624059, 132, '2015-01-01 00:23:47.000000', 'consum', 0.0285, 'lps'),
	(624060, 132, '2015-01-01 00:23:48.000000', 'consum', 0.0257, 'lps'),
	(624061, 132, '2015-01-01 00:23:49.000000', 'consum', 0.0219, 'lps'),
	(624062, 132, '2015-01-01 00:23:50.000000', 'consum', 0.0278, 'lps'),
	(624063, 132, '2015-01-01 00:23:51.000000', 'consum', 0.0278, 'lps'),
	(624064, 132, '2015-01-01 00:23:52.000000', 'consum', 0.0268, 'lps'),
	(624065, 132, '2015-01-01 00:23:53.000000', 'consum', 0.0214, 'lps'),
	(624066, 132, '2015-01-01 00:23:54.000000', 'consum', 0.0220, 'lps'),
	(624067, 132, '2015-01-01 00:23:55.000000', 'consum', 0.0248, 'lps'),
	(624068, 132, '2015-01-01 00:23:56.000000', 'consum', 0.0288, 'lps'),
	(624069, 132, '2015-01-01 00:23:57.000000', 'consum', 0.0246, 'lps'),
	(624070, 132, '2015-01-01 00:23:58.000000', 'consum', 0.0238, 'lps'),
	(624071, 132, '2015-01-01 00:23:59.000000', 'consum', 0.0242, 'lps'),
	(624072, 132, '2015-01-01 00:24:00.000000', 'consum', 0.0286, 'lps'),
	(624073, 132, '2015-01-01 00:24:01.000000', 'consum', 0.0252, 'lps'),
	(624074, 132, '2015-01-01 00:24:02.000000', 'consum', 0.0272, 'lps'),
	(624075, 132, '2015-01-01 00:24:03.000000', 'consum', 0.0232, 'lps'),
	(624076, 132, '2015-01-01 00:24:04.000000', 'consum', 0.0218, 'lps'),
	(624077, 132, '2015-01-01 00:24:05.000000', 'consum', 0.0265, 'lps'),
	(624078, 132, '2015-01-01 00:24:06.000000', 'consum', 0.0219, 'lps'),
	(624079, 132, '2015-01-01 00:24:07.000000', 'consum', 0.0251, 'lps'),
	(624080, 132, '2015-01-01 00:24:08.000000', 'consum', 0.0227, 'lps'),
	(624081, 132, '2015-01-01 00:24:09.000000', 'consum', 0.0255, 'lps'),
	(624082, 132, '2015-01-01 00:24:10.000000', 'consum', 0.0222, 'lps'),
	(624083, 132, '2015-01-01 00:24:11.000000', 'consum', 0.0215, 'lps'),
	(624084, 132, '2015-01-01 00:24:12.000000', 'consum', 0.0282, 'lps'),
	(624085, 132, '2015-01-01 00:24:13.000000', 'consum', 0.0233, 'lps'),
	(624086, 132, '2015-01-01 00:24:14.000000', 'consum', 0.0270, 'lps'),
	(624087, 132, '2015-01-01 00:24:15.000000', 'consum', 0.0281, 'lps'),
	(624088, 132, '2015-01-01 00:24:16.000000', 'consum', 0.0221, 'lps'),
	(624089, 132, '2015-01-01 00:24:17.000000', 'consum', 0.0217, 'lps'),
	(624090, 132, '2015-01-01 00:24:18.000000', 'consum', 0.0210, 'lps'),
	(624091, 132, '2015-01-01 00:24:19.000000', 'consum', 0.0271, 'lps'),
	(624092, 132, '2015-01-01 00:24:20.000000', 'consum', 0.0273, 'lps'),
	(624093, 132, '2015-01-01 00:24:21.000000', 'consum', 0.0261, 'lps'),
	(624094, 132, '2015-01-01 00:24:22.000000', 'consum', 0.0276, 'lps'),
	(624095, 132, '2015-01-01 00:24:23.000000', 'consum', 0.0225, 'lps'),
	(624096, 132, '2015-01-01 00:24:24.000000', 'consum', 0.0250, 'lps'),
	(624097, 132, '2015-01-01 00:24:25.000000', 'consum', 0.0286, 'lps'),
	(624098, 132, '2015-01-01 00:24:26.000000', 'consum', 0.0225, 'lps'),
	(624099, 132, '2015-01-01 00:24:27.000000', 'consum', 0.0220, 'lps'),
	(624100, 132, '2015-01-01 00:24:28.000000', 'consum', 0.0214, 'lps'),
	(624101, 132, '2015-01-01 00:24:29.000000', 'consum', 0.0283, 'lps'),
	(624102, 132, '2015-01-01 00:24:30.000000', 'consum', 0.0241, 'lps'),
	(624103, 132, '2015-01-01 00:24:31.000000', 'consum', 0.0228, 'lps'),
	(624104, 132, '2015-01-01 00:24:32.000000', 'consum', 0.0289, 'lps'),
	(624105, 132, '2015-01-01 00:24:33.000000', 'consum', 0.0226, 'lps'),
	(624106, 132, '2015-01-01 00:24:34.000000', 'consum', 0.0218, 'lps'),
	(624107, 132, '2015-01-01 00:24:35.000000', 'consum', 0.0280, 'lps'),
	(624108, 132, '2015-01-01 00:24:36.000000', 'consum', 0.0215, 'lps'),
	(624109, 132, '2015-01-01 00:24:37.000000', 'consum', 0.0269, 'lps'),
	(624110, 132, '2015-01-01 00:24:38.000000', 'consum', 0.0245, 'lps'),
	(624111, 132, '2015-01-01 00:24:39.000000', 'consum', 0.0290, 'lps'),
	(624112, 132, '2015-01-01 00:24:40.000000', 'consum', 0.0264, 'lps'),
	(624113, 132, '2015-01-01 00:24:41.000000', 'consum', 0.0238, 'lps'),
	(624114, 132, '2015-01-01 00:24:42.000000', 'consum', 0.0269, 'lps'),
	(624115, 132, '2015-01-01 00:24:43.000000', 'consum', 0.0262, 'lps'),
	(624116, 132, '2015-01-01 00:24:44.000000', 'consum', 0.0212, 'lps'),
	(624117, 132, '2015-01-01 00:24:45.000000', 'consum', 0.0224, 'lps'),
	(624118, 132, '2015-01-01 00:24:46.000000', 'consum', 0.0278, 'lps'),
	(624119, 132, '2015-01-01 00:24:47.000000', 'consum', 0.0264, 'lps'),
	(624120, 132, '2015-01-01 00:24:48.000000', 'consum', 0.0276, 'lps'),
	(624121, 132, '2015-01-01 00:24:49.000000', 'consum', 0.0216, 'lps'),
	(624122, 132, '2015-01-01 00:24:50.000000', 'consum', 0.0284, 'lps'),
	(624123, 132, '2015-01-01 00:24:51.000000', 'consum', 0.0241, 'lps'),
	(624124, 132, '2015-01-01 00:24:52.000000', 'consum', 0.0225, 'lps'),
	(624125, 132, '2015-01-01 00:24:53.000000', 'consum', 0.0272, 'lps'),
	(624126, 132, '2015-01-01 00:24:54.000000', 'consum', 0.0235, 'lps'),
	(624127, 132, '2015-01-01 00:24:55.000000', 'consum', 0.0229, 'lps'),
	(624128, 132, '2015-01-01 00:24:56.000000', 'consum', 0.0231, 'lps'),
	(624129, 132, '2015-01-01 00:24:57.000000', 'consum', 0.0259, 'lps'),
	(624130, 132, '2015-01-01 00:24:58.000000', 'consum', 0.0231, 'lps'),
	(624131, 132, '2015-01-01 00:24:59.000000', 'consum', 0.0247, 'lps'),
	(624132, 132, '2015-01-01 00:25:00.000000', 'consum', 0.0255, 'lps'),
	(624133, 132, '2015-01-01 00:25:01.000000', 'consum', 0.0240, 'lps'),
	(624134, 132, '2015-01-01 00:25:02.000000', 'consum', 0.0228, 'lps'),
	(624135, 132, '2015-01-01 00:25:03.000000', 'consum', 0.0289, 'lps'),
	(624136, 132, '2015-01-01 00:25:04.000000', 'consum', 0.0228, 'lps'),
	(624137, 132, '2015-01-01 00:25:05.000000', 'consum', 0.0224, 'lps'),
	(624138, 132, '2015-01-01 00:25:06.000000', 'consum', 0.0229, 'lps'),
	(624139, 132, '2015-01-01 00:25:07.000000', 'consum', 0.0261, 'lps'),
	(624140, 132, '2015-01-01 00:25:08.000000', 'consum', 0.0249, 'lps'),
	(624141, 132, '2015-01-01 00:25:09.000000', 'consum', 0.0253, 'lps'),
	(624142, 132, '2015-01-01 00:25:10.000000', 'consum', 0.0225, 'lps'),
	(624143, 132, '2015-01-01 00:25:11.000000', 'consum', 0.0240, 'lps'),
	(624144, 132, '2015-01-01 00:25:12.000000', 'consum', 0.0235, 'lps'),
	(624145, 132, '2015-01-01 00:25:13.000000', 'consum', 0.0243, 'lps'),
	(624146, 132, '2015-01-01 00:25:14.000000', 'consum', 0.0221, 'lps'),
	(624147, 132, '2015-01-01 00:25:15.000000', 'consum', 0.0249, 'lps'),
	(624148, 132, '2015-01-01 00:25:16.000000', 'consum', 0.0210, 'lps'),
	(624149, 132, '2015-01-01 00:25:17.000000', 'consum', 0.0255, 'lps'),
	(624150, 132, '2015-01-01 00:25:18.000000', 'consum', 0.0274, 'lps'),
	(624151, 132, '2015-01-01 00:25:19.000000', 'consum', 0.0233, 'lps'),
	(624152, 132, '2015-01-01 00:25:20.000000', 'consum', 0.0213, 'lps'),
	(624153, 132, '2015-01-01 00:25:21.000000', 'consum', 0.0238, 'lps'),
	(624154, 132, '2015-01-01 00:25:22.000000', 'consum', 0.0260, 'lps'),
	(624155, 132, '2015-01-01 00:25:23.000000', 'consum', 0.0213, 'lps'),
	(624156, 132, '2015-01-01 00:25:24.000000', 'consum', 0.0240, 'lps'),
	(624157, 132, '2015-01-01 00:25:25.000000', 'consum', 0.0271, 'lps'),
	(624158, 132, '2015-01-01 00:25:26.000000', 'consum', 0.0261, 'lps'),
	(624159, 132, '2015-01-01 00:25:27.000000', 'consum', 0.0284, 'lps'),
	(624160, 132, '2015-01-01 00:25:28.000000', 'consum', 0.0266, 'lps'),
	(624161, 132, '2015-01-01 00:25:29.000000', 'consum', 0.0268, 'lps'),
	(624162, 132, '2015-01-01 00:25:30.000000', 'consum', 0.0254, 'lps'),
	(624163, 132, '2015-01-01 00:25:31.000000', 'consum', 0.0253, 'lps'),
	(624164, 132, '2015-01-01 00:25:32.000000', 'consum', 0.0215, 'lps'),
	(624165, 132, '2015-01-01 00:25:33.000000', 'consum', 0.0266, 'lps'),
	(624166, 132, '2015-01-01 00:25:34.000000', 'consum', 0.0233, 'lps'),
	(624167, 132, '2015-01-01 00:25:35.000000', 'consum', 0.0240, 'lps'),
	(624168, 132, '2015-01-01 00:25:36.000000', 'consum', 0.0289, 'lps'),
	(624169, 132, '2015-01-01 00:25:37.000000', 'consum', 0.0272, 'lps'),
	(624170, 132, '2015-01-01 00:25:38.000000', 'consum', 0.0285, 'lps'),
	(624171, 132, '2015-01-01 00:25:39.000000', 'consum', 0.0237, 'lps'),
	(624172, 132, '2015-01-01 00:25:40.000000', 'consum', 0.0283, 'lps'),
	(624173, 132, '2015-01-01 00:25:41.000000', 'consum', 0.0251, 'lps'),
	(624174, 132, '2015-01-01 00:25:42.000000', 'consum', 0.0278, 'lps'),
	(624175, 132, '2015-01-01 00:25:43.000000', 'consum', 0.0266, 'lps'),
	(624176, 132, '2015-01-01 00:25:44.000000', 'consum', 0.0288, 'lps'),
	(624177, 132, '2015-01-01 00:25:45.000000', 'consum', 0.0269, 'lps'),
	(624178, 132, '2015-01-01 00:25:46.000000', 'consum', 0.0273, 'lps'),
	(624179, 132, '2015-01-01 00:25:47.000000', 'consum', 0.0267, 'lps'),
	(624180, 132, '2015-01-01 00:25:48.000000', 'consum', 0.0225, 'lps'),
	(624181, 132, '2015-01-01 00:25:49.000000', 'consum', 0.0275, 'lps'),
	(624182, 132, '2015-01-01 00:25:50.000000', 'consum', 0.0250, 'lps'),
	(624183, 132, '2015-01-01 00:25:51.000000', 'consum', 0.0216, 'lps'),
	(624184, 132, '2015-01-01 00:25:52.000000', 'consum', 0.0281, 'lps'),
	(624185, 132, '2015-01-01 00:25:53.000000', 'consum', 0.0226, 'lps'),
	(624186, 132, '2015-01-01 00:25:54.000000', 'consum', 0.0236, 'lps'),
	(624187, 132, '2015-01-01 00:25:55.000000', 'consum', 0.0213, 'lps'),
	(624188, 132, '2015-01-01 00:25:56.000000', 'consum', 0.0229, 'lps'),
	(624189, 132, '2015-01-01 00:25:57.000000', 'consum', 0.0216, 'lps'),
	(624190, 132, '2015-01-01 00:25:58.000000', 'consum', 0.0265, 'lps'),
	(624191, 132, '2015-01-01 00:25:59.000000', 'consum', 0.0223, 'lps'),
	(624192, 132, '2015-01-01 00:26:00.000000', 'consum', 0.0272, 'lps'),
	(624193, 132, '2015-01-01 00:26:01.000000', 'consum', 0.0240, 'lps'),
	(624194, 132, '2015-01-01 00:26:02.000000', 'consum', 0.0253, 'lps'),
	(624195, 132, '2015-01-01 00:26:03.000000', 'consum', 0.0255, 'lps'),
	(624196, 132, '2015-01-01 00:26:04.000000', 'consum', 0.0228, 'lps'),
	(624197, 132, '2015-01-01 00:26:05.000000', 'consum', 0.0246, 'lps'),
	(624198, 132, '2015-01-01 00:26:06.000000', 'consum', 0.0253, 'lps'),
	(624199, 132, '2015-01-01 00:26:07.000000', 'consum', 0.0239, 'lps'),
	(624200, 132, '2015-01-01 00:26:08.000000', 'consum', 0.0226, 'lps'),
	(624201, 132, '2015-01-01 00:26:09.000000', 'consum', 0.0286, 'lps'),
	(624202, 132, '2015-01-01 00:26:10.000000', 'consum', 0.0219, 'lps'),
	(624203, 132, '2015-01-01 00:26:11.000000', 'consum', 0.0270, 'lps'),
	(624204, 132, '2015-01-01 00:26:12.000000', 'consum', 0.0238, 'lps'),
	(624205, 132, '2015-01-01 00:26:13.000000', 'consum', 0.0254, 'lps'),
	(624206, 132, '2015-01-01 00:26:14.000000', 'consum', 0.0264, 'lps'),
	(624207, 132, '2015-01-01 00:26:15.000000', 'consum', 0.0267, 'lps'),
	(624208, 132, '2015-01-01 00:26:16.000000', 'consum', 0.0252, 'lps'),
	(624209, 132, '2015-01-01 00:26:17.000000', 'consum', 0.0252, 'lps'),
	(624210, 132, '2015-01-01 00:26:18.000000', 'consum', 0.0211, 'lps'),
	(624211, 132, '2015-01-01 00:26:19.000000', 'consum', 0.0254, 'lps'),
	(624212, 132, '2015-01-01 00:26:20.000000', 'consum', 0.0265, 'lps'),
	(624213, 132, '2015-01-01 00:26:21.000000', 'consum', 0.0274, 'lps'),
	(624214, 132, '2015-01-01 00:26:22.000000', 'consum', 0.0281, 'lps'),
	(624215, 132, '2015-01-01 00:26:23.000000', 'consum', 0.0214, 'lps'),
	(624216, 132, '2015-01-01 00:26:24.000000', 'consum', 0.0261, 'lps'),
	(624217, 132, '2015-01-01 00:26:25.000000', 'consum', 0.0290, 'lps'),
	(624218, 132, '2015-01-01 00:26:26.000000', 'consum', 0.0213, 'lps'),
	(624219, 132, '2015-01-01 00:26:27.000000', 'consum', 0.0231, 'lps'),
	(624220, 132, '2015-01-01 00:26:28.000000', 'consum', 0.0226, 'lps'),
	(624221, 132, '2015-01-01 00:26:29.000000', 'consum', 0.0227, 'lps'),
	(624222, 132, '2015-01-01 00:26:30.000000', 'consum', 0.0249, 'lps'),
	(624223, 132, '2015-01-01 00:26:31.000000', 'consum', 0.0271, 'lps'),
	(624224, 132, '2015-01-01 00:26:32.000000', 'consum', 0.0238, 'lps'),
	(624225, 132, '2015-01-01 00:26:33.000000', 'consum', 0.0247, 'lps'),
	(624226, 132, '2015-01-01 00:26:34.000000', 'consum', 0.0233, 'lps'),
	(624227, 132, '2015-01-01 00:26:35.000000', 'consum', 0.0213, 'lps'),
	(624228, 132, '2015-01-01 00:26:36.000000', 'consum', 0.0236, 'lps'),
	(624229, 132, '2015-01-01 00:26:37.000000', 'consum', 0.0252, 'lps'),
	(624230, 132, '2015-01-01 00:26:38.000000', 'consum', 0.0260, 'lps'),
	(624231, 132, '2015-01-01 00:26:39.000000', 'consum', 0.0253, 'lps'),
	(624232, 132, '2015-01-01 00:26:40.000000', 'consum', 0.0278, 'lps'),
	(624233, 132, '2015-01-01 00:26:41.000000', 'consum', 0.0257, 'lps'),
	(624234, 132, '2015-01-01 00:26:42.000000', 'consum', 0.0241, 'lps'),
	(624235, 132, '2015-01-01 00:26:43.000000', 'consum', 0.0227, 'lps'),
	(624236, 132, '2015-01-01 00:26:44.000000', 'consum', 0.0284, 'lps'),
	(624237, 132, '2015-01-01 00:26:45.000000', 'consum', 0.0287, 'lps'),
	(624238, 132, '2015-01-01 00:26:46.000000', 'consum', 0.0290, 'lps'),
	(624239, 132, '2015-01-01 00:26:47.000000', 'consum', 0.0217, 'lps'),
	(624240, 132, '2015-01-01 00:26:48.000000', 'consum', 0.0251, 'lps'),
	(624241, 132, '2015-01-01 00:26:49.000000', 'consum', 0.0233, 'lps'),
	(624242, 132, '2015-01-01 00:26:50.000000', 'consum', 0.0285, 'lps'),
	(624243, 132, '2015-01-01 00:26:51.000000', 'consum', 0.0270, 'lps'),
	(624244, 132, '2015-01-01 00:26:52.000000', 'consum', 0.0286, 'lps'),
	(624245, 132, '2015-01-01 00:26:53.000000', 'consum', 0.0249, 'lps'),
	(624246, 132, '2015-01-01 00:26:54.000000', 'consum', 0.0260, 'lps'),
	(624247, 132, '2015-01-01 00:26:55.000000', 'consum', 0.0263, 'lps'),
	(624248, 132, '2015-01-01 00:26:56.000000', 'consum', 0.0244, 'lps'),
	(624249, 132, '2015-01-01 00:26:57.000000', 'consum', 0.0221, 'lps'),
	(624250, 132, '2015-01-01 00:26:58.000000', 'consum', 0.0244, 'lps'),
	(624251, 132, '2015-01-01 00:26:59.000000', 'consum', 0.0267, 'lps'),
	(624252, 132, '2015-01-01 00:27:00.000000', 'consum', 0.0230, 'lps'),
	(624253, 132, '2015-01-01 00:27:01.000000', 'consum', 0.0220, 'lps'),
	(624254, 132, '2015-01-01 00:27:02.000000', 'consum', 0.0281, 'lps'),
	(624255, 132, '2015-01-01 00:27:03.000000', 'consum', 0.0211, 'lps'),
	(624256, 132, '2015-01-01 00:27:04.000000', 'consum', 0.0246, 'lps'),
	(624257, 132, '2015-01-01 00:27:05.000000', 'consum', 0.0224, 'lps'),
	(624258, 132, '2015-01-01 00:27:06.000000', 'consum', 0.0255, 'lps'),
	(624259, 132, '2015-01-01 00:27:07.000000', 'consum', 0.0230, 'lps'),
	(624260, 132, '2015-01-01 00:27:08.000000', 'consum', 0.0257, 'lps'),
	(624261, 132, '2015-01-01 00:27:09.000000', 'consum', 0.0226, 'lps'),
	(624262, 132, '2015-01-01 00:27:10.000000', 'consum', 0.0227, 'lps'),
	(624263, 132, '2015-01-01 00:27:11.000000', 'consum', 0.0250, 'lps'),
	(624264, 132, '2015-01-01 00:27:12.000000', 'consum', 0.0277, 'lps'),
	(624265, 132, '2015-01-01 00:27:13.000000', 'consum', 0.0265, 'lps'),
	(624266, 132, '2015-01-01 00:27:14.000000', 'consum', 0.0285, 'lps'),
	(624267, 132, '2015-01-01 00:27:15.000000', 'consum', 0.0257, 'lps'),
	(624268, 132, '2015-01-01 00:27:16.000000', 'consum', 0.0221, 'lps'),
	(624269, 132, '2015-01-01 00:27:17.000000', 'consum', 0.0286, 'lps'),
	(624270, 132, '2015-01-01 00:27:18.000000', 'consum', 0.0233, 'lps'),
	(624271, 132, '2015-01-01 00:27:19.000000', 'consum', 0.0262, 'lps'),
	(624272, 132, '2015-01-01 00:27:20.000000', 'consum', 0.0238, 'lps'),
	(624273, 132, '2015-01-01 00:27:21.000000', 'consum', 0.0277, 'lps'),
	(624274, 132, '2015-01-01 00:27:22.000000', 'consum', 0.0217, 'lps'),
	(624275, 132, '2015-01-01 00:27:23.000000', 'consum', 0.0287, 'lps'),
	(624276, 132, '2015-01-01 00:27:24.000000', 'consum', 0.0250, 'lps'),
	(624277, 132, '2015-01-01 00:27:25.000000', 'consum', 0.0262, 'lps'),
	(624278, 132, '2015-01-01 00:27:26.000000', 'consum', 0.0268, 'lps'),
	(624279, 132, '2015-01-01 00:27:27.000000', 'consum', 0.0263, 'lps'),
	(624280, 132, '2015-01-01 00:27:28.000000', 'consum', 0.0220, 'lps'),
	(624281, 132, '2015-01-01 00:27:29.000000', 'consum', 0.0264, 'lps'),
	(624282, 132, '2015-01-01 00:27:30.000000', 'consum', 0.0288, 'lps'),
	(624283, 132, '2015-01-01 00:27:31.000000', 'consum', 0.0275, 'lps'),
	(624284, 132, '2015-01-01 00:27:32.000000', 'consum', 0.0224, 'lps'),
	(624285, 132, '2015-01-01 00:27:33.000000', 'consum', 0.0246, 'lps'),
	(624286, 132, '2015-01-01 00:27:34.000000', 'consum', 0.0268, 'lps'),
	(624287, 132, '2015-01-01 00:27:35.000000', 'consum', 0.0228, 'lps'),
	(624288, 132, '2015-01-01 00:27:36.000000', 'consum', 0.0211, 'lps'),
	(624289, 132, '2015-01-01 00:27:37.000000', 'consum', 0.0242, 'lps'),
	(624290, 132, '2015-01-01 00:27:38.000000', 'consum', 0.0284, 'lps'),
	(624291, 132, '2015-01-01 00:27:39.000000', 'consum', 0.0245, 'lps'),
	(624292, 132, '2015-01-01 00:27:40.000000', 'consum', 0.0242, 'lps'),
	(624293, 132, '2015-01-01 00:27:41.000000', 'consum', 0.0268, 'lps'),
	(624294, 132, '2015-01-01 00:27:42.000000', 'consum', 0.0239, 'lps'),
	(624295, 132, '2015-01-01 00:27:43.000000', 'consum', 0.0265, 'lps'),
	(624296, 132, '2015-01-01 00:27:44.000000', 'consum', 0.0234, 'lps'),
	(624297, 132, '2015-01-01 00:27:45.000000', 'consum', 0.0248, 'lps'),
	(624298, 132, '2015-01-01 00:27:46.000000', 'consum', 0.0246, 'lps'),
	(624299, 132, '2015-01-01 00:27:47.000000', 'consum', 0.0276, 'lps'),
	(624300, 132, '2015-01-01 00:27:48.000000', 'consum', 0.0272, 'lps'),
	(624301, 132, '2015-01-01 00:27:49.000000', 'consum', 0.0241, 'lps'),
	(624302, 132, '2015-01-01 00:27:50.000000', 'consum', 0.0260, 'lps'),
	(624303, 132, '2015-01-01 00:27:51.000000', 'consum', 0.0286, 'lps'),
	(624304, 132, '2015-01-01 00:27:52.000000', 'consum', 0.0278, 'lps'),
	(624305, 132, '2015-01-01 00:27:53.000000', 'consum', 0.0243, 'lps'),
	(624306, 132, '2015-01-01 00:27:54.000000', 'consum', 0.0253, 'lps'),
	(624307, 132, '2015-01-01 00:27:55.000000', 'consum', 0.0247, 'lps'),
	(624308, 132, '2015-01-01 00:27:56.000000', 'consum', 0.0265, 'lps'),
	(624309, 132, '2015-01-01 00:27:57.000000', 'consum', 0.0211, 'lps'),
	(624310, 132, '2015-01-01 00:27:58.000000', 'consum', 0.0212, 'lps'),
	(624311, 132, '2015-01-01 00:27:59.000000', 'consum', 0.0220, 'lps'),
	(624312, 132, '2015-01-01 00:28:00.000000', 'consum', 0.0252, 'lps'),
	(624313, 132, '2015-01-01 00:28:01.000000', 'consum', 0.0227, 'lps'),
	(624314, 132, '2015-01-01 00:28:02.000000', 'consum', 0.0254, 'lps'),
	(624315, 132, '2015-01-01 00:28:03.000000', 'consum', 0.0217, 'lps'),
	(624316, 132, '2015-01-01 00:28:04.000000', 'consum', 0.0274, 'lps'),
	(624317, 132, '2015-01-01 00:28:05.000000', 'consum', 0.0267, 'lps'),
	(624318, 132, '2015-01-01 00:28:06.000000', 'consum', 0.0222, 'lps'),
	(624319, 132, '2015-01-01 00:28:07.000000', 'consum', 0.0262, 'lps'),
	(624320, 132, '2015-01-01 00:28:08.000000', 'consum', 0.0271, 'lps'),
	(624321, 132, '2015-01-01 00:28:09.000000', 'consum', 0.0279, 'lps'),
	(624322, 132, '2015-01-01 00:28:10.000000', 'consum', 0.0211, 'lps'),
	(624323, 132, '2015-01-01 00:28:11.000000', 'consum', 0.0251, 'lps'),
	(624324, 132, '2015-01-01 00:28:12.000000', 'consum', 0.0250, 'lps'),
	(624325, 132, '2015-01-01 00:28:13.000000', 'consum', 0.0289, 'lps'),
	(624326, 132, '2015-01-01 00:28:14.000000', 'consum', 0.0242, 'lps'),
	(624327, 132, '2015-01-01 00:28:15.000000', 'consum', 0.0215, 'lps'),
	(624328, 132, '2015-01-01 00:28:16.000000', 'consum', 0.0222, 'lps'),
	(624329, 132, '2015-01-01 00:28:17.000000', 'consum', 0.0255, 'lps'),
	(624330, 132, '2015-01-01 00:28:18.000000', 'consum', 0.0235, 'lps'),
	(624331, 132, '2015-01-01 00:28:19.000000', 'consum', 0.0282, 'lps'),
	(624332, 132, '2015-01-01 00:28:20.000000', 'consum', 0.0255, 'lps'),
	(624333, 132, '2015-01-01 00:28:21.000000', 'consum', 0.0217, 'lps'),
	(624334, 132, '2015-01-01 00:28:22.000000', 'consum', 0.0274, 'lps'),
	(624335, 132, '2015-01-01 00:28:23.000000', 'consum', 0.0265, 'lps'),
	(624336, 132, '2015-01-01 00:28:24.000000', 'consum', 0.0215, 'lps'),
	(624337, 132, '2015-01-01 00:28:25.000000', 'consum', 0.0232, 'lps'),
	(624338, 132, '2015-01-01 00:28:26.000000', 'consum', 0.0225, 'lps'),
	(624339, 132, '2015-01-01 00:28:27.000000', 'consum', 0.0219, 'lps'),
	(624340, 132, '2015-01-01 00:28:28.000000', 'consum', 0.0290, 'lps'),
	(624341, 132, '2015-01-01 00:28:29.000000', 'consum', 0.0261, 'lps'),
	(624342, 132, '2015-01-01 00:28:30.000000', 'consum', 0.0226, 'lps'),
	(624343, 132, '2015-01-01 00:28:31.000000', 'consum', 0.0216, 'lps'),
	(624344, 132, '2015-01-01 00:28:32.000000', 'consum', 0.0274, 'lps'),
	(624345, 132, '2015-01-01 00:28:33.000000', 'consum', 0.0270, 'lps'),
	(624346, 132, '2015-01-01 00:28:34.000000', 'consum', 0.0237, 'lps'),
	(624347, 132, '2015-01-01 00:28:35.000000', 'consum', 0.0249, 'lps'),
	(624348, 132, '2015-01-01 00:28:36.000000', 'consum', 0.0241, 'lps'),
	(624349, 132, '2015-01-01 00:28:37.000000', 'consum', 0.0248, 'lps'),
	(624350, 132, '2015-01-01 00:28:38.000000', 'consum', 0.0228, 'lps'),
	(624351, 132, '2015-01-01 00:28:39.000000', 'consum', 0.0267, 'lps'),
	(624352, 132, '2015-01-01 00:28:40.000000', 'consum', 0.0279, 'lps'),
	(624353, 132, '2015-01-01 00:28:41.000000', 'consum', 0.0223, 'lps'),
	(624354, 132, '2015-01-01 00:28:42.000000', 'consum', 0.0232, 'lps'),
	(624355, 132, '2015-01-01 00:28:43.000000', 'consum', 0.0280, 'lps'),
	(624356, 132, '2015-01-01 00:28:44.000000', 'consum', 0.0252, 'lps'),
	(624357, 132, '2015-01-01 00:28:45.000000', 'consum', 0.0210, 'lps'),
	(624358, 132, '2015-01-01 00:28:46.000000', 'consum', 0.0245, 'lps'),
	(624359, 132, '2015-01-01 00:28:47.000000', 'consum', 0.0224, 'lps'),
	(624360, 132, '2015-01-01 00:28:48.000000', 'consum', 0.0258, 'lps'),
	(624361, 132, '2015-01-01 00:28:49.000000', 'consum', 0.0247, 'lps'),
	(624362, 132, '2015-01-01 00:28:50.000000', 'consum', 0.0250, 'lps'),
	(624363, 132, '2015-01-01 00:28:51.000000', 'consum', 0.0219, 'lps'),
	(624364, 132, '2015-01-01 00:28:52.000000', 'consum', 0.0218, 'lps'),
	(624365, 132, '2015-01-01 00:28:53.000000', 'consum', 0.0223, 'lps'),
	(624366, 132, '2015-01-01 00:28:54.000000', 'consum', 0.0249, 'lps'),
	(624367, 132, '2015-01-01 00:28:55.000000', 'consum', 0.0287, 'lps'),
	(624368, 132, '2015-01-01 00:28:56.000000', 'consum', 0.0235, 'lps'),
	(624369, 132, '2015-01-01 00:28:57.000000', 'consum', 0.0268, 'lps'),
	(624370, 132, '2015-01-01 00:28:58.000000', 'consum', 0.0261, 'lps'),
	(624371, 132, '2015-01-01 00:28:59.000000', 'consum', 0.0211, 'lps'),
	(624372, 132, '2015-01-01 00:29:00.000000', 'consum', 0.0224, 'lps'),
	(624373, 132, '2015-01-01 00:29:01.000000', 'consum', 0.0279, 'lps'),
	(624374, 132, '2015-01-01 00:29:02.000000', 'consum', 0.0272, 'lps'),
	(624375, 132, '2015-01-01 00:29:03.000000', 'consum', 0.0229, 'lps'),
	(624376, 132, '2015-01-01 00:29:04.000000', 'consum', 0.0284, 'lps'),
	(624377, 132, '2015-01-01 00:29:05.000000', 'consum', 0.0281, 'lps'),
	(624378, 132, '2015-01-01 00:29:06.000000', 'consum', 0.0263, 'lps'),
	(624379, 132, '2015-01-01 00:29:07.000000', 'consum', 0.0261, 'lps'),
	(624380, 132, '2015-01-01 00:29:08.000000', 'consum', 0.0228, 'lps'),
	(624381, 132, '2015-01-01 00:29:09.000000', 'consum', 0.0225, 'lps'),
	(624382, 132, '2015-01-01 00:29:10.000000', 'consum', 0.0233, 'lps'),
	(624383, 132, '2015-01-01 00:29:11.000000', 'consum', 0.0282, 'lps'),
	(624384, 132, '2015-01-01 00:29:12.000000', 'consum', 0.0256, 'lps'),
	(624385, 132, '2015-01-01 00:29:13.000000', 'consum', 0.0225, 'lps'),
	(624386, 132, '2015-01-01 00:29:14.000000', 'consum', 0.0229, 'lps'),
	(624387, 132, '2015-01-01 00:29:15.000000', 'consum', 0.0261, 'lps'),
	(624388, 132, '2015-01-01 00:29:16.000000', 'consum', 0.0245, 'lps'),
	(624389, 132, '2015-01-01 00:29:17.000000', 'consum', 0.0234, 'lps'),
	(624390, 132, '2015-01-01 00:29:18.000000', 'consum', 0.0226, 'lps'),
	(624391, 132, '2015-01-01 00:29:19.000000', 'consum', 0.0216, 'lps'),
	(624392, 132, '2015-01-01 00:29:20.000000', 'consum', 0.0275, 'lps'),
	(624393, 132, '2015-01-01 00:29:21.000000', 'consum', 0.0275, 'lps'),
	(624394, 132, '2015-01-01 00:29:22.000000', 'consum', 0.0260, 'lps'),
	(624395, 132, '2015-01-01 00:29:23.000000', 'consum', 0.0265, 'lps'),
	(624396, 132, '2015-01-01 00:29:24.000000', 'consum', 0.0255, 'lps'),
	(624397, 132, '2015-01-01 00:29:25.000000', 'consum', 0.0269, 'lps'),
	(624398, 132, '2015-01-01 00:29:26.000000', 'consum', 0.0290, 'lps'),
	(624399, 132, '2015-01-01 00:29:27.000000', 'consum', 0.0271, 'lps'),
	(624400, 132, '2015-01-01 00:29:28.000000', 'consum', 0.0277, 'lps'),
	(624401, 132, '2015-01-01 00:29:29.000000', 'consum', 0.0283, 'lps'),
	(624402, 132, '2015-01-01 00:29:30.000000', 'consum', 0.0210, 'lps'),
	(624403, 132, '2015-01-01 00:29:31.000000', 'consum', 0.0237, 'lps'),
	(624404, 132, '2015-01-01 00:29:32.000000', 'consum', 0.0263, 'lps'),
	(624405, 132, '2015-01-01 00:29:33.000000', 'consum', 0.0231, 'lps'),
	(624406, 132, '2015-01-01 00:29:34.000000', 'consum', 0.0240, 'lps'),
	(624407, 132, '2015-01-01 00:29:35.000000', 'consum', 0.0217, 'lps'),
	(624408, 132, '2015-01-01 00:29:36.000000', 'consum', 0.0237, 'lps'),
	(624409, 132, '2015-01-01 00:29:37.000000', 'consum', 0.0242, 'lps'),
	(624410, 132, '2015-01-01 00:29:38.000000', 'consum', 0.0290, 'lps'),
	(624411, 132, '2015-01-01 00:29:39.000000', 'consum', 0.0270, 'lps'),
	(624412, 132, '2015-01-01 00:29:40.000000', 'consum', 0.0272, 'lps'),
	(624413, 132, '2015-01-01 00:29:41.000000', 'consum', 0.0260, 'lps'),
	(624414, 132, '2015-01-01 00:29:42.000000', 'consum', 0.0275, 'lps'),
	(624415, 132, '2015-01-01 00:29:43.000000', 'consum', 0.0225, 'lps'),
	(624416, 132, '2015-01-01 00:29:44.000000', 'consum', 0.0250, 'lps'),
	(624417, 132, '2015-01-01 00:29:45.000000', 'consum', 0.0284, 'lps'),
	(624418, 132, '2015-01-01 00:29:46.000000', 'consum', 0.0218, 'lps'),
	(624419, 132, '2015-01-01 00:29:47.000000', 'consum', 0.0272, 'lps'),
	(624420, 132, '2015-01-01 00:29:48.000000', 'consum', 0.0254, 'lps'),
	(624421, 132, '2015-01-01 00:29:49.000000', 'consum', 0.0245, 'lps'),
	(624422, 132, '2015-01-01 00:29:50.000000', 'consum', 0.0254, 'lps'),
	(624423, 132, '2015-01-01 00:29:51.000000', 'consum', 0.0244, 'lps'),
	(624424, 132, '2015-01-01 00:29:52.000000', 'consum', 0.0248, 'lps'),
	(624425, 132, '2015-01-01 00:29:53.000000', 'consum', 0.0219, 'lps'),
	(624426, 132, '2015-01-01 00:29:54.000000', 'consum', 0.0223, 'lps'),
	(624427, 132, '2015-01-01 00:29:55.000000', 'consum', 0.0249, 'lps'),
	(624428, 132, '2015-01-01 00:29:56.000000', 'consum', 0.0285, 'lps'),
	(624429, 132, '2015-01-01 00:29:57.000000', 'consum', 0.0227, 'lps'),
	(624430, 132, '2015-01-01 00:29:58.000000', 'consum', 0.0232, 'lps'),
	(624431, 132, '2015-01-01 00:29:59.000000', 'consum', 0.0268, 'lps'),
	(624432, 132, '2015-01-01 00:30:00.000000', 'consum', 0.0273, 'lps'),
	(624433, 132, '2015-01-01 00:30:01.000000', 'consum', 0.0273, 'lps'),
	(624434, 132, '2015-01-01 00:30:02.000000', 'consum', 0.0252, 'lps'),
	(624435, 132, '2015-01-01 00:30:03.000000', 'consum', 0.0234, 'lps'),
	(624436, 132, '2015-01-01 00:30:04.000000', 'consum', 0.0283, 'lps'),
	(624437, 132, '2015-01-01 00:30:05.000000', 'consum', 0.0264, 'lps'),
	(624438, 132, '2015-01-01 00:30:06.000000', 'consum', 0.0258, 'lps'),
	(624439, 132, '2015-01-01 00:30:07.000000', 'consum', 0.0290, 'lps'),
	(624440, 132, '2015-01-01 00:30:08.000000', 'consum', 0.0225, 'lps'),
	(624441, 132, '2015-01-01 00:30:09.000000', 'consum', 0.0287, 'lps'),
	(624442, 132, '2015-01-01 00:30:10.000000', 'consum', 0.0228, 'lps'),
	(624443, 132, '2015-01-01 00:30:11.000000', 'consum', 0.0229, 'lps'),
	(624444, 132, '2015-01-01 00:30:12.000000', 'consum', 0.0254, 'lps'),
	(624445, 132, '2015-01-01 00:30:13.000000', 'consum', 0.0212, 'lps'),
	(624446, 132, '2015-01-01 00:30:14.000000', 'consum', 0.0249, 'lps'),
	(624447, 132, '2015-01-01 00:30:15.000000', 'consum', 0.0238, 'lps'),
	(624448, 132, '2015-01-01 00:30:16.000000', 'consum', 0.0235, 'lps'),
	(624449, 132, '2015-01-01 00:30:17.000000', 'consum', 0.0250, 'lps'),
	(624450, 132, '2015-01-01 00:30:18.000000', 'consum', 0.0255, 'lps'),
	(624451, 132, '2015-01-01 00:30:19.000000', 'consum', 0.0233, 'lps'),
	(624452, 132, '2015-01-01 00:30:20.000000', 'consum', 0.0271, 'lps'),
	(624453, 132, '2015-01-01 00:30:21.000000', 'consum', 0.0286, 'lps'),
	(624454, 132, '2015-01-01 00:30:22.000000', 'consum', 0.0246, 'lps'),
	(624455, 132, '2015-01-01 00:30:23.000000', 'consum', 0.0244, 'lps'),
	(624456, 132, '2015-01-01 00:30:24.000000', 'consum', 0.0273, 'lps'),
	(624457, 132, '2015-01-01 00:30:25.000000', 'consum', 0.0262, 'lps'),
	(624458, 132, '2015-01-01 00:30:26.000000', 'consum', 0.0283, 'lps'),
	(624459, 132, '2015-01-01 00:30:27.000000', 'consum', 0.0254, 'lps'),
	(624460, 132, '2015-01-01 00:30:28.000000', 'consum', 0.0214, 'lps'),
	(624461, 132, '2015-01-01 00:30:29.000000', 'consum', 0.0259, 'lps'),
	(624462, 132, '2015-01-01 00:30:30.000000', 'consum', 0.0281, 'lps'),
	(624463, 132, '2015-01-01 00:30:31.000000', 'consum', 0.0256, 'lps'),
	(624464, 132, '2015-01-01 00:30:32.000000', 'consum', 0.0230, 'lps'),
	(624465, 132, '2015-01-01 00:30:33.000000', 'consum', 0.0251, 'lps'),
	(624466, 132, '2015-01-01 00:30:34.000000', 'consum', 0.0276, 'lps'),
	(624467, 132, '2015-01-01 00:30:35.000000', 'consum', 0.0256, 'lps'),
	(624468, 132, '2015-01-01 00:30:36.000000', 'consum', 0.0241, 'lps'),
	(624469, 132, '2015-01-01 00:30:37.000000', 'consum', 0.0229, 'lps'),
	(624470, 132, '2015-01-01 00:30:38.000000', 'consum', 0.0213, 'lps'),
	(624471, 132, '2015-01-01 00:30:39.000000', 'consum', 0.0250, 'lps'),
	(624472, 132, '2015-01-01 00:30:40.000000', 'consum', 0.0239, 'lps'),
	(624473, 132, '2015-01-01 00:30:41.000000', 'consum', 0.0236, 'lps'),
	(624474, 132, '2015-01-01 00:30:42.000000', 'consum', 0.0254, 'lps'),
	(624475, 132, '2015-01-01 00:30:43.000000', 'consum', 0.0270, 'lps'),
	(624476, 132, '2015-01-01 00:30:44.000000', 'consum', 0.0217, 'lps'),
	(624477, 132, '2015-01-01 00:30:45.000000', 'consum', 0.0228, 'lps'),
	(624478, 132, '2015-01-01 00:30:46.000000', 'consum', 0.0277, 'lps'),
	(624479, 132, '2015-01-01 00:30:47.000000', 'consum', 0.0252, 'lps'),
	(624480, 132, '2015-01-01 00:30:48.000000', 'consum', 0.0219, 'lps'),
	(624481, 132, '2015-01-01 00:30:49.000000', 'consum', 0.0289, 'lps'),
	(624482, 132, '2015-01-01 00:30:50.000000', 'consum', 0.0256, 'lps'),
	(624483, 132, '2015-01-01 00:30:51.000000', 'consum', 0.0284, 'lps'),
	(624484, 132, '2015-01-01 00:30:52.000000', 'consum', 0.0280, 'lps'),
	(624485, 132, '2015-01-01 00:30:53.000000', 'consum', 0.0256, 'lps'),
	(624486, 132, '2015-01-01 00:30:54.000000', 'consum', 0.0234, 'lps'),
	(624487, 132, '2015-01-01 00:30:55.000000', 'consum', 0.0270, 'lps'),
	(624488, 132, '2015-01-01 00:30:56.000000', 'consum', 0.0279, 'lps'),
	(624489, 132, '2015-01-01 00:30:57.000000', 'consum', 0.0211, 'lps'),
	(624490, 132, '2015-01-01 00:30:58.000000', 'consum', 0.0253, 'lps'),
	(624491, 132, '2015-01-01 00:30:59.000000', 'consum', 0.0260, 'lps'),
	(624492, 132, '2015-01-01 00:31:00.000000', 'consum', 0.0252, 'lps'),
	(624493, 132, '2015-01-01 00:31:01.000000', 'consum', 0.0268, 'lps'),
	(624494, 132, '2015-01-01 00:31:02.000000', 'consum', 0.0215, 'lps'),
	(624495, 132, '2015-01-01 00:31:03.000000', 'consum', 0.0222, 'lps'),
	(624496, 132, '2015-01-01 00:31:04.000000', 'consum', 0.0256, 'lps'),
	(624497, 132, '2015-01-01 00:31:05.000000', 'consum', 0.0244, 'lps'),
	(624498, 132, '2015-01-01 00:31:06.000000', 'consum', 0.0240, 'lps'),
	(624499, 132, '2015-01-01 00:31:07.000000', 'consum', 0.0258, 'lps'),
	(624500, 132, '2015-01-01 00:31:08.000000', 'consum', 0.0279, 'lps'),
	(624501, 132, '2015-01-01 00:31:09.000000', 'consum', 0.0249, 'lps'),
	(624502, 132, '2015-01-01 00:31:10.000000', 'consum', 0.0283, 'lps'),
	(624503, 132, '2015-01-01 00:31:11.000000', 'consum', 0.0212, 'lps'),
	(624504, 132, '2015-01-01 00:31:12.000000', 'consum', 0.0246, 'lps'),
	(624505, 132, '2015-01-01 00:31:13.000000', 'consum', 0.0221, 'lps'),
	(624506, 132, '2015-01-01 00:31:14.000000', 'consum', 0.0238, 'lps'),
	(624507, 132, '2015-01-01 00:31:15.000000', 'consum', 0.0239, 'lps'),
	(624508, 132, '2015-01-01 00:31:16.000000', 'consum', 0.0270, 'lps'),
	(624509, 132, '2015-01-01 00:31:17.000000', 'consum', 0.0263, 'lps'),
	(624510, 132, '2015-01-01 00:31:18.000000', 'consum', 0.0214, 'lps'),
	(624511, 132, '2015-01-01 00:31:19.000000', 'consum', 0.0233, 'lps'),
	(624512, 132, '2015-01-01 00:31:20.000000', 'consum', 0.0231, 'lps'),
	(624513, 132, '2015-01-01 00:31:21.000000', 'consum', 0.0248, 'lps'),
	(624514, 132, '2015-01-01 00:31:22.000000', 'consum', 0.0258, 'lps'),
	(624515, 132, '2015-01-01 00:31:23.000000', 'consum', 0.0255, 'lps'),
	(624516, 132, '2015-01-01 00:31:24.000000', 'consum', 0.0210, 'lps'),
	(624517, 132, '2015-01-01 00:31:25.000000', 'consum', 0.0238, 'lps'),
	(624518, 132, '2015-01-01 00:31:26.000000', 'consum', 0.0269, 'lps'),
	(624519, 132, '2015-01-01 00:31:27.000000', 'consum', 0.0260, 'lps'),
	(624520, 132, '2015-01-01 00:31:28.000000', 'consum', 0.0282, 'lps'),
	(624521, 132, '2015-01-01 00:31:29.000000', 'consum', 0.0259, 'lps'),
	(624522, 132, '2015-01-01 00:31:30.000000', 'consum', 0.0241, 'lps'),
	(624523, 132, '2015-01-01 00:31:31.000000', 'consum', 0.0217, 'lps'),
	(624524, 132, '2015-01-01 00:31:32.000000', 'consum', 0.0236, 'lps'),
	(624525, 132, '2015-01-01 00:31:33.000000', 'consum', 0.0236, 'lps'),
	(624526, 132, '2015-01-01 00:31:34.000000', 'consum', 0.0262, 'lps'),
	(624527, 132, '2015-01-01 00:31:35.000000', 'consum', 0.0232, 'lps'),
	(624528, 132, '2015-01-01 00:31:36.000000', 'consum', 0.0244, 'lps'),
	(624529, 132, '2015-01-01 00:31:37.000000', 'consum', 0.0233, 'lps'),
	(624530, 132, '2015-01-01 00:31:38.000000', 'consum', 0.0226, 'lps'),
	(624531, 132, '2015-01-01 00:31:39.000000', 'consum', 0.0222, 'lps'),
	(624532, 132, '2015-01-01 00:31:40.000000', 'consum', 0.0222, 'lps'),
	(624533, 132, '2015-01-01 00:31:41.000000', 'consum', 0.0234, 'lps'),
	(624534, 132, '2015-01-01 00:31:42.000000', 'consum', 0.0214, 'lps'),
	(624535, 132, '2015-01-01 00:31:43.000000', 'consum', 0.0237, 'lps'),
	(624536, 132, '2015-01-01 00:31:44.000000', 'consum', 0.0254, 'lps'),
	(624537, 132, '2015-01-01 00:31:45.000000', 'consum', 0.0270, 'lps'),
	(624538, 132, '2015-01-01 00:31:46.000000', 'consum', 0.0214, 'lps'),
	(624539, 132, '2015-01-01 00:31:47.000000', 'consum', 0.0216, 'lps'),
	(624540, 132, '2015-01-01 00:31:48.000000', 'consum', 0.0225, 'lps'),
	(624541, 132, '2015-01-01 00:31:49.000000', 'consum', 0.0270, 'lps'),
	(624542, 132, '2015-01-01 00:31:50.000000', 'consum', 0.0221, 'lps'),
	(624543, 132, '2015-01-01 00:31:51.000000', 'consum', 0.0247, 'lps'),
	(624544, 132, '2015-01-01 00:31:52.000000', 'consum', 0.0280, 'lps'),
	(624545, 132, '2015-01-01 00:31:53.000000', 'consum', 0.0289, 'lps'),
	(624546, 132, '2015-01-01 00:31:54.000000', 'consum', 0.0236, 'lps'),
	(624547, 132, '2015-01-01 00:31:55.000000', 'consum', 0.0262, 'lps'),
	(624548, 132, '2015-01-01 00:31:56.000000', 'consum', 0.0232, 'lps'),
	(624549, 132, '2015-01-01 00:31:57.000000', 'consum', 0.0245, 'lps'),
	(624550, 132, '2015-01-01 00:31:58.000000', 'consum', 0.0237, 'lps'),
	(624551, 132, '2015-01-01 00:31:59.000000', 'consum', 0.0244, 'lps'),
	(624552, 132, '2015-01-01 00:32:00.000000', 'consum', 0.0216, 'lps'),
	(624553, 132, '2015-01-01 00:32:01.000000', 'consum', 0.0218, 'lps'),
	(624554, 132, '2015-01-01 00:32:02.000000', 'consum', 0.0236, 'lps'),
	(624555, 132, '2015-01-01 00:32:03.000000', 'consum', 0.0233, 'lps'),
	(624556, 132, '2015-01-01 00:32:04.000000', 'consum', 0.0249, 'lps'),
	(624557, 132, '2015-01-01 00:32:05.000000', 'consum', 0.0254, 'lps'),
	(624558, 132, '2015-01-01 00:32:06.000000', 'consum', 0.0232, 'lps'),
	(624559, 132, '2015-01-01 00:32:07.000000', 'consum', 0.0272, 'lps'),
	(624560, 132, '2015-01-01 00:32:08.000000', 'consum', 0.0290, 'lps'),
	(624561, 132, '2015-01-01 00:32:09.000000', 'consum', 0.0262, 'lps'),
	(624562, 132, '2015-01-01 00:32:10.000000', 'consum', 0.0231, 'lps'),
	(624563, 132, '2015-01-01 00:32:11.000000', 'consum', 0.0241, 'lps'),
	(624564, 132, '2015-01-01 00:32:12.000000', 'consum', 0.0221, 'lps'),
	(624565, 132, '2015-01-01 00:32:13.000000', 'consum', 0.0253, 'lps'),
	(624566, 132, '2015-01-01 00:32:14.000000', 'consum', 0.0231, 'lps'),
	(624567, 132, '2015-01-01 00:32:15.000000', 'consum', 0.0267, 'lps'),
	(624568, 132, '2015-01-01 00:32:16.000000', 'consum', 0.0272, 'lps'),
	(624569, 132, '2015-01-01 00:32:17.000000', 'consum', 0.0268, 'lps'),
	(624570, 132, '2015-01-01 00:32:18.000000', 'consum', 0.0233, 'lps'),
	(624571, 132, '2015-01-01 00:32:19.000000', 'consum', 0.0233, 'lps'),
	(624572, 132, '2015-01-01 00:32:20.000000', 'consum', 0.0255, 'lps'),
	(624573, 132, '2015-01-01 00:32:21.000000', 'consum', 0.0288, 'lps'),
	(624574, 132, '2015-01-01 00:32:22.000000', 'consum', 0.0222, 'lps'),
	(624575, 132, '2015-01-01 00:32:23.000000', 'consum', 0.0281, 'lps'),
	(624576, 132, '2015-01-01 00:32:24.000000', 'consum', 0.0286, 'lps'),
	(624577, 132, '2015-01-01 00:32:25.000000', 'consum', 0.0215, 'lps'),
	(624578, 132, '2015-01-01 00:32:26.000000', 'consum', 0.0251, 'lps'),
	(624579, 132, '2015-01-01 00:32:27.000000', 'consum', 0.0239, 'lps'),
	(624580, 132, '2015-01-01 00:32:28.000000', 'consum', 0.0232, 'lps'),
	(624581, 132, '2015-01-01 00:32:29.000000', 'consum', 0.0233, 'lps'),
	(624582, 132, '2015-01-01 00:32:30.000000', 'consum', 0.0261, 'lps'),
	(624583, 132, '2015-01-01 00:32:31.000000', 'consum', 0.0232, 'lps'),
	(624584, 132, '2015-01-01 00:32:32.000000', 'consum', 0.0251, 'lps'),
	(624585, 132, '2015-01-01 00:32:33.000000', 'consum', 0.0269, 'lps'),
	(624586, 132, '2015-01-01 00:32:34.000000', 'consum', 0.0221, 'lps'),
	(624587, 132, '2015-01-01 00:32:35.000000', 'consum', 0.0251, 'lps'),
	(624588, 132, '2015-01-01 00:32:36.000000', 'consum', 0.0218, 'lps'),
	(624589, 132, '2015-01-01 00:32:37.000000', 'consum', 0.0211, 'lps'),
	(624590, 132, '2015-01-01 00:32:38.000000', 'consum', 0.0271, 'lps'),
	(624591, 132, '2015-01-01 00:32:39.000000', 'consum', 0.0268, 'lps'),
	(624592, 132, '2015-01-01 00:32:40.000000', 'consum', 0.0240, 'lps'),
	(624593, 132, '2015-01-01 00:32:41.000000', 'consum', 0.0265, 'lps'),
	(624594, 132, '2015-01-01 00:32:42.000000', 'consum', 0.0235, 'lps'),
	(624595, 132, '2015-01-01 00:32:43.000000', 'consum', 0.0252, 'lps'),
	(624596, 132, '2015-01-01 00:32:44.000000', 'consum', 0.0265, 'lps'),
	(624597, 132, '2015-01-01 00:32:45.000000', 'consum', 0.0279, 'lps'),
	(624598, 132, '2015-01-01 00:32:46.000000', 'consum', 0.0228, 'lps'),
	(624599, 132, '2015-01-01 00:32:47.000000', 'consum', 0.0257, 'lps'),
	(624600, 132, '2015-01-01 00:32:48.000000', 'consum', 0.0229, 'lps'),
	(624601, 132, '2015-01-01 00:32:49.000000', 'consum', 0.0243, 'lps'),
	(624602, 132, '2015-01-01 00:32:50.000000', 'consum', 0.0238, 'lps'),
	(624603, 132, '2015-01-01 00:32:51.000000', 'consum', 0.0254, 'lps'),
	(624604, 132, '2015-01-01 00:32:52.000000', 'consum', 0.0264, 'lps'),
	(624605, 132, '2015-01-01 00:32:53.000000', 'consum', 0.0267, 'lps'),
	(624606, 132, '2015-01-01 00:32:54.000000', 'consum', 0.0251, 'lps'),
	(624607, 132, '2015-01-01 00:32:55.000000', 'consum', 0.0246, 'lps'),
	(624608, 132, '2015-01-01 00:32:56.000000', 'consum', 0.0266, 'lps'),
	(624609, 132, '2015-01-01 00:32:57.000000', 'consum', 0.0221, 'lps'),
	(624610, 132, '2015-01-01 00:32:58.000000', 'consum', 0.0259, 'lps'),
	(624611, 132, '2015-01-01 00:32:59.000000', 'consum', 0.0261, 'lps'),
	(624612, 132, '2015-01-01 00:33:00.000000', 'consum', 0.0236, 'lps'),
	(624613, 132, '2015-01-01 00:33:01.000000', 'consum', 0.0268, 'lps'),
	(624614, 132, '2015-01-01 00:33:02.000000', 'consum', 0.0262, 'lps'),
	(624615, 132, '2015-01-01 00:33:03.000000', 'consum', 0.0216, 'lps'),
	(624616, 132, '2015-01-01 00:33:04.000000', 'consum', 0.0247, 'lps'),
	(624617, 132, '2015-01-01 00:33:05.000000', 'consum', 0.0217, 'lps'),
	(624618, 132, '2015-01-01 00:33:06.000000', 'consum', 0.0212, 'lps'),
	(624619, 132, '2015-01-01 00:33:07.000000', 'consum', 0.0283, 'lps'),
	(624620, 132, '2015-01-01 00:33:08.000000', 'consum', 0.0245, 'lps'),
	(624621, 132, '2015-01-01 00:33:09.000000', 'consum', 0.0249, 'lps'),
	(624622, 132, '2015-01-01 00:33:10.000000', 'consum', 0.0220, 'lps'),
	(624623, 132, '2015-01-01 00:33:11.000000', 'consum', 0.0222, 'lps'),
	(624624, 132, '2015-01-01 00:33:12.000000', 'consum', 0.0242, 'lps'),
	(624625, 132, '2015-01-01 00:33:13.000000', 'consum', 0.0252, 'lps'),
	(624626, 132, '2015-01-01 00:33:14.000000', 'consum', 0.0244, 'lps'),
	(624627, 132, '2015-01-01 00:33:15.000000', 'consum', 0.0255, 'lps'),
	(624628, 132, '2015-01-01 00:33:16.000000', 'consum', 0.0254, 'lps'),
	(624629, 132, '2015-01-01 00:33:17.000000', 'consum', 0.0214, 'lps'),
	(624630, 132, '2015-01-01 00:33:18.000000', 'consum', 0.0261, 'lps'),
	(624631, 132, '2015-01-01 00:33:19.000000', 'consum', 0.0290, 'lps'),
	(624632, 132, '2015-01-01 00:33:20.000000', 'consum', 0.0214, 'lps'),
	(624633, 132, '2015-01-01 00:33:21.000000', 'consum', 0.0234, 'lps'),
	(624634, 132, '2015-01-01 00:33:22.000000', 'consum', 0.0236, 'lps'),
	(624635, 132, '2015-01-01 00:33:23.000000', 'consum', 0.0269, 'lps'),
	(624636, 132, '2015-01-01 00:33:24.000000', 'consum', 0.0264, 'lps'),
	(624637, 132, '2015-01-01 00:33:25.000000', 'consum', 0.0225, 'lps'),
	(624638, 132, '2015-01-01 00:33:26.000000', 'consum', 0.0286, 'lps'),
	(624639, 132, '2015-01-01 00:33:27.000000', 'consum', 0.0223, 'lps'),
	(624640, 132, '2015-01-01 00:33:28.000000', 'consum', 0.0288, 'lps'),
	(624641, 132, '2015-01-01 00:33:29.000000', 'consum', 0.0237, 'lps'),
	(624642, 132, '2015-01-01 00:33:30.000000', 'consum', 0.0273, 'lps'),
	(624643, 132, '2015-01-01 00:33:31.000000', 'consum', 0.0283, 'lps'),
	(624644, 132, '2015-01-01 00:33:32.000000', 'consum', 0.0226, 'lps'),
	(624645, 132, '2015-01-01 00:33:33.000000', 'consum', 0.0232, 'lps'),
	(624646, 132, '2015-01-01 00:33:34.000000', 'consum', 0.0273, 'lps'),
	(624647, 132, '2015-01-01 00:33:35.000000', 'consum', 0.0217, 'lps'),
	(624648, 132, '2015-01-01 00:33:36.000000', 'consum', 0.0217, 'lps'),
	(624649, 132, '2015-01-01 00:33:37.000000', 'consum', 0.0227, 'lps'),
	(624650, 132, '2015-01-01 00:33:38.000000', 'consum', 0.0275, 'lps'),
	(624651, 132, '2015-01-01 00:33:39.000000', 'consum', 0.0240, 'lps'),
	(624652, 132, '2015-01-01 00:33:40.000000', 'consum', 0.0249, 'lps'),
	(624653, 132, '2015-01-01 00:33:41.000000', 'consum', 0.0231, 'lps'),
	(624654, 132, '2015-01-01 00:33:42.000000', 'consum', 0.0283, 'lps'),
	(624655, 132, '2015-01-01 00:33:43.000000', 'consum', 0.0268, 'lps'),
	(624656, 132, '2015-01-01 00:33:44.000000', 'consum', 0.0281, 'lps'),
	(624657, 132, '2015-01-01 00:33:45.000000', 'consum', 0.0230, 'lps'),
	(624658, 132, '2015-01-01 00:33:46.000000', 'consum', 0.0259, 'lps'),
	(624659, 132, '2015-01-01 00:33:47.000000', 'consum', 0.0235, 'lps'),
	(624660, 132, '2015-01-01 00:33:48.000000', 'consum', 0.0269, 'lps'),
	(624661, 132, '2015-01-01 00:33:49.000000', 'consum', 0.0270, 'lps'),
	(624662, 132, '2015-01-01 00:33:50.000000', 'consum', 0.0250, 'lps'),
	(624663, 132, '2015-01-01 00:33:51.000000', 'consum', 0.0232, 'lps'),
	(624664, 132, '2015-01-01 00:33:52.000000', 'consum', 0.0281, 'lps'),
	(624665, 132, '2015-01-01 00:33:53.000000', 'consum', 0.0256, 'lps'),
	(624666, 132, '2015-01-01 00:33:54.000000', 'consum', 0.0228, 'lps'),
	(624667, 132, '2015-01-01 00:33:55.000000', 'consum', 0.0243, 'lps'),
	(624668, 132, '2015-01-01 00:33:56.000000', 'consum', 0.0239, 'lps'),
	(624669, 132, '2015-01-01 00:33:57.000000', 'consum', 0.0259, 'lps'),
	(624670, 132, '2015-01-01 00:33:58.000000', 'consum', 0.0287, 'lps'),
	(624671, 132, '2015-01-01 00:33:59.000000', 'consum', 0.0286, 'lps'),
	(624672, 132, '2015-01-01 00:34:00.000000', 'consum', 0.0280, 'lps'),
	(624673, 132, '2015-01-01 00:34:01.000000', 'consum', 0.0249, 'lps'),
	(624674, 132, '2015-01-01 00:34:02.000000', 'consum', 0.0277, 'lps'),
	(624675, 132, '2015-01-01 00:34:03.000000', 'consum', 0.0265, 'lps'),
	(624676, 132, '2015-01-01 00:34:04.000000', 'consum', 0.0287, 'lps'),
	(624677, 132, '2015-01-01 00:34:05.000000', 'consum', 0.0266, 'lps'),
	(624678, 132, '2015-01-01 00:34:06.000000', 'consum', 0.0261, 'lps'),
	(624679, 132, '2015-01-01 00:34:07.000000', 'consum', 0.0218, 'lps'),
	(624680, 132, '2015-01-01 00:34:08.000000', 'consum', 0.0259, 'lps'),
	(624681, 132, '2015-01-01 00:34:09.000000', 'consum', 0.0269, 'lps'),
	(624682, 132, '2015-01-01 00:34:10.000000', 'consum', 0.0275, 'lps'),
	(624683, 132, '2015-01-01 00:34:11.000000', 'consum', 0.0281, 'lps'),
	(624684, 132, '2015-01-01 00:34:12.000000', 'consum', 0.0289, 'lps'),
	(624685, 132, '2015-01-01 00:34:13.000000', 'consum', 0.0228, 'lps'),
	(624686, 132, '2015-01-01 00:34:14.000000', 'consum', 0.0227, 'lps'),
	(624687, 132, '2015-01-01 00:34:15.000000', 'consum', 0.0240, 'lps'),
	(624688, 132, '2015-01-01 00:34:16.000000', 'consum', 0.0229, 'lps'),
	(624689, 132, '2015-01-01 00:34:17.000000', 'consum', 0.0215, 'lps'),
	(624690, 132, '2015-01-01 00:34:18.000000', 'consum', 0.0261, 'lps'),
	(624691, 132, '2015-01-01 00:34:19.000000', 'consum', 0.0290, 'lps'),
	(624692, 132, '2015-01-01 00:34:20.000000', 'consum', 0.0212, 'lps'),
	(624693, 132, '2015-01-01 00:34:21.000000', 'consum', 0.0224, 'lps'),
	(624694, 132, '2015-01-01 00:34:22.000000', 'consum', 0.0274, 'lps'),
	(624695, 132, '2015-01-01 00:34:23.000000', 'consum', 0.0246, 'lps'),
	(624696, 132, '2015-01-01 00:34:24.000000', 'consum', 0.0281, 'lps'),
	(624697, 132, '2015-01-01 00:34:25.000000', 'consum', 0.0214, 'lps'),
	(624698, 132, '2015-01-01 00:34:26.000000', 'consum', 0.0259, 'lps'),
	(624699, 132, '2015-01-01 00:34:27.000000', 'consum', 0.0281, 'lps'),
	(624700, 132, '2015-01-01 00:34:28.000000', 'consum', 0.0258, 'lps'),
	(624701, 132, '2015-01-01 00:34:29.000000', 'consum', 0.0238, 'lps'),
	(624702, 132, '2015-01-01 00:34:30.000000', 'consum', 0.0287, 'lps'),
	(624703, 132, '2015-01-01 00:34:31.000000', 'consum', 0.0270, 'lps'),
	(624704, 132, '2015-01-01 00:34:32.000000', 'consum', 0.0280, 'lps'),
	(624705, 132, '2015-01-01 00:34:33.000000', 'consum', 0.0219, 'lps'),
	(624706, 132, '2015-01-01 00:34:34.000000', 'consum', 0.0289, 'lps'),
	(624707, 132, '2015-01-01 00:34:35.000000', 'consum', 0.0252, 'lps'),
	(624708, 132, '2015-01-01 00:34:36.000000', 'consum', 0.0265, 'lps'),
	(624709, 132, '2015-01-01 00:34:37.000000', 'consum', 0.0280, 'lps'),
	(624710, 132, '2015-01-01 00:34:38.000000', 'consum', 0.0233, 'lps'),
	(624711, 132, '2015-01-01 00:34:39.000000', 'consum', 0.0276, 'lps'),
	(624712, 132, '2015-01-01 00:34:40.000000', 'consum', 0.0228, 'lps'),
	(624713, 132, '2015-01-01 00:34:41.000000', 'consum', 0.0265, 'lps'),
	(624714, 132, '2015-01-01 00:34:42.000000', 'consum', 0.0268, 'lps'),
	(624715, 132, '2015-01-01 00:34:43.000000', 'consum', 0.0257, 'lps'),
	(624716, 132, '2015-01-01 00:34:44.000000', 'consum', 0.0269, 'lps'),
	(624717, 132, '2015-01-01 00:34:45.000000', 'consum', 0.0285, 'lps'),
	(624718, 132, '2015-01-01 00:34:46.000000', 'consum', 0.0247, 'lps'),
	(624719, 132, '2015-01-01 00:34:47.000000', 'consum', 0.0251, 'lps'),
	(624720, 132, '2015-01-01 00:34:48.000000', 'consum', 0.0224, 'lps'),
	(624721, 132, '2015-01-01 00:34:49.000000', 'consum', 0.0238, 'lps'),
	(624722, 132, '2015-01-01 00:34:50.000000', 'consum', 0.0226, 'lps'),
	(624723, 132, '2015-01-01 00:34:51.000000', 'consum', 0.0290, 'lps'),
	(624724, 132, '2015-01-01 00:34:52.000000', 'consum', 0.0240, 'lps'),
	(624725, 132, '2015-01-01 00:34:53.000000', 'consum', 0.0279, 'lps'),
	(624726, 132, '2015-01-01 00:34:54.000000', 'consum', 0.0223, 'lps'),
	(624727, 132, '2015-01-01 00:34:55.000000', 'consum', 0.0232, 'lps'),
	(624728, 132, '2015-01-01 00:34:56.000000', 'consum', 0.0282, 'lps'),
	(624729, 132, '2015-01-01 00:34:57.000000', 'consum', 0.0261, 'lps'),
	(624730, 132, '2015-01-01 00:34:58.000000', 'consum', 0.0249, 'lps'),
	(624731, 132, '2015-01-01 00:34:59.000000', 'consum', 0.0251, 'lps'),
	(624732, 132, '2015-01-01 00:35:00.000000', 'consum', 0.0221, 'lps'),
	(624733, 132, '2015-01-01 00:35:01.000000', 'consum', 0.0220, 'lps'),
	(624734, 132, '2015-01-01 00:35:02.000000', 'consum', 0.0230, 'lps'),
	(624735, 132, '2015-01-01 00:35:03.000000', 'consum', 0.0280, 'lps'),
	(624736, 132, '2015-01-01 00:35:04.000000', 'consum', 0.0257, 'lps'),
	(624737, 132, '2015-01-01 00:35:05.000000', 'consum', 0.0235, 'lps'),
	(624738, 132, '2015-01-01 00:35:06.000000', 'consum', 0.0278, 'lps'),
	(624739, 132, '2015-01-01 00:35:07.000000', 'consum', 0.0231, 'lps'),
	(624740, 132, '2015-01-01 00:35:08.000000', 'consum', 0.0272, 'lps'),
	(624741, 132, '2015-01-01 00:35:09.000000', 'consum', 0.0218, 'lps'),
	(624742, 132, '2015-01-01 00:35:10.000000', 'consum', 0.0223, 'lps'),
	(624743, 132, '2015-01-01 00:35:11.000000', 'consum', 0.0254, 'lps'),
	(624744, 132, '2015-01-01 00:35:12.000000', 'consum', 0.0229, 'lps'),
	(624745, 132, '2015-01-01 00:35:13.000000', 'consum', 0.0254, 'lps'),
	(624746, 132, '2015-01-01 00:35:14.000000', 'consum', 0.0211, 'lps'),
	(624747, 132, '2015-01-01 00:35:15.000000', 'consum', 0.0245, 'lps'),
	(624748, 132, '2015-01-01 00:35:16.000000', 'consum', 0.0220, 'lps'),
	(624749, 132, '2015-01-01 00:35:17.000000', 'consum', 0.0238, 'lps'),
	(624750, 132, '2015-01-01 00:35:18.000000', 'consum', 0.0239, 'lps'),
	(624751, 132, '2015-01-01 00:35:19.000000', 'consum', 0.0273, 'lps'),
	(624752, 132, '2015-01-01 00:35:20.000000', 'consum', 0.0274, 'lps'),
	(624753, 132, '2015-01-01 00:35:21.000000', 'consum', 0.0260, 'lps'),
	(624754, 132, '2015-01-01 00:35:22.000000', 'consum', 0.0269, 'lps'),
	(624755, 132, '2015-01-01 00:35:23.000000', 'consum', 0.0275, 'lps'),
	(624756, 132, '2015-01-01 00:35:24.000000', 'consum', 0.0277, 'lps'),
	(624757, 132, '2015-01-01 00:35:25.000000', 'consum', 0.0268, 'lps'),
	(624758, 132, '2015-01-01 00:35:26.000000', 'consum', 0.0221, 'lps'),
	(624759, 132, '2015-01-01 00:35:27.000000', 'consum', 0.0253, 'lps'),
	(624760, 132, '2015-01-01 00:35:28.000000', 'consum', 0.0228, 'lps'),
	(624761, 132, '2015-01-01 00:35:29.000000', 'consum', 0.0255, 'lps'),
	(624762, 132, '2015-01-01 00:35:30.000000', 'consum', 0.0218, 'lps'),
	(624763, 132, '2015-01-01 00:35:31.000000', 'consum', 0.0276, 'lps'),
	(624764, 132, '2015-01-01 00:35:32.000000', 'consum', 0.0276, 'lps'),
	(624765, 132, '2015-01-01 00:35:33.000000', 'consum', 0.0261, 'lps'),
	(624766, 132, '2015-01-01 00:35:34.000000', 'consum', 0.0268, 'lps'),
	(624767, 132, '2015-01-01 00:35:35.000000', 'consum', 0.0267, 'lps'),
	(624768, 132, '2015-01-01 00:35:36.000000', 'consum', 0.0240, 'lps'),
	(624769, 132, '2015-01-01 00:35:37.000000', 'consum', 0.0269, 'lps'),
	(624770, 132, '2015-01-01 00:35:38.000000', 'consum', 0.0253, 'lps'),
	(624771, 132, '2015-01-01 00:35:39.000000', 'consum', 0.0249, 'lps'),
	(624772, 132, '2015-01-01 00:35:40.000000', 'consum', 0.0277, 'lps'),
	(624773, 132, '2015-01-01 00:35:41.000000', 'consum', 0.0268, 'lps'),
	(624774, 132, '2015-01-01 00:35:42.000000', 'consum', 0.0217, 'lps'),
	(624775, 132, '2015-01-01 00:35:43.000000', 'consum', 0.0234, 'lps'),
	(624776, 132, '2015-01-01 00:35:44.000000', 'consum', 0.0229, 'lps'),
	(624777, 132, '2015-01-01 00:35:45.000000', 'consum', 0.0235, 'lps'),
	(624778, 132, '2015-01-01 00:35:46.000000', 'consum', 0.0276, 'lps'),
	(624779, 132, '2015-01-01 00:35:47.000000', 'consum', 0.0224, 'lps'),
	(624780, 132, '2015-01-01 00:35:48.000000', 'consum', 0.0245, 'lps'),
	(624781, 132, '2015-01-01 00:35:49.000000', 'consum', 0.0261, 'lps'),
	(624782, 132, '2015-01-01 00:35:50.000000', 'consum', 0.0279, 'lps'),
	(624783, 132, '2015-01-01 00:35:51.000000', 'consum', 0.0239, 'lps'),
	(624784, 132, '2015-01-01 00:35:52.000000', 'consum', 0.0232, 'lps'),
	(624785, 132, '2015-01-01 00:35:53.000000', 'consum', 0.0234, 'lps'),
	(624786, 132, '2015-01-01 00:35:54.000000', 'consum', 0.0263, 'lps'),
	(624787, 132, '2015-01-01 00:35:55.000000', 'consum', 0.0240, 'lps'),
	(624788, 132, '2015-01-01 00:35:56.000000', 'consum', 0.0284, 'lps'),
	(624789, 132, '2015-01-01 00:35:57.000000', 'consum', 0.0246, 'lps'),
	(624790, 132, '2015-01-01 00:35:58.000000', 'consum', 0.0251, 'lps'),
	(624791, 132, '2015-01-01 00:35:59.000000', 'consum', 0.0227, 'lps'),
	(624792, 132, '2015-01-01 00:36:00.000000', 'consum', 0.0251, 'lps'),
	(624793, 132, '2015-01-01 00:36:01.000000', 'consum', 0.0286, 'lps'),
	(624794, 132, '2015-01-01 00:36:02.000000', 'consum', 0.0225, 'lps'),
	(624795, 132, '2015-01-01 00:36:03.000000', 'consum', 0.0219, 'lps'),
	(624796, 132, '2015-01-01 00:36:04.000000', 'consum', 0.0210, 'lps'),
	(624797, 132, '2015-01-01 00:36:05.000000', 'consum', 0.0266, 'lps'),
	(624798, 132, '2015-01-01 00:36:06.000000', 'consum', 0.0246, 'lps'),
	(624799, 132, '2015-01-01 00:36:07.000000', 'consum', 0.0222, 'lps'),
	(624800, 132, '2015-01-01 00:36:08.000000', 'consum', 0.0245, 'lps'),
	(624801, 132, '2015-01-01 00:36:09.000000', 'consum', 0.0267, 'lps'),
	(624802, 132, '2015-01-01 00:36:10.000000', 'consum', 0.0229, 'lps'),
	(624803, 132, '2015-01-01 00:36:11.000000', 'consum', 0.0214, 'lps'),
	(624804, 132, '2015-01-01 00:36:12.000000', 'consum', 0.0257, 'lps'),
	(624805, 132, '2015-01-01 00:36:13.000000', 'consum', 0.0271, 'lps'),
	(624806, 132, '2015-01-01 00:36:14.000000', 'consum', 0.0211, 'lps'),
	(624807, 132, '2015-01-01 00:36:15.000000', 'consum', 0.0277, 'lps'),
	(624808, 132, '2015-01-01 00:36:16.000000', 'consum', 0.0219, 'lps'),
	(624809, 132, '2015-01-01 00:36:17.000000', 'consum', 0.0216, 'lps'),
	(624810, 132, '2015-01-01 00:36:18.000000', 'consum', 0.0214, 'lps'),
	(624811, 132, '2015-01-01 00:36:19.000000', 'consum', 0.0212, 'lps'),
	(624812, 132, '2015-01-01 00:36:20.000000', 'consum', 0.0288, 'lps'),
	(624813, 132, '2015-01-01 00:36:21.000000', 'consum', 0.0273, 'lps'),
	(624814, 132, '2015-01-01 00:36:22.000000', 'consum', 0.0210, 'lps'),
	(624815, 132, '2015-01-01 00:36:23.000000', 'consum', 0.0265, 'lps'),
	(624816, 132, '2015-01-01 00:36:24.000000', 'consum', 0.0242, 'lps'),
	(624817, 132, '2015-01-01 00:36:25.000000', 'consum', 0.0286, 'lps'),
	(624818, 132, '2015-01-01 00:36:26.000000', 'consum', 0.0253, 'lps'),
	(624819, 132, '2015-01-01 00:36:27.000000', 'consum', 0.0279, 'lps'),
	(624820, 132, '2015-01-01 00:36:28.000000', 'consum', 0.0262, 'lps'),
	(624821, 132, '2015-01-01 00:36:29.000000', 'consum', 0.0262, 'lps'),
	(624822, 132, '2015-01-01 00:36:30.000000', 'consum', 0.0237, 'lps'),
	(624823, 132, '2015-01-01 00:36:31.000000', 'consum', 0.0270, 'lps'),
	(624824, 132, '2015-01-01 00:36:32.000000', 'consum', 0.0269, 'lps'),
	(624825, 132, '2015-01-01 00:36:33.000000', 'consum', 0.0243, 'lps'),
	(624826, 132, '2015-01-01 00:36:34.000000', 'consum', 0.0278, 'lps'),
	(624827, 132, '2015-01-01 00:36:35.000000', 'consum', 0.0289, 'lps'),
	(624828, 132, '2015-01-01 00:36:36.000000', 'consum', 0.0239, 'lps'),
	(624829, 132, '2015-01-01 00:36:37.000000', 'consum', 0.0280, 'lps'),
	(624830, 132, '2015-01-01 00:36:38.000000', 'consum', 0.0232, 'lps'),
	(624831, 132, '2015-01-01 00:36:39.000000', 'consum', 0.0273, 'lps'),
	(624832, 132, '2015-01-01 00:36:40.000000', 'consum', 0.0215, 'lps'),
	(624833, 132, '2015-01-01 00:36:41.000000', 'consum', 0.0290, 'lps'),
	(624834, 132, '2015-01-01 00:36:42.000000', 'consum', 0.0271, 'lps'),
	(624835, 132, '2015-01-01 00:36:43.000000', 'consum', 0.0275, 'lps'),
	(624836, 132, '2015-01-01 00:36:44.000000', 'consum', 0.0274, 'lps'),
	(624837, 132, '2015-01-01 00:36:45.000000', 'consum', 0.0252, 'lps'),
	(624838, 132, '2015-01-01 00:36:46.000000', 'consum', 0.0230, 'lps'),
	(624839, 132, '2015-01-01 00:36:47.000000', 'consum', 0.0265, 'lps'),
	(624840, 132, '2015-01-01 00:36:48.000000', 'consum', 0.0263, 'lps'),
	(624841, 132, '2015-01-01 00:36:49.000000', 'consum', 0.0230, 'lps'),
	(624842, 132, '2015-01-01 00:36:50.000000', 'consum', 0.0233, 'lps'),
	(624843, 132, '2015-01-01 00:36:51.000000', 'consum', 0.0266, 'lps'),
	(624844, 132, '2015-01-01 00:36:52.000000', 'consum', 0.0261, 'lps'),
	(624845, 132, '2015-01-01 00:36:53.000000', 'consum', 0.0214, 'lps'),
	(624846, 132, '2015-01-01 00:36:54.000000', 'consum', 0.0241, 'lps'),
	(624847, 132, '2015-01-01 00:36:55.000000', 'consum', 0.0273, 'lps'),
	(624848, 132, '2015-01-01 00:36:56.000000', 'consum', 0.0268, 'lps'),
	(624849, 132, '2015-01-01 00:36:57.000000', 'consum', 0.0231, 'lps'),
	(624850, 132, '2015-01-01 00:36:58.000000', 'consum', 0.0222, 'lps'),
	(624851, 132, '2015-01-01 00:36:59.000000', 'consum', 0.0210, 'lps'),
	(624852, 132, '2015-01-01 00:37:00.000000', 'consum', 0.0253, 'lps'),
	(624853, 132, '2015-01-01 00:37:01.000000', 'consum', 0.0266, 'lps'),
	(624854, 132, '2015-01-01 00:37:02.000000', 'consum', 0.0281, 'lps'),
	(624855, 132, '2015-01-01 00:37:03.000000', 'consum', 0.0236, 'lps'),
	(624856, 132, '2015-01-01 00:37:04.000000', 'consum', 0.0289, 'lps'),
	(624857, 132, '2015-01-01 00:37:05.000000', 'consum', 0.0286, 'lps'),
	(624858, 132, '2015-01-01 00:37:06.000000', 'consum', 0.0270, 'lps'),
	(624859, 132, '2015-01-01 00:37:07.000000', 'consum', 0.0285, 'lps'),
	(624860, 132, '2015-01-01 00:37:08.000000', 'consum', 0.0244, 'lps'),
	(624861, 132, '2015-01-01 00:37:09.000000', 'consum', 0.0236, 'lps'),
	(624862, 132, '2015-01-01 00:37:10.000000', 'consum', 0.0239, 'lps'),
	(624863, 132, '2015-01-01 00:37:11.000000', 'consum', 0.0277, 'lps'),
	(624864, 132, '2015-01-01 00:37:12.000000', 'consum', 0.0217, 'lps'),
	(624865, 132, '2015-01-01 00:37:13.000000', 'consum', 0.0284, 'lps'),
	(624866, 132, '2015-01-01 00:37:14.000000', 'consum', 0.0239, 'lps'),
	(624867, 132, '2015-01-01 00:37:15.000000', 'consum', 0.0213, 'lps'),
	(624868, 132, '2015-01-01 00:37:16.000000', 'consum', 0.0218, 'lps'),
	(624869, 132, '2015-01-01 00:37:17.000000', 'consum', 0.0243, 'lps'),
	(624870, 132, '2015-01-01 00:37:18.000000', 'consum', 0.0271, 'lps'),
	(624871, 132, '2015-01-01 00:37:19.000000', 'consum', 0.0254, 'lps'),
	(624872, 132, '2015-01-01 00:37:20.000000', 'consum', 0.0249, 'lps'),
	(624873, 132, '2015-01-01 00:37:21.000000', 'consum', 0.0272, 'lps'),
	(624874, 132, '2015-01-01 00:37:22.000000', 'consum', 0.0240, 'lps'),
	(624875, 132, '2015-01-01 00:37:23.000000', 'consum', 0.0257, 'lps'),
	(624876, 132, '2015-01-01 00:37:24.000000', 'consum', 0.0273, 'lps'),
	(624877, 132, '2015-01-01 00:37:25.000000', 'consum', 0.0221, 'lps'),
	(624878, 132, '2015-01-01 00:37:26.000000', 'consum', 0.0242, 'lps'),
	(624879, 132, '2015-01-01 00:37:27.000000', 'consum', 0.0255, 'lps'),
	(624880, 132, '2015-01-01 00:37:28.000000', 'consum', 0.0260, 'lps'),
	(624881, 132, '2015-01-01 00:37:29.000000', 'consum', 0.0242, 'lps'),
	(624882, 132, '2015-01-01 00:37:30.000000', 'consum', 0.0223, 'lps'),
	(624883, 132, '2015-01-01 00:37:31.000000', 'consum', 0.0260, 'lps'),
	(624884, 132, '2015-01-01 00:37:32.000000', 'consum', 0.0257, 'lps'),
	(624885, 132, '2015-01-01 00:37:33.000000', 'consum', 0.0216, 'lps'),
	(624886, 132, '2015-01-01 00:37:34.000000', 'consum', 0.0263, 'lps'),
	(624887, 132, '2015-01-01 00:37:35.000000', 'consum', 0.0215, 'lps'),
	(624888, 132, '2015-01-01 00:37:36.000000', 'consum', 0.0239, 'lps'),
	(624889, 132, '2015-01-01 00:37:37.000000', 'consum', 0.0257, 'lps'),
	(624890, 132, '2015-01-01 00:37:38.000000', 'consum', 0.0280, 'lps'),
	(624891, 132, '2015-01-01 00:37:39.000000', 'consum', 0.0256, 'lps'),
	(624892, 132, '2015-01-01 00:37:40.000000', 'consum', 0.0232, 'lps'),
	(624893, 132, '2015-01-01 00:37:41.000000', 'consum', 0.0261, 'lps'),
	(624894, 132, '2015-01-01 00:37:42.000000', 'consum', 0.0240, 'lps'),
	(624895, 132, '2015-01-01 00:37:43.000000', 'consum', 0.0288, 'lps'),
	(624896, 132, '2015-01-01 00:37:44.000000', 'consum', 0.0267, 'lps'),
	(624897, 132, '2015-01-01 00:37:45.000000', 'consum', 0.0263, 'lps'),
	(624898, 132, '2015-01-01 00:37:46.000000', 'consum', 0.0223, 'lps'),
	(624899, 132, '2015-01-01 00:37:47.000000', 'consum', 0.0277, 'lps'),
	(624900, 132, '2015-01-01 00:37:48.000000', 'consum', 0.0264, 'lps'),
	(624901, 132, '2015-01-01 00:37:49.000000', 'consum', 0.0279, 'lps'),
	(624902, 132, '2015-01-01 00:37:50.000000', 'consum', 0.0230, 'lps'),
	(624903, 132, '2015-01-01 00:37:51.000000', 'consum', 0.0267, 'lps'),
	(624904, 132, '2015-01-01 00:37:52.000000', 'consum', 0.0275, 'lps'),
	(624905, 132, '2015-01-01 00:37:53.000000', 'consum', 0.0281, 'lps'),
	(624906, 132, '2015-01-01 00:37:54.000000', 'consum', 0.0289, 'lps'),
	(624907, 132, '2015-01-01 00:37:55.000000', 'consum', 0.0233, 'lps'),
	(624908, 132, '2015-01-01 00:37:56.000000', 'consum', 0.0248, 'lps'),
	(624909, 132, '2015-01-01 00:37:57.000000', 'consum', 0.0252, 'lps'),
	(624910, 132, '2015-01-01 00:37:58.000000', 'consum', 0.0226, 'lps'),
	(624911, 132, '2015-01-01 00:37:59.000000', 'consum', 0.0244, 'lps'),
	(624912, 132, '2015-01-01 00:38:00.000000', 'consum', 0.0253, 'lps'),
	(624913, 132, '2015-01-01 00:38:01.000000', 'consum', 0.0241, 'lps'),
	(624914, 132, '2015-01-01 00:38:02.000000', 'consum', 0.0238, 'lps'),
	(624915, 132, '2015-01-01 00:38:03.000000', 'consum', 0.0256, 'lps'),
	(624916, 132, '2015-01-01 00:38:04.000000', 'consum', 0.0278, 'lps'),
	(624917, 132, '2015-01-01 00:38:05.000000', 'consum', 0.0249, 'lps'),
	(624918, 132, '2015-01-01 00:38:06.000000', 'consum', 0.0285, 'lps'),
	(624919, 132, '2015-01-01 00:38:07.000000', 'consum', 0.0223, 'lps'),
	(624920, 132, '2015-01-01 00:38:08.000000', 'consum', 0.0211, 'lps'),
	(624921, 132, '2015-01-01 00:38:09.000000', 'consum', 0.0260, 'lps'),
	(624922, 132, '2015-01-01 00:38:10.000000', 'consum', 0.0212, 'lps'),
	(624923, 132, '2015-01-01 00:38:11.000000', 'consum', 0.0235, 'lps'),
	(624924, 132, '2015-01-01 00:38:12.000000', 'consum', 0.0249, 'lps'),
	(624925, 132, '2015-01-01 00:38:13.000000', 'consum', 0.0247, 'lps'),
	(624926, 132, '2015-01-01 00:38:14.000000', 'consum', 0.0280, 'lps'),
	(624927, 132, '2015-01-01 00:38:15.000000', 'consum', 0.0285, 'lps'),
	(624928, 132, '2015-01-01 00:38:16.000000', 'consum', 0.0217, 'lps'),
	(624929, 132, '2015-01-01 00:38:17.000000', 'consum', 0.0262, 'lps'),
	(624930, 132, '2015-01-01 00:38:18.000000', 'consum', 0.0288, 'lps'),
	(624931, 132, '2015-01-01 00:38:19.000000', 'consum', 0.0283, 'lps'),
	(624932, 132, '2015-01-01 00:38:20.000000', 'consum', 0.0260, 'lps'),
	(624933, 132, '2015-01-01 00:38:21.000000', 'consum', 0.0240, 'lps'),
	(624934, 132, '2015-01-01 00:38:22.000000', 'consum', 0.0212, 'lps'),
	(624935, 132, '2015-01-01 00:38:23.000000', 'consum', 0.0211, 'lps'),
	(624936, 132, '2015-01-01 00:38:24.000000', 'consum', 0.0290, 'lps'),
	(624937, 132, '2015-01-01 00:38:25.000000', 'consum', 0.0284, 'lps'),
	(624938, 132, '2015-01-01 00:38:26.000000', 'consum', 0.0257, 'lps'),
	(624939, 132, '2015-01-01 00:38:27.000000', 'consum', 0.0227, 'lps'),
	(624940, 132, '2015-01-01 00:38:28.000000', 'consum', 0.0235, 'lps'),
	(624941, 132, '2015-01-01 00:38:29.000000', 'consum', 0.0284, 'lps'),
	(624942, 132, '2015-01-01 00:38:30.000000', 'consum', 0.0261, 'lps'),
	(624943, 132, '2015-01-01 00:38:31.000000', 'consum', 0.0243, 'lps'),
	(624944, 132, '2015-01-01 00:38:32.000000', 'consum', 0.0225, 'lps'),
	(624945, 132, '2015-01-01 00:38:33.000000', 'consum', 0.0266, 'lps'),
	(624946, 132, '2015-01-01 00:38:34.000000', 'consum', 0.0285, 'lps'),
	(624947, 132, '2015-01-01 00:38:35.000000', 'consum', 0.0254, 'lps'),
	(624948, 132, '2015-01-01 00:38:36.000000', 'consum', 0.0287, 'lps'),
	(624949, 132, '2015-01-01 00:38:37.000000', 'consum', 0.0221, 'lps'),
	(624950, 132, '2015-01-01 00:38:38.000000', 'consum', 0.0277, 'lps'),
	(624951, 132, '2015-01-01 00:38:39.000000', 'consum', 0.0271, 'lps'),
	(624952, 132, '2015-01-01 00:38:40.000000', 'consum', 0.0233, 'lps'),
	(624953, 132, '2015-01-01 00:38:41.000000', 'consum', 0.0221, 'lps'),
	(624954, 132, '2015-01-01 00:38:42.000000', 'consum', 0.0280, 'lps'),
	(624955, 132, '2015-01-01 00:38:43.000000', 'consum', 0.0285, 'lps'),
	(624956, 132, '2015-01-01 00:38:44.000000', 'consum', 0.0213, 'lps'),
	(624957, 132, '2015-01-01 00:38:45.000000', 'consum', 0.0244, 'lps'),
	(624958, 132, '2015-01-01 00:38:46.000000', 'consum', 0.0289, 'lps'),
	(624959, 132, '2015-01-01 00:38:47.000000', 'consum', 0.0261, 'lps'),
	(624960, 132, '2015-01-01 00:38:48.000000', 'consum', 0.0227, 'lps'),
	(624961, 132, '2015-01-01 00:38:49.000000', 'consum', 0.0224, 'lps'),
	(624962, 132, '2015-01-01 00:38:50.000000', 'consum', 0.0231, 'lps'),
	(624963, 132, '2015-01-01 00:38:51.000000', 'consum', 0.0272, 'lps'),
	(624964, 132, '2015-01-01 00:38:52.000000', 'consum', 0.0215, 'lps'),
	(624965, 132, '2015-01-01 00:38:53.000000', 'consum', 0.0213, 'lps'),
	(624966, 132, '2015-01-01 00:38:54.000000', 'consum', 0.0288, 'lps'),
	(624967, 132, '2015-01-01 00:38:55.000000', 'consum', 0.0271, 'lps'),
	(624968, 132, '2015-01-01 00:38:56.000000', 'consum', 0.0279, 'lps'),
	(624969, 132, '2015-01-01 00:38:57.000000', 'consum', 0.0211, 'lps'),
	(624970, 132, '2015-01-01 00:38:58.000000', 'consum', 0.0251, 'lps'),
	(624971, 132, '2015-01-01 00:38:59.000000', 'consum', 0.0250, 'lps'),
	(624972, 132, '2015-01-01 00:39:00.000000', 'consum', 0.0287, 'lps'),
	(624973, 132, '2015-01-01 00:39:01.000000', 'consum', 0.0231, 'lps'),
	(624974, 132, '2015-01-01 00:39:02.000000', 'consum', 0.0250, 'lps'),
	(624975, 132, '2015-01-01 00:39:03.000000', 'consum', 0.0266, 'lps'),
	(624976, 132, '2015-01-01 00:39:04.000000', 'consum', 0.0289, 'lps'),
	(624977, 132, '2015-01-01 00:39:05.000000', 'consum', 0.0277, 'lps'),
	(624978, 132, '2015-01-01 00:39:06.000000', 'consum', 0.0226, 'lps'),
	(624979, 132, '2015-01-01 00:39:07.000000', 'consum', 0.0254, 'lps'),
	(624980, 132, '2015-01-01 00:39:08.000000', 'consum', 0.0218, 'lps'),
	(624981, 132, '2015-01-01 00:39:09.000000', 'consum', 0.0281, 'lps'),
	(624982, 132, '2015-01-01 00:39:10.000000', 'consum', 0.0218, 'lps'),
	(624983, 132, '2015-01-01 00:39:11.000000', 'consum', 0.0279, 'lps'),
	(624984, 132, '2015-01-01 00:39:12.000000', 'consum', 0.0210, 'lps'),
	(624985, 132, '2015-01-01 00:39:13.000000', 'consum', 0.0246, 'lps'),
	(624986, 132, '2015-01-01 00:39:14.000000', 'consum', 0.0226, 'lps'),
	(624987, 132, '2015-01-01 00:39:15.000000', 'consum', 0.0265, 'lps'),
	(624988, 132, '2015-01-01 00:39:16.000000', 'consum', 0.0274, 'lps'),
	(624989, 132, '2015-01-01 00:39:17.000000', 'consum', 0.0286, 'lps'),
	(624990, 132, '2015-01-01 00:39:18.000000', 'consum', 0.0235, 'lps'),
	(624991, 132, '2015-01-01 00:39:19.000000', 'consum', 0.0269, 'lps'),
	(624992, 132, '2015-01-01 00:39:20.000000', 'consum', 0.0268, 'lps'),
	(624993, 132, '2015-01-01 00:39:21.000000', 'consum', 0.0242, 'lps'),
	(624994, 132, '2015-01-01 00:39:22.000000', 'consum', 0.0280, 'lps'),
	(624995, 132, '2015-01-01 00:39:23.000000', 'consum', 0.0219, 'lps'),
	(624996, 132, '2015-01-01 00:39:24.000000', 'consum', 0.0210, 'lps'),
	(624997, 132, '2015-01-01 00:39:25.000000', 'consum', 0.0262, 'lps'),
	(624998, 132, '2015-01-01 00:39:26.000000', 'consum', 0.0229, 'lps'),
	(624999, 132, '2015-01-01 00:39:27.000000', 'consum', 0.0231, 'lps'),
	(625000, 132, '2015-01-01 00:39:28.000000', 'consum', 0.0257, 'lps'),
	(625001, 132, '2015-01-01 00:39:29.000000', 'consum', 0.0221, 'lps'),
	(625002, 132, '2015-01-01 00:39:30.000000', 'consum', 0.0285, 'lps'),
	(625003, 132, '2015-01-01 00:39:31.000000', 'consum', 0.0228, 'lps'),
	(625004, 132, '2015-01-01 00:39:32.000000', 'consum', 0.0241, 'lps'),
	(625005, 132, '2015-01-01 00:39:33.000000', 'consum', 0.0227, 'lps'),
	(625006, 132, '2015-01-01 00:39:34.000000', 'consum', 0.0286, 'lps'),
	(625007, 132, '2015-01-01 00:39:35.000000', 'consum', 0.0215, 'lps'),
	(625008, 132, '2015-01-01 00:39:36.000000', 'consum', 0.0249, 'lps'),
	(625009, 132, '2015-01-01 00:39:37.000000', 'consum', 0.0229, 'lps'),
	(625010, 132, '2015-01-01 00:39:38.000000', 'consum', 0.0270, 'lps'),
	(625011, 132, '2015-01-01 00:39:39.000000', 'consum', 0.0211, 'lps'),
	(625012, 132, '2015-01-01 00:39:40.000000', 'consum', 0.0280, 'lps'),
	(625013, 132, '2015-01-01 00:39:41.000000', 'consum', 0.0231, 'lps'),
	(625014, 132, '2015-01-01 00:39:42.000000', 'consum', 0.0267, 'lps'),
	(625015, 132, '2015-01-01 00:39:43.000000', 'consum', 0.0271, 'lps'),
	(625016, 132, '2015-01-01 00:39:44.000000', 'consum', 0.0262, 'lps'),
	(625017, 132, '2015-01-01 00:39:45.000000', 'consum', 0.0287, 'lps'),
	(625018, 132, '2015-01-01 00:39:46.000000', 'consum', 0.0280, 'lps'),
	(625019, 132, '2015-01-01 00:39:47.000000', 'consum', 0.0246, 'lps'),
	(625020, 132, '2015-01-01 00:39:48.000000', 'consum', 0.0262, 'lps'),
	(625021, 132, '2015-01-01 00:39:49.000000', 'consum', 0.0282, 'lps'),
	(625022, 132, '2015-01-01 00:39:50.000000', 'consum', 0.0253, 'lps'),
	(625023, 132, '2015-01-01 00:39:51.000000', 'consum', 0.0289, 'lps'),
	(625024, 132, '2015-01-01 00:39:52.000000', 'consum', 0.0234, 'lps'),
	(625025, 132, '2015-01-01 00:39:53.000000', 'consum', 0.0258, 'lps'),
	(625026, 132, '2015-01-01 00:39:54.000000', 'consum', 0.0213, 'lps'),
	(625027, 132, '2015-01-01 00:39:55.000000', 'consum', 0.0247, 'lps'),
	(625028, 132, '2015-01-01 00:39:56.000000', 'consum', 0.0223, 'lps'),
	(625029, 132, '2015-01-01 00:39:57.000000', 'consum', 0.0245, 'lps'),
	(625030, 132, '2015-01-01 00:39:58.000000', 'consum', 0.0264, 'lps'),
	(625031, 132, '2015-01-01 00:39:59.000000', 'consum', 0.0217, 'lps'),
	(625032, 132, '2015-01-01 00:40:00.000000', 'consum', 0.0243, 'lps'),
	(625033, 132, '2015-01-01 00:40:01.000000', 'consum', 0.0272, 'lps'),
	(625034, 132, '2015-01-01 00:40:02.000000', 'consum', 0.0263, 'lps'),
	(625035, 132, '2015-01-01 00:40:03.000000', 'consum', 0.0286, 'lps'),
	(625036, 132, '2015-01-01 00:40:04.000000', 'consum', 0.0272, 'lps'),
	(625037, 132, '2015-01-01 00:40:05.000000', 'consum', 0.0212, 'lps'),
	(625038, 132, '2015-01-01 00:40:06.000000', 'consum', 0.0278, 'lps'),
	(625039, 132, '2015-01-01 00:40:07.000000', 'consum', 0.0221, 'lps'),
	(625040, 132, '2015-01-01 00:40:08.000000', 'consum', 0.0221, 'lps'),
	(625041, 132, '2015-01-01 00:40:09.000000', 'consum', 0.0231, 'lps'),
	(625042, 132, '2015-01-01 00:40:10.000000', 'consum', 0.0286, 'lps'),
	(625043, 132, '2015-01-01 00:40:11.000000', 'consum', 0.0285, 'lps'),
	(625044, 132, '2015-01-01 00:40:12.000000', 'consum', 0.0275, 'lps'),
	(625045, 132, '2015-01-01 00:40:13.000000', 'consum', 0.0229, 'lps'),
	(625046, 132, '2015-01-01 00:40:14.000000', 'consum', 0.0271, 'lps'),
	(625047, 132, '2015-01-01 00:40:15.000000', 'consum', 0.0218, 'lps'),
	(625048, 132, '2015-01-01 00:40:16.000000', 'consum', 0.0228, 'lps'),
	(625049, 132, '2015-01-01 00:40:17.000000', 'consum', 0.0277, 'lps'),
	(625050, 132, '2015-01-01 00:40:18.000000', 'consum', 0.0250, 'lps'),
	(625051, 132, '2015-01-01 00:40:19.000000', 'consum', 0.0210, 'lps'),
	(625052, 132, '2015-01-01 00:40:20.000000', 'consum', 0.0251, 'lps'),
	(625053, 132, '2015-01-01 00:40:21.000000', 'consum', 0.0252, 'lps'),
	(625054, 132, '2015-01-01 00:40:22.000000', 'consum', 0.0220, 'lps'),
	(625055, 132, '2015-01-01 00:40:23.000000', 'consum', 0.0213, 'lps'),
	(625056, 132, '2015-01-01 00:40:24.000000', 'consum', 0.0277, 'lps'),
	(625057, 132, '2015-01-01 00:40:25.000000', 'consum', 0.0214, 'lps'),
	(625058, 132, '2015-01-01 00:40:26.000000', 'consum', 0.0271, 'lps'),
	(625059, 132, '2015-01-01 00:40:27.000000', 'consum', 0.0260, 'lps'),
	(625060, 132, '2015-01-01 00:40:28.000000', 'consum', 0.0277, 'lps'),
	(625061, 132, '2015-01-01 00:40:29.000000', 'consum', 0.0236, 'lps'),
	(625062, 132, '2015-01-01 00:40:30.000000', 'consum', 0.0220, 'lps'),
	(625063, 132, '2015-01-01 00:40:31.000000', 'consum', 0.0265, 'lps'),
	(625064, 132, '2015-01-01 00:40:32.000000', 'consum', 0.0290, 'lps'),
	(625065, 132, '2015-01-01 00:40:33.000000', 'consum', 0.0285, 'lps'),
	(625066, 132, '2015-01-01 00:40:34.000000', 'consum', 0.0264, 'lps'),
	(625067, 132, '2015-01-01 00:40:35.000000', 'consum', 0.0255, 'lps'),
	(625068, 132, '2015-01-01 00:40:36.000000', 'consum', 0.0274, 'lps'),
	(625069, 132, '2015-01-01 00:40:37.000000', 'consum', 0.0234, 'lps'),
	(625070, 132, '2015-01-01 00:40:38.000000', 'consum', 0.0220, 'lps'),
	(625071, 132, '2015-01-01 00:40:39.000000', 'consum', 0.0268, 'lps'),
	(625072, 132, '2015-01-01 00:40:40.000000', 'consum', 0.0229, 'lps'),
	(625073, 132, '2015-01-01 00:40:41.000000', 'consum', 0.0211, 'lps'),
	(625074, 132, '2015-01-01 00:40:42.000000', 'consum', 0.0240, 'lps'),
	(625075, 132, '2015-01-01 00:40:43.000000', 'consum', 0.0279, 'lps'),
	(625076, 132, '2015-01-01 00:40:44.000000', 'consum', 0.0220, 'lps'),
	(625077, 132, '2015-01-01 00:40:45.000000', 'consum', 0.0214, 'lps'),
	(625078, 132, '2015-01-01 00:40:46.000000', 'consum', 0.0283, 'lps'),
	(625079, 132, '2015-01-01 00:40:47.000000', 'consum', 0.0239, 'lps'),
	(625080, 132, '2015-01-01 00:40:48.000000', 'consum', 0.0219, 'lps'),
	(625081, 132, '2015-01-01 00:40:49.000000', 'consum', 0.0249, 'lps'),
	(625082, 132, '2015-01-01 00:40:50.000000', 'consum', 0.0216, 'lps'),
	(625083, 132, '2015-01-01 00:40:51.000000', 'consum', 0.0288, 'lps'),
	(625084, 132, '2015-01-01 00:40:52.000000', 'consum', 0.0255, 'lps'),
	(625085, 132, '2015-01-01 00:40:53.000000', 'consum', 0.0286, 'lps'),
	(625086, 132, '2015-01-01 00:40:54.000000', 'consum', 0.0210, 'lps'),
	(625087, 132, '2015-01-01 00:40:55.000000', 'consum', 0.0228, 'lps'),
	(625088, 132, '2015-01-01 00:40:56.000000', 'consum', 0.0218, 'lps'),
	(625089, 132, '2015-01-01 00:40:57.000000', 'consum', 0.0279, 'lps'),
	(625090, 132, '2015-01-01 00:40:58.000000', 'consum', 0.0287, 'lps'),
	(625091, 132, '2015-01-01 00:40:59.000000', 'consum', 0.0225, 'lps'),
	(625092, 132, '2015-01-01 00:41:00.000000', 'consum', 0.0219, 'lps'),
	(625093, 132, '2015-01-01 00:41:01.000000', 'consum', 0.0290, 'lps'),
	(625094, 132, '2015-01-01 00:41:02.000000', 'consum', 0.0261, 'lps'),
	(625095, 132, '2015-01-01 00:41:03.000000', 'consum', 0.0224, 'lps'),
	(625096, 132, '2015-01-01 00:41:04.000000', 'consum', 0.0288, 'lps'),
	(625097, 132, '2015-01-01 00:41:05.000000', 'consum', 0.0236, 'lps'),
	(625098, 132, '2015-01-01 00:41:06.000000', 'consum', 0.0267, 'lps'),
	(625099, 132, '2015-01-01 00:41:07.000000', 'consum', 0.0258, 'lps'),
	(625100, 132, '2015-01-01 00:41:08.000000', 'consum', 0.0279, 'lps'),
	(625101, 132, '2015-01-01 00:41:09.000000', 'consum', 0.0251, 'lps'),
	(625102, 132, '2015-01-01 00:41:10.000000', 'consum', 0.0287, 'lps'),
	(625103, 132, '2015-01-01 00:41:11.000000', 'consum', 0.0229, 'lps'),
	(625104, 132, '2015-01-01 00:41:12.000000', 'consum', 0.0238, 'lps'),
	(625105, 132, '2015-01-01 00:41:13.000000', 'consum', 0.0213, 'lps'),
	(625106, 132, '2015-01-01 00:41:14.000000', 'consum', 0.0223, 'lps'),
	(625107, 132, '2015-01-01 00:41:15.000000', 'consum', 0.0264, 'lps'),
	(625108, 132, '2015-01-01 00:41:16.000000', 'consum', 0.0281, 'lps'),
	(625109, 132, '2015-01-01 00:41:17.000000', 'consum', 0.0239, 'lps'),
	(625110, 132, '2015-01-01 00:41:18.000000', 'consum', 0.0226, 'lps'),
	(625111, 132, '2015-01-01 00:41:19.000000', 'consum', 0.0286, 'lps'),
	(625112, 132, '2015-01-01 00:41:20.000000', 'consum', 0.0217, 'lps'),
	(625113, 132, '2015-01-01 00:41:21.000000', 'consum', 0.0261, 'lps'),
	(625114, 132, '2015-01-01 00:41:22.000000', 'consum', 0.0280, 'lps'),
	(625115, 132, '2015-01-01 00:41:23.000000', 'consum', 0.0249, 'lps'),
	(625116, 132, '2015-01-01 00:41:24.000000', 'consum', 0.0274, 'lps'),
	(625117, 132, '2015-01-01 00:41:25.000000', 'consum', 0.0251, 'lps'),
	(625118, 132, '2015-01-01 00:41:26.000000', 'consum', 0.0225, 'lps'),
	(625119, 132, '2015-01-01 00:41:27.000000', 'consum', 0.0241, 'lps'),
	(625120, 132, '2015-01-01 00:41:28.000000', 'consum', 0.0241, 'lps'),
	(625121, 132, '2015-01-01 00:41:29.000000', 'consum', 0.0271, 'lps'),
	(625122, 132, '2015-01-01 00:41:30.000000', 'consum', 0.0262, 'lps'),
	(625123, 132, '2015-01-01 00:41:31.000000', 'consum', 0.0285, 'lps'),
	(625124, 132, '2015-01-01 00:41:32.000000', 'consum', 0.0269, 'lps'),
	(625125, 132, '2015-01-01 00:41:33.000000', 'consum', 0.0281, 'lps'),
	(625126, 132, '2015-01-01 00:41:34.000000', 'consum', 0.0228, 'lps'),
	(625127, 132, '2015-01-01 00:41:35.000000', 'consum', 0.0247, 'lps'),
	(625128, 132, '2015-01-01 00:41:36.000000', 'consum', 0.0262, 'lps'),
	(625129, 132, '2015-01-01 00:41:37.000000', 'consum', 0.0279, 'lps'),
	(625130, 132, '2015-01-01 00:41:38.000000', 'consum', 0.0238, 'lps'),
	(625131, 132, '2015-01-01 00:41:39.000000', 'consum', 0.0223, 'lps'),
	(625132, 132, '2015-01-01 00:41:40.000000', 'consum', 0.0273, 'lps'),
	(625133, 132, '2015-01-01 00:41:41.000000', 'consum', 0.0242, 'lps'),
	(625134, 132, '2015-01-01 00:41:42.000000', 'consum', 0.0265, 'lps'),
	(625135, 132, '2015-01-01 00:41:43.000000', 'consum', 0.0228, 'lps'),
	(625136, 132, '2015-01-01 00:41:44.000000', 'consum', 0.0216, 'lps'),
	(625137, 132, '2015-01-01 00:41:45.000000', 'consum', 0.0267, 'lps'),
	(625138, 132, '2015-01-01 00:41:46.000000', 'consum', 0.0233, 'lps'),
	(625139, 132, '2015-01-01 00:41:47.000000', 'consum', 0.0237, 'lps'),
	(625140, 132, '2015-01-01 00:41:48.000000', 'consum', 0.0275, 'lps'),
	(625141, 132, '2015-01-01 00:41:49.000000', 'consum', 0.0211, 'lps'),
	(625142, 132, '2015-01-01 00:41:50.000000', 'consum', 0.0264, 'lps'),
	(625143, 132, '2015-01-01 00:41:51.000000', 'consum', 0.0233, 'lps'),
	(625144, 132, '2015-01-01 00:41:52.000000', 'consum', 0.0246, 'lps'),
	(625145, 132, '2015-01-01 00:41:53.000000', 'consum', 0.0242, 'lps'),
	(625146, 132, '2015-01-01 00:41:54.000000', 'consum', 0.0263, 'lps'),
	(625147, 132, '2015-01-01 00:41:55.000000', 'consum', 0.0215, 'lps'),
	(625148, 132, '2015-01-01 00:41:56.000000', 'consum', 0.0239, 'lps'),
	(625149, 132, '2015-01-01 00:41:57.000000', 'consum', 0.0262, 'lps'),
	(625150, 132, '2015-01-01 00:41:58.000000', 'consum', 0.0219, 'lps'),
	(625151, 132, '2015-01-01 00:41:59.000000', 'consum', 0.0263, 'lps'),
	(625152, 132, '2015-01-01 00:42:00.000000', 'consum', 0.0284, 'lps'),
	(625153, 132, '2015-01-01 00:42:01.000000', 'consum', 0.0260, 'lps'),
	(625154, 132, '2015-01-01 00:42:02.000000', 'consum', 0.0241, 'lps'),
	(625155, 132, '2015-01-01 00:42:03.000000', 'consum', 0.0213, 'lps'),
	(625156, 132, '2015-01-01 00:42:04.000000', 'consum', 0.0213, 'lps'),
	(625157, 132, '2015-01-01 00:42:05.000000', 'consum', 0.0219, 'lps'),
	(625158, 132, '2015-01-01 00:42:06.000000', 'consum', 0.0246, 'lps'),
	(625159, 132, '2015-01-01 00:42:07.000000', 'consum', 0.0280, 'lps'),
	(625160, 132, '2015-01-01 00:42:08.000000', 'consum', 0.0211, 'lps'),
	(625161, 132, '2015-01-01 00:42:09.000000', 'consum', 0.0250, 'lps'),
	(625162, 132, '2015-01-01 00:42:10.000000', 'consum', 0.0244, 'lps'),
	(625163, 132, '2015-01-01 00:42:11.000000', 'consum', 0.0262, 'lps'),
	(625164, 132, '2015-01-01 00:42:12.000000', 'consum', 0.0288, 'lps'),
	(625165, 132, '2015-01-01 00:42:13.000000', 'consum', 0.0283, 'lps'),
	(625166, 132, '2015-01-01 00:42:14.000000', 'consum', 0.0260, 'lps'),
	(625167, 132, '2015-01-01 00:42:15.000000', 'consum', 0.0241, 'lps'),
	(625168, 132, '2015-01-01 00:42:16.000000', 'consum', 0.0217, 'lps'),
	(625169, 132, '2015-01-01 00:42:17.000000', 'consum', 0.0231, 'lps'),
	(625170, 132, '2015-01-01 00:42:18.000000', 'consum', 0.0213, 'lps'),
	(625171, 132, '2015-01-01 00:42:19.000000', 'consum', 0.0243, 'lps'),
	(625172, 132, '2015-01-01 00:42:20.000000', 'consum', 0.0287, 'lps'),
	(625173, 132, '2015-01-01 00:42:21.000000', 'consum', 0.0252, 'lps'),
	(625174, 132, '2015-01-01 00:42:22.000000', 'consum', 0.0270, 'lps'),
	(625175, 132, '2015-01-01 00:42:23.000000', 'consum', 0.0222, 'lps'),
	(625176, 132, '2015-01-01 00:42:24.000000', 'consum', 0.0252, 'lps'),
	(625177, 132, '2015-01-01 00:42:25.000000', 'consum', 0.0222, 'lps'),
	(625178, 132, '2015-01-01 00:42:26.000000', 'consum', 0.0226, 'lps'),
	(625179, 132, '2015-01-01 00:42:27.000000', 'consum', 0.0254, 'lps'),
	(625180, 132, '2015-01-01 00:42:28.000000', 'consum', 0.0219, 'lps'),
	(625181, 132, '2015-01-01 00:42:29.000000', 'consum', 0.0289, 'lps'),
	(625182, 132, '2015-01-01 00:42:30.000000', 'consum', 0.0252, 'lps'),
	(625183, 132, '2015-01-01 00:42:31.000000', 'consum', 0.0265, 'lps'),
	(625184, 132, '2015-01-01 00:42:32.000000', 'consum', 0.0281, 'lps'),
	(625185, 132, '2015-01-01 00:42:33.000000', 'consum', 0.0235, 'lps'),
	(625186, 132, '2015-01-01 00:42:34.000000', 'consum', 0.0285, 'lps'),
	(625187, 132, '2015-01-01 00:42:35.000000', 'consum', 0.0268, 'lps'),
	(625188, 132, '2015-01-01 00:42:36.000000', 'consum', 0.0276, 'lps'),
	(625189, 132, '2015-01-01 00:42:37.000000', 'consum', 0.0286, 'lps'),
	(625190, 132, '2015-01-01 00:42:38.000000', 'consum', 0.0230, 'lps'),
	(625191, 132, '2015-01-01 00:42:39.000000', 'consum', 0.0245, 'lps'),
	(625192, 132, '2015-01-01 00:42:40.000000', 'consum', 0.0246, 'lps'),
	(625193, 132, '2015-01-01 00:42:41.000000', 'consum', 0.0284, 'lps'),
	(625194, 132, '2015-01-01 00:42:42.000000', 'consum', 0.0228, 'lps'),
	(625195, 132, '2015-01-01 00:42:43.000000', 'consum', 0.0242, 'lps'),
	(625196, 132, '2015-01-01 00:42:44.000000', 'consum', 0.0236, 'lps'),
	(625197, 132, '2015-01-01 00:42:45.000000', 'consum', 0.0243, 'lps'),
	(625198, 132, '2015-01-01 00:42:46.000000', 'consum', 0.0219, 'lps'),
	(625199, 132, '2015-01-01 00:42:47.000000', 'consum', 0.0236, 'lps'),
	(625200, 132, '2015-01-01 00:42:48.000000', 'consum', 0.0233, 'lps'),
	(625201, 132, '2015-01-01 00:42:49.000000', 'consum', 0.0249, 'lps'),
	(625202, 132, '2015-01-01 00:42:50.000000', 'consum', 0.0253, 'lps'),
	(625203, 132, '2015-01-01 00:42:51.000000', 'consum', 0.0229, 'lps'),
	(625204, 132, '2015-01-01 00:42:52.000000', 'consum', 0.0258, 'lps'),
	(625205, 132, '2015-01-01 00:42:53.000000', 'consum', 0.0232, 'lps'),
	(625206, 132, '2015-01-01 00:42:54.000000', 'consum', 0.0257, 'lps'),
	(625207, 132, '2015-01-01 00:42:55.000000', 'consum', 0.0219, 'lps'),
	(625208, 132, '2015-01-01 00:42:56.000000', 'consum', 0.0276, 'lps'),
	(625209, 132, '2015-01-01 00:42:57.000000', 'consum', 0.0270, 'lps'),
	(625210, 132, '2015-01-01 00:42:58.000000', 'consum', 0.0231, 'lps'),
	(625211, 132, '2015-01-01 00:42:59.000000', 'consum', 0.0217, 'lps'),
	(625212, 132, '2015-01-01 00:43:00.000000', 'consum', 0.0261, 'lps'),
	(625213, 132, '2015-01-01 00:43:01.000000', 'consum', 0.0286, 'lps'),
	(625214, 132, '2015-01-01 00:43:02.000000', 'consum', 0.0274, 'lps'),
	(625215, 132, '2015-01-01 00:43:03.000000', 'consum', 0.0220, 'lps'),
	(625216, 132, '2015-01-01 00:43:04.000000', 'consum', 0.0230, 'lps'),
	(625217, 132, '2015-01-01 00:43:05.000000', 'consum', 0.0280, 'lps'),
	(625218, 132, '2015-01-01 00:43:06.000000', 'consum', 0.0258, 'lps'),
	(625219, 132, '2015-01-01 00:43:07.000000', 'consum', 0.0239, 'lps'),
	(625220, 132, '2015-01-01 00:43:08.000000', 'consum', 0.0215, 'lps'),
	(625221, 132, '2015-01-01 00:43:09.000000', 'consum', 0.0228, 'lps'),
	(625222, 132, '2015-01-01 00:43:10.000000', 'consum', 0.0284, 'lps'),
	(625223, 132, '2015-01-01 00:43:11.000000', 'consum', 0.0285, 'lps'),
	(625224, 132, '2015-01-01 00:43:12.000000', 'consum', 0.0283, 'lps'),
	(625225, 132, '2015-01-01 00:43:13.000000', 'consum', 0.0270, 'lps'),
	(625226, 132, '2015-01-01 00:43:14.000000', 'consum', 0.0210, 'lps'),
	(625227, 132, '2015-01-01 00:43:15.000000', 'consum', 0.0275, 'lps'),
	(625228, 132, '2015-01-01 00:43:16.000000', 'consum', 0.0210, 'lps'),
	(625229, 132, '2015-01-01 00:43:17.000000', 'consum', 0.0260, 'lps'),
	(625230, 132, '2015-01-01 00:43:18.000000', 'consum', 0.0219, 'lps'),
	(625231, 132, '2015-01-01 00:43:19.000000', 'consum', 0.0265, 'lps'),
	(625232, 132, '2015-01-01 00:43:20.000000', 'consum', 0.0215, 'lps'),
	(625233, 132, '2015-01-01 00:43:21.000000', 'consum', 0.0231, 'lps'),
	(625234, 132, '2015-01-01 00:43:22.000000', 'consum', 0.0223, 'lps'),
	(625235, 132, '2015-01-01 00:43:23.000000', 'consum', 0.0210, 'lps'),
	(625236, 132, '2015-01-01 00:43:24.000000', 'consum', 0.0253, 'lps'),
	(625237, 132, '2015-01-01 00:43:25.000000', 'consum', 0.0263, 'lps'),
	(625238, 132, '2015-01-01 00:43:26.000000', 'consum', 0.0266, 'lps'),
	(625239, 132, '2015-01-01 00:43:27.000000', 'consum', 0.0250, 'lps'),
	(625240, 132, '2015-01-01 00:43:28.000000', 'consum', 0.0241, 'lps'),
	(625241, 132, '2015-01-01 00:43:29.000000', 'consum', 0.0248, 'lps'),
	(625242, 132, '2015-01-01 00:43:30.000000', 'consum', 0.0227, 'lps'),
	(625243, 132, '2015-01-01 00:43:31.000000', 'consum', 0.0263, 'lps'),
	(625244, 132, '2015-01-01 00:43:32.000000', 'consum', 0.0261, 'lps'),
	(625245, 132, '2015-01-01 00:43:33.000000', 'consum', 0.0228, 'lps'),
	(625246, 132, '2015-01-01 00:43:34.000000', 'consum', 0.0227, 'lps'),
	(625247, 132, '2015-01-01 00:43:35.000000', 'consum', 0.0240, 'lps'),
	(625248, 132, '2015-01-01 00:43:36.000000', 'consum', 0.0229, 'lps'),
	(625249, 132, '2015-01-01 00:43:37.000000', 'consum', 0.0215, 'lps'),
	(625250, 132, '2015-01-01 00:43:38.000000', 'consum', 0.0260, 'lps'),
	(625251, 132, '2015-01-01 00:43:39.000000', 'consum', 0.0283, 'lps'),
	(625252, 132, '2015-01-01 00:43:40.000000', 'consum', 0.0264, 'lps'),
	(625253, 132, '2015-01-01 00:43:41.000000', 'consum', 0.0263, 'lps'),
	(625254, 132, '2015-01-01 00:43:42.000000', 'consum', 0.0230, 'lps'),
	(625255, 132, '2015-01-01 00:43:43.000000', 'consum', 0.0235, 'lps'),
	(625256, 132, '2015-01-01 00:43:44.000000', 'consum', 0.0273, 'lps'),
	(625257, 132, '2015-01-01 00:43:45.000000', 'consum', 0.0290, 'lps'),
	(625258, 132, '2015-01-01 00:43:46.000000', 'consum', 0.0261, 'lps'),
	(625259, 132, '2015-01-01 00:43:47.000000', 'consum', 0.0222, 'lps'),
	(625260, 132, '2015-01-01 00:43:48.000000', 'consum', 0.0282, 'lps'),
	(625261, 132, '2015-01-01 00:43:49.000000', 'consum', 0.0211, 'lps'),
	(625262, 132, '2015-01-01 00:43:50.000000', 'consum', 0.0242, 'lps'),
	(625263, 132, '2015-01-01 00:43:51.000000', 'consum', 0.0287, 'lps'),
	(625264, 132, '2015-01-01 00:43:52.000000', 'consum', 0.0256, 'lps'),
	(625265, 132, '2015-01-01 00:43:53.000000', 'consum', 0.0290, 'lps'),
	(625266, 132, '2015-01-01 00:43:54.000000', 'consum', 0.0231, 'lps'),
	(625267, 132, '2015-01-01 00:43:55.000000', 'consum', 0.0237, 'lps'),
	(625268, 132, '2015-01-01 00:43:56.000000', 'consum', 0.0282, 'lps'),
	(625269, 132, '2015-01-01 00:43:57.000000', 'consum', 0.0245, 'lps'),
	(625270, 132, '2015-01-01 00:43:58.000000', 'consum', 0.0253, 'lps'),
	(625271, 132, '2015-01-01 00:43:59.000000', 'consum', 0.0239, 'lps'),
	(625272, 132, '2015-01-01 00:44:00.000000', 'consum', 0.0226, 'lps'),
	(625273, 132, '2015-01-01 00:44:01.000000', 'consum', 0.0286, 'lps'),
	(625274, 132, '2015-01-01 00:44:02.000000', 'consum', 0.0217, 'lps'),
	(625275, 132, '2015-01-01 00:44:03.000000', 'consum', 0.0260, 'lps'),
	(625276, 132, '2015-01-01 00:44:04.000000', 'consum', 0.0278, 'lps'),
	(625277, 132, '2015-01-01 00:44:05.000000', 'consum', 0.0237, 'lps'),
	(625278, 132, '2015-01-01 00:44:06.000000', 'consum', 0.0224, 'lps'),
	(625279, 132, '2015-01-01 00:44:07.000000', 'consum', 0.0282, 'lps'),
	(625280, 132, '2015-01-01 00:44:08.000000', 'consum', 0.0285, 'lps'),
	(625281, 132, '2015-01-01 00:44:09.000000', 'consum', 0.0286, 'lps'),
	(625282, 132, '2015-01-01 00:44:10.000000', 'consum', 0.0287, 'lps'),
	(625283, 132, '2015-01-01 00:44:11.000000', 'consum', 0.0287, 'lps'),
	(625284, 132, '2015-01-01 00:44:12.000000', 'consum', 0.0283, 'lps'),
	(625285, 132, '2015-01-01 00:44:13.000000', 'consum', 0.0263, 'lps'),
	(625286, 132, '2015-01-01 00:44:14.000000', 'consum', 0.0258, 'lps'),
	(625287, 132, '2015-01-01 00:44:15.000000', 'consum', 0.0289, 'lps'),
	(625288, 132, '2015-01-01 00:44:16.000000', 'consum', 0.0220, 'lps'),
	(625289, 132, '2015-01-01 00:44:17.000000', 'consum', 0.0265, 'lps'),
	(625290, 132, '2015-01-01 00:44:18.000000', 'consum', 0.0213, 'lps'),
	(625291, 132, '2015-01-01 00:44:19.000000', 'consum', 0.0224, 'lps'),
	(625292, 132, '2015-01-01 00:44:20.000000', 'consum', 0.0270, 'lps'),
	(625293, 132, '2015-01-01 00:44:21.000000', 'consum', 0.0227, 'lps'),
	(625294, 132, '2015-01-01 00:44:22.000000', 'consum', 0.0276, 'lps'),
	(625295, 132, '2015-01-01 00:44:23.000000', 'consum', 0.0245, 'lps'),
	(625296, 132, '2015-01-01 00:44:24.000000', 'consum', 0.0270, 'lps'),
	(625297, 132, '2015-01-01 00:44:25.000000', 'consum', 0.0244, 'lps'),
	(625298, 132, '2015-01-01 00:44:26.000000', 'consum', 0.0283, 'lps'),
	(625299, 132, '2015-01-01 00:44:27.000000', 'consum', 0.0227, 'lps'),
	(625300, 132, '2015-01-01 00:44:28.000000', 'consum', 0.0241, 'lps'),
	(625301, 132, '2015-01-01 00:44:29.000000', 'consum', 0.0235, 'lps'),
	(625302, 132, '2015-01-01 00:44:30.000000', 'consum', 0.0240, 'lps'),
	(625303, 132, '2015-01-01 00:44:31.000000', 'consum', 0.0288, 'lps'),
	(625304, 132, '2015-01-01 00:44:32.000000', 'consum', 0.0265, 'lps'),
	(625305, 132, '2015-01-01 00:44:33.000000', 'consum', 0.0254, 'lps'),
	(625306, 132, '2015-01-01 00:44:34.000000', 'consum', 0.0264, 'lps'),
	(625307, 132, '2015-01-01 00:44:35.000000', 'consum', 0.0268, 'lps'),
	(625308, 132, '2015-01-01 00:44:36.000000', 'consum', 0.0258, 'lps'),
	(625309, 132, '2015-01-01 00:44:37.000000', 'consum', 0.0277, 'lps'),
	(625310, 132, '2015-01-01 00:44:38.000000', 'consum', 0.0239, 'lps'),
	(625311, 132, '2015-01-01 00:44:39.000000', 'consum', 0.0235, 'lps'),
	(625312, 132, '2015-01-01 00:44:40.000000', 'consum', 0.0249, 'lps'),
	(625313, 132, '2015-01-01 00:44:41.000000', 'consum', 0.0248, 'lps'),
	(625314, 132, '2015-01-01 00:44:42.000000', 'consum', 0.0283, 'lps'),
	(625315, 132, '2015-01-01 00:44:43.000000', 'consum', 0.0220, 'lps'),
	(625316, 132, '2015-01-01 00:44:44.000000', 'consum', 0.0284, 'lps'),
	(625317, 132, '2015-01-01 00:44:45.000000', 'consum', 0.0228, 'lps'),
	(625318, 132, '2015-01-01 00:44:46.000000', 'consum', 0.0240, 'lps'),
	(625319, 132, '2015-01-01 00:44:47.000000', 'consum', 0.0226, 'lps'),
	(625320, 132, '2015-01-01 00:44:48.000000', 'consum', 0.0280, 'lps'),
	(625321, 132, '2015-01-01 00:44:49.000000', 'consum', 0.0272, 'lps'),
	(625322, 132, '2015-01-01 00:44:50.000000', 'consum', 0.0226, 'lps'),
	(625323, 132, '2015-01-01 00:44:51.000000', 'consum', 0.0268, 'lps'),
	(625324, 132, '2015-01-01 00:44:52.000000', 'consum', 0.0211, 'lps'),
	(625325, 132, '2015-01-01 00:44:53.000000', 'consum', 0.0285, 'lps'),
	(625326, 132, '2015-01-01 00:44:54.000000', 'consum', 0.0258, 'lps'),
	(625327, 132, '2015-01-01 00:44:55.000000', 'consum', 0.0224, 'lps'),
	(625328, 132, '2015-01-01 00:44:56.000000', 'consum', 0.0216, 'lps'),
	(625329, 132, '2015-01-01 00:44:57.000000', 'consum', 0.0282, 'lps'),
	(625330, 132, '2015-01-01 00:44:58.000000', 'consum', 0.0228, 'lps'),
	(625331, 132, '2015-01-01 00:44:59.000000', 'consum', 0.0248, 'lps'),
	(625332, 132, '2015-01-01 00:45:00.000000', 'consum', 0.0264, 'lps'),
	(625333, 132, '2015-01-01 00:45:01.000000', 'consum', 0.0288, 'lps'),
	(625334, 132, '2015-01-01 00:45:02.000000', 'consum', 0.0273, 'lps'),
	(625335, 132, '2015-01-01 00:45:03.000000', 'consum', 0.0214, 'lps'),
	(625336, 132, '2015-01-01 00:45:04.000000', 'consum', 0.0282, 'lps'),
	(625337, 132, '2015-01-01 00:45:05.000000', 'consum', 0.0235, 'lps'),
	(625338, 132, '2015-01-01 00:45:06.000000', 'consum', 0.0282, 'lps'),
	(625339, 132, '2015-01-01 00:45:07.000000', 'consum', 0.0252, 'lps'),
	(625340, 132, '2015-01-01 00:45:08.000000', 'consum', 0.0286, 'lps'),
	(625341, 132, '2015-01-01 00:45:09.000000', 'consum', 0.0221, 'lps'),
	(625342, 132, '2015-01-01 00:45:10.000000', 'consum', 0.0283, 'lps'),
	(625343, 132, '2015-01-01 00:45:11.000000', 'consum', 0.0215, 'lps'),
	(625344, 132, '2015-01-01 00:45:12.000000', 'consum', 0.0260, 'lps'),
	(625345, 132, '2015-01-01 00:45:13.000000', 'consum', 0.0283, 'lps'),
	(625346, 132, '2015-01-01 00:45:14.000000', 'consum', 0.0265, 'lps'),
	(625347, 132, '2015-01-01 00:45:15.000000', 'consum', 0.0267, 'lps'),
	(625348, 132, '2015-01-01 00:45:16.000000', 'consum', 0.0249, 'lps'),
	(625349, 132, '2015-01-01 00:45:17.000000', 'consum', 0.0235, 'lps'),
	(625350, 132, '2015-01-01 00:45:18.000000', 'consum', 0.0216, 'lps'),
	(625351, 132, '2015-01-01 00:45:19.000000', 'consum', 0.0248, 'lps'),
	(625352, 132, '2015-01-01 00:45:20.000000', 'consum', 0.0218, 'lps'),
	(625353, 132, '2015-01-01 00:45:21.000000', 'consum', 0.0221, 'lps'),
	(625354, 132, '2015-01-01 00:45:22.000000', 'consum', 0.0240, 'lps'),
	(625355, 132, '2015-01-01 00:45:23.000000', 'consum', 0.0246, 'lps'),
	(625356, 132, '2015-01-01 00:45:24.000000', 'consum', 0.0221, 'lps'),
	(625357, 132, '2015-01-01 00:45:25.000000', 'consum', 0.0236, 'lps'),
	(625358, 132, '2015-01-01 00:45:26.000000', 'consum', 0.0226, 'lps'),
	(625359, 132, '2015-01-01 00:45:27.000000', 'consum', 0.0216, 'lps'),
	(625360, 132, '2015-01-01 00:45:28.000000', 'consum', 0.0271, 'lps'),
	(625361, 132, '2015-01-01 00:45:29.000000', 'consum', 0.0255, 'lps'),
	(625362, 132, '2015-01-01 00:45:30.000000', 'consum', 0.0253, 'lps'),
	(625363, 132, '2015-01-01 00:45:31.000000', 'consum', 0.0211, 'lps'),
	(625364, 132, '2015-01-01 00:45:32.000000', 'consum', 0.0247, 'lps'),
	(625365, 132, '2015-01-01 00:45:33.000000', 'consum', 0.0229, 'lps'),
	(625366, 132, '2015-01-01 00:45:34.000000', 'consum', 0.0277, 'lps'),
	(625367, 132, '2015-01-01 00:45:35.000000', 'consum', 0.0246, 'lps'),
	(625368, 132, '2015-01-01 00:45:36.000000', 'consum', 0.0270, 'lps'),
	(625369, 132, '2015-01-01 00:45:37.000000', 'consum', 0.0241, 'lps'),
	(625370, 132, '2015-01-01 00:45:38.000000', 'consum', 0.0267, 'lps'),
	(625371, 132, '2015-01-01 00:45:39.000000', 'consum', 0.0241, 'lps'),
	(625372, 132, '2015-01-01 00:45:40.000000', 'consum', 0.0276, 'lps'),
	(625373, 132, '2015-01-01 00:45:41.000000', 'consum', 0.0287, 'lps'),
	(625374, 132, '2015-01-01 00:45:42.000000', 'consum', 0.0233, 'lps'),
	(625375, 132, '2015-01-01 00:45:43.000000', 'consum', 0.0255, 'lps'),
	(625376, 132, '2015-01-01 00:45:44.000000', 'consum', 0.0289, 'lps'),
	(625377, 132, '2015-01-01 00:45:45.000000', 'consum', 0.0225, 'lps'),
	(625378, 132, '2015-01-01 00:45:46.000000', 'consum', 0.0211, 'lps'),
	(625379, 132, '2015-01-01 00:45:47.000000', 'consum', 0.0253, 'lps'),
	(625380, 132, '2015-01-01 00:45:48.000000', 'consum', 0.0260, 'lps'),
	(625381, 132, '2015-01-01 00:45:49.000000', 'consum', 0.0252, 'lps'),
	(625382, 132, '2015-01-01 00:45:50.000000', 'consum', 0.0268, 'lps'),
	(625383, 132, '2015-01-01 00:45:51.000000', 'consum', 0.0214, 'lps'),
	(625384, 132, '2015-01-01 00:45:52.000000', 'consum', 0.0218, 'lps'),
	(625385, 132, '2015-01-01 00:45:53.000000', 'consum', 0.0238, 'lps'),
	(625386, 132, '2015-01-01 00:45:54.000000', 'consum', 0.0246, 'lps'),
	(625387, 132, '2015-01-01 00:45:55.000000', 'consum', 0.0225, 'lps'),
	(625388, 132, '2015-01-01 00:45:56.000000', 'consum', 0.0259, 'lps'),
	(625389, 132, '2015-01-01 00:45:57.000000', 'consum', 0.0250, 'lps'),
	(625390, 132, '2015-01-01 00:45:58.000000', 'consum', 0.0263, 'lps'),
	(625391, 132, '2015-01-01 00:45:59.000000', 'consum', 0.0272, 'lps'),
	(625392, 132, '2015-01-01 00:46:00.000000', 'consum', 0.0282, 'lps'),
	(625393, 132, '2015-01-01 00:46:01.000000', 'consum', 0.0220, 'lps'),
	(625394, 132, '2015-01-01 00:46:02.000000', 'consum', 0.0210, 'lps'),
	(625395, 132, '2015-01-01 00:46:03.000000', 'consum', 0.0262, 'lps'),
	(625396, 132, '2015-01-01 00:46:04.000000', 'consum', 0.0225, 'lps'),
	(625397, 132, '2015-01-01 00:46:05.000000', 'consum', 0.0210, 'lps'),
	(625398, 132, '2015-01-01 00:46:06.000000', 'consum', 0.0246, 'lps'),
	(625399, 132, '2015-01-01 00:46:07.000000', 'consum', 0.0232, 'lps'),
	(625400, 132, '2015-01-01 00:46:08.000000', 'consum', 0.0290, 'lps'),
	(625401, 132, '2015-01-01 00:46:09.000000', 'consum', 0.0222, 'lps'),
	(625402, 132, '2015-01-01 00:46:10.000000', 'consum', 0.0275, 'lps'),
	(625403, 132, '2015-01-01 00:46:11.000000', 'consum', 0.0257, 'lps'),
	(625404, 132, '2015-01-01 00:46:12.000000', 'consum', 0.0248, 'lps'),
	(625405, 132, '2015-01-01 00:46:13.000000', 'consum', 0.0262, 'lps'),
	(625406, 132, '2015-01-01 00:46:14.000000', 'consum', 0.0274, 'lps'),
	(625407, 132, '2015-01-01 00:46:15.000000', 'consum', 0.0214, 'lps'),
	(625408, 132, '2015-01-01 00:46:16.000000', 'consum', 0.0280, 'lps'),
	(625409, 132, '2015-01-01 00:46:17.000000', 'consum', 0.0226, 'lps'),
	(625410, 132, '2015-01-01 00:46:18.000000', 'consum', 0.0240, 'lps'),
	(625411, 132, '2015-01-01 00:46:19.000000', 'consum', 0.0234, 'lps'),
	(625412, 132, '2015-01-01 00:46:20.000000', 'consum', 0.0239, 'lps'),
	(625413, 132, '2015-01-01 00:46:21.000000', 'consum', 0.0283, 'lps'),
	(625414, 132, '2015-01-01 00:46:22.000000', 'consum', 0.0245, 'lps'),
	(625415, 132, '2015-01-01 00:46:23.000000', 'consum', 0.0246, 'lps'),
	(625416, 132, '2015-01-01 00:46:24.000000', 'consum', 0.0288, 'lps'),
	(625417, 132, '2015-01-01 00:46:25.000000', 'consum', 0.0250, 'lps'),
	(625418, 132, '2015-01-01 00:46:26.000000', 'consum', 0.0257, 'lps'),
	(625419, 132, '2015-01-01 00:46:27.000000', 'consum', 0.0245, 'lps'),
	(625420, 132, '2015-01-01 00:46:28.000000', 'consum', 0.0244, 'lps'),
	(625421, 132, '2015-01-01 00:46:29.000000', 'consum', 0.0274, 'lps'),
	(625422, 132, '2015-01-01 00:46:30.000000', 'consum', 0.0266, 'lps'),
	(625423, 132, '2015-01-01 00:46:31.000000', 'consum', 0.0217, 'lps'),
	(625424, 132, '2015-01-01 00:46:32.000000', 'consum', 0.0241, 'lps'),
	(625425, 132, '2015-01-01 00:46:33.000000', 'consum', 0.0264, 'lps'),
	(625426, 132, '2015-01-01 00:46:34.000000', 'consum', 0.0224, 'lps'),
	(625427, 132, '2015-01-01 00:46:35.000000', 'consum', 0.0283, 'lps'),
	(625428, 132, '2015-01-01 00:46:36.000000', 'consum', 0.0288, 'lps'),
	(625429, 132, '2015-01-01 00:46:37.000000', 'consum', 0.0222, 'lps'),
	(625430, 132, '2015-01-01 00:46:38.000000', 'consum', 0.0277, 'lps'),
	(625431, 132, '2015-01-01 00:46:39.000000', 'consum', 0.0267, 'lps'),
	(625432, 132, '2015-01-01 00:46:40.000000', 'consum', 0.0214, 'lps'),
	(625433, 132, '2015-01-01 00:46:41.000000', 'consum', 0.0220, 'lps'),
	(625434, 132, '2015-01-01 00:46:42.000000', 'consum', 0.0248, 'lps'),
	(625435, 132, '2015-01-01 00:46:43.000000', 'consum', 0.0212, 'lps'),
	(625436, 132, '2015-01-01 00:46:44.000000', 'consum', 0.0265, 'lps'),
	(625437, 132, '2015-01-01 00:46:45.000000', 'consum', 0.0236, 'lps'),
	(625438, 132, '2015-01-01 00:46:46.000000', 'consum', 0.0258, 'lps'),
	(625439, 132, '2015-01-01 00:46:47.000000', 'consum', 0.0212, 'lps'),
	(625440, 132, '2015-01-01 00:46:48.000000', 'consum', 0.0236, 'lps'),
	(625441, 132, '2015-01-01 00:46:49.000000', 'consum', 0.0254, 'lps'),
	(625442, 132, '2015-01-01 00:46:50.000000', 'consum', 0.0272, 'lps'),
	(625443, 132, '2015-01-01 00:46:51.000000', 'consum', 0.0226, 'lps'),
	(625444, 132, '2015-01-01 00:46:52.000000', 'consum', 0.0268, 'lps'),
	(625445, 132, '2015-01-01 00:46:53.000000', 'consum', 0.0288, 'lps'),
	(625446, 132, '2015-01-01 00:46:54.000000', 'consum', 0.0266, 'lps'),
	(625447, 132, '2015-01-01 00:46:55.000000', 'consum', 0.0256, 'lps'),
	(625448, 132, '2015-01-01 00:46:56.000000', 'consum', 0.0273, 'lps'),
	(625449, 132, '2015-01-01 00:46:57.000000', 'consum', 0.0227, 'lps'),
	(625450, 132, '2015-01-01 00:46:58.000000', 'consum', 0.0269, 'lps'),
	(625451, 132, '2015-01-01 00:46:59.000000', 'consum', 0.0290, 'lps'),
	(625452, 132, '2015-01-01 00:47:00.000000', 'consum', 0.0271, 'lps'),
	(625453, 132, '2015-01-01 00:47:01.000000', 'consum', 0.0278, 'lps'),
	(625454, 132, '2015-01-01 00:47:02.000000', 'consum', 0.0285, 'lps'),
	(625455, 132, '2015-01-01 00:47:03.000000', 'consum', 0.0221, 'lps'),
	(625456, 132, '2015-01-01 00:47:04.000000', 'consum', 0.0281, 'lps'),
	(625457, 132, '2015-01-01 00:47:05.000000', 'consum', 0.0289, 'lps'),
	(625458, 132, '2015-01-01 00:47:06.000000', 'consum', 0.0232, 'lps'),
	(625459, 132, '2015-01-01 00:47:07.000000', 'consum', 0.0243, 'lps'),
	(625460, 132, '2015-01-01 00:47:08.000000', 'consum', 0.0231, 'lps'),
	(625461, 132, '2015-01-01 00:47:09.000000', 'consum', 0.0215, 'lps'),
	(625462, 132, '2015-01-01 00:47:10.000000', 'consum', 0.0255, 'lps'),
	(625463, 132, '2015-01-01 00:47:11.000000', 'consum', 0.0258, 'lps'),
	(625464, 132, '2015-01-01 00:47:12.000000', 'consum', 0.0233, 'lps'),
	(625465, 132, '2015-01-01 00:47:13.000000', 'consum', 0.0262, 'lps'),
	(625466, 132, '2015-01-01 00:47:14.000000', 'consum', 0.0241, 'lps'),
	(625467, 132, '2015-01-01 00:47:15.000000', 'consum', 0.0211, 'lps'),
	(625468, 132, '2015-01-01 00:47:16.000000', 'consum', 0.0284, 'lps'),
	(625469, 132, '2015-01-01 00:47:17.000000', 'consum', 0.0255, 'lps'),
	(625470, 132, '2015-01-01 00:47:18.000000', 'consum', 0.0212, 'lps'),
	(625471, 132, '2015-01-01 00:47:19.000000', 'consum', 0.0246, 'lps'),
	(625472, 132, '2015-01-01 00:47:20.000000', 'consum', 0.0223, 'lps'),
	(625473, 132, '2015-01-01 00:47:21.000000', 'consum', 0.0250, 'lps'),
	(625474, 132, '2015-01-01 00:47:22.000000', 'consum', 0.0289, 'lps'),
	(625475, 132, '2015-01-01 00:47:23.000000', 'consum', 0.0245, 'lps'),
	(625476, 132, '2015-01-01 00:47:24.000000', 'consum', 0.0228, 'lps'),
	(625477, 132, '2015-01-01 00:47:25.000000', 'consum', 0.0275, 'lps'),
	(625478, 132, '2015-01-01 00:47:26.000000', 'consum', 0.0239, 'lps'),
	(625479, 132, '2015-01-01 00:47:27.000000', 'consum', 0.0242, 'lps'),
	(625480, 132, '2015-01-01 00:47:28.000000', 'consum', 0.0281, 'lps'),
	(625481, 132, '2015-01-01 00:47:29.000000', 'consum', 0.0230, 'lps'),
	(625482, 132, '2015-01-01 00:47:30.000000', 'consum', 0.0259, 'lps'),
	(625483, 132, '2015-01-01 00:47:31.000000', 'consum', 0.0235, 'lps'),
	(625484, 132, '2015-01-01 00:47:32.000000', 'consum', 0.0267, 'lps'),
	(625485, 132, '2015-01-01 00:47:33.000000', 'consum', 0.0259, 'lps'),
	(625486, 132, '2015-01-01 00:47:34.000000', 'consum', 0.0283, 'lps'),
	(625487, 132, '2015-01-01 00:47:35.000000', 'consum', 0.0267, 'lps'),
	(625488, 132, '2015-01-01 00:47:36.000000', 'consum', 0.0276, 'lps'),
	(625489, 132, '2015-01-01 00:47:37.000000', 'consum', 0.0288, 'lps'),
	(625490, 132, '2015-01-01 00:47:38.000000', 'consum', 0.0243, 'lps'),
	(625491, 132, '2015-01-01 00:47:39.000000', 'consum', 0.0220, 'lps'),
	(625492, 132, '2015-01-01 00:47:40.000000', 'consum', 0.0245, 'lps'),
	(625493, 132, '2015-01-01 00:47:41.000000', 'consum', 0.0274, 'lps'),
	(625494, 132, '2015-01-01 00:47:42.000000', 'consum', 0.0265, 'lps'),
	(625495, 132, '2015-01-01 00:47:43.000000', 'consum', 0.0210, 'lps'),
	(625496, 132, '2015-01-01 00:47:44.000000', 'consum', 0.0290, 'lps'),
	(625497, 132, '2015-01-01 00:47:45.000000', 'consum', 0.0286, 'lps'),
	(625498, 132, '2015-01-01 00:47:46.000000', 'consum', 0.0269, 'lps'),
	(625499, 132, '2015-01-01 00:47:47.000000', 'consum', 0.0279, 'lps'),
	(625500, 132, '2015-01-01 00:47:48.000000', 'consum', 0.0218, 'lps'),
	(625501, 132, '2015-01-01 00:47:49.000000', 'consum', 0.0283, 'lps'),
	(625502, 132, '2015-01-01 00:47:50.000000', 'consum', 0.0230, 'lps'),
	(625503, 132, '2015-01-01 00:47:51.000000', 'consum', 0.0254, 'lps'),
	(625504, 132, '2015-01-01 00:47:52.000000', 'consum', 0.0287, 'lps'),
	(625505, 132, '2015-01-01 00:47:53.000000', 'consum', 0.0222, 'lps'),
	(625506, 132, '2015-01-01 00:47:54.000000', 'consum', 0.0282, 'lps'),
	(625507, 132, '2015-01-01 00:47:55.000000', 'consum', 0.0211, 'lps'),
	(625508, 132, '2015-01-01 00:47:56.000000', 'consum', 0.0240, 'lps'),
	(625509, 132, '2015-01-01 00:47:57.000000', 'consum', 0.0279, 'lps'),
	(625510, 132, '2015-01-01 00:47:58.000000', 'consum', 0.0224, 'lps'),
	(625511, 132, '2015-01-01 00:47:59.000000', 'consum', 0.0232, 'lps'),
	(625512, 132, '2015-01-01 00:48:00.000000', 'consum', 0.0281, 'lps'),
	(625513, 132, '2015-01-01 00:48:01.000000', 'consum', 0.0254, 'lps'),
	(625514, 132, '2015-01-01 00:48:02.000000', 'consum', 0.0219, 'lps'),
	(625515, 132, '2015-01-01 00:48:03.000000', 'consum', 0.0285, 'lps'),
	(625516, 132, '2015-01-01 00:48:04.000000', 'consum', 0.0234, 'lps'),
	(625517, 132, '2015-01-01 00:48:05.000000', 'consum', 0.0266, 'lps'),
	(625518, 132, '2015-01-01 00:48:06.000000', 'consum', 0.0258, 'lps'),
	(625519, 132, '2015-01-01 00:48:07.000000', 'consum', 0.0282, 'lps'),
	(625520, 132, '2015-01-01 00:48:08.000000', 'consum', 0.0265, 'lps'),
	(625521, 132, '2015-01-01 00:48:09.000000', 'consum', 0.0271, 'lps'),
	(625522, 132, '2015-01-01 00:48:10.000000', 'consum', 0.0270, 'lps'),
	(625523, 132, '2015-01-01 00:48:11.000000', 'consum', 0.0244, 'lps'),
	(625524, 132, '2015-01-01 00:48:12.000000', 'consum', 0.0281, 'lps'),
	(625525, 132, '2015-01-01 00:48:13.000000', 'consum', 0.0220, 'lps'),
	(625526, 132, '2015-01-01 00:48:14.000000', 'consum', 0.0210, 'lps'),
	(625527, 132, '2015-01-01 00:48:15.000000', 'consum', 0.0263, 'lps'),
	(625528, 132, '2015-01-01 00:48:16.000000', 'consum', 0.0233, 'lps'),
	(625529, 132, '2015-01-01 00:48:17.000000', 'consum', 0.0245, 'lps'),
	(625530, 132, '2015-01-01 00:48:18.000000', 'consum', 0.0235, 'lps'),
	(625531, 132, '2015-01-01 00:48:19.000000', 'consum', 0.0230, 'lps'),
	(625532, 132, '2015-01-01 00:48:20.000000', 'consum', 0.0239, 'lps'),
	(625533, 132, '2015-01-01 00:48:21.000000', 'consum', 0.0211, 'lps'),
	(625534, 132, '2015-01-01 00:48:22.000000', 'consum', 0.0212, 'lps'),
	(625535, 132, '2015-01-01 00:48:23.000000', 'consum', 0.0215, 'lps'),
	(625536, 132, '2015-01-01 00:48:24.000000', 'consum', 0.0229, 'lps'),
	(625537, 132, '2015-01-01 00:48:25.000000', 'consum', 0.0213, 'lps'),
	(625538, 132, '2015-01-01 00:48:26.000000', 'consum', 0.0247, 'lps'),
	(625539, 132, '2015-01-01 00:48:27.000000', 'consum', 0.0224, 'lps'),
	(625540, 132, '2015-01-01 00:48:28.000000', 'consum', 0.0249, 'lps'),
	(625541, 132, '2015-01-01 00:48:29.000000', 'consum', 0.0285, 'lps'),
	(625542, 132, '2015-01-01 00:48:30.000000', 'consum', 0.0224, 'lps'),
	(625543, 132, '2015-01-01 00:48:31.000000', 'consum', 0.0217, 'lps'),
	(625544, 132, '2015-01-01 00:48:32.000000', 'consum', 0.0287, 'lps'),
	(625545, 132, '2015-01-01 00:48:33.000000', 'consum', 0.0251, 'lps'),
	(625546, 132, '2015-01-01 00:48:34.000000', 'consum', 0.0264, 'lps'),
	(625547, 132, '2015-01-01 00:48:35.000000', 'consum', 0.0279, 'lps'),
	(625548, 132, '2015-01-01 00:48:36.000000', 'consum', 0.0228, 'lps'),
	(625549, 132, '2015-01-01 00:48:37.000000', 'consum', 0.0258, 'lps'),
	(625550, 132, '2015-01-01 00:48:38.000000', 'consum', 0.0234, 'lps'),
	(625551, 132, '2015-01-01 00:48:39.000000', 'consum', 0.0267, 'lps'),
	(625552, 132, '2015-01-01 00:48:40.000000', 'consum', 0.0264, 'lps'),
	(625553, 132, '2015-01-01 00:48:41.000000', 'consum', 0.0225, 'lps'),
	(625554, 132, '2015-01-01 00:48:42.000000', 'consum', 0.0289, 'lps'),
	(625555, 132, '2015-01-01 00:48:43.000000', 'consum', 0.0233, 'lps'),
	(625556, 132, '2015-01-01 00:48:44.000000', 'consum', 0.0254, 'lps'),
	(625557, 132, '2015-01-01 00:48:45.000000', 'consum', 0.0278, 'lps'),
	(625558, 132, '2015-01-01 00:48:46.000000', 'consum', 0.0259, 'lps'),
	(625559, 132, '2015-01-01 00:48:47.000000', 'consum', 0.0249, 'lps'),
	(625560, 132, '2015-01-01 00:48:48.000000', 'consum', 0.0262, 'lps'),
	(625561, 132, '2015-01-01 00:48:49.000000', 'consum', 0.0269, 'lps'),
	(625562, 132, '2015-01-01 00:48:50.000000', 'consum', 0.0268, 'lps'),
	(625563, 132, '2015-01-01 00:48:51.000000', 'consum', 0.0242, 'lps'),
	(625564, 132, '2015-01-01 00:48:52.000000', 'consum', 0.0281, 'lps'),
	(625565, 132, '2015-01-01 00:48:53.000000', 'consum', 0.0223, 'lps'),
	(625566, 132, '2015-01-01 00:48:54.000000', 'consum', 0.0226, 'lps'),
	(625567, 132, '2015-01-01 00:48:55.000000', 'consum', 0.0251, 'lps'),
	(625568, 132, '2015-01-01 00:48:56.000000', 'consum', 0.0287, 'lps'),
	(625569, 132, '2015-01-01 00:48:57.000000', 'consum', 0.0229, 'lps'),
	(625570, 132, '2015-01-01 00:48:58.000000', 'consum', 0.0236, 'lps'),
	(625571, 132, '2015-01-01 00:48:59.000000', 'consum', 0.0285, 'lps'),
	(625572, 132, '2015-01-01 00:49:00.000000', 'consum', 0.0263, 'lps'),
	(625573, 132, '2015-01-01 00:49:01.000000', 'consum', 0.0252, 'lps'),
	(625574, 132, '2015-01-01 00:49:02.000000', 'consum', 0.0262, 'lps'),
	(625575, 132, '2015-01-01 00:49:03.000000', 'consum', 0.0261, 'lps'),
	(625576, 132, '2015-01-01 00:49:04.000000', 'consum', 0.0230, 'lps'),
	(625577, 132, '2015-01-01 00:49:05.000000', 'consum', 0.0236, 'lps'),
	(625578, 132, '2015-01-01 00:49:06.000000', 'consum', 0.0284, 'lps'),
	(625579, 132, '2015-01-01 00:49:07.000000', 'consum', 0.0256, 'lps'),
	(625580, 132, '2015-01-01 00:49:08.000000', 'consum', 0.0220, 'lps'),
	(625581, 132, '2015-01-01 00:49:09.000000', 'consum', 0.0285, 'lps'),
	(625582, 132, '2015-01-01 00:49:10.000000', 'consum', 0.0231, 'lps'),
	(625583, 132, '2015-01-01 00:49:11.000000', 'consum', 0.0254, 'lps'),
	(625584, 132, '2015-01-01 00:49:12.000000', 'consum', 0.0284, 'lps'),
	(625585, 132, '2015-01-01 00:49:13.000000', 'consum', 0.0288, 'lps'),
	(625586, 132, '2015-01-01 00:49:14.000000', 'consum', 0.0217, 'lps'),
	(625587, 132, '2015-01-01 00:49:15.000000', 'consum', 0.0252, 'lps'),
	(625588, 132, '2015-01-01 00:49:16.000000', 'consum', 0.0240, 'lps'),
	(625589, 132, '2015-01-01 00:49:17.000000', 'consum', 0.0233, 'lps'),
	(625590, 132, '2015-01-01 00:49:18.000000', 'consum', 0.0238, 'lps'),
	(625591, 132, '2015-01-01 00:49:19.000000', 'consum', 0.0279, 'lps'),
	(625592, 132, '2015-01-01 00:49:20.000000', 'consum', 0.0229, 'lps'),
	(625593, 132, '2015-01-01 00:49:21.000000', 'consum', 0.0263, 'lps'),
	(625594, 132, '2015-01-01 00:49:22.000000', 'consum', 0.0253, 'lps'),
	(625595, 132, '2015-01-01 00:49:23.000000', 'consum', 0.0267, 'lps'),
	(625596, 132, '2015-01-01 00:49:24.000000', 'consum', 0.0285, 'lps'),
	(625597, 132, '2015-01-01 00:49:25.000000', 'consum', 0.0255, 'lps'),
	(625598, 132, '2015-01-01 00:49:26.000000', 'consum', 0.0210, 'lps'),
	(625599, 132, '2015-01-01 00:49:27.000000', 'consum', 0.0237, 'lps'),
	(625600, 132, '2015-01-01 00:49:28.000000', 'consum', 0.0265, 'lps'),
	(625601, 132, '2015-01-01 00:49:29.000000', 'consum', 0.0242, 'lps'),
	(625602, 132, '2015-01-01 00:49:30.000000', 'consum', 0.0286, 'lps'),
	(625603, 132, '2015-01-01 00:49:31.000000', 'consum', 0.0253, 'lps'),
	(625604, 132, '2015-01-01 00:49:32.000000', 'consum', 0.0276, 'lps'),
	(625605, 132, '2015-01-01 00:49:33.000000', 'consum', 0.0252, 'lps'),
	(625606, 132, '2015-01-01 00:49:34.000000', 'consum', 0.0220, 'lps'),
	(625607, 132, '2015-01-01 00:49:35.000000', 'consum', 0.0217, 'lps'),
	(625608, 132, '2015-01-01 00:49:36.000000', 'consum', 0.0215, 'lps'),
	(625609, 132, '2015-01-01 00:49:37.000000', 'consum', 0.0216, 'lps'),
	(625610, 132, '2015-01-01 00:49:38.000000', 'consum', 0.0226, 'lps'),
	(625611, 132, '2015-01-01 00:49:39.000000', 'consum', 0.0270, 'lps'),
	(625612, 132, '2015-01-01 00:49:40.000000', 'consum', 0.0221, 'lps'),
	(625613, 132, '2015-01-01 00:49:41.000000', 'consum', 0.0248, 'lps'),
	(625614, 132, '2015-01-01 00:49:42.000000', 'consum', 0.0286, 'lps'),
	(625615, 132, '2015-01-01 00:49:43.000000', 'consum', 0.0235, 'lps'),
	(625616, 132, '2015-01-01 00:49:44.000000', 'consum', 0.0270, 'lps'),
	(625617, 132, '2015-01-01 00:49:45.000000', 'consum', 0.0274, 'lps'),
	(625618, 132, '2015-01-01 00:49:46.000000', 'consum', 0.0269, 'lps'),
	(625619, 132, '2015-01-01 00:49:47.000000', 'consum', 0.0232, 'lps'),
	(625620, 132, '2015-01-01 00:49:48.000000', 'consum', 0.0225, 'lps'),
	(625621, 132, '2015-01-01 00:49:49.000000', 'consum', 0.0220, 'lps'),
	(625622, 132, '2015-01-01 00:49:50.000000', 'consum', 0.0215, 'lps'),
	(625623, 132, '2015-01-01 00:49:51.000000', 'consum', 0.0288, 'lps'),
	(625624, 132, '2015-01-01 00:49:52.000000', 'consum', 0.0259, 'lps'),
	(625625, 132, '2015-01-01 00:49:53.000000', 'consum', 0.0223, 'lps'),
	(625626, 132, '2015-01-01 00:49:54.000000', 'consum', 0.0288, 'lps'),
	(625627, 132, '2015-01-01 00:49:55.000000', 'consum', 0.0239, 'lps'),
	(625628, 132, '2015-01-01 00:49:56.000000', 'consum', 0.0285, 'lps'),
	(625629, 132, '2015-01-01 00:49:57.000000', 'consum', 0.0255, 'lps'),
	(625630, 132, '2015-01-01 00:49:58.000000', 'consum', 0.0211, 'lps'),
	(625631, 132, '2015-01-01 00:49:59.000000', 'consum', 0.0241, 'lps'),
	(625632, 132, '2015-01-01 00:50:00.000000', 'consum', 0.0283, 'lps'),
	(625633, 132, '2015-01-01 00:50:01.000000', 'consum', 0.0240, 'lps'),
	(625634, 132, '2015-01-01 00:50:02.000000', 'consum', 0.0221, 'lps'),
	(625635, 132, '2015-01-01 00:50:03.000000', 'consum', 0.0256, 'lps'),
	(625636, 132, '2015-01-01 00:50:04.000000', 'consum', 0.0248, 'lps'),
	(625637, 132, '2015-01-01 00:50:05.000000', 'consum', 0.0261, 'lps'),
	(625638, 132, '2015-01-01 00:50:06.000000', 'consum', 0.0271, 'lps'),
	(625639, 132, '2015-01-01 00:50:07.000000', 'consum', 0.0280, 'lps'),
	(625640, 132, '2015-01-01 00:50:08.000000', 'consum', 0.0216, 'lps'),
	(625641, 132, '2015-01-01 00:50:09.000000', 'consum', 0.0273, 'lps'),
	(625642, 132, '2015-01-01 00:50:10.000000', 'consum', 0.0265, 'lps'),
	(625643, 132, '2015-01-01 00:50:11.000000', 'consum', 0.0217, 'lps'),
	(625644, 132, '2015-01-01 00:50:12.000000', 'consum', 0.0241, 'lps'),
	(625645, 132, '2015-01-01 00:50:13.000000', 'consum', 0.0264, 'lps'),
	(625646, 132, '2015-01-01 00:50:14.000000', 'consum', 0.0225, 'lps'),
	(625647, 132, '2015-01-01 00:50:15.000000', 'consum', 0.0287, 'lps'),
	(625648, 132, '2015-01-01 00:50:16.000000', 'consum', 0.0225, 'lps'),
	(625649, 132, '2015-01-01 00:50:17.000000', 'consum', 0.0217, 'lps'),
	(625650, 132, '2015-01-01 00:50:18.000000', 'consum', 0.0283, 'lps'),
	(625651, 132, '2015-01-01 00:50:19.000000', 'consum', 0.0230, 'lps'),
	(625652, 132, '2015-01-01 00:50:20.000000', 'consum', 0.0253, 'lps'),
	(625653, 132, '2015-01-01 00:50:21.000000', 'consum', 0.0287, 'lps'),
	(625654, 132, '2015-01-01 00:50:22.000000', 'consum', 0.0220, 'lps'),
	(625655, 132, '2015-01-01 00:50:23.000000', 'consum', 0.0273, 'lps'),
	(625656, 132, '2015-01-01 00:50:24.000000', 'consum', 0.0253, 'lps'),
	(625657, 132, '2015-01-01 00:50:25.000000', 'consum', 0.0234, 'lps'),
	(625658, 132, '2015-01-01 00:50:26.000000', 'consum', 0.0286, 'lps'),
	(625659, 132, '2015-01-01 00:50:27.000000', 'consum', 0.0276, 'lps'),
	(625660, 132, '2015-01-01 00:50:28.000000', 'consum', 0.0228, 'lps'),
	(625661, 132, '2015-01-01 00:50:29.000000', 'consum', 0.0267, 'lps'),
	(625662, 132, '2015-01-01 00:50:30.000000', 'consum', 0.0280, 'lps'),
	(625663, 132, '2015-01-01 00:50:31.000000', 'consum', 0.0228, 'lps'),
	(625664, 132, '2015-01-01 00:50:32.000000', 'consum', 0.0252, 'lps'),
	(625665, 132, '2015-01-01 00:50:33.000000', 'consum', 0.0284, 'lps'),
	(625666, 132, '2015-01-01 00:50:34.000000', 'consum', 0.0214, 'lps'),
	(625667, 132, '2015-01-01 00:50:35.000000', 'consum', 0.0249, 'lps'),
	(625668, 132, '2015-01-01 00:50:36.000000', 'consum', 0.0233, 'lps'),
	(625669, 132, '2015-01-01 00:50:37.000000', 'consum', 0.0210, 'lps'),
	(625670, 132, '2015-01-01 00:50:38.000000', 'consum', 0.0221, 'lps'),
	(625671, 132, '2015-01-01 00:50:39.000000', 'consum', 0.0265, 'lps'),
	(625672, 132, '2015-01-01 00:50:40.000000', 'consum', 0.0212, 'lps'),
	(625673, 132, '2015-01-01 00:50:41.000000', 'consum', 0.0215, 'lps'),
	(625674, 132, '2015-01-01 00:50:42.000000', 'consum', 0.0230, 'lps'),
	(625675, 132, '2015-01-01 00:50:43.000000', 'consum', 0.0216, 'lps'),
	(625676, 132, '2015-01-01 00:50:44.000000', 'consum', 0.0260, 'lps'),
	(625677, 132, '2015-01-01 00:50:45.000000', 'consum', 0.0281, 'lps'),
	(625678, 132, '2015-01-01 00:50:46.000000', 'consum', 0.0251, 'lps'),
	(625679, 132, '2015-01-01 00:50:47.000000', 'consum', 0.0287, 'lps'),
	(625680, 132, '2015-01-01 00:50:48.000000', 'consum', 0.0228, 'lps'),
	(625681, 132, '2015-01-01 00:50:49.000000', 'consum', 0.0233, 'lps'),
	(625682, 132, '2015-01-01 00:50:50.000000', 'consum', 0.0272, 'lps'),
	(625683, 132, '2015-01-01 00:50:51.000000', 'consum', 0.0290, 'lps'),
	(625684, 132, '2015-01-01 00:50:52.000000', 'consum', 0.0263, 'lps'),
	(625685, 132, '2015-01-01 00:50:53.000000', 'consum', 0.0233, 'lps'),
	(625686, 132, '2015-01-01 00:50:54.000000', 'consum', 0.0250, 'lps'),
	(625687, 132, '2015-01-01 00:50:55.000000', 'consum', 0.0260, 'lps'),
	(625688, 132, '2015-01-01 00:50:56.000000', 'consum', 0.0260, 'lps'),
	(625689, 132, '2015-01-01 00:50:57.000000', 'consum', 0.0228, 'lps'),
	(625690, 132, '2015-01-01 00:50:58.000000', 'consum', 0.0233, 'lps'),
	(625691, 132, '2015-01-01 00:50:59.000000', 'consum', 0.0272, 'lps'),
	(625692, 132, '2015-01-01 00:51:00.000000', 'consum', 0.0289, 'lps'),
	(625693, 132, '2015-01-01 00:51:01.000000', 'consum', 0.0256, 'lps'),
	(625694, 132, '2015-01-01 00:51:02.000000', 'consum', 0.0284, 'lps'),
	(625695, 132, '2015-01-01 00:51:03.000000', 'consum', 0.0283, 'lps'),
	(625696, 132, '2015-01-01 00:51:04.000000', 'consum', 0.0273, 'lps'),
	(625697, 132, '2015-01-01 00:51:05.000000', 'consum', 0.0225, 'lps'),
	(625698, 132, '2015-01-01 00:51:06.000000', 'consum', 0.0257, 'lps'),
	(625699, 132, '2015-01-01 00:51:07.000000', 'consum', 0.0241, 'lps'),
	(625700, 132, '2015-01-01 00:51:08.000000', 'consum', 0.0222, 'lps'),
	(625701, 132, '2015-01-01 00:51:09.000000', 'consum', 0.0260, 'lps'),
	(625702, 132, '2015-01-01 00:51:10.000000', 'consum', 0.0262, 'lps'),
	(625703, 132, '2015-01-01 00:51:11.000000', 'consum', 0.0241, 'lps'),
	(625704, 132, '2015-01-01 00:51:12.000000', 'consum', 0.0290, 'lps'),
	(625705, 132, '2015-01-01 00:51:13.000000', 'consum', 0.0275, 'lps'),
	(625706, 132, '2015-01-01 00:51:14.000000', 'consum', 0.0216, 'lps'),
	(625707, 132, '2015-01-01 00:51:15.000000', 'consum', 0.0286, 'lps'),
	(625708, 132, '2015-01-01 00:51:16.000000', 'consum', 0.0249, 'lps'),
	(625709, 132, '2015-01-01 00:51:17.000000', 'consum', 0.0258, 'lps'),
	(625710, 132, '2015-01-01 00:51:18.000000', 'consum', 0.0251, 'lps'),
	(625711, 132, '2015-01-01 00:51:19.000000', 'consum', 0.0273, 'lps'),
	(625712, 132, '2015-01-01 00:51:20.000000', 'consum', 0.0242, 'lps'),
	(625713, 132, '2015-01-01 00:51:21.000000', 'consum', 0.0261, 'lps'),
	(625714, 132, '2015-01-01 00:51:22.000000', 'consum', 0.0289, 'lps'),
	(625715, 132, '2015-01-01 00:51:23.000000', 'consum', 0.0289, 'lps'),
	(625716, 132, '2015-01-01 00:51:24.000000', 'consum', 0.0287, 'lps'),
	(625717, 132, '2015-01-01 00:51:25.000000', 'consum', 0.0278, 'lps'),
	(625718, 132, '2015-01-01 00:51:26.000000', 'consum', 0.0241, 'lps'),
	(625719, 132, '2015-01-01 00:51:27.000000', 'consum', 0.0240, 'lps'),
	(625720, 132, '2015-01-01 00:51:28.000000', 'consum', 0.0270, 'lps'),
	(625721, 132, '2015-01-01 00:51:29.000000', 'consum', 0.0255, 'lps'),
	(625722, 132, '2015-01-01 00:51:30.000000', 'consum', 0.0258, 'lps'),
	(625723, 132, '2015-01-01 00:51:31.000000', 'consum', 0.0235, 'lps'),
	(625724, 132, '2015-01-01 00:51:32.000000', 'consum', 0.0270, 'lps'),
	(625725, 132, '2015-01-01 00:51:33.000000', 'consum', 0.0276, 'lps'),
	(625726, 132, '2015-01-01 00:51:34.000000', 'consum', 0.0278, 'lps'),
	(625727, 132, '2015-01-01 00:51:35.000000', 'consum', 0.0273, 'lps'),
	(625728, 132, '2015-01-01 00:51:36.000000', 'consum', 0.0239, 'lps'),
	(625729, 132, '2015-01-01 00:51:37.000000', 'consum', 0.0248, 'lps'),
	(625730, 132, '2015-01-01 00:51:38.000000', 'consum', 0.0234, 'lps'),
	(625731, 132, '2015-01-01 00:51:39.000000', 'consum', 0.0213, 'lps'),
	(625732, 132, '2015-01-01 00:51:40.000000', 'consum', 0.0238, 'lps'),
	(625733, 132, '2015-01-01 00:51:41.000000', 'consum', 0.0259, 'lps'),
	(625734, 132, '2015-01-01 00:51:42.000000', 'consum', 0.0211, 'lps'),
	(625735, 132, '2015-01-01 00:51:43.000000', 'consum', 0.0229, 'lps'),
	(625736, 132, '2015-01-01 00:51:44.000000', 'consum', 0.0222, 'lps'),
	(625737, 132, '2015-01-01 00:51:45.000000', 'consum', 0.0212, 'lps'),
	(625738, 132, '2015-01-01 00:51:46.000000', 'consum', 0.0267, 'lps'),
	(625739, 132, '2015-01-01 00:51:47.000000', 'consum', 0.0248, 'lps'),
	(625740, 132, '2015-01-01 00:51:48.000000', 'consum', 0.0228, 'lps'),
	(625741, 132, '2015-01-01 00:51:49.000000', 'consum', 0.0266, 'lps'),
	(625742, 132, '2015-01-01 00:51:50.000000', 'consum', 0.0276, 'lps'),
	(625743, 132, '2015-01-01 00:51:51.000000', 'consum', 0.0290, 'lps'),
	(625744, 132, '2015-01-01 00:51:52.000000', 'consum', 0.0250, 'lps'),
	(625745, 132, '2015-01-01 00:51:53.000000', 'consum', 0.0253, 'lps'),
	(625746, 132, '2015-01-01 00:51:54.000000', 'consum', 0.0223, 'lps'),
	(625747, 132, '2015-01-01 00:51:55.000000', 'consum', 0.0230, 'lps'),
	(625748, 132, '2015-01-01 00:51:56.000000', 'consum', 0.0268, 'lps'),
	(625749, 132, '2015-01-01 00:51:57.000000', 'consum', 0.0281, 'lps'),
	(625750, 132, '2015-01-01 00:51:58.000000', 'consum', 0.0228, 'lps'),
	(625751, 132, '2015-01-01 00:51:59.000000', 'consum', 0.0251, 'lps'),
	(625752, 132, '2015-01-01 00:52:00.000000', 'consum', 0.0281, 'lps'),
	(625753, 132, '2015-01-01 00:52:01.000000', 'consum', 0.0278, 'lps'),
	(625754, 132, '2015-01-01 00:52:02.000000', 'consum', 0.0256, 'lps'),
	(625755, 132, '2015-01-01 00:52:03.000000', 'consum', 0.0239, 'lps'),
	(625756, 132, '2015-01-01 00:52:04.000000', 'consum', 0.0218, 'lps'),
	(625757, 132, '2015-01-01 00:52:05.000000', 'consum', 0.0242, 'lps'),
	(625758, 132, '2015-01-01 00:52:06.000000', 'consum', 0.0267, 'lps'),
	(625759, 132, '2015-01-01 00:52:07.000000', 'consum', 0.0239, 'lps'),
	(625760, 132, '2015-01-01 00:52:08.000000', 'consum', 0.0265, 'lps'),
	(625761, 132, '2015-01-01 00:52:09.000000', 'consum', 0.0234, 'lps'),
	(625762, 132, '2015-01-01 00:52:10.000000', 'consum', 0.0249, 'lps'),
	(625763, 132, '2015-01-01 00:52:11.000000', 'consum', 0.0251, 'lps'),
	(625764, 132, '2015-01-01 00:52:12.000000', 'consum', 0.0217, 'lps'),
	(625765, 132, '2015-01-01 00:52:13.000000', 'consum', 0.0286, 'lps'),
	(625766, 132, '2015-01-01 00:52:14.000000', 'consum', 0.0247, 'lps'),
	(625767, 132, '2015-01-01 00:52:15.000000', 'consum', 0.0246, 'lps'),
	(625768, 132, '2015-01-01 00:52:16.000000', 'consum', 0.0278, 'lps'),
	(625769, 132, '2015-01-01 00:52:17.000000', 'consum', 0.0283, 'lps'),
	(625770, 132, '2015-01-01 00:52:18.000000', 'consum', 0.0290, 'lps'),
	(625771, 132, '2015-01-01 00:52:19.000000', 'consum', 0.0229, 'lps'),
	(625772, 132, '2015-01-01 00:52:20.000000', 'consum', 0.0229, 'lps'),
	(625773, 132, '2015-01-01 00:52:21.000000', 'consum', 0.0249, 'lps'),
	(625774, 132, '2015-01-01 00:52:22.000000', 'consum', 0.0268, 'lps'),
	(625775, 132, '2015-01-01 00:52:23.000000', 'consum', 0.0219, 'lps'),
	(625776, 132, '2015-01-01 00:52:24.000000', 'consum', 0.0245, 'lps'),
	(625777, 132, '2015-01-01 00:52:25.000000', 'consum', 0.0276, 'lps'),
	(625778, 132, '2015-01-01 00:52:26.000000', 'consum', 0.0273, 'lps'),
	(625779, 132, '2015-01-01 00:52:27.000000', 'consum', 0.0248, 'lps'),
	(625780, 132, '2015-01-01 00:52:28.000000', 'consum', 0.0213, 'lps'),
	(625781, 132, '2015-01-01 00:52:29.000000', 'consum', 0.0272, 'lps'),
	(625782, 132, '2015-01-01 00:52:30.000000', 'consum', 0.0267, 'lps'),
	(625783, 132, '2015-01-01 00:52:31.000000', 'consum', 0.0228, 'lps'),
	(625784, 132, '2015-01-01 00:52:32.000000', 'consum', 0.0210, 'lps'),
	(625785, 132, '2015-01-01 00:52:33.000000', 'consum', 0.0238, 'lps'),
	(625786, 132, '2015-01-01 00:52:34.000000', 'consum', 0.0268, 'lps'),
	(625787, 132, '2015-01-01 00:52:35.000000', 'consum', 0.0258, 'lps'),
	(625788, 132, '2015-01-01 00:52:36.000000', 'consum', 0.0273, 'lps'),
	(625789, 132, '2015-01-01 00:52:37.000000', 'consum', 0.0221, 'lps'),
	(625790, 132, '2015-01-01 00:52:38.000000', 'consum', 0.0239, 'lps'),
	(625791, 132, '2015-01-01 00:52:39.000000', 'consum', 0.0239, 'lps'),
	(625792, 132, '2015-01-01 00:52:40.000000', 'consum', 0.0271, 'lps'),
	(625793, 132, '2015-01-01 00:52:41.000000', 'consum', 0.0265, 'lps'),
	(625794, 132, '2015-01-01 00:52:42.000000', 'consum', 0.0221, 'lps'),
	(625795, 132, '2015-01-01 00:52:43.000000', 'consum', 0.0264, 'lps'),
	(625796, 132, '2015-01-01 00:52:44.000000', 'consum', 0.0286, 'lps'),
	(625797, 132, '2015-01-01 00:52:45.000000', 'consum', 0.0266, 'lps'),
	(625798, 132, '2015-01-01 00:52:46.000000', 'consum', 0.0260, 'lps'),
	(625799, 132, '2015-01-01 00:52:47.000000', 'consum', 0.0215, 'lps'),
	(625800, 132, '2015-01-01 00:52:48.000000', 'consum', 0.0244, 'lps'),
	(625801, 132, '2015-01-01 00:52:49.000000', 'consum', 0.0288, 'lps'),
	(625802, 132, '2015-01-01 00:52:50.000000', 'consum', 0.0253, 'lps'),
	(625803, 132, '2015-01-01 00:52:51.000000', 'consum', 0.0275, 'lps'),
	(625804, 132, '2015-01-01 00:52:52.000000', 'consum', 0.0244, 'lps'),
	(625805, 132, '2015-01-01 00:52:53.000000', 'consum', 0.0266, 'lps'),
	(625806, 132, '2015-01-01 00:52:54.000000', 'consum', 0.0226, 'lps'),
	(625807, 132, '2015-01-01 00:52:55.000000', 'consum', 0.0285, 'lps'),
	(625808, 132, '2015-01-01 00:52:56.000000', 'consum', 0.0214, 'lps'),
	(625809, 132, '2015-01-01 00:52:57.000000', 'consum', 0.0246, 'lps'),
	(625810, 132, '2015-01-01 00:52:58.000000', 'consum', 0.0218, 'lps'),
	(625811, 132, '2015-01-01 00:52:59.000000', 'consum', 0.0223, 'lps'),
	(625812, 132, '2015-01-01 00:53:00.000000', 'consum', 0.0251, 'lps'),
	(625813, 132, '2015-01-01 00:53:01.000000', 'consum', 0.0217, 'lps'),
	(625814, 132, '2015-01-01 00:53:02.000000', 'consum', 0.0283, 'lps'),
	(625815, 132, '2015-01-01 00:53:03.000000', 'consum', 0.0231, 'lps'),
	(625816, 132, '2015-01-01 00:53:04.000000', 'consum', 0.0259, 'lps'),
	(625817, 132, '2015-01-01 00:53:05.000000', 'consum', 0.0232, 'lps'),
	(625818, 132, '2015-01-01 00:53:06.000000', 'consum', 0.0253, 'lps'),
	(625819, 132, '2015-01-01 00:53:07.000000', 'consum', 0.0279, 'lps'),
	(625820, 132, '2015-01-01 00:53:08.000000', 'consum', 0.0266, 'lps'),
	(625821, 132, '2015-01-01 00:53:09.000000', 'consum', 0.0283, 'lps'),
	(625822, 132, '2015-01-01 00:53:10.000000', 'consum', 0.0244, 'lps'),
	(625823, 132, '2015-01-01 00:53:11.000000', 'consum', 0.0244, 'lps'),
	(625824, 132, '2015-01-01 00:53:12.000000', 'consum', 0.0279, 'lps'),
	(625825, 132, '2015-01-01 00:53:13.000000', 'consum', 0.0290, 'lps'),
	(625826, 132, '2015-01-01 00:53:14.000000', 'consum', 0.0241, 'lps'),
	(625827, 132, '2015-01-01 00:53:15.000000', 'consum', 0.0287, 'lps'),
	(625828, 132, '2015-01-01 00:53:16.000000', 'consum', 0.0262, 'lps'),
	(625829, 132, '2015-01-01 00:53:17.000000', 'consum', 0.0240, 'lps'),
	(625830, 132, '2015-01-01 00:53:18.000000', 'consum', 0.0286, 'lps'),
	(625831, 132, '2015-01-01 00:53:19.000000', 'consum', 0.0254, 'lps'),
	(625832, 132, '2015-01-01 00:53:20.000000', 'consum', 0.0286, 'lps'),
	(625833, 132, '2015-01-01 00:53:21.000000', 'consum', 0.0215, 'lps'),
	(625834, 132, '2015-01-01 00:53:22.000000', 'consum', 0.0251, 'lps'),
	(625835, 132, '2015-01-01 00:53:23.000000', 'consum', 0.0238, 'lps'),
	(625836, 132, '2015-01-01 00:53:24.000000', 'consum', 0.0226, 'lps'),
	(625837, 132, '2015-01-01 00:53:25.000000', 'consum', 0.0290, 'lps'),
	(625838, 132, '2015-01-01 00:53:26.000000', 'consum', 0.0238, 'lps'),
	(625839, 132, '2015-01-01 00:53:27.000000', 'consum', 0.0274, 'lps'),
	(625840, 132, '2015-01-01 00:53:28.000000', 'consum', 0.0283, 'lps'),
	(625841, 132, '2015-01-01 00:53:29.000000', 'consum', 0.0224, 'lps'),
	(625842, 132, '2015-01-01 00:53:30.000000', 'consum', 0.0220, 'lps'),
	(625843, 132, '2015-01-01 00:53:31.000000', 'consum', 0.0220, 'lps'),
	(625844, 132, '2015-01-01 00:53:32.000000', 'consum', 0.0228, 'lps'),
	(625845, 132, '2015-01-01 00:53:33.000000', 'consum', 0.0274, 'lps'),
	(625846, 132, '2015-01-01 00:53:34.000000', 'consum', 0.0232, 'lps'),
	(625847, 132, '2015-01-01 00:53:35.000000', 'consum', 0.0210, 'lps'),
	(625848, 132, '2015-01-01 00:53:36.000000', 'consum', 0.0224, 'lps'),
	(625849, 132, '2015-01-01 00:53:37.000000', 'consum', 0.0283, 'lps'),
	(625850, 132, '2015-01-01 00:53:38.000000', 'consum', 0.0288, 'lps'),
	(625851, 132, '2015-01-01 00:53:39.000000', 'consum', 0.0221, 'lps'),
	(625852, 132, '2015-01-01 00:53:40.000000', 'consum', 0.0276, 'lps'),
	(625853, 132, '2015-01-01 00:53:41.000000', 'consum', 0.0261, 'lps'),
	(625854, 132, '2015-01-01 00:53:42.000000', 'consum', 0.0269, 'lps'),
	(625855, 132, '2015-01-01 00:53:43.000000', 'consum', 0.0274, 'lps'),
	(625856, 132, '2015-01-01 00:53:44.000000', 'consum', 0.0269, 'lps'),
	(625857, 132, '2015-01-01 00:53:45.000000', 'consum', 0.0235, 'lps'),
	(625858, 132, '2015-01-01 00:53:46.000000', 'consum', 0.0237, 'lps'),
	(625859, 132, '2015-01-01 00:53:47.000000', 'consum', 0.0274, 'lps'),
	(625860, 132, '2015-01-01 00:53:48.000000', 'consum', 0.0285, 'lps'),
	(625861, 132, '2015-01-01 00:53:49.000000', 'consum', 0.0230, 'lps'),
	(625862, 132, '2015-01-01 00:53:50.000000', 'consum', 0.0251, 'lps'),
	(625863, 132, '2015-01-01 00:53:51.000000', 'consum', 0.0272, 'lps'),
	(625864, 132, '2015-01-01 00:53:52.000000', 'consum', 0.0236, 'lps'),
	(625865, 132, '2015-01-01 00:53:53.000000', 'consum', 0.0238, 'lps'),
	(625866, 132, '2015-01-01 00:53:54.000000', 'consum', 0.0270, 'lps'),
	(625867, 132, '2015-01-01 00:53:55.000000', 'consum', 0.0264, 'lps'),
	(625868, 132, '2015-01-01 00:53:56.000000', 'consum', 0.0222, 'lps'),
	(625869, 132, '2015-01-01 00:53:57.000000', 'consum', 0.0270, 'lps'),
	(625870, 132, '2015-01-01 00:53:58.000000', 'consum', 0.0231, 'lps'),
	(625871, 132, '2015-01-01 00:53:59.000000', 'consum', 0.0216, 'lps'),
	(625872, 132, '2015-01-01 00:54:00.000000', 'consum', 0.0258, 'lps'),
	(625873, 132, '2015-01-01 00:54:01.000000', 'consum', 0.0272, 'lps'),
	(625874, 132, '2015-01-01 00:54:02.000000', 'consum', 0.0216, 'lps'),
	(625875, 132, '2015-01-01 00:54:03.000000', 'consum', 0.0214, 'lps'),
	(625876, 132, '2015-01-01 00:54:04.000000', 'consum', 0.0215, 'lps'),
	(625877, 132, '2015-01-01 00:54:05.000000', 'consum', 0.0222, 'lps'),
	(625878, 132, '2015-01-01 00:54:06.000000', 'consum', 0.0254, 'lps'),
	(625879, 132, '2015-01-01 00:54:07.000000', 'consum', 0.0235, 'lps'),
	(625880, 132, '2015-01-01 00:54:08.000000', 'consum', 0.0283, 'lps'),
	(625881, 132, '2015-01-01 00:54:09.000000', 'consum', 0.0258, 'lps'),
	(625882, 132, '2015-01-01 00:54:10.000000', 'consum', 0.0230, 'lps'),
	(625883, 132, '2015-01-01 00:54:11.000000', 'consum', 0.0249, 'lps'),
	(625884, 132, '2015-01-01 00:54:12.000000', 'consum', 0.0263, 'lps'),
	(625885, 132, '2015-01-01 00:54:13.000000', 'consum', 0.0279, 'lps'),
	(625886, 132, '2015-01-01 00:54:14.000000', 'consum', 0.0235, 'lps'),
	(625887, 132, '2015-01-01 00:54:15.000000', 'consum', 0.0290, 'lps'),
	(625888, 132, '2015-01-01 00:54:16.000000', 'consum', 0.0213, 'lps'),
	(625889, 132, '2015-01-01 00:54:17.000000', 'consum', 0.0227, 'lps'),
	(625890, 132, '2015-01-01 00:54:18.000000', 'consum', 0.0289, 'lps'),
	(625891, 132, '2015-01-01 00:54:19.000000', 'consum', 0.0228, 'lps'),
	(625892, 132, '2015-01-01 00:54:20.000000', 'consum', 0.0224, 'lps'),
	(625893, 132, '2015-01-01 00:54:21.000000', 'consum', 0.0228, 'lps'),
	(625894, 132, '2015-01-01 00:54:22.000000', 'consum', 0.0259, 'lps'),
	(625895, 132, '2015-01-01 00:54:23.000000', 'consum', 0.0237, 'lps'),
	(625896, 132, '2015-01-01 00:54:24.000000', 'consum', 0.0281, 'lps'),
	(625897, 132, '2015-01-01 00:54:25.000000', 'consum', 0.0243, 'lps'),
	(625898, 132, '2015-01-01 00:54:26.000000', 'consum', 0.0243, 'lps'),
	(625899, 132, '2015-01-01 00:54:27.000000', 'consum', 0.0276, 'lps'),
	(625900, 132, '2015-01-01 00:54:28.000000', 'consum', 0.0280, 'lps'),
	(625901, 132, '2015-01-01 00:54:29.000000', 'consum', 0.0281, 'lps'),
	(625902, 132, '2015-01-01 00:54:30.000000', 'consum', 0.0273, 'lps'),
	(625903, 132, '2015-01-01 00:54:31.000000', 'consum', 0.0231, 'lps'),
	(625904, 132, '2015-01-01 00:54:32.000000', 'consum', 0.0289, 'lps'),
	(625905, 132, '2015-01-01 00:54:33.000000', 'consum', 0.0221, 'lps'),
	(625906, 132, '2015-01-01 00:54:34.000000', 'consum', 0.0270, 'lps'),
	(625907, 132, '2015-01-01 00:54:35.000000', 'consum', 0.0234, 'lps'),
	(625908, 132, '2015-01-01 00:54:36.000000', 'consum', 0.0234, 'lps'),
	(625909, 132, '2015-01-01 00:54:37.000000', 'consum', 0.0257, 'lps'),
	(625910, 132, '2015-01-01 00:54:38.000000', 'consum', 0.0212, 'lps'),
	(625911, 132, '2015-01-01 00:54:39.000000', 'consum', 0.0241, 'lps'),
	(625912, 132, '2015-01-01 00:54:40.000000', 'consum', 0.0279, 'lps'),
	(625913, 132, '2015-01-01 00:54:41.000000', 'consum', 0.0218, 'lps'),
	(625914, 132, '2015-01-01 00:54:42.000000', 'consum', 0.0289, 'lps'),
	(625915, 132, '2015-01-01 00:54:43.000000', 'consum', 0.0257, 'lps'),
	(625916, 132, '2015-01-01 00:54:44.000000', 'consum', 0.0289, 'lps'),
	(625917, 132, '2015-01-01 00:54:45.000000', 'consum', 0.0223, 'lps'),
	(625918, 132, '2015-01-01 00:54:46.000000', 'consum', 0.0280, 'lps'),
	(625919, 132, '2015-01-01 00:54:47.000000', 'consum', 0.0277, 'lps'),
	(625920, 132, '2015-01-01 00:54:48.000000', 'consum', 0.0257, 'lps'),
	(625921, 132, '2015-01-01 00:54:49.000000', 'consum', 0.0244, 'lps'),
	(625922, 132, '2015-01-01 00:54:50.000000', 'consum', 0.0239, 'lps'),
	(625923, 132, '2015-01-01 00:54:51.000000', 'consum', 0.0252, 'lps'),
	(625924, 132, '2015-01-01 00:54:52.000000', 'consum', 0.0253, 'lps'),
	(625925, 132, '2015-01-01 00:54:53.000000', 'consum', 0.0218, 'lps'),
	(625926, 132, '2015-01-01 00:54:54.000000', 'consum', 0.0286, 'lps'),
	(625927, 132, '2015-01-01 00:54:55.000000', 'consum', 0.0240, 'lps'),
	(625928, 132, '2015-01-01 00:54:56.000000', 'consum', 0.0215, 'lps'),
	(625929, 132, '2015-01-01 00:54:57.000000', 'consum', 0.0226, 'lps'),
	(625930, 132, '2015-01-01 00:54:58.000000', 'consum', 0.0276, 'lps'),
	(625931, 132, '2015-01-01 00:54:59.000000', 'consum', 0.0247, 'lps'),
	(625932, 132, '2015-01-01 00:55:00.000000', 'consum', 0.0281, 'lps'),
	(625933, 132, '2015-01-01 00:55:01.000000', 'consum', 0.0290, 'lps'),
	(625934, 132, '2015-01-01 00:55:02.000000', 'consum', 0.0237, 'lps'),
	(625935, 132, '2015-01-01 00:55:03.000000', 'consum', 0.0266, 'lps'),
	(625936, 132, '2015-01-01 00:55:04.000000', 'consum', 0.0248, 'lps'),
	(625937, 132, '2015-01-01 00:55:05.000000', 'consum', 0.0234, 'lps'),
	(625938, 132, '2015-01-01 00:55:06.000000', 'consum', 0.0218, 'lps'),
	(625939, 132, '2015-01-01 00:55:07.000000', 'consum', 0.0256, 'lps'),
	(625940, 132, '2015-01-01 00:55:08.000000', 'consum', 0.0258, 'lps'),
	(625941, 132, '2015-01-01 00:55:09.000000', 'consum', 0.0229, 'lps'),
	(625942, 132, '2015-01-01 00:55:10.000000', 'consum', 0.0242, 'lps'),
	(625943, 132, '2015-01-01 00:55:11.000000', 'consum', 0.0235, 'lps'),
	(625944, 132, '2015-01-01 00:55:12.000000', 'consum', 0.0240, 'lps'),
	(625945, 132, '2015-01-01 00:55:13.000000', 'consum', 0.0286, 'lps'),
	(625946, 132, '2015-01-01 00:55:14.000000', 'consum', 0.0255, 'lps'),
	(625947, 132, '2015-01-01 00:55:15.000000', 'consum', 0.0290, 'lps'),
	(625948, 132, '2015-01-01 00:55:16.000000', 'consum', 0.0233, 'lps'),
	(625949, 132, '2015-01-01 00:55:17.000000', 'consum', 0.0247, 'lps'),
	(625950, 132, '2015-01-01 00:55:18.000000', 'consum', 0.0245, 'lps'),
	(625951, 132, '2015-01-01 00:55:19.000000', 'consum', 0.0277, 'lps'),
	(625952, 132, '2015-01-01 00:55:20.000000', 'consum', 0.0276, 'lps'),
	(625953, 132, '2015-01-01 00:55:21.000000', 'consum', 0.0259, 'lps'),
	(625954, 132, '2015-01-01 00:55:22.000000', 'consum', 0.0256, 'lps'),
	(625955, 132, '2015-01-01 00:55:23.000000', 'consum', 0.0212, 'lps'),
	(625956, 132, '2015-01-01 00:55:24.000000', 'consum', 0.0246, 'lps'),
	(625957, 132, '2015-01-01 00:55:25.000000', 'consum', 0.0222, 'lps'),
	(625958, 132, '2015-01-01 00:55:26.000000', 'consum', 0.0245, 'lps'),
	(625959, 132, '2015-01-01 00:55:27.000000', 'consum', 0.0269, 'lps'),
	(625960, 132, '2015-01-01 00:55:28.000000', 'consum', 0.0236, 'lps'),
	(625961, 132, '2015-01-01 00:55:29.000000', 'consum', 0.0246, 'lps'),
	(625962, 132, '2015-01-01 00:55:30.000000', 'consum', 0.0233, 'lps'),
	(625963, 132, '2015-01-01 00:55:31.000000', 'consum', 0.0215, 'lps'),
	(625964, 132, '2015-01-01 00:55:32.000000', 'consum', 0.0250, 'lps'),
	(625965, 132, '2015-01-01 00:55:33.000000', 'consum', 0.0232, 'lps'),
	(625966, 132, '2015-01-01 00:55:34.000000', 'consum', 0.0282, 'lps'),
	(625967, 132, '2015-01-01 00:55:35.000000', 'consum', 0.0261, 'lps'),
	(625968, 132, '2015-01-01 00:55:36.000000', 'consum', 0.0249, 'lps'),
	(625969, 132, '2015-01-01 00:55:37.000000', 'consum', 0.0252, 'lps'),
	(625970, 132, '2015-01-01 00:55:38.000000', 'consum', 0.0222, 'lps'),
	(625971, 132, '2015-01-01 00:55:39.000000', 'consum', 0.0225, 'lps'),
	(625972, 132, '2015-01-01 00:55:40.000000', 'consum', 0.0252, 'lps'),
	(625973, 132, '2015-01-01 00:55:41.000000', 'consum', 0.0214, 'lps'),
	(625974, 132, '2015-01-01 00:55:42.000000', 'consum', 0.0267, 'lps'),
	(625975, 132, '2015-01-01 00:55:43.000000', 'consum', 0.0237, 'lps'),
	(625976, 132, '2015-01-01 00:55:44.000000', 'consum', 0.0259, 'lps'),
	(625977, 132, '2015-01-01 00:55:45.000000', 'consum', 0.0210, 'lps'),
	(625978, 132, '2015-01-01 00:55:46.000000', 'consum', 0.0225, 'lps'),
	(625979, 132, '2015-01-01 00:55:47.000000', 'consum', 0.0287, 'lps'),
	(625980, 132, '2015-01-01 00:55:48.000000', 'consum', 0.0224, 'lps'),
	(625981, 132, '2015-01-01 00:55:49.000000', 'consum', 0.0215, 'lps'),
	(625982, 132, '2015-01-01 00:55:50.000000', 'consum', 0.0272, 'lps'),
	(625983, 132, '2015-01-01 00:55:51.000000', 'consum', 0.0265, 'lps'),
	(625984, 132, '2015-01-01 00:55:52.000000', 'consum', 0.0215, 'lps'),
	(625985, 132, '2015-01-01 00:55:53.000000', 'consum', 0.0235, 'lps'),
	(625986, 132, '2015-01-01 00:55:54.000000', 'consum', 0.0240, 'lps'),
	(625987, 132, '2015-01-01 00:55:55.000000', 'consum', 0.0287, 'lps'),
	(625988, 132, '2015-01-01 00:55:56.000000', 'consum', 0.0260, 'lps'),
	(625989, 132, '2015-01-01 00:55:57.000000', 'consum', 0.0230, 'lps'),
	(625990, 132, '2015-01-01 00:55:58.000000', 'consum', 0.0243, 'lps'),
	(625991, 132, '2015-01-01 00:55:59.000000', 'consum', 0.0233, 'lps'),
	(625992, 132, '2015-01-01 00:56:00.000000', 'consum', 0.0229, 'lps'),
	(625993, 132, '2015-01-01 00:56:01.000000', 'consum', 0.0234, 'lps'),
	(625994, 132, '2015-01-01 00:56:02.000000', 'consum', 0.0276, 'lps'),
	(625995, 132, '2015-01-01 00:56:03.000000', 'consum', 0.0224, 'lps'),
	(625996, 132, '2015-01-01 00:56:04.000000', 'consum', 0.0244, 'lps'),
	(625997, 132, '2015-01-01 00:56:05.000000', 'consum', 0.0259, 'lps'),
	(625998, 132, '2015-01-01 00:56:06.000000', 'consum', 0.0273, 'lps'),
	(625999, 132, '2015-01-01 00:56:07.000000', 'consum', 0.0217, 'lps'),
	(626000, 132, '2015-01-01 00:56:08.000000', 'consum', 0.0218, 'lps'),
	(626001, 132, '2015-01-01 00:56:09.000000', 'consum', 0.0231, 'lps'),
	(626002, 132, '2015-01-01 00:56:10.000000', 'consum', 0.0288, 'lps'),
	(626003, 132, '2015-01-01 00:56:11.000000', 'consum', 0.0217, 'lps'),
	(626004, 132, '2015-01-01 00:56:12.000000', 'consum', 0.0252, 'lps'),
	(626005, 132, '2015-01-01 00:56:13.000000', 'consum', 0.0237, 'lps'),
	(626006, 132, '2015-01-01 00:56:14.000000', 'consum', 0.0222, 'lps'),
	(626007, 132, '2015-01-01 00:56:15.000000', 'consum', 0.0271, 'lps'),
	(626008, 132, '2015-01-01 00:56:16.000000', 'consum', 0.0235, 'lps'),
	(626009, 132, '2015-01-01 00:56:17.000000', 'consum', 0.0233, 'lps'),
	(626010, 132, '2015-01-01 00:56:18.000000', 'consum', 0.0251, 'lps'),
	(626011, 132, '2015-01-01 00:56:19.000000', 'consum', 0.0264, 'lps'),
	(626012, 132, '2015-01-01 00:56:20.000000', 'consum', 0.0278, 'lps'),
	(626013, 132, '2015-01-01 00:56:21.000000', 'consum', 0.0225, 'lps'),
	(626014, 132, '2015-01-01 00:56:22.000000', 'consum', 0.0242, 'lps'),
	(626015, 132, '2015-01-01 00:56:23.000000', 'consum', 0.0248, 'lps'),
	(626016, 132, '2015-01-01 00:56:24.000000', 'consum', 0.0222, 'lps'),
	(626017, 132, '2015-01-01 00:56:25.000000', 'consum', 0.0237, 'lps'),
	(626018, 132, '2015-01-01 00:56:26.000000', 'consum', 0.0230, 'lps'),
	(626019, 132, '2015-01-01 00:56:27.000000', 'consum', 0.0227, 'lps'),
	(626020, 132, '2015-01-01 00:56:28.000000', 'consum', 0.0237, 'lps'),
	(626021, 132, '2015-01-01 00:56:29.000000', 'consum', 0.0214, 'lps'),
	(626022, 132, '2015-01-01 00:56:30.000000', 'consum', 0.0230, 'lps'),
	(626023, 132, '2015-01-01 00:56:31.000000', 'consum', 0.0219, 'lps'),
	(626024, 132, '2015-01-01 00:56:32.000000', 'consum', 0.0275, 'lps'),
	(626025, 132, '2015-01-01 00:56:33.000000', 'consum', 0.0264, 'lps'),
	(626026, 132, '2015-01-01 00:56:34.000000', 'consum', 0.0287, 'lps'),
	(626027, 132, '2015-01-01 00:56:35.000000', 'consum', 0.0273, 'lps'),
	(626028, 132, '2015-01-01 00:56:36.000000', 'consum', 0.0214, 'lps'),
	(626029, 132, '2015-01-01 00:56:37.000000', 'consum', 0.0284, 'lps'),
	(626030, 132, '2015-01-01 00:56:38.000000', 'consum', 0.0246, 'lps'),
	(626031, 132, '2015-01-01 00:56:39.000000', 'consum', 0.0246, 'lps'),
	(626032, 132, '2015-01-01 00:56:40.000000', 'consum', 0.0284, 'lps'),
	(626033, 132, '2015-01-01 00:56:41.000000', 'consum', 0.0231, 'lps'),
	(626034, 132, '2015-01-01 00:56:42.000000', 'consum', 0.0255, 'lps'),
	(626035, 132, '2015-01-01 00:56:43.000000', 'consum', 0.0290, 'lps'),
	(626036, 132, '2015-01-01 00:56:44.000000', 'consum', 0.0233, 'lps'),
	(626037, 132, '2015-01-01 00:56:45.000000', 'consum', 0.0248, 'lps'),
	(626038, 132, '2015-01-01 00:56:46.000000', 'consum', 0.0252, 'lps'),
	(626039, 132, '2015-01-01 00:56:47.000000', 'consum', 0.0224, 'lps'),
	(626040, 132, '2015-01-01 00:56:48.000000', 'consum', 0.0235, 'lps'),
	(626041, 132, '2015-01-01 00:56:49.000000', 'consum', 0.0211, 'lps'),
	(626042, 132, '2015-01-01 00:56:50.000000', 'consum', 0.0223, 'lps'),
	(626043, 132, '2015-01-01 00:56:51.000000', 'consum', 0.0273, 'lps'),
	(626044, 132, '2015-01-01 00:56:52.000000', 'consum', 0.0242, 'lps'),
	(626045, 132, '2015-01-01 00:56:53.000000', 'consum', 0.0265, 'lps'),
	(626046, 132, '2015-01-01 00:56:54.000000', 'consum', 0.0226, 'lps'),
	(626047, 132, '2015-01-01 00:56:55.000000', 'consum', 0.0289, 'lps'),
	(626048, 132, '2015-01-01 00:56:56.000000', 'consum', 0.0234, 'lps'),
	(626049, 132, '2015-01-01 00:56:57.000000', 'consum', 0.0256, 'lps'),
	(626050, 132, '2015-01-01 00:56:58.000000', 'consum', 0.0285, 'lps'),
	(626051, 132, '2015-01-01 00:56:59.000000', 'consum', 0.0287, 'lps'),
	(626052, 132, '2015-01-01 00:57:00.000000', 'consum', 0.0288, 'lps'),
	(626053, 132, '2015-01-01 00:57:01.000000', 'consum', 0.0210, 'lps'),
	(626054, 132, '2015-01-01 00:57:02.000000', 'consum', 0.0217, 'lps'),
	(626055, 132, '2015-01-01 00:57:03.000000', 'consum', 0.0248, 'lps'),
	(626056, 132, '2015-01-01 00:57:04.000000', 'consum', 0.0216, 'lps'),
	(626057, 132, '2015-01-01 00:57:05.000000', 'consum', 0.0288, 'lps'),
	(626058, 132, '2015-01-01 00:57:06.000000', 'consum', 0.0259, 'lps'),
	(626059, 132, '2015-01-01 00:57:07.000000', 'consum', 0.0221, 'lps'),
	(626060, 132, '2015-01-01 00:57:08.000000', 'consum', 0.0279, 'lps'),
	(626061, 132, '2015-01-01 00:57:09.000000', 'consum', 0.0282, 'lps'),
	(626062, 132, '2015-01-01 00:57:10.000000', 'consum', 0.0283, 'lps'),
	(626063, 132, '2015-01-01 00:57:11.000000', 'consum', 0.0277, 'lps'),
	(626064, 132, '2015-01-01 00:57:12.000000', 'consum', 0.0244, 'lps'),
	(626065, 132, '2015-01-01 00:57:13.000000', 'consum', 0.0262, 'lps'),
	(626066, 132, '2015-01-01 00:57:14.000000', 'consum', 0.0289, 'lps'),
	(626067, 132, '2015-01-01 00:57:15.000000', 'consum', 0.0285, 'lps'),
	(626068, 132, '2015-01-01 00:57:16.000000', 'consum', 0.0267, 'lps'),
	(626069, 132, '2015-01-01 00:57:17.000000', 'consum', 0.0270, 'lps'),
	(626070, 132, '2015-01-01 00:57:18.000000', 'consum', 0.0259, 'lps'),
	(626071, 132, '2015-01-01 00:57:19.000000', 'consum', 0.0274, 'lps'),
	(626072, 132, '2015-01-01 00:57:20.000000', 'consum', 0.0223, 'lps'),
	(626073, 132, '2015-01-01 00:57:21.000000', 'consum', 0.0243, 'lps'),
	(626074, 132, '2015-01-01 00:57:22.000000', 'consum', 0.0259, 'lps'),
	(626075, 132, '2015-01-01 00:57:23.000000', 'consum', 0.0273, 'lps'),
	(626076, 132, '2015-01-01 00:57:24.000000', 'consum', 0.0219, 'lps'),
	(626077, 132, '2015-01-01 00:57:25.000000', 'consum', 0.0227, 'lps'),
	(626078, 132, '2015-01-01 00:57:26.000000', 'consum', 0.0270, 'lps'),
	(626079, 132, '2015-01-01 00:57:27.000000', 'consum', 0.0215, 'lps'),
	(626080, 132, '2015-01-01 00:57:28.000000', 'consum', 0.0218, 'lps'),
	(626081, 132, '2015-01-01 00:57:29.000000', 'consum', 0.0234, 'lps'),
	(626082, 132, '2015-01-01 00:57:30.000000', 'consum', 0.0227, 'lps'),
	(626083, 132, '2015-01-01 00:57:31.000000', 'consum', 0.0222, 'lps'),
	(626084, 132, '2015-01-01 00:57:32.000000', 'consum', 0.0219, 'lps'),
	(626085, 132, '2015-01-01 00:57:33.000000', 'consum', 0.0222, 'lps'),
	(626086, 132, '2015-01-01 00:57:34.000000', 'consum', 0.0243, 'lps'),
	(626087, 132, '2015-01-01 00:57:35.000000', 'consum', 0.0259, 'lps'),
	(626088, 132, '2015-01-01 00:57:36.000000', 'consum', 0.0275, 'lps'),
	(626089, 132, '2015-01-01 00:57:37.000000', 'consum', 0.0228, 'lps'),
	(626090, 132, '2015-01-01 00:57:38.000000', 'consum', 0.0267, 'lps'),
	(626091, 132, '2015-01-01 00:57:39.000000', 'consum', 0.0280, 'lps'),
	(626092, 132, '2015-01-01 00:57:40.000000', 'consum', 0.0228, 'lps'),
	(626093, 132, '2015-01-01 00:57:41.000000', 'consum', 0.0250, 'lps'),
	(626094, 132, '2015-01-01 00:57:42.000000', 'consum', 0.0277, 'lps'),
	(626095, 132, '2015-01-01 00:57:43.000000', 'consum', 0.0262, 'lps'),
	(626096, 132, '2015-01-01 00:57:44.000000', 'consum', 0.0272, 'lps'),
	(626097, 132, '2015-01-01 00:57:45.000000', 'consum', 0.0285, 'lps'),
	(626098, 132, '2015-01-01 00:57:46.000000', 'consum', 0.0234, 'lps'),
	(626099, 132, '2015-01-01 00:57:47.000000', 'consum', 0.0267, 'lps'),
	(626100, 132, '2015-01-01 00:57:48.000000', 'consum', 0.0263, 'lps'),
	(626101, 132, '2015-01-01 00:57:49.000000', 'consum', 0.0222, 'lps'),
	(626102, 132, '2015-01-01 00:57:50.000000', 'consum', 0.0275, 'lps'),
	(626103, 132, '2015-01-01 00:57:51.000000', 'consum', 0.0257, 'lps'),
	(626104, 132, '2015-01-01 00:57:52.000000', 'consum', 0.0248, 'lps'),
	(626105, 132, '2015-01-01 00:57:53.000000', 'consum', 0.0261, 'lps'),
	(626106, 132, '2015-01-01 00:57:54.000000', 'consum', 0.0271, 'lps'),
	(626107, 132, '2015-01-01 00:57:55.000000', 'consum', 0.0283, 'lps'),
	(626108, 132, '2015-01-01 00:57:56.000000', 'consum', 0.0229, 'lps'),
	(626109, 132, '2015-01-01 00:57:57.000000', 'consum', 0.0250, 'lps'),
	(626110, 132, '2015-01-01 00:57:58.000000', 'consum', 0.0271, 'lps'),
	(626111, 132, '2015-01-01 00:57:59.000000', 'consum', 0.0234, 'lps'),
	(626112, 132, '2015-01-01 00:58:00.000000', 'consum', 0.0230, 'lps'),
	(626113, 132, '2015-01-01 00:58:01.000000', 'consum', 0.0238, 'lps'),
	(626114, 132, '2015-01-01 00:58:02.000000', 'consum', 0.0210, 'lps'),
	(626115, 132, '2015-01-01 00:58:03.000000', 'consum', 0.0288, 'lps'),
	(626116, 132, '2015-01-01 00:58:04.000000', 'consum', 0.0274, 'lps'),
	(626117, 132, '2015-01-01 00:58:05.000000', 'consum', 0.0218, 'lps'),
	(626118, 132, '2015-01-01 00:58:06.000000', 'consum', 0.0221, 'lps'),
	(626119, 132, '2015-01-01 00:58:07.000000', 'consum', 0.0242, 'lps'),
	(626120, 132, '2015-01-01 00:58:08.000000', 'consum', 0.0257, 'lps'),
	(626121, 132, '2015-01-01 00:58:09.000000', 'consum', 0.0268, 'lps'),
	(626122, 132, '2015-01-01 00:58:10.000000', 'consum', 0.0278, 'lps'),
	(626123, 132, '2015-01-01 00:58:11.000000', 'consum', 0.0215, 'lps'),
	(626124, 132, '2015-01-01 00:58:12.000000', 'consum', 0.0276, 'lps'),
	(626125, 132, '2015-01-01 00:58:13.000000', 'consum', 0.0280, 'lps'),
	(626126, 132, '2015-01-01 00:58:14.000000', 'consum', 0.0282, 'lps'),
	(626127, 132, '2015-01-01 00:58:15.000000', 'consum', 0.0281, 'lps'),
	(626128, 132, '2015-01-01 00:58:16.000000', 'consum', 0.0267, 'lps'),
	(626129, 132, '2015-01-01 00:58:17.000000', 'consum', 0.0281, 'lps'),
	(626130, 132, '2015-01-01 00:58:18.000000', 'consum', 0.0233, 'lps'),
	(626131, 132, '2015-01-01 00:58:19.000000', 'consum', 0.0277, 'lps'),
	(626132, 132, '2015-01-01 00:58:20.000000', 'consum', 0.0233, 'lps'),
	(626133, 132, '2015-01-01 00:58:21.000000', 'consum', 0.0285, 'lps'),
	(626134, 132, '2015-01-01 00:58:22.000000', 'consum', 0.0274, 'lps'),
	(626135, 132, '2015-01-01 00:58:23.000000', 'consum', 0.0225, 'lps'),
	(626136, 132, '2015-01-01 00:58:24.000000', 'consum', 0.0256, 'lps'),
	(626137, 132, '2015-01-01 00:58:25.000000', 'consum', 0.0232, 'lps'),
	(626138, 132, '2015-01-01 00:58:26.000000', 'consum', 0.0264, 'lps'),
	(626139, 132, '2015-01-01 00:58:27.000000', 'consum', 0.0253, 'lps'),
	(626140, 132, '2015-01-01 00:58:28.000000', 'consum', 0.0263, 'lps'),
	(626141, 132, '2015-01-01 00:58:29.000000', 'consum', 0.0266, 'lps'),
	(626142, 132, '2015-01-01 00:58:30.000000', 'consum', 0.0250, 'lps'),
	(626143, 132, '2015-01-01 00:58:31.000000', 'consum', 0.0244, 'lps'),
	(626144, 132, '2015-01-01 00:58:32.000000', 'consum', 0.0260, 'lps'),
	(626145, 132, '2015-01-01 00:58:33.000000', 'consum', 0.0277, 'lps'),
	(626146, 132, '2015-01-01 00:58:34.000000', 'consum', 0.0233, 'lps'),
	(626147, 132, '2015-01-01 00:58:35.000000', 'consum', 0.0286, 'lps'),
	(626148, 132, '2015-01-01 00:58:36.000000', 'consum', 0.0279, 'lps'),
	(626149, 132, '2015-01-01 00:58:37.000000', 'consum', 0.0247, 'lps'),
	(626150, 132, '2015-01-01 00:58:38.000000', 'consum', 0.0271, 'lps'),
	(626151, 132, '2015-01-01 00:58:39.000000', 'consum', 0.0242, 'lps'),
	(626152, 132, '2015-01-01 00:58:40.000000', 'consum', 0.0268, 'lps'),
	(626153, 132, '2015-01-01 00:58:41.000000', 'consum', 0.0241, 'lps'),
	(626154, 132, '2015-01-01 00:58:42.000000', 'consum', 0.0274, 'lps'),
	(626155, 132, '2015-01-01 00:58:43.000000', 'consum', 0.0273, 'lps'),
	(626156, 132, '2015-01-01 00:58:44.000000', 'consum', 0.0255, 'lps'),
	(626157, 132, '2015-01-01 00:58:45.000000', 'consum', 0.0247, 'lps'),
	(626158, 132, '2015-01-01 00:58:46.000000', 'consum', 0.0258, 'lps'),
	(626159, 132, '2015-01-01 00:58:47.000000', 'consum', 0.0258, 'lps'),
	(626160, 132, '2015-01-01 00:58:48.000000', 'consum', 0.0226, 'lps'),
	(626161, 132, '2015-01-01 00:58:49.000000', 'consum', 0.0229, 'lps'),
	(626162, 132, '2015-01-01 00:58:50.000000', 'consum', 0.0258, 'lps'),
	(626163, 132, '2015-01-01 00:58:51.000000', 'consum', 0.0230, 'lps'),
	(626164, 132, '2015-01-01 00:58:52.000000', 'consum', 0.0248, 'lps'),
	(626165, 132, '2015-01-01 00:58:53.000000', 'consum', 0.0261, 'lps'),
	(626166, 132, '2015-01-01 00:58:54.000000', 'consum', 0.0268, 'lps'),
	(626167, 132, '2015-01-01 00:58:55.000000', 'consum', 0.0269, 'lps'),
	(626168, 132, '2015-01-01 00:58:56.000000', 'consum', 0.0249, 'lps'),
	(626169, 132, '2015-01-01 00:58:57.000000', 'consum', 0.0227, 'lps'),
	(626170, 132, '2015-01-01 00:58:58.000000', 'consum', 0.0260, 'lps'),
	(626171, 132, '2015-01-01 00:58:59.000000', 'consum', 0.0248, 'lps'),
	(626172, 132, '2015-01-01 00:59:00.000000', 'consum', 0.0249, 'lps'),
	(626173, 132, '2015-01-01 00:59:01.000000', 'consum', 0.0213, 'lps'),
	(626174, 132, '2015-01-01 00:59:02.000000', 'consum', 0.0271, 'lps'),
	(626175, 132, '2015-01-01 00:59:03.000000', 'consum', 0.0264, 'lps'),
	(626176, 132, '2015-01-01 00:59:04.000000', 'consum', 0.0214, 'lps'),
	(626177, 132, '2015-01-01 00:59:05.000000', 'consum', 0.0233, 'lps'),
	(626178, 132, '2015-01-01 00:59:06.000000', 'consum', 0.0231, 'lps'),
	(626179, 132, '2015-01-01 00:59:07.000000', 'consum', 0.0247, 'lps'),
	(626180, 132, '2015-01-01 00:59:08.000000', 'consum', 0.0252, 'lps'),
	(626181, 132, '2015-01-01 00:59:09.000000', 'consum', 0.0226, 'lps'),
	(626182, 132, '2015-01-01 00:59:10.000000', 'consum', 0.0247, 'lps'),
	(626183, 132, '2015-01-01 00:59:11.000000', 'consum', 0.0268, 'lps'),
	(626184, 132, '2015-01-01 00:59:12.000000', 'consum', 0.0224, 'lps'),
	(626185, 132, '2015-01-01 00:59:13.000000', 'consum', 0.0272, 'lps'),
	(626186, 132, '2015-01-01 00:59:14.000000', 'consum', 0.0233, 'lps'),
	(626187, 132, '2015-01-01 00:59:15.000000', 'consum', 0.0220, 'lps'),
	(626188, 132, '2015-01-01 00:59:16.000000', 'consum', 0.0271, 'lps'),
	(626189, 132, '2015-01-01 00:59:17.000000', 'consum', 0.0246, 'lps'),
	(626190, 132, '2015-01-01 00:59:18.000000', 'consum', 0.0287, 'lps'),
	(626191, 132, '2015-01-01 00:59:19.000000', 'consum', 0.0243, 'lps'),
	(626192, 132, '2015-01-01 00:59:20.000000', 'consum', 0.0228, 'lps'),
	(626193, 132, '2015-01-01 00:59:21.000000', 'consum', 0.0283, 'lps'),
	(626194, 132, '2015-01-01 00:59:22.000000', 'consum', 0.0279, 'lps'),
	(626195, 132, '2015-01-01 00:59:23.000000', 'consum', 0.0254, 'lps'),
	(626196, 132, '2015-01-01 00:59:24.000000', 'consum', 0.0223, 'lps'),
	(626197, 132, '2015-01-01 00:59:25.000000', 'consum', 0.0224, 'lps'),
	(626198, 132, '2015-01-01 00:59:26.000000', 'consum', 0.0241, 'lps'),
	(626199, 132, '2015-01-01 00:59:27.000000', 'consum', 0.0242, 'lps'),
	(626200, 132, '2015-01-01 00:59:28.000000', 'consum', 0.0280, 'lps'),
	(626201, 132, '2015-01-01 00:59:29.000000', 'consum', 0.0222, 'lps'),
	(626202, 132, '2015-01-01 00:59:30.000000', 'consum', 0.0221, 'lps'),
	(626203, 132, '2015-01-01 00:59:31.000000', 'consum', 0.0230, 'lps'),
	(626204, 132, '2015-01-01 00:59:32.000000', 'consum', 0.0276, 'lps'),
	(626205, 132, '2015-01-01 00:59:33.000000', 'consum', 0.0238, 'lps'),
	(626206, 132, '2015-01-01 00:59:34.000000', 'consum', 0.0232, 'lps'),
	(626207, 132, '2015-01-01 00:59:35.000000', 'consum', 0.0237, 'lps'),
	(626208, 132, '2015-01-01 00:59:36.000000', 'consum', 0.0280, 'lps'),
	(626209, 132, '2015-01-01 00:59:37.000000', 'consum', 0.0237, 'lps'),
	(626210, 132, '2015-01-01 00:59:38.000000', 'consum', 0.0215, 'lps'),
	(626211, 132, '2015-01-01 00:59:39.000000', 'consum', 0.0235, 'lps'),
	(626212, 132, '2015-01-01 00:59:40.000000', 'consum', 0.0241, 'lps'),
	(626213, 132, '2015-01-01 00:59:41.000000', 'consum', 0.0211, 'lps'),
	(626214, 132, '2015-01-01 00:59:42.000000', 'consum', 0.0284, 'lps'),
	(626215, 132, '2015-01-01 00:59:43.000000', 'consum', 0.0253, 'lps'),
	(626216, 132, '2015-01-01 00:59:44.000000', 'consum', 0.0284, 'lps'),
	(626217, 132, '2015-01-01 00:59:45.000000', 'consum', 0.0288, 'lps'),
	(626218, 132, '2015-01-01 00:59:46.000000', 'consum', 0.0219, 'lps'),
	(626219, 132, '2015-01-01 00:59:47.000000', 'consum', 0.0266, 'lps'),
	(626220, 132, '2015-01-01 00:59:48.000000', 'consum', 0.0217, 'lps'),
	(626221, 132, '2015-01-01 00:59:49.000000', 'consum', 0.0240, 'lps'),
	(626222, 132, '2015-01-01 00:59:50.000000', 'consum', 0.0257, 'lps'),
	(626223, 132, '2015-01-01 00:59:51.000000', 'consum', 0.0276, 'lps'),
	(626224, 132, '2015-01-01 00:59:52.000000', 'consum', 0.0238, 'lps'),
	(626225, 132, '2015-01-01 00:59:53.000000', 'consum', 0.0235, 'lps'),
	(626226, 132, '2015-01-01 00:59:54.000000', 'consum', 0.0251, 'lps'),
	(626227, 132, '2015-01-01 00:59:55.000000', 'consum', 0.0260, 'lps'),
	(626228, 132, '2015-01-01 00:59:56.000000', 'consum', 0.0255, 'lps'),
	(626229, 132, '2015-01-01 00:59:57.000000', 'consum', 0.0286, 'lps'),
	(626230, 132, '2015-01-01 00:59:58.000000', 'consum', 0.0213, 'lps'),
	(626231, 132, '2015-01-01 00:59:59.000000', 'consum', 0.0240, 'lps'),
	(626232, 132, '2015-01-01 01:00:00.000000', 'consum', 0.0270, 'lps'),
	(626233, 132, '2015-01-01 01:00:01.000000', 'consum', 0.0258, 'lps'),
	(626234, 132, '2015-01-01 01:00:02.000000', 'consum', 0.0273, 'lps'),
	(626235, 132, '2015-01-01 01:00:03.000000', 'consum', 0.0217, 'lps'),
	(626236, 132, '2015-01-01 01:00:04.000000', 'consum', 0.0221, 'lps'),
	(626237, 132, '2015-01-01 01:00:05.000000', 'consum', 0.0245, 'lps'),
	(626238, 132, '2015-01-01 01:00:06.000000', 'consum', 0.0269, 'lps'),
	(626239, 132, '2015-01-01 01:00:07.000000', 'consum', 0.0239, 'lps'),
	(626240, 132, '2015-01-01 01:00:08.000000', 'consum', 0.0260, 'lps'),
	(626241, 132, '2015-01-01 01:00:09.000000', 'consum', 0.0211, 'lps'),
	(626242, 132, '2015-01-01 01:00:10.000000', 'consum', 0.0228, 'lps'),
	(626243, 132, '2015-01-01 01:00:11.000000', 'consum', 0.0217, 'lps'),
	(626244, 132, '2015-01-01 01:00:12.000000', 'consum', 0.0270, 'lps'),
	(626245, 132, '2015-01-01 01:00:13.000000', 'consum', 0.0248, 'lps'),
	(626246, 132, '2015-01-01 01:00:14.000000', 'consum', 0.0219, 'lps'),
	(626247, 132, '2015-01-01 01:00:15.000000', 'consum', 0.0223, 'lps'),
	(626248, 132, '2015-01-01 01:00:16.000000', 'consum', 0.0247, 'lps'),
	(626249, 132, '2015-01-01 01:00:17.000000', 'consum', 0.0277, 'lps'),
	(626250, 132, '2015-01-01 01:00:18.000000', 'consum', 0.0274, 'lps'),
	(626251, 132, '2015-01-01 01:00:19.000000', 'consum', 0.0246, 'lps'),
	(626252, 132, '2015-01-01 01:00:20.000000', 'consum', 0.0279, 'lps'),
	(626253, 132, '2015-01-01 01:00:21.000000', 'consum', 0.0285, 'lps'),
	(626254, 132, '2015-01-01 01:00:22.000000', 'consum', 0.0216, 'lps'),
	(626255, 132, '2015-01-01 01:00:23.000000', 'consum', 0.0258, 'lps'),
	(626256, 132, '2015-01-01 01:00:24.000000', 'consum', 0.0271, 'lps'),
	(626257, 132, '2015-01-01 01:00:25.000000', 'consum', 0.0210, 'lps'),
	(626258, 132, '2015-01-01 01:00:26.000000', 'consum', 0.0270, 'lps'),
	(626259, 132, '2015-01-01 01:00:27.000000', 'consum', 0.0268, 'lps'),
	(626260, 132, '2015-01-01 01:00:28.000000', 'consum', 0.0238, 'lps'),
	(626261, 132, '2015-01-01 01:00:29.000000', 'consum', 0.0259, 'lps'),
	(626262, 132, '2015-01-01 01:00:30.000000', 'consum', 0.0210, 'lps'),
	(626263, 132, '2015-01-01 01:00:31.000000', 'consum', 0.0224, 'lps'),
	(626264, 132, '2015-01-01 01:00:32.000000', 'consum', 0.0281, 'lps'),
	(626265, 132, '2015-01-01 01:00:33.000000', 'consum', 0.0281, 'lps'),
	(626266, 132, '2015-01-01 01:00:34.000000', 'consum', 0.0273, 'lps'),
	(626267, 132, '2015-01-01 01:00:35.000000', 'consum', 0.0230, 'lps'),
	(626268, 132, '2015-01-01 01:00:36.000000', 'consum', 0.0283, 'lps'),
	(626269, 132, '2015-01-01 01:00:37.000000', 'consum', 0.0272, 'lps'),
	(626270, 132, '2015-01-01 01:00:38.000000', 'consum', 0.0222, 'lps'),
	(626271, 132, '2015-01-01 01:00:39.000000', 'consum', 0.0247, 'lps'),
	(626272, 132, '2015-01-01 01:00:40.000000', 'consum', 0.0277, 'lps'),
	(626273, 132, '2015-01-01 01:00:41.000000', 'consum', 0.0272, 'lps'),
	(626274, 132, '2015-01-01 01:00:42.000000', 'consum', 0.0239, 'lps'),
	(626275, 132, '2015-01-01 01:00:43.000000', 'consum', 0.0249, 'lps'),
	(626276, 132, '2015-01-01 01:00:44.000000', 'consum', 0.0240, 'lps'),
	(626277, 132, '2015-01-01 01:00:45.000000', 'consum', 0.0240, 'lps'),
	(626278, 132, '2015-01-01 01:00:46.000000', 'consum', 0.0274, 'lps'),
	(626279, 132, '2015-01-01 01:00:47.000000', 'consum', 0.0278, 'lps'),
	(626280, 132, '2015-01-01 01:00:48.000000', 'consum', 0.0279, 'lps'),
	(626281, 132, '2015-01-01 01:00:49.000000', 'consum', 0.0267, 'lps'),
	(626282, 132, '2015-01-01 01:00:50.000000', 'consum', 0.0210, 'lps'),
	(626283, 132, '2015-01-01 01:00:51.000000', 'consum', 0.0281, 'lps'),
	(626284, 132, '2015-01-01 01:00:52.000000', 'consum', 0.0242, 'lps'),
	(626285, 132, '2015-01-01 01:00:53.000000', 'consum', 0.0239, 'lps'),
	(626286, 132, '2015-01-01 01:00:54.000000', 'consum', 0.0261, 'lps'),
	(626287, 132, '2015-01-01 01:00:55.000000', 'consum', 0.0215, 'lps'),
	(626288, 132, '2015-01-01 01:00:56.000000', 'consum', 0.0246, 'lps'),
	(626289, 132, '2015-01-01 01:00:57.000000', 'consum', 0.0214, 'lps'),
	(626290, 132, '2015-01-01 01:00:58.000000', 'consum', 0.0285, 'lps'),
	(626291, 132, '2015-01-01 01:00:59.000000', 'consum', 0.0248, 'lps'),
	(626292, 132, '2015-01-01 01:01:00.000000', 'consum', 0.0255, 'lps'),
	(626293, 132, '2015-01-01 01:01:01.000000', 'consum', 0.0242, 'lps'),
	(626294, 132, '2015-01-01 01:01:02.000000', 'consum', 0.0234, 'lps'),
	(626295, 132, '2015-01-01 01:01:03.000000', 'consum', 0.0236, 'lps'),
	(626296, 132, '2015-01-01 01:01:04.000000', 'consum', 0.0266, 'lps'),
	(626297, 132, '2015-01-01 01:01:05.000000', 'consum', 0.0254, 'lps'),
	(626298, 132, '2015-01-01 01:01:06.000000', 'consum', 0.0259, 'lps'),
	(626299, 132, '2015-01-01 01:01:07.000000', 'consum', 0.0245, 'lps'),
	(626300, 132, '2015-01-01 01:01:08.000000', 'consum', 0.0240, 'lps'),
	(626301, 132, '2015-01-01 01:01:09.000000', 'consum', 0.0253, 'lps'),
	(626302, 132, '2015-01-01 01:01:10.000000', 'consum', 0.0254, 'lps'),
	(626303, 132, '2015-01-01 01:01:11.000000', 'consum', 0.0219, 'lps'),
	(626304, 132, '2015-01-01 01:01:12.000000', 'consum', 0.0289, 'lps'),
	(626305, 132, '2015-01-01 01:01:13.000000', 'consum', 0.0254, 'lps'),
	(626306, 132, '2015-01-01 01:01:14.000000', 'consum', 0.0274, 'lps'),
	(626307, 132, '2015-01-01 01:01:15.000000', 'consum', 0.0235, 'lps'),
	(626308, 132, '2015-01-01 01:01:16.000000', 'consum', 0.0224, 'lps'),
	(626309, 132, '2015-01-01 01:01:17.000000', 'consum', 0.0287, 'lps'),
	(626310, 132, '2015-01-01 01:01:18.000000', 'consum', 0.0231, 'lps'),
	(626311, 132, '2015-01-01 01:01:19.000000', 'consum', 0.0247, 'lps'),
	(626312, 132, '2015-01-01 01:01:20.000000', 'consum', 0.0253, 'lps'),
	(626313, 132, '2015-01-01 01:01:21.000000', 'consum', 0.0230, 'lps'),
	(626314, 132, '2015-01-01 01:01:22.000000', 'consum', 0.0264, 'lps'),
	(626315, 132, '2015-01-01 01:01:23.000000', 'consum', 0.0257, 'lps'),
	(626316, 132, '2015-01-01 01:01:24.000000', 'consum', 0.0284, 'lps'),
	(626317, 132, '2015-01-01 01:01:25.000000', 'consum', 0.0277, 'lps'),
	(626318, 132, '2015-01-01 01:01:26.000000', 'consum', 0.0241, 'lps'),
	(626319, 132, '2015-01-01 01:01:27.000000', 'consum', 0.0249, 'lps'),
	(626320, 132, '2015-01-01 01:01:28.000000', 'consum', 0.0230, 'lps'),
	(626321, 132, '2015-01-01 01:01:29.000000', 'consum', 0.0274, 'lps'),
	(626322, 132, '2015-01-01 01:01:30.000000', 'consum', 0.0227, 'lps'),
	(626323, 132, '2015-01-01 01:01:31.000000', 'consum', 0.0267, 'lps'),
	(626324, 132, '2015-01-01 01:01:32.000000', 'consum', 0.0280, 'lps'),
	(626325, 132, '2015-01-01 01:01:33.000000', 'consum', 0.0229, 'lps'),
	(626326, 132, '2015-01-01 01:01:34.000000', 'consum', 0.0257, 'lps'),
	(626327, 132, '2015-01-01 01:01:35.000000', 'consum', 0.0227, 'lps'),
	(626328, 132, '2015-01-01 01:01:36.000000', 'consum', 0.0236, 'lps'),
	(626329, 132, '2015-01-01 01:01:37.000000', 'consum', 0.0210, 'lps'),
	(626330, 132, '2015-01-01 01:01:38.000000', 'consum', 0.0212, 'lps'),
	(626331, 132, '2015-01-01 01:01:39.000000', 'consum', 0.0223, 'lps'),
	(626332, 132, '2015-01-01 01:01:40.000000', 'consum', 0.0267, 'lps'),
	(626333, 132, '2015-01-01 01:01:41.000000', 'consum', 0.0213, 'lps'),
	(626334, 132, '2015-01-01 01:01:42.000000', 'consum', 0.0216, 'lps'),
	(626335, 132, '2015-01-01 01:01:43.000000', 'consum', 0.0231, 'lps'),
	(626336, 132, '2015-01-01 01:01:44.000000', 'consum', 0.0216, 'lps'),
	(626337, 132, '2015-01-01 01:01:45.000000', 'consum', 0.0258, 'lps'),
	(626338, 132, '2015-01-01 01:01:46.000000', 'consum', 0.0272, 'lps'),
	(626339, 132, '2015-01-01 01:01:47.000000', 'consum', 0.0213, 'lps'),
	(626340, 132, '2015-01-01 01:01:48.000000', 'consum', 0.0284, 'lps'),
	(626341, 132, '2015-01-01 01:01:49.000000', 'consum', 0.0248, 'lps'),
	(626342, 132, '2015-01-01 01:01:50.000000', 'consum', 0.0259, 'lps'),
	(626343, 132, '2015-01-01 01:01:51.000000', 'consum', 0.0260, 'lps'),
	(626344, 132, '2015-01-01 01:01:52.000000', 'consum', 0.0233, 'lps'),
	(626345, 132, '2015-01-01 01:01:53.000000', 'consum', 0.0257, 'lps'),
	(626346, 132, '2015-01-01 01:01:54.000000', 'consum', 0.0215, 'lps'),
	(626347, 132, '2015-01-01 01:01:55.000000', 'consum', 0.0256, 'lps'),
	(626348, 132, '2015-01-01 01:01:56.000000', 'consum', 0.0265, 'lps'),
	(626349, 132, '2015-01-01 01:01:57.000000', 'consum', 0.0265, 'lps'),
	(626350, 132, '2015-01-01 01:01:58.000000', 'consum', 0.0239, 'lps'),
	(626351, 132, '2015-01-01 01:01:59.000000', 'consum', 0.0271, 'lps'),
	(626352, 132, '2015-01-01 01:02:00.000000', 'consum', 0.0269, 'lps'),
	(626353, 132, '2015-01-01 01:02:01.000000', 'consum', 0.0238, 'lps'),
	(626354, 132, '2015-01-01 01:02:02.000000', 'consum', 0.0257, 'lps'),
	(626355, 132, '2015-01-01 01:02:03.000000', 'consum', 0.0279, 'lps'),
	(626356, 132, '2015-01-01 01:02:04.000000', 'consum', 0.0253, 'lps'),
	(626357, 132, '2015-01-01 01:02:05.000000', 'consum', 0.0219, 'lps'),
	(626358, 132, '2015-01-01 01:02:06.000000', 'consum', 0.0289, 'lps'),
	(626359, 132, '2015-01-01 01:02:07.000000', 'consum', 0.0252, 'lps'),
	(626360, 132, '2015-01-01 01:02:08.000000', 'consum', 0.0266, 'lps'),
	(626361, 132, '2015-01-01 01:02:09.000000', 'consum', 0.0283, 'lps'),
	(626362, 132, '2015-01-01 01:02:10.000000', 'consum', 0.0248, 'lps'),
	(626363, 132, '2015-01-01 01:02:11.000000', 'consum', 0.0260, 'lps'),
	(626364, 132, '2015-01-01 01:02:12.000000', 'consum', 0.0268, 'lps'),
	(626365, 132, '2015-01-01 01:02:13.000000', 'consum', 0.0266, 'lps'),
	(626366, 132, '2015-01-01 01:02:14.000000', 'consum', 0.0238, 'lps'),
	(626367, 132, '2015-01-01 01:02:15.000000', 'consum', 0.0261, 'lps'),
	(626368, 132, '2015-01-01 01:02:16.000000', 'consum', 0.0221, 'lps'),
	(626369, 132, '2015-01-01 01:02:17.000000', 'consum', 0.0276, 'lps'),
	(626370, 132, '2015-01-01 01:02:18.000000', 'consum', 0.0262, 'lps'),
	(626371, 132, '2015-01-01 01:02:19.000000', 'consum', 0.0272, 'lps'),
	(626372, 132, '2015-01-01 01:02:20.000000', 'consum', 0.0286, 'lps'),
	(626373, 132, '2015-01-01 01:02:21.000000', 'consum', 0.0242, 'lps'),
	(626374, 132, '2015-01-01 01:02:22.000000', 'consum', 0.0224, 'lps'),
	(626375, 132, '2015-01-01 01:02:23.000000', 'consum', 0.0263, 'lps'),
	(626376, 132, '2015-01-01 01:02:24.000000', 'consum', 0.0275, 'lps'),
	(626377, 132, '2015-01-01 01:02:25.000000', 'consum', 0.0212, 'lps'),
	(626378, 132, '2015-01-01 01:02:26.000000', 'consum', 0.0270, 'lps'),
	(626379, 132, '2015-01-01 01:02:27.000000', 'consum', 0.0262, 'lps'),
	(626380, 132, '2015-01-01 01:02:28.000000', 'consum', 0.0288, 'lps'),
	(626381, 132, '2015-01-01 01:02:29.000000', 'consum', 0.0285, 'lps'),
	(626382, 132, '2015-01-01 01:02:30.000000', 'consum', 0.0271, 'lps'),
	(626383, 132, '2015-01-01 01:02:31.000000', 'consum', 0.0288, 'lps'),
	(626384, 132, '2015-01-01 01:02:32.000000', 'consum', 0.0257, 'lps'),
	(626385, 132, '2015-01-01 01:02:33.000000', 'consum', 0.0211, 'lps'),
	(626386, 132, '2015-01-01 01:02:34.000000', 'consum', 0.0236, 'lps'),
	(626387, 132, '2015-01-01 01:02:35.000000', 'consum', 0.0259, 'lps'),
	(626388, 132, '2015-01-01 01:02:36.000000', 'consum', 0.0213, 'lps'),
	(626389, 132, '2015-01-01 01:02:37.000000', 'consum', 0.0241, 'lps'),
	(626390, 132, '2015-01-01 01:02:38.000000', 'consum', 0.0275, 'lps'),
	(626391, 132, '2015-01-01 01:02:39.000000', 'consum', 0.0282, 'lps'),
	(626392, 132, '2015-01-01 01:02:40.000000', 'consum', 0.0212, 'lps'),
	(626393, 132, '2015-01-01 01:02:41.000000', 'consum', 0.0250, 'lps'),
	(626394, 132, '2015-01-01 01:02:42.000000', 'consum', 0.0242, 'lps'),
	(626395, 132, '2015-01-01 01:02:43.000000', 'consum', 0.0250, 'lps'),
	(626396, 132, '2015-01-01 01:02:44.000000', 'consum', 0.0232, 'lps'),
	(626397, 132, '2015-01-01 01:02:45.000000', 'consum', 0.0282, 'lps'),
	(626398, 132, '2015-01-01 01:02:46.000000', 'consum', 0.0260, 'lps'),
	(626399, 132, '2015-01-01 01:02:47.000000', 'consum', 0.0246, 'lps'),
	(626400, 132, '2015-01-01 01:02:48.000000', 'consum', 0.0239, 'lps'),
	(626401, 132, '2015-01-01 01:02:49.000000', 'consum', 0.0247, 'lps'),
	(626402, 132, '2015-01-01 01:02:50.000000', 'consum', 0.0227, 'lps'),
	(626403, 132, '2015-01-01 01:02:51.000000', 'consum', 0.0267, 'lps'),
	(626404, 132, '2015-01-01 01:02:52.000000', 'consum', 0.0281, 'lps'),
	(626405, 132, '2015-01-01 01:02:53.000000', 'consum', 0.0233, 'lps'),
	(626406, 132, '2015-01-01 01:02:54.000000', 'consum', 0.0276, 'lps'),
	(626407, 132, '2015-01-01 01:02:55.000000', 'consum', 0.0227, 'lps'),
	(626408, 132, '2015-01-01 01:02:56.000000', 'consum', 0.0259, 'lps'),
	(626409, 132, '2015-01-01 01:02:57.000000', 'consum', 0.0243, 'lps'),
	(626410, 132, '2015-01-01 01:02:58.000000', 'consum', 0.0228, 'lps'),
	(626411, 132, '2015-01-01 01:02:59.000000', 'consum', 0.0284, 'lps'),
	(626412, 132, '2015-01-01 01:03:00.000000', 'consum', 0.0281, 'lps'),
	(626413, 132, '2015-01-01 01:03:01.000000', 'consum', 0.0265, 'lps'),
	(626414, 132, '2015-01-01 01:03:02.000000', 'consum', 0.0270, 'lps'),
	(626415, 132, '2015-01-01 01:03:03.000000', 'consum', 0.0267, 'lps'),
	(626416, 132, '2015-01-01 01:03:04.000000', 'consum', 0.0233, 'lps'),
	(626417, 132, '2015-01-01 01:03:05.000000', 'consum', 0.0234, 'lps'),
	(626418, 132, '2015-01-01 01:03:06.000000', 'consum', 0.0264, 'lps'),
	(626419, 132, '2015-01-01 01:03:07.000000', 'consum', 0.0246, 'lps'),
	(626420, 132, '2015-01-01 01:03:08.000000', 'consum', 0.0227, 'lps'),
	(626421, 132, '2015-01-01 01:03:09.000000', 'consum', 0.0269, 'lps'),
	(626422, 132, '2015-01-01 01:03:10.000000', 'consum', 0.0210, 'lps'),
	(626423, 132, '2015-01-01 01:03:11.000000', 'consum', 0.0279, 'lps'),
	(626424, 132, '2015-01-01 01:03:12.000000', 'consum', 0.0229, 'lps'),
	(626425, 132, '2015-01-01 01:03:13.000000', 'consum', 0.0260, 'lps'),
	(626426, 132, '2015-01-01 01:03:14.000000', 'consum', 0.0244, 'lps'),
	(626427, 132, '2015-01-01 01:03:15.000000', 'consum', 0.0230, 'lps'),
	(626428, 132, '2015-01-01 01:03:16.000000', 'consum', 0.0290, 'lps'),
	(626429, 132, '2015-01-01 01:03:17.000000', 'consum', 0.0226, 'lps'),
	(626430, 132, '2015-01-01 01:03:18.000000', 'consum', 0.0215, 'lps'),
	(626431, 132, '2015-01-01 01:03:19.000000', 'consum', 0.0265, 'lps'),
	(626432, 132, '2015-01-01 01:03:20.000000', 'consum', 0.0227, 'lps'),
	(626433, 132, '2015-01-01 01:03:21.000000', 'consum', 0.0214, 'lps'),
	(626434, 132, '2015-01-01 01:03:22.000000', 'consum', 0.0259, 'lps'),
	(626435, 132, '2015-01-01 01:03:23.000000', 'consum', 0.0280, 'lps'),
	(626436, 132, '2015-01-01 01:03:24.000000', 'consum', 0.0252, 'lps'),
	(626437, 132, '2015-01-01 01:03:25.000000', 'consum', 0.0210, 'lps'),
	(626438, 132, '2015-01-01 01:03:26.000000', 'consum', 0.0249, 'lps'),
	(626439, 132, '2015-01-01 01:03:27.000000', 'consum', 0.0243, 'lps'),
	(626440, 132, '2015-01-01 01:03:28.000000', 'consum', 0.0257, 'lps'),
	(626441, 132, '2015-01-01 01:03:29.000000', 'consum', 0.0268, 'lps'),
	(626442, 132, '2015-01-01 01:03:30.000000', 'consum', 0.0278, 'lps'),
	(626443, 132, '2015-01-01 01:03:31.000000', 'consum', 0.0213, 'lps'),
	(626444, 132, '2015-01-01 01:03:32.000000', 'consum', 0.0263, 'lps'),
	(626445, 132, '2015-01-01 01:03:33.000000', 'consum', 0.0227, 'lps'),
	(626446, 132, '2015-01-01 01:03:34.000000', 'consum', 0.0216, 'lps'),
	(626447, 132, '2015-01-01 01:03:35.000000', 'consum', 0.0269, 'lps'),
	(626448, 132, '2015-01-01 01:03:36.000000', 'consum', 0.0247, 'lps'),
	(626449, 132, '2015-01-01 01:03:37.000000', 'consum', 0.0218, 'lps'),
	(626450, 132, '2015-01-01 01:03:38.000000', 'consum', 0.0221, 'lps'),
	(626451, 132, '2015-01-01 01:03:39.000000', 'consum', 0.0240, 'lps'),
	(626452, 132, '2015-01-01 01:03:40.000000', 'consum', 0.0246, 'lps'),
	(626453, 132, '2015-01-01 01:03:41.000000', 'consum', 0.0219, 'lps'),
	(626454, 132, '2015-01-01 01:03:42.000000', 'consum', 0.0229, 'lps'),
	(626455, 132, '2015-01-01 01:03:43.000000', 'consum', 0.0280, 'lps'),
	(626456, 132, '2015-01-01 01:03:44.000000', 'consum', 0.0261, 'lps'),
	(626457, 132, '2015-01-01 01:03:45.000000', 'consum', 0.0255, 'lps'),
	(626458, 132, '2015-01-01 01:03:46.000000', 'consum', 0.0282, 'lps'),
	(626459, 132, '2015-01-01 01:03:47.000000', 'consum', 0.0275, 'lps'),
	(626460, 132, '2015-01-01 01:03:48.000000', 'consum', 0.0238, 'lps'),
	(626461, 132, '2015-01-01 01:03:49.000000', 'consum', 0.0238, 'lps'),
	(626462, 132, '2015-01-01 01:03:50.000000', 'consum', 0.0263, 'lps'),
	(626463, 132, '2015-01-01 01:03:51.000000', 'consum', 0.0232, 'lps'),
	(626464, 132, '2015-01-01 01:03:52.000000', 'consum', 0.0243, 'lps'),
	(626465, 132, '2015-01-01 01:03:53.000000', 'consum', 0.0226, 'lps'),
	(626466, 132, '2015-01-01 01:03:54.000000', 'consum', 0.0272, 'lps'),
	(626467, 132, '2015-01-01 01:03:55.000000', 'consum', 0.0231, 'lps'),
	(626468, 132, '2015-01-01 01:03:56.000000', 'consum', 0.0210, 'lps'),
	(626469, 132, '2015-01-01 01:03:57.000000', 'consum', 0.0228, 'lps'),
	(626470, 132, '2015-01-01 01:03:58.000000', 'consum', 0.0222, 'lps'),
	(626471, 132, '2015-01-01 01:03:59.000000', 'consum', 0.0214, 'lps'),
	(626472, 132, '2015-01-01 01:04:00.000000', 'consum', 0.0277, 'lps'),
	(626473, 132, '2015-01-01 01:04:01.000000', 'consum', 0.0290, 'lps'),
	(626474, 132, '2015-01-01 01:04:02.000000', 'consum', 0.0247, 'lps'),
	(626475, 132, '2015-01-01 01:04:03.000000', 'consum', 0.0237, 'lps'),
	(626476, 132, '2015-01-01 01:04:04.000000', 'consum', 0.0233, 'lps'),
	(626477, 132, '2015-01-01 01:04:05.000000', 'consum', 0.0247, 'lps'),
	(626478, 132, '2015-01-01 01:04:06.000000', 'consum', 0.0245, 'lps'),
	(626479, 132, '2015-01-01 01:04:07.000000', 'consum', 0.0274, 'lps'),
	(626480, 132, '2015-01-01 01:04:08.000000', 'consum', 0.0264, 'lps'),
	(626481, 132, '2015-01-01 01:04:09.000000', 'consum', 0.0287, 'lps'),
	(626482, 132, '2015-01-01 01:04:10.000000', 'consum', 0.0272, 'lps'),
	(626483, 132, '2015-01-01 01:04:11.000000', 'consum', 0.0288, 'lps'),
	(626484, 132, '2015-01-01 01:04:12.000000', 'consum', 0.0255, 'lps'),
	(626485, 132, '2015-01-01 01:04:13.000000', 'consum', 0.0283, 'lps'),
	(626486, 132, '2015-01-01 01:04:14.000000', 'consum', 0.0277, 'lps'),
	(626487, 132, '2015-01-01 01:04:15.000000', 'consum', 0.0248, 'lps'),
	(626488, 132, '2015-01-01 01:04:16.000000', 'consum', 0.0278, 'lps'),
	(626489, 132, '2015-01-01 01:04:17.000000', 'consum', 0.0273, 'lps'),
	(626490, 132, '2015-01-01 01:04:18.000000', 'consum', 0.0243, 'lps'),
	(626491, 132, '2015-01-01 01:04:19.000000', 'consum', 0.0266, 'lps'),
	(626492, 132, '2015-01-01 01:04:20.000000', 'consum', 0.0229, 'lps'),
	(626493, 132, '2015-01-01 01:04:21.000000', 'consum', 0.0218, 'lps'),
	(626494, 132, '2015-01-01 01:04:22.000000', 'consum', 0.0276, 'lps'),
	(626495, 132, '2015-01-01 01:04:23.000000', 'consum', 0.0273, 'lps'),
	(626496, 132, '2015-01-01 01:04:24.000000', 'consum', 0.0246, 'lps'),
	(626497, 132, '2015-01-01 01:04:25.000000', 'consum', 0.0283, 'lps'),
	(626498, 132, '2015-01-01 01:04:26.000000', 'consum', 0.0226, 'lps'),
	(626499, 132, '2015-01-01 01:04:27.000000', 'consum', 0.0233, 'lps'),
	(626500, 132, '2015-01-01 01:04:28.000000', 'consum', 0.0277, 'lps'),
	(626501, 132, '2015-01-01 01:04:29.000000', 'consum', 0.0233, 'lps'),
	(626502, 132, '2015-01-01 01:04:30.000000', 'consum', 0.0286, 'lps'),
	(626503, 132, '2015-01-01 01:04:31.000000', 'consum', 0.0280, 'lps'),
	(626504, 132, '2015-01-01 01:04:32.000000', 'consum', 0.0251, 'lps'),
	(626505, 132, '2015-01-01 01:04:33.000000', 'consum', 0.0286, 'lps'),
	(626506, 132, '2015-01-01 01:04:34.000000', 'consum', 0.0227, 'lps'),
	(626507, 132, '2015-01-01 01:04:35.000000', 'consum', 0.0227, 'lps'),
	(626508, 132, '2015-01-01 01:04:36.000000', 'consum', 0.0244, 'lps'),
	(626509, 132, '2015-01-01 01:04:37.000000', 'consum', 0.0251, 'lps'),
	(626510, 132, '2015-01-01 01:04:38.000000', 'consum', 0.0229, 'lps'),
	(626511, 132, '2015-01-01 01:04:39.000000', 'consum', 0.0267, 'lps'),
	(626512, 132, '2015-01-01 01:04:40.000000', 'consum', 0.0273, 'lps'),
	(626513, 132, '2015-01-01 01:04:41.000000', 'consum', 0.0276, 'lps'),
	(626514, 132, '2015-01-01 01:04:42.000000', 'consum', 0.0269, 'lps'),
	(626515, 132, '2015-01-01 01:04:43.000000', 'consum', 0.0227, 'lps'),
	(626516, 132, '2015-01-01 01:04:44.000000', 'consum', 0.0282, 'lps'),
	(626517, 132, '2015-01-01 01:04:45.000000', 'consum', 0.0277, 'lps'),
	(626518, 132, '2015-01-01 01:04:46.000000', 'consum', 0.0249, 'lps'),
	(626519, 132, '2015-01-01 01:04:47.000000', 'consum', 0.0285, 'lps'),
	(626520, 132, '2015-01-01 01:04:48.000000', 'consum', 0.0226, 'lps'),
	(626521, 132, '2015-01-01 01:04:49.000000', 'consum', 0.0227, 'lps'),
	(626522, 132, '2015-01-01 01:04:50.000000', 'consum', 0.0249, 'lps'),
	(626523, 132, '2015-01-01 01:04:51.000000', 'consum', 0.0273, 'lps'),
	(626524, 132, '2015-01-01 01:04:52.000000', 'consum', 0.0244, 'lps'),
	(626525, 132, '2015-01-01 01:04:53.000000', 'consum', 0.0275, 'lps'),
	(626526, 132, '2015-01-01 01:04:54.000000', 'consum', 0.0272, 'lps'),
	(626527, 132, '2015-01-01 01:04:55.000000', 'consum', 0.0244, 'lps'),
	(626528, 132, '2015-01-01 01:04:56.000000', 'consum', 0.0274, 'lps'),
	(626529, 132, '2015-01-01 01:04:57.000000', 'consum', 0.0266, 'lps'),
	(626530, 132, '2015-01-01 01:04:58.000000', 'consum', 0.0219, 'lps'),
	(626531, 132, '2015-01-01 01:04:59.000000', 'consum', 0.0247, 'lps'),
	(626532, 132, '2015-01-01 01:05:00.000000', 'consum', 0.0290, 'lps'),
	(626533, 132, '2015-01-01 01:05:01.000000', 'consum', 0.0254, 'lps'),
	(626534, 132, '2015-01-01 01:05:02.000000', 'consum', 0.0271, 'lps'),
	(626535, 132, '2015-01-01 01:05:03.000000', 'consum', 0.0225, 'lps'),
	(626536, 132, '2015-01-01 01:05:04.000000', 'consum', 0.0262, 'lps'),
	(626537, 132, '2015-01-01 01:05:05.000000', 'consum', 0.0263, 'lps'),
	(626538, 132, '2015-01-01 01:05:06.000000', 'consum', 0.0240, 'lps'),
	(626539, 132, '2015-01-01 01:05:07.000000', 'consum', 0.0280, 'lps'),
	(626540, 132, '2015-01-01 01:05:08.000000', 'consum', 0.0230, 'lps'),
	(626541, 132, '2015-01-01 01:05:09.000000', 'consum', 0.0262, 'lps'),
	(626542, 132, '2015-01-01 01:05:10.000000', 'consum', 0.0249, 'lps'),
	(626543, 132, '2015-01-01 01:05:11.000000', 'consum', 0.0250, 'lps'),
	(626544, 132, '2015-01-01 01:05:12.000000', 'consum', 0.0212, 'lps'),
	(626545, 132, '2015-01-01 01:05:13.000000', 'consum', 0.0264, 'lps'),
	(626546, 132, '2015-01-01 01:05:14.000000', 'consum', 0.0232, 'lps'),
	(626547, 132, '2015-01-01 01:05:15.000000', 'consum', 0.0237, 'lps'),
	(626548, 132, '2015-01-01 01:05:16.000000', 'consum', 0.0282, 'lps'),
	(626549, 132, '2015-01-01 01:05:17.000000', 'consum', 0.0246, 'lps'),
	(626550, 132, '2015-01-01 01:05:18.000000', 'consum', 0.0254, 'lps'),
	(626551, 132, '2015-01-01 01:05:19.000000', 'consum', 0.0244, 'lps'),
	(626552, 132, '2015-01-01 01:05:20.000000', 'consum', 0.0247, 'lps'),
	(626553, 132, '2015-01-01 01:05:21.000000', 'consum', 0.0214, 'lps'),
	(626554, 132, '2015-01-01 01:05:22.000000', 'consum', 0.0279, 'lps'),
	(626555, 132, '2015-01-01 01:05:23.000000', 'consum', 0.0222, 'lps'),
	(626556, 132, '2015-01-01 01:05:24.000000', 'consum', 0.0223, 'lps'),
	(626557, 132, '2015-01-01 01:05:25.000000', 'consum', 0.0242, 'lps'),
	(626558, 132, '2015-01-01 01:05:26.000000', 'consum', 0.0251, 'lps'),
	(626559, 132, '2015-01-01 01:05:27.000000', 'consum', 0.0238, 'lps'),
	(626560, 132, '2015-01-01 01:05:28.000000', 'consum', 0.0229, 'lps'),
	(626561, 132, '2015-01-01 01:05:29.000000', 'consum', 0.0220, 'lps'),
	(626562, 132, '2015-01-01 01:05:30.000000', 'consum', 0.0284, 'lps'),
	(626563, 132, '2015-01-01 01:05:31.000000', 'consum', 0.0228, 'lps'),
	(626564, 132, '2015-01-01 01:05:32.000000', 'consum', 0.0239, 'lps'),
	(626565, 132, '2015-01-01 01:05:33.000000', 'consum', 0.0219, 'lps'),
	(626566, 132, '2015-01-01 01:05:34.000000', 'consum', 0.0252, 'lps'),
	(626567, 132, '2015-01-01 01:05:35.000000', 'consum', 0.0231, 'lps'),
	(626568, 132, '2015-01-01 01:05:36.000000', 'consum', 0.0269, 'lps'),
	(626569, 132, '2015-01-01 01:05:37.000000', 'consum', 0.0283, 'lps'),
	(626570, 132, '2015-01-01 01:05:38.000000', 'consum', 0.0236, 'lps'),
	(626571, 132, '2015-01-01 01:05:39.000000', 'consum', 0.0284, 'lps'),
	(626572, 132, '2015-01-01 01:05:40.000000', 'consum', 0.0260, 'lps'),
	(626573, 132, '2015-01-01 01:05:41.000000', 'consum', 0.0237, 'lps'),
	(626574, 132, '2015-01-01 01:05:42.000000', 'consum', 0.0277, 'lps'),
	(626575, 132, '2015-01-01 01:05:43.000000', 'consum', 0.0220, 'lps'),
	(626576, 132, '2015-01-01 01:05:44.000000', 'consum', 0.0220, 'lps'),
	(626577, 132, '2015-01-01 01:05:45.000000', 'consum', 0.0234, 'lps'),
	(626578, 132, '2015-01-01 01:05:46.000000', 'consum', 0.0220, 'lps'),
	(626579, 132, '2015-01-01 01:05:47.000000', 'consum', 0.0266, 'lps'),
	(626580, 132, '2015-01-01 01:05:48.000000', 'consum', 0.0220, 'lps'),
	(626581, 132, '2015-01-01 01:05:49.000000', 'consum', 0.0254, 'lps'),
	(626582, 132, '2015-01-01 01:05:50.000000', 'consum', 0.0237, 'lps'),
	(626583, 132, '2015-01-01 01:05:51.000000', 'consum', 0.0216, 'lps'),
	(626584, 132, '2015-01-01 01:05:52.000000', 'consum', 0.0241, 'lps'),
	(626585, 132, '2015-01-01 01:05:53.000000', 'consum', 0.0266, 'lps'),
	(626586, 132, '2015-01-01 01:05:54.000000', 'consum', 0.0236, 'lps'),
	(626587, 132, '2015-01-01 01:05:55.000000', 'consum', 0.0253, 'lps'),
	(626588, 132, '2015-01-01 01:05:56.000000', 'consum', 0.0264, 'lps'),
	(626589, 132, '2015-01-01 01:05:57.000000', 'consum', 0.0274, 'lps'),
	(626590, 132, '2015-01-01 01:05:58.000000', 'consum', 0.0287, 'lps'),
	(626591, 132, '2015-01-01 01:05:59.000000', 'consum', 0.0240, 'lps'),
	(626592, 132, '2015-01-01 01:06:00.000000', 'consum', 0.0212, 'lps'),
	(626593, 132, '2015-01-01 01:06:01.000000', 'consum', 0.0290, 'lps'),
	(626594, 132, '2015-01-01 01:06:02.000000', 'consum', 0.0283, 'lps'),
	(626595, 132, '2015-01-01 01:06:03.000000', 'consum', 0.0252, 'lps'),
	(626596, 132, '2015-01-01 01:06:04.000000', 'consum', 0.0283, 'lps'),
	(626597, 132, '2015-01-01 01:06:05.000000', 'consum', 0.0286, 'lps'),
	(626598, 132, '2015-01-01 01:06:06.000000', 'consum', 0.0211, 'lps'),
	(626599, 132, '2015-01-01 01:06:07.000000', 'consum', 0.0229, 'lps'),
	(626600, 132, '2015-01-01 01:06:08.000000', 'consum', 0.0223, 'lps'),
	(626601, 132, '2015-01-01 01:06:09.000000', 'consum', 0.0216, 'lps'),
	(626602, 132, '2015-01-01 01:06:10.000000', 'consum', 0.0285, 'lps'),
	(626603, 132, '2015-01-01 01:06:11.000000', 'consum', 0.0245, 'lps'),
	(626604, 132, '2015-01-01 01:06:12.000000', 'consum', 0.0239, 'lps'),
	(626605, 132, '2015-01-01 01:06:13.000000', 'consum', 0.0251, 'lps'),
	(626606, 132, '2015-01-01 01:06:14.000000', 'consum', 0.0248, 'lps'),
	(626607, 132, '2015-01-01 01:06:15.000000', 'consum', 0.0279, 'lps'),
	(626608, 132, '2015-01-01 01:06:16.000000', 'consum', 0.0280, 'lps'),
	(626609, 132, '2015-01-01 01:06:17.000000', 'consum', 0.0271, 'lps'),
	(626610, 132, '2015-01-01 01:06:18.000000', 'consum', 0.0224, 'lps'),
	(626611, 132, '2015-01-01 01:06:19.000000', 'consum', 0.0262, 'lps'),
	(626612, 132, '2015-01-01 01:06:20.000000', 'consum', 0.0265, 'lps'),
	(626613, 132, '2015-01-01 01:06:21.000000', 'consum', 0.0250, 'lps'),
	(626614, 132, '2015-01-01 01:06:22.000000', 'consum', 0.0244, 'lps'),
	(626615, 132, '2015-01-01 01:06:23.000000', 'consum', 0.0263, 'lps'),
	(626616, 132, '2015-01-01 01:06:24.000000', 'consum', 0.0210, 'lps'),
	(626617, 132, '2015-01-01 01:06:25.000000', 'consum', 0.0213, 'lps'),
	(626618, 132, '2015-01-01 01:06:26.000000', 'consum', 0.0226, 'lps'),
	(626619, 132, '2015-01-01 01:06:27.000000', 'consum', 0.0280, 'lps'),
	(626620, 132, '2015-01-01 01:06:28.000000', 'consum', 0.0271, 'lps'),
	(626621, 132, '2015-01-01 01:06:29.000000', 'consum', 0.0224, 'lps'),
	(626622, 132, '2015-01-01 01:06:30.000000', 'consum', 0.0261, 'lps'),
	(626623, 132, '2015-01-01 01:06:31.000000', 'consum', 0.0259, 'lps'),
	(626624, 132, '2015-01-01 01:06:32.000000', 'consum', 0.0225, 'lps'),
	(626625, 132, '2015-01-01 01:06:33.000000', 'consum', 0.0216, 'lps'),
	(626626, 132, '2015-01-01 01:06:34.000000', 'consum', 0.0276, 'lps'),
	(626627, 132, '2015-01-01 01:06:35.000000', 'consum', 0.0282, 'lps'),
	(626628, 132, '2015-01-01 01:06:36.000000', 'consum', 0.0210, 'lps'),
	(626629, 132, '2015-01-01 01:06:37.000000', 'consum', 0.0236, 'lps'),
	(626630, 132, '2015-01-01 01:06:38.000000', 'consum', 0.0260, 'lps'),
	(626631, 132, '2015-01-01 01:06:39.000000', 'consum', 0.0222, 'lps'),
	(626632, 132, '2015-01-01 01:06:40.000000', 'consum', 0.0284, 'lps'),
	(626633, 132, '2015-01-01 01:06:41.000000', 'consum', 0.0217, 'lps'),
	(626634, 132, '2015-01-01 01:06:42.000000', 'consum', 0.0267, 'lps'),
	(626635, 132, '2015-01-01 01:06:43.000000', 'consum', 0.0234, 'lps'),
	(626636, 132, '2015-01-01 01:06:44.000000', 'consum', 0.0238, 'lps'),
	(626637, 132, '2015-01-01 01:06:45.000000', 'consum', 0.0279, 'lps'),
	(626638, 132, '2015-01-01 01:06:46.000000', 'consum', 0.0231, 'lps'),
	(626639, 132, '2015-01-01 01:06:47.000000', 'consum', 0.0268, 'lps'),
	(626640, 132, '2015-01-01 01:06:48.000000', 'consum', 0.0277, 'lps'),
	(626641, 132, '2015-01-01 01:06:49.000000', 'consum', 0.0288, 'lps'),
	(626642, 132, '2015-01-01 01:06:50.000000', 'consum', 0.0238, 'lps'),
	(626643, 132, '2015-01-01 01:06:51.000000', 'consum', 0.0281, 'lps'),
	(626644, 132, '2015-01-01 01:06:52.000000', 'consum', 0.0237, 'lps'),
	(626645, 132, '2015-01-01 01:06:53.000000', 'consum', 0.0214, 'lps'),
	(626646, 132, '2015-01-01 01:06:54.000000', 'consum', 0.0230, 'lps'),
	(626647, 132, '2015-01-01 01:06:55.000000', 'consum', 0.0217, 'lps'),
	(626648, 132, '2015-01-01 01:06:56.000000', 'consum', 0.0265, 'lps'),
	(626649, 132, '2015-01-01 01:06:57.000000', 'consum', 0.0225, 'lps'),
	(626650, 132, '2015-01-01 01:06:58.000000', 'consum', 0.0281, 'lps'),
	(626651, 132, '2015-01-01 01:06:59.000000', 'consum', 0.0277, 'lps'),
	(626652, 132, '2015-01-01 01:07:00.000000', 'consum', 0.0252, 'lps'),
	(626653, 132, '2015-01-01 01:07:01.000000', 'consum', 0.0219, 'lps'),
	(626654, 132, '2015-01-01 01:07:02.000000', 'consum', 0.0213, 'lps'),
	(626655, 132, '2015-01-01 01:07:03.000000', 'consum', 0.0276, 'lps'),
	(626656, 132, '2015-01-01 01:07:04.000000', 'consum', 0.0210, 'lps'),
	(626657, 132, '2015-01-01 01:07:05.000000', 'consum', 0.0253, 'lps'),
	(626658, 132, '2015-01-01 01:07:06.000000', 'consum', 0.0266, 'lps'),
	(626659, 132, '2015-01-01 01:07:07.000000', 'consum', 0.0279, 'lps'),
	(626660, 132, '2015-01-01 01:07:08.000000', 'consum', 0.0225, 'lps'),
	(626661, 132, '2015-01-01 01:07:09.000000', 'consum', 0.0242, 'lps'),
	(626662, 132, '2015-01-01 01:07:10.000000', 'consum', 0.0242, 'lps'),
	(626663, 132, '2015-01-01 01:07:11.000000', 'consum', 0.0276, 'lps'),
	(626664, 132, '2015-01-01 01:07:12.000000', 'consum', 0.0284, 'lps'),
	(626665, 132, '2015-01-01 01:07:13.000000', 'consum', 0.0219, 'lps'),
	(626666, 132, '2015-01-01 01:07:14.000000', 'consum', 0.0276, 'lps'),
	(626667, 132, '2015-01-01 01:07:15.000000', 'consum', 0.0272, 'lps'),
	(626668, 132, '2015-01-01 01:07:16.000000', 'consum', 0.0241, 'lps'),
	(626669, 132, '2015-01-01 01:07:17.000000', 'consum', 0.0260, 'lps'),
	(626670, 132, '2015-01-01 01:07:18.000000', 'consum', 0.0285, 'lps'),
	(626671, 132, '2015-01-01 01:07:19.000000', 'consum', 0.0274, 'lps'),
	(626672, 132, '2015-01-01 01:07:20.000000', 'consum', 0.0226, 'lps'),
	(626673, 132, '2015-01-01 01:07:21.000000', 'consum', 0.0258, 'lps'),
	(626674, 132, '2015-01-01 01:07:22.000000', 'consum', 0.0241, 'lps'),
	(626675, 132, '2015-01-01 01:07:23.000000', 'consum', 0.0223, 'lps'),
	(626676, 132, '2015-01-01 01:07:24.000000', 'consum', 0.0262, 'lps'),
	(626677, 132, '2015-01-01 01:07:25.000000', 'consum', 0.0269, 'lps'),
	(626678, 132, '2015-01-01 01:07:26.000000', 'consum', 0.0267, 'lps'),
	(626679, 132, '2015-01-01 01:07:27.000000', 'consum', 0.0241, 'lps'),
	(626680, 132, '2015-01-01 01:07:28.000000', 'consum', 0.0275, 'lps'),
	(626681, 132, '2015-01-01 01:07:29.000000', 'consum', 0.0279, 'lps'),
	(626682, 132, '2015-01-01 01:07:30.000000', 'consum', 0.0278, 'lps'),
	(626683, 132, '2015-01-01 01:07:31.000000', 'consum', 0.0266, 'lps'),
	(626684, 132, '2015-01-01 01:07:32.000000', 'consum', 0.0283, 'lps'),
	(626685, 132, '2015-01-01 01:07:33.000000', 'consum', 0.0248, 'lps'),
	(626686, 132, '2015-01-01 01:07:34.000000', 'consum', 0.0262, 'lps'),
	(626687, 132, '2015-01-01 01:07:35.000000', 'consum', 0.0274, 'lps'),
	(626688, 132, '2015-01-01 01:07:36.000000', 'consum', 0.0211, 'lps'),
	(626689, 132, '2015-01-01 01:07:37.000000', 'consum', 0.0270, 'lps'),
	(626690, 132, '2015-01-01 01:07:38.000000', 'consum', 0.0262, 'lps'),
	(626691, 132, '2015-01-01 01:07:39.000000', 'consum', 0.0211, 'lps'),
	(626692, 132, '2015-01-01 01:07:40.000000', 'consum', 0.0220, 'lps'),
	(626693, 132, '2015-01-01 01:07:41.000000', 'consum', 0.0259, 'lps'),
	(626694, 132, '2015-01-01 01:07:42.000000', 'consum', 0.0265, 'lps'),
	(626695, 132, '2015-01-01 01:07:43.000000', 'consum', 0.0255, 'lps'),
	(626696, 132, '2015-01-01 01:07:44.000000', 'consum', 0.0270, 'lps'),
	(626697, 132, '2015-01-01 01:07:45.000000', 'consum', 0.0212, 'lps'),
	(626698, 132, '2015-01-01 01:07:46.000000', 'consum', 0.0287, 'lps'),
	(626699, 132, '2015-01-01 01:07:47.000000', 'consum', 0.0263, 'lps'),
	(626700, 132, '2015-01-01 01:07:48.000000', 'consum', 0.0245, 'lps'),
	(626701, 132, '2015-01-01 01:07:49.000000', 'consum', 0.0228, 'lps'),
	(626702, 132, '2015-01-01 01:07:50.000000', 'consum', 0.0274, 'lps'),
	(626703, 132, '2015-01-01 01:07:51.000000', 'consum', 0.0235, 'lps'),
	(626704, 132, '2015-01-01 01:07:52.000000', 'consum', 0.0226, 'lps'),
	(626705, 132, '2015-01-01 01:07:53.000000', 'consum', 0.0215, 'lps'),
	(626706, 132, '2015-01-01 01:07:54.000000', 'consum', 0.0268, 'lps'),
	(626707, 132, '2015-01-01 01:07:55.000000', 'consum', 0.0242, 'lps'),
	(626708, 132, '2015-01-01 01:07:56.000000', 'consum', 0.0280, 'lps'),
	(626709, 132, '2015-01-01 01:07:57.000000', 'consum', 0.0219, 'lps'),
	(626710, 132, '2015-01-01 01:07:58.000000', 'consum', 0.0290, 'lps'),
	(626711, 132, '2015-01-01 01:07:59.000000', 'consum', 0.0261, 'lps'),
	(626712, 132, '2015-01-01 01:08:00.000000', 'consum', 0.0223, 'lps'),
	(626713, 132, '2015-01-01 01:08:01.000000', 'consum', 0.0285, 'lps'),
	(626714, 132, '2015-01-01 01:08:02.000000', 'consum', 0.0222, 'lps'),
	(626715, 132, '2015-01-01 01:08:03.000000', 'consum', 0.0289, 'lps'),
	(626716, 132, '2015-01-01 01:08:04.000000', 'consum', 0.0246, 'lps'),
	(626717, 132, '2015-01-01 01:08:05.000000', 'consum', 0.0233, 'lps'),
	(626718, 132, '2015-01-01 01:08:06.000000', 'consum', 0.0219, 'lps'),
	(626719, 132, '2015-01-01 01:08:07.000000', 'consum', 0.0266, 'lps'),
	(626720, 132, '2015-01-01 01:08:08.000000', 'consum', 0.0222, 'lps'),
	(626721, 132, '2015-01-01 01:08:09.000000', 'consum', 0.0263, 'lps'),
	(626722, 132, '2015-01-01 01:08:10.000000', 'consum', 0.0280, 'lps'),
	(626723, 132, '2015-01-01 01:08:11.000000', 'consum', 0.0239, 'lps'),
	(626724, 132, '2015-01-01 01:08:12.000000', 'consum', 0.0228, 'lps'),
	(626725, 132, '2015-01-01 01:08:13.000000', 'consum', 0.0211, 'lps'),
	(626726, 132, '2015-01-01 01:08:14.000000', 'consum', 0.0245, 'lps'),
	(626727, 132, '2015-01-01 01:08:15.000000', 'consum', 0.0218, 'lps'),
	(626728, 132, '2015-01-01 01:08:16.000000', 'consum', 0.0228, 'lps'),
	(626729, 132, '2015-01-01 01:08:17.000000', 'consum', 0.0278, 'lps'),
	(626730, 132, '2015-01-01 01:08:18.000000', 'consum', 0.0253, 'lps'),
	(626731, 132, '2015-01-01 01:08:19.000000', 'consum', 0.0221, 'lps'),
	(626732, 132, '2015-01-01 01:08:20.000000', 'consum', 0.0218, 'lps'),
	(626733, 132, '2015-01-01 01:08:21.000000', 'consum', 0.0217, 'lps'),
	(626734, 132, '2015-01-01 01:08:22.000000', 'consum', 0.0224, 'lps'),
	(626735, 132, '2015-01-01 01:08:23.000000', 'consum', 0.0256, 'lps'),
	(626736, 132, '2015-01-01 01:08:24.000000', 'consum', 0.0237, 'lps'),
	(626737, 132, '2015-01-01 01:08:25.000000', 'consum', 0.0289, 'lps'),
	(626738, 132, '2015-01-01 01:08:26.000000', 'consum', 0.0281, 'lps'),
	(626739, 132, '2015-01-01 01:08:27.000000', 'consum', 0.0247, 'lps'),
	(626740, 132, '2015-01-01 01:08:28.000000', 'consum', 0.0262, 'lps'),
	(626741, 132, '2015-01-01 01:08:29.000000', 'consum', 0.0280, 'lps'),
	(626742, 132, '2015-01-01 01:08:30.000000', 'consum', 0.0243, 'lps'),
	(626743, 132, '2015-01-01 01:08:31.000000', 'consum', 0.0247, 'lps'),
	(626744, 132, '2015-01-01 01:08:32.000000', 'consum', 0.0216, 'lps'),
	(626745, 132, '2015-01-01 01:08:33.000000', 'consum', 0.0211, 'lps'),
	(626746, 132, '2015-01-01 01:08:34.000000', 'consum', 0.0279, 'lps'),
	(626747, 132, '2015-01-01 01:08:35.000000', 'consum', 0.0227, 'lps'),
	(626748, 132, '2015-01-01 01:08:36.000000', 'consum', 0.0252, 'lps'),
	(626749, 132, '2015-01-01 01:08:37.000000', 'consum', 0.0290, 'lps'),
	(626750, 132, '2015-01-01 01:08:38.000000', 'consum', 0.0239, 'lps'),
	(626751, 132, '2015-01-01 01:08:39.000000', 'consum', 0.0278, 'lps'),
	(626752, 132, '2015-01-01 01:08:40.000000', 'consum', 0.0220, 'lps'),
	(626753, 132, '2015-01-01 01:08:41.000000', 'consum', 0.0217, 'lps'),
	(626754, 132, '2015-01-01 01:08:42.000000', 'consum', 0.0217, 'lps'),
	(626755, 132, '2015-01-01 01:08:43.000000', 'consum', 0.0224, 'lps'),
	(626756, 132, '2015-01-01 01:08:44.000000', 'consum', 0.0258, 'lps'),
	(626757, 132, '2015-01-01 01:08:45.000000', 'consum', 0.0247, 'lps'),
	(626758, 132, '2015-01-01 01:08:46.000000', 'consum', 0.0252, 'lps'),
	(626759, 132, '2015-01-01 01:08:47.000000', 'consum', 0.0230, 'lps'),
	(626760, 132, '2015-01-01 01:08:48.000000', 'consum', 0.0263, 'lps'),
	(626761, 132, '2015-01-01 01:08:49.000000', 'consum', 0.0252, 'lps'),
	(626762, 132, '2015-01-01 01:08:50.000000', 'consum', 0.0265, 'lps'),
	(626763, 132, '2015-01-01 01:08:51.000000', 'consum', 0.0279, 'lps'),
	(626764, 132, '2015-01-01 01:08:52.000000', 'consum', 0.0226, 'lps'),
	(626765, 132, '2015-01-01 01:08:53.000000', 'consum', 0.0249, 'lps'),
	(626766, 132, '2015-01-01 01:08:54.000000', 'consum', 0.0273, 'lps'),
	(626767, 132, '2015-01-01 01:08:55.000000', 'consum', 0.0246, 'lps'),
	(626768, 132, '2015-01-01 01:08:56.000000', 'consum', 0.0286, 'lps'),
	(626769, 132, '2015-01-01 01:08:57.000000', 'consum', 0.0237, 'lps'),
	(626770, 132, '2015-01-01 01:08:58.000000', 'consum', 0.0279, 'lps'),
	(626771, 132, '2015-01-01 01:08:59.000000', 'consum', 0.0233, 'lps'),
	(626772, 132, '2015-01-01 01:09:00.000000', 'consum', 0.0279, 'lps'),
	(626773, 132, '2015-01-01 01:09:01.000000', 'consum', 0.0245, 'lps'),
	(626774, 132, '2015-01-01 01:09:02.000000', 'consum', 0.0258, 'lps'),
	(626775, 132, '2015-01-01 01:09:03.000000', 'consum', 0.0263, 'lps'),
	(626776, 132, '2015-01-01 01:09:04.000000', 'consum', 0.0253, 'lps'),
	(626777, 132, '2015-01-01 01:09:05.000000', 'consum', 0.0264, 'lps'),
	(626778, 132, '2015-01-01 01:09:06.000000', 'consum', 0.0270, 'lps'),
	(626779, 132, '2015-01-01 01:09:07.000000', 'consum', 0.0270, 'lps'),
	(626780, 132, '2015-01-01 01:09:08.000000', 'consum', 0.0249, 'lps'),
	(626781, 132, '2015-01-01 01:09:09.000000', 'consum', 0.0227, 'lps'),
	(626782, 132, '2015-01-01 01:09:10.000000', 'consum', 0.0257, 'lps'),
	(626783, 132, '2015-01-01 01:09:11.000000', 'consum', 0.0233, 'lps'),
	(626784, 132, '2015-01-01 01:09:12.000000', 'consum', 0.0265, 'lps'),
	(626785, 132, '2015-01-01 01:09:13.000000', 'consum', 0.0253, 'lps'),
	(626786, 132, '2015-01-01 01:09:14.000000', 'consum', 0.0263, 'lps'),
	(626787, 132, '2015-01-01 01:09:15.000000', 'consum', 0.0266, 'lps'),
	(626788, 132, '2015-01-01 01:09:16.000000', 'consum', 0.0251, 'lps'),
	(626789, 132, '2015-01-01 01:09:17.000000', 'consum', 0.0246, 'lps'),
	(626790, 132, '2015-01-01 01:09:18.000000', 'consum', 0.0269, 'lps'),
	(626791, 132, '2015-01-01 01:09:19.000000', 'consum', 0.0233, 'lps'),
	(626792, 132, '2015-01-01 01:09:20.000000', 'consum', 0.0232, 'lps'),
	(626793, 132, '2015-01-01 01:09:21.000000', 'consum', 0.0252, 'lps'),
	(626794, 132, '2015-01-01 01:09:22.000000', 'consum', 0.0271, 'lps'),
	(626795, 132, '2015-01-01 01:09:23.000000', 'consum', 0.0227, 'lps'),
	(626796, 132, '2015-01-01 01:09:24.000000', 'consum', 0.0275, 'lps'),
	(626797, 132, '2015-01-01 01:09:25.000000', 'consum', 0.0242, 'lps'),
	(626798, 132, '2015-01-01 01:09:26.000000', 'consum', 0.0258, 'lps'),
	(626799, 132, '2015-01-01 01:09:27.000000', 'consum', 0.0270, 'lps'),
	(626800, 132, '2015-01-01 01:09:28.000000', 'consum', 0.0288, 'lps'),
	(626801, 132, '2015-01-01 01:09:29.000000', 'consum', 0.0259, 'lps'),
	(626802, 132, '2015-01-01 01:09:30.000000', 'consum', 0.0223, 'lps'),
	(626803, 132, '2015-01-01 01:09:31.000000', 'consum', 0.0287, 'lps'),
	(626804, 132, '2015-01-01 01:09:32.000000', 'consum', 0.0235, 'lps'),
	(626805, 132, '2015-01-01 01:09:33.000000', 'consum', 0.0267, 'lps'),
	(626806, 132, '2015-01-01 01:09:34.000000', 'consum', 0.0256, 'lps'),
	(626807, 132, '2015-01-01 01:09:35.000000', 'consum', 0.0272, 'lps'),
	(626808, 132, '2015-01-01 01:09:36.000000', 'consum', 0.0219, 'lps'),
	(626809, 132, '2015-01-01 01:09:37.000000', 'consum', 0.0232, 'lps'),
	(626810, 132, '2015-01-01 01:09:38.000000', 'consum', 0.0212, 'lps'),
	(626811, 132, '2015-01-01 01:09:39.000000', 'consum', 0.0237, 'lps'),
	(626812, 132, '2015-01-01 01:09:40.000000', 'consum', 0.0258, 'lps'),
	(626813, 132, '2015-01-01 01:09:41.000000', 'consum', 0.0290, 'lps'),
	(626814, 132, '2015-01-01 01:09:42.000000', 'consum', 0.0223, 'lps'),
	(626815, 132, '2015-01-01 01:09:43.000000', 'consum', 0.0277, 'lps'),
	(626816, 132, '2015-01-01 01:09:44.000000', 'consum', 0.0262, 'lps'),
	(626817, 132, '2015-01-01 01:09:45.000000', 'consum', 0.0273, 'lps'),
	(626818, 132, '2015-01-01 01:09:46.000000', 'consum', 0.0288, 'lps'),
	(626819, 132, '2015-01-01 01:09:47.000000', 'consum', 0.0247, 'lps'),
	(626820, 132, '2015-01-01 01:09:48.000000', 'consum', 0.0244, 'lps'),
	(626821, 132, '2015-01-01 01:09:49.000000', 'consum', 0.0268, 'lps'),
	(626822, 132, '2015-01-01 01:09:50.000000', 'consum', 0.0237, 'lps'),
	(626823, 132, '2015-01-01 01:09:51.000000', 'consum', 0.0254, 'lps'),
	(626824, 132, '2015-01-01 01:09:52.000000', 'consum', 0.0267, 'lps'),
	(626825, 132, '2015-01-01 01:09:53.000000', 'consum', 0.0283, 'lps'),
	(626826, 132, '2015-01-01 01:09:54.000000', 'consum', 0.0242, 'lps'),
	(626827, 132, '2015-01-01 01:09:55.000000', 'consum', 0.0231, 'lps'),
	(626828, 132, '2015-01-01 01:09:56.000000', 'consum', 0.0220, 'lps'),
	(626829, 132, '2015-01-01 01:09:57.000000', 'consum', 0.0279, 'lps'),
	(626830, 132, '2015-01-01 01:09:58.000000', 'consum', 0.0284, 'lps'),
	(626831, 132, '2015-01-01 01:09:59.000000', 'consum', 0.0290, 'lps'),
	(626832, 132, '2015-01-01 01:10:00.000000', 'consum', 0.0227, 'lps'),
	(626833, 132, '2015-01-01 01:10:01.000000', 'consum', 0.0216, 'lps'),
	(626834, 132, '2015-01-01 01:10:02.000000', 'consum', 0.0271, 'lps'),
	(626835, 132, '2015-01-01 01:10:03.000000', 'consum', 0.0257, 'lps'),
	(626836, 132, '2015-01-01 01:10:04.000000', 'consum', 0.0262, 'lps'),
	(626837, 132, '2015-01-01 01:10:05.000000', 'consum', 0.0247, 'lps'),
	(626838, 132, '2015-01-01 01:10:06.000000', 'consum', 0.0240, 'lps'),
	(626839, 132, '2015-01-01 01:10:07.000000', 'consum', 0.0249, 'lps'),
	(626840, 132, '2015-01-01 01:10:08.000000', 'consum', 0.0234, 'lps'),
	(626841, 132, '2015-01-01 01:10:09.000000', 'consum', 0.0216, 'lps'),
	(626842, 132, '2015-01-01 01:10:10.000000', 'consum', 0.0247, 'lps'),
	(626843, 132, '2015-01-01 01:10:11.000000', 'consum', 0.0217, 'lps'),
	(626844, 132, '2015-01-01 01:10:12.000000', 'consum', 0.0213, 'lps'),
	(626845, 132, '2015-01-01 01:10:13.000000', 'consum', 0.0287, 'lps'),
	(626846, 132, '2015-01-01 01:10:14.000000', 'consum', 0.0261, 'lps'),
	(626847, 132, '2015-01-01 01:10:15.000000', 'consum', 0.0236, 'lps'),
	(626848, 132, '2015-01-01 01:10:16.000000', 'consum', 0.0270, 'lps'),
	(626849, 132, '2015-01-01 01:10:17.000000', 'consum', 0.0269, 'lps'),
	(626850, 132, '2015-01-01 01:10:18.000000', 'consum', 0.0243, 'lps'),
	(626851, 132, '2015-01-01 01:10:19.000000', 'consum', 0.0279, 'lps'),
	(626852, 132, '2015-01-01 01:10:20.000000', 'consum', 0.0214, 'lps'),
	(626853, 132, '2015-01-01 01:10:21.000000', 'consum', 0.0269, 'lps'),
	(626854, 132, '2015-01-01 01:10:22.000000', 'consum', 0.0248, 'lps'),
	(626855, 132, '2015-01-01 01:10:23.000000', 'consum', 0.0222, 'lps'),
	(626856, 132, '2015-01-01 01:10:24.000000', 'consum', 0.0241, 'lps'),
	(626857, 132, '2015-01-01 01:10:25.000000', 'consum', 0.0246, 'lps'),
	(626858, 132, '2015-01-01 01:10:26.000000', 'consum', 0.0217, 'lps'),
	(626859, 132, '2015-01-01 01:10:27.000000', 'consum', 0.0219, 'lps'),
	(626860, 132, '2015-01-01 01:10:28.000000', 'consum', 0.0234, 'lps'),
	(626861, 132, '2015-01-01 01:10:29.000000', 'consum', 0.0224, 'lps'),
	(626862, 132, '2015-01-01 01:10:30.000000', 'consum', 0.0289, 'lps'),
	(626863, 132, '2015-01-01 01:10:31.000000', 'consum', 0.0238, 'lps'),
	(626864, 132, '2015-01-01 01:10:32.000000', 'consum', 0.0278, 'lps'),
	(626865, 132, '2015-01-01 01:10:33.000000', 'consum', 0.0223, 'lps'),
	(626866, 132, '2015-01-01 01:10:34.000000', 'consum', 0.0233, 'lps'),
	(626867, 132, '2015-01-01 01:10:35.000000', 'consum', 0.0285, 'lps'),
	(626868, 132, '2015-01-01 01:10:36.000000', 'consum', 0.0273, 'lps'),
	(626869, 132, '2015-01-01 01:10:37.000000', 'consum', 0.0219, 'lps'),
	(626870, 132, '2015-01-01 01:10:38.000000', 'consum', 0.0231, 'lps'),
	(626871, 132, '2015-01-01 01:10:39.000000', 'consum', 0.0288, 'lps'),
	(626872, 132, '2015-01-01 01:10:40.000000', 'consum', 0.0211, 'lps'),
	(626873, 132, '2015-01-01 01:10:41.000000', 'consum', 0.0227, 'lps'),
	(626874, 132, '2015-01-01 01:10:42.000000', 'consum', 0.0210, 'lps'),
	(626875, 132, '2015-01-01 01:10:43.000000', 'consum', 0.0240, 'lps'),
	(626876, 132, '2015-01-01 01:10:44.000000', 'consum', 0.0278, 'lps'),
	(626877, 132, '2015-01-01 01:10:45.000000', 'consum', 0.0220, 'lps'),
	(626878, 132, '2015-01-01 01:10:46.000000', 'consum', 0.0216, 'lps'),
	(626879, 132, '2015-01-01 01:10:47.000000', 'consum', 0.0213, 'lps'),
	(626880, 132, '2015-01-01 01:10:48.000000', 'consum', 0.0287, 'lps'),
	(626881, 132, '2015-01-01 01:10:49.000000', 'consum', 0.0263, 'lps'),
	(626882, 132, '2015-01-01 01:10:50.000000', 'consum', 0.0244, 'lps'),
	(626883, 132, '2015-01-01 01:10:51.000000', 'consum', 0.0222, 'lps'),
	(626884, 132, '2015-01-01 01:10:52.000000', 'consum', 0.0248, 'lps'),
	(626885, 132, '2015-01-01 01:10:53.000000', 'consum', 0.0286, 'lps'),
	(626886, 132, '2015-01-01 01:10:54.000000', 'consum', 0.0232, 'lps'),
	(626887, 132, '2015-01-01 01:10:55.000000', 'consum', 0.0256, 'lps'),
	(626888, 132, '2015-01-01 01:10:56.000000', 'consum', 0.0210, 'lps'),
	(626889, 132, '2015-01-01 01:10:57.000000', 'consum', 0.0234, 'lps'),
	(626890, 132, '2015-01-01 01:10:58.000000', 'consum', 0.0252, 'lps'),
	(626891, 132, '2015-01-01 01:10:59.000000', 'consum', 0.0267, 'lps'),
	(626892, 132, '2015-01-01 01:11:00.000000', 'consum', 0.0289, 'lps'),
	(626893, 132, '2015-01-01 01:11:01.000000', 'consum', 0.0272, 'lps'),
	(626894, 132, '2015-01-01 01:11:02.000000', 'consum', 0.0282, 'lps'),
	(626895, 132, '2015-01-01 01:11:03.000000', 'consum', 0.0224, 'lps'),
	(626896, 132, '2015-01-01 01:11:04.000000', 'consum', 0.0228, 'lps'),
	(626897, 132, '2015-01-01 01:11:05.000000', 'consum', 0.0259, 'lps'),
	(626898, 132, '2015-01-01 01:11:06.000000', 'consum', 0.0236, 'lps'),
	(626899, 132, '2015-01-01 01:11:07.000000', 'consum', 0.0277, 'lps'),
	(626900, 132, '2015-01-01 01:11:08.000000', 'consum', 0.0223, 'lps'),
	(626901, 132, '2015-01-01 01:11:09.000000', 'consum', 0.0237, 'lps'),
	(626902, 132, '2015-01-01 01:11:10.000000', 'consum', 0.0226, 'lps'),
	(626903, 132, '2015-01-01 01:11:11.000000', 'consum', 0.0290, 'lps'),
	(626904, 132, '2015-01-01 01:11:12.000000', 'consum', 0.0239, 'lps'),
	(626905, 132, '2015-01-01 01:11:13.000000', 'consum', 0.0276, 'lps'),
	(626906, 132, '2015-01-01 01:11:14.000000', 'consum', 0.0210, 'lps'),
	(626907, 132, '2015-01-01 01:11:15.000000', 'consum', 0.0256, 'lps'),
	(626908, 132, '2015-01-01 01:11:16.000000', 'consum', 0.0278, 'lps'),
	(626909, 132, '2015-01-01 01:11:17.000000', 'consum', 0.0251, 'lps'),
	(626910, 132, '2015-01-01 01:11:18.000000', 'consum', 0.0211, 'lps'),
	(626911, 132, '2015-01-01 01:11:19.000000', 'consum', 0.0253, 'lps'),
	(626912, 132, '2015-01-01 01:11:20.000000', 'consum', 0.0263, 'lps'),
	(626913, 132, '2015-01-01 01:11:21.000000', 'consum', 0.0266, 'lps'),
	(626914, 132, '2015-01-01 01:11:22.000000', 'consum', 0.0251, 'lps'),
	(626915, 132, '2015-01-01 01:11:23.000000', 'consum', 0.0246, 'lps'),
	(626916, 132, '2015-01-01 01:11:24.000000', 'consum', 0.0266, 'lps'),
	(626917, 132, '2015-01-01 01:11:25.000000', 'consum', 0.0222, 'lps'),
	(626918, 132, '2015-01-01 01:11:26.000000', 'consum', 0.0264, 'lps'),
	(626919, 132, '2015-01-01 01:11:27.000000', 'consum', 0.0283, 'lps'),
	(626920, 132, '2015-01-01 01:11:28.000000', 'consum', 0.0253, 'lps'),
	(626921, 132, '2015-01-01 01:11:29.000000', 'consum', 0.0288, 'lps'),
	(626922, 132, '2015-01-01 01:11:30.000000', 'consum', 0.0228, 'lps'),
	(626923, 132, '2015-01-01 01:11:31.000000', 'consum', 0.0230, 'lps'),
	(626924, 132, '2015-01-01 01:11:32.000000', 'consum', 0.0253, 'lps'),
	(626925, 132, '2015-01-01 01:11:33.000000', 'consum', 0.0288, 'lps'),
	(626926, 132, '2015-01-01 01:11:34.000000', 'consum', 0.0226, 'lps'),
	(626927, 132, '2015-01-01 01:11:35.000000', 'consum', 0.0217, 'lps'),
	(626928, 132, '2015-01-01 01:11:36.000000', 'consum', 0.0281, 'lps'),
	(626929, 132, '2015-01-01 01:11:37.000000', 'consum', 0.0220, 'lps'),
	(626930, 132, '2015-01-01 01:11:38.000000', 'consum', 0.0211, 'lps'),
	(626931, 132, '2015-01-01 01:11:39.000000', 'consum', 0.0264, 'lps'),
	(626932, 132, '2015-01-01 01:11:40.000000', 'consum', 0.0237, 'lps'),
	(626933, 132, '2015-01-01 01:11:41.000000', 'consum', 0.0265, 'lps'),
	(626934, 132, '2015-01-01 01:11:42.000000', 'consum', 0.0240, 'lps'),
	(626935, 132, '2015-01-01 01:11:43.000000', 'consum', 0.0275, 'lps'),
	(626936, 132, '2015-01-01 01:11:44.000000', 'consum', 0.0287, 'lps'),
	(626937, 132, '2015-01-01 01:11:45.000000', 'consum', 0.0237, 'lps'),
	(626938, 132, '2015-01-01 01:11:46.000000', 'consum', 0.0276, 'lps'),
	(626939, 132, '2015-01-01 01:11:47.000000', 'consum', 0.0217, 'lps'),
	(626940, 132, '2015-01-01 01:11:48.000000', 'consum', 0.0290, 'lps'),
	(626941, 132, '2015-01-01 01:11:49.000000', 'consum', 0.0267, 'lps'),
	(626942, 132, '2015-01-01 01:11:50.000000', 'consum', 0.0253, 'lps'),
	(626943, 132, '2015-01-01 01:11:51.000000', 'consum', 0.0255, 'lps'),
	(626944, 132, '2015-01-01 01:11:52.000000', 'consum', 0.0227, 'lps'),
	(626945, 132, '2015-01-01 01:11:53.000000', 'consum', 0.0242, 'lps'),
	(626946, 132, '2015-01-01 01:11:54.000000', 'consum', 0.0238, 'lps'),
	(626947, 132, '2015-01-01 01:11:55.000000', 'consum', 0.0256, 'lps'),
	(626948, 132, '2015-01-01 01:11:56.000000', 'consum', 0.0274, 'lps'),
	(626949, 132, '2015-01-01 01:11:57.000000', 'consum', 0.0232, 'lps'),
	(626950, 132, '2015-01-01 01:11:58.000000', 'consum', 0.0289, 'lps'),
	(626951, 132, '2015-01-01 01:11:59.000000', 'consum', 0.0215, 'lps'),
	(626952, 132, '2015-01-01 01:12:00.000000', 'consum', 0.0240, 'lps'),
	(626953, 132, '2015-01-01 01:12:01.000000', 'consum', 0.0267, 'lps'),
	(626954, 132, '2015-01-01 01:12:02.000000', 'consum', 0.0241, 'lps'),
	(626955, 132, '2015-01-01 01:12:03.000000', 'consum', 0.0278, 'lps'),
	(626956, 132, '2015-01-01 01:12:04.000000', 'consum', 0.0216, 'lps'),
	(626957, 132, '2015-01-01 01:12:05.000000', 'consum', 0.0276, 'lps'),
	(626958, 132, '2015-01-01 01:12:06.000000', 'consum', 0.0281, 'lps'),
	(626959, 132, '2015-01-01 01:12:07.000000', 'consum', 0.0286, 'lps'),
	(626960, 132, '2015-01-01 01:12:08.000000', 'consum', 0.0214, 'lps'),
	(626961, 132, '2015-01-01 01:12:09.000000', 'consum', 0.0245, 'lps'),
	(626962, 132, '2015-01-01 01:12:10.000000', 'consum', 0.0215, 'lps'),
	(626963, 132, '2015-01-01 01:12:11.000000', 'consum', 0.0289, 'lps'),
	(626964, 132, '2015-01-01 01:12:12.000000', 'consum', 0.0270, 'lps'),
	(626965, 132, '2015-01-01 01:12:13.000000', 'consum', 0.0271, 'lps'),
	(626966, 132, '2015-01-01 01:12:14.000000', 'consum', 0.0255, 'lps'),
	(626967, 132, '2015-01-01 01:12:15.000000', 'consum', 0.0254, 'lps'),
	(626968, 132, '2015-01-01 01:12:16.000000', 'consum', 0.0215, 'lps'),
	(626969, 132, '2015-01-01 01:12:17.000000', 'consum', 0.0264, 'lps'),
	(626970, 132, '2015-01-01 01:12:18.000000', 'consum', 0.0221, 'lps'),
	(626971, 132, '2015-01-01 01:12:19.000000', 'consum', 0.0267, 'lps'),
	(626972, 132, '2015-01-01 01:12:20.000000', 'consum', 0.0218, 'lps'),
	(626973, 132, '2015-01-01 01:12:21.000000', 'consum', 0.0243, 'lps'),
	(626974, 132, '2015-01-01 01:12:22.000000', 'consum', 0.0271, 'lps'),
	(626975, 132, '2015-01-01 01:12:23.000000', 'consum', 0.0253, 'lps'),
	(626976, 132, '2015-01-01 01:12:24.000000', 'consum', 0.0244, 'lps'),
	(626977, 132, '2015-01-01 01:12:25.000000', 'consum', 0.0251, 'lps'),
	(626978, 132, '2015-01-01 01:12:26.000000', 'consum', 0.0233, 'lps'),
	(626979, 132, '2015-01-01 01:12:27.000000', 'consum', 0.0282, 'lps'),
	(626980, 132, '2015-01-01 01:12:28.000000', 'consum', 0.0260, 'lps'),
	(626981, 132, '2015-01-01 01:12:29.000000', 'consum', 0.0244, 'lps'),
	(626982, 132, '2015-01-01 01:12:30.000000', 'consum', 0.0230, 'lps'),
	(626983, 132, '2015-01-01 01:12:31.000000', 'consum', 0.0290, 'lps'),
	(626984, 132, '2015-01-01 01:12:32.000000', 'consum', 0.0225, 'lps'),
	(626985, 132, '2015-01-01 01:12:33.000000', 'consum', 0.0210, 'lps'),
	(626986, 132, '2015-01-01 01:12:34.000000', 'consum', 0.0245, 'lps'),
	(626987, 132, '2015-01-01 01:12:35.000000', 'consum', 0.0222, 'lps'),
	(626988, 132, '2015-01-01 01:12:36.000000', 'consum', 0.0249, 'lps'),
	(626989, 132, '2015-01-01 01:12:37.000000', 'consum', 0.0289, 'lps'),
	(626990, 132, '2015-01-01 01:12:38.000000', 'consum', 0.0243, 'lps'),
	(626991, 132, '2015-01-01 01:12:39.000000', 'consum', 0.0221, 'lps'),
	(626992, 132, '2015-01-01 01:12:40.000000', 'consum', 0.0247, 'lps'),
	(626993, 132, '2015-01-01 01:12:41.000000', 'consum', 0.0280, 'lps'),
	(626994, 132, '2015-01-01 01:12:42.000000', 'consum', 0.0287, 'lps'),
	(626995, 132, '2015-01-01 01:12:43.000000', 'consum', 0.0226, 'lps'),
	(626996, 132, '2015-01-01 01:12:44.000000', 'consum', 0.0220, 'lps'),
	(626997, 132, '2015-01-01 01:12:45.000000', 'consum', 0.0214, 'lps'),
	(626998, 132, '2015-01-01 01:12:46.000000', 'consum', 0.0283, 'lps'),
	(626999, 132, '2015-01-01 01:12:47.000000', 'consum', 0.0236, 'lps'),
	(627000, 132, '2015-01-01 01:12:48.000000', 'consum', 0.0286, 'lps'),
	(627001, 132, '2015-01-01 01:12:49.000000', 'consum', 0.0268, 'lps'),
	(627002, 132, '2015-01-01 01:12:50.000000', 'consum', 0.0273, 'lps'),
	(627003, 132, '2015-01-01 01:12:51.000000', 'consum', 0.0270, 'lps'),
	(627004, 132, '2015-01-01 01:12:52.000000', 'consum', 0.0240, 'lps'),
	(627005, 132, '2015-01-01 01:12:53.000000', 'consum', 0.0262, 'lps'),
	(627006, 132, '2015-01-01 01:12:54.000000', 'consum', 0.0219, 'lps'),
	(627007, 132, '2015-01-01 01:12:55.000000', 'consum', 0.0262, 'lps'),
	(627008, 132, '2015-01-01 01:12:56.000000', 'consum', 0.0282, 'lps'),
	(627009, 132, '2015-01-01 01:12:57.000000', 'consum', 0.0250, 'lps'),
	(627010, 132, '2015-01-01 01:12:58.000000', 'consum', 0.0278, 'lps'),
	(627011, 132, '2015-01-01 01:12:59.000000', 'consum', 0.0266, 'lps'),
	(627012, 132, '2015-01-01 01:13:00.000000', 'consum', 0.0286, 'lps'),
	(627013, 132, '2015-01-01 01:13:01.000000', 'consum', 0.0262, 'lps'),
	(627014, 132, '2015-01-01 01:13:02.000000', 'consum', 0.0242, 'lps'),
	(627015, 132, '2015-01-01 01:13:03.000000', 'consum', 0.0217, 'lps'),
	(627016, 132, '2015-01-01 01:13:04.000000', 'consum', 0.0227, 'lps'),
	(627017, 132, '2015-01-01 01:13:05.000000', 'consum', 0.0277, 'lps'),
	(627018, 132, '2015-01-01 01:13:06.000000', 'consum', 0.0251, 'lps'),
	(627019, 132, '2015-01-01 01:13:07.000000', 'consum', 0.0213, 'lps'),
	(627020, 132, '2015-01-01 01:13:08.000000', 'consum', 0.0265, 'lps'),
	(627021, 132, '2015-01-01 01:13:09.000000', 'consum', 0.0236, 'lps'),
	(627022, 132, '2015-01-01 01:13:10.000000', 'consum', 0.0254, 'lps'),
	(627023, 132, '2015-01-01 01:13:11.000000', 'consum', 0.0271, 'lps'),
	(627024, 132, '2015-01-01 01:13:12.000000', 'consum', 0.0222, 'lps'),
	(627025, 132, '2015-01-01 01:13:13.000000', 'consum', 0.0250, 'lps'),
	(627026, 132, '2015-01-01 01:13:14.000000', 'consum', 0.0211, 'lps'),
	(627027, 132, '2015-01-01 01:13:15.000000', 'consum', 0.0260, 'lps'),
	(627028, 132, '2015-01-01 01:13:16.000000', 'consum', 0.0212, 'lps'),
	(627029, 132, '2015-01-01 01:13:17.000000', 'consum', 0.0232, 'lps'),
	(627030, 132, '2015-01-01 01:13:18.000000', 'consum', 0.0233, 'lps'),
	(627031, 132, '2015-01-01 01:13:19.000000', 'consum', 0.0260, 'lps'),
	(627032, 132, '2015-01-01 01:13:20.000000', 'consum', 0.0229, 'lps'),
	(627033, 132, '2015-01-01 01:13:21.000000', 'consum', 0.0236, 'lps'),
	(627034, 132, '2015-01-01 01:13:22.000000', 'consum', 0.0283, 'lps'),
	(627035, 132, '2015-01-01 01:13:23.000000', 'consum', 0.0255, 'lps'),
	(627036, 132, '2015-01-01 01:13:24.000000', 'consum', 0.0216, 'lps'),
	(627037, 132, '2015-01-01 01:13:25.000000', 'consum', 0.0270, 'lps'),
	(627038, 132, '2015-01-01 01:13:26.000000', 'consum', 0.0248, 'lps'),
	(627039, 132, '2015-01-01 01:13:27.000000', 'consum', 0.0220, 'lps'),
	(627040, 132, '2015-01-01 01:13:28.000000', 'consum', 0.0228, 'lps'),
	(627041, 132, '2015-01-01 01:13:29.000000', 'consum', 0.0270, 'lps'),
	(627042, 132, '2015-01-01 01:13:30.000000', 'consum', 0.0215, 'lps'),
	(627043, 132, '2015-01-01 01:13:31.000000', 'consum', 0.0218, 'lps'),
	(627044, 132, '2015-01-01 01:13:32.000000', 'consum', 0.0234, 'lps'),
	(627045, 132, '2015-01-01 01:13:33.000000', 'consum', 0.0225, 'lps'),
	(627046, 132, '2015-01-01 01:13:34.000000', 'consum', 0.0214, 'lps'),
	(627047, 132, '2015-01-01 01:13:35.000000', 'consum', 0.0265, 'lps'),
	(627048, 132, '2015-01-01 01:13:36.000000', 'consum', 0.0233, 'lps'),
	(627049, 132, '2015-01-01 01:13:37.000000', 'consum', 0.0241, 'lps'),
	(627050, 132, '2015-01-01 01:13:38.000000', 'consum', 0.0214, 'lps'),
	(627051, 132, '2015-01-01 01:13:39.000000', 'consum', 0.0218, 'lps'),
	(627052, 132, '2015-01-01 01:13:40.000000', 'consum', 0.0238, 'lps'),
	(627053, 132, '2015-01-01 01:13:41.000000', 'consum', 0.0246, 'lps'),
	(627054, 132, '2015-01-01 01:13:42.000000', 'consum', 0.0226, 'lps'),
	(627055, 132, '2015-01-01 01:13:43.000000', 'consum', 0.0265, 'lps'),
	(627056, 132, '2015-01-01 01:13:44.000000', 'consum', 0.0276, 'lps'),
	(627057, 132, '2015-01-01 01:13:45.000000', 'consum', 0.0211, 'lps'),
	(627058, 132, '2015-01-01 01:13:46.000000', 'consum', 0.0262, 'lps'),
	(627059, 132, '2015-01-01 01:13:47.000000', 'consum', 0.0225, 'lps'),
	(627060, 132, '2015-01-01 01:13:48.000000', 'consum', 0.0212, 'lps'),
	(627061, 132, '2015-01-01 01:13:49.000000', 'consum', 0.0254, 'lps'),
	(627062, 132, '2015-01-01 01:13:50.000000', 'consum', 0.0262, 'lps'),
	(627063, 132, '2015-01-01 01:13:51.000000', 'consum', 0.0260, 'lps'),
	(627064, 132, '2015-01-01 01:13:52.000000', 'consum', 0.0224, 'lps'),
	(627065, 132, '2015-01-01 01:13:53.000000', 'consum', 0.0210, 'lps'),
	(627066, 132, '2015-01-01 01:13:54.000000', 'consum', 0.0249, 'lps'),
	(627067, 132, '2015-01-01 01:13:55.000000', 'consum', 0.0244, 'lps'),
	(627068, 132, '2015-01-01 01:13:56.000000', 'consum', 0.0265, 'lps'),
	(627069, 132, '2015-01-01 01:13:57.000000', 'consum', 0.0219, 'lps'),
	(627070, 132, '2015-01-01 01:13:58.000000', 'consum', 0.0253, 'lps'),
	(627071, 132, '2015-01-01 01:13:59.000000', 'consum', 0.0236, 'lps'),
	(627072, 132, '2015-01-01 01:14:00.000000', 'consum', 0.0211, 'lps'),
	(627073, 132, '2015-01-01 01:14:01.000000', 'consum', 0.0219, 'lps'),
	(627074, 132, '2015-01-01 01:14:02.000000', 'consum', 0.0253, 'lps'),
	(627075, 132, '2015-01-01 01:14:03.000000', 'consum', 0.0238, 'lps'),
	(627076, 132, '2015-01-01 01:14:04.000000', 'consum', 0.0220, 'lps'),
	(627077, 132, '2015-01-01 01:14:05.000000', 'consum', 0.0258, 'lps'),
	(627078, 132, '2015-01-01 01:14:06.000000', 'consum', 0.0258, 'lps'),
	(627079, 132, '2015-01-01 01:14:07.000000', 'consum', 0.0225, 'lps'),
	(627080, 132, '2015-01-01 01:14:08.000000', 'consum', 0.0224, 'lps'),
	(627081, 132, '2015-01-01 01:14:09.000000', 'consum', 0.0237, 'lps'),
	(627082, 132, '2015-01-01 01:14:10.000000', 'consum', 0.0219, 'lps'),
	(627083, 132, '2015-01-01 01:14:11.000000', 'consum', 0.0258, 'lps'),
	(627084, 132, '2015-01-01 01:14:12.000000', 'consum', 0.0259, 'lps'),
	(627085, 132, '2015-01-01 01:14:13.000000', 'consum', 0.0231, 'lps'),
	(627086, 132, '2015-01-01 01:14:14.000000', 'consum', 0.0250, 'lps'),
	(627087, 132, '2015-01-01 01:14:15.000000', 'consum', 0.0265, 'lps'),
	(627088, 132, '2015-01-01 01:14:16.000000', 'consum', 0.0285, 'lps'),
	(627089, 132, '2015-01-01 01:14:17.000000', 'consum', 0.0260, 'lps'),
	(627090, 132, '2015-01-01 01:14:18.000000', 'consum', 0.0234, 'lps'),
	(627091, 132, '2015-01-01 01:14:19.000000', 'consum', 0.0261, 'lps'),
	(627092, 132, '2015-01-01 01:14:20.000000', 'consum', 0.0234, 'lps'),
	(627093, 132, '2015-01-01 01:14:21.000000', 'consum', 0.0257, 'lps'),
	(627094, 132, '2015-01-01 01:14:22.000000', 'consum', 0.0213, 'lps'),
	(627095, 132, '2015-01-01 01:14:23.000000', 'consum', 0.0245, 'lps'),
	(627096, 132, '2015-01-01 01:14:24.000000', 'consum', 0.0214, 'lps'),
	(627097, 132, '2015-01-01 01:14:25.000000', 'consum', 0.0286, 'lps'),
	(627098, 132, '2015-01-01 01:14:26.000000', 'consum', 0.0257, 'lps'),
	(627099, 132, '2015-01-01 01:14:27.000000', 'consum', 0.0215, 'lps'),
	(627100, 132, '2015-01-01 01:14:28.000000', 'consum', 0.0258, 'lps'),
	(627101, 132, '2015-01-01 01:14:29.000000', 'consum', 0.0274, 'lps'),
	(627102, 132, '2015-01-01 01:14:30.000000', 'consum', 0.0225, 'lps'),
	(627103, 132, '2015-01-01 01:14:31.000000', 'consum', 0.0257, 'lps'),
	(627104, 132, '2015-01-01 01:14:32.000000', 'consum', 0.0235, 'lps'),
	(627105, 132, '2015-01-01 01:14:33.000000', 'consum', 0.0277, 'lps'),
	(627106, 132, '2015-01-01 01:14:34.000000', 'consum', 0.0228, 'lps'),
	(627107, 132, '2015-01-01 01:14:35.000000', 'consum', 0.0262, 'lps'),
	(627108, 132, '2015-01-01 01:14:36.000000', 'consum', 0.0256, 'lps'),
	(627109, 132, '2015-01-01 01:14:37.000000', 'consum', 0.0281, 'lps'),
	(627110, 132, '2015-01-01 01:14:38.000000', 'consum', 0.0268, 'lps'),
	(627111, 132, '2015-01-01 01:14:39.000000', 'consum', 0.0286, 'lps'),
	(627112, 132, '2015-01-01 01:14:40.000000', 'consum', 0.0255, 'lps'),
	(627113, 132, '2015-01-01 01:14:41.000000', 'consum', 0.0288, 'lps'),
	(627114, 132, '2015-01-01 01:14:42.000000', 'consum', 0.0221, 'lps'),
	(627115, 132, '2015-01-01 01:14:43.000000', 'consum', 0.0277, 'lps'),
	(627116, 132, '2015-01-01 01:14:44.000000', 'consum', 0.0268, 'lps'),
	(627117, 132, '2015-01-01 01:14:45.000000', 'consum', 0.0221, 'lps'),
	(627118, 132, '2015-01-01 01:14:46.000000', 'consum', 0.0252, 'lps'),
	(627119, 132, '2015-01-01 01:14:47.000000', 'consum', 0.0227, 'lps'),
	(627120, 132, '2015-01-01 01:14:48.000000', 'consum', 0.0248, 'lps'),
	(627121, 132, '2015-01-01 01:14:49.000000', 'consum', 0.0267, 'lps'),
	(627122, 132, '2015-01-01 01:14:50.000000', 'consum', 0.0223, 'lps'),
	(627123, 132, '2015-01-01 01:14:51.000000', 'consum', 0.0265, 'lps'),
	(627124, 132, '2015-01-01 01:14:52.000000', 'consum', 0.0285, 'lps'),
	(627125, 132, '2015-01-01 01:14:53.000000', 'consum', 0.0260, 'lps'),
	(627126, 132, '2015-01-01 01:14:54.000000', 'consum', 0.0232, 'lps'),
	(627127, 132, '2015-01-01 01:14:55.000000', 'consum', 0.0255, 'lps'),
	(627128, 132, '2015-01-01 01:14:56.000000', 'consum', 0.0287, 'lps'),
	(627129, 132, '2015-01-01 01:14:57.000000', 'consum', 0.0219, 'lps'),
	(627130, 132, '2015-01-01 01:14:58.000000', 'consum', 0.0267, 'lps'),
	(627131, 132, '2015-01-01 01:14:59.000000', 'consum', 0.0226, 'lps'),
	(627132, 132, '2015-01-01 01:15:00.000000', 'consum', 0.0282, 'lps'),
	(627133, 132, '2015-01-01 01:15:01.000000', 'consum', 0.0278, 'lps'),
	(627134, 132, '2015-01-01 01:15:02.000000', 'consum', 0.0255, 'lps'),
	(627135, 132, '2015-01-01 01:15:03.000000', 'consum', 0.0229, 'lps'),
	(627136, 132, '2015-01-01 01:15:04.000000', 'consum', 0.0255, 'lps'),
	(627137, 132, '2015-01-01 01:15:05.000000', 'consum', 0.0213, 'lps'),
	(627138, 132, '2015-01-01 01:15:06.000000', 'consum', 0.0255, 'lps'),
	(627139, 132, '2015-01-01 01:15:07.000000', 'consum', 0.0264, 'lps'),
	(627140, 132, '2015-01-01 01:15:08.000000', 'consum', 0.0264, 'lps'),
	(627141, 132, '2015-01-01 01:15:09.000000', 'consum', 0.0236, 'lps'),
	(627142, 132, '2015-01-01 01:15:10.000000', 'consum', 0.0260, 'lps'),
	(627143, 132, '2015-01-01 01:15:11.000000', 'consum', 0.0221, 'lps'),
	(627144, 132, '2015-01-01 01:15:12.000000', 'consum', 0.0276, 'lps'),
	(627145, 132, '2015-01-01 01:15:13.000000', 'consum', 0.0266, 'lps'),
	(627146, 132, '2015-01-01 01:15:14.000000', 'consum', 0.0210, 'lps'),
	(627147, 132, '2015-01-01 01:15:15.000000', 'consum', 0.0287, 'lps'),
	(627148, 132, '2015-01-01 01:15:16.000000', 'consum', 0.0270, 'lps'),
	(627149, 132, '2015-01-01 01:15:17.000000', 'consum', 0.0282, 'lps'),
	(627150, 132, '2015-01-01 01:15:18.000000', 'consum', 0.0228, 'lps'),
	(627151, 132, '2015-01-01 01:15:19.000000', 'consum', 0.0245, 'lps'),
	(627152, 132, '2015-01-01 01:15:20.000000', 'consum', 0.0250, 'lps'),
	(627153, 133, '2015-01-01 00:00:00.000000', 'consum', 0.0231, 'lps'),
	(627154, 133, '2015-01-01 00:00:01.000000', 'consum', 0.0210, 'lps'),
	(627155, 133, '2015-01-01 00:00:02.000000', 'consum', 0.0212, 'lps'),
	(627156, 133, '2015-01-01 00:00:03.000000', 'consum', 0.0221, 'lps'),
	(627157, 133, '2015-01-01 00:00:04.000000', 'consum', 0.0225, 'lps'),
	(627158, 133, '2015-01-01 00:00:05.000000', 'consum', 0.0221, 'lps'),
	(627159, 133, '2015-01-01 00:00:06.000000', 'consum', 0.0222, 'lps'),
	(627160, 133, '2015-01-01 00:00:07.000000', 'consum', 0.0237, 'lps'),
	(627161, 133, '2015-01-01 00:00:08.000000', 'consum', 0.0213, 'lps'),
	(627162, 133, '2015-01-01 00:00:09.000000', 'consum', 0.0241, 'lps'),
	(627163, 133, '2015-01-01 00:00:10.000000', 'consum', 0.0229, 'lps'),
	(627164, 133, '2015-01-01 00:00:11.000000', 'consum', 0.0210, 'lps'),
	(627165, 133, '2015-01-01 00:00:12.000000', 'consum', 0.0220, 'lps'),
	(627166, 133, '2015-01-01 00:00:13.000000', 'consum', 0.0229, 'lps'),
	(627167, 133, '2015-01-01 00:00:14.000000', 'consum', 0.0241, 'lps'),
	(627168, 133, '2015-01-01 00:00:15.000000', 'consum', 0.0212, 'lps'),
	(627169, 133, '2015-01-01 00:00:16.000000', 'consum', 0.0225, 'lps'),
	(627170, 133, '2015-01-01 00:00:17.000000', 'consum', 0.0215, 'lps'),
	(627171, 133, '2015-01-01 00:00:18.000000', 'consum', 0.0221, 'lps'),
	(627172, 133, '2015-01-01 00:00:19.000000', 'consum', 0.0219, 'lps'),
	(627173, 133, '2015-01-01 00:00:20.000000', 'consum', 0.0223, 'lps'),
	(627174, 133, '2015-01-01 00:00:21.000000', 'consum', 0.0216, 'lps'),
	(627175, 133, '2015-01-01 00:00:22.000000', 'consum', 0.0234, 'lps'),
	(627176, 133, '2015-01-01 00:00:23.000000', 'consum', 0.0217, 'lps'),
	(627177, 133, '2015-01-01 00:00:24.000000', 'consum', 0.0239, 'lps'),
	(627178, 133, '2015-01-01 00:00:25.000000', 'consum', 0.0236, 'lps'),
	(627179, 133, '2015-01-01 00:00:26.000000', 'consum', 0.0224, 'lps'),
	(627180, 133, '2015-01-01 00:00:27.000000', 'consum', 0.0235, 'lps'),
	(627181, 133, '2015-01-01 00:00:28.000000', 'consum', 0.0226, 'lps'),
	(627182, 133, '2015-01-01 00:00:29.000000', 'consum', 0.0218, 'lps'),
	(627183, 133, '2015-01-01 00:00:30.000000', 'consum', 0.0235, 'lps'),
	(627184, 133, '2015-01-01 00:00:31.000000', 'consum', 0.0215, 'lps'),
	(627185, 133, '2015-01-01 00:00:32.000000', 'consum', 0.0223, 'lps'),
	(627186, 133, '2015-01-01 00:00:33.000000', 'consum', 0.0229, 'lps'),
	(627187, 133, '2015-01-01 00:00:34.000000', 'consum', 0.0236, 'lps'),
	(627188, 133, '2015-01-01 00:00:35.000000', 'consum', 0.0219, 'lps'),
	(627189, 133, '2015-01-01 00:00:36.000000', 'consum', 0.0210, 'lps'),
	(627190, 133, '2015-01-01 00:00:37.000000', 'consum', 0.0214, 'lps'),
	(627191, 133, '2015-01-01 00:00:38.000000', 'consum', 0.0232, 'lps'),
	(627192, 133, '2015-01-01 00:00:39.000000', 'consum', 0.0211, 'lps'),
	(627193, 133, '2015-01-01 00:00:40.000000', 'consum', 0.0215, 'lps'),
	(627194, 133, '2015-01-01 00:00:41.000000', 'consum', 0.0231, 'lps'),
	(627195, 133, '2015-01-01 00:00:42.000000', 'consum', 0.0235, 'lps'),
	(627196, 133, '2015-01-01 00:00:43.000000', 'consum', 0.0212, 'lps'),
	(627197, 133, '2015-01-01 00:00:44.000000', 'consum', 0.0239, 'lps'),
	(627198, 133, '2015-01-01 00:00:45.000000', 'consum', 0.0221, 'lps'),
	(627199, 133, '2015-01-01 00:00:46.000000', 'consum', 0.0212, 'lps'),
	(627200, 133, '2015-01-01 00:00:47.000000', 'consum', 0.0221, 'lps'),
	(627201, 133, '2015-01-01 00:00:48.000000', 'consum', 0.0225, 'lps'),
	(627202, 133, '2015-01-01 00:00:49.000000', 'consum', 0.0221, 'lps'),
	(627203, 133, '2015-01-01 00:00:50.000000', 'consum', 0.0222, 'lps'),
	(627204, 133, '2015-01-01 00:00:51.000000', 'consum', 0.0235, 'lps'),
	(627205, 133, '2015-01-01 00:00:52.000000', 'consum', 0.0238, 'lps'),
	(627206, 133, '2015-01-01 00:00:53.000000', 'consum', 0.0241, 'lps'),
	(627207, 133, '2015-01-01 00:00:54.000000', 'consum', 0.0220, 'lps'),
	(627208, 133, '2015-01-01 00:00:55.000000', 'consum', 0.0232, 'lps'),
	(627209, 133, '2015-01-01 00:00:56.000000', 'consum', 0.0227, 'lps'),
	(627210, 133, '2015-01-01 00:00:57.000000', 'consum', 0.0229, 'lps'),
	(627211, 133, '2015-01-01 00:00:58.000000', 'consum', 0.0220, 'lps'),
	(627212, 133, '2015-01-01 00:00:59.000000', 'consum', 0.0239, 'lps'),
	(627213, 133, '2015-01-01 00:01:00.000000', 'consum', 0.0227, 'lps'),
	(627214, 133, '2015-01-01 00:01:01.000000', 'consum', 0.0240, 'lps'),
	(627215, 133, '2015-01-01 00:01:02.000000', 'consum', 0.0214, 'lps'),
	(627216, 133, '2015-01-01 00:01:03.000000', 'consum', 0.0236, 'lps'),
	(627217, 133, '2015-01-01 00:01:04.000000', 'consum', 0.0234, 'lps'),
	(627218, 133, '2015-01-01 00:01:05.000000', 'consum', 0.0220, 'lps'),
	(627219, 133, '2015-01-01 00:01:06.000000', 'consum', 0.0220, 'lps'),
	(627220, 133, '2015-01-01 00:01:07.000000', 'consum', 0.0230, 'lps'),
	(627221, 133, '2015-01-01 00:01:08.000000', 'consum', 0.0215, 'lps'),
	(627222, 133, '2015-01-01 00:01:09.000000', 'consum', 0.0210, 'lps'),
	(627223, 133, '2015-01-01 00:01:10.000000', 'consum', 0.0227, 'lps'),
	(627224, 133, '2015-01-01 00:01:11.000000', 'consum', 0.0231, 'lps'),
	(627225, 133, '2015-01-01 00:01:12.000000', 'consum', 0.0231, 'lps'),
	(627226, 133, '2015-01-01 00:01:13.000000', 'consum', 0.0223, 'lps'),
	(627227, 133, '2015-01-01 00:01:14.000000', 'consum', 0.0211, 'lps'),
	(627228, 133, '2015-01-01 00:01:15.000000', 'consum', 0.0210, 'lps'),
	(627229, 133, '2015-01-01 00:01:16.000000', 'consum', 0.0239, 'lps'),
	(627230, 133, '2015-01-01 00:01:17.000000', 'consum', 0.0229, 'lps'),
	(627231, 133, '2015-01-01 00:01:18.000000', 'consum', 0.0218, 'lps'),
	(627232, 133, '2015-01-01 00:01:19.000000', 'consum', 0.0226, 'lps'),
	(627233, 133, '2015-01-01 00:01:20.000000', 'consum', 0.0235, 'lps'),
	(627234, 133, '2015-01-01 00:01:21.000000', 'consum', 0.0221, 'lps'),
	(627235, 133, '2015-01-01 00:01:22.000000', 'consum', 0.0226, 'lps'),
	(627236, 133, '2015-01-01 00:01:23.000000', 'consum', 0.0222, 'lps'),
	(627237, 133, '2015-01-01 00:01:24.000000', 'consum', 0.0226, 'lps'),
	(627238, 133, '2015-01-01 00:01:25.000000', 'consum', 0.0220, 'lps'),
	(627239, 133, '2015-01-01 00:01:26.000000', 'consum', 0.0213, 'lps'),
	(627240, 133, '2015-01-01 00:01:27.000000', 'consum', 0.0230, 'lps'),
	(627241, 133, '2015-01-01 00:01:28.000000', 'consum', 0.0234, 'lps'),
	(627242, 133, '2015-01-01 00:01:29.000000', 'consum', 0.0241, 'lps'),
	(627243, 133, '2015-01-01 00:01:30.000000', 'consum', 0.0227, 'lps'),
	(627244, 133, '2015-01-01 00:01:31.000000', 'consum', 0.0237, 'lps'),
	(627245, 133, '2015-01-01 00:01:32.000000', 'consum', 0.0230, 'lps'),
	(627246, 133, '2015-01-01 00:01:33.000000', 'consum', 0.0228, 'lps'),
	(627247, 133, '2015-01-01 00:01:34.000000', 'consum', 0.0241, 'lps'),
	(627248, 133, '2015-01-01 00:01:35.000000', 'consum', 0.0215, 'lps'),
	(627249, 133, '2015-01-01 00:01:36.000000', 'consum', 0.0238, 'lps'),
	(627250, 133, '2015-01-01 00:01:37.000000', 'consum', 0.0241, 'lps'),
	(627251, 133, '2015-01-01 00:01:38.000000', 'consum', 0.0218, 'lps'),
	(627252, 133, '2015-01-01 00:01:39.000000', 'consum', 0.0223, 'lps'),
	(627253, 133, '2015-01-01 00:01:40.000000', 'consum', 0.0216, 'lps'),
	(627254, 133, '2015-01-01 00:01:41.000000', 'consum', 0.0236, 'lps'),
	(627255, 133, '2015-01-01 00:01:42.000000', 'consum', 0.0227, 'lps'),
	(627256, 133, '2015-01-01 00:01:43.000000', 'consum', 0.0216, 'lps'),
	(627257, 133, '2015-01-01 00:01:44.000000', 'consum', 0.0223, 'lps'),
	(627258, 133, '2015-01-01 00:01:45.000000', 'consum', 0.0225, 'lps'),
	(627259, 133, '2015-01-01 00:01:46.000000', 'consum', 0.0213, 'lps'),
	(627260, 133, '2015-01-01 00:01:47.000000', 'consum', 0.0213, 'lps'),
	(627261, 133, '2015-01-01 00:01:48.000000', 'consum', 0.0217, 'lps'),
	(627262, 133, '2015-01-01 00:01:49.000000', 'consum', 0.0236, 'lps'),
	(627263, 133, '2015-01-01 00:01:50.000000', 'consum', 0.0222, 'lps'),
	(627264, 133, '2015-01-01 00:01:51.000000', 'consum', 0.0224, 'lps'),
	(627265, 133, '2015-01-01 00:01:52.000000', 'consum', 0.0214, 'lps'),
	(627266, 133, '2015-01-01 00:01:53.000000', 'consum', 0.0219, 'lps'),
	(627267, 133, '2015-01-01 00:01:54.000000', 'consum', 0.0212, 'lps'),
	(627268, 133, '2015-01-01 00:01:55.000000', 'consum', 0.0224, 'lps'),
	(627269, 133, '2015-01-01 00:01:56.000000', 'consum', 0.0212, 'lps'),
	(627270, 133, '2015-01-01 00:01:57.000000', 'consum', 0.0211, 'lps'),
	(627271, 133, '2015-01-01 00:01:58.000000', 'consum', 0.0239, 'lps'),
	(627272, 133, '2015-01-01 00:01:59.000000', 'consum', 0.0226, 'lps'),
	(627273, 133, '2015-01-01 00:02:00.000000', 'consum', 0.0237, 'lps'),
	(627274, 133, '2015-01-01 00:02:01.000000', 'consum', 0.0232, 'lps'),
	(627275, 133, '2015-01-01 00:02:02.000000', 'consum', 0.0241, 'lps'),
	(627276, 133, '2015-01-01 00:02:03.000000', 'consum', 0.0235, 'lps'),
	(627277, 133, '2015-01-01 00:02:04.000000', 'consum', 0.0211, 'lps'),
	(627278, 133, '2015-01-01 00:02:05.000000', 'consum', 0.0235, 'lps'),
	(627279, 133, '2015-01-01 00:02:06.000000', 'consum', 0.0238, 'lps'),
	(627280, 133, '2015-01-01 00:02:07.000000', 'consum', 0.0211, 'lps'),
	(627281, 133, '2015-01-01 00:02:08.000000', 'consum', 0.0230, 'lps'),
	(627282, 133, '2015-01-01 00:02:09.000000', 'consum', 0.0240, 'lps'),
	(627283, 133, '2015-01-01 00:02:10.000000', 'consum', 0.0237, 'lps'),
	(627284, 133, '2015-01-01 00:02:11.000000', 'consum', 0.0222, 'lps'),
	(627285, 133, '2015-01-01 00:02:12.000000', 'consum', 0.0224, 'lps'),
	(627286, 133, '2015-01-01 00:02:13.000000', 'consum', 0.0210, 'lps'),
	(627287, 133, '2015-01-01 00:02:14.000000', 'consum', 0.0232, 'lps'),
	(627288, 133, '2015-01-01 00:02:15.000000', 'consum', 0.0226, 'lps'),
	(627289, 133, '2015-01-01 00:02:16.000000', 'consum', 0.0223, 'lps'),
	(627290, 133, '2015-01-01 00:02:17.000000', 'consum', 0.0228, 'lps'),
	(627291, 133, '2015-01-01 00:02:18.000000', 'consum', 0.0228, 'lps'),
	(627292, 133, '2015-01-01 00:02:19.000000', 'consum', 0.0217, 'lps'),
	(627293, 133, '2015-01-01 00:02:20.000000', 'consum', 0.0224, 'lps'),
	(627294, 133, '2015-01-01 00:02:21.000000', 'consum', 0.0227, 'lps'),
	(627295, 133, '2015-01-01 00:02:22.000000', 'consum', 0.0223, 'lps'),
	(627296, 133, '2015-01-01 00:02:23.000000', 'consum', 0.0221, 'lps'),
	(627297, 133, '2015-01-01 00:02:24.000000', 'consum', 0.0229, 'lps'),
	(627298, 133, '2015-01-01 00:02:25.000000', 'consum', 0.0238, 'lps'),
	(627299, 133, '2015-01-01 00:02:26.000000', 'consum', 0.0232, 'lps'),
	(627300, 133, '2015-01-01 00:02:27.000000', 'consum', 0.0234, 'lps'),
	(627301, 133, '2015-01-01 00:02:28.000000', 'consum', 0.0233, 'lps'),
	(627302, 133, '2015-01-01 00:02:29.000000', 'consum', 0.0223, 'lps'),
	(627303, 133, '2015-01-01 00:02:30.000000', 'consum', 0.0240, 'lps'),
	(627304, 133, '2015-01-01 00:02:31.000000', 'consum', 0.0222, 'lps'),
	(627305, 133, '2015-01-01 00:02:32.000000', 'consum', 0.0215, 'lps'),
	(627306, 133, '2015-01-01 00:02:33.000000', 'consum', 0.0232, 'lps'),
	(627307, 133, '2015-01-01 00:02:34.000000', 'consum', 0.0239, 'lps'),
	(627308, 133, '2015-01-01 00:02:35.000000', 'consum', 0.0225, 'lps'),
	(627309, 133, '2015-01-01 00:02:36.000000', 'consum', 0.0234, 'lps'),
	(627310, 133, '2015-01-01 00:02:37.000000', 'consum', 0.0219, 'lps'),
	(627311, 133, '2015-01-01 00:02:38.000000', 'consum', 0.0214, 'lps'),
	(627312, 133, '2015-01-01 00:02:39.000000', 'consum', 0.0237, 'lps'),
	(627313, 133, '2015-01-01 00:02:40.000000', 'consum', 0.0237, 'lps'),
	(627314, 133, '2015-01-01 00:02:41.000000', 'consum', 0.0233, 'lps'),
	(627315, 133, '2015-01-01 00:02:42.000000', 'consum', 0.0214, 'lps'),
	(627316, 133, '2015-01-01 00:02:43.000000', 'consum', 0.0224, 'lps'),
	(627317, 133, '2015-01-01 00:02:44.000000', 'consum', 0.0237, 'lps'),
	(627318, 133, '2015-01-01 00:02:45.000000', 'consum', 0.0240, 'lps'),
	(627319, 133, '2015-01-01 00:02:46.000000', 'consum', 0.0215, 'lps'),
	(627320, 133, '2015-01-01 00:02:47.000000', 'consum', 0.0211, 'lps'),
	(627321, 133, '2015-01-01 00:02:48.000000', 'consum', 0.0229, 'lps'),
	(627322, 133, '2015-01-01 00:02:49.000000', 'consum', 0.0210, 'lps'),
	(627323, 133, '2015-01-01 00:02:50.000000', 'consum', 0.0215, 'lps'),
	(627324, 133, '2015-01-01 00:02:51.000000', 'consum', 0.0235, 'lps'),
	(627325, 133, '2015-01-01 00:02:52.000000', 'consum', 0.0226, 'lps'),
	(627326, 133, '2015-01-01 00:02:53.000000', 'consum', 0.0214, 'lps'),
	(627327, 133, '2015-01-01 00:02:54.000000', 'consum', 0.0214, 'lps'),
	(627328, 133, '2015-01-01 00:02:55.000000', 'consum', 0.0218, 'lps'),
	(627329, 133, '2015-01-01 00:02:56.000000', 'consum', 0.0239, 'lps'),
	(627330, 133, '2015-01-01 00:02:57.000000', 'consum', 0.0235, 'lps'),
	(627331, 133, '2015-01-01 00:02:58.000000', 'consum', 0.0217, 'lps'),
	(627332, 133, '2015-01-01 00:02:59.000000', 'consum', 0.0233, 'lps'),
	(627333, 133, '2015-01-01 00:03:00.000000', 'consum', 0.0240, 'lps'),
	(627334, 133, '2015-01-01 00:03:01.000000', 'consum', 0.0227, 'lps'),
	(627335, 133, '2015-01-01 00:03:02.000000', 'consum', 0.0237, 'lps'),
	(627336, 133, '2015-01-01 00:03:03.000000', 'consum', 0.0230, 'lps'),
	(627337, 133, '2015-01-01 00:03:04.000000', 'consum', 0.0231, 'lps'),
	(627338, 133, '2015-01-01 00:03:05.000000', 'consum', 0.0223, 'lps'),
	(627339, 133, '2015-01-01 00:03:06.000000', 'consum', 0.0212, 'lps'),
	(627340, 133, '2015-01-01 00:03:07.000000', 'consum', 0.0214, 'lps'),
	(627341, 133, '2015-01-01 00:03:08.000000', 'consum', 0.0223, 'lps'),
	(627342, 133, '2015-01-01 00:03:09.000000', 'consum', 0.0234, 'lps'),
	(627343, 133, '2015-01-01 00:03:10.000000', 'consum', 0.0226, 'lps'),
	(627344, 133, '2015-01-01 00:03:11.000000', 'consum', 0.0218, 'lps'),
	(627345, 133, '2015-01-01 00:03:12.000000', 'consum', 0.0236, 'lps'),
	(627346, 133, '2015-01-01 00:03:13.000000', 'consum', 0.0218, 'lps'),
	(627347, 133, '2015-01-01 00:03:14.000000', 'consum', 0.0238, 'lps'),
	(627348, 133, '2015-01-01 00:03:15.000000', 'consum', 0.0231, 'lps'),
	(627349, 133, '2015-01-01 00:03:16.000000', 'consum', 0.0232, 'lps'),
	(627350, 133, '2015-01-01 00:03:17.000000', 'consum', 0.0224, 'lps'),
	(627351, 133, '2015-01-01 00:03:18.000000', 'consum', 0.0216, 'lps'),
	(627352, 133, '2015-01-01 00:03:19.000000', 'consum', 0.0228, 'lps'),
	(627353, 133, '2015-01-01 00:03:20.000000', 'consum', 0.0219, 'lps'),
	(627354, 133, '2015-01-01 00:03:21.000000', 'consum', 0.0236, 'lps'),
	(627355, 133, '2015-01-01 00:03:22.000000', 'consum', 0.0217, 'lps'),
	(627356, 133, '2015-01-01 00:03:23.000000', 'consum', 0.0231, 'lps'),
	(627357, 133, '2015-01-01 00:03:24.000000', 'consum', 0.0230, 'lps'),
	(627358, 133, '2015-01-01 00:03:25.000000', 'consum', 0.0215, 'lps'),
	(627359, 133, '2015-01-01 00:03:26.000000', 'consum', 0.0239, 'lps'),
	(627360, 133, '2015-01-01 00:03:27.000000', 'consum', 0.0212, 'lps'),
	(627361, 133, '2015-01-01 00:03:28.000000', 'consum', 0.0230, 'lps'),
	(627362, 133, '2015-01-01 00:03:29.000000', 'consum', 0.0210, 'lps'),
	(627363, 133, '2015-01-01 00:03:30.000000', 'consum', 0.0214, 'lps'),
	(627364, 133, '2015-01-01 00:03:31.000000', 'consum', 0.0229, 'lps'),
	(627365, 133, '2015-01-01 00:03:32.000000', 'consum', 0.0232, 'lps'),
	(627366, 133, '2015-01-01 00:03:33.000000', 'consum', 0.0228, 'lps'),
	(627367, 133, '2015-01-01 00:03:34.000000', 'consum', 0.0238, 'lps'),
	(627368, 133, '2015-01-01 00:03:35.000000', 'consum', 0.0230, 'lps'),
	(627369, 133, '2015-01-01 00:03:36.000000', 'consum', 0.0227, 'lps'),
	(627370, 133, '2015-01-01 00:03:37.000000', 'consum', 0.0234, 'lps'),
	(627371, 133, '2015-01-01 00:03:38.000000', 'consum', 0.0216, 'lps'),
	(627372, 133, '2015-01-01 00:03:39.000000', 'consum', 0.0235, 'lps'),
	(627373, 133, '2015-01-01 00:03:40.000000', 'consum', 0.0220, 'lps'),
	(627374, 133, '2015-01-01 00:03:41.000000', 'consum', 0.0218, 'lps'),
	(627375, 133, '2015-01-01 00:03:42.000000', 'consum', 0.0222, 'lps'),
	(627376, 133, '2015-01-01 00:03:43.000000', 'consum', 0.0214, 'lps'),
	(627377, 133, '2015-01-01 00:03:44.000000', 'consum', 0.0228, 'lps'),
	(627378, 133, '2015-01-01 00:03:45.000000', 'consum', 0.0223, 'lps'),
	(627379, 133, '2015-01-01 00:03:46.000000', 'consum', 0.0221, 'lps'),
	(627380, 133, '2015-01-01 00:03:47.000000', 'consum', 0.0227, 'lps'),
	(627381, 133, '2015-01-01 00:03:48.000000', 'consum', 0.0232, 'lps'),
	(627382, 133, '2015-01-01 00:03:49.000000', 'consum', 0.0236, 'lps'),
	(627383, 133, '2015-01-01 00:03:50.000000', 'consum', 0.0212, 'lps'),
	(627384, 133, '2015-01-01 00:03:51.000000', 'consum', 0.0238, 'lps'),
	(627385, 133, '2015-01-01 00:03:52.000000', 'consum', 0.0216, 'lps'),
	(627386, 133, '2015-01-01 00:03:53.000000', 'consum', 0.0220, 'lps'),
	(627387, 133, '2015-01-01 00:03:54.000000', 'consum', 0.0241, 'lps'),
	(627388, 133, '2015-01-01 00:03:55.000000', 'consum', 0.0241, 'lps'),
	(627389, 133, '2015-01-01 00:03:56.000000', 'consum', 0.0240, 'lps'),
	(627390, 133, '2015-01-01 00:03:57.000000', 'consum', 0.0234, 'lps'),
	(627391, 133, '2015-01-01 00:03:58.000000', 'consum', 0.0211, 'lps'),
	(627392, 133, '2015-01-01 00:03:59.000000', 'consum', 0.0238, 'lps'),
	(627393, 133, '2015-01-01 00:04:00.000000', 'consum', 0.0218, 'lps'),
	(627394, 133, '2015-01-01 00:04:01.000000', 'consum', 0.0233, 'lps'),
	(627395, 133, '2015-01-01 00:04:02.000000', 'consum', 0.0235, 'lps'),
	(627396, 133, '2015-01-01 00:04:03.000000', 'consum', 0.0237, 'lps'),
	(627397, 133, '2015-01-01 00:04:04.000000', 'consum', 0.0239, 'lps'),
	(627398, 133, '2015-01-01 00:04:05.000000', 'consum', 0.0211, 'lps'),
	(627399, 133, '2015-01-01 00:04:06.000000', 'consum', 0.0221, 'lps'),
	(627400, 133, '2015-01-01 00:04:07.000000', 'consum', 0.0234, 'lps'),
	(627401, 133, '2015-01-01 00:04:08.000000', 'consum', 0.0233, 'lps'),
	(627402, 133, '2015-01-01 00:04:09.000000', 'consum', 0.0220, 'lps'),
	(627403, 133, '2015-01-01 00:04:10.000000', 'consum', 0.0226, 'lps'),
	(627404, 133, '2015-01-01 00:04:11.000000', 'consum', 0.0226, 'lps'),
	(627405, 133, '2015-01-01 00:04:12.000000', 'consum', 0.0241, 'lps'),
	(627406, 133, '2015-01-01 00:04:13.000000', 'consum', 0.0225, 'lps'),
	(627407, 133, '2015-01-01 00:04:14.000000', 'consum', 0.0222, 'lps'),
	(627408, 133, '2015-01-01 00:04:15.000000', 'consum', 0.0227, 'lps'),
	(627409, 133, '2015-01-01 00:04:16.000000', 'consum', 0.0226, 'lps'),
	(627410, 133, '2015-01-01 00:04:17.000000', 'consum', 0.0240, 'lps'),
	(627411, 133, '2015-01-01 00:04:18.000000', 'consum', 0.0215, 'lps'),
	(627412, 133, '2015-01-01 00:04:19.000000', 'consum', 0.0241, 'lps'),
	(627413, 133, '2015-01-01 00:04:20.000000', 'consum', 0.0223, 'lps'),
	(627414, 133, '2015-01-01 00:04:21.000000', 'consum', 0.0215, 'lps'),
	(627415, 133, '2015-01-01 00:04:22.000000', 'consum', 0.0230, 'lps'),
	(627416, 133, '2015-01-01 00:04:23.000000', 'consum', 0.0231, 'lps'),
	(627417, 133, '2015-01-01 00:04:24.000000', 'consum', 0.0224, 'lps'),
	(627418, 133, '2015-01-01 00:04:25.000000', 'consum', 0.0217, 'lps'),
	(627419, 133, '2015-01-01 00:04:26.000000', 'consum', 0.0237, 'lps'),
	(627420, 133, '2015-01-01 00:04:27.000000', 'consum', 0.0228, 'lps'),
	(627421, 133, '2015-01-01 00:04:28.000000', 'consum', 0.0218, 'lps'),
	(627422, 133, '2015-01-01 00:04:29.000000', 'consum', 0.0230, 'lps'),
	(627423, 133, '2015-01-01 00:04:30.000000', 'consum', 0.0223, 'lps'),
	(627424, 133, '2015-01-01 00:04:31.000000', 'consum', 0.0217, 'lps'),
	(627425, 133, '2015-01-01 00:04:32.000000', 'consum', 0.0236, 'lps'),
	(627426, 133, '2015-01-01 00:04:33.000000', 'consum', 0.0225, 'lps'),
	(627427, 133, '2015-01-01 00:04:34.000000', 'consum', 0.0240, 'lps'),
	(627428, 133, '2015-01-01 00:04:35.000000', 'consum', 0.0220, 'lps'),
	(627429, 133, '2015-01-01 00:04:36.000000', 'consum', 0.0233, 'lps'),
	(627430, 133, '2015-01-01 00:04:37.000000', 'consum', 0.0233, 'lps'),
	(627431, 133, '2015-01-01 00:04:38.000000', 'consum', 0.0224, 'lps'),
	(627432, 133, '2015-01-01 00:04:39.000000', 'consum', 0.0241, 'lps'),
	(627433, 133, '2015-01-01 00:04:40.000000', 'consum', 0.0231, 'lps'),
	(627434, 133, '2015-01-01 00:04:41.000000', 'consum', 0.0220, 'lps'),
	(627435, 133, '2015-01-01 00:04:42.000000', 'consum', 0.0232, 'lps'),
	(627436, 133, '2015-01-01 00:04:43.000000', 'consum', 0.0226, 'lps'),
	(627437, 133, '2015-01-01 00:04:44.000000', 'consum', 0.0226, 'lps'),
	(627438, 133, '2015-01-01 00:04:45.000000', 'consum', 0.0241, 'lps'),
	(627439, 133, '2015-01-01 00:04:46.000000', 'consum', 0.0224, 'lps'),
	(627440, 133, '2015-01-01 00:04:47.000000', 'consum', 0.0217, 'lps'),
	(627441, 133, '2015-01-01 00:04:48.000000', 'consum', 0.0234, 'lps'),
	(627442, 133, '2015-01-01 00:04:49.000000', 'consum', 0.0216, 'lps'),
	(627443, 133, '2015-01-01 00:04:50.000000', 'consum', 0.0230, 'lps'),
	(627444, 133, '2015-01-01 00:04:51.000000', 'consum', 0.0229, 'lps'),
	(627445, 133, '2015-01-01 00:04:52.000000', 'consum', 0.0213, 'lps'),
	(627446, 133, '2015-01-01 00:04:53.000000', 'consum', 0.0234, 'lps'),
	(627447, 133, '2015-01-01 00:04:54.000000', 'consum', 0.0226, 'lps'),
	(627448, 133, '2015-01-01 00:04:55.000000', 'consum', 0.0220, 'lps'),
	(627449, 133, '2015-01-01 00:04:56.000000', 'consum', 0.0210, 'lps'),
	(627450, 133, '2015-01-01 00:04:57.000000', 'consum', 0.0215, 'lps'),
	(627451, 133, '2015-01-01 00:04:58.000000', 'consum', 0.0234, 'lps'),
	(627452, 133, '2015-01-01 00:04:59.000000', 'consum', 0.0219, 'lps'),
	(627453, 133, '2015-01-01 00:05:00.000000', 'consum', 0.0214, 'lps'),
	(627454, 133, '2015-01-01 00:05:01.000000', 'consum', 0.0237, 'lps'),
	(627455, 133, '2015-01-01 00:05:02.000000', 'consum', 0.0237, 'lps'),
	(627456, 133, '2015-01-01 00:05:03.000000', 'consum', 0.0232, 'lps'),
	(627457, 133, '2015-01-01 00:05:04.000000', 'consum', 0.0241, 'lps'),
	(627458, 133, '2015-01-01 00:05:05.000000', 'consum', 0.0236, 'lps'),
	(627459, 133, '2015-01-01 00:05:06.000000', 'consum', 0.0214, 'lps'),
	(627460, 133, '2015-01-01 00:05:07.000000', 'consum', 0.0218, 'lps'),
	(627461, 133, '2015-01-01 00:05:08.000000', 'consum', 0.0239, 'lps'),
	(627462, 133, '2015-01-01 00:05:09.000000', 'consum', 0.0236, 'lps'),
	(627463, 133, '2015-01-01 00:05:10.000000', 'consum', 0.0222, 'lps'),
	(627464, 133, '2015-01-01 00:05:11.000000', 'consum', 0.0224, 'lps'),
	(627465, 133, '2015-01-01 00:05:12.000000', 'consum', 0.0212, 'lps'),
	(627466, 133, '2015-01-01 00:05:13.000000', 'consum', 0.0210, 'lps'),
	(627467, 133, '2015-01-01 00:05:14.000000', 'consum', 0.0238, 'lps'),
	(627468, 133, '2015-01-01 00:05:15.000000', 'consum', 0.0220, 'lps'),
	(627469, 133, '2015-01-01 00:05:16.000000', 'consum', 0.0210, 'lps'),
	(627470, 133, '2015-01-01 00:05:17.000000', 'consum', 0.0213, 'lps'),
	(627471, 133, '2015-01-01 00:05:18.000000', 'consum', 0.0225, 'lps'),
	(627472, 133, '2015-01-01 00:05:19.000000', 'consum', 0.0214, 'lps'),
	(627473, 133, '2015-01-01 00:05:20.000000', 'consum', 0.0218, 'lps'),
	(627474, 133, '2015-01-01 00:05:21.000000', 'consum', 0.0238, 'lps'),
	(627475, 133, '2015-01-01 00:05:22.000000', 'consum', 0.0229, 'lps'),
	(627476, 133, '2015-01-01 00:05:23.000000', 'consum', 0.0222, 'lps'),
	(627477, 133, '2015-01-01 00:05:24.000000', 'consum', 0.0214, 'lps'),
	(627478, 133, '2015-01-01 00:05:25.000000', 'consum', 0.0227, 'lps'),
	(627479, 133, '2015-01-01 00:05:26.000000', 'consum', 0.0218, 'lps'),
	(627480, 133, '2015-01-01 00:05:27.000000', 'consum', 0.0233, 'lps'),
	(627481, 133, '2015-01-01 00:05:28.000000', 'consum', 0.0237, 'lps'),
	(627482, 133, '2015-01-01 00:05:29.000000', 'consum', 0.0212, 'lps'),
	(627483, 133, '2015-01-01 00:05:30.000000', 'consum', 0.0234, 'lps'),
	(627484, 133, '2015-01-01 00:05:31.000000', 'consum', 0.0230, 'lps'),
	(627485, 133, '2015-01-01 00:05:32.000000', 'consum', 0.0240, 'lps'),
	(627486, 133, '2015-01-01 00:05:33.000000', 'consum', 0.0235, 'lps'),
	(627487, 133, '2015-01-01 00:05:34.000000', 'consum', 0.0215, 'lps'),
	(627488, 133, '2015-01-01 00:05:35.000000', 'consum', 0.0224, 'lps'),
	(627489, 133, '2015-01-01 00:05:36.000000', 'consum', 0.0235, 'lps'),
	(627490, 133, '2015-01-01 00:05:37.000000', 'consum', 0.0226, 'lps'),
	(627491, 133, '2015-01-01 00:05:38.000000', 'consum', 0.0219, 'lps'),
	(627492, 133, '2015-01-01 00:05:39.000000', 'consum', 0.0238, 'lps'),
	(627493, 133, '2015-01-01 00:05:40.000000', 'consum', 0.0226, 'lps'),
	(627494, 133, '2015-01-01 00:05:41.000000', 'consum', 0.0239, 'lps'),
	(627495, 133, '2015-01-01 00:05:42.000000', 'consum', 0.0212, 'lps'),
	(627496, 133, '2015-01-01 00:05:43.000000', 'consum', 0.0230, 'lps'),
	(627497, 133, '2015-01-01 00:05:44.000000', 'consum', 0.0240, 'lps'),
	(627498, 133, '2015-01-01 00:05:45.000000', 'consum', 0.0236, 'lps'),
	(627499, 133, '2015-01-01 00:05:46.000000', 'consum', 0.0219, 'lps'),
	(627500, 133, '2015-01-01 00:05:47.000000', 'consum', 0.0211, 'lps'),
	(627501, 133, '2015-01-01 00:05:48.000000', 'consum', 0.0217, 'lps'),
	(627502, 133, '2015-01-01 00:05:49.000000', 'consum', 0.0214, 'lps'),
	(627503, 133, '2015-01-01 00:05:50.000000', 'consum', 0.0239, 'lps'),
	(627504, 133, '2015-01-01 00:05:51.000000', 'consum', 0.0215, 'lps'),
	(627505, 133, '2015-01-01 00:05:52.000000', 'consum', 0.0212, 'lps'),
	(627506, 133, '2015-01-01 00:05:53.000000', 'consum', 0.0238, 'lps'),
	(627507, 133, '2015-01-01 00:05:54.000000', 'consum', 0.0218, 'lps'),
	(627508, 133, '2015-01-01 00:05:55.000000', 'consum', 0.0230, 'lps'),
	(627509, 133, '2015-01-01 00:05:56.000000', 'consum', 0.0224, 'lps'),
	(627510, 133, '2015-01-01 00:05:57.000000', 'consum', 0.0217, 'lps'),
	(627511, 133, '2015-01-01 00:05:58.000000', 'consum', 0.0239, 'lps'),
	(627512, 133, '2015-01-01 00:05:59.000000', 'consum', 0.0238, 'lps'),
	(627513, 133, '2015-01-01 00:06:00.000000', 'consum', 0.0231, 'lps'),
	(627514, 133, '2015-01-01 00:06:01.000000', 'consum', 0.0230, 'lps'),
	(627515, 133, '2015-01-01 00:06:02.000000', 'consum', 0.0217, 'lps'),
	(627516, 133, '2015-01-01 00:06:03.000000', 'consum', 0.0215, 'lps'),
	(627517, 133, '2015-01-01 00:06:04.000000', 'consum', 0.0217, 'lps'),
	(627518, 133, '2015-01-01 00:06:05.000000', 'consum', 0.0230, 'lps'),
	(627519, 133, '2015-01-01 00:06:06.000000', 'consum', 0.0224, 'lps'),
	(627520, 133, '2015-01-01 00:06:07.000000', 'consum', 0.0221, 'lps'),
	(627521, 133, '2015-01-01 00:06:08.000000', 'consum', 0.0223, 'lps'),
	(627522, 133, '2015-01-01 00:06:09.000000', 'consum', 0.0211, 'lps'),
	(627523, 133, '2015-01-01 00:06:10.000000', 'consum', 0.0241, 'lps'),
	(627524, 133, '2015-01-01 00:06:11.000000', 'consum', 0.0233, 'lps'),
	(627525, 133, '2015-01-01 00:06:12.000000', 'consum', 0.0234, 'lps'),
	(627526, 133, '2015-01-01 00:06:13.000000', 'consum', 0.0231, 'lps'),
	(627527, 133, '2015-01-01 00:06:14.000000', 'consum', 0.0210, 'lps'),
	(627528, 133, '2015-01-01 00:06:15.000000', 'consum', 0.0212, 'lps'),
	(627529, 133, '2015-01-01 00:06:16.000000', 'consum', 0.0218, 'lps'),
	(627530, 133, '2015-01-01 00:06:17.000000', 'consum', 0.0215, 'lps'),
	(627531, 133, '2015-01-01 00:06:18.000000', 'consum', 0.0212, 'lps'),
	(627532, 133, '2015-01-01 00:06:19.000000', 'consum', 0.0235, 'lps'),
	(627533, 133, '2015-01-01 00:06:20.000000', 'consum', 0.0235, 'lps'),
	(627534, 133, '2015-01-01 00:06:21.000000', 'consum', 0.0230, 'lps'),
	(627535, 133, '2015-01-01 00:06:22.000000', 'consum', 0.0236, 'lps'),
	(627536, 133, '2015-01-01 00:06:23.000000', 'consum', 0.0215, 'lps'),
	(627537, 133, '2015-01-01 00:06:24.000000', 'consum', 0.0221, 'lps'),
	(627538, 133, '2015-01-01 00:06:25.000000', 'consum', 0.0220, 'lps'),
	(627539, 133, '2015-01-01 00:06:26.000000', 'consum', 0.0226, 'lps'),
	(627540, 133, '2015-01-01 00:06:27.000000', 'consum', 0.0231, 'lps'),
	(627541, 133, '2015-01-01 00:06:28.000000', 'consum', 0.0235, 'lps'),
	(627542, 133, '2015-01-01 00:06:29.000000', 'consum', 0.0240, 'lps'),
	(627543, 133, '2015-01-01 00:06:30.000000', 'consum', 0.0222, 'lps'),
	(627544, 133, '2015-01-01 00:06:31.000000', 'consum', 0.0211, 'lps'),
	(627545, 133, '2015-01-01 00:06:32.000000', 'consum', 0.0214, 'lps'),
	(627546, 133, '2015-01-01 00:06:33.000000', 'consum', 0.0227, 'lps'),
	(627547, 133, '2015-01-01 00:06:34.000000', 'consum', 0.0219, 'lps'),
	(627548, 133, '2015-01-01 00:06:35.000000', 'consum', 0.0237, 'lps'),
	(627549, 133, '2015-01-01 00:06:36.000000', 'consum', 0.0222, 'lps'),
	(627550, 133, '2015-01-01 00:06:37.000000', 'consum', 0.0220, 'lps'),
	(627551, 133, '2015-01-01 00:06:38.000000', 'consum', 0.0226, 'lps'),
	(627552, 133, '2015-01-01 00:06:39.000000', 'consum', 0.0229, 'lps'),
	(627553, 133, '2015-01-01 00:06:40.000000', 'consum', 0.0224, 'lps'),
	(627554, 133, '2015-01-01 00:06:41.000000', 'consum', 0.0224, 'lps'),
	(627555, 133, '2015-01-01 00:06:42.000000', 'consum', 0.0238, 'lps'),
	(627556, 133, '2015-01-01 00:06:43.000000', 'consum', 0.0213, 'lps'),
	(627557, 133, '2015-01-01 00:06:44.000000', 'consum', 0.0235, 'lps'),
	(627558, 133, '2015-01-01 00:06:45.000000', 'consum', 0.0234, 'lps'),
	(627559, 133, '2015-01-01 00:06:46.000000', 'consum', 0.0222, 'lps'),
	(627560, 133, '2015-01-01 00:06:47.000000', 'consum', 0.0231, 'lps'),
	(627561, 133, '2015-01-01 00:06:48.000000', 'consum', 0.0215, 'lps'),
	(627562, 133, '2015-01-01 00:06:49.000000', 'consum', 0.0236, 'lps'),
	(627563, 133, '2015-01-01 00:06:50.000000', 'consum', 0.0230, 'lps'),
	(627564, 133, '2015-01-01 00:06:51.000000', 'consum', 0.0233, 'lps'),
	(627565, 133, '2015-01-01 00:06:52.000000', 'consum', 0.0232, 'lps'),
	(627566, 133, '2015-01-01 00:06:53.000000', 'consum', 0.0222, 'lps'),
	(627567, 133, '2015-01-01 00:06:54.000000', 'consum', 0.0236, 'lps'),
	(627568, 133, '2015-01-01 00:06:55.000000', 'consum', 0.0240, 'lps'),
	(627569, 133, '2015-01-01 00:06:56.000000', 'consum', 0.0220, 'lps'),
	(627570, 133, '2015-01-01 00:06:57.000000', 'consum', 0.0232, 'lps'),
	(627571, 133, '2015-01-01 00:06:58.000000', 'consum', 0.0230, 'lps'),
	(627572, 133, '2015-01-01 00:06:59.000000', 'consum', 0.0241, 'lps'),
	(627573, 133, '2015-01-01 00:07:00.000000', 'consum', 0.0211, 'lps'),
	(627574, 133, '2015-01-01 00:07:01.000000', 'consum', 0.0220, 'lps'),
	(627575, 133, '2015-01-01 00:07:02.000000', 'consum', 0.0222, 'lps'),
	(627576, 133, '2015-01-01 00:07:03.000000', 'consum', 0.0211, 'lps'),
	(627577, 133, '2015-01-01 00:07:04.000000', 'consum', 0.0212, 'lps'),
	(627578, 133, '2015-01-01 00:07:05.000000', 'consum', 0.0218, 'lps'),
	(627579, 133, '2015-01-01 00:07:06.000000', 'consum', 0.0213, 'lps'),
	(627580, 133, '2015-01-01 00:07:07.000000', 'consum', 0.0232, 'lps'),
	(627581, 133, '2015-01-01 00:07:08.000000', 'consum', 0.0215, 'lps'),
	(627582, 133, '2015-01-01 00:07:09.000000', 'consum', 0.0233, 'lps'),
	(627583, 133, '2015-01-01 00:07:10.000000', 'consum', 0.0214, 'lps'),
	(627584, 133, '2015-01-01 00:07:11.000000', 'consum', 0.0226, 'lps'),
	(627585, 133, '2015-01-01 00:07:12.000000', 'consum', 0.0215, 'lps'),
	(627586, 133, '2015-01-01 00:07:13.000000', 'consum', 0.0219, 'lps'),
	(627587, 133, '2015-01-01 00:07:14.000000', 'consum', 0.0210, 'lps'),
	(627588, 133, '2015-01-01 00:07:15.000000', 'consum', 0.0216, 'lps'),
	(627589, 133, '2015-01-01 00:07:16.000000', 'consum', 0.0238, 'lps'),
	(627590, 133, '2015-01-01 00:07:17.000000', 'consum', 0.0236, 'lps'),
	(627591, 133, '2015-01-01 00:07:18.000000', 'consum', 0.0226, 'lps'),
	(627592, 133, '2015-01-01 00:07:19.000000', 'consum', 0.0214, 'lps'),
	(627593, 133, '2015-01-01 00:07:20.000000', 'consum', 0.0213, 'lps'),
	(627594, 133, '2015-01-01 00:07:21.000000', 'consum', 0.0214, 'lps'),
	(627595, 133, '2015-01-01 00:07:22.000000', 'consum', 0.0221, 'lps'),
	(627596, 133, '2015-01-01 00:07:23.000000', 'consum', 0.0221, 'lps'),
	(627597, 133, '2015-01-01 00:07:24.000000', 'consum', 0.0232, 'lps'),
	(627598, 133, '2015-01-01 00:07:25.000000', 'consum', 0.0225, 'lps'),
	(627599, 133, '2015-01-01 00:07:26.000000', 'consum', 0.0221, 'lps'),
	(627600, 133, '2015-01-01 00:07:27.000000', 'consum', 0.0218, 'lps'),
	(627601, 133, '2015-01-01 00:07:28.000000', 'consum', 0.0216, 'lps'),
	(627602, 133, '2015-01-01 00:07:29.000000', 'consum', 0.0218, 'lps'),
	(627603, 133, '2015-01-01 00:07:30.000000', 'consum', 0.0235, 'lps'),
	(627604, 133, '2015-01-01 00:07:31.000000', 'consum', 0.0212, 'lps'),
	(627605, 133, '2015-01-01 00:07:32.000000', 'consum', 0.0212, 'lps'),
	(627606, 133, '2015-01-01 00:07:33.000000', 'consum', 0.0215, 'lps'),
	(627607, 133, '2015-01-01 00:07:34.000000', 'consum', 0.0230, 'lps'),
	(627608, 133, '2015-01-01 00:07:35.000000', 'consum', 0.0229, 'lps'),
	(627609, 133, '2015-01-01 00:07:36.000000', 'consum', 0.0214, 'lps'),
	(627610, 133, '2015-01-01 00:07:37.000000', 'consum', 0.0237, 'lps'),
	(627611, 133, '2015-01-01 00:07:38.000000', 'consum', 0.0237, 'lps'),
	(627612, 133, '2015-01-01 00:07:39.000000', 'consum', 0.0234, 'lps'),
	(627613, 133, '2015-01-01 00:07:40.000000', 'consum', 0.0215, 'lps'),
	(627614, 133, '2015-01-01 00:07:41.000000', 'consum', 0.0229, 'lps'),
	(627615, 133, '2015-01-01 00:07:42.000000', 'consum', 0.0225, 'lps'),
	(627616, 133, '2015-01-01 00:07:43.000000', 'consum', 0.0231, 'lps'),
	(627617, 133, '2015-01-01 00:07:44.000000', 'consum', 0.0239, 'lps'),
	(627618, 133, '2015-01-01 00:07:45.000000', 'consum', 0.0226, 'lps'),
	(627619, 133, '2015-01-01 00:07:46.000000', 'consum', 0.0235, 'lps'),
	(627620, 133, '2015-01-01 00:07:47.000000', 'consum', 0.0222, 'lps'),
	(627621, 133, '2015-01-01 00:07:48.000000', 'consum', 0.0231, 'lps'),
	(627622, 133, '2015-01-01 00:07:49.000000', 'consum', 0.0214, 'lps'),
	(627623, 133, '2015-01-01 00:07:50.000000', 'consum', 0.0233, 'lps'),
	(627624, 133, '2015-01-01 00:07:51.000000', 'consum', 0.0215, 'lps'),
	(627625, 133, '2015-01-01 00:07:52.000000', 'consum', 0.0232, 'lps'),
	(627626, 133, '2015-01-01 00:07:53.000000', 'consum', 0.0210, 'lps'),
	(627627, 133, '2015-01-01 00:07:54.000000', 'consum', 0.0210, 'lps'),
	(627628, 133, '2015-01-01 00:07:55.000000', 'consum', 0.0239, 'lps'),
	(627629, 133, '2015-01-01 00:07:56.000000', 'consum', 0.0229, 'lps'),
	(627630, 133, '2015-01-01 00:07:57.000000', 'consum', 0.0217, 'lps'),
	(627631, 133, '2015-01-01 00:07:58.000000', 'consum', 0.0221, 'lps'),
	(627632, 133, '2015-01-01 00:07:59.000000', 'consum', 0.0214, 'lps'),
	(627633, 133, '2015-01-01 00:08:00.000000', 'consum', 0.0229, 'lps'),
	(627634, 133, '2015-01-01 00:08:01.000000', 'consum', 0.0229, 'lps'),
	(627635, 133, '2015-01-01 00:08:02.000000', 'consum', 0.0215, 'lps'),
	(627636, 133, '2015-01-01 00:08:03.000000', 'consum', 0.0210, 'lps'),
	(627637, 133, '2015-01-01 00:08:04.000000', 'consum', 0.0230, 'lps'),
	(627638, 133, '2015-01-01 00:08:05.000000', 'consum', 0.0214, 'lps'),
	(627639, 133, '2015-01-01 00:08:06.000000', 'consum', 0.0236, 'lps'),
	(627640, 133, '2015-01-01 00:08:07.000000', 'consum', 0.0232, 'lps'),
	(627641, 133, '2015-01-01 00:08:08.000000', 'consum', 0.0241, 'lps'),
	(627642, 133, '2015-01-01 00:08:09.000000', 'consum', 0.0234, 'lps'),
	(627643, 133, '2015-01-01 00:08:10.000000', 'consum', 0.0239, 'lps'),
	(627644, 133, '2015-01-01 00:08:11.000000', 'consum', 0.0221, 'lps'),
	(627645, 133, '2015-01-01 00:08:12.000000', 'consum', 0.0210, 'lps'),
	(627646, 133, '2015-01-01 00:08:13.000000', 'consum', 0.0241, 'lps'),
	(627647, 133, '2015-01-01 00:08:14.000000', 'consum', 0.0235, 'lps'),
	(627648, 133, '2015-01-01 00:08:15.000000', 'consum', 0.0214, 'lps'),
	(627649, 133, '2015-01-01 00:08:16.000000', 'consum', 0.0220, 'lps'),
	(627650, 133, '2015-01-01 00:08:17.000000', 'consum', 0.0213, 'lps'),
	(627651, 133, '2015-01-01 00:08:18.000000', 'consum', 0.0230, 'lps'),
	(627652, 133, '2015-01-01 00:08:19.000000', 'consum', 0.0237, 'lps'),
	(627653, 133, '2015-01-01 00:08:20.000000', 'consum', 0.0219, 'lps'),
	(627654, 133, '2015-01-01 00:08:21.000000', 'consum', 0.0210, 'lps'),
	(627655, 133, '2015-01-01 00:08:22.000000', 'consum', 0.0213, 'lps'),
	(627656, 133, '2015-01-01 00:08:23.000000', 'consum', 0.0228, 'lps'),
	(627657, 133, '2015-01-01 00:08:24.000000', 'consum', 0.0226, 'lps'),
	(627658, 133, '2015-01-01 00:08:25.000000', 'consum', 0.0235, 'lps'),
	(627659, 133, '2015-01-01 00:08:26.000000', 'consum', 0.0223, 'lps'),
	(627660, 133, '2015-01-01 00:08:27.000000', 'consum', 0.0235, 'lps'),
	(627661, 133, '2015-01-01 00:08:28.000000', 'consum', 0.0233, 'lps'),
	(627662, 133, '2015-01-01 00:08:29.000000', 'consum', 0.0220, 'lps'),
	(627663, 133, '2015-01-01 00:08:30.000000', 'consum', 0.0220, 'lps'),
	(627664, 133, '2015-01-01 00:08:31.000000', 'consum', 0.0231, 'lps'),
	(627665, 133, '2015-01-01 00:08:32.000000', 'consum', 0.0224, 'lps'),
	(627666, 133, '2015-01-01 00:08:33.000000', 'consum', 0.0216, 'lps'),
	(627667, 133, '2015-01-01 00:08:34.000000', 'consum', 0.0232, 'lps'),
	(627668, 133, '2015-01-01 00:08:35.000000', 'consum', 0.0237, 'lps'),
	(627669, 133, '2015-01-01 00:08:36.000000', 'consum', 0.0214, 'lps'),
	(627670, 133, '2015-01-01 00:08:37.000000', 'consum', 0.0214, 'lps'),
	(627671, 133, '2015-01-01 00:08:38.000000', 'consum', 0.0220, 'lps'),
	(627672, 133, '2015-01-01 00:08:39.000000', 'consum', 0.0218, 'lps'),
	(627673, 133, '2015-01-01 00:08:40.000000', 'consum', 0.0217, 'lps'),
	(627674, 133, '2015-01-01 00:08:41.000000', 'consum', 0.0224, 'lps'),
	(627675, 133, '2015-01-01 00:08:42.000000', 'consum', 0.0225, 'lps'),
	(627676, 133, '2015-01-01 00:08:43.000000', 'consum', 0.0215, 'lps'),
	(627677, 133, '2015-01-01 00:08:44.000000', 'consum', 0.0219, 'lps'),
	(627678, 133, '2015-01-01 00:08:45.000000', 'consum', 0.0210, 'lps'),
	(627679, 133, '2015-01-01 00:08:46.000000', 'consum', 0.0214, 'lps'),
	(627680, 133, '2015-01-01 00:08:47.000000', 'consum', 0.0231, 'lps'),
	(627681, 133, '2015-01-01 00:08:48.000000', 'consum', 0.0238, 'lps'),
	(627682, 133, '2015-01-01 00:08:49.000000', 'consum', 0.0224, 'lps'),
	(627683, 133, '2015-01-01 00:08:50.000000', 'consum', 0.0230, 'lps'),
	(627684, 133, '2015-01-01 00:08:51.000000', 'consum', 0.0235, 'lps'),
	(627685, 133, '2015-01-01 00:08:52.000000', 'consum', 0.0211, 'lps'),
	(627686, 133, '2015-01-01 00:08:53.000000', 'consum', 0.0238, 'lps'),
	(627687, 133, '2015-01-01 00:08:54.000000', 'consum', 0.0217, 'lps'),
	(627688, 133, '2015-01-01 00:08:55.000000', 'consum', 0.0228, 'lps'),
	(627689, 133, '2015-01-01 00:08:56.000000', 'consum', 0.0216, 'lps'),
	(627690, 133, '2015-01-01 00:08:57.000000', 'consum', 0.0219, 'lps'),
	(627691, 133, '2015-01-01 00:08:58.000000', 'consum', 0.0237, 'lps'),
	(627692, 133, '2015-01-01 00:08:59.000000', 'consum', 0.0224, 'lps'),
	(627693, 133, '2015-01-01 00:09:00.000000', 'consum', 0.0229, 'lps'),
	(627694, 133, '2015-01-01 00:09:01.000000', 'consum', 0.0233, 'lps'),
	(627695, 133, '2015-01-01 00:09:02.000000', 'consum', 0.0236, 'lps'),
	(627696, 133, '2015-01-01 00:09:03.000000', 'consum', 0.0240, 'lps'),
	(627697, 133, '2015-01-01 00:09:04.000000', 'consum', 0.0218, 'lps'),
	(627698, 133, '2015-01-01 00:09:05.000000', 'consum', 0.0225, 'lps'),
	(627699, 133, '2015-01-01 00:09:06.000000', 'consum', 0.0229, 'lps'),
	(627700, 133, '2015-01-01 00:09:07.000000', 'consum', 0.0227, 'lps'),
	(627701, 133, '2015-01-01 00:09:08.000000', 'consum', 0.0238, 'lps'),
	(627702, 133, '2015-01-01 00:09:09.000000', 'consum', 0.0239, 'lps'),
	(627703, 133, '2015-01-01 00:09:10.000000', 'consum', 0.0237, 'lps'),
	(627704, 133, '2015-01-01 00:09:11.000000', 'consum', 0.0225, 'lps'),
	(627705, 133, '2015-01-01 00:09:12.000000', 'consum', 0.0238, 'lps'),
	(627706, 133, '2015-01-01 00:09:13.000000', 'consum', 0.0241, 'lps'),
	(627707, 133, '2015-01-01 00:09:14.000000', 'consum', 0.0216, 'lps'),
	(627708, 133, '2015-01-01 00:09:15.000000', 'consum', 0.0214, 'lps'),
	(627709, 133, '2015-01-01 00:09:16.000000', 'consum', 0.0212, 'lps'),
	(627710, 133, '2015-01-01 00:09:17.000000', 'consum', 0.0239, 'lps'),
	(627711, 133, '2015-01-01 00:09:18.000000', 'consum', 0.0222, 'lps'),
	(627712, 133, '2015-01-01 00:09:19.000000', 'consum', 0.0215, 'lps'),
	(627713, 133, '2015-01-01 00:09:20.000000', 'consum', 0.0230, 'lps'),
	(627714, 133, '2015-01-01 00:09:21.000000', 'consum', 0.0232, 'lps'),
	(627715, 133, '2015-01-01 00:09:22.000000', 'consum', 0.0231, 'lps'),
	(627716, 133, '2015-01-01 00:09:23.000000', 'consum', 0.0216, 'lps'),
	(627717, 133, '2015-01-01 00:09:24.000000', 'consum', 0.0240, 'lps'),
	(627718, 133, '2015-01-01 00:09:25.000000', 'consum', 0.0215, 'lps'),
	(627719, 133, '2015-01-01 00:09:26.000000', 'consum', 0.0240, 'lps'),
	(627720, 133, '2015-01-01 00:09:27.000000', 'consum', 0.0220, 'lps'),
	(627721, 133, '2015-01-01 00:09:28.000000', 'consum', 0.0233, 'lps'),
	(627722, 133, '2015-01-01 00:09:29.000000', 'consum', 0.0231, 'lps'),
	(627723, 133, '2015-01-01 00:09:30.000000', 'consum', 0.0213, 'lps'),
	(627724, 133, '2015-01-01 00:09:31.000000', 'consum', 0.0230, 'lps'),
	(627725, 133, '2015-01-01 00:09:32.000000', 'consum', 0.0237, 'lps'),
	(627726, 133, '2015-01-01 00:09:33.000000', 'consum', 0.0220, 'lps'),
	(627727, 133, '2015-01-01 00:09:34.000000', 'consum', 0.0213, 'lps'),
	(627728, 133, '2015-01-01 00:09:35.000000', 'consum', 0.0227, 'lps'),
	(627729, 133, '2015-01-01 00:09:36.000000', 'consum', 0.0224, 'lps'),
	(627730, 133, '2015-01-01 00:09:37.000000', 'consum', 0.0231, 'lps'),
	(627731, 133, '2015-01-01 00:09:38.000000', 'consum', 0.0238, 'lps'),
	(627732, 133, '2015-01-01 00:09:39.000000', 'consum', 0.0223, 'lps'),
	(627733, 133, '2015-01-01 00:09:40.000000', 'consum', 0.0226, 'lps'),
	(627734, 133, '2015-01-01 00:09:41.000000', 'consum', 0.0218, 'lps'),
	(627735, 133, '2015-01-01 00:09:42.000000', 'consum', 0.0235, 'lps'),
	(627736, 133, '2015-01-01 00:09:43.000000', 'consum', 0.0214, 'lps'),
	(627737, 133, '2015-01-01 00:09:44.000000', 'consum', 0.0220, 'lps'),
	(627738, 133, '2015-01-01 00:09:45.000000', 'consum', 0.0217, 'lps'),
	(627739, 133, '2015-01-01 00:09:46.000000', 'consum', 0.0215, 'lps'),
	(627740, 133, '2015-01-01 00:09:47.000000', 'consum', 0.0213, 'lps'),
	(627741, 133, '2015-01-01 00:09:48.000000', 'consum', 0.0212, 'lps'),
	(627742, 133, '2015-01-01 00:09:49.000000', 'consum', 0.0210, 'lps'),
	(627743, 133, '2015-01-01 00:09:50.000000', 'consum', 0.0235, 'lps'),
	(627744, 133, '2015-01-01 00:09:51.000000', 'consum', 0.0211, 'lps'),
	(627745, 133, '2015-01-01 00:09:52.000000', 'consum', 0.0236, 'lps'),
	(627746, 133, '2015-01-01 00:09:53.000000', 'consum', 0.0211, 'lps'),
	(627747, 133, '2015-01-01 00:09:54.000000', 'consum', 0.0232, 'lps'),
	(627748, 133, '2015-01-01 00:09:55.000000', 'consum', 0.0222, 'lps'),
	(627749, 133, '2015-01-01 00:09:56.000000', 'consum', 0.0236, 'lps'),
	(627750, 133, '2015-01-01 00:09:57.000000', 'consum', 0.0240, 'lps'),
	(627751, 133, '2015-01-01 00:09:58.000000', 'consum', 0.0218, 'lps'),
	(627752, 133, '2015-01-01 00:09:59.000000', 'consum', 0.0225, 'lps'),
	(627753, 133, '2015-01-01 00:10:00.000000', 'consum', 0.0231, 'lps'),
	(627754, 133, '2015-01-01 00:10:01.000000', 'consum', 0.0237, 'lps'),
	(627755, 133, '2015-01-01 00:10:02.000000', 'consum', 0.0218, 'lps'),
	(627756, 133, '2015-01-01 00:10:03.000000', 'consum', 0.0234, 'lps'),
	(627757, 133, '2015-01-01 00:10:04.000000', 'consum', 0.0210, 'lps'),
	(627758, 133, '2015-01-01 00:10:05.000000', 'consum', 0.0233, 'lps'),
	(627759, 133, '2015-01-01 00:10:06.000000', 'consum', 0.0231, 'lps'),
	(627760, 133, '2015-01-01 00:10:07.000000', 'consum', 0.0216, 'lps'),
	(627761, 133, '2015-01-01 00:10:08.000000', 'consum', 0.0239, 'lps'),
	(627762, 133, '2015-01-01 00:10:09.000000', 'consum', 0.0210, 'lps'),
	(627763, 133, '2015-01-01 00:10:10.000000', 'consum', 0.0221, 'lps'),
	(627764, 133, '2015-01-01 00:10:11.000000', 'consum', 0.0232, 'lps'),
	(627765, 133, '2015-01-01 00:10:12.000000', 'consum', 0.0226, 'lps'),
	(627766, 133, '2015-01-01 00:10:13.000000', 'consum', 0.0222, 'lps'),
	(627767, 133, '2015-01-01 00:10:14.000000', 'consum', 0.0223, 'lps'),
	(627768, 133, '2015-01-01 00:10:15.000000', 'consum', 0.0210, 'lps'),
	(627769, 133, '2015-01-01 00:10:16.000000', 'consum', 0.0232, 'lps'),
	(627770, 133, '2015-01-01 00:10:17.000000', 'consum', 0.0225, 'lps'),
	(627771, 133, '2015-01-01 00:10:18.000000', 'consum', 0.0221, 'lps'),
	(627772, 133, '2015-01-01 00:10:19.000000', 'consum', 0.0219, 'lps'),
	(627773, 133, '2015-01-01 00:10:20.000000', 'consum', 0.0225, 'lps'),
	(627774, 133, '2015-01-01 00:10:21.000000', 'consum', 0.0224, 'lps'),
	(627775, 133, '2015-01-01 00:10:22.000000', 'consum', 0.0236, 'lps'),
	(627776, 133, '2015-01-01 00:10:23.000000', 'consum', 0.0235, 'lps'),
	(627777, 133, '2015-01-01 00:10:24.000000', 'consum', 0.0223, 'lps'),
	(627778, 133, '2015-01-01 00:10:25.000000', 'consum', 0.0236, 'lps'),
	(627779, 133, '2015-01-01 00:10:26.000000', 'consum', 0.0236, 'lps'),
	(627780, 133, '2015-01-01 00:10:27.000000', 'consum', 0.0232, 'lps'),
	(627781, 133, '2015-01-01 00:10:28.000000', 'consum', 0.0241, 'lps'),
	(627782, 133, '2015-01-01 00:10:29.000000', 'consum', 0.0236, 'lps'),
	(627783, 133, '2015-01-01 00:10:30.000000', 'consum', 0.0217, 'lps'),
	(627784, 133, '2015-01-01 00:10:31.000000', 'consum', 0.0230, 'lps'),
	(627785, 133, '2015-01-01 00:10:32.000000', 'consum', 0.0228, 'lps'),
	(627786, 133, '2015-01-01 00:10:33.000000', 'consum', 0.0239, 'lps'),
	(627787, 133, '2015-01-01 00:10:34.000000', 'consum', 0.0236, 'lps'),
	(627788, 133, '2015-01-01 00:10:35.000000', 'consum', 0.0222, 'lps'),
	(627789, 133, '2015-01-01 00:10:36.000000', 'consum', 0.0225, 'lps'),
	(627790, 133, '2015-01-01 00:10:37.000000', 'consum', 0.0215, 'lps'),
	(627791, 133, '2015-01-01 00:10:38.000000', 'consum', 0.0226, 'lps'),
	(627792, 133, '2015-01-01 00:10:39.000000', 'consum', 0.0211, 'lps'),
	(627793, 133, '2015-01-01 00:10:40.000000', 'consum', 0.0231, 'lps'),
	(627794, 133, '2015-01-01 00:10:41.000000', 'consum', 0.0217, 'lps'),
	(627795, 133, '2015-01-01 00:10:42.000000', 'consum', 0.0212, 'lps'),
	(627796, 133, '2015-01-01 00:10:43.000000', 'consum', 0.0235, 'lps'),
	(627797, 133, '2015-01-01 00:10:44.000000', 'consum', 0.0231, 'lps'),
	(627798, 133, '2015-01-01 00:10:45.000000', 'consum', 0.0211, 'lps'),
	(627799, 133, '2015-01-01 00:10:46.000000', 'consum', 0.0216, 'lps'),
	(627800, 133, '2015-01-01 00:10:47.000000', 'consum', 0.0238, 'lps'),
	(627801, 133, '2015-01-01 00:10:48.000000', 'consum', 0.0237, 'lps'),
	(627802, 133, '2015-01-01 00:10:49.000000', 'consum', 0.0231, 'lps'),
	(627803, 133, '2015-01-01 00:10:50.000000', 'consum', 0.0231, 'lps'),
	(627804, 133, '2015-01-01 00:10:51.000000', 'consum', 0.0221, 'lps'),
	(627805, 133, '2015-01-01 00:10:52.000000', 'consum', 0.0235, 'lps'),
	(627806, 133, '2015-01-01 00:10:53.000000', 'consum', 0.0238, 'lps'),
	(627807, 133, '2015-01-01 00:10:54.000000', 'consum', 0.0213, 'lps'),
	(627808, 133, '2015-01-01 00:10:55.000000', 'consum', 0.0239, 'lps'),
	(627809, 133, '2015-01-01 00:10:56.000000', 'consum', 0.0216, 'lps'),
	(627810, 133, '2015-01-01 00:10:57.000000', 'consum', 0.0218, 'lps'),
	(627811, 133, '2015-01-01 00:10:58.000000', 'consum', 0.0232, 'lps'),
	(627812, 133, '2015-01-01 00:10:59.000000', 'consum', 0.0232, 'lps'),
	(627813, 133, '2015-01-01 00:11:00.000000', 'consum', 0.0223, 'lps'),
	(627814, 133, '2015-01-01 00:11:01.000000', 'consum', 0.0210, 'lps'),
	(627815, 133, '2015-01-01 00:11:02.000000', 'consum', 0.0233, 'lps'),
	(627816, 133, '2015-01-01 00:11:03.000000', 'consum', 0.0233, 'lps'),
	(627817, 133, '2015-01-01 00:11:04.000000', 'consum', 0.0223, 'lps'),
	(627818, 133, '2015-01-01 00:11:05.000000', 'consum', 0.0237, 'lps'),
	(627819, 133, '2015-01-01 00:11:06.000000', 'consum', 0.0210, 'lps'),
	(627820, 133, '2015-01-01 00:11:07.000000', 'consum', 0.0226, 'lps'),
	(627821, 133, '2015-01-01 00:11:08.000000', 'consum', 0.0229, 'lps'),
	(627822, 133, '2015-01-01 00:11:09.000000', 'consum', 0.0223, 'lps'),
	(627823, 133, '2015-01-01 00:11:10.000000', 'consum', 0.0221, 'lps'),
	(627824, 133, '2015-01-01 00:11:11.000000', 'consum', 0.0226, 'lps'),
	(627825, 133, '2015-01-01 00:11:12.000000', 'consum', 0.0226, 'lps'),
	(627826, 133, '2015-01-01 00:11:13.000000', 'consum', 0.0210, 'lps'),
	(627827, 133, '2015-01-01 00:11:14.000000', 'consum', 0.0228, 'lps'),
	(627828, 133, '2015-01-01 00:11:15.000000', 'consum', 0.0234, 'lps'),
	(627829, 133, '2015-01-01 00:11:16.000000', 'consum', 0.0213, 'lps'),
	(627830, 133, '2015-01-01 00:11:17.000000', 'consum', 0.0218, 'lps'),
	(627831, 133, '2015-01-01 00:11:18.000000', 'consum', 0.0241, 'lps'),
	(627832, 133, '2015-01-01 00:11:19.000000', 'consum', 0.0215, 'lps'),
	(627833, 133, '2015-01-01 00:11:20.000000', 'consum', 0.0239, 'lps'),
	(627834, 133, '2015-01-01 00:11:21.000000', 'consum', 0.0211, 'lps'),
	(627835, 133, '2015-01-01 00:11:22.000000', 'consum', 0.0225, 'lps'),
	(627836, 133, '2015-01-01 00:11:23.000000', 'consum', 0.0217, 'lps'),
	(627837, 133, '2015-01-01 00:11:24.000000', 'consum', 0.0232, 'lps'),
	(627838, 133, '2015-01-01 00:11:25.000000', 'consum', 0.0237, 'lps'),
	(627839, 133, '2015-01-01 00:11:26.000000', 'consum', 0.0216, 'lps'),
	(627840, 133, '2015-01-01 00:11:27.000000', 'consum', 0.0225, 'lps'),
	(627841, 133, '2015-01-01 00:11:28.000000', 'consum', 0.0233, 'lps'),
	(627842, 133, '2015-01-01 00:11:29.000000', 'consum', 0.0216, 'lps'),
	(627843, 133, '2015-01-01 00:11:30.000000', 'consum', 0.0235, 'lps'),
	(627844, 133, '2015-01-01 00:11:31.000000', 'consum', 0.0223, 'lps'),
	(627845, 133, '2015-01-01 00:11:32.000000', 'consum', 0.0233, 'lps'),
	(627846, 133, '2015-01-01 00:11:33.000000', 'consum', 0.0222, 'lps'),
	(627847, 133, '2015-01-01 00:11:34.000000', 'consum', 0.0233, 'lps'),
	(627848, 133, '2015-01-01 00:11:35.000000', 'consum', 0.0227, 'lps'),
	(627849, 133, '2015-01-01 00:11:36.000000', 'consum', 0.0225, 'lps'),
	(627850, 133, '2015-01-01 00:11:37.000000', 'consum', 0.0236, 'lps'),
	(627851, 133, '2015-01-01 00:11:38.000000', 'consum', 0.0231, 'lps'),
	(627852, 133, '2015-01-01 00:11:39.000000', 'consum', 0.0239, 'lps'),
	(627853, 133, '2015-01-01 00:11:40.000000', 'consum', 0.0226, 'lps'),
	(627854, 133, '2015-01-01 00:11:41.000000', 'consum', 0.0238, 'lps'),
	(627855, 133, '2015-01-01 00:11:42.000000', 'consum', 0.0236, 'lps'),
	(627856, 133, '2015-01-01 00:11:43.000000', 'consum', 0.0223, 'lps'),
	(627857, 133, '2015-01-01 00:11:44.000000', 'consum', 0.0233, 'lps'),
	(627858, 133, '2015-01-01 00:11:45.000000', 'consum', 0.0220, 'lps'),
	(627859, 133, '2015-01-01 00:11:46.000000', 'consum', 0.0225, 'lps'),
	(627860, 133, '2015-01-01 00:11:47.000000', 'consum', 0.0222, 'lps'),
	(627861, 133, '2015-01-01 00:11:48.000000', 'consum', 0.0227, 'lps'),
	(627862, 133, '2015-01-01 00:11:49.000000', 'consum', 0.0228, 'lps'),
	(627863, 133, '2015-01-01 00:11:50.000000', 'consum', 0.0215, 'lps'),
	(627864, 133, '2015-01-01 00:11:51.000000', 'consum', 0.0215, 'lps'),
	(627865, 133, '2015-01-01 00:11:52.000000', 'consum', 0.0222, 'lps'),
	(627866, 133, '2015-01-01 00:11:53.000000', 'consum', 0.0221, 'lps'),
	(627867, 133, '2015-01-01 00:11:54.000000', 'consum', 0.0229, 'lps'),
	(627868, 133, '2015-01-01 00:11:55.000000', 'consum', 0.0210, 'lps'),
	(627869, 133, '2015-01-01 00:11:56.000000', 'consum', 0.0215, 'lps'),
	(627870, 133, '2015-01-01 00:11:57.000000', 'consum', 0.0238, 'lps'),
	(627871, 133, '2015-01-01 00:11:58.000000', 'consum', 0.0241, 'lps'),
	(627872, 133, '2015-01-01 00:11:59.000000', 'consum', 0.0214, 'lps'),
	(627873, 133, '2015-01-01 00:12:00.000000', 'consum', 0.0236, 'lps'),
	(627874, 133, '2015-01-01 00:12:01.000000', 'consum', 0.0234, 'lps'),
	(627875, 133, '2015-01-01 00:12:02.000000', 'consum', 0.0218, 'lps'),
	(627876, 133, '2015-01-01 00:12:03.000000', 'consum', 0.0210, 'lps'),
	(627877, 133, '2015-01-01 00:12:04.000000', 'consum', 0.0220, 'lps'),
	(627878, 133, '2015-01-01 00:12:05.000000', 'consum', 0.0226, 'lps'),
	(627879, 133, '2015-01-01 00:12:06.000000', 'consum', 0.0230, 'lps'),
	(627880, 133, '2015-01-01 00:12:07.000000', 'consum', 0.0229, 'lps'),
	(627881, 133, '2015-01-01 00:12:08.000000', 'consum', 0.0214, 'lps'),
	(627882, 133, '2015-01-01 00:12:09.000000', 'consum', 0.0238, 'lps'),
	(627883, 133, '2015-01-01 00:12:10.000000', 'consum', 0.0210, 'lps'),
	(627884, 133, '2015-01-01 00:12:11.000000', 'consum', 0.0224, 'lps'),
	(627885, 133, '2015-01-01 00:12:12.000000', 'consum', 0.0216, 'lps'),
	(627886, 133, '2015-01-01 00:12:13.000000', 'consum', 0.0231, 'lps'),
	(627887, 133, '2015-01-01 00:12:14.000000', 'consum', 0.0233, 'lps'),
	(627888, 133, '2015-01-01 00:12:15.000000', 'consum', 0.0228, 'lps'),
	(627889, 133, '2015-01-01 00:12:16.000000', 'consum', 0.0235, 'lps'),
	(627890, 133, '2015-01-01 00:12:17.000000', 'consum', 0.0218, 'lps'),
	(627891, 133, '2015-01-01 00:12:18.000000', 'consum', 0.0237, 'lps'),
	(627892, 133, '2015-01-01 00:12:19.000000', 'consum', 0.0227, 'lps'),
	(627893, 133, '2015-01-01 00:12:20.000000', 'consum', 0.0213, 'lps'),
	(627894, 133, '2015-01-01 00:12:21.000000', 'consum', 0.0238, 'lps'),
	(627895, 133, '2015-01-01 00:12:22.000000', 'consum', 0.0215, 'lps'),
	(627896, 133, '2015-01-01 00:12:23.000000', 'consum', 0.0213, 'lps'),
	(627897, 133, '2015-01-01 00:12:24.000000', 'consum', 0.0213, 'lps'),
	(627898, 133, '2015-01-01 00:12:25.000000', 'consum', 0.0218, 'lps'),
	(627899, 133, '2015-01-01 00:12:26.000000', 'consum', 0.0239, 'lps'),
	(627900, 133, '2015-01-01 00:12:27.000000', 'consum', 0.0236, 'lps'),
	(627901, 133, '2015-01-01 00:12:28.000000', 'consum', 0.0221, 'lps'),
	(627902, 133, '2015-01-01 00:12:29.000000', 'consum', 0.0219, 'lps'),
	(627903, 133, '2015-01-01 00:12:30.000000', 'consum', 0.0222, 'lps'),
	(627904, 133, '2015-01-01 00:12:31.000000', 'consum', 0.0212, 'lps'),
	(627905, 133, '2015-01-01 00:12:32.000000', 'consum', 0.0215, 'lps'),
	(627906, 133, '2015-01-01 00:12:33.000000', 'consum', 0.0231, 'lps'),
	(627907, 133, '2015-01-01 00:12:34.000000', 'consum', 0.0235, 'lps'),
	(627908, 133, '2015-01-01 00:12:35.000000', 'consum', 0.0239, 'lps'),
	(627909, 133, '2015-01-01 00:12:36.000000', 'consum', 0.0220, 'lps'),
	(627910, 133, '2015-01-01 00:12:37.000000', 'consum', 0.0236, 'lps'),
	(627911, 133, '2015-01-01 00:12:38.000000', 'consum', 0.0213, 'lps'),
	(627912, 133, '2015-01-01 00:12:39.000000', 'consum', 0.0213, 'lps'),
	(627913, 133, '2015-01-01 00:12:40.000000', 'consum', 0.0216, 'lps'),
	(627914, 133, '2015-01-01 00:12:41.000000', 'consum', 0.0232, 'lps'),
	(627915, 133, '2015-01-01 00:12:42.000000', 'consum', 0.0240, 'lps'),
	(627916, 133, '2015-01-01 00:12:43.000000', 'consum', 0.0228, 'lps'),
	(627917, 133, '2015-01-01 00:12:44.000000', 'consum', 0.0210, 'lps'),
	(627918, 133, '2015-01-01 00:12:45.000000', 'consum', 0.0221, 'lps'),
	(627919, 133, '2015-01-01 00:12:46.000000', 'consum', 0.0235, 'lps'),
	(627920, 133, '2015-01-01 00:12:47.000000', 'consum', 0.0236, 'lps'),
	(627921, 133, '2015-01-01 00:12:48.000000', 'consum', 0.0233, 'lps'),
	(627922, 133, '2015-01-01 00:12:49.000000', 'consum', 0.0215, 'lps'),
	(627923, 133, '2015-01-01 00:12:50.000000', 'consum', 0.0234, 'lps'),
	(627924, 133, '2015-01-01 00:12:51.000000', 'consum', 0.0216, 'lps'),
	(627925, 133, '2015-01-01 00:12:52.000000', 'consum', 0.0234, 'lps'),
	(627926, 133, '2015-01-01 00:12:53.000000', 'consum', 0.0216, 'lps'),
	(627927, 133, '2015-01-01 00:12:54.000000', 'consum', 0.0232, 'lps'),
	(627928, 133, '2015-01-01 00:12:55.000000', 'consum', 0.0241, 'lps'),
	(627929, 133, '2015-01-01 00:12:56.000000', 'consum', 0.0234, 'lps'),
	(627930, 133, '2015-01-01 00:12:57.000000', 'consum', 0.0238, 'lps'),
	(627931, 133, '2015-01-01 00:12:58.000000', 'consum', 0.0216, 'lps'),
	(627932, 133, '2015-01-01 00:12:59.000000', 'consum', 0.0219, 'lps'),
	(627933, 133, '2015-01-01 00:13:00.000000', 'consum', 0.0236, 'lps'),
	(627934, 133, '2015-01-01 00:13:01.000000', 'consum', 0.0218, 'lps'),
	(627935, 133, '2015-01-01 00:13:02.000000', 'consum', 0.0236, 'lps'),
	(627936, 133, '2015-01-01 00:13:03.000000', 'consum', 0.0223, 'lps'),
	(627937, 133, '2015-01-01 00:13:04.000000', 'consum', 0.0229, 'lps'),
	(627938, 133, '2015-01-01 00:13:05.000000', 'consum', 0.0235, 'lps'),
	(627939, 133, '2015-01-01 00:13:06.000000', 'consum', 0.0214, 'lps'),
	(627940, 133, '2015-01-01 00:13:07.000000', 'consum', 0.0218, 'lps'),
	(627941, 133, '2015-01-01 00:13:08.000000', 'consum', 0.0241, 'lps'),
	(627942, 133, '2015-01-01 00:13:09.000000', 'consum', 0.0215, 'lps'),
	(627943, 133, '2015-01-01 00:13:10.000000', 'consum', 0.0235, 'lps'),
	(627944, 133, '2015-01-01 00:13:11.000000', 'consum', 0.0224, 'lps'),
	(627945, 133, '2015-01-01 00:13:12.000000', 'consum', 0.0238, 'lps'),
	(627946, 133, '2015-01-01 00:13:13.000000', 'consum', 0.0212, 'lps'),
	(627947, 133, '2015-01-01 00:13:14.000000', 'consum', 0.0233, 'lps'),
	(627948, 133, '2015-01-01 00:13:15.000000', 'consum', 0.0225, 'lps'),
	(627949, 133, '2015-01-01 00:13:16.000000', 'consum', 0.0214, 'lps'),
	(627950, 133, '2015-01-01 00:13:17.000000', 'consum', 0.0219, 'lps'),
	(627951, 133, '2015-01-01 00:13:18.000000', 'consum', 0.0212, 'lps'),
	(627952, 133, '2015-01-01 00:13:19.000000', 'consum', 0.0225, 'lps'),
	(627953, 133, '2015-01-01 00:13:20.000000', 'consum', 0.0217, 'lps'),
	(627954, 133, '2015-01-01 00:13:21.000000', 'consum', 0.0233, 'lps'),
	(627955, 133, '2015-01-01 00:13:22.000000', 'consum', 0.0239, 'lps'),
	(627956, 133, '2015-01-01 00:13:23.000000', 'consum', 0.0221, 'lps'),
	(627957, 133, '2015-01-01 00:13:24.000000', 'consum', 0.0213, 'lps'),
	(627958, 133, '2015-01-01 00:13:25.000000', 'consum', 0.0225, 'lps'),
	(627959, 133, '2015-01-01 00:13:26.000000', 'consum', 0.0214, 'lps'),
	(627960, 133, '2015-01-01 00:13:27.000000', 'consum', 0.0214, 'lps'),
	(627961, 133, '2015-01-01 00:13:28.000000', 'consum', 0.0219, 'lps'),
	(627962, 133, '2015-01-01 00:13:29.000000', 'consum', 0.0211, 'lps'),
	(627963, 133, '2015-01-01 00:13:30.000000', 'consum', 0.0222, 'lps'),
	(627964, 133, '2015-01-01 00:13:31.000000', 'consum', 0.0237, 'lps'),
	(627965, 133, '2015-01-01 00:13:32.000000', 'consum', 0.0212, 'lps'),
	(627966, 133, '2015-01-01 00:13:33.000000', 'consum', 0.0237, 'lps'),
	(627967, 133, '2015-01-01 00:13:34.000000', 'consum', 0.0212, 'lps'),
	(627968, 133, '2015-01-01 00:13:35.000000', 'consum', 0.0234, 'lps'),
	(627969, 133, '2015-01-01 00:13:36.000000', 'consum', 0.0227, 'lps'),
	(627970, 133, '2015-01-01 00:13:37.000000', 'consum', 0.0225, 'lps'),
	(627971, 133, '2015-01-01 00:13:38.000000', 'consum', 0.0234, 'lps'),
	(627972, 133, '2015-01-01 00:13:39.000000', 'consum', 0.0223, 'lps'),
	(627973, 133, '2015-01-01 00:13:40.000000', 'consum', 0.0235, 'lps'),
	(627974, 133, '2015-01-01 00:13:41.000000', 'consum', 0.0232, 'lps'),
	(627975, 133, '2015-01-01 00:13:42.000000', 'consum', 0.0212, 'lps'),
	(627976, 133, '2015-01-01 00:13:43.000000', 'consum', 0.0221, 'lps'),
	(627977, 133, '2015-01-01 00:13:44.000000', 'consum', 0.0228, 'lps'),
	(627978, 133, '2015-01-01 00:13:45.000000', 'consum', 0.0234, 'lps'),
	(627979, 133, '2015-01-01 00:13:46.000000', 'consum', 0.0212, 'lps'),
	(627980, 133, '2015-01-01 00:13:47.000000', 'consum', 0.0214, 'lps'),
	(627981, 133, '2015-01-01 00:13:48.000000', 'consum', 0.0223, 'lps'),
	(627982, 133, '2015-01-01 00:13:49.000000', 'consum', 0.0230, 'lps'),
	(627983, 133, '2015-01-01 00:13:50.000000', 'consum', 0.0210, 'lps'),
	(627984, 133, '2015-01-01 00:13:51.000000', 'consum', 0.0215, 'lps'),
	(627985, 133, '2015-01-01 00:13:52.000000', 'consum', 0.0236, 'lps'),
	(627986, 133, '2015-01-01 00:13:53.000000', 'consum', 0.0228, 'lps'),
	(627987, 133, '2015-01-01 00:13:54.000000', 'consum', 0.0225, 'lps'),
	(627988, 133, '2015-01-01 00:13:55.000000', 'consum', 0.0229, 'lps'),
	(627989, 133, '2015-01-01 00:13:56.000000', 'consum', 0.0227, 'lps'),
	(627990, 133, '2015-01-01 00:13:57.000000', 'consum', 0.0241, 'lps'),
	(627991, 133, '2015-01-01 00:13:58.000000', 'consum', 0.0217, 'lps'),
	(627992, 133, '2015-01-01 00:13:59.000000', 'consum', 0.0217, 'lps'),
	(627993, 133, '2015-01-01 00:14:00.000000', 'consum', 0.0223, 'lps'),
	(627994, 133, '2015-01-01 00:14:01.000000', 'consum', 0.0226, 'lps'),
	(627995, 133, '2015-01-01 00:14:02.000000', 'consum', 0.0216, 'lps'),
	(627996, 133, '2015-01-01 00:14:03.000000', 'consum', 0.0228, 'lps'),
	(627997, 133, '2015-01-01 00:14:04.000000', 'consum', 0.0215, 'lps'),
	(627998, 133, '2015-01-01 00:14:05.000000', 'consum', 0.0216, 'lps'),
	(627999, 133, '2015-01-01 00:14:06.000000', 'consum', 0.0224, 'lps'),
	(628000, 133, '2015-01-01 00:14:07.000000', 'consum', 0.0232, 'lps'),
	(628001, 133, '2015-01-01 00:14:08.000000', 'consum', 0.0212, 'lps'),
	(628002, 133, '2015-01-01 00:14:09.000000', 'consum', 0.0219, 'lps'),
	(628003, 133, '2015-01-01 00:14:10.000000', 'consum', 0.0219, 'lps'),
	(628004, 133, '2015-01-01 00:14:11.000000', 'consum', 0.0226, 'lps'),
	(628005, 133, '2015-01-01 00:14:12.000000', 'consum', 0.0232, 'lps'),
	(628006, 133, '2015-01-01 00:14:13.000000', 'consum', 0.0210, 'lps'),
	(628007, 133, '2015-01-01 00:14:14.000000', 'consum', 0.0239, 'lps'),
	(628008, 133, '2015-01-01 00:14:15.000000', 'consum', 0.0226, 'lps'),
	(628009, 133, '2015-01-01 00:14:16.000000', 'consum', 0.0239, 'lps'),
	(628010, 133, '2015-01-01 00:14:17.000000', 'consum', 0.0210, 'lps'),
	(628011, 133, '2015-01-01 00:14:18.000000', 'consum', 0.0220, 'lps'),
	(628012, 133, '2015-01-01 00:14:19.000000', 'consum', 0.0227, 'lps'),
	(628013, 133, '2015-01-01 00:14:20.000000', 'consum', 0.0233, 'lps'),
	(628014, 133, '2015-01-01 00:14:21.000000', 'consum', 0.0213, 'lps'),
	(628015, 133, '2015-01-01 00:14:22.000000', 'consum', 0.0221, 'lps'),
	(628016, 133, '2015-01-01 00:14:23.000000', 'consum', 0.0225, 'lps'),
	(628017, 133, '2015-01-01 00:14:24.000000', 'consum', 0.0217, 'lps'),
	(628018, 133, '2015-01-01 00:14:25.000000', 'consum', 0.0236, 'lps'),
	(628019, 133, '2015-01-01 00:14:26.000000', 'consum', 0.0221, 'lps'),
	(628020, 133, '2015-01-01 00:14:27.000000', 'consum', 0.0221, 'lps'),
	(628021, 133, '2015-01-01 00:14:28.000000', 'consum', 0.0234, 'lps'),
	(628022, 133, '2015-01-01 00:14:29.000000', 'consum', 0.0232, 'lps'),
	(628023, 133, '2015-01-01 00:14:30.000000', 'consum', 0.0218, 'lps'),
	(628024, 133, '2015-01-01 00:14:31.000000', 'consum', 0.0217, 'lps'),
	(628025, 133, '2015-01-01 00:14:32.000000', 'consum', 0.0220, 'lps'),
	(628026, 133, '2015-01-01 00:14:33.000000', 'consum', 0.0240, 'lps'),
	(628027, 133, '2015-01-01 00:14:34.000000', 'consum', 0.0235, 'lps'),
	(628028, 133, '2015-01-01 00:14:35.000000', 'consum', 0.0215, 'lps'),
	(628029, 133, '2015-01-01 00:14:36.000000', 'consum', 0.0223, 'lps'),
	(628030, 133, '2015-01-01 00:14:37.000000', 'consum', 0.0229, 'lps'),
	(628031, 133, '2015-01-01 00:14:38.000000', 'consum', 0.0233, 'lps'),
	(628032, 133, '2015-01-01 00:14:39.000000', 'consum', 0.0239, 'lps'),
	(628033, 133, '2015-01-01 00:14:40.000000', 'consum', 0.0220, 'lps'),
	(628034, 133, '2015-01-01 00:14:41.000000', 'consum', 0.0238, 'lps'),
	(628035, 133, '2015-01-01 00:14:42.000000', 'consum', 0.0227, 'lps'),
	(628036, 133, '2015-01-01 00:14:43.000000', 'consum', 0.0240, 'lps'),
	(628037, 133, '2015-01-01 00:14:44.000000', 'consum', 0.0215, 'lps'),
	(628038, 133, '2015-01-01 00:14:45.000000', 'consum', 0.0240, 'lps'),
	(628039, 133, '2015-01-01 00:14:46.000000', 'consum', 0.0218, 'lps'),
	(628040, 133, '2015-01-01 00:14:47.000000', 'consum', 0.0224, 'lps'),
	(628041, 133, '2015-01-01 00:14:48.000000', 'consum', 0.0227, 'lps'),
	(628042, 133, '2015-01-01 00:14:49.000000', 'consum', 0.0219, 'lps'),
	(628043, 133, '2015-01-01 00:14:50.000000', 'consum', 0.0238, 'lps'),
	(628044, 133, '2015-01-01 00:14:51.000000', 'consum', 0.0229, 'lps'),
	(628045, 133, '2015-01-01 00:14:52.000000', 'consum', 0.0221, 'lps'),
	(628046, 133, '2015-01-01 00:14:53.000000', 'consum', 0.0239, 'lps'),
	(628047, 133, '2015-01-01 00:14:54.000000', 'consum', 0.0227, 'lps'),
	(628048, 133, '2015-01-01 00:14:55.000000', 'consum', 0.0240, 'lps'),
	(628049, 133, '2015-01-01 00:14:56.000000', 'consum', 0.0214, 'lps'),
	(628050, 133, '2015-01-01 00:14:57.000000', 'consum', 0.0237, 'lps'),
	(628051, 133, '2015-01-01 00:14:58.000000', 'consum', 0.0238, 'lps'),
	(628052, 133, '2015-01-01 00:14:59.000000', 'consum', 0.0235, 'lps'),
	(628053, 133, '2015-01-01 00:15:00.000000', 'consum', 0.0221, 'lps'),
	(628054, 133, '2015-01-01 00:15:01.000000', 'consum', 0.0220, 'lps'),
	(628055, 133, '2015-01-01 00:15:02.000000', 'consum', 0.0231, 'lps'),
	(628056, 133, '2015-01-01 00:15:03.000000', 'consum', 0.0219, 'lps'),
	(628057, 133, '2015-01-01 00:15:04.000000', 'consum', 0.0225, 'lps'),
	(628058, 133, '2015-01-01 00:15:05.000000', 'consum', 0.0228, 'lps'),
	(628059, 133, '2015-01-01 00:15:06.000000', 'consum', 0.0224, 'lps'),
	(628060, 133, '2015-01-01 00:15:07.000000', 'consum', 0.0224, 'lps'),
	(628061, 133, '2015-01-01 00:15:08.000000', 'consum', 0.0240, 'lps'),
	(628062, 133, '2015-01-01 00:15:09.000000', 'consum', 0.0222, 'lps'),
	(628063, 133, '2015-01-01 00:15:10.000000', 'consum', 0.0213, 'lps'),
	(628064, 133, '2015-01-01 00:15:11.000000', 'consum', 0.0220, 'lps'),
	(628065, 133, '2015-01-01 00:15:12.000000', 'consum', 0.0221, 'lps'),
	(628066, 133, '2015-01-01 00:15:13.000000', 'consum', 0.0236, 'lps'),
	(628067, 133, '2015-01-01 00:15:14.000000', 'consum', 0.0211, 'lps'),
	(628068, 133, '2015-01-01 00:15:15.000000', 'consum', 0.0232, 'lps'),
	(628069, 133, '2015-01-01 00:15:16.000000', 'consum', 0.0223, 'lps'),
	(628070, 133, '2015-01-01 00:15:17.000000', 'consum', 0.0240, 'lps'),
	(628071, 133, '2015-01-01 00:15:18.000000', 'consum', 0.0227, 'lps'),
	(628072, 133, '2015-01-01 00:15:19.000000', 'consum', 0.0239, 'lps'),
	(628073, 133, '2015-01-01 00:15:20.000000', 'consum', 0.0238, 'lps'),
	(628074, 133, '2015-01-01 00:15:21.000000', 'consum', 0.0233, 'lps'),
	(628075, 133, '2015-01-01 00:15:22.000000', 'consum', 0.0210, 'lps'),
	(628076, 133, '2015-01-01 00:15:23.000000', 'consum', 0.0235, 'lps'),
	(628077, 133, '2015-01-01 00:15:24.000000', 'consum', 0.0240, 'lps'),
	(628078, 133, '2015-01-01 00:15:25.000000', 'consum', 0.0223, 'lps'),
	(628079, 133, '2015-01-01 00:15:26.000000', 'consum', 0.0217, 'lps'),
	(628080, 133, '2015-01-01 00:15:27.000000', 'consum', 0.0237, 'lps'),
	(628081, 133, '2015-01-01 00:15:28.000000', 'consum', 0.0228, 'lps'),
	(628082, 133, '2015-01-01 00:15:29.000000', 'consum', 0.0219, 'lps'),
	(628083, 133, '2015-01-01 00:15:30.000000', 'consum', 0.0235, 'lps'),
	(628084, 133, '2015-01-01 00:15:31.000000', 'consum', 0.0211, 'lps'),
	(628085, 133, '2015-01-01 00:15:32.000000', 'consum', 0.0237, 'lps'),
	(628086, 133, '2015-01-01 00:15:33.000000', 'consum', 0.0214, 'lps'),
	(628087, 133, '2015-01-01 00:15:34.000000', 'consum', 0.0212, 'lps'),
	(628088, 133, '2015-01-01 00:15:35.000000', 'consum', 0.0212, 'lps'),
	(628089, 133, '2015-01-01 00:15:36.000000', 'consum', 0.0213, 'lps'),
	(628090, 133, '2015-01-01 00:15:37.000000', 'consum', 0.0219, 'lps'),
	(628091, 133, '2015-01-01 00:15:38.000000', 'consum', 0.0217, 'lps'),
	(628092, 133, '2015-01-01 00:15:39.000000', 'consum', 0.0217, 'lps'),
	(628093, 133, '2015-01-01 00:15:40.000000', 'consum', 0.0224, 'lps'),
	(628094, 133, '2015-01-01 00:15:41.000000', 'consum', 0.0229, 'lps'),
	(628095, 133, '2015-01-01 00:15:42.000000', 'consum', 0.0232, 'lps'),
	(628096, 133, '2015-01-01 00:15:43.000000', 'consum', 0.0229, 'lps'),
	(628097, 133, '2015-01-01 00:15:44.000000', 'consum', 0.0239, 'lps'),
	(628098, 133, '2015-01-01 00:15:45.000000', 'consum', 0.0237, 'lps'),
	(628099, 133, '2015-01-01 00:15:46.000000', 'consum', 0.0225, 'lps'),
	(628100, 133, '2015-01-01 00:15:47.000000', 'consum', 0.0236, 'lps'),
	(628101, 133, '2015-01-01 00:15:48.000000', 'consum', 0.0234, 'lps'),
	(628102, 133, '2015-01-01 00:15:49.000000', 'consum', 0.0217, 'lps'),
	(628103, 133, '2015-01-01 00:15:50.000000', 'consum', 0.0240, 'lps'),
	(628104, 133, '2015-01-01 00:15:51.000000', 'consum', 0.0211, 'lps'),
	(628105, 133, '2015-01-01 00:15:52.000000', 'consum', 0.0222, 'lps'),
	(628106, 133, '2015-01-01 00:15:53.000000', 'consum', 0.0237, 'lps'),
	(628107, 133, '2015-01-01 00:15:54.000000', 'consum', 0.0213, 'lps'),
	(628108, 133, '2015-01-01 00:15:55.000000', 'consum', 0.0239, 'lps'),
	(628109, 133, '2015-01-01 00:15:56.000000', 'consum', 0.0218, 'lps'),
	(628110, 133, '2015-01-01 00:15:57.000000', 'consum', 0.0230, 'lps'),
	(628111, 133, '2015-01-01 00:15:58.000000', 'consum', 0.0219, 'lps'),
	(628112, 133, '2015-01-01 00:15:59.000000', 'consum', 0.0231, 'lps'),
	(628113, 133, '2015-01-01 00:16:00.000000', 'consum', 0.0223, 'lps'),
	(628114, 133, '2015-01-01 00:16:01.000000', 'consum', 0.0214, 'lps'),
	(628115, 133, '2015-01-01 00:16:02.000000', 'consum', 0.0222, 'lps'),
	(628116, 133, '2015-01-01 00:16:03.000000', 'consum', 0.0229, 'lps'),
	(628117, 133, '2015-01-01 00:16:04.000000', 'consum', 0.0234, 'lps'),
	(628118, 133, '2015-01-01 00:16:05.000000', 'consum', 0.0212, 'lps'),
	(628119, 133, '2015-01-01 00:16:06.000000', 'consum', 0.0212, 'lps'),
	(628120, 133, '2015-01-01 00:16:07.000000', 'consum', 0.0216, 'lps'),
	(628121, 133, '2015-01-01 00:16:08.000000', 'consum', 0.0235, 'lps'),
	(628122, 133, '2015-01-01 00:16:09.000000', 'consum', 0.0222, 'lps'),
	(628123, 133, '2015-01-01 00:16:10.000000', 'consum', 0.0225, 'lps'),
	(628124, 133, '2015-01-01 00:16:11.000000', 'consum', 0.0220, 'lps'),
	(628125, 133, '2015-01-01 00:16:12.000000', 'consum', 0.0216, 'lps'),
	(628126, 133, '2015-01-01 00:16:13.000000', 'consum', 0.0210, 'lps'),
	(628127, 133, '2015-01-01 00:16:14.000000', 'consum', 0.0226, 'lps'),
	(628128, 133, '2015-01-01 00:16:15.000000', 'consum', 0.0224, 'lps'),
	(628129, 133, '2015-01-01 00:16:16.000000', 'consum', 0.0231, 'lps'),
	(628130, 133, '2015-01-01 00:16:17.000000', 'consum', 0.0213, 'lps'),
	(628131, 133, '2015-01-01 00:16:18.000000', 'consum', 0.0223, 'lps'),
	(628132, 133, '2015-01-01 00:16:19.000000', 'consum', 0.0237, 'lps'),
	(628133, 133, '2015-01-01 00:16:20.000000', 'consum', 0.0212, 'lps'),
	(628134, 133, '2015-01-01 00:16:21.000000', 'consum', 0.0232, 'lps'),
	(628135, 133, '2015-01-01 00:16:22.000000', 'consum', 0.0219, 'lps'),
	(628136, 133, '2015-01-01 00:16:23.000000', 'consum', 0.0223, 'lps'),
	(628137, 133, '2015-01-01 00:16:24.000000', 'consum', 0.0215, 'lps'),
	(628138, 133, '2015-01-01 00:16:25.000000', 'consum', 0.0229, 'lps'),
	(628139, 133, '2015-01-01 00:16:26.000000', 'consum', 0.0225, 'lps'),
	(628140, 133, '2015-01-01 00:16:27.000000', 'consum', 0.0230, 'lps'),
	(628141, 133, '2015-01-01 00:16:28.000000', 'consum', 0.0235, 'lps'),
	(628142, 133, '2015-01-01 00:16:29.000000', 'consum', 0.0241, 'lps'),
	(628143, 133, '2015-01-01 00:16:30.000000', 'consum', 0.0226, 'lps'),
	(628144, 133, '2015-01-01 00:16:31.000000', 'consum', 0.0232, 'lps'),
	(628145, 133, '2015-01-01 00:16:32.000000', 'consum', 0.0241, 'lps'),
	(628146, 133, '2015-01-01 00:16:33.000000', 'consum', 0.0233, 'lps'),
	(628147, 133, '2015-01-01 00:16:34.000000', 'consum', 0.0235, 'lps'),
	(628148, 133, '2015-01-01 00:16:35.000000', 'consum', 0.0235, 'lps'),
	(628149, 133, '2015-01-01 00:16:36.000000', 'consum', 0.0229, 'lps'),
	(628150, 133, '2015-01-01 00:16:37.000000', 'consum', 0.0228, 'lps'),
	(628151, 133, '2015-01-01 00:16:38.000000', 'consum', 0.0214, 'lps'),
	(628152, 133, '2015-01-01 00:16:39.000000', 'consum', 0.0240, 'lps'),
	(628153, 133, '2015-01-01 00:16:40.000000', 'consum', 0.0218, 'lps'),
	(628154, 133, '2015-01-01 00:16:41.000000', 'consum', 0.0228, 'lps'),
	(628155, 133, '2015-01-01 00:16:42.000000', 'consum', 0.0241, 'lps'),
	(628156, 133, '2015-01-01 00:16:43.000000', 'consum', 0.0219, 'lps'),
	(628157, 133, '2015-01-01 00:16:44.000000', 'consum', 0.0223, 'lps'),
	(628158, 133, '2015-01-01 00:16:45.000000', 'consum', 0.0219, 'lps'),
	(628159, 133, '2015-01-01 00:16:46.000000', 'consum', 0.0214, 'lps'),
	(628160, 133, '2015-01-01 00:16:47.000000', 'consum', 0.0238, 'lps'),
	(628161, 133, '2015-01-01 00:16:48.000000', 'consum', 0.0210, 'lps'),
	(628162, 133, '2015-01-01 00:16:49.000000', 'consum', 0.0224, 'lps'),
	(628163, 133, '2015-01-01 00:16:50.000000', 'consum', 0.0213, 'lps'),
	(628164, 133, '2015-01-01 00:16:51.000000', 'consum', 0.0219, 'lps'),
	(628165, 133, '2015-01-01 00:16:52.000000', 'consum', 0.0211, 'lps'),
	(628166, 133, '2015-01-01 00:16:53.000000', 'consum', 0.0223, 'lps'),
	(628167, 133, '2015-01-01 00:16:54.000000', 'consum', 0.0239, 'lps'),
	(628168, 133, '2015-01-01 00:16:55.000000', 'consum', 0.0222, 'lps'),
	(628169, 133, '2015-01-01 00:16:56.000000', 'consum', 0.0217, 'lps'),
	(628170, 133, '2015-01-01 00:16:57.000000', 'consum', 0.0239, 'lps'),
	(628171, 133, '2015-01-01 00:16:58.000000', 'consum', 0.0238, 'lps'),
	(628172, 133, '2015-01-01 00:16:59.000000', 'consum', 0.0233, 'lps'),
	(628173, 133, '2015-01-01 00:17:00.000000', 'consum', 0.0211, 'lps'),
	(628174, 133, '2015-01-01 00:17:01.000000', 'consum', 0.0239, 'lps'),
	(628175, 133, '2015-01-01 00:17:02.000000', 'consum', 0.0228, 'lps'),
	(628176, 133, '2015-01-01 00:17:03.000000', 'consum', 0.0211, 'lps'),
	(628177, 133, '2015-01-01 00:17:04.000000', 'consum', 0.0228, 'lps'),
	(628178, 133, '2015-01-01 00:17:05.000000', 'consum', 0.0234, 'lps'),
	(628179, 133, '2015-01-01 00:17:06.000000', 'consum', 0.0211, 'lps'),
	(628180, 133, '2015-01-01 00:17:07.000000', 'consum', 0.0239, 'lps'),
	(628181, 133, '2015-01-01 00:17:08.000000', 'consum', 0.0226, 'lps'),
	(628182, 133, '2015-01-01 00:17:09.000000', 'consum', 0.0237, 'lps'),
	(628183, 133, '2015-01-01 00:17:10.000000', 'consum', 0.0230, 'lps'),
	(628184, 133, '2015-01-01 00:17:11.000000', 'consum', 0.0233, 'lps'),
	(628185, 133, '2015-01-01 00:17:12.000000', 'consum', 0.0231, 'lps'),
	(628186, 133, '2015-01-01 00:17:13.000000', 'consum', 0.0217, 'lps'),
	(628187, 133, '2015-01-01 00:17:14.000000', 'consum', 0.0212, 'lps'),
	(628188, 133, '2015-01-01 00:17:15.000000', 'consum', 0.0234, 'lps'),
	(628189, 133, '2015-01-01 00:17:16.000000', 'consum', 0.0227, 'lps'),
	(628190, 133, '2015-01-01 00:17:17.000000', 'consum', 0.0223, 'lps'),
	(628191, 133, '2015-01-01 00:17:18.000000', 'consum', 0.0225, 'lps'),
	(628192, 133, '2015-01-01 00:17:19.000000', 'consum', 0.0214, 'lps'),
	(628193, 133, '2015-01-01 00:17:20.000000', 'consum', 0.0218, 'lps'),
	(628194, 133, '2015-01-01 00:17:21.000000', 'consum', 0.0240, 'lps'),
	(628195, 133, '2015-01-01 00:17:22.000000', 'consum', 0.0239, 'lps'),
	(628196, 133, '2015-01-01 00:17:23.000000', 'consum', 0.0232, 'lps'),
	(628197, 133, '2015-01-01 00:17:24.000000', 'consum', 0.0234, 'lps'),
	(628198, 133, '2015-01-01 00:17:25.000000', 'consum', 0.0233, 'lps'),
	(628199, 133, '2015-01-01 00:17:26.000000', 'consum', 0.0221, 'lps'),
	(628200, 133, '2015-01-01 00:17:27.000000', 'consum', 0.0229, 'lps'),
	(628201, 133, '2015-01-01 00:17:28.000000', 'consum', 0.0239, 'lps'),
	(628202, 133, '2015-01-01 00:17:29.000000', 'consum', 0.0236, 'lps'),
	(628203, 133, '2015-01-01 00:17:30.000000', 'consum', 0.0221, 'lps'),
	(628204, 133, '2015-01-01 00:17:31.000000', 'consum', 0.0221, 'lps'),
	(628205, 133, '2015-01-01 00:17:32.000000', 'consum', 0.0233, 'lps'),
	(628206, 133, '2015-01-01 00:17:33.000000', 'consum', 0.0228, 'lps'),
	(628207, 133, '2015-01-01 00:17:34.000000', 'consum', 0.0230, 'lps'),
	(628208, 133, '2015-01-01 00:17:35.000000', 'consum', 0.0227, 'lps'),
	(628209, 133, '2015-01-01 00:17:36.000000', 'consum', 0.0235, 'lps'),
	(628210, 133, '2015-01-01 00:17:37.000000', 'consum', 0.0220, 'lps'),
	(628211, 133, '2015-01-01 00:17:38.000000', 'consum', 0.0215, 'lps'),
	(628212, 133, '2015-01-01 00:17:39.000000', 'consum', 0.0241, 'lps'),
	(628213, 133, '2015-01-01 00:17:40.000000', 'consum', 0.0222, 'lps'),
	(628214, 133, '2015-01-01 00:17:41.000000', 'consum', 0.0239, 'lps'),
	(628215, 133, '2015-01-01 00:17:42.000000', 'consum', 0.0226, 'lps'),
	(628216, 133, '2015-01-01 00:17:43.000000', 'consum', 0.0234, 'lps'),
	(628217, 133, '2015-01-01 00:17:44.000000', 'consum', 0.0218, 'lps'),
	(628218, 133, '2015-01-01 00:17:45.000000', 'consum', 0.0210, 'lps'),
	(628219, 133, '2015-01-01 00:17:46.000000', 'consum', 0.0218, 'lps'),
	(628220, 133, '2015-01-01 00:17:47.000000', 'consum', 0.0220, 'lps'),
	(628221, 133, '2015-01-01 00:17:48.000000', 'consum', 0.0236, 'lps'),
	(628222, 133, '2015-01-01 00:17:49.000000', 'consum', 0.0214, 'lps'),
	(628223, 133, '2015-01-01 00:17:50.000000', 'consum', 0.0216, 'lps'),
	(628224, 133, '2015-01-01 00:17:51.000000', 'consum', 0.0227, 'lps'),
	(628225, 133, '2015-01-01 00:17:52.000000', 'consum', 0.0215, 'lps'),
	(628226, 133, '2015-01-01 00:17:53.000000', 'consum', 0.0217, 'lps'),
	(628227, 133, '2015-01-01 00:17:54.000000', 'consum', 0.0231, 'lps'),
	(628228, 133, '2015-01-01 00:17:55.000000', 'consum', 0.0230, 'lps'),
	(628229, 133, '2015-01-01 00:17:56.000000', 'consum', 0.0214, 'lps'),
	(628230, 133, '2015-01-01 00:17:57.000000', 'consum', 0.0237, 'lps'),
	(628231, 133, '2015-01-01 00:17:58.000000', 'consum', 0.0236, 'lps'),
	(628232, 133, '2015-01-01 00:17:59.000000', 'consum', 0.0226, 'lps'),
	(628233, 133, '2015-01-01 00:18:00.000000', 'consum', 0.0213, 'lps'),
	(628234, 133, '2015-01-01 00:18:01.000000', 'consum', 0.0210, 'lps'),
	(628235, 133, '2015-01-01 00:18:02.000000', 'consum', 0.0232, 'lps'),
	(628236, 133, '2015-01-01 00:18:03.000000', 'consum', 0.0227, 'lps'),
	(628237, 133, '2015-01-01 00:18:04.000000', 'consum', 0.0230, 'lps'),
	(628238, 133, '2015-01-01 00:18:05.000000', 'consum', 0.0226, 'lps'),
	(628239, 133, '2015-01-01 00:18:06.000000', 'consum', 0.0229, 'lps'),
	(628240, 133, '2015-01-01 00:18:07.000000', 'consum', 0.0227, 'lps'),
	(628241, 133, '2015-01-01 00:18:08.000000', 'consum', 0.0237, 'lps'),
	(628242, 133, '2015-01-01 00:18:09.000000', 'consum', 0.0230, 'lps'),
	(628243, 133, '2015-01-01 00:18:10.000000', 'consum', 0.0230, 'lps'),
	(628244, 133, '2015-01-01 00:18:11.000000', 'consum', 0.0219, 'lps'),
	(628245, 133, '2015-01-01 00:18:12.000000', 'consum', 0.0226, 'lps'),
	(628246, 133, '2015-01-01 00:18:13.000000', 'consum', 0.0233, 'lps'),
	(628247, 133, '2015-01-01 00:18:14.000000', 'consum', 0.0214, 'lps'),
	(628248, 133, '2015-01-01 00:18:15.000000', 'consum', 0.0223, 'lps'),
	(628249, 133, '2015-01-01 00:18:16.000000', 'consum', 0.0234, 'lps'),
	(628250, 133, '2015-01-01 00:18:17.000000', 'consum', 0.0229, 'lps'),
	(628251, 133, '2015-01-01 00:18:18.000000', 'consum', 0.0230, 'lps'),
	(628252, 133, '2015-01-01 00:18:19.000000', 'consum', 0.0224, 'lps'),
	(628253, 133, '2015-01-01 00:18:20.000000', 'consum', 0.0219, 'lps'),
	(628254, 133, '2015-01-01 00:18:21.000000', 'consum', 0.0215, 'lps'),
	(628255, 133, '2015-01-01 00:18:22.000000', 'consum', 0.0239, 'lps'),
	(628256, 133, '2015-01-01 00:18:23.000000', 'consum', 0.0213, 'lps'),
	(628257, 133, '2015-01-01 00:18:24.000000', 'consum', 0.0234, 'lps'),
	(628258, 133, '2015-01-01 00:18:25.000000', 'consum', 0.0225, 'lps'),
	(628259, 133, '2015-01-01 00:18:26.000000', 'consum', 0.0212, 'lps'),
	(628260, 133, '2015-01-01 00:18:27.000000', 'consum', 0.0241, 'lps'),
	(628261, 133, '2015-01-01 00:18:28.000000', 'consum', 0.0232, 'lps'),
	(628262, 133, '2015-01-01 00:18:29.000000', 'consum', 0.0227, 'lps'),
	(628263, 133, '2015-01-01 00:18:30.000000', 'consum', 0.0229, 'lps'),
	(628264, 133, '2015-01-01 00:18:31.000000', 'consum', 0.0223, 'lps'),
	(628265, 133, '2015-01-01 00:18:32.000000', 'consum', 0.0220, 'lps'),
	(628266, 133, '2015-01-01 00:18:33.000000', 'consum', 0.0222, 'lps'),
	(628267, 133, '2015-01-01 00:18:34.000000', 'consum', 0.0238, 'lps'),
	(628268, 133, '2015-01-01 00:18:35.000000', 'consum', 0.0220, 'lps'),
	(628269, 133, '2015-01-01 00:18:36.000000', 'consum', 0.0241, 'lps'),
	(628270, 133, '2015-01-01 00:18:37.000000', 'consum', 0.0239, 'lps'),
	(628271, 133, '2015-01-01 00:18:38.000000', 'consum', 0.0232, 'lps'),
	(628272, 133, '2015-01-01 00:18:39.000000', 'consum', 0.0234, 'lps'),
	(628273, 133, '2015-01-01 00:18:40.000000', 'consum', 0.0231, 'lps'),
	(628274, 133, '2015-01-01 00:18:41.000000', 'consum', 0.0211, 'lps'),
	(628275, 133, '2015-01-01 00:18:42.000000', 'consum', 0.0216, 'lps'),
	(628276, 133, '2015-01-01 00:18:43.000000', 'consum', 0.0238, 'lps'),
	(628277, 133, '2015-01-01 00:18:44.000000', 'consum', 0.0239, 'lps'),
	(628278, 133, '2015-01-01 00:18:45.000000', 'consum', 0.0236, 'lps'),
	(628279, 133, '2015-01-01 00:18:46.000000', 'consum', 0.0222, 'lps'),
	(628280, 133, '2015-01-01 00:18:47.000000', 'consum', 0.0226, 'lps'),
	(628281, 133, '2015-01-01 00:18:48.000000', 'consum', 0.0224, 'lps'),
	(628282, 133, '2015-01-01 00:18:49.000000', 'consum', 0.0230, 'lps'),
	(628283, 133, '2015-01-01 00:18:50.000000', 'consum', 0.0236, 'lps'),
	(628284, 133, '2015-01-01 00:18:51.000000', 'consum', 0.0215, 'lps'),
	(628285, 133, '2015-01-01 00:18:52.000000', 'consum', 0.0225, 'lps'),
	(628286, 133, '2015-01-01 00:18:53.000000', 'consum', 0.0237, 'lps'),
	(628287, 133, '2015-01-01 00:18:54.000000', 'consum', 0.0237, 'lps'),
	(628288, 133, '2015-01-01 00:18:55.000000', 'consum', 0.0232, 'lps'),
	(628289, 133, '2015-01-01 00:18:56.000000', 'consum', 0.0238, 'lps'),
	(628290, 133, '2015-01-01 00:18:57.000000', 'consum', 0.0220, 'lps'),
	(628291, 133, '2015-01-01 00:18:58.000000', 'consum', 0.0240, 'lps'),
	(628292, 133, '2015-01-01 00:18:59.000000', 'consum', 0.0236, 'lps'),
	(628293, 133, '2015-01-01 00:19:00.000000', 'consum', 0.0218, 'lps'),
	(628294, 133, '2015-01-01 00:19:01.000000', 'consum', 0.0238, 'lps'),
	(628295, 133, '2015-01-01 00:19:02.000000', 'consum', 0.0229, 'lps'),
	(628296, 133, '2015-01-01 00:19:03.000000', 'consum', 0.0223, 'lps'),
	(628297, 133, '2015-01-01 00:19:04.000000', 'consum', 0.0219, 'lps'),
	(628298, 133, '2015-01-01 00:19:05.000000', 'consum', 0.0215, 'lps'),
	(628299, 133, '2015-01-01 00:19:06.000000', 'consum', 0.0211, 'lps'),
	(628300, 133, '2015-01-01 00:19:07.000000', 'consum', 0.0231, 'lps'),
	(628301, 133, '2015-01-01 00:19:08.000000', 'consum', 0.0215, 'lps'),
	(628302, 133, '2015-01-01 00:19:09.000000', 'consum', 0.0236, 'lps'),
	(628303, 133, '2015-01-01 00:19:10.000000', 'consum', 0.0232, 'lps'),
	(628304, 133, '2015-01-01 00:19:11.000000', 'consum', 0.0211, 'lps'),
	(628305, 133, '2015-01-01 00:19:12.000000', 'consum', 0.0211, 'lps'),
	(628306, 133, '2015-01-01 00:19:13.000000', 'consum', 0.0213, 'lps'),
	(628307, 133, '2015-01-01 00:19:14.000000', 'consum', 0.0223, 'lps'),
	(628308, 133, '2015-01-01 00:19:15.000000', 'consum', 0.0233, 'lps'),
	(628309, 133, '2015-01-01 00:19:16.000000', 'consum', 0.0225, 'lps'),
	(628310, 133, '2015-01-01 00:19:17.000000', 'consum', 0.0217, 'lps'),
	(628311, 133, '2015-01-01 00:19:18.000000', 'consum', 0.0230, 'lps'),
	(628312, 133, '2015-01-01 00:19:19.000000', 'consum', 0.0225, 'lps'),
	(628313, 133, '2015-01-01 00:19:20.000000', 'consum', 0.0227, 'lps'),
	(628314, 133, '2015-01-01 00:19:21.000000', 'consum', 0.0220, 'lps'),
	(628315, 133, '2015-01-01 00:19:22.000000', 'consum', 0.0241, 'lps'),
	(628316, 133, '2015-01-01 00:19:23.000000', 'consum', 0.0240, 'lps'),
	(628317, 133, '2015-01-01 00:19:24.000000', 'consum', 0.0237, 'lps'),
	(628318, 133, '2015-01-01 00:19:25.000000', 'consum', 0.0220, 'lps'),
	(628319, 133, '2015-01-01 00:19:26.000000', 'consum', 0.0215, 'lps'),
	(628320, 133, '2015-01-01 00:19:27.000000', 'consum', 0.0235, 'lps'),
	(628321, 133, '2015-01-01 00:19:28.000000', 'consum', 0.0225, 'lps'),
	(628322, 133, '2015-01-01 00:19:29.000000', 'consum', 0.0241, 'lps'),
	(628323, 133, '2015-01-01 00:19:30.000000', 'consum', 0.0226, 'lps'),
	(628324, 133, '2015-01-01 00:19:31.000000', 'consum', 0.0230, 'lps'),
	(628325, 133, '2015-01-01 00:19:32.000000', 'consum', 0.0231, 'lps'),
	(628326, 133, '2015-01-01 00:19:33.000000', 'consum', 0.0221, 'lps'),
	(628327, 133, '2015-01-01 00:19:34.000000', 'consum', 0.0237, 'lps'),
	(628328, 133, '2015-01-01 00:19:35.000000', 'consum', 0.0218, 'lps'),
	(628329, 133, '2015-01-01 00:19:36.000000', 'consum', 0.0230, 'lps'),
	(628330, 133, '2015-01-01 00:19:37.000000', 'consum', 0.0226, 'lps'),
	(628331, 133, '2015-01-01 00:19:38.000000', 'consum', 0.0228, 'lps'),
	(628332, 133, '2015-01-01 00:19:39.000000', 'consum', 0.0222, 'lps'),
	(628333, 133, '2015-01-01 00:19:40.000000', 'consum', 0.0218, 'lps'),
	(628334, 133, '2015-01-01 00:19:41.000000', 'consum', 0.0213, 'lps'),
	(628335, 133, '2015-01-01 00:19:42.000000', 'consum', 0.0235, 'lps'),
	(628336, 133, '2015-01-01 00:19:43.000000', 'consum', 0.0228, 'lps'),
	(628337, 133, '2015-01-01 00:19:44.000000', 'consum', 0.0228, 'lps'),
	(628338, 133, '2015-01-01 00:19:45.000000', 'consum', 0.0216, 'lps'),
	(628339, 133, '2015-01-01 00:19:46.000000', 'consum', 0.0215, 'lps'),
	(628340, 133, '2015-01-01 00:19:47.000000', 'consum', 0.0219, 'lps'),
	(628341, 133, '2015-01-01 00:19:48.000000', 'consum', 0.0239, 'lps'),
	(628342, 133, '2015-01-01 00:19:49.000000', 'consum', 0.0234, 'lps'),
	(628343, 133, '2015-01-01 00:19:50.000000', 'consum', 0.0211, 'lps'),
	(628344, 133, '2015-01-01 00:19:51.000000', 'consum', 0.0210, 'lps'),
	(628345, 133, '2015-01-01 00:19:52.000000', 'consum', 0.0236, 'lps'),
	(628346, 133, '2015-01-01 00:19:53.000000', 'consum', 0.0212, 'lps'),
	(628347, 133, '2015-01-01 00:19:54.000000', 'consum', 0.0241, 'lps'),
	(628348, 133, '2015-01-01 00:19:55.000000', 'consum', 0.0232, 'lps'),
	(628349, 133, '2015-01-01 00:19:56.000000', 'consum', 0.0229, 'lps'),
	(628350, 133, '2015-01-01 00:19:57.000000', 'consum', 0.0236, 'lps'),
	(628351, 133, '2015-01-01 00:19:58.000000', 'consum', 0.0219, 'lps'),
	(628352, 133, '2015-01-01 00:19:59.000000', 'consum', 0.0211, 'lps'),
	(628353, 133, '2015-01-01 00:20:00.000000', 'consum', 0.0222, 'lps'),
	(628354, 133, '2015-01-01 00:20:01.000000', 'consum', 0.0234, 'lps'),
	(628355, 133, '2015-01-01 00:20:02.000000', 'consum', 0.0229, 'lps'),
	(628356, 133, '2015-01-01 00:20:03.000000', 'consum', 0.0237, 'lps'),
	(628357, 133, '2015-01-01 00:20:04.000000', 'consum', 0.0222, 'lps'),
	(628358, 133, '2015-01-01 00:20:05.000000', 'consum', 0.0220, 'lps'),
	(628359, 133, '2015-01-01 00:20:06.000000', 'consum', 0.0227, 'lps'),
	(628360, 133, '2015-01-01 00:20:07.000000', 'consum', 0.0234, 'lps'),
	(628361, 133, '2015-01-01 00:20:08.000000', 'consum', 0.0213, 'lps'),
	(628362, 133, '2015-01-01 00:20:09.000000', 'consum', 0.0219, 'lps'),
	(628363, 133, '2015-01-01 00:20:10.000000', 'consum', 0.0215, 'lps'),
	(628364, 133, '2015-01-01 00:20:11.000000', 'consum', 0.0241, 'lps'),
	(628365, 133, '2015-01-01 00:20:12.000000', 'consum', 0.0222, 'lps'),
	(628366, 133, '2015-01-01 00:20:13.000000', 'consum', 0.0239, 'lps'),
	(628367, 133, '2015-01-01 00:20:14.000000', 'consum', 0.0227, 'lps'),
	(628368, 133, '2015-01-01 00:20:15.000000', 'consum', 0.0238, 'lps'),
	(628369, 133, '2015-01-01 00:20:16.000000', 'consum', 0.0238, 'lps'),
	(628370, 133, '2015-01-01 00:20:17.000000', 'consum', 0.0234, 'lps'),
	(628371, 133, '2015-01-01 00:20:18.000000', 'consum', 0.0214, 'lps'),
	(628372, 133, '2015-01-01 00:20:19.000000', 'consum', 0.0225, 'lps'),
	(628373, 133, '2015-01-01 00:20:20.000000', 'consum', 0.0238, 'lps'),
	(628374, 133, '2015-01-01 00:20:21.000000', 'consum', 0.0210, 'lps'),
	(628375, 133, '2015-01-01 00:20:22.000000', 'consum', 0.0221, 'lps'),
	(628376, 133, '2015-01-01 00:20:23.000000', 'consum', 0.0236, 'lps'),
	(628377, 133, '2015-01-01 00:20:24.000000', 'consum', 0.0210, 'lps'),
	(628378, 133, '2015-01-01 00:20:25.000000', 'consum', 0.0229, 'lps'),
	(628379, 133, '2015-01-01 00:20:26.000000', 'consum', 0.0211, 'lps'),
	(628380, 133, '2015-01-01 00:20:27.000000', 'consum', 0.0221, 'lps'),
	(628381, 133, '2015-01-01 00:20:28.000000', 'consum', 0.0232, 'lps'),
	(628382, 133, '2015-01-01 00:20:29.000000', 'consum', 0.0223, 'lps'),
	(628383, 133, '2015-01-01 00:20:30.000000', 'consum', 0.0211, 'lps'),
	(628384, 133, '2015-01-01 00:20:31.000000', 'consum', 0.0237, 'lps'),
	(628385, 133, '2015-01-01 00:20:32.000000', 'consum', 0.0217, 'lps'),
	(628386, 133, '2015-01-01 00:20:33.000000', 'consum', 0.0230, 'lps'),
	(628387, 133, '2015-01-01 00:20:34.000000', 'consum', 0.0224, 'lps'),
	(628388, 133, '2015-01-01 00:20:35.000000', 'consum', 0.0221, 'lps'),
	(628389, 133, '2015-01-01 00:20:36.000000', 'consum', 0.0223, 'lps'),
	(628390, 133, '2015-01-01 00:20:37.000000', 'consum', 0.0211, 'lps'),
	(628391, 133, '2015-01-01 00:20:38.000000', 'consum', 0.0240, 'lps'),
	(628392, 133, '2015-01-01 00:20:39.000000', 'consum', 0.0228, 'lps'),
	(628393, 133, '2015-01-01 00:20:40.000000', 'consum', 0.0212, 'lps'),
	(628394, 133, '2015-01-01 00:20:41.000000', 'consum', 0.0232, 'lps'),
	(628395, 133, '2015-01-01 00:20:42.000000', 'consum', 0.0217, 'lps'),
	(628396, 133, '2015-01-01 00:20:43.000000', 'consum', 0.0212, 'lps'),
	(628397, 133, '2015-01-01 00:20:44.000000', 'consum', 0.0232, 'lps'),
	(628398, 133, '2015-01-01 00:20:45.000000', 'consum', 0.0217, 'lps'),
	(628399, 133, '2015-01-01 00:20:46.000000', 'consum', 0.0213, 'lps'),
	(628400, 133, '2015-01-01 00:20:47.000000', 'consum', 0.0234, 'lps'),
	(628401, 133, '2015-01-01 00:20:48.000000', 'consum', 0.0229, 'lps'),
	(628402, 133, '2015-01-01 00:20:49.000000', 'consum', 0.0231, 'lps'),
	(628403, 133, '2015-01-01 00:20:50.000000', 'consum', 0.0227, 'lps'),
	(628404, 133, '2015-01-01 00:20:51.000000', 'consum', 0.0234, 'lps'),
	(628405, 133, '2015-01-01 00:20:52.000000', 'consum', 0.0216, 'lps'),
	(628406, 133, '2015-01-01 00:20:53.000000', 'consum', 0.0231, 'lps'),
	(628407, 133, '2015-01-01 00:20:54.000000', 'consum', 0.0232, 'lps'),
	(628408, 133, '2015-01-01 00:20:55.000000', 'consum', 0.0229, 'lps'),
	(628409, 133, '2015-01-01 00:20:56.000000', 'consum', 0.0237, 'lps'),
	(628410, 133, '2015-01-01 00:20:57.000000', 'consum', 0.0226, 'lps'),
	(628411, 133, '2015-01-01 00:20:58.000000', 'consum', 0.0241, 'lps'),
	(628412, 133, '2015-01-01 00:20:59.000000', 'consum', 0.0223, 'lps'),
	(628413, 133, '2015-01-01 00:21:00.000000', 'consum', 0.0212, 'lps'),
	(628414, 133, '2015-01-01 00:21:01.000000', 'consum', 0.0213, 'lps'),
	(628415, 133, '2015-01-01 00:21:02.000000', 'consum', 0.0220, 'lps'),
	(628416, 133, '2015-01-01 00:21:03.000000', 'consum', 0.0221, 'lps'),
	(628417, 133, '2015-01-01 00:21:04.000000', 'consum', 0.0235, 'lps'),
	(628418, 133, '2015-01-01 00:21:05.000000', 'consum', 0.0238, 'lps'),
	(628419, 133, '2015-01-01 00:21:06.000000', 'consum', 0.0211, 'lps'),
	(628420, 133, '2015-01-01 00:21:07.000000', 'consum', 0.0229, 'lps'),
	(628421, 133, '2015-01-01 00:21:08.000000', 'consum', 0.0237, 'lps'),
	(628422, 133, '2015-01-01 00:21:09.000000', 'consum', 0.0225, 'lps'),
	(628423, 133, '2015-01-01 00:21:10.000000', 'consum', 0.0238, 'lps'),
	(628424, 133, '2015-01-01 00:21:11.000000', 'consum', 0.0240, 'lps'),
	(628425, 133, '2015-01-01 00:21:12.000000', 'consum', 0.0211, 'lps'),
	(628426, 133, '2015-01-01 00:21:13.000000', 'consum', 0.0223, 'lps'),
	(628427, 133, '2015-01-01 00:21:14.000000', 'consum', 0.0241, 'lps'),
	(628428, 133, '2015-01-01 00:21:15.000000', 'consum', 0.0231, 'lps'),
	(628429, 133, '2015-01-01 00:21:16.000000', 'consum', 0.0222, 'lps'),
	(628430, 133, '2015-01-01 00:21:17.000000', 'consum', 0.0241, 'lps'),
	(628431, 133, '2015-01-01 00:21:18.000000', 'consum', 0.0233, 'lps'),
	(628432, 133, '2015-01-01 00:21:19.000000', 'consum', 0.0234, 'lps'),
	(628433, 133, '2015-01-01 00:21:20.000000', 'consum', 0.0227, 'lps'),
	(628434, 133, '2015-01-01 00:21:21.000000', 'consum', 0.0222, 'lps'),
	(628435, 133, '2015-01-01 00:21:22.000000', 'consum', 0.0223, 'lps'),
	(628436, 133, '2015-01-01 00:21:23.000000', 'consum', 0.0237, 'lps'),
	(628437, 133, '2015-01-01 00:21:24.000000', 'consum', 0.0211, 'lps'),
	(628438, 133, '2015-01-01 00:21:25.000000', 'consum', 0.0232, 'lps'),
	(628439, 133, '2015-01-01 00:21:26.000000', 'consum', 0.0222, 'lps'),
	(628440, 133, '2015-01-01 00:21:27.000000', 'consum', 0.0237, 'lps'),
	(628441, 133, '2015-01-01 00:21:28.000000', 'consum', 0.0213, 'lps'),
	(628442, 133, '2015-01-01 00:21:29.000000', 'consum', 0.0210, 'lps'),
	(628443, 133, '2015-01-01 00:21:30.000000', 'consum', 0.0232, 'lps'),
	(628444, 133, '2015-01-01 00:21:31.000000', 'consum', 0.0225, 'lps'),
	(628445, 133, '2015-01-01 00:21:32.000000', 'consum', 0.0220, 'lps'),
	(628446, 133, '2015-01-01 00:21:33.000000', 'consum', 0.0213, 'lps'),
	(628447, 133, '2015-01-01 00:21:34.000000', 'consum', 0.0230, 'lps'),
	(628448, 133, '2015-01-01 00:21:35.000000', 'consum', 0.0239, 'lps'),
	(628449, 133, '2015-01-01 00:21:36.000000', 'consum', 0.0228, 'lps'),
	(628450, 133, '2015-01-01 00:21:37.000000', 'consum', 0.0215, 'lps'),
	(628451, 133, '2015-01-01 00:21:38.000000', 'consum', 0.0215, 'lps'),
	(628452, 133, '2015-01-01 00:21:39.000000', 'consum', 0.0220, 'lps'),
	(628453, 133, '2015-01-01 00:21:40.000000', 'consum', 0.0213, 'lps'),
	(628454, 133, '2015-01-01 00:21:41.000000', 'consum', 0.0226, 'lps'),
	(628455, 133, '2015-01-01 00:21:42.000000', 'consum', 0.0218, 'lps'),
	(628456, 133, '2015-01-01 00:21:43.000000', 'consum', 0.0233, 'lps'),
	(628457, 133, '2015-01-01 00:21:44.000000', 'consum', 0.0239, 'lps'),
	(628458, 133, '2015-01-01 00:21:45.000000', 'consum', 0.0222, 'lps'),
	(628459, 133, '2015-01-01 00:21:46.000000', 'consum', 0.0214, 'lps'),
	(628460, 133, '2015-01-01 00:21:47.000000', 'consum', 0.0228, 'lps'),
	(628461, 133, '2015-01-01 00:21:48.000000', 'consum', 0.0225, 'lps'),
	(628462, 133, '2015-01-01 00:21:49.000000', 'consum', 0.0229, 'lps'),
	(628463, 133, '2015-01-01 00:21:50.000000', 'consum', 0.0230, 'lps'),
	(628464, 133, '2015-01-01 00:21:51.000000', 'consum', 0.0221, 'lps'),
	(628465, 133, '2015-01-01 00:21:52.000000', 'consum', 0.0238, 'lps'),
	(628466, 133, '2015-01-01 00:21:53.000000', 'consum', 0.0223, 'lps'),
	(628467, 133, '2015-01-01 00:21:54.000000', 'consum', 0.0221, 'lps'),
	(628468, 133, '2015-01-01 00:21:55.000000', 'consum', 0.0229, 'lps'),
	(628469, 133, '2015-01-01 00:21:56.000000', 'consum', 0.0240, 'lps'),
	(628470, 133, '2015-01-01 00:21:57.000000', 'consum', 0.0241, 'lps'),
	(628471, 133, '2015-01-01 00:21:58.000000', 'consum', 0.0240, 'lps'),
	(628472, 133, '2015-01-01 00:21:59.000000', 'consum', 0.0238, 'lps'),
	(628473, 133, '2015-01-01 00:22:00.000000', 'consum', 0.0226, 'lps'),
	(628474, 133, '2015-01-01 00:22:01.000000', 'consum', 0.0241, 'lps'),
	(628475, 133, '2015-01-01 00:22:02.000000', 'consum', 0.0222, 'lps'),
	(628476, 133, '2015-01-01 00:22:03.000000', 'consum', 0.0210, 'lps'),
	(628477, 133, '2015-01-01 00:22:04.000000', 'consum', 0.0239, 'lps'),
	(628478, 133, '2015-01-01 00:22:05.000000', 'consum', 0.0228, 'lps'),
	(628479, 133, '2015-01-01 00:22:06.000000', 'consum', 0.0214, 'lps'),
	(628480, 133, '2015-01-01 00:22:07.000000', 'consum', 0.0238, 'lps'),
	(628481, 133, '2015-01-01 00:22:08.000000', 'consum', 0.0213, 'lps'),
	(628482, 133, '2015-01-01 00:22:09.000000', 'consum', 0.0238, 'lps'),
	(628483, 133, '2015-01-01 00:22:10.000000', 'consum', 0.0212, 'lps'),
	(628484, 133, '2015-01-01 00:22:11.000000', 'consum', 0.0231, 'lps'),
	(628485, 133, '2015-01-01 00:22:12.000000', 'consum', 0.0215, 'lps'),
	(628486, 133, '2015-01-01 00:22:13.000000', 'consum', 0.0238, 'lps'),
	(628487, 133, '2015-01-01 00:22:14.000000', 'consum', 0.0239, 'lps'),
	(628488, 133, '2015-01-01 00:22:15.000000', 'consum', 0.0238, 'lps'),
	(628489, 133, '2015-01-01 00:22:16.000000', 'consum', 0.0232, 'lps'),
	(628490, 133, '2015-01-01 00:22:17.000000', 'consum', 0.0235, 'lps'),
	(628491, 133, '2015-01-01 00:22:18.000000', 'consum', 0.0240, 'lps'),
	(628492, 133, '2015-01-01 00:22:19.000000', 'consum', 0.0219, 'lps'),
	(628493, 133, '2015-01-01 00:22:20.000000', 'consum', 0.0233, 'lps'),
	(628494, 133, '2015-01-01 00:22:21.000000', 'consum', 0.0231, 'lps'),
	(628495, 133, '2015-01-01 00:22:22.000000', 'consum', 0.0216, 'lps'),
	(628496, 133, '2015-01-01 00:22:23.000000', 'consum', 0.0240, 'lps'),
	(628497, 133, '2015-01-01 00:22:24.000000', 'consum', 0.0216, 'lps'),
	(628498, 133, '2015-01-01 00:22:25.000000', 'consum', 0.0215, 'lps'),
	(628499, 133, '2015-01-01 00:22:26.000000', 'consum', 0.0217, 'lps'),
	(628500, 133, '2015-01-01 00:22:27.000000', 'consum', 0.0229, 'lps'),
	(628501, 133, '2015-01-01 00:22:28.000000', 'consum', 0.0220, 'lps'),
	(628502, 133, '2015-01-01 00:22:29.000000', 'consum', 0.0238, 'lps'),
	(628503, 133, '2015-01-01 00:22:30.000000', 'consum', 0.0224, 'lps'),
	(628504, 133, '2015-01-01 00:22:31.000000', 'consum', 0.0229, 'lps'),
	(628505, 133, '2015-01-01 00:22:32.000000', 'consum', 0.0233, 'lps'),
	(628506, 133, '2015-01-01 00:22:33.000000', 'consum', 0.0234, 'lps'),
	(628507, 133, '2015-01-01 00:22:34.000000', 'consum', 0.0229, 'lps'),
	(628508, 133, '2015-01-01 00:22:35.000000', 'consum', 0.0235, 'lps'),
	(628509, 133, '2015-01-01 00:22:36.000000', 'consum', 0.0212, 'lps'),
	(628510, 133, '2015-01-01 00:22:37.000000', 'consum', 0.0211, 'lps'),
	(628511, 133, '2015-01-01 00:22:38.000000', 'consum', 0.0241, 'lps'),
	(628512, 133, '2015-01-01 00:22:39.000000', 'consum', 0.0233, 'lps'),
	(628513, 133, '2015-01-01 00:22:40.000000', 'consum', 0.0234, 'lps'),
	(628514, 133, '2015-01-01 00:22:41.000000', 'consum', 0.0228, 'lps'),
	(628515, 133, '2015-01-01 00:22:42.000000', 'consum', 0.0230, 'lps'),
	(628516, 133, '2015-01-01 00:22:43.000000', 'consum', 0.0223, 'lps'),
	(628517, 133, '2015-01-01 00:22:44.000000', 'consum', 0.0215, 'lps'),
	(628518, 133, '2015-01-01 00:22:45.000000', 'consum', 0.0229, 'lps'),
	(628519, 133, '2015-01-01 00:22:46.000000', 'consum', 0.0226, 'lps'),
	(628520, 133, '2015-01-01 00:22:47.000000', 'consum', 0.0235, 'lps'),
	(628521, 133, '2015-01-01 00:22:48.000000', 'consum', 0.0224, 'lps'),
	(628522, 133, '2015-01-01 00:22:49.000000', 'consum', 0.0237, 'lps'),
	(628523, 133, '2015-01-01 00:22:50.000000', 'consum', 0.0238, 'lps'),
	(628524, 133, '2015-01-01 00:22:51.000000', 'consum', 0.0240, 'lps'),
	(628525, 133, '2015-01-01 00:22:52.000000', 'consum', 0.0210, 'lps'),
	(628526, 133, '2015-01-01 00:22:53.000000', 'consum', 0.0219, 'lps'),
	(628527, 133, '2015-01-01 00:22:54.000000', 'consum', 0.0223, 'lps'),
	(628528, 133, '2015-01-01 00:22:55.000000', 'consum', 0.0216, 'lps'),
	(628529, 133, '2015-01-01 00:22:56.000000', 'consum', 0.0234, 'lps'),
	(628530, 133, '2015-01-01 00:22:57.000000', 'consum', 0.0215, 'lps'),
	(628531, 133, '2015-01-01 00:22:58.000000', 'consum', 0.0228, 'lps'),
	(628532, 133, '2015-01-01 00:22:59.000000', 'consum', 0.0222, 'lps'),
	(628533, 133, '2015-01-01 00:23:00.000000', 'consum', 0.0218, 'lps'),
	(628534, 133, '2015-01-01 00:23:01.000000', 'consum', 0.0215, 'lps'),
	(628535, 133, '2015-01-01 00:23:02.000000', 'consum', 0.0211, 'lps'),
	(628536, 133, '2015-01-01 00:23:03.000000', 'consum', 0.0233, 'lps'),
	(628537, 133, '2015-01-01 00:23:04.000000', 'consum', 0.0224, 'lps'),
	(628538, 133, '2015-01-01 00:23:05.000000', 'consum', 0.0213, 'lps'),
	(628539, 133, '2015-01-01 00:23:06.000000', 'consum', 0.0215, 'lps'),
	(628540, 133, '2015-01-01 00:23:07.000000', 'consum', 0.0226, 'lps'),
	(628541, 133, '2015-01-01 00:23:08.000000', 'consum', 0.0211, 'lps'),
	(628542, 133, '2015-01-01 00:23:09.000000', 'consum', 0.0234, 'lps'),
	(628543, 133, '2015-01-01 00:23:10.000000', 'consum', 0.0228, 'lps'),
	(628544, 133, '2015-01-01 00:23:11.000000', 'consum', 0.0231, 'lps'),
	(628545, 133, '2015-01-01 00:23:12.000000', 'consum', 0.0229, 'lps'),
	(628546, 133, '2015-01-01 00:23:13.000000', 'consum', 0.0241, 'lps'),
	(628547, 133, '2015-01-01 00:23:14.000000', 'consum', 0.0213, 'lps'),
	(628548, 133, '2015-01-01 00:23:15.000000', 'consum', 0.0227, 'lps'),
	(628549, 133, '2015-01-01 00:23:16.000000', 'consum', 0.0226, 'lps'),
	(628550, 133, '2015-01-01 00:23:17.000000', 'consum', 0.0236, 'lps'),
	(628551, 133, '2015-01-01 00:23:18.000000', 'consum', 0.0229, 'lps'),
	(628552, 133, '2015-01-01 00:23:19.000000', 'consum', 0.0229, 'lps'),
	(628553, 133, '2015-01-01 00:23:20.000000', 'consum', 0.0214, 'lps'),
	(628554, 133, '2015-01-01 00:23:21.000000', 'consum', 0.0239, 'lps'),
	(628555, 133, '2015-01-01 00:23:22.000000', 'consum', 0.0216, 'lps'),
	(628556, 133, '2015-01-01 00:23:23.000000', 'consum', 0.0217, 'lps'),
	(628557, 133, '2015-01-01 00:23:24.000000', 'consum', 0.0226, 'lps'),
	(628558, 133, '2015-01-01 00:23:25.000000', 'consum', 0.0239, 'lps'),
	(628559, 133, '2015-01-01 00:23:26.000000', 'consum', 0.0241, 'lps'),
	(628560, 133, '2015-01-01 00:23:27.000000', 'consum', 0.0217, 'lps'),
	(628561, 133, '2015-01-01 00:23:28.000000', 'consum', 0.0215, 'lps'),
	(628562, 133, '2015-01-01 00:23:29.000000', 'consum', 0.0217, 'lps'),
	(628563, 133, '2015-01-01 00:23:30.000000', 'consum', 0.0229, 'lps'),
	(628564, 133, '2015-01-01 00:23:31.000000', 'consum', 0.0219, 'lps'),
	(628565, 133, '2015-01-01 00:23:32.000000', 'consum', 0.0232, 'lps'),
	(628566, 133, '2015-01-01 00:23:33.000000', 'consum', 0.0227, 'lps'),
	(628567, 133, '2015-01-01 00:23:34.000000', 'consum', 0.0233, 'lps'),
	(628568, 133, '2015-01-01 00:23:35.000000', 'consum', 0.0241, 'lps'),
	(628569, 133, '2015-01-01 00:23:36.000000', 'consum', 0.0232, 'lps'),
	(628570, 133, '2015-01-01 00:23:37.000000', 'consum', 0.0229, 'lps'),
	(628571, 133, '2015-01-01 00:23:38.000000', 'consum', 0.0240, 'lps'),
	(628572, 133, '2015-01-01 00:23:39.000000', 'consum', 0.0237, 'lps'),
	(628573, 133, '2015-01-01 00:23:40.000000', 'consum', 0.0225, 'lps'),
	(628574, 133, '2015-01-01 00:23:41.000000', 'consum', 0.0237, 'lps'),
	(628575, 133, '2015-01-01 00:23:42.000000', 'consum', 0.0237, 'lps'),
	(628576, 133, '2015-01-01 00:23:43.000000', 'consum', 0.0233, 'lps'),
	(628577, 133, '2015-01-01 00:23:44.000000', 'consum', 0.0214, 'lps'),
	(628578, 133, '2015-01-01 00:23:45.000000', 'consum', 0.0222, 'lps'),
	(628579, 133, '2015-01-01 00:23:46.000000', 'consum', 0.0229, 'lps'),
	(628580, 133, '2015-01-01 00:23:47.000000', 'consum', 0.0238, 'lps'),
	(628581, 133, '2015-01-01 00:23:48.000000', 'consum', 0.0228, 'lps'),
	(628582, 133, '2015-01-01 00:23:49.000000', 'consum', 0.0216, 'lps'),
	(628583, 133, '2015-01-01 00:23:50.000000', 'consum', 0.0217, 'lps'),
	(628584, 133, '2015-01-01 00:23:51.000000', 'consum', 0.0230, 'lps'),
	(628585, 133, '2015-01-01 00:23:52.000000', 'consum', 0.0226, 'lps'),
	(628586, 133, '2015-01-01 00:23:53.000000', 'consum', 0.0230, 'lps'),
	(628587, 133, '2015-01-01 00:23:54.000000', 'consum', 0.0229, 'lps'),
	(628588, 133, '2015-01-01 00:23:55.000000', 'consum', 0.0213, 'lps'),
	(628589, 133, '2015-01-01 00:23:56.000000', 'consum', 0.0234, 'lps'),
	(628590, 133, '2015-01-01 00:23:57.000000', 'consum', 0.0225, 'lps'),
	(628591, 133, '2015-01-01 00:23:58.000000', 'consum', 0.0212, 'lps'),
	(628592, 133, '2015-01-01 00:23:59.000000', 'consum', 0.0241, 'lps'),
	(628593, 133, '2015-01-01 00:24:00.000000', 'consum', 0.0232, 'lps'),
	(628594, 133, '2015-01-01 00:24:01.000000', 'consum', 0.0229, 'lps'),
	(628595, 133, '2015-01-01 00:24:02.000000', 'consum', 0.0238, 'lps'),
	(628596, 133, '2015-01-01 00:24:03.000000', 'consum', 0.0229, 'lps'),
	(628597, 133, '2015-01-01 00:24:04.000000', 'consum', 0.0222, 'lps'),
	(628598, 133, '2015-01-01 00:24:05.000000', 'consum', 0.0212, 'lps'),
	(628599, 133, '2015-01-01 00:24:06.000000', 'consum', 0.0219, 'lps'),
	(628600, 133, '2015-01-01 00:24:07.000000', 'consum', 0.0218, 'lps'),
	(628601, 133, '2015-01-01 00:24:08.000000', 'consum', 0.0223, 'lps'),
	(628602, 133, '2015-01-01 00:24:09.000000', 'consum', 0.0217, 'lps'),
	(628603, 133, '2015-01-01 00:24:10.000000', 'consum', 0.0241, 'lps'),
	(628604, 133, '2015-01-01 00:24:11.000000', 'consum', 0.0215, 'lps'),
	(628605, 133, '2015-01-01 00:24:12.000000', 'consum', 0.0238, 'lps'),
	(628606, 133, '2015-01-01 00:24:13.000000', 'consum', 0.0210, 'lps'),
	(628607, 133, '2015-01-01 00:24:14.000000', 'consum', 0.0222, 'lps'),
	(628608, 133, '2015-01-01 00:24:15.000000', 'consum', 0.0239, 'lps'),
	(628609, 133, '2015-01-01 00:24:16.000000', 'consum', 0.0224, 'lps'),
	(628610, 133, '2015-01-01 00:24:17.000000', 'consum', 0.0225, 'lps'),
	(628611, 133, '2015-01-01 00:24:18.000000', 'consum', 0.0211, 'lps'),
	(628612, 133, '2015-01-01 00:24:19.000000', 'consum', 0.0233, 'lps'),
	(628613, 133, '2015-01-01 00:24:20.000000', 'consum', 0.0230, 'lps'),
	(628614, 133, '2015-01-01 00:24:21.000000', 'consum', 0.0238, 'lps'),
	(628615, 133, '2015-01-01 00:24:22.000000', 'consum', 0.0228, 'lps'),
	(628616, 133, '2015-01-01 00:24:23.000000', 'consum', 0.0215, 'lps'),
	(628617, 133, '2015-01-01 00:24:24.000000', 'consum', 0.0213, 'lps'),
	(628618, 133, '2015-01-01 00:24:25.000000', 'consum', 0.0213, 'lps'),
	(628619, 133, '2015-01-01 00:24:26.000000', 'consum', 0.0215, 'lps'),
	(628620, 133, '2015-01-01 00:24:27.000000', 'consum', 0.0225, 'lps'),
	(628621, 133, '2015-01-01 00:24:28.000000', 'consum', 0.0239, 'lps'),
	(628622, 133, '2015-01-01 00:24:29.000000', 'consum', 0.0217, 'lps'),
	(628623, 133, '2015-01-01 00:24:30.000000', 'consum', 0.0222, 'lps'),
	(628624, 133, '2015-01-01 00:24:31.000000', 'consum', 0.0215, 'lps'),
	(628625, 133, '2015-01-01 00:24:32.000000', 'consum', 0.0232, 'lps'),
	(628626, 133, '2015-01-01 00:24:33.000000', 'consum', 0.0210, 'lps'),
	(628627, 133, '2015-01-01 00:24:34.000000', 'consum', 0.0241, 'lps'),
	(628628, 133, '2015-01-01 00:24:35.000000', 'consum', 0.0235, 'lps'),
	(628629, 133, '2015-01-01 00:24:36.000000', 'consum', 0.0213, 'lps'),
	(628630, 133, '2015-01-01 00:24:37.000000', 'consum', 0.0215, 'lps'),
	(628631, 133, '2015-01-01 00:24:38.000000', 'consum', 0.0225, 'lps'),
	(628632, 133, '2015-01-01 00:24:39.000000', 'consum', 0.0239, 'lps'),
	(628633, 133, '2015-01-01 00:24:40.000000', 'consum', 0.0216, 'lps'),
	(628634, 133, '2015-01-01 00:24:41.000000', 'consum', 0.0216, 'lps'),
	(628635, 133, '2015-01-01 00:24:42.000000', 'consum', 0.0221, 'lps'),
	(628636, 133, '2015-01-01 00:24:43.000000', 'consum', 0.0218, 'lps'),
	(628637, 133, '2015-01-01 00:24:44.000000', 'consum', 0.0215, 'lps'),
	(628638, 133, '2015-01-01 00:24:45.000000', 'consum', 0.0211, 'lps'),
	(628639, 133, '2015-01-01 00:24:46.000000', 'consum', 0.0232, 'lps'),
	(628640, 133, '2015-01-01 00:24:47.000000', 'consum', 0.0222, 'lps'),
	(628641, 133, '2015-01-01 00:24:48.000000', 'consum', 0.0239, 'lps'),
	(628642, 133, '2015-01-01 00:24:49.000000', 'consum', 0.0221, 'lps'),
	(628643, 133, '2015-01-01 00:24:50.000000', 'consum', 0.0211, 'lps'),
	(628644, 133, '2015-01-01 00:24:51.000000', 'consum', 0.0215, 'lps'),
	(628645, 133, '2015-01-01 00:24:52.000000', 'consum', 0.0230, 'lps'),
	(628646, 133, '2015-01-01 00:24:53.000000', 'consum', 0.0235, 'lps'),
	(628647, 133, '2015-01-01 00:24:54.000000', 'consum', 0.0241, 'lps'),
	(628648, 133, '2015-01-01 00:24:55.000000', 'consum', 0.0228, 'lps'),
	(628649, 133, '2015-01-01 00:24:56.000000', 'consum', 0.0237, 'lps'),
	(628650, 133, '2015-01-01 00:24:57.000000', 'consum', 0.0228, 'lps'),
	(628651, 133, '2015-01-01 00:24:58.000000', 'consum', 0.0222, 'lps'),
	(628652, 133, '2015-01-01 00:24:59.000000', 'consum', 0.0214, 'lps'),
	(628653, 133, '2015-01-01 00:25:00.000000', 'consum', 0.0229, 'lps'),
	(628654, 133, '2015-01-01 00:25:01.000000', 'consum', 0.0229, 'lps'),
	(628655, 133, '2015-01-01 00:25:02.000000', 'consum', 0.0216, 'lps'),
	(628656, 133, '2015-01-01 00:25:03.000000', 'consum', 0.0216, 'lps'),
	(628657, 133, '2015-01-01 00:25:04.000000', 'consum', 0.0224, 'lps'),
	(628658, 133, '2015-01-01 00:25:05.000000', 'consum', 0.0228, 'lps'),
	(628659, 133, '2015-01-01 00:25:06.000000', 'consum', 0.0228, 'lps'),
	(628660, 133, '2015-01-01 00:25:07.000000', 'consum', 0.0214, 'lps'),
	(628661, 133, '2015-01-01 00:25:08.000000', 'consum', 0.0240, 'lps'),
	(628662, 133, '2015-01-01 00:25:09.000000', 'consum', 0.0220, 'lps'),
	(628663, 133, '2015-01-01 00:25:10.000000', 'consum', 0.0235, 'lps'),
	(628664, 133, '2015-01-01 00:25:11.000000', 'consum', 0.0240, 'lps'),
	(628665, 133, '2015-01-01 00:25:12.000000', 'consum', 0.0224, 'lps'),
	(628666, 133, '2015-01-01 00:25:13.000000', 'consum', 0.0222, 'lps'),
	(628667, 133, '2015-01-01 00:25:14.000000', 'consum', 0.0229, 'lps'),
	(628668, 133, '2015-01-01 00:25:15.000000', 'consum', 0.0235, 'lps'),
	(628669, 133, '2015-01-01 00:25:16.000000', 'consum', 0.0215, 'lps'),
	(628670, 133, '2015-01-01 00:25:17.000000', 'consum', 0.0225, 'lps'),
	(628671, 133, '2015-01-01 00:25:18.000000', 'consum', 0.0239, 'lps'),
	(628672, 133, '2015-01-01 00:25:19.000000', 'consum', 0.0212, 'lps'),
	(628673, 133, '2015-01-01 00:25:20.000000', 'consum', 0.0233, 'lps'),
	(628674, 133, '2015-01-01 00:25:21.000000', 'consum', 0.0220, 'lps'),
	(628675, 133, '2015-01-01 00:25:22.000000', 'consum', 0.0226, 'lps'),
	(628676, 133, '2015-01-01 00:25:23.000000', 'consum', 0.0228, 'lps'),
	(628677, 133, '2015-01-01 00:25:24.000000', 'consum', 0.0221, 'lps'),
	(628678, 133, '2015-01-01 00:25:25.000000', 'consum', 0.0211, 'lps'),
	(628679, 133, '2015-01-01 00:25:26.000000', 'consum', 0.0214, 'lps'),
	(628680, 133, '2015-01-01 00:25:27.000000', 'consum', 0.0230, 'lps'),
	(628681, 133, '2015-01-01 00:25:28.000000', 'consum', 0.0231, 'lps'),
	(628682, 133, '2015-01-01 00:25:29.000000', 'consum', 0.0227, 'lps'),
	(628683, 133, '2015-01-01 00:25:30.000000', 'consum', 0.0231, 'lps'),
	(628684, 133, '2015-01-01 00:25:31.000000', 'consum', 0.0232, 'lps'),
	(628685, 133, '2015-01-01 00:25:32.000000', 'consum', 0.0225, 'lps'),
	(628686, 133, '2015-01-01 00:25:33.000000', 'consum', 0.0220, 'lps'),
	(628687, 133, '2015-01-01 00:25:34.000000', 'consum', 0.0215, 'lps'),
	(628688, 133, '2015-01-01 00:25:35.000000', 'consum', 0.0238, 'lps'),
	(628689, 133, '2015-01-01 00:25:36.000000', 'consum', 0.0240, 'lps'),
	(628690, 133, '2015-01-01 00:25:37.000000', 'consum', 0.0212, 'lps'),
	(628691, 133, '2015-01-01 00:25:38.000000', 'consum', 0.0226, 'lps'),
	(628692, 133, '2015-01-01 00:25:39.000000', 'consum', 0.0221, 'lps'),
	(628693, 133, '2015-01-01 00:25:40.000000', 'consum', 0.0219, 'lps'),
	(628694, 133, '2015-01-01 00:25:41.000000', 'consum', 0.0222, 'lps'),
	(628695, 133, '2015-01-01 00:25:42.000000', 'consum', 0.0241, 'lps'),
	(628696, 133, '2015-01-01 00:25:43.000000', 'consum', 0.0237, 'lps'),
	(628697, 133, '2015-01-01 00:25:44.000000', 'consum', 0.0218, 'lps'),
	(628698, 133, '2015-01-01 00:25:45.000000', 'consum', 0.0235, 'lps'),
	(628699, 133, '2015-01-01 00:25:46.000000', 'consum', 0.0215, 'lps'),
	(628700, 133, '2015-01-01 00:25:47.000000', 'consum', 0.0223, 'lps'),
	(628701, 133, '2015-01-01 00:25:48.000000', 'consum', 0.0228, 'lps'),
	(628702, 133, '2015-01-01 00:25:49.000000', 'consum', 0.0231, 'lps'),
	(628703, 133, '2015-01-01 00:25:50.000000', 'consum', 0.0228, 'lps'),
	(628704, 133, '2015-01-01 00:25:51.000000', 'consum', 0.0240, 'lps'),
	(628705, 133, '2015-01-01 00:25:52.000000', 'consum', 0.0241, 'lps'),
	(628706, 133, '2015-01-01 00:25:53.000000', 'consum', 0.0210, 'lps'),
	(628707, 133, '2015-01-01 00:25:54.000000', 'consum', 0.0213, 'lps'),
	(628708, 133, '2015-01-01 00:25:55.000000', 'consum', 0.0228, 'lps'),
	(628709, 133, '2015-01-01 00:25:56.000000', 'consum', 0.0225, 'lps'),
	(628710, 133, '2015-01-01 00:25:57.000000', 'consum', 0.0234, 'lps'),
	(628711, 133, '2015-01-01 00:25:58.000000', 'consum', 0.0219, 'lps'),
	(628712, 133, '2015-01-01 00:25:59.000000', 'consum', 0.0217, 'lps'),
	(628713, 133, '2015-01-01 00:26:00.000000', 'consum', 0.0218, 'lps'),
	(628714, 133, '2015-01-01 00:26:01.000000', 'consum', 0.0231, 'lps'),
	(628715, 133, '2015-01-01 00:26:02.000000', 'consum', 0.0225, 'lps'),
	(628716, 133, '2015-01-01 00:26:03.000000', 'consum', 0.0224, 'lps'),
	(628717, 133, '2015-01-01 00:26:04.000000', 'consum', 0.0235, 'lps'),
	(628718, 133, '2015-01-01 00:26:05.000000', 'consum', 0.0231, 'lps'),
	(628719, 133, '2015-01-01 00:26:06.000000', 'consum', 0.0239, 'lps'),
	(628720, 133, '2015-01-01 00:26:07.000000', 'consum', 0.0230, 'lps'),
	(628721, 133, '2015-01-01 00:26:08.000000', 'consum', 0.0221, 'lps'),
	(628722, 133, '2015-01-01 00:26:09.000000', 'consum', 0.0240, 'lps'),
	(628723, 133, '2015-01-01 00:26:10.000000', 'consum', 0.0232, 'lps'),
	(628724, 133, '2015-01-01 00:26:11.000000', 'consum', 0.0227, 'lps'),
	(628725, 133, '2015-01-01 00:26:12.000000', 'consum', 0.0233, 'lps'),
	(628726, 133, '2015-01-01 00:26:13.000000', 'consum', 0.0211, 'lps'),
	(628727, 133, '2015-01-01 00:26:14.000000', 'consum', 0.0241, 'lps'),
	(628728, 133, '2015-01-01 00:26:15.000000', 'consum', 0.0236, 'lps'),
	(628729, 133, '2015-01-01 00:26:16.000000', 'consum', 0.0214, 'lps'),
	(628730, 133, '2015-01-01 00:26:17.000000', 'consum', 0.0219, 'lps'),
	(628731, 133, '2015-01-01 00:26:18.000000', 'consum', 0.0241, 'lps'),
	(628732, 133, '2015-01-01 00:26:19.000000', 'consum', 0.0212, 'lps'),
	(628733, 133, '2015-01-01 00:26:20.000000', 'consum', 0.0222, 'lps'),
	(628734, 133, '2015-01-01 00:26:21.000000', 'consum', 0.0234, 'lps'),
	(628735, 133, '2015-01-01 00:26:22.000000', 'consum', 0.0230, 'lps'),
	(628736, 133, '2015-01-01 00:26:23.000000', 'consum', 0.0238, 'lps'),
	(628737, 133, '2015-01-01 00:26:24.000000', 'consum', 0.0225, 'lps'),
	(628738, 133, '2015-01-01 00:26:25.000000', 'consum', 0.0235, 'lps'),
	(628739, 133, '2015-01-01 00:26:26.000000', 'consum', 0.0228, 'lps'),
	(628740, 133, '2015-01-01 00:26:27.000000', 'consum', 0.0224, 'lps'),
	(628741, 133, '2015-01-01 00:26:28.000000', 'consum', 0.0228, 'lps'),
	(628742, 133, '2015-01-01 00:26:29.000000', 'consum', 0.0224, 'lps'),
	(628743, 133, '2015-01-01 00:26:30.000000', 'consum', 0.0228, 'lps'),
	(628744, 133, '2015-01-01 00:26:31.000000', 'consum', 0.0228, 'lps'),
	(628745, 133, '2015-01-01 00:26:32.000000', 'consum', 0.0212, 'lps'),
	(628746, 133, '2015-01-01 00:26:33.000000', 'consum', 0.0233, 'lps'),
	(628747, 133, '2015-01-01 00:26:34.000000', 'consum', 0.0222, 'lps'),
	(628748, 133, '2015-01-01 00:26:35.000000', 'consum', 0.0234, 'lps'),
	(628749, 133, '2015-01-01 00:26:36.000000', 'consum', 0.0230, 'lps'),
	(628750, 133, '2015-01-01 00:26:37.000000', 'consum', 0.0240, 'lps'),
	(628751, 133, '2015-01-01 00:26:38.000000', 'consum', 0.0236, 'lps'),
	(628752, 133, '2015-01-01 00:26:39.000000', 'consum', 0.0217, 'lps'),
	(628753, 133, '2015-01-01 00:26:40.000000', 'consum', 0.0231, 'lps'),
	(628754, 133, '2015-01-01 00:26:41.000000', 'consum', 0.0232, 'lps'),
	(628755, 133, '2015-01-01 00:26:42.000000', 'consum', 0.0227, 'lps'),
	(628756, 133, '2015-01-01 00:26:43.000000', 'consum', 0.0227, 'lps'),
	(628757, 133, '2015-01-01 00:26:44.000000', 'consum', 0.0212, 'lps'),
	(628758, 133, '2015-01-01 00:26:45.000000', 'consum', 0.0235, 'lps'),
	(628759, 133, '2015-01-01 00:26:46.000000', 'consum', 0.0233, 'lps'),
	(628760, 133, '2015-01-01 00:26:47.000000', 'consum', 0.0217, 'lps'),
	(628761, 133, '2015-01-01 00:26:48.000000', 'consum', 0.0211, 'lps'),
	(628762, 133, '2015-01-01 00:26:49.000000', 'consum', 0.0227, 'lps'),
	(628763, 133, '2015-01-01 00:26:50.000000', 'consum', 0.0229, 'lps'),
	(628764, 133, '2015-01-01 00:26:51.000000', 'consum', 0.0222, 'lps'),
	(628765, 133, '2015-01-01 00:26:52.000000', 'consum', 0.0214, 'lps'),
	(628766, 133, '2015-01-01 00:26:53.000000', 'consum', 0.0225, 'lps'),
	(628767, 133, '2015-01-01 00:26:54.000000', 'consum', 0.0210, 'lps'),
	(628768, 133, '2015-01-01 00:26:55.000000', 'consum', 0.0229, 'lps'),
	(628769, 133, '2015-01-01 00:26:56.000000', 'consum', 0.0241, 'lps'),
	(628770, 133, '2015-01-01 00:26:57.000000', 'consum', 0.0214, 'lps'),
	(628771, 133, '2015-01-01 00:26:58.000000', 'consum', 0.0233, 'lps'),
	(628772, 133, '2015-01-01 00:26:59.000000', 'consum', 0.0218, 'lps'),
	(628773, 133, '2015-01-01 00:27:00.000000', 'consum', 0.0214, 'lps'),
	(628774, 133, '2015-01-01 00:27:01.000000', 'consum', 0.0238, 'lps'),
	(628775, 133, '2015-01-01 00:27:02.000000', 'consum', 0.0212, 'lps'),
	(628776, 133, '2015-01-01 00:27:03.000000', 'consum', 0.0232, 'lps'),
	(628777, 133, '2015-01-01 00:27:04.000000', 'consum', 0.0216, 'lps'),
	(628778, 133, '2015-01-01 00:27:05.000000', 'consum', 0.0241, 'lps'),
	(628779, 133, '2015-01-01 00:27:06.000000', 'consum', 0.0220, 'lps'),
	(628780, 133, '2015-01-01 00:27:07.000000', 'consum', 0.0230, 'lps'),
	(628781, 133, '2015-01-01 00:27:08.000000', 'consum', 0.0219, 'lps'),
	(628782, 133, '2015-01-01 00:27:09.000000', 'consum', 0.0226, 'lps'),
	(628783, 133, '2015-01-01 00:27:10.000000', 'consum', 0.0234, 'lps'),
	(628784, 133, '2015-01-01 00:27:11.000000', 'consum', 0.0215, 'lps'),
	(628785, 133, '2015-01-01 00:27:12.000000', 'consum', 0.0227, 'lps'),
	(628786, 133, '2015-01-01 00:27:13.000000', 'consum', 0.0219, 'lps'),
	(628787, 133, '2015-01-01 00:27:14.000000', 'consum', 0.0237, 'lps'),
	(628788, 133, '2015-01-01 00:27:15.000000', 'consum', 0.0223, 'lps'),
	(628789, 133, '2015-01-01 00:27:16.000000', 'consum', 0.0227, 'lps'),
	(628790, 133, '2015-01-01 00:27:17.000000', 'consum', 0.0224, 'lps'),
	(628791, 133, '2015-01-01 00:27:18.000000', 'consum', 0.0227, 'lps'),
	(628792, 133, '2015-01-01 00:27:19.000000', 'consum', 0.0223, 'lps'),
	(628793, 133, '2015-01-01 00:27:20.000000', 'consum', 0.0226, 'lps'),
	(628794, 133, '2015-01-01 00:27:21.000000', 'consum', 0.0219, 'lps'),
	(628795, 133, '2015-01-01 00:27:22.000000', 'consum', 0.0239, 'lps'),
	(628796, 133, '2015-01-01 00:27:23.000000', 'consum', 0.0232, 'lps'),
	(628797, 133, '2015-01-01 00:27:24.000000', 'consum', 0.0233, 'lps'),
	(628798, 133, '2015-01-01 00:27:25.000000', 'consum', 0.0230, 'lps'),
	(628799, 133, '2015-01-01 00:27:26.000000', 'consum', 0.0238, 'lps'),
	(628800, 133, '2015-01-01 00:27:27.000000', 'consum', 0.0228, 'lps'),
	(628801, 133, '2015-01-01 00:27:28.000000', 'consum', 0.0218, 'lps'),
	(628802, 133, '2015-01-01 00:27:29.000000', 'consum', 0.0229, 'lps'),
	(628803, 133, '2015-01-01 00:27:30.000000', 'consum', 0.0215, 'lps'),
	(628804, 133, '2015-01-01 00:27:31.000000', 'consum', 0.0212, 'lps'),
	(628805, 133, '2015-01-01 00:27:32.000000', 'consum', 0.0239, 'lps'),
	(628806, 133, '2015-01-01 00:27:33.000000', 'consum', 0.0220, 'lps'),
	(628807, 133, '2015-01-01 00:27:34.000000', 'consum', 0.0239, 'lps'),
	(628808, 133, '2015-01-01 00:27:35.000000', 'consum', 0.0230, 'lps'),
	(628809, 133, '2015-01-01 00:27:36.000000', 'consum', 0.0221, 'lps'),
	(628810, 133, '2015-01-01 00:27:37.000000', 'consum', 0.0241, 'lps'),
	(628811, 133, '2015-01-01 00:27:38.000000', 'consum', 0.0233, 'lps'),
	(628812, 133, '2015-01-01 00:27:39.000000', 'consum', 0.0234, 'lps'),
	(628813, 133, '2015-01-01 00:27:40.000000', 'consum', 0.0230, 'lps'),
	(628814, 133, '2015-01-01 00:27:41.000000', 'consum', 0.0238, 'lps'),
	(628815, 133, '2015-01-01 00:27:42.000000', 'consum', 0.0228, 'lps'),
	(628816, 133, '2015-01-01 00:27:43.000000', 'consum', 0.0216, 'lps'),
	(628817, 133, '2015-01-01 00:27:44.000000', 'consum', 0.0218, 'lps'),
	(628818, 133, '2015-01-01 00:27:45.000000', 'consum', 0.0233, 'lps'),
	(628819, 133, '2015-01-01 00:27:46.000000', 'consum', 0.0235, 'lps'),
	(628820, 133, '2015-01-01 00:27:47.000000', 'consum', 0.0238, 'lps'),
	(628821, 133, '2015-01-01 00:27:48.000000', 'consum', 0.0240, 'lps'),
	(628822, 133, '2015-01-01 00:27:49.000000', 'consum', 0.0216, 'lps'),
	(628823, 133, '2015-01-01 00:27:50.000000', 'consum', 0.0213, 'lps'),
	(628824, 133, '2015-01-01 00:27:51.000000', 'consum', 0.0239, 'lps'),
	(628825, 133, '2015-01-01 00:27:52.000000', 'consum', 0.0220, 'lps'),
	(628826, 133, '2015-01-01 00:27:53.000000', 'consum', 0.0238, 'lps'),
	(628827, 133, '2015-01-01 00:27:54.000000', 'consum', 0.0224, 'lps'),
	(628828, 133, '2015-01-01 00:27:55.000000', 'consum', 0.0227, 'lps'),
	(628829, 133, '2015-01-01 00:27:56.000000', 'consum', 0.0220, 'lps'),
	(628830, 133, '2015-01-01 00:27:57.000000', 'consum', 0.0213, 'lps'),
	(628831, 133, '2015-01-01 00:27:58.000000', 'consum', 0.0226, 'lps'),
	(628832, 133, '2015-01-01 00:27:59.000000', 'consum', 0.0216, 'lps'),
	(628833, 133, '2015-01-01 00:28:00.000000', 'consum', 0.0225, 'lps'),
	(628834, 133, '2015-01-01 00:28:01.000000', 'consum', 0.0236, 'lps'),
	(628835, 133, '2015-01-01 00:28:02.000000', 'consum', 0.0234, 'lps'),
	(628836, 133, '2015-01-01 00:28:03.000000', 'consum', 0.0217, 'lps'),
	(628837, 133, '2015-01-01 00:28:04.000000', 'consum', 0.0238, 'lps'),
	(628838, 133, '2015-01-01 00:28:05.000000', 'consum', 0.0236, 'lps'),
	(628839, 133, '2015-01-01 00:28:06.000000', 'consum', 0.0223, 'lps'),
	(628840, 133, '2015-01-01 00:28:07.000000', 'consum', 0.0228, 'lps'),
	(628841, 133, '2015-01-01 00:28:08.000000', 'consum', 0.0230, 'lps'),
	(628842, 133, '2015-01-01 00:28:09.000000', 'consum', 0.0226, 'lps'),
	(628843, 133, '2015-01-01 00:28:10.000000', 'consum', 0.0231, 'lps'),
	(628844, 133, '2015-01-01 00:28:11.000000', 'consum', 0.0236, 'lps'),
	(628845, 133, '2015-01-01 00:28:12.000000', 'consum', 0.0211, 'lps'),
	(628846, 133, '2015-01-01 00:28:13.000000', 'consum', 0.0233, 'lps'),
	(628847, 133, '2015-01-01 00:28:14.000000', 'consum', 0.0226, 'lps'),
	(628848, 133, '2015-01-01 00:28:15.000000', 'consum', 0.0221, 'lps'),
	(628849, 133, '2015-01-01 00:28:16.000000', 'consum', 0.0219, 'lps'),
	(628850, 133, '2015-01-01 00:28:17.000000', 'consum', 0.0221, 'lps'),
	(628851, 133, '2015-01-01 00:28:18.000000', 'consum', 0.0239, 'lps'),
	(628852, 133, '2015-01-01 00:28:19.000000', 'consum', 0.0228, 'lps'),
	(628853, 133, '2015-01-01 00:28:20.000000', 'consum', 0.0211, 'lps'),
	(628854, 133, '2015-01-01 00:28:21.000000', 'consum', 0.0225, 'lps'),
	(628855, 133, '2015-01-01 00:28:22.000000', 'consum', 0.0219, 'lps'),
	(628856, 133, '2015-01-01 00:28:23.000000', 'consum', 0.0211, 'lps'),
	(628857, 133, '2015-01-01 00:28:24.000000', 'consum', 0.0220, 'lps'),
	(628858, 133, '2015-01-01 00:28:25.000000', 'consum', 0.0225, 'lps'),
	(628859, 133, '2015-01-01 00:28:26.000000', 'consum', 0.0224, 'lps'),
	(628860, 133, '2015-01-01 00:28:27.000000', 'consum', 0.0235, 'lps'),
	(628861, 133, '2015-01-01 00:28:28.000000', 'consum', 0.0229, 'lps'),
	(628862, 133, '2015-01-01 00:28:29.000000', 'consum', 0.0232, 'lps'),
	(628863, 133, '2015-01-01 00:28:30.000000', 'consum', 0.0232, 'lps'),
	(628864, 133, '2015-01-01 00:28:31.000000', 'consum', 0.0221, 'lps'),
	(628865, 133, '2015-01-01 00:28:32.000000', 'consum', 0.0234, 'lps'),
	(628866, 133, '2015-01-01 00:28:33.000000', 'consum', 0.0231, 'lps'),
	(628867, 133, '2015-01-01 00:28:34.000000', 'consum', 0.0211, 'lps'),
	(628868, 133, '2015-01-01 00:28:35.000000', 'consum', 0.0217, 'lps'),
	(628869, 133, '2015-01-01 00:28:36.000000', 'consum', 0.0213, 'lps'),
	(628870, 133, '2015-01-01 00:28:37.000000', 'consum', 0.0234, 'lps'),
	(628871, 133, '2015-01-01 00:28:38.000000', 'consum', 0.0228, 'lps'),
	(628872, 133, '2015-01-01 00:28:39.000000', 'consum', 0.0228, 'lps'),
	(628873, 133, '2015-01-01 00:28:40.000000', 'consum', 0.0213, 'lps'),
	(628874, 133, '2015-01-01 00:28:41.000000', 'consum', 0.0235, 'lps'),
	(628875, 133, '2015-01-01 00:28:42.000000', 'consum', 0.0233, 'lps'),
	(628876, 133, '2015-01-01 00:28:43.000000', 'consum', 0.0219, 'lps'),
	(628877, 133, '2015-01-01 00:28:44.000000', 'consum', 0.0216, 'lps'),
	(628878, 133, '2015-01-01 00:28:45.000000', 'consum', 0.0213, 'lps'),
	(628879, 133, '2015-01-01 00:28:46.000000', 'consum', 0.0240, 'lps'),
	(628880, 133, '2015-01-01 00:28:47.000000', 'consum', 0.0224, 'lps'),
	(628881, 133, '2015-01-01 00:28:48.000000', 'consum', 0.0221, 'lps'),
	(628882, 133, '2015-01-01 00:28:49.000000', 'consum', 0.0223, 'lps'),
	(628883, 133, '2015-01-01 00:28:50.000000', 'consum', 0.0210, 'lps'),
	(628884, 133, '2015-01-01 00:28:51.000000', 'consum', 0.0236, 'lps'),
	(628885, 133, '2015-01-01 00:28:52.000000', 'consum', 0.0214, 'lps'),
	(628886, 133, '2015-01-01 00:28:53.000000', 'consum', 0.0214, 'lps'),
	(628887, 133, '2015-01-01 00:28:54.000000', 'consum', 0.0221, 'lps'),
	(628888, 133, '2015-01-01 00:28:55.000000', 'consum', 0.0220, 'lps'),
	(628889, 133, '2015-01-01 00:28:56.000000', 'consum', 0.0230, 'lps'),
	(628890, 133, '2015-01-01 00:28:57.000000', 'consum', 0.0213, 'lps'),
	(628891, 133, '2015-01-01 00:28:58.000000', 'consum', 0.0231, 'lps'),
	(628892, 133, '2015-01-01 00:28:59.000000', 'consum', 0.0241, 'lps'),
	(628893, 133, '2015-01-01 00:29:00.000000', 'consum', 0.0240, 'lps'),
	(628894, 133, '2015-01-01 00:29:01.000000', 'consum', 0.0236, 'lps'),
	(628895, 133, '2015-01-01 00:29:02.000000', 'consum', 0.0217, 'lps'),
	(628896, 133, '2015-01-01 00:29:03.000000', 'consum', 0.0231, 'lps'),
	(628897, 133, '2015-01-01 00:29:04.000000', 'consum', 0.0229, 'lps'),
	(628898, 133, '2015-01-01 00:29:05.000000', 'consum', 0.0214, 'lps'),
	(628899, 133, '2015-01-01 00:29:06.000000', 'consum', 0.0236, 'lps'),
	(628900, 133, '2015-01-01 00:29:07.000000', 'consum', 0.0232, 'lps'),
	(628901, 133, '2015-01-01 00:29:08.000000', 'consum', 0.0212, 'lps'),
	(628902, 133, '2015-01-01 00:29:09.000000', 'consum', 0.0216, 'lps'),
	(628903, 133, '2015-01-01 00:29:10.000000', 'consum', 0.0235, 'lps'),
	(628904, 133, '2015-01-01 00:29:11.000000', 'consum', 0.0222, 'lps'),
	(628905, 133, '2015-01-01 00:29:12.000000', 'consum', 0.0226, 'lps'),
	(628906, 133, '2015-01-01 00:29:13.000000', 'consum', 0.0225, 'lps'),
	(628907, 133, '2015-01-01 00:29:14.000000', 'consum', 0.0235, 'lps'),
	(628908, 133, '2015-01-01 00:29:15.000000', 'consum', 0.0226, 'lps'),
	(628909, 133, '2015-01-01 00:29:16.000000', 'consum', 0.0217, 'lps'),
	(628910, 133, '2015-01-01 00:29:17.000000', 'consum', 0.0227, 'lps'),
	(628911, 133, '2015-01-01 00:29:18.000000', 'consum', 0.0213, 'lps'),
	(628912, 133, '2015-01-01 00:29:19.000000', 'consum', 0.0238, 'lps'),
	(628913, 133, '2015-01-01 00:29:20.000000', 'consum', 0.0211, 'lps'),
	(628914, 133, '2015-01-01 00:29:21.000000', 'consum', 0.0230, 'lps'),
	(628915, 133, '2015-01-01 00:29:22.000000', 'consum', 0.0212, 'lps'),
	(628916, 133, '2015-01-01 00:29:23.000000', 'consum', 0.0225, 'lps'),
	(628917, 133, '2015-01-01 00:29:24.000000', 'consum', 0.0215, 'lps'),
	(628918, 133, '2015-01-01 00:29:25.000000', 'consum', 0.0221, 'lps'),
	(628919, 133, '2015-01-01 00:29:26.000000', 'consum', 0.0220, 'lps'),
	(628920, 133, '2015-01-01 00:29:27.000000', 'consum', 0.0228, 'lps'),
	(628921, 133, '2015-01-01 00:29:28.000000', 'consum', 0.0239, 'lps'),
	(628922, 133, '2015-01-01 00:29:29.000000', 'consum', 0.0237, 'lps'),
	(628923, 133, '2015-01-01 00:29:30.000000', 'consum', 0.0225, 'lps'),
	(628924, 133, '2015-01-01 00:29:31.000000', 'consum', 0.0239, 'lps'),
	(628925, 133, '2015-01-01 00:29:32.000000', 'consum', 0.0215, 'lps'),
	(628926, 133, '2015-01-01 00:29:33.000000', 'consum', 0.0212, 'lps'),
	(628927, 133, '2015-01-01 00:29:34.000000', 'consum', 0.0236, 'lps'),
	(628928, 133, '2015-01-01 00:29:35.000000', 'consum', 0.0237, 'lps'),
	(628929, 133, '2015-01-01 00:29:36.000000', 'consum', 0.0238, 'lps'),
	(628930, 133, '2015-01-01 00:29:37.000000', 'consum', 0.0239, 'lps'),
	(628931, 133, '2015-01-01 00:29:38.000000', 'consum', 0.0237, 'lps'),
	(628932, 133, '2015-01-01 00:29:39.000000', 'consum', 0.0226, 'lps'),
	(628933, 133, '2015-01-01 00:29:40.000000', 'consum', 0.0210, 'lps'),
	(628934, 133, '2015-01-01 00:29:41.000000', 'consum', 0.0225, 'lps'),
	(628935, 133, '2015-01-01 00:29:42.000000', 'consum', 0.0223, 'lps'),
	(628936, 133, '2015-01-01 00:29:43.000000', 'consum', 0.0231, 'lps'),
	(628937, 133, '2015-01-01 00:29:44.000000', 'consum', 0.0213, 'lps'),
	(628938, 133, '2015-01-01 00:29:45.000000', 'consum', 0.0226, 'lps'),
	(628939, 133, '2015-01-01 00:29:46.000000', 'consum', 0.0217, 'lps'),
	(628940, 133, '2015-01-01 00:29:47.000000', 'consum', 0.0230, 'lps'),
	(628941, 133, '2015-01-01 00:29:48.000000', 'consum', 0.0224, 'lps'),
	(628942, 133, '2015-01-01 00:29:49.000000', 'consum', 0.0220, 'lps'),
	(628943, 133, '2015-01-01 00:29:50.000000', 'consum', 0.0221, 'lps'),
	(628944, 133, '2015-01-01 00:29:51.000000', 'consum', 0.0233, 'lps'),
	(628945, 133, '2015-01-01 00:29:52.000000', 'consum', 0.0228, 'lps'),
	(628946, 133, '2015-01-01 00:29:53.000000', 'consum', 0.0230, 'lps'),
	(628947, 133, '2015-01-01 00:29:54.000000', 'consum', 0.0228, 'lps'),
	(628948, 133, '2015-01-01 00:29:55.000000', 'consum', 0.0241, 'lps'),
	(628949, 133, '2015-01-01 00:29:56.000000', 'consum', 0.0213, 'lps'),
	(628950, 133, '2015-01-01 00:29:57.000000', 'consum', 0.0227, 'lps'),
	(628951, 133, '2015-01-01 00:29:58.000000', 'consum', 0.0226, 'lps'),
	(628952, 133, '2015-01-01 00:29:59.000000', 'consum', 0.0238, 'lps'),
	(628953, 133, '2015-01-01 00:30:00.000000', 'consum', 0.0240, 'lps'),
	(628954, 133, '2015-01-01 00:30:01.000000', 'consum', 0.0210, 'lps'),
	(628955, 133, '2015-01-01 00:30:02.000000', 'consum', 0.0216, 'lps'),
	(628956, 133, '2015-01-01 00:30:03.000000', 'consum', 0.0212, 'lps'),
	(628957, 133, '2015-01-01 00:30:04.000000', 'consum', 0.0232, 'lps'),
	(628958, 133, '2015-01-01 00:30:05.000000', 'consum', 0.0218, 'lps'),
	(628959, 133, '2015-01-01 00:30:06.000000', 'consum', 0.0216, 'lps'),
	(628960, 133, '2015-01-01 00:30:07.000000', 'consum', 0.0215, 'lps'),
	(628961, 133, '2015-01-01 00:30:08.000000', 'consum', 0.0220, 'lps'),
	(628962, 133, '2015-01-01 00:30:09.000000', 'consum', 0.0214, 'lps'),
	(628963, 133, '2015-01-01 00:30:10.000000', 'consum', 0.0233, 'lps'),
	(628964, 133, '2015-01-01 00:30:11.000000', 'consum', 0.0215, 'lps'),
	(628965, 133, '2015-01-01 00:30:12.000000', 'consum', 0.0231, 'lps'),
	(628966, 133, '2015-01-01 00:30:13.000000', 'consum', 0.0235, 'lps'),
	(628967, 133, '2015-01-01 00:30:14.000000', 'consum', 0.0210, 'lps'),
	(628968, 133, '2015-01-01 00:30:15.000000', 'consum', 0.0232, 'lps'),
	(628969, 133, '2015-01-01 00:30:16.000000', 'consum', 0.0225, 'lps'),
	(628970, 133, '2015-01-01 00:30:17.000000', 'consum', 0.0218, 'lps'),
	(628971, 133, '2015-01-01 00:30:18.000000', 'consum', 0.0239, 'lps'),
	(628972, 133, '2015-01-01 00:30:19.000000', 'consum', 0.0236, 'lps'),
	(628973, 133, '2015-01-01 00:30:20.000000', 'consum', 0.0219, 'lps'),
	(628974, 133, '2015-01-01 00:30:21.000000', 'consum', 0.0212, 'lps'),
	(628975, 133, '2015-01-01 00:30:22.000000', 'consum', 0.0226, 'lps'),
	(628976, 133, '2015-01-01 00:30:23.000000', 'consum', 0.0218, 'lps'),
	(628977, 133, '2015-01-01 00:30:24.000000', 'consum', 0.0234, 'lps'),
	(628978, 133, '2015-01-01 00:30:25.000000', 'consum', 0.0210, 'lps'),
	(628979, 133, '2015-01-01 00:30:26.000000', 'consum', 0.0234, 'lps'),
	(628980, 133, '2015-01-01 00:30:27.000000', 'consum', 0.0234, 'lps'),
	(628981, 133, '2015-01-01 00:30:28.000000', 'consum', 0.0228, 'lps'),
	(628982, 133, '2015-01-01 00:30:29.000000', 'consum', 0.0228, 'lps'),
	(628983, 133, '2015-01-01 00:30:30.000000', 'consum', 0.0216, 'lps'),
	(628984, 133, '2015-01-01 00:30:31.000000', 'consum', 0.0216, 'lps'),
	(628985, 133, '2015-01-01 00:30:32.000000', 'consum', 0.0222, 'lps'),
	(628986, 133, '2015-01-01 00:30:33.000000', 'consum', 0.0222, 'lps'),
	(628987, 133, '2015-01-01 00:30:34.000000', 'consum', 0.0233, 'lps'),
	(628988, 133, '2015-01-01 00:30:35.000000', 'consum', 0.0227, 'lps'),
	(628989, 133, '2015-01-01 00:30:36.000000', 'consum', 0.0226, 'lps'),
	(628990, 133, '2015-01-01 00:30:37.000000', 'consum', 0.0240, 'lps'),
	(628991, 133, '2015-01-01 00:30:38.000000', 'consum', 0.0217, 'lps'),
	(628992, 133, '2015-01-01 00:30:39.000000', 'consum', 0.0218, 'lps'),
	(628993, 133, '2015-01-01 00:30:40.000000', 'consum', 0.0232, 'lps'),
	(628994, 133, '2015-01-01 00:30:41.000000', 'consum', 0.0231, 'lps'),
	(628995, 133, '2015-01-01 00:30:42.000000', 'consum', 0.0218, 'lps'),
	(628996, 133, '2015-01-01 00:30:43.000000', 'consum', 0.0218, 'lps'),
	(628997, 133, '2015-01-01 00:30:44.000000', 'consum', 0.0229, 'lps'),
	(628998, 133, '2015-01-01 00:30:45.000000', 'consum', 0.0215, 'lps'),
	(628999, 133, '2015-01-01 00:30:46.000000', 'consum', 0.0212, 'lps'),
	(629000, 133, '2015-01-01 00:30:47.000000', 'consum', 0.0237, 'lps'),
	(629001, 133, '2015-01-01 00:30:48.000000', 'consum', 0.0212, 'lps'),
	(629002, 133, '2015-01-01 00:30:49.000000', 'consum', 0.0233, 'lps'),
	(629003, 133, '2015-01-01 00:30:50.000000', 'consum', 0.0225, 'lps'),
	(629004, 133, '2015-01-01 00:30:51.000000', 'consum', 0.0218, 'lps'),
	(629005, 133, '2015-01-01 00:30:52.000000', 'consum', 0.0236, 'lps'),
	(629006, 133, '2015-01-01 00:30:53.000000', 'consum', 0.0220, 'lps'),
	(629007, 133, '2015-01-01 00:30:54.000000', 'consum', 0.0216, 'lps'),
	(629008, 133, '2015-01-01 00:30:55.000000', 'consum', 0.0240, 'lps'),
	(629009, 133, '2015-01-01 00:30:56.000000', 'consum', 0.0215, 'lps'),
	(629010, 133, '2015-01-01 00:30:57.000000', 'consum', 0.0211, 'lps'),
	(629011, 133, '2015-01-01 00:30:58.000000', 'consum', 0.0233, 'lps'),
	(629012, 133, '2015-01-01 00:30:59.000000', 'consum', 0.0224, 'lps'),
	(629013, 133, '2015-01-01 00:31:00.000000', 'consum', 0.0213, 'lps'),
	(629014, 133, '2015-01-01 00:31:01.000000', 'consum', 0.0216, 'lps'),
	(629015, 133, '2015-01-01 00:31:02.000000', 'consum', 0.0230, 'lps'),
	(629016, 133, '2015-01-01 00:31:03.000000', 'consum', 0.0229, 'lps'),
	(629017, 133, '2015-01-01 00:31:04.000000', 'consum', 0.0213, 'lps'),
	(629018, 133, '2015-01-01 00:31:05.000000', 'consum', 0.0235, 'lps'),
	(629019, 133, '2015-01-01 00:31:06.000000', 'consum', 0.0227, 'lps'),
	(629020, 133, '2015-01-01 00:31:07.000000', 'consum', 0.0223, 'lps'),
	(629021, 133, '2015-01-01 00:31:08.000000', 'consum', 0.0224, 'lps'),
	(629022, 133, '2015-01-01 00:31:09.000000', 'consum', 0.0211, 'lps'),
	(629023, 133, '2015-01-01 00:31:10.000000', 'consum', 0.0237, 'lps'),
	(629024, 133, '2015-01-01 00:31:11.000000', 'consum', 0.0216, 'lps'),
	(629025, 133, '2015-01-01 00:31:12.000000', 'consum', 0.0221, 'lps'),
	(629026, 133, '2015-01-01 00:31:13.000000', 'consum', 0.0217, 'lps'),
	(629027, 133, '2015-01-01 00:31:14.000000', 'consum', 0.0212, 'lps'),
	(629028, 133, '2015-01-01 00:31:15.000000', 'consum', 0.0230, 'lps'),
	(629029, 133, '2015-01-01 00:31:16.000000', 'consum', 0.0240, 'lps'),
	(629030, 133, '2015-01-01 00:31:17.000000', 'consum', 0.0236, 'lps'),
	(629031, 133, '2015-01-01 00:31:18.000000', 'consum', 0.0222, 'lps'),
	(629032, 133, '2015-01-01 00:31:19.000000', 'consum', 0.0221, 'lps'),
	(629033, 133, '2015-01-01 00:31:20.000000', 'consum', 0.0233, 'lps'),
	(629034, 133, '2015-01-01 00:31:21.000000', 'consum', 0.0226, 'lps'),
	(629035, 133, '2015-01-01 00:31:22.000000', 'consum', 0.0221, 'lps'),
	(629036, 133, '2015-01-01 00:31:23.000000', 'consum', 0.0217, 'lps'),
	(629037, 133, '2015-01-01 00:31:24.000000', 'consum', 0.0214, 'lps'),
	(629038, 133, '2015-01-01 00:31:25.000000', 'consum', 0.0211, 'lps'),
	(629039, 133, '2015-01-01 00:31:26.000000', 'consum', 0.0234, 'lps'),
	(629040, 133, '2015-01-01 00:31:27.000000', 'consum', 0.0230, 'lps'),
	(629041, 133, '2015-01-01 00:31:28.000000', 'consum', 0.0239, 'lps'),
	(629042, 133, '2015-01-01 00:31:29.000000', 'consum', 0.0230, 'lps'),
	(629043, 133, '2015-01-01 00:31:30.000000', 'consum', 0.0225, 'lps'),
	(629044, 133, '2015-01-01 00:31:31.000000', 'consum', 0.0227, 'lps'),
	(629045, 133, '2015-01-01 00:31:32.000000', 'consum', 0.0218, 'lps'),
	(629046, 133, '2015-01-01 00:31:33.000000', 'consum', 0.0231, 'lps'),
	(629047, 133, '2015-01-01 00:31:34.000000', 'consum', 0.0229, 'lps'),
	(629048, 133, '2015-01-01 00:31:35.000000', 'consum', 0.0241, 'lps'),
	(629049, 133, '2015-01-01 00:31:36.000000', 'consum', 0.0214, 'lps'),
	(629050, 133, '2015-01-01 00:31:37.000000', 'consum', 0.0232, 'lps'),
	(629051, 133, '2015-01-01 00:31:38.000000', 'consum', 0.0213, 'lps'),
	(629052, 133, '2015-01-01 00:31:39.000000', 'consum', 0.0223, 'lps'),
	(629053, 133, '2015-01-01 00:31:40.000000', 'consum', 0.0235, 'lps'),
	(629054, 133, '2015-01-01 00:31:41.000000', 'consum', 0.0231, 'lps'),
	(629055, 133, '2015-01-01 00:31:42.000000', 'consum', 0.0241, 'lps'),
	(629056, 133, '2015-01-01 00:31:43.000000', 'consum', 0.0239, 'lps'),
	(629057, 133, '2015-01-01 00:31:44.000000', 'consum', 0.0231, 'lps'),
	(629058, 133, '2015-01-01 00:31:45.000000', 'consum', 0.0228, 'lps'),
	(629059, 133, '2015-01-01 00:31:46.000000', 'consum', 0.0239, 'lps'),
	(629060, 133, '2015-01-01 00:31:47.000000', 'consum', 0.0236, 'lps'),
	(629061, 133, '2015-01-01 00:31:48.000000', 'consum', 0.0221, 'lps'),
	(629062, 133, '2015-01-01 00:31:49.000000', 'consum', 0.0219, 'lps'),
	(629063, 133, '2015-01-01 00:31:50.000000', 'consum', 0.0222, 'lps'),
	(629064, 133, '2015-01-01 00:31:51.000000', 'consum', 0.0214, 'lps'),
	(629065, 133, '2015-01-01 00:31:52.000000', 'consum', 0.0226, 'lps'),
	(629066, 133, '2015-01-01 00:31:53.000000', 'consum', 0.0216, 'lps'),
	(629067, 133, '2015-01-01 00:31:54.000000', 'consum', 0.0221, 'lps'),
	(629068, 133, '2015-01-01 00:31:55.000000', 'consum', 0.0219, 'lps'),
	(629069, 133, '2015-01-01 00:31:56.000000', 'consum', 0.0220, 'lps'),
	(629070, 133, '2015-01-01 00:31:57.000000', 'consum', 0.0233, 'lps'),
	(629071, 133, '2015-01-01 00:31:58.000000', 'consum', 0.0234, 'lps'),
	(629072, 133, '2015-01-01 00:31:59.000000', 'consum', 0.0228, 'lps'),
	(629073, 133, '2015-01-01 00:32:00.000000', 'consum', 0.0228, 'lps'),
	(629074, 133, '2015-01-01 00:32:01.000000', 'consum', 0.0216, 'lps'),
	(629075, 133, '2015-01-01 00:32:02.000000', 'consum', 0.0219, 'lps'),
	(629076, 133, '2015-01-01 00:32:03.000000', 'consum', 0.0238, 'lps'),
	(629077, 133, '2015-01-01 00:32:04.000000', 'consum', 0.0227, 'lps'),
	(629078, 133, '2015-01-01 00:32:05.000000', 'consum', 0.0210, 'lps'),
	(629079, 133, '2015-01-01 00:32:06.000000', 'consum', 0.0226, 'lps'),
	(629080, 133, '2015-01-01 00:32:07.000000', 'consum', 0.0224, 'lps'),
	(629081, 133, '2015-01-01 00:32:08.000000', 'consum', 0.0235, 'lps'),
	(629082, 133, '2015-01-01 00:32:09.000000', 'consum', 0.0227, 'lps'),
	(629083, 133, '2015-01-01 00:32:10.000000', 'consum', 0.0220, 'lps'),
	(629084, 133, '2015-01-01 00:32:11.000000', 'consum', 0.0241, 'lps'),
	(629085, 133, '2015-01-01 00:32:12.000000', 'consum', 0.0239, 'lps'),
	(629086, 133, '2015-01-01 00:32:13.000000', 'consum', 0.0230, 'lps'),
	(629087, 133, '2015-01-01 00:32:14.000000', 'consum', 0.0224, 'lps'),
	(629088, 133, '2015-01-01 00:32:15.000000', 'consum', 0.0221, 'lps'),
	(629089, 133, '2015-01-01 00:32:16.000000', 'consum', 0.0223, 'lps'),
	(629090, 133, '2015-01-01 00:32:17.000000', 'consum', 0.0212, 'lps'),
	(629091, 133, '2015-01-01 00:32:18.000000', 'consum', 0.0213, 'lps'),
	(629092, 133, '2015-01-01 00:32:19.000000', 'consum', 0.0221, 'lps'),
	(629093, 133, '2015-01-01 00:32:20.000000', 'consum', 0.0224, 'lps'),
	(629094, 133, '2015-01-01 00:32:21.000000', 'consum', 0.0215, 'lps'),
	(629095, 133, '2015-01-01 00:32:22.000000', 'consum', 0.0226, 'lps'),
	(629096, 133, '2015-01-01 00:32:23.000000', 'consum', 0.0210, 'lps'),
	(629097, 133, '2015-01-01 00:32:24.000000', 'consum', 0.0226, 'lps'),
	(629098, 133, '2015-01-01 00:32:25.000000', 'consum', 0.0229, 'lps'),
	(629099, 133, '2015-01-01 00:32:26.000000', 'consum', 0.0225, 'lps'),
	(629100, 133, '2015-01-01 00:32:27.000000', 'consum', 0.0226, 'lps'),
	(629101, 133, '2015-01-01 00:32:28.000000', 'consum', 0.0217, 'lps'),
	(629102, 133, '2015-01-01 00:32:29.000000', 'consum', 0.0227, 'lps'),
	(629103, 133, '2015-01-01 00:32:30.000000', 'consum', 0.0241, 'lps'),
	(629104, 133, '2015-01-01 00:32:31.000000', 'consum', 0.0222, 'lps'),
	(629105, 133, '2015-01-01 00:32:32.000000', 'consum', 0.0240, 'lps'),
	(629106, 133, '2015-01-01 00:32:33.000000', 'consum', 0.0230, 'lps'),
	(629107, 133, '2015-01-01 00:32:34.000000', 'consum', 0.0221, 'lps'),
	(629108, 133, '2015-01-01 00:32:35.000000', 'consum', 0.0238, 'lps'),
	(629109, 133, '2015-01-01 00:32:36.000000', 'consum', 0.0220, 'lps'),
	(629110, 133, '2015-01-01 00:32:37.000000', 'consum', 0.0240, 'lps'),
	(629111, 133, '2015-01-01 00:32:38.000000', 'consum', 0.0235, 'lps'),
	(629112, 133, '2015-01-01 00:32:39.000000', 'consum', 0.0214, 'lps'),
	(629113, 133, '2015-01-01 00:32:40.000000', 'consum', 0.0220, 'lps'),
	(629114, 133, '2015-01-01 00:32:41.000000', 'consum', 0.0217, 'lps'),
	(629115, 133, '2015-01-01 00:32:42.000000', 'consum', 0.0214, 'lps'),
	(629116, 133, '2015-01-01 00:32:43.000000', 'consum', 0.0211, 'lps'),
	(629117, 133, '2015-01-01 00:32:44.000000', 'consum', 0.0235, 'lps'),
	(629118, 133, '2015-01-01 00:32:45.000000', 'consum', 0.0235, 'lps'),
	(629119, 133, '2015-01-01 00:32:46.000000', 'consum', 0.0229, 'lps'),
	(629120, 133, '2015-01-01 00:32:47.000000', 'consum', 0.0229, 'lps'),
	(629121, 133, '2015-01-01 00:32:48.000000', 'consum', 0.0218, 'lps'),
	(629122, 133, '2015-01-01 00:32:49.000000', 'consum', 0.0224, 'lps'),
	(629123, 133, '2015-01-01 00:32:50.000000', 'consum', 0.0226, 'lps'),
	(629124, 133, '2015-01-01 00:32:51.000000', 'consum', 0.0215, 'lps'),
	(629125, 133, '2015-01-01 00:32:52.000000', 'consum', 0.0219, 'lps'),
	(629126, 133, '2015-01-01 00:32:53.000000', 'consum', 0.0240, 'lps'),
	(629127, 133, '2015-01-01 00:32:54.000000', 'consum', 0.0240, 'lps'),
	(629128, 133, '2015-01-01 00:32:55.000000', 'consum', 0.0237, 'lps'),
	(629129, 133, '2015-01-01 00:32:56.000000', 'consum', 0.0223, 'lps'),
	(629130, 133, '2015-01-01 00:32:57.000000', 'consum', 0.0227, 'lps'),
	(629131, 133, '2015-01-01 00:32:58.000000', 'consum', 0.0223, 'lps'),
	(629132, 133, '2015-01-01 00:32:59.000000', 'consum', 0.0226, 'lps'),
	(629133, 133, '2015-01-01 00:33:00.000000', 'consum', 0.0221, 'lps'),
	(629134, 133, '2015-01-01 00:33:01.000000', 'consum', 0.0215, 'lps'),
	(629135, 133, '2015-01-01 00:33:02.000000', 'consum', 0.0236, 'lps'),
	(629136, 133, '2015-01-01 00:33:03.000000', 'consum', 0.0227, 'lps'),
	(629137, 133, '2015-01-01 00:33:04.000000', 'consum', 0.0220, 'lps'),
	(629138, 133, '2015-01-01 00:33:05.000000', 'consum', 0.0241, 'lps'),
	(629139, 133, '2015-01-01 00:33:06.000000', 'consum', 0.0241, 'lps'),
	(629140, 133, '2015-01-01 00:33:07.000000', 'consum', 0.0240, 'lps'),
	(629141, 133, '2015-01-01 00:33:08.000000', 'consum', 0.0237, 'lps'),
	(629142, 133, '2015-01-01 00:33:09.000000', 'consum', 0.0223, 'lps'),
	(629143, 133, '2015-01-01 00:33:10.000000', 'consum', 0.0224, 'lps'),
	(629144, 133, '2015-01-01 00:33:11.000000', 'consum', 0.0210, 'lps'),
	(629145, 133, '2015-01-01 00:33:12.000000', 'consum', 0.0235, 'lps'),
	(629146, 133, '2015-01-01 00:33:13.000000', 'consum', 0.0238, 'lps'),
	(629147, 133, '2015-01-01 00:33:14.000000', 'consum', 0.0212, 'lps'),
	(629148, 133, '2015-01-01 00:33:15.000000', 'consum', 0.0232, 'lps'),
	(629149, 133, '2015-01-01 00:33:16.000000', 'consum', 0.0220, 'lps'),
	(629150, 133, '2015-01-01 00:33:17.000000', 'consum', 0.0225, 'lps'),
	(629151, 133, '2015-01-01 00:33:18.000000', 'consum', 0.0225, 'lps'),
	(629152, 133, '2015-01-01 00:33:19.000000', 'consum', 0.0239, 'lps'),
	(629153, 133, '2015-01-01 00:33:20.000000', 'consum', 0.0215, 'lps'),
	(629154, 133, '2015-01-01 00:33:21.000000', 'consum', 0.0211, 'lps'),
	(629155, 133, '2015-01-01 00:33:22.000000', 'consum', 0.0233, 'lps'),
	(629156, 133, '2015-01-01 00:33:23.000000', 'consum', 0.0225, 'lps'),
	(629157, 133, '2015-01-01 00:33:24.000000', 'consum', 0.0219, 'lps'),
	(629158, 133, '2015-01-01 00:33:25.000000', 'consum', 0.0210, 'lps'),
	(629159, 133, '2015-01-01 00:33:26.000000', 'consum', 0.0214, 'lps'),
	(629160, 133, '2015-01-01 00:33:27.000000', 'consum', 0.0230, 'lps'),
	(629161, 133, '2015-01-01 00:33:28.000000', 'consum', 0.0235, 'lps'),
	(629162, 133, '2015-01-01 00:33:29.000000', 'consum', 0.0210, 'lps'),
	(629163, 133, '2015-01-01 00:33:30.000000', 'consum', 0.0234, 'lps'),
	(629164, 133, '2015-01-01 00:33:31.000000', 'consum', 0.0232, 'lps'),
	(629165, 133, '2015-01-01 00:33:32.000000', 'consum', 0.0220, 'lps'),
	(629166, 133, '2015-01-01 00:33:33.000000', 'consum', 0.0223, 'lps'),
	(629167, 133, '2015-01-01 00:33:34.000000', 'consum', 0.0216, 'lps'),
	(629168, 133, '2015-01-01 00:33:35.000000', 'consum', 0.0231, 'lps'),
	(629169, 133, '2015-01-01 00:33:36.000000', 'consum', 0.0235, 'lps'),
	(629170, 133, '2015-01-01 00:33:37.000000', 'consum', 0.0240, 'lps'),
	(629171, 133, '2015-01-01 00:33:38.000000', 'consum', 0.0220, 'lps'),
	(629172, 133, '2015-01-01 00:33:39.000000', 'consum', 0.0236, 'lps'),
	(629173, 133, '2015-01-01 00:33:40.000000', 'consum', 0.0213, 'lps'),
	(629174, 133, '2015-01-01 00:33:41.000000', 'consum', 0.0212, 'lps'),
	(629175, 133, '2015-01-01 00:33:42.000000', 'consum', 0.0210, 'lps'),
	(629176, 133, '2015-01-01 00:33:43.000000', 'consum', 0.0240, 'lps'),
	(629177, 133, '2015-01-01 00:33:44.000000', 'consum', 0.0230, 'lps'),
	(629178, 133, '2015-01-01 00:33:45.000000', 'consum', 0.0220, 'lps'),
	(629179, 133, '2015-01-01 00:33:46.000000', 'consum', 0.0235, 'lps'),
	(629180, 133, '2015-01-01 00:33:47.000000', 'consum', 0.0240, 'lps'),
	(629181, 133, '2015-01-01 00:33:48.000000', 'consum', 0.0221, 'lps'),
	(629182, 133, '2015-01-01 00:33:49.000000', 'consum', 0.0241, 'lps'),
	(629183, 133, '2015-01-01 00:33:50.000000', 'consum', 0.0237, 'lps'),
	(629184, 133, '2015-01-01 00:33:51.000000', 'consum', 0.0218, 'lps'),
	(629185, 133, '2015-01-01 00:33:52.000000', 'consum', 0.0236, 'lps'),
	(629186, 133, '2015-01-01 00:33:53.000000', 'consum', 0.0220, 'lps'),
	(629187, 133, '2015-01-01 00:33:54.000000', 'consum', 0.0214, 'lps'),
	(629188, 133, '2015-01-01 00:33:55.000000', 'consum', 0.0233, 'lps'),
	(629189, 133, '2015-01-01 00:33:56.000000', 'consum', 0.0215, 'lps'),
	(629190, 133, '2015-01-01 00:33:57.000000', 'consum', 0.0234, 'lps'),
	(629191, 133, '2015-01-01 00:33:58.000000', 'consum', 0.0219, 'lps'),
	(629192, 133, '2015-01-01 00:33:59.000000', 'consum', 0.0215, 'lps'),
	(629193, 133, '2015-01-01 00:34:00.000000', 'consum', 0.0238, 'lps'),
	(629194, 133, '2015-01-01 00:34:01.000000', 'consum', 0.0211, 'lps'),
	(629195, 133, '2015-01-01 00:34:02.000000', 'consum', 0.0225, 'lps'),
	(629196, 133, '2015-01-01 00:34:03.000000', 'consum', 0.0220, 'lps'),
	(629197, 133, '2015-01-01 00:34:04.000000', 'consum', 0.0215, 'lps'),
	(629198, 133, '2015-01-01 00:34:05.000000', 'consum', 0.0238, 'lps'),
	(629199, 133, '2015-01-01 00:34:06.000000', 'consum', 0.0239, 'lps'),
	(629200, 133, '2015-01-01 00:34:07.000000', 'consum', 0.0240, 'lps'),
	(629201, 133, '2015-01-01 00:34:08.000000', 'consum', 0.0211, 'lps'),
	(629202, 133, '2015-01-01 00:34:09.000000', 'consum', 0.0220, 'lps'),
	(629203, 133, '2015-01-01 00:34:10.000000', 'consum', 0.0224, 'lps'),
	(629204, 133, '2015-01-01 00:34:11.000000', 'consum', 0.0219, 'lps'),
	(629205, 133, '2015-01-01 00:34:12.000000', 'consum', 0.0214, 'lps'),
	(629206, 133, '2015-01-01 00:34:13.000000', 'consum', 0.0234, 'lps'),
	(629207, 133, '2015-01-01 00:34:14.000000', 'consum', 0.0224, 'lps'),
	(629208, 133, '2015-01-01 00:34:15.000000', 'consum', 0.0240, 'lps'),
	(629209, 133, '2015-01-01 00:34:16.000000', 'consum', 0.0222, 'lps'),
	(629210, 133, '2015-01-01 00:34:17.000000', 'consum', 0.0214, 'lps'),
	(629211, 133, '2015-01-01 00:34:18.000000', 'consum', 0.0224, 'lps'),
	(629212, 133, '2015-01-01 00:34:19.000000', 'consum', 0.0236, 'lps'),
	(629213, 133, '2015-01-01 00:34:20.000000', 'consum', 0.0237, 'lps'),
	(629214, 133, '2015-01-01 00:34:21.000000', 'consum', 0.0235, 'lps'),
	(629215, 133, '2015-01-01 00:34:22.000000', 'consum', 0.0221, 'lps'),
	(629216, 133, '2015-01-01 00:34:23.000000', 'consum', 0.0222, 'lps'),
	(629217, 133, '2015-01-01 00:34:24.000000', 'consum', 0.0239, 'lps'),
	(629218, 133, '2015-01-01 00:34:25.000000', 'consum', 0.0224, 'lps'),
	(629219, 133, '2015-01-01 00:34:26.000000', 'consum', 0.0227, 'lps'),
	(629220, 133, '2015-01-01 00:34:27.000000', 'consum', 0.0219, 'lps'),
	(629221, 133, '2015-01-01 00:34:28.000000', 'consum', 0.0239, 'lps'),
	(629222, 133, '2015-01-01 00:34:29.000000', 'consum', 0.0232, 'lps'),
	(629223, 133, '2015-01-01 00:34:30.000000', 'consum', 0.0232, 'lps'),
	(629224, 133, '2015-01-01 00:34:31.000000', 'consum', 0.0223, 'lps'),
	(629225, 133, '2015-01-01 00:34:32.000000', 'consum', 0.0241, 'lps'),
	(629226, 133, '2015-01-01 00:34:33.000000', 'consum', 0.0232, 'lps'),
	(629227, 133, '2015-01-01 00:34:34.000000', 'consum', 0.0227, 'lps'),
	(629228, 133, '2015-01-01 00:34:35.000000', 'consum', 0.0231, 'lps'),
	(629229, 133, '2015-01-01 00:34:36.000000', 'consum', 0.0231, 'lps'),
	(629230, 133, '2015-01-01 00:34:37.000000', 'consum', 0.0222, 'lps'),
	(629231, 133, '2015-01-01 00:34:38.000000', 'consum', 0.0239, 'lps'),
	(629232, 133, '2015-01-01 00:34:39.000000', 'consum', 0.0222, 'lps'),
	(629233, 133, '2015-01-01 00:34:40.000000', 'consum', 0.0215, 'lps'),
	(629234, 133, '2015-01-01 00:34:41.000000', 'consum', 0.0232, 'lps'),
	(629235, 133, '2015-01-01 00:34:42.000000', 'consum', 0.0210, 'lps'),
	(629236, 133, '2015-01-01 00:34:43.000000', 'consum', 0.0241, 'lps'),
	(629237, 133, '2015-01-01 00:34:44.000000', 'consum', 0.0237, 'lps'),
	(629238, 133, '2015-01-01 00:34:45.000000', 'consum', 0.0222, 'lps'),
	(629239, 133, '2015-01-01 00:34:46.000000', 'consum', 0.0222, 'lps'),
	(629240, 133, '2015-01-01 00:34:47.000000', 'consum', 0.0232, 'lps'),
	(629241, 133, '2015-01-01 00:34:48.000000', 'consum', 0.0221, 'lps'),
	(629242, 133, '2015-01-01 00:34:49.000000', 'consum', 0.0231, 'lps'),
	(629243, 133, '2015-01-01 00:34:50.000000', 'consum', 0.0221, 'lps'),
	(629244, 133, '2015-01-01 00:34:51.000000', 'consum', 0.0232, 'lps'),
	(629245, 133, '2015-01-01 00:34:52.000000', 'consum', 0.0222, 'lps'),
	(629246, 133, '2015-01-01 00:34:53.000000', 'consum', 0.0239, 'lps'),
	(629247, 133, '2015-01-01 00:34:54.000000', 'consum', 0.0224, 'lps'),
	(629248, 133, '2015-01-01 00:34:55.000000', 'consum', 0.0225, 'lps'),
	(629249, 133, '2015-01-01 00:34:56.000000', 'consum', 0.0211, 'lps'),
	(629250, 133, '2015-01-01 00:34:57.000000', 'consum', 0.0233, 'lps'),
	(629251, 133, '2015-01-01 00:34:58.000000', 'consum', 0.0227, 'lps'),
	(629252, 133, '2015-01-01 00:34:59.000000', 'consum', 0.0229, 'lps'),
	(629253, 133, '2015-01-01 00:35:00.000000', 'consum', 0.0221, 'lps'),
	(629254, 133, '2015-01-01 00:35:01.000000', 'consum', 0.0210, 'lps'),
	(629255, 133, '2015-01-01 00:35:02.000000', 'consum', 0.0239, 'lps'),
	(629256, 133, '2015-01-01 00:35:03.000000', 'consum', 0.0227, 'lps'),
	(629257, 133, '2015-01-01 00:35:04.000000', 'consum', 0.0210, 'lps'),
	(629258, 133, '2015-01-01 00:35:05.000000', 'consum', 0.0222, 'lps'),
	(629259, 133, '2015-01-01 00:35:06.000000', 'consum', 0.0240, 'lps'),
	(629260, 133, '2015-01-01 00:35:07.000000', 'consum', 0.0229, 'lps'),
	(629261, 133, '2015-01-01 00:35:08.000000', 'consum', 0.0214, 'lps'),
	(629262, 133, '2015-01-01 00:35:09.000000', 'consum', 0.0238, 'lps'),
	(629263, 133, '2015-01-01 00:35:10.000000', 'consum', 0.0213, 'lps'),
	(629264, 133, '2015-01-01 00:35:11.000000', 'consum', 0.0234, 'lps'),
	(629265, 133, '2015-01-01 00:35:12.000000', 'consum', 0.0229, 'lps'),
	(629266, 133, '2015-01-01 00:35:13.000000', 'consum', 0.0230, 'lps'),
	(629267, 133, '2015-01-01 00:35:14.000000', 'consum', 0.0223, 'lps'),
	(629268, 133, '2015-01-01 00:35:15.000000', 'consum', 0.0217, 'lps'),
	(629269, 133, '2015-01-01 00:35:16.000000', 'consum', 0.0236, 'lps'),
	(629270, 133, '2015-01-01 00:35:17.000000', 'consum', 0.0223, 'lps'),
	(629271, 133, '2015-01-01 00:35:18.000000', 'consum', 0.0231, 'lps'),
	(629272, 133, '2015-01-01 00:35:19.000000', 'consum', 0.0212, 'lps'),
	(629273, 133, '2015-01-01 00:35:20.000000', 'consum', 0.0223, 'lps'),
	(629274, 133, '2015-01-01 00:35:21.000000', 'consum', 0.0238, 'lps'),
	(629275, 133, '2015-01-01 00:35:22.000000', 'consum', 0.0213, 'lps'),
	(629276, 133, '2015-01-01 00:35:23.000000', 'consum', 0.0240, 'lps'),
	(629277, 133, '2015-01-01 00:35:24.000000', 'consum', 0.0221, 'lps'),
	(629278, 133, '2015-01-01 00:35:25.000000', 'consum', 0.0239, 'lps'),
	(629279, 133, '2015-01-01 00:35:26.000000', 'consum', 0.0227, 'lps'),
	(629280, 133, '2015-01-01 00:35:27.000000', 'consum', 0.0210, 'lps'),
	(629281, 133, '2015-01-01 00:35:28.000000', 'consum', 0.0221, 'lps'),
	(629282, 133, '2015-01-01 00:35:29.000000', 'consum', 0.0235, 'lps'),
	(629283, 133, '2015-01-01 00:35:30.000000', 'consum', 0.0237, 'lps'),
	(629284, 133, '2015-01-01 00:35:31.000000', 'consum', 0.0240, 'lps'),
	(629285, 133, '2015-01-01 00:35:32.000000', 'consum', 0.0215, 'lps'),
	(629286, 133, '2015-01-01 00:35:33.000000', 'consum', 0.0240, 'lps'),
	(629287, 133, '2015-01-01 00:35:34.000000', 'consum', 0.0216, 'lps'),
	(629288, 133, '2015-01-01 00:35:35.000000', 'consum', 0.0218, 'lps'),
	(629289, 133, '2015-01-01 00:35:36.000000', 'consum', 0.0233, 'lps'),
	(629290, 133, '2015-01-01 00:35:37.000000', 'consum', 0.0236, 'lps'),
	(629291, 133, '2015-01-01 00:35:38.000000', 'consum', 0.0239, 'lps'),
	(629292, 133, '2015-01-01 00:35:39.000000', 'consum', 0.0215, 'lps'),
	(629293, 133, '2015-01-01 00:35:40.000000', 'consum', 0.0214, 'lps'),
	(629294, 133, '2015-01-01 00:35:41.000000', 'consum', 0.0212, 'lps'),
	(629295, 133, '2015-01-01 00:35:42.000000', 'consum', 0.0241, 'lps'),
	(629296, 133, '2015-01-01 00:35:43.000000', 'consum', 0.0233, 'lps'),
	(629297, 133, '2015-01-01 00:35:44.000000', 'consum', 0.0232, 'lps'),
	(629298, 133, '2015-01-01 00:35:45.000000', 'consum', 0.0220, 'lps'),
	(629299, 133, '2015-01-01 00:35:46.000000', 'consum', 0.0227, 'lps'),
	(629300, 133, '2015-01-01 00:35:47.000000', 'consum', 0.0234, 'lps'),
	(629301, 133, '2015-01-01 00:35:48.000000', 'consum', 0.0213, 'lps'),
	(629302, 133, '2015-01-01 00:35:49.000000', 'consum', 0.0217, 'lps'),
	(629303, 133, '2015-01-01 00:35:50.000000', 'consum', 0.0239, 'lps'),
	(629304, 133, '2015-01-01 00:35:51.000000', 'consum', 0.0236, 'lps'),
	(629305, 133, '2015-01-01 00:35:52.000000', 'consum', 0.0222, 'lps'),
	(629306, 133, '2015-01-01 00:35:53.000000', 'consum', 0.0227, 'lps'),
	(629307, 133, '2015-01-01 00:35:54.000000', 'consum', 0.0224, 'lps'),
	(629308, 133, '2015-01-01 00:35:55.000000', 'consum', 0.0232, 'lps'),
	(629309, 133, '2015-01-01 00:35:56.000000', 'consum', 0.0212, 'lps'),
	(629310, 133, '2015-01-01 00:35:57.000000', 'consum', 0.0219, 'lps'),
	(629311, 133, '2015-01-01 00:35:58.000000', 'consum', 0.0219, 'lps'),
	(629312, 133, '2015-01-01 00:35:59.000000', 'consum', 0.0228, 'lps'),
	(629313, 133, '2015-01-01 00:36:00.000000', 'consum', 0.0241, 'lps'),
	(629314, 133, '2015-01-01 00:36:01.000000', 'consum', 0.0214, 'lps'),
	(629315, 133, '2015-01-01 00:36:02.000000', 'consum', 0.0233, 'lps'),
	(629316, 133, '2015-01-01 00:36:03.000000', 'consum', 0.0221, 'lps'),
	(629317, 133, '2015-01-01 00:36:04.000000', 'consum', 0.0225, 'lps'),
	(629318, 133, '2015-01-01 00:36:05.000000', 'consum', 0.0222, 'lps'),
	(629319, 133, '2015-01-01 00:36:06.000000', 'consum', 0.0225, 'lps'),
	(629320, 133, '2015-01-01 00:36:07.000000', 'consum', 0.0220, 'lps'),
	(629321, 133, '2015-01-01 00:36:08.000000', 'consum', 0.0212, 'lps'),
	(629322, 133, '2015-01-01 00:36:09.000000', 'consum', 0.0224, 'lps'),
	(629323, 133, '2015-01-01 00:36:10.000000', 'consum', 0.0211, 'lps'),
	(629324, 133, '2015-01-01 00:36:11.000000', 'consum', 0.0237, 'lps'),
	(629325, 133, '2015-01-01 00:36:12.000000', 'consum', 0.0213, 'lps'),
	(629326, 133, '2015-01-01 00:36:13.000000', 'consum', 0.0240, 'lps'),
	(629327, 133, '2015-01-01 00:36:14.000000', 'consum', 0.0223, 'lps'),
	(629328, 133, '2015-01-01 00:36:15.000000', 'consum', 0.0217, 'lps'),
	(629329, 133, '2015-01-01 00:36:16.000000', 'consum', 0.0239, 'lps'),
	(629330, 133, '2015-01-01 00:36:17.000000', 'consum', 0.0241, 'lps'),
	(629331, 133, '2015-01-01 00:36:18.000000', 'consum', 0.0213, 'lps'),
	(629332, 133, '2015-01-01 00:36:19.000000', 'consum', 0.0229, 'lps'),
	(629333, 133, '2015-01-01 00:36:20.000000', 'consum', 0.0234, 'lps'),
	(629334, 133, '2015-01-01 00:36:21.000000', 'consum', 0.0240, 'lps'),
	(629335, 133, '2015-01-01 00:36:22.000000', 'consum', 0.0226, 'lps'),
	(629336, 133, '2015-01-01 00:36:23.000000', 'consum', 0.0232, 'lps'),
	(629337, 133, '2015-01-01 00:36:24.000000', 'consum', 0.0241, 'lps'),
	(629338, 133, '2015-01-01 00:36:25.000000', 'consum', 0.0236, 'lps'),
	(629339, 133, '2015-01-01 00:36:26.000000', 'consum', 0.0215, 'lps'),
	(629340, 133, '2015-01-01 00:36:27.000000', 'consum', 0.0220, 'lps'),
	(629341, 133, '2015-01-01 00:36:28.000000', 'consum', 0.0214, 'lps'),
	(629342, 133, '2015-01-01 00:36:29.000000', 'consum', 0.0233, 'lps'),
	(629343, 133, '2015-01-01 00:36:30.000000', 'consum', 0.0218, 'lps'),
	(629344, 133, '2015-01-01 00:36:31.000000', 'consum', 0.0211, 'lps'),
	(629345, 133, '2015-01-01 00:36:32.000000', 'consum', 0.0227, 'lps'),
	(629346, 133, '2015-01-01 00:36:33.000000', 'consum', 0.0225, 'lps'),
	(629347, 133, '2015-01-01 00:36:34.000000', 'consum', 0.0237, 'lps'),
	(629348, 133, '2015-01-01 00:36:35.000000', 'consum', 0.0237, 'lps'),
	(629349, 133, '2015-01-01 00:36:36.000000', 'consum', 0.0231, 'lps'),
	(629350, 133, '2015-01-01 00:36:37.000000', 'consum', 0.0234, 'lps'),
	(629351, 133, '2015-01-01 00:36:38.000000', 'consum', 0.0237, 'lps'),
	(629352, 133, '2015-01-01 00:36:39.000000', 'consum', 0.0240, 'lps'),
	(629353, 133, '2015-01-01 00:36:40.000000', 'consum', 0.0215, 'lps'),
	(629354, 133, '2015-01-01 00:36:41.000000', 'consum', 0.0211, 'lps'),
	(629355, 133, '2015-01-01 00:36:42.000000', 'consum', 0.0233, 'lps'),
	(629356, 133, '2015-01-01 00:36:43.000000', 'consum', 0.0227, 'lps'),
	(629357, 133, '2015-01-01 00:36:44.000000', 'consum', 0.0224, 'lps'),
	(629358, 133, '2015-01-01 00:36:45.000000', 'consum', 0.0230, 'lps'),
	(629359, 133, '2015-01-01 00:36:46.000000', 'consum', 0.0239, 'lps'),
	(629360, 133, '2015-01-01 00:36:47.000000', 'consum', 0.0230, 'lps'),
	(629361, 133, '2015-01-01 00:36:48.000000', 'consum', 0.0223, 'lps'),
	(629362, 133, '2015-01-01 00:36:49.000000', 'consum', 0.0217, 'lps'),
	(629363, 133, '2015-01-01 00:36:50.000000', 'consum', 0.0238, 'lps'),
	(629364, 133, '2015-01-01 00:36:51.000000', 'consum', 0.0231, 'lps'),
	(629365, 133, '2015-01-01 00:36:52.000000', 'consum', 0.0234, 'lps'),
	(629366, 133, '2015-01-01 00:36:53.000000', 'consum', 0.0235, 'lps'),
	(629367, 133, '2015-01-01 00:36:54.000000', 'consum', 0.0232, 'lps'),
	(629368, 133, '2015-01-01 00:36:55.000000', 'consum', 0.0215, 'lps'),
	(629369, 133, '2015-01-01 00:36:56.000000', 'consum', 0.0231, 'lps'),
	(629370, 133, '2015-01-01 00:36:57.000000', 'consum', 0.0236, 'lps'),
	(629371, 133, '2015-01-01 00:36:58.000000', 'consum', 0.0216, 'lps'),
	(629372, 133, '2015-01-01 00:36:59.000000', 'consum', 0.0227, 'lps'),
	(629373, 133, '2015-01-01 00:37:00.000000', 'consum', 0.0212, 'lps'),
	(629374, 133, '2015-01-01 00:37:01.000000', 'consum', 0.0234, 'lps'),
	(629375, 133, '2015-01-01 00:37:02.000000', 'consum', 0.0227, 'lps'),
	(629376, 133, '2015-01-01 00:37:03.000000', 'consum', 0.0225, 'lps'),
	(629377, 133, '2015-01-01 00:37:04.000000', 'consum', 0.0235, 'lps'),
	(629378, 133, '2015-01-01 00:37:05.000000', 'consum', 0.0226, 'lps'),
	(629379, 133, '2015-01-01 00:37:06.000000', 'consum', 0.0215, 'lps'),
	(629380, 133, '2015-01-01 00:37:07.000000', 'consum', 0.0219, 'lps'),
	(629381, 133, '2015-01-01 00:37:08.000000', 'consum', 0.0240, 'lps'),
	(629382, 133, '2015-01-01 00:37:09.000000', 'consum', 0.0240, 'lps'),
	(629383, 133, '2015-01-01 00:37:10.000000', 'consum', 0.0238, 'lps'),
	(629384, 133, '2015-01-01 00:37:11.000000', 'consum', 0.0226, 'lps'),
	(629385, 133, '2015-01-01 00:37:12.000000', 'consum', 0.0240, 'lps'),
	(629386, 133, '2015-01-01 00:37:13.000000', 'consum', 0.0216, 'lps'),
	(629387, 133, '2015-01-01 00:37:14.000000', 'consum', 0.0217, 'lps'),
	(629388, 133, '2015-01-01 00:37:15.000000', 'consum', 0.0225, 'lps'),
	(629389, 133, '2015-01-01 00:37:16.000000', 'consum', 0.0234, 'lps'),
	(629390, 133, '2015-01-01 00:37:17.000000', 'consum', 0.0222, 'lps'),
	(629391, 133, '2015-01-01 00:37:18.000000', 'consum', 0.0229, 'lps'),
	(629392, 133, '2015-01-01 00:37:19.000000', 'consum', 0.0236, 'lps'),
	(629393, 133, '2015-01-01 00:37:20.000000', 'consum', 0.0222, 'lps'),
	(629394, 133, '2015-01-01 00:37:21.000000', 'consum', 0.0224, 'lps'),
	(629395, 133, '2015-01-01 00:37:22.000000', 'consum', 0.0214, 'lps'),
	(629396, 133, '2015-01-01 00:37:23.000000', 'consum', 0.0218, 'lps'),
	(629397, 133, '2015-01-01 00:37:24.000000', 'consum', 0.0237, 'lps'),
	(629398, 133, '2015-01-01 00:37:25.000000', 'consum', 0.0229, 'lps'),
	(629399, 133, '2015-01-01 00:37:26.000000', 'consum', 0.0223, 'lps'),
	(629400, 133, '2015-01-01 00:37:27.000000', 'consum', 0.0220, 'lps'),
	(629401, 133, '2015-01-01 00:37:28.000000', 'consum', 0.0221, 'lps'),
	(629402, 133, '2015-01-01 00:37:29.000000', 'consum', 0.0236, 'lps'),
	(629403, 133, '2015-01-01 00:37:30.000000', 'consum', 0.0241, 'lps'),
	(629404, 133, '2015-01-01 00:37:31.000000', 'consum', 0.0224, 'lps'),
	(629405, 133, '2015-01-01 00:37:32.000000', 'consum', 0.0222, 'lps'),
	(629406, 133, '2015-01-01 00:37:33.000000', 'consum', 0.0226, 'lps'),
	(629407, 133, '2015-01-01 00:37:34.000000', 'consum', 0.0222, 'lps'),
	(629408, 133, '2015-01-01 00:37:35.000000', 'consum', 0.0225, 'lps'),
	(629409, 133, '2015-01-01 00:37:36.000000', 'consum', 0.0218, 'lps'),
	(629410, 133, '2015-01-01 00:37:37.000000', 'consum', 0.0237, 'lps'),
	(629411, 133, '2015-01-01 00:37:38.000000', 'consum', 0.0225, 'lps'),
	(629412, 133, '2015-01-01 00:37:39.000000', 'consum', 0.0236, 'lps'),
	(629413, 133, '2015-01-01 00:37:40.000000', 'consum', 0.0234, 'lps'),
	(629414, 133, '2015-01-01 00:37:41.000000', 'consum', 0.0219, 'lps'),
	(629415, 133, '2015-01-01 00:37:42.000000', 'consum', 0.0216, 'lps'),
	(629416, 133, '2015-01-01 00:37:43.000000', 'consum', 0.0212, 'lps'),
	(629417, 133, '2015-01-01 00:37:44.000000', 'consum', 0.0234, 'lps'),
	(629418, 133, '2015-01-01 00:37:45.000000', 'consum', 0.0231, 'lps'),
	(629419, 133, '2015-01-01 00:37:46.000000', 'consum', 0.0241, 'lps'),
	(629420, 133, '2015-01-01 00:37:47.000000', 'consum', 0.0240, 'lps'),
	(629421, 133, '2015-01-01 00:37:48.000000', 'consum', 0.0237, 'lps'),
	(629422, 133, '2015-01-01 00:37:49.000000', 'consum', 0.0223, 'lps'),
	(629423, 133, '2015-01-01 00:37:50.000000', 'consum', 0.0225, 'lps'),
	(629424, 133, '2015-01-01 00:37:51.000000', 'consum', 0.0215, 'lps'),
	(629425, 133, '2015-01-01 00:37:52.000000', 'consum', 0.0221, 'lps'),
	(629426, 133, '2015-01-01 00:37:53.000000', 'consum', 0.0219, 'lps'),
	(629427, 133, '2015-01-01 00:37:54.000000', 'consum', 0.0225, 'lps'),
	(629428, 133, '2015-01-01 00:37:55.000000', 'consum', 0.0225, 'lps'),
	(629429, 133, '2015-01-01 00:37:56.000000', 'consum', 0.0239, 'lps'),
	(629430, 133, '2015-01-01 00:37:57.000000', 'consum', 0.0215, 'lps'),
	(629431, 133, '2015-01-01 00:37:58.000000', 'consum', 0.0211, 'lps'),
	(629432, 133, '2015-01-01 00:37:59.000000', 'consum', 0.0233, 'lps'),
	(629433, 133, '2015-01-01 00:38:00.000000', 'consum', 0.0229, 'lps'),
	(629434, 133, '2015-01-01 00:38:01.000000', 'consum', 0.0236, 'lps'),
	(629435, 133, '2015-01-01 00:38:02.000000', 'consum', 0.0219, 'lps'),
	(629436, 133, '2015-01-01 00:38:03.000000', 'consum', 0.0240, 'lps'),
	(629437, 133, '2015-01-01 00:38:04.000000', 'consum', 0.0237, 'lps'),
	(629438, 133, '2015-01-01 00:38:05.000000', 'consum', 0.0225, 'lps'),
	(629439, 133, '2015-01-01 00:38:06.000000', 'consum', 0.0236, 'lps'),
	(629440, 133, '2015-01-01 00:38:07.000000', 'consum', 0.0231, 'lps'),
	(629441, 133, '2015-01-01 00:38:08.000000', 'consum', 0.0238, 'lps'),
	(629442, 133, '2015-01-01 00:38:09.000000', 'consum', 0.0223, 'lps'),
	(629443, 133, '2015-01-01 00:38:10.000000', 'consum', 0.0226, 'lps'),
	(629444, 133, '2015-01-01 00:38:11.000000', 'consum', 0.0216, 'lps'),
	(629445, 133, '2015-01-01 00:38:12.000000', 'consum', 0.0227, 'lps'),
	(629446, 133, '2015-01-01 00:38:13.000000', 'consum', 0.0214, 'lps'),
	(629447, 133, '2015-01-01 00:38:14.000000', 'consum', 0.0210, 'lps'),
	(629448, 133, '2015-01-01 00:38:15.000000', 'consum', 0.0233, 'lps'),
	(629449, 133, '2015-01-01 00:38:16.000000', 'consum', 0.0227, 'lps'),
	(629450, 133, '2015-01-01 00:38:17.000000', 'consum', 0.0229, 'lps'),
	(629451, 133, '2015-01-01 00:38:18.000000', 'consum', 0.0223, 'lps'),
	(629452, 133, '2015-01-01 00:38:19.000000', 'consum', 0.0217, 'lps'),
	(629453, 133, '2015-01-01 00:38:20.000000', 'consum', 0.0238, 'lps'),
	(629454, 133, '2015-01-01 00:38:21.000000', 'consum', 0.0236, 'lps'),
	(629455, 133, '2015-01-01 00:38:22.000000', 'consum', 0.0223, 'lps'),
	(629456, 133, '2015-01-01 00:38:23.000000', 'consum', 0.0228, 'lps'),
	(629457, 133, '2015-01-01 00:38:24.000000', 'consum', 0.0230, 'lps'),
	(629458, 133, '2015-01-01 00:38:25.000000', 'consum', 0.0225, 'lps'),
	(629459, 133, '2015-01-01 00:38:26.000000', 'consum', 0.0224, 'lps'),
	(629460, 133, '2015-01-01 00:38:27.000000', 'consum', 0.0236, 'lps'),
	(629461, 133, '2015-01-01 00:38:28.000000', 'consum', 0.0236, 'lps'),
	(629462, 133, '2015-01-01 00:38:29.000000', 'consum', 0.0229, 'lps'),
	(629463, 133, '2015-01-01 00:38:30.000000', 'consum', 0.0227, 'lps'),
	(629464, 133, '2015-01-01 00:38:31.000000', 'consum', 0.0240, 'lps'),
	(629465, 133, '2015-01-01 00:38:32.000000', 'consum', 0.0214, 'lps'),
	(629466, 133, '2015-01-01 00:38:33.000000', 'consum', 0.0234, 'lps'),
	(629467, 133, '2015-01-01 00:38:34.000000', 'consum', 0.0225, 'lps'),
	(629468, 133, '2015-01-01 00:38:35.000000', 'consum', 0.0213, 'lps'),
	(629469, 133, '2015-01-01 00:38:36.000000', 'consum', 0.0212, 'lps'),
	(629470, 133, '2015-01-01 00:38:37.000000', 'consum', 0.0213, 'lps'),
	(629471, 133, '2015-01-01 00:38:38.000000', 'consum', 0.0219, 'lps'),
	(629472, 133, '2015-01-01 00:38:39.000000', 'consum', 0.0214, 'lps'),
	(629473, 133, '2015-01-01 00:38:40.000000', 'consum', 0.0235, 'lps'),
	(629474, 133, '2015-01-01 00:38:41.000000', 'consum', 0.0226, 'lps'),
	(629475, 133, '2015-01-01 00:38:42.000000', 'consum', 0.0217, 'lps'),
	(629476, 133, '2015-01-01 00:38:43.000000', 'consum', 0.0229, 'lps'),
	(629477, 133, '2015-01-01 00:38:44.000000', 'consum', 0.0219, 'lps'),
	(629478, 133, '2015-01-01 00:38:45.000000', 'consum', 0.0232, 'lps'),
	(629479, 133, '2015-01-01 00:38:46.000000', 'consum', 0.0227, 'lps'),
	(629480, 133, '2015-01-01 00:38:47.000000', 'consum', 0.0233, 'lps'),
	(629481, 133, '2015-01-01 00:38:48.000000', 'consum', 0.0241, 'lps'),
	(629482, 133, '2015-01-01 00:38:49.000000', 'consum', 0.0231, 'lps'),
	(629483, 133, '2015-01-01 00:38:50.000000', 'consum', 0.0224, 'lps'),
	(629484, 133, '2015-01-01 00:38:51.000000', 'consum', 0.0216, 'lps'),
	(629485, 133, '2015-01-01 00:38:52.000000', 'consum', 0.0230, 'lps'),
	(629486, 133, '2015-01-01 00:38:53.000000', 'consum', 0.0228, 'lps'),
	(629487, 133, '2015-01-01 00:38:54.000000', 'consum', 0.0211, 'lps'),
	(629488, 133, '2015-01-01 00:38:55.000000', 'consum', 0.0223, 'lps'),
	(629489, 133, '2015-01-01 00:38:56.000000', 'consum', 0.0211, 'lps'),
	(629490, 133, '2015-01-01 00:38:57.000000', 'consum', 0.0239, 'lps'),
	(629491, 133, '2015-01-01 00:38:58.000000', 'consum', 0.0223, 'lps'),
	(629492, 133, '2015-01-01 00:38:59.000000', 'consum', 0.0223, 'lps'),
	(629493, 133, '2015-01-01 00:39:00.000000', 'consum', 0.0237, 'lps'),
	(629494, 133, '2015-01-01 00:39:01.000000', 'consum', 0.0240, 'lps'),
	(629495, 133, '2015-01-01 00:39:02.000000', 'consum', 0.0218, 'lps'),
	(629496, 133, '2015-01-01 00:39:03.000000', 'consum', 0.0222, 'lps'),
	(629497, 133, '2015-01-01 00:39:04.000000', 'consum', 0.0214, 'lps'),
	(629498, 133, '2015-01-01 00:39:05.000000', 'consum', 0.0226, 'lps'),
	(629499, 133, '2015-01-01 00:39:06.000000', 'consum', 0.0217, 'lps'),
	(629500, 133, '2015-01-01 00:39:07.000000', 'consum', 0.0228, 'lps'),
	(629501, 133, '2015-01-01 00:39:08.000000', 'consum', 0.0214, 'lps'),
	(629502, 133, '2015-01-01 00:39:09.000000', 'consum', 0.0211, 'lps'),
	(629503, 133, '2015-01-01 00:39:10.000000', 'consum', 0.0233, 'lps'),
	(629504, 133, '2015-01-01 00:39:11.000000', 'consum', 0.0226, 'lps'),
	(629505, 133, '2015-01-01 00:39:12.000000', 'consum', 0.0223, 'lps'),
	(629506, 133, '2015-01-01 00:39:13.000000', 'consum', 0.0225, 'lps'),
	(629507, 133, '2015-01-01 00:39:14.000000', 'consum', 0.0217, 'lps'),
	(629508, 133, '2015-01-01 00:39:15.000000', 'consum', 0.0233, 'lps'),
	(629509, 133, '2015-01-01 00:39:16.000000', 'consum', 0.0239, 'lps'),
	(629510, 133, '2015-01-01 00:39:17.000000', 'consum', 0.0224, 'lps'),
	(629511, 133, '2015-01-01 00:39:18.000000', 'consum', 0.0223, 'lps'),
	(629512, 133, '2015-01-01 00:39:19.000000', 'consum', 0.0233, 'lps'),
	(629513, 133, '2015-01-01 00:39:20.000000', 'consum', 0.0225, 'lps'),
	(629514, 133, '2015-01-01 00:39:21.000000', 'consum', 0.0217, 'lps'),
	(629515, 133, '2015-01-01 00:39:22.000000', 'consum', 0.0233, 'lps'),
	(629516, 133, '2015-01-01 00:39:23.000000', 'consum', 0.0241, 'lps'),
	(629517, 133, '2015-01-01 00:39:24.000000', 'consum', 0.0233, 'lps'),
	(629518, 133, '2015-01-01 00:39:25.000000', 'consum', 0.0232, 'lps'),
	(629519, 133, '2015-01-01 00:39:26.000000', 'consum', 0.0217, 'lps'),
	(629520, 133, '2015-01-01 00:39:27.000000', 'consum', 0.0214, 'lps'),
	(629521, 133, '2015-01-01 00:39:28.000000', 'consum', 0.0240, 'lps'),
	(629522, 133, '2015-01-01 00:39:29.000000', 'consum', 0.0221, 'lps'),
	(629523, 133, '2015-01-01 00:39:30.000000', 'consum', 0.0239, 'lps'),
	(629524, 133, '2015-01-01 00:39:31.000000', 'consum', 0.0228, 'lps'),
	(629525, 133, '2015-01-01 00:39:32.000000', 'consum', 0.0211, 'lps'),
	(629526, 133, '2015-01-01 00:39:33.000000', 'consum', 0.0225, 'lps'),
	(629527, 133, '2015-01-01 00:39:34.000000', 'consum', 0.0219, 'lps'),
	(629528, 133, '2015-01-01 00:39:35.000000', 'consum', 0.0213, 'lps'),
	(629529, 133, '2015-01-01 00:39:36.000000', 'consum', 0.0229, 'lps'),
	(629530, 133, '2015-01-01 00:39:37.000000', 'consum', 0.0231, 'lps'),
	(629531, 133, '2015-01-01 00:39:38.000000', 'consum', 0.0229, 'lps'),
	(629532, 133, '2015-01-01 00:39:39.000000', 'consum', 0.0241, 'lps'),
	(629533, 133, '2015-01-01 00:39:40.000000', 'consum', 0.0214, 'lps'),
	(629534, 133, '2015-01-01 00:39:41.000000', 'consum', 0.0234, 'lps'),
	(629535, 133, '2015-01-01 00:39:42.000000', 'consum', 0.0223, 'lps'),
	(629536, 133, '2015-01-01 00:39:43.000000', 'consum', 0.0235, 'lps'),
	(629537, 133, '2015-01-01 00:39:44.000000', 'consum', 0.0234, 'lps'),
	(629538, 133, '2015-01-01 00:39:45.000000', 'consum', 0.0222, 'lps'),
	(629539, 133, '2015-01-01 00:39:46.000000', 'consum', 0.0229, 'lps'),
	(629540, 133, '2015-01-01 00:39:47.000000', 'consum', 0.0239, 'lps'),
	(629541, 133, '2015-01-01 00:39:48.000000', 'consum', 0.0236, 'lps'),
	(629542, 133, '2015-01-01 00:39:49.000000', 'consum', 0.0221, 'lps'),
	(629543, 133, '2015-01-01 00:39:50.000000', 'consum', 0.0218, 'lps'),
	(629544, 133, '2015-01-01 00:39:51.000000', 'consum', 0.0217, 'lps'),
	(629545, 133, '2015-01-01 00:39:52.000000', 'consum', 0.0222, 'lps'),
	(629546, 133, '2015-01-01 00:39:53.000000', 'consum', 0.0217, 'lps'),
	(629547, 133, '2015-01-01 00:39:54.000000', 'consum', 0.0210, 'lps'),
	(629548, 133, '2015-01-01 00:39:55.000000', 'consum', 0.0220, 'lps'),
	(629549, 133, '2015-01-01 00:39:56.000000', 'consum', 0.0230, 'lps'),
	(629550, 133, '2015-01-01 00:39:57.000000', 'consum', 0.0216, 'lps'),
	(629551, 133, '2015-01-01 00:39:58.000000', 'consum', 0.0214, 'lps'),
	(629552, 133, '2015-01-01 00:39:59.000000', 'consum', 0.0210, 'lps'),
	(629553, 133, '2015-01-01 00:40:00.000000', 'consum', 0.0232, 'lps'),
	(629554, 133, '2015-01-01 00:40:01.000000', 'consum', 0.0222, 'lps'),
	(629555, 133, '2015-01-01 00:40:02.000000', 'consum', 0.0239, 'lps'),
	(629556, 133, '2015-01-01 00:40:03.000000', 'consum', 0.0221, 'lps'),
	(629557, 133, '2015-01-01 00:40:04.000000', 'consum', 0.0214, 'lps'),
	(629558, 133, '2015-01-01 00:40:05.000000', 'consum', 0.0228, 'lps'),
	(629559, 133, '2015-01-01 00:40:06.000000', 'consum', 0.0223, 'lps'),
	(629560, 133, '2015-01-01 00:40:07.000000', 'consum', 0.0222, 'lps'),
	(629561, 133, '2015-01-01 00:40:08.000000', 'consum', 0.0231, 'lps'),
	(629562, 133, '2015-01-01 00:40:09.000000', 'consum', 0.0214, 'lps'),
	(629563, 133, '2015-01-01 00:40:10.000000', 'consum', 0.0234, 'lps'),
	(629564, 133, '2015-01-01 00:40:11.000000', 'consum', 0.0222, 'lps'),
	(629565, 133, '2015-01-01 00:40:12.000000', 'consum', 0.0230, 'lps'),
	(629566, 133, '2015-01-01 00:40:13.000000', 'consum', 0.0211, 'lps'),
	(629567, 133, '2015-01-01 00:40:14.000000', 'consum', 0.0220, 'lps'),
	(629568, 133, '2015-01-01 00:40:15.000000', 'consum', 0.0226, 'lps'),
	(629569, 133, '2015-01-01 00:40:16.000000', 'consum', 0.0230, 'lps'),
	(629570, 133, '2015-01-01 00:40:17.000000', 'consum', 0.0228, 'lps'),
	(629571, 133, '2015-01-01 00:40:18.000000', 'consum', 0.0241, 'lps'),
	(629572, 133, '2015-01-01 00:40:19.000000', 'consum', 0.0214, 'lps'),
	(629573, 133, '2015-01-01 00:40:20.000000', 'consum', 0.0235, 'lps'),
	(629574, 133, '2015-01-01 00:40:21.000000', 'consum', 0.0228, 'lps'),
	(629575, 133, '2015-01-01 00:40:22.000000', 'consum', 0.0225, 'lps'),
	(629576, 133, '2015-01-01 00:40:23.000000', 'consum', 0.0230, 'lps'),
	(629577, 133, '2015-01-01 00:40:24.000000', 'consum', 0.0233, 'lps'),
	(629578, 133, '2015-01-01 00:40:25.000000', 'consum', 0.0233, 'lps'),
	(629579, 133, '2015-01-01 00:40:26.000000', 'consum', 0.0224, 'lps'),
	(629580, 133, '2015-01-01 00:40:27.000000', 'consum', 0.0212, 'lps'),
	(629581, 133, '2015-01-01 00:40:28.000000', 'consum', 0.0211, 'lps'),
	(629582, 133, '2015-01-01 00:40:29.000000', 'consum', 0.0240, 'lps'),
	(629583, 133, '2015-01-01 00:40:30.000000', 'consum', 0.0229, 'lps'),
	(629584, 133, '2015-01-01 00:40:31.000000', 'consum', 0.0217, 'lps'),
	(629585, 133, '2015-01-01 00:40:32.000000', 'consum', 0.0219, 'lps'),
	(629586, 133, '2015-01-01 00:40:33.000000', 'consum', 0.0236, 'lps'),
	(629587, 133, '2015-01-01 00:40:34.000000', 'consum', 0.0218, 'lps'),
	(629588, 133, '2015-01-01 00:40:35.000000', 'consum', 0.0234, 'lps'),
	(629589, 133, '2015-01-01 00:40:36.000000', 'consum', 0.0214, 'lps'),
	(629590, 133, '2015-01-01 00:40:37.000000', 'consum', 0.0220, 'lps'),
	(629591, 133, '2015-01-01 00:40:38.000000', 'consum', 0.0218, 'lps'),
	(629592, 133, '2015-01-01 00:40:39.000000', 'consum', 0.0221, 'lps'),
	(629593, 133, '2015-01-01 00:40:40.000000', 'consum', 0.0240, 'lps'),
	(629594, 133, '2015-01-01 00:40:41.000000', 'consum', 0.0234, 'lps'),
	(629595, 133, '2015-01-01 00:40:42.000000', 'consum', 0.0238, 'lps'),
	(629596, 133, '2015-01-01 00:40:43.000000', 'consum', 0.0217, 'lps'),
	(629597, 133, '2015-01-01 00:40:44.000000', 'consum', 0.0223, 'lps'),
	(629598, 133, '2015-01-01 00:40:45.000000', 'consum', 0.0222, 'lps'),
	(629599, 133, '2015-01-01 00:40:46.000000', 'consum', 0.0233, 'lps'),
	(629600, 133, '2015-01-01 00:40:47.000000', 'consum', 0.0225, 'lps'),
	(629601, 133, '2015-01-01 00:40:48.000000', 'consum', 0.0218, 'lps'),
	(629602, 133, '2015-01-01 00:40:49.000000', 'consum', 0.0238, 'lps'),
	(629603, 133, '2015-01-01 00:40:50.000000', 'consum', 0.0228, 'lps'),
	(629604, 133, '2015-01-01 00:40:51.000000', 'consum', 0.0219, 'lps'),
	(629605, 133, '2015-01-01 00:40:52.000000', 'consum', 0.0233, 'lps'),
	(629606, 133, '2015-01-01 00:40:53.000000', 'consum', 0.0233, 'lps'),
	(629607, 133, '2015-01-01 00:40:54.000000', 'consum', 0.0226, 'lps'),
	(629608, 133, '2015-01-01 00:40:55.000000', 'consum', 0.0223, 'lps'),
	(629609, 133, '2015-01-01 00:40:56.000000', 'consum', 0.0226, 'lps'),
	(629610, 133, '2015-01-01 00:40:57.000000', 'consum', 0.0220, 'lps'),
	(629611, 133, '2015-01-01 00:40:58.000000', 'consum', 0.0212, 'lps'),
	(629612, 133, '2015-01-01 00:40:59.000000', 'consum', 0.0224, 'lps'),
	(629613, 133, '2015-01-01 00:41:00.000000', 'consum', 0.0241, 'lps'),
	(629614, 133, '2015-01-01 00:41:01.000000', 'consum', 0.0227, 'lps'),
	(629615, 133, '2015-01-01 00:41:02.000000', 'consum', 0.0233, 'lps'),
	(629616, 133, '2015-01-01 00:41:03.000000', 'consum', 0.0213, 'lps'),
	(629617, 133, '2015-01-01 00:41:04.000000', 'consum', 0.0219, 'lps'),
	(629618, 133, '2015-01-01 00:41:05.000000', 'consum', 0.0216, 'lps'),
	(629619, 133, '2015-01-01 00:41:06.000000', 'consum', 0.0212, 'lps'),
	(629620, 133, '2015-01-01 00:41:07.000000', 'consum', 0.0233, 'lps'),
	(629621, 133, '2015-01-01 00:41:08.000000', 'consum', 0.0226, 'lps'),
	(629622, 133, '2015-01-01 00:41:09.000000', 'consum', 0.0221, 'lps'),
	(629623, 133, '2015-01-01 00:41:10.000000', 'consum', 0.0218, 'lps'),
	(629624, 133, '2015-01-01 00:41:11.000000', 'consum', 0.0215, 'lps'),
	(629625, 133, '2015-01-01 00:41:12.000000', 'consum', 0.0213, 'lps'),
	(629626, 133, '2015-01-01 00:41:13.000000', 'consum', 0.0211, 'lps'),
	(629627, 133, '2015-01-01 00:41:14.000000', 'consum', 0.0236, 'lps'),
	(629628, 133, '2015-01-01 00:41:15.000000', 'consum', 0.0212, 'lps'),
	(629629, 133, '2015-01-01 00:41:16.000000', 'consum', 0.0238, 'lps'),
	(629630, 133, '2015-01-01 00:41:17.000000', 'consum', 0.0215, 'lps'),
	(629631, 133, '2015-01-01 00:41:18.000000', 'consum', 0.0217, 'lps'),
	(629632, 133, '2015-01-01 00:41:19.000000', 'consum', 0.0232, 'lps'),
	(629633, 133, '2015-01-01 00:41:20.000000', 'consum', 0.0233, 'lps'),
	(629634, 133, '2015-01-01 00:41:21.000000', 'consum', 0.0228, 'lps'),
	(629635, 133, '2015-01-01 00:41:22.000000', 'consum', 0.0232, 'lps'),
	(629636, 133, '2015-01-01 00:41:23.000000', 'consum', 0.0236, 'lps'),
	(629637, 133, '2015-01-01 00:41:24.000000', 'consum', 0.0241, 'lps'),
	(629638, 133, '2015-01-01 00:41:25.000000', 'consum', 0.0222, 'lps'),
	(629639, 133, '2015-01-01 00:41:26.000000', 'consum', 0.0211, 'lps'),
	(629640, 133, '2015-01-01 00:41:27.000000', 'consum', 0.0212, 'lps'),
	(629641, 133, '2015-01-01 00:41:28.000000', 'consum', 0.0216, 'lps'),
	(629642, 133, '2015-01-01 00:41:29.000000', 'consum', 0.0234, 'lps'),
	(629643, 133, '2015-01-01 00:41:30.000000', 'consum', 0.0218, 'lps'),
	(629644, 133, '2015-01-01 00:41:31.000000', 'consum', 0.0241, 'lps'),
	(629645, 133, '2015-01-01 00:41:32.000000', 'consum', 0.0216, 'lps'),
	(629646, 133, '2015-01-01 00:41:33.000000', 'consum', 0.0212, 'lps'),
	(629647, 133, '2015-01-01 00:41:34.000000', 'consum', 0.0231, 'lps'),
	(629648, 133, '2015-01-01 00:41:35.000000', 'consum', 0.0217, 'lps'),
	(629649, 133, '2015-01-01 00:41:36.000000', 'consum', 0.0213, 'lps'),
	(629650, 133, '2015-01-01 00:41:37.000000', 'consum', 0.0235, 'lps'),
	(629651, 133, '2015-01-01 00:41:38.000000', 'consum', 0.0232, 'lps'),
	(629652, 133, '2015-01-01 00:41:39.000000', 'consum', 0.0213, 'lps'),
	(629653, 133, '2015-01-01 00:41:40.000000', 'consum', 0.0225, 'lps'),
	(629654, 133, '2015-01-01 00:41:41.000000', 'consum', 0.0210, 'lps'),
	(629655, 133, '2015-01-01 00:41:42.000000', 'consum', 0.0232, 'lps'),
	(629656, 133, '2015-01-01 00:41:43.000000', 'consum', 0.0225, 'lps'),
	(629657, 133, '2015-01-01 00:41:44.000000', 'consum', 0.0219, 'lps'),
	(629658, 133, '2015-01-01 00:41:45.000000', 'consum', 0.0212, 'lps'),
	(629659, 133, '2015-01-01 00:41:46.000000', 'consum', 0.0225, 'lps'),
	(629660, 133, '2015-01-01 00:41:47.000000', 'consum', 0.0216, 'lps'),
	(629661, 133, '2015-01-01 00:41:48.000000', 'consum', 0.0227, 'lps'),
	(629662, 133, '2015-01-01 00:41:49.000000', 'consum', 0.0215, 'lps'),
	(629663, 133, '2015-01-01 00:41:50.000000', 'consum', 0.0214, 'lps'),
	(629664, 133, '2015-01-01 00:41:51.000000', 'consum', 0.0217, 'lps'),
	(629665, 133, '2015-01-01 00:41:52.000000', 'consum', 0.0234, 'lps'),
	(629666, 133, '2015-01-01 00:41:53.000000', 'consum', 0.0213, 'lps'),
	(629667, 133, '2015-01-01 00:41:54.000000', 'consum', 0.0218, 'lps'),
	(629668, 133, '2015-01-01 00:41:55.000000', 'consum', 0.0241, 'lps'),
	(629669, 133, '2015-01-01 00:41:56.000000', 'consum', 0.0216, 'lps'),
	(629670, 133, '2015-01-01 00:41:57.000000', 'consum', 0.0240, 'lps'),
	(629671, 133, '2015-01-01 00:41:58.000000', 'consum', 0.0215, 'lps'),
	(629672, 133, '2015-01-01 00:41:59.000000', 'consum', 0.0210, 'lps'),
	(629673, 133, '2015-01-01 00:42:00.000000', 'consum', 0.0227, 'lps'),
	(629674, 133, '2015-01-01 00:42:01.000000', 'consum', 0.0232, 'lps'),
	(629675, 133, '2015-01-01 00:42:02.000000', 'consum', 0.0236, 'lps'),
	(629676, 133, '2015-01-01 00:42:03.000000', 'consum', 0.0241, 'lps'),
	(629677, 133, '2015-01-01 00:42:04.000000', 'consum', 0.0227, 'lps'),
	(629678, 133, '2015-01-01 00:42:05.000000', 'consum', 0.0232, 'lps'),
	(629679, 133, '2015-01-01 00:42:06.000000', 'consum', 0.0239, 'lps'),
	(629680, 133, '2015-01-01 00:42:07.000000', 'consum', 0.0227, 'lps'),
	(629681, 133, '2015-01-01 00:42:08.000000', 'consum', 0.0238, 'lps'),
	(629682, 133, '2015-01-01 00:42:09.000000', 'consum', 0.0236, 'lps'),
	(629683, 133, '2015-01-01 00:42:10.000000', 'consum', 0.0227, 'lps'),
	(629684, 133, '2015-01-01 00:42:11.000000', 'consum', 0.0215, 'lps'),
	(629685, 133, '2015-01-01 00:42:12.000000', 'consum', 0.0218, 'lps'),
	(629686, 133, '2015-01-01 00:42:13.000000', 'consum', 0.0233, 'lps'),
	(629687, 133, '2015-01-01 00:42:14.000000', 'consum', 0.0238, 'lps'),
	(629688, 133, '2015-01-01 00:42:15.000000', 'consum', 0.0219, 'lps'),
	(629689, 133, '2015-01-01 00:42:16.000000', 'consum', 0.0236, 'lps'),
	(629690, 133, '2015-01-01 00:42:17.000000', 'consum', 0.0216, 'lps'),
	(629691, 133, '2015-01-01 00:42:18.000000', 'consum', 0.0227, 'lps'),
	(629692, 133, '2015-01-01 00:42:19.000000', 'consum', 0.0215, 'lps'),
	(629693, 133, '2015-01-01 00:42:20.000000', 'consum', 0.0214, 'lps'),
	(629694, 133, '2015-01-01 00:42:21.000000', 'consum', 0.0215, 'lps'),
	(629695, 133, '2015-01-01 00:42:22.000000', 'consum', 0.0225, 'lps'),
	(629696, 133, '2015-01-01 00:42:23.000000', 'consum', 0.0236, 'lps'),
	(629697, 133, '2015-01-01 00:42:24.000000', 'consum', 0.0235, 'lps'),
	(629698, 133, '2015-01-01 00:42:25.000000', 'consum', 0.0224, 'lps'),
	(629699, 133, '2015-01-01 00:42:26.000000', 'consum', 0.0238, 'lps'),
	(629700, 133, '2015-01-01 00:42:27.000000', 'consum', 0.0214, 'lps'),
	(629701, 133, '2015-01-01 00:42:28.000000', 'consum', 0.0210, 'lps'),
	(629702, 133, '2015-01-01 00:42:29.000000', 'consum', 0.0230, 'lps'),
	(629703, 133, '2015-01-01 00:42:30.000000', 'consum', 0.0217, 'lps'),
	(629704, 133, '2015-01-01 00:42:31.000000', 'consum', 0.0214, 'lps'),
	(629705, 133, '2015-01-01 00:42:32.000000', 'consum', 0.0210, 'lps'),
	(629706, 133, '2015-01-01 00:42:33.000000', 'consum', 0.0231, 'lps'),
	(629707, 133, '2015-01-01 00:42:34.000000', 'consum', 0.0220, 'lps'),
	(629708, 133, '2015-01-01 00:42:35.000000', 'consum', 0.0229, 'lps'),
	(629709, 133, '2015-01-01 00:42:36.000000', 'consum', 0.0210, 'lps'),
	(629710, 133, '2015-01-01 00:42:37.000000', 'consum', 0.0220, 'lps'),
	(629711, 133, '2015-01-01 00:42:38.000000', 'consum', 0.0226, 'lps'),
	(629712, 133, '2015-01-01 00:42:39.000000', 'consum', 0.0229, 'lps'),
	(629713, 133, '2015-01-01 00:42:40.000000', 'consum', 0.0226, 'lps'),
	(629714, 133, '2015-01-01 00:42:41.000000', 'consum', 0.0233, 'lps'),
	(629715, 133, '2015-01-01 00:42:42.000000', 'consum', 0.0213, 'lps'),
	(629716, 133, '2015-01-01 00:42:43.000000', 'consum', 0.0221, 'lps'),
	(629717, 133, '2015-01-01 00:42:44.000000', 'consum', 0.0224, 'lps'),
	(629718, 133, '2015-01-01 00:42:45.000000', 'consum', 0.0218, 'lps'),
	(629719, 133, '2015-01-01 00:42:46.000000', 'consum', 0.0239, 'lps'),
	(629720, 133, '2015-01-01 00:42:47.000000', 'consum', 0.0233, 'lps'),
	(629721, 133, '2015-01-01 00:42:48.000000', 'consum', 0.0210, 'lps'),
	(629722, 133, '2015-01-01 00:42:49.000000', 'consum', 0.0237, 'lps'),
	(629723, 133, '2015-01-01 00:42:50.000000', 'consum', 0.0215, 'lps'),
	(629724, 133, '2015-01-01 00:42:51.000000', 'consum', 0.0219, 'lps'),
	(629725, 133, '2015-01-01 00:42:52.000000', 'consum', 0.0210, 'lps'),
	(629726, 133, '2015-01-01 00:42:53.000000', 'consum', 0.0217, 'lps'),
	(629727, 133, '2015-01-01 00:42:54.000000', 'consum', 0.0212, 'lps'),
	(629728, 133, '2015-01-01 00:42:55.000000', 'consum', 0.0230, 'lps'),
	(629729, 133, '2015-01-01 00:42:56.000000', 'consum', 0.0241, 'lps'),
	(629730, 133, '2015-01-01 00:42:57.000000', 'consum', 0.0211, 'lps'),
	(629731, 133, '2015-01-01 00:42:58.000000', 'consum', 0.0219, 'lps'),
	(629732, 133, '2015-01-01 00:42:59.000000', 'consum', 0.0220, 'lps'),
	(629733, 133, '2015-01-01 00:43:00.000000', 'consum', 0.0233, 'lps'),
	(629734, 133, '2015-01-01 00:43:01.000000', 'consum', 0.0231, 'lps'),
	(629735, 133, '2015-01-01 00:43:02.000000', 'consum', 0.0214, 'lps'),
	(629736, 133, '2015-01-01 00:43:03.000000', 'consum', 0.0234, 'lps'),
	(629737, 133, '2015-01-01 00:43:04.000000', 'consum', 0.0222, 'lps'),
	(629738, 133, '2015-01-01 00:43:05.000000', 'consum', 0.0228, 'lps'),
	(629739, 133, '2015-01-01 00:43:06.000000', 'consum', 0.0235, 'lps'),
	(629740, 133, '2015-01-01 00:43:07.000000', 'consum', 0.0219, 'lps'),
	(629741, 133, '2015-01-01 00:43:08.000000', 'consum', 0.0210, 'lps'),
	(629742, 133, '2015-01-01 00:43:09.000000', 'consum', 0.0215, 'lps'),
	(629743, 133, '2015-01-01 00:43:10.000000', 'consum', 0.0235, 'lps'),
	(629744, 133, '2015-01-01 00:43:11.000000', 'consum', 0.0225, 'lps'),
	(629745, 133, '2015-01-01 00:43:12.000000', 'consum', 0.0211, 'lps'),
	(629746, 133, '2015-01-01 00:43:13.000000', 'consum', 0.0235, 'lps'),
	(629747, 133, '2015-01-01 00:43:14.000000', 'consum', 0.0235, 'lps'),
	(629748, 133, '2015-01-01 00:43:15.000000', 'consum', 0.0231, 'lps'),
	(629749, 133, '2015-01-01 00:43:16.000000', 'consum', 0.0239, 'lps'),
	(629750, 133, '2015-01-01 00:43:17.000000', 'consum', 0.0227, 'lps'),
	(629751, 133, '2015-01-01 00:43:18.000000', 'consum', 0.0211, 'lps'),
	(629752, 133, '2015-01-01 00:43:19.000000', 'consum', 0.0229, 'lps'),
	(629753, 133, '2015-01-01 00:43:20.000000', 'consum', 0.0237, 'lps'),
	(629754, 133, '2015-01-01 00:43:21.000000', 'consum', 0.0224, 'lps'),
	(629755, 133, '2015-01-01 00:43:22.000000', 'consum', 0.0232, 'lps'),
	(629756, 133, '2015-01-01 00:43:23.000000', 'consum', 0.0213, 'lps'),
	(629757, 133, '2015-01-01 00:43:24.000000', 'consum', 0.0226, 'lps'),
	(629758, 133, '2015-01-01 00:43:25.000000', 'consum', 0.0218, 'lps'),
	(629759, 133, '2015-01-01 00:43:26.000000', 'consum', 0.0234, 'lps'),
	(629760, 133, '2015-01-01 00:43:27.000000', 'consum', 0.0241, 'lps'),
	(629761, 133, '2015-01-01 00:43:28.000000', 'consum', 0.0229, 'lps'),
	(629762, 133, '2015-01-01 00:43:29.000000', 'consum', 0.0215, 'lps'),
	(629763, 133, '2015-01-01 00:43:30.000000', 'consum', 0.0211, 'lps'),
	(629764, 133, '2015-01-01 00:43:31.000000', 'consum', 0.0231, 'lps'),
	(629765, 133, '2015-01-01 00:43:32.000000', 'consum', 0.0219, 'lps'),
	(629766, 133, '2015-01-01 00:43:33.000000', 'consum', 0.0222, 'lps'),
	(629767, 133, '2015-01-01 00:43:34.000000', 'consum', 0.0213, 'lps'),
	(629768, 133, '2015-01-01 00:43:35.000000', 'consum', 0.0220, 'lps'),
	(629769, 133, '2015-01-01 00:43:36.000000', 'consum', 0.0218, 'lps'),
	(629770, 133, '2015-01-01 00:43:37.000000', 'consum', 0.0222, 'lps'),
	(629771, 133, '2015-01-01 00:43:38.000000', 'consum', 0.0215, 'lps'),
	(629772, 133, '2015-01-01 00:43:39.000000', 'consum', 0.0232, 'lps'),
	(629773, 133, '2015-01-01 00:43:40.000000', 'consum', 0.0241, 'lps'),
	(629774, 133, '2015-01-01 00:43:41.000000', 'consum', 0.0236, 'lps'),
	(629775, 133, '2015-01-01 00:43:42.000000', 'consum', 0.0215, 'lps'),
	(629776, 133, '2015-01-01 00:43:43.000000', 'consum', 0.0223, 'lps'),
	(629777, 133, '2015-01-01 00:43:44.000000', 'consum', 0.0229, 'lps'),
	(629778, 133, '2015-01-01 00:43:45.000000', 'consum', 0.0235, 'lps'),
	(629779, 133, '2015-01-01 00:43:46.000000', 'consum', 0.0212, 'lps'),
	(629780, 133, '2015-01-01 00:43:47.000000', 'consum', 0.0241, 'lps'),
	(629781, 133, '2015-01-01 00:43:48.000000', 'consum', 0.0231, 'lps'),
	(629782, 133, '2015-01-01 00:43:49.000000', 'consum', 0.0223, 'lps'),
	(629783, 133, '2015-01-01 00:43:50.000000', 'consum', 0.0214, 'lps'),
	(629784, 133, '2015-01-01 00:43:51.000000', 'consum', 0.0221, 'lps'),
	(629785, 133, '2015-01-01 00:43:52.000000', 'consum', 0.0222, 'lps'),
	(629786, 133, '2015-01-01 00:43:53.000000', 'consum', 0.0236, 'lps'),
	(629787, 133, '2015-01-01 00:43:54.000000', 'consum', 0.0211, 'lps'),
	(629788, 133, '2015-01-01 00:43:55.000000', 'consum', 0.0231, 'lps'),
	(629789, 133, '2015-01-01 00:43:56.000000', 'consum', 0.0216, 'lps'),
	(629790, 133, '2015-01-01 00:43:57.000000', 'consum', 0.0212, 'lps'),
	(629791, 133, '2015-01-01 00:43:58.000000', 'consum', 0.0233, 'lps'),
	(629792, 133, '2015-01-01 00:43:59.000000', 'consum', 0.0225, 'lps'),
	(629793, 133, '2015-01-01 00:44:00.000000', 'consum', 0.0214, 'lps'),
	(629794, 133, '2015-01-01 00:44:01.000000', 'consum', 0.0218, 'lps'),
	(629795, 133, '2015-01-01 00:44:02.000000', 'consum', 0.0237, 'lps'),
	(629796, 133, '2015-01-01 00:44:03.000000', 'consum', 0.0226, 'lps'),
	(629797, 133, '2015-01-01 00:44:04.000000', 'consum', 0.0211, 'lps'),
	(629798, 133, '2015-01-01 00:44:05.000000', 'consum', 0.0233, 'lps'),
	(629799, 133, '2015-01-01 00:44:06.000000', 'consum', 0.0224, 'lps'),
	(629800, 133, '2015-01-01 00:44:07.000000', 'consum', 0.0213, 'lps'),
	(629801, 133, '2015-01-01 00:44:08.000000', 'consum', 0.0214, 'lps'),
	(629802, 133, '2015-01-01 00:44:09.000000', 'consum', 0.0223, 'lps'),
	(629803, 133, '2015-01-01 00:44:10.000000', 'consum', 0.0232, 'lps'),
	(629804, 133, '2015-01-01 00:44:11.000000', 'consum', 0.0216, 'lps'),
	(629805, 133, '2015-01-01 00:44:12.000000', 'consum', 0.0240, 'lps'),
	(629806, 133, '2015-01-01 00:44:13.000000', 'consum', 0.0213, 'lps'),
	(629807, 133, '2015-01-01 00:44:14.000000', 'consum', 0.0231, 'lps'),
	(629808, 133, '2015-01-01 00:44:15.000000', 'consum', 0.0212, 'lps'),
	(629809, 133, '2015-01-01 00:44:16.000000', 'consum', 0.0220, 'lps'),
	(629810, 133, '2015-01-01 00:44:17.000000', 'consum', 0.0224, 'lps'),
	(629811, 133, '2015-01-01 00:44:18.000000', 'consum', 0.0216, 'lps'),
	(629812, 133, '2015-01-01 00:44:19.000000', 'consum', 0.0234, 'lps'),
	(629813, 133, '2015-01-01 00:44:20.000000', 'consum', 0.0214, 'lps'),
	(629814, 133, '2015-01-01 00:44:21.000000', 'consum', 0.0225, 'lps'),
	(629815, 133, '2015-01-01 00:44:22.000000', 'consum', 0.0240, 'lps'),
	(629816, 133, '2015-01-01 00:44:23.000000', 'consum', 0.0218, 'lps'),
	(629817, 133, '2015-01-01 00:44:24.000000', 'consum', 0.0228, 'lps'),
	(629818, 133, '2015-01-01 00:44:25.000000', 'consum', 0.0210, 'lps'),
	(629819, 133, '2015-01-01 00:44:26.000000', 'consum', 0.0221, 'lps'),
	(629820, 133, '2015-01-01 00:44:27.000000', 'consum', 0.0234, 'lps'),
	(629821, 133, '2015-01-01 00:44:28.000000', 'consum', 0.0235, 'lps'),
	(629822, 133, '2015-01-01 00:44:29.000000', 'consum', 0.0230, 'lps'),
	(629823, 133, '2015-01-01 00:44:30.000000', 'consum', 0.0236, 'lps'),
	(629824, 133, '2015-01-01 00:44:31.000000', 'consum', 0.0215, 'lps'),
	(629825, 133, '2015-01-01 00:44:32.000000', 'consum', 0.0221, 'lps'),
	(629826, 133, '2015-01-01 00:44:33.000000', 'consum', 0.0221, 'lps'),
	(629827, 133, '2015-01-01 00:44:34.000000', 'consum', 0.0230, 'lps'),
	(629828, 133, '2015-01-01 00:44:35.000000', 'consum', 0.0214, 'lps'),
	(629829, 133, '2015-01-01 00:44:36.000000', 'consum', 0.0234, 'lps'),
	(629830, 133, '2015-01-01 00:44:37.000000', 'consum', 0.0225, 'lps'),
	(629831, 133, '2015-01-01 00:44:38.000000', 'consum', 0.0212, 'lps'),
	(629832, 133, '2015-01-01 00:44:39.000000', 'consum', 0.0210, 'lps'),
	(629833, 133, '2015-01-01 00:44:40.000000', 'consum', 0.0234, 'lps'),
	(629834, 133, '2015-01-01 00:44:41.000000', 'consum', 0.0234, 'lps'),
	(629835, 133, '2015-01-01 00:44:42.000000', 'consum', 0.0227, 'lps'),
	(629836, 133, '2015-01-01 00:44:43.000000', 'consum', 0.0222, 'lps'),
	(629837, 133, '2015-01-01 00:44:44.000000', 'consum', 0.0220, 'lps'),
	(629838, 133, '2015-01-01 00:44:45.000000', 'consum', 0.0226, 'lps'),
	(629839, 133, '2015-01-01 00:44:46.000000', 'consum', 0.0228, 'lps'),
	(629840, 133, '2015-01-01 00:44:47.000000', 'consum', 0.0219, 'lps'),
	(629841, 133, '2015-01-01 00:44:48.000000', 'consum', 0.0236, 'lps'),
	(629842, 133, '2015-01-01 00:44:49.000000', 'consum', 0.0217, 'lps'),
	(629843, 133, '2015-01-01 00:44:50.000000', 'consum', 0.0232, 'lps'),
	(629844, 133, '2015-01-01 00:44:51.000000', 'consum', 0.0236, 'lps'),
	(629845, 133, '2015-01-01 00:44:52.000000', 'consum', 0.0240, 'lps'),
	(629846, 133, '2015-01-01 00:44:53.000000', 'consum', 0.0219, 'lps'),
	(629847, 133, '2015-01-01 00:44:54.000000', 'consum', 0.0231, 'lps'),
	(629848, 133, '2015-01-01 00:44:55.000000', 'consum', 0.0223, 'lps'),
	(629849, 133, '2015-01-01 00:44:56.000000', 'consum', 0.0212, 'lps'),
	(629850, 133, '2015-01-01 00:44:57.000000', 'consum', 0.0214, 'lps'),
	(629851, 133, '2015-01-01 00:44:58.000000', 'consum', 0.0223, 'lps'),
	(629852, 133, '2015-01-01 00:44:59.000000', 'consum', 0.0233, 'lps'),
	(629853, 133, '2015-01-01 00:45:00.000000', 'consum', 0.0223, 'lps'),
	(629854, 133, '2015-01-01 00:45:01.000000', 'consum', 0.0237, 'lps'),
	(629855, 133, '2015-01-01 00:45:02.000000', 'consum', 0.0213, 'lps'),
	(629856, 133, '2015-01-01 00:45:03.000000', 'consum', 0.0239, 'lps'),
	(629857, 133, '2015-01-01 00:45:04.000000', 'consum', 0.0220, 'lps'),
	(629858, 133, '2015-01-01 00:45:05.000000', 'consum', 0.0238, 'lps'),
	(629859, 133, '2015-01-01 00:45:06.000000', 'consum', 0.0223, 'lps'),
	(629860, 133, '2015-01-01 00:45:07.000000', 'consum', 0.0223, 'lps'),
	(629861, 133, '2015-01-01 00:45:08.000000', 'consum', 0.0236, 'lps'),
	(629862, 133, '2015-01-01 00:45:09.000000', 'consum', 0.0237, 'lps'),
	(629863, 133, '2015-01-01 00:45:10.000000', 'consum', 0.0237, 'lps'),
	(629864, 133, '2015-01-01 00:45:11.000000', 'consum', 0.0233, 'lps'),
	(629865, 133, '2015-01-01 00:45:12.000000', 'consum', 0.0211, 'lps'),
	(629866, 133, '2015-01-01 00:45:13.000000', 'consum', 0.0212, 'lps'),
	(629867, 133, '2015-01-01 00:45:14.000000', 'consum', 0.0217, 'lps'),
	(629868, 133, '2015-01-01 00:45:15.000000', 'consum', 0.0241, 'lps'),
	(629869, 133, '2015-01-01 00:45:16.000000', 'consum', 0.0214, 'lps'),
	(629870, 133, '2015-01-01 00:45:17.000000', 'consum', 0.0235, 'lps'),
	(629871, 133, '2015-01-01 00:45:18.000000', 'consum', 0.0226, 'lps'),
	(629872, 133, '2015-01-01 00:45:19.000000', 'consum', 0.0215, 'lps'),
	(629873, 133, '2015-01-01 00:45:20.000000', 'consum', 0.0222, 'lps'),
	(629874, 133, '2015-01-01 00:45:21.000000', 'consum', 0.0224, 'lps'),
	(629875, 133, '2015-01-01 00:45:22.000000', 'consum', 0.0213, 'lps'),
	(629876, 133, '2015-01-01 00:45:23.000000', 'consum', 0.0216, 'lps'),
	(629877, 133, '2015-01-01 00:45:24.000000', 'consum', 0.0232, 'lps'),
	(629878, 133, '2015-01-01 00:45:25.000000', 'consum', 0.0238, 'lps'),
	(629879, 133, '2015-01-01 00:45:26.000000', 'consum', 0.0219, 'lps'),
	(629880, 133, '2015-01-01 00:45:27.000000', 'consum', 0.0236, 'lps'),
	(629881, 133, '2015-01-01 00:45:28.000000', 'consum', 0.0217, 'lps'),
	(629882, 133, '2015-01-01 00:45:29.000000', 'consum', 0.0234, 'lps'),
	(629883, 133, '2015-01-01 00:45:30.000000', 'consum', 0.0211, 'lps'),
	(629884, 133, '2015-01-01 00:45:31.000000', 'consum', 0.0240, 'lps'),
	(629885, 133, '2015-01-01 00:45:32.000000', 'consum', 0.0232, 'lps'),
	(629886, 133, '2015-01-01 00:45:33.000000', 'consum', 0.0227, 'lps'),
	(629887, 133, '2015-01-01 00:45:34.000000', 'consum', 0.0230, 'lps'),
	(629888, 133, '2015-01-01 00:45:35.000000', 'consum', 0.0229, 'lps'),
	(629889, 133, '2015-01-01 00:45:36.000000', 'consum', 0.0212, 'lps'),
	(629890, 133, '2015-01-01 00:45:37.000000', 'consum', 0.0230, 'lps'),
	(629891, 133, '2015-01-01 00:45:38.000000', 'consum', 0.0237, 'lps'),
	(629892, 133, '2015-01-01 00:45:39.000000', 'consum', 0.0224, 'lps'),
	(629893, 133, '2015-01-01 00:45:40.000000', 'consum', 0.0231, 'lps'),
	(629894, 133, '2015-01-01 00:45:41.000000', 'consum', 0.0211, 'lps'),
	(629895, 133, '2015-01-01 00:45:42.000000', 'consum', 0.0214, 'lps'),
	(629896, 133, '2015-01-01 00:45:43.000000', 'consum', 0.0230, 'lps'),
	(629897, 133, '2015-01-01 00:45:44.000000', 'consum', 0.0234, 'lps'),
	(629898, 133, '2015-01-01 00:45:45.000000', 'consum', 0.0240, 'lps'),
	(629899, 133, '2015-01-01 00:45:46.000000', 'consum', 0.0222, 'lps'),
	(629900, 133, '2015-01-01 00:45:47.000000', 'consum', 0.0213, 'lps'),
	(629901, 133, '2015-01-01 00:45:48.000000', 'consum', 0.0220, 'lps'),
	(629902, 133, '2015-01-01 00:45:49.000000', 'consum', 0.0223, 'lps'),
	(629903, 133, '2015-01-01 00:45:50.000000', 'consum', 0.0211, 'lps'),
	(629904, 133, '2015-01-01 00:45:51.000000', 'consum', 0.0239, 'lps'),
	(629905, 133, '2015-01-01 00:45:52.000000', 'consum', 0.0227, 'lps'),
	(629906, 133, '2015-01-01 00:45:53.000000', 'consum', 0.0240, 'lps'),
	(629907, 133, '2015-01-01 00:45:54.000000', 'consum', 0.0211, 'lps'),
	(629908, 133, '2015-01-01 00:45:55.000000', 'consum', 0.0224, 'lps'),
	(629909, 133, '2015-01-01 00:45:56.000000', 'consum', 0.0214, 'lps'),
	(629910, 133, '2015-01-01 00:45:57.000000', 'consum', 0.0218, 'lps'),
	(629911, 133, '2015-01-01 00:45:58.000000', 'consum', 0.0241, 'lps'),
	(629912, 133, '2015-01-01 00:45:59.000000', 'consum', 0.0214, 'lps'),
	(629913, 133, '2015-01-01 00:46:00.000000', 'consum', 0.0233, 'lps'),
	(629914, 133, '2015-01-01 00:46:01.000000', 'consum', 0.0215, 'lps'),
	(629915, 133, '2015-01-01 00:46:02.000000', 'consum', 0.0234, 'lps'),
	(629916, 133, '2015-01-01 00:46:03.000000', 'consum', 0.0216, 'lps'),
	(629917, 133, '2015-01-01 00:46:04.000000', 'consum', 0.0235, 'lps'),
	(629918, 133, '2015-01-01 00:46:05.000000', 'consum', 0.0223, 'lps'),
	(629919, 133, '2015-01-01 00:46:06.000000', 'consum', 0.0230, 'lps'),
	(629920, 133, '2015-01-01 00:46:07.000000', 'consum', 0.0239, 'lps'),
	(629921, 133, '2015-01-01 00:46:08.000000', 'consum', 0.0233, 'lps'),
	(629922, 133, '2015-01-01 00:46:09.000000', 'consum', 0.0238, 'lps'),
	(629923, 133, '2015-01-01 00:46:10.000000', 'consum', 0.0216, 'lps'),
	(629924, 133, '2015-01-01 00:46:11.000000', 'consum', 0.0220, 'lps'),
	(629925, 133, '2015-01-01 00:46:12.000000', 'consum', 0.0212, 'lps'),
	(629926, 133, '2015-01-01 00:46:13.000000', 'consum', 0.0220, 'lps'),
	(629927, 133, '2015-01-01 00:46:14.000000', 'consum', 0.0226, 'lps'),
	(629928, 133, '2015-01-01 00:46:15.000000', 'consum', 0.0225, 'lps'),
	(629929, 133, '2015-01-01 00:46:16.000000', 'consum', 0.0240, 'lps'),
	(629930, 133, '2015-01-01 00:46:17.000000', 'consum', 0.0220, 'lps'),
	(629931, 133, '2015-01-01 00:46:18.000000', 'consum', 0.0234, 'lps'),
	(629932, 133, '2015-01-01 00:46:19.000000', 'consum', 0.0235, 'lps'),
	(629933, 133, '2015-01-01 00:46:20.000000', 'consum', 0.0231, 'lps'),
	(629934, 133, '2015-01-01 00:46:21.000000', 'consum', 0.0241, 'lps'),
	(629935, 133, '2015-01-01 00:46:22.000000', 'consum', 0.0239, 'lps'),
	(629936, 133, '2015-01-01 00:46:23.000000', 'consum', 0.0230, 'lps'),
	(629937, 133, '2015-01-01 00:46:24.000000', 'consum', 0.0224, 'lps'),
	(629938, 133, '2015-01-01 00:46:25.000000', 'consum', 0.0220, 'lps'),
	(629939, 133, '2015-01-01 00:46:26.000000', 'consum', 0.0217, 'lps'),
	(629940, 133, '2015-01-01 00:46:27.000000', 'consum', 0.0216, 'lps'),
	(629941, 133, '2015-01-01 00:46:28.000000', 'consum', 0.0220, 'lps'),
	(629942, 133, '2015-01-01 00:46:29.000000', 'consum', 0.0241, 'lps'),
	(629943, 133, '2015-01-01 00:46:30.000000', 'consum', 0.0240, 'lps'),
	(629944, 133, '2015-01-01 00:46:31.000000', 'consum', 0.0234, 'lps'),
	(629945, 133, '2015-01-01 00:46:32.000000', 'consum', 0.0212, 'lps'),
	(629946, 133, '2015-01-01 00:46:33.000000', 'consum', 0.0210, 'lps'),
	(629947, 133, '2015-01-01 00:46:34.000000', 'consum', 0.0236, 'lps'),
	(629948, 133, '2015-01-01 00:46:35.000000', 'consum', 0.0212, 'lps'),
	(629949, 133, '2015-01-01 00:46:36.000000', 'consum', 0.0239, 'lps'),
	(629950, 133, '2015-01-01 00:46:37.000000', 'consum', 0.0220, 'lps'),
	(629951, 133, '2015-01-01 00:46:38.000000', 'consum', 0.0240, 'lps'),
	(629952, 133, '2015-01-01 00:46:39.000000', 'consum', 0.0233, 'lps'),
	(629953, 133, '2015-01-01 00:46:40.000000', 'consum', 0.0235, 'lps'),
	(629954, 133, '2015-01-01 00:46:41.000000', 'consum', 0.0237, 'lps'),
	(629955, 133, '2015-01-01 00:46:42.000000', 'consum', 0.0235, 'lps'),
	(629956, 133, '2015-01-01 00:46:43.000000', 'consum', 0.0225, 'lps'),
	(629957, 133, '2015-01-01 00:46:44.000000', 'consum', 0.0212, 'lps'),
	(629958, 133, '2015-01-01 00:46:45.000000', 'consum', 0.0236, 'lps'),
	(629959, 133, '2015-01-01 00:46:46.000000', 'consum', 0.0239, 'lps'),
	(629960, 133, '2015-01-01 00:46:47.000000', 'consum', 0.0216, 'lps'),
	(629961, 133, '2015-01-01 00:46:48.000000', 'consum', 0.0215, 'lps'),
	(629962, 133, '2015-01-01 00:46:49.000000', 'consum', 0.0220, 'lps'),
	(629963, 133, '2015-01-01 00:46:50.000000', 'consum', 0.0212, 'lps'),
	(629964, 133, '2015-01-01 00:46:51.000000', 'consum', 0.0221, 'lps'),
	(629965, 133, '2015-01-01 00:46:52.000000', 'consum', 0.0227, 'lps'),
	(629966, 133, '2015-01-01 00:46:53.000000', 'consum', 0.0232, 'lps'),
	(629967, 133, '2015-01-01 00:46:54.000000', 'consum', 0.0237, 'lps'),
	(629968, 133, '2015-01-01 00:46:55.000000', 'consum', 0.0215, 'lps'),
	(629969, 133, '2015-01-01 00:46:56.000000', 'consum', 0.0220, 'lps'),
	(629970, 133, '2015-01-01 00:46:57.000000', 'consum', 0.0213, 'lps'),
	(629971, 133, '2015-01-01 00:46:58.000000', 'consum', 0.0229, 'lps'),
	(629972, 133, '2015-01-01 00:46:59.000000', 'consum', 0.0232, 'lps'),
	(629973, 133, '2015-01-01 00:47:00.000000', 'consum', 0.0229, 'lps'),
	(629974, 133, '2015-01-01 00:47:01.000000', 'consum', 0.0241, 'lps'),
	(629975, 133, '2015-01-01 00:47:02.000000', 'consum', 0.0214, 'lps'),
	(629976, 133, '2015-01-01 00:47:03.000000', 'consum', 0.0231, 'lps'),
	(629977, 133, '2015-01-01 00:47:04.000000', 'consum', 0.0210, 'lps'),
	(629978, 133, '2015-01-01 00:47:05.000000', 'consum', 0.0210, 'lps'),
	(629979, 133, '2015-01-01 00:47:06.000000', 'consum', 0.0211, 'lps'),
	(629980, 133, '2015-01-01 00:47:07.000000', 'consum', 0.0216, 'lps'),
	(629981, 133, '2015-01-01 00:47:08.000000', 'consum', 0.0236, 'lps'),
	(629982, 133, '2015-01-01 00:47:09.000000', 'consum', 0.0228, 'lps'),
	(629983, 133, '2015-01-01 00:47:10.000000', 'consum', 0.0222, 'lps'),
	(629984, 133, '2015-01-01 00:47:11.000000', 'consum', 0.0217, 'lps'),
	(629985, 133, '2015-01-01 00:47:12.000000', 'consum', 0.0211, 'lps'),
	(629986, 133, '2015-01-01 00:47:13.000000', 'consum', 0.0225, 'lps'),
	(629987, 133, '2015-01-01 00:47:14.000000', 'consum', 0.0221, 'lps'),
	(629988, 133, '2015-01-01 00:47:15.000000', 'consum', 0.0218, 'lps'),
	(629989, 133, '2015-01-01 00:47:16.000000', 'consum', 0.0216, 'lps'),
	(629990, 133, '2015-01-01 00:47:17.000000', 'consum', 0.0220, 'lps'),
	(629991, 133, '2015-01-01 00:47:18.000000', 'consum', 0.0240, 'lps'),
	(629992, 133, '2015-01-01 00:47:19.000000', 'consum', 0.0236, 'lps'),
	(629993, 133, '2015-01-01 00:47:20.000000', 'consum', 0.0219, 'lps'),
	(629994, 133, '2015-01-01 00:47:21.000000', 'consum', 0.0240, 'lps'),
	(629995, 133, '2015-01-01 00:47:22.000000', 'consum', 0.0239, 'lps'),
	(629996, 133, '2015-01-01 00:47:23.000000', 'consum', 0.0232, 'lps'),
	(629997, 133, '2015-01-01 00:47:24.000000', 'consum', 0.0236, 'lps'),
	(629998, 133, '2015-01-01 00:47:25.000000', 'consum', 0.0239, 'lps'),
	(629999, 133, '2015-01-01 00:47:26.000000', 'consum', 0.0216, 'lps'),
	(630000, 133, '2015-01-01 00:47:27.000000', 'consum', 0.0216, 'lps'),
	(630001, 133, '2015-01-01 00:47:28.000000', 'consum', 0.0221, 'lps'),
	(630002, 133, '2015-01-01 00:47:29.000000', 'consum', 0.0217, 'lps'),
	(630003, 133, '2015-01-01 00:47:30.000000', 'consum', 0.0214, 'lps'),
	(630004, 133, '2015-01-01 00:47:31.000000', 'consum', 0.0210, 'lps'),
	(630005, 133, '2015-01-01 00:47:32.000000', 'consum', 0.0227, 'lps'),
	(630006, 133, '2015-01-01 00:47:33.000000', 'consum', 0.0235, 'lps'),
	(630007, 133, '2015-01-01 00:47:34.000000', 'consum', 0.0219, 'lps'),
	(630008, 133, '2015-01-01 00:47:35.000000', 'consum', 0.0211, 'lps'),
	(630009, 133, '2015-01-01 00:47:36.000000', 'consum', 0.0222, 'lps'),
	(630010, 133, '2015-01-01 00:47:37.000000', 'consum', 0.0234, 'lps'),
	(630011, 133, '2015-01-01 00:47:38.000000', 'consum', 0.0232, 'lps'),
	(630012, 133, '2015-01-01 00:47:39.000000', 'consum', 0.0214, 'lps'),
	(630013, 133, '2015-01-01 00:47:40.000000', 'consum', 0.0230, 'lps'),
	(630014, 133, '2015-01-01 00:47:41.000000', 'consum', 0.0233, 'lps'),
	(630015, 133, '2015-01-01 00:47:42.000000', 'consum', 0.0234, 'lps'),
	(630016, 133, '2015-01-01 00:47:43.000000', 'consum', 0.0229, 'lps'),
	(630017, 133, '2015-01-01 00:47:44.000000', 'consum', 0.0236, 'lps'),
	(630018, 133, '2015-01-01 00:47:45.000000', 'consum', 0.0219, 'lps'),
	(630019, 133, '2015-01-01 00:47:46.000000', 'consum', 0.0241, 'lps'),
	(630020, 133, '2015-01-01 00:47:47.000000', 'consum', 0.0212, 'lps'),
	(630021, 133, '2015-01-01 00:47:48.000000', 'consum', 0.0223, 'lps'),
	(630022, 133, '2015-01-01 00:47:49.000000', 'consum', 0.0239, 'lps'),
	(630023, 133, '2015-01-01 00:47:50.000000', 'consum', 0.0220, 'lps'),
	(630024, 133, '2015-01-01 00:47:51.000000', 'consum', 0.0238, 'lps'),
	(630025, 133, '2015-01-01 00:47:52.000000', 'consum', 0.0223, 'lps'),
	(630026, 133, '2015-01-01 00:47:53.000000', 'consum', 0.0223, 'lps'),
	(630027, 133, '2015-01-01 00:47:54.000000', 'consum', 0.0238, 'lps'),
	(630028, 133, '2015-01-01 00:47:55.000000', 'consum', 0.0214, 'lps'),
	(630029, 133, '2015-01-01 00:47:56.000000', 'consum', 0.0211, 'lps'),
	(630030, 133, '2015-01-01 00:47:57.000000', 'consum', 0.0236, 'lps'),
	(630031, 133, '2015-01-01 00:47:58.000000', 'consum', 0.0241, 'lps'),
	(630032, 133, '2015-01-01 00:47:59.000000', 'consum', 0.0222, 'lps'),
	(630033, 133, '2015-01-01 00:48:00.000000', 'consum', 0.0210, 'lps'),
	(630034, 133, '2015-01-01 00:48:01.000000', 'consum', 0.0238, 'lps'),
	(630035, 133, '2015-01-01 00:48:02.000000', 'consum', 0.0223, 'lps'),
	(630036, 133, '2015-01-01 00:48:03.000000', 'consum', 0.0225, 'lps'),
	(630037, 133, '2015-01-01 00:48:04.000000', 'consum', 0.0214, 'lps'),
	(630038, 133, '2015-01-01 00:48:05.000000', 'consum', 0.0216, 'lps'),
	(630039, 133, '2015-01-01 00:48:06.000000', 'consum', 0.0228, 'lps'),
	(630040, 133, '2015-01-01 00:48:07.000000', 'consum', 0.0218, 'lps'),
	(630041, 133, '2015-01-01 00:48:08.000000', 'consum', 0.0231, 'lps'),
	(630042, 133, '2015-01-01 00:48:09.000000', 'consum', 0.0225, 'lps'),
	(630043, 133, '2015-01-01 00:48:10.000000', 'consum', 0.0225, 'lps'),
	(630044, 133, '2015-01-01 00:48:11.000000', 'consum', 0.0239, 'lps'),
	(630045, 133, '2015-01-01 00:48:12.000000', 'consum', 0.0216, 'lps'),
	(630046, 133, '2015-01-01 00:48:13.000000', 'consum', 0.0215, 'lps'),
	(630047, 133, '2015-01-01 00:48:14.000000', 'consum', 0.0217, 'lps'),
	(630048, 133, '2015-01-01 00:48:15.000000', 'consum', 0.0233, 'lps'),
	(630049, 133, '2015-01-01 00:48:16.000000', 'consum', 0.0240, 'lps'),
	(630050, 133, '2015-01-01 00:48:17.000000', 'consum', 0.0226, 'lps'),
	(630051, 133, '2015-01-01 00:48:18.000000', 'consum', 0.0231, 'lps'),
	(630052, 133, '2015-01-01 00:48:19.000000', 'consum', 0.0238, 'lps'),
	(630053, 133, '2015-01-01 00:48:20.000000', 'consum', 0.0223, 'lps'),
	(630054, 133, '2015-01-01 00:48:21.000000', 'consum', 0.0223, 'lps'),
	(630055, 133, '2015-01-01 00:48:22.000000', 'consum', 0.0235, 'lps'),
	(630056, 133, '2015-01-01 00:48:23.000000', 'consum', 0.0235, 'lps'),
	(630057, 133, '2015-01-01 00:48:24.000000', 'consum', 0.0228, 'lps'),
	(630058, 133, '2015-01-01 00:48:25.000000', 'consum', 0.0227, 'lps'),
	(630059, 133, '2015-01-01 00:48:26.000000', 'consum', 0.0239, 'lps'),
	(630060, 133, '2015-01-01 00:48:27.000000', 'consum', 0.0239, 'lps'),
	(630061, 133, '2015-01-01 00:48:28.000000', 'consum', 0.0239, 'lps'),
	(630062, 133, '2015-01-01 00:48:29.000000', 'consum', 0.0237, 'lps'),
	(630063, 133, '2015-01-01 00:48:30.000000', 'consum', 0.0226, 'lps'),
	(630064, 133, '2015-01-01 00:48:31.000000', 'consum', 0.0240, 'lps'),
	(630065, 133, '2015-01-01 00:48:32.000000', 'consum', 0.0216, 'lps'),
	(630066, 133, '2015-01-01 00:48:33.000000', 'consum', 0.0214, 'lps'),
	(630067, 133, '2015-01-01 00:48:34.000000', 'consum', 0.0212, 'lps'),
	(630068, 133, '2015-01-01 00:48:35.000000', 'consum', 0.0210, 'lps'),
	(630069, 133, '2015-01-01 00:48:36.000000', 'consum', 0.0234, 'lps'),
	(630070, 133, '2015-01-01 00:48:37.000000', 'consum', 0.0237, 'lps'),
	(630071, 133, '2015-01-01 00:48:38.000000', 'consum', 0.0210, 'lps'),
	(630072, 133, '2015-01-01 00:48:39.000000', 'consum', 0.0226, 'lps'),
	(630073, 133, '2015-01-01 00:48:40.000000', 'consum', 0.0224, 'lps'),
	(630074, 133, '2015-01-01 00:48:41.000000', 'consum', 0.0235, 'lps'),
	(630075, 133, '2015-01-01 00:48:42.000000', 'consum', 0.0229, 'lps'),
	(630076, 133, '2015-01-01 00:48:43.000000', 'consum', 0.0231, 'lps'),
	(630077, 133, '2015-01-01 00:48:44.000000', 'consum', 0.0227, 'lps'),
	(630078, 133, '2015-01-01 00:48:45.000000', 'consum', 0.0233, 'lps'),
	(630079, 133, '2015-01-01 00:48:46.000000', 'consum', 0.0210, 'lps'),
	(630080, 133, '2015-01-01 00:48:47.000000', 'consum', 0.0239, 'lps'),
	(630081, 133, '2015-01-01 00:48:48.000000', 'consum', 0.0225, 'lps'),
	(630082, 133, '2015-01-01 00:48:49.000000', 'consum', 0.0233, 'lps'),
	(630083, 133, '2015-01-01 00:48:50.000000', 'consum', 0.0216, 'lps'),
	(630084, 133, '2015-01-01 00:48:51.000000', 'consum', 0.0233, 'lps'),
	(630085, 133, '2015-01-01 00:48:52.000000', 'consum', 0.0213, 'lps'),
	(630086, 133, '2015-01-01 00:48:53.000000', 'consum', 0.0222, 'lps'),
	(630087, 133, '2015-01-01 00:48:54.000000', 'consum', 0.0230, 'lps'),
	(630088, 133, '2015-01-01 00:48:55.000000', 'consum', 0.0210, 'lps'),
	(630089, 133, '2015-01-01 00:48:56.000000', 'consum', 0.0215, 'lps'),
	(630090, 133, '2015-01-01 00:48:57.000000', 'consum', 0.0236, 'lps'),
	(630091, 133, '2015-01-01 00:48:58.000000', 'consum', 0.0227, 'lps'),
	(630092, 133, '2015-01-01 00:48:59.000000', 'consum', 0.0218, 'lps'),
	(630093, 133, '2015-01-01 00:49:00.000000', 'consum', 0.0230, 'lps'),
	(630094, 133, '2015-01-01 00:49:01.000000', 'consum', 0.0224, 'lps'),
	(630095, 133, '2015-01-01 00:49:02.000000', 'consum', 0.0221, 'lps'),
	(630096, 133, '2015-01-01 00:49:03.000000', 'consum', 0.0224, 'lps'),
	(630097, 133, '2015-01-01 00:49:04.000000', 'consum', 0.0217, 'lps'),
	(630098, 133, '2015-01-01 00:49:05.000000', 'consum', 0.0233, 'lps'),
	(630099, 133, '2015-01-01 00:49:06.000000', 'consum', 0.0240, 'lps'),
	(630100, 133, '2015-01-01 00:49:07.000000', 'consum', 0.0228, 'lps'),
	(630101, 133, '2015-01-01 00:49:08.000000', 'consum', 0.0210, 'lps'),
	(630102, 133, '2015-01-01 00:49:09.000000', 'consum', 0.0219, 'lps'),
	(630103, 133, '2015-01-01 00:49:10.000000', 'consum', 0.0226, 'lps'),
	(630104, 133, '2015-01-01 00:49:11.000000', 'consum', 0.0232, 'lps'),
	(630105, 133, '2015-01-01 00:49:12.000000', 'consum', 0.0210, 'lps'),
	(630106, 133, '2015-01-01 00:49:13.000000', 'consum', 0.0238, 'lps'),
	(630107, 133, '2015-01-01 00:49:14.000000', 'consum', 0.0221, 'lps'),
	(630108, 133, '2015-01-01 00:49:15.000000', 'consum', 0.0216, 'lps'),
	(630109, 133, '2015-01-01 00:49:16.000000', 'consum', 0.0238, 'lps'),
	(630110, 133, '2015-01-01 00:49:17.000000', 'consum', 0.0237, 'lps'),
	(630111, 133, '2015-01-01 00:49:18.000000', 'consum', 0.0230, 'lps'),
	(630112, 133, '2015-01-01 00:49:19.000000', 'consum', 0.0230, 'lps'),
	(630113, 133, '2015-01-01 00:49:20.000000', 'consum', 0.0217, 'lps'),
	(630114, 133, '2015-01-01 00:49:21.000000', 'consum', 0.0217, 'lps'),
	(630115, 133, '2015-01-01 00:49:22.000000', 'consum', 0.0224, 'lps'),
	(630116, 133, '2015-01-01 00:49:23.000000', 'consum', 0.0228, 'lps'),
	(630117, 133, '2015-01-01 00:49:24.000000', 'consum', 0.0225, 'lps'),
	(630118, 133, '2015-01-01 00:49:25.000000', 'consum', 0.0232, 'lps'),
	(630119, 133, '2015-01-01 00:49:26.000000', 'consum', 0.0214, 'lps'),
	(630120, 133, '2015-01-01 00:49:27.000000', 'consum', 0.0227, 'lps'),
	(630121, 133, '2015-01-01 00:49:28.000000', 'consum', 0.0220, 'lps'),
	(630122, 133, '2015-01-01 00:49:29.000000', 'consum', 0.0210, 'lps'),
	(630123, 133, '2015-01-01 00:49:30.000000', 'consum', 0.0211, 'lps'),
	(630124, 133, '2015-01-01 00:49:31.000000', 'consum', 0.0218, 'lps'),
	(630125, 133, '2015-01-01 00:49:32.000000', 'consum', 0.0215, 'lps'),
	(630126, 133, '2015-01-01 00:49:33.000000', 'consum', 0.0210, 'lps'),
	(630127, 133, '2015-01-01 00:49:34.000000', 'consum', 0.0229, 'lps'),
	(630128, 133, '2015-01-01 00:49:35.000000', 'consum', 0.0211, 'lps'),
	(630129, 133, '2015-01-01 00:49:36.000000', 'consum', 0.0221, 'lps'),
	(630130, 133, '2015-01-01 00:49:37.000000', 'consum', 0.0232, 'lps'),
	(630131, 133, '2015-01-01 00:49:38.000000', 'consum', 0.0221, 'lps'),
	(630132, 133, '2015-01-01 00:49:39.000000', 'consum', 0.0231, 'lps'),
	(630133, 133, '2015-01-01 00:49:40.000000', 'consum', 0.0222, 'lps'),
	(630134, 133, '2015-01-01 00:49:41.000000', 'consum', 0.0236, 'lps'),
	(630135, 133, '2015-01-01 00:49:42.000000', 'consum', 0.0210, 'lps'),
	(630136, 133, '2015-01-01 00:49:43.000000', 'consum', 0.0228, 'lps'),
	(630137, 133, '2015-01-01 00:49:44.000000', 'consum', 0.0236, 'lps'),
	(630138, 133, '2015-01-01 00:49:45.000000', 'consum', 0.0224, 'lps'),
	(630139, 133, '2015-01-01 00:49:46.000000', 'consum', 0.0232, 'lps'),
	(630140, 133, '2015-01-01 00:49:47.000000', 'consum', 0.0216, 'lps'),
	(630141, 133, '2015-01-01 00:49:48.000000', 'consum', 0.0239, 'lps'),
	(630142, 133, '2015-01-01 00:49:49.000000', 'consum', 0.0211, 'lps'),
	(630143, 133, '2015-01-01 00:49:50.000000', 'consum', 0.0224, 'lps'),
	(630144, 133, '2015-01-01 00:49:51.000000', 'consum', 0.0212, 'lps'),
	(630145, 133, '2015-01-01 00:49:52.000000', 'consum', 0.0213, 'lps'),
	(630146, 133, '2015-01-01 00:49:53.000000', 'consum', 0.0216, 'lps'),
	(630147, 133, '2015-01-01 00:49:54.000000', 'consum', 0.0234, 'lps'),
	(630148, 133, '2015-01-01 00:49:55.000000', 'consum', 0.0216, 'lps'),
	(630149, 133, '2015-01-01 00:49:56.000000', 'consum', 0.0233, 'lps'),
	(630150, 133, '2015-01-01 00:49:57.000000', 'consum', 0.0211, 'lps'),
	(630151, 133, '2015-01-01 00:49:58.000000', 'consum', 0.0210, 'lps'),
	(630152, 133, '2015-01-01 00:49:59.000000', 'consum', 0.0239, 'lps'),
	(630153, 133, '2015-01-01 00:50:00.000000', 'consum', 0.0226, 'lps'),
	(630154, 133, '2015-01-01 00:50:01.000000', 'consum', 0.0239, 'lps'),
	(630155, 133, '2015-01-01 00:50:02.000000', 'consum', 0.0240, 'lps'),
	(630156, 133, '2015-01-01 00:50:03.000000', 'consum', 0.0212, 'lps'),
	(630157, 133, '2015-01-01 00:50:04.000000', 'consum', 0.0224, 'lps'),
	(630158, 133, '2015-01-01 00:50:05.000000', 'consum', 0.0210, 'lps'),
	(630159, 133, '2015-01-01 00:50:06.000000', 'consum', 0.0235, 'lps'),
	(630160, 133, '2015-01-01 00:50:07.000000', 'consum', 0.0239, 'lps'),
	(630161, 133, '2015-01-01 00:50:08.000000', 'consum', 0.0216, 'lps'),
	(630162, 133, '2015-01-01 00:50:09.000000', 'consum', 0.0218, 'lps'),
	(630163, 133, '2015-01-01 00:50:10.000000', 'consum', 0.0231, 'lps'),
	(630164, 133, '2015-01-01 00:50:11.000000', 'consum', 0.0228, 'lps'),
	(630165, 133, '2015-01-01 00:50:12.000000', 'consum', 0.0239, 'lps'),
	(630166, 133, '2015-01-01 00:50:13.000000', 'consum', 0.0237, 'lps'),
	(630167, 133, '2015-01-01 00:50:14.000000', 'consum', 0.0225, 'lps'),
	(630168, 133, '2015-01-01 00:50:15.000000', 'consum', 0.0236, 'lps'),
	(630169, 133, '2015-01-01 00:50:16.000000', 'consum', 0.0234, 'lps'),
	(630170, 133, '2015-01-01 00:50:17.000000', 'consum', 0.0220, 'lps'),
	(630171, 133, '2015-01-01 00:50:18.000000', 'consum', 0.0222, 'lps'),
	(630172, 133, '2015-01-01 00:50:19.000000', 'consum', 0.0240, 'lps'),
	(630173, 133, '2015-01-01 00:50:20.000000', 'consum', 0.0228, 'lps'),
	(630174, 133, '2015-01-01 00:50:21.000000', 'consum', 0.0240, 'lps'),
	(630175, 133, '2015-01-01 00:50:22.000000', 'consum', 0.0214, 'lps'),
	(630176, 133, '2015-01-01 00:50:23.000000', 'consum', 0.0234, 'lps'),
	(630177, 133, '2015-01-01 00:50:24.000000', 'consum', 0.0224, 'lps'),
	(630178, 133, '2015-01-01 00:50:25.000000', 'consum', 0.0240, 'lps'),
	(630179, 133, '2015-01-01 00:50:26.000000', 'consum', 0.0224, 'lps'),
	(630180, 133, '2015-01-01 00:50:27.000000', 'consum', 0.0223, 'lps'),
	(630181, 133, '2015-01-01 00:50:28.000000', 'consum', 0.0231, 'lps'),
	(630182, 133, '2015-01-01 00:50:29.000000', 'consum', 0.0214, 'lps'),
	(630183, 133, '2015-01-01 00:50:30.000000', 'consum', 0.0231, 'lps'),
	(630184, 133, '2015-01-01 00:50:31.000000', 'consum', 0.0239, 'lps'),
	(630185, 133, '2015-01-01 00:50:32.000000', 'consum', 0.0228, 'lps'),
	(630186, 133, '2015-01-01 00:50:33.000000', 'consum', 0.0214, 'lps'),
	(630187, 133, '2015-01-01 00:50:34.000000', 'consum', 0.0239, 'lps'),
	(630188, 133, '2015-01-01 00:50:35.000000', 'consum', 0.0216, 'lps'),
	(630189, 133, '2015-01-01 00:50:36.000000', 'consum', 0.0217, 'lps'),
	(630190, 133, '2015-01-01 00:50:37.000000', 'consum', 0.0230, 'lps'),
	(630191, 133, '2015-01-01 00:50:38.000000', 'consum', 0.0225, 'lps'),
	(630192, 133, '2015-01-01 00:50:39.000000', 'consum', 0.0223, 'lps'),
	(630193, 133, '2015-01-01 00:50:40.000000', 'consum', 0.0233, 'lps'),
	(630194, 133, '2015-01-01 00:50:41.000000', 'consum', 0.0220, 'lps'),
	(630195, 133, '2015-01-01 00:50:42.000000', 'consum', 0.0225, 'lps'),
	(630196, 133, '2015-01-01 00:50:43.000000', 'consum', 0.0224, 'lps'),
	(630197, 133, '2015-01-01 00:50:44.000000', 'consum', 0.0235, 'lps'),
	(630198, 133, '2015-01-01 00:50:45.000000', 'consum', 0.0231, 'lps'),
	(630199, 133, '2015-01-01 00:50:46.000000', 'consum', 0.0241, 'lps'),
	(630200, 133, '2015-01-01 00:50:47.000000', 'consum', 0.0236, 'lps'),
	(630201, 133, '2015-01-01 00:50:48.000000', 'consum', 0.0215, 'lps'),
	(630202, 133, '2015-01-01 00:50:49.000000', 'consum', 0.0223, 'lps'),
	(630203, 133, '2015-01-01 00:50:50.000000', 'consum', 0.0229, 'lps'),
	(630204, 133, '2015-01-01 00:50:51.000000', 'consum', 0.0232, 'lps'),
	(630205, 133, '2015-01-01 00:50:52.000000', 'consum', 0.0233, 'lps'),
	(630206, 133, '2015-01-01 00:50:53.000000', 'consum', 0.0227, 'lps'),
	(630207, 133, '2015-01-01 00:50:54.000000', 'consum', 0.0225, 'lps'),
	(630208, 133, '2015-01-01 00:50:55.000000', 'consum', 0.0237, 'lps'),
	(630209, 133, '2015-01-01 00:50:56.000000', 'consum', 0.0234, 'lps'),
	(630210, 133, '2015-01-01 00:50:57.000000', 'consum', 0.0219, 'lps'),
	(630211, 133, '2015-01-01 00:50:58.000000', 'consum', 0.0217, 'lps'),
	(630212, 133, '2015-01-01 00:50:59.000000', 'consum', 0.0217, 'lps'),
	(630213, 133, '2015-01-01 00:51:00.000000', 'consum', 0.0223, 'lps'),
	(630214, 133, '2015-01-01 00:51:01.000000', 'consum', 0.0224, 'lps'),
	(630215, 133, '2015-01-01 00:51:02.000000', 'consum', 0.0211, 'lps'),
	(630216, 133, '2015-01-01 00:51:03.000000', 'consum', 0.0236, 'lps'),
	(630217, 133, '2015-01-01 00:51:04.000000', 'consum', 0.0240, 'lps'),
	(630218, 133, '2015-01-01 00:51:05.000000', 'consum', 0.0221, 'lps'),
	(630219, 133, '2015-01-01 00:51:06.000000', 'consum', 0.0239, 'lps'),
	(630220, 133, '2015-01-01 00:51:07.000000', 'consum', 0.0224, 'lps'),
	(630221, 133, '2015-01-01 00:51:08.000000', 'consum', 0.0227, 'lps'),
	(630222, 133, '2015-01-01 00:51:09.000000', 'consum', 0.0223, 'lps'),
	(630223, 133, '2015-01-01 00:51:10.000000', 'consum', 0.0224, 'lps'),
	(630224, 133, '2015-01-01 00:51:11.000000', 'consum', 0.0210, 'lps'),
	(630225, 133, '2015-01-01 00:51:12.000000', 'consum', 0.0231, 'lps'),
	(630226, 133, '2015-01-01 00:51:13.000000', 'consum', 0.0220, 'lps'),
	(630227, 133, '2015-01-01 00:51:14.000000', 'consum', 0.0229, 'lps'),
	(630228, 133, '2015-01-01 00:51:15.000000', 'consum', 0.0213, 'lps'),
	(630229, 133, '2015-01-01 00:51:16.000000', 'consum', 0.0232, 'lps'),
	(630230, 133, '2015-01-01 00:51:17.000000', 'consum', 0.0217, 'lps'),
	(630231, 133, '2015-01-01 00:51:18.000000', 'consum', 0.0241, 'lps'),
	(630232, 133, '2015-01-01 00:51:19.000000', 'consum', 0.0219, 'lps'),
	(630233, 133, '2015-01-01 00:51:20.000000', 'consum', 0.0227, 'lps'),
	(630234, 133, '2015-01-01 00:51:21.000000', 'consum', 0.0237, 'lps'),
	(630235, 133, '2015-01-01 00:51:22.000000', 'consum', 0.0231, 'lps'),
	(630236, 133, '2015-01-01 00:51:23.000000', 'consum', 0.0234, 'lps'),
	(630237, 133, '2015-01-01 00:51:24.000000', 'consum', 0.0235, 'lps'),
	(630238, 133, '2015-01-01 00:51:25.000000', 'consum', 0.0231, 'lps'),
	(630239, 133, '2015-01-01 00:51:26.000000', 'consum', 0.0211, 'lps'),
	(630240, 133, '2015-01-01 00:51:27.000000', 'consum', 0.0215, 'lps'),
	(630241, 133, '2015-01-01 00:51:28.000000', 'consum', 0.0232, 'lps'),
	(630242, 133, '2015-01-01 00:51:29.000000', 'consum', 0.0241, 'lps'),
	(630243, 133, '2015-01-01 00:51:30.000000', 'consum', 0.0237, 'lps'),
	(630244, 133, '2015-01-01 00:51:31.000000', 'consum', 0.0221, 'lps'),
	(630245, 133, '2015-01-01 00:51:32.000000', 'consum', 0.0217, 'lps'),
	(630246, 133, '2015-01-01 00:51:33.000000', 'consum', 0.0212, 'lps'),
	(630247, 133, '2015-01-01 00:51:34.000000', 'consum', 0.0231, 'lps'),
	(630248, 133, '2015-01-01 00:51:35.000000', 'consum', 0.0212, 'lps'),
	(630249, 133, '2015-01-01 00:51:36.000000', 'consum', 0.0224, 'lps'),
	(630250, 133, '2015-01-01 00:51:37.000000', 'consum', 0.0241, 'lps'),
	(630251, 133, '2015-01-01 00:51:38.000000', 'consum', 0.0229, 'lps'),
	(630252, 133, '2015-01-01 00:51:39.000000', 'consum', 0.0213, 'lps'),
	(630253, 133, '2015-01-01 00:51:40.000000', 'consum', 0.0232, 'lps'),
	(630254, 133, '2015-01-01 00:51:41.000000', 'consum', 0.0214, 'lps'),
	(630255, 133, '2015-01-01 00:51:42.000000', 'consum', 0.0231, 'lps'),
	(630256, 133, '2015-01-01 00:51:43.000000', 'consum', 0.0238, 'lps'),
	(630257, 133, '2015-01-01 00:51:44.000000', 'consum', 0.0224, 'lps'),
	(630258, 133, '2015-01-01 00:51:45.000000', 'consum', 0.0227, 'lps'),
	(630259, 133, '2015-01-01 00:51:46.000000', 'consum', 0.0223, 'lps'),
	(630260, 133, '2015-01-01 00:51:47.000000', 'consum', 0.0225, 'lps'),
	(630261, 133, '2015-01-01 00:51:48.000000', 'consum', 0.0212, 'lps'),
	(630262, 133, '2015-01-01 00:51:49.000000', 'consum', 0.0240, 'lps'),
	(630263, 133, '2015-01-01 00:51:50.000000', 'consum', 0.0228, 'lps'),
	(630264, 133, '2015-01-01 00:51:51.000000', 'consum', 0.0210, 'lps'),
	(630265, 133, '2015-01-01 00:51:52.000000', 'consum', 0.0221, 'lps'),
	(630266, 133, '2015-01-01 00:51:53.000000', 'consum', 0.0234, 'lps'),
	(630267, 133, '2015-01-01 00:51:54.000000', 'consum', 0.0232, 'lps'),
	(630268, 133, '2015-01-01 00:51:55.000000', 'consum', 0.0219, 'lps'),
	(630269, 133, '2015-01-01 00:51:56.000000', 'consum', 0.0221, 'lps'),
	(630270, 133, '2015-01-01 00:51:57.000000', 'consum', 0.0238, 'lps'),
	(630271, 133, '2015-01-01 00:51:58.000000', 'consum', 0.0223, 'lps'),
	(630272, 133, '2015-01-01 00:51:59.000000', 'consum', 0.0224, 'lps'),
	(630273, 133, '2015-01-01 00:52:00.000000', 'consum', 0.0241, 'lps'),
	(630274, 133, '2015-01-01 00:52:01.000000', 'consum', 0.0227, 'lps'),
	(630275, 133, '2015-01-01 00:52:02.000000', 'consum', 0.0235, 'lps'),
	(630276, 133, '2015-01-01 00:52:03.000000', 'consum', 0.0220, 'lps'),
	(630277, 133, '2015-01-01 00:52:04.000000', 'consum', 0.0218, 'lps'),
	(630278, 133, '2015-01-01 00:52:05.000000', 'consum', 0.0222, 'lps'),
	(630279, 133, '2015-01-01 00:52:06.000000', 'consum', 0.0213, 'lps'),
	(630280, 133, '2015-01-01 00:52:07.000000', 'consum', 0.0222, 'lps'),
	(630281, 133, '2015-01-01 00:52:08.000000', 'consum', 0.0228, 'lps'),
	(630282, 133, '2015-01-01 00:52:09.000000', 'consum', 0.0232, 'lps'),
	(630283, 133, '2015-01-01 00:52:10.000000', 'consum', 0.0236, 'lps'),
	(630284, 133, '2015-01-01 00:52:11.000000', 'consum', 0.0211, 'lps'),
	(630285, 133, '2015-01-01 00:52:12.000000', 'consum', 0.0234, 'lps'),
	(630286, 133, '2015-01-01 00:52:13.000000', 'consum', 0.0229, 'lps'),
	(630287, 133, '2015-01-01 00:52:14.000000', 'consum', 0.0236, 'lps'),
	(630288, 133, '2015-01-01 00:52:15.000000', 'consum', 0.0217, 'lps'),
	(630289, 133, '2015-01-01 00:52:16.000000', 'consum', 0.0232, 'lps'),
	(630290, 133, '2015-01-01 00:52:17.000000', 'consum', 0.0235, 'lps'),
	(630291, 133, '2015-01-01 00:52:18.000000', 'consum', 0.0238, 'lps'),
	(630292, 133, '2015-01-01 00:52:19.000000', 'consum', 0.0210, 'lps'),
	(630293, 133, '2015-01-01 00:52:20.000000', 'consum', 0.0224, 'lps'),
	(630294, 133, '2015-01-01 00:52:21.000000', 'consum', 0.0214, 'lps'),
	(630295, 133, '2015-01-01 00:52:22.000000', 'consum', 0.0223, 'lps'),
	(630296, 133, '2015-01-01 00:52:23.000000', 'consum', 0.0230, 'lps'),
	(630297, 133, '2015-01-01 00:52:24.000000', 'consum', 0.0238, 'lps'),
	(630298, 133, '2015-01-01 00:52:25.000000', 'consum', 0.0228, 'lps'),
	(630299, 133, '2015-01-01 00:52:26.000000', 'consum', 0.0216, 'lps'),
	(630300, 133, '2015-01-01 00:52:27.000000', 'consum', 0.0220, 'lps'),
	(630301, 133, '2015-01-01 00:52:28.000000', 'consum', 0.0241, 'lps'),
	(630302, 133, '2015-01-01 00:52:29.000000', 'consum', 0.0240, 'lps'),
	(630303, 133, '2015-01-01 00:52:30.000000', 'consum', 0.0235, 'lps'),
	(630304, 133, '2015-01-01 00:52:31.000000', 'consum', 0.0214, 'lps'),
	(630305, 133, '2015-01-01 00:52:32.000000', 'consum', 0.0219, 'lps'),
	(630306, 133, '2015-01-01 00:52:33.000000', 'consum', 0.0214, 'lps'),
	(630307, 133, '2015-01-01 00:52:34.000000', 'consum', 0.0232, 'lps'),
	(630308, 133, '2015-01-01 00:52:35.000000', 'consum', 0.0214, 'lps'),
	(630309, 133, '2015-01-01 00:52:36.000000', 'consum', 0.0230, 'lps'),
	(630310, 133, '2015-01-01 00:52:37.000000', 'consum', 0.0232, 'lps'),
	(630311, 133, '2015-01-01 00:52:38.000000', 'consum', 0.0230, 'lps'),
	(630312, 133, '2015-01-01 00:52:39.000000', 'consum', 0.0214, 'lps'),
	(630313, 133, '2015-01-01 00:52:40.000000', 'consum', 0.0232, 'lps'),
	(630314, 133, '2015-01-01 00:52:41.000000', 'consum', 0.0213, 'lps'),
	(630315, 133, '2015-01-01 00:52:42.000000', 'consum', 0.0222, 'lps'),
	(630316, 133, '2015-01-01 00:52:43.000000', 'consum', 0.0230, 'lps'),
	(630317, 133, '2015-01-01 00:52:44.000000', 'consum', 0.0210, 'lps'),
	(630318, 133, '2015-01-01 00:52:45.000000', 'consum', 0.0214, 'lps'),
	(630319, 133, '2015-01-01 00:52:46.000000', 'consum', 0.0233, 'lps'),
	(630320, 133, '2015-01-01 00:52:47.000000', 'consum', 0.0218, 'lps'),
	(630321, 133, '2015-01-01 00:52:48.000000', 'consum', 0.0212, 'lps'),
	(630322, 133, '2015-01-01 00:52:49.000000', 'consum', 0.0230, 'lps'),
	(630323, 133, '2015-01-01 00:52:50.000000', 'consum', 0.0238, 'lps'),
	(630324, 133, '2015-01-01 00:52:51.000000', 'consum', 0.0228, 'lps'),
	(630325, 133, '2015-01-01 00:52:52.000000', 'consum', 0.0215, 'lps'),
	(630326, 133, '2015-01-01 00:52:53.000000', 'consum', 0.0216, 'lps'),
	(630327, 133, '2015-01-01 00:52:54.000000', 'consum', 0.0226, 'lps'),
	(630328, 133, '2015-01-01 00:52:55.000000', 'consum', 0.0237, 'lps'),
	(630329, 133, '2015-01-01 00:52:56.000000', 'consum', 0.0237, 'lps'),
	(630330, 133, '2015-01-01 00:52:57.000000', 'consum', 0.0229, 'lps'),
	(630331, 133, '2015-01-01 00:52:58.000000', 'consum', 0.0227, 'lps'),
	(630332, 133, '2015-01-01 00:52:59.000000', 'consum', 0.0237, 'lps'),
	(630333, 133, '2015-01-01 00:53:00.000000', 'consum', 0.0230, 'lps'),
	(630334, 133, '2015-01-01 00:53:01.000000', 'consum', 0.0232, 'lps'),
	(630335, 133, '2015-01-01 00:53:02.000000', 'consum', 0.0227, 'lps'),
	(630336, 133, '2015-01-01 00:53:03.000000', 'consum', 0.0228, 'lps'),
	(630337, 133, '2015-01-01 00:53:04.000000', 'consum', 0.0218, 'lps'),
	(630338, 133, '2015-01-01 00:53:05.000000', 'consum', 0.0229, 'lps'),
	(630339, 133, '2015-01-01 00:53:06.000000', 'consum', 0.0219, 'lps'),
	(630340, 133, '2015-01-01 00:53:07.000000', 'consum', 0.0228, 'lps'),
	(630341, 133, '2015-01-01 00:53:08.000000', 'consum', 0.0241, 'lps'),
	(630342, 133, '2015-01-01 00:53:09.000000', 'consum', 0.0215, 'lps'),
	(630343, 133, '2015-01-01 00:53:10.000000', 'consum', 0.0210, 'lps'),
	(630344, 133, '2015-01-01 00:53:11.000000', 'consum', 0.0225, 'lps'),
	(630345, 133, '2015-01-01 00:53:12.000000', 'consum', 0.0220, 'lps'),
	(630346, 133, '2015-01-01 00:53:13.000000', 'consum', 0.0218, 'lps'),
	(630347, 133, '2015-01-01 00:53:14.000000', 'consum', 0.0220, 'lps'),
	(630348, 133, '2015-01-01 00:53:15.000000', 'consum', 0.0237, 'lps'),
	(630349, 133, '2015-01-01 00:53:16.000000', 'consum', 0.0219, 'lps'),
	(630350, 133, '2015-01-01 00:53:17.000000', 'consum', 0.0237, 'lps'),
	(630351, 133, '2015-01-01 00:53:18.000000', 'consum', 0.0225, 'lps'),
	(630352, 133, '2015-01-01 00:53:19.000000', 'consum', 0.0237, 'lps'),
	(630353, 133, '2015-01-01 00:53:20.000000', 'consum', 0.0236, 'lps'),
	(630354, 133, '2015-01-01 00:53:21.000000', 'consum', 0.0225, 'lps'),
	(630355, 133, '2015-01-01 00:53:22.000000', 'consum', 0.0211, 'lps'),
	(630356, 133, '2015-01-01 00:53:23.000000', 'consum', 0.0232, 'lps'),
	(630357, 133, '2015-01-01 00:53:24.000000', 'consum', 0.0221, 'lps'),
	(630358, 133, '2015-01-01 00:53:25.000000', 'consum', 0.0234, 'lps'),
	(630359, 133, '2015-01-01 00:53:26.000000', 'consum', 0.0233, 'lps'),
	(630360, 133, '2015-01-01 00:53:27.000000', 'consum', 0.0223, 'lps'),
	(630361, 133, '2015-01-01 00:53:28.000000', 'consum', 0.0238, 'lps'),
	(630362, 133, '2015-01-01 00:53:29.000000', 'consum', 0.0214, 'lps'),
	(630363, 133, '2015-01-01 00:53:30.000000', 'consum', 0.0241, 'lps'),
	(630364, 133, '2015-01-01 00:53:31.000000', 'consum', 0.0228, 'lps'),
	(630365, 133, '2015-01-01 00:53:32.000000', 'consum', 0.0238, 'lps'),
	(630366, 133, '2015-01-01 00:53:33.000000', 'consum', 0.0235, 'lps'),
	(630367, 133, '2015-01-01 00:53:34.000000', 'consum', 0.0217, 'lps'),
	(630368, 133, '2015-01-01 00:53:35.000000', 'consum', 0.0235, 'lps'),
	(630369, 133, '2015-01-01 00:53:36.000000', 'consum', 0.0218, 'lps'),
	(630370, 133, '2015-01-01 00:53:37.000000', 'consum', 0.0240, 'lps'),
	(630371, 133, '2015-01-01 00:53:38.000000', 'consum', 0.0210, 'lps'),
	(630372, 133, '2015-01-01 00:53:39.000000', 'consum', 0.0216, 'lps'),
	(630373, 133, '2015-01-01 00:53:40.000000', 'consum', 0.0241, 'lps'),
	(630374, 133, '2015-01-01 00:53:41.000000', 'consum', 0.0220, 'lps'),
	(630375, 133, '2015-01-01 00:53:42.000000', 'consum', 0.0229, 'lps'),
	(630376, 133, '2015-01-01 00:53:43.000000', 'consum', 0.0213, 'lps'),
	(630377, 133, '2015-01-01 00:53:44.000000', 'consum', 0.0233, 'lps'),
	(630378, 133, '2015-01-01 00:53:45.000000', 'consum', 0.0220, 'lps'),
	(630379, 133, '2015-01-01 00:53:46.000000', 'consum', 0.0222, 'lps'),
	(630380, 133, '2015-01-01 00:53:47.000000', 'consum', 0.0211, 'lps'),
	(630381, 133, '2015-01-01 00:53:48.000000', 'consum', 0.0212, 'lps'),
	(630382, 133, '2015-01-01 00:53:49.000000', 'consum', 0.0216, 'lps'),
	(630383, 133, '2015-01-01 00:53:50.000000', 'consum', 0.0233, 'lps'),
	(630384, 133, '2015-01-01 00:53:51.000000', 'consum', 0.0215, 'lps'),
	(630385, 133, '2015-01-01 00:53:52.000000', 'consum', 0.0227, 'lps'),
	(630386, 133, '2015-01-01 00:53:53.000000', 'consum', 0.0219, 'lps'),
	(630387, 133, '2015-01-01 00:53:54.000000', 'consum', 0.0238, 'lps'),
	(630388, 133, '2015-01-01 00:53:55.000000', 'consum', 0.0224, 'lps'),
	(630389, 133, '2015-01-01 00:53:56.000000', 'consum', 0.0229, 'lps'),
	(630390, 133, '2015-01-01 00:53:57.000000', 'consum', 0.0232, 'lps'),
	(630391, 133, '2015-01-01 00:53:58.000000', 'consum', 0.0230, 'lps'),
	(630392, 133, '2015-01-01 00:53:59.000000', 'consum', 0.0211, 'lps'),
	(630393, 133, '2015-01-01 00:54:00.000000', 'consum', 0.0223, 'lps'),
	(630394, 133, '2015-01-01 00:54:01.000000', 'consum', 0.0240, 'lps'),
	(630395, 133, '2015-01-01 00:54:02.000000', 'consum', 0.0226, 'lps'),
	(630396, 133, '2015-01-01 00:54:03.000000', 'consum', 0.0230, 'lps'),
	(630397, 133, '2015-01-01 00:54:04.000000', 'consum', 0.0233, 'lps'),
	(630398, 133, '2015-01-01 00:54:05.000000', 'consum', 0.0233, 'lps'),
	(630399, 133, '2015-01-01 00:54:06.000000', 'consum', 0.0225, 'lps'),
	(630400, 133, '2015-01-01 00:54:07.000000', 'consum', 0.0214, 'lps'),
	(630401, 133, '2015-01-01 00:54:08.000000', 'consum', 0.0220, 'lps'),
	(630402, 133, '2015-01-01 00:54:09.000000', 'consum', 0.0217, 'lps'),
	(630403, 133, '2015-01-01 00:54:10.000000', 'consum', 0.0217, 'lps'),
	(630404, 133, '2015-01-01 00:54:11.000000', 'consum', 0.0221, 'lps'),
	(630405, 133, '2015-01-01 00:54:12.000000', 'consum', 0.0213, 'lps'),
	(630406, 133, '2015-01-01 00:54:13.000000', 'consum', 0.0226, 'lps'),
	(630407, 133, '2015-01-01 00:54:14.000000', 'consum', 0.0217, 'lps'),
	(630408, 133, '2015-01-01 00:54:15.000000', 'consum', 0.0230, 'lps'),
	(630409, 133, '2015-01-01 00:54:16.000000', 'consum', 0.0223, 'lps'),
	(630410, 133, '2015-01-01 00:54:17.000000', 'consum', 0.0218, 'lps'),
	(630411, 133, '2015-01-01 00:54:18.000000', 'consum', 0.0210, 'lps'),
	(630412, 133, '2015-01-01 00:54:19.000000', 'consum', 0.0217, 'lps'),
	(630413, 133, '2015-01-01 00:54:20.000000', 'consum', 0.0216, 'lps'),
	(630414, 133, '2015-01-01 00:54:21.000000', 'consum', 0.0220, 'lps'),
	(630415, 133, '2015-01-01 00:54:22.000000', 'consum', 0.0211, 'lps'),
	(630416, 133, '2015-01-01 00:54:23.000000', 'consum', 0.0215, 'lps'),
	(630417, 133, '2015-01-01 00:54:24.000000', 'consum', 0.0235, 'lps'),
	(630418, 133, '2015-01-01 00:54:25.000000', 'consum', 0.0222, 'lps'),
	(630419, 133, '2015-01-01 00:54:26.000000', 'consum', 0.0228, 'lps'),
	(630420, 133, '2015-01-01 00:54:27.000000', 'consum', 0.0231, 'lps'),
	(630421, 133, '2015-01-01 00:54:28.000000', 'consum', 0.0232, 'lps'),
	(630422, 133, '2015-01-01 00:54:29.000000', 'consum', 0.0223, 'lps'),
	(630423, 133, '2015-01-01 00:54:30.000000', 'consum', 0.0211, 'lps'),
	(630424, 133, '2015-01-01 00:54:31.000000', 'consum', 0.0238, 'lps'),
	(630425, 133, '2015-01-01 00:54:32.000000', 'consum', 0.0223, 'lps'),
	(630426, 133, '2015-01-01 00:54:33.000000', 'consum', 0.0221, 'lps'),
	(630427, 133, '2015-01-01 00:54:34.000000', 'consum', 0.0226, 'lps'),
	(630428, 133, '2015-01-01 00:54:35.000000', 'consum', 0.0226, 'lps'),
	(630429, 133, '2015-01-01 00:54:36.000000', 'consum', 0.0211, 'lps'),
	(630430, 133, '2015-01-01 00:54:37.000000', 'consum', 0.0232, 'lps'),
	(630431, 133, '2015-01-01 00:54:38.000000', 'consum', 0.0219, 'lps'),
	(630432, 133, '2015-01-01 00:54:39.000000', 'consum', 0.0223, 'lps'),
	(630433, 133, '2015-01-01 00:54:40.000000', 'consum', 0.0215, 'lps'),
	(630434, 133, '2015-01-01 00:54:41.000000', 'consum', 0.0228, 'lps'),
	(630435, 133, '2015-01-01 00:54:42.000000', 'consum', 0.0222, 'lps'),
	(630436, 133, '2015-01-01 00:54:43.000000', 'consum', 0.0217, 'lps'),
	(630437, 133, '2015-01-01 00:54:44.000000', 'consum', 0.0240, 'lps'),
	(630438, 133, '2015-01-01 00:54:45.000000', 'consum', 0.0213, 'lps'),
	(630439, 133, '2015-01-01 00:54:46.000000', 'consum', 0.0232, 'lps'),
	(630440, 133, '2015-01-01 00:54:47.000000', 'consum', 0.0215, 'lps'),
	(630441, 133, '2015-01-01 00:54:48.000000', 'consum', 0.0235, 'lps'),
	(630442, 133, '2015-01-01 00:54:49.000000', 'consum', 0.0221, 'lps'),
	(630443, 133, '2015-01-01 00:54:50.000000', 'consum', 0.0226, 'lps'),
	(630444, 133, '2015-01-01 00:54:51.000000', 'consum', 0.0224, 'lps'),
	(630445, 133, '2015-01-01 00:54:52.000000', 'consum', 0.0234, 'lps'),
	(630446, 133, '2015-01-01 00:54:53.000000', 'consum', 0.0223, 'lps'),
	(630447, 133, '2015-01-01 00:54:54.000000', 'consum', 0.0234, 'lps'),
	(630448, 133, '2015-01-01 00:54:55.000000', 'consum', 0.0229, 'lps'),
	(630449, 133, '2015-01-01 00:54:56.000000', 'consum', 0.0234, 'lps'),
	(630450, 133, '2015-01-01 00:54:57.000000', 'consum', 0.0241, 'lps'),
	(630451, 133, '2015-01-01 00:54:58.000000', 'consum', 0.0229, 'lps'),
	(630452, 133, '2015-01-01 00:54:59.000000', 'consum', 0.0212, 'lps'),
	(630453, 133, '2015-01-01 00:55:00.000000', 'consum', 0.0230, 'lps'),
	(630454, 133, '2015-01-01 00:55:01.000000', 'consum', 0.0240, 'lps'),
	(630455, 133, '2015-01-01 00:55:02.000000', 'consum', 0.0235, 'lps'),
	(630456, 133, '2015-01-01 00:55:03.000000', 'consum', 0.0216, 'lps'),
	(630457, 133, '2015-01-01 00:55:04.000000', 'consum', 0.0226, 'lps'),
	(630458, 133, '2015-01-01 00:55:05.000000', 'consum', 0.0211, 'lps'),
	(630459, 133, '2015-01-01 00:55:06.000000', 'consum', 0.0229, 'lps'),
	(630460, 133, '2015-01-01 00:55:07.000000', 'consum', 0.0239, 'lps'),
	(630461, 133, '2015-01-01 00:55:08.000000', 'consum', 0.0233, 'lps'),
	(630462, 133, '2015-01-01 00:55:09.000000', 'consum', 0.0241, 'lps'),
	(630463, 133, '2015-01-01 00:55:10.000000', 'consum', 0.0233, 'lps'),
	(630464, 133, '2015-01-01 00:55:11.000000', 'consum', 0.0233, 'lps'),
	(630465, 133, '2015-01-01 00:55:12.000000', 'consum', 0.0225, 'lps'),
	(630466, 133, '2015-01-01 00:55:13.000000', 'consum', 0.0215, 'lps'),
	(630467, 133, '2015-01-01 00:55:14.000000', 'consum', 0.0222, 'lps'),
	(630468, 133, '2015-01-01 00:55:15.000000', 'consum', 0.0223, 'lps'),
	(630469, 133, '2015-01-01 00:55:16.000000', 'consum', 0.0210, 'lps'),
	(630470, 133, '2015-01-01 00:55:17.000000', 'consum', 0.0236, 'lps'),
	(630471, 133, '2015-01-01 00:55:18.000000', 'consum', 0.0211, 'lps'),
	(630472, 133, '2015-01-01 00:55:19.000000', 'consum', 0.0234, 'lps'),
	(630473, 133, '2015-01-01 00:55:20.000000', 'consum', 0.0233, 'lps'),
	(630474, 133, '2015-01-01 00:55:21.000000', 'consum', 0.0220, 'lps'),
	(630475, 133, '2015-01-01 00:55:22.000000', 'consum', 0.0222, 'lps'),
	(630476, 133, '2015-01-01 00:55:23.000000', 'consum', 0.0240, 'lps'),
	(630477, 133, '2015-01-01 00:55:24.000000', 'consum', 0.0231, 'lps'),
	(630478, 133, '2015-01-01 00:55:25.000000', 'consum', 0.0225, 'lps'),
	(630479, 133, '2015-01-01 00:55:26.000000', 'consum', 0.0222, 'lps'),
	(630480, 133, '2015-01-01 00:55:27.000000', 'consum', 0.0224, 'lps'),
	(630481, 133, '2015-01-01 00:55:28.000000', 'consum', 0.0215, 'lps'),
	(630482, 133, '2015-01-01 00:55:29.000000', 'consum', 0.0226, 'lps'),
	(630483, 133, '2015-01-01 00:55:30.000000', 'consum', 0.0212, 'lps'),
	(630484, 133, '2015-01-01 00:55:31.000000', 'consum', 0.0233, 'lps'),
	(630485, 133, '2015-01-01 00:55:32.000000', 'consum', 0.0227, 'lps'),
	(630486, 133, '2015-01-01 00:55:33.000000', 'consum', 0.0225, 'lps'),
	(630487, 133, '2015-01-01 00:55:34.000000', 'consum', 0.0235, 'lps'),
	(630488, 133, '2015-01-01 00:55:35.000000', 'consum', 0.0226, 'lps'),
	(630489, 133, '2015-01-01 00:55:36.000000', 'consum', 0.0216, 'lps'),
	(630490, 133, '2015-01-01 00:55:37.000000', 'consum', 0.0223, 'lps'),
	(630491, 133, '2015-01-01 00:55:38.000000', 'consum', 0.0225, 'lps'),
	(630492, 133, '2015-01-01 00:55:39.000000', 'consum', 0.0215, 'lps'),
	(630493, 133, '2015-01-01 00:55:40.000000', 'consum', 0.0224, 'lps'),
	(630494, 133, '2015-01-01 00:55:41.000000', 'consum', 0.0233, 'lps'),
	(630495, 133, '2015-01-01 00:55:42.000000', 'consum', 0.0218, 'lps'),
	(630496, 133, '2015-01-01 00:55:43.000000', 'consum', 0.0212, 'lps'),
	(630497, 133, '2015-01-01 00:55:44.000000', 'consum', 0.0232, 'lps'),
	(630498, 133, '2015-01-01 00:55:45.000000', 'consum', 0.0217, 'lps'),
	(630499, 133, '2015-01-01 00:55:46.000000', 'consum', 0.0210, 'lps'),
	(630500, 133, '2015-01-01 00:55:47.000000', 'consum', 0.0223, 'lps'),
	(630501, 133, '2015-01-01 00:55:48.000000', 'consum', 0.0212, 'lps'),
	(630502, 133, '2015-01-01 00:55:49.000000', 'consum', 0.0211, 'lps'),
	(630503, 133, '2015-01-01 00:55:50.000000', 'consum', 0.0212, 'lps'),
	(630504, 133, '2015-01-01 00:55:51.000000', 'consum', 0.0217, 'lps'),
	(630505, 133, '2015-01-01 00:55:52.000000', 'consum', 0.0241, 'lps'),
	(630506, 133, '2015-01-01 00:55:53.000000', 'consum', 0.0213, 'lps'),
	(630507, 133, '2015-01-01 00:55:54.000000', 'consum', 0.0232, 'lps'),
	(630508, 133, '2015-01-01 00:55:55.000000', 'consum', 0.0215, 'lps'),
	(630509, 133, '2015-01-01 00:55:56.000000', 'consum', 0.0232, 'lps'),
	(630510, 133, '2015-01-01 00:55:57.000000', 'consum', 0.0212, 'lps'),
	(630511, 133, '2015-01-01 00:55:58.000000', 'consum', 0.0217, 'lps'),
	(630512, 133, '2015-01-01 00:55:59.000000', 'consum', 0.0239, 'lps'),
	(630513, 133, '2015-01-01 00:56:00.000000', 'consum', 0.0240, 'lps'),
	(630514, 133, '2015-01-01 00:56:01.000000', 'consum', 0.0240, 'lps'),
	(630515, 133, '2015-01-01 00:56:02.000000', 'consum', 0.0240, 'lps'),
	(630516, 133, '2015-01-01 00:56:03.000000', 'consum', 0.0238, 'lps'),
	(630517, 133, '2015-01-01 00:56:04.000000', 'consum', 0.0230, 'lps'),
	(630518, 133, '2015-01-01 00:56:05.000000', 'consum', 0.0227, 'lps'),
	(630519, 133, '2015-01-01 00:56:06.000000', 'consum', 0.0236, 'lps'),
	(630520, 133, '2015-01-01 00:56:07.000000', 'consum', 0.0226, 'lps'),
	(630521, 133, '2015-01-01 00:56:08.000000', 'consum', 0.0211, 'lps'),
	(630522, 133, '2015-01-01 00:56:09.000000', 'consum', 0.0233, 'lps'),
	(630523, 133, '2015-01-01 00:56:10.000000', 'consum', 0.0226, 'lps'),
	(630524, 133, '2015-01-01 00:56:11.000000', 'consum', 0.0219, 'lps'),
	(630525, 133, '2015-01-01 00:56:12.000000', 'consum', 0.0211, 'lps'),
	(630526, 133, '2015-01-01 00:56:13.000000', 'consum', 0.0220, 'lps'),
	(630527, 133, '2015-01-01 00:56:14.000000', 'consum', 0.0225, 'lps'),
	(630528, 133, '2015-01-01 00:56:15.000000', 'consum', 0.0224, 'lps'),
	(630529, 133, '2015-01-01 00:56:16.000000', 'consum', 0.0235, 'lps'),
	(630530, 133, '2015-01-01 00:56:17.000000', 'consum', 0.0231, 'lps'),
	(630531, 133, '2015-01-01 00:56:18.000000', 'consum', 0.0237, 'lps'),
	(630532, 133, '2015-01-01 00:56:19.000000', 'consum', 0.0222, 'lps'),
	(630533, 133, '2015-01-01 00:56:20.000000', 'consum', 0.0219, 'lps'),
	(630534, 133, '2015-01-01 00:56:21.000000', 'consum', 0.0222, 'lps'),
	(630535, 133, '2015-01-01 00:56:22.000000', 'consum', 0.0210, 'lps'),
	(630536, 133, '2015-01-01 00:56:23.000000', 'consum', 0.0240, 'lps'),
	(630537, 133, '2015-01-01 00:56:24.000000', 'consum', 0.0230, 'lps'),
	(630538, 133, '2015-01-01 00:56:25.000000', 'consum', 0.0222, 'lps'),
	(630539, 133, '2015-01-01 00:56:26.000000', 'consum', 0.0210, 'lps'),
	(630540, 133, '2015-01-01 00:56:27.000000', 'consum', 0.0241, 'lps'),
	(630541, 133, '2015-01-01 00:56:28.000000', 'consum', 0.0234, 'lps'),
	(630542, 133, '2015-01-01 00:56:29.000000', 'consum', 0.0240, 'lps'),
	(630543, 133, '2015-01-01 00:56:30.000000', 'consum', 0.0224, 'lps'),
	(630544, 133, '2015-01-01 00:56:31.000000', 'consum', 0.0222, 'lps'),
	(630545, 133, '2015-01-01 00:56:32.000000', 'consum', 0.0228, 'lps'),
	(630546, 133, '2015-01-01 00:56:33.000000', 'consum', 0.0232, 'lps'),
	(630547, 133, '2015-01-01 00:56:34.000000', 'consum', 0.0234, 'lps'),
	(630548, 133, '2015-01-01 00:56:35.000000', 'consum', 0.0235, 'lps'),
	(630549, 133, '2015-01-01 00:56:36.000000', 'consum', 0.0229, 'lps'),
	(630550, 133, '2015-01-01 00:56:37.000000', 'consum', 0.0232, 'lps'),
	(630551, 133, '2015-01-01 00:56:38.000000', 'consum', 0.0231, 'lps'),
	(630552, 133, '2015-01-01 00:56:39.000000', 'consum', 0.0219, 'lps'),
	(630553, 133, '2015-01-01 00:56:40.000000', 'consum', 0.0225, 'lps'),
	(630554, 133, '2015-01-01 00:56:41.000000', 'consum', 0.0226, 'lps'),
	(630555, 133, '2015-01-01 00:56:42.000000', 'consum', 0.0214, 'lps'),
	(630556, 133, '2015-01-01 00:56:43.000000', 'consum', 0.0213, 'lps'),
	(630557, 133, '2015-01-01 00:56:44.000000', 'consum', 0.0214, 'lps'),
	(630558, 133, '2015-01-01 00:56:45.000000', 'consum', 0.0223, 'lps'),
	(630559, 133, '2015-01-01 00:56:46.000000', 'consum', 0.0231, 'lps'),
	(630560, 133, '2015-01-01 00:56:47.000000', 'consum', 0.0214, 'lps'),
	(630561, 133, '2015-01-01 00:56:48.000000', 'consum', 0.0229, 'lps'),
	(630562, 133, '2015-01-01 00:56:49.000000', 'consum', 0.0230, 'lps'),
	(630563, 133, '2015-01-01 00:56:50.000000', 'consum', 0.0224, 'lps'),
	(630564, 133, '2015-01-01 00:56:51.000000', 'consum', 0.0217, 'lps'),
	(630565, 133, '2015-01-01 00:56:52.000000', 'consum', 0.0238, 'lps'),
	(630566, 133, '2015-01-01 00:56:53.000000', 'consum', 0.0233, 'lps'),
	(630567, 133, '2015-01-01 00:56:54.000000', 'consum', 0.0239, 'lps'),
	(630568, 133, '2015-01-01 00:56:55.000000', 'consum', 0.0226, 'lps'),
	(630569, 133, '2015-01-01 00:56:56.000000', 'consum', 0.0235, 'lps'),
	(630570, 133, '2015-01-01 00:56:57.000000', 'consum', 0.0222, 'lps'),
	(630571, 133, '2015-01-01 00:56:58.000000', 'consum', 0.0230, 'lps'),
	(630572, 133, '2015-01-01 00:56:59.000000', 'consum', 0.0239, 'lps'),
	(630573, 133, '2015-01-01 00:57:00.000000', 'consum', 0.0234, 'lps'),
	(630574, 133, '2015-01-01 00:57:01.000000', 'consum', 0.0213, 'lps'),
	(630575, 133, '2015-01-01 00:57:02.000000', 'consum', 0.0216, 'lps'),
	(630576, 133, '2015-01-01 00:57:03.000000', 'consum', 0.0231, 'lps'),
	(630577, 133, '2015-01-01 00:57:04.000000', 'consum', 0.0234, 'lps'),
	(630578, 133, '2015-01-01 00:57:05.000000', 'consum', 0.0233, 'lps'),
	(630579, 133, '2015-01-01 00:57:06.000000', 'consum', 0.0225, 'lps'),
	(630580, 133, '2015-01-01 00:57:07.000000', 'consum', 0.0216, 'lps'),
	(630581, 133, '2015-01-01 00:57:08.000000', 'consum', 0.0227, 'lps'),
	(630582, 133, '2015-01-01 00:57:09.000000', 'consum', 0.0211, 'lps'),
	(630583, 133, '2015-01-01 00:57:10.000000', 'consum', 0.0232, 'lps'),
	(630584, 133, '2015-01-01 00:57:11.000000', 'consum', 0.0221, 'lps'),
	(630585, 133, '2015-01-01 00:57:12.000000', 'consum', 0.0231, 'lps'),
	(630586, 133, '2015-01-01 00:57:13.000000', 'consum', 0.0220, 'lps'),
	(630587, 133, '2015-01-01 00:57:14.000000', 'consum', 0.0230, 'lps'),
	(630588, 133, '2015-01-01 00:57:15.000000', 'consum', 0.0217, 'lps'),
	(630589, 133, '2015-01-01 00:57:16.000000', 'consum', 0.0216, 'lps'),
	(630590, 133, '2015-01-01 00:57:17.000000', 'consum', 0.0218, 'lps'),
	(630591, 133, '2015-01-01 00:57:18.000000', 'consum', 0.0233, 'lps'),
	(630592, 133, '2015-01-01 00:57:19.000000', 'consum', 0.0236, 'lps'),
	(630593, 133, '2015-01-01 00:57:20.000000', 'consum', 0.0241, 'lps'),
	(630594, 133, '2015-01-01 00:57:21.000000', 'consum', 0.0225, 'lps'),
	(630595, 133, '2015-01-01 00:57:22.000000', 'consum', 0.0224, 'lps'),
	(630596, 133, '2015-01-01 00:57:23.000000', 'consum', 0.0235, 'lps'),
	(630597, 133, '2015-01-01 00:57:24.000000', 'consum', 0.0231, 'lps'),
	(630598, 133, '2015-01-01 00:57:25.000000', 'consum', 0.0238, 'lps'),
	(630599, 133, '2015-01-01 00:57:26.000000', 'consum', 0.0226, 'lps'),
	(630600, 133, '2015-01-01 00:57:27.000000', 'consum', 0.0235, 'lps'),
	(630601, 133, '2015-01-01 00:57:28.000000', 'consum', 0.0227, 'lps'),
	(630602, 133, '2015-01-01 00:57:29.000000', 'consum', 0.0221, 'lps'),
	(630603, 133, '2015-01-01 00:57:30.000000', 'consum', 0.0212, 'lps'),
	(630604, 133, '2015-01-01 00:57:31.000000', 'consum', 0.0222, 'lps'),
	(630605, 133, '2015-01-01 00:57:32.000000', 'consum', 0.0232, 'lps'),
	(630606, 133, '2015-01-01 00:57:33.000000', 'consum', 0.0222, 'lps'),
	(630607, 133, '2015-01-01 00:57:34.000000', 'consum', 0.0234, 'lps'),
	(630608, 133, '2015-01-01 00:57:35.000000', 'consum', 0.0230, 'lps'),
	(630609, 133, '2015-01-01 00:57:36.000000', 'consum', 0.0241, 'lps'),
	(630610, 133, '2015-01-01 00:57:37.000000', 'consum', 0.0240, 'lps'),
	(630611, 133, '2015-01-01 00:57:38.000000', 'consum', 0.0234, 'lps'),
	(630612, 133, '2015-01-01 00:57:39.000000', 'consum', 0.0240, 'lps'),
	(630613, 133, '2015-01-01 00:57:40.000000', 'consum', 0.0228, 'lps'),
	(630614, 133, '2015-01-01 00:57:41.000000', 'consum', 0.0239, 'lps'),
	(630615, 133, '2015-01-01 00:57:42.000000', 'consum', 0.0240, 'lps'),
	(630616, 133, '2015-01-01 00:57:43.000000', 'consum', 0.0241, 'lps'),
	(630617, 133, '2015-01-01 00:57:44.000000', 'consum', 0.0211, 'lps'),
	(630618, 133, '2015-01-01 00:57:45.000000', 'consum', 0.0219, 'lps'),
	(630619, 133, '2015-01-01 00:57:46.000000', 'consum', 0.0219, 'lps'),
	(630620, 133, '2015-01-01 00:57:47.000000', 'consum', 0.0230, 'lps'),
	(630621, 133, '2015-01-01 00:57:48.000000', 'consum', 0.0221, 'lps'),
	(630622, 133, '2015-01-01 00:57:49.000000', 'consum', 0.0237, 'lps'),
	(630623, 133, '2015-01-01 00:57:50.000000', 'consum', 0.0214, 'lps'),
	(630624, 133, '2015-01-01 00:57:51.000000', 'consum', 0.0214, 'lps'),
	(630625, 133, '2015-01-01 00:57:52.000000', 'consum', 0.0221, 'lps'),
	(630626, 133, '2015-01-01 00:57:53.000000', 'consum', 0.0219, 'lps'),
	(630627, 133, '2015-01-01 00:57:54.000000', 'consum', 0.0224, 'lps'),
	(630628, 133, '2015-01-01 00:57:55.000000', 'consum', 0.0220, 'lps'),
	(630629, 133, '2015-01-01 00:57:56.000000', 'consum', 0.0220, 'lps'),
	(630630, 133, '2015-01-01 00:57:57.000000', 'consum', 0.0229, 'lps'),
	(630631, 133, '2015-01-01 00:57:58.000000', 'consum', 0.0212, 'lps'),
	(630632, 133, '2015-01-01 00:57:59.000000', 'consum', 0.0230, 'lps'),
	(630633, 133, '2015-01-01 00:58:00.000000', 'consum', 0.0237, 'lps'),
	(630634, 133, '2015-01-01 00:58:01.000000', 'consum', 0.0222, 'lps'),
	(630635, 133, '2015-01-01 00:58:02.000000', 'consum', 0.0224, 'lps'),
	(630636, 133, '2015-01-01 00:58:03.000000', 'consum', 0.0210, 'lps'),
	(630637, 133, '2015-01-01 00:58:04.000000', 'consum', 0.0234, 'lps'),
	(630638, 133, '2015-01-01 00:58:05.000000', 'consum', 0.0235, 'lps'),
	(630639, 133, '2015-01-01 00:58:06.000000', 'consum', 0.0232, 'lps'),
	(630640, 133, '2015-01-01 00:58:07.000000', 'consum', 0.0211, 'lps'),
	(630641, 133, '2015-01-01 00:58:08.000000', 'consum', 0.0214, 'lps'),
	(630642, 133, '2015-01-01 00:58:09.000000', 'consum', 0.0230, 'lps'),
	(630643, 133, '2015-01-01 00:58:10.000000', 'consum', 0.0232, 'lps'),
	(630644, 133, '2015-01-01 00:58:11.000000', 'consum', 0.0231, 'lps'),
	(630645, 133, '2015-01-01 00:58:12.000000', 'consum', 0.0217, 'lps'),
	(630646, 133, '2015-01-01 00:58:13.000000', 'consum', 0.0216, 'lps'),
	(630647, 133, '2015-01-01 00:58:14.000000', 'consum', 0.0219, 'lps'),
	(630648, 133, '2015-01-01 00:58:15.000000', 'consum', 0.0235, 'lps'),
	(630649, 133, '2015-01-01 00:58:16.000000', 'consum', 0.0216, 'lps'),
	(630650, 133, '2015-01-01 00:58:17.000000', 'consum', 0.0226, 'lps'),
	(630651, 133, '2015-01-01 00:58:18.000000', 'consum', 0.0210, 'lps'),
	(630652, 133, '2015-01-01 00:58:19.000000', 'consum', 0.0225, 'lps'),
	(630653, 133, '2015-01-01 00:58:20.000000', 'consum', 0.0222, 'lps'),
	(630654, 133, '2015-01-01 00:58:21.000000', 'consum', 0.0226, 'lps'),
	(630655, 133, '2015-01-01 00:58:22.000000', 'consum', 0.0223, 'lps'),
	(630656, 133, '2015-01-01 00:58:23.000000', 'consum', 0.0227, 'lps'),
	(630657, 133, '2015-01-01 00:58:24.000000', 'consum', 0.0225, 'lps'),
	(630658, 133, '2015-01-01 00:58:25.000000', 'consum', 0.0234, 'lps'),
	(630659, 133, '2015-01-01 00:58:26.000000', 'consum', 0.0220, 'lps'),
	(630660, 133, '2015-01-01 00:58:27.000000', 'consum', 0.0223, 'lps'),
	(630661, 133, '2015-01-01 00:58:28.000000', 'consum', 0.0212, 'lps'),
	(630662, 133, '2015-01-01 00:58:29.000000', 'consum', 0.0212, 'lps'),
	(630663, 133, '2015-01-01 00:58:30.000000', 'consum', 0.0217, 'lps'),
	(630664, 133, '2015-01-01 00:58:31.000000', 'consum', 0.0238, 'lps'),
	(630665, 133, '2015-01-01 00:58:32.000000', 'consum', 0.0234, 'lps'),
	(630666, 133, '2015-01-01 00:58:33.000000', 'consum', 0.0216, 'lps'),
	(630667, 133, '2015-01-01 00:58:34.000000', 'consum', 0.0233, 'lps'),
	(630668, 133, '2015-01-01 00:58:35.000000', 'consum', 0.0241, 'lps'),
	(630669, 133, '2015-01-01 00:58:36.000000', 'consum', 0.0234, 'lps'),
	(630670, 133, '2015-01-01 00:58:37.000000', 'consum', 0.0236, 'lps'),
	(630671, 133, '2015-01-01 00:58:38.000000', 'consum', 0.0239, 'lps'),
	(630672, 133, '2015-01-01 00:58:39.000000', 'consum', 0.0212, 'lps'),
	(630673, 133, '2015-01-01 00:58:40.000000', 'consum', 0.0230, 'lps'),
	(630674, 133, '2015-01-01 00:58:41.000000', 'consum', 0.0239, 'lps'),
	(630675, 133, '2015-01-01 00:58:42.000000', 'consum', 0.0231, 'lps'),
	(630676, 133, '2015-01-01 00:58:43.000000', 'consum', 0.0228, 'lps'),
	(630677, 133, '2015-01-01 00:58:44.000000', 'consum', 0.0237, 'lps'),
	(630678, 133, '2015-01-01 00:58:45.000000', 'consum', 0.0229, 'lps'),
	(630679, 133, '2015-01-01 00:58:46.000000', 'consum', 0.0224, 'lps'),
	(630680, 133, '2015-01-01 00:58:47.000000', 'consum', 0.0222, 'lps'),
	(630681, 133, '2015-01-01 00:58:48.000000', 'consum', 0.0230, 'lps'),
	(630682, 133, '2015-01-01 00:58:49.000000', 'consum', 0.0210, 'lps'),
	(630683, 133, '2015-01-01 00:58:50.000000', 'consum', 0.0217, 'lps'),
	(630684, 133, '2015-01-01 00:58:51.000000', 'consum', 0.0210, 'lps'),
	(630685, 133, '2015-01-01 00:58:52.000000', 'consum', 0.0223, 'lps'),
	(630686, 133, '2015-01-01 00:58:53.000000', 'consum', 0.0213, 'lps'),
	(630687, 133, '2015-01-01 00:58:54.000000', 'consum', 0.0217, 'lps'),
	(630688, 133, '2015-01-01 00:58:55.000000', 'consum', 0.0235, 'lps'),
	(630689, 133, '2015-01-01 00:58:56.000000', 'consum', 0.0219, 'lps'),
	(630690, 133, '2015-01-01 00:58:57.000000', 'consum', 0.0213, 'lps'),
	(630691, 133, '2015-01-01 00:58:58.000000', 'consum', 0.0231, 'lps'),
	(630692, 133, '2015-01-01 00:58:59.000000', 'consum', 0.0241, 'lps'),
	(630693, 133, '2015-01-01 00:59:00.000000', 'consum', 0.0238, 'lps'),
	(630694, 133, '2015-01-01 00:59:01.000000', 'consum', 0.0224, 'lps'),
	(630695, 133, '2015-01-01 00:59:02.000000', 'consum', 0.0232, 'lps'),
	(630696, 133, '2015-01-01 00:59:03.000000', 'consum', 0.0211, 'lps'),
	(630697, 133, '2015-01-01 00:59:04.000000', 'consum', 0.0216, 'lps'),
	(630698, 133, '2015-01-01 00:59:05.000000', 'consum', 0.0237, 'lps'),
	(630699, 133, '2015-01-01 00:59:06.000000', 'consum', 0.0231, 'lps'),
	(630700, 133, '2015-01-01 00:59:07.000000', 'consum', 0.0234, 'lps'),
	(630701, 133, '2015-01-01 00:59:08.000000', 'consum', 0.0237, 'lps'),
	(630702, 133, '2015-01-01 00:59:09.000000', 'consum', 0.0239, 'lps'),
	(630703, 133, '2015-01-01 00:59:10.000000', 'consum', 0.0213, 'lps'),
	(630704, 133, '2015-01-01 00:59:11.000000', 'consum', 0.0234, 'lps'),
	(630705, 133, '2015-01-01 00:59:12.000000', 'consum', 0.0227, 'lps'),
	(630706, 133, '2015-01-01 00:59:13.000000', 'consum', 0.0224, 'lps'),
	(630707, 133, '2015-01-01 00:59:14.000000', 'consum', 0.0227, 'lps'),
	(630708, 133, '2015-01-01 00:59:15.000000', 'consum', 0.0222, 'lps'),
	(630709, 133, '2015-01-01 00:59:16.000000', 'consum', 0.0220, 'lps'),
	(630710, 133, '2015-01-01 00:59:17.000000', 'consum', 0.0225, 'lps'),
	(630711, 133, '2015-01-01 00:59:18.000000', 'consum', 0.0224, 'lps'),
	(630712, 133, '2015-01-01 00:59:19.000000', 'consum', 0.0234, 'lps'),
	(630713, 133, '2015-01-01 00:59:20.000000', 'consum', 0.0223, 'lps'),
	(630714, 133, '2015-01-01 00:59:21.000000', 'consum', 0.0238, 'lps'),
	(630715, 133, '2015-01-01 00:59:22.000000', 'consum', 0.0213, 'lps'),
	(630716, 133, '2015-01-01 00:59:23.000000', 'consum', 0.0240, 'lps'),
	(630717, 133, '2015-01-01 00:59:24.000000', 'consum', 0.0223, 'lps'),
	(630718, 133, '2015-01-01 00:59:25.000000', 'consum', 0.0219, 'lps'),
	(630719, 133, '2015-01-01 00:59:26.000000', 'consum', 0.0213, 'lps'),
	(630720, 133, '2015-01-01 00:59:27.000000', 'consum', 0.0234, 'lps'),
	(630721, 133, '2015-01-01 00:59:28.000000', 'consum', 0.0225, 'lps'),
	(630722, 133, '2015-01-01 00:59:29.000000', 'consum', 0.0212, 'lps'),
	(630723, 133, '2015-01-01 00:59:30.000000', 'consum', 0.0240, 'lps'),
	(630724, 133, '2015-01-01 00:59:31.000000', 'consum', 0.0229, 'lps'),
	(630725, 133, '2015-01-01 00:59:32.000000', 'consum', 0.0213, 'lps'),
	(630726, 133, '2015-01-01 00:59:33.000000', 'consum', 0.0231, 'lps'),
	(630727, 133, '2015-01-01 00:59:34.000000', 'consum', 0.0212, 'lps'),
	(630728, 133, '2015-01-01 00:59:35.000000', 'consum', 0.0221, 'lps'),
	(630729, 133, '2015-01-01 00:59:36.000000', 'consum', 0.0226, 'lps'),
	(630730, 133, '2015-01-01 00:59:37.000000', 'consum', 0.0229, 'lps'),
	(630731, 133, '2015-01-01 00:59:38.000000', 'consum', 0.0222, 'lps'),
	(630732, 133, '2015-01-01 00:59:39.000000', 'consum', 0.0217, 'lps'),
	(630733, 133, '2015-01-01 00:59:40.000000', 'consum', 0.0238, 'lps'),
	(630734, 133, '2015-01-01 00:59:41.000000', 'consum', 0.0237, 'lps'),
	(630735, 133, '2015-01-01 00:59:42.000000', 'consum', 0.0226, 'lps'),
	(630736, 133, '2015-01-01 00:59:43.000000', 'consum', 0.0212, 'lps'),
	(630737, 133, '2015-01-01 00:59:44.000000', 'consum', 0.0238, 'lps'),
	(630738, 133, '2015-01-01 00:59:45.000000', 'consum', 0.0214, 'lps'),
	(630739, 133, '2015-01-01 00:59:46.000000', 'consum', 0.0210, 'lps'),
	(630740, 133, '2015-01-01 00:59:47.000000', 'consum', 0.0233, 'lps'),
	(630741, 133, '2015-01-01 00:59:48.000000', 'consum', 0.0227, 'lps'),
	(630742, 133, '2015-01-01 00:59:49.000000', 'consum', 0.0230, 'lps'),
	(630743, 133, '2015-01-01 00:59:50.000000', 'consum', 0.0224, 'lps'),
	(630744, 133, '2015-01-01 00:59:51.000000', 'consum', 0.0220, 'lps'),
	(630745, 133, '2015-01-01 00:59:52.000000', 'consum', 0.0220, 'lps'),
	(630746, 133, '2015-01-01 00:59:53.000000', 'consum', 0.0229, 'lps'),
	(630747, 133, '2015-01-01 00:59:54.000000', 'consum', 0.0213, 'lps'),
	(630748, 133, '2015-01-01 00:59:55.000000', 'consum', 0.0231, 'lps'),
	(630749, 133, '2015-01-01 00:59:56.000000', 'consum', 0.0211, 'lps'),
	(630750, 133, '2015-01-01 00:59:57.000000', 'consum', 0.0217, 'lps'),
	(630751, 133, '2015-01-01 00:59:58.000000', 'consum', 0.0212, 'lps'),
	(630752, 133, '2015-01-01 00:59:59.000000', 'consum', 0.0232, 'lps'),
	(630753, 133, '2015-01-01 01:00:00.000000', 'consum', 0.0217, 'lps'),
	(630754, 133, '2015-01-01 01:00:01.000000', 'consum', 0.0211, 'lps'),
	(630755, 133, '2015-01-01 01:00:02.000000', 'consum', 0.0227, 'lps'),
	(630756, 133, '2015-01-01 01:00:03.000000', 'consum', 0.0228, 'lps'),
	(630757, 133, '2015-01-01 01:00:04.000000', 'consum', 0.0218, 'lps'),
	(630758, 133, '2015-01-01 01:00:05.000000', 'consum', 0.0230, 'lps'),
	(630759, 133, '2015-01-01 01:00:06.000000', 'consum', 0.0220, 'lps'),
	(630760, 133, '2015-01-01 01:00:07.000000', 'consum', 0.0232, 'lps'),
	(630761, 133, '2015-01-01 01:00:08.000000', 'consum', 0.0227, 'lps'),
	(630762, 133, '2015-01-01 01:00:09.000000', 'consum', 0.0228, 'lps'),
	(630763, 133, '2015-01-01 01:00:10.000000', 'consum', 0.0221, 'lps'),
	(630764, 133, '2015-01-01 01:00:11.000000', 'consum', 0.0210, 'lps'),
	(630765, 133, '2015-01-01 01:00:12.000000', 'consum', 0.0240, 'lps'),
	(630766, 133, '2015-01-01 01:00:13.000000', 'consum', 0.0232, 'lps'),
	(630767, 133, '2015-01-01 01:00:14.000000', 'consum', 0.0233, 'lps'),
	(630768, 133, '2015-01-01 01:00:15.000000', 'consum', 0.0227, 'lps'),
	(630769, 133, '2015-01-01 01:00:16.000000', 'consum', 0.0228, 'lps'),
	(630770, 133, '2015-01-01 01:00:17.000000', 'consum', 0.0217, 'lps'),
	(630771, 133, '2015-01-01 01:00:18.000000', 'consum', 0.0224, 'lps'),
	(630772, 133, '2015-01-01 01:00:19.000000', 'consum', 0.0226, 'lps'),
	(630773, 133, '2015-01-01 01:00:20.000000', 'consum', 0.0215, 'lps'),
	(630774, 133, '2015-01-01 01:00:21.000000', 'consum', 0.0221, 'lps'),
	(630775, 133, '2015-01-01 01:00:22.000000', 'consum', 0.0218, 'lps'),
	(630776, 133, '2015-01-01 01:00:23.000000', 'consum', 0.0219, 'lps'),
	(630777, 133, '2015-01-01 01:00:24.000000', 'consum', 0.0231, 'lps'),
	(630778, 133, '2015-01-01 01:00:25.000000', 'consum', 0.0223, 'lps'),
	(630779, 133, '2015-01-01 01:00:26.000000', 'consum', 0.0212, 'lps'),
	(630780, 133, '2015-01-01 01:00:27.000000', 'consum', 0.0212, 'lps'),
	(630781, 133, '2015-01-01 01:00:28.000000', 'consum', 0.0218, 'lps'),
	(630782, 133, '2015-01-01 01:00:29.000000', 'consum', 0.0213, 'lps'),
	(630783, 133, '2015-01-01 01:00:30.000000', 'consum', 0.0231, 'lps'),
	(630784, 133, '2015-01-01 01:00:31.000000', 'consum', 0.0210, 'lps'),
	(630785, 133, '2015-01-01 01:00:32.000000', 'consum', 0.0213, 'lps'),
	(630786, 133, '2015-01-01 01:00:33.000000', 'consum', 0.0227, 'lps'),
	(630787, 133, '2015-01-01 01:00:34.000000', 'consum', 0.0219, 'lps'),
	(630788, 133, '2015-01-01 01:00:35.000000', 'consum', 0.0239, 'lps'),
	(630789, 133, '2015-01-01 01:00:36.000000', 'consum', 0.0231, 'lps'),
	(630790, 133, '2015-01-01 01:00:37.000000', 'consum', 0.0228, 'lps'),
	(630791, 133, '2015-01-01 01:00:38.000000', 'consum', 0.0239, 'lps'),
	(630792, 133, '2015-01-01 01:00:39.000000', 'consum', 0.0238, 'lps'),
	(630793, 133, '2015-01-01 01:00:40.000000', 'consum', 0.0230, 'lps'),
	(630794, 133, '2015-01-01 01:00:41.000000', 'consum', 0.0228, 'lps'),
	(630795, 133, '2015-01-01 01:00:42.000000', 'consum', 0.0239, 'lps'),
	(630796, 133, '2015-01-01 01:00:43.000000', 'consum', 0.0239, 'lps'),
	(630797, 133, '2015-01-01 01:00:44.000000', 'consum', 0.0238, 'lps'),
	(630798, 133, '2015-01-01 01:00:45.000000', 'consum', 0.0229, 'lps'),
	(630799, 133, '2015-01-01 01:00:46.000000', 'consum', 0.0222, 'lps'),
	(630800, 133, '2015-01-01 01:00:47.000000', 'consum', 0.0212, 'lps'),
	(630801, 133, '2015-01-01 01:00:48.000000', 'consum', 0.0216, 'lps'),
	(630802, 133, '2015-01-01 01:00:49.000000', 'consum', 0.0236, 'lps'),
	(630803, 133, '2015-01-01 01:00:50.000000', 'consum', 0.0227, 'lps'),
	(630804, 133, '2015-01-01 01:00:51.000000', 'consum', 0.0217, 'lps'),
	(630805, 133, '2015-01-01 01:00:52.000000', 'consum', 0.0227, 'lps'),
	(630806, 133, '2015-01-01 01:00:53.000000', 'consum', 0.0241, 'lps'),
	(630807, 133, '2015-01-01 01:00:54.000000', 'consum', 0.0218, 'lps'),
	(630808, 133, '2015-01-01 01:00:55.000000', 'consum', 0.0222, 'lps'),
	(630809, 133, '2015-01-01 01:00:56.000000', 'consum', 0.0215, 'lps'),
	(630810, 133, '2015-01-01 01:00:57.000000', 'consum', 0.0233, 'lps'),
	(630811, 133, '2015-01-01 01:00:58.000000', 'consum', 0.0212, 'lps'),
	(630812, 133, '2015-01-01 01:00:59.000000', 'consum', 0.0215, 'lps'),
	(630813, 133, '2015-01-01 01:01:00.000000', 'consum', 0.0230, 'lps'),
	(630814, 133, '2015-01-01 01:01:01.000000', 'consum', 0.0232, 'lps'),
	(630815, 133, '2015-01-01 01:01:02.000000', 'consum', 0.0229, 'lps'),
	(630816, 133, '2015-01-01 01:01:03.000000', 'consum', 0.0241, 'lps'),
	(630817, 133, '2015-01-01 01:01:04.000000', 'consum', 0.0241, 'lps'),
	(630818, 133, '2015-01-01 01:01:05.000000', 'consum', 0.0211, 'lps'),
	(630819, 133, '2015-01-01 01:01:06.000000', 'consum', 0.0217, 'lps'),
	(630820, 133, '2015-01-01 01:01:07.000000', 'consum', 0.0211, 'lps'),
	(630821, 133, '2015-01-01 01:01:08.000000', 'consum', 0.0228, 'lps'),
	(630822, 133, '2015-01-01 01:01:09.000000', 'consum', 0.0231, 'lps'),
	(630823, 133, '2015-01-01 01:01:10.000000', 'consum', 0.0230, 'lps'),
	(630824, 133, '2015-01-01 01:01:11.000000', 'consum', 0.0217, 'lps'),
	(630825, 133, '2015-01-01 01:01:12.000000', 'consum', 0.0216, 'lps'),
	(630826, 133, '2015-01-01 01:01:13.000000', 'consum', 0.0221, 'lps'),
	(630827, 133, '2015-01-01 01:01:14.000000', 'consum', 0.0216, 'lps'),
	(630828, 133, '2015-01-01 01:01:15.000000', 'consum', 0.0237, 'lps'),
	(630829, 133, '2015-01-01 01:01:16.000000', 'consum', 0.0232, 'lps'),
	(630830, 133, '2015-01-01 01:01:17.000000', 'consum', 0.0238, 'lps'),
	(630831, 133, '2015-01-01 01:01:18.000000', 'consum', 0.0222, 'lps'),
	(630832, 133, '2015-01-01 01:01:19.000000', 'consum', 0.0219, 'lps'),
	(630833, 133, '2015-01-01 01:01:20.000000', 'consum', 0.0220, 'lps'),
	(630834, 133, '2015-01-01 01:01:21.000000', 'consum', 0.0233, 'lps'),
	(630835, 133, '2015-01-01 01:01:22.000000', 'consum', 0.0231, 'lps'),
	(630836, 133, '2015-01-01 01:01:23.000000', 'consum', 0.0215, 'lps'),
	(630837, 133, '2015-01-01 01:01:24.000000', 'consum', 0.0238, 'lps'),
	(630838, 133, '2015-01-01 01:01:25.000000', 'consum', 0.0237, 'lps'),
	(630839, 133, '2015-01-01 01:01:26.000000', 'consum', 0.0231, 'lps'),
	(630840, 133, '2015-01-01 01:01:27.000000', 'consum', 0.0234, 'lps'),
	(630841, 133, '2015-01-01 01:01:28.000000', 'consum', 0.0238, 'lps'),
	(630842, 133, '2015-01-01 01:01:29.000000', 'consum', 0.0211, 'lps'),
	(630843, 133, '2015-01-01 01:01:30.000000', 'consum', 0.0228, 'lps'),
	(630844, 133, '2015-01-01 01:01:31.000000', 'consum', 0.0235, 'lps'),
	(630845, 133, '2015-01-01 01:01:32.000000', 'consum', 0.0217, 'lps'),
	(630846, 133, '2015-01-01 01:01:33.000000', 'consum', 0.0235, 'lps'),
	(630847, 133, '2015-01-01 01:01:34.000000', 'consum', 0.0219, 'lps'),
	(630848, 133, '2015-01-01 01:01:35.000000', 'consum', 0.0211, 'lps'),
	(630849, 133, '2015-01-01 01:01:36.000000', 'consum', 0.0223, 'lps'),
	(630850, 133, '2015-01-01 01:01:37.000000', 'consum', 0.0238, 'lps'),
	(630851, 133, '2015-01-01 01:01:38.000000', 'consum', 0.0218, 'lps'),
	(630852, 133, '2015-01-01 01:01:39.000000', 'consum', 0.0230, 'lps'),
	(630853, 133, '2015-01-01 01:01:40.000000', 'consum', 0.0223, 'lps'),
	(630854, 133, '2015-01-01 01:01:41.000000', 'consum', 0.0214, 'lps'),
	(630855, 133, '2015-01-01 01:01:42.000000', 'consum', 0.0225, 'lps'),
	(630856, 133, '2015-01-01 01:01:43.000000', 'consum', 0.0241, 'lps'),
	(630857, 133, '2015-01-01 01:01:44.000000', 'consum', 0.0226, 'lps'),
	(630858, 133, '2015-01-01 01:01:45.000000', 'consum', 0.0227, 'lps'),
	(630859, 133, '2015-01-01 01:01:46.000000', 'consum', 0.0218, 'lps'),
	(630860, 133, '2015-01-01 01:01:47.000000', 'consum', 0.0231, 'lps'),
	(630861, 133, '2015-01-01 01:01:48.000000', 'consum', 0.0226, 'lps'),
	(630862, 133, '2015-01-01 01:01:49.000000', 'consum', 0.0227, 'lps'),
	(630863, 133, '2015-01-01 01:01:50.000000', 'consum', 0.0215, 'lps'),
	(630864, 133, '2015-01-01 01:01:51.000000', 'consum', 0.0219, 'lps'),
	(630865, 133, '2015-01-01 01:01:52.000000', 'consum', 0.0238, 'lps'),
	(630866, 133, '2015-01-01 01:01:53.000000', 'consum', 0.0231, 'lps'),
	(630867, 133, '2015-01-01 01:01:54.000000', 'consum', 0.0228, 'lps'),
	(630868, 133, '2015-01-01 01:01:55.000000', 'consum', 0.0239, 'lps'),
	(630869, 133, '2015-01-01 01:01:56.000000', 'consum', 0.0236, 'lps'),
	(630870, 133, '2015-01-01 01:01:57.000000', 'consum', 0.0221, 'lps'),
	(630871, 133, '2015-01-01 01:01:58.000000', 'consum', 0.0219, 'lps'),
	(630872, 133, '2015-01-01 01:01:59.000000', 'consum', 0.0223, 'lps'),
	(630873, 133, '2015-01-01 01:02:00.000000', 'consum', 0.0219, 'lps'),
	(630874, 133, '2015-01-01 01:02:01.000000', 'consum', 0.0214, 'lps'),
	(630875, 133, '2015-01-01 01:02:02.000000', 'consum', 0.0235, 'lps'),
	(630876, 133, '2015-01-01 01:02:03.000000', 'consum', 0.0229, 'lps'),
	(630877, 133, '2015-01-01 01:02:04.000000', 'consum', 0.0232, 'lps'),
	(630878, 133, '2015-01-01 01:02:05.000000', 'consum', 0.0230, 'lps'),
	(630879, 133, '2015-01-01 01:02:06.000000', 'consum', 0.0214, 'lps'),
	(630880, 133, '2015-01-01 01:02:07.000000', 'consum', 0.0232, 'lps'),
	(630881, 133, '2015-01-01 01:02:08.000000', 'consum', 0.0212, 'lps'),
	(630882, 133, '2015-01-01 01:02:09.000000', 'consum', 0.0219, 'lps'),
	(630883, 133, '2015-01-01 01:02:10.000000', 'consum', 0.0218, 'lps'),
	(630884, 133, '2015-01-01 01:02:11.000000', 'consum', 0.0223, 'lps'),
	(630885, 133, '2015-01-01 01:02:12.000000', 'consum', 0.0220, 'lps'),
	(630886, 133, '2015-01-01 01:02:13.000000', 'consum', 0.0221, 'lps'),
	(630887, 133, '2015-01-01 01:02:14.000000', 'consum', 0.0234, 'lps'),
	(630888, 133, '2015-01-01 01:02:15.000000', 'consum', 0.0237, 'lps'),
	(630889, 133, '2015-01-01 01:02:16.000000', 'consum', 0.0239, 'lps'),
	(630890, 133, '2015-01-01 01:02:17.000000', 'consum', 0.0212, 'lps'),
	(630891, 133, '2015-01-01 01:02:18.000000', 'consum', 0.0230, 'lps'),
	(630892, 133, '2015-01-01 01:02:19.000000', 'consum', 0.0238, 'lps'),
	(630893, 133, '2015-01-01 01:02:20.000000', 'consum', 0.0228, 'lps'),
	(630894, 133, '2015-01-01 01:02:21.000000', 'consum', 0.0215, 'lps'),
	(630895, 133, '2015-01-01 01:02:22.000000', 'consum', 0.0215, 'lps'),
	(630896, 133, '2015-01-01 01:02:23.000000', 'consum', 0.0219, 'lps'),
	(630897, 133, '2015-01-01 01:02:24.000000', 'consum', 0.0241, 'lps'),
	(630898, 133, '2015-01-01 01:02:25.000000', 'consum', 0.0241, 'lps'),
	(630899, 133, '2015-01-01 01:02:26.000000', 'consum', 0.0210, 'lps'),
	(630900, 133, '2015-01-01 01:02:27.000000', 'consum', 0.0212, 'lps'),
	(630901, 133, '2015-01-01 01:02:28.000000', 'consum', 0.0221, 'lps'),
	(630902, 133, '2015-01-01 01:02:29.000000', 'consum', 0.0226, 'lps'),
	(630903, 133, '2015-01-01 01:02:30.000000', 'consum', 0.0228, 'lps'),
	(630904, 133, '2015-01-01 01:02:31.000000', 'consum', 0.0220, 'lps'),
	(630905, 133, '2015-01-01 01:02:32.000000', 'consum', 0.0240, 'lps'),
	(630906, 133, '2015-01-01 01:02:33.000000', 'consum', 0.0234, 'lps'),
	(630907, 133, '2015-01-01 01:02:34.000000', 'consum', 0.0240, 'lps'),
	(630908, 133, '2015-01-01 01:02:35.000000', 'consum', 0.0224, 'lps'),
	(630909, 133, '2015-01-01 01:02:36.000000', 'consum', 0.0221, 'lps'),
	(630910, 133, '2015-01-01 01:02:37.000000', 'consum', 0.0227, 'lps'),
	(630911, 133, '2015-01-01 01:02:38.000000', 'consum', 0.0228, 'lps'),
	(630912, 133, '2015-01-01 01:02:39.000000', 'consum', 0.0216, 'lps'),
	(630913, 133, '2015-01-01 01:02:40.000000', 'consum', 0.0222, 'lps'),
	(630914, 133, '2015-01-01 01:02:41.000000', 'consum', 0.0218, 'lps'),
	(630915, 133, '2015-01-01 01:02:42.000000', 'consum', 0.0214, 'lps'),
	(630916, 133, '2015-01-01 01:02:43.000000', 'consum', 0.0240, 'lps'),
	(630917, 133, '2015-01-01 01:02:44.000000', 'consum', 0.0222, 'lps'),
	(630918, 133, '2015-01-01 01:02:45.000000', 'consum', 0.0211, 'lps'),
	(630919, 133, '2015-01-01 01:02:46.000000', 'consum', 0.0214, 'lps'),
	(630920, 133, '2015-01-01 01:02:47.000000', 'consum', 0.0224, 'lps'),
	(630921, 133, '2015-01-01 01:02:48.000000', 'consum', 0.0238, 'lps'),
	(630922, 133, '2015-01-01 01:02:49.000000', 'consum', 0.0213, 'lps'),
	(630923, 133, '2015-01-01 01:02:50.000000', 'consum', 0.0237, 'lps'),
	(630924, 133, '2015-01-01 01:02:51.000000', 'consum', 0.0239, 'lps'),
	(630925, 133, '2015-01-01 01:02:52.000000', 'consum', 0.0213, 'lps'),
	(630926, 133, '2015-01-01 01:02:53.000000', 'consum', 0.0233, 'lps'),
	(630927, 133, '2015-01-01 01:02:54.000000', 'consum', 0.0222, 'lps'),
	(630928, 133, '2015-01-01 01:02:55.000000', 'consum', 0.0233, 'lps'),
	(630929, 133, '2015-01-01 01:02:56.000000', 'consum', 0.0226, 'lps'),
	(630930, 133, '2015-01-01 01:02:57.000000', 'consum', 0.0223, 'lps'),
	(630931, 133, '2015-01-01 01:02:58.000000', 'consum', 0.0225, 'lps'),
	(630932, 133, '2015-01-01 01:02:59.000000', 'consum', 0.0217, 'lps'),
	(630933, 133, '2015-01-01 01:03:00.000000', 'consum', 0.0230, 'lps'),
	(630934, 133, '2015-01-01 01:03:01.000000', 'consum', 0.0225, 'lps'),
	(630935, 133, '2015-01-01 01:03:02.000000', 'consum', 0.0229, 'lps'),
	(630936, 133, '2015-01-01 01:03:03.000000', 'consum', 0.0225, 'lps'),
	(630937, 133, '2015-01-01 01:03:04.000000', 'consum', 0.0229, 'lps'),
	(630938, 133, '2015-01-01 01:03:05.000000', 'consum', 0.0229, 'lps'),
	(630939, 133, '2015-01-01 01:03:06.000000', 'consum', 0.0218, 'lps'),
	(630940, 133, '2015-01-01 01:03:07.000000', 'consum', 0.0225, 'lps'),
	(630941, 133, '2015-01-01 01:03:08.000000', 'consum', 0.0230, 'lps'),
	(630942, 133, '2015-01-01 01:03:09.000000', 'consum', 0.0233, 'lps'),
	(630943, 133, '2015-01-01 01:03:10.000000', 'consum', 0.0232, 'lps'),
	(630944, 133, '2015-01-01 01:03:11.000000', 'consum', 0.0220, 'lps'),
	(630945, 133, '2015-01-01 01:03:12.000000', 'consum', 0.0229, 'lps'),
	(630946, 133, '2015-01-01 01:03:13.000000', 'consum', 0.0240, 'lps'),
	(630947, 133, '2015-01-01 01:03:14.000000', 'consum', 0.0211, 'lps'),
	(630948, 133, '2015-01-01 01:03:15.000000', 'consum', 0.0219, 'lps'),
	(630949, 133, '2015-01-01 01:03:16.000000', 'consum', 0.0223, 'lps'),
	(630950, 133, '2015-01-01 01:03:17.000000', 'consum', 0.0214, 'lps'),
	(630951, 133, '2015-01-01 01:03:18.000000', 'consum', 0.0226, 'lps'),
	(630952, 133, '2015-01-01 01:03:19.000000', 'consum', 0.0212, 'lps'),
	(630953, 133, '2015-01-01 01:03:20.000000', 'consum', 0.0239, 'lps'),
	(630954, 133, '2015-01-01 01:03:21.000000', 'consum', 0.0218, 'lps'),
	(630955, 133, '2015-01-01 01:03:22.000000', 'consum', 0.0230, 'lps'),
	(630956, 133, '2015-01-01 01:03:23.000000', 'consum', 0.0224, 'lps'),
	(630957, 133, '2015-01-01 01:03:24.000000', 'consum', 0.0217, 'lps'),
	(630958, 133, '2015-01-01 01:03:25.000000', 'consum', 0.0239, 'lps'),
	(630959, 133, '2015-01-01 01:03:26.000000', 'consum', 0.0236, 'lps'),
	(630960, 133, '2015-01-01 01:03:27.000000', 'consum', 0.0223, 'lps'),
	(630961, 133, '2015-01-01 01:03:28.000000', 'consum', 0.0230, 'lps'),
	(630962, 133, '2015-01-01 01:03:29.000000', 'consum', 0.0238, 'lps'),
	(630963, 133, '2015-01-01 01:03:30.000000', 'consum', 0.0228, 'lps'),
	(630964, 133, '2015-01-01 01:03:31.000000', 'consum', 0.0215, 'lps'),
	(630965, 133, '2015-01-01 01:03:32.000000', 'consum', 0.0212, 'lps'),
	(630966, 133, '2015-01-01 01:03:33.000000', 'consum', 0.0240, 'lps'),
	(630967, 133, '2015-01-01 01:03:34.000000', 'consum', 0.0225, 'lps'),
	(630968, 133, '2015-01-01 01:03:35.000000', 'consum', 0.0228, 'lps'),
	(630969, 133, '2015-01-01 01:03:36.000000', 'consum', 0.0224, 'lps'),
	(630970, 133, '2015-01-01 01:03:37.000000', 'consum', 0.0225, 'lps'),
	(630971, 133, '2015-01-01 01:03:38.000000', 'consum', 0.0212, 'lps'),
	(630972, 133, '2015-01-01 01:03:39.000000', 'consum', 0.0239, 'lps'),
	(630973, 133, '2015-01-01 01:03:40.000000', 'consum', 0.0220, 'lps'),
	(630974, 133, '2015-01-01 01:03:41.000000', 'consum', 0.0240, 'lps'),
	(630975, 133, '2015-01-01 01:03:42.000000', 'consum', 0.0234, 'lps'),
	(630976, 133, '2015-01-01 01:03:43.000000', 'consum', 0.0241, 'lps'),
	(630977, 133, '2015-01-01 01:03:44.000000', 'consum', 0.0229, 'lps'),
	(630978, 133, '2015-01-01 01:03:45.000000', 'consum', 0.0212, 'lps'),
	(630979, 133, '2015-01-01 01:03:46.000000', 'consum', 0.0228, 'lps'),
	(630980, 133, '2015-01-01 01:03:47.000000', 'consum', 0.0232, 'lps'),
	(630981, 133, '2015-01-01 01:03:48.000000', 'consum', 0.0233, 'lps'),
	(630982, 133, '2015-01-01 01:03:49.000000', 'consum', 0.0228, 'lps'),
	(630983, 133, '2015-01-01 01:03:50.000000', 'consum', 0.0232, 'lps'),
	(630984, 133, '2015-01-01 01:03:51.000000', 'consum', 0.0235, 'lps'),
	(630985, 133, '2015-01-01 01:03:52.000000', 'consum', 0.0237, 'lps'),
	(630986, 133, '2015-01-01 01:03:53.000000', 'consum', 0.0239, 'lps'),
	(630987, 133, '2015-01-01 01:03:54.000000', 'consum', 0.0240, 'lps'),
	(630988, 133, '2015-01-01 01:03:55.000000', 'consum', 0.0211, 'lps'),
	(630989, 133, '2015-01-01 01:03:56.000000', 'consum', 0.0221, 'lps'),
	(630990, 133, '2015-01-01 01:03:57.000000', 'consum', 0.0230, 'lps'),
	(630991, 133, '2015-01-01 01:03:58.000000', 'consum', 0.0212, 'lps'),
	(630992, 133, '2015-01-01 01:03:59.000000', 'consum', 0.0226, 'lps'),
	(630993, 133, '2015-01-01 01:04:00.000000', 'consum', 0.0221, 'lps'),
	(630994, 133, '2015-01-01 01:04:01.000000', 'consum', 0.0217, 'lps'),
	(630995, 133, '2015-01-01 01:04:02.000000', 'consum', 0.0215, 'lps'),
	(630996, 133, '2015-01-01 01:04:03.000000', 'consum', 0.0211, 'lps'),
	(630997, 133, '2015-01-01 01:04:04.000000', 'consum', 0.0233, 'lps'),
	(630998, 133, '2015-01-01 01:04:05.000000', 'consum', 0.0225, 'lps'),
	(630999, 133, '2015-01-01 01:04:06.000000', 'consum', 0.0219, 'lps'),
	(631000, 133, '2015-01-01 01:04:07.000000', 'consum', 0.0210, 'lps'),
	(631001, 133, '2015-01-01 01:04:08.000000', 'consum', 0.0216, 'lps'),
	(631002, 133, '2015-01-01 01:04:09.000000', 'consum', 0.0240, 'lps'),
	(631003, 133, '2015-01-01 01:04:10.000000', 'consum', 0.0213, 'lps'),
	(631004, 133, '2015-01-01 01:04:11.000000', 'consum', 0.0232, 'lps'),
	(631005, 133, '2015-01-01 01:04:12.000000', 'consum', 0.0215, 'lps'),
	(631006, 133, '2015-01-01 01:04:13.000000', 'consum', 0.0234, 'lps'),
	(631007, 133, '2015-01-01 01:04:14.000000', 'consum', 0.0218, 'lps'),
	(631008, 133, '2015-01-01 01:04:15.000000', 'consum', 0.0212, 'lps'),
	(631009, 133, '2015-01-01 01:04:16.000000', 'consum', 0.0230, 'lps'),
	(631010, 133, '2015-01-01 01:04:17.000000', 'consum', 0.0238, 'lps'),
	(631011, 133, '2015-01-01 01:04:18.000000', 'consum', 0.0228, 'lps'),
	(631012, 133, '2015-01-01 01:04:19.000000', 'consum', 0.0216, 'lps'),
	(631013, 133, '2015-01-01 01:04:20.000000', 'consum', 0.0217, 'lps'),
	(631014, 133, '2015-01-01 01:04:21.000000', 'consum', 0.0229, 'lps'),
	(631015, 133, '2015-01-01 01:04:22.000000', 'consum', 0.0220, 'lps'),
	(631016, 133, '2015-01-01 01:04:23.000000', 'consum', 0.0237, 'lps'),
	(631017, 133, '2015-01-01 01:04:24.000000', 'consum', 0.0220, 'lps'),
	(631018, 133, '2015-01-01 01:04:25.000000', 'consum', 0.0241, 'lps'),
	(631019, 133, '2015-01-01 01:04:26.000000', 'consum', 0.0241, 'lps'),
	(631020, 133, '2015-01-01 01:04:27.000000', 'consum', 0.0238, 'lps'),
	(631021, 133, '2015-01-01 01:04:28.000000', 'consum', 0.0228, 'lps'),
	(631022, 133, '2015-01-01 01:04:29.000000', 'consum', 0.0216, 'lps'),
	(631023, 133, '2015-01-01 01:04:30.000000', 'consum', 0.0218, 'lps'),
	(631024, 133, '2015-01-01 01:04:31.000000', 'consum', 0.0231, 'lps'),
	(631025, 133, '2015-01-01 01:04:32.000000', 'consum', 0.0231, 'lps'),
	(631026, 133, '2015-01-01 01:04:33.000000', 'consum', 0.0218, 'lps'),
	(631027, 133, '2015-01-01 01:04:34.000000', 'consum', 0.0219, 'lps'),
	(631028, 133, '2015-01-01 01:04:35.000000', 'consum', 0.0231, 'lps'),
	(631029, 133, '2015-01-01 01:04:36.000000', 'consum', 0.0226, 'lps'),
	(631030, 133, '2015-01-01 01:04:37.000000', 'consum', 0.0229, 'lps'),
	(631031, 133, '2015-01-01 01:04:38.000000', 'consum', 0.0222, 'lps'),
	(631032, 133, '2015-01-01 01:04:39.000000', 'consum', 0.0215, 'lps'),
	(631033, 133, '2015-01-01 01:04:40.000000', 'consum', 0.0232, 'lps'),
	(631034, 133, '2015-01-01 01:04:41.000000', 'consum', 0.0211, 'lps'),
	(631035, 133, '2015-01-01 01:04:42.000000', 'consum', 0.0212, 'lps'),
	(631036, 133, '2015-01-01 01:04:43.000000', 'consum', 0.0218, 'lps'),
	(631037, 133, '2015-01-01 01:04:44.000000', 'consum', 0.0214, 'lps'),
	(631038, 133, '2015-01-01 01:04:45.000000', 'consum', 0.0238, 'lps'),
	(631039, 133, '2015-01-01 01:04:46.000000', 'consum', 0.0240, 'lps'),
	(631040, 133, '2015-01-01 01:04:47.000000', 'consum', 0.0215, 'lps'),
	(631041, 133, '2015-01-01 01:04:48.000000', 'consum', 0.0210, 'lps'),
	(631042, 133, '2015-01-01 01:04:49.000000', 'consum', 0.0225, 'lps'),
	(631043, 133, '2015-01-01 01:04:50.000000', 'consum', 0.0224, 'lps'),
	(631044, 133, '2015-01-01 01:04:51.000000', 'consum', 0.0234, 'lps'),
	(631045, 133, '2015-01-01 01:04:52.000000', 'consum', 0.0226, 'lps'),
	(631046, 133, '2015-01-01 01:04:53.000000', 'consum', 0.0220, 'lps'),
	(631047, 133, '2015-01-01 01:04:54.000000', 'consum', 0.0241, 'lps'),
	(631048, 133, '2015-01-01 01:04:55.000000', 'consum', 0.0241, 'lps'),
	(631049, 133, '2015-01-01 01:04:56.000000', 'consum', 0.0210, 'lps'),
	(631050, 133, '2015-01-01 01:04:57.000000', 'consum', 0.0212, 'lps'),
	(631051, 133, '2015-01-01 01:04:58.000000', 'consum', 0.0220, 'lps'),
	(631052, 133, '2015-01-01 01:04:59.000000', 'consum', 0.0221, 'lps'),
	(631053, 133, '2015-01-01 01:05:00.000000', 'consum', 0.0236, 'lps'),
	(631054, 133, '2015-01-01 01:05:01.000000', 'consum', 0.0214, 'lps'),
	(631055, 133, '2015-01-01 01:05:02.000000', 'consum', 0.0216, 'lps'),
	(631056, 133, '2015-01-01 01:05:03.000000', 'consum', 0.0226, 'lps'),
	(631057, 133, '2015-01-01 01:05:04.000000', 'consum', 0.0211, 'lps'),
	(631058, 133, '2015-01-01 01:05:05.000000', 'consum', 0.0230, 'lps'),
	(631059, 133, '2015-01-01 01:05:06.000000', 'consum', 0.0214, 'lps'),
	(631060, 133, '2015-01-01 01:05:07.000000', 'consum', 0.0232, 'lps'),
	(631061, 133, '2015-01-01 01:05:08.000000', 'consum', 0.0214, 'lps'),
	(631062, 133, '2015-01-01 01:05:09.000000', 'consum', 0.0226, 'lps'),
	(631063, 133, '2015-01-01 01:05:10.000000', 'consum', 0.0217, 'lps'),
	(631064, 133, '2015-01-01 01:05:11.000000', 'consum', 0.0229, 'lps'),
	(631065, 133, '2015-01-01 01:05:12.000000', 'consum', 0.0220, 'lps'),
	(631066, 133, '2015-01-01 01:05:13.000000', 'consum', 0.0237, 'lps'),
	(631067, 133, '2015-01-01 01:05:14.000000', 'consum', 0.0219, 'lps'),
	(631068, 133, '2015-01-01 01:05:15.000000', 'consum', 0.0237, 'lps'),
	(631069, 133, '2015-01-01 01:05:16.000000', 'consum', 0.0225, 'lps'),
	(631070, 133, '2015-01-01 01:05:17.000000', 'consum', 0.0237, 'lps'),
	(631071, 133, '2015-01-01 01:05:18.000000', 'consum', 0.0234, 'lps'),
	(631072, 133, '2015-01-01 01:05:19.000000', 'consum', 0.0220, 'lps'),
	(631073, 133, '2015-01-01 01:05:20.000000', 'consum', 0.0219, 'lps'),
	(631074, 133, '2015-01-01 01:05:21.000000', 'consum', 0.0225, 'lps'),
	(631075, 133, '2015-01-01 01:05:22.000000', 'consum', 0.0225, 'lps'),
	(631076, 133, '2015-01-01 01:05:23.000000', 'consum', 0.0210, 'lps'),
	(631077, 133, '2015-01-01 01:05:24.000000', 'consum', 0.0229, 'lps'),
	(631078, 133, '2015-01-01 01:05:25.000000', 'consum', 0.0210, 'lps'),
	(631079, 133, '2015-01-01 01:05:26.000000', 'consum', 0.0219, 'lps'),
	(631080, 133, '2015-01-01 01:05:27.000000', 'consum', 0.0223, 'lps'),
	(631081, 133, '2015-01-01 01:05:28.000000', 'consum', 0.0217, 'lps'),
	(631082, 133, '2015-01-01 01:05:29.000000', 'consum', 0.0238, 'lps'),
	(631083, 133, '2015-01-01 01:05:30.000000', 'consum', 0.0232, 'lps'),
	(631084, 133, '2015-01-01 01:05:31.000000', 'consum', 0.0237, 'lps'),
	(631085, 133, '2015-01-01 01:05:32.000000', 'consum', 0.0218, 'lps'),
	(631086, 133, '2015-01-01 01:05:33.000000', 'consum', 0.0231, 'lps'),
	(631087, 133, '2015-01-01 01:05:34.000000', 'consum', 0.0229, 'lps'),
	(631088, 133, '2015-01-01 01:05:35.000000', 'consum', 0.0210, 'lps'),
	(631089, 133, '2015-01-01 01:05:36.000000', 'consum', 0.0219, 'lps'),
	(631090, 133, '2015-01-01 01:05:37.000000', 'consum', 0.0221, 'lps'),
	(631091, 133, '2015-01-01 01:05:38.000000', 'consum', 0.0239, 'lps'),
	(631092, 133, '2015-01-01 01:05:39.000000', 'consum', 0.0228, 'lps'),
	(631093, 133, '2015-01-01 01:05:40.000000', 'consum', 0.0211, 'lps'),
	(631094, 133, '2015-01-01 01:05:41.000000', 'consum', 0.0226, 'lps'),
	(631095, 133, '2015-01-01 01:05:42.000000', 'consum', 0.0223, 'lps'),
	(631096, 133, '2015-01-01 01:05:43.000000', 'consum', 0.0228, 'lps'),
	(631097, 133, '2015-01-01 01:05:44.000000', 'consum', 0.0231, 'lps'),
	(631098, 133, '2015-01-01 01:05:45.000000', 'consum', 0.0228, 'lps'),
	(631099, 133, '2015-01-01 01:05:46.000000', 'consum', 0.0236, 'lps'),
	(631100, 133, '2015-01-01 01:05:47.000000', 'consum', 0.0223, 'lps'),
	(631101, 133, '2015-01-01 01:05:48.000000', 'consum', 0.0231, 'lps'),
	(631102, 133, '2015-01-01 01:05:49.000000', 'consum', 0.0213, 'lps'),
	(631103, 133, '2015-01-01 01:05:50.000000', 'consum', 0.0224, 'lps'),
	(631104, 133, '2015-01-01 01:05:51.000000', 'consum', 0.0210, 'lps'),
	(631105, 133, '2015-01-01 01:05:52.000000', 'consum', 0.0233, 'lps'),
	(631106, 133, '2015-01-01 01:05:53.000000', 'consum', 0.0231, 'lps'),
	(631107, 133, '2015-01-01 01:05:54.000000', 'consum', 0.0211, 'lps'),
	(631108, 133, '2015-01-01 01:05:55.000000', 'consum', 0.0217, 'lps'),
	(631109, 133, '2015-01-01 01:05:56.000000', 'consum', 0.0211, 'lps'),
	(631110, 133, '2015-01-01 01:05:57.000000', 'consum', 0.0226, 'lps'),
	(631111, 133, '2015-01-01 01:05:58.000000', 'consum', 0.0223, 'lps'),
	(631112, 133, '2015-01-01 01:05:59.000000', 'consum', 0.0228, 'lps'),
	(631113, 133, '2015-01-01 01:06:00.000000', 'consum', 0.0228, 'lps'),
	(631114, 133, '2015-01-01 01:06:01.000000', 'consum', 0.0217, 'lps'),
	(631115, 133, '2015-01-01 01:06:02.000000', 'consum', 0.0224, 'lps'),
	(631116, 133, '2015-01-01 01:06:03.000000', 'consum', 0.0228, 'lps'),
	(631117, 133, '2015-01-01 01:06:04.000000', 'consum', 0.0224, 'lps'),
	(631118, 133, '2015-01-01 01:06:05.000000', 'consum', 0.0229, 'lps'),
	(631119, 133, '2015-01-01 01:06:06.000000', 'consum', 0.0232, 'lps'),
	(631120, 133, '2015-01-01 01:06:07.000000', 'consum', 0.0229, 'lps'),
	(631121, 133, '2015-01-01 01:06:08.000000', 'consum', 0.0239, 'lps'),
	(631122, 133, '2015-01-01 01:06:09.000000', 'consum', 0.0237, 'lps'),
	(631123, 133, '2015-01-01 01:06:10.000000', 'consum', 0.0226, 'lps'),
	(631124, 133, '2015-01-01 01:06:11.000000', 'consum', 0.0241, 'lps'),
	(631125, 133, '2015-01-01 01:06:12.000000', 'consum', 0.0221, 'lps'),
	(631126, 133, '2015-01-01 01:06:13.000000', 'consum', 0.0236, 'lps'),
	(631127, 133, '2015-01-01 01:06:14.000000', 'consum', 0.0213, 'lps'),
	(631128, 133, '2015-01-01 01:06:15.000000', 'consum', 0.0210, 'lps'),
	(631129, 133, '2015-01-01 01:06:16.000000', 'consum', 0.0233, 'lps'),
	(631130, 133, '2015-01-01 01:06:17.000000', 'consum', 0.0231, 'lps'),
	(631131, 133, '2015-01-01 01:06:18.000000', 'consum', 0.0213, 'lps'),
	(631132, 133, '2015-01-01 01:06:19.000000', 'consum', 0.0226, 'lps'),
	(631133, 133, '2015-01-01 01:06:20.000000', 'consum', 0.0219, 'lps'),
	(631134, 133, '2015-01-01 01:06:21.000000', 'consum', 0.0239, 'lps'),
	(631135, 133, '2015-01-01 01:06:22.000000', 'consum', 0.0233, 'lps'),
	(631136, 133, '2015-01-01 01:06:23.000000', 'consum', 0.0237, 'lps'),
	(631137, 133, '2015-01-01 01:06:24.000000', 'consum', 0.0215, 'lps'),
	(631138, 133, '2015-01-01 01:06:25.000000', 'consum', 0.0219, 'lps'),
	(631139, 133, '2015-01-01 01:06:26.000000', 'consum', 0.0239, 'lps'),
	(631140, 133, '2015-01-01 01:06:27.000000', 'consum', 0.0232, 'lps'),
	(631141, 133, '2015-01-01 01:06:28.000000', 'consum', 0.0234, 'lps'),
	(631142, 133, '2015-01-01 01:06:29.000000', 'consum', 0.0231, 'lps'),
	(631143, 133, '2015-01-01 01:06:30.000000', 'consum', 0.0211, 'lps'),
	(631144, 133, '2015-01-01 01:06:31.000000', 'consum', 0.0216, 'lps'),
	(631145, 133, '2015-01-01 01:06:32.000000', 'consum', 0.0238, 'lps'),
	(631146, 133, '2015-01-01 01:06:33.000000', 'consum', 0.0236, 'lps'),
	(631147, 133, '2015-01-01 01:06:34.000000', 'consum', 0.0227, 'lps'),
	(631148, 133, '2015-01-01 01:06:35.000000', 'consum', 0.0214, 'lps'),
	(631149, 133, '2015-01-01 01:06:36.000000', 'consum', 0.0213, 'lps'),
	(631150, 133, '2015-01-01 01:06:37.000000', 'consum', 0.0215, 'lps'),
	(631151, 133, '2015-01-01 01:06:38.000000', 'consum', 0.0226, 'lps'),
	(631152, 133, '2015-01-01 01:06:39.000000', 'consum', 0.0213, 'lps'),
	(631153, 133, '2015-01-01 01:06:40.000000', 'consum', 0.0239, 'lps'),
	(631154, 133, '2015-01-01 01:06:41.000000', 'consum', 0.0221, 'lps'),
	(631155, 133, '2015-01-01 01:06:42.000000', 'consum', 0.0210, 'lps'),
	(631156, 133, '2015-01-01 01:06:43.000000', 'consum', 0.0211, 'lps'),
	(631157, 133, '2015-01-01 01:06:44.000000', 'consum', 0.0215, 'lps'),
	(631158, 133, '2015-01-01 01:06:45.000000', 'consum', 0.0232, 'lps'),
	(631159, 133, '2015-01-01 01:06:46.000000', 'consum', 0.0240, 'lps'),
	(631160, 133, '2015-01-01 01:06:47.000000', 'consum', 0.0230, 'lps'),
	(631161, 133, '2015-01-01 01:06:48.000000', 'consum', 0.0221, 'lps'),
	(631162, 133, '2015-01-01 01:06:49.000000', 'consum', 0.0236, 'lps'),
	(631163, 133, '2015-01-01 01:06:50.000000', 'consum', 0.0214, 'lps'),
	(631164, 133, '2015-01-01 01:06:51.000000', 'consum', 0.0214, 'lps'),
	(631165, 133, '2015-01-01 01:06:52.000000', 'consum', 0.0220, 'lps'),
	(631166, 133, '2015-01-01 01:06:53.000000', 'consum', 0.0218, 'lps'),
	(631167, 133, '2015-01-01 01:06:54.000000', 'consum', 0.0218, 'lps'),
	(631168, 133, '2015-01-01 01:06:55.000000', 'consum', 0.0226, 'lps'),
	(631169, 133, '2015-01-01 01:06:56.000000', 'consum', 0.0237, 'lps'),
	(631170, 133, '2015-01-01 01:06:57.000000', 'consum', 0.0234, 'lps'),
	(631171, 133, '2015-01-01 01:06:58.000000', 'consum', 0.0215, 'lps'),
	(631172, 133, '2015-01-01 01:06:59.000000', 'consum', 0.0229, 'lps'),
	(631173, 133, '2015-01-01 01:07:00.000000', 'consum', 0.0227, 'lps'),
	(631174, 133, '2015-01-01 01:07:01.000000', 'consum', 0.0237, 'lps'),
	(631175, 133, '2015-01-01 01:07:02.000000', 'consum', 0.0231, 'lps'),
	(631176, 133, '2015-01-01 01:07:03.000000', 'consum', 0.0233, 'lps'),
	(631177, 133, '2015-01-01 01:07:04.000000', 'consum', 0.0232, 'lps'),
	(631178, 133, '2015-01-01 01:07:05.000000', 'consum', 0.0221, 'lps'),
	(631179, 133, '2015-01-01 01:07:06.000000', 'consum', 0.0231, 'lps'),
	(631180, 133, '2015-01-01 01:07:07.000000', 'consum', 0.0218, 'lps'),
	(631181, 133, '2015-01-01 01:07:08.000000', 'consum', 0.0222, 'lps'),
	(631182, 133, '2015-01-01 01:07:09.000000', 'consum', 0.0211, 'lps'),
	(631183, 133, '2015-01-01 01:07:10.000000', 'consum', 0.0212, 'lps'),
	(631184, 133, '2015-01-01 01:07:11.000000', 'consum', 0.0218, 'lps'),
	(631185, 133, '2015-01-01 01:07:12.000000', 'consum', 0.0211, 'lps'),
	(631186, 133, '2015-01-01 01:07:13.000000', 'consum', 0.0224, 'lps'),
	(631187, 133, '2015-01-01 01:07:14.000000', 'consum', 0.0214, 'lps'),
	(631188, 133, '2015-01-01 01:07:15.000000', 'consum', 0.0219, 'lps'),
	(631189, 133, '2015-01-01 01:07:16.000000', 'consum', 0.0213, 'lps'),
	(631190, 133, '2015-01-01 01:07:17.000000', 'consum', 0.0230, 'lps'),
	(631191, 133, '2015-01-01 01:07:18.000000', 'consum', 0.0236, 'lps'),
	(631192, 133, '2015-01-01 01:07:19.000000', 'consum', 0.0218, 'lps'),
	(631193, 133, '2015-01-01 01:07:20.000000', 'consum', 0.0235, 'lps'),
	(631194, 133, '2015-01-01 01:07:21.000000', 'consum', 0.0214, 'lps'),
	(631195, 133, '2015-01-01 01:07:22.000000', 'consum', 0.0223, 'lps'),
	(631196, 133, '2015-01-01 01:07:23.000000', 'consum', 0.0230, 'lps'),
	(631197, 133, '2015-01-01 01:07:24.000000', 'consum', 0.0239, 'lps'),
	(631198, 133, '2015-01-01 01:07:25.000000', 'consum', 0.0232, 'lps'),
	(631199, 133, '2015-01-01 01:07:26.000000', 'consum', 0.0236, 'lps'),
	(631200, 133, '2015-01-01 01:07:27.000000', 'consum', 0.0239, 'lps'),
	(631201, 133, '2015-01-01 01:07:28.000000', 'consum', 0.0213, 'lps'),
	(631202, 133, '2015-01-01 01:07:29.000000', 'consum', 0.0236, 'lps'),
	(631203, 133, '2015-01-01 01:07:30.000000', 'consum', 0.0234, 'lps'),
	(631204, 133, '2015-01-01 01:07:31.000000', 'consum', 0.0223, 'lps'),
	(631205, 133, '2015-01-01 01:07:32.000000', 'consum', 0.0236, 'lps'),
	(631206, 133, '2015-01-01 01:07:33.000000', 'consum', 0.0238, 'lps'),
	(631207, 133, '2015-01-01 01:07:34.000000', 'consum', 0.0241, 'lps'),
	(631208, 133, '2015-01-01 01:07:35.000000', 'consum', 0.0218, 'lps'),
	(631209, 133, '2015-01-01 01:07:36.000000', 'consum', 0.0221, 'lps'),
	(631210, 133, '2015-01-01 01:07:37.000000', 'consum', 0.0241, 'lps'),
	(631211, 133, '2015-01-01 01:07:38.000000', 'consum', 0.0238, 'lps'),
	(631212, 133, '2015-01-01 01:07:39.000000', 'consum', 0.0225, 'lps'),
	(631213, 133, '2015-01-01 01:07:40.000000', 'consum', 0.0233, 'lps'),
	(631214, 133, '2015-01-01 01:07:41.000000', 'consum', 0.0217, 'lps'),
	(631215, 133, '2015-01-01 01:07:42.000000', 'consum', 0.0241, 'lps'),
	(631216, 133, '2015-01-01 01:07:43.000000', 'consum', 0.0215, 'lps'),
	(631217, 133, '2015-01-01 01:07:44.000000', 'consum', 0.0241, 'lps'),
	(631218, 133, '2015-01-01 01:07:45.000000', 'consum', 0.0222, 'lps'),
	(631219, 133, '2015-01-01 01:07:46.000000', 'consum', 0.0240, 'lps'),
	(631220, 133, '2015-01-01 01:07:47.000000', 'consum', 0.0231, 'lps'),
	(631221, 133, '2015-01-01 01:07:48.000000', 'consum', 0.0222, 'lps'),
	(631222, 133, '2015-01-01 01:07:49.000000', 'consum', 0.0210, 'lps'),
	(631223, 133, '2015-01-01 01:07:50.000000', 'consum', 0.0240, 'lps'),
	(631224, 133, '2015-01-01 01:07:51.000000', 'consum', 0.0229, 'lps'),
	(631225, 133, '2015-01-01 01:07:52.000000', 'consum', 0.0217, 'lps'),
	(631226, 133, '2015-01-01 01:07:53.000000', 'consum', 0.0218, 'lps'),
	(631227, 133, '2015-01-01 01:07:54.000000', 'consum', 0.0233, 'lps'),
	(631228, 133, '2015-01-01 01:07:55.000000', 'consum', 0.0235, 'lps'),
	(631229, 133, '2015-01-01 01:07:56.000000', 'consum', 0.0237, 'lps'),
	(631230, 133, '2015-01-01 01:07:57.000000', 'consum', 0.0236, 'lps'),
	(631231, 133, '2015-01-01 01:07:58.000000', 'consum', 0.0230, 'lps'),
	(631232, 133, '2015-01-01 01:07:59.000000', 'consum', 0.0229, 'lps'),
	(631233, 133, '2015-01-01 01:08:00.000000', 'consum', 0.0216, 'lps'),
	(631234, 133, '2015-01-01 01:08:01.000000', 'consum', 0.0217, 'lps'),
	(631235, 133, '2015-01-01 01:08:02.000000', 'consum', 0.0225, 'lps'),
	(631236, 133, '2015-01-01 01:08:03.000000', 'consum', 0.0234, 'lps'),
	(631237, 133, '2015-01-01 01:08:04.000000', 'consum', 0.0221, 'lps'),
	(631238, 133, '2015-01-01 01:08:05.000000', 'consum', 0.0224, 'lps'),
	(631239, 133, '2015-01-01 01:08:06.000000', 'consum', 0.0218, 'lps'),
	(631240, 133, '2015-01-01 01:08:07.000000', 'consum', 0.0239, 'lps'),
	(631241, 133, '2015-01-01 01:08:08.000000', 'consum', 0.0235, 'lps'),
	(631242, 133, '2015-01-01 01:08:09.000000', 'consum', 0.0216, 'lps'),
	(631243, 133, '2015-01-01 01:08:10.000000', 'consum', 0.0232, 'lps'),
	(631244, 133, '2015-01-01 01:08:11.000000', 'consum', 0.0235, 'lps'),
	(631245, 133, '2015-01-01 01:08:12.000000', 'consum', 0.0240, 'lps'),
	(631246, 133, '2015-01-01 01:08:13.000000', 'consum', 0.0223, 'lps'),
	(631247, 133, '2015-01-01 01:08:14.000000', 'consum', 0.0214, 'lps'),
	(631248, 133, '2015-01-01 01:08:15.000000', 'consum', 0.0226, 'lps'),
	(631249, 133, '2015-01-01 01:08:16.000000', 'consum', 0.0216, 'lps'),
	(631250, 133, '2015-01-01 01:08:17.000000', 'consum', 0.0221, 'lps'),
	(631251, 133, '2015-01-01 01:08:18.000000', 'consum', 0.0217, 'lps'),
	(631252, 133, '2015-01-01 01:08:19.000000', 'consum', 0.0211, 'lps'),
	(631253, 133, '2015-01-01 01:08:20.000000', 'consum', 0.0226, 'lps'),
	(631254, 133, '2015-01-01 01:08:21.000000', 'consum', 0.0224, 'lps'),
	(631255, 133, '2015-01-01 01:08:22.000000', 'consum', 0.0235, 'lps'),
	(631256, 133, '2015-01-01 01:08:23.000000', 'consum', 0.0227, 'lps'),
	(631257, 133, '2015-01-01 01:08:24.000000', 'consum', 0.0221, 'lps'),
	(631258, 133, '2015-01-01 01:08:25.000000', 'consum', 0.0214, 'lps'),
	(631259, 133, '2015-01-01 01:08:26.000000', 'consum', 0.0231, 'lps'),
	(631260, 133, '2015-01-01 01:08:27.000000', 'consum', 0.0240, 'lps'),
	(631261, 133, '2015-01-01 01:08:28.000000', 'consum', 0.0232, 'lps'),
	(631262, 133, '2015-01-01 01:08:29.000000', 'consum', 0.0232, 'lps'),
	(631263, 133, '2015-01-01 01:08:30.000000', 'consum', 0.0222, 'lps'),
	(631264, 133, '2015-01-01 01:08:31.000000', 'consum', 0.0238, 'lps'),
	(631265, 133, '2015-01-01 01:08:32.000000', 'consum', 0.0217, 'lps'),
	(631266, 133, '2015-01-01 01:08:33.000000', 'consum', 0.0227, 'lps'),
	(631267, 133, '2015-01-01 01:08:34.000000', 'consum', 0.0241, 'lps'),
	(631268, 133, '2015-01-01 01:08:35.000000', 'consum', 0.0221, 'lps'),
	(631269, 133, '2015-01-01 01:08:36.000000', 'consum', 0.0233, 'lps'),
	(631270, 133, '2015-01-01 01:08:37.000000', 'consum', 0.0230, 'lps'),
	(631271, 133, '2015-01-01 01:08:38.000000', 'consum', 0.0241, 'lps'),
	(631272, 133, '2015-01-01 01:08:39.000000', 'consum', 0.0212, 'lps'),
	(631273, 133, '2015-01-01 01:08:40.000000', 'consum', 0.0220, 'lps'),
	(631274, 133, '2015-01-01 01:08:41.000000', 'consum', 0.0224, 'lps'),
	(631275, 133, '2015-01-01 01:08:42.000000', 'consum', 0.0219, 'lps'),
	(631276, 133, '2015-01-01 01:08:43.000000', 'consum', 0.0215, 'lps'),
	(631277, 133, '2015-01-01 01:08:44.000000', 'consum', 0.0240, 'lps'),
	(631278, 133, '2015-01-01 01:08:45.000000', 'consum', 0.0216, 'lps'),
	(631279, 133, '2015-01-01 01:08:46.000000', 'consum', 0.0213, 'lps'),
	(631280, 133, '2015-01-01 01:08:47.000000', 'consum', 0.0241, 'lps'),
	(631281, 133, '2015-01-01 01:08:48.000000', 'consum', 0.0230, 'lps'),
	(631282, 133, '2015-01-01 01:08:49.000000', 'consum', 0.0218, 'lps'),
	(631283, 133, '2015-01-01 01:08:50.000000', 'consum', 0.0223, 'lps'),
	(631284, 133, '2015-01-01 01:08:51.000000', 'consum', 0.0217, 'lps'),
	(631285, 133, '2015-01-01 01:08:52.000000', 'consum', 0.0237, 'lps'),
	(631286, 133, '2015-01-01 01:08:53.000000', 'consum', 0.0232, 'lps'),
	(631287, 133, '2015-01-01 01:08:54.000000', 'consum', 0.0240, 'lps'),
	(631288, 133, '2015-01-01 01:08:55.000000', 'consum', 0.0228, 'lps'),
	(631289, 133, '2015-01-01 01:08:56.000000', 'consum', 0.0211, 'lps'),
	(631290, 133, '2015-01-01 01:08:57.000000', 'consum', 0.0226, 'lps'),
	(631291, 133, '2015-01-01 01:08:58.000000', 'consum', 0.0223, 'lps'),
	(631292, 133, '2015-01-01 01:08:59.000000', 'consum', 0.0229, 'lps'),
	(631293, 133, '2015-01-01 01:09:00.000000', 'consum', 0.0233, 'lps'),
	(631294, 133, '2015-01-01 01:09:01.000000', 'consum', 0.0237, 'lps'),
	(631295, 133, '2015-01-01 01:09:02.000000', 'consum', 0.0214, 'lps'),
	(631296, 133, '2015-01-01 01:09:03.000000', 'consum', 0.0210, 'lps'),
	(631297, 133, '2015-01-01 01:09:04.000000', 'consum', 0.0234, 'lps'),
	(631298, 133, '2015-01-01 01:09:05.000000', 'consum', 0.0231, 'lps'),
	(631299, 133, '2015-01-01 01:09:06.000000', 'consum', 0.0214, 'lps'),
	(631300, 133, '2015-01-01 01:09:07.000000', 'consum', 0.0231, 'lps'),
	(631301, 133, '2015-01-01 01:09:08.000000', 'consum', 0.0238, 'lps'),
	(631302, 133, '2015-01-01 01:09:09.000000', 'consum', 0.0226, 'lps'),
	(631303, 133, '2015-01-01 01:09:10.000000', 'consum', 0.0239, 'lps'),
	(631304, 133, '2015-01-01 01:09:11.000000', 'consum', 0.0210, 'lps'),
	(631305, 133, '2015-01-01 01:09:12.000000', 'consum', 0.0222, 'lps'),
	(631306, 133, '2015-01-01 01:09:13.000000', 'consum', 0.0236, 'lps'),
	(631307, 133, '2015-01-01 01:09:14.000000', 'consum', 0.0239, 'lps'),
	(631308, 133, '2015-01-01 01:09:15.000000', 'consum', 0.0216, 'lps'),
	(631309, 133, '2015-01-01 01:09:16.000000', 'consum', 0.0218, 'lps'),
	(631310, 133, '2015-01-01 01:09:17.000000', 'consum', 0.0232, 'lps'),
	(631311, 133, '2015-01-01 01:09:18.000000', 'consum', 0.0231, 'lps'),
	(631312, 133, '2015-01-01 01:09:19.000000', 'consum', 0.0218, 'lps'),
	(631313, 133, '2015-01-01 01:09:20.000000', 'consum', 0.0219, 'lps'),
	(631314, 133, '2015-01-01 01:09:21.000000', 'consum', 0.0233, 'lps'),
	(631315, 133, '2015-01-01 01:09:22.000000', 'consum', 0.0235, 'lps'),
	(631316, 133, '2015-01-01 01:09:23.000000', 'consum', 0.0233, 'lps'),
	(631317, 133, '2015-01-01 01:09:24.000000', 'consum', 0.0217, 'lps'),
	(631318, 133, '2015-01-01 01:09:25.000000', 'consum', 0.0241, 'lps'),
	(631319, 133, '2015-01-01 01:09:26.000000', 'consum', 0.0219, 'lps'),
	(631320, 133, '2015-01-01 01:09:27.000000', 'consum', 0.0225, 'lps'),
	(631321, 133, '2015-01-01 01:09:28.000000', 'consum', 0.0225, 'lps'),
	(631322, 133, '2015-01-01 01:09:29.000000', 'consum', 0.0211, 'lps'),
	(631323, 133, '2015-01-01 01:09:30.000000', 'consum', 0.0233, 'lps'),
	(631324, 133, '2015-01-01 01:09:31.000000', 'consum', 0.0228, 'lps'),
	(631325, 133, '2015-01-01 01:09:32.000000', 'consum', 0.0230, 'lps'),
	(631326, 133, '2015-01-01 01:09:33.000000', 'consum', 0.0224, 'lps'),
	(631327, 133, '2015-01-01 01:09:34.000000', 'consum', 0.0223, 'lps'),
	(631328, 133, '2015-01-01 01:09:35.000000', 'consum', 0.0233, 'lps'),
	(631329, 133, '2015-01-01 01:09:36.000000', 'consum', 0.0220, 'lps'),
	(631330, 133, '2015-01-01 01:09:37.000000', 'consum', 0.0227, 'lps'),
	(631331, 133, '2015-01-01 01:09:38.000000', 'consum', 0.0232, 'lps'),
	(631332, 133, '2015-01-01 01:09:39.000000', 'consum', 0.0236, 'lps'),
	(631333, 133, '2015-01-01 01:09:40.000000', 'consum', 0.0213, 'lps'),
	(631334, 133, '2015-01-01 01:09:41.000000', 'consum', 0.0241, 'lps'),
	(631335, 133, '2015-01-01 01:09:42.000000', 'consum', 0.0232, 'lps'),
	(631336, 133, '2015-01-01 01:09:43.000000', 'consum', 0.0224, 'lps'),
	(631337, 133, '2015-01-01 01:09:44.000000', 'consum', 0.0215, 'lps'),
	(631338, 133, '2015-01-01 01:09:45.000000', 'consum', 0.0226, 'lps'),
	(631339, 133, '2015-01-01 01:09:46.000000', 'consum', 0.0210, 'lps'),
	(631340, 133, '2015-01-01 01:09:47.000000', 'consum', 0.0227, 'lps'),
	(631341, 133, '2015-01-01 01:09:48.000000', 'consum', 0.0233, 'lps'),
	(631342, 133, '2015-01-01 01:09:49.000000', 'consum', 0.0211, 'lps'),
	(631343, 133, '2015-01-01 01:09:50.000000', 'consum', 0.0241, 'lps'),
	(631344, 133, '2015-01-01 01:09:51.000000', 'consum', 0.0236, 'lps'),
	(631345, 133, '2015-01-01 01:09:52.000000', 'consum', 0.0217, 'lps'),
	(631346, 133, '2015-01-01 01:09:53.000000', 'consum', 0.0229, 'lps'),
	(631347, 133, '2015-01-01 01:09:54.000000', 'consum', 0.0221, 'lps'),
	(631348, 133, '2015-01-01 01:09:55.000000', 'consum', 0.0210, 'lps'),
	(631349, 133, '2015-01-01 01:09:56.000000', 'consum', 0.0239, 'lps'),
	(631350, 133, '2015-01-01 01:09:57.000000', 'consum', 0.0230, 'lps'),
	(631351, 133, '2015-01-01 01:09:58.000000', 'consum', 0.0223, 'lps'),
	(631352, 133, '2015-01-01 01:09:59.000000', 'consum', 0.0214, 'lps'),
	(631353, 133, '2015-01-01 01:10:00.000000', 'consum', 0.0224, 'lps'),
	(631354, 133, '2015-01-01 01:10:01.000000', 'consum', 0.0236, 'lps'),
	(631355, 133, '2015-01-01 01:10:02.000000', 'consum', 0.0235, 'lps'),
	(631356, 133, '2015-01-01 01:10:03.000000', 'consum', 0.0224, 'lps'),
	(631357, 133, '2015-01-01 01:10:04.000000', 'consum', 0.0238, 'lps'),
	(631358, 133, '2015-01-01 01:10:05.000000', 'consum', 0.0211, 'lps'),
	(631359, 133, '2015-01-01 01:10:06.000000', 'consum', 0.0230, 'lps'),
	(631360, 133, '2015-01-01 01:10:07.000000', 'consum', 0.0211, 'lps'),
	(631361, 133, '2015-01-01 01:10:08.000000', 'consum', 0.0219, 'lps'),
	(631362, 133, '2015-01-01 01:10:09.000000', 'consum', 0.0220, 'lps'),
	(631363, 133, '2015-01-01 01:10:10.000000', 'consum', 0.0232, 'lps'),
	(631364, 133, '2015-01-01 01:10:11.000000', 'consum', 0.0229, 'lps'),
	(631365, 133, '2015-01-01 01:10:12.000000', 'consum', 0.0239, 'lps'),
	(631366, 133, '2015-01-01 01:10:13.000000', 'consum', 0.0233, 'lps'),
	(631367, 133, '2015-01-01 01:10:14.000000', 'consum', 0.0239, 'lps'),
	(631368, 133, '2015-01-01 01:10:15.000000', 'consum', 0.0224, 'lps'),
	(631369, 133, '2015-01-01 01:10:16.000000', 'consum', 0.0225, 'lps'),
	(631370, 133, '2015-01-01 01:10:17.000000', 'consum', 0.0212, 'lps'),
	(631371, 133, '2015-01-01 01:10:18.000000', 'consum', 0.0239, 'lps'),
	(631372, 133, '2015-01-01 01:10:19.000000', 'consum', 0.0221, 'lps'),
	(631373, 133, '2015-01-01 01:10:20.000000', 'consum', 0.0210, 'lps'),
	(631374, 133, '2015-01-01 01:10:21.000000', 'consum', 0.0210, 'lps'),
	(631375, 133, '2015-01-01 01:10:22.000000', 'consum', 0.0210, 'lps'),
	(631376, 133, '2015-01-01 01:10:23.000000', 'consum', 0.0213, 'lps'),
	(631377, 133, '2015-01-01 01:10:24.000000', 'consum', 0.0224, 'lps'),
	(631378, 133, '2015-01-01 01:10:25.000000', 'consum', 0.0240, 'lps'),
	(631379, 133, '2015-01-01 01:10:26.000000', 'consum', 0.0223, 'lps'),
	(631380, 133, '2015-01-01 01:10:27.000000', 'consum', 0.0217, 'lps'),
	(631381, 133, '2015-01-01 01:10:28.000000', 'consum', 0.0239, 'lps'),
	(631382, 133, '2015-01-01 01:10:29.000000', 'consum', 0.0240, 'lps'),
	(631383, 133, '2015-01-01 01:10:30.000000', 'consum', 0.0240, 'lps'),
	(631384, 133, '2015-01-01 01:10:31.000000', 'consum', 0.0237, 'lps'),
	(631385, 133, '2015-01-01 01:10:32.000000', 'consum', 0.0223, 'lps'),
	(631386, 133, '2015-01-01 01:10:33.000000', 'consum', 0.0226, 'lps'),
	(631387, 133, '2015-01-01 01:10:34.000000', 'consum', 0.0219, 'lps'),
	(631388, 133, '2015-01-01 01:10:35.000000', 'consum', 0.0239, 'lps'),
	(631389, 133, '2015-01-01 01:10:36.000000', 'consum', 0.0233, 'lps'),
	(631390, 133, '2015-01-01 01:10:37.000000', 'consum', 0.0237, 'lps'),
	(631391, 133, '2015-01-01 01:10:38.000000', 'consum', 0.0214, 'lps'),
	(631392, 133, '2015-01-01 01:10:39.000000', 'consum', 0.0212, 'lps'),
	(631393, 133, '2015-01-01 01:10:40.000000', 'consum', 0.0211, 'lps'),
	(631394, 133, '2015-01-01 01:10:41.000000', 'consum', 0.0239, 'lps'),
	(631395, 133, '2015-01-01 01:10:42.000000', 'consum', 0.0226, 'lps'),
	(631396, 133, '2015-01-01 01:10:43.000000', 'consum', 0.0235, 'lps'),
	(631397, 133, '2015-01-01 01:10:44.000000', 'consum', 0.0223, 'lps'),
	(631398, 133, '2015-01-01 01:10:45.000000', 'consum', 0.0233, 'lps'),
	(631399, 133, '2015-01-01 01:10:46.000000', 'consum', 0.0223, 'lps'),
	(631400, 133, '2015-01-01 01:10:47.000000', 'consum', 0.0237, 'lps'),
	(631401, 133, '2015-01-01 01:10:48.000000', 'consum', 0.0213, 'lps'),
	(631402, 133, '2015-01-01 01:10:49.000000', 'consum', 0.0238, 'lps'),
	(631403, 133, '2015-01-01 01:10:50.000000', 'consum', 0.0216, 'lps'),
	(631404, 133, '2015-01-01 01:10:51.000000', 'consum', 0.0218, 'lps'),
	(631405, 133, '2015-01-01 01:10:52.000000', 'consum', 0.0234, 'lps'),
	(631406, 133, '2015-01-01 01:10:53.000000', 'consum', 0.0211, 'lps'),
	(631407, 133, '2015-01-01 01:10:54.000000', 'consum', 0.0239, 'lps'),
	(631408, 133, '2015-01-01 01:10:55.000000', 'consum', 0.0224, 'lps'),
	(631409, 133, '2015-01-01 01:10:56.000000', 'consum', 0.0226, 'lps'),
	(631410, 133, '2015-01-01 01:10:57.000000', 'consum', 0.0217, 'lps'),
	(631411, 133, '2015-01-01 01:10:58.000000', 'consum', 0.0230, 'lps'),
	(631412, 133, '2015-01-01 01:10:59.000000', 'consum', 0.0227, 'lps'),
	(631413, 133, '2015-01-01 01:11:00.000000', 'consum', 0.0234, 'lps'),
	(631414, 133, '2015-01-01 01:11:01.000000', 'consum', 0.0215, 'lps'),
	(631415, 133, '2015-01-01 01:11:02.000000', 'consum', 0.0228, 'lps'),
	(631416, 133, '2015-01-01 01:11:03.000000', 'consum', 0.0223, 'lps'),
	(631417, 133, '2015-01-01 01:11:04.000000', 'consum', 0.0222, 'lps'),
	(631418, 133, '2015-01-01 01:11:05.000000', 'consum', 0.0232, 'lps'),
	(631419, 133, '2015-01-01 01:11:06.000000', 'consum', 0.0218, 'lps'),
	(631420, 133, '2015-01-01 01:11:07.000000', 'consum', 0.0217, 'lps'),
	(631421, 133, '2015-01-01 01:11:08.000000', 'consum', 0.0223, 'lps'),
	(631422, 133, '2015-01-01 01:11:09.000000', 'consum', 0.0221, 'lps'),
	(631423, 133, '2015-01-01 01:11:10.000000', 'consum', 0.0226, 'lps'),
	(631424, 133, '2015-01-01 01:11:11.000000', 'consum', 0.0227, 'lps'),
	(631425, 133, '2015-01-01 01:11:12.000000', 'consum', 0.0213, 'lps'),
	(631426, 133, '2015-01-01 01:11:13.000000', 'consum', 0.0210, 'lps'),
	(631427, 133, '2015-01-01 01:11:14.000000', 'consum', 0.0231, 'lps'),
	(631428, 133, '2015-01-01 01:11:15.000000', 'consum', 0.0218, 'lps'),
	(631429, 133, '2015-01-01 01:11:16.000000', 'consum', 0.0222, 'lps'),
	(631430, 133, '2015-01-01 01:11:17.000000', 'consum', 0.0212, 'lps'),
	(631431, 133, '2015-01-01 01:11:18.000000', 'consum', 0.0218, 'lps'),
	(631432, 133, '2015-01-01 01:11:19.000000', 'consum', 0.0214, 'lps'),
	(631433, 133, '2015-01-01 01:11:20.000000', 'consum', 0.0237, 'lps'),
	(631434, 133, '2015-01-01 01:11:21.000000', 'consum', 0.0239, 'lps'),
	(631435, 133, '2015-01-01 01:11:22.000000', 'consum', 0.0211, 'lps'),
	(631436, 133, '2015-01-01 01:11:23.000000', 'consum', 0.0224, 'lps'),
	(631437, 133, '2015-01-01 01:11:24.000000', 'consum', 0.0215, 'lps'),
	(631438, 133, '2015-01-01 01:11:25.000000', 'consum', 0.0225, 'lps'),
	(631439, 133, '2015-01-01 01:11:26.000000', 'consum', 0.0239, 'lps'),
	(631440, 133, '2015-01-01 01:11:27.000000', 'consum', 0.0213, 'lps'),
	(631441, 133, '2015-01-01 01:11:28.000000', 'consum', 0.0236, 'lps'),
	(631442, 133, '2015-01-01 01:11:29.000000', 'consum', 0.0233, 'lps'),
	(631443, 133, '2015-01-01 01:11:30.000000', 'consum', 0.0216, 'lps'),
	(631444, 133, '2015-01-01 01:11:31.000000', 'consum', 0.0236, 'lps'),
	(631445, 133, '2015-01-01 01:11:32.000000', 'consum', 0.0227, 'lps'),
	(631446, 133, '2015-01-01 01:11:33.000000', 'consum', 0.0215, 'lps'),
	(631447, 133, '2015-01-01 01:11:34.000000', 'consum', 0.0219, 'lps'),
	(631448, 133, '2015-01-01 01:11:35.000000', 'consum', 0.0241, 'lps'),
	(631449, 133, '2015-01-01 01:11:36.000000', 'consum', 0.0241, 'lps'),
	(631450, 133, '2015-01-01 01:11:37.000000', 'consum', 0.0241, 'lps'),
	(631451, 133, '2015-01-01 01:11:38.000000', 'consum', 0.0239, 'lps'),
	(631452, 133, '2015-01-01 01:11:39.000000', 'consum', 0.0233, 'lps'),
	(631453, 133, '2015-01-01 01:11:40.000000', 'consum', 0.0237, 'lps'),
	(631454, 133, '2015-01-01 01:11:41.000000', 'consum', 0.0214, 'lps'),
	(631455, 133, '2015-01-01 01:11:42.000000', 'consum', 0.0212, 'lps'),
	(631456, 133, '2015-01-01 01:11:43.000000', 'consum', 0.0210, 'lps'),
	(631457, 133, '2015-01-01 01:11:44.000000', 'consum', 0.0234, 'lps'),
	(631458, 133, '2015-01-01 01:11:45.000000', 'consum', 0.0234, 'lps'),
	(631459, 133, '2015-01-01 01:11:46.000000', 'consum', 0.0229, 'lps'),
	(631460, 133, '2015-01-01 01:11:47.000000', 'consum', 0.0234, 'lps'),
	(631461, 133, '2015-01-01 01:11:48.000000', 'consum', 0.0240, 'lps'),
	(631462, 133, '2015-01-01 01:11:49.000000', 'consum', 0.0224, 'lps'),
	(631463, 133, '2015-01-01 01:11:50.000000', 'consum', 0.0222, 'lps'),
	(631464, 133, '2015-01-01 01:11:51.000000', 'consum', 0.0229, 'lps'),
	(631465, 133, '2015-01-01 01:11:52.000000', 'consum', 0.0240, 'lps'),
	(631466, 133, '2015-01-01 01:11:53.000000', 'consum', 0.0236, 'lps'),
	(631467, 133, '2015-01-01 01:11:54.000000', 'consum', 0.0221, 'lps'),
	(631468, 133, '2015-01-01 01:11:55.000000', 'consum', 0.0220, 'lps'),
	(631469, 133, '2015-01-01 01:11:56.000000', 'consum', 0.0224, 'lps'),
	(631470, 133, '2015-01-01 01:11:57.000000', 'consum', 0.0222, 'lps'),
	(631471, 133, '2015-01-01 01:11:58.000000', 'consum', 0.0229, 'lps'),
	(631472, 133, '2015-01-01 01:11:59.000000', 'consum', 0.0236, 'lps'),
	(631473, 133, '2015-01-01 01:12:00.000000', 'consum', 0.0219, 'lps'),
	(631474, 133, '2015-01-01 01:12:01.000000', 'consum', 0.0211, 'lps'),
	(631475, 133, '2015-01-01 01:12:02.000000', 'consum', 0.0220, 'lps'),
	(631476, 133, '2015-01-01 01:12:03.000000', 'consum', 0.0226, 'lps'),
	(631477, 133, '2015-01-01 01:12:04.000000', 'consum', 0.0229, 'lps'),
	(631478, 133, '2015-01-01 01:12:05.000000', 'consum', 0.0226, 'lps'),
	(631479, 133, '2015-01-01 01:12:06.000000', 'consum', 0.0233, 'lps'),
	(631480, 133, '2015-01-01 01:12:07.000000', 'consum', 0.0215, 'lps'),
	(631481, 133, '2015-01-01 01:12:08.000000', 'consum', 0.0228, 'lps'),
	(631482, 133, '2015-01-01 01:12:09.000000', 'consum', 0.0221, 'lps'),
	(631483, 133, '2015-01-01 01:12:10.000000', 'consum', 0.0213, 'lps'),
	(631484, 133, '2015-01-01 01:12:11.000000', 'consum', 0.0226, 'lps'),
	(631485, 133, '2015-01-01 01:12:12.000000', 'consum', 0.0216, 'lps'),
	(631486, 133, '2015-01-01 01:12:13.000000', 'consum', 0.0225, 'lps'),
	(631487, 133, '2015-01-01 01:12:14.000000', 'consum', 0.0233, 'lps'),
	(631488, 133, '2015-01-01 01:12:15.000000', 'consum', 0.0220, 'lps'),
	(631489, 133, '2015-01-01 01:12:16.000000', 'consum', 0.0221, 'lps'),
	(631490, 133, '2015-01-01 01:12:17.000000', 'consum', 0.0238, 'lps'),
	(631491, 133, '2015-01-01 01:12:18.000000', 'consum', 0.0221, 'lps'),
	(631492, 133, '2015-01-01 01:12:19.000000', 'consum', 0.0214, 'lps'),
	(631493, 133, '2015-01-01 01:12:20.000000', 'consum', 0.0229, 'lps'),
	(631494, 133, '2015-01-01 01:12:21.000000', 'consum', 0.0229, 'lps'),
	(631495, 134, '2015-01-01 00:00:00.000000', 'consum', 0.0213, 'lps'),
	(631496, 134, '2015-01-01 00:00:01.000000', 'consum', 0.0239, 'lps'),
	(631497, 134, '2015-01-01 00:00:02.000000', 'consum', 0.0210, 'lps'),
	(631498, 134, '2015-01-01 00:00:03.000000', 'consum', 0.0214, 'lps'),
	(631499, 134, '2015-01-01 00:00:04.000000', 'consum', 0.0231, 'lps'),
	(631500, 134, '2015-01-01 00:00:05.000000', 'consum', 0.0214, 'lps'),
	(631501, 134, '2015-01-01 00:00:06.000000', 'consum', 0.0213, 'lps'),
	(631502, 134, '2015-01-01 00:00:07.000000', 'consum', 0.0213, 'lps'),
	(631503, 134, '2015-01-01 00:00:08.000000', 'consum', 0.0215, 'lps'),
	(631504, 134, '2015-01-01 00:00:09.000000', 'consum', 0.0228, 'lps'),
	(631505, 134, '2015-01-01 00:00:10.000000', 'consum', 0.0241, 'lps'),
	(631506, 134, '2015-01-01 00:00:11.000000', 'consum', 0.0220, 'lps'),
	(631507, 134, '2015-01-01 00:00:12.000000', 'consum', 0.0212, 'lps'),
	(631508, 134, '2015-01-01 00:00:13.000000', 'consum', 0.0234, 'lps'),
	(631509, 134, '2015-01-01 00:00:14.000000', 'consum', 0.0237, 'lps'),
	(631510, 134, '2015-01-01 00:00:15.000000', 'consum', 0.0226, 'lps'),
	(631511, 134, '2015-01-01 00:00:16.000000', 'consum', 0.0211, 'lps'),
	(631512, 134, '2015-01-01 00:00:17.000000', 'consum', 0.0212, 'lps'),
	(631513, 134, '2015-01-01 00:00:18.000000', 'consum', 0.0216, 'lps'),
	(631514, 134, '2015-01-01 00:00:19.000000', 'consum', 0.0235, 'lps'),
	(631515, 134, '2015-01-01 00:00:20.000000', 'consum', 0.0227, 'lps'),
	(631516, 134, '2015-01-01 00:00:21.000000', 'consum', 0.0221, 'lps'),
	(631517, 134, '2015-01-01 00:00:22.000000', 'consum', 0.0215, 'lps'),
	(631518, 134, '2015-01-01 00:00:23.000000', 'consum', 0.0246, 'lps'),
	(631519, 134, '2015-01-01 00:00:24.000000', 'consum', 0.0241, 'lps'),
	(631520, 134, '2015-01-01 00:00:25.000000', 'consum', 0.0213, 'lps'),
	(631521, 134, '2015-01-01 00:00:26.000000', 'consum', 0.0221, 'lps'),
	(631522, 134, '2015-01-01 00:00:27.000000', 'consum', 0.0210, 'lps'),
	(631523, 134, '2015-01-01 00:00:28.000000', 'consum', 0.0226, 'lps'),
	(631524, 134, '2015-01-01 00:00:29.000000', 'consum', 0.0244, 'lps'),
	(631525, 134, '2015-01-01 00:00:30.000000', 'consum', 0.0245, 'lps'),
	(631526, 134, '2015-01-01 00:00:31.000000', 'consum', 0.0236, 'lps'),
	(631527, 134, '2015-01-01 00:00:32.000000', 'consum', 0.0234, 'lps'),
	(631528, 134, '2015-01-01 00:00:33.000000', 'consum', 0.0210, 'lps'),
	(631529, 134, '2015-01-01 00:00:34.000000', 'consum', 0.0229, 'lps'),
	(631530, 134, '2015-01-01 00:00:35.000000', 'consum', 0.0214, 'lps'),
	(631531, 134, '2015-01-01 00:00:36.000000', 'consum', 0.0220, 'lps'),
	(631532, 134, '2015-01-01 00:00:37.000000', 'consum', 0.0249, 'lps'),
	(631533, 134, '2015-01-01 00:00:38.000000', 'consum', 0.0240, 'lps'),
	(631534, 134, '2015-01-01 00:00:39.000000', 'consum', 0.0244, 'lps'),
	(631535, 134, '2015-01-01 00:00:40.000000', 'consum', 0.0244, 'lps'),
	(631536, 134, '2015-01-01 00:00:41.000000', 'consum', 0.0234, 'lps'),
	(631537, 134, '2015-01-01 00:00:42.000000', 'consum', 0.0228, 'lps'),
	(631538, 134, '2015-01-01 00:00:43.000000', 'consum', 0.0229, 'lps'),
	(631539, 134, '2015-01-01 00:00:44.000000', 'consum', 0.0250, 'lps'),
	(631540, 134, '2015-01-01 00:00:45.000000', 'consum', 0.0219, 'lps'),
	(631541, 134, '2015-01-01 00:00:46.000000', 'consum', 0.0227, 'lps'),
	(631542, 134, '2015-01-01 00:00:47.000000', 'consum', 0.0223, 'lps'),
	(631543, 134, '2015-01-01 00:00:48.000000', 'consum', 0.0224, 'lps'),
	(631544, 134, '2015-01-01 00:00:49.000000', 'consum', 0.0241, 'lps'),
	(631545, 134, '2015-01-01 00:00:50.000000', 'consum', 0.0236, 'lps'),
	(631546, 134, '2015-01-01 00:00:51.000000', 'consum', 0.0245, 'lps'),
	(631547, 134, '2015-01-01 00:00:52.000000', 'consum', 0.0220, 'lps'),
	(631548, 134, '2015-01-01 00:00:53.000000', 'consum', 0.0244, 'lps'),
	(631549, 134, '2015-01-01 00:00:54.000000', 'consum', 0.0216, 'lps'),
	(631550, 134, '2015-01-01 00:00:55.000000', 'consum', 0.0227, 'lps'),
	(631551, 134, '2015-01-01 00:00:56.000000', 'consum', 0.0232, 'lps'),
	(631552, 134, '2015-01-01 00:00:57.000000', 'consum', 0.0227, 'lps'),
	(631553, 134, '2015-01-01 00:00:58.000000', 'consum', 0.0227, 'lps'),
	(631554, 134, '2015-01-01 00:00:59.000000', 'consum', 0.0244, 'lps'),
	(631555, 134, '2015-01-01 00:01:00.000000', 'consum', 0.0240, 'lps'),
	(631556, 134, '2015-01-01 00:01:01.000000', 'consum', 0.0216, 'lps'),
	(631557, 134, '2015-01-01 00:01:02.000000', 'consum', 0.0239, 'lps'),
	(631558, 134, '2015-01-01 00:01:03.000000', 'consum', 0.0246, 'lps'),
	(631559, 134, '2015-01-01 00:01:04.000000', 'consum', 0.0215, 'lps'),
	(631560, 134, '2015-01-01 00:01:05.000000', 'consum', 0.0216, 'lps'),
	(631561, 134, '2015-01-01 00:01:06.000000', 'consum', 0.0225, 'lps'),
	(631562, 134, '2015-01-01 00:01:07.000000', 'consum', 0.0225, 'lps'),
	(631563, 134, '2015-01-01 00:01:08.000000', 'consum', 0.0239, 'lps'),
	(631564, 134, '2015-01-01 00:01:09.000000', 'consum', 0.0222, 'lps'),
	(631565, 134, '2015-01-01 00:01:10.000000', 'consum', 0.0228, 'lps'),
	(631566, 134, '2015-01-01 00:01:11.000000', 'consum', 0.0221, 'lps'),
	(631567, 134, '2015-01-01 00:01:12.000000', 'consum', 0.0210, 'lps'),
	(631568, 134, '2015-01-01 00:01:13.000000', 'consum', 0.0221, 'lps'),
	(631569, 134, '2015-01-01 00:01:14.000000', 'consum', 0.0224, 'lps'),
	(631570, 134, '2015-01-01 00:01:15.000000', 'consum', 0.0245, 'lps'),
	(631571, 134, '2015-01-01 00:01:16.000000', 'consum', 0.0253, 'lps'),
	(631572, 134, '2015-01-01 00:01:17.000000', 'consum', 0.0233, 'lps'),
	(631573, 134, '2015-01-01 00:01:18.000000', 'consum', 0.0239, 'lps'),
	(631574, 134, '2015-01-01 00:01:19.000000', 'consum', 0.0242, 'lps'),
	(631575, 134, '2015-01-01 00:01:20.000000', 'consum', 0.0239, 'lps'),
	(631576, 134, '2015-01-01 00:01:21.000000', 'consum', 0.0213, 'lps'),
	(631577, 134, '2015-01-01 00:01:22.000000', 'consum', 0.0229, 'lps'),
	(631578, 134, '2015-01-01 00:01:23.000000', 'consum', 0.0252, 'lps'),
	(631579, 134, '2015-01-01 00:01:24.000000', 'consum', 0.0228, 'lps'),
	(631580, 134, '2015-01-01 00:01:25.000000', 'consum', 0.0219, 'lps'),
	(631581, 134, '2015-01-01 00:01:26.000000', 'consum', 0.0245, 'lps'),
	(631582, 134, '2015-01-01 00:01:27.000000', 'consum', 0.0225, 'lps'),
	(631583, 134, '2015-01-01 00:01:28.000000', 'consum', 0.0225, 'lps'),
	(631584, 134, '2015-01-01 00:01:29.000000', 'consum', 0.0241, 'lps'),
	(631585, 134, '2015-01-01 00:01:30.000000', 'consum', 0.0230, 'lps'),
	(631586, 134, '2015-01-01 00:01:31.000000', 'consum', 0.0216, 'lps'),
	(631587, 134, '2015-01-01 00:01:32.000000', 'consum', 0.0225, 'lps'),
	(631588, 134, '2015-01-01 00:01:33.000000', 'consum', 0.0225, 'lps'),
	(631589, 134, '2015-01-01 00:01:34.000000', 'consum', 0.0239, 'lps'),
	(631590, 134, '2015-01-01 00:01:35.000000', 'consum', 0.0219, 'lps'),
	(631591, 134, '2015-01-01 00:01:36.000000', 'consum', 0.0216, 'lps'),
	(631592, 134, '2015-01-01 00:01:37.000000', 'consum', 0.0213, 'lps'),
	(631593, 134, '2015-01-01 00:01:38.000000', 'consum', 0.0253, 'lps'),
	(631594, 134, '2015-01-01 00:01:39.000000', 'consum', 0.0235, 'lps'),
	(631595, 134, '2015-01-01 00:01:40.000000', 'consum', 0.0253, 'lps'),
	(631596, 134, '2015-01-01 00:01:41.000000', 'consum', 0.0213, 'lps'),
	(631597, 134, '2015-01-01 00:01:42.000000', 'consum', 0.0234, 'lps'),
	(631598, 134, '2015-01-01 00:01:43.000000', 'consum', 0.0230, 'lps'),
	(631599, 134, '2015-01-01 00:01:44.000000', 'consum', 0.0238, 'lps'),
	(631600, 134, '2015-01-01 00:01:45.000000', 'consum', 0.0245, 'lps'),
	(631601, 134, '2015-01-01 00:01:46.000000', 'consum', 0.0213, 'lps'),
	(631602, 134, '2015-01-01 00:01:47.000000', 'consum', 0.0210, 'lps'),
	(631603, 134, '2015-01-01 00:01:48.000000', 'consum', 0.0247, 'lps'),
	(631604, 134, '2015-01-01 00:01:49.000000', 'consum', 0.0214, 'lps'),
	(631605, 134, '2015-01-01 00:01:50.000000', 'consum', 0.0254, 'lps'),
	(631606, 134, '2015-01-01 00:01:51.000000', 'consum', 0.0239, 'lps'),
	(631607, 134, '2015-01-01 00:01:52.000000', 'consum', 0.0222, 'lps'),
	(631608, 134, '2015-01-01 00:01:53.000000', 'consum', 0.0228, 'lps'),
	(631609, 134, '2015-01-01 00:01:54.000000', 'consum', 0.0223, 'lps'),
	(631610, 134, '2015-01-01 00:01:55.000000', 'consum', 0.0218, 'lps'),
	(631611, 134, '2015-01-01 00:01:56.000000', 'consum', 0.0212, 'lps'),
	(631612, 134, '2015-01-01 00:01:57.000000', 'consum', 0.0243, 'lps'),
	(631613, 134, '2015-01-01 00:01:58.000000', 'consum', 0.0234, 'lps'),
	(631614, 134, '2015-01-01 00:01:59.000000', 'consum', 0.0232, 'lps'),
	(631615, 134, '2015-01-01 00:02:00.000000', 'consum', 0.0248, 'lps'),
	(631616, 134, '2015-01-01 00:02:01.000000', 'consum', 0.0244, 'lps'),
	(631617, 134, '2015-01-01 00:02:02.000000', 'consum', 0.0221, 'lps'),
	(631618, 134, '2015-01-01 00:02:03.000000', 'consum', 0.0211, 'lps'),
	(631619, 134, '2015-01-01 00:02:04.000000', 'consum', 0.0227, 'lps'),
	(631620, 134, '2015-01-01 00:02:05.000000', 'consum', 0.0246, 'lps'),
	(631621, 134, '2015-01-01 00:02:06.000000', 'consum', 0.0252, 'lps'),
	(631622, 134, '2015-01-01 00:02:07.000000', 'consum', 0.0221, 'lps'),
	(631623, 134, '2015-01-01 00:02:08.000000', 'consum', 0.0228, 'lps'),
	(631624, 134, '2015-01-01 00:02:09.000000', 'consum', 0.0223, 'lps'),
	(631625, 134, '2015-01-01 00:02:10.000000', 'consum', 0.0224, 'lps'),
	(631626, 134, '2015-01-01 00:02:11.000000', 'consum', 0.0239, 'lps'),
	(631627, 134, '2015-01-01 00:02:12.000000', 'consum', 0.0223, 'lps'),
	(631628, 134, '2015-01-01 00:02:13.000000', 'consum', 0.0232, 'lps'),
	(631629, 134, '2015-01-01 00:02:14.000000', 'consum', 0.0240, 'lps'),
	(631630, 134, '2015-01-01 00:02:15.000000', 'consum', 0.0246, 'lps'),
	(631631, 134, '2015-01-01 00:02:16.000000', 'consum', 0.0214, 'lps'),
	(631632, 134, '2015-01-01 00:02:17.000000', 'consum', 0.0210, 'lps'),
	(631633, 134, '2015-01-01 00:02:18.000000', 'consum', 0.0244, 'lps'),
	(631634, 134, '2015-01-01 00:02:19.000000', 'consum', 0.0244, 'lps'),
	(631635, 134, '2015-01-01 00:02:20.000000', 'consum', 0.0233, 'lps'),
	(631636, 134, '2015-01-01 00:02:21.000000', 'consum', 0.0225, 'lps'),
	(631637, 134, '2015-01-01 00:02:22.000000', 'consum', 0.0216, 'lps'),
	(631638, 134, '2015-01-01 00:02:23.000000', 'consum', 0.0241, 'lps'),
	(631639, 134, '2015-01-01 00:02:24.000000', 'consum', 0.0211, 'lps'),
	(631640, 134, '2015-01-01 00:02:25.000000', 'consum', 0.0215, 'lps'),
	(631641, 134, '2015-01-01 00:02:26.000000', 'consum', 0.0232, 'lps'),
	(631642, 134, '2015-01-01 00:02:27.000000', 'consum', 0.0217, 'lps'),
	(631643, 134, '2015-01-01 00:02:28.000000', 'consum', 0.0221, 'lps'),
	(631644, 134, '2015-01-01 00:02:29.000000', 'consum', 0.0248, 'lps'),
	(631645, 134, '2015-01-01 00:02:30.000000', 'consum', 0.0231, 'lps'),
	(631646, 134, '2015-01-01 00:02:31.000000', 'consum', 0.0247, 'lps'),
	(631647, 134, '2015-01-01 00:02:32.000000', 'consum', 0.0242, 'lps'),
	(631648, 134, '2015-01-01 00:02:33.000000', 'consum', 0.0214, 'lps'),
	(631649, 134, '2015-01-01 00:02:34.000000', 'consum', 0.0225, 'lps'),
	(631650, 134, '2015-01-01 00:02:35.000000', 'consum', 0.0227, 'lps'),
	(631651, 134, '2015-01-01 00:02:36.000000', 'consum', 0.0253, 'lps'),
	(631652, 134, '2015-01-01 00:02:37.000000', 'consum', 0.0238, 'lps'),
	(631653, 134, '2015-01-01 00:02:38.000000', 'consum', 0.0223, 'lps'),
	(631654, 134, '2015-01-01 00:02:39.000000', 'consum', 0.0236, 'lps'),
	(631655, 134, '2015-01-01 00:02:40.000000', 'consum', 0.0212, 'lps'),
	(631656, 134, '2015-01-01 00:02:41.000000', 'consum', 0.0233, 'lps'),
	(631657, 134, '2015-01-01 00:02:42.000000', 'consum', 0.0229, 'lps'),
	(631658, 134, '2015-01-01 00:02:43.000000', 'consum', 0.0235, 'lps'),
	(631659, 134, '2015-01-01 00:02:44.000000', 'consum', 0.0235, 'lps'),
	(631660, 134, '2015-01-01 00:02:45.000000', 'consum', 0.0216, 'lps'),
	(631661, 134, '2015-01-01 00:02:46.000000', 'consum', 0.0253, 'lps'),
	(631662, 134, '2015-01-01 00:02:47.000000', 'consum', 0.0228, 'lps'),
	(631663, 134, '2015-01-01 00:02:48.000000', 'consum', 0.0216, 'lps'),
	(631664, 134, '2015-01-01 00:02:49.000000', 'consum', 0.0234, 'lps'),
	(631665, 134, '2015-01-01 00:02:50.000000', 'consum', 0.0220, 'lps'),
	(631666, 134, '2015-01-01 00:02:51.000000', 'consum', 0.0234, 'lps'),
	(631667, 134, '2015-01-01 00:02:52.000000', 'consum', 0.0210, 'lps'),
	(631668, 134, '2015-01-01 00:02:53.000000', 'consum', 0.0227, 'lps'),
	(631669, 134, '2015-01-01 00:02:54.000000', 'consum', 0.0253, 'lps'),
	(631670, 134, '2015-01-01 00:02:55.000000', 'consum', 0.0237, 'lps'),
	(631671, 134, '2015-01-01 00:02:56.000000', 'consum', 0.0218, 'lps'),
	(631672, 134, '2015-01-01 00:02:57.000000', 'consum', 0.0213, 'lps'),
	(631673, 134, '2015-01-01 00:02:58.000000', 'consum', 0.0246, 'lps'),
	(631674, 134, '2015-01-01 00:02:59.000000', 'consum', 0.0248, 'lps'),
	(631675, 134, '2015-01-01 00:03:00.000000', 'consum', 0.0249, 'lps'),
	(631676, 134, '2015-01-01 00:03:01.000000', 'consum', 0.0246, 'lps'),
	(631677, 134, '2015-01-01 00:03:02.000000', 'consum', 0.0230, 'lps'),
	(631678, 134, '2015-01-01 00:03:03.000000', 'consum', 0.0245, 'lps'),
	(631679, 134, '2015-01-01 00:03:04.000000', 'consum', 0.0235, 'lps'),
	(631680, 134, '2015-01-01 00:03:05.000000', 'consum', 0.0233, 'lps'),
	(631681, 134, '2015-01-01 00:03:06.000000', 'consum', 0.0247, 'lps'),
	(631682, 134, '2015-01-01 00:03:07.000000', 'consum', 0.0240, 'lps'),
	(631683, 134, '2015-01-01 00:03:08.000000', 'consum', 0.0247, 'lps'),
	(631684, 134, '2015-01-01 00:03:09.000000', 'consum', 0.0215, 'lps'),
	(631685, 134, '2015-01-01 00:03:10.000000', 'consum', 0.0217, 'lps'),
	(631686, 134, '2015-01-01 00:03:11.000000', 'consum', 0.0228, 'lps'),
	(631687, 134, '2015-01-01 00:03:12.000000', 'consum', 0.0233, 'lps'),
	(631688, 134, '2015-01-01 00:03:13.000000', 'consum', 0.0230, 'lps'),
	(631689, 134, '2015-01-01 00:03:14.000000', 'consum', 0.0239, 'lps'),
	(631690, 134, '2015-01-01 00:03:15.000000', 'consum', 0.0251, 'lps'),
	(631691, 134, '2015-01-01 00:03:16.000000', 'consum', 0.0239, 'lps'),
	(631692, 134, '2015-01-01 00:03:17.000000', 'consum', 0.0232, 'lps'),
	(631693, 134, '2015-01-01 00:03:18.000000', 'consum', 0.0235, 'lps'),
	(631694, 134, '2015-01-01 00:03:19.000000', 'consum', 0.0223, 'lps'),
	(631695, 134, '2015-01-01 00:03:20.000000', 'consum', 0.0245, 'lps'),
	(631696, 134, '2015-01-01 00:03:21.000000', 'consum', 0.0214, 'lps'),
	(631697, 134, '2015-01-01 00:03:22.000000', 'consum', 0.0215, 'lps'),
	(631698, 134, '2015-01-01 00:03:23.000000', 'consum', 0.0221, 'lps'),
	(631699, 134, '2015-01-01 00:03:24.000000', 'consum', 0.0254, 'lps'),
	(631700, 134, '2015-01-01 00:03:25.000000', 'consum', 0.0214, 'lps'),
	(631701, 134, '2015-01-01 00:03:26.000000', 'consum', 0.0236, 'lps'),
	(631702, 134, '2015-01-01 00:03:27.000000', 'consum', 0.0237, 'lps'),
	(631703, 134, '2015-01-01 00:03:28.000000', 'consum', 0.0224, 'lps'),
	(631704, 134, '2015-01-01 00:03:29.000000', 'consum', 0.0242, 'lps'),
	(631705, 134, '2015-01-01 00:03:30.000000', 'consum', 0.0239, 'lps'),
	(631706, 134, '2015-01-01 00:03:31.000000', 'consum', 0.0213, 'lps'),
	(631707, 134, '2015-01-01 00:03:32.000000', 'consum', 0.0230, 'lps'),
	(631708, 134, '2015-01-01 00:03:33.000000', 'consum', 0.0213, 'lps'),
	(631709, 134, '2015-01-01 00:03:34.000000', 'consum', 0.0211, 'lps'),
	(631710, 134, '2015-01-01 00:03:35.000000', 'consum', 0.0248, 'lps'),
	(631711, 134, '2015-01-01 00:03:36.000000', 'consum', 0.0220, 'lps'),
	(631712, 134, '2015-01-01 00:03:37.000000', 'consum', 0.0237, 'lps'),
	(631713, 134, '2015-01-01 00:03:38.000000', 'consum', 0.0224, 'lps'),
	(631714, 134, '2015-01-01 00:03:39.000000', 'consum', 0.0245, 'lps'),
	(631715, 134, '2015-01-01 00:03:40.000000', 'consum', 0.0210, 'lps'),
	(631716, 134, '2015-01-01 00:03:41.000000', 'consum', 0.0240, 'lps'),
	(631717, 134, '2015-01-01 00:03:42.000000', 'consum', 0.0226, 'lps'),
	(631718, 134, '2015-01-01 00:03:43.000000', 'consum', 0.0246, 'lps'),
	(631719, 134, '2015-01-01 00:03:44.000000', 'consum', 0.0253, 'lps'),
	(631720, 134, '2015-01-01 00:03:45.000000', 'consum', 0.0229, 'lps'),
	(631721, 134, '2015-01-01 00:03:46.000000', 'consum', 0.0218, 'lps'),
	(631722, 134, '2015-01-01 00:03:47.000000', 'consum', 0.0240, 'lps'),
	(631723, 134, '2015-01-01 00:03:48.000000', 'consum', 0.0246, 'lps'),
	(631724, 134, '2015-01-01 00:03:49.000000', 'consum', 0.0254, 'lps'),
	(631725, 134, '2015-01-01 00:03:50.000000', 'consum', 0.0233, 'lps'),
	(631726, 134, '2015-01-01 00:03:51.000000', 'consum', 0.0241, 'lps'),
	(631727, 134, '2015-01-01 00:03:52.000000', 'consum', 0.0249, 'lps'),
	(631728, 134, '2015-01-01 00:03:53.000000', 'consum', 0.0224, 'lps'),
	(631729, 134, '2015-01-01 00:03:54.000000', 'consum', 0.0252, 'lps'),
	(631730, 134, '2015-01-01 00:03:55.000000', 'consum', 0.0242, 'lps'),
	(631731, 134, '2015-01-01 00:03:56.000000', 'consum', 0.0246, 'lps'),
	(631732, 134, '2015-01-01 00:03:57.000000', 'consum', 0.0251, 'lps'),
	(631733, 134, '2015-01-01 00:03:58.000000', 'consum', 0.0217, 'lps'),
	(631734, 134, '2015-01-01 00:03:59.000000', 'consum', 0.0214, 'lps'),
	(631735, 134, '2015-01-01 00:04:00.000000', 'consum', 0.0254, 'lps'),
	(631736, 134, '2015-01-01 00:04:01.000000', 'consum', 0.0237, 'lps'),
	(631737, 134, '2015-01-01 00:04:02.000000', 'consum', 0.0215, 'lps'),
	(631738, 134, '2015-01-01 00:04:03.000000', 'consum', 0.0244, 'lps'),
	(631739, 134, '2015-01-01 00:04:04.000000', 'consum', 0.0229, 'lps'),
	(631740, 134, '2015-01-01 00:04:05.000000', 'consum', 0.0251, 'lps'),
	(631741, 134, '2015-01-01 00:04:06.000000', 'consum', 0.0221, 'lps'),
	(631742, 134, '2015-01-01 00:04:07.000000', 'consum', 0.0232, 'lps'),
	(631743, 134, '2015-01-01 00:04:08.000000', 'consum', 0.0245, 'lps'),
	(631744, 134, '2015-01-01 00:04:09.000000', 'consum', 0.0229, 'lps'),
	(631745, 134, '2015-01-01 00:04:10.000000', 'consum', 0.0244, 'lps'),
	(631746, 134, '2015-01-01 00:04:11.000000', 'consum', 0.0234, 'lps'),
	(631747, 134, '2015-01-01 00:04:12.000000', 'consum', 0.0230, 'lps'),
	(631748, 134, '2015-01-01 00:04:13.000000', 'consum', 0.0239, 'lps'),
	(631749, 134, '2015-01-01 00:04:14.000000', 'consum', 0.0248, 'lps'),
	(631750, 134, '2015-01-01 00:04:15.000000', 'consum', 0.0225, 'lps'),
	(631751, 134, '2015-01-01 00:04:16.000000', 'consum', 0.0216, 'lps'),
	(631752, 134, '2015-01-01 00:04:17.000000', 'consum', 0.0243, 'lps'),
	(631753, 134, '2015-01-01 00:04:18.000000', 'consum', 0.0220, 'lps'),
	(631754, 134, '2015-01-01 00:04:19.000000', 'consum', 0.0250, 'lps'),
	(631755, 134, '2015-01-01 00:04:20.000000', 'consum', 0.0247, 'lps'),
	(631756, 134, '2015-01-01 00:04:21.000000', 'consum', 0.0232, 'lps'),
	(631757, 134, '2015-01-01 00:04:22.000000', 'consum', 0.0251, 'lps'),
	(631758, 134, '2015-01-01 00:04:23.000000', 'consum', 0.0218, 'lps'),
	(631759, 134, '2015-01-01 00:04:24.000000', 'consum', 0.0215, 'lps'),
	(631760, 134, '2015-01-01 00:04:25.000000', 'consum', 0.0211, 'lps'),
	(631761, 134, '2015-01-01 00:04:26.000000', 'consum', 0.0245, 'lps'),
	(631762, 134, '2015-01-01 00:04:27.000000', 'consum', 0.0247, 'lps'),
	(631763, 134, '2015-01-01 00:04:28.000000', 'consum', 0.0248, 'lps'),
	(631764, 134, '2015-01-01 00:04:29.000000', 'consum', 0.0241, 'lps'),
	(631765, 134, '2015-01-01 00:04:30.000000', 'consum', 0.0210, 'lps'),
	(631766, 134, '2015-01-01 00:04:31.000000', 'consum', 0.0251, 'lps'),
	(631767, 134, '2015-01-01 00:04:32.000000', 'consum', 0.0237, 'lps'),
	(631768, 134, '2015-01-01 00:04:33.000000', 'consum', 0.0221, 'lps'),
	(631769, 134, '2015-01-01 00:04:34.000000', 'consum', 0.0231, 'lps'),
	(631770, 134, '2015-01-01 00:04:35.000000', 'consum', 0.0237, 'lps'),
	(631771, 134, '2015-01-01 00:04:36.000000', 'consum', 0.0239, 'lps'),
	(631772, 134, '2015-01-01 00:04:37.000000', 'consum', 0.0229, 'lps'),
	(631773, 134, '2015-01-01 00:04:38.000000', 'consum', 0.0217, 'lps'),
	(631774, 134, '2015-01-01 00:04:39.000000', 'consum', 0.0233, 'lps'),
	(631775, 134, '2015-01-01 00:04:40.000000', 'consum', 0.0213, 'lps'),
	(631776, 134, '2015-01-01 00:04:41.000000', 'consum', 0.0250, 'lps'),
	(631777, 134, '2015-01-01 00:04:42.000000', 'consum', 0.0219, 'lps'),
	(631778, 134, '2015-01-01 00:04:43.000000', 'consum', 0.0226, 'lps'),
	(631779, 134, '2015-01-01 00:04:44.000000', 'consum', 0.0218, 'lps'),
	(631780, 134, '2015-01-01 00:04:45.000000', 'consum', 0.0246, 'lps'),
	(631781, 134, '2015-01-01 00:04:46.000000', 'consum', 0.0233, 'lps'),
	(631782, 134, '2015-01-01 00:04:47.000000', 'consum', 0.0219, 'lps'),
	(631783, 134, '2015-01-01 00:04:48.000000', 'consum', 0.0232, 'lps'),
	(631784, 134, '2015-01-01 00:04:49.000000', 'consum', 0.0248, 'lps'),
	(631785, 134, '2015-01-01 00:04:50.000000', 'consum', 0.0243, 'lps'),
	(631786, 134, '2015-01-01 00:04:51.000000', 'consum', 0.0215, 'lps'),
	(631787, 134, '2015-01-01 00:04:52.000000', 'consum', 0.0230, 'lps'),
	(631788, 134, '2015-01-01 00:04:53.000000', 'consum', 0.0248, 'lps'),
	(631789, 134, '2015-01-01 00:04:54.000000', 'consum', 0.0251, 'lps'),
	(631790, 134, '2015-01-01 00:04:55.000000', 'consum', 0.0211, 'lps'),
	(631791, 134, '2015-01-01 00:04:56.000000', 'consum', 0.0226, 'lps'),
	(631792, 134, '2015-01-01 00:04:57.000000', 'consum', 0.0246, 'lps'),
	(631793, 134, '2015-01-01 00:04:58.000000', 'consum', 0.0250, 'lps'),
	(631794, 134, '2015-01-01 00:04:59.000000', 'consum', 0.0215, 'lps'),
	(631795, 134, '2015-01-01 00:05:00.000000', 'consum', 0.0249, 'lps'),
	(631796, 134, '2015-01-01 00:05:01.000000', 'consum', 0.0212, 'lps'),
	(631797, 134, '2015-01-01 00:05:02.000000', 'consum', 0.0239, 'lps'),
	(631798, 134, '2015-01-01 00:05:03.000000', 'consum', 0.0216, 'lps'),
	(631799, 134, '2015-01-01 00:05:04.000000', 'consum', 0.0240, 'lps'),
	(631800, 134, '2015-01-01 00:05:05.000000', 'consum', 0.0253, 'lps'),
	(631801, 134, '2015-01-01 00:05:06.000000', 'consum', 0.0248, 'lps'),
	(631802, 134, '2015-01-01 00:05:07.000000', 'consum', 0.0224, 'lps'),
	(631803, 134, '2015-01-01 00:05:08.000000', 'consum', 0.0212, 'lps'),
	(631804, 134, '2015-01-01 00:05:09.000000', 'consum', 0.0225, 'lps'),
	(631805, 134, '2015-01-01 00:05:10.000000', 'consum', 0.0233, 'lps'),
	(631806, 134, '2015-01-01 00:05:11.000000', 'consum', 0.0235, 'lps'),
	(631807, 134, '2015-01-01 00:05:12.000000', 'consum', 0.0222, 'lps'),
	(631808, 134, '2015-01-01 00:05:13.000000', 'consum', 0.0240, 'lps'),
	(631809, 134, '2015-01-01 00:05:14.000000', 'consum', 0.0233, 'lps'),
	(631810, 134, '2015-01-01 00:05:15.000000', 'consum', 0.0237, 'lps'),
	(631811, 134, '2015-01-01 00:05:16.000000', 'consum', 0.0230, 'lps'),
	(631812, 134, '2015-01-01 00:05:17.000000', 'consum', 0.0229, 'lps'),
	(631813, 134, '2015-01-01 00:05:18.000000', 'consum', 0.0247, 'lps'),
	(631814, 134, '2015-01-01 00:05:19.000000', 'consum', 0.0247, 'lps'),
	(631815, 134, '2015-01-01 00:05:20.000000', 'consum', 0.0242, 'lps'),
	(631816, 134, '2015-01-01 00:05:21.000000', 'consum', 0.0215, 'lps'),
	(631817, 134, '2015-01-01 00:05:22.000000', 'consum', 0.0228, 'lps'),
	(631818, 134, '2015-01-01 00:05:23.000000', 'consum', 0.0241, 'lps'),
	(631819, 134, '2015-01-01 00:05:24.000000', 'consum', 0.0222, 'lps'),
	(631820, 134, '2015-01-01 00:05:25.000000', 'consum', 0.0224, 'lps'),
	(631821, 134, '2015-01-01 00:05:26.000000', 'consum', 0.0242, 'lps'),
	(631822, 134, '2015-01-01 00:05:27.000000', 'consum', 0.0238, 'lps'),
	(631823, 134, '2015-01-01 00:05:28.000000', 'consum', 0.0211, 'lps'),
	(631824, 134, '2015-01-01 00:05:29.000000', 'consum', 0.0222, 'lps'),
	(631825, 134, '2015-01-01 00:05:30.000000', 'consum', 0.0221, 'lps'),
	(631826, 134, '2015-01-01 00:05:31.000000', 'consum', 0.0230, 'lps'),
	(631827, 134, '2015-01-01 00:05:32.000000', 'consum', 0.0231, 'lps'),
	(631828, 134, '2015-01-01 00:05:33.000000', 'consum', 0.0212, 'lps'),
	(631829, 134, '2015-01-01 00:05:34.000000', 'consum', 0.0245, 'lps'),
	(631830, 134, '2015-01-01 00:05:35.000000', 'consum', 0.0247, 'lps'),
	(631831, 134, '2015-01-01 00:05:36.000000', 'consum', 0.0243, 'lps'),
	(631832, 134, '2015-01-01 00:05:37.000000', 'consum', 0.0223, 'lps'),
	(631833, 134, '2015-01-01 00:05:38.000000', 'consum', 0.0219, 'lps'),
	(631834, 134, '2015-01-01 00:05:39.000000', 'consum', 0.0219, 'lps'),
	(631835, 134, '2015-01-01 00:05:40.000000', 'consum', 0.0228, 'lps'),
	(631836, 134, '2015-01-01 00:05:41.000000', 'consum', 0.0226, 'lps'),
	(631837, 134, '2015-01-01 00:05:42.000000', 'consum', 0.0237, 'lps'),
	(631838, 134, '2015-01-01 00:05:43.000000', 'consum', 0.0254, 'lps'),
	(631839, 134, '2015-01-01 00:05:44.000000', 'consum', 0.0214, 'lps'),
	(631840, 134, '2015-01-01 00:05:45.000000', 'consum', 0.0232, 'lps'),
	(631841, 134, '2015-01-01 00:05:46.000000', 'consum', 0.0220, 'lps'),
	(631842, 134, '2015-01-01 00:05:47.000000', 'consum', 0.0240, 'lps'),
	(631843, 134, '2015-01-01 00:05:48.000000', 'consum', 0.0239, 'lps'),
	(631844, 134, '2015-01-01 00:05:49.000000', 'consum', 0.0223, 'lps'),
	(631845, 134, '2015-01-01 00:05:50.000000', 'consum', 0.0231, 'lps'),
	(631846, 134, '2015-01-01 00:05:51.000000', 'consum', 0.0234, 'lps'),
	(631847, 134, '2015-01-01 00:05:52.000000', 'consum', 0.0220, 'lps'),
	(631848, 134, '2015-01-01 00:05:53.000000', 'consum', 0.0233, 'lps'),
	(631849, 134, '2015-01-01 00:05:54.000000', 'consum', 0.0251, 'lps'),
	(631850, 134, '2015-01-01 00:05:55.000000', 'consum', 0.0212, 'lps'),
	(631851, 134, '2015-01-01 00:05:56.000000', 'consum', 0.0233, 'lps'),
	(631852, 134, '2015-01-01 00:05:57.000000', 'consum', 0.0231, 'lps'),
	(631853, 134, '2015-01-01 00:05:58.000000', 'consum', 0.0245, 'lps'),
	(631854, 134, '2015-01-01 00:05:59.000000', 'consum', 0.0232, 'lps'),
	(631855, 134, '2015-01-01 00:06:00.000000', 'consum', 0.0217, 'lps'),
	(631856, 134, '2015-01-01 00:06:01.000000', 'consum', 0.0225, 'lps'),
	(631857, 134, '2015-01-01 00:06:02.000000', 'consum', 0.0220, 'lps'),
	(631858, 134, '2015-01-01 00:06:03.000000', 'consum', 0.0214, 'lps'),
	(631859, 134, '2015-01-01 00:06:04.000000', 'consum', 0.0245, 'lps'),
	(631860, 134, '2015-01-01 00:06:05.000000', 'consum', 0.0241, 'lps'),
	(631861, 134, '2015-01-01 00:06:06.000000', 'consum', 0.0213, 'lps'),
	(631862, 134, '2015-01-01 00:06:07.000000', 'consum', 0.0222, 'lps'),
	(631863, 134, '2015-01-01 00:06:08.000000', 'consum', 0.0217, 'lps'),
	(631864, 134, '2015-01-01 00:06:09.000000', 'consum', 0.0210, 'lps'),
	(631865, 134, '2015-01-01 00:06:10.000000', 'consum', 0.0236, 'lps'),
	(631866, 134, '2015-01-01 00:06:11.000000', 'consum', 0.0250, 'lps'),
	(631867, 134, '2015-01-01 00:06:12.000000', 'consum', 0.0240, 'lps'),
	(631868, 134, '2015-01-01 00:06:13.000000', 'consum', 0.0242, 'lps'),
	(631869, 134, '2015-01-01 00:06:14.000000', 'consum', 0.0235, 'lps'),
	(631870, 134, '2015-01-01 00:06:15.000000', 'consum', 0.0241, 'lps'),
	(631871, 134, '2015-01-01 00:06:16.000000', 'consum', 0.0243, 'lps'),
	(631872, 134, '2015-01-01 00:06:17.000000', 'consum', 0.0240, 'lps'),
	(631873, 134, '2015-01-01 00:06:18.000000', 'consum', 0.0216, 'lps'),
	(631874, 134, '2015-01-01 00:06:19.000000', 'consum', 0.0240, 'lps'),
	(631875, 134, '2015-01-01 00:06:20.000000', 'consum', 0.0253, 'lps'),
	(631876, 134, '2015-01-01 00:06:21.000000', 'consum', 0.0246, 'lps'),
	(631877, 134, '2015-01-01 00:06:22.000000', 'consum', 0.0218, 'lps'),
	(631878, 134, '2015-01-01 00:06:23.000000', 'consum', 0.0230, 'lps'),
	(631879, 134, '2015-01-01 00:06:24.000000', 'consum', 0.0242, 'lps'),
	(631880, 134, '2015-01-01 00:06:25.000000', 'consum', 0.0222, 'lps'),
	(631881, 134, '2015-01-01 00:06:26.000000', 'consum', 0.0217, 'lps'),
	(631882, 134, '2015-01-01 00:06:27.000000', 'consum', 0.0211, 'lps'),
	(631883, 134, '2015-01-01 00:06:28.000000', 'consum', 0.0241, 'lps'),
	(631884, 134, '2015-01-01 00:06:29.000000', 'consum', 0.0226, 'lps'),
	(631885, 134, '2015-01-01 00:06:30.000000', 'consum', 0.0244, 'lps'),
	(631886, 134, '2015-01-01 00:06:31.000000', 'consum', 0.0244, 'lps'),
	(631887, 134, '2015-01-01 00:06:32.000000', 'consum', 0.0230, 'lps'),
	(631888, 134, '2015-01-01 00:06:33.000000', 'consum', 0.0211, 'lps'),
	(631889, 134, '2015-01-01 00:06:34.000000', 'consum', 0.0243, 'lps'),
	(631890, 134, '2015-01-01 00:06:35.000000', 'consum', 0.0238, 'lps'),
	(631891, 134, '2015-01-01 00:06:36.000000', 'consum', 0.0253, 'lps'),
	(631892, 134, '2015-01-01 00:06:37.000000', 'consum', 0.0251, 'lps'),
	(631893, 134, '2015-01-01 00:06:38.000000', 'consum', 0.0241, 'lps'),
	(631894, 134, '2015-01-01 00:06:39.000000', 'consum', 0.0241, 'lps'),
	(631895, 134, '2015-01-01 00:06:40.000000', 'consum', 0.0228, 'lps'),
	(631896, 134, '2015-01-01 00:06:41.000000', 'consum', 0.0253, 'lps'),
	(631897, 134, '2015-01-01 00:06:42.000000', 'consum', 0.0235, 'lps'),
	(631898, 134, '2015-01-01 00:06:43.000000', 'consum', 0.0254, 'lps'),
	(631899, 134, '2015-01-01 00:06:44.000000', 'consum', 0.0217, 'lps'),
	(631900, 134, '2015-01-01 00:06:45.000000', 'consum', 0.0252, 'lps'),
	(631901, 134, '2015-01-01 00:06:46.000000', 'consum', 0.0219, 'lps'),
	(631902, 134, '2015-01-01 00:06:47.000000', 'consum', 0.0218, 'lps'),
	(631903, 134, '2015-01-01 00:06:48.000000', 'consum', 0.0223, 'lps'),
	(631904, 134, '2015-01-01 00:06:49.000000', 'consum', 0.0254, 'lps'),
	(631905, 134, '2015-01-01 00:06:50.000000', 'consum', 0.0212, 'lps'),
	(631906, 134, '2015-01-01 00:06:51.000000', 'consum', 0.0223, 'lps'),
	(631907, 134, '2015-01-01 00:06:52.000000', 'consum', 0.0223, 'lps'),
	(631908, 134, '2015-01-01 00:06:53.000000', 'consum', 0.0237, 'lps'),
	(631909, 134, '2015-01-01 00:06:54.000000', 'consum', 0.0215, 'lps'),
	(631910, 134, '2015-01-01 00:06:55.000000', 'consum', 0.0245, 'lps'),
	(631911, 134, '2015-01-01 00:06:56.000000', 'consum', 0.0236, 'lps'),
	(631912, 134, '2015-01-01 00:06:57.000000', 'consum', 0.0237, 'lps'),
	(631913, 134, '2015-01-01 00:06:58.000000', 'consum', 0.0222, 'lps'),
	(631914, 134, '2015-01-01 00:06:59.000000', 'consum', 0.0234, 'lps'),
	(631915, 134, '2015-01-01 00:07:00.000000', 'consum', 0.0249, 'lps'),
	(631916, 134, '2015-01-01 00:07:01.000000', 'consum', 0.0242, 'lps'),
	(631917, 134, '2015-01-01 00:07:02.000000', 'consum', 0.0210, 'lps'),
	(631918, 134, '2015-01-01 00:07:03.000000', 'consum', 0.0250, 'lps'),
	(631919, 134, '2015-01-01 00:07:04.000000', 'consum', 0.0230, 'lps'),
	(631920, 134, '2015-01-01 00:07:05.000000', 'consum', 0.0237, 'lps'),
	(631921, 134, '2015-01-01 00:07:06.000000', 'consum', 0.0239, 'lps'),
	(631922, 134, '2015-01-01 00:07:07.000000', 'consum', 0.0230, 'lps'),
	(631923, 134, '2015-01-01 00:07:08.000000', 'consum', 0.0224, 'lps'),
	(631924, 134, '2015-01-01 00:07:09.000000', 'consum', 0.0222, 'lps'),
	(631925, 134, '2015-01-01 00:07:10.000000', 'consum', 0.0227, 'lps'),
	(631926, 134, '2015-01-01 00:07:11.000000', 'consum', 0.0215, 'lps'),
	(631927, 134, '2015-01-01 00:07:12.000000', 'consum', 0.0227, 'lps'),
	(631928, 134, '2015-01-01 00:07:13.000000', 'consum', 0.0238, 'lps'),
	(631929, 134, '2015-01-01 00:07:14.000000', 'consum', 0.0252, 'lps'),
	(631930, 134, '2015-01-01 00:07:15.000000', 'consum', 0.0248, 'lps'),
	(631931, 134, '2015-01-01 00:07:16.000000', 'consum', 0.0231, 'lps'),
	(631932, 134, '2015-01-01 00:07:17.000000', 'consum', 0.0244, 'lps'),
	(631933, 134, '2015-01-01 00:07:18.000000', 'consum', 0.0230, 'lps'),
	(631934, 134, '2015-01-01 00:07:19.000000', 'consum', 0.0253, 'lps'),
	(631935, 134, '2015-01-01 00:07:20.000000', 'consum', 0.0231, 'lps'),
	(631936, 134, '2015-01-01 00:07:21.000000', 'consum', 0.0230, 'lps'),
	(631937, 134, '2015-01-01 00:07:22.000000', 'consum', 0.0247, 'lps'),
	(631938, 134, '2015-01-01 00:07:23.000000', 'consum', 0.0248, 'lps'),
	(631939, 134, '2015-01-01 00:07:24.000000', 'consum', 0.0243, 'lps'),
	(631940, 134, '2015-01-01 00:07:25.000000', 'consum', 0.0218, 'lps'),
	(631941, 134, '2015-01-01 00:07:26.000000', 'consum', 0.0242, 'lps'),
	(631942, 134, '2015-01-01 00:07:27.000000', 'consum', 0.0212, 'lps'),
	(631943, 134, '2015-01-01 00:07:28.000000', 'consum', 0.0214, 'lps'),
	(631944, 134, '2015-01-01 00:07:29.000000', 'consum', 0.0223, 'lps'),
	(631945, 134, '2015-01-01 00:07:30.000000', 'consum', 0.0220, 'lps'),
	(631946, 134, '2015-01-01 00:07:31.000000', 'consum', 0.0223, 'lps'),
	(631947, 134, '2015-01-01 00:07:32.000000', 'consum', 0.0243, 'lps'),
	(631948, 134, '2015-01-01 00:07:33.000000', 'consum', 0.0247, 'lps'),
	(631949, 134, '2015-01-01 00:07:34.000000', 'consum', 0.0251, 'lps'),
	(631950, 134, '2015-01-01 00:07:35.000000', 'consum', 0.0216, 'lps'),
	(631951, 134, '2015-01-01 00:07:36.000000', 'consum', 0.0252, 'lps'),
	(631952, 134, '2015-01-01 00:07:37.000000', 'consum', 0.0224, 'lps'),
	(631953, 134, '2015-01-01 00:07:38.000000', 'consum', 0.0241, 'lps'),
	(631954, 134, '2015-01-01 00:07:39.000000', 'consum', 0.0237, 'lps'),
	(631955, 134, '2015-01-01 00:07:40.000000', 'consum', 0.0249, 'lps'),
	(631956, 134, '2015-01-01 00:07:41.000000', 'consum', 0.0236, 'lps'),
	(631957, 134, '2015-01-01 00:07:42.000000', 'consum', 0.0225, 'lps'),
	(631958, 134, '2015-01-01 00:07:43.000000', 'consum', 0.0252, 'lps'),
	(631959, 134, '2015-01-01 00:07:44.000000', 'consum', 0.0240, 'lps'),
	(631960, 134, '2015-01-01 00:07:45.000000', 'consum', 0.0237, 'lps'),
	(631961, 134, '2015-01-01 00:07:46.000000', 'consum', 0.0253, 'lps'),
	(631962, 134, '2015-01-01 00:07:47.000000', 'consum', 0.0254, 'lps'),
	(631963, 134, '2015-01-01 00:07:48.000000', 'consum', 0.0211, 'lps'),
	(631964, 134, '2015-01-01 00:07:49.000000', 'consum', 0.0220, 'lps'),
	(631965, 134, '2015-01-01 00:07:50.000000', 'consum', 0.0210, 'lps'),
	(631966, 134, '2015-01-01 00:07:51.000000', 'consum', 0.0227, 'lps'),
	(631967, 134, '2015-01-01 00:07:52.000000', 'consum', 0.0252, 'lps'),
	(631968, 134, '2015-01-01 00:07:53.000000', 'consum', 0.0233, 'lps'),
	(631969, 134, '2015-01-01 00:07:54.000000', 'consum', 0.0245, 'lps'),
	(631970, 134, '2015-01-01 00:07:55.000000', 'consum', 0.0228, 'lps'),
	(631971, 134, '2015-01-01 00:07:56.000000', 'consum', 0.0239, 'lps'),
	(631972, 134, '2015-01-01 00:07:57.000000', 'consum', 0.0212, 'lps'),
	(631973, 134, '2015-01-01 00:07:58.000000', 'consum', 0.0225, 'lps'),
	(631974, 134, '2015-01-01 00:07:59.000000', 'consum', 0.0232, 'lps'),
	(631975, 134, '2015-01-01 00:08:00.000000', 'consum', 0.0232, 'lps'),
	(631976, 134, '2015-01-01 00:08:01.000000', 'consum', 0.0253, 'lps'),
	(631977, 134, '2015-01-01 00:08:02.000000', 'consum', 0.0224, 'lps'),
	(631978, 134, '2015-01-01 00:08:03.000000', 'consum', 0.0244, 'lps'),
	(631979, 134, '2015-01-01 00:08:04.000000', 'consum', 0.0247, 'lps'),
	(631980, 134, '2015-01-01 00:08:05.000000', 'consum', 0.0249, 'lps'),
	(631981, 134, '2015-01-01 00:08:06.000000', 'consum', 0.0251, 'lps'),
	(631982, 134, '2015-01-01 00:08:07.000000', 'consum', 0.0252, 'lps'),
	(631983, 134, '2015-01-01 00:08:08.000000', 'consum', 0.0252, 'lps'),
	(631984, 134, '2015-01-01 00:08:09.000000', 'consum', 0.0251, 'lps'),
	(631985, 134, '2015-01-01 00:08:10.000000', 'consum', 0.0242, 'lps'),
	(631986, 134, '2015-01-01 00:08:11.000000', 'consum', 0.0249, 'lps'),
	(631987, 134, '2015-01-01 00:08:12.000000', 'consum', 0.0217, 'lps'),
	(631988, 134, '2015-01-01 00:08:13.000000', 'consum', 0.0222, 'lps'),
	(631989, 134, '2015-01-01 00:08:14.000000', 'consum', 0.0249, 'lps'),
	(631990, 134, '2015-01-01 00:08:15.000000', 'consum', 0.0234, 'lps'),
	(631991, 134, '2015-01-01 00:08:16.000000', 'consum', 0.0212, 'lps'),
	(631992, 134, '2015-01-01 00:08:17.000000', 'consum', 0.0241, 'lps'),
	(631993, 134, '2015-01-01 00:08:18.000000', 'consum', 0.0223, 'lps'),
	(631994, 134, '2015-01-01 00:08:19.000000', 'consum', 0.0227, 'lps'),
	(631995, 134, '2015-01-01 00:08:20.000000', 'consum', 0.0214, 'lps'),
	(631996, 134, '2015-01-01 00:08:21.000000', 'consum', 0.0222, 'lps'),
	(631997, 134, '2015-01-01 00:08:22.000000', 'consum', 0.0213, 'lps'),
	(631998, 134, '2015-01-01 00:08:23.000000', 'consum', 0.0237, 'lps'),
	(631999, 134, '2015-01-01 00:08:24.000000', 'consum', 0.0244, 'lps'),
	(632000, 134, '2015-01-01 00:08:25.000000', 'consum', 0.0212, 'lps'),
	(632001, 134, '2015-01-01 00:08:26.000000', 'consum', 0.0254, 'lps'),
	(632002, 134, '2015-01-01 00:08:27.000000', 'consum', 0.0244, 'lps'),
	(632003, 134, '2015-01-01 00:08:28.000000', 'consum', 0.0249, 'lps'),
	(632004, 134, '2015-01-01 00:08:29.000000', 'consum', 0.0213, 'lps'),
	(632005, 134, '2015-01-01 00:08:30.000000', 'consum', 0.0242, 'lps'),
	(632006, 134, '2015-01-01 00:08:31.000000', 'consum', 0.0226, 'lps'),
	(632007, 134, '2015-01-01 00:08:32.000000', 'consum', 0.0240, 'lps'),
	(632008, 134, '2015-01-01 00:08:33.000000', 'consum', 0.0222, 'lps'),
	(632009, 134, '2015-01-01 00:08:34.000000', 'consum', 0.0225, 'lps'),
	(632010, 134, '2015-01-01 00:08:35.000000', 'consum', 0.0252, 'lps'),
	(632011, 134, '2015-01-01 00:08:36.000000', 'consum', 0.0238, 'lps'),
	(632012, 134, '2015-01-01 00:08:37.000000', 'consum', 0.0227, 'lps'),
	(632013, 134, '2015-01-01 00:08:38.000000', 'consum', 0.0211, 'lps'),
	(632014, 134, '2015-01-01 00:08:39.000000', 'consum', 0.0253, 'lps'),
	(632015, 134, '2015-01-01 00:08:40.000000', 'consum', 0.0243, 'lps'),
	(632016, 134, '2015-01-01 00:08:41.000000', 'consum', 0.0248, 'lps'),
	(632017, 134, '2015-01-01 00:08:42.000000', 'consum', 0.0254, 'lps'),
	(632018, 134, '2015-01-01 00:08:43.000000', 'consum', 0.0226, 'lps'),
	(632019, 134, '2015-01-01 00:08:44.000000', 'consum', 0.0251, 'lps'),
	(632020, 134, '2015-01-01 00:08:45.000000', 'consum', 0.0232, 'lps'),
	(632021, 134, '2015-01-01 00:08:46.000000', 'consum', 0.0242, 'lps'),
	(632022, 134, '2015-01-01 00:08:47.000000', 'consum', 0.0215, 'lps'),
	(632023, 134, '2015-01-01 00:08:48.000000', 'consum', 0.0228, 'lps'),
	(632024, 134, '2015-01-01 00:08:49.000000', 'consum', 0.0241, 'lps'),
	(632025, 134, '2015-01-01 00:08:50.000000', 'consum', 0.0221, 'lps'),
	(632026, 134, '2015-01-01 00:08:51.000000', 'consum', 0.0219, 'lps'),
	(632027, 134, '2015-01-01 00:08:52.000000', 'consum', 0.0222, 'lps'),
	(632028, 134, '2015-01-01 00:08:53.000000', 'consum', 0.0242, 'lps'),
	(632029, 134, '2015-01-01 00:08:54.000000', 'consum', 0.0245, 'lps'),
	(632030, 134, '2015-01-01 00:08:55.000000', 'consum', 0.0246, 'lps'),
	(632031, 134, '2015-01-01 00:08:56.000000', 'consum', 0.0239, 'lps'),
	(632032, 134, '2015-01-01 00:08:57.000000', 'consum', 0.0246, 'lps'),
	(632033, 134, '2015-01-01 00:08:58.000000', 'consum', 0.0216, 'lps'),
	(632034, 134, '2015-01-01 00:08:59.000000', 'consum', 0.0220, 'lps'),
	(632035, 134, '2015-01-01 00:09:00.000000', 'consum', 0.0245, 'lps'),
	(632036, 134, '2015-01-01 00:09:01.000000', 'consum', 0.0219, 'lps'),
	(632037, 134, '2015-01-01 00:09:02.000000', 'consum', 0.0243, 'lps'),
	(632038, 134, '2015-01-01 00:09:03.000000', 'consum', 0.0212, 'lps'),
	(632039, 134, '2015-01-01 00:09:04.000000', 'consum', 0.0211, 'lps'),
	(632040, 134, '2015-01-01 00:09:05.000000', 'consum', 0.0210, 'lps'),
	(632041, 134, '2015-01-01 00:09:06.000000', 'consum', 0.0251, 'lps'),
	(632042, 134, '2015-01-01 00:09:07.000000', 'consum', 0.0237, 'lps'),
	(632043, 134, '2015-01-01 00:09:08.000000', 'consum', 0.0222, 'lps'),
	(632044, 134, '2015-01-01 00:09:09.000000', 'consum', 0.0234, 'lps'),
	(632045, 134, '2015-01-01 00:09:10.000000', 'consum', 0.0249, 'lps'),
	(632046, 134, '2015-01-01 00:09:11.000000', 'consum', 0.0246, 'lps'),
	(632047, 134, '2015-01-01 00:09:12.000000', 'consum', 0.0226, 'lps'),
	(632048, 134, '2015-01-01 00:09:13.000000', 'consum', 0.0229, 'lps'),
	(632049, 134, '2015-01-01 00:09:14.000000', 'consum', 0.0212, 'lps'),
	(632050, 134, '2015-01-01 00:09:15.000000', 'consum', 0.0254, 'lps'),
	(632051, 134, '2015-01-01 00:09:16.000000', 'consum', 0.0242, 'lps'),
	(632052, 134, '2015-01-01 00:09:17.000000', 'consum', 0.0242, 'lps'),
	(632053, 134, '2015-01-01 00:09:18.000000', 'consum', 0.0227, 'lps'),
	(632054, 134, '2015-01-01 00:09:19.000000', 'consum', 0.0244, 'lps'),
	(632055, 134, '2015-01-01 00:09:20.000000', 'consum', 0.0241, 'lps'),
	(632056, 134, '2015-01-01 00:09:21.000000', 'consum', 0.0219, 'lps'),
	(632057, 134, '2015-01-01 00:09:22.000000', 'consum', 0.0252, 'lps'),
	(632058, 134, '2015-01-01 00:09:23.000000', 'consum', 0.0215, 'lps'),
	(632059, 134, '2015-01-01 00:09:24.000000', 'consum', 0.0246, 'lps'),
	(632060, 134, '2015-01-01 00:09:25.000000', 'consum', 0.0237, 'lps'),
	(632061, 134, '2015-01-01 00:09:26.000000', 'consum', 0.0237, 'lps'),
	(632062, 134, '2015-01-01 00:09:27.000000', 'consum', 0.0220, 'lps'),
	(632063, 134, '2015-01-01 00:09:28.000000', 'consum', 0.0227, 'lps'),
	(632064, 134, '2015-01-01 00:09:29.000000', 'consum', 0.0218, 'lps'),
	(632065, 134, '2015-01-01 00:09:30.000000', 'consum', 0.0244, 'lps'),
	(632066, 134, '2015-01-01 00:09:31.000000', 'consum', 0.0220, 'lps'),
	(632067, 134, '2015-01-01 00:09:32.000000', 'consum', 0.0252, 'lps'),
	(632068, 134, '2015-01-01 00:09:33.000000', 'consum', 0.0254, 'lps'),
	(632069, 134, '2015-01-01 00:09:34.000000', 'consum', 0.0216, 'lps'),
	(632070, 134, '2015-01-01 00:09:35.000000', 'consum', 0.0243, 'lps'),
	(632071, 134, '2015-01-01 00:09:36.000000', 'consum', 0.0223, 'lps'),
	(632072, 134, '2015-01-01 00:09:37.000000', 'consum', 0.0222, 'lps'),
	(632073, 134, '2015-01-01 00:09:38.000000', 'consum', 0.0232, 'lps'),
	(632074, 134, '2015-01-01 00:09:39.000000', 'consum', 0.0237, 'lps'),
	(632075, 134, '2015-01-01 00:09:40.000000', 'consum', 0.0237, 'lps'),
	(632076, 134, '2015-01-01 00:09:41.000000', 'consum', 0.0218, 'lps'),
	(632077, 134, '2015-01-01 00:09:42.000000', 'consum', 0.0217, 'lps'),
	(632078, 134, '2015-01-01 00:09:43.000000', 'consum', 0.0218, 'lps'),
	(632079, 134, '2015-01-01 00:09:44.000000', 'consum', 0.0233, 'lps'),
	(632080, 134, '2015-01-01 00:09:45.000000', 'consum', 0.0253, 'lps'),
	(632081, 134, '2015-01-01 00:09:46.000000', 'consum', 0.0223, 'lps'),
	(632082, 134, '2015-01-01 00:09:47.000000', 'consum', 0.0236, 'lps'),
	(632083, 134, '2015-01-01 00:09:48.000000', 'consum', 0.0211, 'lps'),
	(632084, 134, '2015-01-01 00:09:49.000000', 'consum', 0.0226, 'lps'),
	(632085, 134, '2015-01-01 00:09:50.000000', 'consum', 0.0246, 'lps'),
	(632086, 134, '2015-01-01 00:09:51.000000', 'consum', 0.0249, 'lps'),
	(632087, 134, '2015-01-01 00:09:52.000000', 'consum', 0.0211, 'lps'),
	(632088, 134, '2015-01-01 00:09:53.000000', 'consum', 0.0230, 'lps'),
	(632089, 134, '2015-01-01 00:09:54.000000', 'consum', 0.0220, 'lps'),
	(632090, 134, '2015-01-01 00:09:55.000000', 'consum', 0.0246, 'lps'),
	(632091, 134, '2015-01-01 00:09:56.000000', 'consum', 0.0224, 'lps'),
	(632092, 134, '2015-01-01 00:09:57.000000', 'consum', 0.0218, 'lps'),
	(632093, 134, '2015-01-01 00:09:58.000000', 'consum', 0.0251, 'lps'),
	(632094, 134, '2015-01-01 00:09:59.000000', 'consum', 0.0215, 'lps'),
	(632095, 134, '2015-01-01 00:10:00.000000', 'consum', 0.0246, 'lps'),
	(632096, 134, '2015-01-01 00:10:01.000000', 'consum', 0.0239, 'lps'),
	(632097, 134, '2015-01-01 00:10:02.000000', 'consum', 0.0250, 'lps'),
	(632098, 134, '2015-01-01 00:10:03.000000', 'consum', 0.0233, 'lps'),
	(632099, 134, '2015-01-01 00:10:04.000000', 'consum', 0.0249, 'lps'),
	(632100, 134, '2015-01-01 00:10:05.000000', 'consum', 0.0246, 'lps'),
	(632101, 134, '2015-01-01 00:10:06.000000', 'consum', 0.0230, 'lps'),
	(632102, 134, '2015-01-01 00:10:07.000000', 'consum', 0.0247, 'lps'),
	(632103, 134, '2015-01-01 00:10:08.000000', 'consum', 0.0246, 'lps'),
	(632104, 134, '2015-01-01 00:10:09.000000', 'consum', 0.0235, 'lps'),
	(632105, 134, '2015-01-01 00:10:10.000000', 'consum', 0.0227, 'lps'),
	(632106, 134, '2015-01-01 00:10:11.000000', 'consum', 0.0222, 'lps'),
	(632107, 134, '2015-01-01 00:10:12.000000', 'consum', 0.0219, 'lps'),
	(632108, 134, '2015-01-01 00:10:13.000000', 'consum', 0.0217, 'lps'),
	(632109, 134, '2015-01-01 00:10:14.000000', 'consum', 0.0222, 'lps'),
	(632110, 134, '2015-01-01 00:10:15.000000', 'consum', 0.0248, 'lps'),
	(632111, 134, '2015-01-01 00:10:16.000000', 'consum', 0.0231, 'lps'),
	(632112, 134, '2015-01-01 00:10:17.000000', 'consum', 0.0245, 'lps'),
	(632113, 134, '2015-01-01 00:10:18.000000', 'consum', 0.0233, 'lps'),
	(632114, 134, '2015-01-01 00:10:19.000000', 'consum', 0.0218, 'lps'),
	(632115, 134, '2015-01-01 00:10:20.000000', 'consum', 0.0230, 'lps'),
	(632116, 134, '2015-01-01 00:10:21.000000', 'consum', 0.0239, 'lps'),
	(632117, 134, '2015-01-01 00:10:22.000000', 'consum', 0.0251, 'lps'),
	(632118, 134, '2015-01-01 00:10:23.000000', 'consum', 0.0240, 'lps'),
	(632119, 134, '2015-01-01 00:10:24.000000', 'consum', 0.0236, 'lps'),
	(632120, 134, '2015-01-01 00:10:25.000000', 'consum', 0.0253, 'lps'),
	(632121, 134, '2015-01-01 00:10:26.000000', 'consum', 0.0211, 'lps'),
	(632122, 134, '2015-01-01 00:10:27.000000', 'consum', 0.0220, 'lps'),
	(632123, 134, '2015-01-01 00:10:28.000000', 'consum', 0.0216, 'lps'),
	(632124, 134, '2015-01-01 00:10:29.000000', 'consum', 0.0253, 'lps'),
	(632125, 134, '2015-01-01 00:10:30.000000', 'consum', 0.0226, 'lps'),
	(632126, 134, '2015-01-01 00:10:31.000000', 'consum', 0.0210, 'lps'),
	(632127, 134, '2015-01-01 00:10:32.000000', 'consum', 0.0250, 'lps'),
	(632128, 134, '2015-01-01 00:10:33.000000', 'consum', 0.0233, 'lps'),
	(632129, 134, '2015-01-01 00:10:34.000000', 'consum', 0.0250, 'lps'),
	(632130, 134, '2015-01-01 00:10:35.000000', 'consum', 0.0251, 'lps'),
	(632131, 134, '2015-01-01 00:10:36.000000', 'consum', 0.0251, 'lps'),
	(632132, 134, '2015-01-01 00:10:37.000000', 'consum', 0.0246, 'lps'),
	(632133, 134, '2015-01-01 00:10:38.000000', 'consum', 0.0225, 'lps'),
	(632134, 134, '2015-01-01 00:10:39.000000', 'consum', 0.0221, 'lps'),
	(632135, 134, '2015-01-01 00:10:40.000000', 'consum', 0.0219, 'lps'),
	(632136, 134, '2015-01-01 00:10:41.000000', 'consum', 0.0225, 'lps'),
	(632137, 134, '2015-01-01 00:10:42.000000', 'consum', 0.0215, 'lps'),
	(632138, 134, '2015-01-01 00:10:43.000000', 'consum', 0.0232, 'lps'),
	(632139, 134, '2015-01-01 00:10:44.000000', 'consum', 0.0218, 'lps'),
	(632140, 134, '2015-01-01 00:10:45.000000', 'consum', 0.0227, 'lps'),
	(632141, 134, '2015-01-01 00:10:46.000000', 'consum', 0.0229, 'lps'),
	(632142, 134, '2015-01-01 00:10:47.000000', 'consum', 0.0210, 'lps'),
	(632143, 134, '2015-01-01 00:10:48.000000', 'consum', 0.0241, 'lps'),
	(632144, 134, '2015-01-01 00:10:49.000000', 'consum', 0.0230, 'lps'),
	(632145, 134, '2015-01-01 00:10:50.000000', 'consum', 0.0218, 'lps'),
	(632146, 134, '2015-01-01 00:10:51.000000', 'consum', 0.0235, 'lps'),
	(632147, 134, '2015-01-01 00:10:52.000000', 'consum', 0.0222, 'lps'),
	(632148, 134, '2015-01-01 00:10:53.000000', 'consum', 0.0239, 'lps'),
	(632149, 134, '2015-01-01 00:10:54.000000', 'consum', 0.0230, 'lps'),
	(632150, 134, '2015-01-01 00:10:55.000000', 'consum', 0.0226, 'lps'),
	(632151, 134, '2015-01-01 00:10:56.000000', 'consum', 0.0229, 'lps'),
	(632152, 134, '2015-01-01 00:10:57.000000', 'consum', 0.0212, 'lps'),
	(632153, 134, '2015-01-01 00:10:58.000000', 'consum', 0.0211, 'lps'),
	(632154, 134, '2015-01-01 00:10:59.000000', 'consum', 0.0251, 'lps'),
	(632155, 134, '2015-01-01 00:11:00.000000', 'consum', 0.0235, 'lps'),
	(632156, 134, '2015-01-01 00:11:01.000000', 'consum', 0.0214, 'lps'),
	(632157, 134, '2015-01-01 00:11:02.000000', 'consum', 0.0243, 'lps'),
	(632158, 134, '2015-01-01 00:11:03.000000', 'consum', 0.0230, 'lps'),
	(632159, 134, '2015-01-01 00:11:04.000000', 'consum', 0.0210, 'lps'),
	(632160, 134, '2015-01-01 00:11:05.000000', 'consum', 0.0241, 'lps'),
	(632161, 134, '2015-01-01 00:11:06.000000', 'consum', 0.0231, 'lps'),
	(632162, 134, '2015-01-01 00:11:07.000000', 'consum', 0.0220, 'lps'),
	(632163, 134, '2015-01-01 00:11:08.000000', 'consum', 0.0245, 'lps'),
	(632164, 134, '2015-01-01 00:11:09.000000', 'consum', 0.0221, 'lps'),
	(632165, 134, '2015-01-01 00:11:10.000000', 'consum', 0.0250, 'lps'),
	(632166, 134, '2015-01-01 00:11:11.000000', 'consum', 0.0242, 'lps'),
	(632167, 134, '2015-01-01 00:11:12.000000', 'consum', 0.0253, 'lps'),
	(632168, 134, '2015-01-01 00:11:13.000000', 'consum', 0.0237, 'lps'),
	(632169, 134, '2015-01-01 00:11:14.000000', 'consum', 0.0216, 'lps'),
	(632170, 134, '2015-01-01 00:11:15.000000', 'consum', 0.0251, 'lps'),
	(632171, 134, '2015-01-01 00:11:16.000000', 'consum', 0.0218, 'lps'),
	(632172, 134, '2015-01-01 00:11:17.000000', 'consum', 0.0215, 'lps'),
	(632173, 134, '2015-01-01 00:11:18.000000', 'consum', 0.0214, 'lps'),
	(632174, 134, '2015-01-01 00:11:19.000000', 'consum', 0.0217, 'lps'),
	(632175, 134, '2015-01-01 00:11:20.000000', 'consum', 0.0230, 'lps'),
	(632176, 134, '2015-01-01 00:11:21.000000', 'consum', 0.0246, 'lps'),
	(632177, 134, '2015-01-01 00:11:22.000000', 'consum', 0.0239, 'lps'),
	(632178, 134, '2015-01-01 00:11:23.000000', 'consum', 0.0249, 'lps'),
	(632179, 134, '2015-01-01 00:11:24.000000', 'consum', 0.0226, 'lps'),
	(632180, 134, '2015-01-01 00:11:25.000000', 'consum', 0.0220, 'lps'),
	(632181, 134, '2015-01-01 00:11:26.000000', 'consum', 0.0214, 'lps'),
	(632182, 134, '2015-01-01 00:11:27.000000', 'consum', 0.0243, 'lps'),
	(632183, 134, '2015-01-01 00:11:28.000000', 'consum', 0.0229, 'lps'),
	(632184, 134, '2015-01-01 00:11:29.000000', 'consum', 0.0250, 'lps'),
	(632185, 134, '2015-01-01 00:11:30.000000', 'consum', 0.0221, 'lps'),
	(632186, 134, '2015-01-01 00:11:31.000000', 'consum', 0.0235, 'lps'),
	(632187, 134, '2015-01-01 00:11:32.000000', 'consum', 0.0212, 'lps'),
	(632188, 134, '2015-01-01 00:11:33.000000', 'consum', 0.0235, 'lps'),
	(632189, 134, '2015-01-01 00:11:34.000000', 'consum', 0.0242, 'lps'),
	(632190, 134, '2015-01-01 00:11:35.000000', 'consum', 0.0249, 'lps'),
	(632191, 134, '2015-01-01 00:11:36.000000', 'consum', 0.0221, 'lps'),
	(632192, 134, '2015-01-01 00:11:37.000000', 'consum', 0.0236, 'lps'),
	(632193, 134, '2015-01-01 00:11:38.000000', 'consum', 0.0219, 'lps'),
	(632194, 134, '2015-01-01 00:11:39.000000', 'consum', 0.0224, 'lps'),
	(632195, 134, '2015-01-01 00:11:40.000000', 'consum', 0.0252, 'lps'),
	(632196, 134, '2015-01-01 00:11:41.000000', 'consum', 0.0244, 'lps'),
	(632197, 134, '2015-01-01 00:11:42.000000', 'consum', 0.0254, 'lps'),
	(632198, 134, '2015-01-01 00:11:43.000000', 'consum', 0.0239, 'lps'),
	(632199, 134, '2015-01-01 00:11:44.000000', 'consum', 0.0222, 'lps'),
	(632200, 134, '2015-01-01 00:11:45.000000', 'consum', 0.0231, 'lps'),
	(632201, 134, '2015-01-01 00:11:46.000000', 'consum', 0.0235, 'lps'),
	(632202, 134, '2015-01-01 00:11:47.000000', 'consum', 0.0227, 'lps'),
	(632203, 134, '2015-01-01 00:11:48.000000', 'consum', 0.0218, 'lps'),
	(632204, 134, '2015-01-01 00:11:49.000000', 'consum', 0.0246, 'lps'),
	(632205, 134, '2015-01-01 00:11:50.000000', 'consum', 0.0233, 'lps'),
	(632206, 134, '2015-01-01 00:11:51.000000', 'consum', 0.0218, 'lps'),
	(632207, 134, '2015-01-01 00:11:52.000000', 'consum', 0.0225, 'lps'),
	(632208, 134, '2015-01-01 00:11:53.000000', 'consum', 0.0216, 'lps'),
	(632209, 134, '2015-01-01 00:11:54.000000', 'consum', 0.0240, 'lps'),
	(632210, 134, '2015-01-01 00:11:55.000000', 'consum', 0.0252, 'lps'),
	(632211, 134, '2015-01-01 00:11:56.000000', 'consum', 0.0242, 'lps'),
	(632212, 134, '2015-01-01 00:11:57.000000', 'consum', 0.0245, 'lps'),
	(632213, 134, '2015-01-01 00:11:58.000000', 'consum', 0.0244, 'lps'),
	(632214, 134, '2015-01-01 00:11:59.000000', 'consum', 0.0232, 'lps'),
	(632215, 134, '2015-01-01 00:12:00.000000', 'consum', 0.0219, 'lps'),
	(632216, 134, '2015-01-01 00:12:01.000000', 'consum', 0.0232, 'lps'),
	(632217, 134, '2015-01-01 00:12:02.000000', 'consum', 0.0248, 'lps'),
	(632218, 134, '2015-01-01 00:12:03.000000', 'consum', 0.0244, 'lps'),
	(632219, 134, '2015-01-01 00:12:04.000000', 'consum', 0.0222, 'lps'),
	(632220, 134, '2015-01-01 00:12:05.000000', 'consum', 0.0216, 'lps'),
	(632221, 134, '2015-01-01 00:12:06.000000', 'consum', 0.0246, 'lps'),
	(632222, 134, '2015-01-01 00:12:07.000000', 'consum', 0.0240, 'lps'),
	(632223, 134, '2015-01-01 00:12:08.000000', 'consum', 0.0251, 'lps'),
	(632224, 134, '2015-01-01 00:12:09.000000', 'consum', 0.0235, 'lps'),
	(632225, 134, '2015-01-01 00:12:10.000000', 'consum', 0.0214, 'lps'),
	(632226, 134, '2015-01-01 00:12:11.000000', 'consum', 0.0244, 'lps'),
	(632227, 134, '2015-01-01 00:12:12.000000', 'consum', 0.0233, 'lps'),
	(632228, 134, '2015-01-01 00:12:13.000000', 'consum', 0.0225, 'lps'),
	(632229, 134, '2015-01-01 00:12:14.000000', 'consum', 0.0215, 'lps'),
	(632230, 134, '2015-01-01 00:12:15.000000', 'consum', 0.0235, 'lps'),
	(632231, 134, '2015-01-01 00:12:16.000000', 'consum', 0.0233, 'lps'),
	(632232, 134, '2015-01-01 00:12:17.000000', 'consum', 0.0249, 'lps'),
	(632233, 134, '2015-01-01 00:12:18.000000', 'consum', 0.0245, 'lps'),
	(632234, 134, '2015-01-01 00:12:19.000000', 'consum', 0.0227, 'lps'),
	(632235, 134, '2015-01-01 00:12:20.000000', 'consum', 0.0233, 'lps'),
	(632236, 134, '2015-01-01 00:12:21.000000', 'consum', 0.0229, 'lps'),
	(632237, 134, '2015-01-01 00:12:22.000000', 'consum', 0.0238, 'lps'),
	(632238, 134, '2015-01-01 00:12:23.000000', 'consum', 0.0250, 'lps'),
	(632239, 134, '2015-01-01 00:12:24.000000', 'consum', 0.0234, 'lps'),
	(632240, 134, '2015-01-01 00:12:25.000000', 'consum', 0.0212, 'lps'),
	(632241, 134, '2015-01-01 00:12:26.000000', 'consum', 0.0240, 'lps'),
	(632242, 134, '2015-01-01 00:12:27.000000', 'consum', 0.0217, 'lps'),
	(632243, 134, '2015-01-01 00:12:28.000000', 'consum', 0.0248, 'lps'),
	(632244, 134, '2015-01-01 00:12:29.000000', 'consum', 0.0244, 'lps'),
	(632245, 134, '2015-01-01 00:12:30.000000', 'consum', 0.0223, 'lps'),
	(632246, 134, '2015-01-01 00:12:31.000000', 'consum', 0.0218, 'lps'),
	(632247, 134, '2015-01-01 00:12:32.000000', 'consum', 0.0254, 'lps'),
	(632248, 134, '2015-01-01 00:12:33.000000', 'consum', 0.0229, 'lps'),
	(632249, 134, '2015-01-01 00:12:34.000000', 'consum', 0.0218, 'lps'),
	(632250, 134, '2015-01-01 00:12:35.000000', 'consum', 0.0239, 'lps'),
	(632251, 134, '2015-01-01 00:12:36.000000', 'consum', 0.0242, 'lps'),
	(632252, 134, '2015-01-01 00:12:37.000000', 'consum', 0.0237, 'lps'),
	(632253, 134, '2015-01-01 00:12:38.000000', 'consum', 0.0251, 'lps'),
	(632254, 134, '2015-01-01 00:12:39.000000', 'consum', 0.0245, 'lps'),
	(632255, 134, '2015-01-01 00:12:40.000000', 'consum', 0.0217, 'lps'),
	(632256, 134, '2015-01-01 00:12:41.000000', 'consum', 0.0228, 'lps'),
	(632257, 134, '2015-01-01 00:12:42.000000', 'consum', 0.0237, 'lps'),
	(632258, 134, '2015-01-01 00:12:43.000000', 'consum', 0.0245, 'lps'),
	(632259, 134, '2015-01-01 00:12:44.000000', 'consum', 0.0215, 'lps'),
	(632260, 134, '2015-01-01 00:12:45.000000', 'consum', 0.0223, 'lps'),
	(632261, 134, '2015-01-01 00:12:46.000000', 'consum', 0.0212, 'lps'),
	(632262, 134, '2015-01-01 00:12:47.000000', 'consum', 0.0228, 'lps'),
	(632263, 134, '2015-01-01 00:12:48.000000', 'consum', 0.0250, 'lps'),
	(632264, 134, '2015-01-01 00:12:49.000000', 'consum', 0.0220, 'lps'),
	(632265, 134, '2015-01-01 00:12:50.000000', 'consum', 0.0231, 'lps'),
	(632266, 134, '2015-01-01 00:12:51.000000', 'consum', 0.0241, 'lps'),
	(632267, 134, '2015-01-01 00:12:52.000000', 'consum', 0.0214, 'lps'),
	(632268, 134, '2015-01-01 00:12:53.000000', 'consum', 0.0225, 'lps'),
	(632269, 134, '2015-01-01 00:12:54.000000', 'consum', 0.0231, 'lps'),
	(632270, 134, '2015-01-01 00:12:55.000000', 'consum', 0.0225, 'lps'),
	(632271, 134, '2015-01-01 00:12:56.000000', 'consum', 0.0222, 'lps'),
	(632272, 134, '2015-01-01 00:12:57.000000', 'consum', 0.0225, 'lps'),
	(632273, 134, '2015-01-01 00:12:58.000000', 'consum', 0.0248, 'lps'),
	(632274, 134, '2015-01-01 00:12:59.000000', 'consum', 0.0223, 'lps'),
	(632275, 134, '2015-01-01 00:13:00.000000', 'consum', 0.0250, 'lps'),
	(632276, 134, '2015-01-01 00:13:01.000000', 'consum', 0.0238, 'lps'),
	(632277, 134, '2015-01-01 00:13:02.000000', 'consum', 0.0228, 'lps'),
	(632278, 134, '2015-01-01 00:13:03.000000', 'consum', 0.0218, 'lps'),
	(632279, 134, '2015-01-01 00:13:04.000000', 'consum', 0.0243, 'lps'),
	(632280, 134, '2015-01-01 00:13:05.000000', 'consum', 0.0217, 'lps'),
	(632281, 134, '2015-01-01 00:13:06.000000', 'consum', 0.0233, 'lps'),
	(632282, 134, '2015-01-01 00:13:07.000000', 'consum', 0.0218, 'lps'),
	(632283, 134, '2015-01-01 00:13:08.000000', 'consum', 0.0225, 'lps'),
	(632284, 134, '2015-01-01 00:13:09.000000', 'consum', 0.0216, 'lps'),
	(632285, 134, '2015-01-01 00:13:10.000000', 'consum', 0.0243, 'lps'),
	(632286, 134, '2015-01-01 00:13:11.000000', 'consum', 0.0220, 'lps'),
	(632287, 134, '2015-01-01 00:13:12.000000', 'consum', 0.0252, 'lps'),
	(632288, 134, '2015-01-01 00:13:13.000000', 'consum', 0.0254, 'lps'),
	(632289, 134, '2015-01-01 00:13:14.000000', 'consum', 0.0216, 'lps'),
	(632290, 134, '2015-01-01 00:13:15.000000', 'consum', 0.0243, 'lps'),
	(632291, 134, '2015-01-01 00:13:16.000000', 'consum', 0.0222, 'lps'),
	(632292, 134, '2015-01-01 00:13:17.000000', 'consum', 0.0218, 'lps'),
	(632293, 134, '2015-01-01 00:13:18.000000', 'consum', 0.0214, 'lps'),
	(632294, 134, '2015-01-01 00:13:19.000000', 'consum', 0.0252, 'lps'),
	(632295, 134, '2015-01-01 00:13:20.000000', 'consum', 0.0229, 'lps'),
	(632296, 134, '2015-01-01 00:13:21.000000', 'consum', 0.0224, 'lps'),
	(632297, 134, '2015-01-01 00:13:22.000000', 'consum', 0.0224, 'lps'),
	(632298, 134, '2015-01-01 00:13:23.000000', 'consum', 0.0238, 'lps'),
	(632299, 134, '2015-01-01 00:13:24.000000', 'consum', 0.0217, 'lps'),
	(632300, 134, '2015-01-01 00:13:25.000000', 'consum', 0.0252, 'lps'),
	(632301, 134, '2015-01-01 00:13:26.000000', 'consum', 0.0221, 'lps'),
	(632302, 134, '2015-01-01 00:13:27.000000', 'consum', 0.0229, 'lps'),
	(632303, 134, '2015-01-01 00:13:28.000000', 'consum', 0.0228, 'lps'),
	(632304, 134, '2015-01-01 00:13:29.000000', 'consum', 0.0242, 'lps'),
	(632305, 134, '2015-01-01 00:13:30.000000', 'consum', 0.0226, 'lps'),
	(632306, 134, '2015-01-01 00:13:31.000000', 'consum', 0.0239, 'lps'),
	(632307, 134, '2015-01-01 00:13:32.000000', 'consum', 0.0220, 'lps'),
	(632308, 134, '2015-01-01 00:13:33.000000', 'consum', 0.0218, 'lps'),
	(632309, 134, '2015-01-01 00:13:34.000000', 'consum', 0.0219, 'lps'),
	(632310, 134, '2015-01-01 00:13:35.000000', 'consum', 0.0233, 'lps'),
	(632311, 134, '2015-01-01 00:13:36.000000', 'consum', 0.0253, 'lps'),
	(632312, 134, '2015-01-01 00:13:37.000000', 'consum', 0.0221, 'lps'),
	(632313, 134, '2015-01-01 00:13:38.000000', 'consum', 0.0226, 'lps'),
	(632314, 134, '2015-01-01 00:13:39.000000', 'consum', 0.0214, 'lps'),
	(632315, 134, '2015-01-01 00:13:40.000000', 'consum', 0.0227, 'lps'),
	(632316, 134, '2015-01-01 00:13:41.000000', 'consum', 0.0237, 'lps'),
	(632317, 134, '2015-01-01 00:13:42.000000', 'consum', 0.0250, 'lps'),
	(632318, 134, '2015-01-01 00:13:43.000000', 'consum', 0.0241, 'lps'),
	(632319, 134, '2015-01-01 00:13:44.000000', 'consum', 0.0244, 'lps'),
	(632320, 134, '2015-01-01 00:13:45.000000', 'consum', 0.0244, 'lps'),
	(632321, 134, '2015-01-01 00:13:46.000000', 'consum', 0.0233, 'lps'),
	(632322, 134, '2015-01-01 00:13:47.000000', 'consum', 0.0225, 'lps'),
	(632323, 134, '2015-01-01 00:13:48.000000', 'consum', 0.0214, 'lps'),
	(632324, 134, '2015-01-01 00:13:49.000000', 'consum', 0.0232, 'lps'),
	(632325, 134, '2015-01-01 00:13:50.000000', 'consum', 0.0218, 'lps'),
	(632326, 134, '2015-01-01 00:13:51.000000', 'consum', 0.0230, 'lps'),
	(632327, 134, '2015-01-01 00:13:52.000000', 'consum', 0.0240, 'lps'),
	(632328, 134, '2015-01-01 00:13:53.000000', 'consum', 0.0210, 'lps'),
	(632329, 134, '2015-01-01 00:13:54.000000', 'consum', 0.0211, 'lps'),
	(632330, 134, '2015-01-01 00:13:55.000000', 'consum', 0.0215, 'lps'),
	(632331, 134, '2015-01-01 00:13:56.000000', 'consum', 0.0235, 'lps'),
	(632332, 134, '2015-01-01 00:13:57.000000', 'consum', 0.0229, 'lps'),
	(632333, 134, '2015-01-01 00:13:58.000000', 'consum', 0.0230, 'lps'),
	(632334, 134, '2015-01-01 00:13:59.000000', 'consum', 0.0253, 'lps'),
	(632335, 134, '2015-01-01 00:14:00.000000', 'consum', 0.0230, 'lps'),
	(632336, 134, '2015-01-01 00:14:01.000000', 'consum', 0.0227, 'lps'),
	(632337, 134, '2015-01-01 00:14:02.000000', 'consum', 0.0235, 'lps'),
	(632338, 134, '2015-01-01 00:14:03.000000', 'consum', 0.0240, 'lps'),
	(632339, 134, '2015-01-01 00:14:04.000000', 'consum', 0.0241, 'lps'),
	(632340, 134, '2015-01-01 00:14:05.000000', 'consum', 0.0232, 'lps'),
	(632341, 134, '2015-01-01 00:14:06.000000', 'consum', 0.0224, 'lps'),
	(632342, 134, '2015-01-01 00:14:07.000000', 'consum', 0.0217, 'lps'),
	(632343, 134, '2015-01-01 00:14:08.000000', 'consum', 0.0249, 'lps'),
	(632344, 134, '2015-01-01 00:14:09.000000', 'consum', 0.0248, 'lps'),
	(632345, 134, '2015-01-01 00:14:10.000000', 'consum', 0.0237, 'lps'),
	(632346, 134, '2015-01-01 00:14:11.000000', 'consum', 0.0232, 'lps'),
	(632347, 134, '2015-01-01 00:14:12.000000', 'consum', 0.0242, 'lps'),
	(632348, 134, '2015-01-01 00:14:13.000000', 'consum', 0.0212, 'lps'),
	(632349, 134, '2015-01-01 00:14:14.000000', 'consum', 0.0213, 'lps'),
	(632350, 134, '2015-01-01 00:14:15.000000', 'consum', 0.0222, 'lps'),
	(632351, 134, '2015-01-01 00:14:16.000000', 'consum', 0.0217, 'lps'),
	(632352, 134, '2015-01-01 00:14:17.000000', 'consum', 0.0210, 'lps'),
	(632353, 134, '2015-01-01 00:14:18.000000', 'consum', 0.0234, 'lps'),
	(632354, 134, '2015-01-01 00:14:19.000000', 'consum', 0.0242, 'lps'),
	(632355, 134, '2015-01-01 00:14:20.000000', 'consum', 0.0253, 'lps'),
	(632356, 134, '2015-01-01 00:14:21.000000', 'consum', 0.0240, 'lps'),
	(632357, 134, '2015-01-01 00:14:22.000000', 'consum', 0.0232, 'lps'),
	(632358, 134, '2015-01-01 00:14:23.000000', 'consum', 0.0229, 'lps'),
	(632359, 134, '2015-01-01 00:14:24.000000', 'consum', 0.0239, 'lps'),
	(632360, 134, '2015-01-01 00:14:25.000000', 'consum', 0.0210, 'lps'),
	(632361, 134, '2015-01-01 00:14:26.000000', 'consum', 0.0214, 'lps'),
	(632362, 134, '2015-01-01 00:14:27.000000', 'consum', 0.0230, 'lps'),
	(632363, 134, '2015-01-01 00:14:28.000000', 'consum', 0.0254, 'lps'),
	(632364, 134, '2015-01-01 00:14:29.000000', 'consum', 0.0236, 'lps'),
	(632365, 134, '2015-01-01 00:14:30.000000', 'consum', 0.0253, 'lps'),
	(632366, 134, '2015-01-01 00:14:31.000000', 'consum', 0.0211, 'lps'),
	(632367, 134, '2015-01-01 00:14:32.000000', 'consum', 0.0221, 'lps'),
	(632368, 134, '2015-01-01 00:14:33.000000', 'consum', 0.0216, 'lps'),
	(632369, 134, '2015-01-01 00:14:34.000000', 'consum', 0.0211, 'lps'),
	(632370, 134, '2015-01-01 00:14:35.000000', 'consum', 0.0242, 'lps'),
	(632371, 134, '2015-01-01 00:14:36.000000', 'consum', 0.0232, 'lps'),
	(632372, 134, '2015-01-01 00:14:37.000000', 'consum', 0.0226, 'lps'),
	(632373, 134, '2015-01-01 00:14:38.000000', 'consum', 0.0221, 'lps'),
	(632374, 134, '2015-01-01 00:14:39.000000', 'consum', 0.0221, 'lps'),
	(632375, 134, '2015-01-01 00:14:40.000000', 'consum', 0.0231, 'lps'),
	(632376, 134, '2015-01-01 00:14:41.000000', 'consum', 0.0236, 'lps'),
	(632377, 134, '2015-01-01 00:14:42.000000', 'consum', 0.0233, 'lps'),
	(632378, 134, '2015-01-01 00:14:43.000000', 'consum', 0.0250, 'lps'),
	(632379, 134, '2015-01-01 00:14:44.000000', 'consum', 0.0248, 'lps'),
	(632380, 134, '2015-01-01 00:14:45.000000', 'consum', 0.0238, 'lps'),
	(632381, 134, '2015-01-01 00:14:46.000000', 'consum', 0.0235, 'lps'),
	(632382, 134, '2015-01-01 00:14:47.000000', 'consum', 0.0251, 'lps'),
	(632383, 134, '2015-01-01 00:14:48.000000', 'consum', 0.0251, 'lps'),
	(632384, 134, '2015-01-01 00:14:49.000000', 'consum', 0.0248, 'lps'),
	(632385, 134, '2015-01-01 00:14:50.000000', 'consum', 0.0231, 'lps'),
	(632386, 134, '2015-01-01 00:14:51.000000', 'consum', 0.0248, 'lps'),
	(632387, 134, '2015-01-01 00:14:52.000000', 'consum', 0.0246, 'lps'),
	(632388, 134, '2015-01-01 00:14:53.000000', 'consum', 0.0233, 'lps'),
	(632389, 134, '2015-01-01 00:14:54.000000', 'consum', 0.0215, 'lps'),
	(632390, 134, '2015-01-01 00:14:55.000000', 'consum', 0.0213, 'lps'),
	(632391, 134, '2015-01-01 00:14:56.000000', 'consum', 0.0254, 'lps'),
	(632392, 134, '2015-01-01 00:14:57.000000', 'consum', 0.0243, 'lps'),
	(632393, 134, '2015-01-01 00:14:58.000000', 'consum', 0.0244, 'lps'),
	(632394, 134, '2015-01-01 00:14:59.000000', 'consum', 0.0238, 'lps'),
	(632395, 134, '2015-01-01 00:15:00.000000', 'consum', 0.0246, 'lps'),
	(632396, 134, '2015-01-01 00:15:01.000000', 'consum', 0.0218, 'lps'),
	(632397, 134, '2015-01-01 00:15:02.000000', 'consum', 0.0234, 'lps'),
	(632398, 134, '2015-01-01 00:15:03.000000', 'consum', 0.0213, 'lps'),
	(632399, 134, '2015-01-01 00:15:04.000000', 'consum', 0.0245, 'lps'),
	(632400, 134, '2015-01-01 00:15:05.000000', 'consum', 0.0240, 'lps'),
	(632401, 134, '2015-01-01 00:15:06.000000', 'consum', 0.0212, 'lps'),
	(632402, 134, '2015-01-01 00:15:07.000000', 'consum', 0.0222, 'lps'),
	(632403, 134, '2015-01-01 00:15:08.000000', 'consum', 0.0218, 'lps'),
	(632404, 134, '2015-01-01 00:15:09.000000', 'consum', 0.0215, 'lps'),
	(632405, 134, '2015-01-01 00:15:10.000000', 'consum', 0.0210, 'lps'),
	(632406, 134, '2015-01-01 00:15:11.000000', 'consum', 0.0240, 'lps'),
	(632407, 134, '2015-01-01 00:15:12.000000', 'consum', 0.0228, 'lps'),
	(632408, 134, '2015-01-01 00:15:13.000000', 'consum', 0.0253, 'lps'),
	(632409, 134, '2015-01-01 00:15:14.000000', 'consum', 0.0236, 'lps'),
	(632410, 134, '2015-01-01 00:15:15.000000', 'consum', 0.0214, 'lps'),
	(632411, 134, '2015-01-01 00:15:16.000000', 'consum', 0.0243, 'lps'),
	(632412, 134, '2015-01-01 00:15:17.000000', 'consum', 0.0229, 'lps'),
	(632413, 134, '2015-01-01 00:15:18.000000', 'consum', 0.0252, 'lps'),
	(632414, 134, '2015-01-01 00:15:19.000000', 'consum', 0.0227, 'lps'),
	(632415, 134, '2015-01-01 00:15:20.000000', 'consum', 0.0213, 'lps'),
	(632416, 134, '2015-01-01 00:15:21.000000', 'consum', 0.0222, 'lps'),
	(632417, 134, '2015-01-01 00:15:22.000000', 'consum', 0.0217, 'lps'),
	(632418, 134, '2015-01-01 00:15:23.000000', 'consum', 0.0210, 'lps'),
	(632419, 134, '2015-01-01 00:15:24.000000', 'consum', 0.0232, 'lps'),
	(632420, 134, '2015-01-01 00:15:25.000000', 'consum', 0.0232, 'lps'),
	(632421, 134, '2015-01-01 00:15:26.000000', 'consum', 0.0253, 'lps'),
	(632422, 134, '2015-01-01 00:15:27.000000', 'consum', 0.0224, 'lps'),
	(632423, 134, '2015-01-01 00:15:28.000000', 'consum', 0.0244, 'lps'),
	(632424, 134, '2015-01-01 00:15:29.000000', 'consum', 0.0248, 'lps'),
	(632425, 134, '2015-01-01 00:15:30.000000', 'consum', 0.0210, 'lps'),
	(632426, 134, '2015-01-01 00:15:31.000000', 'consum', 0.0230, 'lps'),
	(632427, 134, '2015-01-01 00:15:32.000000', 'consum', 0.0220, 'lps'),
	(632428, 134, '2015-01-01 00:15:33.000000', 'consum', 0.0246, 'lps'),
	(632429, 134, '2015-01-01 00:15:34.000000', 'consum', 0.0224, 'lps'),
	(632430, 134, '2015-01-01 00:15:35.000000', 'consum', 0.0217, 'lps'),
	(632431, 134, '2015-01-01 00:15:36.000000', 'consum', 0.0250, 'lps'),
	(632432, 134, '2015-01-01 00:15:37.000000', 'consum', 0.0210, 'lps'),
	(632433, 134, '2015-01-01 00:15:38.000000', 'consum', 0.0225, 'lps'),
	(632434, 134, '2015-01-01 00:15:39.000000', 'consum', 0.0239, 'lps'),
	(632435, 134, '2015-01-01 00:15:40.000000', 'consum', 0.0220, 'lps'),
	(632436, 134, '2015-01-01 00:15:41.000000', 'consum', 0.0219, 'lps'),
	(632437, 134, '2015-01-01 00:15:42.000000', 'consum', 0.0224, 'lps'),
	(632438, 134, '2015-01-01 00:15:43.000000', 'consum', 0.0211, 'lps'),
	(632439, 134, '2015-01-01 00:15:44.000000', 'consum', 0.0217, 'lps'),
	(632440, 134, '2015-01-01 00:15:45.000000', 'consum', 0.0244, 'lps'),
	(632441, 134, '2015-01-01 00:15:46.000000', 'consum', 0.0223, 'lps'),
	(632442, 134, '2015-01-01 00:15:47.000000', 'consum', 0.0217, 'lps'),
	(632443, 134, '2015-01-01 00:15:48.000000', 'consum', 0.0253, 'lps'),
	(632444, 134, '2015-01-01 00:15:49.000000', 'consum', 0.0224, 'lps'),
	(632445, 134, '2015-01-01 00:15:50.000000', 'consum', 0.0242, 'lps'),
	(632446, 134, '2015-01-01 00:15:51.000000', 'consum', 0.0240, 'lps'),
	(632447, 134, '2015-01-01 00:15:52.000000', 'consum', 0.0219, 'lps'),
	(632448, 134, '2015-01-01 00:15:53.000000', 'consum', 0.0212, 'lps'),
	(632449, 134, '2015-01-01 00:15:54.000000', 'consum', 0.0235, 'lps'),
	(632450, 134, '2015-01-01 00:15:55.000000', 'consum', 0.0241, 'lps'),
	(632451, 134, '2015-01-01 00:15:56.000000', 'consum', 0.0247, 'lps'),
	(632452, 134, '2015-01-01 00:15:57.000000', 'consum', 0.0212, 'lps'),
	(632453, 134, '2015-01-01 00:15:58.000000', 'consum', 0.0244, 'lps'),
	(632454, 134, '2015-01-01 00:15:59.000000', 'consum', 0.0242, 'lps'),
	(632455, 134, '2015-01-01 00:16:00.000000', 'consum', 0.0220, 'lps'),
	(632456, 134, '2015-01-01 00:16:01.000000', 'consum', 0.0210, 'lps'),
	(632457, 134, '2015-01-01 00:16:02.000000', 'consum', 0.0226, 'lps'),
	(632458, 134, '2015-01-01 00:16:03.000000', 'consum', 0.0246, 'lps'),
	(632459, 134, '2015-01-01 00:16:04.000000', 'consum', 0.0251, 'lps'),
	(632460, 134, '2015-01-01 00:16:05.000000', 'consum', 0.0220, 'lps'),
	(632461, 134, '2015-01-01 00:16:06.000000', 'consum', 0.0228, 'lps'),
	(632462, 134, '2015-01-01 00:16:07.000000', 'consum', 0.0225, 'lps'),
	(632463, 134, '2015-01-01 00:16:08.000000', 'consum', 0.0231, 'lps'),
	(632464, 134, '2015-01-01 00:16:09.000000', 'consum', 0.0227, 'lps'),
	(632465, 134, '2015-01-01 00:16:10.000000', 'consum', 0.0233, 'lps'),
	(632466, 134, '2015-01-01 00:16:11.000000', 'consum', 0.0228, 'lps'),
	(632467, 134, '2015-01-01 00:16:12.000000', 'consum', 0.0232, 'lps'),
	(632468, 134, '2015-01-01 00:16:13.000000', 'consum', 0.0221, 'lps'),
	(632469, 134, '2015-01-01 00:16:14.000000', 'consum', 0.0246, 'lps'),
	(632470, 134, '2015-01-01 00:16:15.000000', 'consum', 0.0223, 'lps'),
	(632471, 134, '2015-01-01 00:16:16.000000', 'consum', 0.0211, 'lps'),
	(632472, 134, '2015-01-01 00:16:17.000000', 'consum', 0.0222, 'lps'),
	(632473, 134, '2015-01-01 00:16:18.000000', 'consum', 0.0224, 'lps'),
	(632474, 134, '2015-01-01 00:16:19.000000', 'consum', 0.0243, 'lps'),
	(632475, 134, '2015-01-01 00:16:20.000000', 'consum', 0.0245, 'lps'),
	(632476, 134, '2015-01-01 00:16:21.000000', 'consum', 0.0241, 'lps'),
	(632477, 134, '2015-01-01 00:16:22.000000', 'consum', 0.0215, 'lps'),
	(632478, 134, '2015-01-01 00:16:23.000000', 'consum', 0.0232, 'lps'),
	(632479, 134, '2015-01-01 00:16:24.000000', 'consum', 0.0218, 'lps'),
	(632480, 134, '2015-01-01 00:16:25.000000', 'consum', 0.0227, 'lps'),
	(632481, 134, '2015-01-01 00:16:26.000000', 'consum', 0.0228, 'lps'),
	(632482, 134, '2015-01-01 00:16:27.000000', 'consum', 0.0248, 'lps'),
	(632483, 134, '2015-01-01 00:16:28.000000', 'consum', 0.0211, 'lps'),
	(632484, 134, '2015-01-01 00:16:29.000000', 'consum', 0.0237, 'lps'),
	(632485, 134, '2015-01-01 00:16:30.000000', 'consum', 0.0254, 'lps'),
	(632486, 134, '2015-01-01 00:16:31.000000', 'consum', 0.0212, 'lps'),
	(632487, 134, '2015-01-01 00:16:32.000000', 'consum', 0.0226, 'lps'),
	(632488, 134, '2015-01-01 00:16:33.000000', 'consum', 0.0239, 'lps'),
	(632489, 134, '2015-01-01 00:16:34.000000', 'consum', 0.0216, 'lps'),
	(632490, 134, '2015-01-01 00:16:35.000000', 'consum', 0.0243, 'lps'),
	(632491, 134, '2015-01-01 00:16:36.000000', 'consum', 0.0223, 'lps'),
	(632492, 134, '2015-01-01 00:16:37.000000', 'consum', 0.0223, 'lps'),
	(632493, 134, '2015-01-01 00:16:38.000000', 'consum', 0.0235, 'lps'),
	(632494, 134, '2015-01-01 00:16:39.000000', 'consum', 0.0250, 'lps'),
	(632495, 134, '2015-01-01 00:16:40.000000', 'consum', 0.0246, 'lps'),
	(632496, 134, '2015-01-01 00:16:41.000000', 'consum', 0.0228, 'lps'),
	(632497, 134, '2015-01-01 00:16:42.000000', 'consum', 0.0235, 'lps'),
	(632498, 134, '2015-01-01 00:16:43.000000', 'consum', 0.0237, 'lps'),
	(632499, 134, '2015-01-01 00:16:44.000000', 'consum', 0.0225, 'lps'),
	(632500, 134, '2015-01-01 00:16:45.000000', 'consum', 0.0249, 'lps'),
	(632501, 134, '2015-01-01 00:16:46.000000', 'consum', 0.0226, 'lps'),
	(632502, 134, '2015-01-01 00:16:47.000000', 'consum', 0.0218, 'lps'),
	(632503, 134, '2015-01-01 00:16:48.000000', 'consum', 0.0250, 'lps'),
	(632504, 134, '2015-01-01 00:16:49.000000', 'consum', 0.0249, 'lps'),
	(632505, 134, '2015-01-01 00:16:50.000000', 'consum', 0.0242, 'lps'),
	(632506, 134, '2015-01-01 00:16:51.000000', 'consum', 0.0253, 'lps'),
	(632507, 134, '2015-01-01 00:16:52.000000', 'consum', 0.0238, 'lps'),
	(632508, 134, '2015-01-01 00:16:53.000000', 'consum', 0.0224, 'lps'),
	(632509, 134, '2015-01-01 00:16:54.000000', 'consum', 0.0242, 'lps'),
	(632510, 134, '2015-01-01 00:16:55.000000', 'consum', 0.0239, 'lps'),
	(632511, 134, '2015-01-01 00:16:56.000000', 'consum', 0.0214, 'lps'),
	(632512, 134, '2015-01-01 00:16:57.000000', 'consum', 0.0234, 'lps'),
	(632513, 134, '2015-01-01 00:16:58.000000', 'consum', 0.0228, 'lps'),
	(632514, 134, '2015-01-01 00:16:59.000000', 'consum', 0.0227, 'lps'),
	(632515, 134, '2015-01-01 00:17:00.000000', 'consum', 0.0243, 'lps'),
	(632516, 134, '2015-01-01 00:17:01.000000', 'consum', 0.0234, 'lps'),
	(632517, 134, '2015-01-01 00:17:02.000000', 'consum', 0.0231, 'lps'),
	(632518, 134, '2015-01-01 00:17:03.000000', 'consum', 0.0243, 'lps'),
	(632519, 134, '2015-01-01 00:17:04.000000', 'consum', 0.0224, 'lps'),
	(632520, 134, '2015-01-01 00:17:05.000000', 'consum', 0.0226, 'lps'),
	(632521, 134, '2015-01-01 00:17:06.000000', 'consum', 0.0247, 'lps'),
	(632522, 134, '2015-01-01 00:17:07.000000', 'consum', 0.0212, 'lps'),
	(632523, 134, '2015-01-01 00:17:08.000000', 'consum', 0.0245, 'lps'),
	(632524, 134, '2015-01-01 00:17:09.000000', 'consum', 0.0246, 'lps'),
	(632525, 134, '2015-01-01 00:17:10.000000', 'consum', 0.0238, 'lps'),
	(632526, 134, '2015-01-01 00:17:11.000000', 'consum', 0.0243, 'lps'),
	(632527, 134, '2015-01-01 00:17:12.000000', 'consum', 0.0249, 'lps'),
	(632528, 134, '2015-01-01 00:17:13.000000', 'consum', 0.0213, 'lps'),
	(632529, 134, '2015-01-01 00:17:14.000000', 'consum', 0.0247, 'lps'),
	(632530, 134, '2015-01-01 00:17:15.000000', 'consum', 0.0250, 'lps'),
	(632531, 134, '2015-01-01 00:17:16.000000', 'consum', 0.0211, 'lps'),
	(632532, 134, '2015-01-01 00:17:17.000000', 'consum', 0.0231, 'lps'),
	(632533, 134, '2015-01-01 00:17:18.000000', 'consum', 0.0221, 'lps'),
	(632534, 134, '2015-01-01 00:17:19.000000', 'consum', 0.0248, 'lps'),
	(632535, 134, '2015-01-01 00:17:20.000000', 'consum', 0.0232, 'lps'),
	(632536, 134, '2015-01-01 00:17:21.000000', 'consum', 0.0254, 'lps'),
	(632537, 134, '2015-01-01 00:17:22.000000', 'consum', 0.0227, 'lps'),
	(632538, 134, '2015-01-01 00:17:23.000000', 'consum', 0.0254, 'lps'),
	(632539, 134, '2015-01-01 00:17:24.000000', 'consum', 0.0245, 'lps'),
	(632540, 134, '2015-01-01 00:17:25.000000', 'consum', 0.0253, 'lps'),
	(632541, 134, '2015-01-01 00:17:26.000000', 'consum', 0.0232, 'lps'),
	(632542, 134, '2015-01-01 00:17:27.000000', 'consum', 0.0234, 'lps'),
	(632543, 134, '2015-01-01 00:17:28.000000', 'consum', 0.0221, 'lps'),
	(632544, 134, '2015-01-01 00:17:29.000000', 'consum', 0.0237, 'lps'),
	(632545, 134, '2015-01-01 00:17:30.000000', 'consum', 0.0222, 'lps'),
	(632546, 134, '2015-01-01 00:17:31.000000', 'consum', 0.0236, 'lps'),
	(632547, 134, '2015-01-01 00:17:32.000000', 'consum', 0.0214, 'lps'),
	(632548, 134, '2015-01-01 00:17:33.000000', 'consum', 0.0245, 'lps'),
	(632549, 134, '2015-01-01 00:17:34.000000', 'consum', 0.0235, 'lps'),
	(632550, 134, '2015-01-01 00:17:35.000000', 'consum', 0.0230, 'lps'),
	(632551, 134, '2015-01-01 00:17:36.000000', 'consum', 0.0239, 'lps'),
	(632552, 134, '2015-01-01 00:17:37.000000', 'consum', 0.0247, 'lps'),
	(632553, 134, '2015-01-01 00:17:38.000000', 'consum', 0.0220, 'lps'),
	(632554, 134, '2015-01-01 00:17:39.000000', 'consum', 0.0238, 'lps'),
	(632555, 134, '2015-01-01 00:17:40.000000', 'consum', 0.0232, 'lps'),
	(632556, 134, '2015-01-01 00:17:41.000000', 'consum', 0.0238, 'lps'),
	(632557, 134, '2015-01-01 00:17:42.000000', 'consum', 0.0239, 'lps'),
	(632558, 134, '2015-01-01 00:17:43.000000', 'consum', 0.0227, 'lps'),
	(632559, 134, '2015-01-01 00:17:44.000000', 'consum', 0.0253, 'lps'),
	(632560, 134, '2015-01-01 00:17:45.000000', 'consum', 0.0237, 'lps'),
	(632561, 134, '2015-01-01 00:17:46.000000', 'consum', 0.0220, 'lps'),
	(632562, 134, '2015-01-01 00:17:47.000000', 'consum', 0.0223, 'lps'),
	(632563, 134, '2015-01-01 00:17:48.000000', 'consum', 0.0248, 'lps'),
	(632564, 134, '2015-01-01 00:17:49.000000', 'consum', 0.0223, 'lps'),
	(632565, 134, '2015-01-01 00:17:50.000000', 'consum', 0.0253, 'lps'),
	(632566, 134, '2015-01-01 00:17:51.000000', 'consum', 0.0253, 'lps'),
	(632567, 134, '2015-01-01 00:17:52.000000', 'consum', 0.0252, 'lps'),
	(632568, 134, '2015-01-01 00:17:53.000000', 'consum', 0.0246, 'lps'),
	(632569, 134, '2015-01-01 00:17:54.000000', 'consum', 0.0220, 'lps'),
	(632570, 134, '2015-01-01 00:17:55.000000', 'consum', 0.0241, 'lps'),
	(632571, 134, '2015-01-01 00:17:56.000000', 'consum', 0.0247, 'lps'),
	(632572, 134, '2015-01-01 00:17:57.000000', 'consum', 0.0212, 'lps'),
	(632573, 134, '2015-01-01 00:17:58.000000', 'consum', 0.0247, 'lps'),
	(632574, 134, '2015-01-01 00:17:59.000000', 'consum', 0.0251, 'lps'),
	(632575, 134, '2015-01-01 00:18:00.000000', 'consum', 0.0214, 'lps'),
	(632576, 134, '2015-01-01 00:18:01.000000', 'consum', 0.0243, 'lps'),
	(632577, 134, '2015-01-01 00:18:02.000000', 'consum', 0.0230, 'lps'),
	(632578, 134, '2015-01-01 00:18:03.000000', 'consum', 0.0212, 'lps'),
	(632579, 134, '2015-01-01 00:18:04.000000', 'consum', 0.0251, 'lps'),
	(632580, 134, '2015-01-01 00:18:05.000000', 'consum', 0.0230, 'lps'),
	(632581, 134, '2015-01-01 00:18:06.000000', 'consum', 0.0232, 'lps'),
	(632582, 134, '2015-01-01 00:18:07.000000', 'consum', 0.0215, 'lps'),
	(632583, 134, '2015-01-01 00:18:08.000000', 'consum', 0.0213, 'lps'),
	(632584, 134, '2015-01-01 00:18:09.000000', 'consum', 0.0211, 'lps'),
	(632585, 134, '2015-01-01 00:18:10.000000', 'consum', 0.0251, 'lps'),
	(632586, 134, '2015-01-01 00:18:11.000000', 'consum', 0.0234, 'lps'),
	(632587, 134, '2015-01-01 00:18:12.000000', 'consum', 0.0253, 'lps'),
	(632588, 134, '2015-01-01 00:18:13.000000', 'consum', 0.0218, 'lps'),
	(632589, 134, '2015-01-01 00:18:14.000000', 'consum', 0.0211, 'lps'),
	(632590, 134, '2015-01-01 00:18:15.000000', 'consum', 0.0236, 'lps'),
	(632591, 134, '2015-01-01 00:18:16.000000', 'consum', 0.0248, 'lps'),
	(632592, 134, '2015-01-01 00:18:17.000000', 'consum', 0.0232, 'lps'),
	(632593, 134, '2015-01-01 00:18:18.000000', 'consum', 0.0250, 'lps'),
	(632594, 134, '2015-01-01 00:18:19.000000', 'consum', 0.0211, 'lps'),
	(632595, 134, '2015-01-01 00:18:20.000000', 'consum', 0.0232, 'lps'),
	(632596, 134, '2015-01-01 00:18:21.000000', 'consum', 0.0227, 'lps'),
	(632597, 134, '2015-01-01 00:18:22.000000', 'consum', 0.0229, 'lps'),
	(632598, 134, '2015-01-01 00:18:23.000000', 'consum', 0.0253, 'lps'),
	(632599, 134, '2015-01-01 00:18:24.000000', 'consum', 0.0234, 'lps'),
	(632600, 134, '2015-01-01 00:18:25.000000', 'consum', 0.0248, 'lps'),
	(632601, 134, '2015-01-01 00:18:26.000000', 'consum', 0.0239, 'lps'),
	(632602, 134, '2015-01-01 00:18:27.000000', 'consum', 0.0242, 'lps'),
	(632603, 134, '2015-01-01 00:18:28.000000', 'consum', 0.0236, 'lps'),
	(632604, 134, '2015-01-01 00:18:29.000000', 'consum', 0.0244, 'lps'),
	(632605, 134, '2015-01-01 00:18:30.000000', 'consum', 0.0212, 'lps'),
	(632606, 134, '2015-01-01 00:18:31.000000', 'consum', 0.0211, 'lps'),
	(632607, 134, '2015-01-01 00:18:32.000000', 'consum', 0.0253, 'lps'),
	(632608, 134, '2015-01-01 00:18:33.000000', 'consum', 0.0242, 'lps'),
	(632609, 134, '2015-01-01 00:18:34.000000', 'consum', 0.0241, 'lps'),
	(632610, 134, '2015-01-01 00:18:35.000000', 'consum', 0.0226, 'lps'),
	(632611, 134, '2015-01-01 00:18:36.000000', 'consum', 0.0241, 'lps'),
	(632612, 134, '2015-01-01 00:18:37.000000', 'consum', 0.0230, 'lps'),
	(632613, 134, '2015-01-01 00:18:38.000000', 'consum', 0.0217, 'lps'),
	(632614, 134, '2015-01-01 00:18:39.000000', 'consum', 0.0231, 'lps'),
	(632615, 134, '2015-01-01 00:18:40.000000', 'consum', 0.0248, 'lps'),
	(632616, 134, '2015-01-01 00:18:41.000000', 'consum', 0.0248, 'lps'),
	(632617, 134, '2015-01-01 00:18:42.000000', 'consum', 0.0242, 'lps'),
	(632618, 134, '2015-01-01 00:18:43.000000', 'consum', 0.0213, 'lps'),
	(632619, 134, '2015-01-01 00:18:44.000000', 'consum', 0.0218, 'lps'),
	(632620, 134, '2015-01-01 00:18:45.000000', 'consum', 0.0242, 'lps'),
	(632621, 134, '2015-01-01 00:18:46.000000', 'consum', 0.0210, 'lps'),
	(632622, 134, '2015-01-01 00:18:47.000000', 'consum', 0.0250, 'lps'),
	(632623, 134, '2015-01-01 00:18:48.000000', 'consum', 0.0230, 'lps'),
	(632624, 134, '2015-01-01 00:18:49.000000', 'consum', 0.0238, 'lps'),
	(632625, 134, '2015-01-01 00:18:50.000000', 'consum', 0.0243, 'lps'),
	(632626, 134, '2015-01-01 00:18:51.000000', 'consum', 0.0249, 'lps'),
	(632627, 134, '2015-01-01 00:18:52.000000', 'consum', 0.0217, 'lps'),
	(632628, 134, '2015-01-01 00:18:53.000000', 'consum', 0.0218, 'lps'),
	(632629, 134, '2015-01-01 00:18:54.000000', 'consum', 0.0228, 'lps'),
	(632630, 134, '2015-01-01 00:18:55.000000', 'consum', 0.0234, 'lps'),
	(632631, 134, '2015-01-01 00:18:56.000000', 'consum', 0.0229, 'lps'),
	(632632, 134, '2015-01-01 00:18:57.000000', 'consum', 0.0233, 'lps'),
	(632633, 134, '2015-01-01 00:18:58.000000', 'consum', 0.0225, 'lps'),
	(632634, 134, '2015-01-01 00:18:59.000000', 'consum', 0.0215, 'lps'),
	(632635, 134, '2015-01-01 00:19:00.000000', 'consum', 0.0235, 'lps'),
	(632636, 134, '2015-01-01 00:19:01.000000', 'consum', 0.0230, 'lps'),
	(632637, 134, '2015-01-01 00:19:02.000000', 'consum', 0.0236, 'lps'),
	(632638, 134, '2015-01-01 00:19:03.000000', 'consum', 0.0235, 'lps'),
	(632639, 134, '2015-01-01 00:19:04.000000', 'consum', 0.0212, 'lps'),
	(632640, 134, '2015-01-01 00:19:05.000000', 'consum', 0.0238, 'lps'),
	(632641, 134, '2015-01-01 00:19:06.000000', 'consum', 0.0252, 'lps'),
	(632642, 134, '2015-01-01 00:19:07.000000', 'consum', 0.0248, 'lps'),
	(632643, 134, '2015-01-01 00:19:08.000000', 'consum', 0.0231, 'lps'),
	(632644, 134, '2015-01-01 00:19:09.000000', 'consum', 0.0243, 'lps'),
	(632645, 134, '2015-01-01 00:19:10.000000', 'consum', 0.0226, 'lps'),
	(632646, 134, '2015-01-01 00:19:11.000000', 'consum', 0.0234, 'lps'),
	(632647, 134, '2015-01-01 00:19:12.000000', 'consum', 0.0238, 'lps'),
	(632648, 134, '2015-01-01 00:19:13.000000', 'consum', 0.0234, 'lps'),
	(632649, 134, '2015-01-01 00:19:14.000000', 'consum', 0.0244, 'lps'),
	(632650, 134, '2015-01-01 00:19:15.000000', 'consum', 0.0222, 'lps'),
	(632651, 134, '2015-01-01 00:19:16.000000', 'consum', 0.0211, 'lps'),
	(632652, 134, '2015-01-01 00:19:17.000000', 'consum', 0.0225, 'lps'),
	(632653, 134, '2015-01-01 00:19:18.000000', 'consum', 0.0239, 'lps'),
	(632654, 134, '2015-01-01 00:19:19.000000', 'consum', 0.0219, 'lps'),
	(632655, 134, '2015-01-01 00:19:20.000000', 'consum', 0.0214, 'lps'),
	(632656, 134, '2015-01-01 00:19:21.000000', 'consum', 0.0250, 'lps'),
	(632657, 134, '2015-01-01 00:19:22.000000', 'consum', 0.0215, 'lps'),
	(632658, 134, '2015-01-01 00:19:23.000000', 'consum', 0.0254, 'lps'),
	(632659, 134, '2015-01-01 00:19:24.000000', 'consum', 0.0235, 'lps'),
	(632660, 134, '2015-01-01 00:19:25.000000', 'consum', 0.0247, 'lps'),
	(632661, 134, '2015-01-01 00:19:26.000000', 'consum', 0.0231, 'lps'),
	(632662, 134, '2015-01-01 00:19:27.000000', 'consum', 0.0250, 'lps'),
	(632663, 134, '2015-01-01 00:19:28.000000', 'consum', 0.0212, 'lps'),
	(632664, 134, '2015-01-01 00:19:29.000000', 'consum', 0.0234, 'lps'),
	(632665, 134, '2015-01-01 00:19:30.000000', 'consum', 0.0236, 'lps'),
	(632666, 134, '2015-01-01 00:19:31.000000', 'consum', 0.0223, 'lps'),
	(632667, 134, '2015-01-01 00:19:32.000000', 'consum', 0.0244, 'lps'),
	(632668, 134, '2015-01-01 00:19:33.000000', 'consum', 0.0250, 'lps'),
	(632669, 134, '2015-01-01 00:19:34.000000', 'consum', 0.0217, 'lps'),
	(632670, 134, '2015-01-01 00:19:35.000000', 'consum', 0.0217, 'lps'),
	(632671, 134, '2015-01-01 00:19:36.000000', 'consum', 0.0225, 'lps'),
	(632672, 134, '2015-01-01 00:19:37.000000', 'consum', 0.0219, 'lps'),
	(632673, 134, '2015-01-01 00:19:38.000000', 'consum', 0.0211, 'lps'),
	(632674, 134, '2015-01-01 00:19:39.000000', 'consum', 0.0233, 'lps'),
	(632675, 134, '2015-01-01 00:19:40.000000', 'consum', 0.0232, 'lps'),
	(632676, 134, '2015-01-01 00:19:41.000000', 'consum', 0.0254, 'lps'),
	(632677, 134, '2015-01-01 00:19:42.000000', 'consum', 0.0228, 'lps'),
	(632678, 134, '2015-01-01 00:19:43.000000', 'consum', 0.0213, 'lps'),
	(632679, 134, '2015-01-01 00:19:44.000000', 'consum', 0.0218, 'lps'),
	(632680, 134, '2015-01-01 00:19:45.000000', 'consum', 0.0242, 'lps'),
	(632681, 134, '2015-01-01 00:19:46.000000', 'consum', 0.0211, 'lps'),
	(632682, 134, '2015-01-01 00:19:47.000000', 'consum', 0.0210, 'lps'),
	(632683, 134, '2015-01-01 00:19:48.000000', 'consum', 0.0252, 'lps'),
	(632684, 134, '2015-01-01 00:19:49.000000', 'consum', 0.0240, 'lps'),
	(632685, 134, '2015-01-01 00:19:50.000000', 'consum', 0.0235, 'lps'),
	(632686, 134, '2015-01-01 00:19:51.000000', 'consum', 0.0243, 'lps'),
	(632687, 134, '2015-01-01 00:19:52.000000', 'consum', 0.0213, 'lps'),
	(632688, 134, '2015-01-01 00:19:53.000000', 'consum', 0.0218, 'lps'),
	(632689, 134, '2015-01-01 00:19:54.000000', 'consum', 0.0238, 'lps'),
	(632690, 134, '2015-01-01 00:19:55.000000', 'consum', 0.0238, 'lps'),
	(632691, 134, '2015-01-01 00:19:56.000000', 'consum', 0.0223, 'lps'),
	(632692, 134, '2015-01-01 00:19:57.000000', 'consum', 0.0235, 'lps'),
	(632693, 134, '2015-01-01 00:19:58.000000', 'consum', 0.0252, 'lps'),
	(632694, 134, '2015-01-01 00:19:59.000000', 'consum', 0.0212, 'lps'),
	(632695, 134, '2015-01-01 00:20:00.000000', 'consum', 0.0230, 'lps'),
	(632696, 134, '2015-01-01 00:20:01.000000', 'consum', 0.0211, 'lps'),
	(632697, 134, '2015-01-01 00:20:02.000000', 'consum', 0.0248, 'lps'),
	(632698, 134, '2015-01-01 00:20:03.000000', 'consum', 0.0217, 'lps'),
	(632699, 134, '2015-01-01 00:20:04.000000', 'consum', 0.0222, 'lps'),
	(632700, 134, '2015-01-01 00:20:05.000000', 'consum', 0.0250, 'lps'),
	(632701, 134, '2015-01-01 00:20:06.000000', 'consum', 0.0238, 'lps'),
	(632702, 134, '2015-01-01 00:20:07.000000', 'consum', 0.0229, 'lps'),
	(632703, 134, '2015-01-01 00:20:08.000000', 'consum', 0.0225, 'lps'),
	(632704, 134, '2015-01-01 00:20:09.000000', 'consum', 0.0226, 'lps'),
	(632705, 134, '2015-01-01 00:20:10.000000', 'consum', 0.0248, 'lps'),
	(632706, 134, '2015-01-01 00:20:11.000000', 'consum', 0.0217, 'lps'),
	(632707, 134, '2015-01-01 00:20:12.000000', 'consum', 0.0221, 'lps'),
	(632708, 134, '2015-01-01 00:20:13.000000', 'consum', 0.0245, 'lps'),
	(632709, 134, '2015-01-01 00:20:14.000000', 'consum', 0.0216, 'lps'),
	(632710, 134, '2015-01-01 00:20:15.000000', 'consum', 0.0226, 'lps'),
	(632711, 134, '2015-01-01 00:20:16.000000', 'consum', 0.0226, 'lps'),
	(632712, 134, '2015-01-01 00:20:17.000000', 'consum', 0.0244, 'lps'),
	(632713, 134, '2015-01-01 00:20:18.000000', 'consum', 0.0242, 'lps'),
	(632714, 134, '2015-01-01 00:20:19.000000', 'consum', 0.0226, 'lps'),
	(632715, 134, '2015-01-01 00:20:20.000000', 'consum', 0.0237, 'lps'),
	(632716, 134, '2015-01-01 00:20:21.000000', 'consum', 0.0253, 'lps'),
	(632717, 134, '2015-01-01 00:20:22.000000', 'consum', 0.0254, 'lps'),
	(632718, 134, '2015-01-01 00:20:23.000000', 'consum', 0.0212, 'lps'),
	(632719, 134, '2015-01-01 00:20:24.000000', 'consum', 0.0222, 'lps'),
	(632720, 134, '2015-01-01 00:20:25.000000', 'consum', 0.0220, 'lps'),
	(632721, 134, '2015-01-01 00:20:26.000000', 'consum', 0.0226, 'lps'),
	(632722, 134, '2015-01-01 00:20:27.000000', 'consum', 0.0215, 'lps'),
	(632723, 134, '2015-01-01 00:20:28.000000', 'consum', 0.0231, 'lps'),
	(632724, 134, '2015-01-01 00:20:29.000000', 'consum', 0.0210, 'lps'),
	(632725, 134, '2015-01-01 00:20:30.000000', 'consum', 0.0237, 'lps'),
	(632726, 134, '2015-01-01 00:20:31.000000', 'consum', 0.0211, 'lps'),
	(632727, 134, '2015-01-01 00:20:32.000000', 'consum', 0.0227, 'lps'),
	(632728, 134, '2015-01-01 00:20:33.000000', 'consum', 0.0244, 'lps'),
	(632729, 134, '2015-01-01 00:20:34.000000', 'consum', 0.0240, 'lps'),
	(632730, 134, '2015-01-01 00:20:35.000000', 'consum', 0.0216, 'lps'),
	(632731, 134, '2015-01-01 00:20:36.000000', 'consum', 0.0240, 'lps'),
	(632732, 134, '2015-01-01 00:20:37.000000', 'consum', 0.0250, 'lps'),
	(632733, 134, '2015-01-01 00:20:38.000000', 'consum', 0.0234, 'lps'),
	(632734, 134, '2015-01-01 00:20:39.000000', 'consum', 0.0253, 'lps'),
	(632735, 134, '2015-01-01 00:20:40.000000', 'consum', 0.0218, 'lps'),
	(632736, 134, '2015-01-01 00:20:41.000000', 'consum', 0.0214, 'lps'),
	(632737, 134, '2015-01-01 00:20:42.000000', 'consum', 0.0251, 'lps'),
	(632738, 134, '2015-01-01 00:20:43.000000', 'consum', 0.0224, 'lps'),
	(632739, 134, '2015-01-01 00:20:44.000000', 'consum', 0.0247, 'lps'),
	(632740, 134, '2015-01-01 00:20:45.000000', 'consum', 0.0218, 'lps'),
	(632741, 134, '2015-01-01 00:20:46.000000', 'consum', 0.0228, 'lps'),
	(632742, 134, '2015-01-01 00:20:47.000000', 'consum', 0.0233, 'lps'),
	(632743, 134, '2015-01-01 00:20:48.000000', 'consum', 0.0227, 'lps'),
	(632744, 134, '2015-01-01 00:20:49.000000', 'consum', 0.0225, 'lps'),
	(632745, 134, '2015-01-01 00:20:50.000000', 'consum', 0.0234, 'lps'),
	(632746, 134, '2015-01-01 00:20:51.000000', 'consum', 0.0240, 'lps'),
	(632747, 134, '2015-01-01 00:20:52.000000', 'consum', 0.0243, 'lps'),
	(632748, 134, '2015-01-01 00:20:53.000000', 'consum', 0.0243, 'lps'),
	(632749, 134, '2015-01-01 00:20:54.000000', 'consum', 0.0231, 'lps'),
	(632750, 134, '2015-01-01 00:20:55.000000', 'consum', 0.0214, 'lps'),
	(632751, 134, '2015-01-01 00:20:56.000000', 'consum', 0.0214, 'lps'),
	(632752, 134, '2015-01-01 00:20:57.000000', 'consum', 0.0219, 'lps'),
	(632753, 134, '2015-01-01 00:20:58.000000', 'consum', 0.0244, 'lps'),
	(632754, 134, '2015-01-01 00:20:59.000000', 'consum', 0.0218, 'lps'),
	(632755, 134, '2015-01-01 00:21:00.000000', 'consum', 0.0237, 'lps'),
	(632756, 134, '2015-01-01 00:21:01.000000', 'consum', 0.0232, 'lps'),
	(632757, 134, '2015-01-01 00:21:02.000000', 'consum', 0.0241, 'lps'),
	(632758, 134, '2015-01-01 00:21:03.000000', 'consum', 0.0252, 'lps'),
	(632759, 134, '2015-01-01 00:21:04.000000', 'consum', 0.0238, 'lps'),
	(632760, 134, '2015-01-01 00:21:05.000000', 'consum', 0.0227, 'lps'),
	(632761, 134, '2015-01-01 00:21:06.000000', 'consum', 0.0253, 'lps'),
	(632762, 134, '2015-01-01 00:21:07.000000', 'consum', 0.0243, 'lps'),
	(632763, 134, '2015-01-01 00:21:08.000000', 'consum', 0.0245, 'lps'),
	(632764, 134, '2015-01-01 00:21:09.000000', 'consum', 0.0240, 'lps'),
	(632765, 134, '2015-01-01 00:21:10.000000', 'consum', 0.0210, 'lps'),
	(632766, 134, '2015-01-01 00:21:11.000000', 'consum', 0.0211, 'lps'),
	(632767, 134, '2015-01-01 00:21:12.000000', 'consum', 0.0215, 'lps'),
	(632768, 134, '2015-01-01 00:21:13.000000', 'consum', 0.0234, 'lps'),
	(632769, 134, '2015-01-01 00:21:14.000000', 'consum', 0.0226, 'lps'),
	(632770, 134, '2015-01-01 00:21:15.000000', 'consum', 0.0217, 'lps'),
	(632771, 134, '2015-01-01 00:21:16.000000', 'consum', 0.0244, 'lps'),
	(632772, 134, '2015-01-01 00:21:17.000000', 'consum', 0.0225, 'lps'),
	(632773, 134, '2015-01-01 00:21:18.000000', 'consum', 0.0229, 'lps'),
	(632774, 134, '2015-01-01 00:21:19.000000', 'consum', 0.0215, 'lps'),
	(632775, 134, '2015-01-01 00:21:20.000000', 'consum', 0.0224, 'lps'),
	(632776, 134, '2015-01-01 00:21:21.000000', 'consum', 0.0220, 'lps'),
	(632777, 134, '2015-01-01 00:21:22.000000', 'consum', 0.0219, 'lps'),
	(632778, 134, '2015-01-01 00:21:23.000000', 'consum', 0.0223, 'lps'),
	(632779, 134, '2015-01-01 00:21:24.000000', 'consum', 0.0252, 'lps'),
	(632780, 134, '2015-01-01 00:21:25.000000', 'consum', 0.0243, 'lps'),
	(632781, 134, '2015-01-01 00:21:26.000000', 'consum', 0.0252, 'lps'),
	(632782, 134, '2015-01-01 00:21:27.000000', 'consum', 0.0232, 'lps'),
	(632783, 134, '2015-01-01 00:21:28.000000', 'consum', 0.0239, 'lps'),
	(632784, 134, '2015-01-01 00:21:29.000000', 'consum', 0.0244, 'lps'),
	(632785, 134, '2015-01-01 00:21:30.000000', 'consum', 0.0250, 'lps'),
	(632786, 134, '2015-01-01 00:21:31.000000', 'consum', 0.0219, 'lps'),
	(632787, 134, '2015-01-01 00:21:32.000000', 'consum', 0.0225, 'lps'),
	(632788, 134, '2015-01-01 00:21:33.000000', 'consum', 0.0213, 'lps'),
	(632789, 134, '2015-01-01 00:21:34.000000', 'consum', 0.0224, 'lps'),
	(632790, 134, '2015-01-01 00:21:35.000000', 'consum', 0.0226, 'lps'),
	(632791, 134, '2015-01-01 00:21:36.000000', 'consum', 0.0248, 'lps'),
	(632792, 134, '2015-01-01 00:21:37.000000', 'consum', 0.0217, 'lps'),
	(632793, 134, '2015-01-01 00:21:38.000000', 'consum', 0.0225, 'lps'),
	(632794, 134, '2015-01-01 00:21:39.000000', 'consum', 0.0216, 'lps'),
	(632795, 134, '2015-01-01 00:21:40.000000', 'consum', 0.0244, 'lps'),
	(632796, 134, '2015-01-01 00:21:41.000000', 'consum', 0.0225, 'lps'),
	(632797, 134, '2015-01-01 00:21:42.000000', 'consum', 0.0229, 'lps'),
	(632798, 134, '2015-01-01 00:21:43.000000', 'consum', 0.0214, 'lps'),
	(632799, 134, '2015-01-01 00:21:44.000000', 'consum', 0.0221, 'lps'),
	(632800, 134, '2015-01-01 00:21:45.000000', 'consum', 0.0251, 'lps'),
	(632801, 134, '2015-01-01 00:21:46.000000', 'consum', 0.0249, 'lps'),
	(632802, 134, '2015-01-01 00:21:47.000000', 'consum', 0.0237, 'lps'),
	(632803, 134, '2015-01-01 00:21:48.000000', 'consum', 0.0230, 'lps'),
	(632804, 134, '2015-01-01 00:21:49.000000', 'consum', 0.0231, 'lps'),
	(632805, 134, '2015-01-01 00:21:50.000000', 'consum', 0.0252, 'lps'),
	(632806, 134, '2015-01-01 00:21:51.000000', 'consum', 0.0223, 'lps'),
	(632807, 134, '2015-01-01 00:21:52.000000', 'consum', 0.0238, 'lps'),
	(632808, 134, '2015-01-01 00:21:53.000000', 'consum', 0.0224, 'lps'),
	(632809, 134, '2015-01-01 00:21:54.000000', 'consum', 0.0240, 'lps'),
	(632810, 134, '2015-01-01 00:21:55.000000', 'consum', 0.0229, 'lps'),
	(632811, 134, '2015-01-01 00:21:56.000000', 'consum', 0.0214, 'lps'),
	(632812, 134, '2015-01-01 00:21:57.000000', 'consum', 0.0221, 'lps'),
	(632813, 134, '2015-01-01 00:21:58.000000', 'consum', 0.0251, 'lps'),
	(632814, 134, '2015-01-01 00:21:59.000000', 'consum', 0.0247, 'lps'),
	(632815, 134, '2015-01-01 00:22:00.000000', 'consum', 0.0229, 'lps'),
	(632816, 134, '2015-01-01 00:22:01.000000', 'consum', 0.0238, 'lps'),
	(632817, 134, '2015-01-01 00:22:02.000000', 'consum', 0.0250, 'lps'),
	(632818, 134, '2015-01-01 00:22:03.000000', 'consum', 0.0235, 'lps'),
	(632819, 134, '2015-01-01 00:22:04.000000', 'consum', 0.0218, 'lps'),
	(632820, 134, '2015-01-01 00:22:05.000000', 'consum', 0.0217, 'lps'),
	(632821, 134, '2015-01-01 00:22:06.000000', 'consum', 0.0225, 'lps'),
	(632822, 134, '2015-01-01 00:22:07.000000', 'consum', 0.0216, 'lps'),
	(632823, 134, '2015-01-01 00:22:08.000000', 'consum', 0.0242, 'lps'),
	(632824, 134, '2015-01-01 00:22:09.000000', 'consum', 0.0219, 'lps'),
	(632825, 134, '2015-01-01 00:22:10.000000', 'consum', 0.0247, 'lps'),
	(632826, 134, '2015-01-01 00:22:11.000000', 'consum', 0.0233, 'lps'),
	(632827, 134, '2015-01-01 00:22:12.000000', 'consum', 0.0216, 'lps'),
	(632828, 134, '2015-01-01 00:22:13.000000', 'consum', 0.0215, 'lps'),
	(632829, 134, '2015-01-01 00:22:14.000000', 'consum', 0.0219, 'lps'),
	(632830, 134, '2015-01-01 00:22:15.000000', 'consum', 0.0240, 'lps'),
	(632831, 134, '2015-01-01 00:22:16.000000', 'consum', 0.0245, 'lps'),
	(632832, 134, '2015-01-01 00:22:17.000000', 'consum', 0.0249, 'lps'),
	(632833, 134, '2015-01-01 00:22:18.000000', 'consum', 0.0212, 'lps'),
	(632834, 134, '2015-01-01 00:22:19.000000', 'consum', 0.0237, 'lps'),
	(632835, 134, '2015-01-01 00:22:20.000000', 'consum', 0.0249, 'lps'),
	(632836, 134, '2015-01-01 00:22:21.000000', 'consum', 0.0236, 'lps'),
	(632837, 134, '2015-01-01 00:22:22.000000', 'consum', 0.0223, 'lps'),
	(632838, 134, '2015-01-01 00:22:23.000000', 'consum', 0.0241, 'lps'),
	(632839, 134, '2015-01-01 00:22:24.000000', 'consum', 0.0238, 'lps'),
	(632840, 134, '2015-01-01 00:22:25.000000', 'consum', 0.0212, 'lps'),
	(632841, 134, '2015-01-01 00:22:26.000000', 'consum', 0.0225, 'lps'),
	(632842, 134, '2015-01-01 00:22:27.000000', 'consum', 0.0236, 'lps'),
	(632843, 134, '2015-01-01 00:22:28.000000', 'consum', 0.0250, 'lps'),
	(632844, 134, '2015-01-01 00:22:29.000000', 'consum', 0.0243, 'lps'),
	(632845, 134, '2015-01-01 00:22:30.000000', 'consum', 0.0210, 'lps'),
	(632846, 134, '2015-01-01 00:22:31.000000', 'consum', 0.0246, 'lps'),
	(632847, 134, '2015-01-01 00:22:32.000000', 'consum', 0.0210, 'lps'),
	(632848, 134, '2015-01-01 00:22:33.000000', 'consum', 0.0238, 'lps'),
	(632849, 134, '2015-01-01 00:22:34.000000', 'consum', 0.0213, 'lps'),
	(632850, 134, '2015-01-01 00:22:35.000000', 'consum', 0.0235, 'lps'),
	(632851, 134, '2015-01-01 00:22:36.000000', 'consum', 0.0237, 'lps'),
	(632852, 134, '2015-01-01 00:22:37.000000', 'consum', 0.0224, 'lps'),
	(632853, 134, '2015-01-01 00:22:38.000000', 'consum', 0.0246, 'lps'),
	(632854, 134, '2015-01-01 00:22:39.000000', 'consum', 0.0211, 'lps'),
	(632855, 134, '2015-01-01 00:22:40.000000', 'consum', 0.0244, 'lps'),
	(632856, 134, '2015-01-01 00:22:41.000000', 'consum', 0.0243, 'lps'),
	(632857, 134, '2015-01-01 00:22:42.000000', 'consum', 0.0230, 'lps'),
	(632858, 134, '2015-01-01 00:22:43.000000', 'consum', 0.0253, 'lps'),
	(632859, 134, '2015-01-01 00:22:44.000000', 'consum', 0.0234, 'lps'),
	(632860, 134, '2015-01-01 00:22:45.000000', 'consum', 0.0244, 'lps'),
	(632861, 134, '2015-01-01 00:22:46.000000', 'consum', 0.0219, 'lps'),
	(632862, 134, '2015-01-01 00:22:47.000000', 'consum', 0.0244, 'lps'),
	(632863, 134, '2015-01-01 00:22:48.000000', 'consum', 0.0216, 'lps'),
	(632864, 134, '2015-01-01 00:22:49.000000', 'consum', 0.0232, 'lps'),
	(632865, 134, '2015-01-01 00:22:50.000000', 'consum', 0.0210, 'lps'),
	(632866, 134, '2015-01-01 00:22:51.000000', 'consum', 0.0237, 'lps'),
	(632867, 134, '2015-01-01 00:22:52.000000', 'consum', 0.0254, 'lps'),
	(632868, 134, '2015-01-01 00:22:53.000000', 'consum', 0.0216, 'lps'),
	(632869, 134, '2015-01-01 00:22:54.000000', 'consum', 0.0243, 'lps'),
	(632870, 134, '2015-01-01 00:22:55.000000', 'consum', 0.0224, 'lps'),
	(632871, 134, '2015-01-01 00:22:56.000000', 'consum', 0.0224, 'lps'),
	(632872, 134, '2015-01-01 00:22:57.000000', 'consum', 0.0241, 'lps'),
	(632873, 134, '2015-01-01 00:22:58.000000', 'consum', 0.0234, 'lps'),
	(632874, 134, '2015-01-01 00:22:59.000000', 'consum', 0.0236, 'lps'),
	(632875, 134, '2015-01-01 00:23:00.000000', 'consum', 0.0225, 'lps'),
	(632876, 134, '2015-01-01 00:23:01.000000', 'consum', 0.0253, 'lps'),
	(632877, 134, '2015-01-01 00:23:02.000000', 'consum', 0.0246, 'lps'),
	(632878, 134, '2015-01-01 00:23:03.000000', 'consum', 0.0216, 'lps'),
	(632879, 134, '2015-01-01 00:23:04.000000', 'consum', 0.0223, 'lps'),
	(632880, 134, '2015-01-01 00:23:05.000000', 'consum', 0.0213, 'lps'),
	(632881, 134, '2015-01-01 00:23:06.000000', 'consum', 0.0231, 'lps'),
	(632882, 134, '2015-01-01 00:23:07.000000', 'consum', 0.0214, 'lps'),
	(632883, 134, '2015-01-01 00:23:08.000000', 'consum', 0.0216, 'lps'),
	(632884, 134, '2015-01-01 00:23:09.000000', 'consum', 0.0228, 'lps'),
	(632885, 134, '2015-01-01 00:23:10.000000', 'consum', 0.0235, 'lps'),
	(632886, 134, '2015-01-01 00:23:11.000000', 'consum', 0.0238, 'lps'),
	(632887, 134, '2015-01-01 00:23:12.000000', 'consum', 0.0231, 'lps'),
	(632888, 134, '2015-01-01 00:23:13.000000', 'consum', 0.0233, 'lps'),
	(632889, 134, '2015-01-01 00:23:14.000000', 'consum', 0.0217, 'lps'),
	(632890, 134, '2015-01-01 00:23:15.000000', 'consum', 0.0219, 'lps'),
	(632891, 134, '2015-01-01 00:23:16.000000', 'consum', 0.0238, 'lps'),
	(632892, 134, '2015-01-01 00:23:17.000000', 'consum', 0.0232, 'lps'),
	(632893, 134, '2015-01-01 00:23:18.000000', 'consum', 0.0235, 'lps'),
	(632894, 134, '2015-01-01 00:23:19.000000', 'consum', 0.0227, 'lps'),
	(632895, 134, '2015-01-01 00:23:20.000000', 'consum', 0.0218, 'lps'),
	(632896, 134, '2015-01-01 00:23:21.000000', 'consum', 0.0246, 'lps'),
	(632897, 134, '2015-01-01 00:23:22.000000', 'consum', 0.0232, 'lps'),
	(632898, 134, '2015-01-01 00:23:23.000000', 'consum', 0.0211, 'lps'),
	(632899, 134, '2015-01-01 00:23:24.000000', 'consum', 0.0242, 'lps'),
	(632900, 134, '2015-01-01 00:23:25.000000', 'consum', 0.0231, 'lps'),
	(632901, 134, '2015-01-01 00:23:26.000000', 'consum', 0.0219, 'lps'),
	(632902, 134, '2015-01-01 00:23:27.000000', 'consum', 0.0239, 'lps'),
	(632903, 134, '2015-01-01 00:23:28.000000', 'consum', 0.0237, 'lps'),
	(632904, 134, '2015-01-01 00:23:29.000000', 'consum', 0.0212, 'lps'),
	(632905, 134, '2015-01-01 00:23:30.000000', 'consum', 0.0232, 'lps'),
	(632906, 134, '2015-01-01 00:23:31.000000', 'consum', 0.0225, 'lps'),
	(632907, 134, '2015-01-01 00:23:32.000000', 'consum', 0.0217, 'lps'),
	(632908, 134, '2015-01-01 00:23:33.000000', 'consum', 0.0248, 'lps'),
	(632909, 134, '2015-01-01 00:23:34.000000', 'consum', 0.0245, 'lps'),
	(632910, 134, '2015-01-01 00:23:35.000000', 'consum', 0.0228, 'lps'),
	(632911, 134, '2015-01-01 00:23:36.000000', 'consum', 0.0237, 'lps'),
	(632912, 134, '2015-01-01 00:23:37.000000', 'consum', 0.0247, 'lps'),
	(632913, 134, '2015-01-01 00:23:38.000000', 'consum', 0.0226, 'lps'),
	(632914, 134, '2015-01-01 00:23:39.000000', 'consum', 0.0225, 'lps'),
	(632915, 134, '2015-01-01 00:23:40.000000', 'consum', 0.0238, 'lps'),
	(632916, 134, '2015-01-01 00:23:41.000000', 'consum', 0.0215, 'lps'),
	(632917, 134, '2015-01-01 00:23:42.000000', 'consum', 0.0239, 'lps'),
	(632918, 134, '2015-01-01 00:23:43.000000', 'consum', 0.0252, 'lps'),
	(632919, 134, '2015-01-01 00:23:44.000000', 'consum', 0.0246, 'lps'),
	(632920, 134, '2015-01-01 00:23:45.000000', 'consum', 0.0216, 'lps'),
	(632921, 134, '2015-01-01 00:23:46.000000', 'consum', 0.0224, 'lps'),
	(632922, 134, '2015-01-01 00:23:47.000000', 'consum', 0.0217, 'lps'),
	(632923, 134, '2015-01-01 00:23:48.000000', 'consum', 0.0249, 'lps'),
	(632924, 134, '2015-01-01 00:23:49.000000', 'consum', 0.0249, 'lps'),
	(632925, 134, '2015-01-01 00:23:50.000000', 'consum', 0.0244, 'lps'),
	(632926, 134, '2015-01-01 00:23:51.000000', 'consum', 0.0220, 'lps'),
	(632927, 134, '2015-01-01 00:23:52.000000', 'consum', 0.0245, 'lps'),
	(632928, 134, '2015-01-01 00:23:53.000000', 'consum', 0.0223, 'lps'),
	(632929, 134, '2015-01-01 00:23:54.000000', 'consum', 0.0216, 'lps'),
	(632930, 134, '2015-01-01 00:23:55.000000', 'consum', 0.0245, 'lps'),
	(632931, 134, '2015-01-01 00:23:56.000000', 'consum', 0.0233, 'lps'),
	(632932, 134, '2015-01-01 00:23:57.000000', 'consum', 0.0221, 'lps'),
	(632933, 134, '2015-01-01 00:23:58.000000', 'consum', 0.0240, 'lps'),
	(632934, 134, '2015-01-01 00:23:59.000000', 'consum', 0.0239, 'lps'),
	(632935, 134, '2015-01-01 00:24:00.000000', 'consum', 0.0221, 'lps'),
	(632936, 134, '2015-01-01 00:24:01.000000', 'consum', 0.0223, 'lps'),
	(632937, 134, '2015-01-01 00:24:02.000000', 'consum', 0.0241, 'lps'),
	(632938, 134, '2015-01-01 00:24:03.000000', 'consum', 0.0236, 'lps'),
	(632939, 134, '2015-01-01 00:24:04.000000', 'consum', 0.0249, 'lps'),
	(632940, 134, '2015-01-01 00:24:05.000000', 'consum', 0.0237, 'lps'),
	(632941, 134, '2015-01-01 00:24:06.000000', 'consum', 0.0227, 'lps'),
	(632942, 134, '2015-01-01 00:24:07.000000', 'consum', 0.0215, 'lps'),
	(632943, 134, '2015-01-01 00:24:08.000000', 'consum', 0.0229, 'lps'),
	(632944, 134, '2015-01-01 00:24:09.000000', 'consum', 0.0245, 'lps'),
	(632945, 134, '2015-01-01 00:24:10.000000', 'consum', 0.0238, 'lps'),
	(632946, 134, '2015-01-01 00:24:11.000000', 'consum', 0.0248, 'lps'),
	(632947, 134, '2015-01-01 00:24:12.000000', 'consum', 0.0227, 'lps'),
	(632948, 134, '2015-01-01 00:24:13.000000', 'consum', 0.0227, 'lps'),
	(632949, 134, '2015-01-01 00:24:14.000000', 'consum', 0.0245, 'lps'),
	(632950, 134, '2015-01-01 00:24:15.000000', 'consum', 0.0242, 'lps'),
	(632951, 134, '2015-01-01 00:24:16.000000', 'consum', 0.0222, 'lps'),
	(632952, 134, '2015-01-01 00:24:17.000000', 'consum', 0.0221, 'lps'),
	(632953, 134, '2015-01-01 00:24:18.000000', 'consum', 0.0228, 'lps'),
	(632954, 134, '2015-01-01 00:24:19.000000', 'consum', 0.0224, 'lps'),
	(632955, 134, '2015-01-01 00:24:20.000000', 'consum', 0.0226, 'lps'),
	(632956, 134, '2015-01-01 00:24:21.000000', 'consum', 0.0250, 'lps'),
	(632957, 134, '2015-01-01 00:24:22.000000', 'consum', 0.0227, 'lps'),
	(632958, 134, '2015-01-01 00:24:23.000000', 'consum', 0.0219, 'lps'),
	(632959, 134, '2015-01-01 00:24:24.000000', 'consum', 0.0250, 'lps'),
	(632960, 134, '2015-01-01 00:24:25.000000', 'consum', 0.0248, 'lps'),
	(632961, 134, '2015-01-01 00:24:26.000000', 'consum', 0.0236, 'lps'),
	(632962, 134, '2015-01-01 00:24:27.000000', 'consum', 0.0225, 'lps'),
	(632963, 134, '2015-01-01 00:24:28.000000', 'consum', 0.0253, 'lps'),
	(632964, 134, '2015-01-01 00:24:29.000000', 'consum', 0.0247, 'lps'),
	(632965, 134, '2015-01-01 00:24:30.000000', 'consum', 0.0219, 'lps'),
	(632966, 134, '2015-01-01 00:24:31.000000', 'consum', 0.0238, 'lps'),
	(632967, 134, '2015-01-01 00:24:32.000000', 'consum', 0.0231, 'lps'),
	(632968, 134, '2015-01-01 00:24:33.000000', 'consum', 0.0231, 'lps'),
	(632969, 134, '2015-01-01 00:24:34.000000', 'consum', 0.0252, 'lps'),
	(632970, 134, '2015-01-01 00:24:35.000000', 'consum', 0.0226, 'lps'),
	(632971, 134, '2015-01-01 00:24:36.000000', 'consum', 0.0251, 'lps'),
	(632972, 134, '2015-01-01 00:24:37.000000', 'consum', 0.0232, 'lps'),
	(632973, 134, '2015-01-01 00:24:38.000000', 'consum', 0.0245, 'lps'),
	(632974, 134, '2015-01-01 00:24:39.000000', 'consum', 0.0229, 'lps'),
	(632975, 134, '2015-01-01 00:24:40.000000', 'consum', 0.0244, 'lps'),
	(632976, 134, '2015-01-01 00:24:41.000000', 'consum', 0.0234, 'lps'),
	(632977, 134, '2015-01-01 00:24:42.000000', 'consum', 0.0228, 'lps'),
	(632978, 134, '2015-01-01 00:24:43.000000', 'consum', 0.0231, 'lps'),
	(632979, 134, '2015-01-01 00:24:44.000000', 'consum', 0.0215, 'lps'),
	(632980, 134, '2015-01-01 00:24:45.000000', 'consum', 0.0219, 'lps'),
	(632981, 134, '2015-01-01 00:24:46.000000', 'consum', 0.0238, 'lps'),
	(632982, 134, '2015-01-01 00:24:47.000000', 'consum', 0.0233, 'lps'),
	(632983, 134, '2015-01-01 00:24:48.000000', 'consum', 0.0240, 'lps'),
	(632984, 134, '2015-01-01 00:24:49.000000', 'consum', 0.0250, 'lps'),
	(632985, 134, '2015-01-01 00:24:50.000000', 'consum', 0.0231, 'lps'),
	(632986, 134, '2015-01-01 00:24:51.000000', 'consum', 0.0238, 'lps'),
	(632987, 134, '2015-01-01 00:24:52.000000', 'consum', 0.0243, 'lps'),
	(632988, 134, '2015-01-01 00:24:53.000000', 'consum', 0.0247, 'lps'),
	(632989, 134, '2015-01-01 00:24:54.000000', 'consum', 0.0252, 'lps'),
	(632990, 134, '2015-01-01 00:24:55.000000', 'consum', 0.0221, 'lps'),
	(632991, 134, '2015-01-01 00:24:56.000000', 'consum', 0.0227, 'lps'),
	(632992, 134, '2015-01-01 00:24:57.000000', 'consum', 0.0220, 'lps'),
	(632993, 134, '2015-01-01 00:24:58.000000', 'consum', 0.0254, 'lps'),
	(632994, 134, '2015-01-01 00:24:59.000000', 'consum', 0.0220, 'lps'),
	(632995, 134, '2015-01-01 00:25:00.000000', 'consum', 0.0219, 'lps'),
	(632996, 134, '2015-01-01 00:25:01.000000', 'consum', 0.0225, 'lps'),
	(632997, 134, '2015-01-01 00:25:02.000000', 'consum', 0.0212, 'lps'),
	(632998, 134, '2015-01-01 00:25:03.000000', 'consum', 0.0221, 'lps'),
	(632999, 134, '2015-01-01 00:25:04.000000', 'consum', 0.0213, 'lps'),
	(633000, 134, '2015-01-01 00:25:05.000000', 'consum', 0.0238, 'lps'),
	(633001, 134, '2015-01-01 00:25:06.000000', 'consum', 0.0253, 'lps'),
	(633002, 134, '2015-01-01 00:25:07.000000', 'consum', 0.0251, 'lps'),
	(633003, 134, '2015-01-01 00:25:08.000000', 'consum', 0.0240, 'lps'),
	(633004, 134, '2015-01-01 00:25:09.000000', 'consum', 0.0238, 'lps'),
	(633005, 134, '2015-01-01 00:25:10.000000', 'consum', 0.0214, 'lps'),
	(633006, 134, '2015-01-01 00:25:11.000000', 'consum', 0.0237, 'lps'),
	(633007, 134, '2015-01-01 00:25:12.000000', 'consum', 0.0244, 'lps'),
	(633008, 134, '2015-01-01 00:25:13.000000', 'consum', 0.0211, 'lps'),
	(633009, 134, '2015-01-01 00:25:14.000000', 'consum', 0.0249, 'lps'),
	(633010, 134, '2015-01-01 00:25:15.000000', 'consum', 0.0221, 'lps'),
	(633011, 134, '2015-01-01 00:25:16.000000', 'consum', 0.0241, 'lps'),
	(633012, 134, '2015-01-01 00:25:17.000000', 'consum', 0.0240, 'lps'),
	(633013, 134, '2015-01-01 00:25:18.000000', 'consum', 0.0222, 'lps'),
	(633014, 134, '2015-01-01 00:25:19.000000', 'consum', 0.0226, 'lps'),
	(633015, 134, '2015-01-01 00:25:20.000000', 'consum', 0.0212, 'lps'),
	(633016, 134, '2015-01-01 00:25:21.000000', 'consum', 0.0215, 'lps'),
	(633017, 134, '2015-01-01 00:25:22.000000', 'consum', 0.0231, 'lps'),
	(633018, 134, '2015-01-01 00:25:23.000000', 'consum', 0.0211, 'lps'),
	(633019, 134, '2015-01-01 00:25:24.000000', 'consum', 0.0244, 'lps'),
	(633020, 134, '2015-01-01 00:25:25.000000', 'consum', 0.0239, 'lps'),
	(633021, 134, '2015-01-01 00:25:26.000000', 'consum', 0.0210, 'lps'),
	(633022, 134, '2015-01-01 00:25:27.000000', 'consum', 0.0215, 'lps'),
	(633023, 134, '2015-01-01 00:25:28.000000', 'consum', 0.0235, 'lps'),
	(633024, 134, '2015-01-01 00:25:29.000000', 'consum', 0.0230, 'lps'),
	(633025, 134, '2015-01-01 00:25:30.000000', 'consum', 0.0235, 'lps'),
	(633026, 134, '2015-01-01 00:25:31.000000', 'consum', 0.0231, 'lps'),
	(633027, 134, '2015-01-01 00:25:32.000000', 'consum', 0.0239, 'lps'),
	(633028, 134, '2015-01-01 00:25:33.000000', 'consum', 0.0247, 'lps'),
	(633029, 134, '2015-01-01 00:25:34.000000', 'consum', 0.0220, 'lps'),
	(633030, 134, '2015-01-01 00:25:35.000000', 'consum', 0.0238, 'lps'),
	(633031, 134, '2015-01-01 00:25:36.000000', 'consum', 0.0233, 'lps'),
	(633032, 134, '2015-01-01 00:25:37.000000', 'consum', 0.0240, 'lps'),
	(633033, 134, '2015-01-01 00:25:38.000000', 'consum', 0.0247, 'lps'),
	(633034, 134, '2015-01-01 00:25:39.000000', 'consum', 0.0216, 'lps'),
	(633035, 134, '2015-01-01 00:25:40.000000', 'consum', 0.0219, 'lps'),
	(633036, 134, '2015-01-01 00:25:41.000000', 'consum', 0.0239, 'lps'),
	(633037, 134, '2015-01-01 00:25:42.000000', 'consum', 0.0236, 'lps'),
	(633038, 134, '2015-01-01 00:25:43.000000', 'consum', 0.0254, 'lps'),
	(633039, 134, '2015-01-01 00:25:44.000000', 'consum', 0.0219, 'lps'),
	(633040, 134, '2015-01-01 00:25:45.000000', 'consum', 0.0212, 'lps'),
	(633041, 134, '2015-01-01 00:25:46.000000', 'consum', 0.0240, 'lps'),
	(633042, 134, '2015-01-01 00:25:47.000000', 'consum', 0.0221, 'lps'),
	(633043, 134, '2015-01-01 00:25:48.000000', 'consum', 0.0218, 'lps'),
	(633044, 134, '2015-01-01 00:25:49.000000', 'consum', 0.0217, 'lps'),
	(633045, 134, '2015-01-01 00:25:50.000000', 'consum', 0.0221, 'lps'),
	(633046, 134, '2015-01-01 00:25:51.000000', 'consum', 0.0246, 'lps'),
	(633047, 134, '2015-01-01 00:25:52.000000', 'consum', 0.0223, 'lps'),
	(633048, 134, '2015-01-01 00:25:53.000000', 'consum', 0.0213, 'lps'),
	(633049, 134, '2015-01-01 00:25:54.000000', 'consum', 0.0229, 'lps'),
	(633050, 134, '2015-01-01 00:25:55.000000', 'consum', 0.0254, 'lps'),
	(633051, 134, '2015-01-01 00:25:56.000000', 'consum', 0.0237, 'lps'),
	(633052, 134, '2015-01-01 00:25:57.000000', 'consum', 0.0214, 'lps'),
	(633053, 134, '2015-01-01 00:25:58.000000', 'consum', 0.0240, 'lps'),
	(633054, 134, '2015-01-01 00:25:59.000000', 'consum', 0.0211, 'lps'),
	(633055, 134, '2015-01-01 00:26:00.000000', 'consum', 0.0219, 'lps'),
	(633056, 134, '2015-01-01 00:26:01.000000', 'consum', 0.0251, 'lps'),
	(633057, 134, '2015-01-01 00:26:02.000000', 'consum', 0.0210, 'lps'),
	(633058, 134, '2015-01-01 00:26:03.000000', 'consum', 0.0221, 'lps'),
	(633059, 134, '2015-01-01 00:26:04.000000', 'consum', 0.0221, 'lps'),
	(633060, 134, '2015-01-01 00:26:05.000000', 'consum', 0.0234, 'lps'),
	(633061, 134, '2015-01-01 00:26:06.000000', 'consum', 0.0250, 'lps'),
	(633062, 134, '2015-01-01 00:26:07.000000', 'consum', 0.0251, 'lps'),
	(633063, 134, '2015-01-01 00:26:08.000000', 'consum', 0.0251, 'lps'),
	(633064, 134, '2015-01-01 00:26:09.000000', 'consum', 0.0249, 'lps'),
	(633065, 134, '2015-01-01 00:26:10.000000', 'consum', 0.0234, 'lps'),
	(633066, 134, '2015-01-01 00:26:11.000000', 'consum', 0.0213, 'lps'),
	(633067, 134, '2015-01-01 00:26:12.000000', 'consum', 0.0247, 'lps'),
	(633068, 134, '2015-01-01 00:26:13.000000', 'consum', 0.0248, 'lps'),
	(633069, 134, '2015-01-01 00:26:14.000000', 'consum', 0.0248, 'lps'),
	(633070, 134, '2015-01-01 00:26:15.000000', 'consum', 0.0238, 'lps'),
	(633071, 134, '2015-01-01 00:26:16.000000', 'consum', 0.0239, 'lps'),
	(633072, 134, '2015-01-01 00:26:17.000000', 'consum', 0.0227, 'lps'),
	(633073, 134, '2015-01-01 00:26:18.000000', 'consum', 0.0254, 'lps'),
	(633074, 134, '2015-01-01 00:26:19.000000', 'consum', 0.0243, 'lps'),
	(633075, 134, '2015-01-01 00:26:20.000000', 'consum', 0.0245, 'lps'),
	(633076, 134, '2015-01-01 00:26:21.000000', 'consum', 0.0243, 'lps'),
	(633077, 134, '2015-01-01 00:26:22.000000', 'consum', 0.0222, 'lps'),
	(633078, 134, '2015-01-01 00:26:23.000000', 'consum', 0.0219, 'lps'),
	(633079, 134, '2015-01-01 00:26:24.000000', 'consum', 0.0221, 'lps'),
	(633080, 134, '2015-01-01 00:26:25.000000', 'consum', 0.0236, 'lps'),
	(633081, 134, '2015-01-01 00:26:26.000000', 'consum', 0.0218, 'lps'),
	(633082, 134, '2015-01-01 00:26:27.000000', 'consum', 0.0218, 'lps'),
	(633083, 134, '2015-01-01 00:26:28.000000', 'consum', 0.0224, 'lps'),
	(633084, 134, '2015-01-01 00:26:29.000000', 'consum', 0.0215, 'lps'),
	(633085, 134, '2015-01-01 00:26:30.000000', 'consum', 0.0237, 'lps'),
	(633086, 134, '2015-01-01 00:26:31.000000', 'consum', 0.0240, 'lps'),
	(633087, 134, '2015-01-01 00:26:32.000000', 'consum', 0.0234, 'lps'),
	(633088, 134, '2015-01-01 00:26:33.000000', 'consum', 0.0241, 'lps'),
	(633089, 134, '2015-01-01 00:26:34.000000', 'consum', 0.0246, 'lps'),
	(633090, 134, '2015-01-01 00:26:35.000000', 'consum', 0.0211, 'lps'),
	(633091, 134, '2015-01-01 00:26:36.000000', 'consum', 0.0243, 'lps'),
	(633092, 134, '2015-01-01 00:26:37.000000', 'consum', 0.0237, 'lps'),
	(633093, 134, '2015-01-01 00:26:38.000000', 'consum', 0.0247, 'lps'),
	(633094, 134, '2015-01-01 00:26:39.000000', 'consum', 0.0224, 'lps'),
	(633095, 134, '2015-01-01 00:26:40.000000', 'consum', 0.0214, 'lps'),
	(633096, 134, '2015-01-01 00:26:41.000000', 'consum', 0.0235, 'lps'),
	(633097, 134, '2015-01-01 00:26:42.000000', 'consum', 0.0234, 'lps'),
	(633098, 134, '2015-01-01 00:26:43.000000', 'consum', 0.0253, 'lps'),
	(633099, 134, '2015-01-01 00:26:44.000000', 'consum', 0.0221, 'lps'),
	(633100, 134, '2015-01-01 00:26:45.000000', 'consum', 0.0225, 'lps'),
	(633101, 134, '2015-01-01 00:26:46.000000', 'consum', 0.0252, 'lps'),
	(633102, 134, '2015-01-01 00:26:47.000000', 'consum', 0.0242, 'lps'),
	(633103, 134, '2015-01-01 00:26:48.000000', 'consum', 0.0244, 'lps'),
	(633104, 134, '2015-01-01 00:26:49.000000', 'consum', 0.0239, 'lps'),
	(633105, 134, '2015-01-01 00:26:50.000000', 'consum', 0.0252, 'lps'),
	(633106, 134, '2015-01-01 00:26:51.000000', 'consum', 0.0245, 'lps'),
	(633107, 134, '2015-01-01 00:26:52.000000', 'consum', 0.0213, 'lps'),
	(633108, 134, '2015-01-01 00:26:53.000000', 'consum', 0.0212, 'lps'),
	(633109, 134, '2015-01-01 00:26:54.000000', 'consum', 0.0254, 'lps'),
	(633110, 134, '2015-01-01 00:26:55.000000', 'consum', 0.0247, 'lps'),
	(633111, 134, '2015-01-01 00:26:56.000000', 'consum', 0.0220, 'lps'),
	(633112, 134, '2015-01-01 00:26:57.000000', 'consum', 0.0237, 'lps'),
	(633113, 134, '2015-01-01 00:26:58.000000', 'consum', 0.0225, 'lps'),
	(633114, 134, '2015-01-01 00:26:59.000000', 'consum', 0.0250, 'lps'),
	(633115, 134, '2015-01-01 00:27:00.000000', 'consum', 0.0232, 'lps'),
	(633116, 134, '2015-01-01 00:27:01.000000', 'consum', 0.0246, 'lps'),
	(633117, 134, '2015-01-01 00:27:02.000000', 'consum', 0.0234, 'lps'),
	(633118, 134, '2015-01-01 00:27:03.000000', 'consum', 0.0224, 'lps'),
	(633119, 134, '2015-01-01 00:27:04.000000', 'consum', 0.0251, 'lps'),
	(633120, 134, '2015-01-01 00:27:05.000000', 'consum', 0.0240, 'lps'),
	(633121, 134, '2015-01-01 00:27:06.000000', 'consum', 0.0237, 'lps'),
	(633122, 134, '2015-01-01 00:27:07.000000', 'consum', 0.0213, 'lps'),
	(633123, 134, '2015-01-01 00:27:08.000000', 'consum', 0.0231, 'lps'),
	(633124, 134, '2015-01-01 00:27:09.000000', 'consum', 0.0219, 'lps'),
	(633125, 134, '2015-01-01 00:27:10.000000', 'consum', 0.0235, 'lps'),
	(633126, 134, '2015-01-01 00:27:11.000000', 'consum', 0.0219, 'lps'),
	(633127, 134, '2015-01-01 00:27:12.000000', 'consum', 0.0224, 'lps'),
	(633128, 134, '2015-01-01 00:27:13.000000', 'consum', 0.0210, 'lps'),
	(633129, 134, '2015-01-01 00:27:14.000000', 'consum', 0.0212, 'lps'),
	(633130, 134, '2015-01-01 00:27:15.000000', 'consum', 0.0223, 'lps'),
	(633131, 134, '2015-01-01 00:27:16.000000', 'consum', 0.0224, 'lps'),
	(633132, 134, '2015-01-01 00:27:17.000000', 'consum', 0.0242, 'lps'),
	(633133, 134, '2015-01-01 00:27:18.000000', 'consum', 0.0239, 'lps'),
	(633134, 134, '2015-01-01 00:27:19.000000', 'consum', 0.0212, 'lps'),
	(633135, 134, '2015-01-01 00:27:20.000000', 'consum', 0.0223, 'lps'),
	(633136, 134, '2015-01-01 00:27:21.000000', 'consum', 0.0225, 'lps'),
	(633137, 134, '2015-01-01 00:27:22.000000', 'consum', 0.0247, 'lps'),
	(633138, 134, '2015-01-01 00:27:23.000000', 'consum', 0.0217, 'lps'),
	(633139, 134, '2015-01-01 00:27:24.000000', 'consum', 0.0222, 'lps'),
	(633140, 134, '2015-01-01 00:27:25.000000', 'consum', 0.0250, 'lps'),
	(633141, 134, '2015-01-01 00:27:26.000000', 'consum', 0.0239, 'lps'),
	(633142, 134, '2015-01-01 00:27:27.000000', 'consum', 0.0238, 'lps'),
	(633143, 134, '2015-01-01 00:27:28.000000', 'consum', 0.0217, 'lps'),
	(633144, 134, '2015-01-01 00:27:29.000000', 'consum', 0.0251, 'lps'),
	(633145, 134, '2015-01-01 00:27:30.000000', 'consum', 0.0216, 'lps'),
	(633146, 134, '2015-01-01 00:27:31.000000', 'consum', 0.0254, 'lps'),
	(633147, 134, '2015-01-01 00:27:32.000000', 'consum', 0.0230, 'lps'),
	(633148, 134, '2015-01-01 00:27:33.000000', 'consum', 0.0223, 'lps'),
	(633149, 134, '2015-01-01 00:27:34.000000', 'consum', 0.0216, 'lps'),
	(633150, 134, '2015-01-01 00:27:35.000000', 'consum', 0.0248, 'lps'),
	(633151, 134, '2015-01-01 00:27:36.000000', 'consum', 0.0248, 'lps'),
	(633152, 134, '2015-01-01 00:27:37.000000', 'consum', 0.0240, 'lps'),
	(633153, 134, '2015-01-01 00:27:38.000000', 'consum', 0.0246, 'lps'),
	(633154, 134, '2015-01-01 00:27:39.000000', 'consum', 0.0212, 'lps'),
	(633155, 134, '2015-01-01 00:27:40.000000', 'consum', 0.0248, 'lps'),
	(633156, 134, '2015-01-01 00:27:41.000000', 'consum', 0.0214, 'lps'),
	(633157, 134, '2015-01-01 00:27:42.000000', 'consum', 0.0253, 'lps'),
	(633158, 134, '2015-01-01 00:27:43.000000', 'consum', 0.0230, 'lps'),
	(633159, 134, '2015-01-01 00:27:44.000000', 'consum', 0.0229, 'lps'),
	(633160, 134, '2015-01-01 00:27:45.000000', 'consum', 0.0245, 'lps'),
	(633161, 134, '2015-01-01 00:27:46.000000', 'consum', 0.0238, 'lps'),
	(633162, 134, '2015-01-01 00:27:47.000000', 'consum', 0.0247, 'lps'),
	(633163, 134, '2015-01-01 00:27:48.000000', 'consum', 0.0219, 'lps'),
	(633164, 134, '2015-01-01 00:27:49.000000', 'consum', 0.0236, 'lps'),
	(633165, 134, '2015-01-01 00:27:50.000000', 'consum', 0.0223, 'lps'),
	(633166, 134, '2015-01-01 00:27:51.000000', 'consum', 0.0243, 'lps'),
	(633167, 134, '2015-01-01 00:27:52.000000', 'consum', 0.0248, 'lps'),
	(633168, 134, '2015-01-01 00:27:53.000000', 'consum', 0.0254, 'lps'),
	(633169, 134, '2015-01-01 00:27:54.000000', 'consum', 0.0226, 'lps'),
	(633170, 134, '2015-01-01 00:27:55.000000', 'consum', 0.0251, 'lps'),
	(633171, 134, '2015-01-01 00:27:56.000000', 'consum', 0.0230, 'lps'),
	(633172, 134, '2015-01-01 00:27:57.000000', 'consum', 0.0233, 'lps'),
	(633173, 134, '2015-01-01 00:27:58.000000', 'consum', 0.0219, 'lps'),
	(633174, 134, '2015-01-01 00:27:59.000000', 'consum', 0.0234, 'lps'),
	(633175, 134, '2015-01-01 00:28:00.000000', 'consum', 0.0212, 'lps'),
	(633176, 134, '2015-01-01 00:28:01.000000', 'consum', 0.0237, 'lps'),
	(633177, 134, '2015-01-01 00:28:02.000000', 'consum', 0.0253, 'lps'),
	(633178, 134, '2015-01-01 00:28:03.000000', 'consum', 0.0253, 'lps'),
	(633179, 134, '2015-01-01 00:28:04.000000', 'consum', 0.0250, 'lps'),
	(633180, 134, '2015-01-01 00:28:05.000000', 'consum', 0.0238, 'lps'),
	(633181, 134, '2015-01-01 00:28:06.000000', 'consum', 0.0231, 'lps'),
	(633182, 134, '2015-01-01 00:28:07.000000', 'consum', 0.0231, 'lps'),
	(633183, 134, '2015-01-01 00:28:08.000000', 'consum', 0.0251, 'lps'),
	(633184, 134, '2015-01-01 00:28:09.000000', 'consum', 0.0217, 'lps'),
	(633185, 134, '2015-01-01 00:28:10.000000', 'consum', 0.0214, 'lps'),
	(633186, 134, '2015-01-01 00:28:11.000000', 'consum', 0.0252, 'lps'),
	(633187, 134, '2015-01-01 00:28:12.000000', 'consum', 0.0231, 'lps'),
	(633188, 134, '2015-01-01 00:28:13.000000', 'consum', 0.0233, 'lps'),
	(633189, 134, '2015-01-01 00:28:14.000000', 'consum', 0.0219, 'lps'),
	(633190, 134, '2015-01-01 00:28:15.000000', 'consum', 0.0229, 'lps'),
	(633191, 134, '2015-01-01 00:28:16.000000', 'consum', 0.0234, 'lps'),
	(633192, 134, '2015-01-01 00:28:17.000000', 'consum', 0.0228, 'lps'),
	(633193, 134, '2015-01-01 00:28:18.000000', 'consum', 0.0230, 'lps'),
	(633194, 134, '2015-01-01 00:28:19.000000', 'consum', 0.0254, 'lps'),
	(633195, 134, '2015-01-01 00:28:20.000000', 'consum', 0.0236, 'lps'),
	(633196, 134, '2015-01-01 00:28:21.000000', 'consum', 0.0210, 'lps'),
	(633197, 134, '2015-01-01 00:28:22.000000', 'consum', 0.0223, 'lps'),
	(633198, 134, '2015-01-01 00:28:23.000000', 'consum', 0.0232, 'lps'),
	(633199, 134, '2015-01-01 00:28:24.000000', 'consum', 0.0234, 'lps'),
	(633200, 134, '2015-01-01 00:28:25.000000', 'consum', 0.0221, 'lps'),
	(633201, 134, '2015-01-01 00:28:26.000000', 'consum', 0.0239, 'lps'),
	(633202, 134, '2015-01-01 00:28:27.000000', 'consum', 0.0231, 'lps'),
	(633203, 134, '2015-01-01 00:28:28.000000', 'consum', 0.0231, 'lps'),
	(633204, 134, '2015-01-01 00:28:29.000000', 'consum', 0.0250, 'lps'),
	(633205, 134, '2015-01-01 00:28:30.000000', 'consum', 0.0213, 'lps'),
	(633206, 134, '2015-01-01 00:28:31.000000', 'consum', 0.0239, 'lps'),
	(633207, 134, '2015-01-01 00:28:32.000000', 'consum', 0.0212, 'lps'),
	(633208, 134, '2015-01-01 00:28:33.000000', 'consum', 0.0225, 'lps'),
	(633209, 134, '2015-01-01 00:28:34.000000', 'consum', 0.0233, 'lps'),
	(633210, 134, '2015-01-01 00:28:35.000000', 'consum', 0.0237, 'lps'),
	(633211, 134, '2015-01-01 00:28:36.000000', 'consum', 0.0232, 'lps'),
	(633212, 134, '2015-01-01 00:28:37.000000', 'consum', 0.0240, 'lps'),
	(633213, 134, '2015-01-01 00:28:38.000000', 'consum', 0.0248, 'lps'),
	(633214, 134, '2015-01-01 00:28:39.000000', 'consum', 0.0222, 'lps'),
	(633215, 134, '2015-01-01 00:28:40.000000', 'consum', 0.0247, 'lps'),
	(633216, 134, '2015-01-01 00:28:41.000000', 'consum', 0.0224, 'lps'),
	(633217, 134, '2015-01-01 00:28:42.000000', 'consum', 0.0216, 'lps'),
	(633218, 134, '2015-01-01 00:28:43.000000', 'consum', 0.0243, 'lps'),
	(633219, 134, '2015-01-01 00:28:44.000000', 'consum', 0.0222, 'lps'),
	(633220, 134, '2015-01-01 00:28:45.000000', 'consum', 0.0216, 'lps'),
	(633221, 134, '2015-01-01 00:28:46.000000', 'consum', 0.0251, 'lps'),
	(633222, 134, '2015-01-01 00:28:47.000000', 'consum', 0.0217, 'lps'),
	(633223, 134, '2015-01-01 00:28:48.000000', 'consum', 0.0213, 'lps'),
	(633224, 134, '2015-01-01 00:28:49.000000', 'consum', 0.0251, 'lps'),
	(633225, 134, '2015-01-01 00:28:50.000000', 'consum', 0.0224, 'lps'),
	(633226, 134, '2015-01-01 00:28:51.000000', 'consum', 0.0249, 'lps'),
	(633227, 134, '2015-01-01 00:28:52.000000', 'consum', 0.0227, 'lps'),
	(633228, 134, '2015-01-01 00:28:53.000000', 'consum', 0.0223, 'lps'),
	(633229, 134, '2015-01-01 00:28:54.000000', 'consum', 0.0223, 'lps'),
	(633230, 134, '2015-01-01 00:28:55.000000', 'consum', 0.0239, 'lps'),
	(633231, 134, '2015-01-01 00:28:56.000000', 'consum', 0.0228, 'lps'),
	(633232, 134, '2015-01-01 00:28:57.000000', 'consum', 0.0210, 'lps'),
	(633233, 134, '2015-01-01 00:28:58.000000', 'consum', 0.0248, 'lps'),
	(633234, 134, '2015-01-01 00:28:59.000000', 'consum', 0.0218, 'lps'),
	(633235, 134, '2015-01-01 00:29:00.000000', 'consum', 0.0230, 'lps'),
	(633236, 134, '2015-01-01 00:29:01.000000', 'consum', 0.0242, 'lps'),
	(633237, 134, '2015-01-01 00:29:02.000000', 'consum', 0.0218, 'lps'),
	(633238, 134, '2015-01-01 00:29:03.000000', 'consum', 0.0246, 'lps'),
	(633239, 134, '2015-01-01 00:29:04.000000', 'consum', 0.0229, 'lps'),
	(633240, 134, '2015-01-01 00:29:05.000000', 'consum', 0.0246, 'lps'),
	(633241, 134, '2015-01-01 00:29:06.000000', 'consum', 0.0241, 'lps'),
	(633242, 134, '2015-01-01 00:29:07.000000', 'consum', 0.0211, 'lps'),
	(633243, 134, '2015-01-01 00:29:08.000000', 'consum', 0.0215, 'lps'),
	(633244, 134, '2015-01-01 00:29:09.000000', 'consum', 0.0231, 'lps'),
	(633245, 134, '2015-01-01 00:29:10.000000', 'consum', 0.0213, 'lps'),
	(633246, 134, '2015-01-01 00:29:11.000000', 'consum', 0.0251, 'lps'),
	(633247, 134, '2015-01-01 00:29:12.000000', 'consum', 0.0228, 'lps'),
	(633248, 134, '2015-01-01 00:29:13.000000', 'consum', 0.0220, 'lps'),
	(633249, 134, '2015-01-01 00:29:14.000000', 'consum', 0.0252, 'lps'),
	(633250, 134, '2015-01-01 00:29:15.000000', 'consum', 0.0254, 'lps'),
	(633251, 134, '2015-01-01 00:29:16.000000', 'consum', 0.0216, 'lps'),
	(633252, 134, '2015-01-01 00:29:17.000000', 'consum', 0.0241, 'lps'),
	(633253, 134, '2015-01-01 00:29:18.000000', 'consum', 0.0215, 'lps'),
	(633254, 134, '2015-01-01 00:29:19.000000', 'consum', 0.0233, 'lps'),
	(633255, 134, '2015-01-01 00:29:20.000000', 'consum', 0.0220, 'lps'),
	(633256, 134, '2015-01-01 00:29:21.000000', 'consum', 0.0238, 'lps'),
	(633257, 134, '2015-01-01 00:29:22.000000', 'consum', 0.0228, 'lps'),
	(633258, 134, '2015-01-01 00:29:23.000000', 'consum', 0.0219, 'lps'),
	(633259, 134, '2015-01-01 00:29:24.000000', 'consum', 0.0246, 'lps'),
	(633260, 134, '2015-01-01 00:29:25.000000', 'consum', 0.0230, 'lps'),
	(633261, 134, '2015-01-01 00:29:26.000000', 'consum', 0.0245, 'lps'),
	(633262, 134, '2015-01-01 00:29:27.000000', 'consum', 0.0236, 'lps'),
	(633263, 134, '2015-01-01 00:29:28.000000', 'consum', 0.0234, 'lps'),
	(633264, 134, '2015-01-01 00:29:29.000000', 'consum', 0.0253, 'lps'),
	(633265, 134, '2015-01-01 00:29:30.000000', 'consum', 0.0220, 'lps'),
	(633266, 134, '2015-01-01 00:29:31.000000', 'consum', 0.0223, 'lps'),
	(633267, 134, '2015-01-01 00:29:32.000000', 'consum', 0.0243, 'lps'),
	(633268, 134, '2015-01-01 00:29:33.000000', 'consum', 0.0246, 'lps'),
	(633269, 134, '2015-01-01 00:29:34.000000', 'consum', 0.0247, 'lps'),
	(633270, 134, '2015-01-01 00:29:35.000000', 'consum', 0.0241, 'lps'),
	(633271, 134, '2015-01-01 00:29:36.000000', 'consum', 0.0212, 'lps'),
	(633272, 134, '2015-01-01 00:29:37.000000', 'consum', 0.0216, 'lps'),
	(633273, 134, '2015-01-01 00:29:38.000000', 'consum', 0.0234, 'lps'),
	(633274, 134, '2015-01-01 00:29:39.000000', 'consum', 0.0225, 'lps'),
	(633275, 134, '2015-01-01 00:29:40.000000', 'consum', 0.0211, 'lps'),
	(633276, 134, '2015-01-01 00:29:41.000000', 'consum', 0.0216, 'lps'),
	(633277, 134, '2015-01-01 00:29:42.000000', 'consum', 0.0237, 'lps'),
	(633278, 134, '2015-01-01 00:29:43.000000', 'consum', 0.0237, 'lps'),
	(633279, 134, '2015-01-01 00:29:44.000000', 'consum', 0.0222, 'lps'),
	(633280, 134, '2015-01-01 00:29:45.000000', 'consum', 0.0232, 'lps'),
	(633281, 134, '2015-01-01 00:29:46.000000', 'consum', 0.0241, 'lps'),
	(633282, 134, '2015-01-01 00:29:47.000000', 'consum', 0.0254, 'lps'),
	(633283, 134, '2015-01-01 00:29:48.000000', 'consum', 0.0247, 'lps'),
	(633284, 134, '2015-01-01 00:29:49.000000', 'consum', 0.0217, 'lps'),
	(633285, 134, '2015-01-01 00:29:50.000000', 'consum', 0.0227, 'lps'),
	(633286, 134, '2015-01-01 00:29:51.000000', 'consum', 0.0227, 'lps'),
	(633287, 134, '2015-01-01 00:29:52.000000', 'consum', 0.0247, 'lps'),
	(633288, 134, '2015-01-01 00:29:53.000000', 'consum', 0.0254, 'lps'),
	(633289, 134, '2015-01-01 00:29:54.000000', 'consum', 0.0227, 'lps'),
	(633290, 134, '2015-01-01 00:29:55.000000', 'consum', 0.0210, 'lps'),
	(633291, 134, '2015-01-01 00:29:56.000000', 'consum', 0.0251, 'lps'),
	(633292, 134, '2015-01-01 00:29:57.000000', 'consum', 0.0236, 'lps'),
	(633293, 134, '2015-01-01 00:29:58.000000', 'consum', 0.0217, 'lps'),
	(633294, 134, '2015-01-01 00:29:59.000000', 'consum', 0.0212, 'lps'),
	(633295, 134, '2015-01-01 00:30:00.000000', 'consum', 0.0245, 'lps'),
	(633296, 134, '2015-01-01 00:30:01.000000', 'consum', 0.0246, 'lps'),
	(633297, 134, '2015-01-01 00:30:02.000000', 'consum', 0.0238, 'lps'),
	(633298, 134, '2015-01-01 00:30:03.000000', 'consum', 0.0245, 'lps'),
	(633299, 134, '2015-01-01 00:30:04.000000', 'consum', 0.0210, 'lps'),
	(633300, 134, '2015-01-01 00:30:05.000000', 'consum', 0.0241, 'lps'),
	(633301, 134, '2015-01-01 00:30:06.000000', 'consum', 0.0229, 'lps'),
	(633302, 134, '2015-01-01 00:30:07.000000', 'consum', 0.0213, 'lps'),
	(633303, 134, '2015-01-01 00:30:08.000000', 'consum', 0.0212, 'lps'),
	(633304, 134, '2015-01-01 00:30:09.000000', 'consum', 0.0214, 'lps'),
	(633305, 134, '2015-01-01 00:30:10.000000', 'consum', 0.0224, 'lps'),
	(633306, 134, '2015-01-01 00:30:11.000000', 'consum', 0.0222, 'lps'),
	(633307, 134, '2015-01-01 00:30:12.000000', 'consum', 0.0231, 'lps'),
	(633308, 134, '2015-01-01 00:30:13.000000', 'consum', 0.0233, 'lps'),
	(633309, 134, '2015-01-01 00:30:14.000000', 'consum', 0.0217, 'lps'),
	(633310, 134, '2015-01-01 00:30:15.000000', 'consum', 0.0224, 'lps'),
	(633311, 134, '2015-01-01 00:30:16.000000', 'consum', 0.0213, 'lps'),
	(633312, 134, '2015-01-01 00:30:17.000000', 'consum', 0.0227, 'lps'),
	(633313, 134, '2015-01-01 00:30:18.000000', 'consum', 0.0241, 'lps'),
	(633314, 134, '2015-01-01 00:30:19.000000', 'consum', 0.0224, 'lps'),
	(633315, 134, '2015-01-01 00:30:20.000000', 'consum', 0.0234, 'lps'),
	(633316, 134, '2015-01-01 00:30:21.000000', 'consum', 0.0245, 'lps'),
	(633317, 134, '2015-01-01 00:30:22.000000', 'consum', 0.0222, 'lps'),
	(633318, 134, '2015-01-01 00:30:23.000000', 'consum', 0.0212, 'lps'),
	(633319, 134, '2015-01-01 00:30:24.000000', 'consum', 0.0229, 'lps'),
	(633320, 134, '2015-01-01 00:30:25.000000', 'consum', 0.0254, 'lps'),
	(633321, 134, '2015-01-01 00:30:26.000000', 'consum', 0.0241, 'lps'),
	(633322, 134, '2015-01-01 00:30:27.000000', 'consum', 0.0231, 'lps'),
	(633323, 134, '2015-01-01 00:30:28.000000', 'consum', 0.0223, 'lps'),
	(633324, 134, '2015-01-01 00:30:29.000000', 'consum', 0.0211, 'lps'),
	(633325, 134, '2015-01-01 00:30:30.000000', 'consum', 0.0221, 'lps'),
	(633326, 134, '2015-01-01 00:30:31.000000', 'consum', 0.0219, 'lps'),
	(633327, 134, '2015-01-01 00:30:32.000000', 'consum', 0.0220, 'lps'),
	(633328, 134, '2015-01-01 00:30:33.000000', 'consum', 0.0236, 'lps'),
	(633329, 134, '2015-01-01 00:30:34.000000', 'consum', 0.0221, 'lps'),
	(633330, 134, '2015-01-01 00:30:35.000000', 'consum', 0.0230, 'lps'),
	(633331, 134, '2015-01-01 00:30:36.000000', 'consum', 0.0234, 'lps'),
	(633332, 134, '2015-01-01 00:30:37.000000', 'consum', 0.0227, 'lps'),
	(633333, 134, '2015-01-01 00:30:38.000000', 'consum', 0.0221, 'lps'),
	(633334, 134, '2015-01-01 00:30:39.000000', 'consum', 0.0215, 'lps'),
	(633335, 134, '2015-01-01 00:30:40.000000', 'consum', 0.0248, 'lps'),
	(633336, 134, '2015-01-01 00:30:41.000000', 'consum', 0.0252, 'lps'),
	(633337, 134, '2015-01-01 00:30:42.000000', 'consum', 0.0215, 'lps'),
	(633338, 134, '2015-01-01 00:30:43.000000', 'consum', 0.0246, 'lps'),
	(633339, 134, '2015-01-01 00:30:44.000000', 'consum', 0.0239, 'lps'),
	(633340, 134, '2015-01-01 00:30:45.000000', 'consum', 0.0249, 'lps'),
	(633341, 134, '2015-01-01 00:30:46.000000', 'consum', 0.0227, 'lps'),
	(633342, 134, '2015-01-01 00:30:47.000000', 'consum', 0.0226, 'lps'),
	(633343, 134, '2015-01-01 00:30:48.000000', 'consum', 0.0237, 'lps'),
	(633344, 134, '2015-01-01 00:30:49.000000', 'consum', 0.0254, 'lps'),
	(633345, 134, '2015-01-01 00:30:50.000000', 'consum', 0.0212, 'lps'),
	(633346, 134, '2015-01-01 00:30:51.000000', 'consum', 0.0224, 'lps'),
	(633347, 134, '2015-01-01 00:30:52.000000', 'consum', 0.0232, 'lps'),
	(633348, 134, '2015-01-01 00:30:53.000000', 'consum', 0.0233, 'lps'),
	(633349, 134, '2015-01-01 00:30:54.000000', 'consum', 0.0212, 'lps'),
	(633350, 134, '2015-01-01 00:30:55.000000', 'consum', 0.0243, 'lps'),
	(633351, 134, '2015-01-01 00:30:56.000000', 'consum', 0.0235, 'lps'),
	(633352, 134, '2015-01-01 00:30:57.000000', 'consum', 0.0236, 'lps'),
	(633353, 134, '2015-01-01 00:30:58.000000', 'consum', 0.0221, 'lps'),
	(633354, 134, '2015-01-01 00:30:59.000000', 'consum', 0.0230, 'lps'),
	(633355, 134, '2015-01-01 00:31:00.000000', 'consum', 0.0236, 'lps'),
	(633356, 134, '2015-01-01 00:31:01.000000', 'consum', 0.0233, 'lps'),
	(633357, 134, '2015-01-01 00:31:02.000000', 'consum', 0.0247, 'lps'),
	(633358, 134, '2015-01-01 00:31:03.000000', 'consum', 0.0239, 'lps'),
	(633359, 134, '2015-01-01 00:31:04.000000', 'consum', 0.0242, 'lps'),
	(633360, 134, '2015-01-01 00:31:05.000000', 'consum', 0.0239, 'lps'),
	(633361, 134, '2015-01-01 00:31:06.000000', 'consum', 0.0214, 'lps'),
	(633362, 134, '2015-01-01 00:31:07.000000', 'consum', 0.0236, 'lps'),
	(633363, 134, '2015-01-01 00:31:08.000000', 'consum', 0.0237, 'lps'),
	(633364, 134, '2015-01-01 00:31:09.000000', 'consum', 0.0222, 'lps'),
	(633365, 134, '2015-01-01 00:31:10.000000', 'consum', 0.0234, 'lps'),
	(633366, 134, '2015-01-01 00:31:11.000000', 'consum', 0.0251, 'lps'),
	(633367, 134, '2015-01-01 00:31:12.000000', 'consum', 0.0252, 'lps'),
	(633368, 134, '2015-01-01 00:31:13.000000', 'consum', 0.0252, 'lps'),
	(633369, 134, '2015-01-01 00:31:14.000000', 'consum', 0.0249, 'lps'),
	(633370, 134, '2015-01-01 00:31:15.000000', 'consum', 0.0237, 'lps'),
	(633371, 134, '2015-01-01 00:31:16.000000', 'consum', 0.0228, 'lps'),
	(633372, 134, '2015-01-01 00:31:17.000000', 'consum', 0.0219, 'lps'),
	(633373, 134, '2015-01-01 00:31:18.000000', 'consum', 0.0246, 'lps'),
	(633374, 134, '2015-01-01 00:31:19.000000', 'consum', 0.0229, 'lps'),
	(633375, 134, '2015-01-01 00:31:20.000000', 'consum', 0.0241, 'lps'),
	(633376, 134, '2015-01-01 00:31:21.000000', 'consum', 0.0220, 'lps'),
	(633377, 134, '2015-01-01 00:31:22.000000', 'consum', 0.0212, 'lps'),
	(633378, 134, '2015-01-01 00:31:23.000000', 'consum', 0.0235, 'lps'),
	(633379, 134, '2015-01-01 00:31:24.000000', 'consum', 0.0242, 'lps'),
	(633380, 134, '2015-01-01 00:31:25.000000', 'consum', 0.0248, 'lps'),
	(633381, 134, '2015-01-01 00:31:26.000000', 'consum', 0.0216, 'lps'),
	(633382, 134, '2015-01-01 00:31:27.000000', 'consum', 0.0216, 'lps'),
	(633383, 134, '2015-01-01 00:31:28.000000', 'consum', 0.0224, 'lps'),
	(633384, 134, '2015-01-01 00:31:29.000000', 'consum', 0.0217, 'lps'),
	(633385, 134, '2015-01-01 00:31:30.000000', 'consum', 0.0246, 'lps'),
	(633386, 134, '2015-01-01 00:31:31.000000', 'consum', 0.0237, 'lps'),
	(633387, 134, '2015-01-01 00:31:32.000000', 'consum', 0.0235, 'lps'),
	(633388, 134, '2015-01-01 00:31:33.000000', 'consum', 0.0212, 'lps'),
	(633389, 134, '2015-01-01 00:31:34.000000', 'consum', 0.0237, 'lps'),
	(633390, 134, '2015-01-01 00:31:35.000000', 'consum', 0.0246, 'lps'),
	(633391, 134, '2015-01-01 00:31:36.000000', 'consum', 0.0221, 'lps'),
	(633392, 134, '2015-01-01 00:31:37.000000', 'consum', 0.0246, 'lps'),
	(633393, 134, '2015-01-01 00:31:38.000000', 'consum', 0.0224, 'lps'),
	(633394, 134, '2015-01-01 00:31:39.000000', 'consum', 0.0218, 'lps'),
	(633395, 134, '2015-01-01 00:31:40.000000', 'consum', 0.0254, 'lps'),
	(633396, 134, '2015-01-01 00:31:41.000000', 'consum', 0.0225, 'lps'),
	(633397, 134, '2015-01-01 00:31:42.000000', 'consum', 0.0244, 'lps'),
	(633398, 134, '2015-01-01 00:31:43.000000', 'consum', 0.0245, 'lps'),
	(633399, 134, '2015-01-01 00:31:44.000000', 'consum', 0.0239, 'lps'),
	(633400, 134, '2015-01-01 00:31:45.000000', 'consum', 0.0250, 'lps'),
	(633401, 134, '2015-01-01 00:31:46.000000', 'consum', 0.0235, 'lps'),
	(633402, 134, '2015-01-01 00:31:47.000000', 'consum', 0.0217, 'lps'),
	(633403, 134, '2015-01-01 00:31:48.000000', 'consum', 0.0212, 'lps'),
	(633404, 134, '2015-01-01 00:31:49.000000', 'consum', 0.0247, 'lps'),
	(633405, 134, '2015-01-01 00:31:50.000000', 'consum', 0.0254, 'lps'),
	(633406, 134, '2015-01-01 00:31:51.000000', 'consum', 0.0228, 'lps'),
	(633407, 134, '2015-01-01 00:31:52.000000', 'consum', 0.0214, 'lps'),
	(633408, 134, '2015-01-01 00:31:53.000000', 'consum', 0.0222, 'lps'),
	(633409, 134, '2015-01-01 00:31:54.000000', 'consum', 0.0214, 'lps'),
	(633410, 134, '2015-01-01 00:31:55.000000', 'consum', 0.0240, 'lps'),
	(633411, 134, '2015-01-01 00:31:56.000000', 'consum', 0.0214, 'lps'),
	(633412, 134, '2015-01-01 00:31:57.000000', 'consum', 0.0228, 'lps'),
	(633413, 134, '2015-01-01 00:31:58.000000', 'consum', 0.0243, 'lps'),
	(633414, 134, '2015-01-01 00:31:59.000000', 'consum', 0.0234, 'lps'),
	(633415, 134, '2015-01-01 00:32:00.000000', 'consum', 0.0229, 'lps'),
	(633416, 134, '2015-01-01 00:32:01.000000', 'consum', 0.0236, 'lps'),
	(633417, 134, '2015-01-01 00:32:02.000000', 'consum', 0.0237, 'lps'),
	(633418, 134, '2015-01-01 00:32:03.000000', 'consum', 0.0221, 'lps'),
	(633419, 134, '2015-01-01 00:32:04.000000', 'consum', 0.0231, 'lps'),
	(633420, 134, '2015-01-01 00:32:05.000000', 'consum', 0.0238, 'lps'),
	(633421, 134, '2015-01-01 00:32:06.000000', 'consum', 0.0243, 'lps'),
	(633422, 134, '2015-01-01 00:32:07.000000', 'consum', 0.0247, 'lps'),
	(633423, 134, '2015-01-01 00:32:08.000000', 'consum', 0.0250, 'lps'),
	(633424, 134, '2015-01-01 00:32:09.000000', 'consum', 0.0210, 'lps'),
	(633425, 134, '2015-01-01 00:32:10.000000', 'consum', 0.0226, 'lps'),
	(633426, 134, '2015-01-01 00:32:11.000000', 'consum', 0.0244, 'lps'),
	(633427, 134, '2015-01-01 00:32:12.000000', 'consum', 0.0245, 'lps'),
	(633428, 134, '2015-01-01 00:32:13.000000', 'consum', 0.0239, 'lps'),
	(633429, 134, '2015-01-01 00:32:14.000000', 'consum', 0.0250, 'lps'),
	(633430, 134, '2015-01-01 00:32:15.000000', 'consum', 0.0231, 'lps'),
	(633431, 134, '2015-01-01 00:32:16.000000', 'consum', 0.0243, 'lps'),
	(633432, 134, '2015-01-01 00:32:17.000000', 'consum', 0.0223, 'lps'),
	(633433, 134, '2015-01-01 00:32:18.000000', 'consum', 0.0219, 'lps'),
	(633434, 134, '2015-01-01 00:32:19.000000', 'consum', 0.0216, 'lps'),
	(633435, 134, '2015-01-01 00:32:20.000000', 'consum', 0.0216, 'lps'),
	(633436, 134, '2015-01-01 00:32:21.000000', 'consum', 0.0221, 'lps'),
	(633437, 134, '2015-01-01 00:32:22.000000', 'consum', 0.0249, 'lps'),
	(633438, 134, '2015-01-01 00:32:23.000000', 'consum', 0.0238, 'lps'),
	(633439, 134, '2015-01-01 00:32:24.000000', 'consum', 0.0234, 'lps'),
	(633440, 134, '2015-01-01 00:32:25.000000', 'consum', 0.0246, 'lps'),
	(633441, 134, '2015-01-01 00:32:26.000000', 'consum', 0.0227, 'lps'),
	(633442, 134, '2015-01-01 00:32:27.000000', 'consum', 0.0233, 'lps'),
	(633443, 134, '2015-01-01 00:32:28.000000', 'consum', 0.0229, 'lps'),
	(633444, 134, '2015-01-01 00:32:29.000000', 'consum', 0.0237, 'lps'),
	(633445, 134, '2015-01-01 00:32:30.000000', 'consum', 0.0246, 'lps'),
	(633446, 134, '2015-01-01 00:32:31.000000', 'consum', 0.0216, 'lps'),
	(633447, 134, '2015-01-01 00:32:32.000000', 'consum', 0.0225, 'lps'),
	(633448, 134, '2015-01-01 00:32:33.000000', 'consum', 0.0220, 'lps'),
	(633449, 134, '2015-01-01 00:32:34.000000', 'consum', 0.0219, 'lps'),
	(633450, 134, '2015-01-01 00:32:35.000000', 'consum', 0.0222, 'lps'),
	(633451, 134, '2015-01-01 00:32:36.000000', 'consum', 0.0244, 'lps'),
	(633452, 134, '2015-01-01 00:32:37.000000', 'consum', 0.0211, 'lps'),
	(633453, 134, '2015-01-01 00:32:38.000000', 'consum', 0.0250, 'lps'),
	(633454, 134, '2015-01-01 00:32:39.000000', 'consum', 0.0225, 'lps'),
	(633455, 134, '2015-01-01 00:32:40.000000', 'consum', 0.0254, 'lps'),
	(633456, 134, '2015-01-01 00:32:41.000000', 'consum', 0.0253, 'lps'),
	(633457, 134, '2015-01-01 00:32:42.000000', 'consum', 0.0246, 'lps'),
	(633458, 134, '2015-01-01 00:32:43.000000', 'consum', 0.0219, 'lps'),
	(633459, 134, '2015-01-01 00:32:44.000000', 'consum', 0.0235, 'lps'),
	(633460, 134, '2015-01-01 00:32:45.000000', 'consum', 0.0220, 'lps'),
	(633461, 134, '2015-01-01 00:32:46.000000', 'consum', 0.0229, 'lps'),
	(633462, 134, '2015-01-01 00:32:47.000000', 'consum', 0.0232, 'lps'),
	(633463, 134, '2015-01-01 00:32:48.000000', 'consum', 0.0218, 'lps'),
	(633464, 134, '2015-01-01 00:32:49.000000', 'consum', 0.0229, 'lps'),
	(633465, 134, '2015-01-01 00:32:50.000000', 'consum', 0.0238, 'lps'),
	(633466, 134, '2015-01-01 00:32:51.000000', 'consum', 0.0248, 'lps'),
	(633467, 134, '2015-01-01 00:32:52.000000', 'consum', 0.0227, 'lps'),
	(633468, 134, '2015-01-01 00:32:53.000000', 'consum', 0.0227, 'lps'),
	(633469, 134, '2015-01-01 00:32:54.000000', 'consum', 0.0244, 'lps'),
	(633470, 134, '2015-01-01 00:32:55.000000', 'consum', 0.0238, 'lps'),
	(633471, 134, '2015-01-01 00:32:56.000000', 'consum', 0.0248, 'lps'),
	(633472, 134, '2015-01-01 00:32:57.000000', 'consum', 0.0228, 'lps'),
	(633473, 134, '2015-01-01 00:32:58.000000', 'consum', 0.0230, 'lps'),
	(633474, 134, '2015-01-01 00:32:59.000000', 'consum', 0.0214, 'lps'),
	(633475, 134, '2015-01-01 00:33:00.000000', 'consum', 0.0213, 'lps'),
	(633476, 134, '2015-01-01 00:33:01.000000', 'consum', 0.0215, 'lps'),
	(633477, 134, '2015-01-01 00:33:02.000000', 'consum', 0.0227, 'lps'),
	(633478, 134, '2015-01-01 00:33:03.000000', 'consum', 0.0235, 'lps'),
	(633479, 134, '2015-01-01 00:33:04.000000', 'consum', 0.0242, 'lps'),
	(633480, 134, '2015-01-01 00:33:05.000000', 'consum', 0.0247, 'lps'),
	(633481, 134, '2015-01-01 00:33:06.000000', 'consum', 0.0254, 'lps'),
	(633482, 134, '2015-01-01 00:33:07.000000', 'consum', 0.0230, 'lps'),
	(633483, 134, '2015-01-01 00:33:08.000000', 'consum', 0.0226, 'lps'),
	(633484, 134, '2015-01-01 00:33:09.000000', 'consum', 0.0229, 'lps'),
	(633485, 134, '2015-01-01 00:33:10.000000', 'consum', 0.0211, 'lps'),
	(633486, 134, '2015-01-01 00:33:11.000000', 'consum', 0.0248, 'lps'),
	(633487, 134, '2015-01-01 00:33:12.000000', 'consum', 0.0219, 'lps'),
	(633488, 134, '2015-01-01 00:33:13.000000', 'consum', 0.0230, 'lps'),
	(633489, 134, '2015-01-01 00:33:14.000000', 'consum', 0.0238, 'lps'),
	(633490, 134, '2015-01-01 00:33:15.000000', 'consum', 0.0247, 'lps'),
	(633491, 134, '2015-01-01 00:33:16.000000', 'consum', 0.0220, 'lps'),
	(633492, 134, '2015-01-01 00:33:17.000000', 'consum', 0.0239, 'lps'),
	(633493, 134, '2015-01-01 00:33:18.000000', 'consum', 0.0236, 'lps'),
	(633494, 134, '2015-01-01 00:33:19.000000', 'consum', 0.0252, 'lps'),
	(633495, 134, '2015-01-01 00:33:20.000000', 'consum', 0.0254, 'lps'),
	(633496, 134, '2015-01-01 00:33:21.000000', 'consum', 0.0212, 'lps'),
	(633497, 134, '2015-01-01 00:33:22.000000', 'consum', 0.0226, 'lps'),
	(633498, 134, '2015-01-01 00:33:23.000000', 'consum', 0.0240, 'lps'),
	(633499, 134, '2015-01-01 00:33:24.000000', 'consum', 0.0221, 'lps'),
	(633500, 134, '2015-01-01 00:33:25.000000', 'consum', 0.0222, 'lps'),
	(633501, 134, '2015-01-01 00:33:26.000000', 'consum', 0.0238, 'lps'),
	(633502, 134, '2015-01-01 00:33:27.000000', 'consum', 0.0222, 'lps'),
	(633503, 134, '2015-01-01 00:33:28.000000', 'consum', 0.0233, 'lps'),
	(633504, 134, '2015-01-01 00:33:29.000000', 'consum', 0.0244, 'lps'),
	(633505, 134, '2015-01-01 00:33:30.000000', 'consum', 0.0224, 'lps'),
	(633506, 134, '2015-01-01 00:33:31.000000', 'consum', 0.0221, 'lps'),
	(633507, 134, '2015-01-01 00:33:32.000000', 'consum', 0.0222, 'lps'),
	(633508, 134, '2015-01-01 00:33:33.000000', 'consum', 0.0240, 'lps'),
	(633509, 134, '2015-01-01 00:33:34.000000', 'consum', 0.0234, 'lps'),
	(633510, 134, '2015-01-01 00:33:35.000000', 'consum', 0.0242, 'lps'),
	(633511, 134, '2015-01-01 00:33:36.000000', 'consum', 0.0254, 'lps'),
	(633512, 134, '2015-01-01 00:33:37.000000', 'consum', 0.0241, 'lps'),
	(633513, 134, '2015-01-01 00:33:38.000000', 'consum', 0.0237, 'lps'),
	(633514, 134, '2015-01-01 00:33:39.000000', 'consum', 0.0251, 'lps'),
	(633515, 134, '2015-01-01 00:33:40.000000', 'consum', 0.0247, 'lps'),
	(633516, 134, '2015-01-01 00:33:41.000000', 'consum', 0.0224, 'lps'),
	(633517, 134, '2015-01-01 00:33:42.000000', 'consum', 0.0218, 'lps'),
	(633518, 134, '2015-01-01 00:33:43.000000', 'consum', 0.0250, 'lps'),
	(633519, 134, '2015-01-01 00:33:44.000000', 'consum', 0.0252, 'lps'),
	(633520, 134, '2015-01-01 00:33:45.000000', 'consum', 0.0213, 'lps'),
	(633521, 134, '2015-01-01 00:33:46.000000', 'consum', 0.0231, 'lps'),
	(633522, 134, '2015-01-01 00:33:47.000000', 'consum', 0.0219, 'lps'),
	(633523, 134, '2015-01-01 00:33:48.000000', 'consum', 0.0236, 'lps'),
	(633524, 134, '2015-01-01 00:33:49.000000', 'consum', 0.0226, 'lps'),
	(633525, 134, '2015-01-01 00:33:50.000000', 'consum', 0.0254, 'lps'),
	(633526, 134, '2015-01-01 00:33:51.000000', 'consum', 0.0251, 'lps'),
	(633527, 134, '2015-01-01 00:33:52.000000', 'consum', 0.0237, 'lps'),
	(633528, 134, '2015-01-01 00:33:53.000000', 'consum', 0.0224, 'lps'),
	(633529, 134, '2015-01-01 00:33:54.000000', 'consum', 0.0244, 'lps'),
	(633530, 134, '2015-01-01 00:33:55.000000', 'consum', 0.0248, 'lps'),
	(633531, 134, '2015-01-01 00:33:56.000000', 'consum', 0.0253, 'lps'),
	(633532, 134, '2015-01-01 00:33:57.000000', 'consum', 0.0222, 'lps'),
	(633533, 134, '2015-01-01 00:33:58.000000', 'consum', 0.0232, 'lps'),
	(633534, 134, '2015-01-01 00:33:59.000000', 'consum', 0.0241, 'lps'),
	(633535, 134, '2015-01-01 00:34:00.000000', 'consum', 0.0252, 'lps'),
	(633536, 134, '2015-01-01 00:34:01.000000', 'consum', 0.0240, 'lps'),
	(633537, 134, '2015-01-01 00:34:02.000000', 'consum', 0.0233, 'lps'),
	(633538, 134, '2015-01-01 00:34:03.000000', 'consum', 0.0237, 'lps'),
	(633539, 134, '2015-01-01 00:34:04.000000', 'consum', 0.0231, 'lps'),
	(633540, 134, '2015-01-01 00:34:05.000000', 'consum', 0.0235, 'lps'),
	(633541, 134, '2015-01-01 00:34:06.000000', 'consum', 0.0227, 'lps'),
	(633542, 134, '2015-01-01 00:34:07.000000', 'consum', 0.0219, 'lps'),
	(633543, 134, '2015-01-01 00:34:08.000000', 'consum', 0.0252, 'lps'),
	(633544, 134, '2015-01-01 00:34:09.000000', 'consum', 0.0214, 'lps'),
	(633545, 134, '2015-01-01 00:34:10.000000', 'consum', 0.0237, 'lps'),
	(633546, 134, '2015-01-01 00:34:11.000000', 'consum', 0.0246, 'lps'),
	(633547, 134, '2015-01-01 00:34:12.000000', 'consum', 0.0220, 'lps'),
	(633548, 134, '2015-01-01 00:34:13.000000', 'consum', 0.0240, 'lps'),
	(633549, 134, '2015-01-01 00:34:14.000000', 'consum', 0.0241, 'lps'),
	(633550, 134, '2015-01-01 00:34:15.000000', 'consum', 0.0229, 'lps'),
	(633551, 134, '2015-01-01 00:34:16.000000', 'consum', 0.0215, 'lps'),
	(633552, 134, '2015-01-01 00:34:17.000000', 'consum', 0.0224, 'lps'),
	(633553, 134, '2015-01-01 00:34:18.000000', 'consum', 0.0221, 'lps'),
	(633554, 134, '2015-01-01 00:34:19.000000', 'consum', 0.0222, 'lps'),
	(633555, 134, '2015-01-01 00:34:20.000000', 'consum', 0.0240, 'lps'),
	(633556, 134, '2015-01-01 00:34:21.000000', 'consum', 0.0231, 'lps'),
	(633557, 134, '2015-01-01 00:34:22.000000', 'consum', 0.0228, 'lps'),
	(633558, 134, '2015-01-01 00:34:23.000000', 'consum', 0.0238, 'lps'),
	(633559, 134, '2015-01-01 00:34:24.000000', 'consum', 0.0250, 'lps'),
	(633560, 134, '2015-01-01 00:34:25.000000', 'consum', 0.0239, 'lps'),
	(633561, 134, '2015-01-01 00:34:26.000000', 'consum', 0.0233, 'lps'),
	(633562, 134, '2015-01-01 00:34:27.000000', 'consum', 0.0240, 'lps'),
	(633563, 134, '2015-01-01 00:34:28.000000', 'consum', 0.0248, 'lps'),
	(633564, 134, '2015-01-01 00:34:29.000000', 'consum', 0.0219, 'lps'),
	(633565, 134, '2015-01-01 00:34:30.000000', 'consum', 0.0231, 'lps'),
	(633566, 134, '2015-01-01 00:34:31.000000', 'consum', 0.0245, 'lps'),
	(633567, 134, '2015-01-01 00:34:32.000000', 'consum', 0.0233, 'lps'),
	(633568, 134, '2015-01-01 00:34:33.000000', 'consum', 0.0221, 'lps'),
	(633569, 134, '2015-01-01 00:34:34.000000', 'consum', 0.0239, 'lps'),
	(633570, 134, '2015-01-01 00:34:35.000000', 'consum', 0.0234, 'lps'),
	(633571, 134, '2015-01-01 00:34:36.000000', 'consum', 0.0243, 'lps'),
	(633572, 134, '2015-01-01 00:34:37.000000', 'consum', 0.0215, 'lps'),
	(633573, 134, '2015-01-01 00:34:38.000000', 'consum', 0.0225, 'lps'),
	(633574, 134, '2015-01-01 00:34:39.000000', 'consum', 0.0228, 'lps'),
	(633575, 134, '2015-01-01 00:34:40.000000', 'consum', 0.0252, 'lps'),
	(633576, 134, '2015-01-01 00:34:41.000000', 'consum', 0.0234, 'lps'),
	(633577, 134, '2015-01-01 00:34:42.000000', 'consum', 0.0247, 'lps'),
	(633578, 134, '2015-01-01 00:34:43.000000', 'consum', 0.0237, 'lps'),
	(633579, 134, '2015-01-01 00:34:44.000000', 'consum', 0.0232, 'lps'),
	(633580, 134, '2015-01-01 00:34:45.000000', 'consum', 0.0239, 'lps'),
	(633581, 134, '2015-01-01 00:34:46.000000', 'consum', 0.0245, 'lps'),
	(633582, 134, '2015-01-01 00:34:47.000000', 'consum', 0.0253, 'lps'),
	(633583, 134, '2015-01-01 00:34:48.000000', 'consum', 0.0233, 'lps'),
	(633584, 134, '2015-01-01 00:34:49.000000', 'consum', 0.0241, 'lps'),
	(633585, 134, '2015-01-01 00:34:50.000000', 'consum', 0.0249, 'lps'),
	(633586, 134, '2015-01-01 00:34:51.000000', 'consum', 0.0224, 'lps'),
	(633587, 134, '2015-01-01 00:34:52.000000', 'consum', 0.0210, 'lps'),
	(633588, 134, '2015-01-01 00:34:53.000000', 'consum', 0.0211, 'lps'),
	(633589, 134, '2015-01-01 00:34:54.000000', 'consum', 0.0217, 'lps'),
	(633590, 134, '2015-01-01 00:34:55.000000', 'consum', 0.0243, 'lps'),
	(633591, 134, '2015-01-01 00:34:56.000000', 'consum', 0.0218, 'lps'),
	(633592, 134, '2015-01-01 00:34:57.000000', 'consum', 0.0242, 'lps'),
	(633593, 134, '2015-01-01 00:34:58.000000', 'consum', 0.0214, 'lps'),
	(633594, 134, '2015-01-01 00:34:59.000000', 'consum', 0.0221, 'lps'),
	(633595, 134, '2015-01-01 00:35:00.000000', 'consum', 0.0211, 'lps'),
	(633596, 134, '2015-01-01 00:35:01.000000', 'consum', 0.0227, 'lps'),
	(633597, 134, '2015-01-01 00:35:02.000000', 'consum', 0.0246, 'lps'),
	(633598, 134, '2015-01-01 00:35:03.000000', 'consum', 0.0250, 'lps'),
	(633599, 134, '2015-01-01 00:35:04.000000', 'consum', 0.0214, 'lps'),
	(633600, 134, '2015-01-01 00:35:05.000000', 'consum', 0.0246, 'lps'),
	(633601, 134, '2015-01-01 00:35:06.000000', 'consum', 0.0242, 'lps'),
	(633602, 134, '2015-01-01 00:35:07.000000', 'consum', 0.0219, 'lps'),
	(633603, 134, '2015-01-01 00:35:08.000000', 'consum', 0.0250, 'lps'),
	(633604, 134, '2015-01-01 00:35:09.000000', 'consum', 0.0248, 'lps'),
	(633605, 134, '2015-01-01 00:35:10.000000', 'consum', 0.0233, 'lps'),
	(633606, 134, '2015-01-01 00:35:11.000000', 'consum', 0.0214, 'lps'),
	(633607, 134, '2015-01-01 00:35:12.000000', 'consum', 0.0251, 'lps'),
	(633608, 134, '2015-01-01 00:35:13.000000', 'consum', 0.0223, 'lps'),
	(633609, 134, '2015-01-01 00:35:14.000000', 'consum', 0.0241, 'lps'),
	(633610, 134, '2015-01-01 00:35:15.000000', 'consum', 0.0237, 'lps'),
	(633611, 134, '2015-01-01 00:35:16.000000', 'consum', 0.0253, 'lps'),
	(633612, 134, '2015-01-01 00:35:17.000000', 'consum', 0.0210, 'lps'),
	(633613, 134, '2015-01-01 00:35:18.000000', 'consum', 0.0216, 'lps'),
	(633614, 134, '2015-01-01 00:35:19.000000', 'consum', 0.0239, 'lps'),
	(633615, 134, '2015-01-01 00:35:20.000000', 'consum', 0.0247, 'lps'),
	(633616, 134, '2015-01-01 00:35:21.000000', 'consum', 0.0220, 'lps'),
	(633617, 134, '2015-01-01 00:35:22.000000', 'consum', 0.0238, 'lps'),
	(633618, 134, '2015-01-01 00:35:23.000000', 'consum', 0.0233, 'lps'),
	(633619, 134, '2015-01-01 00:35:24.000000', 'consum', 0.0242, 'lps'),
	(633620, 134, '2015-01-01 00:35:25.000000', 'consum', 0.0211, 'lps'),
	(633621, 134, '2015-01-01 00:35:26.000000', 'consum', 0.0254, 'lps'),
	(633622, 134, '2015-01-01 00:35:27.000000', 'consum', 0.0247, 'lps'),
	(633623, 134, '2015-01-01 00:35:28.000000', 'consum', 0.0221, 'lps'),
	(633624, 134, '2015-01-01 00:35:29.000000', 'consum', 0.0241, 'lps'),
	(633625, 134, '2015-01-01 00:35:30.000000', 'consum', 0.0243, 'lps'),
	(633626, 134, '2015-01-01 00:35:31.000000', 'consum', 0.0240, 'lps'),
	(633627, 134, '2015-01-01 00:35:32.000000', 'consum', 0.0216, 'lps'),
	(633628, 134, '2015-01-01 00:35:33.000000', 'consum', 0.0241, 'lps'),
	(633629, 134, '2015-01-01 00:35:34.000000', 'consum', 0.0212, 'lps'),
	(633630, 134, '2015-01-01 00:35:35.000000', 'consum', 0.0219, 'lps'),
	(633631, 134, '2015-01-01 00:35:36.000000', 'consum', 0.0249, 'lps'),
	(633632, 134, '2015-01-01 00:35:37.000000', 'consum', 0.0242, 'lps'),
	(633633, 134, '2015-01-01 00:35:38.000000', 'consum', 0.0253, 'lps'),
	(633634, 134, '2015-01-01 00:35:39.000000', 'consum', 0.0239, 'lps'),
	(633635, 134, '2015-01-01 00:35:40.000000', 'consum', 0.0226, 'lps'),
	(633636, 134, '2015-01-01 00:35:41.000000', 'consum', 0.0250, 'lps'),
	(633637, 134, '2015-01-01 00:35:42.000000', 'consum', 0.0225, 'lps'),
	(633638, 134, '2015-01-01 00:35:43.000000', 'consum', 0.0212, 'lps'),
	(633639, 134, '2015-01-01 00:35:44.000000', 'consum', 0.0222, 'lps'),
	(633640, 134, '2015-01-01 00:35:45.000000', 'consum', 0.0217, 'lps'),
	(633641, 134, '2015-01-01 00:35:46.000000', 'consum', 0.0210, 'lps'),
	(633642, 134, '2015-01-01 00:35:47.000000', 'consum', 0.0236, 'lps'),
	(633643, 134, '2015-01-01 00:35:48.000000', 'consum', 0.0248, 'lps'),
	(633644, 134, '2015-01-01 00:35:49.000000', 'consum', 0.0236, 'lps'),
	(633645, 134, '2015-01-01 00:35:50.000000', 'consum', 0.0223, 'lps'),
	(633646, 134, '2015-01-01 00:35:51.000000', 'consum', 0.0245, 'lps'),
	(633647, 134, '2015-01-01 00:35:52.000000', 'consum', 0.0211, 'lps'),
	(633648, 134, '2015-01-01 00:35:53.000000', 'consum', 0.0246, 'lps'),
	(633649, 134, '2015-01-01 00:35:54.000000', 'consum', 0.0254, 'lps'),
	(633650, 134, '2015-01-01 00:35:55.000000', 'consum', 0.0231, 'lps'),
	(633651, 134, '2015-01-01 00:35:56.000000', 'consum', 0.0230, 'lps'),
	(633652, 134, '2015-01-01 00:35:57.000000', 'consum', 0.0247, 'lps'),
	(633653, 134, '2015-01-01 00:35:58.000000', 'consum', 0.0247, 'lps'),
	(633654, 134, '2015-01-01 00:35:59.000000', 'consum', 0.0238, 'lps'),
	(633655, 134, '2015-01-01 00:36:00.000000', 'consum', 0.0239, 'lps'),
	(633656, 134, '2015-01-01 00:36:01.000000', 'consum', 0.0226, 'lps'),
	(633657, 134, '2015-01-01 00:36:02.000000', 'consum', 0.0250, 'lps'),
	(633658, 134, '2015-01-01 00:36:03.000000', 'consum', 0.0226, 'lps'),
	(633659, 134, '2015-01-01 00:36:04.000000', 'consum', 0.0217, 'lps'),
	(633660, 134, '2015-01-01 00:36:05.000000', 'consum', 0.0243, 'lps'),
	(633661, 134, '2015-01-01 00:36:06.000000', 'consum', 0.0218, 'lps'),
	(633662, 134, '2015-01-01 00:36:07.000000', 'consum', 0.0241, 'lps'),
	(633663, 134, '2015-01-01 00:36:08.000000', 'consum', 0.0251, 'lps'),
	(633664, 134, '2015-01-01 00:36:09.000000', 'consum', 0.0235, 'lps'),
	(633665, 134, '2015-01-01 00:36:10.000000', 'consum', 0.0211, 'lps'),
	(633666, 134, '2015-01-01 00:36:11.000000', 'consum', 0.0232, 'lps'),
	(633667, 134, '2015-01-01 00:36:12.000000', 'consum', 0.0228, 'lps'),
	(633668, 134, '2015-01-01 00:36:13.000000', 'consum', 0.0234, 'lps'),
	(633669, 134, '2015-01-01 00:36:14.000000', 'consum', 0.0233, 'lps'),
	(633670, 134, '2015-01-01 00:36:15.000000', 'consum', 0.0253, 'lps'),
	(633671, 134, '2015-01-01 00:36:16.000000', 'consum', 0.0219, 'lps'),
	(633672, 134, '2015-01-01 00:36:17.000000', 'consum', 0.0217, 'lps'),
	(633673, 134, '2015-01-01 00:36:18.000000', 'consum', 0.0220, 'lps'),
	(633674, 134, '2015-01-01 00:36:19.000000', 'consum', 0.0241, 'lps'),
	(633675, 134, '2015-01-01 00:36:20.000000', 'consum', 0.0243, 'lps'),
	(633676, 134, '2015-01-01 00:36:21.000000', 'consum', 0.0238, 'lps'),
	(633677, 134, '2015-01-01 00:36:22.000000', 'consum', 0.0253, 'lps'),
	(633678, 134, '2015-01-01 00:36:23.000000', 'consum', 0.0250, 'lps'),
	(633679, 134, '2015-01-01 00:36:24.000000', 'consum', 0.0239, 'lps'),
	(633680, 134, '2015-01-01 00:36:25.000000', 'consum', 0.0234, 'lps'),
	(633681, 134, '2015-01-01 00:36:26.000000', 'consum', 0.0244, 'lps'),
	(633682, 134, '2015-01-01 00:36:27.000000', 'consum', 0.0217, 'lps'),
	(633683, 134, '2015-01-01 00:36:28.000000', 'consum', 0.0236, 'lps'),
	(633684, 134, '2015-01-01 00:36:29.000000', 'consum', 0.0228, 'lps'),
	(633685, 134, '2015-01-01 00:36:30.000000', 'consum', 0.0221, 'lps'),
	(633686, 134, '2015-01-01 00:36:31.000000', 'consum', 0.0214, 'lps'),
	(633687, 134, '2015-01-01 00:36:32.000000', 'consum', 0.0243, 'lps'),
	(633688, 134, '2015-01-01 00:36:33.000000', 'consum', 0.0229, 'lps'),
	(633689, 134, '2015-01-01 00:36:34.000000', 'consum', 0.0251, 'lps'),
	(633690, 134, '2015-01-01 00:36:35.000000', 'consum', 0.0221, 'lps'),
	(633691, 134, '2015-01-01 00:36:36.000000', 'consum', 0.0234, 'lps'),
	(633692, 134, '2015-01-01 00:36:37.000000', 'consum', 0.0254, 'lps'),
	(633693, 134, '2015-01-01 00:36:38.000000', 'consum', 0.0224, 'lps'),
	(633694, 134, '2015-01-01 00:36:39.000000', 'consum', 0.0236, 'lps'),
	(633695, 134, '2015-01-01 00:36:40.000000', 'consum', 0.0210, 'lps'),
	(633696, 134, '2015-01-01 00:36:41.000000', 'consum', 0.0221, 'lps'),
	(633697, 134, '2015-01-01 00:36:42.000000', 'consum', 0.0219, 'lps'),
	(633698, 134, '2015-01-01 00:36:43.000000', 'consum', 0.0225, 'lps'),
	(633699, 134, '2015-01-01 00:36:44.000000', 'consum', 0.0213, 'lps'),
	(633700, 134, '2015-01-01 00:36:45.000000', 'consum', 0.0224, 'lps'),
	(633701, 134, '2015-01-01 00:36:46.000000', 'consum', 0.0227, 'lps'),
	(633702, 134, '2015-01-01 00:36:47.000000', 'consum', 0.0210, 'lps'),
	(633703, 134, '2015-01-01 00:36:48.000000', 'consum', 0.0250, 'lps'),
	(633704, 134, '2015-01-01 00:36:49.000000', 'consum', 0.0228, 'lps'),
	(633705, 134, '2015-01-01 00:36:50.000000', 'consum', 0.0227, 'lps'),
	(633706, 134, '2015-01-01 00:36:51.000000', 'consum', 0.0241, 'lps'),
	(633707, 134, '2015-01-01 00:36:52.000000', 'consum', 0.0226, 'lps'),
	(633708, 134, '2015-01-01 00:36:53.000000', 'consum', 0.0242, 'lps'),
	(633709, 134, '2015-01-01 00:36:54.000000', 'consum', 0.0232, 'lps'),
	(633710, 134, '2015-01-01 00:36:55.000000', 'consum', 0.0226, 'lps'),
	(633711, 134, '2015-01-01 00:36:56.000000', 'consum', 0.0221, 'lps'),
	(633712, 134, '2015-01-01 00:36:57.000000', 'consum', 0.0221, 'lps'),
	(633713, 134, '2015-01-01 00:36:58.000000', 'consum', 0.0232, 'lps'),
	(633714, 134, '2015-01-01 00:36:59.000000', 'consum', 0.0240, 'lps'),
	(633715, 134, '2015-01-01 00:37:00.000000', 'consum', 0.0252, 'lps'),
	(633716, 134, '2015-01-01 00:37:01.000000', 'consum', 0.0240, 'lps'),
	(633717, 134, '2015-01-01 00:37:02.000000', 'consum', 0.0233, 'lps'),
	(633718, 134, '2015-01-01 00:37:03.000000', 'consum', 0.0235, 'lps'),
	(633719, 134, '2015-01-01 00:37:04.000000', 'consum', 0.0225, 'lps'),
	(633720, 134, '2015-01-01 00:37:05.000000', 'consum', 0.0252, 'lps'),
	(633721, 134, '2015-01-01 00:37:06.000000', 'consum', 0.0242, 'lps'),
	(633722, 134, '2015-01-01 00:37:07.000000', 'consum', 0.0244, 'lps'),
	(633723, 134, '2015-01-01 00:37:08.000000', 'consum', 0.0242, 'lps'),
	(633724, 134, '2015-01-01 00:37:09.000000', 'consum', 0.0221, 'lps'),
	(633725, 134, '2015-01-01 00:37:10.000000', 'consum', 0.0215, 'lps'),
	(633726, 134, '2015-01-01 00:37:11.000000', 'consum', 0.0246, 'lps'),
	(633727, 134, '2015-01-01 00:37:12.000000', 'consum', 0.0240, 'lps'),
	(633728, 134, '2015-01-01 00:37:13.000000', 'consum', 0.0254, 'lps'),
	(633729, 134, '2015-01-01 00:37:14.000000', 'consum', 0.0252, 'lps'),
	(633730, 134, '2015-01-01 00:37:15.000000', 'consum', 0.0244, 'lps'),
	(633731, 134, '2015-01-01 00:37:16.000000', 'consum', 0.0252, 'lps'),
	(633732, 134, '2015-01-01 00:37:17.000000', 'consum', 0.0231, 'lps'),
	(633733, 134, '2015-01-01 00:37:18.000000', 'consum', 0.0232, 'lps'),
	(633734, 134, '2015-01-01 00:37:19.000000', 'consum', 0.0216, 'lps'),
	(633735, 134, '2015-01-01 00:37:20.000000', 'consum', 0.0216, 'lps'),
	(633736, 134, '2015-01-01 00:37:21.000000', 'consum', 0.0223, 'lps'),
	(633737, 134, '2015-01-01 00:37:22.000000', 'consum', 0.0215, 'lps'),
	(633738, 134, '2015-01-01 00:37:23.000000', 'consum', 0.0238, 'lps'),
	(633739, 134, '2015-01-01 00:37:24.000000', 'consum', 0.0247, 'lps'),
	(633740, 134, '2015-01-01 00:37:25.000000', 'consum', 0.0222, 'lps'),
	(633741, 134, '2015-01-01 00:37:26.000000', 'consum', 0.0251, 'lps'),
	(633742, 134, '2015-01-01 00:37:27.000000', 'consum', 0.0242, 'lps'),
	(633743, 134, '2015-01-01 00:37:28.000000', 'consum', 0.0246, 'lps'),
	(633744, 134, '2015-01-01 00:37:29.000000', 'consum', 0.0253, 'lps'),
	(633745, 134, '2015-01-01 00:37:30.000000', 'consum', 0.0225, 'lps'),
	(633746, 134, '2015-01-01 00:37:31.000000', 'consum', 0.0247, 'lps'),
	(633747, 134, '2015-01-01 00:37:32.000000', 'consum', 0.0216, 'lps'),
	(633748, 134, '2015-01-01 00:37:33.000000', 'consum', 0.0220, 'lps'),
	(633749, 134, '2015-01-01 00:37:34.000000', 'consum', 0.0244, 'lps'),
	(633750, 134, '2015-01-01 00:37:35.000000', 'consum', 0.0213, 'lps'),
	(633751, 134, '2015-01-01 00:37:36.000000', 'consum', 0.0214, 'lps'),
	(633752, 134, '2015-01-01 00:37:37.000000', 'consum', 0.0223, 'lps'),
	(633753, 134, '2015-01-01 00:37:38.000000', 'consum', 0.0218, 'lps'),
	(633754, 134, '2015-01-01 00:37:39.000000', 'consum', 0.0210, 'lps'),
	(633755, 134, '2015-01-01 00:37:40.000000', 'consum', 0.0232, 'lps'),
	(633756, 134, '2015-01-01 00:37:41.000000', 'consum', 0.0230, 'lps'),
	(633757, 134, '2015-01-01 00:37:42.000000', 'consum', 0.0247, 'lps'),
	(633758, 134, '2015-01-01 00:37:43.000000', 'consum', 0.0242, 'lps'),
	(633759, 134, '2015-01-01 00:37:44.000000', 'consum', 0.0216, 'lps'),
	(633760, 134, '2015-01-01 00:37:45.000000', 'consum', 0.0237, 'lps'),
	(633761, 134, '2015-01-01 00:37:46.000000', 'consum', 0.0234, 'lps'),
	(633762, 134, '2015-01-01 00:37:47.000000', 'consum', 0.0250, 'lps'),
	(633763, 134, '2015-01-01 00:37:48.000000', 'consum', 0.0251, 'lps'),
	(633764, 134, '2015-01-01 00:37:49.000000', 'consum', 0.0248, 'lps'),
	(633765, 134, '2015-01-01 00:37:50.000000', 'consum', 0.0232, 'lps'),
	(633766, 134, '2015-01-01 00:37:51.000000', 'consum', 0.0254, 'lps'),
	(633767, 134, '2015-01-01 00:37:52.000000', 'consum', 0.0227, 'lps'),
	(633768, 134, '2015-01-01 00:37:53.000000', 'consum', 0.0254, 'lps'),
	(633769, 134, '2015-01-01 00:37:54.000000', 'consum', 0.0244, 'lps'),
	(633770, 134, '2015-01-01 00:37:55.000000', 'consum', 0.0250, 'lps'),
	(633771, 134, '2015-01-01 00:37:56.000000', 'consum', 0.0219, 'lps'),
	(633772, 134, '2015-01-01 00:37:57.000000', 'consum', 0.0226, 'lps'),
	(633773, 134, '2015-01-01 00:37:58.000000', 'consum', 0.0216, 'lps'),
	(633774, 134, '2015-01-01 00:37:59.000000', 'consum', 0.0240, 'lps'),
	(633775, 134, '2015-01-01 00:38:00.000000', 'consum', 0.0252, 'lps'),
	(633776, 134, '2015-01-01 00:38:01.000000', 'consum', 0.0238, 'lps'),
	(633777, 134, '2015-01-01 00:38:02.000000', 'consum', 0.0227, 'lps'),
	(633778, 134, '2015-01-01 00:38:03.000000', 'consum', 0.0213, 'lps'),
	(633779, 134, '2015-01-01 00:38:04.000000', 'consum', 0.0217, 'lps'),
	(633780, 134, '2015-01-01 00:38:05.000000', 'consum', 0.0237, 'lps'),
	(633781, 134, '2015-01-01 00:38:06.000000', 'consum', 0.0234, 'lps'),
	(633782, 134, '2015-01-01 00:38:07.000000', 'consum', 0.0251, 'lps'),
	(633783, 134, '2015-01-01 00:38:08.000000', 'consum', 0.0254, 'lps'),
	(633784, 134, '2015-01-01 00:38:09.000000', 'consum', 0.0215, 'lps'),
	(633785, 134, '2015-01-01 00:38:10.000000', 'consum', 0.0241, 'lps'),
	(633786, 134, '2015-01-01 00:38:11.000000', 'consum', 0.0215, 'lps'),
	(633787, 134, '2015-01-01 00:38:12.000000', 'consum', 0.0233, 'lps'),
	(633788, 134, '2015-01-01 00:38:13.000000', 'consum', 0.0218, 'lps'),
	(633789, 134, '2015-01-01 00:38:14.000000', 'consum', 0.0227, 'lps'),
	(633790, 134, '2015-01-01 00:38:15.000000', 'consum', 0.0228, 'lps'),
	(633791, 134, '2015-01-01 00:38:16.000000', 'consum', 0.0247, 'lps'),
	(633792, 134, '2015-01-01 00:38:17.000000', 'consum', 0.0253, 'lps'),
	(633793, 134, '2015-01-01 00:38:18.000000', 'consum', 0.0226, 'lps'),
	(633794, 134, '2015-01-01 00:38:19.000000', 'consum', 0.0251, 'lps'),
	(633795, 134, '2015-01-01 00:38:20.000000', 'consum', 0.0232, 'lps'),
	(633796, 134, '2015-01-01 00:38:21.000000', 'consum', 0.0241, 'lps'),
	(633797, 134, '2015-01-01 00:38:22.000000', 'consum', 0.0212, 'lps'),
	(633798, 134, '2015-01-01 00:38:23.000000', 'consum', 0.0216, 'lps'),
	(633799, 134, '2015-01-01 00:38:24.000000', 'consum', 0.0233, 'lps'),
	(633800, 134, '2015-01-01 00:38:25.000000', 'consum', 0.0218, 'lps'),
	(633801, 134, '2015-01-01 00:38:26.000000', 'consum', 0.0227, 'lps'),
	(633802, 134, '2015-01-01 00:38:27.000000', 'consum', 0.0226, 'lps'),
	(633803, 134, '2015-01-01 00:38:28.000000', 'consum', 0.0240, 'lps'),
	(633804, 134, '2015-01-01 00:38:29.000000', 'consum', 0.0223, 'lps'),
	(633805, 134, '2015-01-01 00:38:30.000000', 'consum', 0.0231, 'lps'),
	(633806, 134, '2015-01-01 00:38:31.000000', 'consum', 0.0231, 'lps'),
	(633807, 134, '2015-01-01 00:38:32.000000', 'consum', 0.0254, 'lps'),
	(633808, 134, '2015-01-01 00:38:33.000000', 'consum', 0.0229, 'lps'),
	(633809, 134, '2015-01-01 00:38:34.000000', 'consum', 0.0222, 'lps'),
	(633810, 134, '2015-01-01 00:38:35.000000', 'consum', 0.0213, 'lps'),
	(633811, 134, '2015-01-01 00:38:36.000000', 'consum', 0.0232, 'lps'),
	(633812, 134, '2015-01-01 00:38:37.000000', 'consum', 0.0224, 'lps'),
	(633813, 134, '2015-01-01 00:38:38.000000', 'consum', 0.0213, 'lps'),
	(633814, 134, '2015-01-01 00:38:39.000000', 'consum', 0.0228, 'lps'),
	(633815, 134, '2015-01-01 00:38:40.000000', 'consum', 0.0247, 'lps'),
	(633816, 134, '2015-01-01 00:38:41.000000', 'consum', 0.0252, 'lps'),
	(633817, 134, '2015-01-01 00:38:42.000000', 'consum', 0.0221, 'lps'),
	(633818, 134, '2015-01-01 00:38:43.000000', 'consum', 0.0230, 'lps'),
	(633819, 134, '2015-01-01 00:38:44.000000', 'consum', 0.0230, 'lps'),
	(633820, 134, '2015-01-01 00:38:45.000000', 'consum', 0.0252, 'lps'),
	(633821, 134, '2015-01-01 00:38:46.000000', 'consum', 0.0226, 'lps'),
	(633822, 134, '2015-01-01 00:38:47.000000', 'consum', 0.0211, 'lps'),
	(633823, 134, '2015-01-01 00:38:48.000000', 'consum', 0.0210, 'lps'),
	(633824, 134, '2015-01-01 00:38:49.000000', 'consum', 0.0210, 'lps'),
	(633825, 134, '2015-01-01 00:38:50.000000', 'consum', 0.0254, 'lps'),
	(633826, 134, '2015-01-01 00:38:51.000000', 'consum', 0.0251, 'lps'),
	(633827, 134, '2015-01-01 00:38:52.000000', 'consum', 0.0236, 'lps'),
	(633828, 134, '2015-01-01 00:38:53.000000', 'consum', 0.0221, 'lps'),
	(633829, 134, '2015-01-01 00:38:54.000000', 'consum', 0.0231, 'lps'),
	(633830, 134, '2015-01-01 00:38:55.000000', 'consum', 0.0238, 'lps'),
	(633831, 134, '2015-01-01 00:38:56.000000', 'consum', 0.0240, 'lps'),
	(633832, 134, '2015-01-01 00:38:57.000000', 'consum', 0.0234, 'lps'),
	(633833, 134, '2015-01-01 00:38:58.000000', 'consum', 0.0242, 'lps'),
	(633834, 134, '2015-01-01 00:38:59.000000', 'consum', 0.0250, 'lps'),
	(633835, 134, '2015-01-01 00:39:00.000000', 'consum', 0.0226, 'lps'),
	(633836, 134, '2015-01-01 00:39:01.000000', 'consum', 0.0216, 'lps'),
	(633837, 134, '2015-01-01 00:39:02.000000', 'consum', 0.0239, 'lps'),
	(633838, 134, '2015-01-01 00:39:03.000000', 'consum', 0.0246, 'lps'),
	(633839, 134, '2015-01-01 00:39:04.000000', 'consum', 0.0212, 'lps'),
	(633840, 134, '2015-01-01 00:39:05.000000', 'consum', 0.0251, 'lps'),
	(633841, 134, '2015-01-01 00:39:06.000000', 'consum', 0.0226, 'lps'),
	(633842, 134, '2015-01-01 00:39:07.000000', 'consum', 0.0214, 'lps'),
	(633843, 134, '2015-01-01 00:39:08.000000', 'consum', 0.0226, 'lps'),
	(633844, 134, '2015-01-01 00:39:09.000000', 'consum', 0.0234, 'lps'),
	(633845, 134, '2015-01-01 00:39:10.000000', 'consum', 0.0239, 'lps'),
	(633846, 134, '2015-01-01 00:39:11.000000', 'consum', 0.0237, 'lps'),
	(633847, 134, '2015-01-01 00:39:12.000000', 'consum', 0.0213, 'lps'),
	(633848, 134, '2015-01-01 00:39:13.000000', 'consum', 0.0236, 'lps'),
	(633849, 134, '2015-01-01 00:39:14.000000', 'consum', 0.0241, 'lps'),
	(633850, 134, '2015-01-01 00:39:15.000000', 'consum', 0.0242, 'lps'),
	(633851, 134, '2015-01-01 00:39:16.000000', 'consum', 0.0233, 'lps'),
	(633852, 134, '2015-01-01 00:39:17.000000', 'consum', 0.0230, 'lps'),
	(633853, 134, '2015-01-01 00:39:18.000000', 'consum', 0.0240, 'lps'),
	(633854, 134, '2015-01-01 00:39:19.000000', 'consum', 0.0210, 'lps'),
	(633855, 134, '2015-01-01 00:39:20.000000', 'consum', 0.0213, 'lps'),
	(633856, 134, '2015-01-01 00:39:21.000000', 'consum', 0.0223, 'lps'),
	(633857, 134, '2015-01-01 00:39:22.000000', 'consum', 0.0223, 'lps'),
	(633858, 134, '2015-01-01 00:39:23.000000', 'consum', 0.0236, 'lps'),
	(633859, 134, '2015-01-01 00:39:24.000000', 'consum', 0.0211, 'lps'),
	(633860, 134, '2015-01-01 00:39:25.000000', 'consum', 0.0228, 'lps'),
	(633861, 134, '2015-01-01 00:39:26.000000', 'consum', 0.0254, 'lps'),
	(633862, 134, '2015-01-01 00:39:27.000000', 'consum', 0.0241, 'lps'),
	(633863, 134, '2015-01-01 00:39:28.000000', 'consum', 0.0233, 'lps'),
	(633864, 134, '2015-01-01 00:39:29.000000', 'consum', 0.0233, 'lps'),
	(633865, 134, '2015-01-01 00:39:30.000000', 'consum', 0.0213, 'lps'),
	(633866, 134, '2015-01-01 00:39:31.000000', 'consum', 0.0246, 'lps'),
	(633867, 134, '2015-01-01 00:39:32.000000', 'consum', 0.0245, 'lps'),
	(633868, 134, '2015-01-01 00:39:33.000000', 'consum', 0.0233, 'lps'),
	(633869, 134, '2015-01-01 00:39:34.000000', 'consum', 0.0220, 'lps'),
	(633870, 134, '2015-01-01 00:39:35.000000', 'consum', 0.0236, 'lps'),
	(633871, 134, '2015-01-01 00:39:36.000000', 'consum', 0.0221, 'lps'),
	(633872, 134, '2015-01-01 00:39:37.000000', 'consum', 0.0232, 'lps'),
	(633873, 134, '2015-01-01 00:39:38.000000', 'consum', 0.0241, 'lps'),
	(633874, 134, '2015-01-01 00:39:39.000000', 'consum', 0.0210, 'lps'),
	(633875, 134, '2015-01-01 00:39:40.000000', 'consum', 0.0253, 'lps'),
	(633876, 134, '2015-01-01 00:39:41.000000', 'consum', 0.0246, 'lps'),
	(633877, 134, '2015-01-01 00:39:42.000000', 'consum', 0.0215, 'lps'),
	(633878, 134, '2015-01-01 00:39:43.000000', 'consum', 0.0216, 'lps'),
	(633879, 134, '2015-01-01 00:39:44.000000', 'consum', 0.0229, 'lps'),
	(633880, 134, '2015-01-01 00:39:45.000000', 'consum', 0.0240, 'lps'),
	(633881, 134, '2015-01-01 00:39:46.000000', 'consum', 0.0216, 'lps'),
	(633882, 134, '2015-01-01 00:39:47.000000', 'consum', 0.0239, 'lps'),
	(633883, 134, '2015-01-01 00:39:48.000000', 'consum', 0.0249, 'lps'),
	(633884, 134, '2015-01-01 00:39:49.000000', 'consum', 0.0229, 'lps'),
	(633885, 134, '2015-01-01 00:39:50.000000', 'consum', 0.0230, 'lps'),
	(633886, 134, '2015-01-01 00:39:51.000000', 'consum', 0.0212, 'lps'),
	(633887, 134, '2015-01-01 00:39:52.000000', 'consum', 0.0249, 'lps'),
	(633888, 134, '2015-01-01 00:39:53.000000', 'consum', 0.0221, 'lps'),
	(633889, 134, '2015-01-01 00:39:54.000000', 'consum', 0.0236, 'lps'),
	(633890, 134, '2015-01-01 00:39:55.000000', 'consum', 0.0220, 'lps'),
	(633891, 134, '2015-01-01 00:39:56.000000', 'consum', 0.0225, 'lps'),
	(633892, 134, '2015-01-01 00:39:57.000000', 'consum', 0.0213, 'lps'),
	(633893, 134, '2015-01-01 00:39:58.000000', 'consum', 0.0225, 'lps'),
	(633894, 134, '2015-01-01 00:39:59.000000', 'consum', 0.0230, 'lps'),
	(633895, 134, '2015-01-01 00:40:00.000000', 'consum', 0.0223, 'lps'),
	(633896, 134, '2015-01-01 00:40:01.000000', 'consum', 0.0213, 'lps'),
	(633897, 134, '2015-01-01 00:40:02.000000', 'consum', 0.0233, 'lps'),
	(633898, 134, '2015-01-01 00:40:03.000000', 'consum', 0.0224, 'lps'),
	(633899, 134, '2015-01-01 00:40:04.000000', 'consum', 0.0215, 'lps'),
	(633900, 134, '2015-01-01 00:40:05.000000', 'consum', 0.0235, 'lps'),
	(633901, 134, '2015-01-01 00:40:06.000000', 'consum', 0.0232, 'lps'),
	(633902, 134, '2015-01-01 00:40:07.000000', 'consum', 0.0244, 'lps'),
	(633903, 134, '2015-01-01 00:40:08.000000', 'consum', 0.0226, 'lps'),
	(633904, 134, '2015-01-01 00:40:09.000000', 'consum', 0.0235, 'lps'),
	(633905, 134, '2015-01-01 00:40:10.000000', 'consum', 0.0242, 'lps'),
	(633906, 134, '2015-01-01 00:40:11.000000', 'consum', 0.0248, 'lps'),
	(633907, 134, '2015-01-01 00:40:12.000000', 'consum', 0.0217, 'lps'),
	(633908, 134, '2015-01-01 00:40:13.000000', 'consum', 0.0220, 'lps'),
	(633909, 134, '2015-01-01 00:40:14.000000', 'consum', 0.0242, 'lps'),
	(633910, 134, '2015-01-01 00:40:15.000000', 'consum', 0.0249, 'lps'),
	(633911, 134, '2015-01-01 00:40:16.000000', 'consum', 0.0220, 'lps'),
	(633912, 134, '2015-01-01 00:40:17.000000', 'consum', 0.0235, 'lps'),
	(633913, 134, '2015-01-01 00:40:18.000000', 'consum', 0.0213, 'lps'),
	(633914, 134, '2015-01-01 00:40:19.000000', 'consum', 0.0243, 'lps'),
	(633915, 134, '2015-01-01 00:40:20.000000', 'consum', 0.0232, 'lps'),
	(633916, 134, '2015-01-01 00:40:21.000000', 'consum', 0.0218, 'lps'),
	(633917, 134, '2015-01-01 00:40:22.000000', 'consum', 0.0233, 'lps'),
	(633918, 134, '2015-01-01 00:40:23.000000', 'consum', 0.0210, 'lps'),
	(633919, 134, '2015-01-01 00:40:24.000000', 'consum', 0.0231, 'lps'),
	(633920, 134, '2015-01-01 00:40:25.000000', 'consum', 0.0224, 'lps'),
	(633921, 134, '2015-01-01 00:40:26.000000', 'consum', 0.0220, 'lps'),
	(633922, 134, '2015-01-01 00:40:27.000000', 'consum', 0.0219, 'lps'),
	(633923, 134, '2015-01-01 00:40:28.000000', 'consum', 0.0225, 'lps'),
	(633924, 134, '2015-01-01 00:40:29.000000', 'consum', 0.0213, 'lps'),
	(633925, 134, '2015-01-01 00:40:30.000000', 'consum', 0.0226, 'lps'),
	(633926, 134, '2015-01-01 00:40:31.000000', 'consum', 0.0235, 'lps'),
	(633927, 134, '2015-01-01 00:40:32.000000', 'consum', 0.0245, 'lps'),
	(633928, 134, '2015-01-01 00:40:33.000000', 'consum', 0.0220, 'lps'),
	(633929, 134, '2015-01-01 00:40:34.000000', 'consum', 0.0244, 'lps'),
	(633930, 134, '2015-01-01 00:40:35.000000', 'consum', 0.0214, 'lps'),
	(633931, 134, '2015-01-01 00:40:36.000000', 'consum', 0.0221, 'lps'),
	(633932, 134, '2015-01-01 00:40:37.000000', 'consum', 0.0210, 'lps'),
	(633933, 134, '2015-01-01 00:40:38.000000', 'consum', 0.0219, 'lps'),
	(633934, 134, '2015-01-01 00:40:39.000000', 'consum', 0.0212, 'lps'),
	(633935, 134, '2015-01-01 00:40:40.000000', 'consum', 0.0237, 'lps'),
	(633936, 134, '2015-01-01 00:40:41.000000', 'consum', 0.0248, 'lps'),
	(633937, 134, '2015-01-01 00:40:42.000000', 'consum', 0.0233, 'lps'),
	(633938, 134, '2015-01-01 00:40:43.000000', 'consum', 0.0211, 'lps'),
	(633939, 134, '2015-01-01 00:40:44.000000', 'consum', 0.0234, 'lps'),
	(633940, 134, '2015-01-01 00:40:45.000000', 'consum', 0.0239, 'lps'),
	(633941, 134, '2015-01-01 00:40:46.000000', 'consum', 0.0239, 'lps'),
	(633942, 134, '2015-01-01 00:40:47.000000', 'consum', 0.0224, 'lps'),
	(633943, 134, '2015-01-01 00:40:48.000000', 'consum', 0.0236, 'lps'),
	(633944, 134, '2015-01-01 00:40:49.000000', 'consum', 0.0254, 'lps'),
	(633945, 134, '2015-01-01 00:40:50.000000', 'consum', 0.0220, 'lps'),
	(633946, 134, '2015-01-01 00:40:51.000000', 'consum', 0.0217, 'lps'),
	(633947, 134, '2015-01-01 00:40:52.000000', 'consum', 0.0216, 'lps'),
	(633948, 134, '2015-01-01 00:40:53.000000', 'consum', 0.0218, 'lps'),
	(633949, 134, '2015-01-01 00:40:54.000000', 'consum', 0.0233, 'lps'),
	(633950, 134, '2015-01-01 00:40:55.000000', 'consum', 0.0213, 'lps'),
	(633951, 134, '2015-01-01 00:40:56.000000', 'consum', 0.0245, 'lps'),
	(633952, 134, '2015-01-01 00:40:57.000000', 'consum', 0.0244, 'lps'),
	(633953, 134, '2015-01-01 00:40:58.000000', 'consum', 0.0227, 'lps'),
	(633954, 134, '2015-01-01 00:40:59.000000', 'consum', 0.0242, 'lps'),
	(633955, 134, '2015-01-01 00:41:00.000000', 'consum', 0.0226, 'lps'),
	(633956, 134, '2015-01-01 00:41:01.000000', 'consum', 0.0241, 'lps'),
	(633957, 134, '2015-01-01 00:41:02.000000', 'consum', 0.0229, 'lps'),
	(633958, 134, '2015-01-01 00:41:03.000000', 'consum', 0.0213, 'lps'),
	(633959, 134, '2015-01-01 00:41:04.000000', 'consum', 0.0214, 'lps'),
	(633960, 134, '2015-01-01 00:41:05.000000', 'consum', 0.0221, 'lps'),
	(633961, 134, '2015-01-01 00:41:06.000000', 'consum', 0.0253, 'lps'),
	(633962, 134, '2015-01-01 00:41:07.000000', 'consum', 0.0212, 'lps'),
	(633963, 134, '2015-01-01 00:41:08.000000', 'consum', 0.0228, 'lps'),
	(633964, 134, '2015-01-01 00:41:09.000000', 'consum', 0.0250, 'lps'),
	(633965, 134, '2015-01-01 00:41:10.000000', 'consum', 0.0219, 'lps'),
	(633966, 134, '2015-01-01 00:41:11.000000', 'consum', 0.0228, 'lps'),
	(633967, 134, '2015-01-01 00:41:12.000000', 'consum', 0.0227, 'lps'),
	(633968, 134, '2015-01-01 00:41:13.000000', 'consum', 0.0244, 'lps'),
	(633969, 134, '2015-01-01 00:41:14.000000', 'consum', 0.0236, 'lps'),
	(633970, 134, '2015-01-01 00:41:15.000000', 'consum', 0.0241, 'lps'),
	(633971, 134, '2015-01-01 00:41:16.000000', 'consum', 0.0240, 'lps'),
	(633972, 134, '2015-01-01 00:41:17.000000', 'consum', 0.0223, 'lps'),
	(633973, 134, '2015-01-01 00:41:18.000000', 'consum', 0.0233, 'lps'),
	(633974, 134, '2015-01-01 00:41:19.000000', 'consum', 0.0239, 'lps'),
	(633975, 134, '2015-01-01 00:41:20.000000', 'consum', 0.0244, 'lps'),
	(633976, 134, '2015-01-01 00:41:21.000000', 'consum', 0.0246, 'lps'),
	(633977, 134, '2015-01-01 00:41:22.000000', 'consum', 0.0243, 'lps'),
	(633978, 134, '2015-01-01 00:41:23.000000', 'consum', 0.0222, 'lps'),
	(633979, 134, '2015-01-01 00:41:24.000000', 'consum', 0.0219, 'lps'),
	(633980, 134, '2015-01-01 00:41:25.000000', 'consum', 0.0219, 'lps'),
	(633981, 134, '2015-01-01 00:41:26.000000', 'consum', 0.0228, 'lps'),
	(633982, 134, '2015-01-01 00:41:27.000000', 'consum', 0.0228, 'lps'),
	(633983, 134, '2015-01-01 00:41:28.000000', 'consum', 0.0248, 'lps'),
	(633984, 134, '2015-01-01 00:41:29.000000', 'consum', 0.0210, 'lps'),
	(633985, 134, '2015-01-01 00:41:30.000000', 'consum', 0.0232, 'lps'),
	(633986, 134, '2015-01-01 00:41:31.000000', 'consum', 0.0231, 'lps'),
	(633987, 134, '2015-01-01 00:41:32.000000', 'consum', 0.0248, 'lps'),
	(633988, 134, '2015-01-01 00:41:33.000000', 'consum', 0.0246, 'lps'),
	(633989, 134, '2015-01-01 00:41:34.000000', 'consum', 0.0234, 'lps'),
	(633990, 134, '2015-01-01 00:41:35.000000', 'consum', 0.0224, 'lps'),
	(633991, 134, '2015-01-01 00:41:36.000000', 'consum', 0.0250, 'lps'),
	(633992, 134, '2015-01-01 00:41:37.000000', 'consum', 0.0236, 'lps'),
	(633993, 134, '2015-01-01 00:41:38.000000', 'consum', 0.0221, 'lps'),
	(633994, 134, '2015-01-01 00:41:39.000000', 'consum', 0.0231, 'lps'),
	(633995, 134, '2015-01-01 00:41:40.000000', 'consum', 0.0238, 'lps'),
	(633996, 134, '2015-01-01 00:41:41.000000', 'consum', 0.0244, 'lps'),
	(633997, 134, '2015-01-01 00:41:42.000000', 'consum', 0.0251, 'lps'),
	(633998, 134, '2015-01-01 00:41:43.000000', 'consum', 0.0222, 'lps'),
	(633999, 134, '2015-01-01 00:41:44.000000', 'consum', 0.0238, 'lps'),
	(634000, 134, '2015-01-01 00:41:45.000000', 'consum', 0.0225, 'lps'),
	(634001, 134, '2015-01-01 00:41:46.000000', 'consum', 0.0245, 'lps'),
	(634002, 134, '2015-01-01 00:41:47.000000', 'consum', 0.0253, 'lps'),
	(634003, 134, '2015-01-01 00:41:48.000000', 'consum', 0.0229, 'lps'),
	(634004, 134, '2015-01-01 00:41:49.000000', 'consum', 0.0220, 'lps'),
	(634005, 134, '2015-01-01 00:41:50.000000', 'consum', 0.0248, 'lps'),
	(634006, 134, '2015-01-01 00:41:51.000000', 'consum', 0.0238, 'lps'),
	(634007, 134, '2015-01-01 00:41:52.000000', 'consum', 0.0236, 'lps'),
	(634008, 134, '2015-01-01 00:41:53.000000', 'consum', 0.0213, 'lps'),
	(634009, 134, '2015-01-01 00:41:54.000000', 'consum', 0.0236, 'lps'),
	(634010, 134, '2015-01-01 00:41:55.000000', 'consum', 0.0240, 'lps'),
	(634011, 134, '2015-01-01 00:41:56.000000', 'consum', 0.0239, 'lps'),
	(634012, 134, '2015-01-01 00:41:57.000000', 'consum', 0.0222, 'lps'),
	(634013, 134, '2015-01-01 00:41:58.000000', 'consum', 0.0226, 'lps'),
	(634014, 134, '2015-01-01 00:41:59.000000', 'consum', 0.0212, 'lps'),
	(634015, 134, '2015-01-01 00:42:00.000000', 'consum', 0.0216, 'lps'),
	(634016, 134, '2015-01-01 00:42:01.000000', 'consum', 0.0236, 'lps'),
	(634017, 134, '2015-01-01 00:42:02.000000', 'consum', 0.0233, 'lps'),
	(634018, 134, '2015-01-01 00:42:03.000000', 'consum', 0.0246, 'lps'),
	(634019, 134, '2015-01-01 00:42:04.000000', 'consum', 0.0233, 'lps'),
	(634020, 134, '2015-01-01 00:42:05.000000', 'consum', 0.0217, 'lps'),
	(634021, 134, '2015-01-01 00:42:06.000000', 'consum', 0.0222, 'lps'),
	(634022, 134, '2015-01-01 00:42:07.000000', 'consum', 0.0249, 'lps'),
	(634023, 134, '2015-01-01 00:42:08.000000', 'consum', 0.0234, 'lps'),
	(634024, 134, '2015-01-01 00:42:09.000000', 'consum', 0.0214, 'lps'),
	(634025, 134, '2015-01-01 00:42:10.000000', 'consum', 0.0248, 'lps'),
	(634026, 134, '2015-01-01 00:42:11.000000', 'consum', 0.0254, 'lps'),
	(634027, 134, '2015-01-01 00:42:12.000000', 'consum', 0.0225, 'lps'),
	(634028, 134, '2015-01-01 00:42:13.000000', 'consum', 0.0244, 'lps'),
	(634029, 134, '2015-01-01 00:42:14.000000', 'consum', 0.0248, 'lps'),
	(634030, 134, '2015-01-01 00:42:15.000000', 'consum', 0.0250, 'lps'),
	(634031, 134, '2015-01-01 00:42:16.000000', 'consum', 0.0252, 'lps'),
	(634032, 134, '2015-01-01 00:42:17.000000', 'consum', 0.0212, 'lps'),
	(634033, 134, '2015-01-01 00:42:18.000000', 'consum', 0.0229, 'lps'),
	(634034, 134, '2015-01-01 00:42:19.000000', 'consum', 0.0211, 'lps'),
	(634035, 134, '2015-01-01 00:42:20.000000', 'consum', 0.0247, 'lps'),
	(634036, 134, '2015-01-01 00:42:21.000000', 'consum', 0.0212, 'lps'),
	(634037, 134, '2015-01-01 00:42:22.000000', 'consum', 0.0243, 'lps'),
	(634038, 134, '2015-01-01 00:42:23.000000', 'consum', 0.0238, 'lps'),
	(634039, 134, '2015-01-01 00:42:24.000000', 'consum', 0.0249, 'lps'),
	(634040, 134, '2015-01-01 00:42:25.000000', 'consum', 0.0231, 'lps'),
	(634041, 134, '2015-01-01 00:42:26.000000', 'consum', 0.0242, 'lps'),
	(634042, 134, '2015-01-01 00:42:27.000000', 'consum', 0.0221, 'lps'),
	(634043, 134, '2015-01-01 00:42:28.000000', 'consum', 0.0213, 'lps'),
	(634044, 134, '2015-01-01 00:42:29.000000', 'consum', 0.0238, 'lps'),
	(634045, 134, '2015-01-01 00:42:30.000000', 'consum', 0.0252, 'lps'),
	(634046, 134, '2015-01-01 00:42:31.000000', 'consum', 0.0246, 'lps'),
	(634047, 134, '2015-01-01 00:42:32.000000', 'consum', 0.0218, 'lps'),
	(634048, 134, '2015-01-01 00:42:33.000000', 'consum', 0.0232, 'lps'),
	(634049, 134, '2015-01-01 00:42:34.000000', 'consum', 0.0252, 'lps'),
	(634050, 134, '2015-01-01 00:42:35.000000', 'consum', 0.0221, 'lps'),
	(634051, 134, '2015-01-01 00:42:36.000000', 'consum', 0.0229, 'lps'),
	(634052, 134, '2015-01-01 00:42:37.000000', 'consum', 0.0229, 'lps'),
	(634053, 134, '2015-01-01 00:42:38.000000', 'consum', 0.0246, 'lps'),
	(634054, 134, '2015-01-01 00:42:39.000000', 'consum', 0.0244, 'lps'),
	(634055, 134, '2015-01-01 00:42:40.000000', 'consum', 0.0228, 'lps'),
	(634056, 134, '2015-01-01 00:42:41.000000', 'consum', 0.0242, 'lps'),
	(634057, 134, '2015-01-01 00:42:42.000000', 'consum', 0.0229, 'lps'),
	(634058, 134, '2015-01-01 00:42:43.000000', 'consum', 0.0251, 'lps'),
	(634059, 134, '2015-01-01 00:42:44.000000', 'consum', 0.0227, 'lps'),
	(634060, 134, '2015-01-01 00:42:45.000000', 'consum', 0.0216, 'lps'),
	(634061, 134, '2015-01-01 00:42:46.000000', 'consum', 0.0233, 'lps'),
	(634062, 134, '2015-01-01 00:42:47.000000', 'consum', 0.0218, 'lps'),
	(634063, 134, '2015-01-01 00:42:48.000000', 'consum', 0.0228, 'lps'),
	(634064, 134, '2015-01-01 00:42:49.000000', 'consum', 0.0231, 'lps'),
	(634065, 134, '2015-01-01 00:42:50.000000', 'consum', 0.0217, 'lps'),
	(634066, 134, '2015-01-01 00:42:51.000000', 'consum', 0.0226, 'lps'),
	(634067, 134, '2015-01-01 00:42:52.000000', 'consum', 0.0225, 'lps'),
	(634068, 134, '2015-01-01 00:42:53.000000', 'consum', 0.0237, 'lps'),
	(634069, 134, '2015-01-01 00:42:54.000000', 'consum', 0.0210, 'lps'),
	(634070, 134, '2015-01-01 00:42:55.000000', 'consum', 0.0220, 'lps'),
	(634071, 134, '2015-01-01 00:42:56.000000', 'consum', 0.0216, 'lps'),
	(634072, 134, '2015-01-01 00:42:57.000000', 'consum', 0.0253, 'lps'),
	(634073, 134, '2015-01-01 00:42:58.000000', 'consum', 0.0229, 'lps'),
	(634074, 134, '2015-01-01 00:42:59.000000', 'consum', 0.0224, 'lps'),
	(634075, 134, '2015-01-01 00:43:00.000000', 'consum', 0.0220, 'lps'),
	(634076, 134, '2015-01-01 00:43:01.000000', 'consum', 0.0220, 'lps'),
	(634077, 134, '2015-01-01 00:43:02.000000', 'consum', 0.0231, 'lps'),
	(634078, 134, '2015-01-01 00:43:03.000000', 'consum', 0.0241, 'lps'),
	(634079, 134, '2015-01-01 00:43:04.000000', 'consum', 0.0211, 'lps'),
	(634080, 134, '2015-01-01 00:43:05.000000', 'consum', 0.0213, 'lps'),
	(634081, 134, '2015-01-01 00:43:06.000000', 'consum', 0.0224, 'lps'),
	(634082, 134, '2015-01-01 00:43:07.000000', 'consum', 0.0227, 'lps'),
	(634083, 134, '2015-01-01 00:43:08.000000', 'consum', 0.0250, 'lps'),
	(634084, 134, '2015-01-01 00:43:09.000000', 'consum', 0.0228, 'lps'),
	(634085, 134, '2015-01-01 00:43:10.000000', 'consum', 0.0225, 'lps'),
	(634086, 134, '2015-01-01 00:43:11.000000', 'consum', 0.0229, 'lps'),
	(634087, 134, '2015-01-01 00:43:12.000000', 'consum', 0.0217, 'lps'),
	(634088, 134, '2015-01-01 00:43:13.000000', 'consum', 0.0232, 'lps'),
	(634089, 134, '2015-01-01 00:43:14.000000', 'consum', 0.0212, 'lps'),
	(634090, 134, '2015-01-01 00:43:15.000000', 'consum', 0.0245, 'lps'),
	(634091, 134, '2015-01-01 00:43:16.000000', 'consum', 0.0243, 'lps'),
	(634092, 134, '2015-01-01 00:43:17.000000', 'consum', 0.0224, 'lps'),
	(634093, 134, '2015-01-01 00:43:18.000000', 'consum', 0.0230, 'lps'),
	(634094, 134, '2015-01-01 00:43:19.000000', 'consum', 0.0221, 'lps'),
	(634095, 134, '2015-01-01 00:43:20.000000', 'consum', 0.0251, 'lps'),
	(634096, 134, '2015-01-01 00:43:21.000000', 'consum', 0.0248, 'lps'),
	(634097, 134, '2015-01-01 00:43:22.000000', 'consum', 0.0232, 'lps'),
	(634098, 134, '2015-01-01 00:43:23.000000', 'consum', 0.0251, 'lps'),
	(634099, 134, '2015-01-01 00:43:24.000000', 'consum', 0.0216, 'lps'),
	(634100, 134, '2015-01-01 00:43:25.000000', 'consum', 0.0250, 'lps'),
	(634101, 134, '2015-01-01 00:43:26.000000', 'consum', 0.0213, 'lps'),
	(634102, 134, '2015-01-01 00:43:27.000000', 'consum', 0.0241, 'lps'),
	(634103, 134, '2015-01-01 00:43:28.000000', 'consum', 0.0219, 'lps'),
	(634104, 134, '2015-01-01 00:43:29.000000', 'consum', 0.0211, 'lps'),
	(634105, 134, '2015-01-01 00:43:30.000000', 'consum', 0.0232, 'lps'),
	(634106, 134, '2015-01-01 00:43:31.000000', 'consum', 0.0229, 'lps'),
	(634107, 134, '2015-01-01 00:43:32.000000', 'consum', 0.0240, 'lps'),
	(634108, 134, '2015-01-01 00:43:33.000000', 'consum', 0.0213, 'lps'),
	(634109, 134, '2015-01-01 00:43:34.000000', 'consum', 0.0225, 'lps'),
	(634110, 134, '2015-01-01 00:43:35.000000', 'consum', 0.0231, 'lps'),
	(634111, 134, '2015-01-01 00:43:36.000000', 'consum', 0.0227, 'lps'),
	(634112, 134, '2015-01-01 00:43:37.000000', 'consum', 0.0233, 'lps'),
	(634113, 134, '2015-01-01 00:43:38.000000', 'consum', 0.0228, 'lps'),
	(634114, 134, '2015-01-01 00:43:39.000000', 'consum', 0.0230, 'lps'),
	(634115, 134, '2015-01-01 00:43:40.000000', 'consum', 0.0215, 'lps'),
	(634116, 134, '2015-01-01 00:43:41.000000', 'consum', 0.0218, 'lps'),
	(634117, 134, '2015-01-01 00:43:42.000000', 'consum', 0.0237, 'lps'),
	(634118, 134, '2015-01-01 00:43:43.000000', 'consum', 0.0233, 'lps'),
	(634119, 134, '2015-01-01 00:43:44.000000', 'consum', 0.0241, 'lps'),
	(634120, 134, '2015-01-01 00:43:45.000000', 'consum', 0.0210, 'lps'),
	(634121, 134, '2015-01-01 00:43:46.000000', 'consum', 0.0250, 'lps'),
	(634122, 134, '2015-01-01 00:43:47.000000', 'consum', 0.0230, 'lps'),
	(634123, 134, '2015-01-01 00:43:48.000000', 'consum', 0.0238, 'lps'),
	(634124, 134, '2015-01-01 00:43:49.000000', 'consum', 0.0246, 'lps'),
	(634125, 134, '2015-01-01 00:43:50.000000', 'consum', 0.0217, 'lps'),
	(634126, 134, '2015-01-01 00:43:51.000000', 'consum', 0.0228, 'lps'),
	(634127, 134, '2015-01-01 00:43:52.000000', 'consum', 0.0231, 'lps'),
	(634128, 134, '2015-01-01 00:43:53.000000', 'consum', 0.0219, 'lps'),
	(634129, 134, '2015-01-01 00:43:54.000000', 'consum', 0.0239, 'lps'),
	(634130, 134, '2015-01-01 00:43:55.000000', 'consum', 0.0235, 'lps'),
	(634131, 134, '2015-01-01 00:43:56.000000', 'consum', 0.0250, 'lps'),
	(634132, 134, '2015-01-01 00:43:57.000000', 'consum', 0.0246, 'lps'),
	(634133, 134, '2015-01-01 00:43:58.000000', 'consum', 0.0223, 'lps'),
	(634134, 134, '2015-01-01 00:43:59.000000', 'consum', 0.0216, 'lps'),
	(634135, 134, '2015-01-01 00:44:00.000000', 'consum', 0.0245, 'lps'),
	(634136, 134, '2015-01-01 00:44:01.000000', 'consum', 0.0234, 'lps'),
	(634137, 134, '2015-01-01 00:44:02.000000', 'consum', 0.0223, 'lps'),
	(634138, 134, '2015-01-01 00:44:03.000000', 'consum', 0.0250, 'lps'),
	(634139, 134, '2015-01-01 00:44:04.000000', 'consum', 0.0234, 'lps'),
	(634140, 134, '2015-01-01 00:44:05.000000', 'consum', 0.0212, 'lps'),
	(634141, 134, '2015-01-01 00:44:06.000000', 'consum', 0.0239, 'lps'),
	(634142, 134, '2015-01-01 00:44:07.000000', 'consum', 0.0216, 'lps'),
	(634143, 134, '2015-01-01 00:44:08.000000', 'consum', 0.0243, 'lps'),
	(634144, 134, '2015-01-01 00:44:09.000000', 'consum', 0.0222, 'lps'),
	(634145, 134, '2015-01-01 00:44:10.000000', 'consum', 0.0215, 'lps'),
	(634146, 134, '2015-01-01 00:44:11.000000', 'consum', 0.0246, 'lps'),
	(634147, 134, '2015-01-01 00:44:12.000000', 'consum', 0.0238, 'lps'),
	(634148, 134, '2015-01-01 00:44:13.000000', 'consum', 0.0245, 'lps'),
	(634149, 134, '2015-01-01 00:44:14.000000', 'consum', 0.0254, 'lps'),
	(634150, 134, '2015-01-01 00:44:15.000000', 'consum', 0.0238, 'lps'),
	(634151, 134, '2015-01-01 00:44:16.000000', 'consum', 0.0216, 'lps'),
	(634152, 134, '2015-01-01 00:44:17.000000', 'consum', 0.0248, 'lps'),
	(634153, 134, '2015-01-01 00:44:18.000000', 'consum', 0.0247, 'lps'),
	(634154, 134, '2015-01-01 00:44:19.000000', 'consum', 0.0235, 'lps'),
	(634155, 134, '2015-01-01 00:44:20.000000', 'consum', 0.0226, 'lps'),
	(634156, 134, '2015-01-01 00:44:21.000000', 'consum', 0.0214, 'lps'),
	(634157, 134, '2015-01-01 00:44:22.000000', 'consum', 0.0229, 'lps'),
	(634158, 134, '2015-01-01 00:44:23.000000', 'consum', 0.0248, 'lps'),
	(634159, 134, '2015-01-01 00:44:24.000000', 'consum', 0.0210, 'lps'),
	(634160, 134, '2015-01-01 00:44:25.000000', 'consum', 0.0232, 'lps'),
	(634161, 134, '2015-01-01 00:44:26.000000', 'consum', 0.0229, 'lps'),
	(634162, 134, '2015-01-01 00:44:27.000000', 'consum', 0.0242, 'lps'),
	(634163, 134, '2015-01-01 00:44:28.000000', 'consum', 0.0222, 'lps'),
	(634164, 134, '2015-01-01 00:44:29.000000', 'consum', 0.0218, 'lps'),
	(634165, 134, '2015-01-01 00:44:30.000000', 'consum', 0.0215, 'lps'),
	(634166, 134, '2015-01-01 00:44:31.000000', 'consum', 0.0212, 'lps'),
	(634167, 134, '2015-01-01 00:44:32.000000', 'consum', 0.0249, 'lps'),
	(634168, 134, '2015-01-01 00:44:33.000000', 'consum', 0.0222, 'lps'),
	(634169, 134, '2015-01-01 00:44:34.000000', 'consum', 0.0241, 'lps'),
	(634170, 134, '2015-01-01 00:44:35.000000', 'consum', 0.0239, 'lps'),
	(634171, 134, '2015-01-01 00:44:36.000000', 'consum', 0.0219, 'lps'),
	(634172, 134, '2015-01-01 00:44:37.000000', 'consum', 0.0212, 'lps'),
	(634173, 134, '2015-01-01 00:44:38.000000', 'consum', 0.0238, 'lps'),
	(634174, 134, '2015-01-01 00:44:39.000000', 'consum', 0.0212, 'lps'),
	(634175, 134, '2015-01-01 00:44:40.000000', 'consum', 0.0226, 'lps'),
	(634176, 134, '2015-01-01 00:44:41.000000', 'consum', 0.0241, 'lps'),
	(634177, 134, '2015-01-01 00:44:42.000000', 'consum', 0.0226, 'lps'),
	(634178, 134, '2015-01-01 00:44:43.000000', 'consum', 0.0240, 'lps'),
	(634179, 134, '2015-01-01 00:44:44.000000', 'consum', 0.0226, 'lps'),
	(634180, 134, '2015-01-01 00:44:45.000000', 'consum', 0.0246, 'lps'),
	(634181, 134, '2015-01-01 00:44:46.000000', 'consum', 0.0252, 'lps'),
	(634182, 134, '2015-01-01 00:44:47.000000', 'consum', 0.0221, 'lps'),
	(634183, 134, '2015-01-01 00:44:48.000000', 'consum', 0.0230, 'lps'),
	(634184, 134, '2015-01-01 00:44:49.000000', 'consum', 0.0232, 'lps'),
	(634185, 134, '2015-01-01 00:44:50.000000', 'consum', 0.0216, 'lps'),
	(634186, 134, '2015-01-01 00:44:51.000000', 'consum', 0.0218, 'lps'),
	(634187, 134, '2015-01-01 00:44:52.000000', 'consum', 0.0232, 'lps'),
	(634188, 134, '2015-01-01 00:44:53.000000', 'consum', 0.0254, 'lps'),
	(634189, 134, '2015-01-01 00:44:54.000000', 'consum', 0.0229, 'lps'),
	(634190, 134, '2015-01-01 00:44:55.000000', 'consum', 0.0218, 'lps'),
	(634191, 134, '2015-01-01 00:44:56.000000', 'consum', 0.0239, 'lps'),
	(634192, 134, '2015-01-01 00:44:57.000000', 'consum', 0.0240, 'lps'),
	(634193, 134, '2015-01-01 00:44:58.000000', 'consum', 0.0231, 'lps'),
	(634194, 134, '2015-01-01 00:44:59.000000', 'consum', 0.0222, 'lps'),
	(634195, 134, '2015-01-01 00:45:00.000000', 'consum', 0.0211, 'lps'),
	(634196, 134, '2015-01-01 00:45:01.000000', 'consum', 0.0223, 'lps'),
	(634197, 134, '2015-01-01 00:45:02.000000', 'consum', 0.0227, 'lps'),
	(634198, 134, '2015-01-01 00:45:03.000000', 'consum', 0.0213, 'lps'),
	(634199, 134, '2015-01-01 00:45:04.000000', 'consum', 0.0218, 'lps'),
	(634200, 134, '2015-01-01 00:45:05.000000', 'consum', 0.0241, 'lps'),
	(634201, 134, '2015-01-01 00:45:06.000000', 'consum', 0.0251, 'lps'),
	(634202, 134, '2015-01-01 00:45:07.000000', 'consum', 0.0233, 'lps'),
	(634203, 134, '2015-01-01 00:45:08.000000', 'consum', 0.0249, 'lps'),
	(634204, 134, '2015-01-01 00:45:09.000000', 'consum', 0.0244, 'lps'),
	(634205, 134, '2015-01-01 00:45:10.000000', 'consum', 0.0221, 'lps'),
	(634206, 134, '2015-01-01 00:45:11.000000', 'consum', 0.0251, 'lps'),
	(634207, 134, '2015-01-01 00:45:12.000000', 'consum', 0.0248, 'lps'),
	(634208, 134, '2015-01-01 00:45:13.000000', 'consum', 0.0233, 'lps'),
	(634209, 134, '2015-01-01 00:45:14.000000', 'consum', 0.0210, 'lps'),
	(634210, 134, '2015-01-01 00:45:15.000000', 'consum', 0.0231, 'lps'),
	(634211, 134, '2015-01-01 00:45:16.000000', 'consum', 0.0229, 'lps'),
	(634212, 134, '2015-01-01 00:45:17.000000', 'consum', 0.0239, 'lps'),
	(634213, 134, '2015-01-01 00:45:18.000000', 'consum', 0.0211, 'lps'),
	(634214, 134, '2015-01-01 00:45:19.000000', 'consum', 0.0216, 'lps'),
	(634215, 134, '2015-01-01 00:45:20.000000', 'consum', 0.0237, 'lps'),
	(634216, 134, '2015-01-01 00:45:21.000000', 'consum', 0.0239, 'lps'),
	(634217, 134, '2015-01-01 00:45:22.000000', 'consum', 0.0231, 'lps'),
	(634218, 134, '2015-01-01 00:45:23.000000', 'consum', 0.0227, 'lps'),
	(634219, 134, '2015-01-01 00:45:24.000000', 'consum', 0.0231, 'lps'),
	(634220, 134, '2015-01-01 00:45:25.000000', 'consum', 0.0223, 'lps'),
	(634221, 134, '2015-01-01 00:45:26.000000', 'consum', 0.0210, 'lps'),
	(634222, 134, '2015-01-01 00:45:27.000000', 'consum', 0.0215, 'lps'),
	(634223, 134, '2015-01-01 00:45:28.000000', 'consum', 0.0238, 'lps'),
	(634224, 134, '2015-01-01 00:45:29.000000', 'consum', 0.0243, 'lps'),
	(634225, 134, '2015-01-01 00:45:30.000000', 'consum', 0.0248, 'lps'),
	(634226, 134, '2015-01-01 00:45:31.000000', 'consum', 0.0211, 'lps'),
	(634227, 134, '2015-01-01 00:45:32.000000', 'consum', 0.0235, 'lps'),
	(634228, 134, '2015-01-01 00:45:33.000000', 'consum', 0.0244, 'lps'),
	(634229, 134, '2015-01-01 00:45:34.000000', 'consum', 0.0216, 'lps'),
	(634230, 134, '2015-01-01 00:45:35.000000', 'consum', 0.0230, 'lps'),
	(634231, 134, '2015-01-01 00:45:36.000000', 'consum', 0.0246, 'lps'),
	(634232, 134, '2015-01-01 00:45:37.000000', 'consum', 0.0240, 'lps'),
	(634233, 134, '2015-01-01 00:45:38.000000', 'consum', 0.0252, 'lps'),
	(634234, 134, '2015-01-01 00:45:39.000000', 'consum', 0.0243, 'lps'),
	(634235, 134, '2015-01-01 00:45:40.000000', 'consum', 0.0248, 'lps'),
	(634236, 134, '2015-01-01 00:45:41.000000', 'consum', 0.0210, 'lps'),
	(634237, 134, '2015-01-01 00:45:42.000000', 'consum', 0.0233, 'lps'),
	(634238, 134, '2015-01-01 00:45:43.000000', 'consum', 0.0237, 'lps'),
	(634239, 134, '2015-01-01 00:45:44.000000', 'consum', 0.0230, 'lps'),
	(634240, 134, '2015-01-01 00:45:45.000000', 'consum', 0.0230, 'lps'),
	(634241, 134, '2015-01-01 00:45:46.000000', 'consum', 0.0252, 'lps'),
	(634242, 134, '2015-01-01 00:45:47.000000', 'consum', 0.0224, 'lps'),
	(634243, 134, '2015-01-01 00:45:48.000000', 'consum', 0.0243, 'lps'),
	(634244, 134, '2015-01-01 00:45:49.000000', 'consum', 0.0246, 'lps'),
	(634245, 134, '2015-01-01 00:45:50.000000', 'consum', 0.0247, 'lps'),
	(634246, 134, '2015-01-01 00:45:51.000000', 'consum', 0.0241, 'lps'),
	(634247, 134, '2015-01-01 00:45:52.000000', 'consum', 0.0210, 'lps'),
	(634248, 134, '2015-01-01 00:45:53.000000', 'consum', 0.0252, 'lps'),
	(634249, 134, '2015-01-01 00:45:54.000000', 'consum', 0.0239, 'lps'),
	(634250, 134, '2015-01-01 00:45:55.000000', 'consum', 0.0232, 'lps'),
	(634251, 134, '2015-01-01 00:45:56.000000', 'consum', 0.0232, 'lps'),
	(634252, 134, '2015-01-01 00:45:57.000000', 'consum', 0.0254, 'lps'),
	(634253, 134, '2015-01-01 00:45:58.000000', 'consum', 0.0232, 'lps'),
	(634254, 134, '2015-01-01 00:45:59.000000', 'consum', 0.0233, 'lps'),
	(634255, 134, '2015-01-01 00:46:00.000000', 'consum', 0.0213, 'lps'),
	(634256, 134, '2015-01-01 00:46:01.000000', 'consum', 0.0248, 'lps'),
	(634257, 134, '2015-01-01 00:46:02.000000', 'consum', 0.0254, 'lps'),
	(634258, 134, '2015-01-01 00:46:03.000000', 'consum', 0.0228, 'lps'),
	(634259, 134, '2015-01-01 00:46:04.000000', 'consum', 0.0214, 'lps'),
	(634260, 134, '2015-01-01 00:46:05.000000', 'consum', 0.0220, 'lps'),
	(634261, 134, '2015-01-01 00:46:06.000000', 'consum', 0.0249, 'lps'),
	(634262, 134, '2015-01-01 00:46:07.000000', 'consum', 0.0241, 'lps'),
	(634263, 134, '2015-01-01 00:46:08.000000', 'consum', 0.0248, 'lps'),
	(634264, 134, '2015-01-01 00:46:09.000000', 'consum', 0.0218, 'lps'),
	(634265, 134, '2015-01-01 00:46:10.000000', 'consum', 0.0227, 'lps'),
	(634266, 134, '2015-01-01 00:46:11.000000', 'consum', 0.0224, 'lps'),
	(634267, 134, '2015-01-01 00:46:12.000000', 'consum', 0.0231, 'lps'),
	(634268, 134, '2015-01-01 00:46:13.000000', 'consum', 0.0228, 'lps'),
	(634269, 134, '2015-01-01 00:46:14.000000', 'consum', 0.0236, 'lps'),
	(634270, 134, '2015-01-01 00:46:15.000000', 'consum', 0.0241, 'lps'),
	(634271, 134, '2015-01-01 00:46:16.000000', 'consum', 0.0246, 'lps'),
	(634272, 134, '2015-01-01 00:46:17.000000', 'consum', 0.0249, 'lps'),
	(634273, 134, '2015-01-01 00:46:18.000000', 'consum', 0.0253, 'lps'),
	(634274, 134, '2015-01-01 00:46:19.000000', 'consum', 0.0218, 'lps'),
	(634275, 134, '2015-01-01 00:46:20.000000', 'consum', 0.0214, 'lps'),
	(634276, 134, '2015-01-01 00:46:21.000000', 'consum', 0.0251, 'lps'),
	(634277, 134, '2015-01-01 00:46:22.000000', 'consum', 0.0224, 'lps'),
	(634278, 134, '2015-01-01 00:46:23.000000', 'consum', 0.0245, 'lps'),
	(634279, 134, '2015-01-01 00:46:24.000000', 'consum', 0.0210, 'lps'),
	(634280, 134, '2015-01-01 00:46:25.000000', 'consum', 0.0241, 'lps'),
	(634281, 134, '2015-01-01 00:46:26.000000', 'consum', 0.0228, 'lps'),
	(634282, 134, '2015-01-01 00:46:27.000000', 'consum', 0.0210, 'lps'),
	(634283, 134, '2015-01-01 00:46:28.000000', 'consum', 0.0248, 'lps'),
	(634284, 134, '2015-01-01 00:46:29.000000', 'consum', 0.0218, 'lps'),
	(634285, 134, '2015-01-01 00:46:30.000000', 'consum', 0.0227, 'lps'),
	(634286, 134, '2015-01-01 00:46:31.000000', 'consum', 0.0229, 'lps'),
	(634287, 134, '2015-01-01 00:46:32.000000', 'consum', 0.0252, 'lps'),
	(634288, 134, '2015-01-01 00:46:33.000000', 'consum', 0.0227, 'lps'),
	(634289, 134, '2015-01-01 00:46:34.000000', 'consum', 0.0217, 'lps'),
	(634290, 134, '2015-01-01 00:46:35.000000', 'consum', 0.0240, 'lps'),
	(634291, 134, '2015-01-01 00:46:36.000000', 'consum', 0.0247, 'lps'),
	(634292, 134, '2015-01-01 00:46:37.000000', 'consum', 0.0215, 'lps'),
	(634293, 134, '2015-01-01 00:46:38.000000', 'consum', 0.0214, 'lps'),
	(634294, 134, '2015-01-01 00:46:39.000000', 'consum', 0.0217, 'lps'),
	(634295, 134, '2015-01-01 00:46:40.000000', 'consum', 0.0233, 'lps'),
	(634296, 134, '2015-01-01 00:46:41.000000', 'consum', 0.0216, 'lps'),
	(634297, 134, '2015-01-01 00:46:42.000000', 'consum', 0.0217, 'lps'),
	(634298, 134, '2015-01-01 00:46:43.000000', 'consum', 0.0227, 'lps'),
	(634299, 134, '2015-01-01 00:46:44.000000', 'consum', 0.0229, 'lps'),
	(634300, 134, '2015-01-01 00:46:45.000000', 'consum', 0.0253, 'lps'),
	(634301, 134, '2015-01-01 00:46:46.000000', 'consum', 0.0235, 'lps'),
	(634302, 134, '2015-01-01 00:46:47.000000', 'consum', 0.0253, 'lps'),
	(634303, 134, '2015-01-01 00:46:48.000000', 'consum', 0.0213, 'lps'),
	(634304, 134, '2015-01-01 00:46:49.000000', 'consum', 0.0233, 'lps'),
	(634305, 134, '2015-01-01 00:46:50.000000', 'consum', 0.0228, 'lps'),
	(634306, 134, '2015-01-01 00:46:51.000000', 'consum', 0.0231, 'lps'),
	(634307, 134, '2015-01-01 00:46:52.000000', 'consum', 0.0215, 'lps'),
	(634308, 134, '2015-01-01 00:46:53.000000', 'consum', 0.0217, 'lps'),
	(634309, 134, '2015-01-01 00:46:54.000000', 'consum', 0.0231, 'lps'),
	(634310, 134, '2015-01-01 00:46:55.000000', 'consum', 0.0249, 'lps'),
	(634311, 134, '2015-01-01 00:46:56.000000', 'consum', 0.0251, 'lps'),
	(634312, 134, '2015-01-01 00:46:57.000000', 'consum', 0.0210, 'lps'),
	(634313, 134, '2015-01-01 00:46:58.000000', 'consum', 0.0221, 'lps'),
	(634314, 134, '2015-01-01 00:46:59.000000', 'consum', 0.0223, 'lps'),
	(634315, 134, '2015-01-01 00:47:00.000000', 'consum', 0.0239, 'lps'),
	(634316, 134, '2015-01-01 00:47:01.000000', 'consum', 0.0230, 'lps'),
	(634317, 134, '2015-01-01 00:47:02.000000', 'consum', 0.0223, 'lps'),
	(634318, 134, '2015-01-01 00:47:03.000000', 'consum', 0.0214, 'lps'),
	(634319, 134, '2015-01-01 00:47:04.000000', 'consum', 0.0237, 'lps'),
	(634320, 134, '2015-01-01 00:47:05.000000', 'consum', 0.0244, 'lps'),
	(634321, 134, '2015-01-01 00:47:06.000000', 'consum', 0.0211, 'lps'),
	(634322, 134, '2015-01-01 00:47:07.000000', 'consum', 0.0246, 'lps'),
	(634323, 134, '2015-01-01 00:47:08.000000', 'consum', 0.0210, 'lps'),
	(634324, 134, '2015-01-01 00:47:09.000000', 'consum', 0.0237, 'lps'),
	(634325, 134, '2015-01-01 00:47:10.000000', 'consum', 0.0212, 'lps'),
	(634326, 134, '2015-01-01 00:47:11.000000', 'consum', 0.0228, 'lps'),
	(634327, 134, '2015-01-01 00:47:12.000000', 'consum', 0.0248, 'lps'),
	(634328, 134, '2015-01-01 00:47:13.000000', 'consum', 0.0212, 'lps'),
	(634329, 134, '2015-01-01 00:47:14.000000', 'consum', 0.0243, 'lps'),
	(634330, 134, '2015-01-01 00:47:15.000000', 'consum', 0.0236, 'lps'),
	(634331, 134, '2015-01-01 00:47:16.000000', 'consum', 0.0238, 'lps'),
	(634332, 134, '2015-01-01 00:47:17.000000', 'consum', 0.0230, 'lps'),
	(634333, 134, '2015-01-01 00:47:18.000000', 'consum', 0.0224, 'lps'),
	(634334, 134, '2015-01-01 00:47:19.000000', 'consum', 0.0223, 'lps'),
	(634335, 134, '2015-01-01 00:47:20.000000', 'consum', 0.0232, 'lps'),
	(634336, 134, '2015-01-01 00:47:21.000000', 'consum', 0.0235, 'lps'),
	(634337, 134, '2015-01-01 00:47:22.000000', 'consum', 0.0227, 'lps'),
	(634338, 134, '2015-01-01 00:47:23.000000', 'consum', 0.0221, 'lps'),
	(634339, 134, '2015-01-01 00:47:24.000000', 'consum', 0.0213, 'lps'),
	(634340, 134, '2015-01-01 00:47:25.000000', 'consum', 0.0236, 'lps'),
	(634341, 134, '2015-01-01 00:47:26.000000', 'consum', 0.0243, 'lps'),
	(634342, 134, '2015-01-01 00:47:27.000000', 'consum', 0.0251, 'lps'),
	(634343, 134, '2015-01-01 00:47:28.000000', 'consum', 0.0227, 'lps'),
	(634344, 134, '2015-01-01 00:47:29.000000', 'consum', 0.0218, 'lps'),
	(634345, 134, '2015-01-01 00:47:30.000000', 'consum', 0.0246, 'lps'),
	(634346, 134, '2015-01-01 00:47:31.000000', 'consum', 0.0229, 'lps'),
	(634347, 134, '2015-01-01 00:47:32.000000', 'consum', 0.0245, 'lps'),
	(634348, 134, '2015-01-01 00:47:33.000000', 'consum', 0.0236, 'lps'),
	(634349, 134, '2015-01-01 00:47:34.000000', 'consum', 0.0235, 'lps'),
	(634350, 134, '2015-01-01 00:47:35.000000', 'consum', 0.0214, 'lps'),
	(634351, 134, '2015-01-01 00:47:36.000000', 'consum', 0.0244, 'lps'),
	(634352, 134, '2015-01-01 00:47:37.000000', 'consum', 0.0232, 'lps'),
	(634353, 134, '2015-01-01 00:47:38.000000', 'consum', 0.0222, 'lps'),
	(634354, 134, '2015-01-01 00:47:39.000000', 'consum', 0.0246, 'lps'),
	(634355, 134, '2015-01-01 00:47:40.000000', 'consum', 0.0223, 'lps'),
	(634356, 134, '2015-01-01 00:47:41.000000', 'consum', 0.0212, 'lps'),
	(634357, 134, '2015-01-01 00:47:42.000000', 'consum', 0.0224, 'lps'),
	(634358, 134, '2015-01-01 00:47:43.000000', 'consum', 0.0232, 'lps'),
	(634359, 134, '2015-01-01 00:47:44.000000', 'consum', 0.0235, 'lps'),
	(634360, 134, '2015-01-01 00:47:45.000000', 'consum', 0.0222, 'lps'),
	(634361, 134, '2015-01-01 00:47:46.000000', 'consum', 0.0241, 'lps'),
	(634362, 134, '2015-01-01 00:47:47.000000', 'consum', 0.0239, 'lps'),
	(634363, 134, '2015-01-01 00:47:48.000000', 'consum', 0.0216, 'lps'),
	(634364, 134, '2015-01-01 00:47:49.000000', 'consum', 0.0246, 'lps'),
	(634365, 134, '2015-01-01 00:47:50.000000', 'consum', 0.0237, 'lps'),
	(634366, 134, '2015-01-01 00:47:51.000000', 'consum', 0.0237, 'lps'),
	(634367, 134, '2015-01-01 00:47:52.000000', 'consum', 0.0221, 'lps'),
	(634368, 134, '2015-01-01 00:47:53.000000', 'consum', 0.0230, 'lps'),
	(634369, 134, '2015-01-01 00:47:54.000000', 'consum', 0.0230, 'lps'),
	(634370, 134, '2015-01-01 00:47:55.000000', 'consum', 0.0250, 'lps'),
	(634371, 134, '2015-01-01 00:47:56.000000', 'consum', 0.0217, 'lps'),
	(634372, 134, '2015-01-01 00:47:57.000000', 'consum', 0.0213, 'lps'),
	(634373, 134, '2015-01-01 00:47:58.000000', 'consum', 0.0252, 'lps'),
	(634374, 134, '2015-01-01 00:47:59.000000', 'consum', 0.0230, 'lps'),
	(634375, 134, '2015-01-01 00:48:00.000000', 'consum', 0.0231, 'lps'),
	(634376, 134, '2015-01-01 00:48:01.000000', 'consum', 0.0254, 'lps'),
	(634377, 134, '2015-01-01 00:48:02.000000', 'consum', 0.0233, 'lps'),
	(634378, 134, '2015-01-01 00:48:03.000000', 'consum', 0.0237, 'lps'),
	(634379, 134, '2015-01-01 00:48:04.000000', 'consum', 0.0234, 'lps'),
	(634380, 134, '2015-01-01 00:48:05.000000', 'consum', 0.0249, 'lps'),
	(634381, 134, '2015-01-01 00:48:06.000000', 'consum', 0.0243, 'lps'),
	(634382, 134, '2015-01-01 00:48:07.000000', 'consum', 0.0212, 'lps'),
	(634383, 134, '2015-01-01 00:48:08.000000', 'consum', 0.0215, 'lps'),
	(634384, 134, '2015-01-01 00:48:09.000000', 'consum', 0.0226, 'lps'),
	(634385, 134, '2015-01-01 00:48:10.000000', 'consum', 0.0232, 'lps'),
	(634386, 134, '2015-01-01 00:48:11.000000', 'consum', 0.0228, 'lps'),
	(634387, 134, '2015-01-01 00:48:12.000000', 'consum', 0.0236, 'lps'),
	(634388, 134, '2015-01-01 00:48:13.000000', 'consum', 0.0241, 'lps'),
	(634389, 134, '2015-01-01 00:48:14.000000', 'consum', 0.0241, 'lps'),
	(634390, 134, '2015-01-01 00:48:15.000000', 'consum', 0.0226, 'lps'),
	(634391, 134, '2015-01-01 00:48:16.000000', 'consum', 0.0246, 'lps'),
	(634392, 134, '2015-01-01 00:48:17.000000', 'consum', 0.0251, 'lps'),
	(634393, 134, '2015-01-01 00:48:18.000000', 'consum', 0.0218, 'lps'),
	(634394, 134, '2015-01-01 00:48:19.000000', 'consum', 0.0217, 'lps'),
	(634395, 134, '2015-01-01 00:48:20.000000', 'consum', 0.0223, 'lps'),
	(634396, 134, '2015-01-01 00:48:21.000000', 'consum', 0.0252, 'lps'),
	(634397, 134, '2015-01-01 00:48:22.000000', 'consum', 0.0249, 'lps'),
	(634398, 134, '2015-01-01 00:48:23.000000', 'consum', 0.0231, 'lps'),
	(634399, 134, '2015-01-01 00:48:24.000000', 'consum', 0.0247, 'lps'),
	(634400, 134, '2015-01-01 00:48:25.000000', 'consum', 0.0241, 'lps'),
	(634401, 134, '2015-01-01 00:48:26.000000', 'consum', 0.0210, 'lps'),
	(634402, 134, '2015-01-01 00:48:27.000000', 'consum', 0.0252, 'lps'),
	(634403, 134, '2015-01-01 00:48:28.000000', 'consum', 0.0241, 'lps'),
	(634404, 134, '2015-01-01 00:48:29.000000', 'consum', 0.0239, 'lps'),
	(634405, 134, '2015-01-01 00:48:30.000000', 'consum', 0.0217, 'lps'),
	(634406, 134, '2015-01-01 00:48:31.000000', 'consum', 0.0250, 'lps'),
	(634407, 134, '2015-01-01 00:48:32.000000', 'consum', 0.0210, 'lps'),
	(634408, 134, '2015-01-01 00:48:33.000000', 'consum', 0.0226, 'lps'),
	(634409, 134, '2015-01-01 00:48:34.000000', 'consum', 0.0244, 'lps'),
	(634410, 134, '2015-01-01 00:48:35.000000', 'consum', 0.0244, 'lps'),
	(634411, 134, '2015-01-01 00:48:36.000000', 'consum', 0.0231, 'lps'),
	(634412, 134, '2015-01-01 00:48:37.000000', 'consum', 0.0215, 'lps'),
	(634413, 134, '2015-01-01 00:48:38.000000', 'consum', 0.0216, 'lps'),
	(634414, 134, '2015-01-01 00:48:39.000000', 'consum', 0.0227, 'lps'),
	(634415, 134, '2015-01-01 00:48:40.000000', 'consum', 0.0233, 'lps'),
	(634416, 134, '2015-01-01 00:48:41.000000', 'consum', 0.0228, 'lps'),
	(634417, 134, '2015-01-01 00:48:42.000000', 'consum', 0.0234, 'lps'),
	(634418, 134, '2015-01-01 00:48:43.000000', 'consum', 0.0229, 'lps'),
	(634419, 134, '2015-01-01 00:48:44.000000', 'consum', 0.0235, 'lps'),
	(634420, 134, '2015-01-01 00:48:45.000000', 'consum', 0.0231, 'lps'),
	(634421, 134, '2015-01-01 00:48:46.000000', 'consum', 0.0242, 'lps'),
	(634422, 134, '2015-01-01 00:48:47.000000', 'consum', 0.0219, 'lps'),
	(634423, 134, '2015-01-01 00:48:48.000000', 'consum', 0.0248, 'lps'),
	(634424, 134, '2015-01-01 00:48:49.000000', 'consum', 0.0237, 'lps'),
	(634425, 134, '2015-01-01 00:48:50.000000', 'consum', 0.0234, 'lps'),
	(634426, 134, '2015-01-01 00:48:51.000000', 'consum', 0.0250, 'lps'),
	(634427, 134, '2015-01-01 00:48:52.000000', 'consum', 0.0247, 'lps'),
	(634428, 134, '2015-01-01 00:48:53.000000', 'consum', 0.0232, 'lps'),
	(634429, 134, '2015-01-01 00:48:54.000000', 'consum', 0.0253, 'lps'),
	(634430, 134, '2015-01-01 00:48:55.000000', 'consum', 0.0223, 'lps'),
	(634431, 134, '2015-01-01 00:48:56.000000', 'consum', 0.0239, 'lps'),
	(634432, 134, '2015-01-01 00:48:57.000000', 'consum', 0.0224, 'lps'),
	(634433, 134, '2015-01-01 00:48:58.000000', 'consum', 0.0241, 'lps'),
	(634434, 134, '2015-01-01 00:48:59.000000', 'consum', 0.0231, 'lps'),
	(634435, 134, '2015-01-01 00:49:00.000000', 'consum', 0.0225, 'lps'),
	(634436, 134, '2015-01-01 00:49:01.000000', 'consum', 0.0221, 'lps'),
	(634437, 134, '2015-01-01 00:49:02.000000', 'consum', 0.0219, 'lps'),
	(634438, 134, '2015-01-01 00:49:03.000000', 'consum', 0.0225, 'lps'),
	(634439, 134, '2015-01-01 00:49:04.000000', 'consum', 0.0211, 'lps'),
	(634440, 134, '2015-01-01 00:49:05.000000', 'consum', 0.0218, 'lps'),
	(634441, 134, '2015-01-01 00:49:06.000000', 'consum', 0.0245, 'lps'),
	(634442, 134, '2015-01-01 00:49:07.000000', 'consum', 0.0227, 'lps'),
	(634443, 134, '2015-01-01 00:49:08.000000', 'consum', 0.0234, 'lps'),
	(634444, 134, '2015-01-01 00:49:09.000000', 'consum', 0.0236, 'lps'),
	(634445, 134, '2015-01-01 00:49:10.000000', 'consum', 0.0224, 'lps'),
	(634446, 134, '2015-01-01 00:49:11.000000', 'consum', 0.0248, 'lps'),
	(634447, 134, '2015-01-01 00:49:12.000000', 'consum', 0.0223, 'lps'),
	(634448, 134, '2015-01-01 00:49:13.000000', 'consum', 0.0250, 'lps'),
	(634449, 134, '2015-01-01 00:49:14.000000', 'consum', 0.0239, 'lps'),
	(634450, 134, '2015-01-01 00:49:15.000000', 'consum', 0.0234, 'lps'),
	(634451, 134, '2015-01-01 00:49:16.000000', 'consum', 0.0243, 'lps'),
	(634452, 134, '2015-01-01 00:49:17.000000', 'consum', 0.0216, 'lps'),
	(634453, 134, '2015-01-01 00:49:18.000000', 'consum', 0.0230, 'lps'),
	(634454, 134, '2015-01-01 00:49:19.000000', 'consum', 0.0247, 'lps'),
	(634455, 134, '2015-01-01 00:49:20.000000', 'consum', 0.0247, 'lps'),
	(634456, 134, '2015-01-01 00:49:21.000000', 'consum', 0.0240, 'lps'),
	(634457, 134, '2015-01-01 00:49:22.000000', 'consum', 0.0250, 'lps'),
	(634458, 134, '2015-01-01 00:49:23.000000', 'consum', 0.0231, 'lps'),
	(634459, 134, '2015-01-01 00:49:24.000000', 'consum', 0.0239, 'lps'),
	(634460, 134, '2015-01-01 00:49:25.000000', 'consum', 0.0249, 'lps'),
	(634461, 134, '2015-01-01 00:49:26.000000', 'consum', 0.0228, 'lps'),
	(634462, 134, '2015-01-01 00:49:27.000000', 'consum', 0.0228, 'lps'),
	(634463, 134, '2015-01-01 00:49:28.000000', 'consum', 0.0247, 'lps'),
	(634464, 134, '2015-01-01 00:49:29.000000', 'consum', 0.0251, 'lps'),
	(634465, 134, '2015-01-01 00:49:30.000000', 'consum', 0.0216, 'lps'),
	(634466, 134, '2015-01-01 00:49:31.000000', 'consum', 0.0251, 'lps'),
	(634467, 134, '2015-01-01 00:49:32.000000', 'consum', 0.0218, 'lps'),
	(634468, 134, '2015-01-01 00:49:33.000000', 'consum', 0.0219, 'lps'),
	(634469, 134, '2015-01-01 00:49:34.000000', 'consum', 0.0232, 'lps'),
	(634470, 134, '2015-01-01 00:49:35.000000', 'consum', 0.0249, 'lps'),
	(634471, 134, '2015-01-01 00:49:36.000000', 'consum', 0.0246, 'lps'),
	(634472, 134, '2015-01-01 00:49:37.000000', 'consum', 0.0232, 'lps'),
	(634473, 134, '2015-01-01 00:49:38.000000', 'consum', 0.0211, 'lps'),
	(634474, 134, '2015-01-01 00:49:39.000000', 'consum', 0.0238, 'lps'),
	(634475, 134, '2015-01-01 00:49:40.000000', 'consum', 0.0212, 'lps'),
	(634476, 134, '2015-01-01 00:49:41.000000', 'consum', 0.0230, 'lps'),
	(634477, 134, '2015-01-01 00:49:42.000000', 'consum', 0.0212, 'lps'),
	(634478, 134, '2015-01-01 00:49:43.000000', 'consum', 0.0250, 'lps'),
	(634479, 134, '2015-01-01 00:49:44.000000', 'consum', 0.0226, 'lps'),
	(634480, 134, '2015-01-01 00:49:45.000000', 'consum', 0.0215, 'lps'),
	(634481, 134, '2015-01-01 00:49:46.000000', 'consum', 0.0232, 'lps'),
	(634482, 134, '2015-01-01 00:49:47.000000', 'consum', 0.0217, 'lps'),
	(634483, 134, '2015-01-01 00:49:48.000000', 'consum', 0.0222, 'lps'),
	(634484, 134, '2015-01-01 00:49:49.000000', 'consum', 0.0250, 'lps'),
	(634485, 134, '2015-01-01 00:49:50.000000', 'consum', 0.0242, 'lps'),
	(634486, 134, '2015-01-01 00:49:51.000000', 'consum', 0.0248, 'lps'),
	(634487, 134, '2015-01-01 00:49:52.000000', 'consum', 0.0215, 'lps'),
	(634488, 134, '2015-01-01 00:49:53.000000', 'consum', 0.0210, 'lps'),
	(634489, 134, '2015-01-01 00:49:54.000000', 'consum', 0.0242, 'lps'),
	(634490, 134, '2015-01-01 00:49:55.000000', 'consum', 0.0236, 'lps'),
	(634491, 134, '2015-01-01 00:49:56.000000', 'consum', 0.0245, 'lps'),
	(634492, 134, '2015-01-01 00:49:57.000000', 'consum', 0.0216, 'lps'),
	(634493, 134, '2015-01-01 00:49:58.000000', 'consum', 0.0226, 'lps'),
	(634494, 134, '2015-01-01 00:49:59.000000', 'consum', 0.0229, 'lps'),
	(634495, 134, '2015-01-01 00:50:00.000000', 'consum', 0.0214, 'lps'),
	(634496, 134, '2015-01-01 00:50:01.000000', 'consum', 0.0215, 'lps'),
	(634497, 134, '2015-01-01 00:50:02.000000', 'consum', 0.0223, 'lps'),
	(634498, 134, '2015-01-01 00:50:03.000000', 'consum', 0.0219, 'lps'),
	(634499, 134, '2015-01-01 00:50:04.000000', 'consum', 0.0214, 'lps'),
	(634500, 134, '2015-01-01 00:50:05.000000', 'consum', 0.0250, 'lps'),
	(634501, 134, '2015-01-01 00:50:06.000000', 'consum', 0.0217, 'lps'),
	(634502, 134, '2015-01-01 00:50:07.000000', 'consum', 0.0216, 'lps'),
	(634503, 134, '2015-01-01 00:50:08.000000', 'consum', 0.0219, 'lps'),
	(634504, 134, '2015-01-01 00:50:09.000000', 'consum', 0.0237, 'lps'),
	(634505, 134, '2015-01-01 00:50:10.000000', 'consum', 0.0231, 'lps'),
	(634506, 134, '2015-01-01 00:50:11.000000', 'consum', 0.0234, 'lps'),
	(634507, 134, '2015-01-01 00:50:12.000000', 'consum', 0.0223, 'lps'),
	(634508, 134, '2015-01-01 00:50:13.000000', 'consum', 0.0246, 'lps'),
	(634509, 134, '2015-01-01 00:50:14.000000', 'consum', 0.0217, 'lps'),
	(634510, 134, '2015-01-01 00:50:15.000000', 'consum', 0.0227, 'lps'),
	(634511, 134, '2015-01-01 00:50:16.000000', 'consum', 0.0231, 'lps'),
	(634512, 134, '2015-01-01 00:50:17.000000', 'consum', 0.0220, 'lps'),
	(634513, 134, '2015-01-01 00:50:18.000000', 'consum', 0.0240, 'lps'),
	(634514, 134, '2015-01-01 00:50:19.000000', 'consum', 0.0241, 'lps'),
	(634515, 134, '2015-01-01 00:50:20.000000', 'consum', 0.0230, 'lps'),
	(634516, 134, '2015-01-01 00:50:21.000000', 'consum', 0.0219, 'lps'),
	(634517, 134, '2015-01-01 00:50:22.000000', 'consum', 0.0239, 'lps'),
	(634518, 134, '2015-01-01 00:50:23.000000', 'consum', 0.0241, 'lps'),
	(634519, 134, '2015-01-01 00:50:24.000000', 'consum', 0.0233, 'lps'),
	(634520, 134, '2015-01-01 00:50:25.000000', 'consum', 0.0230, 'lps'),
	(634521, 134, '2015-01-01 00:50:26.000000', 'consum', 0.0242, 'lps'),
	(634522, 134, '2015-01-01 00:50:27.000000', 'consum', 0.0222, 'lps'),
	(634523, 134, '2015-01-01 00:50:28.000000', 'consum', 0.0220, 'lps'),
	(634524, 134, '2015-01-01 00:50:29.000000', 'consum', 0.0225, 'lps'),
	(634525, 134, '2015-01-01 00:50:30.000000', 'consum', 0.0211, 'lps'),
	(634526, 134, '2015-01-01 00:50:31.000000', 'consum', 0.0216, 'lps'),
	(634527, 134, '2015-01-01 00:50:32.000000', 'consum', 0.0236, 'lps'),
	(634528, 134, '2015-01-01 00:50:33.000000', 'consum', 0.0235, 'lps'),
	(634529, 134, '2015-01-01 00:50:34.000000', 'consum', 0.0254, 'lps'),
	(634530, 134, '2015-01-01 00:50:35.000000', 'consum', 0.0222, 'lps'),
	(634531, 134, '2015-01-01 00:50:36.000000', 'consum', 0.0228, 'lps'),
	(634532, 134, '2015-01-01 00:50:37.000000', 'consum', 0.0219, 'lps'),
	(634533, 134, '2015-01-01 00:50:38.000000', 'consum', 0.0248, 'lps'),
	(634534, 134, '2015-01-01 00:50:39.000000', 'consum', 0.0238, 'lps'),
	(634535, 134, '2015-01-01 00:50:40.000000', 'consum', 0.0237, 'lps'),
	(634536, 134, '2015-01-01 00:50:41.000000', 'consum', 0.0217, 'lps'),
	(634537, 134, '2015-01-01 00:50:42.000000', 'consum', 0.0210, 'lps'),
	(634538, 134, '2015-01-01 00:50:43.000000', 'consum', 0.0233, 'lps'),
	(634539, 134, '2015-01-01 00:50:44.000000', 'consum', 0.0234, 'lps'),
	(634540, 134, '2015-01-01 00:50:45.000000', 'consum', 0.0219, 'lps'),
	(634541, 134, '2015-01-01 00:50:46.000000', 'consum', 0.0229, 'lps'),
	(634542, 134, '2015-01-01 00:50:47.000000', 'consum', 0.0234, 'lps'),
	(634543, 134, '2015-01-01 00:50:48.000000', 'consum', 0.0227, 'lps'),
	(634544, 134, '2015-01-01 00:50:49.000000', 'consum', 0.0223, 'lps'),
	(634545, 134, '2015-01-01 00:50:50.000000', 'consum', 0.0227, 'lps'),
	(634546, 134, '2015-01-01 00:50:51.000000', 'consum', 0.0253, 'lps'),
	(634547, 134, '2015-01-01 00:50:52.000000', 'consum', 0.0242, 'lps'),
	(634548, 134, '2015-01-01 00:50:53.000000', 'consum', 0.0241, 'lps'),
	(634549, 134, '2015-01-01 00:50:54.000000', 'consum', 0.0224, 'lps'),
	(634550, 134, '2015-01-01 00:50:55.000000', 'consum', 0.0234, 'lps'),
	(634551, 134, '2015-01-01 00:50:56.000000', 'consum', 0.0241, 'lps'),
	(634552, 134, '2015-01-01 00:50:57.000000', 'consum', 0.0251, 'lps'),
	(634553, 134, '2015-01-01 00:50:58.000000', 'consum', 0.0231, 'lps'),
	(634554, 134, '2015-01-01 00:50:59.000000', 'consum', 0.0240, 'lps'),
	(634555, 134, '2015-01-01 00:51:00.000000', 'consum', 0.0250, 'lps'),
	(634556, 134, '2015-01-01 00:51:01.000000', 'consum', 0.0233, 'lps'),
	(634557, 134, '2015-01-01 00:51:02.000000', 'consum', 0.0248, 'lps'),
	(634558, 134, '2015-01-01 00:51:03.000000', 'consum', 0.0242, 'lps'),
	(634559, 134, '2015-01-01 00:51:04.000000', 'consum', 0.0214, 'lps'),
	(634560, 134, '2015-01-01 00:51:05.000000', 'consum', 0.0222, 'lps'),
	(634561, 134, '2015-01-01 00:51:06.000000', 'consum', 0.0212, 'lps'),
	(634562, 134, '2015-01-01 00:51:07.000000', 'consum', 0.0232, 'lps'),
	(634563, 134, '2015-01-01 00:51:08.000000', 'consum', 0.0223, 'lps'),
	(634564, 134, '2015-01-01 00:51:09.000000', 'consum', 0.0210, 'lps'),
	(634565, 134, '2015-01-01 00:51:10.000000', 'consum', 0.0216, 'lps'),
	(634566, 134, '2015-01-01 00:51:11.000000', 'consum', 0.0241, 'lps'),
	(634567, 134, '2015-01-01 00:51:12.000000', 'consum', 0.0214, 'lps'),
	(634568, 134, '2015-01-01 00:51:13.000000', 'consum', 0.0227, 'lps'),
	(634569, 134, '2015-01-01 00:51:14.000000', 'consum', 0.0240, 'lps'),
	(634570, 134, '2015-01-01 00:51:15.000000', 'consum', 0.0218, 'lps'),
	(634571, 134, '2015-01-01 00:51:16.000000', 'consum', 0.0252, 'lps'),
	(634572, 134, '2015-01-01 00:51:17.000000', 'consum', 0.0215, 'lps'),
	(634573, 134, '2015-01-01 00:51:18.000000', 'consum', 0.0244, 'lps'),
	(634574, 134, '2015-01-01 00:51:19.000000', 'consum', 0.0229, 'lps'),
	(634575, 134, '2015-01-01 00:51:20.000000', 'consum', 0.0250, 'lps'),
	(634576, 134, '2015-01-01 00:51:21.000000', 'consum', 0.0220, 'lps'),
	(634577, 134, '2015-01-01 00:51:22.000000', 'consum', 0.0231, 'lps'),
	(634578, 134, '2015-01-01 00:51:23.000000', 'consum', 0.0240, 'lps'),
	(634579, 134, '2015-01-01 00:51:24.000000', 'consum', 0.0252, 'lps'),
	(634580, 134, '2015-01-01 00:51:25.000000', 'consum', 0.0239, 'lps'),
	(634581, 134, '2015-01-01 00:51:26.000000', 'consum', 0.0231, 'lps'),
	(634582, 134, '2015-01-01 00:51:27.000000', 'consum', 0.0228, 'lps'),
	(634583, 134, '2015-01-01 00:51:28.000000', 'consum', 0.0236, 'lps'),
	(634584, 134, '2015-01-01 00:51:29.000000', 'consum', 0.0241, 'lps'),
	(634585, 134, '2015-01-01 00:51:30.000000', 'consum', 0.0244, 'lps'),
	(634586, 134, '2015-01-01 00:51:31.000000', 'consum', 0.0242, 'lps'),
	(634587, 134, '2015-01-01 00:51:32.000000', 'consum', 0.0222, 'lps'),
	(634588, 134, '2015-01-01 00:51:33.000000', 'consum', 0.0221, 'lps'),
	(634589, 134, '2015-01-01 00:51:34.000000', 'consum', 0.0227, 'lps'),
	(634590, 134, '2015-01-01 00:51:35.000000', 'consum', 0.0220, 'lps'),
	(634591, 134, '2015-01-01 00:51:36.000000', 'consum', 0.0211, 'lps'),
	(634592, 134, '2015-01-01 00:51:37.000000', 'consum', 0.0228, 'lps'),
	(634593, 134, '2015-01-01 00:51:38.000000', 'consum', 0.0254, 'lps'),
	(634594, 134, '2015-01-01 00:51:39.000000', 'consum', 0.0240, 'lps'),
	(634595, 134, '2015-01-01 00:51:40.000000', 'consum', 0.0228, 'lps'),
	(634596, 134, '2015-01-01 00:51:41.000000', 'consum', 0.0213, 'lps'),
	(634597, 134, '2015-01-01 00:51:42.000000', 'consum', 0.0217, 'lps'),
	(634598, 134, '2015-01-01 00:51:43.000000', 'consum', 0.0234, 'lps'),
	(634599, 134, '2015-01-01 00:51:44.000000', 'consum', 0.0218, 'lps'),
	(634600, 134, '2015-01-01 00:51:45.000000', 'consum', 0.0227, 'lps'),
	(634601, 134, '2015-01-01 00:51:46.000000', 'consum', 0.0224, 'lps'),
	(634602, 134, '2015-01-01 00:51:47.000000', 'consum', 0.0228, 'lps'),
	(634603, 134, '2015-01-01 00:51:48.000000', 'consum', 0.0217, 'lps'),
	(634604, 134, '2015-01-01 00:51:49.000000', 'consum', 0.0236, 'lps'),
	(634605, 134, '2015-01-01 00:51:50.000000', 'consum', 0.0228, 'lps'),
	(634606, 134, '2015-01-01 00:51:51.000000', 'consum', 0.0224, 'lps'),
	(634607, 134, '2015-01-01 00:51:52.000000', 'consum', 0.0228, 'lps'),
	(634608, 134, '2015-01-01 00:51:53.000000', 'consum', 0.0210, 'lps'),
	(634609, 134, '2015-01-01 00:51:54.000000', 'consum', 0.0248, 'lps'),
	(634610, 134, '2015-01-01 00:51:55.000000', 'consum', 0.0221, 'lps'),
	(634611, 134, '2015-01-01 00:51:56.000000', 'consum', 0.0239, 'lps'),
	(634612, 134, '2015-01-01 00:51:57.000000', 'consum', 0.0236, 'lps'),
	(634613, 134, '2015-01-01 00:51:58.000000', 'consum', 0.0250, 'lps'),
	(634614, 134, '2015-01-01 00:51:59.000000', 'consum', 0.0245, 'lps'),
	(634615, 134, '2015-01-01 00:52:00.000000', 'consum', 0.0219, 'lps'),
	(634616, 134, '2015-01-01 00:52:01.000000', 'consum', 0.0242, 'lps'),
	(634617, 134, '2015-01-01 00:52:02.000000', 'consum', 0.0253, 'lps'),
	(634618, 134, '2015-01-01 00:52:03.000000', 'consum', 0.0238, 'lps'),
	(634619, 134, '2015-01-01 00:52:04.000000', 'consum', 0.0222, 'lps'),
	(634620, 134, '2015-01-01 00:52:05.000000', 'consum', 0.0233, 'lps'),
	(634621, 134, '2015-01-01 00:52:06.000000', 'consum', 0.0245, 'lps'),
	(634622, 134, '2015-01-01 00:52:07.000000', 'consum', 0.0226, 'lps'),
	(634623, 134, '2015-01-01 00:52:08.000000', 'consum', 0.0231, 'lps'),
	(634624, 134, '2015-01-01 00:52:09.000000', 'consum', 0.0224, 'lps'),
	(634625, 134, '2015-01-01 00:52:10.000000', 'consum', 0.0214, 'lps'),
	(634626, 134, '2015-01-01 00:52:11.000000', 'consum', 0.0237, 'lps'),
	(634627, 134, '2015-01-01 00:52:12.000000', 'consum', 0.0240, 'lps'),
	(634628, 134, '2015-01-01 00:52:13.000000', 'consum', 0.0237, 'lps'),
	(634629, 134, '2015-01-01 00:52:14.000000', 'consum', 0.0253, 'lps'),
	(634630, 134, '2015-01-01 00:52:15.000000', 'consum', 0.0211, 'lps'),
	(634631, 134, '2015-01-01 00:52:16.000000', 'consum', 0.0222, 'lps'),
	(634632, 134, '2015-01-01 00:52:17.000000', 'consum', 0.0224, 'lps'),
	(634633, 134, '2015-01-01 00:52:18.000000', 'consum', 0.0241, 'lps'),
	(634634, 134, '2015-01-01 00:52:19.000000', 'consum', 0.0235, 'lps'),
	(634635, 134, '2015-01-01 00:52:20.000000', 'consum', 0.0243, 'lps'),
	(634636, 134, '2015-01-01 00:52:21.000000', 'consum', 0.0210, 'lps'),
	(634637, 134, '2015-01-01 00:52:22.000000', 'consum', 0.0244, 'lps'),
	(634638, 134, '2015-01-01 00:52:23.000000', 'consum', 0.0249, 'lps'),
	(634639, 134, '2015-01-01 00:52:24.000000', 'consum', 0.0214, 'lps'),
	(634640, 134, '2015-01-01 00:52:25.000000', 'consum', 0.0246, 'lps'),
	(634641, 134, '2015-01-01 00:52:26.000000', 'consum', 0.0244, 'lps'),
	(634642, 134, '2015-01-01 00:52:27.000000', 'consum', 0.0229, 'lps'),
	(634643, 134, '2015-01-01 00:52:28.000000', 'consum', 0.0249, 'lps'),
	(634644, 134, '2015-01-01 00:52:29.000000', 'consum', 0.0214, 'lps'),
	(634645, 134, '2015-01-01 00:52:30.000000', 'consum', 0.0245, 'lps'),
	(634646, 134, '2015-01-01 00:52:31.000000', 'consum', 0.0242, 'lps'),
	(634647, 134, '2015-01-01 00:52:32.000000', 'consum', 0.0220, 'lps'),
	(634648, 134, '2015-01-01 00:52:33.000000', 'consum', 0.0253, 'lps'),
	(634649, 134, '2015-01-01 00:52:34.000000', 'consum', 0.0216, 'lps'),
	(634650, 134, '2015-01-01 00:52:35.000000', 'consum', 0.0247, 'lps'),
	(634651, 134, '2015-01-01 00:52:36.000000', 'consum', 0.0241, 'lps'),
	(634652, 134, '2015-01-01 00:52:37.000000', 'consum', 0.0210, 'lps'),
	(634653, 134, '2015-01-01 00:52:38.000000', 'consum', 0.0252, 'lps'),
	(634654, 134, '2015-01-01 00:52:39.000000', 'consum', 0.0242, 'lps'),
	(634655, 134, '2015-01-01 00:52:40.000000', 'consum', 0.0242, 'lps'),
	(634656, 134, '2015-01-01 00:52:41.000000', 'consum', 0.0232, 'lps'),
	(634657, 134, '2015-01-01 00:52:42.000000', 'consum', 0.0223, 'lps'),
	(634658, 134, '2015-01-01 00:52:43.000000', 'consum', 0.0210, 'lps'),
	(634659, 134, '2015-01-01 00:52:44.000000', 'consum', 0.0217, 'lps'),
	(634660, 134, '2015-01-01 00:52:45.000000', 'consum', 0.0246, 'lps'),
	(634661, 134, '2015-01-01 00:52:46.000000', 'consum', 0.0234, 'lps'),
	(634662, 134, '2015-01-01 00:52:47.000000', 'consum', 0.0222, 'lps'),
	(634663, 134, '2015-01-01 00:52:48.000000', 'consum', 0.0243, 'lps'),
	(634664, 134, '2015-01-01 00:52:49.000000', 'consum', 0.0248, 'lps'),
	(634665, 134, '2015-01-01 00:52:50.000000', 'consum', 0.0213, 'lps'),
	(634666, 134, '2015-01-01 00:52:51.000000', 'consum', 0.0246, 'lps'),
	(634667, 134, '2015-01-01 00:52:52.000000', 'consum', 0.0247, 'lps'),
	(634668, 134, '2015-01-01 00:52:53.000000', 'consum', 0.0240, 'lps'),
	(634669, 134, '2015-01-01 00:52:54.000000', 'consum', 0.0253, 'lps'),
	(634670, 134, '2015-01-01 00:52:55.000000', 'consum', 0.0244, 'lps'),
	(634671, 134, '2015-01-01 00:52:56.000000', 'consum', 0.0253, 'lps'),
	(634672, 134, '2015-01-01 00:52:57.000000', 'consum', 0.0233, 'lps'),
	(634673, 134, '2015-01-01 00:52:58.000000', 'consum', 0.0242, 'lps'),
	(634674, 134, '2015-01-01 00:52:59.000000', 'consum', 0.0212, 'lps'),
	(634675, 134, '2015-01-01 00:53:00.000000', 'consum', 0.0212, 'lps'),
	(634676, 134, '2015-01-01 00:53:01.000000', 'consum', 0.0216, 'lps'),
	(634677, 134, '2015-01-01 00:53:02.000000', 'consum', 0.0235, 'lps'),
	(634678, 134, '2015-01-01 00:53:03.000000', 'consum', 0.0225, 'lps'),
	(634679, 134, '2015-01-01 00:53:04.000000', 'consum', 0.0211, 'lps'),
	(634680, 134, '2015-01-01 00:53:05.000000', 'consum', 0.0218, 'lps'),
	(634681, 134, '2015-01-01 00:53:06.000000', 'consum', 0.0245, 'lps'),
	(634682, 134, '2015-01-01 00:53:07.000000', 'consum', 0.0227, 'lps'),
	(634683, 134, '2015-01-01 00:53:08.000000', 'consum', 0.0234, 'lps'),
	(634684, 134, '2015-01-01 00:53:09.000000', 'consum', 0.0237, 'lps'),
	(634685, 134, '2015-01-01 00:53:10.000000', 'consum', 0.0226, 'lps'),
	(634686, 134, '2015-01-01 00:53:11.000000', 'consum', 0.0254, 'lps'),
	(634687, 134, '2015-01-01 00:53:12.000000', 'consum', 0.0249, 'lps'),
	(634688, 134, '2015-01-01 00:53:13.000000', 'consum', 0.0230, 'lps'),
	(634689, 134, '2015-01-01 00:53:14.000000', 'consum', 0.0237, 'lps'),
	(634690, 134, '2015-01-01 00:53:15.000000', 'consum', 0.0242, 'lps'),
	(634691, 134, '2015-01-01 00:53:16.000000', 'consum', 0.0244, 'lps'),
	(634692, 134, '2015-01-01 00:53:17.000000', 'consum', 0.0241, 'lps'),
	(634693, 134, '2015-01-01 00:53:18.000000', 'consum', 0.0217, 'lps'),
	(634694, 134, '2015-01-01 00:53:19.000000', 'consum', 0.0245, 'lps'),
	(634695, 134, '2015-01-01 00:53:20.000000', 'consum', 0.0226, 'lps'),
	(634696, 134, '2015-01-01 00:53:21.000000', 'consum', 0.0232, 'lps'),
	(634697, 134, '2015-01-01 00:53:22.000000', 'consum', 0.0229, 'lps'),
	(634698, 134, '2015-01-01 00:53:23.000000', 'consum', 0.0240, 'lps'),
	(634699, 134, '2015-01-01 00:53:24.000000', 'consum', 0.0214, 'lps'),
	(634700, 134, '2015-01-01 00:53:25.000000', 'consum', 0.0229, 'lps'),
	(634701, 134, '2015-01-01 00:53:26.000000', 'consum', 0.0251, 'lps'),
	(634702, 134, '2015-01-01 00:53:27.000000', 'consum', 0.0221, 'lps'),
	(634703, 134, '2015-01-01 00:53:28.000000', 'consum', 0.0234, 'lps'),
	(634704, 134, '2015-01-01 00:53:29.000000', 'consum', 0.0253, 'lps'),
	(634705, 134, '2015-01-01 00:53:30.000000', 'consum', 0.0217, 'lps'),
	(634706, 134, '2015-01-01 00:53:31.000000', 'consum', 0.0251, 'lps'),
	(634707, 134, '2015-01-01 00:53:32.000000', 'consum', 0.0216, 'lps'),
	(634708, 134, '2015-01-01 00:53:33.000000', 'consum', 0.0251, 'lps'),
	(634709, 134, '2015-01-01 00:53:34.000000', 'consum', 0.0217, 'lps'),
	(634710, 134, '2015-01-01 00:53:35.000000', 'consum', 0.0212, 'lps'),
	(634711, 134, '2015-01-01 00:53:36.000000', 'consum', 0.0244, 'lps'),
	(634712, 134, '2015-01-01 00:53:37.000000', 'consum', 0.0241, 'lps'),
	(634713, 134, '2015-01-01 00:53:38.000000', 'consum', 0.0218, 'lps'),
	(634714, 134, '2015-01-01 00:53:39.000000', 'consum', 0.0246, 'lps'),
	(634715, 134, '2015-01-01 00:53:40.000000', 'consum', 0.0234, 'lps'),
	(634716, 134, '2015-01-01 00:53:41.000000', 'consum', 0.0219, 'lps'),
	(634717, 134, '2015-01-01 00:53:42.000000', 'consum', 0.0232, 'lps'),
	(634718, 134, '2015-01-01 00:53:43.000000', 'consum', 0.0248, 'lps'),
	(634719, 134, '2015-01-01 00:53:44.000000', 'consum', 0.0243, 'lps'),
	(634720, 134, '2015-01-01 00:53:45.000000', 'consum', 0.0217, 'lps'),
	(634721, 134, '2015-01-01 00:53:46.000000', 'consum', 0.0236, 'lps'),
	(634722, 134, '2015-01-01 00:53:47.000000', 'consum', 0.0228, 'lps'),
	(634723, 134, '2015-01-01 00:53:48.000000', 'consum', 0.0225, 'lps'),
	(634724, 134, '2015-01-01 00:53:49.000000', 'consum', 0.0229, 'lps'),
	(634725, 134, '2015-01-01 00:53:50.000000', 'consum', 0.0216, 'lps'),
	(634726, 134, '2015-01-01 00:53:51.000000', 'consum', 0.0229, 'lps'),
	(634727, 134, '2015-01-01 00:53:52.000000', 'consum', 0.0241, 'lps'),
	(634728, 134, '2015-01-01 00:53:53.000000', 'consum', 0.0221, 'lps'),
	(634729, 134, '2015-01-01 00:53:54.000000', 'consum', 0.0218, 'lps'),
	(634730, 134, '2015-01-01 00:53:55.000000', 'consum', 0.0216, 'lps'),
	(634731, 134, '2015-01-01 00:53:56.000000', 'consum', 0.0216, 'lps'),
	(634732, 134, '2015-01-01 00:53:57.000000', 'consum', 0.0223, 'lps'),
	(634733, 134, '2015-01-01 00:53:58.000000', 'consum', 0.0212, 'lps'),
	(634734, 134, '2015-01-01 00:53:59.000000', 'consum', 0.0225, 'lps'),
	(634735, 134, '2015-01-01 00:54:00.000000', 'consum', 0.0238, 'lps'),
	(634736, 134, '2015-01-01 00:54:01.000000', 'consum', 0.0213, 'lps'),
	(634737, 134, '2015-01-01 00:54:02.000000', 'consum', 0.0232, 'lps'),
	(634738, 134, '2015-01-01 00:54:03.000000', 'consum', 0.0224, 'lps'),
	(634739, 134, '2015-01-01 00:54:04.000000', 'consum', 0.0211, 'lps'),
	(634740, 134, '2015-01-01 00:54:05.000000', 'consum', 0.0221, 'lps'),
	(634741, 134, '2015-01-01 00:54:06.000000', 'consum', 0.0215, 'lps'),
	(634742, 134, '2015-01-01 00:54:07.000000', 'consum', 0.0247, 'lps'),
	(634743, 134, '2015-01-01 00:54:08.000000', 'consum', 0.0246, 'lps'),
	(634744, 134, '2015-01-01 00:54:09.000000', 'consum', 0.0236, 'lps'),
	(634745, 134, '2015-01-01 00:54:10.000000', 'consum', 0.0232, 'lps'),
	(634746, 134, '2015-01-01 00:54:11.000000', 'consum', 0.0242, 'lps'),
	(634747, 134, '2015-01-01 00:54:12.000000', 'consum', 0.0214, 'lps'),
	(634748, 134, '2015-01-01 00:54:13.000000', 'consum', 0.0225, 'lps'),
	(634749, 134, '2015-01-01 00:54:14.000000', 'consum', 0.0230, 'lps'),
	(634750, 134, '2015-01-01 00:54:15.000000', 'consum', 0.0218, 'lps'),
	(634751, 134, '2015-01-01 00:54:16.000000', 'consum', 0.0237, 'lps'),
	(634752, 134, '2015-01-01 00:54:17.000000', 'consum', 0.0230, 'lps'),
	(634753, 134, '2015-01-01 00:54:18.000000', 'consum', 0.0231, 'lps'),
	(634754, 134, '2015-01-01 00:54:19.000000', 'consum', 0.0212, 'lps'),
	(634755, 134, '2015-01-01 00:54:20.000000', 'consum', 0.0245, 'lps'),
	(634756, 134, '2015-01-01 00:54:21.000000', 'consum', 0.0246, 'lps'),
	(634757, 134, '2015-01-01 00:54:22.000000', 'consum', 0.0241, 'lps'),
	(634758, 134, '2015-01-01 00:54:23.000000', 'consum', 0.0210, 'lps'),
	(634759, 134, '2015-01-01 00:54:24.000000', 'consum', 0.0253, 'lps'),
	(634760, 134, '2015-01-01 00:54:25.000000', 'consum', 0.0248, 'lps'),
	(634761, 134, '2015-01-01 00:54:26.000000', 'consum', 0.0224, 'lps'),
	(634762, 134, '2015-01-01 00:54:27.000000', 'consum', 0.0214, 'lps'),
	(634763, 134, '2015-01-01 00:54:28.000000', 'consum', 0.0230, 'lps'),
	(634764, 134, '2015-01-01 00:54:29.000000', 'consum', 0.0212, 'lps'),
	(634765, 134, '2015-01-01 00:54:30.000000', 'consum', 0.0249, 'lps'),
	(634766, 134, '2015-01-01 00:54:31.000000', 'consum', 0.0219, 'lps'),
	(634767, 134, '2015-01-01 00:54:32.000000', 'consum', 0.0227, 'lps'),
	(634768, 134, '2015-01-01 00:54:33.000000', 'consum', 0.0226, 'lps'),
	(634769, 134, '2015-01-01 00:54:34.000000', 'consum', 0.0238, 'lps'),
	(634770, 134, '2015-01-01 00:54:35.000000', 'consum', 0.0214, 'lps'),
	(634771, 134, '2015-01-01 00:54:36.000000', 'consum', 0.0235, 'lps'),
	(634772, 134, '2015-01-01 00:54:37.000000', 'consum', 0.0234, 'lps'),
	(634773, 134, '2015-01-01 00:54:38.000000', 'consum', 0.0254, 'lps'),
	(634774, 134, '2015-01-01 00:54:39.000000', 'consum', 0.0224, 'lps'),
	(634775, 134, '2015-01-01 00:54:40.000000', 'consum', 0.0237, 'lps'),
	(634776, 134, '2015-01-01 00:54:41.000000', 'consum', 0.0215, 'lps'),
	(634777, 134, '2015-01-01 00:54:42.000000', 'consum', 0.0243, 'lps'),
	(634778, 134, '2015-01-01 00:54:43.000000', 'consum', 0.0225, 'lps'),
	(634779, 134, '2015-01-01 00:54:44.000000', 'consum', 0.0233, 'lps'),
	(634780, 134, '2015-01-01 00:54:45.000000', 'consum', 0.0236, 'lps'),
	(634781, 134, '2015-01-01 00:54:46.000000', 'consum', 0.0228, 'lps'),
	(634782, 134, '2015-01-01 00:54:47.000000', 'consum', 0.0220, 'lps'),
	(634783, 134, '2015-01-01 00:54:48.000000', 'consum', 0.0252, 'lps'),
	(634784, 134, '2015-01-01 00:54:49.000000', 'consum', 0.0212, 'lps'),
	(634785, 134, '2015-01-01 00:54:50.000000', 'consum', 0.0227, 'lps'),
	(634786, 134, '2015-01-01 00:54:51.000000', 'consum', 0.0247, 'lps'),
	(634787, 134, '2015-01-01 00:54:52.000000', 'consum', 0.0252, 'lps'),
	(634788, 134, '2015-01-01 00:54:53.000000', 'consum', 0.0219, 'lps'),
	(634789, 134, '2015-01-01 00:54:54.000000', 'consum', 0.0222, 'lps'),
	(634790, 134, '2015-01-01 00:54:55.000000', 'consum', 0.0241, 'lps'),
	(634791, 134, '2015-01-01 00:54:56.000000', 'consum', 0.0240, 'lps'),
	(634792, 134, '2015-01-01 00:54:57.000000', 'consum', 0.0222, 'lps'),
	(634793, 134, '2015-01-01 00:54:58.000000', 'consum', 0.0226, 'lps'),
	(634794, 134, '2015-01-01 00:54:59.000000', 'consum', 0.0211, 'lps'),
	(634795, 134, '2015-01-01 00:55:00.000000', 'consum', 0.0254, 'lps'),
	(634796, 134, '2015-01-01 00:55:01.000000', 'consum', 0.0251, 'lps'),
	(634797, 134, '2015-01-01 00:55:02.000000', 'consum', 0.0237, 'lps'),
	(634798, 134, '2015-01-01 00:55:03.000000', 'consum', 0.0221, 'lps'),
	(634799, 134, '2015-01-01 00:55:04.000000', 'consum', 0.0231, 'lps'),
	(634800, 134, '2015-01-01 00:55:05.000000', 'consum', 0.0239, 'lps'),
	(634801, 134, '2015-01-01 00:55:06.000000', 'consum', 0.0247, 'lps'),
	(634802, 134, '2015-01-01 00:55:07.000000', 'consum', 0.0216, 'lps'),
	(634803, 134, '2015-01-01 00:55:08.000000', 'consum', 0.0221, 'lps'),
	(634804, 134, '2015-01-01 00:55:09.000000', 'consum', 0.0248, 'lps'),
	(634805, 134, '2015-01-01 00:55:10.000000', 'consum', 0.0232, 'lps'),
	(634806, 134, '2015-01-01 00:55:11.000000', 'consum', 0.0253, 'lps'),
	(634807, 134, '2015-01-01 00:55:12.000000', 'consum', 0.0223, 'lps'),
	(634808, 134, '2015-01-01 00:55:13.000000', 'consum', 0.0236, 'lps'),
	(634809, 134, '2015-01-01 00:55:14.000000', 'consum', 0.0211, 'lps'),
	(634810, 134, '2015-01-01 00:55:15.000000', 'consum', 0.0227, 'lps'),
	(634811, 134, '2015-01-01 00:55:16.000000', 'consum', 0.0246, 'lps'),
	(634812, 134, '2015-01-01 00:55:17.000000', 'consum', 0.0253, 'lps'),
	(634813, 134, '2015-01-01 00:55:18.000000', 'consum', 0.0226, 'lps'),
	(634814, 134, '2015-01-01 00:55:19.000000', 'consum', 0.0252, 'lps'),
	(634815, 134, '2015-01-01 00:55:20.000000', 'consum', 0.0236, 'lps'),
	(634816, 134, '2015-01-01 00:55:21.000000', 'consum', 0.0215, 'lps'),
	(634817, 134, '2015-01-01 00:55:22.000000', 'consum', 0.0248, 'lps'),
	(634818, 134, '2015-01-01 00:55:23.000000', 'consum', 0.0248, 'lps'),
	(634819, 134, '2015-01-01 00:55:24.000000', 'consum', 0.0245, 'lps'),
	(634820, 134, '2015-01-01 00:55:25.000000', 'consum', 0.0223, 'lps'),
	(634821, 134, '2015-01-01 00:55:26.000000', 'consum', 0.0219, 'lps'),
	(634822, 134, '2015-01-01 00:55:27.000000', 'consum', 0.0215, 'lps'),
	(634823, 134, '2015-01-01 00:55:28.000000', 'consum', 0.0252, 'lps'),
	(634824, 134, '2015-01-01 00:55:29.000000', 'consum', 0.0227, 'lps'),
	(634825, 134, '2015-01-01 00:55:30.000000', 'consum', 0.0213, 'lps'),
	(634826, 134, '2015-01-01 00:55:31.000000', 'consum', 0.0220, 'lps'),
	(634827, 134, '2015-01-01 00:55:32.000000', 'consum', 0.0251, 'lps'),
	(634828, 134, '2015-01-01 00:55:33.000000', 'consum', 0.0250, 'lps'),
	(634829, 134, '2015-01-01 00:55:34.000000', 'consum', 0.0244, 'lps'),
	(634830, 134, '2015-01-01 00:55:35.000000', 'consum', 0.0216, 'lps'),
	(634831, 134, '2015-01-01 00:55:36.000000', 'consum', 0.0227, 'lps'),
	(634832, 134, '2015-01-01 00:55:37.000000', 'consum', 0.0234, 'lps'),
	(634833, 134, '2015-01-01 00:55:38.000000', 'consum', 0.0234, 'lps'),
	(634834, 134, '2015-01-01 00:55:39.000000', 'consum', 0.0212, 'lps'),
	(634835, 134, '2015-01-01 00:55:40.000000', 'consum', 0.0240, 'lps'),
	(634836, 134, '2015-01-01 00:55:41.000000', 'consum', 0.0218, 'lps'),
	(634837, 134, '2015-01-01 00:55:42.000000', 'consum', 0.0253, 'lps'),
	(634838, 134, '2015-01-01 00:55:43.000000', 'consum', 0.0221, 'lps'),
	(634839, 134, '2015-01-01 00:55:44.000000', 'consum', 0.0227, 'lps'),
	(634840, 134, '2015-01-01 00:55:45.000000', 'consum', 0.0215, 'lps'),
	(634841, 134, '2015-01-01 00:55:46.000000', 'consum', 0.0230, 'lps'),
	(634842, 134, '2015-01-01 00:55:47.000000', 'consum', 0.0251, 'lps'),
	(634843, 134, '2015-01-01 00:55:48.000000', 'consum', 0.0221, 'lps'),
	(634844, 134, '2015-01-01 00:55:49.000000', 'consum', 0.0231, 'lps'),
	(634845, 134, '2015-01-01 00:55:50.000000', 'consum', 0.0239, 'lps'),
	(634846, 134, '2015-01-01 00:55:51.000000', 'consum', 0.0246, 'lps'),
	(634847, 134, '2015-01-01 00:55:52.000000', 'consum', 0.0216, 'lps'),
	(634848, 134, '2015-01-01 00:55:53.000000', 'consum', 0.0219, 'lps'),
	(634849, 134, '2015-01-01 00:55:54.000000', 'consum', 0.0240, 'lps'),
	(634850, 134, '2015-01-01 00:55:55.000000', 'consum', 0.0241, 'lps'),
	(634851, 134, '2015-01-01 00:55:56.000000', 'consum', 0.0233, 'lps'),
	(634852, 134, '2015-01-01 00:55:57.000000', 'consum', 0.0232, 'lps'),
	(634853, 134, '2015-01-01 00:55:58.000000', 'consum', 0.0249, 'lps'),
	(634854, 134, '2015-01-01 00:55:59.000000', 'consum', 0.0252, 'lps'),
	(634855, 134, '2015-01-01 00:56:00.000000', 'consum', 0.0211, 'lps'),
	(634856, 134, '2015-01-01 00:56:01.000000', 'consum', 0.0228, 'lps'),
	(634857, 134, '2015-01-01 00:56:02.000000', 'consum', 0.0251, 'lps'),
	(634858, 134, '2015-01-01 00:56:03.000000', 'consum', 0.0225, 'lps'),
	(634859, 134, '2015-01-01 00:56:04.000000', 'consum', 0.0254, 'lps'),
	(634860, 134, '2015-01-01 00:56:05.000000', 'consum', 0.0249, 'lps'),
	(634861, 134, '2015-01-01 00:56:06.000000', 'consum', 0.0230, 'lps'),
	(634862, 134, '2015-01-01 00:56:07.000000', 'consum', 0.0238, 'lps'),
	(634863, 134, '2015-01-01 00:56:08.000000', 'consum', 0.0244, 'lps'),
	(634864, 134, '2015-01-01 00:56:09.000000', 'consum', 0.0251, 'lps'),
	(634865, 134, '2015-01-01 00:56:10.000000', 'consum', 0.0224, 'lps'),
	(634866, 134, '2015-01-01 00:56:11.000000', 'consum', 0.0249, 'lps'),
	(634867, 134, '2015-01-01 00:56:12.000000', 'consum', 0.0226, 'lps'),
	(634868, 134, '2015-01-01 00:56:13.000000', 'consum', 0.0219, 'lps'),
	(634869, 134, '2015-01-01 00:56:14.000000', 'consum', 0.0253, 'lps'),
	(634870, 134, '2015-01-01 00:56:15.000000', 'consum', 0.0218, 'lps'),
	(634871, 134, '2015-01-01 00:56:16.000000', 'consum', 0.0211, 'lps'),
	(634872, 134, '2015-01-01 00:56:17.000000', 'consum', 0.0237, 'lps'),
	(634873, 134, '2015-01-01 00:56:18.000000', 'consum', 0.0252, 'lps'),
	(634874, 134, '2015-01-01 00:56:19.000000', 'consum', 0.0251, 'lps'),
	(634875, 134, '2015-01-01 00:56:20.000000', 'consum', 0.0244, 'lps'),
	(634876, 134, '2015-01-01 00:56:21.000000', 'consum', 0.0213, 'lps'),
	(634877, 134, '2015-01-01 00:56:22.000000', 'consum', 0.0212, 'lps'),
	(634878, 134, '2015-01-01 00:56:23.000000', 'consum', 0.0213, 'lps'),
	(634879, 134, '2015-01-01 00:56:24.000000', 'consum', 0.0221, 'lps'),
	(634880, 134, '2015-01-01 00:56:25.000000', 'consum', 0.0253, 'lps'),
	(634881, 134, '2015-01-01 00:56:26.000000', 'consum', 0.0215, 'lps'),
	(634882, 134, '2015-01-01 00:56:27.000000', 'consum', 0.0241, 'lps'),
	(634883, 134, '2015-01-01 00:56:28.000000', 'consum', 0.0214, 'lps'),
	(634884, 134, '2015-01-01 00:56:29.000000', 'consum', 0.0227, 'lps'),
	(634885, 134, '2015-01-01 00:56:30.000000', 'consum', 0.0238, 'lps'),
	(634886, 134, '2015-01-01 00:56:31.000000', 'consum', 0.0210, 'lps'),
	(634887, 134, '2015-01-01 00:56:32.000000', 'consum', 0.0216, 'lps'),
	(634888, 134, '2015-01-01 00:56:33.000000', 'consum', 0.0239, 'lps'),
	(634889, 134, '2015-01-01 00:56:34.000000', 'consum', 0.0250, 'lps'),
	(634890, 134, '2015-01-01 00:56:35.000000', 'consum', 0.0231, 'lps'),
	(634891, 134, '2015-01-01 00:56:36.000000', 'consum', 0.0242, 'lps'),
	(634892, 134, '2015-01-01 00:56:37.000000', 'consum', 0.0218, 'lps'),
	(634893, 134, '2015-01-01 00:56:38.000000', 'consum', 0.0244, 'lps'),
	(634894, 134, '2015-01-01 00:56:39.000000', 'consum', 0.0221, 'lps'),
	(634895, 134, '2015-01-01 00:56:40.000000', 'consum', 0.0253, 'lps'),
	(634896, 134, '2015-01-01 00:56:41.000000', 'consum', 0.0213, 'lps'),
	(634897, 134, '2015-01-01 00:56:42.000000', 'consum', 0.0230, 'lps'),
	(634898, 134, '2015-01-01 00:56:43.000000', 'consum', 0.0214, 'lps'),
	(634899, 134, '2015-01-01 00:56:44.000000', 'consum', 0.0215, 'lps'),
	(634900, 134, '2015-01-01 00:56:45.000000', 'consum', 0.0224, 'lps'),
	(634901, 134, '2015-01-01 00:56:46.000000', 'consum', 0.0221, 'lps'),
	(634902, 134, '2015-01-01 00:56:47.000000', 'consum', 0.0225, 'lps'),
	(634903, 134, '2015-01-01 00:56:48.000000', 'consum', 0.0250, 'lps'),
	(634904, 134, '2015-01-01 00:56:49.000000', 'consum', 0.0232, 'lps'),
	(634905, 134, '2015-01-01 00:56:50.000000', 'consum', 0.0246, 'lps'),
	(634906, 134, '2015-01-01 00:56:51.000000', 'consum', 0.0234, 'lps'),
	(634907, 134, '2015-01-01 00:56:52.000000', 'consum', 0.0224, 'lps'),
	(634908, 134, '2015-01-01 00:56:53.000000', 'consum', 0.0252, 'lps'),
	(634909, 134, '2015-01-01 00:56:54.000000', 'consum', 0.0242, 'lps'),
	(634910, 134, '2015-01-01 00:56:55.000000', 'consum', 0.0245, 'lps'),
	(634911, 134, '2015-01-01 00:56:56.000000', 'consum', 0.0246, 'lps'),
	(634912, 134, '2015-01-01 00:56:57.000000', 'consum', 0.0239, 'lps'),
	(634913, 134, '2015-01-01 00:56:58.000000', 'consum', 0.0249, 'lps'),
	(634914, 134, '2015-01-01 00:56:59.000000', 'consum', 0.0230, 'lps'),
	(634915, 134, '2015-01-01 00:57:00.000000', 'consum', 0.0237, 'lps'),
	(634916, 134, '2015-01-01 00:57:01.000000', 'consum', 0.0240, 'lps'),
	(634917, 134, '2015-01-01 00:57:02.000000', 'consum', 0.0235, 'lps'),
	(634918, 134, '2015-01-01 00:57:03.000000', 'consum', 0.0247, 'lps'),
	(634919, 134, '2015-01-01 00:57:04.000000', 'consum', 0.0228, 'lps'),
	(634920, 134, '2015-01-01 00:57:05.000000', 'consum', 0.0235, 'lps'),
	(634921, 134, '2015-01-01 00:57:06.000000', 'consum', 0.0237, 'lps'),
	(634922, 134, '2015-01-01 00:57:07.000000', 'consum', 0.0227, 'lps'),
	(634923, 134, '2015-01-01 00:57:08.000000', 'consum', 0.0215, 'lps'),
	(634924, 134, '2015-01-01 00:57:09.000000', 'consum', 0.0230, 'lps'),
	(634925, 134, '2015-01-01 00:57:10.000000', 'consum', 0.0248, 'lps'),
	(634926, 134, '2015-01-01 00:57:11.000000', 'consum', 0.0253, 'lps'),
	(634927, 134, '2015-01-01 00:57:12.000000', 'consum', 0.0220, 'lps'),
	(634928, 134, '2015-01-01 00:57:13.000000', 'consum', 0.0223, 'lps'),
	(634929, 134, '2015-01-01 00:57:14.000000', 'consum', 0.0243, 'lps'),
	(634930, 134, '2015-01-01 00:57:15.000000', 'consum', 0.0246, 'lps'),
	(634931, 134, '2015-01-01 00:57:16.000000', 'consum', 0.0247, 'lps'),
	(634932, 134, '2015-01-01 00:57:17.000000', 'consum', 0.0244, 'lps'),
	(634933, 134, '2015-01-01 00:57:18.000000', 'consum', 0.0224, 'lps'),
	(634934, 134, '2015-01-01 00:57:19.000000', 'consum', 0.0225, 'lps'),
	(634935, 134, '2015-01-01 00:57:20.000000', 'consum', 0.0241, 'lps'),
	(634936, 134, '2015-01-01 00:57:21.000000', 'consum', 0.0232, 'lps'),
	(634937, 134, '2015-01-01 00:57:22.000000', 'consum', 0.0228, 'lps'),
	(634938, 134, '2015-01-01 00:57:23.000000', 'consum', 0.0235, 'lps'),
	(634939, 134, '2015-01-01 00:57:24.000000', 'consum', 0.0234, 'lps'),
	(634940, 134, '2015-01-01 00:57:25.000000', 'consum', 0.0211, 'lps'),
	(634941, 134, '2015-01-01 00:57:26.000000', 'consum', 0.0235, 'lps'),
	(634942, 134, '2015-01-01 00:57:27.000000', 'consum', 0.0241, 'lps'),
	(634943, 134, '2015-01-01 00:57:28.000000', 'consum', 0.0247, 'lps'),
	(634944, 134, '2015-01-01 00:57:29.000000', 'consum', 0.0211, 'lps'),
	(634945, 134, '2015-01-01 00:57:30.000000', 'consum', 0.0238, 'lps'),
	(634946, 134, '2015-01-01 00:57:31.000000', 'consum', 0.0214, 'lps'),
	(634947, 134, '2015-01-01 00:57:32.000000', 'consum', 0.0238, 'lps'),
	(634948, 134, '2015-01-01 00:57:33.000000', 'consum', 0.0246, 'lps'),
	(634949, 134, '2015-01-01 00:57:34.000000', 'consum', 0.0216, 'lps'),
	(634950, 134, '2015-01-01 00:57:35.000000', 'consum', 0.0225, 'lps'),
	(634951, 134, '2015-01-01 00:57:36.000000', 'consum', 0.0222, 'lps'),
	(634952, 134, '2015-01-01 00:57:37.000000', 'consum', 0.0225, 'lps'),
	(634953, 134, '2015-01-01 00:57:38.000000', 'consum', 0.0250, 'lps'),
	(634954, 134, '2015-01-01 00:57:39.000000', 'consum', 0.0228, 'lps'),
	(634955, 134, '2015-01-01 00:57:40.000000', 'consum', 0.0228, 'lps'),
	(634956, 134, '2015-01-01 00:57:41.000000', 'consum', 0.0248, 'lps'),
	(634957, 134, '2015-01-01 00:57:42.000000', 'consum', 0.0254, 'lps'),
	(634958, 134, '2015-01-01 00:57:43.000000', 'consum', 0.0226, 'lps'),
	(634959, 134, '2015-01-01 00:57:44.000000', 'consum', 0.0250, 'lps'),
	(634960, 134, '2015-01-01 00:57:45.000000', 'consum', 0.0227, 'lps'),
	(634961, 134, '2015-01-01 00:57:46.000000', 'consum', 0.0221, 'lps'),
	(634962, 134, '2015-01-01 00:57:47.000000', 'consum', 0.0215, 'lps'),
	(634963, 134, '2015-01-01 00:57:48.000000', 'consum', 0.0246, 'lps'),
	(634964, 134, '2015-01-01 00:57:49.000000', 'consum', 0.0242, 'lps'),
	(634965, 134, '2015-01-01 00:57:50.000000', 'consum', 0.0215, 'lps'),
	(634966, 134, '2015-01-01 00:57:51.000000', 'consum', 0.0231, 'lps'),
	(634967, 134, '2015-01-01 00:57:52.000000', 'consum', 0.0210, 'lps'),
	(634968, 134, '2015-01-01 00:57:53.000000', 'consum', 0.0239, 'lps'),
	(634969, 134, '2015-01-01 00:57:54.000000', 'consum', 0.0219, 'lps'),
	(634970, 134, '2015-01-01 00:57:55.000000', 'consum', 0.0213, 'lps'),
	(634971, 134, '2015-01-01 00:57:56.000000', 'consum', 0.0243, 'lps'),
	(634972, 134, '2015-01-01 00:57:57.000000', 'consum', 0.0233, 'lps'),
	(634973, 134, '2015-01-01 00:57:58.000000', 'consum', 0.0228, 'lps'),
	(634974, 134, '2015-01-01 00:57:59.000000', 'consum', 0.0229, 'lps'),
	(634975, 134, '2015-01-01 00:58:00.000000', 'consum', 0.0252, 'lps'),
	(634976, 134, '2015-01-01 00:58:01.000000', 'consum', 0.0229, 'lps'),
	(634977, 134, '2015-01-01 00:58:02.000000', 'consum', 0.0223, 'lps'),
	(634978, 134, '2015-01-01 00:58:03.000000', 'consum', 0.0219, 'lps'),
	(634979, 134, '2015-01-01 00:58:04.000000', 'consum', 0.0215, 'lps'),
	(634980, 134, '2015-01-01 00:58:05.000000', 'consum', 0.0254, 'lps'),
	(634981, 134, '2015-01-01 00:58:06.000000', 'consum', 0.0235, 'lps'),
	(634982, 134, '2015-01-01 00:58:07.000000', 'consum', 0.0250, 'lps'),
	(634983, 134, '2015-01-01 00:58:08.000000', 'consum', 0.0246, 'lps'),
	(634984, 134, '2015-01-01 00:58:09.000000', 'consum', 0.0225, 'lps'),
	(634985, 134, '2015-01-01 00:58:10.000000', 'consum', 0.0220, 'lps'),
	(634986, 134, '2015-01-01 00:58:11.000000', 'consum', 0.0219, 'lps'),
	(634987, 134, '2015-01-01 00:58:12.000000', 'consum', 0.0224, 'lps'),
	(634988, 134, '2015-01-01 00:58:13.000000', 'consum', 0.0253, 'lps'),
	(634989, 134, '2015-01-01 00:58:14.000000', 'consum', 0.0251, 'lps'),
	(634990, 134, '2015-01-01 00:58:15.000000', 'consum', 0.0239, 'lps'),
	(634991, 134, '2015-01-01 00:58:16.000000', 'consum', 0.0233, 'lps'),
	(634992, 134, '2015-01-01 00:58:17.000000', 'consum', 0.0238, 'lps'),
	(634993, 134, '2015-01-01 00:58:18.000000', 'consum', 0.0235, 'lps'),
	(634994, 134, '2015-01-01 00:58:19.000000', 'consum', 0.0210, 'lps'),
	(634995, 134, '2015-01-01 00:58:20.000000', 'consum', 0.0223, 'lps'),
	(634996, 134, '2015-01-01 00:58:21.000000', 'consum', 0.0232, 'lps'),
	(634997, 134, '2015-01-01 00:58:22.000000', 'consum', 0.0237, 'lps'),
	(634998, 134, '2015-01-01 00:58:23.000000', 'consum', 0.0234, 'lps'),
	(634999, 134, '2015-01-01 00:58:24.000000', 'consum', 0.0249, 'lps'),
	(635000, 134, '2015-01-01 00:58:25.000000', 'consum', 0.0243, 'lps'),
	(635001, 134, '2015-01-01 00:58:26.000000', 'consum', 0.0215, 'lps'),
	(635002, 134, '2015-01-01 00:58:27.000000', 'consum', 0.0224, 'lps'),
	(635003, 134, '2015-01-01 00:58:28.000000', 'consum', 0.0223, 'lps'),
	(635004, 134, '2015-01-01 00:58:29.000000', 'consum', 0.0231, 'lps'),
	(635005, 134, '2015-01-01 00:58:30.000000', 'consum', 0.0231, 'lps'),
	(635006, 134, '2015-01-01 00:58:31.000000', 'consum', 0.0252, 'lps'),
	(635007, 134, '2015-01-01 00:58:32.000000', 'consum', 0.0222, 'lps'),
	(635008, 134, '2015-01-01 00:58:33.000000', 'consum', 0.0238, 'lps'),
	(635009, 134, '2015-01-01 00:58:34.000000', 'consum', 0.0222, 'lps'),
	(635010, 134, '2015-01-01 00:58:35.000000', 'consum', 0.0231, 'lps'),
	(635011, 134, '2015-01-01 00:58:36.000000', 'consum', 0.0234, 'lps'),
	(635012, 134, '2015-01-01 00:58:37.000000', 'consum', 0.0223, 'lps'),
	(635013, 134, '2015-01-01 00:58:38.000000', 'consum', 0.0250, 'lps'),
	(635014, 134, '2015-01-01 00:58:39.000000', 'consum', 0.0235, 'lps'),
	(635015, 134, '2015-01-01 00:58:40.000000', 'consum', 0.0215, 'lps'),
	(635016, 134, '2015-01-01 00:58:41.000000', 'consum', 0.0253, 'lps'),
	(635017, 134, '2015-01-01 00:58:42.000000', 'consum', 0.0230, 'lps'),
	(635018, 134, '2015-01-01 00:58:43.000000', 'consum', 0.0227, 'lps'),
	(635019, 134, '2015-01-01 00:58:44.000000', 'consum', 0.0235, 'lps'),
	(635020, 134, '2015-01-01 00:58:45.000000', 'consum', 0.0241, 'lps'),
	(635021, 134, '2015-01-01 00:58:46.000000', 'consum', 0.0245, 'lps'),
	(635022, 134, '2015-01-01 00:58:47.000000', 'consum', 0.0246, 'lps'),
	(635023, 134, '2015-01-01 00:58:48.000000', 'consum', 0.0243, 'lps'),
	(635024, 134, '2015-01-01 00:58:49.000000', 'consum', 0.0219, 'lps'),
	(635025, 134, '2015-01-01 00:58:50.000000', 'consum', 0.0249, 'lps'),
	(635026, 134, '2015-01-01 00:58:51.000000', 'consum', 0.0243, 'lps'),
	(635027, 134, '2015-01-01 00:58:52.000000', 'consum', 0.0214, 'lps'),
	(635028, 134, '2015-01-01 00:58:53.000000', 'consum', 0.0223, 'lps'),
	(635029, 134, '2015-01-01 00:58:54.000000', 'consum', 0.0216, 'lps'),
	(635030, 134, '2015-01-01 00:58:55.000000', 'consum', 0.0248, 'lps'),
	(635031, 134, '2015-01-01 00:58:56.000000', 'consum', 0.0245, 'lps'),
	(635032, 134, '2015-01-01 00:58:57.000000', 'consum', 0.0228, 'lps'),
	(635033, 134, '2015-01-01 00:58:58.000000', 'consum', 0.0241, 'lps'),
	(635034, 134, '2015-01-01 00:58:59.000000', 'consum', 0.0219, 'lps'),
	(635035, 134, '2015-01-01 00:59:00.000000', 'consum', 0.0210, 'lps'),
	(635036, 134, '2015-01-01 00:59:01.000000', 'consum', 0.0230, 'lps'),
	(635037, 134, '2015-01-01 00:59:02.000000', 'consum', 0.0217, 'lps'),
	(635038, 134, '2015-01-01 00:59:03.000000', 'consum', 0.0234, 'lps'),
	(635039, 134, '2015-01-01 00:59:04.000000', 'consum', 0.0217, 'lps'),
	(635040, 134, '2015-01-01 00:59:05.000000', 'consum', 0.0219, 'lps'),
	(635041, 134, '2015-01-01 00:59:06.000000', 'consum', 0.0233, 'lps'),
	(635042, 134, '2015-01-01 00:59:07.000000', 'consum', 0.0254, 'lps'),
	(635043, 134, '2015-01-01 00:59:08.000000', 'consum', 0.0228, 'lps'),
	(635044, 134, '2015-01-01 00:59:09.000000', 'consum', 0.0212, 'lps'),
	(635045, 134, '2015-01-01 00:59:10.000000', 'consum', 0.0210, 'lps'),
	(635046, 134, '2015-01-01 00:59:11.000000', 'consum', 0.0253, 'lps'),
	(635047, 134, '2015-01-01 00:59:12.000000', 'consum', 0.0244, 'lps'),
	(635048, 134, '2015-01-01 00:59:13.000000', 'consum', 0.0251, 'lps'),
	(635049, 134, '2015-01-01 00:59:14.000000', 'consum', 0.0225, 'lps'),
	(635050, 134, '2015-01-01 00:59:15.000000', 'consum', 0.0251, 'lps'),
	(635051, 134, '2015-01-01 00:59:16.000000', 'consum', 0.0235, 'lps'),
	(635052, 134, '2015-01-01 00:59:17.000000', 'consum', 0.0211, 'lps'),
	(635053, 134, '2015-01-01 00:59:18.000000', 'consum', 0.0234, 'lps'),
	(635054, 134, '2015-01-01 00:59:19.000000', 'consum', 0.0237, 'lps'),
	(635055, 134, '2015-01-01 00:59:20.000000', 'consum', 0.0227, 'lps'),
	(635056, 134, '2015-01-01 00:59:21.000000', 'consum', 0.0216, 'lps'),
	(635057, 134, '2015-01-01 00:59:22.000000', 'consum', 0.0234, 'lps'),
	(635058, 134, '2015-01-01 00:59:23.000000', 'consum', 0.0224, 'lps'),
	(635059, 134, '2015-01-01 00:59:24.000000', 'consum', 0.0253, 'lps'),
	(635060, 134, '2015-01-01 00:59:25.000000', 'consum', 0.0248, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(635061, 134, '2015-01-01 00:59:26.000000', 'consum', 0.0226, 'lps'),
	(635062, 134, '2015-01-01 00:59:27.000000', 'consum', 0.0220, 'lps'),
	(635063, 134, '2015-01-01 00:59:28.000000', 'consum', 0.0215, 'lps'),
	(635064, 134, '2015-01-01 00:59:29.000000', 'consum', 0.0252, 'lps'),
	(635065, 134, '2015-01-01 00:59:30.000000', 'consum', 0.0223, 'lps'),
	(635066, 134, '2015-01-01 00:59:31.000000', 'consum', 0.0240, 'lps'),
	(635067, 134, '2015-01-01 00:59:32.000000', 'consum', 0.0230, 'lps'),
	(635068, 134, '2015-01-01 00:59:33.000000', 'consum', 0.0222, 'lps'),
	(635069, 134, '2015-01-01 00:59:34.000000', 'consum', 0.0254, 'lps'),
	(635070, 134, '2015-01-01 00:59:35.000000', 'consum', 0.0216, 'lps'),
	(635071, 134, '2015-01-01 00:59:36.000000', 'consum', 0.0245, 'lps'),
	(635072, 134, '2015-01-01 00:59:37.000000', 'consum', 0.0232, 'lps'),
	(635073, 134, '2015-01-01 00:59:38.000000', 'consum', 0.0213, 'lps'),
	(635074, 134, '2015-01-01 00:59:39.000000', 'consum', 0.0251, 'lps'),
	(635075, 134, '2015-01-01 00:59:40.000000', 'consum', 0.0225, 'lps'),
	(635076, 134, '2015-01-01 00:59:41.000000', 'consum', 0.0252, 'lps'),
	(635077, 134, '2015-01-01 00:59:42.000000', 'consum', 0.0242, 'lps'),
	(635078, 134, '2015-01-01 00:59:43.000000', 'consum', 0.0242, 'lps'),
	(635079, 134, '2015-01-01 00:59:44.000000', 'consum', 0.0232, 'lps'),
	(635080, 134, '2015-01-01 00:59:45.000000', 'consum', 0.0225, 'lps'),
	(635081, 134, '2015-01-01 00:59:46.000000', 'consum', 0.0218, 'lps'),
	(635082, 134, '2015-01-01 00:59:47.000000', 'consum', 0.0252, 'lps'),
	(635083, 134, '2015-01-01 00:59:48.000000', 'consum', 0.0214, 'lps'),
	(635084, 134, '2015-01-01 00:59:49.000000', 'consum', 0.0242, 'lps'),
	(635085, 134, '2015-01-01 00:59:50.000000', 'consum', 0.0222, 'lps'),
	(635086, 134, '2015-01-01 00:59:51.000000', 'consum', 0.0222, 'lps'),
	(635087, 134, '2015-01-01 00:59:52.000000', 'consum', 0.0231, 'lps'),
	(635088, 134, '2015-01-01 00:59:53.000000', 'consum', 0.0237, 'lps'),
	(635089, 134, '2015-01-01 00:59:54.000000', 'consum', 0.0236, 'lps'),
	(635090, 134, '2015-01-01 00:59:55.000000', 'consum', 0.0217, 'lps'),
	(635091, 134, '2015-01-01 00:59:56.000000', 'consum', 0.0210, 'lps'),
	(635092, 134, '2015-01-01 00:59:57.000000', 'consum', 0.0235, 'lps'),
	(635093, 134, '2015-01-01 00:59:58.000000', 'consum', 0.0246, 'lps'),
	(635094, 134, '2015-01-01 00:59:59.000000', 'consum', 0.0224, 'lps'),
	(635095, 134, '2015-01-01 01:00:00.000000', 'consum', 0.0220, 'lps'),
	(635096, 134, '2015-01-01 01:00:01.000000', 'consum', 0.0218, 'lps'),
	(635097, 134, '2015-01-01 01:00:02.000000', 'consum', 0.0219, 'lps'),
	(635098, 134, '2015-01-01 01:00:03.000000', 'consum', 0.0234, 'lps'),
	(635099, 134, '2015-01-01 01:00:04.000000', 'consum', 0.0212, 'lps'),
	(635100, 134, '2015-01-01 01:00:05.000000', 'consum', 0.0238, 'lps'),
	(635101, 134, '2015-01-01 01:00:06.000000', 'consum', 0.0253, 'lps'),
	(635102, 134, '2015-01-01 01:00:07.000000', 'consum', 0.0254, 'lps'),
	(635103, 134, '2015-01-01 01:00:08.000000', 'consum', 0.0210, 'lps'),
	(635104, 134, '2015-01-01 01:00:09.000000', 'consum', 0.0212, 'lps'),
	(635105, 134, '2015-01-01 01:00:10.000000', 'consum', 0.0222, 'lps'),
	(635106, 134, '2015-01-01 01:00:11.000000', 'consum', 0.0220, 'lps'),
	(635107, 134, '2015-01-01 01:00:12.000000', 'consum', 0.0223, 'lps'),
	(635108, 134, '2015-01-01 01:00:13.000000', 'consum', 0.0245, 'lps'),
	(635109, 134, '2015-01-01 01:00:14.000000', 'consum', 0.0210, 'lps'),
	(635110, 134, '2015-01-01 01:00:15.000000', 'consum', 0.0244, 'lps'),
	(635111, 134, '2015-01-01 01:00:16.000000', 'consum', 0.0244, 'lps'),
	(635112, 134, '2015-01-01 01:00:17.000000', 'consum', 0.0233, 'lps'),
	(635113, 134, '2015-01-01 01:00:18.000000', 'consum', 0.0222, 'lps'),
	(635114, 134, '2015-01-01 01:00:19.000000', 'consum', 0.0250, 'lps'),
	(635115, 134, '2015-01-01 01:00:20.000000', 'consum', 0.0238, 'lps'),
	(635116, 134, '2015-01-01 01:00:21.000000', 'consum', 0.0229, 'lps'),
	(635117, 134, '2015-01-01 01:00:22.000000', 'consum', 0.0224, 'lps'),
	(635118, 134, '2015-01-01 01:00:23.000000', 'consum', 0.0221, 'lps'),
	(635119, 134, '2015-01-01 01:00:24.000000', 'consum', 0.0224, 'lps'),
	(635120, 134, '2015-01-01 01:00:25.000000', 'consum', 0.0249, 'lps'),
	(635121, 134, '2015-01-01 01:00:26.000000', 'consum', 0.0227, 'lps'),
	(635122, 134, '2015-01-01 01:00:27.000000', 'consum', 0.0225, 'lps'),
	(635123, 134, '2015-01-01 01:00:28.000000', 'consum', 0.0235, 'lps'),
	(635124, 134, '2015-01-01 01:00:29.000000', 'consum', 0.0243, 'lps'),
	(635125, 134, '2015-01-01 01:00:30.000000', 'consum', 0.0213, 'lps'),
	(635126, 134, '2015-01-01 01:00:31.000000', 'consum', 0.0216, 'lps'),
	(635127, 134, '2015-01-01 01:00:32.000000', 'consum', 0.0230, 'lps'),
	(635128, 134, '2015-01-01 01:00:33.000000', 'consum', 0.0249, 'lps'),
	(635129, 134, '2015-01-01 01:00:34.000000', 'consum', 0.0212, 'lps'),
	(635130, 134, '2015-01-01 01:00:35.000000', 'consum', 0.0238, 'lps'),
	(635131, 134, '2015-01-01 01:00:36.000000', 'consum', 0.0253, 'lps'),
	(635132, 134, '2015-01-01 01:00:37.000000', 'consum', 0.0252, 'lps'),
	(635133, 134, '2015-01-01 01:00:38.000000', 'consum', 0.0246, 'lps'),
	(635134, 134, '2015-01-01 01:00:39.000000', 'consum', 0.0218, 'lps'),
	(635135, 134, '2015-01-01 01:00:40.000000', 'consum', 0.0235, 'lps'),
	(635136, 134, '2015-01-01 01:00:41.000000', 'consum', 0.0219, 'lps'),
	(635137, 134, '2015-01-01 01:00:42.000000', 'consum', 0.0227, 'lps'),
	(635138, 134, '2015-01-01 01:00:43.000000', 'consum', 0.0224, 'lps'),
	(635139, 134, '2015-01-01 01:00:44.000000', 'consum', 0.0228, 'lps'),
	(635140, 134, '2015-01-01 01:00:45.000000', 'consum', 0.0215, 'lps'),
	(635141, 134, '2015-01-01 01:00:46.000000', 'consum', 0.0226, 'lps'),
	(635142, 134, '2015-01-01 01:00:47.000000', 'consum', 0.0229, 'lps'),
	(635143, 134, '2015-01-01 01:00:48.000000', 'consum', 0.0216, 'lps'),
	(635144, 134, '2015-01-01 01:00:49.000000', 'consum', 0.0225, 'lps'),
	(635145, 134, '2015-01-01 01:00:50.000000', 'consum', 0.0224, 'lps'),
	(635146, 134, '2015-01-01 01:00:51.000000', 'consum', 0.0235, 'lps'),
	(635147, 134, '2015-01-01 01:00:52.000000', 'consum', 0.0251, 'lps'),
	(635148, 134, '2015-01-01 01:00:53.000000', 'consum', 0.0247, 'lps'),
	(635149, 134, '2015-01-01 01:00:54.000000', 'consum', 0.0231, 'lps'),
	(635150, 134, '2015-01-01 01:00:55.000000', 'consum', 0.0248, 'lps'),
	(635151, 134, '2015-01-01 01:00:56.000000', 'consum', 0.0246, 'lps'),
	(635152, 134, '2015-01-01 01:00:57.000000', 'consum', 0.0232, 'lps'),
	(635153, 134, '2015-01-01 01:00:58.000000', 'consum', 0.0214, 'lps'),
	(635154, 134, '2015-01-01 01:00:59.000000', 'consum', 0.0253, 'lps'),
	(635155, 134, '2015-01-01 01:01:00.000000', 'consum', 0.0235, 'lps'),
	(635156, 134, '2015-01-01 01:01:01.000000', 'consum', 0.0250, 'lps'),
	(635157, 134, '2015-01-01 01:01:02.000000', 'consum', 0.0247, 'lps'),
	(635158, 134, '2015-01-01 01:01:03.000000', 'consum', 0.0231, 'lps'),
	(635159, 134, '2015-01-01 01:01:04.000000', 'consum', 0.0249, 'lps'),
	(635160, 134, '2015-01-01 01:01:05.000000', 'consum', 0.0253, 'lps'),
	(635161, 134, '2015-01-01 01:01:06.000000', 'consum', 0.0217, 'lps'),
	(635162, 134, '2015-01-01 01:01:07.000000', 'consum', 0.0252, 'lps'),
	(635163, 134, '2015-01-01 01:01:08.000000', 'consum', 0.0221, 'lps'),
	(635164, 134, '2015-01-01 01:01:09.000000', 'consum', 0.0230, 'lps'),
	(635165, 134, '2015-01-01 01:01:10.000000', 'consum', 0.0231, 'lps'),
	(635166, 134, '2015-01-01 01:01:11.000000', 'consum', 0.0210, 'lps'),
	(635167, 134, '2015-01-01 01:01:12.000000', 'consum', 0.0240, 'lps'),
	(635168, 134, '2015-01-01 01:01:13.000000', 'consum', 0.0223, 'lps'),
	(635169, 134, '2015-01-01 01:01:14.000000', 'consum', 0.0231, 'lps'),
	(635170, 134, '2015-01-01 01:01:15.000000', 'consum', 0.0231, 'lps'),
	(635171, 134, '2015-01-01 01:01:16.000000', 'consum', 0.0210, 'lps'),
	(635172, 134, '2015-01-01 01:01:17.000000', 'consum', 0.0234, 'lps'),
	(635173, 134, '2015-01-01 01:01:18.000000', 'consum', 0.0243, 'lps'),
	(635174, 134, '2015-01-01 01:01:19.000000', 'consum', 0.0214, 'lps'),
	(635175, 134, '2015-01-01 01:01:20.000000', 'consum', 0.0221, 'lps'),
	(635176, 134, '2015-01-01 01:01:21.000000', 'consum', 0.0254, 'lps'),
	(635177, 134, '2015-01-01 01:01:22.000000', 'consum', 0.0219, 'lps'),
	(635178, 134, '2015-01-01 01:01:23.000000', 'consum', 0.0210, 'lps'),
	(635179, 134, '2015-01-01 01:01:24.000000', 'consum', 0.0232, 'lps'),
	(635180, 134, '2015-01-01 01:01:25.000000', 'consum', 0.0229, 'lps'),
	(635181, 134, '2015-01-01 01:01:26.000000', 'consum', 0.0238, 'lps'),
	(635182, 134, '2015-01-01 01:01:27.000000', 'consum', 0.0251, 'lps'),
	(635183, 134, '2015-01-01 01:01:28.000000', 'consum', 0.0243, 'lps'),
	(635184, 134, '2015-01-01 01:01:29.000000', 'consum', 0.0249, 'lps'),
	(635185, 134, '2015-01-01 01:01:30.000000', 'consum', 0.0217, 'lps'),
	(635186, 134, '2015-01-01 01:01:31.000000', 'consum', 0.0220, 'lps'),
	(635187, 134, '2015-01-01 01:01:32.000000', 'consum', 0.0237, 'lps'),
	(635188, 134, '2015-01-01 01:01:33.000000', 'consum', 0.0227, 'lps'),
	(635189, 134, '2015-01-01 01:01:34.000000', 'consum', 0.0213, 'lps'),
	(635190, 134, '2015-01-01 01:01:35.000000', 'consum', 0.0220, 'lps'),
	(635191, 134, '2015-01-01 01:01:36.000000', 'consum', 0.0251, 'lps'),
	(635192, 134, '2015-01-01 01:01:37.000000', 'consum', 0.0251, 'lps'),
	(635193, 134, '2015-01-01 01:01:38.000000', 'consum', 0.0247, 'lps'),
	(635194, 134, '2015-01-01 01:01:39.000000', 'consum', 0.0228, 'lps'),
	(635195, 134, '2015-01-01 01:01:40.000000', 'consum', 0.0233, 'lps'),
	(635196, 134, '2015-01-01 01:01:41.000000', 'consum', 0.0228, 'lps'),
	(635197, 134, '2015-01-01 01:01:42.000000', 'consum', 0.0229, 'lps'),
	(635198, 134, '2015-01-01 01:01:43.000000', 'consum', 0.0253, 'lps'),
	(635199, 134, '2015-01-01 01:01:44.000000', 'consum', 0.0234, 'lps'),
	(635200, 134, '2015-01-01 01:01:45.000000', 'consum', 0.0246, 'lps'),
	(635201, 134, '2015-01-01 01:01:46.000000', 'consum', 0.0226, 'lps'),
	(635202, 134, '2015-01-01 01:01:47.000000', 'consum', 0.0231, 'lps'),
	(635203, 134, '2015-01-01 01:01:48.000000', 'consum', 0.0223, 'lps'),
	(635204, 134, '2015-01-01 01:01:49.000000', 'consum', 0.0212, 'lps'),
	(635205, 134, '2015-01-01 01:01:50.000000', 'consum', 0.0227, 'lps'),
	(635206, 134, '2015-01-01 01:01:51.000000', 'consum', 0.0242, 'lps'),
	(635207, 134, '2015-01-01 01:01:52.000000', 'consum', 0.0231, 'lps'),
	(635208, 134, '2015-01-01 01:01:53.000000', 'consum', 0.0220, 'lps'),
	(635209, 134, '2015-01-01 01:01:54.000000', 'consum', 0.0242, 'lps'),
	(635210, 134, '2015-01-01 01:01:55.000000', 'consum', 0.0251, 'lps'),
	(635211, 134, '2015-01-01 01:01:56.000000', 'consum', 0.0228, 'lps'),
	(635212, 134, '2015-01-01 01:01:57.000000', 'consum', 0.0223, 'lps'),
	(635213, 134, '2015-01-01 01:01:58.000000', 'consum', 0.0222, 'lps'),
	(635214, 134, '2015-01-01 01:01:59.000000', 'consum', 0.0233, 'lps'),
	(635215, 134, '2015-01-01 01:02:00.000000', 'consum', 0.0242, 'lps'),
	(635216, 134, '2015-01-01 01:02:01.000000', 'consum', 0.0212, 'lps'),
	(635217, 134, '2015-01-01 01:02:02.000000', 'consum', 0.0213, 'lps'),
	(635218, 134, '2015-01-01 01:02:03.000000', 'consum', 0.0223, 'lps'),
	(635219, 134, '2015-01-01 01:02:04.000000', 'consum', 0.0219, 'lps'),
	(635220, 134, '2015-01-01 01:02:05.000000', 'consum', 0.0217, 'lps'),
	(635221, 134, '2015-01-01 01:02:06.000000', 'consum', 0.0220, 'lps'),
	(635222, 134, '2015-01-01 01:02:07.000000', 'consum', 0.0239, 'lps'),
	(635223, 134, '2015-01-01 01:02:08.000000', 'consum', 0.0236, 'lps'),
	(635224, 134, '2015-01-01 01:02:09.000000', 'consum', 0.0252, 'lps'),
	(635225, 134, '2015-01-01 01:02:10.000000', 'consum', 0.0254, 'lps'),
	(635226, 134, '2015-01-01 01:02:11.000000', 'consum', 0.0216, 'lps'),
	(635227, 134, '2015-01-01 01:02:12.000000', 'consum', 0.0242, 'lps'),
	(635228, 134, '2015-01-01 01:02:13.000000', 'consum', 0.0215, 'lps'),
	(635229, 134, '2015-01-01 01:02:14.000000', 'consum', 0.0233, 'lps'),
	(635230, 134, '2015-01-01 01:02:15.000000', 'consum', 0.0220, 'lps'),
	(635231, 134, '2015-01-01 01:02:16.000000', 'consum', 0.0238, 'lps'),
	(635232, 134, '2015-01-01 01:02:17.000000', 'consum', 0.0228, 'lps'),
	(635233, 134, '2015-01-01 01:02:18.000000', 'consum', 0.0217, 'lps'),
	(635234, 134, '2015-01-01 01:02:19.000000', 'consum', 0.0237, 'lps'),
	(635235, 134, '2015-01-01 01:02:20.000000', 'consum', 0.0233, 'lps'),
	(635236, 134, '2015-01-01 01:02:21.000000', 'consum', 0.0245, 'lps'),
	(635237, 134, '2015-01-01 01:02:22.000000', 'consum', 0.0225, 'lps'),
	(635238, 134, '2015-01-01 01:02:23.000000', 'consum', 0.0226, 'lps'),
	(635239, 134, '2015-01-01 01:02:24.000000', 'consum', 0.0248, 'lps'),
	(635240, 134, '2015-01-01 01:02:25.000000', 'consum', 0.0215, 'lps'),
	(635241, 134, '2015-01-01 01:02:26.000000', 'consum', 0.0214, 'lps'),
	(635242, 134, '2015-01-01 01:02:27.000000', 'consum', 0.0213, 'lps'),
	(635243, 134, '2015-01-01 01:02:28.000000', 'consum', 0.0214, 'lps'),
	(635244, 134, '2015-01-01 01:02:29.000000', 'consum', 0.0220, 'lps'),
	(635245, 134, '2015-01-01 01:02:30.000000', 'consum', 0.0249, 'lps'),
	(635246, 134, '2015-01-01 01:02:31.000000', 'consum', 0.0242, 'lps'),
	(635247, 134, '2015-01-01 01:02:32.000000', 'consum', 0.0251, 'lps'),
	(635248, 134, '2015-01-01 01:02:33.000000', 'consum', 0.0233, 'lps'),
	(635249, 134, '2015-01-01 01:02:34.000000', 'consum', 0.0245, 'lps'),
	(635250, 134, '2015-01-01 01:02:35.000000', 'consum', 0.0226, 'lps'),
	(635251, 134, '2015-01-01 01:02:36.000000', 'consum', 0.0233, 'lps'),
	(635252, 134, '2015-01-01 01:02:37.000000', 'consum', 0.0230, 'lps'),
	(635253, 134, '2015-01-01 01:02:38.000000', 'consum', 0.0244, 'lps'),
	(635254, 134, '2015-01-01 01:02:39.000000', 'consum', 0.0229, 'lps'),
	(635255, 134, '2015-01-01 01:02:40.000000', 'consum', 0.0250, 'lps'),
	(635256, 134, '2015-01-01 01:02:41.000000', 'consum', 0.0219, 'lps'),
	(635257, 134, '2015-01-01 01:02:42.000000', 'consum', 0.0226, 'lps'),
	(635258, 134, '2015-01-01 01:02:43.000000', 'consum', 0.0219, 'lps'),
	(635259, 134, '2015-01-01 01:02:44.000000', 'consum', 0.0253, 'lps'),
	(635260, 134, '2015-01-01 01:02:45.000000', 'consum', 0.0216, 'lps'),
	(635261, 134, '2015-01-01 01:02:46.000000', 'consum', 0.0246, 'lps'),
	(635262, 134, '2015-01-01 01:02:47.000000', 'consum', 0.0239, 'lps'),
	(635263, 134, '2015-01-01 01:02:48.000000', 'consum', 0.0246, 'lps'),
	(635264, 134, '2015-01-01 01:02:49.000000', 'consum', 0.0213, 'lps'),
	(635265, 134, '2015-01-01 01:02:50.000000', 'consum', 0.0254, 'lps'),
	(635266, 134, '2015-01-01 01:02:51.000000', 'consum', 0.0239, 'lps'),
	(635267, 134, '2015-01-01 01:02:52.000000', 'consum', 0.0227, 'lps'),
	(635268, 134, '2015-01-01 01:02:53.000000', 'consum', 0.0251, 'lps'),
	(635269, 134, '2015-01-01 01:02:54.000000', 'consum', 0.0231, 'lps'),
	(635270, 134, '2015-01-01 01:02:55.000000', 'consum', 0.0239, 'lps'),
	(635271, 134, '2015-01-01 01:02:56.000000', 'consum', 0.0245, 'lps'),
	(635272, 134, '2015-01-01 01:02:57.000000', 'consum', 0.0253, 'lps'),
	(635273, 134, '2015-01-01 01:02:58.000000', 'consum', 0.0230, 'lps'),
	(635274, 134, '2015-01-01 01:02:59.000000', 'consum', 0.0227, 'lps'),
	(635275, 134, '2015-01-01 01:03:00.000000', 'consum', 0.0235, 'lps'),
	(635276, 134, '2015-01-01 01:03:01.000000', 'consum', 0.0239, 'lps'),
	(635277, 134, '2015-01-01 01:03:02.000000', 'consum', 0.0238, 'lps'),
	(635278, 134, '2015-01-01 01:03:03.000000', 'consum', 0.0218, 'lps'),
	(635279, 134, '2015-01-01 01:03:04.000000', 'consum', 0.0212, 'lps'),
	(635280, 134, '2015-01-01 01:03:05.000000', 'consum', 0.0241, 'lps'),
	(635281, 134, '2015-01-01 01:03:06.000000', 'consum', 0.0226, 'lps'),
	(635282, 134, '2015-01-01 01:03:07.000000', 'consum', 0.0243, 'lps'),
	(635283, 134, '2015-01-01 01:03:08.000000', 'consum', 0.0237, 'lps'),
	(635284, 134, '2015-01-01 01:03:09.000000', 'consum', 0.0247, 'lps'),
	(635285, 134, '2015-01-01 01:03:10.000000', 'consum', 0.0224, 'lps'),
	(635286, 134, '2015-01-01 01:03:11.000000', 'consum', 0.0216, 'lps'),
	(635287, 134, '2015-01-01 01:03:12.000000', 'consum', 0.0241, 'lps'),
	(635288, 134, '2015-01-01 01:03:13.000000', 'consum', 0.0214, 'lps'),
	(635289, 134, '2015-01-01 01:03:14.000000', 'consum', 0.0226, 'lps'),
	(635290, 134, '2015-01-01 01:03:15.000000', 'consum', 0.0234, 'lps'),
	(635291, 134, '2015-01-01 01:03:16.000000', 'consum', 0.0239, 'lps'),
	(635292, 134, '2015-01-01 01:03:17.000000', 'consum', 0.0236, 'lps'),
	(635293, 134, '2015-01-01 01:03:18.000000', 'consum', 0.0212, 'lps'),
	(635294, 134, '2015-01-01 01:03:19.000000', 'consum', 0.0229, 'lps'),
	(635295, 134, '2015-01-01 01:03:20.000000', 'consum', 0.0212, 'lps'),
	(635296, 134, '2015-01-01 01:03:21.000000', 'consum', 0.0251, 'lps'),
	(635297, 134, '2015-01-01 01:03:22.000000', 'consum', 0.0232, 'lps'),
	(635298, 134, '2015-01-01 01:03:23.000000', 'consum', 0.0240, 'lps'),
	(635299, 134, '2015-01-01 01:03:24.000000', 'consum', 0.0250, 'lps'),
	(635300, 134, '2015-01-01 01:03:25.000000', 'consum', 0.0232, 'lps'),
	(635301, 134, '2015-01-01 01:03:26.000000', 'consum', 0.0246, 'lps'),
	(635302, 134, '2015-01-01 01:03:27.000000', 'consum', 0.0236, 'lps'),
	(635303, 134, '2015-01-01 01:03:28.000000', 'consum', 0.0229, 'lps'),
	(635304, 134, '2015-01-01 01:03:29.000000', 'consum', 0.0229, 'lps'),
	(635305, 134, '2015-01-01 01:03:30.000000', 'consum', 0.0247, 'lps'),
	(635306, 134, '2015-01-01 01:03:31.000000', 'consum', 0.0250, 'lps'),
	(635307, 134, '2015-01-01 01:03:32.000000', 'consum', 0.0254, 'lps'),
	(635308, 134, '2015-01-01 01:03:33.000000', 'consum', 0.0221, 'lps'),
	(635309, 134, '2015-01-01 01:03:34.000000', 'consum', 0.0222, 'lps'),
	(635310, 134, '2015-01-01 01:03:35.000000', 'consum', 0.0239, 'lps'),
	(635311, 134, '2015-01-01 01:03:36.000000', 'consum', 0.0230, 'lps'),
	(635312, 134, '2015-01-01 01:03:37.000000', 'consum', 0.0222, 'lps'),
	(635313, 134, '2015-01-01 01:03:38.000000', 'consum', 0.0210, 'lps'),
	(635314, 134, '2015-01-01 01:03:39.000000', 'consum', 0.0218, 'lps'),
	(635315, 134, '2015-01-01 01:03:40.000000', 'consum', 0.0254, 'lps'),
	(635316, 134, '2015-01-01 01:03:41.000000', 'consum', 0.0223, 'lps'),
	(635317, 134, '2015-01-01 01:03:42.000000', 'consum', 0.0236, 'lps'),
	(635318, 134, '2015-01-01 01:03:43.000000', 'consum', 0.0213, 'lps'),
	(635319, 134, '2015-01-01 01:03:44.000000', 'consum', 0.0236, 'lps'),
	(635320, 134, '2015-01-01 01:03:45.000000', 'consum', 0.0239, 'lps'),
	(635321, 134, '2015-01-01 01:03:46.000000', 'consum', 0.0236, 'lps'),
	(635322, 134, '2015-01-01 01:03:47.000000', 'consum', 0.0253, 'lps'),
	(635323, 134, '2015-01-01 01:03:48.000000', 'consum', 0.0211, 'lps'),
	(635324, 134, '2015-01-01 01:03:49.000000', 'consum', 0.0223, 'lps'),
	(635325, 134, '2015-01-01 01:03:50.000000', 'consum', 0.0228, 'lps'),
	(635326, 134, '2015-01-01 01:03:51.000000', 'consum', 0.0214, 'lps'),
	(635327, 134, '2015-01-01 01:03:52.000000', 'consum', 0.0224, 'lps'),
	(635328, 134, '2015-01-01 01:03:53.000000', 'consum', 0.0223, 'lps'),
	(635329, 134, '2015-01-01 01:03:54.000000', 'consum', 0.0233, 'lps'),
	(635330, 134, '2015-01-01 01:03:55.000000', 'consum', 0.0241, 'lps'),
	(635331, 134, '2015-01-01 01:03:56.000000', 'consum', 0.0252, 'lps'),
	(635332, 134, '2015-01-01 01:03:57.000000', 'consum', 0.0238, 'lps'),
	(635333, 134, '2015-01-01 01:03:58.000000', 'consum', 0.0225, 'lps'),
	(635334, 134, '2015-01-01 01:03:59.000000', 'consum', 0.0245, 'lps'),
	(635335, 134, '2015-01-01 01:04:00.000000', 'consum', 0.0250, 'lps'),
	(635336, 134, '2015-01-01 01:04:01.000000', 'consum', 0.0218, 'lps'),
	(635337, 134, '2015-01-01 01:04:02.000000', 'consum', 0.0218, 'lps'),
	(635338, 134, '2015-01-01 01:04:03.000000', 'consum', 0.0225, 'lps'),
	(635339, 134, '2015-01-01 01:04:04.000000', 'consum', 0.0220, 'lps'),
	(635340, 134, '2015-01-01 01:04:05.000000', 'consum', 0.0214, 'lps'),
	(635341, 134, '2015-01-01 01:04:06.000000', 'consum', 0.0247, 'lps'),
	(635342, 134, '2015-01-01 01:04:07.000000', 'consum', 0.0249, 'lps'),
	(635343, 134, '2015-01-01 01:04:08.000000', 'consum', 0.0251, 'lps'),
	(635344, 134, '2015-01-01 01:04:09.000000', 'consum', 0.0250, 'lps'),
	(635345, 134, '2015-01-01 01:04:10.000000', 'consum', 0.0244, 'lps'),
	(635346, 134, '2015-01-01 01:04:11.000000', 'consum', 0.0216, 'lps'),
	(635347, 134, '2015-01-01 01:04:12.000000', 'consum', 0.0226, 'lps'),
	(635348, 134, '2015-01-01 01:04:13.000000', 'consum', 0.0228, 'lps'),
	(635349, 134, '2015-01-01 01:04:14.000000', 'consum', 0.0210, 'lps'),
	(635350, 134, '2015-01-01 01:04:15.000000', 'consum', 0.0244, 'lps'),
	(635351, 134, '2015-01-01 01:04:16.000000', 'consum', 0.0248, 'lps'),
	(635352, 134, '2015-01-01 01:04:17.000000', 'consum', 0.0252, 'lps'),
	(635353, 134, '2015-01-01 01:04:18.000000', 'consum', 0.0215, 'lps'),
	(635354, 134, '2015-01-01 01:04:19.000000', 'consum', 0.0247, 'lps'),
	(635355, 134, '2015-01-01 01:04:20.000000', 'consum', 0.0245, 'lps'),
	(635356, 134, '2015-01-01 01:04:21.000000', 'consum', 0.0230, 'lps'),
	(635357, 134, '2015-01-01 01:04:22.000000', 'consum', 0.0250, 'lps'),
	(635358, 134, '2015-01-01 01:04:23.000000', 'consum', 0.0216, 'lps'),
	(635359, 134, '2015-01-01 01:04:24.000000', 'consum', 0.0212, 'lps'),
	(635360, 134, '2015-01-01 01:04:25.000000', 'consum', 0.0244, 'lps'),
	(635361, 134, '2015-01-01 01:04:26.000000', 'consum', 0.0242, 'lps'),
	(635362, 134, '2015-01-01 01:04:27.000000', 'consum', 0.0224, 'lps'),
	(635363, 134, '2015-01-01 01:04:28.000000', 'consum', 0.0228, 'lps'),
	(635364, 134, '2015-01-01 01:04:29.000000', 'consum', 0.0215, 'lps'),
	(635365, 134, '2015-01-01 01:04:30.000000', 'consum', 0.0224, 'lps'),
	(635366, 134, '2015-01-01 01:04:31.000000', 'consum', 0.0224, 'lps'),
	(635367, 134, '2015-01-01 01:04:32.000000', 'consum', 0.0235, 'lps'),
	(635368, 134, '2015-01-01 01:04:33.000000', 'consum', 0.0249, 'lps'),
	(635369, 134, '2015-01-01 01:04:34.000000', 'consum', 0.0243, 'lps'),
	(635370, 134, '2015-01-01 01:04:35.000000', 'consum', 0.0213, 'lps'),
	(635371, 134, '2015-01-01 01:04:36.000000', 'consum', 0.0215, 'lps'),
	(635372, 134, '2015-01-01 01:04:37.000000', 'consum', 0.0227, 'lps'),
	(635373, 134, '2015-01-01 01:04:38.000000', 'consum', 0.0236, 'lps'),
	(635374, 134, '2015-01-01 01:04:39.000000', 'consum', 0.0244, 'lps'),
	(635375, 134, '2015-01-01 01:04:40.000000', 'consum', 0.0211, 'lps'),
	(635376, 134, '2015-01-01 01:04:41.000000', 'consum', 0.0251, 'lps'),
	(635377, 134, '2015-01-01 01:04:42.000000', 'consum', 0.0231, 'lps'),
	(635378, 134, '2015-01-01 01:04:43.000000', 'consum', 0.0239, 'lps'),
	(635379, 134, '2015-01-01 01:04:44.000000', 'consum', 0.0246, 'lps'),
	(635380, 134, '2015-01-01 01:04:45.000000', 'consum', 0.0213, 'lps'),
	(635381, 134, '2015-01-01 01:04:46.000000', 'consum', 0.0252, 'lps'),
	(635382, 134, '2015-01-01 01:04:47.000000', 'consum', 0.0231, 'lps'),
	(635383, 134, '2015-01-01 01:04:48.000000', 'consum', 0.0234, 'lps'),
	(635384, 134, '2015-01-01 01:04:49.000000', 'consum', 0.0224, 'lps'),
	(635385, 134, '2015-01-01 01:04:50.000000', 'consum', 0.0253, 'lps'),
	(635386, 134, '2015-01-01 01:04:51.000000', 'consum', 0.0250, 'lps'),
	(635387, 134, '2015-01-01 01:04:52.000000', 'consum', 0.0237, 'lps'),
	(635388, 134, '2015-01-01 01:04:53.000000', 'consum', 0.0226, 'lps'),
	(635389, 134, '2015-01-01 01:04:54.000000', 'consum', 0.0254, 'lps'),
	(635390, 134, '2015-01-01 01:04:55.000000', 'consum', 0.0245, 'lps'),
	(635391, 134, '2015-01-01 01:04:56.000000', 'consum', 0.0211, 'lps'),
	(635392, 134, '2015-01-01 01:04:57.000000', 'consum', 0.0245, 'lps'),
	(635393, 134, '2015-01-01 01:04:58.000000', 'consum', 0.0247, 'lps'),
	(635394, 134, '2015-01-01 01:04:59.000000', 'consum', 0.0247, 'lps'),
	(635395, 134, '2015-01-01 01:05:00.000000', 'consum', 0.0241, 'lps'),
	(635396, 134, '2015-01-01 01:05:01.000000', 'consum', 0.0252, 'lps'),
	(635397, 134, '2015-01-01 01:05:02.000000', 'consum', 0.0237, 'lps'),
	(635398, 134, '2015-01-01 01:05:03.000000', 'consum', 0.0219, 'lps'),
	(635399, 134, '2015-01-01 01:05:04.000000', 'consum', 0.0219, 'lps'),
	(635400, 134, '2015-01-01 01:05:05.000000', 'consum', 0.0228, 'lps'),
	(635401, 134, '2015-01-01 01:05:06.000000', 'consum', 0.0228, 'lps'),
	(635402, 134, '2015-01-01 01:05:07.000000', 'consum', 0.0248, 'lps'),
	(635403, 134, '2015-01-01 01:05:08.000000', 'consum', 0.0212, 'lps'),
	(635404, 134, '2015-01-01 01:05:09.000000', 'consum', 0.0242, 'lps'),
	(635405, 134, '2015-01-01 01:05:10.000000', 'consum', 0.0229, 'lps'),
	(635406, 134, '2015-01-01 01:05:11.000000', 'consum', 0.0254, 'lps'),
	(635407, 134, '2015-01-01 01:05:12.000000', 'consum', 0.0239, 'lps'),
	(635408, 134, '2015-01-01 01:05:13.000000', 'consum', 0.0225, 'lps'),
	(635409, 134, '2015-01-01 01:05:14.000000', 'consum', 0.0243, 'lps'),
	(635410, 134, '2015-01-01 01:05:15.000000', 'consum', 0.0240, 'lps'),
	(635411, 134, '2015-01-01 01:05:16.000000', 'consum', 0.0218, 'lps'),
	(635412, 134, '2015-01-01 01:05:17.000000', 'consum', 0.0248, 'lps'),
	(635413, 134, '2015-01-01 01:05:18.000000', 'consum', 0.0244, 'lps'),
	(635414, 134, '2015-01-01 01:05:19.000000', 'consum', 0.0221, 'lps'),
	(635415, 134, '2015-01-01 01:05:20.000000', 'consum', 0.0251, 'lps'),
	(635416, 134, '2015-01-01 01:05:21.000000', 'consum', 0.0249, 'lps'),
	(635417, 134, '2015-01-01 01:05:22.000000', 'consum', 0.0239, 'lps'),
	(635418, 134, '2015-01-01 01:05:23.000000', 'consum', 0.0235, 'lps'),
	(635419, 134, '2015-01-01 01:05:24.000000', 'consum', 0.0252, 'lps'),
	(635420, 134, '2015-01-01 01:05:25.000000', 'consum', 0.0210, 'lps'),
	(635421, 134, '2015-01-01 01:05:26.000000', 'consum', 0.0220, 'lps'),
	(635422, 134, '2015-01-01 01:05:27.000000', 'consum', 0.0214, 'lps'),
	(635423, 134, '2015-01-01 01:05:28.000000', 'consum', 0.0245, 'lps'),
	(635424, 134, '2015-01-01 01:05:29.000000', 'consum', 0.0238, 'lps'),
	(635425, 134, '2015-01-01 01:05:30.000000', 'consum', 0.0246, 'lps'),
	(635426, 134, '2015-01-01 01:05:31.000000', 'consum', 0.0217, 'lps'),
	(635427, 134, '2015-01-01 01:05:32.000000', 'consum', 0.0229, 'lps'),
	(635428, 134, '2015-01-01 01:05:33.000000', 'consum', 0.0240, 'lps'),
	(635429, 134, '2015-01-01 01:05:34.000000', 'consum', 0.0213, 'lps'),
	(635430, 134, '2015-01-01 01:05:35.000000', 'consum', 0.0227, 'lps'),
	(635431, 134, '2015-01-01 01:05:36.000000', 'consum', 0.0239, 'lps'),
	(635432, 134, '2015-01-01 01:05:37.000000', 'consum', 0.0214, 'lps'),
	(635433, 134, '2015-01-01 01:05:38.000000', 'consum', 0.0236, 'lps'),
	(635434, 134, '2015-01-01 01:05:39.000000', 'consum', 0.0237, 'lps'),
	(635435, 134, '2015-01-01 01:05:40.000000', 'consum', 0.0223, 'lps'),
	(635436, 134, '2015-01-01 01:05:41.000000', 'consum', 0.0241, 'lps'),
	(635437, 134, '2015-01-01 01:05:42.000000', 'consum', 0.0237, 'lps'),
	(635438, 134, '2015-01-01 01:05:43.000000', 'consum', 0.0252, 'lps'),
	(635439, 134, '2015-01-01 01:05:44.000000', 'consum', 0.0248, 'lps'),
	(635440, 134, '2015-01-01 01:05:45.000000', 'consum', 0.0231, 'lps'),
	(635441, 134, '2015-01-01 01:05:46.000000', 'consum', 0.0246, 'lps'),
	(635442, 134, '2015-01-01 01:05:47.000000', 'consum', 0.0238, 'lps'),
	(635443, 134, '2015-01-01 01:05:48.000000', 'consum', 0.0244, 'lps'),
	(635444, 134, '2015-01-01 01:05:49.000000', 'consum', 0.0249, 'lps'),
	(635445, 134, '2015-01-01 01:05:50.000000', 'consum', 0.0214, 'lps'),
	(635446, 134, '2015-01-01 01:05:51.000000', 'consum', 0.0249, 'lps'),
	(635447, 134, '2015-01-01 01:05:52.000000', 'consum', 0.0212, 'lps'),
	(635448, 134, '2015-01-01 01:05:53.000000', 'consum', 0.0241, 'lps'),
	(635449, 134, '2015-01-01 01:05:54.000000', 'consum', 0.0224, 'lps'),
	(635450, 134, '2015-01-01 01:05:55.000000', 'consum', 0.0231, 'lps'),
	(635451, 134, '2015-01-01 01:05:56.000000', 'consum', 0.0230, 'lps'),
	(635452, 134, '2015-01-01 01:05:57.000000', 'consum', 0.0248, 'lps'),
	(635453, 134, '2015-01-01 01:05:58.000000', 'consum', 0.0248, 'lps'),
	(635454, 134, '2015-01-01 01:05:59.000000', 'consum', 0.0245, 'lps'),
	(635455, 134, '2015-01-01 01:06:00.000000', 'consum', 0.0223, 'lps'),
	(635456, 134, '2015-01-01 01:06:01.000000', 'consum', 0.0218, 'lps'),
	(635457, 134, '2015-01-01 01:06:02.000000', 'consum', 0.0210, 'lps'),
	(635458, 134, '2015-01-01 01:06:03.000000', 'consum', 0.0231, 'lps'),
	(635459, 134, '2015-01-01 01:06:04.000000', 'consum', 0.0225, 'lps'),
	(635460, 134, '2015-01-01 01:06:05.000000', 'consum', 0.0223, 'lps'),
	(635461, 134, '2015-01-01 01:06:06.000000', 'consum', 0.0229, 'lps'),
	(635462, 134, '2015-01-01 01:06:07.000000', 'consum', 0.0223, 'lps'),
	(635463, 134, '2015-01-01 01:06:08.000000', 'consum', 0.0220, 'lps'),
	(635464, 134, '2015-01-01 01:06:09.000000', 'consum', 0.0220, 'lps'),
	(635465, 134, '2015-01-01 01:06:10.000000', 'consum', 0.0232, 'lps'),
	(635466, 134, '2015-01-01 01:06:11.000000', 'consum', 0.0245, 'lps'),
	(635467, 134, '2015-01-01 01:06:12.000000', 'consum', 0.0231, 'lps'),
	(635468, 134, '2015-01-01 01:06:13.000000', 'consum', 0.0210, 'lps'),
	(635469, 134, '2015-01-01 01:06:14.000000', 'consum', 0.0236, 'lps'),
	(635470, 134, '2015-01-01 01:06:15.000000', 'consum', 0.0251, 'lps'),
	(635471, 134, '2015-01-01 01:06:16.000000', 'consum', 0.0248, 'lps'),
	(635472, 134, '2015-01-01 01:06:17.000000', 'consum', 0.0233, 'lps'),
	(635473, 134, '2015-01-01 01:06:18.000000', 'consum', 0.0254, 'lps'),
	(635474, 134, '2015-01-01 01:06:19.000000', 'consum', 0.0228, 'lps'),
	(635475, 134, '2015-01-01 01:06:20.000000', 'consum', 0.0213, 'lps'),
	(635476, 134, '2015-01-01 01:06:21.000000', 'consum', 0.0215, 'lps'),
	(635477, 134, '2015-01-01 01:06:22.000000', 'consum', 0.0227, 'lps'),
	(635478, 134, '2015-01-01 01:06:23.000000', 'consum', 0.0234, 'lps'),
	(635479, 134, '2015-01-01 01:06:24.000000', 'consum', 0.0237, 'lps'),
	(635480, 134, '2015-01-01 01:06:25.000000', 'consum', 0.0229, 'lps'),
	(635481, 134, '2015-01-01 01:06:26.000000', 'consum', 0.0225, 'lps'),
	(635482, 134, '2015-01-01 01:06:27.000000', 'consum', 0.0228, 'lps'),
	(635483, 134, '2015-01-01 01:06:28.000000', 'consum', 0.0211, 'lps'),
	(635484, 134, '2015-01-01 01:06:29.000000', 'consum', 0.0253, 'lps'),
	(635485, 134, '2015-01-01 01:06:30.000000', 'consum', 0.0240, 'lps'),
	(635486, 134, '2015-01-01 01:06:31.000000', 'consum', 0.0234, 'lps'),
	(635487, 134, '2015-01-01 01:06:32.000000', 'consum', 0.0237, 'lps'),
	(635488, 134, '2015-01-01 01:06:33.000000', 'consum', 0.0231, 'lps'),
	(635489, 134, '2015-01-01 01:06:34.000000', 'consum', 0.0236, 'lps'),
	(635490, 134, '2015-01-01 01:06:35.000000', 'consum', 0.0231, 'lps'),
	(635491, 134, '2015-01-01 01:06:36.000000', 'consum', 0.0236, 'lps'),
	(635492, 134, '2015-01-01 01:06:37.000000', 'consum', 0.0235, 'lps'),
	(635493, 134, '2015-01-01 01:06:38.000000', 'consum', 0.0211, 'lps'),
	(635494, 134, '2015-01-01 01:06:39.000000', 'consum', 0.0231, 'lps'),
	(635495, 134, '2015-01-01 01:06:40.000000', 'consum', 0.0221, 'lps'),
	(635496, 134, '2015-01-01 01:06:41.000000', 'consum', 0.0250, 'lps'),
	(635497, 134, '2015-01-01 01:06:42.000000', 'consum', 0.0241, 'lps'),
	(635498, 134, '2015-01-01 01:06:43.000000', 'consum', 0.0244, 'lps'),
	(635499, 134, '2015-01-01 01:06:44.000000', 'consum', 0.0244, 'lps'),
	(635500, 134, '2015-01-01 01:06:45.000000', 'consum', 0.0234, 'lps'),
	(635501, 134, '2015-01-01 01:06:46.000000', 'consum', 0.0230, 'lps'),
	(635502, 134, '2015-01-01 01:06:47.000000', 'consum', 0.0235, 'lps'),
	(635503, 134, '2015-01-01 01:06:48.000000', 'consum', 0.0233, 'lps'),
	(635504, 134, '2015-01-01 01:06:49.000000', 'consum', 0.0251, 'lps'),
	(635505, 134, '2015-01-01 01:06:50.000000', 'consum', 0.0210, 'lps'),
	(635506, 134, '2015-01-01 01:06:51.000000', 'consum', 0.0221, 'lps'),
	(635507, 134, '2015-01-01 01:06:52.000000', 'consum', 0.0222, 'lps'),
	(635508, 134, '2015-01-01 01:06:53.000000', 'consum', 0.0236, 'lps'),
	(635509, 134, '2015-01-01 01:06:54.000000', 'consum', 0.0216, 'lps'),
	(635510, 134, '2015-01-01 01:06:55.000000', 'consum', 0.0254, 'lps'),
	(635511, 134, '2015-01-01 01:06:56.000000', 'consum', 0.0230, 'lps'),
	(635512, 134, '2015-01-01 01:06:57.000000', 'consum', 0.0225, 'lps'),
	(635513, 134, '2015-01-01 01:06:58.000000', 'consum', 0.0225, 'lps'),
	(635514, 134, '2015-01-01 01:06:59.000000', 'consum', 0.0241, 'lps'),
	(635515, 134, '2015-01-01 01:07:00.000000', 'consum', 0.0231, 'lps'),
	(635516, 134, '2015-01-01 01:07:01.000000', 'consum', 0.0223, 'lps'),
	(635517, 134, '2015-01-01 01:07:02.000000', 'consum', 0.0212, 'lps'),
	(635518, 134, '2015-01-01 01:07:03.000000', 'consum', 0.0227, 'lps'),
	(635519, 134, '2015-01-01 01:07:04.000000', 'consum', 0.0245, 'lps'),
	(635520, 134, '2015-01-01 01:07:05.000000', 'consum', 0.0244, 'lps'),
	(635521, 134, '2015-01-01 01:07:06.000000', 'consum', 0.0232, 'lps'),
	(635522, 134, '2015-01-01 01:07:07.000000', 'consum', 0.0218, 'lps'),
	(635523, 134, '2015-01-01 01:07:08.000000', 'consum', 0.0228, 'lps'),
	(635524, 134, '2015-01-01 01:07:09.000000', 'consum', 0.0233, 'lps'),
	(635525, 134, '2015-01-01 01:07:10.000000', 'consum', 0.0226, 'lps'),
	(635526, 134, '2015-01-01 01:07:11.000000', 'consum', 0.0221, 'lps'),
	(635527, 134, '2015-01-01 01:07:12.000000', 'consum', 0.0220, 'lps'),
	(635528, 134, '2015-01-01 01:07:13.000000', 'consum', 0.0225, 'lps'),
	(635529, 134, '2015-01-01 01:07:14.000000', 'consum', 0.0211, 'lps'),
	(635530, 134, '2015-01-01 01:07:15.000000', 'consum', 0.0215, 'lps'),
	(635531, 134, '2015-01-01 01:07:16.000000', 'consum', 0.0232, 'lps'),
	(635532, 134, '2015-01-01 01:07:17.000000', 'consum', 0.0216, 'lps'),
	(635533, 134, '2015-01-01 01:07:18.000000', 'consum', 0.0218, 'lps'),
	(635534, 134, '2015-01-01 01:07:19.000000', 'consum', 0.0235, 'lps'),
	(635535, 134, '2015-01-01 01:07:20.000000', 'consum', 0.0222, 'lps'),
	(635536, 134, '2015-01-01 01:07:21.000000', 'consum', 0.0240, 'lps'),
	(635537, 134, '2015-01-01 01:07:22.000000', 'consum', 0.0233, 'lps'),
	(635538, 134, '2015-01-01 01:07:23.000000', 'consum', 0.0237, 'lps'),
	(635539, 134, '2015-01-01 01:07:24.000000', 'consum', 0.0231, 'lps'),
	(635540, 134, '2015-01-01 01:07:25.000000', 'consum', 0.0233, 'lps'),
	(635541, 134, '2015-01-01 01:07:26.000000', 'consum', 0.0220, 'lps'),
	(635542, 134, '2015-01-01 01:07:27.000000', 'consum', 0.0234, 'lps'),
	(635543, 134, '2015-01-01 01:07:28.000000', 'consum', 0.0210, 'lps'),
	(635544, 134, '2015-01-01 01:07:29.000000', 'consum', 0.0228, 'lps'),
	(635545, 134, '2015-01-01 01:07:30.000000', 'consum', 0.0210, 'lps'),
	(635546, 134, '2015-01-01 01:07:31.000000', 'consum', 0.0246, 'lps'),
	(635547, 134, '2015-01-01 01:07:32.000000', 'consum', 0.0211, 'lps'),
	(635548, 134, '2015-01-01 01:07:33.000000', 'consum', 0.0244, 'lps'),
	(635549, 134, '2015-01-01 01:07:34.000000', 'consum', 0.0243, 'lps'),
	(635550, 134, '2015-01-01 01:07:35.000000', 'consum', 0.0229, 'lps'),
	(635551, 134, '2015-01-01 01:07:36.000000', 'consum', 0.0249, 'lps'),
	(635552, 134, '2015-01-01 01:07:37.000000', 'consum', 0.0216, 'lps'),
	(635553, 134, '2015-01-01 01:07:38.000000', 'consum', 0.0213, 'lps'),
	(635554, 134, '2015-01-01 01:07:39.000000', 'consum', 0.0253, 'lps'),
	(635555, 134, '2015-01-01 01:07:40.000000', 'consum', 0.0236, 'lps'),
	(635556, 134, '2015-01-01 01:07:41.000000', 'consum', 0.0210, 'lps'),
	(635557, 134, '2015-01-01 01:07:42.000000', 'consum', 0.0222, 'lps'),
	(635558, 134, '2015-01-01 01:07:43.000000', 'consum', 0.0227, 'lps'),
	(635559, 134, '2015-01-01 01:07:44.000000', 'consum', 0.0212, 'lps'),
	(635560, 134, '2015-01-01 01:07:45.000000', 'consum', 0.0216, 'lps'),
	(635561, 134, '2015-01-01 01:07:46.000000', 'consum', 0.0236, 'lps'),
	(635562, 134, '2015-01-01 01:07:47.000000', 'consum', 0.0232, 'lps'),
	(635563, 134, '2015-01-01 01:07:48.000000', 'consum', 0.0244, 'lps'),
	(635564, 134, '2015-01-01 01:07:49.000000', 'consum', 0.0224, 'lps'),
	(635565, 134, '2015-01-01 01:07:50.000000', 'consum', 0.0223, 'lps'),
	(635566, 134, '2015-01-01 01:07:51.000000', 'consum', 0.0233, 'lps'),
	(635567, 134, '2015-01-01 01:07:52.000000', 'consum', 0.0242, 'lps'),
	(635568, 134, '2015-01-01 01:07:53.000000', 'consum', 0.0212, 'lps'),
	(635569, 134, '2015-01-01 01:07:54.000000', 'consum', 0.0216, 'lps'),
	(635570, 134, '2015-01-01 01:07:55.000000', 'consum', 0.0232, 'lps'),
	(635571, 134, '2015-01-01 01:07:56.000000', 'consum', 0.0212, 'lps'),
	(635572, 134, '2015-01-01 01:07:57.000000', 'consum', 0.0245, 'lps'),
	(635573, 134, '2015-01-01 01:07:58.000000', 'consum', 0.0246, 'lps'),
	(635574, 134, '2015-01-01 01:07:59.000000', 'consum', 0.0238, 'lps'),
	(635575, 134, '2015-01-01 01:08:00.000000', 'consum', 0.0246, 'lps'),
	(635576, 134, '2015-01-01 01:08:01.000000', 'consum', 0.0213, 'lps'),
	(635577, 134, '2015-01-01 01:08:02.000000', 'consum', 0.0253, 'lps'),
	(635578, 134, '2015-01-01 01:08:03.000000', 'consum', 0.0236, 'lps'),
	(635579, 134, '2015-01-01 01:08:04.000000', 'consum', 0.0211, 'lps'),
	(635580, 134, '2015-01-01 01:08:05.000000', 'consum', 0.0229, 'lps'),
	(635581, 134, '2015-01-01 01:08:06.000000', 'consum', 0.0214, 'lps'),
	(635582, 134, '2015-01-01 01:08:07.000000', 'consum', 0.0217, 'lps'),
	(635583, 134, '2015-01-01 01:08:08.000000', 'consum', 0.0233, 'lps'),
	(635584, 134, '2015-01-01 01:08:09.000000', 'consum', 0.0215, 'lps'),
	(635585, 134, '2015-01-01 01:08:10.000000', 'consum', 0.0212, 'lps'),
	(635586, 134, '2015-01-01 01:08:11.000000', 'consum', 0.0249, 'lps'),
	(635587, 134, '2015-01-01 01:08:12.000000', 'consum', 0.0220, 'lps'),
	(635588, 134, '2015-01-01 01:08:13.000000', 'consum', 0.0232, 'lps'),
	(635589, 134, '2015-01-01 01:08:14.000000', 'consum', 0.0249, 'lps'),
	(635590, 134, '2015-01-01 01:08:15.000000', 'consum', 0.0246, 'lps'),
	(635591, 134, '2015-01-01 01:08:16.000000', 'consum', 0.0231, 'lps'),
	(635592, 134, '2015-01-01 01:08:17.000000', 'consum', 0.0250, 'lps'),
	(635593, 134, '2015-01-01 01:08:18.000000', 'consum', 0.0214, 'lps'),
	(635594, 134, '2015-01-01 01:08:19.000000', 'consum', 0.0247, 'lps'),
	(635595, 134, '2015-01-01 01:08:20.000000', 'consum', 0.0246, 'lps'),
	(635596, 134, '2015-01-01 01:08:21.000000', 'consum', 0.0236, 'lps'),
	(635597, 134, '2015-01-01 01:08:22.000000', 'consum', 0.0230, 'lps'),
	(635598, 134, '2015-01-01 01:08:23.000000', 'consum', 0.0234, 'lps'),
	(635599, 134, '2015-01-01 01:08:24.000000', 'consum', 0.0226, 'lps'),
	(635600, 134, '2015-01-01 01:08:25.000000', 'consum', 0.0216, 'lps'),
	(635601, 134, '2015-01-01 01:08:26.000000', 'consum', 0.0240, 'lps'),
	(635602, 134, '2015-01-01 01:08:27.000000', 'consum', 0.0252, 'lps'),
	(635603, 134, '2015-01-01 01:08:28.000000', 'consum', 0.0241, 'lps'),
	(635604, 134, '2015-01-01 01:08:29.000000', 'consum', 0.0240, 'lps'),
	(635605, 134, '2015-01-01 01:08:30.000000', 'consum', 0.0222, 'lps'),
	(635606, 134, '2015-01-01 01:08:31.000000', 'consum', 0.0226, 'lps'),
	(635607, 134, '2015-01-01 01:08:32.000000', 'consum', 0.0252, 'lps'),
	(635608, 134, '2015-01-01 01:08:33.000000', 'consum', 0.0241, 'lps'),
	(635609, 134, '2015-01-01 01:08:34.000000', 'consum', 0.0238, 'lps'),
	(635610, 134, '2015-01-01 01:08:35.000000', 'consum', 0.0214, 'lps'),
	(635611, 134, '2015-01-01 01:08:36.000000', 'consum', 0.0234, 'lps'),
	(635612, 134, '2015-01-01 01:08:37.000000', 'consum', 0.0229, 'lps'),
	(635613, 134, '2015-01-01 01:08:38.000000', 'consum', 0.0232, 'lps'),
	(635614, 134, '2015-01-01 01:08:39.000000', 'consum', 0.0221, 'lps'),
	(635615, 134, '2015-01-01 01:08:40.000000', 'consum', 0.0243, 'lps'),
	(635616, 134, '2015-01-01 01:08:41.000000', 'consum', 0.0210, 'lps'),
	(635617, 134, '2015-01-01 01:08:42.000000', 'consum', 0.0244, 'lps'),
	(635618, 134, '2015-01-01 01:08:43.000000', 'consum', 0.0245, 'lps'),
	(635619, 134, '2015-01-01 01:08:44.000000', 'consum', 0.0238, 'lps'),
	(635620, 134, '2015-01-01 01:08:45.000000', 'consum', 0.0248, 'lps'),
	(635621, 134, '2015-01-01 01:08:46.000000', 'consum', 0.0224, 'lps'),
	(635622, 134, '2015-01-01 01:08:47.000000', 'consum', 0.0214, 'lps'),
	(635623, 134, '2015-01-01 01:08:48.000000', 'consum', 0.0234, 'lps'),
	(635624, 134, '2015-01-01 01:08:49.000000', 'consum', 0.0228, 'lps'),
	(635625, 134, '2015-01-01 01:08:50.000000', 'consum', 0.0226, 'lps'),
	(635626, 134, '2015-01-01 01:08:51.000000', 'consum', 0.0239, 'lps'),
	(635627, 134, '2015-01-01 01:08:52.000000', 'consum', 0.0217, 'lps'),
	(635628, 134, '2015-01-01 01:08:53.000000', 'consum', 0.0247, 'lps'),
	(635629, 134, '2015-01-01 01:08:54.000000', 'consum', 0.0242, 'lps'),
	(635630, 134, '2015-01-01 01:08:55.000000', 'consum', 0.0212, 'lps'),
	(635631, 134, '2015-01-01 01:08:56.000000', 'consum', 0.0216, 'lps'),
	(635632, 134, '2015-01-01 01:08:57.000000', 'consum', 0.0236, 'lps'),
	(635633, 134, '2015-01-01 01:08:58.000000', 'consum', 0.0230, 'lps'),
	(635634, 134, '2015-01-01 01:08:59.000000', 'consum', 0.0232, 'lps'),
	(635635, 134, '2015-01-01 01:09:00.000000', 'consum', 0.0216, 'lps'),
	(635636, 134, '2015-01-01 01:09:01.000000', 'consum', 0.0222, 'lps'),
	(635637, 134, '2015-01-01 01:09:02.000000', 'consum', 0.0251, 'lps'),
	(635638, 134, '2015-01-01 01:09:03.000000', 'consum', 0.0243, 'lps'),
	(635639, 134, '2015-01-01 01:09:04.000000', 'consum', 0.0252, 'lps'),
	(635640, 134, '2015-01-01 01:09:05.000000', 'consum', 0.0232, 'lps'),
	(635641, 134, '2015-01-01 01:09:06.000000', 'consum', 0.0241, 'lps'),
	(635642, 134, '2015-01-01 01:09:07.000000', 'consum', 0.0210, 'lps'),
	(635643, 134, '2015-01-01 01:09:08.000000', 'consum', 0.0250, 'lps'),
	(635644, 134, '2015-01-01 01:09:09.000000', 'consum', 0.0233, 'lps'),
	(635645, 134, '2015-01-01 01:09:10.000000', 'consum', 0.0249, 'lps'),
	(635646, 134, '2015-01-01 01:09:11.000000', 'consum', 0.0245, 'lps'),
	(635647, 134, '2015-01-01 01:09:12.000000', 'consum', 0.0224, 'lps'),
	(635648, 134, '2015-01-01 01:09:13.000000', 'consum', 0.0222, 'lps'),
	(635649, 134, '2015-01-01 01:09:14.000000', 'consum', 0.0229, 'lps'),
	(635650, 134, '2015-01-01 01:09:15.000000', 'consum', 0.0222, 'lps'),
	(635651, 134, '2015-01-01 01:09:16.000000', 'consum', 0.0215, 'lps'),
	(635652, 134, '2015-01-01 01:09:17.000000', 'consum', 0.0246, 'lps'),
	(635653, 134, '2015-01-01 01:09:18.000000', 'consum', 0.0239, 'lps'),
	(635654, 134, '2015-01-01 01:09:19.000000', 'consum', 0.0248, 'lps'),
	(635655, 134, '2015-01-01 01:09:20.000000', 'consum', 0.0221, 'lps'),
	(635656, 134, '2015-01-01 01:09:21.000000', 'consum', 0.0245, 'lps'),
	(635657, 134, '2015-01-01 01:09:22.000000', 'consum', 0.0215, 'lps'),
	(635658, 134, '2015-01-01 01:09:23.000000', 'consum', 0.0223, 'lps'),
	(635659, 134, '2015-01-01 01:09:24.000000', 'consum', 0.0215, 'lps'),
	(635660, 134, '2015-01-01 01:09:25.000000', 'consum', 0.0240, 'lps'),
	(635661, 134, '2015-01-01 01:09:26.000000', 'consum', 0.0212, 'lps'),
	(635662, 134, '2015-01-01 01:09:27.000000', 'consum', 0.0221, 'lps'),
	(635663, 134, '2015-01-01 01:09:28.000000', 'consum', 0.0214, 'lps'),
	(635664, 134, '2015-01-01 01:09:29.000000', 'consum', 0.0240, 'lps'),
	(635665, 134, '2015-01-01 01:09:30.000000', 'consum', 0.0217, 'lps'),
	(635666, 134, '2015-01-01 01:09:31.000000', 'consum', 0.0242, 'lps'),
	(635667, 134, '2015-01-01 01:09:32.000000', 'consum', 0.0217, 'lps'),
	(635668, 134, '2015-01-01 01:09:33.000000', 'consum', 0.0240, 'lps'),
	(635669, 134, '2015-01-01 01:09:34.000000', 'consum', 0.0250, 'lps'),
	(635670, 134, '2015-01-01 01:09:35.000000', 'consum', 0.0230, 'lps'),
	(635671, 134, '2015-01-01 01:09:36.000000', 'consum', 0.0235, 'lps'),
	(635672, 134, '2015-01-01 01:09:37.000000', 'consum', 0.0230, 'lps'),
	(635673, 134, '2015-01-01 01:09:38.000000', 'consum', 0.0234, 'lps'),
	(635674, 134, '2015-01-01 01:09:39.000000', 'consum', 0.0226, 'lps'),
	(635675, 134, '2015-01-01 01:09:40.000000', 'consum', 0.0221, 'lps'),
	(635676, 134, '2015-01-01 01:09:41.000000', 'consum', 0.0217, 'lps'),
	(635677, 134, '2015-01-01 01:09:42.000000', 'consum', 0.0211, 'lps'),
	(635678, 134, '2015-01-01 01:09:43.000000', 'consum', 0.0241, 'lps'),
	(635679, 134, '2015-01-01 01:09:44.000000', 'consum', 0.0226, 'lps'),
	(635680, 134, '2015-01-01 01:09:45.000000', 'consum', 0.0241, 'lps'),
	(635681, 134, '2015-01-01 01:09:46.000000', 'consum', 0.0230, 'lps'),
	(635682, 134, '2015-01-01 01:09:47.000000', 'consum', 0.0216, 'lps'),
	(635683, 134, '2015-01-01 01:09:48.000000', 'consum', 0.0227, 'lps'),
	(635684, 134, '2015-01-01 01:09:49.000000', 'consum', 0.0232, 'lps'),
	(635685, 134, '2015-01-01 01:09:50.000000', 'consum', 0.0226, 'lps'),
	(635686, 134, '2015-01-01 01:09:51.000000', 'consum', 0.0222, 'lps'),
	(635687, 134, '2015-01-01 01:09:52.000000', 'consum', 0.0225, 'lps'),
	(635688, 134, '2015-01-01 01:09:53.000000', 'consum', 0.0251, 'lps'),
	(635689, 134, '2015-01-01 01:09:54.000000', 'consum', 0.0232, 'lps'),
	(635690, 134, '2015-01-01 01:09:55.000000', 'consum', 0.0242, 'lps'),
	(635691, 134, '2015-01-01 01:09:56.000000', 'consum', 0.0215, 'lps'),
	(635692, 134, '2015-01-01 01:09:57.000000', 'consum', 0.0230, 'lps'),
	(635693, 134, '2015-01-01 01:09:58.000000', 'consum', 0.0250, 'lps'),
	(635694, 134, '2015-01-01 01:09:59.000000', 'consum', 0.0214, 'lps'),
	(635695, 134, '2015-01-01 01:10:00.000000', 'consum', 0.0247, 'lps'),
	(635696, 134, '2015-01-01 01:10:01.000000', 'consum', 0.0247, 'lps'),
	(635697, 134, '2015-01-01 01:10:02.000000', 'consum', 0.0239, 'lps'),
	(635698, 134, '2015-01-01 01:10:03.000000', 'consum', 0.0247, 'lps'),
	(635699, 134, '2015-01-01 01:10:04.000000', 'consum', 0.0219, 'lps'),
	(635700, 134, '2015-01-01 01:10:05.000000', 'consum', 0.0236, 'lps'),
	(635701, 134, '2015-01-01 01:10:06.000000', 'consum', 0.0220, 'lps'),
	(635702, 134, '2015-01-01 01:10:07.000000', 'consum', 0.0227, 'lps'),
	(635703, 134, '2015-01-01 01:10:08.000000', 'consum', 0.0221, 'lps'),
	(635704, 134, '2015-01-01 01:10:09.000000', 'consum', 0.0215, 'lps'),
	(635705, 134, '2015-01-01 01:10:10.000000', 'consum', 0.0250, 'lps'),
	(635706, 134, '2015-01-01 01:10:11.000000', 'consum', 0.0212, 'lps'),
	(635707, 134, '2015-01-01 01:10:12.000000', 'consum', 0.0236, 'lps'),
	(635708, 134, '2015-01-01 01:10:13.000000', 'consum', 0.0244, 'lps'),
	(635709, 134, '2015-01-01 01:10:14.000000', 'consum', 0.0212, 'lps'),
	(635710, 134, '2015-01-01 01:10:15.000000', 'consum', 0.0254, 'lps'),
	(635711, 134, '2015-01-01 01:10:16.000000', 'consum', 0.0245, 'lps'),
	(635712, 134, '2015-01-01 01:10:17.000000', 'consum', 0.0253, 'lps'),
	(635713, 134, '2015-01-01 01:10:18.000000', 'consum', 0.0229, 'lps'),
	(635714, 134, '2015-01-01 01:10:19.000000', 'consum', 0.0224, 'lps'),
	(635715, 134, '2015-01-01 01:10:20.000000', 'consum', 0.0221, 'lps'),
	(635716, 134, '2015-01-01 01:10:21.000000', 'consum', 0.0223, 'lps'),
	(635717, 134, '2015-01-01 01:10:22.000000', 'consum', 0.0245, 'lps'),
	(635718, 134, '2015-01-01 01:10:23.000000', 'consum', 0.0254, 'lps'),
	(635719, 134, '2015-01-01 01:10:24.000000', 'consum', 0.0236, 'lps'),
	(635720, 134, '2015-01-01 01:10:25.000000', 'consum', 0.0252, 'lps'),
	(635721, 134, '2015-01-01 01:10:26.000000', 'consum', 0.0253, 'lps'),
	(635722, 134, '2015-01-01 01:10:27.000000', 'consum', 0.0211, 'lps'),
	(635723, 134, '2015-01-01 01:10:28.000000', 'consum', 0.0221, 'lps'),
	(635724, 134, '2015-01-01 01:10:29.000000', 'consum', 0.0216, 'lps'),
	(635725, 134, '2015-01-01 01:10:30.000000', 'consum', 0.0253, 'lps'),
	(635726, 134, '2015-01-01 01:10:31.000000', 'consum', 0.0227, 'lps'),
	(635727, 134, '2015-01-01 01:10:32.000000', 'consum', 0.0212, 'lps'),
	(635728, 134, '2015-01-01 01:10:33.000000', 'consum', 0.0215, 'lps'),
	(635729, 134, '2015-01-01 01:10:34.000000', 'consum', 0.0231, 'lps'),
	(635730, 134, '2015-01-01 01:10:35.000000', 'consum', 0.0252, 'lps'),
	(635731, 134, '2015-01-01 01:10:36.000000', 'consum', 0.0225, 'lps'),
	(635732, 134, '2015-01-01 01:10:37.000000', 'consum', 0.0248, 'lps'),
	(635733, 134, '2015-01-01 01:10:38.000000', 'consum', 0.0222, 'lps'),
	(635734, 134, '2015-01-01 01:10:39.000000', 'consum', 0.0244, 'lps'),
	(635735, 134, '2015-01-01 01:10:40.000000', 'consum', 0.0210, 'lps'),
	(635736, 134, '2015-01-01 01:10:41.000000', 'consum', 0.0245, 'lps'),
	(635737, 134, '2015-01-01 01:10:42.000000', 'consum', 0.0250, 'lps'),
	(635738, 134, '2015-01-01 01:10:43.000000', 'consum', 0.0215, 'lps'),
	(635739, 134, '2015-01-01 01:10:44.000000', 'consum', 0.0249, 'lps'),
	(635740, 134, '2015-01-01 01:10:45.000000', 'consum', 0.0211, 'lps'),
	(635741, 134, '2015-01-01 01:10:46.000000', 'consum', 0.0233, 'lps'),
	(635742, 134, '2015-01-01 01:10:47.000000', 'consum', 0.0233, 'lps'),
	(635743, 134, '2015-01-01 01:10:48.000000', 'consum', 0.0210, 'lps'),
	(635744, 134, '2015-01-01 01:10:49.000000', 'consum', 0.0231, 'lps'),
	(635745, 134, '2015-01-01 01:10:50.000000', 'consum', 0.0228, 'lps'),
	(635746, 134, '2015-01-01 01:10:51.000000', 'consum', 0.0238, 'lps'),
	(635747, 134, '2015-01-01 01:10:52.000000', 'consum', 0.0250, 'lps'),
	(635748, 134, '2015-01-01 01:10:53.000000', 'consum', 0.0238, 'lps'),
	(635749, 134, '2015-01-01 01:10:54.000000', 'consum', 0.0229, 'lps'),
	(635750, 134, '2015-01-01 01:10:55.000000', 'consum', 0.0220, 'lps'),
	(635751, 134, '2015-01-01 01:10:56.000000', 'consum', 0.0250, 'lps'),
	(635752, 134, '2015-01-01 01:10:57.000000', 'consum', 0.0247, 'lps'),
	(635753, 134, '2015-01-01 01:10:58.000000', 'consum', 0.0228, 'lps'),
	(635754, 134, '2015-01-01 01:10:59.000000', 'consum', 0.0235, 'lps'),
	(635755, 134, '2015-01-01 01:11:00.000000', 'consum', 0.0236, 'lps'),
	(635756, 134, '2015-01-01 01:11:01.000000', 'consum', 0.0219, 'lps'),
	(635757, 134, '2015-01-01 01:11:02.000000', 'consum', 0.0225, 'lps'),
	(635758, 134, '2015-01-01 01:11:03.000000', 'consum', 0.0213, 'lps'),
	(635759, 134, '2015-01-01 01:11:04.000000', 'consum', 0.0224, 'lps'),
	(635760, 134, '2015-01-01 01:11:05.000000', 'consum', 0.0227, 'lps'),
	(635761, 134, '2015-01-01 01:11:06.000000', 'consum', 0.0252, 'lps'),
	(635762, 134, '2015-01-01 01:11:07.000000', 'consum', 0.0238, 'lps'),
	(635763, 134, '2015-01-01 01:11:08.000000', 'consum', 0.0222, 'lps'),
	(635764, 134, '2015-01-01 01:11:09.000000', 'consum', 0.0233, 'lps'),
	(635765, 134, '2015-01-01 01:11:10.000000', 'consum', 0.0243, 'lps'),
	(635766, 134, '2015-01-01 01:11:11.000000', 'consum', 0.0218, 'lps'),
	(635767, 134, '2015-01-01 01:11:12.000000', 'consum', 0.0241, 'lps'),
	(635768, 134, '2015-01-01 01:11:13.000000', 'consum', 0.0252, 'lps'),
	(635769, 134, '2015-01-01 01:11:14.000000', 'consum', 0.0237, 'lps'),
	(635770, 134, '2015-01-01 01:11:15.000000', 'consum', 0.0217, 'lps'),
	(635771, 134, '2015-01-01 01:11:16.000000', 'consum', 0.0213, 'lps'),
	(635772, 134, '2015-01-01 01:11:17.000000', 'consum', 0.0249, 'lps'),
	(635773, 134, '2015-01-01 01:11:18.000000', 'consum', 0.0217, 'lps'),
	(635774, 134, '2015-01-01 01:11:19.000000', 'consum', 0.0217, 'lps'),
	(635775, 134, '2015-01-01 01:11:20.000000', 'consum', 0.0226, 'lps'),
	(635776, 134, '2015-01-01 01:11:21.000000', 'consum', 0.0223, 'lps'),
	(635777, 134, '2015-01-01 01:11:22.000000', 'consum', 0.0228, 'lps'),
	(635778, 134, '2015-01-01 01:11:23.000000', 'consum', 0.0217, 'lps'),
	(635779, 134, '2015-01-01 01:11:24.000000', 'consum', 0.0238, 'lps'),
	(635780, 134, '2015-01-01 01:11:25.000000', 'consum', 0.0239, 'lps'),
	(635781, 134, '2015-01-01 01:11:26.000000', 'consum', 0.0225, 'lps'),
	(635782, 134, '2015-01-01 01:11:27.000000', 'consum', 0.0246, 'lps'),
	(635783, 134, '2015-01-01 01:11:28.000000', 'consum', 0.0252, 'lps'),
	(635784, 134, '2015-01-01 01:11:29.000000', 'consum', 0.0226, 'lps'),
	(635785, 134, '2015-01-01 01:11:30.000000', 'consum', 0.0252, 'lps'),
	(635786, 134, '2015-01-01 01:11:31.000000', 'consum', 0.0240, 'lps'),
	(635787, 134, '2015-01-01 01:11:32.000000', 'consum', 0.0231, 'lps'),
	(635788, 134, '2015-01-01 01:11:33.000000', 'consum', 0.0228, 'lps'),
	(635789, 134, '2015-01-01 01:11:34.000000', 'consum', 0.0239, 'lps'),
	(635790, 134, '2015-01-01 01:11:35.000000', 'consum', 0.0253, 'lps'),
	(635791, 134, '2015-01-01 01:11:36.000000', 'consum', 0.0251, 'lps'),
	(635792, 134, '2015-01-01 01:11:37.000000', 'consum', 0.0240, 'lps'),
	(635793, 134, '2015-01-01 01:11:38.000000', 'consum', 0.0240, 'lps'),
	(635794, 134, '2015-01-01 01:11:39.000000', 'consum', 0.0224, 'lps'),
	(635795, 134, '2015-01-01 01:11:40.000000', 'consum', 0.0236, 'lps'),
	(635796, 134, '2015-01-01 01:11:41.000000', 'consum', 0.0252, 'lps'),
	(635797, 134, '2015-01-01 01:11:42.000000', 'consum', 0.0253, 'lps'),
	(635798, 134, '2015-01-01 01:11:43.000000', 'consum', 0.0210, 'lps'),
	(635799, 134, '2015-01-01 01:11:44.000000', 'consum', 0.0218, 'lps'),
	(635800, 134, '2015-01-01 01:11:45.000000', 'consum', 0.0248, 'lps'),
	(635801, 134, '2015-01-01 01:11:46.000000', 'consum', 0.0242, 'lps'),
	(635802, 134, '2015-01-01 01:11:47.000000', 'consum', 0.0214, 'lps'),
	(635803, 134, '2015-01-01 01:11:48.000000', 'consum', 0.0223, 'lps'),
	(635804, 134, '2015-01-01 01:11:49.000000', 'consum', 0.0217, 'lps'),
	(635805, 134, '2015-01-01 01:11:50.000000', 'consum', 0.0253, 'lps'),
	(635806, 134, '2015-01-01 01:11:51.000000', 'consum', 0.0223, 'lps'),
	(635807, 134, '2015-01-01 01:11:52.000000', 'consum', 0.0239, 'lps'),
	(635808, 134, '2015-01-01 01:11:53.000000', 'consum', 0.0225, 'lps'),
	(635809, 134, '2015-01-01 01:11:54.000000', 'consum', 0.0243, 'lps'),
	(635810, 134, '2015-01-01 01:11:55.000000', 'consum', 0.0242, 'lps'),
	(635811, 134, '2015-01-01 01:11:56.000000', 'consum', 0.0224, 'lps'),
	(635812, 134, '2015-01-01 01:11:57.000000', 'consum', 0.0232, 'lps'),
	(635813, 134, '2015-01-01 01:11:58.000000', 'consum', 0.0233, 'lps'),
	(635814, 134, '2015-01-01 01:11:59.000000', 'consum', 0.0214, 'lps'),
	(635815, 134, '2015-01-01 01:12:00.000000', 'consum', 0.0252, 'lps'),
	(635816, 134, '2015-01-01 01:12:01.000000', 'consum', 0.0228, 'lps'),
	(635817, 134, '2015-01-01 01:12:02.000000', 'consum', 0.0221, 'lps'),
	(635818, 134, '2015-01-01 01:12:03.000000', 'consum', 0.0210, 'lps'),
	(635819, 134, '2015-01-01 01:12:04.000000', 'consum', 0.0221, 'lps'),
	(635820, 134, '2015-01-01 01:12:05.000000', 'consum', 0.0221, 'lps'),
	(635821, 134, '2015-01-01 01:12:06.000000', 'consum', 0.0233, 'lps'),
	(635822, 134, '2015-01-01 01:12:07.000000', 'consum', 0.0246, 'lps'),
	(635823, 134, '2015-01-01 01:12:08.000000', 'consum', 0.0232, 'lps'),
	(635824, 134, '2015-01-01 01:12:09.000000', 'consum', 0.0214, 'lps'),
	(635825, 134, '2015-01-01 01:12:10.000000', 'consum', 0.0254, 'lps'),
	(635826, 134, '2015-01-01 01:12:11.000000', 'consum', 0.0239, 'lps'),
	(635827, 134, '2015-01-01 01:12:12.000000', 'consum', 0.0222, 'lps'),
	(635828, 134, '2015-01-01 01:12:13.000000', 'consum', 0.0228, 'lps'),
	(635829, 134, '2015-01-01 01:12:14.000000', 'consum', 0.0221, 'lps'),
	(635830, 134, '2015-01-01 01:12:15.000000', 'consum', 0.0213, 'lps'),
	(635831, 134, '2015-01-01 01:12:16.000000', 'consum', 0.0236, 'lps'),
	(635832, 134, '2015-01-01 01:12:17.000000', 'consum', 0.0241, 'lps'),
	(635833, 134, '2015-01-01 01:12:18.000000', 'consum', 0.0243, 'lps'),
	(635834, 134, '2015-01-01 01:12:19.000000', 'consum', 0.0239, 'lps'),
	(635835, 134, '2015-01-01 01:12:20.000000', 'consum', 0.0254, 'lps'),
	(635836, 134, '2015-01-01 01:12:21.000000', 'consum', 0.0210, 'lps'),
	(635837, 134, '2015-01-01 01:12:22.000000', 'consum', 0.0215, 'lps'),
	(635838, 134, '2015-01-01 01:12:23.000000', 'consum', 0.0234, 'lps'),
	(635839, 134, '2015-01-01 01:12:24.000000', 'consum', 0.0224, 'lps'),
	(635840, 134, '2015-01-01 01:12:25.000000', 'consum', 0.0211, 'lps'),
	(635841, 134, '2015-01-01 01:12:26.000000', 'consum', 0.0217, 'lps'),
	(635842, 134, '2015-01-01 01:12:27.000000', 'consum', 0.0244, 'lps'),
	(635843, 134, '2015-01-01 01:12:28.000000', 'consum', 0.0226, 'lps'),
	(635844, 134, '2015-01-01 01:12:29.000000', 'consum', 0.0231, 'lps'),
	(635845, 134, '2015-01-01 01:12:30.000000', 'consum', 0.0222, 'lps'),
	(635846, 134, '2015-01-01 01:12:31.000000', 'consum', 0.0253, 'lps'),
	(635847, 134, '2015-01-01 01:12:32.000000', 'consum', 0.0210, 'lps'),
	(635848, 134, '2015-01-01 01:12:33.000000', 'consum', 0.0215, 'lps'),
	(635849, 134, '2015-01-01 01:12:34.000000', 'consum', 0.0234, 'lps'),
	(635850, 134, '2015-01-01 01:12:35.000000', 'consum', 0.0228, 'lps'),
	(635851, 134, '2015-01-01 01:12:36.000000', 'consum', 0.0230, 'lps'),
	(635852, 134, '2015-01-01 01:12:37.000000', 'consum', 0.0254, 'lps'),
	(635853, 134, '2015-01-01 01:12:38.000000', 'consum', 0.0238, 'lps'),
	(635854, 134, '2015-01-01 01:12:39.000000', 'consum', 0.0216, 'lps'),
	(635855, 134, '2015-01-01 01:12:40.000000', 'consum', 0.0247, 'lps'),
	(635856, 134, '2015-01-01 01:12:41.000000', 'consum', 0.0244, 'lps'),
	(635857, 134, '2015-01-01 01:12:42.000000', 'consum', 0.0226, 'lps'),
	(635858, 134, '2015-01-01 01:12:43.000000', 'consum', 0.0231, 'lps'),
	(635859, 134, '2015-01-01 01:12:44.000000', 'consum', 0.0221, 'lps'),
	(635860, 134, '2015-01-01 01:12:45.000000', 'consum', 0.0249, 'lps'),
	(635861, 134, '2015-01-01 01:12:46.000000', 'consum', 0.0238, 'lps'),
	(635862, 134, '2015-01-01 01:12:47.000000', 'consum', 0.0235, 'lps'),
	(635863, 134, '2015-01-01 01:12:48.000000', 'consum', 0.0250, 'lps'),
	(635864, 134, '2015-01-01 01:12:49.000000', 'consum', 0.0244, 'lps'),
	(635865, 134, '2015-01-01 01:12:50.000000', 'consum', 0.0215, 'lps'),
	(635866, 134, '2015-01-01 01:12:51.000000', 'consum', 0.0227, 'lps'),
	(635867, 134, '2015-01-01 01:12:52.000000', 'consum', 0.0232, 'lps'),
	(635868, 134, '2015-01-01 01:12:53.000000', 'consum', 0.0226, 'lps'),
	(635869, 134, '2015-01-01 01:12:54.000000', 'consum', 0.0223, 'lps'),
	(635870, 134, '2015-01-01 01:12:55.000000', 'consum', 0.0228, 'lps'),
	(635871, 134, '2015-01-01 01:12:56.000000', 'consum', 0.0218, 'lps'),
	(635872, 134, '2015-01-01 01:12:57.000000', 'consum', 0.0240, 'lps'),
	(635873, 134, '2015-01-01 01:12:58.000000', 'consum', 0.0248, 'lps'),
	(635874, 134, '2015-01-01 01:12:59.000000', 'consum', 0.0221, 'lps'),
	(635875, 134, '2015-01-01 01:13:00.000000', 'consum', 0.0243, 'lps'),
	(635876, 134, '2015-01-01 01:13:01.000000', 'consum', 0.0249, 'lps'),
	(635877, 134, '2015-01-01 01:13:02.000000', 'consum', 0.0219, 'lps'),
	(635878, 134, '2015-01-01 01:13:03.000000', 'consum', 0.0229, 'lps'),
	(635879, 134, '2015-01-01 01:13:04.000000', 'consum', 0.0232, 'lps'),
	(635880, 134, '2015-01-01 01:13:05.000000', 'consum', 0.0220, 'lps'),
	(635881, 134, '2015-01-01 01:13:06.000000', 'consum', 0.0241, 'lps'),
	(635882, 134, '2015-01-01 01:13:07.000000', 'consum', 0.0242, 'lps'),
	(635883, 134, '2015-01-01 01:13:08.000000', 'consum', 0.0234, 'lps'),
	(635884, 134, '2015-01-01 01:13:09.000000', 'consum', 0.0236, 'lps'),
	(635885, 134, '2015-01-01 01:13:10.000000', 'consum', 0.0224, 'lps'),
	(635886, 134, '2015-01-01 01:13:11.000000', 'consum', 0.0248, 'lps'),
	(635887, 134, '2015-01-01 01:13:12.000000', 'consum', 0.0223, 'lps'),
	(635888, 134, '2015-01-01 01:13:13.000000', 'consum', 0.0250, 'lps'),
	(635889, 134, '2015-01-01 01:13:14.000000', 'consum', 0.0237, 'lps'),
	(635890, 134, '2015-01-01 01:13:15.000000', 'consum', 0.0227, 'lps'),
	(635891, 134, '2015-01-01 01:13:16.000000', 'consum', 0.0215, 'lps'),
	(635892, 134, '2015-01-01 01:13:17.000000', 'consum', 0.0228, 'lps'),
	(635893, 134, '2015-01-01 01:13:18.000000', 'consum', 0.0240, 'lps'),
	(635894, 134, '2015-01-01 01:13:19.000000', 'consum', 0.0217, 'lps'),
	(635895, 134, '2015-01-01 01:13:20.000000', 'consum', 0.0246, 'lps'),
	(635896, 134, '2015-01-01 01:13:21.000000', 'consum', 0.0234, 'lps'),
	(635897, 134, '2015-01-01 01:13:22.000000', 'consum', 0.0224, 'lps'),
	(635898, 134, '2015-01-01 01:13:23.000000', 'consum', 0.0251, 'lps'),
	(635899, 134, '2015-01-01 01:13:24.000000', 'consum', 0.0240, 'lps'),
	(635900, 134, '2015-01-01 01:13:25.000000', 'consum', 0.0239, 'lps'),
	(635901, 134, '2015-01-01 01:13:26.000000', 'consum', 0.0220, 'lps'),
	(635902, 134, '2015-01-01 01:13:27.000000', 'consum', 0.0217, 'lps'),
	(635903, 134, '2015-01-01 01:13:28.000000', 'consum', 0.0215, 'lps'),
	(635904, 134, '2015-01-01 01:13:29.000000', 'consum', 0.0213, 'lps'),
	(635905, 134, '2015-01-01 01:13:30.000000', 'consum', 0.0213, 'lps'),
	(635906, 134, '2015-01-01 01:13:31.000000', 'consum', 0.0217, 'lps'),
	(635907, 134, '2015-01-01 01:13:32.000000', 'consum', 0.0236, 'lps'),
	(635908, 134, '2015-01-01 01:13:33.000000', 'consum', 0.0228, 'lps'),
	(635909, 134, '2015-01-01 01:13:34.000000', 'consum', 0.0224, 'lps'),
	(635910, 134, '2015-01-01 01:13:35.000000', 'consum', 0.0226, 'lps'),
	(635911, 134, '2015-01-01 01:13:36.000000', 'consum', 0.0247, 'lps'),
	(635912, 134, '2015-01-01 01:13:37.000000', 'consum', 0.0214, 'lps'),
	(635913, 134, '2015-01-01 01:13:38.000000', 'consum', 0.0254, 'lps'),
	(635914, 134, '2015-01-01 01:13:39.000000', 'consum', 0.0237, 'lps'),
	(635915, 134, '2015-01-01 01:13:40.000000', 'consum', 0.0215, 'lps'),
	(635916, 134, '2015-01-01 01:13:41.000000', 'consum', 0.0244, 'lps'),
	(635917, 134, '2015-01-01 01:13:42.000000', 'consum', 0.0230, 'lps'),
	(635918, 134, '2015-01-01 01:13:43.000000', 'consum', 0.0254, 'lps'),
	(635919, 134, '2015-01-01 01:13:44.000000', 'consum', 0.0235, 'lps'),
	(635920, 134, '2015-01-01 01:13:45.000000', 'consum', 0.0248, 'lps'),
	(635921, 134, '2015-01-01 01:13:46.000000', 'consum', 0.0237, 'lps'),
	(635922, 134, '2015-01-01 01:13:47.000000', 'consum', 0.0233, 'lps'),
	(635923, 134, '2015-01-01 01:13:48.000000', 'consum', 0.0241, 'lps'),
	(635924, 134, '2015-01-01 01:13:49.000000', 'consum', 0.0210, 'lps'),
	(635925, 134, '2015-01-01 01:13:50.000000', 'consum', 0.0251, 'lps'),
	(635926, 134, '2015-01-01 01:13:51.000000', 'consum', 0.0236, 'lps'),
	(635927, 134, '2015-01-01 01:13:52.000000', 'consum', 0.0219, 'lps'),
	(635928, 134, '2015-01-01 01:13:53.000000', 'consum', 0.0219, 'lps'),
	(635929, 134, '2015-01-01 01:13:54.000000', 'consum', 0.0232, 'lps'),
	(635930, 134, '2015-01-01 01:13:55.000000', 'consum', 0.0246, 'lps'),
	(635931, 134, '2015-01-01 01:13:56.000000', 'consum', 0.0235, 'lps'),
	(635932, 134, '2015-01-01 01:13:57.000000', 'consum', 0.0227, 'lps'),
	(635933, 134, '2015-01-01 01:13:58.000000', 'consum', 0.0220, 'lps'),
	(635934, 134, '2015-01-01 01:13:59.000000', 'consum', 0.0210, 'lps'),
	(635935, 134, '2015-01-01 01:14:00.000000', 'consum', 0.0226, 'lps'),
	(635936, 134, '2015-01-01 01:14:01.000000', 'consum', 0.0246, 'lps'),
	(635937, 134, '2015-01-01 01:14:02.000000', 'consum', 0.0253, 'lps'),
	(635938, 134, '2015-01-01 01:14:03.000000', 'consum', 0.0227, 'lps'),
	(635939, 134, '2015-01-01 01:14:04.000000', 'consum', 0.0212, 'lps'),
	(635940, 134, '2015-01-01 01:14:05.000000', 'consum', 0.0215, 'lps'),
	(635941, 134, '2015-01-01 01:14:06.000000', 'consum', 0.0229, 'lps'),
	(635942, 134, '2015-01-01 01:14:07.000000', 'consum', 0.0246, 'lps'),
	(635943, 134, '2015-01-01 01:14:08.000000', 'consum', 0.0245, 'lps'),
	(635944, 134, '2015-01-01 01:14:09.000000', 'consum', 0.0230, 'lps'),
	(635945, 134, '2015-01-01 01:14:10.000000', 'consum', 0.0250, 'lps'),
	(635946, 134, '2015-01-01 01:14:11.000000', 'consum', 0.0215, 'lps'),
	(635947, 134, '2015-01-01 01:14:12.000000', 'consum', 0.0250, 'lps'),
	(635948, 134, '2015-01-01 01:14:13.000000', 'consum', 0.0217, 'lps'),
	(635949, 134, '2015-01-01 01:14:14.000000', 'consum', 0.0214, 'lps'),
	(635950, 134, '2015-01-01 01:14:15.000000', 'consum', 0.0254, 'lps'),
	(635951, 134, '2015-01-01 01:14:16.000000', 'consum', 0.0237, 'lps'),
	(635952, 134, '2015-01-01 01:14:17.000000', 'consum', 0.0217, 'lps'),
	(635953, 134, '2015-01-01 01:14:18.000000', 'consum', 0.0252, 'lps'),
	(635954, 134, '2015-01-01 01:14:19.000000', 'consum', 0.0221, 'lps'),
	(635955, 134, '2015-01-01 01:14:20.000000', 'consum', 0.0231, 'lps'),
	(635956, 134, '2015-01-01 01:14:21.000000', 'consum', 0.0237, 'lps'),
	(635957, 134, '2015-01-01 01:14:22.000000', 'consum', 0.0236, 'lps'),
	(635958, 134, '2015-01-01 01:14:23.000000', 'consum', 0.0216, 'lps'),
	(635959, 134, '2015-01-01 01:14:24.000000', 'consum', 0.0253, 'lps'),
	(635960, 134, '2015-01-01 01:14:25.000000', 'consum', 0.0228, 'lps'),
	(635961, 134, '2015-01-01 01:14:26.000000', 'consum', 0.0217, 'lps'),
	(635962, 134, '2015-01-01 01:14:27.000000', 'consum', 0.0234, 'lps'),
	(635963, 134, '2015-01-01 01:14:28.000000', 'consum', 0.0222, 'lps'),
	(635964, 134, '2015-01-01 01:14:29.000000', 'consum', 0.0244, 'lps'),
	(635965, 134, '2015-01-01 01:14:30.000000', 'consum', 0.0254, 'lps'),
	(635966, 134, '2015-01-01 01:14:31.000000', 'consum', 0.0237, 'lps'),
	(635967, 134, '2015-01-01 01:14:32.000000', 'consum', 0.0213, 'lps'),
	(635968, 134, '2015-01-01 01:14:33.000000', 'consum', 0.0234, 'lps'),
	(635969, 134, '2015-01-01 01:14:34.000000', 'consum', 0.0234, 'lps'),
	(635970, 134, '2015-01-01 01:14:35.000000', 'consum', 0.0214, 'lps'),
	(635971, 134, '2015-01-01 01:14:36.000000', 'consum', 0.0248, 'lps'),
	(635972, 134, '2015-01-01 01:14:37.000000', 'consum', 0.0210, 'lps'),
	(635973, 134, '2015-01-01 01:14:38.000000', 'consum', 0.0230, 'lps'),
	(635974, 134, '2015-01-01 01:14:39.000000', 'consum', 0.0219, 'lps'),
	(635975, 134, '2015-01-01 01:14:40.000000', 'consum', 0.0244, 'lps'),
	(635976, 134, '2015-01-01 01:14:41.000000', 'consum', 0.0216, 'lps'),
	(635977, 134, '2015-01-01 01:14:42.000000', 'consum', 0.0228, 'lps'),
	(635978, 134, '2015-01-01 01:14:43.000000', 'consum', 0.0237, 'lps'),
	(635979, 134, '2015-01-01 01:14:44.000000', 'consum', 0.0246, 'lps'),
	(635980, 134, '2015-01-01 01:14:45.000000', 'consum', 0.0222, 'lps'),
	(635981, 134, '2015-01-01 01:14:46.000000', 'consum', 0.0252, 'lps'),
	(635982, 134, '2015-01-01 01:14:47.000000', 'consum', 0.0248, 'lps'),
	(635983, 134, '2015-01-01 01:14:48.000000', 'consum', 0.0231, 'lps'),
	(635984, 134, '2015-01-01 01:14:49.000000', 'consum', 0.0246, 'lps'),
	(635985, 134, '2015-01-01 01:14:50.000000', 'consum', 0.0239, 'lps'),
	(635986, 134, '2015-01-01 01:14:51.000000', 'consum', 0.0247, 'lps'),
	(635987, 134, '2015-01-01 01:14:52.000000', 'consum', 0.0218, 'lps'),
	(635988, 134, '2015-01-01 01:14:53.000000', 'consum', 0.0231, 'lps'),
	(635989, 134, '2015-01-01 01:14:54.000000', 'consum', 0.0245, 'lps'),
	(635990, 134, '2015-01-01 01:14:55.000000', 'consum', 0.0232, 'lps'),
	(635991, 134, '2015-01-01 01:14:56.000000', 'consum', 0.0216, 'lps'),
	(635992, 134, '2015-01-01 01:14:57.000000', 'consum', 0.0221, 'lps'),
	(635993, 134, '2015-01-01 01:14:58.000000', 'consum', 0.0248, 'lps'),
	(635994, 134, '2015-01-01 01:14:59.000000', 'consum', 0.0229, 'lps'),
	(635995, 134, '2015-01-01 01:15:00.000000', 'consum', 0.0240, 'lps'),
	(635996, 134, '2015-01-01 01:15:01.000000', 'consum', 0.0213, 'lps'),
	(635997, 134, '2015-01-01 01:15:02.000000', 'consum', 0.0226, 'lps'),
	(635998, 134, '2015-01-01 01:15:03.000000', 'consum', 0.0234, 'lps'),
	(635999, 134, '2015-01-01 01:15:04.000000', 'consum', 0.0241, 'lps'),
	(636000, 134, '2015-01-01 01:15:05.000000', 'consum', 0.0245, 'lps'),
	(636001, 134, '2015-01-01 01:15:06.000000', 'consum', 0.0249, 'lps'),
	(636002, 134, '2015-01-01 01:15:07.000000', 'consum', 0.0213, 'lps'),
	(636003, 134, '2015-01-01 01:15:08.000000', 'consum', 0.0240, 'lps'),
	(636004, 134, '2015-01-01 01:15:09.000000', 'consum', 0.0216, 'lps'),
	(636005, 134, '2015-01-01 01:15:10.000000', 'consum', 0.0242, 'lps'),
	(636006, 134, '2015-01-01 01:15:11.000000', 'consum', 0.0216, 'lps'),
	(636007, 134, '2015-01-01 01:15:12.000000', 'consum', 0.0233, 'lps'),
	(636008, 134, '2015-01-01 01:15:13.000000', 'consum', 0.0221, 'lps'),
	(636009, 134, '2015-01-01 01:15:14.000000', 'consum', 0.0239, 'lps'),
	(636010, 134, '2015-01-01 01:15:15.000000', 'consum', 0.0233, 'lps'),
	(636011, 134, '2015-01-01 01:15:16.000000', 'consum', 0.0240, 'lps'),
	(636012, 134, '2015-01-01 01:15:17.000000', 'consum', 0.0247, 'lps'),
	(636013, 134, '2015-01-01 01:15:18.000000', 'consum', 0.0216, 'lps'),
	(636014, 134, '2015-01-01 01:15:19.000000', 'consum', 0.0218, 'lps'),
	(636015, 134, '2015-01-01 01:15:20.000000', 'consum', 0.0232, 'lps'),
	(636016, 134, '2015-01-01 01:15:21.000000', 'consum', 0.0252, 'lps'),
	(636017, 134, '2015-01-01 01:15:22.000000', 'consum', 0.0218, 'lps'),
	(636018, 134, '2015-01-01 01:15:23.000000', 'consum', 0.0216, 'lps'),
	(636019, 134, '2015-01-01 01:15:24.000000', 'consum', 0.0215, 'lps'),
	(636020, 134, '2015-01-01 01:15:25.000000', 'consum', 0.0218, 'lps'),
	(636021, 134, '2015-01-01 01:15:26.000000', 'consum', 0.0237, 'lps'),
	(636022, 134, '2015-01-01 01:15:27.000000', 'consum', 0.0229, 'lps'),
	(636023, 134, '2015-01-01 01:15:28.000000', 'consum', 0.0227, 'lps'),
	(636024, 134, '2015-01-01 01:15:29.000000', 'consum', 0.0238, 'lps'),
	(636025, 134, '2015-01-01 01:15:30.000000', 'consum', 0.0210, 'lps'),
	(636026, 134, '2015-01-01 01:15:31.000000', 'consum', 0.0216, 'lps'),
	(636027, 134, '2015-01-01 01:15:32.000000', 'consum', 0.0239, 'lps'),
	(636028, 134, '2015-01-01 01:15:33.000000', 'consum', 0.0247, 'lps'),
	(636029, 134, '2015-01-01 01:15:34.000000', 'consum', 0.0220, 'lps'),
	(636030, 134, '2015-01-01 01:15:35.000000', 'consum', 0.0241, 'lps'),
	(636031, 134, '2015-01-01 01:15:36.000000', 'consum', 0.0244, 'lps'),
	(636032, 134, '2015-01-01 01:15:37.000000', 'consum', 0.0243, 'lps'),
	(636033, 134, '2015-01-01 01:15:38.000000', 'consum', 0.0229, 'lps'),
	(636034, 134, '2015-01-01 01:15:39.000000', 'consum', 0.0250, 'lps'),
	(636035, 134, '2015-01-01 01:15:40.000000', 'consum', 0.0220, 'lps'),
	(636036, 134, '2015-01-01 01:15:41.000000', 'consum', 0.0228, 'lps'),
	(636037, 134, '2015-01-01 01:15:42.000000', 'consum', 0.0228, 'lps'),
	(636038, 134, '2015-01-01 01:15:43.000000', 'consum', 0.0245, 'lps'),
	(636039, 134, '2015-01-01 01:15:44.000000', 'consum', 0.0241, 'lps'),
	(636040, 134, '2015-01-01 01:15:45.000000', 'consum', 0.0216, 'lps'),
	(636041, 134, '2015-01-01 01:15:46.000000', 'consum', 0.0236, 'lps'),
	(636042, 134, '2015-01-01 01:15:47.000000', 'consum', 0.0232, 'lps'),
	(636043, 134, '2015-01-01 01:15:48.000000', 'consum', 0.0242, 'lps'),
	(636044, 134, '2015-01-01 01:15:49.000000', 'consum', 0.0217, 'lps'),
	(636045, 134, '2015-01-01 01:15:50.000000', 'consum', 0.0239, 'lps'),
	(636046, 134, '2015-01-01 01:15:51.000000', 'consum', 0.0243, 'lps'),
	(636047, 134, '2015-01-01 01:15:52.000000', 'consum', 0.0244, 'lps'),
	(636048, 134, '2015-01-01 01:15:53.000000', 'consum', 0.0236, 'lps'),
	(636049, 134, '2015-01-01 01:15:54.000000', 'consum', 0.0238, 'lps'),
	(636050, 134, '2015-01-01 01:15:55.000000', 'consum', 0.0230, 'lps'),
	(636051, 134, '2015-01-01 01:15:56.000000', 'consum', 0.0224, 'lps'),
	(636052, 134, '2015-01-01 01:15:57.000000', 'consum', 0.0220, 'lps'),
	(636053, 134, '2015-01-01 01:15:58.000000', 'consum', 0.0218, 'lps'),
	(636054, 134, '2015-01-01 01:15:59.000000', 'consum', 0.0223, 'lps'),
	(636055, 134, '2015-01-01 01:16:00.000000', 'consum', 0.0251, 'lps'),
	(636056, 134, '2015-01-01 01:16:01.000000', 'consum', 0.0241, 'lps'),
	(636057, 134, '2015-01-01 01:16:02.000000', 'consum', 0.0243, 'lps'),
	(636058, 134, '2015-01-01 01:16:03.000000', 'consum', 0.0235, 'lps'),
	(636059, 134, '2015-01-01 01:16:04.000000', 'consum', 0.0239, 'lps'),
	(636060, 134, '2015-01-01 01:16:05.000000', 'consum', 0.0236, 'lps'),
	(636061, 134, '2015-01-01 01:16:06.000000', 'consum', 0.0253, 'lps'),
	(636062, 134, '2015-01-01 01:16:07.000000', 'consum', 0.0210, 'lps'),
	(636063, 134, '2015-01-01 01:16:08.000000', 'consum', 0.0220, 'lps'),
	(636064, 134, '2015-01-01 01:16:09.000000', 'consum', 0.0212, 'lps'),
	(636065, 134, '2015-01-01 01:16:10.000000', 'consum', 0.0239, 'lps'),
	(636066, 134, '2015-01-01 01:16:11.000000', 'consum', 0.0211, 'lps'),
	(636067, 134, '2015-01-01 01:16:12.000000', 'consum', 0.0222, 'lps'),
	(636068, 134, '2015-01-01 01:16:13.000000', 'consum', 0.0221, 'lps'),
	(636069, 134, '2015-01-01 01:16:14.000000', 'consum', 0.0229, 'lps'),
	(636070, 134, '2015-01-01 01:16:15.000000', 'consum', 0.0229, 'lps'),
	(636071, 134, '2015-01-01 01:16:16.000000', 'consum', 0.0249, 'lps'),
	(636072, 134, '2015-01-01 01:16:17.000000', 'consum', 0.0212, 'lps'),
	(636073, 134, '2015-01-01 01:16:18.000000', 'consum', 0.0237, 'lps'),
	(636074, 134, '2015-01-01 01:16:19.000000', 'consum', 0.0252, 'lps'),
	(636075, 134, '2015-01-01 01:16:20.000000', 'consum', 0.0247, 'lps'),
	(636076, 134, '2015-01-01 01:16:21.000000', 'consum', 0.0224, 'lps'),
	(636077, 134, '2015-01-01 01:16:22.000000', 'consum', 0.0216, 'lps'),
	(636078, 134, '2015-01-01 01:16:23.000000', 'consum', 0.0241, 'lps'),
	(636079, 134, '2015-01-01 01:16:24.000000', 'consum', 0.0216, 'lps'),
	(636080, 134, '2015-01-01 01:16:25.000000', 'consum', 0.0237, 'lps'),
	(636081, 134, '2015-01-01 01:16:26.000000', 'consum', 0.0237, 'lps'),
	(636082, 134, '2015-01-01 01:16:27.000000', 'consum', 0.0220, 'lps'),
	(636083, 134, '2015-01-01 01:16:28.000000', 'consum', 0.0224, 'lps'),
	(636084, 134, '2015-01-01 01:16:29.000000', 'consum', 0.0250, 'lps'),
	(636085, 134, '2015-01-01 01:16:30.000000', 'consum', 0.0233, 'lps'),
	(636086, 134, '2015-01-01 01:16:31.000000', 'consum', 0.0251, 'lps'),
	(636087, 134, '2015-01-01 01:16:32.000000', 'consum', 0.0214, 'lps'),
	(636088, 134, '2015-01-01 01:16:33.000000', 'consum', 0.0239, 'lps'),
	(636089, 134, '2015-01-01 01:16:34.000000', 'consum', 0.0253, 'lps'),
	(636090, 134, '2015-01-01 01:16:35.000000', 'consum', 0.0252, 'lps'),
	(636091, 134, '2015-01-01 01:16:36.000000', 'consum', 0.0243, 'lps'),
	(636092, 134, '2015-01-01 01:16:37.000000', 'consum', 0.0251, 'lps'),
	(636093, 134, '2015-01-01 01:16:38.000000', 'consum', 0.0225, 'lps'),
	(636094, 134, '2015-01-01 01:16:39.000000', 'consum', 0.0210, 'lps'),
	(636095, 134, '2015-01-01 01:16:40.000000', 'consum', 0.0253, 'lps'),
	(636096, 134, '2015-01-01 01:16:41.000000', 'consum', 0.0245, 'lps'),
	(636097, 134, '2015-01-01 01:16:42.000000', 'consum', 0.0211, 'lps'),
	(636098, 134, '2015-01-01 01:16:43.000000', 'consum', 0.0248, 'lps'),
	(636099, 134, '2015-01-01 01:16:44.000000', 'consum', 0.0216, 'lps'),
	(636100, 134, '2015-01-01 01:16:45.000000', 'consum', 0.0218, 'lps'),
	(636101, 134, '2015-01-01 01:16:46.000000', 'consum', 0.0232, 'lps'),
	(636102, 134, '2015-01-01 01:16:47.000000', 'consum', 0.0250, 'lps'),
	(636103, 134, '2015-01-01 01:16:48.000000', 'consum', 0.0210, 'lps'),
	(636104, 134, '2015-01-01 01:16:49.000000', 'consum', 0.0225, 'lps'),
	(636105, 134, '2015-01-01 01:16:50.000000', 'consum', 0.0242, 'lps'),
	(636106, 134, '2015-01-01 01:16:51.000000', 'consum', 0.0233, 'lps'),
	(636107, 134, '2015-01-01 01:16:52.000000', 'consum', 0.0231, 'lps'),
	(636108, 134, '2015-01-01 01:16:53.000000', 'consum', 0.0244, 'lps'),
	(636109, 134, '2015-01-01 01:16:54.000000', 'consum', 0.0230, 'lps'),
	(636110, 134, '2015-01-01 01:16:55.000000', 'consum', 0.0210, 'lps'),
	(636111, 134, '2015-01-01 01:16:56.000000', 'consum', 0.0238, 'lps'),
	(636112, 134, '2015-01-01 01:16:57.000000', 'consum', 0.0217, 'lps'),
	(636113, 134, '2015-01-01 01:16:58.000000', 'consum', 0.0251, 'lps'),
	(636114, 134, '2015-01-01 01:16:59.000000', 'consum', 0.0216, 'lps'),
	(636115, 134, '2015-01-01 01:17:00.000000', 'consum', 0.0252, 'lps'),
	(636116, 134, '2015-01-01 01:17:01.000000', 'consum', 0.0221, 'lps'),
	(636117, 134, '2015-01-01 01:17:02.000000', 'consum', 0.0232, 'lps'),
	(636118, 134, '2015-01-01 01:17:03.000000', 'consum', 0.0241, 'lps'),
	(636119, 134, '2015-01-01 01:17:04.000000', 'consum', 0.0212, 'lps'),
	(636120, 134, '2015-01-01 01:17:05.000000', 'consum', 0.0215, 'lps'),
	(636121, 134, '2015-01-01 01:17:06.000000', 'consum', 0.0229, 'lps'),
	(636122, 134, '2015-01-01 01:17:07.000000', 'consum', 0.0245, 'lps'),
	(636123, 134, '2015-01-01 01:17:08.000000', 'consum', 0.0241, 'lps'),
	(636124, 134, '2015-01-01 01:17:09.000000', 'consum', 0.0213, 'lps'),
	(636125, 134, '2015-01-01 01:17:10.000000', 'consum', 0.0222, 'lps'),
	(636126, 134, '2015-01-01 01:17:11.000000', 'consum', 0.0218, 'lps'),
	(636127, 134, '2015-01-01 01:17:12.000000', 'consum', 0.0212, 'lps'),
	(636128, 134, '2015-01-01 01:17:13.000000', 'consum', 0.0245, 'lps'),
	(636129, 134, '2015-01-01 01:17:14.000000', 'consum', 0.0242, 'lps'),
	(636130, 134, '2015-01-01 01:17:15.000000', 'consum', 0.0222, 'lps'),
	(636131, 134, '2015-01-01 01:17:16.000000', 'consum', 0.0217, 'lps'),
	(636132, 134, '2015-01-01 01:17:17.000000', 'consum', 0.0212, 'lps'),
	(636133, 134, '2015-01-01 01:17:18.000000', 'consum', 0.0245, 'lps'),
	(636134, 134, '2015-01-01 01:17:19.000000', 'consum', 0.0244, 'lps'),
	(636135, 134, '2015-01-01 01:17:20.000000', 'consum', 0.0229, 'lps'),
	(636136, 134, '2015-01-01 01:17:21.000000', 'consum', 0.0250, 'lps'),
	(636137, 134, '2015-01-01 01:17:22.000000', 'consum', 0.0217, 'lps'),
	(636138, 134, '2015-01-01 01:17:23.000000', 'consum', 0.0216, 'lps'),
	(636139, 134, '2015-01-01 01:17:24.000000', 'consum', 0.0222, 'lps'),
	(636140, 134, '2015-01-01 01:17:25.000000', 'consum', 0.0249, 'lps'),
	(636141, 134, '2015-01-01 01:17:26.000000', 'consum', 0.0237, 'lps'),
	(636142, 134, '2015-01-01 01:17:27.000000', 'consum', 0.0227, 'lps'),
	(636143, 134, '2015-01-01 01:17:28.000000', 'consum', 0.0214, 'lps'),
	(636144, 134, '2015-01-01 01:17:29.000000', 'consum', 0.0223, 'lps'),
	(636145, 134, '2015-01-01 01:17:30.000000', 'consum', 0.0222, 'lps'),
	(636146, 134, '2015-01-01 01:17:31.000000', 'consum', 0.0230, 'lps'),
	(636147, 134, '2015-01-01 01:17:32.000000', 'consum', 0.0229, 'lps'),
	(636148, 134, '2015-01-01 01:17:33.000000', 'consum', 0.0245, 'lps'),
	(636149, 134, '2015-01-01 01:17:34.000000', 'consum', 0.0240, 'lps'),
	(636150, 134, '2015-01-01 01:17:35.000000', 'consum', 0.0210, 'lps'),
	(636151, 134, '2015-01-01 01:17:36.000000', 'consum', 0.0253, 'lps'),
	(636152, 134, '2015-01-01 01:17:37.000000', 'consum', 0.0249, 'lps'),
	(636153, 134, '2015-01-01 01:17:38.000000', 'consum', 0.0229, 'lps'),
	(636154, 134, '2015-01-01 01:17:39.000000', 'consum', 0.0234, 'lps'),
	(636155, 134, '2015-01-01 01:17:40.000000', 'consum', 0.0229, 'lps'),
	(636156, 134, '2015-01-01 01:17:41.000000', 'consum', 0.0232, 'lps'),
	(636157, 134, '2015-01-01 01:17:42.000000', 'consum', 0.0221, 'lps'),
	(636158, 134, '2015-01-01 01:17:43.000000', 'consum', 0.0244, 'lps'),
	(636159, 134, '2015-01-01 01:17:44.000000', 'consum', 0.0211, 'lps'),
	(636160, 134, '2015-01-01 01:17:45.000000', 'consum', 0.0250, 'lps'),
	(636161, 134, '2015-01-01 01:17:46.000000', 'consum', 0.0229, 'lps'),
	(636162, 134, '2015-01-01 01:17:47.000000', 'consum', 0.0228, 'lps'),
	(636163, 134, '2015-01-01 01:17:48.000000', 'consum', 0.0246, 'lps'),
	(636164, 134, '2015-01-01 01:17:49.000000', 'consum', 0.0247, 'lps'),
	(636165, 134, '2015-01-01 01:17:50.000000', 'consum', 0.0241, 'lps'),
	(636166, 134, '2015-01-01 01:17:51.000000', 'consum', 0.0210, 'lps'),
	(636167, 134, '2015-01-01 01:17:52.000000', 'consum', 0.0252, 'lps'),
	(636168, 134, '2015-01-01 01:17:53.000000', 'consum', 0.0243, 'lps'),
	(636169, 134, '2015-01-01 01:17:54.000000', 'consum', 0.0247, 'lps'),
	(636170, 134, '2015-01-01 01:17:55.000000', 'consum', 0.0253, 'lps'),
	(636171, 134, '2015-01-01 01:17:56.000000', 'consum', 0.0224, 'lps'),
	(636172, 134, '2015-01-01 01:17:57.000000', 'consum', 0.0240, 'lps'),
	(636173, 134, '2015-01-01 01:17:58.000000', 'consum', 0.0229, 'lps'),
	(636174, 134, '2015-01-01 01:17:59.000000', 'consum', 0.0217, 'lps'),
	(636175, 134, '2015-01-01 01:18:00.000000', 'consum', 0.0232, 'lps'),
	(636176, 134, '2015-01-01 01:18:01.000000', 'consum', 0.0210, 'lps'),
	(636177, 134, '2015-01-01 01:18:02.000000', 'consum', 0.0236, 'lps'),
	(636178, 134, '2015-01-01 01:18:03.000000', 'consum', 0.0249, 'lps'),
	(636179, 134, '2015-01-01 01:18:04.000000', 'consum', 0.0238, 'lps'),
	(636180, 134, '2015-01-01 01:18:05.000000', 'consum', 0.0231, 'lps'),
	(636181, 134, '2015-01-01 01:18:06.000000', 'consum', 0.0235, 'lps'),
	(636182, 134, '2015-01-01 01:18:07.000000', 'consum', 0.0225, 'lps'),
	(636183, 134, '2015-01-01 01:18:08.000000', 'consum', 0.0211, 'lps'),
	(636184, 134, '2015-01-01 01:18:09.000000', 'consum', 0.0216, 'lps'),
	(636185, 134, '2015-01-01 01:18:10.000000', 'consum', 0.0239, 'lps'),
	(636186, 134, '2015-01-01 01:18:11.000000', 'consum', 0.0245, 'lps'),
	(636187, 134, '2015-01-01 01:18:12.000000', 'consum', 0.0211, 'lps'),
	(636188, 134, '2015-01-01 01:18:13.000000', 'consum', 0.0244, 'lps'),
	(636189, 134, '2015-01-01 01:18:14.000000', 'consum', 0.0244, 'lps'),
	(636190, 134, '2015-01-01 01:18:15.000000', 'consum', 0.0232, 'lps'),
	(636191, 134, '2015-01-01 01:18:16.000000', 'consum', 0.0221, 'lps'),
	(636192, 134, '2015-01-01 01:18:17.000000', 'consum', 0.0243, 'lps'),
	(636193, 134, '2015-01-01 01:18:18.000000', 'consum', 0.0210, 'lps'),
	(636194, 134, '2015-01-01 01:18:19.000000', 'consum', 0.0243, 'lps'),
	(636195, 134, '2015-01-01 01:18:20.000000', 'consum', 0.0242, 'lps'),
	(636196, 134, '2015-01-01 01:18:21.000000', 'consum', 0.0228, 'lps'),
	(636197, 134, '2015-01-01 01:18:22.000000', 'consum', 0.0247, 'lps'),
	(636198, 134, '2015-01-01 01:18:23.000000', 'consum', 0.0251, 'lps'),
	(636199, 134, '2015-01-01 01:18:24.000000', 'consum', 0.0216, 'lps'),
	(636200, 134, '2015-01-01 01:18:25.000000', 'consum', 0.0251, 'lps'),
	(636201, 134, '2015-01-01 01:18:26.000000', 'consum', 0.0216, 'lps'),
	(636202, 134, '2015-01-01 01:18:27.000000', 'consum', 0.0211, 'lps'),
	(636203, 134, '2015-01-01 01:18:28.000000', 'consum', 0.0242, 'lps'),
	(636204, 134, '2015-01-01 01:18:29.000000', 'consum', 0.0231, 'lps'),
	(636205, 134, '2015-01-01 01:18:30.000000', 'consum', 0.0218, 'lps'),
	(636206, 134, '2015-01-01 01:18:31.000000', 'consum', 0.0236, 'lps'),
	(636207, 134, '2015-01-01 01:18:32.000000', 'consum', 0.0224, 'lps'),
	(636208, 134, '2015-01-01 01:18:33.000000', 'consum', 0.0249, 'lps'),
	(636209, 134, '2015-01-01 01:18:34.000000', 'consum', 0.0230, 'lps'),
	(636210, 134, '2015-01-01 01:18:35.000000', 'consum', 0.0237, 'lps'),
	(636211, 134, '2015-01-01 01:18:36.000000', 'consum', 0.0239, 'lps'),
	(636212, 134, '2015-01-01 01:18:37.000000', 'consum', 0.0231, 'lps'),
	(636213, 134, '2015-01-01 01:18:38.000000', 'consum', 0.0230, 'lps'),
	(636214, 134, '2015-01-01 01:18:39.000000', 'consum', 0.0248, 'lps'),
	(636215, 134, '2015-01-01 01:18:40.000000', 'consum', 0.0249, 'lps'),
	(636216, 134, '2015-01-01 01:18:41.000000', 'consum', 0.0245, 'lps'),
	(636217, 134, '2015-01-01 01:18:42.000000', 'consum', 0.0224, 'lps'),
	(636218, 134, '2015-01-01 01:18:43.000000', 'consum', 0.0222, 'lps'),
	(636219, 134, '2015-01-01 01:18:44.000000', 'consum', 0.0229, 'lps'),
	(636220, 134, '2015-01-01 01:18:45.000000', 'consum', 0.0224, 'lps'),
	(636221, 134, '2015-01-01 01:18:46.000000', 'consum', 0.0223, 'lps'),
	(636222, 134, '2015-01-01 01:18:47.000000', 'consum', 0.0235, 'lps'),
	(636223, 134, '2015-01-01 01:18:48.000000', 'consum', 0.0249, 'lps'),
	(636224, 134, '2015-01-01 01:18:49.000000', 'consum', 0.0242, 'lps'),
	(636225, 134, '2015-01-01 01:18:50.000000', 'consum', 0.0254, 'lps'),
	(636226, 134, '2015-01-01 01:18:51.000000', 'consum', 0.0243, 'lps'),
	(636227, 134, '2015-01-01 01:18:52.000000', 'consum', 0.0246, 'lps'),
	(636228, 134, '2015-01-01 01:18:53.000000', 'consum', 0.0244, 'lps'),
	(636229, 134, '2015-01-01 01:18:54.000000', 'consum', 0.0229, 'lps'),
	(636230, 134, '2015-01-01 01:18:55.000000', 'consum', 0.0248, 'lps'),
	(636231, 134, '2015-01-01 01:18:56.000000', 'consum', 0.0254, 'lps'),
	(636232, 134, '2015-01-01 01:18:57.000000', 'consum', 0.0224, 'lps'),
	(636233, 134, '2015-01-01 01:18:58.000000', 'consum', 0.0241, 'lps'),
	(636234, 134, '2015-01-01 01:18:59.000000', 'consum', 0.0234, 'lps'),
	(636235, 134, '2015-01-01 01:19:00.000000', 'consum', 0.0236, 'lps'),
	(636236, 134, '2015-01-01 01:19:01.000000', 'consum', 0.0226, 'lps'),
	(636237, 134, '2015-01-01 01:19:02.000000', 'consum', 0.0254, 'lps'),
	(636238, 134, '2015-01-01 01:19:03.000000', 'consum', 0.0251, 'lps'),
	(636239, 134, '2015-01-01 01:19:04.000000', 'consum', 0.0235, 'lps'),
	(636240, 134, '2015-01-01 01:19:05.000000', 'consum', 0.0216, 'lps'),
	(636241, 134, '2015-01-01 01:19:06.000000', 'consum', 0.0253, 'lps'),
	(636242, 134, '2015-01-01 01:19:07.000000', 'consum', 0.0228, 'lps'),
	(636243, 134, '2015-01-01 01:19:08.000000', 'consum', 0.0216, 'lps'),
	(636244, 134, '2015-01-01 01:19:09.000000', 'consum', 0.0232, 'lps'),
	(636245, 134, '2015-01-01 01:19:10.000000', 'consum', 0.0212, 'lps'),
	(636246, 134, '2015-01-01 01:19:11.000000', 'consum', 0.0245, 'lps'),
	(636247, 134, '2015-01-01 01:19:12.000000', 'consum', 0.0245, 'lps'),
	(636248, 134, '2015-01-01 01:19:13.000000', 'consum', 0.0236, 'lps'),
	(636249, 134, '2015-01-01 01:19:14.000000', 'consum', 0.0234, 'lps'),
	(636250, 134, '2015-01-01 01:19:15.000000', 'consum', 0.0253, 'lps'),
	(636251, 134, '2015-01-01 01:19:16.000000', 'consum', 0.0217, 'lps'),
	(636252, 134, '2015-01-01 01:19:17.000000', 'consum', 0.0253, 'lps'),
	(636253, 134, '2015-01-01 01:19:18.000000', 'consum', 0.0225, 'lps'),
	(636254, 134, '2015-01-01 01:19:19.000000', 'consum', 0.0246, 'lps'),
	(636255, 134, '2015-01-01 01:19:20.000000', 'consum', 0.0254, 'lps'),
	(636256, 134, '2015-01-01 01:19:21.000000', 'consum', 0.0236, 'lps'),
	(636257, 134, '2015-01-01 01:19:22.000000', 'consum', 0.0250, 'lps'),
	(636258, 134, '2015-01-01 01:19:23.000000', 'consum', 0.0244, 'lps'),
	(636259, 134, '2015-01-01 01:19:24.000000', 'consum', 0.0216, 'lps'),
	(636260, 134, '2015-01-01 01:19:25.000000', 'consum', 0.0227, 'lps'),
	(636261, 134, '2015-01-01 01:19:26.000000', 'consum', 0.0233, 'lps'),
	(636262, 134, '2015-01-01 01:19:27.000000', 'consum', 0.0229, 'lps'),
	(636263, 134, '2015-01-01 01:19:28.000000', 'consum', 0.0238, 'lps'),
	(636264, 134, '2015-01-01 01:19:29.000000', 'consum', 0.0250, 'lps'),
	(636265, 134, '2015-01-01 01:19:30.000000', 'consum', 0.0233, 'lps'),
	(636266, 134, '2015-01-01 01:19:31.000000', 'consum', 0.0254, 'lps'),
	(636267, 134, '2015-01-01 01:19:32.000000', 'consum', 0.0224, 'lps'),
	(636268, 134, '2015-01-01 01:19:33.000000', 'consum', 0.0240, 'lps'),
	(636269, 134, '2015-01-01 01:19:34.000000', 'consum', 0.0228, 'lps'),
	(636270, 134, '2015-01-01 01:19:35.000000', 'consum', 0.0254, 'lps'),
	(636271, 134, '2015-01-01 01:19:36.000000', 'consum', 0.0241, 'lps'),
	(636272, 134, '2015-01-01 01:19:37.000000', 'consum', 0.0233, 'lps'),
	(636273, 134, '2015-01-01 01:19:38.000000', 'consum', 0.0232, 'lps'),
	(636274, 134, '2015-01-01 01:19:39.000000', 'consum', 0.0254, 'lps'),
	(636275, 135, '2015-01-01 00:00:00.000000', 'consum', 0.0253, 'lps'),
	(636276, 135, '2015-01-01 00:00:01.000000', 'consum', 0.0264, 'lps'),
	(636277, 135, '2015-01-01 00:00:02.000000', 'consum', 0.0230, 'lps'),
	(636278, 135, '2015-01-01 00:00:03.000000', 'consum', 0.0270, 'lps'),
	(636279, 135, '2015-01-01 00:00:04.000000', 'consum', 0.0263, 'lps'),
	(636280, 135, '2015-01-01 00:00:05.000000', 'consum', 0.0237, 'lps'),
	(636281, 135, '2015-01-01 00:00:06.000000', 'consum', 0.0249, 'lps'),
	(636282, 135, '2015-01-01 00:00:07.000000', 'consum', 0.0259, 'lps'),
	(636283, 135, '2015-01-01 00:00:08.000000', 'consum', 0.0218, 'lps'),
	(636284, 135, '2015-01-01 00:00:09.000000', 'consum', 0.0227, 'lps'),
	(636285, 135, '2015-01-01 00:00:10.000000', 'consum', 0.0271, 'lps'),
	(636286, 135, '2015-01-01 00:00:11.000000', 'consum', 0.0216, 'lps'),
	(636287, 135, '2015-01-01 00:00:12.000000', 'consum', 0.0245, 'lps'),
	(636288, 135, '2015-01-01 00:00:13.000000', 'consum', 0.0242, 'lps'),
	(636289, 135, '2015-01-01 00:00:14.000000', 'consum', 0.0264, 'lps'),
	(636290, 135, '2015-01-01 00:00:15.000000', 'consum', 0.0263, 'lps'),
	(636291, 135, '2015-01-01 00:00:16.000000', 'consum', 0.0251, 'lps'),
	(636292, 135, '2015-01-01 00:00:17.000000', 'consum', 0.0255, 'lps'),
	(636293, 135, '2015-01-01 00:00:18.000000', 'consum', 0.0253, 'lps'),
	(636294, 135, '2015-01-01 00:00:19.000000', 'consum', 0.0226, 'lps'),
	(636295, 135, '2015-01-01 00:00:20.000000', 'consum', 0.0227, 'lps'),
	(636296, 135, '2015-01-01 00:00:21.000000', 'consum', 0.0244, 'lps'),
	(636297, 135, '2015-01-01 00:00:22.000000', 'consum', 0.0268, 'lps'),
	(636298, 135, '2015-01-01 00:00:23.000000', 'consum', 0.0213, 'lps'),
	(636299, 135, '2015-01-01 00:00:24.000000', 'consum', 0.0239, 'lps'),
	(636300, 135, '2015-01-01 00:00:25.000000', 'consum', 0.0223, 'lps'),
	(636301, 135, '2015-01-01 00:00:26.000000', 'consum', 0.0249, 'lps'),
	(636302, 135, '2015-01-01 00:00:27.000000', 'consum', 0.0241, 'lps'),
	(636303, 135, '2015-01-01 00:00:28.000000', 'consum', 0.0252, 'lps'),
	(636304, 135, '2015-01-01 00:00:29.000000', 'consum', 0.0262, 'lps'),
	(636305, 135, '2015-01-01 00:00:30.000000', 'consum', 0.0224, 'lps'),
	(636306, 135, '2015-01-01 00:00:31.000000', 'consum', 0.0247, 'lps'),
	(636307, 135, '2015-01-01 00:00:32.000000', 'consum', 0.0229, 'lps'),
	(636308, 135, '2015-01-01 00:00:33.000000', 'consum', 0.0257, 'lps'),
	(636309, 135, '2015-01-01 00:00:34.000000', 'consum', 0.0265, 'lps'),
	(636310, 135, '2015-01-01 00:00:35.000000', 'consum', 0.0218, 'lps'),
	(636311, 135, '2015-01-01 00:00:36.000000', 'consum', 0.0211, 'lps'),
	(636312, 135, '2015-01-01 00:00:37.000000', 'consum', 0.0255, 'lps'),
	(636313, 135, '2015-01-01 00:00:38.000000', 'consum', 0.0246, 'lps'),
	(636314, 135, '2015-01-01 00:00:39.000000', 'consum', 0.0256, 'lps'),
	(636315, 135, '2015-01-01 00:00:40.000000', 'consum', 0.0210, 'lps'),
	(636316, 135, '2015-01-01 00:00:41.000000', 'consum', 0.0256, 'lps'),
	(636317, 135, '2015-01-01 00:00:42.000000', 'consum', 0.0254, 'lps'),
	(636318, 135, '2015-01-01 00:00:43.000000', 'consum', 0.0229, 'lps'),
	(636319, 135, '2015-01-01 00:00:44.000000', 'consum', 0.0238, 'lps'),
	(636320, 135, '2015-01-01 00:00:45.000000', 'consum', 0.0233, 'lps'),
	(636321, 135, '2015-01-01 00:00:46.000000', 'consum', 0.0239, 'lps'),
	(636322, 135, '2015-01-01 00:00:47.000000', 'consum', 0.0224, 'lps'),
	(636323, 135, '2015-01-01 00:00:48.000000', 'consum', 0.0258, 'lps'),
	(636324, 135, '2015-01-01 00:00:49.000000', 'consum', 0.0219, 'lps'),
	(636325, 135, '2015-01-01 00:00:50.000000', 'consum', 0.0239, 'lps'),
	(636326, 135, '2015-01-01 00:00:51.000000', 'consum', 0.0264, 'lps'),
	(636327, 135, '2015-01-01 00:00:52.000000', 'consum', 0.0269, 'lps'),
	(636328, 135, '2015-01-01 00:00:53.000000', 'consum', 0.0222, 'lps'),
	(636329, 135, '2015-01-01 00:00:54.000000', 'consum', 0.0217, 'lps'),
	(636330, 135, '2015-01-01 00:00:55.000000', 'consum', 0.0211, 'lps'),
	(636331, 135, '2015-01-01 00:00:56.000000', 'consum', 0.0255, 'lps'),
	(636332, 135, '2015-01-01 00:00:57.000000', 'consum', 0.0245, 'lps'),
	(636333, 135, '2015-01-01 00:00:58.000000', 'consum', 0.0250, 'lps'),
	(636334, 135, '2015-01-01 00:00:59.000000', 'consum', 0.0243, 'lps'),
	(636335, 135, '2015-01-01 00:01:00.000000', 'consum', 0.0255, 'lps'),
	(636336, 135, '2015-01-01 00:01:01.000000', 'consum', 0.0214, 'lps'),
	(636337, 135, '2015-01-01 00:01:02.000000', 'consum', 0.0220, 'lps'),
	(636338, 135, '2015-01-01 00:01:03.000000', 'consum', 0.0247, 'lps'),
	(636339, 135, '2015-01-01 00:01:04.000000', 'consum', 0.0243, 'lps'),
	(636340, 135, '2015-01-01 00:01:05.000000', 'consum', 0.0262, 'lps'),
	(636341, 135, '2015-01-01 00:01:06.000000', 'consum', 0.0251, 'lps'),
	(636342, 135, '2015-01-01 00:01:07.000000', 'consum', 0.0258, 'lps'),
	(636343, 135, '2015-01-01 00:01:08.000000', 'consum', 0.0264, 'lps'),
	(636344, 135, '2015-01-01 00:01:09.000000', 'consum', 0.0214, 'lps'),
	(636345, 135, '2015-01-01 00:01:10.000000', 'consum', 0.0253, 'lps'),
	(636346, 135, '2015-01-01 00:01:11.000000', 'consum', 0.0229, 'lps'),
	(636347, 135, '2015-01-01 00:01:12.000000', 'consum', 0.0239, 'lps'),
	(636348, 135, '2015-01-01 00:01:13.000000', 'consum', 0.0236, 'lps'),
	(636349, 135, '2015-01-01 00:01:14.000000', 'consum', 0.0255, 'lps'),
	(636350, 135, '2015-01-01 00:01:15.000000', 'consum', 0.0231, 'lps'),
	(636351, 135, '2015-01-01 00:01:16.000000', 'consum', 0.0244, 'lps'),
	(636352, 135, '2015-01-01 00:01:17.000000', 'consum', 0.0254, 'lps'),
	(636353, 135, '2015-01-01 00:01:18.000000', 'consum', 0.0268, 'lps'),
	(636354, 135, '2015-01-01 00:01:19.000000', 'consum', 0.0243, 'lps'),
	(636355, 135, '2015-01-01 00:01:20.000000', 'consum', 0.0266, 'lps'),
	(636356, 135, '2015-01-01 00:01:21.000000', 'consum', 0.0266, 'lps'),
	(636357, 135, '2015-01-01 00:01:22.000000', 'consum', 0.0260, 'lps'),
	(636358, 135, '2015-01-01 00:01:23.000000', 'consum', 0.0232, 'lps'),
	(636359, 135, '2015-01-01 00:01:24.000000', 'consum', 0.0232, 'lps'),
	(636360, 135, '2015-01-01 00:01:25.000000', 'consum', 0.0254, 'lps'),
	(636361, 135, '2015-01-01 00:01:26.000000', 'consum', 0.0243, 'lps'),
	(636362, 135, '2015-01-01 00:01:27.000000', 'consum', 0.0241, 'lps'),
	(636363, 135, '2015-01-01 00:01:28.000000', 'consum', 0.0269, 'lps'),
	(636364, 135, '2015-01-01 00:01:29.000000', 'consum', 0.0225, 'lps'),
	(636365, 135, '2015-01-01 00:01:30.000000', 'consum', 0.0233, 'lps'),
	(636366, 135, '2015-01-01 00:01:31.000000', 'consum', 0.0217, 'lps'),
	(636367, 135, '2015-01-01 00:01:32.000000', 'consum', 0.0239, 'lps'),
	(636368, 135, '2015-01-01 00:01:33.000000', 'consum', 0.0211, 'lps'),
	(636369, 135, '2015-01-01 00:01:34.000000', 'consum', 0.0251, 'lps'),
	(636370, 135, '2015-01-01 00:01:35.000000', 'consum', 0.0228, 'lps'),
	(636371, 135, '2015-01-01 00:01:36.000000', 'consum', 0.0237, 'lps'),
	(636372, 135, '2015-01-01 00:01:37.000000', 'consum', 0.0233, 'lps'),
	(636373, 135, '2015-01-01 00:01:38.000000', 'consum', 0.0241, 'lps'),
	(636374, 135, '2015-01-01 00:01:39.000000', 'consum', 0.0236, 'lps'),
	(636375, 135, '2015-01-01 00:01:40.000000', 'consum', 0.0248, 'lps'),
	(636376, 135, '2015-01-01 00:01:41.000000', 'consum', 0.0258, 'lps'),
	(636377, 135, '2015-01-01 00:01:42.000000', 'consum', 0.0215, 'lps'),
	(636378, 135, '2015-01-01 00:01:43.000000', 'consum', 0.0214, 'lps'),
	(636379, 135, '2015-01-01 00:01:44.000000', 'consum', 0.0215, 'lps'),
	(636380, 135, '2015-01-01 00:01:45.000000', 'consum', 0.0225, 'lps'),
	(636381, 135, '2015-01-01 00:01:46.000000', 'consum', 0.0270, 'lps'),
	(636382, 135, '2015-01-01 00:01:47.000000', 'consum', 0.0218, 'lps'),
	(636383, 135, '2015-01-01 00:01:48.000000', 'consum', 0.0258, 'lps'),
	(636384, 135, '2015-01-01 00:01:49.000000', 'consum', 0.0239, 'lps'),
	(636385, 135, '2015-01-01 00:01:50.000000', 'consum', 0.0212, 'lps'),
	(636386, 135, '2015-01-01 00:01:51.000000', 'consum', 0.0256, 'lps'),
	(636387, 135, '2015-01-01 00:01:52.000000', 'consum', 0.0251, 'lps'),
	(636388, 135, '2015-01-01 00:01:53.000000', 'consum', 0.0215, 'lps'),
	(636389, 135, '2015-01-01 00:01:54.000000', 'consum', 0.0235, 'lps'),
	(636390, 135, '2015-01-01 00:01:55.000000', 'consum', 0.0260, 'lps'),
	(636391, 135, '2015-01-01 00:01:56.000000', 'consum', 0.0259, 'lps'),
	(636392, 135, '2015-01-01 00:01:57.000000', 'consum', 0.0246, 'lps'),
	(636393, 135, '2015-01-01 00:01:58.000000', 'consum', 0.0243, 'lps'),
	(636394, 135, '2015-01-01 00:01:59.000000', 'consum', 0.0268, 'lps'),
	(636395, 135, '2015-01-01 00:02:00.000000', 'consum', 0.0215, 'lps'),
	(636396, 135, '2015-01-01 00:02:01.000000', 'consum', 0.0247, 'lps'),
	(636397, 135, '2015-01-01 00:02:02.000000', 'consum', 0.0259, 'lps'),
	(636398, 135, '2015-01-01 00:02:03.000000', 'consum', 0.0219, 'lps'),
	(636399, 135, '2015-01-01 00:02:04.000000', 'consum', 0.0232, 'lps'),
	(636400, 135, '2015-01-01 00:02:05.000000', 'consum', 0.0231, 'lps'),
	(636401, 135, '2015-01-01 00:02:06.000000', 'consum', 0.0252, 'lps'),
	(636402, 135, '2015-01-01 00:02:07.000000', 'consum', 0.0231, 'lps'),
	(636403, 135, '2015-01-01 00:02:08.000000', 'consum', 0.0254, 'lps'),
	(636404, 135, '2015-01-01 00:02:09.000000', 'consum', 0.0241, 'lps'),
	(636405, 135, '2015-01-01 00:02:10.000000', 'consum', 0.0236, 'lps'),
	(636406, 135, '2015-01-01 00:02:11.000000', 'consum', 0.0248, 'lps'),
	(636407, 135, '2015-01-01 00:02:12.000000', 'consum', 0.0258, 'lps'),
	(636408, 135, '2015-01-01 00:02:13.000000', 'consum', 0.0213, 'lps'),
	(636409, 135, '2015-01-01 00:02:14.000000', 'consum', 0.0268, 'lps'),
	(636410, 135, '2015-01-01 00:02:15.000000', 'consum', 0.0245, 'lps'),
	(636411, 135, '2015-01-01 00:02:16.000000', 'consum', 0.0211, 'lps'),
	(636412, 135, '2015-01-01 00:02:17.000000', 'consum', 0.0234, 'lps'),
	(636413, 135, '2015-01-01 00:02:18.000000', 'consum', 0.0266, 'lps'),
	(636414, 135, '2015-01-01 00:02:19.000000', 'consum', 0.0230, 'lps'),
	(636415, 135, '2015-01-01 00:02:20.000000', 'consum', 0.0270, 'lps'),
	(636416, 135, '2015-01-01 00:02:21.000000', 'consum', 0.0263, 'lps'),
	(636417, 135, '2015-01-01 00:02:22.000000', 'consum', 0.0233, 'lps'),
	(636418, 135, '2015-01-01 00:02:23.000000', 'consum', 0.0230, 'lps'),
	(636419, 135, '2015-01-01 00:02:24.000000', 'consum', 0.0240, 'lps'),
	(636420, 135, '2015-01-01 00:02:25.000000', 'consum', 0.0238, 'lps'),
	(636421, 135, '2015-01-01 00:02:26.000000', 'consum', 0.0259, 'lps'),
	(636422, 135, '2015-01-01 00:02:27.000000', 'consum', 0.0250, 'lps'),
	(636423, 135, '2015-01-01 00:02:28.000000', 'consum', 0.0263, 'lps'),
	(636424, 135, '2015-01-01 00:02:29.000000', 'consum', 0.0233, 'lps'),
	(636425, 135, '2015-01-01 00:02:30.000000', 'consum', 0.0228, 'lps'),
	(636426, 135, '2015-01-01 00:02:31.000000', 'consum', 0.0233, 'lps'),
	(636427, 135, '2015-01-01 00:02:32.000000', 'consum', 0.0271, 'lps'),
	(636428, 135, '2015-01-01 00:02:33.000000', 'consum', 0.0260, 'lps'),
	(636429, 135, '2015-01-01 00:02:34.000000', 'consum', 0.0215, 'lps'),
	(636430, 135, '2015-01-01 00:02:35.000000', 'consum', 0.0270, 'lps'),
	(636431, 135, '2015-01-01 00:02:36.000000', 'consum', 0.0250, 'lps'),
	(636432, 135, '2015-01-01 00:02:37.000000', 'consum', 0.0228, 'lps'),
	(636433, 135, '2015-01-01 00:02:38.000000', 'consum', 0.0243, 'lps'),
	(636434, 135, '2015-01-01 00:02:39.000000', 'consum', 0.0259, 'lps'),
	(636435, 135, '2015-01-01 00:02:40.000000', 'consum', 0.0234, 'lps'),
	(636436, 135, '2015-01-01 00:02:41.000000', 'consum', 0.0245, 'lps'),
	(636437, 135, '2015-01-01 00:02:42.000000', 'consum', 0.0253, 'lps'),
	(636438, 135, '2015-01-01 00:02:43.000000', 'consum', 0.0255, 'lps'),
	(636439, 135, '2015-01-01 00:02:44.000000', 'consum', 0.0248, 'lps'),
	(636440, 135, '2015-01-01 00:02:45.000000', 'consum', 0.0263, 'lps'),
	(636441, 135, '2015-01-01 00:02:46.000000', 'consum', 0.0236, 'lps'),
	(636442, 135, '2015-01-01 00:02:47.000000', 'consum', 0.0247, 'lps'),
	(636443, 135, '2015-01-01 00:02:48.000000', 'consum', 0.0255, 'lps'),
	(636444, 135, '2015-01-01 00:02:49.000000', 'consum', 0.0264, 'lps'),
	(636445, 135, '2015-01-01 00:02:50.000000', 'consum', 0.0219, 'lps'),
	(636446, 135, '2015-01-01 00:02:51.000000', 'consum', 0.0218, 'lps'),
	(636447, 135, '2015-01-01 00:02:52.000000', 'consum', 0.0224, 'lps'),
	(636448, 135, '2015-01-01 00:02:53.000000', 'consum', 0.0258, 'lps'),
	(636449, 135, '2015-01-01 00:02:54.000000', 'consum', 0.0220, 'lps'),
	(636450, 135, '2015-01-01 00:02:55.000000', 'consum', 0.0243, 'lps'),
	(636451, 135, '2015-01-01 00:02:56.000000', 'consum', 0.0221, 'lps'),
	(636452, 135, '2015-01-01 00:02:57.000000', 'consum', 0.0226, 'lps'),
	(636453, 135, '2015-01-01 00:02:58.000000', 'consum', 0.0260, 'lps'),
	(636454, 135, '2015-01-01 00:02:59.000000', 'consum', 0.0226, 'lps'),
	(636455, 135, '2015-01-01 00:03:00.000000', 'consum', 0.0262, 'lps'),
	(636456, 135, '2015-01-01 00:03:01.000000', 'consum', 0.0240, 'lps'),
	(636457, 135, '2015-01-01 00:03:02.000000', 'consum', 0.0266, 'lps'),
	(636458, 135, '2015-01-01 00:03:03.000000', 'consum', 0.0214, 'lps'),
	(636459, 135, '2015-01-01 00:03:04.000000', 'consum', 0.0249, 'lps'),
	(636460, 135, '2015-01-01 00:03:05.000000', 'consum', 0.0270, 'lps'),
	(636461, 135, '2015-01-01 00:03:06.000000', 'consum', 0.0269, 'lps'),
	(636462, 135, '2015-01-01 00:03:07.000000', 'consum', 0.0263, 'lps'),
	(636463, 135, '2015-01-01 00:03:08.000000', 'consum', 0.0236, 'lps'),
	(636464, 135, '2015-01-01 00:03:09.000000', 'consum', 0.0244, 'lps'),
	(636465, 135, '2015-01-01 00:03:10.000000', 'consum', 0.0239, 'lps'),
	(636466, 135, '2015-01-01 00:03:11.000000', 'consum', 0.0256, 'lps'),
	(636467, 135, '2015-01-01 00:03:12.000000', 'consum', 0.0230, 'lps'),
	(636468, 135, '2015-01-01 00:03:13.000000', 'consum', 0.0234, 'lps'),
	(636469, 135, '2015-01-01 00:03:14.000000', 'consum', 0.0271, 'lps'),
	(636470, 135, '2015-01-01 00:03:15.000000', 'consum', 0.0255, 'lps'),
	(636471, 135, '2015-01-01 00:03:16.000000', 'consum', 0.0253, 'lps'),
	(636472, 135, '2015-01-01 00:03:17.000000', 'consum', 0.0229, 'lps'),
	(636473, 135, '2015-01-01 00:03:18.000000', 'consum', 0.0238, 'lps'),
	(636474, 135, '2015-01-01 00:03:19.000000', 'consum', 0.0230, 'lps'),
	(636475, 135, '2015-01-01 00:03:20.000000', 'consum', 0.0229, 'lps'),
	(636476, 135, '2015-01-01 00:03:21.000000', 'consum', 0.0246, 'lps'),
	(636477, 135, '2015-01-01 00:03:22.000000', 'consum', 0.0210, 'lps'),
	(636478, 135, '2015-01-01 00:03:23.000000', 'consum', 0.0226, 'lps'),
	(636479, 135, '2015-01-01 00:03:24.000000', 'consum', 0.0229, 'lps'),
	(636480, 135, '2015-01-01 00:03:25.000000', 'consum', 0.0256, 'lps'),
	(636481, 135, '2015-01-01 00:03:26.000000', 'consum', 0.0262, 'lps'),
	(636482, 135, '2015-01-01 00:03:27.000000', 'consum', 0.0269, 'lps'),
	(636483, 135, '2015-01-01 00:03:28.000000', 'consum', 0.0226, 'lps'),
	(636484, 135, '2015-01-01 00:03:29.000000', 'consum', 0.0237, 'lps'),
	(636485, 135, '2015-01-01 00:03:30.000000', 'consum', 0.0234, 'lps'),
	(636486, 135, '2015-01-01 00:03:31.000000', 'consum', 0.0249, 'lps'),
	(636487, 135, '2015-01-01 00:03:32.000000', 'consum', 0.0212, 'lps'),
	(636488, 135, '2015-01-01 00:03:33.000000', 'consum', 0.0226, 'lps'),
	(636489, 135, '2015-01-01 00:03:34.000000', 'consum', 0.0221, 'lps'),
	(636490, 135, '2015-01-01 00:03:35.000000', 'consum', 0.0220, 'lps'),
	(636491, 135, '2015-01-01 00:03:36.000000', 'consum', 0.0228, 'lps'),
	(636492, 135, '2015-01-01 00:03:37.000000', 'consum', 0.0271, 'lps'),
	(636493, 135, '2015-01-01 00:03:38.000000', 'consum', 0.0211, 'lps'),
	(636494, 135, '2015-01-01 00:03:39.000000', 'consum', 0.0221, 'lps'),
	(636495, 135, '2015-01-01 00:03:40.000000', 'consum', 0.0263, 'lps'),
	(636496, 135, '2015-01-01 00:03:41.000000', 'consum', 0.0257, 'lps'),
	(636497, 135, '2015-01-01 00:03:42.000000', 'consum', 0.0223, 'lps'),
	(636498, 135, '2015-01-01 00:03:43.000000', 'consum', 0.0259, 'lps'),
	(636499, 135, '2015-01-01 00:03:44.000000', 'consum', 0.0230, 'lps'),
	(636500, 135, '2015-01-01 00:03:45.000000', 'consum', 0.0227, 'lps'),
	(636501, 135, '2015-01-01 00:03:46.000000', 'consum', 0.0234, 'lps'),
	(636502, 135, '2015-01-01 00:03:47.000000', 'consum', 0.0216, 'lps'),
	(636503, 135, '2015-01-01 00:03:48.000000', 'consum', 0.0233, 'lps'),
	(636504, 135, '2015-01-01 00:03:49.000000', 'consum', 0.0246, 'lps'),
	(636505, 135, '2015-01-01 00:03:50.000000', 'consum', 0.0259, 'lps'),
	(636506, 135, '2015-01-01 00:03:51.000000', 'consum', 0.0224, 'lps'),
	(636507, 135, '2015-01-01 00:03:52.000000', 'consum', 0.0257, 'lps'),
	(636508, 135, '2015-01-01 00:03:53.000000', 'consum', 0.0216, 'lps'),
	(636509, 135, '2015-01-01 00:03:54.000000', 'consum', 0.0224, 'lps'),
	(636510, 135, '2015-01-01 00:03:55.000000', 'consum', 0.0264, 'lps'),
	(636511, 135, '2015-01-01 00:03:56.000000', 'consum', 0.0251, 'lps'),
	(636512, 135, '2015-01-01 00:03:57.000000', 'consum', 0.0254, 'lps'),
	(636513, 135, '2015-01-01 00:03:58.000000', 'consum', 0.0244, 'lps'),
	(636514, 135, '2015-01-01 00:03:59.000000', 'consum', 0.0251, 'lps'),
	(636515, 135, '2015-01-01 00:04:00.000000', 'consum', 0.0249, 'lps'),
	(636516, 135, '2015-01-01 00:04:01.000000', 'consum', 0.0223, 'lps'),
	(636517, 135, '2015-01-01 00:04:02.000000', 'consum', 0.0219, 'lps'),
	(636518, 135, '2015-01-01 00:04:03.000000', 'consum', 0.0219, 'lps'),
	(636519, 135, '2015-01-01 00:04:04.000000', 'consum', 0.0225, 'lps'),
	(636520, 135, '2015-01-01 00:04:05.000000', 'consum', 0.0261, 'lps'),
	(636521, 135, '2015-01-01 00:04:06.000000', 'consum', 0.0235, 'lps'),
	(636522, 135, '2015-01-01 00:04:07.000000', 'consum', 0.0242, 'lps'),
	(636523, 135, '2015-01-01 00:04:08.000000', 'consum', 0.0233, 'lps'),
	(636524, 135, '2015-01-01 00:04:09.000000', 'consum', 0.0230, 'lps'),
	(636525, 135, '2015-01-01 00:04:10.000000', 'consum', 0.0241, 'lps'),
	(636526, 135, '2015-01-01 00:04:11.000000', 'consum', 0.0244, 'lps'),
	(636527, 135, '2015-01-01 00:04:12.000000', 'consum', 0.0224, 'lps'),
	(636528, 135, '2015-01-01 00:04:13.000000', 'consum', 0.0240, 'lps'),
	(636529, 135, '2015-01-01 00:04:14.000000', 'consum', 0.0259, 'lps'),
	(636530, 135, '2015-01-01 00:04:15.000000', 'consum', 0.0242, 'lps'),
	(636531, 135, '2015-01-01 00:04:16.000000', 'consum', 0.0222, 'lps'),
	(636532, 135, '2015-01-01 00:04:17.000000', 'consum', 0.0236, 'lps'),
	(636533, 135, '2015-01-01 00:04:18.000000', 'consum', 0.0242, 'lps'),
	(636534, 135, '2015-01-01 00:04:19.000000', 'consum', 0.0233, 'lps'),
	(636535, 135, '2015-01-01 00:04:20.000000', 'consum', 0.0228, 'lps'),
	(636536, 135, '2015-01-01 00:04:21.000000', 'consum', 0.0231, 'lps'),
	(636537, 135, '2015-01-01 00:04:22.000000', 'consum', 0.0261, 'lps'),
	(636538, 135, '2015-01-01 00:04:23.000000', 'consum', 0.0219, 'lps'),
	(636539, 135, '2015-01-01 00:04:24.000000', 'consum', 0.0223, 'lps'),
	(636540, 135, '2015-01-01 00:04:25.000000', 'consum', 0.0252, 'lps'),
	(636541, 135, '2015-01-01 00:04:26.000000', 'consum', 0.0255, 'lps'),
	(636542, 135, '2015-01-01 00:04:27.000000', 'consum', 0.0248, 'lps'),
	(636543, 135, '2015-01-01 00:04:28.000000', 'consum', 0.0266, 'lps'),
	(636544, 135, '2015-01-01 00:04:29.000000', 'consum', 0.0253, 'lps'),
	(636545, 135, '2015-01-01 00:04:30.000000', 'consum', 0.0259, 'lps'),
	(636546, 135, '2015-01-01 00:04:31.000000', 'consum', 0.0262, 'lps'),
	(636547, 135, '2015-01-01 00:04:32.000000', 'consum', 0.0262, 'lps'),
	(636548, 135, '2015-01-01 00:04:33.000000', 'consum', 0.0251, 'lps'),
	(636549, 135, '2015-01-01 00:04:34.000000', 'consum', 0.0262, 'lps'),
	(636550, 135, '2015-01-01 00:04:35.000000', 'consum', 0.0222, 'lps'),
	(636551, 135, '2015-01-01 00:04:36.000000', 'consum', 0.0237, 'lps'),
	(636552, 135, '2015-01-01 00:04:37.000000', 'consum', 0.0248, 'lps'),
	(636553, 135, '2015-01-01 00:04:38.000000', 'consum', 0.0260, 'lps'),
	(636554, 135, '2015-01-01 00:04:39.000000', 'consum', 0.0219, 'lps'),
	(636555, 135, '2015-01-01 00:04:40.000000', 'consum', 0.0233, 'lps'),
	(636556, 135, '2015-01-01 00:04:41.000000', 'consum', 0.0235, 'lps'),
	(636557, 135, '2015-01-01 00:04:42.000000', 'consum', 0.0268, 'lps'),
	(636558, 135, '2015-01-01 00:04:43.000000', 'consum', 0.0239, 'lps'),
	(636559, 135, '2015-01-01 00:04:44.000000', 'consum', 0.0242, 'lps'),
	(636560, 135, '2015-01-01 00:04:45.000000', 'consum', 0.0221, 'lps'),
	(636561, 135, '2015-01-01 00:04:46.000000', 'consum', 0.0233, 'lps'),
	(636562, 135, '2015-01-01 00:04:47.000000', 'consum', 0.0230, 'lps'),
	(636563, 135, '2015-01-01 00:04:48.000000', 'consum', 0.0244, 'lps'),
	(636564, 135, '2015-01-01 00:04:49.000000', 'consum', 0.0255, 'lps'),
	(636565, 135, '2015-01-01 00:04:50.000000', 'consum', 0.0211, 'lps'),
	(636566, 135, '2015-01-01 00:04:51.000000', 'consum', 0.0268, 'lps'),
	(636567, 135, '2015-01-01 00:04:52.000000', 'consum', 0.0248, 'lps'),
	(636568, 135, '2015-01-01 00:04:53.000000', 'consum', 0.0227, 'lps'),
	(636569, 135, '2015-01-01 00:04:54.000000', 'consum', 0.0245, 'lps'),
	(636570, 135, '2015-01-01 00:04:55.000000', 'consum', 0.0270, 'lps'),
	(636571, 135, '2015-01-01 00:04:56.000000', 'consum', 0.0220, 'lps'),
	(636572, 135, '2015-01-01 00:04:57.000000', 'consum', 0.0266, 'lps'),
	(636573, 135, '2015-01-01 00:04:58.000000', 'consum', 0.0211, 'lps'),
	(636574, 135, '2015-01-01 00:04:59.000000', 'consum', 0.0237, 'lps'),
	(636575, 135, '2015-01-01 00:05:00.000000', 'consum', 0.0216, 'lps'),
	(636576, 135, '2015-01-01 00:05:01.000000', 'consum', 0.0224, 'lps'),
	(636577, 135, '2015-01-01 00:05:02.000000', 'consum', 0.0259, 'lps'),
	(636578, 135, '2015-01-01 00:05:03.000000', 'consum', 0.0230, 'lps'),
	(636579, 135, '2015-01-01 00:05:04.000000', 'consum', 0.0224, 'lps'),
	(636580, 135, '2015-01-01 00:05:05.000000', 'consum', 0.0220, 'lps'),
	(636581, 135, '2015-01-01 00:05:06.000000', 'consum', 0.0220, 'lps'),
	(636582, 135, '2015-01-01 00:05:07.000000', 'consum', 0.0229, 'lps'),
	(636583, 135, '2015-01-01 00:05:08.000000', 'consum', 0.0213, 'lps'),
	(636584, 135, '2015-01-01 00:05:09.000000', 'consum', 0.0231, 'lps'),
	(636585, 135, '2015-01-01 00:05:10.000000', 'consum', 0.0245, 'lps'),
	(636586, 135, '2015-01-01 00:05:11.000000', 'consum', 0.0262, 'lps'),
	(636587, 135, '2015-01-01 00:05:12.000000', 'consum', 0.0240, 'lps'),
	(636588, 135, '2015-01-01 00:05:13.000000', 'consum', 0.0266, 'lps'),
	(636589, 135, '2015-01-01 00:05:14.000000', 'consum', 0.0216, 'lps'),
	(636590, 135, '2015-01-01 00:05:15.000000', 'consum', 0.0256, 'lps'),
	(636591, 135, '2015-01-01 00:05:16.000000', 'consum', 0.0237, 'lps'),
	(636592, 135, '2015-01-01 00:05:17.000000', 'consum', 0.0269, 'lps'),
	(636593, 135, '2015-01-01 00:05:18.000000', 'consum', 0.0241, 'lps'),
	(636594, 135, '2015-01-01 00:05:19.000000', 'consum', 0.0249, 'lps'),
	(636595, 135, '2015-01-01 00:05:20.000000', 'consum', 0.0251, 'lps'),
	(636596, 135, '2015-01-01 00:05:21.000000', 'consum', 0.0236, 'lps'),
	(636597, 135, '2015-01-01 00:05:22.000000', 'consum', 0.0220, 'lps'),
	(636598, 135, '2015-01-01 00:05:23.000000', 'consum', 0.0241, 'lps'),
	(636599, 135, '2015-01-01 00:05:24.000000', 'consum', 0.0214, 'lps'),
	(636600, 135, '2015-01-01 00:05:25.000000', 'consum', 0.0260, 'lps'),
	(636601, 135, '2015-01-01 00:05:26.000000', 'consum', 0.0262, 'lps'),
	(636602, 135, '2015-01-01 00:05:27.000000', 'consum', 0.0259, 'lps'),
	(636603, 135, '2015-01-01 00:05:28.000000', 'consum', 0.0239, 'lps'),
	(636604, 135, '2015-01-01 00:05:29.000000', 'consum', 0.0271, 'lps'),
	(636605, 135, '2015-01-01 00:05:30.000000', 'consum', 0.0240, 'lps'),
	(636606, 135, '2015-01-01 00:05:31.000000', 'consum', 0.0240, 'lps'),
	(636607, 135, '2015-01-01 00:05:32.000000', 'consum', 0.0270, 'lps'),
	(636608, 135, '2015-01-01 00:05:33.000000', 'consum', 0.0237, 'lps'),
	(636609, 135, '2015-01-01 00:05:34.000000', 'consum', 0.0225, 'lps'),
	(636610, 135, '2015-01-01 00:05:35.000000', 'consum', 0.0266, 'lps'),
	(636611, 135, '2015-01-01 00:05:36.000000', 'consum', 0.0262, 'lps'),
	(636612, 135, '2015-01-01 00:05:37.000000', 'consum', 0.0238, 'lps'),
	(636613, 135, '2015-01-01 00:05:38.000000', 'consum', 0.0258, 'lps'),
	(636614, 135, '2015-01-01 00:05:39.000000', 'consum', 0.0242, 'lps'),
	(636615, 135, '2015-01-01 00:05:40.000000', 'consum', 0.0227, 'lps'),
	(636616, 135, '2015-01-01 00:05:41.000000', 'consum', 0.0259, 'lps'),
	(636617, 135, '2015-01-01 00:05:42.000000', 'consum', 0.0221, 'lps'),
	(636618, 135, '2015-01-01 00:05:43.000000', 'consum', 0.0242, 'lps'),
	(636619, 135, '2015-01-01 00:05:44.000000', 'consum', 0.0213, 'lps'),
	(636620, 135, '2015-01-01 00:05:45.000000', 'consum', 0.0256, 'lps'),
	(636621, 135, '2015-01-01 00:05:46.000000', 'consum', 0.0242, 'lps'),
	(636622, 135, '2015-01-01 00:05:47.000000', 'consum', 0.0236, 'lps'),
	(636623, 135, '2015-01-01 00:05:48.000000', 'consum', 0.0242, 'lps'),
	(636624, 135, '2015-01-01 00:05:49.000000', 'consum', 0.0232, 'lps'),
	(636625, 135, '2015-01-01 00:05:50.000000', 'consum', 0.0225, 'lps'),
	(636626, 135, '2015-01-01 00:05:51.000000', 'consum', 0.0219, 'lps'),
	(636627, 135, '2015-01-01 00:05:52.000000', 'consum', 0.0210, 'lps'),
	(636628, 135, '2015-01-01 00:05:53.000000', 'consum', 0.0247, 'lps'),
	(636629, 135, '2015-01-01 00:05:54.000000', 'consum', 0.0270, 'lps'),
	(636630, 135, '2015-01-01 00:05:55.000000', 'consum', 0.0215, 'lps'),
	(636631, 135, '2015-01-01 00:05:56.000000', 'consum', 0.0239, 'lps'),
	(636632, 135, '2015-01-01 00:05:57.000000', 'consum', 0.0218, 'lps'),
	(636633, 135, '2015-01-01 00:05:58.000000', 'consum', 0.0224, 'lps'),
	(636634, 135, '2015-01-01 00:05:59.000000', 'consum', 0.0256, 'lps'),
	(636635, 135, '2015-01-01 00:06:00.000000', 'consum', 0.0214, 'lps'),
	(636636, 135, '2015-01-01 00:06:01.000000', 'consum', 0.0216, 'lps'),
	(636637, 135, '2015-01-01 00:06:02.000000', 'consum', 0.0228, 'lps'),
	(636638, 135, '2015-01-01 00:06:03.000000', 'consum', 0.0220, 'lps'),
	(636639, 135, '2015-01-01 00:06:04.000000', 'consum', 0.0271, 'lps'),
	(636640, 135, '2015-01-01 00:06:05.000000', 'consum', 0.0235, 'lps'),
	(636641, 135, '2015-01-01 00:06:06.000000', 'consum', 0.0215, 'lps'),
	(636642, 135, '2015-01-01 00:06:07.000000', 'consum', 0.0224, 'lps'),
	(636643, 135, '2015-01-01 00:06:08.000000', 'consum', 0.0266, 'lps'),
	(636644, 135, '2015-01-01 00:06:09.000000', 'consum', 0.0260, 'lps'),
	(636645, 135, '2015-01-01 00:06:10.000000', 'consum', 0.0233, 'lps'),
	(636646, 135, '2015-01-01 00:06:11.000000', 'consum', 0.0235, 'lps'),
	(636647, 135, '2015-01-01 00:06:12.000000', 'consum', 0.0266, 'lps'),
	(636648, 135, '2015-01-01 00:06:13.000000', 'consum', 0.0232, 'lps'),
	(636649, 135, '2015-01-01 00:06:14.000000', 'consum', 0.0215, 'lps'),
	(636650, 135, '2015-01-01 00:06:15.000000', 'consum', 0.0230, 'lps'),
	(636651, 135, '2015-01-01 00:06:16.000000', 'consum', 0.0235, 'lps'),
	(636652, 135, '2015-01-01 00:06:17.000000', 'consum', 0.0213, 'lps'),
	(636653, 135, '2015-01-01 00:06:18.000000', 'consum', 0.0211, 'lps'),
	(636654, 135, '2015-01-01 00:06:19.000000', 'consum', 0.0269, 'lps'),
	(636655, 135, '2015-01-01 00:06:20.000000', 'consum', 0.0256, 'lps'),
	(636656, 135, '2015-01-01 00:06:21.000000', 'consum', 0.0265, 'lps'),
	(636657, 135, '2015-01-01 00:06:22.000000', 'consum', 0.0220, 'lps'),
	(636658, 135, '2015-01-01 00:06:23.000000', 'consum', 0.0221, 'lps'),
	(636659, 135, '2015-01-01 00:06:24.000000', 'consum', 0.0236, 'lps'),
	(636660, 135, '2015-01-01 00:06:25.000000', 'consum', 0.0246, 'lps'),
	(636661, 135, '2015-01-01 00:06:26.000000', 'consum', 0.0249, 'lps'),
	(636662, 135, '2015-01-01 00:06:27.000000', 'consum', 0.0235, 'lps'),
	(636663, 135, '2015-01-01 00:06:28.000000', 'consum', 0.0219, 'lps'),
	(636664, 135, '2015-01-01 00:06:29.000000', 'consum', 0.0244, 'lps'),
	(636665, 135, '2015-01-01 00:06:30.000000', 'consum', 0.0227, 'lps'),
	(636666, 135, '2015-01-01 00:06:31.000000', 'consum', 0.0258, 'lps'),
	(636667, 135, '2015-01-01 00:06:32.000000', 'consum', 0.0212, 'lps'),
	(636668, 135, '2015-01-01 00:06:33.000000', 'consum', 0.0264, 'lps'),
	(636669, 135, '2015-01-01 00:06:34.000000', 'consum', 0.0227, 'lps'),
	(636670, 135, '2015-01-01 00:06:35.000000', 'consum', 0.0258, 'lps'),
	(636671, 135, '2015-01-01 00:06:36.000000', 'consum', 0.0214, 'lps'),
	(636672, 135, '2015-01-01 00:06:37.000000', 'consum', 0.0210, 'lps'),
	(636673, 135, '2015-01-01 00:06:38.000000', 'consum', 0.0261, 'lps'),
	(636674, 135, '2015-01-01 00:06:39.000000', 'consum', 0.0218, 'lps'),
	(636675, 135, '2015-01-01 00:06:40.000000', 'consum', 0.0222, 'lps'),
	(636676, 135, '2015-01-01 00:06:41.000000', 'consum', 0.0245, 'lps'),
	(636677, 135, '2015-01-01 00:06:42.000000', 'consum', 0.0226, 'lps'),
	(636678, 135, '2015-01-01 00:06:43.000000', 'consum', 0.0249, 'lps'),
	(636679, 135, '2015-01-01 00:06:44.000000', 'consum', 0.0234, 'lps'),
	(636680, 135, '2015-01-01 00:06:45.000000', 'consum', 0.0212, 'lps'),
	(636681, 135, '2015-01-01 00:06:46.000000', 'consum', 0.0210, 'lps'),
	(636682, 135, '2015-01-01 00:06:47.000000', 'consum', 0.0268, 'lps'),
	(636683, 135, '2015-01-01 00:06:48.000000', 'consum', 0.0253, 'lps'),
	(636684, 135, '2015-01-01 00:06:49.000000', 'consum', 0.0253, 'lps'),
	(636685, 135, '2015-01-01 00:06:50.000000', 'consum', 0.0232, 'lps'),
	(636686, 135, '2015-01-01 00:06:51.000000', 'consum', 0.0255, 'lps'),
	(636687, 135, '2015-01-01 00:06:52.000000', 'consum', 0.0243, 'lps'),
	(636688, 135, '2015-01-01 00:06:53.000000', 'consum', 0.0242, 'lps'),
	(636689, 135, '2015-01-01 00:06:54.000000', 'consum', 0.0211, 'lps'),
	(636690, 135, '2015-01-01 00:06:55.000000', 'consum', 0.0241, 'lps'),
	(636691, 135, '2015-01-01 00:06:56.000000', 'consum', 0.0239, 'lps'),
	(636692, 135, '2015-01-01 00:06:57.000000', 'consum', 0.0262, 'lps'),
	(636693, 135, '2015-01-01 00:06:58.000000', 'consum', 0.0259, 'lps'),
	(636694, 135, '2015-01-01 00:06:59.000000', 'consum', 0.0236, 'lps'),
	(636695, 135, '2015-01-01 00:07:00.000000', 'consum', 0.0259, 'lps'),
	(636696, 135, '2015-01-01 00:07:01.000000', 'consum', 0.0252, 'lps'),
	(636697, 135, '2015-01-01 00:07:02.000000', 'consum', 0.0214, 'lps'),
	(636698, 135, '2015-01-01 00:07:03.000000', 'consum', 0.0225, 'lps'),
	(636699, 135, '2015-01-01 00:07:04.000000', 'consum', 0.0212, 'lps'),
	(636700, 135, '2015-01-01 00:07:05.000000', 'consum', 0.0240, 'lps'),
	(636701, 135, '2015-01-01 00:07:06.000000', 'consum', 0.0227, 'lps'),
	(636702, 135, '2015-01-01 00:07:07.000000', 'consum', 0.0270, 'lps'),
	(636703, 135, '2015-01-01 00:07:08.000000', 'consum', 0.0211, 'lps'),
	(636704, 135, '2015-01-01 00:07:09.000000', 'consum', 0.0223, 'lps'),
	(636705, 135, '2015-01-01 00:07:10.000000', 'consum', 0.0269, 'lps'),
	(636706, 135, '2015-01-01 00:07:11.000000', 'consum', 0.0221, 'lps'),
	(636707, 135, '2015-01-01 00:07:12.000000', 'consum', 0.0213, 'lps'),
	(636708, 135, '2015-01-01 00:07:13.000000', 'consum', 0.0252, 'lps'),
	(636709, 135, '2015-01-01 00:07:14.000000', 'consum', 0.0227, 'lps'),
	(636710, 135, '2015-01-01 00:07:15.000000', 'consum', 0.0233, 'lps'),
	(636711, 135, '2015-01-01 00:07:16.000000', 'consum', 0.0271, 'lps'),
	(636712, 135, '2015-01-01 00:07:17.000000', 'consum', 0.0264, 'lps'),
	(636713, 135, '2015-01-01 00:07:18.000000', 'consum', 0.0235, 'lps'),
	(636714, 135, '2015-01-01 00:07:19.000000', 'consum', 0.0234, 'lps'),
	(636715, 135, '2015-01-01 00:07:20.000000', 'consum', 0.0257, 'lps'),
	(636716, 135, '2015-01-01 00:07:21.000000', 'consum', 0.0251, 'lps'),
	(636717, 135, '2015-01-01 00:07:22.000000', 'consum', 0.0211, 'lps'),
	(636718, 135, '2015-01-01 00:07:23.000000', 'consum', 0.0216, 'lps'),
	(636719, 135, '2015-01-01 00:07:24.000000', 'consum', 0.0236, 'lps'),
	(636720, 135, '2015-01-01 00:07:25.000000', 'consum', 0.0263, 'lps'),
	(636721, 135, '2015-01-01 00:07:26.000000', 'consum', 0.0271, 'lps'),
	(636722, 135, '2015-01-01 00:07:27.000000', 'consum', 0.0235, 'lps'),
	(636723, 135, '2015-01-01 00:07:28.000000', 'consum', 0.0214, 'lps'),
	(636724, 135, '2015-01-01 00:07:29.000000', 'consum', 0.0218, 'lps'),
	(636725, 135, '2015-01-01 00:07:30.000000', 'consum', 0.0240, 'lps'),
	(636726, 135, '2015-01-01 00:07:31.000000', 'consum', 0.0271, 'lps'),
	(636727, 135, '2015-01-01 00:07:32.000000', 'consum', 0.0242, 'lps'),
	(636728, 135, '2015-01-01 00:07:33.000000', 'consum', 0.0248, 'lps'),
	(636729, 135, '2015-01-01 00:07:34.000000', 'consum', 0.0244, 'lps'),
	(636730, 135, '2015-01-01 00:07:35.000000', 'consum', 0.0266, 'lps'),
	(636731, 135, '2015-01-01 00:07:36.000000', 'consum', 0.0266, 'lps'),
	(636732, 135, '2015-01-01 00:07:37.000000', 'consum', 0.0260, 'lps'),
	(636733, 135, '2015-01-01 00:07:38.000000', 'consum', 0.0229, 'lps'),
	(636734, 135, '2015-01-01 00:07:39.000000', 'consum', 0.0217, 'lps'),
	(636735, 135, '2015-01-01 00:07:40.000000', 'consum', 0.0249, 'lps'),
	(636736, 135, '2015-01-01 00:07:41.000000', 'consum', 0.0264, 'lps'),
	(636737, 135, '2015-01-01 00:07:42.000000', 'consum', 0.0236, 'lps'),
	(636738, 135, '2015-01-01 00:07:43.000000', 'consum', 0.0242, 'lps'),
	(636739, 135, '2015-01-01 00:07:44.000000', 'consum', 0.0232, 'lps'),
	(636740, 135, '2015-01-01 00:07:45.000000', 'consum', 0.0226, 'lps'),
	(636741, 135, '2015-01-01 00:07:46.000000', 'consum', 0.0221, 'lps'),
	(636742, 135, '2015-01-01 00:07:47.000000', 'consum', 0.0218, 'lps'),
	(636743, 135, '2015-01-01 00:07:48.000000', 'consum', 0.0216, 'lps'),
	(636744, 135, '2015-01-01 00:07:49.000000', 'consum', 0.0219, 'lps'),
	(636745, 135, '2015-01-01 00:07:50.000000', 'consum', 0.0237, 'lps'),
	(636746, 135, '2015-01-01 00:07:51.000000', 'consum', 0.0258, 'lps'),
	(636747, 135, '2015-01-01 00:07:52.000000', 'consum', 0.0245, 'lps'),
	(636748, 135, '2015-01-01 00:07:53.000000', 'consum', 0.0239, 'lps'),
	(636749, 135, '2015-01-01 00:07:54.000000', 'consum', 0.0252, 'lps'),
	(636750, 135, '2015-01-01 00:07:55.000000', 'consum', 0.0270, 'lps'),
	(636751, 135, '2015-01-01 00:07:56.000000', 'consum', 0.0262, 'lps'),
	(636752, 135, '2015-01-01 00:07:57.000000', 'consum', 0.0228, 'lps'),
	(636753, 135, '2015-01-01 00:07:58.000000', 'consum', 0.0268, 'lps'),
	(636754, 135, '2015-01-01 00:07:59.000000', 'consum', 0.0261, 'lps'),
	(636755, 135, '2015-01-01 00:08:00.000000', 'consum', 0.0231, 'lps'),
	(636756, 135, '2015-01-01 00:08:01.000000', 'consum', 0.0223, 'lps'),
	(636757, 135, '2015-01-01 00:08:02.000000', 'consum', 0.0212, 'lps'),
	(636758, 135, '2015-01-01 00:08:03.000000', 'consum', 0.0245, 'lps'),
	(636759, 135, '2015-01-01 00:08:04.000000', 'consum', 0.0255, 'lps'),
	(636760, 135, '2015-01-01 00:08:05.000000', 'consum', 0.0269, 'lps'),
	(636761, 135, '2015-01-01 00:08:06.000000', 'consum', 0.0247, 'lps'),
	(636762, 135, '2015-01-01 00:08:07.000000', 'consum', 0.0220, 'lps'),
	(636763, 135, '2015-01-01 00:08:08.000000', 'consum', 0.0271, 'lps'),
	(636764, 135, '2015-01-01 00:08:09.000000', 'consum', 0.0237, 'lps'),
	(636765, 135, '2015-01-01 00:08:10.000000', 'consum', 0.0227, 'lps'),
	(636766, 135, '2015-01-01 00:08:11.000000', 'consum', 0.0215, 'lps'),
	(636767, 135, '2015-01-01 00:08:12.000000', 'consum', 0.0247, 'lps'),
	(636768, 135, '2015-01-01 00:08:13.000000', 'consum', 0.0253, 'lps'),
	(636769, 135, '2015-01-01 00:08:14.000000', 'consum', 0.0256, 'lps'),
	(636770, 135, '2015-01-01 00:08:15.000000', 'consum', 0.0248, 'lps'),
	(636771, 135, '2015-01-01 00:08:16.000000', 'consum', 0.0264, 'lps'),
	(636772, 135, '2015-01-01 00:08:17.000000', 'consum', 0.0243, 'lps'),
	(636773, 135, '2015-01-01 00:08:18.000000', 'consum', 0.0211, 'lps'),
	(636774, 135, '2015-01-01 00:08:19.000000', 'consum', 0.0243, 'lps'),
	(636775, 135, '2015-01-01 00:08:20.000000', 'consum', 0.0246, 'lps'),
	(636776, 135, '2015-01-01 00:08:21.000000', 'consum', 0.0231, 'lps'),
	(636777, 135, '2015-01-01 00:08:22.000000', 'consum', 0.0269, 'lps'),
	(636778, 135, '2015-01-01 00:08:23.000000', 'consum', 0.0257, 'lps'),
	(636779, 135, '2015-01-01 00:08:24.000000', 'consum', 0.0267, 'lps'),
	(636780, 135, '2015-01-01 00:08:25.000000', 'consum', 0.0233, 'lps'),
	(636781, 135, '2015-01-01 00:08:26.000000', 'consum', 0.0216, 'lps'),
	(636782, 135, '2015-01-01 00:08:27.000000', 'consum', 0.0232, 'lps'),
	(636783, 135, '2015-01-01 00:08:28.000000', 'consum', 0.0240, 'lps'),
	(636784, 135, '2015-01-01 00:08:29.000000', 'consum', 0.0232, 'lps'),
	(636785, 135, '2015-01-01 00:08:30.000000', 'consum', 0.0232, 'lps'),
	(636786, 135, '2015-01-01 00:08:31.000000', 'consum', 0.0256, 'lps'),
	(636787, 135, '2015-01-01 00:08:32.000000', 'consum', 0.0250, 'lps'),
	(636788, 135, '2015-01-01 00:08:33.000000', 'consum', 0.0271, 'lps'),
	(636789, 135, '2015-01-01 00:08:34.000000', 'consum', 0.0210, 'lps'),
	(636790, 135, '2015-01-01 00:08:35.000000', 'consum', 0.0212, 'lps'),
	(636791, 135, '2015-01-01 00:08:36.000000', 'consum', 0.0220, 'lps'),
	(636792, 135, '2015-01-01 00:08:37.000000', 'consum', 0.0254, 'lps'),
	(636793, 135, '2015-01-01 00:08:38.000000', 'consum', 0.0214, 'lps'),
	(636794, 135, '2015-01-01 00:08:39.000000', 'consum', 0.0224, 'lps'),
	(636795, 135, '2015-01-01 00:08:40.000000', 'consum', 0.0266, 'lps'),
	(636796, 135, '2015-01-01 00:08:41.000000', 'consum', 0.0266, 'lps'),
	(636797, 135, '2015-01-01 00:08:42.000000', 'consum', 0.0260, 'lps'),
	(636798, 135, '2015-01-01 00:08:43.000000', 'consum', 0.0229, 'lps'),
	(636799, 135, '2015-01-01 00:08:44.000000', 'consum', 0.0216, 'lps'),
	(636800, 135, '2015-01-01 00:08:45.000000', 'consum', 0.0249, 'lps'),
	(636801, 135, '2015-01-01 00:08:46.000000', 'consum', 0.0263, 'lps'),
	(636802, 135, '2015-01-01 00:08:47.000000', 'consum', 0.0232, 'lps'),
	(636803, 135, '2015-01-01 00:08:48.000000', 'consum', 0.0225, 'lps'),
	(636804, 135, '2015-01-01 00:08:49.000000', 'consum', 0.0219, 'lps'),
	(636805, 135, '2015-01-01 00:08:50.000000', 'consum', 0.0271, 'lps'),
	(636806, 135, '2015-01-01 00:08:51.000000', 'consum', 0.0242, 'lps'),
	(636807, 135, '2015-01-01 00:08:52.000000', 'consum', 0.0248, 'lps'),
	(636808, 135, '2015-01-01 00:08:53.000000', 'consum', 0.0242, 'lps'),
	(636809, 135, '2015-01-01 00:08:54.000000', 'consum', 0.0259, 'lps'),
	(636810, 135, '2015-01-01 00:08:55.000000', 'consum', 0.0236, 'lps'),
	(636811, 135, '2015-01-01 00:08:56.000000', 'consum', 0.0253, 'lps'),
	(636812, 135, '2015-01-01 00:08:57.000000', 'consum', 0.0226, 'lps'),
	(636813, 135, '2015-01-01 00:08:58.000000', 'consum', 0.0222, 'lps'),
	(636814, 135, '2015-01-01 00:08:59.000000', 'consum', 0.0225, 'lps'),
	(636815, 135, '2015-01-01 00:09:00.000000', 'consum', 0.0246, 'lps'),
	(636816, 135, '2015-01-01 00:09:01.000000', 'consum', 0.0224, 'lps'),
	(636817, 135, '2015-01-01 00:09:02.000000', 'consum', 0.0235, 'lps'),
	(636818, 135, '2015-01-01 00:09:03.000000', 'consum', 0.0229, 'lps'),
	(636819, 135, '2015-01-01 00:09:04.000000', 'consum', 0.0232, 'lps'),
	(636820, 135, '2015-01-01 00:09:05.000000', 'consum', 0.0263, 'lps'),
	(636821, 135, '2015-01-01 00:09:06.000000', 'consum', 0.0223, 'lps'),
	(636822, 135, '2015-01-01 00:09:07.000000', 'consum', 0.0242, 'lps'),
	(636823, 135, '2015-01-01 00:09:08.000000', 'consum', 0.0270, 'lps'),
	(636824, 135, '2015-01-01 00:09:09.000000', 'consum', 0.0226, 'lps'),
	(636825, 135, '2015-01-01 00:09:10.000000', 'consum', 0.0236, 'lps'),
	(636826, 135, '2015-01-01 00:09:11.000000', 'consum', 0.0231, 'lps'),
	(636827, 135, '2015-01-01 00:09:12.000000', 'consum', 0.0238, 'lps'),
	(636828, 135, '2015-01-01 00:09:13.000000', 'consum', 0.0223, 'lps'),
	(636829, 135, '2015-01-01 00:09:14.000000', 'consum', 0.0255, 'lps'),
	(636830, 135, '2015-01-01 00:09:15.000000', 'consum', 0.0212, 'lps'),
	(636831, 135, '2015-01-01 00:09:16.000000', 'consum', 0.0270, 'lps'),
	(636832, 135, '2015-01-01 00:09:17.000000', 'consum', 0.0258, 'lps'),
	(636833, 135, '2015-01-01 00:09:18.000000', 'consum', 0.0268, 'lps'),
	(636834, 135, '2015-01-01 00:09:19.000000', 'consum', 0.0235, 'lps'),
	(636835, 135, '2015-01-01 00:09:20.000000', 'consum', 0.0223, 'lps'),
	(636836, 135, '2015-01-01 00:09:21.000000', 'consum', 0.0260, 'lps'),
	(636837, 135, '2015-01-01 00:09:22.000000', 'consum', 0.0239, 'lps'),
	(636838, 135, '2015-01-01 00:09:23.000000', 'consum', 0.0267, 'lps'),
	(636839, 135, '2015-01-01 00:09:24.000000', 'consum', 0.0221, 'lps'),
	(636840, 135, '2015-01-01 00:09:25.000000', 'consum', 0.0217, 'lps'),
	(636841, 135, '2015-01-01 00:09:26.000000', 'consum', 0.0215, 'lps'),
	(636842, 135, '2015-01-01 00:09:27.000000', 'consum', 0.0215, 'lps'),
	(636843, 135, '2015-01-01 00:09:28.000000', 'consum', 0.0220, 'lps'),
	(636844, 135, '2015-01-01 00:09:29.000000', 'consum', 0.0244, 'lps'),
	(636845, 135, '2015-01-01 00:09:30.000000', 'consum', 0.0226, 'lps'),
	(636846, 135, '2015-01-01 00:09:31.000000', 'consum', 0.0253, 'lps'),
	(636847, 135, '2015-01-01 00:09:32.000000', 'consum', 0.0252, 'lps'),
	(636848, 135, '2015-01-01 00:09:33.000000', 'consum', 0.0230, 'lps'),
	(636849, 135, '2015-01-01 00:09:34.000000', 'consum', 0.0248, 'lps'),
	(636850, 135, '2015-01-01 00:09:35.000000', 'consum', 0.0216, 'lps'),
	(636851, 135, '2015-01-01 00:09:36.000000', 'consum', 0.0251, 'lps'),
	(636852, 135, '2015-01-01 00:09:37.000000', 'consum', 0.0212, 'lps'),
	(636853, 135, '2015-01-01 00:09:38.000000', 'consum', 0.0220, 'lps'),
	(636854, 135, '2015-01-01 00:09:39.000000', 'consum', 0.0256, 'lps'),
	(636855, 135, '2015-01-01 00:09:40.000000', 'consum', 0.0224, 'lps'),
	(636856, 135, '2015-01-01 00:09:41.000000', 'consum', 0.0267, 'lps'),
	(636857, 135, '2015-01-01 00:09:42.000000', 'consum', 0.0268, 'lps'),
	(636858, 135, '2015-01-01 00:09:43.000000', 'consum', 0.0265, 'lps'),
	(636859, 135, '2015-01-01 00:09:44.000000', 'consum', 0.0251, 'lps'),
	(636860, 135, '2015-01-01 00:09:45.000000', 'consum', 0.0250, 'lps'),
	(636861, 135, '2015-01-01 00:09:46.000000', 'consum', 0.0227, 'lps'),
	(636862, 135, '2015-01-01 00:09:47.000000', 'consum', 0.0236, 'lps'),
	(636863, 135, '2015-01-01 00:09:48.000000', 'consum', 0.0226, 'lps'),
	(636864, 135, '2015-01-01 00:09:49.000000', 'consum', 0.0213, 'lps'),
	(636865, 135, '2015-01-01 00:09:50.000000', 'consum', 0.0240, 'lps'),
	(636866, 135, '2015-01-01 00:09:51.000000', 'consum', 0.0227, 'lps'),
	(636867, 135, '2015-01-01 00:09:52.000000', 'consum', 0.0266, 'lps'),
	(636868, 135, '2015-01-01 00:09:53.000000', 'consum', 0.0256, 'lps'),
	(636869, 135, '2015-01-01 00:09:54.000000', 'consum', 0.0271, 'lps'),
	(636870, 135, '2015-01-01 00:09:55.000000', 'consum', 0.0253, 'lps'),
	(636871, 135, '2015-01-01 00:09:56.000000', 'consum', 0.0242, 'lps'),
	(636872, 135, '2015-01-01 00:09:57.000000', 'consum', 0.0242, 'lps'),
	(636873, 135, '2015-01-01 00:09:58.000000', 'consum', 0.0212, 'lps'),
	(636874, 135, '2015-01-01 00:09:59.000000', 'consum', 0.0250, 'lps'),
	(636875, 135, '2015-01-01 00:10:00.000000', 'consum', 0.0216, 'lps'),
	(636876, 135, '2015-01-01 00:10:01.000000', 'consum', 0.0245, 'lps'),
	(636877, 135, '2015-01-01 00:10:02.000000', 'consum', 0.0242, 'lps'),
	(636878, 135, '2015-01-01 00:10:03.000000', 'consum', 0.0266, 'lps'),
	(636879, 135, '2015-01-01 00:10:04.000000', 'consum', 0.0211, 'lps'),
	(636880, 135, '2015-01-01 00:10:05.000000', 'consum', 0.0233, 'lps'),
	(636881, 135, '2015-01-01 00:10:06.000000', 'consum', 0.0260, 'lps'),
	(636882, 135, '2015-01-01 00:10:07.000000', 'consum', 0.0268, 'lps'),
	(636883, 135, '2015-01-01 00:10:08.000000', 'consum', 0.0226, 'lps'),
	(636884, 135, '2015-01-01 00:10:09.000000', 'consum', 0.0241, 'lps'),
	(636885, 135, '2015-01-01 00:10:10.000000', 'consum', 0.0255, 'lps'),
	(636886, 135, '2015-01-01 00:10:11.000000', 'consum', 0.0217, 'lps'),
	(636887, 135, '2015-01-01 00:10:12.000000', 'consum', 0.0235, 'lps'),
	(636888, 135, '2015-01-01 00:10:13.000000', 'consum', 0.0255, 'lps'),
	(636889, 135, '2015-01-01 00:10:14.000000', 'consum', 0.0234, 'lps'),
	(636890, 135, '2015-01-01 00:10:15.000000', 'consum', 0.0257, 'lps'),
	(636891, 135, '2015-01-01 00:10:16.000000', 'consum', 0.0249, 'lps'),
	(636892, 135, '2015-01-01 00:10:17.000000', 'consum', 0.0266, 'lps'),
	(636893, 135, '2015-01-01 00:10:18.000000', 'consum', 0.0251, 'lps'),
	(636894, 135, '2015-01-01 00:10:19.000000', 'consum', 0.0244, 'lps'),
	(636895, 135, '2015-01-01 00:10:20.000000', 'consum', 0.0261, 'lps'),
	(636896, 135, '2015-01-01 00:10:21.000000', 'consum', 0.0238, 'lps'),
	(636897, 135, '2015-01-01 00:10:22.000000', 'consum', 0.0258, 'lps'),
	(636898, 135, '2015-01-01 00:10:23.000000', 'consum', 0.0244, 'lps'),
	(636899, 135, '2015-01-01 00:10:24.000000', 'consum', 0.0235, 'lps'),
	(636900, 135, '2015-01-01 00:10:25.000000', 'consum', 0.0234, 'lps'),
	(636901, 135, '2015-01-01 00:10:26.000000', 'consum', 0.0257, 'lps'),
	(636902, 135, '2015-01-01 00:10:27.000000', 'consum', 0.0250, 'lps'),
	(636903, 135, '2015-01-01 00:10:28.000000', 'consum', 0.0267, 'lps'),
	(636904, 135, '2015-01-01 00:10:29.000000', 'consum', 0.0253, 'lps'),
	(636905, 135, '2015-01-01 00:10:30.000000', 'consum', 0.0253, 'lps'),
	(636906, 135, '2015-01-01 00:10:31.000000', 'consum', 0.0235, 'lps'),
	(636907, 135, '2015-01-01 00:10:32.000000', 'consum', 0.0270, 'lps'),
	(636908, 135, '2015-01-01 00:10:33.000000', 'consum', 0.0249, 'lps'),
	(636909, 135, '2015-01-01 00:10:34.000000', 'consum', 0.0225, 'lps'),
	(636910, 135, '2015-01-01 00:10:35.000000', 'consum', 0.0232, 'lps'),
	(636911, 135, '2015-01-01 00:10:36.000000', 'consum', 0.0211, 'lps'),
	(636912, 135, '2015-01-01 00:10:37.000000', 'consum', 0.0214, 'lps'),
	(636913, 135, '2015-01-01 00:10:38.000000', 'consum', 0.0226, 'lps'),
	(636914, 135, '2015-01-01 00:10:39.000000', 'consum', 0.0217, 'lps'),
	(636915, 135, '2015-01-01 00:10:40.000000', 'consum', 0.0259, 'lps'),
	(636916, 135, '2015-01-01 00:10:41.000000', 'consum', 0.0251, 'lps'),
	(636917, 135, '2015-01-01 00:10:42.000000', 'consum', 0.0265, 'lps'),
	(636918, 135, '2015-01-01 00:10:43.000000', 'consum', 0.0242, 'lps'),
	(636919, 135, '2015-01-01 00:10:44.000000', 'consum', 0.0264, 'lps'),
	(636920, 135, '2015-01-01 00:10:45.000000', 'consum', 0.0264, 'lps'),
	(636921, 135, '2015-01-01 00:10:46.000000', 'consum', 0.0254, 'lps'),
	(636922, 135, '2015-01-01 00:10:47.000000', 'consum', 0.0269, 'lps'),
	(636923, 135, '2015-01-01 00:10:48.000000', 'consum', 0.0250, 'lps'),
	(636924, 135, '2015-01-01 00:10:49.000000', 'consum', 0.0232, 'lps'),
	(636925, 135, '2015-01-01 00:10:50.000000', 'consum', 0.0262, 'lps'),
	(636926, 135, '2015-01-01 00:10:51.000000', 'consum', 0.0221, 'lps'),
	(636927, 135, '2015-01-01 00:10:52.000000', 'consum', 0.0231, 'lps'),
	(636928, 135, '2015-01-01 00:10:53.000000', 'consum', 0.0220, 'lps'),
	(636929, 135, '2015-01-01 00:10:54.000000', 'consum', 0.0262, 'lps'),
	(636930, 135, '2015-01-01 00:10:55.000000', 'consum', 0.0252, 'lps'),
	(636931, 135, '2015-01-01 00:10:56.000000', 'consum', 0.0267, 'lps'),
	(636932, 135, '2015-01-01 00:10:57.000000', 'consum', 0.0246, 'lps'),
	(636933, 135, '2015-01-01 00:10:58.000000', 'consum', 0.0219, 'lps'),
	(636934, 135, '2015-01-01 00:10:59.000000', 'consum', 0.0270, 'lps'),
	(636935, 135, '2015-01-01 00:11:00.000000', 'consum', 0.0236, 'lps'),
	(636936, 135, '2015-01-01 00:11:01.000000', 'consum', 0.0221, 'lps'),
	(636937, 135, '2015-01-01 00:11:02.000000', 'consum', 0.0249, 'lps'),
	(636938, 135, '2015-01-01 00:11:03.000000', 'consum', 0.0249, 'lps'),
	(636939, 135, '2015-01-01 00:11:04.000000', 'consum', 0.0228, 'lps'),
	(636940, 135, '2015-01-01 00:11:05.000000', 'consum', 0.0243, 'lps'),
	(636941, 135, '2015-01-01 00:11:06.000000', 'consum', 0.0259, 'lps'),
	(636942, 135, '2015-01-01 00:11:07.000000', 'consum', 0.0236, 'lps'),
	(636943, 135, '2015-01-01 00:11:08.000000', 'consum', 0.0253, 'lps'),
	(636944, 135, '2015-01-01 00:11:09.000000', 'consum', 0.0225, 'lps'),
	(636945, 135, '2015-01-01 00:11:10.000000', 'consum', 0.0216, 'lps'),
	(636946, 135, '2015-01-01 00:11:11.000000', 'consum', 0.0261, 'lps'),
	(636947, 135, '2015-01-01 00:11:12.000000', 'consum', 0.0258, 'lps'),
	(636948, 135, '2015-01-01 00:11:13.000000', 'consum', 0.0237, 'lps'),
	(636949, 135, '2015-01-01 00:11:14.000000', 'consum', 0.0265, 'lps'),
	(636950, 135, '2015-01-01 00:11:15.000000', 'consum', 0.0219, 'lps'),
	(636951, 135, '2015-01-01 00:11:16.000000', 'consum', 0.0212, 'lps'),
	(636952, 135, '2015-01-01 00:11:17.000000', 'consum', 0.0258, 'lps'),
	(636953, 135, '2015-01-01 00:11:18.000000', 'consum', 0.0257, 'lps'),
	(636954, 135, '2015-01-01 00:11:19.000000', 'consum', 0.0241, 'lps'),
	(636955, 135, '2015-01-01 00:11:20.000000', 'consum', 0.0223, 'lps'),
	(636956, 135, '2015-01-01 00:11:21.000000', 'consum', 0.0244, 'lps'),
	(636957, 135, '2015-01-01 00:11:22.000000', 'consum', 0.0219, 'lps'),
	(636958, 135, '2015-01-01 00:11:23.000000', 'consum', 0.0216, 'lps'),
	(636959, 135, '2015-01-01 00:11:24.000000', 'consum', 0.0214, 'lps'),
	(636960, 135, '2015-01-01 00:11:25.000000', 'consum', 0.0212, 'lps'),
	(636961, 135, '2015-01-01 00:11:26.000000', 'consum', 0.0210, 'lps'),
	(636962, 135, '2015-01-01 00:11:27.000000', 'consum', 0.0265, 'lps'),
	(636963, 135, '2015-01-01 00:11:28.000000', 'consum', 0.0238, 'lps'),
	(636964, 135, '2015-01-01 00:11:29.000000', 'consum', 0.0247, 'lps'),
	(636965, 135, '2015-01-01 00:11:30.000000', 'consum', 0.0250, 'lps'),
	(636966, 135, '2015-01-01 00:11:31.000000', 'consum', 0.0239, 'lps'),
	(636967, 135, '2015-01-01 00:11:32.000000', 'consum', 0.0234, 'lps'),
	(636968, 135, '2015-01-01 00:11:33.000000', 'consum', 0.0243, 'lps'),
	(636969, 135, '2015-01-01 00:11:34.000000', 'consum', 0.0240, 'lps'),
	(636970, 135, '2015-01-01 00:11:35.000000', 'consum', 0.0263, 'lps'),
	(636971, 135, '2015-01-01 00:11:36.000000', 'consum', 0.0261, 'lps'),
	(636972, 135, '2015-01-01 00:11:37.000000', 'consum', 0.0245, 'lps'),
	(636973, 135, '2015-01-01 00:11:38.000000', 'consum', 0.0232, 'lps'),
	(636974, 135, '2015-01-01 00:11:39.000000', 'consum', 0.0215, 'lps'),
	(636975, 135, '2015-01-01 00:11:40.000000', 'consum', 0.0234, 'lps'),
	(636976, 135, '2015-01-01 00:11:41.000000', 'consum', 0.0251, 'lps'),
	(636977, 135, '2015-01-01 00:11:42.000000', 'consum', 0.0222, 'lps'),
	(636978, 135, '2015-01-01 00:11:43.000000', 'consum', 0.0270, 'lps'),
	(636979, 135, '2015-01-01 00:11:44.000000', 'consum', 0.0226, 'lps'),
	(636980, 135, '2015-01-01 00:11:45.000000', 'consum', 0.0235, 'lps'),
	(636981, 135, '2015-01-01 00:11:46.000000', 'consum', 0.0224, 'lps'),
	(636982, 135, '2015-01-01 00:11:47.000000', 'consum', 0.0266, 'lps'),
	(636983, 135, '2015-01-01 00:11:48.000000', 'consum', 0.0266, 'lps'),
	(636984, 135, '2015-01-01 00:11:49.000000', 'consum', 0.0261, 'lps'),
	(636985, 135, '2015-01-01 00:11:50.000000', 'consum', 0.0233, 'lps'),
	(636986, 135, '2015-01-01 00:11:51.000000', 'consum', 0.0237, 'lps'),
	(636987, 135, '2015-01-01 00:11:52.000000', 'consum', 0.0213, 'lps'),
	(636988, 135, '2015-01-01 00:11:53.000000', 'consum', 0.0270, 'lps'),
	(636989, 135, '2015-01-01 00:11:54.000000', 'consum', 0.0252, 'lps'),
	(636990, 135, '2015-01-01 00:11:55.000000', 'consum', 0.0240, 'lps'),
	(636991, 135, '2015-01-01 00:11:56.000000', 'consum', 0.0235, 'lps'),
	(636992, 135, '2015-01-01 00:11:57.000000', 'consum', 0.0247, 'lps'),
	(636993, 135, '2015-01-01 00:11:58.000000', 'consum', 0.0259, 'lps'),
	(636994, 135, '2015-01-01 00:11:59.000000', 'consum', 0.0220, 'lps'),
	(636995, 135, '2015-01-01 00:12:00.000000', 'consum', 0.0236, 'lps'),
	(636996, 135, '2015-01-01 00:12:01.000000', 'consum', 0.0249, 'lps'),
	(636997, 135, '2015-01-01 00:12:02.000000', 'consum', 0.0266, 'lps'),
	(636998, 135, '2015-01-01 00:12:03.000000', 'consum', 0.0249, 'lps'),
	(636999, 135, '2015-01-01 00:12:04.000000', 'consum', 0.0239, 'lps'),
	(637000, 135, '2015-01-01 00:12:05.000000', 'consum', 0.0238, 'lps'),
	(637001, 135, '2015-01-01 00:12:06.000000', 'consum', 0.0261, 'lps'),
	(637002, 135, '2015-01-01 00:12:07.000000', 'consum', 0.0260, 'lps'),
	(637003, 135, '2015-01-01 00:12:08.000000', 'consum', 0.0247, 'lps'),
	(637004, 135, '2015-01-01 00:12:09.000000', 'consum', 0.0243, 'lps'),
	(637005, 135, '2015-01-01 00:12:10.000000', 'consum', 0.0266, 'lps'),
	(637006, 135, '2015-01-01 00:12:11.000000', 'consum', 0.0268, 'lps'),
	(637007, 135, '2015-01-01 00:12:12.000000', 'consum', 0.0269, 'lps'),
	(637008, 135, '2015-01-01 00:12:13.000000', 'consum', 0.0210, 'lps'),
	(637009, 135, '2015-01-01 00:12:14.000000', 'consum', 0.0218, 'lps'),
	(637010, 135, '2015-01-01 00:12:15.000000', 'consum', 0.0251, 'lps'),
	(637011, 135, '2015-01-01 00:12:16.000000', 'consum', 0.0269, 'lps'),
	(637012, 135, '2015-01-01 00:12:17.000000', 'consum', 0.0257, 'lps'),
	(637013, 135, '2015-01-01 00:12:18.000000', 'consum', 0.0270, 'lps'),
	(637014, 135, '2015-01-01 00:12:19.000000', 'consum', 0.0246, 'lps'),
	(637015, 135, '2015-01-01 00:12:20.000000', 'consum', 0.0270, 'lps'),
	(637016, 135, '2015-01-01 00:12:21.000000', 'consum', 0.0218, 'lps'),
	(637017, 135, '2015-01-01 00:12:22.000000', 'consum', 0.0254, 'lps'),
	(637018, 135, '2015-01-01 00:12:23.000000', 'consum', 0.0223, 'lps'),
	(637019, 135, '2015-01-01 00:12:24.000000', 'consum', 0.0268, 'lps'),
	(637020, 135, '2015-01-01 00:12:25.000000', 'consum', 0.0214, 'lps'),
	(637021, 135, '2015-01-01 00:12:26.000000', 'consum', 0.0243, 'lps'),
	(637022, 135, '2015-01-01 00:12:27.000000', 'consum', 0.0239, 'lps'),
	(637023, 135, '2015-01-01 00:12:28.000000', 'consum', 0.0256, 'lps'),
	(637024, 135, '2015-01-01 00:12:29.000000', 'consum', 0.0231, 'lps'),
	(637025, 135, '2015-01-01 00:12:30.000000', 'consum', 0.0239, 'lps'),
	(637026, 135, '2015-01-01 00:12:31.000000', 'consum', 0.0231, 'lps'),
	(637027, 135, '2015-01-01 00:12:32.000000', 'consum', 0.0228, 'lps'),
	(637028, 135, '2015-01-01 00:12:33.000000', 'consum', 0.0236, 'lps'),
	(637029, 135, '2015-01-01 00:12:34.000000', 'consum', 0.0223, 'lps'),
	(637030, 135, '2015-01-01 00:12:35.000000', 'consum', 0.0263, 'lps'),
	(637031, 135, '2015-01-01 00:12:36.000000', 'consum', 0.0251, 'lps'),
	(637032, 135, '2015-01-01 00:12:37.000000', 'consum', 0.0255, 'lps'),
	(637033, 135, '2015-01-01 00:12:38.000000', 'consum', 0.0249, 'lps'),
	(637034, 135, '2015-01-01 00:12:39.000000', 'consum', 0.0270, 'lps'),
	(637035, 135, '2015-01-01 00:12:40.000000', 'consum', 0.0270, 'lps'),
	(637036, 135, '2015-01-01 00:12:41.000000', 'consum', 0.0270, 'lps'),
	(637037, 135, '2015-01-01 00:12:42.000000', 'consum', 0.0267, 'lps'),
	(637038, 135, '2015-01-01 00:12:43.000000', 'consum', 0.0256, 'lps'),
	(637039, 135, '2015-01-01 00:12:44.000000', 'consum', 0.0268, 'lps'),
	(637040, 135, '2015-01-01 00:12:45.000000', 'consum', 0.0241, 'lps'),
	(637041, 135, '2015-01-01 00:12:46.000000', 'consum', 0.0250, 'lps'),
	(637042, 135, '2015-01-01 00:12:47.000000', 'consum', 0.0258, 'lps'),
	(637043, 135, '2015-01-01 00:12:48.000000', 'consum', 0.0269, 'lps'),
	(637044, 135, '2015-01-01 00:12:49.000000', 'consum', 0.0238, 'lps'),
	(637045, 135, '2015-01-01 00:12:50.000000', 'consum', 0.0233, 'lps'),
	(637046, 135, '2015-01-01 00:12:51.000000', 'consum', 0.0241, 'lps'),
	(637047, 135, '2015-01-01 00:12:52.000000', 'consum', 0.0235, 'lps'),
	(637048, 135, '2015-01-01 00:12:53.000000', 'consum', 0.0241, 'lps'),
	(637049, 135, '2015-01-01 00:12:54.000000', 'consum', 0.0231, 'lps'),
	(637050, 135, '2015-01-01 00:12:55.000000', 'consum', 0.0220, 'lps'),
	(637051, 135, '2015-01-01 00:12:56.000000', 'consum', 0.0261, 'lps'),
	(637052, 135, '2015-01-01 00:12:57.000000', 'consum', 0.0251, 'lps'),
	(637053, 135, '2015-01-01 00:12:58.000000', 'consum', 0.0261, 'lps'),
	(637054, 135, '2015-01-01 00:12:59.000000', 'consum', 0.0218, 'lps'),
	(637055, 135, '2015-01-01 00:13:00.000000', 'consum', 0.0222, 'lps'),
	(637056, 135, '2015-01-01 00:13:01.000000', 'consum', 0.0247, 'lps'),
	(637057, 135, '2015-01-01 00:13:02.000000', 'consum', 0.0234, 'lps'),
	(637058, 135, '2015-01-01 00:13:03.000000', 'consum', 0.0221, 'lps'),
	(637059, 135, '2015-01-01 00:13:04.000000', 'consum', 0.0257, 'lps'),
	(637060, 135, '2015-01-01 00:13:05.000000', 'consum', 0.0224, 'lps'),
	(637061, 135, '2015-01-01 00:13:06.000000', 'consum', 0.0265, 'lps'),
	(637062, 135, '2015-01-01 00:13:07.000000', 'consum', 0.0257, 'lps'),
	(637063, 135, '2015-01-01 00:13:08.000000', 'consum', 0.0216, 'lps'),
	(637064, 135, '2015-01-01 00:13:09.000000', 'consum', 0.0227, 'lps'),
	(637065, 135, '2015-01-01 00:13:10.000000', 'consum', 0.0215, 'lps'),
	(637066, 135, '2015-01-01 00:13:11.000000', 'consum', 0.0245, 'lps'),
	(637067, 135, '2015-01-01 00:13:12.000000', 'consum', 0.0248, 'lps'),
	(637068, 135, '2015-01-01 00:13:13.000000', 'consum', 0.0233, 'lps'),
	(637069, 135, '2015-01-01 00:13:14.000000', 'consum', 0.0212, 'lps'),
	(637070, 135, '2015-01-01 00:13:15.000000', 'consum', 0.0214, 'lps'),
	(637071, 135, '2015-01-01 00:13:16.000000', 'consum', 0.0222, 'lps'),
	(637072, 135, '2015-01-01 00:13:17.000000', 'consum', 0.0259, 'lps'),
	(637073, 135, '2015-01-01 00:13:18.000000', 'consum', 0.0235, 'lps'),
	(637074, 135, '2015-01-01 00:13:19.000000', 'consum', 0.0250, 'lps'),
	(637075, 135, '2015-01-01 00:13:20.000000', 'consum', 0.0212, 'lps'),
	(637076, 135, '2015-01-01 00:13:21.000000', 'consum', 0.0225, 'lps'),
	(637077, 135, '2015-01-01 00:13:22.000000', 'consum', 0.0216, 'lps'),
	(637078, 135, '2015-01-01 00:13:23.000000', 'consum', 0.0260, 'lps'),
	(637079, 135, '2015-01-01 00:13:24.000000', 'consum', 0.0255, 'lps'),
	(637080, 135, '2015-01-01 00:13:25.000000', 'consum', 0.0223, 'lps'),
	(637081, 135, '2015-01-01 00:13:26.000000', 'consum', 0.0267, 'lps'),
	(637082, 135, '2015-01-01 00:13:27.000000', 'consum', 0.0268, 'lps'),
	(637083, 135, '2015-01-01 00:13:28.000000', 'consum', 0.0269, 'lps'),
	(637084, 135, '2015-01-01 00:13:29.000000', 'consum', 0.0268, 'lps'),
	(637085, 135, '2015-01-01 00:13:30.000000', 'consum', 0.0262, 'lps'),
	(637086, 135, '2015-01-01 00:13:31.000000', 'consum', 0.0233, 'lps'),
	(637087, 135, '2015-01-01 00:13:32.000000', 'consum', 0.0233, 'lps'),
	(637088, 135, '2015-01-01 00:13:33.000000', 'consum', 0.0258, 'lps'),
	(637089, 135, '2015-01-01 00:13:34.000000', 'consum', 0.0256, 'lps'),
	(637090, 135, '2015-01-01 00:13:35.000000', 'consum', 0.0236, 'lps'),
	(637091, 135, '2015-01-01 00:13:36.000000', 'consum', 0.0262, 'lps'),
	(637092, 135, '2015-01-01 00:13:37.000000', 'consum', 0.0270, 'lps'),
	(637093, 135, '2015-01-01 00:13:38.000000', 'consum', 0.0230, 'lps'),
	(637094, 135, '2015-01-01 00:13:39.000000', 'consum', 0.0255, 'lps'),
	(637095, 135, '2015-01-01 00:13:40.000000', 'consum', 0.0253, 'lps'),
	(637096, 135, '2015-01-01 00:13:41.000000', 'consum', 0.0226, 'lps'),
	(637097, 135, '2015-01-01 00:13:42.000000', 'consum', 0.0226, 'lps'),
	(637098, 135, '2015-01-01 00:13:43.000000', 'consum', 0.0243, 'lps'),
	(637099, 135, '2015-01-01 00:13:44.000000', 'consum', 0.0263, 'lps'),
	(637100, 135, '2015-01-01 00:13:45.000000', 'consum', 0.0254, 'lps'),
	(637101, 135, '2015-01-01 00:13:46.000000', 'consum', 0.0271, 'lps'),
	(637102, 135, '2015-01-01 00:13:47.000000', 'consum', 0.0258, 'lps'),
	(637103, 135, '2015-01-01 00:13:48.000000', 'consum', 0.0268, 'lps'),
	(637104, 135, '2015-01-01 00:13:49.000000', 'consum', 0.0232, 'lps'),
	(637105, 135, '2015-01-01 00:13:50.000000', 'consum', 0.0269, 'lps'),
	(637106, 135, '2015-01-01 00:13:51.000000', 'consum', 0.0257, 'lps'),
	(637107, 135, '2015-01-01 00:13:52.000000', 'consum', 0.0267, 'lps'),
	(637108, 135, '2015-01-01 00:13:53.000000', 'consum', 0.0229, 'lps'),
	(637109, 135, '2015-01-01 00:13:54.000000', 'consum', 0.0260, 'lps'),
	(637110, 135, '2015-01-01 00:13:55.000000', 'consum', 0.0218, 'lps'),
	(637111, 135, '2015-01-01 00:13:56.000000', 'consum', 0.0225, 'lps'),
	(637112, 135, '2015-01-01 00:13:57.000000', 'consum', 0.0262, 'lps'),
	(637113, 135, '2015-01-01 00:13:58.000000', 'consum', 0.0238, 'lps'),
	(637114, 135, '2015-01-01 00:13:59.000000', 'consum', 0.0259, 'lps'),
	(637115, 135, '2015-01-01 00:14:00.000000', 'consum', 0.0246, 'lps'),
	(637116, 135, '2015-01-01 00:14:01.000000', 'consum', 0.0244, 'lps'),
	(637117, 135, '2015-01-01 00:14:02.000000', 'consum', 0.0271, 'lps'),
	(637118, 135, '2015-01-01 00:14:03.000000', 'consum', 0.0227, 'lps'),
	(637119, 135, '2015-01-01 00:14:04.000000', 'consum', 0.0239, 'lps'),
	(637120, 135, '2015-01-01 00:14:05.000000', 'consum', 0.0240, 'lps'),
	(637121, 135, '2015-01-01 00:14:06.000000', 'consum', 0.0211, 'lps'),
	(637122, 135, '2015-01-01 00:14:07.000000', 'consum', 0.0250, 'lps'),
	(637123, 135, '2015-01-01 00:14:08.000000', 'consum', 0.0221, 'lps'),
	(637124, 135, '2015-01-01 00:14:09.000000', 'consum', 0.0210, 'lps'),
	(637125, 135, '2015-01-01 00:14:10.000000', 'consum', 0.0238, 'lps'),
	(637126, 135, '2015-01-01 00:14:11.000000', 'consum', 0.0226, 'lps'),
	(637127, 135, '2015-01-01 00:14:12.000000', 'consum', 0.0268, 'lps'),
	(637128, 135, '2015-01-01 00:14:13.000000', 'consum', 0.0267, 'lps'),
	(637129, 135, '2015-01-01 00:14:14.000000', 'consum', 0.0261, 'lps'),
	(637130, 135, '2015-01-01 00:14:15.000000', 'consum', 0.0233, 'lps'),
	(637131, 135, '2015-01-01 00:14:16.000000', 'consum', 0.0233, 'lps'),
	(637132, 135, '2015-01-01 00:14:17.000000', 'consum', 0.0258, 'lps'),
	(637133, 135, '2015-01-01 00:14:18.000000', 'consum', 0.0258, 'lps'),
	(637134, 135, '2015-01-01 00:14:19.000000', 'consum', 0.0245, 'lps'),
	(637135, 135, '2015-01-01 00:14:20.000000', 'consum', 0.0243, 'lps'),
	(637136, 135, '2015-01-01 00:14:21.000000', 'consum', 0.0267, 'lps'),
	(637137, 135, '2015-01-01 00:14:22.000000', 'consum', 0.0210, 'lps'),
	(637138, 135, '2015-01-01 00:14:23.000000', 'consum', 0.0227, 'lps'),
	(637139, 135, '2015-01-01 00:14:24.000000', 'consum', 0.0234, 'lps'),
	(637140, 135, '2015-01-01 00:14:25.000000', 'consum', 0.0215, 'lps'),
	(637141, 135, '2015-01-01 00:14:26.000000', 'consum', 0.0227, 'lps'),
	(637142, 135, '2015-01-01 00:14:27.000000', 'consum', 0.0220, 'lps'),
	(637143, 135, '2015-01-01 00:14:28.000000', 'consum', 0.0210, 'lps'),
	(637144, 135, '2015-01-01 00:14:29.000000', 'consum', 0.0240, 'lps'),
	(637145, 135, '2015-01-01 00:14:30.000000', 'consum', 0.0239, 'lps'),
	(637146, 135, '2015-01-01 00:14:31.000000', 'consum', 0.0266, 'lps'),
	(637147, 135, '2015-01-01 00:14:32.000000', 'consum', 0.0217, 'lps'),
	(637148, 135, '2015-01-01 00:14:33.000000', 'consum', 0.0264, 'lps'),
	(637149, 135, '2015-01-01 00:14:34.000000', 'consum', 0.0210, 'lps'),
	(637150, 135, '2015-01-01 00:14:35.000000', 'consum', 0.0233, 'lps'),
	(637151, 135, '2015-01-01 00:14:36.000000', 'consum', 0.0267, 'lps'),
	(637152, 135, '2015-01-01 00:14:37.000000', 'consum', 0.0238, 'lps'),
	(637153, 135, '2015-01-01 00:14:38.000000', 'consum', 0.0241, 'lps'),
	(637154, 135, '2015-01-01 00:14:39.000000', 'consum', 0.0222, 'lps'),
	(637155, 135, '2015-01-01 00:14:40.000000', 'consum', 0.0238, 'lps'),
	(637156, 135, '2015-01-01 00:14:41.000000', 'consum', 0.0253, 'lps'),
	(637157, 135, '2015-01-01 00:14:42.000000', 'consum', 0.0216, 'lps'),
	(637158, 135, '2015-01-01 00:14:43.000000', 'consum', 0.0236, 'lps'),
	(637159, 135, '2015-01-01 00:14:44.000000', 'consum', 0.0260, 'lps'),
	(637160, 135, '2015-01-01 00:14:45.000000', 'consum', 0.0260, 'lps'),
	(637161, 135, '2015-01-01 00:14:46.000000', 'consum', 0.0247, 'lps'),
	(637162, 135, '2015-01-01 00:14:47.000000', 'consum', 0.0245, 'lps'),
	(637163, 135, '2015-01-01 00:14:48.000000', 'consum', 0.0212, 'lps'),
	(637164, 135, '2015-01-01 00:14:49.000000', 'consum', 0.0239, 'lps'),
	(637165, 135, '2015-01-01 00:14:50.000000', 'consum', 0.0225, 'lps'),
	(637166, 135, '2015-01-01 00:14:51.000000', 'consum', 0.0261, 'lps'),
	(637167, 135, '2015-01-01 00:14:52.000000', 'consum', 0.0236, 'lps'),
	(637168, 135, '2015-01-01 00:14:53.000000', 'consum', 0.0251, 'lps'),
	(637169, 135, '2015-01-01 00:14:54.000000', 'consum', 0.0210, 'lps'),
	(637170, 135, '2015-01-01 00:14:55.000000', 'consum', 0.0213, 'lps'),
	(637171, 135, '2015-01-01 00:14:56.000000', 'consum', 0.0224, 'lps'),
	(637172, 135, '2015-01-01 00:14:57.000000', 'consum', 0.0210, 'lps'),
	(637173, 135, '2015-01-01 00:14:58.000000', 'consum', 0.0230, 'lps'),
	(637174, 135, '2015-01-01 00:14:59.000000', 'consum', 0.0251, 'lps'),
	(637175, 135, '2015-01-01 00:15:00.000000', 'consum', 0.0229, 'lps'),
	(637176, 135, '2015-01-01 00:15:01.000000', 'consum', 0.0246, 'lps'),
	(637177, 135, '2015-01-01 00:15:02.000000', 'consum', 0.0271, 'lps'),
	(637178, 135, '2015-01-01 00:15:03.000000', 'consum', 0.0221, 'lps'),
	(637179, 135, '2015-01-01 00:15:04.000000', 'consum', 0.0267, 'lps'),
	(637180, 135, '2015-01-01 00:15:05.000000', 'consum', 0.0216, 'lps'),
	(637181, 135, '2015-01-01 00:15:06.000000', 'consum', 0.0254, 'lps'),
	(637182, 135, '2015-01-01 00:15:07.000000', 'consum', 0.0229, 'lps'),
	(637183, 135, '2015-01-01 00:15:08.000000', 'consum', 0.0233, 'lps'),
	(637184, 135, '2015-01-01 00:15:09.000000', 'consum', 0.0271, 'lps'),
	(637185, 135, '2015-01-01 00:15:10.000000', 'consum', 0.0257, 'lps'),
	(637186, 135, '2015-01-01 00:15:11.000000', 'consum', 0.0266, 'lps'),
	(637187, 135, '2015-01-01 00:15:12.000000', 'consum', 0.0224, 'lps'),
	(637188, 135, '2015-01-01 00:15:13.000000', 'consum', 0.0238, 'lps'),
	(637189, 135, '2015-01-01 00:15:14.000000', 'consum', 0.0244, 'lps'),
	(637190, 135, '2015-01-01 00:15:15.000000', 'consum', 0.0235, 'lps'),
	(637191, 135, '2015-01-01 00:15:16.000000', 'consum', 0.0235, 'lps'),
	(637192, 135, '2015-01-01 00:15:17.000000', 'consum', 0.0258, 'lps'),
	(637193, 135, '2015-01-01 00:15:18.000000', 'consum', 0.0252, 'lps'),
	(637194, 135, '2015-01-01 00:15:19.000000', 'consum', 0.0217, 'lps'),
	(637195, 135, '2015-01-01 00:15:20.000000', 'consum', 0.0242, 'lps'),
	(637196, 135, '2015-01-01 00:15:21.000000', 'consum', 0.0225, 'lps'),
	(637197, 135, '2015-01-01 00:15:22.000000', 'consum', 0.0251, 'lps'),
	(637198, 135, '2015-01-01 00:15:23.000000', 'consum', 0.0249, 'lps'),
	(637199, 135, '2015-01-01 00:15:24.000000', 'consum', 0.0220, 'lps'),
	(637200, 135, '2015-01-01 00:15:25.000000', 'consum', 0.0266, 'lps'),
	(637201, 135, '2015-01-01 00:15:26.000000', 'consum', 0.0214, 'lps'),
	(637202, 135, '2015-01-01 00:15:27.000000', 'consum', 0.0248, 'lps'),
	(637203, 135, '2015-01-01 00:15:28.000000', 'consum', 0.0263, 'lps'),
	(637204, 135, '2015-01-01 00:15:29.000000', 'consum', 0.0238, 'lps'),
	(637205, 135, '2015-01-01 00:15:30.000000', 'consum', 0.0254, 'lps'),
	(637206, 135, '2015-01-01 00:15:31.000000', 'consum', 0.0224, 'lps'),
	(637207, 135, '2015-01-01 00:15:32.000000', 'consum', 0.0210, 'lps'),
	(637208, 135, '2015-01-01 00:15:33.000000', 'consum', 0.0232, 'lps'),
	(637209, 135, '2015-01-01 00:15:34.000000', 'consum', 0.0256, 'lps'),
	(637210, 135, '2015-01-01 00:15:35.000000', 'consum', 0.0251, 'lps'),
	(637211, 135, '2015-01-01 00:15:36.000000', 'consum', 0.0214, 'lps'),
	(637212, 135, '2015-01-01 00:15:37.000000', 'consum', 0.0233, 'lps'),
	(637213, 135, '2015-01-01 00:15:38.000000', 'consum', 0.0252, 'lps'),
	(637214, 135, '2015-01-01 00:15:39.000000', 'consum', 0.0227, 'lps'),
	(637215, 135, '2015-01-01 00:15:40.000000', 'consum', 0.0233, 'lps'),
	(637216, 135, '2015-01-01 00:15:41.000000', 'consum', 0.0212, 'lps'),
	(637217, 135, '2015-01-01 00:15:42.000000', 'consum', 0.0213, 'lps'),
	(637218, 135, '2015-01-01 00:15:43.000000', 'consum', 0.0221, 'lps'),
	(637219, 135, '2015-01-01 00:15:44.000000', 'consum', 0.0254, 'lps'),
	(637220, 135, '2015-01-01 00:15:45.000000', 'consum', 0.0214, 'lps'),
	(637221, 135, '2015-01-01 00:15:46.000000', 'consum', 0.0222, 'lps'),
	(637222, 135, '2015-01-01 00:15:47.000000', 'consum', 0.0259, 'lps'),
	(637223, 135, '2015-01-01 00:15:48.000000', 'consum', 0.0234, 'lps'),
	(637224, 135, '2015-01-01 00:15:49.000000', 'consum', 0.0243, 'lps'),
	(637225, 135, '2015-01-01 00:15:50.000000', 'consum', 0.0244, 'lps'),
	(637226, 135, '2015-01-01 00:15:51.000000', 'consum', 0.0220, 'lps'),
	(637227, 135, '2015-01-01 00:15:52.000000', 'consum', 0.0221, 'lps'),
	(637228, 135, '2015-01-01 00:15:53.000000', 'consum', 0.0233, 'lps'),
	(637229, 135, '2015-01-01 00:15:54.000000', 'consum', 0.0231, 'lps'),
	(637230, 135, '2015-01-01 00:15:55.000000', 'consum', 0.0248, 'lps'),
	(637231, 135, '2015-01-01 00:15:56.000000', 'consum', 0.0214, 'lps'),
	(637232, 135, '2015-01-01 00:15:57.000000', 'consum', 0.0240, 'lps'),
	(637233, 135, '2015-01-01 00:15:58.000000', 'consum', 0.0226, 'lps'),
	(637234, 135, '2015-01-01 00:15:59.000000', 'consum', 0.0261, 'lps'),
	(637235, 135, '2015-01-01 00:16:00.000000', 'consum', 0.0230, 'lps'),
	(637236, 135, '2015-01-01 00:16:01.000000', 'consum', 0.0219, 'lps'),
	(637237, 135, '2015-01-01 00:16:02.000000', 'consum', 0.0259, 'lps'),
	(637238, 135, '2015-01-01 00:16:03.000000', 'consum', 0.0241, 'lps'),
	(637239, 135, '2015-01-01 00:16:04.000000', 'consum', 0.0218, 'lps'),
	(637240, 135, '2015-01-01 00:16:05.000000', 'consum', 0.0221, 'lps'),
	(637241, 135, '2015-01-01 00:16:06.000000', 'consum', 0.0241, 'lps'),
	(637242, 135, '2015-01-01 00:16:07.000000', 'consum', 0.0210, 'lps'),
	(637243, 135, '2015-01-01 00:16:08.000000', 'consum', 0.0241, 'lps'),
	(637244, 135, '2015-01-01 00:16:09.000000', 'consum', 0.0243, 'lps'),
	(637245, 135, '2015-01-01 00:16:10.000000', 'consum', 0.0220, 'lps'),
	(637246, 135, '2015-01-01 00:16:11.000000', 'consum', 0.0223, 'lps'),
	(637247, 135, '2015-01-01 00:16:12.000000', 'consum', 0.0244, 'lps'),
	(637248, 135, '2015-01-01 00:16:13.000000', 'consum', 0.0217, 'lps'),
	(637249, 135, '2015-01-01 00:16:14.000000', 'consum', 0.0268, 'lps'),
	(637250, 135, '2015-01-01 00:16:15.000000', 'consum', 0.0232, 'lps'),
	(637251, 135, '2015-01-01 00:16:16.000000', 'consum', 0.0269, 'lps'),
	(637252, 135, '2015-01-01 00:16:17.000000', 'consum', 0.0256, 'lps'),
	(637253, 135, '2015-01-01 00:16:18.000000', 'consum', 0.0264, 'lps'),
	(637254, 135, '2015-01-01 00:16:19.000000', 'consum', 0.0217, 'lps'),
	(637255, 135, '2015-01-01 00:16:20.000000', 'consum', 0.0210, 'lps'),
	(637256, 135, '2015-01-01 00:16:21.000000', 'consum', 0.0248, 'lps'),
	(637257, 135, '2015-01-01 00:16:22.000000', 'consum', 0.0218, 'lps'),
	(637258, 135, '2015-01-01 00:16:23.000000', 'consum', 0.0258, 'lps'),
	(637259, 135, '2015-01-01 00:16:24.000000', 'consum', 0.0242, 'lps'),
	(637260, 135, '2015-01-01 00:16:25.000000', 'consum', 0.0225, 'lps'),
	(637261, 135, '2015-01-01 00:16:26.000000', 'consum', 0.0254, 'lps'),
	(637262, 135, '2015-01-01 00:16:27.000000', 'consum', 0.0259, 'lps'),
	(637263, 135, '2015-01-01 00:16:28.000000', 'consum', 0.0260, 'lps'),
	(637264, 135, '2015-01-01 00:16:29.000000', 'consum', 0.0255, 'lps'),
	(637265, 135, '2015-01-01 00:16:30.000000', 'consum', 0.0220, 'lps'),
	(637266, 135, '2015-01-01 00:16:31.000000', 'consum', 0.0252, 'lps'),
	(637267, 135, '2015-01-01 00:16:32.000000', 'consum', 0.0264, 'lps'),
	(637268, 135, '2015-01-01 00:16:33.000000', 'consum', 0.0234, 'lps'),
	(637269, 135, '2015-01-01 00:16:34.000000', 'consum', 0.0228, 'lps'),
	(637270, 135, '2015-01-01 00:16:35.000000', 'consum', 0.0230, 'lps'),
	(637271, 135, '2015-01-01 00:16:36.000000', 'consum', 0.0256, 'lps'),
	(637272, 135, '2015-01-01 00:16:37.000000', 'consum', 0.0255, 'lps'),
	(637273, 135, '2015-01-01 00:16:38.000000', 'consum', 0.0238, 'lps'),
	(637274, 135, '2015-01-01 00:16:39.000000', 'consum', 0.0213, 'lps'),
	(637275, 135, '2015-01-01 00:16:40.000000', 'consum', 0.0266, 'lps'),
	(637276, 135, '2015-01-01 00:16:41.000000', 'consum', 0.0234, 'lps'),
	(637277, 135, '2015-01-01 00:16:42.000000', 'consum', 0.0225, 'lps'),
	(637278, 135, '2015-01-01 00:16:43.000000', 'consum', 0.0214, 'lps'),
	(637279, 135, '2015-01-01 00:16:44.000000', 'consum', 0.0246, 'lps'),
	(637280, 135, '2015-01-01 00:16:45.000000', 'consum', 0.0256, 'lps'),
	(637281, 135, '2015-01-01 00:16:46.000000', 'consum', 0.0269, 'lps'),
	(637282, 135, '2015-01-01 00:16:47.000000', 'consum', 0.0242, 'lps'),
	(637283, 135, '2015-01-01 00:16:48.000000', 'consum', 0.0257, 'lps'),
	(637284, 135, '2015-01-01 00:16:49.000000', 'consum', 0.0228, 'lps'),
	(637285, 135, '2015-01-01 00:16:50.000000', 'consum', 0.0218, 'lps'),
	(637286, 135, '2015-01-01 00:16:51.000000', 'consum', 0.0260, 'lps'),
	(637287, 135, '2015-01-01 00:16:52.000000', 'consum', 0.0249, 'lps'),
	(637288, 135, '2015-01-01 00:16:53.000000', 'consum', 0.0255, 'lps'),
	(637289, 135, '2015-01-01 00:16:54.000000', 'consum', 0.0258, 'lps'),
	(637290, 135, '2015-01-01 00:16:55.000000', 'consum', 0.0253, 'lps'),
	(637291, 135, '2015-01-01 00:16:56.000000', 'consum', 0.0220, 'lps'),
	(637292, 135, '2015-01-01 00:16:57.000000', 'consum', 0.0256, 'lps'),
	(637293, 135, '2015-01-01 00:16:58.000000', 'consum', 0.0225, 'lps'),
	(637294, 135, '2015-01-01 00:16:59.000000', 'consum', 0.0211, 'lps'),
	(637295, 135, '2015-01-01 00:17:00.000000', 'consum', 0.0229, 'lps'),
	(637296, 135, '2015-01-01 00:17:01.000000', 'consum', 0.0241, 'lps'),
	(637297, 135, '2015-01-01 00:17:02.000000', 'consum', 0.0247, 'lps'),
	(637298, 135, '2015-01-01 00:17:03.000000', 'consum', 0.0241, 'lps'),
	(637299, 135, '2015-01-01 00:17:04.000000', 'consum', 0.0253, 'lps'),
	(637300, 135, '2015-01-01 00:17:05.000000', 'consum', 0.0211, 'lps'),
	(637301, 135, '2015-01-01 00:17:06.000000', 'consum', 0.0270, 'lps'),
	(637302, 135, '2015-01-01 00:17:07.000000', 'consum', 0.0261, 'lps'),
	(637303, 135, '2015-01-01 00:17:08.000000', 'consum', 0.0224, 'lps'),
	(637304, 135, '2015-01-01 00:17:09.000000', 'consum', 0.0251, 'lps'),
	(637305, 135, '2015-01-01 00:17:10.000000', 'consum', 0.0250, 'lps'),
	(637306, 135, '2015-01-01 00:17:11.000000', 'consum', 0.0227, 'lps'),
	(637307, 135, '2015-01-01 00:17:12.000000', 'consum', 0.0237, 'lps'),
	(637308, 135, '2015-01-01 00:17:13.000000', 'consum', 0.0232, 'lps'),
	(637309, 135, '2015-01-01 00:17:14.000000', 'consum', 0.0239, 'lps'),
	(637310, 135, '2015-01-01 00:17:15.000000', 'consum', 0.0229, 'lps'),
	(637311, 135, '2015-01-01 00:17:16.000000', 'consum', 0.0217, 'lps'),
	(637312, 135, '2015-01-01 00:17:17.000000', 'consum', 0.0253, 'lps'),
	(637313, 135, '2015-01-01 00:17:18.000000', 'consum', 0.0217, 'lps'),
	(637314, 135, '2015-01-01 00:17:19.000000', 'consum', 0.0240, 'lps'),
	(637315, 135, '2015-01-01 00:17:20.000000', 'consum', 0.0216, 'lps'),
	(637316, 135, '2015-01-01 00:17:21.000000', 'consum', 0.0212, 'lps'),
	(637317, 135, '2015-01-01 00:17:22.000000', 'consum', 0.0264, 'lps'),
	(637318, 135, '2015-01-01 00:17:23.000000', 'consum', 0.0228, 'lps'),
	(637319, 135, '2015-01-01 00:17:24.000000', 'consum', 0.0260, 'lps'),
	(637320, 135, '2015-01-01 00:17:25.000000', 'consum', 0.0222, 'lps'),
	(637321, 135, '2015-01-01 00:17:26.000000', 'consum', 0.0246, 'lps'),
	(637322, 135, '2015-01-01 00:17:27.000000', 'consum', 0.0229, 'lps'),
	(637323, 135, '2015-01-01 00:17:28.000000', 'consum', 0.0262, 'lps'),
	(637324, 135, '2015-01-01 00:17:29.000000', 'consum', 0.0224, 'lps'),
	(637325, 135, '2015-01-01 00:17:30.000000', 'consum', 0.0251, 'lps'),
	(637326, 135, '2015-01-01 00:17:31.000000', 'consum', 0.0247, 'lps'),
	(637327, 135, '2015-01-01 00:17:32.000000', 'consum', 0.0210, 'lps'),
	(637328, 135, '2015-01-01 00:17:33.000000', 'consum', 0.0224, 'lps'),
	(637329, 135, '2015-01-01 00:17:34.000000', 'consum', 0.0221, 'lps'),
	(637330, 135, '2015-01-01 00:17:35.000000', 'consum', 0.0221, 'lps'),
	(637331, 135, '2015-01-01 00:17:36.000000', 'consum', 0.0234, 'lps'),
	(637332, 135, '2015-01-01 00:17:37.000000', 'consum', 0.0234, 'lps'),
	(637333, 135, '2015-01-01 00:17:38.000000', 'consum', 0.0259, 'lps'),
	(637334, 135, '2015-01-01 00:17:39.000000', 'consum', 0.0260, 'lps'),
	(637335, 135, '2015-01-01 00:17:40.000000', 'consum', 0.0253, 'lps'),
	(637336, 135, '2015-01-01 00:17:41.000000', 'consum', 0.0213, 'lps'),
	(637337, 135, '2015-01-01 00:17:42.000000', 'consum', 0.0221, 'lps'),
	(637338, 135, '2015-01-01 00:17:43.000000', 'consum', 0.0256, 'lps'),
	(637339, 135, '2015-01-01 00:17:44.000000', 'consum', 0.0221, 'lps'),
	(637340, 135, '2015-01-01 00:17:45.000000', 'consum', 0.0253, 'lps'),
	(637341, 135, '2015-01-01 00:17:46.000000', 'consum', 0.0268, 'lps'),
	(637342, 135, '2015-01-01 00:17:47.000000', 'consum', 0.0247, 'lps'),
	(637343, 135, '2015-01-01 00:17:48.000000', 'consum', 0.0221, 'lps'),
	(637344, 135, '2015-01-01 00:17:49.000000', 'consum', 0.0216, 'lps'),
	(637345, 135, '2015-01-01 00:17:50.000000', 'consum', 0.0210, 'lps'),
	(637346, 135, '2015-01-01 00:17:51.000000', 'consum', 0.0251, 'lps'),
	(637347, 135, '2015-01-01 00:17:52.000000', 'consum', 0.0232, 'lps'),
	(637348, 135, '2015-01-01 00:17:53.000000', 'consum', 0.0257, 'lps'),
	(637349, 135, '2015-01-01 00:17:54.000000', 'consum', 0.0256, 'lps'),
	(637350, 135, '2015-01-01 00:17:55.000000', 'consum', 0.0238, 'lps'),
	(637351, 135, '2015-01-01 00:17:56.000000', 'consum', 0.0212, 'lps'),
	(637352, 135, '2015-01-01 00:17:57.000000', 'consum', 0.0259, 'lps'),
	(637353, 135, '2015-01-01 00:17:58.000000', 'consum', 0.0266, 'lps'),
	(637354, 135, '2015-01-01 00:17:59.000000', 'consum', 0.0218, 'lps'),
	(637355, 135, '2015-01-01 00:18:00.000000', 'consum', 0.0268, 'lps'),
	(637356, 135, '2015-01-01 00:18:01.000000', 'consum', 0.0231, 'lps'),
	(637357, 135, '2015-01-01 00:18:02.000000', 'consum', 0.0265, 'lps'),
	(637358, 135, '2015-01-01 00:18:03.000000', 'consum', 0.0237, 'lps'),
	(637359, 135, '2015-01-01 00:18:04.000000', 'consum', 0.0242, 'lps'),
	(637360, 135, '2015-01-01 00:18:05.000000', 'consum', 0.0227, 'lps'),
	(637361, 135, '2015-01-01 00:18:06.000000', 'consum', 0.0262, 'lps'),
	(637362, 135, '2015-01-01 00:18:07.000000', 'consum', 0.0234, 'lps'),
	(637363, 135, '2015-01-01 00:18:08.000000', 'consum', 0.0234, 'lps'),
	(637364, 135, '2015-01-01 00:18:09.000000', 'consum', 0.0261, 'lps'),
	(637365, 135, '2015-01-01 00:18:10.000000', 'consum', 0.0269, 'lps'),
	(637366, 135, '2015-01-01 00:18:11.000000', 'consum', 0.0229, 'lps'),
	(637367, 135, '2015-01-01 00:18:12.000000', 'consum', 0.0252, 'lps'),
	(637368, 135, '2015-01-01 00:18:13.000000', 'consum', 0.0239, 'lps'),
	(637369, 135, '2015-01-01 00:18:14.000000', 'consum', 0.0231, 'lps'),
	(637370, 135, '2015-01-01 00:18:15.000000', 'consum', 0.0226, 'lps'),
	(637371, 135, '2015-01-01 00:18:16.000000', 'consum', 0.0230, 'lps'),
	(637372, 135, '2015-01-01 00:18:17.000000', 'consum', 0.0261, 'lps'),
	(637373, 135, '2015-01-01 00:18:18.000000', 'consum', 0.0220, 'lps'),
	(637374, 135, '2015-01-01 00:18:19.000000', 'consum', 0.0231, 'lps'),
	(637375, 135, '2015-01-01 00:18:20.000000', 'consum', 0.0222, 'lps'),
	(637376, 135, '2015-01-01 00:18:21.000000', 'consum', 0.0271, 'lps'),
	(637377, 135, '2015-01-01 00:18:22.000000', 'consum', 0.0230, 'lps'),
	(637378, 135, '2015-01-01 00:18:23.000000', 'consum', 0.0251, 'lps'),
	(637379, 135, '2015-01-01 00:18:24.000000', 'consum', 0.0232, 'lps'),
	(637380, 135, '2015-01-01 00:18:25.000000', 'consum', 0.0261, 'lps'),
	(637381, 135, '2015-01-01 00:18:26.000000', 'consum', 0.0215, 'lps'),
	(637382, 135, '2015-01-01 00:18:27.000000', 'consum', 0.0266, 'lps'),
	(637383, 135, '2015-01-01 00:18:28.000000', 'consum', 0.0227, 'lps'),
	(637384, 135, '2015-01-01 00:18:29.000000', 'consum', 0.0251, 'lps'),
	(637385, 135, '2015-01-01 00:18:30.000000', 'consum', 0.0241, 'lps'),
	(637386, 135, '2015-01-01 00:18:31.000000', 'consum', 0.0241, 'lps'),
	(637387, 135, '2015-01-01 00:18:32.000000', 'consum', 0.0211, 'lps'),
	(637388, 135, '2015-01-01 00:18:33.000000', 'consum', 0.0248, 'lps'),
	(637389, 135, '2015-01-01 00:18:34.000000', 'consum', 0.0211, 'lps'),
	(637390, 135, '2015-01-01 00:18:35.000000', 'consum', 0.0226, 'lps'),
	(637391, 135, '2015-01-01 00:18:36.000000', 'consum', 0.0227, 'lps'),
	(637392, 135, '2015-01-01 00:18:37.000000', 'consum', 0.0247, 'lps'),
	(637393, 135, '2015-01-01 00:18:38.000000', 'consum', 0.0218, 'lps'),
	(637394, 135, '2015-01-01 00:18:39.000000', 'consum', 0.0264, 'lps'),
	(637395, 135, '2015-01-01 00:18:40.000000', 'consum', 0.0210, 'lps'),
	(637396, 135, '2015-01-01 00:18:41.000000', 'consum', 0.0235, 'lps'),
	(637397, 135, '2015-01-01 00:18:42.000000', 'consum', 0.0210, 'lps'),
	(637398, 135, '2015-01-01 00:18:43.000000', 'consum', 0.0261, 'lps'),
	(637399, 135, '2015-01-01 00:18:44.000000', 'consum', 0.0218, 'lps'),
	(637400, 135, '2015-01-01 00:18:45.000000', 'consum', 0.0221, 'lps'),
	(637401, 135, '2015-01-01 00:18:46.000000', 'consum', 0.0239, 'lps'),
	(637402, 135, '2015-01-01 00:18:47.000000', 'consum', 0.0264, 'lps'),
	(637403, 135, '2015-01-01 00:18:48.000000', 'consum', 0.0267, 'lps'),
	(637404, 135, '2015-01-01 00:18:49.000000', 'consum', 0.0210, 'lps'),
	(637405, 135, '2015-01-01 00:18:50.000000', 'consum', 0.0224, 'lps'),
	(637406, 135, '2015-01-01 00:18:51.000000', 'consum', 0.0219, 'lps'),
	(637407, 135, '2015-01-01 00:18:52.000000', 'consum', 0.0213, 'lps'),
	(637408, 135, '2015-01-01 00:18:53.000000', 'consum', 0.0260, 'lps'),
	(637409, 135, '2015-01-01 00:18:54.000000', 'consum', 0.0267, 'lps'),
	(637410, 135, '2015-01-01 00:18:55.000000', 'consum', 0.0221, 'lps'),
	(637411, 135, '2015-01-01 00:18:56.000000', 'consum', 0.0217, 'lps'),
	(637412, 135, '2015-01-01 00:18:57.000000', 'consum', 0.0213, 'lps'),
	(637413, 135, '2015-01-01 00:18:58.000000', 'consum', 0.0268, 'lps'),
	(637414, 135, '2015-01-01 00:18:59.000000', 'consum', 0.0244, 'lps'),
	(637415, 135, '2015-01-01 00:19:00.000000', 'consum', 0.0269, 'lps'),
	(637416, 135, '2015-01-01 00:19:01.000000', 'consum', 0.0215, 'lps'),
	(637417, 135, '2015-01-01 00:19:02.000000', 'consum', 0.0245, 'lps'),
	(637418, 135, '2015-01-01 00:19:03.000000', 'consum', 0.0245, 'lps'),
	(637419, 135, '2015-01-01 00:19:04.000000', 'consum', 0.0222, 'lps'),
	(637420, 135, '2015-01-01 00:19:05.000000', 'consum', 0.0224, 'lps'),
	(637421, 135, '2015-01-01 00:19:06.000000', 'consum', 0.0247, 'lps'),
	(637422, 135, '2015-01-01 00:19:07.000000', 'consum', 0.0227, 'lps'),
	(637423, 135, '2015-01-01 00:19:08.000000', 'consum', 0.0246, 'lps'),
	(637424, 135, '2015-01-01 00:19:09.000000', 'consum', 0.0217, 'lps'),
	(637425, 135, '2015-01-01 00:19:10.000000', 'consum', 0.0260, 'lps'),
	(637426, 135, '2015-01-01 00:19:11.000000', 'consum', 0.0255, 'lps'),
	(637427, 135, '2015-01-01 00:19:12.000000', 'consum', 0.0225, 'lps'),
	(637428, 135, '2015-01-01 00:19:13.000000', 'consum', 0.0211, 'lps'),
	(637429, 135, '2015-01-01 00:19:14.000000', 'consum', 0.0233, 'lps'),
	(637430, 135, '2015-01-01 00:19:15.000000', 'consum', 0.0259, 'lps'),
	(637431, 135, '2015-01-01 00:19:16.000000', 'consum', 0.0262, 'lps'),
	(637432, 135, '2015-01-01 00:19:17.000000', 'consum', 0.0264, 'lps'),
	(637433, 135, '2015-01-01 00:19:18.000000', 'consum', 0.0262, 'lps'),
	(637434, 135, '2015-01-01 00:19:19.000000', 'consum', 0.0247, 'lps'),
	(637435, 135, '2015-01-01 00:19:20.000000', 'consum', 0.0240, 'lps'),
	(637436, 135, '2015-01-01 00:19:21.000000', 'consum', 0.0251, 'lps'),
	(637437, 135, '2015-01-01 00:19:22.000000', 'consum', 0.0261, 'lps'),
	(637438, 135, '2015-01-01 00:19:23.000000', 'consum', 0.0220, 'lps'),
	(637439, 135, '2015-01-01 00:19:24.000000', 'consum', 0.0231, 'lps'),
	(637440, 135, '2015-01-01 00:19:25.000000', 'consum', 0.0224, 'lps'),
	(637441, 135, '2015-01-01 00:19:26.000000', 'consum', 0.0218, 'lps'),
	(637442, 135, '2015-01-01 00:19:27.000000', 'consum', 0.0269, 'lps'),
	(637443, 135, '2015-01-01 00:19:28.000000', 'consum', 0.0234, 'lps'),
	(637444, 135, '2015-01-01 00:19:29.000000', 'consum', 0.0215, 'lps'),
	(637445, 135, '2015-01-01 00:19:30.000000', 'consum', 0.0228, 'lps'),
	(637446, 135, '2015-01-01 00:19:31.000000', 'consum', 0.0221, 'lps'),
	(637447, 135, '2015-01-01 00:19:32.000000', 'consum', 0.0212, 'lps'),
	(637448, 135, '2015-01-01 00:19:33.000000', 'consum', 0.0251, 'lps'),
	(637449, 135, '2015-01-01 00:19:34.000000', 'consum', 0.0222, 'lps'),
	(637450, 135, '2015-01-01 00:19:35.000000', 'consum', 0.0270, 'lps'),
	(637451, 135, '2015-01-01 00:19:36.000000', 'consum', 0.0229, 'lps'),
	(637452, 135, '2015-01-01 00:19:37.000000', 'consum', 0.0250, 'lps'),
	(637453, 135, '2015-01-01 00:19:38.000000', 'consum', 0.0229, 'lps'),
	(637454, 135, '2015-01-01 00:19:39.000000', 'consum', 0.0249, 'lps'),
	(637455, 135, '2015-01-01 00:19:40.000000', 'consum', 0.0222, 'lps'),
	(637456, 135, '2015-01-01 00:19:41.000000', 'consum', 0.0214, 'lps'),
	(637457, 135, '2015-01-01 00:19:42.000000', 'consum', 0.0260, 'lps'),
	(637458, 135, '2015-01-01 00:19:43.000000', 'consum', 0.0261, 'lps'),
	(637459, 135, '2015-01-01 00:19:44.000000', 'consum', 0.0255, 'lps'),
	(637460, 135, '2015-01-01 00:19:45.000000', 'consum', 0.0218, 'lps'),
	(637461, 135, '2015-01-01 00:19:46.000000', 'consum', 0.0241, 'lps'),
	(637462, 135, '2015-01-01 00:19:47.000000', 'consum', 0.0216, 'lps'),
	(637463, 135, '2015-01-01 00:19:48.000000', 'consum', 0.0210, 'lps'),
	(637464, 135, '2015-01-01 00:19:49.000000', 'consum', 0.0256, 'lps'),
	(637465, 135, '2015-01-01 00:19:50.000000', 'consum', 0.0252, 'lps'),
	(637466, 135, '2015-01-01 00:19:51.000000', 'consum', 0.0223, 'lps'),
	(637467, 135, '2015-01-01 00:19:52.000000', 'consum', 0.0210, 'lps'),
	(637468, 135, '2015-01-01 00:19:53.000000', 'consum', 0.0234, 'lps'),
	(637469, 135, '2015-01-01 00:19:54.000000', 'consum', 0.0269, 'lps'),
	(637470, 135, '2015-01-01 00:19:55.000000', 'consum', 0.0247, 'lps'),
	(637471, 135, '2015-01-01 00:19:56.000000', 'consum', 0.0219, 'lps'),
	(637472, 135, '2015-01-01 00:19:57.000000', 'consum', 0.0268, 'lps'),
	(637473, 135, '2015-01-01 00:19:58.000000', 'consum', 0.0225, 'lps'),
	(637474, 135, '2015-01-01 00:19:59.000000', 'consum', 0.0237, 'lps'),
	(637475, 135, '2015-01-01 00:20:00.000000', 'consum', 0.0237, 'lps'),
	(637476, 135, '2015-01-01 00:20:01.000000', 'consum', 0.0266, 'lps'),
	(637477, 135, '2015-01-01 00:20:02.000000', 'consum', 0.0222, 'lps'),
	(637478, 135, '2015-01-01 00:20:03.000000', 'consum', 0.0226, 'lps'),
	(637479, 135, '2015-01-01 00:20:04.000000', 'consum', 0.0255, 'lps'),
	(637480, 135, '2015-01-01 00:20:05.000000', 'consum', 0.0265, 'lps'),
	(637481, 135, '2015-01-01 00:20:06.000000', 'consum', 0.0224, 'lps'),
	(637482, 135, '2015-01-01 00:20:07.000000', 'consum', 0.0242, 'lps'),
	(637483, 135, '2015-01-01 00:20:08.000000', 'consum', 0.0265, 'lps'),
	(637484, 135, '2015-01-01 00:20:09.000000', 'consum', 0.0265, 'lps'),
	(637485, 135, '2015-01-01 00:20:10.000000', 'consum', 0.0258, 'lps'),
	(637486, 135, '2015-01-01 00:20:11.000000', 'consum', 0.0224, 'lps'),
	(637487, 135, '2015-01-01 00:20:12.000000', 'consum', 0.0261, 'lps'),
	(637488, 135, '2015-01-01 00:20:13.000000', 'consum', 0.0236, 'lps'),
	(637489, 135, '2015-01-01 00:20:14.000000', 'consum', 0.0249, 'lps'),
	(637490, 135, '2015-01-01 00:20:15.000000', 'consum', 0.0264, 'lps'),
	(637491, 135, '2015-01-01 00:20:16.000000', 'consum', 0.0243, 'lps'),
	(637492, 135, '2015-01-01 00:20:17.000000', 'consum', 0.0213, 'lps'),
	(637493, 135, '2015-01-01 00:20:18.000000', 'consum', 0.0249, 'lps'),
	(637494, 135, '2015-01-01 00:20:19.000000', 'consum', 0.0210, 'lps'),
	(637495, 135, '2015-01-01 00:20:20.000000', 'consum', 0.0218, 'lps'),
	(637496, 135, '2015-01-01 00:20:21.000000', 'consum', 0.0251, 'lps'),
	(637497, 135, '2015-01-01 00:20:22.000000', 'consum', 0.0269, 'lps'),
	(637498, 135, '2015-01-01 00:20:23.000000', 'consum', 0.0258, 'lps'),
	(637499, 135, '2015-01-01 00:20:24.000000', 'consum', 0.0212, 'lps'),
	(637500, 135, '2015-01-01 00:20:25.000000', 'consum', 0.0264, 'lps'),
	(637501, 135, '2015-01-01 00:20:26.000000', 'consum', 0.0224, 'lps'),
	(637502, 135, '2015-01-01 00:20:27.000000', 'consum', 0.0243, 'lps'),
	(637503, 135, '2015-01-01 00:20:28.000000', 'consum', 0.0270, 'lps'),
	(637504, 135, '2015-01-01 00:20:29.000000', 'consum', 0.0226, 'lps'),
	(637505, 135, '2015-01-01 00:20:30.000000', 'consum', 0.0236, 'lps'),
	(637506, 135, '2015-01-01 00:20:31.000000', 'consum', 0.0231, 'lps'),
	(637507, 135, '2015-01-01 00:20:32.000000', 'consum', 0.0235, 'lps'),
	(637508, 135, '2015-01-01 00:20:33.000000', 'consum', 0.0212, 'lps'),
	(637509, 135, '2015-01-01 00:20:34.000000', 'consum', 0.0271, 'lps'),
	(637510, 135, '2015-01-01 00:20:35.000000', 'consum', 0.0261, 'lps'),
	(637511, 135, '2015-01-01 00:20:36.000000', 'consum', 0.0218, 'lps'),
	(637512, 135, '2015-01-01 00:20:37.000000', 'consum', 0.0223, 'lps'),
	(637513, 135, '2015-01-01 00:20:38.000000', 'consum', 0.0250, 'lps'),
	(637514, 135, '2015-01-01 00:20:39.000000', 'consum', 0.0248, 'lps'),
	(637515, 135, '2015-01-01 00:20:40.000000', 'consum', 0.0219, 'lps'),
	(637516, 135, '2015-01-01 00:20:41.000000', 'consum', 0.0267, 'lps'),
	(637517, 135, '2015-01-01 00:20:42.000000', 'consum', 0.0221, 'lps'),
	(637518, 135, '2015-01-01 00:20:43.000000', 'consum', 0.0217, 'lps'),
	(637519, 135, '2015-01-01 00:20:44.000000', 'consum', 0.0212, 'lps'),
	(637520, 135, '2015-01-01 00:20:45.000000', 'consum', 0.0263, 'lps'),
	(637521, 135, '2015-01-01 00:20:46.000000', 'consum', 0.0222, 'lps'),
	(637522, 135, '2015-01-01 00:20:47.000000', 'consum', 0.0236, 'lps'),
	(637523, 135, '2015-01-01 00:20:48.000000', 'consum', 0.0242, 'lps'),
	(637524, 135, '2015-01-01 00:20:49.000000', 'consum', 0.0229, 'lps'),
	(637525, 135, '2015-01-01 00:20:50.000000', 'consum', 0.0211, 'lps'),
	(637526, 135, '2015-01-01 00:20:51.000000', 'consum', 0.0222, 'lps'),
	(637527, 135, '2015-01-01 00:20:52.000000', 'consum', 0.0266, 'lps'),
	(637528, 135, '2015-01-01 00:20:53.000000', 'consum', 0.0270, 'lps'),
	(637529, 135, '2015-01-01 00:20:54.000000', 'consum', 0.0219, 'lps'),
	(637530, 135, '2015-01-01 00:20:55.000000', 'consum', 0.0259, 'lps'),
	(637531, 135, '2015-01-01 00:20:56.000000', 'consum', 0.0244, 'lps'),
	(637532, 135, '2015-01-01 00:20:57.000000', 'consum', 0.0234, 'lps'),
	(637533, 135, '2015-01-01 00:20:58.000000', 'consum', 0.0227, 'lps'),
	(637534, 135, '2015-01-01 00:20:59.000000', 'consum', 0.0225, 'lps'),
	(637535, 135, '2015-01-01 00:21:00.000000', 'consum', 0.0232, 'lps'),
	(637536, 135, '2015-01-01 00:21:01.000000', 'consum', 0.0215, 'lps'),
	(637537, 135, '2015-01-01 00:21:02.000000', 'consum', 0.0231, 'lps'),
	(637538, 135, '2015-01-01 00:21:03.000000', 'consum', 0.0238, 'lps'),
	(637539, 135, '2015-01-01 00:21:04.000000', 'consum', 0.0228, 'lps'),
	(637540, 135, '2015-01-01 00:21:05.000000', 'consum', 0.0214, 'lps'),
	(637541, 135, '2015-01-01 00:21:06.000000', 'consum', 0.0240, 'lps'),
	(637542, 135, '2015-01-01 00:21:07.000000', 'consum', 0.0225, 'lps'),
	(637543, 135, '2015-01-01 00:21:08.000000', 'consum', 0.0255, 'lps'),
	(637544, 135, '2015-01-01 00:21:09.000000', 'consum', 0.0267, 'lps'),
	(637545, 135, '2015-01-01 00:21:10.000000', 'consum', 0.0238, 'lps'),
	(637546, 135, '2015-01-01 00:21:11.000000', 'consum', 0.0241, 'lps'),
	(637547, 135, '2015-01-01 00:21:12.000000', 'consum', 0.0221, 'lps'),
	(637548, 135, '2015-01-01 00:21:13.000000', 'consum', 0.0232, 'lps'),
	(637549, 135, '2015-01-01 00:21:14.000000', 'consum', 0.0225, 'lps'),
	(637550, 135, '2015-01-01 00:21:15.000000', 'consum', 0.0222, 'lps'),
	(637551, 135, '2015-01-01 00:21:16.000000', 'consum', 0.0222, 'lps'),
	(637552, 135, '2015-01-01 00:21:17.000000', 'consum', 0.0238, 'lps'),
	(637553, 135, '2015-01-01 00:21:18.000000', 'consum', 0.0253, 'lps'),
	(637554, 135, '2015-01-01 00:21:19.000000', 'consum', 0.0215, 'lps'),
	(637555, 135, '2015-01-01 00:21:20.000000', 'consum', 0.0233, 'lps'),
	(637556, 135, '2015-01-01 00:21:21.000000', 'consum', 0.0247, 'lps'),
	(637557, 135, '2015-01-01 00:21:22.000000', 'consum', 0.0263, 'lps'),
	(637558, 135, '2015-01-01 00:21:23.000000', 'consum', 0.0241, 'lps'),
	(637559, 135, '2015-01-01 00:21:24.000000', 'consum', 0.0269, 'lps'),
	(637560, 135, '2015-01-01 00:21:25.000000', 'consum', 0.0227, 'lps'),
	(637561, 135, '2015-01-01 00:21:26.000000', 'consum', 0.0242, 'lps'),
	(637562, 135, '2015-01-01 00:21:27.000000', 'consum', 0.0257, 'lps'),
	(637563, 135, '2015-01-01 00:21:28.000000', 'consum', 0.0226, 'lps'),
	(637564, 135, '2015-01-01 00:21:29.000000', 'consum', 0.0210, 'lps'),
	(637565, 135, '2015-01-01 00:21:30.000000', 'consum', 0.0227, 'lps'),
	(637566, 135, '2015-01-01 00:21:31.000000', 'consum', 0.0233, 'lps'),
	(637567, 135, '2015-01-01 00:21:32.000000', 'consum', 0.0213, 'lps'),
	(637568, 135, '2015-01-01 00:21:33.000000', 'consum', 0.0220, 'lps'),
	(637569, 135, '2015-01-01 00:21:34.000000', 'consum', 0.0248, 'lps'),
	(637570, 135, '2015-01-01 00:21:35.000000', 'consum', 0.0250, 'lps'),
	(637571, 135, '2015-01-01 00:21:36.000000', 'consum', 0.0232, 'lps'),
	(637572, 135, '2015-01-01 00:21:37.000000', 'consum', 0.0262, 'lps'),
	(637573, 135, '2015-01-01 00:21:38.000000', 'consum', 0.0218, 'lps'),
	(637574, 135, '2015-01-01 00:21:39.000000', 'consum', 0.0219, 'lps'),
	(637575, 135, '2015-01-01 00:21:40.000000', 'consum', 0.0232, 'lps'),
	(637576, 135, '2015-01-01 00:21:41.000000', 'consum', 0.0231, 'lps'),
	(637577, 135, '2015-01-01 00:21:42.000000', 'consum', 0.0249, 'lps'),
	(637578, 135, '2015-01-01 00:21:43.000000', 'consum', 0.0221, 'lps'),
	(637579, 135, '2015-01-01 00:21:44.000000', 'consum', 0.0270, 'lps'),
	(637580, 135, '2015-01-01 00:21:45.000000', 'consum', 0.0232, 'lps'),
	(637581, 135, '2015-01-01 00:21:46.000000', 'consum', 0.0263, 'lps'),
	(637582, 135, '2015-01-01 00:21:47.000000', 'consum', 0.0224, 'lps'),
	(637583, 135, '2015-01-01 00:21:48.000000', 'consum', 0.0244, 'lps'),
	(637584, 135, '2015-01-01 00:21:49.000000', 'consum', 0.0217, 'lps'),
	(637585, 135, '2015-01-01 00:21:50.000000', 'consum', 0.0268, 'lps'),
	(637586, 135, '2015-01-01 00:21:51.000000', 'consum', 0.0229, 'lps'),
	(637587, 135, '2015-01-01 00:21:52.000000', 'consum', 0.0257, 'lps'),
	(637588, 135, '2015-01-01 00:21:53.000000', 'consum', 0.0265, 'lps'),
	(637589, 135, '2015-01-01 00:21:54.000000', 'consum', 0.0221, 'lps'),
	(637590, 135, '2015-01-01 00:21:55.000000', 'consum', 0.0222, 'lps'),
	(637591, 135, '2015-01-01 00:21:56.000000', 'consum', 0.0240, 'lps'),
	(637592, 135, '2015-01-01 00:21:57.000000', 'consum', 0.0262, 'lps'),
	(637593, 135, '2015-01-01 00:21:58.000000', 'consum', 0.0255, 'lps'),
	(637594, 135, '2015-01-01 00:21:59.000000', 'consum', 0.0218, 'lps'),
	(637595, 135, '2015-01-01 00:22:00.000000', 'consum', 0.0239, 'lps'),
	(637596, 135, '2015-01-01 00:22:01.000000', 'consum', 0.0270, 'lps'),
	(637597, 135, '2015-01-01 00:22:02.000000', 'consum', 0.0239, 'lps'),
	(637598, 135, '2015-01-01 00:22:03.000000', 'consum', 0.0236, 'lps'),
	(637599, 135, '2015-01-01 00:22:04.000000', 'consum', 0.0255, 'lps'),
	(637600, 135, '2015-01-01 00:22:05.000000', 'consum', 0.0235, 'lps'),
	(637601, 135, '2015-01-01 00:22:06.000000', 'consum', 0.0260, 'lps'),
	(637602, 135, '2015-01-01 00:22:07.000000', 'consum', 0.0261, 'lps'),
	(637603, 135, '2015-01-01 00:22:08.000000', 'consum', 0.0256, 'lps'),
	(637604, 135, '2015-01-01 00:22:09.000000', 'consum', 0.0225, 'lps'),
	(637605, 135, '2015-01-01 00:22:10.000000', 'consum', 0.0271, 'lps'),
	(637606, 135, '2015-01-01 00:22:11.000000', 'consum', 0.0224, 'lps'),
	(637607, 135, '2015-01-01 00:22:12.000000', 'consum', 0.0223, 'lps'),
	(637608, 135, '2015-01-01 00:22:13.000000', 'consum', 0.0230, 'lps'),
	(637609, 135, '2015-01-01 00:22:14.000000', 'consum', 0.0271, 'lps'),
	(637610, 135, '2015-01-01 00:22:15.000000', 'consum', 0.0271, 'lps'),
	(637611, 135, '2015-01-01 00:22:16.000000', 'consum', 0.0210, 'lps'),
	(637612, 135, '2015-01-01 00:22:17.000000', 'consum', 0.0211, 'lps'),
	(637613, 135, '2015-01-01 00:22:18.000000', 'consum', 0.0217, 'lps'),
	(637614, 135, '2015-01-01 00:22:19.000000', 'consum', 0.0240, 'lps'),
	(637615, 135, '2015-01-01 00:22:20.000000', 'consum', 0.0217, 'lps'),
	(637616, 135, '2015-01-01 00:22:21.000000', 'consum', 0.0217, 'lps'),
	(637617, 135, '2015-01-01 00:22:22.000000', 'consum', 0.0225, 'lps'),
	(637618, 135, '2015-01-01 00:22:23.000000', 'consum', 0.0264, 'lps'),
	(637619, 135, '2015-01-01 00:22:24.000000', 'consum', 0.0250, 'lps'),
	(637620, 135, '2015-01-01 00:22:25.000000', 'consum', 0.0250, 'lps'),
	(637621, 135, '2015-01-01 00:22:26.000000', 'consum', 0.0227, 'lps'),
	(637622, 135, '2015-01-01 00:22:27.000000', 'consum', 0.0239, 'lps'),
	(637623, 135, '2015-01-01 00:22:28.000000', 'consum', 0.0240, 'lps'),
	(637624, 135, '2015-01-01 00:22:29.000000', 'consum', 0.0215, 'lps'),
	(637625, 135, '2015-01-01 00:22:30.000000', 'consum', 0.0267, 'lps'),
	(637626, 135, '2015-01-01 00:22:31.000000', 'consum', 0.0231, 'lps'),
	(637627, 135, '2015-01-01 00:22:32.000000', 'consum', 0.0271, 'lps'),
	(637628, 135, '2015-01-01 00:22:33.000000', 'consum', 0.0267, 'lps'),
	(637629, 135, '2015-01-01 00:22:34.000000', 'consum', 0.0251, 'lps'),
	(637630, 135, '2015-01-01 00:22:35.000000', 'consum', 0.0245, 'lps'),
	(637631, 135, '2015-01-01 00:22:36.000000', 'consum', 0.0261, 'lps'),
	(637632, 135, '2015-01-01 00:22:37.000000', 'consum', 0.0235, 'lps'),
	(637633, 135, '2015-01-01 00:22:38.000000', 'consum', 0.0245, 'lps'),
	(637634, 135, '2015-01-01 00:22:39.000000', 'consum', 0.0250, 'lps'),
	(637635, 135, '2015-01-01 00:22:40.000000', 'consum', 0.0242, 'lps'),
	(637636, 135, '2015-01-01 00:22:41.000000', 'consum', 0.0253, 'lps'),
	(637637, 135, '2015-01-01 00:22:42.000000', 'consum', 0.0265, 'lps'),
	(637638, 135, '2015-01-01 00:22:43.000000', 'consum', 0.0235, 'lps'),
	(637639, 135, '2015-01-01 00:22:44.000000', 'consum', 0.0233, 'lps'),
	(637640, 135, '2015-01-01 00:22:45.000000', 'consum', 0.0249, 'lps'),
	(637641, 135, '2015-01-01 00:22:46.000000', 'consum', 0.0212, 'lps'),
	(637642, 135, '2015-01-01 00:22:47.000000', 'consum', 0.0230, 'lps'),
	(637643, 135, '2015-01-01 00:22:48.000000', 'consum', 0.0241, 'lps'),
	(637644, 135, '2015-01-01 00:22:49.000000', 'consum', 0.0244, 'lps'),
	(637645, 135, '2015-01-01 00:22:50.000000', 'consum', 0.0225, 'lps'),
	(637646, 135, '2015-01-01 00:22:51.000000', 'consum', 0.0245, 'lps'),
	(637647, 135, '2015-01-01 00:22:52.000000', 'consum', 0.0218, 'lps'),
	(637648, 135, '2015-01-01 00:22:53.000000', 'consum', 0.0268, 'lps'),
	(637649, 135, '2015-01-01 00:22:54.000000', 'consum', 0.0228, 'lps'),
	(637650, 135, '2015-01-01 00:22:55.000000', 'consum', 0.0251, 'lps'),
	(637651, 135, '2015-01-01 00:22:56.000000', 'consum', 0.0239, 'lps'),
	(637652, 135, '2015-01-01 00:22:57.000000', 'consum', 0.0231, 'lps'),
	(637653, 135, '2015-01-01 00:22:58.000000', 'consum', 0.0229, 'lps'),
	(637654, 135, '2015-01-01 00:22:59.000000', 'consum', 0.0242, 'lps'),
	(637655, 135, '2015-01-01 00:23:00.000000', 'consum', 0.0253, 'lps'),
	(637656, 135, '2015-01-01 00:23:01.000000', 'consum', 0.0268, 'lps'),
	(637657, 135, '2015-01-01 00:23:02.000000', 'consum', 0.0248, 'lps'),
	(637658, 135, '2015-01-01 00:23:03.000000', 'consum', 0.0226, 'lps'),
	(637659, 135, '2015-01-01 00:23:04.000000', 'consum', 0.0239, 'lps'),
	(637660, 135, '2015-01-01 00:23:05.000000', 'consum', 0.0243, 'lps'),
	(637661, 135, '2015-01-01 00:23:06.000000', 'consum', 0.0228, 'lps'),
	(637662, 135, '2015-01-01 00:23:07.000000', 'consum', 0.0262, 'lps'),
	(637663, 135, '2015-01-01 00:23:08.000000', 'consum', 0.0230, 'lps'),
	(637664, 135, '2015-01-01 00:23:09.000000', 'consum', 0.0220, 'lps'),
	(637665, 135, '2015-01-01 00:23:10.000000', 'consum', 0.0259, 'lps'),
	(637666, 135, '2015-01-01 00:23:11.000000', 'consum', 0.0240, 'lps'),
	(637667, 135, '2015-01-01 00:23:12.000000', 'consum', 0.0215, 'lps'),
	(637668, 135, '2015-01-01 00:23:13.000000', 'consum', 0.0270, 'lps'),
	(637669, 135, '2015-01-01 00:23:14.000000', 'consum', 0.0247, 'lps'),
	(637670, 135, '2015-01-01 00:23:15.000000', 'consum', 0.0215, 'lps'),
	(637671, 135, '2015-01-01 00:23:16.000000', 'consum', 0.0249, 'lps'),
	(637672, 135, '2015-01-01 00:23:17.000000', 'consum', 0.0265, 'lps'),
	(637673, 135, '2015-01-01 00:23:18.000000', 'consum', 0.0246, 'lps'),
	(637674, 135, '2015-01-01 00:23:19.000000', 'consum', 0.0227, 'lps'),
	(637675, 135, '2015-01-01 00:23:20.000000', 'consum', 0.0247, 'lps'),
	(637676, 135, '2015-01-01 00:23:21.000000', 'consum', 0.0220, 'lps'),
	(637677, 135, '2015-01-01 00:23:22.000000', 'consum', 0.0213, 'lps'),
	(637678, 135, '2015-01-01 00:23:23.000000', 'consum', 0.0257, 'lps'),
	(637679, 135, '2015-01-01 00:23:24.000000', 'consum', 0.0250, 'lps'),
	(637680, 135, '2015-01-01 00:23:25.000000', 'consum', 0.0269, 'lps'),
	(637681, 135, '2015-01-01 00:23:26.000000', 'consum', 0.0262, 'lps'),
	(637682, 135, '2015-01-01 00:23:27.000000', 'consum', 0.0230, 'lps'),
	(637683, 135, '2015-01-01 00:23:28.000000', 'consum', 0.0218, 'lps'),
	(637684, 135, '2015-01-01 00:23:29.000000', 'consum', 0.0252, 'lps'),
	(637685, 135, '2015-01-01 00:23:30.000000', 'consum', 0.0271, 'lps'),
	(637686, 135, '2015-01-01 00:23:31.000000', 'consum', 0.0267, 'lps'),
	(637687, 135, '2015-01-01 00:23:32.000000', 'consum', 0.0249, 'lps'),
	(637688, 135, '2015-01-01 00:23:33.000000', 'consum', 0.0234, 'lps'),
	(637689, 135, '2015-01-01 00:23:34.000000', 'consum', 0.0216, 'lps'),
	(637690, 135, '2015-01-01 00:23:35.000000', 'consum', 0.0230, 'lps'),
	(637691, 135, '2015-01-01 00:23:36.000000', 'consum', 0.0231, 'lps'),
	(637692, 135, '2015-01-01 00:23:37.000000', 'consum', 0.0254, 'lps'),
	(637693, 135, '2015-01-01 00:23:38.000000', 'consum', 0.0246, 'lps'),
	(637694, 135, '2015-01-01 00:23:39.000000', 'consum', 0.0258, 'lps'),
	(637695, 135, '2015-01-01 00:23:40.000000', 'consum', 0.0219, 'lps'),
	(637696, 135, '2015-01-01 00:23:41.000000', 'consum', 0.0233, 'lps'),
	(637697, 135, '2015-01-01 00:23:42.000000', 'consum', 0.0239, 'lps'),
	(637698, 135, '2015-01-01 00:23:43.000000', 'consum', 0.0225, 'lps'),
	(637699, 135, '2015-01-01 00:23:44.000000', 'consum', 0.0261, 'lps'),
	(637700, 135, '2015-01-01 00:23:45.000000', 'consum', 0.0235, 'lps'),
	(637701, 135, '2015-01-01 00:23:46.000000', 'consum', 0.0242, 'lps'),
	(637702, 135, '2015-01-01 00:23:47.000000', 'consum', 0.0235, 'lps'),
	(637703, 135, '2015-01-01 00:23:48.000000', 'consum', 0.0240, 'lps'),
	(637704, 135, '2015-01-01 00:23:49.000000', 'consum', 0.0225, 'lps'),
	(637705, 135, '2015-01-01 00:23:50.000000', 'consum', 0.0256, 'lps'),
	(637706, 135, '2015-01-01 00:23:51.000000', 'consum', 0.0270, 'lps'),
	(637707, 135, '2015-01-01 00:23:52.000000', 'consum', 0.0249, 'lps'),
	(637708, 135, '2015-01-01 00:23:53.000000', 'consum', 0.0227, 'lps'),
	(637709, 135, '2015-01-01 00:23:54.000000', 'consum', 0.0239, 'lps'),
	(637710, 135, '2015-01-01 00:23:55.000000', 'consum', 0.0241, 'lps'),
	(637711, 135, '2015-01-01 00:23:56.000000', 'consum', 0.0220, 'lps'),
	(637712, 135, '2015-01-01 00:23:57.000000', 'consum', 0.0226, 'lps'),
	(637713, 135, '2015-01-01 00:23:58.000000', 'consum', 0.0263, 'lps'),
	(637714, 135, '2015-01-01 00:23:59.000000', 'consum', 0.0239, 'lps'),
	(637715, 135, '2015-01-01 00:24:00.000000', 'consum', 0.0259, 'lps'),
	(637716, 135, '2015-01-01 00:24:01.000000', 'consum', 0.0246, 'lps'),
	(637717, 135, '2015-01-01 00:24:02.000000', 'consum', 0.0244, 'lps'),
	(637718, 135, '2015-01-01 00:24:03.000000', 'consum', 0.0211, 'lps'),
	(637719, 135, '2015-01-01 00:24:04.000000', 'consum', 0.0237, 'lps'),
	(637720, 135, '2015-01-01 00:24:05.000000', 'consum', 0.0218, 'lps'),
	(637721, 135, '2015-01-01 00:24:06.000000', 'consum', 0.0232, 'lps'),
	(637722, 135, '2015-01-01 00:24:07.000000', 'consum', 0.0236, 'lps'),
	(637723, 135, '2015-01-01 00:24:08.000000', 'consum', 0.0211, 'lps'),
	(637724, 135, '2015-01-01 00:24:09.000000', 'consum', 0.0262, 'lps'),
	(637725, 135, '2015-01-01 00:24:10.000000', 'consum', 0.0221, 'lps'),
	(637726, 135, '2015-01-01 00:24:11.000000', 'consum', 0.0233, 'lps'),
	(637727, 135, '2015-01-01 00:24:12.000000', 'consum', 0.0230, 'lps'),
	(637728, 135, '2015-01-01 00:24:13.000000', 'consum', 0.0240, 'lps'),
	(637729, 135, '2015-01-01 00:24:14.000000', 'consum', 0.0240, 'lps'),
	(637730, 135, '2015-01-01 00:24:15.000000', 'consum', 0.0269, 'lps'),
	(637731, 135, '2015-01-01 00:24:16.000000', 'consum', 0.0232, 'lps'),
	(637732, 135, '2015-01-01 00:24:17.000000', 'consum', 0.0268, 'lps'),
	(637733, 135, '2015-01-01 00:24:18.000000', 'consum', 0.0248, 'lps'),
	(637734, 135, '2015-01-01 00:24:19.000000', 'consum', 0.0227, 'lps'),
	(637735, 135, '2015-01-01 00:24:20.000000', 'consum', 0.0243, 'lps'),
	(637736, 135, '2015-01-01 00:24:21.000000', 'consum', 0.0262, 'lps'),
	(637737, 135, '2015-01-01 00:24:22.000000', 'consum', 0.0249, 'lps'),
	(637738, 135, '2015-01-01 00:24:23.000000', 'consum', 0.0247, 'lps'),
	(637739, 135, '2015-01-01 00:24:24.000000', 'consum', 0.0216, 'lps'),
	(637740, 135, '2015-01-01 00:24:25.000000', 'consum', 0.0254, 'lps'),
	(637741, 135, '2015-01-01 00:24:26.000000', 'consum', 0.0226, 'lps'),
	(637742, 135, '2015-01-01 00:24:27.000000', 'consum', 0.0219, 'lps'),
	(637743, 135, '2015-01-01 00:24:28.000000', 'consum', 0.0271, 'lps'),
	(637744, 135, '2015-01-01 00:24:29.000000', 'consum', 0.0241, 'lps'),
	(637745, 135, '2015-01-01 00:24:30.000000', 'consum', 0.0245, 'lps'),
	(637746, 135, '2015-01-01 00:24:31.000000', 'consum', 0.0230, 'lps'),
	(637747, 135, '2015-01-01 00:24:32.000000', 'consum', 0.0266, 'lps'),
	(637748, 135, '2015-01-01 00:24:33.000000', 'consum', 0.0244, 'lps'),
	(637749, 135, '2015-01-01 00:24:34.000000', 'consum', 0.0213, 'lps'),
	(637750, 135, '2015-01-01 00:24:35.000000', 'consum', 0.0248, 'lps'),
	(637751, 135, '2015-01-01 00:24:36.000000', 'consum', 0.0268, 'lps'),
	(637752, 135, '2015-01-01 00:24:37.000000', 'consum', 0.0262, 'lps'),
	(637753, 135, '2015-01-01 00:24:38.000000', 'consum', 0.0236, 'lps'),
	(637754, 135, '2015-01-01 00:24:39.000000', 'consum', 0.0244, 'lps'),
	(637755, 135, '2015-01-01 00:24:40.000000', 'consum', 0.0241, 'lps'),
	(637756, 135, '2015-01-01 00:24:41.000000', 'consum', 0.0265, 'lps'),
	(637757, 135, '2015-01-01 00:24:42.000000', 'consum', 0.0269, 'lps'),
	(637758, 135, '2015-01-01 00:24:43.000000', 'consum', 0.0215, 'lps'),
	(637759, 135, '2015-01-01 00:24:44.000000', 'consum', 0.0244, 'lps'),
	(637760, 135, '2015-01-01 00:24:45.000000', 'consum', 0.0241, 'lps'),
	(637761, 135, '2015-01-01 00:24:46.000000', 'consum', 0.0263, 'lps'),
	(637762, 135, '2015-01-01 00:24:47.000000', 'consum', 0.0258, 'lps'),
	(637763, 135, '2015-01-01 00:24:48.000000', 'consum', 0.0232, 'lps'),
	(637764, 135, '2015-01-01 00:24:49.000000', 'consum', 0.0237, 'lps'),
	(637765, 135, '2015-01-01 00:24:50.000000', 'consum', 0.0218, 'lps'),
	(637766, 135, '2015-01-01 00:24:51.000000', 'consum', 0.0230, 'lps'),
	(637767, 135, '2015-01-01 00:24:52.000000', 'consum', 0.0225, 'lps'),
	(637768, 135, '2015-01-01 00:24:53.000000', 'consum', 0.0225, 'lps'),
	(637769, 135, '2015-01-01 00:24:54.000000', 'consum', 0.0241, 'lps'),
	(637770, 135, '2015-01-01 00:24:55.000000', 'consum', 0.0260, 'lps'),
	(637771, 135, '2015-01-01 00:24:56.000000', 'consum', 0.0241, 'lps'),
	(637772, 135, '2015-01-01 00:24:57.000000', 'consum', 0.0218, 'lps'),
	(637773, 135, '2015-01-01 00:24:58.000000', 'consum', 0.0218, 'lps'),
	(637774, 135, '2015-01-01 00:24:59.000000', 'consum', 0.0227, 'lps'),
	(637775, 135, '2015-01-01 00:25:00.000000', 'consum', 0.0271, 'lps'),
	(637776, 135, '2015-01-01 00:25:01.000000', 'consum', 0.0216, 'lps'),
	(637777, 135, '2015-01-01 00:25:02.000000', 'consum', 0.0242, 'lps'),
	(637778, 135, '2015-01-01 00:25:03.000000', 'consum', 0.0230, 'lps'),
	(637779, 135, '2015-01-01 00:25:04.000000', 'consum', 0.0213, 'lps'),
	(637780, 135, '2015-01-01 00:25:05.000000', 'consum', 0.0230, 'lps'),
	(637781, 135, '2015-01-01 00:25:06.000000', 'consum', 0.0236, 'lps'),
	(637782, 135, '2015-01-01 00:25:07.000000', 'consum', 0.0222, 'lps'),
	(637783, 135, '2015-01-01 00:25:08.000000', 'consum', 0.0254, 'lps'),
	(637784, 135, '2015-01-01 00:25:09.000000', 'consum', 0.0270, 'lps'),
	(637785, 135, '2015-01-01 00:25:10.000000', 'consum', 0.0254, 'lps'),
	(637786, 135, '2015-01-01 00:25:11.000000', 'consum', 0.0251, 'lps'),
	(637787, 135, '2015-01-01 00:25:12.000000', 'consum', 0.0224, 'lps'),
	(637788, 135, '2015-01-01 00:25:13.000000', 'consum', 0.0216, 'lps'),
	(637789, 135, '2015-01-01 00:25:14.000000', 'consum', 0.0260, 'lps'),
	(637790, 135, '2015-01-01 00:25:15.000000', 'consum', 0.0257, 'lps'),
	(637791, 135, '2015-01-01 00:25:16.000000', 'consum', 0.0235, 'lps'),
	(637792, 135, '2015-01-01 00:25:17.000000', 'consum', 0.0258, 'lps'),
	(637793, 135, '2015-01-01 00:25:18.000000', 'consum', 0.0249, 'lps'),
	(637794, 135, '2015-01-01 00:25:19.000000', 'consum', 0.0262, 'lps'),
	(637795, 135, '2015-01-01 00:25:20.000000', 'consum', 0.0229, 'lps'),
	(637796, 135, '2015-01-01 00:25:21.000000', 'consum', 0.0211, 'lps'),
	(637797, 135, '2015-01-01 00:25:22.000000', 'consum', 0.0222, 'lps'),
	(637798, 135, '2015-01-01 00:25:23.000000', 'consum', 0.0266, 'lps'),
	(637799, 135, '2015-01-01 00:25:24.000000', 'consum', 0.0269, 'lps'),
	(637800, 135, '2015-01-01 00:25:25.000000', 'consum', 0.0215, 'lps'),
	(637801, 135, '2015-01-01 00:25:26.000000', 'consum', 0.0243, 'lps'),
	(637802, 135, '2015-01-01 00:25:27.000000', 'consum', 0.0236, 'lps'),
	(637803, 135, '2015-01-01 00:25:28.000000', 'consum', 0.0243, 'lps'),
	(637804, 135, '2015-01-01 00:25:29.000000', 'consum', 0.0235, 'lps'),
	(637805, 135, '2015-01-01 00:25:30.000000', 'consum', 0.0238, 'lps'),
	(637806, 135, '2015-01-01 00:25:31.000000', 'consum', 0.0213, 'lps'),
	(637807, 135, '2015-01-01 00:25:32.000000', 'consum', 0.0265, 'lps'),
	(637808, 135, '2015-01-01 00:25:33.000000', 'consum', 0.0228, 'lps'),
	(637809, 135, '2015-01-01 00:25:34.000000', 'consum', 0.0261, 'lps'),
	(637810, 135, '2015-01-01 00:25:35.000000', 'consum', 0.0223, 'lps'),
	(637811, 135, '2015-01-01 00:25:36.000000', 'consum', 0.0247, 'lps'),
	(637812, 135, '2015-01-01 00:25:37.000000', 'consum', 0.0233, 'lps'),
	(637813, 135, '2015-01-01 00:25:38.000000', 'consum', 0.0215, 'lps'),
	(637814, 135, '2015-01-01 00:25:39.000000', 'consum', 0.0228, 'lps'),
	(637815, 135, '2015-01-01 00:25:40.000000', 'consum', 0.0224, 'lps'),
	(637816, 135, '2015-01-01 00:25:41.000000', 'consum', 0.0226, 'lps'),
	(637817, 135, '2015-01-01 00:25:42.000000', 'consum', 0.0248, 'lps'),
	(637818, 135, '2015-01-01 00:25:43.000000', 'consum', 0.0230, 'lps'),
	(637819, 135, '2015-01-01 00:25:44.000000', 'consum', 0.0257, 'lps'),
	(637820, 135, '2015-01-01 00:25:45.000000', 'consum', 0.0260, 'lps'),
	(637821, 135, '2015-01-01 00:25:46.000000', 'consum', 0.0259, 'lps'),
	(637822, 135, '2015-01-01 00:25:47.000000', 'consum', 0.0243, 'lps'),
	(637823, 135, '2015-01-01 00:25:48.000000', 'consum', 0.0229, 'lps'),
	(637824, 135, '2015-01-01 00:25:49.000000', 'consum', 0.0267, 'lps'),
	(637825, 135, '2015-01-01 00:25:50.000000', 'consum', 0.0252, 'lps'),
	(637826, 135, '2015-01-01 00:25:51.000000', 'consum', 0.0251, 'lps'),
	(637827, 135, '2015-01-01 00:25:52.000000', 'consum', 0.0229, 'lps'),
	(637828, 135, '2015-01-01 00:25:53.000000', 'consum', 0.0244, 'lps'),
	(637829, 135, '2015-01-01 00:25:54.000000', 'consum', 0.0260, 'lps'),
	(637830, 135, '2015-01-01 00:25:55.000000', 'consum', 0.0233, 'lps'),
	(637831, 135, '2015-01-01 00:25:56.000000', 'consum', 0.0240, 'lps'),
	(637832, 135, '2015-01-01 00:25:57.000000', 'consum', 0.0228, 'lps'),
	(637833, 135, '2015-01-01 00:25:58.000000', 'consum', 0.0212, 'lps'),
	(637834, 135, '2015-01-01 00:25:59.000000', 'consum', 0.0228, 'lps'),
	(637835, 135, '2015-01-01 00:26:00.000000', 'consum', 0.0232, 'lps'),
	(637836, 135, '2015-01-01 00:26:01.000000', 'consum', 0.0269, 'lps'),
	(637837, 135, '2015-01-01 00:26:02.000000', 'consum', 0.0251, 'lps'),
	(637838, 135, '2015-01-01 00:26:03.000000', 'consum', 0.0238, 'lps'),
	(637839, 135, '2015-01-01 00:26:04.000000', 'consum', 0.0229, 'lps'),
	(637840, 135, '2015-01-01 00:26:05.000000', 'consum', 0.0221, 'lps'),
	(637841, 135, '2015-01-01 00:26:06.000000', 'consum', 0.0210, 'lps'),
	(637842, 135, '2015-01-01 00:26:07.000000', 'consum', 0.0237, 'lps'),
	(637843, 135, '2015-01-01 00:26:08.000000', 'consum', 0.0221, 'lps'),
	(637844, 135, '2015-01-01 00:26:09.000000', 'consum', 0.0249, 'lps'),
	(637845, 135, '2015-01-01 00:26:10.000000', 'consum', 0.0248, 'lps'),
	(637846, 135, '2015-01-01 00:26:11.000000', 'consum', 0.0222, 'lps'),
	(637847, 135, '2015-01-01 00:26:12.000000', 'consum', 0.0216, 'lps'),
	(637848, 135, '2015-01-01 00:26:13.000000', 'consum', 0.0269, 'lps'),
	(637849, 135, '2015-01-01 00:26:14.000000', 'consum', 0.0240, 'lps'),
	(637850, 135, '2015-01-01 00:26:15.000000', 'consum', 0.0246, 'lps'),
	(637851, 135, '2015-01-01 00:26:16.000000', 'consum', 0.0239, 'lps'),
	(637852, 135, '2015-01-01 00:26:17.000000', 'consum', 0.0248, 'lps'),
	(637853, 135, '2015-01-01 00:26:18.000000', 'consum', 0.0250, 'lps'),
	(637854, 135, '2015-01-01 00:26:19.000000', 'consum', 0.0236, 'lps'),
	(637855, 135, '2015-01-01 00:26:20.000000', 'consum', 0.0220, 'lps'),
	(637856, 135, '2015-01-01 00:26:21.000000', 'consum', 0.0245, 'lps'),
	(637857, 135, '2015-01-01 00:26:22.000000', 'consum', 0.0229, 'lps'),
	(637858, 135, '2015-01-01 00:26:23.000000', 'consum', 0.0265, 'lps'),
	(637859, 135, '2015-01-01 00:26:24.000000', 'consum', 0.0240, 'lps'),
	(637860, 135, '2015-01-01 00:26:25.000000', 'consum', 0.0257, 'lps'),
	(637861, 135, '2015-01-01 00:26:26.000000', 'consum', 0.0234, 'lps'),
	(637862, 135, '2015-01-01 00:26:27.000000', 'consum', 0.0250, 'lps'),
	(637863, 135, '2015-01-01 00:26:28.000000', 'consum', 0.0217, 'lps'),
	(637864, 135, '2015-01-01 00:26:29.000000', 'consum', 0.0247, 'lps'),
	(637865, 135, '2015-01-01 00:26:30.000000', 'consum', 0.0250, 'lps'),
	(637866, 135, '2015-01-01 00:26:31.000000', 'consum', 0.0240, 'lps'),
	(637867, 135, '2015-01-01 00:26:32.000000', 'consum', 0.0238, 'lps'),
	(637868, 135, '2015-01-01 00:26:33.000000', 'consum', 0.0260, 'lps'),
	(637869, 135, '2015-01-01 00:26:34.000000', 'consum', 0.0252, 'lps'),
	(637870, 135, '2015-01-01 00:26:35.000000', 'consum', 0.0210, 'lps'),
	(637871, 135, '2015-01-01 00:26:36.000000', 'consum', 0.0210, 'lps'),
	(637872, 135, '2015-01-01 00:26:37.000000', 'consum', 0.0210, 'lps'),
	(637873, 135, '2015-01-01 00:26:38.000000', 'consum', 0.0211, 'lps'),
	(637874, 135, '2015-01-01 00:26:39.000000', 'consum', 0.0213, 'lps'),
	(637875, 135, '2015-01-01 00:26:40.000000', 'consum', 0.0223, 'lps'),
	(637876, 135, '2015-01-01 00:26:41.000000', 'consum', 0.0265, 'lps'),
	(637877, 135, '2015-01-01 00:26:42.000000', 'consum', 0.0263, 'lps'),
	(637878, 135, '2015-01-01 00:26:43.000000', 'consum', 0.0249, 'lps'),
	(637879, 135, '2015-01-01 00:26:44.000000', 'consum', 0.0247, 'lps'),
	(637880, 135, '2015-01-01 00:26:45.000000', 'consum', 0.0214, 'lps'),
	(637881, 135, '2015-01-01 00:26:46.000000', 'consum', 0.0242, 'lps'),
	(637882, 135, '2015-01-01 00:26:47.000000', 'consum', 0.0238, 'lps'),
	(637883, 135, '2015-01-01 00:26:48.000000', 'consum', 0.0254, 'lps'),
	(637884, 135, '2015-01-01 00:26:49.000000', 'consum', 0.0221, 'lps'),
	(637885, 135, '2015-01-01 00:26:50.000000', 'consum', 0.0259, 'lps'),
	(637886, 135, '2015-01-01 00:26:51.000000', 'consum', 0.0235, 'lps'),
	(637887, 135, '2015-01-01 00:26:52.000000', 'consum', 0.0250, 'lps'),
	(637888, 135, '2015-01-01 00:26:53.000000', 'consum', 0.0212, 'lps'),
	(637889, 135, '2015-01-01 00:26:54.000000', 'consum', 0.0225, 'lps'),
	(637890, 135, '2015-01-01 00:26:55.000000', 'consum', 0.0216, 'lps'),
	(637891, 135, '2015-01-01 00:26:56.000000', 'consum', 0.0259, 'lps'),
	(637892, 135, '2015-01-01 00:26:57.000000', 'consum', 0.0250, 'lps'),
	(637893, 135, '2015-01-01 00:26:58.000000', 'consum', 0.0265, 'lps'),
	(637894, 135, '2015-01-01 00:26:59.000000', 'consum', 0.0240, 'lps'),
	(637895, 135, '2015-01-01 00:27:00.000000', 'consum', 0.0260, 'lps'),
	(637896, 135, '2015-01-01 00:27:01.000000', 'consum', 0.0245, 'lps'),
	(637897, 135, '2015-01-01 00:27:02.000000', 'consum', 0.0235, 'lps'),
	(637898, 135, '2015-01-01 00:27:03.000000', 'consum', 0.0230, 'lps'),
	(637899, 135, '2015-01-01 00:27:04.000000', 'consum', 0.0235, 'lps'),
	(637900, 135, '2015-01-01 00:27:05.000000', 'consum', 0.0215, 'lps'),
	(637901, 135, '2015-01-01 00:27:06.000000', 'consum', 0.0224, 'lps'),
	(637902, 135, '2015-01-01 00:27:07.000000', 'consum', 0.0263, 'lps'),
	(637903, 135, '2015-01-01 00:27:08.000000', 'consum', 0.0247, 'lps'),
	(637904, 135, '2015-01-01 00:27:09.000000', 'consum', 0.0238, 'lps'),
	(637905, 135, '2015-01-01 00:27:10.000000', 'consum', 0.0238, 'lps'),
	(637906, 135, '2015-01-01 00:27:11.000000', 'consum', 0.0268, 'lps'),
	(637907, 135, '2015-01-01 00:27:12.000000', 'consum', 0.0232, 'lps'),
	(637908, 135, '2015-01-01 00:27:13.000000', 'consum', 0.0269, 'lps'),
	(637909, 135, '2015-01-01 00:27:14.000000', 'consum', 0.0252, 'lps'),
	(637910, 135, '2015-01-01 00:27:15.000000', 'consum', 0.0246, 'lps'),
	(637911, 135, '2015-01-01 00:27:16.000000', 'consum', 0.0263, 'lps'),
	(637912, 135, '2015-01-01 00:27:17.000000', 'consum', 0.0245, 'lps'),
	(637913, 135, '2015-01-01 00:27:18.000000', 'consum', 0.0226, 'lps'),
	(637914, 135, '2015-01-01 00:27:19.000000', 'consum', 0.0248, 'lps'),
	(637915, 135, '2015-01-01 00:27:20.000000', 'consum', 0.0227, 'lps'),
	(637916, 135, '2015-01-01 00:27:21.000000', 'consum', 0.0246, 'lps'),
	(637917, 135, '2015-01-01 00:27:22.000000', 'consum', 0.0213, 'lps'),
	(637918, 135, '2015-01-01 00:27:23.000000', 'consum', 0.0244, 'lps'),
	(637919, 135, '2015-01-01 00:27:24.000000', 'consum', 0.0248, 'lps'),
	(637920, 135, '2015-01-01 00:27:25.000000', 'consum', 0.0237, 'lps'),
	(637921, 135, '2015-01-01 00:27:26.000000', 'consum', 0.0230, 'lps'),
	(637922, 135, '2015-01-01 00:27:27.000000', 'consum', 0.0229, 'lps'),
	(637923, 135, '2015-01-01 00:27:28.000000', 'consum', 0.0246, 'lps'),
	(637924, 135, '2015-01-01 00:27:29.000000', 'consum', 0.0211, 'lps'),
	(637925, 135, '2015-01-01 00:27:30.000000', 'consum', 0.0232, 'lps'),
	(637926, 135, '2015-01-01 00:27:31.000000', 'consum', 0.0255, 'lps'),
	(637927, 135, '2015-01-01 00:27:32.000000', 'consum', 0.0247, 'lps'),
	(637928, 135, '2015-01-01 00:27:33.000000', 'consum', 0.0260, 'lps'),
	(637929, 135, '2015-01-01 00:27:34.000000', 'consum', 0.0224, 'lps'),
	(637930, 135, '2015-01-01 00:27:35.000000', 'consum', 0.0257, 'lps'),
	(637931, 135, '2015-01-01 00:27:36.000000', 'consum', 0.0217, 'lps'),
	(637932, 135, '2015-01-01 00:27:37.000000', 'consum', 0.0228, 'lps'),
	(637933, 135, '2015-01-01 00:27:38.000000', 'consum', 0.0216, 'lps'),
	(637934, 135, '2015-01-01 00:27:39.000000', 'consum', 0.0251, 'lps'),
	(637935, 135, '2015-01-01 00:27:40.000000', 'consum', 0.0211, 'lps'),
	(637936, 135, '2015-01-01 00:27:41.000000', 'consum', 0.0215, 'lps'),
	(637937, 135, '2015-01-01 00:27:42.000000', 'consum', 0.0231, 'lps'),
	(637938, 135, '2015-01-01 00:27:43.000000', 'consum', 0.0242, 'lps'),
	(637939, 135, '2015-01-01 00:27:44.000000', 'consum', 0.0242, 'lps'),
	(637940, 135, '2015-01-01 00:27:45.000000', 'consum', 0.0214, 'lps'),
	(637941, 135, '2015-01-01 00:27:46.000000', 'consum', 0.0259, 'lps'),
	(637942, 135, '2015-01-01 00:27:47.000000', 'consum', 0.0257, 'lps'),
	(637943, 135, '2015-01-01 00:27:48.000000', 'consum', 0.0238, 'lps'),
	(637944, 135, '2015-01-01 00:27:49.000000', 'consum', 0.0211, 'lps'),
	(637945, 135, '2015-01-01 00:27:50.000000', 'consum', 0.0252, 'lps'),
	(637946, 135, '2015-01-01 00:27:51.000000', 'consum', 0.0233, 'lps'),
	(637947, 135, '2015-01-01 00:27:52.000000', 'consum', 0.0259, 'lps'),
	(637948, 135, '2015-01-01 00:27:53.000000', 'consum', 0.0265, 'lps'),
	(637949, 135, '2015-01-01 00:27:54.000000', 'consum', 0.0214, 'lps'),
	(637950, 135, '2015-01-01 00:27:55.000000', 'consum', 0.0252, 'lps'),
	(637951, 135, '2015-01-01 00:27:56.000000', 'consum', 0.0223, 'lps'),
	(637952, 135, '2015-01-01 00:27:57.000000', 'consum', 0.0213, 'lps'),
	(637953, 135, '2015-01-01 00:27:58.000000', 'consum', 0.0246, 'lps'),
	(637954, 135, '2015-01-01 00:27:59.000000', 'consum', 0.0259, 'lps'),
	(637955, 135, '2015-01-01 00:28:00.000000', 'consum', 0.0224, 'lps'),
	(637956, 135, '2015-01-01 00:28:01.000000', 'consum', 0.0257, 'lps'),
	(637957, 135, '2015-01-01 00:28:02.000000', 'consum', 0.0219, 'lps'),
	(637958, 135, '2015-01-01 00:28:03.000000', 'consum', 0.0236, 'lps'),
	(637959, 135, '2015-01-01 00:28:04.000000', 'consum', 0.0254, 'lps'),
	(637960, 135, '2015-01-01 00:28:05.000000', 'consum', 0.0227, 'lps'),
	(637961, 135, '2015-01-01 00:28:06.000000', 'consum', 0.0225, 'lps'),
	(637962, 135, '2015-01-01 00:28:07.000000', 'consum', 0.0235, 'lps'),
	(637963, 135, '2015-01-01 00:28:08.000000', 'consum', 0.0228, 'lps'),
	(637964, 135, '2015-01-01 00:28:09.000000', 'consum', 0.0225, 'lps'),
	(637965, 135, '2015-01-01 00:28:10.000000', 'consum', 0.0232, 'lps'),
	(637966, 135, '2015-01-01 00:28:11.000000', 'consum', 0.0215, 'lps'),
	(637967, 135, '2015-01-01 00:28:12.000000', 'consum', 0.0229, 'lps'),
	(637968, 135, '2015-01-01 00:28:13.000000', 'consum', 0.0229, 'lps'),
	(637969, 135, '2015-01-01 00:28:14.000000', 'consum', 0.0247, 'lps'),
	(637970, 135, '2015-01-01 00:28:15.000000', 'consum', 0.0218, 'lps'),
	(637971, 135, '2015-01-01 00:28:16.000000', 'consum', 0.0261, 'lps'),
	(637972, 135, '2015-01-01 00:28:17.000000', 'consum', 0.0255, 'lps'),
	(637973, 135, '2015-01-01 00:28:18.000000', 'consum', 0.0222, 'lps'),
	(637974, 135, '2015-01-01 00:28:19.000000', 'consum', 0.0259, 'lps'),
	(637975, 135, '2015-01-01 00:28:20.000000', 'consum', 0.0235, 'lps'),
	(637976, 135, '2015-01-01 00:28:21.000000', 'consum', 0.0250, 'lps'),
	(637977, 135, '2015-01-01 00:28:22.000000', 'consum', 0.0213, 'lps'),
	(637978, 135, '2015-01-01 00:28:23.000000', 'consum', 0.0228, 'lps'),
	(637979, 135, '2015-01-01 00:28:24.000000', 'consum', 0.0230, 'lps'),
	(637980, 135, '2015-01-01 00:28:25.000000', 'consum', 0.0255, 'lps'),
	(637981, 135, '2015-01-01 00:28:26.000000', 'consum', 0.0253, 'lps'),
	(637982, 135, '2015-01-01 00:28:27.000000', 'consum', 0.0226, 'lps'),
	(637983, 135, '2015-01-01 00:28:28.000000', 'consum', 0.0225, 'lps'),
	(637984, 135, '2015-01-01 00:28:29.000000', 'consum', 0.0238, 'lps'),
	(637985, 135, '2015-01-01 00:28:30.000000', 'consum', 0.0244, 'lps'),
	(637986, 135, '2015-01-01 00:28:31.000000', 'consum', 0.0234, 'lps'),
	(637987, 135, '2015-01-01 00:28:32.000000', 'consum', 0.0228, 'lps'),
	(637988, 135, '2015-01-01 00:28:33.000000', 'consum', 0.0228, 'lps'),
	(637989, 135, '2015-01-01 00:28:34.000000', 'consum', 0.0246, 'lps'),
	(637990, 135, '2015-01-01 00:28:35.000000', 'consum', 0.0215, 'lps'),
	(637991, 135, '2015-01-01 00:28:36.000000', 'consum', 0.0249, 'lps'),
	(637992, 135, '2015-01-01 00:28:37.000000', 'consum', 0.0269, 'lps'),
	(637993, 135, '2015-01-01 00:28:38.000000', 'consum', 0.0262, 'lps'),
	(637994, 135, '2015-01-01 00:28:39.000000', 'consum', 0.0234, 'lps'),
	(637995, 135, '2015-01-01 00:28:40.000000', 'consum', 0.0236, 'lps'),
	(637996, 135, '2015-01-01 00:28:41.000000', 'consum', 0.0269, 'lps'),
	(637997, 135, '2015-01-01 00:28:42.000000', 'consum', 0.0242, 'lps'),
	(637998, 135, '2015-01-01 00:28:43.000000', 'consum', 0.0256, 'lps'),
	(637999, 135, '2015-01-01 00:28:44.000000', 'consum', 0.0218, 'lps'),
	(638000, 135, '2015-01-01 00:28:45.000000', 'consum', 0.0237, 'lps'),
	(638001, 135, '2015-01-01 00:28:46.000000', 'consum', 0.0258, 'lps'),
	(638002, 135, '2015-01-01 00:28:47.000000', 'consum', 0.0247, 'lps'),
	(638003, 135, '2015-01-01 00:28:48.000000', 'consum', 0.0250, 'lps'),
	(638004, 135, '2015-01-01 00:28:49.000000', 'consum', 0.0240, 'lps'),
	(638005, 135, '2015-01-01 00:28:50.000000', 'consum', 0.0239, 'lps'),
	(638006, 135, '2015-01-01 00:28:51.000000', 'consum', 0.0267, 'lps'),
	(638007, 135, '2015-01-01 00:28:52.000000', 'consum', 0.0220, 'lps'),
	(638008, 135, '2015-01-01 00:28:53.000000', 'consum', 0.0216, 'lps'),
	(638009, 135, '2015-01-01 00:28:54.000000', 'consum', 0.0212, 'lps'),
	(638010, 135, '2015-01-01 00:28:55.000000', 'consum', 0.0261, 'lps'),
	(638011, 135, '2015-01-01 00:28:56.000000', 'consum', 0.0214, 'lps'),
	(638012, 135, '2015-01-01 00:28:57.000000', 'consum', 0.0262, 'lps'),
	(638013, 135, '2015-01-01 00:28:58.000000', 'consum', 0.0210, 'lps'),
	(638014, 135, '2015-01-01 00:28:59.000000', 'consum', 0.0239, 'lps'),
	(638015, 135, '2015-01-01 00:29:00.000000', 'consum', 0.0234, 'lps'),
	(638016, 135, '2015-01-01 00:29:01.000000', 'consum', 0.0243, 'lps'),
	(638017, 135, '2015-01-01 00:29:02.000000', 'consum', 0.0241, 'lps'),
	(638018, 135, '2015-01-01 00:29:03.000000', 'consum', 0.0269, 'lps'),
	(638019, 135, '2015-01-01 00:29:04.000000', 'consum', 0.0224, 'lps'),
	(638020, 135, '2015-01-01 00:29:05.000000', 'consum', 0.0230, 'lps'),
	(638021, 135, '2015-01-01 00:29:06.000000', 'consum', 0.0268, 'lps'),
	(638022, 135, '2015-01-01 00:29:07.000000', 'consum', 0.0254, 'lps'),
	(638023, 135, '2015-01-01 00:29:08.000000', 'consum', 0.0258, 'lps'),
	(638024, 135, '2015-01-01 00:29:09.000000', 'consum', 0.0254, 'lps'),
	(638025, 135, '2015-01-01 00:29:10.000000', 'consum', 0.0223, 'lps'),
	(638026, 135, '2015-01-01 00:29:11.000000', 'consum', 0.0271, 'lps'),
	(638027, 135, '2015-01-01 00:29:12.000000', 'consum', 0.0226, 'lps'),
	(638028, 135, '2015-01-01 00:29:13.000000', 'consum', 0.0234, 'lps'),
	(638029, 135, '2015-01-01 00:29:14.000000', 'consum', 0.0219, 'lps'),
	(638030, 135, '2015-01-01 00:29:15.000000', 'consum', 0.0247, 'lps'),
	(638031, 135, '2015-01-01 00:29:16.000000', 'consum', 0.0242, 'lps'),
	(638032, 135, '2015-01-01 00:29:17.000000', 'consum', 0.0260, 'lps'),
	(638033, 135, '2015-01-01 00:29:18.000000', 'consum', 0.0239, 'lps'),
	(638034, 135, '2015-01-01 00:29:19.000000', 'consum', 0.0271, 'lps'),
	(638035, 135, '2015-01-01 00:29:20.000000', 'consum', 0.0240, 'lps'),
	(638036, 135, '2015-01-01 00:29:21.000000', 'consum', 0.0242, 'lps'),
	(638037, 135, '2015-01-01 00:29:22.000000', 'consum', 0.0216, 'lps'),
	(638038, 135, '2015-01-01 00:29:23.000000', 'consum', 0.0270, 'lps'),
	(638039, 135, '2015-01-01 00:29:24.000000', 'consum', 0.0243, 'lps'),
	(638040, 135, '2015-01-01 00:29:25.000000', 'consum', 0.0257, 'lps'),
	(638041, 135, '2015-01-01 00:29:26.000000', 'consum', 0.0223, 'lps'),
	(638042, 135, '2015-01-01 00:29:27.000000', 'consum', 0.0261, 'lps'),
	(638043, 135, '2015-01-01 00:29:28.000000', 'consum', 0.0238, 'lps'),
	(638044, 135, '2015-01-01 00:29:29.000000', 'consum', 0.0261, 'lps'),
	(638045, 135, '2015-01-01 00:29:30.000000', 'consum', 0.0255, 'lps'),
	(638046, 135, '2015-01-01 00:29:31.000000', 'consum', 0.0223, 'lps'),
	(638047, 135, '2015-01-01 00:29:32.000000', 'consum', 0.0265, 'lps'),
	(638048, 135, '2015-01-01 00:29:33.000000', 'consum', 0.0261, 'lps'),
	(638049, 135, '2015-01-01 00:29:34.000000', 'consum', 0.0238, 'lps'),
	(638050, 135, '2015-01-01 00:29:35.000000', 'consum', 0.0259, 'lps'),
	(638051, 135, '2015-01-01 00:29:36.000000', 'consum', 0.0247, 'lps'),
	(638052, 135, '2015-01-01 00:29:37.000000', 'consum', 0.0250, 'lps'),
	(638053, 135, '2015-01-01 00:29:38.000000', 'consum', 0.0237, 'lps'),
	(638054, 135, '2015-01-01 00:29:39.000000', 'consum', 0.0224, 'lps'),
	(638055, 135, '2015-01-01 00:29:40.000000', 'consum', 0.0264, 'lps'),
	(638056, 135, '2015-01-01 00:29:41.000000', 'consum', 0.0253, 'lps'),
	(638057, 135, '2015-01-01 00:29:42.000000', 'consum', 0.0262, 'lps'),
	(638058, 135, '2015-01-01 00:29:43.000000', 'consum', 0.0216, 'lps'),
	(638059, 135, '2015-01-01 00:29:44.000000', 'consum', 0.0210, 'lps'),
	(638060, 135, '2015-01-01 00:29:45.000000', 'consum', 0.0252, 'lps'),
	(638061, 135, '2015-01-01 00:29:46.000000', 'consum', 0.0238, 'lps'),
	(638062, 135, '2015-01-01 00:29:47.000000', 'consum', 0.0221, 'lps'),
	(638063, 135, '2015-01-01 00:29:48.000000', 'consum', 0.0247, 'lps'),
	(638064, 135, '2015-01-01 00:29:49.000000', 'consum', 0.0235, 'lps'),
	(638065, 135, '2015-01-01 00:29:50.000000', 'consum', 0.0226, 'lps'),
	(638066, 135, '2015-01-01 00:29:51.000000', 'consum', 0.0215, 'lps'),
	(638067, 135, '2015-01-01 00:29:52.000000', 'consum', 0.0251, 'lps'),
	(638068, 135, '2015-01-01 00:29:53.000000', 'consum', 0.0214, 'lps'),
	(638069, 135, '2015-01-01 00:29:54.000000', 'consum', 0.0231, 'lps'),
	(638070, 135, '2015-01-01 00:29:55.000000', 'consum', 0.0242, 'lps'),
	(638071, 135, '2015-01-01 00:29:56.000000', 'consum', 0.0246, 'lps'),
	(638072, 135, '2015-01-01 00:29:57.000000', 'consum', 0.0233, 'lps'),
	(638073, 135, '2015-01-01 00:29:58.000000', 'consum', 0.0215, 'lps'),
	(638074, 135, '2015-01-01 00:29:59.000000', 'consum', 0.0230, 'lps'),
	(638075, 135, '2015-01-01 00:30:00.000000', 'consum', 0.0232, 'lps'),
	(638076, 135, '2015-01-01 00:30:01.000000', 'consum', 0.0263, 'lps'),
	(638077, 135, '2015-01-01 00:30:02.000000', 'consum', 0.0221, 'lps'),
	(638078, 135, '2015-01-01 00:30:03.000000', 'consum', 0.0232, 'lps'),
	(638079, 135, '2015-01-01 00:30:04.000000', 'consum', 0.0224, 'lps'),
	(638080, 135, '2015-01-01 00:30:05.000000', 'consum', 0.0216, 'lps'),
	(638081, 135, '2015-01-01 00:30:06.000000', 'consum', 0.0261, 'lps'),
	(638082, 135, '2015-01-01 00:30:07.000000', 'consum', 0.0260, 'lps'),
	(638083, 135, '2015-01-01 00:30:08.000000', 'consum', 0.0248, 'lps'),
	(638084, 135, '2015-01-01 00:30:09.000000', 'consum', 0.0249, 'lps'),
	(638085, 135, '2015-01-01 00:30:10.000000', 'consum', 0.0228, 'lps'),
	(638086, 135, '2015-01-01 00:30:11.000000', 'consum', 0.0245, 'lps'),
	(638087, 135, '2015-01-01 00:30:12.000000', 'consum', 0.0271, 'lps'),
	(638088, 135, '2015-01-01 00:30:13.000000', 'consum', 0.0222, 'lps'),
	(638089, 135, '2015-01-01 00:30:14.000000', 'consum', 0.0215, 'lps'),
	(638090, 135, '2015-01-01 00:30:15.000000', 'consum', 0.0261, 'lps'),
	(638091, 135, '2015-01-01 00:30:16.000000', 'consum', 0.0262, 'lps'),
	(638092, 135, '2015-01-01 00:30:17.000000', 'consum', 0.0258, 'lps'),
	(638093, 135, '2015-01-01 00:30:18.000000', 'consum', 0.0232, 'lps'),
	(638094, 135, '2015-01-01 00:30:19.000000', 'consum', 0.0238, 'lps'),
	(638095, 135, '2015-01-01 00:30:20.000000', 'consum', 0.0222, 'lps'),
	(638096, 135, '2015-01-01 00:30:21.000000', 'consum', 0.0248, 'lps'),
	(638097, 135, '2015-01-01 00:30:22.000000', 'consum', 0.0242, 'lps'),
	(638098, 135, '2015-01-01 00:30:23.000000', 'consum', 0.0257, 'lps'),
	(638099, 135, '2015-01-01 00:30:24.000000', 'consum', 0.0225, 'lps'),
	(638100, 135, '2015-01-01 00:30:25.000000', 'consum', 0.0267, 'lps'),
	(638101, 135, '2015-01-01 00:30:26.000000', 'consum', 0.0265, 'lps'),
	(638102, 135, '2015-01-01 00:30:27.000000', 'consum', 0.0252, 'lps'),
	(638103, 135, '2015-01-01 00:30:28.000000', 'consum', 0.0258, 'lps'),
	(638104, 135, '2015-01-01 00:30:29.000000', 'consum', 0.0260, 'lps'),
	(638105, 135, '2015-01-01 00:30:30.000000', 'consum', 0.0257, 'lps'),
	(638106, 135, '2015-01-01 00:30:31.000000', 'consum', 0.0234, 'lps'),
	(638107, 135, '2015-01-01 00:30:32.000000', 'consum', 0.0250, 'lps'),
	(638108, 135, '2015-01-01 00:30:33.000000', 'consum', 0.0213, 'lps'),
	(638109, 135, '2015-01-01 00:30:34.000000', 'consum', 0.0232, 'lps'),
	(638110, 135, '2015-01-01 00:30:35.000000', 'consum', 0.0250, 'lps'),
	(638111, 135, '2015-01-01 00:30:36.000000', 'consum', 0.0220, 'lps'),
	(638112, 135, '2015-01-01 00:30:37.000000', 'consum', 0.0265, 'lps'),
	(638113, 135, '2015-01-01 00:30:38.000000', 'consum', 0.0267, 'lps'),
	(638114, 135, '2015-01-01 00:30:39.000000', 'consum', 0.0269, 'lps'),
	(638115, 135, '2015-01-01 00:30:40.000000', 'consum', 0.0213, 'lps'),
	(638116, 135, '2015-01-01 00:30:41.000000', 'consum', 0.0232, 'lps'),
	(638117, 135, '2015-01-01 00:30:42.000000', 'consum', 0.0251, 'lps'),
	(638118, 135, '2015-01-01 00:30:43.000000', 'consum', 0.0224, 'lps'),
	(638119, 135, '2015-01-01 00:30:44.000000', 'consum', 0.0221, 'lps'),
	(638120, 135, '2015-01-01 00:30:45.000000', 'consum', 0.0224, 'lps'),
	(638121, 135, '2015-01-01 00:30:46.000000', 'consum', 0.0245, 'lps'),
	(638122, 135, '2015-01-01 00:30:47.000000', 'consum', 0.0219, 'lps'),
	(638123, 135, '2015-01-01 00:30:48.000000', 'consum', 0.0215, 'lps'),
	(638124, 135, '2015-01-01 00:30:49.000000', 'consum', 0.0271, 'lps'),
	(638125, 135, '2015-01-01 00:30:50.000000', 'consum', 0.0251, 'lps'),
	(638126, 135, '2015-01-01 00:30:51.000000', 'consum', 0.0233, 'lps'),
	(638127, 135, '2015-01-01 00:30:52.000000', 'consum', 0.0262, 'lps'),
	(638128, 135, '2015-01-01 00:30:53.000000', 'consum', 0.0219, 'lps'),
	(638129, 135, '2015-01-01 00:30:54.000000', 'consum', 0.0223, 'lps'),
	(638130, 135, '2015-01-01 00:30:55.000000', 'consum', 0.0247, 'lps'),
	(638131, 135, '2015-01-01 00:30:56.000000', 'consum', 0.0234, 'lps'),
	(638132, 135, '2015-01-01 00:30:57.000000', 'consum', 0.0219, 'lps'),
	(638133, 135, '2015-01-01 00:30:58.000000', 'consum', 0.0247, 'lps'),
	(638134, 135, '2015-01-01 00:30:59.000000', 'consum', 0.0243, 'lps'),
	(638135, 135, '2015-01-01 00:31:00.000000', 'consum', 0.0267, 'lps'),
	(638136, 135, '2015-01-01 00:31:01.000000', 'consum', 0.0270, 'lps'),
	(638137, 135, '2015-01-01 00:31:02.000000', 'consum', 0.0215, 'lps'),
	(638138, 135, '2015-01-01 00:31:03.000000', 'consum', 0.0242, 'lps'),
	(638139, 135, '2015-01-01 00:31:04.000000', 'consum', 0.0233, 'lps'),
	(638140, 135, '2015-01-01 00:31:05.000000', 'consum', 0.0229, 'lps'),
	(638141, 135, '2015-01-01 00:31:06.000000', 'consum', 0.0235, 'lps'),
	(638142, 135, '2015-01-01 00:31:07.000000', 'consum', 0.0216, 'lps'),
	(638143, 135, '2015-01-01 00:31:08.000000', 'consum', 0.0228, 'lps'),
	(638144, 135, '2015-01-01 00:31:09.000000', 'consum', 0.0222, 'lps'),
	(638145, 135, '2015-01-01 00:31:10.000000', 'consum', 0.0218, 'lps'),
	(638146, 135, '2015-01-01 00:31:11.000000', 'consum', 0.0212, 'lps'),
	(638147, 135, '2015-01-01 00:31:12.000000', 'consum', 0.0259, 'lps'),
	(638148, 135, '2015-01-01 00:31:13.000000', 'consum', 0.0263, 'lps'),
	(638149, 135, '2015-01-01 00:31:14.000000', 'consum', 0.0265, 'lps'),
	(638150, 135, '2015-01-01 00:31:15.000000', 'consum', 0.0265, 'lps'),
	(638151, 135, '2015-01-01 00:31:16.000000', 'consum', 0.0261, 'lps'),
	(638152, 135, '2015-01-01 00:31:17.000000', 'consum', 0.0238, 'lps'),
	(638153, 135, '2015-01-01 00:31:18.000000', 'consum', 0.0257, 'lps'),
	(638154, 135, '2015-01-01 00:31:19.000000', 'consum', 0.0238, 'lps'),
	(638155, 135, '2015-01-01 00:31:20.000000', 'consum', 0.0212, 'lps'),
	(638156, 135, '2015-01-01 00:31:21.000000', 'consum', 0.0260, 'lps'),
	(638157, 135, '2015-01-01 00:31:22.000000', 'consum', 0.0267, 'lps'),
	(638158, 135, '2015-01-01 00:31:23.000000', 'consum', 0.0222, 'lps'),
	(638159, 135, '2015-01-01 00:31:24.000000', 'consum', 0.0225, 'lps'),
	(638160, 135, '2015-01-01 00:31:25.000000', 'consum', 0.0247, 'lps'),
	(638161, 135, '2015-01-01 00:31:26.000000', 'consum', 0.0228, 'lps'),
	(638162, 135, '2015-01-01 00:31:27.000000', 'consum', 0.0252, 'lps'),
	(638163, 135, '2015-01-01 00:31:28.000000', 'consum', 0.0240, 'lps'),
	(638164, 135, '2015-01-01 00:31:29.000000', 'consum', 0.0236, 'lps'),
	(638165, 135, '2015-01-01 00:31:30.000000', 'consum', 0.0250, 'lps'),
	(638166, 135, '2015-01-01 00:31:31.000000', 'consum', 0.0269, 'lps'),
	(638167, 135, '2015-01-01 00:31:32.000000', 'consum', 0.0264, 'lps'),
	(638168, 135, '2015-01-01 00:31:33.000000', 'consum', 0.0242, 'lps'),
	(638169, 135, '2015-01-01 00:31:34.000000', 'consum', 0.0269, 'lps'),
	(638170, 135, '2015-01-01 00:31:35.000000', 'consum', 0.0225, 'lps'),
	(638171, 135, '2015-01-01 00:31:36.000000', 'consum', 0.0233, 'lps'),
	(638172, 135, '2015-01-01 00:31:37.000000', 'consum', 0.0217, 'lps'),
	(638173, 135, '2015-01-01 00:31:38.000000', 'consum', 0.0238, 'lps'),
	(638174, 135, '2015-01-01 00:31:39.000000', 'consum', 0.0267, 'lps'),
	(638175, 135, '2015-01-01 00:31:40.000000', 'consum', 0.0225, 'lps'),
	(638176, 135, '2015-01-01 00:31:41.000000', 'consum', 0.0239, 'lps'),
	(638177, 135, '2015-01-01 00:31:42.000000', 'consum', 0.0247, 'lps'),
	(638178, 135, '2015-01-01 00:31:43.000000', 'consum', 0.0247, 'lps'),
	(638179, 135, '2015-01-01 00:31:44.000000', 'consum', 0.0222, 'lps'),
	(638180, 135, '2015-01-01 00:31:45.000000', 'consum', 0.0222, 'lps'),
	(638181, 135, '2015-01-01 00:31:46.000000', 'consum', 0.0234, 'lps'),
	(638182, 135, '2015-01-01 00:31:47.000000', 'consum', 0.0233, 'lps'),
	(638183, 135, '2015-01-01 00:31:48.000000', 'consum', 0.0253, 'lps'),
	(638184, 135, '2015-01-01 00:31:49.000000', 'consum', 0.0231, 'lps'),
	(638185, 135, '2015-01-01 00:31:50.000000', 'consum', 0.0250, 'lps'),
	(638186, 135, '2015-01-01 00:31:51.000000', 'consum', 0.0222, 'lps'),
	(638187, 135, '2015-01-01 00:31:52.000000', 'consum', 0.0213, 'lps'),
	(638188, 135, '2015-01-01 00:31:53.000000', 'consum', 0.0253, 'lps'),
	(638189, 135, '2015-01-01 00:31:54.000000', 'consum', 0.0228, 'lps'),
	(638190, 135, '2015-01-01 00:31:55.000000', 'consum', 0.0233, 'lps'),
	(638191, 135, '2015-01-01 00:31:56.000000', 'consum', 0.0211, 'lps'),
	(638192, 135, '2015-01-01 00:31:57.000000', 'consum', 0.0210, 'lps'),
	(638193, 135, '2015-01-01 00:31:58.000000', 'consum', 0.0268, 'lps'),
	(638194, 135, '2015-01-01 00:31:59.000000', 'consum', 0.0251, 'lps'),
	(638195, 135, '2015-01-01 00:32:00.000000', 'consum', 0.0244, 'lps'),
	(638196, 135, '2015-01-01 00:32:01.000000', 'consum', 0.0257, 'lps'),
	(638197, 135, '2015-01-01 00:32:02.000000', 'consum', 0.0219, 'lps'),
	(638198, 135, '2015-01-01 00:32:03.000000', 'consum', 0.0240, 'lps'),
	(638199, 135, '2015-01-01 00:32:04.000000', 'consum', 0.0271, 'lps'),
	(638200, 135, '2015-01-01 00:32:05.000000', 'consum', 0.0237, 'lps'),
	(638201, 135, '2015-01-01 00:32:06.000000', 'consum', 0.0227, 'lps'),
	(638202, 135, '2015-01-01 00:32:07.000000', 'consum', 0.0212, 'lps'),
	(638203, 135, '2015-01-01 00:32:08.000000', 'consum', 0.0234, 'lps'),
	(638204, 135, '2015-01-01 00:32:09.000000', 'consum', 0.0260, 'lps'),
	(638205, 135, '2015-01-01 00:32:10.000000', 'consum', 0.0267, 'lps'),
	(638206, 135, '2015-01-01 00:32:11.000000', 'consum', 0.0219, 'lps'),
	(638207, 135, '2015-01-01 00:32:12.000000', 'consum', 0.0271, 'lps'),
	(638208, 135, '2015-01-01 00:32:13.000000', 'consum', 0.0240, 'lps'),
	(638209, 135, '2015-01-01 00:32:14.000000', 'consum', 0.0238, 'lps'),
	(638210, 135, '2015-01-01 00:32:15.000000', 'consum', 0.0264, 'lps'),
	(638211, 135, '2015-01-01 00:32:16.000000', 'consum', 0.0269, 'lps'),
	(638212, 135, '2015-01-01 00:32:17.000000', 'consum', 0.0221, 'lps'),
	(638213, 135, '2015-01-01 00:32:18.000000', 'consum', 0.0214, 'lps'),
	(638214, 135, '2015-01-01 00:32:19.000000', 'consum', 0.0259, 'lps'),
	(638215, 135, '2015-01-01 00:32:20.000000', 'consum', 0.0259, 'lps'),
	(638216, 135, '2015-01-01 00:32:21.000000', 'consum', 0.0245, 'lps'),
	(638217, 135, '2015-01-01 00:32:22.000000', 'consum', 0.0240, 'lps'),
	(638218, 135, '2015-01-01 00:32:23.000000', 'consum', 0.0254, 'lps'),
	(638219, 135, '2015-01-01 00:32:24.000000', 'consum', 0.0219, 'lps'),
	(638220, 135, '2015-01-01 00:32:25.000000', 'consum', 0.0246, 'lps'),
	(638221, 135, '2015-01-01 00:32:26.000000', 'consum', 0.0240, 'lps'),
	(638222, 135, '2015-01-01 00:32:27.000000', 'consum', 0.0251, 'lps'),
	(638223, 135, '2015-01-01 00:32:28.000000', 'consum', 0.0266, 'lps'),
	(638224, 135, '2015-01-01 00:32:29.000000', 'consum', 0.0241, 'lps'),
	(638225, 135, '2015-01-01 00:32:30.000000', 'consum', 0.0262, 'lps'),
	(638226, 135, '2015-01-01 00:32:31.000000', 'consum', 0.0251, 'lps'),
	(638227, 135, '2015-01-01 00:32:32.000000', 'consum', 0.0262, 'lps'),
	(638228, 135, '2015-01-01 00:32:33.000000', 'consum', 0.0221, 'lps'),
	(638229, 135, '2015-01-01 00:32:34.000000', 'consum', 0.0235, 'lps'),
	(638230, 135, '2015-01-01 00:32:35.000000', 'consum', 0.0238, 'lps'),
	(638231, 135, '2015-01-01 00:32:36.000000', 'consum', 0.0217, 'lps'),
	(638232, 135, '2015-01-01 00:32:37.000000', 'consum', 0.0222, 'lps'),
	(638233, 135, '2015-01-01 00:32:38.000000', 'consum', 0.0248, 'lps'),
	(638234, 135, '2015-01-01 00:32:39.000000', 'consum', 0.0244, 'lps'),
	(638235, 135, '2015-01-01 00:32:40.000000', 'consum', 0.0263, 'lps'),
	(638236, 135, '2015-01-01 00:32:41.000000', 'consum', 0.0250, 'lps'),
	(638237, 135, '2015-01-01 00:32:42.000000', 'consum', 0.0251, 'lps'),
	(638238, 135, '2015-01-01 00:32:43.000000', 'consum', 0.0236, 'lps'),
	(638239, 135, '2015-01-01 00:32:44.000000', 'consum', 0.0216, 'lps'),
	(638240, 135, '2015-01-01 00:32:45.000000', 'consum', 0.0223, 'lps'),
	(638241, 135, '2015-01-01 00:32:46.000000', 'consum', 0.0257, 'lps'),
	(638242, 135, '2015-01-01 00:32:47.000000', 'consum', 0.0222, 'lps'),
	(638243, 135, '2015-01-01 00:32:48.000000', 'consum', 0.0253, 'lps'),
	(638244, 135, '2015-01-01 00:32:49.000000', 'consum', 0.0264, 'lps'),
	(638245, 135, '2015-01-01 00:32:50.000000', 'consum', 0.0229, 'lps'),
	(638246, 135, '2015-01-01 00:32:51.000000', 'consum', 0.0269, 'lps'),
	(638247, 135, '2015-01-01 00:32:52.000000', 'consum', 0.0261, 'lps'),
	(638248, 135, '2015-01-01 00:32:53.000000', 'consum', 0.0225, 'lps'),
	(638249, 135, '2015-01-01 00:32:54.000000', 'consum', 0.0259, 'lps'),
	(638250, 135, '2015-01-01 00:32:55.000000', 'consum', 0.0223, 'lps'),
	(638251, 135, '2015-01-01 00:32:56.000000', 'consum', 0.0255, 'lps'),
	(638252, 135, '2015-01-01 00:32:57.000000', 'consum', 0.0269, 'lps'),
	(638253, 135, '2015-01-01 00:32:58.000000', 'consum', 0.0250, 'lps'),
	(638254, 135, '2015-01-01 00:32:59.000000', 'consum', 0.0231, 'lps'),
	(638255, 135, '2015-01-01 00:33:00.000000', 'consum', 0.0259, 'lps'),
	(638256, 135, '2015-01-01 00:33:01.000000', 'consum', 0.0267, 'lps'),
	(638257, 135, '2015-01-01 00:33:02.000000', 'consum', 0.0224, 'lps'),
	(638258, 135, '2015-01-01 00:33:03.000000', 'consum', 0.0236, 'lps'),
	(638259, 135, '2015-01-01 00:33:04.000000', 'consum', 0.0234, 'lps'),
	(638260, 135, '2015-01-01 00:33:05.000000', 'consum', 0.0252, 'lps'),
	(638261, 135, '2015-01-01 00:33:06.000000', 'consum', 0.0226, 'lps'),
	(638262, 135, '2015-01-01 00:33:07.000000', 'consum', 0.0226, 'lps'),
	(638263, 135, '2015-01-01 00:33:08.000000', 'consum', 0.0244, 'lps'),
	(638264, 135, '2015-01-01 00:33:09.000000', 'consum', 0.0270, 'lps'),
	(638265, 135, '2015-01-01 00:33:10.000000', 'consum', 0.0224, 'lps'),
	(638266, 135, '2015-01-01 00:33:11.000000', 'consum', 0.0223, 'lps'),
	(638267, 135, '2015-01-01 00:33:12.000000', 'consum', 0.0233, 'lps'),
	(638268, 135, '2015-01-01 00:33:13.000000', 'consum', 0.0224, 'lps'),
	(638269, 135, '2015-01-01 00:33:14.000000', 'consum', 0.0211, 'lps'),
	(638270, 135, '2015-01-01 00:33:15.000000', 'consum', 0.0236, 'lps'),
	(638271, 135, '2015-01-01 00:33:16.000000', 'consum', 0.0214, 'lps'),
	(638272, 135, '2015-01-01 00:33:17.000000', 'consum', 0.0213, 'lps'),
	(638273, 135, '2015-01-01 00:33:18.000000', 'consum', 0.0215, 'lps'),
	(638274, 135, '2015-01-01 00:33:19.000000', 'consum', 0.0225, 'lps'),
	(638275, 135, '2015-01-01 00:33:20.000000', 'consum', 0.0270, 'lps'),
	(638276, 135, '2015-01-01 00:33:21.000000', 'consum', 0.0219, 'lps'),
	(638277, 135, '2015-01-01 00:33:22.000000', 'consum', 0.0262, 'lps'),
	(638278, 135, '2015-01-01 00:33:23.000000', 'consum', 0.0259, 'lps'),
	(638279, 135, '2015-01-01 00:33:24.000000', 'consum', 0.0234, 'lps'),
	(638280, 135, '2015-01-01 00:33:25.000000', 'consum', 0.0248, 'lps'),
	(638281, 135, '2015-01-01 00:33:26.000000', 'consum', 0.0266, 'lps'),
	(638282, 135, '2015-01-01 00:33:27.000000', 'consum', 0.0252, 'lps'),
	(638283, 135, '2015-01-01 00:33:28.000000', 'consum', 0.0252, 'lps'),
	(638284, 135, '2015-01-01 00:33:29.000000', 'consum', 0.0233, 'lps'),
	(638285, 135, '2015-01-01 00:33:30.000000', 'consum', 0.0262, 'lps'),
	(638286, 135, '2015-01-01 00:33:31.000000', 'consum', 0.0214, 'lps'),
	(638287, 135, '2015-01-01 00:33:32.000000', 'consum', 0.0262, 'lps'),
	(638288, 135, '2015-01-01 00:33:33.000000', 'consum', 0.0210, 'lps'),
	(638289, 135, '2015-01-01 00:33:34.000000', 'consum', 0.0240, 'lps'),
	(638290, 135, '2015-01-01 00:33:35.000000', 'consum', 0.0235, 'lps'),
	(638291, 135, '2015-01-01 00:33:36.000000', 'consum', 0.0248, 'lps'),
	(638292, 135, '2015-01-01 00:33:37.000000', 'consum', 0.0261, 'lps'),
	(638293, 135, '2015-01-01 00:33:38.000000', 'consum', 0.0228, 'lps'),
	(638294, 135, '2015-01-01 00:33:39.000000', 'consum', 0.0210, 'lps'),
	(638295, 135, '2015-01-01 00:33:40.000000', 'consum', 0.0220, 'lps'),
	(638296, 135, '2015-01-01 00:33:41.000000', 'consum', 0.0258, 'lps'),
	(638297, 135, '2015-01-01 00:33:42.000000', 'consum', 0.0234, 'lps'),
	(638298, 135, '2015-01-01 00:33:43.000000', 'consum', 0.0248, 'lps'),
	(638299, 135, '2015-01-01 00:33:44.000000', 'consum', 0.0267, 'lps'),
	(638300, 135, '2015-01-01 00:33:45.000000', 'consum', 0.0259, 'lps'),
	(638301, 135, '2015-01-01 00:33:46.000000', 'consum', 0.0221, 'lps'),
	(638302, 135, '2015-01-01 00:33:47.000000', 'consum', 0.0245, 'lps'),
	(638303, 135, '2015-01-01 00:33:48.000000', 'consum', 0.0226, 'lps'),
	(638304, 135, '2015-01-01 00:33:49.000000', 'consum', 0.0247, 'lps'),
	(638305, 135, '2015-01-01 00:33:50.000000', 'consum', 0.0223, 'lps'),
	(638306, 135, '2015-01-01 00:33:51.000000', 'consum', 0.0228, 'lps'),
	(638307, 135, '2015-01-01 00:33:52.000000', 'consum', 0.0261, 'lps'),
	(638308, 135, '2015-01-01 00:33:53.000000', 'consum', 0.0224, 'lps'),
	(638309, 135, '2015-01-01 00:33:54.000000', 'consum', 0.0253, 'lps'),
	(638310, 135, '2015-01-01 00:33:55.000000', 'consum', 0.0257, 'lps'),
	(638311, 135, '2015-01-01 00:33:56.000000', 'consum', 0.0258, 'lps'),
	(638312, 135, '2015-01-01 00:33:57.000000', 'consum', 0.0247, 'lps'),
	(638313, 135, '2015-01-01 00:33:58.000000', 'consum', 0.0251, 'lps'),
	(638314, 135, '2015-01-01 00:33:59.000000', 'consum', 0.0242, 'lps'),
	(638315, 135, '2015-01-01 00:34:00.000000', 'consum', 0.0248, 'lps'),
	(638316, 135, '2015-01-01 00:34:01.000000', 'consum', 0.0244, 'lps'),
	(638317, 135, '2015-01-01 00:34:02.000000', 'consum', 0.0266, 'lps'),
	(638318, 135, '2015-01-01 00:34:03.000000', 'consum', 0.0265, 'lps'),
	(638319, 135, '2015-01-01 00:34:04.000000', 'consum', 0.0254, 'lps'),
	(638320, 135, '2015-01-01 00:34:05.000000', 'consum', 0.0265, 'lps'),
	(638321, 135, '2015-01-01 00:34:06.000000', 'consum', 0.0229, 'lps'),
	(638322, 135, '2015-01-01 00:34:07.000000', 'consum', 0.0266, 'lps'),
	(638323, 135, '2015-01-01 00:34:08.000000', 'consum', 0.0249, 'lps'),
	(638324, 135, '2015-01-01 00:34:09.000000', 'consum', 0.0237, 'lps'),
	(638325, 135, '2015-01-01 00:34:10.000000', 'consum', 0.0226, 'lps'),
	(638326, 135, '2015-01-01 00:34:11.000000', 'consum', 0.0211, 'lps'),
	(638327, 135, '2015-01-01 00:34:12.000000', 'consum', 0.0229, 'lps'),
	(638328, 135, '2015-01-01 00:34:13.000000', 'consum', 0.0242, 'lps'),
	(638329, 135, '2015-01-01 00:34:14.000000', 'consum', 0.0252, 'lps'),
	(638330, 135, '2015-01-01 00:34:15.000000', 'consum', 0.0260, 'lps'),
	(638331, 135, '2015-01-01 00:34:16.000000', 'consum', 0.0214, 'lps'),
	(638332, 135, '2015-01-01 00:34:17.000000', 'consum', 0.0263, 'lps'),
	(638333, 135, '2015-01-01 00:34:18.000000', 'consum', 0.0217, 'lps'),
	(638334, 135, '2015-01-01 00:34:19.000000', 'consum', 0.0271, 'lps'),
	(638335, 135, '2015-01-01 00:34:20.000000', 'consum', 0.0249, 'lps'),
	(638336, 135, '2015-01-01 00:34:21.000000', 'consum', 0.0220, 'lps'),
	(638337, 135, '2015-01-01 00:34:22.000000', 'consum', 0.0268, 'lps'),
	(638338, 135, '2015-01-01 00:34:23.000000', 'consum', 0.0223, 'lps'),
	(638339, 135, '2015-01-01 00:34:24.000000', 'consum', 0.0225, 'lps'),
	(638340, 135, '2015-01-01 00:34:25.000000', 'consum', 0.0246, 'lps'),
	(638341, 135, '2015-01-01 00:34:26.000000', 'consum', 0.0221, 'lps'),
	(638342, 135, '2015-01-01 00:34:27.000000', 'consum', 0.0218, 'lps'),
	(638343, 135, '2015-01-01 00:34:28.000000', 'consum', 0.0219, 'lps'),
	(638344, 135, '2015-01-01 00:34:29.000000', 'consum', 0.0233, 'lps'),
	(638345, 135, '2015-01-01 00:34:30.000000', 'consum', 0.0236, 'lps'),
	(638346, 135, '2015-01-01 00:34:31.000000', 'consum', 0.0270, 'lps'),
	(638347, 135, '2015-01-01 00:34:32.000000', 'consum', 0.0248, 'lps'),
	(638348, 135, '2015-01-01 00:34:33.000000', 'consum', 0.0218, 'lps'),
	(638349, 135, '2015-01-01 00:34:34.000000', 'consum', 0.0263, 'lps'),
	(638350, 135, '2015-01-01 00:34:35.000000', 'consum', 0.0266, 'lps'),
	(638351, 135, '2015-01-01 00:34:36.000000', 'consum', 0.0270, 'lps'),
	(638352, 135, '2015-01-01 00:34:37.000000', 'consum', 0.0217, 'lps'),
	(638353, 135, '2015-01-01 00:34:38.000000', 'consum', 0.0250, 'lps'),
	(638354, 135, '2015-01-01 00:34:39.000000', 'consum', 0.0269, 'lps'),
	(638355, 135, '2015-01-01 00:34:40.000000', 'consum', 0.0258, 'lps'),
	(638356, 135, '2015-01-01 00:34:41.000000', 'consum', 0.0213, 'lps'),
	(638357, 135, '2015-01-01 00:34:42.000000', 'consum', 0.0268, 'lps'),
	(638358, 135, '2015-01-01 00:34:43.000000', 'consum', 0.0241, 'lps'),
	(638359, 135, '2015-01-01 00:34:44.000000', 'consum', 0.0256, 'lps'),
	(638360, 135, '2015-01-01 00:34:45.000000', 'consum', 0.0221, 'lps'),
	(638361, 135, '2015-01-01 00:34:46.000000', 'consum', 0.0252, 'lps'),
	(638362, 135, '2015-01-01 00:34:47.000000', 'consum', 0.0266, 'lps'),
	(638363, 135, '2015-01-01 00:34:48.000000', 'consum', 0.0239, 'lps'),
	(638364, 135, '2015-01-01 00:34:49.000000', 'consum', 0.0248, 'lps'),
	(638365, 135, '2015-01-01 00:34:50.000000', 'consum', 0.0253, 'lps'),
	(638366, 135, '2015-01-01 00:34:51.000000', 'consum', 0.0251, 'lps'),
	(638367, 135, '2015-01-01 00:34:52.000000', 'consum', 0.0222, 'lps'),
	(638368, 135, '2015-01-01 00:34:53.000000', 'consum', 0.0211, 'lps'),
	(638369, 135, '2015-01-01 00:34:54.000000', 'consum', 0.0240, 'lps'),
	(638370, 135, '2015-01-01 00:34:55.000000', 'consum', 0.0236, 'lps'),
	(638371, 135, '2015-01-01 00:34:56.000000', 'consum', 0.0249, 'lps'),
	(638372, 135, '2015-01-01 00:34:57.000000', 'consum', 0.0265, 'lps'),
	(638373, 135, '2015-01-01 00:34:58.000000', 'consum', 0.0244, 'lps'),
	(638374, 135, '2015-01-01 00:34:59.000000', 'consum', 0.0218, 'lps'),
	(638375, 135, '2015-01-01 00:35:00.000000', 'consum', 0.0270, 'lps'),
	(638376, 135, '2015-01-01 00:35:01.000000', 'consum', 0.0241, 'lps'),
	(638377, 135, '2015-01-01 00:35:02.000000', 'consum', 0.0245, 'lps'),
	(638378, 135, '2015-01-01 00:35:03.000000', 'consum', 0.0232, 'lps'),
	(638379, 135, '2015-01-01 00:35:04.000000', 'consum', 0.0214, 'lps'),
	(638380, 135, '2015-01-01 00:35:05.000000', 'consum', 0.0225, 'lps'),
	(638381, 135, '2015-01-01 00:35:06.000000', 'consum', 0.0214, 'lps'),
	(638382, 135, '2015-01-01 00:35:07.000000', 'consum', 0.0248, 'lps'),
	(638383, 135, '2015-01-01 00:35:08.000000', 'consum', 0.0264, 'lps'),
	(638384, 135, '2015-01-01 00:35:09.000000', 'consum', 0.0240, 'lps'),
	(638385, 135, '2015-01-01 00:35:10.000000', 'consum', 0.0263, 'lps'),
	(638386, 135, '2015-01-01 00:35:11.000000', 'consum', 0.0260, 'lps'),
	(638387, 135, '2015-01-01 00:35:12.000000', 'consum', 0.0242, 'lps'),
	(638388, 135, '2015-01-01 00:35:13.000000', 'consum', 0.0219, 'lps'),
	(638389, 135, '2015-01-01 00:35:14.000000', 'consum', 0.0220, 'lps'),
	(638390, 135, '2015-01-01 00:35:15.000000', 'consum', 0.0236, 'lps'),
	(638391, 135, '2015-01-01 00:35:16.000000', 'consum', 0.0246, 'lps'),
	(638392, 135, '2015-01-01 00:35:17.000000', 'consum', 0.0251, 'lps'),
	(638393, 135, '2015-01-01 00:35:18.000000', 'consum', 0.0246, 'lps'),
	(638394, 135, '2015-01-01 00:35:19.000000', 'consum', 0.0267, 'lps'),
	(638395, 135, '2015-01-01 00:35:20.000000', 'consum', 0.0262, 'lps'),
	(638396, 135, '2015-01-01 00:35:21.000000', 'consum', 0.0238, 'lps'),
	(638397, 135, '2015-01-01 00:35:22.000000', 'consum', 0.0259, 'lps'),
	(638398, 135, '2015-01-01 00:35:23.000000', 'consum', 0.0245, 'lps'),
	(638399, 135, '2015-01-01 00:35:24.000000', 'consum', 0.0241, 'lps'),
	(638400, 135, '2015-01-01 00:35:25.000000', 'consum', 0.0261, 'lps'),
	(638401, 135, '2015-01-01 00:35:26.000000', 'consum', 0.0248, 'lps'),
	(638402, 135, '2015-01-01 00:35:27.000000', 'consum', 0.0246, 'lps'),
	(638403, 135, '2015-01-01 00:35:28.000000', 'consum', 0.0216, 'lps'),
	(638404, 135, '2015-01-01 00:35:29.000000', 'consum', 0.0256, 'lps'),
	(638405, 135, '2015-01-01 00:35:30.000000', 'consum', 0.0237, 'lps'),
	(638406, 135, '2015-01-01 00:35:31.000000', 'consum', 0.0271, 'lps'),
	(638407, 135, '2015-01-01 00:35:32.000000', 'consum', 0.0247, 'lps'),
	(638408, 135, '2015-01-01 00:35:33.000000', 'consum', 0.0211, 'lps'),
	(638409, 135, '2015-01-01 00:35:34.000000', 'consum', 0.0229, 'lps'),
	(638410, 135, '2015-01-01 00:35:35.000000', 'consum', 0.0243, 'lps'),
	(638411, 135, '2015-01-01 00:35:36.000000', 'consum', 0.0254, 'lps'),
	(638412, 135, '2015-01-01 00:35:37.000000', 'consum', 0.0210, 'lps'),
	(638413, 135, '2015-01-01 00:35:38.000000', 'consum', 0.0263, 'lps'),
	(638414, 135, '2015-01-01 00:35:39.000000', 'consum', 0.0227, 'lps'),
	(638415, 135, '2015-01-01 00:35:40.000000', 'consum', 0.0262, 'lps'),
	(638416, 135, '2015-01-01 00:35:41.000000', 'consum', 0.0232, 'lps'),
	(638417, 135, '2015-01-01 00:35:42.000000', 'consum', 0.0228, 'lps'),
	(638418, 135, '2015-01-01 00:35:43.000000', 'consum', 0.0233, 'lps'),
	(638419, 135, '2015-01-01 00:35:44.000000', 'consum', 0.0210, 'lps'),
	(638420, 135, '2015-01-01 00:35:45.000000', 'consum', 0.0266, 'lps'),
	(638421, 135, '2015-01-01 00:35:46.000000', 'consum', 0.0242, 'lps'),
	(638422, 135, '2015-01-01 00:35:47.000000', 'consum', 0.0265, 'lps'),
	(638423, 135, '2015-01-01 00:35:48.000000', 'consum', 0.0265, 'lps'),
	(638424, 135, '2015-01-01 00:35:49.000000', 'consum', 0.0257, 'lps'),
	(638425, 135, '2015-01-01 00:35:50.000000', 'consum', 0.0218, 'lps'),
	(638426, 135, '2015-01-01 00:35:51.000000', 'consum', 0.0236, 'lps'),
	(638427, 135, '2015-01-01 00:35:52.000000', 'consum', 0.0252, 'lps'),
	(638428, 135, '2015-01-01 00:35:53.000000', 'consum', 0.0219, 'lps'),
	(638429, 135, '2015-01-01 00:35:54.000000', 'consum', 0.0255, 'lps'),
	(638430, 135, '2015-01-01 00:35:55.000000', 'consum', 0.0222, 'lps'),
	(638431, 135, '2015-01-01 00:35:56.000000', 'consum', 0.0259, 'lps'),
	(638432, 135, '2015-01-01 00:35:57.000000', 'consum', 0.0233, 'lps'),
	(638433, 135, '2015-01-01 00:35:58.000000', 'consum', 0.0239, 'lps'),
	(638434, 135, '2015-01-01 00:35:59.000000', 'consum', 0.0228, 'lps'),
	(638435, 135, '2015-01-01 00:36:00.000000', 'consum', 0.0212, 'lps'),
	(638436, 135, '2015-01-01 00:36:01.000000', 'consum', 0.0229, 'lps'),
	(638437, 135, '2015-01-01 00:36:02.000000', 'consum', 0.0239, 'lps'),
	(638438, 135, '2015-01-01 00:36:03.000000', 'consum', 0.0234, 'lps'),
	(638439, 135, '2015-01-01 00:36:04.000000', 'consum', 0.0243, 'lps'),
	(638440, 135, '2015-01-01 00:36:05.000000', 'consum', 0.0243, 'lps'),
	(638441, 135, '2015-01-01 00:36:06.000000', 'consum', 0.0216, 'lps'),
	(638442, 135, '2015-01-01 00:36:07.000000', 'consum', 0.0265, 'lps'),
	(638443, 135, '2015-01-01 00:36:08.000000', 'consum', 0.0219, 'lps'),
	(638444, 135, '2015-01-01 00:36:09.000000', 'consum', 0.0212, 'lps'),
	(638445, 135, '2015-01-01 00:36:10.000000', 'consum', 0.0259, 'lps'),
	(638446, 135, '2015-01-01 00:36:11.000000', 'consum', 0.0260, 'lps'),
	(638447, 135, '2015-01-01 00:36:12.000000', 'consum', 0.0255, 'lps'),
	(638448, 135, '2015-01-01 00:36:13.000000', 'consum', 0.0223, 'lps'),
	(638449, 135, '2015-01-01 00:36:14.000000', 'consum', 0.0263, 'lps'),
	(638450, 135, '2015-01-01 00:36:15.000000', 'consum', 0.0251, 'lps'),
	(638451, 135, '2015-01-01 00:36:16.000000', 'consum', 0.0258, 'lps'),
	(638452, 135, '2015-01-01 00:36:17.000000', 'consum', 0.0264, 'lps'),
	(638453, 135, '2015-01-01 00:36:18.000000', 'consum', 0.0212, 'lps'),
	(638454, 135, '2015-01-01 00:36:19.000000', 'consum', 0.0245, 'lps'),
	(638455, 135, '2015-01-01 00:36:20.000000', 'consum', 0.0256, 'lps'),
	(638456, 135, '2015-01-01 00:36:21.000000', 'consum', 0.0211, 'lps'),
	(638457, 135, '2015-01-01 00:36:22.000000', 'consum', 0.0263, 'lps'),
	(638458, 135, '2015-01-01 00:36:23.000000', 'consum', 0.0226, 'lps'),
	(638459, 135, '2015-01-01 00:36:24.000000', 'consum', 0.0257, 'lps'),
	(638460, 135, '2015-01-01 00:36:25.000000', 'consum', 0.0271, 'lps'),
	(638461, 135, '2015-01-01 00:36:26.000000', 'consum', 0.0253, 'lps'),
	(638462, 135, '2015-01-01 00:36:27.000000', 'consum', 0.0240, 'lps'),
	(638463, 135, '2015-01-01 00:36:28.000000', 'consum', 0.0230, 'lps'),
	(638464, 135, '2015-01-01 00:36:29.000000', 'consum', 0.0224, 'lps'),
	(638465, 135, '2015-01-01 00:36:30.000000', 'consum', 0.0219, 'lps'),
	(638466, 135, '2015-01-01 00:36:31.000000', 'consum', 0.0212, 'lps'),
	(638467, 135, '2015-01-01 00:36:32.000000', 'consum', 0.0258, 'lps'),
	(638468, 135, '2015-01-01 00:36:33.000000', 'consum', 0.0259, 'lps'),
	(638469, 135, '2015-01-01 00:36:34.000000', 'consum', 0.0249, 'lps'),
	(638470, 135, '2015-01-01 00:36:35.000000', 'consum', 0.0258, 'lps'),
	(638471, 135, '2015-01-01 00:36:36.000000', 'consum', 0.0211, 'lps'),
	(638472, 135, '2015-01-01 00:36:37.000000', 'consum', 0.0258, 'lps'),
	(638473, 135, '2015-01-01 00:36:38.000000', 'consum', 0.0259, 'lps'),
	(638474, 135, '2015-01-01 00:36:39.000000', 'consum', 0.0250, 'lps'),
	(638475, 135, '2015-01-01 00:36:40.000000', 'consum', 0.0263, 'lps'),
	(638476, 135, '2015-01-01 00:36:41.000000', 'consum', 0.0231, 'lps'),
	(638477, 135, '2015-01-01 00:36:42.000000', 'consum', 0.0220, 'lps'),
	(638478, 135, '2015-01-01 00:36:43.000000', 'consum', 0.0260, 'lps'),
	(638479, 135, '2015-01-01 00:36:44.000000', 'consum', 0.0244, 'lps'),
	(638480, 135, '2015-01-01 00:36:45.000000', 'consum', 0.0229, 'lps'),
	(638481, 135, '2015-01-01 00:36:46.000000', 'consum', 0.0266, 'lps'),
	(638482, 135, '2015-01-01 00:36:47.000000', 'consum', 0.0248, 'lps'),
	(638483, 135, '2015-01-01 00:36:48.000000', 'consum', 0.0233, 'lps'),
	(638484, 135, '2015-01-01 00:36:49.000000', 'consum', 0.0211, 'lps'),
	(638485, 135, '2015-01-01 00:36:50.000000', 'consum', 0.0271, 'lps'),
	(638486, 135, '2015-01-01 00:36:51.000000', 'consum', 0.0265, 'lps'),
	(638487, 135, '2015-01-01 00:36:52.000000', 'consum', 0.0241, 'lps'),
	(638488, 135, '2015-01-01 00:36:53.000000', 'consum', 0.0263, 'lps'),
	(638489, 135, '2015-01-01 00:36:54.000000', 'consum', 0.0259, 'lps'),
	(638490, 135, '2015-01-01 00:36:55.000000', 'consum', 0.0233, 'lps'),
	(638491, 135, '2015-01-01 00:36:56.000000', 'consum', 0.0239, 'lps'),
	(638492, 135, '2015-01-01 00:36:57.000000', 'consum', 0.0228, 'lps'),
	(638493, 135, '2015-01-01 00:36:58.000000', 'consum', 0.0210, 'lps'),
	(638494, 135, '2015-01-01 00:36:59.000000', 'consum', 0.0220, 'lps'),
	(638495, 135, '2015-01-01 00:37:00.000000', 'consum', 0.0260, 'lps'),
	(638496, 135, '2015-01-01 00:37:01.000000', 'consum', 0.0244, 'lps'),
	(638497, 135, '2015-01-01 00:37:02.000000', 'consum', 0.0230, 'lps'),
	(638498, 135, '2015-01-01 00:37:03.000000', 'consum', 0.0270, 'lps'),
	(638499, 135, '2015-01-01 00:37:04.000000', 'consum', 0.0267, 'lps'),
	(638500, 135, '2015-01-01 00:37:05.000000', 'consum', 0.0252, 'lps'),
	(638501, 135, '2015-01-01 00:37:06.000000', 'consum', 0.0248, 'lps'),
	(638502, 135, '2015-01-01 00:37:07.000000', 'consum', 0.0212, 'lps'),
	(638503, 135, '2015-01-01 00:37:08.000000', 'consum', 0.0234, 'lps'),
	(638504, 135, '2015-01-01 00:37:09.000000', 'consum', 0.0260, 'lps'),
	(638505, 135, '2015-01-01 00:37:10.000000', 'consum', 0.0264, 'lps'),
	(638506, 135, '2015-01-01 00:37:11.000000', 'consum', 0.0268, 'lps'),
	(638507, 135, '2015-01-01 00:37:12.000000', 'consum', 0.0217, 'lps'),
	(638508, 135, '2015-01-01 00:37:13.000000', 'consum', 0.0256, 'lps'),
	(638509, 135, '2015-01-01 00:37:14.000000', 'consum', 0.0235, 'lps'),
	(638510, 135, '2015-01-01 00:37:15.000000', 'consum', 0.0257, 'lps'),
	(638511, 135, '2015-01-01 00:37:16.000000', 'consum', 0.0247, 'lps'),
	(638512, 135, '2015-01-01 00:37:17.000000', 'consum', 0.0255, 'lps'),
	(638513, 135, '2015-01-01 00:37:18.000000', 'consum', 0.0263, 'lps'),
	(638514, 135, '2015-01-01 00:37:19.000000', 'consum', 0.0217, 'lps'),
	(638515, 135, '2015-01-01 00:37:20.000000', 'consum', 0.0212, 'lps'),
	(638516, 135, '2015-01-01 00:37:21.000000', 'consum', 0.0259, 'lps'),
	(638517, 135, '2015-01-01 00:37:22.000000', 'consum', 0.0266, 'lps'),
	(638518, 135, '2015-01-01 00:37:23.000000', 'consum', 0.0218, 'lps'),
	(638519, 135, '2015-01-01 00:37:24.000000', 'consum', 0.0269, 'lps'),
	(638520, 135, '2015-01-01 00:37:25.000000', 'consum', 0.0234, 'lps'),
	(638521, 135, '2015-01-01 00:37:26.000000', 'consum', 0.0216, 'lps'),
	(638522, 135, '2015-01-01 00:37:27.000000', 'consum', 0.0232, 'lps'),
	(638523, 135, '2015-01-01 00:37:28.000000', 'consum', 0.0237, 'lps'),
	(638524, 135, '2015-01-01 00:37:29.000000', 'consum', 0.0219, 'lps'),
	(638525, 135, '2015-01-01 00:37:30.000000', 'consum', 0.0237, 'lps'),
	(638526, 135, '2015-01-01 00:37:31.000000', 'consum', 0.0254, 'lps'),
	(638527, 135, '2015-01-01 00:37:32.000000', 'consum', 0.0228, 'lps'),
	(638528, 135, '2015-01-01 00:37:33.000000', 'consum', 0.0229, 'lps'),
	(638529, 135, '2015-01-01 00:37:34.000000', 'consum', 0.0250, 'lps'),
	(638530, 135, '2015-01-01 00:37:35.000000', 'consum', 0.0232, 'lps'),
	(638531, 135, '2015-01-01 00:37:36.000000', 'consum', 0.0263, 'lps'),
	(638532, 135, '2015-01-01 00:37:37.000000', 'consum', 0.0223, 'lps'),
	(638533, 135, '2015-01-01 00:37:38.000000', 'consum', 0.0241, 'lps'),
	(638534, 135, '2015-01-01 00:37:39.000000', 'consum', 0.0266, 'lps'),
	(638535, 135, '2015-01-01 00:37:40.000000', 'consum', 0.0271, 'lps'),
	(638536, 135, '2015-01-01 00:37:41.000000', 'consum', 0.0222, 'lps'),
	(638537, 135, '2015-01-01 00:37:42.000000', 'consum', 0.0214, 'lps'),
	(638538, 135, '2015-01-01 00:37:43.000000', 'consum', 0.0255, 'lps'),
	(638539, 135, '2015-01-01 00:37:44.000000', 'consum', 0.0237, 'lps'),
	(638540, 135, '2015-01-01 00:37:45.000000', 'consum', 0.0210, 'lps'),
	(638541, 135, '2015-01-01 00:37:46.000000', 'consum', 0.0253, 'lps'),
	(638542, 135, '2015-01-01 00:37:47.000000', 'consum', 0.0242, 'lps'),
	(638543, 135, '2015-01-01 00:37:48.000000', 'consum', 0.0242, 'lps'),
	(638544, 135, '2015-01-01 00:37:49.000000', 'consum', 0.0211, 'lps'),
	(638545, 135, '2015-01-01 00:37:50.000000', 'consum', 0.0242, 'lps'),
	(638546, 135, '2015-01-01 00:37:51.000000', 'consum', 0.0245, 'lps'),
	(638547, 135, '2015-01-01 00:37:52.000000', 'consum', 0.0226, 'lps'),
	(638548, 135, '2015-01-01 00:37:53.000000', 'consum', 0.0250, 'lps'),
	(638549, 135, '2015-01-01 00:37:54.000000', 'consum', 0.0238, 'lps'),
	(638550, 135, '2015-01-01 00:37:55.000000', 'consum', 0.0228, 'lps'),
	(638551, 135, '2015-01-01 00:37:56.000000', 'consum', 0.0219, 'lps'),
	(638552, 135, '2015-01-01 00:37:57.000000', 'consum', 0.0261, 'lps'),
	(638553, 135, '2015-01-01 00:37:58.000000', 'consum', 0.0256, 'lps'),
	(638554, 135, '2015-01-01 00:37:59.000000', 'consum', 0.0223, 'lps'),
	(638555, 135, '2015-01-01 00:38:00.000000', 'consum', 0.0262, 'lps'),
	(638556, 135, '2015-01-01 00:38:01.000000', 'consum', 0.0245, 'lps'),
	(638557, 135, '2015-01-01 00:38:02.000000', 'consum', 0.0232, 'lps'),
	(638558, 135, '2015-01-01 00:38:03.000000', 'consum', 0.0214, 'lps'),
	(638559, 135, '2015-01-01 00:38:04.000000', 'consum', 0.0226, 'lps'),
	(638560, 135, '2015-01-01 00:38:05.000000', 'consum', 0.0216, 'lps'),
	(638561, 135, '2015-01-01 00:38:06.000000', 'consum', 0.0254, 'lps'),
	(638562, 135, '2015-01-01 00:38:07.000000', 'consum', 0.0226, 'lps'),
	(638563, 135, '2015-01-01 00:38:08.000000', 'consum', 0.0220, 'lps'),
	(638564, 135, '2015-01-01 00:38:09.000000', 'consum', 0.0214, 'lps'),
	(638565, 135, '2015-01-01 00:38:10.000000', 'consum', 0.0264, 'lps'),
	(638566, 135, '2015-01-01 00:38:11.000000', 'consum', 0.0219, 'lps'),
	(638567, 135, '2015-01-01 00:38:12.000000', 'consum', 0.0220, 'lps'),
	(638568, 135, '2015-01-01 00:38:13.000000', 'consum', 0.0230, 'lps'),
	(638569, 135, '2015-01-01 00:38:14.000000', 'consum', 0.0221, 'lps'),
	(638570, 135, '2015-01-01 00:38:15.000000', 'consum', 0.0266, 'lps'),
	(638571, 135, '2015-01-01 00:38:16.000000', 'consum', 0.0271, 'lps'),
	(638572, 135, '2015-01-01 00:38:17.000000', 'consum', 0.0226, 'lps'),
	(638573, 135, '2015-01-01 00:38:18.000000', 'consum', 0.0230, 'lps'),
	(638574, 135, '2015-01-01 00:38:19.000000', 'consum', 0.0263, 'lps'),
	(638575, 135, '2015-01-01 00:38:20.000000', 'consum', 0.0229, 'lps'),
	(638576, 135, '2015-01-01 00:38:21.000000', 'consum', 0.0271, 'lps'),
	(638577, 135, '2015-01-01 00:38:22.000000', 'consum', 0.0210, 'lps'),
	(638578, 135, '2015-01-01 00:38:23.000000', 'consum', 0.0213, 'lps'),
	(638579, 135, '2015-01-01 00:38:24.000000', 'consum', 0.0226, 'lps'),
	(638580, 135, '2015-01-01 00:38:25.000000', 'consum', 0.0219, 'lps'),
	(638581, 135, '2015-01-01 00:38:26.000000', 'consum', 0.0271, 'lps'),
	(638582, 135, '2015-01-01 00:38:27.000000', 'consum', 0.0239, 'lps'),
	(638583, 135, '2015-01-01 00:38:28.000000', 'consum', 0.0233, 'lps'),
	(638584, 135, '2015-01-01 00:38:29.000000', 'consum', 0.0240, 'lps'),
	(638585, 135, '2015-01-01 00:38:30.000000', 'consum', 0.0231, 'lps'),
	(638586, 135, '2015-01-01 00:38:31.000000', 'consum', 0.0226, 'lps'),
	(638587, 135, '2015-01-01 00:38:32.000000', 'consum', 0.0226, 'lps'),
	(638588, 135, '2015-01-01 00:38:33.000000', 'consum', 0.0241, 'lps'),
	(638589, 135, '2015-01-01 00:38:34.000000', 'consum', 0.0258, 'lps'),
	(638590, 135, '2015-01-01 00:38:35.000000', 'consum', 0.0233, 'lps'),
	(638591, 135, '2015-01-01 00:38:36.000000', 'consum', 0.0245, 'lps'),
	(638592, 135, '2015-01-01 00:38:37.000000', 'consum', 0.0252, 'lps'),
	(638593, 135, '2015-01-01 00:38:38.000000', 'consum', 0.0256, 'lps'),
	(638594, 135, '2015-01-01 00:38:39.000000', 'consum', 0.0250, 'lps'),
	(638595, 135, '2015-01-01 00:38:40.000000', 'consum', 0.0212, 'lps'),
	(638596, 135, '2015-01-01 00:38:41.000000', 'consum', 0.0222, 'lps'),
	(638597, 135, '2015-01-01 00:38:42.000000', 'consum', 0.0268, 'lps'),
	(638598, 135, '2015-01-01 00:38:43.000000', 'consum', 0.0214, 'lps'),
	(638599, 135, '2015-01-01 00:38:44.000000', 'consum', 0.0245, 'lps'),
	(638600, 135, '2015-01-01 00:38:45.000000', 'consum', 0.0247, 'lps'),
	(638601, 135, '2015-01-01 00:38:46.000000', 'consum', 0.0228, 'lps'),
	(638602, 135, '2015-01-01 00:38:47.000000', 'consum', 0.0254, 'lps'),
	(638603, 135, '2015-01-01 00:38:48.000000', 'consum', 0.0253, 'lps'),
	(638604, 135, '2015-01-01 00:38:49.000000', 'consum', 0.0231, 'lps'),
	(638605, 135, '2015-01-01 00:38:50.000000', 'consum', 0.0250, 'lps'),
	(638606, 135, '2015-01-01 00:38:51.000000', 'consum', 0.0222, 'lps'),
	(638607, 135, '2015-01-01 00:38:52.000000', 'consum', 0.0213, 'lps'),
	(638608, 135, '2015-01-01 00:38:53.000000', 'consum', 0.0251, 'lps'),
	(638609, 135, '2015-01-01 00:38:54.000000', 'consum', 0.0220, 'lps'),
	(638610, 135, '2015-01-01 00:38:55.000000', 'consum', 0.0260, 'lps'),
	(638611, 135, '2015-01-01 00:38:56.000000', 'consum', 0.0246, 'lps'),
	(638612, 135, '2015-01-01 00:38:57.000000', 'consum', 0.0241, 'lps'),
	(638613, 135, '2015-01-01 00:38:58.000000', 'consum', 0.0259, 'lps'),
	(638614, 135, '2015-01-01 00:38:59.000000', 'consum', 0.0237, 'lps'),
	(638615, 135, '2015-01-01 00:39:00.000000', 'consum', 0.0262, 'lps'),
	(638616, 135, '2015-01-01 00:39:01.000000', 'consum', 0.0265, 'lps'),
	(638617, 135, '2015-01-01 00:39:02.000000', 'consum', 0.0266, 'lps'),
	(638618, 135, '2015-01-01 00:39:03.000000', 'consum', 0.0264, 'lps'),
	(638619, 135, '2015-01-01 00:39:04.000000', 'consum', 0.0250, 'lps'),
	(638620, 135, '2015-01-01 00:39:05.000000', 'consum', 0.0249, 'lps'),
	(638621, 135, '2015-01-01 00:39:06.000000', 'consum', 0.0224, 'lps'),
	(638622, 135, '2015-01-01 00:39:07.000000', 'consum', 0.0226, 'lps'),
	(638623, 135, '2015-01-01 00:39:08.000000', 'consum', 0.0248, 'lps'),
	(638624, 135, '2015-01-01 00:39:09.000000', 'consum', 0.0227, 'lps'),
	(638625, 135, '2015-01-01 00:39:10.000000', 'consum', 0.0245, 'lps'),
	(638626, 135, '2015-01-01 00:39:11.000000', 'consum', 0.0271, 'lps'),
	(638627, 135, '2015-01-01 00:39:12.000000', 'consum', 0.0226, 'lps'),
	(638628, 135, '2015-01-01 00:39:13.000000', 'consum', 0.0231, 'lps'),
	(638629, 135, '2015-01-01 00:39:14.000000', 'consum', 0.0267, 'lps'),
	(638630, 135, '2015-01-01 00:39:15.000000', 'consum', 0.0249, 'lps'),
	(638631, 135, '2015-01-01 00:39:16.000000', 'consum', 0.0232, 'lps'),
	(638632, 135, '2015-01-01 00:39:17.000000', 'consum', 0.0265, 'lps'),
	(638633, 135, '2015-01-01 00:39:18.000000', 'consum', 0.0235, 'lps'),
	(638634, 135, '2015-01-01 00:39:19.000000', 'consum', 0.0232, 'lps'),
	(638635, 135, '2015-01-01 00:39:20.000000', 'consum', 0.0244, 'lps'),
	(638636, 135, '2015-01-01 00:39:21.000000', 'consum', 0.0255, 'lps'),
	(638637, 135, '2015-01-01 00:39:22.000000', 'consum', 0.0269, 'lps'),
	(638638, 135, '2015-01-01 00:39:23.000000', 'consum', 0.0247, 'lps'),
	(638639, 135, '2015-01-01 00:39:24.000000', 'consum', 0.0219, 'lps'),
	(638640, 135, '2015-01-01 00:39:25.000000', 'consum', 0.0269, 'lps'),
	(638641, 135, '2015-01-01 00:39:26.000000', 'consum', 0.0232, 'lps'),
	(638642, 135, '2015-01-01 00:39:27.000000', 'consum', 0.0266, 'lps'),
	(638643, 135, '2015-01-01 00:39:28.000000', 'consum', 0.0238, 'lps'),
	(638644, 135, '2015-01-01 00:39:29.000000', 'consum', 0.0244, 'lps'),
	(638645, 135, '2015-01-01 00:39:30.000000', 'consum', 0.0234, 'lps'),
	(638646, 135, '2015-01-01 00:39:31.000000', 'consum', 0.0228, 'lps'),
	(638647, 135, '2015-01-01 00:39:32.000000', 'consum', 0.0230, 'lps'),
	(638648, 135, '2015-01-01 00:39:33.000000', 'consum', 0.0256, 'lps'),
	(638649, 135, '2015-01-01 00:39:34.000000', 'consum', 0.0258, 'lps'),
	(638650, 135, '2015-01-01 00:39:35.000000', 'consum', 0.0251, 'lps'),
	(638651, 135, '2015-01-01 00:39:36.000000', 'consum', 0.0270, 'lps'),
	(638652, 135, '2015-01-01 00:39:37.000000', 'consum', 0.0263, 'lps'),
	(638653, 135, '2015-01-01 00:39:38.000000', 'consum', 0.0235, 'lps'),
	(638654, 135, '2015-01-01 00:39:39.000000', 'consum', 0.0239, 'lps'),
	(638655, 135, '2015-01-01 00:39:40.000000', 'consum', 0.0218, 'lps'),
	(638656, 135, '2015-01-01 00:39:41.000000', 'consum', 0.0223, 'lps'),
	(638657, 135, '2015-01-01 00:39:42.000000', 'consum', 0.0255, 'lps'),
	(638658, 135, '2015-01-01 00:39:43.000000', 'consum', 0.0271, 'lps'),
	(638659, 135, '2015-01-01 00:39:44.000000', 'consum', 0.0258, 'lps'),
	(638660, 135, '2015-01-01 00:39:45.000000', 'consum', 0.0265, 'lps'),
	(638661, 135, '2015-01-01 00:39:46.000000', 'consum', 0.0218, 'lps'),
	(638662, 135, '2015-01-01 00:39:47.000000', 'consum', 0.0210, 'lps'),
	(638663, 135, '2015-01-01 00:39:48.000000', 'consum', 0.0247, 'lps'),
	(638664, 135, '2015-01-01 00:39:49.000000', 'consum', 0.0212, 'lps'),
	(638665, 135, '2015-01-01 00:39:50.000000', 'consum', 0.0235, 'lps'),
	(638666, 135, '2015-01-01 00:39:51.000000', 'consum', 0.0264, 'lps'),
	(638667, 135, '2015-01-01 00:39:52.000000', 'consum', 0.0220, 'lps'),
	(638668, 135, '2015-01-01 00:39:53.000000', 'consum', 0.0225, 'lps'),
	(638669, 135, '2015-01-01 00:39:54.000000', 'consum', 0.0253, 'lps'),
	(638670, 135, '2015-01-01 00:39:55.000000', 'consum', 0.0259, 'lps'),
	(638671, 135, '2015-01-01 00:39:56.000000', 'consum', 0.0264, 'lps'),
	(638672, 135, '2015-01-01 00:39:57.000000', 'consum', 0.0211, 'lps'),
	(638673, 135, '2015-01-01 00:39:58.000000', 'consum', 0.0237, 'lps'),
	(638674, 135, '2015-01-01 00:39:59.000000', 'consum', 0.0218, 'lps'),
	(638675, 135, '2015-01-01 00:40:00.000000', 'consum', 0.0235, 'lps'),
	(638676, 135, '2015-01-01 00:40:01.000000', 'consum', 0.0246, 'lps'),
	(638677, 135, '2015-01-01 00:40:02.000000', 'consum', 0.0253, 'lps'),
	(638678, 135, '2015-01-01 00:40:03.000000', 'consum', 0.0258, 'lps'),
	(638679, 135, '2015-01-01 00:40:04.000000', 'consum', 0.0259, 'lps'),
	(638680, 135, '2015-01-01 00:40:05.000000', 'consum', 0.0248, 'lps'),
	(638681, 135, '2015-01-01 00:40:06.000000', 'consum', 0.0252, 'lps'),
	(638682, 135, '2015-01-01 00:40:07.000000', 'consum', 0.0248, 'lps'),
	(638683, 135, '2015-01-01 00:40:08.000000', 'consum', 0.0210, 'lps'),
	(638684, 135, '2015-01-01 00:40:09.000000', 'consum', 0.0223, 'lps'),
	(638685, 135, '2015-01-01 00:40:10.000000', 'consum', 0.0212, 'lps'),
	(638686, 135, '2015-01-01 00:40:11.000000', 'consum', 0.0244, 'lps'),
	(638687, 135, '2015-01-01 00:40:12.000000', 'consum', 0.0249, 'lps'),
	(638688, 135, '2015-01-01 00:40:13.000000', 'consum', 0.0243, 'lps'),
	(638689, 135, '2015-01-01 00:40:14.000000', 'consum', 0.0256, 'lps'),
	(638690, 135, '2015-01-01 00:40:15.000000', 'consum', 0.0221, 'lps'),
	(638691, 135, '2015-01-01 00:40:16.000000', 'consum', 0.0248, 'lps'),
	(638692, 135, '2015-01-01 00:40:17.000000', 'consum', 0.0246, 'lps'),
	(638693, 135, '2015-01-01 00:40:18.000000', 'consum', 0.0215, 'lps'),
	(638694, 135, '2015-01-01 00:40:19.000000', 'consum', 0.0251, 'lps'),
	(638695, 135, '2015-01-01 00:40:20.000000', 'consum', 0.0216, 'lps'),
	(638696, 135, '2015-01-01 00:40:21.000000', 'consum', 0.0238, 'lps'),
	(638697, 135, '2015-01-01 00:40:22.000000', 'consum', 0.0212, 'lps'),
	(638698, 135, '2015-01-01 00:40:23.000000', 'consum', 0.0259, 'lps'),
	(638699, 135, '2015-01-01 00:40:24.000000', 'consum', 0.0265, 'lps'),
	(638700, 135, '2015-01-01 00:40:25.000000', 'consum', 0.0213, 'lps'),
	(638701, 135, '2015-01-01 00:40:26.000000', 'consum', 0.0245, 'lps'),
	(638702, 135, '2015-01-01 00:40:27.000000', 'consum', 0.0253, 'lps'),
	(638703, 135, '2015-01-01 00:40:28.000000', 'consum', 0.0260, 'lps'),
	(638704, 135, '2015-01-01 00:40:29.000000', 'consum', 0.0271, 'lps'),
	(638705, 135, '2015-01-01 00:40:30.000000', 'consum', 0.0238, 'lps'),
	(638706, 135, '2015-01-01 00:40:31.000000', 'consum', 0.0230, 'lps'),
	(638707, 135, '2015-01-01 00:40:32.000000', 'consum', 0.0228, 'lps'),
	(638708, 135, '2015-01-01 00:40:33.000000', 'consum', 0.0242, 'lps'),
	(638709, 135, '2015-01-01 00:40:34.000000', 'consum', 0.0253, 'lps'),
	(638710, 135, '2015-01-01 00:40:35.000000', 'consum', 0.0267, 'lps'),
	(638711, 135, '2015-01-01 00:40:36.000000', 'consum', 0.0242, 'lps'),
	(638712, 135, '2015-01-01 00:40:37.000000', 'consum', 0.0262, 'lps'),
	(638713, 135, '2015-01-01 00:40:38.000000', 'consum', 0.0249, 'lps'),
	(638714, 135, '2015-01-01 00:40:39.000000', 'consum', 0.0248, 'lps'),
	(638715, 135, '2015-01-01 00:40:40.000000', 'consum', 0.0225, 'lps'),
	(638716, 135, '2015-01-01 00:40:41.000000', 'consum', 0.0233, 'lps'),
	(638717, 135, '2015-01-01 00:40:42.000000', 'consum', 0.0219, 'lps'),
	(638718, 135, '2015-01-01 00:40:43.000000', 'consum', 0.0249, 'lps'),
	(638719, 135, '2015-01-01 00:40:44.000000', 'consum', 0.0253, 'lps'),
	(638720, 135, '2015-01-01 00:40:45.000000', 'consum', 0.0248, 'lps'),
	(638721, 135, '2015-01-01 00:40:46.000000', 'consum', 0.0211, 'lps'),
	(638722, 135, '2015-01-01 00:40:47.000000', 'consum', 0.0222, 'lps'),
	(638723, 135, '2015-01-01 00:40:48.000000', 'consum', 0.0271, 'lps'),
	(638724, 135, '2015-01-01 00:40:49.000000', 'consum', 0.0230, 'lps'),
	(638725, 135, '2015-01-01 00:40:50.000000', 'consum', 0.0250, 'lps'),
	(638726, 135, '2015-01-01 00:40:51.000000', 'consum', 0.0229, 'lps'),
	(638727, 135, '2015-01-01 00:40:52.000000', 'consum', 0.0245, 'lps'),
	(638728, 135, '2015-01-01 00:40:53.000000', 'consum', 0.0268, 'lps'),
	(638729, 135, '2015-01-01 00:40:54.000000', 'consum', 0.0210, 'lps'),
	(638730, 135, '2015-01-01 00:40:55.000000', 'consum', 0.0224, 'lps'),
	(638731, 135, '2015-01-01 00:40:56.000000', 'consum', 0.0215, 'lps'),
	(638732, 135, '2015-01-01 00:40:57.000000', 'consum', 0.0257, 'lps'),
	(638733, 135, '2015-01-01 00:40:58.000000', 'consum', 0.0244, 'lps'),
	(638734, 135, '2015-01-01 00:40:59.000000', 'consum', 0.0240, 'lps'),
	(638735, 135, '2015-01-01 00:41:00.000000', 'consum', 0.0258, 'lps'),
	(638736, 135, '2015-01-01 00:41:01.000000', 'consum', 0.0235, 'lps'),
	(638737, 135, '2015-01-01 00:41:02.000000', 'consum', 0.0256, 'lps'),
	(638738, 135, '2015-01-01 00:41:03.000000', 'consum', 0.0239, 'lps'),
	(638739, 135, '2015-01-01 00:41:04.000000', 'consum', 0.0220, 'lps'),
	(638740, 135, '2015-01-01 00:41:05.000000', 'consum', 0.0234, 'lps'),
	(638741, 135, '2015-01-01 00:41:06.000000', 'consum', 0.0237, 'lps'),
	(638742, 135, '2015-01-01 00:41:07.000000', 'consum', 0.0214, 'lps'),
	(638743, 135, '2015-01-01 00:41:08.000000', 'consum', 0.0210, 'lps'),
	(638744, 135, '2015-01-01 00:41:09.000000', 'consum', 0.0263, 'lps'),
	(638745, 135, '2015-01-01 00:41:10.000000', 'consum', 0.0225, 'lps'),
	(638746, 135, '2015-01-01 00:41:11.000000', 'consum', 0.0253, 'lps'),
	(638747, 135, '2015-01-01 00:41:12.000000', 'consum', 0.0257, 'lps'),
	(638748, 135, '2015-01-01 00:41:13.000000', 'consum', 0.0253, 'lps'),
	(638749, 135, '2015-01-01 00:41:14.000000', 'consum', 0.0224, 'lps'),
	(638750, 135, '2015-01-01 00:41:15.000000', 'consum', 0.0211, 'lps'),
	(638751, 135, '2015-01-01 00:41:16.000000', 'consum', 0.0238, 'lps'),
	(638752, 135, '2015-01-01 00:41:17.000000', 'consum', 0.0221, 'lps'),
	(638753, 135, '2015-01-01 00:41:18.000000', 'consum', 0.0246, 'lps'),
	(638754, 135, '2015-01-01 00:41:19.000000', 'consum', 0.0232, 'lps'),
	(638755, 135, '2015-01-01 00:41:20.000000', 'consum', 0.0214, 'lps'),
	(638756, 135, '2015-01-01 00:41:21.000000', 'consum', 0.0226, 'lps'),
	(638757, 135, '2015-01-01 00:41:22.000000', 'consum', 0.0214, 'lps'),
	(638758, 135, '2015-01-01 00:41:23.000000', 'consum', 0.0248, 'lps'),
	(638759, 135, '2015-01-01 00:41:24.000000', 'consum', 0.0263, 'lps'),
	(638760, 135, '2015-01-01 00:41:25.000000', 'consum', 0.0238, 'lps'),
	(638761, 135, '2015-01-01 00:41:26.000000', 'consum', 0.0253, 'lps'),
	(638762, 135, '2015-01-01 00:41:27.000000', 'consum', 0.0218, 'lps'),
	(638763, 135, '2015-01-01 00:41:28.000000', 'consum', 0.0246, 'lps'),
	(638764, 135, '2015-01-01 00:41:29.000000', 'consum', 0.0240, 'lps'),
	(638765, 135, '2015-01-01 00:41:30.000000', 'consum', 0.0254, 'lps'),
	(638766, 135, '2015-01-01 00:41:31.000000', 'consum', 0.0218, 'lps'),
	(638767, 135, '2015-01-01 00:41:32.000000', 'consum', 0.0240, 'lps'),
	(638768, 135, '2015-01-01 00:41:33.000000', 'consum', 0.0214, 'lps'),
	(638769, 135, '2015-01-01 00:41:34.000000', 'consum', 0.0263, 'lps'),
	(638770, 135, '2015-01-01 00:41:35.000000', 'consum', 0.0217, 'lps'),
	(638771, 135, '2015-01-01 00:41:36.000000', 'consum', 0.0211, 'lps'),
	(638772, 135, '2015-01-01 00:41:37.000000', 'consum', 0.0258, 'lps'),
	(638773, 135, '2015-01-01 00:41:38.000000', 'consum', 0.0259, 'lps'),
	(638774, 135, '2015-01-01 00:41:39.000000', 'consum', 0.0249, 'lps'),
	(638775, 135, '2015-01-01 00:41:40.000000', 'consum', 0.0261, 'lps'),
	(638776, 135, '2015-01-01 00:41:41.000000', 'consum', 0.0221, 'lps'),
	(638777, 135, '2015-01-01 00:41:42.000000', 'consum', 0.0240, 'lps'),
	(638778, 135, '2015-01-01 00:41:43.000000', 'consum', 0.0264, 'lps'),
	(638779, 135, '2015-01-01 00:41:44.000000', 'consum', 0.0265, 'lps'),
	(638780, 135, '2015-01-01 00:41:45.000000', 'consum', 0.0264, 'lps'),
	(638781, 135, '2015-01-01 00:41:46.000000', 'consum', 0.0251, 'lps'),
	(638782, 135, '2015-01-01 00:41:47.000000', 'consum', 0.0253, 'lps'),
	(638783, 135, '2015-01-01 00:41:48.000000', 'consum', 0.0242, 'lps'),
	(638784, 135, '2015-01-01 00:41:49.000000', 'consum', 0.0243, 'lps'),
	(638785, 135, '2015-01-01 00:41:50.000000', 'consum', 0.0216, 'lps'),
	(638786, 135, '2015-01-01 00:41:51.000000', 'consum', 0.0267, 'lps'),
	(638787, 135, '2015-01-01 00:41:52.000000', 'consum', 0.0230, 'lps'),
	(638788, 135, '2015-01-01 00:41:53.000000', 'consum', 0.0262, 'lps'),
	(638789, 135, '2015-01-01 00:41:54.000000', 'consum', 0.0225, 'lps'),
	(638790, 135, '2015-01-01 00:41:55.000000', 'consum', 0.0256, 'lps'),
	(638791, 135, '2015-01-01 00:41:56.000000', 'consum', 0.0268, 'lps'),
	(638792, 135, '2015-01-01 00:41:57.000000', 'consum', 0.0238, 'lps'),
	(638793, 135, '2015-01-01 00:41:58.000000', 'consum', 0.0239, 'lps'),
	(638794, 135, '2015-01-01 00:41:59.000000', 'consum', 0.0211, 'lps'),
	(638795, 135, '2015-01-01 00:42:00.000000', 'consum', 0.0250, 'lps'),
	(638796, 135, '2015-01-01 00:42:01.000000', 'consum', 0.0224, 'lps'),
	(638797, 135, '2015-01-01 00:42:02.000000', 'consum', 0.0220, 'lps'),
	(638798, 135, '2015-01-01 00:42:03.000000', 'consum', 0.0222, 'lps'),
	(638799, 135, '2015-01-01 00:42:04.000000', 'consum', 0.0237, 'lps'),
	(638800, 135, '2015-01-01 00:42:05.000000', 'consum', 0.0249, 'lps'),
	(638801, 135, '2015-01-01 00:42:06.000000', 'consum', 0.0262, 'lps'),
	(638802, 135, '2015-01-01 00:42:07.000000', 'consum', 0.0229, 'lps'),
	(638803, 135, '2015-01-01 00:42:08.000000', 'consum', 0.0212, 'lps'),
	(638804, 135, '2015-01-01 00:42:09.000000', 'consum', 0.0227, 'lps'),
	(638805, 135, '2015-01-01 00:42:10.000000', 'consum', 0.0227, 'lps'),
	(638806, 135, '2015-01-01 00:42:11.000000', 'consum', 0.0245, 'lps'),
	(638807, 135, '2015-01-01 00:42:12.000000', 'consum', 0.0210, 'lps'),
	(638808, 135, '2015-01-01 00:42:13.000000', 'consum', 0.0228, 'lps'),
	(638809, 135, '2015-01-01 00:42:14.000000', 'consum', 0.0239, 'lps'),
	(638810, 135, '2015-01-01 00:42:15.000000', 'consum', 0.0241, 'lps'),
	(638811, 135, '2015-01-01 00:42:16.000000', 'consum', 0.0216, 'lps'),
	(638812, 135, '2015-01-01 00:42:17.000000', 'consum', 0.0269, 'lps'),
	(638813, 135, '2015-01-01 00:42:18.000000', 'consum', 0.0243, 'lps'),
	(638814, 135, '2015-01-01 00:42:19.000000', 'consum', 0.0260, 'lps'),
	(638815, 135, '2015-01-01 00:42:20.000000', 'consum', 0.0237, 'lps'),
	(638816, 135, '2015-01-01 00:42:21.000000', 'consum', 0.0259, 'lps'),
	(638817, 135, '2015-01-01 00:42:22.000000', 'consum', 0.0249, 'lps'),
	(638818, 135, '2015-01-01 00:42:23.000000', 'consum', 0.0258, 'lps'),
	(638819, 135, '2015-01-01 00:42:24.000000', 'consum', 0.0210, 'lps'),
	(638820, 135, '2015-01-01 00:42:25.000000', 'consum', 0.0253, 'lps'),
	(638821, 135, '2015-01-01 00:42:26.000000', 'consum', 0.0240, 'lps'),
	(638822, 135, '2015-01-01 00:42:27.000000', 'consum', 0.0230, 'lps'),
	(638823, 135, '2015-01-01 00:42:28.000000', 'consum', 0.0220, 'lps'),
	(638824, 135, '2015-01-01 00:42:29.000000', 'consum', 0.0262, 'lps'),
	(638825, 135, '2015-01-01 00:42:30.000000', 'consum', 0.0256, 'lps'),
	(638826, 135, '2015-01-01 00:42:31.000000', 'consum', 0.0221, 'lps'),
	(638827, 135, '2015-01-01 00:42:32.000000', 'consum', 0.0250, 'lps'),
	(638828, 135, '2015-01-01 00:42:33.000000', 'consum', 0.0256, 'lps'),
	(638829, 135, '2015-01-01 00:42:34.000000', 'consum', 0.0257, 'lps'),
	(638830, 135, '2015-01-01 00:42:35.000000', 'consum', 0.0246, 'lps'),
	(638831, 135, '2015-01-01 00:42:36.000000', 'consum', 0.0251, 'lps'),
	(638832, 135, '2015-01-01 00:42:37.000000', 'consum', 0.0244, 'lps'),
	(638833, 135, '2015-01-01 00:42:38.000000', 'consum', 0.0258, 'lps'),
	(638834, 135, '2015-01-01 00:42:39.000000', 'consum', 0.0226, 'lps'),
	(638835, 135, '2015-01-01 00:42:40.000000', 'consum', 0.0268, 'lps'),
	(638836, 135, '2015-01-01 00:42:41.000000', 'consum', 0.0269, 'lps'),
	(638837, 135, '2015-01-01 00:42:42.000000', 'consum', 0.0268, 'lps'),
	(638838, 135, '2015-01-01 00:42:43.000000', 'consum', 0.0262, 'lps'),
	(638839, 135, '2015-01-01 00:42:44.000000', 'consum', 0.0236, 'lps'),
	(638840, 135, '2015-01-01 00:42:45.000000', 'consum', 0.0243, 'lps'),
	(638841, 135, '2015-01-01 00:42:46.000000', 'consum', 0.0239, 'lps'),
	(638842, 135, '2015-01-01 00:42:47.000000', 'consum', 0.0255, 'lps'),
	(638843, 135, '2015-01-01 00:42:48.000000', 'consum', 0.0223, 'lps'),
	(638844, 135, '2015-01-01 00:42:49.000000', 'consum', 0.0265, 'lps'),
	(638845, 135, '2015-01-01 00:42:50.000000', 'consum', 0.0260, 'lps'),
	(638846, 135, '2015-01-01 00:42:51.000000', 'consum', 0.0232, 'lps'),
	(638847, 135, '2015-01-01 00:42:52.000000', 'consum', 0.0234, 'lps'),
	(638848, 135, '2015-01-01 00:42:53.000000', 'consum', 0.0266, 'lps'),
	(638849, 135, '2015-01-01 00:42:54.000000', 'consum', 0.0230, 'lps'),
	(638850, 135, '2015-01-01 00:42:55.000000', 'consum', 0.0269, 'lps'),
	(638851, 135, '2015-01-01 00:42:56.000000', 'consum', 0.0260, 'lps'),
	(638852, 135, '2015-01-01 00:42:57.000000', 'consum', 0.0221, 'lps'),
	(638853, 135, '2015-01-01 00:42:58.000000', 'consum', 0.0237, 'lps'),
	(638854, 135, '2015-01-01 00:42:59.000000', 'consum', 0.0254, 'lps'),
	(638855, 135, '2015-01-01 00:43:00.000000', 'consum', 0.0223, 'lps'),
	(638856, 135, '2015-01-01 00:43:01.000000', 'consum', 0.0267, 'lps'),
	(638857, 135, '2015-01-01 00:43:02.000000', 'consum', 0.0271, 'lps'),
	(638858, 135, '2015-01-01 00:43:03.000000', 'consum', 0.0223, 'lps'),
	(638859, 135, '2015-01-01 00:43:04.000000', 'consum', 0.0213, 'lps'),
	(638860, 135, '2015-01-01 00:43:05.000000', 'consum', 0.0251, 'lps'),
	(638861, 135, '2015-01-01 00:43:06.000000', 'consum', 0.0221, 'lps'),
	(638862, 135, '2015-01-01 00:43:07.000000', 'consum', 0.0267, 'lps'),
	(638863, 135, '2015-01-01 00:43:08.000000', 'consum', 0.0211, 'lps'),
	(638864, 135, '2015-01-01 00:43:09.000000', 'consum', 0.0234, 'lps'),
	(638865, 135, '2015-01-01 00:43:10.000000', 'consum', 0.0266, 'lps'),
	(638866, 135, '2015-01-01 00:43:11.000000', 'consum', 0.0230, 'lps'),
	(638867, 135, '2015-01-01 00:43:12.000000', 'consum', 0.0266, 'lps'),
	(638868, 135, '2015-01-01 00:43:13.000000', 'consum', 0.0246, 'lps'),
	(638869, 135, '2015-01-01 00:43:14.000000', 'consum', 0.0221, 'lps'),
	(638870, 135, '2015-01-01 00:43:15.000000', 'consum', 0.0219, 'lps'),
	(638871, 135, '2015-01-01 00:43:16.000000', 'consum', 0.0225, 'lps'),
	(638872, 135, '2015-01-01 00:43:17.000000', 'consum', 0.0257, 'lps'),
	(638873, 135, '2015-01-01 00:43:18.000000', 'consum', 0.0215, 'lps'),
	(638874, 135, '2015-01-01 00:43:19.000000', 'consum', 0.0218, 'lps'),
	(638875, 135, '2015-01-01 00:43:20.000000', 'consum', 0.0238, 'lps'),
	(638876, 135, '2015-01-01 00:43:21.000000', 'consum', 0.0261, 'lps'),
	(638877, 135, '2015-01-01 00:43:22.000000', 'consum', 0.0259, 'lps'),
	(638878, 135, '2015-01-01 00:43:23.000000', 'consum', 0.0239, 'lps'),
	(638879, 135, '2015-01-01 00:43:24.000000', 'consum', 0.0210, 'lps'),
	(638880, 135, '2015-01-01 00:43:25.000000', 'consum', 0.0247, 'lps'),
	(638881, 135, '2015-01-01 00:43:26.000000', 'consum', 0.0271, 'lps'),
	(638882, 135, '2015-01-01 00:43:27.000000', 'consum', 0.0219, 'lps'),
	(638883, 135, '2015-01-01 00:43:28.000000', 'consum', 0.0259, 'lps'),
	(638884, 135, '2015-01-01 00:43:29.000000', 'consum', 0.0243, 'lps'),
	(638885, 135, '2015-01-01 00:43:30.000000', 'consum', 0.0229, 'lps'),
	(638886, 135, '2015-01-01 00:43:31.000000', 'consum', 0.0267, 'lps'),
	(638887, 135, '2015-01-01 00:43:32.000000', 'consum', 0.0252, 'lps'),
	(638888, 135, '2015-01-01 00:43:33.000000', 'consum', 0.0249, 'lps'),
	(638889, 135, '2015-01-01 00:43:34.000000', 'consum', 0.0220, 'lps'),
	(638890, 135, '2015-01-01 00:43:35.000000', 'consum', 0.0265, 'lps'),
	(638891, 135, '2015-01-01 00:43:36.000000', 'consum', 0.0210, 'lps'),
	(638892, 135, '2015-01-01 00:43:37.000000', 'consum', 0.0231, 'lps'),
	(638893, 135, '2015-01-01 00:43:38.000000', 'consum', 0.0254, 'lps'),
	(638894, 135, '2015-01-01 00:43:39.000000', 'consum', 0.0243, 'lps'),
	(638895, 135, '2015-01-01 00:43:40.000000', 'consum', 0.0243, 'lps'),
	(638896, 135, '2015-01-01 00:43:41.000000', 'consum', 0.0214, 'lps'),
	(638897, 135, '2015-01-01 00:43:42.000000', 'consum', 0.0255, 'lps'),
	(638898, 135, '2015-01-01 00:43:43.000000', 'consum', 0.0239, 'lps'),
	(638899, 135, '2015-01-01 00:43:44.000000', 'consum', 0.0219, 'lps'),
	(638900, 135, '2015-01-01 00:43:45.000000', 'consum', 0.0231, 'lps'),
	(638901, 135, '2015-01-01 00:43:46.000000', 'consum', 0.0227, 'lps'),
	(638902, 135, '2015-01-01 00:43:47.000000', 'consum', 0.0233, 'lps'),
	(638903, 135, '2015-01-01 00:43:48.000000', 'consum', 0.0211, 'lps'),
	(638904, 135, '2015-01-01 00:43:49.000000', 'consum', 0.0211, 'lps'),
	(638905, 135, '2015-01-01 00:43:50.000000', 'consum', 0.0210, 'lps'),
	(638906, 135, '2015-01-01 00:43:51.000000', 'consum', 0.0269, 'lps'),
	(638907, 135, '2015-01-01 00:43:52.000000', 'consum', 0.0258, 'lps'),
	(638908, 135, '2015-01-01 00:43:53.000000', 'consum', 0.0213, 'lps'),
	(638909, 135, '2015-01-01 00:43:54.000000', 'consum', 0.0267, 'lps'),
	(638910, 135, '2015-01-01 00:43:55.000000', 'consum', 0.0240, 'lps'),
	(638911, 135, '2015-01-01 00:43:56.000000', 'consum', 0.0251, 'lps'),
	(638912, 135, '2015-01-01 00:43:57.000000', 'consum', 0.0262, 'lps'),
	(638913, 135, '2015-01-01 00:43:58.000000', 'consum', 0.0223, 'lps'),
	(638914, 135, '2015-01-01 00:43:59.000000', 'consum', 0.0245, 'lps'),
	(638915, 135, '2015-01-01 00:44:00.000000', 'consum', 0.0223, 'lps'),
	(638916, 135, '2015-01-01 00:44:01.000000', 'consum', 0.0232, 'lps'),
	(638917, 135, '2015-01-01 00:44:02.000000', 'consum', 0.0219, 'lps'),
	(638918, 135, '2015-01-01 00:44:03.000000', 'consum', 0.0251, 'lps'),
	(638919, 135, '2015-01-01 00:44:04.000000', 'consum', 0.0267, 'lps'),
	(638920, 135, '2015-01-01 00:44:05.000000', 'consum', 0.0247, 'lps'),
	(638921, 135, '2015-01-01 00:44:06.000000', 'consum', 0.0225, 'lps'),
	(638922, 135, '2015-01-01 00:44:07.000000', 'consum', 0.0238, 'lps'),
	(638923, 135, '2015-01-01 00:44:08.000000', 'consum', 0.0244, 'lps'),
	(638924, 135, '2015-01-01 00:44:09.000000', 'consum', 0.0232, 'lps'),
	(638925, 135, '2015-01-01 00:44:10.000000', 'consum', 0.0220, 'lps'),
	(638926, 135, '2015-01-01 00:44:11.000000', 'consum', 0.0257, 'lps'),
	(638927, 135, '2015-01-01 00:44:12.000000', 'consum', 0.0228, 'lps'),
	(638928, 135, '2015-01-01 00:44:13.000000', 'consum', 0.0224, 'lps'),
	(638929, 135, '2015-01-01 00:44:14.000000', 'consum', 0.0224, 'lps'),
	(638930, 135, '2015-01-01 00:44:15.000000', 'consum', 0.0238, 'lps'),
	(638931, 135, '2015-01-01 00:44:16.000000', 'consum', 0.0247, 'lps'),
	(638932, 135, '2015-01-01 00:44:17.000000', 'consum', 0.0250, 'lps'),
	(638933, 135, '2015-01-01 00:44:18.000000', 'consum', 0.0239, 'lps'),
	(638934, 135, '2015-01-01 00:44:19.000000', 'consum', 0.0234, 'lps'),
	(638935, 135, '2015-01-01 00:44:20.000000', 'consum', 0.0243, 'lps'),
	(638936, 135, '2015-01-01 00:44:21.000000', 'consum', 0.0240, 'lps'),
	(638937, 135, '2015-01-01 00:44:22.000000', 'consum', 0.0263, 'lps'),
	(638938, 135, '2015-01-01 00:44:23.000000', 'consum', 0.0262, 'lps'),
	(638939, 135, '2015-01-01 00:44:24.000000', 'consum', 0.0250, 'lps'),
	(638940, 135, '2015-01-01 00:44:25.000000', 'consum', 0.0252, 'lps'),
	(638941, 135, '2015-01-01 00:44:26.000000', 'consum', 0.0240, 'lps'),
	(638942, 135, '2015-01-01 00:44:27.000000', 'consum', 0.0234, 'lps'),
	(638943, 135, '2015-01-01 00:44:28.000000', 'consum', 0.0241, 'lps'),
	(638944, 135, '2015-01-01 00:44:29.000000', 'consum', 0.0230, 'lps'),
	(638945, 135, '2015-01-01 00:44:30.000000', 'consum', 0.0219, 'lps'),
	(638946, 135, '2015-01-01 00:44:31.000000', 'consum', 0.0256, 'lps'),
	(638947, 135, '2015-01-01 00:44:32.000000', 'consum', 0.0229, 'lps'),
	(638948, 135, '2015-01-01 00:44:33.000000', 'consum', 0.0228, 'lps'),
	(638949, 135, '2015-01-01 00:44:34.000000', 'consum', 0.0242, 'lps'),
	(638950, 135, '2015-01-01 00:44:35.000000', 'consum', 0.0257, 'lps'),
	(638951, 135, '2015-01-01 00:44:36.000000', 'consum', 0.0223, 'lps'),
	(638952, 135, '2015-01-01 00:44:37.000000', 'consum', 0.0260, 'lps'),
	(638953, 135, '2015-01-01 00:44:38.000000', 'consum', 0.0235, 'lps'),
	(638954, 135, '2015-01-01 00:44:39.000000', 'consum', 0.0247, 'lps'),
	(638955, 135, '2015-01-01 00:44:40.000000', 'consum', 0.0259, 'lps'),
	(638956, 135, '2015-01-01 00:44:41.000000', 'consum', 0.0221, 'lps'),
	(638957, 135, '2015-01-01 00:44:42.000000', 'consum', 0.0243, 'lps'),
	(638958, 135, '2015-01-01 00:44:43.000000', 'consum', 0.0218, 'lps'),
	(638959, 135, '2015-01-01 00:44:44.000000', 'consum', 0.0212, 'lps'),
	(638960, 135, '2015-01-01 00:44:45.000000', 'consum', 0.0258, 'lps'),
	(638961, 135, '2015-01-01 00:44:46.000000', 'consum', 0.0260, 'lps'),
	(638962, 135, '2015-01-01 00:44:47.000000', 'consum', 0.0254, 'lps'),
	(638963, 135, '2015-01-01 00:44:48.000000', 'consum', 0.0218, 'lps'),
	(638964, 135, '2015-01-01 00:44:49.000000', 'consum', 0.0242, 'lps'),
	(638965, 135, '2015-01-01 00:44:50.000000', 'consum', 0.0224, 'lps'),
	(638966, 135, '2015-01-01 00:44:51.000000', 'consum', 0.0245, 'lps'),
	(638967, 135, '2015-01-01 00:44:52.000000', 'consum', 0.0220, 'lps'),
	(638968, 135, '2015-01-01 00:44:53.000000', 'consum', 0.0216, 'lps'),
	(638969, 135, '2015-01-01 00:44:54.000000', 'consum', 0.0210, 'lps'),
	(638970, 135, '2015-01-01 00:44:55.000000', 'consum', 0.0257, 'lps'),
	(638971, 135, '2015-01-01 00:44:56.000000', 'consum', 0.0259, 'lps'),
	(638972, 135, '2015-01-01 00:44:57.000000', 'consum', 0.0252, 'lps'),
	(638973, 135, '2015-01-01 00:44:58.000000', 'consum', 0.0211, 'lps'),
	(638974, 135, '2015-01-01 00:44:59.000000', 'consum', 0.0213, 'lps'),
	(638975, 135, '2015-01-01 00:45:00.000000', 'consum', 0.0221, 'lps'),
	(638976, 135, '2015-01-01 00:45:01.000000', 'consum', 0.0259, 'lps'),
	(638977, 135, '2015-01-01 00:45:02.000000', 'consum', 0.0238, 'lps'),
	(638978, 135, '2015-01-01 00:45:03.000000', 'consum', 0.0263, 'lps'),
	(638979, 135, '2015-01-01 00:45:04.000000', 'consum', 0.0267, 'lps'),
	(638980, 135, '2015-01-01 00:45:05.000000', 'consum', 0.0211, 'lps'),
	(638981, 135, '2015-01-01 00:45:06.000000', 'consum', 0.0233, 'lps'),
	(638982, 135, '2015-01-01 00:45:07.000000', 'consum', 0.0260, 'lps'),
	(638983, 135, '2015-01-01 00:45:08.000000', 'consum', 0.0269, 'lps'),
	(638984, 135, '2015-01-01 00:45:09.000000', 'consum', 0.0232, 'lps'),
	(638985, 135, '2015-01-01 00:45:10.000000', 'consum', 0.0266, 'lps'),
	(638986, 135, '2015-01-01 00:45:11.000000', 'consum', 0.0237, 'lps'),
	(638987, 135, '2015-01-01 00:45:12.000000', 'consum', 0.0241, 'lps'),
	(638988, 135, '2015-01-01 00:45:13.000000', 'consum', 0.0221, 'lps'),
	(638989, 135, '2015-01-01 00:45:14.000000', 'consum', 0.0235, 'lps'),
	(638990, 135, '2015-01-01 00:45:15.000000', 'consum', 0.0242, 'lps'),
	(638991, 135, '2015-01-01 00:45:16.000000', 'consum', 0.0231, 'lps'),
	(638992, 135, '2015-01-01 00:45:17.000000', 'consum', 0.0220, 'lps'),
	(638993, 135, '2015-01-01 00:45:18.000000', 'consum', 0.0258, 'lps'),
	(638994, 135, '2015-01-01 00:45:19.000000', 'consum', 0.0236, 'lps'),
	(638995, 135, '2015-01-01 00:45:20.000000', 'consum', 0.0257, 'lps'),
	(638996, 135, '2015-01-01 00:45:21.000000', 'consum', 0.0246, 'lps'),
	(638997, 135, '2015-01-01 00:45:22.000000', 'consum', 0.0247, 'lps'),
	(638998, 135, '2015-01-01 00:45:23.000000', 'consum', 0.0225, 'lps'),
	(638999, 135, '2015-01-01 00:45:24.000000', 'consum', 0.0236, 'lps'),
	(639000, 135, '2015-01-01 00:45:25.000000', 'consum', 0.0235, 'lps'),
	(639001, 135, '2015-01-01 00:45:26.000000', 'consum', 0.0257, 'lps'),
	(639002, 135, '2015-01-01 00:45:27.000000', 'consum', 0.0246, 'lps'),
	(639003, 135, '2015-01-01 00:45:28.000000', 'consum', 0.0251, 'lps'),
	(639004, 135, '2015-01-01 00:45:29.000000', 'consum', 0.0245, 'lps'),
	(639005, 135, '2015-01-01 00:45:30.000000', 'consum', 0.0263, 'lps'),
	(639006, 135, '2015-01-01 00:45:31.000000', 'consum', 0.0245, 'lps'),
	(639007, 135, '2015-01-01 00:45:32.000000', 'consum', 0.0226, 'lps'),
	(639008, 135, '2015-01-01 00:45:33.000000', 'consum', 0.0248, 'lps'),
	(639009, 135, '2015-01-01 00:45:34.000000', 'consum', 0.0229, 'lps'),
	(639010, 135, '2015-01-01 00:45:35.000000', 'consum', 0.0252, 'lps'),
	(639011, 135, '2015-01-01 00:45:36.000000', 'consum', 0.0241, 'lps'),
	(639012, 135, '2015-01-01 00:45:37.000000', 'consum', 0.0241, 'lps'),
	(639013, 135, '2015-01-01 00:45:38.000000', 'consum', 0.0210, 'lps'),
	(639014, 135, '2015-01-01 00:45:39.000000', 'consum', 0.0241, 'lps'),
	(639015, 135, '2015-01-01 00:45:40.000000', 'consum', 0.0243, 'lps'),
	(639016, 135, '2015-01-01 00:45:41.000000', 'consum', 0.0221, 'lps'),
	(639017, 135, '2015-01-01 00:45:42.000000', 'consum', 0.0229, 'lps'),
	(639018, 135, '2015-01-01 00:45:43.000000', 'consum', 0.0270, 'lps'),
	(639019, 135, '2015-01-01 00:45:44.000000', 'consum', 0.0271, 'lps'),
	(639020, 135, '2015-01-01 00:45:45.000000', 'consum', 0.0270, 'lps'),
	(639021, 135, '2015-01-01 00:45:46.000000', 'consum', 0.0266, 'lps'),
	(639022, 135, '2015-01-01 00:45:47.000000', 'consum', 0.0248, 'lps'),
	(639023, 135, '2015-01-01 00:45:48.000000', 'consum', 0.0235, 'lps'),
	(639024, 135, '2015-01-01 00:45:49.000000', 'consum', 0.0219, 'lps'),
	(639025, 135, '2015-01-01 00:45:50.000000', 'consum', 0.0242, 'lps'),
	(639026, 135, '2015-01-01 00:45:51.000000', 'consum', 0.0219, 'lps'),
	(639027, 135, '2015-01-01 00:45:52.000000', 'consum', 0.0223, 'lps'),
	(639028, 135, '2015-01-01 00:45:53.000000', 'consum', 0.0249, 'lps'),
	(639029, 135, '2015-01-01 00:45:54.000000', 'consum', 0.0241, 'lps'),
	(639030, 135, '2015-01-01 00:45:55.000000', 'consum', 0.0248, 'lps'),
	(639031, 135, '2015-01-01 00:45:56.000000', 'consum', 0.0246, 'lps'),
	(639032, 135, '2015-01-01 00:45:57.000000', 'consum', 0.0213, 'lps'),
	(639033, 135, '2015-01-01 00:45:58.000000', 'consum', 0.0245, 'lps'),
	(639034, 135, '2015-01-01 00:45:59.000000', 'consum', 0.0250, 'lps'),
	(639035, 135, '2015-01-01 00:46:00.000000', 'consum', 0.0244, 'lps'),
	(639036, 135, '2015-01-01 00:46:01.000000', 'consum', 0.0262, 'lps'),
	(639037, 135, '2015-01-01 00:46:02.000000', 'consum', 0.0243, 'lps'),
	(639038, 135, '2015-01-01 00:46:03.000000', 'consum', 0.0222, 'lps'),
	(639039, 135, '2015-01-01 00:46:04.000000', 'consum', 0.0231, 'lps'),
	(639040, 135, '2015-01-01 00:46:05.000000', 'consum', 0.0217, 'lps'),
	(639041, 135, '2015-01-01 00:46:06.000000', 'consum', 0.0243, 'lps'),
	(639042, 135, '2015-01-01 00:46:07.000000', 'consum', 0.0234, 'lps'),
	(639043, 135, '2015-01-01 00:46:08.000000', 'consum', 0.0231, 'lps'),
	(639044, 135, '2015-01-01 00:46:09.000000', 'consum', 0.0243, 'lps'),
	(639045, 135, '2015-01-01 00:46:10.000000', 'consum', 0.0249, 'lps'),
	(639046, 135, '2015-01-01 00:46:11.000000', 'consum', 0.0245, 'lps'),
	(639047, 135, '2015-01-01 00:46:12.000000', 'consum', 0.0270, 'lps'),
	(639048, 135, '2015-01-01 00:46:13.000000', 'consum', 0.0220, 'lps'),
	(639049, 135, '2015-01-01 00:46:14.000000', 'consum', 0.0266, 'lps'),
	(639050, 135, '2015-01-01 00:46:15.000000', 'consum', 0.0214, 'lps'),
	(639051, 135, '2015-01-01 00:46:16.000000', 'consum', 0.0248, 'lps'),
	(639052, 135, '2015-01-01 00:46:17.000000', 'consum', 0.0265, 'lps'),
	(639053, 135, '2015-01-01 00:46:18.000000', 'consum', 0.0247, 'lps'),
	(639054, 135, '2015-01-01 00:46:19.000000', 'consum', 0.0230, 'lps'),
	(639055, 135, '2015-01-01 00:46:20.000000', 'consum', 0.0260, 'lps'),
	(639056, 135, '2015-01-01 00:46:21.000000', 'consum', 0.0216, 'lps'),
	(639057, 135, '2015-01-01 00:46:22.000000', 'consum', 0.0215, 'lps'),
	(639058, 135, '2015-01-01 00:46:23.000000', 'consum', 0.0218, 'lps'),
	(639059, 135, '2015-01-01 00:46:24.000000', 'consum', 0.0236, 'lps'),
	(639060, 135, '2015-01-01 00:46:25.000000', 'consum', 0.0252, 'lps'),
	(639061, 135, '2015-01-01 00:46:26.000000', 'consum', 0.0220, 'lps'),
	(639062, 135, '2015-01-01 00:46:27.000000', 'consum', 0.0258, 'lps'),
	(639063, 135, '2015-01-01 00:46:28.000000', 'consum', 0.0233, 'lps'),
	(639064, 135, '2015-01-01 00:46:29.000000', 'consum', 0.0243, 'lps'),
	(639065, 135, '2015-01-01 00:46:30.000000', 'consum', 0.0247, 'lps'),
	(639066, 135, '2015-01-01 00:46:31.000000', 'consum', 0.0232, 'lps'),
	(639067, 135, '2015-01-01 00:46:32.000000', 'consum', 0.0211, 'lps'),
	(639068, 135, '2015-01-01 00:46:33.000000', 'consum', 0.0213, 'lps'),
	(639069, 135, '2015-01-01 00:46:34.000000', 'consum', 0.0219, 'lps'),
	(639070, 135, '2015-01-01 00:46:35.000000', 'consum', 0.0250, 'lps'),
	(639071, 135, '2015-01-01 00:46:36.000000', 'consum', 0.0257, 'lps'),
	(639072, 135, '2015-01-01 00:46:37.000000', 'consum', 0.0262, 'lps'),
	(639073, 135, '2015-01-01 00:46:38.000000', 'consum', 0.0271, 'lps'),
	(639074, 135, '2015-01-01 00:46:39.000000', 'consum', 0.0234, 'lps'),
	(639075, 135, '2015-01-01 00:46:40.000000', 'consum', 0.0210, 'lps'),
	(639076, 135, '2015-01-01 00:46:41.000000', 'consum', 0.0261, 'lps'),
	(639077, 135, '2015-01-01 00:46:42.000000', 'consum', 0.0220, 'lps'),
	(639078, 135, '2015-01-01 00:46:43.000000', 'consum', 0.0232, 'lps'),
	(639079, 135, '2015-01-01 00:46:44.000000', 'consum', 0.0225, 'lps'),
	(639080, 135, '2015-01-01 00:46:45.000000', 'consum', 0.0223, 'lps'),
	(639081, 135, '2015-01-01 00:46:46.000000', 'consum', 0.0230, 'lps'),
	(639082, 135, '2015-01-01 00:46:47.000000', 'consum', 0.0269, 'lps'),
	(639083, 135, '2015-01-01 00:46:48.000000', 'consum', 0.0261, 'lps'),
	(639084, 135, '2015-01-01 00:46:49.000000', 'consum', 0.0228, 'lps'),
	(639085, 135, '2015-01-01 00:46:50.000000', 'consum', 0.0210, 'lps'),
	(639086, 135, '2015-01-01 00:46:51.000000', 'consum', 0.0219, 'lps'),
	(639087, 135, '2015-01-01 00:46:52.000000', 'consum', 0.0254, 'lps'),
	(639088, 135, '2015-01-01 00:46:53.000000', 'consum', 0.0220, 'lps'),
	(639089, 135, '2015-01-01 00:46:54.000000', 'consum', 0.0250, 'lps'),
	(639090, 135, '2015-01-01 00:46:55.000000', 'consum', 0.0255, 'lps'),
	(639091, 135, '2015-01-01 00:46:56.000000', 'consum', 0.0257, 'lps'),
	(639092, 135, '2015-01-01 00:46:57.000000', 'consum', 0.0247, 'lps'),
	(639093, 135, '2015-01-01 00:46:58.000000', 'consum', 0.0254, 'lps'),
	(639094, 135, '2015-01-01 00:46:59.000000', 'consum', 0.0258, 'lps'),
	(639095, 135, '2015-01-01 00:47:00.000000', 'consum', 0.0254, 'lps'),
	(639096, 135, '2015-01-01 00:47:01.000000', 'consum', 0.0228, 'lps'),
	(639097, 135, '2015-01-01 00:47:02.000000', 'consum', 0.0227, 'lps'),
	(639098, 135, '2015-01-01 00:47:03.000000', 'consum', 0.0245, 'lps'),
	(639099, 135, '2015-01-01 00:47:04.000000', 'consum', 0.0269, 'lps'),
	(639100, 135, '2015-01-01 00:47:05.000000', 'consum', 0.0218, 'lps'),
	(639101, 135, '2015-01-01 00:47:06.000000', 'consum', 0.0256, 'lps'),
	(639102, 135, '2015-01-01 00:47:07.000000', 'consum', 0.0233, 'lps'),
	(639103, 135, '2015-01-01 00:47:08.000000', 'consum', 0.0249, 'lps'),
	(639104, 135, '2015-01-01 00:47:09.000000', 'consum', 0.0214, 'lps'),
	(639105, 135, '2015-01-01 00:47:10.000000', 'consum', 0.0235, 'lps'),
	(639106, 135, '2015-01-01 00:47:11.000000', 'consum', 0.0264, 'lps'),
	(639107, 135, '2015-01-01 00:47:12.000000', 'consum', 0.0220, 'lps'),
	(639108, 135, '2015-01-01 00:47:13.000000', 'consum', 0.0223, 'lps'),
	(639109, 135, '2015-01-01 00:47:14.000000', 'consum', 0.0245, 'lps'),
	(639110, 135, '2015-01-01 00:47:15.000000', 'consum', 0.0224, 'lps'),
	(639111, 135, '2015-01-01 00:47:16.000000', 'consum', 0.0235, 'lps'),
	(639112, 135, '2015-01-01 00:47:17.000000', 'consum', 0.0231, 'lps'),
	(639113, 135, '2015-01-01 00:47:18.000000', 'consum', 0.0240, 'lps'),
	(639114, 135, '2015-01-01 00:47:19.000000', 'consum', 0.0235, 'lps'),
	(639115, 135, '2015-01-01 00:47:20.000000', 'consum', 0.0247, 'lps'),
	(639116, 135, '2015-01-01 00:47:21.000000', 'consum', 0.0258, 'lps'),
	(639117, 135, '2015-01-01 00:47:22.000000', 'consum', 0.0216, 'lps'),
	(639118, 135, '2015-01-01 00:47:23.000000', 'consum', 0.0221, 'lps'),
	(639119, 135, '2015-01-01 00:47:24.000000', 'consum', 0.0247, 'lps'),
	(639120, 135, '2015-01-01 00:47:25.000000', 'consum', 0.0238, 'lps'),
	(639121, 135, '2015-01-01 00:47:26.000000', 'consum', 0.0238, 'lps'),
	(639122, 135, '2015-01-01 00:47:27.000000', 'consum', 0.0270, 'lps'),
	(639123, 135, '2015-01-01 00:47:28.000000', 'consum', 0.0237, 'lps'),
	(639124, 135, '2015-01-01 00:47:29.000000', 'consum', 0.0230, 'lps'),
	(639125, 135, '2015-01-01 00:47:30.000000', 'consum', 0.0230, 'lps'),
	(639126, 135, '2015-01-01 00:47:31.000000', 'consum', 0.0250, 'lps'),
	(639127, 135, '2015-01-01 00:47:32.000000', 'consum', 0.0225, 'lps'),
	(639128, 135, '2015-01-01 00:47:33.000000', 'consum', 0.0228, 'lps'),
	(639129, 135, '2015-01-01 00:47:34.000000', 'consum', 0.0254, 'lps'),
	(639130, 135, '2015-01-01 00:47:35.000000', 'consum', 0.0255, 'lps'),
	(639131, 135, '2015-01-01 00:47:36.000000', 'consum', 0.0241, 'lps'),
	(639132, 135, '2015-01-01 00:47:37.000000', 'consum', 0.0231, 'lps'),
	(639133, 135, '2015-01-01 00:47:38.000000', 'consum', 0.0220, 'lps'),
	(639134, 135, '2015-01-01 00:47:39.000000', 'consum', 0.0262, 'lps'),
	(639135, 135, '2015-01-01 00:47:40.000000', 'consum', 0.0255, 'lps'),
	(639136, 135, '2015-01-01 00:47:41.000000', 'consum', 0.0214, 'lps'),
	(639137, 135, '2015-01-01 00:47:42.000000', 'consum', 0.0223, 'lps'),
	(639138, 135, '2015-01-01 00:47:43.000000', 'consum', 0.0264, 'lps'),
	(639139, 135, '2015-01-01 00:47:44.000000', 'consum', 0.0255, 'lps'),
	(639140, 135, '2015-01-01 00:47:45.000000', 'consum', 0.0210, 'lps'),
	(639141, 135, '2015-01-01 00:47:46.000000', 'consum', 0.0262, 'lps'),
	(639142, 135, '2015-01-01 00:47:47.000000', 'consum', 0.0223, 'lps'),
	(639143, 135, '2015-01-01 00:47:48.000000', 'consum', 0.0243, 'lps'),
	(639144, 135, '2015-01-01 00:47:49.000000', 'consum', 0.0214, 'lps'),
	(639145, 135, '2015-01-01 00:47:50.000000', 'consum', 0.0254, 'lps'),
	(639146, 135, '2015-01-01 00:47:51.000000', 'consum', 0.0232, 'lps'),
	(639147, 135, '2015-01-01 00:47:52.000000', 'consum', 0.0253, 'lps'),
	(639148, 135, '2015-01-01 00:47:53.000000', 'consum', 0.0233, 'lps'),
	(639149, 135, '2015-01-01 00:47:54.000000', 'consum', 0.0258, 'lps'),
	(639150, 135, '2015-01-01 00:47:55.000000', 'consum', 0.0256, 'lps'),
	(639151, 135, '2015-01-01 00:47:56.000000', 'consum', 0.0238, 'lps'),
	(639152, 135, '2015-01-01 00:47:57.000000', 'consum', 0.0210, 'lps'),
	(639153, 135, '2015-01-01 00:47:58.000000', 'consum', 0.0252, 'lps'),
	(639154, 135, '2015-01-01 00:47:59.000000', 'consum', 0.0233, 'lps'),
	(639155, 135, '2015-01-01 00:48:00.000000', 'consum', 0.0261, 'lps'),
	(639156, 135, '2015-01-01 00:48:01.000000', 'consum', 0.0271, 'lps'),
	(639157, 135, '2015-01-01 00:48:02.000000', 'consum', 0.0241, 'lps'),
	(639158, 135, '2015-01-01 00:48:03.000000', 'consum', 0.0244, 'lps'),
	(639159, 135, '2015-01-01 00:48:04.000000', 'consum', 0.0227, 'lps'),
	(639160, 135, '2015-01-01 00:48:05.000000', 'consum', 0.0254, 'lps'),
	(639161, 135, '2015-01-01 00:48:06.000000', 'consum', 0.0257, 'lps'),
	(639162, 135, '2015-01-01 00:48:07.000000', 'consum', 0.0250, 'lps'),
	(639163, 135, '2015-01-01 00:48:08.000000', 'consum', 0.0268, 'lps'),
	(639164, 135, '2015-01-01 00:48:09.000000', 'consum', 0.0257, 'lps'),
	(639165, 135, '2015-01-01 00:48:10.000000', 'consum', 0.0212, 'lps'),
	(639166, 135, '2015-01-01 00:48:11.000000', 'consum', 0.0264, 'lps'),
	(639167, 135, '2015-01-01 00:48:12.000000', 'consum', 0.0228, 'lps'),
	(639168, 135, '2015-01-01 00:48:13.000000', 'consum', 0.0264, 'lps'),
	(639169, 135, '2015-01-01 00:48:14.000000', 'consum', 0.0237, 'lps'),
	(639170, 135, '2015-01-01 00:48:15.000000', 'consum', 0.0245, 'lps'),
	(639171, 135, '2015-01-01 00:48:16.000000', 'consum', 0.0245, 'lps'),
	(639172, 135, '2015-01-01 00:48:17.000000', 'consum', 0.0217, 'lps'),
	(639173, 135, '2015-01-01 00:48:18.000000', 'consum', 0.0263, 'lps'),
	(639174, 135, '2015-01-01 00:48:19.000000', 'consum', 0.0210, 'lps'),
	(639175, 135, '2015-01-01 00:48:20.000000', 'consum', 0.0235, 'lps'),
	(639176, 135, '2015-01-01 00:48:21.000000', 'consum', 0.0214, 'lps'),
	(639177, 135, '2015-01-01 00:48:22.000000', 'consum', 0.0215, 'lps'),
	(639178, 135, '2015-01-01 00:48:23.000000', 'consum', 0.0226, 'lps'),
	(639179, 135, '2015-01-01 00:48:24.000000', 'consum', 0.0211, 'lps'),
	(639180, 135, '2015-01-01 00:48:25.000000', 'consum', 0.0229, 'lps'),
	(639181, 135, '2015-01-01 00:48:26.000000', 'consum', 0.0242, 'lps'),
	(639182, 135, '2015-01-01 00:48:27.000000', 'consum', 0.0252, 'lps'),
	(639183, 135, '2015-01-01 00:48:28.000000', 'consum', 0.0261, 'lps'),
	(639184, 135, '2015-01-01 00:48:29.000000', 'consum', 0.0218, 'lps'),
	(639185, 135, '2015-01-01 00:48:30.000000', 'consum', 0.0218, 'lps'),
	(639186, 135, '2015-01-01 00:48:31.000000', 'consum', 0.0230, 'lps'),
	(639187, 135, '2015-01-01 00:48:32.000000', 'consum', 0.0221, 'lps'),
	(639188, 135, '2015-01-01 00:48:33.000000', 'consum', 0.0270, 'lps'),
	(639189, 135, '2015-01-01 00:48:34.000000', 'consum', 0.0227, 'lps'),
	(639190, 135, '2015-01-01 00:48:35.000000', 'consum', 0.0242, 'lps'),
	(639191, 135, '2015-01-01 00:48:36.000000', 'consum', 0.0257, 'lps'),
	(639192, 135, '2015-01-01 00:48:37.000000', 'consum', 0.0224, 'lps'),
	(639193, 135, '2015-01-01 00:48:38.000000', 'consum', 0.0265, 'lps'),
	(639194, 135, '2015-01-01 00:48:39.000000', 'consum', 0.0257, 'lps'),
	(639195, 135, '2015-01-01 00:48:40.000000', 'consum', 0.0217, 'lps'),
	(639196, 135, '2015-01-01 00:48:41.000000', 'consum', 0.0228, 'lps'),
	(639197, 135, '2015-01-01 00:48:42.000000', 'consum', 0.0220, 'lps'),
	(639198, 135, '2015-01-01 00:48:43.000000', 'consum', 0.0266, 'lps'),
	(639199, 135, '2015-01-01 00:48:44.000000', 'consum', 0.0214, 'lps'),
	(639200, 135, '2015-01-01 00:48:45.000000', 'consum', 0.0248, 'lps'),
	(639201, 135, '2015-01-01 00:48:46.000000', 'consum', 0.0266, 'lps'),
	(639202, 135, '2015-01-01 00:48:47.000000', 'consum', 0.0253, 'lps'),
	(639203, 135, '2015-01-01 00:48:48.000000', 'consum', 0.0256, 'lps'),
	(639204, 135, '2015-01-01 00:48:49.000000', 'consum', 0.0251, 'lps'),
	(639205, 135, '2015-01-01 00:48:50.000000', 'consum', 0.0214, 'lps'),
	(639206, 135, '2015-01-01 00:48:51.000000', 'consum', 0.0231, 'lps'),
	(639207, 135, '2015-01-01 00:48:52.000000', 'consum', 0.0241, 'lps'),
	(639208, 135, '2015-01-01 00:48:53.000000', 'consum', 0.0240, 'lps'),
	(639209, 135, '2015-01-01 00:48:54.000000', 'consum', 0.0268, 'lps'),
	(639210, 135, '2015-01-01 00:48:55.000000', 'consum', 0.0225, 'lps'),
	(639211, 135, '2015-01-01 00:48:56.000000', 'consum', 0.0237, 'lps'),
	(639212, 135, '2015-01-01 00:48:57.000000', 'consum', 0.0238, 'lps'),
	(639213, 135, '2015-01-01 00:48:58.000000', 'consum', 0.0268, 'lps'),
	(639214, 135, '2015-01-01 00:48:59.000000', 'consum', 0.0233, 'lps'),
	(639215, 135, '2015-01-01 00:49:00.000000', 'consum', 0.0211, 'lps'),
	(639216, 135, '2015-01-01 00:49:01.000000', 'consum', 0.0269, 'lps'),
	(639217, 135, '2015-01-01 00:49:02.000000', 'consum', 0.0258, 'lps'),
	(639218, 135, '2015-01-01 00:49:03.000000', 'consum', 0.0271, 'lps'),
	(639219, 135, '2015-01-01 00:49:04.000000', 'consum', 0.0250, 'lps'),
	(639220, 135, '2015-01-01 00:49:05.000000', 'consum', 0.0227, 'lps'),
	(639221, 135, '2015-01-01 00:49:06.000000', 'consum', 0.0235, 'lps'),
	(639222, 135, '2015-01-01 00:49:07.000000', 'consum', 0.0226, 'lps'),
	(639223, 135, '2015-01-01 00:49:08.000000', 'consum', 0.0212, 'lps'),
	(639224, 135, '2015-01-01 00:49:09.000000', 'consum', 0.0238, 'lps'),
	(639225, 135, '2015-01-01 00:49:10.000000', 'consum', 0.0218, 'lps'),
	(639226, 135, '2015-01-01 00:49:11.000000', 'consum', 0.0228, 'lps'),
	(639227, 135, '2015-01-01 00:49:12.000000', 'consum', 0.0216, 'lps'),
	(639228, 135, '2015-01-01 00:49:13.000000', 'consum', 0.0249, 'lps'),
	(639229, 135, '2015-01-01 00:49:14.000000', 'consum', 0.0263, 'lps'),
	(639230, 135, '2015-01-01 00:49:15.000000', 'consum', 0.0233, 'lps'),
	(639231, 135, '2015-01-01 00:49:16.000000', 'consum', 0.0228, 'lps'),
	(639232, 135, '2015-01-01 00:49:17.000000', 'consum', 0.0234, 'lps'),
	(639233, 135, '2015-01-01 00:49:18.000000', 'consum', 0.0214, 'lps'),
	(639234, 135, '2015-01-01 00:49:19.000000', 'consum', 0.0219, 'lps'),
	(639235, 135, '2015-01-01 00:49:20.000000', 'consum', 0.0245, 'lps'),
	(639236, 135, '2015-01-01 00:49:21.000000', 'consum', 0.0234, 'lps'),
	(639237, 135, '2015-01-01 00:49:22.000000', 'consum', 0.0227, 'lps'),
	(639238, 135, '2015-01-01 00:49:23.000000', 'consum', 0.0221, 'lps'),
	(639239, 135, '2015-01-01 00:49:24.000000', 'consum', 0.0217, 'lps'),
	(639240, 135, '2015-01-01 00:49:25.000000', 'consum', 0.0212, 'lps'),
	(639241, 135, '2015-01-01 00:49:26.000000', 'consum', 0.0262, 'lps'),
	(639242, 135, '2015-01-01 00:49:27.000000', 'consum', 0.0216, 'lps'),
	(639243, 135, '2015-01-01 00:49:28.000000', 'consum', 0.0210, 'lps'),
	(639244, 135, '2015-01-01 00:49:29.000000', 'consum', 0.0254, 'lps'),
	(639245, 135, '2015-01-01 00:49:30.000000', 'consum', 0.0245, 'lps'),
	(639246, 135, '2015-01-01 00:49:31.000000', 'consum', 0.0254, 'lps'),
	(639247, 135, '2015-01-01 00:49:32.000000', 'consum', 0.0261, 'lps'),
	(639248, 135, '2015-01-01 00:49:33.000000', 'consum', 0.0213, 'lps'),
	(639249, 135, '2015-01-01 00:49:34.000000', 'consum', 0.0256, 'lps'),
	(639250, 135, '2015-01-01 00:49:35.000000', 'consum', 0.0245, 'lps'),
	(639251, 135, '2015-01-01 00:49:36.000000', 'consum', 0.0248, 'lps'),
	(639252, 135, '2015-01-01 00:49:37.000000', 'consum', 0.0232, 'lps'),
	(639253, 135, '2015-01-01 00:49:38.000000', 'consum', 0.0270, 'lps'),
	(639254, 135, '2015-01-01 00:49:39.000000', 'consum', 0.0260, 'lps'),
	(639255, 135, '2015-01-01 00:49:40.000000', 'consum', 0.0216, 'lps'),
	(639256, 135, '2015-01-01 00:49:41.000000', 'consum', 0.0217, 'lps'),
	(639257, 135, '2015-01-01 00:49:42.000000', 'consum', 0.0228, 'lps'),
	(639258, 135, '2015-01-01 00:49:43.000000', 'consum', 0.0218, 'lps'),
	(639259, 135, '2015-01-01 00:49:44.000000', 'consum', 0.0255, 'lps'),
	(639260, 135, '2015-01-01 00:49:45.000000', 'consum', 0.0228, 'lps'),
	(639261, 135, '2015-01-01 00:49:46.000000', 'consum', 0.0228, 'lps'),
	(639262, 135, '2015-01-01 00:49:47.000000', 'consum', 0.0246, 'lps'),
	(639263, 135, '2015-01-01 00:49:48.000000', 'consum', 0.0213, 'lps'),
	(639264, 135, '2015-01-01 00:49:49.000000', 'consum', 0.0241, 'lps'),
	(639265, 135, '2015-01-01 00:49:50.000000', 'consum', 0.0234, 'lps'),
	(639266, 135, '2015-01-01 00:49:51.000000', 'consum', 0.0235, 'lps'),
	(639267, 135, '2015-01-01 00:49:52.000000', 'consum', 0.0263, 'lps'),
	(639268, 135, '2015-01-01 00:49:53.000000', 'consum', 0.0215, 'lps'),
	(639269, 135, '2015-01-01 00:49:54.000000', 'consum', 0.0263, 'lps'),
	(639270, 135, '2015-01-01 00:49:55.000000', 'consum', 0.0213, 'lps'),
	(639271, 135, '2015-01-01 00:49:56.000000', 'consum', 0.0253, 'lps'),
	(639272, 135, '2015-01-01 00:49:57.000000', 'consum', 0.0229, 'lps'),
	(639273, 135, '2015-01-01 00:49:58.000000', 'consum', 0.0241, 'lps'),
	(639274, 135, '2015-01-01 00:49:59.000000', 'consum', 0.0243, 'lps'),
	(639275, 135, '2015-01-01 00:50:00.000000', 'consum', 0.0224, 'lps'),
	(639276, 135, '2015-01-01 00:50:01.000000', 'consum', 0.0240, 'lps'),
	(639277, 135, '2015-01-01 00:50:02.000000', 'consum', 0.0259, 'lps'),
	(639278, 135, '2015-01-01 00:50:03.000000', 'consum', 0.0243, 'lps'),
	(639279, 135, '2015-01-01 00:50:04.000000', 'consum', 0.0226, 'lps'),
	(639280, 135, '2015-01-01 00:50:05.000000', 'consum', 0.0254, 'lps'),
	(639281, 135, '2015-01-01 00:50:06.000000', 'consum', 0.0258, 'lps'),
	(639282, 135, '2015-01-01 00:50:07.000000', 'consum', 0.0259, 'lps'),
	(639283, 135, '2015-01-01 00:50:08.000000', 'consum', 0.0247, 'lps'),
	(639284, 135, '2015-01-01 00:50:09.000000', 'consum', 0.0251, 'lps'),
	(639285, 135, '2015-01-01 00:50:10.000000', 'consum', 0.0241, 'lps'),
	(639286, 135, '2015-01-01 00:50:11.000000', 'consum', 0.0243, 'lps'),
	(639287, 135, '2015-01-01 00:50:12.000000', 'consum', 0.0220, 'lps'),
	(639288, 135, '2015-01-01 00:50:13.000000', 'consum', 0.0224, 'lps'),
	(639289, 135, '2015-01-01 00:50:14.000000', 'consum', 0.0248, 'lps'),
	(639290, 135, '2015-01-01 00:50:15.000000', 'consum', 0.0237, 'lps'),
	(639291, 135, '2015-01-01 00:50:16.000000', 'consum', 0.0230, 'lps'),
	(639292, 135, '2015-01-01 00:50:17.000000', 'consum', 0.0231, 'lps'),
	(639293, 135, '2015-01-01 00:50:18.000000', 'consum', 0.0255, 'lps'),
	(639294, 135, '2015-01-01 00:50:19.000000', 'consum', 0.0250, 'lps'),
	(639295, 135, '2015-01-01 00:50:20.000000', 'consum', 0.0213, 'lps'),
	(639296, 135, '2015-01-01 00:50:21.000000', 'consum', 0.0229, 'lps'),
	(639297, 135, '2015-01-01 00:50:22.000000', 'consum', 0.0236, 'lps'),
	(639298, 135, '2015-01-01 00:50:23.000000', 'consum', 0.0221, 'lps'),
	(639299, 135, '2015-01-01 00:50:24.000000', 'consum', 0.0247, 'lps'),
	(639300, 135, '2015-01-01 00:50:25.000000', 'consum', 0.0241, 'lps'),
	(639301, 135, '2015-01-01 00:50:26.000000', 'consum', 0.0253, 'lps'),
	(639302, 135, '2015-01-01 00:50:27.000000', 'consum', 0.0210, 'lps'),
	(639303, 135, '2015-01-01 00:50:28.000000', 'consum', 0.0266, 'lps'),
	(639304, 135, '2015-01-01 00:50:29.000000', 'consum', 0.0242, 'lps'),
	(639305, 135, '2015-01-01 00:50:30.000000', 'consum', 0.0263, 'lps'),
	(639306, 135, '2015-01-01 00:50:31.000000', 'consum', 0.0259, 'lps'),
	(639307, 135, '2015-01-01 00:50:32.000000', 'consum', 0.0232, 'lps'),
	(639308, 135, '2015-01-01 00:50:33.000000', 'consum', 0.0235, 'lps'),
	(639309, 135, '2015-01-01 00:50:34.000000', 'consum', 0.0269, 'lps'),
	(639310, 135, '2015-01-01 00:50:35.000000', 'consum', 0.0246, 'lps'),
	(639311, 135, '2015-01-01 00:50:36.000000', 'consum', 0.0214, 'lps'),
	(639312, 135, '2015-01-01 00:50:37.000000', 'consum', 0.0246, 'lps'),
	(639313, 135, '2015-01-01 00:50:38.000000', 'consum', 0.0254, 'lps'),
	(639314, 135, '2015-01-01 00:50:39.000000', 'consum', 0.0262, 'lps'),
	(639315, 135, '2015-01-01 00:50:40.000000', 'consum', 0.0216, 'lps'),
	(639316, 135, '2015-01-01 00:50:41.000000', 'consum', 0.0268, 'lps'),
	(639317, 135, '2015-01-01 00:50:42.000000', 'consum', 0.0235, 'lps'),
	(639318, 135, '2015-01-01 00:50:43.000000', 'consum', 0.0221, 'lps'),
	(639319, 135, '2015-01-01 00:50:44.000000', 'consum', 0.0256, 'lps'),
	(639320, 135, '2015-01-01 00:50:45.000000', 'consum', 0.0221, 'lps'),
	(639321, 135, '2015-01-01 00:50:46.000000', 'consum', 0.0252, 'lps'),
	(639322, 135, '2015-01-01 00:50:47.000000', 'consum', 0.0264, 'lps'),
	(639323, 135, '2015-01-01 00:50:48.000000', 'consum', 0.0231, 'lps'),
	(639324, 135, '2015-01-01 00:50:49.000000', 'consum', 0.0217, 'lps'),
	(639325, 135, '2015-01-01 00:50:50.000000', 'consum', 0.0241, 'lps'),
	(639326, 135, '2015-01-01 00:50:51.000000', 'consum', 0.0221, 'lps'),
	(639327, 135, '2015-01-01 00:50:52.000000', 'consum', 0.0233, 'lps'),
	(639328, 135, '2015-01-01 00:50:53.000000', 'consum', 0.0232, 'lps'),
	(639329, 135, '2015-01-01 00:50:54.000000', 'consum', 0.0251, 'lps'),
	(639330, 135, '2015-01-01 00:50:55.000000', 'consum', 0.0224, 'lps'),
	(639331, 135, '2015-01-01 00:50:56.000000', 'consum', 0.0221, 'lps'),
	(639332, 135, '2015-01-01 00:50:57.000000', 'consum', 0.0222, 'lps'),
	(639333, 135, '2015-01-01 00:50:58.000000', 'consum', 0.0238, 'lps'),
	(639334, 135, '2015-01-01 00:50:59.000000', 'consum', 0.0254, 'lps'),
	(639335, 135, '2015-01-01 00:51:00.000000', 'consum', 0.0223, 'lps'),
	(639336, 135, '2015-01-01 00:51:01.000000', 'consum', 0.0265, 'lps'),
	(639337, 135, '2015-01-01 00:51:02.000000', 'consum', 0.0260, 'lps'),
	(639338, 135, '2015-01-01 00:51:03.000000', 'consum', 0.0235, 'lps'),
	(639339, 135, '2015-01-01 00:51:04.000000', 'consum', 0.0246, 'lps'),
	(639340, 135, '2015-01-01 00:51:05.000000', 'consum', 0.0256, 'lps'),
	(639341, 135, '2015-01-01 00:51:06.000000', 'consum', 0.0268, 'lps'),
	(639342, 135, '2015-01-01 00:51:07.000000', 'consum', 0.0241, 'lps'),
	(639343, 135, '2015-01-01 00:51:08.000000', 'consum', 0.0253, 'lps'),
	(639344, 135, '2015-01-01 00:51:09.000000', 'consum', 0.0269, 'lps'),
	(639345, 135, '2015-01-01 00:51:10.000000', 'consum', 0.0254, 'lps'),
	(639346, 135, '2015-01-01 00:51:11.000000', 'consum', 0.0254, 'lps'),
	(639347, 135, '2015-01-01 00:51:12.000000', 'consum', 0.0238, 'lps'),
	(639348, 135, '2015-01-01 00:51:13.000000', 'consum', 0.0215, 'lps'),
	(639349, 135, '2015-01-01 00:51:14.000000', 'consum', 0.0215, 'lps'),
	(639350, 135, '2015-01-01 00:51:15.000000', 'consum', 0.0219, 'lps'),
	(639351, 135, '2015-01-01 00:51:16.000000', 'consum', 0.0241, 'lps'),
	(639352, 135, '2015-01-01 00:51:17.000000', 'consum', 0.0216, 'lps'),
	(639353, 135, '2015-01-01 00:51:18.000000', 'consum', 0.0270, 'lps'),
	(639354, 135, '2015-01-01 00:51:19.000000', 'consum', 0.0246, 'lps'),
	(639355, 135, '2015-01-01 00:51:20.000000', 'consum', 0.0210, 'lps'),
	(639356, 135, '2015-01-01 00:51:21.000000', 'consum', 0.0227, 'lps'),
	(639357, 135, '2015-01-01 00:51:22.000000', 'consum', 0.0235, 'lps'),
	(639358, 135, '2015-01-01 00:51:23.000000', 'consum', 0.0221, 'lps'),
	(639359, 135, '2015-01-01 00:51:24.000000', 'consum', 0.0254, 'lps'),
	(639360, 135, '2015-01-01 00:51:25.000000', 'consum', 0.0211, 'lps'),
	(639361, 135, '2015-01-01 00:51:26.000000', 'consum', 0.0269, 'lps'),
	(639362, 135, '2015-01-01 00:51:27.000000', 'consum', 0.0255, 'lps'),
	(639363, 135, '2015-01-01 00:51:28.000000', 'consum', 0.0260, 'lps'),
	(639364, 135, '2015-01-01 00:51:29.000000', 'consum', 0.0262, 'lps'),
	(639365, 135, '2015-01-01 00:51:30.000000', 'consum', 0.0259, 'lps'),
	(639366, 135, '2015-01-01 00:51:31.000000', 'consum', 0.0239, 'lps'),
	(639367, 135, '2015-01-01 00:51:32.000000', 'consum', 0.0271, 'lps'),
	(639368, 135, '2015-01-01 00:51:33.000000', 'consum', 0.0240, 'lps'),
	(639369, 135, '2015-01-01 00:51:34.000000', 'consum', 0.0242, 'lps'),
	(639370, 135, '2015-01-01 00:51:35.000000', 'consum', 0.0219, 'lps'),
	(639371, 135, '2015-01-01 00:51:36.000000', 'consum', 0.0219, 'lps'),
	(639372, 135, '2015-01-01 00:51:37.000000', 'consum', 0.0229, 'lps'),
	(639373, 135, '2015-01-01 00:51:38.000000', 'consum', 0.0219, 'lps'),
	(639374, 135, '2015-01-01 00:51:39.000000', 'consum', 0.0258, 'lps'),
	(639375, 135, '2015-01-01 00:51:40.000000', 'consum', 0.0239, 'lps'),
	(639376, 135, '2015-01-01 00:51:41.000000', 'consum', 0.0271, 'lps'),
	(639377, 135, '2015-01-01 00:51:42.000000', 'consum', 0.0245, 'lps'),
	(639378, 135, '2015-01-01 00:51:43.000000', 'consum', 0.0262, 'lps'),
	(639379, 135, '2015-01-01 00:51:44.000000', 'consum', 0.0243, 'lps'),
	(639380, 135, '2015-01-01 00:51:45.000000', 'consum', 0.0218, 'lps'),
	(639381, 135, '2015-01-01 00:51:46.000000', 'consum', 0.0213, 'lps'),
	(639382, 135, '2015-01-01 00:51:47.000000', 'consum', 0.0264, 'lps'),
	(639383, 135, '2015-01-01 00:51:48.000000', 'consum', 0.0226, 'lps'),
	(639384, 135, '2015-01-01 00:51:49.000000', 'consum', 0.0250, 'lps'),
	(639385, 135, '2015-01-01 00:51:50.000000', 'consum', 0.0238, 'lps'),
	(639386, 135, '2015-01-01 00:51:51.000000', 'consum', 0.0230, 'lps'),
	(639387, 135, '2015-01-01 00:51:52.000000', 'consum', 0.0226, 'lps'),
	(639388, 135, '2015-01-01 00:51:53.000000', 'consum', 0.0230, 'lps'),
	(639389, 135, '2015-01-01 00:51:54.000000', 'consum', 0.0262, 'lps'),
	(639390, 135, '2015-01-01 00:51:55.000000', 'consum', 0.0224, 'lps'),
	(639391, 135, '2015-01-01 00:51:56.000000', 'consum', 0.0249, 'lps'),
	(639392, 135, '2015-01-01 00:51:57.000000', 'consum', 0.0238, 'lps'),
	(639393, 135, '2015-01-01 00:51:58.000000', 'consum', 0.0234, 'lps'),
	(639394, 135, '2015-01-01 00:51:59.000000', 'consum', 0.0247, 'lps'),
	(639395, 135, '2015-01-01 00:52:00.000000', 'consum', 0.0262, 'lps'),
	(639396, 135, '2015-01-01 00:52:01.000000', 'consum', 0.0235, 'lps'),
	(639397, 135, '2015-01-01 00:52:02.000000', 'consum', 0.0240, 'lps'),
	(639398, 135, '2015-01-01 00:52:03.000000', 'consum', 0.0226, 'lps'),
	(639399, 135, '2015-01-01 00:52:04.000000', 'consum', 0.0261, 'lps'),
	(639400, 135, '2015-01-01 00:52:05.000000', 'consum', 0.0231, 'lps'),
	(639401, 135, '2015-01-01 00:52:06.000000', 'consum', 0.0224, 'lps'),
	(639402, 135, '2015-01-01 00:52:07.000000', 'consum', 0.0218, 'lps'),
	(639403, 135, '2015-01-01 00:52:08.000000', 'consum', 0.0210, 'lps'),
	(639404, 135, '2015-01-01 00:52:09.000000', 'consum', 0.0246, 'lps'),
	(639405, 135, '2015-01-01 00:52:10.000000', 'consum', 0.0269, 'lps'),
	(639406, 135, '2015-01-01 00:52:11.000000', 'consum', 0.0271, 'lps'),
	(639407, 135, '2015-01-01 00:52:12.000000', 'consum', 0.0218, 'lps'),
	(639408, 135, '2015-01-01 00:52:13.000000', 'consum', 0.0250, 'lps'),
	(639409, 135, '2015-01-01 00:52:14.000000', 'consum', 0.0264, 'lps'),
	(639410, 135, '2015-01-01 00:52:15.000000', 'consum', 0.0236, 'lps'),
	(639411, 135, '2015-01-01 00:52:16.000000', 'consum', 0.0239, 'lps'),
	(639412, 135, '2015-01-01 00:52:17.000000', 'consum', 0.0216, 'lps'),
	(639413, 135, '2015-01-01 00:52:18.000000', 'consum', 0.0215, 'lps'),
	(639414, 135, '2015-01-01 00:52:19.000000', 'consum', 0.0217, 'lps'),
	(639415, 135, '2015-01-01 00:52:20.000000', 'consum', 0.0231, 'lps'),
	(639416, 135, '2015-01-01 00:52:21.000000', 'consum', 0.0235, 'lps'),
	(639417, 135, '2015-01-01 00:52:22.000000', 'consum', 0.0270, 'lps'),
	(639418, 135, '2015-01-01 00:52:23.000000', 'consum', 0.0251, 'lps'),
	(639419, 135, '2015-01-01 00:52:24.000000', 'consum', 0.0236, 'lps'),
	(639420, 135, '2015-01-01 00:52:25.000000', 'consum', 0.0216, 'lps'),
	(639421, 135, '2015-01-01 00:52:26.000000', 'consum', 0.0223, 'lps'),
	(639422, 135, '2015-01-01 00:52:27.000000', 'consum', 0.0259, 'lps'),
	(639423, 135, '2015-01-01 00:52:28.000000', 'consum', 0.0228, 'lps'),
	(639424, 135, '2015-01-01 00:52:29.000000', 'consum', 0.0218, 'lps'),
	(639425, 135, '2015-01-01 00:52:30.000000', 'consum', 0.0260, 'lps'),
	(639426, 135, '2015-01-01 00:52:31.000000', 'consum', 0.0249, 'lps'),
	(639427, 135, '2015-01-01 00:52:32.000000', 'consum', 0.0255, 'lps'),
	(639428, 135, '2015-01-01 00:52:33.000000', 'consum', 0.0256, 'lps'),
	(639429, 135, '2015-01-01 00:52:34.000000', 'consum', 0.0245, 'lps'),
	(639430, 135, '2015-01-01 00:52:35.000000', 'consum', 0.0247, 'lps'),
	(639431, 135, '2015-01-01 00:52:36.000000', 'consum', 0.0229, 'lps'),
	(639432, 135, '2015-01-01 00:52:37.000000', 'consum', 0.0257, 'lps'),
	(639433, 135, '2015-01-01 00:52:38.000000', 'consum', 0.0263, 'lps'),
	(639434, 135, '2015-01-01 00:52:39.000000', 'consum', 0.0212, 'lps'),
	(639435, 135, '2015-01-01 00:52:40.000000', 'consum', 0.0247, 'lps'),
	(639436, 135, '2015-01-01 00:52:41.000000', 'consum', 0.0266, 'lps'),
	(639437, 135, '2015-01-01 00:52:42.000000', 'consum', 0.0256, 'lps'),
	(639438, 135, '2015-01-01 00:52:43.000000', 'consum', 0.0212, 'lps'),
	(639439, 135, '2015-01-01 00:52:44.000000', 'consum', 0.0267, 'lps'),
	(639440, 135, '2015-01-01 00:52:45.000000', 'consum', 0.0240, 'lps'),
	(639441, 135, '2015-01-01 00:52:46.000000', 'consum', 0.0252, 'lps'),
	(639442, 135, '2015-01-01 00:52:47.000000', 'consum', 0.0270, 'lps'),
	(639443, 135, '2015-01-01 00:52:48.000000', 'consum', 0.0258, 'lps'),
	(639444, 135, '2015-01-01 00:52:49.000000', 'consum', 0.0211, 'lps'),
	(639445, 135, '2015-01-01 00:52:50.000000', 'consum', 0.0256, 'lps'),
	(639446, 135, '2015-01-01 00:52:51.000000', 'consum', 0.0252, 'lps'),
	(639447, 135, '2015-01-01 00:52:52.000000', 'consum', 0.0222, 'lps'),
	(639448, 135, '2015-01-01 00:52:53.000000', 'consum', 0.0267, 'lps'),
	(639449, 135, '2015-01-01 00:52:54.000000', 'consum', 0.0211, 'lps'),
	(639450, 135, '2015-01-01 00:52:55.000000', 'consum', 0.0232, 'lps'),
	(639451, 135, '2015-01-01 00:52:56.000000', 'consum', 0.0257, 'lps'),
	(639452, 135, '2015-01-01 00:52:57.000000', 'consum', 0.0254, 'lps'),
	(639453, 135, '2015-01-01 00:52:58.000000', 'consum', 0.0227, 'lps'),
	(639454, 135, '2015-01-01 00:52:59.000000', 'consum', 0.0224, 'lps'),
	(639455, 135, '2015-01-01 00:53:00.000000', 'consum', 0.0232, 'lps'),
	(639456, 135, '2015-01-01 00:53:01.000000', 'consum', 0.0218, 'lps'),
	(639457, 135, '2015-01-01 00:53:02.000000', 'consum', 0.0244, 'lps'),
	(639458, 135, '2015-01-01 00:53:03.000000', 'consum', 0.0231, 'lps'),
	(639459, 135, '2015-01-01 00:53:04.000000', 'consum', 0.0215, 'lps'),
	(639460, 135, '2015-01-01 00:53:05.000000', 'consum', 0.0234, 'lps'),
	(639461, 135, '2015-01-01 00:53:06.000000', 'consum', 0.0254, 'lps'),
	(639462, 135, '2015-01-01 00:53:07.000000', 'consum', 0.0236, 'lps'),
	(639463, 135, '2015-01-01 00:53:08.000000', 'consum', 0.0271, 'lps'),
	(639464, 135, '2015-01-01 00:53:09.000000', 'consum', 0.0250, 'lps'),
	(639465, 135, '2015-01-01 00:53:10.000000', 'consum', 0.0228, 'lps'),
	(639466, 135, '2015-01-01 00:53:11.000000', 'consum', 0.0243, 'lps'),
	(639467, 135, '2015-01-01 00:53:12.000000', 'consum', 0.0259, 'lps'),
	(639468, 135, '2015-01-01 00:53:13.000000', 'consum', 0.0234, 'lps'),
	(639469, 135, '2015-01-01 00:53:14.000000', 'consum', 0.0243, 'lps'),
	(639470, 135, '2015-01-01 00:53:15.000000', 'consum', 0.0244, 'lps'),
	(639471, 135, '2015-01-01 00:53:16.000000', 'consum', 0.0219, 'lps'),
	(639472, 135, '2015-01-01 00:53:17.000000', 'consum', 0.0214, 'lps'),
	(639473, 135, '2015-01-01 00:53:18.000000', 'consum', 0.0266, 'lps'),
	(639474, 135, '2015-01-01 00:53:19.000000', 'consum', 0.0229, 'lps'),
	(639475, 135, '2015-01-01 00:53:20.000000', 'consum', 0.0262, 'lps'),
	(639476, 135, '2015-01-01 00:53:21.000000', 'consum', 0.0226, 'lps'),
	(639477, 135, '2015-01-01 00:53:22.000000', 'consum', 0.0260, 'lps'),
	(639478, 135, '2015-01-01 00:53:23.000000', 'consum', 0.0227, 'lps'),
	(639479, 135, '2015-01-01 00:53:24.000000', 'consum', 0.0268, 'lps'),
	(639480, 135, '2015-01-01 00:53:25.000000', 'consum', 0.0265, 'lps'),
	(639481, 135, '2015-01-01 00:53:26.000000', 'consum', 0.0248, 'lps'),
	(639482, 135, '2015-01-01 00:53:27.000000', 'consum', 0.0237, 'lps'),
	(639483, 135, '2015-01-01 00:53:28.000000', 'consum', 0.0229, 'lps'),
	(639484, 135, '2015-01-01 00:53:29.000000', 'consum', 0.0228, 'lps'),
	(639485, 135, '2015-01-01 00:53:30.000000', 'consum', 0.0241, 'lps'),
	(639486, 135, '2015-01-01 00:53:31.000000', 'consum', 0.0252, 'lps'),
	(639487, 135, '2015-01-01 00:53:32.000000', 'consum', 0.0265, 'lps'),
	(639488, 135, '2015-01-01 00:53:33.000000', 'consum', 0.0235, 'lps'),
	(639489, 135, '2015-01-01 00:53:34.000000', 'consum', 0.0233, 'lps'),
	(639490, 135, '2015-01-01 00:53:35.000000', 'consum', 0.0249, 'lps'),
	(639491, 135, '2015-01-01 00:53:36.000000', 'consum', 0.0214, 'lps'),
	(639492, 135, '2015-01-01 00:53:37.000000', 'consum', 0.0236, 'lps'),
	(639493, 135, '2015-01-01 00:53:38.000000', 'consum', 0.0267, 'lps'),
	(639494, 135, '2015-01-01 00:53:39.000000', 'consum', 0.0231, 'lps'),
	(639495, 135, '2015-01-01 00:53:40.000000', 'consum', 0.0269, 'lps'),
	(639496, 135, '2015-01-01 00:53:41.000000', 'consum', 0.0256, 'lps'),
	(639497, 135, '2015-01-01 00:53:42.000000', 'consum', 0.0264, 'lps'),
	(639498, 135, '2015-01-01 00:53:43.000000', 'consum', 0.0220, 'lps'),
	(639499, 135, '2015-01-01 00:53:44.000000', 'consum', 0.0223, 'lps'),
	(639500, 135, '2015-01-01 00:53:45.000000', 'consum', 0.0244, 'lps'),
	(639501, 135, '2015-01-01 00:53:46.000000', 'consum', 0.0217, 'lps'),
	(639502, 135, '2015-01-01 00:53:47.000000', 'consum', 0.0267, 'lps'),
	(639503, 135, '2015-01-01 00:53:48.000000', 'consum', 0.0226, 'lps'),
	(639504, 135, '2015-01-01 00:53:49.000000', 'consum', 0.0244, 'lps'),
	(639505, 135, '2015-01-01 00:53:50.000000', 'consum', 0.0271, 'lps'),
	(639506, 135, '2015-01-01 00:53:51.000000', 'consum', 0.0226, 'lps'),
	(639507, 135, '2015-01-01 00:53:52.000000', 'consum', 0.0231, 'lps'),
	(639508, 135, '2015-01-01 00:53:53.000000', 'consum', 0.0270, 'lps'),
	(639509, 135, '2015-01-01 00:53:54.000000', 'consum', 0.0260, 'lps'),
	(639510, 135, '2015-01-01 00:53:55.000000', 'consum', 0.0220, 'lps'),
	(639511, 135, '2015-01-01 00:53:56.000000', 'consum', 0.0235, 'lps'),
	(639512, 135, '2015-01-01 00:53:57.000000', 'consum', 0.0244, 'lps'),
	(639513, 135, '2015-01-01 00:53:58.000000', 'consum', 0.0241, 'lps'),
	(639514, 135, '2015-01-01 00:53:59.000000', 'consum', 0.0263, 'lps'),
	(639515, 135, '2015-01-01 00:54:00.000000', 'consum', 0.0260, 'lps'),
	(639516, 135, '2015-01-01 00:54:01.000000', 'consum', 0.0240, 'lps'),
	(639517, 135, '2015-01-01 00:54:02.000000', 'consum', 0.0210, 'lps'),
	(639518, 135, '2015-01-01 00:54:03.000000', 'consum', 0.0243, 'lps'),
	(639519, 135, '2015-01-01 00:54:04.000000', 'consum', 0.0254, 'lps'),
	(639520, 135, '2015-01-01 00:54:05.000000', 'consum', 0.0270, 'lps'),
	(639521, 135, '2015-01-01 00:54:06.000000', 'consum', 0.0255, 'lps'),
	(639522, 135, '2015-01-01 00:54:07.000000', 'consum', 0.0255, 'lps'),
	(639523, 135, '2015-01-01 00:54:08.000000', 'consum', 0.0238, 'lps'),
	(639524, 135, '2015-01-01 00:54:09.000000', 'consum', 0.0215, 'lps'),
	(639525, 135, '2015-01-01 00:54:10.000000', 'consum', 0.0214, 'lps'),
	(639526, 135, '2015-01-01 00:54:11.000000', 'consum', 0.0215, 'lps'),
	(639527, 135, '2015-01-01 00:54:12.000000', 'consum', 0.0226, 'lps'),
	(639528, 135, '2015-01-01 00:54:13.000000', 'consum', 0.0211, 'lps'),
	(639529, 135, '2015-01-01 00:54:14.000000', 'consum', 0.0232, 'lps'),
	(639530, 135, '2015-01-01 00:54:15.000000', 'consum', 0.0254, 'lps'),
	(639531, 135, '2015-01-01 00:54:16.000000', 'consum', 0.0243, 'lps'),
	(639532, 135, '2015-01-01 00:54:17.000000', 'consum', 0.0241, 'lps'),
	(639533, 135, '2015-01-01 00:54:18.000000', 'consum', 0.0267, 'lps'),
	(639534, 135, '2015-01-01 00:54:19.000000', 'consum', 0.0215, 'lps'),
	(639535, 135, '2015-01-01 00:54:20.000000', 'consum', 0.0250, 'lps'),
	(639536, 135, '2015-01-01 00:54:21.000000', 'consum', 0.0271, 'lps'),
	(639537, 135, '2015-01-01 00:54:22.000000', 'consum', 0.0210, 'lps'),
	(639538, 135, '2015-01-01 00:54:23.000000', 'consum', 0.0216, 'lps'),
	(639539, 135, '2015-01-01 00:54:24.000000', 'consum', 0.0238, 'lps'),
	(639540, 135, '2015-01-01 00:54:25.000000', 'consum', 0.0210, 'lps'),
	(639541, 135, '2015-01-01 00:54:26.000000', 'consum', 0.0251, 'lps'),
	(639542, 135, '2015-01-01 00:54:27.000000', 'consum', 0.0227, 'lps'),
	(639543, 135, '2015-01-01 00:54:28.000000', 'consum', 0.0237, 'lps'),
	(639544, 135, '2015-01-01 00:54:29.000000', 'consum', 0.0233, 'lps'),
	(639545, 135, '2015-01-01 00:54:30.000000', 'consum', 0.0242, 'lps'),
	(639546, 135, '2015-01-01 00:54:31.000000', 'consum', 0.0241, 'lps'),
	(639547, 135, '2015-01-01 00:54:32.000000', 'consum', 0.0271, 'lps'),
	(639548, 135, '2015-01-01 00:54:33.000000', 'consum', 0.0234, 'lps'),
	(639549, 135, '2015-01-01 00:54:34.000000', 'consum', 0.0212, 'lps'),
	(639550, 135, '2015-01-01 00:54:35.000000', 'consum', 0.0270, 'lps'),
	(639551, 135, '2015-01-01 00:54:36.000000', 'consum', 0.0258, 'lps'),
	(639552, 135, '2015-01-01 00:54:37.000000', 'consum', 0.0269, 'lps'),
	(639553, 135, '2015-01-01 00:54:38.000000', 'consum', 0.0238, 'lps'),
	(639554, 135, '2015-01-01 00:54:39.000000', 'consum', 0.0236, 'lps'),
	(639555, 135, '2015-01-01 00:54:40.000000', 'consum', 0.0257, 'lps'),
	(639556, 135, '2015-01-01 00:54:41.000000', 'consum', 0.0245, 'lps'),
	(639557, 135, '2015-01-01 00:54:42.000000', 'consum', 0.0243, 'lps'),
	(639558, 135, '2015-01-01 00:54:43.000000', 'consum', 0.0210, 'lps'),
	(639559, 135, '2015-01-01 00:54:44.000000', 'consum', 0.0233, 'lps'),
	(639560, 135, '2015-01-01 00:54:45.000000', 'consum', 0.0264, 'lps'),
	(639561, 135, '2015-01-01 00:54:46.000000', 'consum', 0.0227, 'lps'),
	(639562, 135, '2015-01-01 00:54:47.000000', 'consum', 0.0255, 'lps'),
	(639563, 135, '2015-01-01 00:54:48.000000', 'consum', 0.0263, 'lps'),
	(639564, 135, '2015-01-01 00:54:49.000000', 'consum', 0.0216, 'lps'),
	(639565, 135, '2015-01-01 00:54:50.000000', 'consum', 0.0267, 'lps'),
	(639566, 135, '2015-01-01 00:54:51.000000', 'consum', 0.0231, 'lps'),
	(639567, 135, '2015-01-01 00:54:52.000000', 'consum', 0.0268, 'lps'),
	(639568, 135, '2015-01-01 00:54:53.000000', 'consum', 0.0253, 'lps'),
	(639569, 135, '2015-01-01 00:54:54.000000', 'consum', 0.0250, 'lps'),
	(639570, 135, '2015-01-01 00:54:55.000000', 'consum', 0.0220, 'lps'),
	(639571, 135, '2015-01-01 00:54:56.000000', 'consum', 0.0266, 'lps'),
	(639572, 135, '2015-01-01 00:54:57.000000', 'consum', 0.0210, 'lps'),
	(639573, 135, '2015-01-01 00:54:58.000000', 'consum', 0.0228, 'lps'),
	(639574, 135, '2015-01-01 00:54:59.000000', 'consum', 0.0238, 'lps'),
	(639575, 135, '2015-01-01 00:55:00.000000', 'consum', 0.0235, 'lps'),
	(639576, 135, '2015-01-01 00:55:01.000000', 'consum', 0.0251, 'lps'),
	(639577, 135, '2015-01-01 00:55:02.000000', 'consum', 0.0216, 'lps'),
	(639578, 135, '2015-01-01 00:55:03.000000', 'consum', 0.0241, 'lps'),
	(639579, 135, '2015-01-01 00:55:04.000000', 'consum', 0.0226, 'lps'),
	(639580, 135, '2015-01-01 00:55:05.000000', 'consum', 0.0257, 'lps'),
	(639581, 135, '2015-01-01 00:55:06.000000', 'consum', 0.0211, 'lps'),
	(639582, 135, '2015-01-01 00:55:07.000000', 'consum', 0.0263, 'lps'),
	(639583, 135, '2015-01-01 00:55:08.000000', 'consum', 0.0222, 'lps'),
	(639584, 135, '2015-01-01 00:55:09.000000', 'consum', 0.0238, 'lps'),
	(639585, 135, '2015-01-01 00:55:10.000000', 'consum', 0.0253, 'lps'),
	(639586, 135, '2015-01-01 00:55:11.000000', 'consum', 0.0215, 'lps'),
	(639587, 135, '2015-01-01 00:55:12.000000', 'consum', 0.0229, 'lps'),
	(639588, 135, '2015-01-01 00:55:13.000000', 'consum', 0.0232, 'lps'),
	(639589, 135, '2015-01-01 00:55:14.000000', 'consum', 0.0263, 'lps'),
	(639590, 135, '2015-01-01 00:55:15.000000', 'consum', 0.0222, 'lps'),
	(639591, 135, '2015-01-01 00:55:16.000000', 'consum', 0.0238, 'lps'),
	(639592, 135, '2015-01-01 00:55:17.000000', 'consum', 0.0250, 'lps'),
	(639593, 135, '2015-01-01 00:55:18.000000', 'consum', 0.0265, 'lps'),
	(639594, 135, '2015-01-01 00:55:19.000000', 'consum', 0.0243, 'lps'),
	(639595, 135, '2015-01-01 00:55:20.000000', 'consum', 0.0211, 'lps'),
	(639596, 135, '2015-01-01 00:55:21.000000', 'consum', 0.0238, 'lps'),
	(639597, 135, '2015-01-01 00:55:22.000000', 'consum', 0.0224, 'lps'),
	(639598, 135, '2015-01-01 00:55:23.000000', 'consum', 0.0259, 'lps'),
	(639599, 135, '2015-01-01 00:55:24.000000', 'consum', 0.0226, 'lps'),
	(639600, 135, '2015-01-01 00:55:25.000000', 'consum', 0.0268, 'lps'),
	(639601, 135, '2015-01-01 00:55:26.000000', 'consum', 0.0269, 'lps'),
	(639602, 135, '2015-01-01 00:55:27.000000', 'consum', 0.0268, 'lps'),
	(639603, 135, '2015-01-01 00:55:28.000000', 'consum', 0.0261, 'lps'),
	(639604, 135, '2015-01-01 00:55:29.000000', 'consum', 0.0231, 'lps'),
	(639605, 135, '2015-01-01 00:55:30.000000', 'consum', 0.0222, 'lps'),
	(639606, 135, '2015-01-01 00:55:31.000000', 'consum', 0.0269, 'lps'),
	(639607, 135, '2015-01-01 00:55:32.000000', 'consum', 0.0222, 'lps'),
	(639608, 135, '2015-01-01 00:55:33.000000', 'consum', 0.0217, 'lps'),
	(639609, 135, '2015-01-01 00:55:34.000000', 'consum', 0.0270, 'lps'),
	(639610, 135, '2015-01-01 00:55:35.000000', 'consum', 0.0244, 'lps'),
	(639611, 135, '2015-01-01 00:55:36.000000', 'consum', 0.0262, 'lps'),
	(639612, 135, '2015-01-01 00:55:37.000000', 'consum', 0.0245, 'lps'),
	(639613, 135, '2015-01-01 00:55:38.000000', 'consum', 0.0230, 'lps'),
	(639614, 135, '2015-01-01 00:55:39.000000', 'consum', 0.0267, 'lps'),
	(639615, 135, '2015-01-01 00:55:40.000000', 'consum', 0.0249, 'lps'),
	(639616, 135, '2015-01-01 00:55:41.000000', 'consum', 0.0237, 'lps'),
	(639617, 135, '2015-01-01 00:55:42.000000', 'consum', 0.0225, 'lps'),
	(639618, 135, '2015-01-01 00:55:43.000000', 'consum', 0.0269, 'lps'),
	(639619, 135, '2015-01-01 00:55:44.000000', 'consum', 0.0213, 'lps'),
	(639620, 135, '2015-01-01 00:55:45.000000', 'consum', 0.0234, 'lps'),
	(639621, 135, '2015-01-01 00:55:46.000000', 'consum', 0.0258, 'lps'),
	(639622, 135, '2015-01-01 00:55:47.000000', 'consum', 0.0254, 'lps'),
	(639623, 135, '2015-01-01 00:55:48.000000', 'consum', 0.0227, 'lps'),
	(639624, 135, '2015-01-01 00:55:49.000000', 'consum', 0.0224, 'lps'),
	(639625, 135, '2015-01-01 00:55:50.000000', 'consum', 0.0228, 'lps'),
	(639626, 135, '2015-01-01 00:55:51.000000', 'consum', 0.0261, 'lps'),
	(639627, 135, '2015-01-01 00:55:52.000000', 'consum', 0.0222, 'lps'),
	(639628, 135, '2015-01-01 00:55:53.000000', 'consum', 0.0245, 'lps'),
	(639629, 135, '2015-01-01 00:55:54.000000', 'consum', 0.0226, 'lps'),
	(639630, 135, '2015-01-01 00:55:55.000000', 'consum', 0.0247, 'lps'),
	(639631, 135, '2015-01-01 00:55:56.000000', 'consum', 0.0221, 'lps'),
	(639632, 135, '2015-01-01 00:55:57.000000', 'consum', 0.0219, 'lps'),
	(639633, 135, '2015-01-01 00:55:58.000000', 'consum', 0.0223, 'lps'),
	(639634, 135, '2015-01-01 00:55:59.000000', 'consum', 0.0248, 'lps'),
	(639635, 135, '2015-01-01 00:56:00.000000', 'consum', 0.0237, 'lps'),
	(639636, 135, '2015-01-01 00:56:01.000000', 'consum', 0.0234, 'lps'),
	(639637, 135, '2015-01-01 00:56:02.000000', 'consum', 0.0247, 'lps'),
	(639638, 135, '2015-01-01 00:56:03.000000', 'consum', 0.0262, 'lps'),
	(639639, 135, '2015-01-01 00:56:04.000000', 'consum', 0.0237, 'lps'),
	(639640, 135, '2015-01-01 00:56:05.000000', 'consum', 0.0250, 'lps'),
	(639641, 135, '2015-01-01 00:56:06.000000', 'consum', 0.0269, 'lps'),
	(639642, 135, '2015-01-01 00:56:07.000000', 'consum', 0.0261, 'lps'),
	(639643, 135, '2015-01-01 00:56:08.000000', 'consum', 0.0225, 'lps'),
	(639644, 135, '2015-01-01 00:56:09.000000', 'consum', 0.0257, 'lps'),
	(639645, 135, '2015-01-01 00:56:10.000000', 'consum', 0.0215, 'lps'),
	(639646, 135, '2015-01-01 00:56:11.000000', 'consum', 0.0220, 'lps'),
	(639647, 135, '2015-01-01 00:56:12.000000', 'consum', 0.0243, 'lps'),
	(639648, 135, '2015-01-01 00:56:13.000000', 'consum', 0.0224, 'lps'),
	(639649, 135, '2015-01-01 00:56:14.000000', 'consum', 0.0242, 'lps'),
	(639650, 135, '2015-01-01 00:56:15.000000', 'consum', 0.0268, 'lps'),
	(639651, 135, '2015-01-01 00:56:16.000000', 'consum', 0.0217, 'lps'),
	(639652, 135, '2015-01-01 00:56:17.000000', 'consum', 0.0258, 'lps'),
	(639653, 135, '2015-01-01 00:56:18.000000', 'consum', 0.0244, 'lps'),
	(639654, 135, '2015-01-01 00:56:19.000000', 'consum', 0.0237, 'lps'),
	(639655, 135, '2015-01-01 00:56:20.000000', 'consum', 0.0241, 'lps'),
	(639656, 135, '2015-01-01 00:56:21.000000', 'consum', 0.0224, 'lps'),
	(639657, 135, '2015-01-01 00:56:22.000000', 'consum', 0.0251, 'lps'),
	(639658, 135, '2015-01-01 00:56:23.000000', 'consum', 0.0248, 'lps'),
	(639659, 135, '2015-01-01 00:56:24.000000', 'consum', 0.0215, 'lps'),
	(639660, 135, '2015-01-01 00:56:25.000000', 'consum', 0.0247, 'lps'),
	(639661, 135, '2015-01-01 00:56:26.000000', 'consum', 0.0256, 'lps'),
	(639662, 135, '2015-01-01 00:56:27.000000', 'consum', 0.0268, 'lps'),
	(639663, 135, '2015-01-01 00:56:28.000000', 'consum', 0.0238, 'lps'),
	(639664, 135, '2015-01-01 00:56:29.000000', 'consum', 0.0240, 'lps'),
	(639665, 135, '2015-01-01 00:56:30.000000', 'consum', 0.0215, 'lps'),
	(639666, 135, '2015-01-01 00:56:31.000000', 'consum', 0.0269, 'lps'),
	(639667, 135, '2015-01-01 00:56:32.000000', 'consum', 0.0244, 'lps'),
	(639668, 135, '2015-01-01 00:56:33.000000', 'consum', 0.0263, 'lps'),
	(639669, 135, '2015-01-01 00:56:34.000000', 'consum', 0.0250, 'lps'),
	(639670, 135, '2015-01-01 00:56:35.000000', 'consum', 0.0251, 'lps'),
	(639671, 135, '2015-01-01 00:56:36.000000', 'consum', 0.0233, 'lps'),
	(639672, 135, '2015-01-01 00:56:37.000000', 'consum', 0.0266, 'lps'),
	(639673, 135, '2015-01-01 00:56:38.000000', 'consum', 0.0233, 'lps'),
	(639674, 135, '2015-01-01 00:56:39.000000', 'consum', 0.0221, 'lps'),
	(639675, 135, '2015-01-01 00:56:40.000000', 'consum', 0.0260, 'lps'),
	(639676, 135, '2015-01-01 00:56:41.000000', 'consum', 0.0239, 'lps'),
	(639677, 135, '2015-01-01 00:56:42.000000', 'consum', 0.0267, 'lps'),
	(639678, 135, '2015-01-01 00:56:43.000000', 'consum', 0.0226, 'lps'),
	(639679, 135, '2015-01-01 00:56:44.000000', 'consum', 0.0240, 'lps'),
	(639680, 135, '2015-01-01 00:56:45.000000', 'consum', 0.0251, 'lps'),
	(639681, 135, '2015-01-01 00:56:46.000000', 'consum', 0.0265, 'lps'),
	(639682, 135, '2015-01-01 00:56:47.000000', 'consum', 0.0238, 'lps'),
	(639683, 135, '2015-01-01 00:56:48.000000', 'consum', 0.0246, 'lps'),
	(639684, 135, '2015-01-01 00:56:49.000000', 'consum', 0.0247, 'lps'),
	(639685, 135, '2015-01-01 00:56:50.000000', 'consum', 0.0226, 'lps'),
	(639686, 135, '2015-01-01 00:56:51.000000', 'consum', 0.0238, 'lps'),
	(639687, 135, '2015-01-01 00:56:52.000000', 'consum', 0.0244, 'lps'),
	(639688, 135, '2015-01-01 00:56:53.000000', 'consum', 0.0232, 'lps'),
	(639689, 135, '2015-01-01 00:56:54.000000', 'consum', 0.0220, 'lps'),
	(639690, 135, '2015-01-01 00:56:55.000000', 'consum', 0.0255, 'lps'),
	(639691, 135, '2015-01-01 00:56:56.000000', 'consum', 0.0222, 'lps'),
	(639692, 135, '2015-01-01 00:56:57.000000', 'consum', 0.0258, 'lps'),
	(639693, 135, '2015-01-01 00:56:58.000000', 'consum', 0.0227, 'lps'),
	(639694, 135, '2015-01-01 00:56:59.000000', 'consum', 0.0216, 'lps'),
	(639695, 135, '2015-01-01 00:57:00.000000', 'consum', 0.0249, 'lps'),
	(639696, 135, '2015-01-01 00:57:01.000000', 'consum', 0.0266, 'lps'),
	(639697, 135, '2015-01-01 00:57:02.000000', 'consum', 0.0250, 'lps'),
	(639698, 135, '2015-01-01 00:57:03.000000', 'consum', 0.0240, 'lps'),
	(639699, 135, '2015-01-01 00:57:04.000000', 'consum', 0.0241, 'lps'),
	(639700, 135, '2015-01-01 00:57:05.000000', 'consum', 0.0216, 'lps'),
	(639701, 135, '2015-01-01 00:57:06.000000', 'consum', 0.0269, 'lps'),
	(639702, 135, '2015-01-01 00:57:07.000000', 'consum', 0.0240, 'lps'),
	(639703, 135, '2015-01-01 00:57:08.000000', 'consum', 0.0244, 'lps'),
	(639704, 135, '2015-01-01 00:57:09.000000', 'consum', 0.0229, 'lps'),
	(639705, 135, '2015-01-01 00:57:10.000000', 'consum', 0.0266, 'lps'),
	(639706, 135, '2015-01-01 00:57:11.000000', 'consum', 0.0250, 'lps'),
	(639707, 135, '2015-01-01 00:57:12.000000', 'consum', 0.0239, 'lps'),
	(639708, 135, '2015-01-01 00:57:13.000000', 'consum', 0.0236, 'lps'),
	(639709, 135, '2015-01-01 00:57:14.000000', 'consum', 0.0256, 'lps'),
	(639710, 135, '2015-01-01 00:57:15.000000', 'consum', 0.0235, 'lps'),
	(639711, 135, '2015-01-01 00:57:16.000000', 'consum', 0.0263, 'lps'),
	(639712, 135, '2015-01-01 00:57:17.000000', 'consum', 0.0212, 'lps'),
	(639713, 135, '2015-01-01 00:57:18.000000', 'consum', 0.0246, 'lps'),
	(639714, 135, '2015-01-01 00:57:19.000000', 'consum', 0.0263, 'lps'),
	(639715, 135, '2015-01-01 00:57:20.000000', 'consum', 0.0243, 'lps'),
	(639716, 135, '2015-01-01 00:57:21.000000', 'consum', 0.0217, 'lps'),
	(639717, 135, '2015-01-01 00:57:22.000000', 'consum', 0.0271, 'lps'),
	(639718, 135, '2015-01-01 00:57:23.000000', 'consum', 0.0245, 'lps'),
	(639719, 135, '2015-01-01 00:57:24.000000', 'consum', 0.0267, 'lps'),
	(639720, 135, '2015-01-01 00:57:25.000000', 'consum', 0.0265, 'lps'),
	(639721, 135, '2015-01-01 00:57:26.000000', 'consum', 0.0251, 'lps'),
	(639722, 135, '2015-01-01 00:57:27.000000', 'consum', 0.0253, 'lps'),
	(639723, 135, '2015-01-01 00:57:28.000000', 'consum', 0.0241, 'lps'),
	(639724, 135, '2015-01-01 00:57:29.000000', 'consum', 0.0234, 'lps'),
	(639725, 135, '2015-01-01 00:57:30.000000', 'consum', 0.0239, 'lps'),
	(639726, 135, '2015-01-01 00:57:31.000000', 'consum', 0.0223, 'lps'),
	(639727, 135, '2015-01-01 00:57:32.000000', 'consum', 0.0250, 'lps'),
	(639728, 135, '2015-01-01 00:57:33.000000', 'consum', 0.0245, 'lps'),
	(639729, 135, '2015-01-01 00:57:34.000000', 'consum', 0.0267, 'lps'),
	(639730, 135, '2015-01-01 00:57:35.000000', 'consum', 0.0266, 'lps'),
	(639731, 135, '2015-01-01 00:57:36.000000', 'consum', 0.0257, 'lps'),
	(639732, 135, '2015-01-01 00:57:37.000000', 'consum', 0.0216, 'lps'),
	(639733, 135, '2015-01-01 00:57:38.000000', 'consum', 0.0223, 'lps'),
	(639734, 135, '2015-01-01 00:57:39.000000', 'consum', 0.0257, 'lps'),
	(639735, 135, '2015-01-01 00:57:40.000000', 'consum', 0.0220, 'lps'),
	(639736, 135, '2015-01-01 00:57:41.000000', 'consum', 0.0243, 'lps'),
	(639737, 135, '2015-01-01 00:57:42.000000', 'consum', 0.0223, 'lps'),
	(639738, 135, '2015-01-01 00:57:43.000000', 'consum', 0.0239, 'lps'),
	(639739, 135, '2015-01-01 00:57:44.000000', 'consum', 0.0253, 'lps'),
	(639740, 135, '2015-01-01 00:57:45.000000', 'consum', 0.0214, 'lps'),
	(639741, 135, '2015-01-01 00:57:46.000000', 'consum', 0.0226, 'lps'),
	(639742, 135, '2015-01-01 00:57:47.000000', 'consum', 0.0215, 'lps'),
	(639743, 135, '2015-01-01 00:57:48.000000', 'consum', 0.0249, 'lps'),
	(639744, 135, '2015-01-01 00:57:49.000000', 'consum', 0.0267, 'lps'),
	(639745, 135, '2015-01-01 00:57:50.000000', 'consum', 0.0255, 'lps'),
	(639746, 135, '2015-01-01 00:57:51.000000', 'consum', 0.0266, 'lps'),
	(639747, 135, '2015-01-01 00:57:52.000000', 'consum', 0.0231, 'lps'),
	(639748, 135, '2015-01-01 00:57:53.000000', 'consum', 0.0271, 'lps'),
	(639749, 135, '2015-01-01 00:57:54.000000', 'consum', 0.0265, 'lps'),
	(639750, 135, '2015-01-01 00:57:55.000000', 'consum', 0.0242, 'lps'),
	(639751, 135, '2015-01-01 00:57:56.000000', 'consum', 0.0266, 'lps'),
	(639752, 135, '2015-01-01 00:57:57.000000', 'consum', 0.0210, 'lps'),
	(639753, 135, '2015-01-01 00:57:58.000000', 'consum', 0.0228, 'lps'),
	(639754, 135, '2015-01-01 00:57:59.000000', 'consum', 0.0239, 'lps'),
	(639755, 135, '2015-01-01 00:58:00.000000', 'consum', 0.0238, 'lps'),
	(639756, 135, '2015-01-01 00:58:01.000000', 'consum', 0.0265, 'lps'),
	(639757, 135, '2015-01-01 00:58:02.000000', 'consum', 0.0215, 'lps'),
	(639758, 135, '2015-01-01 00:58:03.000000', 'consum', 0.0256, 'lps'),
	(639759, 135, '2015-01-01 00:58:04.000000', 'consum', 0.0239, 'lps'),
	(639760, 135, '2015-01-01 00:58:05.000000', 'consum', 0.0217, 'lps'),
	(639761, 135, '2015-01-01 00:58:06.000000', 'consum', 0.0222, 'lps'),
	(639762, 135, '2015-01-01 00:58:07.000000', 'consum', 0.0249, 'lps'),
	(639763, 135, '2015-01-01 00:58:08.000000', 'consum', 0.0245, 'lps'),
	(639764, 135, '2015-01-01 00:58:09.000000', 'consum', 0.0268, 'lps'),
	(639765, 135, '2015-01-01 00:58:10.000000', 'consum', 0.0210, 'lps'),
	(639766, 135, '2015-01-01 00:58:11.000000', 'consum', 0.0223, 'lps'),
	(639767, 135, '2015-01-01 00:58:12.000000', 'consum', 0.0212, 'lps'),
	(639768, 135, '2015-01-01 00:58:13.000000', 'consum', 0.0243, 'lps'),
	(639769, 135, '2015-01-01 00:58:14.000000', 'consum', 0.0248, 'lps'),
	(639770, 135, '2015-01-01 00:58:15.000000', 'consum', 0.0238, 'lps'),
	(639771, 135, '2015-01-01 00:58:16.000000', 'consum', 0.0235, 'lps'),
	(639772, 135, '2015-01-01 00:58:17.000000', 'consum', 0.0254, 'lps'),
	(639773, 135, '2015-01-01 00:58:18.000000', 'consum', 0.0229, 'lps'),
	(639774, 135, '2015-01-01 00:58:19.000000', 'consum', 0.0237, 'lps'),
	(639775, 135, '2015-01-01 00:58:20.000000', 'consum', 0.0225, 'lps'),
	(639776, 135, '2015-01-01 00:58:21.000000', 'consum', 0.0268, 'lps'),
	(639777, 135, '2015-01-01 00:58:22.000000', 'consum', 0.0270, 'lps'),
	(639778, 135, '2015-01-01 00:58:23.000000', 'consum', 0.0213, 'lps'),
	(639779, 135, '2015-01-01 00:58:24.000000', 'consum', 0.0230, 'lps'),
	(639780, 135, '2015-01-01 00:58:25.000000', 'consum', 0.0241, 'lps'),
	(639781, 135, '2015-01-01 00:58:26.000000', 'consum', 0.0241, 'lps'),
	(639782, 135, '2015-01-01 00:58:27.000000', 'consum', 0.0212, 'lps'),
	(639783, 135, '2015-01-01 00:58:28.000000', 'consum', 0.0251, 'lps'),
	(639784, 135, '2015-01-01 00:58:29.000000', 'consum', 0.0224, 'lps'),
	(639785, 135, '2015-01-01 00:58:30.000000', 'consum', 0.0219, 'lps'),
	(639786, 135, '2015-01-01 00:58:31.000000', 'consum', 0.0212, 'lps'),
	(639787, 135, '2015-01-01 00:58:32.000000', 'consum', 0.0257, 'lps'),
	(639788, 135, '2015-01-01 00:58:33.000000', 'consum', 0.0252, 'lps'),
	(639789, 135, '2015-01-01 00:58:34.000000', 'consum', 0.0217, 'lps'),
	(639790, 135, '2015-01-01 00:58:35.000000', 'consum', 0.0244, 'lps'),
	(639791, 135, '2015-01-01 00:58:36.000000', 'consum', 0.0236, 'lps'),
	(639792, 135, '2015-01-01 00:58:37.000000', 'consum', 0.0239, 'lps'),
	(639793, 135, '2015-01-01 00:58:38.000000', 'consum', 0.0214, 'lps'),
	(639794, 135, '2015-01-01 00:58:39.000000', 'consum', 0.0269, 'lps'),
	(639795, 135, '2015-01-01 00:58:40.000000', 'consum', 0.0244, 'lps'),
	(639796, 135, '2015-01-01 00:58:41.000000', 'consum', 0.0265, 'lps'),
	(639797, 135, '2015-01-01 00:58:42.000000', 'consum', 0.0259, 'lps'),
	(639798, 135, '2015-01-01 00:58:43.000000', 'consum', 0.0231, 'lps'),
	(639799, 135, '2015-01-01 00:58:44.000000', 'consum', 0.0230, 'lps'),
	(639800, 135, '2015-01-01 00:58:45.000000', 'consum', 0.0247, 'lps'),
	(639801, 135, '2015-01-01 00:58:46.000000', 'consum', 0.0210, 'lps'),
	(639802, 135, '2015-01-01 00:58:47.000000', 'consum', 0.0225, 'lps'),
	(639803, 135, '2015-01-01 00:58:48.000000', 'consum', 0.0224, 'lps'),
	(639804, 135, '2015-01-01 00:58:49.000000', 'consum', 0.0235, 'lps'),
	(639805, 135, '2015-01-01 00:58:50.000000', 'consum', 0.0230, 'lps'),
	(639806, 135, '2015-01-01 00:58:51.000000', 'consum', 0.0235, 'lps'),
	(639807, 135, '2015-01-01 00:58:52.000000', 'consum', 0.0215, 'lps'),
	(639808, 135, '2015-01-01 00:58:53.000000', 'consum', 0.0222, 'lps'),
	(639809, 135, '2015-01-01 00:58:54.000000', 'consum', 0.0257, 'lps'),
	(639810, 135, '2015-01-01 00:58:55.000000', 'consum', 0.0223, 'lps'),
	(639811, 135, '2015-01-01 00:58:56.000000', 'consum', 0.0258, 'lps'),
	(639812, 135, '2015-01-01 00:58:57.000000', 'consum', 0.0227, 'lps'),
	(639813, 135, '2015-01-01 00:58:58.000000', 'consum', 0.0213, 'lps'),
	(639814, 135, '2015-01-01 00:58:59.000000', 'consum', 0.0235, 'lps'),
	(639815, 135, '2015-01-01 00:59:00.000000', 'consum', 0.0263, 'lps'),
	(639816, 135, '2015-01-01 00:59:01.000000', 'consum', 0.0217, 'lps'),
	(639817, 135, '2015-01-01 00:59:02.000000', 'consum', 0.0211, 'lps'),
	(639818, 135, '2015-01-01 00:59:03.000000', 'consum', 0.0254, 'lps'),
	(639819, 135, '2015-01-01 00:59:04.000000', 'consum', 0.0243, 'lps'),
	(639820, 135, '2015-01-01 00:59:05.000000', 'consum', 0.0242, 'lps'),
	(639821, 135, '2015-01-01 00:59:06.000000', 'consum', 0.0210, 'lps'),
	(639822, 135, '2015-01-01 00:59:07.000000', 'consum', 0.0240, 'lps'),
	(639823, 135, '2015-01-01 00:59:08.000000', 'consum', 0.0238, 'lps'),
	(639824, 135, '2015-01-01 00:59:09.000000', 'consum', 0.0258, 'lps'),
	(639825, 135, '2015-01-01 00:59:10.000000', 'consum', 0.0243, 'lps'),
	(639826, 135, '2015-01-01 00:59:11.000000', 'consum', 0.0230, 'lps'),
	(639827, 135, '2015-01-01 00:59:12.000000', 'consum', 0.0213, 'lps'),
	(639828, 135, '2015-01-01 00:59:13.000000', 'consum', 0.0227, 'lps'),
	(639829, 135, '2015-01-01 00:59:14.000000', 'consum', 0.0223, 'lps'),
	(639830, 135, '2015-01-01 00:59:15.000000', 'consum', 0.0224, 'lps'),
	(639831, 135, '2015-01-01 00:59:16.000000', 'consum', 0.0244, 'lps'),
	(639832, 135, '2015-01-01 00:59:17.000000', 'consum', 0.0215, 'lps'),
	(639833, 135, '2015-01-01 00:59:18.000000', 'consum', 0.0256, 'lps'),
	(639834, 135, '2015-01-01 00:59:19.000000', 'consum', 0.0239, 'lps'),
	(639835, 135, '2015-01-01 00:59:20.000000', 'consum', 0.0220, 'lps'),
	(639836, 135, '2015-01-01 00:59:21.000000', 'consum', 0.0233, 'lps'),
	(639837, 135, '2015-01-01 00:59:22.000000', 'consum', 0.0236, 'lps'),
	(639838, 135, '2015-01-01 00:59:23.000000', 'consum', 0.0271, 'lps'),
	(639839, 135, '2015-01-01 00:59:24.000000', 'consum', 0.0252, 'lps'),
	(639840, 135, '2015-01-01 00:59:25.000000', 'consum', 0.0235, 'lps'),
	(639841, 135, '2015-01-01 00:59:26.000000', 'consum', 0.0210, 'lps'),
	(639842, 135, '2015-01-01 00:59:27.000000', 'consum', 0.0261, 'lps'),
	(639843, 135, '2015-01-01 00:59:28.000000', 'consum', 0.0215, 'lps'),
	(639844, 135, '2015-01-01 00:59:29.000000', 'consum', 0.0271, 'lps'),
	(639845, 135, '2015-01-01 00:59:30.000000', 'consum', 0.0251, 'lps'),
	(639846, 135, '2015-01-01 00:59:31.000000', 'consum', 0.0232, 'lps'),
	(639847, 135, '2015-01-01 00:59:32.000000', 'consum', 0.0260, 'lps'),
	(639848, 135, '2015-01-01 00:59:33.000000', 'consum', 0.0210, 'lps'),
	(639849, 135, '2015-01-01 00:59:34.000000', 'consum', 0.0246, 'lps'),
	(639850, 135, '2015-01-01 00:59:35.000000', 'consum', 0.0268, 'lps'),
	(639851, 135, '2015-01-01 00:59:36.000000', 'consum', 0.0268, 'lps'),
	(639852, 135, '2015-01-01 00:59:37.000000', 'consum', 0.0262, 'lps'),
	(639853, 135, '2015-01-01 00:59:38.000000', 'consum', 0.0238, 'lps'),
	(639854, 135, '2015-01-01 00:59:39.000000', 'consum', 0.0253, 'lps'),
	(639855, 135, '2015-01-01 00:59:40.000000', 'consum', 0.0219, 'lps'),
	(639856, 135, '2015-01-01 00:59:41.000000', 'consum', 0.0248, 'lps'),
	(639857, 135, '2015-01-01 00:59:42.000000', 'consum', 0.0253, 'lps'),
	(639858, 135, '2015-01-01 00:59:43.000000', 'consum', 0.0247, 'lps'),
	(639859, 135, '2015-01-01 00:59:44.000000', 'consum', 0.0269, 'lps'),
	(639860, 135, '2015-01-01 00:59:45.000000', 'consum', 0.0269, 'lps'),
	(639861, 135, '2015-01-01 00:59:46.000000', 'consum', 0.0267, 'lps'),
	(639862, 135, '2015-01-01 00:59:47.000000', 'consum', 0.0258, 'lps'),
	(639863, 135, '2015-01-01 00:59:48.000000', 'consum', 0.0217, 'lps'),
	(639864, 135, '2015-01-01 00:59:49.000000', 'consum', 0.0227, 'lps'),
	(639865, 135, '2015-01-01 00:59:50.000000', 'consum', 0.0271, 'lps'),
	(639866, 135, '2015-01-01 00:59:51.000000', 'consum', 0.0220, 'lps'),
	(639867, 135, '2015-01-01 00:59:52.000000', 'consum', 0.0261, 'lps'),
	(639868, 135, '2015-01-01 00:59:53.000000', 'consum', 0.0252, 'lps'),
	(639869, 135, '2015-01-01 00:59:54.000000', 'consum', 0.0264, 'lps'),
	(639870, 135, '2015-01-01 00:59:55.000000', 'consum', 0.0233, 'lps'),
	(639871, 135, '2015-01-01 00:59:56.000000', 'consum', 0.0226, 'lps'),
	(639872, 135, '2015-01-01 00:59:57.000000', 'consum', 0.0222, 'lps'),
	(639873, 135, '2015-01-01 00:59:58.000000', 'consum', 0.0223, 'lps'),
	(639874, 135, '2015-01-01 00:59:59.000000', 'consum', 0.0238, 'lps'),
	(639875, 135, '2015-01-01 01:00:00.000000', 'consum', 0.0251, 'lps'),
	(639876, 136, '2015-01-01 00:00:00.000000', 'consum', 0.0324, 'lps'),
	(639877, 136, '2015-01-01 00:00:01.000000', 'consum', 0.0254, 'lps'),
	(639878, 136, '2015-01-01 00:00:02.000000', 'consum', 0.0210, 'lps'),
	(639879, 136, '2015-01-01 00:00:03.000000', 'consum', 0.0327, 'lps'),
	(639880, 136, '2015-01-01 00:00:04.000000', 'consum', 0.0301, 'lps'),
	(639881, 136, '2015-01-01 00:00:05.000000', 'consum', 0.0314, 'lps'),
	(639882, 136, '2015-01-01 00:00:06.000000', 'consum', 0.0333, 'lps'),
	(639883, 136, '2015-01-01 00:00:07.000000', 'consum', 0.0264, 'lps'),
	(639884, 136, '2015-01-01 00:00:08.000000', 'consum', 0.0238, 'lps'),
	(639885, 136, '2015-01-01 00:00:09.000000', 'consum', 0.0312, 'lps'),
	(639886, 136, '2015-01-01 00:00:10.000000', 'consum', 0.0265, 'lps'),
	(639887, 136, '2015-01-01 00:00:11.000000', 'consum', 0.0303, 'lps'),
	(639888, 136, '2015-01-01 00:00:12.000000', 'consum', 0.0263, 'lps'),
	(639889, 136, '2015-01-01 00:00:13.000000', 'consum', 0.0319, 'lps'),
	(639890, 136, '2015-01-01 00:00:14.000000', 'consum', 0.0227, 'lps'),
	(639891, 136, '2015-01-01 00:00:15.000000', 'consum', 0.0216, 'lps'),
	(639892, 136, '2015-01-01 00:00:16.000000', 'consum', 0.0315, 'lps'),
	(639893, 136, '2015-01-01 00:00:17.000000', 'consum', 0.0221, 'lps'),
	(639894, 136, '2015-01-01 00:00:18.000000', 'consum', 0.0320, 'lps'),
	(639895, 136, '2015-01-01 00:00:19.000000', 'consum', 0.0234, 'lps'),
	(639896, 136, '2015-01-01 00:00:20.000000', 'consum', 0.0247, 'lps'),
	(639897, 136, '2015-01-01 00:00:21.000000', 'consum', 0.0325, 'lps'),
	(639898, 136, '2015-01-01 00:00:22.000000', 'consum', 0.0301, 'lps'),
	(639899, 136, '2015-01-01 00:00:23.000000', 'consum', 0.0319, 'lps'),
	(639900, 136, '2015-01-01 00:00:24.000000', 'consum', 0.0237, 'lps'),
	(639901, 136, '2015-01-01 00:00:25.000000', 'consum', 0.0264, 'lps'),
	(639902, 136, '2015-01-01 00:00:26.000000', 'consum', 0.0277, 'lps'),
	(639903, 136, '2015-01-01 00:00:27.000000', 'consum', 0.0260, 'lps'),
	(639904, 136, '2015-01-01 00:00:28.000000', 'consum', 0.0257, 'lps'),
	(639905, 136, '2015-01-01 00:00:29.000000', 'consum', 0.0297, 'lps'),
	(639906, 136, '2015-01-01 00:00:30.000000', 'consum', 0.0258, 'lps'),
	(639907, 136, '2015-01-01 00:00:31.000000', 'consum', 0.0314, 'lps'),
	(639908, 136, '2015-01-01 00:00:32.000000', 'consum', 0.0214, 'lps'),
	(639909, 136, '2015-01-01 00:00:33.000000', 'consum', 0.0288, 'lps'),
	(639910, 136, '2015-01-01 00:00:34.000000', 'consum', 0.0218, 'lps'),
	(639911, 136, '2015-01-01 00:00:35.000000', 'consum', 0.0263, 'lps'),
	(639912, 136, '2015-01-01 00:00:36.000000', 'consum', 0.0330, 'lps'),
	(639913, 136, '2015-01-01 00:00:37.000000', 'consum', 0.0277, 'lps'),
	(639914, 136, '2015-01-01 00:00:38.000000', 'consum', 0.0311, 'lps'),
	(639915, 136, '2015-01-01 00:00:39.000000', 'consum', 0.0265, 'lps'),
	(639916, 136, '2015-01-01 00:00:40.000000', 'consum', 0.0306, 'lps'),
	(639917, 136, '2015-01-01 00:00:41.000000', 'consum', 0.0280, 'lps'),
	(639918, 136, '2015-01-01 00:00:42.000000', 'consum', 0.0270, 'lps'),
	(639919, 136, '2015-01-01 00:00:43.000000', 'consum', 0.0302, 'lps'),
	(639920, 136, '2015-01-01 00:00:44.000000', 'consum', 0.0241, 'lps'),
	(639921, 136, '2015-01-01 00:00:45.000000', 'consum', 0.0214, 'lps'),
	(639922, 136, '2015-01-01 00:00:46.000000', 'consum', 0.0263, 'lps'),
	(639923, 136, '2015-01-01 00:00:47.000000', 'consum', 0.0214, 'lps'),
	(639924, 136, '2015-01-01 00:00:48.000000', 'consum', 0.0318, 'lps'),
	(639925, 136, '2015-01-01 00:00:49.000000', 'consum', 0.0245, 'lps'),
	(639926, 136, '2015-01-01 00:00:50.000000', 'consum', 0.0307, 'lps'),
	(639927, 136, '2015-01-01 00:00:51.000000', 'consum', 0.0219, 'lps'),
	(639928, 136, '2015-01-01 00:00:52.000000', 'consum', 0.0213, 'lps'),
	(639929, 136, '2015-01-01 00:00:53.000000', 'consum', 0.0323, 'lps'),
	(639930, 136, '2015-01-01 00:00:54.000000', 'consum', 0.0272, 'lps'),
	(639931, 136, '2015-01-01 00:00:55.000000', 'consum', 0.0305, 'lps'),
	(639932, 136, '2015-01-01 00:00:56.000000', 'consum', 0.0249, 'lps'),
	(639933, 136, '2015-01-01 00:00:57.000000', 'consum', 0.0246, 'lps'),
	(639934, 136, '2015-01-01 00:00:58.000000', 'consum', 0.0272, 'lps'),
	(639935, 136, '2015-01-01 00:00:59.000000', 'consum', 0.0291, 'lps'),
	(639936, 136, '2015-01-01 00:01:00.000000', 'consum', 0.0302, 'lps'),
	(639937, 136, '2015-01-01 00:01:01.000000', 'consum', 0.0307, 'lps'),
	(639938, 136, '2015-01-01 00:01:02.000000', 'consum', 0.0293, 'lps'),
	(639939, 136, '2015-01-01 00:01:03.000000', 'consum', 0.0213, 'lps'),
	(639940, 136, '2015-01-01 00:01:04.000000', 'consum', 0.0221, 'lps'),
	(639941, 136, '2015-01-01 00:01:05.000000', 'consum', 0.0260, 'lps'),
	(639942, 136, '2015-01-01 00:01:06.000000', 'consum', 0.0303, 'lps'),
	(639943, 136, '2015-01-01 00:01:07.000000', 'consum', 0.0276, 'lps'),
	(639944, 136, '2015-01-01 00:01:08.000000', 'consum', 0.0260, 'lps'),
	(639945, 136, '2015-01-01 00:01:09.000000', 'consum', 0.0265, 'lps'),
	(639946, 136, '2015-01-01 00:01:10.000000', 'consum', 0.0211, 'lps'),
	(639947, 136, '2015-01-01 00:01:11.000000', 'consum', 0.0300, 'lps'),
	(639948, 136, '2015-01-01 00:01:12.000000', 'consum', 0.0283, 'lps'),
	(639949, 136, '2015-01-01 00:01:13.000000', 'consum', 0.0305, 'lps'),
	(639950, 136, '2015-01-01 00:01:14.000000', 'consum', 0.0218, 'lps'),
	(639951, 136, '2015-01-01 00:01:15.000000', 'consum', 0.0215, 'lps'),
	(639952, 136, '2015-01-01 00:01:16.000000', 'consum', 0.0211, 'lps'),
	(639953, 136, '2015-01-01 00:01:17.000000', 'consum', 0.0326, 'lps'),
	(639954, 136, '2015-01-01 00:01:18.000000', 'consum', 0.0293, 'lps'),
	(639955, 136, '2015-01-01 00:01:19.000000', 'consum', 0.0274, 'lps'),
	(639956, 136, '2015-01-01 00:01:20.000000', 'consum', 0.0282, 'lps'),
	(639957, 136, '2015-01-01 00:01:21.000000', 'consum', 0.0257, 'lps'),
	(639958, 136, '2015-01-01 00:01:22.000000', 'consum', 0.0228, 'lps'),
	(639959, 136, '2015-01-01 00:01:23.000000', 'consum', 0.0282, 'lps'),
	(639960, 136, '2015-01-01 00:01:24.000000', 'consum', 0.0270, 'lps'),
	(639961, 136, '2015-01-01 00:01:25.000000', 'consum', 0.0292, 'lps'),
	(639962, 136, '2015-01-01 00:01:26.000000', 'consum', 0.0318, 'lps'),
	(639963, 136, '2015-01-01 00:01:27.000000', 'consum', 0.0258, 'lps'),
	(639964, 136, '2015-01-01 00:01:28.000000', 'consum', 0.0250, 'lps'),
	(639965, 136, '2015-01-01 00:01:29.000000', 'consum', 0.0267, 'lps'),
	(639966, 136, '2015-01-01 00:01:30.000000', 'consum', 0.0253, 'lps'),
	(639967, 136, '2015-01-01 00:01:31.000000', 'consum', 0.0253, 'lps'),
	(639968, 136, '2015-01-01 00:01:32.000000', 'consum', 0.0297, 'lps'),
	(639969, 136, '2015-01-01 00:01:33.000000', 'consum', 0.0268, 'lps'),
	(639970, 136, '2015-01-01 00:01:34.000000', 'consum', 0.0241, 'lps'),
	(639971, 136, '2015-01-01 00:01:35.000000', 'consum', 0.0314, 'lps'),
	(639972, 136, '2015-01-01 00:01:36.000000', 'consum', 0.0264, 'lps'),
	(639973, 136, '2015-01-01 00:01:37.000000', 'consum', 0.0296, 'lps'),
	(639974, 136, '2015-01-01 00:01:38.000000', 'consum', 0.0228, 'lps'),
	(639975, 136, '2015-01-01 00:01:39.000000', 'consum', 0.0292, 'lps'),
	(639976, 136, '2015-01-01 00:01:40.000000', 'consum', 0.0318, 'lps'),
	(639977, 136, '2015-01-01 00:01:41.000000', 'consum', 0.0255, 'lps'),
	(639978, 136, '2015-01-01 00:01:42.000000', 'consum', 0.0236, 'lps'),
	(639979, 136, '2015-01-01 00:01:43.000000', 'consum', 0.0328, 'lps'),
	(639980, 136, '2015-01-01 00:01:44.000000', 'consum', 0.0227, 'lps'),
	(639981, 136, '2015-01-01 00:01:45.000000', 'consum', 0.0313, 'lps'),
	(639982, 136, '2015-01-01 00:01:46.000000', 'consum', 0.0302, 'lps'),
	(639983, 136, '2015-01-01 00:01:47.000000', 'consum', 0.0238, 'lps'),
	(639984, 136, '2015-01-01 00:01:48.000000', 'consum', 0.0324, 'lps'),
	(639985, 136, '2015-01-01 00:01:49.000000', 'consum', 0.0322, 'lps'),
	(639986, 136, '2015-01-01 00:01:50.000000', 'consum', 0.0305, 'lps'),
	(639987, 136, '2015-01-01 00:01:51.000000', 'consum', 0.0227, 'lps'),
	(639988, 136, '2015-01-01 00:01:52.000000', 'consum', 0.0257, 'lps'),
	(639989, 136, '2015-01-01 00:01:53.000000', 'consum', 0.0269, 'lps'),
	(639990, 136, '2015-01-01 00:01:54.000000', 'consum', 0.0242, 'lps'),
	(639991, 136, '2015-01-01 00:01:55.000000', 'consum', 0.0316, 'lps'),
	(639992, 136, '2015-01-01 00:01:56.000000', 'consum', 0.0273, 'lps'),
	(639993, 136, '2015-01-01 00:01:57.000000', 'consum', 0.0330, 'lps'),
	(639994, 136, '2015-01-01 00:01:58.000000', 'consum', 0.0250, 'lps'),
	(639995, 136, '2015-01-01 00:01:59.000000', 'consum', 0.0297, 'lps'),
	(639996, 136, '2015-01-01 00:02:00.000000', 'consum', 0.0281, 'lps'),
	(639997, 136, '2015-01-01 00:02:01.000000', 'consum', 0.0303, 'lps'),
	(639998, 136, '2015-01-01 00:02:02.000000', 'consum', 0.0214, 'lps'),
	(639999, 136, '2015-01-01 00:02:03.000000', 'consum', 0.0322, 'lps'),
	(640000, 136, '2015-01-01 00:02:04.000000', 'consum', 0.0266, 'lps'),
	(640001, 136, '2015-01-01 00:02:05.000000', 'consum', 0.0275, 'lps'),
	(640002, 136, '2015-01-01 00:02:06.000000', 'consum', 0.0246, 'lps'),
	(640003, 136, '2015-01-01 00:02:07.000000', 'consum', 0.0318, 'lps'),
	(640004, 136, '2015-01-01 00:02:08.000000', 'consum', 0.0273, 'lps'),
	(640005, 136, '2015-01-01 00:02:09.000000', 'consum', 0.0322, 'lps'),
	(640006, 136, '2015-01-01 00:02:10.000000', 'consum', 0.0213, 'lps'),
	(640007, 136, '2015-01-01 00:02:11.000000', 'consum', 0.0260, 'lps'),
	(640008, 136, '2015-01-01 00:02:12.000000', 'consum', 0.0326, 'lps'),
	(640009, 136, '2015-01-01 00:02:13.000000', 'consum', 0.0269, 'lps'),
	(640010, 136, '2015-01-01 00:02:14.000000', 'consum', 0.0284, 'lps'),
	(640011, 136, '2015-01-01 00:02:15.000000', 'consum', 0.0278, 'lps'),
	(640012, 136, '2015-01-01 00:02:16.000000', 'consum', 0.0327, 'lps'),
	(640013, 136, '2015-01-01 00:02:17.000000', 'consum', 0.0220, 'lps'),
	(640014, 136, '2015-01-01 00:02:18.000000', 'consum', 0.0280, 'lps'),
	(640015, 136, '2015-01-01 00:02:19.000000', 'consum', 0.0283, 'lps'),
	(640016, 136, '2015-01-01 00:02:20.000000', 'consum', 0.0241, 'lps'),
	(640017, 136, '2015-01-01 00:02:21.000000', 'consum', 0.0273, 'lps'),
	(640018, 136, '2015-01-01 00:02:22.000000', 'consum', 0.0307, 'lps'),
	(640019, 136, '2015-01-01 00:02:23.000000', 'consum', 0.0257, 'lps'),
	(640020, 136, '2015-01-01 00:02:24.000000', 'consum', 0.0282, 'lps'),
	(640021, 136, '2015-01-01 00:02:25.000000', 'consum', 0.0302, 'lps'),
	(640022, 136, '2015-01-01 00:02:26.000000', 'consum', 0.0332, 'lps'),
	(640023, 136, '2015-01-01 00:02:27.000000', 'consum', 0.0295, 'lps'),
	(640024, 136, '2015-01-01 00:02:28.000000', 'consum', 0.0270, 'lps'),
	(640025, 136, '2015-01-01 00:02:29.000000', 'consum', 0.0257, 'lps'),
	(640026, 136, '2015-01-01 00:02:30.000000', 'consum', 0.0266, 'lps'),
	(640027, 136, '2015-01-01 00:02:31.000000', 'consum', 0.0223, 'lps'),
	(640028, 136, '2015-01-01 00:02:32.000000', 'consum', 0.0231, 'lps'),
	(640029, 136, '2015-01-01 00:02:33.000000', 'consum', 0.0277, 'lps'),
	(640030, 136, '2015-01-01 00:02:34.000000', 'consum', 0.0233, 'lps'),
	(640031, 136, '2015-01-01 00:02:35.000000', 'consum', 0.0252, 'lps'),
	(640032, 136, '2015-01-01 00:02:36.000000', 'consum', 0.0225, 'lps'),
	(640033, 136, '2015-01-01 00:02:37.000000', 'consum', 0.0285, 'lps'),
	(640034, 136, '2015-01-01 00:02:38.000000', 'consum', 0.0292, 'lps'),
	(640035, 136, '2015-01-01 00:02:39.000000', 'consum', 0.0273, 'lps'),
	(640036, 136, '2015-01-01 00:02:40.000000', 'consum', 0.0280, 'lps'),
	(640037, 136, '2015-01-01 00:02:41.000000', 'consum', 0.0246, 'lps'),
	(640038, 136, '2015-01-01 00:02:42.000000', 'consum', 0.0306, 'lps'),
	(640039, 136, '2015-01-01 00:02:43.000000', 'consum', 0.0211, 'lps'),
	(640040, 136, '2015-01-01 00:02:44.000000', 'consum', 0.0299, 'lps'),
	(640041, 136, '2015-01-01 00:02:45.000000', 'consum', 0.0282, 'lps'),
	(640042, 136, '2015-01-01 00:02:46.000000', 'consum', 0.0304, 'lps'),
	(640043, 136, '2015-01-01 00:02:47.000000', 'consum', 0.0214, 'lps'),
	(640044, 136, '2015-01-01 00:02:48.000000', 'consum', 0.0321, 'lps'),
	(640045, 136, '2015-01-01 00:02:49.000000', 'consum', 0.0256, 'lps'),
	(640046, 136, '2015-01-01 00:02:50.000000', 'consum', 0.0234, 'lps'),
	(640047, 136, '2015-01-01 00:02:51.000000', 'consum', 0.0315, 'lps'),
	(640048, 136, '2015-01-01 00:02:52.000000', 'consum', 0.0291, 'lps'),
	(640049, 136, '2015-01-01 00:02:53.000000', 'consum', 0.0301, 'lps'),
	(640050, 136, '2015-01-01 00:02:54.000000', 'consum', 0.0298, 'lps'),
	(640051, 136, '2015-01-01 00:02:55.000000', 'consum', 0.0256, 'lps'),
	(640052, 136, '2015-01-01 00:02:56.000000', 'consum', 0.0299, 'lps'),
	(640053, 136, '2015-01-01 00:02:57.000000', 'consum', 0.0270, 'lps'),
	(640054, 136, '2015-01-01 00:02:58.000000', 'consum', 0.0243, 'lps'),
	(640055, 136, '2015-01-01 00:02:59.000000', 'consum', 0.0320, 'lps'),
	(640056, 136, '2015-01-01 00:03:00.000000', 'consum', 0.0291, 'lps'),
	(640057, 136, '2015-01-01 00:03:01.000000', 'consum', 0.0283, 'lps'),
	(640058, 136, '2015-01-01 00:03:02.000000', 'consum', 0.0332, 'lps'),
	(640059, 136, '2015-01-01 00:03:03.000000', 'consum', 0.0229, 'lps'),
	(640060, 136, '2015-01-01 00:03:04.000000', 'consum', 0.0311, 'lps'),
	(640061, 136, '2015-01-01 00:03:05.000000', 'consum', 0.0288, 'lps'),
	(640062, 136, '2015-01-01 00:03:06.000000', 'consum', 0.0297, 'lps'),
	(640063, 136, '2015-01-01 00:03:07.000000', 'consum', 0.0286, 'lps'),
	(640064, 136, '2015-01-01 00:03:08.000000', 'consum', 0.0333, 'lps'),
	(640065, 136, '2015-01-01 00:03:09.000000', 'consum', 0.0222, 'lps'),
	(640066, 136, '2015-01-01 00:03:10.000000', 'consum', 0.0276, 'lps'),
	(640067, 136, '2015-01-01 00:03:11.000000', 'consum', 0.0254, 'lps'),
	(640068, 136, '2015-01-01 00:03:12.000000', 'consum', 0.0234, 'lps'),
	(640069, 136, '2015-01-01 00:03:13.000000', 'consum', 0.0320, 'lps'),
	(640070, 136, '2015-01-01 00:03:14.000000', 'consum', 0.0319, 'lps'),
	(640071, 136, '2015-01-01 00:03:15.000000', 'consum', 0.0300, 'lps'),
	(640072, 136, '2015-01-01 00:03:16.000000', 'consum', 0.0332, 'lps'),
	(640073, 136, '2015-01-01 00:03:17.000000', 'consum', 0.0304, 'lps'),
	(640074, 136, '2015-01-01 00:03:18.000000', 'consum', 0.0316, 'lps'),
	(640075, 136, '2015-01-01 00:03:19.000000', 'consum', 0.0332, 'lps'),
	(640076, 136, '2015-01-01 00:03:20.000000', 'consum', 0.0256, 'lps'),
	(640077, 136, '2015-01-01 00:03:21.000000', 'consum', 0.0320, 'lps'),
	(640078, 136, '2015-01-01 00:03:22.000000', 'consum', 0.0254, 'lps'),
	(640079, 136, '2015-01-01 00:03:23.000000', 'consum', 0.0221, 'lps'),
	(640080, 136, '2015-01-01 00:03:24.000000', 'consum', 0.0260, 'lps'),
	(640081, 136, '2015-01-01 00:03:25.000000', 'consum', 0.0304, 'lps'),
	(640082, 136, '2015-01-01 00:03:26.000000', 'consum', 0.0283, 'lps'),
	(640083, 136, '2015-01-01 00:03:27.000000', 'consum', 0.0291, 'lps'),
	(640084, 136, '2015-01-01 00:03:28.000000', 'consum', 0.0272, 'lps'),
	(640085, 136, '2015-01-01 00:03:29.000000', 'consum', 0.0279, 'lps'),
	(640086, 136, '2015-01-01 00:03:30.000000', 'consum', 0.0247, 'lps'),
	(640087, 136, '2015-01-01 00:03:31.000000', 'consum', 0.0311, 'lps'),
	(640088, 136, '2015-01-01 00:03:32.000000', 'consum', 0.0231, 'lps'),
	(640089, 136, '2015-01-01 00:03:33.000000', 'consum', 0.0260, 'lps'),
	(640090, 136, '2015-01-01 00:03:34.000000', 'consum', 0.0276, 'lps'),
	(640091, 136, '2015-01-01 00:03:35.000000', 'consum', 0.0264, 'lps'),
	(640092, 136, '2015-01-01 00:03:36.000000', 'consum', 0.0286, 'lps'),
	(640093, 136, '2015-01-01 00:03:37.000000', 'consum', 0.0301, 'lps'),
	(640094, 136, '2015-01-01 00:03:38.000000', 'consum', 0.0315, 'lps'),
	(640095, 136, '2015-01-01 00:03:39.000000', 'consum', 0.0214, 'lps'),
	(640096, 136, '2015-01-01 00:03:40.000000', 'consum', 0.0288, 'lps'),
	(640097, 136, '2015-01-01 00:03:41.000000', 'consum', 0.0215, 'lps'),
	(640098, 136, '2015-01-01 00:03:42.000000', 'consum', 0.0250, 'lps'),
	(640099, 136, '2015-01-01 00:03:43.000000', 'consum', 0.0272, 'lps'),
	(640100, 136, '2015-01-01 00:03:44.000000', 'consum', 0.0278, 'lps'),
	(640101, 136, '2015-01-01 00:03:45.000000', 'consum', 0.0240, 'lps'),
	(640102, 136, '2015-01-01 00:03:46.000000', 'consum', 0.0278, 'lps'),
	(640103, 136, '2015-01-01 00:03:47.000000', 'consum', 0.0215, 'lps'),
	(640104, 136, '2015-01-01 00:03:48.000000', 'consum', 0.0278, 'lps'),
	(640105, 136, '2015-01-01 00:03:49.000000', 'consum', 0.0287, 'lps'),
	(640106, 136, '2015-01-01 00:03:50.000000', 'consum', 0.0269, 'lps'),
	(640107, 136, '2015-01-01 00:03:51.000000', 'consum', 0.0272, 'lps'),
	(640108, 136, '2015-01-01 00:03:52.000000', 'consum', 0.0222, 'lps'),
	(640109, 136, '2015-01-01 00:03:53.000000', 'consum', 0.0332, 'lps'),
	(640110, 136, '2015-01-01 00:03:54.000000', 'consum', 0.0287, 'lps'),
	(640111, 136, '2015-01-01 00:03:55.000000', 'consum', 0.0232, 'lps'),
	(640112, 136, '2015-01-01 00:03:56.000000', 'consum', 0.0213, 'lps'),
	(640113, 136, '2015-01-01 00:03:57.000000', 'consum', 0.0281, 'lps'),
	(640114, 136, '2015-01-01 00:03:58.000000', 'consum', 0.0310, 'lps'),
	(640115, 136, '2015-01-01 00:03:59.000000', 'consum', 0.0248, 'lps'),
	(640116, 136, '2015-01-01 00:04:00.000000', 'consum', 0.0227, 'lps'),
	(640117, 136, '2015-01-01 00:04:01.000000', 'consum', 0.0305, 'lps'),
	(640118, 136, '2015-01-01 00:04:02.000000', 'consum', 0.0263, 'lps'),
	(640119, 136, '2015-01-01 00:04:03.000000', 'consum', 0.0315, 'lps'),
	(640120, 136, '2015-01-01 00:04:04.000000', 'consum', 0.0329, 'lps'),
	(640121, 136, '2015-01-01 00:04:05.000000', 'consum', 0.0240, 'lps'),
	(640122, 136, '2015-01-01 00:04:06.000000', 'consum', 0.0252, 'lps'),
	(640123, 136, '2015-01-01 00:04:07.000000', 'consum', 0.0331, 'lps'),
	(640124, 136, '2015-01-01 00:04:08.000000', 'consum', 0.0318, 'lps'),
	(640125, 136, '2015-01-01 00:04:09.000000', 'consum', 0.0264, 'lps'),
	(640126, 136, '2015-01-01 00:04:10.000000', 'consum', 0.0282, 'lps'),
	(640127, 136, '2015-01-01 00:04:11.000000', 'consum', 0.0283, 'lps'),
	(640128, 136, '2015-01-01 00:04:12.000000', 'consum', 0.0235, 'lps'),
	(640129, 136, '2015-01-01 00:04:13.000000', 'consum', 0.0242, 'lps'),
	(640130, 136, '2015-01-01 00:04:14.000000', 'consum', 0.0295, 'lps'),
	(640131, 136, '2015-01-01 00:04:15.000000', 'consum', 0.0292, 'lps'),
	(640132, 136, '2015-01-01 00:04:16.000000', 'consum', 0.0242, 'lps'),
	(640133, 136, '2015-01-01 00:04:17.000000', 'consum', 0.0246, 'lps'),
	(640134, 136, '2015-01-01 00:04:18.000000', 'consum', 0.0295, 'lps'),
	(640135, 136, '2015-01-01 00:04:19.000000', 'consum', 0.0282, 'lps'),
	(640136, 136, '2015-01-01 00:04:20.000000', 'consum', 0.0313, 'lps'),
	(640137, 136, '2015-01-01 00:04:21.000000', 'consum', 0.0264, 'lps'),
	(640138, 136, '2015-01-01 00:04:22.000000', 'consum', 0.0294, 'lps'),
	(640139, 136, '2015-01-01 00:04:23.000000', 'consum', 0.0220, 'lps'),
	(640140, 136, '2015-01-01 00:04:24.000000', 'consum', 0.0256, 'lps'),
	(640141, 136, '2015-01-01 00:04:25.000000', 'consum', 0.0287, 'lps'),
	(640142, 136, '2015-01-01 00:04:26.000000', 'consum', 0.0211, 'lps'),
	(640143, 136, '2015-01-01 00:04:27.000000', 'consum', 0.0230, 'lps'),
	(640144, 136, '2015-01-01 00:04:28.000000', 'consum', 0.0310, 'lps'),
	(640145, 136, '2015-01-01 00:04:29.000000', 'consum', 0.0279, 'lps'),
	(640146, 136, '2015-01-01 00:04:30.000000', 'consum', 0.0254, 'lps'),
	(640147, 136, '2015-01-01 00:04:31.000000', 'consum', 0.0224, 'lps'),
	(640148, 136, '2015-01-01 00:04:32.000000', 'consum', 0.0273, 'lps'),
	(640149, 136, '2015-01-01 00:04:33.000000', 'consum', 0.0235, 'lps'),
	(640150, 136, '2015-01-01 00:04:34.000000', 'consum', 0.0272, 'lps'),
	(640151, 136, '2015-01-01 00:04:35.000000', 'consum', 0.0321, 'lps'),
	(640152, 136, '2015-01-01 00:04:36.000000', 'consum', 0.0331, 'lps'),
	(640153, 136, '2015-01-01 00:04:37.000000', 'consum', 0.0236, 'lps'),
	(640154, 136, '2015-01-01 00:04:38.000000', 'consum', 0.0226, 'lps'),
	(640155, 136, '2015-01-01 00:04:39.000000', 'consum', 0.0211, 'lps'),
	(640156, 136, '2015-01-01 00:04:40.000000', 'consum', 0.0292, 'lps'),
	(640157, 136, '2015-01-01 00:04:41.000000', 'consum', 0.0246, 'lps'),
	(640158, 136, '2015-01-01 00:04:42.000000', 'consum', 0.0268, 'lps'),
	(640159, 136, '2015-01-01 00:04:43.000000', 'consum', 0.0267, 'lps'),
	(640160, 136, '2015-01-01 00:04:44.000000', 'consum', 0.0324, 'lps'),
	(640161, 136, '2015-01-01 00:04:45.000000', 'consum', 0.0237, 'lps'),
	(640162, 136, '2015-01-01 00:04:46.000000', 'consum', 0.0251, 'lps'),
	(640163, 136, '2015-01-01 00:04:47.000000', 'consum', 0.0333, 'lps'),
	(640164, 136, '2015-01-01 00:04:48.000000', 'consum', 0.0333, 'lps'),
	(640165, 136, '2015-01-01 00:04:49.000000', 'consum', 0.0333, 'lps'),
	(640166, 136, '2015-01-01 00:04:50.000000', 'consum', 0.0332, 'lps'),
	(640167, 136, '2015-01-01 00:04:51.000000', 'consum', 0.0326, 'lps'),
	(640168, 136, '2015-01-01 00:04:52.000000', 'consum', 0.0303, 'lps'),
	(640169, 136, '2015-01-01 00:04:53.000000', 'consum', 0.0325, 'lps'),
	(640170, 136, '2015-01-01 00:04:54.000000', 'consum', 0.0261, 'lps'),
	(640171, 136, '2015-01-01 00:04:55.000000', 'consum', 0.0245, 'lps'),
	(640172, 136, '2015-01-01 00:04:56.000000', 'consum', 0.0231, 'lps'),
	(640173, 136, '2015-01-01 00:04:57.000000', 'consum', 0.0210, 'lps'),
	(640174, 136, '2015-01-01 00:04:58.000000', 'consum', 0.0273, 'lps'),
	(640175, 136, '2015-01-01 00:04:59.000000', 'consum', 0.0277, 'lps'),
	(640176, 136, '2015-01-01 00:05:00.000000', 'consum', 0.0234, 'lps'),
	(640177, 136, '2015-01-01 00:05:01.000000', 'consum', 0.0251, 'lps'),
	(640178, 136, '2015-01-01 00:05:02.000000', 'consum', 0.0220, 'lps'),
	(640179, 136, '2015-01-01 00:05:03.000000', 'consum', 0.0262, 'lps'),
	(640180, 136, '2015-01-01 00:05:04.000000', 'consum', 0.0316, 'lps'),
	(640181, 136, '2015-01-01 00:05:05.000000', 'consum', 0.0213, 'lps'),
	(640182, 136, '2015-01-01 00:05:06.000000', 'consum', 0.0281, 'lps'),
	(640183, 136, '2015-01-01 00:05:07.000000', 'consum', 0.0309, 'lps'),
	(640184, 136, '2015-01-01 00:05:08.000000', 'consum', 0.0242, 'lps'),
	(640185, 136, '2015-01-01 00:05:09.000000', 'consum', 0.0321, 'lps'),
	(640186, 136, '2015-01-01 00:05:10.000000', 'consum', 0.0296, 'lps'),
	(640187, 136, '2015-01-01 00:05:11.000000', 'consum', 0.0311, 'lps'),
	(640188, 136, '2015-01-01 00:05:12.000000', 'consum', 0.0331, 'lps'),
	(640189, 136, '2015-01-01 00:05:13.000000', 'consum', 0.0267, 'lps'),
	(640190, 136, '2015-01-01 00:05:14.000000', 'consum', 0.0255, 'lps'),
	(640191, 136, '2015-01-01 00:05:15.000000', 'consum', 0.0266, 'lps'),
	(640192, 136, '2015-01-01 00:05:16.000000', 'consum', 0.0231, 'lps'),
	(640193, 136, '2015-01-01 00:05:17.000000', 'consum', 0.0271, 'lps'),
	(640194, 136, '2015-01-01 00:05:18.000000', 'consum', 0.0328, 'lps'),
	(640195, 136, '2015-01-01 00:05:19.000000', 'consum', 0.0245, 'lps'),
	(640196, 136, '2015-01-01 00:05:20.000000', 'consum', 0.0280, 'lps'),
	(640197, 136, '2015-01-01 00:05:21.000000', 'consum', 0.0331, 'lps'),
	(640198, 136, '2015-01-01 00:05:22.000000', 'consum', 0.0236, 'lps'),
	(640199, 136, '2015-01-01 00:05:23.000000', 'consum', 0.0223, 'lps'),
	(640200, 136, '2015-01-01 00:05:24.000000', 'consum', 0.0322, 'lps'),
	(640201, 136, '2015-01-01 00:05:25.000000', 'consum', 0.0234, 'lps'),
	(640202, 136, '2015-01-01 00:05:26.000000', 'consum', 0.0244, 'lps'),
	(640203, 136, '2015-01-01 00:05:27.000000', 'consum', 0.0307, 'lps'),
	(640204, 136, '2015-01-01 00:05:28.000000', 'consum', 0.0223, 'lps'),
	(640205, 136, '2015-01-01 00:05:29.000000', 'consum', 0.0233, 'lps'),
	(640206, 136, '2015-01-01 00:05:30.000000', 'consum', 0.0286, 'lps'),
	(640207, 136, '2015-01-01 00:05:31.000000', 'consum', 0.0275, 'lps'),
	(640208, 136, '2015-01-01 00:05:32.000000', 'consum', 0.0309, 'lps'),
	(640209, 136, '2015-01-01 00:05:33.000000', 'consum', 0.0259, 'lps'),
	(640210, 136, '2015-01-01 00:05:34.000000', 'consum', 0.0282, 'lps'),
	(640211, 136, '2015-01-01 00:05:35.000000', 'consum', 0.0300, 'lps'),
	(640212, 136, '2015-01-01 00:05:36.000000', 'consum', 0.0322, 'lps'),
	(640213, 136, '2015-01-01 00:05:37.000000', 'consum', 0.0252, 'lps'),
	(640214, 136, '2015-01-01 00:05:38.000000', 'consum', 0.0333, 'lps'),
	(640215, 136, '2015-01-01 00:05:39.000000', 'consum', 0.0328, 'lps'),
	(640216, 136, '2015-01-01 00:05:40.000000', 'consum', 0.0306, 'lps'),
	(640217, 136, '2015-01-01 00:05:41.000000', 'consum', 0.0211, 'lps'),
	(640218, 136, '2015-01-01 00:05:42.000000', 'consum', 0.0301, 'lps'),
	(640219, 136, '2015-01-01 00:05:43.000000', 'consum', 0.0290, 'lps'),
	(640220, 136, '2015-01-01 00:05:44.000000', 'consum', 0.0212, 'lps'),
	(640221, 136, '2015-01-01 00:05:45.000000', 'consum', 0.0231, 'lps'),
	(640222, 136, '2015-01-01 00:05:46.000000', 'consum', 0.0310, 'lps'),
	(640223, 136, '2015-01-01 00:05:47.000000', 'consum', 0.0272, 'lps'),
	(640224, 136, '2015-01-01 00:05:48.000000', 'consum', 0.0224, 'lps'),
	(640225, 136, '2015-01-01 00:05:49.000000', 'consum', 0.0219, 'lps'),
	(640226, 136, '2015-01-01 00:05:50.000000', 'consum', 0.0211, 'lps'),
	(640227, 136, '2015-01-01 00:05:51.000000', 'consum', 0.0314, 'lps'),
	(640228, 136, '2015-01-01 00:05:52.000000', 'consum', 0.0229, 'lps'),
	(640229, 136, '2015-01-01 00:05:53.000000', 'consum', 0.0245, 'lps'),
	(640230, 136, '2015-01-01 00:05:54.000000', 'consum', 0.0326, 'lps'),
	(640231, 136, '2015-01-01 00:05:55.000000', 'consum', 0.0312, 'lps'),
	(640232, 136, '2015-01-01 00:05:56.000000', 'consum', 0.0251, 'lps'),
	(640233, 136, '2015-01-01 00:05:57.000000', 'consum', 0.0233, 'lps'),
	(640234, 136, '2015-01-01 00:05:58.000000', 'consum', 0.0327, 'lps'),
	(640235, 136, '2015-01-01 00:05:59.000000', 'consum', 0.0228, 'lps'),
	(640236, 136, '2015-01-01 00:06:00.000000', 'consum', 0.0324, 'lps'),
	(640237, 136, '2015-01-01 00:06:01.000000', 'consum', 0.0230, 'lps'),
	(640238, 136, '2015-01-01 00:06:02.000000', 'consum', 0.0218, 'lps'),
	(640239, 136, '2015-01-01 00:06:03.000000', 'consum', 0.0313, 'lps'),
	(640240, 136, '2015-01-01 00:06:04.000000', 'consum', 0.0328, 'lps'),
	(640241, 136, '2015-01-01 00:06:05.000000', 'consum', 0.0247, 'lps'),
	(640242, 136, '2015-01-01 00:06:06.000000', 'consum', 0.0286, 'lps'),
	(640243, 136, '2015-01-01 00:06:07.000000', 'consum', 0.0232, 'lps'),
	(640244, 136, '2015-01-01 00:06:08.000000', 'consum', 0.0216, 'lps'),
	(640245, 136, '2015-01-01 00:06:09.000000', 'consum', 0.0300, 'lps'),
	(640246, 136, '2015-01-01 00:06:10.000000', 'consum', 0.0271, 'lps'),
	(640247, 136, '2015-01-01 00:06:11.000000', 'consum', 0.0243, 'lps'),
	(640248, 136, '2015-01-01 00:06:12.000000', 'consum', 0.0318, 'lps'),
	(640249, 136, '2015-01-01 00:06:13.000000', 'consum', 0.0279, 'lps'),
	(640250, 136, '2015-01-01 00:06:14.000000', 'consum', 0.0233, 'lps'),
	(640251, 136, '2015-01-01 00:06:15.000000', 'consum', 0.0243, 'lps'),
	(640252, 136, '2015-01-01 00:06:16.000000', 'consum', 0.0304, 'lps'),
	(640253, 136, '2015-01-01 00:06:17.000000', 'consum', 0.0211, 'lps'),
	(640254, 136, '2015-01-01 00:06:18.000000', 'consum', 0.0307, 'lps'),
	(640255, 136, '2015-01-01 00:06:19.000000', 'consum', 0.0318, 'lps'),
	(640256, 136, '2015-01-01 00:06:20.000000', 'consum', 0.0213, 'lps'),
	(640257, 136, '2015-01-01 00:06:21.000000', 'consum', 0.0274, 'lps'),
	(640258, 136, '2015-01-01 00:06:22.000000', 'consum', 0.0272, 'lps'),
	(640259, 136, '2015-01-01 00:06:23.000000', 'consum', 0.0331, 'lps'),
	(640260, 136, '2015-01-01 00:06:24.000000', 'consum', 0.0257, 'lps'),
	(640261, 136, '2015-01-01 00:06:25.000000', 'consum', 0.0329, 'lps'),
	(640262, 136, '2015-01-01 00:06:26.000000', 'consum', 0.0291, 'lps'),
	(640263, 136, '2015-01-01 00:06:27.000000', 'consum', 0.0262, 'lps'),
	(640264, 136, '2015-01-01 00:06:28.000000', 'consum', 0.0225, 'lps'),
	(640265, 136, '2015-01-01 00:06:29.000000', 'consum', 0.0256, 'lps'),
	(640266, 136, '2015-01-01 00:06:30.000000', 'consum', 0.0271, 'lps'),
	(640267, 136, '2015-01-01 00:06:31.000000', 'consum', 0.0253, 'lps'),
	(640268, 136, '2015-01-01 00:06:32.000000', 'consum', 0.0240, 'lps'),
	(640269, 136, '2015-01-01 00:06:33.000000', 'consum', 0.0235, 'lps'),
	(640270, 136, '2015-01-01 00:06:34.000000', 'consum', 0.0243, 'lps'),
	(640271, 136, '2015-01-01 00:06:35.000000', 'consum', 0.0303, 'lps'),
	(640272, 136, '2015-01-01 00:06:36.000000', 'consum', 0.0327, 'lps'),
	(640273, 136, '2015-01-01 00:06:37.000000', 'consum', 0.0270, 'lps'),
	(640274, 136, '2015-01-01 00:06:38.000000', 'consum', 0.0284, 'lps'),
	(640275, 136, '2015-01-01 00:06:39.000000', 'consum', 0.0275, 'lps'),
	(640276, 136, '2015-01-01 00:06:40.000000', 'consum', 0.0313, 'lps'),
	(640277, 136, '2015-01-01 00:06:41.000000', 'consum', 0.0282, 'lps'),
	(640278, 136, '2015-01-01 00:06:42.000000', 'consum', 0.0262, 'lps'),
	(640279, 136, '2015-01-01 00:06:43.000000', 'consum', 0.0254, 'lps'),
	(640280, 136, '2015-01-01 00:06:44.000000', 'consum', 0.0274, 'lps'),
	(640281, 136, '2015-01-01 00:06:45.000000', 'consum', 0.0275, 'lps'),
	(640282, 136, '2015-01-01 00:06:46.000000', 'consum', 0.0220, 'lps'),
	(640283, 136, '2015-01-01 00:06:47.000000', 'consum', 0.0315, 'lps'),
	(640284, 136, '2015-01-01 00:06:48.000000', 'consum', 0.0331, 'lps'),
	(640285, 136, '2015-01-01 00:06:49.000000', 'consum', 0.0254, 'lps'),
	(640286, 136, '2015-01-01 00:06:50.000000', 'consum', 0.0316, 'lps'),
	(640287, 136, '2015-01-01 00:06:51.000000', 'consum', 0.0238, 'lps'),
	(640288, 136, '2015-01-01 00:06:52.000000', 'consum', 0.0278, 'lps'),
	(640289, 136, '2015-01-01 00:06:53.000000', 'consum', 0.0221, 'lps'),
	(640290, 136, '2015-01-01 00:06:54.000000', 'consum', 0.0309, 'lps'),
	(640291, 136, '2015-01-01 00:06:55.000000', 'consum', 0.0299, 'lps'),
	(640292, 136, '2015-01-01 00:06:56.000000', 'consum', 0.0234, 'lps'),
	(640293, 136, '2015-01-01 00:06:57.000000', 'consum', 0.0311, 'lps'),
	(640294, 136, '2015-01-01 00:06:58.000000', 'consum', 0.0273, 'lps'),
	(640295, 136, '2015-01-01 00:06:59.000000', 'consum', 0.0221, 'lps'),
	(640296, 136, '2015-01-01 00:07:00.000000', 'consum', 0.0327, 'lps'),
	(640297, 136, '2015-01-01 00:07:01.000000', 'consum', 0.0263, 'lps'),
	(640298, 136, '2015-01-01 00:07:02.000000', 'consum', 0.0252, 'lps'),
	(640299, 136, '2015-01-01 00:07:03.000000', 'consum', 0.0259, 'lps'),
	(640300, 136, '2015-01-01 00:07:04.000000', 'consum', 0.0330, 'lps'),
	(640301, 136, '2015-01-01 00:07:05.000000', 'consum', 0.0290, 'lps'),
	(640302, 136, '2015-01-01 00:07:06.000000', 'consum', 0.0253, 'lps'),
	(640303, 136, '2015-01-01 00:07:07.000000', 'consum', 0.0309, 'lps'),
	(640304, 136, '2015-01-01 00:07:08.000000', 'consum', 0.0328, 'lps'),
	(640305, 136, '2015-01-01 00:07:09.000000', 'consum', 0.0257, 'lps'),
	(640306, 136, '2015-01-01 00:07:10.000000', 'consum', 0.0214, 'lps'),
	(640307, 136, '2015-01-01 00:07:11.000000', 'consum', 0.0213, 'lps'),
	(640308, 136, '2015-01-01 00:07:12.000000', 'consum', 0.0212, 'lps'),
	(640309, 136, '2015-01-01 00:07:13.000000', 'consum', 0.0214, 'lps'),
	(640310, 136, '2015-01-01 00:07:14.000000', 'consum', 0.0224, 'lps'),
	(640311, 136, '2015-01-01 00:07:15.000000', 'consum', 0.0270, 'lps'),
	(640312, 136, '2015-01-01 00:07:16.000000', 'consum', 0.0218, 'lps'),
	(640313, 136, '2015-01-01 00:07:17.000000', 'consum', 0.0319, 'lps'),
	(640314, 136, '2015-01-01 00:07:18.000000', 'consum', 0.0236, 'lps'),
	(640315, 136, '2015-01-01 00:07:19.000000', 'consum', 0.0260, 'lps'),
	(640316, 136, '2015-01-01 00:07:20.000000', 'consum', 0.0261, 'lps'),
	(640317, 136, '2015-01-01 00:07:21.000000', 'consum', 0.0313, 'lps'),
	(640318, 136, '2015-01-01 00:07:22.000000', 'consum', 0.0324, 'lps'),
	(640319, 136, '2015-01-01 00:07:23.000000', 'consum', 0.0225, 'lps'),
	(640320, 136, '2015-01-01 00:07:24.000000', 'consum', 0.0316, 'lps'),
	(640321, 136, '2015-01-01 00:07:25.000000', 'consum', 0.0325, 'lps'),
	(640322, 136, '2015-01-01 00:07:26.000000', 'consum', 0.0217, 'lps'),
	(640323, 136, '2015-01-01 00:07:27.000000', 'consum', 0.0274, 'lps'),
	(640324, 136, '2015-01-01 00:07:28.000000', 'consum', 0.0263, 'lps'),
	(640325, 136, '2015-01-01 00:07:29.000000', 'consum', 0.0280, 'lps'),
	(640326, 136, '2015-01-01 00:07:30.000000', 'consum', 0.0280, 'lps'),
	(640327, 136, '2015-01-01 00:07:31.000000', 'consum', 0.0225, 'lps'),
	(640328, 136, '2015-01-01 00:07:32.000000', 'consum', 0.0322, 'lps'),
	(640329, 136, '2015-01-01 00:07:33.000000', 'consum', 0.0232, 'lps'),
	(640330, 136, '2015-01-01 00:07:34.000000', 'consum', 0.0233, 'lps'),
	(640331, 136, '2015-01-01 00:07:35.000000', 'consum', 0.0257, 'lps'),
	(640332, 136, '2015-01-01 00:07:36.000000', 'consum', 0.0254, 'lps'),
	(640333, 136, '2015-01-01 00:07:37.000000', 'consum', 0.0289, 'lps'),
	(640334, 136, '2015-01-01 00:07:38.000000', 'consum', 0.0224, 'lps'),
	(640335, 136, '2015-01-01 00:07:39.000000', 'consum', 0.0294, 'lps'),
	(640336, 136, '2015-01-01 00:07:40.000000', 'consum', 0.0216, 'lps'),
	(640337, 136, '2015-01-01 00:07:41.000000', 'consum', 0.0235, 'lps'),
	(640338, 136, '2015-01-01 00:07:42.000000', 'consum', 0.0317, 'lps'),
	(640339, 136, '2015-01-01 00:07:43.000000', 'consum', 0.0300, 'lps'),
	(640340, 136, '2015-01-01 00:07:44.000000', 'consum', 0.0216, 'lps'),
	(640341, 136, '2015-01-01 00:07:45.000000', 'consum', 0.0217, 'lps'),
	(640342, 136, '2015-01-01 00:07:46.000000', 'consum', 0.0229, 'lps'),
	(640343, 136, '2015-01-01 00:07:47.000000', 'consum', 0.0285, 'lps'),
	(640344, 136, '2015-01-01 00:07:48.000000', 'consum', 0.0278, 'lps'),
	(640345, 136, '2015-01-01 00:07:49.000000', 'consum', 0.0326, 'lps'),
	(640346, 136, '2015-01-01 00:07:50.000000', 'consum', 0.0215, 'lps'),
	(640347, 136, '2015-01-01 00:07:51.000000', 'consum', 0.0258, 'lps'),
	(640348, 136, '2015-01-01 00:07:52.000000', 'consum', 0.0314, 'lps'),
	(640349, 136, '2015-01-01 00:07:53.000000', 'consum', 0.0215, 'lps'),
	(640350, 136, '2015-01-01 00:07:54.000000', 'consum', 0.0294, 'lps'),
	(640351, 136, '2015-01-01 00:07:55.000000', 'consum', 0.0245, 'lps'),
	(640352, 136, '2015-01-01 00:07:56.000000', 'consum', 0.0257, 'lps'),
	(640353, 136, '2015-01-01 00:07:57.000000', 'consum', 0.0216, 'lps'),
	(640354, 136, '2015-01-01 00:07:58.000000', 'consum', 0.0224, 'lps'),
	(640355, 136, '2015-01-01 00:07:59.000000', 'consum', 0.0264, 'lps'),
	(640356, 136, '2015-01-01 00:08:00.000000', 'consum', 0.0314, 'lps'),
	(640357, 136, '2015-01-01 00:08:01.000000', 'consum', 0.0320, 'lps'),
	(640358, 136, '2015-01-01 00:08:02.000000', 'consum', 0.0325, 'lps'),
	(640359, 136, '2015-01-01 00:08:03.000000', 'consum', 0.0333, 'lps'),
	(640360, 136, '2015-01-01 00:08:04.000000', 'consum', 0.0230, 'lps'),
	(640361, 136, '2015-01-01 00:08:05.000000', 'consum', 0.0314, 'lps'),
	(640362, 136, '2015-01-01 00:08:06.000000', 'consum', 0.0298, 'lps'),
	(640363, 136, '2015-01-01 00:08:07.000000', 'consum', 0.0213, 'lps'),
	(640364, 136, '2015-01-01 00:08:08.000000', 'consum', 0.0213, 'lps'),
	(640365, 136, '2015-01-01 00:08:09.000000', 'consum', 0.0214, 'lps'),
	(640366, 136, '2015-01-01 00:08:10.000000', 'consum', 0.0223, 'lps'),
	(640367, 136, '2015-01-01 00:08:11.000000', 'consum', 0.0262, 'lps'),
	(640368, 136, '2015-01-01 00:08:12.000000', 'consum', 0.0308, 'lps'),
	(640369, 136, '2015-01-01 00:08:13.000000', 'consum', 0.0296, 'lps'),
	(640370, 136, '2015-01-01 00:08:14.000000', 'consum', 0.0223, 'lps'),
	(640371, 136, '2015-01-01 00:08:15.000000', 'consum', 0.0266, 'lps'),
	(640372, 136, '2015-01-01 00:08:16.000000', 'consum', 0.0329, 'lps'),
	(640373, 136, '2015-01-01 00:08:17.000000', 'consum', 0.0264, 'lps'),
	(640374, 136, '2015-01-01 00:08:18.000000', 'consum', 0.0246, 'lps'),
	(640375, 136, '2015-01-01 00:08:19.000000', 'consum', 0.0229, 'lps'),
	(640376, 136, '2015-01-01 00:08:20.000000', 'consum', 0.0320, 'lps'),
	(640377, 136, '2015-01-01 00:08:21.000000', 'consum', 0.0210, 'lps'),
	(640378, 136, '2015-01-01 00:08:22.000000', 'consum', 0.0254, 'lps'),
	(640379, 136, '2015-01-01 00:08:23.000000', 'consum', 0.0304, 'lps'),
	(640380, 136, '2015-01-01 00:08:24.000000', 'consum', 0.0302, 'lps'),
	(640381, 136, '2015-01-01 00:08:25.000000', 'consum', 0.0262, 'lps'),
	(640382, 136, '2015-01-01 00:08:26.000000', 'consum', 0.0321, 'lps'),
	(640383, 136, '2015-01-01 00:08:27.000000', 'consum', 0.0238, 'lps'),
	(640384, 136, '2015-01-01 00:08:28.000000', 'consum', 0.0263, 'lps'),
	(640385, 136, '2015-01-01 00:08:29.000000', 'consum', 0.0269, 'lps'),
	(640386, 136, '2015-01-01 00:08:30.000000', 'consum', 0.0224, 'lps'),
	(640387, 136, '2015-01-01 00:08:31.000000', 'consum', 0.0227, 'lps'),
	(640388, 136, '2015-01-01 00:08:32.000000', 'consum', 0.0252, 'lps'),
	(640389, 136, '2015-01-01 00:08:33.000000', 'consum', 0.0246, 'lps'),
	(640390, 136, '2015-01-01 00:08:34.000000', 'consum', 0.0265, 'lps'),
	(640391, 136, '2015-01-01 00:08:35.000000', 'consum', 0.0252, 'lps'),
	(640392, 136, '2015-01-01 00:08:36.000000', 'consum', 0.0258, 'lps'),
	(640393, 136, '2015-01-01 00:08:37.000000', 'consum', 0.0322, 'lps'),
	(640394, 136, '2015-01-01 00:08:38.000000', 'consum', 0.0256, 'lps'),
	(640395, 136, '2015-01-01 00:08:39.000000', 'consum', 0.0228, 'lps'),
	(640396, 136, '2015-01-01 00:08:40.000000', 'consum', 0.0288, 'lps'),
	(640397, 136, '2015-01-01 00:08:41.000000', 'consum', 0.0295, 'lps'),
	(640398, 136, '2015-01-01 00:08:42.000000', 'consum', 0.0281, 'lps'),
	(640399, 136, '2015-01-01 00:08:43.000000', 'consum', 0.0310, 'lps'),
	(640400, 136, '2015-01-01 00:08:44.000000', 'consum', 0.0249, 'lps'),
	(640401, 136, '2015-01-01 00:08:45.000000', 'consum', 0.0229, 'lps'),
	(640402, 136, '2015-01-01 00:08:46.000000', 'consum', 0.0312, 'lps'),
	(640403, 136, '2015-01-01 00:08:47.000000', 'consum', 0.0293, 'lps'),
	(640404, 136, '2015-01-01 00:08:48.000000', 'consum', 0.0320, 'lps'),
	(640405, 136, '2015-01-01 00:08:49.000000', 'consum', 0.0261, 'lps'),
	(640406, 136, '2015-01-01 00:08:50.000000', 'consum', 0.0260, 'lps'),
	(640407, 136, '2015-01-01 00:08:51.000000', 'consum', 0.0307, 'lps'),
	(640408, 136, '2015-01-01 00:08:52.000000', 'consum', 0.0300, 'lps'),
	(640409, 136, '2015-01-01 00:08:53.000000', 'consum', 0.0246, 'lps'),
	(640410, 136, '2015-01-01 00:08:54.000000', 'consum', 0.0242, 'lps'),
	(640411, 136, '2015-01-01 00:08:55.000000', 'consum', 0.0262, 'lps'),
	(640412, 136, '2015-01-01 00:08:56.000000', 'consum', 0.0250, 'lps'),
	(640413, 136, '2015-01-01 00:08:57.000000', 'consum', 0.0257, 'lps'),
	(640414, 136, '2015-01-01 00:08:58.000000', 'consum', 0.0324, 'lps'),
	(640415, 136, '2015-01-01 00:08:59.000000', 'consum', 0.0266, 'lps'),
	(640416, 136, '2015-01-01 00:09:00.000000', 'consum', 0.0273, 'lps'),
	(640417, 136, '2015-01-01 00:09:01.000000', 'consum', 0.0232, 'lps'),
	(640418, 136, '2015-01-01 00:09:02.000000', 'consum', 0.0257, 'lps'),
	(640419, 136, '2015-01-01 00:09:03.000000', 'consum', 0.0255, 'lps'),
	(640420, 136, '2015-01-01 00:09:04.000000', 'consum', 0.0294, 'lps'),
	(640421, 136, '2015-01-01 00:09:05.000000', 'consum', 0.0247, 'lps'),
	(640422, 136, '2015-01-01 00:09:06.000000', 'consum', 0.0267, 'lps'),
	(640423, 136, '2015-01-01 00:09:07.000000', 'consum', 0.0260, 'lps'),
	(640424, 136, '2015-01-01 00:09:08.000000', 'consum', 0.0290, 'lps'),
	(640425, 136, '2015-01-01 00:09:09.000000', 'consum', 0.0212, 'lps'),
	(640426, 136, '2015-01-01 00:09:10.000000', 'consum', 0.0228, 'lps'),
	(640427, 136, '2015-01-01 00:09:11.000000', 'consum', 0.0296, 'lps'),
	(640428, 136, '2015-01-01 00:09:12.000000', 'consum', 0.0213, 'lps'),
	(640429, 136, '2015-01-01 00:09:13.000000', 'consum', 0.0218, 'lps'),
	(640430, 136, '2015-01-01 00:09:14.000000', 'consum', 0.0241, 'lps'),
	(640431, 136, '2015-01-01 00:09:15.000000', 'consum', 0.0218, 'lps'),
	(640432, 136, '2015-01-01 00:09:16.000000', 'consum', 0.0280, 'lps'),
	(640433, 136, '2015-01-01 00:09:17.000000', 'consum', 0.0288, 'lps'),
	(640434, 136, '2015-01-01 00:09:18.000000', 'consum', 0.0268, 'lps'),
	(640435, 136, '2015-01-01 00:09:19.000000', 'consum', 0.0267, 'lps'),
	(640436, 136, '2015-01-01 00:09:20.000000', 'consum', 0.0322, 'lps'),
	(640437, 136, '2015-01-01 00:09:21.000000', 'consum', 0.0225, 'lps'),
	(640438, 136, '2015-01-01 00:09:22.000000', 'consum', 0.0324, 'lps'),
	(640439, 136, '2015-01-01 00:09:23.000000', 'consum', 0.0237, 'lps'),
	(640440, 136, '2015-01-01 00:09:24.000000', 'consum', 0.0253, 'lps'),
	(640441, 136, '2015-01-01 00:09:25.000000', 'consum', 0.0219, 'lps'),
	(640442, 136, '2015-01-01 00:09:26.000000', 'consum', 0.0250, 'lps'),
	(640443, 136, '2015-01-01 00:09:27.000000', 'consum', 0.0260, 'lps'),
	(640444, 136, '2015-01-01 00:09:28.000000', 'consum', 0.0215, 'lps'),
	(640445, 136, '2015-01-01 00:09:29.000000', 'consum', 0.0212, 'lps'),
	(640446, 136, '2015-01-01 00:09:30.000000', 'consum', 0.0331, 'lps'),
	(640447, 136, '2015-01-01 00:09:31.000000', 'consum', 0.0310, 'lps'),
	(640448, 136, '2015-01-01 00:09:32.000000', 'consum', 0.0226, 'lps'),
	(640449, 136, '2015-01-01 00:09:33.000000', 'consum', 0.0239, 'lps'),
	(640450, 136, '2015-01-01 00:09:34.000000', 'consum', 0.0306, 'lps'),
	(640451, 136, '2015-01-01 00:09:35.000000', 'consum', 0.0231, 'lps'),
	(640452, 136, '2015-01-01 00:09:36.000000', 'consum', 0.0274, 'lps'),
	(640453, 136, '2015-01-01 00:09:37.000000', 'consum', 0.0223, 'lps'),
	(640454, 136, '2015-01-01 00:09:38.000000', 'consum', 0.0328, 'lps'),
	(640455, 136, '2015-01-01 00:09:39.000000', 'consum', 0.0268, 'lps'),
	(640456, 136, '2015-01-01 00:09:40.000000', 'consum', 0.0272, 'lps'),
	(640457, 136, '2015-01-01 00:09:41.000000', 'consum', 0.0219, 'lps'),
	(640458, 136, '2015-01-01 00:09:42.000000', 'consum', 0.0320, 'lps'),
	(640459, 136, '2015-01-01 00:09:43.000000', 'consum', 0.0237, 'lps'),
	(640460, 136, '2015-01-01 00:09:44.000000', 'consum', 0.0263, 'lps'),
	(640461, 136, '2015-01-01 00:09:45.000000', 'consum', 0.0271, 'lps'),
	(640462, 136, '2015-01-01 00:09:46.000000', 'consum', 0.0234, 'lps'),
	(640463, 136, '2015-01-01 00:09:47.000000', 'consum', 0.0270, 'lps'),
	(640464, 136, '2015-01-01 00:09:48.000000', 'consum', 0.0314, 'lps'),
	(640465, 136, '2015-01-01 00:09:49.000000', 'consum', 0.0302, 'lps'),
	(640466, 136, '2015-01-01 00:09:50.000000', 'consum', 0.0237, 'lps'),
	(640467, 136, '2015-01-01 00:09:51.000000', 'consum', 0.0318, 'lps'),
	(640468, 136, '2015-01-01 00:09:52.000000', 'consum', 0.0295, 'lps'),
	(640469, 136, '2015-01-01 00:09:53.000000', 'consum', 0.0313, 'lps'),
	(640470, 136, '2015-01-01 00:09:54.000000', 'consum', 0.0220, 'lps'),
	(640471, 136, '2015-01-01 00:09:55.000000', 'consum', 0.0327, 'lps'),
	(640472, 136, '2015-01-01 00:09:56.000000', 'consum', 0.0267, 'lps'),
	(640473, 136, '2015-01-01 00:09:57.000000', 'consum', 0.0269, 'lps'),
	(640474, 136, '2015-01-01 00:09:58.000000', 'consum', 0.0212, 'lps'),
	(640475, 136, '2015-01-01 00:09:59.000000', 'consum', 0.0289, 'lps'),
	(640476, 136, '2015-01-01 00:10:00.000000', 'consum', 0.0231, 'lps'),
	(640477, 136, '2015-01-01 00:10:01.000000', 'consum', 0.0323, 'lps'),
	(640478, 136, '2015-01-01 00:10:02.000000', 'consum', 0.0217, 'lps'),
	(640479, 136, '2015-01-01 00:10:03.000000', 'consum', 0.0277, 'lps'),
	(640480, 136, '2015-01-01 00:10:04.000000', 'consum', 0.0280, 'lps'),
	(640481, 136, '2015-01-01 00:10:05.000000', 'consum', 0.0232, 'lps'),
	(640482, 136, '2015-01-01 00:10:06.000000', 'consum', 0.0236, 'lps'),
	(640483, 136, '2015-01-01 00:10:07.000000', 'consum', 0.0275, 'lps'),
	(640484, 136, '2015-01-01 00:10:08.000000', 'consum', 0.0333, 'lps'),
	(640485, 136, '2015-01-01 00:10:09.000000', 'consum', 0.0261, 'lps'),
	(640486, 136, '2015-01-01 00:10:10.000000', 'consum', 0.0217, 'lps'),
	(640487, 136, '2015-01-01 00:10:11.000000', 'consum', 0.0220, 'lps'),
	(640488, 136, '2015-01-01 00:10:12.000000', 'consum', 0.0236, 'lps'),
	(640489, 136, '2015-01-01 00:10:13.000000', 'consum', 0.0314, 'lps'),
	(640490, 136, '2015-01-01 00:10:14.000000', 'consum', 0.0278, 'lps'),
	(640491, 136, '2015-01-01 00:10:15.000000', 'consum', 0.0237, 'lps'),
	(640492, 136, '2015-01-01 00:10:16.000000', 'consum', 0.0269, 'lps'),
	(640493, 136, '2015-01-01 00:10:17.000000', 'consum', 0.0299, 'lps'),
	(640494, 136, '2015-01-01 00:10:18.000000', 'consum', 0.0232, 'lps'),
	(640495, 136, '2015-01-01 00:10:19.000000', 'consum', 0.0302, 'lps'),
	(640496, 136, '2015-01-01 00:10:20.000000', 'consum', 0.0230, 'lps'),
	(640497, 136, '2015-01-01 00:10:21.000000', 'consum', 0.0285, 'lps'),
	(640498, 136, '2015-01-01 00:10:22.000000', 'consum', 0.0275, 'lps'),
	(640499, 136, '2015-01-01 00:10:23.000000', 'consum', 0.0313, 'lps'),
	(640500, 136, '2015-01-01 00:10:24.000000', 'consum', 0.0280, 'lps'),
	(640501, 136, '2015-01-01 00:10:25.000000', 'consum', 0.0253, 'lps'),
	(640502, 136, '2015-01-01 00:10:26.000000', 'consum', 0.0217, 'lps'),
	(640503, 136, '2015-01-01 00:10:27.000000', 'consum', 0.0238, 'lps'),
	(640504, 136, '2015-01-01 00:10:28.000000', 'consum', 0.0332, 'lps'),
	(640505, 136, '2015-01-01 00:10:29.000000', 'consum', 0.0239, 'lps'),
	(640506, 136, '2015-01-01 00:10:30.000000', 'consum', 0.0236, 'lps'),
	(640507, 136, '2015-01-01 00:10:31.000000', 'consum', 0.0255, 'lps'),
	(640508, 136, '2015-01-01 00:10:32.000000', 'consum', 0.0232, 'lps'),
	(640509, 136, '2015-01-01 00:10:33.000000', 'consum', 0.0311, 'lps'),
	(640510, 136, '2015-01-01 00:10:34.000000', 'consum', 0.0276, 'lps'),
	(640511, 136, '2015-01-01 00:10:35.000000', 'consum', 0.0239, 'lps'),
	(640512, 136, '2015-01-01 00:10:36.000000', 'consum', 0.0282, 'lps'),
	(640513, 136, '2015-01-01 00:10:37.000000', 'consum', 0.0234, 'lps'),
	(640514, 136, '2015-01-01 00:10:38.000000', 'consum', 0.0240, 'lps'),
	(640515, 136, '2015-01-01 00:10:39.000000', 'consum', 0.0287, 'lps'),
	(640516, 136, '2015-01-01 00:10:40.000000', 'consum', 0.0256, 'lps'),
	(640517, 136, '2015-01-01 00:10:41.000000', 'consum', 0.0212, 'lps'),
	(640518, 136, '2015-01-01 00:10:42.000000', 'consum', 0.0328, 'lps'),
	(640519, 136, '2015-01-01 00:10:43.000000', 'consum', 0.0300, 'lps'),
	(640520, 136, '2015-01-01 00:10:44.000000', 'consum', 0.0305, 'lps'),
	(640521, 136, '2015-01-01 00:10:45.000000', 'consum', 0.0291, 'lps'),
	(640522, 136, '2015-01-01 00:10:46.000000', 'consum', 0.0333, 'lps'),
	(640523, 136, '2015-01-01 00:10:47.000000', 'consum', 0.0211, 'lps'),
	(640524, 136, '2015-01-01 00:10:48.000000', 'consum', 0.0215, 'lps'),
	(640525, 136, '2015-01-01 00:10:49.000000', 'consum', 0.0236, 'lps'),
	(640526, 136, '2015-01-01 00:10:50.000000', 'consum', 0.0325, 'lps'),
	(640527, 136, '2015-01-01 00:10:51.000000', 'consum', 0.0212, 'lps'),
	(640528, 136, '2015-01-01 00:10:52.000000', 'consum', 0.0245, 'lps'),
	(640529, 136, '2015-01-01 00:10:53.000000', 'consum', 0.0255, 'lps'),
	(640530, 136, '2015-01-01 00:10:54.000000', 'consum', 0.0210, 'lps'),
	(640531, 136, '2015-01-01 00:10:55.000000', 'consum', 0.0320, 'lps'),
	(640532, 136, '2015-01-01 00:10:56.000000', 'consum', 0.0265, 'lps'),
	(640533, 136, '2015-01-01 00:10:57.000000', 'consum', 0.0282, 'lps'),
	(640534, 136, '2015-01-01 00:10:58.000000', 'consum', 0.0279, 'lps'),
	(640535, 136, '2015-01-01 00:10:59.000000', 'consum', 0.0216, 'lps'),
	(640536, 136, '2015-01-01 00:11:00.000000', 'consum', 0.0280, 'lps'),
	(640537, 136, '2015-01-01 00:11:01.000000', 'consum', 0.0295, 'lps'),
	(640538, 136, '2015-01-01 00:11:02.000000', 'consum', 0.0301, 'lps'),
	(640539, 136, '2015-01-01 00:11:03.000000', 'consum', 0.0288, 'lps'),
	(640540, 136, '2015-01-01 00:11:04.000000', 'consum', 0.0328, 'lps'),
	(640541, 136, '2015-01-01 00:11:05.000000', 'consum', 0.0317, 'lps'),
	(640542, 136, '2015-01-01 00:11:06.000000', 'consum', 0.0269, 'lps'),
	(640543, 136, '2015-01-01 00:11:07.000000', 'consum', 0.0306, 'lps'),
	(640544, 136, '2015-01-01 00:11:08.000000', 'consum', 0.0268, 'lps'),
	(640545, 136, '2015-01-01 00:11:09.000000', 'consum', 0.0211, 'lps'),
	(640546, 136, '2015-01-01 00:11:10.000000', 'consum', 0.0289, 'lps'),
	(640547, 136, '2015-01-01 00:11:11.000000', 'consum', 0.0231, 'lps'),
	(640548, 136, '2015-01-01 00:11:12.000000', 'consum', 0.0328, 'lps'),
	(640549, 136, '2015-01-01 00:11:13.000000', 'consum', 0.0241, 'lps'),
	(640550, 136, '2015-01-01 00:11:14.000000', 'consum', 0.0260, 'lps'),
	(640551, 136, '2015-01-01 00:11:15.000000', 'consum', 0.0245, 'lps'),
	(640552, 136, '2015-01-01 00:11:16.000000', 'consum', 0.0233, 'lps'),
	(640553, 136, '2015-01-01 00:11:17.000000', 'consum', 0.0221, 'lps'),
	(640554, 136, '2015-01-01 00:11:18.000000', 'consum', 0.0321, 'lps'),
	(640555, 136, '2015-01-01 00:11:19.000000', 'consum', 0.0235, 'lps'),
	(640556, 136, '2015-01-01 00:11:20.000000', 'consum', 0.0253, 'lps'),
	(640557, 136, '2015-01-01 00:11:21.000000', 'consum', 0.0223, 'lps'),
	(640558, 136, '2015-01-01 00:11:22.000000', 'consum', 0.0273, 'lps'),
	(640559, 136, '2015-01-01 00:11:23.000000', 'consum', 0.0239, 'lps'),
	(640560, 136, '2015-01-01 00:11:24.000000', 'consum', 0.0290, 'lps'),
	(640561, 136, '2015-01-01 00:11:25.000000', 'consum', 0.0275, 'lps'),
	(640562, 136, '2015-01-01 00:11:26.000000', 'consum', 0.0297, 'lps'),
	(640563, 136, '2015-01-01 00:11:27.000000', 'consum', 0.0327, 'lps'),
	(640564, 136, '2015-01-01 00:11:28.000000', 'consum', 0.0287, 'lps'),
	(640565, 136, '2015-01-01 00:11:29.000000', 'consum', 0.0245, 'lps'),
	(640566, 136, '2015-01-01 00:11:30.000000', 'consum', 0.0276, 'lps'),
	(640567, 136, '2015-01-01 00:11:31.000000', 'consum', 0.0311, 'lps'),
	(640568, 136, '2015-01-01 00:11:32.000000', 'consum', 0.0270, 'lps'),
	(640569, 136, '2015-01-01 00:11:33.000000', 'consum', 0.0333, 'lps'),
	(640570, 136, '2015-01-01 00:11:34.000000', 'consum', 0.0272, 'lps'),
	(640571, 136, '2015-01-01 00:11:35.000000', 'consum', 0.0278, 'lps'),
	(640572, 136, '2015-01-01 00:11:36.000000', 'consum', 0.0239, 'lps'),
	(640573, 136, '2015-01-01 00:11:37.000000', 'consum', 0.0276, 'lps'),
	(640574, 136, '2015-01-01 00:11:38.000000', 'consum', 0.0328, 'lps'),
	(640575, 136, '2015-01-01 00:11:39.000000', 'consum', 0.0230, 'lps'),
	(640576, 136, '2015-01-01 00:11:40.000000', 'consum', 0.0328, 'lps'),
	(640577, 136, '2015-01-01 00:11:41.000000', 'consum', 0.0244, 'lps'),
	(640578, 136, '2015-01-01 00:11:42.000000', 'consum', 0.0277, 'lps'),
	(640579, 136, '2015-01-01 00:11:43.000000', 'consum', 0.0317, 'lps'),
	(640580, 136, '2015-01-01 00:11:44.000000', 'consum', 0.0296, 'lps'),
	(640581, 136, '2015-01-01 00:11:45.000000', 'consum', 0.0322, 'lps'),
	(640582, 136, '2015-01-01 00:11:46.000000', 'consum', 0.0263, 'lps'),
	(640583, 136, '2015-01-01 00:11:47.000000', 'consum', 0.0264, 'lps'),
	(640584, 136, '2015-01-01 00:11:48.000000', 'consum', 0.0321, 'lps'),
	(640585, 136, '2015-01-01 00:11:49.000000', 'consum', 0.0233, 'lps'),
	(640586, 136, '2015-01-01 00:11:50.000000', 'consum', 0.0239, 'lps'),
	(640587, 136, '2015-01-01 00:11:51.000000', 'consum', 0.0286, 'lps'),
	(640588, 136, '2015-01-01 00:11:52.000000', 'consum', 0.0258, 'lps'),
	(640589, 136, '2015-01-01 00:11:53.000000', 'consum', 0.0222, 'lps'),
	(640590, 136, '2015-01-01 00:11:54.000000', 'consum', 0.0248, 'lps'),
	(640591, 136, '2015-01-01 00:11:55.000000', 'consum', 0.0242, 'lps'),
	(640592, 136, '2015-01-01 00:11:56.000000', 'consum', 0.0256, 'lps'),
	(640593, 136, '2015-01-01 00:11:57.000000', 'consum', 0.0221, 'lps'),
	(640594, 136, '2015-01-01 00:11:58.000000', 'consum', 0.0252, 'lps'),
	(640595, 136, '2015-01-01 00:11:59.000000', 'consum', 0.0261, 'lps'),
	(640596, 136, '2015-01-01 00:12:00.000000', 'consum', 0.0218, 'lps'),
	(640597, 136, '2015-01-01 00:12:01.000000', 'consum', 0.0222, 'lps'),
	(640598, 136, '2015-01-01 00:12:02.000000', 'consum', 0.0247, 'lps'),
	(640599, 136, '2015-01-01 00:12:03.000000', 'consum', 0.0233, 'lps'),
	(640600, 136, '2015-01-01 00:12:04.000000', 'consum', 0.0217, 'lps'),
	(640601, 136, '2015-01-01 00:12:05.000000', 'consum', 0.0300, 'lps'),
	(640602, 136, '2015-01-01 00:12:06.000000', 'consum', 0.0266, 'lps'),
	(640603, 136, '2015-01-01 00:12:07.000000', 'consum', 0.0222, 'lps'),
	(640604, 136, '2015-01-01 00:12:08.000000', 'consum', 0.0228, 'lps'),
	(640605, 136, '2015-01-01 00:12:09.000000', 'consum', 0.0263, 'lps'),
	(640606, 136, '2015-01-01 00:12:10.000000', 'consum', 0.0296, 'lps'),
	(640607, 136, '2015-01-01 00:12:11.000000', 'consum', 0.0234, 'lps'),
	(640608, 136, '2015-01-01 00:12:12.000000', 'consum', 0.0323, 'lps'),
	(640609, 136, '2015-01-01 00:12:13.000000', 'consum', 0.0329, 'lps'),
	(640610, 136, '2015-01-01 00:12:14.000000', 'consum', 0.0219, 'lps'),
	(640611, 136, '2015-01-01 00:12:15.000000', 'consum', 0.0269, 'lps'),
	(640612, 136, '2015-01-01 00:12:16.000000', 'consum', 0.0233, 'lps'),
	(640613, 136, '2015-01-01 00:12:17.000000', 'consum', 0.0271, 'lps'),
	(640614, 136, '2015-01-01 00:12:18.000000', 'consum', 0.0322, 'lps'),
	(640615, 136, '2015-01-01 00:12:19.000000', 'consum', 0.0215, 'lps'),
	(640616, 136, '2015-01-01 00:12:20.000000', 'consum', 0.0271, 'lps'),
	(640617, 136, '2015-01-01 00:12:21.000000', 'consum', 0.0252, 'lps'),
	(640618, 136, '2015-01-01 00:12:22.000000', 'consum', 0.0240, 'lps'),
	(640619, 136, '2015-01-01 00:12:23.000000', 'consum', 0.0234, 'lps'),
	(640620, 136, '2015-01-01 00:12:24.000000', 'consum', 0.0241, 'lps'),
	(640621, 136, '2015-01-01 00:12:25.000000', 'consum', 0.0294, 'lps'),
	(640622, 136, '2015-01-01 00:12:26.000000', 'consum', 0.0290, 'lps'),
	(640623, 136, '2015-01-01 00:12:27.000000', 'consum', 0.0232, 'lps'),
	(640624, 136, '2015-01-01 00:12:28.000000', 'consum', 0.0328, 'lps'),
	(640625, 136, '2015-01-01 00:12:29.000000', 'consum', 0.0241, 'lps'),
	(640626, 136, '2015-01-01 00:12:30.000000', 'consum', 0.0257, 'lps'),
	(640627, 136, '2015-01-01 00:12:31.000000', 'consum', 0.0232, 'lps'),
	(640628, 136, '2015-01-01 00:12:32.000000', 'consum', 0.0300, 'lps'),
	(640629, 136, '2015-01-01 00:12:33.000000', 'consum', 0.0224, 'lps'),
	(640630, 136, '2015-01-01 00:12:34.000000', 'consum', 0.0260, 'lps'),
	(640631, 136, '2015-01-01 00:12:35.000000', 'consum', 0.0294, 'lps'),
	(640632, 136, '2015-01-01 00:12:36.000000', 'consum', 0.0231, 'lps'),
	(640633, 136, '2015-01-01 00:12:37.000000', 'consum', 0.0311, 'lps'),
	(640634, 136, '2015-01-01 00:12:38.000000', 'consum', 0.0283, 'lps'),
	(640635, 136, '2015-01-01 00:12:39.000000', 'consum', 0.0270, 'lps'),
	(640636, 136, '2015-01-01 00:12:40.000000', 'consum', 0.0291, 'lps'),
	(640637, 136, '2015-01-01 00:12:41.000000', 'consum', 0.0311, 'lps'),
	(640638, 136, '2015-01-01 00:12:42.000000', 'consum', 0.0227, 'lps'),
	(640639, 136, '2015-01-01 00:12:43.000000', 'consum', 0.0239, 'lps'),
	(640640, 136, '2015-01-01 00:12:44.000000', 'consum', 0.0304, 'lps'),
	(640641, 136, '2015-01-01 00:12:45.000000', 'consum', 0.0222, 'lps'),
	(640642, 136, '2015-01-01 00:12:46.000000', 'consum', 0.0235, 'lps'),
	(640643, 136, '2015-01-01 00:12:47.000000', 'consum', 0.0301, 'lps'),
	(640644, 136, '2015-01-01 00:12:48.000000', 'consum', 0.0220, 'lps'),
	(640645, 136, '2015-01-01 00:12:49.000000', 'consum', 0.0233, 'lps'),
	(640646, 136, '2015-01-01 00:12:50.000000', 'consum', 0.0297, 'lps'),
	(640647, 136, '2015-01-01 00:12:51.000000', 'consum', 0.0329, 'lps'),
	(640648, 136, '2015-01-01 00:12:52.000000', 'consum', 0.0294, 'lps'),
	(640649, 136, '2015-01-01 00:12:53.000000', 'consum', 0.0274, 'lps'),
	(640650, 136, '2015-01-01 00:12:54.000000', 'consum', 0.0281, 'lps'),
	(640651, 136, '2015-01-01 00:12:55.000000', 'consum', 0.0249, 'lps'),
	(640652, 136, '2015-01-01 00:12:56.000000', 'consum', 0.0315, 'lps'),
	(640653, 136, '2015-01-01 00:12:57.000000', 'consum', 0.0247, 'lps'),
	(640654, 136, '2015-01-01 00:12:58.000000', 'consum', 0.0328, 'lps'),
	(640655, 136, '2015-01-01 00:12:59.000000', 'consum', 0.0319, 'lps'),
	(640656, 136, '2015-01-01 00:13:00.000000', 'consum', 0.0278, 'lps'),
	(640657, 136, '2015-01-01 00:13:01.000000', 'consum', 0.0221, 'lps'),
	(640658, 136, '2015-01-01 00:13:02.000000', 'consum', 0.0311, 'lps'),
	(640659, 136, '2015-01-01 00:13:03.000000', 'consum', 0.0311, 'lps'),
	(640660, 136, '2015-01-01 00:13:04.000000', 'consum', 0.0286, 'lps'),
	(640661, 136, '2015-01-01 00:13:05.000000', 'consum', 0.0289, 'lps'),
	(640662, 136, '2015-01-01 00:13:06.000000', 'consum', 0.0255, 'lps'),
	(640663, 136, '2015-01-01 00:13:07.000000', 'consum', 0.0322, 'lps'),
	(640664, 136, '2015-01-01 00:13:08.000000', 'consum', 0.0262, 'lps'),
	(640665, 136, '2015-01-01 00:13:09.000000', 'consum', 0.0258, 'lps'),
	(640666, 136, '2015-01-01 00:13:10.000000', 'consum', 0.0296, 'lps'),
	(640667, 136, '2015-01-01 00:13:11.000000', 'consum', 0.0250, 'lps'),
	(640668, 136, '2015-01-01 00:13:12.000000', 'consum', 0.0276, 'lps'),
	(640669, 136, '2015-01-01 00:13:13.000000', 'consum', 0.0296, 'lps'),
	(640670, 136, '2015-01-01 00:13:14.000000', 'consum', 0.0319, 'lps'),
	(640671, 136, '2015-01-01 00:13:15.000000', 'consum', 0.0250, 'lps'),
	(640672, 136, '2015-01-01 00:13:16.000000', 'consum', 0.0330, 'lps'),
	(640673, 136, '2015-01-01 00:13:17.000000', 'consum', 0.0321, 'lps'),
	(640674, 136, '2015-01-01 00:13:18.000000', 'consum', 0.0281, 'lps'),
	(640675, 136, '2015-01-01 00:13:19.000000', 'consum', 0.0233, 'lps'),
	(640676, 136, '2015-01-01 00:13:20.000000', 'consum', 0.0235, 'lps'),
	(640677, 136, '2015-01-01 00:13:21.000000', 'consum', 0.0269, 'lps'),
	(640678, 136, '2015-01-01 00:13:22.000000', 'consum', 0.0303, 'lps'),
	(640679, 136, '2015-01-01 00:13:23.000000', 'consum', 0.0253, 'lps'),
	(640680, 136, '2015-01-01 00:13:24.000000', 'consum', 0.0271, 'lps'),
	(640681, 136, '2015-01-01 00:13:25.000000', 'consum', 0.0260, 'lps'),
	(640682, 136, '2015-01-01 00:13:26.000000', 'consum', 0.0280, 'lps'),
	(640683, 136, '2015-01-01 00:13:27.000000', 'consum', 0.0287, 'lps'),
	(640684, 136, '2015-01-01 00:13:28.000000', 'consum', 0.0259, 'lps'),
	(640685, 136, '2015-01-01 00:13:29.000000', 'consum', 0.0224, 'lps'),
	(640686, 136, '2015-01-01 00:13:30.000000', 'consum', 0.0260, 'lps'),
	(640687, 136, '2015-01-01 00:13:31.000000', 'consum', 0.0295, 'lps'),
	(640688, 136, '2015-01-01 00:13:32.000000', 'consum', 0.0238, 'lps'),
	(640689, 136, '2015-01-01 00:13:33.000000', 'consum', 0.0219, 'lps'),
	(640690, 136, '2015-01-01 00:13:34.000000', 'consum', 0.0295, 'lps'),
	(640691, 136, '2015-01-01 00:13:35.000000', 'consum', 0.0238, 'lps'),
	(640692, 136, '2015-01-01 00:13:36.000000', 'consum', 0.0217, 'lps'),
	(640693, 136, '2015-01-01 00:13:37.000000', 'consum', 0.0288, 'lps'),
	(640694, 136, '2015-01-01 00:13:38.000000', 'consum', 0.0330, 'lps'),
	(640695, 136, '2015-01-01 00:13:39.000000', 'consum', 0.0328, 'lps'),
	(640696, 136, '2015-01-01 00:13:40.000000', 'consum', 0.0315, 'lps'),
	(640697, 136, '2015-01-01 00:13:41.000000', 'consum', 0.0259, 'lps'),
	(640698, 136, '2015-01-01 00:13:42.000000', 'consum', 0.0264, 'lps'),
	(640699, 136, '2015-01-01 00:13:43.000000', 'consum', 0.0332, 'lps'),
	(640700, 136, '2015-01-01 00:13:44.000000', 'consum', 0.0290, 'lps'),
	(640701, 136, '2015-01-01 00:13:45.000000', 'consum', 0.0241, 'lps'),
	(640702, 136, '2015-01-01 00:13:46.000000', 'consum', 0.0251, 'lps'),
	(640703, 136, '2015-01-01 00:13:47.000000', 'consum', 0.0321, 'lps'),
	(640704, 136, '2015-01-01 00:13:48.000000', 'consum', 0.0270, 'lps'),
	(640705, 136, '2015-01-01 00:13:49.000000', 'consum', 0.0303, 'lps'),
	(640706, 136, '2015-01-01 00:13:50.000000', 'consum', 0.0247, 'lps'),
	(640707, 136, '2015-01-01 00:13:51.000000', 'consum', 0.0243, 'lps'),
	(640708, 136, '2015-01-01 00:13:52.000000', 'consum', 0.0261, 'lps'),
	(640709, 136, '2015-01-01 00:13:53.000000', 'consum', 0.0245, 'lps'),
	(640710, 136, '2015-01-01 00:13:54.000000', 'consum', 0.0231, 'lps'),
	(640711, 136, '2015-01-01 00:13:55.000000', 'consum', 0.0211, 'lps'),
	(640712, 136, '2015-01-01 00:13:56.000000', 'consum', 0.0277, 'lps'),
	(640713, 136, '2015-01-01 00:13:57.000000', 'consum', 0.0293, 'lps'),
	(640714, 136, '2015-01-01 00:13:58.000000', 'consum', 0.0300, 'lps'),
	(640715, 136, '2015-01-01 00:13:59.000000', 'consum', 0.0290, 'lps'),
	(640716, 136, '2015-01-01 00:14:00.000000', 'consum', 0.0216, 'lps'),
	(640717, 136, '2015-01-01 00:14:01.000000', 'consum', 0.0250, 'lps'),
	(640718, 136, '2015-01-01 00:14:02.000000', 'consum', 0.0266, 'lps'),
	(640719, 136, '2015-01-01 00:14:03.000000', 'consum', 0.0247, 'lps'),
	(640720, 136, '2015-01-01 00:14:04.000000', 'consum', 0.0227, 'lps'),
	(640721, 136, '2015-01-01 00:14:05.000000', 'consum', 0.0310, 'lps'),
	(640722, 136, '2015-01-01 00:14:06.000000', 'consum', 0.0288, 'lps'),
	(640723, 136, '2015-01-01 00:14:07.000000', 'consum', 0.0299, 'lps'),
	(640724, 136, '2015-01-01 00:14:08.000000', 'consum', 0.0298, 'lps'),
	(640725, 136, '2015-01-01 00:14:09.000000', 'consum', 0.0262, 'lps'),
	(640726, 136, '2015-01-01 00:14:10.000000', 'consum', 0.0327, 'lps'),
	(640727, 136, '2015-01-01 00:14:11.000000', 'consum', 0.0269, 'lps'),
	(640728, 136, '2015-01-01 00:14:12.000000', 'consum', 0.0278, 'lps'),
	(640729, 136, '2015-01-01 00:14:13.000000', 'consum', 0.0252, 'lps'),
	(640730, 136, '2015-01-01 00:14:14.000000', 'consum', 0.0213, 'lps'),
	(640731, 136, '2015-01-01 00:14:15.000000', 'consum', 0.0224, 'lps'),
	(640732, 136, '2015-01-01 00:14:16.000000', 'consum', 0.0272, 'lps'),
	(640733, 136, '2015-01-01 00:14:17.000000', 'consum', 0.0232, 'lps'),
	(640734, 136, '2015-01-01 00:14:18.000000', 'consum', 0.0258, 'lps'),
	(640735, 136, '2015-01-01 00:14:19.000000', 'consum', 0.0261, 'lps'),
	(640736, 136, '2015-01-01 00:14:20.000000', 'consum', 0.0322, 'lps'),
	(640737, 136, '2015-01-01 00:14:21.000000', 'consum', 0.0246, 'lps'),
	(640738, 136, '2015-01-01 00:14:22.000000', 'consum', 0.0301, 'lps'),
	(640739, 136, '2015-01-01 00:14:23.000000', 'consum', 0.0310, 'lps'),
	(640740, 136, '2015-01-01 00:14:24.000000', 'consum', 0.0314, 'lps'),
	(640741, 136, '2015-01-01 00:14:25.000000', 'consum', 0.0304, 'lps'),
	(640742, 136, '2015-01-01 00:14:26.000000', 'consum', 0.0247, 'lps'),
	(640743, 136, '2015-01-01 00:14:27.000000', 'consum', 0.0236, 'lps'),
	(640744, 136, '2015-01-01 00:14:28.000000', 'consum', 0.0231, 'lps'),
	(640745, 136, '2015-01-01 00:14:29.000000', 'consum', 0.0237, 'lps'),
	(640746, 136, '2015-01-01 00:14:30.000000', 'consum', 0.0283, 'lps'),
	(640747, 136, '2015-01-01 00:14:31.000000', 'consum', 0.0246, 'lps'),
	(640748, 136, '2015-01-01 00:14:32.000000', 'consum', 0.0294, 'lps'),
	(640749, 136, '2015-01-01 00:14:33.000000', 'consum', 0.0274, 'lps'),
	(640750, 136, '2015-01-01 00:14:34.000000', 'consum', 0.0279, 'lps'),
	(640751, 136, '2015-01-01 00:14:35.000000', 'consum', 0.0238, 'lps'),
	(640752, 136, '2015-01-01 00:14:36.000000', 'consum', 0.0270, 'lps'),
	(640753, 136, '2015-01-01 00:14:37.000000', 'consum', 0.0301, 'lps'),
	(640754, 136, '2015-01-01 00:14:38.000000', 'consum', 0.0236, 'lps'),
	(640755, 136, '2015-01-01 00:14:39.000000', 'consum', 0.0319, 'lps'),
	(640756, 136, '2015-01-01 00:14:40.000000', 'consum', 0.0303, 'lps'),
	(640757, 136, '2015-01-01 00:14:41.000000', 'consum', 0.0225, 'lps'),
	(640758, 136, '2015-01-01 00:14:42.000000', 'consum', 0.0253, 'lps'),
	(640759, 136, '2015-01-01 00:14:43.000000', 'consum', 0.0256, 'lps'),
	(640760, 136, '2015-01-01 00:14:44.000000', 'consum', 0.0313, 'lps'),
	(640761, 136, '2015-01-01 00:14:45.000000', 'consum', 0.0216, 'lps'),
	(640762, 136, '2015-01-01 00:14:46.000000', 'consum', 0.0302, 'lps'),
	(640763, 136, '2015-01-01 00:14:47.000000', 'consum', 0.0283, 'lps'),
	(640764, 136, '2015-01-01 00:14:48.000000', 'consum', 0.0300, 'lps'),
	(640765, 136, '2015-01-01 00:14:49.000000', 'consum', 0.0314, 'lps'),
	(640766, 136, '2015-01-01 00:14:50.000000', 'consum', 0.0216, 'lps'),
	(640767, 136, '2015-01-01 00:14:51.000000', 'consum', 0.0300, 'lps'),
	(640768, 136, '2015-01-01 00:14:52.000000', 'consum', 0.0270, 'lps'),
	(640769, 136, '2015-01-01 00:14:53.000000', 'consum', 0.0240, 'lps'),
	(640770, 136, '2015-01-01 00:14:54.000000', 'consum', 0.0304, 'lps'),
	(640771, 136, '2015-01-01 00:14:55.000000', 'consum', 0.0221, 'lps'),
	(640772, 136, '2015-01-01 00:14:56.000000', 'consum', 0.0230, 'lps'),
	(640773, 136, '2015-01-01 00:14:57.000000', 'consum', 0.0278, 'lps'),
	(640774, 136, '2015-01-01 00:14:58.000000', 'consum', 0.0242, 'lps'),
	(640775, 136, '2015-01-01 00:14:59.000000', 'consum', 0.0291, 'lps'),
	(640776, 136, '2015-01-01 00:15:00.000000', 'consum', 0.0272, 'lps'),
	(640777, 136, '2015-01-01 00:15:01.000000', 'consum', 0.0277, 'lps'),
	(640778, 136, '2015-01-01 00:15:02.000000', 'consum', 0.0235, 'lps'),
	(640779, 136, '2015-01-01 00:15:03.000000', 'consum', 0.0258, 'lps'),
	(640780, 136, '2015-01-01 00:15:04.000000', 'consum', 0.0254, 'lps'),
	(640781, 136, '2015-01-01 00:15:05.000000', 'consum', 0.0286, 'lps'),
	(640782, 136, '2015-01-01 00:15:06.000000', 'consum', 0.0333, 'lps'),
	(640783, 136, '2015-01-01 00:15:07.000000', 'consum', 0.0226, 'lps'),
	(640784, 136, '2015-01-01 00:15:08.000000', 'consum', 0.0292, 'lps'),
	(640785, 136, '2015-01-01 00:15:09.000000', 'consum', 0.0328, 'lps'),
	(640786, 136, '2015-01-01 00:15:10.000000', 'consum', 0.0303, 'lps'),
	(640787, 136, '2015-01-01 00:15:11.000000', 'consum', 0.0323, 'lps'),
	(640788, 136, '2015-01-01 00:15:12.000000', 'consum', 0.0247, 'lps'),
	(640789, 136, '2015-01-01 00:15:13.000000', 'consum', 0.0306, 'lps'),
	(640790, 136, '2015-01-01 00:15:14.000000', 'consum', 0.0332, 'lps'),
	(640791, 136, '2015-01-01 00:15:15.000000', 'consum', 0.0286, 'lps'),
	(640792, 136, '2015-01-01 00:15:16.000000', 'consum', 0.0222, 'lps'),
	(640793, 136, '2015-01-01 00:15:17.000000', 'consum', 0.0290, 'lps'),
	(640794, 136, '2015-01-01 00:15:18.000000', 'consum', 0.0328, 'lps'),
	(640795, 136, '2015-01-01 00:15:19.000000', 'consum', 0.0313, 'lps'),
	(640796, 136, '2015-01-01 00:15:20.000000', 'consum', 0.0245, 'lps'),
	(640797, 136, '2015-01-01 00:15:21.000000', 'consum', 0.0327, 'lps'),
	(640798, 136, '2015-01-01 00:15:22.000000', 'consum', 0.0319, 'lps'),
	(640799, 136, '2015-01-01 00:15:23.000000', 'consum', 0.0280, 'lps'),
	(640800, 136, '2015-01-01 00:15:24.000000', 'consum', 0.0235, 'lps'),
	(640801, 136, '2015-01-01 00:15:25.000000', 'consum', 0.0247, 'lps'),
	(640802, 136, '2015-01-01 00:15:26.000000', 'consum', 0.0321, 'lps'),
	(640803, 136, '2015-01-01 00:15:27.000000', 'consum', 0.0284, 'lps'),
	(640804, 136, '2015-01-01 00:15:28.000000', 'consum', 0.0248, 'lps'),
	(640805, 136, '2015-01-01 00:15:29.000000', 'consum', 0.0302, 'lps'),
	(640806, 136, '2015-01-01 00:15:30.000000', 'consum', 0.0309, 'lps'),
	(640807, 136, '2015-01-01 00:15:31.000000', 'consum', 0.0306, 'lps'),
	(640808, 136, '2015-01-01 00:15:32.000000', 'consum', 0.0267, 'lps'),
	(640809, 136, '2015-01-01 00:15:33.000000', 'consum', 0.0210, 'lps'),
	(640810, 136, '2015-01-01 00:15:34.000000', 'consum', 0.0287, 'lps'),
	(640811, 136, '2015-01-01 00:15:35.000000', 'consum', 0.0225, 'lps'),
	(640812, 136, '2015-01-01 00:15:36.000000', 'consum', 0.0301, 'lps'),
	(640813, 136, '2015-01-01 00:15:37.000000', 'consum', 0.0249, 'lps'),
	(640814, 136, '2015-01-01 00:15:38.000000', 'consum', 0.0256, 'lps'),
	(640815, 136, '2015-01-01 00:15:39.000000', 'consum', 0.0324, 'lps'),
	(640816, 136, '2015-01-01 00:15:40.000000', 'consum', 0.0269, 'lps'),
	(640817, 136, '2015-01-01 00:15:41.000000', 'consum', 0.0288, 'lps'),
	(640818, 136, '2015-01-01 00:15:42.000000', 'consum', 0.0302, 'lps'),
	(640819, 136, '2015-01-01 00:15:43.000000', 'consum', 0.0309, 'lps'),
	(640820, 136, '2015-01-01 00:15:44.000000', 'consum', 0.0308, 'lps'),
	(640821, 136, '2015-01-01 00:15:45.000000', 'consum', 0.0277, 'lps'),
	(640822, 136, '2015-01-01 00:15:46.000000', 'consum', 0.0251, 'lps'),
	(640823, 136, '2015-01-01 00:15:47.000000', 'consum', 0.0215, 'lps'),
	(640824, 136, '2015-01-01 00:15:48.000000', 'consum', 0.0236, 'lps'),
	(640825, 136, '2015-01-01 00:15:49.000000', 'consum', 0.0325, 'lps'),
	(640826, 136, '2015-01-01 00:15:50.000000', 'consum', 0.0212, 'lps'),
	(640827, 136, '2015-01-01 00:15:51.000000', 'consum', 0.0246, 'lps'),
	(640828, 136, '2015-01-01 00:15:52.000000', 'consum', 0.0262, 'lps'),
	(640829, 136, '2015-01-01 00:15:53.000000', 'consum', 0.0238, 'lps'),
	(640830, 136, '2015-01-01 00:15:54.000000', 'consum', 0.0320, 'lps'),
	(640831, 136, '2015-01-01 00:15:55.000000', 'consum', 0.0304, 'lps'),
	(640832, 136, '2015-01-01 00:15:56.000000', 'consum', 0.0226, 'lps'),
	(640833, 136, '2015-01-01 00:15:57.000000', 'consum', 0.0256, 'lps'),
	(640834, 136, '2015-01-01 00:15:58.000000', 'consum', 0.0269, 'lps'),
	(640835, 136, '2015-01-01 00:15:59.000000', 'consum', 0.0242, 'lps'),
	(640836, 136, '2015-01-01 00:16:00.000000', 'consum', 0.0319, 'lps'),
	(640837, 136, '2015-01-01 00:16:01.000000', 'consum', 0.0289, 'lps'),
	(640838, 136, '2015-01-01 00:16:02.000000', 'consum', 0.0275, 'lps'),
	(640839, 136, '2015-01-01 00:16:03.000000', 'consum', 0.0301, 'lps'),
	(640840, 136, '2015-01-01 00:16:04.000000', 'consum', 0.0222, 'lps'),
	(640841, 136, '2015-01-01 00:16:05.000000', 'consum', 0.0246, 'lps'),
	(640842, 136, '2015-01-01 00:16:06.000000', 'consum', 0.0231, 'lps'),
	(640843, 136, '2015-01-01 00:16:07.000000', 'consum', 0.0331, 'lps'),
	(640844, 136, '2015-01-01 00:16:08.000000', 'consum', 0.0257, 'lps'),
	(640845, 136, '2015-01-01 00:16:09.000000', 'consum', 0.0329, 'lps'),
	(640846, 136, '2015-01-01 00:16:10.000000', 'consum', 0.0294, 'lps'),
	(640847, 136, '2015-01-01 00:16:11.000000', 'consum', 0.0271, 'lps'),
	(640848, 136, '2015-01-01 00:16:12.000000', 'consum', 0.0265, 'lps'),
	(640849, 136, '2015-01-01 00:16:13.000000', 'consum', 0.0302, 'lps'),
	(640850, 136, '2015-01-01 00:16:14.000000', 'consum', 0.0257, 'lps'),
	(640851, 136, '2015-01-01 00:16:15.000000', 'consum', 0.0294, 'lps'),
	(640852, 136, '2015-01-01 00:16:16.000000', 'consum', 0.0243, 'lps'),
	(640853, 136, '2015-01-01 00:16:17.000000', 'consum', 0.0247, 'lps'),
	(640854, 136, '2015-01-01 00:16:18.000000', 'consum', 0.0294, 'lps'),
	(640855, 136, '2015-01-01 00:16:19.000000', 'consum', 0.0274, 'lps'),
	(640856, 136, '2015-01-01 00:16:20.000000', 'consum', 0.0279, 'lps'),
	(640857, 136, '2015-01-01 00:16:21.000000', 'consum', 0.0237, 'lps'),
	(640858, 136, '2015-01-01 00:16:22.000000', 'consum', 0.0263, 'lps'),
	(640859, 136, '2015-01-01 00:16:23.000000', 'consum', 0.0273, 'lps'),
	(640860, 136, '2015-01-01 00:16:24.000000', 'consum', 0.0240, 'lps'),
	(640861, 136, '2015-01-01 00:16:25.000000', 'consum', 0.0294, 'lps'),
	(640862, 136, '2015-01-01 00:16:26.000000', 'consum', 0.0296, 'lps'),
	(640863, 136, '2015-01-01 00:16:27.000000', 'consum', 0.0261, 'lps'),
	(640864, 136, '2015-01-01 00:16:28.000000', 'consum', 0.0210, 'lps'),
	(640865, 136, '2015-01-01 00:16:29.000000', 'consum', 0.0304, 'lps'),
	(640866, 136, '2015-01-01 00:16:30.000000', 'consum', 0.0307, 'lps'),
	(640867, 136, '2015-01-01 00:16:31.000000', 'consum', 0.0291, 'lps'),
	(640868, 136, '2015-01-01 00:16:32.000000', 'consum', 0.0326, 'lps'),
	(640869, 136, '2015-01-01 00:16:33.000000', 'consum', 0.0297, 'lps'),
	(640870, 136, '2015-01-01 00:16:34.000000', 'consum', 0.0298, 'lps'),
	(640871, 136, '2015-01-01 00:16:35.000000', 'consum', 0.0267, 'lps'),
	(640872, 136, '2015-01-01 00:16:36.000000', 'consum', 0.0231, 'lps'),
	(640873, 136, '2015-01-01 00:16:37.000000', 'consum', 0.0266, 'lps'),
	(640874, 136, '2015-01-01 00:16:38.000000', 'consum', 0.0307, 'lps'),
	(640875, 136, '2015-01-01 00:16:39.000000', 'consum', 0.0276, 'lps'),
	(640876, 136, '2015-01-01 00:16:40.000000', 'consum', 0.0252, 'lps'),
	(640877, 136, '2015-01-01 00:16:41.000000', 'consum', 0.0220, 'lps'),
	(640878, 136, '2015-01-01 00:16:42.000000', 'consum', 0.0259, 'lps'),
	(640879, 136, '2015-01-01 00:16:43.000000', 'consum', 0.0301, 'lps'),
	(640880, 136, '2015-01-01 00:16:44.000000', 'consum', 0.0271, 'lps'),
	(640881, 136, '2015-01-01 00:16:45.000000', 'consum', 0.0243, 'lps'),
	(640882, 136, '2015-01-01 00:16:46.000000', 'consum', 0.0316, 'lps'),
	(640883, 136, '2015-01-01 00:16:47.000000', 'consum', 0.0271, 'lps'),
	(640884, 136, '2015-01-01 00:16:48.000000', 'consum', 0.0320, 'lps'),
	(640885, 136, '2015-01-01 00:16:49.000000', 'consum', 0.0330, 'lps'),
	(640886, 136, '2015-01-01 00:16:50.000000', 'consum', 0.0232, 'lps'),
	(640887, 136, '2015-01-01 00:16:51.000000', 'consum', 0.0210, 'lps'),
	(640888, 136, '2015-01-01 00:16:52.000000', 'consum', 0.0270, 'lps'),
	(640889, 136, '2015-01-01 00:16:53.000000', 'consum', 0.0260, 'lps'),
	(640890, 136, '2015-01-01 00:16:54.000000', 'consum', 0.0281, 'lps'),
	(640891, 136, '2015-01-01 00:16:55.000000', 'consum', 0.0292, 'lps'),
	(640892, 136, '2015-01-01 00:16:56.000000', 'consum', 0.0282, 'lps'),
	(640893, 136, '2015-01-01 00:16:57.000000', 'consum', 0.0326, 'lps'),
	(640894, 136, '2015-01-01 00:16:58.000000', 'consum', 0.0325, 'lps'),
	(640895, 136, '2015-01-01 00:16:59.000000', 'consum', 0.0312, 'lps'),
	(640896, 136, '2015-01-01 00:17:00.000000', 'consum', 0.0255, 'lps'),
	(640897, 136, '2015-01-01 00:17:01.000000', 'consum', 0.0251, 'lps'),
	(640898, 136, '2015-01-01 00:17:02.000000', 'consum', 0.0282, 'lps'),
	(640899, 136, '2015-01-01 00:17:03.000000', 'consum', 0.0322, 'lps'),
	(640900, 136, '2015-01-01 00:17:04.000000', 'consum', 0.0309, 'lps'),
	(640901, 136, '2015-01-01 00:17:05.000000', 'consum', 0.0243, 'lps'),
	(640902, 136, '2015-01-01 00:17:06.000000', 'consum', 0.0326, 'lps'),
	(640903, 136, '2015-01-01 00:17:07.000000', 'consum', 0.0322, 'lps'),
	(640904, 136, '2015-01-01 00:17:08.000000', 'consum', 0.0299, 'lps'),
	(640905, 136, '2015-01-01 00:17:09.000000', 'consum', 0.0320, 'lps'),
	(640906, 136, '2015-01-01 00:17:10.000000', 'consum', 0.0244, 'lps'),
	(640907, 136, '2015-01-01 00:17:11.000000', 'consum', 0.0300, 'lps'),
	(640908, 136, '2015-01-01 00:17:12.000000', 'consum', 0.0310, 'lps'),
	(640909, 136, '2015-01-01 00:17:13.000000', 'consum', 0.0318, 'lps'),
	(640910, 136, '2015-01-01 00:17:14.000000', 'consum', 0.0325, 'lps'),
	(640911, 136, '2015-01-01 00:17:15.000000', 'consum', 0.0215, 'lps'),
	(640912, 136, '2015-01-01 00:17:16.000000', 'consum', 0.0262, 'lps'),
	(640913, 136, '2015-01-01 00:17:17.000000', 'consum', 0.0331, 'lps'),
	(640914, 136, '2015-01-01 00:17:18.000000', 'consum', 0.0290, 'lps'),
	(640915, 136, '2015-01-01 00:17:19.000000', 'consum', 0.0244, 'lps'),
	(640916, 136, '2015-01-01 00:17:20.000000', 'consum', 0.0266, 'lps'),
	(640917, 136, '2015-01-01 00:17:21.000000', 'consum', 0.0263, 'lps'),
	(640918, 136, '2015-01-01 00:17:22.000000', 'consum', 0.0308, 'lps'),
	(640919, 136, '2015-01-01 00:17:23.000000', 'consum', 0.0294, 'lps'),
	(640920, 136, '2015-01-01 00:17:24.000000', 'consum', 0.0214, 'lps'),
	(640921, 136, '2015-01-01 00:17:25.000000', 'consum', 0.0225, 'lps'),
	(640922, 136, '2015-01-01 00:17:26.000000', 'consum', 0.0275, 'lps'),
	(640923, 136, '2015-01-01 00:17:27.000000', 'consum', 0.0241, 'lps'),
	(640924, 136, '2015-01-01 00:17:28.000000', 'consum', 0.0295, 'lps'),
	(640925, 136, '2015-01-01 00:17:29.000000', 'consum', 0.0294, 'lps'),
	(640926, 136, '2015-01-01 00:17:30.000000', 'consum', 0.0253, 'lps'),
	(640927, 136, '2015-01-01 00:17:31.000000', 'consum', 0.0297, 'lps'),
	(640928, 136, '2015-01-01 00:17:32.000000', 'consum', 0.0270, 'lps'),
	(640929, 136, '2015-01-01 00:17:33.000000', 'consum', 0.0249, 'lps'),
	(640930, 136, '2015-01-01 00:17:34.000000', 'consum', 0.0227, 'lps'),
	(640931, 136, '2015-01-01 00:17:35.000000', 'consum', 0.0301, 'lps'),
	(640932, 136, '2015-01-01 00:17:36.000000', 'consum', 0.0242, 'lps'),
	(640933, 136, '2015-01-01 00:17:37.000000', 'consum', 0.0222, 'lps'),
	(640934, 136, '2015-01-01 00:17:38.000000', 'consum', 0.0298, 'lps'),
	(640935, 136, '2015-01-01 00:17:39.000000', 'consum', 0.0244, 'lps'),
	(640936, 136, '2015-01-01 00:17:40.000000', 'consum', 0.0240, 'lps'),
	(640937, 136, '2015-01-01 00:17:41.000000', 'consum', 0.0257, 'lps'),
	(640938, 136, '2015-01-01 00:17:42.000000', 'consum', 0.0232, 'lps'),
	(640939, 136, '2015-01-01 00:17:43.000000', 'consum', 0.0305, 'lps'),
	(640940, 136, '2015-01-01 00:17:44.000000', 'consum', 0.0248, 'lps'),
	(640941, 136, '2015-01-01 00:17:45.000000', 'consum', 0.0240, 'lps'),
	(640942, 136, '2015-01-01 00:17:46.000000', 'consum', 0.0244, 'lps'),
	(640943, 136, '2015-01-01 00:17:47.000000', 'consum', 0.0290, 'lps'),
	(640944, 136, '2015-01-01 00:17:48.000000', 'consum', 0.0263, 'lps'),
	(640945, 136, '2015-01-01 00:17:49.000000', 'consum', 0.0234, 'lps'),
	(640946, 136, '2015-01-01 00:17:50.000000', 'consum', 0.0298, 'lps'),
	(640947, 136, '2015-01-01 00:17:51.000000', 'consum', 0.0329, 'lps'),
	(640948, 136, '2015-01-01 00:17:52.000000', 'consum', 0.0293, 'lps'),
	(640949, 136, '2015-01-01 00:17:53.000000', 'consum', 0.0269, 'lps'),
	(640950, 136, '2015-01-01 00:17:54.000000', 'consum', 0.0255, 'lps'),
	(640951, 136, '2015-01-01 00:17:55.000000', 'consum', 0.0260, 'lps'),
	(640952, 136, '2015-01-01 00:17:56.000000', 'consum', 0.0327, 'lps'),
	(640953, 136, '2015-01-01 00:17:57.000000', 'consum', 0.0271, 'lps'),
	(640954, 136, '2015-01-01 00:17:58.000000', 'consum', 0.0291, 'lps'),
	(640955, 136, '2015-01-01 00:17:59.000000', 'consum', 0.0308, 'lps'),
	(640956, 136, '2015-01-01 00:18:00.000000', 'consum', 0.0211, 'lps'),
	(640957, 136, '2015-01-01 00:18:01.000000', 'consum', 0.0291, 'lps'),
	(640958, 136, '2015-01-01 00:18:02.000000', 'consum', 0.0240, 'lps'),
	(640959, 136, '2015-01-01 00:18:03.000000', 'consum', 0.0243, 'lps'),
	(640960, 136, '2015-01-01 00:18:04.000000', 'consum', 0.0286, 'lps'),
	(640961, 136, '2015-01-01 00:18:05.000000', 'consum', 0.0242, 'lps'),
	(640962, 136, '2015-01-01 00:18:06.000000', 'consum', 0.0266, 'lps'),
	(640963, 136, '2015-01-01 00:18:07.000000', 'consum', 0.0270, 'lps'),
	(640964, 136, '2015-01-01 00:18:08.000000', 'consum', 0.0220, 'lps'),
	(640965, 136, '2015-01-01 00:18:09.000000', 'consum', 0.0327, 'lps'),
	(640966, 136, '2015-01-01 00:18:10.000000', 'consum', 0.0271, 'lps'),
	(640967, 136, '2015-01-01 00:18:11.000000', 'consum', 0.0286, 'lps'),
	(640968, 136, '2015-01-01 00:18:12.000000', 'consum', 0.0284, 'lps'),
	(640969, 136, '2015-01-01 00:18:13.000000', 'consum', 0.0231, 'lps'),
	(640970, 136, '2015-01-01 00:18:14.000000', 'consum', 0.0215, 'lps'),
	(640971, 136, '2015-01-01 00:18:15.000000', 'consum', 0.0299, 'lps'),
	(640972, 136, '2015-01-01 00:18:16.000000', 'consum', 0.0265, 'lps'),
	(640973, 136, '2015-01-01 00:18:17.000000', 'consum', 0.0222, 'lps'),
	(640974, 136, '2015-01-01 00:18:18.000000', 'consum', 0.0227, 'lps'),
	(640975, 136, '2015-01-01 00:18:19.000000', 'consum', 0.0261, 'lps'),
	(640976, 136, '2015-01-01 00:18:20.000000', 'consum', 0.0290, 'lps'),
	(640977, 136, '2015-01-01 00:18:21.000000', 'consum', 0.0211, 'lps'),
	(640978, 136, '2015-01-01 00:18:22.000000', 'consum', 0.0221, 'lps'),
	(640979, 136, '2015-01-01 00:18:23.000000', 'consum', 0.0264, 'lps'),
	(640980, 136, '2015-01-01 00:18:24.000000', 'consum', 0.0324, 'lps'),
	(640981, 136, '2015-01-01 00:18:25.000000', 'consum', 0.0248, 'lps'),
	(640982, 136, '2015-01-01 00:18:26.000000', 'consum', 0.0304, 'lps'),
	(640983, 136, '2015-01-01 00:18:27.000000', 'consum', 0.0321, 'lps'),
	(640984, 136, '2015-01-01 00:18:28.000000', 'consum', 0.0235, 'lps'),
	(640985, 136, '2015-01-01 00:18:29.000000', 'consum', 0.0249, 'lps'),
	(640986, 136, '2015-01-01 00:18:30.000000', 'consum', 0.0332, 'lps'),
	(640987, 136, '2015-01-01 00:18:31.000000', 'consum', 0.0332, 'lps'),
	(640988, 136, '2015-01-01 00:18:32.000000', 'consum', 0.0330, 'lps'),
	(640989, 136, '2015-01-01 00:18:33.000000', 'consum', 0.0322, 'lps'),
	(640990, 136, '2015-01-01 00:18:34.000000', 'consum', 0.0285, 'lps'),
	(640991, 136, '2015-01-01 00:18:35.000000', 'consum', 0.0249, 'lps'),
	(640992, 136, '2015-01-01 00:18:36.000000', 'consum', 0.0305, 'lps'),
	(640993, 136, '2015-01-01 00:18:37.000000', 'consum', 0.0320, 'lps'),
	(640994, 136, '2015-01-01 00:18:38.000000', 'consum', 0.0228, 'lps'),
	(640995, 136, '2015-01-01 00:18:39.000000', 'consum', 0.0220, 'lps'),
	(640996, 136, '2015-01-01 00:18:40.000000', 'consum', 0.0331, 'lps'),
	(640997, 136, '2015-01-01 00:18:41.000000', 'consum', 0.0288, 'lps'),
	(640998, 136, '2015-01-01 00:18:42.000000', 'consum', 0.0239, 'lps'),
	(640999, 136, '2015-01-01 00:18:43.000000', 'consum', 0.0246, 'lps'),
	(641000, 136, '2015-01-01 00:18:44.000000', 'consum', 0.0304, 'lps'),
	(641001, 136, '2015-01-01 00:18:45.000000', 'consum', 0.0325, 'lps'),
	(641002, 136, '2015-01-01 00:18:46.000000', 'consum', 0.0256, 'lps'),
	(641003, 136, '2015-01-01 00:18:47.000000', 'consum', 0.0218, 'lps'),
	(641004, 136, '2015-01-01 00:18:48.000000', 'consum', 0.0237, 'lps'),
	(641005, 136, '2015-01-01 00:18:49.000000', 'consum', 0.0323, 'lps'),
	(641006, 136, '2015-01-01 00:18:50.000000', 'consum', 0.0321, 'lps'),
	(641007, 136, '2015-01-01 00:18:51.000000', 'consum', 0.0302, 'lps'),
	(641008, 136, '2015-01-01 00:18:52.000000', 'consum', 0.0212, 'lps'),
	(641009, 136, '2015-01-01 00:18:53.000000', 'consum', 0.0319, 'lps'),
	(641010, 136, '2015-01-01 00:18:54.000000', 'consum', 0.0251, 'lps'),
	(641011, 136, '2015-01-01 00:18:55.000000', 'consum', 0.0214, 'lps'),
	(641012, 136, '2015-01-01 00:18:56.000000', 'consum', 0.0231, 'lps'),
	(641013, 136, '2015-01-01 00:18:57.000000', 'consum', 0.0303, 'lps'),
	(641014, 136, '2015-01-01 00:18:58.000000', 'consum', 0.0240, 'lps'),
	(641015, 136, '2015-01-01 00:18:59.000000', 'consum', 0.0329, 'lps'),
	(641016, 136, '2015-01-01 00:19:00.000000', 'consum', 0.0221, 'lps'),
	(641017, 136, '2015-01-01 00:19:01.000000', 'consum', 0.0282, 'lps'),
	(641018, 136, '2015-01-01 00:19:02.000000', 'consum', 0.0287, 'lps'),
	(641019, 136, '2015-01-01 00:19:03.000000', 'consum', 0.0256, 'lps'),
	(641020, 136, '2015-01-01 00:19:04.000000', 'consum', 0.0211, 'lps'),
	(641021, 136, '2015-01-01 00:19:05.000000', 'consum', 0.0325, 'lps'),
	(641022, 136, '2015-01-01 00:19:06.000000', 'consum', 0.0286, 'lps'),
	(641023, 136, '2015-01-01 00:19:07.000000', 'consum', 0.0247, 'lps'),
	(641024, 136, '2015-01-01 00:19:08.000000', 'consum', 0.0289, 'lps'),
	(641025, 136, '2015-01-01 00:19:09.000000', 'consum', 0.0247, 'lps'),
	(641026, 136, '2015-01-01 00:19:10.000000', 'consum', 0.0283, 'lps'),
	(641027, 136, '2015-01-01 00:19:11.000000', 'consum', 0.0216, 'lps'),
	(641028, 136, '2015-01-01 00:19:12.000000', 'consum', 0.0272, 'lps'),
	(641029, 136, '2015-01-01 00:19:13.000000', 'consum', 0.0252, 'lps'),
	(641030, 136, '2015-01-01 00:19:14.000000', 'consum', 0.0237, 'lps'),
	(641031, 136, '2015-01-01 00:19:15.000000', 'consum', 0.0217, 'lps'),
	(641032, 136, '2015-01-01 00:19:16.000000', 'consum', 0.0291, 'lps'),
	(641033, 136, '2015-01-01 00:19:17.000000', 'consum', 0.0222, 'lps'),
	(641034, 136, '2015-01-01 00:19:18.000000', 'consum', 0.0277, 'lps'),
	(641035, 136, '2015-01-01 00:19:19.000000', 'consum', 0.0258, 'lps'),
	(641036, 136, '2015-01-01 00:19:20.000000', 'consum', 0.0251, 'lps'),
	(641037, 136, '2015-01-01 00:19:21.000000', 'consum', 0.0273, 'lps'),
	(641038, 136, '2015-01-01 00:19:22.000000', 'consum', 0.0278, 'lps'),
	(641039, 136, '2015-01-01 00:19:23.000000', 'consum', 0.0238, 'lps'),
	(641040, 136, '2015-01-01 00:19:24.000000', 'consum', 0.0270, 'lps'),
	(641041, 136, '2015-01-01 00:19:25.000000', 'consum', 0.0301, 'lps'),
	(641042, 136, '2015-01-01 00:19:26.000000', 'consum', 0.0239, 'lps'),
	(641043, 136, '2015-01-01 00:19:27.000000', 'consum', 0.0330, 'lps'),
	(641044, 136, '2015-01-01 00:19:28.000000', 'consum', 0.0228, 'lps'),
	(641045, 136, '2015-01-01 00:19:29.000000', 'consum', 0.0314, 'lps'),
	(641046, 136, '2015-01-01 00:19:30.000000', 'consum', 0.0303, 'lps'),
	(641047, 136, '2015-01-01 00:19:31.000000', 'consum', 0.0238, 'lps'),
	(641048, 136, '2015-01-01 00:19:32.000000', 'consum', 0.0322, 'lps'),
	(641049, 136, '2015-01-01 00:19:33.000000', 'consum', 0.0314, 'lps'),
	(641050, 136, '2015-01-01 00:19:34.000000', 'consum', 0.0268, 'lps'),
	(641051, 136, '2015-01-01 00:19:35.000000', 'consum', 0.0316, 'lps'),
	(641052, 136, '2015-01-01 00:19:36.000000', 'consum', 0.0316, 'lps'),
	(641053, 136, '2015-01-01 00:19:37.000000', 'consum', 0.0301, 'lps'),
	(641054, 136, '2015-01-01 00:19:38.000000', 'consum', 0.0223, 'lps'),
	(641055, 136, '2015-01-01 00:19:39.000000', 'consum', 0.0250, 'lps'),
	(641056, 136, '2015-01-01 00:19:40.000000', 'consum', 0.0247, 'lps'),
	(641057, 136, '2015-01-01 00:19:41.000000', 'consum', 0.0274, 'lps'),
	(641058, 136, '2015-01-01 00:19:42.000000', 'consum', 0.0296, 'lps'),
	(641059, 136, '2015-01-01 00:19:43.000000', 'consum', 0.0327, 'lps'),
	(641060, 136, '2015-01-01 00:19:44.000000', 'consum', 0.0288, 'lps'),
	(641061, 136, '2015-01-01 00:19:45.000000', 'consum', 0.0250, 'lps'),
	(641062, 136, '2015-01-01 00:19:46.000000', 'consum', 0.0300, 'lps'),
	(641063, 136, '2015-01-01 00:19:47.000000', 'consum', 0.0293, 'lps'),
	(641064, 136, '2015-01-01 00:19:48.000000', 'consum', 0.0232, 'lps'),
	(641065, 136, '2015-01-01 00:19:49.000000', 'consum', 0.0320, 'lps'),
	(641066, 136, '2015-01-01 00:19:50.000000', 'consum', 0.0322, 'lps'),
	(641067, 136, '2015-01-01 00:19:51.000000', 'consum', 0.0315, 'lps'),
	(641068, 136, '2015-01-01 00:19:52.000000', 'consum', 0.0278, 'lps'),
	(641069, 136, '2015-01-01 00:19:53.000000', 'consum', 0.0235, 'lps'),
	(641070, 136, '2015-01-01 00:19:54.000000', 'consum', 0.0255, 'lps'),
	(641071, 136, '2015-01-01 00:19:55.000000', 'consum', 0.0235, 'lps'),
	(641072, 136, '2015-01-01 00:19:56.000000', 'consum', 0.0326, 'lps'),
	(641073, 136, '2015-01-01 00:19:57.000000', 'consum', 0.0220, 'lps'),
	(641074, 136, '2015-01-01 00:19:58.000000', 'consum', 0.0283, 'lps'),
	(641075, 136, '2015-01-01 00:19:59.000000', 'consum', 0.0299, 'lps'),
	(641076, 136, '2015-01-01 00:20:00.000000', 'consum', 0.0314, 'lps'),
	(641077, 136, '2015-01-01 00:20:01.000000', 'consum', 0.0214, 'lps'),
	(641078, 136, '2015-01-01 00:20:02.000000', 'consum', 0.0290, 'lps'),
	(641079, 136, '2015-01-01 00:20:03.000000', 'consum', 0.0225, 'lps'),
	(641080, 136, '2015-01-01 00:20:04.000000', 'consum', 0.0296, 'lps'),
	(641081, 136, '2015-01-01 00:20:05.000000', 'consum', 0.0224, 'lps'),
	(641082, 136, '2015-01-01 00:20:06.000000', 'consum', 0.0269, 'lps'),
	(641083, 136, '2015-01-01 00:20:07.000000', 'consum', 0.0216, 'lps'),
	(641084, 136, '2015-01-01 00:20:08.000000', 'consum', 0.0310, 'lps'),
	(641085, 136, '2015-01-01 00:20:09.000000', 'consum', 0.0321, 'lps'),
	(641086, 136, '2015-01-01 00:20:10.000000', 'consum', 0.0216, 'lps'),
	(641087, 136, '2015-01-01 00:20:11.000000', 'consum', 0.0280, 'lps'),
	(641088, 136, '2015-01-01 00:20:12.000000', 'consum', 0.0295, 'lps'),
	(641089, 136, '2015-01-01 00:20:13.000000', 'consum', 0.0303, 'lps'),
	(641090, 136, '2015-01-01 00:20:14.000000', 'consum', 0.0294, 'lps'),
	(641091, 136, '2015-01-01 00:20:15.000000', 'consum', 0.0230, 'lps'),
	(641092, 136, '2015-01-01 00:20:16.000000', 'consum', 0.0307, 'lps'),
	(641093, 136, '2015-01-01 00:20:17.000000', 'consum', 0.0261, 'lps'),
	(641094, 136, '2015-01-01 00:20:18.000000', 'consum', 0.0298, 'lps'),
	(641095, 136, '2015-01-01 00:20:19.000000', 'consum', 0.0252, 'lps'),
	(641096, 136, '2015-01-01 00:20:20.000000', 'consum', 0.0278, 'lps'),
	(641097, 136, '2015-01-01 00:20:21.000000', 'consum', 0.0302, 'lps'),
	(641098, 136, '2015-01-01 00:20:22.000000', 'consum', 0.0217, 'lps'),
	(641099, 136, '2015-01-01 00:20:23.000000', 'consum', 0.0219, 'lps'),
	(641100, 136, '2015-01-01 00:20:24.000000', 'consum', 0.0233, 'lps'),
	(641101, 136, '2015-01-01 00:20:25.000000', 'consum', 0.0298, 'lps'),
	(641102, 136, '2015-01-01 00:20:26.000000', 'consum', 0.0211, 'lps'),
	(641103, 136, '2015-01-01 00:20:27.000000', 'consum', 0.0325, 'lps'),
	(641104, 136, '2015-01-01 00:20:28.000000', 'consum', 0.0285, 'lps'),
	(641105, 136, '2015-01-01 00:20:29.000000', 'consum', 0.0242, 'lps'),
	(641106, 136, '2015-01-01 00:20:30.000000', 'consum', 0.0267, 'lps'),
	(641107, 136, '2015-01-01 00:20:31.000000', 'consum', 0.0275, 'lps'),
	(641108, 136, '2015-01-01 00:20:32.000000', 'consum', 0.0239, 'lps'),
	(641109, 136, '2015-01-01 00:20:33.000000', 'consum', 0.0288, 'lps'),
	(641110, 136, '2015-01-01 00:20:34.000000', 'consum', 0.0266, 'lps'),
	(641111, 136, '2015-01-01 00:20:35.000000', 'consum', 0.0255, 'lps'),
	(641112, 136, '2015-01-01 00:20:36.000000', 'consum', 0.0267, 'lps'),
	(641113, 136, '2015-01-01 00:20:37.000000', 'consum', 0.0237, 'lps'),
	(641114, 136, '2015-01-01 00:20:38.000000', 'consum', 0.0299, 'lps'),
	(641115, 136, '2015-01-01 00:20:39.000000', 'consum', 0.0327, 'lps'),
	(641116, 136, '2015-01-01 00:20:40.000000', 'consum', 0.0280, 'lps'),
	(641117, 136, '2015-01-01 00:20:41.000000', 'consum', 0.0332, 'lps'),
	(641118, 136, '2015-01-01 00:20:42.000000', 'consum', 0.0240, 'lps'),
	(641119, 136, '2015-01-01 00:20:43.000000', 'consum', 0.0241, 'lps'),
	(641120, 136, '2015-01-01 00:20:44.000000', 'consum', 0.0277, 'lps'),
	(641121, 136, '2015-01-01 00:20:45.000000', 'consum', 0.0329, 'lps'),
	(641122, 136, '2015-01-01 00:20:46.000000', 'consum', 0.0233, 'lps'),
	(641123, 136, '2015-01-01 00:20:47.000000', 'consum', 0.0214, 'lps'),
	(641124, 136, '2015-01-01 00:20:48.000000', 'consum', 0.0286, 'lps'),
	(641125, 136, '2015-01-01 00:20:49.000000', 'consum', 0.0331, 'lps'),
	(641126, 136, '2015-01-01 00:20:50.000000', 'consum', 0.0215, 'lps'),
	(641127, 136, '2015-01-01 00:20:51.000000', 'consum', 0.0244, 'lps'),
	(641128, 136, '2015-01-01 00:20:52.000000', 'consum', 0.0243, 'lps'),
	(641129, 136, '2015-01-01 00:20:53.000000', 'consum', 0.0272, 'lps'),
	(641130, 136, '2015-01-01 00:20:54.000000', 'consum', 0.0296, 'lps'),
	(641131, 136, '2015-01-01 00:20:55.000000', 'consum', 0.0333, 'lps'),
	(641132, 136, '2015-01-01 00:20:56.000000', 'consum', 0.0318, 'lps'),
	(641133, 136, '2015-01-01 00:20:57.000000', 'consum', 0.0260, 'lps'),
	(641134, 136, '2015-01-01 00:20:58.000000', 'consum', 0.0257, 'lps'),
	(641135, 136, '2015-01-01 00:20:59.000000', 'consum', 0.0298, 'lps'),
	(641136, 136, '2015-01-01 00:21:00.000000', 'consum', 0.0263, 'lps'),
	(641137, 136, '2015-01-01 00:21:01.000000', 'consum', 0.0333, 'lps'),
	(641138, 136, '2015-01-01 00:21:02.000000', 'consum', 0.0296, 'lps'),
	(641139, 136, '2015-01-01 00:21:03.000000', 'consum', 0.0269, 'lps'),
	(641140, 136, '2015-01-01 00:21:04.000000', 'consum', 0.0248, 'lps'),
	(641141, 136, '2015-01-01 00:21:05.000000', 'consum', 0.0225, 'lps'),
	(641142, 136, '2015-01-01 00:21:06.000000', 'consum', 0.0294, 'lps'),
	(641143, 136, '2015-01-01 00:21:07.000000', 'consum', 0.0213, 'lps'),
	(641144, 136, '2015-01-01 00:21:08.000000', 'consum', 0.0223, 'lps'),
	(641145, 136, '2015-01-01 00:21:09.000000', 'consum', 0.0266, 'lps'),
	(641146, 136, '2015-01-01 00:21:10.000000', 'consum', 0.0326, 'lps'),
	(641147, 136, '2015-01-01 00:21:11.000000', 'consum', 0.0251, 'lps'),
	(641148, 136, '2015-01-01 00:21:12.000000', 'consum', 0.0315, 'lps'),
	(641149, 136, '2015-01-01 00:21:13.000000', 'consum', 0.0240, 'lps'),
	(641150, 136, '2015-01-01 00:21:14.000000', 'consum', 0.0293, 'lps'),
	(641151, 136, '2015-01-01 00:21:15.000000', 'consum', 0.0290, 'lps'),
	(641152, 136, '2015-01-01 00:21:16.000000', 'consum', 0.0238, 'lps'),
	(641153, 136, '2015-01-01 00:21:17.000000', 'consum', 0.0234, 'lps'),
	(641154, 136, '2015-01-01 00:21:18.000000', 'consum', 0.0247, 'lps'),
	(641155, 136, '2015-01-01 00:21:19.000000', 'consum', 0.0323, 'lps'),
	(641156, 136, '2015-01-01 00:21:20.000000', 'consum', 0.0294, 'lps'),
	(641157, 136, '2015-01-01 00:21:21.000000', 'consum', 0.0291, 'lps'),
	(641158, 136, '2015-01-01 00:21:22.000000', 'consum', 0.0239, 'lps'),
	(641159, 136, '2015-01-01 00:21:23.000000', 'consum', 0.0239, 'lps'),
	(641160, 136, '2015-01-01 00:21:24.000000', 'consum', 0.0265, 'lps'),
	(641161, 136, '2015-01-01 00:21:25.000000', 'consum', 0.0278, 'lps'),
	(641162, 136, '2015-01-01 00:21:26.000000', 'consum', 0.0258, 'lps'),
	(641163, 136, '2015-01-01 00:21:27.000000', 'consum', 0.0248, 'lps'),
	(641164, 136, '2015-01-01 00:21:28.000000', 'consum', 0.0256, 'lps'),
	(641165, 136, '2015-01-01 00:21:29.000000', 'consum', 0.0326, 'lps'),
	(641166, 136, '2015-01-01 00:21:30.000000', 'consum', 0.0280, 'lps'),
	(641167, 136, '2015-01-01 00:21:31.000000', 'consum', 0.0212, 'lps'),
	(641168, 136, '2015-01-01 00:21:32.000000', 'consum', 0.0259, 'lps'),
	(641169, 136, '2015-01-01 00:21:33.000000', 'consum', 0.0327, 'lps'),
	(641170, 136, '2015-01-01 00:21:34.000000', 'consum', 0.0277, 'lps'),
	(641171, 136, '2015-01-01 00:21:35.000000', 'consum', 0.0316, 'lps'),
	(641172, 136, '2015-01-01 00:21:36.000000', 'consum', 0.0293, 'lps'),
	(641173, 136, '2015-01-01 00:21:37.000000', 'consum', 0.0309, 'lps'),
	(641174, 136, '2015-01-01 00:21:38.000000', 'consum', 0.0330, 'lps'),
	(641175, 136, '2015-01-01 00:21:39.000000', 'consum', 0.0268, 'lps'),
	(641176, 136, '2015-01-01 00:21:40.000000', 'consum', 0.0265, 'lps'),
	(641177, 136, '2015-01-01 00:21:41.000000', 'consum', 0.0312, 'lps'),
	(641178, 136, '2015-01-01 00:21:42.000000', 'consum', 0.0305, 'lps'),
	(641179, 136, '2015-01-01 00:21:43.000000', 'consum', 0.0257, 'lps'),
	(641180, 136, '2015-01-01 00:21:44.000000', 'consum', 0.0282, 'lps'),
	(641181, 136, '2015-01-01 00:21:45.000000', 'consum', 0.0309, 'lps'),
	(641182, 136, '2015-01-01 00:21:46.000000', 'consum', 0.0240, 'lps'),
	(641183, 136, '2015-01-01 00:21:47.000000', 'consum', 0.0310, 'lps'),
	(641184, 136, '2015-01-01 00:21:48.000000', 'consum', 0.0249, 'lps'),
	(641185, 136, '2015-01-01 00:21:49.000000', 'consum', 0.0228, 'lps'),
	(641186, 136, '2015-01-01 00:21:50.000000', 'consum', 0.0311, 'lps'),
	(641187, 136, '2015-01-01 00:21:51.000000', 'consum', 0.0286, 'lps'),
	(641188, 136, '2015-01-01 00:21:52.000000', 'consum', 0.0288, 'lps'),
	(641189, 136, '2015-01-01 00:21:53.000000', 'consum', 0.0251, 'lps'),
	(641190, 136, '2015-01-01 00:21:54.000000', 'consum', 0.0303, 'lps'),
	(641191, 136, '2015-01-01 00:21:55.000000', 'consum', 0.0304, 'lps'),
	(641192, 136, '2015-01-01 00:21:56.000000', 'consum', 0.0279, 'lps'),
	(641193, 136, '2015-01-01 00:21:57.000000', 'consum', 0.0272, 'lps'),
	(641194, 136, '2015-01-01 00:21:58.000000', 'consum', 0.0315, 'lps'),
	(641195, 136, '2015-01-01 00:21:59.000000', 'consum', 0.0300, 'lps'),
	(641196, 136, '2015-01-01 00:22:00.000000', 'consum', 0.0220, 'lps'),
	(641197, 136, '2015-01-01 00:22:01.000000', 'consum', 0.0242, 'lps'),
	(641198, 136, '2015-01-01 00:22:02.000000', 'consum', 0.0215, 'lps'),
	(641199, 136, '2015-01-01 00:22:03.000000', 'consum', 0.0265, 'lps'),
	(641200, 136, '2015-01-01 00:22:04.000000', 'consum', 0.0221, 'lps'),
	(641201, 136, '2015-01-01 00:22:05.000000', 'consum', 0.0227, 'lps'),
	(641202, 136, '2015-01-01 00:22:06.000000', 'consum', 0.0260, 'lps'),
	(641203, 136, '2015-01-01 00:22:07.000000', 'consum', 0.0285, 'lps'),
	(641204, 136, '2015-01-01 00:22:08.000000', 'consum', 0.0311, 'lps'),
	(641205, 136, '2015-01-01 00:22:09.000000', 'consum', 0.0245, 'lps'),
	(641206, 136, '2015-01-01 00:22:10.000000', 'consum', 0.0330, 'lps'),
	(641207, 136, '2015-01-01 00:22:11.000000', 'consum', 0.0331, 'lps'),
	(641208, 136, '2015-01-01 00:22:12.000000', 'consum', 0.0210, 'lps'),
	(641209, 136, '2015-01-01 00:22:13.000000', 'consum', 0.0220, 'lps'),
	(641210, 136, '2015-01-01 00:22:14.000000', 'consum', 0.0261, 'lps'),
	(641211, 136, '2015-01-01 00:22:15.000000', 'consum', 0.0310, 'lps'),
	(641212, 136, '2015-01-01 00:22:16.000000', 'consum', 0.0311, 'lps'),
	(641213, 136, '2015-01-01 00:22:17.000000', 'consum', 0.0289, 'lps'),
	(641214, 136, '2015-01-01 00:22:18.000000', 'consum', 0.0306, 'lps'),
	(641215, 136, '2015-01-01 00:22:19.000000', 'consum', 0.0326, 'lps'),
	(641216, 136, '2015-01-01 00:22:20.000000', 'consum', 0.0255, 'lps'),
	(641217, 136, '2015-01-01 00:22:21.000000', 'consum', 0.0212, 'lps'),
	(641218, 136, '2015-01-01 00:22:22.000000', 'consum', 0.0332, 'lps'),
	(641219, 136, '2015-01-01 00:22:23.000000', 'consum', 0.0318, 'lps'),
	(641220, 136, '2015-01-01 00:22:24.000000', 'consum', 0.0261, 'lps'),
	(641221, 136, '2015-01-01 00:22:25.000000', 'consum', 0.0264, 'lps'),
	(641222, 136, '2015-01-01 00:22:26.000000', 'consum', 0.0328, 'lps'),
	(641223, 136, '2015-01-01 00:22:27.000000', 'consum', 0.0268, 'lps'),
	(641224, 136, '2015-01-01 00:22:28.000000', 'consum', 0.0269, 'lps'),
	(641225, 136, '2015-01-01 00:22:29.000000', 'consum', 0.0332, 'lps'),
	(641226, 136, '2015-01-01 00:22:30.000000', 'consum', 0.0270, 'lps'),
	(641227, 136, '2015-01-01 00:22:31.000000', 'consum', 0.0271, 'lps'),
	(641228, 136, '2015-01-01 00:22:32.000000', 'consum', 0.0332, 'lps'),
	(641229, 136, '2015-01-01 00:22:33.000000', 'consum', 0.0269, 'lps'),
	(641230, 136, '2015-01-01 00:22:34.000000', 'consum', 0.0262, 'lps'),
	(641231, 136, '2015-01-01 00:22:35.000000', 'consum', 0.0296, 'lps'),
	(641232, 136, '2015-01-01 00:22:36.000000', 'consum', 0.0233, 'lps'),
	(641233, 136, '2015-01-01 00:22:37.000000', 'consum', 0.0318, 'lps'),
	(641234, 136, '2015-01-01 00:22:38.000000', 'consum', 0.0311, 'lps'),
	(641235, 136, '2015-01-01 00:22:39.000000', 'consum', 0.0265, 'lps'),
	(641236, 136, '2015-01-01 00:22:40.000000', 'consum', 0.0308, 'lps'),
	(641237, 136, '2015-01-01 00:22:41.000000', 'consum', 0.0286, 'lps'),
	(641238, 136, '2015-01-01 00:22:42.000000', 'consum', 0.0295, 'lps'),
	(641239, 136, '2015-01-01 00:22:43.000000', 'consum', 0.0286, 'lps'),
	(641240, 136, '2015-01-01 00:22:44.000000', 'consum', 0.0210, 'lps'),
	(641241, 136, '2015-01-01 00:22:45.000000', 'consum', 0.0233, 'lps'),
	(641242, 136, '2015-01-01 00:22:46.000000', 'consum', 0.0324, 'lps'),
	(641243, 136, '2015-01-01 00:22:47.000000', 'consum', 0.0217, 'lps'),
	(641244, 136, '2015-01-01 00:22:48.000000', 'consum', 0.0275, 'lps'),
	(641245, 136, '2015-01-01 00:22:49.000000', 'consum', 0.0268, 'lps'),
	(641246, 136, '2015-01-01 00:22:50.000000', 'consum', 0.0303, 'lps'),
	(641247, 136, '2015-01-01 00:22:51.000000', 'consum', 0.0252, 'lps'),
	(641248, 136, '2015-01-01 00:22:52.000000', 'consum', 0.0268, 'lps'),
	(641249, 136, '2015-01-01 00:22:53.000000', 'consum', 0.0252, 'lps'),
	(641250, 136, '2015-01-01 00:22:54.000000', 'consum', 0.0243, 'lps'),
	(641251, 136, '2015-01-01 00:22:55.000000', 'consum', 0.0251, 'lps'),
	(641252, 136, '2015-01-01 00:22:56.000000', 'consum', 0.0318, 'lps'),
	(641253, 136, '2015-01-01 00:22:57.000000', 'consum', 0.0253, 'lps'),
	(641254, 136, '2015-01-01 00:22:58.000000', 'consum', 0.0225, 'lps'),
	(641255, 136, '2015-01-01 00:22:59.000000', 'consum', 0.0282, 'lps'),
	(641256, 136, '2015-01-01 00:23:00.000000', 'consum', 0.0278, 'lps'),
	(641257, 136, '2015-01-01 00:23:01.000000', 'consum', 0.0211, 'lps'),
	(641258, 136, '2015-01-01 00:23:02.000000', 'consum', 0.0258, 'lps'),
	(641259, 136, '2015-01-01 00:23:03.000000', 'consum', 0.0324, 'lps'),
	(641260, 136, '2015-01-01 00:23:04.000000', 'consum', 0.0263, 'lps'),
	(641261, 136, '2015-01-01 00:23:05.000000', 'consum', 0.0260, 'lps'),
	(641262, 136, '2015-01-01 00:23:06.000000', 'consum', 0.0301, 'lps'),
	(641263, 136, '2015-01-01 00:23:07.000000', 'consum', 0.0267, 'lps'),
	(641264, 136, '2015-01-01 00:23:08.000000', 'consum', 0.0224, 'lps'),
	(641265, 136, '2015-01-01 00:23:09.000000', 'consum', 0.0232, 'lps'),
	(641266, 136, '2015-01-01 00:23:10.000000', 'consum', 0.0280, 'lps'),
	(641267, 136, '2015-01-01 00:23:11.000000', 'consum', 0.0247, 'lps'),
	(641268, 136, '2015-01-01 00:23:12.000000', 'consum', 0.0309, 'lps'),
	(641269, 136, '2015-01-01 00:23:13.000000', 'consum', 0.0221, 'lps'),
	(641270, 136, '2015-01-01 00:23:14.000000', 'consum', 0.0217, 'lps'),
	(641271, 136, '2015-01-01 00:23:15.000000', 'consum', 0.0211, 'lps'),
	(641272, 136, '2015-01-01 00:23:16.000000', 'consum', 0.0319, 'lps'),
	(641273, 136, '2015-01-01 00:23:17.000000', 'consum', 0.0256, 'lps'),
	(641274, 136, '2015-01-01 00:23:18.000000', 'consum', 0.0237, 'lps'),
	(641275, 136, '2015-01-01 00:23:19.000000', 'consum', 0.0331, 'lps'),
	(641276, 136, '2015-01-01 00:23:20.000000', 'consum', 0.0241, 'lps'),
	(641277, 136, '2015-01-01 00:23:21.000000', 'consum', 0.0248, 'lps'),
	(641278, 136, '2015-01-01 00:23:22.000000', 'consum', 0.0307, 'lps'),
	(641279, 136, '2015-01-01 00:23:23.000000', 'consum', 0.0333, 'lps'),
	(641280, 136, '2015-01-01 00:23:24.000000', 'consum', 0.0288, 'lps'),
	(641281, 136, '2015-01-01 00:23:25.000000', 'consum', 0.0231, 'lps'),
	(641282, 136, '2015-01-01 00:23:26.000000', 'consum', 0.0328, 'lps'),
	(641283, 136, '2015-01-01 00:23:27.000000', 'consum', 0.0242, 'lps'),
	(641284, 136, '2015-01-01 00:23:28.000000', 'consum', 0.0265, 'lps'),
	(641285, 136, '2015-01-01 00:23:29.000000', 'consum', 0.0267, 'lps'),
	(641286, 136, '2015-01-01 00:23:30.000000', 'consum', 0.0330, 'lps'),
	(641287, 136, '2015-01-01 00:23:31.000000', 'consum', 0.0266, 'lps'),
	(641288, 136, '2015-01-01 00:23:32.000000', 'consum', 0.0257, 'lps'),
	(641289, 136, '2015-01-01 00:23:33.000000', 'consum', 0.0276, 'lps'),
	(641290, 136, '2015-01-01 00:23:34.000000', 'consum', 0.0274, 'lps'),
	(641291, 136, '2015-01-01 00:23:35.000000', 'consum', 0.0211, 'lps'),
	(641292, 136, '2015-01-01 00:23:36.000000', 'consum', 0.0272, 'lps'),
	(641293, 136, '2015-01-01 00:23:37.000000', 'consum', 0.0270, 'lps'),
	(641294, 136, '2015-01-01 00:23:38.000000', 'consum', 0.0324, 'lps'),
	(641295, 136, '2015-01-01 00:23:39.000000', 'consum', 0.0228, 'lps'),
	(641296, 136, '2015-01-01 00:23:40.000000', 'consum', 0.0331, 'lps'),
	(641297, 136, '2015-01-01 00:23:41.000000', 'consum', 0.0263, 'lps'),
	(641298, 136, '2015-01-01 00:23:42.000000', 'consum', 0.0240, 'lps'),
	(641299, 136, '2015-01-01 00:23:43.000000', 'consum', 0.0322, 'lps'),
	(641300, 136, '2015-01-01 00:23:44.000000', 'consum', 0.0311, 'lps'),
	(641301, 136, '2015-01-01 00:23:45.000000', 'consum', 0.0256, 'lps'),
	(641302, 136, '2015-01-01 00:23:46.000000', 'consum', 0.0259, 'lps'),
	(641303, 136, '2015-01-01 00:23:47.000000', 'consum', 0.0319, 'lps'),
	(641304, 136, '2015-01-01 00:23:48.000000', 'consum', 0.0235, 'lps'),
	(641305, 136, '2015-01-01 00:23:49.000000', 'consum', 0.0257, 'lps'),
	(641306, 136, '2015-01-01 00:23:50.000000', 'consum', 0.0247, 'lps'),
	(641307, 136, '2015-01-01 00:23:51.000000', 'consum', 0.0256, 'lps'),
	(641308, 136, '2015-01-01 00:23:52.000000', 'consum', 0.0330, 'lps'),
	(641309, 136, '2015-01-01 00:23:53.000000', 'consum', 0.0298, 'lps'),
	(641310, 136, '2015-01-01 00:23:54.000000', 'consum', 0.0291, 'lps'),
	(641311, 136, '2015-01-01 00:23:55.000000', 'consum', 0.0226, 'lps'),
	(641312, 136, '2015-01-01 00:23:56.000000', 'consum', 0.0298, 'lps'),
	(641313, 136, '2015-01-01 00:23:57.000000', 'consum', 0.0229, 'lps'),
	(641314, 136, '2015-01-01 00:23:58.000000', 'consum', 0.0289, 'lps'),
	(641315, 136, '2015-01-01 00:23:59.000000', 'consum', 0.0301, 'lps'),
	(641316, 136, '2015-01-01 00:24:00.000000', 'consum', 0.0304, 'lps'),
	(641317, 136, '2015-01-01 00:24:01.000000', 'consum', 0.0282, 'lps'),
	(641318, 136, '2015-01-01 00:24:02.000000', 'consum', 0.0292, 'lps'),
	(641319, 136, '2015-01-01 00:24:03.000000', 'consum', 0.0277, 'lps'),
	(641320, 136, '2015-01-01 00:24:04.000000', 'consum', 0.0301, 'lps'),
	(641321, 136, '2015-01-01 00:24:05.000000', 'consum', 0.0217, 'lps'),
	(641322, 136, '2015-01-01 00:24:06.000000', 'consum', 0.0220, 'lps'),
	(641323, 136, '2015-01-01 00:24:07.000000', 'consum', 0.0240, 'lps'),
	(641324, 136, '2015-01-01 00:24:08.000000', 'consum', 0.0331, 'lps'),
	(641325, 136, '2015-01-01 00:24:09.000000', 'consum', 0.0230, 'lps'),
	(641326, 136, '2015-01-01 00:24:10.000000', 'consum', 0.0317, 'lps'),
	(641327, 136, '2015-01-01 00:24:11.000000', 'consum', 0.0316, 'lps'),
	(641328, 136, '2015-01-01 00:24:12.000000', 'consum', 0.0297, 'lps'),
	(641329, 136, '2015-01-01 00:24:13.000000', 'consum', 0.0324, 'lps'),
	(641330, 136, '2015-01-01 00:24:14.000000', 'consum', 0.0274, 'lps'),
	(641331, 136, '2015-01-01 00:24:15.000000', 'consum', 0.0314, 'lps'),
	(641332, 136, '2015-01-01 00:24:16.000000', 'consum', 0.0288, 'lps'),
	(641333, 136, '2015-01-01 00:24:17.000000', 'consum', 0.0288, 'lps'),
	(641334, 136, '2015-01-01 00:24:18.000000', 'consum', 0.0245, 'lps'),
	(641335, 136, '2015-01-01 00:24:19.000000', 'consum', 0.0273, 'lps'),
	(641336, 136, '2015-01-01 00:24:20.000000', 'consum', 0.0296, 'lps'),
	(641337, 136, '2015-01-01 00:24:21.000000', 'consum', 0.0330, 'lps'),
	(641338, 136, '2015-01-01 00:24:22.000000', 'consum', 0.0303, 'lps'),
	(641339, 136, '2015-01-01 00:24:23.000000', 'consum', 0.0315, 'lps'),
	(641340, 136, '2015-01-01 00:24:24.000000', 'consum', 0.0331, 'lps'),
	(641341, 136, '2015-01-01 00:24:25.000000', 'consum', 0.0255, 'lps'),
	(641342, 136, '2015-01-01 00:24:26.000000', 'consum', 0.0321, 'lps'),
	(641343, 136, '2015-01-01 00:24:27.000000', 'consum', 0.0257, 'lps'),
	(641344, 136, '2015-01-01 00:24:28.000000', 'consum', 0.0239, 'lps'),
	(641345, 136, '2015-01-01 00:24:29.000000', 'consum', 0.0212, 'lps'),
	(641346, 136, '2015-01-01 00:24:30.000000', 'consum', 0.0260, 'lps'),
	(641347, 136, '2015-01-01 00:24:31.000000', 'consum', 0.0329, 'lps'),
	(641348, 136, '2015-01-01 00:24:32.000000', 'consum', 0.0284, 'lps'),
	(641349, 136, '2015-01-01 00:24:33.000000', 'consum', 0.0224, 'lps'),
	(641350, 136, '2015-01-01 00:24:34.000000', 'consum', 0.0305, 'lps'),
	(641351, 136, '2015-01-01 00:24:35.000000', 'consum', 0.0273, 'lps'),
	(641352, 136, '2015-01-01 00:24:36.000000', 'consum', 0.0239, 'lps'),
	(641353, 136, '2015-01-01 00:24:37.000000', 'consum', 0.0293, 'lps'),
	(641354, 136, '2015-01-01 00:24:38.000000', 'consum', 0.0289, 'lps'),
	(641355, 136, '2015-01-01 00:24:39.000000', 'consum', 0.0234, 'lps'),
	(641356, 136, '2015-01-01 00:24:40.000000', 'consum', 0.0218, 'lps'),
	(641357, 136, '2015-01-01 00:24:41.000000', 'consum', 0.0301, 'lps'),
	(641358, 136, '2015-01-01 00:24:42.000000', 'consum', 0.0270, 'lps'),
	(641359, 136, '2015-01-01 00:24:43.000000', 'consum', 0.0236, 'lps'),
	(641360, 136, '2015-01-01 00:24:44.000000', 'consum', 0.0286, 'lps'),
	(641361, 136, '2015-01-01 00:24:45.000000', 'consum', 0.0264, 'lps'),
	(641362, 136, '2015-01-01 00:24:46.000000', 'consum', 0.0251, 'lps'),
	(641363, 136, '2015-01-01 00:24:47.000000', 'consum', 0.0256, 'lps'),
	(641364, 136, '2015-01-01 00:24:48.000000', 'consum', 0.0318, 'lps'),
	(641365, 136, '2015-01-01 00:24:49.000000', 'consum', 0.0238, 'lps'),
	(641366, 136, '2015-01-01 00:24:50.000000', 'consum', 0.0277, 'lps'),
	(641367, 136, '2015-01-01 00:24:51.000000', 'consum', 0.0213, 'lps'),
	(641368, 136, '2015-01-01 00:24:52.000000', 'consum', 0.0272, 'lps'),
	(641369, 136, '2015-01-01 00:24:53.000000', 'consum', 0.0264, 'lps'),
	(641370, 136, '2015-01-01 00:24:54.000000', 'consum', 0.0295, 'lps'),
	(641371, 136, '2015-01-01 00:24:55.000000', 'consum', 0.0225, 'lps'),
	(641372, 136, '2015-01-01 00:24:56.000000', 'consum', 0.0277, 'lps'),
	(641373, 136, '2015-01-01 00:24:57.000000', 'consum', 0.0252, 'lps'),
	(641374, 136, '2015-01-01 00:24:58.000000', 'consum', 0.0222, 'lps'),
	(641375, 136, '2015-01-01 00:24:59.000000', 'consum', 0.0269, 'lps'),
	(641376, 136, '2015-01-01 00:25:00.000000', 'consum', 0.0222, 'lps'),
	(641377, 136, '2015-01-01 00:25:01.000000', 'consum', 0.0215, 'lps'),
	(641378, 136, '2015-01-01 00:25:02.000000', 'consum', 0.0323, 'lps'),
	(641379, 136, '2015-01-01 00:25:03.000000', 'consum', 0.0267, 'lps'),
	(641380, 136, '2015-01-01 00:25:04.000000', 'consum', 0.0280, 'lps'),
	(641381, 136, '2015-01-01 00:25:05.000000', 'consum', 0.0266, 'lps'),
	(641382, 136, '2015-01-01 00:25:06.000000', 'consum', 0.0281, 'lps'),
	(641383, 136, '2015-01-01 00:25:07.000000', 'consum', 0.0272, 'lps'),
	(641384, 136, '2015-01-01 00:25:08.000000', 'consum', 0.0308, 'lps'),
	(641385, 136, '2015-01-01 00:25:09.000000', 'consum', 0.0265, 'lps'),
	(641386, 136, '2015-01-01 00:25:10.000000', 'consum', 0.0315, 'lps'),
	(641387, 136, '2015-01-01 00:25:11.000000', 'consum', 0.0324, 'lps'),
	(641388, 136, '2015-01-01 00:25:12.000000', 'consum', 0.0219, 'lps'),
	(641389, 136, '2015-01-01 00:25:13.000000', 'consum', 0.0284, 'lps'),
	(641390, 136, '2015-01-01 00:25:14.000000', 'consum', 0.0307, 'lps'),
	(641391, 136, '2015-01-01 00:25:15.000000', 'consum', 0.0225, 'lps'),
	(641392, 136, '2015-01-01 00:25:16.000000', 'consum', 0.0241, 'lps'),
	(641393, 136, '2015-01-01 00:25:17.000000', 'consum', 0.0321, 'lps'),
	(641394, 136, '2015-01-01 00:25:18.000000', 'consum', 0.0301, 'lps'),
	(641395, 136, '2015-01-01 00:25:19.000000', 'consum', 0.0333, 'lps'),
	(641396, 136, '2015-01-01 00:25:20.000000', 'consum', 0.0306, 'lps'),
	(641397, 136, '2015-01-01 00:25:21.000000', 'consum', 0.0319, 'lps'),
	(641398, 136, '2015-01-01 00:25:22.000000', 'consum', 0.0220, 'lps'),
	(641399, 136, '2015-01-01 00:25:23.000000', 'consum', 0.0307, 'lps'),
	(641400, 136, '2015-01-01 00:25:24.000000', 'consum', 0.0294, 'lps'),
	(641401, 136, '2015-01-01 00:25:25.000000', 'consum', 0.0213, 'lps'),
	(641402, 136, '2015-01-01 00:25:26.000000', 'consum', 0.0222, 'lps'),
	(641403, 136, '2015-01-01 00:25:27.000000', 'consum', 0.0263, 'lps'),
	(641404, 136, '2015-01-01 00:25:28.000000', 'consum', 0.0316, 'lps'),
	(641405, 136, '2015-01-01 00:25:29.000000', 'consum', 0.0331, 'lps'),
	(641406, 136, '2015-01-01 00:25:30.000000', 'consum', 0.0252, 'lps'),
	(641407, 136, '2015-01-01 00:25:31.000000', 'consum', 0.0305, 'lps'),
	(641408, 136, '2015-01-01 00:25:32.000000', 'consum', 0.0312, 'lps'),
	(641409, 136, '2015-01-01 00:25:33.000000', 'consum', 0.0309, 'lps'),
	(641410, 136, '2015-01-01 00:25:34.000000', 'consum', 0.0278, 'lps'),
	(641411, 136, '2015-01-01 00:25:35.000000', 'consum', 0.0253, 'lps'),
	(641412, 136, '2015-01-01 00:25:36.000000', 'consum', 0.0219, 'lps'),
	(641413, 136, '2015-01-01 00:25:37.000000', 'consum', 0.0253, 'lps'),
	(641414, 136, '2015-01-01 00:25:38.000000', 'consum', 0.0275, 'lps'),
	(641415, 136, '2015-01-01 00:25:39.000000', 'consum', 0.0284, 'lps'),
	(641416, 136, '2015-01-01 00:25:40.000000', 'consum', 0.0259, 'lps'),
	(641417, 136, '2015-01-01 00:25:41.000000', 'consum', 0.0235, 'lps'),
	(641418, 136, '2015-01-01 00:25:42.000000', 'consum', 0.0310, 'lps'),
	(641419, 136, '2015-01-01 00:25:43.000000', 'consum', 0.0267, 'lps'),
	(641420, 136, '2015-01-01 00:25:44.000000', 'consum', 0.0317, 'lps'),
	(641421, 136, '2015-01-01 00:25:45.000000', 'consum', 0.0329, 'lps'),
	(641422, 136, '2015-01-01 00:25:46.000000', 'consum', 0.0236, 'lps'),
	(641423, 136, '2015-01-01 00:25:47.000000', 'consum', 0.0233, 'lps'),
	(641424, 136, '2015-01-01 00:25:48.000000', 'consum', 0.0245, 'lps'),
	(641425, 136, '2015-01-01 00:25:49.000000', 'consum', 0.0319, 'lps'),
	(641426, 136, '2015-01-01 00:25:50.000000', 'consum', 0.0277, 'lps'),
	(641427, 136, '2015-01-01 00:25:51.000000', 'consum', 0.0219, 'lps'),
	(641428, 136, '2015-01-01 00:25:52.000000', 'consum', 0.0302, 'lps'),
	(641429, 136, '2015-01-01 00:25:53.000000', 'consum', 0.0273, 'lps'),
	(641430, 136, '2015-01-01 00:25:54.000000', 'consum', 0.0251, 'lps'),
	(641431, 136, '2015-01-01 00:25:55.000000', 'consum', 0.0223, 'lps'),
	(641432, 136, '2015-01-01 00:25:56.000000', 'consum', 0.0279, 'lps'),
	(641433, 136, '2015-01-01 00:25:57.000000', 'consum', 0.0269, 'lps'),
	(641434, 136, '2015-01-01 00:25:58.000000', 'consum', 0.0299, 'lps'),
	(641435, 136, '2015-01-01 00:25:59.000000', 'consum', 0.0231, 'lps'),
	(641436, 136, '2015-01-01 00:26:00.000000', 'consum', 0.0295, 'lps'),
	(641437, 136, '2015-01-01 00:26:01.000000', 'consum', 0.0324, 'lps'),
	(641438, 136, '2015-01-01 00:26:02.000000', 'consum', 0.0278, 'lps'),
	(641439, 136, '2015-01-01 00:26:03.000000', 'consum', 0.0332, 'lps'),
	(641440, 136, '2015-01-01 00:26:04.000000', 'consum', 0.0243, 'lps'),
	(641441, 136, '2015-01-01 00:26:05.000000', 'consum', 0.0258, 'lps'),
	(641442, 136, '2015-01-01 00:26:06.000000', 'consum', 0.0228, 'lps'),
	(641443, 136, '2015-01-01 00:26:07.000000', 'consum', 0.0281, 'lps'),
	(641444, 136, '2015-01-01 00:26:08.000000', 'consum', 0.0263, 'lps'),
	(641445, 136, '2015-01-01 00:26:09.000000', 'consum', 0.0262, 'lps'),
	(641446, 136, '2015-01-01 00:26:10.000000', 'consum', 0.0310, 'lps'),
	(641447, 136, '2015-01-01 00:26:11.000000', 'consum', 0.0308, 'lps'),
	(641448, 136, '2015-01-01 00:26:12.000000', 'consum', 0.0275, 'lps'),
	(641449, 136, '2015-01-01 00:26:13.000000', 'consum', 0.0244, 'lps'),
	(641450, 136, '2015-01-01 00:26:14.000000', 'consum', 0.0310, 'lps'),
	(641451, 136, '2015-01-01 00:26:15.000000', 'consum', 0.0237, 'lps'),
	(641452, 136, '2015-01-01 00:26:16.000000', 'consum', 0.0293, 'lps'),
	(641453, 136, '2015-01-01 00:26:17.000000', 'consum', 0.0295, 'lps'),
	(641454, 136, '2015-01-01 00:26:18.000000', 'consum', 0.0265, 'lps'),
	(641455, 136, '2015-01-01 00:26:19.000000', 'consum', 0.0229, 'lps'),
	(641456, 136, '2015-01-01 00:26:20.000000', 'consum', 0.0264, 'lps'),
	(641457, 136, '2015-01-01 00:26:21.000000', 'consum', 0.0299, 'lps'),
	(641458, 136, '2015-01-01 00:26:22.000000', 'consum', 0.0248, 'lps'),
	(641459, 136, '2015-01-01 00:26:23.000000', 'consum', 0.0256, 'lps'),
	(641460, 136, '2015-01-01 00:26:24.000000', 'consum', 0.0326, 'lps'),
	(641461, 136, '2015-01-01 00:26:25.000000', 'consum', 0.0280, 'lps'),
	(641462, 136, '2015-01-01 00:26:26.000000', 'consum', 0.0212, 'lps'),
	(641463, 136, '2015-01-01 00:26:27.000000', 'consum', 0.0260, 'lps'),
	(641464, 136, '2015-01-01 00:26:28.000000', 'consum', 0.0331, 'lps'),
	(641465, 136, '2015-01-01 00:26:29.000000', 'consum', 0.0291, 'lps'),
	(641466, 136, '2015-01-01 00:26:30.000000', 'consum', 0.0255, 'lps'),
	(641467, 136, '2015-01-01 00:26:31.000000', 'consum', 0.0317, 'lps'),
	(641468, 136, '2015-01-01 00:26:32.000000', 'consum', 0.0236, 'lps'),
	(641469, 136, '2015-01-01 00:26:33.000000', 'consum', 0.0267, 'lps'),
	(641470, 136, '2015-01-01 00:26:34.000000', 'consum', 0.0297, 'lps'),
	(641471, 136, '2015-01-01 00:26:35.000000', 'consum', 0.0223, 'lps'),
	(641472, 136, '2015-01-01 00:26:36.000000', 'consum', 0.0263, 'lps'),
	(641473, 136, '2015-01-01 00:26:37.000000', 'consum', 0.0315, 'lps'),
	(641474, 136, '2015-01-01 00:26:38.000000', 'consum', 0.0326, 'lps'),
	(641475, 136, '2015-01-01 00:26:39.000000', 'consum', 0.0230, 'lps'),
	(641476, 136, '2015-01-01 00:26:40.000000', 'consum', 0.0210, 'lps'),
	(641477, 136, '2015-01-01 00:26:41.000000', 'consum', 0.0274, 'lps'),
	(641478, 136, '2015-01-01 00:26:42.000000', 'consum', 0.0284, 'lps'),
	(641479, 136, '2015-01-01 00:26:43.000000', 'consum', 0.0264, 'lps'),
	(641480, 136, '2015-01-01 00:26:44.000000', 'consum', 0.0258, 'lps'),
	(641481, 136, '2015-01-01 00:26:45.000000', 'consum', 0.0289, 'lps'),
	(641482, 136, '2015-01-01 00:26:46.000000', 'consum', 0.0212, 'lps'),
	(641483, 136, '2015-01-01 00:26:47.000000', 'consum', 0.0233, 'lps'),
	(641484, 136, '2015-01-01 00:26:48.000000', 'consum', 0.0318, 'lps'),
	(641485, 136, '2015-01-01 00:26:49.000000', 'consum', 0.0310, 'lps'),
	(641486, 136, '2015-01-01 00:26:50.000000', 'consum', 0.0261, 'lps'),
	(641487, 136, '2015-01-01 00:26:51.000000', 'consum', 0.0293, 'lps'),
	(641488, 136, '2015-01-01 00:26:52.000000', 'consum', 0.0221, 'lps'),
	(641489, 136, '2015-01-01 00:26:53.000000', 'consum', 0.0265, 'lps'),
	(641490, 136, '2015-01-01 00:26:54.000000', 'consum', 0.0329, 'lps'),
	(641491, 136, '2015-01-01 00:26:55.000000', 'consum', 0.0270, 'lps'),
	(641492, 136, '2015-01-01 00:26:56.000000', 'consum', 0.0275, 'lps'),
	(641493, 136, '2015-01-01 00:26:57.000000', 'consum', 0.0232, 'lps'),
	(641494, 136, '2015-01-01 00:26:58.000000', 'consum', 0.0252, 'lps'),
	(641495, 136, '2015-01-01 00:26:59.000000', 'consum', 0.0228, 'lps'),
	(641496, 136, '2015-01-01 00:27:00.000000', 'consum', 0.0299, 'lps'),
	(641497, 136, '2015-01-01 00:27:01.000000', 'consum', 0.0231, 'lps'),
	(641498, 136, '2015-01-01 00:27:02.000000', 'consum', 0.0295, 'lps'),
	(641499, 136, '2015-01-01 00:27:03.000000', 'consum', 0.0324, 'lps'),
	(641500, 136, '2015-01-01 00:27:04.000000', 'consum', 0.0280, 'lps'),
	(641501, 136, '2015-01-01 00:27:05.000000', 'consum', 0.0216, 'lps'),
	(641502, 136, '2015-01-01 00:27:06.000000', 'consum', 0.0279, 'lps'),
	(641503, 136, '2015-01-01 00:27:07.000000', 'consum', 0.0291, 'lps'),
	(641504, 136, '2015-01-01 00:27:08.000000', 'consum', 0.0283, 'lps'),
	(641505, 136, '2015-01-01 00:27:09.000000', 'consum', 0.0331, 'lps'),
	(641506, 136, '2015-01-01 00:27:10.000000', 'consum', 0.0228, 'lps'),
	(641507, 136, '2015-01-01 00:27:11.000000', 'consum', 0.0307, 'lps'),
	(641508, 136, '2015-01-01 00:27:12.000000', 'consum', 0.0268, 'lps'),
	(641509, 136, '2015-01-01 00:27:13.000000', 'consum', 0.0213, 'lps'),
	(641510, 136, '2015-01-01 00:27:14.000000', 'consum', 0.0296, 'lps'),
	(641511, 136, '2015-01-01 00:27:15.000000', 'consum', 0.0261, 'lps'),
	(641512, 136, '2015-01-01 00:27:16.000000', 'consum', 0.0333, 'lps'),
	(641513, 136, '2015-01-01 00:27:17.000000', 'consum', 0.0301, 'lps'),
	(641514, 136, '2015-01-01 00:27:18.000000', 'consum', 0.0293, 'lps'),
	(641515, 136, '2015-01-01 00:27:19.000000', 'consum', 0.0231, 'lps'),
	(641516, 136, '2015-01-01 00:27:20.000000', 'consum', 0.0316, 'lps'),
	(641517, 136, '2015-01-01 00:27:21.000000', 'consum', 0.0302, 'lps'),
	(641518, 136, '2015-01-01 00:27:22.000000', 'consum', 0.0232, 'lps'),
	(641519, 136, '2015-01-01 00:27:23.000000', 'consum', 0.0290, 'lps'),
	(641520, 136, '2015-01-01 00:27:24.000000', 'consum', 0.0296, 'lps'),
	(641521, 136, '2015-01-01 00:27:25.000000', 'consum', 0.0278, 'lps'),
	(641522, 136, '2015-01-01 00:27:26.000000', 'consum', 0.0291, 'lps'),
	(641523, 136, '2015-01-01 00:27:27.000000', 'consum', 0.0290, 'lps'),
	(641524, 136, '2015-01-01 00:27:28.000000', 'consum', 0.0241, 'lps'),
	(641525, 136, '2015-01-01 00:27:29.000000', 'consum', 0.0253, 'lps'),
	(641526, 136, '2015-01-01 00:27:30.000000', 'consum', 0.0329, 'lps'),
	(641527, 136, '2015-01-01 00:27:31.000000', 'consum', 0.0304, 'lps'),
	(641528, 136, '2015-01-01 00:27:32.000000', 'consum', 0.0325, 'lps'),
	(641529, 136, '2015-01-01 00:27:33.000000', 'consum', 0.0254, 'lps'),
	(641530, 136, '2015-01-01 00:27:34.000000', 'consum', 0.0210, 'lps'),
	(641531, 136, '2015-01-01 00:27:35.000000', 'consum', 0.0326, 'lps'),
	(641532, 136, '2015-01-01 00:27:36.000000', 'consum', 0.0296, 'lps'),
	(641533, 136, '2015-01-01 00:27:37.000000', 'consum', 0.0291, 'lps'),
	(641534, 136, '2015-01-01 00:27:38.000000', 'consum', 0.0234, 'lps'),
	(641535, 136, '2015-01-01 00:27:39.000000', 'consum', 0.0210, 'lps'),
	(641536, 136, '2015-01-01 00:27:40.000000', 'consum', 0.0265, 'lps'),
	(641537, 136, '2015-01-01 00:27:41.000000', 'consum', 0.0237, 'lps'),
	(641538, 136, '2015-01-01 00:27:42.000000', 'consum', 0.0302, 'lps'),
	(641539, 136, '2015-01-01 00:27:43.000000', 'consum', 0.0221, 'lps'),
	(641540, 136, '2015-01-01 00:27:44.000000', 'consum', 0.0236, 'lps'),
	(641541, 136, '2015-01-01 00:27:45.000000', 'consum', 0.0308, 'lps'),
	(641542, 136, '2015-01-01 00:27:46.000000', 'consum', 0.0251, 'lps'),
	(641543, 136, '2015-01-01 00:27:47.000000', 'consum', 0.0244, 'lps'),
	(641544, 136, '2015-01-01 00:27:48.000000', 'consum', 0.0258, 'lps'),
	(641545, 136, '2015-01-01 00:27:49.000000', 'consum', 0.0224, 'lps'),
	(641546, 136, '2015-01-01 00:27:50.000000', 'consum', 0.0261, 'lps'),
	(641547, 136, '2015-01-01 00:27:51.000000', 'consum', 0.0298, 'lps'),
	(641548, 136, '2015-01-01 00:27:52.000000', 'consum', 0.0249, 'lps'),
	(641549, 136, '2015-01-01 00:27:53.000000', 'consum', 0.0268, 'lps'),
	(641550, 136, '2015-01-01 00:27:54.000000', 'consum', 0.0257, 'lps'),
	(641551, 136, '2015-01-01 00:27:55.000000', 'consum', 0.0272, 'lps'),
	(641552, 136, '2015-01-01 00:27:56.000000', 'consum', 0.0258, 'lps'),
	(641553, 136, '2015-01-01 00:27:57.000000', 'consum', 0.0262, 'lps'),
	(641554, 136, '2015-01-01 00:27:58.000000', 'consum', 0.0326, 'lps'),
	(641555, 136, '2015-01-01 00:27:59.000000', 'consum', 0.0262, 'lps'),
	(641556, 136, '2015-01-01 00:28:00.000000', 'consum', 0.0247, 'lps'),
	(641557, 136, '2015-01-01 00:28:01.000000', 'consum', 0.0239, 'lps'),
	(641558, 136, '2015-01-01 00:28:02.000000', 'consum', 0.0247, 'lps'),
	(641559, 136, '2015-01-01 00:28:03.000000', 'consum', 0.0308, 'lps'),
	(641560, 136, '2015-01-01 00:28:04.000000', 'consum', 0.0216, 'lps'),
	(641561, 136, '2015-01-01 00:28:05.000000', 'consum', 0.0321, 'lps'),
	(641562, 136, '2015-01-01 00:28:06.000000', 'consum', 0.0251, 'lps'),
	(641563, 136, '2015-01-01 00:28:07.000000', 'consum', 0.0331, 'lps'),
	(641564, 136, '2015-01-01 00:28:08.000000', 'consum', 0.0320, 'lps'),
	(641565, 136, '2015-01-01 00:28:09.000000', 'consum', 0.0272, 'lps'),
	(641566, 136, '2015-01-01 00:28:10.000000', 'consum', 0.0315, 'lps'),
	(641567, 136, '2015-01-01 00:28:11.000000', 'consum', 0.0300, 'lps'),
	(641568, 136, '2015-01-01 00:28:12.000000', 'consum', 0.0223, 'lps'),
	(641569, 136, '2015-01-01 00:28:13.000000', 'consum', 0.0254, 'lps'),
	(641570, 136, '2015-01-01 00:28:14.000000', 'consum', 0.0266, 'lps'),
	(641571, 136, '2015-01-01 00:28:15.000000', 'consum', 0.0234, 'lps'),
	(641572, 136, '2015-01-01 00:28:16.000000', 'consum', 0.0285, 'lps'),
	(641573, 136, '2015-01-01 00:28:17.000000', 'consum', 0.0268, 'lps'),
	(641574, 136, '2015-01-01 00:28:18.000000', 'consum', 0.0276, 'lps'),
	(641575, 136, '2015-01-01 00:28:19.000000', 'consum', 0.0244, 'lps'),
	(641576, 136, '2015-01-01 00:28:20.000000', 'consum', 0.0304, 'lps'),
	(641577, 136, '2015-01-01 00:28:21.000000', 'consum', 0.0332, 'lps'),
	(641578, 136, '2015-01-01 00:28:22.000000', 'consum', 0.0292, 'lps'),
	(641579, 136, '2015-01-01 00:28:23.000000', 'consum', 0.0253, 'lps'),
	(641580, 136, '2015-01-01 00:28:24.000000', 'consum', 0.0303, 'lps'),
	(641581, 136, '2015-01-01 00:28:25.000000', 'consum', 0.0299, 'lps'),
	(641582, 136, '2015-01-01 00:28:26.000000', 'consum', 0.0254, 'lps'),
	(641583, 136, '2015-01-01 00:28:27.000000', 'consum', 0.0285, 'lps'),
	(641584, 136, '2015-01-01 00:28:28.000000', 'consum', 0.0330, 'lps'),
	(641585, 136, '2015-01-01 00:28:29.000000', 'consum', 0.0215, 'lps'),
	(641586, 136, '2015-01-01 00:28:30.000000', 'consum', 0.0247, 'lps'),
	(641587, 136, '2015-01-01 00:28:31.000000', 'consum', 0.0255, 'lps'),
	(641588, 136, '2015-01-01 00:28:32.000000', 'consum', 0.0326, 'lps'),
	(641589, 136, '2015-01-01 00:28:33.000000', 'consum', 0.0283, 'lps'),
	(641590, 136, '2015-01-01 00:28:34.000000', 'consum', 0.0226, 'lps'),
	(641591, 136, '2015-01-01 00:28:35.000000', 'consum', 0.0322, 'lps'),
	(641592, 136, '2015-01-01 00:28:36.000000', 'consum', 0.0224, 'lps'),
	(641593, 136, '2015-01-01 00:28:37.000000', 'consum', 0.0318, 'lps'),
	(641594, 136, '2015-01-01 00:28:38.000000', 'consum', 0.0210, 'lps'),
	(641595, 136, '2015-01-01 00:28:39.000000', 'consum', 0.0262, 'lps'),
	(641596, 136, '2015-01-01 00:28:40.000000', 'consum', 0.0221, 'lps'),
	(641597, 136, '2015-01-01 00:28:41.000000', 'consum', 0.0233, 'lps'),
	(641598, 136, '2015-01-01 00:28:42.000000', 'consum', 0.0293, 'lps'),
	(641599, 136, '2015-01-01 00:28:43.000000', 'consum', 0.0308, 'lps'),
	(641600, 136, '2015-01-01 00:28:44.000000', 'consum', 0.0326, 'lps'),
	(641601, 136, '2015-01-01 00:28:45.000000', 'consum', 0.0251, 'lps'),
	(641602, 136, '2015-01-01 00:28:46.000000', 'consum', 0.0314, 'lps'),
	(641603, 136, '2015-01-01 00:28:47.000000', 'consum', 0.0235, 'lps'),
	(641604, 136, '2015-01-01 00:28:48.000000', 'consum', 0.0271, 'lps'),
	(641605, 136, '2015-01-01 00:28:49.000000', 'consum', 0.0317, 'lps'),
	(641606, 136, '2015-01-01 00:28:50.000000', 'consum', 0.0313, 'lps'),
	(641607, 136, '2015-01-01 00:28:51.000000', 'consum', 0.0283, 'lps'),
	(641608, 136, '2015-01-01 00:28:52.000000', 'consum', 0.0265, 'lps'),
	(641609, 136, '2015-01-01 00:28:53.000000', 'consum', 0.0267, 'lps'),
	(641610, 136, '2015-01-01 00:28:54.000000', 'consum', 0.0331, 'lps'),
	(641611, 136, '2015-01-01 00:28:55.000000', 'consum', 0.0273, 'lps'),
	(641612, 136, '2015-01-01 00:28:56.000000', 'consum', 0.0287, 'lps'),
	(641613, 136, '2015-01-01 00:28:57.000000', 'consum', 0.0280, 'lps'),
	(641614, 136, '2015-01-01 00:28:58.000000', 'consum', 0.0332, 'lps'),
	(641615, 136, '2015-01-01 00:28:59.000000', 'consum', 0.0240, 'lps'),
	(641616, 136, '2015-01-01 00:29:00.000000', 'consum', 0.0239, 'lps'),
	(641617, 136, '2015-01-01 00:29:01.000000', 'consum', 0.0268, 'lps'),
	(641618, 136, '2015-01-01 00:29:02.000000', 'consum', 0.0289, 'lps'),
	(641619, 136, '2015-01-01 00:29:03.000000', 'consum', 0.0307, 'lps'),
	(641620, 136, '2015-01-01 00:29:04.000000', 'consum', 0.0211, 'lps'),
	(641621, 136, '2015-01-01 00:29:05.000000', 'consum', 0.0294, 'lps'),
	(641622, 136, '2015-01-01 00:29:06.000000', 'consum', 0.0258, 'lps'),
	(641623, 136, '2015-01-01 00:29:07.000000', 'consum', 0.0322, 'lps'),
	(641624, 136, '2015-01-01 00:29:08.000000', 'consum', 0.0254, 'lps'),
	(641625, 136, '2015-01-01 00:29:09.000000', 'consum', 0.0219, 'lps'),
	(641626, 136, '2015-01-01 00:29:10.000000', 'consum', 0.0247, 'lps'),
	(641627, 136, '2015-01-01 00:29:11.000000', 'consum', 0.0246, 'lps'),
	(641628, 136, '2015-01-01 00:29:12.000000', 'consum', 0.0278, 'lps'),
	(641629, 136, '2015-01-01 00:29:13.000000', 'consum', 0.0320, 'lps'),
	(641630, 136, '2015-01-01 00:29:14.000000', 'consum', 0.0310, 'lps'),
	(641631, 136, '2015-01-01 00:29:15.000000', 'consum', 0.0254, 'lps'),
	(641632, 136, '2015-01-01 00:29:16.000000', 'consum', 0.0254, 'lps'),
	(641633, 136, '2015-01-01 00:29:17.000000', 'consum', 0.0301, 'lps'),
	(641634, 136, '2015-01-01 00:29:18.000000', 'consum', 0.0284, 'lps'),
	(641635, 136, '2015-01-01 00:29:19.000000', 'consum', 0.0307, 'lps'),
	(641636, 136, '2015-01-01 00:29:20.000000', 'consum', 0.0224, 'lps'),
	(641637, 136, '2015-01-01 00:29:21.000000', 'consum', 0.0240, 'lps'),
	(641638, 136, '2015-01-01 00:29:22.000000', 'consum', 0.0316, 'lps'),
	(641639, 136, '2015-01-01 00:29:23.000000', 'consum', 0.0280, 'lps'),
	(641640, 136, '2015-01-01 00:29:24.000000', 'consum', 0.0241, 'lps'),
	(641641, 136, '2015-01-01 00:29:25.000000', 'consum', 0.0281, 'lps'),
	(641642, 136, '2015-01-01 00:29:26.000000', 'consum', 0.0222, 'lps'),
	(641643, 136, '2015-01-01 00:29:27.000000', 'consum', 0.0309, 'lps'),
	(641644, 136, '2015-01-01 00:29:28.000000', 'consum', 0.0296, 'lps'),
	(641645, 136, '2015-01-01 00:29:29.000000', 'consum', 0.0219, 'lps'),
	(641646, 136, '2015-01-01 00:29:30.000000', 'consum', 0.0244, 'lps'),
	(641647, 136, '2015-01-01 00:29:31.000000', 'consum', 0.0233, 'lps'),
	(641648, 136, '2015-01-01 00:29:32.000000', 'consum', 0.0221, 'lps'),
	(641649, 136, '2015-01-01 00:29:33.000000', 'consum', 0.0321, 'lps'),
	(641650, 136, '2015-01-01 00:29:34.000000', 'consum', 0.0236, 'lps'),
	(641651, 136, '2015-01-01 00:29:35.000000', 'consum', 0.0255, 'lps'),
	(641652, 136, '2015-01-01 00:29:36.000000', 'consum', 0.0233, 'lps'),
	(641653, 136, '2015-01-01 00:29:37.000000', 'consum', 0.0316, 'lps'),
	(641654, 136, '2015-01-01 00:29:38.000000', 'consum', 0.0300, 'lps'),
	(641655, 136, '2015-01-01 00:29:39.000000', 'consum', 0.0218, 'lps'),
	(641656, 136, '2015-01-01 00:29:40.000000', 'consum', 0.0229, 'lps'),
	(641657, 136, '2015-01-01 00:29:41.000000', 'consum', 0.0282, 'lps'),
	(641658, 136, '2015-01-01 00:29:42.000000', 'consum', 0.0263, 'lps'),
	(641659, 136, '2015-01-01 00:29:43.000000', 'consum', 0.0263, 'lps'),
	(641660, 136, '2015-01-01 00:29:44.000000', 'consum', 0.0314, 'lps'),
	(641661, 136, '2015-01-01 00:29:45.000000', 'consum', 0.0325, 'lps'),
	(641662, 136, '2015-01-01 00:29:46.000000', 'consum', 0.0225, 'lps'),
	(641663, 136, '2015-01-01 00:29:47.000000', 'consum', 0.0314, 'lps'),
	(641664, 136, '2015-01-01 00:29:48.000000', 'consum', 0.0313, 'lps'),
	(641665, 136, '2015-01-01 00:29:49.000000', 'consum', 0.0289, 'lps'),
	(641666, 136, '2015-01-01 00:29:50.000000', 'consum', 0.0295, 'lps'),
	(641667, 136, '2015-01-01 00:29:51.000000', 'consum', 0.0276, 'lps'),
	(641668, 136, '2015-01-01 00:29:52.000000', 'consum', 0.0283, 'lps'),
	(641669, 136, '2015-01-01 00:29:53.000000', 'consum', 0.0257, 'lps'),
	(641670, 136, '2015-01-01 00:29:54.000000', 'consum', 0.0226, 'lps'),
	(641671, 136, '2015-01-01 00:29:55.000000', 'consum', 0.0272, 'lps'),
	(641672, 136, '2015-01-01 00:29:56.000000', 'consum', 0.0225, 'lps'),
	(641673, 136, '2015-01-01 00:29:57.000000', 'consum', 0.0225, 'lps'),
	(641674, 136, '2015-01-01 00:29:58.000000', 'consum', 0.0239, 'lps'),
	(641675, 136, '2015-01-01 00:29:59.000000', 'consum', 0.0310, 'lps'),
	(641676, 136, '2015-01-01 00:30:00.000000', 'consum', 0.0253, 'lps'),
	(641677, 136, '2015-01-01 00:30:01.000000', 'consum', 0.0247, 'lps'),
	(641678, 136, '2015-01-01 00:30:02.000000', 'consum', 0.0267, 'lps'),
	(641679, 136, '2015-01-01 00:30:03.000000', 'consum', 0.0263, 'lps'),
	(641680, 136, '2015-01-01 00:30:04.000000', 'consum', 0.0304, 'lps'),
	(641681, 136, '2015-01-01 00:30:05.000000', 'consum', 0.0273, 'lps'),
	(641682, 136, '2015-01-01 00:30:06.000000', 'consum', 0.0244, 'lps'),
	(641683, 136, '2015-01-01 00:30:07.000000', 'consum', 0.0315, 'lps'),
	(641684, 136, '2015-01-01 00:30:08.000000', 'consum', 0.0261, 'lps'),
	(641685, 136, '2015-01-01 00:30:09.000000', 'consum', 0.0275, 'lps'),
	(641686, 136, '2015-01-01 00:30:10.000000', 'consum', 0.0256, 'lps'),
	(641687, 136, '2015-01-01 00:30:11.000000', 'consum', 0.0249, 'lps'),
	(641688, 136, '2015-01-01 00:30:12.000000', 'consum', 0.0265, 'lps'),
	(641689, 136, '2015-01-01 00:30:13.000000', 'consum', 0.0245, 'lps'),
	(641690, 136, '2015-01-01 00:30:14.000000', 'consum', 0.0221, 'lps'),
	(641691, 136, '2015-01-01 00:30:15.000000', 'consum', 0.0285, 'lps'),
	(641692, 136, '2015-01-01 00:30:16.000000', 'consum', 0.0304, 'lps'),
	(641693, 136, '2015-01-01 00:30:17.000000', 'consum', 0.0331, 'lps'),
	(641694, 136, '2015-01-01 00:30:18.000000', 'consum', 0.0286, 'lps'),
	(641695, 136, '2015-01-01 00:30:19.000000', 'consum', 0.0227, 'lps'),
	(641696, 136, '2015-01-01 00:30:20.000000', 'consum', 0.0316, 'lps'),
	(641697, 136, '2015-01-01 00:30:21.000000', 'consum', 0.0317, 'lps'),
	(641698, 136, '2015-01-01 00:30:22.000000', 'consum', 0.0305, 'lps'),
	(641699, 136, '2015-01-01 00:30:23.000000', 'consum', 0.0240, 'lps'),
	(641700, 136, '2015-01-01 00:30:24.000000', 'consum', 0.0323, 'lps'),
	(641701, 136, '2015-01-01 00:30:25.000000', 'consum', 0.0316, 'lps'),
	(641702, 136, '2015-01-01 00:30:26.000000', 'consum', 0.0274, 'lps'),
	(641703, 136, '2015-01-01 00:30:27.000000', 'consum', 0.0213, 'lps'),
	(641704, 136, '2015-01-01 00:30:28.000000', 'consum', 0.0281, 'lps'),
	(641705, 136, '2015-01-01 00:30:29.000000', 'consum', 0.0309, 'lps'),
	(641706, 136, '2015-01-01 00:30:30.000000', 'consum', 0.0243, 'lps'),
	(641707, 136, '2015-01-01 00:30:31.000000', 'consum', 0.0328, 'lps'),
	(641708, 136, '2015-01-01 00:30:32.000000', 'consum', 0.0331, 'lps'),
	(641709, 136, '2015-01-01 00:30:33.000000', 'consum', 0.0214, 'lps'),
	(641710, 136, '2015-01-01 00:30:34.000000', 'consum', 0.0238, 'lps'),
	(641711, 136, '2015-01-01 00:30:35.000000', 'consum', 0.0213, 'lps'),
	(641712, 136, '2015-01-01 00:30:36.000000', 'consum', 0.0267, 'lps'),
	(641713, 136, '2015-01-01 00:30:37.000000', 'consum', 0.0239, 'lps'),
	(641714, 136, '2015-01-01 00:30:38.000000', 'consum', 0.0310, 'lps'),
	(641715, 136, '2015-01-01 00:30:39.000000', 'consum', 0.0251, 'lps'),
	(641716, 136, '2015-01-01 00:30:40.000000', 'consum', 0.0237, 'lps'),
	(641717, 136, '2015-01-01 00:30:41.000000', 'consum', 0.0225, 'lps'),
	(641718, 136, '2015-01-01 00:30:42.000000', 'consum', 0.0327, 'lps'),
	(641719, 136, '2015-01-01 00:30:43.000000', 'consum', 0.0253, 'lps'),
	(641720, 136, '2015-01-01 00:30:44.000000', 'consum', 0.0324, 'lps'),
	(641721, 136, '2015-01-01 00:30:45.000000', 'consum', 0.0279, 'lps'),
	(641722, 136, '2015-01-01 00:30:46.000000', 'consum', 0.0216, 'lps'),
	(641723, 136, '2015-01-01 00:30:47.000000', 'consum', 0.0279, 'lps'),
	(641724, 136, '2015-01-01 00:30:48.000000', 'consum', 0.0292, 'lps'),
	(641725, 136, '2015-01-01 00:30:49.000000', 'consum', 0.0289, 'lps'),
	(641726, 136, '2015-01-01 00:30:50.000000', 'consum', 0.0235, 'lps'),
	(641727, 136, '2015-01-01 00:30:51.000000', 'consum', 0.0224, 'lps'),
	(641728, 136, '2015-01-01 00:30:52.000000', 'consum', 0.0330, 'lps'),
	(641729, 136, '2015-01-01 00:30:53.000000', 'consum', 0.0270, 'lps'),
	(641730, 136, '2015-01-01 00:30:54.000000', 'consum', 0.0275, 'lps'),
	(641731, 136, '2015-01-01 00:30:55.000000', 'consum', 0.0234, 'lps'),
	(641732, 136, '2015-01-01 00:30:56.000000', 'consum', 0.0257, 'lps'),
	(641733, 136, '2015-01-01 00:30:57.000000', 'consum', 0.0250, 'lps'),
	(641734, 136, '2015-01-01 00:30:58.000000', 'consum', 0.0270, 'lps'),
	(641735, 136, '2015-01-01 00:30:59.000000', 'consum', 0.0268, 'lps'),
	(641736, 136, '2015-01-01 00:31:00.000000', 'consum', 0.0320, 'lps'),
	(641737, 136, '2015-01-01 00:31:01.000000', 'consum', 0.0214, 'lps'),
	(641738, 136, '2015-01-01 00:31:02.000000', 'consum', 0.0272, 'lps'),
	(641739, 136, '2015-01-01 00:31:03.000000', 'consum', 0.0261, 'lps'),
	(641740, 136, '2015-01-01 00:31:04.000000', 'consum', 0.0279, 'lps'),
	(641741, 136, '2015-01-01 00:31:05.000000', 'consum', 0.0277, 'lps'),
	(641742, 136, '2015-01-01 00:31:06.000000', 'consum', 0.0216, 'lps'),
	(641743, 136, '2015-01-01 00:31:07.000000', 'consum', 0.0287, 'lps'),
	(641744, 136, '2015-01-01 00:31:08.000000', 'consum', 0.0332, 'lps'),
	(641745, 136, '2015-01-01 00:31:09.000000', 'consum', 0.0215, 'lps'),
	(641746, 136, '2015-01-01 00:31:10.000000', 'consum', 0.0241, 'lps'),
	(641747, 136, '2015-01-01 00:31:11.000000', 'consum', 0.0225, 'lps'),
	(641748, 136, '2015-01-01 00:31:12.000000', 'consum', 0.0319, 'lps'),
	(641749, 136, '2015-01-01 00:31:13.000000', 'consum', 0.0214, 'lps'),
	(641750, 136, '2015-01-01 00:31:14.000000', 'consum', 0.0274, 'lps'),
	(641751, 136, '2015-01-01 00:31:15.000000', 'consum', 0.0272, 'lps'),
	(641752, 136, '2015-01-01 00:31:16.000000', 'consum', 0.0328, 'lps'),
	(641753, 136, '2015-01-01 00:31:17.000000', 'consum', 0.0243, 'lps'),
	(641754, 136, '2015-01-01 00:31:18.000000', 'consum', 0.0269, 'lps'),
	(641755, 136, '2015-01-01 00:31:19.000000', 'consum', 0.0284, 'lps'),
	(641756, 136, '2015-01-01 00:31:20.000000', 'consum', 0.0278, 'lps'),
	(641757, 136, '2015-01-01 00:31:21.000000', 'consum', 0.0329, 'lps'),
	(641758, 136, '2015-01-01 00:31:22.000000', 'consum', 0.0230, 'lps'),
	(641759, 136, '2015-01-01 00:31:23.000000', 'consum', 0.0324, 'lps'),
	(641760, 136, '2015-01-01 00:31:24.000000', 'consum', 0.0226, 'lps'),
	(641761, 136, '2015-01-01 00:31:25.000000', 'consum', 0.0322, 'lps'),
	(641762, 136, '2015-01-01 00:31:26.000000', 'consum', 0.0224, 'lps'),
	(641763, 136, '2015-01-01 00:31:27.000000', 'consum', 0.0318, 'lps'),
	(641764, 136, '2015-01-01 00:31:28.000000', 'consum', 0.0210, 'lps'),
	(641765, 136, '2015-01-01 00:31:29.000000', 'consum', 0.0259, 'lps'),
	(641766, 136, '2015-01-01 00:31:30.000000', 'consum', 0.0333, 'lps'),
	(641767, 136, '2015-01-01 00:31:31.000000', 'consum', 0.0306, 'lps'),
	(641768, 136, '2015-01-01 00:31:32.000000', 'consum', 0.0320, 'lps'),
	(641769, 136, '2015-01-01 00:31:33.000000', 'consum', 0.0224, 'lps'),
	(641770, 136, '2015-01-01 00:31:34.000000', 'consum', 0.0325, 'lps'),
	(641771, 136, '2015-01-01 00:31:35.000000', 'consum', 0.0249, 'lps'),
	(641772, 136, '2015-01-01 00:31:36.000000', 'consum', 0.0305, 'lps'),
	(641773, 136, '2015-01-01 00:31:37.000000', 'consum', 0.0322, 'lps'),
	(641774, 136, '2015-01-01 00:31:38.000000', 'consum', 0.0237, 'lps'),
	(641775, 136, '2015-01-01 00:31:39.000000', 'consum', 0.0257, 'lps'),
	(641776, 136, '2015-01-01 00:31:40.000000', 'consum', 0.0239, 'lps'),
	(641777, 136, '2015-01-01 00:31:41.000000', 'consum', 0.0216, 'lps'),
	(641778, 136, '2015-01-01 00:31:42.000000', 'consum', 0.0279, 'lps'),
	(641779, 136, '2015-01-01 00:31:43.000000', 'consum', 0.0287, 'lps'),
	(641780, 136, '2015-01-01 00:31:44.000000', 'consum', 0.0265, 'lps'),
	(641781, 136, '2015-01-01 00:31:45.000000', 'consum', 0.0256, 'lps'),
	(641782, 136, '2015-01-01 00:31:46.000000', 'consum', 0.0275, 'lps'),
	(641783, 136, '2015-01-01 00:31:47.000000', 'consum', 0.0274, 'lps'),
	(641784, 136, '2015-01-01 00:31:48.000000', 'consum', 0.0213, 'lps'),
	(641785, 136, '2015-01-01 00:31:49.000000', 'consum', 0.0278, 'lps'),
	(641786, 136, '2015-01-01 00:31:50.000000', 'consum', 0.0296, 'lps'),
	(641787, 136, '2015-01-01 00:31:51.000000', 'consum', 0.0313, 'lps'),
	(641788, 136, '2015-01-01 00:31:52.000000', 'consum', 0.0219, 'lps'),
	(641789, 136, '2015-01-01 00:31:53.000000', 'consum', 0.0318, 'lps'),
	(641790, 136, '2015-01-01 00:31:54.000000', 'consum', 0.0230, 'lps'),
	(641791, 136, '2015-01-01 00:31:55.000000', 'consum', 0.0232, 'lps'),
	(641792, 136, '2015-01-01 00:31:56.000000', 'consum', 0.0260, 'lps'),
	(641793, 136, '2015-01-01 00:31:57.000000', 'consum', 0.0270, 'lps'),
	(641794, 136, '2015-01-01 00:31:58.000000', 'consum', 0.0238, 'lps'),
	(641795, 136, '2015-01-01 00:31:59.000000', 'consum', 0.0296, 'lps'),
	(641796, 136, '2015-01-01 00:32:00.000000', 'consum', 0.0308, 'lps'),
	(641797, 136, '2015-01-01 00:32:01.000000', 'consum', 0.0316, 'lps'),
	(641798, 136, '2015-01-01 00:32:02.000000', 'consum', 0.0325, 'lps'),
	(641799, 136, '2015-01-01 00:32:03.000000', 'consum', 0.0217, 'lps'),
	(641800, 136, '2015-01-01 00:32:04.000000', 'consum', 0.0275, 'lps'),
	(641801, 136, '2015-01-01 00:32:05.000000', 'consum', 0.0266, 'lps'),
	(641802, 136, '2015-01-01 00:32:06.000000', 'consum', 0.0294, 'lps'),
	(641803, 136, '2015-01-01 00:32:07.000000', 'consum', 0.0214, 'lps'),
	(641804, 136, '2015-01-01 00:32:08.000000', 'consum', 0.0228, 'lps'),
	(641805, 136, '2015-01-01 00:32:09.000000', 'consum', 0.0287, 'lps'),
	(641806, 136, '2015-01-01 00:32:10.000000', 'consum', 0.0294, 'lps'),
	(641807, 136, '2015-01-01 00:32:11.000000', 'consum', 0.0277, 'lps'),
	(641808, 136, '2015-01-01 00:32:12.000000', 'consum', 0.0292, 'lps'),
	(641809, 136, '2015-01-01 00:32:13.000000', 'consum', 0.0295, 'lps'),
	(641810, 136, '2015-01-01 00:32:14.000000', 'consum', 0.0265, 'lps'),
	(641811, 136, '2015-01-01 00:32:15.000000', 'consum', 0.0232, 'lps'),
	(641812, 136, '2015-01-01 00:32:16.000000', 'consum', 0.0278, 'lps'),
	(641813, 136, '2015-01-01 00:32:17.000000', 'consum', 0.0236, 'lps'),
	(641814, 136, '2015-01-01 00:32:18.000000', 'consum', 0.0262, 'lps'),
	(641815, 136, '2015-01-01 00:32:19.000000', 'consum', 0.0267, 'lps'),
	(641816, 136, '2015-01-01 00:32:20.000000', 'consum', 0.0215, 'lps'),
	(641817, 136, '2015-01-01 00:32:21.000000', 'consum', 0.0315, 'lps'),
	(641818, 136, '2015-01-01 00:32:22.000000', 'consum', 0.0225, 'lps'),
	(641819, 136, '2015-01-01 00:32:23.000000', 'consum', 0.0218, 'lps'),
	(641820, 136, '2015-01-01 00:32:24.000000', 'consum', 0.0327, 'lps'),
	(641821, 136, '2015-01-01 00:32:25.000000', 'consum', 0.0278, 'lps'),
	(641822, 136, '2015-01-01 00:32:26.000000', 'consum', 0.0323, 'lps'),
	(641823, 136, '2015-01-01 00:32:27.000000', 'consum', 0.0323, 'lps'),
	(641824, 136, '2015-01-01 00:32:28.000000', 'consum', 0.0313, 'lps'),
	(641825, 136, '2015-01-01 00:32:29.000000', 'consum', 0.0263, 'lps'),
	(641826, 136, '2015-01-01 00:32:30.000000', 'consum', 0.0292, 'lps'),
	(641827, 136, '2015-01-01 00:32:31.000000', 'consum', 0.0210, 'lps'),
	(641828, 136, '2015-01-01 00:32:32.000000', 'consum', 0.0216, 'lps'),
	(641829, 136, '2015-01-01 00:32:33.000000', 'consum', 0.0238, 'lps'),
	(641830, 136, '2015-01-01 00:32:34.000000', 'consum', 0.0333, 'lps'),
	(641831, 136, '2015-01-01 00:32:35.000000', 'consum', 0.0247, 'lps'),
	(641832, 136, '2015-01-01 00:32:36.000000', 'consum', 0.0275, 'lps'),
	(641833, 136, '2015-01-01 00:32:37.000000', 'consum', 0.0300, 'lps'),
	(641834, 136, '2015-01-01 00:32:38.000000', 'consum', 0.0215, 'lps'),
	(641835, 136, '2015-01-01 00:32:39.000000', 'consum', 0.0216, 'lps'),
	(641836, 136, '2015-01-01 00:32:40.000000', 'consum', 0.0224, 'lps'),
	(641837, 136, '2015-01-01 00:32:41.000000', 'consum', 0.0262, 'lps'),
	(641838, 136, '2015-01-01 00:32:42.000000', 'consum', 0.0306, 'lps'),
	(641839, 136, '2015-01-01 00:32:43.000000', 'consum', 0.0287, 'lps'),
	(641840, 136, '2015-01-01 00:32:44.000000', 'consum', 0.0306, 'lps'),
	(641841, 136, '2015-01-01 00:32:45.000000', 'consum', 0.0212, 'lps'),
	(641842, 136, '2015-01-01 00:32:46.000000', 'consum', 0.0303, 'lps'),
	(641843, 136, '2015-01-01 00:32:47.000000', 'consum', 0.0300, 'lps'),
	(641844, 136, '2015-01-01 00:32:48.000000', 'consum', 0.0258, 'lps'),
	(641845, 136, '2015-01-01 00:32:49.000000', 'consum', 0.0303, 'lps'),
	(641846, 136, '2015-01-01 00:32:50.000000', 'consum', 0.0285, 'lps'),
	(641847, 136, '2015-01-01 00:32:51.000000', 'consum', 0.0304, 'lps'),
	(641848, 136, '2015-01-01 00:32:52.000000', 'consum', 0.0333, 'lps'),
	(641849, 136, '2015-01-01 00:32:53.000000', 'consum', 0.0294, 'lps'),
	(641850, 136, '2015-01-01 00:32:54.000000', 'consum', 0.0261, 'lps'),
	(641851, 136, '2015-01-01 00:32:55.000000', 'consum', 0.0216, 'lps'),
	(641852, 136, '2015-01-01 00:32:56.000000', 'consum', 0.0212, 'lps'),
	(641853, 136, '2015-01-01 00:32:57.000000', 'consum', 0.0324, 'lps'),
	(641854, 136, '2015-01-01 00:32:58.000000', 'consum', 0.0279, 'lps'),
	(641855, 136, '2015-01-01 00:32:59.000000', 'consum', 0.0215, 'lps'),
	(641856, 136, '2015-01-01 00:33:00.000000', 'consum', 0.0277, 'lps'),
	(641857, 136, '2015-01-01 00:33:01.000000', 'consum', 0.0281, 'lps'),
	(641858, 136, '2015-01-01 00:33:02.000000', 'consum', 0.0240, 'lps'),
	(641859, 136, '2015-01-01 00:33:03.000000', 'consum', 0.0270, 'lps'),
	(641860, 136, '2015-01-01 00:33:04.000000', 'consum', 0.0300, 'lps'),
	(641861, 136, '2015-01-01 00:33:05.000000', 'consum', 0.0229, 'lps'),
	(641862, 136, '2015-01-01 00:33:06.000000', 'consum', 0.0285, 'lps'),
	(641863, 136, '2015-01-01 00:33:07.000000', 'consum', 0.0280, 'lps'),
	(641864, 136, '2015-01-01 00:33:08.000000', 'consum', 0.0211, 'lps'),
	(641865, 136, '2015-01-01 00:33:09.000000', 'consum', 0.0254, 'lps'),
	(641866, 136, '2015-01-01 00:33:10.000000', 'consum', 0.0304, 'lps'),
	(641867, 136, '2015-01-01 00:33:11.000000', 'consum', 0.0302, 'lps'),
	(641868, 136, '2015-01-01 00:33:12.000000', 'consum', 0.0261, 'lps'),
	(641869, 136, '2015-01-01 00:33:13.000000', 'consum', 0.0316, 'lps'),
	(641870, 136, '2015-01-01 00:33:14.000000', 'consum', 0.0213, 'lps'),
	(641871, 136, '2015-01-01 00:33:15.000000', 'consum', 0.0282, 'lps'),
	(641872, 136, '2015-01-01 00:33:16.000000', 'consum', 0.0312, 'lps'),
	(641873, 136, '2015-01-01 00:33:17.000000', 'consum', 0.0258, 'lps'),
	(641874, 136, '2015-01-01 00:33:18.000000', 'consum', 0.0268, 'lps'),
	(641875, 136, '2015-01-01 00:33:19.000000', 'consum', 0.0234, 'lps'),
	(641876, 136, '2015-01-01 00:33:20.000000', 'consum', 0.0279, 'lps'),
	(641877, 136, '2015-01-01 00:33:21.000000', 'consum', 0.0236, 'lps'),
	(641878, 136, '2015-01-01 00:33:22.000000', 'consum', 0.0258, 'lps'),
	(641879, 136, '2015-01-01 00:33:23.000000', 'consum', 0.0249, 'lps'),
	(641880, 136, '2015-01-01 00:33:24.000000', 'consum', 0.0262, 'lps'),
	(641881, 136, '2015-01-01 00:33:25.000000', 'consum', 0.0230, 'lps'),
	(641882, 136, '2015-01-01 00:33:26.000000', 'consum', 0.0276, 'lps'),
	(641883, 136, '2015-01-01 00:33:27.000000', 'consum', 0.0235, 'lps'),
	(641884, 136, '2015-01-01 00:33:28.000000', 'consum', 0.0260, 'lps'),
	(641885, 136, '2015-01-01 00:33:29.000000', 'consum', 0.0260, 'lps'),
	(641886, 136, '2015-01-01 00:33:30.000000', 'consum', 0.0312, 'lps'),
	(641887, 136, '2015-01-01 00:33:31.000000', 'consum', 0.0322, 'lps'),
	(641888, 136, '2015-01-01 00:33:32.000000', 'consum', 0.0217, 'lps'),
	(641889, 136, '2015-01-01 00:33:33.000000', 'consum', 0.0282, 'lps'),
	(641890, 136, '2015-01-01 00:33:34.000000', 'consum', 0.0302, 'lps'),
	(641891, 136, '2015-01-01 00:33:35.000000', 'consum', 0.0331, 'lps'),
	(641892, 136, '2015-01-01 00:33:36.000000', 'consum', 0.0290, 'lps'),
	(641893, 136, '2015-01-01 00:33:37.000000', 'consum', 0.0246, 'lps'),
	(641894, 136, '2015-01-01 00:33:38.000000', 'consum', 0.0276, 'lps'),
	(641895, 136, '2015-01-01 00:33:39.000000', 'consum', 0.0309, 'lps'),
	(641896, 136, '2015-01-01 00:33:40.000000', 'consum', 0.0260, 'lps'),
	(641897, 136, '2015-01-01 00:33:41.000000', 'consum', 0.0289, 'lps'),
	(641898, 136, '2015-01-01 00:33:42.000000', 'consum', 0.0329, 'lps'),
	(641899, 136, '2015-01-01 00:33:43.000000', 'consum', 0.0319, 'lps'),
	(641900, 136, '2015-01-01 00:33:44.000000', 'consum', 0.0277, 'lps'),
	(641901, 136, '2015-01-01 00:33:45.000000', 'consum', 0.0218, 'lps'),
	(641902, 136, '2015-01-01 00:33:46.000000', 'consum', 0.0296, 'lps'),
	(641903, 136, '2015-01-01 00:33:47.000000', 'consum', 0.0245, 'lps'),
	(641904, 136, '2015-01-01 00:33:48.000000', 'consum', 0.0250, 'lps'),
	(641905, 136, '2015-01-01 00:33:49.000000', 'consum', 0.0309, 'lps'),
	(641906, 136, '2015-01-01 00:33:50.000000', 'consum', 0.0211, 'lps'),
	(641907, 136, '2015-01-01 00:33:51.000000', 'consum', 0.0291, 'lps'),
	(641908, 136, '2015-01-01 00:33:52.000000', 'consum', 0.0240, 'lps'),
	(641909, 136, '2015-01-01 00:33:53.000000', 'consum', 0.0242, 'lps'),
	(641910, 136, '2015-01-01 00:33:54.000000', 'consum', 0.0281, 'lps'),
	(641911, 136, '2015-01-01 00:33:55.000000', 'consum', 0.0220, 'lps'),
	(641912, 136, '2015-01-01 00:33:56.000000', 'consum', 0.0297, 'lps'),
	(641913, 136, '2015-01-01 00:33:57.000000', 'consum', 0.0243, 'lps'),
	(641914, 136, '2015-01-01 00:33:58.000000', 'consum', 0.0239, 'lps'),
	(641915, 136, '2015-01-01 00:33:59.000000', 'consum', 0.0258, 'lps'),
	(641916, 136, '2015-01-01 00:34:00.000000', 'consum', 0.0238, 'lps'),
	(641917, 136, '2015-01-01 00:34:01.000000', 'consum', 0.0331, 'lps'),
	(641918, 136, '2015-01-01 00:34:02.000000', 'consum', 0.0235, 'lps'),
	(641919, 136, '2015-01-01 00:34:03.000000', 'consum', 0.0221, 'lps'),
	(641920, 136, '2015-01-01 00:34:04.000000', 'consum', 0.0314, 'lps'),
	(641921, 136, '2015-01-01 00:34:05.000000', 'consum', 0.0325, 'lps'),
	(641922, 136, '2015-01-01 00:34:06.000000', 'consum', 0.0224, 'lps'),
	(641923, 136, '2015-01-01 00:34:07.000000', 'consum', 0.0310, 'lps'),
	(641924, 136, '2015-01-01 00:34:08.000000', 'consum', 0.0294, 'lps'),
	(641925, 136, '2015-01-01 00:34:09.000000', 'consum', 0.0331, 'lps'),
	(641926, 136, '2015-01-01 00:34:10.000000', 'consum', 0.0317, 'lps'),
	(641927, 136, '2015-01-01 00:34:11.000000', 'consum', 0.0257, 'lps'),
	(641928, 136, '2015-01-01 00:34:12.000000', 'consum', 0.0250, 'lps'),
	(641929, 136, '2015-01-01 00:34:13.000000', 'consum', 0.0268, 'lps'),
	(641930, 136, '2015-01-01 00:34:14.000000', 'consum', 0.0256, 'lps'),
	(641931, 136, '2015-01-01 00:34:15.000000', 'consum', 0.0265, 'lps'),
	(641932, 136, '2015-01-01 00:34:16.000000', 'consum', 0.0226, 'lps'),
	(641933, 136, '2015-01-01 00:34:17.000000', 'consum', 0.0251, 'lps'),
	(641934, 136, '2015-01-01 00:34:18.000000', 'consum', 0.0241, 'lps'),
	(641935, 136, '2015-01-01 00:34:19.000000', 'consum', 0.0243, 'lps'),
	(641936, 136, '2015-01-01 00:34:20.000000', 'consum', 0.0284, 'lps'),
	(641937, 136, '2015-01-01 00:34:21.000000', 'consum', 0.0234, 'lps'),
	(641938, 136, '2015-01-01 00:34:22.000000', 'consum', 0.0230, 'lps'),
	(641939, 136, '2015-01-01 00:34:23.000000', 'consum', 0.0241, 'lps'),
	(641940, 136, '2015-01-01 00:34:24.000000', 'consum', 0.0303, 'lps'),
	(641941, 136, '2015-01-01 00:34:25.000000', 'consum', 0.0210, 'lps'),
	(641942, 136, '2015-01-01 00:34:26.000000', 'consum', 0.0306, 'lps'),
	(641943, 136, '2015-01-01 00:34:27.000000', 'consum', 0.0318, 'lps'),
	(641944, 136, '2015-01-01 00:34:28.000000', 'consum', 0.0214, 'lps'),
	(641945, 136, '2015-01-01 00:34:29.000000', 'consum', 0.0279, 'lps'),
	(641946, 136, '2015-01-01 00:34:30.000000', 'consum', 0.0296, 'lps'),
	(641947, 136, '2015-01-01 00:34:31.000000', 'consum', 0.0307, 'lps'),
	(641948, 136, '2015-01-01 00:34:32.000000', 'consum', 0.0315, 'lps'),
	(641949, 136, '2015-01-01 00:34:33.000000', 'consum', 0.0319, 'lps'),
	(641950, 136, '2015-01-01 00:34:34.000000', 'consum', 0.0318, 'lps'),
	(641951, 136, '2015-01-01 00:34:35.000000', 'consum', 0.0298, 'lps'),
	(641952, 136, '2015-01-01 00:34:36.000000', 'consum', 0.0328, 'lps'),
	(641953, 136, '2015-01-01 00:34:37.000000', 'consum', 0.0287, 'lps'),
	(641954, 136, '2015-01-01 00:34:38.000000', 'consum', 0.0242, 'lps'),
	(641955, 136, '2015-01-01 00:34:39.000000', 'consum', 0.0265, 'lps'),
	(641956, 136, '2015-01-01 00:34:40.000000', 'consum', 0.0263, 'lps'),
	(641957, 136, '2015-01-01 00:34:41.000000', 'consum', 0.0310, 'lps'),
	(641958, 136, '2015-01-01 00:34:42.000000', 'consum', 0.0305, 'lps'),
	(641959, 136, '2015-01-01 00:34:43.000000', 'consum', 0.0262, 'lps'),
	(641960, 136, '2015-01-01 00:34:44.000000', 'consum', 0.0310, 'lps'),
	(641961, 136, '2015-01-01 00:34:45.000000', 'consum', 0.0308, 'lps'),
	(641962, 136, '2015-01-01 00:34:46.000000', 'consum', 0.0274, 'lps'),
	(641963, 136, '2015-01-01 00:34:47.000000', 'consum', 0.0239, 'lps'),
	(641964, 136, '2015-01-01 00:34:48.000000', 'consum', 0.0286, 'lps'),
	(641965, 136, '2015-01-01 00:34:49.000000', 'consum', 0.0254, 'lps'),
	(641966, 136, '2015-01-01 00:34:50.000000', 'consum', 0.0329, 'lps'),
	(641967, 136, '2015-01-01 00:34:51.000000', 'consum', 0.0301, 'lps'),
	(641968, 136, '2015-01-01 00:34:52.000000', 'consum', 0.0307, 'lps'),
	(641969, 136, '2015-01-01 00:34:53.000000', 'consum', 0.0301, 'lps'),
	(641970, 136, '2015-01-01 00:34:54.000000', 'consum', 0.0251, 'lps'),
	(641971, 136, '2015-01-01 00:34:55.000000', 'consum', 0.0267, 'lps'),
	(641972, 136, '2015-01-01 00:34:56.000000', 'consum', 0.0248, 'lps'),
	(641973, 136, '2015-01-01 00:34:57.000000', 'consum', 0.0228, 'lps'),
	(641974, 136, '2015-01-01 00:34:58.000000', 'consum', 0.0311, 'lps'),
	(641975, 136, '2015-01-01 00:34:59.000000', 'consum', 0.0290, 'lps'),
	(641976, 136, '2015-01-01 00:35:00.000000', 'consum', 0.0309, 'lps'),
	(641977, 136, '2015-01-01 00:35:01.000000', 'consum', 0.0215, 'lps'),
	(641978, 136, '2015-01-01 00:35:02.000000', 'consum', 0.0312, 'lps'),
	(641979, 136, '2015-01-01 00:35:03.000000', 'consum', 0.0210, 'lps'),
	(641980, 136, '2015-01-01 00:35:04.000000', 'consum', 0.0274, 'lps'),
	(641981, 136, '2015-01-01 00:35:05.000000', 'consum', 0.0285, 'lps'),
	(641982, 136, '2015-01-01 00:35:06.000000', 'consum', 0.0270, 'lps'),
	(641983, 136, '2015-01-01 00:35:07.000000', 'consum', 0.0285, 'lps'),
	(641984, 136, '2015-01-01 00:35:08.000000', 'consum', 0.0283, 'lps'),
	(641985, 136, '2015-01-01 00:35:09.000000', 'consum', 0.0226, 'lps'),
	(641986, 136, '2015-01-01 00:35:10.000000', 'consum', 0.0321, 'lps'),
	(641987, 136, '2015-01-01 00:35:11.000000', 'consum', 0.0219, 'lps'),
	(641988, 136, '2015-01-01 00:35:12.000000', 'consum', 0.0294, 'lps'),
	(641989, 136, '2015-01-01 00:35:13.000000', 'consum', 0.0231, 'lps'),
	(641990, 136, '2015-01-01 00:35:14.000000', 'consum', 0.0311, 'lps'),
	(641991, 136, '2015-01-01 00:35:15.000000', 'consum', 0.0281, 'lps'),
	(641992, 136, '2015-01-01 00:35:16.000000', 'consum', 0.0264, 'lps'),
	(641993, 136, '2015-01-01 00:35:17.000000', 'consum', 0.0268, 'lps'),
	(641994, 136, '2015-01-01 00:35:18.000000', 'consum', 0.0213, 'lps'),
	(641995, 136, '2015-01-01 00:35:19.000000', 'consum', 0.0301, 'lps'),
	(641996, 136, '2015-01-01 00:35:20.000000', 'consum', 0.0283, 'lps'),
	(641997, 136, '2015-01-01 00:35:21.000000', 'consum', 0.0302, 'lps'),
	(641998, 136, '2015-01-01 00:35:22.000000', 'consum', 0.0329, 'lps'),
	(641999, 136, '2015-01-01 00:35:23.000000', 'consum', 0.0280, 'lps'),
	(642000, 136, '2015-01-01 00:35:24.000000', 'consum', 0.0329, 'lps'),
	(642001, 136, '2015-01-01 00:35:25.000000', 'consum', 0.0223, 'lps'),
	(642002, 136, '2015-01-01 00:35:26.000000', 'consum', 0.0291, 'lps'),
	(642003, 136, '2015-01-01 00:35:27.000000', 'consum', 0.0327, 'lps'),
	(642004, 136, '2015-01-01 00:35:28.000000', 'consum', 0.0304, 'lps'),
	(642005, 136, '2015-01-01 00:35:29.000000', 'consum', 0.0331, 'lps'),
	(642006, 136, '2015-01-01 00:35:30.000000', 'consum', 0.0285, 'lps'),
	(642007, 136, '2015-01-01 00:35:31.000000', 'consum', 0.0221, 'lps'),
	(642008, 136, '2015-01-01 00:35:32.000000', 'consum', 0.0288, 'lps'),
	(642009, 136, '2015-01-01 00:35:33.000000', 'consum', 0.0322, 'lps'),
	(642010, 136, '2015-01-01 00:35:34.000000', 'consum', 0.0290, 'lps'),
	(642011, 136, '2015-01-01 00:35:35.000000', 'consum', 0.0271, 'lps'),
	(642012, 136, '2015-01-01 00:35:36.000000', 'consum', 0.0277, 'lps'),
	(642013, 136, '2015-01-01 00:35:37.000000', 'consum', 0.0240, 'lps'),
	(642014, 136, '2015-01-01 00:35:38.000000', 'consum', 0.0282, 'lps'),
	(642015, 136, '2015-01-01 00:35:39.000000', 'consum', 0.0231, 'lps'),
	(642016, 136, '2015-01-01 00:35:40.000000', 'consum', 0.0226, 'lps'),
	(642017, 136, '2015-01-01 00:35:41.000000', 'consum', 0.0226, 'lps'),
	(642018, 136, '2015-01-01 00:35:42.000000', 'consum', 0.0241, 'lps'),
	(642019, 136, '2015-01-01 00:35:43.000000', 'consum', 0.0319, 'lps'),
	(642020, 136, '2015-01-01 00:35:44.000000', 'consum', 0.0292, 'lps'),
	(642021, 136, '2015-01-01 00:35:45.000000', 'consum', 0.0292, 'lps'),
	(642022, 136, '2015-01-01 00:35:46.000000', 'consum', 0.0252, 'lps'),
	(642023, 136, '2015-01-01 00:35:47.000000', 'consum', 0.0298, 'lps'),
	(642024, 136, '2015-01-01 00:35:48.000000', 'consum', 0.0275, 'lps'),
	(642025, 136, '2015-01-01 00:35:49.000000', 'consum', 0.0272, 'lps'),
	(642026, 136, '2015-01-01 00:35:50.000000', 'consum', 0.0328, 'lps'),
	(642027, 136, '2015-01-01 00:35:51.000000', 'consum', 0.0239, 'lps'),
	(642028, 136, '2015-01-01 00:35:52.000000', 'consum', 0.0250, 'lps'),
	(642029, 136, '2015-01-01 00:35:53.000000', 'consum', 0.0325, 'lps'),
	(642030, 136, '2015-01-01 00:35:54.000000', 'consum', 0.0294, 'lps'),
	(642031, 136, '2015-01-01 00:35:55.000000', 'consum', 0.0285, 'lps'),
	(642032, 136, '2015-01-01 00:35:56.000000', 'consum', 0.0332, 'lps'),
	(642033, 136, '2015-01-01 00:35:57.000000', 'consum', 0.0224, 'lps'),
	(642034, 136, '2015-01-01 00:35:58.000000', 'consum', 0.0288, 'lps'),
	(642035, 136, '2015-01-01 00:35:59.000000', 'consum', 0.0308, 'lps'),
	(642036, 136, '2015-01-01 00:36:00.000000', 'consum', 0.0219, 'lps'),
	(642037, 136, '2015-01-01 00:36:01.000000', 'consum', 0.0332, 'lps'),
	(642038, 136, '2015-01-01 00:36:02.000000', 'consum', 0.0300, 'lps'),
	(642039, 136, '2015-01-01 00:36:03.000000', 'consum', 0.0295, 'lps'),
	(642040, 136, '2015-01-01 00:36:04.000000', 'consum', 0.0241, 'lps'),
	(642041, 136, '2015-01-01 00:36:05.000000', 'consum', 0.0235, 'lps'),
	(642042, 136, '2015-01-01 00:36:06.000000', 'consum', 0.0244, 'lps'),
	(642043, 136, '2015-01-01 00:36:07.000000', 'consum', 0.0303, 'lps'),
	(642044, 136, '2015-01-01 00:36:08.000000', 'consum', 0.0326, 'lps'),
	(642045, 136, '2015-01-01 00:36:09.000000', 'consum', 0.0264, 'lps'),
	(642046, 136, '2015-01-01 00:36:10.000000', 'consum', 0.0258, 'lps'),
	(642047, 136, '2015-01-01 00:36:11.000000', 'consum', 0.0287, 'lps'),
	(642048, 136, '2015-01-01 00:36:12.000000', 'consum', 0.0327, 'lps'),
	(642049, 136, '2015-01-01 00:36:13.000000', 'consum', 0.0316, 'lps'),
	(642050, 136, '2015-01-01 00:36:14.000000', 'consum', 0.0265, 'lps'),
	(642051, 136, '2015-01-01 00:36:15.000000', 'consum', 0.0292, 'lps'),
	(642052, 136, '2015-01-01 00:36:16.000000', 'consum', 0.0330, 'lps'),
	(642053, 136, '2015-01-01 00:36:17.000000', 'consum', 0.0318, 'lps'),
	(642054, 136, '2015-01-01 00:36:18.000000', 'consum', 0.0268, 'lps'),
	(642055, 136, '2015-01-01 00:36:19.000000', 'consum', 0.0301, 'lps'),
	(642056, 136, '2015-01-01 00:36:20.000000', 'consum', 0.0242, 'lps'),
	(642057, 136, '2015-01-01 00:36:21.000000', 'consum', 0.0221, 'lps'),
	(642058, 136, '2015-01-01 00:36:22.000000', 'consum', 0.0296, 'lps'),
	(642059, 136, '2015-01-01 00:36:23.000000', 'consum', 0.0235, 'lps'),
	(642060, 136, '2015-01-01 00:36:24.000000', 'consum', 0.0323, 'lps'),
	(642061, 136, '2015-01-01 00:36:25.000000', 'consum', 0.0332, 'lps'),
	(642062, 136, '2015-01-01 00:36:26.000000', 'consum', 0.0231, 'lps'),
	(642063, 136, '2015-01-01 00:36:27.000000', 'consum', 0.0323, 'lps'),
	(642064, 136, '2015-01-01 00:36:28.000000', 'consum', 0.0217, 'lps'),
	(642065, 136, '2015-01-01 00:36:29.000000', 'consum', 0.0276, 'lps'),
	(642066, 136, '2015-01-01 00:36:30.000000', 'consum', 0.0271, 'lps'),
	(642067, 136, '2015-01-01 00:36:31.000000', 'consum', 0.0319, 'lps'),
	(642068, 136, '2015-01-01 00:36:32.000000', 'consum', 0.0324, 'lps'),
	(642069, 136, '2015-01-01 00:36:33.000000', 'consum', 0.0328, 'lps'),
	(642070, 136, '2015-01-01 00:36:34.000000', 'consum', 0.0210, 'lps'),
	(642071, 136, '2015-01-01 00:36:35.000000', 'consum', 0.0231, 'lps'),
	(642072, 136, '2015-01-01 00:36:36.000000', 'consum', 0.0317, 'lps'),
	(642073, 136, '2015-01-01 00:36:37.000000', 'consum', 0.0307, 'lps'),
	(642074, 136, '2015-01-01 00:36:38.000000', 'consum', 0.0252, 'lps'),
	(642075, 136, '2015-01-01 00:36:39.000000', 'consum', 0.0255, 'lps'),
	(642076, 136, '2015-01-01 00:36:40.000000', 'consum', 0.0309, 'lps'),
	(642077, 136, '2015-01-01 00:36:41.000000', 'consum', 0.0321, 'lps'),
	(642078, 136, '2015-01-01 00:36:42.000000', 'consum', 0.0221, 'lps'),
	(642079, 136, '2015-01-01 00:36:43.000000', 'consum', 0.0303, 'lps'),
	(642080, 136, '2015-01-01 00:36:44.000000', 'consum', 0.0273, 'lps'),
	(642081, 136, '2015-01-01 00:36:45.000000', 'consum', 0.0247, 'lps'),
	(642082, 136, '2015-01-01 00:36:46.000000', 'consum', 0.0329, 'lps'),
	(642083, 136, '2015-01-01 00:36:47.000000', 'consum', 0.0321, 'lps'),
	(642084, 136, '2015-01-01 00:36:48.000000', 'consum', 0.0287, 'lps'),
	(642085, 136, '2015-01-01 00:36:49.000000', 'consum', 0.0262, 'lps'),
	(642086, 136, '2015-01-01 00:36:50.000000', 'consum', 0.0241, 'lps'),
	(642087, 136, '2015-01-01 00:36:51.000000', 'consum', 0.0333, 'lps'),
	(642088, 136, '2015-01-01 00:36:52.000000', 'consum', 0.0235, 'lps'),
	(642089, 136, '2015-01-01 00:36:53.000000', 'consum', 0.0214, 'lps'),
	(642090, 136, '2015-01-01 00:36:54.000000', 'consum', 0.0282, 'lps'),
	(642091, 136, '2015-01-01 00:36:55.000000', 'consum', 0.0309, 'lps'),
	(642092, 136, '2015-01-01 00:36:56.000000', 'consum', 0.0240, 'lps'),
	(642093, 136, '2015-01-01 00:36:57.000000', 'consum', 0.0313, 'lps'),
	(642094, 136, '2015-01-01 00:36:58.000000', 'consum', 0.0263, 'lps'),
	(642095, 136, '2015-01-01 00:36:59.000000', 'consum', 0.0293, 'lps'),
	(642096, 136, '2015-01-01 00:37:00.000000', 'consum', 0.0216, 'lps'),
	(642097, 136, '2015-01-01 00:37:01.000000', 'consum', 0.0240, 'lps'),
	(642098, 136, '2015-01-01 00:37:02.000000', 'consum', 0.0219, 'lps'),
	(642099, 136, '2015-01-01 00:37:03.000000', 'consum', 0.0289, 'lps'),
	(642100, 136, '2015-01-01 00:37:04.000000', 'consum', 0.0332, 'lps'),
	(642101, 136, '2015-01-01 00:37:05.000000', 'consum', 0.0332, 'lps'),
	(642102, 136, '2015-01-01 00:37:06.000000', 'consum', 0.0210, 'lps'),
	(642103, 136, '2015-01-01 00:37:07.000000', 'consum', 0.0216, 'lps'),
	(642104, 136, '2015-01-01 00:37:08.000000', 'consum', 0.0240, 'lps'),
	(642105, 136, '2015-01-01 00:37:09.000000', 'consum', 0.0218, 'lps'),
	(642106, 136, '2015-01-01 00:37:10.000000', 'consum', 0.0283, 'lps'),
	(642107, 136, '2015-01-01 00:37:11.000000', 'consum', 0.0304, 'lps'),
	(642108, 136, '2015-01-01 00:37:12.000000', 'consum', 0.0213, 'lps'),
	(642109, 136, '2015-01-01 00:37:13.000000', 'consum', 0.0318, 'lps'),
	(642110, 136, '2015-01-01 00:37:14.000000', 'consum', 0.0245, 'lps'),
	(642111, 136, '2015-01-01 00:37:15.000000', 'consum', 0.0310, 'lps'),
	(642112, 136, '2015-01-01 00:37:16.000000', 'consum', 0.0233, 'lps'),
	(642113, 136, '2015-01-01 00:37:17.000000', 'consum', 0.0274, 'lps'),
	(642114, 136, '2015-01-01 00:37:18.000000', 'consum', 0.0213, 'lps'),
	(642115, 136, '2015-01-01 00:37:19.000000', 'consum', 0.0282, 'lps'),
	(642116, 136, '2015-01-01 00:37:20.000000', 'consum', 0.0311, 'lps'),
	(642117, 136, '2015-01-01 00:37:21.000000', 'consum', 0.0253, 'lps'),
	(642118, 136, '2015-01-01 00:37:22.000000', 'consum', 0.0248, 'lps'),
	(642119, 136, '2015-01-01 00:37:23.000000', 'consum', 0.0271, 'lps'),
	(642120, 136, '2015-01-01 00:37:24.000000', 'consum', 0.0275, 'lps'),
	(642121, 136, '2015-01-01 00:37:25.000000', 'consum', 0.0231, 'lps'),
	(642122, 136, '2015-01-01 00:37:26.000000', 'consum', 0.0246, 'lps'),
	(642123, 136, '2015-01-01 00:37:27.000000', 'consum', 0.0324, 'lps'),
	(642124, 136, '2015-01-01 00:37:28.000000', 'consum', 0.0303, 'lps'),
	(642125, 136, '2015-01-01 00:37:29.000000', 'consum', 0.0210, 'lps'),
	(642126, 136, '2015-01-01 00:37:30.000000', 'consum', 0.0303, 'lps'),
	(642127, 136, '2015-01-01 00:37:31.000000', 'consum', 0.0304, 'lps'),
	(642128, 136, '2015-01-01 00:37:32.000000', 'consum', 0.0277, 'lps'),
	(642129, 136, '2015-01-01 00:37:33.000000', 'consum', 0.0262, 'lps'),
	(642130, 136, '2015-01-01 00:37:34.000000', 'consum', 0.0272, 'lps'),
	(642131, 136, '2015-01-01 00:37:35.000000', 'consum', 0.0241, 'lps'),
	(642132, 136, '2015-01-01 00:37:36.000000', 'consum', 0.0301, 'lps'),
	(642133, 136, '2015-01-01 00:37:37.000000', 'consum', 0.0324, 'lps'),
	(642134, 136, '2015-01-01 00:37:38.000000', 'consum', 0.0262, 'lps'),
	(642135, 136, '2015-01-01 00:37:39.000000', 'consum', 0.0252, 'lps'),
	(642136, 136, '2015-01-01 00:37:40.000000', 'consum', 0.0266, 'lps'),
	(642137, 136, '2015-01-01 00:37:41.000000', 'consum', 0.0240, 'lps'),
	(642138, 136, '2015-01-01 00:37:42.000000', 'consum', 0.0315, 'lps'),
	(642139, 136, '2015-01-01 00:37:43.000000', 'consum', 0.0272, 'lps'),
	(642140, 136, '2015-01-01 00:37:44.000000', 'consum', 0.0333, 'lps'),
	(642141, 136, '2015-01-01 00:37:45.000000', 'consum', 0.0265, 'lps'),
	(642142, 136, '2015-01-01 00:37:46.000000', 'consum', 0.0240, 'lps'),
	(642143, 136, '2015-01-01 00:37:47.000000', 'consum', 0.0320, 'lps'),
	(642144, 136, '2015-01-01 00:37:48.000000', 'consum', 0.0298, 'lps'),
	(642145, 136, '2015-01-01 00:37:49.000000', 'consum', 0.0320, 'lps'),
	(642146, 136, '2015-01-01 00:37:50.000000', 'consum', 0.0250, 'lps'),
	(642147, 136, '2015-01-01 00:37:51.000000', 'consum', 0.0327, 'lps'),
	(642148, 136, '2015-01-01 00:37:52.000000', 'consum', 0.0304, 'lps'),
	(642149, 136, '2015-01-01 00:37:53.000000', 'consum', 0.0331, 'lps'),
	(642150, 136, '2015-01-01 00:37:54.000000', 'consum', 0.0284, 'lps'),
	(642151, 136, '2015-01-01 00:37:55.000000', 'consum', 0.0217, 'lps'),
	(642152, 136, '2015-01-01 00:37:56.000000', 'consum', 0.0272, 'lps'),
	(642153, 136, '2015-01-01 00:37:57.000000', 'consum', 0.0250, 'lps'),
	(642154, 136, '2015-01-01 00:37:58.000000', 'consum', 0.0227, 'lps'),
	(642155, 136, '2015-01-01 00:37:59.000000', 'consum', 0.0298, 'lps'),
	(642156, 136, '2015-01-01 00:38:00.000000', 'consum', 0.0229, 'lps'),
	(642157, 136, '2015-01-01 00:38:01.000000', 'consum', 0.0288, 'lps'),
	(642158, 136, '2015-01-01 00:38:02.000000', 'consum', 0.0297, 'lps'),
	(642159, 136, '2015-01-01 00:38:03.000000', 'consum', 0.0287, 'lps'),
	(642160, 136, '2015-01-01 00:38:04.000000', 'consum', 0.0210, 'lps'),
	(642161, 136, '2015-01-01 00:38:05.000000', 'consum', 0.0226, 'lps'),
	(642162, 136, '2015-01-01 00:38:06.000000', 'consum', 0.0290, 'lps'),
	(642163, 136, '2015-01-01 00:38:07.000000', 'consum', 0.0317, 'lps'),
	(642164, 136, '2015-01-01 00:38:08.000000', 'consum', 0.0257, 'lps'),
	(642165, 136, '2015-01-01 00:38:09.000000', 'consum', 0.0247, 'lps'),
	(642166, 136, '2015-01-01 00:38:10.000000', 'consum', 0.0255, 'lps'),
	(642167, 136, '2015-01-01 00:38:11.000000', 'consum', 0.0325, 'lps'),
	(642168, 136, '2015-01-01 00:38:12.000000', 'consum', 0.0279, 'lps'),
	(642169, 136, '2015-01-01 00:38:13.000000', 'consum', 0.0211, 'lps'),
	(642170, 136, '2015-01-01 00:38:14.000000', 'consum', 0.0254, 'lps'),
	(642171, 136, '2015-01-01 00:38:15.000000', 'consum', 0.0304, 'lps'),
	(642172, 136, '2015-01-01 00:38:16.000000', 'consum', 0.0300, 'lps'),
	(642173, 136, '2015-01-01 00:38:17.000000', 'consum', 0.0256, 'lps'),
	(642174, 136, '2015-01-01 00:38:18.000000', 'consum', 0.0296, 'lps'),
	(642175, 136, '2015-01-01 00:38:19.000000', 'consum', 0.0252, 'lps'),
	(642176, 136, '2015-01-01 00:38:20.000000', 'consum', 0.0285, 'lps'),
	(642177, 136, '2015-01-01 00:38:21.000000', 'consum', 0.0215, 'lps'),
	(642178, 136, '2015-01-01 00:38:22.000000', 'consum', 0.0257, 'lps'),
	(642179, 136, '2015-01-01 00:38:23.000000', 'consum', 0.0305, 'lps'),
	(642180, 136, '2015-01-01 00:38:24.000000', 'consum', 0.0298, 'lps'),
	(642181, 136, '2015-01-01 00:38:25.000000', 'consum', 0.0241, 'lps'),
	(642182, 136, '2015-01-01 00:38:26.000000', 'consum', 0.0227, 'lps'),
	(642183, 136, '2015-01-01 00:38:27.000000', 'consum', 0.0324, 'lps'),
	(642184, 136, '2015-01-01 00:38:28.000000', 'consum', 0.0234, 'lps'),
	(642185, 136, '2015-01-01 00:38:29.000000', 'consum', 0.0238, 'lps'),
	(642186, 136, '2015-01-01 00:38:30.000000', 'consum', 0.0277, 'lps'),
	(642187, 136, '2015-01-01 00:38:31.000000', 'consum', 0.0216, 'lps'),
	(642188, 136, '2015-01-01 00:38:32.000000', 'consum', 0.0284, 'lps'),
	(642189, 136, '2015-01-01 00:38:33.000000', 'consum', 0.0317, 'lps'),
	(642190, 136, '2015-01-01 00:38:34.000000', 'consum', 0.0277, 'lps'),
	(642191, 136, '2015-01-01 00:38:35.000000', 'consum', 0.0223, 'lps'),
	(642192, 136, '2015-01-01 00:38:36.000000', 'consum', 0.0321, 'lps'),
	(642193, 136, '2015-01-01 00:38:37.000000', 'consum', 0.0231, 'lps'),
	(642194, 136, '2015-01-01 00:38:38.000000', 'consum', 0.0231, 'lps'),
	(642195, 136, '2015-01-01 00:38:39.000000', 'consum', 0.0253, 'lps'),
	(642196, 136, '2015-01-01 00:38:40.000000', 'consum', 0.0238, 'lps'),
	(642197, 136, '2015-01-01 00:38:41.000000', 'consum', 0.0222, 'lps'),
	(642198, 136, '2015-01-01 00:38:42.000000', 'consum', 0.0310, 'lps'),
	(642199, 136, '2015-01-01 00:38:43.000000', 'consum', 0.0303, 'lps'),
	(642200, 136, '2015-01-01 00:38:44.000000', 'consum', 0.0252, 'lps'),
	(642201, 136, '2015-01-01 00:38:45.000000', 'consum', 0.0263, 'lps'),
	(642202, 136, '2015-01-01 00:38:46.000000', 'consum', 0.0226, 'lps'),
	(642203, 136, '2015-01-01 00:38:47.000000', 'consum', 0.0257, 'lps'),
	(642204, 136, '2015-01-01 00:38:48.000000', 'consum', 0.0275, 'lps'),
	(642205, 136, '2015-01-01 00:38:49.000000', 'consum', 0.0269, 'lps'),
	(642206, 136, '2015-01-01 00:38:50.000000', 'consum', 0.0309, 'lps'),
	(642207, 136, '2015-01-01 00:38:51.000000', 'consum', 0.0281, 'lps'),
	(642208, 136, '2015-01-01 00:38:52.000000', 'consum', 0.0267, 'lps'),
	(642209, 136, '2015-01-01 00:38:53.000000', 'consum', 0.0283, 'lps'),
	(642210, 136, '2015-01-01 00:38:54.000000', 'consum', 0.0282, 'lps'),
	(642211, 136, '2015-01-01 00:38:55.000000', 'consum', 0.0225, 'lps'),
	(642212, 136, '2015-01-01 00:38:56.000000', 'consum', 0.0320, 'lps'),
	(642213, 136, '2015-01-01 00:38:57.000000', 'consum', 0.0220, 'lps'),
	(642214, 136, '2015-01-01 00:38:58.000000', 'consum', 0.0302, 'lps'),
	(642215, 136, '2015-01-01 00:38:59.000000', 'consum', 0.0267, 'lps'),
	(642216, 136, '2015-01-01 00:39:00.000000', 'consum', 0.0220, 'lps'),
	(642217, 136, '2015-01-01 00:39:01.000000', 'consum', 0.0212, 'lps'),
	(642218, 136, '2015-01-01 00:39:02.000000', 'consum', 0.0317, 'lps'),
	(642219, 136, '2015-01-01 00:39:03.000000', 'consum', 0.0242, 'lps'),
	(642220, 136, '2015-01-01 00:39:04.000000', 'consum', 0.0296, 'lps'),
	(642221, 136, '2015-01-01 00:39:05.000000', 'consum', 0.0299, 'lps'),
	(642222, 136, '2015-01-01 00:39:06.000000', 'consum', 0.0275, 'lps'),
	(642223, 136, '2015-01-01 00:39:07.000000', 'consum', 0.0266, 'lps'),
	(642224, 136, '2015-01-01 00:39:08.000000', 'consum', 0.0295, 'lps'),
	(642225, 136, '2015-01-01 00:39:09.000000', 'consum', 0.0221, 'lps'),
	(642226, 136, '2015-01-01 00:39:10.000000', 'consum', 0.0258, 'lps'),
	(642227, 136, '2015-01-01 00:39:11.000000', 'consum', 0.0292, 'lps'),
	(642228, 136, '2015-01-01 00:39:12.000000', 'consum', 0.0229, 'lps'),
	(642229, 136, '2015-01-01 00:39:13.000000', 'consum', 0.0307, 'lps'),
	(642230, 136, '2015-01-01 00:39:14.000000', 'consum', 0.0266, 'lps'),
	(642231, 136, '2015-01-01 00:39:15.000000', 'consum', 0.0325, 'lps'),
	(642232, 136, '2015-01-01 00:39:16.000000', 'consum', 0.0243, 'lps'),
	(642233, 136, '2015-01-01 00:39:17.000000', 'consum', 0.0280, 'lps'),
	(642234, 136, '2015-01-01 00:39:18.000000', 'consum', 0.0214, 'lps'),
	(642235, 136, '2015-01-01 00:39:19.000000', 'consum', 0.0268, 'lps'),
	(642236, 136, '2015-01-01 00:39:20.000000', 'consum', 0.0242, 'lps'),
	(642237, 136, '2015-01-01 00:39:21.000000', 'consum', 0.0318, 'lps'),
	(642238, 136, '2015-01-01 00:39:22.000000', 'consum', 0.0282, 'lps'),
	(642239, 136, '2015-01-01 00:39:23.000000', 'consum', 0.0248, 'lps'),
	(642240, 136, '2015-01-01 00:39:24.000000', 'consum', 0.0307, 'lps'),
	(642241, 136, '2015-01-01 00:39:25.000000', 'consum', 0.0211, 'lps'),
	(642242, 136, '2015-01-01 00:39:26.000000', 'consum', 0.0298, 'lps'),
	(642243, 136, '2015-01-01 00:39:27.000000', 'consum', 0.0273, 'lps'),
	(642244, 136, '2015-01-01 00:39:28.000000', 'consum', 0.0264, 'lps'),
	(642245, 136, '2015-01-01 00:39:29.000000', 'consum', 0.0290, 'lps'),
	(642246, 136, '2015-01-01 00:39:30.000000', 'consum', 0.0325, 'lps'),
	(642247, 136, '2015-01-01 00:39:31.000000', 'consum', 0.0296, 'lps'),
	(642248, 136, '2015-01-01 00:39:32.000000', 'consum', 0.0296, 'lps'),
	(642249, 136, '2015-01-01 00:39:33.000000', 'consum', 0.0257, 'lps'),
	(642250, 136, '2015-01-01 00:39:34.000000', 'consum', 0.0312, 'lps'),
	(642251, 136, '2015-01-01 00:39:35.000000', 'consum', 0.0330, 'lps'),
	(642252, 136, '2015-01-01 00:39:36.000000', 'consum', 0.0259, 'lps'),
	(642253, 136, '2015-01-01 00:39:37.000000', 'consum', 0.0217, 'lps'),
	(642254, 136, '2015-01-01 00:39:38.000000', 'consum', 0.0226, 'lps'),
	(642255, 136, '2015-01-01 00:39:39.000000', 'consum', 0.0266, 'lps'),
	(642256, 136, '2015-01-01 00:39:40.000000', 'consum', 0.0320, 'lps'),
	(642257, 136, '2015-01-01 00:39:41.000000', 'consum', 0.0219, 'lps'),
	(642258, 136, '2015-01-01 00:39:42.000000', 'consum', 0.0299, 'lps'),
	(642259, 136, '2015-01-01 00:39:43.000000', 'consum', 0.0256, 'lps'),
	(642260, 136, '2015-01-01 00:39:44.000000', 'consum', 0.0297, 'lps'),
	(642261, 136, '2015-01-01 00:39:45.000000', 'consum', 0.0259, 'lps'),
	(642262, 136, '2015-01-01 00:39:46.000000', 'consum', 0.0317, 'lps'),
	(642263, 136, '2015-01-01 00:39:47.000000', 'consum', 0.0230, 'lps'),
	(642264, 136, '2015-01-01 00:39:48.000000', 'consum', 0.0235, 'lps'),
	(642265, 136, '2015-01-01 00:39:49.000000', 'consum', 0.0275, 'lps'),
	(642266, 136, '2015-01-01 00:39:50.000000', 'consum', 0.0214, 'lps'),
	(642267, 136, '2015-01-01 00:39:51.000000', 'consum', 0.0285, 'lps'),
	(642268, 136, '2015-01-01 00:39:52.000000', 'consum', 0.0322, 'lps'),
	(642269, 136, '2015-01-01 00:39:53.000000', 'consum', 0.0300, 'lps'),
	(642270, 136, '2015-01-01 00:39:54.000000', 'consum', 0.0325, 'lps'),
	(642271, 136, '2015-01-01 00:39:55.000000', 'consum', 0.0268, 'lps'),
	(642272, 136, '2015-01-01 00:39:56.000000', 'consum', 0.0277, 'lps'),
	(642273, 136, '2015-01-01 00:39:57.000000', 'consum', 0.0248, 'lps'),
	(642274, 136, '2015-01-01 00:39:58.000000', 'consum', 0.0326, 'lps'),
	(642275, 136, '2015-01-01 00:39:59.000000', 'consum', 0.0303, 'lps'),
	(642276, 136, '2015-01-01 00:40:00.000000', 'consum', 0.0327, 'lps'),
	(642277, 136, '2015-01-01 00:40:01.000000', 'consum', 0.0268, 'lps'),
	(642278, 136, '2015-01-01 00:40:02.000000', 'consum', 0.0276, 'lps'),
	(642279, 136, '2015-01-01 00:40:03.000000', 'consum', 0.0240, 'lps'),
	(642280, 136, '2015-01-01 00:40:04.000000', 'consum', 0.0288, 'lps'),
	(642281, 136, '2015-01-01 00:40:05.000000', 'consum', 0.0261, 'lps'),
	(642282, 136, '2015-01-01 00:40:06.000000', 'consum', 0.0233, 'lps'),
	(642283, 136, '2015-01-01 00:40:07.000000', 'consum', 0.0295, 'lps'),
	(642284, 136, '2015-01-01 00:40:08.000000', 'consum', 0.0318, 'lps'),
	(642285, 136, '2015-01-01 00:40:09.000000', 'consum', 0.0250, 'lps'),
	(642286, 136, '2015-01-01 00:40:10.000000', 'consum', 0.0210, 'lps'),
	(642287, 136, '2015-01-01 00:40:11.000000', 'consum', 0.0214, 'lps'),
	(642288, 136, '2015-01-01 00:40:12.000000', 'consum', 0.0231, 'lps'),
	(642289, 136, '2015-01-01 00:40:13.000000', 'consum', 0.0304, 'lps'),
	(642290, 136, '2015-01-01 00:40:14.000000', 'consum', 0.0246, 'lps'),
	(642291, 136, '2015-01-01 00:40:15.000000', 'consum', 0.0233, 'lps'),
	(642292, 136, '2015-01-01 00:40:16.000000', 'consum', 0.0215, 'lps'),
	(642293, 136, '2015-01-01 00:40:17.000000', 'consum', 0.0291, 'lps'),
	(642294, 136, '2015-01-01 00:40:18.000000', 'consum', 0.0229, 'lps'),
	(642295, 136, '2015-01-01 00:40:19.000000', 'consum', 0.0309, 'lps'),
	(642296, 136, '2015-01-01 00:40:20.000000', 'consum', 0.0276, 'lps'),
	(642297, 136, '2015-01-01 00:40:21.000000', 'consum', 0.0246, 'lps'),
	(642298, 136, '2015-01-01 00:40:22.000000', 'consum', 0.0315, 'lps'),
	(642299, 136, '2015-01-01 00:40:23.000000', 'consum', 0.0254, 'lps'),
	(642300, 136, '2015-01-01 00:40:24.000000', 'consum', 0.0241, 'lps'),
	(642301, 136, '2015-01-01 00:40:25.000000', 'consum', 0.0234, 'lps'),
	(642302, 136, '2015-01-01 00:40:26.000000', 'consum', 0.0238, 'lps'),
	(642303, 136, '2015-01-01 00:40:27.000000', 'consum', 0.0279, 'lps'),
	(642304, 136, '2015-01-01 00:40:28.000000', 'consum', 0.0223, 'lps'),
	(642305, 136, '2015-01-01 00:40:29.000000', 'consum', 0.0317, 'lps'),
	(642306, 136, '2015-01-01 00:40:30.000000', 'consum', 0.0212, 'lps'),
	(642307, 136, '2015-01-01 00:40:31.000000', 'consum', 0.0271, 'lps'),
	(642308, 136, '2015-01-01 00:40:32.000000', 'consum', 0.0260, 'lps'),
	(642309, 136, '2015-01-01 00:40:33.000000', 'consum', 0.0276, 'lps'),
	(642310, 136, '2015-01-01 00:40:34.000000', 'consum', 0.0269, 'lps'),
	(642311, 136, '2015-01-01 00:40:35.000000', 'consum', 0.0306, 'lps'),
	(642312, 136, '2015-01-01 00:40:36.000000', 'consum', 0.0267, 'lps'),
	(642313, 136, '2015-01-01 00:40:37.000000', 'consum', 0.0329, 'lps'),
	(642314, 136, '2015-01-01 00:40:38.000000', 'consum', 0.0265, 'lps'),
	(642315, 136, '2015-01-01 00:40:39.000000', 'consum', 0.0252, 'lps'),
	(642316, 136, '2015-01-01 00:40:40.000000', 'consum', 0.0257, 'lps'),
	(642317, 136, '2015-01-01 00:40:41.000000', 'consum', 0.0318, 'lps'),
	(642318, 136, '2015-01-01 00:40:42.000000', 'consum', 0.0237, 'lps'),
	(642319, 136, '2015-01-01 00:40:43.000000', 'consum', 0.0271, 'lps'),
	(642320, 136, '2015-01-01 00:40:44.000000', 'consum', 0.0311, 'lps'),
	(642321, 136, '2015-01-01 00:40:45.000000', 'consum', 0.0283, 'lps'),
	(642322, 136, '2015-01-01 00:40:46.000000', 'consum', 0.0273, 'lps'),
	(642323, 136, '2015-01-01 00:40:47.000000', 'consum', 0.0308, 'lps'),
	(642324, 136, '2015-01-01 00:40:48.000000', 'consum', 0.0264, 'lps'),
	(642325, 136, '2015-01-01 00:40:49.000000', 'consum', 0.0309, 'lps'),
	(642326, 136, '2015-01-01 00:40:50.000000', 'consum', 0.0297, 'lps'),
	(642327, 136, '2015-01-01 00:40:51.000000', 'consum', 0.0225, 'lps'),
	(642328, 136, '2015-01-01 00:40:52.000000', 'consum', 0.0273, 'lps'),
	(642329, 136, '2015-01-01 00:40:53.000000', 'consum', 0.0230, 'lps'),
	(642330, 136, '2015-01-01 00:40:54.000000', 'consum', 0.0248, 'lps'),
	(642331, 136, '2015-01-01 00:40:55.000000', 'consum', 0.0216, 'lps'),
	(642332, 136, '2015-01-01 00:40:56.000000', 'consum', 0.0249, 'lps'),
	(642333, 136, '2015-01-01 00:40:57.000000', 'consum', 0.0266, 'lps'),
	(642334, 136, '2015-01-01 00:40:58.000000', 'consum', 0.0249, 'lps'),
	(642335, 136, '2015-01-01 00:40:59.000000', 'consum', 0.0238, 'lps'),
	(642336, 136, '2015-01-01 00:41:00.000000', 'consum', 0.0234, 'lps'),
	(642337, 136, '2015-01-01 00:41:01.000000', 'consum', 0.0248, 'lps'),
	(642338, 136, '2015-01-01 00:41:02.000000', 'consum', 0.0326, 'lps'),
	(642339, 136, '2015-01-01 00:41:03.000000', 'consum', 0.0304, 'lps'),
	(642340, 136, '2015-01-01 00:41:04.000000', 'consum', 0.0333, 'lps'),
	(642341, 136, '2015-01-01 00:41:05.000000', 'consum', 0.0296, 'lps'),
	(642342, 136, '2015-01-01 00:41:06.000000', 'consum', 0.0272, 'lps'),
	(642343, 136, '2015-01-01 00:41:07.000000', 'consum', 0.0263, 'lps'),
	(642344, 136, '2015-01-01 00:41:08.000000', 'consum', 0.0287, 'lps'),
	(642345, 136, '2015-01-01 00:41:09.000000', 'consum', 0.0315, 'lps'),
	(642346, 136, '2015-01-01 00:41:10.000000', 'consum', 0.0255, 'lps'),
	(642347, 136, '2015-01-01 00:41:11.000000', 'consum', 0.0244, 'lps'),
	(642348, 136, '2015-01-01 00:41:12.000000', 'consum', 0.0247, 'lps'),
	(642349, 136, '2015-01-01 00:41:13.000000', 'consum', 0.0293, 'lps'),
	(642350, 136, '2015-01-01 00:41:14.000000', 'consum', 0.0266, 'lps'),
	(642351, 136, '2015-01-01 00:41:15.000000', 'consum', 0.0241, 'lps'),
	(642352, 136, '2015-01-01 00:41:16.000000', 'consum', 0.0323, 'lps'),
	(642353, 136, '2015-01-01 00:41:17.000000', 'consum', 0.0311, 'lps'),
	(642354, 136, '2015-01-01 00:41:18.000000', 'consum', 0.0251, 'lps'),
	(642355, 136, '2015-01-01 00:41:19.000000', 'consum', 0.0238, 'lps'),
	(642356, 136, '2015-01-01 00:41:20.000000', 'consum', 0.0229, 'lps'),
	(642357, 136, '2015-01-01 00:41:21.000000', 'consum', 0.0219, 'lps'),
	(642358, 136, '2015-01-01 00:41:22.000000', 'consum', 0.0323, 'lps'),
	(642359, 136, '2015-01-01 00:41:23.000000', 'consum', 0.0253, 'lps'),
	(642360, 136, '2015-01-01 00:41:24.000000', 'consum', 0.0332, 'lps'),
	(642361, 136, '2015-01-01 00:41:25.000000', 'consum', 0.0323, 'lps'),
	(642362, 136, '2015-01-01 00:41:26.000000', 'consum', 0.0284, 'lps'),
	(642363, 136, '2015-01-01 00:41:27.000000', 'consum', 0.0244, 'lps'),
	(642364, 136, '2015-01-01 00:41:28.000000', 'consum', 0.0279, 'lps'),
	(642365, 136, '2015-01-01 00:41:29.000000', 'consum', 0.0330, 'lps'),
	(642366, 136, '2015-01-01 00:41:30.000000', 'consum', 0.0234, 'lps'),
	(642367, 136, '2015-01-01 00:41:31.000000', 'consum', 0.0216, 'lps'),
	(642368, 136, '2015-01-01 00:41:32.000000', 'consum', 0.0293, 'lps'),
	(642369, 136, '2015-01-01 00:41:33.000000', 'consum', 0.0234, 'lps'),
	(642370, 136, '2015-01-01 00:41:34.000000', 'consum', 0.0330, 'lps'),
	(642371, 136, '2015-01-01 00:41:35.000000', 'consum', 0.0242, 'lps'),
	(642372, 136, '2015-01-01 00:41:36.000000', 'consum', 0.0259, 'lps'),
	(642373, 136, '2015-01-01 00:41:37.000000', 'consum', 0.0235, 'lps'),
	(642374, 136, '2015-01-01 00:41:38.000000', 'consum', 0.0312, 'lps'),
	(642375, 136, '2015-01-01 00:41:39.000000', 'consum', 0.0272, 'lps'),
	(642376, 136, '2015-01-01 00:41:40.000000', 'consum', 0.0218, 'lps'),
	(642377, 136, '2015-01-01 00:41:41.000000', 'consum', 0.0311, 'lps'),
	(642378, 136, '2015-01-01 00:41:42.000000', 'consum', 0.0319, 'lps'),
	(642379, 136, '2015-01-01 00:41:43.000000', 'consum', 0.0330, 'lps'),
	(642380, 136, '2015-01-01 00:41:44.000000', 'consum', 0.0234, 'lps'),
	(642381, 136, '2015-01-01 00:41:45.000000', 'consum', 0.0217, 'lps'),
	(642382, 136, '2015-01-01 00:41:46.000000', 'consum', 0.0299, 'lps'),
	(642383, 136, '2015-01-01 00:41:47.000000', 'consum', 0.0262, 'lps'),
	(642384, 136, '2015-01-01 00:41:48.000000', 'consum', 0.0327, 'lps'),
	(642385, 136, '2015-01-01 00:41:49.000000', 'consum', 0.0267, 'lps'),
	(642386, 136, '2015-01-01 00:41:50.000000', 'consum', 0.0270, 'lps'),
	(642387, 136, '2015-01-01 00:41:51.000000', 'consum', 0.0216, 'lps'),
	(642388, 136, '2015-01-01 00:41:52.000000', 'consum', 0.0310, 'lps'),
	(642389, 136, '2015-01-01 00:41:53.000000', 'consum', 0.0318, 'lps'),
	(642390, 136, '2015-01-01 00:41:54.000000', 'consum', 0.0329, 'lps'),
	(642391, 136, '2015-01-01 00:41:55.000000', 'consum', 0.0233, 'lps'),
	(642392, 136, '2015-01-01 00:41:56.000000', 'consum', 0.0218, 'lps'),
	(642393, 136, '2015-01-01 00:41:57.000000', 'consum', 0.0304, 'lps'),
	(642394, 136, '2015-01-01 00:41:58.000000', 'consum', 0.0286, 'lps'),
	(642395, 136, '2015-01-01 00:41:59.000000', 'consum', 0.0309, 'lps'),
	(642396, 136, '2015-01-01 00:42:00.000000', 'consum', 0.0228, 'lps'),
	(642397, 136, '2015-01-01 00:42:01.000000', 'consum', 0.0253, 'lps'),
	(642398, 136, '2015-01-01 00:42:02.000000', 'consum', 0.0246, 'lps'),
	(642399, 136, '2015-01-01 00:42:03.000000', 'consum', 0.0262, 'lps'),
	(642400, 136, '2015-01-01 00:42:04.000000', 'consum', 0.0240, 'lps'),
	(642401, 136, '2015-01-01 00:42:05.000000', 'consum', 0.0329, 'lps'),
	(642402, 136, '2015-01-01 00:42:06.000000', 'consum', 0.0219, 'lps'),
	(642403, 136, '2015-01-01 00:42:07.000000', 'consum', 0.0272, 'lps'),
	(642404, 136, '2015-01-01 00:42:08.000000', 'consum', 0.0242, 'lps'),
	(642405, 136, '2015-01-01 00:42:09.000000', 'consum', 0.0311, 'lps'),
	(642406, 136, '2015-01-01 00:42:10.000000', 'consum', 0.0248, 'lps'),
	(642407, 136, '2015-01-01 00:42:11.000000', 'consum', 0.0223, 'lps'),
	(642408, 136, '2015-01-01 00:42:12.000000', 'consum', 0.0283, 'lps'),
	(642409, 136, '2015-01-01 00:42:13.000000', 'consum', 0.0289, 'lps'),
	(642410, 136, '2015-01-01 00:42:14.000000', 'consum', 0.0262, 'lps'),
	(642411, 136, '2015-01-01 00:42:15.000000', 'consum', 0.0235, 'lps'),
	(642412, 136, '2015-01-01 00:42:16.000000', 'consum', 0.0301, 'lps'),
	(642413, 136, '2015-01-01 00:42:17.000000', 'consum', 0.0222, 'lps'),
	(642414, 136, '2015-01-01 00:42:18.000000', 'consum', 0.0242, 'lps'),
	(642415, 136, '2015-01-01 00:42:19.000000', 'consum', 0.0211, 'lps'),
	(642416, 136, '2015-01-01 00:42:20.000000', 'consum', 0.0245, 'lps'),
	(642417, 136, '2015-01-01 00:42:21.000000', 'consum', 0.0259, 'lps'),
	(642418, 136, '2015-01-01 00:42:22.000000', 'consum', 0.0226, 'lps'),
	(642419, 136, '2015-01-01 00:42:23.000000', 'consum', 0.0269, 'lps'),
	(642420, 136, '2015-01-01 00:42:24.000000', 'consum', 0.0210, 'lps'),
	(642421, 136, '2015-01-01 00:42:25.000000', 'consum', 0.0281, 'lps'),
	(642422, 136, '2015-01-01 00:42:26.000000', 'consum', 0.0315, 'lps'),
	(642423, 136, '2015-01-01 00:42:27.000000', 'consum', 0.0277, 'lps'),
	(642424, 136, '2015-01-01 00:42:28.000000', 'consum', 0.0229, 'lps'),
	(642425, 136, '2015-01-01 00:42:29.000000', 'consum', 0.0228, 'lps'),
	(642426, 136, '2015-01-01 00:42:30.000000', 'consum', 0.0246, 'lps'),
	(642427, 136, '2015-01-01 00:42:31.000000', 'consum', 0.0210, 'lps'),
	(642428, 136, '2015-01-01 00:42:32.000000', 'consum', 0.0228, 'lps'),
	(642429, 136, '2015-01-01 00:42:33.000000', 'consum', 0.0298, 'lps'),
	(642430, 136, '2015-01-01 00:42:34.000000', 'consum', 0.0226, 'lps'),
	(642431, 136, '2015-01-01 00:42:35.000000', 'consum', 0.0276, 'lps'),
	(642432, 136, '2015-01-01 00:42:36.000000', 'consum', 0.0242, 'lps'),
	(642433, 136, '2015-01-01 00:42:37.000000', 'consum', 0.0300, 'lps'),
	(642434, 136, '2015-01-01 00:42:38.000000', 'consum', 0.0313, 'lps'),
	(642435, 136, '2015-01-01 00:42:39.000000', 'consum', 0.0332, 'lps'),
	(642436, 136, '2015-01-01 00:42:40.000000', 'consum', 0.0265, 'lps'),
	(642437, 136, '2015-01-01 00:42:41.000000', 'consum', 0.0242, 'lps'),
	(642438, 136, '2015-01-01 00:42:42.000000', 'consum', 0.0329, 'lps'),
	(642439, 136, '2015-01-01 00:42:43.000000', 'consum', 0.0215, 'lps'),
	(642440, 136, '2015-01-01 00:42:44.000000', 'consum', 0.0249, 'lps'),
	(642441, 136, '2015-01-01 00:42:45.000000', 'consum', 0.0268, 'lps'),
	(642442, 136, '2015-01-01 00:42:46.000000', 'consum', 0.0258, 'lps'),
	(642443, 136, '2015-01-01 00:42:47.000000', 'consum', 0.0277, 'lps'),
	(642444, 136, '2015-01-01 00:42:48.000000', 'consum', 0.0277, 'lps'),
	(642445, 136, '2015-01-01 00:42:49.000000', 'consum', 0.0222, 'lps'),
	(642446, 136, '2015-01-01 00:42:50.000000', 'consum', 0.0317, 'lps'),
	(642447, 136, '2015-01-01 00:42:51.000000', 'consum', 0.0212, 'lps'),
	(642448, 136, '2015-01-01 00:42:52.000000', 'consum', 0.0272, 'lps'),
	(642449, 136, '2015-01-01 00:42:53.000000', 'consum', 0.0268, 'lps'),
	(642450, 136, '2015-01-01 00:42:54.000000', 'consum', 0.0315, 'lps'),
	(642451, 136, '2015-01-01 00:42:55.000000', 'consum', 0.0314, 'lps'),
	(642452, 136, '2015-01-01 00:42:56.000000', 'consum', 0.0292, 'lps'),
	(642453, 136, '2015-01-01 00:42:57.000000', 'consum', 0.0309, 'lps'),
	(642454, 136, '2015-01-01 00:42:58.000000', 'consum', 0.0211, 'lps'),
	(642455, 136, '2015-01-01 00:42:59.000000', 'consum', 0.0292, 'lps'),
	(642456, 136, '2015-01-01 00:43:00.000000', 'consum', 0.0242, 'lps'),
	(642457, 136, '2015-01-01 00:43:01.000000', 'consum', 0.0252, 'lps'),
	(642458, 136, '2015-01-01 00:43:02.000000', 'consum', 0.0323, 'lps'),
	(642459, 136, '2015-01-01 00:43:03.000000', 'consum', 0.0279, 'lps'),
	(642460, 136, '2015-01-01 00:43:04.000000', 'consum', 0.0216, 'lps'),
	(642461, 136, '2015-01-01 00:43:05.000000', 'consum', 0.0282, 'lps'),
	(642462, 136, '2015-01-01 00:43:06.000000', 'consum', 0.0303, 'lps'),
	(642463, 136, '2015-01-01 00:43:07.000000', 'consum', 0.0212, 'lps'),
	(642464, 136, '2015-01-01 00:43:08.000000', 'consum', 0.0313, 'lps'),
	(642465, 136, '2015-01-01 00:43:09.000000', 'consum', 0.0224, 'lps'),
	(642466, 136, '2015-01-01 00:43:10.000000', 'consum', 0.0218, 'lps'),
	(642467, 136, '2015-01-01 00:43:11.000000', 'consum', 0.0211, 'lps'),
	(642468, 136, '2015-01-01 00:43:12.000000', 'consum', 0.0314, 'lps'),
	(642469, 136, '2015-01-01 00:43:13.000000', 'consum', 0.0233, 'lps'),
	(642470, 136, '2015-01-01 00:43:14.000000', 'consum', 0.0261, 'lps'),
	(642471, 136, '2015-01-01 00:43:15.000000', 'consum', 0.0271, 'lps'),
	(642472, 136, '2015-01-01 00:43:16.000000', 'consum', 0.0239, 'lps'),
	(642473, 136, '2015-01-01 00:43:17.000000', 'consum', 0.0298, 'lps'),
	(642474, 136, '2015-01-01 00:43:18.000000', 'consum', 0.0313, 'lps'),
	(642475, 136, '2015-01-01 00:43:19.000000', 'consum', 0.0215, 'lps'),
	(642476, 136, '2015-01-01 00:43:20.000000', 'consum', 0.0296, 'lps'),
	(642477, 136, '2015-01-01 00:43:21.000000', 'consum', 0.0257, 'lps'),
	(642478, 136, '2015-01-01 00:43:22.000000', 'consum', 0.0308, 'lps'),
	(642479, 136, '2015-01-01 00:43:23.000000', 'consum', 0.0314, 'lps'),
	(642480, 136, '2015-01-01 00:43:24.000000', 'consum', 0.0311, 'lps'),
	(642481, 136, '2015-01-01 00:43:25.000000', 'consum', 0.0280, 'lps'),
	(642482, 136, '2015-01-01 00:43:26.000000', 'consum', 0.0258, 'lps'),
	(642483, 136, '2015-01-01 00:43:27.000000', 'consum', 0.0242, 'lps'),
	(642484, 136, '2015-01-01 00:43:28.000000', 'consum', 0.0224, 'lps'),
	(642485, 136, '2015-01-01 00:43:29.000000', 'consum', 0.0311, 'lps'),
	(642486, 136, '2015-01-01 00:43:30.000000', 'consum', 0.0301, 'lps'),
	(642487, 136, '2015-01-01 00:43:31.000000', 'consum', 0.0238, 'lps'),
	(642488, 136, '2015-01-01 00:43:32.000000', 'consum', 0.0327, 'lps'),
	(642489, 136, '2015-01-01 00:43:33.000000', 'consum', 0.0214, 'lps'),
	(642490, 136, '2015-01-01 00:43:34.000000', 'consum', 0.0253, 'lps'),
	(642491, 136, '2015-01-01 00:43:35.000000', 'consum', 0.0288, 'lps'),
	(642492, 136, '2015-01-01 00:43:36.000000', 'consum', 0.0225, 'lps'),
	(642493, 136, '2015-01-01 00:43:37.000000', 'consum', 0.0298, 'lps'),
	(642494, 136, '2015-01-01 00:43:38.000000', 'consum', 0.0233, 'lps'),
	(642495, 136, '2015-01-01 00:43:39.000000', 'consum', 0.0310, 'lps'),
	(642496, 136, '2015-01-01 00:43:40.000000', 'consum', 0.0268, 'lps'),
	(642497, 136, '2015-01-01 00:43:41.000000', 'consum', 0.0324, 'lps'),
	(642498, 136, '2015-01-01 00:43:42.000000', 'consum', 0.0237, 'lps'),
	(642499, 136, '2015-01-01 00:43:43.000000', 'consum', 0.0253, 'lps'),
	(642500, 136, '2015-01-01 00:43:44.000000', 'consum', 0.0217, 'lps'),
	(642501, 136, '2015-01-01 00:43:45.000000', 'consum', 0.0244, 'lps'),
	(642502, 136, '2015-01-01 00:43:46.000000', 'consum', 0.0232, 'lps'),
	(642503, 136, '2015-01-01 00:43:47.000000', 'consum', 0.0219, 'lps'),
	(642504, 136, '2015-01-01 00:43:48.000000', 'consum', 0.0314, 'lps'),
	(642505, 136, '2015-01-01 00:43:49.000000', 'consum', 0.0333, 'lps'),
	(642506, 136, '2015-01-01 00:43:50.000000', 'consum', 0.0266, 'lps'),
	(642507, 136, '2015-01-01 00:43:51.000000', 'consum', 0.0246, 'lps'),
	(642508, 136, '2015-01-01 00:43:52.000000', 'consum', 0.0221, 'lps'),
	(642509, 136, '2015-01-01 00:43:53.000000', 'consum', 0.0282, 'lps'),
	(642510, 136, '2015-01-01 00:43:54.000000', 'consum', 0.0288, 'lps'),
	(642511, 136, '2015-01-01 00:43:55.000000', 'consum', 0.0263, 'lps'),
	(642512, 136, '2015-01-01 00:43:56.000000', 'consum', 0.0241, 'lps'),
	(642513, 136, '2015-01-01 00:43:57.000000', 'consum', 0.0331, 'lps'),
	(642514, 136, '2015-01-01 00:43:58.000000', 'consum', 0.0226, 'lps'),
	(642515, 136, '2015-01-01 00:43:59.000000', 'consum', 0.0297, 'lps'),
	(642516, 136, '2015-01-01 00:44:00.000000', 'consum', 0.0228, 'lps'),
	(642517, 136, '2015-01-01 00:44:01.000000', 'consum', 0.0288, 'lps'),
	(642518, 136, '2015-01-01 00:44:02.000000', 'consum', 0.0299, 'lps'),
	(642519, 136, '2015-01-01 00:44:03.000000', 'consum', 0.0297, 'lps'),
	(642520, 136, '2015-01-01 00:44:04.000000', 'consum', 0.0253, 'lps'),
	(642521, 136, '2015-01-01 00:44:05.000000', 'consum', 0.0289, 'lps'),
	(642522, 136, '2015-01-01 00:44:06.000000', 'consum', 0.0230, 'lps'),
	(642523, 136, '2015-01-01 00:44:07.000000', 'consum', 0.0320, 'lps'),
	(642524, 136, '2015-01-01 00:44:08.000000', 'consum', 0.0328, 'lps'),
	(642525, 136, '2015-01-01 00:44:09.000000', 'consum', 0.0221, 'lps'),
	(642526, 136, '2015-01-01 00:44:10.000000', 'consum', 0.0287, 'lps'),
	(642527, 136, '2015-01-01 00:44:11.000000', 'consum', 0.0311, 'lps'),
	(642528, 136, '2015-01-01 00:44:12.000000', 'consum', 0.0239, 'lps'),
	(642529, 136, '2015-01-01 00:44:13.000000', 'consum', 0.0301, 'lps'),
	(642530, 136, '2015-01-01 00:44:14.000000', 'consum', 0.0330, 'lps'),
	(642531, 136, '2015-01-01 00:44:15.000000', 'consum', 0.0289, 'lps'),
	(642532, 136, '2015-01-01 00:44:16.000000', 'consum', 0.0246, 'lps'),
	(642533, 136, '2015-01-01 00:44:17.000000', 'consum', 0.0277, 'lps'),
	(642534, 136, '2015-01-01 00:44:18.000000', 'consum', 0.0312, 'lps'),
	(642535, 136, '2015-01-01 00:44:19.000000', 'consum', 0.0271, 'lps'),
	(642536, 136, '2015-01-01 00:44:20.000000', 'consum', 0.0211, 'lps'),
	(642537, 136, '2015-01-01 00:44:21.000000', 'consum', 0.0280, 'lps'),
	(642538, 136, '2015-01-01 00:44:22.000000', 'consum', 0.0312, 'lps'),
	(642539, 136, '2015-01-01 00:44:23.000000', 'consum', 0.0259, 'lps'),
	(642540, 136, '2015-01-01 00:44:24.000000', 'consum', 0.0274, 'lps'),
	(642541, 136, '2015-01-01 00:44:25.000000', 'consum', 0.0259, 'lps'),
	(642542, 136, '2015-01-01 00:44:26.000000', 'consum', 0.0266, 'lps'),
	(642543, 136, '2015-01-01 00:44:27.000000', 'consum', 0.0218, 'lps'),
	(642544, 136, '2015-01-01 00:44:28.000000', 'consum', 0.0330, 'lps'),
	(642545, 136, '2015-01-01 00:44:29.000000', 'consum', 0.0292, 'lps'),
	(642546, 136, '2015-01-01 00:44:30.000000', 'consum', 0.0260, 'lps'),
	(642547, 136, '2015-01-01 00:44:31.000000', 'consum', 0.0212, 'lps'),
	(642548, 136, '2015-01-01 00:44:32.000000', 'consum', 0.0321, 'lps'),
	(642549, 136, '2015-01-01 00:44:33.000000', 'consum', 0.0263, 'lps'),
	(642550, 136, '2015-01-01 00:44:34.000000', 'consum', 0.0267, 'lps'),
	(642551, 136, '2015-01-01 00:44:35.000000', 'consum', 0.0213, 'lps'),
	(642552, 136, '2015-01-01 00:44:36.000000', 'consum', 0.0303, 'lps'),
	(642553, 136, '2015-01-01 00:44:37.000000', 'consum', 0.0295, 'lps'),
	(642554, 136, '2015-01-01 00:44:38.000000', 'consum', 0.0233, 'lps'),
	(642555, 136, '2015-01-01 00:44:39.000000', 'consum', 0.0316, 'lps'),
	(642556, 136, '2015-01-01 00:44:40.000000', 'consum', 0.0299, 'lps'),
	(642557, 136, '2015-01-01 00:44:41.000000', 'consum', 0.0214, 'lps'),
	(642558, 136, '2015-01-01 00:44:42.000000', 'consum', 0.0213, 'lps'),
	(642559, 136, '2015-01-01 00:44:43.000000', 'consum', 0.0214, 'lps'),
	(642560, 136, '2015-01-01 00:44:44.000000', 'consum', 0.0219, 'lps'),
	(642561, 136, '2015-01-01 00:44:45.000000', 'consum', 0.0247, 'lps'),
	(642562, 136, '2015-01-01 00:44:46.000000', 'consum', 0.0241, 'lps'),
	(642563, 136, '2015-01-01 00:44:47.000000', 'consum', 0.0257, 'lps'),
	(642564, 136, '2015-01-01 00:44:48.000000', 'consum', 0.0230, 'lps'),
	(642565, 136, '2015-01-01 00:44:49.000000', 'consum', 0.0290, 'lps'),
	(642566, 136, '2015-01-01 00:44:50.000000', 'consum', 0.0303, 'lps'),
	(642567, 136, '2015-01-01 00:44:51.000000', 'consum', 0.0314, 'lps'),
	(642568, 136, '2015-01-01 00:44:52.000000', 'consum', 0.0326, 'lps'),
	(642569, 136, '2015-01-01 00:44:53.000000', 'consum', 0.0229, 'lps'),
	(642570, 136, '2015-01-01 00:44:54.000000', 'consum', 0.0329, 'lps'),
	(642571, 136, '2015-01-01 00:44:55.000000', 'consum', 0.0253, 'lps'),
	(642572, 136, '2015-01-01 00:44:56.000000', 'consum', 0.0317, 'lps'),
	(642573, 136, '2015-01-01 00:44:57.000000', 'consum', 0.0244, 'lps'),
	(642574, 136, '2015-01-01 00:44:58.000000', 'consum', 0.0309, 'lps'),
	(642575, 136, '2015-01-01 00:44:59.000000', 'consum', 0.0230, 'lps'),
	(642576, 136, '2015-01-01 00:45:00.000000', 'consum', 0.0262, 'lps'),
	(642577, 136, '2015-01-01 00:45:01.000000', 'consum', 0.0287, 'lps'),
	(642578, 136, '2015-01-01 00:45:02.000000', 'consum', 0.0314, 'lps'),
	(642579, 136, '2015-01-01 00:45:03.000000', 'consum', 0.0251, 'lps'),
	(642580, 136, '2015-01-01 00:45:04.000000', 'consum', 0.0227, 'lps'),
	(642581, 136, '2015-01-01 00:45:05.000000', 'consum', 0.0298, 'lps'),
	(642582, 136, '2015-01-01 00:45:06.000000', 'consum', 0.0227, 'lps'),
	(642583, 136, '2015-01-01 00:45:07.000000', 'consum', 0.0282, 'lps'),
	(642584, 136, '2015-01-01 00:45:08.000000', 'consum', 0.0268, 'lps'),
	(642585, 136, '2015-01-01 00:45:09.000000', 'consum', 0.0286, 'lps'),
	(642586, 136, '2015-01-01 00:45:10.000000', 'consum', 0.0292, 'lps'),
	(642587, 136, '2015-01-01 00:45:11.000000', 'consum', 0.0269, 'lps'),
	(642588, 136, '2015-01-01 00:45:12.000000', 'consum', 0.0258, 'lps'),
	(642589, 136, '2015-01-01 00:45:13.000000', 'consum', 0.0275, 'lps'),
	(642590, 136, '2015-01-01 00:45:14.000000', 'consum', 0.0266, 'lps'),
	(642591, 136, '2015-01-01 00:45:15.000000', 'consum', 0.0297, 'lps'),
	(642592, 136, '2015-01-01 00:45:16.000000', 'consum', 0.0227, 'lps'),
	(642593, 136, '2015-01-01 00:45:17.000000', 'consum', 0.0285, 'lps'),
	(642594, 136, '2015-01-01 00:45:18.000000', 'consum', 0.0286, 'lps'),
	(642595, 136, '2015-01-01 00:45:19.000000', 'consum', 0.0243, 'lps'),
	(642596, 136, '2015-01-01 00:45:20.000000', 'consum', 0.0271, 'lps'),
	(642597, 136, '2015-01-01 00:45:21.000000', 'consum', 0.0293, 'lps'),
	(642598, 136, '2015-01-01 00:45:22.000000', 'consum', 0.0318, 'lps'),
	(642599, 136, '2015-01-01 00:45:23.000000', 'consum', 0.0252, 'lps'),
	(642600, 136, '2015-01-01 00:45:24.000000', 'consum', 0.0222, 'lps'),
	(642601, 136, '2015-01-01 00:45:25.000000', 'consum', 0.0266, 'lps'),
	(642602, 136, '2015-01-01 00:45:26.000000', 'consum', 0.0332, 'lps'),
	(642603, 136, '2015-01-01 00:45:27.000000', 'consum', 0.0280, 'lps'),
	(642604, 136, '2015-01-01 00:45:28.000000', 'consum', 0.0320, 'lps'),
	(642605, 136, '2015-01-01 00:45:29.000000', 'consum', 0.0303, 'lps'),
	(642606, 136, '2015-01-01 00:45:30.000000', 'consum', 0.0222, 'lps'),
	(642607, 136, '2015-01-01 00:45:31.000000', 'consum', 0.0237, 'lps'),
	(642608, 136, '2015-01-01 00:45:32.000000', 'consum', 0.0312, 'lps'),
	(642609, 136, '2015-01-01 00:45:33.000000', 'consum', 0.0266, 'lps'),
	(642610, 136, '2015-01-01 00:45:34.000000', 'consum', 0.0311, 'lps'),
	(642611, 136, '2015-01-01 00:45:35.000000', 'consum', 0.0297, 'lps'),
	(642612, 136, '2015-01-01 00:45:36.000000', 'consum', 0.0218, 'lps'),
	(642613, 136, '2015-01-01 00:45:37.000000', 'consum', 0.0238, 'lps'),
	(642614, 136, '2015-01-01 00:45:38.000000', 'consum', 0.0325, 'lps'),
	(642615, 136, '2015-01-01 00:45:39.000000', 'consum', 0.0329, 'lps'),
	(642616, 136, '2015-01-01 00:45:40.000000', 'consum', 0.0216, 'lps'),
	(642617, 136, '2015-01-01 00:45:41.000000', 'consum', 0.0252, 'lps'),
	(642618, 136, '2015-01-01 00:45:42.000000', 'consum', 0.0280, 'lps'),
	(642619, 136, '2015-01-01 00:45:43.000000', 'consum', 0.0309, 'lps'),
	(642620, 136, '2015-01-01 00:45:44.000000', 'consum', 0.0249, 'lps'),
	(642621, 136, '2015-01-01 00:45:45.000000', 'consum', 0.0230, 'lps'),
	(642622, 136, '2015-01-01 00:45:46.000000', 'consum', 0.0320, 'lps'),
	(642623, 136, '2015-01-01 00:45:47.000000', 'consum', 0.0329, 'lps'),
	(642624, 136, '2015-01-01 00:45:48.000000', 'consum', 0.0228, 'lps'),
	(642625, 136, '2015-01-01 00:45:49.000000', 'consum', 0.0314, 'lps'),
	(642626, 136, '2015-01-01 00:45:50.000000', 'consum', 0.0304, 'lps'),
	(642627, 136, '2015-01-01 00:45:51.000000', 'consum', 0.0243, 'lps'),
	(642628, 136, '2015-01-01 00:45:52.000000', 'consum', 0.0219, 'lps'),
	(642629, 136, '2015-01-01 00:45:53.000000', 'consum', 0.0282, 'lps'),
	(642630, 136, '2015-01-01 00:45:54.000000', 'consum', 0.0293, 'lps'),
	(642631, 136, '2015-01-01 00:45:55.000000', 'consum', 0.0288, 'lps'),
	(642632, 136, '2015-01-01 00:45:56.000000', 'consum', 0.0228, 'lps'),
	(642633, 136, '2015-01-01 00:45:57.000000', 'consum', 0.0315, 'lps'),
	(642634, 136, '2015-01-01 00:45:58.000000', 'consum', 0.0310, 'lps'),
	(642635, 136, '2015-01-01 00:45:59.000000', 'consum', 0.0272, 'lps'),
	(642636, 136, '2015-01-01 00:46:00.000000', 'consum', 0.0218, 'lps'),
	(642637, 136, '2015-01-01 00:46:01.000000', 'consum', 0.0314, 'lps'),
	(642638, 136, '2015-01-01 00:46:02.000000', 'consum', 0.0211, 'lps'),
	(642639, 136, '2015-01-01 00:46:03.000000', 'consum', 0.0275, 'lps'),
	(642640, 136, '2015-01-01 00:46:04.000000', 'consum', 0.0285, 'lps'),
	(642641, 136, '2015-01-01 00:46:05.000000', 'consum', 0.0268, 'lps'),
	(642642, 136, '2015-01-01 00:46:06.000000', 'consum', 0.0273, 'lps'),
	(642643, 136, '2015-01-01 00:46:07.000000', 'consum', 0.0228, 'lps'),
	(642644, 136, '2015-01-01 00:46:08.000000', 'consum', 0.0237, 'lps'),
	(642645, 136, '2015-01-01 00:46:09.000000', 'consum', 0.0289, 'lps'),
	(642646, 136, '2015-01-01 00:46:10.000000', 'consum', 0.0277, 'lps'),
	(642647, 136, '2015-01-01 00:46:11.000000', 'consum', 0.0310, 'lps'),
	(642648, 136, '2015-01-01 00:46:12.000000', 'consum', 0.0262, 'lps'),
	(642649, 136, '2015-01-01 00:46:13.000000', 'consum', 0.0294, 'lps'),
	(642650, 136, '2015-01-01 00:46:14.000000', 'consum', 0.0227, 'lps'),
	(642651, 136, '2015-01-01 00:46:15.000000', 'consum', 0.0293, 'lps'),
	(642652, 136, '2015-01-01 00:46:16.000000', 'consum', 0.0324, 'lps'),
	(642653, 136, '2015-01-01 00:46:17.000000', 'consum', 0.0283, 'lps'),
	(642654, 136, '2015-01-01 00:46:18.000000', 'consum', 0.0235, 'lps'),
	(642655, 136, '2015-01-01 00:46:19.000000', 'consum', 0.0242, 'lps'),
	(642656, 136, '2015-01-01 00:46:20.000000', 'consum', 0.0294, 'lps'),
	(642657, 136, '2015-01-01 00:46:21.000000', 'consum', 0.0288, 'lps'),
	(642658, 136, '2015-01-01 00:46:22.000000', 'consum', 0.0224, 'lps'),
	(642659, 136, '2015-01-01 00:46:23.000000', 'consum', 0.0293, 'lps'),
	(642660, 136, '2015-01-01 00:46:24.000000', 'consum', 0.0214, 'lps'),
	(642661, 136, '2015-01-01 00:46:25.000000', 'consum', 0.0226, 'lps'),
	(642662, 136, '2015-01-01 00:46:26.000000', 'consum', 0.0282, 'lps'),
	(642663, 136, '2015-01-01 00:46:27.000000', 'consum', 0.0273, 'lps'),
	(642664, 136, '2015-01-01 00:46:28.000000', 'consum', 0.0308, 'lps'),
	(642665, 136, '2015-01-01 00:46:29.000000', 'consum', 0.0265, 'lps'),
	(642666, 136, '2015-01-01 00:46:30.000000', 'consum', 0.0317, 'lps'),
	(642667, 136, '2015-01-01 00:46:31.000000', 'consum', 0.0333, 'lps'),
	(642668, 136, '2015-01-01 00:46:32.000000', 'consum', 0.0254, 'lps'),
	(642669, 136, '2015-01-01 00:46:33.000000', 'consum', 0.0311, 'lps'),
	(642670, 136, '2015-01-01 00:46:34.000000', 'consum', 0.0212, 'lps'),
	(642671, 136, '2015-01-01 00:46:35.000000', 'consum', 0.0288, 'lps'),
	(642672, 136, '2015-01-01 00:46:36.000000', 'consum', 0.0224, 'lps'),
	(642673, 136, '2015-01-01 00:46:37.000000', 'consum', 0.0293, 'lps'),
	(642674, 136, '2015-01-01 00:46:38.000000', 'consum', 0.0214, 'lps'),
	(642675, 136, '2015-01-01 00:46:39.000000', 'consum', 0.0226, 'lps'),
	(642676, 136, '2015-01-01 00:46:40.000000', 'consum', 0.0281, 'lps'),
	(642677, 136, '2015-01-01 00:46:41.000000', 'consum', 0.0267, 'lps'),
	(642678, 136, '2015-01-01 00:46:42.000000', 'consum', 0.0283, 'lps'),
	(642679, 136, '2015-01-01 00:46:43.000000', 'consum', 0.0279, 'lps'),
	(642680, 136, '2015-01-01 00:46:44.000000', 'consum', 0.0215, 'lps'),
	(642681, 136, '2015-01-01 00:46:45.000000', 'consum', 0.0276, 'lps'),
	(642682, 136, '2015-01-01 00:46:46.000000', 'consum', 0.0276, 'lps'),
	(642683, 136, '2015-01-01 00:46:47.000000', 'consum', 0.0217, 'lps'),
	(642684, 136, '2015-01-01 00:46:48.000000', 'consum', 0.0299, 'lps'),
	(642685, 136, '2015-01-01 00:46:49.000000', 'consum', 0.0263, 'lps'),
	(642686, 136, '2015-01-01 00:46:50.000000', 'consum', 0.0330, 'lps'),
	(642687, 136, '2015-01-01 00:46:51.000000', 'consum', 0.0279, 'lps'),
	(642688, 136, '2015-01-01 00:46:52.000000', 'consum', 0.0319, 'lps'),
	(642689, 136, '2015-01-01 00:46:53.000000', 'consum', 0.0301, 'lps'),
	(642690, 136, '2015-01-01 00:46:54.000000', 'consum', 0.0214, 'lps'),
	(642691, 136, '2015-01-01 00:46:55.000000', 'consum', 0.0329, 'lps'),
	(642692, 136, '2015-01-01 00:46:56.000000', 'consum', 0.0300, 'lps'),
	(642693, 136, '2015-01-01 00:46:57.000000', 'consum', 0.0301, 'lps'),
	(642694, 136, '2015-01-01 00:46:58.000000', 'consum', 0.0270, 'lps'),
	(642695, 136, '2015-01-01 00:46:59.000000', 'consum', 0.0241, 'lps'),
	(642696, 136, '2015-01-01 00:47:00.000000', 'consum', 0.0309, 'lps'),
	(642697, 136, '2015-01-01 00:47:01.000000', 'consum', 0.0240, 'lps'),
	(642698, 136, '2015-01-01 00:47:02.000000', 'consum', 0.0310, 'lps'),
	(642699, 136, '2015-01-01 00:47:03.000000', 'consum', 0.0251, 'lps'),
	(642700, 136, '2015-01-01 00:47:04.000000', 'consum', 0.0238, 'lps'),
	(642701, 136, '2015-01-01 00:47:05.000000', 'consum', 0.0227, 'lps'),
	(642702, 136, '2015-01-01 00:47:06.000000', 'consum', 0.0213, 'lps'),
	(642703, 136, '2015-01-01 00:47:07.000000', 'consum', 0.0297, 'lps'),
	(642704, 136, '2015-01-01 00:47:08.000000', 'consum', 0.0267, 'lps'),
	(642705, 136, '2015-01-01 00:47:09.000000', 'consum', 0.0233, 'lps'),
	(642706, 136, '2015-01-01 00:47:10.000000', 'consum', 0.0280, 'lps'),
	(642707, 136, '2015-01-01 00:47:11.000000', 'consum', 0.0242, 'lps'),
	(642708, 136, '2015-01-01 00:47:12.000000', 'consum', 0.0285, 'lps'),
	(642709, 136, '2015-01-01 00:47:13.000000', 'consum', 0.0241, 'lps'),
	(642710, 136, '2015-01-01 00:47:14.000000', 'consum', 0.0266, 'lps'),
	(642711, 136, '2015-01-01 00:47:15.000000', 'consum', 0.0272, 'lps'),
	(642712, 136, '2015-01-01 00:47:16.000000', 'consum', 0.0227, 'lps'),
	(642713, 136, '2015-01-01 00:47:17.000000', 'consum', 0.0236, 'lps'),
	(642714, 136, '2015-01-01 00:47:18.000000', 'consum', 0.0290, 'lps'),
	(642715, 136, '2015-01-01 00:47:19.000000', 'consum', 0.0283, 'lps'),
	(642716, 136, '2015-01-01 00:47:20.000000', 'consum', 0.0211, 'lps'),
	(642717, 136, '2015-01-01 00:47:21.000000', 'consum', 0.0245, 'lps'),
	(642718, 136, '2015-01-01 00:47:22.000000', 'consum', 0.0261, 'lps'),
	(642719, 136, '2015-01-01 00:47:23.000000', 'consum', 0.0233, 'lps'),
	(642720, 136, '2015-01-01 00:47:24.000000', 'consum', 0.0297, 'lps'),
	(642721, 136, '2015-01-01 00:47:25.000000', 'consum', 0.0330, 'lps'),
	(642722, 136, '2015-01-01 00:47:26.000000', 'consum', 0.0302, 'lps'),
	(642723, 136, '2015-01-01 00:47:27.000000', 'consum', 0.0311, 'lps'),
	(642724, 136, '2015-01-01 00:47:28.000000', 'consum', 0.0314, 'lps'),
	(642725, 136, '2015-01-01 00:47:29.000000', 'consum', 0.0304, 'lps'),
	(642726, 136, '2015-01-01 00:47:30.000000', 'consum', 0.0246, 'lps'),
	(642727, 136, '2015-01-01 00:47:31.000000', 'consum', 0.0230, 'lps'),
	(642728, 136, '2015-01-01 00:47:32.000000', 'consum', 0.0325, 'lps'),
	(642729, 136, '2015-01-01 00:47:33.000000', 'consum', 0.0233, 'lps'),
	(642730, 136, '2015-01-01 00:47:34.000000', 'consum', 0.0227, 'lps'),
	(642731, 136, '2015-01-01 00:47:35.000000', 'consum', 0.0228, 'lps'),
	(642732, 136, '2015-01-01 00:47:36.000000', 'consum', 0.0248, 'lps'),
	(642733, 136, '2015-01-01 00:47:37.000000', 'consum', 0.0222, 'lps'),
	(642734, 136, '2015-01-01 00:47:38.000000', 'consum', 0.0280, 'lps'),
	(642735, 136, '2015-01-01 00:47:39.000000', 'consum', 0.0279, 'lps'),
	(642736, 136, '2015-01-01 00:47:40.000000', 'consum', 0.0219, 'lps'),
	(642737, 136, '2015-01-01 00:47:41.000000', 'consum', 0.0297, 'lps'),
	(642738, 136, '2015-01-01 00:47:42.000000', 'consum', 0.0246, 'lps'),
	(642739, 136, '2015-01-01 00:47:43.000000', 'consum', 0.0255, 'lps'),
	(642740, 136, '2015-01-01 00:47:44.000000', 'consum', 0.0325, 'lps'),
	(642741, 136, '2015-01-01 00:47:45.000000', 'consum', 0.0279, 'lps'),
	(642742, 136, '2015-01-01 00:47:46.000000', 'consum', 0.0333, 'lps'),
	(642743, 136, '2015-01-01 00:47:47.000000', 'consum', 0.0250, 'lps'),
	(642744, 136, '2015-01-01 00:47:48.000000', 'consum', 0.0288, 'lps'),
	(642745, 136, '2015-01-01 00:47:49.000000', 'consum', 0.0231, 'lps'),
	(642746, 136, '2015-01-01 00:47:50.000000', 'consum', 0.0330, 'lps'),
	(642747, 136, '2015-01-01 00:47:51.000000', 'consum', 0.0251, 'lps'),
	(642748, 136, '2015-01-01 00:47:52.000000', 'consum', 0.0306, 'lps'),
	(642749, 136, '2015-01-01 00:47:53.000000', 'consum', 0.0319, 'lps'),
	(642750, 136, '2015-01-01 00:47:54.000000', 'consum', 0.0221, 'lps'),
	(642751, 136, '2015-01-01 00:47:55.000000', 'consum', 0.0307, 'lps'),
	(642752, 136, '2015-01-01 00:47:56.000000', 'consum', 0.0292, 'lps'),
	(642753, 136, '2015-01-01 00:47:57.000000', 'consum', 0.0330, 'lps'),
	(642754, 136, '2015-01-01 00:47:58.000000', 'consum', 0.0317, 'lps'),
	(642755, 136, '2015-01-01 00:47:59.000000', 'consum', 0.0260, 'lps'),
	(642756, 136, '2015-01-01 00:48:00.000000', 'consum', 0.0263, 'lps'),
	(642757, 136, '2015-01-01 00:48:01.000000', 'consum', 0.0328, 'lps'),
	(642758, 136, '2015-01-01 00:48:02.000000', 'consum', 0.0267, 'lps'),
	(642759, 136, '2015-01-01 00:48:03.000000', 'consum', 0.0265, 'lps'),
	(642760, 136, '2015-01-01 00:48:04.000000', 'consum', 0.0314, 'lps'),
	(642761, 136, '2015-01-01 00:48:05.000000', 'consum', 0.0321, 'lps'),
	(642762, 136, '2015-01-01 00:48:06.000000', 'consum', 0.0326, 'lps'),
	(642763, 136, '2015-01-01 00:48:07.000000', 'consum', 0.0211, 'lps'),
	(642764, 136, '2015-01-01 00:48:08.000000', 'consum', 0.0239, 'lps'),
	(642765, 136, '2015-01-01 00:48:09.000000', 'consum', 0.0228, 'lps'),
	(642766, 136, '2015-01-01 00:48:10.000000', 'consum', 0.0214, 'lps'),
	(642767, 136, '2015-01-01 00:48:11.000000', 'consum', 0.0301, 'lps'),
	(642768, 136, '2015-01-01 00:48:12.000000', 'consum', 0.0282, 'lps'),
	(642769, 136, '2015-01-01 00:48:13.000000', 'consum', 0.0296, 'lps'),
	(642770, 136, '2015-01-01 00:48:14.000000', 'consum', 0.0299, 'lps'),
	(642771, 136, '2015-01-01 00:48:15.000000', 'consum', 0.0276, 'lps'),
	(642772, 136, '2015-01-01 00:48:16.000000', 'consum', 0.0271, 'lps'),
	(642773, 136, '2015-01-01 00:48:17.000000', 'consum', 0.0318, 'lps'),
	(642774, 136, '2015-01-01 00:48:18.000000', 'consum', 0.0319, 'lps'),
	(642775, 136, '2015-01-01 00:48:19.000000', 'consum', 0.0307, 'lps'),
	(642776, 136, '2015-01-01 00:48:20.000000', 'consum', 0.0247, 'lps'),
	(642777, 136, '2015-01-01 00:48:21.000000', 'consum', 0.0228, 'lps'),
	(642778, 136, '2015-01-01 00:48:22.000000', 'consum', 0.0313, 'lps'),
	(642779, 136, '2015-01-01 00:48:23.000000', 'consum', 0.0299, 'lps'),
	(642780, 136, '2015-01-01 00:48:24.000000', 'consum', 0.0222, 'lps'),
	(642781, 136, '2015-01-01 00:48:25.000000', 'consum', 0.0250, 'lps'),
	(642782, 136, '2015-01-01 00:48:26.000000', 'consum', 0.0254, 'lps'),
	(642783, 136, '2015-01-01 00:48:27.000000', 'consum', 0.0307, 'lps'),
	(642784, 136, '2015-01-01 00:48:28.000000', 'consum', 0.0318, 'lps'),
	(642785, 136, '2015-01-01 00:48:29.000000', 'consum', 0.0210, 'lps'),
	(642786, 136, '2015-01-01 00:48:30.000000', 'consum', 0.0261, 'lps'),
	(642787, 136, '2015-01-01 00:48:31.000000', 'consum', 0.0215, 'lps'),
	(642788, 136, '2015-01-01 00:48:32.000000', 'consum', 0.0330, 'lps'),
	(642789, 136, '2015-01-01 00:48:33.000000', 'consum', 0.0302, 'lps'),
	(642790, 136, '2015-01-01 00:48:34.000000', 'consum', 0.0308, 'lps'),
	(642791, 136, '2015-01-01 00:48:35.000000', 'consum', 0.0301, 'lps'),
	(642792, 136, '2015-01-01 00:48:36.000000', 'consum', 0.0249, 'lps'),
	(642793, 136, '2015-01-01 00:48:37.000000', 'consum', 0.0257, 'lps'),
	(642794, 136, '2015-01-01 00:48:38.000000', 'consum', 0.0328, 'lps'),
	(642795, 136, '2015-01-01 00:48:39.000000', 'consum', 0.0288, 'lps'),
	(642796, 136, '2015-01-01 00:48:40.000000', 'consum', 0.0245, 'lps'),
	(642797, 136, '2015-01-01 00:48:41.000000', 'consum', 0.0276, 'lps'),
	(642798, 136, '2015-01-01 00:48:42.000000', 'consum', 0.0311, 'lps'),
	(642799, 136, '2015-01-01 00:48:43.000000', 'consum', 0.0270, 'lps'),
	(642800, 136, '2015-01-01 00:48:44.000000', 'consum', 0.0332, 'lps'),
	(642801, 136, '2015-01-01 00:48:45.000000', 'consum', 0.0268, 'lps'),
	(642802, 136, '2015-01-01 00:48:46.000000', 'consum', 0.0260, 'lps'),
	(642803, 136, '2015-01-01 00:48:47.000000', 'consum', 0.0284, 'lps'),
	(642804, 136, '2015-01-01 00:48:48.000000', 'consum', 0.0307, 'lps'),
	(642805, 136, '2015-01-01 00:48:49.000000', 'consum', 0.0225, 'lps'),
	(642806, 136, '2015-01-01 00:48:50.000000', 'consum', 0.0242, 'lps'),
	(642807, 136, '2015-01-01 00:48:51.000000', 'consum', 0.0326, 'lps'),
	(642808, 136, '2015-01-01 00:48:52.000000', 'consum', 0.0322, 'lps'),
	(642809, 136, '2015-01-01 00:48:53.000000', 'consum', 0.0297, 'lps'),
	(642810, 136, '2015-01-01 00:48:54.000000', 'consum', 0.0313, 'lps'),
	(642811, 136, '2015-01-01 00:48:55.000000', 'consum', 0.0214, 'lps'),
	(642812, 136, '2015-01-01 00:48:56.000000', 'consum', 0.0293, 'lps'),
	(642813, 136, '2015-01-01 00:48:57.000000', 'consum', 0.0244, 'lps'),
	(642814, 136, '2015-01-01 00:48:58.000000', 'consum', 0.0254, 'lps'),
	(642815, 136, '2015-01-01 00:48:59.000000', 'consum', 0.0330, 'lps'),
	(642816, 136, '2015-01-01 00:49:00.000000', 'consum', 0.0305, 'lps'),
	(642817, 136, '2015-01-01 00:49:01.000000', 'consum', 0.0327, 'lps'),
	(642818, 136, '2015-01-01 00:49:02.000000', 'consum', 0.0261, 'lps'),
	(642819, 136, '2015-01-01 00:49:03.000000', 'consum', 0.0240, 'lps'),
	(642820, 136, '2015-01-01 00:49:04.000000', 'consum', 0.0331, 'lps'),
	(642821, 136, '2015-01-01 00:49:05.000000', 'consum', 0.0229, 'lps'),
	(642822, 136, '2015-01-01 00:49:06.000000', 'consum', 0.0315, 'lps'),
	(642823, 136, '2015-01-01 00:49:07.000000', 'consum', 0.0308, 'lps'),
	(642824, 136, '2015-01-01 00:49:08.000000', 'consum', 0.0260, 'lps'),
	(642825, 136, '2015-01-01 00:49:09.000000', 'consum', 0.0290, 'lps'),
	(642826, 136, '2015-01-01 00:49:10.000000', 'consum', 0.0214, 'lps'),
	(642827, 136, '2015-01-01 00:49:11.000000', 'consum', 0.0237, 'lps'),
	(642828, 136, '2015-01-01 00:49:12.000000', 'consum', 0.0210, 'lps'),
	(642829, 136, '2015-01-01 00:49:13.000000', 'consum', 0.0254, 'lps'),
	(642830, 136, '2015-01-01 00:49:14.000000', 'consum', 0.0306, 'lps'),
	(642831, 136, '2015-01-01 00:49:15.000000', 'consum', 0.0310, 'lps'),
	(642832, 136, '2015-01-01 00:49:16.000000', 'consum', 0.0297, 'lps'),
	(642833, 136, '2015-01-01 00:49:17.000000', 'consum', 0.0224, 'lps'),
	(642834, 136, '2015-01-01 00:49:18.000000', 'consum', 0.0265, 'lps'),
	(642835, 136, '2015-01-01 00:49:19.000000', 'consum', 0.0320, 'lps'),
	(642836, 136, '2015-01-01 00:49:20.000000', 'consum', 0.0226, 'lps'),
	(642837, 136, '2015-01-01 00:49:21.000000', 'consum', 0.0329, 'lps'),
	(642838, 136, '2015-01-01 00:49:22.000000', 'consum', 0.0263, 'lps'),
	(642839, 136, '2015-01-01 00:49:23.000000', 'consum', 0.0243, 'lps'),
	(642840, 136, '2015-01-01 00:49:24.000000', 'consum', 0.0218, 'lps'),
	(642841, 136, '2015-01-01 00:49:25.000000', 'consum', 0.0273, 'lps'),
	(642842, 136, '2015-01-01 00:49:26.000000', 'consum', 0.0254, 'lps'),
	(642843, 136, '2015-01-01 00:49:27.000000', 'consum', 0.0242, 'lps'),
	(642844, 136, '2015-01-01 00:49:28.000000', 'consum', 0.0236, 'lps'),
	(642845, 136, '2015-01-01 00:49:29.000000', 'consum', 0.0248, 'lps'),
	(642846, 136, '2015-01-01 00:49:30.000000', 'consum', 0.0320, 'lps'),
	(642847, 136, '2015-01-01 00:49:31.000000', 'consum', 0.0276, 'lps'),
	(642848, 136, '2015-01-01 00:49:32.000000', 'consum', 0.0211, 'lps'),
	(642849, 136, '2015-01-01 00:49:33.000000', 'consum', 0.0267, 'lps'),
	(642850, 136, '2015-01-01 00:49:34.000000', 'consum', 0.0243, 'lps'),
	(642851, 136, '2015-01-01 00:49:35.000000', 'consum', 0.0327, 'lps'),
	(642852, 136, '2015-01-01 00:49:36.000000', 'consum', 0.0324, 'lps'),
	(642853, 136, '2015-01-01 00:49:37.000000', 'consum', 0.0308, 'lps'),
	(642854, 136, '2015-01-01 00:49:38.000000', 'consum', 0.0232, 'lps'),
	(642855, 136, '2015-01-01 00:49:39.000000', 'consum', 0.0277, 'lps'),
	(642856, 136, '2015-01-01 00:49:40.000000', 'consum', 0.0231, 'lps'),
	(642857, 136, '2015-01-01 00:49:41.000000', 'consum', 0.0238, 'lps'),
	(642858, 136, '2015-01-01 00:49:42.000000', 'consum', 0.0286, 'lps'),
	(642859, 136, '2015-01-01 00:49:43.000000', 'consum', 0.0258, 'lps'),
	(642860, 136, '2015-01-01 00:49:44.000000', 'consum', 0.0222, 'lps'),
	(642861, 136, '2015-01-01 00:49:45.000000', 'consum', 0.0252, 'lps'),
	(642862, 136, '2015-01-01 00:49:46.000000', 'consum', 0.0261, 'lps'),
	(642863, 136, '2015-01-01 00:49:47.000000', 'consum', 0.0217, 'lps'),
	(642864, 136, '2015-01-01 00:49:48.000000', 'consum', 0.0213, 'lps'),
	(642865, 136, '2015-01-01 00:49:49.000000', 'consum', 0.0332, 'lps'),
	(642866, 136, '2015-01-01 00:49:50.000000', 'consum', 0.0312, 'lps'),
	(642867, 136, '2015-01-01 00:49:51.000000', 'consum', 0.0233, 'lps'),
	(642868, 136, '2015-01-01 00:49:52.000000', 'consum', 0.0267, 'lps'),
	(642869, 136, '2015-01-01 00:49:53.000000', 'consum', 0.0300, 'lps'),
	(642870, 136, '2015-01-01 00:49:54.000000', 'consum', 0.0244, 'lps'),
	(642871, 136, '2015-01-01 00:49:55.000000', 'consum', 0.0235, 'lps'),
	(642872, 136, '2015-01-01 00:49:56.000000', 'consum', 0.0231, 'lps'),
	(642873, 136, '2015-01-01 00:49:57.000000', 'consum', 0.0240, 'lps'),
	(642874, 136, '2015-01-01 00:49:58.000000', 'consum', 0.0299, 'lps'),
	(642875, 136, '2015-01-01 00:49:59.000000', 'consum', 0.0318, 'lps'),
	(642876, 136, '2015-01-01 00:50:00.000000', 'consum', 0.0235, 'lps'),
	(642877, 136, '2015-01-01 00:50:01.000000', 'consum', 0.0258, 'lps'),
	(642878, 136, '2015-01-01 00:50:02.000000', 'consum', 0.0252, 'lps'),
	(642879, 136, '2015-01-01 00:50:03.000000', 'consum', 0.0277, 'lps'),
	(642880, 136, '2015-01-01 00:50:04.000000', 'consum', 0.0295, 'lps'),
	(642881, 136, '2015-01-01 00:50:05.000000', 'consum', 0.0311, 'lps'),
	(642882, 136, '2015-01-01 00:50:06.000000', 'consum', 0.0213, 'lps'),
	(642883, 136, '2015-01-01 00:50:07.000000', 'consum', 0.0296, 'lps'),
	(642884, 136, '2015-01-01 00:50:08.000000', 'consum', 0.0258, 'lps'),
	(642885, 136, '2015-01-01 00:50:09.000000', 'consum', 0.0315, 'lps'),
	(642886, 136, '2015-01-01 00:50:10.000000', 'consum', 0.0221, 'lps'),
	(642887, 136, '2015-01-01 00:50:11.000000', 'consum', 0.0320, 'lps'),
	(642888, 136, '2015-01-01 00:50:12.000000', 'consum', 0.0235, 'lps'),
	(642889, 136, '2015-01-01 00:50:13.000000', 'consum', 0.0253, 'lps'),
	(642890, 136, '2015-01-01 00:50:14.000000', 'consum', 0.0225, 'lps'),
	(642891, 136, '2015-01-01 00:50:15.000000', 'consum', 0.0279, 'lps'),
	(642892, 136, '2015-01-01 00:50:16.000000', 'consum', 0.0265, 'lps'),
	(642893, 136, '2015-01-01 00:50:17.000000', 'consum', 0.0278, 'lps'),
	(642894, 136, '2015-01-01 00:50:18.000000', 'consum', 0.0261, 'lps'),
	(642895, 136, '2015-01-01 00:50:19.000000', 'consum', 0.0260, 'lps'),
	(642896, 136, '2015-01-01 00:50:20.000000', 'consum', 0.0308, 'lps'),
	(642897, 136, '2015-01-01 00:50:21.000000', 'consum', 0.0304, 'lps'),
	(642898, 136, '2015-01-01 00:50:22.000000', 'consum', 0.0261, 'lps'),
	(642899, 136, '2015-01-01 00:50:23.000000', 'consum', 0.0306, 'lps'),
	(642900, 136, '2015-01-01 00:50:24.000000', 'consum', 0.0293, 'lps'),
	(642901, 136, '2015-01-01 00:50:25.000000', 'consum', 0.0211, 'lps'),
	(642902, 136, '2015-01-01 00:50:26.000000', 'consum', 0.0216, 'lps'),
	(642903, 136, '2015-01-01 00:50:27.000000', 'consum', 0.0237, 'lps'),
	(642904, 136, '2015-01-01 00:50:28.000000', 'consum', 0.0327, 'lps'),
	(642905, 136, '2015-01-01 00:50:29.000000', 'consum', 0.0219, 'lps'),
	(642906, 136, '2015-01-01 00:50:30.000000', 'consum', 0.0276, 'lps'),
	(642907, 136, '2015-01-01 00:50:31.000000', 'consum', 0.0267, 'lps'),
	(642908, 136, '2015-01-01 00:50:32.000000', 'consum', 0.0298, 'lps'),
	(642909, 136, '2015-01-01 00:50:33.000000', 'consum', 0.0232, 'lps'),
	(642910, 136, '2015-01-01 00:50:34.000000', 'consum', 0.0303, 'lps'),
	(642911, 136, '2015-01-01 00:50:35.000000', 'consum', 0.0239, 'lps'),
	(642912, 136, '2015-01-01 00:50:36.000000', 'consum', 0.0322, 'lps'),
	(642913, 136, '2015-01-01 00:50:37.000000', 'consum', 0.0312, 'lps'),
	(642914, 136, '2015-01-01 00:50:38.000000', 'consum', 0.0260, 'lps'),
	(642915, 136, '2015-01-01 00:50:39.000000', 'consum', 0.0278, 'lps'),
	(642916, 136, '2015-01-01 00:50:40.000000', 'consum', 0.0278, 'lps'),
	(642917, 136, '2015-01-01 00:50:41.000000', 'consum', 0.0224, 'lps'),
	(642918, 136, '2015-01-01 00:50:42.000000', 'consum', 0.0321, 'lps'),
	(642919, 136, '2015-01-01 00:50:43.000000', 'consum', 0.0230, 'lps'),
	(642920, 136, '2015-01-01 00:50:44.000000', 'consum', 0.0223, 'lps'),
	(642921, 136, '2015-01-01 00:50:45.000000', 'consum', 0.0218, 'lps'),
	(642922, 136, '2015-01-01 00:50:46.000000', 'consum', 0.0212, 'lps'),
	(642923, 136, '2015-01-01 00:50:47.000000', 'consum', 0.0321, 'lps'),
	(642924, 136, '2015-01-01 00:50:48.000000', 'consum', 0.0264, 'lps'),
	(642925, 136, '2015-01-01 00:50:49.000000', 'consum', 0.0269, 'lps'),
	(642926, 136, '2015-01-01 00:50:50.000000', 'consum', 0.0220, 'lps'),
	(642927, 136, '2015-01-01 00:50:51.000000', 'consum', 0.0331, 'lps'),
	(642928, 136, '2015-01-01 00:50:52.000000', 'consum', 0.0289, 'lps'),
	(642929, 136, '2015-01-01 00:50:53.000000', 'consum', 0.0245, 'lps'),
	(642930, 136, '2015-01-01 00:50:54.000000', 'consum', 0.0270, 'lps'),
	(642931, 136, '2015-01-01 00:50:55.000000', 'consum', 0.0284, 'lps'),
	(642932, 136, '2015-01-01 00:50:56.000000', 'consum', 0.0276, 'lps'),
	(642933, 136, '2015-01-01 00:50:57.000000', 'consum', 0.0319, 'lps'),
	(642934, 136, '2015-01-01 00:50:58.000000', 'consum', 0.0308, 'lps'),
	(642935, 136, '2015-01-01 00:50:59.000000', 'consum', 0.0250, 'lps'),
	(642936, 136, '2015-01-01 00:51:00.000000', 'consum', 0.0240, 'lps'),
	(642937, 136, '2015-01-01 00:51:01.000000', 'consum', 0.0239, 'lps'),
	(642938, 136, '2015-01-01 00:51:02.000000', 'consum', 0.0267, 'lps'),
	(642939, 136, '2015-01-01 00:51:03.000000', 'consum', 0.0284, 'lps'),
	(642940, 136, '2015-01-01 00:51:04.000000', 'consum', 0.0286, 'lps'),
	(642941, 136, '2015-01-01 00:51:05.000000', 'consum', 0.0246, 'lps'),
	(642942, 136, '2015-01-01 00:51:06.000000', 'consum', 0.0287, 'lps'),
	(642943, 136, '2015-01-01 00:51:07.000000', 'consum', 0.0236, 'lps'),
	(642944, 136, '2015-01-01 00:51:08.000000', 'consum', 0.0236, 'lps'),
	(642945, 136, '2015-01-01 00:51:09.000000', 'consum', 0.0263, 'lps'),
	(642946, 136, '2015-01-01 00:51:10.000000', 'consum', 0.0272, 'lps'),
	(642947, 136, '2015-01-01 00:51:11.000000', 'consum', 0.0239, 'lps'),
	(642948, 136, '2015-01-01 00:51:12.000000', 'consum', 0.0291, 'lps'),
	(642949, 136, '2015-01-01 00:51:13.000000', 'consum', 0.0284, 'lps'),
	(642950, 136, '2015-01-01 00:51:14.000000', 'consum', 0.0210, 'lps'),
	(642951, 136, '2015-01-01 00:51:15.000000', 'consum', 0.0238, 'lps'),
	(642952, 136, '2015-01-01 00:51:16.000000', 'consum', 0.0228, 'lps'),
	(642953, 136, '2015-01-01 00:51:17.000000', 'consum', 0.0217, 'lps'),
	(642954, 136, '2015-01-01 00:51:18.000000', 'consum', 0.0313, 'lps'),
	(642955, 136, '2015-01-01 00:51:19.000000', 'consum', 0.0211, 'lps'),
	(642956, 136, '2015-01-01 00:51:20.000000', 'consum', 0.0276, 'lps'),
	(642957, 136, '2015-01-01 00:51:21.000000', 'consum', 0.0292, 'lps'),
	(642958, 136, '2015-01-01 00:51:22.000000', 'consum', 0.0297, 'lps'),
	(642959, 136, '2015-01-01 00:51:23.000000', 'consum', 0.0275, 'lps'),
	(642960, 136, '2015-01-01 00:51:24.000000', 'consum', 0.0277, 'lps'),
	(642961, 136, '2015-01-01 00:51:25.000000', 'consum', 0.0225, 'lps'),
	(642962, 136, '2015-01-01 00:51:26.000000', 'consum', 0.0331, 'lps'),
	(642963, 136, '2015-01-01 00:51:27.000000', 'consum', 0.0276, 'lps'),
	(642964, 136, '2015-01-01 00:51:28.000000', 'consum', 0.0301, 'lps'),
	(642965, 136, '2015-01-01 00:51:29.000000', 'consum', 0.0218, 'lps'),
	(642966, 136, '2015-01-01 00:51:30.000000', 'consum', 0.0225, 'lps'),
	(642967, 136, '2015-01-01 00:51:31.000000', 'consum', 0.0262, 'lps'),
	(642968, 136, '2015-01-01 00:51:32.000000', 'consum', 0.0300, 'lps'),
	(642969, 136, '2015-01-01 00:51:33.000000', 'consum', 0.0259, 'lps'),
	(642970, 136, '2015-01-01 00:51:34.000000', 'consum', 0.0309, 'lps'),
	(642971, 136, '2015-01-01 00:51:35.000000', 'consum', 0.0311, 'lps'),
	(642972, 136, '2015-01-01 00:51:36.000000', 'consum', 0.0295, 'lps'),
	(642973, 136, '2015-01-01 00:51:37.000000', 'consum', 0.0333, 'lps'),
	(642974, 136, '2015-01-01 00:51:38.000000', 'consum', 0.0321, 'lps'),
	(642975, 136, '2015-01-01 00:51:39.000000', 'consum', 0.0274, 'lps'),
	(642976, 136, '2015-01-01 00:51:40.000000', 'consum', 0.0319, 'lps'),
	(642977, 136, '2015-01-01 00:51:41.000000', 'consum', 0.0316, 'lps'),
	(642978, 136, '2015-01-01 00:51:42.000000', 'consum', 0.0288, 'lps'),
	(642979, 136, '2015-01-01 00:51:43.000000', 'consum', 0.0286, 'lps'),
	(642980, 136, '2015-01-01 00:51:44.000000', 'consum', 0.0230, 'lps'),
	(642981, 136, '2015-01-01 00:51:45.000000', 'consum', 0.0332, 'lps'),
	(642982, 136, '2015-01-01 00:51:46.000000', 'consum', 0.0265, 'lps'),
	(642983, 136, '2015-01-01 00:51:47.000000', 'consum', 0.0243, 'lps'),
	(642984, 136, '2015-01-01 00:51:48.000000', 'consum', 0.0210, 'lps'),
	(642985, 136, '2015-01-01 00:51:49.000000', 'consum', 0.0235, 'lps'),
	(642986, 136, '2015-01-01 00:51:50.000000', 'consum', 0.0212, 'lps'),
	(642987, 136, '2015-01-01 00:51:51.000000', 'consum', 0.0271, 'lps'),
	(642988, 136, '2015-01-01 00:51:52.000000', 'consum', 0.0259, 'lps'),
	(642989, 136, '2015-01-01 00:51:53.000000', 'consum', 0.0274, 'lps'),
	(642990, 136, '2015-01-01 00:51:54.000000', 'consum', 0.0261, 'lps'),
	(642991, 136, '2015-01-01 00:51:55.000000', 'consum', 0.0273, 'lps'),
	(642992, 136, '2015-01-01 00:51:56.000000', 'consum', 0.0247, 'lps'),
	(642993, 136, '2015-01-01 00:51:57.000000', 'consum', 0.0331, 'lps'),
	(642994, 136, '2015-01-01 00:51:58.000000', 'consum', 0.0210, 'lps'),
	(642995, 136, '2015-01-01 00:51:59.000000', 'consum', 0.0219, 'lps'),
	(642996, 136, '2015-01-01 00:52:00.000000', 'consum', 0.0255, 'lps'),
	(642997, 136, '2015-01-01 00:52:01.000000', 'consum', 0.0287, 'lps'),
	(642998, 136, '2015-01-01 00:52:02.000000', 'consum', 0.0333, 'lps'),
	(642999, 136, '2015-01-01 00:52:03.000000', 'consum', 0.0224, 'lps'),
	(643000, 136, '2015-01-01 00:52:04.000000', 'consum', 0.0284, 'lps'),
	(643001, 136, '2015-01-01 00:52:05.000000', 'consum', 0.0290, 'lps'),
	(643002, 136, '2015-01-01 00:52:06.000000', 'consum', 0.0265, 'lps'),
	(643003, 136, '2015-01-01 00:52:07.000000', 'consum', 0.0245, 'lps'),
	(643004, 136, '2015-01-01 00:52:08.000000', 'consum', 0.0220, 'lps'),
	(643005, 136, '2015-01-01 00:52:09.000000', 'consum', 0.0279, 'lps'),
	(643006, 136, '2015-01-01 00:52:10.000000', 'consum', 0.0278, 'lps'),
	(643007, 136, '2015-01-01 00:52:11.000000', 'consum', 0.0218, 'lps'),
	(643008, 136, '2015-01-01 00:52:12.000000', 'consum', 0.0296, 'lps'),
	(643009, 136, '2015-01-01 00:52:13.000000', 'consum', 0.0246, 'lps'),
	(643010, 136, '2015-01-01 00:52:14.000000', 'consum', 0.0256, 'lps'),
	(643011, 136, '2015-01-01 00:52:15.000000', 'consum', 0.0332, 'lps'),
	(643012, 136, '2015-01-01 00:52:16.000000', 'consum', 0.0313, 'lps'),
	(643013, 136, '2015-01-01 00:52:17.000000', 'consum', 0.0232, 'lps'),
	(643014, 136, '2015-01-01 00:52:18.000000', 'consum', 0.0261, 'lps'),
	(643015, 136, '2015-01-01 00:52:19.000000', 'consum', 0.0275, 'lps'),
	(643016, 136, '2015-01-01 00:52:20.000000', 'consum', 0.0259, 'lps'),
	(643017, 136, '2015-01-01 00:52:21.000000', 'consum', 0.0261, 'lps'),
	(643018, 136, '2015-01-01 00:52:22.000000', 'consum', 0.0318, 'lps'),
	(643019, 136, '2015-01-01 00:52:23.000000', 'consum', 0.0227, 'lps'),
	(643020, 136, '2015-01-01 00:52:24.000000', 'consum', 0.0218, 'lps'),
	(643021, 136, '2015-01-01 00:52:25.000000', 'consum', 0.0323, 'lps'),
	(643022, 136, '2015-01-01 00:52:26.000000', 'consum', 0.0257, 'lps'),
	(643023, 136, '2015-01-01 00:52:27.000000', 'consum', 0.0228, 'lps'),
	(643024, 136, '2015-01-01 00:52:28.000000', 'consum', 0.0284, 'lps'),
	(643025, 136, '2015-01-01 00:52:29.000000', 'consum', 0.0281, 'lps'),
	(643026, 136, '2015-01-01 00:52:30.000000', 'consum', 0.0216, 'lps'),
	(643027, 136, '2015-01-01 00:52:31.000000', 'consum', 0.0277, 'lps'),
	(643028, 136, '2015-01-01 00:52:32.000000', 'consum', 0.0281, 'lps'),
	(643029, 136, '2015-01-01 00:52:33.000000', 'consum', 0.0238, 'lps'),
	(643030, 136, '2015-01-01 00:52:34.000000', 'consum', 0.0261, 'lps'),
	(643031, 136, '2015-01-01 00:52:35.000000', 'consum', 0.0260, 'lps'),
	(643032, 136, '2015-01-01 00:52:36.000000', 'consum', 0.0306, 'lps'),
	(643033, 136, '2015-01-01 00:52:37.000000', 'consum', 0.0293, 'lps'),
	(643034, 136, '2015-01-01 00:52:38.000000', 'consum', 0.0213, 'lps'),
	(643035, 136, '2015-01-01 00:52:39.000000', 'consum', 0.0227, 'lps'),
	(643036, 136, '2015-01-01 00:52:40.000000', 'consum', 0.0284, 'lps'),
	(643037, 136, '2015-01-01 00:52:41.000000', 'consum', 0.0282, 'lps'),
	(643038, 136, '2015-01-01 00:52:42.000000', 'consum', 0.0223, 'lps'),
	(643039, 136, '2015-01-01 00:52:43.000000', 'consum', 0.0309, 'lps'),
	(643040, 136, '2015-01-01 00:52:44.000000', 'consum', 0.0293, 'lps'),
	(643041, 136, '2015-01-01 00:52:45.000000', 'consum', 0.0329, 'lps'),
	(643042, 136, '2015-01-01 00:52:46.000000', 'consum', 0.0307, 'lps'),
	(643043, 136, '2015-01-01 00:52:47.000000', 'consum', 0.0215, 'lps'),
	(643044, 136, '2015-01-01 00:52:48.000000', 'consum', 0.0317, 'lps'),
	(643045, 136, '2015-01-01 00:52:49.000000', 'consum', 0.0236, 'lps'),
	(643046, 136, '2015-01-01 00:52:50.000000', 'consum', 0.0268, 'lps'),
	(643047, 136, '2015-01-01 00:52:51.000000', 'consum', 0.0298, 'lps'),
	(643048, 136, '2015-01-01 00:52:52.000000', 'consum', 0.0229, 'lps'),
	(643049, 136, '2015-01-01 00:52:53.000000', 'consum', 0.0290, 'lps'),
	(643050, 136, '2015-01-01 00:52:54.000000', 'consum', 0.0306, 'lps'),
	(643051, 136, '2015-01-01 00:52:55.000000', 'consum', 0.0325, 'lps'),
	(643052, 136, '2015-01-01 00:52:56.000000', 'consum', 0.0251, 'lps'),
	(643053, 136, '2015-01-01 00:52:57.000000', 'consum', 0.0317, 'lps'),
	(643054, 136, '2015-01-01 00:52:58.000000', 'consum', 0.0249, 'lps'),
	(643055, 136, '2015-01-01 00:52:59.000000', 'consum', 0.0211, 'lps'),
	(643056, 136, '2015-01-01 00:53:00.000000', 'consum', 0.0223, 'lps'),
	(643057, 136, '2015-01-01 00:53:01.000000', 'consum', 0.0273, 'lps'),
	(643058, 136, '2015-01-01 00:53:02.000000', 'consum', 0.0236, 'lps'),
	(643059, 136, '2015-01-01 00:53:03.000000', 'consum', 0.0277, 'lps'),
	(643060, 136, '2015-01-01 00:53:04.000000', 'consum', 0.0219, 'lps'),
	(643061, 136, '2015-01-01 00:53:05.000000', 'consum', 0.0301, 'lps'),
	(643062, 136, '2015-01-01 00:53:06.000000', 'consum', 0.0269, 'lps'),
	(643063, 136, '2015-01-01 00:53:07.000000', 'consum', 0.0233, 'lps'),
	(643064, 136, '2015-01-01 00:53:08.000000', 'consum', 0.0272, 'lps'),
	(643065, 136, '2015-01-01 00:53:09.000000', 'consum', 0.0329, 'lps'),
	(643066, 136, '2015-01-01 00:53:10.000000', 'consum', 0.0245, 'lps'),
	(643067, 136, '2015-01-01 00:53:11.000000', 'consum', 0.0278, 'lps'),
	(643068, 136, '2015-01-01 00:53:12.000000', 'consum', 0.0322, 'lps'),
	(643069, 136, '2015-01-01 00:53:13.000000', 'consum', 0.0318, 'lps'),
	(643070, 136, '2015-01-01 00:53:14.000000', 'consum', 0.0289, 'lps'),
	(643071, 136, '2015-01-01 00:53:15.000000', 'consum', 0.0282, 'lps'),
	(643072, 136, '2015-01-01 00:53:16.000000', 'consum', 0.0333, 'lps'),
	(643073, 136, '2015-01-01 00:53:17.000000', 'consum', 0.0236, 'lps'),
	(643074, 136, '2015-01-01 00:53:18.000000', 'consum', 0.0223, 'lps'),
	(643075, 136, '2015-01-01 00:53:19.000000', 'consum', 0.0318, 'lps'),
	(643076, 136, '2015-01-01 00:53:20.000000', 'consum', 0.0218, 'lps'),
	(643077, 136, '2015-01-01 00:53:21.000000', 'consum', 0.0296, 'lps'),
	(643078, 136, '2015-01-01 00:53:22.000000', 'consum', 0.0245, 'lps'),
	(643079, 136, '2015-01-01 00:53:23.000000', 'consum', 0.0250, 'lps'),
	(643080, 136, '2015-01-01 00:53:24.000000', 'consum', 0.0307, 'lps'),
	(643081, 136, '2015-01-01 00:53:25.000000', 'consum', 0.0328, 'lps'),
	(643082, 136, '2015-01-01 00:53:26.000000', 'consum', 0.0260, 'lps'),
	(643083, 136, '2015-01-01 00:53:27.000000', 'consum', 0.0231, 'lps'),
	(643084, 136, '2015-01-01 00:53:28.000000', 'consum', 0.0290, 'lps'),
	(643085, 136, '2015-01-01 00:53:29.000000', 'consum', 0.0298, 'lps'),
	(643086, 136, '2015-01-01 00:53:30.000000', 'consum', 0.0287, 'lps'),
	(643087, 136, '2015-01-01 00:53:31.000000', 'consum', 0.0331, 'lps'),
	(643088, 136, '2015-01-01 00:53:32.000000', 'consum', 0.0211, 'lps'),
	(643089, 136, '2015-01-01 00:53:33.000000', 'consum', 0.0227, 'lps'),
	(643090, 136, '2015-01-01 00:53:34.000000', 'consum', 0.0291, 'lps'),
	(643091, 136, '2015-01-01 00:53:35.000000', 'consum', 0.0317, 'lps'),
	(643092, 136, '2015-01-01 00:53:36.000000', 'consum', 0.0256, 'lps'),
	(643093, 136, '2015-01-01 00:53:37.000000', 'consum', 0.0241, 'lps'),
	(643094, 136, '2015-01-01 00:53:38.000000', 'consum', 0.0229, 'lps'),
	(643095, 136, '2015-01-01 00:53:39.000000', 'consum', 0.0214, 'lps'),
	(643096, 136, '2015-01-01 00:53:40.000000', 'consum', 0.0297, 'lps'),
	(643097, 136, '2015-01-01 00:53:41.000000', 'consum', 0.0261, 'lps'),
	(643098, 136, '2015-01-01 00:53:42.000000', 'consum', 0.0327, 'lps'),
	(643099, 136, '2015-01-01 00:53:43.000000', 'consum', 0.0272, 'lps'),
	(643100, 136, '2015-01-01 00:53:44.000000', 'consum', 0.0294, 'lps'),
	(643101, 136, '2015-01-01 00:53:45.000000', 'consum', 0.0321, 'lps'),
	(643102, 136, '2015-01-01 00:53:46.000000', 'consum', 0.0266, 'lps'),
	(643103, 136, '2015-01-01 00:53:47.000000', 'consum', 0.0279, 'lps'),
	(643104, 136, '2015-01-01 00:53:48.000000', 'consum', 0.0264, 'lps'),
	(643105, 136, '2015-01-01 00:53:49.000000', 'consum', 0.0273, 'lps'),
	(643106, 136, '2015-01-01 00:53:50.000000', 'consum', 0.0239, 'lps'),
	(643107, 136, '2015-01-01 00:53:51.000000', 'consum', 0.0290, 'lps'),
	(643108, 136, '2015-01-01 00:53:52.000000', 'consum', 0.0278, 'lps'),
	(643109, 136, '2015-01-01 00:53:53.000000', 'consum', 0.0308, 'lps'),
	(643110, 136, '2015-01-01 00:53:54.000000', 'consum', 0.0251, 'lps'),
	(643111, 136, '2015-01-01 00:53:55.000000', 'consum', 0.0243, 'lps'),
	(643112, 136, '2015-01-01 00:53:56.000000', 'consum', 0.0252, 'lps'),
	(643113, 136, '2015-01-01 00:53:57.000000', 'consum', 0.0322, 'lps'),
	(643114, 136, '2015-01-01 00:53:58.000000', 'consum', 0.0275, 'lps'),
	(643115, 136, '2015-01-01 00:53:59.000000', 'consum', 0.0322, 'lps'),
	(643116, 136, '2015-01-01 00:54:00.000000', 'consum', 0.0327, 'lps'),
	(643117, 136, '2015-01-01 00:54:01.000000', 'consum', 0.0214, 'lps'),
	(643118, 136, '2015-01-01 00:54:02.000000', 'consum', 0.0249, 'lps'),
	(643119, 136, '2015-01-01 00:54:03.000000', 'consum', 0.0272, 'lps'),
	(643120, 136, '2015-01-01 00:54:04.000000', 'consum', 0.0278, 'lps'),
	(643121, 136, '2015-01-01 00:54:05.000000', 'consum', 0.0241, 'lps'),
	(643122, 136, '2015-01-01 00:54:06.000000', 'consum', 0.0285, 'lps'),
	(643123, 136, '2015-01-01 00:54:07.000000', 'consum', 0.0243, 'lps'),
	(643124, 136, '2015-01-01 00:54:08.000000', 'consum', 0.0277, 'lps'),
	(643125, 136, '2015-01-01 00:54:09.000000', 'consum', 0.0323, 'lps'),
	(643126, 136, '2015-01-01 00:54:10.000000', 'consum', 0.0327, 'lps'),
	(643127, 136, '2015-01-01 00:54:11.000000', 'consum', 0.0332, 'lps'),
	(643128, 136, '2015-01-01 00:54:12.000000', 'consum', 0.0220, 'lps'),
	(643129, 136, '2015-01-01 00:54:13.000000', 'consum', 0.0268, 'lps'),
	(643130, 136, '2015-01-01 00:54:14.000000', 'consum', 0.0222, 'lps'),
	(643131, 136, '2015-01-01 00:54:15.000000', 'consum', 0.0219, 'lps'),
	(643132, 136, '2015-01-01 00:54:16.000000', 'consum', 0.0218, 'lps'),
	(643133, 136, '2015-01-01 00:54:17.000000', 'consum', 0.0227, 'lps'),
	(643134, 136, '2015-01-01 00:54:18.000000', 'consum', 0.0271, 'lps'),
	(643135, 136, '2015-01-01 00:54:19.000000', 'consum', 0.0216, 'lps'),
	(643136, 136, '2015-01-01 00:54:20.000000', 'consum', 0.0305, 'lps'),
	(643137, 136, '2015-01-01 00:54:21.000000', 'consum', 0.0297, 'lps'),
	(643138, 136, '2015-01-01 00:54:22.000000', 'consum', 0.0237, 'lps'),
	(643139, 136, '2015-01-01 00:54:23.000000', 'consum', 0.0331, 'lps'),
	(643140, 136, '2015-01-01 00:54:24.000000', 'consum', 0.0239, 'lps'),
	(643141, 136, '2015-01-01 00:54:25.000000', 'consum', 0.0239, 'lps'),
	(643142, 136, '2015-01-01 00:54:26.000000', 'consum', 0.0270, 'lps'),
	(643143, 136, '2015-01-01 00:54:27.000000', 'consum', 0.0298, 'lps'),
	(643144, 136, '2015-01-01 00:54:28.000000', 'consum', 0.0222, 'lps'),
	(643145, 136, '2015-01-01 00:54:29.000000', 'consum', 0.0253, 'lps'),
	(643146, 136, '2015-01-01 00:54:30.000000', 'consum', 0.0269, 'lps'),
	(643147, 136, '2015-01-01 00:54:31.000000', 'consum', 0.0250, 'lps'),
	(643148, 136, '2015-01-01 00:54:32.000000', 'consum', 0.0234, 'lps'),
	(643149, 136, '2015-01-01 00:54:33.000000', 'consum', 0.0211, 'lps'),
	(643150, 136, '2015-01-01 00:54:34.000000', 'consum', 0.0269, 'lps'),
	(643151, 136, '2015-01-01 00:54:35.000000', 'consum', 0.0252, 'lps'),
	(643152, 136, '2015-01-01 00:54:36.000000', 'consum', 0.0246, 'lps'),
	(643153, 136, '2015-01-01 00:54:37.000000', 'consum', 0.0264, 'lps'),
	(643154, 136, '2015-01-01 00:54:38.000000', 'consum', 0.0246, 'lps'),
	(643155, 136, '2015-01-01 00:54:39.000000', 'consum', 0.0231, 'lps'),
	(643156, 136, '2015-01-01 00:54:40.000000', 'consum', 0.0332, 'lps'),
	(643157, 136, '2015-01-01 00:54:41.000000', 'consum', 0.0261, 'lps'),
	(643158, 136, '2015-01-01 00:54:42.000000', 'consum', 0.0223, 'lps'),
	(643159, 136, '2015-01-01 00:54:43.000000', 'consum', 0.0248, 'lps'),
	(643160, 136, '2015-01-01 00:54:44.000000', 'consum', 0.0238, 'lps'),
	(643161, 136, '2015-01-01 00:54:45.000000', 'consum', 0.0235, 'lps'),
	(643162, 136, '2015-01-01 00:54:46.000000', 'consum', 0.0253, 'lps'),
	(643163, 136, '2015-01-01 00:54:47.000000', 'consum', 0.0227, 'lps'),
	(643164, 136, '2015-01-01 00:54:48.000000', 'consum', 0.0290, 'lps'),
	(643165, 136, '2015-01-01 00:54:49.000000', 'consum', 0.0313, 'lps'),
	(643166, 136, '2015-01-01 00:54:50.000000', 'consum', 0.0235, 'lps'),
	(643167, 136, '2015-01-01 00:54:51.000000', 'consum', 0.0276, 'lps'),
	(643168, 136, '2015-01-01 00:54:52.000000', 'consum', 0.0218, 'lps'),
	(643169, 136, '2015-01-01 00:54:53.000000', 'consum', 0.0299, 'lps'),
	(643170, 136, '2015-01-01 00:54:54.000000', 'consum', 0.0259, 'lps'),
	(643171, 136, '2015-01-01 00:54:55.000000', 'consum', 0.0315, 'lps'),
	(643172, 136, '2015-01-01 00:54:56.000000', 'consum', 0.0215, 'lps'),
	(643173, 136, '2015-01-01 00:54:57.000000', 'consum', 0.0295, 'lps'),
	(643174, 136, '2015-01-01 00:54:58.000000', 'consum', 0.0245, 'lps'),
	(643175, 136, '2015-01-01 00:54:59.000000', 'consum', 0.0258, 'lps'),
	(643176, 136, '2015-01-01 00:55:00.000000', 'consum', 0.0218, 'lps'),
	(643177, 136, '2015-01-01 00:55:01.000000', 'consum', 0.0233, 'lps'),
	(643178, 136, '2015-01-01 00:55:02.000000', 'consum', 0.0301, 'lps'),
	(643179, 136, '2015-01-01 00:55:03.000000', 'consum', 0.0223, 'lps'),
	(643180, 136, '2015-01-01 00:55:04.000000', 'consum', 0.0250, 'lps'),
	(643181, 136, '2015-01-01 00:55:05.000000', 'consum', 0.0247, 'lps'),
	(643182, 136, '2015-01-01 00:55:06.000000', 'consum', 0.0276, 'lps'),
	(643183, 136, '2015-01-01 00:55:07.000000', 'consum', 0.0305, 'lps'),
	(643184, 136, '2015-01-01 00:55:08.000000', 'consum', 0.0238, 'lps'),
	(643185, 136, '2015-01-01 00:55:09.000000', 'consum', 0.0316, 'lps'),
	(643186, 136, '2015-01-01 00:55:10.000000', 'consum', 0.0285, 'lps'),
	(643187, 136, '2015-01-01 00:55:11.000000', 'consum', 0.0268, 'lps'),
	(643188, 136, '2015-01-01 00:55:12.000000', 'consum', 0.0276, 'lps'),
	(643189, 136, '2015-01-01 00:55:13.000000', 'consum', 0.0240, 'lps'),
	(643190, 136, '2015-01-01 00:55:14.000000', 'consum', 0.0286, 'lps'),
	(643191, 136, '2015-01-01 00:55:15.000000', 'consum', 0.0252, 'lps'),
	(643192, 136, '2015-01-01 00:55:16.000000', 'consum', 0.0319, 'lps'),
	(643193, 136, '2015-01-01 00:55:17.000000', 'consum', 0.0258, 'lps'),
	(643194, 136, '2015-01-01 00:55:18.000000', 'consum', 0.0245, 'lps'),
	(643195, 136, '2015-01-01 00:55:19.000000', 'consum', 0.0241, 'lps'),
	(643196, 136, '2015-01-01 00:55:20.000000', 'consum', 0.0260, 'lps'),
	(643197, 136, '2015-01-01 00:55:21.000000', 'consum', 0.0245, 'lps'),
	(643198, 136, '2015-01-01 00:55:22.000000', 'consum', 0.0234, 'lps'),
	(643199, 136, '2015-01-01 00:55:23.000000', 'consum', 0.0228, 'lps'),
	(643200, 136, '2015-01-01 00:55:24.000000', 'consum', 0.0229, 'lps'),
	(643201, 136, '2015-01-01 00:55:25.000000', 'consum', 0.0250, 'lps'),
	(643202, 136, '2015-01-01 00:55:26.000000', 'consum', 0.0231, 'lps'),
	(643203, 136, '2015-01-01 00:55:27.000000', 'consum', 0.0320, 'lps'),
	(643204, 136, '2015-01-01 00:55:28.000000', 'consum', 0.0327, 'lps'),
	(643205, 136, '2015-01-01 00:55:29.000000', 'consum', 0.0214, 'lps'),
	(643206, 136, '2015-01-01 00:55:30.000000', 'consum', 0.0253, 'lps'),
	(643207, 136, '2015-01-01 00:55:31.000000', 'consum', 0.0291, 'lps'),
	(643208, 136, '2015-01-01 00:55:32.000000', 'consum', 0.0237, 'lps'),
	(643209, 136, '2015-01-01 00:55:33.000000', 'consum', 0.0226, 'lps'),
	(643210, 136, '2015-01-01 00:55:34.000000', 'consum', 0.0332, 'lps'),
	(643211, 136, '2015-01-01 00:55:35.000000', 'consum', 0.0278, 'lps'),
	(643212, 136, '2015-01-01 00:55:36.000000', 'consum', 0.0310, 'lps'),
	(643213, 136, '2015-01-01 00:55:37.000000', 'consum', 0.0255, 'lps'),
	(643214, 136, '2015-01-01 00:55:38.000000', 'consum', 0.0263, 'lps'),
	(643215, 136, '2015-01-01 00:55:39.000000', 'consum', 0.0216, 'lps'),
	(643216, 136, '2015-01-01 00:55:40.000000', 'consum', 0.0328, 'lps'),
	(643217, 136, '2015-01-01 00:55:41.000000', 'consum', 0.0289, 'lps'),
	(643218, 136, '2015-01-01 00:55:42.000000', 'consum', 0.0249, 'lps'),
	(643219, 136, '2015-01-01 00:55:43.000000', 'consum', 0.0294, 'lps'),
	(643220, 136, '2015-01-01 00:55:44.000000', 'consum', 0.0264, 'lps'),
	(643221, 136, '2015-01-01 00:55:45.000000', 'consum', 0.0231, 'lps'),
	(643222, 136, '2015-01-01 00:55:46.000000', 'consum', 0.0276, 'lps'),
	(643223, 136, '2015-01-01 00:55:47.000000', 'consum', 0.0230, 'lps'),
	(643224, 136, '2015-01-01 00:55:48.000000', 'consum', 0.0238, 'lps'),
	(643225, 136, '2015-01-01 00:55:49.000000', 'consum', 0.0289, 'lps'),
	(643226, 136, '2015-01-01 00:55:50.000000', 'consum', 0.0274, 'lps'),
	(643227, 136, '2015-01-01 00:55:51.000000', 'consum', 0.0292, 'lps'),
	(643228, 136, '2015-01-01 00:55:52.000000', 'consum', 0.0306, 'lps'),
	(643229, 136, '2015-01-01 00:55:53.000000', 'consum', 0.0321, 'lps'),
	(643230, 136, '2015-01-01 00:55:54.000000', 'consum', 0.0227, 'lps'),
	(643231, 136, '2015-01-01 00:55:55.000000', 'consum', 0.0214, 'lps'),
	(643232, 136, '2015-01-01 00:55:56.000000', 'consum', 0.0301, 'lps'),
	(643233, 136, '2015-01-01 00:55:57.000000', 'consum', 0.0284, 'lps'),
	(643234, 136, '2015-01-01 00:55:58.000000', 'consum', 0.0305, 'lps'),
	(643235, 136, '2015-01-01 00:55:59.000000', 'consum', 0.0217, 'lps'),
	(643236, 136, '2015-01-01 00:56:00.000000', 'consum', 0.0333, 'lps'),
	(643237, 136, '2015-01-01 00:56:01.000000', 'consum', 0.0308, 'lps'),
	(643238, 136, '2015-01-01 00:56:02.000000', 'consum', 0.0332, 'lps'),
	(643239, 136, '2015-01-01 00:56:03.000000', 'consum', 0.0280, 'lps'),
	(643240, 136, '2015-01-01 00:56:04.000000', 'consum', 0.0317, 'lps'),
	(643241, 136, '2015-01-01 00:56:05.000000', 'consum', 0.0286, 'lps'),
	(643242, 136, '2015-01-01 00:56:06.000000', 'consum', 0.0272, 'lps'),
	(643243, 136, '2015-01-01 00:56:07.000000', 'consum', 0.0291, 'lps'),
	(643244, 136, '2015-01-01 00:56:08.000000', 'consum', 0.0306, 'lps'),
	(643245, 136, '2015-01-01 00:56:09.000000', 'consum', 0.0324, 'lps'),
	(643246, 136, '2015-01-01 00:56:10.000000', 'consum', 0.0245, 'lps'),
	(643247, 136, '2015-01-01 00:56:11.000000', 'consum', 0.0293, 'lps'),
	(643248, 136, '2015-01-01 00:56:12.000000', 'consum', 0.0271, 'lps'),
	(643249, 136, '2015-01-01 00:56:13.000000', 'consum', 0.0266, 'lps'),
	(643250, 136, '2015-01-01 00:56:14.000000', 'consum', 0.0309, 'lps'),
	(643251, 136, '2015-01-01 00:56:15.000000', 'consum', 0.0287, 'lps'),
	(643252, 136, '2015-01-01 00:56:16.000000', 'consum', 0.0301, 'lps'),
	(643253, 136, '2015-01-01 00:56:17.000000', 'consum', 0.0309, 'lps'),
	(643254, 136, '2015-01-01 00:56:18.000000', 'consum', 0.0309, 'lps'),
	(643255, 136, '2015-01-01 00:56:19.000000', 'consum', 0.0287, 'lps'),
	(643256, 136, '2015-01-01 00:56:20.000000', 'consum', 0.0295, 'lps'),
	(643257, 136, '2015-01-01 00:56:21.000000', 'consum', 0.0280, 'lps'),
	(643258, 136, '2015-01-01 00:56:22.000000', 'consum', 0.0308, 'lps'),
	(643259, 136, '2015-01-01 00:56:23.000000', 'consum', 0.0241, 'lps'),
	(643260, 136, '2015-01-01 00:56:24.000000', 'consum', 0.0318, 'lps'),
	(643261, 136, '2015-01-01 00:56:25.000000', 'consum', 0.0288, 'lps'),
	(643262, 136, '2015-01-01 00:56:26.000000', 'consum', 0.0274, 'lps'),
	(643263, 136, '2015-01-01 00:56:27.000000', 'consum', 0.0298, 'lps'),
	(643264, 136, '2015-01-01 00:56:28.000000', 'consum', 0.0332, 'lps'),
	(643265, 136, '2015-01-01 00:56:29.000000', 'consum', 0.0312, 'lps'),
	(643266, 136, '2015-01-01 00:56:30.000000', 'consum', 0.0227, 'lps'),
	(643267, 136, '2015-01-01 00:56:31.000000', 'consum', 0.0239, 'lps'),
	(643268, 136, '2015-01-01 00:56:32.000000', 'consum', 0.0306, 'lps'),
	(643269, 136, '2015-01-01 00:56:33.000000', 'consum', 0.0230, 'lps'),
	(643270, 136, '2015-01-01 00:56:34.000000', 'consum', 0.0269, 'lps'),
	(643271, 136, '2015-01-01 00:56:35.000000', 'consum', 0.0322, 'lps'),
	(643272, 136, '2015-01-01 00:56:36.000000', 'consum', 0.0222, 'lps'),
	(643273, 136, '2015-01-01 00:56:37.000000', 'consum', 0.0305, 'lps'),
	(643274, 136, '2015-01-01 00:56:38.000000', 'consum', 0.0278, 'lps'),
	(643275, 136, '2015-01-01 00:56:39.000000', 'consum', 0.0266, 'lps'),
	(643276, 136, '2015-01-01 00:56:40.000000', 'consum', 0.0285, 'lps'),
	(643277, 136, '2015-01-01 00:56:41.000000', 'consum', 0.0294, 'lps'),
	(643278, 136, '2015-01-01 00:56:42.000000', 'consum', 0.0283, 'lps'),
	(643279, 136, '2015-01-01 00:56:43.000000', 'consum', 0.0323, 'lps'),
	(643280, 136, '2015-01-01 00:56:44.000000', 'consum', 0.0309, 'lps'),
	(643281, 136, '2015-01-01 00:56:45.000000', 'consum', 0.0243, 'lps'),
	(643282, 136, '2015-01-01 00:56:46.000000', 'consum', 0.0327, 'lps'),
	(643283, 136, '2015-01-01 00:56:47.000000', 'consum', 0.0322, 'lps'),
	(643284, 136, '2015-01-01 00:56:48.000000', 'consum', 0.0296, 'lps'),
	(643285, 136, '2015-01-01 00:56:49.000000', 'consum', 0.0304, 'lps'),
	(643286, 136, '2015-01-01 00:56:50.000000', 'consum', 0.0298, 'lps'),
	(643287, 136, '2015-01-01 00:56:51.000000', 'consum', 0.0245, 'lps'),
	(643288, 136, '2015-01-01 00:56:52.000000', 'consum', 0.0246, 'lps'),
	(643289, 136, '2015-01-01 00:56:53.000000', 'consum', 0.0285, 'lps'),
	(643290, 136, '2015-01-01 00:56:54.000000', 'consum', 0.0230, 'lps'),
	(643291, 136, '2015-01-01 00:56:55.000000', 'consum', 0.0331, 'lps'),
	(643292, 136, '2015-01-01 00:56:56.000000', 'consum', 0.0262, 'lps'),
	(643293, 136, '2015-01-01 00:56:57.000000', 'consum', 0.0232, 'lps'),
	(643294, 136, '2015-01-01 00:56:58.000000', 'consum', 0.0286, 'lps'),
	(643295, 136, '2015-01-01 00:56:59.000000', 'consum', 0.0277, 'lps'),
	(643296, 136, '2015-01-01 00:57:00.000000', 'consum', 0.0318, 'lps'),
	(643297, 136, '2015-01-01 00:57:01.000000', 'consum', 0.0302, 'lps'),
	(643298, 136, '2015-01-01 00:57:02.000000', 'consum', 0.0222, 'lps'),
	(643299, 136, '2015-01-01 00:57:03.000000', 'consum', 0.0242, 'lps'),
	(643300, 136, '2015-01-01 00:57:04.000000', 'consum', 0.0210, 'lps'),
	(643301, 136, '2015-01-01 00:57:05.000000', 'consum', 0.0240, 'lps'),
	(643302, 136, '2015-01-01 00:57:06.000000', 'consum', 0.0236, 'lps'),
	(643303, 136, '2015-01-01 00:57:07.000000', 'consum', 0.0249, 'lps'),
	(643304, 136, '2015-01-01 00:57:08.000000', 'consum', 0.0329, 'lps'),
	(643305, 136, '2015-01-01 00:57:09.000000', 'consum', 0.0318, 'lps'),
	(643306, 136, '2015-01-01 00:57:10.000000', 'consum', 0.0268, 'lps'),
	(643307, 136, '2015-01-01 00:57:11.000000', 'consum', 0.0301, 'lps'),
	(643308, 136, '2015-01-01 00:57:12.000000', 'consum', 0.0244, 'lps'),
	(643309, 136, '2015-01-01 00:57:13.000000', 'consum', 0.0232, 'lps'),
	(643310, 136, '2015-01-01 00:57:14.000000', 'consum', 0.0218, 'lps'),
	(643311, 136, '2015-01-01 00:57:15.000000', 'consum', 0.0309, 'lps'),
	(643312, 136, '2015-01-01 00:57:16.000000', 'consum', 0.0309, 'lps'),
	(643313, 136, '2015-01-01 00:57:17.000000', 'consum', 0.0284, 'lps'),
	(643314, 136, '2015-01-01 00:57:18.000000', 'consum', 0.0283, 'lps'),
	(643315, 136, '2015-01-01 00:57:19.000000', 'consum', 0.0230, 'lps'),
	(643316, 136, '2015-01-01 00:57:20.000000', 'consum', 0.0216, 'lps'),
	(643317, 136, '2015-01-01 00:57:21.000000', 'consum', 0.0302, 'lps'),
	(643318, 136, '2015-01-01 00:57:22.000000', 'consum', 0.0284, 'lps'),
	(643319, 136, '2015-01-01 00:57:23.000000', 'consum', 0.0301, 'lps'),
	(643320, 136, '2015-01-01 00:57:24.000000', 'consum', 0.0322, 'lps'),
	(643321, 136, '2015-01-01 00:57:25.000000', 'consum', 0.0250, 'lps'),
	(643322, 136, '2015-01-01 00:57:26.000000', 'consum', 0.0323, 'lps'),
	(643323, 136, '2015-01-01 00:57:27.000000', 'consum', 0.0283, 'lps'),
	(643324, 136, '2015-01-01 00:57:28.000000', 'consum', 0.0234, 'lps'),
	(643325, 136, '2015-01-01 00:57:29.000000', 'consum', 0.0239, 'lps'),
	(643326, 136, '2015-01-01 00:57:30.000000', 'consum', 0.0281, 'lps'),
	(643327, 136, '2015-01-01 00:57:31.000000', 'consum', 0.0233, 'lps'),
	(643328, 136, '2015-01-01 00:57:32.000000', 'consum', 0.0236, 'lps'),
	(643329, 136, '2015-01-01 00:57:33.000000', 'consum', 0.0269, 'lps'),
	(643330, 136, '2015-01-01 00:57:34.000000', 'consum', 0.0305, 'lps'),
	(643331, 136, '2015-01-01 00:57:35.000000', 'consum', 0.0260, 'lps'),
	(643332, 136, '2015-01-01 00:57:36.000000', 'consum', 0.0298, 'lps'),
	(643333, 136, '2015-01-01 00:57:37.000000', 'consum', 0.0255, 'lps'),
	(643334, 136, '2015-01-01 00:57:38.000000', 'consum', 0.0295, 'lps'),
	(643335, 136, '2015-01-01 00:57:39.000000', 'consum', 0.0251, 'lps'),
	(643336, 136, '2015-01-01 00:57:40.000000', 'consum', 0.0284, 'lps'),
	(643337, 136, '2015-01-01 00:57:41.000000', 'consum', 0.0210, 'lps'),
	(643338, 136, '2015-01-01 00:57:42.000000', 'consum', 0.0237, 'lps'),
	(643339, 136, '2015-01-01 00:57:43.000000', 'consum', 0.0219, 'lps'),
	(643340, 136, '2015-01-01 00:57:44.000000', 'consum', 0.0301, 'lps'),
	(643341, 136, '2015-01-01 00:57:45.000000', 'consum', 0.0267, 'lps'),
	(643342, 136, '2015-01-01 00:57:46.000000', 'consum', 0.0223, 'lps'),
	(643343, 136, '2015-01-01 00:57:47.000000', 'consum', 0.0226, 'lps'),
	(643344, 136, '2015-01-01 00:57:48.000000', 'consum', 0.0252, 'lps'),
	(643345, 136, '2015-01-01 00:57:49.000000', 'consum', 0.0249, 'lps'),
	(643346, 136, '2015-01-01 00:57:50.000000', 'consum', 0.0278, 'lps'),
	(643347, 136, '2015-01-01 00:57:51.000000', 'consum', 0.0309, 'lps'),
	(643348, 136, '2015-01-01 00:57:52.000000', 'consum', 0.0255, 'lps'),
	(643349, 136, '2015-01-01 00:57:53.000000', 'consum', 0.0261, 'lps'),
	(643350, 136, '2015-01-01 00:57:54.000000', 'consum', 0.0333, 'lps'),
	(643351, 136, '2015-01-01 00:57:55.000000', 'consum', 0.0301, 'lps'),
	(643352, 136, '2015-01-01 00:57:56.000000', 'consum', 0.0296, 'lps'),
	(643353, 136, '2015-01-01 00:57:57.000000', 'consum', 0.0244, 'lps'),
	(643354, 136, '2015-01-01 00:57:58.000000', 'consum', 0.0245, 'lps'),
	(643355, 136, '2015-01-01 00:57:59.000000', 'consum', 0.0284, 'lps'),
	(643356, 136, '2015-01-01 00:58:00.000000', 'consum', 0.0226, 'lps'),
	(643357, 136, '2015-01-01 00:58:01.000000', 'consum', 0.0316, 'lps'),
	(643358, 136, '2015-01-01 00:58:02.000000', 'consum', 0.0322, 'lps'),
	(643359, 136, '2015-01-01 00:58:03.000000', 'consum', 0.0327, 'lps'),
	(643360, 136, '2015-01-01 00:58:04.000000', 'consum', 0.0214, 'lps'),
	(643361, 136, '2015-01-01 00:58:05.000000', 'consum', 0.0251, 'lps'),
	(643362, 136, '2015-01-01 00:58:06.000000', 'consum', 0.0281, 'lps'),
	(643363, 136, '2015-01-01 00:58:07.000000', 'consum', 0.0317, 'lps'),
	(643364, 136, '2015-01-01 00:58:08.000000', 'consum', 0.0283, 'lps'),
	(643365, 136, '2015-01-01 00:58:09.000000', 'consum', 0.0255, 'lps'),
	(643366, 136, '2015-01-01 00:58:10.000000', 'consum', 0.0217, 'lps'),
	(643367, 136, '2015-01-01 00:58:11.000000', 'consum', 0.0235, 'lps'),
	(643368, 136, '2015-01-01 00:58:12.000000', 'consum', 0.0313, 'lps'),
	(643369, 136, '2015-01-01 00:58:13.000000', 'consum', 0.0278, 'lps'),
	(643370, 136, '2015-01-01 00:58:14.000000', 'consum', 0.0242, 'lps'),
	(643371, 136, '2015-01-01 00:58:15.000000', 'consum', 0.0291, 'lps'),
	(643372, 136, '2015-01-01 00:58:16.000000', 'consum', 0.0270, 'lps'),
	(643373, 136, '2015-01-01 00:58:17.000000', 'consum', 0.0271, 'lps'),
	(643374, 136, '2015-01-01 00:58:18.000000', 'consum', 0.0332, 'lps'),
	(643375, 136, '2015-01-01 00:58:19.000000', 'consum', 0.0265, 'lps'),
	(643376, 136, '2015-01-01 00:58:20.000000', 'consum', 0.0247, 'lps'),
	(643377, 136, '2015-01-01 00:58:21.000000', 'consum', 0.0227, 'lps'),
	(643378, 136, '2015-01-01 00:58:22.000000', 'consum', 0.0310, 'lps'),
	(643379, 136, '2015-01-01 00:58:23.000000', 'consum', 0.0288, 'lps'),
	(643380, 136, '2015-01-01 00:58:24.000000', 'consum', 0.0302, 'lps'),
	(643381, 136, '2015-01-01 00:58:25.000000', 'consum', 0.0311, 'lps'),
	(643382, 136, '2015-01-01 00:58:26.000000', 'consum', 0.0317, 'lps'),
	(643383, 136, '2015-01-01 00:58:27.000000', 'consum', 0.0317, 'lps'),
	(643384, 136, '2015-01-01 00:58:28.000000', 'consum', 0.0299, 'lps'),
	(643385, 136, '2015-01-01 00:58:29.000000', 'consum', 0.0214, 'lps'),
	(643386, 136, '2015-01-01 00:58:30.000000', 'consum', 0.0332, 'lps'),
	(643387, 136, '2015-01-01 00:58:31.000000', 'consum', 0.0315, 'lps'),
	(643388, 136, '2015-01-01 00:58:32.000000', 'consum', 0.0244, 'lps'),
	(643389, 136, '2015-01-01 00:58:33.000000', 'consum', 0.0312, 'lps'),
	(643390, 136, '2015-01-01 00:58:34.000000', 'consum', 0.0248, 'lps'),
	(643391, 136, '2015-01-01 00:58:35.000000', 'consum', 0.0218, 'lps'),
	(643392, 136, '2015-01-01 00:58:36.000000', 'consum', 0.0262, 'lps'),
	(643393, 136, '2015-01-01 00:58:37.000000', 'consum', 0.0322, 'lps'),
	(643394, 136, '2015-01-01 00:58:38.000000', 'consum', 0.0243, 'lps'),
	(643395, 136, '2015-01-01 00:58:39.000000', 'consum', 0.0289, 'lps'),
	(643396, 136, '2015-01-01 00:58:40.000000', 'consum', 0.0256, 'lps'),
	(643397, 136, '2015-01-01 00:58:41.000000', 'consum', 0.0328, 'lps'),
	(643398, 136, '2015-01-01 00:58:42.000000', 'consum', 0.0289, 'lps'),
	(643399, 136, '2015-01-01 00:58:43.000000', 'consum', 0.0251, 'lps'),
	(643400, 136, '2015-01-01 00:58:44.000000', 'consum', 0.0304, 'lps'),
	(643401, 136, '2015-01-01 00:58:45.000000', 'consum', 0.0311, 'lps'),
	(643402, 136, '2015-01-01 00:58:46.000000', 'consum', 0.0309, 'lps'),
	(643403, 136, '2015-01-01 00:58:47.000000', 'consum', 0.0278, 'lps'),
	(643404, 136, '2015-01-01 00:58:48.000000', 'consum', 0.0254, 'lps'),
	(643405, 136, '2015-01-01 00:58:49.000000', 'consum', 0.0225, 'lps'),
	(643406, 136, '2015-01-01 00:58:50.000000', 'consum', 0.0278, 'lps'),
	(643407, 136, '2015-01-01 00:58:51.000000', 'consum', 0.0258, 'lps'),
	(643408, 136, '2015-01-01 00:58:52.000000', 'consum', 0.0245, 'lps'),
	(643409, 136, '2015-01-01 00:58:53.000000', 'consum', 0.0244, 'lps'),
	(643410, 136, '2015-01-01 00:58:54.000000', 'consum', 0.0276, 'lps'),
	(643411, 136, '2015-01-01 00:58:55.000000', 'consum', 0.0314, 'lps'),
	(643412, 136, '2015-01-01 00:58:56.000000', 'consum', 0.0286, 'lps'),
	(643413, 136, '2015-01-01 00:58:57.000000', 'consum', 0.0276, 'lps'),
	(643414, 136, '2015-01-01 00:58:58.000000', 'consum', 0.0314, 'lps'),
	(643415, 136, '2015-01-01 00:58:59.000000', 'consum', 0.0285, 'lps'),
	(643416, 136, '2015-01-01 00:59:00.000000', 'consum', 0.0273, 'lps'),
	(643417, 136, '2015-01-01 00:59:01.000000', 'consum', 0.0300, 'lps'),
	(643418, 136, '2015-01-01 00:59:02.000000', 'consum', 0.0224, 'lps'),
	(643419, 136, '2015-01-01 00:59:03.000000', 'consum', 0.0258, 'lps'),
	(643420, 136, '2015-01-01 00:59:04.000000', 'consum', 0.0285, 'lps'),
	(643421, 136, '2015-01-01 00:59:05.000000', 'consum', 0.0316, 'lps'),
	(643422, 136, '2015-01-01 00:59:06.000000', 'consum', 0.0270, 'lps'),
	(643423, 136, '2015-01-01 00:59:07.000000', 'consum', 0.0315, 'lps'),
	(643424, 136, '2015-01-01 00:59:08.000000', 'consum', 0.0306, 'lps'),
	(643425, 136, '2015-01-01 00:59:09.000000', 'consum', 0.0253, 'lps'),
	(643426, 136, '2015-01-01 00:59:10.000000', 'consum', 0.0260, 'lps'),
	(643427, 136, '2015-01-01 00:59:11.000000', 'consum', 0.0331, 'lps'),
	(643428, 136, '2015-01-01 00:59:12.000000', 'consum', 0.0294, 'lps'),
	(643429, 136, '2015-01-01 00:59:13.000000', 'consum', 0.0269, 'lps'),
	(643430, 136, '2015-01-01 00:59:14.000000', 'consum', 0.0252, 'lps'),
	(643431, 136, '2015-01-01 00:59:15.000000', 'consum', 0.0246, 'lps'),
	(643432, 136, '2015-01-01 00:59:16.000000', 'consum', 0.0263, 'lps'),
	(643433, 136, '2015-01-01 00:59:17.000000', 'consum', 0.0243, 'lps'),
	(643434, 136, '2015-01-01 00:59:18.000000', 'consum', 0.0217, 'lps'),
	(643435, 136, '2015-01-01 00:59:19.000000', 'consum', 0.0270, 'lps'),
	(643436, 136, '2015-01-01 00:59:20.000000', 'consum', 0.0241, 'lps'),
	(643437, 136, '2015-01-01 00:59:21.000000', 'consum', 0.0310, 'lps'),
	(643438, 136, '2015-01-01 00:59:22.000000', 'consum', 0.0244, 'lps'),
	(643439, 136, '2015-01-01 00:59:23.000000', 'consum', 0.0329, 'lps'),
	(643440, 136, '2015-01-01 00:59:24.000000', 'consum', 0.0333, 'lps'),
	(643441, 136, '2015-01-01 00:59:25.000000', 'consum', 0.0221, 'lps'),
	(643442, 136, '2015-01-01 00:59:26.000000', 'consum', 0.0266, 'lps'),
	(643443, 136, '2015-01-01 00:59:27.000000', 'consum', 0.0212, 'lps'),
	(643444, 136, '2015-01-01 00:59:28.000000', 'consum', 0.0301, 'lps'),
	(643445, 136, '2015-01-01 00:59:29.000000', 'consum', 0.0285, 'lps'),
	(643446, 136, '2015-01-01 00:59:30.000000', 'consum', 0.0315, 'lps'),
	(643447, 136, '2015-01-01 00:59:31.000000', 'consum', 0.0264, 'lps'),
	(643448, 136, '2015-01-01 00:59:32.000000', 'consum', 0.0286, 'lps'),
	(643449, 136, '2015-01-01 00:59:33.000000', 'consum', 0.0306, 'lps'),
	(643450, 136, '2015-01-01 00:59:34.000000', 'consum', 0.0213, 'lps'),
	(643451, 136, '2015-01-01 00:59:35.000000', 'consum', 0.0309, 'lps'),
	(643452, 136, '2015-01-01 00:59:36.000000', 'consum', 0.0327, 'lps'),
	(643453, 136, '2015-01-01 00:59:37.000000', 'consum', 0.0249, 'lps'),
	(643454, 136, '2015-01-01 00:59:38.000000', 'consum', 0.0302, 'lps'),
	(643455, 136, '2015-01-01 00:59:39.000000', 'consum', 0.0307, 'lps'),
	(643456, 136, '2015-01-01 00:59:40.000000', 'consum', 0.0295, 'lps'),
	(643457, 136, '2015-01-01 00:59:41.000000', 'consum', 0.0222, 'lps'),
	(643458, 136, '2015-01-01 00:59:42.000000', 'consum', 0.0262, 'lps'),
	(643459, 136, '2015-01-01 00:59:43.000000', 'consum', 0.0311, 'lps'),
	(643460, 136, '2015-01-01 00:59:44.000000', 'consum', 0.0311, 'lps'),
	(643461, 136, '2015-01-01 00:59:45.000000', 'consum', 0.0291, 'lps'),
	(643462, 136, '2015-01-01 00:59:46.000000', 'consum', 0.0310, 'lps'),
	(643463, 136, '2015-01-01 00:59:47.000000', 'consum', 0.0220, 'lps'),
	(643464, 136, '2015-01-01 00:59:48.000000', 'consum', 0.0333, 'lps'),
	(643465, 136, '2015-01-01 00:59:49.000000', 'consum', 0.0301, 'lps'),
	(643466, 136, '2015-01-01 00:59:50.000000', 'consum', 0.0294, 'lps'),
	(643467, 136, '2015-01-01 00:59:51.000000', 'consum', 0.0235, 'lps'),
	(643468, 136, '2015-01-01 00:59:52.000000', 'consum', 0.0332, 'lps'),
	(643469, 136, '2015-01-01 00:59:53.000000', 'consum', 0.0247, 'lps'),
	(643470, 136, '2015-01-01 00:59:54.000000', 'consum', 0.0280, 'lps'),
	(643471, 136, '2015-01-01 00:59:55.000000', 'consum', 0.0324, 'lps'),
	(643472, 136, '2015-01-01 00:59:56.000000', 'consum', 0.0324, 'lps'),
	(643473, 136, '2015-01-01 00:59:57.000000', 'consum', 0.0315, 'lps'),
	(643474, 136, '2015-01-01 00:59:58.000000', 'consum', 0.0270, 'lps'),
	(643475, 136, '2015-01-01 00:59:59.000000', 'consum', 0.0318, 'lps'),
	(643476, 136, '2015-01-01 01:00:00.000000', 'consum', 0.0325, 'lps'),
	(643477, 136, '2015-01-01 01:00:01.000000', 'consum', 0.0211, 'lps'),
	(643478, 136, '2015-01-01 01:00:02.000000', 'consum', 0.0245, 'lps'),
	(643479, 136, '2015-01-01 01:00:03.000000', 'consum', 0.0258, 'lps'),
	(643480, 136, '2015-01-01 01:00:04.000000', 'consum', 0.0220, 'lps'),
	(643481, 136, '2015-01-01 01:00:05.000000', 'consum', 0.0240, 'lps'),
	(643482, 136, '2015-01-01 01:00:06.000000', 'consum', 0.0332, 'lps'),
	(643483, 136, '2015-01-01 01:00:07.000000', 'consum', 0.0233, 'lps'),
	(643484, 136, '2015-01-01 01:00:08.000000', 'consum', 0.0333, 'lps'),
	(643485, 136, '2015-01-01 01:00:09.000000', 'consum', 0.0260, 'lps'),
	(643486, 136, '2015-01-01 01:00:10.000000', 'consum', 0.0215, 'lps'),
	(643487, 136, '2015-01-01 01:00:11.000000', 'consum', 0.0332, 'lps'),
	(643488, 136, '2015-01-01 01:00:12.000000', 'consum', 0.0313, 'lps'),
	(643489, 136, '2015-01-01 01:00:13.000000', 'consum', 0.0233, 'lps'),
	(643490, 136, '2015-01-01 01:00:14.000000', 'consum', 0.0264, 'lps'),
	(643491, 136, '2015-01-01 01:00:15.000000', 'consum', 0.0287, 'lps'),
	(643492, 136, '2015-01-01 01:00:16.000000', 'consum', 0.0309, 'lps'),
	(643493, 136, '2015-01-01 01:00:17.000000', 'consum', 0.0226, 'lps'),
	(643494, 136, '2015-01-01 01:00:18.000000', 'consum', 0.0242, 'lps'),
	(643495, 136, '2015-01-01 01:00:19.000000', 'consum', 0.0325, 'lps'),
	(643496, 136, '2015-01-01 01:00:20.000000', 'consum', 0.0315, 'lps'),
	(643497, 136, '2015-01-01 01:00:21.000000', 'consum', 0.0267, 'lps'),
	(643498, 136, '2015-01-01 01:00:22.000000', 'consum', 0.0303, 'lps'),
	(643499, 136, '2015-01-01 01:00:23.000000', 'consum', 0.0260, 'lps'),
	(643500, 136, '2015-01-01 01:00:24.000000', 'consum', 0.0302, 'lps'),
	(643501, 136, '2015-01-01 01:00:25.000000', 'consum', 0.0275, 'lps'),
	(643502, 136, '2015-01-01 01:00:26.000000', 'consum', 0.0260, 'lps'),
	(643503, 136, '2015-01-01 01:00:27.000000', 'consum', 0.0264, 'lps'),
	(643504, 136, '2015-01-01 01:00:28.000000', 'consum', 0.0333, 'lps'),
	(643505, 136, '2015-01-01 01:00:29.000000', 'consum', 0.0288, 'lps'),
	(643506, 136, '2015-01-01 01:00:30.000000', 'consum', 0.0234, 'lps'),
	(643507, 136, '2015-01-01 01:00:31.000000', 'consum', 0.0221, 'lps'),
	(643508, 136, '2015-01-01 01:00:32.000000', 'consum', 0.0319, 'lps'),
	(643509, 136, '2015-01-01 01:00:33.000000', 'consum', 0.0223, 'lps'),
	(643510, 136, '2015-01-01 01:00:34.000000', 'consum', 0.0321, 'lps'),
	(643511, 136, '2015-01-01 01:00:35.000000', 'consum', 0.0229, 'lps'),
	(643512, 136, '2015-01-01 01:00:36.000000', 'consum', 0.0223, 'lps'),
	(643513, 136, '2015-01-01 01:00:37.000000', 'consum', 0.0218, 'lps'),
	(643514, 136, '2015-01-01 01:00:38.000000', 'consum', 0.0210, 'lps'),
	(643515, 136, '2015-01-01 01:00:39.000000', 'consum', 0.0311, 'lps'),
	(643516, 136, '2015-01-01 01:00:40.000000', 'consum', 0.0221, 'lps'),
	(643517, 136, '2015-01-01 01:00:41.000000', 'consum', 0.0211, 'lps'),
	(643518, 136, '2015-01-01 01:00:42.000000', 'consum', 0.0305, 'lps'),
	(643519, 136, '2015-01-01 01:00:43.000000', 'consum', 0.0310, 'lps'),
	(643520, 136, '2015-01-01 01:00:44.000000', 'consum', 0.0301, 'lps'),
	(643521, 136, '2015-01-01 01:00:45.000000', 'consum', 0.0241, 'lps'),
	(643522, 136, '2015-01-01 01:00:46.000000', 'consum', 0.0219, 'lps'),
	(643523, 136, '2015-01-01 01:00:47.000000', 'consum', 0.0286, 'lps'),
	(643524, 136, '2015-01-01 01:00:48.000000', 'consum', 0.0314, 'lps'),
	(643525, 136, '2015-01-01 01:00:49.000000', 'consum', 0.0253, 'lps'),
	(643526, 136, '2015-01-01 01:00:50.000000', 'consum', 0.0241, 'lps'),
	(643527, 136, '2015-01-01 01:00:51.000000', 'consum', 0.0234, 'lps'),
	(643528, 136, '2015-01-01 01:00:52.000000', 'consum', 0.0236, 'lps'),
	(643529, 136, '2015-01-01 01:00:53.000000', 'consum', 0.0272, 'lps'),
	(643530, 136, '2015-01-01 01:00:54.000000', 'consum', 0.0318, 'lps'),
	(643531, 136, '2015-01-01 01:00:55.000000', 'consum', 0.0314, 'lps'),
	(643532, 136, '2015-01-01 01:00:56.000000', 'consum', 0.0283, 'lps'),
	(643533, 136, '2015-01-01 01:00:57.000000', 'consum', 0.0266, 'lps'),
	(643534, 136, '2015-01-01 01:00:58.000000', 'consum', 0.0270, 'lps'),
	(643535, 136, '2015-01-01 01:00:59.000000', 'consum', 0.0218, 'lps'),
	(643536, 136, '2015-01-01 01:01:00.000000', 'consum', 0.0318, 'lps'),
	(643537, 136, '2015-01-01 01:01:01.000000', 'consum', 0.0231, 'lps'),
	(643538, 136, '2015-01-01 01:01:02.000000', 'consum', 0.0239, 'lps'),
	(643539, 136, '2015-01-01 01:01:03.000000', 'consum', 0.0291, 'lps'),
	(643540, 136, '2015-01-01 01:01:04.000000', 'consum', 0.0282, 'lps'),
	(643541, 136, '2015-01-01 01:01:05.000000', 'consum', 0.0325, 'lps'),
	(643542, 136, '2015-01-01 01:01:06.000000', 'consum', 0.0324, 'lps'),
	(643543, 136, '2015-01-01 01:01:07.000000', 'consum', 0.0312, 'lps'),
	(643544, 136, '2015-01-01 01:01:08.000000', 'consum', 0.0255, 'lps'),
	(643545, 136, '2015-01-01 01:01:09.000000', 'consum', 0.0251, 'lps'),
	(643546, 136, '2015-01-01 01:01:10.000000', 'consum', 0.0283, 'lps'),
	(643547, 136, '2015-01-01 01:01:11.000000', 'consum', 0.0329, 'lps'),
	(643548, 136, '2015-01-01 01:01:12.000000', 'consum', 0.0212, 'lps'),
	(643549, 136, '2015-01-01 01:01:13.000000', 'consum', 0.0236, 'lps'),
	(643550, 136, '2015-01-01 01:01:14.000000', 'consum', 0.0333, 'lps'),
	(643551, 136, '2015-01-01 01:01:15.000000', 'consum', 0.0255, 'lps'),
	(643552, 136, '2015-01-01 01:01:16.000000', 'consum', 0.0312, 'lps'),
	(643553, 136, '2015-01-01 01:01:17.000000', 'consum', 0.0214, 'lps'),
	(643554, 136, '2015-01-01 01:01:18.000000', 'consum', 0.0296, 'lps'),
	(643555, 136, '2015-01-01 01:01:19.000000', 'consum', 0.0256, 'lps'),
	(643556, 136, '2015-01-01 01:01:20.000000', 'consum', 0.0307, 'lps'),
	(643557, 136, '2015-01-01 01:01:21.000000', 'consum', 0.0310, 'lps'),
	(643558, 136, '2015-01-01 01:01:22.000000', 'consum', 0.0294, 'lps'),
	(643559, 136, '2015-01-01 01:01:23.000000', 'consum', 0.0331, 'lps'),
	(643560, 136, '2015-01-01 01:01:24.000000', 'consum', 0.0314, 'lps'),
	(643561, 136, '2015-01-01 01:01:25.000000', 'consum', 0.0246, 'lps'),
	(643562, 136, '2015-01-01 01:01:26.000000', 'consum', 0.0325, 'lps'),
	(643563, 136, '2015-01-01 01:01:27.000000', 'consum', 0.0304, 'lps'),
	(643564, 136, '2015-01-01 01:01:28.000000', 'consum', 0.0212, 'lps'),
	(643565, 136, '2015-01-01 01:01:29.000000', 'consum', 0.0311, 'lps'),
	(643566, 136, '2015-01-01 01:01:30.000000', 'consum', 0.0215, 'lps'),
	(643567, 136, '2015-01-01 01:01:31.000000', 'consum', 0.0305, 'lps'),
	(643568, 136, '2015-01-01 01:01:32.000000', 'consum', 0.0297, 'lps'),
	(643569, 136, '2015-01-01 01:01:33.000000', 'consum', 0.0237, 'lps'),
	(643570, 136, '2015-01-01 01:01:34.000000', 'consum', 0.0330, 'lps'),
	(643571, 136, '2015-01-01 01:01:35.000000', 'consum', 0.0237, 'lps'),
	(643572, 136, '2015-01-01 01:01:36.000000', 'consum', 0.0232, 'lps'),
	(643573, 136, '2015-01-01 01:01:37.000000', 'consum', 0.0241, 'lps'),
	(643574, 136, '2015-01-01 01:01:38.000000', 'consum', 0.0298, 'lps'),
	(643575, 136, '2015-01-01 01:01:39.000000', 'consum', 0.0308, 'lps'),
	(643576, 136, '2015-01-01 01:01:40.000000', 'consum', 0.0315, 'lps'),
	(643577, 136, '2015-01-01 01:01:41.000000', 'consum', 0.0318, 'lps'),
	(643578, 136, '2015-01-01 01:01:42.000000', 'consum', 0.0309, 'lps'),
	(643579, 136, '2015-01-01 01:01:43.000000', 'consum', 0.0258, 'lps'),
	(643580, 136, '2015-01-01 01:01:44.000000', 'consum', 0.0278, 'lps'),
	(643581, 136, '2015-01-01 01:01:45.000000', 'consum', 0.0283, 'lps'),
	(643582, 136, '2015-01-01 01:01:46.000000', 'consum', 0.0246, 'lps'),
	(643583, 136, '2015-01-01 01:01:47.000000', 'consum', 0.0295, 'lps'),
	(643584, 136, '2015-01-01 01:01:48.000000', 'consum', 0.0282, 'lps'),
	(643585, 136, '2015-01-01 01:01:49.000000', 'consum', 0.0316, 'lps'),
	(643586, 136, '2015-01-01 01:01:50.000000', 'consum', 0.0274, 'lps'),
	(643587, 136, '2015-01-01 01:01:51.000000', 'consum', 0.0215, 'lps'),
	(643588, 136, '2015-01-01 01:01:52.000000', 'consum', 0.0291, 'lps'),
	(643589, 136, '2015-01-01 01:01:53.000000', 'consum', 0.0227, 'lps'),
	(643590, 136, '2015-01-01 01:01:54.000000', 'consum', 0.0303, 'lps'),
	(643591, 136, '2015-01-01 01:01:55.000000', 'consum', 0.0253, 'lps'),
	(643592, 136, '2015-01-01 01:01:56.000000', 'consum', 0.0269, 'lps'),
	(643593, 136, '2015-01-01 01:01:57.000000', 'consum', 0.0252, 'lps'),
	(643594, 136, '2015-01-01 01:01:58.000000', 'consum', 0.0244, 'lps'),
	(643595, 136, '2015-01-01 01:01:59.000000', 'consum', 0.0255, 'lps'),
	(643596, 136, '2015-01-01 01:02:00.000000', 'consum', 0.0332, 'lps'),
	(643597, 136, '2015-01-01 01:02:01.000000', 'consum', 0.0314, 'lps'),
	(643598, 136, '2015-01-01 01:02:02.000000', 'consum', 0.0239, 'lps'),
	(643599, 136, '2015-01-01 01:02:03.000000', 'consum', 0.0291, 'lps'),
	(643600, 136, '2015-01-01 01:02:04.000000', 'consum', 0.0282, 'lps'),
	(643601, 136, '2015-01-01 01:02:05.000000', 'consum', 0.0327, 'lps'),
	(643602, 136, '2015-01-01 01:02:06.000000', 'consum', 0.0333, 'lps'),
	(643603, 136, '2015-01-01 01:02:07.000000', 'consum', 0.0225, 'lps'),
	(643604, 136, '2015-01-01 01:02:08.000000', 'consum', 0.0287, 'lps'),
	(643605, 136, '2015-01-01 01:02:09.000000', 'consum', 0.0304, 'lps'),
	(643606, 136, '2015-01-01 01:02:10.000000', 'consum', 0.0326, 'lps'),
	(643607, 136, '2015-01-01 01:02:11.000000', 'consum', 0.0261, 'lps'),
	(643608, 136, '2015-01-01 01:02:12.000000', 'consum', 0.0243, 'lps'),
	(643609, 136, '2015-01-01 01:02:13.000000', 'consum', 0.0220, 'lps'),
	(643610, 136, '2015-01-01 01:02:14.000000', 'consum', 0.0287, 'lps'),
	(643611, 136, '2015-01-01 01:02:15.000000', 'consum', 0.0316, 'lps'),
	(643612, 136, '2015-01-01 01:02:16.000000', 'consum', 0.0264, 'lps'),
	(643613, 136, '2015-01-01 01:02:17.000000', 'consum', 0.0285, 'lps'),
	(643614, 136, '2015-01-01 01:02:18.000000', 'consum', 0.0300, 'lps'),
	(643615, 136, '2015-01-01 01:02:19.000000', 'consum', 0.0309, 'lps'),
	(643616, 136, '2015-01-01 01:02:20.000000', 'consum', 0.0315, 'lps'),
	(643617, 136, '2015-01-01 01:02:21.000000', 'consum', 0.0312, 'lps'),
	(643618, 136, '2015-01-01 01:02:22.000000', 'consum', 0.0283, 'lps'),
	(643619, 136, '2015-01-01 01:02:23.000000', 'consum', 0.0269, 'lps'),
	(643620, 136, '2015-01-01 01:02:24.000000', 'consum', 0.0286, 'lps'),
	(643621, 136, '2015-01-01 01:02:25.000000', 'consum', 0.0289, 'lps'),
	(643622, 136, '2015-01-01 01:02:26.000000', 'consum', 0.0255, 'lps'),
	(643623, 136, '2015-01-01 01:02:27.000000', 'consum', 0.0322, 'lps'),
	(643624, 136, '2015-01-01 01:02:28.000000', 'consum', 0.0262, 'lps'),
	(643625, 136, '2015-01-01 01:02:29.000000', 'consum', 0.0258, 'lps'),
	(643626, 136, '2015-01-01 01:02:30.000000', 'consum', 0.0297, 'lps'),
	(643627, 136, '2015-01-01 01:02:31.000000', 'consum', 0.0253, 'lps'),
	(643628, 136, '2015-01-01 01:02:32.000000', 'consum', 0.0289, 'lps'),
	(643629, 136, '2015-01-01 01:02:33.000000', 'consum', 0.0228, 'lps'),
	(643630, 136, '2015-01-01 01:02:34.000000', 'consum', 0.0312, 'lps'),
	(643631, 136, '2015-01-01 01:02:35.000000', 'consum', 0.0296, 'lps'),
	(643632, 136, '2015-01-01 01:02:36.000000', 'consum', 0.0331, 'lps'),
	(643633, 136, '2015-01-01 01:02:37.000000', 'consum', 0.0313, 'lps'),
	(643634, 136, '2015-01-01 01:02:38.000000', 'consum', 0.0236, 'lps'),
	(643635, 136, '2015-01-01 01:02:39.000000', 'consum', 0.0279, 'lps'),
	(643636, 136, '2015-01-01 01:02:40.000000', 'consum', 0.0229, 'lps'),
	(643637, 136, '2015-01-01 01:02:41.000000', 'consum', 0.0223, 'lps'),
	(643638, 136, '2015-01-01 01:02:42.000000', 'consum', 0.0218, 'lps'),
	(643639, 136, '2015-01-01 01:02:43.000000', 'consum', 0.0213, 'lps'),
	(643640, 136, '2015-01-01 01:02:44.000000', 'consum', 0.0325, 'lps'),
	(643641, 136, '2015-01-01 01:02:45.000000', 'consum', 0.0280, 'lps'),
	(643642, 136, '2015-01-01 01:02:46.000000', 'consum', 0.0218, 'lps'),
	(643643, 136, '2015-01-01 01:02:47.000000', 'consum', 0.0286, 'lps'),
	(643644, 136, '2015-01-01 01:02:48.000000', 'consum', 0.0318, 'lps'),
	(643645, 136, '2015-01-01 01:02:49.000000', 'consum', 0.0277, 'lps'),
	(643646, 136, '2015-01-01 01:02:50.000000', 'consum', 0.0222, 'lps'),
	(643647, 136, '2015-01-01 01:02:51.000000', 'consum', 0.0315, 'lps'),
	(643648, 136, '2015-01-01 01:02:52.000000', 'consum', 0.0328, 'lps'),
	(643649, 136, '2015-01-01 01:02:53.000000', 'consum', 0.0236, 'lps'),
	(643650, 136, '2015-01-01 01:02:54.000000', 'consum', 0.0238, 'lps'),
	(643651, 136, '2015-01-01 01:02:55.000000', 'consum', 0.0269, 'lps'),
	(643652, 136, '2015-01-01 01:02:56.000000', 'consum', 0.0300, 'lps'),
	(643653, 136, '2015-01-01 01:02:57.000000', 'consum', 0.0237, 'lps'),
	(643654, 136, '2015-01-01 01:02:58.000000', 'consum', 0.0320, 'lps'),
	(643655, 136, '2015-01-01 01:02:59.000000', 'consum', 0.0311, 'lps'),
	(643656, 136, '2015-01-01 01:03:00.000000', 'consum', 0.0258, 'lps'),
	(643657, 136, '2015-01-01 01:03:01.000000', 'consum', 0.0275, 'lps'),
	(643658, 136, '2015-01-01 01:03:02.000000', 'consum', 0.0265, 'lps'),
	(643659, 136, '2015-01-01 01:03:03.000000', 'consum', 0.0289, 'lps'),
	(643660, 136, '2015-01-01 01:03:04.000000', 'consum', 0.0320, 'lps'),
	(643661, 136, '2015-01-01 01:03:05.000000', 'consum', 0.0273, 'lps'),
	(643662, 136, '2015-01-01 01:03:06.000000', 'consum', 0.0320, 'lps'),
	(643663, 136, '2015-01-01 01:03:07.000000', 'consum', 0.0322, 'lps'),
	(643664, 136, '2015-01-01 01:03:08.000000', 'consum', 0.0317, 'lps'),
	(643665, 136, '2015-01-01 01:03:09.000000', 'consum', 0.0288, 'lps'),
	(643666, 136, '2015-01-01 01:03:10.000000', 'consum', 0.0277, 'lps'),
	(643667, 136, '2015-01-01 01:03:11.000000', 'consum', 0.0310, 'lps'),
	(643668, 136, '2015-01-01 01:03:12.000000', 'consum', 0.0265, 'lps'),
	(643669, 136, '2015-01-01 01:03:13.000000', 'consum', 0.0309, 'lps'),
	(643670, 136, '2015-01-01 01:03:14.000000', 'consum', 0.0290, 'lps'),
	(643671, 136, '2015-01-01 01:03:15.000000', 'consum', 0.0316, 'lps'),
	(643672, 136, '2015-01-01 01:03:16.000000', 'consum', 0.0253, 'lps'),
	(643673, 136, '2015-01-01 01:03:17.000000', 'consum', 0.0232, 'lps'),
	(643674, 136, '2015-01-01 01:03:18.000000', 'consum', 0.0313, 'lps'),
	(643675, 136, '2015-01-01 01:03:19.000000', 'consum', 0.0289, 'lps'),
	(643676, 136, '2015-01-01 01:03:20.000000', 'consum', 0.0297, 'lps'),
	(643677, 136, '2015-01-01 01:03:21.000000', 'consum', 0.0283, 'lps'),
	(643678, 136, '2015-01-01 01:03:22.000000', 'consum', 0.0315, 'lps'),
	(643679, 136, '2015-01-01 01:03:23.000000', 'consum', 0.0270, 'lps'),
	(643680, 136, '2015-01-01 01:03:24.000000', 'consum', 0.0319, 'lps'),
	(643681, 136, '2015-01-01 01:03:25.000000', 'consum', 0.0325, 'lps'),
	(643682, 136, '2015-01-01 01:03:26.000000', 'consum', 0.0213, 'lps'),
	(643683, 136, '2015-01-01 01:03:27.000000', 'consum', 0.0251, 'lps'),
	(643684, 136, '2015-01-01 01:03:28.000000', 'consum', 0.0284, 'lps'),
	(643685, 136, '2015-01-01 01:03:29.000000', 'consum', 0.0333, 'lps'),
	(643686, 136, '2015-01-01 01:03:30.000000', 'consum', 0.0230, 'lps'),
	(643687, 136, '2015-01-01 01:03:31.000000', 'consum', 0.0313, 'lps'),
	(643688, 136, '2015-01-01 01:03:32.000000', 'consum', 0.0293, 'lps'),
	(643689, 136, '2015-01-01 01:03:33.000000', 'consum', 0.0317, 'lps'),
	(643690, 136, '2015-01-01 01:03:34.000000', 'consum', 0.0251, 'lps'),
	(643691, 136, '2015-01-01 01:03:35.000000', 'consum', 0.0216, 'lps'),
	(643692, 136, '2015-01-01 01:03:36.000000', 'consum', 0.0242, 'lps'),
	(643693, 136, '2015-01-01 01:03:37.000000', 'consum', 0.0227, 'lps'),
	(643694, 136, '2015-01-01 01:03:38.000000', 'consum', 0.0323, 'lps'),
	(643695, 136, '2015-01-01 01:03:39.000000', 'consum', 0.0229, 'lps'),
	(643696, 136, '2015-01-01 01:03:40.000000', 'consum', 0.0215, 'lps'),
	(643697, 136, '2015-01-01 01:03:41.000000', 'consum', 0.0302, 'lps'),
	(643698, 136, '2015-01-01 01:03:42.000000', 'consum', 0.0283, 'lps'),
	(643699, 136, '2015-01-01 01:03:43.000000', 'consum', 0.0301, 'lps'),
	(643700, 136, '2015-01-01 01:03:44.000000', 'consum', 0.0321, 'lps'),
	(643701, 136, '2015-01-01 01:03:45.000000', 'consum', 0.0246, 'lps'),
	(643702, 136, '2015-01-01 01:03:46.000000', 'consum', 0.0303, 'lps'),
	(643703, 136, '2015-01-01 01:03:47.000000', 'consum', 0.0322, 'lps'),
	(643704, 136, '2015-01-01 01:03:48.000000', 'consum', 0.0243, 'lps'),
	(643705, 136, '2015-01-01 01:03:49.000000', 'consum', 0.0288, 'lps'),
	(643706, 136, '2015-01-01 01:03:50.000000', 'consum', 0.0255, 'lps'),
	(643707, 136, '2015-01-01 01:03:51.000000', 'consum', 0.0322, 'lps'),
	(643708, 136, '2015-01-01 01:03:52.000000', 'consum', 0.0265, 'lps'),
	(643709, 136, '2015-01-01 01:03:53.000000', 'consum', 0.0273, 'lps'),
	(643710, 136, '2015-01-01 01:03:54.000000', 'consum', 0.0238, 'lps'),
	(643711, 136, '2015-01-01 01:03:55.000000', 'consum', 0.0284, 'lps'),
	(643712, 136, '2015-01-01 01:03:56.000000', 'consum', 0.0248, 'lps'),
	(643713, 136, '2015-01-01 01:03:57.000000', 'consum', 0.0302, 'lps'),
	(643714, 136, '2015-01-01 01:03:58.000000', 'consum', 0.0311, 'lps'),
	(643715, 136, '2015-01-01 01:03:59.000000', 'consum', 0.0314, 'lps'),
	(643716, 136, '2015-01-01 01:04:00.000000', 'consum', 0.0303, 'lps'),
	(643717, 136, '2015-01-01 01:04:01.000000', 'consum', 0.0238, 'lps'),
	(643718, 136, '2015-01-01 01:04:02.000000', 'consum', 0.0322, 'lps'),
	(643719, 136, '2015-01-01 01:04:03.000000', 'consum', 0.0312, 'lps'),
	(643720, 136, '2015-01-01 01:04:04.000000', 'consum', 0.0261, 'lps'),
	(643721, 136, '2015-01-01 01:04:05.000000', 'consum', 0.0286, 'lps'),
	(643722, 136, '2015-01-01 01:04:06.000000', 'consum', 0.0312, 'lps'),
	(643723, 136, '2015-01-01 01:04:07.000000', 'consum', 0.0245, 'lps'),
	(643724, 136, '2015-01-01 01:04:08.000000', 'consum', 0.0329, 'lps'),
	(643725, 136, '2015-01-01 01:04:09.000000', 'consum', 0.0327, 'lps'),
	(643726, 136, '2015-01-01 01:04:10.000000', 'consum', 0.0316, 'lps'),
	(643727, 136, '2015-01-01 01:04:11.000000', 'consum', 0.0265, 'lps'),
	(643728, 136, '2015-01-01 01:04:12.000000', 'consum', 0.0292, 'lps'),
	(643729, 136, '2015-01-01 01:04:13.000000', 'consum', 0.0330, 'lps'),
	(643730, 136, '2015-01-01 01:04:14.000000', 'consum', 0.0318, 'lps'),
	(643731, 136, '2015-01-01 01:04:15.000000', 'consum', 0.0266, 'lps'),
	(643732, 136, '2015-01-01 01:04:16.000000', 'consum', 0.0292, 'lps'),
	(643733, 136, '2015-01-01 01:04:17.000000', 'consum', 0.0328, 'lps'),
	(643734, 136, '2015-01-01 01:04:18.000000', 'consum', 0.0306, 'lps'),
	(643735, 136, '2015-01-01 01:04:19.000000', 'consum', 0.0213, 'lps'),
	(643736, 136, '2015-01-01 01:04:20.000000', 'consum', 0.0310, 'lps'),
	(643737, 136, '2015-01-01 01:04:21.000000', 'consum', 0.0327, 'lps'),
	(643738, 136, '2015-01-01 01:04:22.000000', 'consum', 0.0249, 'lps'),
	(643739, 136, '2015-01-01 01:04:23.000000', 'consum', 0.0304, 'lps'),
	(643740, 136, '2015-01-01 01:04:24.000000', 'consum', 0.0314, 'lps'),
	(643741, 136, '2015-01-01 01:04:25.000000', 'consum', 0.0325, 'lps'),
	(643742, 136, '2015-01-01 01:04:26.000000', 'consum', 0.0227, 'lps'),
	(643743, 136, '2015-01-01 01:04:27.000000', 'consum', 0.0322, 'lps'),
	(643744, 136, '2015-01-01 01:04:28.000000', 'consum', 0.0222, 'lps'),
	(643745, 136, '2015-01-01 01:04:29.000000', 'consum', 0.0309, 'lps'),
	(643746, 136, '2015-01-01 01:04:30.000000', 'consum', 0.0298, 'lps'),
	(643747, 136, '2015-01-01 01:04:31.000000', 'consum', 0.0226, 'lps'),
	(643748, 136, '2015-01-01 01:04:32.000000', 'consum', 0.0277, 'lps'),
	(643749, 136, '2015-01-01 01:04:33.000000', 'consum', 0.0249, 'lps'),
	(643750, 136, '2015-01-01 01:04:34.000000', 'consum', 0.0330, 'lps'),
	(643751, 136, '2015-01-01 01:04:35.000000', 'consum', 0.0320, 'lps'),
	(643752, 136, '2015-01-01 01:04:36.000000', 'consum', 0.0277, 'lps'),
	(643753, 136, '2015-01-01 01:04:37.000000', 'consum', 0.0215, 'lps'),
	(643754, 136, '2015-01-01 01:04:38.000000', 'consum', 0.0285, 'lps'),
	(643755, 136, '2015-01-01 01:04:39.000000', 'consum', 0.0319, 'lps'),
	(643756, 136, '2015-01-01 01:04:40.000000', 'consum', 0.0285, 'lps'),
	(643757, 136, '2015-01-01 01:04:41.000000', 'consum', 0.0257, 'lps'),
	(643758, 136, '2015-01-01 01:04:42.000000', 'consum', 0.0219, 'lps'),
	(643759, 136, '2015-01-01 01:04:43.000000', 'consum', 0.0240, 'lps'),
	(643760, 136, '2015-01-01 01:04:44.000000', 'consum', 0.0210, 'lps'),
	(643761, 136, '2015-01-01 01:04:45.000000', 'consum', 0.0242, 'lps'),
	(643762, 136, '2015-01-01 01:04:46.000000', 'consum', 0.0249, 'lps'),
	(643763, 136, '2015-01-01 01:04:47.000000', 'consum', 0.0308, 'lps'),
	(643764, 136, '2015-01-01 01:04:48.000000', 'consum', 0.0213, 'lps'),
	(643765, 136, '2015-01-01 01:04:49.000000', 'consum', 0.0301, 'lps'),
	(643766, 136, '2015-01-01 01:04:50.000000', 'consum', 0.0288, 'lps'),
	(643767, 136, '2015-01-01 01:04:51.000000', 'consum', 0.0325, 'lps'),
	(643768, 136, '2015-01-01 01:04:52.000000', 'consum', 0.0303, 'lps'),
	(643769, 136, '2015-01-01 01:04:53.000000', 'consum', 0.0332, 'lps'),
	(643770, 136, '2015-01-01 01:04:54.000000', 'consum', 0.0292, 'lps'),
	(643771, 136, '2015-01-01 01:04:55.000000', 'consum', 0.0257, 'lps'),
	(643772, 136, '2015-01-01 01:04:56.000000', 'consum', 0.0322, 'lps'),
	(643773, 136, '2015-01-01 01:04:57.000000', 'consum', 0.0259, 'lps'),
	(643774, 136, '2015-01-01 01:04:58.000000', 'consum', 0.0241, 'lps'),
	(643775, 136, '2015-01-01 01:04:59.000000', 'consum', 0.0218, 'lps'),
	(643776, 136, '2015-01-01 01:05:00.000000', 'consum', 0.0280, 'lps'),
	(643777, 136, '2015-01-01 01:05:01.000000', 'consum', 0.0292, 'lps'),
	(643778, 136, '2015-01-01 01:05:02.000000', 'consum', 0.0287, 'lps'),
	(643779, 136, '2015-01-01 01:05:03.000000', 'consum', 0.0225, 'lps'),
	(643780, 136, '2015-01-01 01:05:04.000000', 'consum', 0.0304, 'lps'),
	(643781, 136, '2015-01-01 01:05:05.000000', 'consum', 0.0263, 'lps'),
	(643782, 136, '2015-01-01 01:05:06.000000', 'consum', 0.0316, 'lps'),
	(643783, 136, '2015-01-01 01:05:07.000000', 'consum', 0.0333, 'lps'),
	(643784, 136, '2015-01-01 01:05:08.000000', 'consum', 0.0259, 'lps'),
	(643785, 136, '2015-01-01 01:05:09.000000', 'consum', 0.0212, 'lps'),
	(643786, 136, '2015-01-01 01:05:10.000000', 'consum', 0.0320, 'lps'),
	(643787, 136, '2015-01-01 01:05:11.000000', 'consum', 0.0260, 'lps'),
	(643788, 136, '2015-01-01 01:05:12.000000', 'consum', 0.0254, 'lps'),
	(643789, 136, '2015-01-01 01:05:13.000000', 'consum', 0.0282, 'lps'),
	(643790, 136, '2015-01-01 01:05:14.000000', 'consum', 0.0315, 'lps'),
	(643791, 136, '2015-01-01 01:05:15.000000', 'consum', 0.0269, 'lps'),
	(643792, 136, '2015-01-01 01:05:16.000000', 'consum', 0.0314, 'lps'),
	(643793, 136, '2015-01-01 01:05:17.000000', 'consum', 0.0307, 'lps'),
	(643794, 136, '2015-01-01 01:05:18.000000', 'consum', 0.0260, 'lps'),
	(643795, 136, '2015-01-01 01:05:19.000000', 'consum', 0.0292, 'lps'),
	(643796, 136, '2015-01-01 01:05:20.000000', 'consum', 0.0222, 'lps'),
	(643797, 136, '2015-01-01 01:05:21.000000', 'consum', 0.0271, 'lps'),
	(643798, 136, '2015-01-01 01:05:22.000000', 'consum', 0.0234, 'lps'),
	(643799, 136, '2015-01-01 01:05:23.000000', 'consum', 0.0272, 'lps'),
	(643800, 136, '2015-01-01 01:05:24.000000', 'consum', 0.0323, 'lps'),
	(643801, 136, '2015-01-01 01:05:25.000000', 'consum', 0.0218, 'lps'),
	(643802, 136, '2015-01-01 01:05:26.000000', 'consum', 0.0283, 'lps'),
	(643803, 136, '2015-01-01 01:05:27.000000', 'consum', 0.0303, 'lps'),
	(643804, 136, '2015-01-01 01:05:28.000000', 'consum', 0.0332, 'lps'),
	(643805, 136, '2015-01-01 01:05:29.000000', 'consum', 0.0292, 'lps'),
	(643806, 136, '2015-01-01 01:05:30.000000', 'consum', 0.0257, 'lps'),
	(643807, 136, '2015-01-01 01:05:31.000000', 'consum', 0.0321, 'lps'),
	(643808, 136, '2015-01-01 01:05:32.000000', 'consum', 0.0254, 'lps'),
	(643809, 136, '2015-01-01 01:05:33.000000', 'consum', 0.0221, 'lps'),
	(643810, 136, '2015-01-01 01:05:34.000000', 'consum', 0.0258, 'lps'),
	(643811, 136, '2015-01-01 01:05:35.000000', 'consum', 0.0294, 'lps'),
	(643812, 136, '2015-01-01 01:05:36.000000', 'consum', 0.0239, 'lps'),
	(643813, 136, '2015-01-01 01:05:37.000000', 'consum', 0.0229, 'lps'),
	(643814, 136, '2015-01-01 01:05:38.000000', 'consum', 0.0215, 'lps'),
	(643815, 136, '2015-01-01 01:05:39.000000', 'consum', 0.0303, 'lps'),
	(643816, 136, '2015-01-01 01:05:40.000000', 'consum', 0.0291, 'lps'),
	(643817, 136, '2015-01-01 01:05:41.000000', 'consum', 0.0333, 'lps'),
	(643818, 136, '2015-01-01 01:05:42.000000', 'consum', 0.0213, 'lps'),
	(643819, 136, '2015-01-01 01:05:43.000000', 'consum', 0.0227, 'lps'),
	(643820, 136, '2015-01-01 01:05:44.000000', 'consum', 0.0285, 'lps'),
	(643821, 136, '2015-01-01 01:05:45.000000', 'consum', 0.0290, 'lps'),
	(643822, 136, '2015-01-01 01:05:46.000000', 'consum', 0.0260, 'lps'),
	(643823, 136, '2015-01-01 01:05:47.000000', 'consum', 0.0222, 'lps'),
	(643824, 136, '2015-01-01 01:05:48.000000', 'consum', 0.0242, 'lps'),
	(643825, 136, '2015-01-01 01:05:49.000000', 'consum', 0.0210, 'lps'),
	(643826, 136, '2015-01-01 01:05:50.000000', 'consum', 0.0241, 'lps'),
	(643827, 136, '2015-01-01 01:05:51.000000', 'consum', 0.0240, 'lps'),
	(643828, 136, '2015-01-01 01:05:52.000000', 'consum', 0.0269, 'lps'),
	(643829, 136, '2015-01-01 01:05:53.000000', 'consum', 0.0292, 'lps'),
	(643830, 136, '2015-01-01 01:05:54.000000', 'consum', 0.0319, 'lps'),
	(643831, 136, '2015-01-01 01:05:55.000000', 'consum', 0.0259, 'lps'),
	(643832, 136, '2015-01-01 01:05:56.000000', 'consum', 0.0255, 'lps'),
	(643833, 136, '2015-01-01 01:05:57.000000', 'consum', 0.0289, 'lps'),
	(643834, 136, '2015-01-01 01:05:58.000000', 'consum', 0.0224, 'lps'),
	(643835, 136, '2015-01-01 01:05:59.000000', 'consum', 0.0289, 'lps'),
	(643836, 136, '2015-01-01 01:06:00.000000', 'consum', 0.0317, 'lps'),
	(643837, 136, '2015-01-01 01:06:01.000000', 'consum', 0.0258, 'lps'),
	(643838, 136, '2015-01-01 01:06:02.000000', 'consum', 0.0254, 'lps'),
	(643839, 136, '2015-01-01 01:06:03.000000', 'consum', 0.0287, 'lps'),
	(643840, 136, '2015-01-01 01:06:04.000000', 'consum', 0.0214, 'lps'),
	(643841, 136, '2015-01-01 01:06:05.000000', 'consum', 0.0246, 'lps'),
	(643842, 136, '2015-01-01 01:06:06.000000', 'consum', 0.0258, 'lps'),
	(643843, 136, '2015-01-01 01:06:07.000000', 'consum', 0.0219, 'lps'),
	(643844, 136, '2015-01-01 01:06:08.000000', 'consum', 0.0233, 'lps'),
	(643845, 136, '2015-01-01 01:06:09.000000', 'consum', 0.0301, 'lps'),
	(643846, 136, '2015-01-01 01:06:10.000000', 'consum', 0.0223, 'lps'),
	(643847, 136, '2015-01-01 01:06:11.000000', 'consum', 0.0249, 'lps'),
	(643848, 136, '2015-01-01 01:06:12.000000', 'consum', 0.0245, 'lps'),
	(643849, 136, '2015-01-01 01:06:13.000000', 'consum', 0.0268, 'lps'),
	(643850, 136, '2015-01-01 01:06:14.000000', 'consum', 0.0273, 'lps'),
	(643851, 136, '2015-01-01 01:06:15.000000', 'consum', 0.0227, 'lps'),
	(643852, 136, '2015-01-01 01:06:16.000000', 'consum', 0.0231, 'lps'),
	(643853, 136, '2015-01-01 01:06:17.000000', 'consum', 0.0262, 'lps'),
	(643854, 136, '2015-01-01 01:06:18.000000', 'consum', 0.0285, 'lps'),
	(643855, 136, '2015-01-01 01:06:19.000000', 'consum', 0.0304, 'lps'),
	(643856, 136, '2015-01-01 01:06:20.000000', 'consum', 0.0210, 'lps'),
	(643857, 136, '2015-01-01 01:06:21.000000', 'consum', 0.0298, 'lps'),
	(643858, 136, '2015-01-01 01:06:22.000000', 'consum', 0.0278, 'lps'),
	(643859, 136, '2015-01-01 01:06:23.000000', 'consum', 0.0286, 'lps'),
	(643860, 136, '2015-01-01 01:06:24.000000', 'consum', 0.0262, 'lps'),
	(643861, 136, '2015-01-01 01:06:25.000000', 'consum', 0.0244, 'lps'),
	(643862, 136, '2015-01-01 01:06:26.000000', 'consum', 0.0224, 'lps'),
	(643863, 136, '2015-01-01 01:06:27.000000', 'consum', 0.0302, 'lps'),
	(643864, 136, '2015-01-01 01:06:28.000000', 'consum', 0.0258, 'lps'),
	(643865, 136, '2015-01-01 01:06:29.000000', 'consum', 0.0296, 'lps'),
	(643866, 136, '2015-01-01 01:06:30.000000', 'consum', 0.0251, 'lps'),
	(643867, 136, '2015-01-01 01:06:31.000000', 'consum', 0.0282, 'lps'),
	(643868, 136, '2015-01-01 01:06:32.000000', 'consum', 0.0321, 'lps'),
	(643869, 136, '2015-01-01 01:06:33.000000', 'consum', 0.0301, 'lps'),
	(643870, 136, '2015-01-01 01:06:34.000000', 'consum', 0.0332, 'lps'),
	(643871, 136, '2015-01-01 01:06:35.000000', 'consum', 0.0303, 'lps'),
	(643872, 136, '2015-01-01 01:06:36.000000', 'consum', 0.0306, 'lps'),
	(643873, 136, '2015-01-01 01:06:37.000000', 'consum', 0.0288, 'lps'),
	(643874, 136, '2015-01-01 01:06:38.000000', 'consum', 0.0314, 'lps'),
	(643875, 136, '2015-01-01 01:06:39.000000', 'consum', 0.0247, 'lps'),
	(643876, 136, '2015-01-01 01:06:40.000000', 'consum', 0.0332, 'lps'),
	(643877, 136, '2015-01-01 01:06:41.000000', 'consum', 0.0214, 'lps'),
	(643878, 136, '2015-01-01 01:06:42.000000', 'consum', 0.0234, 'lps'),
	(643879, 136, '2015-01-01 01:06:43.000000', 'consum', 0.0321, 'lps'),
	(643880, 136, '2015-01-01 01:06:44.000000', 'consum', 0.0319, 'lps'),
	(643881, 136, '2015-01-01 01:06:45.000000', 'consum', 0.0301, 'lps'),
	(643882, 136, '2015-01-01 01:06:46.000000', 'consum', 0.0216, 'lps'),
	(643883, 136, '2015-01-01 01:06:47.000000', 'consum', 0.0213, 'lps'),
	(643884, 136, '2015-01-01 01:06:48.000000', 'consum', 0.0332, 'lps'),
	(643885, 136, '2015-01-01 01:06:49.000000', 'consum', 0.0315, 'lps'),
	(643886, 136, '2015-01-01 01:06:50.000000', 'consum', 0.0246, 'lps'),
	(643887, 136, '2015-01-01 01:06:51.000000', 'consum', 0.0324, 'lps'),
	(643888, 136, '2015-01-01 01:06:52.000000', 'consum', 0.0300, 'lps'),
	(643889, 136, '2015-01-01 01:06:53.000000', 'consum', 0.0318, 'lps'),
	(643890, 136, '2015-01-01 01:06:54.000000', 'consum', 0.0233, 'lps'),
	(643891, 136, '2015-01-01 01:06:55.000000', 'consum', 0.0247, 'lps'),
	(643892, 136, '2015-01-01 01:06:56.000000', 'consum', 0.0330, 'lps'),
	(643893, 136, '2015-01-01 01:06:57.000000', 'consum', 0.0327, 'lps'),
	(643894, 136, '2015-01-01 01:06:58.000000', 'consum', 0.0311, 'lps'),
	(643895, 136, '2015-01-01 01:06:59.000000', 'consum', 0.0241, 'lps'),
	(643896, 136, '2015-01-01 01:07:00.000000', 'consum', 0.0308, 'lps'),
	(643897, 136, '2015-01-01 01:07:01.000000', 'consum', 0.0237, 'lps'),
	(643898, 136, '2015-01-01 01:07:02.000000', 'consum', 0.0300, 'lps'),
	(643899, 136, '2015-01-01 01:07:03.000000', 'consum', 0.0332, 'lps'),
	(643900, 136, '2015-01-01 01:07:04.000000', 'consum', 0.0304, 'lps'),
	(643901, 136, '2015-01-01 01:07:05.000000', 'consum', 0.0312, 'lps'),
	(643902, 136, '2015-01-01 01:07:06.000000', 'consum', 0.0315, 'lps'),
	(643903, 136, '2015-01-01 01:07:07.000000', 'consum', 0.0304, 'lps'),
	(643904, 136, '2015-01-01 01:07:08.000000', 'consum', 0.0241, 'lps'),
	(643905, 136, '2015-01-01 01:07:09.000000', 'consum', 0.0333, 'lps'),
	(643906, 136, '2015-01-01 01:07:10.000000', 'consum', 0.0234, 'lps'),
	(643907, 136, '2015-01-01 01:07:11.000000', 'consum', 0.0213, 'lps'),
	(643908, 136, '2015-01-01 01:07:12.000000', 'consum', 0.0277, 'lps'),
	(643909, 136, '2015-01-01 01:07:13.000000', 'consum', 0.0287, 'lps'),
	(643910, 136, '2015-01-01 01:07:14.000000', 'consum', 0.0270, 'lps'),
	(643911, 136, '2015-01-01 01:07:15.000000', 'consum', 0.0279, 'lps'),
	(643912, 136, '2015-01-01 01:07:16.000000', 'consum', 0.0254, 'lps'),
	(643913, 136, '2015-01-01 01:07:17.000000', 'consum', 0.0220, 'lps'),
	(643914, 136, '2015-01-01 01:07:18.000000', 'consum', 0.0256, 'lps'),
	(643915, 136, '2015-01-01 01:07:19.000000', 'consum', 0.0283, 'lps'),
	(643916, 136, '2015-01-01 01:07:20.000000', 'consum', 0.0317, 'lps'),
	(643917, 136, '2015-01-01 01:07:21.000000', 'consum', 0.0276, 'lps'),
	(643918, 136, '2015-01-01 01:07:22.000000', 'consum', 0.0220, 'lps'),
	(643919, 136, '2015-01-01 01:07:23.000000', 'consum', 0.0311, 'lps'),
	(643920, 136, '2015-01-01 01:07:24.000000', 'consum', 0.0315, 'lps'),
	(643921, 136, '2015-01-01 01:07:25.000000', 'consum', 0.0307, 'lps'),
	(643922, 136, '2015-01-01 01:07:26.000000', 'consum', 0.0258, 'lps'),
	(643923, 136, '2015-01-01 01:07:27.000000', 'consum', 0.0283, 'lps'),
	(643924, 136, '2015-01-01 01:07:28.000000', 'consum', 0.0308, 'lps'),
	(643925, 136, '2015-01-01 01:07:29.000000', 'consum', 0.0234, 'lps'),
	(643926, 136, '2015-01-01 01:07:30.000000', 'consum', 0.0285, 'lps'),
	(643927, 136, '2015-01-01 01:07:31.000000', 'consum', 0.0263, 'lps'),
	(643928, 136, '2015-01-01 01:07:32.000000', 'consum', 0.0252, 'lps'),
	(643929, 136, '2015-01-01 01:07:33.000000', 'consum', 0.0261, 'lps'),
	(643930, 136, '2015-01-01 01:07:34.000000', 'consum', 0.0216, 'lps'),
	(643931, 136, '2015-01-01 01:07:35.000000', 'consum', 0.0212, 'lps'),
	(643932, 136, '2015-01-01 01:07:36.000000', 'consum', 0.0325, 'lps'),
	(643933, 136, '2015-01-01 01:07:37.000000', 'consum', 0.0286, 'lps'),
	(643934, 136, '2015-01-01 01:07:38.000000', 'consum', 0.0243, 'lps'),
	(643935, 136, '2015-01-01 01:07:39.000000', 'consum', 0.0271, 'lps'),
	(643936, 136, '2015-01-01 01:07:40.000000', 'consum', 0.0293, 'lps'),
	(643937, 136, '2015-01-01 01:07:41.000000', 'consum', 0.0318, 'lps'),
	(643938, 136, '2015-01-01 01:07:42.000000', 'consum', 0.0254, 'lps'),
	(643939, 136, '2015-01-01 01:07:43.000000', 'consum', 0.0230, 'lps'),
	(643940, 136, '2015-01-01 01:07:44.000000', 'consum', 0.0304, 'lps'),
	(643941, 136, '2015-01-01 01:07:45.000000', 'consum', 0.0250, 'lps'),
	(643942, 136, '2015-01-01 01:07:46.000000', 'consum', 0.0249, 'lps'),
	(643943, 136, '2015-01-01 01:07:47.000000', 'consum', 0.0286, 'lps'),
	(643944, 136, '2015-01-01 01:07:48.000000', 'consum', 0.0227, 'lps'),
	(643945, 136, '2015-01-01 01:07:49.000000', 'consum', 0.0313, 'lps'),
	(643946, 136, '2015-01-01 01:07:50.000000', 'consum', 0.0305, 'lps'),
	(643947, 136, '2015-01-01 01:07:51.000000', 'consum', 0.0253, 'lps'),
	(643948, 136, '2015-01-01 01:07:52.000000', 'consum', 0.0262, 'lps'),
	(643949, 136, '2015-01-01 01:07:53.000000', 'consum', 0.0219, 'lps'),
	(643950, 136, '2015-01-01 01:07:54.000000', 'consum', 0.0225, 'lps'),
	(643951, 136, '2015-01-01 01:07:55.000000', 'consum', 0.0258, 'lps'),
	(643952, 136, '2015-01-01 01:07:56.000000', 'consum', 0.0280, 'lps'),
	(643953, 136, '2015-01-01 01:07:57.000000', 'consum', 0.0293, 'lps'),
	(643954, 136, '2015-01-01 01:07:58.000000', 'consum', 0.0292, 'lps'),
	(643955, 136, '2015-01-01 01:07:59.000000', 'consum', 0.0247, 'lps'),
	(643956, 136, '2015-01-01 01:08:00.000000', 'consum', 0.0273, 'lps'),
	(643957, 136, '2015-01-01 01:08:01.000000', 'consum', 0.0291, 'lps'),
	(643958, 136, '2015-01-01 01:08:02.000000', 'consum', 0.0301, 'lps'),
	(643959, 136, '2015-01-01 01:08:03.000000', 'consum', 0.0301, 'lps'),
	(643960, 136, '2015-01-01 01:08:04.000000', 'consum', 0.0267, 'lps'),
	(643961, 136, '2015-01-01 01:08:05.000000', 'consum', 0.0224, 'lps'),
	(643962, 136, '2015-01-01 01:08:06.000000', 'consum', 0.0231, 'lps'),
	(643963, 136, '2015-01-01 01:08:07.000000', 'consum', 0.0273, 'lps'),
	(643964, 136, '2015-01-01 01:08:08.000000', 'consum', 0.0215, 'lps'),
	(643965, 136, '2015-01-01 01:08:09.000000', 'consum', 0.0293, 'lps'),
	(643966, 136, '2015-01-01 01:08:10.000000', 'consum', 0.0241, 'lps'),
	(643967, 136, '2015-01-01 01:08:11.000000', 'consum', 0.0241, 'lps'),
	(643968, 136, '2015-01-01 01:08:12.000000', 'consum', 0.0272, 'lps'),
	(643969, 136, '2015-01-01 01:08:13.000000', 'consum', 0.0303, 'lps'),
	(643970, 136, '2015-01-01 01:08:14.000000', 'consum', 0.0244, 'lps'),
	(643971, 136, '2015-01-01 01:08:15.000000', 'consum', 0.0223, 'lps'),
	(643972, 136, '2015-01-01 01:08:16.000000', 'consum', 0.0296, 'lps'),
	(643973, 136, '2015-01-01 01:08:17.000000', 'consum', 0.0232, 'lps'),
	(643974, 136, '2015-01-01 01:08:18.000000', 'consum', 0.0309, 'lps'),
	(643975, 136, '2015-01-01 01:08:19.000000', 'consum', 0.0269, 'lps'),
	(643976, 136, '2015-01-01 01:08:20.000000', 'consum', 0.0332, 'lps'),
	(643977, 136, '2015-01-01 01:08:21.000000', 'consum', 0.0272, 'lps'),
	(643978, 136, '2015-01-01 01:08:22.000000', 'consum', 0.0279, 'lps'),
	(643979, 136, '2015-01-01 01:08:23.000000', 'consum', 0.0247, 'lps'),
	(643980, 136, '2015-01-01 01:08:24.000000', 'consum', 0.0310, 'lps'),
	(643981, 136, '2015-01-01 01:08:25.000000', 'consum', 0.0229, 'lps'),
	(643982, 136, '2015-01-01 01:08:26.000000', 'consum', 0.0252, 'lps'),
	(643983, 136, '2015-01-01 01:08:27.000000', 'consum', 0.0239, 'lps'),
	(643984, 136, '2015-01-01 01:08:28.000000', 'consum', 0.0229, 'lps'),
	(643985, 136, '2015-01-01 01:08:29.000000', 'consum', 0.0218, 'lps'),
	(643986, 136, '2015-01-01 01:08:30.000000', 'consum', 0.0317, 'lps'),
	(643987, 136, '2015-01-01 01:08:31.000000', 'consum', 0.0229, 'lps'),
	(643988, 136, '2015-01-01 01:08:32.000000', 'consum', 0.0229, 'lps'),
	(643989, 136, '2015-01-01 01:08:33.000000', 'consum', 0.0251, 'lps'),
	(643990, 136, '2015-01-01 01:08:34.000000', 'consum', 0.0232, 'lps'),
	(643991, 136, '2015-01-01 01:08:35.000000', 'consum', 0.0321, 'lps'),
	(643992, 136, '2015-01-01 01:08:36.000000', 'consum', 0.0330, 'lps'),
	(643993, 136, '2015-01-01 01:08:37.000000', 'consum', 0.0228, 'lps'),
	(643994, 136, '2015-01-01 01:08:38.000000', 'consum', 0.0313, 'lps'),
	(643995, 136, '2015-01-01 01:08:39.000000', 'consum', 0.0298, 'lps'),
	(643996, 136, '2015-01-01 01:08:40.000000', 'consum', 0.0217, 'lps'),
	(643997, 136, '2015-01-01 01:08:41.000000', 'consum', 0.0232, 'lps'),
	(643998, 136, '2015-01-01 01:08:42.000000', 'consum', 0.0299, 'lps'),
	(643999, 136, '2015-01-01 01:08:43.000000', 'consum', 0.0215, 'lps'),
	(644000, 136, '2015-01-01 01:08:44.000000', 'consum', 0.0218, 'lps'),
	(644001, 136, '2015-01-01 01:08:45.000000', 'consum', 0.0238, 'lps'),
	(644002, 136, '2015-01-01 01:08:46.000000', 'consum', 0.0323, 'lps'),
	(644003, 136, '2015-01-01 01:08:47.000000', 'consum', 0.0321, 'lps'),
	(644004, 136, '2015-01-01 01:08:48.000000', 'consum', 0.0304, 'lps'),
	(644005, 136, '2015-01-01 01:08:49.000000', 'consum', 0.0223, 'lps'),
	(644006, 136, '2015-01-01 01:08:50.000000', 'consum', 0.0240, 'lps'),
	(644007, 136, '2015-01-01 01:08:51.000000', 'consum', 0.0321, 'lps'),
	(644008, 136, '2015-01-01 01:08:52.000000', 'consum', 0.0303, 'lps'),
	(644009, 136, '2015-01-01 01:08:53.000000', 'consum', 0.0217, 'lps'),
	(644010, 136, '2015-01-01 01:08:54.000000', 'consum', 0.0218, 'lps'),
	(644011, 136, '2015-01-01 01:08:55.000000', 'consum', 0.0229, 'lps'),
	(644012, 136, '2015-01-01 01:08:56.000000', 'consum', 0.0280, 'lps'),
	(644013, 136, '2015-01-01 01:08:57.000000', 'consum', 0.0256, 'lps'),
	(644014, 136, '2015-01-01 01:08:58.000000', 'consum', 0.0231, 'lps'),
	(644015, 136, '2015-01-01 01:08:59.000000', 'consum', 0.0300, 'lps'),
	(644016, 136, '2015-01-01 01:09:00.000000', 'consum', 0.0226, 'lps'),
	(644017, 136, '2015-01-01 01:09:01.000000', 'consum', 0.0271, 'lps'),
	(644018, 136, '2015-01-01 01:09:02.000000', 'consum', 0.0216, 'lps'),
	(644019, 136, '2015-01-01 01:09:03.000000', 'consum', 0.0307, 'lps'),
	(644020, 136, '2015-01-01 01:09:04.000000', 'consum', 0.0305, 'lps'),
	(644021, 136, '2015-01-01 01:09:05.000000', 'consum', 0.0272, 'lps'),
	(644022, 136, '2015-01-01 01:09:06.000000', 'consum', 0.0235, 'lps'),
	(644023, 136, '2015-01-01 01:09:07.000000', 'consum', 0.0275, 'lps'),
	(644024, 136, '2015-01-01 01:09:08.000000', 'consum', 0.0213, 'lps'),
	(644025, 136, '2015-01-01 01:09:09.000000', 'consum', 0.0276, 'lps'),
	(644026, 136, '2015-01-01 01:09:10.000000', 'consum', 0.0283, 'lps'),
	(644027, 136, '2015-01-01 01:09:11.000000', 'consum', 0.0256, 'lps'),
	(644028, 136, '2015-01-01 01:09:12.000000', 'consum', 0.0219, 'lps'),
	(644029, 136, '2015-01-01 01:09:13.000000', 'consum', 0.0242, 'lps'),
	(644030, 136, '2015-01-01 01:09:14.000000', 'consum', 0.0218, 'lps'),
	(644031, 136, '2015-01-01 01:09:15.000000', 'consum', 0.0279, 'lps'),
	(644032, 136, '2015-01-01 01:09:16.000000', 'consum', 0.0282, 'lps'),
	(644033, 136, '2015-01-01 01:09:17.000000', 'consum', 0.0243, 'lps'),
	(644034, 136, '2015-01-01 01:09:18.000000', 'consum', 0.0280, 'lps'),
	(644035, 136, '2015-01-01 01:09:19.000000', 'consum', 0.0215, 'lps'),
	(644036, 136, '2015-01-01 01:09:20.000000', 'consum', 0.0272, 'lps'),
	(644037, 136, '2015-01-01 01:09:21.000000', 'consum', 0.0257, 'lps'),
	(644038, 136, '2015-01-01 01:09:22.000000', 'consum', 0.0261, 'lps'),
	(644039, 136, '2015-01-01 01:09:23.000000', 'consum', 0.0326, 'lps'),
	(644040, 136, '2015-01-01 01:09:24.000000', 'consum', 0.0264, 'lps'),
	(644041, 136, '2015-01-01 01:09:25.000000', 'consum', 0.0258, 'lps'),
	(644042, 136, '2015-01-01 01:09:26.000000', 'consum', 0.0289, 'lps'),
	(644043, 136, '2015-01-01 01:09:27.000000', 'consum', 0.0211, 'lps'),
	(644044, 136, '2015-01-01 01:09:28.000000', 'consum', 0.0228, 'lps'),
	(644045, 136, '2015-01-01 01:09:29.000000', 'consum', 0.0297, 'lps'),
	(644046, 136, '2015-01-01 01:09:30.000000', 'consum', 0.0221, 'lps'),
	(644047, 136, '2015-01-01 01:09:31.000000', 'consum', 0.0253, 'lps'),
	(644048, 136, '2015-01-01 01:09:32.000000', 'consum', 0.0269, 'lps'),
	(644049, 136, '2015-01-01 01:09:33.000000', 'consum', 0.0252, 'lps'),
	(644050, 136, '2015-01-01 01:09:34.000000', 'consum', 0.0242, 'lps'),
	(644051, 136, '2015-01-01 01:09:35.000000', 'consum', 0.0244, 'lps'),
	(644052, 136, '2015-01-01 01:09:36.000000', 'consum', 0.0284, 'lps'),
	(644053, 136, '2015-01-01 01:09:37.000000', 'consum', 0.0231, 'lps'),
	(644054, 136, '2015-01-01 01:09:38.000000', 'consum', 0.0218, 'lps'),
	(644055, 136, '2015-01-01 01:09:39.000000', 'consum', 0.0313, 'lps'),
	(644056, 136, '2015-01-01 01:09:40.000000', 'consum', 0.0328, 'lps'),
	(644057, 136, '2015-01-01 01:09:41.000000', 'consum', 0.0242, 'lps'),
	(644058, 136, '2015-01-01 01:09:42.000000', 'consum', 0.0268, 'lps'),
	(644059, 136, '2015-01-01 01:09:43.000000', 'consum', 0.0278, 'lps'),
	(644060, 136, '2015-01-01 01:09:44.000000', 'consum', 0.0252, 'lps'),
	(644061, 136, '2015-01-01 01:09:45.000000', 'consum', 0.0216, 'lps'),
	(644062, 136, '2015-01-01 01:09:46.000000', 'consum', 0.0239, 'lps'),
	(644063, 136, '2015-01-01 01:09:47.000000', 'consum', 0.0213, 'lps'),
	(644064, 136, '2015-01-01 01:09:48.000000', 'consum', 0.0262, 'lps'),
	(644065, 136, '2015-01-01 01:09:49.000000', 'consum', 0.0215, 'lps'),
	(644066, 136, '2015-01-01 01:09:50.000000', 'consum', 0.0326, 'lps'),
	(644067, 136, '2015-01-01 01:09:51.000000', 'consum', 0.0282, 'lps'),
	(644068, 136, '2015-01-01 01:09:52.000000', 'consum', 0.0220, 'lps'),
	(644069, 136, '2015-01-01 01:09:53.000000', 'consum', 0.0291, 'lps'),
	(644070, 136, '2015-01-01 01:09:54.000000', 'consum', 0.0216, 'lps'),
	(644071, 136, '2015-01-01 01:09:55.000000', 'consum', 0.0246, 'lps'),
	(644072, 136, '2015-01-01 01:09:56.000000', 'consum', 0.0248, 'lps'),
	(644073, 136, '2015-01-01 01:09:57.000000', 'consum', 0.0292, 'lps'),
	(644074, 136, '2015-01-01 01:09:58.000000', 'consum', 0.0260, 'lps'),
	(644075, 136, '2015-01-01 01:09:59.000000', 'consum', 0.0212, 'lps'),
	(644076, 136, '2015-01-01 01:10:00.000000', 'consum', 0.0321, 'lps'),
	(644077, 136, '2015-01-01 01:10:01.000000', 'consum', 0.0263, 'lps'),
	(644078, 136, '2015-01-01 01:10:02.000000', 'consum', 0.0268, 'lps'),
	(644079, 136, '2015-01-01 01:10:03.000000', 'consum', 0.0216, 'lps'),
	(644080, 136, '2015-01-01 01:10:04.000000', 'consum', 0.0315, 'lps'),
	(644081, 136, '2015-01-01 01:10:05.000000', 'consum', 0.0220, 'lps'),
	(644082, 136, '2015-01-01 01:10:06.000000', 'consum', 0.0319, 'lps'),
	(644083, 136, '2015-01-01 01:10:07.000000', 'consum', 0.0231, 'lps'),
	(644084, 136, '2015-01-01 01:10:08.000000', 'consum', 0.0233, 'lps'),
	(644085, 136, '2015-01-01 01:10:09.000000', 'consum', 0.0265, 'lps'),
	(644086, 136, '2015-01-01 01:10:10.000000', 'consum', 0.0291, 'lps'),
	(644087, 136, '2015-01-01 01:10:11.000000', 'consum', 0.0327, 'lps'),
	(644088, 136, '2015-01-01 01:10:12.000000', 'consum', 0.0303, 'lps'),
	(644089, 136, '2015-01-01 01:10:13.000000', 'consum', 0.0327, 'lps'),
	(644090, 136, '2015-01-01 01:10:14.000000', 'consum', 0.0269, 'lps'),
	(644091, 136, '2015-01-01 01:10:15.000000', 'consum', 0.0278, 'lps'),
	(644092, 136, '2015-01-01 01:10:16.000000', 'consum', 0.0248, 'lps'),
	(644093, 136, '2015-01-01 01:10:17.000000', 'consum', 0.0320, 'lps'),
	(644094, 136, '2015-01-01 01:10:18.000000', 'consum', 0.0275, 'lps'),
	(644095, 136, '2015-01-01 01:10:19.000000', 'consum', 0.0329, 'lps'),
	(644096, 136, '2015-01-01 01:10:20.000000', 'consum', 0.0240, 'lps'),
	(644097, 136, '2015-01-01 01:10:21.000000', 'consum', 0.0251, 'lps'),
	(644098, 136, '2015-01-01 01:10:22.000000', 'consum', 0.0324, 'lps'),
	(644099, 136, '2015-01-01 01:10:23.000000', 'consum', 0.0288, 'lps'),
	(644100, 136, '2015-01-01 01:10:24.000000', 'consum', 0.0256, 'lps'),
	(644101, 136, '2015-01-01 01:10:25.000000', 'consum', 0.0332, 'lps'),
	(644102, 136, '2015-01-01 01:10:26.000000', 'consum', 0.0312, 'lps'),
	(644103, 136, '2015-01-01 01:10:27.000000', 'consum', 0.0230, 'lps'),
	(644104, 136, '2015-01-01 01:10:28.000000', 'consum', 0.0252, 'lps'),
	(644105, 136, '2015-01-01 01:10:29.000000', 'consum', 0.0237, 'lps'),
	(644106, 136, '2015-01-01 01:10:30.000000', 'consum', 0.0219, 'lps'),
	(644107, 136, '2015-01-01 01:10:31.000000', 'consum', 0.0300, 'lps'),
	(644108, 136, '2015-01-01 01:10:32.000000', 'consum', 0.0259, 'lps'),
	(644109, 136, '2015-01-01 01:10:33.000000', 'consum', 0.0308, 'lps'),
	(644110, 136, '2015-01-01 01:10:34.000000', 'consum', 0.0309, 'lps'),
	(644111, 136, '2015-01-01 01:10:35.000000', 'consum', 0.0287, 'lps'),
	(644112, 136, '2015-01-01 01:10:36.000000', 'consum', 0.0297, 'lps'),
	(644113, 136, '2015-01-01 01:10:37.000000', 'consum', 0.0291, 'lps'),
	(644114, 136, '2015-01-01 01:10:38.000000', 'consum', 0.0232, 'lps'),
	(644115, 136, '2015-01-01 01:10:39.000000', 'consum', 0.0323, 'lps'),
	(644116, 136, '2015-01-01 01:10:40.000000', 'consum', 0.0215, 'lps'),
	(644117, 136, '2015-01-01 01:10:41.000000', 'consum', 0.0267, 'lps'),
	(644118, 136, '2015-01-01 01:10:42.000000', 'consum', 0.0235, 'lps'),
	(644119, 136, '2015-01-01 01:10:43.000000', 'consum', 0.0286, 'lps'),
	(644120, 136, '2015-01-01 01:10:44.000000', 'consum', 0.0267, 'lps'),
	(644121, 136, '2015-01-01 01:10:45.000000', 'consum', 0.0267, 'lps'),
	(644122, 136, '2015-01-01 01:10:46.000000', 'consum', 0.0326, 'lps'),
	(644123, 136, '2015-01-01 01:10:47.000000', 'consum', 0.0247, 'lps'),
	(644124, 136, '2015-01-01 01:10:48.000000', 'consum', 0.0294, 'lps'),
	(644125, 136, '2015-01-01 01:10:49.000000', 'consum', 0.0271, 'lps'),
	(644126, 136, '2015-01-01 01:10:50.000000', 'consum', 0.0265, 'lps'),
	(644127, 136, '2015-01-01 01:10:51.000000', 'consum', 0.0301, 'lps'),
	(644128, 136, '2015-01-01 01:10:52.000000', 'consum', 0.0253, 'lps'),
	(644129, 136, '2015-01-01 01:10:53.000000', 'consum', 0.0275, 'lps'),
	(644130, 136, '2015-01-01 01:10:54.000000', 'consum', 0.0283, 'lps'),
	(644131, 136, '2015-01-01 01:10:55.000000', 'consum', 0.0258, 'lps'),
	(644132, 136, '2015-01-01 01:10:56.000000', 'consum', 0.0232, 'lps'),
	(644133, 136, '2015-01-01 01:10:57.000000', 'consum', 0.0301, 'lps'),
	(644134, 136, '2015-01-01 01:10:58.000000', 'consum', 0.0227, 'lps'),
	(644135, 136, '2015-01-01 01:10:59.000000', 'consum', 0.0268, 'lps'),
	(644136, 136, '2015-01-01 01:11:00.000000', 'consum', 0.0329, 'lps'),
	(644137, 136, '2015-01-01 01:11:01.000000', 'consum', 0.0257, 'lps'),
	(644138, 136, '2015-01-01 01:11:02.000000', 'consum', 0.0212, 'lps'),
	(644139, 136, '2015-01-01 01:11:03.000000', 'consum', 0.0330, 'lps'),
	(644140, 136, '2015-01-01 01:11:04.000000', 'consum', 0.0306, 'lps'),
	(644141, 136, '2015-01-01 01:11:05.000000', 'consum', 0.0329, 'lps'),
	(644142, 136, '2015-01-01 01:11:06.000000', 'consum', 0.0273, 'lps'),
	(644143, 136, '2015-01-01 01:11:07.000000', 'consum', 0.0293, 'lps'),
	(644144, 136, '2015-01-01 01:11:08.000000', 'consum', 0.0311, 'lps'),
	(644145, 136, '2015-01-01 01:11:09.000000', 'consum', 0.0217, 'lps'),
	(644146, 136, '2015-01-01 01:11:10.000000', 'consum', 0.0314, 'lps'),
	(644147, 136, '2015-01-01 01:11:11.000000', 'consum', 0.0216, 'lps'),
	(644148, 136, '2015-01-01 01:11:12.000000', 'consum', 0.0298, 'lps'),
	(644149, 136, '2015-01-01 01:11:13.000000', 'consum', 0.0260, 'lps'),
	(644150, 136, '2015-01-01 01:11:14.000000', 'consum', 0.0323, 'lps'),
	(644151, 136, '2015-01-01 01:11:15.000000', 'consum', 0.0255, 'lps'),
	(644152, 136, '2015-01-01 01:11:16.000000', 'consum', 0.0217, 'lps'),
	(644153, 136, '2015-01-01 01:11:17.000000', 'consum', 0.0235, 'lps'),
	(644154, 136, '2015-01-01 01:11:18.000000', 'consum', 0.0317, 'lps'),
	(644155, 136, '2015-01-01 01:11:19.000000', 'consum', 0.0296, 'lps'),
	(644156, 136, '2015-01-01 01:11:20.000000', 'consum', 0.0320, 'lps'),
	(644157, 136, '2015-01-01 01:11:21.000000', 'consum', 0.0253, 'lps'),
	(644158, 136, '2015-01-01 01:11:22.000000', 'consum', 0.0221, 'lps'),
	(644159, 136, '2015-01-01 01:11:23.000000', 'consum', 0.0260, 'lps'),
	(644160, 136, '2015-01-01 01:11:24.000000', 'consum', 0.0306, 'lps'),
	(644161, 136, '2015-01-01 01:11:25.000000', 'consum', 0.0289, 'lps'),
	(644162, 136, '2015-01-01 01:11:26.000000', 'consum', 0.0318, 'lps'),
	(644163, 136, '2015-01-01 01:11:27.000000', 'consum', 0.0268, 'lps'),
	(644164, 136, '2015-01-01 01:11:28.000000', 'consum', 0.0297, 'lps'),
	(644165, 136, '2015-01-01 01:11:29.000000', 'consum', 0.0227, 'lps'),
	(644166, 136, '2015-01-01 01:11:30.000000', 'consum', 0.0280, 'lps'),
	(644167, 136, '2015-01-01 01:11:31.000000', 'consum', 0.0264, 'lps'),
	(644168, 136, '2015-01-01 01:11:32.000000', 'consum', 0.0267, 'lps'),
	(644169, 136, '2015-01-01 01:11:33.000000', 'consum', 0.0212, 'lps'),
	(644170, 136, '2015-01-01 01:11:34.000000', 'consum', 0.0297, 'lps'),
	(644171, 136, '2015-01-01 01:11:35.000000', 'consum', 0.0269, 'lps'),
	(644172, 136, '2015-01-01 01:11:36.000000', 'consum', 0.0245, 'lps'),
	(644173, 136, '2015-01-01 01:11:37.000000', 'consum', 0.0330, 'lps'),
	(644174, 136, '2015-01-01 01:11:38.000000', 'consum', 0.0333, 'lps'),
	(644175, 136, '2015-01-01 01:11:39.000000', 'consum', 0.0219, 'lps'),
	(644176, 136, '2015-01-01 01:11:40.000000', 'consum', 0.0256, 'lps'),
	(644177, 136, '2015-01-01 01:11:41.000000', 'consum', 0.0292, 'lps'),
	(644178, 136, '2015-01-01 01:11:42.000000', 'consum', 0.0235, 'lps'),
	(644179, 136, '2015-01-01 01:11:43.000000', 'consum', 0.0212, 'lps'),
	(644180, 136, '2015-01-01 01:11:44.000000', 'consum', 0.0269, 'lps'),
	(644181, 136, '2015-01-01 01:11:45.000000', 'consum', 0.0253, 'lps'),
	(644182, 136, '2015-01-01 01:11:46.000000', 'consum', 0.0247, 'lps'),
	(644183, 136, '2015-01-01 01:11:47.000000', 'consum', 0.0268, 'lps'),
	(644184, 136, '2015-01-01 01:11:48.000000', 'consum', 0.0264, 'lps'),
	(644185, 136, '2015-01-01 01:11:49.000000', 'consum', 0.0309, 'lps'),
	(644186, 136, '2015-01-01 01:11:50.000000', 'consum', 0.0294, 'lps'),
	(644187, 136, '2015-01-01 01:11:51.000000', 'consum', 0.0333, 'lps'),
	(644188, 136, '2015-01-01 01:11:52.000000', 'consum', 0.0324, 'lps'),
	(644189, 136, '2015-01-01 01:11:53.000000', 'consum', 0.0289, 'lps'),
	(644190, 136, '2015-01-01 01:11:54.000000', 'consum', 0.0264, 'lps'),
	(644191, 136, '2015-01-01 01:11:55.000000', 'consum', 0.0241, 'lps'),
	(644192, 136, '2015-01-01 01:11:56.000000', 'consum', 0.0329, 'lps'),
	(644193, 136, '2015-01-01 01:11:57.000000', 'consum', 0.0217, 'lps'),
	(644194, 136, '2015-01-01 01:11:58.000000', 'consum', 0.0260, 'lps'),
	(644195, 136, '2015-01-01 01:11:59.000000', 'consum', 0.0315, 'lps'),
	(644196, 136, '2015-01-01 01:12:00.000000', 'consum', 0.0215, 'lps'),
	(644197, 136, '2015-01-01 01:12:01.000000', 'consum', 0.0293, 'lps'),
	(644198, 136, '2015-01-01 01:12:02.000000', 'consum', 0.0238, 'lps'),
	(644199, 136, '2015-01-01 01:12:03.000000', 'consum', 0.0225, 'lps'),
	(644200, 136, '2015-01-01 01:12:04.000000', 'consum', 0.0328, 'lps'),
	(644201, 136, '2015-01-01 01:12:05.000000', 'consum', 0.0256, 'lps'),
	(644202, 136, '2015-01-01 01:12:06.000000', 'consum', 0.0213, 'lps'),
	(644203, 136, '2015-01-01 01:12:07.000000', 'consum', 0.0210, 'lps'),
	(644204, 136, '2015-01-01 01:12:08.000000', 'consum', 0.0324, 'lps'),
	(644205, 136, '2015-01-01 01:12:09.000000', 'consum', 0.0287, 'lps'),
	(644206, 136, '2015-01-01 01:12:10.000000', 'consum', 0.0251, 'lps'),
	(644207, 136, '2015-01-01 01:12:11.000000', 'consum', 0.0308, 'lps'),
	(644208, 136, '2015-01-01 01:12:12.000000', 'consum', 0.0332, 'lps'),
	(644209, 136, '2015-01-01 01:12:13.000000', 'consum', 0.0280, 'lps'),
	(644210, 136, '2015-01-01 01:12:14.000000', 'consum', 0.0315, 'lps'),
	(644211, 136, '2015-01-01 01:12:15.000000', 'consum', 0.0280, 'lps'),
	(644212, 136, '2015-01-01 01:12:16.000000', 'consum', 0.0246, 'lps'),
	(644213, 136, '2015-01-01 01:12:17.000000', 'consum', 0.0302, 'lps'),
	(644214, 136, '2015-01-01 01:12:18.000000', 'consum', 0.0316, 'lps'),
	(644215, 136, '2015-01-01 01:12:19.000000', 'consum', 0.0218, 'lps'),
	(644216, 136, '2015-01-01 01:12:20.000000', 'consum', 0.0302, 'lps'),
	(644217, 136, '2015-01-01 01:12:21.000000', 'consum', 0.0277, 'lps'),
	(644218, 136, '2015-01-01 01:12:22.000000', 'consum', 0.0268, 'lps'),
	(644219, 136, '2015-01-01 01:12:23.000000', 'consum', 0.0299, 'lps'),
	(644220, 136, '2015-01-01 01:12:24.000000', 'consum', 0.0233, 'lps'),
	(644221, 136, '2015-01-01 01:12:25.000000', 'consum', 0.0307, 'lps'),
	(644222, 136, '2015-01-01 01:12:26.000000', 'consum', 0.0256, 'lps'),
	(644223, 136, '2015-01-01 01:12:27.000000', 'consum', 0.0274, 'lps'),
	(644224, 136, '2015-01-01 01:12:28.000000', 'consum', 0.0269, 'lps'),
	(644225, 136, '2015-01-01 01:12:29.000000', 'consum', 0.0314, 'lps'),
	(644226, 136, '2015-01-01 01:12:30.000000', 'consum', 0.0304, 'lps'),
	(644227, 136, '2015-01-01 01:12:31.000000', 'consum', 0.0247, 'lps'),
	(644228, 136, '2015-01-01 01:12:32.000000', 'consum', 0.0235, 'lps'),
	(644229, 136, '2015-01-01 01:12:33.000000', 'consum', 0.0226, 'lps'),
	(644230, 136, '2015-01-01 01:12:34.000000', 'consum', 0.0217, 'lps'),
	(644231, 136, '2015-01-01 01:12:35.000000', 'consum', 0.0320, 'lps'),
	(644232, 136, '2015-01-01 01:12:36.000000', 'consum', 0.0242, 'lps'),
	(644233, 136, '2015-01-01 01:12:37.000000', 'consum', 0.0291, 'lps'),
	(644234, 136, '2015-01-01 01:12:38.000000', 'consum', 0.0268, 'lps'),
	(644235, 136, '2015-01-01 01:12:39.000000', 'consum', 0.0261, 'lps'),
	(644236, 136, '2015-01-01 01:12:40.000000', 'consum', 0.0289, 'lps'),
	(644237, 136, '2015-01-01 01:12:41.000000', 'consum', 0.0331, 'lps'),
	(644238, 136, '2015-01-01 01:12:42.000000', 'consum', 0.0329, 'lps'),
	(644239, 136, '2015-01-01 01:12:43.000000', 'consum', 0.0320, 'lps'),
	(644240, 136, '2015-01-01 01:12:44.000000', 'consum', 0.0281, 'lps'),
	(644241, 136, '2015-01-01 01:12:45.000000', 'consum', 0.0233, 'lps'),
	(644242, 136, '2015-01-01 01:12:46.000000', 'consum', 0.0236, 'lps'),
	(644243, 136, '2015-01-01 01:12:47.000000', 'consum', 0.0273, 'lps'),
	(644244, 136, '2015-01-01 01:12:48.000000', 'consum', 0.0321, 'lps'),
	(644245, 136, '2015-01-01 01:12:49.000000', 'consum', 0.0331, 'lps'),
	(644246, 136, '2015-01-01 01:12:50.000000', 'consum', 0.0233, 'lps'),
	(644247, 136, '2015-01-01 01:12:51.000000', 'consum', 0.0212, 'lps'),
	(644248, 136, '2015-01-01 01:12:52.000000', 'consum', 0.0274, 'lps'),
	(644249, 136, '2015-01-01 01:12:53.000000', 'consum', 0.0275, 'lps'),
	(644250, 136, '2015-01-01 01:12:54.000000', 'consum', 0.0221, 'lps'),
	(644251, 136, '2015-01-01 01:12:55.000000', 'consum', 0.0318, 'lps'),
	(644252, 136, '2015-01-01 01:12:56.000000', 'consum', 0.0224, 'lps'),
	(644253, 136, '2015-01-01 01:12:57.000000', 'consum', 0.0326, 'lps'),
	(644254, 136, '2015-01-01 01:12:58.000000', 'consum', 0.0254, 'lps'),
	(644255, 136, '2015-01-01 01:12:59.000000', 'consum', 0.0328, 'lps'),
	(644256, 136, '2015-01-01 01:13:00.000000', 'consum', 0.0298, 'lps'),
	(644257, 136, '2015-01-01 01:13:01.000000', 'consum', 0.0296, 'lps'),
	(644258, 136, '2015-01-01 01:13:02.000000', 'consum', 0.0253, 'lps'),
	(644259, 136, '2015-01-01 01:13:03.000000', 'consum', 0.0291, 'lps'),
	(644260, 136, '2015-01-01 01:13:04.000000', 'consum', 0.0237, 'lps'),
	(644261, 136, '2015-01-01 01:13:05.000000', 'consum', 0.0227, 'lps'),
	(644262, 136, '2015-01-01 01:13:06.000000', 'consum', 0.0215, 'lps'),
	(644263, 136, '2015-01-01 01:13:07.000000', 'consum', 0.0309, 'lps'),
	(644264, 136, '2015-01-01 01:13:08.000000', 'consum', 0.0318, 'lps'),
	(644265, 136, '2015-01-01 01:13:09.000000', 'consum', 0.0329, 'lps'),
	(644266, 136, '2015-01-01 01:13:10.000000', 'consum', 0.0234, 'lps'),
	(644267, 136, '2015-01-01 01:13:11.000000', 'consum', 0.0221, 'lps'),
	(644268, 136, '2015-01-01 01:13:12.000000', 'consum', 0.0318, 'lps'),
	(644269, 136, '2015-01-01 01:13:13.000000', 'consum', 0.0219, 'lps'),
	(644270, 136, '2015-01-01 01:13:14.000000', 'consum', 0.0307, 'lps'),
	(644271, 136, '2015-01-01 01:13:15.000000', 'consum', 0.0294, 'lps'),
	(644272, 136, '2015-01-01 01:13:16.000000', 'consum', 0.0218, 'lps'),
	(644273, 136, '2015-01-01 01:13:17.000000', 'consum', 0.0247, 'lps'),
	(644274, 136, '2015-01-01 01:13:18.000000', 'consum', 0.0248, 'lps'),
	(644275, 136, '2015-01-01 01:13:19.000000', 'consum', 0.0290, 'lps'),
	(644276, 136, '2015-01-01 01:13:20.000000', 'consum', 0.0247, 'lps'),
	(644277, 136, '2015-01-01 01:13:21.000000', 'consum', 0.0280, 'lps'),
	(644278, 136, '2015-01-01 01:13:22.000000', 'consum', 0.0326, 'lps'),
	(644279, 136, '2015-01-01 01:13:23.000000', 'consum', 0.0332, 'lps'),
	(644280, 136, '2015-01-01 01:13:24.000000', 'consum', 0.0224, 'lps'),
	(644281, 136, '2015-01-01 01:13:25.000000', 'consum', 0.0286, 'lps'),
	(644282, 136, '2015-01-01 01:13:26.000000', 'consum', 0.0300, 'lps'),
	(644283, 136, '2015-01-01 01:13:27.000000', 'consum', 0.0307, 'lps'),
	(644284, 136, '2015-01-01 01:13:28.000000', 'consum', 0.0304, 'lps'),
	(644285, 136, '2015-01-01 01:13:29.000000', 'consum', 0.0267, 'lps'),
	(644286, 136, '2015-01-01 01:13:30.000000', 'consum', 0.0211, 'lps'),
	(644287, 136, '2015-01-01 01:13:31.000000', 'consum', 0.0295, 'lps'),
	(644288, 136, '2015-01-01 01:13:32.000000', 'consum', 0.0259, 'lps'),
	(644289, 136, '2015-01-01 01:13:33.000000', 'consum', 0.0326, 'lps'),
	(644290, 136, '2015-01-01 01:13:34.000000', 'consum', 0.0269, 'lps'),
	(644291, 136, '2015-01-01 01:13:35.000000', 'consum', 0.0285, 'lps'),
	(644292, 136, '2015-01-01 01:13:36.000000', 'consum', 0.0281, 'lps'),
	(644293, 136, '2015-01-01 01:13:37.000000', 'consum', 0.0219, 'lps'),
	(644294, 136, '2015-01-01 01:13:38.000000', 'consum', 0.0292, 'lps'),
	(644295, 136, '2015-01-01 01:13:39.000000', 'consum', 0.0219, 'lps'),
	(644296, 136, '2015-01-01 01:13:40.000000', 'consum', 0.0257, 'lps'),
	(644297, 136, '2015-01-01 01:13:41.000000', 'consum', 0.0295, 'lps'),
	(644298, 136, '2015-01-01 01:13:42.000000', 'consum', 0.0247, 'lps'),
	(644299, 136, '2015-01-01 01:13:43.000000', 'consum', 0.0266, 'lps'),
	(644300, 136, '2015-01-01 01:13:44.000000', 'consum', 0.0254, 'lps'),
	(644301, 136, '2015-01-01 01:13:45.000000', 'consum', 0.0261, 'lps'),
	(644302, 136, '2015-01-01 01:13:46.000000', 'consum', 0.0210, 'lps'),
	(644303, 136, '2015-01-01 01:13:47.000000', 'consum', 0.0306, 'lps'),
	(644304, 136, '2015-01-01 01:13:48.000000', 'consum', 0.0318, 'lps'),
	(644305, 136, '2015-01-01 01:13:49.000000', 'consum', 0.0214, 'lps'),
	(644306, 136, '2015-01-01 01:13:50.000000', 'consum', 0.0277, 'lps'),
	(644307, 136, '2015-01-01 01:13:51.000000', 'consum', 0.0288, 'lps'),
	(644308, 136, '2015-01-01 01:13:52.000000', 'consum', 0.0274, 'lps'),
	(644309, 136, '2015-01-01 01:13:53.000000', 'consum', 0.0295, 'lps'),
	(644310, 136, '2015-01-01 01:13:54.000000', 'consum', 0.0322, 'lps'),
	(644311, 136, '2015-01-01 01:13:55.000000', 'consum', 0.0267, 'lps'),
	(644312, 136, '2015-01-01 01:13:56.000000', 'consum', 0.0281, 'lps'),
	(644313, 136, '2015-01-01 01:13:57.000000', 'consum', 0.0274, 'lps'),
	(644314, 136, '2015-01-01 01:13:58.000000', 'consum', 0.0317, 'lps'),
	(644315, 136, '2015-01-01 01:13:59.000000', 'consum', 0.0306, 'lps'),
	(644316, 136, '2015-01-01 01:14:00.000000', 'consum', 0.0244, 'lps'),
	(644317, 136, '2015-01-01 01:14:01.000000', 'consum', 0.0217, 'lps'),
	(644318, 136, '2015-01-01 01:14:02.000000', 'consum', 0.0269, 'lps'),
	(644319, 136, '2015-01-01 01:14:03.000000', 'consum', 0.0235, 'lps'),
	(644320, 136, '2015-01-01 01:14:04.000000', 'consum', 0.0283, 'lps'),
	(644321, 136, '2015-01-01 01:14:05.000000', 'consum', 0.0250, 'lps'),
	(644322, 136, '2015-01-01 01:14:06.000000', 'consum', 0.0319, 'lps'),
	(644323, 136, '2015-01-01 01:14:07.000000', 'consum', 0.0263, 'lps'),
	(644324, 136, '2015-01-01 01:14:08.000000', 'consum', 0.0274, 'lps'),
	(644325, 136, '2015-01-01 01:14:09.000000', 'consum', 0.0245, 'lps'),
	(644326, 136, '2015-01-01 01:14:10.000000', 'consum', 0.0320, 'lps'),
	(644327, 136, '2015-01-01 01:14:11.000000', 'consum', 0.0282, 'lps'),
	(644328, 136, '2015-01-01 01:14:12.000000', 'consum', 0.0240, 'lps'),
	(644329, 136, '2015-01-01 01:14:13.000000', 'consum', 0.0267, 'lps'),
	(644330, 136, '2015-01-01 01:14:14.000000', 'consum', 0.0283, 'lps'),
	(644331, 136, '2015-01-01 01:14:15.000000', 'consum', 0.0280, 'lps'),
	(644332, 136, '2015-01-01 01:14:16.000000', 'consum', 0.0219, 'lps'),
	(644333, 136, '2015-01-01 01:14:17.000000', 'consum', 0.0293, 'lps'),
	(644334, 136, '2015-01-01 01:14:18.000000', 'consum', 0.0228, 'lps'),
	(644335, 136, '2015-01-01 01:14:19.000000', 'consum', 0.0298, 'lps'),
	(644336, 136, '2015-01-01 01:14:20.000000', 'consum', 0.0224, 'lps'),
	(644337, 136, '2015-01-01 01:14:21.000000', 'consum', 0.0264, 'lps'),
	(644338, 136, '2015-01-01 01:14:22.000000', 'consum', 0.0315, 'lps'),
	(644339, 136, '2015-01-01 01:14:23.000000', 'consum', 0.0325, 'lps'),
	(644340, 136, '2015-01-01 01:14:24.000000', 'consum', 0.0223, 'lps'),
	(644341, 136, '2015-01-01 01:14:25.000000', 'consum', 0.0301, 'lps'),
	(644342, 136, '2015-01-01 01:14:26.000000', 'consum', 0.0257, 'lps'),
	(644343, 136, '2015-01-01 01:14:27.000000', 'consum', 0.0296, 'lps'),
	(644344, 136, '2015-01-01 01:14:28.000000', 'consum', 0.0251, 'lps'),
	(644345, 136, '2015-01-01 01:14:29.000000', 'consum', 0.0281, 'lps'),
	(644346, 136, '2015-01-01 01:14:30.000000', 'consum', 0.0317, 'lps'),
	(644347, 136, '2015-01-01 01:14:31.000000', 'consum', 0.0288, 'lps'),
	(644348, 136, '2015-01-01 01:14:32.000000', 'consum', 0.0276, 'lps'),
	(644349, 136, '2015-01-01 01:14:33.000000', 'consum', 0.0308, 'lps'),
	(644350, 136, '2015-01-01 01:14:34.000000', 'consum', 0.0255, 'lps'),
	(644351, 136, '2015-01-01 01:14:35.000000', 'consum', 0.0266, 'lps'),
	(644352, 136, '2015-01-01 01:14:36.000000', 'consum', 0.0230, 'lps'),
	(644353, 136, '2015-01-01 01:14:37.000000', 'consum', 0.0269, 'lps'),
	(644354, 136, '2015-01-01 01:14:38.000000', 'consum', 0.0321, 'lps'),
	(644355, 136, '2015-01-01 01:14:39.000000', 'consum', 0.0215, 'lps'),
	(644356, 136, '2015-01-01 01:14:40.000000', 'consum', 0.0274, 'lps'),
	(644357, 136, '2015-01-01 01:14:41.000000', 'consum', 0.0267, 'lps'),
	(644358, 136, '2015-01-01 01:14:42.000000', 'consum', 0.0304, 'lps'),
	(644359, 136, '2015-01-01 01:14:43.000000', 'consum', 0.0263, 'lps'),
	(644360, 136, '2015-01-01 01:14:44.000000', 'consum', 0.0317, 'lps'),
	(644361, 136, '2015-01-01 01:14:45.000000', 'consum', 0.0213, 'lps'),
	(644362, 136, '2015-01-01 01:14:46.000000', 'consum', 0.0279, 'lps'),
	(644363, 136, '2015-01-01 01:14:47.000000', 'consum', 0.0297, 'lps'),
	(644364, 136, '2015-01-01 01:14:48.000000', 'consum', 0.0313, 'lps'),
	(644365, 136, '2015-01-01 01:14:49.000000', 'consum', 0.0219, 'lps'),
	(644366, 136, '2015-01-01 01:14:50.000000', 'consum', 0.0316, 'lps'),
	(644367, 136, '2015-01-01 01:14:51.000000', 'consum', 0.0220, 'lps'),
	(644368, 136, '2015-01-01 01:14:52.000000', 'consum', 0.0313, 'lps'),
	(644369, 136, '2015-01-01 01:14:53.000000', 'consum', 0.0323, 'lps'),
	(644370, 136, '2015-01-01 01:14:54.000000', 'consum', 0.0218, 'lps'),
	(644371, 136, '2015-01-01 01:14:55.000000', 'consum', 0.0283, 'lps'),
	(644372, 136, '2015-01-01 01:14:56.000000', 'consum', 0.0304, 'lps'),
	(644373, 136, '2015-01-01 01:14:57.000000', 'consum', 0.0213, 'lps'),
	(644374, 136, '2015-01-01 01:14:58.000000', 'consum', 0.0317, 'lps'),
	(644375, 136, '2015-01-01 01:14:59.000000', 'consum', 0.0239, 'lps'),
	(644376, 136, '2015-01-01 01:15:00.000000', 'consum', 0.0281, 'lps'),
	(644377, 136, '2015-01-01 01:15:01.000000', 'consum', 0.0232, 'lps'),
	(644378, 136, '2015-01-01 01:15:02.000000', 'consum', 0.0233, 'lps'),
	(644379, 136, '2015-01-01 01:15:03.000000', 'consum', 0.0256, 'lps'),
	(644380, 136, '2015-01-01 01:15:04.000000', 'consum', 0.0251, 'lps'),
	(644381, 136, '2015-01-01 01:15:05.000000', 'consum', 0.0274, 'lps'),
	(644382, 136, '2015-01-01 01:15:06.000000', 'consum', 0.0286, 'lps'),
	(644383, 136, '2015-01-01 01:15:07.000000', 'consum', 0.0273, 'lps'),
	(644384, 136, '2015-01-01 01:15:08.000000', 'consum', 0.0297, 'lps'),
	(644385, 136, '2015-01-01 01:15:09.000000', 'consum', 0.0333, 'lps'),
	(644386, 136, '2015-01-01 01:15:10.000000', 'consum', 0.0317, 'lps'),
	(644387, 136, '2015-01-01 01:15:11.000000', 'consum', 0.0254, 'lps'),
	(644388, 136, '2015-01-01 01:15:12.000000', 'consum', 0.0233, 'lps'),
	(644389, 136, '2015-01-01 01:15:13.000000', 'consum', 0.0317, 'lps'),
	(644390, 136, '2015-01-01 01:15:14.000000', 'consum', 0.0304, 'lps'),
	(644391, 136, '2015-01-01 01:15:15.000000', 'consum', 0.0236, 'lps'),
	(644392, 136, '2015-01-01 01:15:16.000000', 'consum', 0.0306, 'lps'),
	(644393, 136, '2015-01-01 01:15:17.000000', 'consum', 0.0240, 'lps'),
	(644394, 136, '2015-01-01 01:15:18.000000', 'consum', 0.0320, 'lps'),
	(644395, 136, '2015-01-01 01:15:19.000000', 'consum', 0.0301, 'lps'),
	(644396, 136, '2015-01-01 01:15:20.000000', 'consum', 0.0210, 'lps'),
	(644397, 136, '2015-01-01 01:15:21.000000', 'consum', 0.0309, 'lps'),
	(644398, 136, '2015-01-01 01:15:22.000000', 'consum', 0.0212, 'lps'),
	(644399, 136, '2015-01-01 01:15:23.000000', 'consum', 0.0293, 'lps'),
	(644400, 136, '2015-01-01 01:15:24.000000', 'consum', 0.0250, 'lps'),
	(644401, 136, '2015-01-01 01:15:25.000000', 'consum', 0.0283, 'lps'),
	(644402, 136, '2015-01-01 01:15:26.000000', 'consum', 0.0333, 'lps'),
	(644403, 136, '2015-01-01 01:15:27.000000', 'consum', 0.0232, 'lps'),
	(644404, 136, '2015-01-01 01:15:28.000000', 'consum', 0.0327, 'lps'),
	(644405, 136, '2015-01-01 01:15:29.000000', 'consum', 0.0230, 'lps'),
	(644406, 136, '2015-01-01 01:15:30.000000', 'consum', 0.0333, 'lps'),
	(644407, 136, '2015-01-01 01:15:31.000000', 'consum', 0.0269, 'lps'),
	(644408, 136, '2015-01-01 01:15:32.000000', 'consum', 0.0261, 'lps'),
	(644409, 136, '2015-01-01 01:15:33.000000', 'consum', 0.0287, 'lps'),
	(644410, 136, '2015-01-01 01:15:34.000000', 'consum', 0.0318, 'lps'),
	(644411, 136, '2015-01-01 01:15:35.000000', 'consum', 0.0275, 'lps'),
	(644412, 136, '2015-01-01 01:15:36.000000', 'consum', 0.0332, 'lps'),
	(644413, 136, '2015-01-01 01:15:37.000000', 'consum', 0.0254, 'lps'),
	(644414, 136, '2015-01-01 01:15:38.000000', 'consum', 0.0314, 'lps'),
	(644415, 136, '2015-01-01 01:15:39.000000', 'consum', 0.0227, 'lps'),
	(644416, 136, '2015-01-01 01:15:40.000000', 'consum', 0.0229, 'lps'),
	(644417, 136, '2015-01-01 01:15:41.000000', 'consum', 0.0256, 'lps'),
	(644418, 136, '2015-01-01 01:15:42.000000', 'consum', 0.0261, 'lps'),
	(644419, 136, '2015-01-01 01:15:43.000000', 'consum', 0.0327, 'lps'),
	(644420, 136, '2015-01-01 01:15:44.000000', 'consum', 0.0271, 'lps'),
	(644421, 136, '2015-01-01 01:15:45.000000', 'consum', 0.0286, 'lps'),
	(644422, 136, '2015-01-01 01:15:46.000000', 'consum', 0.0285, 'lps'),
	(644423, 136, '2015-01-01 01:15:47.000000', 'consum', 0.0233, 'lps'),
	(644424, 136, '2015-01-01 01:15:48.000000', 'consum', 0.0226, 'lps'),
	(644425, 136, '2015-01-01 01:15:49.000000', 'consum', 0.0223, 'lps'),
	(644426, 136, '2015-01-01 01:15:50.000000', 'consum', 0.0224, 'lps'),
	(644427, 136, '2015-01-01 01:15:51.000000', 'consum', 0.0242, 'lps'),
	(644428, 136, '2015-01-01 01:15:52.000000', 'consum', 0.0327, 'lps'),
	(644429, 136, '2015-01-01 01:15:53.000000', 'consum', 0.0329, 'lps'),
	(644430, 136, '2015-01-01 01:15:54.000000', 'consum', 0.0329, 'lps'),
	(644431, 136, '2015-01-01 01:15:55.000000', 'consum', 0.0324, 'lps'),
	(644432, 136, '2015-01-01 01:15:56.000000', 'consum', 0.0302, 'lps'),
	(644433, 136, '2015-01-01 01:15:57.000000', 'consum', 0.0329, 'lps'),
	(644434, 136, '2015-01-01 01:15:58.000000', 'consum', 0.0279, 'lps'),
	(644435, 136, '2015-01-01 01:15:59.000000', 'consum', 0.0325, 'lps'),
	(644436, 136, '2015-01-01 01:16:00.000000', 'consum', 0.0330, 'lps'),
	(644437, 136, '2015-01-01 01:16:01.000000', 'consum', 0.0219, 'lps'),
	(644438, 136, '2015-01-01 01:16:02.000000', 'consum', 0.0267, 'lps'),
	(644439, 136, '2015-01-01 01:16:03.000000', 'consum', 0.0218, 'lps'),
	(644440, 136, '2015-01-01 01:16:04.000000', 'consum', 0.0331, 'lps'),
	(644441, 136, '2015-01-01 01:16:05.000000', 'consum', 0.0292, 'lps'),
	(644442, 136, '2015-01-01 01:16:06.000000', 'consum', 0.0261, 'lps'),
	(644443, 136, '2015-01-01 01:16:07.000000', 'consum', 0.0216, 'lps'),
	(644444, 136, '2015-01-01 01:16:08.000000', 'consum', 0.0215, 'lps'),
	(644445, 136, '2015-01-01 01:16:09.000000', 'consum', 0.0215, 'lps'),
	(644446, 136, '2015-01-01 01:16:10.000000', 'consum', 0.0223, 'lps'),
	(644447, 136, '2015-01-01 01:16:11.000000', 'consum', 0.0260, 'lps'),
	(644448, 136, '2015-01-01 01:16:12.000000', 'consum', 0.0298, 'lps'),
	(644449, 136, '2015-01-01 01:16:13.000000', 'consum', 0.0253, 'lps'),
	(644450, 136, '2015-01-01 01:16:14.000000', 'consum', 0.0285, 'lps'),
	(644451, 136, '2015-01-01 01:16:15.000000', 'consum', 0.0332, 'lps'),
	(644452, 136, '2015-01-01 01:16:16.000000', 'consum', 0.0223, 'lps'),
	(644453, 136, '2015-01-01 01:16:17.000000', 'consum', 0.0283, 'lps'),
	(644454, 136, '2015-01-01 01:16:18.000000', 'consum', 0.0286, 'lps'),
	(644455, 136, '2015-01-01 01:16:19.000000', 'consum', 0.0248, 'lps'),
	(644456, 136, '2015-01-01 01:16:20.000000', 'consum', 0.0298, 'lps'),
	(644457, 136, '2015-01-01 01:16:21.000000', 'consum', 0.0286, 'lps'),
	(644458, 136, '2015-01-01 01:16:22.000000', 'consum', 0.0328, 'lps'),
	(644459, 136, '2015-01-01 01:16:23.000000', 'consum', 0.0324, 'lps'),
	(644460, 136, '2015-01-01 01:16:24.000000', 'consum', 0.0302, 'lps'),
	(644461, 136, '2015-01-01 01:16:25.000000', 'consum', 0.0327, 'lps'),
	(644462, 136, '2015-01-01 01:16:26.000000', 'consum', 0.0275, 'lps'),
	(644463, 136, '2015-01-01 01:16:27.000000', 'consum', 0.0307, 'lps'),
	(644464, 136, '2015-01-01 01:16:28.000000', 'consum', 0.0253, 'lps'),
	(644465, 136, '2015-01-01 01:16:29.000000', 'consum', 0.0256, 'lps'),
	(644466, 136, '2015-01-01 01:16:30.000000', 'consum', 0.0315, 'lps'),
	(644467, 136, '2015-01-01 01:16:31.000000', 'consum', 0.0224, 'lps'),
	(644468, 136, '2015-01-01 01:16:32.000000', 'consum', 0.0215, 'lps'),
	(644469, 136, '2015-01-01 01:16:33.000000', 'consum', 0.0315, 'lps'),
	(644470, 136, '2015-01-01 01:16:34.000000', 'consum', 0.0224, 'lps'),
	(644471, 136, '2015-01-01 01:16:35.000000', 'consum', 0.0214, 'lps'),
	(644472, 136, '2015-01-01 01:16:36.000000', 'consum', 0.0314, 'lps'),
	(644473, 136, '2015-01-01 01:16:37.000000', 'consum', 0.0224, 'lps'),
	(644474, 136, '2015-01-01 01:16:38.000000', 'consum', 0.0213, 'lps'),
	(644475, 136, '2015-01-01 01:16:39.000000', 'consum', 0.0308, 'lps'),
	(644476, 136, '2015-01-01 01:16:40.000000', 'consum', 0.0320, 'lps'),
	(644477, 136, '2015-01-01 01:16:41.000000', 'consum', 0.0220, 'lps'),
	(644478, 136, '2015-01-01 01:16:42.000000', 'consum', 0.0303, 'lps'),
	(644479, 136, '2015-01-01 01:16:43.000000', 'consum', 0.0274, 'lps'),
	(644480, 136, '2015-01-01 01:16:44.000000', 'consum', 0.0251, 'lps'),
	(644481, 136, '2015-01-01 01:16:45.000000', 'consum', 0.0222, 'lps'),
	(644482, 136, '2015-01-01 01:16:46.000000', 'consum', 0.0272, 'lps'),
	(644483, 136, '2015-01-01 01:16:47.000000', 'consum', 0.0235, 'lps'),
	(644484, 136, '2015-01-01 01:16:48.000000', 'consum', 0.0273, 'lps'),
	(644485, 136, '2015-01-01 01:16:49.000000', 'consum', 0.0330, 'lps'),
	(644486, 136, '2015-01-01 01:16:50.000000', 'consum', 0.0247, 'lps'),
	(644487, 136, '2015-01-01 01:16:51.000000', 'consum', 0.0283, 'lps'),
	(644488, 136, '2015-01-01 01:16:52.000000', 'consum', 0.0219, 'lps'),
	(644489, 136, '2015-01-01 01:16:53.000000', 'consum', 0.0283, 'lps'),
	(644490, 136, '2015-01-01 01:16:54.000000', 'consum', 0.0300, 'lps'),
	(644491, 136, '2015-01-01 01:16:55.000000', 'consum', 0.0319, 'lps'),
	(644492, 136, '2015-01-01 01:16:56.000000', 'consum', 0.0236, 'lps'),
	(644493, 136, '2015-01-01 01:16:57.000000', 'consum', 0.0263, 'lps'),
	(644494, 136, '2015-01-01 01:16:58.000000', 'consum', 0.0274, 'lps'),
	(644495, 136, '2015-01-01 01:16:59.000000', 'consum', 0.0245, 'lps'),
	(644496, 136, '2015-01-01 01:17:00.000000', 'consum', 0.0317, 'lps'),
	(644497, 136, '2015-01-01 01:17:01.000000', 'consum', 0.0271, 'lps'),
	(644498, 136, '2015-01-01 01:17:02.000000', 'consum', 0.0319, 'lps'),
	(644499, 136, '2015-01-01 01:17:03.000000', 'consum', 0.0321, 'lps'),
	(644500, 136, '2015-01-01 01:17:04.000000', 'consum', 0.0318, 'lps'),
	(644501, 136, '2015-01-01 01:17:05.000000', 'consum', 0.0292, 'lps'),
	(644502, 136, '2015-01-01 01:17:06.000000', 'consum', 0.0298, 'lps'),
	(644503, 136, '2015-01-01 01:17:07.000000', 'consum', 0.0281, 'lps'),
	(644504, 136, '2015-01-01 01:17:08.000000', 'consum', 0.0301, 'lps'),
	(644505, 136, '2015-01-01 01:17:09.000000', 'consum', 0.0329, 'lps'),
	(644506, 136, '2015-01-01 01:17:10.000000', 'consum', 0.0286, 'lps'),
	(644507, 136, '2015-01-01 01:17:11.000000', 'consum', 0.0232, 'lps'),
	(644508, 136, '2015-01-01 01:17:12.000000', 'consum', 0.0215, 'lps'),
	(644509, 136, '2015-01-01 01:17:13.000000', 'consum', 0.0294, 'lps'),
	(644510, 136, '2015-01-01 01:17:14.000000', 'consum', 0.0243, 'lps'),
	(644511, 136, '2015-01-01 01:17:15.000000', 'consum', 0.0248, 'lps'),
	(644512, 136, '2015-01-01 01:17:16.000000', 'consum', 0.0300, 'lps'),
	(644513, 136, '2015-01-01 01:17:17.000000', 'consum', 0.0299, 'lps'),
	(644514, 136, '2015-01-01 01:17:18.000000', 'consum', 0.0262, 'lps'),
	(644515, 136, '2015-01-01 01:17:19.000000', 'consum', 0.0328, 'lps'),
	(644516, 136, '2015-01-01 01:17:20.000000', 'consum', 0.0273, 'lps'),
	(644517, 136, '2015-01-01 01:17:21.000000', 'consum', 0.0295, 'lps'),
	(644518, 136, '2015-01-01 01:17:22.000000', 'consum', 0.0324, 'lps'),
	(644519, 136, '2015-01-01 01:17:23.000000', 'consum', 0.0278, 'lps'),
	(644520, 136, '2015-01-01 01:17:24.000000', 'consum', 0.0330, 'lps'),
	(644521, 136, '2015-01-01 01:17:25.000000', 'consum', 0.0236, 'lps'),
	(644522, 136, '2015-01-01 01:17:26.000000', 'consum', 0.0229, 'lps'),
	(644523, 136, '2015-01-01 01:17:27.000000', 'consum', 0.0227, 'lps'),
	(644524, 136, '2015-01-01 01:17:28.000000', 'consum', 0.0238, 'lps'),
	(644525, 136, '2015-01-01 01:17:29.000000', 'consum', 0.0299, 'lps'),
	(644526, 136, '2015-01-01 01:17:30.000000', 'consum', 0.0324, 'lps'),
	(644527, 136, '2015-01-01 01:17:31.000000', 'consum', 0.0267, 'lps'),
	(644528, 136, '2015-01-01 01:17:32.000000', 'consum', 0.0275, 'lps'),
	(644529, 136, '2015-01-01 01:17:33.000000', 'consum', 0.0240, 'lps'),
	(644530, 136, '2015-01-01 01:17:34.000000', 'consum', 0.0289, 'lps'),
	(644531, 136, '2015-01-01 01:17:35.000000', 'consum', 0.0267, 'lps'),
	(644532, 136, '2015-01-01 01:17:36.000000', 'consum', 0.0262, 'lps'),
	(644533, 136, '2015-01-01 01:17:37.000000', 'consum', 0.0297, 'lps'),
	(644534, 136, '2015-01-01 01:17:38.000000', 'consum', 0.0241, 'lps'),
	(644535, 136, '2015-01-01 01:17:39.000000', 'consum', 0.0229, 'lps'),
	(644536, 136, '2015-01-01 01:17:40.000000', 'consum', 0.0212, 'lps'),
	(644537, 136, '2015-01-01 01:17:41.000000', 'consum', 0.0289, 'lps'),
	(644538, 136, '2015-01-01 01:17:42.000000', 'consum', 0.0226, 'lps'),
	(644539, 136, '2015-01-01 01:17:43.000000', 'consum', 0.0302, 'lps'),
	(644540, 136, '2015-01-01 01:17:44.000000', 'consum', 0.0250, 'lps'),
	(644541, 136, '2015-01-01 01:17:45.000000', 'consum', 0.0259, 'lps'),
	(644542, 136, '2015-01-01 01:17:46.000000', 'consum', 0.0212, 'lps'),
	(644543, 136, '2015-01-01 01:17:47.000000', 'consum', 0.0320, 'lps'),
	(644544, 136, '2015-01-01 01:17:48.000000', 'consum', 0.0257, 'lps'),
	(644545, 136, '2015-01-01 01:17:49.000000', 'consum', 0.0242, 'lps'),
	(644546, 136, '2015-01-01 01:17:50.000000', 'consum', 0.0227, 'lps'),
	(644547, 136, '2015-01-01 01:17:51.000000', 'consum', 0.0324, 'lps'),
	(644548, 136, '2015-01-01 01:17:52.000000', 'consum', 0.0235, 'lps'),
	(644549, 136, '2015-01-01 01:17:53.000000', 'consum', 0.0241, 'lps'),
	(644550, 136, '2015-01-01 01:17:54.000000', 'consum', 0.0291, 'lps'),
	(644551, 136, '2015-01-01 01:17:55.000000', 'consum', 0.0274, 'lps'),
	(644552, 136, '2015-01-01 01:17:56.000000', 'consum', 0.0287, 'lps'),
	(644553, 136, '2015-01-01 01:17:57.000000', 'consum', 0.0279, 'lps'),
	(644554, 136, '2015-01-01 01:17:58.000000', 'consum', 0.0327, 'lps'),
	(644555, 136, '2015-01-01 01:17:59.000000', 'consum', 0.0215, 'lps'),
	(644556, 136, '2015-01-01 01:18:00.000000', 'consum', 0.0256, 'lps'),
	(644557, 136, '2015-01-01 01:18:01.000000', 'consum', 0.0303, 'lps'),
	(644558, 136, '2015-01-01 01:18:02.000000', 'consum', 0.0289, 'lps'),
	(644559, 136, '2015-01-01 01:18:03.000000', 'consum', 0.0324, 'lps'),
	(644560, 136, '2015-01-01 01:18:04.000000', 'consum', 0.0299, 'lps'),
	(644561, 136, '2015-01-01 01:18:05.000000', 'consum', 0.0311, 'lps'),
	(644562, 136, '2015-01-01 01:18:06.000000', 'consum', 0.0327, 'lps'),
	(644563, 136, '2015-01-01 01:18:07.000000', 'consum', 0.0245, 'lps'),
	(644564, 136, '2015-01-01 01:18:08.000000', 'consum', 0.0282, 'lps'),
	(644565, 136, '2015-01-01 01:18:09.000000', 'consum', 0.0215, 'lps'),
	(644566, 136, '2015-01-01 01:18:10.000000', 'consum', 0.0270, 'lps'),
	(644567, 136, '2015-01-01 01:18:11.000000', 'consum', 0.0245, 'lps'),
	(644568, 136, '2015-01-01 01:18:12.000000', 'consum', 0.0332, 'lps'),
	(644569, 136, '2015-01-01 01:18:13.000000', 'consum', 0.0217, 'lps'),
	(644570, 136, '2015-01-01 01:18:14.000000', 'consum', 0.0252, 'lps'),
	(644571, 136, '2015-01-01 01:18:15.000000', 'consum', 0.0278, 'lps'),
	(644572, 136, '2015-01-01 01:18:16.000000', 'consum', 0.0298, 'lps'),
	(644573, 136, '2015-01-01 01:18:17.000000', 'consum', 0.0324, 'lps'),
	(644574, 136, '2015-01-01 01:18:18.000000', 'consum', 0.0270, 'lps'),
	(644575, 136, '2015-01-01 01:18:19.000000', 'consum', 0.0289, 'lps'),
	(644576, 136, '2015-01-01 01:18:20.000000', 'consum', 0.0303, 'lps'),
	(644577, 136, '2015-01-01 01:18:21.000000', 'consum', 0.0316, 'lps'),
	(644578, 136, '2015-01-01 01:18:22.000000', 'consum', 0.0214, 'lps'),
	(644579, 136, '2015-01-01 01:18:23.000000', 'consum', 0.0285, 'lps'),
	(644580, 136, '2015-01-01 01:18:24.000000', 'consum', 0.0323, 'lps'),
	(644581, 136, '2015-01-01 01:18:25.000000', 'consum', 0.0302, 'lps'),
	(644582, 136, '2015-01-01 01:18:26.000000', 'consum', 0.0333, 'lps'),
	(644583, 136, '2015-01-01 01:18:27.000000', 'consum', 0.0300, 'lps'),
	(644584, 136, '2015-01-01 01:18:28.000000', 'consum', 0.0294, 'lps'),
	(644585, 136, '2015-01-01 01:18:29.000000', 'consum', 0.0237, 'lps'),
	(644586, 136, '2015-01-01 01:18:30.000000', 'consum', 0.0218, 'lps'),
	(644587, 136, '2015-01-01 01:18:31.000000', 'consum', 0.0290, 'lps'),
	(644588, 136, '2015-01-01 01:18:32.000000', 'consum', 0.0218, 'lps'),
	(644589, 136, '2015-01-01 01:18:33.000000', 'consum', 0.0256, 'lps'),
	(644590, 136, '2015-01-01 01:18:34.000000', 'consum', 0.0295, 'lps'),
	(644591, 136, '2015-01-01 01:18:35.000000', 'consum', 0.0250, 'lps'),
	(644592, 136, '2015-01-01 01:18:36.000000', 'consum', 0.0277, 'lps'),
	(644593, 136, '2015-01-01 01:18:37.000000', 'consum', 0.0301, 'lps'),
	(644594, 136, '2015-01-01 01:18:38.000000', 'consum', 0.0217, 'lps'),
	(644595, 136, '2015-01-01 01:18:39.000000', 'consum', 0.0222, 'lps'),
	(644596, 136, '2015-01-01 01:18:40.000000', 'consum', 0.0249, 'lps'),
	(644597, 136, '2015-01-01 01:18:41.000000', 'consum', 0.0246, 'lps'),
	(644598, 136, '2015-01-01 01:18:42.000000', 'consum', 0.0273, 'lps'),
	(644599, 136, '2015-01-01 01:18:43.000000', 'consum', 0.0294, 'lps'),
	(644600, 136, '2015-01-01 01:18:44.000000', 'consum', 0.0317, 'lps'),
	(644601, 136, '2015-01-01 01:18:45.000000', 'consum', 0.0247, 'lps'),
	(644602, 136, '2015-01-01 01:18:46.000000', 'consum', 0.0323, 'lps'),
	(644603, 136, '2015-01-01 01:18:47.000000', 'consum', 0.0291, 'lps'),
	(644604, 136, '2015-01-01 01:18:48.000000', 'consum', 0.0277, 'lps'),
	(644605, 136, '2015-01-01 01:18:49.000000', 'consum', 0.0301, 'lps'),
	(644606, 136, '2015-01-01 01:18:50.000000', 'consum', 0.0216, 'lps'),
	(644607, 136, '2015-01-01 01:18:51.000000', 'consum', 0.0215, 'lps'),
	(644608, 136, '2015-01-01 01:18:52.000000', 'consum', 0.0217, 'lps'),
	(644609, 136, '2015-01-01 01:18:53.000000', 'consum', 0.0231, 'lps'),
	(644610, 136, '2015-01-01 01:18:54.000000', 'consum', 0.0297, 'lps'),
	(644611, 136, '2015-01-01 01:18:55.000000', 'consum', 0.0331, 'lps'),
	(644612, 136, '2015-01-01 01:18:56.000000', 'consum', 0.0309, 'lps'),
	(644613, 136, '2015-01-01 01:18:57.000000', 'consum', 0.0219, 'lps'),
	(644614, 136, '2015-01-01 01:18:58.000000', 'consum', 0.0328, 'lps'),
	(644615, 136, '2015-01-01 01:18:59.000000', 'consum', 0.0279, 'lps'),
	(644616, 136, '2015-01-01 01:19:00.000000', 'consum', 0.0325, 'lps'),
	(644617, 136, '2015-01-01 01:19:01.000000', 'consum', 0.0330, 'lps'),
	(644618, 136, '2015-01-01 01:19:02.000000', 'consum', 0.0218, 'lps'),
	(644619, 136, '2015-01-01 01:19:03.000000', 'consum', 0.0263, 'lps'),
	(644620, 136, '2015-01-01 01:19:04.000000', 'consum', 0.0325, 'lps'),
	(644621, 136, '2015-01-01 01:19:05.000000', 'consum', 0.0257, 'lps'),
	(644622, 136, '2015-01-01 01:19:06.000000', 'consum', 0.0223, 'lps'),
	(644623, 136, '2015-01-01 01:19:07.000000', 'consum', 0.0257, 'lps'),
	(644624, 136, '2015-01-01 01:19:08.000000', 'consum', 0.0286, 'lps'),
	(644625, 136, '2015-01-01 01:19:09.000000', 'consum', 0.0322, 'lps'),
	(644626, 136, '2015-01-01 01:19:10.000000', 'consum', 0.0297, 'lps'),
	(644627, 136, '2015-01-01 01:19:11.000000', 'consum', 0.0311, 'lps'),
	(644628, 136, '2015-01-01 01:19:12.000000', 'consum', 0.0328, 'lps'),
	(644629, 136, '2015-01-01 01:19:13.000000', 'consum', 0.0251, 'lps'),
	(644630, 136, '2015-01-01 01:19:14.000000', 'consum', 0.0307, 'lps'),
	(644631, 136, '2015-01-01 01:19:15.000000', 'consum', 0.0327, 'lps'),
	(644632, 136, '2015-01-01 01:19:16.000000', 'consum', 0.0256, 'lps'),
	(644633, 136, '2015-01-01 01:19:17.000000', 'consum', 0.0214, 'lps'),
	(644634, 136, '2015-01-01 01:19:18.000000', 'consum', 0.0217, 'lps'),
	(644635, 136, '2015-01-01 01:19:19.000000', 'consum', 0.0233, 'lps'),
	(644636, 136, '2015-01-01 01:19:20.000000', 'consum', 0.0303, 'lps'),
	(644637, 136, '2015-01-01 01:19:21.000000', 'consum', 0.0235, 'lps'),
	(644638, 136, '2015-01-01 01:19:22.000000', 'consum', 0.0303, 'lps'),
	(644639, 136, '2015-01-01 01:19:23.000000', 'consum', 0.0231, 'lps'),
	(644640, 136, '2015-01-01 01:19:24.000000', 'consum', 0.0282, 'lps'),
	(644641, 136, '2015-01-01 01:19:25.000000', 'consum', 0.0261, 'lps'),
	(644642, 136, '2015-01-01 01:19:26.000000', 'consum', 0.0247, 'lps'),
	(644643, 136, '2015-01-01 01:19:27.000000', 'consum', 0.0246, 'lps'),
	(644644, 136, '2015-01-01 01:19:28.000000', 'consum', 0.0278, 'lps'),
	(644645, 136, '2015-01-01 01:19:29.000000', 'consum', 0.0317, 'lps'),
	(644646, 136, '2015-01-01 01:19:30.000000', 'consum', 0.0295, 'lps'),
	(644647, 136, '2015-01-01 01:19:31.000000', 'consum', 0.0316, 'lps'),
	(644648, 136, '2015-01-01 01:19:32.000000', 'consum', 0.0237, 'lps'),
	(644649, 136, '2015-01-01 01:19:33.000000', 'consum', 0.0277, 'lps'),
	(644650, 136, '2015-01-01 01:19:34.000000', 'consum', 0.0213, 'lps'),
	(644651, 136, '2015-01-01 01:19:35.000000', 'consum', 0.0276, 'lps'),
	(644652, 136, '2015-01-01 01:19:36.000000', 'consum', 0.0281, 'lps'),
	(644653, 136, '2015-01-01 01:19:37.000000', 'consum', 0.0246, 'lps'),
	(644654, 136, '2015-01-01 01:19:38.000000', 'consum', 0.0300, 'lps'),
	(644655, 136, '2015-01-01 01:19:39.000000', 'consum', 0.0305, 'lps'),
	(644656, 136, '2015-01-01 01:19:40.000000', 'consum', 0.0292, 'lps'),
	(644657, 136, '2015-01-01 01:19:41.000000', 'consum', 0.0211, 'lps'),
	(644658, 136, '2015-01-01 01:19:42.000000', 'consum', 0.0219, 'lps'),
	(644659, 136, '2015-01-01 01:19:43.000000', 'consum', 0.0251, 'lps'),
	(644660, 136, '2015-01-01 01:19:44.000000', 'consum', 0.0263, 'lps'),
	(644661, 136, '2015-01-01 01:19:45.000000', 'consum', 0.0232, 'lps'),
	(644662, 136, '2015-01-01 01:19:46.000000', 'consum', 0.0283, 'lps'),
	(644663, 136, '2015-01-01 01:19:47.000000', 'consum', 0.0264, 'lps'),
	(644664, 136, '2015-01-01 01:19:48.000000', 'consum', 0.0258, 'lps'),
	(644665, 136, '2015-01-01 01:19:49.000000', 'consum', 0.0292, 'lps'),
	(644666, 136, '2015-01-01 01:19:50.000000', 'consum', 0.0227, 'lps'),
	(644667, 136, '2015-01-01 01:19:51.000000', 'consum', 0.0298, 'lps'),
	(644668, 136, '2015-01-01 01:19:52.000000', 'consum', 0.0228, 'lps'),
	(644669, 136, '2015-01-01 01:19:53.000000', 'consum', 0.0286, 'lps'),
	(644670, 136, '2015-01-01 01:19:54.000000', 'consum', 0.0287, 'lps'),
	(644671, 136, '2015-01-01 01:19:55.000000', 'consum', 0.0243, 'lps'),
	(644672, 136, '2015-01-01 01:19:56.000000', 'consum', 0.0269, 'lps'),
	(644673, 136, '2015-01-01 01:19:57.000000', 'consum', 0.0281, 'lps'),
	(644674, 136, '2015-01-01 01:19:58.000000', 'consum', 0.0265, 'lps'),
	(644675, 136, '2015-01-01 01:19:59.000000', 'consum', 0.0272, 'lps'),
	(644676, 136, '2015-01-01 01:20:00.000000', 'consum', 0.0232, 'lps'),
	(644677, 136, '2015-01-01 01:20:01.000000', 'consum', 0.0259, 'lps'),
	(644678, 136, '2015-01-01 01:20:02.000000', 'consum', 0.0267, 'lps'),
	(644679, 136, '2015-01-01 01:20:03.000000', 'consum', 0.0225, 'lps'),
	(644680, 136, '2015-01-01 01:20:04.000000', 'consum', 0.0236, 'lps'),
	(644681, 136, '2015-01-01 01:20:05.000000', 'consum', 0.0296, 'lps'),
	(644682, 136, '2015-01-01 01:20:06.000000', 'consum', 0.0314, 'lps'),
	(644683, 136, '2015-01-01 01:20:07.000000', 'consum', 0.0226, 'lps'),
	(644684, 136, '2015-01-01 01:20:08.000000', 'consum', 0.0224, 'lps'),
	(644685, 136, '2015-01-01 01:20:09.000000', 'consum', 0.0234, 'lps'),
	(644686, 136, '2015-01-01 01:20:10.000000', 'consum', 0.0290, 'lps'),
	(644687, 136, '2015-01-01 01:20:11.000000', 'consum', 0.0290, 'lps'),
	(644688, 136, '2015-01-01 01:20:12.000000', 'consum', 0.0247, 'lps'),
	(644689, 136, '2015-01-01 01:20:13.000000', 'consum', 0.0278, 'lps'),
	(644690, 136, '2015-01-01 01:20:14.000000', 'consum', 0.0317, 'lps'),
	(644691, 136, '2015-01-01 01:20:15.000000', 'consum', 0.0295, 'lps'),
	(644692, 136, '2015-01-01 01:20:16.000000', 'consum', 0.0311, 'lps'),
	(644693, 136, '2015-01-01 01:20:17.000000', 'consum', 0.0214, 'lps'),
	(644694, 136, '2015-01-01 01:20:18.000000', 'consum', 0.0301, 'lps'),
	(644695, 136, '2015-01-01 01:20:19.000000', 'consum', 0.0280, 'lps'),
	(644696, 136, '2015-01-01 01:20:20.000000', 'consum', 0.0289, 'lps'),
	(644697, 136, '2015-01-01 01:20:21.000000', 'consum', 0.0272, 'lps'),
	(644698, 136, '2015-01-01 01:20:22.000000', 'consum', 0.0284, 'lps'),
	(644699, 136, '2015-01-01 01:20:23.000000', 'consum', 0.0268, 'lps'),
	(644700, 136, '2015-01-01 01:20:24.000000', 'consum', 0.0279, 'lps'),
	(644701, 136, '2015-01-01 01:20:25.000000', 'consum', 0.0260, 'lps'),
	(644702, 136, '2015-01-01 01:20:26.000000', 'consum', 0.0250, 'lps'),
	(644703, 136, '2015-01-01 01:20:27.000000', 'consum', 0.0263, 'lps'),
	(644704, 136, '2015-01-01 01:20:28.000000', 'consum', 0.0229, 'lps'),
	(644705, 136, '2015-01-01 01:20:29.000000', 'consum', 0.0272, 'lps'),
	(644706, 136, '2015-01-01 01:20:30.000000', 'consum', 0.0215, 'lps'),
	(644707, 136, '2015-01-01 01:20:31.000000', 'consum', 0.0299, 'lps'),
	(644708, 136, '2015-01-01 01:20:32.000000', 'consum', 0.0270, 'lps'),
	(644709, 136, '2015-01-01 01:20:33.000000', 'consum', 0.0240, 'lps'),
	(644710, 136, '2015-01-01 01:20:34.000000', 'consum', 0.0305, 'lps'),
	(644711, 136, '2015-01-01 01:20:35.000000', 'consum', 0.0223, 'lps'),
	(644712, 136, '2015-01-01 01:20:36.000000', 'consum', 0.0239, 'lps'),
	(644713, 136, '2015-01-01 01:20:37.000000', 'consum', 0.0317, 'lps'),
	(644714, 136, '2015-01-01 01:20:38.000000', 'consum', 0.0287, 'lps'),
	(644715, 136, '2015-01-01 01:20:39.000000', 'consum', 0.0275, 'lps'),
	(644716, 136, '2015-01-01 01:20:40.000000', 'consum', 0.0304, 'lps'),
	(644717, 136, '2015-01-01 01:20:41.000000', 'consum', 0.0236, 'lps'),
	(644718, 136, '2015-01-01 01:20:42.000000', 'consum', 0.0309, 'lps'),
	(644719, 136, '2015-01-01 01:20:43.000000', 'consum', 0.0253, 'lps'),
	(644720, 136, '2015-01-01 01:20:44.000000', 'consum', 0.0252, 'lps'),
	(644721, 136, '2015-01-01 01:20:45.000000', 'consum', 0.0294, 'lps'),
	(644722, 136, '2015-01-01 01:20:46.000000', 'consum', 0.0256, 'lps'),
	(644723, 136, '2015-01-01 01:20:47.000000', 'consum', 0.0311, 'lps'),
	(644724, 136, '2015-01-01 01:20:48.000000', 'consum', 0.0329, 'lps'),
	(644725, 136, '2015-01-01 01:20:49.000000', 'consum', 0.0256, 'lps'),
	(644726, 136, '2015-01-01 01:20:50.000000', 'consum', 0.0331, 'lps'),
	(644727, 136, '2015-01-01 01:20:51.000000', 'consum', 0.0304, 'lps'),
	(644728, 136, '2015-01-01 01:20:52.000000', 'consum', 0.0319, 'lps'),
	(644729, 136, '2015-01-01 01:20:53.000000', 'consum', 0.0224, 'lps'),
	(644730, 136, '2015-01-01 01:20:54.000000', 'consum', 0.0325, 'lps'),
	(644731, 136, '2015-01-01 01:20:55.000000', 'consum', 0.0248, 'lps'),
	(644732, 136, '2015-01-01 01:20:56.000000', 'consum', 0.0306, 'lps'),
	(644733, 136, '2015-01-01 01:20:57.000000', 'consum', 0.0326, 'lps'),
	(644734, 136, '2015-01-01 01:20:58.000000', 'consum', 0.0254, 'lps'),
	(644735, 136, '2015-01-01 01:20:59.000000', 'consum', 0.0329, 'lps'),
	(644736, 136, '2015-01-01 01:21:00.000000', 'consum', 0.0305, 'lps'),
	(644737, 136, '2015-01-01 01:21:01.000000', 'consum', 0.0328, 'lps'),
	(644738, 136, '2015-01-01 01:21:02.000000', 'consum', 0.0267, 'lps'),
	(644739, 136, '2015-01-01 01:21:03.000000', 'consum', 0.0266, 'lps'),
	(644740, 136, '2015-01-01 01:21:04.000000', 'consum', 0.0320, 'lps'),
	(644741, 136, '2015-01-01 01:21:05.000000', 'consum', 0.0220, 'lps'),
	(644742, 136, '2015-01-01 01:21:06.000000', 'consum', 0.0303, 'lps'),
	(644743, 136, '2015-01-01 01:21:07.000000', 'consum', 0.0272, 'lps'),
	(644744, 136, '2015-01-01 01:21:08.000000', 'consum', 0.0242, 'lps'),
	(644745, 136, '2015-01-01 01:21:09.000000', 'consum', 0.0309, 'lps'),
	(644746, 136, '2015-01-01 01:21:10.000000', 'consum', 0.0239, 'lps'),
	(644747, 136, '2015-01-01 01:21:11.000000', 'consum', 0.0304, 'lps'),
	(644748, 136, '2015-01-01 01:21:12.000000', 'consum', 0.0221, 'lps'),
	(644749, 136, '2015-01-01 01:21:13.000000', 'consum', 0.0232, 'lps'),
	(644750, 136, '2015-01-01 01:21:14.000000', 'consum', 0.0289, 'lps'),
	(644751, 136, '2015-01-01 01:21:15.000000', 'consum', 0.0291, 'lps'),
	(644752, 136, '2015-01-01 01:21:16.000000', 'consum', 0.0253, 'lps'),
	(644753, 136, '2015-01-01 01:21:17.000000', 'consum', 0.0308, 'lps'),
	(644754, 136, '2015-01-01 01:21:18.000000', 'consum', 0.0322, 'lps'),
	(644755, 136, '2015-01-01 01:21:19.000000', 'consum', 0.0229, 'lps'),
	(644756, 136, '2015-01-01 01:21:20.000000', 'consum', 0.0216, 'lps'),
	(644757, 136, '2015-01-01 01:21:21.000000', 'consum', 0.0309, 'lps'),
	(644758, 136, '2015-01-01 01:21:22.000000', 'consum', 0.0316, 'lps'),
	(644759, 136, '2015-01-01 01:21:23.000000', 'consum', 0.0319, 'lps'),
	(644760, 136, '2015-01-01 01:21:24.000000', 'consum', 0.0313, 'lps'),
	(644761, 136, '2015-01-01 01:21:25.000000', 'consum', 0.0275, 'lps'),
	(644762, 136, '2015-01-01 01:21:26.000000', 'consum', 0.0225, 'lps'),
	(644763, 136, '2015-01-01 01:21:27.000000', 'consum', 0.0214, 'lps'),
	(644764, 136, '2015-01-01 01:21:28.000000', 'consum', 0.0311, 'lps'),
	(644765, 136, '2015-01-01 01:21:29.000000', 'consum', 0.0332, 'lps'),
	(644766, 136, '2015-01-01 01:21:30.000000', 'consum', 0.0271, 'lps'),
	(644767, 136, '2015-01-01 01:21:31.000000', 'consum', 0.0272, 'lps'),
	(644768, 136, '2015-01-01 01:21:32.000000', 'consum', 0.0212, 'lps'),
	(644769, 136, '2015-01-01 01:21:33.000000', 'consum', 0.0282, 'lps'),
	(644770, 136, '2015-01-01 01:21:34.000000', 'consum', 0.0317, 'lps'),
	(644771, 136, '2015-01-01 01:21:35.000000', 'consum', 0.0282, 'lps'),
	(644772, 136, '2015-01-01 01:21:36.000000', 'consum', 0.0251, 'lps'),
	(644773, 136, '2015-01-01 01:21:37.000000', 'consum', 0.0322, 'lps'),
	(644774, 136, '2015-01-01 01:21:38.000000', 'consum', 0.0276, 'lps'),
	(644775, 136, '2015-01-01 01:21:39.000000', 'consum', 0.0330, 'lps'),
	(644776, 136, '2015-01-01 01:21:40.000000', 'consum', 0.0241, 'lps'),
	(644777, 136, '2015-01-01 01:21:41.000000', 'consum', 0.0252, 'lps'),
	(644778, 136, '2015-01-01 01:21:42.000000', 'consum', 0.0327, 'lps'),
	(644779, 136, '2015-01-01 01:21:43.000000', 'consum', 0.0298, 'lps'),
	(644780, 136, '2015-01-01 01:21:44.000000', 'consum', 0.0301, 'lps'),
	(644781, 136, '2015-01-01 01:21:45.000000', 'consum', 0.0278, 'lps'),
	(644782, 136, '2015-01-01 01:21:46.000000', 'consum', 0.0277, 'lps'),
	(644783, 136, '2015-01-01 01:21:47.000000', 'consum', 0.0219, 'lps'),
	(644784, 136, '2015-01-01 01:21:48.000000', 'consum', 0.0300, 'lps'),
	(644785, 136, '2015-01-01 01:21:49.000000', 'consum', 0.0261, 'lps'),
	(644786, 136, '2015-01-01 01:21:50.000000', 'consum', 0.0320, 'lps'),
	(644787, 136, '2015-01-01 01:21:51.000000', 'consum', 0.0237, 'lps'),
	(644788, 136, '2015-01-01 01:21:52.000000', 'consum', 0.0263, 'lps'),
	(644789, 136, '2015-01-01 01:21:53.000000', 'consum', 0.0272, 'lps'),
	(644790, 136, '2015-01-01 01:21:54.000000', 'consum', 0.0236, 'lps'),
	(644791, 136, '2015-01-01 01:21:55.000000', 'consum', 0.0278, 'lps'),
	(644792, 136, '2015-01-01 01:21:56.000000', 'consum', 0.0223, 'lps'),
	(644793, 136, '2015-01-01 01:21:57.000000', 'consum', 0.0320, 'lps'),
	(644794, 136, '2015-01-01 01:21:58.000000', 'consum', 0.0228, 'lps'),
	(644795, 136, '2015-01-01 01:21:59.000000', 'consum', 0.0217, 'lps'),
	(644796, 136, '2015-01-01 01:22:00.000000', 'consum', 0.0314, 'lps'),
	(644797, 136, '2015-01-01 01:22:01.000000', 'consum', 0.0214, 'lps'),
	(644798, 136, '2015-01-01 01:22:02.000000', 'consum', 0.0290, 'lps'),
	(644799, 136, '2015-01-01 01:22:03.000000', 'consum', 0.0229, 'lps'),
	(644800, 136, '2015-01-01 01:22:04.000000', 'consum', 0.0313, 'lps'),
	(644801, 136, '2015-01-01 01:22:05.000000', 'consum', 0.0296, 'lps'),
	(644802, 136, '2015-01-01 01:22:06.000000', 'consum', 0.0333, 'lps'),
	(644803, 136, '2015-01-01 01:22:07.000000', 'consum', 0.0319, 'lps'),
	(644804, 136, '2015-01-01 01:22:08.000000', 'consum', 0.0260, 'lps'),
	(644805, 136, '2015-01-01 01:22:09.000000', 'consum', 0.0261, 'lps'),
	(644806, 136, '2015-01-01 01:22:10.000000', 'consum', 0.0313, 'lps'),
	(644807, 136, '2015-01-01 01:22:11.000000', 'consum', 0.0327, 'lps'),
	(644808, 136, '2015-01-01 01:22:12.000000', 'consum', 0.0236, 'lps'),
	(644809, 136, '2015-01-01 01:22:13.000000', 'consum', 0.0237, 'lps'),
	(644810, 136, '2015-01-01 01:22:14.000000', 'consum', 0.0267, 'lps'),
	(644811, 136, '2015-01-01 01:22:15.000000', 'consum', 0.0290, 'lps'),
	(644812, 136, '2015-01-01 01:22:16.000000', 'consum', 0.0318, 'lps'),
	(644813, 136, '2015-01-01 01:22:17.000000', 'consum', 0.0260, 'lps'),
	(644814, 136, '2015-01-01 01:22:18.000000', 'consum', 0.0262, 'lps'),
	(644815, 136, '2015-01-01 01:22:19.000000', 'consum', 0.0318, 'lps'),
	(644816, 136, '2015-01-01 01:22:20.000000', 'consum', 0.0225, 'lps'),
	(644817, 136, '2015-01-01 01:22:21.000000', 'consum', 0.0332, 'lps'),
	(644818, 136, '2015-01-01 01:22:22.000000', 'consum', 0.0281, 'lps'),
	(644819, 136, '2015-01-01 01:22:23.000000', 'consum', 0.0321, 'lps'),
	(644820, 136, '2015-01-01 01:22:24.000000', 'consum', 0.0305, 'lps'),
	(644821, 136, '2015-01-01 01:22:25.000000', 'consum', 0.0231, 'lps'),
	(644822, 136, '2015-01-01 01:22:26.000000', 'consum', 0.0278, 'lps'),
	(644823, 136, '2015-01-01 01:22:27.000000', 'consum', 0.0238, 'lps'),
	(644824, 136, '2015-01-01 01:22:28.000000', 'consum', 0.0272, 'lps'),
	(644825, 136, '2015-01-01 01:22:29.000000', 'consum', 0.0313, 'lps'),
	(644826, 136, '2015-01-01 01:22:30.000000', 'consum', 0.0290, 'lps'),
	(644827, 136, '2015-01-01 01:22:31.000000', 'consum', 0.0300, 'lps'),
	(644828, 136, '2015-01-01 01:22:32.000000', 'consum', 0.0298, 'lps'),
	(644829, 136, '2015-01-01 01:22:33.000000', 'consum', 0.0255, 'lps'),
	(644830, 136, '2015-01-01 01:22:34.000000', 'consum', 0.0295, 'lps'),
	(644831, 136, '2015-01-01 01:22:35.000000', 'consum', 0.0253, 'lps'),
	(644832, 136, '2015-01-01 01:22:36.000000', 'consum', 0.0294, 'lps'),
	(644833, 136, '2015-01-01 01:22:37.000000', 'consum', 0.0254, 'lps'),
	(644834, 136, '2015-01-01 01:22:38.000000', 'consum', 0.0301, 'lps'),
	(644835, 136, '2015-01-01 01:22:39.000000', 'consum', 0.0286, 'lps'),
	(644836, 136, '2015-01-01 01:22:40.000000', 'consum', 0.0318, 'lps'),
	(644837, 136, '2015-01-01 01:22:41.000000', 'consum', 0.0275, 'lps'),
	(644838, 136, '2015-01-01 01:22:42.000000', 'consum', 0.0213, 'lps'),
	(644839, 136, '2015-01-01 01:22:43.000000', 'consum', 0.0275, 'lps'),
	(644840, 136, '2015-01-01 01:22:44.000000', 'consum', 0.0281, 'lps'),
	(644841, 136, '2015-01-01 01:22:45.000000', 'consum', 0.0245, 'lps'),
	(644842, 136, '2015-01-01 01:22:46.000000', 'consum', 0.0297, 'lps'),
	(644843, 136, '2015-01-01 01:22:47.000000', 'consum', 0.0293, 'lps'),
	(644844, 136, '2015-01-01 01:22:48.000000', 'consum', 0.0242, 'lps'),
	(644845, 136, '2015-01-01 01:22:49.000000', 'consum', 0.0242, 'lps'),
	(644846, 136, '2015-01-01 01:22:50.000000', 'consum', 0.0278, 'lps'),
	(644847, 136, '2015-01-01 01:22:51.000000', 'consum', 0.0327, 'lps'),
	(644848, 136, '2015-01-01 01:22:52.000000', 'consum', 0.0222, 'lps'),
	(644849, 136, '2015-01-01 01:22:53.000000', 'consum', 0.0291, 'lps'),
	(644850, 136, '2015-01-01 01:22:54.000000', 'consum', 0.0331, 'lps'),
	(644851, 136, '2015-01-01 01:22:55.000000', 'consum', 0.0323, 'lps'),
	(644852, 136, '2015-01-01 01:22:56.000000', 'consum', 0.0288, 'lps'),
	(644853, 136, '2015-01-01 01:22:57.000000', 'consum', 0.0265, 'lps'),
	(644854, 136, '2015-01-01 01:22:58.000000', 'consum', 0.0249, 'lps'),
	(644855, 136, '2015-01-01 01:22:59.000000', 'consum', 0.0240, 'lps'),
	(644856, 136, '2015-01-01 01:23:00.000000', 'consum', 0.0242, 'lps'),
	(644857, 136, '2015-01-01 01:23:01.000000', 'consum', 0.0284, 'lps'),
	(644858, 136, '2015-01-01 01:23:02.000000', 'consum', 0.0235, 'lps'),
	(644859, 136, '2015-01-01 01:23:03.000000', 'consum', 0.0235, 'lps'),
	(644860, 136, '2015-01-01 01:23:04.000000', 'consum', 0.0264, 'lps'),
	(644861, 136, '2015-01-01 01:23:05.000000', 'consum', 0.0282, 'lps'),
	(644862, 136, '2015-01-01 01:23:06.000000', 'consum', 0.0285, 'lps'),
	(644863, 136, '2015-01-01 01:23:07.000000', 'consum', 0.0243, 'lps'),
	(644864, 136, '2015-01-01 01:23:08.000000', 'consum', 0.0276, 'lps'),
	(644865, 136, '2015-01-01 01:23:09.000000', 'consum', 0.0317, 'lps'),
	(644866, 136, '2015-01-01 01:23:10.000000', 'consum', 0.0301, 'lps'),
	(644867, 136, '2015-01-01 01:23:11.000000', 'consum', 0.0219, 'lps'),
	(644868, 136, '2015-01-01 01:23:12.000000', 'consum', 0.0230, 'lps'),
	(644869, 136, '2015-01-01 01:23:13.000000', 'consum', 0.0282, 'lps'),
	(644870, 136, '2015-01-01 01:23:14.000000', 'consum', 0.0266, 'lps'),
	(644871, 136, '2015-01-01 01:23:15.000000', 'consum', 0.0272, 'lps'),
	(644872, 136, '2015-01-01 01:23:16.000000', 'consum', 0.0229, 'lps'),
	(644873, 136, '2015-01-01 01:23:17.000000', 'consum', 0.0245, 'lps'),
	(644874, 136, '2015-01-01 01:23:18.000000', 'consum', 0.0330, 'lps'),
	(644875, 136, '2015-01-01 01:23:19.000000', 'consum', 0.0330, 'lps'),
	(644876, 136, '2015-01-01 01:23:20.000000', 'consum', 0.0328, 'lps'),
	(644877, 136, '2015-01-01 01:23:21.000000', 'consum', 0.0317, 'lps'),
	(644878, 136, '2015-01-01 01:23:22.000000', 'consum', 0.0266, 'lps'),
	(644879, 136, '2015-01-01 01:23:23.000000', 'consum', 0.0296, 'lps'),
	(644880, 136, '2015-01-01 01:23:24.000000', 'consum', 0.0225, 'lps'),
	(644881, 136, '2015-01-01 01:23:25.000000', 'consum', 0.0274, 'lps'),
	(644882, 136, '2015-01-01 01:23:26.000000', 'consum', 0.0236, 'lps'),
	(644883, 136, '2015-01-01 01:23:27.000000', 'consum', 0.0272, 'lps'),
	(644884, 136, '2015-01-01 01:23:28.000000', 'consum', 0.0321, 'lps'),
	(644885, 136, '2015-01-01 01:23:29.000000', 'consum', 0.0329, 'lps'),
	(644886, 136, '2015-01-01 01:23:30.000000', 'consum', 0.0225, 'lps'),
	(644887, 136, '2015-01-01 01:23:31.000000', 'consum', 0.0299, 'lps'),
	(644888, 136, '2015-01-01 01:23:32.000000', 'consum', 0.0240, 'lps'),
	(644889, 136, '2015-01-01 01:23:33.000000', 'consum', 0.0215, 'lps'),
	(644890, 136, '2015-01-01 01:23:34.000000', 'consum', 0.0273, 'lps'),
	(644891, 136, '2015-01-01 01:23:35.000000', 'consum', 0.0262, 'lps'),
	(644892, 136, '2015-01-01 01:23:36.000000', 'consum', 0.0280, 'lps'),
	(644893, 136, '2015-01-01 01:23:37.000000', 'consum', 0.0280, 'lps'),
	(644894, 136, '2015-01-01 01:23:38.000000', 'consum', 0.0228, 'lps'),
	(644895, 136, '2015-01-01 01:23:39.000000', 'consum', 0.0215, 'lps'),
	(644896, 136, '2015-01-01 01:23:40.000000', 'consum', 0.0304, 'lps'),
	(644897, 136, '2015-01-01 01:23:41.000000', 'consum', 0.0295, 'lps'),
	(644898, 136, '2015-01-01 01:23:42.000000', 'consum', 0.0228, 'lps'),
	(644899, 136, '2015-01-01 01:23:43.000000', 'consum', 0.0292, 'lps'),
	(644900, 136, '2015-01-01 01:23:44.000000', 'consum', 0.0322, 'lps'),
	(644901, 136, '2015-01-01 01:23:45.000000', 'consum', 0.0275, 'lps'),
	(644902, 136, '2015-01-01 01:23:46.000000', 'consum', 0.0325, 'lps'),
	(644903, 136, '2015-01-01 01:23:47.000000', 'consum', 0.0215, 'lps'),
	(644904, 136, '2015-01-01 01:23:48.000000', 'consum', 0.0266, 'lps'),
	(644905, 136, '2015-01-01 01:23:49.000000', 'consum', 0.0228, 'lps'),
	(644906, 136, '2015-01-01 01:23:50.000000', 'consum', 0.0255, 'lps'),
	(644907, 136, '2015-01-01 01:23:51.000000', 'consum', 0.0256, 'lps'),
	(644908, 136, '2015-01-01 01:23:52.000000', 'consum', 0.0306, 'lps'),
	(644909, 136, '2015-01-01 01:23:53.000000', 'consum', 0.0306, 'lps'),
	(644910, 136, '2015-01-01 01:23:54.000000', 'consum', 0.0279, 'lps'),
	(644911, 136, '2015-01-01 01:23:55.000000', 'consum', 0.0265, 'lps'),
	(644912, 136, '2015-01-01 01:23:56.000000', 'consum', 0.0279, 'lps'),
	(644913, 136, '2015-01-01 01:23:57.000000', 'consum', 0.0266, 'lps'),
	(644914, 136, '2015-01-01 01:23:58.000000', 'consum', 0.0284, 'lps'),
	(644915, 136, '2015-01-01 01:23:59.000000', 'consum', 0.0289, 'lps'),
	(644916, 136, '2015-01-01 01:24:00.000000', 'consum', 0.0261, 'lps'),
	(644917, 136, '2015-01-01 01:24:01.000000', 'consum', 0.0227, 'lps'),
	(644918, 136, '2015-01-01 01:24:02.000000', 'consum', 0.0269, 'lps'),
	(644919, 136, '2015-01-01 01:24:03.000000', 'consum', 0.0327, 'lps'),
	(644920, 136, '2015-01-01 01:24:04.000000', 'consum', 0.0248, 'lps'),
	(644921, 136, '2015-01-01 01:24:05.000000', 'consum', 0.0298, 'lps'),
	(644922, 136, '2015-01-01 01:24:06.000000', 'consum', 0.0286, 'lps'),
	(644923, 136, '2015-01-01 01:24:07.000000', 'consum', 0.0329, 'lps'),
	(644924, 136, '2015-01-01 01:24:08.000000', 'consum', 0.0327, 'lps'),
	(644925, 136, '2015-01-01 01:24:09.000000', 'consum', 0.0317, 'lps'),
	(644926, 136, '2015-01-01 01:24:10.000000', 'consum', 0.0268, 'lps'),
	(644927, 136, '2015-01-01 01:24:11.000000', 'consum', 0.0303, 'lps'),
	(644928, 136, '2015-01-01 01:24:12.000000', 'consum', 0.0255, 'lps'),
	(644929, 136, '2015-01-01 01:24:13.000000', 'consum', 0.0280, 'lps'),
	(644930, 136, '2015-01-01 01:24:14.000000', 'consum', 0.0302, 'lps'),
	(644931, 136, '2015-01-01 01:24:15.000000', 'consum', 0.0214, 'lps'),
	(644932, 136, '2015-01-01 01:24:16.000000', 'consum', 0.0327, 'lps'),
	(644933, 136, '2015-01-01 01:24:17.000000', 'consum', 0.0285, 'lps'),
	(644934, 136, '2015-01-01 01:24:18.000000', 'consum', 0.0236, 'lps'),
	(644935, 136, '2015-01-01 01:24:19.000000', 'consum', 0.0240, 'lps'),
	(644936, 136, '2015-01-01 01:24:20.000000', 'consum', 0.0282, 'lps'),
	(644937, 136, '2015-01-01 01:24:21.000000', 'consum', 0.0233, 'lps'),
	(644938, 136, '2015-01-01 01:24:22.000000', 'consum', 0.0232, 'lps'),
	(644939, 136, '2015-01-01 01:24:23.000000', 'consum', 0.0254, 'lps'),
	(644940, 136, '2015-01-01 01:24:24.000000', 'consum', 0.0240, 'lps'),
	(644941, 136, '2015-01-01 01:24:25.000000', 'consum', 0.0228, 'lps'),
	(644942, 136, '2015-01-01 01:24:26.000000', 'consum', 0.0332, 'lps'),
	(644943, 136, '2015-01-01 01:24:27.000000', 'consum', 0.0274, 'lps'),
	(644944, 136, '2015-01-01 01:24:28.000000', 'consum', 0.0288, 'lps'),
	(644945, 136, '2015-01-01 01:24:29.000000', 'consum', 0.0283, 'lps'),
	(644946, 136, '2015-01-01 01:24:30.000000', 'consum', 0.0217, 'lps'),
	(644947, 136, '2015-01-01 01:24:31.000000', 'consum', 0.0276, 'lps'),
	(644948, 136, '2015-01-01 01:24:32.000000', 'consum', 0.0272, 'lps'),
	(644949, 136, '2015-01-01 01:24:33.000000', 'consum', 0.0324, 'lps'),
	(644950, 136, '2015-01-01 01:24:34.000000', 'consum', 0.0220, 'lps'),
	(644951, 136, '2015-01-01 01:24:35.000000', 'consum', 0.0292, 'lps'),
	(644952, 136, '2015-01-01 01:24:36.000000', 'consum', 0.0217, 'lps'),
	(644953, 136, '2015-01-01 01:24:37.000000', 'consum', 0.0246, 'lps'),
	(644954, 136, '2015-01-01 01:24:38.000000', 'consum', 0.0248, 'lps'),
	(644955, 136, '2015-01-01 01:24:39.000000', 'consum', 0.0290, 'lps'),
	(644956, 136, '2015-01-01 01:24:40.000000', 'consum', 0.0248, 'lps'),
	(644957, 136, '2015-01-01 01:24:41.000000', 'consum', 0.0288, 'lps'),
	(644958, 136, '2015-01-01 01:24:42.000000', 'consum', 0.0236, 'lps'),
	(644959, 136, '2015-01-01 01:24:43.000000', 'consum', 0.0229, 'lps'),
	(644960, 136, '2015-01-01 01:24:44.000000', 'consum', 0.0230, 'lps'),
	(644961, 136, '2015-01-01 01:24:45.000000', 'consum', 0.0253, 'lps'),
	(644962, 136, '2015-01-01 01:24:46.000000', 'consum', 0.0243, 'lps'),
	(644963, 136, '2015-01-01 01:24:47.000000', 'consum', 0.0244, 'lps'),
	(644964, 136, '2015-01-01 01:24:48.000000', 'consum', 0.0281, 'lps'),
	(644965, 136, '2015-01-01 01:24:49.000000', 'consum', 0.0216, 'lps'),
	(644966, 136, '2015-01-01 01:24:50.000000', 'consum', 0.0277, 'lps'),
	(644967, 136, '2015-01-01 01:24:51.000000', 'consum', 0.0279, 'lps'),
	(644968, 136, '2015-01-01 01:24:52.000000', 'consum', 0.0231, 'lps'),
	(644969, 136, '2015-01-01 01:24:53.000000', 'consum', 0.0232, 'lps'),
	(644970, 136, '2015-01-01 01:24:54.000000', 'consum', 0.0259, 'lps'),
	(644971, 136, '2015-01-01 01:24:55.000000', 'consum', 0.0264, 'lps'),
	(644972, 136, '2015-01-01 01:24:56.000000', 'consum', 0.0211, 'lps'),
	(644973, 136, '2015-01-01 01:24:57.000000', 'consum', 0.0299, 'lps'),
	(644974, 136, '2015-01-01 01:24:58.000000', 'consum', 0.0280, 'lps'),
	(644975, 136, '2015-01-01 01:24:59.000000', 'consum', 0.0296, 'lps'),
	(644976, 136, '2015-01-01 01:25:00.000000', 'consum', 0.0304, 'lps'),
	(644977, 136, '2015-01-01 01:25:01.000000', 'consum', 0.0298, 'lps'),
	(644978, 136, '2015-01-01 01:25:02.000000', 'consum', 0.0247, 'lps'),
	(644979, 136, '2015-01-01 01:25:03.000000', 'consum', 0.0255, 'lps'),
	(644980, 136, '2015-01-01 01:25:04.000000', 'consum', 0.0323, 'lps'),
	(644981, 136, '2015-01-01 01:25:05.000000', 'consum', 0.0267, 'lps'),
	(644982, 136, '2015-01-01 01:25:06.000000', 'consum', 0.0283, 'lps'),
	(644983, 136, '2015-01-01 01:25:07.000000', 'consum', 0.0280, 'lps'),
	(644984, 136, '2015-01-01 01:25:08.000000', 'consum', 0.0216, 'lps'),
	(644985, 136, '2015-01-01 01:25:09.000000', 'consum', 0.0278, 'lps'),
	(644986, 136, '2015-01-01 01:25:10.000000', 'consum', 0.0286, 'lps'),
	(644987, 136, '2015-01-01 01:25:11.000000', 'consum', 0.0261, 'lps'),
	(644988, 136, '2015-01-01 01:25:12.000000', 'consum', 0.0238, 'lps'),
	(644989, 136, '2015-01-01 01:25:13.000000', 'consum', 0.0321, 'lps'),
	(644990, 136, '2015-01-01 01:25:14.000000', 'consum', 0.0308, 'lps'),
	(644991, 136, '2015-01-01 01:25:15.000000', 'consum', 0.0245, 'lps'),
	(644992, 136, '2015-01-01 01:25:16.000000', 'consum', 0.0215, 'lps'),
	(644993, 136, '2015-01-01 01:25:17.000000', 'consum', 0.0253, 'lps'),
	(644994, 136, '2015-01-01 01:25:18.000000', 'consum', 0.0287, 'lps'),
	(644995, 136, '2015-01-01 01:25:19.000000', 'consum', 0.0220, 'lps'),
	(644996, 136, '2015-01-01 01:25:20.000000', 'consum', 0.0279, 'lps'),
	(644997, 136, '2015-01-01 01:25:21.000000', 'consum', 0.0275, 'lps'),
	(644998, 136, '2015-01-01 01:25:22.000000', 'consum', 0.0328, 'lps'),
	(644999, 136, '2015-01-01 01:25:23.000000', 'consum', 0.0234, 'lps'),
	(645000, 136, '2015-01-01 01:25:24.000000', 'consum', 0.0226, 'lps'),
	(645001, 136, '2015-01-01 01:25:25.000000', 'consum', 0.0219, 'lps'),
	(645002, 136, '2015-01-01 01:25:26.000000', 'consum', 0.0332, 'lps'),
	(645003, 136, '2015-01-01 01:25:27.000000', 'consum', 0.0295, 'lps'),
	(645004, 136, '2015-01-01 01:25:28.000000', 'consum', 0.0270, 'lps'),
	(645005, 136, '2015-01-01 01:25:29.000000', 'consum', 0.0256, 'lps'),
	(645006, 136, '2015-01-01 01:25:30.000000', 'consum', 0.0260, 'lps'),
	(645007, 136, '2015-01-01 01:25:31.000000', 'consum', 0.0322, 'lps'),
	(645008, 136, '2015-01-01 01:25:32.000000', 'consum', 0.0249, 'lps'),
	(645009, 136, '2015-01-01 01:25:33.000000', 'consum', 0.0319, 'lps'),
	(645010, 136, '2015-01-01 01:25:34.000000', 'consum', 0.0265, 'lps'),
	(645011, 136, '2015-01-01 01:25:35.000000', 'consum', 0.0284, 'lps'),
	(645012, 136, '2015-01-01 01:25:36.000000', 'consum', 0.0291, 'lps'),
	(645013, 136, '2015-01-01 01:25:37.000000', 'consum', 0.0269, 'lps'),
	(645014, 136, '2015-01-01 01:25:38.000000', 'consum', 0.0262, 'lps'),
	(645015, 136, '2015-01-01 01:25:39.000000', 'consum', 0.0294, 'lps'),
	(645016, 136, '2015-01-01 01:25:40.000000', 'consum', 0.0225, 'lps'),
	(645017, 136, '2015-01-01 01:25:41.000000', 'consum', 0.0282, 'lps'),
	(645018, 136, '2015-01-01 01:25:42.000000', 'consum', 0.0279, 'lps'),
	(645019, 136, '2015-01-01 01:25:43.000000', 'consum', 0.0216, 'lps'),
	(645020, 136, '2015-01-01 01:25:44.000000', 'consum', 0.0283, 'lps'),
	(645021, 136, '2015-01-01 01:25:45.000000', 'consum', 0.0306, 'lps'),
	(645022, 136, '2015-01-01 01:25:46.000000', 'consum', 0.0227, 'lps'),
	(645023, 136, '2015-01-01 01:25:47.000000', 'consum', 0.0253, 'lps'),
	(645024, 136, '2015-01-01 01:25:48.000000', 'consum', 0.0251, 'lps'),
	(645025, 136, '2015-01-01 01:25:49.000000', 'consum', 0.0286, 'lps'),
	(645026, 136, '2015-01-01 01:25:50.000000', 'consum', 0.0221, 'lps'),
	(645027, 136, '2015-01-01 01:25:51.000000', 'consum', 0.0283, 'lps'),
	(645028, 136, '2015-01-01 01:25:52.000000', 'consum', 0.0296, 'lps'),
	(645029, 136, '2015-01-01 01:25:53.000000', 'consum', 0.0297, 'lps'),
	(645030, 136, '2015-01-01 01:25:54.000000', 'consum', 0.0266, 'lps'),
	(645031, 136, '2015-01-01 01:25:55.000000', 'consum', 0.0227, 'lps'),
	(645032, 136, '2015-01-01 01:25:56.000000', 'consum', 0.0251, 'lps'),
	(645033, 136, '2015-01-01 01:25:57.000000', 'consum', 0.0243, 'lps'),
	(645034, 136, '2015-01-01 01:25:58.000000', 'consum', 0.0249, 'lps'),
	(645035, 136, '2015-01-01 01:25:59.000000', 'consum', 0.0309, 'lps'),
	(645036, 136, '2015-01-01 01:26:00.000000', 'consum', 0.0215, 'lps'),
	(645037, 136, '2015-01-01 01:26:01.000000', 'consum', 0.0313, 'lps'),
	(645038, 136, '2015-01-01 01:26:02.000000', 'consum', 0.0211, 'lps'),
	(645039, 136, '2015-01-01 01:26:03.000000', 'consum', 0.0281, 'lps'),
	(645040, 136, '2015-01-01 01:26:04.000000', 'consum', 0.0315, 'lps'),
	(645041, 136, '2015-01-01 01:26:05.000000', 'consum', 0.0274, 'lps'),
	(645042, 136, '2015-01-01 01:26:06.000000', 'consum', 0.0213, 'lps'),
	(645043, 136, '2015-01-01 01:26:07.000000', 'consum', 0.0285, 'lps'),
	(645044, 136, '2015-01-01 01:26:08.000000', 'consum', 0.0327, 'lps'),
	(645045, 136, '2015-01-01 01:26:09.000000', 'consum', 0.0324, 'lps'),
	(645046, 136, '2015-01-01 01:26:10.000000', 'consum', 0.0304, 'lps'),
	(645047, 136, '2015-01-01 01:26:11.000000', 'consum', 0.0214, 'lps'),
	(645048, 136, '2015-01-01 01:26:12.000000', 'consum', 0.0320, 'lps'),
	(645049, 136, '2015-01-01 01:26:13.000000', 'consum', 0.0254, 'lps'),
	(645050, 136, '2015-01-01 01:26:14.000000', 'consum', 0.0225, 'lps'),
	(645051, 136, '2015-01-01 01:26:15.000000', 'consum', 0.0276, 'lps'),
	(645052, 136, '2015-01-01 01:26:16.000000', 'consum', 0.0250, 'lps'),
	(645053, 136, '2015-01-01 01:26:17.000000', 'consum', 0.0333, 'lps'),
	(645054, 136, '2015-01-01 01:26:18.000000', 'consum', 0.0212, 'lps'),
	(645055, 136, '2015-01-01 01:26:19.000000', 'consum', 0.0224, 'lps'),
	(645056, 136, '2015-01-01 01:26:20.000000', 'consum', 0.0276, 'lps'),
	(645057, 136, '2015-01-01 01:26:21.000000', 'consum', 0.0247, 'lps'),
	(645058, 136, '2015-01-01 01:26:22.000000', 'consum', 0.0323, 'lps'),
	(645059, 136, '2015-01-01 01:26:23.000000', 'consum', 0.0294, 'lps'),
	(645060, 136, '2015-01-01 01:26:24.000000', 'consum', 0.0289, 'lps'),
	(645061, 136, '2015-01-01 01:26:25.000000', 'consum', 0.0230, 'lps'),
	(645062, 136, '2015-01-01 01:26:26.000000', 'consum', 0.0320, 'lps'),
	(645063, 136, '2015-01-01 01:26:27.000000', 'consum', 0.0332, 'lps'),
	(645064, 136, '2015-01-01 01:26:28.000000', 'consum', 0.0240, 'lps'),
	(645065, 136, '2015-01-01 01:26:29.000000', 'consum', 0.0241, 'lps'),
	(645066, 136, '2015-01-01 01:26:30.000000', 'consum', 0.0278, 'lps'),
	(645067, 136, '2015-01-01 01:26:31.000000', 'consum', 0.0333, 'lps'),
	(645068, 136, '2015-01-01 01:26:32.000000', 'consum', 0.0251, 'lps'),
	(645069, 136, '2015-01-01 01:26:33.000000', 'consum', 0.0291, 'lps'),
	(645070, 136, '2015-01-01 01:26:34.000000', 'consum', 0.0247, 'lps'),
	(645071, 136, '2015-01-01 01:26:35.000000', 'consum', 0.0277, 'lps'),
	(645072, 136, '2015-01-01 01:26:36.000000', 'consum', 0.0309, 'lps'),
	(645073, 136, '2015-01-01 01:26:37.000000', 'consum', 0.0255, 'lps'),
	(645074, 136, '2015-01-01 01:26:38.000000', 'consum', 0.0265, 'lps'),
	(645075, 136, '2015-01-01 01:26:39.000000', 'consum', 0.0226, 'lps'),
	(645076, 136, '2015-01-01 01:26:40.000000', 'consum', 0.0250, 'lps'),
	(645077, 136, '2015-01-01 01:26:41.000000', 'consum', 0.0239, 'lps'),
	(645078, 136, '2015-01-01 01:26:42.000000', 'consum', 0.0234, 'lps'),
	(645079, 136, '2015-01-01 01:26:43.000000', 'consum', 0.0243, 'lps'),
	(645080, 136, '2015-01-01 01:26:44.000000', 'consum', 0.0304, 'lps'),
	(645081, 136, '2015-01-01 01:26:45.000000', 'consum', 0.0211, 'lps'),
	(645082, 136, '2015-01-01 01:26:46.000000', 'consum', 0.0303, 'lps'),
	(645083, 136, '2015-01-01 01:26:47.000000', 'consum', 0.0303, 'lps'),
	(645084, 136, '2015-01-01 01:26:48.000000', 'consum', 0.0271, 'lps'),
	(645085, 136, '2015-01-01 01:26:49.000000', 'consum', 0.0235, 'lps'),
	(645086, 136, '2015-01-01 01:26:50.000000', 'consum', 0.0278, 'lps'),
	(645087, 136, '2015-01-01 01:26:51.000000', 'consum', 0.0227, 'lps'),
	(645088, 136, '2015-01-01 01:26:52.000000', 'consum', 0.0215, 'lps'),
	(645089, 136, '2015-01-01 01:26:53.000000', 'consum', 0.0309, 'lps'),
	(645090, 136, '2015-01-01 01:26:54.000000', 'consum', 0.0318, 'lps'),
	(645091, 136, '2015-01-01 01:26:55.000000', 'consum', 0.0331, 'lps'),
	(645092, 136, '2015-01-01 01:26:56.000000', 'consum', 0.0244, 'lps'),
	(645093, 136, '2015-01-01 01:26:57.000000', 'consum', 0.0265, 'lps'),
	(645094, 136, '2015-01-01 01:26:58.000000', 'consum', 0.0260, 'lps'),
	(645095, 136, '2015-01-01 01:26:59.000000', 'consum', 0.0296, 'lps'),
	(645096, 136, '2015-01-01 01:27:00.000000', 'consum', 0.0243, 'lps'),
	(645097, 136, '2015-01-01 01:27:01.000000', 'consum', 0.0239, 'lps'),
	(645098, 136, '2015-01-01 01:27:02.000000', 'consum', 0.0258, 'lps'),
	(645099, 136, '2015-01-01 01:27:03.000000', 'consum', 0.0238, 'lps'),
	(645100, 136, '2015-01-01 01:27:04.000000', 'consum', 0.0330, 'lps'),
	(645101, 136, '2015-01-01 01:27:05.000000', 'consum', 0.0233, 'lps'),
	(645102, 136, '2015-01-01 01:27:06.000000', 'consum', 0.0214, 'lps'),
	(645103, 136, '2015-01-01 01:27:07.000000', 'consum', 0.0286, 'lps'),
	(645104, 136, '2015-01-01 01:27:08.000000', 'consum', 0.0328, 'lps'),
	(645105, 136, '2015-01-01 01:27:09.000000', 'consum', 0.0325, 'lps'),
	(645106, 136, '2015-01-01 01:27:10.000000', 'consum', 0.0308, 'lps'),
	(645107, 136, '2015-01-01 01:27:11.000000', 'consum', 0.0233, 'lps'),
	(645108, 136, '2015-01-01 01:27:12.000000', 'consum', 0.0280, 'lps'),
	(645109, 136, '2015-01-01 01:27:13.000000', 'consum', 0.0243, 'lps'),
	(645110, 136, '2015-01-01 01:27:14.000000', 'consum', 0.0290, 'lps'),
	(645111, 136, '2015-01-01 01:27:15.000000', 'consum', 0.0261, 'lps'),
	(645112, 136, '2015-01-01 01:27:16.000000', 'consum', 0.0229, 'lps'),
	(645113, 136, '2015-01-01 01:27:17.000000', 'consum', 0.0273, 'lps'),
	(645114, 136, '2015-01-01 01:27:18.000000', 'consum', 0.0222, 'lps'),
	(645115, 136, '2015-01-01 01:27:19.000000', 'consum', 0.0329, 'lps'),
	(645116, 136, '2015-01-01 01:27:20.000000', 'consum', 0.0273, 'lps'),
	(645117, 136, '2015-01-01 01:27:21.000000', 'consum', 0.0295, 'lps'),
	(645118, 136, '2015-01-01 01:27:22.000000', 'consum', 0.0321, 'lps'),
	(645119, 136, '2015-01-01 01:27:23.000000', 'consum', 0.0263, 'lps'),
	(645120, 136, '2015-01-01 01:27:24.000000', 'consum', 0.0267, 'lps'),
	(645121, 136, '2015-01-01 01:27:25.000000', 'consum', 0.0213, 'lps'),
	(645122, 136, '2015-01-01 01:27:26.000000', 'consum', 0.0301, 'lps'),
	(645123, 136, '2015-01-01 01:27:27.000000', 'consum', 0.0287, 'lps'),
	(645124, 136, '2015-01-01 01:27:28.000000', 'consum', 0.0321, 'lps'),
	(645125, 136, '2015-01-01 01:27:29.000000', 'consum', 0.0285, 'lps'),
	(645126, 136, '2015-01-01 01:27:30.000000', 'consum', 0.0254, 'lps'),
	(645127, 136, '2015-01-01 01:27:31.000000', 'consum', 0.0328, 'lps'),
	(645128, 136, '2015-01-01 01:27:32.000000', 'consum', 0.0299, 'lps'),
	(645129, 136, '2015-01-01 01:27:33.000000', 'consum', 0.0302, 'lps'),
	(645130, 136, '2015-01-01 01:27:34.000000', 'consum', 0.0279, 'lps'),
	(645131, 136, '2015-01-01 01:27:35.000000', 'consum', 0.0280, 'lps'),
	(645132, 136, '2015-01-01 01:27:36.000000', 'consum', 0.0227, 'lps'),
	(645133, 136, '2015-01-01 01:27:37.000000', 'consum', 0.0212, 'lps'),
	(645134, 136, '2015-01-01 01:27:38.000000', 'consum', 0.0291, 'lps'),
	(645135, 136, '2015-01-01 01:27:39.000000', 'consum', 0.0239, 'lps'),
	(645136, 136, '2015-01-01 01:27:40.000000', 'consum', 0.0236, 'lps'),
	(645137, 136, '2015-01-01 01:27:41.000000', 'consum', 0.0253, 'lps'),
	(645138, 136, '2015-01-01 01:27:42.000000', 'consum', 0.0223, 'lps'),
	(645139, 136, '2015-01-01 01:27:43.000000', 'consum', 0.0270, 'lps'),
	(645140, 136, '2015-01-01 01:27:44.000000', 'consum', 0.0222, 'lps'),
	(645141, 136, '2015-01-01 01:27:45.000000', 'consum', 0.0217, 'lps'),
	(645142, 136, '2015-01-01 01:27:46.000000', 'consum', 0.0210, 'lps'),
	(645143, 136, '2015-01-01 01:27:47.000000', 'consum', 0.0311, 'lps'),
	(645144, 136, '2015-01-01 01:27:48.000000', 'consum', 0.0221, 'lps'),
	(645145, 132, '2015-01-15 00:00:00.000000', 'consum', 0.0217, 'lps'),
	(645146, 132, '2015-01-15 00:00:01.000000', 'consum', 0.0213, 'lps'),
	(645147, 132, '2015-01-15 00:00:02.000000', 'consum', 0.0216, 'lps'),
	(645148, 132, '2015-01-15 00:00:03.000000', 'consum', 0.0211, 'lps'),
	(645149, 132, '2015-01-15 00:00:04.000000', 'consum', 0.0216, 'lps'),
	(645150, 132, '2015-01-15 00:00:05.000000', 'consum', 0.0218, 'lps'),
	(645151, 132, '2015-01-15 00:00:06.000000', 'consum', 0.0219, 'lps'),
	(645152, 132, '2015-01-15 00:00:07.000000', 'consum', 0.0212, 'lps'),
	(645153, 132, '2015-01-15 00:00:08.000000', 'consum', 0.0213, 'lps'),
	(645154, 132, '2015-01-15 00:00:09.000000', 'consum', 0.0219, 'lps'),
	(645155, 132, '2015-01-15 00:00:10.000000', 'consum', 0.0216, 'lps'),
	(645156, 132, '2015-01-15 00:00:11.000000', 'consum', 0.0214, 'lps'),
	(645157, 132, '2015-01-15 00:00:12.000000', 'consum', 0.0212, 'lps'),
	(645158, 132, '2015-01-15 00:00:13.000000', 'consum', 0.0210, 'lps'),
	(645159, 132, '2015-01-15 00:00:14.000000', 'consum', 0.0213, 'lps'),
	(645160, 132, '2015-01-15 00:00:15.000000', 'consum', 0.0216, 'lps'),
	(645161, 132, '2015-01-15 00:00:16.000000', 'consum', 0.0211, 'lps'),
	(645162, 132, '2015-01-15 00:00:17.000000', 'consum', 0.0217, 'lps'),
	(645163, 132, '2015-01-15 00:00:18.000000', 'consum', 0.0220, 'lps'),
	(645164, 132, '2015-01-15 00:00:19.000000', 'consum', 0.0220, 'lps'),
	(645165, 132, '2015-01-15 00:00:20.000000', 'consum', 0.0217, 'lps'),
	(645166, 132, '2015-01-15 00:00:21.000000', 'consum', 0.0218, 'lps'),
	(645167, 132, '2015-01-15 00:00:22.000000', 'consum', 0.0218, 'lps'),
	(645168, 132, '2015-01-15 00:00:23.000000', 'consum', 0.0215, 'lps'),
	(645169, 132, '2015-01-15 00:00:24.000000', 'consum', 0.0211, 'lps'),
	(645170, 132, '2015-01-15 00:00:25.000000', 'consum', 0.0214, 'lps'),
	(645171, 132, '2015-01-15 00:00:26.000000', 'consum', 0.0213, 'lps'),
	(645172, 132, '2015-01-15 00:00:27.000000', 'consum', 0.0216, 'lps'),
	(645173, 132, '2015-01-15 00:00:28.000000', 'consum', 0.0220, 'lps'),
	(645174, 132, '2015-01-15 00:00:29.000000', 'consum', 0.0220, 'lps'),
	(645175, 132, '2015-01-15 00:00:30.000000', 'consum', 0.0218, 'lps'),
	(645176, 132, '2015-01-15 00:00:31.000000', 'consum', 0.0210, 'lps'),
	(645177, 132, '2015-01-15 00:00:32.000000', 'consum', 0.0220, 'lps'),
	(645178, 132, '2015-01-15 00:00:33.000000', 'consum', 0.0216, 'lps'),
	(645179, 132, '2015-01-15 00:00:34.000000', 'consum', 0.0212, 'lps'),
	(645180, 132, '2015-01-15 00:00:35.000000', 'consum', 0.0215, 'lps'),
	(645181, 132, '2015-01-15 00:00:36.000000', 'consum', 0.0215, 'lps'),
	(645182, 132, '2015-01-15 00:00:37.000000', 'consum', 0.0210, 'lps'),
	(645183, 132, '2015-01-15 00:00:38.000000', 'consum', 0.0220, 'lps'),
	(645184, 132, '2015-01-15 00:00:39.000000', 'consum', 0.0213, 'lps'),
	(645185, 132, '2015-01-15 00:00:40.000000', 'consum', 0.0220, 'lps'),
	(645186, 132, '2015-01-15 00:00:41.000000', 'consum', 0.0216, 'lps'),
	(645187, 132, '2015-01-15 00:00:42.000000', 'consum', 0.0211, 'lps'),
	(645188, 132, '2015-01-15 00:00:43.000000', 'consum', 0.0210, 'lps'),
	(645189, 132, '2015-01-15 00:00:44.000000', 'consum', 0.0218, 'lps'),
	(645190, 132, '2015-01-15 00:00:45.000000', 'consum', 0.0219, 'lps'),
	(645191, 132, '2015-01-15 00:00:46.000000', 'consum', 0.0220, 'lps'),
	(645192, 132, '2015-01-15 00:00:47.000000', 'consum', 0.0210, 'lps'),
	(645193, 132, '2015-01-15 00:00:48.000000', 'consum', 0.0213, 'lps'),
	(645194, 132, '2015-01-15 00:00:49.000000', 'consum', 0.0215, 'lps'),
	(645195, 132, '2015-01-15 00:00:50.000000', 'consum', 0.0217, 'lps'),
	(645196, 132, '2015-01-15 00:00:51.000000', 'consum', 0.0217, 'lps'),
	(645197, 132, '2015-01-15 00:00:52.000000', 'consum', 0.0215, 'lps'),
	(645198, 132, '2015-01-15 00:00:53.000000', 'consum', 0.0215, 'lps'),
	(645199, 132, '2015-01-15 00:00:54.000000', 'consum', 0.0218, 'lps'),
	(645200, 132, '2015-01-15 00:00:55.000000', 'consum', 0.0216, 'lps'),
	(645201, 132, '2015-01-15 00:00:56.000000', 'consum', 0.0214, 'lps'),
	(645202, 132, '2015-01-15 00:00:57.000000', 'consum', 0.0212, 'lps'),
	(645203, 132, '2015-01-15 00:00:58.000000', 'consum', 0.0211, 'lps'),
	(645204, 132, '2015-01-15 00:00:59.000000', 'consum', 0.0220, 'lps'),
	(645205, 132, '2015-01-15 00:01:00.000000', 'consum', 0.0214, 'lps'),
	(645206, 132, '2015-01-15 00:01:01.000000', 'consum', 0.0212, 'lps'),
	(645207, 132, '2015-01-15 00:01:02.000000', 'consum', 0.0218, 'lps'),
	(645208, 132, '2015-01-15 00:01:03.000000', 'consum', 0.0210, 'lps'),
	(645209, 132, '2015-01-15 00:01:04.000000', 'consum', 0.0211, 'lps'),
	(645210, 132, '2015-01-15 00:01:05.000000', 'consum', 0.0216, 'lps'),
	(645211, 132, '2015-01-15 00:01:06.000000', 'consum', 0.0215, 'lps'),
	(645212, 132, '2015-01-15 00:01:07.000000', 'consum', 0.0217, 'lps'),
	(645213, 132, '2015-01-15 00:01:08.000000', 'consum', 0.0218, 'lps'),
	(645214, 132, '2015-01-15 00:01:09.000000', 'consum', 0.0219, 'lps'),
	(645215, 132, '2015-01-15 00:01:10.000000', 'consum', 0.0212, 'lps'),
	(645216, 132, '2015-01-15 00:01:11.000000', 'consum', 0.0214, 'lps'),
	(645217, 132, '2015-01-15 00:01:12.000000', 'consum', 0.0212, 'lps'),
	(645218, 132, '2015-01-15 00:01:13.000000', 'consum', 0.0220, 'lps'),
	(645219, 132, '2015-01-15 00:01:14.000000', 'consum', 0.0210, 'lps'),
	(645220, 132, '2015-01-15 00:01:15.000000', 'consum', 0.0214, 'lps'),
	(645221, 132, '2015-01-15 00:01:16.000000', 'consum', 0.0218, 'lps'),
	(645222, 132, '2015-01-15 00:01:17.000000', 'consum', 0.0219, 'lps'),
	(645223, 132, '2015-01-15 00:01:18.000000', 'consum', 0.0210, 'lps'),
	(645224, 132, '2015-01-15 00:01:19.000000', 'consum', 0.0216, 'lps'),
	(645225, 132, '2015-01-15 00:01:20.000000', 'consum', 0.0218, 'lps'),
	(645226, 132, '2015-01-15 00:01:21.000000', 'consum', 0.0212, 'lps'),
	(645227, 132, '2015-01-15 00:01:22.000000', 'consum', 0.0218, 'lps'),
	(645228, 132, '2015-01-15 00:01:23.000000', 'consum', 0.0210, 'lps'),
	(645229, 132, '2015-01-15 00:01:24.000000', 'consum', 0.0220, 'lps'),
	(645230, 132, '2015-01-15 00:01:25.000000', 'consum', 0.0219, 'lps'),
	(645231, 132, '2015-01-15 00:01:26.000000', 'consum', 0.0212, 'lps'),
	(645232, 132, '2015-01-15 00:01:27.000000', 'consum', 0.0215, 'lps'),
	(645233, 132, '2015-01-15 00:01:28.000000', 'consum', 0.0217, 'lps'),
	(645234, 132, '2015-01-15 00:01:29.000000', 'consum', 0.0211, 'lps'),
	(645235, 132, '2015-01-15 00:01:30.000000', 'consum', 0.0216, 'lps'),
	(645236, 132, '2015-01-15 00:01:31.000000', 'consum', 0.0215, 'lps'),
	(645237, 132, '2015-01-15 00:01:32.000000', 'consum', 0.0219, 'lps'),
	(645238, 132, '2015-01-15 00:01:33.000000', 'consum', 0.0217, 'lps'),
	(645239, 132, '2015-01-15 00:01:34.000000', 'consum', 0.0218, 'lps'),
	(645240, 132, '2015-01-15 00:01:35.000000', 'consum', 0.0220, 'lps'),
	(645241, 132, '2015-01-15 00:01:36.000000', 'consum', 0.0213, 'lps'),
	(645242, 132, '2015-01-15 00:01:37.000000', 'consum', 0.0218, 'lps'),
	(645243, 132, '2015-01-15 00:01:38.000000', 'consum', 0.0219, 'lps'),
	(645244, 132, '2015-01-15 00:01:39.000000', 'consum', 0.0219, 'lps'),
	(645245, 132, '2015-01-15 00:01:40.000000', 'consum', 0.0218, 'lps'),
	(645246, 132, '2015-01-15 00:01:41.000000', 'consum', 0.0215, 'lps'),
	(645247, 132, '2015-01-15 00:01:42.000000', 'consum', 0.0210, 'lps'),
	(645248, 132, '2015-01-15 00:01:43.000000', 'consum', 0.0218, 'lps'),
	(645249, 132, '2015-01-15 00:01:44.000000', 'consum', 0.0216, 'lps'),
	(645250, 132, '2015-01-15 00:01:45.000000', 'consum', 0.0218, 'lps'),
	(645251, 132, '2015-01-15 00:01:46.000000', 'consum', 0.0211, 'lps'),
	(645252, 132, '2015-01-15 00:01:47.000000', 'consum', 0.0213, 'lps'),
	(645253, 132, '2015-01-15 00:01:48.000000', 'consum', 0.0211, 'lps'),
	(645254, 132, '2015-01-15 00:01:49.000000', 'consum', 0.0217, 'lps'),
	(645255, 132, '2015-01-15 00:01:50.000000', 'consum', 0.0210, 'lps'),
	(645256, 132, '2015-01-15 00:01:51.000000', 'consum', 0.0213, 'lps'),
	(645257, 132, '2015-01-15 00:01:52.000000', 'consum', 0.0214, 'lps'),
	(645258, 132, '2015-01-15 00:01:53.000000', 'consum', 0.0211, 'lps'),
	(645259, 132, '2015-01-15 00:01:54.000000', 'consum', 0.0213, 'lps'),
	(645260, 132, '2015-01-15 00:01:55.000000', 'consum', 0.0213, 'lps'),
	(645261, 132, '2015-01-15 00:01:56.000000', 'consum', 0.0215, 'lps'),
	(645262, 132, '2015-01-15 00:01:57.000000', 'consum', 0.0218, 'lps'),
	(645263, 132, '2015-01-15 00:01:58.000000', 'consum', 0.0210, 'lps'),
	(645264, 132, '2015-01-15 00:01:59.000000', 'consum', 0.0212, 'lps'),
	(645265, 132, '2015-01-15 00:02:00.000000', 'consum', 0.0220, 'lps'),
	(645266, 132, '2015-01-15 00:02:01.000000', 'consum', 0.0220, 'lps'),
	(645267, 132, '2015-01-15 00:02:02.000000', 'consum', 0.0210, 'lps'),
	(645268, 132, '2015-01-15 00:02:03.000000', 'consum', 0.0214, 'lps'),
	(645269, 132, '2015-01-15 00:02:04.000000', 'consum', 0.0220, 'lps'),
	(645270, 132, '2015-01-15 00:02:05.000000', 'consum', 0.0214, 'lps'),
	(645271, 132, '2015-01-15 00:02:06.000000', 'consum', 0.0211, 'lps'),
	(645272, 132, '2015-01-15 00:02:07.000000', 'consum', 0.0214, 'lps'),
	(645273, 132, '2015-01-15 00:02:08.000000', 'consum', 0.0218, 'lps'),
	(645274, 132, '2015-01-15 00:02:09.000000', 'consum', 0.0216, 'lps'),
	(645275, 132, '2015-01-15 00:02:10.000000', 'consum', 0.0218, 'lps'),
	(645276, 132, '2015-01-15 00:02:11.000000', 'consum', 0.0211, 'lps'),
	(645277, 132, '2015-01-15 00:02:12.000000', 'consum', 0.0212, 'lps'),
	(645278, 132, '2015-01-15 00:02:13.000000', 'consum', 0.0216, 'lps'),
	(645279, 132, '2015-01-15 00:02:14.000000', 'consum', 0.0215, 'lps'),
	(645280, 132, '2015-01-15 00:02:15.000000', 'consum', 0.0215, 'lps'),
	(645281, 132, '2015-01-15 00:02:16.000000', 'consum', 0.0211, 'lps'),
	(645282, 132, '2015-01-15 00:02:17.000000', 'consum', 0.0211, 'lps'),
	(645283, 132, '2015-01-15 00:02:18.000000', 'consum', 0.0212, 'lps'),
	(645284, 132, '2015-01-15 00:02:19.000000', 'consum', 0.0219, 'lps'),
	(645285, 132, '2015-01-15 00:02:20.000000', 'consum', 0.0216, 'lps'),
	(645286, 132, '2015-01-15 00:02:21.000000', 'consum', 0.0215, 'lps'),
	(645287, 132, '2015-01-15 00:02:22.000000', 'consum', 0.0218, 'lps'),
	(645288, 132, '2015-01-15 00:02:23.000000', 'consum', 0.0212, 'lps'),
	(645289, 132, '2015-01-15 00:02:24.000000', 'consum', 0.0217, 'lps'),
	(645290, 132, '2015-01-15 00:02:25.000000', 'consum', 0.0220, 'lps'),
	(645291, 132, '2015-01-15 00:02:26.000000', 'consum', 0.0215, 'lps'),
	(645292, 132, '2015-01-15 00:02:27.000000', 'consum', 0.0218, 'lps'),
	(645293, 132, '2015-01-15 00:02:28.000000', 'consum', 0.0213, 'lps'),
	(645294, 132, '2015-01-15 00:02:29.000000', 'consum', 0.0212, 'lps'),
	(645295, 132, '2015-01-15 00:02:30.000000', 'consum', 0.0210, 'lps'),
	(645296, 132, '2015-01-15 00:02:31.000000', 'consum', 0.0217, 'lps'),
	(645297, 132, '2015-01-15 00:02:32.000000', 'consum', 0.0211, 'lps'),
	(645298, 132, '2015-01-15 00:02:33.000000', 'consum', 0.0216, 'lps'),
	(645299, 132, '2015-01-15 00:02:34.000000', 'consum', 0.0216, 'lps'),
	(645300, 132, '2015-01-15 00:02:35.000000', 'consum', 0.0211, 'lps'),
	(645301, 132, '2015-01-15 00:02:36.000000', 'consum', 0.0210, 'lps'),
	(645302, 132, '2015-01-15 00:02:37.000000', 'consum', 0.0219, 'lps'),
	(645303, 132, '2015-01-15 00:02:38.000000', 'consum', 0.0210, 'lps'),
	(645304, 132, '2015-01-15 00:02:39.000000', 'consum', 0.0215, 'lps'),
	(645305, 132, '2015-01-15 00:02:40.000000', 'consum', 0.0215, 'lps'),
	(645306, 132, '2015-01-15 00:02:41.000000', 'consum', 0.0220, 'lps'),
	(645307, 132, '2015-01-15 00:02:42.000000', 'consum', 0.0211, 'lps'),
	(645308, 132, '2015-01-15 00:02:43.000000', 'consum', 0.0220, 'lps'),
	(645309, 132, '2015-01-15 00:02:44.000000', 'consum', 0.0212, 'lps'),
	(645310, 132, '2015-01-15 00:02:45.000000', 'consum', 0.0215, 'lps'),
	(645311, 132, '2015-01-15 00:02:46.000000', 'consum', 0.0216, 'lps'),
	(645312, 132, '2015-01-15 00:02:47.000000', 'consum', 0.0216, 'lps'),
	(645313, 132, '2015-01-15 00:02:48.000000', 'consum', 0.0210, 'lps'),
	(645314, 132, '2015-01-15 00:02:49.000000', 'consum', 0.0217, 'lps'),
	(645315, 132, '2015-01-15 00:02:50.000000', 'consum', 0.0211, 'lps'),
	(645316, 132, '2015-01-15 00:02:51.000000', 'consum', 0.0216, 'lps'),
	(645317, 132, '2015-01-15 00:02:52.000000', 'consum', 0.0215, 'lps'),
	(645318, 132, '2015-01-15 00:02:53.000000', 'consum', 0.0217, 'lps'),
	(645319, 132, '2015-01-15 00:02:54.000000', 'consum', 0.0210, 'lps'),
	(645320, 132, '2015-01-15 00:02:55.000000', 'consum', 0.0212, 'lps'),
	(645321, 132, '2015-01-15 00:02:56.000000', 'consum', 0.0220, 'lps'),
	(645322, 132, '2015-01-15 00:02:57.000000', 'consum', 0.0212, 'lps'),
	(645323, 132, '2015-01-15 00:02:58.000000', 'consum', 0.0212, 'lps'),
	(645324, 132, '2015-01-15 00:02:59.000000', 'consum', 0.0213, 'lps'),
	(645325, 132, '2015-01-15 00:03:00.000000', 'consum', 0.0210, 'lps'),
	(645326, 132, '2015-01-15 00:03:01.000000', 'consum', 0.0210, 'lps'),
	(645327, 132, '2015-01-15 00:03:02.000000', 'consum', 0.0212, 'lps'),
	(645328, 132, '2015-01-15 00:03:03.000000', 'consum', 0.0211, 'lps'),
	(645329, 132, '2015-01-15 00:03:04.000000', 'consum', 0.0219, 'lps'),
	(645330, 132, '2015-01-15 00:03:05.000000', 'consum', 0.0218, 'lps'),
	(645331, 132, '2015-01-15 00:03:06.000000', 'consum', 0.0215, 'lps'),
	(645332, 132, '2015-01-15 00:03:07.000000', 'consum', 0.0210, 'lps'),
	(645333, 132, '2015-01-15 00:03:08.000000', 'consum', 0.0217, 'lps'),
	(645334, 132, '2015-01-15 00:03:09.000000', 'consum', 0.0214, 'lps'),
	(645335, 132, '2015-01-15 00:03:10.000000', 'consum', 0.0219, 'lps'),
	(645336, 132, '2015-01-15 00:03:11.000000', 'consum', 0.0213, 'lps'),
	(645337, 132, '2015-01-15 00:03:12.000000', 'consum', 0.0220, 'lps'),
	(645338, 132, '2015-01-15 00:03:13.000000', 'consum', 0.0218, 'lps'),
	(645339, 132, '2015-01-15 00:03:14.000000', 'consum', 0.0219, 'lps'),
	(645340, 132, '2015-01-15 00:03:15.000000', 'consum', 0.0220, 'lps'),
	(645341, 132, '2015-01-15 00:03:16.000000', 'consum', 0.0213, 'lps'),
	(645342, 132, '2015-01-15 00:03:17.000000', 'consum', 0.0215, 'lps'),
	(645343, 132, '2015-01-15 00:03:18.000000', 'consum', 0.0219, 'lps'),
	(645344, 132, '2015-01-15 00:03:19.000000', 'consum', 0.0217, 'lps'),
	(645345, 132, '2015-01-15 00:03:20.000000', 'consum', 0.0220, 'lps'),
	(645346, 132, '2015-01-15 00:03:21.000000', 'consum', 0.0218, 'lps'),
	(645347, 132, '2015-01-15 00:03:22.000000', 'consum', 0.0220, 'lps'),
	(645348, 132, '2015-01-15 00:03:23.000000', 'consum', 0.0214, 'lps'),
	(645349, 132, '2015-01-15 00:03:24.000000', 'consum', 0.0211, 'lps'),
	(645350, 132, '2015-01-15 00:03:25.000000', 'consum', 0.0216, 'lps'),
	(645351, 132, '2015-01-15 00:03:26.000000', 'consum', 0.0215, 'lps'),
	(645352, 132, '2015-01-15 00:03:27.000000', 'consum', 0.0219, 'lps'),
	(645353, 132, '2015-01-15 00:03:28.000000', 'consum', 0.0219, 'lps'),
	(645354, 132, '2015-01-15 00:03:29.000000', 'consum', 0.0216, 'lps'),
	(645355, 132, '2015-01-15 00:03:30.000000', 'consum', 0.0212, 'lps'),
	(645356, 132, '2015-01-15 00:03:31.000000', 'consum', 0.0214, 'lps'),
	(645357, 132, '2015-01-15 00:03:32.000000', 'consum', 0.0216, 'lps'),
	(645358, 132, '2015-01-15 00:03:33.000000', 'consum', 0.0214, 'lps'),
	(645359, 132, '2015-01-15 00:03:34.000000', 'consum', 0.0214, 'lps'),
	(645360, 132, '2015-01-15 00:03:35.000000', 'consum', 0.0218, 'lps'),
	(645361, 132, '2015-01-15 00:03:36.000000', 'consum', 0.0217, 'lps'),
	(645362, 132, '2015-01-15 00:03:37.000000', 'consum', 0.0210, 'lps'),
	(645363, 132, '2015-01-15 00:03:38.000000', 'consum', 0.0210, 'lps'),
	(645364, 132, '2015-01-15 00:03:39.000000', 'consum', 0.0212, 'lps'),
	(645365, 132, '2015-01-15 00:03:40.000000', 'consum', 0.0210, 'lps'),
	(645366, 132, '2015-01-15 00:03:41.000000', 'consum', 0.0215, 'lps'),
	(645367, 132, '2015-01-15 00:03:42.000000', 'consum', 0.0215, 'lps'),
	(645368, 132, '2015-01-15 00:03:43.000000', 'consum', 0.0220, 'lps'),
	(645369, 132, '2015-01-15 00:03:44.000000', 'consum', 0.0211, 'lps'),
	(645370, 132, '2015-01-15 00:03:45.000000', 'consum', 0.0210, 'lps'),
	(645371, 132, '2015-01-15 00:03:46.000000', 'consum', 0.0217, 'lps'),
	(645372, 132, '2015-01-15 00:03:47.000000', 'consum', 0.0211, 'lps'),
	(645373, 132, '2015-01-15 00:03:48.000000', 'consum', 0.0219, 'lps'),
	(645374, 132, '2015-01-15 00:03:49.000000', 'consum', 0.0218, 'lps'),
	(645375, 132, '2015-01-15 00:03:50.000000', 'consum', 0.0215, 'lps'),
	(645376, 132, '2015-01-15 00:03:51.000000', 'consum', 0.0220, 'lps'),
	(645377, 132, '2015-01-15 00:03:52.000000', 'consum', 0.0214, 'lps'),
	(645378, 132, '2015-01-15 00:03:53.000000', 'consum', 0.0211, 'lps'),
	(645379, 132, '2015-01-15 00:03:54.000000', 'consum', 0.0215, 'lps'),
	(645380, 132, '2015-01-15 00:03:55.000000', 'consum', 0.0212, 'lps'),
	(645381, 132, '2015-01-15 00:03:56.000000', 'consum', 0.0216, 'lps'),
	(645382, 132, '2015-01-15 00:03:57.000000', 'consum', 0.0212, 'lps'),
	(645383, 132, '2015-01-15 00:03:58.000000', 'consum', 0.0212, 'lps'),
	(645384, 132, '2015-01-15 00:03:59.000000', 'consum', 0.0215, 'lps'),
	(645385, 132, '2015-01-15 00:04:00.000000', 'consum', 0.0210, 'lps'),
	(645386, 132, '2015-01-15 00:04:01.000000', 'consum', 0.0214, 'lps'),
	(645387, 132, '2015-01-15 00:04:02.000000', 'consum', 0.0211, 'lps'),
	(645388, 132, '2015-01-15 00:04:03.000000', 'consum', 0.0213, 'lps'),
	(645389, 132, '2015-01-15 00:04:04.000000', 'consum', 0.0214, 'lps'),
	(645390, 132, '2015-01-15 00:04:05.000000', 'consum', 0.0220, 'lps'),
	(645391, 132, '2015-01-15 00:04:06.000000', 'consum', 0.0217, 'lps'),
	(645392, 132, '2015-01-15 00:04:07.000000', 'consum', 0.0215, 'lps'),
	(645393, 132, '2015-01-15 00:04:08.000000', 'consum', 0.0214, 'lps'),
	(645394, 132, '2015-01-15 00:04:09.000000', 'consum', 0.0217, 'lps'),
	(645395, 132, '2015-01-15 00:04:10.000000', 'consum', 0.0212, 'lps'),
	(645396, 132, '2015-01-15 00:04:11.000000', 'consum', 0.0220, 'lps'),
	(645397, 132, '2015-01-15 00:04:12.000000', 'consum', 0.0211, 'lps'),
	(645398, 132, '2015-01-15 00:04:13.000000', 'consum', 0.0220, 'lps'),
	(645399, 132, '2015-01-15 00:04:14.000000', 'consum', 0.0211, 'lps'),
	(645400, 132, '2015-01-15 00:04:15.000000', 'consum', 0.0211, 'lps'),
	(645401, 132, '2015-01-15 00:04:16.000000', 'consum', 0.0220, 'lps'),
	(645402, 132, '2015-01-15 00:04:17.000000', 'consum', 0.0213, 'lps'),
	(645403, 132, '2015-01-15 00:04:18.000000', 'consum', 0.0220, 'lps'),
	(645404, 132, '2015-01-15 00:04:19.000000', 'consum', 0.0218, 'lps'),
	(645405, 132, '2015-01-15 00:04:20.000000', 'consum', 0.0211, 'lps'),
	(645406, 132, '2015-01-15 00:04:21.000000', 'consum', 0.0213, 'lps'),
	(645407, 132, '2015-01-15 00:04:22.000000', 'consum', 0.0211, 'lps'),
	(645408, 132, '2015-01-15 00:04:23.000000', 'consum', 0.0218, 'lps'),
	(645409, 132, '2015-01-15 00:04:24.000000', 'consum', 0.0214, 'lps'),
	(645410, 132, '2015-01-15 00:04:25.000000', 'consum', 0.0216, 'lps'),
	(645411, 132, '2015-01-15 00:04:26.000000', 'consum', 0.0217, 'lps'),
	(645412, 132, '2015-01-15 00:04:27.000000', 'consum', 0.0217, 'lps'),
	(645413, 132, '2015-01-15 00:04:28.000000', 'consum', 0.0215, 'lps'),
	(645414, 132, '2015-01-15 00:04:29.000000', 'consum', 0.0215, 'lps'),
	(645415, 132, '2015-01-15 00:04:30.000000', 'consum', 0.0210, 'lps'),
	(645416, 132, '2015-01-15 00:04:31.000000', 'consum', 0.0217, 'lps'),
	(645417, 132, '2015-01-15 00:04:32.000000', 'consum', 0.0211, 'lps'),
	(645418, 132, '2015-01-15 00:04:33.000000', 'consum', 0.0219, 'lps'),
	(645419, 132, '2015-01-15 00:04:34.000000', 'consum', 0.0218, 'lps'),
	(645420, 132, '2015-01-15 00:04:35.000000', 'consum', 0.0213, 'lps'),
	(645421, 132, '2015-01-15 00:04:36.000000', 'consum', 0.0214, 'lps'),
	(645422, 132, '2015-01-15 00:04:37.000000', 'consum', 0.0211, 'lps'),
	(645423, 132, '2015-01-15 00:04:38.000000', 'consum', 0.0214, 'lps'),
	(645424, 132, '2015-01-15 00:04:39.000000', 'consum', 0.0215, 'lps'),
	(645425, 132, '2015-01-15 00:04:40.000000', 'consum', 0.0212, 'lps'),
	(645426, 132, '2015-01-15 00:04:41.000000', 'consum', 0.0217, 'lps'),
	(645427, 132, '2015-01-15 00:04:42.000000', 'consum', 0.0220, 'lps'),
	(645428, 132, '2015-01-15 00:04:43.000000', 'consum', 0.0214, 'lps'),
	(645429, 132, '2015-01-15 00:04:44.000000', 'consum', 0.0213, 'lps'),
	(645430, 132, '2015-01-15 00:04:45.000000', 'consum', 0.0214, 'lps'),
	(645431, 132, '2015-01-15 00:04:46.000000', 'consum', 0.0219, 'lps'),
	(645432, 132, '2015-01-15 00:04:47.000000', 'consum', 0.0213, 'lps'),
	(645433, 132, '2015-01-15 00:04:48.000000', 'consum', 0.0219, 'lps'),
	(645434, 132, '2015-01-15 00:04:49.000000', 'consum', 0.0214, 'lps'),
	(645435, 132, '2015-01-15 00:04:50.000000', 'consum', 0.0213, 'lps'),
	(645436, 132, '2015-01-15 00:04:51.000000', 'consum', 0.0213, 'lps'),
	(645437, 132, '2015-01-15 00:04:52.000000', 'consum', 0.0217, 'lps'),
	(645438, 132, '2015-01-15 00:04:53.000000', 'consum', 0.0215, 'lps'),
	(645439, 132, '2015-01-15 00:04:54.000000', 'consum', 0.0215, 'lps'),
	(645440, 132, '2015-01-15 00:04:55.000000', 'consum', 0.0210, 'lps'),
	(645441, 132, '2015-01-15 00:04:56.000000', 'consum', 0.0218, 'lps'),
	(645442, 132, '2015-01-15 00:04:57.000000', 'consum', 0.0215, 'lps'),
	(645443, 132, '2015-01-15 00:04:58.000000', 'consum', 0.0212, 'lps'),
	(645444, 132, '2015-01-15 00:04:59.000000', 'consum', 0.0217, 'lps'),
	(645445, 132, '2015-01-15 00:05:00.000000', 'consum', 0.0218, 'lps'),
	(645446, 132, '2015-01-15 00:05:01.000000', 'consum', 0.0219, 'lps'),
	(645447, 132, '2015-01-15 00:05:02.000000', 'consum', 0.0219, 'lps'),
	(645448, 132, '2015-01-15 00:05:03.000000', 'consum', 0.0218, 'lps'),
	(645449, 132, '2015-01-15 00:05:04.000000', 'consum', 0.0215, 'lps'),
	(645450, 132, '2015-01-15 00:05:05.000000', 'consum', 0.0219, 'lps'),
	(645451, 132, '2015-01-15 00:05:06.000000', 'consum', 0.0210, 'lps'),
	(645452, 132, '2015-01-15 00:05:07.000000', 'consum', 0.0215, 'lps'),
	(645453, 132, '2015-01-15 00:05:08.000000', 'consum', 0.0213, 'lps'),
	(645454, 132, '2015-01-15 00:05:09.000000', 'consum', 0.0220, 'lps'),
	(645455, 132, '2015-01-15 00:05:10.000000', 'consum', 0.0211, 'lps'),
	(645456, 132, '2015-01-15 00:05:11.000000', 'consum', 0.0215, 'lps'),
	(645457, 132, '2015-01-15 00:05:12.000000', 'consum', 0.0213, 'lps'),
	(645458, 132, '2015-01-15 00:05:13.000000', 'consum', 0.0212, 'lps'),
	(645459, 132, '2015-01-15 00:05:14.000000', 'consum', 0.0219, 'lps'),
	(645460, 132, '2015-01-15 00:05:15.000000', 'consum', 0.0217, 'lps'),
	(645461, 132, '2015-01-15 00:05:16.000000', 'consum', 0.0210, 'lps'),
	(645462, 132, '2015-01-15 00:05:17.000000', 'consum', 0.0220, 'lps'),
	(645463, 132, '2015-01-15 00:05:18.000000', 'consum', 0.0219, 'lps'),
	(645464, 132, '2015-01-15 00:05:19.000000', 'consum', 0.0212, 'lps'),
	(645465, 132, '2015-01-15 00:05:20.000000', 'consum', 0.0215, 'lps'),
	(645466, 132, '2015-01-15 00:05:21.000000', 'consum', 0.0218, 'lps'),
	(645467, 132, '2015-01-15 00:05:22.000000', 'consum', 0.0215, 'lps'),
	(645468, 132, '2015-01-15 00:05:23.000000', 'consum', 0.0212, 'lps'),
	(645469, 132, '2015-01-15 00:05:24.000000', 'consum', 0.0215, 'lps'),
	(645470, 132, '2015-01-15 00:05:25.000000', 'consum', 0.0217, 'lps'),
	(645471, 132, '2015-01-15 00:05:26.000000', 'consum', 0.0212, 'lps'),
	(645472, 132, '2015-01-15 00:05:27.000000', 'consum', 0.0210, 'lps'),
	(645473, 132, '2015-01-15 00:05:28.000000', 'consum', 0.0213, 'lps'),
	(645474, 132, '2015-01-15 00:05:29.000000', 'consum', 0.0216, 'lps'),
	(645475, 132, '2015-01-15 00:05:30.000000', 'consum', 0.0220, 'lps'),
	(645476, 132, '2015-01-15 00:05:31.000000', 'consum', 0.0220, 'lps'),
	(645477, 132, '2015-01-15 00:05:32.000000', 'consum', 0.0210, 'lps'),
	(645478, 132, '2015-01-15 00:05:33.000000', 'consum', 0.0214, 'lps'),
	(645479, 132, '2015-01-15 00:05:34.000000', 'consum', 0.0220, 'lps'),
	(645480, 132, '2015-01-15 00:05:35.000000', 'consum', 0.0215, 'lps'),
	(645481, 132, '2015-01-15 00:05:36.000000', 'consum', 0.0216, 'lps'),
	(645482, 132, '2015-01-15 00:05:37.000000', 'consum', 0.0214, 'lps'),
	(645483, 132, '2015-01-15 00:05:38.000000', 'consum', 0.0214, 'lps'),
	(645484, 132, '2015-01-15 00:05:39.000000', 'consum', 0.0217, 'lps'),
	(645485, 132, '2015-01-15 00:05:40.000000', 'consum', 0.0211, 'lps'),
	(645486, 132, '2015-01-15 00:05:41.000000', 'consum', 0.0215, 'lps'),
	(645487, 132, '2015-01-15 00:05:42.000000', 'consum', 0.0213, 'lps'),
	(645488, 132, '2015-01-15 00:05:43.000000', 'consum', 0.0219, 'lps'),
	(645489, 132, '2015-01-15 00:05:44.000000', 'consum', 0.0216, 'lps'),
	(645490, 132, '2015-01-15 00:05:45.000000', 'consum', 0.0213, 'lps'),
	(645491, 132, '2015-01-15 00:05:46.000000', 'consum', 0.0217, 'lps'),
	(645492, 132, '2015-01-15 00:05:47.000000', 'consum', 0.0213, 'lps'),
	(645493, 132, '2015-01-15 00:05:48.000000', 'consum', 0.0219, 'lps'),
	(645494, 132, '2015-01-15 00:05:49.000000', 'consum', 0.0212, 'lps'),
	(645495, 132, '2015-01-15 00:05:50.000000', 'consum', 0.0216, 'lps'),
	(645496, 132, '2015-01-15 00:05:51.000000', 'consum', 0.0213, 'lps'),
	(645497, 132, '2015-01-15 00:05:52.000000', 'consum', 0.0218, 'lps'),
	(645498, 132, '2015-01-15 00:05:53.000000', 'consum', 0.0220, 'lps'),
	(645499, 132, '2015-01-15 00:05:54.000000', 'consum', 0.0214, 'lps'),
	(645500, 132, '2015-01-15 00:05:55.000000', 'consum', 0.0210, 'lps'),
	(645501, 132, '2015-01-15 00:05:56.000000', 'consum', 0.0220, 'lps'),
	(645502, 132, '2015-01-15 00:05:57.000000', 'consum', 0.0219, 'lps'),
	(645503, 132, '2015-01-15 00:05:58.000000', 'consum', 0.0213, 'lps'),
	(645504, 132, '2015-01-15 00:05:59.000000', 'consum', 0.0212, 'lps'),
	(645505, 132, '2015-01-15 00:06:00.000000', 'consum', 0.0220, 'lps'),
	(645506, 132, '2015-01-15 00:06:01.000000', 'consum', 0.0211, 'lps'),
	(645507, 132, '2015-01-15 00:06:02.000000', 'consum', 0.0220, 'lps'),
	(645508, 132, '2015-01-15 00:06:03.000000', 'consum', 0.0213, 'lps'),
	(645509, 132, '2015-01-15 00:06:04.000000', 'consum', 0.0217, 'lps'),
	(645510, 132, '2015-01-15 00:06:05.000000', 'consum', 0.0216, 'lps'),
	(645511, 132, '2015-01-15 00:06:06.000000', 'consum', 0.0220, 'lps'),
	(645512, 132, '2015-01-15 00:06:07.000000', 'consum', 0.0220, 'lps'),
	(645513, 132, '2015-01-15 00:06:08.000000', 'consum', 0.0218, 'lps'),
	(645514, 132, '2015-01-15 00:06:09.000000', 'consum', 0.0211, 'lps'),
	(645515, 132, '2015-01-15 00:06:10.000000', 'consum', 0.0212, 'lps'),
	(645516, 132, '2015-01-15 00:06:11.000000', 'consum', 0.0219, 'lps'),
	(645517, 132, '2015-01-15 00:06:12.000000', 'consum', 0.0215, 'lps'),
	(645518, 132, '2015-01-15 00:06:13.000000', 'consum', 0.0219, 'lps'),
	(645519, 132, '2015-01-15 00:06:14.000000', 'consum', 0.0220, 'lps'),
	(645520, 132, '2015-01-15 00:06:15.000000', 'consum', 0.0212, 'lps'),
	(645521, 132, '2015-01-15 00:06:16.000000', 'consum', 0.0212, 'lps'),
	(645522, 132, '2015-01-15 00:06:17.000000', 'consum', 0.0215, 'lps'),
	(645523, 132, '2015-01-15 00:06:18.000000', 'consum', 0.0219, 'lps'),
	(645524, 132, '2015-01-15 00:06:19.000000', 'consum', 0.0218, 'lps'),
	(645525, 132, '2015-01-15 00:06:20.000000', 'consum', 0.0212, 'lps'),
	(645526, 132, '2015-01-15 00:06:21.000000', 'consum', 0.0218, 'lps'),
	(645527, 132, '2015-01-15 00:06:22.000000', 'consum', 0.0211, 'lps'),
	(645528, 132, '2015-01-15 00:06:23.000000', 'consum', 0.0212, 'lps'),
	(645529, 132, '2015-01-15 00:06:24.000000', 'consum', 0.0220, 'lps'),
	(645530, 132, '2015-01-15 00:06:25.000000', 'consum', 0.0211, 'lps'),
	(645531, 132, '2015-01-15 00:06:26.000000', 'consum', 0.0218, 'lps'),
	(645532, 132, '2015-01-15 00:06:27.000000', 'consum', 0.0216, 'lps'),
	(645533, 132, '2015-01-15 00:06:28.000000', 'consum', 0.0215, 'lps'),
	(645534, 132, '2015-01-15 00:06:29.000000', 'consum', 0.0219, 'lps'),
	(645535, 132, '2015-01-15 00:06:30.000000', 'consum', 0.0218, 'lps'),
	(645536, 132, '2015-01-15 00:06:31.000000', 'consum', 0.0212, 'lps'),
	(645537, 132, '2015-01-15 00:06:32.000000', 'consum', 0.0217, 'lps'),
	(645538, 132, '2015-01-15 00:06:33.000000', 'consum', 0.0219, 'lps'),
	(645539, 132, '2015-01-15 00:06:34.000000', 'consum', 0.0211, 'lps'),
	(645540, 132, '2015-01-15 00:06:35.000000', 'consum', 0.0212, 'lps'),
	(645541, 132, '2015-01-15 00:06:36.000000', 'consum', 0.0216, 'lps'),
	(645542, 132, '2015-01-15 00:06:37.000000', 'consum', 0.0215, 'lps'),
	(645543, 132, '2015-01-15 00:06:38.000000', 'consum', 0.0215, 'lps'),
	(645544, 132, '2015-01-15 00:06:39.000000', 'consum', 0.0211, 'lps'),
	(645545, 132, '2015-01-15 00:06:40.000000', 'consum', 0.0212, 'lps'),
	(645546, 132, '2015-01-15 00:06:41.000000', 'consum', 0.0218, 'lps'),
	(645547, 132, '2015-01-15 00:06:42.000000', 'consum', 0.0210, 'lps'),
	(645548, 132, '2015-01-15 00:06:43.000000', 'consum', 0.0220, 'lps'),
	(645549, 132, '2015-01-15 00:06:44.000000', 'consum', 0.0219, 'lps'),
	(645550, 132, '2015-01-15 00:06:45.000000', 'consum', 0.0211, 'lps'),
	(645551, 132, '2015-01-15 00:06:46.000000', 'consum', 0.0212, 'lps'),
	(645552, 132, '2015-01-15 00:06:47.000000', 'consum', 0.0216, 'lps'),
	(645553, 132, '2015-01-15 00:06:48.000000', 'consum', 0.0215, 'lps'),
	(645554, 132, '2015-01-15 00:06:49.000000', 'consum', 0.0215, 'lps'),
	(645555, 132, '2015-01-15 00:06:50.000000', 'consum', 0.0220, 'lps'),
	(645556, 132, '2015-01-15 00:06:51.000000', 'consum', 0.0214, 'lps'),
	(645557, 132, '2015-01-15 00:06:52.000000', 'consum', 0.0210, 'lps'),
	(645558, 132, '2015-01-15 00:06:53.000000', 'consum', 0.0212, 'lps'),
	(645559, 132, '2015-01-15 00:06:54.000000', 'consum', 0.0218, 'lps'),
	(645560, 132, '2015-01-15 00:06:55.000000', 'consum', 0.0212, 'lps'),
	(645561, 132, '2015-01-15 00:06:56.000000', 'consum', 0.0219, 'lps'),
	(645562, 132, '2015-01-15 00:06:57.000000', 'consum', 0.0214, 'lps'),
	(645563, 132, '2015-01-15 00:06:58.000000', 'consum', 0.0218, 'lps'),
	(645564, 132, '2015-01-15 00:06:59.000000', 'consum', 0.0214, 'lps'),
	(645565, 132, '2015-01-15 00:07:00.000000', 'consum', 0.0218, 'lps'),
	(645566, 132, '2015-01-15 00:07:01.000000', 'consum', 0.0217, 'lps'),
	(645567, 132, '2015-01-15 00:07:02.000000', 'consum', 0.0211, 'lps'),
	(645568, 132, '2015-01-15 00:07:03.000000', 'consum', 0.0216, 'lps'),
	(645569, 132, '2015-01-15 00:07:04.000000', 'consum', 0.0217, 'lps'),
	(645570, 132, '2015-01-15 00:07:05.000000', 'consum', 0.0215, 'lps'),
	(645571, 132, '2015-01-15 00:07:06.000000', 'consum', 0.0216, 'lps'),
	(645572, 132, '2015-01-15 00:07:07.000000', 'consum', 0.0215, 'lps'),
	(645573, 132, '2015-01-15 00:07:08.000000', 'consum', 0.0218, 'lps'),
	(645574, 132, '2015-01-15 00:07:09.000000', 'consum', 0.0214, 'lps'),
	(645575, 132, '2015-01-15 00:07:10.000000', 'consum', 0.0217, 'lps'),
	(645576, 132, '2015-01-15 00:07:11.000000', 'consum', 0.0210, 'lps'),
	(645577, 132, '2015-01-15 00:07:12.000000', 'consum', 0.0211, 'lps'),
	(645578, 132, '2015-01-15 00:07:13.000000', 'consum', 0.0215, 'lps'),
	(645579, 132, '2015-01-15 00:07:14.000000', 'consum', 0.0212, 'lps'),
	(645580, 132, '2015-01-15 00:07:15.000000', 'consum', 0.0215, 'lps'),
	(645581, 132, '2015-01-15 00:07:16.000000', 'consum', 0.0219, 'lps'),
	(645582, 132, '2015-01-15 00:07:17.000000', 'consum', 0.0210, 'lps'),
	(645583, 132, '2015-01-15 00:07:18.000000', 'consum', 0.0213, 'lps'),
	(645584, 132, '2015-01-15 00:07:19.000000', 'consum', 0.0218, 'lps'),
	(645585, 132, '2015-01-15 00:07:20.000000', 'consum', 0.0217, 'lps'),
	(645586, 132, '2015-01-15 00:07:21.000000', 'consum', 0.0210, 'lps'),
	(645587, 132, '2015-01-15 00:07:22.000000', 'consum', 0.0212, 'lps'),
	(645588, 132, '2015-01-15 00:07:23.000000', 'consum', 0.0220, 'lps'),
	(645589, 132, '2015-01-15 00:07:24.000000', 'consum', 0.0210, 'lps'),
	(645590, 132, '2015-01-15 00:07:25.000000', 'consum', 0.0215, 'lps'),
	(645591, 132, '2015-01-15 00:07:26.000000', 'consum', 0.0213, 'lps'),
	(645592, 132, '2015-01-15 00:07:27.000000', 'consum', 0.0211, 'lps'),
	(645593, 132, '2015-01-15 00:07:28.000000', 'consum', 0.0215, 'lps'),
	(645594, 132, '2015-01-15 00:07:29.000000', 'consum', 0.0214, 'lps'),
	(645595, 132, '2015-01-15 00:07:30.000000', 'consum', 0.0214, 'lps'),
	(645596, 132, '2015-01-15 00:07:31.000000', 'consum', 0.0220, 'lps'),
	(645597, 132, '2015-01-15 00:07:32.000000', 'consum', 0.0213, 'lps'),
	(645598, 132, '2015-01-15 00:07:33.000000', 'consum', 0.0216, 'lps'),
	(645599, 132, '2015-01-15 00:07:34.000000', 'consum', 0.0213, 'lps'),
	(645600, 132, '2015-01-15 00:07:35.000000', 'consum', 0.0219, 'lps'),
	(645601, 132, '2015-01-15 00:07:36.000000', 'consum', 0.0212, 'lps'),
	(645602, 132, '2015-01-15 00:07:37.000000', 'consum', 0.0218, 'lps'),
	(645603, 132, '2015-01-15 00:07:38.000000', 'consum', 0.0220, 'lps'),
	(645604, 132, '2015-01-15 00:07:39.000000', 'consum', 0.0215, 'lps'),
	(645605, 132, '2015-01-15 00:07:40.000000', 'consum', 0.0215, 'lps'),
	(645606, 132, '2015-01-15 00:07:41.000000', 'consum', 0.0220, 'lps'),
	(645607, 132, '2015-01-15 00:07:42.000000', 'consum', 0.0213, 'lps'),
	(645608, 132, '2015-01-15 00:07:43.000000', 'consum', 0.0219, 'lps'),
	(645609, 132, '2015-01-15 00:07:44.000000', 'consum', 0.0211, 'lps'),
	(645610, 132, '2015-01-15 00:07:45.000000', 'consum', 0.0212, 'lps'),
	(645611, 132, '2015-01-15 00:07:46.000000', 'consum', 0.0217, 'lps'),
	(645612, 132, '2015-01-15 00:07:47.000000', 'consum', 0.0220, 'lps'),
	(645613, 132, '2015-01-15 00:07:48.000000', 'consum', 0.0214, 'lps'),
	(645614, 132, '2015-01-15 00:07:49.000000', 'consum', 0.0215, 'lps'),
	(645615, 132, '2015-01-15 00:07:50.000000', 'consum', 0.0210, 'lps'),
	(645616, 132, '2015-01-15 00:07:51.000000', 'consum', 0.0218, 'lps'),
	(645617, 132, '2015-01-15 00:07:52.000000', 'consum', 0.0219, 'lps'),
	(645618, 132, '2015-01-15 00:07:53.000000', 'consum', 0.0210, 'lps'),
	(645619, 132, '2015-01-15 00:07:54.000000', 'consum', 0.0214, 'lps'),
	(645620, 132, '2015-01-15 00:07:55.000000', 'consum', 0.0210, 'lps'),
	(645621, 132, '2015-01-15 00:07:56.000000', 'consum', 0.0211, 'lps'),
	(645622, 132, '2015-01-15 00:07:57.000000', 'consum', 0.0213, 'lps'),
	(645623, 132, '2015-01-15 00:07:58.000000', 'consum', 0.0213, 'lps'),
	(645624, 132, '2015-01-15 00:07:59.000000', 'consum', 0.0215, 'lps'),
	(645625, 132, '2015-01-15 00:08:00.000000', 'consum', 0.0214, 'lps'),
	(645626, 132, '2015-01-15 00:08:01.000000', 'consum', 0.0217, 'lps'),
	(645627, 132, '2015-01-15 00:08:02.000000', 'consum', 0.0213, 'lps'),
	(645628, 132, '2015-01-15 00:08:03.000000', 'consum', 0.0216, 'lps'),
	(645629, 132, '2015-01-15 00:08:04.000000', 'consum', 0.0218, 'lps'),
	(645630, 132, '2015-01-15 00:08:05.000000', 'consum', 0.0213, 'lps'),
	(645631, 132, '2015-01-15 00:08:06.000000', 'consum', 0.0214, 'lps'),
	(645632, 132, '2015-01-15 00:08:07.000000', 'consum', 0.0218, 'lps'),
	(645633, 132, '2015-01-15 00:08:08.000000', 'consum', 0.0217, 'lps'),
	(645634, 132, '2015-01-15 00:08:09.000000', 'consum', 0.0213, 'lps'),
	(645635, 132, '2015-01-15 00:08:10.000000', 'consum', 0.0212, 'lps'),
	(645636, 132, '2015-01-15 00:08:11.000000', 'consum', 0.0215, 'lps'),
	(645637, 132, '2015-01-15 00:08:12.000000', 'consum', 0.0216, 'lps'),
	(645638, 132, '2015-01-15 00:08:13.000000', 'consum', 0.0216, 'lps'),
	(645639, 132, '2015-01-15 00:08:14.000000', 'consum', 0.0213, 'lps'),
	(645640, 132, '2015-01-15 00:08:15.000000', 'consum', 0.0215, 'lps'),
	(645641, 132, '2015-01-15 00:08:16.000000', 'consum', 0.0217, 'lps'),
	(645642, 132, '2015-01-15 00:08:17.000000', 'consum', 0.0220, 'lps'),
	(645643, 132, '2015-01-15 00:08:18.000000', 'consum', 0.0217, 'lps'),
	(645644, 132, '2015-01-15 00:08:19.000000', 'consum', 0.0216, 'lps'),
	(645645, 132, '2015-01-15 00:08:20.000000', 'consum', 0.0220, 'lps'),
	(645646, 132, '2015-01-15 00:08:21.000000', 'consum', 0.0218, 'lps'),
	(645647, 132, '2015-01-15 00:08:22.000000', 'consum', 0.0211, 'lps'),
	(645648, 132, '2015-01-15 00:08:23.000000', 'consum', 0.0214, 'lps'),
	(645649, 132, '2015-01-15 00:08:24.000000', 'consum', 0.0217, 'lps'),
	(645650, 132, '2015-01-15 00:08:25.000000', 'consum', 0.0210, 'lps'),
	(645651, 132, '2015-01-15 00:08:26.000000', 'consum', 0.0212, 'lps'),
	(645652, 132, '2015-01-15 00:08:27.000000', 'consum', 0.0220, 'lps'),
	(645653, 132, '2015-01-15 00:08:28.000000', 'consum', 0.0213, 'lps'),
	(645654, 132, '2015-01-15 00:08:29.000000', 'consum', 0.0216, 'lps'),
	(645655, 132, '2015-01-15 00:08:30.000000', 'consum', 0.0219, 'lps'),
	(645656, 132, '2015-01-15 00:08:31.000000', 'consum', 0.0216, 'lps'),
	(645657, 132, '2015-01-15 00:08:32.000000', 'consum', 0.0215, 'lps'),
	(645658, 132, '2015-01-15 00:08:33.000000', 'consum', 0.0216, 'lps'),
	(645659, 132, '2015-01-15 00:08:34.000000', 'consum', 0.0216, 'lps'),
	(645660, 132, '2015-01-15 00:08:35.000000', 'consum', 0.0213, 'lps'),
	(645661, 132, '2015-01-15 00:08:36.000000', 'consum', 0.0217, 'lps'),
	(645662, 132, '2015-01-15 00:08:37.000000', 'consum', 0.0213, 'lps'),
	(645663, 132, '2015-01-15 00:08:38.000000', 'consum', 0.0218, 'lps'),
	(645664, 132, '2015-01-15 00:08:39.000000', 'consum', 0.0218, 'lps'),
	(645665, 132, '2015-01-15 00:08:40.000000', 'consum', 0.0217, 'lps'),
	(645666, 132, '2015-01-15 00:08:41.000000', 'consum', 0.0219, 'lps'),
	(645667, 132, '2015-01-15 00:08:42.000000', 'consum', 0.0212, 'lps'),
	(645668, 132, '2015-01-15 00:08:43.000000', 'consum', 0.0218, 'lps'),
	(645669, 132, '2015-01-15 00:08:44.000000', 'consum', 0.0220, 'lps'),
	(645670, 132, '2015-01-15 00:08:45.000000', 'consum', 0.0216, 'lps'),
	(645671, 132, '2015-01-15 00:08:46.000000', 'consum', 0.0210, 'lps'),
	(645672, 132, '2015-01-15 00:08:47.000000', 'consum', 0.0215, 'lps'),
	(645673, 132, '2015-01-15 00:08:48.000000', 'consum', 0.0214, 'lps'),
	(645674, 132, '2015-01-15 00:08:49.000000', 'consum', 0.0216, 'lps'),
	(645675, 132, '2015-01-15 00:08:50.000000', 'consum', 0.0219, 'lps'),
	(645676, 132, '2015-01-15 00:08:51.000000', 'consum', 0.0213, 'lps'),
	(645677, 132, '2015-01-15 00:08:52.000000', 'consum', 0.0219, 'lps'),
	(645678, 132, '2015-01-15 00:08:53.000000', 'consum', 0.0215, 'lps'),
	(645679, 132, '2015-01-15 00:08:54.000000', 'consum', 0.0210, 'lps'),
	(645680, 132, '2015-01-15 00:08:55.000000', 'consum', 0.0215, 'lps'),
	(645681, 132, '2015-01-15 00:08:56.000000', 'consum', 0.0215, 'lps'),
	(645682, 132, '2015-01-15 00:08:57.000000', 'consum', 0.0218, 'lps'),
	(645683, 132, '2015-01-15 00:08:58.000000', 'consum', 0.0215, 'lps'),
	(645684, 132, '2015-01-15 00:08:59.000000', 'consum', 0.0213, 'lps'),
	(645685, 132, '2015-01-15 00:09:00.000000', 'consum', 0.0219, 'lps'),
	(645686, 132, '2015-01-15 00:09:01.000000', 'consum', 0.0217, 'lps'),
	(645687, 132, '2015-01-15 00:09:02.000000', 'consum', 0.0215, 'lps'),
	(645688, 132, '2015-01-15 00:09:03.000000', 'consum', 0.0216, 'lps'),
	(645689, 132, '2015-01-15 00:09:04.000000', 'consum', 0.0215, 'lps'),
	(645690, 132, '2015-01-15 00:09:05.000000', 'consum', 0.0216, 'lps'),
	(645691, 132, '2015-01-15 00:09:06.000000', 'consum', 0.0217, 'lps'),
	(645692, 132, '2015-01-15 00:09:07.000000', 'consum', 0.0215, 'lps'),
	(645693, 132, '2015-01-15 00:09:08.000000', 'consum', 0.0215, 'lps'),
	(645694, 132, '2015-01-15 00:09:09.000000', 'consum', 0.0210, 'lps'),
	(645695, 132, '2015-01-15 00:09:10.000000', 'consum', 0.0216, 'lps'),
	(645696, 132, '2015-01-15 00:09:11.000000', 'consum', 0.0219, 'lps'),
	(645697, 132, '2015-01-15 00:09:12.000000', 'consum', 0.0217, 'lps'),
	(645698, 132, '2015-01-15 00:09:13.000000', 'consum', 0.0216, 'lps'),
	(645699, 132, '2015-01-15 00:09:14.000000', 'consum', 0.0211, 'lps'),
	(645700, 132, '2015-01-15 00:09:15.000000', 'consum', 0.0217, 'lps'),
	(645701, 132, '2015-01-15 00:09:16.000000', 'consum', 0.0220, 'lps'),
	(645702, 132, '2015-01-15 00:09:17.000000', 'consum', 0.0218, 'lps'),
	(645703, 132, '2015-01-15 00:09:18.000000', 'consum', 0.0210, 'lps'),
	(645704, 132, '2015-01-15 00:09:19.000000', 'consum', 0.0218, 'lps'),
	(645705, 132, '2015-01-15 00:09:20.000000', 'consum', 0.0220, 'lps'),
	(645706, 132, '2015-01-15 00:09:21.000000', 'consum', 0.0213, 'lps'),
	(645707, 132, '2015-01-15 00:09:22.000000', 'consum', 0.0217, 'lps'),
	(645708, 132, '2015-01-15 00:09:23.000000', 'consum', 0.0213, 'lps'),
	(645709, 132, '2015-01-15 00:09:24.000000', 'consum', 0.0219, 'lps'),
	(645710, 132, '2015-01-15 00:09:25.000000', 'consum', 0.0210, 'lps'),
	(645711, 132, '2015-01-15 00:09:26.000000', 'consum', 0.0220, 'lps'),
	(645712, 132, '2015-01-15 00:09:27.000000', 'consum', 0.0213, 'lps'),
	(645713, 132, '2015-01-15 00:09:28.000000', 'consum', 0.0210, 'lps'),
	(645714, 132, '2015-01-15 00:09:29.000000', 'consum', 0.0210, 'lps'),
	(645715, 132, '2015-01-15 00:09:30.000000', 'consum', 0.0212, 'lps'),
	(645716, 132, '2015-01-15 00:09:31.000000', 'consum', 0.0219, 'lps'),
	(645717, 132, '2015-01-15 00:09:32.000000', 'consum', 0.0219, 'lps'),
	(645718, 132, '2015-01-15 00:09:33.000000', 'consum', 0.0217, 'lps'),
	(645719, 132, '2015-01-15 00:09:34.000000', 'consum', 0.0218, 'lps'),
	(645720, 132, '2015-01-15 00:09:35.000000', 'consum', 0.0219, 'lps'),
	(645721, 132, '2015-01-15 00:09:36.000000', 'consum', 0.0219, 'lps'),
	(645722, 132, '2015-01-15 00:09:37.000000', 'consum', 0.0218, 'lps'),
	(645723, 132, '2015-01-15 00:09:38.000000', 'consum', 0.0213, 'lps'),
	(645724, 132, '2015-01-15 00:09:39.000000', 'consum', 0.0212, 'lps'),
	(645725, 132, '2015-01-15 00:09:40.000000', 'consum', 0.0210, 'lps'),
	(645726, 132, '2015-01-15 00:09:41.000000', 'consum', 0.0218, 'lps'),
	(645727, 132, '2015-01-15 00:09:42.000000', 'consum', 0.0219, 'lps'),
	(645728, 132, '2015-01-15 00:09:43.000000', 'consum', 0.0217, 'lps'),
	(645729, 132, '2015-01-15 00:09:44.000000', 'consum', 0.0218, 'lps'),
	(645730, 132, '2015-01-15 00:09:45.000000', 'consum', 0.0210, 'lps'),
	(645731, 132, '2015-01-15 00:09:46.000000', 'consum', 0.0220, 'lps'),
	(645732, 132, '2015-01-15 00:09:47.000000', 'consum', 0.0214, 'lps'),
	(645733, 132, '2015-01-15 00:09:48.000000', 'consum', 0.0211, 'lps'),
	(645734, 132, '2015-01-15 00:09:49.000000', 'consum', 0.0215, 'lps'),
	(645735, 132, '2015-01-15 00:09:50.000000', 'consum', 0.0220, 'lps'),
	(645736, 132, '2015-01-15 00:09:51.000000', 'consum', 0.0214, 'lps'),
	(645737, 132, '2015-01-15 00:09:52.000000', 'consum', 0.0210, 'lps'),
	(645738, 132, '2015-01-15 00:09:53.000000', 'consum', 0.0210, 'lps'),
	(645739, 132, '2015-01-15 00:09:54.000000', 'consum', 0.0210, 'lps'),
	(645740, 132, '2015-01-15 00:09:55.000000', 'consum', 0.0212, 'lps'),
	(645741, 132, '2015-01-15 00:09:56.000000', 'consum', 0.0219, 'lps'),
	(645742, 132, '2015-01-15 00:09:57.000000', 'consum', 0.0216, 'lps'),
	(645743, 132, '2015-01-15 00:09:58.000000', 'consum', 0.0212, 'lps'),
	(645744, 132, '2015-01-15 00:09:59.000000', 'consum', 0.0216, 'lps'),
	(645745, 132, '2015-01-15 00:10:00.000000', 'consum', 0.0211, 'lps'),
	(645746, 132, '2015-01-15 00:10:01.000000', 'consum', 0.0211, 'lps'),
	(645747, 132, '2015-01-15 00:10:02.000000', 'consum', 0.0220, 'lps'),
	(645748, 132, '2015-01-15 00:10:03.000000', 'consum', 0.0215, 'lps'),
	(645749, 132, '2015-01-15 00:10:04.000000', 'consum', 0.0218, 'lps'),
	(645750, 132, '2015-01-15 00:10:05.000000', 'consum', 0.0214, 'lps'),
	(645751, 132, '2015-01-15 00:10:06.000000', 'consum', 0.0218, 'lps'),
	(645752, 132, '2015-01-15 00:10:07.000000', 'consum', 0.0216, 'lps'),
	(645753, 132, '2015-01-15 00:10:08.000000', 'consum', 0.0217, 'lps'),
	(645754, 132, '2015-01-15 00:10:09.000000', 'consum', 0.0216, 'lps'),
	(645755, 132, '2015-01-15 00:10:10.000000', 'consum', 0.0220, 'lps'),
	(645756, 132, '2015-01-15 00:10:11.000000', 'consum', 0.0218, 'lps'),
	(645757, 132, '2015-01-15 00:10:12.000000', 'consum', 0.0212, 'lps'),
	(645758, 132, '2015-01-15 00:10:13.000000', 'consum', 0.0219, 'lps'),
	(645759, 132, '2015-01-15 00:10:14.000000', 'consum', 0.0216, 'lps'),
	(645760, 132, '2015-01-15 00:10:15.000000', 'consum', 0.0215, 'lps'),
	(645761, 132, '2015-01-15 00:10:16.000000', 'consum', 0.0217, 'lps'),
	(645762, 132, '2015-01-15 00:10:17.000000', 'consum', 0.0218, 'lps'),
	(645763, 132, '2015-01-15 00:10:18.000000', 'consum', 0.0218, 'lps'),
	(645764, 132, '2015-01-15 00:10:19.000000', 'consum', 0.0217, 'lps'),
	(645765, 132, '2015-01-15 00:10:20.000000', 'consum', 0.0219, 'lps'),
	(645766, 132, '2015-01-15 00:10:21.000000', 'consum', 0.0216, 'lps'),
	(645767, 132, '2015-01-15 00:10:22.000000', 'consum', 0.0212, 'lps'),
	(645768, 132, '2015-01-15 00:10:23.000000', 'consum', 0.0214, 'lps'),
	(645769, 132, '2015-01-15 00:10:24.000000', 'consum', 0.0214, 'lps'),
	(645770, 132, '2015-01-15 00:10:25.000000', 'consum', 0.0216, 'lps'),
	(645771, 132, '2015-01-15 00:10:26.000000', 'consum', 0.0218, 'lps'),
	(645772, 132, '2015-01-15 00:10:27.000000', 'consum', 0.0211, 'lps'),
	(645773, 132, '2015-01-15 00:10:28.000000', 'consum', 0.0213, 'lps'),
	(645774, 132, '2015-01-15 00:10:29.000000', 'consum', 0.0212, 'lps'),
	(645775, 132, '2015-01-15 00:10:30.000000', 'consum', 0.0211, 'lps'),
	(645776, 132, '2015-01-15 00:10:31.000000', 'consum', 0.0211, 'lps'),
	(645777, 132, '2015-01-15 00:10:32.000000', 'consum', 0.0213, 'lps'),
	(645778, 132, '2015-01-15 00:10:33.000000', 'consum', 0.0211, 'lps'),
	(645779, 132, '2015-01-15 00:10:34.000000', 'consum', 0.0218, 'lps'),
	(645780, 132, '2015-01-15 00:10:35.000000', 'consum', 0.0215, 'lps'),
	(645781, 132, '2015-01-15 00:10:36.000000', 'consum', 0.0210, 'lps'),
	(645782, 132, '2015-01-15 00:10:37.000000', 'consum', 0.0220, 'lps'),
	(645783, 132, '2015-01-15 00:10:38.000000', 'consum', 0.0215, 'lps'),
	(645784, 132, '2015-01-15 00:10:39.000000', 'consum', 0.0215, 'lps'),
	(645785, 132, '2015-01-15 00:10:40.000000', 'consum', 0.0210, 'lps'),
	(645786, 132, '2015-01-15 00:10:41.000000', 'consum', 0.0218, 'lps'),
	(645787, 132, '2015-01-15 00:10:42.000000', 'consum', 0.0219, 'lps'),
	(645788, 132, '2015-01-15 00:10:43.000000', 'consum', 0.0210, 'lps'),
	(645789, 132, '2015-01-15 00:10:44.000000', 'consum', 0.0215, 'lps'),
	(645790, 132, '2015-01-15 00:10:45.000000', 'consum', 0.0214, 'lps'),
	(645791, 132, '2015-01-15 00:10:46.000000', 'consum', 0.0216, 'lps'),
	(645792, 132, '2015-01-15 00:10:47.000000', 'consum', 0.0217, 'lps'),
	(645793, 132, '2015-01-15 00:10:48.000000', 'consum', 0.0215, 'lps'),
	(645794, 132, '2015-01-15 00:10:49.000000', 'consum', 0.0214, 'lps'),
	(645795, 132, '2015-01-15 00:10:50.000000', 'consum', 0.0215, 'lps'),
	(645796, 132, '2015-01-15 00:10:51.000000', 'consum', 0.0215, 'lps'),
	(645797, 132, '2015-01-15 00:10:52.000000', 'consum', 0.0219, 'lps'),
	(645798, 132, '2015-01-15 00:10:53.000000', 'consum', 0.0219, 'lps'),
	(645799, 132, '2015-01-15 00:10:54.000000', 'consum', 0.0217, 'lps'),
	(645800, 132, '2015-01-15 00:10:55.000000', 'consum', 0.0220, 'lps'),
	(645801, 132, '2015-01-15 00:10:56.000000', 'consum', 0.0217, 'lps'),
	(645802, 132, '2015-01-15 00:10:57.000000', 'consum', 0.0214, 'lps'),
	(645803, 132, '2015-01-15 00:10:58.000000', 'consum', 0.0210, 'lps'),
	(645804, 132, '2015-01-15 00:10:59.000000', 'consum', 0.0220, 'lps'),
	(645805, 132, '2015-01-15 00:11:00.000000', 'consum', 0.0217, 'lps'),
	(645806, 132, '2015-01-15 00:11:01.000000', 'consum', 0.0214, 'lps'),
	(645807, 132, '2015-01-15 00:11:02.000000', 'consum', 0.0212, 'lps'),
	(645808, 132, '2015-01-15 00:11:03.000000', 'consum', 0.0210, 'lps'),
	(645809, 132, '2015-01-15 00:11:04.000000', 'consum', 0.0212, 'lps'),
	(645810, 132, '2015-01-15 00:11:05.000000', 'consum', 0.0212, 'lps'),
	(645811, 132, '2015-01-15 00:11:06.000000', 'consum', 0.0213, 'lps'),
	(645812, 132, '2015-01-15 00:11:07.000000', 'consum', 0.0218, 'lps'),
	(645813, 132, '2015-01-15 00:11:08.000000', 'consum', 0.0211, 'lps'),
	(645814, 132, '2015-01-15 00:11:09.000000', 'consum', 0.0211, 'lps'),
	(645815, 132, '2015-01-15 00:11:10.000000', 'consum', 0.0213, 'lps'),
	(645816, 132, '2015-01-15 00:11:11.000000', 'consum', 0.0211, 'lps'),
	(645817, 132, '2015-01-15 00:11:12.000000', 'consum', 0.0217, 'lps'),
	(645818, 132, '2015-01-15 00:11:13.000000', 'consum', 0.0210, 'lps'),
	(645819, 132, '2015-01-15 00:11:14.000000', 'consum', 0.0212, 'lps'),
	(645820, 132, '2015-01-15 00:11:15.000000', 'consum', 0.0220, 'lps'),
	(645821, 132, '2015-01-15 00:11:16.000000', 'consum', 0.0210, 'lps'),
	(645822, 132, '2015-01-15 00:11:17.000000', 'consum', 0.0215, 'lps'),
	(645823, 132, '2015-01-15 00:11:18.000000', 'consum', 0.0215, 'lps'),
	(645824, 132, '2015-01-15 00:11:19.000000', 'consum', 0.0217, 'lps'),
	(645825, 132, '2015-01-15 00:11:20.000000', 'consum', 0.0220, 'lps'),
	(645826, 132, '2015-01-15 00:11:21.000000', 'consum', 0.0219, 'lps'),
	(645827, 132, '2015-01-15 00:11:22.000000', 'consum', 0.0215, 'lps'),
	(645828, 132, '2015-01-15 00:11:23.000000', 'consum', 0.0218, 'lps'),
	(645829, 132, '2015-01-15 00:11:24.000000', 'consum', 0.0215, 'lps'),
	(645830, 132, '2015-01-15 00:11:25.000000', 'consum', 0.0212, 'lps'),
	(645831, 132, '2015-01-15 00:11:26.000000', 'consum', 0.0214, 'lps'),
	(645832, 132, '2015-01-15 00:11:27.000000', 'consum', 0.0216, 'lps'),
	(645833, 132, '2015-01-15 00:11:28.000000', 'consum', 0.0216, 'lps'),
	(645834, 132, '2015-01-15 00:11:29.000000', 'consum', 0.0213, 'lps'),
	(645835, 132, '2015-01-15 00:11:30.000000', 'consum', 0.0220, 'lps'),
	(645836, 132, '2015-01-15 00:11:31.000000', 'consum', 0.0216, 'lps'),
	(645837, 132, '2015-01-15 00:11:32.000000', 'consum', 0.0212, 'lps'),
	(645838, 132, '2015-01-15 00:11:33.000000', 'consum', 0.0214, 'lps'),
	(645839, 132, '2015-01-15 00:11:34.000000', 'consum', 0.0211, 'lps'),
	(645840, 132, '2015-01-15 00:11:35.000000', 'consum', 0.0214, 'lps'),
	(645841, 132, '2015-01-15 00:11:36.000000', 'consum', 0.0218, 'lps'),
	(645842, 132, '2015-01-15 00:11:37.000000', 'consum', 0.0217, 'lps'),
	(645843, 132, '2015-01-15 00:11:38.000000', 'consum', 0.0211, 'lps'),
	(645844, 132, '2015-01-15 00:11:39.000000', 'consum', 0.0215, 'lps'),
	(645845, 132, '2015-01-15 00:11:40.000000', 'consum', 0.0212, 'lps'),
	(645846, 132, '2015-01-15 00:11:41.000000', 'consum', 0.0216, 'lps'),
	(645847, 132, '2015-01-15 00:11:42.000000', 'consum', 0.0214, 'lps'),
	(645848, 132, '2015-01-15 00:11:43.000000', 'consum', 0.0211, 'lps'),
	(645849, 132, '2015-01-15 00:11:44.000000', 'consum', 0.0215, 'lps'),
	(645850, 132, '2015-01-15 00:11:45.000000', 'consum', 0.0211, 'lps'),
	(645851, 132, '2015-01-15 00:11:46.000000', 'consum', 0.0211, 'lps'),
	(645852, 132, '2015-01-15 00:11:47.000000', 'consum', 0.0211, 'lps'),
	(645853, 132, '2015-01-15 00:11:48.000000', 'consum', 0.0214, 'lps'),
	(645854, 132, '2015-01-15 00:11:49.000000', 'consum', 0.0217, 'lps'),
	(645855, 132, '2015-01-15 00:11:50.000000', 'consum', 0.0211, 'lps'),
	(645856, 132, '2015-01-15 00:11:51.000000', 'consum', 0.0218, 'lps'),
	(645857, 132, '2015-01-15 00:11:52.000000', 'consum', 0.0215, 'lps'),
	(645858, 132, '2015-01-15 00:11:53.000000', 'consum', 0.0219, 'lps'),
	(645859, 132, '2015-01-15 00:11:54.000000', 'consum', 0.0211, 'lps'),
	(645860, 132, '2015-01-15 00:11:55.000000', 'consum', 0.0218, 'lps'),
	(645861, 132, '2015-01-15 00:11:56.000000', 'consum', 0.0217, 'lps'),
	(645862, 132, '2015-01-15 00:11:57.000000', 'consum', 0.0220, 'lps'),
	(645863, 132, '2015-01-15 00:11:58.000000', 'consum', 0.0219, 'lps'),
	(645864, 132, '2015-01-15 00:11:59.000000', 'consum', 0.0213, 'lps'),
	(645865, 132, '2015-01-15 00:12:00.000000', 'consum', 0.0211, 'lps'),
	(645866, 132, '2015-01-15 00:12:01.000000', 'consum', 0.0216, 'lps'),
	(645867, 132, '2015-01-15 00:12:02.000000', 'consum', 0.0216, 'lps'),
	(645868, 132, '2015-01-15 00:12:03.000000', 'consum', 0.0214, 'lps'),
	(645869, 132, '2015-01-15 00:12:04.000000', 'consum', 0.0220, 'lps'),
	(645870, 132, '2015-01-15 00:12:05.000000', 'consum', 0.0215, 'lps'),
	(645871, 132, '2015-01-15 00:12:06.000000', 'consum', 0.0219, 'lps'),
	(645872, 132, '2015-01-15 00:12:07.000000', 'consum', 0.0218, 'lps'),
	(645873, 132, '2015-01-15 00:12:08.000000', 'consum', 0.0214, 'lps'),
	(645874, 132, '2015-01-15 00:12:09.000000', 'consum', 0.0215, 'lps'),
	(645875, 132, '2015-01-15 00:12:10.000000', 'consum', 0.0214, 'lps'),
	(645876, 132, '2015-01-15 00:12:11.000000', 'consum', 0.0214, 'lps'),
	(645877, 132, '2015-01-15 00:12:12.000000', 'consum', 0.0219, 'lps'),
	(645878, 132, '2015-01-15 00:12:13.000000', 'consum', 0.0211, 'lps'),
	(645879, 132, '2015-01-15 00:12:14.000000', 'consum', 0.0211, 'lps'),
	(645880, 132, '2015-01-15 00:12:15.000000', 'consum', 0.0213, 'lps'),
	(645881, 132, '2015-01-15 00:12:16.000000', 'consum', 0.0212, 'lps'),
	(645882, 132, '2015-01-15 00:12:17.000000', 'consum', 0.0213, 'lps'),
	(645883, 132, '2015-01-15 00:12:18.000000', 'consum', 0.0217, 'lps'),
	(645884, 132, '2015-01-15 00:12:19.000000', 'consum', 0.0215, 'lps'),
	(645885, 132, '2015-01-15 00:12:20.000000', 'consum', 0.0214, 'lps'),
	(645886, 132, '2015-01-15 00:12:21.000000', 'consum', 0.0217, 'lps'),
	(645887, 132, '2015-01-15 00:12:22.000000', 'consum', 0.0210, 'lps'),
	(645888, 132, '2015-01-15 00:12:23.000000', 'consum', 0.0213, 'lps'),
	(645889, 132, '2015-01-15 00:12:24.000000', 'consum', 0.0215, 'lps'),
	(645890, 132, '2015-01-15 00:12:25.000000', 'consum', 0.0213, 'lps'),
	(645891, 132, '2015-01-15 00:12:26.000000', 'consum', 0.0213, 'lps'),
	(645892, 132, '2015-01-15 00:12:27.000000', 'consum', 0.0218, 'lps'),
	(645893, 132, '2015-01-15 00:12:28.000000', 'consum', 0.0216, 'lps'),
	(645894, 132, '2015-01-15 00:12:29.000000', 'consum', 0.0218, 'lps'),
	(645895, 132, '2015-01-15 00:12:30.000000', 'consum', 0.0220, 'lps'),
	(645896, 132, '2015-01-15 00:12:31.000000', 'consum', 0.0214, 'lps'),
	(645897, 132, '2015-01-15 00:12:32.000000', 'consum', 0.0214, 'lps'),
	(645898, 132, '2015-01-15 00:12:33.000000', 'consum', 0.0218, 'lps'),
	(645899, 132, '2015-01-15 00:12:34.000000', 'consum', 0.0215, 'lps'),
	(645900, 132, '2015-01-15 00:12:35.000000', 'consum', 0.0213, 'lps'),
	(645901, 132, '2015-01-15 00:12:36.000000', 'consum', 0.0211, 'lps'),
	(645902, 132, '2015-01-15 00:12:37.000000', 'consum', 0.0218, 'lps'),
	(645903, 132, '2015-01-15 00:12:38.000000', 'consum', 0.0214, 'lps'),
	(645904, 132, '2015-01-15 00:12:39.000000', 'consum', 0.0217, 'lps'),
	(645905, 132, '2015-01-15 00:12:40.000000', 'consum', 0.0212, 'lps'),
	(645906, 132, '2015-01-15 00:12:41.000000', 'consum', 0.0210, 'lps'),
	(645907, 132, '2015-01-15 00:12:42.000000', 'consum', 0.0216, 'lps'),
	(645908, 132, '2015-01-15 00:12:43.000000', 'consum', 0.0218, 'lps'),
	(645909, 132, '2015-01-15 00:12:44.000000', 'consum', 0.0210, 'lps'),
	(645910, 132, '2015-01-15 00:12:45.000000', 'consum', 0.0218, 'lps'),
	(645911, 132, '2015-01-15 00:12:46.000000', 'consum', 0.0220, 'lps'),
	(645912, 132, '2015-01-15 00:12:47.000000', 'consum', 0.0214, 'lps'),
	(645913, 132, '2015-01-15 00:12:48.000000', 'consum', 0.0220, 'lps'),
	(645914, 132, '2015-01-15 00:12:49.000000', 'consum', 0.0219, 'lps'),
	(645915, 132, '2015-01-15 00:12:50.000000', 'consum', 0.0211, 'lps'),
	(645916, 132, '2015-01-15 00:12:51.000000', 'consum', 0.0213, 'lps'),
	(645917, 132, '2015-01-15 00:12:52.000000', 'consum', 0.0210, 'lps'),
	(645918, 132, '2015-01-15 00:12:53.000000', 'consum', 0.0213, 'lps'),
	(645919, 132, '2015-01-15 00:12:54.000000', 'consum', 0.0213, 'lps'),
	(645920, 132, '2015-01-15 00:12:55.000000', 'consum', 0.0216, 'lps'),
	(645921, 132, '2015-01-15 00:12:56.000000', 'consum', 0.0212, 'lps'),
	(645922, 132, '2015-01-15 00:12:57.000000', 'consum', 0.0214, 'lps'),
	(645923, 132, '2015-01-15 00:12:58.000000', 'consum', 0.0212, 'lps'),
	(645924, 132, '2015-01-15 00:12:59.000000', 'consum', 0.0218, 'lps'),
	(645925, 132, '2015-01-15 00:13:00.000000', 'consum', 0.0212, 'lps'),
	(645926, 132, '2015-01-15 00:13:01.000000', 'consum', 0.0218, 'lps'),
	(645927, 132, '2015-01-15 00:13:02.000000', 'consum', 0.0210, 'lps'),
	(645928, 132, '2015-01-15 00:13:03.000000', 'consum', 0.0211, 'lps'),
	(645929, 132, '2015-01-15 00:13:04.000000', 'consum', 0.0213, 'lps'),
	(645930, 132, '2015-01-15 00:13:05.000000', 'consum', 0.0214, 'lps'),
	(645931, 132, '2015-01-15 00:13:06.000000', 'consum', 0.0219, 'lps'),
	(645932, 132, '2015-01-15 00:13:07.000000', 'consum', 0.0213, 'lps'),
	(645933, 132, '2015-01-15 00:13:08.000000', 'consum', 0.0220, 'lps'),
	(645934, 132, '2015-01-15 00:13:09.000000', 'consum', 0.0217, 'lps'),
	(645935, 132, '2015-01-15 00:13:10.000000', 'consum', 0.0215, 'lps'),
	(645936, 132, '2015-01-15 00:13:11.000000', 'consum', 0.0215, 'lps'),
	(645937, 132, '2015-01-15 00:13:12.000000', 'consum', 0.0212, 'lps'),
	(645938, 132, '2015-01-15 00:13:13.000000', 'consum', 0.0213, 'lps'),
	(645939, 132, '2015-01-15 00:13:14.000000', 'consum', 0.0210, 'lps'),
	(645940, 132, '2015-01-15 00:13:15.000000', 'consum', 0.0211, 'lps'),
	(645941, 132, '2015-01-15 00:13:16.000000', 'consum', 0.0218, 'lps'),
	(645942, 132, '2015-01-15 00:13:17.000000', 'consum', 0.0214, 'lps'),
	(645943, 132, '2015-01-15 00:13:18.000000', 'consum', 0.0219, 'lps'),
	(645944, 132, '2015-01-15 00:13:19.000000', 'consum', 0.0219, 'lps'),
	(645945, 132, '2015-01-15 00:13:20.000000', 'consum', 0.0220, 'lps'),
	(645946, 132, '2015-01-15 00:13:21.000000', 'consum', 0.0210, 'lps'),
	(645947, 132, '2015-01-15 00:13:22.000000', 'consum', 0.0212, 'lps'),
	(645948, 132, '2015-01-15 00:13:23.000000', 'consum', 0.0212, 'lps'),
	(645949, 132, '2015-01-15 00:13:24.000000', 'consum', 0.0213, 'lps'),
	(645950, 132, '2015-01-15 00:13:25.000000', 'consum', 0.0220, 'lps'),
	(645951, 132, '2015-01-15 00:13:26.000000', 'consum', 0.0219, 'lps'),
	(645952, 132, '2015-01-15 00:13:27.000000', 'consum', 0.0214, 'lps'),
	(645953, 132, '2015-01-15 00:13:28.000000', 'consum', 0.0216, 'lps'),
	(645954, 132, '2015-01-15 00:13:29.000000', 'consum', 0.0218, 'lps'),
	(645955, 132, '2015-01-15 00:13:30.000000', 'consum', 0.0210, 'lps'),
	(645956, 132, '2015-01-15 00:13:31.000000', 'consum', 0.0219, 'lps'),
	(645957, 132, '2015-01-15 00:13:32.000000', 'consum', 0.0211, 'lps'),
	(645958, 132, '2015-01-15 00:13:33.000000', 'consum', 0.0212, 'lps'),
	(645959, 132, '2015-01-15 00:13:34.000000', 'consum', 0.0219, 'lps'),
	(645960, 132, '2015-01-15 00:13:35.000000', 'consum', 0.0214, 'lps'),
	(645961, 132, '2015-01-15 00:13:36.000000', 'consum', 0.0216, 'lps'),
	(645962, 132, '2015-01-15 00:13:37.000000', 'consum', 0.0217, 'lps'),
	(645963, 132, '2015-01-15 00:13:38.000000', 'consum', 0.0216, 'lps'),
	(645964, 132, '2015-01-15 00:13:39.000000', 'consum', 0.0218, 'lps'),
	(645965, 132, '2015-01-15 00:13:40.000000', 'consum', 0.0211, 'lps'),
	(645966, 132, '2015-01-15 00:13:41.000000', 'consum', 0.0214, 'lps'),
	(645967, 132, '2015-01-15 00:13:42.000000', 'consum', 0.0216, 'lps'),
	(645968, 132, '2015-01-15 00:13:43.000000', 'consum', 0.0217, 'lps'),
	(645969, 132, '2015-01-15 00:13:44.000000', 'consum', 0.0218, 'lps'),
	(645970, 132, '2015-01-15 00:13:45.000000', 'consum', 0.0218, 'lps'),
	(645971, 132, '2015-01-15 00:13:46.000000', 'consum', 0.0217, 'lps'),
	(645972, 132, '2015-01-15 00:13:47.000000', 'consum', 0.0211, 'lps'),
	(645973, 132, '2015-01-15 00:13:48.000000', 'consum', 0.0217, 'lps'),
	(645974, 132, '2015-01-15 00:13:49.000000', 'consum', 0.0219, 'lps'),
	(645975, 132, '2015-01-15 00:13:50.000000', 'consum', 0.0214, 'lps'),
	(645976, 132, '2015-01-15 00:13:51.000000', 'consum', 0.0213, 'lps'),
	(645977, 132, '2015-01-15 00:13:52.000000', 'consum', 0.0212, 'lps'),
	(645978, 132, '2015-01-15 00:13:53.000000', 'consum', 0.0212, 'lps'),
	(645979, 132, '2015-01-15 00:13:54.000000', 'consum', 0.0216, 'lps'),
	(645980, 132, '2015-01-15 00:13:55.000000', 'consum', 0.0211, 'lps'),
	(645981, 132, '2015-01-15 00:13:56.000000', 'consum', 0.0210, 'lps'),
	(645982, 132, '2015-01-15 00:13:57.000000', 'consum', 0.0216, 'lps'),
	(645983, 132, '2015-01-15 00:13:58.000000', 'consum', 0.0219, 'lps'),
	(645984, 132, '2015-01-15 00:13:59.000000', 'consum', 0.0217, 'lps'),
	(645985, 132, '2015-01-15 00:14:00.000000', 'consum', 0.0219, 'lps'),
	(645986, 132, '2015-01-15 00:14:01.000000', 'consum', 0.0213, 'lps'),
	(645987, 132, '2015-01-15 00:14:02.000000', 'consum', 0.0210, 'lps'),
	(645988, 132, '2015-01-15 00:14:03.000000', 'consum', 0.0213, 'lps'),
	(645989, 132, '2015-01-15 00:14:04.000000', 'consum', 0.0215, 'lps'),
	(645990, 132, '2015-01-15 00:14:05.000000', 'consum', 0.0216, 'lps'),
	(645991, 132, '2015-01-15 00:14:06.000000', 'consum', 0.0213, 'lps'),
	(645992, 132, '2015-01-15 00:14:07.000000', 'consum', 0.0220, 'lps'),
	(645993, 132, '2015-01-15 00:14:08.000000', 'consum', 0.0216, 'lps'),
	(645994, 132, '2015-01-15 00:14:09.000000', 'consum', 0.0210, 'lps'),
	(645995, 132, '2015-01-15 00:14:10.000000', 'consum', 0.0215, 'lps'),
	(645996, 132, '2015-01-15 00:14:11.000000', 'consum', 0.0216, 'lps'),
	(645997, 132, '2015-01-15 00:14:12.000000', 'consum', 0.0212, 'lps'),
	(645998, 132, '2015-01-15 00:14:13.000000', 'consum', 0.0214, 'lps'),
	(645999, 132, '2015-01-15 00:14:14.000000', 'consum', 0.0212, 'lps'),
	(646000, 132, '2015-01-15 00:14:15.000000', 'consum', 0.0210, 'lps'),
	(646001, 132, '2015-01-15 00:14:16.000000', 'consum', 0.0215, 'lps'),
	(646002, 132, '2015-01-15 00:14:17.000000', 'consum', 0.0212, 'lps'),
	(646003, 132, '2015-01-15 00:14:18.000000', 'consum', 0.0217, 'lps'),
	(646004, 132, '2015-01-15 00:14:19.000000', 'consum', 0.0219, 'lps'),
	(646005, 132, '2015-01-15 00:14:20.000000', 'consum', 0.0213, 'lps'),
	(646006, 132, '2015-01-15 00:14:21.000000', 'consum', 0.0219, 'lps'),
	(646007, 132, '2015-01-15 00:14:22.000000', 'consum', 0.0213, 'lps'),
	(646008, 132, '2015-01-15 00:14:23.000000', 'consum', 0.0210, 'lps'),
	(646009, 132, '2015-01-15 00:14:24.000000', 'consum', 0.0212, 'lps'),
	(646010, 132, '2015-01-15 00:14:25.000000', 'consum', 0.0210, 'lps'),
	(646011, 132, '2015-01-15 00:14:26.000000', 'consum', 0.0214, 'lps'),
	(646012, 132, '2015-01-15 00:14:27.000000', 'consum', 0.0219, 'lps'),
	(646013, 132, '2015-01-15 00:14:28.000000', 'consum', 0.0210, 'lps'),
	(646014, 132, '2015-01-15 00:14:29.000000', 'consum', 0.0216, 'lps'),
	(646015, 132, '2015-01-15 00:14:30.000000', 'consum', 0.0220, 'lps'),
	(646016, 132, '2015-01-15 00:14:31.000000', 'consum', 0.0219, 'lps'),
	(646017, 132, '2015-01-15 00:14:32.000000', 'consum', 0.0214, 'lps'),
	(646018, 132, '2015-01-15 00:14:33.000000', 'consum', 0.0214, 'lps'),
	(646019, 132, '2015-01-15 00:14:34.000000', 'consum', 0.0219, 'lps'),
	(646020, 132, '2015-01-15 00:14:35.000000', 'consum', 0.0220, 'lps'),
	(646021, 132, '2015-01-15 00:14:36.000000', 'consum', 0.0212, 'lps'),
	(646022, 132, '2015-01-15 00:14:37.000000', 'consum', 0.0214, 'lps'),
	(646023, 132, '2015-01-15 00:14:38.000000', 'consum', 0.0211, 'lps'),
	(646024, 132, '2015-01-15 00:14:39.000000', 'consum', 0.0217, 'lps'),
	(646025, 132, '2015-01-15 00:14:40.000000', 'consum', 0.0219, 'lps'),
	(646026, 132, '2015-01-15 00:14:41.000000', 'consum', 0.0212, 'lps'),
	(646027, 132, '2015-01-15 00:14:42.000000', 'consum', 0.0217, 'lps'),
	(646028, 132, '2015-01-15 00:14:43.000000', 'consum', 0.0215, 'lps'),
	(646029, 132, '2015-01-15 00:14:44.000000', 'consum', 0.0216, 'lps'),
	(646030, 132, '2015-01-15 00:14:45.000000', 'consum', 0.0212, 'lps'),
	(646031, 132, '2015-01-15 00:14:46.000000', 'consum', 0.0217, 'lps'),
	(646032, 132, '2015-01-15 00:14:47.000000', 'consum', 0.0216, 'lps'),
	(646033, 132, '2015-01-15 00:14:48.000000', 'consum', 0.0219, 'lps'),
	(646034, 132, '2015-01-15 00:14:49.000000', 'consum', 0.0215, 'lps'),
	(646035, 132, '2015-01-15 00:14:50.000000', 'consum', 0.0211, 'lps'),
	(646036, 132, '2015-01-15 00:14:51.000000', 'consum', 0.0220, 'lps'),
	(646037, 132, '2015-01-15 00:14:52.000000', 'consum', 0.0216, 'lps'),
	(646038, 132, '2015-01-15 00:14:53.000000', 'consum', 0.0220, 'lps'),
	(646039, 132, '2015-01-15 00:14:54.000000', 'consum', 0.0219, 'lps'),
	(646040, 132, '2015-01-15 00:14:55.000000', 'consum', 0.0218, 'lps'),
	(646041, 132, '2015-01-15 00:14:56.000000', 'consum', 0.0210, 'lps'),
	(646042, 132, '2015-01-15 00:14:57.000000', 'consum', 0.0220, 'lps'),
	(646043, 132, '2015-01-15 00:14:58.000000', 'consum', 0.0217, 'lps'),
	(646044, 132, '2015-01-15 00:14:59.000000', 'consum', 0.0217, 'lps'),
	(646045, 132, '2015-01-15 00:15:00.000000', 'consum', 0.0213, 'lps'),
	(646046, 132, '2015-01-15 00:15:01.000000', 'consum', 0.0214, 'lps'),
	(646047, 132, '2015-01-15 00:15:02.000000', 'consum', 0.0211, 'lps'),
	(646048, 132, '2015-01-15 00:15:03.000000', 'consum', 0.0216, 'lps'),
	(646049, 132, '2015-01-15 00:15:04.000000', 'consum', 0.0215, 'lps'),
	(646050, 132, '2015-01-15 00:15:05.000000', 'consum', 0.0216, 'lps'),
	(646051, 132, '2015-01-15 00:15:06.000000', 'consum', 0.0217, 'lps'),
	(646052, 132, '2015-01-15 00:15:07.000000', 'consum', 0.0213, 'lps'),
	(646053, 132, '2015-01-15 00:15:08.000000', 'consum', 0.0218, 'lps'),
	(646054, 132, '2015-01-15 00:15:09.000000', 'consum', 0.0210, 'lps'),
	(646055, 132, '2015-01-15 00:15:10.000000', 'consum', 0.0217, 'lps'),
	(646056, 132, '2015-01-15 00:15:11.000000', 'consum', 0.0211, 'lps'),
	(646057, 132, '2015-01-15 00:15:12.000000', 'consum', 0.0218, 'lps'),
	(646058, 132, '2015-01-15 00:15:13.000000', 'consum', 0.0217, 'lps'),
	(646059, 132, '2015-01-15 00:15:14.000000', 'consum', 0.0218, 'lps'),
	(646060, 132, '2015-01-15 00:15:15.000000', 'consum', 0.0219, 'lps'),
	(646061, 132, '2015-01-15 00:15:16.000000', 'consum', 0.0211, 'lps'),
	(646062, 132, '2015-01-15 00:15:17.000000', 'consum', 0.0212, 'lps'),
	(646063, 132, '2015-01-15 00:15:18.000000', 'consum', 0.0215, 'lps'),
	(646064, 132, '2015-01-15 00:15:19.000000', 'consum', 0.0219, 'lps'),
	(646065, 132, '2015-01-15 00:15:20.000000', 'consum', 0.0220, 'lps'),
	(646066, 132, '2015-01-15 00:15:21.000000', 'consum', 0.0211, 'lps'),
	(646067, 132, '2015-01-15 00:15:22.000000', 'consum', 0.0216, 'lps'),
	(646068, 132, '2015-01-15 00:15:23.000000', 'consum', 0.0219, 'lps'),
	(646069, 132, '2015-01-15 00:15:24.000000', 'consum', 0.0215, 'lps'),
	(646070, 132, '2015-01-15 00:15:25.000000', 'consum', 0.0217, 'lps'),
	(646071, 132, '2015-01-15 00:15:26.000000', 'consum', 0.0220, 'lps'),
	(646072, 132, '2015-01-15 00:15:27.000000', 'consum', 0.0218, 'lps'),
	(646073, 132, '2015-01-15 00:15:28.000000', 'consum', 0.0211, 'lps'),
	(646074, 132, '2015-01-15 00:15:29.000000', 'consum', 0.0213, 'lps'),
	(646075, 132, '2015-01-15 00:15:30.000000', 'consum', 0.0210, 'lps'),
	(646076, 132, '2015-01-15 00:15:31.000000', 'consum', 0.0212, 'lps'),
	(646077, 132, '2015-01-15 00:15:32.000000', 'consum', 0.0220, 'lps'),
	(646078, 132, '2015-01-15 00:15:33.000000', 'consum', 0.0211, 'lps'),
	(646079, 132, '2015-01-15 00:15:34.000000', 'consum', 0.0220, 'lps'),
	(646080, 132, '2015-01-15 00:15:35.000000', 'consum', 0.0214, 'lps'),
	(646081, 132, '2015-01-15 00:15:36.000000', 'consum', 0.0211, 'lps'),
	(646082, 132, '2015-01-15 00:15:37.000000', 'consum', 0.0216, 'lps'),
	(646083, 132, '2015-01-15 00:15:38.000000', 'consum', 0.0213, 'lps'),
	(646084, 132, '2015-01-15 00:15:39.000000', 'consum', 0.0220, 'lps'),
	(646085, 132, '2015-01-15 00:15:40.000000', 'consum', 0.0218, 'lps'),
	(646086, 132, '2015-01-15 00:15:41.000000', 'consum', 0.0219, 'lps'),
	(646087, 132, '2015-01-15 00:15:42.000000', 'consum', 0.0210, 'lps'),
	(646088, 132, '2015-01-15 00:15:43.000000', 'consum', 0.0219, 'lps'),
	(646089, 132, '2015-01-15 00:15:44.000000', 'consum', 0.0219, 'lps'),
	(646090, 132, '2015-01-15 00:15:45.000000', 'consum', 0.0210, 'lps'),
	(646091, 132, '2015-01-15 00:15:46.000000', 'consum', 0.0213, 'lps'),
	(646092, 132, '2015-01-15 00:15:47.000000', 'consum', 0.0218, 'lps'),
	(646093, 132, '2015-01-15 00:15:48.000000', 'consum', 0.0218, 'lps'),
	(646094, 132, '2015-01-15 00:15:49.000000', 'consum', 0.0216, 'lps'),
	(646095, 132, '2015-01-15 00:15:50.000000', 'consum', 0.0215, 'lps'),
	(646096, 132, '2015-01-15 00:15:51.000000', 'consum', 0.0217, 'lps'),
	(646097, 132, '2015-01-15 00:15:52.000000', 'consum', 0.0219, 'lps'),
	(646098, 132, '2015-01-15 00:15:53.000000', 'consum', 0.0213, 'lps'),
	(646099, 132, '2015-01-15 00:15:54.000000', 'consum', 0.0219, 'lps'),
	(646100, 132, '2015-01-15 00:15:55.000000', 'consum', 0.0215, 'lps'),
	(646101, 132, '2015-01-15 00:15:56.000000', 'consum', 0.0210, 'lps'),
	(646102, 132, '2015-01-15 00:15:57.000000', 'consum', 0.0218, 'lps'),
	(646103, 132, '2015-01-15 00:15:58.000000', 'consum', 0.0214, 'lps'),
	(646104, 132, '2015-01-15 00:15:59.000000', 'consum', 0.0220, 'lps'),
	(646105, 132, '2015-01-15 00:16:00.000000', 'consum', 0.0216, 'lps'),
	(646106, 132, '2015-01-15 00:16:01.000000', 'consum', 0.0220, 'lps'),
	(646107, 132, '2015-01-15 00:16:02.000000', 'consum', 0.0211, 'lps'),
	(646108, 132, '2015-01-15 00:16:03.000000', 'consum', 0.0218, 'lps'),
	(646109, 132, '2015-01-15 00:16:04.000000', 'consum', 0.0215, 'lps'),
	(646110, 132, '2015-01-15 00:16:05.000000', 'consum', 0.0212, 'lps'),
	(646111, 132, '2015-01-15 00:16:06.000000', 'consum', 0.0215, 'lps'),
	(646112, 132, '2015-01-15 00:16:07.000000', 'consum', 0.0219, 'lps'),
	(646113, 132, '2015-01-15 00:16:08.000000', 'consum', 0.0217, 'lps'),
	(646114, 132, '2015-01-15 00:16:09.000000', 'consum', 0.0218, 'lps'),
	(646115, 132, '2015-01-15 00:16:10.000000', 'consum', 0.0219, 'lps'),
	(646116, 132, '2015-01-15 00:16:11.000000', 'consum', 0.0211, 'lps'),
	(646117, 132, '2015-01-15 00:16:12.000000', 'consum', 0.0210, 'lps'),
	(646118, 132, '2015-01-15 00:16:13.000000', 'consum', 0.0217, 'lps'),
	(646119, 132, '2015-01-15 00:16:14.000000', 'consum', 0.0212, 'lps'),
	(646120, 132, '2015-01-15 00:16:15.000000', 'consum', 0.0213, 'lps'),
	(646121, 132, '2015-01-15 00:16:16.000000', 'consum', 0.0217, 'lps'),
	(646122, 132, '2015-01-15 00:16:17.000000', 'consum', 0.0217, 'lps'),
	(646123, 132, '2015-01-15 00:16:18.000000', 'consum', 0.0212, 'lps'),
	(646124, 132, '2015-01-15 00:16:19.000000', 'consum', 0.0220, 'lps'),
	(646125, 132, '2015-01-15 00:16:20.000000', 'consum', 0.0211, 'lps'),
	(646126, 132, '2015-01-15 00:16:21.000000', 'consum', 0.0210, 'lps'),
	(646127, 132, '2015-01-15 00:16:22.000000', 'consum', 0.0218, 'lps'),
	(646128, 132, '2015-01-15 00:16:23.000000', 'consum', 0.0215, 'lps'),
	(646129, 132, '2015-01-15 00:16:24.000000', 'consum', 0.0213, 'lps'),
	(646130, 132, '2015-01-15 00:16:25.000000', 'consum', 0.0219, 'lps'),
	(646131, 132, '2015-01-15 00:16:26.000000', 'consum', 0.0216, 'lps'),
	(646132, 132, '2015-01-15 00:16:27.000000', 'consum', 0.0214, 'lps'),
	(646133, 132, '2015-01-15 00:16:28.000000', 'consum', 0.0210, 'lps'),
	(646134, 132, '2015-01-15 00:16:29.000000', 'consum', 0.0210, 'lps'),
	(646135, 132, '2015-01-15 00:16:30.000000', 'consum', 0.0212, 'lps'),
	(646136, 132, '2015-01-15 00:16:31.000000', 'consum', 0.0218, 'lps'),
	(646137, 132, '2015-01-15 00:16:32.000000', 'consum', 0.0213, 'lps'),
	(646138, 132, '2015-01-15 00:16:33.000000', 'consum', 0.0214, 'lps'),
	(646139, 132, '2015-01-15 00:16:34.000000', 'consum', 0.0210, 'lps'),
	(646140, 132, '2015-01-15 00:16:35.000000', 'consum', 0.0211, 'lps'),
	(646141, 132, '2015-01-15 00:16:36.000000', 'consum', 0.0215, 'lps'),
	(646142, 132, '2015-01-15 00:16:37.000000', 'consum', 0.0210, 'lps'),
	(646143, 132, '2015-01-15 00:16:38.000000', 'consum', 0.0215, 'lps'),
	(646144, 132, '2015-01-15 00:16:39.000000', 'consum', 0.0217, 'lps'),
	(646145, 132, '2015-01-15 00:16:40.000000', 'consum', 0.0217, 'lps'),
	(646146, 132, '2015-01-15 00:16:41.000000', 'consum', 0.0214, 'lps'),
	(646147, 132, '2015-01-15 00:16:42.000000', 'consum', 0.0220, 'lps'),
	(646148, 132, '2015-01-15 00:16:43.000000', 'consum', 0.0218, 'lps'),
	(646149, 132, '2015-01-15 00:16:44.000000', 'consum', 0.0219, 'lps'),
	(646150, 132, '2015-01-15 00:16:45.000000', 'consum', 0.0211, 'lps'),
	(646151, 132, '2015-01-15 00:16:46.000000', 'consum', 0.0220, 'lps'),
	(646152, 132, '2015-01-15 00:16:47.000000', 'consum', 0.0213, 'lps'),
	(646153, 132, '2015-01-15 00:16:48.000000', 'consum', 0.0216, 'lps'),
	(646154, 132, '2015-01-15 00:16:49.000000', 'consum', 0.0211, 'lps'),
	(646155, 132, '2015-01-15 00:16:50.000000', 'consum', 0.0210, 'lps'),
	(646156, 132, '2015-01-15 00:16:51.000000', 'consum', 0.0218, 'lps'),
	(646157, 132, '2015-01-15 00:16:52.000000', 'consum', 0.0218, 'lps'),
	(646158, 132, '2015-01-15 00:16:53.000000', 'consum', 0.0217, 'lps'),
	(646159, 132, '2015-01-15 00:16:54.000000', 'consum', 0.0218, 'lps'),
	(646160, 132, '2015-01-15 00:16:55.000000', 'consum', 0.0210, 'lps'),
	(646161, 132, '2015-01-15 00:16:56.000000', 'consum', 0.0218, 'lps'),
	(646162, 132, '2015-01-15 00:16:57.000000', 'consum', 0.0218, 'lps'),
	(646163, 132, '2015-01-15 00:16:58.000000', 'consum', 0.0217, 'lps'),
	(646164, 132, '2015-01-15 00:16:59.000000', 'consum', 0.0210, 'lps'),
	(646165, 132, '2015-01-15 00:17:00.000000', 'consum', 0.0213, 'lps'),
	(646166, 132, '2015-01-15 00:17:01.000000', 'consum', 0.0212, 'lps'),
	(646167, 132, '2015-01-15 00:17:02.000000', 'consum', 0.0214, 'lps'),
	(646168, 132, '2015-01-15 00:17:03.000000', 'consum', 0.0214, 'lps'),
	(646169, 132, '2015-01-15 00:17:04.000000', 'consum', 0.0216, 'lps'),
	(646170, 132, '2015-01-15 00:17:05.000000', 'consum', 0.0217, 'lps'),
	(646171, 132, '2015-01-15 00:17:06.000000', 'consum', 0.0217, 'lps'),
	(646172, 132, '2015-01-15 00:17:07.000000', 'consum', 0.0214, 'lps'),
	(646173, 132, '2015-01-15 00:17:08.000000', 'consum', 0.0219, 'lps'),
	(646174, 132, '2015-01-15 00:17:09.000000', 'consum', 0.0210, 'lps'),
	(646175, 132, '2015-01-15 00:17:10.000000', 'consum', 0.0218, 'lps'),
	(646176, 132, '2015-01-15 00:17:11.000000', 'consum', 0.0215, 'lps'),
	(646177, 132, '2015-01-15 00:17:12.000000', 'consum', 0.0214, 'lps'),
	(646178, 132, '2015-01-15 00:17:13.000000', 'consum', 0.0215, 'lps'),
	(646179, 132, '2015-01-15 00:17:14.000000', 'consum', 0.0213, 'lps'),
	(646180, 132, '2015-01-15 00:17:15.000000', 'consum', 0.0210, 'lps'),
	(646181, 132, '2015-01-15 00:17:16.000000', 'consum', 0.0213, 'lps'),
	(646182, 132, '2015-01-15 00:17:17.000000', 'consum', 0.0215, 'lps'),
	(646183, 132, '2015-01-15 00:17:18.000000', 'consum', 0.0215, 'lps'),
	(646184, 132, '2015-01-15 00:17:19.000000', 'consum', 0.0220, 'lps'),
	(646185, 132, '2015-01-15 00:17:20.000000', 'consum', 0.0211, 'lps'),
	(646186, 132, '2015-01-15 00:17:21.000000', 'consum', 0.0210, 'lps'),
	(646187, 132, '2015-01-15 00:17:22.000000', 'consum', 0.0219, 'lps'),
	(646188, 132, '2015-01-15 00:17:23.000000', 'consum', 0.0213, 'lps'),
	(646189, 132, '2015-01-15 00:17:24.000000', 'consum', 0.0217, 'lps'),
	(646190, 132, '2015-01-15 00:17:25.000000', 'consum', 0.0215, 'lps'),
	(646191, 132, '2015-01-15 00:17:26.000000', 'consum', 0.0214, 'lps'),
	(646192, 132, '2015-01-15 00:17:27.000000', 'consum', 0.0216, 'lps'),
	(646193, 132, '2015-01-15 00:17:28.000000', 'consum', 0.0219, 'lps'),
	(646194, 132, '2015-01-15 00:17:29.000000', 'consum', 0.0216, 'lps'),
	(646195, 132, '2015-01-15 00:17:30.000000', 'consum', 0.0210, 'lps'),
	(646196, 132, '2015-01-15 00:17:31.000000', 'consum', 0.0218, 'lps'),
	(646197, 132, '2015-01-15 00:17:32.000000', 'consum', 0.0217, 'lps'),
	(646198, 132, '2015-01-15 00:17:33.000000', 'consum', 0.0211, 'lps'),
	(646199, 132, '2015-01-15 00:17:34.000000', 'consum', 0.0217, 'lps'),
	(646200, 132, '2015-01-15 00:17:35.000000', 'consum', 0.0210, 'lps'),
	(646201, 132, '2015-01-15 00:17:36.000000', 'consum', 0.0212, 'lps'),
	(646202, 132, '2015-01-15 00:17:37.000000', 'consum', 0.0210, 'lps'),
	(646203, 132, '2015-01-15 00:17:38.000000', 'consum', 0.0214, 'lps'),
	(646204, 132, '2015-01-15 00:17:39.000000', 'consum', 0.0219, 'lps'),
	(646205, 132, '2015-01-15 00:17:40.000000', 'consum', 0.0220, 'lps'),
	(646206, 132, '2015-01-15 00:17:41.000000', 'consum', 0.0214, 'lps'),
	(646207, 132, '2015-01-15 00:17:42.000000', 'consum', 0.0211, 'lps'),
	(646208, 132, '2015-01-15 00:17:43.000000', 'consum', 0.0215, 'lps'),
	(646209, 132, '2015-01-15 00:17:44.000000', 'consum', 0.0220, 'lps'),
	(646210, 132, '2015-01-15 00:17:45.000000', 'consum', 0.0211, 'lps'),
	(646211, 132, '2015-01-15 00:17:46.000000', 'consum', 0.0211, 'lps'),
	(646212, 132, '2015-01-15 00:17:47.000000', 'consum', 0.0210, 'lps'),
	(646213, 132, '2015-01-15 00:17:48.000000', 'consum', 0.0218, 'lps'),
	(646214, 132, '2015-01-15 00:17:49.000000', 'consum', 0.0220, 'lps'),
	(646215, 132, '2015-01-15 00:17:50.000000', 'consum', 0.0212, 'lps'),
	(646216, 132, '2015-01-15 00:17:51.000000', 'consum', 0.0212, 'lps'),
	(646217, 132, '2015-01-15 00:17:52.000000', 'consum', 0.0215, 'lps'),
	(646218, 132, '2015-01-15 00:17:53.000000', 'consum', 0.0218, 'lps'),
	(646219, 132, '2015-01-15 00:17:54.000000', 'consum', 0.0214, 'lps'),
	(646220, 132, '2015-01-15 00:17:55.000000', 'consum', 0.0219, 'lps'),
	(646221, 132, '2015-01-15 00:17:56.000000', 'consum', 0.0211, 'lps'),
	(646222, 132, '2015-01-15 00:17:57.000000', 'consum', 0.0219, 'lps'),
	(646223, 132, '2015-01-15 00:17:58.000000', 'consum', 0.0211, 'lps'),
	(646224, 132, '2015-01-15 00:17:59.000000', 'consum', 0.0210, 'lps'),
	(646225, 132, '2015-01-15 00:18:00.000000', 'consum', 0.0217, 'lps'),
	(646226, 132, '2015-01-15 00:18:01.000000', 'consum', 0.0214, 'lps'),
	(646227, 132, '2015-01-15 00:18:02.000000', 'consum', 0.0218, 'lps'),
	(646228, 132, '2015-01-15 00:18:03.000000', 'consum', 0.0220, 'lps'),
	(646229, 132, '2015-01-15 00:18:04.000000', 'consum', 0.0211, 'lps'),
	(646230, 132, '2015-01-15 00:18:05.000000', 'consum', 0.0211, 'lps'),
	(646231, 132, '2015-01-15 00:18:06.000000', 'consum', 0.0220, 'lps'),
	(646232, 132, '2015-01-15 00:18:07.000000', 'consum', 0.0216, 'lps'),
	(646233, 132, '2015-01-15 00:18:08.000000', 'consum', 0.0220, 'lps'),
	(646234, 132, '2015-01-15 00:18:09.000000', 'consum', 0.0210, 'lps'),
	(646235, 132, '2015-01-15 00:18:10.000000', 'consum', 0.0213, 'lps'),
	(646236, 132, '2015-01-15 00:18:11.000000', 'consum', 0.0216, 'lps'),
	(646237, 132, '2015-01-15 00:18:12.000000', 'consum', 0.0220, 'lps'),
	(646238, 132, '2015-01-15 00:18:13.000000', 'consum', 0.0219, 'lps'),
	(646239, 132, '2015-01-15 00:18:14.000000', 'consum', 0.0215, 'lps'),
	(646240, 132, '2015-01-15 00:18:15.000000', 'consum', 0.0220, 'lps'),
	(646241, 132, '2015-01-15 00:18:16.000000', 'consum', 0.0213, 'lps'),
	(646242, 132, '2015-01-15 00:18:17.000000', 'consum', 0.0216, 'lps'),
	(646243, 132, '2015-01-15 00:18:18.000000', 'consum', 0.0219, 'lps'),
	(646244, 132, '2015-01-15 00:18:19.000000', 'consum', 0.0218, 'lps'),
	(646245, 132, '2015-01-15 00:18:20.000000', 'consum', 0.0213, 'lps'),
	(646246, 132, '2015-01-15 00:18:21.000000', 'consum', 0.0210, 'lps'),
	(646247, 132, '2015-01-15 00:18:22.000000', 'consum', 0.0214, 'lps'),
	(646248, 132, '2015-01-15 00:18:23.000000', 'consum', 0.0218, 'lps'),
	(646249, 132, '2015-01-15 00:18:24.000000', 'consum', 0.0218, 'lps'),
	(646250, 132, '2015-01-15 00:18:25.000000', 'consum', 0.0213, 'lps'),
	(646251, 132, '2015-01-15 00:18:26.000000', 'consum', 0.0216, 'lps'),
	(646252, 132, '2015-01-15 00:18:27.000000', 'consum', 0.0219, 'lps'),
	(646253, 132, '2015-01-15 00:18:28.000000', 'consum', 0.0216, 'lps'),
	(646254, 132, '2015-01-15 00:18:29.000000', 'consum', 0.0212, 'lps'),
	(646255, 132, '2015-01-15 00:18:30.000000', 'consum', 0.0215, 'lps'),
	(646256, 132, '2015-01-15 00:18:31.000000', 'consum', 0.0216, 'lps'),
	(646257, 132, '2015-01-15 00:18:32.000000', 'consum', 0.0216, 'lps'),
	(646258, 132, '2015-01-15 00:18:33.000000', 'consum', 0.0211, 'lps'),
	(646259, 132, '2015-01-15 00:18:34.000000', 'consum', 0.0211, 'lps'),
	(646260, 132, '2015-01-15 00:18:35.000000', 'consum', 0.0220, 'lps'),
	(646261, 132, '2015-01-15 00:18:36.000000', 'consum', 0.0216, 'lps'),
	(646262, 132, '2015-01-15 00:18:37.000000', 'consum', 0.0219, 'lps'),
	(646263, 132, '2015-01-15 00:18:38.000000', 'consum', 0.0218, 'lps'),
	(646264, 132, '2015-01-15 00:18:39.000000', 'consum', 0.0211, 'lps'),
	(646265, 132, '2015-01-15 00:18:40.000000', 'consum', 0.0216, 'lps'),
	(646266, 132, '2015-01-15 00:18:41.000000', 'consum', 0.0212, 'lps'),
	(646267, 132, '2015-01-15 00:18:42.000000', 'consum', 0.0216, 'lps'),
	(646268, 132, '2015-01-15 00:18:43.000000', 'consum', 0.0211, 'lps'),
	(646269, 132, '2015-01-15 00:18:44.000000', 'consum', 0.0210, 'lps'),
	(646270, 132, '2015-01-15 00:18:45.000000', 'consum', 0.0217, 'lps'),
	(646271, 132, '2015-01-15 00:18:46.000000', 'consum', 0.0212, 'lps'),
	(646272, 132, '2015-01-15 00:18:47.000000', 'consum', 0.0211, 'lps'),
	(646273, 132, '2015-01-15 00:18:48.000000', 'consum', 0.0211, 'lps'),
	(646274, 132, '2015-01-15 00:18:49.000000', 'consum', 0.0212, 'lps'),
	(646275, 132, '2015-01-15 00:18:50.000000', 'consum', 0.0216, 'lps'),
	(646276, 132, '2015-01-15 00:18:51.000000', 'consum', 0.0213, 'lps'),
	(646277, 132, '2015-01-15 00:18:52.000000', 'consum', 0.0219, 'lps'),
	(646278, 132, '2015-01-15 00:18:53.000000', 'consum', 0.0213, 'lps'),
	(646279, 132, '2015-01-15 00:18:54.000000', 'consum', 0.0210, 'lps'),
	(646280, 132, '2015-01-15 00:18:55.000000', 'consum', 0.0213, 'lps'),
	(646281, 132, '2015-01-15 00:18:56.000000', 'consum', 0.0214, 'lps'),
	(646282, 132, '2015-01-15 00:18:57.000000', 'consum', 0.0220, 'lps'),
	(646283, 132, '2015-01-15 00:18:58.000000', 'consum', 0.0218, 'lps'),
	(646284, 132, '2015-01-15 00:18:59.000000', 'consum', 0.0219, 'lps'),
	(646285, 132, '2015-01-15 00:19:00.000000', 'consum', 0.0211, 'lps'),
	(646286, 132, '2015-01-15 00:19:01.000000', 'consum', 0.0220, 'lps'),
	(646287, 132, '2015-01-15 00:19:02.000000', 'consum', 0.0212, 'lps'),
	(646288, 132, '2015-01-15 00:19:03.000000', 'consum', 0.0215, 'lps'),
	(646289, 132, '2015-01-15 00:19:04.000000', 'consum', 0.0216, 'lps'),
	(646290, 132, '2015-01-15 00:19:05.000000', 'consum', 0.0215, 'lps'),
	(646291, 132, '2015-01-15 00:19:06.000000', 'consum', 0.0217, 'lps'),
	(646292, 132, '2015-01-15 00:19:07.000000', 'consum', 0.0211, 'lps'),
	(646293, 132, '2015-01-15 00:19:08.000000', 'consum', 0.0214, 'lps'),
	(646294, 132, '2015-01-15 00:19:09.000000', 'consum', 0.0216, 'lps'),
	(646295, 132, '2015-01-15 00:19:10.000000', 'consum', 0.0218, 'lps'),
	(646296, 132, '2015-01-15 00:19:11.000000', 'consum', 0.0211, 'lps'),
	(646297, 132, '2015-01-15 00:19:12.000000', 'consum', 0.0212, 'lps'),
	(646298, 132, '2015-01-15 00:19:13.000000', 'consum', 0.0218, 'lps'),
	(646299, 132, '2015-01-15 00:19:14.000000', 'consum', 0.0212, 'lps'),
	(646300, 132, '2015-01-15 00:19:15.000000', 'consum', 0.0217, 'lps'),
	(646301, 132, '2015-01-15 00:19:16.000000', 'consum', 0.0219, 'lps'),
	(646302, 132, '2015-01-15 00:19:17.000000', 'consum', 0.0213, 'lps'),
	(646303, 132, '2015-01-15 00:19:18.000000', 'consum', 0.0220, 'lps'),
	(646304, 132, '2015-01-15 00:19:19.000000', 'consum', 0.0217, 'lps'),
	(646305, 132, '2015-01-15 00:19:20.000000', 'consum', 0.0216, 'lps'),
	(646306, 132, '2015-01-15 00:19:21.000000', 'consum', 0.0210, 'lps'),
	(646307, 132, '2015-01-15 00:19:22.000000', 'consum', 0.0213, 'lps'),
	(646308, 132, '2015-01-15 00:19:23.000000', 'consum', 0.0215, 'lps'),
	(646309, 132, '2015-01-15 00:19:24.000000', 'consum', 0.0214, 'lps'),
	(646310, 132, '2015-01-15 00:19:25.000000', 'consum', 0.0216, 'lps'),
	(646311, 132, '2015-01-15 00:19:26.000000', 'consum', 0.0218, 'lps'),
	(646312, 132, '2015-01-15 00:19:27.000000', 'consum', 0.0212, 'lps'),
	(646313, 132, '2015-01-15 00:19:28.000000', 'consum', 0.0219, 'lps'),
	(646314, 132, '2015-01-15 00:19:29.000000', 'consum', 0.0216, 'lps'),
	(646315, 132, '2015-01-15 00:19:30.000000', 'consum', 0.0214, 'lps'),
	(646316, 132, '2015-01-15 00:19:31.000000', 'consum', 0.0210, 'lps'),
	(646317, 132, '2015-01-15 00:19:32.000000', 'consum', 0.0212, 'lps'),
	(646318, 132, '2015-01-15 00:19:33.000000', 'consum', 0.0220, 'lps'),
	(646319, 132, '2015-01-15 00:19:34.000000', 'consum', 0.0220, 'lps'),
	(646320, 132, '2015-01-15 00:19:35.000000', 'consum', 0.0210, 'lps'),
	(646321, 132, '2015-01-15 00:19:36.000000', 'consum', 0.0211, 'lps'),
	(646322, 132, '2015-01-15 00:19:37.000000', 'consum', 0.0218, 'lps'),
	(646323, 132, '2015-01-15 00:19:38.000000', 'consum', 0.0216, 'lps'),
	(646324, 132, '2015-01-15 00:19:39.000000', 'consum', 0.0213, 'lps'),
	(646325, 132, '2015-01-15 00:19:40.000000', 'consum', 0.0220, 'lps'),
	(646326, 132, '2015-01-15 00:19:41.000000', 'consum', 0.0217, 'lps'),
	(646327, 132, '2015-01-15 00:19:42.000000', 'consum', 0.0217, 'lps'),
	(646328, 132, '2015-01-15 00:19:43.000000', 'consum', 0.0214, 'lps'),
	(646329, 132, '2015-01-15 00:19:44.000000', 'consum', 0.0210, 'lps'),
	(646330, 132, '2015-01-15 00:19:45.000000', 'consum', 0.0220, 'lps'),
	(646331, 132, '2015-01-15 00:19:46.000000', 'consum', 0.0214, 'lps'),
	(646332, 132, '2015-01-15 00:19:47.000000', 'consum', 0.0215, 'lps'),
	(646333, 132, '2015-01-15 00:19:48.000000', 'consum', 0.0211, 'lps'),
	(646334, 132, '2015-01-15 00:19:49.000000', 'consum', 0.0213, 'lps'),
	(646335, 132, '2015-01-15 00:19:50.000000', 'consum', 0.0213, 'lps'),
	(646336, 132, '2015-01-15 00:19:51.000000', 'consum', 0.0213, 'lps'),
	(646337, 132, '2015-01-15 00:19:52.000000', 'consum', 0.0219, 'lps'),
	(646338, 132, '2015-01-15 00:19:53.000000', 'consum', 0.0212, 'lps'),
	(646339, 132, '2015-01-15 00:19:54.000000', 'consum', 0.0215, 'lps'),
	(646340, 132, '2015-01-15 00:19:55.000000', 'consum', 0.0218, 'lps'),
	(646341, 132, '2015-01-15 00:19:56.000000', 'consum', 0.0215, 'lps'),
	(646342, 132, '2015-01-15 00:19:57.000000', 'consum', 0.0213, 'lps'),
	(646343, 132, '2015-01-15 00:19:58.000000', 'consum', 0.0220, 'lps'),
	(646344, 132, '2015-01-15 00:19:59.000000', 'consum', 0.0217, 'lps'),
	(646345, 132, '2015-01-15 00:20:00.000000', 'consum', 0.0217, 'lps'),
	(646346, 132, '2015-01-15 00:20:01.000000', 'consum', 0.0212, 'lps'),
	(646347, 132, '2015-01-15 00:20:02.000000', 'consum', 0.0211, 'lps'),
	(646348, 132, '2015-01-15 00:20:03.000000', 'consum', 0.0211, 'lps'),
	(646349, 132, '2015-01-15 00:20:04.000000', 'consum', 0.0214, 'lps'),
	(646350, 132, '2015-01-15 00:20:05.000000', 'consum', 0.0214, 'lps'),
	(646351, 132, '2015-01-15 00:20:06.000000', 'consum', 0.0218, 'lps'),
	(646352, 132, '2015-01-15 00:20:07.000000', 'consum', 0.0219, 'lps'),
	(646353, 132, '2015-01-15 00:20:08.000000', 'consum', 0.0218, 'lps'),
	(646354, 132, '2015-01-15 00:20:09.000000', 'consum', 0.0212, 'lps'),
	(646355, 132, '2015-01-15 00:20:10.000000', 'consum', 0.0218, 'lps'),
	(646356, 132, '2015-01-15 00:20:11.000000', 'consum', 0.0214, 'lps'),
	(646357, 132, '2015-01-15 00:20:12.000000', 'consum', 0.0216, 'lps'),
	(646358, 132, '2015-01-15 00:20:13.000000', 'consum', 0.0216, 'lps'),
	(646359, 132, '2015-01-15 00:20:14.000000', 'consum', 0.0212, 'lps'),
	(646360, 132, '2015-01-15 00:20:15.000000', 'consum', 0.0214, 'lps'),
	(646361, 132, '2015-01-15 00:20:16.000000', 'consum', 0.0215, 'lps'),
	(646362, 132, '2015-01-15 00:20:17.000000', 'consum', 0.0212, 'lps'),
	(646363, 132, '2015-01-15 00:20:18.000000', 'consum', 0.0217, 'lps'),
	(646364, 132, '2015-01-15 00:20:19.000000', 'consum', 0.0217, 'lps'),
	(646365, 132, '2015-01-15 00:20:20.000000', 'consum', 0.0215, 'lps'),
	(646366, 132, '2015-01-15 00:20:21.000000', 'consum', 0.0215, 'lps'),
	(646367, 132, '2015-01-15 00:20:22.000000', 'consum', 0.0218, 'lps'),
	(646368, 132, '2015-01-15 00:20:23.000000', 'consum', 0.0216, 'lps'),
	(646369, 132, '2015-01-15 00:20:24.000000', 'consum', 0.0214, 'lps'),
	(646370, 132, '2015-01-15 00:20:25.000000', 'consum', 0.0212, 'lps'),
	(646371, 132, '2015-01-15 00:20:26.000000', 'consum', 0.0212, 'lps'),
	(646372, 132, '2015-01-15 00:20:27.000000', 'consum', 0.0211, 'lps'),
	(646373, 132, '2015-01-15 00:20:28.000000', 'consum', 0.0212, 'lps'),
	(646374, 132, '2015-01-15 00:20:29.000000', 'consum', 0.0218, 'lps'),
	(646375, 132, '2015-01-15 00:20:30.000000', 'consum', 0.0210, 'lps'),
	(646376, 132, '2015-01-15 00:20:31.000000', 'consum', 0.0218, 'lps'),
	(646377, 132, '2015-01-15 00:20:32.000000', 'consum', 0.0218, 'lps'),
	(646378, 132, '2015-01-15 00:20:33.000000', 'consum', 0.0218, 'lps'),
	(646379, 132, '2015-01-15 00:20:34.000000', 'consum', 0.0214, 'lps'),
	(646380, 132, '2015-01-15 00:20:35.000000', 'consum', 0.0217, 'lps'),
	(646381, 132, '2015-01-15 00:20:36.000000', 'consum', 0.0211, 'lps'),
	(646382, 132, '2015-01-15 00:20:37.000000', 'consum', 0.0217, 'lps'),
	(646383, 132, '2015-01-15 00:20:38.000000', 'consum', 0.0211, 'lps'),
	(646384, 132, '2015-01-15 00:20:39.000000', 'consum', 0.0215, 'lps'),
	(646385, 132, '2015-01-15 00:20:40.000000', 'consum', 0.0213, 'lps'),
	(646386, 132, '2015-01-15 00:20:41.000000', 'consum', 0.0219, 'lps'),
	(646387, 132, '2015-01-15 00:20:42.000000', 'consum', 0.0214, 'lps'),
	(646388, 132, '2015-01-15 00:20:43.000000', 'consum', 0.0215, 'lps'),
	(646389, 132, '2015-01-15 00:20:44.000000', 'consum', 0.0211, 'lps'),
	(646390, 132, '2015-01-15 00:20:45.000000', 'consum', 0.0212, 'lps'),
	(646391, 132, '2015-01-15 00:20:46.000000', 'consum', 0.0218, 'lps'),
	(646392, 132, '2015-01-15 00:20:47.000000', 'consum', 0.0212, 'lps'),
	(646393, 132, '2015-01-15 00:20:48.000000', 'consum', 0.0219, 'lps'),
	(646394, 132, '2015-01-15 00:20:49.000000', 'consum', 0.0218, 'lps'),
	(646395, 132, '2015-01-15 00:20:50.000000', 'consum', 0.0210, 'lps'),
	(646396, 132, '2015-01-15 00:20:51.000000', 'consum', 0.0218, 'lps'),
	(646397, 132, '2015-01-15 00:20:52.000000', 'consum', 0.0219, 'lps'),
	(646398, 132, '2015-01-15 00:20:53.000000', 'consum', 0.0210, 'lps'),
	(646399, 132, '2015-01-15 00:20:54.000000', 'consum', 0.0218, 'lps'),
	(646400, 132, '2015-01-15 00:20:55.000000', 'consum', 0.0217, 'lps'),
	(646401, 132, '2015-01-15 00:20:56.000000', 'consum', 0.0210, 'lps'),
	(646402, 132, '2015-01-15 00:20:57.000000', 'consum', 0.0213, 'lps'),
	(646403, 132, '2015-01-15 00:20:58.000000', 'consum', 0.0214, 'lps'),
	(646404, 132, '2015-01-15 00:20:59.000000', 'consum', 0.0219, 'lps'),
	(646405, 132, '2015-01-15 00:21:00.000000', 'consum', 0.0213, 'lps'),
	(646406, 132, '2015-01-15 00:21:01.000000', 'consum', 0.0220, 'lps'),
	(646407, 132, '2015-01-15 00:21:02.000000', 'consum', 0.0220, 'lps'),
	(646408, 132, '2015-01-15 00:21:03.000000', 'consum', 0.0217, 'lps'),
	(646409, 132, '2015-01-15 00:21:04.000000', 'consum', 0.0218, 'lps'),
	(646410, 132, '2015-01-15 00:21:05.000000', 'consum', 0.0218, 'lps'),
	(646411, 132, '2015-01-15 00:21:06.000000', 'consum', 0.0216, 'lps'),
	(646412, 132, '2015-01-15 00:21:07.000000', 'consum', 0.0216, 'lps'),
	(646413, 132, '2015-01-15 00:21:08.000000', 'consum', 0.0213, 'lps'),
	(646414, 132, '2015-01-15 00:21:09.000000', 'consum', 0.0218, 'lps'),
	(646415, 132, '2015-01-15 00:21:10.000000', 'consum', 0.0220, 'lps'),
	(646416, 132, '2015-01-15 00:21:11.000000', 'consum', 0.0216, 'lps'),
	(646417, 132, '2015-01-15 00:21:12.000000', 'consum', 0.0219, 'lps'),
	(646418, 132, '2015-01-15 00:21:13.000000', 'consum', 0.0215, 'lps'),
	(646419, 132, '2015-01-15 00:21:14.000000', 'consum', 0.0211, 'lps'),
	(646420, 132, '2015-01-15 00:21:15.000000', 'consum', 0.0210, 'lps'),
	(646421, 132, '2015-01-15 00:21:16.000000', 'consum', 0.0220, 'lps'),
	(646422, 132, '2015-01-15 00:21:17.000000', 'consum', 0.0215, 'lps'),
	(646423, 132, '2015-01-15 00:21:18.000000', 'consum', 0.0217, 'lps'),
	(646424, 132, '2015-01-15 00:21:19.000000', 'consum', 0.0210, 'lps'),
	(646425, 132, '2015-01-15 00:21:20.000000', 'consum', 0.0212, 'lps'),
	(646426, 132, '2015-01-15 00:21:21.000000', 'consum', 0.0219, 'lps'),
	(646427, 132, '2015-01-15 00:21:22.000000', 'consum', 0.0216, 'lps'),
	(646428, 132, '2015-01-15 00:21:23.000000', 'consum', 0.0216, 'lps'),
	(646429, 132, '2015-01-15 00:21:24.000000', 'consum', 0.0220, 'lps'),
	(646430, 132, '2015-01-15 00:21:25.000000', 'consum', 0.0210, 'lps'),
	(646431, 132, '2015-01-15 00:21:26.000000', 'consum', 0.0214, 'lps'),
	(646432, 132, '2015-01-15 00:21:27.000000', 'consum', 0.0210, 'lps'),
	(646433, 132, '2015-01-15 00:21:28.000000', 'consum', 0.0219, 'lps'),
	(646434, 132, '2015-01-15 00:21:29.000000', 'consum', 0.0214, 'lps'),
	(646435, 132, '2015-01-15 00:21:30.000000', 'consum', 0.0212, 'lps'),
	(646436, 132, '2015-01-15 00:21:31.000000', 'consum', 0.0220, 'lps'),
	(646437, 132, '2015-01-15 00:21:32.000000', 'consum', 0.0211, 'lps'),
	(646438, 132, '2015-01-15 00:21:33.000000', 'consum', 0.0219, 'lps'),
	(646439, 132, '2015-01-15 00:21:34.000000', 'consum', 0.0218, 'lps'),
	(646440, 132, '2015-01-15 00:21:35.000000', 'consum', 0.0214, 'lps'),
	(646441, 132, '2015-01-15 00:21:36.000000', 'consum', 0.0218, 'lps'),
	(646442, 132, '2015-01-15 00:21:37.000000', 'consum', 0.0217, 'lps'),
	(646443, 132, '2015-01-15 00:21:38.000000', 'consum', 0.0220, 'lps'),
	(646444, 132, '2015-01-15 00:21:39.000000', 'consum', 0.0218, 'lps'),
	(646445, 132, '2015-01-15 00:21:40.000000', 'consum', 0.0210, 'lps'),
	(646446, 132, '2015-01-15 00:21:41.000000', 'consum', 0.0210, 'lps'),
	(646447, 132, '2015-01-15 00:21:42.000000', 'consum', 0.0210, 'lps'),
	(646448, 132, '2015-01-15 00:21:43.000000', 'consum', 0.0211, 'lps'),
	(646449, 132, '2015-01-15 00:21:44.000000', 'consum', 0.0216, 'lps'),
	(646450, 132, '2015-01-15 00:21:45.000000', 'consum', 0.0216, 'lps'),
	(646451, 132, '2015-01-15 00:21:46.000000', 'consum', 0.0212, 'lps'),
	(646452, 132, '2015-01-15 00:21:47.000000', 'consum', 0.0213, 'lps'),
	(646453, 132, '2015-01-15 00:21:48.000000', 'consum', 0.0218, 'lps'),
	(646454, 132, '2015-01-15 00:21:49.000000', 'consum', 0.0211, 'lps'),
	(646455, 132, '2015-01-15 00:21:50.000000', 'consum', 0.0211, 'lps'),
	(646456, 132, '2015-01-15 00:21:51.000000', 'consum', 0.0215, 'lps'),
	(646457, 132, '2015-01-15 00:21:52.000000', 'consum', 0.0210, 'lps'),
	(646458, 132, '2015-01-15 00:21:53.000000', 'consum', 0.0217, 'lps'),
	(646459, 132, '2015-01-15 00:21:54.000000', 'consum', 0.0211, 'lps'),
	(646460, 132, '2015-01-15 00:21:55.000000', 'consum', 0.0218, 'lps'),
	(646461, 132, '2015-01-15 00:21:56.000000', 'consum', 0.0216, 'lps'),
	(646462, 132, '2015-01-15 00:21:57.000000', 'consum', 0.0215, 'lps'),
	(646463, 132, '2015-01-15 00:21:58.000000', 'consum', 0.0219, 'lps'),
	(646464, 132, '2015-01-15 00:21:59.000000', 'consum', 0.0216, 'lps'),
	(646465, 132, '2015-01-15 00:22:00.000000', 'consum', 0.0215, 'lps'),
	(646466, 132, '2015-01-15 00:22:01.000000', 'consum', 0.0215, 'lps'),
	(646467, 132, '2015-01-15 00:22:02.000000', 'consum', 0.0213, 'lps'),
	(646468, 132, '2015-01-15 00:22:03.000000', 'consum', 0.0218, 'lps'),
	(646469, 132, '2015-01-15 00:22:04.000000', 'consum', 0.0212, 'lps'),
	(646470, 132, '2015-01-15 00:22:05.000000', 'consum', 0.0217, 'lps'),
	(646471, 132, '2015-01-15 00:22:06.000000', 'consum', 0.0217, 'lps'),
	(646472, 132, '2015-01-15 00:22:07.000000', 'consum', 0.0216, 'lps'),
	(646473, 132, '2015-01-15 00:22:08.000000', 'consum', 0.0218, 'lps'),
	(646474, 132, '2015-01-15 00:22:09.000000', 'consum', 0.0210, 'lps'),
	(646475, 132, '2015-01-15 00:22:10.000000', 'consum', 0.0220, 'lps'),
	(646476, 132, '2015-01-15 00:22:11.000000', 'consum', 0.0217, 'lps'),
	(646477, 132, '2015-01-15 00:22:12.000000', 'consum', 0.0216, 'lps'),
	(646478, 132, '2015-01-15 00:22:13.000000', 'consum', 0.0219, 'lps'),
	(646479, 132, '2015-01-15 00:22:14.000000', 'consum', 0.0218, 'lps'),
	(646480, 132, '2015-01-15 00:22:15.000000', 'consum', 0.0220, 'lps'),
	(646481, 132, '2015-01-15 00:22:16.000000', 'consum', 0.0214, 'lps'),
	(646482, 132, '2015-01-15 00:22:17.000000', 'consum', 0.0212, 'lps'),
	(646483, 132, '2015-01-15 00:22:18.000000', 'consum', 0.0219, 'lps'),
	(646484, 132, '2015-01-15 00:22:19.000000', 'consum', 0.0216, 'lps'),
	(646485, 132, '2015-01-15 00:22:20.000000', 'consum', 0.0213, 'lps'),
	(646486, 132, '2015-01-15 00:22:21.000000', 'consum', 0.0220, 'lps'),
	(646487, 132, '2015-01-15 00:22:22.000000', 'consum', 0.0217, 'lps'),
	(646488, 132, '2015-01-15 00:22:23.000000', 'consum', 0.0216, 'lps'),
	(646489, 132, '2015-01-15 00:22:24.000000', 'consum', 0.0218, 'lps'),
	(646490, 132, '2015-01-15 00:22:25.000000', 'consum', 0.0213, 'lps'),
	(646491, 132, '2015-01-15 00:22:26.000000', 'consum', 0.0210, 'lps'),
	(646492, 132, '2015-01-15 00:22:27.000000', 'consum', 0.0216, 'lps'),
	(646493, 132, '2015-01-15 00:22:28.000000', 'consum', 0.0215, 'lps'),
	(646494, 132, '2015-01-15 00:22:29.000000', 'consum', 0.0217, 'lps'),
	(646495, 132, '2015-01-15 00:22:30.000000', 'consum', 0.0212, 'lps'),
	(646496, 132, '2015-01-15 00:22:31.000000', 'consum', 0.0218, 'lps'),
	(646497, 132, '2015-01-15 00:22:32.000000', 'consum', 0.0212, 'lps'),
	(646498, 132, '2015-01-15 00:22:33.000000', 'consum', 0.0219, 'lps'),
	(646499, 132, '2015-01-15 00:22:34.000000', 'consum', 0.0219, 'lps'),
	(646500, 132, '2015-01-15 00:22:35.000000', 'consum', 0.0214, 'lps'),
	(646501, 132, '2015-01-15 00:22:36.000000', 'consum', 0.0215, 'lps'),
	(646502, 132, '2015-01-15 00:22:37.000000', 'consum', 0.0211, 'lps'),
	(646503, 132, '2015-01-15 00:22:38.000000', 'consum', 0.0215, 'lps'),
	(646504, 132, '2015-01-15 00:22:39.000000', 'consum', 0.0219, 'lps'),
	(646505, 132, '2015-01-15 00:22:40.000000', 'consum', 0.0210, 'lps'),
	(646506, 132, '2015-01-15 00:22:41.000000', 'consum', 0.0215, 'lps'),
	(646507, 132, '2015-01-15 00:22:42.000000', 'consum', 0.0212, 'lps'),
	(646508, 132, '2015-01-15 00:22:43.000000', 'consum', 0.0218, 'lps'),
	(646509, 132, '2015-01-15 00:22:44.000000', 'consum', 0.0220, 'lps'),
	(646510, 132, '2015-01-15 00:22:45.000000', 'consum', 0.0217, 'lps'),
	(646511, 132, '2015-01-15 00:22:46.000000', 'consum', 0.0214, 'lps'),
	(646512, 132, '2015-01-15 00:22:47.000000', 'consum', 0.0220, 'lps'),
	(646513, 132, '2015-01-15 00:22:48.000000', 'consum', 0.0218, 'lps'),
	(646514, 132, '2015-01-15 00:22:49.000000', 'consum', 0.0218, 'lps'),
	(646515, 132, '2015-01-15 00:22:50.000000', 'consum', 0.0217, 'lps'),
	(646516, 132, '2015-01-15 00:22:51.000000', 'consum', 0.0220, 'lps'),
	(646517, 132, '2015-01-15 00:22:52.000000', 'consum', 0.0219, 'lps'),
	(646518, 132, '2015-01-15 00:22:53.000000', 'consum', 0.0213, 'lps'),
	(646519, 132, '2015-01-15 00:22:54.000000', 'consum', 0.0212, 'lps'),
	(646520, 132, '2015-01-15 00:22:55.000000', 'consum', 0.0211, 'lps'),
	(646521, 132, '2015-01-15 00:22:56.000000', 'consum', 0.0211, 'lps'),
	(646522, 132, '2015-01-15 00:22:57.000000', 'consum', 0.0210, 'lps'),
	(646523, 132, '2015-01-15 00:22:58.000000', 'consum', 0.0219, 'lps'),
	(646524, 132, '2015-01-15 00:22:59.000000', 'consum', 0.0213, 'lps'),
	(646525, 132, '2015-01-15 00:23:00.000000', 'consum', 0.0219, 'lps'),
	(646526, 132, '2015-01-15 00:23:01.000000', 'consum', 0.0212, 'lps'),
	(646527, 132, '2015-01-15 00:23:02.000000', 'consum', 0.0219, 'lps'),
	(646528, 132, '2015-01-15 00:23:03.000000', 'consum', 0.0215, 'lps'),
	(646529, 132, '2015-01-15 00:23:04.000000', 'consum', 0.0218, 'lps'),
	(646530, 132, '2015-01-15 00:23:05.000000', 'consum', 0.0215, 'lps'),
	(646531, 132, '2015-01-15 00:23:06.000000', 'consum', 0.0220, 'lps'),
	(646532, 132, '2015-01-15 00:23:07.000000', 'consum', 0.0214, 'lps'),
	(646533, 132, '2015-01-15 00:23:08.000000', 'consum', 0.0212, 'lps'),
	(646534, 132, '2015-01-15 00:23:09.000000', 'consum', 0.0220, 'lps'),
	(646535, 132, '2015-01-15 00:23:10.000000', 'consum', 0.0219, 'lps'),
	(646536, 132, '2015-01-15 00:23:11.000000', 'consum', 0.0217, 'lps'),
	(646537, 132, '2015-01-15 00:23:12.000000', 'consum', 0.0218, 'lps'),
	(646538, 132, '2015-01-15 00:23:13.000000', 'consum', 0.0220, 'lps'),
	(646539, 132, '2015-01-15 00:23:14.000000', 'consum', 0.0214, 'lps'),
	(646540, 132, '2015-01-15 00:23:15.000000', 'consum', 0.0210, 'lps'),
	(646541, 132, '2015-01-15 00:23:16.000000', 'consum', 0.0220, 'lps'),
	(646542, 132, '2015-01-15 00:23:17.000000', 'consum', 0.0218, 'lps'),
	(646543, 132, '2015-01-15 00:23:18.000000', 'consum', 0.0219, 'lps'),
	(646544, 132, '2015-01-15 00:23:19.000000', 'consum', 0.0210, 'lps'),
	(646545, 132, '2015-01-15 00:23:20.000000', 'consum', 0.0218, 'lps'),
	(646546, 132, '2015-01-15 00:23:21.000000', 'consum', 0.0216, 'lps'),
	(646547, 132, '2015-01-15 00:23:22.000000', 'consum', 0.0216, 'lps'),
	(646548, 132, '2015-01-15 00:23:23.000000', 'consum', 0.0211, 'lps'),
	(646549, 132, '2015-01-15 00:23:24.000000', 'consum', 0.0220, 'lps'),
	(646550, 132, '2015-01-15 00:23:25.000000', 'consum', 0.0214, 'lps'),
	(646551, 132, '2015-01-15 00:23:26.000000', 'consum', 0.0212, 'lps'),
	(646552, 132, '2015-01-15 00:23:27.000000', 'consum', 0.0217, 'lps'),
	(646553, 132, '2015-01-15 00:23:28.000000', 'consum', 0.0220, 'lps'),
	(646554, 132, '2015-01-15 00:23:29.000000', 'consum', 0.0218, 'lps'),
	(646555, 132, '2015-01-15 00:23:30.000000', 'consum', 0.0220, 'lps'),
	(646556, 132, '2015-01-15 00:23:31.000000', 'consum', 0.0215, 'lps'),
	(646557, 132, '2015-01-15 00:23:32.000000', 'consum', 0.0216, 'lps'),
	(646558, 132, '2015-01-15 00:23:33.000000', 'consum', 0.0213, 'lps'),
	(646559, 132, '2015-01-15 00:23:34.000000', 'consum', 0.0219, 'lps'),
	(646560, 132, '2015-01-15 00:23:35.000000', 'consum', 0.0214, 'lps'),
	(646561, 132, '2015-01-15 00:23:36.000000', 'consum', 0.0213, 'lps'),
	(646562, 132, '2015-01-15 00:23:37.000000', 'consum', 0.0213, 'lps'),
	(646563, 132, '2015-01-15 00:23:38.000000', 'consum', 0.0216, 'lps'),
	(646564, 132, '2015-01-15 00:23:39.000000', 'consum', 0.0212, 'lps'),
	(646565, 132, '2015-01-15 00:23:40.000000', 'consum', 0.0212, 'lps'),
	(646566, 132, '2015-01-15 00:23:41.000000', 'consum', 0.0216, 'lps'),
	(646567, 132, '2015-01-15 00:23:42.000000', 'consum', 0.0211, 'lps'),
	(646568, 132, '2015-01-15 00:23:43.000000', 'consum', 0.0210, 'lps'),
	(646569, 132, '2015-01-15 00:23:44.000000', 'consum', 0.0218, 'lps'),
	(646570, 132, '2015-01-15 00:23:45.000000', 'consum', 0.0218, 'lps'),
	(646571, 132, '2015-01-15 00:23:46.000000', 'consum', 0.0217, 'lps'),
	(646572, 132, '2015-01-15 00:23:47.000000', 'consum', 0.0220, 'lps'),
	(646573, 132, '2015-01-15 00:23:48.000000', 'consum', 0.0217, 'lps'),
	(646574, 132, '2015-01-15 00:23:49.000000', 'consum', 0.0215, 'lps'),
	(646575, 132, '2015-01-15 00:23:50.000000', 'consum', 0.0215, 'lps'),
	(646576, 132, '2015-01-15 00:23:51.000000', 'consum', 0.0211, 'lps'),
	(646577, 132, '2015-01-15 00:23:52.000000', 'consum', 0.0212, 'lps'),
	(646578, 132, '2015-01-15 00:23:53.000000', 'consum', 0.0217, 'lps'),
	(646579, 132, '2015-01-15 00:23:54.000000', 'consum', 0.0216, 'lps'),
	(646580, 132, '2015-01-15 00:23:55.000000', 'consum', 0.0210, 'lps'),
	(646581, 132, '2015-01-15 00:23:56.000000', 'consum', 0.0214, 'lps'),
	(646582, 132, '2015-01-15 00:23:57.000000', 'consum', 0.0210, 'lps'),
	(646583, 132, '2015-01-15 00:23:58.000000', 'consum', 0.0219, 'lps'),
	(646584, 132, '2015-01-15 00:23:59.000000', 'consum', 0.0210, 'lps'),
	(646585, 132, '2015-01-15 00:24:00.000000', 'consum', 0.0218, 'lps'),
	(646586, 132, '2015-01-15 00:24:01.000000', 'consum', 0.0216, 'lps'),
	(646587, 132, '2015-01-15 00:24:02.000000', 'consum', 0.0216, 'lps'),
	(646588, 132, '2015-01-15 00:24:03.000000', 'consum', 0.0213, 'lps'),
	(646589, 132, '2015-01-15 00:24:04.000000', 'consum', 0.0218, 'lps'),
	(646590, 132, '2015-01-15 00:24:05.000000', 'consum', 0.0219, 'lps'),
	(646591, 132, '2015-01-15 00:24:06.000000', 'consum', 0.0219, 'lps'),
	(646592, 132, '2015-01-15 00:24:07.000000', 'consum', 0.0219, 'lps'),
	(646593, 132, '2015-01-15 00:24:08.000000', 'consum', 0.0217, 'lps'),
	(646594, 132, '2015-01-15 00:24:09.000000', 'consum', 0.0210, 'lps'),
	(646595, 132, '2015-01-15 00:24:10.000000', 'consum', 0.0219, 'lps'),
	(646596, 132, '2015-01-15 00:24:11.000000', 'consum', 0.0212, 'lps'),
	(646597, 132, '2015-01-15 00:24:12.000000', 'consum', 0.0217, 'lps'),
	(646598, 132, '2015-01-15 00:24:13.000000', 'consum', 0.0215, 'lps'),
	(646599, 132, '2015-01-15 00:24:14.000000', 'consum', 0.0217, 'lps'),
	(646600, 132, '2015-01-15 00:24:15.000000', 'consum', 0.0217, 'lps'),
	(646601, 132, '2015-01-15 00:24:16.000000', 'consum', 0.0214, 'lps'),
	(646602, 132, '2015-01-15 00:24:17.000000', 'consum', 0.0219, 'lps'),
	(646603, 132, '2015-01-15 00:24:18.000000', 'consum', 0.0211, 'lps'),
	(646604, 132, '2015-01-15 00:24:19.000000', 'consum', 0.0212, 'lps'),
	(646605, 132, '2015-01-15 00:24:20.000000', 'consum', 0.0215, 'lps'),
	(646606, 132, '2015-01-15 00:24:21.000000', 'consum', 0.0220, 'lps'),
	(646607, 132, '2015-01-15 00:24:22.000000', 'consum', 0.0214, 'lps'),
	(646608, 132, '2015-01-15 00:24:23.000000', 'consum', 0.0211, 'lps'),
	(646609, 132, '2015-01-15 00:24:24.000000', 'consum', 0.0214, 'lps'),
	(646610, 132, '2015-01-15 00:24:25.000000', 'consum', 0.0216, 'lps'),
	(646611, 132, '2015-01-15 00:24:26.000000', 'consum', 0.0219, 'lps'),
	(646612, 132, '2015-01-15 00:24:27.000000', 'consum', 0.0216, 'lps'),
	(646613, 132, '2015-01-15 00:24:28.000000', 'consum', 0.0214, 'lps'),
	(646614, 132, '2015-01-15 00:24:29.000000', 'consum', 0.0211, 'lps'),
	(646615, 132, '2015-01-15 00:24:30.000000', 'consum', 0.0216, 'lps'),
	(646616, 132, '2015-01-15 00:24:31.000000', 'consum', 0.0214, 'lps'),
	(646617, 132, '2015-01-15 00:24:32.000000', 'consum', 0.0215, 'lps'),
	(646618, 132, '2015-01-15 00:24:33.000000', 'consum', 0.0210, 'lps'),
	(646619, 132, '2015-01-15 00:24:34.000000', 'consum', 0.0216, 'lps'),
	(646620, 132, '2015-01-15 00:24:35.000000', 'consum', 0.0211, 'lps'),
	(646621, 132, '2015-01-15 00:24:36.000000', 'consum', 0.0218, 'lps'),
	(646622, 132, '2015-01-15 00:24:37.000000', 'consum', 0.0213, 'lps'),
	(646623, 132, '2015-01-15 00:24:38.000000', 'consum', 0.0213, 'lps'),
	(646624, 132, '2015-01-15 00:24:39.000000', 'consum', 0.0217, 'lps'),
	(646625, 132, '2015-01-15 00:24:40.000000', 'consum', 0.0216, 'lps'),
	(646626, 132, '2015-01-15 00:24:41.000000', 'consum', 0.0219, 'lps'),
	(646627, 132, '2015-01-15 00:24:42.000000', 'consum', 0.0215, 'lps'),
	(646628, 132, '2015-01-15 00:24:43.000000', 'consum', 0.0218, 'lps'),
	(646629, 132, '2015-01-15 00:24:44.000000', 'consum', 0.0213, 'lps'),
	(646630, 132, '2015-01-15 00:24:45.000000', 'consum', 0.0214, 'lps'),
	(646631, 132, '2015-01-15 00:24:46.000000', 'consum', 0.0219, 'lps'),
	(646632, 132, '2015-01-15 00:24:47.000000', 'consum', 0.0213, 'lps'),
	(646633, 132, '2015-01-15 00:24:48.000000', 'consum', 0.0220, 'lps'),
	(646634, 132, '2015-01-15 00:24:49.000000', 'consum', 0.0218, 'lps'),
	(646635, 132, '2015-01-15 00:24:50.000000', 'consum', 0.0219, 'lps'),
	(646636, 132, '2015-01-15 00:24:51.000000', 'consum', 0.0212, 'lps'),
	(646637, 132, '2015-01-15 00:24:52.000000', 'consum', 0.0215, 'lps'),
	(646638, 132, '2015-01-15 00:24:53.000000', 'consum', 0.0220, 'lps'),
	(646639, 132, '2015-01-15 00:24:54.000000', 'consum', 0.0210, 'lps'),
	(646640, 132, '2015-01-15 00:24:55.000000', 'consum', 0.0216, 'lps'),
	(646641, 132, '2015-01-15 00:24:56.000000', 'consum', 0.0219, 'lps'),
	(646642, 132, '2015-01-15 00:24:57.000000', 'consum', 0.0216, 'lps'),
	(646643, 132, '2015-01-15 00:24:58.000000', 'consum', 0.0211, 'lps'),
	(646644, 132, '2015-01-15 00:24:59.000000', 'consum', 0.0220, 'lps'),
	(646645, 132, '2015-01-15 00:25:00.000000', 'consum', 0.0212, 'lps'),
	(646646, 132, '2015-01-15 00:25:01.000000', 'consum', 0.0214, 'lps'),
	(646647, 132, '2015-01-15 00:25:02.000000', 'consum', 0.0213, 'lps'),
	(646648, 132, '2015-01-15 00:25:03.000000', 'consum', 0.0212, 'lps'),
	(646649, 132, '2015-01-15 00:25:04.000000', 'consum', 0.0213, 'lps'),
	(646650, 132, '2015-01-15 00:25:05.000000', 'consum', 0.0218, 'lps'),
	(646651, 132, '2015-01-15 00:25:06.000000', 'consum', 0.0210, 'lps'),
	(646652, 132, '2015-01-15 00:25:07.000000', 'consum', 0.0210, 'lps'),
	(646653, 132, '2015-01-15 00:25:08.000000', 'consum', 0.0210, 'lps'),
	(646654, 132, '2015-01-15 00:25:09.000000', 'consum', 0.0219, 'lps'),
	(646655, 132, '2015-01-15 00:25:10.000000', 'consum', 0.0212, 'lps'),
	(646656, 132, '2015-01-15 00:25:11.000000', 'consum', 0.0218, 'lps'),
	(646657, 132, '2015-01-15 00:25:12.000000', 'consum', 0.0210, 'lps'),
	(646658, 132, '2015-01-15 00:25:13.000000', 'consum', 0.0220, 'lps'),
	(646659, 132, '2015-01-15 00:25:14.000000', 'consum', 0.0216, 'lps'),
	(646660, 132, '2015-01-15 00:25:15.000000', 'consum', 0.0220, 'lps'),
	(646661, 132, '2015-01-15 00:25:16.000000', 'consum', 0.0211, 'lps'),
	(646662, 132, '2015-01-15 00:25:17.000000', 'consum', 0.0218, 'lps'),
	(646663, 132, '2015-01-15 00:25:18.000000', 'consum', 0.0214, 'lps'),
	(646664, 132, '2015-01-15 00:25:19.000000', 'consum', 0.0219, 'lps'),
	(646665, 132, '2015-01-15 00:25:20.000000', 'consum', 0.0210, 'lps'),
	(646666, 132, '2015-01-15 00:25:21.000000', 'consum', 0.0215, 'lps'),
	(646667, 132, '2015-01-15 00:25:22.000000', 'consum', 0.0213, 'lps'),
	(646668, 132, '2015-01-15 00:25:23.000000', 'consum', 0.0212, 'lps'),
	(646669, 132, '2015-01-15 00:25:24.000000', 'consum', 0.0211, 'lps'),
	(646670, 132, '2015-01-15 00:25:25.000000', 'consum', 0.0210, 'lps'),
	(646671, 132, '2015-01-15 00:25:26.000000', 'consum', 0.0218, 'lps'),
	(646672, 132, '2015-01-15 00:25:27.000000', 'consum', 0.0219, 'lps'),
	(646673, 132, '2015-01-15 00:25:28.000000', 'consum', 0.0218, 'lps'),
	(646674, 132, '2015-01-15 00:25:29.000000', 'consum', 0.0214, 'lps'),
	(646675, 132, '2015-01-15 00:25:30.000000', 'consum', 0.0218, 'lps'),
	(646676, 132, '2015-01-15 00:25:31.000000', 'consum', 0.0215, 'lps'),
	(646677, 132, '2015-01-15 00:25:32.000000', 'consum', 0.0213, 'lps'),
	(646678, 132, '2015-01-15 00:25:33.000000', 'consum', 0.0211, 'lps'),
	(646679, 132, '2015-01-15 00:25:34.000000', 'consum', 0.0215, 'lps'),
	(646680, 132, '2015-01-15 00:25:35.000000', 'consum', 0.0214, 'lps'),
	(646681, 132, '2015-01-15 00:25:36.000000', 'consum', 0.0212, 'lps'),
	(646682, 132, '2015-01-15 00:25:37.000000', 'consum', 0.0212, 'lps'),
	(646683, 132, '2015-01-15 00:25:38.000000', 'consum', 0.0212, 'lps'),
	(646684, 132, '2015-01-15 00:25:39.000000', 'consum', 0.0215, 'lps'),
	(646685, 132, '2015-01-15 00:25:40.000000', 'consum', 0.0218, 'lps'),
	(646686, 132, '2015-01-15 00:25:41.000000', 'consum', 0.0213, 'lps'),
	(646687, 132, '2015-01-15 00:25:42.000000', 'consum', 0.0212, 'lps'),
	(646688, 132, '2015-01-15 00:25:43.000000', 'consum', 0.0212, 'lps'),
	(646689, 132, '2015-01-15 00:25:44.000000', 'consum', 0.0216, 'lps'),
	(646690, 132, '2015-01-15 00:25:45.000000', 'consum', 0.0211, 'lps'),
	(646691, 132, '2015-01-15 00:25:46.000000', 'consum', 0.0218, 'lps'),
	(646692, 132, '2015-01-15 00:25:47.000000', 'consum', 0.0215, 'lps'),
	(646693, 132, '2015-01-15 00:25:48.000000', 'consum', 0.0213, 'lps'),
	(646694, 132, '2015-01-15 00:25:49.000000', 'consum', 0.0220, 'lps'),
	(646695, 132, '2015-01-15 00:25:50.000000', 'consum', 0.0219, 'lps'),
	(646696, 132, '2015-01-15 00:25:51.000000', 'consum', 0.0216, 'lps'),
	(646697, 132, '2015-01-15 00:25:52.000000', 'consum', 0.0214, 'lps'),
	(646698, 132, '2015-01-15 00:25:53.000000', 'consum', 0.0210, 'lps'),
	(646699, 132, '2015-01-15 00:25:54.000000', 'consum', 0.0210, 'lps'),
	(646700, 132, '2015-01-15 00:25:55.000000', 'consum', 0.0212, 'lps'),
	(646701, 132, '2015-01-15 00:25:56.000000', 'consum', 0.0210, 'lps'),
	(646702, 132, '2015-01-15 00:25:57.000000', 'consum', 0.0215, 'lps'),
	(646703, 132, '2015-01-15 00:25:58.000000', 'consum', 0.0214, 'lps'),
	(646704, 132, '2015-01-15 00:25:59.000000', 'consum', 0.0215, 'lps'),
	(646705, 132, '2015-01-15 00:26:00.000000', 'consum', 0.0214, 'lps'),
	(646706, 132, '2015-01-15 00:26:01.000000', 'consum', 0.0214, 'lps'),
	(646707, 132, '2015-01-15 00:26:02.000000', 'consum', 0.0220, 'lps'),
	(646708, 132, '2015-01-15 00:26:03.000000', 'consum', 0.0216, 'lps'),
	(646709, 132, '2015-01-15 00:26:04.000000', 'consum', 0.0219, 'lps'),
	(646710, 132, '2015-01-15 00:26:05.000000', 'consum', 0.0216, 'lps'),
	(646711, 132, '2015-01-15 00:26:06.000000', 'consum', 0.0215, 'lps'),
	(646712, 132, '2015-01-15 00:26:07.000000', 'consum', 0.0216, 'lps'),
	(646713, 132, '2015-01-15 00:26:08.000000', 'consum', 0.0217, 'lps'),
	(646714, 132, '2015-01-15 00:26:09.000000', 'consum', 0.0215, 'lps'),
	(646715, 132, '2015-01-15 00:26:10.000000', 'consum', 0.0215, 'lps'),
	(646716, 132, '2015-01-15 00:26:11.000000', 'consum', 0.0220, 'lps'),
	(646717, 132, '2015-01-15 00:26:12.000000', 'consum', 0.0213, 'lps'),
	(646718, 132, '2015-01-15 00:26:13.000000', 'consum', 0.0215, 'lps'),
	(646719, 132, '2015-01-15 00:26:14.000000', 'consum', 0.0218, 'lps'),
	(646720, 132, '2015-01-15 00:26:15.000000', 'consum', 0.0211, 'lps'),
	(646721, 132, '2015-01-15 00:26:16.000000', 'consum', 0.0214, 'lps'),
	(646722, 132, '2015-01-15 00:26:17.000000', 'consum', 0.0219, 'lps'),
	(646723, 132, '2015-01-15 00:26:18.000000', 'consum', 0.0210, 'lps'),
	(646724, 132, '2015-01-15 00:26:19.000000', 'consum', 0.0215, 'lps'),
	(646725, 132, '2015-01-15 00:26:20.000000', 'consum', 0.0213, 'lps'),
	(646726, 132, '2015-01-15 00:26:21.000000', 'consum', 0.0220, 'lps'),
	(646727, 132, '2015-01-15 00:26:22.000000', 'consum', 0.0211, 'lps'),
	(646728, 132, '2015-01-15 00:26:23.000000', 'consum', 0.0217, 'lps'),
	(646729, 132, '2015-01-15 00:26:24.000000', 'consum', 0.0211, 'lps'),
	(646730, 132, '2015-01-15 00:26:25.000000', 'consum', 0.0216, 'lps'),
	(646731, 132, '2015-01-15 00:26:26.000000', 'consum', 0.0215, 'lps'),
	(646732, 132, '2015-01-15 00:26:27.000000', 'consum', 0.0217, 'lps'),
	(646733, 132, '2015-01-15 00:26:28.000000', 'consum', 0.0220, 'lps'),
	(646734, 132, '2015-01-15 00:26:29.000000', 'consum', 0.0219, 'lps'),
	(646735, 132, '2015-01-15 00:26:30.000000', 'consum', 0.0214, 'lps'),
	(646736, 132, '2015-01-15 00:26:31.000000', 'consum', 0.0216, 'lps'),
	(646737, 132, '2015-01-15 00:26:32.000000', 'consum', 0.0215, 'lps'),
	(646738, 132, '2015-01-15 00:26:33.000000', 'consum', 0.0217, 'lps'),
	(646739, 132, '2015-01-15 00:26:34.000000', 'consum', 0.0220, 'lps'),
	(646740, 132, '2015-01-15 00:26:35.000000', 'consum', 0.0219, 'lps'),
	(646741, 132, '2015-01-15 00:26:36.000000', 'consum', 0.0215, 'lps'),
	(646742, 132, '2015-01-15 00:26:37.000000', 'consum', 0.0217, 'lps'),
	(646743, 132, '2015-01-15 00:26:38.000000', 'consum', 0.0220, 'lps'),
	(646744, 132, '2015-01-15 00:26:39.000000', 'consum', 0.0220, 'lps'),
	(646745, 132, '2015-01-15 00:26:40.000000', 'consum', 0.0218, 'lps'),
	(646746, 132, '2015-01-15 00:26:41.000000', 'consum', 0.0220, 'lps'),
	(646747, 132, '2015-01-15 00:26:42.000000', 'consum', 0.0214, 'lps'),
	(646748, 132, '2015-01-15 00:26:43.000000', 'consum', 0.0213, 'lps'),
	(646749, 132, '2015-01-15 00:26:44.000000', 'consum', 0.0214, 'lps'),
	(646750, 132, '2015-01-15 00:26:45.000000', 'consum', 0.0211, 'lps'),
	(646751, 132, '2015-01-15 00:26:46.000000', 'consum', 0.0215, 'lps'),
	(646752, 132, '2015-01-15 00:26:47.000000', 'consum', 0.0212, 'lps'),
	(646753, 132, '2015-01-15 00:26:48.000000', 'consum', 0.0213, 'lps'),
	(646754, 132, '2015-01-15 00:26:49.000000', 'consum', 0.0220, 'lps'),
	(646755, 132, '2015-01-15 00:26:50.000000', 'consum', 0.0219, 'lps'),
	(646756, 132, '2015-01-15 00:26:51.000000', 'consum', 0.0216, 'lps'),
	(646757, 132, '2015-01-15 00:26:52.000000', 'consum', 0.0213, 'lps'),
	(646758, 132, '2015-01-15 00:26:53.000000', 'consum', 0.0220, 'lps'),
	(646759, 132, '2015-01-15 00:26:54.000000', 'consum', 0.0217, 'lps'),
	(646760, 132, '2015-01-15 00:26:55.000000', 'consum', 0.0214, 'lps'),
	(646761, 132, '2015-01-15 00:26:56.000000', 'consum', 0.0220, 'lps'),
	(646762, 132, '2015-01-15 00:26:57.000000', 'consum', 0.0215, 'lps'),
	(646763, 132, '2015-01-15 00:26:58.000000', 'consum', 0.0218, 'lps'),
	(646764, 132, '2015-01-15 00:26:59.000000', 'consum', 0.0213, 'lps'),
	(646765, 132, '2015-01-15 00:27:00.000000', 'consum', 0.0211, 'lps'),
	(646766, 132, '2015-01-15 00:27:01.000000', 'consum', 0.0220, 'lps'),
	(646767, 132, '2015-01-15 00:27:02.000000', 'consum', 0.0212, 'lps'),
	(646768, 132, '2015-01-15 00:27:03.000000', 'consum', 0.0214, 'lps'),
	(646769, 132, '2015-01-15 00:27:04.000000', 'consum', 0.0214, 'lps'),
	(646770, 132, '2015-01-15 00:27:05.000000', 'consum', 0.0219, 'lps'),
	(646771, 132, '2015-01-15 00:27:06.000000', 'consum', 0.0219, 'lps'),
	(646772, 132, '2015-01-15 00:27:07.000000', 'consum', 0.0210, 'lps'),
	(646773, 132, '2015-01-15 00:27:08.000000', 'consum', 0.0213, 'lps'),
	(646774, 132, '2015-01-15 00:27:09.000000', 'consum', 0.0215, 'lps'),
	(646775, 132, '2015-01-15 00:27:10.000000', 'consum', 0.0217, 'lps'),
	(646776, 132, '2015-01-15 00:27:11.000000', 'consum', 0.0217, 'lps'),
	(646777, 132, '2015-01-15 00:27:12.000000', 'consum', 0.0214, 'lps'),
	(646778, 132, '2015-01-15 00:27:13.000000', 'consum', 0.0211, 'lps'),
	(646779, 132, '2015-01-15 00:27:14.000000', 'consum', 0.0215, 'lps'),
	(646780, 132, '2015-01-15 00:27:15.000000', 'consum', 0.0219, 'lps'),
	(646781, 132, '2015-01-15 00:27:16.000000', 'consum', 0.0218, 'lps'),
	(646782, 132, '2015-01-15 00:27:17.000000', 'consum', 0.0216, 'lps'),
	(646783, 132, '2015-01-15 00:27:18.000000', 'consum', 0.0214, 'lps'),
	(646784, 132, '2015-01-15 00:27:19.000000', 'consum', 0.0212, 'lps'),
	(646785, 132, '2015-01-15 00:27:20.000000', 'consum', 0.0220, 'lps'),
	(646786, 132, '2015-01-15 00:27:21.000000', 'consum', 0.0220, 'lps'),
	(646787, 132, '2015-01-15 00:27:22.000000', 'consum', 0.0219, 'lps'),
	(646788, 132, '2015-01-15 00:27:23.000000', 'consum', 0.0217, 'lps'),
	(646789, 132, '2015-01-15 00:27:24.000000', 'consum', 0.0217, 'lps'),
	(646790, 132, '2015-01-15 00:27:25.000000', 'consum', 0.0213, 'lps'),
	(646791, 132, '2015-01-15 00:27:26.000000', 'consum', 0.0218, 'lps'),
	(646792, 132, '2015-01-15 00:27:27.000000', 'consum', 0.0218, 'lps'),
	(646793, 132, '2015-01-15 00:27:28.000000', 'consum', 0.0216, 'lps'),
	(646794, 132, '2015-01-15 00:27:29.000000', 'consum', 0.0217, 'lps'),
	(646795, 132, '2015-01-15 00:27:30.000000', 'consum', 0.0217, 'lps'),
	(646796, 132, '2015-01-15 00:27:31.000000', 'consum', 0.0213, 'lps'),
	(646797, 132, '2015-01-15 00:27:32.000000', 'consum', 0.0214, 'lps'),
	(646798, 132, '2015-01-15 00:27:33.000000', 'consum', 0.0212, 'lps'),
	(646799, 132, '2015-01-15 00:27:34.000000', 'consum', 0.0220, 'lps'),
	(646800, 132, '2015-01-15 00:27:35.000000', 'consum', 0.0211, 'lps'),
	(646801, 132, '2015-01-15 00:27:36.000000', 'consum', 0.0216, 'lps'),
	(646802, 132, '2015-01-15 00:27:37.000000', 'consum', 0.0217, 'lps'),
	(646803, 132, '2015-01-15 00:27:38.000000', 'consum', 0.0216, 'lps'),
	(646804, 132, '2015-01-15 00:27:39.000000', 'consum', 0.0220, 'lps'),
	(646805, 132, '2015-01-15 00:27:40.000000', 'consum', 0.0211, 'lps'),
	(646806, 132, '2015-01-15 00:27:41.000000', 'consum', 0.0217, 'lps'),
	(646807, 132, '2015-01-15 00:27:42.000000', 'consum', 0.0211, 'lps'),
	(646808, 132, '2015-01-15 00:27:43.000000', 'consum', 0.0218, 'lps'),
	(646809, 132, '2015-01-15 00:27:44.000000', 'consum', 0.0212, 'lps'),
	(646810, 132, '2015-01-15 00:27:45.000000', 'consum', 0.0217, 'lps'),
	(646811, 132, '2015-01-15 00:27:46.000000', 'consum', 0.0220, 'lps'),
	(646812, 132, '2015-01-15 00:27:47.000000', 'consum', 0.0217, 'lps'),
	(646813, 132, '2015-01-15 00:27:48.000000', 'consum', 0.0216, 'lps'),
	(646814, 132, '2015-01-15 00:27:49.000000', 'consum', 0.0218, 'lps'),
	(646815, 132, '2015-01-15 00:27:50.000000', 'consum', 0.0211, 'lps'),
	(646816, 132, '2015-01-15 00:27:51.000000', 'consum', 0.0213, 'lps'),
	(646817, 132, '2015-01-15 00:27:52.000000', 'consum', 0.0212, 'lps'),
	(646818, 132, '2015-01-15 00:27:53.000000', 'consum', 0.0210, 'lps'),
	(646819, 132, '2015-01-15 00:27:54.000000', 'consum', 0.0216, 'lps'),
	(646820, 132, '2015-01-15 00:27:55.000000', 'consum', 0.0210, 'lps'),
	(646821, 132, '2015-01-15 00:27:56.000000', 'consum', 0.0212, 'lps'),
	(646822, 132, '2015-01-15 00:27:57.000000', 'consum', 0.0219, 'lps'),
	(646823, 132, '2015-01-15 00:27:58.000000', 'consum', 0.0219, 'lps'),
	(646824, 132, '2015-01-15 00:27:59.000000', 'consum', 0.0217, 'lps'),
	(646825, 132, '2015-01-15 00:28:00.000000', 'consum', 0.0216, 'lps'),
	(646826, 132, '2015-01-15 00:28:01.000000', 'consum', 0.0212, 'lps'),
	(646827, 132, '2015-01-15 00:28:02.000000', 'consum', 0.0212, 'lps'),
	(646828, 132, '2015-01-15 00:28:03.000000', 'consum', 0.0216, 'lps'),
	(646829, 132, '2015-01-15 00:28:04.000000', 'consum', 0.0211, 'lps'),
	(646830, 132, '2015-01-15 00:28:05.000000', 'consum', 0.0219, 'lps'),
	(646831, 132, '2015-01-15 00:28:06.000000', 'consum', 0.0218, 'lps'),
	(646832, 132, '2015-01-15 00:28:07.000000', 'consum', 0.0216, 'lps'),
	(646833, 132, '2015-01-15 00:28:08.000000', 'consum', 0.0214, 'lps'),
	(646834, 132, '2015-01-15 00:28:09.000000', 'consum', 0.0212, 'lps'),
	(646835, 132, '2015-01-15 00:28:10.000000', 'consum', 0.0210, 'lps'),
	(646836, 132, '2015-01-15 00:28:11.000000', 'consum', 0.0216, 'lps'),
	(646837, 132, '2015-01-15 00:28:12.000000', 'consum', 0.0216, 'lps'),
	(646838, 132, '2015-01-15 00:28:13.000000', 'consum', 0.0213, 'lps'),
	(646839, 132, '2015-01-15 00:28:14.000000', 'consum', 0.0217, 'lps'),
	(646840, 132, '2015-01-15 00:28:15.000000', 'consum', 0.0215, 'lps'),
	(646841, 132, '2015-01-15 00:28:16.000000', 'consum', 0.0216, 'lps'),
	(646842, 132, '2015-01-15 00:28:17.000000', 'consum', 0.0212, 'lps'),
	(646843, 132, '2015-01-15 00:28:18.000000', 'consum', 0.0213, 'lps'),
	(646844, 132, '2015-01-15 00:28:19.000000', 'consum', 0.0219, 'lps'),
	(646845, 132, '2015-01-15 00:28:20.000000', 'consum', 0.0215, 'lps'),
	(646846, 132, '2015-01-15 00:28:21.000000', 'consum', 0.0210, 'lps'),
	(646847, 132, '2015-01-15 00:28:22.000000', 'consum', 0.0215, 'lps'),
	(646848, 132, '2015-01-15 00:28:23.000000', 'consum', 0.0216, 'lps'),
	(646849, 132, '2015-01-15 00:28:24.000000', 'consum', 0.0215, 'lps'),
	(646850, 132, '2015-01-15 00:28:25.000000', 'consum', 0.0215, 'lps'),
	(646851, 132, '2015-01-15 00:28:26.000000', 'consum', 0.0210, 'lps'),
	(646852, 132, '2015-01-15 00:28:27.000000', 'consum', 0.0216, 'lps'),
	(646853, 132, '2015-01-15 00:28:28.000000', 'consum', 0.0220, 'lps'),
	(646854, 132, '2015-01-15 00:28:29.000000', 'consum', 0.0210, 'lps'),
	(646855, 132, '2015-01-15 00:28:30.000000', 'consum', 0.0212, 'lps'),
	(646856, 132, '2015-01-15 00:28:31.000000', 'consum', 0.0219, 'lps'),
	(646857, 132, '2015-01-15 00:28:32.000000', 'consum', 0.0219, 'lps'),
	(646858, 132, '2015-01-15 00:28:33.000000', 'consum', 0.0215, 'lps'),
	(646859, 132, '2015-01-15 00:28:34.000000', 'consum', 0.0211, 'lps'),
	(646860, 132, '2015-01-15 00:28:35.000000', 'consum', 0.0210, 'lps'),
	(646861, 132, '2015-01-15 00:28:36.000000', 'consum', 0.0218, 'lps'),
	(646862, 132, '2015-01-15 00:28:37.000000', 'consum', 0.0219, 'lps'),
	(646863, 132, '2015-01-15 00:28:38.000000', 'consum', 0.0210, 'lps'),
	(646864, 132, '2015-01-15 00:28:39.000000', 'consum', 0.0217, 'lps'),
	(646865, 132, '2015-01-15 00:28:40.000000', 'consum', 0.0212, 'lps'),
	(646866, 132, '2015-01-15 00:28:41.000000', 'consum', 0.0212, 'lps'),
	(646867, 132, '2015-01-15 00:28:42.000000', 'consum', 0.0212, 'lps'),
	(646868, 132, '2015-01-15 00:28:43.000000', 'consum', 0.0217, 'lps'),
	(646869, 132, '2015-01-15 00:28:44.000000', 'consum', 0.0216, 'lps'),
	(646870, 132, '2015-01-15 00:28:45.000000', 'consum', 0.0218, 'lps'),
	(646871, 132, '2015-01-15 00:28:46.000000', 'consum', 0.0213, 'lps'),
	(646872, 132, '2015-01-15 00:28:47.000000', 'consum', 0.0212, 'lps'),
	(646873, 132, '2015-01-15 00:28:48.000000', 'consum', 0.0212, 'lps'),
	(646874, 132, '2015-01-15 00:28:49.000000', 'consum', 0.0216, 'lps'),
	(646875, 132, '2015-01-15 00:28:50.000000', 'consum', 0.0212, 'lps'),
	(646876, 132, '2015-01-15 00:28:51.000000', 'consum', 0.0211, 'lps'),
	(646877, 132, '2015-01-15 00:28:52.000000', 'consum', 0.0210, 'lps'),
	(646878, 132, '2015-01-15 00:28:53.000000', 'consum', 0.0218, 'lps'),
	(646879, 132, '2015-01-15 00:28:54.000000', 'consum', 0.0216, 'lps'),
	(646880, 132, '2015-01-15 00:28:55.000000', 'consum', 0.0219, 'lps'),
	(646881, 132, '2015-01-15 00:28:56.000000', 'consum', 0.0215, 'lps'),
	(646882, 132, '2015-01-15 00:28:57.000000', 'consum', 0.0210, 'lps'),
	(646883, 132, '2015-01-15 00:28:58.000000', 'consum', 0.0215, 'lps'),
	(646884, 132, '2015-01-15 00:28:59.000000', 'consum', 0.0216, 'lps'),
	(646885, 132, '2015-01-15 00:29:00.000000', 'consum', 0.0214, 'lps'),
	(646886, 132, '2015-01-15 00:29:01.000000', 'consum', 0.0213, 'lps'),
	(646887, 132, '2015-01-15 00:29:02.000000', 'consum', 0.0212, 'lps'),
	(646888, 132, '2015-01-15 00:29:03.000000', 'consum', 0.0213, 'lps'),
	(646889, 132, '2015-01-15 00:29:04.000000', 'consum', 0.0217, 'lps'),
	(646890, 132, '2015-01-15 00:29:05.000000', 'consum', 0.0217, 'lps'),
	(646891, 132, '2015-01-15 00:29:06.000000', 'consum', 0.0214, 'lps'),
	(646892, 132, '2015-01-15 00:29:07.000000', 'consum', 0.0219, 'lps'),
	(646893, 132, '2015-01-15 00:29:08.000000', 'consum', 0.0212, 'lps'),
	(646894, 132, '2015-01-15 00:29:09.000000', 'consum', 0.0213, 'lps'),
	(646895, 132, '2015-01-15 00:29:10.000000', 'consum', 0.0220, 'lps'),
	(646896, 132, '2015-01-15 00:29:11.000000', 'consum', 0.0218, 'lps'),
	(646897, 132, '2015-01-15 00:29:12.000000', 'consum', 0.0211, 'lps'),
	(646898, 132, '2015-01-15 00:29:13.000000', 'consum', 0.0213, 'lps'),
	(646899, 132, '2015-01-15 00:29:14.000000', 'consum', 0.0210, 'lps'),
	(646900, 132, '2015-01-15 00:29:15.000000', 'consum', 0.0215, 'lps'),
	(646901, 132, '2015-01-15 00:29:16.000000', 'consum', 0.0211, 'lps'),
	(646902, 132, '2015-01-15 00:29:17.000000', 'consum', 0.0213, 'lps'),
	(646903, 132, '2015-01-15 00:29:18.000000', 'consum', 0.0210, 'lps'),
	(646904, 132, '2015-01-15 00:29:19.000000', 'consum', 0.0214, 'lps'),
	(646905, 132, '2015-01-15 00:29:20.000000', 'consum', 0.0219, 'lps'),
	(646906, 132, '2015-01-15 00:29:21.000000', 'consum', 0.0210, 'lps'),
	(646907, 132, '2015-01-15 00:29:22.000000', 'consum', 0.0218, 'lps'),
	(646908, 132, '2015-01-15 00:29:23.000000', 'consum', 0.0217, 'lps'),
	(646909, 132, '2015-01-15 00:29:24.000000', 'consum', 0.0211, 'lps'),
	(646910, 132, '2015-01-15 00:29:25.000000', 'consum', 0.0215, 'lps'),
	(646911, 132, '2015-01-15 00:29:26.000000', 'consum', 0.0211, 'lps'),
	(646912, 132, '2015-01-15 00:29:27.000000', 'consum', 0.0213, 'lps'),
	(646913, 132, '2015-01-15 00:29:28.000000', 'consum', 0.0210, 'lps'),
	(646914, 132, '2015-01-15 00:29:29.000000', 'consum', 0.0212, 'lps'),
	(646915, 132, '2015-01-15 00:29:30.000000', 'consum', 0.0220, 'lps'),
	(646916, 132, '2015-01-15 00:29:31.000000', 'consum', 0.0212, 'lps'),
	(646917, 132, '2015-01-15 00:29:32.000000', 'consum', 0.0213, 'lps'),
	(646918, 132, '2015-01-15 00:29:33.000000', 'consum', 0.0210, 'lps'),
	(646919, 132, '2015-01-15 00:29:34.000000', 'consum', 0.0210, 'lps'),
	(646920, 132, '2015-01-15 00:29:35.000000', 'consum', 0.0210, 'lps'),
	(646921, 132, '2015-01-15 00:29:36.000000', 'consum', 0.0213, 'lps'),
	(646922, 132, '2015-01-15 00:29:37.000000', 'consum', 0.0212, 'lps'),
	(646923, 132, '2015-01-15 00:29:38.000000', 'consum', 0.0214, 'lps'),
	(646924, 132, '2015-01-15 00:29:39.000000', 'consum', 0.0212, 'lps'),
	(646925, 132, '2015-01-15 00:29:40.000000', 'consum', 0.0219, 'lps'),
	(646926, 132, '2015-01-15 00:29:41.000000', 'consum', 0.0215, 'lps'),
	(646927, 132, '2015-01-15 00:29:42.000000', 'consum', 0.0212, 'lps'),
	(646928, 132, '2015-01-15 00:29:43.000000', 'consum', 0.0213, 'lps'),
	(646929, 132, '2015-01-15 00:29:44.000000', 'consum', 0.0211, 'lps'),
	(646930, 132, '2015-01-15 00:29:45.000000', 'consum', 0.0218, 'lps'),
	(646931, 132, '2015-01-15 00:29:46.000000', 'consum', 0.0214, 'lps'),
	(646932, 132, '2015-01-15 00:29:47.000000', 'consum', 0.0218, 'lps'),
	(646933, 132, '2015-01-15 00:29:48.000000', 'consum', 0.0216, 'lps'),
	(646934, 132, '2015-01-15 00:29:49.000000', 'consum', 0.0216, 'lps'),
	(646935, 132, '2015-01-15 00:29:50.000000', 'consum', 0.0212, 'lps'),
	(646936, 132, '2015-01-15 00:29:51.000000', 'consum', 0.0211, 'lps'),
	(646937, 132, '2015-01-15 00:29:52.000000', 'consum', 0.0213, 'lps'),
	(646938, 132, '2015-01-15 00:29:53.000000', 'consum', 0.0211, 'lps'),
	(646939, 132, '2015-01-15 00:29:54.000000', 'consum', 0.0215, 'lps'),
	(646940, 132, '2015-01-15 00:29:55.000000', 'consum', 0.0211, 'lps'),
	(646941, 132, '2015-01-15 00:29:56.000000', 'consum', 0.0214, 'lps'),
	(646942, 132, '2015-01-15 00:29:57.000000', 'consum', 0.0214, 'lps'),
	(646943, 132, '2015-01-15 00:29:58.000000', 'consum', 0.0219, 'lps'),
	(646944, 132, '2015-01-15 00:29:59.000000', 'consum', 0.0210, 'lps'),
	(646945, 132, '2015-01-15 00:30:00.000000', 'consum', 0.0217, 'lps'),
	(646946, 132, '2015-01-15 00:30:01.000000', 'consum', 0.0212, 'lps'),
	(646947, 132, '2015-01-15 00:30:02.000000', 'consum', 0.0212, 'lps'),
	(646948, 132, '2015-01-15 00:30:03.000000', 'consum', 0.0214, 'lps'),
	(646949, 132, '2015-01-15 00:30:04.000000', 'consum', 0.0215, 'lps'),
	(646950, 132, '2015-01-15 00:30:05.000000', 'consum', 0.0211, 'lps'),
	(646951, 132, '2015-01-15 00:30:06.000000', 'consum', 0.0210, 'lps'),
	(646952, 132, '2015-01-15 00:30:07.000000', 'consum', 0.0220, 'lps'),
	(646953, 132, '2015-01-15 00:30:08.000000', 'consum', 0.0217, 'lps'),
	(646954, 132, '2015-01-15 00:30:09.000000', 'consum', 0.0213, 'lps'),
	(646955, 132, '2015-01-15 00:30:10.000000', 'consum', 0.0218, 'lps'),
	(646956, 132, '2015-01-15 00:30:11.000000', 'consum', 0.0219, 'lps'),
	(646957, 132, '2015-01-15 00:30:12.000000', 'consum', 0.0220, 'lps'),
	(646958, 132, '2015-01-15 00:30:13.000000', 'consum', 0.0213, 'lps'),
	(646959, 132, '2015-01-15 00:30:14.000000', 'consum', 0.0216, 'lps'),
	(646960, 132, '2015-01-15 00:30:15.000000', 'consum', 0.0210, 'lps'),
	(646961, 132, '2015-01-15 00:30:16.000000', 'consum', 0.0214, 'lps'),
	(646962, 132, '2015-01-15 00:30:17.000000', 'consum', 0.0210, 'lps'),
	(646963, 132, '2015-01-15 00:30:18.000000', 'consum', 0.0220, 'lps'),
	(646964, 132, '2015-01-15 00:30:19.000000', 'consum', 0.0218, 'lps'),
	(646965, 132, '2015-01-15 00:30:20.000000', 'consum', 0.0220, 'lps'),
	(646966, 132, '2015-01-15 00:30:21.000000', 'consum', 0.0213, 'lps'),
	(646967, 132, '2015-01-15 00:30:22.000000', 'consum', 0.0216, 'lps'),
	(646968, 132, '2015-01-15 00:30:23.000000', 'consum', 0.0212, 'lps'),
	(646969, 132, '2015-01-15 00:30:24.000000', 'consum', 0.0213, 'lps'),
	(646970, 132, '2015-01-15 00:30:25.000000', 'consum', 0.0210, 'lps'),
	(646971, 132, '2015-01-15 00:30:26.000000', 'consum', 0.0210, 'lps'),
	(646972, 132, '2015-01-15 00:30:27.000000', 'consum', 0.0211, 'lps'),
	(646973, 132, '2015-01-15 00:30:28.000000', 'consum', 0.0216, 'lps'),
	(646974, 132, '2015-01-15 00:30:29.000000', 'consum', 0.0214, 'lps'),
	(646975, 132, '2015-01-15 00:30:30.000000', 'consum', 0.0212, 'lps'),
	(646976, 132, '2015-01-15 00:30:31.000000', 'consum', 0.0210, 'lps'),
	(646977, 132, '2015-01-15 00:30:32.000000', 'consum', 0.0214, 'lps'),
	(646978, 132, '2015-01-15 00:30:33.000000', 'consum', 0.0219, 'lps'),
	(646979, 132, '2015-01-15 00:30:34.000000', 'consum', 0.0212, 'lps'),
	(646980, 132, '2015-01-15 00:30:35.000000', 'consum', 0.0214, 'lps'),
	(646981, 132, '2015-01-15 00:30:36.000000', 'consum', 0.0212, 'lps'),
	(646982, 132, '2015-01-15 00:30:37.000000', 'consum', 0.0211, 'lps'),
	(646983, 132, '2015-01-15 00:30:38.000000', 'consum', 0.0211, 'lps'),
	(646984, 132, '2015-01-15 00:30:39.000000', 'consum', 0.0210, 'lps'),
	(646985, 132, '2015-01-15 00:30:40.000000', 'consum', 0.0218, 'lps'),
	(646986, 132, '2015-01-15 00:30:41.000000', 'consum', 0.0216, 'lps'),
	(646987, 132, '2015-01-15 00:30:42.000000', 'consum', 0.0220, 'lps'),
	(646988, 132, '2015-01-15 00:30:43.000000', 'consum', 0.0220, 'lps'),
	(646989, 132, '2015-01-15 00:30:44.000000', 'consum', 0.0219, 'lps'),
	(646990, 132, '2015-01-15 00:30:45.000000', 'consum', 0.0213, 'lps'),
	(646991, 132, '2015-01-15 00:30:46.000000', 'consum', 0.0210, 'lps'),
	(646992, 132, '2015-01-15 00:30:47.000000', 'consum', 0.0214, 'lps'),
	(646993, 132, '2015-01-15 00:30:48.000000', 'consum', 0.0220, 'lps'),
	(646994, 132, '2015-01-15 00:30:49.000000', 'consum', 0.0215, 'lps'),
	(646995, 132, '2015-01-15 00:30:50.000000', 'consum', 0.0215, 'lps'),
	(646996, 132, '2015-01-15 00:30:51.000000', 'consum', 0.0220, 'lps'),
	(646997, 132, '2015-01-15 00:30:52.000000', 'consum', 0.0216, 'lps'),
	(646998, 132, '2015-01-15 00:30:53.000000', 'consum', 0.0218, 'lps'),
	(646999, 132, '2015-01-15 00:30:54.000000', 'consum', 0.0210, 'lps'),
	(647000, 132, '2015-01-15 00:30:55.000000', 'consum', 0.0210, 'lps'),
	(647001, 132, '2015-01-15 00:30:56.000000', 'consum', 0.0220, 'lps'),
	(647002, 132, '2015-01-15 00:30:57.000000', 'consum', 0.0218, 'lps'),
	(647003, 132, '2015-01-15 00:30:58.000000', 'consum', 0.0219, 'lps'),
	(647004, 132, '2015-01-15 00:30:59.000000', 'consum', 0.0211, 'lps'),
	(647005, 132, '2015-01-15 00:31:00.000000', 'consum', 0.0210, 'lps'),
	(647006, 132, '2015-01-15 00:31:01.000000', 'consum', 0.0219, 'lps'),
	(647007, 132, '2015-01-15 00:31:02.000000', 'consum', 0.0213, 'lps'),
	(647008, 132, '2015-01-15 00:31:03.000000', 'consum', 0.0217, 'lps'),
	(647009, 132, '2015-01-15 00:31:04.000000', 'consum', 0.0216, 'lps'),
	(647010, 132, '2015-01-15 00:31:05.000000', 'consum', 0.0210, 'lps'),
	(647011, 132, '2015-01-15 00:31:06.000000', 'consum', 0.0213, 'lps'),
	(647012, 132, '2015-01-15 00:31:07.000000', 'consum', 0.0214, 'lps'),
	(647013, 132, '2015-01-15 00:31:08.000000', 'consum', 0.0211, 'lps'),
	(647014, 132, '2015-01-15 00:31:09.000000', 'consum', 0.0213, 'lps'),
	(647015, 132, '2015-01-15 00:31:10.000000', 'consum', 0.0214, 'lps'),
	(647016, 132, '2015-01-15 00:31:11.000000', 'consum', 0.0210, 'lps'),
	(647017, 132, '2015-01-15 00:31:12.000000', 'consum', 0.0210, 'lps'),
	(647018, 132, '2015-01-15 00:31:13.000000', 'consum', 0.0220, 'lps'),
	(647019, 132, '2015-01-15 00:31:14.000000', 'consum', 0.0219, 'lps'),
	(647020, 132, '2015-01-15 00:31:15.000000', 'consum', 0.0212, 'lps'),
	(647021, 132, '2015-01-15 00:31:16.000000', 'consum', 0.0218, 'lps'),
	(647022, 132, '2015-01-15 00:31:17.000000', 'consum', 0.0212, 'lps'),
	(647023, 132, '2015-01-15 00:31:18.000000', 'consum', 0.0216, 'lps'),
	(647024, 132, '2015-01-15 00:31:19.000000', 'consum', 0.0213, 'lps'),
	(647025, 132, '2015-01-15 00:31:20.000000', 'consum', 0.0219, 'lps'),
	(647026, 132, '2015-01-15 00:31:21.000000', 'consum', 0.0213, 'lps'),
	(647027, 132, '2015-01-15 00:31:22.000000', 'consum', 0.0210, 'lps'),
	(647028, 132, '2015-01-15 00:31:23.000000', 'consum', 0.0211, 'lps'),
	(647029, 132, '2015-01-15 00:31:24.000000', 'consum', 0.0215, 'lps'),
	(647030, 132, '2015-01-15 00:31:25.000000', 'consum', 0.0212, 'lps'),
	(647031, 132, '2015-01-15 00:31:26.000000', 'consum', 0.0218, 'lps'),
	(647032, 132, '2015-01-15 00:31:27.000000', 'consum', 0.0220, 'lps'),
	(647033, 132, '2015-01-15 00:31:28.000000', 'consum', 0.0216, 'lps'),
	(647034, 132, '2015-01-15 00:31:29.000000', 'consum', 0.0219, 'lps'),
	(647035, 132, '2015-01-15 00:31:30.000000', 'consum', 0.0218, 'lps'),
	(647036, 132, '2015-01-15 00:31:31.000000', 'consum', 0.0211, 'lps'),
	(647037, 132, '2015-01-15 00:31:32.000000', 'consum', 0.0214, 'lps'),
	(647038, 132, '2015-01-15 00:31:33.000000', 'consum', 0.0216, 'lps'),
	(647039, 132, '2015-01-15 00:31:34.000000', 'consum', 0.0217, 'lps'),
	(647040, 132, '2015-01-15 00:31:35.000000', 'consum', 0.0218, 'lps'),
	(647041, 132, '2015-01-15 00:31:36.000000', 'consum', 0.0219, 'lps'),
	(647042, 132, '2015-01-15 00:31:37.000000', 'consum', 0.0210, 'lps'),
	(647043, 132, '2015-01-15 00:31:38.000000', 'consum', 0.0214, 'lps'),
	(647044, 132, '2015-01-15 00:31:39.000000', 'consum', 0.0211, 'lps'),
	(647045, 132, '2015-01-15 00:31:40.000000', 'consum', 0.0214, 'lps'),
	(647046, 132, '2015-01-15 00:31:41.000000', 'consum', 0.0217, 'lps'),
	(647047, 132, '2015-01-15 00:31:42.000000', 'consum', 0.0210, 'lps'),
	(647048, 132, '2015-01-15 00:31:43.000000', 'consum', 0.0211, 'lps'),
	(647049, 132, '2015-01-15 00:31:44.000000', 'consum', 0.0217, 'lps'),
	(647050, 132, '2015-01-15 00:31:45.000000', 'consum', 0.0211, 'lps'),
	(647051, 132, '2015-01-15 00:31:46.000000', 'consum', 0.0213, 'lps'),
	(647052, 132, '2015-01-15 00:31:47.000000', 'consum', 0.0215, 'lps'),
	(647053, 132, '2015-01-15 00:31:48.000000', 'consum', 0.0213, 'lps'),
	(647054, 132, '2015-01-15 00:31:49.000000', 'consum', 0.0212, 'lps'),
	(647055, 132, '2015-01-15 00:31:50.000000', 'consum', 0.0212, 'lps'),
	(647056, 132, '2015-01-15 00:31:51.000000', 'consum', 0.0215, 'lps'),
	(647057, 132, '2015-01-15 00:31:52.000000', 'consum', 0.0218, 'lps'),
	(647058, 132, '2015-01-15 00:31:53.000000', 'consum', 0.0214, 'lps'),
	(647059, 132, '2015-01-15 00:31:54.000000', 'consum', 0.0218, 'lps'),
	(647060, 132, '2015-01-15 00:31:55.000000', 'consum', 0.0216, 'lps'),
	(647061, 132, '2015-01-15 00:31:56.000000', 'consum', 0.0217, 'lps'),
	(647062, 132, '2015-01-15 00:31:57.000000', 'consum', 0.0216, 'lps'),
	(647063, 132, '2015-01-15 00:31:58.000000', 'consum', 0.0219, 'lps'),
	(647064, 132, '2015-01-15 00:31:59.000000', 'consum', 0.0215, 'lps'),
	(647065, 132, '2015-01-15 00:32:00.000000', 'consum', 0.0219, 'lps'),
	(647066, 132, '2015-01-15 00:32:01.000000', 'consum', 0.0219, 'lps'),
	(647067, 132, '2015-01-15 00:32:02.000000', 'consum', 0.0220, 'lps'),
	(647068, 132, '2015-01-15 00:32:03.000000', 'consum', 0.0219, 'lps'),
	(647069, 132, '2015-01-15 00:32:04.000000', 'consum', 0.0216, 'lps'),
	(647070, 132, '2015-01-15 00:32:05.000000', 'consum', 0.0214, 'lps'),
	(647071, 132, '2015-01-15 00:32:06.000000', 'consum', 0.0213, 'lps'),
	(647072, 132, '2015-01-15 00:32:07.000000', 'consum', 0.0213, 'lps'),
	(647073, 132, '2015-01-15 00:32:08.000000', 'consum', 0.0215, 'lps'),
	(647074, 132, '2015-01-15 00:32:09.000000', 'consum', 0.0216, 'lps'),
	(647075, 132, '2015-01-15 00:32:10.000000', 'consum', 0.0216, 'lps'),
	(647076, 132, '2015-01-15 00:32:11.000000', 'consum', 0.0220, 'lps'),
	(647077, 132, '2015-01-15 00:32:12.000000', 'consum', 0.0212, 'lps'),
	(647078, 132, '2015-01-15 00:32:13.000000', 'consum', 0.0210, 'lps'),
	(647079, 132, '2015-01-15 00:32:14.000000', 'consum', 0.0215, 'lps'),
	(647080, 132, '2015-01-15 00:32:15.000000', 'consum', 0.0213, 'lps'),
	(647081, 132, '2015-01-15 00:32:16.000000', 'consum', 0.0214, 'lps'),
	(647082, 132, '2015-01-15 00:32:17.000000', 'consum', 0.0218, 'lps'),
	(647083, 132, '2015-01-15 00:32:18.000000', 'consum', 0.0219, 'lps'),
	(647084, 132, '2015-01-15 00:32:19.000000', 'consum', 0.0210, 'lps'),
	(647085, 132, '2015-01-15 00:32:20.000000', 'consum', 0.0214, 'lps'),
	(647086, 132, '2015-01-15 00:32:21.000000', 'consum', 0.0219, 'lps'),
	(647087, 132, '2015-01-15 00:32:22.000000', 'consum', 0.0211, 'lps'),
	(647088, 132, '2015-01-15 00:32:23.000000', 'consum', 0.0212, 'lps'),
	(647089, 132, '2015-01-15 00:32:24.000000', 'consum', 0.0217, 'lps'),
	(647090, 132, '2015-01-15 00:32:25.000000', 'consum', 0.0218, 'lps'),
	(647091, 132, '2015-01-15 00:32:26.000000', 'consum', 0.0217, 'lps'),
	(647092, 132, '2015-01-15 00:32:27.000000', 'consum', 0.0213, 'lps'),
	(647093, 132, '2015-01-15 00:32:28.000000', 'consum', 0.0213, 'lps'),
	(647094, 132, '2015-01-15 00:32:29.000000', 'consum', 0.0216, 'lps'),
	(647095, 132, '2015-01-15 00:32:30.000000', 'consum', 0.0212, 'lps'),
	(647096, 132, '2015-01-15 00:32:31.000000', 'consum', 0.0212, 'lps'),
	(647097, 132, '2015-01-15 00:32:32.000000', 'consum', 0.0213, 'lps'),
	(647098, 132, '2015-01-15 00:32:33.000000', 'consum', 0.0212, 'lps'),
	(647099, 132, '2015-01-15 00:32:34.000000', 'consum', 0.0220, 'lps'),
	(647100, 132, '2015-01-15 00:32:35.000000', 'consum', 0.0212, 'lps'),
	(647101, 132, '2015-01-15 00:32:36.000000', 'consum', 0.0211, 'lps'),
	(647102, 132, '2015-01-15 00:32:37.000000', 'consum', 0.0220, 'lps'),
	(647103, 132, '2015-01-15 00:32:38.000000', 'consum', 0.0216, 'lps'),
	(647104, 132, '2015-01-15 00:32:39.000000', 'consum', 0.0211, 'lps'),
	(647105, 132, '2015-01-15 00:32:40.000000', 'consum', 0.0219, 'lps'),
	(647106, 132, '2015-01-15 00:32:41.000000', 'consum', 0.0219, 'lps'),
	(647107, 132, '2015-01-15 00:32:42.000000', 'consum', 0.0217, 'lps'),
	(647108, 132, '2015-01-15 00:32:43.000000', 'consum', 0.0220, 'lps'),
	(647109, 132, '2015-01-15 00:32:44.000000', 'consum', 0.0218, 'lps'),
	(647110, 132, '2015-01-15 00:32:45.000000', 'consum', 0.0210, 'lps'),
	(647111, 132, '2015-01-15 00:32:46.000000', 'consum', 0.0219, 'lps'),
	(647112, 132, '2015-01-15 00:32:47.000000', 'consum', 0.0210, 'lps'),
	(647113, 132, '2015-01-15 00:32:48.000000', 'consum', 0.0216, 'lps'),
	(647114, 132, '2015-01-15 00:32:49.000000', 'consum', 0.0218, 'lps'),
	(647115, 132, '2015-01-15 00:32:50.000000', 'consum', 0.0212, 'lps'),
	(647116, 132, '2015-01-15 00:32:51.000000', 'consum', 0.0220, 'lps'),
	(647117, 132, '2015-01-15 00:32:52.000000', 'consum', 0.0220, 'lps'),
	(647118, 132, '2015-01-15 00:32:53.000000', 'consum', 0.0210, 'lps'),
	(647119, 132, '2015-01-15 00:32:54.000000', 'consum', 0.0213, 'lps'),
	(647120, 132, '2015-01-15 00:32:55.000000', 'consum', 0.0215, 'lps'),
	(647121, 132, '2015-01-15 00:32:56.000000', 'consum', 0.0217, 'lps'),
	(647122, 132, '2015-01-15 00:32:57.000000', 'consum', 0.0216, 'lps'),
	(647123, 132, '2015-01-15 00:32:58.000000', 'consum', 0.0210, 'lps'),
	(647124, 132, '2015-01-15 00:32:59.000000', 'consum', 0.0214, 'lps'),
	(647125, 132, '2015-01-15 00:33:00.000000', 'consum', 0.0220, 'lps'),
	(647126, 132, '2015-01-15 00:33:01.000000', 'consum', 0.0217, 'lps'),
	(647127, 132, '2015-01-15 00:33:02.000000', 'consum', 0.0212, 'lps'),
	(647128, 132, '2015-01-15 00:33:03.000000', 'consum', 0.0214, 'lps'),
	(647129, 132, '2015-01-15 00:33:04.000000', 'consum', 0.0212, 'lps'),
	(647130, 132, '2015-01-15 00:33:05.000000', 'consum', 0.0210, 'lps'),
	(647131, 132, '2015-01-15 00:33:06.000000', 'consum', 0.0214, 'lps'),
	(647132, 132, '2015-01-15 00:33:07.000000', 'consum', 0.0210, 'lps'),
	(647133, 132, '2015-01-15 00:33:08.000000', 'consum', 0.0210, 'lps'),
	(647134, 132, '2015-01-15 00:33:09.000000', 'consum', 0.0219, 'lps'),
	(647135, 132, '2015-01-15 00:33:10.000000', 'consum', 0.0213, 'lps'),
	(647136, 132, '2015-01-15 00:33:11.000000', 'consum', 0.0210, 'lps'),
	(647137, 132, '2015-01-15 00:33:12.000000', 'consum', 0.0213, 'lps'),
	(647138, 132, '2015-01-15 00:33:13.000000', 'consum', 0.0215, 'lps'),
	(647139, 132, '2015-01-15 00:33:14.000000', 'consum', 0.0216, 'lps'),
	(647140, 132, '2015-01-15 00:33:15.000000', 'consum', 0.0212, 'lps'),
	(647141, 132, '2015-01-15 00:33:16.000000', 'consum', 0.0217, 'lps'),
	(647142, 132, '2015-01-15 00:33:17.000000', 'consum', 0.0214, 'lps'),
	(647143, 132, '2015-01-15 00:33:18.000000', 'consum', 0.0211, 'lps'),
	(647144, 132, '2015-01-15 00:33:19.000000', 'consum', 0.0213, 'lps'),
	(647145, 132, '2015-01-15 00:33:20.000000', 'consum', 0.0212, 'lps'),
	(647146, 132, '2015-01-15 00:33:21.000000', 'consum', 0.0211, 'lps'),
	(647147, 132, '2015-01-15 00:33:22.000000', 'consum', 0.0211, 'lps'),
	(647148, 132, '2015-01-15 00:33:23.000000', 'consum', 0.0213, 'lps'),
	(647149, 132, '2015-01-15 00:33:24.000000', 'consum', 0.0211, 'lps'),
	(647150, 132, '2015-01-15 00:33:25.000000', 'consum', 0.0218, 'lps'),
	(647151, 132, '2015-01-15 00:33:26.000000', 'consum', 0.0213, 'lps'),
	(647152, 132, '2015-01-15 00:33:27.000000', 'consum', 0.0212, 'lps'),
	(647153, 132, '2015-01-15 00:33:28.000000', 'consum', 0.0213, 'lps'),
	(647154, 132, '2015-01-15 00:33:29.000000', 'consum', 0.0220, 'lps'),
	(647155, 132, '2015-01-15 00:33:30.000000', 'consum', 0.0217, 'lps'),
	(647156, 132, '2015-01-15 00:33:31.000000', 'consum', 0.0218, 'lps'),
	(647157, 132, '2015-01-15 00:33:32.000000', 'consum', 0.0217, 'lps'),
	(647158, 132, '2015-01-15 00:33:33.000000', 'consum', 0.0212, 'lps'),
	(647159, 132, '2015-01-15 00:33:34.000000', 'consum', 0.0210, 'lps'),
	(647160, 132, '2015-01-15 00:33:35.000000', 'consum', 0.0214, 'lps'),
	(647161, 132, '2015-01-15 00:33:36.000000', 'consum', 0.0211, 'lps'),
	(647162, 132, '2015-01-15 00:33:37.000000', 'consum', 0.0213, 'lps'),
	(647163, 132, '2015-01-15 00:33:38.000000', 'consum', 0.0213, 'lps'),
	(647164, 132, '2015-01-15 00:33:39.000000', 'consum', 0.0214, 'lps'),
	(647165, 132, '2015-01-15 00:33:40.000000', 'consum', 0.0212, 'lps'),
	(647166, 132, '2015-01-15 00:33:41.000000', 'consum', 0.0218, 'lps'),
	(647167, 132, '2015-01-15 00:33:42.000000', 'consum', 0.0213, 'lps'),
	(647168, 132, '2015-01-15 00:33:43.000000', 'consum', 0.0211, 'lps'),
	(647169, 132, '2015-01-15 00:33:44.000000', 'consum', 0.0218, 'lps'),
	(647170, 132, '2015-01-15 00:33:45.000000', 'consum', 0.0213, 'lps'),
	(647171, 132, '2015-01-15 00:33:46.000000', 'consum', 0.0212, 'lps'),
	(647172, 132, '2015-01-15 00:33:47.000000', 'consum', 0.0212, 'lps'),
	(647173, 132, '2015-01-15 00:33:48.000000', 'consum', 0.0216, 'lps'),
	(647174, 132, '2015-01-15 00:33:49.000000', 'consum', 0.0213, 'lps'),
	(647175, 132, '2015-01-15 00:33:50.000000', 'consum', 0.0217, 'lps'),
	(647176, 132, '2015-01-15 00:33:51.000000', 'consum', 0.0213, 'lps'),
	(647177, 132, '2015-01-15 00:33:52.000000', 'consum', 0.0218, 'lps'),
	(647178, 132, '2015-01-15 00:33:53.000000', 'consum', 0.0220, 'lps'),
	(647179, 132, '2015-01-15 00:33:54.000000', 'consum', 0.0214, 'lps'),
	(647180, 132, '2015-01-15 00:33:55.000000', 'consum', 0.0213, 'lps'),
	(647181, 132, '2015-01-15 00:33:56.000000', 'consum', 0.0211, 'lps'),
	(647182, 132, '2015-01-15 00:33:57.000000', 'consum', 0.0220, 'lps'),
	(647183, 132, '2015-01-15 00:33:58.000000', 'consum', 0.0213, 'lps'),
	(647184, 132, '2015-01-15 00:33:59.000000', 'consum', 0.0216, 'lps'),
	(647185, 132, '2015-01-15 00:34:00.000000', 'consum', 0.0220, 'lps'),
	(647186, 132, '2015-01-15 00:34:01.000000', 'consum', 0.0212, 'lps'),
	(647187, 132, '2015-01-15 00:34:02.000000', 'consum', 0.0212, 'lps'),
	(647188, 132, '2015-01-15 00:34:03.000000', 'consum', 0.0215, 'lps'),
	(647189, 132, '2015-01-15 00:34:04.000000', 'consum', 0.0216, 'lps'),
	(647190, 132, '2015-01-15 00:34:05.000000', 'consum', 0.0215, 'lps'),
	(647191, 132, '2015-01-15 00:34:06.000000', 'consum', 0.0219, 'lps'),
	(647192, 132, '2015-01-15 00:34:07.000000', 'consum', 0.0216, 'lps'),
	(647193, 132, '2015-01-15 00:34:08.000000', 'consum', 0.0216, 'lps'),
	(647194, 132, '2015-01-15 00:34:09.000000', 'consum', 0.0212, 'lps'),
	(647195, 132, '2015-01-15 00:34:10.000000', 'consum', 0.0213, 'lps'),
	(647196, 132, '2015-01-15 00:34:11.000000', 'consum', 0.0210, 'lps'),
	(647197, 132, '2015-01-15 00:34:12.000000', 'consum', 0.0211, 'lps'),
	(647198, 132, '2015-01-15 00:34:13.000000', 'consum', 0.0215, 'lps'),
	(647199, 132, '2015-01-15 00:34:14.000000', 'consum', 0.0211, 'lps'),
	(647200, 132, '2015-01-15 00:34:15.000000', 'consum', 0.0213, 'lps'),
	(647201, 132, '2015-01-15 00:34:16.000000', 'consum', 0.0212, 'lps'),
	(647202, 132, '2015-01-15 00:34:17.000000', 'consum', 0.0211, 'lps'),
	(647203, 132, '2015-01-15 00:34:18.000000', 'consum', 0.0211, 'lps'),
	(647204, 132, '2015-01-15 00:34:19.000000', 'consum', 0.0220, 'lps'),
	(647205, 132, '2015-01-15 00:34:20.000000', 'consum', 0.0217, 'lps'),
	(647206, 132, '2015-01-15 00:34:21.000000', 'consum', 0.0213, 'lps'),
	(647207, 132, '2015-01-15 00:34:22.000000', 'consum', 0.0217, 'lps'),
	(647208, 132, '2015-01-15 00:34:23.000000', 'consum', 0.0214, 'lps'),
	(647209, 132, '2015-01-15 00:34:24.000000', 'consum', 0.0211, 'lps'),
	(647210, 132, '2015-01-15 00:34:25.000000', 'consum', 0.0215, 'lps'),
	(647211, 132, '2015-01-15 00:34:26.000000', 'consum', 0.0211, 'lps'),
	(647212, 132, '2015-01-15 00:34:27.000000', 'consum', 0.0211, 'lps'),
	(647213, 132, '2015-01-15 00:34:28.000000', 'consum', 0.0212, 'lps'),
	(647214, 132, '2015-01-15 00:34:29.000000', 'consum', 0.0216, 'lps'),
	(647215, 132, '2015-01-15 00:34:30.000000', 'consum', 0.0212, 'lps'),
	(647216, 132, '2015-01-15 00:34:31.000000', 'consum', 0.0216, 'lps'),
	(647217, 132, '2015-01-15 00:34:32.000000', 'consum', 0.0211, 'lps'),
	(647218, 132, '2015-01-15 00:34:33.000000', 'consum', 0.0218, 'lps'),
	(647219, 132, '2015-01-15 00:34:34.000000', 'consum', 0.0215, 'lps'),
	(647220, 132, '2015-01-15 00:34:35.000000', 'consum', 0.0212, 'lps'),
	(647221, 132, '2015-01-15 00:34:36.000000', 'consum', 0.0217, 'lps'),
	(647222, 132, '2015-01-15 00:34:37.000000', 'consum', 0.0219, 'lps'),
	(647223, 132, '2015-01-15 00:34:38.000000', 'consum', 0.0210, 'lps'),
	(647224, 132, '2015-01-15 00:34:39.000000', 'consum', 0.0217, 'lps'),
	(647225, 132, '2015-01-15 00:34:40.000000', 'consum', 0.0214, 'lps'),
	(647226, 132, '2015-01-15 00:34:41.000000', 'consum', 0.0211, 'lps'),
	(647227, 132, '2015-01-15 00:34:42.000000', 'consum', 0.0211, 'lps'),
	(647228, 132, '2015-01-15 00:34:43.000000', 'consum', 0.0213, 'lps'),
	(647229, 132, '2015-01-15 00:34:44.000000', 'consum', 0.0210, 'lps'),
	(647230, 132, '2015-01-15 00:34:45.000000', 'consum', 0.0215, 'lps'),
	(647231, 132, '2015-01-15 00:34:46.000000', 'consum', 0.0211, 'lps'),
	(647232, 132, '2015-01-15 00:34:47.000000', 'consum', 0.0214, 'lps'),
	(647233, 132, '2015-01-15 00:34:48.000000', 'consum', 0.0218, 'lps'),
	(647234, 132, '2015-01-15 00:34:49.000000', 'consum', 0.0214, 'lps'),
	(647235, 132, '2015-01-15 00:34:50.000000', 'consum', 0.0217, 'lps'),
	(647236, 132, '2015-01-15 00:34:51.000000', 'consum', 0.0211, 'lps'),
	(647237, 132, '2015-01-15 00:34:52.000000', 'consum', 0.0216, 'lps'),
	(647238, 132, '2015-01-15 00:34:53.000000', 'consum', 0.0217, 'lps'),
	(647239, 132, '2015-01-15 00:34:54.000000', 'consum', 0.0216, 'lps'),
	(647240, 132, '2015-01-15 00:34:55.000000', 'consum', 0.0219, 'lps'),
	(647241, 132, '2015-01-15 00:34:56.000000', 'consum', 0.0216, 'lps'),
	(647242, 132, '2015-01-15 00:34:57.000000', 'consum', 0.0215, 'lps'),
	(647243, 132, '2015-01-15 00:34:58.000000', 'consum', 0.0216, 'lps'),
	(647244, 132, '2015-01-15 00:34:59.000000', 'consum', 0.0215, 'lps'),
	(647245, 132, '2015-01-15 00:35:00.000000', 'consum', 0.0217, 'lps'),
	(647246, 132, '2015-01-15 00:35:01.000000', 'consum', 0.0219, 'lps'),
	(647247, 132, '2015-01-15 00:35:02.000000', 'consum', 0.0215, 'lps'),
	(647248, 132, '2015-01-15 00:35:03.000000', 'consum', 0.0219, 'lps'),
	(647249, 132, '2015-01-15 00:35:04.000000', 'consum', 0.0216, 'lps'),
	(647250, 132, '2015-01-15 00:35:05.000000', 'consum', 0.0216, 'lps'),
	(647251, 132, '2015-01-15 00:35:06.000000', 'consum', 0.0210, 'lps'),
	(647252, 132, '2015-01-15 00:35:07.000000', 'consum', 0.0213, 'lps'),
	(647253, 132, '2015-01-15 00:35:08.000000', 'consum', 0.0218, 'lps'),
	(647254, 132, '2015-01-15 00:35:09.000000', 'consum', 0.0217, 'lps'),
	(647255, 132, '2015-01-15 00:35:10.000000', 'consum', 0.0220, 'lps'),
	(647256, 132, '2015-01-15 00:35:11.000000', 'consum', 0.0220, 'lps'),
	(647257, 132, '2015-01-15 00:35:12.000000', 'consum', 0.0220, 'lps'),
	(647258, 132, '2015-01-15 00:35:13.000000', 'consum', 0.0210, 'lps'),
	(647259, 132, '2015-01-15 00:35:14.000000', 'consum', 0.0210, 'lps'),
	(647260, 132, '2015-01-15 00:35:15.000000', 'consum', 0.0212, 'lps'),
	(647261, 132, '2015-01-15 00:35:16.000000', 'consum', 0.0220, 'lps'),
	(647262, 132, '2015-01-15 00:35:17.000000', 'consum', 0.0210, 'lps'),
	(647263, 132, '2015-01-15 00:35:18.000000', 'consum', 0.0216, 'lps'),
	(647264, 132, '2015-01-15 00:35:19.000000', 'consum', 0.0217, 'lps'),
	(647265, 132, '2015-01-15 00:35:20.000000', 'consum', 0.0215, 'lps'),
	(647266, 132, '2015-01-15 00:35:21.000000', 'consum', 0.0217, 'lps'),
	(647267, 132, '2015-01-15 00:35:22.000000', 'consum', 0.0220, 'lps'),
	(647268, 132, '2015-01-15 00:35:23.000000', 'consum', 0.0218, 'lps'),
	(647269, 132, '2015-01-15 00:35:24.000000', 'consum', 0.0219, 'lps'),
	(647270, 132, '2015-01-15 00:35:25.000000', 'consum', 0.0210, 'lps'),
	(647271, 132, '2015-01-15 00:35:26.000000', 'consum', 0.0216, 'lps'),
	(647272, 132, '2015-01-15 00:35:27.000000', 'consum', 0.0210, 'lps'),
	(647273, 132, '2015-01-15 00:35:28.000000', 'consum', 0.0212, 'lps'),
	(647274, 132, '2015-01-15 00:35:29.000000', 'consum', 0.0220, 'lps'),
	(647275, 132, '2015-01-15 00:35:30.000000', 'consum', 0.0212, 'lps'),
	(647276, 132, '2015-01-15 00:35:31.000000', 'consum', 0.0213, 'lps'),
	(647277, 132, '2015-01-15 00:35:32.000000', 'consum', 0.0217, 'lps'),
	(647278, 132, '2015-01-15 00:35:33.000000', 'consum', 0.0217, 'lps'),
	(647279, 132, '2015-01-15 00:35:34.000000', 'consum', 0.0212, 'lps'),
	(647280, 132, '2015-01-15 00:35:35.000000', 'consum', 0.0212, 'lps'),
	(647281, 132, '2015-01-15 00:35:36.000000', 'consum', 0.0214, 'lps'),
	(647282, 132, '2015-01-15 00:35:37.000000', 'consum', 0.0215, 'lps'),
	(647283, 132, '2015-01-15 00:35:38.000000', 'consum', 0.0212, 'lps'),
	(647284, 132, '2015-01-15 00:35:39.000000', 'consum', 0.0214, 'lps'),
	(647285, 132, '2015-01-15 00:35:40.000000', 'consum', 0.0215, 'lps'),
	(647286, 132, '2015-01-15 00:35:41.000000', 'consum', 0.0213, 'lps'),
	(647287, 132, '2015-01-15 00:35:42.000000', 'consum', 0.0220, 'lps'),
	(647288, 132, '2015-01-15 00:35:43.000000', 'consum', 0.0218, 'lps'),
	(647289, 132, '2015-01-15 00:35:44.000000', 'consum', 0.0210, 'lps'),
	(647290, 132, '2015-01-15 00:35:45.000000', 'consum', 0.0219, 'lps'),
	(647291, 132, '2015-01-15 00:35:46.000000', 'consum', 0.0213, 'lps'),
	(647292, 132, '2015-01-15 00:35:47.000000', 'consum', 0.0218, 'lps'),
	(647293, 132, '2015-01-15 00:35:48.000000', 'consum', 0.0220, 'lps'),
	(647294, 132, '2015-01-15 00:35:49.000000', 'consum', 0.0214, 'lps'),
	(647295, 132, '2015-01-15 00:35:50.000000', 'consum', 0.0213, 'lps'),
	(647296, 132, '2015-01-15 00:35:51.000000', 'consum', 0.0213, 'lps'),
	(647297, 132, '2015-01-15 00:35:52.000000', 'consum', 0.0216, 'lps'),
	(647298, 132, '2015-01-15 00:35:53.000000', 'consum', 0.0211, 'lps'),
	(647299, 132, '2015-01-15 00:35:54.000000', 'consum', 0.0217, 'lps'),
	(647300, 132, '2015-01-15 00:35:55.000000', 'consum', 0.0220, 'lps'),
	(647301, 132, '2015-01-15 00:35:56.000000', 'consum', 0.0217, 'lps'),
	(647302, 132, '2015-01-15 00:35:57.000000', 'consum', 0.0218, 'lps'),
	(647303, 132, '2015-01-15 00:35:58.000000', 'consum', 0.0218, 'lps'),
	(647304, 132, '2015-01-15 00:35:59.000000', 'consum', 0.0214, 'lps'),
	(647305, 132, '2015-01-15 00:36:00.000000', 'consum', 0.0220, 'lps'),
	(647306, 132, '2015-01-15 00:36:01.000000', 'consum', 0.0216, 'lps'),
	(647307, 132, '2015-01-15 00:36:02.000000', 'consum', 0.0220, 'lps'),
	(647308, 132, '2015-01-15 00:36:03.000000', 'consum', 0.0220, 'lps'),
	(647309, 132, '2015-01-15 00:36:04.000000', 'consum', 0.0219, 'lps'),
	(647310, 132, '2015-01-15 00:36:05.000000', 'consum', 0.0213, 'lps'),
	(647311, 132, '2015-01-15 00:36:06.000000', 'consum', 0.0212, 'lps'),
	(647312, 132, '2015-01-15 00:36:07.000000', 'consum', 0.0213, 'lps'),
	(647313, 132, '2015-01-15 00:36:08.000000', 'consum', 0.0218, 'lps'),
	(647314, 132, '2015-01-15 00:36:09.000000', 'consum', 0.0219, 'lps'),
	(647315, 132, '2015-01-15 00:36:10.000000', 'consum', 0.0220, 'lps'),
	(647316, 132, '2015-01-15 00:36:11.000000', 'consum', 0.0214, 'lps'),
	(647317, 132, '2015-01-15 00:36:12.000000', 'consum', 0.0219, 'lps'),
	(647318, 132, '2015-01-15 00:36:13.000000', 'consum', 0.0212, 'lps'),
	(647319, 132, '2015-01-15 00:36:14.000000', 'consum', 0.0217, 'lps'),
	(647320, 132, '2015-01-15 00:36:15.000000', 'consum', 0.0215, 'lps'),
	(647321, 132, '2015-01-15 00:36:16.000000', 'consum', 0.0214, 'lps'),
	(647322, 132, '2015-01-15 00:36:17.000000', 'consum', 0.0216, 'lps'),
	(647323, 132, '2015-01-15 00:36:18.000000', 'consum', 0.0217, 'lps'),
	(647324, 132, '2015-01-15 00:36:19.000000', 'consum', 0.0216, 'lps'),
	(647325, 132, '2015-01-15 00:36:20.000000', 'consum', 0.0219, 'lps'),
	(647326, 132, '2015-01-15 00:36:21.000000', 'consum', 0.0214, 'lps'),
	(647327, 132, '2015-01-15 00:36:22.000000', 'consum', 0.0218, 'lps'),
	(647328, 132, '2015-01-15 00:36:23.000000', 'consum', 0.0215, 'lps'),
	(647329, 132, '2015-01-15 00:36:24.000000', 'consum', 0.0213, 'lps'),
	(647330, 132, '2015-01-15 00:36:25.000000', 'consum', 0.0210, 'lps'),
	(647331, 132, '2015-01-15 00:36:26.000000', 'consum', 0.0214, 'lps'),
	(647332, 132, '2015-01-15 00:36:27.000000', 'consum', 0.0217, 'lps'),
	(647333, 132, '2015-01-15 00:36:28.000000', 'consum', 0.0212, 'lps'),
	(647334, 132, '2015-01-15 00:36:29.000000', 'consum', 0.0211, 'lps'),
	(647335, 132, '2015-01-15 00:36:30.000000', 'consum', 0.0211, 'lps'),
	(647336, 132, '2015-01-15 00:36:31.000000', 'consum', 0.0220, 'lps'),
	(647337, 132, '2015-01-15 00:36:32.000000', 'consum', 0.0217, 'lps'),
	(647338, 132, '2015-01-15 00:36:33.000000', 'consum', 0.0213, 'lps'),
	(647339, 132, '2015-01-15 00:36:34.000000', 'consum', 0.0218, 'lps'),
	(647340, 132, '2015-01-15 00:36:35.000000', 'consum', 0.0217, 'lps'),
	(647341, 132, '2015-01-15 00:36:36.000000', 'consum', 0.0210, 'lps'),
	(647342, 132, '2015-01-15 00:36:37.000000', 'consum', 0.0213, 'lps'),
	(647343, 132, '2015-01-15 00:36:38.000000', 'consum', 0.0213, 'lps'),
	(647344, 132, '2015-01-15 00:36:39.000000', 'consum', 0.0217, 'lps'),
	(647345, 132, '2015-01-15 00:36:40.000000', 'consum', 0.0215, 'lps'),
	(647346, 132, '2015-01-15 00:36:41.000000', 'consum', 0.0215, 'lps'),
	(647347, 132, '2015-01-15 00:36:42.000000', 'consum', 0.0218, 'lps'),
	(647348, 132, '2015-01-15 00:36:43.000000', 'consum', 0.0215, 'lps'),
	(647349, 132, '2015-01-15 00:36:44.000000', 'consum', 0.0210, 'lps'),
	(647350, 132, '2015-01-15 00:36:45.000000', 'consum', 0.0218, 'lps'),
	(647351, 132, '2015-01-15 00:36:46.000000', 'consum', 0.0220, 'lps'),
	(647352, 132, '2015-01-15 00:36:47.000000', 'consum', 0.0213, 'lps'),
	(647353, 132, '2015-01-15 00:36:48.000000', 'consum', 0.0217, 'lps'),
	(647354, 132, '2015-01-15 00:36:49.000000', 'consum', 0.0215, 'lps'),
	(647355, 132, '2015-01-15 00:36:50.000000', 'consum', 0.0214, 'lps'),
	(647356, 132, '2015-01-15 00:36:51.000000', 'consum', 0.0217, 'lps'),
	(647357, 132, '2015-01-15 00:36:52.000000', 'consum', 0.0211, 'lps'),
	(647358, 132, '2015-01-15 00:36:53.000000', 'consum', 0.0216, 'lps'),
	(647359, 132, '2015-01-15 00:36:54.000000', 'consum', 0.0216, 'lps'),
	(647360, 132, '2015-01-15 00:36:55.000000', 'consum', 0.0211, 'lps'),
	(647361, 132, '2015-01-15 00:36:56.000000', 'consum', 0.0218, 'lps'),
	(647362, 132, '2015-01-15 00:36:57.000000', 'consum', 0.0216, 'lps'),
	(647363, 132, '2015-01-15 00:36:58.000000', 'consum', 0.0215, 'lps'),
	(647364, 132, '2015-01-15 00:36:59.000000', 'consum', 0.0219, 'lps'),
	(647365, 132, '2015-01-15 00:37:00.000000', 'consum', 0.0220, 'lps'),
	(647366, 132, '2015-01-15 00:37:01.000000', 'consum', 0.0210, 'lps'),
	(647367, 132, '2015-01-15 00:37:02.000000', 'consum', 0.0214, 'lps'),
	(647368, 132, '2015-01-15 00:37:03.000000', 'consum', 0.0218, 'lps'),
	(647369, 132, '2015-01-15 00:37:04.000000', 'consum', 0.0216, 'lps'),
	(647370, 132, '2015-01-15 00:37:05.000000', 'consum', 0.0216, 'lps'),
	(647371, 132, '2015-01-15 00:37:06.000000', 'consum', 0.0213, 'lps'),
	(647372, 132, '2015-01-15 00:37:07.000000', 'consum', 0.0220, 'lps'),
	(647373, 132, '2015-01-15 00:37:08.000000', 'consum', 0.0216, 'lps'),
	(647374, 132, '2015-01-15 00:37:09.000000', 'consum', 0.0210, 'lps'),
	(647375, 132, '2015-01-15 00:37:10.000000', 'consum', 0.0216, 'lps'),
	(647376, 132, '2015-01-15 00:37:11.000000', 'consum', 0.0218, 'lps'),
	(647377, 132, '2015-01-15 00:37:12.000000', 'consum', 0.0212, 'lps'),
	(647378, 132, '2015-01-15 00:37:13.000000', 'consum', 0.0217, 'lps'),
	(647379, 132, '2015-01-15 00:37:14.000000', 'consum', 0.0216, 'lps'),
	(647380, 132, '2015-01-15 00:37:15.000000', 'consum', 0.0211, 'lps'),
	(647381, 132, '2015-01-15 00:37:16.000000', 'consum', 0.0220, 'lps'),
	(647382, 132, '2015-01-15 00:37:17.000000', 'consum', 0.0214, 'lps'),
	(647383, 132, '2015-01-15 00:37:18.000000', 'consum', 0.0211, 'lps'),
	(647384, 132, '2015-01-15 00:37:19.000000', 'consum', 0.0214, 'lps'),
	(647385, 132, '2015-01-15 00:37:20.000000', 'consum', 0.0216, 'lps'),
	(647386, 132, '2015-01-15 00:37:21.000000', 'consum', 0.0218, 'lps'),
	(647387, 132, '2015-01-15 00:37:22.000000', 'consum', 0.0213, 'lps'),
	(647388, 132, '2015-01-15 00:37:23.000000', 'consum', 0.0220, 'lps'),
	(647389, 132, '2015-01-15 00:37:24.000000', 'consum', 0.0218, 'lps'),
	(647390, 132, '2015-01-15 00:37:25.000000', 'consum', 0.0210, 'lps'),
	(647391, 132, '2015-01-15 00:37:26.000000', 'consum', 0.0220, 'lps'),
	(647392, 132, '2015-01-15 00:37:27.000000', 'consum', 0.0216, 'lps'),
	(647393, 132, '2015-01-15 00:37:28.000000', 'consum', 0.0213, 'lps'),
	(647394, 132, '2015-01-15 00:37:29.000000', 'consum', 0.0217, 'lps'),
	(647395, 132, '2015-01-15 00:37:30.000000', 'consum', 0.0213, 'lps'),
	(647396, 132, '2015-01-15 00:37:31.000000', 'consum', 0.0216, 'lps'),
	(647397, 132, '2015-01-15 00:37:32.000000', 'consum', 0.0211, 'lps'),
	(647398, 132, '2015-01-15 00:37:33.000000', 'consum', 0.0218, 'lps'),
	(647399, 132, '2015-01-15 00:37:34.000000', 'consum', 0.0215, 'lps'),
	(647400, 132, '2015-01-15 00:37:35.000000', 'consum', 0.0212, 'lps'),
	(647401, 132, '2015-01-15 00:37:36.000000', 'consum', 0.0215, 'lps'),
	(647402, 132, '2015-01-15 00:37:37.000000', 'consum', 0.0219, 'lps'),
	(647403, 132, '2015-01-15 00:37:38.000000', 'consum', 0.0217, 'lps'),
	(647404, 132, '2015-01-15 00:37:39.000000', 'consum', 0.0211, 'lps'),
	(647405, 132, '2015-01-15 00:37:40.000000', 'consum', 0.0213, 'lps'),
	(647406, 132, '2015-01-15 00:37:41.000000', 'consum', 0.0214, 'lps'),
	(647407, 132, '2015-01-15 00:37:42.000000', 'consum', 0.0211, 'lps'),
	(647408, 132, '2015-01-15 00:37:43.000000', 'consum', 0.0213, 'lps'),
	(647409, 132, '2015-01-15 00:37:44.000000', 'consum', 0.0212, 'lps'),
	(647410, 132, '2015-01-15 00:37:45.000000', 'consum', 0.0211, 'lps'),
	(647411, 132, '2015-01-15 00:37:46.000000', 'consum', 0.0220, 'lps'),
	(647412, 132, '2015-01-15 00:37:47.000000', 'consum', 0.0212, 'lps'),
	(647413, 132, '2015-01-15 00:37:48.000000', 'consum', 0.0216, 'lps'),
	(647414, 132, '2015-01-15 00:37:49.000000', 'consum', 0.0211, 'lps'),
	(647415, 132, '2015-01-15 00:37:50.000000', 'consum', 0.0220, 'lps'),
	(647416, 132, '2015-01-15 00:37:51.000000', 'consum', 0.0212, 'lps'),
	(647417, 132, '2015-01-15 00:37:52.000000', 'consum', 0.0213, 'lps'),
	(647418, 132, '2015-01-15 00:37:53.000000', 'consum', 0.0219, 'lps'),
	(647419, 132, '2015-01-15 00:37:54.000000', 'consum', 0.0212, 'lps'),
	(647420, 132, '2015-01-15 00:37:55.000000', 'consum', 0.0218, 'lps'),
	(647421, 132, '2015-01-15 00:37:56.000000', 'consum', 0.0212, 'lps'),
	(647422, 132, '2015-01-15 00:37:57.000000', 'consum', 0.0219, 'lps'),
	(647423, 132, '2015-01-15 00:37:58.000000', 'consum', 0.0214, 'lps'),
	(647424, 132, '2015-01-15 00:37:59.000000', 'consum', 0.0214, 'lps'),
	(647425, 132, '2015-01-15 00:38:00.000000', 'consum', 0.0219, 'lps'),
	(647426, 132, '2015-01-15 00:38:01.000000', 'consum', 0.0220, 'lps'),
	(647427, 132, '2015-01-15 00:38:02.000000', 'consum', 0.0213, 'lps'),
	(647428, 132, '2015-01-15 00:38:03.000000', 'consum', 0.0217, 'lps'),
	(647429, 132, '2015-01-15 00:38:04.000000', 'consum', 0.0217, 'lps'),
	(647430, 132, '2015-01-15 00:38:05.000000', 'consum', 0.0211, 'lps'),
	(647431, 132, '2015-01-15 00:38:06.000000', 'consum', 0.0219, 'lps'),
	(647432, 132, '2015-01-15 00:38:07.000000', 'consum', 0.0217, 'lps'),
	(647433, 132, '2015-01-15 00:38:08.000000', 'consum', 0.0219, 'lps'),
	(647434, 132, '2015-01-15 00:38:09.000000', 'consum', 0.0215, 'lps'),
	(647435, 132, '2015-01-15 00:38:10.000000', 'consum', 0.0217, 'lps'),
	(647436, 132, '2015-01-15 00:38:11.000000', 'consum', 0.0210, 'lps'),
	(647437, 132, '2015-01-15 00:38:12.000000', 'consum', 0.0210, 'lps'),
	(647438, 132, '2015-01-15 00:38:13.000000', 'consum', 0.0213, 'lps'),
	(647439, 132, '2015-01-15 00:38:14.000000', 'consum', 0.0214, 'lps'),
	(647440, 132, '2015-01-15 00:38:15.000000', 'consum', 0.0219, 'lps'),
	(647441, 132, '2015-01-15 00:38:16.000000', 'consum', 0.0212, 'lps'),
	(647442, 132, '2015-01-15 00:38:17.000000', 'consum', 0.0215, 'lps'),
	(647443, 132, '2015-01-15 00:38:18.000000', 'consum', 0.0218, 'lps'),
	(647444, 132, '2015-01-15 00:38:19.000000', 'consum', 0.0214, 'lps'),
	(647445, 132, '2015-01-15 00:38:20.000000', 'consum', 0.0217, 'lps'),
	(647446, 132, '2015-01-15 00:38:21.000000', 'consum', 0.0214, 'lps'),
	(647447, 132, '2015-01-15 00:38:22.000000', 'consum', 0.0218, 'lps'),
	(647448, 132, '2015-01-15 00:38:23.000000', 'consum', 0.0219, 'lps'),
	(647449, 132, '2015-01-15 00:38:24.000000', 'consum', 0.0220, 'lps'),
	(647450, 132, '2015-01-15 00:38:25.000000', 'consum', 0.0213, 'lps'),
	(647451, 132, '2015-01-15 00:38:26.000000', 'consum', 0.0215, 'lps'),
	(647452, 132, '2015-01-15 00:38:27.000000', 'consum', 0.0216, 'lps'),
	(647453, 132, '2015-01-15 00:38:28.000000', 'consum', 0.0214, 'lps'),
	(647454, 132, '2015-01-15 00:38:29.000000', 'consum', 0.0214, 'lps'),
	(647455, 132, '2015-01-15 00:38:30.000000', 'consum', 0.0217, 'lps'),
	(647456, 132, '2015-01-15 00:38:31.000000', 'consum', 0.0213, 'lps'),
	(647457, 132, '2015-01-15 00:38:32.000000', 'consum', 0.0214, 'lps'),
	(647458, 132, '2015-01-15 00:38:33.000000', 'consum', 0.0220, 'lps'),
	(647459, 132, '2015-01-15 00:38:34.000000', 'consum', 0.0218, 'lps'),
	(647460, 132, '2015-01-15 00:38:35.000000', 'consum', 0.0210, 'lps'),
	(647461, 132, '2015-01-15 00:38:36.000000', 'consum', 0.0218, 'lps'),
	(647462, 132, '2015-01-15 00:38:37.000000', 'consum', 0.0219, 'lps'),
	(647463, 132, '2015-01-15 00:38:38.000000', 'consum', 0.0219, 'lps'),
	(647464, 132, '2015-01-15 00:38:39.000000', 'consum', 0.0216, 'lps'),
	(647465, 132, '2015-01-15 00:38:40.000000', 'consum', 0.0215, 'lps'),
	(647466, 132, '2015-01-15 00:38:41.000000', 'consum', 0.0217, 'lps'),
	(647467, 132, '2015-01-15 00:38:42.000000', 'consum', 0.0210, 'lps'),
	(647468, 132, '2015-01-15 00:38:43.000000', 'consum', 0.0212, 'lps'),
	(647469, 132, '2015-01-15 00:38:44.000000', 'consum', 0.0218, 'lps'),
	(647470, 132, '2015-01-15 00:38:45.000000', 'consum', 0.0211, 'lps'),
	(647471, 132, '2015-01-15 00:38:46.000000', 'consum', 0.0214, 'lps'),
	(647472, 132, '2015-01-15 00:38:47.000000', 'consum', 0.0216, 'lps'),
	(647473, 132, '2015-01-15 00:38:48.000000', 'consum', 0.0218, 'lps'),
	(647474, 132, '2015-01-15 00:38:49.000000', 'consum', 0.0210, 'lps'),
	(647475, 132, '2015-01-15 00:38:50.000000', 'consum', 0.0218, 'lps'),
	(647476, 132, '2015-01-15 00:38:51.000000', 'consum', 0.0219, 'lps'),
	(647477, 132, '2015-01-15 00:38:52.000000', 'consum', 0.0220, 'lps'),
	(647478, 132, '2015-01-15 00:38:53.000000', 'consum', 0.0211, 'lps'),
	(647479, 132, '2015-01-15 00:38:54.000000', 'consum', 0.0217, 'lps'),
	(647480, 132, '2015-01-15 00:38:55.000000', 'consum', 0.0211, 'lps'),
	(647481, 132, '2015-01-15 00:38:56.000000', 'consum', 0.0217, 'lps'),
	(647482, 132, '2015-01-15 00:38:57.000000', 'consum', 0.0220, 'lps'),
	(647483, 132, '2015-01-15 00:38:58.000000', 'consum', 0.0219, 'lps'),
	(647484, 132, '2015-01-15 00:38:59.000000', 'consum', 0.0213, 'lps'),
	(647485, 132, '2015-01-15 00:39:00.000000', 'consum', 0.0219, 'lps'),
	(647486, 132, '2015-01-15 00:39:01.000000', 'consum', 0.0217, 'lps'),
	(647487, 132, '2015-01-15 00:39:02.000000', 'consum', 0.0216, 'lps'),
	(647488, 132, '2015-01-15 00:39:03.000000', 'consum', 0.0210, 'lps'),
	(647489, 132, '2015-01-15 00:39:04.000000', 'consum', 0.0214, 'lps'),
	(647490, 132, '2015-01-15 00:39:05.000000', 'consum', 0.0210, 'lps'),
	(647491, 132, '2015-01-15 00:39:06.000000', 'consum', 0.0220, 'lps'),
	(647492, 132, '2015-01-15 00:39:07.000000', 'consum', 0.0217, 'lps'),
	(647493, 132, '2015-01-15 00:39:08.000000', 'consum', 0.0213, 'lps'),
	(647494, 132, '2015-01-15 00:39:09.000000', 'consum', 0.0219, 'lps'),
	(647495, 132, '2015-01-15 00:39:10.000000', 'consum', 0.0212, 'lps'),
	(647496, 132, '2015-01-15 00:39:11.000000', 'consum', 0.0214, 'lps'),
	(647497, 132, '2015-01-15 00:39:12.000000', 'consum', 0.0214, 'lps'),
	(647498, 132, '2015-01-15 00:39:13.000000', 'consum', 0.0218, 'lps'),
	(647499, 132, '2015-01-15 00:39:14.000000', 'consum', 0.0219, 'lps'),
	(647500, 132, '2015-01-15 00:39:15.000000', 'consum', 0.0218, 'lps'),
	(647501, 132, '2015-01-15 00:39:16.000000', 'consum', 0.0211, 'lps'),
	(647502, 132, '2015-01-15 00:39:17.000000', 'consum', 0.0217, 'lps'),
	(647503, 132, '2015-01-15 00:39:18.000000', 'consum', 0.0220, 'lps'),
	(647504, 132, '2015-01-15 00:39:19.000000', 'consum', 0.0215, 'lps'),
	(647505, 132, '2015-01-15 00:39:20.000000', 'consum', 0.0220, 'lps'),
	(647506, 132, '2015-01-15 00:39:21.000000', 'consum', 0.0210, 'lps'),
	(647507, 132, '2015-01-15 00:39:22.000000', 'consum', 0.0215, 'lps'),
	(647508, 132, '2015-01-15 00:39:23.000000', 'consum', 0.0214, 'lps'),
	(647509, 132, '2015-01-15 00:39:24.000000', 'consum', 0.0216, 'lps'),
	(647510, 132, '2015-01-15 00:39:25.000000', 'consum', 0.0216, 'lps'),
	(647511, 132, '2015-01-15 00:39:26.000000', 'consum', 0.0211, 'lps'),
	(647512, 132, '2015-01-15 00:39:27.000000', 'consum', 0.0210, 'lps'),
	(647513, 132, '2015-01-15 00:39:28.000000', 'consum', 0.0217, 'lps'),
	(647514, 132, '2015-01-15 00:39:29.000000', 'consum', 0.0214, 'lps'),
	(647515, 132, '2015-01-15 00:39:30.000000', 'consum', 0.0218, 'lps'),
	(647516, 132, '2015-01-15 00:39:31.000000', 'consum', 0.0218, 'lps'),
	(647517, 132, '2015-01-15 00:39:32.000000', 'consum', 0.0216, 'lps'),
	(647518, 132, '2015-01-15 00:39:33.000000', 'consum', 0.0217, 'lps'),
	(647519, 132, '2015-01-15 00:39:34.000000', 'consum', 0.0218, 'lps'),
	(647520, 132, '2015-01-15 00:39:35.000000', 'consum', 0.0216, 'lps'),
	(647521, 132, '2015-01-15 00:39:36.000000', 'consum', 0.0219, 'lps'),
	(647522, 132, '2015-01-15 00:39:37.000000', 'consum', 0.0213, 'lps'),
	(647523, 132, '2015-01-15 00:39:38.000000', 'consum', 0.0220, 'lps'),
	(647524, 132, '2015-01-15 00:39:39.000000', 'consum', 0.0219, 'lps'),
	(647525, 132, '2015-01-15 00:39:40.000000', 'consum', 0.0215, 'lps'),
	(647526, 132, '2015-01-15 00:39:41.000000', 'consum', 0.0219, 'lps'),
	(647527, 132, '2015-01-15 00:39:42.000000', 'consum', 0.0220, 'lps'),
	(647528, 132, '2015-01-15 00:39:43.000000', 'consum', 0.0212, 'lps'),
	(647529, 132, '2015-01-15 00:39:44.000000', 'consum', 0.0213, 'lps'),
	(647530, 132, '2015-01-15 00:39:45.000000', 'consum', 0.0220, 'lps'),
	(647531, 132, '2015-01-15 00:39:46.000000', 'consum', 0.0217, 'lps'),
	(647532, 132, '2015-01-15 00:39:47.000000', 'consum', 0.0215, 'lps'),
	(647533, 132, '2015-01-15 00:39:48.000000', 'consum', 0.0213, 'lps'),
	(647534, 132, '2015-01-15 00:39:49.000000', 'consum', 0.0213, 'lps'),
	(647535, 132, '2015-01-15 00:39:50.000000', 'consum', 0.0214, 'lps'),
	(647536, 132, '2015-01-15 00:39:51.000000', 'consum', 0.0213, 'lps'),
	(647537, 132, '2015-01-15 00:39:52.000000', 'consum', 0.0214, 'lps'),
	(647538, 132, '2015-01-15 00:39:53.000000', 'consum', 0.0211, 'lps'),
	(647539, 132, '2015-01-15 00:39:54.000000', 'consum', 0.0213, 'lps'),
	(647540, 132, '2015-01-15 00:39:55.000000', 'consum', 0.0213, 'lps'),
	(647541, 132, '2015-01-15 00:39:56.000000', 'consum', 0.0216, 'lps'),
	(647542, 132, '2015-01-15 00:39:57.000000', 'consum', 0.0211, 'lps'),
	(647543, 132, '2015-01-15 00:39:58.000000', 'consum', 0.0219, 'lps'),
	(647544, 132, '2015-01-15 00:39:59.000000', 'consum', 0.0210, 'lps'),
	(647545, 132, '2015-01-15 00:40:00.000000', 'consum', 0.0213, 'lps'),
	(647546, 132, '2015-01-15 00:40:01.000000', 'consum', 0.0217, 'lps'),
	(647547, 132, '2015-01-15 00:40:02.000000', 'consum', 0.0216, 'lps'),
	(647548, 132, '2015-01-15 00:40:03.000000', 'consum', 0.0217, 'lps'),
	(647549, 132, '2015-01-15 00:40:04.000000', 'consum', 0.0216, 'lps'),
	(647550, 132, '2015-01-15 00:40:05.000000', 'consum', 0.0210, 'lps'),
	(647551, 132, '2015-01-15 00:40:06.000000', 'consum', 0.0212, 'lps'),
	(647552, 132, '2015-01-15 00:40:07.000000', 'consum', 0.0212, 'lps'),
	(647553, 132, '2015-01-15 00:40:08.000000', 'consum', 0.0214, 'lps'),
	(647554, 132, '2015-01-15 00:40:09.000000', 'consum', 0.0213, 'lps'),
	(647555, 132, '2015-01-15 00:40:10.000000', 'consum', 0.0215, 'lps'),
	(647556, 132, '2015-01-15 00:40:11.000000', 'consum', 0.0216, 'lps'),
	(647557, 132, '2015-01-15 00:40:12.000000', 'consum', 0.0215, 'lps'),
	(647558, 132, '2015-01-15 00:40:13.000000', 'consum', 0.0216, 'lps'),
	(647559, 132, '2015-01-15 00:40:14.000000', 'consum', 0.0213, 'lps'),
	(647560, 132, '2015-01-15 00:40:15.000000', 'consum', 0.0220, 'lps'),
	(647561, 132, '2015-01-15 00:40:16.000000', 'consum', 0.0217, 'lps'),
	(647562, 132, '2015-01-15 00:40:17.000000', 'consum', 0.0216, 'lps'),
	(647563, 132, '2015-01-15 00:40:18.000000', 'consum', 0.0210, 'lps'),
	(647564, 132, '2015-01-15 00:40:19.000000', 'consum', 0.0213, 'lps'),
	(647565, 132, '2015-01-15 00:40:20.000000', 'consum', 0.0217, 'lps'),
	(647566, 132, '2015-01-15 00:40:21.000000', 'consum', 0.0213, 'lps'),
	(647567, 132, '2015-01-15 00:40:22.000000', 'consum', 0.0216, 'lps'),
	(647568, 132, '2015-01-15 00:40:23.000000', 'consum', 0.0211, 'lps'),
	(647569, 132, '2015-01-15 00:40:24.000000', 'consum', 0.0217, 'lps'),
	(647570, 132, '2015-01-15 00:40:25.000000', 'consum', 0.0220, 'lps'),
	(647571, 132, '2015-01-15 00:40:26.000000', 'consum', 0.0219, 'lps'),
	(647572, 132, '2015-01-15 00:40:27.000000', 'consum', 0.0216, 'lps'),
	(647573, 132, '2015-01-15 00:40:28.000000', 'consum', 0.0213, 'lps'),
	(647574, 132, '2015-01-15 00:40:29.000000', 'consum', 0.0218, 'lps'),
	(647575, 132, '2015-01-15 00:40:30.000000', 'consum', 0.0217, 'lps'),
	(647576, 132, '2015-01-15 00:40:31.000000', 'consum', 0.0214, 'lps'),
	(647577, 132, '2015-01-15 00:40:32.000000', 'consum', 0.0219, 'lps'),
	(647578, 132, '2015-01-15 00:40:33.000000', 'consum', 0.0212, 'lps'),
	(647579, 132, '2015-01-15 00:40:34.000000', 'consum', 0.0214, 'lps'),
	(647580, 132, '2015-01-15 00:40:35.000000', 'consum', 0.0212, 'lps'),
	(647581, 132, '2015-01-15 00:40:36.000000', 'consum', 0.0211, 'lps'),
	(647582, 132, '2015-01-15 00:40:37.000000', 'consum', 0.0210, 'lps'),
	(647583, 132, '2015-01-15 00:40:38.000000', 'consum', 0.0217, 'lps'),
	(647584, 132, '2015-01-15 00:40:39.000000', 'consum', 0.0213, 'lps'),
	(647585, 132, '2015-01-15 00:40:40.000000', 'consum', 0.0214, 'lps'),
	(647586, 132, '2015-01-15 00:40:41.000000', 'consum', 0.0213, 'lps'),
	(647587, 132, '2015-01-15 00:40:42.000000', 'consum', 0.0214, 'lps'),
	(647588, 132, '2015-01-15 00:40:43.000000', 'consum', 0.0220, 'lps'),
	(647589, 132, '2015-01-15 00:40:44.000000', 'consum', 0.0214, 'lps'),
	(647590, 132, '2015-01-15 00:40:45.000000', 'consum', 0.0212, 'lps'),
	(647591, 132, '2015-01-15 00:40:46.000000', 'consum', 0.0219, 'lps'),
	(647592, 132, '2015-01-15 00:40:47.000000', 'consum', 0.0218, 'lps'),
	(647593, 132, '2015-01-15 00:40:48.000000', 'consum', 0.0214, 'lps'),
	(647594, 132, '2015-01-15 00:40:49.000000', 'consum', 0.0216, 'lps'),
	(647595, 132, '2015-01-15 00:40:50.000000', 'consum', 0.0216, 'lps'),
	(647596, 132, '2015-01-15 00:40:51.000000', 'consum', 0.0211, 'lps'),
	(647597, 132, '2015-01-15 00:40:52.000000', 'consum', 0.0219, 'lps'),
	(647598, 132, '2015-01-15 00:40:53.000000', 'consum', 0.0219, 'lps'),
	(647599, 132, '2015-01-15 00:40:54.000000', 'consum', 0.0217, 'lps'),
	(647600, 132, '2015-01-15 00:40:55.000000', 'consum', 0.0210, 'lps'),
	(647601, 132, '2015-01-15 00:40:56.000000', 'consum', 0.0213, 'lps'),
	(647602, 132, '2015-01-15 00:40:57.000000', 'consum', 0.0211, 'lps'),
	(647603, 132, '2015-01-15 00:40:58.000000', 'consum', 0.0219, 'lps'),
	(647604, 132, '2015-01-15 00:40:59.000000', 'consum', 0.0218, 'lps'),
	(647605, 132, '2015-01-15 00:41:00.000000', 'consum', 0.0214, 'lps'),
	(647606, 132, '2015-01-15 00:41:01.000000', 'consum', 0.0215, 'lps'),
	(647607, 132, '2015-01-15 00:41:02.000000', 'consum', 0.0214, 'lps'),
	(647608, 132, '2015-01-15 00:41:03.000000', 'consum', 0.0214, 'lps'),
	(647609, 132, '2015-01-15 00:41:04.000000', 'consum', 0.0210, 'lps'),
	(647610, 132, '2015-01-15 00:41:05.000000', 'consum', 0.0220, 'lps'),
	(647611, 132, '2015-01-15 00:41:06.000000', 'consum', 0.0214, 'lps'),
	(647612, 132, '2015-01-15 00:41:07.000000', 'consum', 0.0213, 'lps'),
	(647613, 132, '2015-01-15 00:41:08.000000', 'consum', 0.0215, 'lps'),
	(647614, 132, '2015-01-15 00:41:09.000000', 'consum', 0.0216, 'lps'),
	(647615, 132, '2015-01-15 00:41:10.000000', 'consum', 0.0213, 'lps'),
	(647616, 132, '2015-01-15 00:41:11.000000', 'consum', 0.0219, 'lps'),
	(647617, 132, '2015-01-15 00:41:12.000000', 'consum', 0.0215, 'lps'),
	(647618, 132, '2015-01-15 00:41:13.000000', 'consum', 0.0220, 'lps'),
	(647619, 132, '2015-01-15 00:41:14.000000', 'consum', 0.0212, 'lps'),
	(647620, 132, '2015-01-15 00:41:15.000000', 'consum', 0.0213, 'lps'),
	(647621, 132, '2015-01-15 00:41:16.000000', 'consum', 0.0220, 'lps'),
	(647622, 132, '2015-01-15 00:41:17.000000', 'consum', 0.0220, 'lps'),
	(647623, 132, '2015-01-15 00:41:18.000000', 'consum', 0.0217, 'lps'),
	(647624, 132, '2015-01-15 00:41:19.000000', 'consum', 0.0215, 'lps'),
	(647625, 132, '2015-01-15 00:41:20.000000', 'consum', 0.0215, 'lps'),
	(647626, 132, '2015-01-15 00:41:21.000000', 'consum', 0.0211, 'lps'),
	(647627, 132, '2015-01-15 00:41:22.000000', 'consum', 0.0211, 'lps'),
	(647628, 132, '2015-01-15 00:41:23.000000', 'consum', 0.0213, 'lps'),
	(647629, 132, '2015-01-15 00:41:24.000000', 'consum', 0.0212, 'lps'),
	(647630, 132, '2015-01-15 00:41:25.000000', 'consum', 0.0212, 'lps'),
	(647631, 132, '2015-01-15 00:41:26.000000', 'consum', 0.0212, 'lps'),
	(647632, 132, '2015-01-15 00:41:27.000000', 'consum', 0.0217, 'lps'),
	(647633, 132, '2015-01-15 00:41:28.000000', 'consum', 0.0217, 'lps'),
	(647634, 132, '2015-01-15 00:41:29.000000', 'consum', 0.0212, 'lps'),
	(647635, 132, '2015-01-15 00:41:30.000000', 'consum', 0.0211, 'lps'),
	(647636, 132, '2015-01-15 00:41:31.000000', 'consum', 0.0212, 'lps'),
	(647637, 132, '2015-01-15 00:41:32.000000', 'consum', 0.0215, 'lps'),
	(647638, 132, '2015-01-15 00:41:33.000000', 'consum', 0.0218, 'lps'),
	(647639, 132, '2015-01-15 00:41:34.000000', 'consum', 0.0213, 'lps'),
	(647640, 132, '2015-01-15 00:41:35.000000', 'consum', 0.0215, 'lps'),
	(647641, 132, '2015-01-15 00:41:36.000000', 'consum', 0.0216, 'lps'),
	(647642, 132, '2015-01-15 00:41:37.000000', 'consum', 0.0213, 'lps'),
	(647643, 132, '2015-01-15 00:41:38.000000', 'consum', 0.0219, 'lps'),
	(647644, 132, '2015-01-15 00:41:39.000000', 'consum', 0.0214, 'lps'),
	(647645, 132, '2015-01-15 00:41:40.000000', 'consum', 0.0213, 'lps'),
	(647646, 132, '2015-01-15 00:41:41.000000', 'consum', 0.0213, 'lps'),
	(647647, 132, '2015-01-15 00:41:42.000000', 'consum', 0.0216, 'lps'),
	(647648, 132, '2015-01-15 00:41:43.000000', 'consum', 0.0220, 'lps'),
	(647649, 132, '2015-01-15 00:41:44.000000', 'consum', 0.0212, 'lps'),
	(647650, 132, '2015-01-15 00:41:45.000000', 'consum', 0.0213, 'lps'),
	(647651, 132, '2015-01-15 00:41:46.000000', 'consum', 0.0220, 'lps'),
	(647652, 132, '2015-01-15 00:41:47.000000', 'consum', 0.0219, 'lps'),
	(647653, 132, '2015-01-15 00:41:48.000000', 'consum', 0.0212, 'lps'),
	(647654, 132, '2015-01-15 00:41:49.000000', 'consum', 0.0218, 'lps'),
	(647655, 132, '2015-01-15 00:41:50.000000', 'consum', 0.0220, 'lps'),
	(647656, 132, '2015-01-15 00:41:51.000000', 'consum', 0.0215, 'lps'),
	(647657, 132, '2015-01-15 00:41:52.000000', 'consum', 0.0215, 'lps'),
	(647658, 132, '2015-01-15 00:41:53.000000', 'consum', 0.0210, 'lps'),
	(647659, 132, '2015-01-15 00:41:54.000000', 'consum', 0.0218, 'lps'),
	(647660, 132, '2015-01-15 00:41:55.000000', 'consum', 0.0219, 'lps'),
	(647661, 132, '2015-01-15 00:41:56.000000', 'consum', 0.0219, 'lps'),
	(647662, 132, '2015-01-15 00:41:57.000000', 'consum', 0.0217, 'lps'),
	(647663, 132, '2015-01-15 00:41:58.000000', 'consum', 0.0219, 'lps'),
	(647664, 132, '2015-01-15 00:41:59.000000', 'consum', 0.0213, 'lps'),
	(647665, 132, '2015-01-15 00:42:00.000000', 'consum', 0.0220, 'lps'),
	(647666, 132, '2015-01-15 00:42:01.000000', 'consum', 0.0219, 'lps'),
	(647667, 132, '2015-01-15 00:42:02.000000', 'consum', 0.0213, 'lps'),
	(647668, 132, '2015-01-15 00:42:03.000000', 'consum', 0.0211, 'lps'),
	(647669, 132, '2015-01-15 00:42:04.000000', 'consum', 0.0219, 'lps'),
	(647670, 132, '2015-01-15 00:42:05.000000', 'consum', 0.0218, 'lps'),
	(647671, 132, '2015-01-15 00:42:06.000000', 'consum', 0.0214, 'lps'),
	(647672, 132, '2015-01-15 00:42:07.000000', 'consum', 0.0215, 'lps'),
	(647673, 132, '2015-01-15 00:42:08.000000', 'consum', 0.0214, 'lps'),
	(647674, 132, '2015-01-15 00:42:09.000000', 'consum', 0.0215, 'lps'),
	(647675, 132, '2015-01-15 00:42:10.000000', 'consum', 0.0213, 'lps'),
	(647676, 132, '2015-01-15 00:42:11.000000', 'consum', 0.0219, 'lps'),
	(647677, 132, '2015-01-15 00:42:12.000000', 'consum', 0.0216, 'lps'),
	(647678, 132, '2015-01-15 00:42:13.000000', 'consum', 0.0214, 'lps'),
	(647679, 132, '2015-01-15 00:42:14.000000', 'consum', 0.0212, 'lps'),
	(647680, 132, '2015-01-15 00:42:15.000000', 'consum', 0.0217, 'lps'),
	(647681, 132, '2015-01-15 00:42:16.000000', 'consum', 0.0210, 'lps'),
	(647682, 132, '2015-01-15 00:42:17.000000', 'consum', 0.0211, 'lps'),
	(647683, 132, '2015-01-15 00:42:18.000000', 'consum', 0.0214, 'lps'),
	(647684, 132, '2015-01-15 00:42:19.000000', 'consum', 0.0216, 'lps'),
	(647685, 132, '2015-01-15 00:42:20.000000', 'consum', 0.0220, 'lps'),
	(647686, 132, '2015-01-15 00:42:21.000000', 'consum', 0.0210, 'lps'),
	(647687, 132, '2015-01-15 00:42:22.000000', 'consum', 0.0212, 'lps'),
	(647688, 132, '2015-01-15 00:42:23.000000', 'consum', 0.0211, 'lps'),
	(647689, 132, '2015-01-15 00:42:24.000000', 'consum', 0.0210, 'lps'),
	(647690, 132, '2015-01-15 00:42:25.000000', 'consum', 0.0220, 'lps'),
	(647691, 132, '2015-01-15 00:42:26.000000', 'consum', 0.0213, 'lps'),
	(647692, 132, '2015-01-15 00:42:27.000000', 'consum', 0.0217, 'lps'),
	(647693, 132, '2015-01-15 00:42:28.000000', 'consum', 0.0217, 'lps'),
	(647694, 132, '2015-01-15 00:42:29.000000', 'consum', 0.0215, 'lps'),
	(647695, 132, '2015-01-15 00:42:30.000000', 'consum', 0.0211, 'lps'),
	(647696, 132, '2015-01-15 00:42:31.000000', 'consum', 0.0212, 'lps'),
	(647697, 132, '2015-01-15 00:42:32.000000', 'consum', 0.0216, 'lps'),
	(647698, 132, '2015-01-15 00:42:33.000000', 'consum', 0.0213, 'lps'),
	(647699, 132, '2015-01-15 00:42:34.000000', 'consum', 0.0210, 'lps'),
	(647700, 132, '2015-01-15 00:42:35.000000', 'consum', 0.0212, 'lps'),
	(647701, 132, '2015-01-15 00:42:36.000000', 'consum', 0.0218, 'lps'),
	(647702, 132, '2015-01-15 00:42:37.000000', 'consum', 0.0214, 'lps'),
	(647703, 132, '2015-01-15 00:42:38.000000', 'consum', 0.0218, 'lps'),
	(647704, 132, '2015-01-15 00:42:39.000000', 'consum', 0.0215, 'lps'),
	(647705, 132, '2015-01-15 00:42:40.000000', 'consum', 0.0211, 'lps'),
	(647706, 132, '2015-01-15 00:42:41.000000', 'consum', 0.0212, 'lps'),
	(647707, 132, '2015-01-15 00:42:42.000000', 'consum', 0.0218, 'lps'),
	(647708, 132, '2015-01-15 00:42:43.000000', 'consum', 0.0213, 'lps'),
	(647709, 132, '2015-01-15 00:42:44.000000', 'consum', 0.0220, 'lps'),
	(647710, 132, '2015-01-15 00:42:45.000000', 'consum', 0.0210, 'lps'),
	(647711, 132, '2015-01-15 00:42:46.000000', 'consum', 0.0212, 'lps'),
	(647712, 132, '2015-01-15 00:42:47.000000', 'consum', 0.0211, 'lps'),
	(647713, 132, '2015-01-15 00:42:48.000000', 'consum', 0.0210, 'lps'),
	(647714, 132, '2015-01-15 00:42:49.000000', 'consum', 0.0217, 'lps'),
	(647715, 132, '2015-01-15 00:42:50.000000', 'consum', 0.0213, 'lps'),
	(647716, 132, '2015-01-15 00:42:51.000000', 'consum', 0.0215, 'lps'),
	(647717, 132, '2015-01-15 00:42:52.000000', 'consum', 0.0215, 'lps'),
	(647718, 132, '2015-01-15 00:42:53.000000', 'consum', 0.0212, 'lps'),
	(647719, 132, '2015-01-15 00:42:54.000000', 'consum', 0.0216, 'lps'),
	(647720, 132, '2015-01-15 00:42:55.000000', 'consum', 0.0212, 'lps'),
	(647721, 132, '2015-01-15 00:42:56.000000', 'consum', 0.0214, 'lps'),
	(647722, 132, '2015-01-15 00:42:57.000000', 'consum', 0.0214, 'lps'),
	(647723, 132, '2015-01-15 00:42:58.000000', 'consum', 0.0216, 'lps'),
	(647724, 132, '2015-01-15 00:42:59.000000', 'consum', 0.0220, 'lps'),
	(647725, 132, '2015-01-15 00:43:00.000000', 'consum', 0.0220, 'lps'),
	(647726, 132, '2015-01-15 00:43:01.000000', 'consum', 0.0219, 'lps'),
	(647727, 132, '2015-01-15 00:43:02.000000', 'consum', 0.0215, 'lps'),
	(647728, 132, '2015-01-15 00:43:03.000000', 'consum', 0.0218, 'lps'),
	(647729, 132, '2015-01-15 00:43:04.000000', 'consum', 0.0215, 'lps'),
	(647730, 132, '2015-01-15 00:43:05.000000', 'consum', 0.0213, 'lps'),
	(647731, 132, '2015-01-15 00:43:06.000000', 'consum', 0.0219, 'lps'),
	(647732, 132, '2015-01-15 00:43:07.000000', 'consum', 0.0214, 'lps'),
	(647733, 132, '2015-01-15 00:43:08.000000', 'consum', 0.0213, 'lps'),
	(647734, 132, '2015-01-15 00:43:09.000000', 'consum', 0.0214, 'lps'),
	(647735, 132, '2015-01-15 00:43:10.000000', 'consum', 0.0213, 'lps'),
	(647736, 132, '2015-01-15 00:43:11.000000', 'consum', 0.0210, 'lps'),
	(647737, 132, '2015-01-15 00:43:12.000000', 'consum', 0.0215, 'lps'),
	(647738, 132, '2015-01-15 00:43:13.000000', 'consum', 0.0211, 'lps'),
	(647739, 132, '2015-01-15 00:43:14.000000', 'consum', 0.0215, 'lps'),
	(647740, 132, '2015-01-15 00:43:15.000000', 'consum', 0.0219, 'lps'),
	(647741, 132, '2015-01-15 00:43:16.000000', 'consum', 0.0218, 'lps'),
	(647742, 132, '2015-01-15 00:43:17.000000', 'consum', 0.0214, 'lps'),
	(647743, 132, '2015-01-15 00:43:18.000000', 'consum', 0.0219, 'lps'),
	(647744, 132, '2015-01-15 00:43:19.000000', 'consum', 0.0220, 'lps'),
	(647745, 132, '2015-01-15 00:43:20.000000', 'consum', 0.0210, 'lps'),
	(647746, 132, '2015-01-15 00:43:21.000000', 'consum', 0.0215, 'lps'),
	(647747, 132, '2015-01-15 00:43:22.000000', 'consum', 0.0211, 'lps'),
	(647748, 132, '2015-01-15 00:43:23.000000', 'consum', 0.0215, 'lps'),
	(647749, 132, '2015-01-15 00:43:24.000000', 'consum', 0.0220, 'lps'),
	(647750, 132, '2015-01-15 00:43:25.000000', 'consum', 0.0214, 'lps'),
	(647751, 132, '2015-01-15 00:43:26.000000', 'consum', 0.0220, 'lps'),
	(647752, 132, '2015-01-15 00:43:27.000000', 'consum', 0.0215, 'lps'),
	(647753, 132, '2015-01-15 00:43:28.000000', 'consum', 0.0215, 'lps'),
	(647754, 132, '2015-01-15 00:43:29.000000', 'consum', 0.0213, 'lps'),
	(647755, 132, '2015-01-15 00:43:30.000000', 'consum', 0.0211, 'lps'),
	(647756, 132, '2015-01-15 00:43:31.000000', 'consum', 0.0214, 'lps'),
	(647757, 132, '2015-01-15 00:43:32.000000', 'consum', 0.0220, 'lps'),
	(647758, 132, '2015-01-15 00:43:33.000000', 'consum', 0.0215, 'lps'),
	(647759, 132, '2015-01-15 00:43:34.000000', 'consum', 0.0216, 'lps'),
	(647760, 132, '2015-01-15 00:43:35.000000', 'consum', 0.0215, 'lps'),
	(647761, 132, '2015-01-15 00:43:36.000000', 'consum', 0.0219, 'lps'),
	(647762, 132, '2015-01-15 00:43:37.000000', 'consum', 0.0218, 'lps'),
	(647763, 132, '2015-01-15 00:43:38.000000', 'consum', 0.0213, 'lps'),
	(647764, 132, '2015-01-15 00:43:39.000000', 'consum', 0.0211, 'lps'),
	(647765, 132, '2015-01-15 00:43:40.000000', 'consum', 0.0217, 'lps'),
	(647766, 132, '2015-01-15 00:43:41.000000', 'consum', 0.0220, 'lps'),
	(647767, 132, '2015-01-15 00:43:42.000000', 'consum', 0.0219, 'lps'),
	(647768, 132, '2015-01-15 00:43:43.000000', 'consum', 0.0213, 'lps'),
	(647769, 132, '2015-01-15 00:43:44.000000', 'consum', 0.0220, 'lps'),
	(647770, 132, '2015-01-15 00:43:45.000000', 'consum', 0.0218, 'lps'),
	(647771, 132, '2015-01-15 00:43:46.000000', 'consum', 0.0210, 'lps'),
	(647772, 132, '2015-01-15 00:43:47.000000', 'consum', 0.0218, 'lps'),
	(647773, 132, '2015-01-15 00:43:48.000000', 'consum', 0.0218, 'lps'),
	(647774, 132, '2015-01-15 00:43:49.000000', 'consum', 0.0215, 'lps'),
	(647775, 132, '2015-01-15 00:43:50.000000', 'consum', 0.0212, 'lps'),
	(647776, 132, '2015-01-15 00:43:51.000000', 'consum', 0.0215, 'lps'),
	(647777, 132, '2015-01-15 00:43:52.000000', 'consum', 0.0211, 'lps'),
	(647778, 132, '2015-01-15 00:43:53.000000', 'consum', 0.0220, 'lps'),
	(647779, 132, '2015-01-15 00:43:54.000000', 'consum', 0.0213, 'lps'),
	(647780, 132, '2015-01-15 00:43:55.000000', 'consum', 0.0216, 'lps'),
	(647781, 132, '2015-01-15 00:43:56.000000', 'consum', 0.0212, 'lps'),
	(647782, 132, '2015-01-15 00:43:57.000000', 'consum', 0.0213, 'lps'),
	(647783, 132, '2015-01-15 00:43:58.000000', 'consum', 0.0210, 'lps'),
	(647784, 132, '2015-01-15 00:43:59.000000', 'consum', 0.0211, 'lps'),
	(647785, 132, '2015-01-15 00:44:00.000000', 'consum', 0.0216, 'lps'),
	(647786, 132, '2015-01-15 00:44:01.000000', 'consum', 0.0214, 'lps'),
	(647787, 132, '2015-01-15 00:44:02.000000', 'consum', 0.0215, 'lps'),
	(647788, 132, '2015-01-15 00:44:03.000000', 'consum', 0.0213, 'lps'),
	(647789, 132, '2015-01-15 00:44:04.000000', 'consum', 0.0220, 'lps'),
	(647790, 132, '2015-01-15 00:44:05.000000', 'consum', 0.0219, 'lps'),
	(647791, 132, '2015-01-15 00:44:06.000000', 'consum', 0.0214, 'lps'),
	(647792, 132, '2015-01-15 00:44:07.000000', 'consum', 0.0213, 'lps'),
	(647793, 132, '2015-01-15 00:44:08.000000', 'consum', 0.0214, 'lps'),
	(647794, 132, '2015-01-15 00:44:09.000000', 'consum', 0.0220, 'lps'),
	(647795, 132, '2015-01-15 00:44:10.000000', 'consum', 0.0218, 'lps'),
	(647796, 132, '2015-01-15 00:44:11.000000', 'consum', 0.0220, 'lps'),
	(647797, 132, '2015-01-15 00:44:12.000000', 'consum', 0.0214, 'lps'),
	(647798, 132, '2015-01-15 00:44:13.000000', 'consum', 0.0211, 'lps'),
	(647799, 132, '2015-01-15 00:44:14.000000', 'consum', 0.0216, 'lps'),
	(647800, 132, '2015-01-15 00:44:15.000000', 'consum', 0.0213, 'lps'),
	(647801, 132, '2015-01-15 00:44:16.000000', 'consum', 0.0210, 'lps'),
	(647802, 132, '2015-01-15 00:44:17.000000', 'consum', 0.0213, 'lps'),
	(647803, 132, '2015-01-15 00:44:18.000000', 'consum', 0.0212, 'lps'),
	(647804, 132, '2015-01-15 00:44:19.000000', 'consum', 0.0215, 'lps'),
	(647805, 132, '2015-01-15 00:44:20.000000', 'consum', 0.0215, 'lps'),
	(647806, 132, '2015-01-15 00:44:21.000000', 'consum', 0.0212, 'lps'),
	(647807, 132, '2015-01-15 00:44:22.000000', 'consum', 0.0214, 'lps'),
	(647808, 132, '2015-01-15 00:44:23.000000', 'consum', 0.0213, 'lps'),
	(647809, 132, '2015-01-15 00:44:24.000000', 'consum', 0.0214, 'lps'),
	(647810, 132, '2015-01-15 00:44:25.000000', 'consum', 0.0220, 'lps'),
	(647811, 132, '2015-01-15 00:44:26.000000', 'consum', 0.0217, 'lps'),
	(647812, 132, '2015-01-15 00:44:27.000000', 'consum', 0.0215, 'lps'),
	(647813, 132, '2015-01-15 00:44:28.000000', 'consum', 0.0215, 'lps'),
	(647814, 132, '2015-01-15 00:44:29.000000', 'consum', 0.0210, 'lps'),
	(647815, 132, '2015-01-15 00:44:30.000000', 'consum', 0.0218, 'lps'),
	(647816, 132, '2015-01-15 00:44:31.000000', 'consum', 0.0216, 'lps'),
	(647817, 132, '2015-01-15 00:44:32.000000', 'consum', 0.0218, 'lps'),
	(647818, 132, '2015-01-15 00:44:33.000000', 'consum', 0.0212, 'lps'),
	(647819, 132, '2015-01-15 00:44:34.000000', 'consum', 0.0217, 'lps'),
	(647820, 132, '2015-01-15 00:44:35.000000', 'consum', 0.0216, 'lps'),
	(647821, 132, '2015-01-15 00:44:36.000000', 'consum', 0.0212, 'lps'),
	(647822, 132, '2015-01-15 00:44:37.000000', 'consum', 0.0210, 'lps'),
	(647823, 132, '2015-01-15 00:44:38.000000', 'consum', 0.0217, 'lps'),
	(647824, 132, '2015-01-15 00:44:39.000000', 'consum', 0.0211, 'lps'),
	(647825, 132, '2015-01-15 00:44:40.000000', 'consum', 0.0216, 'lps'),
	(647826, 132, '2015-01-15 00:44:41.000000', 'consum', 0.0218, 'lps'),
	(647827, 132, '2015-01-15 00:44:42.000000', 'consum', 0.0219, 'lps'),
	(647828, 132, '2015-01-15 00:44:43.000000', 'consum', 0.0212, 'lps'),
	(647829, 132, '2015-01-15 00:44:44.000000', 'consum', 0.0215, 'lps'),
	(647830, 132, '2015-01-15 00:44:45.000000', 'consum', 0.0217, 'lps'),
	(647831, 132, '2015-01-15 00:44:46.000000', 'consum', 0.0219, 'lps'),
	(647832, 132, '2015-01-15 00:44:47.000000', 'consum', 0.0212, 'lps'),
	(647833, 132, '2015-01-15 00:44:48.000000', 'consum', 0.0215, 'lps'),
	(647834, 132, '2015-01-15 00:44:49.000000', 'consum', 0.0220, 'lps'),
	(647835, 132, '2015-01-15 00:44:50.000000', 'consum', 0.0210, 'lps'),
	(647836, 132, '2015-01-15 00:44:51.000000', 'consum', 0.0216, 'lps'),
	(647837, 132, '2015-01-15 00:44:52.000000', 'consum', 0.0217, 'lps'),
	(647838, 132, '2015-01-15 00:44:53.000000', 'consum', 0.0216, 'lps'),
	(647839, 132, '2015-01-15 00:44:54.000000', 'consum', 0.0220, 'lps'),
	(647840, 132, '2015-01-15 00:44:55.000000', 'consum', 0.0220, 'lps'),
	(647841, 132, '2015-01-15 00:44:56.000000', 'consum', 0.0220, 'lps'),
	(647842, 132, '2015-01-15 00:44:57.000000', 'consum', 0.0220, 'lps'),
	(647843, 132, '2015-01-15 00:44:58.000000', 'consum', 0.0218, 'lps'),
	(647844, 132, '2015-01-15 00:44:59.000000', 'consum', 0.0220, 'lps'),
	(647845, 132, '2015-01-15 00:45:00.000000', 'consum', 0.0215, 'lps'),
	(647846, 132, '2015-01-15 00:45:01.000000', 'consum', 0.0216, 'lps'),
	(647847, 132, '2015-01-15 00:45:02.000000', 'consum', 0.0213, 'lps'),
	(647848, 132, '2015-01-15 00:45:03.000000', 'consum', 0.0220, 'lps'),
	(647849, 132, '2015-01-15 00:45:04.000000', 'consum', 0.0217, 'lps'),
	(647850, 132, '2015-01-15 00:45:05.000000', 'consum', 0.0214, 'lps'),
	(647851, 132, '2015-01-15 00:45:06.000000', 'consum', 0.0213, 'lps'),
	(647852, 132, '2015-01-15 00:45:07.000000', 'consum', 0.0214, 'lps'),
	(647853, 132, '2015-01-15 00:45:08.000000', 'consum', 0.0219, 'lps'),
	(647854, 132, '2015-01-15 00:45:09.000000', 'consum', 0.0212, 'lps'),
	(647855, 132, '2015-01-15 00:45:10.000000', 'consum', 0.0215, 'lps'),
	(647856, 132, '2015-01-15 00:45:11.000000', 'consum', 0.0217, 'lps'),
	(647857, 132, '2015-01-15 00:45:12.000000', 'consum', 0.0220, 'lps'),
	(647858, 132, '2015-01-15 00:45:13.000000', 'consum', 0.0219, 'lps'),
	(647859, 132, '2015-01-15 00:45:14.000000', 'consum', 0.0212, 'lps'),
	(647860, 132, '2015-01-15 00:45:15.000000', 'consum', 0.0218, 'lps'),
	(647861, 132, '2015-01-15 00:45:16.000000', 'consum', 0.0211, 'lps'),
	(647862, 132, '2015-01-15 00:45:17.000000', 'consum', 0.0212, 'lps'),
	(647863, 132, '2015-01-15 00:45:18.000000', 'consum', 0.0217, 'lps'),
	(647864, 132, '2015-01-15 00:45:19.000000', 'consum', 0.0220, 'lps'),
	(647865, 132, '2015-01-15 00:45:20.000000', 'consum', 0.0217, 'lps'),
	(647866, 132, '2015-01-15 00:45:21.000000', 'consum', 0.0214, 'lps'),
	(647867, 132, '2015-01-15 00:45:22.000000', 'consum', 0.0210, 'lps'),
	(647868, 132, '2015-01-15 00:45:23.000000', 'consum', 0.0220, 'lps'),
	(647869, 132, '2015-01-15 00:45:24.000000', 'consum', 0.0219, 'lps'),
	(647870, 132, '2015-01-15 00:45:25.000000', 'consum', 0.0212, 'lps'),
	(647871, 132, '2015-01-15 00:45:26.000000', 'consum', 0.0214, 'lps'),
	(647872, 132, '2015-01-15 00:45:27.000000', 'consum', 0.0216, 'lps'),
	(647873, 132, '2015-01-15 00:45:28.000000', 'consum', 0.0219, 'lps'),
	(647874, 132, '2015-01-15 00:45:29.000000', 'consum', 0.0213, 'lps'),
	(647875, 132, '2015-01-15 00:45:30.000000', 'consum', 0.0212, 'lps'),
	(647876, 132, '2015-01-15 00:45:31.000000', 'consum', 0.0219, 'lps'),
	(647877, 132, '2015-01-15 00:45:32.000000', 'consum', 0.0220, 'lps'),
	(647878, 132, '2015-01-15 00:45:33.000000', 'consum', 0.0220, 'lps'),
	(647879, 132, '2015-01-15 00:45:34.000000', 'consum', 0.0219, 'lps'),
	(647880, 132, '2015-01-15 00:45:35.000000', 'consum', 0.0214, 'lps'),
	(647881, 132, '2015-01-15 00:45:36.000000', 'consum', 0.0214, 'lps'),
	(647882, 132, '2015-01-15 00:45:37.000000', 'consum', 0.0219, 'lps'),
	(647883, 132, '2015-01-15 00:45:38.000000', 'consum', 0.0210, 'lps'),
	(647884, 132, '2015-01-15 00:45:39.000000', 'consum', 0.0216, 'lps'),
	(647885, 132, '2015-01-15 00:45:40.000000', 'consum', 0.0217, 'lps'),
	(647886, 132, '2015-01-15 00:45:41.000000', 'consum', 0.0219, 'lps'),
	(647887, 132, '2015-01-15 00:45:42.000000', 'consum', 0.0213, 'lps'),
	(647888, 132, '2015-01-15 00:45:43.000000', 'consum', 0.0219, 'lps'),
	(647889, 132, '2015-01-15 00:45:44.000000', 'consum', 0.0215, 'lps'),
	(647890, 132, '2015-01-15 00:45:45.000000', 'consum', 0.0217, 'lps'),
	(647891, 132, '2015-01-15 00:45:46.000000', 'consum', 0.0210, 'lps'),
	(647892, 132, '2015-01-15 00:45:47.000000', 'consum', 0.0213, 'lps'),
	(647893, 132, '2015-01-15 00:45:48.000000', 'consum', 0.0212, 'lps'),
	(647894, 132, '2015-01-15 00:45:49.000000', 'consum', 0.0211, 'lps'),
	(647895, 132, '2015-01-15 00:45:50.000000', 'consum', 0.0211, 'lps'),
	(647896, 132, '2015-01-15 00:45:51.000000', 'consum', 0.0211, 'lps'),
	(647897, 132, '2015-01-15 00:45:52.000000', 'consum', 0.0211, 'lps'),
	(647898, 132, '2015-01-15 00:45:53.000000', 'consum', 0.0215, 'lps'),
	(647899, 132, '2015-01-15 00:45:54.000000', 'consum', 0.0211, 'lps'),
	(647900, 132, '2015-01-15 00:45:55.000000', 'consum', 0.0212, 'lps'),
	(647901, 132, '2015-01-15 00:45:56.000000', 'consum', 0.0218, 'lps'),
	(647902, 132, '2015-01-15 00:45:57.000000', 'consum', 0.0220, 'lps'),
	(647903, 132, '2015-01-15 00:45:58.000000', 'consum', 0.0213, 'lps'),
	(647904, 132, '2015-01-15 00:45:59.000000', 'consum', 0.0210, 'lps'),
	(647905, 132, '2015-01-15 00:46:00.000000', 'consum', 0.0213, 'lps'),
	(647906, 132, '2015-01-15 00:46:01.000000', 'consum', 0.0211, 'lps'),
	(647907, 132, '2015-01-15 00:46:02.000000', 'consum', 0.0210, 'lps'),
	(647908, 132, '2015-01-15 00:46:03.000000', 'consum', 0.0217, 'lps'),
	(647909, 132, '2015-01-15 00:46:04.000000', 'consum', 0.0211, 'lps'),
	(647910, 132, '2015-01-15 00:46:05.000000', 'consum', 0.0217, 'lps'),
	(647911, 132, '2015-01-15 00:46:06.000000', 'consum', 0.0219, 'lps'),
	(647912, 132, '2015-01-15 00:46:07.000000', 'consum', 0.0215, 'lps'),
	(647913, 132, '2015-01-15 00:46:08.000000', 'consum', 0.0218, 'lps'),
	(647914, 132, '2015-01-15 00:46:09.000000', 'consum', 0.0214, 'lps'),
	(647915, 132, '2015-01-15 00:46:10.000000', 'consum', 0.0219, 'lps'),
	(647916, 132, '2015-01-15 00:46:11.000000', 'consum', 0.0210, 'lps'),
	(647917, 132, '2015-01-15 00:46:12.000000', 'consum', 0.0218, 'lps'),
	(647918, 132, '2015-01-15 00:46:13.000000', 'consum', 0.0216, 'lps'),
	(647919, 132, '2015-01-15 00:46:14.000000', 'consum', 0.0218, 'lps'),
	(647920, 132, '2015-01-15 00:46:15.000000', 'consum', 0.0212, 'lps'),
	(647921, 132, '2015-01-15 00:46:16.000000', 'consum', 0.0215, 'lps'),
	(647922, 132, '2015-01-15 00:46:17.000000', 'consum', 0.0220, 'lps'),
	(647923, 132, '2015-01-15 00:46:18.000000', 'consum', 0.0214, 'lps'),
	(647924, 132, '2015-01-15 00:46:19.000000', 'consum', 0.0219, 'lps'),
	(647925, 132, '2015-01-15 00:46:20.000000', 'consum', 0.0214, 'lps'),
	(647926, 132, '2015-01-15 00:46:21.000000', 'consum', 0.0213, 'lps'),
	(647927, 132, '2015-01-15 00:46:22.000000', 'consum', 0.0214, 'lps'),
	(647928, 132, '2015-01-15 00:46:23.000000', 'consum', 0.0219, 'lps'),
	(647929, 132, '2015-01-15 00:46:24.000000', 'consum', 0.0213, 'lps'),
	(647930, 132, '2015-01-15 00:46:25.000000', 'consum', 0.0211, 'lps'),
	(647931, 132, '2015-01-15 00:46:26.000000', 'consum', 0.0216, 'lps'),
	(647932, 132, '2015-01-15 00:46:27.000000', 'consum', 0.0213, 'lps'),
	(647933, 132, '2015-01-15 00:46:28.000000', 'consum', 0.0211, 'lps'),
	(647934, 132, '2015-01-15 00:46:29.000000', 'consum', 0.0215, 'lps'),
	(647935, 132, '2015-01-15 00:46:30.000000', 'consum', 0.0212, 'lps'),
	(647936, 132, '2015-01-15 00:46:31.000000', 'consum', 0.0218, 'lps'),
	(647937, 132, '2015-01-15 00:46:32.000000', 'consum', 0.0210, 'lps'),
	(647938, 132, '2015-01-15 00:46:33.000000', 'consum', 0.0218, 'lps'),
	(647939, 132, '2015-01-15 00:46:34.000000', 'consum', 0.0218, 'lps'),
	(647940, 132, '2015-01-15 00:46:35.000000', 'consum', 0.0214, 'lps'),
	(647941, 132, '2015-01-15 00:46:36.000000', 'consum', 0.0219, 'lps'),
	(647942, 132, '2015-01-15 00:46:37.000000', 'consum', 0.0219, 'lps'),
	(647943, 132, '2015-01-15 00:46:38.000000', 'consum', 0.0220, 'lps'),
	(647944, 132, '2015-01-15 00:46:39.000000', 'consum', 0.0212, 'lps'),
	(647945, 132, '2015-01-15 00:46:40.000000', 'consum', 0.0214, 'lps'),
	(647946, 132, '2015-01-15 00:46:41.000000', 'consum', 0.0210, 'lps'),
	(647947, 132, '2015-01-15 00:46:42.000000', 'consum', 0.0213, 'lps'),
	(647948, 132, '2015-01-15 00:46:43.000000', 'consum', 0.0213, 'lps'),
	(647949, 132, '2015-01-15 00:46:44.000000', 'consum', 0.0215, 'lps'),
	(647950, 132, '2015-01-15 00:46:45.000000', 'consum', 0.0218, 'lps'),
	(647951, 132, '2015-01-15 00:46:46.000000', 'consum', 0.0212, 'lps'),
	(647952, 132, '2015-01-15 00:46:47.000000', 'consum', 0.0210, 'lps'),
	(647953, 132, '2015-01-15 00:46:48.000000', 'consum', 0.0212, 'lps'),
	(647954, 132, '2015-01-15 00:46:49.000000', 'consum', 0.0211, 'lps'),
	(647955, 132, '2015-01-15 00:46:50.000000', 'consum', 0.0211, 'lps'),
	(647956, 132, '2015-01-15 00:46:51.000000', 'consum', 0.0213, 'lps'),
	(647957, 132, '2015-01-15 00:46:52.000000', 'consum', 0.0210, 'lps'),
	(647958, 132, '2015-01-15 00:46:53.000000', 'consum', 0.0212, 'lps'),
	(647959, 132, '2015-01-15 00:46:54.000000', 'consum', 0.0210, 'lps'),
	(647960, 132, '2015-01-15 00:46:55.000000', 'consum', 0.0215, 'lps'),
	(647961, 132, '2015-01-15 00:46:56.000000', 'consum', 0.0213, 'lps'),
	(647962, 132, '2015-01-15 00:46:57.000000', 'consum', 0.0210, 'lps'),
	(647963, 132, '2015-01-15 00:46:58.000000', 'consum', 0.0213, 'lps'),
	(647964, 132, '2015-01-15 00:46:59.000000', 'consum', 0.0217, 'lps'),
	(647965, 132, '2015-01-15 00:47:00.000000', 'consum', 0.0212, 'lps'),
	(647966, 132, '2015-01-15 00:47:01.000000', 'consum', 0.0210, 'lps'),
	(647967, 132, '2015-01-15 00:47:02.000000', 'consum', 0.0217, 'lps'),
	(647968, 132, '2015-01-15 00:47:03.000000', 'consum', 0.0210, 'lps'),
	(647969, 132, '2015-01-15 00:47:04.000000', 'consum', 0.0213, 'lps'),
	(647970, 132, '2015-01-15 00:47:05.000000', 'consum', 0.0215, 'lps'),
	(647971, 132, '2015-01-15 00:47:06.000000', 'consum', 0.0216, 'lps'),
	(647972, 132, '2015-01-15 00:47:07.000000', 'consum', 0.0214, 'lps'),
	(647973, 132, '2015-01-15 00:47:08.000000', 'consum', 0.0211, 'lps'),
	(647974, 132, '2015-01-15 00:47:09.000000', 'consum', 0.0217, 'lps'),
	(647975, 132, '2015-01-15 00:47:10.000000', 'consum', 0.0210, 'lps'),
	(647976, 132, '2015-01-15 00:47:11.000000', 'consum', 0.0220, 'lps'),
	(647977, 132, '2015-01-15 00:47:12.000000', 'consum', 0.0216, 'lps'),
	(647978, 132, '2015-01-15 00:47:13.000000', 'consum', 0.0211, 'lps'),
	(647979, 132, '2015-01-15 00:47:14.000000', 'consum', 0.0210, 'lps'),
	(647980, 132, '2015-01-15 00:47:15.000000', 'consum', 0.0220, 'lps'),
	(647981, 132, '2015-01-15 00:47:16.000000', 'consum', 0.0213, 'lps'),
	(647982, 132, '2015-01-15 00:47:17.000000', 'consum', 0.0220, 'lps'),
	(647983, 132, '2015-01-15 00:47:18.000000', 'consum', 0.0217, 'lps'),
	(647984, 132, '2015-01-15 00:47:19.000000', 'consum', 0.0217, 'lps'),
	(647985, 132, '2015-01-15 00:47:20.000000', 'consum', 0.0214, 'lps'),
	(647986, 132, '2015-01-15 00:47:21.000000', 'consum', 0.0211, 'lps'),
	(647987, 132, '2015-01-15 00:47:22.000000', 'consum', 0.0212, 'lps'),
	(647988, 132, '2015-01-15 00:47:23.000000', 'consum', 0.0218, 'lps'),
	(647989, 132, '2015-01-15 00:47:24.000000', 'consum', 0.0211, 'lps'),
	(647990, 132, '2015-01-15 00:47:25.000000', 'consum', 0.0213, 'lps'),
	(647991, 132, '2015-01-15 00:47:26.000000', 'consum', 0.0212, 'lps'),
	(647992, 132, '2015-01-15 00:47:27.000000', 'consum', 0.0213, 'lps'),
	(647993, 132, '2015-01-15 00:47:28.000000', 'consum', 0.0217, 'lps'),
	(647994, 132, '2015-01-15 00:47:29.000000', 'consum', 0.0217, 'lps'),
	(647995, 132, '2015-01-15 00:47:30.000000', 'consum', 0.0211, 'lps'),
	(647996, 132, '2015-01-15 00:47:31.000000', 'consum', 0.0216, 'lps'),
	(647997, 132, '2015-01-15 00:47:32.000000', 'consum', 0.0219, 'lps'),
	(647998, 132, '2015-01-15 00:47:33.000000', 'consum', 0.0212, 'lps'),
	(647999, 132, '2015-01-15 00:47:34.000000', 'consum', 0.0217, 'lps'),
	(648000, 132, '2015-01-15 00:47:35.000000', 'consum', 0.0219, 'lps'),
	(648001, 132, '2015-01-15 00:47:36.000000', 'consum', 0.0211, 'lps'),
	(648002, 132, '2015-01-15 00:47:37.000000', 'consum', 0.0210, 'lps'),
	(648003, 132, '2015-01-15 00:47:38.000000', 'consum', 0.0219, 'lps'),
	(648004, 132, '2015-01-15 00:47:39.000000', 'consum', 0.0210, 'lps'),
	(648005, 132, '2015-01-15 00:47:40.000000', 'consum', 0.0217, 'lps'),
	(648006, 132, '2015-01-15 00:47:41.000000', 'consum', 0.0214, 'lps'),
	(648007, 132, '2015-01-15 00:47:42.000000', 'consum', 0.0210, 'lps'),
	(648008, 132, '2015-01-15 00:47:43.000000', 'consum', 0.0218, 'lps'),
	(648009, 132, '2015-01-15 00:47:44.000000', 'consum', 0.0220, 'lps'),
	(648010, 132, '2015-01-15 00:47:45.000000', 'consum', 0.0216, 'lps'),
	(648011, 132, '2015-01-15 00:47:46.000000', 'consum', 0.0218, 'lps'),
	(648012, 132, '2015-01-15 00:47:47.000000', 'consum', 0.0213, 'lps'),
	(648013, 132, '2015-01-15 00:47:48.000000', 'consum', 0.0210, 'lps'),
	(648014, 132, '2015-01-15 00:47:49.000000', 'consum', 0.0216, 'lps'),
	(648015, 132, '2015-01-15 00:47:50.000000', 'consum', 0.0215, 'lps'),
	(648016, 132, '2015-01-15 00:47:51.000000', 'consum', 0.0220, 'lps'),
	(648017, 132, '2015-01-15 00:47:52.000000', 'consum', 0.0213, 'lps'),
	(648018, 132, '2015-01-15 00:47:53.000000', 'consum', 0.0215, 'lps'),
	(648019, 132, '2015-01-15 00:47:54.000000', 'consum', 0.0218, 'lps'),
	(648020, 132, '2015-01-15 00:47:55.000000', 'consum', 0.0212, 'lps'),
	(648021, 132, '2015-01-15 00:47:56.000000', 'consum', 0.0218, 'lps'),
	(648022, 132, '2015-01-15 00:47:57.000000', 'consum', 0.0214, 'lps'),
	(648023, 132, '2015-01-15 00:47:58.000000', 'consum', 0.0214, 'lps'),
	(648024, 132, '2015-01-15 00:47:59.000000', 'consum', 0.0210, 'lps'),
	(648025, 132, '2015-01-15 00:48:00.000000', 'consum', 0.0218, 'lps'),
	(648026, 132, '2015-01-15 00:48:01.000000', 'consum', 0.0219, 'lps'),
	(648027, 132, '2015-01-15 00:48:02.000000', 'consum', 0.0219, 'lps'),
	(648028, 132, '2015-01-15 00:48:03.000000', 'consum', 0.0220, 'lps'),
	(648029, 132, '2015-01-15 00:48:04.000000', 'consum', 0.0211, 'lps'),
	(648030, 132, '2015-01-15 00:48:05.000000', 'consum', 0.0217, 'lps'),
	(648031, 132, '2015-01-15 00:48:06.000000', 'consum', 0.0212, 'lps'),
	(648032, 132, '2015-01-15 00:48:07.000000', 'consum', 0.0220, 'lps'),
	(648033, 132, '2015-01-15 00:48:08.000000', 'consum', 0.0211, 'lps'),
	(648034, 132, '2015-01-15 00:48:09.000000', 'consum', 0.0220, 'lps'),
	(648035, 132, '2015-01-15 00:48:10.000000', 'consum', 0.0212, 'lps'),
	(648036, 132, '2015-01-15 00:48:11.000000', 'consum', 0.0213, 'lps'),
	(648037, 132, '2015-01-15 00:48:12.000000', 'consum', 0.0217, 'lps'),
	(648038, 132, '2015-01-15 00:48:13.000000', 'consum', 0.0218, 'lps'),
	(648039, 132, '2015-01-15 00:48:14.000000', 'consum', 0.0218, 'lps'),
	(648040, 132, '2015-01-15 00:48:15.000000', 'consum', 0.0213, 'lps'),
	(648041, 132, '2015-01-15 00:48:16.000000', 'consum', 0.0213, 'lps'),
	(648042, 132, '2015-01-15 00:48:17.000000', 'consum', 0.0218, 'lps'),
	(648043, 132, '2015-01-15 00:48:18.000000', 'consum', 0.0219, 'lps'),
	(648044, 132, '2015-01-15 00:48:19.000000', 'consum', 0.0210, 'lps'),
	(648045, 132, '2015-01-15 00:48:20.000000', 'consum', 0.0216, 'lps'),
	(648046, 132, '2015-01-15 00:48:21.000000', 'consum', 0.0218, 'lps'),
	(648047, 132, '2015-01-15 00:48:22.000000', 'consum', 0.0210, 'lps'),
	(648048, 132, '2015-01-15 00:48:23.000000', 'consum', 0.0211, 'lps'),
	(648049, 132, '2015-01-15 00:48:24.000000', 'consum', 0.0212, 'lps'),
	(648050, 132, '2015-01-15 00:48:25.000000', 'consum', 0.0219, 'lps'),
	(648051, 132, '2015-01-15 00:48:26.000000', 'consum', 0.0219, 'lps'),
	(648052, 132, '2015-01-15 00:48:27.000000', 'consum', 0.0214, 'lps'),
	(648053, 132, '2015-01-15 00:48:28.000000', 'consum', 0.0216, 'lps'),
	(648054, 132, '2015-01-15 00:48:29.000000', 'consum', 0.0216, 'lps'),
	(648055, 132, '2015-01-15 00:48:30.000000', 'consum', 0.0212, 'lps'),
	(648056, 132, '2015-01-15 00:48:31.000000', 'consum', 0.0214, 'lps'),
	(648057, 132, '2015-01-15 00:48:32.000000', 'consum', 0.0213, 'lps'),
	(648058, 132, '2015-01-15 00:48:33.000000', 'consum', 0.0216, 'lps'),
	(648059, 132, '2015-01-15 00:48:34.000000', 'consum', 0.0218, 'lps'),
	(648060, 132, '2015-01-15 00:48:35.000000', 'consum', 0.0211, 'lps'),
	(648061, 132, '2015-01-15 00:48:36.000000', 'consum', 0.0215, 'lps'),
	(648062, 132, '2015-01-15 00:48:37.000000', 'consum', 0.0211, 'lps'),
	(648063, 132, '2015-01-15 00:48:38.000000', 'consum', 0.0212, 'lps'),
	(648064, 132, '2015-01-15 00:48:39.000000', 'consum', 0.0216, 'lps'),
	(648065, 132, '2015-01-15 00:48:40.000000', 'consum', 0.0215, 'lps'),
	(648066, 132, '2015-01-15 00:48:41.000000', 'consum', 0.0214, 'lps'),
	(648067, 132, '2015-01-15 00:48:42.000000', 'consum', 0.0218, 'lps'),
	(648068, 132, '2015-01-15 00:48:43.000000', 'consum', 0.0216, 'lps'),
	(648069, 132, '2015-01-15 00:48:44.000000', 'consum', 0.0217, 'lps'),
	(648070, 132, '2015-01-15 00:48:45.000000', 'consum', 0.0217, 'lps'),
	(648071, 132, '2015-01-15 00:48:46.000000', 'consum', 0.0211, 'lps'),
	(648072, 132, '2015-01-15 00:48:47.000000', 'consum', 0.0220, 'lps'),
	(648073, 132, '2015-01-15 00:48:48.000000', 'consum', 0.0210, 'lps'),
	(648074, 132, '2015-01-15 00:48:49.000000', 'consum', 0.0216, 'lps'),
	(648075, 132, '2015-01-15 00:48:50.000000', 'consum', 0.0218, 'lps'),
	(648076, 132, '2015-01-15 00:48:51.000000', 'consum', 0.0220, 'lps'),
	(648077, 132, '2015-01-15 00:48:52.000000', 'consum', 0.0217, 'lps'),
	(648078, 132, '2015-01-15 00:48:53.000000', 'consum', 0.0215, 'lps'),
	(648079, 132, '2015-01-15 00:48:54.000000', 'consum', 0.0216, 'lps'),
	(648080, 132, '2015-01-15 00:48:55.000000', 'consum', 0.0213, 'lps'),
	(648081, 132, '2015-01-15 00:48:56.000000', 'consum', 0.0220, 'lps'),
	(648082, 132, '2015-01-15 00:48:57.000000', 'consum', 0.0219, 'lps'),
	(648083, 132, '2015-01-15 00:48:58.000000', 'consum', 0.0213, 'lps'),
	(648084, 132, '2015-01-15 00:48:59.000000', 'consum', 0.0220, 'lps'),
	(648085, 132, '2015-01-15 00:49:00.000000', 'consum', 0.0220, 'lps'),
	(648086, 132, '2015-01-15 00:49:01.000000', 'consum', 0.0218, 'lps'),
	(648087, 132, '2015-01-15 00:49:02.000000', 'consum', 0.0211, 'lps'),
	(648088, 132, '2015-01-15 00:49:03.000000', 'consum', 0.0214, 'lps'),
	(648089, 132, '2015-01-15 00:49:04.000000', 'consum', 0.0216, 'lps'),
	(648090, 132, '2015-01-15 00:49:05.000000', 'consum', 0.0215, 'lps'),
	(648091, 132, '2015-01-15 00:49:06.000000', 'consum', 0.0210, 'lps'),
	(648092, 132, '2015-01-15 00:49:07.000000', 'consum', 0.0216, 'lps'),
	(648093, 132, '2015-01-15 00:49:08.000000', 'consum', 0.0218, 'lps'),
	(648094, 132, '2015-01-15 00:49:09.000000', 'consum', 0.0213, 'lps'),
	(648095, 132, '2015-01-15 00:49:10.000000', 'consum', 0.0210, 'lps'),
	(648096, 132, '2015-01-15 00:49:11.000000', 'consum', 0.0215, 'lps'),
	(648097, 132, '2015-01-15 00:49:12.000000', 'consum', 0.0210, 'lps'),
	(648098, 132, '2015-01-15 00:49:13.000000', 'consum', 0.0210, 'lps'),
	(648099, 132, '2015-01-15 00:49:14.000000', 'consum', 0.0220, 'lps'),
	(648100, 132, '2015-01-15 00:49:15.000000', 'consum', 0.0217, 'lps'),
	(648101, 132, '2015-01-15 00:49:16.000000', 'consum', 0.0215, 'lps'),
	(648102, 132, '2015-01-15 00:49:17.000000', 'consum', 0.0216, 'lps'),
	(648103, 132, '2015-01-15 00:49:18.000000', 'consum', 0.0215, 'lps'),
	(648104, 132, '2015-01-15 00:49:19.000000', 'consum', 0.0217, 'lps'),
	(648105, 132, '2015-01-15 00:49:20.000000', 'consum', 0.0218, 'lps'),
	(648106, 132, '2015-01-15 00:49:21.000000', 'consum', 0.0220, 'lps'),
	(648107, 132, '2015-01-15 00:49:22.000000', 'consum', 0.0214, 'lps'),
	(648108, 132, '2015-01-15 00:49:23.000000', 'consum', 0.0211, 'lps'),
	(648109, 132, '2015-01-15 00:49:24.000000', 'consum', 0.0217, 'lps'),
	(648110, 132, '2015-01-15 00:49:25.000000', 'consum', 0.0218, 'lps'),
	(648111, 132, '2015-01-15 00:49:26.000000', 'consum', 0.0217, 'lps'),
	(648112, 132, '2015-01-15 00:49:27.000000', 'consum', 0.0213, 'lps'),
	(648113, 132, '2015-01-15 00:49:28.000000', 'consum', 0.0216, 'lps'),
	(648114, 132, '2015-01-15 00:49:29.000000', 'consum', 0.0219, 'lps'),
	(648115, 132, '2015-01-15 00:49:30.000000', 'consum', 0.0215, 'lps'),
	(648116, 132, '2015-01-15 00:49:31.000000', 'consum', 0.0211, 'lps'),
	(648117, 132, '2015-01-15 00:49:32.000000', 'consum', 0.0211, 'lps'),
	(648118, 132, '2015-01-15 00:49:33.000000', 'consum', 0.0211, 'lps'),
	(648119, 132, '2015-01-15 00:49:34.000000', 'consum', 0.0212, 'lps'),
	(648120, 132, '2015-01-15 00:49:35.000000', 'consum', 0.0216, 'lps'),
	(648121, 132, '2015-01-15 00:49:36.000000', 'consum', 0.0216, 'lps'),
	(648122, 132, '2015-01-15 00:49:37.000000', 'consum', 0.0210, 'lps'),
	(648123, 132, '2015-01-15 00:49:38.000000', 'consum', 0.0215, 'lps'),
	(648124, 132, '2015-01-15 00:49:39.000000', 'consum', 0.0211, 'lps'),
	(648125, 132, '2015-01-15 00:49:40.000000', 'consum', 0.0215, 'lps'),
	(648126, 132, '2015-01-15 00:49:41.000000', 'consum', 0.0220, 'lps'),
	(648127, 132, '2015-01-15 00:49:42.000000', 'consum', 0.0213, 'lps'),
	(648128, 132, '2015-01-15 00:49:43.000000', 'consum', 0.0218, 'lps'),
	(648129, 132, '2015-01-15 00:49:44.000000', 'consum', 0.0220, 'lps'),
	(648130, 132, '2015-01-15 00:49:45.000000', 'consum', 0.0215, 'lps'),
	(648131, 132, '2015-01-15 00:49:46.000000', 'consum', 0.0215, 'lps'),
	(648132, 132, '2015-01-15 00:49:47.000000', 'consum', 0.0220, 'lps'),
	(648133, 132, '2015-01-15 00:49:48.000000', 'consum', 0.0215, 'lps'),
	(648134, 132, '2015-01-15 00:49:49.000000', 'consum', 0.0215, 'lps'),
	(648135, 132, '2015-01-15 00:49:50.000000', 'consum', 0.0220, 'lps'),
	(648136, 132, '2015-01-15 00:49:51.000000', 'consum', 0.0214, 'lps'),
	(648137, 132, '2015-01-15 00:49:52.000000', 'consum', 0.0220, 'lps'),
	(648138, 132, '2015-01-15 00:49:53.000000', 'consum', 0.0219, 'lps'),
	(648139, 132, '2015-01-15 00:49:54.000000', 'consum', 0.0212, 'lps'),
	(648140, 132, '2015-01-15 00:49:55.000000', 'consum', 0.0217, 'lps'),
	(648141, 132, '2015-01-15 00:49:56.000000', 'consum', 0.0217, 'lps'),
	(648142, 132, '2015-01-15 00:49:57.000000', 'consum', 0.0215, 'lps'),
	(648143, 132, '2015-01-15 00:49:58.000000', 'consum', 0.0213, 'lps'),
	(648144, 132, '2015-01-15 00:49:59.000000', 'consum', 0.0220, 'lps'),
	(648145, 132, '2015-01-15 00:50:00.000000', 'consum', 0.0210, 'lps'),
	(648146, 132, '2015-01-15 00:50:01.000000', 'consum', 0.0212, 'lps'),
	(648147, 132, '2015-01-15 00:50:02.000000', 'consum', 0.0220, 'lps'),
	(648148, 132, '2015-01-15 00:50:03.000000', 'consum', 0.0211, 'lps'),
	(648149, 132, '2015-01-15 00:50:04.000000', 'consum', 0.0219, 'lps'),
	(648150, 132, '2015-01-15 00:50:05.000000', 'consum', 0.0220, 'lps'),
	(648151, 132, '2015-01-15 00:50:06.000000', 'consum', 0.0211, 'lps'),
	(648152, 132, '2015-01-15 00:50:07.000000', 'consum', 0.0220, 'lps'),
	(648153, 132, '2015-01-15 00:50:08.000000', 'consum', 0.0214, 'lps'),
	(648154, 132, '2015-01-15 00:50:09.000000', 'consum', 0.0211, 'lps'),
	(648155, 132, '2015-01-15 00:50:10.000000', 'consum', 0.0213, 'lps'),
	(648156, 132, '2015-01-15 00:50:11.000000', 'consum', 0.0210, 'lps'),
	(648157, 132, '2015-01-15 00:50:12.000000', 'consum', 0.0216, 'lps'),
	(648158, 132, '2015-01-15 00:50:13.000000', 'consum', 0.0215, 'lps'),
	(648159, 132, '2015-01-15 00:50:14.000000', 'consum', 0.0210, 'lps'),
	(648160, 132, '2015-01-15 00:50:15.000000', 'consum', 0.0216, 'lps'),
	(648161, 132, '2015-01-15 00:50:16.000000', 'consum', 0.0218, 'lps'),
	(648162, 132, '2015-01-15 00:50:17.000000', 'consum', 0.0210, 'lps'),
	(648163, 132, '2015-01-15 00:50:18.000000', 'consum', 0.0218, 'lps'),
	(648164, 132, '2015-01-15 00:50:19.000000', 'consum', 0.0219, 'lps'),
	(648165, 132, '2015-01-15 00:50:20.000000', 'consum', 0.0211, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(648166, 132, '2015-01-15 00:50:21.000000', 'consum', 0.0210, 'lps'),
	(648167, 132, '2015-01-15 00:50:22.000000', 'consum', 0.0218, 'lps'),
	(648168, 132, '2015-01-15 00:50:23.000000', 'consum', 0.0217, 'lps'),
	(648169, 132, '2015-01-15 00:50:24.000000', 'consum', 0.0212, 'lps'),
	(648170, 132, '2015-01-15 00:50:25.000000', 'consum', 0.0220, 'lps'),
	(648171, 132, '2015-01-15 00:50:26.000000', 'consum', 0.0220, 'lps'),
	(648172, 132, '2015-01-15 00:50:27.000000', 'consum', 0.0210, 'lps'),
	(648173, 132, '2015-01-15 00:50:28.000000', 'consum', 0.0214, 'lps'),
	(648174, 132, '2015-01-15 00:50:29.000000', 'consum', 0.0217, 'lps'),
	(648175, 132, '2015-01-15 00:50:30.000000', 'consum', 0.0214, 'lps'),
	(648176, 132, '2015-01-15 00:50:31.000000', 'consum', 0.0220, 'lps'),
	(648177, 132, '2015-01-15 00:50:32.000000', 'consum', 0.0214, 'lps'),
	(648178, 132, '2015-01-15 00:50:33.000000', 'consum', 0.0211, 'lps'),
	(648179, 132, '2015-01-15 00:50:34.000000', 'consum', 0.0217, 'lps'),
	(648180, 132, '2015-01-15 00:50:35.000000', 'consum', 0.0218, 'lps'),
	(648181, 132, '2015-01-15 00:50:36.000000', 'consum', 0.0210, 'lps'),
	(648182, 132, '2015-01-15 00:50:37.000000', 'consum', 0.0219, 'lps'),
	(648183, 132, '2015-01-15 00:50:38.000000', 'consum', 0.0220, 'lps'),
	(648184, 132, '2015-01-15 00:50:39.000000', 'consum', 0.0215, 'lps'),
	(648185, 132, '2015-01-15 00:50:40.000000', 'consum', 0.0215, 'lps'),
	(648186, 132, '2015-01-15 00:50:41.000000', 'consum', 0.0210, 'lps'),
	(648187, 132, '2015-01-15 00:50:42.000000', 'consum', 0.0219, 'lps'),
	(648188, 132, '2015-01-15 00:50:43.000000', 'consum', 0.0210, 'lps'),
	(648189, 132, '2015-01-15 00:50:44.000000', 'consum', 0.0218, 'lps'),
	(648190, 132, '2015-01-15 00:50:45.000000', 'consum', 0.0217, 'lps'),
	(648191, 132, '2015-01-15 00:50:46.000000', 'consum', 0.0212, 'lps'),
	(648192, 132, '2015-01-15 00:50:47.000000', 'consum', 0.0219, 'lps'),
	(648193, 132, '2015-01-15 00:50:48.000000', 'consum', 0.0218, 'lps'),
	(648194, 132, '2015-01-15 00:50:49.000000', 'consum', 0.0213, 'lps'),
	(648195, 132, '2015-01-15 00:50:50.000000', 'consum', 0.0212, 'lps'),
	(648196, 132, '2015-01-15 00:50:51.000000', 'consum', 0.0211, 'lps'),
	(648197, 132, '2015-01-15 00:50:52.000000', 'consum', 0.0210, 'lps'),
	(648198, 132, '2015-01-15 00:50:53.000000', 'consum', 0.0220, 'lps'),
	(648199, 132, '2015-01-15 00:50:54.000000', 'consum', 0.0214, 'lps'),
	(648200, 132, '2015-01-15 00:50:55.000000', 'consum', 0.0214, 'lps'),
	(648201, 132, '2015-01-15 00:50:56.000000', 'consum', 0.0217, 'lps'),
	(648202, 132, '2015-01-15 00:50:57.000000', 'consum', 0.0212, 'lps'),
	(648203, 132, '2015-01-15 00:50:58.000000', 'consum', 0.0211, 'lps'),
	(648204, 132, '2015-01-15 00:50:59.000000', 'consum', 0.0220, 'lps'),
	(648205, 132, '2015-01-15 00:51:00.000000', 'consum', 0.0215, 'lps'),
	(648206, 132, '2015-01-15 00:51:01.000000', 'consum', 0.0214, 'lps'),
	(648207, 132, '2015-01-15 00:51:02.000000', 'consum', 0.0215, 'lps'),
	(648208, 132, '2015-01-15 00:51:03.000000', 'consum', 0.0213, 'lps'),
	(648209, 132, '2015-01-15 00:51:04.000000', 'consum', 0.0212, 'lps'),
	(648210, 132, '2015-01-15 00:51:05.000000', 'consum', 0.0211, 'lps'),
	(648211, 132, '2015-01-15 00:51:06.000000', 'consum', 0.0219, 'lps'),
	(648212, 132, '2015-01-15 00:51:07.000000', 'consum', 0.0220, 'lps'),
	(648213, 132, '2015-01-15 00:51:08.000000', 'consum', 0.0213, 'lps'),
	(648214, 132, '2015-01-15 00:51:09.000000', 'consum', 0.0219, 'lps'),
	(648215, 132, '2015-01-15 00:51:10.000000', 'consum', 0.0211, 'lps'),
	(648216, 132, '2015-01-15 00:51:11.000000', 'consum', 0.0211, 'lps'),
	(648217, 132, '2015-01-15 00:51:12.000000', 'consum', 0.0214, 'lps'),
	(648218, 132, '2015-01-15 00:51:13.000000', 'consum', 0.0214, 'lps'),
	(648219, 132, '2015-01-15 00:51:14.000000', 'consum', 0.0219, 'lps'),
	(648220, 132, '2015-01-15 00:51:15.000000', 'consum', 0.0211, 'lps'),
	(648221, 132, '2015-01-15 00:51:16.000000', 'consum', 0.0211, 'lps'),
	(648222, 132, '2015-01-15 00:51:17.000000', 'consum', 0.0214, 'lps'),
	(648223, 132, '2015-01-15 00:51:18.000000', 'consum', 0.0214, 'lps'),
	(648224, 132, '2015-01-15 00:51:19.000000', 'consum', 0.0219, 'lps'),
	(648225, 132, '2015-01-15 00:51:20.000000', 'consum', 0.0210, 'lps'),
	(648226, 132, '2015-01-15 00:51:21.000000', 'consum', 0.0219, 'lps'),
	(648227, 132, '2015-01-15 00:51:22.000000', 'consum', 0.0220, 'lps'),
	(648228, 132, '2015-01-15 00:51:23.000000', 'consum', 0.0212, 'lps'),
	(648229, 132, '2015-01-15 00:51:24.000000', 'consum', 0.0213, 'lps'),
	(648230, 132, '2015-01-15 00:51:25.000000', 'consum', 0.0220, 'lps'),
	(648231, 132, '2015-01-15 00:51:26.000000', 'consum', 0.0219, 'lps'),
	(648232, 132, '2015-01-15 00:51:27.000000', 'consum', 0.0212, 'lps'),
	(648233, 132, '2015-01-15 00:51:28.000000', 'consum', 0.0216, 'lps'),
	(648234, 132, '2015-01-15 00:51:29.000000', 'consum', 0.0212, 'lps'),
	(648235, 132, '2015-01-15 00:51:30.000000', 'consum', 0.0213, 'lps'),
	(648236, 132, '2015-01-15 00:51:31.000000', 'consum', 0.0220, 'lps'),
	(648237, 132, '2015-01-15 00:51:32.000000', 'consum', 0.0210, 'lps'),
	(648238, 132, '2015-01-15 00:51:33.000000', 'consum', 0.0211, 'lps'),
	(648239, 132, '2015-01-15 00:51:34.000000', 'consum', 0.0216, 'lps'),
	(648240, 132, '2015-01-15 00:51:35.000000', 'consum', 0.0214, 'lps'),
	(648241, 132, '2015-01-15 00:51:36.000000', 'consum', 0.0213, 'lps'),
	(648242, 132, '2015-01-15 00:51:37.000000', 'consum', 0.0213, 'lps'),
	(648243, 132, '2015-01-15 00:51:38.000000', 'consum', 0.0217, 'lps'),
	(648244, 132, '2015-01-15 00:51:39.000000', 'consum', 0.0216, 'lps'),
	(648245, 132, '2015-01-15 00:51:40.000000', 'consum', 0.0217, 'lps'),
	(648246, 132, '2015-01-15 00:51:41.000000', 'consum', 0.0219, 'lps'),
	(648247, 132, '2015-01-15 00:51:42.000000', 'consum', 0.0212, 'lps'),
	(648248, 132, '2015-01-15 00:51:43.000000', 'consum', 0.0215, 'lps'),
	(648249, 132, '2015-01-15 00:51:44.000000', 'consum', 0.0220, 'lps'),
	(648250, 132, '2015-01-15 00:51:45.000000', 'consum', 0.0212, 'lps'),
	(648251, 132, '2015-01-15 00:51:46.000000', 'consum', 0.0212, 'lps'),
	(648252, 132, '2015-01-15 00:51:47.000000', 'consum', 0.0216, 'lps'),
	(648253, 132, '2015-01-15 00:51:48.000000', 'consum', 0.0212, 'lps'),
	(648254, 132, '2015-01-15 00:51:49.000000', 'consum', 0.0214, 'lps'),
	(648255, 132, '2015-01-15 00:51:50.000000', 'consum', 0.0213, 'lps'),
	(648256, 132, '2015-01-15 00:51:51.000000', 'consum', 0.0212, 'lps'),
	(648257, 132, '2015-01-15 00:51:52.000000', 'consum', 0.0211, 'lps'),
	(648258, 132, '2015-01-15 00:51:53.000000', 'consum', 0.0210, 'lps'),
	(648259, 132, '2015-01-15 00:51:54.000000', 'consum', 0.0219, 'lps'),
	(648260, 132, '2015-01-15 00:51:55.000000', 'consum', 0.0213, 'lps'),
	(648261, 132, '2015-01-15 00:51:56.000000', 'consum', 0.0210, 'lps'),
	(648262, 132, '2015-01-15 00:51:57.000000', 'consum', 0.0211, 'lps'),
	(648263, 132, '2015-01-15 00:51:58.000000', 'consum', 0.0217, 'lps'),
	(648264, 132, '2015-01-15 00:51:59.000000', 'consum', 0.0210, 'lps'),
	(648265, 132, '2015-01-15 00:52:00.000000', 'consum', 0.0219, 'lps'),
	(648266, 132, '2015-01-15 00:52:01.000000', 'consum', 0.0215, 'lps'),
	(648267, 132, '2015-01-15 00:52:02.000000', 'consum', 0.0219, 'lps'),
	(648268, 132, '2015-01-15 00:52:03.000000', 'consum', 0.0218, 'lps'),
	(648269, 132, '2015-01-15 00:52:04.000000', 'consum', 0.0214, 'lps'),
	(648270, 132, '2015-01-15 00:52:05.000000', 'consum', 0.0216, 'lps'),
	(648271, 132, '2015-01-15 00:52:06.000000', 'consum', 0.0219, 'lps'),
	(648272, 132, '2015-01-15 00:52:07.000000', 'consum', 0.0213, 'lps'),
	(648273, 132, '2015-01-15 00:52:08.000000', 'consum', 0.0212, 'lps'),
	(648274, 132, '2015-01-15 00:52:09.000000', 'consum', 0.0220, 'lps'),
	(648275, 132, '2015-01-15 00:52:10.000000', 'consum', 0.0211, 'lps'),
	(648276, 132, '2015-01-15 00:52:11.000000', 'consum', 0.0219, 'lps'),
	(648277, 132, '2015-01-15 00:52:12.000000', 'consum', 0.0218, 'lps'),
	(648278, 132, '2015-01-15 00:52:13.000000', 'consum', 0.0216, 'lps'),
	(648279, 132, '2015-01-15 00:52:14.000000', 'consum', 0.0213, 'lps'),
	(648280, 132, '2015-01-15 00:52:15.000000', 'consum', 0.0220, 'lps'),
	(648281, 132, '2015-01-15 00:52:16.000000', 'consum', 0.0220, 'lps'),
	(648282, 132, '2015-01-15 00:52:17.000000', 'consum', 0.0218, 'lps'),
	(648283, 132, '2015-01-15 00:52:18.000000', 'consum', 0.0210, 'lps'),
	(648284, 132, '2015-01-15 00:52:19.000000', 'consum', 0.0220, 'lps'),
	(648285, 132, '2015-01-15 00:52:20.000000', 'consum', 0.0216, 'lps'),
	(648286, 132, '2015-01-15 00:52:21.000000', 'consum', 0.0211, 'lps'),
	(648287, 132, '2015-01-15 00:52:22.000000', 'consum', 0.0220, 'lps'),
	(648288, 132, '2015-01-15 00:52:23.000000', 'consum', 0.0212, 'lps'),
	(648289, 132, '2015-01-15 00:52:24.000000', 'consum', 0.0215, 'lps'),
	(648290, 132, '2015-01-15 00:52:25.000000', 'consum', 0.0218, 'lps'),
	(648291, 132, '2015-01-15 00:52:26.000000', 'consum', 0.0213, 'lps'),
	(648292, 132, '2015-01-15 00:52:27.000000', 'consum', 0.0211, 'lps'),
	(648293, 132, '2015-01-15 00:52:28.000000', 'consum', 0.0218, 'lps'),
	(648294, 132, '2015-01-15 00:52:29.000000', 'consum', 0.0213, 'lps'),
	(648295, 132, '2015-01-15 00:52:30.000000', 'consum', 0.0215, 'lps'),
	(648296, 132, '2015-01-15 00:52:31.000000', 'consum', 0.0216, 'lps'),
	(648297, 132, '2015-01-15 00:52:32.000000', 'consum', 0.0211, 'lps'),
	(648298, 132, '2015-01-15 00:52:33.000000', 'consum', 0.0212, 'lps'),
	(648299, 132, '2015-01-15 00:52:34.000000', 'consum', 0.0218, 'lps'),
	(648300, 132, '2015-01-15 00:52:35.000000', 'consum', 0.0211, 'lps'),
	(648301, 132, '2015-01-15 00:52:36.000000', 'consum', 0.0212, 'lps'),
	(648302, 132, '2015-01-15 00:52:37.000000', 'consum', 0.0218, 'lps'),
	(648303, 132, '2015-01-15 00:52:38.000000', 'consum', 0.0213, 'lps'),
	(648304, 132, '2015-01-15 00:52:39.000000', 'consum', 0.0213, 'lps'),
	(648305, 132, '2015-01-15 00:52:40.000000', 'consum', 0.0215, 'lps'),
	(648306, 132, '2015-01-15 00:52:41.000000', 'consum', 0.0218, 'lps'),
	(648307, 132, '2015-01-15 00:52:42.000000', 'consum', 0.0211, 'lps'),
	(648308, 132, '2015-01-15 00:52:43.000000', 'consum', 0.0214, 'lps'),
	(648309, 132, '2015-01-15 00:52:44.000000', 'consum', 0.0218, 'lps'),
	(648310, 132, '2015-01-15 00:52:45.000000', 'consum', 0.0216, 'lps'),
	(648311, 132, '2015-01-15 00:52:46.000000', 'consum', 0.0215, 'lps'),
	(648312, 132, '2015-01-15 00:52:47.000000', 'consum', 0.0219, 'lps'),
	(648313, 132, '2015-01-15 00:52:48.000000', 'consum', 0.0216, 'lps'),
	(648314, 132, '2015-01-15 00:52:49.000000', 'consum', 0.0217, 'lps'),
	(648315, 132, '2015-01-15 00:52:50.000000', 'consum', 0.0214, 'lps'),
	(648316, 132, '2015-01-15 00:52:51.000000', 'consum', 0.0211, 'lps'),
	(648317, 132, '2015-01-15 00:52:52.000000', 'consum', 0.0213, 'lps'),
	(648318, 132, '2015-01-15 00:52:53.000000', 'consum', 0.0213, 'lps'),
	(648319, 132, '2015-01-15 00:52:54.000000', 'consum', 0.0215, 'lps'),
	(648320, 132, '2015-01-15 00:52:55.000000', 'consum', 0.0217, 'lps'),
	(648321, 132, '2015-01-15 00:52:56.000000', 'consum', 0.0219, 'lps'),
	(648322, 132, '2015-01-15 00:52:57.000000', 'consum', 0.0212, 'lps'),
	(648323, 132, '2015-01-15 00:52:58.000000', 'consum', 0.0215, 'lps'),
	(648324, 132, '2015-01-15 00:52:59.000000', 'consum', 0.0220, 'lps'),
	(648325, 132, '2015-01-15 00:53:00.000000', 'consum', 0.0210, 'lps'),
	(648326, 132, '2015-01-15 00:53:01.000000', 'consum', 0.0217, 'lps'),
	(648327, 132, '2015-01-15 00:53:02.000000', 'consum', 0.0210, 'lps'),
	(648328, 132, '2015-01-15 00:53:03.000000', 'consum', 0.0213, 'lps'),
	(648329, 132, '2015-01-15 00:53:04.000000', 'consum', 0.0213, 'lps'),
	(648330, 132, '2015-01-15 00:53:05.000000', 'consum', 0.0216, 'lps'),
	(648331, 132, '2015-01-15 00:53:06.000000', 'consum', 0.0212, 'lps'),
	(648332, 132, '2015-01-15 00:53:07.000000', 'consum', 0.0211, 'lps'),
	(648333, 132, '2015-01-15 00:53:08.000000', 'consum', 0.0220, 'lps'),
	(648334, 132, '2015-01-15 00:53:09.000000', 'consum', 0.0214, 'lps'),
	(648335, 132, '2015-01-15 00:53:10.000000', 'consum', 0.0210, 'lps'),
	(648336, 132, '2015-01-15 00:53:11.000000', 'consum', 0.0212, 'lps'),
	(648337, 132, '2015-01-15 00:53:12.000000', 'consum', 0.0211, 'lps'),
	(648338, 132, '2015-01-15 00:53:13.000000', 'consum', 0.0217, 'lps'),
	(648339, 132, '2015-01-15 00:53:14.000000', 'consum', 0.0211, 'lps'),
	(648340, 132, '2015-01-15 00:53:15.000000', 'consum', 0.0216, 'lps'),
	(648341, 132, '2015-01-15 00:53:16.000000', 'consum', 0.0215, 'lps'),
	(648342, 132, '2015-01-15 00:53:17.000000', 'consum', 0.0217, 'lps'),
	(648343, 132, '2015-01-15 00:53:18.000000', 'consum', 0.0219, 'lps'),
	(648344, 132, '2015-01-15 00:53:19.000000', 'consum', 0.0214, 'lps'),
	(648345, 132, '2015-01-15 00:53:20.000000', 'consum', 0.0213, 'lps'),
	(648346, 132, '2015-01-15 00:53:21.000000', 'consum', 0.0213, 'lps'),
	(648347, 132, '2015-01-15 00:53:22.000000', 'consum', 0.0219, 'lps'),
	(648348, 132, '2015-01-15 00:53:23.000000', 'consum', 0.0214, 'lps'),
	(648349, 132, '2015-01-15 00:53:24.000000', 'consum', 0.0215, 'lps'),
	(648350, 132, '2015-01-15 00:53:25.000000', 'consum', 0.0211, 'lps'),
	(648351, 132, '2015-01-15 00:53:26.000000', 'consum', 0.0211, 'lps'),
	(648352, 132, '2015-01-15 00:53:27.000000', 'consum', 0.0214, 'lps'),
	(648353, 132, '2015-01-15 00:53:28.000000', 'consum', 0.0214, 'lps'),
	(648354, 132, '2015-01-15 00:53:29.000000', 'consum', 0.0211, 'lps'),
	(648355, 132, '2015-01-15 00:53:30.000000', 'consum', 0.0212, 'lps'),
	(648356, 132, '2015-01-15 00:53:31.000000', 'consum', 0.0217, 'lps'),
	(648357, 132, '2015-01-15 00:53:32.000000', 'consum', 0.0218, 'lps'),
	(648358, 132, '2015-01-15 00:53:33.000000', 'consum', 0.0218, 'lps'),
	(648359, 132, '2015-01-15 00:53:34.000000', 'consum', 0.0215, 'lps'),
	(648360, 132, '2015-01-15 00:53:35.000000', 'consum', 0.0212, 'lps'),
	(648361, 132, '2015-01-15 00:53:36.000000', 'consum', 0.0218, 'lps'),
	(648362, 132, '2015-01-15 00:53:37.000000', 'consum', 0.0212, 'lps'),
	(648363, 132, '2015-01-15 00:53:38.000000', 'consum', 0.0219, 'lps'),
	(648364, 132, '2015-01-15 00:53:39.000000', 'consum', 0.0214, 'lps'),
	(648365, 132, '2015-01-15 00:53:40.000000', 'consum', 0.0214, 'lps'),
	(648366, 132, '2015-01-15 00:53:41.000000', 'consum', 0.0219, 'lps'),
	(648367, 132, '2015-01-15 00:53:42.000000', 'consum', 0.0210, 'lps'),
	(648368, 132, '2015-01-15 00:53:43.000000', 'consum', 0.0216, 'lps'),
	(648369, 132, '2015-01-15 00:53:44.000000', 'consum', 0.0210, 'lps'),
	(648370, 132, '2015-01-15 00:53:45.000000', 'consum', 0.0215, 'lps'),
	(648371, 132, '2015-01-15 00:53:46.000000', 'consum', 0.0211, 'lps'),
	(648372, 132, '2015-01-15 00:53:47.000000', 'consum', 0.0211, 'lps'),
	(648373, 132, '2015-01-15 00:53:48.000000', 'consum', 0.0214, 'lps'),
	(648374, 132, '2015-01-15 00:53:49.000000', 'consum', 0.0218, 'lps'),
	(648375, 132, '2015-01-15 00:53:50.000000', 'consum', 0.0215, 'lps'),
	(648376, 132, '2015-01-15 00:53:51.000000', 'consum', 0.0213, 'lps'),
	(648377, 132, '2015-01-15 00:53:52.000000', 'consum', 0.0220, 'lps'),
	(648378, 132, '2015-01-15 00:53:53.000000', 'consum', 0.0220, 'lps'),
	(648379, 132, '2015-01-15 00:53:54.000000', 'consum', 0.0217, 'lps'),
	(648380, 132, '2015-01-15 00:53:55.000000', 'consum', 0.0215, 'lps'),
	(648381, 132, '2015-01-15 00:53:56.000000', 'consum', 0.0218, 'lps'),
	(648382, 132, '2015-01-15 00:53:57.000000', 'consum', 0.0210, 'lps'),
	(648383, 132, '2015-01-15 00:53:58.000000', 'consum', 0.0211, 'lps'),
	(648384, 132, '2015-01-15 00:53:59.000000', 'consum', 0.0216, 'lps'),
	(648385, 132, '2015-01-15 00:54:00.000000', 'consum', 0.0216, 'lps'),
	(648386, 132, '2015-01-15 00:54:01.000000', 'consum', 0.0220, 'lps'),
	(648387, 132, '2015-01-15 00:54:02.000000', 'consum', 0.0210, 'lps'),
	(648388, 132, '2015-01-15 00:54:03.000000', 'consum', 0.0212, 'lps'),
	(648389, 132, '2015-01-15 00:54:04.000000', 'consum', 0.0212, 'lps'),
	(648390, 132, '2015-01-15 00:54:05.000000', 'consum', 0.0213, 'lps'),
	(648391, 132, '2015-01-15 00:54:06.000000', 'consum', 0.0210, 'lps'),
	(648392, 132, '2015-01-15 00:54:07.000000', 'consum', 0.0212, 'lps'),
	(648393, 132, '2015-01-15 00:54:08.000000', 'consum', 0.0210, 'lps'),
	(648394, 132, '2015-01-15 00:54:09.000000', 'consum', 0.0216, 'lps'),
	(648395, 132, '2015-01-15 00:54:10.000000', 'consum', 0.0216, 'lps'),
	(648396, 132, '2015-01-15 00:54:11.000000', 'consum', 0.0212, 'lps'),
	(648397, 132, '2015-01-15 00:54:12.000000', 'consum', 0.0213, 'lps'),
	(648398, 132, '2015-01-15 00:54:13.000000', 'consum', 0.0219, 'lps'),
	(648399, 132, '2015-01-15 00:54:14.000000', 'consum', 0.0215, 'lps'),
	(648400, 132, '2015-01-15 00:54:15.000000', 'consum', 0.0210, 'lps'),
	(648401, 132, '2015-01-15 00:54:16.000000', 'consum', 0.0215, 'lps'),
	(648402, 132, '2015-01-15 00:54:17.000000', 'consum', 0.0214, 'lps'),
	(648403, 132, '2015-01-15 00:54:18.000000', 'consum', 0.0218, 'lps'),
	(648404, 132, '2015-01-15 00:54:19.000000', 'consum', 0.0213, 'lps'),
	(648405, 132, '2015-01-15 00:54:20.000000', 'consum', 0.0215, 'lps'),
	(648406, 132, '2015-01-15 00:54:21.000000', 'consum', 0.0214, 'lps'),
	(648407, 132, '2015-01-15 00:54:22.000000', 'consum', 0.0218, 'lps'),
	(648408, 132, '2015-01-15 00:54:23.000000', 'consum', 0.0216, 'lps'),
	(648409, 132, '2015-01-15 00:54:24.000000', 'consum', 0.0214, 'lps'),
	(648410, 132, '2015-01-15 00:54:25.000000', 'consum', 0.0213, 'lps'),
	(648411, 132, '2015-01-15 00:54:26.000000', 'consum', 0.0212, 'lps'),
	(648412, 132, '2015-01-15 00:54:27.000000', 'consum', 0.0214, 'lps'),
	(648413, 132, '2015-01-15 00:54:28.000000', 'consum', 0.0213, 'lps'),
	(648414, 132, '2015-01-15 00:54:29.000000', 'consum', 0.0213, 'lps'),
	(648415, 132, '2015-01-15 00:54:30.000000', 'consum', 0.0217, 'lps'),
	(648416, 132, '2015-01-15 00:54:31.000000', 'consum', 0.0216, 'lps'),
	(648417, 132, '2015-01-15 00:54:32.000000', 'consum', 0.0220, 'lps'),
	(648418, 132, '2015-01-15 00:54:33.000000', 'consum', 0.0220, 'lps'),
	(648419, 132, '2015-01-15 00:54:34.000000', 'consum', 0.0220, 'lps'),
	(648420, 132, '2015-01-15 00:54:35.000000', 'consum', 0.0220, 'lps'),
	(648421, 132, '2015-01-15 00:54:36.000000', 'consum', 0.0218, 'lps'),
	(648422, 132, '2015-01-15 00:54:37.000000', 'consum', 0.0211, 'lps'),
	(648423, 132, '2015-01-15 00:54:38.000000', 'consum', 0.0215, 'lps'),
	(648424, 132, '2015-01-15 00:54:39.000000', 'consum', 0.0220, 'lps'),
	(648425, 132, '2015-01-15 00:54:40.000000', 'consum', 0.0211, 'lps'),
	(648426, 132, '2015-01-15 00:54:41.000000', 'consum', 0.0219, 'lps'),
	(648427, 132, '2015-01-15 00:54:42.000000', 'consum', 0.0218, 'lps'),
	(648428, 132, '2015-01-15 00:54:43.000000', 'consum', 0.0215, 'lps'),
	(648429, 132, '2015-01-15 00:54:44.000000', 'consum', 0.0220, 'lps'),
	(648430, 132, '2015-01-15 00:54:45.000000', 'consum', 0.0215, 'lps'),
	(648431, 132, '2015-01-15 00:54:46.000000', 'consum', 0.0216, 'lps'),
	(648432, 132, '2015-01-15 00:54:47.000000', 'consum', 0.0213, 'lps'),
	(648433, 132, '2015-01-15 00:54:48.000000', 'consum', 0.0219, 'lps'),
	(648434, 132, '2015-01-15 00:54:49.000000', 'consum', 0.0212, 'lps'),
	(648435, 132, '2015-01-15 00:54:50.000000', 'consum', 0.0215, 'lps'),
	(648436, 132, '2015-01-15 00:54:51.000000', 'consum', 0.0220, 'lps'),
	(648437, 132, '2015-01-15 00:54:52.000000', 'consum', 0.0214, 'lps'),
	(648438, 132, '2015-01-15 00:54:53.000000', 'consum', 0.0212, 'lps'),
	(648439, 132, '2015-01-15 00:54:54.000000', 'consum', 0.0218, 'lps'),
	(648440, 132, '2015-01-15 00:54:55.000000', 'consum', 0.0211, 'lps'),
	(648441, 132, '2015-01-15 00:54:56.000000', 'consum', 0.0214, 'lps'),
	(648442, 132, '2015-01-15 00:54:57.000000', 'consum', 0.0216, 'lps'),
	(648443, 132, '2015-01-15 00:54:58.000000', 'consum', 0.0220, 'lps'),
	(648444, 132, '2015-01-15 00:54:59.000000', 'consum', 0.0218, 'lps'),
	(648445, 132, '2015-01-15 00:55:00.000000', 'consum', 0.0211, 'lps'),
	(648446, 132, '2015-01-15 00:55:01.000000', 'consum', 0.0213, 'lps'),
	(648447, 132, '2015-01-15 00:55:02.000000', 'consum', 0.0210, 'lps'),
	(648448, 132, '2015-01-15 00:55:03.000000', 'consum', 0.0212, 'lps'),
	(648449, 132, '2015-01-15 00:55:04.000000', 'consum', 0.0220, 'lps'),
	(648450, 132, '2015-01-15 00:55:05.000000', 'consum', 0.0220, 'lps'),
	(648451, 132, '2015-01-15 00:55:06.000000', 'consum', 0.0212, 'lps'),
	(648452, 132, '2015-01-15 00:55:07.000000', 'consum', 0.0213, 'lps'),
	(648453, 132, '2015-01-15 00:55:08.000000', 'consum', 0.0219, 'lps'),
	(648454, 132, '2015-01-15 00:55:09.000000', 'consum', 0.0211, 'lps'),
	(648455, 132, '2015-01-15 00:55:10.000000', 'consum', 0.0212, 'lps'),
	(648456, 132, '2015-01-15 00:55:11.000000', 'consum', 0.0217, 'lps'),
	(648457, 132, '2015-01-15 00:55:12.000000', 'consum', 0.0219, 'lps'),
	(648458, 132, '2015-01-15 00:55:13.000000', 'consum', 0.0210, 'lps'),
	(648459, 132, '2015-01-15 00:55:14.000000', 'consum', 0.0219, 'lps'),
	(648460, 132, '2015-01-15 00:55:15.000000', 'consum', 0.0220, 'lps'),
	(648461, 132, '2015-01-15 00:55:16.000000', 'consum', 0.0211, 'lps'),
	(648462, 132, '2015-01-15 00:55:17.000000', 'consum', 0.0220, 'lps'),
	(648463, 132, '2015-01-15 00:55:18.000000', 'consum', 0.0212, 'lps'),
	(648464, 132, '2015-01-15 00:55:19.000000', 'consum', 0.0215, 'lps'),
	(648465, 132, '2015-01-15 00:55:20.000000', 'consum', 0.0216, 'lps'),
	(648466, 132, '2015-01-15 00:55:21.000000', 'consum', 0.0214, 'lps'),
	(648467, 132, '2015-01-15 00:55:22.000000', 'consum', 0.0213, 'lps'),
	(648468, 132, '2015-01-15 00:55:23.000000', 'consum', 0.0212, 'lps'),
	(648469, 132, '2015-01-15 00:55:24.000000', 'consum', 0.0214, 'lps'),
	(648470, 132, '2015-01-15 00:55:25.000000', 'consum', 0.0211, 'lps'),
	(648471, 132, '2015-01-15 00:55:26.000000', 'consum', 0.0215, 'lps'),
	(648472, 132, '2015-01-15 00:55:27.000000', 'consum', 0.0211, 'lps'),
	(648473, 132, '2015-01-15 00:55:28.000000', 'consum', 0.0211, 'lps'),
	(648474, 132, '2015-01-15 00:55:29.000000', 'consum', 0.0213, 'lps'),
	(648475, 132, '2015-01-15 00:55:30.000000', 'consum', 0.0212, 'lps'),
	(648476, 132, '2015-01-15 00:55:31.000000', 'consum', 0.0210, 'lps'),
	(648477, 132, '2015-01-15 00:55:32.000000', 'consum', 0.0218, 'lps'),
	(648478, 132, '2015-01-15 00:55:33.000000', 'consum', 0.0216, 'lps'),
	(648479, 132, '2015-01-15 00:55:34.000000', 'consum', 0.0218, 'lps'),
	(648480, 132, '2015-01-15 00:55:35.000000', 'consum', 0.0219, 'lps'),
	(648481, 132, '2015-01-15 00:55:36.000000', 'consum', 0.0210, 'lps'),
	(648482, 132, '2015-01-15 00:55:37.000000', 'consum', 0.0217, 'lps'),
	(648483, 132, '2015-01-15 00:55:38.000000', 'consum', 0.0214, 'lps'),
	(648484, 132, '2015-01-15 00:55:39.000000', 'consum', 0.0210, 'lps'),
	(648485, 132, '2015-01-15 00:55:40.000000', 'consum', 0.0219, 'lps'),
	(648486, 132, '2015-01-15 00:55:41.000000', 'consum', 0.0212, 'lps'),
	(648487, 132, '2015-01-15 00:55:42.000000', 'consum', 0.0217, 'lps'),
	(648488, 132, '2015-01-15 00:55:43.000000', 'consum', 0.0218, 'lps'),
	(648489, 132, '2015-01-15 00:55:44.000000', 'consum', 0.0217, 'lps'),
	(648490, 132, '2015-01-15 00:55:45.000000', 'consum', 0.0211, 'lps'),
	(648491, 132, '2015-01-15 00:55:46.000000', 'consum', 0.0218, 'lps'),
	(648492, 132, '2015-01-15 00:55:47.000000', 'consum', 0.0214, 'lps'),
	(648493, 132, '2015-01-15 00:55:48.000000', 'consum', 0.0218, 'lps'),
	(648494, 132, '2015-01-15 00:55:49.000000', 'consum', 0.0214, 'lps'),
	(648495, 132, '2015-01-15 00:55:50.000000', 'consum', 0.0218, 'lps'),
	(648496, 132, '2015-01-15 00:55:51.000000', 'consum', 0.0217, 'lps'),
	(648497, 132, '2015-01-15 00:55:52.000000', 'consum', 0.0212, 'lps'),
	(648498, 132, '2015-01-15 00:55:53.000000', 'consum', 0.0211, 'lps'),
	(648499, 132, '2015-01-15 00:55:54.000000', 'consum', 0.0220, 'lps'),
	(648500, 132, '2015-01-15 00:55:55.000000', 'consum', 0.0215, 'lps'),
	(648501, 132, '2015-01-15 00:55:56.000000', 'consum', 0.0214, 'lps'),
	(648502, 132, '2015-01-15 00:55:57.000000', 'consum', 0.0217, 'lps'),
	(648503, 132, '2015-01-15 00:55:58.000000', 'consum', 0.0211, 'lps'),
	(648504, 132, '2015-01-15 00:55:59.000000', 'consum', 0.0215, 'lps'),
	(648505, 132, '2015-01-15 00:56:00.000000', 'consum', 0.0211, 'lps'),
	(648506, 132, '2015-01-15 00:56:01.000000', 'consum', 0.0214, 'lps'),
	(648507, 132, '2015-01-15 00:56:02.000000', 'consum', 0.0215, 'lps'),
	(648508, 132, '2015-01-15 00:56:03.000000', 'consum', 0.0211, 'lps'),
	(648509, 132, '2015-01-15 00:56:04.000000', 'consum', 0.0212, 'lps'),
	(648510, 132, '2015-01-15 00:56:05.000000', 'consum', 0.0217, 'lps'),
	(648511, 132, '2015-01-15 00:56:06.000000', 'consum', 0.0219, 'lps'),
	(648512, 132, '2015-01-15 00:56:07.000000', 'consum', 0.0213, 'lps'),
	(648513, 132, '2015-01-15 00:56:08.000000', 'consum', 0.0218, 'lps'),
	(648514, 132, '2015-01-15 00:56:09.000000', 'consum', 0.0220, 'lps'),
	(648515, 132, '2015-01-15 00:56:10.000000', 'consum', 0.0215, 'lps'),
	(648516, 132, '2015-01-15 00:56:11.000000', 'consum', 0.0217, 'lps'),
	(648517, 132, '2015-01-15 00:56:12.000000', 'consum', 0.0218, 'lps'),
	(648518, 132, '2015-01-15 00:56:13.000000', 'consum', 0.0217, 'lps'),
	(648519, 132, '2015-01-15 00:56:14.000000', 'consum', 0.0213, 'lps'),
	(648520, 132, '2015-01-15 00:56:15.000000', 'consum', 0.0215, 'lps'),
	(648521, 132, '2015-01-15 00:56:16.000000', 'consum', 0.0216, 'lps'),
	(648522, 132, '2015-01-15 00:56:17.000000', 'consum', 0.0214, 'lps'),
	(648523, 132, '2015-01-15 00:56:18.000000', 'consum', 0.0214, 'lps'),
	(648524, 132, '2015-01-15 00:56:19.000000', 'consum', 0.0218, 'lps'),
	(648525, 132, '2015-01-15 00:56:20.000000', 'consum', 0.0218, 'lps'),
	(648526, 132, '2015-01-15 00:56:21.000000', 'consum', 0.0213, 'lps'),
	(648527, 132, '2015-01-15 00:56:22.000000', 'consum', 0.0212, 'lps'),
	(648528, 132, '2015-01-15 00:56:23.000000', 'consum', 0.0211, 'lps'),
	(648529, 132, '2015-01-15 00:56:24.000000', 'consum', 0.0213, 'lps'),
	(648530, 132, '2015-01-15 00:56:25.000000', 'consum', 0.0219, 'lps'),
	(648531, 132, '2015-01-15 00:56:26.000000', 'consum', 0.0214, 'lps'),
	(648532, 132, '2015-01-15 00:56:27.000000', 'consum', 0.0217, 'lps'),
	(648533, 132, '2015-01-15 00:56:28.000000', 'consum', 0.0211, 'lps'),
	(648534, 132, '2015-01-15 00:56:29.000000', 'consum', 0.0214, 'lps'),
	(648535, 132, '2015-01-15 00:56:30.000000', 'consum', 0.0218, 'lps'),
	(648536, 132, '2015-01-15 00:56:31.000000', 'consum', 0.0214, 'lps'),
	(648537, 132, '2015-01-15 00:56:32.000000', 'consum', 0.0210, 'lps'),
	(648538, 132, '2015-01-15 00:56:33.000000', 'consum', 0.0219, 'lps'),
	(648539, 132, '2015-01-15 00:56:34.000000', 'consum', 0.0212, 'lps'),
	(648540, 132, '2015-01-15 00:56:35.000000', 'consum', 0.0215, 'lps'),
	(648541, 132, '2015-01-15 00:56:36.000000', 'consum', 0.0217, 'lps'),
	(648542, 132, '2015-01-15 00:56:37.000000', 'consum', 0.0220, 'lps'),
	(648543, 132, '2015-01-15 00:56:38.000000', 'consum', 0.0216, 'lps'),
	(648544, 132, '2015-01-15 00:56:39.000000', 'consum', 0.0211, 'lps'),
	(648545, 132, '2015-01-15 00:56:40.000000', 'consum', 0.0210, 'lps'),
	(648546, 132, '2015-01-15 00:56:41.000000', 'consum', 0.0216, 'lps'),
	(648547, 132, '2015-01-15 00:56:42.000000', 'consum', 0.0211, 'lps'),
	(648548, 132, '2015-01-15 00:56:43.000000', 'consum', 0.0216, 'lps'),
	(648549, 132, '2015-01-15 00:56:44.000000', 'consum', 0.0218, 'lps'),
	(648550, 132, '2015-01-15 00:56:45.000000', 'consum', 0.0219, 'lps'),
	(648551, 132, '2015-01-15 00:56:46.000000', 'consum', 0.0212, 'lps'),
	(648552, 132, '2015-01-15 00:56:47.000000', 'consum', 0.0215, 'lps'),
	(648553, 132, '2015-01-15 00:56:48.000000', 'consum', 0.0219, 'lps'),
	(648554, 132, '2015-01-15 00:56:49.000000', 'consum', 0.0219, 'lps'),
	(648555, 132, '2015-01-15 00:56:50.000000', 'consum', 0.0218, 'lps'),
	(648556, 132, '2015-01-15 00:56:51.000000', 'consum', 0.0213, 'lps'),
	(648557, 132, '2015-01-15 00:56:52.000000', 'consum', 0.0212, 'lps'),
	(648558, 132, '2015-01-15 00:56:53.000000', 'consum', 0.0211, 'lps'),
	(648559, 132, '2015-01-15 00:56:54.000000', 'consum', 0.0211, 'lps'),
	(648560, 132, '2015-01-15 00:56:55.000000', 'consum', 0.0211, 'lps'),
	(648561, 132, '2015-01-15 00:56:56.000000', 'consum', 0.0214, 'lps'),
	(648562, 132, '2015-01-15 00:56:57.000000', 'consum', 0.0215, 'lps'),
	(648563, 132, '2015-01-15 00:56:58.000000', 'consum', 0.0214, 'lps'),
	(648564, 132, '2015-01-15 00:56:59.000000', 'consum', 0.0214, 'lps'),
	(648565, 132, '2015-01-15 00:57:00.000000', 'consum', 0.0220, 'lps'),
	(648566, 132, '2015-01-15 00:57:01.000000', 'consum', 0.0217, 'lps'),
	(648567, 132, '2015-01-15 00:57:02.000000', 'consum', 0.0213, 'lps'),
	(648568, 132, '2015-01-15 00:57:03.000000', 'consum', 0.0216, 'lps'),
	(648569, 132, '2015-01-15 00:57:04.000000', 'consum', 0.0211, 'lps'),
	(648570, 132, '2015-01-15 00:57:05.000000', 'consum', 0.0219, 'lps'),
	(648571, 132, '2015-01-15 00:57:06.000000', 'consum', 0.0219, 'lps'),
	(648572, 132, '2015-01-15 00:57:07.000000', 'consum', 0.0216, 'lps'),
	(648573, 132, '2015-01-15 00:57:08.000000', 'consum', 0.0215, 'lps'),
	(648574, 132, '2015-01-15 00:57:09.000000', 'consum', 0.0216, 'lps'),
	(648575, 132, '2015-01-15 00:57:10.000000', 'consum', 0.0215, 'lps'),
	(648576, 132, '2015-01-15 00:57:11.000000', 'consum', 0.0217, 'lps'),
	(648577, 132, '2015-01-15 00:57:12.000000', 'consum', 0.0219, 'lps'),
	(648578, 132, '2015-01-15 00:57:13.000000', 'consum', 0.0212, 'lps'),
	(648579, 132, '2015-01-15 00:57:14.000000', 'consum', 0.0218, 'lps'),
	(648580, 132, '2015-01-15 00:57:15.000000', 'consum', 0.0210, 'lps'),
	(648581, 132, '2015-01-15 00:57:16.000000', 'consum', 0.0220, 'lps'),
	(648582, 132, '2015-01-15 00:57:17.000000', 'consum', 0.0215, 'lps'),
	(648583, 132, '2015-01-15 00:57:18.000000', 'consum', 0.0216, 'lps'),
	(648584, 132, '2015-01-15 00:57:19.000000', 'consum', 0.0215, 'lps'),
	(648585, 132, '2015-01-15 00:57:20.000000', 'consum', 0.0216, 'lps'),
	(648586, 132, '2015-01-15 00:57:21.000000', 'consum', 0.0217, 'lps'),
	(648587, 132, '2015-01-15 00:57:22.000000', 'consum', 0.0217, 'lps'),
	(648588, 132, '2015-01-15 00:57:23.000000', 'consum', 0.0212, 'lps'),
	(648589, 132, '2015-01-15 00:57:24.000000', 'consum', 0.0212, 'lps'),
	(648590, 132, '2015-01-15 00:57:25.000000', 'consum', 0.0213, 'lps'),
	(648591, 132, '2015-01-15 00:57:26.000000', 'consum', 0.0210, 'lps'),
	(648592, 132, '2015-01-15 00:57:27.000000', 'consum', 0.0213, 'lps'),
	(648593, 132, '2015-01-15 00:57:28.000000', 'consum', 0.0212, 'lps'),
	(648594, 132, '2015-01-15 00:57:29.000000', 'consum', 0.0215, 'lps'),
	(648595, 132, '2015-01-15 00:57:30.000000', 'consum', 0.0216, 'lps'),
	(648596, 132, '2015-01-15 00:57:31.000000', 'consum', 0.0215, 'lps'),
	(648597, 132, '2015-01-15 00:57:32.000000', 'consum', 0.0218, 'lps'),
	(648598, 132, '2015-01-15 00:57:33.000000', 'consum', 0.0212, 'lps'),
	(648599, 132, '2015-01-15 00:57:34.000000', 'consum', 0.0220, 'lps'),
	(648600, 132, '2015-01-15 00:57:35.000000', 'consum', 0.0212, 'lps'),
	(648601, 132, '2015-01-15 00:57:36.000000', 'consum', 0.0211, 'lps'),
	(648602, 132, '2015-01-15 00:57:37.000000', 'consum', 0.0211, 'lps'),
	(648603, 132, '2015-01-15 00:57:38.000000', 'consum', 0.0210, 'lps'),
	(648604, 132, '2015-01-15 00:57:39.000000', 'consum', 0.0218, 'lps'),
	(648605, 132, '2015-01-15 00:57:40.000000', 'consum', 0.0219, 'lps'),
	(648606, 132, '2015-01-15 00:57:41.000000', 'consum', 0.0210, 'lps'),
	(648607, 132, '2015-01-15 00:57:42.000000', 'consum', 0.0215, 'lps'),
	(648608, 132, '2015-01-15 00:57:43.000000', 'consum', 0.0214, 'lps'),
	(648609, 132, '2015-01-15 00:57:44.000000', 'consum', 0.0218, 'lps'),
	(648610, 132, '2015-01-15 00:57:45.000000', 'consum', 0.0214, 'lps'),
	(648611, 132, '2015-01-15 00:57:46.000000', 'consum', 0.0216, 'lps'),
	(648612, 132, '2015-01-15 00:57:47.000000', 'consum', 0.0219, 'lps'),
	(648613, 132, '2015-01-15 00:57:48.000000', 'consum', 0.0216, 'lps'),
	(648614, 132, '2015-01-15 00:57:49.000000', 'consum', 0.0213, 'lps'),
	(648615, 132, '2015-01-15 00:57:50.000000', 'consum', 0.0218, 'lps'),
	(648616, 132, '2015-01-15 00:57:51.000000', 'consum', 0.0218, 'lps'),
	(648617, 132, '2015-01-15 00:57:52.000000', 'consum', 0.0218, 'lps'),
	(648618, 132, '2015-01-15 00:57:53.000000', 'consum', 0.0214, 'lps'),
	(648619, 132, '2015-01-15 00:57:54.000000', 'consum', 0.0217, 'lps'),
	(648620, 132, '2015-01-15 00:57:55.000000', 'consum', 0.0212, 'lps'),
	(648621, 132, '2015-01-15 00:57:56.000000', 'consum', 0.0210, 'lps'),
	(648622, 132, '2015-01-15 00:57:57.000000', 'consum', 0.0215, 'lps'),
	(648623, 132, '2015-01-15 00:57:58.000000', 'consum', 0.0214, 'lps'),
	(648624, 132, '2015-01-15 00:57:59.000000', 'consum', 0.0214, 'lps'),
	(648625, 132, '2015-01-15 00:58:00.000000', 'consum', 0.0220, 'lps'),
	(648626, 132, '2015-01-15 00:58:01.000000', 'consum', 0.0216, 'lps'),
	(648627, 132, '2015-01-15 00:58:02.000000', 'consum', 0.0220, 'lps'),
	(648628, 132, '2015-01-15 00:58:03.000000', 'consum', 0.0210, 'lps'),
	(648629, 132, '2015-01-15 00:58:04.000000', 'consum', 0.0216, 'lps'),
	(648630, 132, '2015-01-15 00:58:05.000000', 'consum', 0.0215, 'lps'),
	(648631, 132, '2015-01-15 00:58:06.000000', 'consum', 0.0220, 'lps'),
	(648632, 132, '2015-01-15 00:58:07.000000', 'consum', 0.0214, 'lps'),
	(648633, 132, '2015-01-15 00:58:08.000000', 'consum', 0.0219, 'lps'),
	(648634, 132, '2015-01-15 00:58:09.000000', 'consum', 0.0213, 'lps'),
	(648635, 132, '2015-01-15 00:58:10.000000', 'consum', 0.0218, 'lps'),
	(648636, 132, '2015-01-15 00:58:11.000000', 'consum', 0.0210, 'lps'),
	(648637, 132, '2015-01-15 00:58:12.000000', 'consum', 0.0218, 'lps'),
	(648638, 132, '2015-01-15 00:58:13.000000', 'consum', 0.0217, 'lps'),
	(648639, 132, '2015-01-15 00:58:14.000000', 'consum', 0.0211, 'lps'),
	(648640, 132, '2015-01-15 00:58:15.000000', 'consum', 0.0218, 'lps'),
	(648641, 132, '2015-01-15 00:58:16.000000', 'consum', 0.0214, 'lps'),
	(648642, 132, '2015-01-15 00:58:17.000000', 'consum', 0.0218, 'lps'),
	(648643, 132, '2015-01-15 00:58:18.000000', 'consum', 0.0217, 'lps'),
	(648644, 132, '2015-01-15 00:58:19.000000', 'consum', 0.0211, 'lps'),
	(648645, 132, '2015-01-15 00:58:20.000000', 'consum', 0.0216, 'lps'),
	(648646, 132, '2015-01-15 00:58:21.000000', 'consum', 0.0213, 'lps'),
	(648647, 132, '2015-01-15 00:58:22.000000', 'consum', 0.0211, 'lps'),
	(648648, 132, '2015-01-15 00:58:23.000000', 'consum', 0.0214, 'lps'),
	(648649, 132, '2015-01-15 00:58:24.000000', 'consum', 0.0218, 'lps'),
	(648650, 132, '2015-01-15 00:58:25.000000', 'consum', 0.0218, 'lps'),
	(648651, 132, '2015-01-15 00:58:26.000000', 'consum', 0.0214, 'lps'),
	(648652, 132, '2015-01-15 00:58:27.000000', 'consum', 0.0217, 'lps'),
	(648653, 132, '2015-01-15 00:58:28.000000', 'consum', 0.0211, 'lps'),
	(648654, 132, '2015-01-15 00:58:29.000000', 'consum', 0.0215, 'lps'),
	(648655, 132, '2015-01-15 00:58:30.000000', 'consum', 0.0214, 'lps'),
	(648656, 132, '2015-01-15 00:58:31.000000', 'consum', 0.0214, 'lps'),
	(648657, 132, '2015-01-15 00:58:32.000000', 'consum', 0.0219, 'lps'),
	(648658, 132, '2015-01-15 00:58:33.000000', 'consum', 0.0220, 'lps'),
	(648659, 132, '2015-01-15 00:58:34.000000', 'consum', 0.0214, 'lps'),
	(648660, 132, '2015-01-15 00:58:35.000000', 'consum', 0.0211, 'lps'),
	(648661, 132, '2015-01-15 00:58:36.000000', 'consum', 0.0212, 'lps'),
	(648662, 132, '2015-01-15 00:58:37.000000', 'consum', 0.0219, 'lps'),
	(648663, 132, '2015-01-15 00:58:38.000000', 'consum', 0.0218, 'lps'),
	(648664, 132, '2015-01-15 00:58:39.000000', 'consum', 0.0211, 'lps'),
	(648665, 132, '2015-01-15 00:58:40.000000', 'consum', 0.0213, 'lps'),
	(648666, 132, '2015-01-15 00:58:41.000000', 'consum', 0.0210, 'lps'),
	(648667, 132, '2015-01-15 00:58:42.000000', 'consum', 0.0216, 'lps'),
	(648668, 132, '2015-01-15 00:58:43.000000', 'consum', 0.0217, 'lps'),
	(648669, 132, '2015-01-15 00:58:44.000000', 'consum', 0.0218, 'lps'),
	(648670, 132, '2015-01-15 00:58:45.000000', 'consum', 0.0217, 'lps'),
	(648671, 132, '2015-01-15 00:58:46.000000', 'consum', 0.0220, 'lps'),
	(648672, 132, '2015-01-15 00:58:47.000000', 'consum', 0.0220, 'lps'),
	(648673, 132, '2015-01-15 00:58:48.000000', 'consum', 0.0217, 'lps'),
	(648674, 132, '2015-01-15 00:58:49.000000', 'consum', 0.0217, 'lps'),
	(648675, 132, '2015-01-15 00:58:50.000000', 'consum', 0.0214, 'lps'),
	(648676, 132, '2015-01-15 00:58:51.000000', 'consum', 0.0220, 'lps'),
	(648677, 132, '2015-01-15 00:58:52.000000', 'consum', 0.0214, 'lps'),
	(648678, 132, '2015-01-15 00:58:53.000000', 'consum', 0.0212, 'lps'),
	(648679, 132, '2015-01-15 00:58:54.000000', 'consum', 0.0211, 'lps'),
	(648680, 132, '2015-01-15 00:58:55.000000', 'consum', 0.0217, 'lps'),
	(648681, 132, '2015-01-15 00:58:56.000000', 'consum', 0.0212, 'lps'),
	(648682, 132, '2015-01-15 00:58:57.000000', 'consum', 0.0220, 'lps'),
	(648683, 132, '2015-01-15 00:58:58.000000', 'consum', 0.0211, 'lps'),
	(648684, 132, '2015-01-15 00:58:59.000000', 'consum', 0.0217, 'lps'),
	(648685, 132, '2015-01-15 00:59:00.000000', 'consum', 0.0211, 'lps'),
	(648686, 132, '2015-01-15 00:59:01.000000', 'consum', 0.0215, 'lps'),
	(648687, 132, '2015-01-15 00:59:02.000000', 'consum', 0.0212, 'lps'),
	(648688, 132, '2015-01-15 00:59:03.000000', 'consum', 0.0217, 'lps'),
	(648689, 132, '2015-01-15 00:59:04.000000', 'consum', 0.0219, 'lps'),
	(648690, 132, '2015-01-15 00:59:05.000000', 'consum', 0.0210, 'lps'),
	(648691, 132, '2015-01-15 00:59:06.000000', 'consum', 0.0215, 'lps'),
	(648692, 132, '2015-01-15 00:59:07.000000', 'consum', 0.0216, 'lps'),
	(648693, 132, '2015-01-15 00:59:08.000000', 'consum', 0.0212, 'lps'),
	(648694, 132, '2015-01-15 00:59:09.000000', 'consum', 0.0215, 'lps'),
	(648695, 132, '2015-01-15 00:59:10.000000', 'consum', 0.0216, 'lps'),
	(648696, 132, '2015-01-15 00:59:11.000000', 'consum', 0.0217, 'lps'),
	(648697, 132, '2015-01-15 00:59:12.000000', 'consum', 0.0217, 'lps'),
	(648698, 132, '2015-01-15 00:59:13.000000', 'consum', 0.0214, 'lps'),
	(648699, 132, '2015-01-15 00:59:14.000000', 'consum', 0.0220, 'lps'),
	(648700, 132, '2015-01-15 00:59:15.000000', 'consum', 0.0213, 'lps'),
	(648701, 132, '2015-01-15 00:59:16.000000', 'consum', 0.0210, 'lps'),
	(648702, 132, '2015-01-15 00:59:17.000000', 'consum', 0.0210, 'lps'),
	(648703, 132, '2015-01-15 00:59:18.000000', 'consum', 0.0210, 'lps'),
	(648704, 132, '2015-01-15 00:59:19.000000', 'consum', 0.0212, 'lps'),
	(648705, 132, '2015-01-15 00:59:20.000000', 'consum', 0.0211, 'lps'),
	(648706, 132, '2015-01-15 00:59:21.000000', 'consum', 0.0218, 'lps'),
	(648707, 132, '2015-01-15 00:59:22.000000', 'consum', 0.0214, 'lps'),
	(648708, 132, '2015-01-15 00:59:23.000000', 'consum', 0.0217, 'lps'),
	(648709, 132, '2015-01-15 00:59:24.000000', 'consum', 0.0213, 'lps'),
	(648710, 132, '2015-01-15 00:59:25.000000', 'consum', 0.0215, 'lps'),
	(648711, 132, '2015-01-15 00:59:26.000000', 'consum', 0.0216, 'lps'),
	(648712, 132, '2015-01-15 00:59:27.000000', 'consum', 0.0216, 'lps'),
	(648713, 132, '2015-01-15 00:59:28.000000', 'consum', 0.0211, 'lps'),
	(648714, 132, '2015-01-15 00:59:29.000000', 'consum', 0.0220, 'lps'),
	(648715, 132, '2015-01-15 00:59:30.000000', 'consum', 0.0215, 'lps'),
	(648716, 132, '2015-01-15 00:59:31.000000', 'consum', 0.0215, 'lps'),
	(648717, 132, '2015-01-15 00:59:32.000000', 'consum', 0.0219, 'lps'),
	(648718, 132, '2015-01-15 00:59:33.000000', 'consum', 0.0219, 'lps'),
	(648719, 132, '2015-01-15 00:59:34.000000', 'consum', 0.0218, 'lps'),
	(648720, 132, '2015-01-15 00:59:35.000000', 'consum', 0.0212, 'lps'),
	(648721, 132, '2015-01-15 00:59:36.000000', 'consum', 0.0220, 'lps'),
	(648722, 132, '2015-01-15 00:59:37.000000', 'consum', 0.0210, 'lps'),
	(648723, 132, '2015-01-15 00:59:38.000000', 'consum', 0.0215, 'lps'),
	(648724, 132, '2015-01-15 00:59:39.000000', 'consum', 0.0211, 'lps'),
	(648725, 132, '2015-01-15 00:59:40.000000', 'consum', 0.0212, 'lps'),
	(648726, 132, '2015-01-15 00:59:41.000000', 'consum', 0.0218, 'lps'),
	(648727, 132, '2015-01-15 00:59:42.000000', 'consum', 0.0212, 'lps'),
	(648728, 132, '2015-01-15 00:59:43.000000', 'consum', 0.0216, 'lps'),
	(648729, 132, '2015-01-15 00:59:44.000000', 'consum', 0.0216, 'lps'),
	(648730, 132, '2015-01-15 00:59:45.000000', 'consum', 0.0210, 'lps'),
	(648731, 132, '2015-01-15 00:59:46.000000', 'consum', 0.0213, 'lps'),
	(648732, 132, '2015-01-15 00:59:47.000000', 'consum', 0.0213, 'lps'),
	(648733, 132, '2015-01-15 00:59:48.000000', 'consum', 0.0220, 'lps'),
	(648734, 132, '2015-01-15 00:59:49.000000', 'consum', 0.0218, 'lps'),
	(648735, 132, '2015-01-15 00:59:50.000000', 'consum', 0.0220, 'lps'),
	(648736, 132, '2015-01-15 00:59:51.000000', 'consum', 0.0216, 'lps'),
	(648737, 132, '2015-01-15 00:59:52.000000', 'consum', 0.0220, 'lps'),
	(648738, 132, '2015-01-15 00:59:53.000000', 'consum', 0.0220, 'lps'),
	(648739, 132, '2015-01-15 00:59:54.000000', 'consum', 0.0210, 'lps'),
	(648740, 132, '2015-01-15 00:59:55.000000', 'consum', 0.0213, 'lps'),
	(648741, 132, '2015-01-15 00:59:56.000000', 'consum', 0.0216, 'lps'),
	(648742, 132, '2015-01-15 00:59:57.000000', 'consum', 0.0210, 'lps'),
	(648743, 132, '2015-01-15 00:59:58.000000', 'consum', 0.0213, 'lps'),
	(648744, 132, '2015-01-15 00:59:59.000000', 'consum', 0.0216, 'lps'),
	(648745, 132, '2015-01-15 01:00:00.000000', 'consum', 0.0210, 'lps'),
	(648746, 132, '2015-01-15 01:00:01.000000', 'consum', 0.0215, 'lps'),
	(648747, 132, '2015-01-15 01:00:02.000000', 'consum', 0.0214, 'lps'),
	(648748, 132, '2015-01-15 01:00:03.000000', 'consum', 0.0213, 'lps'),
	(648749, 132, '2015-01-15 01:00:04.000000', 'consum', 0.0213, 'lps'),
	(648750, 132, '2015-01-15 01:00:05.000000', 'consum', 0.0219, 'lps'),
	(648751, 132, '2015-01-15 01:00:06.000000', 'consum', 0.0214, 'lps'),
	(648752, 132, '2015-01-15 01:00:07.000000', 'consum', 0.0212, 'lps'),
	(648753, 132, '2015-01-15 01:00:08.000000', 'consum', 0.0220, 'lps'),
	(648754, 132, '2015-01-15 01:00:09.000000', 'consum', 0.0220, 'lps'),
	(648755, 132, '2015-01-15 01:00:10.000000', 'consum', 0.0212, 'lps'),
	(648756, 132, '2015-01-15 01:00:11.000000', 'consum', 0.0220, 'lps'),
	(648757, 132, '2015-01-15 01:00:12.000000', 'consum', 0.0211, 'lps'),
	(648758, 132, '2015-01-15 01:00:13.000000', 'consum', 0.0220, 'lps'),
	(648759, 132, '2015-01-15 01:00:14.000000', 'consum', 0.0212, 'lps'),
	(648760, 132, '2015-01-15 01:00:15.000000', 'consum', 0.0212, 'lps'),
	(648761, 132, '2015-01-15 01:00:16.000000', 'consum', 0.0217, 'lps'),
	(648762, 132, '2015-01-15 01:00:17.000000', 'consum', 0.0217, 'lps'),
	(648763, 132, '2015-01-15 01:00:18.000000', 'consum', 0.0214, 'lps'),
	(648764, 132, '2015-01-15 01:00:19.000000', 'consum', 0.0220, 'lps'),
	(648765, 132, '2015-01-15 01:00:20.000000', 'consum', 0.0217, 'lps'),
	(648766, 132, '2015-01-15 01:00:21.000000', 'consum', 0.0215, 'lps'),
	(648767, 132, '2015-01-15 01:00:22.000000', 'consum', 0.0213, 'lps'),
	(648768, 132, '2015-01-15 01:00:23.000000', 'consum', 0.0211, 'lps'),
	(648769, 132, '2015-01-15 01:00:24.000000', 'consum', 0.0217, 'lps'),
	(648770, 132, '2015-01-15 01:00:25.000000', 'consum', 0.0220, 'lps'),
	(648771, 132, '2015-01-15 01:00:26.000000', 'consum', 0.0220, 'lps'),
	(648772, 132, '2015-01-15 01:00:27.000000', 'consum', 0.0219, 'lps'),
	(648773, 132, '2015-01-15 01:00:28.000000', 'consum', 0.0216, 'lps'),
	(648774, 132, '2015-01-15 01:00:29.000000', 'consum', 0.0212, 'lps'),
	(648775, 132, '2015-01-15 01:00:30.000000', 'consum', 0.0214, 'lps'),
	(648776, 132, '2015-01-15 01:00:31.000000', 'consum', 0.0215, 'lps'),
	(648777, 132, '2015-01-15 01:00:32.000000', 'consum', 0.0220, 'lps'),
	(648778, 132, '2015-01-15 01:00:33.000000', 'consum', 0.0216, 'lps'),
	(648779, 132, '2015-01-15 01:00:34.000000', 'consum', 0.0219, 'lps'),
	(648780, 132, '2015-01-15 01:00:35.000000', 'consum', 0.0218, 'lps'),
	(648781, 132, '2015-01-15 01:00:36.000000', 'consum', 0.0210, 'lps'),
	(648782, 132, '2015-01-15 01:00:37.000000', 'consum', 0.0218, 'lps'),
	(648783, 132, '2015-01-15 01:00:38.000000', 'consum', 0.0220, 'lps'),
	(648784, 132, '2015-01-15 01:00:39.000000', 'consum', 0.0216, 'lps'),
	(648785, 132, '2015-01-15 01:00:40.000000', 'consum', 0.0218, 'lps'),
	(648786, 132, '2015-01-15 01:00:41.000000', 'consum', 0.0213, 'lps'),
	(648787, 132, '2015-01-15 01:00:42.000000', 'consum', 0.0211, 'lps'),
	(648788, 132, '2015-01-15 01:00:43.000000', 'consum', 0.0219, 'lps'),
	(648789, 132, '2015-01-15 01:00:44.000000', 'consum', 0.0219, 'lps'),
	(648790, 132, '2015-01-15 01:00:45.000000', 'consum', 0.0216, 'lps'),
	(648791, 132, '2015-01-15 01:00:46.000000', 'consum', 0.0214, 'lps'),
	(648792, 132, '2015-01-15 01:00:47.000000', 'consum', 0.0212, 'lps'),
	(648793, 132, '2015-01-15 01:00:48.000000', 'consum', 0.0220, 'lps'),
	(648794, 132, '2015-01-15 01:00:49.000000', 'consum', 0.0220, 'lps'),
	(648795, 132, '2015-01-15 01:00:50.000000', 'consum', 0.0220, 'lps'),
	(648796, 132, '2015-01-15 01:00:51.000000', 'consum', 0.0211, 'lps'),
	(648797, 132, '2015-01-15 01:00:52.000000', 'consum', 0.0217, 'lps'),
	(648798, 132, '2015-01-15 01:00:53.000000', 'consum', 0.0220, 'lps'),
	(648799, 132, '2015-01-15 01:00:54.000000', 'consum', 0.0219, 'lps'),
	(648800, 132, '2015-01-15 01:00:55.000000', 'consum', 0.0212, 'lps'),
	(648801, 132, '2015-01-15 01:00:56.000000', 'consum', 0.0217, 'lps'),
	(648802, 132, '2015-01-15 01:00:57.000000', 'consum', 0.0218, 'lps'),
	(648803, 132, '2015-01-15 01:00:58.000000', 'consum', 0.0216, 'lps'),
	(648804, 132, '2015-01-15 01:00:59.000000', 'consum', 0.0218, 'lps'),
	(648805, 132, '2015-01-15 01:01:00.000000', 'consum', 0.0212, 'lps'),
	(648806, 132, '2015-01-15 01:01:01.000000', 'consum', 0.0219, 'lps'),
	(648807, 132, '2015-01-15 01:01:02.000000', 'consum', 0.0216, 'lps'),
	(648808, 132, '2015-01-15 01:01:03.000000', 'consum', 0.0213, 'lps'),
	(648809, 132, '2015-01-15 01:01:04.000000', 'consum', 0.0217, 'lps'),
	(648810, 132, '2015-01-15 01:01:05.000000', 'consum', 0.0214, 'lps'),
	(648811, 132, '2015-01-15 01:01:06.000000', 'consum', 0.0212, 'lps'),
	(648812, 132, '2015-01-15 01:01:07.000000', 'consum', 0.0218, 'lps'),
	(648813, 132, '2015-01-15 01:01:08.000000', 'consum', 0.0212, 'lps'),
	(648814, 132, '2015-01-15 01:01:09.000000', 'consum', 0.0218, 'lps'),
	(648815, 132, '2015-01-15 01:01:10.000000', 'consum', 0.0214, 'lps'),
	(648816, 132, '2015-01-15 01:01:11.000000', 'consum', 0.0215, 'lps'),
	(648817, 132, '2015-01-15 01:01:12.000000', 'consum', 0.0212, 'lps'),
	(648818, 132, '2015-01-15 01:01:13.000000', 'consum', 0.0216, 'lps'),
	(648819, 132, '2015-01-15 01:01:14.000000', 'consum', 0.0214, 'lps'),
	(648820, 132, '2015-01-15 01:01:15.000000', 'consum', 0.0214, 'lps'),
	(648821, 132, '2015-01-15 01:01:16.000000', 'consum', 0.0215, 'lps'),
	(648822, 132, '2015-01-15 01:01:17.000000', 'consum', 0.0215, 'lps'),
	(648823, 132, '2015-01-15 01:01:18.000000', 'consum', 0.0218, 'lps'),
	(648824, 132, '2015-01-15 01:01:19.000000', 'consum', 0.0216, 'lps'),
	(648825, 132, '2015-01-15 01:01:20.000000', 'consum', 0.0215, 'lps'),
	(648826, 132, '2015-01-15 01:01:21.000000', 'consum', 0.0216, 'lps'),
	(648827, 132, '2015-01-15 01:01:22.000000', 'consum', 0.0217, 'lps'),
	(648828, 132, '2015-01-15 01:01:23.000000', 'consum', 0.0215, 'lps'),
	(648829, 132, '2015-01-15 01:01:24.000000', 'consum', 0.0216, 'lps'),
	(648830, 132, '2015-01-15 01:01:25.000000', 'consum', 0.0214, 'lps'),
	(648831, 132, '2015-01-15 01:01:26.000000', 'consum', 0.0211, 'lps'),
	(648832, 132, '2015-01-15 01:01:27.000000', 'consum', 0.0217, 'lps'),
	(648833, 132, '2015-01-15 01:01:28.000000', 'consum', 0.0210, 'lps'),
	(648834, 132, '2015-01-15 01:01:29.000000', 'consum', 0.0219, 'lps'),
	(648835, 132, '2015-01-15 01:01:30.000000', 'consum', 0.0215, 'lps'),
	(648836, 132, '2015-01-15 01:01:31.000000', 'consum', 0.0219, 'lps'),
	(648837, 132, '2015-01-15 01:01:32.000000', 'consum', 0.0217, 'lps'),
	(648838, 132, '2015-01-15 01:01:33.000000', 'consum', 0.0218, 'lps'),
	(648839, 132, '2015-01-15 01:01:34.000000', 'consum', 0.0219, 'lps'),
	(648840, 132, '2015-01-15 01:01:35.000000', 'consum', 0.0210, 'lps'),
	(648841, 132, '2015-01-15 01:01:36.000000', 'consum', 0.0214, 'lps'),
	(648842, 132, '2015-01-15 01:01:37.000000', 'consum', 0.0212, 'lps'),
	(648843, 132, '2015-01-15 01:01:38.000000', 'consum', 0.0219, 'lps'),
	(648844, 132, '2015-01-15 01:01:39.000000', 'consum', 0.0217, 'lps'),
	(648845, 132, '2015-01-15 01:01:40.000000', 'consum', 0.0216, 'lps'),
	(648846, 132, '2015-01-15 01:01:41.000000', 'consum', 0.0210, 'lps'),
	(648847, 132, '2015-01-15 01:01:42.000000', 'consum', 0.0213, 'lps'),
	(648848, 132, '2015-01-15 01:01:43.000000', 'consum', 0.0215, 'lps'),
	(648849, 132, '2015-01-15 01:01:44.000000', 'consum', 0.0215, 'lps'),
	(648850, 132, '2015-01-15 01:01:45.000000', 'consum', 0.0211, 'lps'),
	(648851, 132, '2015-01-15 01:01:46.000000', 'consum', 0.0212, 'lps'),
	(648852, 132, '2015-01-15 01:01:47.000000', 'consum', 0.0217, 'lps'),
	(648853, 132, '2015-01-15 01:01:48.000000', 'consum', 0.0219, 'lps'),
	(648854, 132, '2015-01-15 01:01:49.000000', 'consum', 0.0211, 'lps'),
	(648855, 132, '2015-01-15 01:01:50.000000', 'consum', 0.0212, 'lps'),
	(648856, 132, '2015-01-15 01:01:51.000000', 'consum', 0.0215, 'lps'),
	(648857, 132, '2015-01-15 01:01:52.000000', 'consum', 0.0218, 'lps'),
	(648858, 132, '2015-01-15 01:01:53.000000', 'consum', 0.0215, 'lps'),
	(648859, 132, '2015-01-15 01:01:54.000000', 'consum', 0.0211, 'lps'),
	(648860, 132, '2015-01-15 01:01:55.000000', 'consum', 0.0212, 'lps'),
	(648861, 132, '2015-01-15 01:01:56.000000', 'consum', 0.0216, 'lps'),
	(648862, 132, '2015-01-15 01:01:57.000000', 'consum', 0.0212, 'lps'),
	(648863, 132, '2015-01-15 01:01:58.000000', 'consum', 0.0216, 'lps'),
	(648864, 132, '2015-01-15 01:01:59.000000', 'consum', 0.0211, 'lps'),
	(648865, 132, '2015-01-15 01:02:00.000000', 'consum', 0.0210, 'lps'),
	(648866, 132, '2015-01-15 01:02:01.000000', 'consum', 0.0219, 'lps'),
	(648867, 132, '2015-01-15 01:02:02.000000', 'consum', 0.0210, 'lps'),
	(648868, 132, '2015-01-15 01:02:03.000000', 'consum', 0.0218, 'lps'),
	(648869, 132, '2015-01-15 01:02:04.000000', 'consum', 0.0217, 'lps'),
	(648870, 132, '2015-01-15 01:02:05.000000', 'consum', 0.0220, 'lps'),
	(648871, 132, '2015-01-15 01:02:06.000000', 'consum', 0.0217, 'lps'),
	(648872, 132, '2015-01-15 01:02:07.000000', 'consum', 0.0215, 'lps'),
	(648873, 132, '2015-01-15 01:02:08.000000', 'consum', 0.0216, 'lps'),
	(648874, 132, '2015-01-15 01:02:09.000000', 'consum', 0.0214, 'lps'),
	(648875, 132, '2015-01-15 01:02:10.000000', 'consum', 0.0211, 'lps'),
	(648876, 132, '2015-01-15 01:02:11.000000', 'consum', 0.0217, 'lps'),
	(648877, 132, '2015-01-15 01:02:12.000000', 'consum', 0.0219, 'lps'),
	(648878, 132, '2015-01-15 01:02:13.000000', 'consum', 0.0213, 'lps'),
	(648879, 132, '2015-01-15 01:02:14.000000', 'consum', 0.0212, 'lps'),
	(648880, 132, '2015-01-15 01:02:15.000000', 'consum', 0.0219, 'lps'),
	(648881, 132, '2015-01-15 01:02:16.000000', 'consum', 0.0217, 'lps'),
	(648882, 132, '2015-01-15 01:02:17.000000', 'consum', 0.0218, 'lps'),
	(648883, 132, '2015-01-15 01:02:18.000000', 'consum', 0.0218, 'lps'),
	(648884, 132, '2015-01-15 01:02:19.000000', 'consum', 0.0214, 'lps'),
	(648885, 132, '2015-01-15 01:02:20.000000', 'consum', 0.0220, 'lps'),
	(648886, 132, '2015-01-15 01:02:21.000000', 'consum', 0.0215, 'lps'),
	(648887, 132, '2015-01-15 01:02:22.000000', 'consum', 0.0218, 'lps'),
	(648888, 132, '2015-01-15 01:02:23.000000', 'consum', 0.0213, 'lps'),
	(648889, 132, '2015-01-15 01:02:24.000000', 'consum', 0.0211, 'lps'),
	(648890, 132, '2015-01-15 01:02:25.000000', 'consum', 0.0218, 'lps'),
	(648891, 132, '2015-01-15 01:02:26.000000', 'consum', 0.0214, 'lps'),
	(648892, 132, '2015-01-15 01:02:27.000000', 'consum', 0.0219, 'lps'),
	(648893, 132, '2015-01-15 01:02:28.000000', 'consum', 0.0211, 'lps'),
	(648894, 132, '2015-01-15 01:02:29.000000', 'consum', 0.0219, 'lps'),
	(648895, 132, '2015-01-15 01:02:30.000000', 'consum', 0.0210, 'lps'),
	(648896, 132, '2015-01-15 01:02:31.000000', 'consum', 0.0218, 'lps'),
	(648897, 132, '2015-01-15 01:02:32.000000', 'consum', 0.0214, 'lps'),
	(648898, 132, '2015-01-15 01:02:33.000000', 'consum', 0.0210, 'lps'),
	(648899, 132, '2015-01-15 01:02:34.000000', 'consum', 0.0218, 'lps'),
	(648900, 132, '2015-01-15 01:02:35.000000', 'consum', 0.0219, 'lps'),
	(648901, 132, '2015-01-15 01:02:36.000000', 'consum', 0.0219, 'lps'),
	(648902, 132, '2015-01-15 01:02:37.000000', 'consum', 0.0219, 'lps'),
	(648903, 132, '2015-01-15 01:02:38.000000', 'consum', 0.0216, 'lps'),
	(648904, 132, '2015-01-15 01:02:39.000000', 'consum', 0.0215, 'lps'),
	(648905, 132, '2015-01-15 01:02:40.000000', 'consum', 0.0217, 'lps'),
	(648906, 132, '2015-01-15 01:02:41.000000', 'consum', 0.0210, 'lps'),
	(648907, 132, '2015-01-15 01:02:42.000000', 'consum', 0.0220, 'lps'),
	(648908, 132, '2015-01-15 01:02:43.000000', 'consum', 0.0216, 'lps'),
	(648909, 132, '2015-01-15 01:02:44.000000', 'consum', 0.0211, 'lps'),
	(648910, 132, '2015-01-15 01:02:45.000000', 'consum', 0.0220, 'lps'),
	(648911, 132, '2015-01-15 01:02:46.000000', 'consum', 0.0212, 'lps'),
	(648912, 132, '2015-01-15 01:02:47.000000', 'consum', 0.0212, 'lps'),
	(648913, 132, '2015-01-15 01:02:48.000000', 'consum', 0.0217, 'lps'),
	(648914, 132, '2015-01-15 01:02:49.000000', 'consum', 0.0216, 'lps'),
	(648915, 132, '2015-01-15 01:02:50.000000', 'consum', 0.0218, 'lps'),
	(648916, 132, '2015-01-15 01:02:51.000000', 'consum', 0.0213, 'lps'),
	(648917, 132, '2015-01-15 01:02:52.000000', 'consum', 0.0212, 'lps'),
	(648918, 132, '2015-01-15 01:02:53.000000', 'consum', 0.0210, 'lps'),
	(648919, 132, '2015-01-15 01:02:54.000000', 'consum', 0.0217, 'lps'),
	(648920, 132, '2015-01-15 01:02:55.000000', 'consum', 0.0213, 'lps'),
	(648921, 132, '2015-01-15 01:02:56.000000', 'consum', 0.0215, 'lps'),
	(648922, 132, '2015-01-15 01:02:57.000000', 'consum', 0.0215, 'lps'),
	(648923, 132, '2015-01-15 01:02:58.000000', 'consum', 0.0210, 'lps'),
	(648924, 132, '2015-01-15 01:02:59.000000', 'consum', 0.0218, 'lps'),
	(648925, 132, '2015-01-15 01:03:00.000000', 'consum', 0.0218, 'lps'),
	(648926, 132, '2015-01-15 01:03:01.000000', 'consum', 0.0215, 'lps'),
	(648927, 132, '2015-01-15 01:03:02.000000', 'consum', 0.0210, 'lps'),
	(648928, 132, '2015-01-15 01:03:03.000000', 'consum', 0.0220, 'lps'),
	(648929, 132, '2015-01-15 01:03:04.000000', 'consum', 0.0217, 'lps'),
	(648930, 132, '2015-01-15 01:03:05.000000', 'consum', 0.0216, 'lps'),
	(648931, 132, '2015-01-15 01:03:06.000000', 'consum', 0.0217, 'lps'),
	(648932, 132, '2015-01-15 01:03:07.000000', 'consum', 0.0216, 'lps'),
	(648933, 132, '2015-01-15 01:03:08.000000', 'consum', 0.0211, 'lps'),
	(648934, 132, '2015-01-15 01:03:09.000000', 'consum', 0.0219, 'lps'),
	(648935, 132, '2015-01-15 01:03:10.000000', 'consum', 0.0218, 'lps'),
	(648936, 132, '2015-01-15 01:03:11.000000', 'consum', 0.0214, 'lps'),
	(648937, 132, '2015-01-15 01:03:12.000000', 'consum', 0.0218, 'lps'),
	(648938, 132, '2015-01-15 01:03:13.000000', 'consum', 0.0215, 'lps'),
	(648939, 132, '2015-01-15 01:03:14.000000', 'consum', 0.0214, 'lps'),
	(648940, 132, '2015-01-15 01:03:15.000000', 'consum', 0.0214, 'lps'),
	(648941, 132, '2015-01-15 01:03:16.000000', 'consum', 0.0220, 'lps'),
	(648942, 132, '2015-01-15 01:03:17.000000', 'consum', 0.0214, 'lps'),
	(648943, 132, '2015-01-15 01:03:18.000000', 'consum', 0.0213, 'lps'),
	(648944, 132, '2015-01-15 01:03:19.000000', 'consum', 0.0212, 'lps'),
	(648945, 132, '2015-01-15 01:03:20.000000', 'consum', 0.0210, 'lps'),
	(648946, 132, '2015-01-15 01:03:21.000000', 'consum', 0.0218, 'lps'),
	(648947, 132, '2015-01-15 01:03:22.000000', 'consum', 0.0215, 'lps'),
	(648948, 132, '2015-01-15 01:03:23.000000', 'consum', 0.0211, 'lps'),
	(648949, 132, '2015-01-15 01:03:24.000000', 'consum', 0.0214, 'lps'),
	(648950, 132, '2015-01-15 01:03:25.000000', 'consum', 0.0216, 'lps'),
	(648951, 132, '2015-01-15 01:03:26.000000', 'consum', 0.0218, 'lps'),
	(648952, 132, '2015-01-15 01:03:27.000000', 'consum', 0.0219, 'lps'),
	(648953, 132, '2015-01-15 01:03:28.000000', 'consum', 0.0212, 'lps'),
	(648954, 132, '2015-01-15 01:03:29.000000', 'consum', 0.0216, 'lps'),
	(648955, 132, '2015-01-15 01:03:30.000000', 'consum', 0.0210, 'lps'),
	(648956, 132, '2015-01-15 01:03:31.000000', 'consum', 0.0217, 'lps'),
	(648957, 132, '2015-01-15 01:03:32.000000', 'consum', 0.0211, 'lps'),
	(648958, 132, '2015-01-15 01:03:33.000000', 'consum', 0.0218, 'lps'),
	(648959, 132, '2015-01-15 01:03:34.000000', 'consum', 0.0215, 'lps'),
	(648960, 132, '2015-01-15 01:03:35.000000', 'consum', 0.0210, 'lps'),
	(648961, 132, '2015-01-15 01:03:36.000000', 'consum', 0.0219, 'lps'),
	(648962, 132, '2015-01-15 01:03:37.000000', 'consum', 0.0212, 'lps'),
	(648963, 132, '2015-01-15 01:03:38.000000', 'consum', 0.0215, 'lps'),
	(648964, 132, '2015-01-15 01:03:39.000000', 'consum', 0.0217, 'lps'),
	(648965, 132, '2015-01-15 01:03:40.000000', 'consum', 0.0211, 'lps'),
	(648966, 132, '2015-01-15 01:03:41.000000', 'consum', 0.0217, 'lps'),
	(648967, 132, '2015-01-15 01:03:42.000000', 'consum', 0.0218, 'lps'),
	(648968, 132, '2015-01-15 01:03:43.000000', 'consum', 0.0210, 'lps'),
	(648969, 132, '2015-01-15 01:03:44.000000', 'consum', 0.0217, 'lps'),
	(648970, 132, '2015-01-15 01:03:45.000000', 'consum', 0.0213, 'lps'),
	(648971, 132, '2015-01-15 01:03:46.000000', 'consum', 0.0218, 'lps'),
	(648972, 132, '2015-01-15 01:03:47.000000', 'consum', 0.0217, 'lps'),
	(648973, 132, '2015-01-15 01:03:48.000000', 'consum', 0.0213, 'lps'),
	(648974, 132, '2015-01-15 01:03:49.000000', 'consum', 0.0212, 'lps'),
	(648975, 132, '2015-01-15 01:03:50.000000', 'consum', 0.0215, 'lps'),
	(648976, 132, '2015-01-15 01:03:51.000000', 'consum', 0.0217, 'lps'),
	(648977, 132, '2015-01-15 01:03:52.000000', 'consum', 0.0218, 'lps'),
	(648978, 132, '2015-01-15 01:03:53.000000', 'consum', 0.0211, 'lps'),
	(648979, 132, '2015-01-15 01:03:54.000000', 'consum', 0.0211, 'lps'),
	(648980, 132, '2015-01-15 01:03:55.000000', 'consum', 0.0212, 'lps'),
	(648981, 132, '2015-01-15 01:03:56.000000', 'consum', 0.0218, 'lps'),
	(648982, 132, '2015-01-15 01:03:57.000000', 'consum', 0.0213, 'lps'),
	(648983, 132, '2015-01-15 01:03:58.000000', 'consum', 0.0211, 'lps'),
	(648984, 132, '2015-01-15 01:03:59.000000', 'consum', 0.0218, 'lps'),
	(648985, 132, '2015-01-15 01:04:00.000000', 'consum', 0.0212, 'lps'),
	(648986, 132, '2015-01-15 01:04:01.000000', 'consum', 0.0211, 'lps'),
	(648987, 132, '2015-01-15 01:04:02.000000', 'consum', 0.0219, 'lps'),
	(648988, 132, '2015-01-15 01:04:03.000000', 'consum', 0.0210, 'lps'),
	(648989, 132, '2015-01-15 01:04:04.000000', 'consum', 0.0217, 'lps'),
	(648990, 132, '2015-01-15 01:04:05.000000', 'consum', 0.0210, 'lps'),
	(648991, 132, '2015-01-15 01:04:06.000000', 'consum', 0.0213, 'lps'),
	(648992, 132, '2015-01-15 01:04:07.000000', 'consum', 0.0214, 'lps'),
	(648993, 132, '2015-01-15 01:04:08.000000', 'consum', 0.0211, 'lps'),
	(648994, 132, '2015-01-15 01:04:09.000000', 'consum', 0.0213, 'lps'),
	(648995, 132, '2015-01-15 01:04:10.000000', 'consum', 0.0212, 'lps'),
	(648996, 132, '2015-01-15 01:04:11.000000', 'consum', 0.0210, 'lps'),
	(648997, 132, '2015-01-15 01:04:12.000000', 'consum', 0.0217, 'lps'),
	(648998, 132, '2015-01-15 01:04:13.000000', 'consum', 0.0213, 'lps'),
	(648999, 132, '2015-01-15 01:04:14.000000', 'consum', 0.0214, 'lps'),
	(649000, 132, '2015-01-15 01:04:15.000000', 'consum', 0.0211, 'lps'),
	(649001, 132, '2015-01-15 01:04:16.000000', 'consum', 0.0217, 'lps'),
	(649002, 132, '2015-01-15 01:04:17.000000', 'consum', 0.0217, 'lps'),
	(649003, 132, '2015-01-15 01:04:18.000000', 'consum', 0.0215, 'lps'),
	(649004, 132, '2015-01-15 01:04:19.000000', 'consum', 0.0213, 'lps'),
	(649005, 132, '2015-01-15 01:04:20.000000', 'consum', 0.0213, 'lps'),
	(649006, 132, '2015-01-15 01:04:21.000000', 'consum', 0.0214, 'lps'),
	(649007, 132, '2015-01-15 01:04:22.000000', 'consum', 0.0211, 'lps'),
	(649008, 132, '2015-01-15 01:04:23.000000', 'consum', 0.0215, 'lps'),
	(649009, 132, '2015-01-15 01:04:24.000000', 'consum', 0.0211, 'lps'),
	(649010, 132, '2015-01-15 01:04:25.000000', 'consum', 0.0213, 'lps'),
	(649011, 132, '2015-01-15 01:04:26.000000', 'consum', 0.0220, 'lps'),
	(649012, 132, '2015-01-15 01:04:27.000000', 'consum', 0.0220, 'lps'),
	(649013, 132, '2015-01-15 01:04:28.000000', 'consum', 0.0219, 'lps'),
	(649014, 132, '2015-01-15 01:04:29.000000', 'consum', 0.0214, 'lps'),
	(649015, 132, '2015-01-15 01:04:30.000000', 'consum', 0.0215, 'lps'),
	(649016, 132, '2015-01-15 01:04:31.000000', 'consum', 0.0211, 'lps'),
	(649017, 132, '2015-01-15 01:04:32.000000', 'consum', 0.0211, 'lps'),
	(649018, 132, '2015-01-15 01:04:33.000000', 'consum', 0.0215, 'lps'),
	(649019, 132, '2015-01-15 01:04:34.000000', 'consum', 0.0211, 'lps'),
	(649020, 132, '2015-01-15 01:04:35.000000', 'consum', 0.0220, 'lps'),
	(649021, 132, '2015-01-15 01:04:36.000000', 'consum', 0.0216, 'lps'),
	(649022, 132, '2015-01-15 01:04:37.000000', 'consum', 0.0211, 'lps'),
	(649023, 132, '2015-01-15 01:04:38.000000', 'consum', 0.0220, 'lps'),
	(649024, 132, '2015-01-15 01:04:39.000000', 'consum', 0.0214, 'lps'),
	(649025, 132, '2015-01-15 01:04:40.000000', 'consum', 0.0211, 'lps'),
	(649026, 132, '2015-01-15 01:04:41.000000', 'consum', 0.0214, 'lps'),
	(649027, 132, '2015-01-15 01:04:42.000000', 'consum', 0.0216, 'lps'),
	(649028, 132, '2015-01-15 01:04:43.000000', 'consum', 0.0217, 'lps'),
	(649029, 132, '2015-01-15 01:04:44.000000', 'consum', 0.0216, 'lps'),
	(649030, 132, '2015-01-15 01:04:45.000000', 'consum', 0.0210, 'lps'),
	(649031, 132, '2015-01-15 01:04:46.000000', 'consum', 0.0212, 'lps'),
	(649032, 132, '2015-01-15 01:04:47.000000', 'consum', 0.0211, 'lps'),
	(649033, 132, '2015-01-15 01:04:48.000000', 'consum', 0.0220, 'lps'),
	(649034, 132, '2015-01-15 01:04:49.000000', 'consum', 0.0214, 'lps'),
	(649035, 132, '2015-01-15 01:04:50.000000', 'consum', 0.0213, 'lps'),
	(649036, 132, '2015-01-15 01:04:51.000000', 'consum', 0.0212, 'lps'),
	(649037, 132, '2015-01-15 01:04:52.000000', 'consum', 0.0211, 'lps'),
	(649038, 132, '2015-01-15 01:04:53.000000', 'consum', 0.0219, 'lps'),
	(649039, 132, '2015-01-15 01:04:54.000000', 'consum', 0.0211, 'lps'),
	(649040, 132, '2015-01-15 01:04:55.000000', 'consum', 0.0210, 'lps'),
	(649041, 132, '2015-01-15 01:04:56.000000', 'consum', 0.0217, 'lps'),
	(649042, 132, '2015-01-15 01:04:57.000000', 'consum', 0.0213, 'lps'),
	(649043, 132, '2015-01-15 01:04:58.000000', 'consum', 0.0215, 'lps'),
	(649044, 132, '2015-01-15 01:04:59.000000', 'consum', 0.0214, 'lps'),
	(649045, 132, '2015-01-15 01:05:00.000000', 'consum', 0.0218, 'lps'),
	(649046, 132, '2015-01-15 01:05:01.000000', 'consum', 0.0214, 'lps'),
	(649047, 132, '2015-01-15 01:05:02.000000', 'consum', 0.0217, 'lps'),
	(649048, 132, '2015-01-15 01:05:03.000000', 'consum', 0.0214, 'lps'),
	(649049, 132, '2015-01-15 01:05:04.000000', 'consum', 0.0219, 'lps'),
	(649050, 132, '2015-01-15 01:05:05.000000', 'consum', 0.0220, 'lps'),
	(649051, 132, '2015-01-15 01:05:06.000000', 'consum', 0.0212, 'lps'),
	(649052, 132, '2015-01-15 01:05:07.000000', 'consum', 0.0214, 'lps'),
	(649053, 132, '2015-01-15 01:05:08.000000', 'consum', 0.0214, 'lps'),
	(649054, 132, '2015-01-15 01:05:09.000000', 'consum', 0.0216, 'lps'),
	(649055, 132, '2015-01-15 01:05:10.000000', 'consum', 0.0218, 'lps'),
	(649056, 132, '2015-01-15 01:05:11.000000', 'consum', 0.0211, 'lps'),
	(649057, 132, '2015-01-15 01:05:12.000000', 'consum', 0.0213, 'lps'),
	(649058, 132, '2015-01-15 01:05:13.000000', 'consum', 0.0213, 'lps'),
	(649059, 132, '2015-01-15 01:05:14.000000', 'consum', 0.0216, 'lps'),
	(649060, 132, '2015-01-15 01:05:15.000000', 'consum', 0.0219, 'lps'),
	(649061, 132, '2015-01-15 01:05:16.000000', 'consum', 0.0216, 'lps'),
	(649062, 132, '2015-01-15 01:05:17.000000', 'consum', 0.0212, 'lps'),
	(649063, 132, '2015-01-15 01:05:18.000000', 'consum', 0.0216, 'lps'),
	(649064, 132, '2015-01-15 01:05:19.000000', 'consum', 0.0210, 'lps'),
	(649065, 132, '2015-01-15 01:05:20.000000', 'consum', 0.0214, 'lps'),
	(649066, 132, '2015-01-15 01:05:21.000000', 'consum', 0.0211, 'lps'),
	(649067, 132, '2015-01-15 01:05:22.000000', 'consum', 0.0214, 'lps'),
	(649068, 132, '2015-01-15 01:05:23.000000', 'consum', 0.0216, 'lps'),
	(649069, 132, '2015-01-15 01:05:24.000000', 'consum', 0.0219, 'lps'),
	(649070, 132, '2015-01-15 01:05:25.000000', 'consum', 0.0214, 'lps'),
	(649071, 132, '2015-01-15 01:05:26.000000', 'consum', 0.0214, 'lps'),
	(649072, 132, '2015-01-15 01:05:27.000000', 'consum', 0.0220, 'lps'),
	(649073, 132, '2015-01-15 01:05:28.000000', 'consum', 0.0216, 'lps'),
	(649074, 132, '2015-01-15 01:05:29.000000', 'consum', 0.0210, 'lps'),
	(649075, 132, '2015-01-15 01:05:30.000000', 'consum', 0.0213, 'lps'),
	(649076, 132, '2015-01-15 01:05:31.000000', 'consum', 0.0216, 'lps'),
	(649077, 132, '2015-01-15 01:05:32.000000', 'consum', 0.0218, 'lps'),
	(649078, 132, '2015-01-15 01:05:33.000000', 'consum', 0.0213, 'lps'),
	(649079, 132, '2015-01-15 01:05:34.000000', 'consum', 0.0213, 'lps'),
	(649080, 132, '2015-01-15 01:05:35.000000', 'consum', 0.0217, 'lps'),
	(649081, 132, '2015-01-15 01:05:36.000000', 'consum', 0.0214, 'lps'),
	(649082, 132, '2015-01-15 01:05:37.000000', 'consum', 0.0218, 'lps'),
	(649083, 132, '2015-01-15 01:05:38.000000', 'consum', 0.0220, 'lps'),
	(649084, 132, '2015-01-15 01:05:39.000000', 'consum', 0.0213, 'lps'),
	(649085, 132, '2015-01-15 01:05:40.000000', 'consum', 0.0219, 'lps'),
	(649086, 132, '2015-01-15 01:05:41.000000', 'consum', 0.0215, 'lps'),
	(649087, 132, '2015-01-15 01:05:42.000000', 'consum', 0.0216, 'lps'),
	(649088, 132, '2015-01-15 01:05:43.000000', 'consum', 0.0217, 'lps'),
	(649089, 132, '2015-01-15 01:05:44.000000', 'consum', 0.0214, 'lps'),
	(649090, 132, '2015-01-15 01:05:45.000000', 'consum', 0.0212, 'lps'),
	(649091, 132, '2015-01-15 01:05:46.000000', 'consum', 0.0220, 'lps'),
	(649092, 132, '2015-01-15 01:05:47.000000', 'consum', 0.0212, 'lps'),
	(649093, 132, '2015-01-15 01:05:48.000000', 'consum', 0.0220, 'lps'),
	(649094, 132, '2015-01-15 01:05:49.000000', 'consum', 0.0211, 'lps'),
	(649095, 132, '2015-01-15 01:05:50.000000', 'consum', 0.0217, 'lps'),
	(649096, 132, '2015-01-15 01:05:51.000000', 'consum', 0.0210, 'lps'),
	(649097, 132, '2015-01-15 01:05:52.000000', 'consum', 0.0213, 'lps'),
	(649098, 132, '2015-01-15 01:05:53.000000', 'consum', 0.0215, 'lps'),
	(649099, 132, '2015-01-15 01:05:54.000000', 'consum', 0.0216, 'lps'),
	(649100, 132, '2015-01-15 01:05:55.000000', 'consum', 0.0214, 'lps'),
	(649101, 132, '2015-01-15 01:05:56.000000', 'consum', 0.0211, 'lps'),
	(649102, 132, '2015-01-15 01:05:57.000000', 'consum', 0.0214, 'lps'),
	(649103, 132, '2015-01-15 01:05:58.000000', 'consum', 0.0218, 'lps'),
	(649104, 132, '2015-01-15 01:05:59.000000', 'consum', 0.0218, 'lps'),
	(649105, 132, '2015-01-15 01:06:00.000000', 'consum', 0.0213, 'lps'),
	(649106, 132, '2015-01-15 01:06:01.000000', 'consum', 0.0212, 'lps'),
	(649107, 132, '2015-01-15 01:06:02.000000', 'consum', 0.0213, 'lps'),
	(649108, 132, '2015-01-15 01:06:03.000000', 'consum', 0.0219, 'lps'),
	(649109, 132, '2015-01-15 01:06:04.000000', 'consum', 0.0213, 'lps'),
	(649110, 132, '2015-01-15 01:06:05.000000', 'consum', 0.0211, 'lps'),
	(649111, 132, '2015-01-15 01:06:06.000000', 'consum', 0.0216, 'lps'),
	(649112, 132, '2015-01-15 01:06:07.000000', 'consum', 0.0218, 'lps'),
	(649113, 132, '2015-01-15 01:06:08.000000', 'consum', 0.0220, 'lps'),
	(649114, 132, '2015-01-15 01:06:09.000000', 'consum', 0.0213, 'lps'),
	(649115, 132, '2015-01-15 01:06:10.000000', 'consum', 0.0217, 'lps'),
	(649116, 132, '2015-01-15 01:06:11.000000', 'consum', 0.0217, 'lps'),
	(649117, 132, '2015-01-15 01:06:12.000000', 'consum', 0.0211, 'lps'),
	(649118, 132, '2015-01-15 01:06:13.000000', 'consum', 0.0219, 'lps'),
	(649119, 132, '2015-01-15 01:06:14.000000', 'consum', 0.0217, 'lps'),
	(649120, 132, '2015-01-15 01:06:15.000000', 'consum', 0.0220, 'lps'),
	(649121, 132, '2015-01-15 01:06:16.000000', 'consum', 0.0218, 'lps'),
	(649122, 132, '2015-01-15 01:06:17.000000', 'consum', 0.0218, 'lps'),
	(649123, 132, '2015-01-15 01:06:18.000000', 'consum', 0.0216, 'lps'),
	(649124, 132, '2015-01-15 01:06:19.000000', 'consum', 0.0217, 'lps'),
	(649125, 132, '2015-01-15 01:06:20.000000', 'consum', 0.0216, 'lps'),
	(649126, 132, '2015-01-15 01:06:21.000000', 'consum', 0.0211, 'lps'),
	(649127, 132, '2015-01-15 01:06:22.000000', 'consum', 0.0217, 'lps'),
	(649128, 132, '2015-01-15 01:06:23.000000', 'consum', 0.0220, 'lps'),
	(649129, 132, '2015-01-15 01:06:24.000000', 'consum', 0.0218, 'lps'),
	(649130, 132, '2015-01-15 01:06:25.000000', 'consum', 0.0211, 'lps'),
	(649131, 132, '2015-01-15 01:06:26.000000', 'consum', 0.0212, 'lps'),
	(649132, 132, '2015-01-15 01:06:27.000000', 'consum', 0.0218, 'lps'),
	(649133, 132, '2015-01-15 01:06:28.000000', 'consum', 0.0211, 'lps'),
	(649134, 132, '2015-01-15 01:06:29.000000', 'consum', 0.0213, 'lps'),
	(649135, 132, '2015-01-15 01:06:30.000000', 'consum', 0.0212, 'lps'),
	(649136, 132, '2015-01-15 01:06:31.000000', 'consum', 0.0213, 'lps'),
	(649137, 132, '2015-01-15 01:06:32.000000', 'consum', 0.0219, 'lps'),
	(649138, 132, '2015-01-15 01:06:33.000000', 'consum', 0.0212, 'lps'),
	(649139, 132, '2015-01-15 01:06:34.000000', 'consum', 0.0218, 'lps'),
	(649140, 132, '2015-01-15 01:06:35.000000', 'consum', 0.0211, 'lps'),
	(649141, 132, '2015-01-15 01:06:36.000000', 'consum', 0.0213, 'lps'),
	(649142, 132, '2015-01-15 01:06:37.000000', 'consum', 0.0211, 'lps'),
	(649143, 132, '2015-01-15 01:06:38.000000', 'consum', 0.0217, 'lps'),
	(649144, 132, '2015-01-15 01:06:39.000000', 'consum', 0.0219, 'lps'),
	(649145, 132, '2015-01-15 01:06:40.000000', 'consum', 0.0215, 'lps'),
	(649146, 132, '2015-01-15 01:06:41.000000', 'consum', 0.0218, 'lps'),
	(649147, 132, '2015-01-15 01:06:42.000000', 'consum', 0.0215, 'lps'),
	(649148, 132, '2015-01-15 01:06:43.000000', 'consum', 0.0211, 'lps'),
	(649149, 132, '2015-01-15 01:06:44.000000', 'consum', 0.0210, 'lps'),
	(649150, 132, '2015-01-15 01:06:45.000000', 'consum', 0.0220, 'lps'),
	(649151, 132, '2015-01-15 01:06:46.000000', 'consum', 0.0217, 'lps'),
	(649152, 132, '2015-01-15 01:06:47.000000', 'consum', 0.0214, 'lps'),
	(649153, 132, '2015-01-15 01:06:48.000000', 'consum', 0.0219, 'lps'),
	(649154, 132, '2015-01-15 01:06:49.000000', 'consum', 0.0213, 'lps'),
	(649155, 132, '2015-01-15 01:06:50.000000', 'consum', 0.0218, 'lps'),
	(649156, 132, '2015-01-15 01:06:51.000000', 'consum', 0.0220, 'lps'),
	(649157, 132, '2015-01-15 01:06:52.000000', 'consum', 0.0217, 'lps'),
	(649158, 132, '2015-01-15 01:06:53.000000', 'consum', 0.0213, 'lps'),
	(649159, 132, '2015-01-15 01:06:54.000000', 'consum', 0.0217, 'lps'),
	(649160, 132, '2015-01-15 01:06:55.000000', 'consum', 0.0214, 'lps'),
	(649161, 132, '2015-01-15 01:06:56.000000', 'consum', 0.0210, 'lps'),
	(649162, 132, '2015-01-15 01:06:57.000000', 'consum', 0.0219, 'lps'),
	(649163, 132, '2015-01-15 01:06:58.000000', 'consum', 0.0212, 'lps'),
	(649164, 132, '2015-01-15 01:06:59.000000', 'consum', 0.0217, 'lps'),
	(649165, 132, '2015-01-15 01:07:00.000000', 'consum', 0.0217, 'lps'),
	(649166, 132, '2015-01-15 01:07:01.000000', 'consum', 0.0214, 'lps'),
	(649167, 132, '2015-01-15 01:07:02.000000', 'consum', 0.0218, 'lps'),
	(649168, 132, '2015-01-15 01:07:03.000000', 'consum', 0.0218, 'lps'),
	(649169, 132, '2015-01-15 01:07:04.000000', 'consum', 0.0213, 'lps'),
	(649170, 132, '2015-01-15 01:07:05.000000', 'consum', 0.0216, 'lps'),
	(649171, 132, '2015-01-15 01:07:06.000000', 'consum', 0.0220, 'lps'),
	(649172, 132, '2015-01-15 01:07:07.000000', 'consum', 0.0210, 'lps'),
	(649173, 132, '2015-01-15 01:07:08.000000', 'consum', 0.0211, 'lps'),
	(649174, 132, '2015-01-15 01:07:09.000000', 'consum', 0.0217, 'lps'),
	(649175, 132, '2015-01-15 01:07:10.000000', 'consum', 0.0210, 'lps'),
	(649176, 132, '2015-01-15 01:07:11.000000', 'consum', 0.0212, 'lps'),
	(649177, 132, '2015-01-15 01:07:12.000000', 'consum', 0.0219, 'lps'),
	(649178, 132, '2015-01-15 01:07:13.000000', 'consum', 0.0215, 'lps'),
	(649179, 132, '2015-01-15 01:07:14.000000', 'consum', 0.0211, 'lps'),
	(649180, 132, '2015-01-15 01:07:15.000000', 'consum', 0.0213, 'lps'),
	(649181, 132, '2015-01-15 01:07:16.000000', 'consum', 0.0220, 'lps'),
	(649182, 132, '2015-01-15 01:07:17.000000', 'consum', 0.0218, 'lps'),
	(649183, 132, '2015-01-15 01:07:18.000000', 'consum', 0.0211, 'lps'),
	(649184, 132, '2015-01-15 01:07:19.000000', 'consum', 0.0212, 'lps'),
	(649185, 132, '2015-01-15 01:07:20.000000', 'consum', 0.0218, 'lps'),
	(649186, 132, '2015-01-15 01:07:21.000000', 'consum', 0.0212, 'lps'),
	(649187, 132, '2015-01-15 01:07:22.000000', 'consum', 0.0220, 'lps'),
	(649188, 132, '2015-01-15 01:07:23.000000', 'consum', 0.0220, 'lps'),
	(649189, 132, '2015-01-15 01:07:24.000000', 'consum', 0.0219, 'lps'),
	(649190, 132, '2015-01-15 01:07:25.000000', 'consum', 0.0214, 'lps'),
	(649191, 132, '2015-01-15 01:07:26.000000', 'consum', 0.0215, 'lps'),
	(649192, 132, '2015-01-15 01:07:27.000000', 'consum', 0.0213, 'lps'),
	(649193, 132, '2015-01-15 01:07:28.000000', 'consum', 0.0210, 'lps'),
	(649194, 132, '2015-01-15 01:07:29.000000', 'consum', 0.0212, 'lps'),
	(649195, 132, '2015-01-15 01:07:30.000000', 'consum', 0.0220, 'lps'),
	(649196, 132, '2015-01-15 01:07:31.000000', 'consum', 0.0212, 'lps'),
	(649197, 132, '2015-01-15 01:07:32.000000', 'consum', 0.0211, 'lps'),
	(649198, 132, '2015-01-15 01:07:33.000000', 'consum', 0.0210, 'lps'),
	(649199, 132, '2015-01-15 01:07:34.000000', 'consum', 0.0218, 'lps'),
	(649200, 132, '2015-01-15 01:07:35.000000', 'consum', 0.0216, 'lps'),
	(649201, 132, '2015-01-15 01:07:36.000000', 'consum', 0.0218, 'lps'),
	(649202, 132, '2015-01-15 01:07:37.000000', 'consum', 0.0211, 'lps'),
	(649203, 132, '2015-01-15 01:07:38.000000', 'consum', 0.0212, 'lps'),
	(649204, 132, '2015-01-15 01:07:39.000000', 'consum', 0.0218, 'lps'),
	(649205, 132, '2015-01-15 01:07:40.000000', 'consum', 0.0210, 'lps'),
	(649206, 132, '2015-01-15 01:07:41.000000', 'consum', 0.0220, 'lps'),
	(649207, 132, '2015-01-15 01:07:42.000000', 'consum', 0.0216, 'lps'),
	(649208, 132, '2015-01-15 01:07:43.000000', 'consum', 0.0211, 'lps'),
	(649209, 132, '2015-01-15 01:07:44.000000', 'consum', 0.0219, 'lps'),
	(649210, 132, '2015-01-15 01:07:45.000000', 'consum', 0.0219, 'lps'),
	(649211, 132, '2015-01-15 01:07:46.000000', 'consum', 0.0220, 'lps'),
	(649212, 132, '2015-01-15 01:07:47.000000', 'consum', 0.0220, 'lps'),
	(649213, 132, '2015-01-15 01:07:48.000000', 'consum', 0.0218, 'lps'),
	(649214, 132, '2015-01-15 01:07:49.000000', 'consum', 0.0213, 'lps'),
	(649215, 132, '2015-01-15 01:07:50.000000', 'consum', 0.0210, 'lps'),
	(649216, 132, '2015-01-15 01:07:51.000000', 'consum', 0.0214, 'lps'),
	(649217, 132, '2015-01-15 01:07:52.000000', 'consum', 0.0218, 'lps'),
	(649218, 132, '2015-01-15 01:07:53.000000', 'consum', 0.0217, 'lps'),
	(649219, 132, '2015-01-15 01:07:54.000000', 'consum', 0.0211, 'lps'),
	(649220, 132, '2015-01-15 01:07:55.000000', 'consum', 0.0216, 'lps'),
	(649221, 132, '2015-01-15 01:07:56.000000', 'consum', 0.0214, 'lps'),
	(649222, 132, '2015-01-15 01:07:57.000000', 'consum', 0.0216, 'lps'),
	(649223, 132, '2015-01-15 01:07:58.000000', 'consum', 0.0215, 'lps'),
	(649224, 132, '2015-01-15 01:07:59.000000', 'consum', 0.0218, 'lps'),
	(649225, 132, '2015-01-15 01:08:00.000000', 'consum', 0.0214, 'lps'),
	(649226, 132, '2015-01-15 01:08:01.000000', 'consum', 0.0219, 'lps'),
	(649227, 132, '2015-01-15 01:08:02.000000', 'consum', 0.0218, 'lps'),
	(649228, 132, '2015-01-15 01:08:03.000000', 'consum', 0.0215, 'lps'),
	(649229, 132, '2015-01-15 01:08:04.000000', 'consum', 0.0212, 'lps'),
	(649230, 132, '2015-01-15 01:08:05.000000', 'consum', 0.0215, 'lps'),
	(649231, 132, '2015-01-15 01:08:06.000000', 'consum', 0.0219, 'lps'),
	(649232, 132, '2015-01-15 01:08:07.000000', 'consum', 0.0220, 'lps'),
	(649233, 132, '2015-01-15 01:08:08.000000', 'consum', 0.0211, 'lps'),
	(649234, 132, '2015-01-15 01:08:09.000000', 'consum', 0.0218, 'lps'),
	(649235, 132, '2015-01-15 01:08:10.000000', 'consum', 0.0214, 'lps'),
	(649236, 132, '2015-01-15 01:08:11.000000', 'consum', 0.0219, 'lps'),
	(649237, 132, '2015-01-15 01:08:12.000000', 'consum', 0.0210, 'lps'),
	(649238, 132, '2015-01-15 01:08:13.000000', 'consum', 0.0217, 'lps'),
	(649239, 132, '2015-01-15 01:08:14.000000', 'consum', 0.0213, 'lps'),
	(649240, 132, '2015-01-15 01:08:15.000000', 'consum', 0.0215, 'lps'),
	(649241, 132, '2015-01-15 01:08:16.000000', 'consum', 0.0214, 'lps'),
	(649242, 132, '2015-01-15 01:08:17.000000', 'consum', 0.0215, 'lps'),
	(649243, 132, '2015-01-15 01:08:18.000000', 'consum', 0.0215, 'lps'),
	(649244, 132, '2015-01-15 01:08:19.000000', 'consum', 0.0210, 'lps'),
	(649245, 132, '2015-01-15 01:08:20.000000', 'consum', 0.0215, 'lps'),
	(649246, 132, '2015-01-15 01:08:21.000000', 'consum', 0.0214, 'lps'),
	(649247, 132, '2015-01-15 01:08:22.000000', 'consum', 0.0216, 'lps'),
	(649248, 132, '2015-01-15 01:08:23.000000', 'consum', 0.0217, 'lps'),
	(649249, 132, '2015-01-15 01:08:24.000000', 'consum', 0.0215, 'lps'),
	(649250, 132, '2015-01-15 01:08:25.000000', 'consum', 0.0217, 'lps'),
	(649251, 132, '2015-01-15 01:08:26.000000', 'consum', 0.0219, 'lps'),
	(649252, 132, '2015-01-15 01:08:27.000000', 'consum', 0.0213, 'lps'),
	(649253, 132, '2015-01-15 01:08:28.000000', 'consum', 0.0218, 'lps'),
	(649254, 132, '2015-01-15 01:08:29.000000', 'consum', 0.0211, 'lps'),
	(649255, 132, '2015-01-15 01:08:30.000000', 'consum', 0.0214, 'lps'),
	(649256, 132, '2015-01-15 01:08:31.000000', 'consum', 0.0217, 'lps'),
	(649257, 132, '2015-01-15 01:08:32.000000', 'consum', 0.0210, 'lps'),
	(649258, 132, '2015-01-15 01:08:33.000000', 'consum', 0.0210, 'lps'),
	(649259, 132, '2015-01-15 01:08:34.000000', 'consum', 0.0211, 'lps'),
	(649260, 132, '2015-01-15 01:08:35.000000', 'consum', 0.0215, 'lps'),
	(649261, 132, '2015-01-15 01:08:36.000000', 'consum', 0.0211, 'lps'),
	(649262, 132, '2015-01-15 01:08:37.000000', 'consum', 0.0212, 'lps'),
	(649263, 132, '2015-01-15 01:08:38.000000', 'consum', 0.0219, 'lps'),
	(649264, 132, '2015-01-15 01:08:39.000000', 'consum', 0.0214, 'lps'),
	(649265, 132, '2015-01-15 01:08:40.000000', 'consum', 0.0217, 'lps'),
	(649266, 132, '2015-01-15 01:08:41.000000', 'consum', 0.0220, 'lps'),
	(649267, 132, '2015-01-15 01:08:42.000000', 'consum', 0.0217, 'lps'),
	(649268, 132, '2015-01-15 01:08:43.000000', 'consum', 0.0218, 'lps'),
	(649269, 132, '2015-01-15 01:08:44.000000', 'consum', 0.0216, 'lps'),
	(649270, 132, '2015-01-15 01:08:45.000000', 'consum', 0.0216, 'lps'),
	(649271, 132, '2015-01-15 01:08:46.000000', 'consum', 0.0211, 'lps'),
	(649272, 132, '2015-01-15 01:08:47.000000', 'consum', 0.0219, 'lps'),
	(649273, 132, '2015-01-15 01:08:48.000000', 'consum', 0.0211, 'lps'),
	(649274, 132, '2015-01-15 01:08:49.000000', 'consum', 0.0220, 'lps'),
	(649275, 132, '2015-01-15 01:08:50.000000', 'consum', 0.0215, 'lps'),
	(649276, 132, '2015-01-15 01:08:51.000000', 'consum', 0.0217, 'lps'),
	(649277, 132, '2015-01-15 01:08:52.000000', 'consum', 0.0218, 'lps'),
	(649278, 132, '2015-01-15 01:08:53.000000', 'consum', 0.0220, 'lps'),
	(649279, 132, '2015-01-15 01:08:54.000000', 'consum', 0.0215, 'lps'),
	(649280, 132, '2015-01-15 01:08:55.000000', 'consum', 0.0216, 'lps'),
	(649281, 132, '2015-01-15 01:08:56.000000', 'consum', 0.0214, 'lps'),
	(649282, 132, '2015-01-15 01:08:57.000000', 'consum', 0.0212, 'lps'),
	(649283, 132, '2015-01-15 01:08:58.000000', 'consum', 0.0218, 'lps'),
	(649284, 132, '2015-01-15 01:08:59.000000', 'consum', 0.0213, 'lps'),
	(649285, 132, '2015-01-15 01:09:00.000000', 'consum', 0.0214, 'lps'),
	(649286, 132, '2015-01-15 01:09:01.000000', 'consum', 0.0220, 'lps'),
	(649287, 132, '2015-01-15 01:09:02.000000', 'consum', 0.0218, 'lps'),
	(649288, 132, '2015-01-15 01:09:03.000000', 'consum', 0.0218, 'lps'),
	(649289, 132, '2015-01-15 01:09:04.000000', 'consum', 0.0216, 'lps'),
	(649290, 132, '2015-01-15 01:09:05.000000', 'consum', 0.0217, 'lps'),
	(649291, 132, '2015-01-15 01:09:06.000000', 'consum', 0.0215, 'lps'),
	(649292, 132, '2015-01-15 01:09:07.000000', 'consum', 0.0215, 'lps'),
	(649293, 132, '2015-01-15 01:09:08.000000', 'consum', 0.0219, 'lps'),
	(649294, 132, '2015-01-15 01:09:09.000000', 'consum', 0.0220, 'lps'),
	(649295, 132, '2015-01-15 01:09:10.000000', 'consum', 0.0211, 'lps'),
	(649296, 132, '2015-01-15 01:09:11.000000', 'consum', 0.0220, 'lps'),
	(649297, 132, '2015-01-15 01:09:12.000000', 'consum', 0.0212, 'lps'),
	(649298, 132, '2015-01-15 01:09:13.000000', 'consum', 0.0211, 'lps'),
	(649299, 132, '2015-01-15 01:09:14.000000', 'consum', 0.0211, 'lps'),
	(649300, 132, '2015-01-15 01:09:15.000000', 'consum', 0.0211, 'lps'),
	(649301, 132, '2015-01-15 01:09:16.000000', 'consum', 0.0212, 'lps'),
	(649302, 132, '2015-01-15 01:09:17.000000', 'consum', 0.0219, 'lps'),
	(649303, 132, '2015-01-15 01:09:18.000000', 'consum', 0.0214, 'lps'),
	(649304, 132, '2015-01-15 01:09:19.000000', 'consum', 0.0218, 'lps'),
	(649305, 132, '2015-01-15 01:09:20.000000', 'consum', 0.0215, 'lps'),
	(649306, 132, '2015-01-15 01:09:21.000000', 'consum', 0.0210, 'lps'),
	(649307, 132, '2015-01-15 01:09:22.000000', 'consum', 0.0217, 'lps'),
	(649308, 132, '2015-01-15 01:09:23.000000', 'consum', 0.0216, 'lps'),
	(649309, 132, '2015-01-15 01:09:24.000000', 'consum', 0.0216, 'lps'),
	(649310, 132, '2015-01-15 01:09:25.000000', 'consum', 0.0212, 'lps'),
	(649311, 132, '2015-01-15 01:09:26.000000', 'consum', 0.0212, 'lps'),
	(649312, 132, '2015-01-15 01:09:27.000000', 'consum', 0.0217, 'lps'),
	(649313, 132, '2015-01-15 01:09:28.000000', 'consum', 0.0216, 'lps'),
	(649314, 132, '2015-01-15 01:09:29.000000', 'consum', 0.0220, 'lps'),
	(649315, 132, '2015-01-15 01:09:30.000000', 'consum', 0.0210, 'lps'),
	(649316, 132, '2015-01-15 01:09:31.000000', 'consum', 0.0213, 'lps'),
	(649317, 132, '2015-01-15 01:09:32.000000', 'consum', 0.0215, 'lps'),
	(649318, 132, '2015-01-15 01:09:33.000000', 'consum', 0.0216, 'lps'),
	(649319, 132, '2015-01-15 01:09:34.000000', 'consum', 0.0214, 'lps'),
	(649320, 132, '2015-01-15 01:09:35.000000', 'consum', 0.0213, 'lps'),
	(649321, 132, '2015-01-15 01:09:36.000000', 'consum', 0.0212, 'lps'),
	(649322, 132, '2015-01-15 01:09:37.000000', 'consum', 0.0211, 'lps'),
	(649323, 132, '2015-01-15 01:09:38.000000', 'consum', 0.0211, 'lps'),
	(649324, 132, '2015-01-15 01:09:39.000000', 'consum', 0.0210, 'lps'),
	(649325, 132, '2015-01-15 01:09:40.000000', 'consum', 0.0220, 'lps'),
	(649326, 132, '2015-01-15 01:09:41.000000', 'consum', 0.0218, 'lps'),
	(649327, 132, '2015-01-15 01:09:42.000000', 'consum', 0.0219, 'lps'),
	(649328, 132, '2015-01-15 01:09:43.000000', 'consum', 0.0212, 'lps'),
	(649329, 132, '2015-01-15 01:09:44.000000', 'consum', 0.0214, 'lps'),
	(649330, 132, '2015-01-15 01:09:45.000000', 'consum', 0.0212, 'lps'),
	(649331, 132, '2015-01-15 01:09:46.000000', 'consum', 0.0210, 'lps'),
	(649332, 132, '2015-01-15 01:09:47.000000', 'consum', 0.0217, 'lps'),
	(649333, 132, '2015-01-15 01:09:48.000000', 'consum', 0.0210, 'lps'),
	(649334, 132, '2015-01-15 01:09:49.000000', 'consum', 0.0214, 'lps'),
	(649335, 132, '2015-01-15 01:09:50.000000', 'consum', 0.0220, 'lps'),
	(649336, 132, '2015-01-15 01:09:51.000000', 'consum', 0.0214, 'lps'),
	(649337, 132, '2015-01-15 01:09:52.000000', 'consum', 0.0212, 'lps'),
	(649338, 132, '2015-01-15 01:09:53.000000', 'consum', 0.0220, 'lps'),
	(649339, 132, '2015-01-15 01:09:54.000000', 'consum', 0.0210, 'lps'),
	(649340, 132, '2015-01-15 01:09:55.000000', 'consum', 0.0216, 'lps'),
	(649341, 132, '2015-01-15 01:09:56.000000', 'consum', 0.0215, 'lps'),
	(649342, 132, '2015-01-15 01:09:57.000000', 'consum', 0.0219, 'lps'),
	(649343, 132, '2015-01-15 01:09:58.000000', 'consum', 0.0220, 'lps'),
	(649344, 132, '2015-01-15 01:09:59.000000', 'consum', 0.0210, 'lps'),
	(649345, 132, '2015-01-15 01:10:00.000000', 'consum', 0.0212, 'lps'),
	(649346, 132, '2015-01-15 01:10:01.000000', 'consum', 0.0213, 'lps'),
	(649347, 132, '2015-01-15 01:10:02.000000', 'consum', 0.0216, 'lps'),
	(649348, 132, '2015-01-15 01:10:03.000000', 'consum', 0.0211, 'lps'),
	(649349, 132, '2015-01-15 01:10:04.000000', 'consum', 0.0219, 'lps'),
	(649350, 132, '2015-01-15 01:10:05.000000', 'consum', 0.0218, 'lps'),
	(649351, 132, '2015-01-15 01:10:06.000000', 'consum', 0.0213, 'lps'),
	(649352, 132, '2015-01-15 01:10:07.000000', 'consum', 0.0211, 'lps'),
	(649353, 132, '2015-01-15 01:10:08.000000', 'consum', 0.0210, 'lps'),
	(649354, 132, '2015-01-15 01:10:09.000000', 'consum', 0.0215, 'lps'),
	(649355, 132, '2015-01-15 01:10:10.000000', 'consum', 0.0215, 'lps'),
	(649356, 132, '2015-01-15 01:10:11.000000', 'consum', 0.0219, 'lps'),
	(649357, 132, '2015-01-15 01:10:12.000000', 'consum', 0.0210, 'lps'),
	(649358, 132, '2015-01-15 01:10:13.000000', 'consum', 0.0215, 'lps'),
	(649359, 132, '2015-01-15 01:10:14.000000', 'consum', 0.0214, 'lps'),
	(649360, 132, '2015-01-15 01:10:15.000000', 'consum', 0.0217, 'lps'),
	(649361, 132, '2015-01-15 01:10:16.000000', 'consum', 0.0220, 'lps'),
	(649362, 132, '2015-01-15 01:10:17.000000', 'consum', 0.0219, 'lps'),
	(649363, 132, '2015-01-15 01:10:18.000000', 'consum', 0.0215, 'lps'),
	(649364, 132, '2015-01-15 01:10:19.000000', 'consum', 0.0210, 'lps'),
	(649365, 132, '2015-01-15 01:10:20.000000', 'consum', 0.0216, 'lps'),
	(649366, 132, '2015-01-15 01:10:21.000000', 'consum', 0.0219, 'lps'),
	(649367, 132, '2015-01-15 01:10:22.000000', 'consum', 0.0215, 'lps'),
	(649368, 132, '2015-01-15 01:10:23.000000', 'consum', 0.0210, 'lps'),
	(649369, 132, '2015-01-15 01:10:24.000000', 'consum', 0.0214, 'lps'),
	(649370, 132, '2015-01-15 01:10:25.000000', 'consum', 0.0212, 'lps'),
	(649371, 132, '2015-01-15 01:10:26.000000', 'consum', 0.0219, 'lps'),
	(649372, 132, '2015-01-15 01:10:27.000000', 'consum', 0.0214, 'lps'),
	(649373, 132, '2015-01-15 01:10:28.000000', 'consum', 0.0217, 'lps'),
	(649374, 132, '2015-01-15 01:10:29.000000', 'consum', 0.0211, 'lps'),
	(649375, 132, '2015-01-15 01:10:30.000000', 'consum', 0.0216, 'lps'),
	(649376, 132, '2015-01-15 01:10:31.000000', 'consum', 0.0216, 'lps'),
	(649377, 132, '2015-01-15 01:10:32.000000', 'consum', 0.0210, 'lps'),
	(649378, 132, '2015-01-15 01:10:33.000000', 'consum', 0.0214, 'lps'),
	(649379, 132, '2015-01-15 01:10:34.000000', 'consum', 0.0211, 'lps'),
	(649380, 132, '2015-01-15 01:10:35.000000', 'consum', 0.0213, 'lps'),
	(649381, 132, '2015-01-15 01:10:36.000000', 'consum', 0.0211, 'lps'),
	(649382, 132, '2015-01-15 01:10:37.000000', 'consum', 0.0216, 'lps'),
	(649383, 132, '2015-01-15 01:10:38.000000', 'consum', 0.0219, 'lps'),
	(649384, 132, '2015-01-15 01:10:39.000000', 'consum', 0.0213, 'lps'),
	(649385, 132, '2015-01-15 01:10:40.000000', 'consum', 0.0211, 'lps'),
	(649386, 132, '2015-01-15 01:10:41.000000', 'consum', 0.0215, 'lps'),
	(649387, 132, '2015-01-15 01:10:42.000000', 'consum', 0.0211, 'lps'),
	(649388, 132, '2015-01-15 01:10:43.000000', 'consum', 0.0214, 'lps'),
	(649389, 132, '2015-01-15 01:10:44.000000', 'consum', 0.0216, 'lps'),
	(649390, 132, '2015-01-15 01:10:45.000000', 'consum', 0.0215, 'lps'),
	(649391, 132, '2015-01-15 01:10:46.000000', 'consum', 0.0219, 'lps'),
	(649392, 132, '2015-01-15 01:10:47.000000', 'consum', 0.0217, 'lps'),
	(649393, 132, '2015-01-15 01:10:48.000000', 'consum', 0.0218, 'lps'),
	(649394, 132, '2015-01-15 01:10:49.000000', 'consum', 0.0220, 'lps'),
	(649395, 132, '2015-01-15 01:10:50.000000', 'consum', 0.0216, 'lps'),
	(649396, 132, '2015-01-15 01:10:51.000000', 'consum', 0.0210, 'lps'),
	(649397, 132, '2015-01-15 01:10:52.000000', 'consum', 0.0212, 'lps'),
	(649398, 132, '2015-01-15 01:10:53.000000', 'consum', 0.0211, 'lps'),
	(649399, 132, '2015-01-15 01:10:54.000000', 'consum', 0.0220, 'lps'),
	(649400, 132, '2015-01-15 01:10:55.000000', 'consum', 0.0215, 'lps'),
	(649401, 132, '2015-01-15 01:10:56.000000', 'consum', 0.0214, 'lps'),
	(649402, 132, '2015-01-15 01:10:57.000000', 'consum', 0.0219, 'lps'),
	(649403, 132, '2015-01-15 01:10:58.000000', 'consum', 0.0219, 'lps'),
	(649404, 132, '2015-01-15 01:10:59.000000', 'consum', 0.0216, 'lps'),
	(649405, 132, '2015-01-15 01:11:00.000000', 'consum', 0.0216, 'lps'),
	(649406, 132, '2015-01-15 01:11:01.000000', 'consum', 0.0211, 'lps'),
	(649407, 132, '2015-01-15 01:11:02.000000', 'consum', 0.0218, 'lps'),
	(649408, 132, '2015-01-15 01:11:03.000000', 'consum', 0.0215, 'lps'),
	(649409, 132, '2015-01-15 01:11:04.000000', 'consum', 0.0213, 'lps'),
	(649410, 132, '2015-01-15 01:11:05.000000', 'consum', 0.0211, 'lps'),
	(649411, 132, '2015-01-15 01:11:06.000000', 'consum', 0.0217, 'lps'),
	(649412, 132, '2015-01-15 01:11:07.000000', 'consum', 0.0211, 'lps'),
	(649413, 132, '2015-01-15 01:11:08.000000', 'consum', 0.0216, 'lps'),
	(649414, 132, '2015-01-15 01:11:09.000000', 'consum', 0.0215, 'lps'),
	(649415, 132, '2015-01-15 01:11:10.000000', 'consum', 0.0216, 'lps'),
	(649416, 132, '2015-01-15 01:11:11.000000', 'consum', 0.0215, 'lps'),
	(649417, 132, '2015-01-15 01:11:12.000000', 'consum', 0.0217, 'lps'),
	(649418, 132, '2015-01-15 01:11:13.000000', 'consum', 0.0219, 'lps'),
	(649419, 132, '2015-01-15 01:11:14.000000', 'consum', 0.0212, 'lps'),
	(649420, 132, '2015-01-15 01:11:15.000000', 'consum', 0.0218, 'lps'),
	(649421, 132, '2015-01-15 01:11:16.000000', 'consum', 0.0212, 'lps'),
	(649422, 132, '2015-01-15 01:11:17.000000', 'consum', 0.0219, 'lps'),
	(649423, 132, '2015-01-15 01:11:18.000000', 'consum', 0.0217, 'lps'),
	(649424, 132, '2015-01-15 01:11:19.000000', 'consum', 0.0216, 'lps'),
	(649425, 132, '2015-01-15 01:11:20.000000', 'consum', 0.0220, 'lps'),
	(649426, 132, '2015-01-15 01:11:21.000000', 'consum', 0.0219, 'lps'),
	(649427, 132, '2015-01-15 01:11:22.000000', 'consum', 0.0214, 'lps'),
	(649428, 132, '2015-01-15 01:11:23.000000', 'consum', 0.0218, 'lps'),
	(649429, 132, '2015-01-15 01:11:24.000000', 'consum', 0.0214, 'lps'),
	(649430, 132, '2015-01-15 01:11:25.000000', 'consum', 0.0217, 'lps'),
	(649431, 132, '2015-01-15 01:11:26.000000', 'consum', 0.0212, 'lps'),
	(649432, 132, '2015-01-15 01:11:27.000000', 'consum', 0.0212, 'lps'),
	(649433, 132, '2015-01-15 01:11:28.000000', 'consum', 0.0212, 'lps'),
	(649434, 132, '2015-01-15 01:11:29.000000', 'consum', 0.0216, 'lps'),
	(649435, 132, '2015-01-15 01:11:30.000000', 'consum', 0.0212, 'lps'),
	(649436, 132, '2015-01-15 01:11:31.000000', 'consum', 0.0212, 'lps'),
	(649437, 132, '2015-01-15 01:11:32.000000', 'consum', 0.0216, 'lps'),
	(649438, 132, '2015-01-15 01:11:33.000000', 'consum', 0.0214, 'lps'),
	(649439, 132, '2015-01-15 01:11:34.000000', 'consum', 0.0212, 'lps'),
	(649440, 132, '2015-01-15 01:11:35.000000', 'consum', 0.0210, 'lps'),
	(649441, 132, '2015-01-15 01:11:36.000000', 'consum', 0.0212, 'lps'),
	(649442, 132, '2015-01-15 01:11:37.000000', 'consum', 0.0213, 'lps'),
	(649443, 132, '2015-01-15 01:11:38.000000', 'consum', 0.0217, 'lps'),
	(649444, 132, '2015-01-15 01:11:39.000000', 'consum', 0.0214, 'lps'),
	(649445, 132, '2015-01-15 01:11:40.000000', 'consum', 0.0212, 'lps'),
	(649446, 132, '2015-01-15 01:11:41.000000', 'consum', 0.0218, 'lps'),
	(649447, 132, '2015-01-15 01:11:42.000000', 'consum', 0.0213, 'lps'),
	(649448, 132, '2015-01-15 01:11:43.000000', 'consum', 0.0213, 'lps'),
	(649449, 132, '2015-01-15 01:11:44.000000', 'consum', 0.0217, 'lps'),
	(649450, 132, '2015-01-15 01:11:45.000000', 'consum', 0.0213, 'lps'),
	(649451, 132, '2015-01-15 01:11:46.000000', 'consum', 0.0217, 'lps'),
	(649452, 132, '2015-01-15 01:11:47.000000', 'consum', 0.0214, 'lps'),
	(649453, 132, '2015-01-15 01:11:48.000000', 'consum', 0.0218, 'lps'),
	(649454, 132, '2015-01-15 01:11:49.000000', 'consum', 0.0220, 'lps'),
	(649455, 132, '2015-01-15 01:11:50.000000', 'consum', 0.0212, 'lps'),
	(649456, 132, '2015-01-15 01:11:51.000000', 'consum', 0.0214, 'lps'),
	(649457, 132, '2015-01-15 01:11:52.000000', 'consum', 0.0215, 'lps'),
	(649458, 132, '2015-01-15 01:11:53.000000', 'consum', 0.0220, 'lps'),
	(649459, 132, '2015-01-15 01:11:54.000000', 'consum', 0.0215, 'lps'),
	(649460, 132, '2015-01-15 01:11:55.000000', 'consum', 0.0214, 'lps'),
	(649461, 132, '2015-01-15 01:11:56.000000', 'consum', 0.0217, 'lps'),
	(649462, 132, '2015-01-15 01:11:57.000000', 'consum', 0.0212, 'lps'),
	(649463, 132, '2015-01-15 01:11:58.000000', 'consum', 0.0210, 'lps'),
	(649464, 132, '2015-01-15 01:11:59.000000', 'consum', 0.0214, 'lps'),
	(649465, 132, '2015-01-15 01:12:00.000000', 'consum', 0.0219, 'lps'),
	(649466, 132, '2015-01-15 01:12:01.000000', 'consum', 0.0214, 'lps'),
	(649467, 132, '2015-01-15 01:12:02.000000', 'consum', 0.0212, 'lps'),
	(649468, 132, '2015-01-15 01:12:03.000000', 'consum', 0.0218, 'lps'),
	(649469, 132, '2015-01-15 01:12:04.000000', 'consum', 0.0215, 'lps'),
	(649470, 132, '2015-01-15 01:12:05.000000', 'consum', 0.0219, 'lps'),
	(649471, 132, '2015-01-15 01:12:06.000000', 'consum', 0.0210, 'lps'),
	(649472, 132, '2015-01-15 01:12:07.000000', 'consum', 0.0214, 'lps'),
	(649473, 132, '2015-01-15 01:12:08.000000', 'consum', 0.0220, 'lps'),
	(649474, 132, '2015-01-15 01:12:09.000000', 'consum', 0.0214, 'lps'),
	(649475, 132, '2015-01-15 01:12:10.000000', 'consum', 0.0214, 'lps'),
	(649476, 132, '2015-01-15 01:12:11.000000', 'consum', 0.0219, 'lps'),
	(649477, 132, '2015-01-15 01:12:12.000000', 'consum', 0.0210, 'lps'),
	(649478, 132, '2015-01-15 01:12:13.000000', 'consum', 0.0214, 'lps'),
	(649479, 132, '2015-01-15 01:12:14.000000', 'consum', 0.0211, 'lps'),
	(649480, 132, '2015-01-15 01:12:15.000000', 'consum', 0.0214, 'lps'),
	(649481, 132, '2015-01-15 01:12:16.000000', 'consum', 0.0216, 'lps'),
	(649482, 132, '2015-01-15 01:12:17.000000', 'consum', 0.0219, 'lps'),
	(649483, 132, '2015-01-15 01:12:18.000000', 'consum', 0.0215, 'lps'),
	(649484, 132, '2015-01-15 01:12:19.000000', 'consum', 0.0220, 'lps'),
	(649485, 132, '2015-01-15 01:12:20.000000', 'consum', 0.0211, 'lps'),
	(649486, 132, '2015-01-15 01:12:21.000000', 'consum', 0.0210, 'lps'),
	(649487, 132, '2015-01-15 01:12:22.000000', 'consum', 0.0217, 'lps'),
	(649488, 132, '2015-01-15 01:12:23.000000', 'consum', 0.0213, 'lps'),
	(649489, 132, '2015-01-15 01:12:24.000000', 'consum', 0.0215, 'lps'),
	(649490, 132, '2015-01-15 01:12:25.000000', 'consum', 0.0215, 'lps'),
	(649491, 132, '2015-01-15 01:12:26.000000', 'consum', 0.0219, 'lps'),
	(649492, 132, '2015-01-15 01:12:27.000000', 'consum', 0.0220, 'lps'),
	(649493, 132, '2015-01-15 01:12:28.000000', 'consum', 0.0220, 'lps'),
	(649494, 132, '2015-01-15 01:12:29.000000', 'consum', 0.0212, 'lps'),
	(649495, 132, '2015-01-15 01:12:30.000000', 'consum', 0.0211, 'lps'),
	(649496, 132, '2015-01-15 01:12:31.000000', 'consum', 0.0220, 'lps'),
	(649497, 132, '2015-01-15 01:12:32.000000', 'consum', 0.0212, 'lps'),
	(649498, 132, '2015-01-15 01:12:33.000000', 'consum', 0.0215, 'lps'),
	(649499, 132, '2015-01-15 01:12:34.000000', 'consum', 0.0217, 'lps'),
	(649500, 132, '2015-01-15 01:12:35.000000', 'consum', 0.0220, 'lps'),
	(649501, 132, '2015-01-15 01:12:36.000000', 'consum', 0.0216, 'lps'),
	(649502, 132, '2015-01-15 01:12:37.000000', 'consum', 0.0210, 'lps'),
	(649503, 132, '2015-01-15 01:12:38.000000', 'consum', 0.0216, 'lps'),
	(649504, 132, '2015-01-15 01:12:39.000000', 'consum', 0.0216, 'lps'),
	(649505, 132, '2015-01-15 01:12:40.000000', 'consum', 0.0213, 'lps'),
	(649506, 132, '2015-01-15 01:12:41.000000', 'consum', 0.0220, 'lps'),
	(649507, 132, '2015-01-15 01:12:42.000000', 'consum', 0.0217, 'lps'),
	(649508, 132, '2015-01-15 01:12:43.000000', 'consum', 0.0217, 'lps'),
	(649509, 132, '2015-01-15 01:12:44.000000', 'consum', 0.0213, 'lps'),
	(649510, 132, '2015-01-15 01:12:45.000000', 'consum', 0.0216, 'lps'),
	(649511, 132, '2015-01-15 01:12:46.000000', 'consum', 0.0218, 'lps'),
	(649512, 132, '2015-01-15 01:12:47.000000', 'consum', 0.0214, 'lps'),
	(649513, 132, '2015-01-15 01:12:48.000000', 'consum', 0.0215, 'lps'),
	(649514, 132, '2015-01-15 01:12:49.000000', 'consum', 0.0212, 'lps'),
	(649515, 132, '2015-01-15 01:12:50.000000', 'consum', 0.0219, 'lps'),
	(649516, 132, '2015-01-15 01:12:51.000000', 'consum', 0.0217, 'lps'),
	(649517, 132, '2015-01-15 01:12:52.000000', 'consum', 0.0216, 'lps'),
	(649518, 132, '2015-01-15 01:12:53.000000', 'consum', 0.0210, 'lps'),
	(649519, 132, '2015-01-15 01:12:54.000000', 'consum', 0.0214, 'lps'),
	(649520, 132, '2015-01-15 01:12:55.000000', 'consum', 0.0218, 'lps'),
	(649521, 132, '2015-01-15 01:12:56.000000', 'consum', 0.0216, 'lps'),
	(649522, 132, '2015-01-15 01:12:57.000000', 'consum', 0.0216, 'lps'),
	(649523, 132, '2015-01-15 01:12:58.000000', 'consum', 0.0213, 'lps'),
	(649524, 132, '2015-01-15 01:12:59.000000', 'consum', 0.0219, 'lps'),
	(649525, 132, '2015-01-15 01:13:00.000000', 'consum', 0.0213, 'lps'),
	(649526, 132, '2015-01-15 01:13:01.000000', 'consum', 0.0211, 'lps'),
	(649527, 132, '2015-01-15 01:13:02.000000', 'consum', 0.0214, 'lps'),
	(649528, 132, '2015-01-15 01:13:03.000000', 'consum', 0.0220, 'lps'),
	(649529, 132, '2015-01-15 01:13:04.000000', 'consum', 0.0215, 'lps'),
	(649530, 132, '2015-01-15 01:13:05.000000', 'consum', 0.0217, 'lps'),
	(649531, 132, '2015-01-15 01:13:06.000000', 'consum', 0.0219, 'lps'),
	(649532, 132, '2015-01-15 01:13:07.000000', 'consum', 0.0214, 'lps'),
	(649533, 132, '2015-01-15 01:13:08.000000', 'consum', 0.0214, 'lps'),
	(649534, 132, '2015-01-15 01:13:09.000000', 'consum', 0.0217, 'lps'),
	(649535, 132, '2015-01-15 01:13:10.000000', 'consum', 0.0211, 'lps'),
	(649536, 132, '2015-01-15 01:13:11.000000', 'consum', 0.0219, 'lps'),
	(649537, 132, '2015-01-15 01:13:12.000000', 'consum', 0.0217, 'lps'),
	(649538, 132, '2015-01-15 01:13:13.000000', 'consum', 0.0220, 'lps'),
	(649539, 132, '2015-01-15 01:13:14.000000', 'consum', 0.0217, 'lps'),
	(649540, 132, '2015-01-15 01:13:15.000000', 'consum', 0.0216, 'lps'),
	(649541, 132, '2015-01-15 01:13:16.000000', 'consum', 0.0220, 'lps'),
	(649542, 132, '2015-01-15 01:13:17.000000', 'consum', 0.0220, 'lps'),
	(649543, 132, '2015-01-15 01:13:18.000000', 'consum', 0.0220, 'lps'),
	(649544, 132, '2015-01-15 01:13:19.000000', 'consum', 0.0220, 'lps'),
	(649545, 132, '2015-01-15 01:13:20.000000', 'consum', 0.0210, 'lps'),
	(649546, 132, '2015-01-15 01:13:21.000000', 'consum', 0.0212, 'lps'),
	(649547, 132, '2015-01-15 01:13:22.000000', 'consum', 0.0219, 'lps'),
	(649548, 132, '2015-01-15 01:13:23.000000', 'consum', 0.0216, 'lps'),
	(649549, 132, '2015-01-15 01:13:24.000000', 'consum', 0.0216, 'lps'),
	(649550, 132, '2015-01-15 01:13:25.000000', 'consum', 0.0212, 'lps'),
	(649551, 132, '2015-01-15 01:13:26.000000', 'consum', 0.0213, 'lps'),
	(649552, 132, '2015-01-15 01:13:27.000000', 'consum', 0.0220, 'lps'),
	(649553, 132, '2015-01-15 01:13:28.000000', 'consum', 0.0219, 'lps'),
	(649554, 132, '2015-01-15 01:13:29.000000', 'consum', 0.0213, 'lps'),
	(649555, 132, '2015-01-15 01:13:30.000000', 'consum', 0.0211, 'lps'),
	(649556, 132, '2015-01-15 01:13:31.000000', 'consum', 0.0216, 'lps'),
	(649557, 132, '2015-01-15 01:13:32.000000', 'consum', 0.0216, 'lps'),
	(649558, 132, '2015-01-15 01:13:33.000000', 'consum', 0.0211, 'lps'),
	(649559, 132, '2015-01-15 01:13:34.000000', 'consum', 0.0210, 'lps'),
	(649560, 132, '2015-01-15 01:13:35.000000', 'consum', 0.0218, 'lps'),
	(649561, 132, '2015-01-15 01:13:36.000000', 'consum', 0.0217, 'lps'),
	(649562, 132, '2015-01-15 01:13:37.000000', 'consum', 0.0210, 'lps'),
	(649563, 132, '2015-01-15 01:13:38.000000', 'consum', 0.0211, 'lps'),
	(649564, 132, '2015-01-15 01:13:39.000000', 'consum', 0.0217, 'lps'),
	(649565, 132, '2015-01-15 01:13:40.000000', 'consum', 0.0220, 'lps'),
	(649566, 132, '2015-01-15 01:13:41.000000', 'consum', 0.0215, 'lps'),
	(649567, 132, '2015-01-15 01:13:42.000000', 'consum', 0.0220, 'lps'),
	(649568, 132, '2015-01-15 01:13:43.000000', 'consum', 0.0212, 'lps'),
	(649569, 132, '2015-01-15 01:13:44.000000', 'consum', 0.0213, 'lps'),
	(649570, 132, '2015-01-15 01:13:45.000000', 'consum', 0.0217, 'lps'),
	(649571, 132, '2015-01-15 01:13:46.000000', 'consum', 0.0214, 'lps'),
	(649572, 132, '2015-01-15 01:13:47.000000', 'consum', 0.0213, 'lps'),
	(649573, 132, '2015-01-15 01:13:48.000000', 'consum', 0.0210, 'lps'),
	(649574, 132, '2015-01-15 01:13:49.000000', 'consum', 0.0214, 'lps'),
	(649575, 132, '2015-01-15 01:13:50.000000', 'consum', 0.0218, 'lps'),
	(649576, 132, '2015-01-15 01:13:51.000000', 'consum', 0.0216, 'lps'),
	(649577, 132, '2015-01-15 01:13:52.000000', 'consum', 0.0216, 'lps'),
	(649578, 132, '2015-01-15 01:13:53.000000', 'consum', 0.0210, 'lps'),
	(649579, 132, '2015-01-15 01:13:54.000000', 'consum', 0.0218, 'lps'),
	(649580, 132, '2015-01-15 01:13:55.000000', 'consum', 0.0217, 'lps'),
	(649581, 132, '2015-01-15 01:13:56.000000', 'consum', 0.0220, 'lps'),
	(649582, 132, '2015-01-15 01:13:57.000000', 'consum', 0.0219, 'lps'),
	(649583, 132, '2015-01-15 01:13:58.000000', 'consum', 0.0213, 'lps'),
	(649584, 132, '2015-01-15 01:13:59.000000', 'consum', 0.0220, 'lps'),
	(649585, 132, '2015-01-15 01:14:00.000000', 'consum', 0.0219, 'lps'),
	(649586, 132, '2015-01-15 01:14:01.000000', 'consum', 0.0213, 'lps'),
	(649587, 132, '2015-01-15 01:14:02.000000', 'consum', 0.0220, 'lps'),
	(649588, 132, '2015-01-15 01:14:03.000000', 'consum', 0.0210, 'lps'),
	(649589, 132, '2015-01-15 01:14:04.000000', 'consum', 0.0212, 'lps'),
	(649590, 132, '2015-01-15 01:14:05.000000', 'consum', 0.0220, 'lps'),
	(649591, 132, '2015-01-15 01:14:06.000000', 'consum', 0.0213, 'lps'),
	(649592, 132, '2015-01-15 01:14:07.000000', 'consum', 0.0216, 'lps'),
	(649593, 132, '2015-01-15 01:14:08.000000', 'consum', 0.0211, 'lps'),
	(649594, 132, '2015-01-15 01:14:09.000000', 'consum', 0.0219, 'lps'),
	(649595, 132, '2015-01-15 01:14:10.000000', 'consum', 0.0219, 'lps'),
	(649596, 132, '2015-01-15 01:14:11.000000', 'consum', 0.0216, 'lps'),
	(649597, 132, '2015-01-15 01:14:12.000000', 'consum', 0.0216, 'lps'),
	(649598, 132, '2015-01-15 01:14:13.000000', 'consum', 0.0211, 'lps'),
	(649599, 132, '2015-01-15 01:14:14.000000', 'consum', 0.0220, 'lps'),
	(649600, 132, '2015-01-15 01:14:15.000000', 'consum', 0.0212, 'lps'),
	(649601, 132, '2015-01-15 01:14:16.000000', 'consum', 0.0212, 'lps'),
	(649602, 132, '2015-01-15 01:14:17.000000', 'consum', 0.0216, 'lps'),
	(649603, 132, '2015-01-15 01:14:18.000000', 'consum', 0.0213, 'lps'),
	(649604, 132, '2015-01-15 01:14:19.000000', 'consum', 0.0217, 'lps'),
	(649605, 132, '2015-01-15 01:14:20.000000', 'consum', 0.0214, 'lps'),
	(649606, 132, '2015-01-15 01:14:21.000000', 'consum', 0.0211, 'lps'),
	(649607, 132, '2015-01-15 01:14:22.000000', 'consum', 0.0215, 'lps'),
	(649608, 132, '2015-01-15 01:14:23.000000', 'consum', 0.0212, 'lps'),
	(649609, 132, '2015-01-15 01:14:24.000000', 'consum', 0.0215, 'lps'),
	(649610, 132, '2015-01-15 01:14:25.000000', 'consum', 0.0216, 'lps'),
	(649611, 132, '2015-01-15 01:14:26.000000', 'consum', 0.0218, 'lps'),
	(649612, 132, '2015-01-15 01:14:27.000000', 'consum', 0.0219, 'lps'),
	(649613, 132, '2015-01-15 01:14:28.000000', 'consum', 0.0211, 'lps'),
	(649614, 132, '2015-01-15 01:14:29.000000', 'consum', 0.0212, 'lps'),
	(649615, 132, '2015-01-15 01:14:30.000000', 'consum', 0.0215, 'lps'),
	(649616, 132, '2015-01-15 01:14:31.000000', 'consum', 0.0220, 'lps'),
	(649617, 132, '2015-01-15 01:14:32.000000', 'consum', 0.0212, 'lps'),
	(649618, 132, '2015-01-15 01:14:33.000000', 'consum', 0.0213, 'lps'),
	(649619, 132, '2015-01-15 01:14:34.000000', 'consum', 0.0220, 'lps'),
	(649620, 132, '2015-01-15 01:14:35.000000', 'consum', 0.0220, 'lps'),
	(649621, 132, '2015-01-15 01:14:36.000000', 'consum', 0.0217, 'lps'),
	(649622, 132, '2015-01-15 01:14:37.000000', 'consum', 0.0216, 'lps'),
	(649623, 132, '2015-01-15 01:14:38.000000', 'consum', 0.0219, 'lps'),
	(649624, 132, '2015-01-15 01:14:39.000000', 'consum', 0.0216, 'lps'),
	(649625, 132, '2015-01-15 01:14:40.000000', 'consum', 0.0213, 'lps'),
	(649626, 132, '2015-01-15 01:14:41.000000', 'consum', 0.0218, 'lps'),
	(649627, 132, '2015-01-15 01:14:42.000000', 'consum', 0.0219, 'lps'),
	(649628, 132, '2015-01-15 01:14:43.000000', 'consum', 0.0220, 'lps'),
	(649629, 132, '2015-01-15 01:14:44.000000', 'consum', 0.0211, 'lps'),
	(649630, 132, '2015-01-15 01:14:45.000000', 'consum', 0.0218, 'lps'),
	(649631, 132, '2015-01-15 01:14:46.000000', 'consum', 0.0217, 'lps'),
	(649632, 132, '2015-01-15 01:14:47.000000', 'consum', 0.0220, 'lps'),
	(649633, 132, '2015-01-15 01:14:48.000000', 'consum', 0.0216, 'lps'),
	(649634, 132, '2015-01-15 01:14:49.000000', 'consum', 0.0212, 'lps'),
	(649635, 132, '2015-01-15 01:14:50.000000', 'consum', 0.0213, 'lps'),
	(649636, 132, '2015-01-15 01:14:51.000000', 'consum', 0.0211, 'lps'),
	(649637, 132, '2015-01-15 01:14:52.000000', 'consum', 0.0214, 'lps'),
	(649638, 132, '2015-01-15 01:14:53.000000', 'consum', 0.0219, 'lps'),
	(649639, 132, '2015-01-15 01:14:54.000000', 'consum', 0.0210, 'lps'),
	(649640, 132, '2015-01-15 01:14:55.000000', 'consum', 0.0218, 'lps'),
	(649641, 132, '2015-01-15 01:14:56.000000', 'consum', 0.0218, 'lps'),
	(649642, 132, '2015-01-15 01:14:57.000000', 'consum', 0.0213, 'lps'),
	(649643, 132, '2015-01-15 01:14:58.000000', 'consum', 0.0214, 'lps'),
	(649644, 132, '2015-01-15 01:14:59.000000', 'consum', 0.0211, 'lps'),
	(649645, 132, '2015-01-15 01:15:00.000000', 'consum', 0.0212, 'lps'),
	(649646, 132, '2015-01-15 01:15:01.000000', 'consum', 0.0220, 'lps'),
	(649647, 132, '2015-01-15 01:15:02.000000', 'consum', 0.0219, 'lps'),
	(649648, 132, '2015-01-15 01:15:03.000000', 'consum', 0.0217, 'lps'),
	(649649, 132, '2015-01-15 01:15:04.000000', 'consum', 0.0217, 'lps'),
	(649650, 132, '2015-01-15 01:15:05.000000', 'consum', 0.0214, 'lps'),
	(649651, 132, '2015-01-15 01:15:06.000000', 'consum', 0.0211, 'lps'),
	(649652, 132, '2015-01-15 01:15:07.000000', 'consum', 0.0215, 'lps'),
	(649653, 132, '2015-01-15 01:15:08.000000', 'consum', 0.0219, 'lps'),
	(649654, 132, '2015-01-15 01:15:09.000000', 'consum', 0.0210, 'lps'),
	(649655, 132, '2015-01-15 01:15:10.000000', 'consum', 0.0214, 'lps'),
	(649656, 132, '2015-01-15 01:15:11.000000', 'consum', 0.0220, 'lps'),
	(649657, 132, '2015-01-15 01:15:12.000000', 'consum', 0.0214, 'lps'),
	(649658, 132, '2015-01-15 01:15:13.000000', 'consum', 0.0215, 'lps'),
	(649659, 132, '2015-01-15 01:15:14.000000', 'consum', 0.0210, 'lps'),
	(649660, 132, '2015-01-15 01:15:15.000000', 'consum', 0.0220, 'lps'),
	(649661, 132, '2015-01-15 01:15:16.000000', 'consum', 0.0216, 'lps'),
	(649662, 132, '2015-01-15 01:15:17.000000', 'consum', 0.0211, 'lps'),
	(649663, 132, '2015-01-15 01:15:18.000000', 'consum', 0.0220, 'lps'),
	(649664, 132, '2015-01-15 01:15:19.000000', 'consum', 0.0211, 'lps'),
	(649665, 132, '2015-01-15 01:15:20.000000', 'consum', 0.0220, 'lps'),
	(649666, 132, '2015-01-15 01:15:21.000000', 'consum', 0.0212, 'lps'),
	(649667, 132, '2015-01-15 01:15:22.000000', 'consum', 0.0215, 'lps'),
	(649668, 132, '2015-01-15 01:15:23.000000', 'consum', 0.0217, 'lps'),
	(649669, 132, '2015-01-15 01:15:24.000000', 'consum', 0.0219, 'lps'),
	(649670, 132, '2015-01-15 01:15:25.000000', 'consum', 0.0215, 'lps'),
	(649671, 132, '2015-01-15 01:15:26.000000', 'consum', 0.0217, 'lps'),
	(649672, 132, '2015-01-15 01:15:27.000000', 'consum', 0.0211, 'lps'),
	(649673, 132, '2015-01-15 01:15:28.000000', 'consum', 0.0214, 'lps'),
	(649674, 132, '2015-01-15 01:15:29.000000', 'consum', 0.0218, 'lps'),
	(649675, 132, '2015-01-15 01:15:30.000000', 'consum', 0.0214, 'lps'),
	(649676, 132, '2015-01-15 01:15:31.000000', 'consum', 0.0210, 'lps'),
	(649677, 132, '2015-01-15 01:15:32.000000', 'consum', 0.0219, 'lps'),
	(649678, 132, '2015-01-15 01:15:33.000000', 'consum', 0.0211, 'lps'),
	(649679, 132, '2015-01-15 01:15:34.000000', 'consum', 0.0210, 'lps'),
	(649680, 132, '2015-01-15 01:15:35.000000', 'consum', 0.0210, 'lps'),
	(649681, 132, '2015-01-15 01:15:36.000000', 'consum', 0.0220, 'lps'),
	(649682, 132, '2015-01-15 01:15:37.000000', 'consum', 0.0218, 'lps'),
	(649683, 132, '2015-01-15 01:15:38.000000', 'consum', 0.0218, 'lps'),
	(649684, 132, '2015-01-15 01:15:39.000000', 'consum', 0.0216, 'lps'),
	(649685, 132, '2015-01-15 01:15:40.000000', 'consum', 0.0215, 'lps'),
	(649686, 132, '2015-01-15 01:15:41.000000', 'consum', 0.0218, 'lps'),
	(649687, 132, '2015-01-15 01:15:42.000000', 'consum', 0.0214, 'lps'),
	(649688, 132, '2015-01-15 01:15:43.000000', 'consum', 0.0218, 'lps'),
	(649689, 132, '2015-01-15 01:15:44.000000', 'consum', 0.0215, 'lps'),
	(649690, 132, '2015-01-15 01:15:45.000000', 'consum', 0.0214, 'lps'),
	(649691, 132, '2015-01-15 01:15:46.000000', 'consum', 0.0216, 'lps'),
	(649692, 132, '2015-01-15 01:15:47.000000', 'consum', 0.0217, 'lps'),
	(649693, 132, '2015-01-15 01:15:48.000000', 'consum', 0.0215, 'lps'),
	(649694, 132, '2015-01-15 01:15:49.000000', 'consum', 0.0217, 'lps'),
	(649695, 132, '2015-01-15 01:15:50.000000', 'consum', 0.0217, 'lps'),
	(649696, 132, '2015-01-15 01:15:51.000000', 'consum', 0.0215, 'lps'),
	(649697, 132, '2015-01-15 01:15:52.000000', 'consum', 0.0214, 'lps'),
	(649698, 132, '2015-01-15 01:15:53.000000', 'consum', 0.0216, 'lps'),
	(649699, 132, '2015-01-15 01:15:54.000000', 'consum', 0.0218, 'lps'),
	(649700, 132, '2015-01-15 01:15:55.000000', 'consum', 0.0211, 'lps'),
	(649701, 132, '2015-01-15 01:15:56.000000', 'consum', 0.0212, 'lps'),
	(649702, 132, '2015-01-15 01:15:57.000000', 'consum', 0.0220, 'lps'),
	(649703, 132, '2015-01-15 01:15:58.000000', 'consum', 0.0220, 'lps'),
	(649704, 132, '2015-01-15 01:15:59.000000', 'consum', 0.0218, 'lps'),
	(649705, 132, '2015-01-15 01:16:00.000000', 'consum', 0.0212, 'lps'),
	(649706, 132, '2015-01-15 01:16:01.000000', 'consum', 0.0218, 'lps'),
	(649707, 132, '2015-01-15 01:16:02.000000', 'consum', 0.0213, 'lps'),
	(649708, 132, '2015-01-15 01:16:03.000000', 'consum', 0.0212, 'lps'),
	(649709, 132, '2015-01-15 01:16:04.000000', 'consum', 0.0212, 'lps'),
	(649710, 132, '2015-01-15 01:16:05.000000', 'consum', 0.0212, 'lps'),
	(649711, 132, '2015-01-15 01:16:06.000000', 'consum', 0.0216, 'lps'),
	(649712, 132, '2015-01-15 01:16:07.000000', 'consum', 0.0214, 'lps'),
	(649713, 132, '2015-01-15 01:16:08.000000', 'consum', 0.0210, 'lps'),
	(649714, 132, '2015-01-15 01:16:09.000000', 'consum', 0.0210, 'lps'),
	(649715, 132, '2015-01-15 01:16:10.000000', 'consum', 0.0210, 'lps'),
	(649716, 132, '2015-01-15 01:16:11.000000', 'consum', 0.0211, 'lps'),
	(649717, 132, '2015-01-15 01:16:12.000000', 'consum', 0.0217, 'lps'),
	(649718, 132, '2015-01-15 01:16:13.000000', 'consum', 0.0210, 'lps'),
	(649719, 132, '2015-01-15 01:16:14.000000', 'consum', 0.0210, 'lps'),
	(649720, 132, '2015-01-15 01:16:15.000000', 'consum', 0.0212, 'lps'),
	(649721, 132, '2015-01-15 01:16:16.000000', 'consum', 0.0218, 'lps'),
	(649722, 132, '2015-01-15 01:16:17.000000', 'consum', 0.0212, 'lps'),
	(649723, 132, '2015-01-15 01:16:18.000000', 'consum', 0.0220, 'lps'),
	(649724, 132, '2015-01-15 01:16:19.000000', 'consum', 0.0220, 'lps'),
	(649725, 132, '2015-01-15 01:16:20.000000', 'consum', 0.0210, 'lps'),
	(649726, 132, '2015-01-15 01:16:21.000000', 'consum', 0.0213, 'lps'),
	(649727, 132, '2015-01-15 01:16:22.000000', 'consum', 0.0213, 'lps'),
	(649728, 132, '2015-01-15 01:16:23.000000', 'consum', 0.0219, 'lps'),
	(649729, 132, '2015-01-15 01:16:24.000000', 'consum', 0.0214, 'lps'),
	(649730, 132, '2015-01-15 01:16:25.000000', 'consum', 0.0215, 'lps'),
	(649731, 132, '2015-01-15 01:16:26.000000', 'consum', 0.0213, 'lps'),
	(649732, 132, '2015-01-15 01:16:27.000000', 'consum', 0.0219, 'lps'),
	(649733, 132, '2015-01-15 01:16:28.000000', 'consum', 0.0214, 'lps'),
	(649734, 132, '2015-01-15 01:16:29.000000', 'consum', 0.0216, 'lps'),
	(649735, 132, '2015-01-15 01:16:30.000000', 'consum', 0.0215, 'lps'),
	(649736, 132, '2015-01-15 01:16:31.000000', 'consum', 0.0220, 'lps'),
	(649737, 132, '2015-01-15 01:16:32.000000', 'consum', 0.0213, 'lps'),
	(649738, 132, '2015-01-15 01:16:33.000000', 'consum', 0.0218, 'lps'),
	(649739, 132, '2015-01-15 01:16:34.000000', 'consum', 0.0210, 'lps'),
	(649740, 132, '2015-01-15 01:16:35.000000', 'consum', 0.0216, 'lps'),
	(649741, 132, '2015-01-15 01:16:36.000000', 'consum', 0.0220, 'lps'),
	(649742, 132, '2015-01-15 01:16:37.000000', 'consum', 0.0219, 'lps'),
	(649743, 132, '2015-01-15 01:16:38.000000', 'consum', 0.0213, 'lps'),
	(649744, 132, '2015-01-15 01:16:39.000000', 'consum', 0.0213, 'lps'),
	(649745, 132, '2015-01-15 01:16:40.000000', 'consum', 0.0216, 'lps'),
	(649746, 132, '2015-01-15 01:16:41.000000', 'consum', 0.0220, 'lps'),
	(649747, 132, '2015-01-15 01:16:42.000000', 'consum', 0.0220, 'lps'),
	(649748, 132, '2015-01-15 01:16:43.000000', 'consum', 0.0220, 'lps'),
	(649749, 132, '2015-01-15 01:16:44.000000', 'consum', 0.0220, 'lps'),
	(649750, 132, '2015-01-15 01:16:45.000000', 'consum', 0.0218, 'lps'),
	(649751, 132, '2015-01-15 01:16:46.000000', 'consum', 0.0220, 'lps'),
	(649752, 132, '2015-01-15 01:16:47.000000', 'consum', 0.0215, 'lps'),
	(649753, 132, '2015-01-15 01:16:48.000000', 'consum', 0.0218, 'lps'),
	(649754, 132, '2015-01-15 01:16:49.000000', 'consum', 0.0214, 'lps'),
	(649755, 132, '2015-01-15 01:16:50.000000', 'consum', 0.0215, 'lps'),
	(649756, 132, '2015-01-15 01:16:51.000000', 'consum', 0.0215, 'lps'),
	(649757, 132, '2015-01-15 01:16:52.000000', 'consum', 0.0219, 'lps'),
	(649758, 132, '2015-01-15 01:16:53.000000', 'consum', 0.0219, 'lps'),
	(649759, 132, '2015-01-15 01:16:54.000000', 'consum', 0.0218, 'lps'),
	(649760, 132, '2015-01-15 01:16:55.000000', 'consum', 0.0211, 'lps'),
	(649761, 132, '2015-01-15 01:16:56.000000', 'consum', 0.0215, 'lps'),
	(649762, 132, '2015-01-15 01:16:57.000000', 'consum', 0.0219, 'lps'),
	(649763, 132, '2015-01-15 01:16:58.000000', 'consum', 0.0210, 'lps'),
	(649764, 132, '2015-01-15 01:16:59.000000', 'consum', 0.0216, 'lps'),
	(649765, 132, '2015-01-15 01:17:00.000000', 'consum', 0.0220, 'lps'),
	(649766, 132, '2015-01-15 01:17:01.000000', 'consum', 0.0219, 'lps'),
	(649767, 132, '2015-01-15 01:17:02.000000', 'consum', 0.0214, 'lps'),
	(649768, 132, '2015-01-15 01:17:03.000000', 'consum', 0.0216, 'lps'),
	(649769, 132, '2015-01-15 01:17:04.000000', 'consum', 0.0215, 'lps'),
	(649770, 132, '2015-01-15 01:17:05.000000', 'consum', 0.0220, 'lps'),
	(649771, 132, '2015-01-15 01:17:06.000000', 'consum', 0.0213, 'lps'),
	(649772, 132, '2015-01-15 01:17:07.000000', 'consum', 0.0215, 'lps'),
	(649773, 132, '2015-01-15 01:17:08.000000', 'consum', 0.0215, 'lps'),
	(649774, 132, '2015-01-15 01:17:09.000000', 'consum', 0.0212, 'lps'),
	(649775, 132, '2015-01-15 01:17:10.000000', 'consum', 0.0217, 'lps'),
	(649776, 132, '2015-01-15 01:17:11.000000', 'consum', 0.0218, 'lps'),
	(649777, 132, '2015-01-15 01:17:12.000000', 'consum', 0.0219, 'lps'),
	(649778, 132, '2015-01-15 01:17:13.000000', 'consum', 0.0210, 'lps'),
	(649779, 132, '2015-01-15 01:17:14.000000', 'consum', 0.0213, 'lps'),
	(649780, 132, '2015-01-15 01:17:15.000000', 'consum', 0.0218, 'lps'),
	(649781, 132, '2015-01-15 01:17:16.000000', 'consum', 0.0218, 'lps'),
	(649782, 132, '2015-01-15 01:17:17.000000', 'consum', 0.0214, 'lps'),
	(649783, 132, '2015-01-15 01:17:18.000000', 'consum', 0.0218, 'lps'),
	(649784, 132, '2015-01-15 01:17:19.000000', 'consum', 0.0216, 'lps'),
	(649785, 132, '2015-01-15 01:17:20.000000', 'consum', 0.0216, 'lps'),
	(649786, 132, '2015-01-15 01:17:21.000000', 'consum', 0.0213, 'lps'),
	(649787, 132, '2015-01-15 01:17:22.000000', 'consum', 0.0218, 'lps'),
	(649788, 132, '2015-01-15 01:17:23.000000', 'consum', 0.0219, 'lps'),
	(649789, 132, '2015-01-15 01:17:24.000000', 'consum', 0.0219, 'lps'),
	(649790, 132, '2015-01-15 01:17:25.000000', 'consum', 0.0218, 'lps'),
	(649791, 132, '2015-01-15 01:17:26.000000', 'consum', 0.0212, 'lps'),
	(649792, 132, '2015-01-15 01:17:27.000000', 'consum', 0.0219, 'lps'),
	(649793, 132, '2015-01-15 01:17:28.000000', 'consum', 0.0218, 'lps'),
	(649794, 132, '2015-01-15 01:17:29.000000', 'consum', 0.0211, 'lps'),
	(649795, 132, '2015-01-15 01:17:30.000000', 'consum', 0.0213, 'lps'),
	(649796, 132, '2015-01-15 01:17:31.000000', 'consum', 0.0211, 'lps'),
	(649797, 132, '2015-01-15 01:17:32.000000', 'consum', 0.0220, 'lps'),
	(649798, 132, '2015-01-15 01:17:33.000000', 'consum', 0.0212, 'lps'),
	(649799, 132, '2015-01-15 01:17:34.000000', 'consum', 0.0213, 'lps'),
	(649800, 132, '2015-01-15 01:17:35.000000', 'consum', 0.0220, 'lps'),
	(649801, 132, '2015-01-15 01:17:36.000000', 'consum', 0.0219, 'lps'),
	(649802, 132, '2015-01-15 01:17:37.000000', 'consum', 0.0216, 'lps'),
	(649803, 132, '2015-01-15 01:17:38.000000', 'consum', 0.0210, 'lps'),
	(649804, 132, '2015-01-15 01:17:39.000000', 'consum', 0.0215, 'lps'),
	(649805, 132, '2015-01-15 01:17:40.000000', 'consum', 0.0215, 'lps'),
	(649806, 132, '2015-01-15 01:17:41.000000', 'consum', 0.0211, 'lps'),
	(649807, 132, '2015-01-15 01:17:42.000000', 'consum', 0.0210, 'lps'),
	(649808, 132, '2015-01-15 01:17:43.000000', 'consum', 0.0217, 'lps'),
	(649809, 132, '2015-01-15 01:17:44.000000', 'consum', 0.0212, 'lps'),
	(649810, 132, '2015-01-15 01:17:45.000000', 'consum', 0.0212, 'lps'),
	(649811, 132, '2015-01-15 01:17:46.000000', 'consum', 0.0213, 'lps'),
	(649812, 132, '2015-01-15 01:17:47.000000', 'consum', 0.0220, 'lps'),
	(649813, 132, '2015-01-15 01:17:48.000000', 'consum', 0.0220, 'lps'),
	(649814, 132, '2015-01-15 01:17:49.000000', 'consum', 0.0219, 'lps'),
	(649815, 132, '2015-01-15 01:17:50.000000', 'consum', 0.0213, 'lps'),
	(649816, 132, '2015-01-15 01:17:51.000000', 'consum', 0.0220, 'lps'),
	(649817, 132, '2015-01-15 01:17:52.000000', 'consum', 0.0219, 'lps'),
	(649818, 132, '2015-01-15 01:17:53.000000', 'consum', 0.0213, 'lps'),
	(649819, 132, '2015-01-15 01:17:54.000000', 'consum', 0.0211, 'lps'),
	(649820, 132, '2015-01-15 01:17:55.000000', 'consum', 0.0215, 'lps'),
	(649821, 132, '2015-01-15 01:17:56.000000', 'consum', 0.0214, 'lps'),
	(649822, 132, '2015-01-15 01:17:57.000000', 'consum', 0.0215, 'lps'),
	(649823, 132, '2015-01-15 01:17:58.000000', 'consum', 0.0211, 'lps'),
	(649824, 132, '2015-01-15 01:17:59.000000', 'consum', 0.0211, 'lps'),
	(649825, 132, '2015-01-15 01:18:00.000000', 'consum', 0.0215, 'lps'),
	(649826, 132, '2015-01-15 01:18:01.000000', 'consum', 0.0211, 'lps'),
	(649827, 132, '2015-01-15 01:18:02.000000', 'consum', 0.0211, 'lps'),
	(649828, 132, '2015-01-15 01:18:03.000000', 'consum', 0.0212, 'lps'),
	(649829, 132, '2015-01-15 01:18:04.000000', 'consum', 0.0219, 'lps'),
	(649830, 132, '2015-01-15 01:18:05.000000', 'consum', 0.0215, 'lps'),
	(649831, 132, '2015-01-15 01:18:06.000000', 'consum', 0.0218, 'lps'),
	(649832, 132, '2015-01-15 01:18:07.000000', 'consum', 0.0214, 'lps'),
	(649833, 132, '2015-01-15 01:18:08.000000', 'consum', 0.0219, 'lps'),
	(649834, 132, '2015-01-15 01:18:09.000000', 'consum', 0.0211, 'lps'),
	(649835, 132, '2015-01-15 01:18:10.000000', 'consum', 0.0219, 'lps'),
	(649836, 132, '2015-01-15 01:18:11.000000', 'consum', 0.0220, 'lps'),
	(649837, 132, '2015-01-15 01:18:12.000000', 'consum', 0.0211, 'lps'),
	(649838, 132, '2015-01-15 01:18:13.000000', 'consum', 0.0218, 'lps'),
	(649839, 132, '2015-01-15 01:18:14.000000', 'consum', 0.0215, 'lps'),
	(649840, 132, '2015-01-15 01:18:15.000000', 'consum', 0.0212, 'lps'),
	(649841, 132, '2015-01-15 01:18:16.000000', 'consum', 0.0216, 'lps'),
	(649842, 132, '2015-01-15 01:18:17.000000', 'consum', 0.0214, 'lps'),
	(649843, 132, '2015-01-15 01:18:18.000000', 'consum', 0.0213, 'lps'),
	(649844, 132, '2015-01-15 01:18:19.000000', 'consum', 0.0212, 'lps'),
	(649845, 132, '2015-01-15 01:18:20.000000', 'consum', 0.0212, 'lps'),
	(649846, 132, '2015-01-15 01:18:21.000000', 'consum', 0.0213, 'lps'),
	(649847, 132, '2015-01-15 01:18:22.000000', 'consum', 0.0220, 'lps'),
	(649848, 132, '2015-01-15 01:18:23.000000', 'consum', 0.0217, 'lps'),
	(649849, 132, '2015-01-15 01:18:24.000000', 'consum', 0.0218, 'lps'),
	(649850, 132, '2015-01-15 01:18:25.000000', 'consum', 0.0216, 'lps'),
	(649851, 132, '2015-01-15 01:18:26.000000', 'consum', 0.0217, 'lps'),
	(649852, 132, '2015-01-15 01:18:27.000000', 'consum', 0.0218, 'lps'),
	(649853, 132, '2015-01-15 01:18:28.000000', 'consum', 0.0220, 'lps'),
	(649854, 132, '2015-01-15 01:18:29.000000', 'consum', 0.0212, 'lps'),
	(649855, 132, '2015-01-15 01:18:30.000000', 'consum', 0.0214, 'lps'),
	(649856, 132, '2015-01-15 01:18:31.000000', 'consum', 0.0214, 'lps'),
	(649857, 132, '2015-01-15 01:18:32.000000', 'consum', 0.0217, 'lps'),
	(649858, 132, '2015-01-15 01:18:33.000000', 'consum', 0.0210, 'lps'),
	(649859, 132, '2015-01-15 01:18:34.000000', 'consum', 0.0213, 'lps'),
	(649860, 132, '2015-01-15 01:18:35.000000', 'consum', 0.0214, 'lps'),
	(649861, 132, '2015-01-15 01:18:36.000000', 'consum', 0.0211, 'lps'),
	(649862, 132, '2015-01-15 01:18:37.000000', 'consum', 0.0213, 'lps'),
	(649863, 132, '2015-01-15 01:18:38.000000', 'consum', 0.0212, 'lps'),
	(649864, 132, '2015-01-15 01:18:39.000000', 'consum', 0.0214, 'lps'),
	(649865, 132, '2015-01-15 01:18:40.000000', 'consum', 0.0211, 'lps'),
	(649866, 132, '2015-01-15 01:18:41.000000', 'consum', 0.0213, 'lps'),
	(649867, 132, '2015-01-15 01:18:42.000000', 'consum', 0.0214, 'lps'),
	(649868, 132, '2015-01-15 01:18:43.000000', 'consum', 0.0212, 'lps'),
	(649869, 132, '2015-01-15 01:18:44.000000', 'consum', 0.0216, 'lps'),
	(649870, 132, '2015-01-15 01:18:45.000000', 'consum', 0.0213, 'lps'),
	(649871, 132, '2015-01-15 01:18:46.000000', 'consum', 0.0210, 'lps'),
	(649872, 132, '2015-01-15 01:18:47.000000', 'consum', 0.0212, 'lps'),
	(649873, 132, '2015-01-15 01:18:48.000000', 'consum', 0.0219, 'lps'),
	(649874, 132, '2015-01-15 01:18:49.000000', 'consum', 0.0218, 'lps'),
	(649875, 132, '2015-01-15 01:18:50.000000', 'consum', 0.0212, 'lps'),
	(649876, 132, '2015-01-15 01:18:51.000000', 'consum', 0.0217, 'lps'),
	(649877, 132, '2015-01-15 01:18:52.000000', 'consum', 0.0218, 'lps'),
	(649878, 132, '2015-01-15 01:18:53.000000', 'consum', 0.0218, 'lps'),
	(649879, 132, '2015-01-15 01:18:54.000000', 'consum', 0.0216, 'lps'),
	(649880, 132, '2015-01-15 01:18:55.000000', 'consum', 0.0218, 'lps'),
	(649881, 132, '2015-01-15 01:18:56.000000', 'consum', 0.0220, 'lps'),
	(649882, 132, '2015-01-15 01:18:57.000000', 'consum', 0.0216, 'lps'),
	(649883, 132, '2015-01-15 01:18:58.000000', 'consum', 0.0219, 'lps'),
	(649884, 132, '2015-01-15 01:18:59.000000', 'consum', 0.0217, 'lps'),
	(649885, 132, '2015-01-15 01:19:00.000000', 'consum', 0.0216, 'lps'),
	(649886, 132, '2015-01-15 01:19:01.000000', 'consum', 0.0211, 'lps'),
	(649887, 132, '2015-01-15 01:19:02.000000', 'consum', 0.0220, 'lps'),
	(649888, 132, '2015-01-15 01:19:03.000000', 'consum', 0.0214, 'lps'),
	(649889, 132, '2015-01-15 01:19:04.000000', 'consum', 0.0211, 'lps'),
	(649890, 132, '2015-01-15 01:19:05.000000', 'consum', 0.0216, 'lps'),
	(649891, 132, '2015-01-15 01:19:06.000000', 'consum', 0.0212, 'lps'),
	(649892, 132, '2015-01-15 01:19:07.000000', 'consum', 0.0217, 'lps'),
	(649893, 132, '2015-01-15 01:19:08.000000', 'consum', 0.0214, 'lps'),
	(649894, 132, '2015-01-15 01:19:09.000000', 'consum', 0.0213, 'lps'),
	(649895, 132, '2015-01-15 01:19:10.000000', 'consum', 0.0211, 'lps'),
	(649896, 132, '2015-01-15 01:19:11.000000', 'consum', 0.0220, 'lps'),
	(649897, 132, '2015-01-15 01:19:12.000000', 'consum', 0.0214, 'lps'),
	(649898, 132, '2015-01-15 01:19:13.000000', 'consum', 0.0210, 'lps'),
	(649899, 132, '2015-01-15 01:19:14.000000', 'consum', 0.0210, 'lps'),
	(649900, 132, '2015-01-15 01:19:15.000000', 'consum', 0.0211, 'lps'),
	(649901, 132, '2015-01-15 01:19:16.000000', 'consum', 0.0214, 'lps'),
	(649902, 132, '2015-01-15 01:19:17.000000', 'consum', 0.0218, 'lps'),
	(649903, 132, '2015-01-15 01:19:18.000000', 'consum', 0.0215, 'lps'),
	(649904, 132, '2015-01-15 01:19:19.000000', 'consum', 0.0213, 'lps'),
	(649905, 132, '2015-01-15 01:19:20.000000', 'consum', 0.0219, 'lps'),
	(649906, 132, '2015-01-15 01:19:21.000000', 'consum', 0.0217, 'lps'),
	(649907, 132, '2015-01-15 01:19:22.000000', 'consum', 0.0215, 'lps'),
	(649908, 132, '2015-01-15 01:19:23.000000', 'consum', 0.0215, 'lps'),
	(649909, 132, '2015-01-15 01:19:24.000000', 'consum', 0.0212, 'lps'),
	(649910, 132, '2015-01-15 01:19:25.000000', 'consum', 0.0214, 'lps'),
	(649911, 132, '2015-01-15 01:19:26.000000', 'consum', 0.0213, 'lps'),
	(649912, 132, '2015-01-15 01:19:27.000000', 'consum', 0.0214, 'lps'),
	(649913, 132, '2015-01-15 01:19:28.000000', 'consum', 0.0213, 'lps'),
	(649914, 132, '2015-01-15 01:19:29.000000', 'consum', 0.0210, 'lps'),
	(649915, 132, '2015-01-15 01:19:30.000000', 'consum', 0.0214, 'lps'),
	(649916, 132, '2015-01-15 01:19:31.000000', 'consum', 0.0210, 'lps'),
	(649917, 132, '2015-01-15 01:19:32.000000', 'consum', 0.0220, 'lps'),
	(649918, 132, '2015-01-15 01:19:33.000000', 'consum', 0.0216, 'lps'),
	(649919, 132, '2015-01-15 01:19:34.000000', 'consum', 0.0212, 'lps'),
	(649920, 132, '2015-01-15 01:19:35.000000', 'consum', 0.0213, 'lps'),
	(649921, 132, '2015-01-15 01:19:36.000000', 'consum', 0.0218, 'lps'),
	(649922, 132, '2015-01-15 01:19:37.000000', 'consum', 0.0219, 'lps'),
	(649923, 132, '2015-01-15 01:19:38.000000', 'consum', 0.0220, 'lps'),
	(649924, 132, '2015-01-15 01:19:39.000000', 'consum', 0.0211, 'lps'),
	(649925, 132, '2015-01-15 01:19:40.000000', 'consum', 0.0210, 'lps'),
	(649926, 132, '2015-01-15 01:19:41.000000', 'consum', 0.0216, 'lps'),
	(649927, 132, '2015-01-15 01:19:42.000000', 'consum', 0.0210, 'lps'),
	(649928, 132, '2015-01-15 01:19:43.000000', 'consum', 0.0212, 'lps'),
	(649929, 132, '2015-01-15 01:19:44.000000', 'consum', 0.0211, 'lps'),
	(649930, 132, '2015-01-15 01:19:45.000000', 'consum', 0.0211, 'lps'),
	(649931, 132, '2015-01-15 01:19:46.000000', 'consum', 0.0210, 'lps'),
	(649932, 132, '2015-01-15 01:19:47.000000', 'consum', 0.0220, 'lps'),
	(649933, 132, '2015-01-15 01:19:48.000000', 'consum', 0.0216, 'lps'),
	(649934, 132, '2015-01-15 01:19:49.000000', 'consum', 0.0220, 'lps'),
	(649935, 132, '2015-01-15 01:19:50.000000', 'consum', 0.0211, 'lps'),
	(649936, 132, '2015-01-15 01:19:51.000000', 'consum', 0.0217, 'lps'),
	(649937, 132, '2015-01-15 01:19:52.000000', 'consum', 0.0212, 'lps'),
	(649938, 132, '2015-01-15 01:19:53.000000', 'consum', 0.0218, 'lps'),
	(649939, 132, '2015-01-15 01:19:54.000000', 'consum', 0.0215, 'lps'),
	(649940, 132, '2015-01-15 01:19:55.000000', 'consum', 0.0210, 'lps'),
	(649941, 132, '2015-01-15 01:19:56.000000', 'consum', 0.0218, 'lps'),
	(649942, 132, '2015-01-15 01:19:57.000000', 'consum', 0.0217, 'lps'),
	(649943, 132, '2015-01-15 01:19:58.000000', 'consum', 0.0211, 'lps'),
	(649944, 132, '2015-01-15 01:19:59.000000', 'consum', 0.0215, 'lps'),
	(649945, 132, '2015-01-15 01:20:00.000000', 'consum', 0.0213, 'lps'),
	(649946, 132, '2015-01-15 01:20:01.000000', 'consum', 0.0219, 'lps'),
	(649947, 132, '2015-01-15 01:20:02.000000', 'consum', 0.0215, 'lps'),
	(649948, 132, '2015-01-15 01:20:03.000000', 'consum', 0.0217, 'lps'),
	(649949, 132, '2015-01-15 01:20:04.000000', 'consum', 0.0211, 'lps'),
	(649950, 132, '2015-01-15 01:20:05.000000', 'consum', 0.0217, 'lps'),
	(649951, 132, '2015-01-15 01:20:06.000000', 'consum', 0.0220, 'lps'),
	(649952, 132, '2015-01-15 01:20:07.000000', 'consum', 0.0217, 'lps'),
	(649953, 132, '2015-01-15 01:20:08.000000', 'consum', 0.0216, 'lps'),
	(649954, 132, '2015-01-15 01:20:09.000000', 'consum', 0.0217, 'lps'),
	(649955, 132, '2015-01-15 01:20:10.000000', 'consum', 0.0219, 'lps'),
	(649956, 132, '2015-01-15 01:20:11.000000', 'consum', 0.0211, 'lps'),
	(649957, 132, '2015-01-15 01:20:12.000000', 'consum', 0.0211, 'lps'),
	(649958, 132, '2015-01-15 01:20:13.000000', 'consum', 0.0212, 'lps'),
	(649959, 132, '2015-01-15 01:20:14.000000', 'consum', 0.0218, 'lps'),
	(649960, 132, '2015-01-15 01:20:15.000000', 'consum', 0.0213, 'lps'),
	(649961, 132, '2015-01-15 01:20:16.000000', 'consum', 0.0213, 'lps'),
	(649962, 132, '2015-01-15 01:20:17.000000', 'consum', 0.0217, 'lps'),
	(649963, 132, '2015-01-15 01:20:18.000000', 'consum', 0.0214, 'lps'),
	(649964, 132, '2015-01-15 01:20:19.000000', 'consum', 0.0210, 'lps'),
	(649965, 132, '2015-01-15 01:20:20.000000', 'consum', 0.0210, 'lps'),
	(649966, 132, '2015-01-15 01:20:21.000000', 'consum', 0.0211, 'lps'),
	(649967, 132, '2015-01-15 01:20:22.000000', 'consum', 0.0215, 'lps'),
	(649968, 132, '2015-01-15 01:20:23.000000', 'consum', 0.0212, 'lps'),
	(649969, 132, '2015-01-15 01:20:24.000000', 'consum', 0.0215, 'lps'),
	(649970, 132, '2015-01-15 01:20:25.000000', 'consum', 0.0218, 'lps'),
	(649971, 132, '2015-01-15 01:20:26.000000', 'consum', 0.0215, 'lps'),
	(649972, 132, '2015-01-15 01:20:27.000000', 'consum', 0.0211, 'lps'),
	(649973, 132, '2015-01-15 01:20:28.000000', 'consum', 0.0212, 'lps'),
	(649974, 132, '2015-01-15 01:20:29.000000', 'consum', 0.0219, 'lps'),
	(649975, 132, '2015-01-15 01:20:30.000000', 'consum', 0.0214, 'lps'),
	(649976, 132, '2015-01-15 01:20:31.000000', 'consum', 0.0214, 'lps'),
	(649977, 132, '2015-01-15 01:20:32.000000', 'consum', 0.0219, 'lps'),
	(649978, 132, '2015-01-15 01:20:33.000000', 'consum', 0.0213, 'lps'),
	(649979, 132, '2015-01-15 01:20:34.000000', 'consum', 0.0218, 'lps'),
	(649980, 132, '2015-01-15 01:20:35.000000', 'consum', 0.0210, 'lps'),
	(649981, 132, '2015-01-15 01:20:36.000000', 'consum', 0.0220, 'lps'),
	(649982, 132, '2015-01-15 01:20:37.000000', 'consum', 0.0216, 'lps'),
	(649983, 132, '2015-01-15 01:20:38.000000', 'consum', 0.0211, 'lps'),
	(649984, 132, '2015-01-15 01:20:39.000000', 'consum', 0.0219, 'lps'),
	(649985, 132, '2015-01-15 01:20:40.000000', 'consum', 0.0220, 'lps'),
	(649986, 132, '2015-01-15 01:20:41.000000', 'consum', 0.0220, 'lps'),
	(649987, 132, '2015-01-15 01:20:42.000000', 'consum', 0.0212, 'lps'),
	(649988, 132, '2015-01-15 01:20:43.000000', 'consum', 0.0210, 'lps'),
	(649989, 132, '2015-01-15 01:20:44.000000', 'consum', 0.0215, 'lps'),
	(649990, 132, '2015-01-15 01:20:45.000000', 'consum', 0.0216, 'lps'),
	(649991, 132, '2015-01-15 01:20:46.000000', 'consum', 0.0212, 'lps'),
	(649992, 132, '2015-01-15 01:20:47.000000', 'consum', 0.0214, 'lps'),
	(649993, 132, '2015-01-15 01:20:48.000000', 'consum', 0.0214, 'lps'),
	(649994, 132, '2015-01-15 01:20:49.000000', 'consum', 0.0220, 'lps'),
	(649995, 132, '2015-01-15 01:20:50.000000', 'consum', 0.0215, 'lps'),
	(649996, 132, '2015-01-15 01:20:51.000000', 'consum', 0.0215, 'lps'),
	(649997, 132, '2015-01-15 01:20:52.000000', 'consum', 0.0220, 'lps'),
	(649998, 132, '2015-01-15 01:20:53.000000', 'consum', 0.0214, 'lps'),
	(649999, 132, '2015-01-15 01:20:54.000000', 'consum', 0.0210, 'lps'),
	(650000, 132, '2015-01-15 01:20:55.000000', 'consum', 0.0212, 'lps'),
	(650001, 132, '2015-01-15 01:20:56.000000', 'consum', 0.0219, 'lps'),
	(650002, 132, '2015-01-15 01:20:57.000000', 'consum', 0.0219, 'lps'),
	(650003, 132, '2015-01-15 01:20:58.000000', 'consum', 0.0214, 'lps'),
	(650004, 132, '2015-01-15 01:20:59.000000', 'consum', 0.0215, 'lps'),
	(650005, 132, '2015-01-15 01:21:00.000000', 'consum', 0.0215, 'lps'),
	(650006, 132, '2015-01-15 01:21:01.000000', 'consum', 0.0220, 'lps'),
	(650007, 132, '2015-01-15 01:21:02.000000', 'consum', 0.0212, 'lps'),
	(650008, 132, '2015-01-15 01:21:03.000000', 'consum', 0.0212, 'lps'),
	(650009, 132, '2015-01-15 01:21:04.000000', 'consum', 0.0213, 'lps'),
	(650010, 132, '2015-01-15 01:21:05.000000', 'consum', 0.0219, 'lps'),
	(650011, 132, '2015-01-15 01:21:06.000000', 'consum', 0.0216, 'lps'),
	(650012, 132, '2015-01-15 01:21:07.000000', 'consum', 0.0213, 'lps'),
	(650013, 132, '2015-01-15 01:21:08.000000', 'consum', 0.0217, 'lps'),
	(650014, 132, '2015-01-15 01:21:09.000000', 'consum', 0.0214, 'lps'),
	(650015, 132, '2015-01-15 01:21:10.000000', 'consum', 0.0220, 'lps'),
	(650016, 132, '2015-01-15 01:21:11.000000', 'consum', 0.0216, 'lps'),
	(650017, 132, '2015-01-15 01:21:12.000000', 'consum', 0.0210, 'lps'),
	(650018, 132, '2015-01-15 01:21:13.000000', 'consum', 0.0216, 'lps'),
	(650019, 132, '2015-01-15 01:21:14.000000', 'consum', 0.0216, 'lps'),
	(650020, 132, '2015-01-15 01:21:15.000000', 'consum', 0.0214, 'lps'),
	(650021, 132, '2015-01-15 01:21:16.000000', 'consum', 0.0211, 'lps'),
	(650022, 132, '2015-01-15 01:21:17.000000', 'consum', 0.0217, 'lps'),
	(650023, 132, '2015-01-15 01:21:18.000000', 'consum', 0.0218, 'lps'),
	(650024, 132, '2015-01-15 01:21:19.000000', 'consum', 0.0217, 'lps'),
	(650025, 132, '2015-01-15 01:21:20.000000', 'consum', 0.0214, 'lps'),
	(650026, 132, '2015-01-15 01:21:21.000000', 'consum', 0.0219, 'lps'),
	(650027, 132, '2015-01-15 01:21:22.000000', 'consum', 0.0210, 'lps'),
	(650028, 132, '2015-01-15 01:21:23.000000', 'consum', 0.0217, 'lps'),
	(650029, 132, '2015-01-15 01:21:24.000000', 'consum', 0.0212, 'lps'),
	(650030, 132, '2015-01-15 01:21:25.000000', 'consum', 0.0211, 'lps'),
	(650031, 132, '2015-01-15 01:21:26.000000', 'consum', 0.0220, 'lps'),
	(650032, 132, '2015-01-15 01:21:27.000000', 'consum', 0.0212, 'lps'),
	(650033, 132, '2015-01-15 01:21:28.000000', 'consum', 0.0212, 'lps'),
	(650034, 132, '2015-01-15 01:21:29.000000', 'consum', 0.0218, 'lps'),
	(650035, 132, '2015-01-15 01:21:30.000000', 'consum', 0.0220, 'lps'),
	(650036, 132, '2015-01-15 01:21:31.000000', 'consum', 0.0215, 'lps'),
	(650037, 132, '2015-01-15 01:21:32.000000', 'consum', 0.0216, 'lps'),
	(650038, 132, '2015-01-15 01:21:33.000000', 'consum', 0.0216, 'lps'),
	(650039, 132, '2015-01-15 01:21:34.000000', 'consum', 0.0211, 'lps'),
	(650040, 132, '2015-01-15 01:21:35.000000', 'consum', 0.0210, 'lps'),
	(650041, 132, '2015-01-15 01:21:36.000000', 'consum', 0.0218, 'lps'),
	(650042, 132, '2015-01-15 01:21:37.000000', 'consum', 0.0217, 'lps'),
	(650043, 132, '2015-01-15 01:21:38.000000', 'consum', 0.0210, 'lps'),
	(650044, 132, '2015-01-15 01:21:39.000000', 'consum', 0.0211, 'lps'),
	(650045, 132, '2015-01-15 01:21:40.000000', 'consum', 0.0216, 'lps'),
	(650046, 132, '2015-01-15 01:21:41.000000', 'consum', 0.0216, 'lps'),
	(650047, 132, '2015-01-15 01:21:42.000000', 'consum', 0.0211, 'lps'),
	(650048, 132, '2015-01-15 01:21:43.000000', 'consum', 0.0210, 'lps'),
	(650049, 132, '2015-01-15 01:21:44.000000', 'consum', 0.0217, 'lps'),
	(650050, 132, '2015-01-15 01:21:45.000000', 'consum', 0.0215, 'lps'),
	(650051, 132, '2015-01-15 01:21:46.000000', 'consum', 0.0213, 'lps'),
	(650052, 132, '2015-01-15 01:21:47.000000', 'consum', 0.0220, 'lps'),
	(650053, 132, '2015-01-15 01:21:48.000000', 'consum', 0.0218, 'lps'),
	(650054, 132, '2015-01-15 01:21:49.000000', 'consum', 0.0211, 'lps'),
	(650055, 132, '2015-01-15 01:21:50.000000', 'consum', 0.0212, 'lps'),
	(650056, 132, '2015-01-15 01:21:51.000000', 'consum', 0.0217, 'lps'),
	(650057, 132, '2015-01-15 01:21:52.000000', 'consum', 0.0219, 'lps'),
	(650058, 132, '2015-01-15 01:21:53.000000', 'consum', 0.0210, 'lps'),
	(650059, 132, '2015-01-15 01:21:54.000000', 'consum', 0.0219, 'lps'),
	(650060, 132, '2015-01-15 01:21:55.000000', 'consum', 0.0210, 'lps'),
	(650061, 132, '2015-01-15 01:21:56.000000', 'consum', 0.0216, 'lps'),
	(650062, 132, '2015-01-15 01:21:57.000000', 'consum', 0.0210, 'lps'),
	(650063, 132, '2015-01-15 01:21:58.000000', 'consum', 0.0215, 'lps'),
	(650064, 132, '2015-01-15 01:21:59.000000', 'consum', 0.0211, 'lps'),
	(650065, 132, '2015-01-15 01:22:00.000000', 'consum', 0.0214, 'lps'),
	(650066, 132, '2015-01-15 01:22:01.000000', 'consum', 0.0216, 'lps'),
	(650067, 132, '2015-01-15 01:22:02.000000', 'consum', 0.0215, 'lps'),
	(650068, 132, '2015-01-15 01:22:03.000000', 'consum', 0.0220, 'lps'),
	(650069, 132, '2015-01-15 01:22:04.000000', 'consum', 0.0211, 'lps'),
	(650070, 132, '2015-01-15 01:22:05.000000', 'consum', 0.0219, 'lps'),
	(650071, 132, '2015-01-15 01:22:06.000000', 'consum', 0.0210, 'lps'),
	(650072, 132, '2015-01-15 01:22:07.000000', 'consum', 0.0215, 'lps'),
	(650073, 132, '2015-01-15 01:22:08.000000', 'consum', 0.0213, 'lps'),
	(650074, 132, '2015-01-15 01:22:09.000000', 'consum', 0.0210, 'lps'),
	(650075, 132, '2015-01-15 01:22:10.000000', 'consum', 0.0212, 'lps'),
	(650076, 132, '2015-01-15 01:22:11.000000', 'consum', 0.0210, 'lps'),
	(650077, 132, '2015-01-15 01:22:12.000000', 'consum', 0.0218, 'lps'),
	(650078, 132, '2015-01-15 01:22:13.000000', 'consum', 0.0215, 'lps'),
	(650079, 132, '2015-01-15 01:22:14.000000', 'consum', 0.0212, 'lps'),
	(650080, 132, '2015-01-15 01:22:15.000000', 'consum', 0.0215, 'lps'),
	(650081, 132, '2015-01-15 01:22:16.000000', 'consum', 0.0218, 'lps'),
	(650082, 132, '2015-01-15 01:22:17.000000', 'consum', 0.0213, 'lps'),
	(650083, 132, '2015-01-15 01:22:18.000000', 'consum', 0.0213, 'lps'),
	(650084, 132, '2015-01-15 01:22:19.000000', 'consum', 0.0215, 'lps'),
	(650085, 132, '2015-01-15 01:22:20.000000', 'consum', 0.0218, 'lps'),
	(650086, 132, '2015-01-15 01:22:21.000000', 'consum', 0.0212, 'lps'),
	(650087, 132, '2015-01-15 01:22:22.000000', 'consum', 0.0218, 'lps'),
	(650088, 132, '2015-01-15 01:22:23.000000', 'consum', 0.0214, 'lps'),
	(650089, 132, '2015-01-15 01:22:24.000000', 'consum', 0.0215, 'lps'),
	(650090, 132, '2015-01-15 01:22:25.000000', 'consum', 0.0215, 'lps'),
	(650091, 132, '2015-01-15 01:22:26.000000', 'consum', 0.0210, 'lps'),
	(650092, 132, '2015-01-15 01:22:27.000000', 'consum', 0.0218, 'lps'),
	(650093, 132, '2015-01-15 01:22:28.000000', 'consum', 0.0215, 'lps'),
	(650094, 132, '2015-01-15 01:22:29.000000', 'consum', 0.0211, 'lps'),
	(650095, 132, '2015-01-15 01:22:30.000000', 'consum', 0.0213, 'lps'),
	(650096, 132, '2015-01-15 01:22:31.000000', 'consum', 0.0210, 'lps'),
	(650097, 132, '2015-01-15 01:22:32.000000', 'consum', 0.0213, 'lps'),
	(650098, 132, '2015-01-15 01:22:33.000000', 'consum', 0.0214, 'lps'),
	(650099, 132, '2015-01-15 01:22:34.000000', 'consum', 0.0210, 'lps'),
	(650100, 132, '2015-01-15 01:22:35.000000', 'consum', 0.0220, 'lps'),
	(650101, 132, '2015-01-15 01:22:36.000000', 'consum', 0.0219, 'lps'),
	(650102, 132, '2015-01-15 01:22:37.000000', 'consum', 0.0214, 'lps'),
	(650103, 132, '2015-01-15 01:22:38.000000', 'consum', 0.0215, 'lps'),
	(650104, 132, '2015-01-15 01:22:39.000000', 'consum', 0.0212, 'lps'),
	(650105, 132, '2015-01-15 01:22:40.000000', 'consum', 0.0218, 'lps'),
	(650106, 132, '2015-01-15 01:22:41.000000', 'consum', 0.0212, 'lps'),
	(650107, 132, '2015-01-15 01:22:42.000000', 'consum', 0.0216, 'lps'),
	(650108, 132, '2015-01-15 01:22:43.000000', 'consum', 0.0212, 'lps'),
	(650109, 132, '2015-01-15 01:22:44.000000', 'consum', 0.0213, 'lps'),
	(650110, 132, '2015-01-15 01:22:45.000000', 'consum', 0.0211, 'lps'),
	(650111, 132, '2015-01-15 01:22:46.000000', 'consum', 0.0215, 'lps'),
	(650112, 132, '2015-01-15 01:22:47.000000', 'consum', 0.0212, 'lps'),
	(650113, 132, '2015-01-15 01:22:48.000000', 'consum', 0.0215, 'lps'),
	(650114, 132, '2015-01-15 01:22:49.000000', 'consum', 0.0218, 'lps'),
	(650115, 132, '2015-01-15 01:22:50.000000', 'consum', 0.0213, 'lps'),
	(650116, 132, '2015-01-15 01:22:51.000000', 'consum', 0.0212, 'lps'),
	(650117, 132, '2015-01-15 01:22:52.000000', 'consum', 0.0213, 'lps'),
	(650118, 132, '2015-01-15 01:22:53.000000', 'consum', 0.0219, 'lps'),
	(650119, 132, '2015-01-15 01:22:54.000000', 'consum', 0.0215, 'lps'),
	(650120, 132, '2015-01-15 01:22:55.000000', 'consum', 0.0218, 'lps'),
	(650121, 132, '2015-01-15 01:22:56.000000', 'consum', 0.0214, 'lps'),
	(650122, 132, '2015-01-15 01:22:57.000000', 'consum', 0.0219, 'lps'),
	(650123, 132, '2015-01-15 01:22:58.000000', 'consum', 0.0211, 'lps'),
	(650124, 132, '2015-01-15 01:22:59.000000', 'consum', 0.0220, 'lps'),
	(650125, 132, '2015-01-15 01:23:00.000000', 'consum', 0.0213, 'lps'),
	(650126, 132, '2015-01-15 01:23:01.000000', 'consum', 0.0218, 'lps'),
	(650127, 132, '2015-01-15 01:23:02.000000', 'consum', 0.0210, 'lps'),
	(650128, 132, '2015-01-15 01:23:03.000000', 'consum', 0.0219, 'lps'),
	(650129, 132, '2015-01-15 01:23:04.000000', 'consum', 0.0213, 'lps'),
	(650130, 132, '2015-01-15 01:23:05.000000', 'consum', 0.0217, 'lps'),
	(650131, 132, '2015-01-15 01:23:06.000000', 'consum', 0.0218, 'lps'),
	(650132, 132, '2015-01-15 01:23:07.000000', 'consum', 0.0216, 'lps'),
	(650133, 132, '2015-01-15 01:23:08.000000', 'consum', 0.0218, 'lps'),
	(650134, 132, '2015-01-15 01:23:09.000000', 'consum', 0.0219, 'lps'),
	(650135, 132, '2015-01-15 01:23:10.000000', 'consum', 0.0210, 'lps'),
	(650136, 132, '2015-01-15 01:23:11.000000', 'consum', 0.0219, 'lps'),
	(650137, 132, '2015-01-15 01:23:12.000000', 'consum', 0.0210, 'lps'),
	(650138, 132, '2015-01-15 01:23:13.000000', 'consum', 0.0217, 'lps'),
	(650139, 132, '2015-01-15 01:23:14.000000', 'consum', 0.0212, 'lps'),
	(650140, 132, '2015-01-15 01:23:15.000000', 'consum', 0.0220, 'lps'),
	(650141, 132, '2015-01-15 01:23:16.000000', 'consum', 0.0211, 'lps'),
	(650142, 132, '2015-01-15 01:23:17.000000', 'consum', 0.0219, 'lps'),
	(650143, 132, '2015-01-15 01:23:18.000000', 'consum', 0.0218, 'lps'),
	(650144, 132, '2015-01-15 01:23:19.000000', 'consum', 0.0212, 'lps'),
	(650145, 132, '2015-01-15 01:23:20.000000', 'consum', 0.0211, 'lps'),
	(650146, 132, '2015-01-15 01:23:21.000000', 'consum', 0.0217, 'lps'),
	(650147, 132, '2015-01-15 01:23:22.000000', 'consum', 0.0210, 'lps'),
	(650148, 132, '2015-01-15 01:23:23.000000', 'consum', 0.0212, 'lps'),
	(650149, 132, '2015-01-15 01:23:24.000000', 'consum', 0.0210, 'lps'),
	(650150, 132, '2015-01-15 01:23:25.000000', 'consum', 0.0217, 'lps'),
	(650151, 132, '2015-01-15 01:23:26.000000', 'consum', 0.0212, 'lps'),
	(650152, 132, '2015-01-15 01:23:27.000000', 'consum', 0.0211, 'lps'),
	(650153, 132, '2015-01-15 01:23:28.000000', 'consum', 0.0210, 'lps'),
	(650154, 132, '2015-01-15 01:23:29.000000', 'consum', 0.0218, 'lps'),
	(650155, 132, '2015-01-15 01:23:30.000000', 'consum', 0.0217, 'lps'),
	(650156, 132, '2015-01-15 01:23:31.000000', 'consum', 0.0211, 'lps'),
	(650157, 132, '2015-01-15 01:23:32.000000', 'consum', 0.0217, 'lps'),
	(650158, 132, '2015-01-15 01:23:33.000000', 'consum', 0.0220, 'lps'),
	(650159, 132, '2015-01-15 01:23:34.000000', 'consum', 0.0219, 'lps'),
	(650160, 132, '2015-01-15 01:23:35.000000', 'consum', 0.0212, 'lps'),
	(650161, 132, '2015-01-15 01:23:36.000000', 'consum', 0.0218, 'lps'),
	(650162, 132, '2015-01-15 01:23:37.000000', 'consum', 0.0212, 'lps'),
	(650163, 132, '2015-01-15 01:23:38.000000', 'consum', 0.0218, 'lps'),
	(650164, 132, '2015-01-15 01:23:39.000000', 'consum', 0.0220, 'lps'),
	(650165, 132, '2015-01-15 01:23:40.000000', 'consum', 0.0217, 'lps'),
	(650166, 132, '2015-01-15 01:23:41.000000', 'consum', 0.0215, 'lps'),
	(650167, 132, '2015-01-15 01:23:42.000000', 'consum', 0.0216, 'lps'),
	(650168, 132, '2015-01-15 01:23:43.000000', 'consum', 0.0215, 'lps'),
	(650169, 132, '2015-01-15 01:23:44.000000', 'consum', 0.0214, 'lps'),
	(650170, 132, '2015-01-15 01:23:45.000000', 'consum', 0.0219, 'lps'),
	(650171, 132, '2015-01-15 01:23:46.000000', 'consum', 0.0210, 'lps'),
	(650172, 132, '2015-01-15 01:23:47.000000', 'consum', 0.0216, 'lps'),
	(650173, 132, '2015-01-15 01:23:48.000000', 'consum', 0.0219, 'lps'),
	(650174, 132, '2015-01-15 01:23:49.000000', 'consum', 0.0216, 'lps'),
	(650175, 132, '2015-01-15 01:23:50.000000', 'consum', 0.0214, 'lps'),
	(650176, 132, '2015-01-15 01:23:51.000000', 'consum', 0.0210, 'lps'),
	(650177, 132, '2015-01-15 01:23:52.000000', 'consum', 0.0213, 'lps'),
	(650178, 132, '2015-01-15 01:23:53.000000', 'consum', 0.0211, 'lps'),
	(650179, 132, '2015-01-15 01:23:54.000000', 'consum', 0.0210, 'lps'),
	(650180, 132, '2015-01-15 01:23:55.000000', 'consum', 0.0217, 'lps'),
	(650181, 132, '2015-01-15 01:23:56.000000', 'consum', 0.0210, 'lps'),
	(650182, 132, '2015-01-15 01:23:57.000000', 'consum', 0.0215, 'lps'),
	(650183, 132, '2015-01-15 01:23:58.000000', 'consum', 0.0211, 'lps'),
	(650184, 132, '2015-01-15 01:23:59.000000', 'consum', 0.0213, 'lps'),
	(650185, 132, '2015-01-15 01:24:00.000000', 'consum', 0.0212, 'lps'),
	(650186, 132, '2015-01-15 01:24:01.000000', 'consum', 0.0210, 'lps'),
	(650187, 132, '2015-01-15 01:24:02.000000', 'consum', 0.0216, 'lps'),
	(650188, 132, '2015-01-15 01:24:03.000000', 'consum', 0.0217, 'lps'),
	(650189, 132, '2015-01-15 01:24:04.000000', 'consum', 0.0218, 'lps'),
	(650190, 132, '2015-01-15 01:24:05.000000', 'consum', 0.0217, 'lps'),
	(650191, 132, '2015-01-15 01:24:06.000000', 'consum', 0.0213, 'lps'),
	(650192, 132, '2015-01-15 01:24:07.000000', 'consum', 0.0212, 'lps'),
	(650193, 132, '2015-01-15 01:24:08.000000', 'consum', 0.0215, 'lps'),
	(650194, 132, '2015-01-15 01:24:09.000000', 'consum', 0.0216, 'lps'),
	(650195, 132, '2015-01-15 01:24:10.000000', 'consum', 0.0214, 'lps'),
	(650196, 132, '2015-01-15 01:24:11.000000', 'consum', 0.0213, 'lps'),
	(650197, 132, '2015-01-15 01:24:12.000000', 'consum', 0.0213, 'lps'),
	(650198, 132, '2015-01-15 01:24:13.000000', 'consum', 0.0218, 'lps'),
	(650199, 132, '2015-01-15 01:24:14.000000', 'consum', 0.0217, 'lps'),
	(650200, 132, '2015-01-15 01:24:15.000000', 'consum', 0.0213, 'lps'),
	(650201, 132, '2015-01-15 01:24:16.000000', 'consum', 0.0215, 'lps'),
	(650202, 132, '2015-01-15 01:24:17.000000', 'consum', 0.0216, 'lps'),
	(650203, 132, '2015-01-15 01:24:18.000000', 'consum', 0.0213, 'lps'),
	(650204, 132, '2015-01-15 01:24:19.000000', 'consum', 0.0218, 'lps'),
	(650205, 132, '2015-01-15 01:24:20.000000', 'consum', 0.0211, 'lps'),
	(650206, 132, '2015-01-15 01:24:21.000000', 'consum', 0.0212, 'lps'),
	(650207, 132, '2015-01-15 01:24:22.000000', 'consum', 0.0217, 'lps'),
	(650208, 132, '2015-01-15 01:24:23.000000', 'consum', 0.0217, 'lps'),
	(650209, 132, '2015-01-15 01:24:24.000000', 'consum', 0.0214, 'lps'),
	(650210, 132, '2015-01-15 01:24:25.000000', 'consum', 0.0210, 'lps'),
	(650211, 132, '2015-01-15 01:24:26.000000', 'consum', 0.0220, 'lps'),
	(650212, 132, '2015-01-15 01:24:27.000000', 'consum', 0.0215, 'lps'),
	(650213, 132, '2015-01-15 01:24:28.000000', 'consum', 0.0218, 'lps'),
	(650214, 132, '2015-01-15 01:24:29.000000', 'consum', 0.0215, 'lps'),
	(650215, 132, '2015-01-15 01:24:30.000000', 'consum', 0.0210, 'lps'),
	(650216, 132, '2015-01-15 01:24:31.000000', 'consum', 0.0220, 'lps'),
	(650217, 132, '2015-01-15 01:24:32.000000', 'consum', 0.0214, 'lps'),
	(650218, 132, '2015-01-15 01:24:33.000000', 'consum', 0.0211, 'lps'),
	(650219, 132, '2015-01-15 01:24:34.000000', 'consum', 0.0215, 'lps'),
	(650220, 132, '2015-01-15 01:24:35.000000', 'consum', 0.0212, 'lps'),
	(650221, 132, '2015-01-15 01:24:36.000000', 'consum', 0.0216, 'lps'),
	(650222, 132, '2015-01-15 01:24:37.000000', 'consum', 0.0213, 'lps'),
	(650223, 132, '2015-01-15 01:24:38.000000', 'consum', 0.0218, 'lps'),
	(650224, 132, '2015-01-15 01:24:39.000000', 'consum', 0.0220, 'lps'),
	(650225, 132, '2015-01-15 01:24:40.000000', 'consum', 0.0214, 'lps'),
	(650226, 132, '2015-01-15 01:24:41.000000', 'consum', 0.0213, 'lps'),
	(650227, 132, '2015-01-15 01:24:42.000000', 'consum', 0.0211, 'lps'),
	(650228, 132, '2015-01-15 01:24:43.000000', 'consum', 0.0217, 'lps'),
	(650229, 132, '2015-01-15 01:24:44.000000', 'consum', 0.0210, 'lps'),
	(650230, 132, '2015-01-15 01:24:45.000000', 'consum', 0.0213, 'lps'),
	(650231, 132, '2015-01-15 01:24:46.000000', 'consum', 0.0213, 'lps'),
	(650232, 132, '2015-01-15 01:24:47.000000', 'consum', 0.0215, 'lps'),
	(650233, 132, '2015-01-15 01:24:48.000000', 'consum', 0.0217, 'lps'),
	(650234, 132, '2015-01-15 01:24:49.000000', 'consum', 0.0210, 'lps'),
	(650235, 132, '2015-01-15 01:24:50.000000', 'consum', 0.0211, 'lps'),
	(650236, 132, '2015-01-15 01:24:51.000000', 'consum', 0.0217, 'lps'),
	(650237, 132, '2015-01-15 01:24:52.000000', 'consum', 0.0219, 'lps'),
	(650238, 132, '2015-01-15 01:24:53.000000', 'consum', 0.0211, 'lps'),
	(650239, 132, '2015-01-15 01:24:54.000000', 'consum', 0.0212, 'lps'),
	(650240, 132, '2015-01-15 01:24:55.000000', 'consum', 0.0218, 'lps'),
	(650241, 132, '2015-01-15 01:24:56.000000', 'consum', 0.0212, 'lps'),
	(650242, 132, '2015-01-15 01:24:57.000000', 'consum', 0.0217, 'lps'),
	(650243, 132, '2015-01-15 01:24:58.000000', 'consum', 0.0218, 'lps'),
	(650244, 132, '2015-01-15 01:24:59.000000', 'consum', 0.0218, 'lps'),
	(650245, 132, '2015-01-15 01:25:00.000000', 'consum', 0.0216, 'lps'),
	(650246, 132, '2015-01-15 01:25:01.000000', 'consum', 0.0215, 'lps'),
	(650247, 132, '2015-01-15 01:25:02.000000', 'consum', 0.0219, 'lps'),
	(650248, 132, '2015-01-15 01:25:03.000000', 'consum', 0.0218, 'lps'),
	(650249, 132, '2015-01-15 01:25:04.000000', 'consum', 0.0212, 'lps'),
	(650250, 132, '2015-01-15 01:25:05.000000', 'consum', 0.0217, 'lps'),
	(650251, 132, '2015-01-15 01:25:06.000000', 'consum', 0.0219, 'lps'),
	(650252, 132, '2015-01-15 01:25:07.000000', 'consum', 0.0211, 'lps'),
	(650253, 132, '2015-01-15 01:25:08.000000', 'consum', 0.0212, 'lps'),
	(650254, 132, '2015-01-15 01:25:09.000000', 'consum', 0.0219, 'lps'),
	(650255, 132, '2015-01-15 01:25:10.000000', 'consum', 0.0215, 'lps'),
	(650256, 132, '2015-01-15 01:25:11.000000', 'consum', 0.0211, 'lps'),
	(650257, 132, '2015-01-15 01:25:12.000000', 'consum', 0.0219, 'lps'),
	(650258, 132, '2015-01-15 01:25:13.000000', 'consum', 0.0211, 'lps'),
	(650259, 132, '2015-01-15 01:25:14.000000', 'consum', 0.0219, 'lps'),
	(650260, 132, '2015-01-15 01:25:15.000000', 'consum', 0.0220, 'lps'),
	(650261, 132, '2015-01-15 01:25:16.000000', 'consum', 0.0214, 'lps'),
	(650262, 132, '2015-01-15 01:25:17.000000', 'consum', 0.0220, 'lps'),
	(650263, 132, '2015-01-15 01:25:18.000000', 'consum', 0.0217, 'lps'),
	(650264, 132, '2015-01-15 01:25:19.000000', 'consum', 0.0214, 'lps'),
	(650265, 132, '2015-01-15 01:25:20.000000', 'consum', 0.0210, 'lps'),
	(650266, 132, '2015-01-15 01:25:21.000000', 'consum', 0.0211, 'lps'),
	(650267, 132, '2015-01-15 01:25:22.000000', 'consum', 0.0216, 'lps'),
	(650268, 132, '2015-01-15 01:25:23.000000', 'consum', 0.0214, 'lps'),
	(650269, 132, '2015-01-15 01:25:24.000000', 'consum', 0.0214, 'lps'),
	(650270, 132, '2015-01-15 01:25:25.000000', 'consum', 0.0217, 'lps'),
	(650271, 132, '2015-01-15 01:25:26.000000', 'consum', 0.0211, 'lps'),
	(650272, 132, '2015-01-15 01:25:27.000000', 'consum', 0.0216, 'lps'),
	(650273, 132, '2015-01-15 01:25:28.000000', 'consum', 0.0215, 'lps'),
	(650274, 132, '2015-01-15 01:25:29.000000', 'consum', 0.0220, 'lps'),
	(650275, 132, '2015-01-15 01:25:30.000000', 'consum', 0.0211, 'lps'),
	(650276, 132, '2015-01-15 01:25:31.000000', 'consum', 0.0219, 'lps'),
	(650277, 132, '2015-01-15 01:25:32.000000', 'consum', 0.0218, 'lps'),
	(650278, 132, '2015-01-15 01:25:33.000000', 'consum', 0.0212, 'lps'),
	(650279, 132, '2015-01-15 01:25:34.000000', 'consum', 0.0219, 'lps'),
	(650280, 132, '2015-01-15 01:25:35.000000', 'consum', 0.0217, 'lps'),
	(650281, 132, '2015-01-15 01:25:36.000000', 'consum', 0.0219, 'lps'),
	(650282, 132, '2015-01-15 01:25:37.000000', 'consum', 0.0211, 'lps'),
	(650283, 132, '2015-01-15 01:25:38.000000', 'consum', 0.0210, 'lps'),
	(650284, 132, '2015-01-15 01:25:39.000000', 'consum', 0.0219, 'lps'),
	(650285, 132, '2015-01-15 01:25:40.000000', 'consum', 0.0210, 'lps'),
	(650286, 132, '2015-01-15 01:25:41.000000', 'consum', 0.0218, 'lps'),
	(650287, 132, '2015-01-15 01:25:42.000000', 'consum', 0.0215, 'lps'),
	(650288, 132, '2015-01-15 01:25:43.000000', 'consum', 0.0215, 'lps'),
	(650289, 132, '2015-01-15 01:25:44.000000', 'consum', 0.0218, 'lps'),
	(650290, 132, '2015-01-15 01:25:45.000000', 'consum', 0.0215, 'lps'),
	(650291, 132, '2015-01-15 01:25:46.000000', 'consum', 0.0210, 'lps'),
	(650292, 132, '2015-01-15 01:25:47.000000', 'consum', 0.0217, 'lps'),
	(650293, 132, '2015-01-15 01:25:48.000000', 'consum', 0.0215, 'lps'),
	(650294, 132, '2015-01-15 01:25:49.000000', 'consum', 0.0213, 'lps'),
	(650295, 132, '2015-01-15 01:25:50.000000', 'consum', 0.0210, 'lps'),
	(650296, 132, '2015-01-15 01:25:51.000000', 'consum', 0.0214, 'lps'),
	(650297, 132, '2015-01-15 01:25:52.000000', 'consum', 0.0217, 'lps'),
	(650298, 132, '2015-01-15 01:25:53.000000', 'consum', 0.0213, 'lps'),
	(650299, 132, '2015-01-15 01:25:54.000000', 'consum', 0.0217, 'lps'),
	(650300, 132, '2015-01-15 01:25:55.000000', 'consum', 0.0214, 'lps'),
	(650301, 132, '2015-01-15 01:25:56.000000', 'consum', 0.0218, 'lps'),
	(650302, 132, '2015-01-15 01:25:57.000000', 'consum', 0.0220, 'lps'),
	(650303, 132, '2015-01-15 01:25:58.000000', 'consum', 0.0211, 'lps'),
	(650304, 132, '2015-01-15 01:25:59.000000', 'consum', 0.0210, 'lps'),
	(650305, 132, '2015-01-15 01:26:00.000000', 'consum', 0.0219, 'lps'),
	(650306, 132, '2015-01-15 01:26:01.000000', 'consum', 0.0213, 'lps'),
	(650307, 132, '2015-01-15 01:26:02.000000', 'consum', 0.0217, 'lps'),
	(650308, 132, '2015-01-15 01:26:03.000000', 'consum', 0.0218, 'lps'),
	(650309, 132, '2015-01-15 01:26:04.000000', 'consum', 0.0215, 'lps'),
	(650310, 132, '2015-01-15 01:26:05.000000', 'consum', 0.0213, 'lps'),
	(650311, 132, '2015-01-15 01:26:06.000000', 'consum', 0.0220, 'lps'),
	(650312, 132, '2015-01-15 01:26:07.000000', 'consum', 0.0210, 'lps'),
	(650313, 132, '2015-01-15 01:26:08.000000', 'consum', 0.0213, 'lps'),
	(650314, 132, '2015-01-15 01:26:09.000000', 'consum', 0.0212, 'lps'),
	(650315, 132, '2015-01-15 01:26:10.000000', 'consum', 0.0215, 'lps'),
	(650316, 132, '2015-01-15 01:26:11.000000', 'consum', 0.0217, 'lps'),
	(650317, 132, '2015-01-15 01:26:12.000000', 'consum', 0.0217, 'lps'),
	(650318, 132, '2015-01-15 01:26:13.000000', 'consum', 0.0217, 'lps'),
	(650319, 132, '2015-01-15 01:26:14.000000', 'consum', 0.0213, 'lps'),
	(650320, 132, '2015-01-15 01:26:15.000000', 'consum', 0.0215, 'lps'),
	(650321, 132, '2015-01-15 01:26:16.000000', 'consum', 0.0215, 'lps'),
	(650322, 132, '2015-01-15 01:26:17.000000', 'consum', 0.0219, 'lps'),
	(650323, 132, '2015-01-15 01:26:18.000000', 'consum', 0.0210, 'lps'),
	(650324, 132, '2015-01-15 01:26:19.000000', 'consum', 0.0215, 'lps'),
	(650325, 132, '2015-01-15 01:26:20.000000', 'consum', 0.0215, 'lps'),
	(650326, 132, '2015-01-15 01:26:21.000000', 'consum', 0.0210, 'lps'),
	(650327, 132, '2015-01-15 01:26:22.000000', 'consum', 0.0218, 'lps'),
	(650328, 132, '2015-01-15 01:26:23.000000', 'consum', 0.0218, 'lps'),
	(650329, 132, '2015-01-15 01:26:24.000000', 'consum', 0.0216, 'lps'),
	(650330, 132, '2015-01-15 01:26:25.000000', 'consum', 0.0213, 'lps'),
	(650331, 132, '2015-01-15 01:26:26.000000', 'consum', 0.0211, 'lps'),
	(650332, 132, '2015-01-15 01:26:27.000000', 'consum', 0.0217, 'lps'),
	(650333, 132, '2015-01-15 01:26:28.000000', 'consum', 0.0218, 'lps'),
	(650334, 132, '2015-01-15 01:26:29.000000', 'consum', 0.0210, 'lps'),
	(650335, 132, '2015-01-15 01:26:30.000000', 'consum', 0.0219, 'lps'),
	(650336, 132, '2015-01-15 01:26:31.000000', 'consum', 0.0211, 'lps'),
	(650337, 132, '2015-01-15 01:26:32.000000', 'consum', 0.0212, 'lps'),
	(650338, 132, '2015-01-15 01:26:33.000000', 'consum', 0.0215, 'lps'),
	(650339, 132, '2015-01-15 01:26:34.000000', 'consum', 0.0218, 'lps'),
	(650340, 132, '2015-01-15 01:26:35.000000', 'consum', 0.0213, 'lps'),
	(650341, 132, '2015-01-15 01:26:36.000000', 'consum', 0.0213, 'lps'),
	(650342, 132, '2015-01-15 01:26:37.000000', 'consum', 0.0219, 'lps'),
	(650343, 132, '2015-01-15 01:26:38.000000', 'consum', 0.0212, 'lps'),
	(650344, 132, '2015-01-15 01:26:39.000000', 'consum', 0.0218, 'lps'),
	(650345, 132, '2015-01-15 01:26:40.000000', 'consum', 0.0219, 'lps'),
	(650346, 132, '2015-01-15 01:26:41.000000', 'consum', 0.0210, 'lps'),
	(650347, 132, '2015-01-15 01:26:42.000000', 'consum', 0.0217, 'lps'),
	(650348, 132, '2015-01-15 01:26:43.000000', 'consum', 0.0212, 'lps'),
	(650349, 132, '2015-01-15 01:26:44.000000', 'consum', 0.0220, 'lps'),
	(650350, 132, '2015-01-15 01:26:45.000000', 'consum', 0.0213, 'lps'),
	(650351, 132, '2015-01-15 01:26:46.000000', 'consum', 0.0215, 'lps'),
	(650352, 132, '2015-01-15 01:26:47.000000', 'consum', 0.0215, 'lps'),
	(650353, 132, '2015-01-15 01:26:48.000000', 'consum', 0.0220, 'lps'),
	(650354, 132, '2015-01-15 01:26:49.000000', 'consum', 0.0213, 'lps'),
	(650355, 132, '2015-01-15 01:26:50.000000', 'consum', 0.0218, 'lps'),
	(650356, 132, '2015-01-15 01:26:51.000000', 'consum', 0.0219, 'lps'),
	(650357, 132, '2015-01-15 01:26:52.000000', 'consum', 0.0210, 'lps'),
	(650358, 132, '2015-01-15 01:26:53.000000', 'consum', 0.0218, 'lps'),
	(650359, 132, '2015-01-15 01:26:54.000000', 'consum', 0.0216, 'lps'),
	(650360, 132, '2015-01-15 01:26:55.000000', 'consum', 0.0216, 'lps'),
	(650361, 132, '2015-01-15 01:26:56.000000', 'consum', 0.0213, 'lps'),
	(650362, 132, '2015-01-15 01:26:57.000000', 'consum', 0.0216, 'lps'),
	(650363, 132, '2015-01-15 01:26:58.000000', 'consum', 0.0211, 'lps'),
	(650364, 132, '2015-01-15 01:26:59.000000', 'consum', 0.0220, 'lps'),
	(650365, 132, '2015-01-15 01:27:00.000000', 'consum', 0.0213, 'lps'),
	(650366, 132, '2015-01-15 01:27:01.000000', 'consum', 0.0219, 'lps'),
	(650367, 132, '2015-01-15 01:27:02.000000', 'consum', 0.0214, 'lps'),
	(650368, 132, '2015-01-15 01:27:03.000000', 'consum', 0.0215, 'lps'),
	(650369, 132, '2015-01-15 01:27:04.000000', 'consum', 0.0213, 'lps'),
	(650370, 132, '2015-01-15 01:27:05.000000', 'consum', 0.0210, 'lps'),
	(650371, 132, '2015-01-15 01:27:06.000000', 'consum', 0.0214, 'lps'),
	(650372, 132, '2015-01-15 01:27:07.000000', 'consum', 0.0216, 'lps'),
	(650373, 132, '2015-01-15 01:27:08.000000', 'consum', 0.0210, 'lps'),
	(650374, 132, '2015-01-15 01:27:09.000000', 'consum', 0.0212, 'lps'),
	(650375, 132, '2015-01-15 01:27:10.000000', 'consum', 0.0212, 'lps'),
	(650376, 132, '2015-01-15 01:27:11.000000', 'consum', 0.0211, 'lps'),
	(650377, 132, '2015-01-15 01:27:12.000000', 'consum', 0.0213, 'lps'),
	(650378, 132, '2015-01-15 01:27:13.000000', 'consum', 0.0211, 'lps'),
	(650379, 132, '2015-01-15 01:27:14.000000', 'consum', 0.0216, 'lps'),
	(650380, 132, '2015-01-15 01:27:15.000000', 'consum', 0.0218, 'lps'),
	(650381, 132, '2015-01-15 01:27:16.000000', 'consum', 0.0219, 'lps'),
	(650382, 132, '2015-01-15 01:27:17.000000', 'consum', 0.0211, 'lps'),
	(650383, 132, '2015-01-15 01:27:18.000000', 'consum', 0.0212, 'lps'),
	(650384, 132, '2015-01-15 01:27:19.000000', 'consum', 0.0215, 'lps'),
	(650385, 133, '2015-01-15 00:00:00.000000', 'consum', 0.0219, 'lps'),
	(650386, 133, '2015-01-15 00:00:01.000000', 'consum', 0.0360, 'lps'),
	(650387, 133, '2015-01-15 00:00:02.000000', 'consum', 0.0283, 'lps'),
	(650388, 133, '2015-01-15 00:00:03.000000', 'consum', 0.0344, 'lps'),
	(650389, 133, '2015-01-15 00:00:04.000000', 'consum', 0.0225, 'lps'),
	(650390, 133, '2015-01-15 00:00:05.000000', 'consum', 0.0318, 'lps'),
	(650391, 133, '2015-01-15 00:00:06.000000', 'consum', 0.0273, 'lps'),
	(650392, 133, '2015-01-15 00:00:07.000000', 'consum', 0.0419, 'lps'),
	(650393, 133, '2015-01-15 00:00:08.000000', 'consum', 0.0413, 'lps'),
	(650394, 133, '2015-01-15 00:00:09.000000', 'consum', 0.0382, 'lps'),
	(650395, 133, '2015-01-15 00:00:10.000000', 'consum', 0.0247, 'lps'),
	(650396, 133, '2015-01-15 00:00:11.000000', 'consum', 0.0312, 'lps'),
	(650397, 133, '2015-01-15 00:00:12.000000', 'consum', 0.0391, 'lps'),
	(650398, 133, '2015-01-15 00:00:13.000000', 'consum', 0.0375, 'lps'),
	(650399, 133, '2015-01-15 00:00:14.000000', 'consum', 0.0276, 'lps'),
	(650400, 133, '2015-01-15 00:00:15.000000', 'consum', 0.0262, 'lps'),
	(650401, 133, '2015-01-15 00:00:16.000000', 'consum', 0.0274, 'lps'),
	(650402, 133, '2015-01-15 00:00:17.000000', 'consum', 0.0376, 'lps'),
	(650403, 133, '2015-01-15 00:00:18.000000', 'consum', 0.0412, 'lps'),
	(650404, 133, '2015-01-15 00:00:19.000000', 'consum', 0.0291, 'lps'),
	(650405, 133, '2015-01-15 00:00:20.000000', 'consum', 0.0224, 'lps'),
	(650406, 133, '2015-01-15 00:00:21.000000', 'consum', 0.0255, 'lps'),
	(650407, 133, '2015-01-15 00:00:22.000000', 'consum', 0.0393, 'lps'),
	(650408, 133, '2015-01-15 00:00:23.000000', 'consum', 0.0339, 'lps'),
	(650409, 133, '2015-01-15 00:00:24.000000', 'consum', 0.0307, 'lps'),
	(650410, 133, '2015-01-15 00:00:25.000000', 'consum', 0.0307, 'lps'),
	(650411, 133, '2015-01-15 00:00:26.000000', 'consum', 0.0407, 'lps'),
	(650412, 133, '2015-01-15 00:00:27.000000', 'consum', 0.0254, 'lps'),
	(650413, 133, '2015-01-15 00:00:28.000000', 'consum', 0.0271, 'lps'),
	(650414, 133, '2015-01-15 00:00:29.000000', 'consum', 0.0384, 'lps'),
	(650415, 133, '2015-01-15 00:00:30.000000', 'consum', 0.0249, 'lps'),
	(650416, 133, '2015-01-15 00:00:31.000000', 'consum', 0.0315, 'lps'),
	(650417, 133, '2015-01-15 00:00:32.000000', 'consum', 0.0400, 'lps'),
	(650418, 133, '2015-01-15 00:00:33.000000', 'consum', 0.0414, 'lps'),
	(650419, 133, '2015-01-15 00:00:34.000000', 'consum', 0.0228, 'lps'),
	(650420, 133, '2015-01-15 00:00:35.000000', 'consum', 0.0336, 'lps'),
	(650421, 133, '2015-01-15 00:00:36.000000', 'consum', 0.0356, 'lps'),
	(650422, 133, '2015-01-15 00:00:37.000000', 'consum', 0.0342, 'lps'),
	(650423, 133, '2015-01-15 00:00:38.000000', 'consum', 0.0218, 'lps'),
	(650424, 133, '2015-01-15 00:00:39.000000', 'consum', 0.0287, 'lps'),
	(650425, 133, '2015-01-15 00:00:40.000000', 'consum', 0.0353, 'lps'),
	(650426, 133, '2015-01-15 00:00:41.000000', 'consum', 0.0264, 'lps'),
	(650427, 133, '2015-01-15 00:00:42.000000', 'consum', 0.0266, 'lps'),
	(650428, 133, '2015-01-15 00:00:43.000000', 'consum', 0.0331, 'lps'),
	(650429, 133, '2015-01-15 00:00:44.000000', 'consum', 0.0213, 'lps'),
	(650430, 133, '2015-01-15 00:00:45.000000', 'consum', 0.0297, 'lps'),
	(650431, 133, '2015-01-15 00:00:46.000000', 'consum', 0.0419, 'lps'),
	(650432, 133, '2015-01-15 00:00:47.000000', 'consum', 0.0341, 'lps'),
	(650433, 133, '2015-01-15 00:00:48.000000', 'consum', 0.0242, 'lps'),
	(650434, 133, '2015-01-15 00:00:49.000000', 'consum', 0.0408, 'lps'),
	(650435, 133, '2015-01-15 00:00:50.000000', 'consum', 0.0240, 'lps'),
	(650436, 133, '2015-01-15 00:00:51.000000', 'consum', 0.0415, 'lps'),
	(650437, 133, '2015-01-15 00:00:52.000000', 'consum', 0.0278, 'lps'),
	(650438, 133, '2015-01-15 00:00:53.000000', 'consum', 0.0370, 'lps'),
	(650439, 133, '2015-01-15 00:00:54.000000', 'consum', 0.0371, 'lps'),
	(650440, 133, '2015-01-15 00:00:55.000000', 'consum', 0.0319, 'lps'),
	(650441, 133, '2015-01-15 00:00:56.000000', 'consum', 0.0271, 'lps'),
	(650442, 133, '2015-01-15 00:00:57.000000', 'consum', 0.0408, 'lps'),
	(650443, 133, '2015-01-15 00:00:58.000000', 'consum', 0.0364, 'lps'),
	(650444, 133, '2015-01-15 00:00:59.000000', 'consum', 0.0387, 'lps'),
	(650445, 133, '2015-01-15 00:01:00.000000', 'consum', 0.0416, 'lps'),
	(650446, 133, '2015-01-15 00:01:01.000000', 'consum', 0.0277, 'lps'),
	(650447, 133, '2015-01-15 00:01:02.000000', 'consum', 0.0359, 'lps'),
	(650448, 133, '2015-01-15 00:01:03.000000', 'consum', 0.0323, 'lps'),
	(650449, 133, '2015-01-15 00:01:04.000000', 'consum', 0.0329, 'lps'),
	(650450, 133, '2015-01-15 00:01:05.000000', 'consum', 0.0251, 'lps'),
	(650451, 133, '2015-01-15 00:01:06.000000', 'consum', 0.0272, 'lps'),
	(650452, 133, '2015-01-15 00:01:07.000000', 'consum', 0.0400, 'lps'),
	(650453, 133, '2015-01-15 00:01:08.000000', 'consum', 0.0324, 'lps'),
	(650454, 133, '2015-01-15 00:01:09.000000', 'consum', 0.0425, 'lps'),
	(650455, 133, '2015-01-15 00:01:10.000000', 'consum', 0.0294, 'lps'),
	(650456, 133, '2015-01-15 00:01:11.000000', 'consum', 0.0421, 'lps'),
	(650457, 133, '2015-01-15 00:01:12.000000', 'consum', 0.0361, 'lps'),
	(650458, 133, '2015-01-15 00:01:13.000000', 'consum', 0.0333, 'lps'),
	(650459, 133, '2015-01-15 00:01:14.000000', 'consum', 0.0371, 'lps'),
	(650460, 133, '2015-01-15 00:01:15.000000', 'consum', 0.0214, 'lps'),
	(650461, 133, '2015-01-15 00:01:16.000000', 'consum', 0.0400, 'lps'),
	(650462, 133, '2015-01-15 00:01:17.000000', 'consum', 0.0279, 'lps'),
	(650463, 133, '2015-01-15 00:01:18.000000', 'consum', 0.0420, 'lps'),
	(650464, 133, '2015-01-15 00:01:19.000000', 'consum', 0.0401, 'lps'),
	(650465, 133, '2015-01-15 00:01:20.000000', 'consum', 0.0320, 'lps'),
	(650466, 133, '2015-01-15 00:01:21.000000', 'consum', 0.0405, 'lps'),
	(650467, 133, '2015-01-15 00:01:22.000000', 'consum', 0.0419, 'lps'),
	(650468, 133, '2015-01-15 00:01:23.000000', 'consum', 0.0239, 'lps'),
	(650469, 133, '2015-01-15 00:01:24.000000', 'consum', 0.0379, 'lps'),
	(650470, 133, '2015-01-15 00:01:25.000000', 'consum', 0.0319, 'lps'),
	(650471, 133, '2015-01-15 00:01:26.000000', 'consum', 0.0248, 'lps'),
	(650472, 133, '2015-01-15 00:01:27.000000', 'consum', 0.0291, 'lps'),
	(650473, 133, '2015-01-15 00:01:28.000000', 'consum', 0.0285, 'lps'),
	(650474, 133, '2015-01-15 00:01:29.000000', 'consum', 0.0342, 'lps'),
	(650475, 133, '2015-01-15 00:01:30.000000', 'consum', 0.0212, 'lps'),
	(650476, 133, '2015-01-15 00:01:31.000000', 'consum', 0.0256, 'lps'),
	(650477, 133, '2015-01-15 00:01:32.000000', 'consum', 0.0220, 'lps'),
	(650478, 133, '2015-01-15 00:01:33.000000', 'consum', 0.0338, 'lps'),
	(650479, 133, '2015-01-15 00:01:34.000000', 'consum', 0.0386, 'lps'),
	(650480, 133, '2015-01-15 00:01:35.000000', 'consum', 0.0272, 'lps'),
	(650481, 133, '2015-01-15 00:01:36.000000', 'consum', 0.0426, 'lps'),
	(650482, 133, '2015-01-15 00:01:37.000000', 'consum', 0.0236, 'lps'),
	(650483, 133, '2015-01-15 00:01:38.000000', 'consum', 0.0346, 'lps'),
	(650484, 133, '2015-01-15 00:01:39.000000', 'consum', 0.0376, 'lps'),
	(650485, 133, '2015-01-15 00:01:40.000000', 'consum', 0.0418, 'lps'),
	(650486, 133, '2015-01-15 00:01:41.000000', 'consum', 0.0317, 'lps'),
	(650487, 133, '2015-01-15 00:01:42.000000', 'consum', 0.0337, 'lps'),
	(650488, 133, '2015-01-15 00:01:43.000000', 'consum', 0.0310, 'lps'),
	(650489, 133, '2015-01-15 00:01:44.000000', 'consum', 0.0328, 'lps'),
	(650490, 133, '2015-01-15 00:01:45.000000', 'consum', 0.0282, 'lps'),
	(650491, 133, '2015-01-15 00:01:46.000000', 'consum', 0.0219, 'lps'),
	(650492, 133, '2015-01-15 00:01:47.000000', 'consum', 0.0256, 'lps'),
	(650493, 133, '2015-01-15 00:01:48.000000', 'consum', 0.0414, 'lps'),
	(650494, 133, '2015-01-15 00:01:49.000000', 'consum', 0.0223, 'lps'),
	(650495, 133, '2015-01-15 00:01:50.000000', 'consum', 0.0315, 'lps'),
	(650496, 133, '2015-01-15 00:01:51.000000', 'consum', 0.0261, 'lps'),
	(650497, 133, '2015-01-15 00:01:52.000000', 'consum', 0.0369, 'lps'),
	(650498, 133, '2015-01-15 00:01:53.000000', 'consum', 0.0418, 'lps'),
	(650499, 133, '2015-01-15 00:01:54.000000', 'consum', 0.0339, 'lps'),
	(650500, 133, '2015-01-15 00:01:55.000000', 'consum', 0.0234, 'lps'),
	(650501, 133, '2015-01-15 00:01:56.000000', 'consum', 0.0376, 'lps'),
	(650502, 133, '2015-01-15 00:01:57.000000', 'consum', 0.0318, 'lps'),
	(650503, 133, '2015-01-15 00:01:58.000000', 'consum', 0.0250, 'lps'),
	(650504, 133, '2015-01-15 00:01:59.000000', 'consum', 0.0307, 'lps'),
	(650505, 133, '2015-01-15 00:02:00.000000', 'consum', 0.0355, 'lps'),
	(650506, 133, '2015-01-15 00:02:01.000000', 'consum', 0.0213, 'lps'),
	(650507, 133, '2015-01-15 00:02:02.000000', 'consum', 0.0223, 'lps'),
	(650508, 133, '2015-01-15 00:02:03.000000', 'consum', 0.0269, 'lps'),
	(650509, 133, '2015-01-15 00:02:04.000000', 'consum', 0.0248, 'lps'),
	(650510, 133, '2015-01-15 00:02:05.000000', 'consum', 0.0224, 'lps'),
	(650511, 133, '2015-01-15 00:02:06.000000', 'consum', 0.0385, 'lps'),
	(650512, 133, '2015-01-15 00:02:07.000000', 'consum', 0.0391, 'lps'),
	(650513, 133, '2015-01-15 00:02:08.000000', 'consum', 0.0373, 'lps'),
	(650514, 133, '2015-01-15 00:02:09.000000', 'consum', 0.0268, 'lps'),
	(650515, 133, '2015-01-15 00:02:10.000000', 'consum', 0.0227, 'lps'),
	(650516, 133, '2015-01-15 00:02:11.000000', 'consum', 0.0338, 'lps'),
	(650517, 133, '2015-01-15 00:02:12.000000', 'consum', 0.0365, 'lps'),
	(650518, 133, '2015-01-15 00:02:13.000000', 'consum', 0.0386, 'lps'),
	(650519, 133, '2015-01-15 00:02:14.000000', 'consum', 0.0406, 'lps'),
	(650520, 133, '2015-01-15 00:02:15.000000', 'consum', 0.0231, 'lps'),
	(650521, 133, '2015-01-15 00:02:16.000000', 'consum', 0.0379, 'lps'),
	(650522, 133, '2015-01-15 00:02:17.000000', 'consum', 0.0341, 'lps'),
	(650523, 133, '2015-01-15 00:02:18.000000', 'consum', 0.0360, 'lps'),
	(650524, 133, '2015-01-15 00:02:19.000000', 'consum', 0.0348, 'lps'),
	(650525, 133, '2015-01-15 00:02:20.000000', 'consum', 0.0234, 'lps'),
	(650526, 133, '2015-01-15 00:02:21.000000', 'consum', 0.0349, 'lps'),
	(650527, 133, '2015-01-15 00:02:22.000000', 'consum', 0.0400, 'lps'),
	(650528, 133, '2015-01-15 00:02:23.000000', 'consum', 0.0312, 'lps'),
	(650529, 133, '2015-01-15 00:02:24.000000', 'consum', 0.0366, 'lps'),
	(650530, 133, '2015-01-15 00:02:25.000000', 'consum', 0.0250, 'lps'),
	(650531, 133, '2015-01-15 00:02:26.000000', 'consum', 0.0377, 'lps'),
	(650532, 133, '2015-01-15 00:02:27.000000', 'consum', 0.0276, 'lps'),
	(650533, 133, '2015-01-15 00:02:28.000000', 'consum', 0.0254, 'lps'),
	(650534, 133, '2015-01-15 00:02:29.000000', 'consum', 0.0234, 'lps'),
	(650535, 133, '2015-01-15 00:02:30.000000', 'consum', 0.0414, 'lps'),
	(650536, 133, '2015-01-15 00:02:31.000000', 'consum', 0.0290, 'lps'),
	(650537, 133, '2015-01-15 00:02:32.000000', 'consum', 0.0217, 'lps'),
	(650538, 133, '2015-01-15 00:02:33.000000', 'consum', 0.0223, 'lps'),
	(650539, 133, '2015-01-15 00:02:34.000000', 'consum', 0.0255, 'lps'),
	(650540, 133, '2015-01-15 00:02:35.000000', 'consum', 0.0395, 'lps'),
	(650541, 133, '2015-01-15 00:02:36.000000', 'consum', 0.0349, 'lps'),
	(650542, 133, '2015-01-15 00:02:37.000000', 'consum', 0.0350, 'lps'),
	(650543, 133, '2015-01-15 00:02:38.000000', 'consum', 0.0276, 'lps'),
	(650544, 133, '2015-01-15 00:02:39.000000', 'consum', 0.0340, 'lps'),
	(650545, 133, '2015-01-15 00:02:40.000000', 'consum', 0.0229, 'lps'),
	(650546, 133, '2015-01-15 00:02:41.000000', 'consum', 0.0347, 'lps'),
	(650547, 133, '2015-01-15 00:02:42.000000', 'consum', 0.0407, 'lps'),
	(650548, 133, '2015-01-15 00:02:43.000000', 'consum', 0.0347, 'lps'),
	(650549, 133, '2015-01-15 00:02:44.000000', 'consum', 0.0308, 'lps'),
	(650550, 133, '2015-01-15 00:02:45.000000', 'consum', 0.0287, 'lps'),
	(650551, 133, '2015-01-15 00:02:46.000000', 'consum', 0.0301, 'lps'),
	(650552, 133, '2015-01-15 00:02:47.000000', 'consum', 0.0220, 'lps'),
	(650553, 133, '2015-01-15 00:02:48.000000', 'consum', 0.0421, 'lps'),
	(650554, 133, '2015-01-15 00:02:49.000000', 'consum', 0.0367, 'lps'),
	(650555, 133, '2015-01-15 00:02:50.000000', 'consum', 0.0362, 'lps'),
	(650556, 133, '2015-01-15 00:02:51.000000', 'consum', 0.0281, 'lps'),
	(650557, 133, '2015-01-15 00:02:52.000000', 'consum', 0.0327, 'lps'),
	(650558, 133, '2015-01-15 00:02:53.000000', 'consum', 0.0366, 'lps'),
	(650559, 133, '2015-01-15 00:02:54.000000', 'consum', 0.0422, 'lps'),
	(650560, 133, '2015-01-15 00:02:55.000000', 'consum', 0.0367, 'lps'),
	(650561, 133, '2015-01-15 00:02:56.000000', 'consum', 0.0361, 'lps'),
	(650562, 133, '2015-01-15 00:02:57.000000', 'consum', 0.0277, 'lps'),
	(650563, 133, '2015-01-15 00:02:58.000000', 'consum', 0.0308, 'lps'),
	(650564, 133, '2015-01-15 00:02:59.000000', 'consum', 0.0284, 'lps'),
	(650565, 133, '2015-01-15 00:03:00.000000', 'consum', 0.0286, 'lps'),
	(650566, 133, '2015-01-15 00:03:01.000000', 'consum', 0.0367, 'lps'),
	(650567, 133, '2015-01-15 00:03:02.000000', 'consum', 0.0335, 'lps'),
	(650568, 133, '2015-01-15 00:03:03.000000', 'consum', 0.0366, 'lps'),
	(650569, 133, '2015-01-15 00:03:04.000000', 'consum', 0.0396, 'lps'),
	(650570, 133, '2015-01-15 00:03:05.000000', 'consum', 0.0238, 'lps'),
	(650571, 133, '2015-01-15 00:03:06.000000', 'consum', 0.0227, 'lps'),
	(650572, 133, '2015-01-15 00:03:07.000000', 'consum', 0.0212, 'lps'),
	(650573, 133, '2015-01-15 00:03:08.000000', 'consum', 0.0388, 'lps'),
	(650574, 133, '2015-01-15 00:03:09.000000', 'consum', 0.0227, 'lps'),
	(650575, 133, '2015-01-15 00:03:10.000000', 'consum', 0.0413, 'lps'),
	(650576, 133, '2015-01-15 00:03:11.000000', 'consum', 0.0307, 'lps'),
	(650577, 133, '2015-01-15 00:03:12.000000', 'consum', 0.0304, 'lps'),
	(650578, 133, '2015-01-15 00:03:13.000000', 'consum', 0.0389, 'lps'),
	(650579, 133, '2015-01-15 00:03:14.000000', 'consum', 0.0389, 'lps'),
	(650580, 133, '2015-01-15 00:03:15.000000', 'consum', 0.0351, 'lps'),
	(650581, 133, '2015-01-15 00:03:16.000000', 'consum', 0.0379, 'lps'),
	(650582, 133, '2015-01-15 00:03:17.000000', 'consum', 0.0415, 'lps'),
	(650583, 133, '2015-01-15 00:03:18.000000', 'consum', 0.0293, 'lps'),
	(650584, 133, '2015-01-15 00:03:19.000000', 'consum', 0.0228, 'lps'),
	(650585, 133, '2015-01-15 00:03:20.000000', 'consum', 0.0270, 'lps'),
	(650586, 133, '2015-01-15 00:03:21.000000', 'consum', 0.0238, 'lps'),
	(650587, 133, '2015-01-15 00:03:22.000000', 'consum', 0.0386, 'lps'),
	(650588, 133, '2015-01-15 00:03:23.000000', 'consum', 0.0357, 'lps'),
	(650589, 133, '2015-01-15 00:03:24.000000', 'consum', 0.0418, 'lps'),
	(650590, 133, '2015-01-15 00:03:25.000000', 'consum', 0.0374, 'lps'),
	(650591, 133, '2015-01-15 00:03:26.000000', 'consum', 0.0407, 'lps'),
	(650592, 133, '2015-01-15 00:03:27.000000', 'consum', 0.0271, 'lps'),
	(650593, 133, '2015-01-15 00:03:28.000000', 'consum', 0.0356, 'lps'),
	(650594, 133, '2015-01-15 00:03:29.000000', 'consum', 0.0324, 'lps'),
	(650595, 133, '2015-01-15 00:03:30.000000', 'consum', 0.0345, 'lps'),
	(650596, 133, '2015-01-15 00:03:31.000000', 'consum', 0.0324, 'lps'),
	(650597, 133, '2015-01-15 00:03:32.000000', 'consum', 0.0376, 'lps'),
	(650598, 133, '2015-01-15 00:03:33.000000', 'consum', 0.0263, 'lps'),
	(650599, 133, '2015-01-15 00:03:34.000000', 'consum', 0.0412, 'lps'),
	(650600, 133, '2015-01-15 00:03:35.000000', 'consum', 0.0410, 'lps'),
	(650601, 133, '2015-01-15 00:03:36.000000', 'consum', 0.0386, 'lps'),
	(650602, 133, '2015-01-15 00:03:37.000000', 'consum', 0.0277, 'lps'),
	(650603, 133, '2015-01-15 00:03:38.000000', 'consum', 0.0231, 'lps'),
	(650604, 133, '2015-01-15 00:03:39.000000', 'consum', 0.0334, 'lps'),
	(650605, 133, '2015-01-15 00:03:40.000000', 'consum', 0.0335, 'lps'),
	(650606, 133, '2015-01-15 00:03:41.000000', 'consum', 0.0244, 'lps'),
	(650607, 133, '2015-01-15 00:03:42.000000', 'consum', 0.0222, 'lps'),
	(650608, 133, '2015-01-15 00:03:43.000000', 'consum', 0.0388, 'lps'),
	(650609, 133, '2015-01-15 00:03:44.000000', 'consum', 0.0411, 'lps'),
	(650610, 133, '2015-01-15 00:03:45.000000', 'consum', 0.0247, 'lps'),
	(650611, 133, '2015-01-15 00:03:46.000000', 'consum', 0.0227, 'lps'),
	(650612, 133, '2015-01-15 00:03:47.000000', 'consum', 0.0400, 'lps'),
	(650613, 133, '2015-01-15 00:03:48.000000', 'consum', 0.0243, 'lps'),
	(650614, 133, '2015-01-15 00:03:49.000000', 'consum', 0.0240, 'lps'),
	(650615, 133, '2015-01-15 00:03:50.000000', 'consum', 0.0261, 'lps'),
	(650616, 133, '2015-01-15 00:03:51.000000', 'consum', 0.0377, 'lps'),
	(650617, 133, '2015-01-15 00:03:52.000000', 'consum', 0.0242, 'lps'),
	(650618, 133, '2015-01-15 00:03:53.000000', 'consum', 0.0305, 'lps'),
	(650619, 133, '2015-01-15 00:03:54.000000', 'consum', 0.0369, 'lps'),
	(650620, 133, '2015-01-15 00:03:55.000000', 'consum', 0.0287, 'lps'),
	(650621, 133, '2015-01-15 00:03:56.000000', 'consum', 0.0336, 'lps'),
	(650622, 133, '2015-01-15 00:03:57.000000', 'consum', 0.0392, 'lps'),
	(650623, 133, '2015-01-15 00:03:58.000000', 'consum', 0.0309, 'lps'),
	(650624, 133, '2015-01-15 00:03:59.000000', 'consum', 0.0376, 'lps'),
	(650625, 133, '2015-01-15 00:04:00.000000', 'consum', 0.0311, 'lps'),
	(650626, 133, '2015-01-15 00:04:01.000000', 'consum', 0.0215, 'lps'),
	(650627, 133, '2015-01-15 00:04:02.000000', 'consum', 0.0367, 'lps'),
	(650628, 133, '2015-01-15 00:04:03.000000', 'consum', 0.0330, 'lps'),
	(650629, 133, '2015-01-15 00:04:04.000000', 'consum', 0.0339, 'lps'),
	(650630, 133, '2015-01-15 00:04:05.000000', 'consum', 0.0280, 'lps'),
	(650631, 133, '2015-01-15 00:04:06.000000', 'consum', 0.0389, 'lps'),
	(650632, 133, '2015-01-15 00:04:07.000000', 'consum', 0.0246, 'lps'),
	(650633, 133, '2015-01-15 00:04:08.000000', 'consum', 0.0288, 'lps'),
	(650634, 133, '2015-01-15 00:04:09.000000', 'consum', 0.0274, 'lps'),
	(650635, 133, '2015-01-15 00:04:10.000000', 'consum', 0.0298, 'lps'),
	(650636, 133, '2015-01-15 00:04:11.000000', 'consum', 0.0239, 'lps'),
	(650637, 133, '2015-01-15 00:04:12.000000', 'consum', 0.0310, 'lps'),
	(650638, 133, '2015-01-15 00:04:13.000000', 'consum', 0.0407, 'lps'),
	(650639, 133, '2015-01-15 00:04:14.000000', 'consum', 0.0244, 'lps'),
	(650640, 133, '2015-01-15 00:04:15.000000', 'consum', 0.0222, 'lps'),
	(650641, 133, '2015-01-15 00:04:16.000000', 'consum', 0.0386, 'lps'),
	(650642, 133, '2015-01-15 00:04:17.000000', 'consum', 0.0406, 'lps'),
	(650643, 133, '2015-01-15 00:04:18.000000', 'consum', 0.0226, 'lps'),
	(650644, 133, '2015-01-15 00:04:19.000000', 'consum', 0.0353, 'lps'),
	(650645, 133, '2015-01-15 00:04:20.000000', 'consum', 0.0228, 'lps'),
	(650646, 133, '2015-01-15 00:04:21.000000', 'consum', 0.0305, 'lps'),
	(650647, 133, '2015-01-15 00:04:22.000000', 'consum', 0.0413, 'lps'),
	(650648, 133, '2015-01-15 00:04:23.000000', 'consum', 0.0290, 'lps'),
	(650649, 133, '2015-01-15 00:04:24.000000', 'consum', 0.0220, 'lps'),
	(650650, 133, '2015-01-15 00:04:25.000000', 'consum', 0.0238, 'lps'),
	(650651, 133, '2015-01-15 00:04:26.000000', 'consum', 0.0321, 'lps'),
	(650652, 133, '2015-01-15 00:04:27.000000', 'consum', 0.0248, 'lps'),
	(650653, 133, '2015-01-15 00:04:28.000000', 'consum', 0.0285, 'lps'),
	(650654, 133, '2015-01-15 00:04:29.000000', 'consum', 0.0253, 'lps'),
	(650655, 133, '2015-01-15 00:04:30.000000', 'consum', 0.0419, 'lps'),
	(650656, 133, '2015-01-15 00:04:31.000000', 'consum', 0.0257, 'lps'),
	(650657, 133, '2015-01-15 00:04:32.000000', 'consum', 0.0254, 'lps'),
	(650658, 133, '2015-01-15 00:04:33.000000', 'consum', 0.0289, 'lps'),
	(650659, 133, '2015-01-15 00:04:34.000000', 'consum', 0.0256, 'lps'),
	(650660, 133, '2015-01-15 00:04:35.000000', 'consum', 0.0419, 'lps'),
	(650661, 133, '2015-01-15 00:04:36.000000', 'consum', 0.0252, 'lps'),
	(650662, 133, '2015-01-15 00:04:37.000000', 'consum', 0.0228, 'lps'),
	(650663, 133, '2015-01-15 00:04:38.000000', 'consum', 0.0392, 'lps'),
	(650664, 133, '2015-01-15 00:04:39.000000', 'consum', 0.0414, 'lps'),
	(650665, 133, '2015-01-15 00:04:40.000000', 'consum', 0.0253, 'lps'),
	(650666, 133, '2015-01-15 00:04:41.000000', 'consum', 0.0246, 'lps'),
	(650667, 133, '2015-01-15 00:04:42.000000', 'consum', 0.0260, 'lps'),
	(650668, 133, '2015-01-15 00:04:43.000000', 'consum', 0.0354, 'lps'),
	(650669, 133, '2015-01-15 00:04:44.000000', 'consum', 0.0344, 'lps'),
	(650670, 133, '2015-01-15 00:04:45.000000', 'consum', 0.0234, 'lps'),
	(650671, 133, '2015-01-15 00:04:46.000000', 'consum', 0.0363, 'lps'),
	(650672, 133, '2015-01-15 00:04:47.000000', 'consum', 0.0250, 'lps'),
	(650673, 133, '2015-01-15 00:04:48.000000', 'consum', 0.0388, 'lps'),
	(650674, 133, '2015-01-15 00:04:49.000000', 'consum', 0.0330, 'lps'),
	(650675, 133, '2015-01-15 00:04:50.000000', 'consum', 0.0274, 'lps'),
	(650676, 133, '2015-01-15 00:04:51.000000', 'consum', 0.0390, 'lps'),
	(650677, 133, '2015-01-15 00:04:52.000000', 'consum', 0.0268, 'lps'),
	(650678, 133, '2015-01-15 00:04:53.000000', 'consum', 0.0394, 'lps'),
	(650679, 133, '2015-01-15 00:04:54.000000', 'consum', 0.0307, 'lps'),
	(650680, 133, '2015-01-15 00:04:55.000000', 'consum', 0.0358, 'lps'),
	(650681, 133, '2015-01-15 00:04:56.000000', 'consum', 0.0228, 'lps'),
	(650682, 133, '2015-01-15 00:04:57.000000', 'consum', 0.0289, 'lps'),
	(650683, 133, '2015-01-15 00:04:58.000000', 'consum', 0.0336, 'lps'),
	(650684, 133, '2015-01-15 00:04:59.000000', 'consum', 0.0385, 'lps'),
	(650685, 133, '2015-01-15 00:05:00.000000', 'consum', 0.0275, 'lps'),
	(650686, 133, '2015-01-15 00:05:01.000000', 'consum', 0.0225, 'lps'),
	(650687, 133, '2015-01-15 00:05:02.000000', 'consum', 0.0310, 'lps'),
	(650688, 133, '2015-01-15 00:05:03.000000', 'consum', 0.0231, 'lps'),
	(650689, 133, '2015-01-15 00:05:04.000000', 'consum', 0.0231, 'lps'),
	(650690, 133, '2015-01-15 00:05:05.000000', 'consum', 0.0252, 'lps'),
	(650691, 133, '2015-01-15 00:05:06.000000', 'consum', 0.0358, 'lps'),
	(650692, 133, '2015-01-15 00:05:07.000000', 'consum', 0.0390, 'lps'),
	(650693, 133, '2015-01-15 00:05:08.000000', 'consum', 0.0235, 'lps'),
	(650694, 133, '2015-01-15 00:05:09.000000', 'consum', 0.0228, 'lps'),
	(650695, 133, '2015-01-15 00:05:10.000000', 'consum', 0.0227, 'lps'),
	(650696, 133, '2015-01-15 00:05:11.000000', 'consum', 0.0241, 'lps'),
	(650697, 133, '2015-01-15 00:05:12.000000', 'consum', 0.0315, 'lps'),
	(650698, 133, '2015-01-15 00:05:13.000000', 'consum', 0.0424, 'lps'),
	(650699, 133, '2015-01-15 00:05:14.000000', 'consum', 0.0316, 'lps'),
	(650700, 133, '2015-01-15 00:05:15.000000', 'consum', 0.0315, 'lps'),
	(650701, 133, '2015-01-15 00:05:16.000000', 'consum', 0.0416, 'lps'),
	(650702, 133, '2015-01-15 00:05:17.000000', 'consum', 0.0275, 'lps'),
	(650703, 133, '2015-01-15 00:05:18.000000', 'consum', 0.0350, 'lps'),
	(650704, 133, '2015-01-15 00:05:19.000000', 'consum', 0.0282, 'lps'),
	(650705, 133, '2015-01-15 00:05:20.000000', 'consum', 0.0370, 'lps'),
	(650706, 133, '2015-01-15 00:05:21.000000', 'consum', 0.0358, 'lps'),
	(650707, 133, '2015-01-15 00:05:22.000000', 'consum', 0.0254, 'lps'),
	(650708, 133, '2015-01-15 00:05:23.000000', 'consum', 0.0422, 'lps'),
	(650709, 133, '2015-01-15 00:05:24.000000', 'consum', 0.0268, 'lps'),
	(650710, 133, '2015-01-15 00:05:25.000000', 'consum', 0.0298, 'lps'),
	(650711, 133, '2015-01-15 00:05:26.000000', 'consum', 0.0258, 'lps'),
	(650712, 133, '2015-01-15 00:05:27.000000', 'consum', 0.0407, 'lps'),
	(650713, 133, '2015-01-15 00:05:28.000000', 'consum', 0.0401, 'lps'),
	(650714, 133, '2015-01-15 00:05:29.000000', 'consum', 0.0357, 'lps'),
	(650715, 133, '2015-01-15 00:05:30.000000', 'consum', 0.0370, 'lps'),
	(650716, 133, '2015-01-15 00:05:31.000000', 'consum', 0.0354, 'lps'),
	(650717, 133, '2015-01-15 00:05:32.000000', 'consum', 0.0233, 'lps'),
	(650718, 133, '2015-01-15 00:05:33.000000', 'consum', 0.0329, 'lps'),
	(650719, 133, '2015-01-15 00:05:34.000000', 'consum', 0.0303, 'lps'),
	(650720, 133, '2015-01-15 00:05:35.000000', 'consum', 0.0316, 'lps'),
	(650721, 133, '2015-01-15 00:05:36.000000', 'consum', 0.0247, 'lps'),
	(650722, 133, '2015-01-15 00:05:37.000000', 'consum', 0.0295, 'lps'),
	(650723, 133, '2015-01-15 00:05:38.000000', 'consum', 0.0305, 'lps'),
	(650724, 133, '2015-01-15 00:05:39.000000', 'consum', 0.0214, 'lps'),
	(650725, 133, '2015-01-15 00:05:40.000000', 'consum', 0.0379, 'lps'),
	(650726, 133, '2015-01-15 00:05:41.000000', 'consum', 0.0392, 'lps'),
	(650727, 133, '2015-01-15 00:05:42.000000', 'consum', 0.0397, 'lps'),
	(650728, 133, '2015-01-15 00:05:43.000000', 'consum', 0.0383, 'lps'),
	(650729, 133, '2015-01-15 00:05:44.000000', 'consum', 0.0296, 'lps'),
	(650730, 133, '2015-01-15 00:05:45.000000', 'consum', 0.0338, 'lps'),
	(650731, 133, '2015-01-15 00:05:46.000000', 'consum', 0.0378, 'lps'),
	(650732, 133, '2015-01-15 00:05:47.000000', 'consum', 0.0232, 'lps'),
	(650733, 133, '2015-01-15 00:05:48.000000', 'consum', 0.0252, 'lps'),
	(650734, 133, '2015-01-15 00:05:49.000000', 'consum', 0.0352, 'lps'),
	(650735, 133, '2015-01-15 00:05:50.000000', 'consum', 0.0359, 'lps'),
	(650736, 133, '2015-01-15 00:05:51.000000', 'consum', 0.0316, 'lps'),
	(650737, 133, '2015-01-15 00:05:52.000000', 'consum', 0.0293, 'lps'),
	(650738, 133, '2015-01-15 00:05:53.000000', 'consum', 0.0307, 'lps'),
	(650739, 133, '2015-01-15 00:05:54.000000', 'consum', 0.0227, 'lps'),
	(650740, 133, '2015-01-15 00:05:55.000000', 'consum', 0.0225, 'lps'),
	(650741, 133, '2015-01-15 00:05:56.000000', 'consum', 0.0234, 'lps'),
	(650742, 133, '2015-01-15 00:05:57.000000', 'consum', 0.0286, 'lps'),
	(650743, 133, '2015-01-15 00:05:58.000000', 'consum', 0.0300, 'lps'),
	(650744, 133, '2015-01-15 00:05:59.000000', 'consum', 0.0215, 'lps'),
	(650745, 133, '2015-01-15 00:06:00.000000', 'consum', 0.0401, 'lps'),
	(650746, 133, '2015-01-15 00:06:01.000000', 'consum', 0.0280, 'lps'),
	(650747, 133, '2015-01-15 00:06:02.000000', 'consum', 0.0423, 'lps'),
	(650748, 133, '2015-01-15 00:06:03.000000', 'consum', 0.0412, 'lps'),
	(650749, 133, '2015-01-15 00:06:04.000000', 'consum', 0.0368, 'lps'),
	(650750, 133, '2015-01-15 00:06:05.000000', 'consum', 0.0395, 'lps'),
	(650751, 133, '2015-01-15 00:06:06.000000', 'consum', 0.0225, 'lps'),
	(650752, 133, '2015-01-15 00:06:07.000000', 'consum', 0.0381, 'lps'),
	(650753, 133, '2015-01-15 00:06:08.000000', 'consum', 0.0370, 'lps'),
	(650754, 133, '2015-01-15 00:06:09.000000', 'consum', 0.0283, 'lps'),
	(650755, 133, '2015-01-15 00:06:10.000000', 'consum', 0.0309, 'lps'),
	(650756, 133, '2015-01-15 00:06:11.000000', 'consum', 0.0270, 'lps'),
	(650757, 133, '2015-01-15 00:06:12.000000', 'consum', 0.0215, 'lps'),
	(650758, 133, '2015-01-15 00:06:13.000000', 'consum', 0.0274, 'lps'),
	(650759, 133, '2015-01-15 00:06:14.000000', 'consum', 0.0295, 'lps'),
	(650760, 133, '2015-01-15 00:06:15.000000', 'consum', 0.0229, 'lps'),
	(650761, 133, '2015-01-15 00:06:16.000000', 'consum', 0.0268, 'lps'),
	(650762, 133, '2015-01-15 00:06:17.000000', 'consum', 0.0225, 'lps'),
	(650763, 133, '2015-01-15 00:06:18.000000', 'consum', 0.0329, 'lps'),
	(650764, 133, '2015-01-15 00:06:19.000000', 'consum', 0.0326, 'lps'),
	(650765, 133, '2015-01-15 00:06:20.000000', 'consum', 0.0215, 'lps'),
	(650766, 133, '2015-01-15 00:06:21.000000', 'consum', 0.0321, 'lps'),
	(650767, 133, '2015-01-15 00:06:22.000000', 'consum', 0.0319, 'lps'),
	(650768, 133, '2015-01-15 00:06:23.000000', 'consum', 0.0423, 'lps'),
	(650769, 133, '2015-01-15 00:06:24.000000', 'consum', 0.0297, 'lps'),
	(650770, 133, '2015-01-15 00:06:25.000000', 'consum', 0.0222, 'lps'),
	(650771, 133, '2015-01-15 00:06:26.000000', 'consum', 0.0229, 'lps'),
	(650772, 133, '2015-01-15 00:06:27.000000', 'consum', 0.0267, 'lps'),
	(650773, 133, '2015-01-15 00:06:28.000000', 'consum', 0.0223, 'lps'),
	(650774, 133, '2015-01-15 00:06:29.000000', 'consum', 0.0321, 'lps'),
	(650775, 133, '2015-01-15 00:06:30.000000', 'consum', 0.0294, 'lps'),
	(650776, 133, '2015-01-15 00:06:31.000000', 'consum', 0.0297, 'lps'),
	(650777, 133, '2015-01-15 00:06:32.000000', 'consum', 0.0392, 'lps'),
	(650778, 133, '2015-01-15 00:06:33.000000', 'consum', 0.0210, 'lps'),
	(650779, 133, '2015-01-15 00:06:34.000000', 'consum', 0.0313, 'lps'),
	(650780, 133, '2015-01-15 00:06:35.000000', 'consum', 0.0293, 'lps'),
	(650781, 133, '2015-01-15 00:06:36.000000', 'consum', 0.0316, 'lps'),
	(650782, 133, '2015-01-15 00:06:37.000000', 'consum', 0.0274, 'lps'),
	(650783, 133, '2015-01-15 00:06:38.000000', 'consum', 0.0215, 'lps'),
	(650784, 133, '2015-01-15 00:06:39.000000', 'consum', 0.0259, 'lps'),
	(650785, 133, '2015-01-15 00:06:40.000000', 'consum', 0.0226, 'lps'),
	(650786, 133, '2015-01-15 00:06:41.000000', 'consum', 0.0357, 'lps'),
	(650787, 133, '2015-01-15 00:06:42.000000', 'consum', 0.0249, 'lps'),
	(650788, 133, '2015-01-15 00:06:43.000000', 'consum', 0.0399, 'lps'),
	(650789, 133, '2015-01-15 00:06:44.000000', 'consum', 0.0387, 'lps'),
	(650790, 133, '2015-01-15 00:06:45.000000', 'consum', 0.0312, 'lps'),
	(650791, 133, '2015-01-15 00:06:46.000000', 'consum', 0.0404, 'lps'),
	(650792, 133, '2015-01-15 00:06:47.000000', 'consum', 0.0227, 'lps'),
	(650793, 133, '2015-01-15 00:06:48.000000', 'consum', 0.0361, 'lps'),
	(650794, 133, '2015-01-15 00:06:49.000000', 'consum', 0.0267, 'lps'),
	(650795, 133, '2015-01-15 00:06:50.000000', 'consum', 0.0257, 'lps'),
	(650796, 133, '2015-01-15 00:06:51.000000', 'consum', 0.0273, 'lps'),
	(650797, 133, '2015-01-15 00:06:52.000000', 'consum', 0.0387, 'lps'),
	(650798, 133, '2015-01-15 00:06:53.000000', 'consum', 0.0254, 'lps'),
	(650799, 133, '2015-01-15 00:06:54.000000', 'consum', 0.0336, 'lps'),
	(650800, 133, '2015-01-15 00:06:55.000000', 'consum', 0.0272, 'lps'),
	(650801, 133, '2015-01-15 00:06:56.000000', 'consum', 0.0358, 'lps'),
	(650802, 133, '2015-01-15 00:06:57.000000', 'consum', 0.0333, 'lps'),
	(650803, 133, '2015-01-15 00:06:58.000000', 'consum', 0.0380, 'lps'),
	(650804, 133, '2015-01-15 00:06:59.000000', 'consum', 0.0260, 'lps'),
	(650805, 133, '2015-01-15 00:07:00.000000', 'consum', 0.0384, 'lps'),
	(650806, 133, '2015-01-15 00:07:01.000000', 'consum', 0.0279, 'lps'),
	(650807, 133, '2015-01-15 00:07:02.000000', 'consum', 0.0251, 'lps'),
	(650808, 133, '2015-01-15 00:07:03.000000', 'consum', 0.0425, 'lps'),
	(650809, 133, '2015-01-15 00:07:04.000000', 'consum', 0.0293, 'lps'),
	(650810, 133, '2015-01-15 00:07:05.000000', 'consum', 0.0417, 'lps'),
	(650811, 133, '2015-01-15 00:07:06.000000', 'consum', 0.0345, 'lps'),
	(650812, 133, '2015-01-15 00:07:07.000000', 'consum', 0.0263, 'lps'),
	(650813, 133, '2015-01-15 00:07:08.000000', 'consum', 0.0288, 'lps'),
	(650814, 133, '2015-01-15 00:07:09.000000', 'consum', 0.0225, 'lps'),
	(650815, 133, '2015-01-15 00:07:10.000000', 'consum', 0.0269, 'lps'),
	(650816, 133, '2015-01-15 00:07:11.000000', 'consum', 0.0244, 'lps'),
	(650817, 133, '2015-01-15 00:07:12.000000', 'consum', 0.0420, 'lps'),
	(650818, 133, '2015-01-15 00:07:13.000000', 'consum', 0.0291, 'lps'),
	(650819, 133, '2015-01-15 00:07:14.000000', 'consum', 0.0420, 'lps'),
	(650820, 133, '2015-01-15 00:07:15.000000', 'consum', 0.0364, 'lps'),
	(650821, 133, '2015-01-15 00:07:16.000000', 'consum', 0.0352, 'lps'),
	(650822, 133, '2015-01-15 00:07:17.000000', 'consum', 0.0240, 'lps'),
	(650823, 133, '2015-01-15 00:07:18.000000', 'consum', 0.0371, 'lps'),
	(650824, 133, '2015-01-15 00:07:19.000000', 'consum', 0.0274, 'lps'),
	(650825, 133, '2015-01-15 00:07:20.000000', 'consum', 0.0262, 'lps'),
	(650826, 133, '2015-01-15 00:07:21.000000', 'consum', 0.0281, 'lps'),
	(650827, 133, '2015-01-15 00:07:22.000000', 'consum', 0.0411, 'lps'),
	(650828, 133, '2015-01-15 00:07:23.000000', 'consum', 0.0350, 'lps'),
	(650829, 133, '2015-01-15 00:07:24.000000', 'consum', 0.0306, 'lps'),
	(650830, 133, '2015-01-15 00:07:25.000000', 'consum', 0.0270, 'lps'),
	(650831, 133, '2015-01-15 00:07:26.000000', 'consum', 0.0224, 'lps'),
	(650832, 133, '2015-01-15 00:07:27.000000', 'consum', 0.0319, 'lps'),
	(650833, 133, '2015-01-15 00:07:28.000000', 'consum', 0.0279, 'lps'),
	(650834, 133, '2015-01-15 00:07:29.000000', 'consum', 0.0229, 'lps'),
	(650835, 133, '2015-01-15 00:07:30.000000', 'consum', 0.0316, 'lps'),
	(650836, 133, '2015-01-15 00:07:31.000000', 'consum', 0.0249, 'lps'),
	(650837, 133, '2015-01-15 00:07:32.000000', 'consum', 0.0302, 'lps'),
	(650838, 133, '2015-01-15 00:07:33.000000', 'consum', 0.0339, 'lps'),
	(650839, 133, '2015-01-15 00:07:34.000000', 'consum', 0.0360, 'lps'),
	(650840, 133, '2015-01-15 00:07:35.000000', 'consum', 0.0360, 'lps'),
	(650841, 133, '2015-01-15 00:07:36.000000', 'consum', 0.0290, 'lps'),
	(650842, 133, '2015-01-15 00:07:37.000000', 'consum', 0.0379, 'lps'),
	(650843, 133, '2015-01-15 00:07:38.000000', 'consum', 0.0381, 'lps'),
	(650844, 133, '2015-01-15 00:07:39.000000', 'consum', 0.0342, 'lps'),
	(650845, 133, '2015-01-15 00:07:40.000000', 'consum', 0.0358, 'lps'),
	(650846, 133, '2015-01-15 00:07:41.000000', 'consum', 0.0337, 'lps'),
	(650847, 133, '2015-01-15 00:07:42.000000', 'consum', 0.0401, 'lps'),
	(650848, 133, '2015-01-15 00:07:43.000000', 'consum', 0.0349, 'lps'),
	(650849, 133, '2015-01-15 00:07:44.000000', 'consum', 0.0334, 'lps'),
	(650850, 133, '2015-01-15 00:07:45.000000', 'consum', 0.0415, 'lps'),
	(650851, 133, '2015-01-15 00:07:46.000000', 'consum', 0.0212, 'lps'),
	(650852, 133, '2015-01-15 00:07:47.000000', 'consum', 0.0254, 'lps'),
	(650853, 133, '2015-01-15 00:07:48.000000', 'consum', 0.0426, 'lps'),
	(650854, 133, '2015-01-15 00:07:49.000000', 'consum', 0.0292, 'lps'),
	(650855, 133, '2015-01-15 00:07:50.000000', 'consum', 0.0407, 'lps'),
	(650856, 133, '2015-01-15 00:07:51.000000', 'consum', 0.0296, 'lps'),
	(650857, 133, '2015-01-15 00:07:52.000000', 'consum', 0.0268, 'lps'),
	(650858, 133, '2015-01-15 00:07:53.000000', 'consum', 0.0244, 'lps'),
	(650859, 133, '2015-01-15 00:07:54.000000', 'consum', 0.0421, 'lps'),
	(650860, 133, '2015-01-15 00:07:55.000000', 'consum', 0.0297, 'lps'),
	(650861, 133, '2015-01-15 00:07:56.000000', 'consum', 0.0228, 'lps'),
	(650862, 133, '2015-01-15 00:07:57.000000', 'consum', 0.0256, 'lps'),
	(650863, 133, '2015-01-15 00:07:58.000000', 'consum', 0.0389, 'lps'),
	(650864, 133, '2015-01-15 00:07:59.000000', 'consum', 0.0315, 'lps'),
	(650865, 133, '2015-01-15 00:08:00.000000', 'consum', 0.0417, 'lps'),
	(650866, 133, '2015-01-15 00:08:01.000000', 'consum', 0.0278, 'lps'),
	(650867, 133, '2015-01-15 00:08:02.000000', 'consum', 0.0363, 'lps'),
	(650868, 133, '2015-01-15 00:08:03.000000', 'consum', 0.0337, 'lps'),
	(650869, 133, '2015-01-15 00:08:04.000000', 'consum', 0.0388, 'lps'),
	(650870, 133, '2015-01-15 00:08:05.000000', 'consum', 0.0287, 'lps'),
	(650871, 133, '2015-01-15 00:08:06.000000', 'consum', 0.0276, 'lps'),
	(650872, 133, '2015-01-15 00:08:07.000000', 'consum', 0.0312, 'lps'),
	(650873, 133, '2015-01-15 00:08:08.000000', 'consum', 0.0302, 'lps'),
	(650874, 133, '2015-01-15 00:08:09.000000', 'consum', 0.0368, 'lps'),
	(650875, 133, '2015-01-15 00:08:10.000000', 'consum', 0.0287, 'lps'),
	(650876, 133, '2015-01-15 00:08:11.000000', 'consum', 0.0341, 'lps'),
	(650877, 133, '2015-01-15 00:08:12.000000', 'consum', 0.0417, 'lps'),
	(650878, 133, '2015-01-15 00:08:13.000000', 'consum', 0.0419, 'lps'),
	(650879, 133, '2015-01-15 00:08:14.000000', 'consum', 0.0417, 'lps'),
	(650880, 133, '2015-01-15 00:08:15.000000', 'consum', 0.0399, 'lps'),
	(650881, 133, '2015-01-15 00:08:16.000000', 'consum', 0.0321, 'lps'),
	(650882, 133, '2015-01-15 00:08:17.000000', 'consum', 0.0415, 'lps'),
	(650883, 133, '2015-01-15 00:08:18.000000', 'consum', 0.0252, 'lps'),
	(650884, 133, '2015-01-15 00:08:19.000000', 'consum', 0.0240, 'lps'),
	(650885, 133, '2015-01-15 00:08:20.000000', 'consum', 0.0236, 'lps'),
	(650886, 133, '2015-01-15 00:08:21.000000', 'consum', 0.0247, 'lps'),
	(650887, 133, '2015-01-15 00:08:22.000000', 'consum', 0.0320, 'lps'),
	(650888, 133, '2015-01-15 00:08:23.000000', 'consum', 0.0214, 'lps'),
	(650889, 133, '2015-01-15 00:08:24.000000', 'consum', 0.0334, 'lps'),
	(650890, 133, '2015-01-15 00:08:25.000000', 'consum', 0.0384, 'lps'),
	(650891, 133, '2015-01-15 00:08:26.000000', 'consum', 0.0274, 'lps'),
	(650892, 133, '2015-01-15 00:08:27.000000', 'consum', 0.0226, 'lps'),
	(650893, 133, '2015-01-15 00:08:28.000000', 'consum', 0.0317, 'lps'),
	(650894, 133, '2015-01-15 00:08:29.000000', 'consum', 0.0264, 'lps'),
	(650895, 133, '2015-01-15 00:08:30.000000', 'consum', 0.0375, 'lps'),
	(650896, 133, '2015-01-15 00:08:31.000000', 'consum', 0.0222, 'lps'),
	(650897, 133, '2015-01-15 00:08:32.000000', 'consum', 0.0426, 'lps'),
	(650898, 133, '2015-01-15 00:08:33.000000', 'consum', 0.0385, 'lps'),
	(650899, 133, '2015-01-15 00:08:34.000000', 'consum', 0.0223, 'lps'),
	(650900, 133, '2015-01-15 00:08:35.000000', 'consum', 0.0400, 'lps'),
	(650901, 133, '2015-01-15 00:08:36.000000', 'consum', 0.0255, 'lps'),
	(650902, 133, '2015-01-15 00:08:37.000000', 'consum', 0.0300, 'lps'),
	(650903, 133, '2015-01-15 00:08:38.000000', 'consum', 0.0308, 'lps'),
	(650904, 133, '2015-01-15 00:08:39.000000', 'consum', 0.0213, 'lps'),
	(650905, 133, '2015-01-15 00:08:40.000000', 'consum', 0.0366, 'lps'),
	(650906, 133, '2015-01-15 00:08:41.000000', 'consum', 0.0330, 'lps'),
	(650907, 133, '2015-01-15 00:08:42.000000', 'consum', 0.0342, 'lps'),
	(650908, 133, '2015-01-15 00:08:43.000000', 'consum', 0.0293, 'lps'),
	(650909, 133, '2015-01-15 00:08:44.000000', 'consum', 0.0229, 'lps'),
	(650910, 133, '2015-01-15 00:08:45.000000', 'consum', 0.0276, 'lps'),
	(650911, 133, '2015-01-15 00:08:46.000000', 'consum', 0.0267, 'lps'),
	(650912, 133, '2015-01-15 00:08:47.000000', 'consum', 0.0295, 'lps'),
	(650913, 133, '2015-01-15 00:08:48.000000', 'consum', 0.0248, 'lps'),
	(650914, 133, '2015-01-15 00:08:49.000000', 'consum', 0.0364, 'lps'),
	(650915, 133, '2015-01-15 00:08:50.000000', 'consum', 0.0214, 'lps'),
	(650916, 133, '2015-01-15 00:08:51.000000', 'consum', 0.0421, 'lps'),
	(650917, 133, '2015-01-15 00:08:52.000000', 'consum', 0.0384, 'lps'),
	(650918, 133, '2015-01-15 00:08:53.000000', 'consum', 0.0230, 'lps'),
	(650919, 133, '2015-01-15 00:08:54.000000', 'consum', 0.0223, 'lps'),
	(650920, 133, '2015-01-15 00:08:55.000000', 'consum', 0.0218, 'lps'),
	(650921, 133, '2015-01-15 00:08:56.000000', 'consum', 0.0425, 'lps'),
	(650922, 133, '2015-01-15 00:08:57.000000', 'consum', 0.0396, 'lps'),
	(650923, 133, '2015-01-15 00:08:58.000000', 'consum', 0.0276, 'lps'),
	(650924, 133, '2015-01-15 00:08:59.000000', 'consum', 0.0418, 'lps'),
	(650925, 133, '2015-01-15 00:09:00.000000', 'consum', 0.0400, 'lps'),
	(650926, 133, '2015-01-15 00:09:01.000000', 'consum', 0.0320, 'lps'),
	(650927, 133, '2015-01-15 00:09:02.000000', 'consum', 0.0407, 'lps'),
	(650928, 133, '2015-01-15 00:09:03.000000', 'consum', 0.0214, 'lps'),
	(650929, 133, '2015-01-15 00:09:04.000000', 'consum', 0.0292, 'lps'),
	(650930, 133, '2015-01-15 00:09:05.000000', 'consum', 0.0391, 'lps'),
	(650931, 133, '2015-01-15 00:09:06.000000', 'consum', 0.0219, 'lps'),
	(650932, 133, '2015-01-15 00:09:07.000000', 'consum', 0.0363, 'lps'),
	(650933, 133, '2015-01-15 00:09:08.000000', 'consum', 0.0297, 'lps'),
	(650934, 133, '2015-01-15 00:09:09.000000', 'consum', 0.0402, 'lps'),
	(650935, 133, '2015-01-15 00:09:10.000000', 'consum', 0.0262, 'lps'),
	(650936, 133, '2015-01-15 00:09:11.000000', 'consum', 0.0325, 'lps'),
	(650937, 133, '2015-01-15 00:09:12.000000', 'consum', 0.0414, 'lps'),
	(650938, 133, '2015-01-15 00:09:13.000000', 'consum', 0.0236, 'lps'),
	(650939, 133, '2015-01-15 00:09:14.000000', 'consum', 0.0379, 'lps'),
	(650940, 133, '2015-01-15 00:09:15.000000', 'consum', 0.0327, 'lps'),
	(650941, 133, '2015-01-15 00:09:16.000000', 'consum', 0.0288, 'lps'),
	(650942, 133, '2015-01-15 00:09:17.000000', 'consum', 0.0251, 'lps'),
	(650943, 133, '2015-01-15 00:09:18.000000', 'consum', 0.0396, 'lps'),
	(650944, 133, '2015-01-15 00:09:19.000000', 'consum', 0.0368, 'lps'),
	(650945, 133, '2015-01-15 00:09:20.000000', 'consum', 0.0225, 'lps'),
	(650946, 133, '2015-01-15 00:09:21.000000', 'consum', 0.0246, 'lps'),
	(650947, 133, '2015-01-15 00:09:22.000000', 'consum', 0.0344, 'lps'),
	(650948, 133, '2015-01-15 00:09:23.000000', 'consum', 0.0339, 'lps'),
	(650949, 133, '2015-01-15 00:09:24.000000', 'consum', 0.0238, 'lps'),
	(650950, 133, '2015-01-15 00:09:25.000000', 'consum', 0.0396, 'lps'),
	(650951, 133, '2015-01-15 00:09:26.000000', 'consum', 0.0404, 'lps'),
	(650952, 133, '2015-01-15 00:09:27.000000', 'consum', 0.0406, 'lps'),
	(650953, 133, '2015-01-15 00:09:28.000000', 'consum', 0.0394, 'lps'),
	(650954, 133, '2015-01-15 00:09:29.000000', 'consum', 0.0323, 'lps'),
	(650955, 133, '2015-01-15 00:09:30.000000', 'consum', 0.0223, 'lps'),
	(650956, 133, '2015-01-15 00:09:31.000000', 'consum', 0.0372, 'lps'),
	(650957, 133, '2015-01-15 00:09:32.000000', 'consum', 0.0331, 'lps'),
	(650958, 133, '2015-01-15 00:09:33.000000', 'consum', 0.0328, 'lps'),
	(650959, 133, '2015-01-15 00:09:34.000000', 'consum', 0.0221, 'lps'),
	(650960, 133, '2015-01-15 00:09:35.000000', 'consum', 0.0344, 'lps'),
	(650961, 133, '2015-01-15 00:09:36.000000', 'consum', 0.0415, 'lps'),
	(650962, 133, '2015-01-15 00:09:37.000000', 'consum', 0.0400, 'lps'),
	(650963, 133, '2015-01-15 00:09:38.000000', 'consum', 0.0327, 'lps'),
	(650964, 133, '2015-01-15 00:09:39.000000', 'consum', 0.0228, 'lps'),
	(650965, 133, '2015-01-15 00:09:40.000000', 'consum', 0.0383, 'lps'),
	(650966, 133, '2015-01-15 00:09:41.000000', 'consum', 0.0369, 'lps'),
	(650967, 133, '2015-01-15 00:09:42.000000', 'consum', 0.0270, 'lps'),
	(650968, 133, '2015-01-15 00:09:43.000000', 'consum', 0.0252, 'lps'),
	(650969, 133, '2015-01-15 00:09:44.000000', 'consum', 0.0241, 'lps'),
	(650970, 133, '2015-01-15 00:09:45.000000', 'consum', 0.0237, 'lps'),
	(650971, 133, '2015-01-15 00:09:46.000000', 'consum', 0.0253, 'lps'),
	(650972, 133, '2015-01-15 00:09:47.000000', 'consum', 0.0344, 'lps'),
	(650973, 133, '2015-01-15 00:09:48.000000', 'consum', 0.0319, 'lps'),
	(650974, 133, '2015-01-15 00:09:49.000000', 'consum', 0.0354, 'lps'),
	(650975, 133, '2015-01-15 00:09:50.000000', 'consum', 0.0388, 'lps'),
	(650976, 133, '2015-01-15 00:09:51.000000', 'consum', 0.0231, 'lps'),
	(650977, 133, '2015-01-15 00:09:52.000000', 'consum', 0.0217, 'lps'),
	(650978, 133, '2015-01-15 00:09:53.000000', 'consum', 0.0399, 'lps'),
	(650979, 133, '2015-01-15 00:09:54.000000', 'consum', 0.0269, 'lps'),
	(650980, 133, '2015-01-15 00:09:55.000000', 'consum', 0.0370, 'lps'),
	(650981, 133, '2015-01-15 00:09:56.000000', 'consum', 0.0399, 'lps'),
	(650982, 133, '2015-01-15 00:09:57.000000', 'consum', 0.0244, 'lps'),
	(650983, 133, '2015-01-15 00:09:58.000000', 'consum', 0.0246, 'lps'),
	(650984, 133, '2015-01-15 00:09:59.000000', 'consum', 0.0289, 'lps'),
	(650985, 133, '2015-01-15 00:10:00.000000', 'consum', 0.0280, 'lps'),
	(650986, 133, '2015-01-15 00:10:01.000000', 'consum', 0.0325, 'lps'),
	(650987, 133, '2015-01-15 00:10:02.000000', 'consum', 0.0358, 'lps'),
	(650988, 133, '2015-01-15 00:10:03.000000', 'consum', 0.0389, 'lps'),
	(650989, 133, '2015-01-15 00:10:04.000000', 'consum', 0.0227, 'lps'),
	(650990, 133, '2015-01-15 00:10:05.000000', 'consum', 0.0408, 'lps'),
	(650991, 133, '2015-01-15 00:10:06.000000', 'consum', 0.0283, 'lps'),
	(650992, 133, '2015-01-15 00:10:07.000000', 'consum', 0.0417, 'lps'),
	(650993, 133, '2015-01-15 00:10:08.000000', 'consum', 0.0374, 'lps'),
	(650994, 133, '2015-01-15 00:10:09.000000', 'consum', 0.0408, 'lps'),
	(650995, 133, '2015-01-15 00:10:10.000000', 'consum', 0.0277, 'lps'),
	(650996, 133, '2015-01-15 00:10:11.000000', 'consum', 0.0386, 'lps'),
	(650997, 133, '2015-01-15 00:10:12.000000', 'consum', 0.0237, 'lps'),
	(650998, 133, '2015-01-15 00:10:13.000000', 'consum', 0.0251, 'lps'),
	(650999, 133, '2015-01-15 00:10:14.000000', 'consum', 0.0336, 'lps'),
	(651000, 133, '2015-01-15 00:10:15.000000', 'consum', 0.0284, 'lps'),
	(651001, 133, '2015-01-15 00:10:16.000000', 'consum', 0.0419, 'lps'),
	(651002, 133, '2015-01-15 00:10:17.000000', 'consum', 0.0383, 'lps'),
	(651003, 133, '2015-01-15 00:10:18.000000', 'consum', 0.0232, 'lps'),
	(651004, 133, '2015-01-15 00:10:19.000000', 'consum', 0.0234, 'lps'),
	(651005, 133, '2015-01-15 00:10:20.000000', 'consum', 0.0266, 'lps'),
	(651006, 133, '2015-01-15 00:10:21.000000', 'consum', 0.0416, 'lps'),
	(651007, 133, '2015-01-15 00:10:22.000000', 'consum', 0.0422, 'lps'),
	(651008, 133, '2015-01-15 00:10:23.000000', 'consum', 0.0220, 'lps'),
	(651009, 133, '2015-01-15 00:10:24.000000', 'consum', 0.0276, 'lps'),
	(651010, 133, '2015-01-15 00:10:25.000000', 'consum', 0.0295, 'lps'),
	(651011, 133, '2015-01-15 00:10:26.000000', 'consum', 0.0217, 'lps'),
	(651012, 133, '2015-01-15 00:10:27.000000', 'consum', 0.0426, 'lps'),
	(651013, 133, '2015-01-15 00:10:28.000000', 'consum', 0.0403, 'lps'),
	(651014, 133, '2015-01-15 00:10:29.000000', 'consum', 0.0309, 'lps'),
	(651015, 133, '2015-01-15 00:10:30.000000', 'consum', 0.0345, 'lps'),
	(651016, 133, '2015-01-15 00:10:31.000000', 'consum', 0.0369, 'lps'),
	(651017, 133, '2015-01-15 00:10:32.000000', 'consum', 0.0384, 'lps'),
	(651018, 133, '2015-01-15 00:10:33.000000', 'consum', 0.0386, 'lps'),
	(651019, 133, '2015-01-15 00:10:34.000000', 'consum', 0.0351, 'lps'),
	(651020, 133, '2015-01-15 00:10:35.000000', 'consum', 0.0388, 'lps'),
	(651021, 133, '2015-01-15 00:10:36.000000', 'consum', 0.0243, 'lps'),
	(651022, 133, '2015-01-15 00:10:37.000000', 'consum', 0.0276, 'lps'),
	(651023, 133, '2015-01-15 00:10:38.000000', 'consum', 0.0226, 'lps'),
	(651024, 133, '2015-01-15 00:10:39.000000', 'consum', 0.0308, 'lps'),
	(651025, 133, '2015-01-15 00:10:40.000000', 'consum', 0.0218, 'lps'),
	(651026, 133, '2015-01-15 00:10:41.000000', 'consum', 0.0393, 'lps'),
	(651027, 133, '2015-01-15 00:10:42.000000', 'consum', 0.0233, 'lps'),
	(651028, 133, '2015-01-15 00:10:43.000000', 'consum', 0.0425, 'lps'),
	(651029, 133, '2015-01-15 00:10:44.000000', 'consum', 0.0351, 'lps'),
	(651030, 133, '2015-01-15 00:10:45.000000', 'consum', 0.0270, 'lps'),
	(651031, 133, '2015-01-15 00:10:46.000000', 'consum', 0.0306, 'lps'),
	(651032, 133, '2015-01-15 00:10:47.000000', 'consum', 0.0292, 'lps'),
	(651033, 133, '2015-01-15 00:10:48.000000', 'consum', 0.0334, 'lps'),
	(651034, 133, '2015-01-15 00:10:49.000000', 'consum', 0.0368, 'lps'),
	(651035, 133, '2015-01-15 00:10:50.000000', 'consum', 0.0412, 'lps'),
	(651036, 133, '2015-01-15 00:10:51.000000', 'consum', 0.0313, 'lps'),
	(651037, 133, '2015-01-15 00:10:52.000000', 'consum', 0.0337, 'lps'),
	(651038, 133, '2015-01-15 00:10:53.000000', 'consum', 0.0317, 'lps'),
	(651039, 133, '2015-01-15 00:10:54.000000', 'consum', 0.0364, 'lps'),
	(651040, 133, '2015-01-15 00:10:55.000000', 'consum', 0.0227, 'lps'),
	(651041, 133, '2015-01-15 00:10:56.000000', 'consum', 0.0268, 'lps'),
	(651042, 133, '2015-01-15 00:10:57.000000', 'consum', 0.0230, 'lps'),
	(651043, 133, '2015-01-15 00:10:58.000000', 'consum', 0.0356, 'lps'),
	(651044, 133, '2015-01-15 00:10:59.000000', 'consum', 0.0228, 'lps'),
	(651045, 133, '2015-01-15 00:11:00.000000', 'consum', 0.0298, 'lps'),
	(651046, 133, '2015-01-15 00:11:01.000000', 'consum', 0.0379, 'lps'),
	(651047, 133, '2015-01-15 00:11:02.000000', 'consum', 0.0359, 'lps'),
	(651048, 133, '2015-01-15 00:11:03.000000', 'consum', 0.0229, 'lps'),
	(651049, 133, '2015-01-15 00:11:04.000000', 'consum', 0.0293, 'lps'),
	(651050, 133, '2015-01-15 00:11:05.000000', 'consum', 0.0352, 'lps'),
	(651051, 133, '2015-01-15 00:11:06.000000', 'consum', 0.0237, 'lps'),
	(651052, 133, '2015-01-15 00:11:07.000000', 'consum', 0.0355, 'lps'),
	(651053, 133, '2015-01-15 00:11:08.000000', 'consum', 0.0418, 'lps'),
	(651054, 133, '2015-01-15 00:11:09.000000', 'consum', 0.0382, 'lps'),
	(651055, 133, '2015-01-15 00:11:10.000000', 'consum', 0.0229, 'lps'),
	(651056, 133, '2015-01-15 00:11:11.000000', 'consum', 0.0225, 'lps'),
	(651057, 133, '2015-01-15 00:11:12.000000', 'consum', 0.0230, 'lps'),
	(651058, 133, '2015-01-15 00:11:13.000000', 'consum', 0.0263, 'lps'),
	(651059, 133, '2015-01-15 00:11:14.000000', 'consum', 0.0417, 'lps'),
	(651060, 133, '2015-01-15 00:11:15.000000', 'consum', 0.0217, 'lps'),
	(651061, 133, '2015-01-15 00:11:16.000000', 'consum', 0.0277, 'lps'),
	(651062, 133, '2015-01-15 00:11:17.000000', 'consum', 0.0306, 'lps'),
	(651063, 133, '2015-01-15 00:11:18.000000', 'consum', 0.0272, 'lps'),
	(651064, 133, '2015-01-15 00:11:19.000000', 'consum', 0.0234, 'lps'),
	(651065, 133, '2015-01-15 00:11:20.000000', 'consum', 0.0360, 'lps'),
	(651066, 133, '2015-01-15 00:11:21.000000', 'consum', 0.0240, 'lps'),
	(651067, 133, '2015-01-15 00:11:22.000000', 'consum', 0.0344, 'lps'),
	(651068, 133, '2015-01-15 00:11:23.000000', 'consum', 0.0356, 'lps'),
	(651069, 133, '2015-01-15 00:11:24.000000', 'consum', 0.0323, 'lps'),
	(651070, 133, '2015-01-15 00:11:25.000000', 'consum', 0.0335, 'lps'),
	(651071, 133, '2015-01-15 00:11:26.000000', 'consum', 0.0279, 'lps'),
	(651072, 133, '2015-01-15 00:11:27.000000', 'consum', 0.0399, 'lps'),
	(651073, 133, '2015-01-15 00:11:28.000000', 'consum', 0.0295, 'lps'),
	(651074, 133, '2015-01-15 00:11:29.000000', 'consum', 0.0287, 'lps'),
	(651075, 133, '2015-01-15 00:11:30.000000', 'consum', 0.0342, 'lps'),
	(651076, 133, '2015-01-15 00:11:31.000000', 'consum', 0.0421, 'lps'),
	(651077, 133, '2015-01-15 00:11:32.000000', 'consum', 0.0220, 'lps'),
	(651078, 133, '2015-01-15 00:11:33.000000', 'consum', 0.0279, 'lps'),
	(651079, 133, '2015-01-15 00:11:34.000000', 'consum', 0.0308, 'lps'),
	(651080, 133, '2015-01-15 00:11:35.000000', 'consum', 0.0275, 'lps'),
	(651081, 133, '2015-01-15 00:11:36.000000', 'consum', 0.0244, 'lps'),
	(651082, 133, '2015-01-15 00:11:37.000000', 'consum', 0.0402, 'lps'),
	(651083, 133, '2015-01-15 00:11:38.000000', 'consum', 0.0419, 'lps'),
	(651084, 133, '2015-01-15 00:11:39.000000', 'consum', 0.0243, 'lps'),
	(651085, 133, '2015-01-15 00:11:40.000000', 'consum', 0.0401, 'lps'),
	(651086, 133, '2015-01-15 00:11:41.000000', 'consum', 0.0416, 'lps'),
	(651087, 133, '2015-01-15 00:11:42.000000', 'consum', 0.0233, 'lps'),
	(651088, 133, '2015-01-15 00:11:43.000000', 'consum', 0.0357, 'lps'),
	(651089, 133, '2015-01-15 00:11:44.000000', 'consum', 0.0225, 'lps'),
	(651090, 133, '2015-01-15 00:11:45.000000', 'consum', 0.0279, 'lps'),
	(651091, 133, '2015-01-15 00:11:46.000000', 'consum', 0.0292, 'lps'),
	(651092, 133, '2015-01-15 00:11:47.000000', 'consum', 0.0416, 'lps'),
	(651093, 133, '2015-01-15 00:11:48.000000', 'consum', 0.0342, 'lps'),
	(651094, 133, '2015-01-15 00:11:49.000000', 'consum', 0.0254, 'lps'),
	(651095, 133, '2015-01-15 00:11:50.000000', 'consum', 0.0249, 'lps'),
	(651096, 133, '2015-01-15 00:11:51.000000', 'consum', 0.0276, 'lps'),
	(651097, 133, '2015-01-15 00:11:52.000000', 'consum', 0.0424, 'lps'),
	(651098, 133, '2015-01-15 00:11:53.000000', 'consum', 0.0215, 'lps'),
	(651099, 133, '2015-01-15 00:11:54.000000', 'consum', 0.0245, 'lps'),
	(651100, 133, '2015-01-15 00:11:55.000000', 'consum', 0.0368, 'lps'),
	(651101, 133, '2015-01-15 00:11:56.000000', 'consum', 0.0247, 'lps'),
	(651102, 133, '2015-01-15 00:11:57.000000', 'consum', 0.0353, 'lps'),
	(651103, 133, '2015-01-15 00:11:58.000000', 'consum', 0.0382, 'lps'),
	(651104, 133, '2015-01-15 00:11:59.000000', 'consum', 0.0424, 'lps'),
	(651105, 133, '2015-01-15 00:12:00.000000', 'consum', 0.0330, 'lps'),
	(651106, 133, '2015-01-15 00:12:01.000000', 'consum', 0.0385, 'lps'),
	(651107, 133, '2015-01-15 00:12:02.000000', 'consum', 0.0291, 'lps'),
	(651108, 133, '2015-01-15 00:12:03.000000', 'consum', 0.0308, 'lps'),
	(651109, 133, '2015-01-15 00:12:04.000000', 'consum', 0.0239, 'lps'),
	(651110, 133, '2015-01-15 00:12:05.000000', 'consum', 0.0282, 'lps'),
	(651111, 133, '2015-01-15 00:12:06.000000', 'consum', 0.0263, 'lps'),
	(651112, 133, '2015-01-15 00:12:07.000000', 'consum', 0.0262, 'lps'),
	(651113, 133, '2015-01-15 00:12:08.000000', 'consum', 0.0309, 'lps'),
	(651114, 133, '2015-01-15 00:12:09.000000', 'consum', 0.0334, 'lps'),
	(651115, 133, '2015-01-15 00:12:10.000000', 'consum', 0.0316, 'lps'),
	(651116, 133, '2015-01-15 00:12:11.000000', 'consum', 0.0370, 'lps'),
	(651117, 133, '2015-01-15 00:12:12.000000', 'consum', 0.0258, 'lps'),
	(651118, 133, '2015-01-15 00:12:13.000000', 'consum', 0.0403, 'lps'),
	(651119, 133, '2015-01-15 00:12:14.000000', 'consum', 0.0383, 'lps'),
	(651120, 133, '2015-01-15 00:12:15.000000', 'consum', 0.0277, 'lps'),
	(651121, 133, '2015-01-15 00:12:16.000000', 'consum', 0.0243, 'lps'),
	(651122, 133, '2015-01-15 00:12:17.000000', 'consum', 0.0394, 'lps'),
	(651123, 133, '2015-01-15 00:12:18.000000', 'consum', 0.0377, 'lps'),
	(651124, 133, '2015-01-15 00:12:19.000000', 'consum', 0.0280, 'lps'),
	(651125, 133, '2015-01-15 00:12:20.000000', 'consum', 0.0275, 'lps'),
	(651126, 133, '2015-01-15 00:12:21.000000', 'consum', 0.0324, 'lps'),
	(651127, 133, '2015-01-15 00:12:22.000000', 'consum', 0.0368, 'lps'),
	(651128, 133, '2015-01-15 00:12:23.000000', 'consum', 0.0227, 'lps'),
	(651129, 133, '2015-01-15 00:12:24.000000', 'consum', 0.0256, 'lps'),
	(651130, 133, '2015-01-15 00:12:25.000000', 'consum', 0.0390, 'lps'),
	(651131, 133, '2015-01-15 00:12:26.000000', 'consum', 0.0322, 'lps'),
	(651132, 133, '2015-01-15 00:12:27.000000', 'consum', 0.0229, 'lps'),
	(651133, 133, '2015-01-15 00:12:28.000000', 'consum', 0.0406, 'lps'),
	(651134, 133, '2015-01-15 00:12:29.000000', 'consum', 0.0263, 'lps'),
	(651135, 133, '2015-01-15 00:12:30.000000', 'consum', 0.0321, 'lps'),
	(651136, 133, '2015-01-15 00:12:31.000000', 'consum', 0.0392, 'lps'),
	(651137, 133, '2015-01-15 00:12:32.000000', 'consum', 0.0353, 'lps'),
	(651138, 133, '2015-01-15 00:12:33.000000', 'consum', 0.0380, 'lps'),
	(651139, 133, '2015-01-15 00:12:34.000000', 'consum', 0.0414, 'lps'),
	(651140, 133, '2015-01-15 00:12:35.000000', 'consum', 0.0288, 'lps'),
	(651141, 133, '2015-01-15 00:12:36.000000', 'consum', 0.0420, 'lps'),
	(651142, 133, '2015-01-15 00:12:37.000000', 'consum', 0.0377, 'lps'),
	(651143, 133, '2015-01-15 00:12:38.000000', 'consum', 0.0416, 'lps'),
	(651144, 133, '2015-01-15 00:12:39.000000', 'consum', 0.0306, 'lps'),
	(651145, 133, '2015-01-15 00:12:40.000000', 'consum', 0.0289, 'lps'),
	(651146, 133, '2015-01-15 00:12:41.000000', 'consum', 0.0318, 'lps'),
	(651147, 133, '2015-01-15 00:12:42.000000', 'consum', 0.0297, 'lps'),
	(651148, 133, '2015-01-15 00:12:43.000000', 'consum', 0.0321, 'lps'),
	(651149, 133, '2015-01-15 00:12:44.000000', 'consum', 0.0287, 'lps'),
	(651150, 133, '2015-01-15 00:12:45.000000', 'consum', 0.0262, 'lps'),
	(651151, 133, '2015-01-15 00:12:46.000000', 'consum', 0.0239, 'lps'),
	(651152, 133, '2015-01-15 00:12:47.000000', 'consum', 0.0417, 'lps'),
	(651153, 133, '2015-01-15 00:12:48.000000', 'consum', 0.0289, 'lps'),
	(651154, 133, '2015-01-15 00:12:49.000000', 'consum', 0.0419, 'lps'),
	(651155, 133, '2015-01-15 00:12:50.000000', 'consum', 0.0366, 'lps'),
	(651156, 133, '2015-01-15 00:12:51.000000', 'consum', 0.0367, 'lps'),
	(651157, 133, '2015-01-15 00:12:52.000000', 'consum', 0.0307, 'lps'),
	(651158, 133, '2015-01-15 00:12:53.000000', 'consum', 0.0226, 'lps'),
	(651159, 133, '2015-01-15 00:12:54.000000', 'consum', 0.0218, 'lps'),
	(651160, 133, '2015-01-15 00:12:55.000000', 'consum', 0.0417, 'lps'),
	(651161, 133, '2015-01-15 00:12:56.000000', 'consum', 0.0354, 'lps'),
	(651162, 133, '2015-01-15 00:12:57.000000', 'consum', 0.0309, 'lps'),
	(651163, 133, '2015-01-15 00:12:58.000000', 'consum', 0.0276, 'lps'),
	(651164, 133, '2015-01-15 00:12:59.000000', 'consum', 0.0242, 'lps'),
	(651165, 133, '2015-01-15 00:13:00.000000', 'consum', 0.0391, 'lps'),
	(651166, 133, '2015-01-15 00:13:01.000000', 'consum', 0.0370, 'lps'),
	(651167, 133, '2015-01-15 00:13:02.000000', 'consum', 0.0247, 'lps'),
	(651168, 133, '2015-01-15 00:13:03.000000', 'consum', 0.0352, 'lps'),
	(651169, 133, '2015-01-15 00:13:04.000000', 'consum', 0.0375, 'lps'),
	(651170, 133, '2015-01-15 00:13:05.000000', 'consum', 0.0391, 'lps'),
	(651171, 133, '2015-01-15 00:13:06.000000', 'consum', 0.0406, 'lps'),
	(651172, 133, '2015-01-15 00:13:07.000000', 'consum', 0.0213, 'lps'),
	(651173, 133, '2015-01-15 00:13:08.000000', 'consum', 0.0286, 'lps'),
	(651174, 133, '2015-01-15 00:13:09.000000', 'consum', 0.0368, 'lps'),
	(651175, 133, '2015-01-15 00:13:10.000000', 'consum', 0.0337, 'lps'),
	(651176, 133, '2015-01-15 00:13:11.000000', 'consum', 0.0372, 'lps'),
	(651177, 133, '2015-01-15 00:13:12.000000', 'consum', 0.0420, 'lps'),
	(651178, 133, '2015-01-15 00:13:13.000000', 'consum', 0.0343, 'lps'),
	(651179, 133, '2015-01-15 00:13:14.000000', 'consum', 0.0244, 'lps'),
	(651180, 133, '2015-01-15 00:13:15.000000', 'consum', 0.0417, 'lps'),
	(651181, 133, '2015-01-15 00:13:16.000000', 'consum', 0.0277, 'lps'),
	(651182, 133, '2015-01-15 00:13:17.000000', 'consum', 0.0355, 'lps'),
	(651183, 133, '2015-01-15 00:13:18.000000', 'consum', 0.0302, 'lps'),
	(651184, 133, '2015-01-15 00:13:19.000000', 'consum', 0.0234, 'lps'),
	(651185, 133, '2015-01-15 00:13:20.000000', 'consum', 0.0272, 'lps'),
	(651186, 133, '2015-01-15 00:13:21.000000', 'consum', 0.0230, 'lps'),
	(651187, 133, '2015-01-15 00:13:22.000000', 'consum', 0.0343, 'lps'),
	(651188, 133, '2015-01-15 00:13:23.000000', 'consum', 0.0382, 'lps'),
	(651189, 133, '2015-01-15 00:13:24.000000', 'consum', 0.0236, 'lps'),
	(651190, 133, '2015-01-15 00:13:25.000000', 'consum', 0.0260, 'lps'),
	(651191, 133, '2015-01-15 00:13:26.000000', 'consum', 0.0382, 'lps'),
	(651192, 133, '2015-01-15 00:13:27.000000', 'consum', 0.0271, 'lps'),
	(651193, 133, '2015-01-15 00:13:28.000000', 'consum', 0.0217, 'lps'),
	(651194, 133, '2015-01-15 00:13:29.000000', 'consum', 0.0279, 'lps'),
	(651195, 133, '2015-01-15 00:13:30.000000', 'consum', 0.0319, 'lps'),
	(651196, 133, '2015-01-15 00:13:31.000000', 'consum', 0.0330, 'lps'),
	(651197, 133, '2015-01-15 00:13:32.000000', 'consum', 0.0265, 'lps'),
	(651198, 133, '2015-01-15 00:13:33.000000', 'consum', 0.0344, 'lps'),
	(651199, 133, '2015-01-15 00:13:34.000000', 'consum', 0.0281, 'lps'),
	(651200, 133, '2015-01-15 00:13:35.000000', 'consum', 0.0383, 'lps'),
	(651201, 133, '2015-01-15 00:13:36.000000', 'consum', 0.0426, 'lps'),
	(651202, 133, '2015-01-15 00:13:37.000000', 'consum', 0.0336, 'lps'),
	(651203, 133, '2015-01-15 00:13:38.000000', 'consum', 0.0412, 'lps'),
	(651204, 133, '2015-01-15 00:13:39.000000', 'consum', 0.0408, 'lps'),
	(651205, 133, '2015-01-15 00:13:40.000000', 'consum', 0.0378, 'lps'),
	(651206, 133, '2015-01-15 00:13:41.000000', 'consum', 0.0237, 'lps'),
	(651207, 133, '2015-01-15 00:13:42.000000', 'consum', 0.0278, 'lps'),
	(651208, 133, '2015-01-15 00:13:43.000000', 'consum', 0.0250, 'lps'),
	(651209, 133, '2015-01-15 00:13:44.000000', 'consum', 0.0426, 'lps'),
	(651210, 133, '2015-01-15 00:13:45.000000', 'consum', 0.0302, 'lps'),
	(651211, 133, '2015-01-15 00:13:46.000000', 'consum', 0.0239, 'lps'),
	(651212, 133, '2015-01-15 00:13:47.000000', 'consum', 0.0298, 'lps'),
	(651213, 133, '2015-01-15 00:13:48.000000', 'consum', 0.0346, 'lps'),
	(651214, 133, '2015-01-15 00:13:49.000000', 'consum', 0.0410, 'lps'),
	(651215, 133, '2015-01-15 00:13:50.000000', 'consum', 0.0370, 'lps'),
	(651216, 133, '2015-01-15 00:13:51.000000', 'consum', 0.0408, 'lps'),
	(651217, 133, '2015-01-15 00:13:52.000000', 'consum', 0.0285, 'lps'),
	(651218, 133, '2015-01-15 00:13:53.000000', 'consum', 0.0212, 'lps'),
	(651219, 133, '2015-01-15 00:13:54.000000', 'consum', 0.0211, 'lps'),
	(651220, 133, '2015-01-15 00:13:55.000000', 'consum', 0.0210, 'lps'),
	(651221, 133, '2015-01-15 00:13:56.000000', 'consum', 0.0424, 'lps'),
	(651222, 133, '2015-01-15 00:13:57.000000', 'consum', 0.0413, 'lps'),
	(651223, 133, '2015-01-15 00:13:58.000000', 'consum', 0.0365, 'lps'),
	(651224, 133, '2015-01-15 00:13:59.000000', 'consum', 0.0379, 'lps'),
	(651225, 133, '2015-01-15 00:14:00.000000', 'consum', 0.0371, 'lps'),
	(651226, 133, '2015-01-15 00:14:01.000000', 'consum', 0.0292, 'lps'),
	(651227, 133, '2015-01-15 00:14:02.000000', 'consum', 0.0356, 'lps'),
	(651228, 133, '2015-01-15 00:14:03.000000', 'consum', 0.0259, 'lps'),
	(651229, 133, '2015-01-15 00:14:04.000000', 'consum', 0.0235, 'lps'),
	(651230, 133, '2015-01-15 00:14:05.000000', 'consum', 0.0405, 'lps'),
	(651231, 133, '2015-01-15 00:14:06.000000', 'consum', 0.0244, 'lps'),
	(651232, 133, '2015-01-15 00:14:07.000000', 'consum', 0.0230, 'lps'),
	(651233, 133, '2015-01-15 00:14:08.000000', 'consum', 0.0424, 'lps'),
	(651234, 133, '2015-01-15 00:14:09.000000', 'consum', 0.0352, 'lps'),
	(651235, 133, '2015-01-15 00:14:10.000000', 'consum', 0.0278, 'lps'),
	(651236, 133, '2015-01-15 00:14:11.000000', 'consum', 0.0344, 'lps'),
	(651237, 133, '2015-01-15 00:14:12.000000', 'consum', 0.0243, 'lps'),
	(651238, 133, '2015-01-15 00:14:13.000000', 'consum', 0.0407, 'lps'),
	(651239, 133, '2015-01-15 00:14:14.000000', 'consum', 0.0228, 'lps'),
	(651240, 133, '2015-01-15 00:14:15.000000', 'consum', 0.0361, 'lps'),
	(651241, 133, '2015-01-15 00:14:16.000000', 'consum', 0.0260, 'lps'),
	(651242, 133, '2015-01-15 00:14:17.000000', 'consum', 0.0227, 'lps'),
	(651243, 133, '2015-01-15 00:14:18.000000', 'consum', 0.0359, 'lps'),
	(651244, 133, '2015-01-15 00:14:19.000000', 'consum', 0.0256, 'lps'),
	(651245, 133, '2015-01-15 00:14:20.000000', 'consum', 0.0210, 'lps'),
	(651246, 133, '2015-01-15 00:14:21.000000', 'consum', 0.0288, 'lps'),
	(651247, 133, '2015-01-15 00:14:22.000000', 'consum', 0.0384, 'lps'),
	(651248, 133, '2015-01-15 00:14:23.000000', 'consum', 0.0411, 'lps'),
	(651249, 133, '2015-01-15 00:14:24.000000', 'consum', 0.0260, 'lps'),
	(651250, 133, '2015-01-15 00:14:25.000000', 'consum', 0.0293, 'lps'),
	(651251, 133, '2015-01-15 00:14:26.000000', 'consum', 0.0259, 'lps'),
	(651252, 133, '2015-01-15 00:14:27.000000', 'consum', 0.0423, 'lps'),
	(651253, 133, '2015-01-15 00:14:28.000000', 'consum', 0.0259, 'lps'),
	(651254, 133, '2015-01-15 00:14:29.000000', 'consum', 0.0251, 'lps'),
	(651255, 133, '2015-01-15 00:14:30.000000', 'consum', 0.0270, 'lps'),
	(651256, 133, '2015-01-15 00:14:31.000000', 'consum', 0.0386, 'lps'),
	(651257, 133, '2015-01-15 00:14:32.000000', 'consum', 0.0259, 'lps'),
	(651258, 133, '2015-01-15 00:14:33.000000', 'consum', 0.0362, 'lps'),
	(651259, 133, '2015-01-15 00:14:34.000000', 'consum', 0.0390, 'lps'),
	(651260, 133, '2015-01-15 00:14:35.000000', 'consum', 0.0219, 'lps'),
	(651261, 133, '2015-01-15 00:14:36.000000', 'consum', 0.0367, 'lps'),
	(651262, 133, '2015-01-15 00:14:37.000000', 'consum', 0.0319, 'lps'),
	(651263, 133, '2015-01-15 00:14:38.000000', 'consum', 0.0281, 'lps'),
	(651264, 133, '2015-01-15 00:14:39.000000', 'consum', 0.0242, 'lps'),
	(651265, 133, '2015-01-15 00:14:40.000000', 'consum', 0.0375, 'lps'),
	(651266, 133, '2015-01-15 00:14:41.000000', 'consum', 0.0289, 'lps'),
	(651267, 133, '2015-01-15 00:14:42.000000', 'consum', 0.0324, 'lps'),
	(651268, 133, '2015-01-15 00:14:43.000000', 'consum', 0.0330, 'lps'),
	(651269, 133, '2015-01-15 00:14:44.000000', 'consum', 0.0249, 'lps'),
	(651270, 133, '2015-01-15 00:14:45.000000', 'consum', 0.0262, 'lps'),
	(651271, 133, '2015-01-15 00:14:46.000000', 'consum', 0.0353, 'lps'),
	(651272, 133, '2015-01-15 00:14:47.000000', 'consum', 0.0336, 'lps'),
	(651273, 133, '2015-01-15 00:14:48.000000', 'consum', 0.0410, 'lps'),
	(651274, 133, '2015-01-15 00:14:49.000000', 'consum', 0.0400, 'lps'),
	(651275, 133, '2015-01-15 00:14:50.000000', 'consum', 0.0342, 'lps'),
	(651276, 133, '2015-01-15 00:14:51.000000', 'consum', 0.0301, 'lps'),
	(651277, 133, '2015-01-15 00:14:52.000000', 'consum', 0.0268, 'lps'),
	(651278, 133, '2015-01-15 00:14:53.000000', 'consum', 0.0228, 'lps'),
	(651279, 133, '2015-01-15 00:14:54.000000', 'consum', 0.0345, 'lps'),
	(651280, 133, '2015-01-15 00:14:55.000000', 'consum', 0.0398, 'lps'),
	(651281, 133, '2015-01-15 00:14:56.000000', 'consum', 0.0310, 'lps'),
	(651282, 133, '2015-01-15 00:14:57.000000', 'consum', 0.0364, 'lps'),
	(651283, 133, '2015-01-15 00:14:58.000000', 'consum', 0.0247, 'lps'),
	(651284, 133, '2015-01-15 00:14:59.000000', 'consum', 0.0366, 'lps'),
	(651285, 133, '2015-01-15 00:15:00.000000', 'consum', 0.0229, 'lps'),
	(651286, 133, '2015-01-15 00:15:01.000000', 'consum', 0.0272, 'lps'),
	(651287, 133, '2015-01-15 00:15:02.000000', 'consum', 0.0247, 'lps'),
	(651288, 133, '2015-01-15 00:15:03.000000', 'consum', 0.0210, 'lps'),
	(651289, 133, '2015-01-15 00:15:04.000000', 'consum', 0.0316, 'lps'),
	(651290, 133, '2015-01-15 00:15:05.000000', 'consum', 0.0306, 'lps'),
	(651291, 133, '2015-01-15 00:15:06.000000', 'consum', 0.0373, 'lps'),
	(651292, 133, '2015-01-15 00:15:07.000000', 'consum', 0.0303, 'lps'),
	(651293, 133, '2015-01-15 00:15:08.000000', 'consum', 0.0405, 'lps'),
	(651294, 133, '2015-01-15 00:15:09.000000', 'consum', 0.0255, 'lps'),
	(651295, 133, '2015-01-15 00:15:10.000000', 'consum', 0.0285, 'lps'),
	(651296, 133, '2015-01-15 00:15:11.000000', 'consum', 0.0234, 'lps'),
	(651297, 133, '2015-01-15 00:15:12.000000', 'consum', 0.0320, 'lps'),
	(651298, 133, '2015-01-15 00:15:13.000000', 'consum', 0.0257, 'lps'),
	(651299, 133, '2015-01-15 00:15:14.000000', 'consum', 0.0333, 'lps'),
	(651300, 133, '2015-01-15 00:15:15.000000', 'consum', 0.0249, 'lps'),
	(651301, 133, '2015-01-15 00:15:16.000000', 'consum', 0.0254, 'lps'),
	(651302, 133, '2015-01-15 00:15:17.000000', 'consum', 0.0313, 'lps'),
	(651303, 133, '2015-01-15 00:15:18.000000', 'consum', 0.0376, 'lps'),
	(651304, 133, '2015-01-15 00:15:19.000000', 'consum', 0.0299, 'lps'),
	(651305, 133, '2015-01-15 00:15:20.000000', 'consum', 0.0375, 'lps'),
	(651306, 133, '2015-01-15 00:15:21.000000', 'consum', 0.0336, 'lps'),
	(651307, 133, '2015-01-15 00:15:22.000000', 'consum', 0.0342, 'lps'),
	(651308, 133, '2015-01-15 00:15:23.000000', 'consum', 0.0278, 'lps'),
	(651309, 133, '2015-01-15 00:15:24.000000', 'consum', 0.0372, 'lps'),
	(651310, 133, '2015-01-15 00:15:25.000000', 'consum', 0.0381, 'lps'),
	(651311, 133, '2015-01-15 00:15:26.000000', 'consum', 0.0364, 'lps'),
	(651312, 133, '2015-01-15 00:15:27.000000', 'consum', 0.0251, 'lps'),
	(651313, 133, '2015-01-15 00:15:28.000000', 'consum', 0.0388, 'lps'),
	(651314, 133, '2015-01-15 00:15:29.000000', 'consum', 0.0326, 'lps'),
	(651315, 133, '2015-01-15 00:15:30.000000', 'consum', 0.0258, 'lps'),
	(651316, 133, '2015-01-15 00:15:31.000000', 'consum', 0.0317, 'lps'),
	(651317, 133, '2015-01-15 00:15:32.000000', 'consum', 0.0384, 'lps'),
	(651318, 133, '2015-01-15 00:15:33.000000', 'consum', 0.0329, 'lps'),
	(651319, 133, '2015-01-15 00:15:34.000000', 'consum', 0.0280, 'lps'),
	(651320, 133, '2015-01-15 00:15:35.000000', 'consum', 0.0421, 'lps'),
	(651321, 133, '2015-01-15 00:15:36.000000', 'consum', 0.0407, 'lps'),
	(651322, 133, '2015-01-15 00:15:37.000000', 'consum', 0.0342, 'lps'),
	(651323, 133, '2015-01-15 00:15:38.000000', 'consum', 0.0281, 'lps'),
	(651324, 133, '2015-01-15 00:15:39.000000', 'consum', 0.0386, 'lps'),
	(651325, 133, '2015-01-15 00:15:40.000000', 'consum', 0.0226, 'lps'),
	(651326, 133, '2015-01-15 00:15:41.000000', 'consum', 0.0413, 'lps'),
	(651327, 133, '2015-01-15 00:15:42.000000', 'consum', 0.0312, 'lps'),
	(651328, 133, '2015-01-15 00:15:43.000000', 'consum', 0.0325, 'lps'),
	(651329, 133, '2015-01-15 00:15:44.000000', 'consum', 0.0266, 'lps'),
	(651330, 133, '2015-01-15 00:15:45.000000', 'consum', 0.0360, 'lps'),
	(651331, 133, '2015-01-15 00:15:46.000000', 'consum', 0.0359, 'lps'),
	(651332, 133, '2015-01-15 00:15:47.000000', 'consum', 0.0288, 'lps'),
	(651333, 133, '2015-01-15 00:15:48.000000', 'consum', 0.0369, 'lps'),
	(651334, 133, '2015-01-15 00:15:49.000000', 'consum', 0.0339, 'lps'),
	(651335, 133, '2015-01-15 00:15:50.000000', 'consum', 0.0377, 'lps'),
	(651336, 133, '2015-01-15 00:15:51.000000', 'consum', 0.0227, 'lps'),
	(651337, 133, '2015-01-15 00:15:52.000000', 'consum', 0.0229, 'lps'),
	(651338, 133, '2015-01-15 00:15:53.000000', 'consum', 0.0255, 'lps'),
	(651339, 133, '2015-01-15 00:15:54.000000', 'consum', 0.0378, 'lps'),
	(651340, 133, '2015-01-15 00:15:55.000000', 'consum', 0.0262, 'lps'),
	(651341, 133, '2015-01-15 00:15:56.000000', 'consum', 0.0403, 'lps'),
	(651342, 133, '2015-01-15 00:15:57.000000', 'consum', 0.0368, 'lps'),
	(651343, 133, '2015-01-15 00:15:58.000000', 'consum', 0.0422, 'lps'),
	(651344, 133, '2015-01-15 00:15:59.000000', 'consum', 0.0360, 'lps'),
	(651345, 133, '2015-01-15 00:16:00.000000', 'consum', 0.0326, 'lps'),
	(651346, 133, '2015-01-15 00:16:01.000000', 'consum', 0.0340, 'lps'),
	(651347, 133, '2015-01-15 00:16:02.000000', 'consum', 0.0296, 'lps'),
	(651348, 133, '2015-01-15 00:16:03.000000', 'consum', 0.0252, 'lps'),
	(651349, 133, '2015-01-15 00:16:04.000000', 'consum', 0.0378, 'lps'),
	(651350, 133, '2015-01-15 00:16:05.000000', 'consum', 0.0272, 'lps'),
	(651351, 133, '2015-01-15 00:16:06.000000', 'consum', 0.0233, 'lps'),
	(651352, 133, '2015-01-15 00:16:07.000000', 'consum', 0.0358, 'lps'),
	(651353, 133, '2015-01-15 00:16:08.000000', 'consum', 0.0232, 'lps'),
	(651354, 133, '2015-01-15 00:16:09.000000', 'consum', 0.0311, 'lps'),
	(651355, 133, '2015-01-15 00:16:10.000000', 'consum', 0.0213, 'lps'),
	(651356, 133, '2015-01-15 00:16:11.000000', 'consum', 0.0356, 'lps'),
	(651357, 133, '2015-01-15 00:16:12.000000', 'consum', 0.0279, 'lps'),
	(651358, 133, '2015-01-15 00:16:13.000000', 'consum', 0.0338, 'lps'),
	(651359, 133, '2015-01-15 00:16:14.000000', 'consum', 0.0210, 'lps'),
	(651360, 133, '2015-01-15 00:16:15.000000', 'consum', 0.0258, 'lps'),
	(651361, 133, '2015-01-15 00:16:16.000000', 'consum', 0.0233, 'lps'),
	(651362, 133, '2015-01-15 00:16:17.000000', 'consum', 0.0400, 'lps'),
	(651363, 133, '2015-01-15 00:16:18.000000', 'consum', 0.0222, 'lps'),
	(651364, 133, '2015-01-15 00:16:19.000000', 'consum', 0.0351, 'lps'),
	(651365, 133, '2015-01-15 00:16:20.000000', 'consum', 0.0231, 'lps'),
	(651366, 133, '2015-01-15 00:16:21.000000', 'consum', 0.0325, 'lps'),
	(651367, 133, '2015-01-15 00:16:22.000000', 'consum', 0.0291, 'lps'),
	(651368, 133, '2015-01-15 00:16:23.000000', 'consum', 0.0267, 'lps'),
	(651369, 133, '2015-01-15 00:16:24.000000', 'consum', 0.0255, 'lps'),
	(651370, 133, '2015-01-15 00:16:25.000000', 'consum', 0.0266, 'lps'),
	(651371, 133, '2015-01-15 00:16:26.000000', 'consum', 0.0352, 'lps'),
	(651372, 133, '2015-01-15 00:16:27.000000', 'consum', 0.0321, 'lps'),
	(651373, 133, '2015-01-15 00:16:28.000000', 'consum', 0.0337, 'lps'),
	(651374, 133, '2015-01-15 00:16:29.000000', 'consum', 0.0295, 'lps'),
	(651375, 133, '2015-01-15 00:16:30.000000', 'consum', 0.0255, 'lps'),
	(651376, 133, '2015-01-15 00:16:31.000000', 'consum', 0.0399, 'lps'),
	(651377, 133, '2015-01-15 00:16:32.000000', 'consum', 0.0371, 'lps'),
	(651378, 133, '2015-01-15 00:16:33.000000', 'consum', 0.0228, 'lps'),
	(651379, 133, '2015-01-15 00:16:34.000000', 'consum', 0.0253, 'lps'),
	(651380, 133, '2015-01-15 00:16:35.000000', 'consum', 0.0373, 'lps'),
	(651381, 133, '2015-01-15 00:16:36.000000', 'consum', 0.0245, 'lps'),
	(651382, 133, '2015-01-15 00:16:37.000000', 'consum', 0.0328, 'lps'),
	(651383, 133, '2015-01-15 00:16:38.000000', 'consum', 0.0265, 'lps'),
	(651384, 133, '2015-01-15 00:16:39.000000', 'consum', 0.0346, 'lps'),
	(651385, 133, '2015-01-15 00:16:40.000000', 'consum', 0.0292, 'lps'),
	(651386, 133, '2015-01-15 00:16:41.000000', 'consum', 0.0211, 'lps'),
	(651387, 133, '2015-01-15 00:16:42.000000', 'consum', 0.0405, 'lps'),
	(651388, 133, '2015-01-15 00:16:43.000000', 'consum', 0.0316, 'lps'),
	(651389, 133, '2015-01-15 00:16:44.000000', 'consum', 0.0370, 'lps'),
	(651390, 133, '2015-01-15 00:16:45.000000', 'consum', 0.0259, 'lps'),
	(651391, 133, '2015-01-15 00:16:46.000000', 'consum', 0.0410, 'lps'),
	(651392, 133, '2015-01-15 00:16:47.000000', 'consum', 0.0410, 'lps'),
	(651393, 133, '2015-01-15 00:16:48.000000', 'consum', 0.0397, 'lps'),
	(651394, 133, '2015-01-15 00:16:49.000000', 'consum', 0.0326, 'lps'),
	(651395, 133, '2015-01-15 00:16:50.000000', 'consum', 0.0231, 'lps'),
	(651396, 133, '2015-01-15 00:16:51.000000', 'consum', 0.0402, 'lps'),
	(651397, 133, '2015-01-15 00:16:52.000000', 'consum', 0.0238, 'lps'),
	(651398, 133, '2015-01-15 00:16:53.000000', 'consum', 0.0426, 'lps'),
	(651399, 133, '2015-01-15 00:16:54.000000', 'consum', 0.0338, 'lps'),
	(651400, 133, '2015-01-15 00:16:55.000000', 'consum', 0.0420, 'lps'),
	(651401, 133, '2015-01-15 00:16:56.000000', 'consum', 0.0226, 'lps'),
	(651402, 133, '2015-01-15 00:16:57.000000', 'consum', 0.0312, 'lps'),
	(651403, 133, '2015-01-15 00:16:58.000000', 'consum', 0.0237, 'lps'),
	(651404, 133, '2015-01-15 00:16:59.000000', 'consum', 0.0259, 'lps'),
	(651405, 133, '2015-01-15 00:17:00.000000', 'consum', 0.0374, 'lps'),
	(651406, 133, '2015-01-15 00:17:01.000000', 'consum', 0.0232, 'lps'),
	(651407, 133, '2015-01-15 00:17:02.000000', 'consum', 0.0262, 'lps'),
	(651408, 133, '2015-01-15 00:17:03.000000', 'consum', 0.0405, 'lps'),
	(651409, 133, '2015-01-15 00:17:04.000000', 'consum', 0.0378, 'lps'),
	(651410, 133, '2015-01-15 00:17:05.000000', 'consum', 0.0250, 'lps'),
	(651411, 133, '2015-01-15 00:17:06.000000', 'consum', 0.0341, 'lps'),
	(651412, 133, '2015-01-15 00:17:07.000000', 'consum', 0.0309, 'lps'),
	(651413, 133, '2015-01-15 00:17:08.000000', 'consum', 0.0312, 'lps'),
	(651414, 133, '2015-01-15 00:17:09.000000', 'consum', 0.0425, 'lps'),
	(651415, 133, '2015-01-15 00:17:10.000000', 'consum', 0.0328, 'lps'),
	(651416, 133, '2015-01-15 00:17:11.000000', 'consum', 0.0372, 'lps'),
	(651417, 133, '2015-01-15 00:17:12.000000', 'consum', 0.0235, 'lps'),
	(651418, 133, '2015-01-15 00:17:13.000000', 'consum', 0.0282, 'lps'),
	(651419, 133, '2015-01-15 00:17:14.000000', 'consum', 0.0280, 'lps'),
	(651420, 133, '2015-01-15 00:17:15.000000', 'consum', 0.0342, 'lps'),
	(651421, 133, '2015-01-15 00:17:16.000000', 'consum', 0.0228, 'lps'),
	(651422, 133, '2015-01-15 00:17:17.000000', 'consum', 0.0337, 'lps'),
	(651423, 133, '2015-01-15 00:17:18.000000', 'consum', 0.0359, 'lps'),
	(651424, 133, '2015-01-15 00:17:19.000000', 'consum', 0.0358, 'lps'),
	(651425, 133, '2015-01-15 00:17:20.000000', 'consum', 0.0287, 'lps'),
	(651426, 133, '2015-01-15 00:17:21.000000', 'consum', 0.0366, 'lps'),
	(651427, 133, '2015-01-15 00:17:22.000000', 'consum', 0.0328, 'lps'),
	(651428, 133, '2015-01-15 00:17:23.000000', 'consum', 0.0333, 'lps'),
	(651429, 133, '2015-01-15 00:17:24.000000', 'consum', 0.0253, 'lps'),
	(651430, 133, '2015-01-15 00:17:25.000000', 'consum', 0.0276, 'lps'),
	(651431, 133, '2015-01-15 00:17:26.000000', 'consum', 0.0410, 'lps'),
	(651432, 133, '2015-01-15 00:17:27.000000', 'consum', 0.0360, 'lps'),
	(651433, 133, '2015-01-15 00:17:28.000000', 'consum', 0.0361, 'lps'),
	(651434, 133, '2015-01-15 00:17:29.000000', 'consum', 0.0299, 'lps'),
	(651435, 133, '2015-01-15 00:17:30.000000', 'consum', 0.0419, 'lps'),
	(651436, 133, '2015-01-15 00:17:31.000000', 'consum', 0.0336, 'lps'),
	(651437, 133, '2015-01-15 00:17:32.000000', 'consum', 0.0213, 'lps'),
	(651438, 133, '2015-01-15 00:17:33.000000', 'consum', 0.0284, 'lps'),
	(651439, 133, '2015-01-15 00:17:34.000000', 'consum', 0.0353, 'lps'),
	(651440, 133, '2015-01-15 00:17:35.000000', 'consum', 0.0270, 'lps'),
	(651441, 133, '2015-01-15 00:17:36.000000', 'consum', 0.0297, 'lps'),
	(651442, 133, '2015-01-15 00:17:37.000000', 'consum', 0.0251, 'lps'),
	(651443, 133, '2015-01-15 00:17:38.000000', 'consum', 0.0371, 'lps'),
	(651444, 133, '2015-01-15 00:17:39.000000', 'consum', 0.0240, 'lps'),
	(651445, 133, '2015-01-15 00:17:40.000000', 'consum', 0.0312, 'lps'),
	(651446, 133, '2015-01-15 00:17:41.000000', 'consum', 0.0412, 'lps'),
	(651447, 133, '2015-01-15 00:17:42.000000', 'consum', 0.0266, 'lps'),
	(651448, 133, '2015-01-15 00:17:43.000000', 'consum', 0.0316, 'lps'),
	(651449, 133, '2015-01-15 00:17:44.000000', 'consum', 0.0358, 'lps'),
	(651450, 133, '2015-01-15 00:17:45.000000', 'consum', 0.0416, 'lps'),
	(651451, 133, '2015-01-15 00:17:46.000000', 'consum', 0.0360, 'lps'),
	(651452, 133, '2015-01-15 00:17:47.000000', 'consum', 0.0345, 'lps'),
	(651453, 133, '2015-01-15 00:17:48.000000', 'consum', 0.0218, 'lps'),
	(651454, 133, '2015-01-15 00:17:49.000000', 'consum', 0.0279, 'lps'),
	(651455, 133, '2015-01-15 00:17:50.000000', 'consum', 0.0316, 'lps'),
	(651456, 133, '2015-01-15 00:17:51.000000', 'consum', 0.0317, 'lps'),
	(651457, 133, '2015-01-15 00:17:52.000000', 'consum', 0.0426, 'lps'),
	(651458, 133, '2015-01-15 00:17:53.000000', 'consum', 0.0317, 'lps'),
	(651459, 133, '2015-01-15 00:17:54.000000', 'consum', 0.0316, 'lps'),
	(651460, 133, '2015-01-15 00:17:55.000000', 'consum', 0.0419, 'lps'),
	(651461, 133, '2015-01-15 00:17:56.000000', 'consum', 0.0288, 'lps'),
	(651462, 133, '2015-01-15 00:17:57.000000', 'consum', 0.0409, 'lps'),
	(651463, 133, '2015-01-15 00:17:58.000000', 'consum', 0.0317, 'lps'),
	(651464, 133, '2015-01-15 00:17:59.000000', 'consum', 0.0367, 'lps'),
	(651465, 133, '2015-01-15 00:18:00.000000', 'consum', 0.0241, 'lps'),
	(651466, 133, '2015-01-15 00:18:01.000000', 'consum', 0.0328, 'lps'),
	(651467, 133, '2015-01-15 00:18:02.000000', 'consum', 0.0272, 'lps'),
	(651468, 133, '2015-01-15 00:18:03.000000', 'consum', 0.0387, 'lps'),
	(651469, 133, '2015-01-15 00:18:04.000000', 'consum', 0.0255, 'lps'),
	(651470, 133, '2015-01-15 00:18:05.000000', 'consum', 0.0342, 'lps'),
	(651471, 133, '2015-01-15 00:18:06.000000', 'consum', 0.0299, 'lps'),
	(651472, 133, '2015-01-15 00:18:07.000000', 'consum', 0.0262, 'lps'),
	(651473, 133, '2015-01-15 00:18:08.000000', 'consum', 0.0419, 'lps'),
	(651474, 133, '2015-01-15 00:18:09.000000', 'consum', 0.0231, 'lps'),
	(651475, 133, '2015-01-15 00:18:10.000000', 'consum', 0.0340, 'lps'),
	(651476, 133, '2015-01-15 00:18:11.000000', 'consum', 0.0364, 'lps'),
	(651477, 133, '2015-01-15 00:18:12.000000', 'consum', 0.0374, 'lps'),
	(651478, 133, '2015-01-15 00:18:13.000000', 'consum', 0.0352, 'lps'),
	(651479, 133, '2015-01-15 00:18:14.000000', 'consum', 0.0426, 'lps'),
	(651480, 133, '2015-01-15 00:18:15.000000', 'consum', 0.0214, 'lps'),
	(651481, 133, '2015-01-15 00:18:16.000000', 'consum', 0.0236, 'lps'),
	(651482, 133, '2015-01-15 00:18:17.000000', 'consum', 0.0326, 'lps'),
	(651483, 133, '2015-01-15 00:18:18.000000', 'consum', 0.0281, 'lps'),
	(651484, 133, '2015-01-15 00:18:19.000000', 'consum', 0.0218, 'lps'),
	(651485, 133, '2015-01-15 00:18:20.000000', 'consum', 0.0253, 'lps'),
	(651486, 133, '2015-01-15 00:18:21.000000', 'consum', 0.0403, 'lps'),
	(651487, 133, '2015-01-15 00:18:22.000000', 'consum', 0.0396, 'lps'),
	(651488, 133, '2015-01-15 00:18:23.000000', 'consum', 0.0343, 'lps'),
	(651489, 133, '2015-01-15 00:18:24.000000', 'consum', 0.0317, 'lps'),
	(651490, 133, '2015-01-15 00:18:25.000000', 'consum', 0.0349, 'lps'),
	(651491, 133, '2015-01-15 00:18:26.000000', 'consum', 0.0364, 'lps'),
	(651492, 133, '2015-01-15 00:18:27.000000', 'consum', 0.0350, 'lps'),
	(651493, 133, '2015-01-15 00:18:28.000000', 'consum', 0.0229, 'lps'),
	(651494, 133, '2015-01-15 00:18:29.000000', 'consum', 0.0318, 'lps'),
	(651495, 133, '2015-01-15 00:18:30.000000', 'consum', 0.0262, 'lps'),
	(651496, 133, '2015-01-15 00:18:31.000000', 'consum', 0.0364, 'lps'),
	(651497, 133, '2015-01-15 00:18:32.000000', 'consum', 0.0388, 'lps'),
	(651498, 133, '2015-01-15 00:18:33.000000', 'consum', 0.0424, 'lps'),
	(651499, 133, '2015-01-15 00:18:34.000000', 'consum', 0.0313, 'lps'),
	(651500, 133, '2015-01-15 00:18:35.000000', 'consum', 0.0299, 'lps'),
	(651501, 133, '2015-01-15 00:18:36.000000', 'consum', 0.0349, 'lps'),
	(651502, 133, '2015-01-15 00:18:37.000000', 'consum', 0.0419, 'lps'),
	(651503, 133, '2015-01-15 00:18:38.000000', 'consum', 0.0405, 'lps'),
	(651504, 133, '2015-01-15 00:18:39.000000', 'consum', 0.0341, 'lps'),
	(651505, 133, '2015-01-15 00:18:40.000000', 'consum', 0.0280, 'lps'),
	(651506, 133, '2015-01-15 00:18:41.000000', 'consum', 0.0385, 'lps'),
	(651507, 133, '2015-01-15 00:18:42.000000', 'consum', 0.0226, 'lps'),
	(651508, 133, '2015-01-15 00:18:43.000000', 'consum', 0.0416, 'lps'),
	(651509, 133, '2015-01-15 00:18:44.000000', 'consum', 0.0326, 'lps'),
	(651510, 133, '2015-01-15 00:18:45.000000', 'consum', 0.0387, 'lps'),
	(651511, 133, '2015-01-15 00:18:46.000000', 'consum', 0.0314, 'lps'),
	(651512, 133, '2015-01-15 00:18:47.000000', 'consum', 0.0419, 'lps'),
	(651513, 133, '2015-01-15 00:18:48.000000', 'consum', 0.0290, 'lps'),
	(651514, 133, '2015-01-15 00:18:49.000000', 'consum', 0.0416, 'lps'),
	(651515, 133, '2015-01-15 00:18:50.000000', 'consum', 0.0351, 'lps'),
	(651516, 133, '2015-01-15 00:18:51.000000', 'consum', 0.0298, 'lps'),
	(651517, 133, '2015-01-15 00:18:52.000000', 'consum', 0.0226, 'lps'),
	(651518, 133, '2015-01-15 00:18:53.000000', 'consum', 0.0243, 'lps'),
	(651519, 133, '2015-01-15 00:18:54.000000', 'consum', 0.0330, 'lps'),
	(651520, 133, '2015-01-15 00:18:55.000000', 'consum', 0.0278, 'lps'),
	(651521, 133, '2015-01-15 00:18:56.000000', 'consum', 0.0405, 'lps'),
	(651522, 133, '2015-01-15 00:18:57.000000', 'consum', 0.0332, 'lps'),
	(651523, 133, '2015-01-15 00:18:58.000000', 'consum', 0.0233, 'lps'),
	(651524, 133, '2015-01-15 00:18:59.000000', 'consum', 0.0396, 'lps'),
	(651525, 133, '2015-01-15 00:19:00.000000', 'consum', 0.0420, 'lps'),
	(651526, 133, '2015-01-15 00:19:01.000000', 'consum', 0.0267, 'lps'),
	(651527, 133, '2015-01-15 00:19:02.000000', 'consum', 0.0298, 'lps'),
	(651528, 133, '2015-01-15 00:19:03.000000', 'consum', 0.0266, 'lps'),
	(651529, 133, '2015-01-15 00:19:04.000000', 'consum', 0.0223, 'lps'),
	(651530, 133, '2015-01-15 00:19:05.000000', 'consum', 0.0327, 'lps'),
	(651531, 133, '2015-01-15 00:19:06.000000', 'consum', 0.0321, 'lps'),
	(651532, 133, '2015-01-15 00:19:07.000000', 'consum', 0.0414, 'lps'),
	(651533, 133, '2015-01-15 00:19:08.000000', 'consum', 0.0248, 'lps'),
	(651534, 133, '2015-01-15 00:19:09.000000', 'consum', 0.0224, 'lps'),
	(651535, 133, '2015-01-15 00:19:10.000000', 'consum', 0.0380, 'lps'),
	(651536, 133, '2015-01-15 00:19:11.000000', 'consum', 0.0369, 'lps'),
	(651537, 133, '2015-01-15 00:19:12.000000', 'consum', 0.0279, 'lps'),
	(651538, 133, '2015-01-15 00:19:13.000000', 'consum', 0.0294, 'lps'),
	(651539, 133, '2015-01-15 00:19:14.000000', 'consum', 0.0423, 'lps'),
	(651540, 133, '2015-01-15 00:19:15.000000', 'consum', 0.0374, 'lps'),
	(651541, 133, '2015-01-15 00:19:16.000000', 'consum', 0.0393, 'lps'),
	(651542, 133, '2015-01-15 00:19:17.000000', 'consum', 0.0416, 'lps'),
	(651543, 133, '2015-01-15 00:19:18.000000', 'consum', 0.0257, 'lps'),
	(651544, 133, '2015-01-15 00:19:19.000000', 'consum', 0.0260, 'lps'),
	(651545, 133, '2015-01-15 00:19:20.000000', 'consum', 0.0322, 'lps'),
	(651546, 133, '2015-01-15 00:19:21.000000', 'consum', 0.0401, 'lps'),
	(651547, 133, '2015-01-15 00:19:22.000000', 'consum', 0.0395, 'lps'),
	(651548, 133, '2015-01-15 00:19:23.000000', 'consum', 0.0347, 'lps'),
	(651549, 133, '2015-01-15 00:19:24.000000', 'consum', 0.0341, 'lps'),
	(651550, 133, '2015-01-15 00:19:25.000000', 'consum', 0.0237, 'lps'),
	(651551, 133, '2015-01-15 00:19:26.000000', 'consum', 0.0384, 'lps'),
	(651552, 133, '2015-01-15 00:19:27.000000', 'consum', 0.0352, 'lps'),
	(651553, 133, '2015-01-15 00:19:28.000000', 'consum', 0.0396, 'lps'),
	(651554, 133, '2015-01-15 00:19:29.000000', 'consum', 0.0281, 'lps'),
	(651555, 133, '2015-01-15 00:19:30.000000', 'consum', 0.0226, 'lps'),
	(651556, 133, '2015-01-15 00:19:31.000000', 'consum', 0.0294, 'lps'),
	(651557, 133, '2015-01-15 00:19:32.000000', 'consum', 0.0364, 'lps'),
	(651558, 133, '2015-01-15 00:19:33.000000', 'consum', 0.0295, 'lps'),
	(651559, 133, '2015-01-15 00:19:34.000000', 'consum', 0.0391, 'lps'),
	(651560, 133, '2015-01-15 00:19:35.000000', 'consum', 0.0210, 'lps'),
	(651561, 133, '2015-01-15 00:19:36.000000', 'consum', 0.0317, 'lps'),
	(651562, 133, '2015-01-15 00:19:37.000000', 'consum', 0.0313, 'lps'),
	(651563, 133, '2015-01-15 00:19:38.000000', 'consum', 0.0405, 'lps'),
	(651564, 133, '2015-01-15 00:19:39.000000', 'consum', 0.0226, 'lps'),
	(651565, 133, '2015-01-15 00:19:40.000000', 'consum', 0.0354, 'lps'),
	(651566, 133, '2015-01-15 00:19:41.000000', 'consum', 0.0231, 'lps'),
	(651567, 133, '2015-01-15 00:19:42.000000', 'consum', 0.0320, 'lps'),
	(651568, 133, '2015-01-15 00:19:43.000000', 'consum', 0.0261, 'lps'),
	(651569, 133, '2015-01-15 00:19:44.000000', 'consum', 0.0355, 'lps'),
	(651570, 133, '2015-01-15 00:19:45.000000', 'consum', 0.0346, 'lps'),
	(651571, 133, '2015-01-15 00:19:46.000000', 'consum', 0.0238, 'lps'),
	(651572, 133, '2015-01-15 00:19:47.000000', 'consum', 0.0379, 'lps'),
	(651573, 133, '2015-01-15 00:19:48.000000', 'consum', 0.0320, 'lps'),
	(651574, 133, '2015-01-15 00:19:49.000000', 'consum', 0.0253, 'lps'),
	(651575, 133, '2015-01-15 00:19:50.000000', 'consum', 0.0311, 'lps'),
	(651576, 133, '2015-01-15 00:19:51.000000', 'consum', 0.0372, 'lps'),
	(651577, 133, '2015-01-15 00:19:52.000000', 'consum', 0.0284, 'lps'),
	(651578, 133, '2015-01-15 00:19:53.000000', 'consum', 0.0312, 'lps'),
	(651579, 133, '2015-01-15 00:19:54.000000', 'consum', 0.0282, 'lps'),
	(651580, 133, '2015-01-15 00:19:55.000000', 'consum', 0.0264, 'lps'),
	(651581, 133, '2015-01-15 00:19:56.000000', 'consum', 0.0262, 'lps'),
	(651582, 133, '2015-01-15 00:19:57.000000', 'consum', 0.0311, 'lps'),
	(651583, 133, '2015-01-15 00:19:58.000000', 'consum', 0.0340, 'lps'),
	(651584, 133, '2015-01-15 00:19:59.000000', 'consum', 0.0341, 'lps'),
	(651585, 133, '2015-01-15 00:20:00.000000', 'consum', 0.0260, 'lps'),
	(651586, 133, '2015-01-15 00:20:01.000000', 'consum', 0.0285, 'lps'),
	(651587, 133, '2015-01-15 00:20:02.000000', 'consum', 0.0217, 'lps'),
	(651588, 133, '2015-01-15 00:20:03.000000', 'consum', 0.0240, 'lps'),
	(651589, 133, '2015-01-15 00:20:04.000000', 'consum', 0.0337, 'lps'),
	(651590, 133, '2015-01-15 00:20:05.000000', 'consum', 0.0324, 'lps'),
	(651591, 133, '2015-01-15 00:20:06.000000', 'consum', 0.0399, 'lps'),
	(651592, 133, '2015-01-15 00:20:07.000000', 'consum', 0.0381, 'lps'),
	(651593, 133, '2015-01-15 00:20:08.000000', 'consum', 0.0280, 'lps'),
	(651594, 133, '2015-01-15 00:20:09.000000', 'consum', 0.0263, 'lps'),
	(651595, 133, '2015-01-15 00:20:10.000000', 'consum', 0.0268, 'lps'),
	(651596, 133, '2015-01-15 00:20:11.000000', 'consum', 0.0342, 'lps'),
	(651597, 133, '2015-01-15 00:20:12.000000', 'consum', 0.0260, 'lps'),
	(651598, 133, '2015-01-15 00:20:13.000000', 'consum', 0.0285, 'lps'),
	(651599, 133, '2015-01-15 00:20:14.000000', 'consum', 0.0215, 'lps'),
	(651600, 133, '2015-01-15 00:20:15.000000', 'consum', 0.0230, 'lps'),
	(651601, 133, '2015-01-15 00:20:16.000000', 'consum', 0.0295, 'lps'),
	(651602, 133, '2015-01-15 00:20:17.000000', 'consum', 0.0358, 'lps'),
	(651603, 133, '2015-01-15 00:20:18.000000', 'consum', 0.0260, 'lps'),
	(651604, 133, '2015-01-15 00:20:19.000000', 'consum', 0.0235, 'lps'),
	(651605, 133, '2015-01-15 00:20:20.000000', 'consum', 0.0404, 'lps'),
	(651606, 133, '2015-01-15 00:20:21.000000', 'consum', 0.0236, 'lps'),
	(651607, 133, '2015-01-15 00:20:22.000000', 'consum', 0.0411, 'lps'),
	(651608, 133, '2015-01-15 00:20:23.000000', 'consum', 0.0267, 'lps'),
	(651609, 133, '2015-01-15 00:20:24.000000', 'consum', 0.0329, 'lps'),
	(651610, 133, '2015-01-15 00:20:25.000000', 'consum', 0.0418, 'lps'),
	(651611, 133, '2015-01-15 00:20:26.000000', 'consum', 0.0243, 'lps'),
	(651612, 133, '2015-01-15 00:20:27.000000', 'consum', 0.0399, 'lps'),
	(651613, 133, '2015-01-15 00:20:28.000000', 'consum', 0.0409, 'lps'),
	(651614, 133, '2015-01-15 00:20:29.000000', 'consum', 0.0421, 'lps'),
	(651615, 133, '2015-01-15 00:20:30.000000', 'consum', 0.0233, 'lps'),
	(651616, 133, '2015-01-15 00:20:31.000000', 'consum', 0.0344, 'lps'),
	(651617, 133, '2015-01-15 00:20:32.000000', 'consum', 0.0377, 'lps'),
	(651618, 133, '2015-01-15 00:20:33.000000', 'consum', 0.0211, 'lps'),
	(651619, 133, '2015-01-15 00:20:34.000000', 'consum', 0.0365, 'lps'),
	(651620, 133, '2015-01-15 00:20:35.000000', 'consum', 0.0333, 'lps'),
	(651621, 133, '2015-01-15 00:20:36.000000', 'consum', 0.0360, 'lps'),
	(651622, 133, '2015-01-15 00:20:37.000000', 'consum', 0.0375, 'lps'),
	(651623, 133, '2015-01-15 00:20:38.000000', 'consum', 0.0368, 'lps'),
	(651624, 133, '2015-01-15 00:20:39.000000', 'consum', 0.0286, 'lps'),
	(651625, 133, '2015-01-15 00:20:40.000000', 'consum', 0.0337, 'lps'),
	(651626, 133, '2015-01-15 00:20:41.000000', 'consum', 0.0398, 'lps'),
	(651627, 133, '2015-01-15 00:20:42.000000', 'consum', 0.0336, 'lps'),
	(651628, 133, '2015-01-15 00:20:43.000000', 'consum', 0.0276, 'lps'),
	(651629, 133, '2015-01-15 00:20:44.000000', 'consum', 0.0381, 'lps'),
	(651630, 133, '2015-01-15 00:20:45.000000', 'consum', 0.0214, 'lps'),
	(651631, 133, '2015-01-15 00:20:46.000000', 'consum', 0.0370, 'lps'),
	(651632, 133, '2015-01-15 00:20:47.000000', 'consum', 0.0346, 'lps'),
	(651633, 133, '2015-01-15 00:20:48.000000', 'consum', 0.0411, 'lps'),
	(651634, 133, '2015-01-15 00:20:49.000000', 'consum', 0.0372, 'lps'),
	(651635, 133, '2015-01-15 00:20:50.000000', 'consum', 0.0421, 'lps'),
	(651636, 133, '2015-01-15 00:20:51.000000', 'consum', 0.0342, 'lps'),
	(651637, 133, '2015-01-15 00:20:52.000000', 'consum', 0.0238, 'lps'),
	(651638, 133, '2015-01-15 00:20:53.000000', 'consum', 0.0391, 'lps'),
	(651639, 133, '2015-01-15 00:20:54.000000', 'consum', 0.0379, 'lps'),
	(651640, 133, '2015-01-15 00:20:55.000000', 'consum', 0.0295, 'lps'),
	(651641, 133, '2015-01-15 00:20:56.000000', 'consum', 0.0347, 'lps'),
	(651642, 133, '2015-01-15 00:20:57.000000', 'consum', 0.0421, 'lps'),
	(651643, 133, '2015-01-15 00:20:58.000000', 'consum', 0.0421, 'lps'),
	(651644, 133, '2015-01-15 00:20:59.000000', 'consum', 0.0416, 'lps'),
	(651645, 133, '2015-01-15 00:21:00.000000', 'consum', 0.0392, 'lps'),
	(651646, 133, '2015-01-15 00:21:01.000000', 'consum', 0.0282, 'lps'),
	(651647, 133, '2015-01-15 00:21:02.000000', 'consum', 0.0245, 'lps'),
	(651648, 133, '2015-01-15 00:21:03.000000', 'consum', 0.0384, 'lps'),
	(651649, 133, '2015-01-15 00:21:04.000000', 'consum', 0.0326, 'lps'),
	(651650, 133, '2015-01-15 00:21:05.000000', 'consum', 0.0270, 'lps'),
	(651651, 133, '2015-01-15 00:21:06.000000', 'consum', 0.0377, 'lps'),
	(651652, 133, '2015-01-15 00:21:07.000000', 'consum', 0.0216, 'lps'),
	(651653, 133, '2015-01-15 00:21:08.000000', 'consum', 0.0391, 'lps'),
	(651654, 133, '2015-01-15 00:21:09.000000', 'consum', 0.0227, 'lps'),
	(651655, 133, '2015-01-15 00:21:10.000000', 'consum', 0.0406, 'lps'),
	(651656, 133, '2015-01-15 00:21:11.000000', 'consum', 0.0269, 'lps'),
	(651657, 133, '2015-01-15 00:21:12.000000', 'consum', 0.0355, 'lps'),
	(651658, 133, '2015-01-15 00:21:13.000000', 'consum', 0.0322, 'lps'),
	(651659, 133, '2015-01-15 00:21:14.000000', 'consum', 0.0334, 'lps'),
	(651660, 133, '2015-01-15 00:21:15.000000', 'consum', 0.0280, 'lps'),
	(651661, 133, '2015-01-15 00:21:16.000000', 'consum', 0.0404, 'lps'),
	(651662, 133, '2015-01-15 00:21:17.000000', 'consum', 0.0319, 'lps'),
	(651663, 133, '2015-01-15 00:21:18.000000', 'consum', 0.0391, 'lps'),
	(651664, 133, '2015-01-15 00:21:19.000000', 'consum', 0.0355, 'lps'),
	(651665, 133, '2015-01-15 00:21:20.000000', 'consum', 0.0392, 'lps'),
	(651666, 133, '2015-01-15 00:21:21.000000', 'consum', 0.0251, 'lps'),
	(651667, 133, '2015-01-15 00:21:22.000000', 'consum', 0.0303, 'lps'),
	(651668, 133, '2015-01-15 00:21:23.000000', 'consum', 0.0335, 'lps'),
	(651669, 133, '2015-01-15 00:21:24.000000', 'consum', 0.0341, 'lps'),
	(651670, 133, '2015-01-15 00:21:25.000000', 'consum', 0.0273, 'lps'),
	(651671, 133, '2015-01-15 00:21:26.000000', 'consum', 0.0351, 'lps'),
	(651672, 133, '2015-01-15 00:21:27.000000', 'consum', 0.0292, 'lps'),
	(651673, 133, '2015-01-15 00:21:28.000000', 'consum', 0.0415, 'lps'),
	(651674, 133, '2015-01-15 00:21:29.000000', 'consum', 0.0338, 'lps'),
	(651675, 133, '2015-01-15 00:21:30.000000', 'consum', 0.0235, 'lps'),
	(651676, 133, '2015-01-15 00:21:31.000000', 'consum', 0.0385, 'lps'),
	(651677, 133, '2015-01-15 00:21:32.000000', 'consum', 0.0359, 'lps'),
	(651678, 133, '2015-01-15 00:21:33.000000', 'consum', 0.0215, 'lps'),
	(651679, 133, '2015-01-15 00:21:34.000000', 'consum', 0.0221, 'lps'),
	(651680, 133, '2015-01-15 00:21:35.000000', 'consum', 0.0252, 'lps'),
	(651681, 133, '2015-01-15 00:21:36.000000', 'consum', 0.0387, 'lps'),
	(651682, 133, '2015-01-15 00:21:37.000000', 'consum', 0.0320, 'lps'),
	(651683, 133, '2015-01-15 00:21:38.000000', 'consum', 0.0228, 'lps'),
	(651684, 133, '2015-01-15 00:21:39.000000', 'consum', 0.0404, 'lps'),
	(651685, 133, '2015-01-15 00:21:40.000000', 'consum', 0.0259, 'lps'),
	(651686, 133, '2015-01-15 00:21:41.000000', 'consum', 0.0309, 'lps'),
	(651687, 133, '2015-01-15 00:21:42.000000', 'consum', 0.0339, 'lps'),
	(651688, 133, '2015-01-15 00:21:43.000000', 'consum', 0.0341, 'lps'),
	(651689, 133, '2015-01-15 00:21:44.000000', 'consum', 0.0261, 'lps'),
	(651690, 133, '2015-01-15 00:21:45.000000', 'consum', 0.0292, 'lps'),
	(651691, 133, '2015-01-15 00:21:46.000000', 'consum', 0.0250, 'lps'),
	(651692, 133, '2015-01-15 00:21:47.000000', 'consum', 0.0381, 'lps'),
	(651693, 133, '2015-01-15 00:21:48.000000', 'consum', 0.0294, 'lps'),
	(651694, 133, '2015-01-15 00:21:49.000000', 'consum', 0.0335, 'lps'),
	(651695, 133, '2015-01-15 00:21:50.000000', 'consum', 0.0368, 'lps'),
	(651696, 133, '2015-01-15 00:21:51.000000', 'consum', 0.0409, 'lps'),
	(651697, 133, '2015-01-15 00:21:52.000000', 'consum', 0.0297, 'lps'),
	(651698, 133, '2015-01-15 00:21:53.000000', 'consum', 0.0266, 'lps'),
	(651699, 133, '2015-01-15 00:21:54.000000', 'consum', 0.0227, 'lps'),
	(651700, 133, '2015-01-15 00:21:55.000000', 'consum', 0.0347, 'lps'),
	(651701, 133, '2015-01-15 00:21:56.000000', 'consum', 0.0409, 'lps'),
	(651702, 133, '2015-01-15 00:21:57.000000', 'consum', 0.0363, 'lps'),
	(651703, 133, '2015-01-15 00:21:58.000000', 'consum', 0.0377, 'lps'),
	(651704, 133, '2015-01-15 00:21:59.000000', 'consum', 0.0371, 'lps'),
	(651705, 133, '2015-01-15 00:22:00.000000', 'consum', 0.0297, 'lps'),
	(651706, 133, '2015-01-15 00:22:01.000000', 'consum', 0.0379, 'lps'),
	(651707, 133, '2015-01-15 00:22:02.000000', 'consum', 0.0362, 'lps'),
	(651708, 133, '2015-01-15 00:22:03.000000', 'consum', 0.0246, 'lps'),
	(651709, 133, '2015-01-15 00:22:04.000000', 'consum', 0.0368, 'lps'),
	(651710, 133, '2015-01-15 00:22:05.000000', 'consum', 0.0242, 'lps'),
	(651711, 133, '2015-01-15 00:22:06.000000', 'consum', 0.0332, 'lps'),
	(651712, 133, '2015-01-15 00:22:07.000000', 'consum', 0.0290, 'lps'),
	(651713, 133, '2015-01-15 00:22:08.000000', 'consum', 0.0243, 'lps'),
	(651714, 133, '2015-01-15 00:22:09.000000', 'consum', 0.0353, 'lps'),
	(651715, 133, '2015-01-15 00:22:10.000000', 'consum', 0.0394, 'lps'),
	(651716, 133, '2015-01-15 00:22:11.000000', 'consum', 0.0265, 'lps'),
	(651717, 133, '2015-01-15 00:22:12.000000', 'consum', 0.0371, 'lps'),
	(651718, 133, '2015-01-15 00:22:13.000000', 'consum', 0.0413, 'lps'),
	(651719, 133, '2015-01-15 00:22:14.000000', 'consum', 0.0310, 'lps'),
	(651720, 133, '2015-01-15 00:22:15.000000', 'consum', 0.0316, 'lps'),
	(651721, 133, '2015-01-15 00:22:16.000000', 'consum', 0.0226, 'lps'),
	(651722, 133, '2015-01-15 00:22:17.000000', 'consum', 0.0407, 'lps'),
	(651723, 133, '2015-01-15 00:22:18.000000', 'consum', 0.0279, 'lps'),
	(651724, 133, '2015-01-15 00:22:19.000000', 'consum', 0.0398, 'lps'),
	(651725, 133, '2015-01-15 00:22:20.000000', 'consum', 0.0291, 'lps'),
	(651726, 133, '2015-01-15 00:22:21.000000', 'consum', 0.0269, 'lps'),
	(651727, 133, '2015-01-15 00:22:22.000000', 'consum', 0.0262, 'lps'),
	(651728, 133, '2015-01-15 00:22:23.000000', 'consum', 0.0295, 'lps'),
	(651729, 133, '2015-01-15 00:22:24.000000', 'consum', 0.0260, 'lps'),
	(651730, 133, '2015-01-15 00:22:25.000000', 'consum', 0.0424, 'lps'),
	(651731, 133, '2015-01-15 00:22:26.000000', 'consum', 0.0263, 'lps'),
	(651732, 133, '2015-01-15 00:22:27.000000', 'consum', 0.0266, 'lps'),
	(651733, 133, '2015-01-15 00:22:28.000000', 'consum', 0.0331, 'lps'),
	(651734, 133, '2015-01-15 00:22:29.000000', 'consum', 0.0214, 'lps'),
	(651735, 133, '2015-01-15 00:22:30.000000', 'consum', 0.0302, 'lps'),
	(651736, 133, '2015-01-15 00:22:31.000000', 'consum', 0.0223, 'lps'),
	(651737, 133, '2015-01-15 00:22:32.000000', 'consum', 0.0217, 'lps'),
	(651738, 133, '2015-01-15 00:22:33.000000', 'consum', 0.0423, 'lps'),
	(651739, 133, '2015-01-15 00:22:34.000000', 'consum', 0.0387, 'lps'),
	(651740, 133, '2015-01-15 00:22:35.000000', 'consum', 0.0242, 'lps'),
	(651741, 133, '2015-01-15 00:22:36.000000', 'consum', 0.0270, 'lps'),
	(651742, 133, '2015-01-15 00:22:37.000000', 'consum', 0.0415, 'lps'),
	(651743, 133, '2015-01-15 00:22:38.000000', 'consum', 0.0407, 'lps'),
	(651744, 133, '2015-01-15 00:22:39.000000', 'consum', 0.0361, 'lps'),
	(651745, 133, '2015-01-15 00:22:40.000000', 'consum', 0.0376, 'lps'),
	(651746, 133, '2015-01-15 00:22:41.000000', 'consum', 0.0371, 'lps'),
	(651747, 133, '2015-01-15 00:22:42.000000', 'consum', 0.0300, 'lps'),
	(651748, 133, '2015-01-15 00:22:43.000000', 'consum', 0.0393, 'lps'),
	(651749, 133, '2015-01-15 00:22:44.000000', 'consum', 0.0423, 'lps'),
	(651750, 133, '2015-01-15 00:22:45.000000', 'consum', 0.0292, 'lps'),
	(651751, 133, '2015-01-15 00:22:46.000000', 'consum', 0.0417, 'lps'),
	(651752, 133, '2015-01-15 00:22:47.000000', 'consum', 0.0348, 'lps'),
	(651753, 133, '2015-01-15 00:22:48.000000', 'consum', 0.0279, 'lps'),
	(651754, 133, '2015-01-15 00:22:49.000000', 'consum', 0.0358, 'lps'),
	(651755, 133, '2015-01-15 00:22:50.000000', 'consum', 0.0309, 'lps'),
	(651756, 133, '2015-01-15 00:22:51.000000', 'consum', 0.0264, 'lps'),
	(651757, 133, '2015-01-15 00:22:52.000000', 'consum', 0.0397, 'lps'),
	(651758, 133, '2015-01-15 00:22:53.000000', 'consum', 0.0335, 'lps'),
	(651759, 133, '2015-01-15 00:22:54.000000', 'consum', 0.0274, 'lps'),
	(651760, 133, '2015-01-15 00:22:55.000000', 'consum', 0.0372, 'lps'),
	(651761, 133, '2015-01-15 00:22:56.000000', 'consum', 0.0394, 'lps'),
	(651762, 133, '2015-01-15 00:22:57.000000', 'consum', 0.0212, 'lps'),
	(651763, 133, '2015-01-15 00:22:58.000000', 'consum', 0.0317, 'lps'),
	(651764, 133, '2015-01-15 00:22:59.000000', 'consum', 0.0306, 'lps'),
	(651765, 133, '2015-01-15 00:23:00.000000', 'consum', 0.0372, 'lps'),
	(651766, 133, '2015-01-15 00:23:01.000000', 'consum', 0.0296, 'lps'),
	(651767, 133, '2015-01-15 00:23:02.000000', 'consum', 0.0372, 'lps'),
	(651768, 133, '2015-01-15 00:23:03.000000', 'consum', 0.0327, 'lps'),
	(651769, 133, '2015-01-15 00:23:04.000000', 'consum', 0.0310, 'lps'),
	(651770, 133, '2015-01-15 00:23:05.000000', 'consum', 0.0359, 'lps'),
	(651771, 133, '2015-01-15 00:23:06.000000', 'consum', 0.0222, 'lps'),
	(651772, 133, '2015-01-15 00:23:07.000000', 'consum', 0.0259, 'lps'),
	(651773, 133, '2015-01-15 00:23:08.000000', 'consum', 0.0417, 'lps'),
	(651774, 133, '2015-01-15 00:23:09.000000', 'consum', 0.0234, 'lps'),
	(651775, 133, '2015-01-15 00:23:10.000000', 'consum', 0.0357, 'lps'),
	(651776, 133, '2015-01-15 00:23:11.000000', 'consum', 0.0224, 'lps'),
	(651777, 133, '2015-01-15 00:23:12.000000', 'consum', 0.0274, 'lps'),
	(651778, 133, '2015-01-15 00:23:13.000000', 'consum', 0.0272, 'lps'),
	(651779, 133, '2015-01-15 00:23:14.000000', 'consum', 0.0327, 'lps'),
	(651780, 133, '2015-01-15 00:23:15.000000', 'consum', 0.0394, 'lps'),
	(651781, 133, '2015-01-15 00:23:16.000000', 'consum', 0.0345, 'lps'),
	(651782, 133, '2015-01-15 00:23:17.000000', 'consum', 0.0332, 'lps'),
	(651783, 133, '2015-01-15 00:23:18.000000', 'consum', 0.0415, 'lps'),
	(651784, 133, '2015-01-15 00:23:19.000000', 'consum', 0.0222, 'lps'),
	(651785, 133, '2015-01-15 00:23:20.000000', 'consum', 0.0303, 'lps'),
	(651786, 133, '2015-01-15 00:23:21.000000', 'consum', 0.0425, 'lps'),
	(651787, 133, '2015-01-15 00:23:22.000000', 'consum', 0.0356, 'lps'),
	(651788, 133, '2015-01-15 00:23:23.000000', 'consum', 0.0293, 'lps'),
	(651789, 133, '2015-01-15 00:23:24.000000', 'consum', 0.0404, 'lps'),
	(651790, 133, '2015-01-15 00:23:25.000000', 'consum', 0.0281, 'lps'),
	(651791, 133, '2015-01-15 00:23:26.000000', 'consum', 0.0417, 'lps'),
	(651792, 133, '2015-01-15 00:23:27.000000', 'consum', 0.0383, 'lps'),
	(651793, 133, '2015-01-15 00:23:28.000000', 'consum', 0.0235, 'lps'),
	(651794, 133, '2015-01-15 00:23:29.000000', 'consum', 0.0252, 'lps'),
	(651795, 133, '2015-01-15 00:23:30.000000', 'consum', 0.0347, 'lps'),
	(651796, 133, '2015-01-15 00:23:31.000000', 'consum', 0.0333, 'lps'),
	(651797, 133, '2015-01-15 00:23:32.000000', 'consum', 0.0413, 'lps'),
	(651798, 133, '2015-01-15 00:23:33.000000', 'consum', 0.0426, 'lps'),
	(651799, 133, '2015-01-15 00:23:34.000000', 'consum', 0.0246, 'lps'),
	(651800, 133, '2015-01-15 00:23:35.000000', 'consum', 0.0394, 'lps'),
	(651801, 133, '2015-01-15 00:23:36.000000', 'consum', 0.0369, 'lps'),
	(651802, 133, '2015-01-15 00:23:37.000000', 'consum', 0.0240, 'lps'),
	(651803, 133, '2015-01-15 00:23:38.000000', 'consum', 0.0316, 'lps'),
	(651804, 133, '2015-01-15 00:23:39.000000', 'consum', 0.0215, 'lps'),
	(651805, 133, '2015-01-15 00:23:40.000000', 'consum', 0.0353, 'lps'),
	(651806, 133, '2015-01-15 00:23:41.000000', 'consum', 0.0261, 'lps'),
	(651807, 133, '2015-01-15 00:23:42.000000', 'consum', 0.0251, 'lps'),
	(651808, 133, '2015-01-15 00:23:43.000000', 'consum', 0.0262, 'lps'),
	(651809, 133, '2015-01-15 00:23:44.000000', 'consum', 0.0347, 'lps'),
	(651810, 133, '2015-01-15 00:23:45.000000', 'consum', 0.0307, 'lps'),
	(651811, 133, '2015-01-15 00:23:46.000000', 'consum', 0.0285, 'lps'),
	(651812, 133, '2015-01-15 00:23:47.000000', 'consum', 0.0292, 'lps'),
	(651813, 133, '2015-01-15 00:23:48.000000', 'consum', 0.0399, 'lps'),
	(651814, 133, '2015-01-15 00:23:49.000000', 'consum', 0.0256, 'lps'),
	(651815, 133, '2015-01-15 00:23:50.000000', 'consum', 0.0310, 'lps'),
	(651816, 133, '2015-01-15 00:23:51.000000', 'consum', 0.0354, 'lps'),
	(651817, 133, '2015-01-15 00:23:52.000000', 'consum', 0.0413, 'lps'),
	(651818, 133, '2015-01-15 00:23:53.000000', 'consum', 0.0358, 'lps'),
	(651819, 133, '2015-01-15 00:23:54.000000', 'consum', 0.0343, 'lps'),
	(651820, 133, '2015-01-15 00:23:55.000000', 'consum', 0.0213, 'lps'),
	(651821, 133, '2015-01-15 00:23:56.000000', 'consum', 0.0260, 'lps'),
	(651822, 133, '2015-01-15 00:23:57.000000', 'consum', 0.0237, 'lps'),
	(651823, 133, '2015-01-15 00:23:58.000000', 'consum', 0.0412, 'lps'),
	(651824, 133, '2015-01-15 00:23:59.000000', 'consum', 0.0271, 'lps'),
	(651825, 133, '2015-01-15 00:24:00.000000', 'consum', 0.0345, 'lps'),
	(651826, 133, '2015-01-15 00:24:01.000000', 'consum', 0.0266, 'lps'),
	(651827, 133, '2015-01-15 00:24:02.000000', 'consum', 0.0302, 'lps'),
	(651828, 133, '2015-01-15 00:24:03.000000', 'consum', 0.0286, 'lps'),
	(651829, 133, '2015-01-15 00:24:04.000000', 'consum', 0.0315, 'lps'),
	(651830, 133, '2015-01-15 00:24:05.000000', 'consum', 0.0292, 'lps'),
	(651831, 133, '2015-01-15 00:24:06.000000', 'consum', 0.0306, 'lps'),
	(651832, 133, '2015-01-15 00:24:07.000000', 'consum', 0.0226, 'lps'),
	(651833, 133, '2015-01-15 00:24:08.000000', 'consum', 0.0218, 'lps'),
	(651834, 133, '2015-01-15 00:24:09.000000', 'consum', 0.0420, 'lps'),
	(651835, 133, '2015-01-15 00:24:10.000000', 'consum', 0.0368, 'lps'),
	(651836, 133, '2015-01-15 00:24:11.000000', 'consum', 0.0370, 'lps'),
	(651837, 133, '2015-01-15 00:24:12.000000', 'consum', 0.0320, 'lps'),
	(651838, 133, '2015-01-15 00:24:13.000000', 'consum', 0.0279, 'lps'),
	(651839, 133, '2015-01-15 00:24:14.000000', 'consum', 0.0226, 'lps'),
	(651840, 133, '2015-01-15 00:24:15.000000', 'consum', 0.0302, 'lps'),
	(651841, 133, '2015-01-15 00:24:16.000000', 'consum', 0.0404, 'lps'),
	(651842, 133, '2015-01-15 00:24:17.000000', 'consum', 0.0255, 'lps'),
	(651843, 133, '2015-01-15 00:24:18.000000', 'consum', 0.0286, 'lps'),
	(651844, 133, '2015-01-15 00:24:19.000000', 'consum', 0.0238, 'lps'),
	(651845, 133, '2015-01-15 00:24:20.000000', 'consum', 0.0341, 'lps'),
	(651846, 133, '2015-01-15 00:24:21.000000', 'consum', 0.0349, 'lps'),
	(651847, 133, '2015-01-15 00:24:22.000000', 'consum', 0.0294, 'lps'),
	(651848, 133, '2015-01-15 00:24:23.000000', 'consum', 0.0214, 'lps'),
	(651849, 133, '2015-01-15 00:24:24.000000', 'consum', 0.0413, 'lps'),
	(651850, 133, '2015-01-15 00:24:25.000000', 'consum', 0.0343, 'lps'),
	(651851, 133, '2015-01-15 00:24:26.000000', 'consum', 0.0267, 'lps'),
	(651852, 133, '2015-01-15 00:24:27.000000', 'consum', 0.0316, 'lps'),
	(651853, 133, '2015-01-15 00:24:28.000000', 'consum', 0.0352, 'lps'),
	(651854, 133, '2015-01-15 00:24:29.000000', 'consum', 0.0386, 'lps'),
	(651855, 133, '2015-01-15 00:24:30.000000', 'consum', 0.0228, 'lps'),
	(651856, 133, '2015-01-15 00:24:31.000000', 'consum', 0.0424, 'lps'),
	(651857, 133, '2015-01-15 00:24:32.000000', 'consum', 0.0360, 'lps'),
	(651858, 133, '2015-01-15 00:24:33.000000', 'consum', 0.0319, 'lps'),
	(651859, 133, '2015-01-15 00:24:34.000000', 'consum', 0.0304, 'lps'),
	(651860, 133, '2015-01-15 00:24:35.000000', 'consum', 0.0356, 'lps'),
	(651861, 133, '2015-01-15 00:24:36.000000', 'consum', 0.0222, 'lps'),
	(651862, 133, '2015-01-15 00:24:37.000000', 'consum', 0.0268, 'lps'),
	(651863, 133, '2015-01-15 00:24:38.000000', 'consum', 0.0245, 'lps'),
	(651864, 133, '2015-01-15 00:24:39.000000', 'consum', 0.0215, 'lps'),
	(651865, 133, '2015-01-15 00:24:40.000000', 'consum', 0.0345, 'lps'),
	(651866, 133, '2015-01-15 00:24:41.000000', 'consum', 0.0220, 'lps'),
	(651867, 133, '2015-01-15 00:24:42.000000', 'consum', 0.0290, 'lps'),
	(651868, 133, '2015-01-15 00:24:43.000000', 'consum', 0.0364, 'lps'),
	(651869, 133, '2015-01-15 00:24:44.000000', 'consum', 0.0307, 'lps'),
	(651870, 133, '2015-01-15 00:24:45.000000', 'consum', 0.0232, 'lps'),
	(651871, 133, '2015-01-15 00:24:46.000000', 'consum', 0.0248, 'lps'),
	(651872, 133, '2015-01-15 00:24:47.000000', 'consum', 0.0332, 'lps'),
	(651873, 133, '2015-01-15 00:24:48.000000', 'consum', 0.0276, 'lps'),
	(651874, 133, '2015-01-15 00:24:49.000000', 'consum', 0.0388, 'lps'),
	(651875, 133, '2015-01-15 00:24:50.000000', 'consum', 0.0254, 'lps'),
	(651876, 133, '2015-01-15 00:24:51.000000', 'consum', 0.0329, 'lps'),
	(651877, 133, '2015-01-15 00:24:52.000000', 'consum', 0.0239, 'lps'),
	(651878, 133, '2015-01-15 00:24:53.000000', 'consum', 0.0217, 'lps'),
	(651879, 133, '2015-01-15 00:24:54.000000', 'consum', 0.0373, 'lps'),
	(651880, 133, '2015-01-15 00:24:55.000000', 'consum', 0.0355, 'lps'),
	(651881, 133, '2015-01-15 00:24:56.000000', 'consum', 0.0228, 'lps'),
	(651882, 133, '2015-01-15 00:24:57.000000', 'consum', 0.0299, 'lps'),
	(651883, 133, '2015-01-15 00:24:58.000000', 'consum', 0.0387, 'lps'),
	(651884, 133, '2015-01-15 00:24:59.000000', 'consum', 0.0394, 'lps'),
	(651885, 133, '2015-01-15 00:25:00.000000', 'consum', 0.0381, 'lps'),
	(651886, 133, '2015-01-15 00:25:01.000000', 'consum', 0.0295, 'lps'),
	(651887, 133, '2015-01-15 00:25:02.000000', 'consum', 0.0342, 'lps'),
	(651888, 133, '2015-01-15 00:25:03.000000', 'consum', 0.0400, 'lps'),
	(651889, 133, '2015-01-15 00:25:04.000000', 'consum', 0.0328, 'lps'),
	(651890, 133, '2015-01-15 00:25:05.000000', 'consum', 0.0229, 'lps'),
	(651891, 133, '2015-01-15 00:25:06.000000', 'consum', 0.0389, 'lps'),
	(651892, 133, '2015-01-15 00:25:07.000000', 'consum', 0.0394, 'lps'),
	(651893, 133, '2015-01-15 00:25:08.000000', 'consum', 0.0380, 'lps'),
	(651894, 133, '2015-01-15 00:25:09.000000', 'consum', 0.0288, 'lps'),
	(651895, 133, '2015-01-15 00:25:10.000000', 'consum', 0.0310, 'lps'),
	(651896, 133, '2015-01-15 00:25:11.000000', 'consum', 0.0260, 'lps'),
	(651897, 133, '2015-01-15 00:25:12.000000', 'consum', 0.0376, 'lps'),
	(651898, 133, '2015-01-15 00:25:13.000000', 'consum', 0.0242, 'lps'),
	(651899, 133, '2015-01-15 00:25:14.000000', 'consum', 0.0304, 'lps'),
	(651900, 133, '2015-01-15 00:25:15.000000', 'consum', 0.0366, 'lps'),
	(651901, 133, '2015-01-15 00:25:16.000000', 'consum', 0.0277, 'lps'),
	(651902, 133, '2015-01-15 00:25:17.000000', 'consum', 0.0293, 'lps'),
	(651903, 133, '2015-01-15 00:25:18.000000', 'consum', 0.0426, 'lps'),
	(651904, 133, '2015-01-15 00:25:19.000000', 'consum', 0.0388, 'lps'),
	(651905, 133, '2015-01-15 00:25:20.000000', 'consum', 0.0238, 'lps'),
	(651906, 133, '2015-01-15 00:25:21.000000', 'consum', 0.0251, 'lps'),
	(651907, 133, '2015-01-15 00:25:22.000000', 'consum', 0.0329, 'lps'),
	(651908, 133, '2015-01-15 00:25:23.000000', 'consum', 0.0248, 'lps'),
	(651909, 133, '2015-01-15 00:25:24.000000', 'consum', 0.0262, 'lps'),
	(651910, 133, '2015-01-15 00:25:25.000000', 'consum', 0.0354, 'lps'),
	(651911, 133, '2015-01-15 00:25:26.000000', 'consum', 0.0343, 'lps'),
	(651912, 133, '2015-01-15 00:25:27.000000', 'consum', 0.0227, 'lps'),
	(651913, 133, '2015-01-15 00:25:28.000000', 'consum', 0.0329, 'lps'),
	(651914, 133, '2015-01-15 00:25:29.000000', 'consum', 0.0321, 'lps'),
	(651915, 133, '2015-01-15 00:25:30.000000', 'consum', 0.0409, 'lps'),
	(651916, 133, '2015-01-15 00:25:31.000000', 'consum', 0.0223, 'lps'),
	(651917, 133, '2015-01-15 00:25:32.000000', 'consum', 0.0328, 'lps'),
	(651918, 133, '2015-01-15 00:25:33.000000', 'consum', 0.0327, 'lps'),
	(651919, 133, '2015-01-15 00:25:34.000000', 'consum', 0.0225, 'lps'),
	(651920, 133, '2015-01-15 00:25:35.000000', 'consum', 0.0367, 'lps'),
	(651921, 133, '2015-01-15 00:25:36.000000', 'consum', 0.0301, 'lps'),
	(651922, 133, '2015-01-15 00:25:37.000000', 'consum', 0.0409, 'lps'),
	(651923, 133, '2015-01-15 00:25:38.000000', 'consum', 0.0285, 'lps'),
	(651924, 133, '2015-01-15 00:25:39.000000', 'consum', 0.0419, 'lps'),
	(651925, 133, '2015-01-15 00:25:40.000000', 'consum', 0.0383, 'lps'),
	(651926, 133, '2015-01-15 00:25:41.000000', 'consum', 0.0229, 'lps'),
	(651927, 133, '2015-01-15 00:25:42.000000', 'consum', 0.0221, 'lps'),
	(651928, 133, '2015-01-15 00:25:43.000000', 'consum', 0.0210, 'lps'),
	(651929, 133, '2015-01-15 00:25:44.000000', 'consum', 0.0392, 'lps'),
	(651930, 133, '2015-01-15 00:25:45.000000', 'consum', 0.0254, 'lps'),
	(651931, 133, '2015-01-15 00:25:46.000000', 'consum', 0.0317, 'lps'),
	(651932, 133, '2015-01-15 00:25:47.000000', 'consum', 0.0399, 'lps'),
	(651933, 133, '2015-01-15 00:25:48.000000', 'consum', 0.0398, 'lps'),
	(651934, 133, '2015-01-15 00:25:49.000000', 'consum', 0.0368, 'lps'),
	(651935, 133, '2015-01-15 00:25:50.000000', 'consum', 0.0221, 'lps'),
	(651936, 133, '2015-01-15 00:25:51.000000', 'consum', 0.0223, 'lps'),
	(651937, 133, '2015-01-15 00:25:52.000000', 'consum', 0.0242, 'lps'),
	(651938, 133, '2015-01-15 00:25:53.000000', 'consum', 0.0334, 'lps'),
	(651939, 133, '2015-01-15 00:25:54.000000', 'consum', 0.0298, 'lps'),
	(651940, 133, '2015-01-15 00:25:55.000000', 'consum', 0.0279, 'lps'),
	(651941, 133, '2015-01-15 00:25:56.000000', 'consum', 0.0294, 'lps'),
	(651942, 133, '2015-01-15 00:25:57.000000', 'consum', 0.0421, 'lps'),
	(651943, 133, '2015-01-15 00:25:58.000000', 'consum', 0.0364, 'lps'),
	(651944, 133, '2015-01-15 00:25:59.000000', 'consum', 0.0349, 'lps'),
	(651945, 133, '2015-01-15 00:26:00.000000', 'consum', 0.0223, 'lps'),
	(651946, 133, '2015-01-15 00:26:01.000000', 'consum', 0.0294, 'lps'),
	(651947, 133, '2015-01-15 00:26:02.000000', 'consum', 0.0377, 'lps'),
	(651948, 133, '2015-01-15 00:26:03.000000', 'consum', 0.0356, 'lps'),
	(651949, 133, '2015-01-15 00:26:04.000000', 'consum', 0.0223, 'lps'),
	(651950, 133, '2015-01-15 00:26:05.000000', 'consum', 0.0271, 'lps'),
	(651951, 133, '2015-01-15 00:26:06.000000', 'consum', 0.0262, 'lps'),
	(651952, 133, '2015-01-15 00:26:07.000000', 'consum', 0.0286, 'lps'),
	(651953, 133, '2015-01-15 00:26:08.000000', 'consum', 0.0219, 'lps'),
	(651954, 133, '2015-01-15 00:26:09.000000', 'consum', 0.0242, 'lps'),
	(651955, 133, '2015-01-15 00:26:10.000000', 'consum', 0.0343, 'lps'),
	(651956, 133, '2015-01-15 00:26:11.000000', 'consum', 0.0348, 'lps'),
	(651957, 133, '2015-01-15 00:26:12.000000', 'consum', 0.0283, 'lps'),
	(651958, 133, '2015-01-15 00:26:13.000000', 'consum', 0.0377, 'lps'),
	(651959, 133, '2015-01-15 00:26:14.000000', 'consum', 0.0396, 'lps'),
	(651960, 133, '2015-01-15 00:26:15.000000', 'consum', 0.0420, 'lps'),
	(651961, 133, '2015-01-15 00:26:16.000000', 'consum', 0.0268, 'lps'),
	(651962, 133, '2015-01-15 00:26:17.000000', 'consum', 0.0305, 'lps'),
	(651963, 133, '2015-01-15 00:26:18.000000', 'consum', 0.0296, 'lps'),
	(651964, 133, '2015-01-15 00:26:19.000000', 'consum', 0.0354, 'lps'),
	(651965, 133, '2015-01-15 00:26:20.000000', 'consum', 0.0238, 'lps'),
	(651966, 133, '2015-01-15 00:26:21.000000', 'consum', 0.0353, 'lps'),
	(651967, 133, '2015-01-15 00:26:22.000000', 'consum', 0.0406, 'lps'),
	(651968, 133, '2015-01-15 00:26:23.000000', 'consum', 0.0331, 'lps'),
	(651969, 133, '2015-01-15 00:26:24.000000', 'consum', 0.0224, 'lps'),
	(651970, 133, '2015-01-15 00:26:25.000000', 'consum', 0.0355, 'lps'),
	(651971, 133, '2015-01-15 00:26:26.000000', 'consum', 0.0239, 'lps'),
	(651972, 133, '2015-01-15 00:26:27.000000', 'consum', 0.0357, 'lps'),
	(651973, 133, '2015-01-15 00:26:28.000000', 'consum', 0.0425, 'lps'),
	(651974, 133, '2015-01-15 00:26:29.000000', 'consum', 0.0411, 'lps'),
	(651975, 133, '2015-01-15 00:26:30.000000', 'consum', 0.0351, 'lps'),
	(651976, 133, '2015-01-15 00:26:31.000000', 'consum', 0.0315, 'lps'),
	(651977, 133, '2015-01-15 00:26:32.000000', 'consum', 0.0313, 'lps'),
	(651978, 133, '2015-01-15 00:26:33.000000', 'consum', 0.0410, 'lps'),
	(651979, 133, '2015-01-15 00:26:34.000000', 'consum', 0.0251, 'lps'),
	(651980, 133, '2015-01-15 00:26:35.000000', 'consum', 0.0251, 'lps'),
	(651981, 133, '2015-01-15 00:26:36.000000', 'consum', 0.0290, 'lps'),
	(651982, 133, '2015-01-15 00:26:37.000000', 'consum', 0.0273, 'lps'),
	(651983, 133, '2015-01-15 00:26:38.000000', 'consum', 0.0282, 'lps'),
	(651984, 133, '2015-01-15 00:26:39.000000', 'consum', 0.0384, 'lps'),
	(651985, 133, '2015-01-15 00:26:40.000000', 'consum', 0.0214, 'lps'),
	(651986, 133, '2015-01-15 00:26:41.000000', 'consum', 0.0358, 'lps'),
	(651987, 133, '2015-01-15 00:26:42.000000', 'consum', 0.0288, 'lps'),
	(651988, 133, '2015-01-15 00:26:43.000000', 'consum', 0.0375, 'lps'),
	(651989, 133, '2015-01-15 00:26:44.000000', 'consum', 0.0367, 'lps'),
	(651990, 133, '2015-01-15 00:26:45.000000', 'consum', 0.0284, 'lps'),
	(651991, 133, '2015-01-15 00:26:46.000000', 'consum', 0.0328, 'lps'),
	(651992, 133, '2015-01-15 00:26:47.000000', 'consum', 0.0359, 'lps'),
	(651993, 133, '2015-01-15 00:26:48.000000', 'consum', 0.0385, 'lps'),
	(651994, 133, '2015-01-15 00:26:49.000000', 'consum', 0.0420, 'lps'),
	(651995, 133, '2015-01-15 00:26:50.000000', 'consum', 0.0302, 'lps'),
	(651996, 133, '2015-01-15 00:26:51.000000', 'consum', 0.0256, 'lps'),
	(651997, 133, '2015-01-15 00:26:52.000000', 'consum', 0.0384, 'lps'),
	(651998, 133, '2015-01-15 00:26:53.000000', 'consum', 0.0291, 'lps'),
	(651999, 133, '2015-01-15 00:26:54.000000', 'consum', 0.0310, 'lps'),
	(652000, 133, '2015-01-15 00:26:55.000000', 'consum', 0.0251, 'lps'),
	(652001, 133, '2015-01-15 00:26:56.000000', 'consum', 0.0333, 'lps'),
	(652002, 133, '2015-01-15 00:26:57.000000', 'consum', 0.0269, 'lps'),
	(652003, 133, '2015-01-15 00:26:58.000000', 'consum', 0.0351, 'lps'),
	(652004, 133, '2015-01-15 00:26:59.000000', 'consum', 0.0305, 'lps'),
	(652005, 133, '2015-01-15 00:27:00.000000', 'consum', 0.0264, 'lps'),
	(652006, 133, '2015-01-15 00:27:01.000000', 'consum', 0.0411, 'lps'),
	(652007, 133, '2015-01-15 00:27:02.000000', 'consum', 0.0403, 'lps'),
	(652008, 133, '2015-01-15 00:27:03.000000', 'consum', 0.0354, 'lps'),
	(652009, 133, '2015-01-15 00:27:04.000000', 'consum', 0.0354, 'lps'),
	(652010, 133, '2015-01-15 00:27:05.000000', 'consum', 0.0282, 'lps'),
	(652011, 133, '2015-01-15 00:27:06.000000', 'consum', 0.0353, 'lps'),
	(652012, 133, '2015-01-15 00:27:07.000000', 'consum', 0.0278, 'lps'),
	(652013, 133, '2015-01-15 00:27:08.000000', 'consum', 0.0338, 'lps'),
	(652014, 133, '2015-01-15 00:27:09.000000', 'consum', 0.0212, 'lps'),
	(652015, 133, '2015-01-15 00:27:10.000000', 'consum', 0.0270, 'lps'),
	(652016, 133, '2015-01-15 00:27:11.000000', 'consum', 0.0288, 'lps'),
	(652017, 133, '2015-01-15 00:27:12.000000', 'consum', 0.0419, 'lps'),
	(652018, 133, '2015-01-15 00:27:13.000000', 'consum', 0.0371, 'lps'),
	(652019, 133, '2015-01-15 00:27:14.000000', 'consum', 0.0388, 'lps'),
	(652020, 133, '2015-01-15 00:27:15.000000', 'consum', 0.0402, 'lps'),
	(652021, 133, '2015-01-15 00:27:16.000000', 'consum', 0.0418, 'lps'),
	(652022, 133, '2015-01-15 00:27:17.000000', 'consum', 0.0240, 'lps'),
	(652023, 133, '2015-01-15 00:27:18.000000', 'consum', 0.0389, 'lps'),
	(652024, 133, '2015-01-15 00:27:19.000000', 'consum', 0.0363, 'lps'),
	(652025, 133, '2015-01-15 00:27:20.000000', 'consum', 0.0224, 'lps'),
	(652026, 133, '2015-01-15 00:27:21.000000', 'consum', 0.0252, 'lps'),
	(652027, 133, '2015-01-15 00:27:22.000000', 'consum', 0.0381, 'lps'),
	(652028, 133, '2015-01-15 00:27:23.000000', 'consum', 0.0287, 'lps'),
	(652029, 133, '2015-01-15 00:27:24.000000', 'consum', 0.0302, 'lps'),
	(652030, 133, '2015-01-15 00:27:25.000000', 'consum', 0.0222, 'lps'),
	(652031, 133, '2015-01-15 00:27:26.000000', 'consum', 0.0211, 'lps'),
	(652032, 133, '2015-01-15 00:27:27.000000', 'consum', 0.0396, 'lps'),
	(652033, 133, '2015-01-15 00:27:28.000000', 'consum', 0.0269, 'lps'),
	(652034, 133, '2015-01-15 00:27:29.000000', 'consum', 0.0383, 'lps'),
	(652035, 133, '2015-01-15 00:27:30.000000', 'consum', 0.0246, 'lps'),
	(652036, 133, '2015-01-15 00:27:31.000000', 'consum', 0.0305, 'lps'),
	(652037, 133, '2015-01-15 00:27:32.000000', 'consum', 0.0360, 'lps'),
	(652038, 133, '2015-01-15 00:27:33.000000', 'consum', 0.0241, 'lps'),
	(652039, 133, '2015-01-15 00:27:34.000000', 'consum', 0.0351, 'lps'),
	(652040, 133, '2015-01-15 00:27:35.000000', 'consum', 0.0387, 'lps'),
	(652041, 133, '2015-01-15 00:27:36.000000', 'consum', 0.0238, 'lps'),
	(652042, 133, '2015-01-15 00:27:37.000000', 'consum', 0.0255, 'lps'),
	(652043, 133, '2015-01-15 00:27:38.000000', 'consum', 0.0350, 'lps'),
	(652044, 133, '2015-01-15 00:27:39.000000', 'consum', 0.0343, 'lps'),
	(652045, 133, '2015-01-15 00:27:40.000000', 'consum', 0.0239, 'lps'),
	(652046, 133, '2015-01-15 00:27:41.000000', 'consum', 0.0390, 'lps'),
	(652047, 133, '2015-01-15 00:27:42.000000', 'consum', 0.0371, 'lps'),
	(652048, 133, '2015-01-15 00:27:43.000000', 'consum', 0.0259, 'lps'),
	(652049, 133, '2015-01-15 00:27:44.000000', 'consum', 0.0406, 'lps'),
	(652050, 133, '2015-01-15 00:27:45.000000', 'consum', 0.0392, 'lps'),
	(652051, 133, '2015-01-15 00:27:46.000000', 'consum', 0.0316, 'lps'),
	(652052, 133, '2015-01-15 00:27:47.000000', 'consum', 0.0412, 'lps'),
	(652053, 133, '2015-01-15 00:27:48.000000', 'consum', 0.0253, 'lps'),
	(652054, 133, '2015-01-15 00:27:49.000000', 'consum', 0.0254, 'lps'),
	(652055, 133, '2015-01-15 00:27:50.000000', 'consum', 0.0299, 'lps'),
	(652056, 133, '2015-01-15 00:27:51.000000', 'consum', 0.0309, 'lps'),
	(652057, 133, '2015-01-15 00:27:52.000000', 'consum', 0.0219, 'lps'),
	(652058, 133, '2015-01-15 00:27:53.000000', 'consum', 0.0392, 'lps'),
	(652059, 133, '2015-01-15 00:27:54.000000', 'consum', 0.0228, 'lps'),
	(652060, 133, '2015-01-15 00:27:55.000000', 'consum', 0.0405, 'lps'),
	(652061, 133, '2015-01-15 00:27:56.000000', 'consum', 0.0264, 'lps'),
	(652062, 133, '2015-01-15 00:27:57.000000', 'consum', 0.0330, 'lps'),
	(652063, 133, '2015-01-15 00:27:58.000000', 'consum', 0.0215, 'lps'),
	(652064, 133, '2015-01-15 00:27:59.000000', 'consum', 0.0309, 'lps'),
	(652065, 133, '2015-01-15 00:28:00.000000', 'consum', 0.0255, 'lps'),
	(652066, 133, '2015-01-15 00:28:01.000000', 'consum', 0.0357, 'lps'),
	(652067, 133, '2015-01-15 00:28:02.000000', 'consum', 0.0377, 'lps'),
	(652068, 133, '2015-01-15 00:28:03.000000', 'consum', 0.0386, 'lps'),
	(652069, 133, '2015-01-15 00:28:04.000000', 'consum', 0.0375, 'lps'),
	(652070, 133, '2015-01-15 00:28:05.000000', 'consum', 0.0289, 'lps'),
	(652071, 133, '2015-01-15 00:28:06.000000', 'consum', 0.0326, 'lps'),
	(652072, 133, '2015-01-15 00:28:07.000000', 'consum', 0.0336, 'lps'),
	(652073, 133, '2015-01-15 00:28:08.000000', 'consum', 0.0277, 'lps'),
	(652074, 133, '2015-01-15 00:28:09.000000', 'consum', 0.0386, 'lps'),
	(652075, 133, '2015-01-15 00:28:10.000000', 'consum', 0.0238, 'lps'),
	(652076, 133, '2015-01-15 00:28:11.000000', 'consum', 0.0254, 'lps'),
	(652077, 133, '2015-01-15 00:28:12.000000', 'consum', 0.0349, 'lps'),
	(652078, 133, '2015-01-15 00:28:13.000000', 'consum', 0.0338, 'lps'),
	(652079, 133, '2015-01-15 00:28:14.000000', 'consum', 0.0216, 'lps'),
	(652080, 133, '2015-01-15 00:28:15.000000', 'consum', 0.0292, 'lps'),
	(652081, 133, '2015-01-15 00:28:16.000000', 'consum', 0.0384, 'lps'),
	(652082, 133, '2015-01-15 00:28:17.000000', 'consum', 0.0402, 'lps'),
	(652083, 133, '2015-01-15 00:28:18.000000', 'consum', 0.0213, 'lps'),
	(652084, 133, '2015-01-15 00:28:19.000000', 'consum', 0.0300, 'lps'),
	(652085, 133, '2015-01-15 00:28:20.000000', 'consum', 0.0219, 'lps'),
	(652086, 133, '2015-01-15 00:28:21.000000', 'consum', 0.0421, 'lps'),
	(652087, 133, '2015-01-15 00:28:22.000000', 'consum', 0.0367, 'lps'),
	(652088, 133, '2015-01-15 00:28:23.000000', 'consum', 0.0365, 'lps'),
	(652089, 133, '2015-01-15 00:28:24.000000', 'consum', 0.0298, 'lps'),
	(652090, 133, '2015-01-15 00:28:25.000000', 'consum', 0.0400, 'lps'),
	(652091, 133, '2015-01-15 00:28:26.000000', 'consum', 0.0245, 'lps'),
	(652092, 133, '2015-01-15 00:28:27.000000', 'consum', 0.0249, 'lps'),
	(652093, 133, '2015-01-15 00:28:28.000000', 'consum', 0.0301, 'lps'),
	(652094, 133, '2015-01-15 00:28:29.000000', 'consum', 0.0331, 'lps'),
	(652095, 133, '2015-01-15 00:28:30.000000', 'consum', 0.0328, 'lps'),
	(652096, 133, '2015-01-15 00:28:31.000000', 'consum', 0.0217, 'lps'),
	(652097, 133, '2015-01-15 00:28:32.000000', 'consum', 0.0329, 'lps'),
	(652098, 133, '2015-01-15 00:28:33.000000', 'consum', 0.0350, 'lps'),
	(652099, 133, '2015-01-15 00:28:34.000000', 'consum', 0.0335, 'lps'),
	(652100, 133, '2015-01-15 00:28:35.000000', 'consum', 0.0416, 'lps'),
	(652101, 133, '2015-01-15 00:28:36.000000', 'consum', 0.0217, 'lps'),
	(652102, 133, '2015-01-15 00:28:37.000000', 'consum', 0.0275, 'lps'),
	(652103, 133, '2015-01-15 00:28:38.000000', 'consum', 0.0299, 'lps'),
	(652104, 133, '2015-01-15 00:28:39.000000', 'consum', 0.0243, 'lps'),
	(652105, 133, '2015-01-15 00:28:40.000000', 'consum', 0.0327, 'lps'),
	(652106, 133, '2015-01-15 00:28:41.000000', 'consum', 0.0260, 'lps'),
	(652107, 133, '2015-01-15 00:28:42.000000', 'consum', 0.0328, 'lps'),
	(652108, 133, '2015-01-15 00:28:43.000000', 'consum', 0.0215, 'lps'),
	(652109, 133, '2015-01-15 00:28:44.000000', 'consum', 0.0317, 'lps'),
	(652110, 133, '2015-01-15 00:28:45.000000', 'consum', 0.0297, 'lps'),
	(652111, 133, '2015-01-15 00:28:46.000000', 'consum', 0.0325, 'lps'),
	(652112, 133, '2015-01-15 00:28:47.000000', 'consum', 0.0308, 'lps'),
	(652113, 133, '2015-01-15 00:28:48.000000', 'consum', 0.0355, 'lps'),
	(652114, 133, '2015-01-15 00:28:49.000000', 'consum', 0.0424, 'lps'),
	(652115, 133, '2015-01-15 00:28:50.000000', 'consum', 0.0412, 'lps'),
	(652116, 133, '2015-01-15 00:28:51.000000', 'consum', 0.0362, 'lps'),
	(652117, 133, '2015-01-15 00:28:52.000000', 'consum', 0.0363, 'lps'),
	(652118, 133, '2015-01-15 00:28:53.000000', 'consum', 0.0301, 'lps'),
	(652119, 133, '2015-01-15 00:28:54.000000', 'consum', 0.0425, 'lps'),
	(652120, 133, '2015-01-15 00:28:55.000000', 'consum', 0.0362, 'lps'),
	(652121, 133, '2015-01-15 00:28:56.000000', 'consum', 0.0326, 'lps'),
	(652122, 133, '2015-01-15 00:28:57.000000', 'consum', 0.0336, 'lps'),
	(652123, 133, '2015-01-15 00:28:58.000000', 'consum', 0.0272, 'lps'),
	(652124, 133, '2015-01-15 00:28:59.000000', 'consum', 0.0361, 'lps'),
	(652125, 133, '2015-01-15 00:29:00.000000', 'consum', 0.0344, 'lps'),
	(652126, 133, '2015-01-15 00:29:01.000000', 'consum', 0.0210, 'lps'),
	(652127, 133, '2015-01-15 00:29:02.000000', 'consum', 0.0244, 'lps'),
	(652128, 133, '2015-01-15 00:29:03.000000', 'consum', 0.0381, 'lps'),
	(652129, 133, '2015-01-15 00:29:04.000000', 'consum', 0.0313, 'lps'),
	(652130, 133, '2015-01-15 00:29:05.000000', 'consum', 0.0213, 'lps'),
	(652131, 133, '2015-01-15 00:29:06.000000', 'consum', 0.0352, 'lps'),
	(652132, 133, '2015-01-15 00:29:07.000000', 'consum', 0.0257, 'lps'),
	(652133, 133, '2015-01-15 00:29:08.000000', 'consum', 0.0239, 'lps'),
	(652134, 133, '2015-01-15 00:29:09.000000', 'consum', 0.0212, 'lps'),
	(652135, 133, '2015-01-15 00:29:10.000000', 'consum', 0.0353, 'lps'),
	(652136, 133, '2015-01-15 00:29:11.000000', 'consum', 0.0269, 'lps'),
	(652137, 133, '2015-01-15 00:29:12.000000', 'consum', 0.0294, 'lps'),
	(652138, 133, '2015-01-15 00:29:13.000000', 'consum', 0.0237, 'lps'),
	(652139, 133, '2015-01-15 00:29:14.000000', 'consum', 0.0307, 'lps'),
	(652140, 133, '2015-01-15 00:29:15.000000', 'consum', 0.0401, 'lps'),
	(652141, 133, '2015-01-15 00:29:16.000000', 'consum', 0.0221, 'lps'),
	(652142, 133, '2015-01-15 00:29:17.000000', 'consum', 0.0346, 'lps'),
	(652143, 133, '2015-01-15 00:29:18.000000', 'consum', 0.0422, 'lps'),
	(652144, 133, '2015-01-15 00:29:19.000000', 'consum', 0.0211, 'lps'),
	(652145, 133, '2015-01-15 00:29:20.000000', 'consum', 0.0231, 'lps'),
	(652146, 133, '2015-01-15 00:29:21.000000', 'consum', 0.0311, 'lps'),
	(652147, 133, '2015-01-15 00:29:22.000000', 'consum', 0.0218, 'lps'),
	(652148, 133, '2015-01-15 00:29:23.000000', 'consum', 0.0382, 'lps'),
	(652149, 133, '2015-01-15 00:29:24.000000', 'consum', 0.0396, 'lps'),
	(652150, 133, '2015-01-15 00:29:25.000000', 'consum', 0.0406, 'lps'),
	(652151, 133, '2015-01-15 00:29:26.000000', 'consum', 0.0416, 'lps'),
	(652152, 133, '2015-01-15 00:29:27.000000', 'consum', 0.0218, 'lps'),
	(652153, 133, '2015-01-15 00:29:28.000000', 'consum', 0.0283, 'lps'),
	(652154, 133, '2015-01-15 00:29:29.000000', 'consum', 0.0337, 'lps'),
	(652155, 133, '2015-01-15 00:29:30.000000', 'consum', 0.0407, 'lps'),
	(652156, 133, '2015-01-15 00:29:31.000000', 'consum', 0.0380, 'lps'),
	(652157, 133, '2015-01-15 00:29:32.000000', 'consum', 0.0254, 'lps'),
	(652158, 133, '2015-01-15 00:29:33.000000', 'consum', 0.0354, 'lps'),
	(652159, 133, '2015-01-15 00:29:34.000000', 'consum', 0.0363, 'lps'),
	(652160, 133, '2015-01-15 00:29:35.000000', 'consum', 0.0328, 'lps'),
	(652161, 133, '2015-01-15 00:29:36.000000', 'consum', 0.0343, 'lps'),
	(652162, 133, '2015-01-15 00:29:37.000000', 'consum', 0.0304, 'lps'),
	(652163, 133, '2015-01-15 00:29:38.000000', 'consum', 0.0281, 'lps'),
	(652164, 133, '2015-01-15 00:29:39.000000', 'consum', 0.0282, 'lps'),
	(652165, 133, '2015-01-15 00:29:40.000000', 'consum', 0.0360, 'lps'),
	(652166, 133, '2015-01-15 00:29:41.000000', 'consum', 0.0307, 'lps'),
	(652167, 133, '2015-01-15 00:29:42.000000', 'consum', 0.0249, 'lps'),
	(652168, 133, '2015-01-15 00:29:43.000000', 'consum', 0.0329, 'lps'),
	(652169, 133, '2015-01-15 00:29:44.000000', 'consum', 0.0257, 'lps'),
	(652170, 133, '2015-01-15 00:29:45.000000', 'consum', 0.0305, 'lps'),
	(652171, 133, '2015-01-15 00:29:46.000000', 'consum', 0.0325, 'lps'),
	(652172, 133, '2015-01-15 00:29:47.000000', 'consum', 0.0286, 'lps'),
	(652173, 133, '2015-01-15 00:29:48.000000', 'consum', 0.0243, 'lps'),
	(652174, 133, '2015-01-15 00:29:49.000000', 'consum', 0.0366, 'lps'),
	(652175, 133, '2015-01-15 00:29:50.000000', 'consum', 0.0239, 'lps'),
	(652176, 133, '2015-01-15 00:29:51.000000', 'consum', 0.0321, 'lps'),
	(652177, 133, '2015-01-15 00:29:52.000000', 'consum', 0.0244, 'lps'),
	(652178, 133, '2015-01-15 00:29:53.000000', 'consum', 0.0264, 'lps'),
	(652179, 133, '2015-01-15 00:29:54.000000', 'consum', 0.0381, 'lps'),
	(652180, 133, '2015-01-15 00:29:55.000000', 'consum', 0.0253, 'lps'),
	(652181, 133, '2015-01-15 00:29:56.000000', 'consum', 0.0344, 'lps'),
	(652182, 133, '2015-01-15 00:29:57.000000', 'consum', 0.0321, 'lps'),
	(652183, 133, '2015-01-15 00:29:58.000000', 'consum', 0.0360, 'lps'),
	(652184, 133, '2015-01-15 00:29:59.000000', 'consum', 0.0413, 'lps'),
	(652185, 133, '2015-01-15 00:30:00.000000', 'consum', 0.0339, 'lps'),
	(652186, 133, '2015-01-15 00:30:01.000000', 'consum', 0.0248, 'lps'),
	(652187, 133, '2015-01-15 00:30:02.000000', 'consum', 0.0230, 'lps'),
	(652188, 133, '2015-01-15 00:30:03.000000', 'consum', 0.0414, 'lps'),
	(652189, 133, '2015-01-15 00:30:04.000000', 'consum', 0.0304, 'lps'),
	(652190, 133, '2015-01-15 00:30:05.000000', 'consum', 0.0283, 'lps'),
	(652191, 133, '2015-01-15 00:30:06.000000', 'consum', 0.0293, 'lps'),
	(652192, 133, '2015-01-15 00:30:07.000000', 'consum', 0.0410, 'lps'),
	(652193, 133, '2015-01-15 00:30:08.000000', 'consum', 0.0307, 'lps'),
	(652194, 133, '2015-01-15 00:30:09.000000', 'consum', 0.0314, 'lps'),
	(652195, 133, '2015-01-15 00:30:10.000000', 'consum', 0.0220, 'lps'),
	(652196, 133, '2015-01-15 00:30:11.000000', 'consum', 0.0386, 'lps'),
	(652197, 133, '2015-01-15 00:30:12.000000', 'consum', 0.0406, 'lps'),
	(652198, 133, '2015-01-15 00:30:13.000000', 'consum', 0.0230, 'lps'),
	(652199, 133, '2015-01-15 00:30:14.000000', 'consum', 0.0375, 'lps'),
	(652200, 133, '2015-01-15 00:30:15.000000', 'consum', 0.0325, 'lps'),
	(652201, 133, '2015-01-15 00:30:16.000000', 'consum', 0.0290, 'lps'),
	(652202, 133, '2015-01-15 00:30:17.000000', 'consum', 0.0265, 'lps'),
	(652203, 133, '2015-01-15 00:30:18.000000', 'consum', 0.0246, 'lps'),
	(652204, 133, '2015-01-15 00:30:19.000000', 'consum', 0.0226, 'lps'),
	(652205, 133, '2015-01-15 00:30:20.000000', 'consum', 0.0399, 'lps'),
	(652206, 133, '2015-01-15 00:30:21.000000', 'consum', 0.0242, 'lps'),
	(652207, 133, '2015-01-15 00:30:22.000000', 'consum', 0.0234, 'lps'),
	(652208, 133, '2015-01-15 00:30:23.000000', 'consum', 0.0234, 'lps'),
	(652209, 133, '2015-01-15 00:30:24.000000', 'consum', 0.0260, 'lps'),
	(652210, 133, '2015-01-15 00:30:25.000000', 'consum', 0.0389, 'lps'),
	(652211, 133, '2015-01-15 00:30:26.000000', 'consum', 0.0305, 'lps'),
	(652212, 133, '2015-01-15 00:30:27.000000', 'consum', 0.0365, 'lps'),
	(652213, 133, '2015-01-15 00:30:28.000000', 'consum', 0.0267, 'lps'),
	(652214, 133, '2015-01-15 00:30:29.000000', 'consum', 0.0248, 'lps'),
	(652215, 133, '2015-01-15 00:30:30.000000', 'consum', 0.0231, 'lps'),
	(652216, 133, '2015-01-15 00:30:31.000000', 'consum', 0.0416, 'lps'),
	(652217, 133, '2015-01-15 00:30:32.000000', 'consum', 0.0309, 'lps'),
	(652218, 133, '2015-01-15 00:30:33.000000', 'consum', 0.0304, 'lps'),
	(652219, 133, '2015-01-15 00:30:34.000000', 'consum', 0.0386, 'lps'),
	(652220, 133, '2015-01-15 00:30:35.000000', 'consum', 0.0374, 'lps'),
	(652221, 133, '2015-01-15 00:30:36.000000', 'consum', 0.0287, 'lps'),
	(652222, 133, '2015-01-15 00:30:37.000000', 'consum', 0.0319, 'lps'),
	(652223, 133, '2015-01-15 00:30:38.000000', 'consum', 0.0308, 'lps'),
	(652224, 133, '2015-01-15 00:30:39.000000', 'consum', 0.0372, 'lps'),
	(652225, 133, '2015-01-15 00:30:40.000000', 'consum', 0.0292, 'lps'),
	(652226, 133, '2015-01-15 00:30:41.000000', 'consum', 0.0353, 'lps'),
	(652227, 133, '2015-01-15 00:30:42.000000', 'consum', 0.0245, 'lps'),
	(652228, 133, '2015-01-15 00:30:43.000000', 'consum', 0.0390, 'lps'),
	(652229, 133, '2015-01-15 00:30:44.000000', 'consum', 0.0354, 'lps'),
	(652230, 133, '2015-01-15 00:30:45.000000', 'consum', 0.0393, 'lps'),
	(652231, 133, '2015-01-15 00:30:46.000000', 'consum', 0.0258, 'lps'),
	(652232, 133, '2015-01-15 00:30:47.000000', 'consum', 0.0335, 'lps'),
	(652233, 133, '2015-01-15 00:30:48.000000', 'consum', 0.0258, 'lps'),
	(652234, 133, '2015-01-15 00:30:49.000000', 'consum', 0.0291, 'lps'),
	(652235, 133, '2015-01-15 00:30:50.000000', 'consum', 0.0256, 'lps'),
	(652236, 133, '2015-01-15 00:30:51.000000', 'consum', 0.0416, 'lps'),
	(652237, 133, '2015-01-15 00:30:52.000000', 'consum', 0.0234, 'lps'),
	(652238, 133, '2015-01-15 00:30:53.000000', 'consum', 0.0364, 'lps'),
	(652239, 133, '2015-01-15 00:30:54.000000', 'consum', 0.0255, 'lps'),
	(652240, 133, '2015-01-15 00:30:55.000000', 'consum', 0.0407, 'lps'),
	(652241, 133, '2015-01-15 00:30:56.000000', 'consum', 0.0412, 'lps'),
	(652242, 133, '2015-01-15 00:30:57.000000', 'consum', 0.0410, 'lps'),
	(652243, 133, '2015-01-15 00:30:58.000000', 'consum', 0.0388, 'lps'),
	(652244, 133, '2015-01-15 00:30:59.000000', 'consum', 0.0284, 'lps'),
	(652245, 133, '2015-01-15 00:31:00.000000', 'consum', 0.0265, 'lps'),
	(652246, 133, '2015-01-15 00:31:01.000000', 'consum', 0.0263, 'lps'),
	(652247, 133, '2015-01-15 00:31:02.000000', 'consum', 0.0312, 'lps'),
	(652248, 133, '2015-01-15 00:31:03.000000', 'consum', 0.0341, 'lps'),
	(652249, 133, '2015-01-15 00:31:04.000000', 'consum', 0.0346, 'lps'),
	(652250, 133, '2015-01-15 00:31:05.000000', 'consum', 0.0279, 'lps'),
	(652251, 133, '2015-01-15 00:31:06.000000', 'consum', 0.0363, 'lps'),
	(652252, 133, '2015-01-15 00:31:07.000000', 'consum', 0.0337, 'lps'),
	(652253, 133, '2015-01-15 00:31:08.000000', 'consum', 0.0388, 'lps'),
	(652254, 133, '2015-01-15 00:31:09.000000', 'consum', 0.0282, 'lps'),
	(652255, 133, '2015-01-15 00:31:10.000000', 'consum', 0.0256, 'lps'),
	(652256, 133, '2015-01-15 00:31:11.000000', 'consum', 0.0223, 'lps'),
	(652257, 133, '2015-01-15 00:31:12.000000', 'consum', 0.0353, 'lps'),
	(652258, 133, '2015-01-15 00:31:13.000000', 'consum', 0.0238, 'lps'),
	(652259, 133, '2015-01-15 00:31:14.000000', 'consum', 0.0355, 'lps'),
	(652260, 133, '2015-01-15 00:31:15.000000', 'consum', 0.0417, 'lps'),
	(652261, 133, '2015-01-15 00:31:16.000000', 'consum', 0.0378, 'lps'),
	(652262, 133, '2015-01-15 00:31:17.000000', 'consum', 0.0210, 'lps'),
	(652263, 133, '2015-01-15 00:31:18.000000', 'consum', 0.0358, 'lps'),
	(652264, 133, '2015-01-15 00:31:19.000000', 'consum', 0.0302, 'lps'),
	(652265, 133, '2015-01-15 00:31:20.000000', 'consum', 0.0224, 'lps'),
	(652266, 133, '2015-01-15 00:31:21.000000', 'consum', 0.0222, 'lps'),
	(652267, 133, '2015-01-15 00:31:22.000000', 'consum', 0.0230, 'lps'),
	(652268, 133, '2015-01-15 00:31:23.000000', 'consum', 0.0272, 'lps'),
	(652269, 133, '2015-01-15 00:31:24.000000', 'consum', 0.0245, 'lps'),
	(652270, 133, '2015-01-15 00:31:25.000000', 'consum', 0.0417, 'lps'),
	(652271, 133, '2015-01-15 00:31:26.000000', 'consum', 0.0271, 'lps'),
	(652272, 133, '2015-01-15 00:31:27.000000', 'consum', 0.0330, 'lps'),
	(652273, 133, '2015-01-15 00:31:28.000000', 'consum', 0.0408, 'lps'),
	(652274, 133, '2015-01-15 00:31:29.000000', 'consum', 0.0407, 'lps'),
	(652275, 133, '2015-01-15 00:31:30.000000', 'consum', 0.0386, 'lps'),
	(652276, 133, '2015-01-15 00:31:31.000000', 'consum', 0.0280, 'lps'),
	(652277, 133, '2015-01-15 00:31:32.000000', 'consum', 0.0250, 'lps'),
	(652278, 133, '2015-01-15 00:31:33.000000', 'consum', 0.0419, 'lps'),
	(652279, 133, '2015-01-15 00:31:34.000000', 'consum', 0.0268, 'lps'),
	(652280, 133, '2015-01-15 00:31:35.000000', 'consum', 0.0305, 'lps'),
	(652281, 133, '2015-01-15 00:31:36.000000', 'consum', 0.0294, 'lps'),
	(652282, 133, '2015-01-15 00:31:37.000000', 'consum', 0.0348, 'lps'),
	(652283, 133, '2015-01-15 00:31:38.000000', 'consum', 0.0215, 'lps'),
	(652284, 133, '2015-01-15 00:31:39.000000', 'consum', 0.0255, 'lps'),
	(652285, 133, '2015-01-15 00:31:40.000000', 'consum', 0.0421, 'lps'),
	(652286, 133, '2015-01-15 00:31:41.000000', 'consum', 0.0264, 'lps'),
	(652287, 133, '2015-01-15 00:31:42.000000', 'consum', 0.0280, 'lps'),
	(652288, 133, '2015-01-15 00:31:43.000000', 'consum', 0.0397, 'lps'),
	(652289, 133, '2015-01-15 00:31:44.000000', 'consum', 0.0284, 'lps'),
	(652290, 133, '2015-01-15 00:31:45.000000', 'consum', 0.0237, 'lps'),
	(652291, 133, '2015-01-15 00:31:46.000000', 'consum', 0.0340, 'lps'),
	(652292, 133, '2015-01-15 00:31:47.000000', 'consum', 0.0347, 'lps'),
	(652293, 133, '2015-01-15 00:31:48.000000', 'consum', 0.0286, 'lps'),
	(652294, 133, '2015-01-15 00:31:49.000000', 'consum', 0.0398, 'lps'),
	(652295, 133, '2015-01-15 00:31:50.000000', 'consum', 0.0272, 'lps'),
	(652296, 133, '2015-01-15 00:31:51.000000', 'consum', 0.0390, 'lps'),
	(652297, 133, '2015-01-15 00:31:52.000000', 'consum', 0.0271, 'lps'),
	(652298, 133, '2015-01-15 00:31:53.000000', 'consum', 0.0413, 'lps'),
	(652299, 133, '2015-01-15 00:31:54.000000', 'consum', 0.0392, 'lps'),
	(652300, 133, '2015-01-15 00:31:55.000000', 'consum', 0.0293, 'lps'),
	(652301, 133, '2015-01-15 00:31:56.000000', 'consum', 0.0296, 'lps'),
	(652302, 133, '2015-01-15 00:31:57.000000', 'consum', 0.0392, 'lps'),
	(652303, 133, '2015-01-15 00:31:58.000000', 'consum', 0.0426, 'lps'),
	(652304, 133, '2015-01-15 00:31:59.000000', 'consum', 0.0314, 'lps'),
	(652305, 133, '2015-01-15 00:32:00.000000', 'consum', 0.0298, 'lps'),
	(652306, 133, '2015-01-15 00:32:01.000000', 'consum', 0.0339, 'lps'),
	(652307, 133, '2015-01-15 00:32:02.000000', 'consum', 0.0373, 'lps'),
	(652308, 133, '2015-01-15 00:32:03.000000', 'consum', 0.0422, 'lps'),
	(652309, 133, '2015-01-15 00:32:04.000000', 'consum', 0.0348, 'lps'),
	(652310, 133, '2015-01-15 00:32:05.000000', 'consum', 0.0266, 'lps'),
	(652311, 133, '2015-01-15 00:32:06.000000', 'consum', 0.0294, 'lps'),
	(652312, 133, '2015-01-15 00:32:07.000000', 'consum', 0.0245, 'lps'),
	(652313, 133, '2015-01-15 00:32:08.000000', 'consum', 0.0350, 'lps'),
	(652314, 133, '2015-01-15 00:32:09.000000', 'consum', 0.0370, 'lps'),
	(652315, 133, '2015-01-15 00:32:10.000000', 'consum', 0.0373, 'lps'),
	(652316, 133, '2015-01-15 00:32:11.000000', 'consum', 0.0330, 'lps'),
	(652317, 133, '2015-01-15 00:32:12.000000', 'consum', 0.0322, 'lps'),
	(652318, 133, '2015-01-15 00:32:13.000000', 'consum', 0.0409, 'lps'),
	(652319, 133, '2015-01-15 00:32:14.000000', 'consum', 0.0217, 'lps'),
	(652320, 133, '2015-01-15 00:32:15.000000', 'consum', 0.0303, 'lps'),
	(652321, 133, '2015-01-15 00:32:16.000000', 'consum', 0.0218, 'lps'),
	(652322, 133, '2015-01-15 00:32:17.000000', 'consum', 0.0407, 'lps'),
	(652323, 133, '2015-01-15 00:32:18.000000', 'consum', 0.0304, 'lps'),
	(652324, 133, '2015-01-15 00:32:19.000000', 'consum', 0.0306, 'lps'),
	(652325, 133, '2015-01-15 00:32:20.000000', 'consum', 0.0410, 'lps'),
	(652326, 133, '2015-01-15 00:32:21.000000', 'consum', 0.0271, 'lps'),
	(652327, 133, '2015-01-15 00:32:22.000000', 'consum', 0.0349, 'lps'),
	(652328, 133, '2015-01-15 00:32:23.000000', 'consum', 0.0289, 'lps'),
	(652329, 133, '2015-01-15 00:32:24.000000', 'consum', 0.0405, 'lps'),
	(652330, 133, '2015-01-15 00:32:25.000000', 'consum', 0.0298, 'lps'),
	(652331, 133, '2015-01-15 00:32:26.000000', 'consum', 0.0281, 'lps'),
	(652332, 133, '2015-01-15 00:32:27.000000', 'consum', 0.0301, 'lps'),
	(652333, 133, '2015-01-15 00:32:28.000000', 'consum', 0.0236, 'lps'),
	(652334, 133, '2015-01-15 00:32:29.000000', 'consum', 0.0283, 'lps'),
	(652335, 133, '2015-01-15 00:32:30.000000', 'consum', 0.0283, 'lps'),
	(652336, 133, '2015-01-15 00:32:31.000000', 'consum', 0.0357, 'lps'),
	(652337, 133, '2015-01-15 00:32:32.000000', 'consum', 0.0292, 'lps'),
	(652338, 133, '2015-01-15 00:32:33.000000', 'consum', 0.0396, 'lps'),
	(652339, 133, '2015-01-15 00:32:34.000000', 'consum', 0.0245, 'lps'),
	(652340, 133, '2015-01-15 00:32:35.000000', 'consum', 0.0259, 'lps'),
	(652341, 133, '2015-01-15 00:32:36.000000', 'consum', 0.0354, 'lps'),
	(652342, 133, '2015-01-15 00:32:37.000000', 'consum', 0.0346, 'lps'),
	(652343, 133, '2015-01-15 00:32:38.000000', 'consum', 0.0244, 'lps'),
	(652344, 133, '2015-01-15 00:32:39.000000', 'consum', 0.0405, 'lps'),
	(652345, 133, '2015-01-15 00:32:40.000000', 'consum', 0.0217, 'lps'),
	(652346, 133, '2015-01-15 00:32:41.000000', 'consum', 0.0312, 'lps'),
	(652347, 133, '2015-01-15 00:32:42.000000', 'consum', 0.0264, 'lps'),
	(652348, 133, '2015-01-15 00:32:43.000000', 'consum', 0.0393, 'lps'),
	(652349, 133, '2015-01-15 00:32:44.000000', 'consum', 0.0312, 'lps'),
	(652350, 133, '2015-01-15 00:32:45.000000', 'consum', 0.0388, 'lps'),
	(652351, 133, '2015-01-15 00:32:46.000000', 'consum', 0.0361, 'lps'),
	(652352, 133, '2015-01-15 00:32:47.000000', 'consum', 0.0214, 'lps'),
	(652353, 133, '2015-01-15 00:32:48.000000', 'consum', 0.0212, 'lps'),
	(652354, 133, '2015-01-15 00:32:49.000000', 'consum', 0.0425, 'lps'),
	(652355, 133, '2015-01-15 00:32:50.000000', 'consum', 0.0413, 'lps'),
	(652356, 133, '2015-01-15 00:32:51.000000', 'consum', 0.0363, 'lps'),
	(652357, 133, '2015-01-15 00:32:52.000000', 'consum', 0.0367, 'lps'),
	(652358, 133, '2015-01-15 00:32:53.000000', 'consum', 0.0321, 'lps'),
	(652359, 133, '2015-01-15 00:32:54.000000', 'consum', 0.0293, 'lps'),
	(652360, 133, '2015-01-15 00:32:55.000000', 'consum', 0.0294, 'lps'),
	(652361, 133, '2015-01-15 00:32:56.000000', 'consum', 0.0382, 'lps'),
	(652362, 133, '2015-01-15 00:32:57.000000', 'consum', 0.0383, 'lps'),
	(652363, 133, '2015-01-15 00:32:58.000000', 'consum', 0.0345, 'lps'),
	(652364, 133, '2015-01-15 00:32:59.000000', 'consum', 0.0365, 'lps'),
	(652365, 133, '2015-01-15 00:33:00.000000', 'consum', 0.0362, 'lps'),
	(652366, 133, '2015-01-15 00:33:01.000000', 'consum', 0.0291, 'lps'),
	(652367, 133, '2015-01-15 00:33:02.000000', 'consum', 0.0375, 'lps'),
	(652368, 133, '2015-01-15 00:33:03.000000', 'consum', 0.0361, 'lps'),
	(652369, 133, '2015-01-15 00:33:04.000000', 'consum', 0.0252, 'lps'),
	(652370, 133, '2015-01-15 00:33:05.000000', 'consum', 0.0401, 'lps'),
	(652371, 133, '2015-01-15 00:33:06.000000', 'consum', 0.0387, 'lps'),
	(652372, 133, '2015-01-15 00:33:07.000000', 'consum', 0.0308, 'lps'),
	(652373, 133, '2015-01-15 00:33:08.000000', 'consum', 0.0384, 'lps'),
	(652374, 133, '2015-01-15 00:33:09.000000', 'consum', 0.0354, 'lps'),
	(652375, 133, '2015-01-15 00:33:10.000000', 'consum', 0.0410, 'lps'),
	(652376, 133, '2015-01-15 00:33:11.000000', 'consum', 0.0342, 'lps'),
	(652377, 133, '2015-01-15 00:33:12.000000', 'consum', 0.0271, 'lps'),
	(652378, 133, '2015-01-15 00:33:13.000000', 'consum', 0.0338, 'lps'),
	(652379, 133, '2015-01-15 00:33:14.000000', 'consum', 0.0235, 'lps'),
	(652380, 133, '2015-01-15 00:33:15.000000', 'consum', 0.0382, 'lps'),
	(652381, 133, '2015-01-15 00:33:16.000000', 'consum', 0.0345, 'lps'),
	(652382, 133, '2015-01-15 00:33:17.000000', 'consum', 0.0371, 'lps'),
	(652383, 133, '2015-01-15 00:33:18.000000', 'consum', 0.0394, 'lps'),
	(652384, 133, '2015-01-15 00:33:19.000000', 'consum', 0.0211, 'lps'),
	(652385, 133, '2015-01-15 00:33:20.000000', 'consum', 0.0318, 'lps'),
	(652386, 133, '2015-01-15 00:33:21.000000', 'consum', 0.0311, 'lps'),
	(652387, 133, '2015-01-15 00:33:22.000000', 'consum', 0.0390, 'lps'),
	(652388, 133, '2015-01-15 00:33:23.000000', 'consum', 0.0376, 'lps'),
	(652389, 133, '2015-01-15 00:33:24.000000', 'consum', 0.0285, 'lps'),
	(652390, 133, '2015-01-15 00:33:25.000000', 'consum', 0.0301, 'lps'),
	(652391, 133, '2015-01-15 00:33:26.000000', 'consum', 0.0226, 'lps'),
	(652392, 133, '2015-01-15 00:33:27.000000', 'consum', 0.0235, 'lps'),
	(652393, 133, '2015-01-15 00:33:28.000000', 'consum', 0.0287, 'lps'),
	(652394, 133, '2015-01-15 00:33:29.000000', 'consum', 0.0305, 'lps'),
	(652395, 133, '2015-01-15 00:33:30.000000', 'consum', 0.0237, 'lps'),
	(652396, 133, '2015-01-15 00:33:31.000000', 'consum', 0.0277, 'lps'),
	(652397, 133, '2015-01-15 00:33:32.000000', 'consum', 0.0246, 'lps'),
	(652398, 133, '2015-01-15 00:33:33.000000', 'consum', 0.0405, 'lps'),
	(652399, 133, '2015-01-15 00:33:34.000000', 'consum', 0.0213, 'lps'),
	(652400, 133, '2015-01-15 00:33:35.000000', 'consum', 0.0290, 'lps'),
	(652401, 133, '2015-01-15 00:33:36.000000', 'consum', 0.0386, 'lps'),
	(652402, 133, '2015-01-15 00:33:37.000000', 'consum', 0.0416, 'lps'),
	(652403, 133, '2015-01-15 00:33:38.000000', 'consum', 0.0276, 'lps'),
	(652404, 133, '2015-01-15 00:33:39.000000', 'consum', 0.0360, 'lps'),
	(652405, 133, '2015-01-15 00:33:40.000000', 'consum', 0.0327, 'lps'),
	(652406, 133, '2015-01-15 00:33:41.000000', 'consum', 0.0347, 'lps'),
	(652407, 133, '2015-01-15 00:33:42.000000', 'consum', 0.0327, 'lps'),
	(652408, 133, '2015-01-15 00:33:43.000000', 'consum', 0.0384, 'lps'),
	(652409, 133, '2015-01-15 00:33:44.000000', 'consum', 0.0296, 'lps'),
	(652410, 133, '2015-01-15 00:33:45.000000', 'consum', 0.0337, 'lps'),
	(652411, 133, '2015-01-15 00:33:46.000000', 'consum', 0.0370, 'lps'),
	(652412, 133, '2015-01-15 00:33:47.000000', 'consum', 0.0411, 'lps'),
	(652413, 133, '2015-01-15 00:33:48.000000', 'consum', 0.0300, 'lps'),
	(652414, 133, '2015-01-15 00:33:49.000000', 'consum', 0.0277, 'lps'),
	(652415, 133, '2015-01-15 00:33:50.000000', 'consum', 0.0274, 'lps'),
	(652416, 133, '2015-01-15 00:33:51.000000', 'consum', 0.0329, 'lps'),
	(652417, 133, '2015-01-15 00:33:52.000000', 'consum', 0.0398, 'lps'),
	(652418, 133, '2015-01-15 00:33:53.000000', 'consum', 0.0359, 'lps'),
	(652419, 133, '2015-01-15 00:33:54.000000', 'consum', 0.0392, 'lps'),
	(652420, 133, '2015-01-15 00:33:55.000000', 'consum', 0.0238, 'lps'),
	(652421, 133, '2015-01-15 00:33:56.000000', 'consum', 0.0238, 'lps'),
	(652422, 133, '2015-01-15 00:33:57.000000', 'consum', 0.0266, 'lps'),
	(652423, 133, '2015-01-15 00:33:58.000000', 'consum', 0.0410, 'lps'),
	(652424, 133, '2015-01-15 00:33:59.000000', 'consum', 0.0388, 'lps'),
	(652425, 133, '2015-01-15 00:34:00.000000', 'consum', 0.0284, 'lps'),
	(652426, 133, '2015-01-15 00:34:01.000000', 'consum', 0.0265, 'lps'),
	(652427, 133, '2015-01-15 00:34:02.000000', 'consum', 0.0261, 'lps'),
	(652428, 133, '2015-01-15 00:34:03.000000', 'consum', 0.0301, 'lps'),
	(652429, 133, '2015-01-15 00:34:04.000000', 'consum', 0.0295, 'lps'),
	(652430, 133, '2015-01-15 00:34:05.000000', 'consum', 0.0364, 'lps'),
	(652431, 133, '2015-01-15 00:34:06.000000', 'consum', 0.0293, 'lps'),
	(652432, 133, '2015-01-15 00:34:07.000000', 'consum', 0.0379, 'lps'),
	(652433, 133, '2015-01-15 00:34:08.000000', 'consum', 0.0374, 'lps'),
	(652434, 133, '2015-01-15 00:34:09.000000', 'consum', 0.0307, 'lps'),
	(652435, 133, '2015-01-15 00:34:10.000000', 'consum', 0.0418, 'lps'),
	(652436, 133, '2015-01-15 00:34:11.000000', 'consum', 0.0309, 'lps'),
	(652437, 133, '2015-01-15 00:34:12.000000', 'consum', 0.0300, 'lps'),
	(652438, 133, '2015-01-15 00:34:13.000000', 'consum', 0.0361, 'lps'),
	(652439, 133, '2015-01-15 00:34:14.000000', 'consum', 0.0262, 'lps'),
	(652440, 133, '2015-01-15 00:34:15.000000', 'consum', 0.0237, 'lps'),
	(652441, 133, '2015-01-15 00:34:16.000000', 'consum', 0.0404, 'lps'),
	(652442, 133, '2015-01-15 00:34:17.000000', 'consum', 0.0231, 'lps'),
	(652443, 133, '2015-01-15 00:34:18.000000', 'consum', 0.0384, 'lps'),
	(652444, 133, '2015-01-15 00:34:19.000000', 'consum', 0.0368, 'lps'),
	(652445, 133, '2015-01-15 00:34:20.000000', 'consum', 0.0262, 'lps'),
	(652446, 133, '2015-01-15 00:34:21.000000', 'consum', 0.0214, 'lps'),
	(652447, 133, '2015-01-15 00:34:22.000000', 'consum', 0.0292, 'lps'),
	(652448, 133, '2015-01-15 00:34:23.000000', 'consum', 0.0389, 'lps'),
	(652449, 133, '2015-01-15 00:34:24.000000', 'consum', 0.0425, 'lps'),
	(652450, 133, '2015-01-15 00:34:25.000000', 'consum', 0.0314, 'lps'),
	(652451, 133, '2015-01-15 00:34:26.000000', 'consum', 0.0304, 'lps'),
	(652452, 133, '2015-01-15 00:34:27.000000', 'consum', 0.0370, 'lps'),
	(652453, 133, '2015-01-15 00:34:28.000000', 'consum', 0.0292, 'lps'),
	(652454, 133, '2015-01-15 00:34:29.000000', 'consum', 0.0360, 'lps'),
	(652455, 133, '2015-01-15 00:34:30.000000', 'consum', 0.0281, 'lps'),
	(652456, 133, '2015-01-15 00:34:31.000000', 'consum', 0.0333, 'lps'),
	(652457, 133, '2015-01-15 00:34:32.000000', 'consum', 0.0394, 'lps'),
	(652458, 133, '2015-01-15 00:34:33.000000', 'consum', 0.0330, 'lps'),
	(652459, 133, '2015-01-15 00:34:34.000000', 'consum', 0.0255, 'lps'),
	(652460, 133, '2015-01-15 00:34:35.000000', 'consum', 0.0294, 'lps'),
	(652461, 133, '2015-01-15 00:34:36.000000', 'consum', 0.0278, 'lps'),
	(652462, 133, '2015-01-15 00:34:37.000000', 'consum', 0.0299, 'lps'),
	(652463, 133, '2015-01-15 00:34:38.000000', 'consum', 0.0234, 'lps'),
	(652464, 133, '2015-01-15 00:34:39.000000', 'consum', 0.0282, 'lps'),
	(652465, 133, '2015-01-15 00:34:40.000000', 'consum', 0.0280, 'lps'),
	(652466, 133, '2015-01-15 00:34:41.000000', 'consum', 0.0347, 'lps'),
	(652467, 133, '2015-01-15 00:34:42.000000', 'consum', 0.0250, 'lps'),
	(652468, 133, '2015-01-15 00:34:43.000000', 'consum', 0.0215, 'lps'),
	(652469, 133, '2015-01-15 00:34:44.000000', 'consum', 0.0333, 'lps'),
	(652470, 133, '2015-01-15 00:34:45.000000', 'consum', 0.0377, 'lps'),
	(652471, 133, '2015-01-15 00:34:46.000000', 'consum', 0.0242, 'lps'),
	(652472, 133, '2015-01-15 00:34:47.000000', 'consum', 0.0304, 'lps'),
	(652473, 133, '2015-01-15 00:34:48.000000', 'consum', 0.0368, 'lps'),
	(652474, 133, '2015-01-15 00:34:49.000000', 'consum', 0.0285, 'lps'),
	(652475, 133, '2015-01-15 00:34:50.000000', 'consum', 0.0329, 'lps'),
	(652476, 133, '2015-01-15 00:34:51.000000', 'consum', 0.0364, 'lps'),
	(652477, 133, '2015-01-15 00:34:52.000000', 'consum', 0.0406, 'lps'),
	(652478, 133, '2015-01-15 00:34:53.000000', 'consum', 0.0294, 'lps'),
	(652479, 133, '2015-01-15 00:34:54.000000', 'consum', 0.0259, 'lps'),
	(652480, 133, '2015-01-15 00:34:55.000000', 'consum', 0.0422, 'lps'),
	(652481, 133, '2015-01-15 00:34:56.000000', 'consum', 0.0254, 'lps'),
	(652482, 133, '2015-01-15 00:34:57.000000', 'consum', 0.0228, 'lps'),
	(652483, 133, '2015-01-15 00:34:58.000000', 'consum', 0.0388, 'lps'),
	(652484, 133, '2015-01-15 00:34:59.000000', 'consum', 0.0393, 'lps'),
	(652485, 133, '2015-01-15 00:35:00.000000', 'consum', 0.0376, 'lps'),
	(652486, 133, '2015-01-15 00:35:01.000000', 'consum', 0.0276, 'lps'),
	(652487, 133, '2015-01-15 00:35:02.000000', 'consum', 0.0257, 'lps'),
	(652488, 133, '2015-01-15 00:35:03.000000', 'consum', 0.0249, 'lps'),
	(652489, 133, '2015-01-15 00:35:04.000000', 'consum', 0.0263, 'lps'),
	(652490, 133, '2015-01-15 00:35:05.000000', 'consum', 0.0358, 'lps'),
	(652491, 133, '2015-01-15 00:35:06.000000', 'consum', 0.0360, 'lps'),
	(652492, 133, '2015-01-15 00:35:07.000000', 'consum', 0.0300, 'lps'),
	(652493, 133, '2015-01-15 00:35:08.000000', 'consum', 0.0211, 'lps'),
	(652494, 133, '2015-01-15 00:35:09.000000', 'consum', 0.0378, 'lps'),
	(652495, 133, '2015-01-15 00:35:10.000000', 'consum', 0.0397, 'lps'),
	(652496, 133, '2015-01-15 00:35:11.000000', 'consum', 0.0424, 'lps'),
	(652497, 133, '2015-01-15 00:35:12.000000', 'consum', 0.0286, 'lps'),
	(652498, 133, '2015-01-15 00:35:13.000000', 'consum', 0.0384, 'lps'),
	(652499, 133, '2015-01-15 00:35:14.000000', 'consum', 0.0416, 'lps'),
	(652500, 133, '2015-01-15 00:35:15.000000', 'consum', 0.0284, 'lps'),
	(652501, 133, '2015-01-15 00:35:16.000000', 'consum', 0.0398, 'lps'),
	(652502, 133, '2015-01-15 00:35:17.000000', 'consum', 0.0276, 'lps'),
	(652503, 133, '2015-01-15 00:35:18.000000', 'consum', 0.0409, 'lps'),
	(652504, 133, '2015-01-15 00:35:19.000000', 'consum', 0.0359, 'lps'),
	(652505, 133, '2015-01-15 00:35:20.000000', 'consum', 0.0358, 'lps'),
	(652506, 133, '2015-01-15 00:35:21.000000', 'consum', 0.0286, 'lps'),
	(652507, 133, '2015-01-15 00:35:22.000000', 'consum', 0.0365, 'lps'),
	(652508, 133, '2015-01-15 00:35:23.000000', 'consum', 0.0325, 'lps'),
	(652509, 133, '2015-01-15 00:35:24.000000', 'consum', 0.0318, 'lps'),
	(652510, 133, '2015-01-15 00:35:25.000000', 'consum', 0.0405, 'lps'),
	(652511, 133, '2015-01-15 00:35:26.000000', 'consum', 0.0212, 'lps'),
	(652512, 133, '2015-01-15 00:35:27.000000', 'consum', 0.0288, 'lps'),
	(652513, 133, '2015-01-15 00:35:28.000000', 'consum', 0.0374, 'lps'),
	(652514, 133, '2015-01-15 00:35:29.000000', 'consum', 0.0366, 'lps'),
	(652515, 133, '2015-01-15 00:35:30.000000', 'consum', 0.0278, 'lps'),
	(652516, 133, '2015-01-15 00:35:31.000000', 'consum', 0.0302, 'lps'),
	(652517, 133, '2015-01-15 00:35:32.000000', 'consum', 0.0250, 'lps'),
	(652518, 133, '2015-01-15 00:35:33.000000', 'consum', 0.0349, 'lps'),
	(652519, 133, '2015-01-15 00:35:34.000000', 'consum', 0.0353, 'lps'),
	(652520, 133, '2015-01-15 00:35:35.000000', 'consum', 0.0292, 'lps'),
	(652521, 133, '2015-01-15 00:35:36.000000', 'consum', 0.0408, 'lps'),
	(652522, 133, '2015-01-15 00:35:37.000000', 'consum', 0.0305, 'lps'),
	(652523, 133, '2015-01-15 00:35:38.000000', 'consum', 0.0307, 'lps'),
	(652524, 133, '2015-01-15 00:35:39.000000', 'consum', 0.0411, 'lps'),
	(652525, 133, '2015-01-15 00:35:40.000000', 'consum', 0.0275, 'lps'),
	(652526, 133, '2015-01-15 00:35:41.000000', 'consum', 0.0365, 'lps'),
	(652527, 133, '2015-01-15 00:35:42.000000', 'consum', 0.0356, 'lps'),
	(652528, 133, '2015-01-15 00:35:43.000000', 'consum', 0.0261, 'lps'),
	(652529, 133, '2015-01-15 00:35:44.000000', 'consum', 0.0243, 'lps'),
	(652530, 133, '2015-01-15 00:35:45.000000', 'consum', 0.0221, 'lps'),
	(652531, 133, '2015-01-15 00:35:46.000000', 'consum', 0.0386, 'lps'),
	(652532, 133, '2015-01-15 00:35:47.000000', 'consum', 0.0403, 'lps'),
	(652533, 133, '2015-01-15 00:35:48.000000', 'consum', 0.0217, 'lps'),
	(652534, 133, '2015-01-15 00:35:49.000000', 'consum', 0.0318, 'lps'),
	(652535, 133, '2015-01-15 00:35:50.000000', 'consum', 0.0294, 'lps'),
	(652536, 133, '2015-01-15 00:35:51.000000', 'consum', 0.0307, 'lps'),
	(652537, 133, '2015-01-15 00:35:52.000000', 'consum', 0.0227, 'lps'),
	(652538, 133, '2015-01-15 00:35:53.000000', 'consum', 0.0222, 'lps'),
	(652539, 133, '2015-01-15 00:35:54.000000', 'consum', 0.0220, 'lps'),
	(652540, 133, '2015-01-15 00:35:55.000000', 'consum', 0.0225, 'lps'),
	(652541, 133, '2015-01-15 00:35:56.000000', 'consum', 0.0253, 'lps'),
	(652542, 133, '2015-01-15 00:35:57.000000', 'consum', 0.0383, 'lps'),
	(652543, 133, '2015-01-15 00:35:58.000000', 'consum', 0.0294, 'lps'),
	(652544, 133, '2015-01-15 00:35:59.000000', 'consum', 0.0330, 'lps'),
	(652545, 133, '2015-01-15 00:36:00.000000', 'consum', 0.0340, 'lps'),
	(652546, 133, '2015-01-15 00:36:01.000000', 'consum', 0.0284, 'lps'),
	(652547, 133, '2015-01-15 00:36:02.000000', 'consum', 0.0406, 'lps'),
	(652548, 133, '2015-01-15 00:36:03.000000', 'consum', 0.0320, 'lps'),
	(652549, 133, '2015-01-15 00:36:04.000000', 'consum', 0.0386, 'lps'),
	(652550, 133, '2015-01-15 00:36:05.000000', 'consum', 0.0330, 'lps'),
	(652551, 133, '2015-01-15 00:36:06.000000', 'consum', 0.0280, 'lps'),
	(652552, 133, '2015-01-15 00:36:07.000000', 'consum', 0.0418, 'lps'),
	(652553, 133, '2015-01-15 00:36:08.000000', 'consum', 0.0388, 'lps'),
	(652554, 133, '2015-01-15 00:36:09.000000', 'consum', 0.0262, 'lps'),
	(652555, 133, '2015-01-15 00:36:10.000000', 'consum', 0.0370, 'lps'),
	(652556, 133, '2015-01-15 00:36:11.000000', 'consum', 0.0419, 'lps'),
	(652557, 133, '2015-01-15 00:36:12.000000', 'consum', 0.0343, 'lps'),
	(652558, 133, '2015-01-15 00:36:13.000000', 'consum', 0.0248, 'lps'),
	(652559, 133, '2015-01-15 00:36:14.000000', 'consum', 0.0218, 'lps'),
	(652560, 133, '2015-01-15 00:36:15.000000', 'consum', 0.0355, 'lps'),
	(652561, 133, '2015-01-15 00:36:16.000000', 'consum', 0.0259, 'lps'),
	(652562, 133, '2015-01-15 00:36:17.000000', 'consum', 0.0237, 'lps'),
	(652563, 133, '2015-01-15 00:36:18.000000', 'consum', 0.0417, 'lps'),
	(652564, 133, '2015-01-15 00:36:19.000000', 'consum', 0.0294, 'lps'),
	(652565, 133, '2015-01-15 00:36:20.000000', 'consum', 0.0227, 'lps'),
	(652566, 133, '2015-01-15 00:36:21.000000', 'consum', 0.0263, 'lps'),
	(652567, 133, '2015-01-15 00:36:22.000000', 'consum', 0.0424, 'lps'),
	(652568, 133, '2015-01-15 00:36:23.000000', 'consum', 0.0251, 'lps'),
	(652569, 133, '2015-01-15 00:36:24.000000', 'consum', 0.0425, 'lps'),
	(652570, 133, '2015-01-15 00:36:25.000000', 'consum', 0.0295, 'lps'),
	(652571, 133, '2015-01-15 00:36:26.000000', 'consum', 0.0425, 'lps'),
	(652572, 133, '2015-01-15 00:36:27.000000', 'consum', 0.0379, 'lps'),
	(652573, 133, '2015-01-15 00:36:28.000000', 'consum', 0.0409, 'lps'),
	(652574, 133, '2015-01-15 00:36:29.000000', 'consum', 0.0267, 'lps'),
	(652575, 133, '2015-01-15 00:36:30.000000', 'consum', 0.0329, 'lps'),
	(652576, 133, '2015-01-15 00:36:31.000000', 'consum', 0.0421, 'lps'),
	(652577, 133, '2015-01-15 00:36:32.000000', 'consum', 0.0257, 'lps'),
	(652578, 133, '2015-01-15 00:36:33.000000', 'consum', 0.0246, 'lps'),
	(652579, 133, '2015-01-15 00:36:34.000000', 'consum', 0.0251, 'lps'),
	(652580, 133, '2015-01-15 00:36:35.000000', 'consum', 0.0306, 'lps'),
	(652581, 133, '2015-01-15 00:36:36.000000', 'consum', 0.0352, 'lps'),
	(652582, 133, '2015-01-15 00:36:37.000000', 'consum', 0.0417, 'lps'),
	(652583, 133, '2015-01-15 00:36:38.000000', 'consum', 0.0382, 'lps'),
	(652584, 133, '2015-01-15 00:36:39.000000', 'consum', 0.0234, 'lps'),
	(652585, 133, '2015-01-15 00:36:40.000000', 'consum', 0.0247, 'lps'),
	(652586, 133, '2015-01-15 00:36:41.000000', 'consum', 0.0324, 'lps'),
	(652587, 133, '2015-01-15 00:36:42.000000', 'consum', 0.0235, 'lps'),
	(652588, 133, '2015-01-15 00:36:43.000000', 'consum', 0.0210, 'lps'),
	(652589, 133, '2015-01-15 00:36:44.000000', 'consum', 0.0353, 'lps'),
	(652590, 133, '2015-01-15 00:36:45.000000', 'consum', 0.0274, 'lps'),
	(652591, 133, '2015-01-15 00:36:46.000000', 'consum', 0.0320, 'lps'),
	(652592, 133, '2015-01-15 00:36:47.000000', 'consum', 0.0349, 'lps'),
	(652593, 133, '2015-01-15 00:36:48.000000', 'consum', 0.0359, 'lps'),
	(652594, 133, '2015-01-15 00:36:49.000000', 'consum', 0.0324, 'lps'),
	(652595, 133, '2015-01-15 00:36:50.000000', 'consum', 0.0331, 'lps'),
	(652596, 133, '2015-01-15 00:36:51.000000', 'consum', 0.0257, 'lps'),
	(652597, 133, '2015-01-15 00:36:52.000000', 'consum', 0.0300, 'lps'),
	(652598, 133, '2015-01-15 00:36:53.000000', 'consum', 0.0302, 'lps'),
	(652599, 133, '2015-01-15 00:36:54.000000', 'consum', 0.0402, 'lps'),
	(652600, 133, '2015-01-15 00:36:55.000000', 'consum', 0.0241, 'lps'),
	(652601, 133, '2015-01-15 00:36:56.000000', 'consum', 0.0223, 'lps'),
	(652602, 133, '2015-01-15 00:36:57.000000', 'consum', 0.0402, 'lps'),
	(652603, 133, '2015-01-15 00:36:58.000000', 'consum', 0.0263, 'lps'),
	(652604, 133, '2015-01-15 00:36:59.000000', 'consum', 0.0335, 'lps'),
	(652605, 133, '2015-01-15 00:37:00.000000', 'consum', 0.0239, 'lps'),
	(652606, 133, '2015-01-15 00:37:01.000000', 'consum', 0.0417, 'lps'),
	(652607, 133, '2015-01-15 00:37:02.000000', 'consum', 0.0289, 'lps'),
	(652608, 133, '2015-01-15 00:37:03.000000', 'consum', 0.0420, 'lps'),
	(652609, 133, '2015-01-15 00:37:04.000000', 'consum', 0.0372, 'lps'),
	(652610, 133, '2015-01-15 00:37:05.000000', 'consum', 0.0391, 'lps'),
	(652611, 133, '2015-01-15 00:37:06.000000', 'consum', 0.0410, 'lps'),
	(652612, 133, '2015-01-15 00:37:07.000000', 'consum', 0.0237, 'lps'),
	(652613, 133, '2015-01-15 00:37:08.000000', 'consum', 0.0395, 'lps'),
	(652614, 133, '2015-01-15 00:37:09.000000', 'consum', 0.0403, 'lps'),
	(652615, 133, '2015-01-15 00:37:10.000000', 'consum', 0.0404, 'lps'),
	(652616, 133, '2015-01-15 00:37:11.000000', 'consum', 0.0385, 'lps'),
	(652617, 133, '2015-01-15 00:37:12.000000', 'consum', 0.0288, 'lps'),
	(652618, 133, '2015-01-15 00:37:13.000000', 'consum', 0.0290, 'lps'),
	(652619, 133, '2015-01-15 00:37:14.000000', 'consum', 0.0378, 'lps'),
	(652620, 133, '2015-01-15 00:37:15.000000', 'consum', 0.0374, 'lps'),
	(652621, 133, '2015-01-15 00:37:16.000000', 'consum', 0.0312, 'lps'),
	(652622, 133, '2015-01-15 00:37:17.000000', 'consum', 0.0226, 'lps'),
	(652623, 133, '2015-01-15 00:37:18.000000', 'consum', 0.0419, 'lps'),
	(652624, 133, '2015-01-15 00:37:19.000000', 'consum', 0.0338, 'lps'),
	(652625, 133, '2015-01-15 00:37:20.000000', 'consum', 0.0225, 'lps'),
	(652626, 133, '2015-01-15 00:37:21.000000', 'consum', 0.0335, 'lps'),
	(652627, 133, '2015-01-15 00:37:22.000000', 'consum', 0.0358, 'lps'),
	(652628, 133, '2015-01-15 00:37:23.000000', 'consum', 0.0359, 'lps'),
	(652629, 133, '2015-01-15 00:37:24.000000', 'consum', 0.0292, 'lps'),
	(652630, 133, '2015-01-15 00:37:25.000000', 'consum', 0.0392, 'lps'),
	(652631, 133, '2015-01-15 00:37:26.000000', 'consum', 0.0223, 'lps'),
	(652632, 133, '2015-01-15 00:37:27.000000', 'consum', 0.0381, 'lps'),
	(652633, 133, '2015-01-15 00:37:28.000000', 'consum', 0.0375, 'lps'),
	(652634, 133, '2015-01-15 00:37:29.000000', 'consum', 0.0306, 'lps'),
	(652635, 133, '2015-01-15 00:37:30.000000', 'consum', 0.0413, 'lps'),
	(652636, 133, '2015-01-15 00:37:31.000000', 'consum', 0.0287, 'lps'),
	(652637, 133, '2015-01-15 00:37:32.000000', 'consum', 0.0419, 'lps'),
	(652638, 133, '2015-01-15 00:37:33.000000', 'consum', 0.0374, 'lps'),
	(652639, 133, '2015-01-15 00:37:34.000000', 'consum', 0.0405, 'lps'),
	(652640, 133, '2015-01-15 00:37:35.000000', 'consum', 0.0259, 'lps'),
	(652641, 133, '2015-01-15 00:37:36.000000', 'consum', 0.0303, 'lps'),
	(652642, 133, '2015-01-15 00:37:37.000000', 'consum', 0.0313, 'lps'),
	(652643, 133, '2015-01-15 00:37:38.000000', 'consum', 0.0228, 'lps'),
	(652644, 133, '2015-01-15 00:37:39.000000', 'consum', 0.0210, 'lps'),
	(652645, 133, '2015-01-15 00:37:40.000000', 'consum', 0.0372, 'lps'),
	(652646, 133, '2015-01-15 00:37:41.000000', 'consum', 0.0372, 'lps'),
	(652647, 133, '2015-01-15 00:37:42.000000', 'consum', 0.0317, 'lps'),
	(652648, 133, '2015-01-15 00:37:43.000000', 'consum', 0.0260, 'lps'),
	(652649, 133, '2015-01-15 00:37:44.000000', 'consum', 0.0356, 'lps'),
	(652650, 133, '2015-01-15 00:37:45.000000', 'consum', 0.0358, 'lps'),
	(652651, 133, '2015-01-15 00:37:46.000000', 'consum', 0.0293, 'lps'),
	(652652, 133, '2015-01-15 00:37:47.000000', 'consum', 0.0401, 'lps'),
	(652653, 133, '2015-01-15 00:37:48.000000', 'consum', 0.0265, 'lps'),
	(652654, 133, '2015-01-15 00:37:49.000000', 'consum', 0.0348, 'lps'),
	(652655, 133, '2015-01-15 00:37:50.000000', 'consum', 0.0301, 'lps'),
	(652656, 133, '2015-01-15 00:37:51.000000', 'consum', 0.0250, 'lps'),
	(652657, 133, '2015-01-15 00:37:52.000000', 'consum', 0.0355, 'lps'),
	(652658, 133, '2015-01-15 00:37:53.000000', 'consum', 0.0380, 'lps'),
	(652659, 133, '2015-01-15 00:37:54.000000', 'consum', 0.0408, 'lps'),
	(652660, 133, '2015-01-15 00:37:55.000000', 'consum', 0.0259, 'lps'),
	(652661, 133, '2015-01-15 00:37:56.000000', 'consum', 0.0296, 'lps'),
	(652662, 133, '2015-01-15 00:37:57.000000', 'consum', 0.0277, 'lps'),
	(652663, 133, '2015-01-15 00:37:58.000000', 'consum', 0.0285, 'lps'),
	(652664, 133, '2015-01-15 00:37:59.000000', 'consum', 0.0385, 'lps'),
	(652665, 133, '2015-01-15 00:38:00.000000', 'consum', 0.0211, 'lps'),
	(652666, 133, '2015-01-15 00:38:01.000000', 'consum', 0.0342, 'lps'),
	(652667, 133, '2015-01-15 00:38:02.000000', 'consum', 0.0215, 'lps'),
	(652668, 133, '2015-01-15 00:38:03.000000', 'consum', 0.0273, 'lps'),
	(652669, 133, '2015-01-15 00:38:04.000000', 'consum', 0.0293, 'lps'),
	(652670, 133, '2015-01-15 00:38:05.000000', 'consum', 0.0222, 'lps'),
	(652671, 133, '2015-01-15 00:38:06.000000', 'consum', 0.0239, 'lps'),
	(652672, 133, '2015-01-15 00:38:07.000000', 'consum', 0.0317, 'lps'),
	(652673, 133, '2015-01-15 00:38:08.000000', 'consum', 0.0225, 'lps'),
	(652674, 133, '2015-01-15 00:38:09.000000', 'consum', 0.0400, 'lps'),
	(652675, 133, '2015-01-15 00:38:10.000000', 'consum', 0.0245, 'lps'),
	(652676, 133, '2015-01-15 00:38:11.000000', 'consum', 0.0251, 'lps'),
	(652677, 133, '2015-01-15 00:38:12.000000', 'consum', 0.0311, 'lps'),
	(652678, 133, '2015-01-15 00:38:13.000000', 'consum', 0.0376, 'lps'),
	(652679, 133, '2015-01-15 00:38:14.000000', 'consum', 0.0303, 'lps'),
	(652680, 133, '2015-01-15 00:38:15.000000', 'consum', 0.0395, 'lps'),
	(652681, 133, '2015-01-15 00:38:16.000000', 'consum', 0.0420, 'lps'),
	(652682, 133, '2015-01-15 00:38:17.000000', 'consum', 0.0274, 'lps'),
	(652683, 133, '2015-01-15 00:38:18.000000', 'consum', 0.0334, 'lps'),
	(652684, 133, '2015-01-15 00:38:19.000000', 'consum', 0.0422, 'lps'),
	(652685, 133, '2015-01-15 00:38:20.000000', 'consum', 0.0248, 'lps'),
	(652686, 133, '2015-01-15 00:38:21.000000', 'consum', 0.0415, 'lps'),
	(652687, 133, '2015-01-15 00:38:22.000000', 'consum', 0.0255, 'lps'),
	(652688, 133, '2015-01-15 00:38:23.000000', 'consum', 0.0252, 'lps'),
	(652689, 133, '2015-01-15 00:38:24.000000', 'consum', 0.0288, 'lps'),
	(652690, 133, '2015-01-15 00:38:25.000000', 'consum', 0.0256, 'lps'),
	(652691, 133, '2015-01-15 00:38:26.000000', 'consum', 0.0425, 'lps'),
	(652692, 133, '2015-01-15 00:38:27.000000', 'consum', 0.0278, 'lps'),
	(652693, 133, '2015-01-15 00:38:28.000000', 'consum', 0.0339, 'lps'),
	(652694, 133, '2015-01-15 00:38:29.000000', 'consum', 0.0216, 'lps'),
	(652695, 133, '2015-01-15 00:38:30.000000', 'consum', 0.0289, 'lps'),
	(652696, 133, '2015-01-15 00:38:31.000000', 'consum', 0.0371, 'lps'),
	(652697, 133, '2015-01-15 00:38:32.000000', 'consum', 0.0346, 'lps'),
	(652698, 133, '2015-01-15 00:38:33.000000', 'consum', 0.0405, 'lps'),
	(652699, 133, '2015-01-15 00:38:34.000000', 'consum', 0.0344, 'lps'),
	(652700, 133, '2015-01-15 00:38:35.000000', 'consum', 0.0296, 'lps'),
	(652701, 133, '2015-01-15 00:38:36.000000', 'consum', 0.0240, 'lps'),
	(652702, 133, '2015-01-15 00:38:37.000000', 'consum', 0.0316, 'lps'),
	(652703, 133, '2015-01-15 00:38:38.000000', 'consum', 0.0219, 'lps'),
	(652704, 133, '2015-01-15 00:38:39.000000', 'consum', 0.0371, 'lps'),
	(652705, 133, '2015-01-15 00:38:40.000000', 'consum', 0.0338, 'lps'),
	(652706, 133, '2015-01-15 00:38:41.000000', 'consum', 0.0368, 'lps'),
	(652707, 133, '2015-01-15 00:38:42.000000', 'consum', 0.0397, 'lps'),
	(652708, 133, '2015-01-15 00:38:43.000000', 'consum', 0.0238, 'lps'),
	(652709, 133, '2015-01-15 00:38:44.000000', 'consum', 0.0226, 'lps'),
	(652710, 133, '2015-01-15 00:38:45.000000', 'consum', 0.0422, 'lps'),
	(652711, 133, '2015-01-15 00:38:46.000000', 'consum', 0.0355, 'lps'),
	(652712, 133, '2015-01-15 00:38:47.000000', 'consum', 0.0299, 'lps'),
	(652713, 133, '2015-01-15 00:38:48.000000', 'consum', 0.0222, 'lps'),
	(652714, 133, '2015-01-15 00:38:49.000000', 'consum', 0.0218, 'lps'),
	(652715, 133, '2015-01-15 00:38:50.000000', 'consum', 0.0217, 'lps'),
	(652716, 133, '2015-01-15 00:38:51.000000', 'consum', 0.0221, 'lps'),
	(652717, 133, '2015-01-15 00:38:52.000000', 'consum', 0.0246, 'lps'),
	(652718, 133, '2015-01-15 00:38:53.000000', 'consum', 0.0356, 'lps'),
	(652719, 133, '2015-01-15 00:38:54.000000', 'consum', 0.0398, 'lps'),
	(652720, 133, '2015-01-15 00:38:55.000000', 'consum', 0.0279, 'lps'),
	(652721, 133, '2015-01-15 00:38:56.000000', 'consum', 0.0210, 'lps'),
	(652722, 133, '2015-01-15 00:38:57.000000', 'consum', 0.0220, 'lps'),
	(652723, 133, '2015-01-15 00:38:58.000000', 'consum', 0.0261, 'lps'),
	(652724, 133, '2015-01-15 00:38:59.000000', 'consum', 0.0220, 'lps'),
	(652725, 133, '2015-01-15 00:39:00.000000', 'consum', 0.0322, 'lps'),
	(652726, 133, '2015-01-15 00:39:01.000000', 'consum', 0.0308, 'lps'),
	(652727, 133, '2015-01-15 00:39:02.000000', 'consum', 0.0363, 'lps'),
	(652728, 133, '2015-01-15 00:39:03.000000', 'consum', 0.0247, 'lps'),
	(652729, 133, '2015-01-15 00:39:04.000000', 'consum', 0.0372, 'lps'),
	(652730, 133, '2015-01-15 00:39:05.000000', 'consum', 0.0258, 'lps'),
	(652731, 133, '2015-01-15 00:39:06.000000', 'consum', 0.0399, 'lps'),
	(652732, 133, '2015-01-15 00:39:07.000000', 'consum', 0.0359, 'lps'),
	(652733, 133, '2015-01-15 00:39:08.000000', 'consum', 0.0390, 'lps'),
	(652734, 133, '2015-01-15 00:39:09.000000', 'consum', 0.0230, 'lps'),
	(652735, 133, '2015-01-15 00:39:10.000000', 'consum', 0.0421, 'lps'),
	(652736, 133, '2015-01-15 00:39:11.000000', 'consum', 0.0336, 'lps'),
	(652737, 133, '2015-01-15 00:39:12.000000', 'consum', 0.0426, 'lps'),
	(652738, 133, '2015-01-15 00:39:13.000000', 'consum', 0.0262, 'lps'),
	(652739, 133, '2015-01-15 00:39:14.000000', 'consum', 0.0255, 'lps'),
	(652740, 133, '2015-01-15 00:39:15.000000', 'consum', 0.0281, 'lps'),
	(652741, 133, '2015-01-15 00:39:16.000000', 'consum', 0.0214, 'lps'),
	(652742, 133, '2015-01-15 00:39:17.000000', 'consum', 0.0232, 'lps'),
	(652743, 133, '2015-01-15 00:39:18.000000', 'consum', 0.0311, 'lps'),
	(652744, 133, '2015-01-15 00:39:19.000000', 'consum', 0.0215, 'lps'),
	(652745, 133, '2015-01-15 00:39:20.000000', 'consum', 0.0367, 'lps'),
	(652746, 133, '2015-01-15 00:39:21.000000', 'consum', 0.0330, 'lps'),
	(652747, 133, '2015-01-15 00:39:22.000000', 'consum', 0.0337, 'lps'),
	(652748, 133, '2015-01-15 00:39:23.000000', 'consum', 0.0271, 'lps'),
	(652749, 133, '2015-01-15 00:39:24.000000', 'consum', 0.0350, 'lps'),
	(652750, 133, '2015-01-15 00:39:25.000000', 'consum', 0.0293, 'lps'),
	(652751, 133, '2015-01-15 00:39:26.000000', 'consum', 0.0424, 'lps'),
	(652752, 133, '2015-01-15 00:39:27.000000', 'consum', 0.0381, 'lps'),
	(652753, 133, '2015-01-15 00:39:28.000000', 'consum', 0.0421, 'lps'),
	(652754, 133, '2015-01-15 00:39:29.000000', 'consum', 0.0319, 'lps'),
	(652755, 133, '2015-01-15 00:39:30.000000', 'consum', 0.0339, 'lps'),
	(652756, 133, '2015-01-15 00:39:31.000000', 'consum', 0.0314, 'lps'),
	(652757, 133, '2015-01-15 00:39:32.000000', 'consum', 0.0343, 'lps'),
	(652758, 133, '2015-01-15 00:39:33.000000', 'consum', 0.0347, 'lps'),
	(652759, 133, '2015-01-15 00:39:34.000000', 'consum', 0.0278, 'lps'),
	(652760, 133, '2015-01-15 00:39:35.000000', 'consum', 0.0359, 'lps'),
	(652761, 133, '2015-01-15 00:39:36.000000', 'consum', 0.0315, 'lps'),
	(652762, 133, '2015-01-15 00:39:37.000000', 'consum', 0.0289, 'lps'),
	(652763, 133, '2015-01-15 00:39:38.000000', 'consum', 0.0291, 'lps'),
	(652764, 133, '2015-01-15 00:39:39.000000', 'consum', 0.0378, 'lps'),
	(652765, 133, '2015-01-15 00:39:40.000000', 'consum', 0.0373, 'lps'),
	(652766, 133, '2015-01-15 00:39:41.000000', 'consum', 0.0306, 'lps'),
	(652767, 133, '2015-01-15 00:39:42.000000', 'consum', 0.0419, 'lps'),
	(652768, 133, '2015-01-15 00:39:43.000000', 'consum', 0.0316, 'lps'),
	(652769, 133, '2015-01-15 00:39:44.000000', 'consum', 0.0332, 'lps'),
	(652770, 133, '2015-01-15 00:39:45.000000', 'consum', 0.0283, 'lps'),
	(652771, 133, '2015-01-15 00:39:46.000000', 'consum', 0.0212, 'lps'),
	(652772, 133, '2015-01-15 00:39:47.000000', 'consum', 0.0218, 'lps'),
	(652773, 133, '2015-01-15 00:39:48.000000', 'consum', 0.0245, 'lps'),
	(652774, 133, '2015-01-15 00:39:49.000000', 'consum', 0.0363, 'lps'),
	(652775, 133, '2015-01-15 00:39:50.000000', 'consum', 0.0217, 'lps'),
	(652776, 133, '2015-01-15 00:39:51.000000', 'consum', 0.0222, 'lps'),
	(652777, 133, '2015-01-15 00:39:52.000000', 'consum', 0.0251, 'lps'),
	(652778, 133, '2015-01-15 00:39:53.000000', 'consum', 0.0378, 'lps'),
	(652779, 133, '2015-01-15 00:39:54.000000', 'consum', 0.0278, 'lps'),
	(652780, 133, '2015-01-15 00:39:55.000000', 'consum', 0.0264, 'lps'),
	(652781, 133, '2015-01-15 00:39:56.000000', 'consum', 0.0273, 'lps'),
	(652782, 133, '2015-01-15 00:39:57.000000', 'consum', 0.0367, 'lps'),
	(652783, 133, '2015-01-15 00:39:58.000000', 'consum', 0.0370, 'lps'),
	(652784, 133, '2015-01-15 00:39:59.000000', 'consum', 0.0323, 'lps'),
	(652785, 133, '2015-01-15 00:40:00.000000', 'consum', 0.0296, 'lps'),
	(652786, 133, '2015-01-15 00:40:01.000000', 'consum', 0.0303, 'lps'),
	(652787, 133, '2015-01-15 00:40:02.000000', 'consum', 0.0417, 'lps'),
	(652788, 133, '2015-01-15 00:40:03.000000', 'consum', 0.0315, 'lps'),
	(652789, 133, '2015-01-15 00:40:04.000000', 'consum', 0.0331, 'lps'),
	(652790, 133, '2015-01-15 00:40:05.000000', 'consum', 0.0282, 'lps'),
	(652791, 133, '2015-01-15 00:40:06.000000', 'consum', 0.0211, 'lps'),
	(652792, 133, '2015-01-15 00:40:07.000000', 'consum', 0.0215, 'lps'),
	(652793, 133, '2015-01-15 00:40:08.000000', 'consum', 0.0231, 'lps'),
	(652794, 133, '2015-01-15 00:40:09.000000', 'consum', 0.0303, 'lps'),
	(652795, 133, '2015-01-15 00:40:10.000000', 'consum', 0.0394, 'lps'),
	(652796, 133, '2015-01-15 00:40:11.000000', 'consum', 0.0416, 'lps'),
	(652797, 133, '2015-01-15 00:40:12.000000', 'consum', 0.0256, 'lps'),
	(652798, 133, '2015-01-15 00:40:13.000000', 'consum', 0.0257, 'lps'),
	(652799, 133, '2015-01-15 00:40:14.000000', 'consum', 0.0307, 'lps'),
	(652800, 133, '2015-01-15 00:40:15.000000', 'consum', 0.0335, 'lps'),
	(652801, 133, '2015-01-15 00:40:16.000000', 'consum', 0.0331, 'lps'),
	(652802, 133, '2015-01-15 00:40:17.000000', 'consum', 0.0223, 'lps'),
	(652803, 133, '2015-01-15 00:40:18.000000', 'consum', 0.0346, 'lps'),
	(652804, 133, '2015-01-15 00:40:19.000000', 'consum', 0.0418, 'lps'),
	(652805, 133, '2015-01-15 00:40:20.000000', 'consum', 0.0408, 'lps'),
	(652806, 133, '2015-01-15 00:40:21.000000', 'consum', 0.0361, 'lps'),
	(652807, 133, '2015-01-15 00:40:22.000000', 'consum', 0.0370, 'lps'),
	(652808, 133, '2015-01-15 00:40:23.000000', 'consum', 0.0340, 'lps'),
	(652809, 133, '2015-01-15 00:40:24.000000', 'consum', 0.0381, 'lps'),
	(652810, 133, '2015-01-15 00:40:25.000000', 'consum', 0.0241, 'lps'),
	(652811, 133, '2015-01-15 00:40:26.000000', 'consum', 0.0288, 'lps'),
	(652812, 133, '2015-01-15 00:40:27.000000', 'consum', 0.0292, 'lps'),
	(652813, 133, '2015-01-15 00:40:28.000000', 'consum', 0.0383, 'lps'),
	(652814, 133, '2015-01-15 00:40:29.000000', 'consum', 0.0396, 'lps'),
	(652815, 133, '2015-01-15 00:40:30.000000', 'consum', 0.0407, 'lps'),
	(652816, 133, '2015-01-15 00:40:31.000000', 'consum', 0.0419, 'lps'),
	(652817, 133, '2015-01-15 00:40:32.000000', 'consum', 0.0231, 'lps'),
	(652818, 133, '2015-01-15 00:40:33.000000', 'consum', 0.0338, 'lps'),
	(652819, 133, '2015-01-15 00:40:34.000000', 'consum', 0.0355, 'lps'),
	(652820, 133, '2015-01-15 00:40:35.000000', 'consum', 0.0333, 'lps'),
	(652821, 133, '2015-01-15 00:40:36.000000', 'consum', 0.0390, 'lps'),
	(652822, 133, '2015-01-15 00:40:37.000000', 'consum', 0.0308, 'lps'),
	(652823, 133, '2015-01-15 00:40:38.000000', 'consum', 0.0379, 'lps'),
	(652824, 133, '2015-01-15 00:40:39.000000', 'consum', 0.0326, 'lps'),
	(652825, 133, '2015-01-15 00:40:40.000000', 'consum', 0.0283, 'lps'),
	(652826, 133, '2015-01-15 00:40:41.000000', 'consum', 0.0228, 'lps'),
	(652827, 133, '2015-01-15 00:40:42.000000', 'consum', 0.0299, 'lps'),
	(652828, 133, '2015-01-15 00:40:43.000000', 'consum', 0.0386, 'lps'),
	(652829, 133, '2015-01-15 00:40:44.000000', 'consum', 0.0387, 'lps'),
	(652830, 133, '2015-01-15 00:40:45.000000', 'consum', 0.0352, 'lps'),
	(652831, 133, '2015-01-15 00:40:46.000000', 'consum', 0.0390, 'lps'),
	(652832, 133, '2015-01-15 00:40:47.000000', 'consum', 0.0251, 'lps'),
	(652833, 133, '2015-01-15 00:40:48.000000', 'consum', 0.0308, 'lps'),
	(652834, 133, '2015-01-15 00:40:49.000000', 'consum', 0.0359, 'lps'),
	(652835, 133, '2015-01-15 00:40:50.000000', 'consum', 0.0230, 'lps'),
	(652836, 133, '2015-01-15 00:40:51.000000', 'consum', 0.0296, 'lps'),
	(652837, 133, '2015-01-15 00:40:52.000000', 'consum', 0.0364, 'lps'),
	(652838, 133, '2015-01-15 00:40:53.000000', 'consum', 0.0289, 'lps'),
	(652839, 133, '2015-01-15 00:40:54.000000', 'consum', 0.0360, 'lps'),
	(652840, 133, '2015-01-15 00:40:55.000000', 'consum', 0.0290, 'lps'),
	(652841, 133, '2015-01-15 00:40:56.000000', 'consum', 0.0378, 'lps'),
	(652842, 133, '2015-01-15 00:40:57.000000', 'consum', 0.0377, 'lps'),
	(652843, 133, '2015-01-15 00:40:58.000000', 'consum', 0.0325, 'lps'),
	(652844, 133, '2015-01-15 00:40:59.000000', 'consum', 0.0285, 'lps'),
	(652845, 133, '2015-01-15 00:41:00.000000', 'consum', 0.0238, 'lps'),
	(652846, 133, '2015-01-15 00:41:01.000000', 'consum', 0.0344, 'lps'),
	(652847, 133, '2015-01-15 00:41:02.000000', 'consum', 0.0363, 'lps'),
	(652848, 133, '2015-01-15 00:41:03.000000', 'consum', 0.0355, 'lps'),
	(652849, 133, '2015-01-15 00:41:04.000000', 'consum', 0.0259, 'lps'),
	(652850, 133, '2015-01-15 00:41:05.000000', 'consum', 0.0239, 'lps'),
	(652851, 133, '2015-01-15 00:41:06.000000', 'consum', 0.0426, 'lps'),
	(652852, 133, '2015-01-15 00:41:07.000000', 'consum', 0.0334, 'lps'),
	(652853, 133, '2015-01-15 00:41:08.000000', 'consum', 0.0398, 'lps'),
	(652854, 133, '2015-01-15 00:41:09.000000', 'consum', 0.0348, 'lps'),
	(652855, 133, '2015-01-15 00:41:10.000000', 'consum', 0.0335, 'lps'),
	(652856, 133, '2015-01-15 00:41:11.000000', 'consum', 0.0422, 'lps'),
	(652857, 133, '2015-01-15 00:41:12.000000', 'consum', 0.0245, 'lps'),
	(652858, 133, '2015-01-15 00:41:13.000000', 'consum', 0.0400, 'lps'),
	(652859, 133, '2015-01-15 00:41:14.000000', 'consum', 0.0404, 'lps'),
	(652860, 133, '2015-01-15 00:41:15.000000', 'consum', 0.0392, 'lps'),
	(652861, 133, '2015-01-15 00:41:16.000000', 'consum', 0.0325, 'lps'),
	(652862, 133, '2015-01-15 00:41:17.000000', 'consum', 0.0237, 'lps'),
	(652863, 133, '2015-01-15 00:41:18.000000', 'consum', 0.0219, 'lps'),
	(652864, 133, '2015-01-15 00:41:19.000000', 'consum', 0.0391, 'lps'),
	(652865, 133, '2015-01-15 00:41:20.000000', 'consum', 0.0221, 'lps'),
	(652866, 133, '2015-01-15 00:41:21.000000', 'consum', 0.0373, 'lps'),
	(652867, 133, '2015-01-15 00:41:22.000000', 'consum', 0.0341, 'lps'),
	(652868, 133, '2015-01-15 00:41:23.000000', 'consum', 0.0379, 'lps'),
	(652869, 133, '2015-01-15 00:41:24.000000', 'consum', 0.0225, 'lps'),
	(652870, 133, '2015-01-15 00:41:25.000000', 'consum', 0.0215, 'lps'),
	(652871, 133, '2015-01-15 00:41:26.000000', 'consum', 0.0406, 'lps'),
	(652872, 133, '2015-01-15 00:41:27.000000', 'consum', 0.0310, 'lps'),
	(652873, 133, '2015-01-15 00:41:28.000000', 'consum', 0.0338, 'lps'),
	(652874, 133, '2015-01-15 00:41:29.000000', 'consum', 0.0336, 'lps'),
	(652875, 133, '2015-01-15 00:41:30.000000', 'consum', 0.0236, 'lps'),
	(652876, 133, '2015-01-15 00:41:31.000000', 'consum', 0.0400, 'lps'),
	(652877, 133, '2015-01-15 00:41:32.000000', 'consum', 0.0212, 'lps'),
	(652878, 133, '2015-01-15 00:41:33.000000', 'consum', 0.0302, 'lps'),
	(652879, 133, '2015-01-15 00:41:34.000000', 'consum', 0.0229, 'lps'),
	(652880, 133, '2015-01-15 00:41:35.000000', 'consum', 0.0248, 'lps'),
	(652881, 133, '2015-01-15 00:41:36.000000', 'consum', 0.0344, 'lps'),
	(652882, 133, '2015-01-15 00:41:37.000000', 'consum', 0.0331, 'lps'),
	(652883, 133, '2015-01-15 00:41:38.000000', 'consum', 0.0413, 'lps'),
	(652884, 133, '2015-01-15 00:41:39.000000', 'consum', 0.0212, 'lps'),
	(652885, 133, '2015-01-15 00:41:40.000000', 'consum', 0.0263, 'lps'),
	(652886, 133, '2015-01-15 00:41:41.000000', 'consum', 0.0252, 'lps'),
	(652887, 133, '2015-01-15 00:41:42.000000', 'consum', 0.0263, 'lps'),
	(652888, 133, '2015-01-15 00:41:43.000000', 'consum', 0.0347, 'lps'),
	(652889, 133, '2015-01-15 00:41:44.000000', 'consum', 0.0303, 'lps'),
	(652890, 133, '2015-01-15 00:41:45.000000', 'consum', 0.0266, 'lps'),
	(652891, 133, '2015-01-15 00:41:46.000000', 'consum', 0.0210, 'lps'),
	(652892, 133, '2015-01-15 00:41:47.000000', 'consum', 0.0258, 'lps'),
	(652893, 133, '2015-01-15 00:41:48.000000', 'consum', 0.0237, 'lps'),
	(652894, 133, '2015-01-15 00:41:49.000000', 'consum', 0.0416, 'lps'),
	(652895, 133, '2015-01-15 00:41:50.000000', 'consum', 0.0293, 'lps'),
	(652896, 133, '2015-01-15 00:41:51.000000', 'consum', 0.0224, 'lps'),
	(652897, 133, '2015-01-15 00:41:52.000000', 'consum', 0.0250, 'lps'),
	(652898, 133, '2015-01-15 00:41:53.000000', 'consum', 0.0368, 'lps'),
	(652899, 133, '2015-01-15 00:41:54.000000', 'consum', 0.0230, 'lps'),
	(652900, 133, '2015-01-15 00:41:55.000000', 'consum', 0.0270, 'lps'),
	(652901, 133, '2015-01-15 00:41:56.000000', 'consum', 0.0233, 'lps'),
	(652902, 133, '2015-01-15 00:41:57.000000', 'consum', 0.0362, 'lps'),
	(652903, 133, '2015-01-15 00:41:58.000000', 'consum', 0.0252, 'lps'),
	(652904, 133, '2015-01-15 00:41:59.000000', 'consum', 0.0397, 'lps'),
	(652905, 133, '2015-01-15 00:42:00.000000', 'consum', 0.0369, 'lps'),
	(652906, 133, '2015-01-15 00:42:01.000000', 'consum', 0.0225, 'lps'),
	(652907, 133, '2015-01-15 00:42:02.000000', 'consum', 0.0246, 'lps'),
	(652908, 133, '2015-01-15 00:42:03.000000', 'consum', 0.0346, 'lps'),
	(652909, 133, '2015-01-15 00:42:04.000000', 'consum', 0.0348, 'lps'),
	(652910, 133, '2015-01-15 00:42:05.000000', 'consum', 0.0275, 'lps'),
	(652911, 133, '2015-01-15 00:42:06.000000', 'consum', 0.0338, 'lps'),
	(652912, 133, '2015-01-15 00:42:07.000000', 'consum', 0.0223, 'lps'),
	(652913, 133, '2015-01-15 00:42:08.000000', 'consum', 0.0325, 'lps'),
	(652914, 133, '2015-01-15 00:42:09.000000', 'consum', 0.0311, 'lps'),
	(652915, 133, '2015-01-15 00:42:10.000000', 'consum', 0.0369, 'lps'),
	(652916, 133, '2015-01-15 00:42:11.000000', 'consum', 0.0272, 'lps'),
	(652917, 133, '2015-01-15 00:42:12.000000', 'consum', 0.0257, 'lps'),
	(652918, 133, '2015-01-15 00:42:13.000000', 'consum', 0.0263, 'lps'),
	(652919, 133, '2015-01-15 00:42:14.000000', 'consum', 0.0332, 'lps'),
	(652920, 133, '2015-01-15 00:42:15.000000', 'consum', 0.0230, 'lps'),
	(652921, 133, '2015-01-15 00:42:16.000000', 'consum', 0.0376, 'lps'),
	(652922, 133, '2015-01-15 00:42:17.000000', 'consum', 0.0331, 'lps'),
	(652923, 133, '2015-01-15 00:42:18.000000', 'consum', 0.0315, 'lps'),
	(652924, 133, '2015-01-15 00:42:19.000000', 'consum', 0.0375, 'lps'),
	(652925, 133, '2015-01-15 00:42:20.000000', 'consum', 0.0284, 'lps'),
	(652926, 133, '2015-01-15 00:42:21.000000', 'consum', 0.0303, 'lps'),
	(652927, 133, '2015-01-15 00:42:22.000000', 'consum', 0.0237, 'lps'),
	(652928, 133, '2015-01-15 00:42:23.000000', 'consum', 0.0283, 'lps'),
	(652929, 133, '2015-01-15 00:42:24.000000', 'consum', 0.0278, 'lps'),
	(652930, 133, '2015-01-15 00:42:25.000000', 'consum', 0.0333, 'lps'),
	(652931, 133, '2015-01-15 00:42:26.000000', 'consum', 0.0402, 'lps'),
	(652932, 133, '2015-01-15 00:42:27.000000', 'consum', 0.0369, 'lps'),
	(652933, 133, '2015-01-15 00:42:28.000000', 'consum', 0.0214, 'lps'),
	(652934, 133, '2015-01-15 00:42:29.000000', 'consum', 0.0402, 'lps'),
	(652935, 133, '2015-01-15 00:42:30.000000', 'consum', 0.0292, 'lps'),
	(652936, 133, '2015-01-15 00:42:31.000000', 'consum', 0.0261, 'lps'),
	(652937, 133, '2015-01-15 00:42:32.000000', 'consum', 0.0221, 'lps'),
	(652938, 133, '2015-01-15 00:42:33.000000', 'consum', 0.0329, 'lps'),
	(652939, 133, '2015-01-15 00:42:34.000000', 'consum', 0.0340, 'lps'),
	(652940, 133, '2015-01-15 00:42:35.000000', 'consum', 0.0286, 'lps'),
	(652941, 133, '2015-01-15 00:42:36.000000', 'consum', 0.0419, 'lps'),
	(652942, 133, '2015-01-15 00:42:37.000000', 'consum', 0.0374, 'lps'),
	(652943, 133, '2015-01-15 00:42:38.000000', 'consum', 0.0402, 'lps'),
	(652944, 133, '2015-01-15 00:42:39.000000', 'consum', 0.0247, 'lps'),
	(652945, 133, '2015-01-15 00:42:40.000000', 'consum', 0.0253, 'lps'),
	(652946, 133, '2015-01-15 00:42:41.000000', 'consum', 0.0312, 'lps'),
	(652947, 133, '2015-01-15 00:42:42.000000', 'consum', 0.0377, 'lps'),
	(652948, 133, '2015-01-15 00:42:43.000000', 'consum', 0.0306, 'lps'),
	(652949, 133, '2015-01-15 00:42:44.000000', 'consum', 0.0406, 'lps'),
	(652950, 133, '2015-01-15 00:42:45.000000', 'consum', 0.0253, 'lps'),
	(652951, 133, '2015-01-15 00:42:46.000000', 'consum', 0.0271, 'lps'),
	(652952, 133, '2015-01-15 00:42:47.000000', 'consum', 0.0386, 'lps'),
	(652953, 133, '2015-01-15 00:42:48.000000', 'consum', 0.0257, 'lps'),
	(652954, 133, '2015-01-15 00:42:49.000000', 'consum', 0.0353, 'lps'),
	(652955, 133, '2015-01-15 00:42:50.000000', 'consum', 0.0348, 'lps'),
	(652956, 133, '2015-01-15 00:42:51.000000', 'consum', 0.0256, 'lps'),
	(652957, 133, '2015-01-15 00:42:52.000000', 'consum', 0.0243, 'lps'),
	(652958, 133, '2015-01-15 00:42:53.000000', 'consum', 0.0237, 'lps'),
	(652959, 133, '2015-01-15 00:42:54.000000', 'consum', 0.0248, 'lps'),
	(652960, 133, '2015-01-15 00:42:55.000000', 'consum', 0.0319, 'lps'),
	(652961, 133, '2015-01-15 00:42:56.000000', 'consum', 0.0423, 'lps'),
	(652962, 133, '2015-01-15 00:42:57.000000', 'consum', 0.0300, 'lps'),
	(652963, 133, '2015-01-15 00:42:58.000000', 'consum', 0.0235, 'lps'),
	(652964, 133, '2015-01-15 00:42:59.000000', 'consum', 0.0286, 'lps'),
	(652965, 133, '2015-01-15 00:43:00.000000', 'consum', 0.0295, 'lps'),
	(652966, 133, '2015-01-15 00:43:01.000000', 'consum', 0.0409, 'lps'),
	(652967, 133, '2015-01-15 00:43:02.000000', 'consum', 0.0301, 'lps'),
	(652968, 133, '2015-01-15 00:43:03.000000', 'consum', 0.0286, 'lps'),
	(652969, 133, '2015-01-15 00:43:04.000000', 'consum', 0.0317, 'lps'),
	(652970, 133, '2015-01-15 00:43:05.000000', 'consum', 0.0300, 'lps'),
	(652971, 133, '2015-01-15 00:43:06.000000', 'consum', 0.0342, 'lps'),
	(652972, 133, '2015-01-15 00:43:07.000000', 'consum', 0.0380, 'lps'),
	(652973, 133, '2015-01-15 00:43:08.000000', 'consum', 0.0232, 'lps'),
	(652974, 133, '2015-01-15 00:43:09.000000', 'consum', 0.0244, 'lps'),
	(652975, 133, '2015-01-15 00:43:10.000000', 'consum', 0.0314, 'lps'),
	(652976, 133, '2015-01-15 00:43:11.000000', 'consum', 0.0412, 'lps'),
	(652977, 133, '2015-01-15 00:43:12.000000', 'consum', 0.0258, 'lps'),
	(652978, 133, '2015-01-15 00:43:13.000000', 'consum', 0.0280, 'lps'),
	(652979, 133, '2015-01-15 00:43:14.000000', 'consum', 0.0416, 'lps'),
	(652980, 133, '2015-01-15 00:43:15.000000', 'consum', 0.0380, 'lps'),
	(652981, 133, '2015-01-15 00:43:16.000000', 'consum', 0.0224, 'lps'),
	(652982, 133, '2015-01-15 00:43:17.000000', 'consum', 0.0423, 'lps'),
	(652983, 133, '2015-01-15 00:43:18.000000', 'consum', 0.0364, 'lps'),
	(652984, 133, '2015-01-15 00:43:19.000000', 'consum', 0.0342, 'lps'),
	(652985, 133, '2015-01-15 00:43:20.000000', 'consum', 0.0411, 'lps'),
	(652986, 133, '2015-01-15 00:43:21.000000', 'consum', 0.0382, 'lps'),
	(652987, 133, '2015-01-15 00:43:22.000000', 'consum', 0.0253, 'lps'),
	(652988, 133, '2015-01-15 00:43:23.000000', 'consum', 0.0341, 'lps'),
	(652989, 133, '2015-01-15 00:43:24.000000', 'consum', 0.0305, 'lps'),
	(652990, 133, '2015-01-15 00:43:25.000000', 'consum', 0.0291, 'lps'),
	(652991, 133, '2015-01-15 00:43:26.000000', 'consum', 0.0332, 'lps'),
	(652992, 133, '2015-01-15 00:43:27.000000', 'consum', 0.0359, 'lps'),
	(652993, 133, '2015-01-15 00:43:28.000000', 'consum', 0.0372, 'lps'),
	(652994, 133, '2015-01-15 00:43:29.000000', 'consum', 0.0358, 'lps'),
	(652995, 133, '2015-01-15 00:43:30.000000', 'consum', 0.0246, 'lps'),
	(652996, 133, '2015-01-15 00:43:31.000000', 'consum', 0.0380, 'lps'),
	(652997, 133, '2015-01-15 00:43:32.000000', 'consum', 0.0304, 'lps'),
	(652998, 133, '2015-01-15 00:43:33.000000', 'consum', 0.0384, 'lps'),
	(652999, 133, '2015-01-15 00:43:34.000000', 'consum', 0.0367, 'lps'),
	(653000, 133, '2015-01-15 00:43:35.000000', 'consum', 0.0256, 'lps'),
	(653001, 133, '2015-01-15 00:43:36.000000', 'consum', 0.0403, 'lps'),
	(653002, 133, '2015-01-15 00:43:37.000000', 'consum', 0.0388, 'lps'),
	(653003, 133, '2015-01-15 00:43:38.000000', 'consum', 0.0306, 'lps'),
	(653004, 133, '2015-01-15 00:43:39.000000', 'consum', 0.0370, 'lps'),
	(653005, 133, '2015-01-15 00:43:40.000000', 'consum', 0.0290, 'lps'),
	(653006, 133, '2015-01-15 00:43:41.000000', 'consum', 0.0349, 'lps'),
	(653007, 133, '2015-01-15 00:43:42.000000', 'consum', 0.0231, 'lps'),
	(653008, 133, '2015-01-15 00:43:43.000000', 'consum', 0.0332, 'lps'),
	(653009, 133, '2015-01-15 00:43:44.000000', 'consum', 0.0326, 'lps'),
	(653010, 133, '2015-01-15 00:43:45.000000', 'consum', 0.0421, 'lps'),
	(653011, 133, '2015-01-15 00:43:46.000000', 'consum', 0.0267, 'lps'),
	(653012, 133, '2015-01-15 00:43:47.000000', 'consum', 0.0295, 'lps'),
	(653013, 133, '2015-01-15 00:43:48.000000', 'consum', 0.0250, 'lps'),
	(653014, 133, '2015-01-15 00:43:49.000000', 'consum', 0.0374, 'lps'),
	(653015, 133, '2015-01-15 00:43:50.000000', 'consum', 0.0257, 'lps'),
	(653016, 133, '2015-01-15 00:43:51.000000', 'consum', 0.0388, 'lps'),
	(653017, 133, '2015-01-15 00:43:52.000000', 'consum', 0.0311, 'lps'),
	(653018, 133, '2015-01-15 00:43:53.000000', 'consum', 0.0395, 'lps'),
	(653019, 133, '2015-01-15 00:43:54.000000', 'consum', 0.0400, 'lps'),
	(653020, 133, '2015-01-15 00:43:55.000000', 'consum', 0.0389, 'lps'),
	(653021, 133, '2015-01-15 00:43:56.000000', 'consum', 0.0319, 'lps'),
	(653022, 133, '2015-01-15 00:43:57.000000', 'consum', 0.0219, 'lps'),
	(653023, 133, '2015-01-15 00:43:58.000000', 'consum', 0.0362, 'lps'),
	(653024, 133, '2015-01-15 00:43:59.000000', 'consum', 0.0293, 'lps'),
	(653025, 133, '2015-01-15 00:44:00.000000', 'consum', 0.0386, 'lps'),
	(653026, 133, '2015-01-15 00:44:01.000000', 'consum', 0.0407, 'lps'),
	(653027, 133, '2015-01-15 00:44:02.000000', 'consum', 0.0232, 'lps'),
	(653028, 133, '2015-01-15 00:44:03.000000', 'consum', 0.0381, 'lps'),
	(653029, 133, '2015-01-15 00:44:04.000000', 'consum', 0.0348, 'lps'),
	(653030, 133, '2015-01-15 00:44:05.000000', 'consum', 0.0386, 'lps'),
	(653031, 133, '2015-01-15 00:44:06.000000', 'consum', 0.0246, 'lps'),
	(653032, 133, '2015-01-15 00:44:07.000000', 'consum', 0.0295, 'lps'),
	(653033, 133, '2015-01-15 00:44:08.000000', 'consum', 0.0310, 'lps'),
	(653034, 133, '2015-01-15 00:44:09.000000', 'consum', 0.0238, 'lps'),
	(653035, 133, '2015-01-15 00:44:10.000000', 'consum', 0.0268, 'lps'),
	(653036, 133, '2015-01-15 00:44:11.000000', 'consum', 0.0416, 'lps'),
	(653037, 133, '2015-01-15 00:44:12.000000', 'consum', 0.0417, 'lps'),
	(653038, 133, '2015-01-15 00:44:13.000000', 'consum', 0.0409, 'lps'),
	(653039, 133, '2015-01-15 00:44:14.000000', 'consum', 0.0370, 'lps'),
	(653040, 133, '2015-01-15 00:44:15.000000', 'consum', 0.0411, 'lps'),
	(653041, 133, '2015-01-15 00:44:16.000000', 'consum', 0.0303, 'lps'),
	(653042, 133, '2015-01-15 00:44:17.000000', 'consum', 0.0289, 'lps'),
	(653043, 133, '2015-01-15 00:44:18.000000', 'consum', 0.0328, 'lps'),
	(653044, 133, '2015-01-15 00:44:19.000000', 'consum', 0.0347, 'lps'),
	(653045, 133, '2015-01-15 00:44:20.000000', 'consum', 0.0323, 'lps'),
	(653046, 133, '2015-01-15 00:44:21.000000', 'consum', 0.0363, 'lps'),
	(653047, 133, '2015-01-15 00:44:22.000000', 'consum', 0.0420, 'lps'),
	(653048, 133, '2015-01-15 00:44:23.000000', 'consum', 0.0368, 'lps'),
	(653049, 133, '2015-01-15 00:44:24.000000', 'consum', 0.0371, 'lps'),
	(653050, 133, '2015-01-15 00:44:25.000000', 'consum', 0.0324, 'lps'),
	(653051, 133, '2015-01-15 00:44:26.000000', 'consum', 0.0298, 'lps'),
	(653052, 133, '2015-01-15 00:44:27.000000', 'consum', 0.0309, 'lps'),
	(653053, 133, '2015-01-15 00:44:28.000000', 'consum', 0.0225, 'lps'),
	(653054, 133, '2015-01-15 00:44:29.000000', 'consum', 0.0421, 'lps'),
	(653055, 133, '2015-01-15 00:44:30.000000', 'consum', 0.0352, 'lps'),
	(653056, 133, '2015-01-15 00:44:31.000000', 'consum', 0.0290, 'lps'),
	(653057, 133, '2015-01-15 00:44:32.000000', 'consum', 0.0399, 'lps'),
	(653058, 133, '2015-01-15 00:44:33.000000', 'consum', 0.0265, 'lps'),
	(653059, 133, '2015-01-15 00:44:34.000000', 'consum', 0.0352, 'lps'),
	(653060, 133, '2015-01-15 00:44:35.000000', 'consum', 0.0321, 'lps'),
	(653061, 133, '2015-01-15 00:44:36.000000', 'consum', 0.0341, 'lps'),
	(653062, 133, '2015-01-15 00:44:37.000000', 'consum', 0.0317, 'lps'),
	(653063, 133, '2015-01-15 00:44:38.000000', 'consum', 0.0351, 'lps'),
	(653064, 133, '2015-01-15 00:44:39.000000', 'consum', 0.0379, 'lps'),
	(653065, 133, '2015-01-15 00:44:40.000000', 'consum', 0.0416, 'lps'),
	(653066, 133, '2015-01-15 00:44:41.000000', 'consum', 0.0298, 'lps'),
	(653067, 133, '2015-01-15 00:44:42.000000', 'consum', 0.0250, 'lps'),
	(653068, 133, '2015-01-15 00:44:43.000000', 'consum', 0.0363, 'lps'),
	(653069, 133, '2015-01-15 00:44:44.000000', 'consum', 0.0421, 'lps'),
	(653070, 133, '2015-01-15 00:44:45.000000', 'consum', 0.0374, 'lps'),
	(653071, 133, '2015-01-15 00:44:46.000000', 'consum', 0.0395, 'lps'),
	(653072, 133, '2015-01-15 00:44:47.000000', 'consum', 0.0213, 'lps'),
	(653073, 133, '2015-01-15 00:44:48.000000', 'consum', 0.0319, 'lps'),
	(653074, 133, '2015-01-15 00:44:49.000000', 'consum', 0.0311, 'lps'),
	(653075, 133, '2015-01-15 00:44:50.000000', 'consum', 0.0391, 'lps'),
	(653076, 133, '2015-01-15 00:44:51.000000', 'consum', 0.0377, 'lps'),
	(653077, 133, '2015-01-15 00:44:52.000000', 'consum', 0.0285, 'lps'),
	(653078, 133, '2015-01-15 00:44:53.000000', 'consum', 0.0303, 'lps'),
	(653079, 133, '2015-01-15 00:44:54.000000', 'consum', 0.0234, 'lps'),
	(653080, 133, '2015-01-15 00:44:55.000000', 'consum', 0.0267, 'lps'),
	(653081, 133, '2015-01-15 00:44:56.000000', 'consum', 0.0423, 'lps'),
	(653082, 133, '2015-01-15 00:44:57.000000', 'consum', 0.0238, 'lps'),
	(653083, 133, '2015-01-15 00:44:58.000000', 'consum', 0.0361, 'lps'),
	(653084, 133, '2015-01-15 00:44:59.000000', 'consum', 0.0229, 'lps'),
	(653085, 133, '2015-01-15 00:45:00.000000', 'consum', 0.0290, 'lps'),
	(653086, 133, '2015-01-15 00:45:01.000000', 'consum', 0.0335, 'lps'),
	(653087, 133, '2015-01-15 00:45:02.000000', 'consum', 0.0380, 'lps'),
	(653088, 133, '2015-01-15 00:45:03.000000', 'consum', 0.0249, 'lps'),
	(653089, 133, '2015-01-15 00:45:04.000000', 'consum', 0.0330, 'lps'),
	(653090, 133, '2015-01-15 00:45:05.000000', 'consum', 0.0259, 'lps'),
	(653091, 133, '2015-01-15 00:45:06.000000', 'consum', 0.0315, 'lps'),
	(653092, 133, '2015-01-15 00:45:07.000000', 'consum', 0.0371, 'lps'),
	(653093, 133, '2015-01-15 00:45:08.000000', 'consum', 0.0266, 'lps'),
	(653094, 133, '2015-01-15 00:45:09.000000', 'consum', 0.0226, 'lps'),
	(653095, 133, '2015-01-15 00:45:10.000000', 'consum', 0.0340, 'lps'),
	(653096, 133, '2015-01-15 00:45:11.000000', 'consum', 0.0375, 'lps'),
	(653097, 133, '2015-01-15 00:45:12.000000', 'consum', 0.0215, 'lps'),
	(653098, 133, '2015-01-15 00:45:13.000000', 'consum', 0.0389, 'lps'),
	(653099, 133, '2015-01-15 00:45:14.000000', 'consum', 0.0225, 'lps'),
	(653100, 133, '2015-01-15 00:45:15.000000', 'consum', 0.0400, 'lps'),
	(653101, 133, '2015-01-15 00:45:16.000000', 'consum', 0.0244, 'lps'),
	(653102, 133, '2015-01-15 00:45:17.000000', 'consum', 0.0247, 'lps'),
	(653103, 133, '2015-01-15 00:45:18.000000', 'consum', 0.0295, 'lps'),
	(653104, 133, '2015-01-15 00:45:19.000000', 'consum', 0.0306, 'lps'),
	(653105, 133, '2015-01-15 00:45:20.000000', 'consum', 0.0219, 'lps'),
	(653106, 133, '2015-01-15 00:45:21.000000', 'consum', 0.0400, 'lps'),
	(653107, 133, '2015-01-15 00:45:22.000000', 'consum', 0.0266, 'lps'),
	(653108, 133, '2015-01-15 00:45:23.000000', 'consum', 0.0356, 'lps'),
	(653109, 133, '2015-01-15 00:45:24.000000', 'consum', 0.0338, 'lps'),
	(653110, 133, '2015-01-15 00:45:25.000000', 'consum', 0.0413, 'lps'),
	(653111, 133, '2015-01-15 00:45:26.000000', 'consum', 0.0405, 'lps'),
	(653112, 133, '2015-01-15 00:45:27.000000', 'consum', 0.0362, 'lps'),
	(653113, 133, '2015-01-15 00:45:28.000000', 'consum', 0.0383, 'lps'),
	(653114, 133, '2015-01-15 00:45:29.000000', 'consum', 0.0402, 'lps'),
	(653115, 133, '2015-01-15 00:45:30.000000', 'consum', 0.0219, 'lps'),
	(653116, 133, '2015-01-15 00:45:31.000000', 'consum', 0.0329, 'lps'),
	(653117, 133, '2015-01-15 00:45:32.000000', 'consum', 0.0345, 'lps'),
	(653118, 133, '2015-01-15 00:45:33.000000', 'consum', 0.0312, 'lps'),
	(653119, 133, '2015-01-15 00:45:34.000000', 'consum', 0.0317, 'lps'),
	(653120, 133, '2015-01-15 00:45:35.000000', 'consum', 0.0223, 'lps'),
	(653121, 133, '2015-01-15 00:45:36.000000', 'consum', 0.0389, 'lps'),
	(653122, 133, '2015-01-15 00:45:37.000000', 'consum', 0.0414, 'lps'),
	(653123, 133, '2015-01-15 00:45:38.000000', 'consum', 0.0259, 'lps'),
	(653124, 133, '2015-01-15 00:45:39.000000', 'consum', 0.0279, 'lps'),
	(653125, 133, '2015-01-15 00:45:40.000000', 'consum', 0.0406, 'lps'),
	(653126, 133, '2015-01-15 00:45:41.000000', 'consum', 0.0333, 'lps'),
	(653127, 133, '2015-01-15 00:45:42.000000', 'consum', 0.0239, 'lps'),
	(653128, 133, '2015-01-15 00:45:43.000000', 'consum', 0.0419, 'lps'),
	(653129, 133, '2015-01-15 00:45:44.000000', 'consum', 0.0302, 'lps'),
	(653130, 133, '2015-01-15 00:45:45.000000', 'consum', 0.0262, 'lps'),
	(653131, 133, '2015-01-15 00:45:46.000000', 'consum', 0.0408, 'lps'),
	(653132, 133, '2015-01-15 00:45:47.000000', 'consum', 0.0395, 'lps'),
	(653133, 133, '2015-01-15 00:45:48.000000', 'consum', 0.0324, 'lps'),
	(653134, 133, '2015-01-15 00:45:49.000000', 'consum', 0.0227, 'lps'),
	(653135, 133, '2015-01-15 00:45:50.000000', 'consum', 0.0388, 'lps'),
	(653136, 133, '2015-01-15 00:45:51.000000', 'consum', 0.0397, 'lps'),
	(653137, 133, '2015-01-15 00:45:52.000000', 'consum', 0.0395, 'lps'),
	(653138, 133, '2015-01-15 00:45:53.000000', 'consum', 0.0359, 'lps'),
	(653139, 133, '2015-01-15 00:45:54.000000', 'consum', 0.0398, 'lps'),
	(653140, 133, '2015-01-15 00:45:55.000000', 'consum', 0.0273, 'lps'),
	(653141, 133, '2015-01-15 00:45:56.000000', 'consum', 0.0392, 'lps'),
	(653142, 133, '2015-01-15 00:45:57.000000', 'consum', 0.0282, 'lps'),
	(653143, 133, '2015-01-15 00:45:58.000000', 'consum', 0.0240, 'lps'),
	(653144, 133, '2015-01-15 00:45:59.000000', 'consum', 0.0364, 'lps'),
	(653145, 133, '2015-01-15 00:46:00.000000', 'consum', 0.0240, 'lps'),
	(653146, 133, '2015-01-15 00:46:01.000000', 'consum', 0.0332, 'lps'),
	(653147, 133, '2015-01-15 00:46:02.000000', 'consum', 0.0297, 'lps'),
	(653148, 133, '2015-01-15 00:46:03.000000', 'consum', 0.0281, 'lps'),
	(653149, 133, '2015-01-15 00:46:04.000000', 'consum', 0.0302, 'lps'),
	(653150, 133, '2015-01-15 00:46:05.000000', 'consum', 0.0240, 'lps'),
	(653151, 133, '2015-01-15 00:46:06.000000', 'consum', 0.0301, 'lps'),
	(653152, 133, '2015-01-15 00:46:07.000000', 'consum', 0.0358, 'lps'),
	(653153, 133, '2015-01-15 00:46:08.000000', 'consum', 0.0243, 'lps'),
	(653154, 133, '2015-01-15 00:46:09.000000', 'consum', 0.0366, 'lps'),
	(653155, 133, '2015-01-15 00:46:10.000000', 'consum', 0.0242, 'lps'),
	(653156, 133, '2015-01-15 00:46:11.000000', 'consum', 0.0338, 'lps'),
	(653157, 133, '2015-01-15 00:46:12.000000', 'consum', 0.0318, 'lps'),
	(653158, 133, '2015-01-15 00:46:13.000000', 'consum', 0.0367, 'lps'),
	(653159, 133, '2015-01-15 00:46:14.000000', 'consum', 0.0236, 'lps'),
	(653160, 133, '2015-01-15 00:46:15.000000', 'consum', 0.0305, 'lps'),
	(653161, 133, '2015-01-15 00:46:16.000000', 'consum', 0.0390, 'lps'),
	(653162, 133, '2015-01-15 00:46:17.000000', 'consum', 0.0393, 'lps'),
	(653163, 133, '2015-01-15 00:46:18.000000', 'consum', 0.0366, 'lps'),
	(653164, 133, '2015-01-15 00:46:19.000000', 'consum', 0.0227, 'lps'),
	(653165, 133, '2015-01-15 00:46:20.000000', 'consum', 0.0260, 'lps'),
	(653166, 133, '2015-01-15 00:46:21.000000', 'consum', 0.0409, 'lps'),
	(653167, 133, '2015-01-15 00:46:22.000000', 'consum', 0.0405, 'lps'),
	(653168, 133, '2015-01-15 00:46:23.000000', 'consum', 0.0370, 'lps'),
	(653169, 133, '2015-01-15 00:46:24.000000', 'consum', 0.0210, 'lps'),
	(653170, 133, '2015-01-15 00:46:25.000000', 'consum', 0.0381, 'lps'),
	(653171, 133, '2015-01-15 00:46:26.000000', 'consum', 0.0415, 'lps'),
	(653172, 133, '2015-01-15 00:46:27.000000', 'consum', 0.0287, 'lps'),
	(653173, 133, '2015-01-15 00:46:28.000000', 'consum', 0.0416, 'lps'),
	(653174, 133, '2015-01-15 00:46:29.000000', 'consum', 0.0357, 'lps'),
	(653175, 133, '2015-01-15 00:46:30.000000', 'consum', 0.0330, 'lps'),
	(653176, 133, '2015-01-15 00:46:31.000000', 'consum', 0.0368, 'lps'),
	(653177, 133, '2015-01-15 00:46:32.000000', 'consum', 0.0422, 'lps'),
	(653178, 133, '2015-01-15 00:46:33.000000', 'consum', 0.0363, 'lps'),
	(653179, 133, '2015-01-15 00:46:34.000000', 'consum', 0.0341, 'lps'),
	(653180, 133, '2015-01-15 00:46:35.000000', 'consum', 0.0405, 'lps'),
	(653181, 133, '2015-01-15 00:46:36.000000', 'consum', 0.0359, 'lps'),
	(653182, 133, '2015-01-15 00:46:37.000000', 'consum', 0.0371, 'lps'),
	(653183, 133, '2015-01-15 00:46:38.000000', 'consum', 0.0353, 'lps'),
	(653184, 133, '2015-01-15 00:46:39.000000', 'consum', 0.0224, 'lps'),
	(653185, 133, '2015-01-15 00:46:40.000000', 'consum', 0.0286, 'lps'),
	(653186, 133, '2015-01-15 00:46:41.000000', 'consum', 0.0329, 'lps'),
	(653187, 133, '2015-01-15 00:46:42.000000', 'consum', 0.0364, 'lps'),
	(653188, 133, '2015-01-15 00:46:43.000000', 'consum', 0.0405, 'lps'),
	(653189, 133, '2015-01-15 00:46:44.000000', 'consum', 0.0291, 'lps'),
	(653190, 133, '2015-01-15 00:46:45.000000', 'consum', 0.0245, 'lps'),
	(653191, 133, '2015-01-15 00:46:46.000000', 'consum', 0.0361, 'lps'),
	(653192, 133, '2015-01-15 00:46:47.000000', 'consum', 0.0211, 'lps'),
	(653193, 133, '2015-01-15 00:46:48.000000', 'consum', 0.0413, 'lps'),
	(653194, 133, '2015-01-15 00:46:49.000000', 'consum', 0.0355, 'lps'),
	(653195, 133, '2015-01-15 00:46:50.000000', 'consum', 0.0325, 'lps'),
	(653196, 133, '2015-01-15 00:46:51.000000', 'consum', 0.0351, 'lps'),
	(653197, 133, '2015-01-15 00:46:52.000000', 'consum', 0.0355, 'lps'),
	(653198, 133, '2015-01-15 00:46:53.000000', 'consum', 0.0294, 'lps'),
	(653199, 133, '2015-01-15 00:46:54.000000', 'consum', 0.0412, 'lps'),
	(653200, 133, '2015-01-15 00:46:55.000000', 'consum', 0.0319, 'lps'),
	(653201, 133, '2015-01-15 00:46:56.000000', 'consum', 0.0366, 'lps'),
	(653202, 133, '2015-01-15 00:46:57.000000', 'consum', 0.0229, 'lps'),
	(653203, 133, '2015-01-15 00:46:58.000000', 'consum', 0.0272, 'lps'),
	(653204, 133, '2015-01-15 00:46:59.000000', 'consum', 0.0245, 'lps'),
	(653205, 133, '2015-01-15 00:47:00.000000', 'consum', 0.0419, 'lps'),
	(653206, 133, '2015-01-15 00:47:01.000000', 'consum', 0.0279, 'lps'),
	(653207, 133, '2015-01-15 00:47:02.000000', 'consum', 0.0366, 'lps'),
	(653208, 133, '2015-01-15 00:47:03.000000', 'consum', 0.0349, 'lps'),
	(653209, 133, '2015-01-15 00:47:04.000000', 'consum', 0.0219, 'lps'),
	(653210, 133, '2015-01-15 00:47:05.000000', 'consum', 0.0275, 'lps'),
	(653211, 133, '2015-01-15 00:47:06.000000', 'consum', 0.0289, 'lps'),
	(653212, 133, '2015-01-15 00:47:07.000000', 'consum', 0.0412, 'lps'),
	(653213, 133, '2015-01-15 00:47:08.000000', 'consum', 0.0332, 'lps'),
	(653214, 133, '2015-01-15 00:47:09.000000', 'consum', 0.0213, 'lps'),
	(653215, 133, '2015-01-15 00:47:10.000000', 'consum', 0.0294, 'lps'),
	(653216, 133, '2015-01-15 00:47:11.000000', 'consum', 0.0407, 'lps'),
	(653217, 133, '2015-01-15 00:47:12.000000', 'consum', 0.0290, 'lps'),
	(653218, 133, '2015-01-15 00:47:13.000000', 'consum', 0.0237, 'lps'),
	(653219, 133, '2015-01-15 00:47:14.000000', 'consum', 0.0324, 'lps'),
	(653220, 133, '2015-01-15 00:47:15.000000', 'consum', 0.0264, 'lps'),
	(653221, 133, '2015-01-15 00:47:16.000000', 'consum', 0.0357, 'lps'),
	(653222, 133, '2015-01-15 00:47:17.000000', 'consum', 0.0348, 'lps'),
	(653223, 133, '2015-01-15 00:47:18.000000', 'consum', 0.0242, 'lps'),
	(653224, 133, '2015-01-15 00:47:19.000000', 'consum', 0.0392, 'lps'),
	(653225, 133, '2015-01-15 00:47:20.000000', 'consum', 0.0375, 'lps'),
	(653226, 133, '2015-01-15 00:47:21.000000', 'consum', 0.0271, 'lps'),
	(653227, 133, '2015-01-15 00:47:22.000000', 'consum', 0.0237, 'lps'),
	(653228, 133, '2015-01-15 00:47:23.000000', 'consum', 0.0381, 'lps'),
	(653229, 133, '2015-01-15 00:47:24.000000', 'consum', 0.0331, 'lps'),
	(653230, 133, '2015-01-15 00:47:25.000000', 'consum', 0.0302, 'lps'),
	(653231, 133, '2015-01-15 00:47:26.000000', 'consum', 0.0309, 'lps'),
	(653232, 133, '2015-01-15 00:47:27.000000', 'consum', 0.0210, 'lps'),
	(653233, 133, '2015-01-15 00:47:28.000000', 'consum', 0.0350, 'lps'),
	(653234, 133, '2015-01-15 00:47:29.000000', 'consum', 0.0259, 'lps'),
	(653235, 133, '2015-01-15 00:47:30.000000', 'consum', 0.0250, 'lps'),
	(653236, 133, '2015-01-15 00:47:31.000000', 'consum', 0.0267, 'lps'),
	(653237, 133, '2015-01-15 00:47:32.000000', 'consum', 0.0373, 'lps'),
	(653238, 133, '2015-01-15 00:47:33.000000', 'consum', 0.0422, 'lps'),
	(653239, 133, '2015-01-15 00:47:34.000000', 'consum', 0.0347, 'lps'),
	(653240, 133, '2015-01-15 00:47:35.000000', 'consum', 0.0260, 'lps'),
	(653241, 133, '2015-01-15 00:47:36.000000', 'consum', 0.0266, 'lps'),
	(653242, 133, '2015-01-15 00:47:37.000000', 'consum', 0.0340, 'lps'),
	(653243, 133, '2015-01-15 00:47:38.000000', 'consum', 0.0260, 'lps'),
	(653244, 133, '2015-01-15 00:47:39.000000', 'consum', 0.0287, 'lps'),
	(653245, 133, '2015-01-15 00:47:40.000000', 'consum', 0.0228, 'lps'),
	(653246, 133, '2015-01-15 00:47:41.000000', 'consum', 0.0286, 'lps'),
	(653247, 133, '2015-01-15 00:47:42.000000', 'consum', 0.0322, 'lps'),
	(653248, 133, '2015-01-15 00:47:43.000000', 'consum', 0.0323, 'lps'),
	(653249, 133, '2015-01-15 00:47:44.000000', 'consum', 0.0224, 'lps'),
	(653250, 133, '2015-01-15 00:47:45.000000', 'consum', 0.0374, 'lps'),
	(653251, 133, '2015-01-15 00:47:46.000000', 'consum', 0.0340, 'lps'),
	(653252, 133, '2015-01-15 00:47:47.000000', 'consum', 0.0366, 'lps'),
	(653253, 133, '2015-01-15 00:47:48.000000', 'consum', 0.0383, 'lps'),
	(653254, 133, '2015-01-15 00:47:49.000000', 'consum', 0.0392, 'lps'),
	(653255, 133, '2015-01-15 00:47:50.000000', 'consum', 0.0384, 'lps'),
	(653256, 133, '2015-01-15 00:47:51.000000', 'consum', 0.0320, 'lps'),
	(653257, 133, '2015-01-15 00:47:52.000000', 'consum', 0.0235, 'lps'),
	(653258, 133, '2015-01-15 00:47:53.000000', 'consum', 0.0225, 'lps'),
	(653259, 133, '2015-01-15 00:47:54.000000', 'consum', 0.0211, 'lps'),
	(653260, 133, '2015-01-15 00:47:55.000000', 'consum', 0.0386, 'lps'),
	(653261, 133, '2015-01-15 00:47:56.000000', 'consum', 0.0219, 'lps'),
	(653262, 133, '2015-01-15 00:47:57.000000', 'consum', 0.0379, 'lps'),
	(653263, 133, '2015-01-15 00:47:58.000000', 'consum', 0.0378, 'lps'),
	(653264, 133, '2015-01-15 00:47:59.000000', 'consum', 0.0324, 'lps'),
	(653265, 133, '2015-01-15 00:48:00.000000', 'consum', 0.0279, 'lps'),
	(653266, 133, '2015-01-15 00:48:01.000000', 'consum', 0.0211, 'lps'),
	(653267, 133, '2015-01-15 00:48:02.000000', 'consum', 0.0227, 'lps'),
	(653268, 133, '2015-01-15 00:48:03.000000', 'consum', 0.0290, 'lps'),
	(653269, 133, '2015-01-15 00:48:04.000000', 'consum', 0.0346, 'lps'),
	(653270, 133, '2015-01-15 00:48:05.000000', 'consum', 0.0214, 'lps'),
	(653271, 133, '2015-01-15 00:48:06.000000', 'consum', 0.0256, 'lps'),
	(653272, 133, '2015-01-15 00:48:07.000000', 'consum', 0.0212, 'lps'),
	(653273, 133, '2015-01-15 00:48:08.000000', 'consum', 0.0301, 'lps'),
	(653274, 133, '2015-01-15 00:48:09.000000', 'consum', 0.0223, 'lps'),
	(653275, 133, '2015-01-15 00:48:10.000000', 'consum', 0.0220, 'lps'),
	(653276, 133, '2015-01-15 00:48:11.000000', 'consum', 0.0221, 'lps'),
	(653277, 133, '2015-01-15 00:48:12.000000', 'consum', 0.0238, 'lps'),
	(653278, 133, '2015-01-15 00:48:13.000000', 'consum', 0.0316, 'lps'),
	(653279, 133, '2015-01-15 00:48:14.000000', 'consum', 0.0221, 'lps'),
	(653280, 133, '2015-01-15 00:48:15.000000', 'consum', 0.0383, 'lps'),
	(653281, 133, '2015-01-15 00:48:16.000000', 'consum', 0.0392, 'lps'),
	(653282, 133, '2015-01-15 00:48:17.000000', 'consum', 0.0382, 'lps'),
	(653283, 133, '2015-01-15 00:48:18.000000', 'consum', 0.0311, 'lps'),
	(653284, 133, '2015-01-15 00:48:19.000000', 'consum', 0.0414, 'lps'),
	(653285, 133, '2015-01-15 00:48:20.000000', 'consum', 0.0279, 'lps'),
	(653286, 133, '2015-01-15 00:48:21.000000', 'consum', 0.0375, 'lps'),
	(653287, 133, '2015-01-15 00:48:22.000000', 'consum', 0.0394, 'lps'),
	(653288, 133, '2015-01-15 00:48:23.000000', 'consum', 0.0419, 'lps'),
	(653289, 133, '2015-01-15 00:48:24.000000', 'consum', 0.0269, 'lps'),
	(653290, 133, '2015-01-15 00:48:25.000000', 'consum', 0.0313, 'lps'),
	(653291, 133, '2015-01-15 00:48:26.000000', 'consum', 0.0333, 'lps'),
	(653292, 133, '2015-01-15 00:48:27.000000', 'consum', 0.0298, 'lps'),
	(653293, 133, '2015-01-15 00:48:28.000000', 'consum', 0.0282, 'lps'),
	(653294, 133, '2015-01-15 00:48:29.000000', 'consum', 0.0306, 'lps'),
	(653295, 133, '2015-01-15 00:48:30.000000', 'consum', 0.0257, 'lps'),
	(653296, 133, '2015-01-15 00:48:31.000000', 'consum', 0.0376, 'lps'),
	(653297, 133, '2015-01-15 00:48:32.000000', 'consum', 0.0247, 'lps'),
	(653298, 133, '2015-01-15 00:48:33.000000', 'consum', 0.0330, 'lps'),
	(653299, 133, '2015-01-15 00:48:34.000000', 'consum', 0.0267, 'lps'),
	(653300, 133, '2015-01-15 00:48:35.000000', 'consum', 0.0352, 'lps'),
	(653301, 133, '2015-01-15 00:48:36.000000', 'consum', 0.0317, 'lps'),
	(653302, 133, '2015-01-15 00:48:37.000000', 'consum', 0.0318, 'lps'),
	(653303, 133, '2015-01-15 00:48:38.000000', 'consum', 0.0211, 'lps'),
	(653304, 133, '2015-01-15 00:48:39.000000', 'consum', 0.0329, 'lps'),
	(653305, 133, '2015-01-15 00:48:40.000000', 'consum', 0.0366, 'lps'),
	(653306, 133, '2015-01-15 00:48:41.000000', 'consum', 0.0418, 'lps'),
	(653307, 133, '2015-01-15 00:48:42.000000', 'consum', 0.0348, 'lps'),
	(653308, 133, '2015-01-15 00:48:43.000000', 'consum', 0.0275, 'lps'),
	(653309, 133, '2015-01-15 00:48:44.000000', 'consum', 0.0341, 'lps'),
	(653310, 133, '2015-01-15 00:48:45.000000', 'consum', 0.0236, 'lps'),
	(653311, 133, '2015-01-15 00:48:46.000000', 'consum', 0.0379, 'lps'),
	(653312, 133, '2015-01-15 00:48:47.000000', 'consum', 0.0328, 'lps'),
	(653313, 133, '2015-01-15 00:48:48.000000', 'consum', 0.0294, 'lps'),
	(653314, 133, '2015-01-15 00:48:49.000000', 'consum', 0.0275, 'lps'),
	(653315, 133, '2015-01-15 00:48:50.000000', 'consum', 0.0284, 'lps'),
	(653316, 133, '2015-01-15 00:48:51.000000', 'consum', 0.0387, 'lps'),
	(653317, 133, '2015-01-15 00:48:52.000000', 'consum', 0.0222, 'lps'),
	(653318, 133, '2015-01-15 00:48:53.000000', 'consum', 0.0389, 'lps'),
	(653319, 133, '2015-01-15 00:48:54.000000', 'consum', 0.0420, 'lps'),
	(653320, 133, '2015-01-15 00:48:55.000000', 'consum', 0.0291, 'lps'),
	(653321, 133, '2015-01-15 00:48:56.000000', 'consum', 0.0416, 'lps'),
	(653322, 133, '2015-01-15 00:48:57.000000', 'consum', 0.0348, 'lps'),
	(653323, 133, '2015-01-15 00:48:58.000000', 'consum', 0.0284, 'lps'),
	(653324, 133, '2015-01-15 00:48:59.000000', 'consum', 0.0381, 'lps'),
	(653325, 133, '2015-01-15 00:49:00.000000', 'consum', 0.0413, 'lps'),
	(653326, 133, '2015-01-15 00:49:01.000000', 'consum', 0.0275, 'lps'),
	(653327, 133, '2015-01-15 00:49:02.000000', 'consum', 0.0362, 'lps'),
	(653328, 133, '2015-01-15 00:49:03.000000', 'consum', 0.0339, 'lps'),
	(653329, 133, '2015-01-15 00:49:04.000000', 'consum', 0.0402, 'lps'),
	(653330, 133, '2015-01-15 00:49:05.000000', 'consum', 0.0350, 'lps'),
	(653331, 133, '2015-01-15 00:49:06.000000', 'consum', 0.0334, 'lps'),
	(653332, 133, '2015-01-15 00:49:07.000000', 'consum', 0.0411, 'lps'),
	(653333, 133, '2015-01-15 00:49:08.000000', 'consum', 0.0410, 'lps'),
	(653334, 133, '2015-01-15 00:49:09.000000', 'consum', 0.0390, 'lps'),
	(653335, 133, '2015-01-15 00:49:10.000000', 'consum', 0.0294, 'lps'),
	(653336, 133, '2015-01-15 00:49:11.000000', 'consum', 0.0309, 'lps'),
	(653337, 133, '2015-01-15 00:49:12.000000', 'consum', 0.0236, 'lps'),
	(653338, 133, '2015-01-15 00:49:13.000000', 'consum', 0.0260, 'lps'),
	(653339, 133, '2015-01-15 00:49:14.000000', 'consum', 0.0383, 'lps'),
	(653340, 133, '2015-01-15 00:49:15.000000', 'consum', 0.0274, 'lps'),
	(653341, 133, '2015-01-15 00:49:16.000000', 'consum', 0.0228, 'lps'),
	(653342, 133, '2015-01-15 00:49:17.000000', 'consum', 0.0327, 'lps'),
	(653343, 133, '2015-01-15 00:49:18.000000', 'consum', 0.0305, 'lps'),
	(653344, 133, '2015-01-15 00:49:19.000000', 'consum', 0.0337, 'lps'),
	(653345, 133, '2015-01-15 00:49:20.000000', 'consum', 0.0344, 'lps'),
	(653346, 133, '2015-01-15 00:49:21.000000', 'consum', 0.0280, 'lps'),
	(653347, 133, '2015-01-15 00:49:22.000000', 'consum', 0.0376, 'lps'),
	(653348, 133, '2015-01-15 00:49:23.000000', 'consum', 0.0396, 'lps'),
	(653349, 133, '2015-01-15 00:49:24.000000', 'consum', 0.0210, 'lps'),
	(653350, 133, '2015-01-15 00:49:25.000000', 'consum', 0.0301, 'lps'),
	(653351, 133, '2015-01-15 00:49:26.000000', 'consum', 0.0232, 'lps'),
	(653352, 133, '2015-01-15 00:49:27.000000', 'consum', 0.0266, 'lps'),
	(653353, 133, '2015-01-15 00:49:28.000000', 'consum', 0.0425, 'lps'),
	(653354, 133, '2015-01-15 00:49:29.000000', 'consum', 0.0249, 'lps'),
	(653355, 133, '2015-01-15 00:49:30.000000', 'consum', 0.0411, 'lps'),
	(653356, 133, '2015-01-15 00:49:31.000000', 'consum', 0.0231, 'lps'),
	(653357, 133, '2015-01-15 00:49:32.000000', 'consum', 0.0361, 'lps'),
	(653358, 133, '2015-01-15 00:49:33.000000', 'consum', 0.0254, 'lps'),
	(653359, 133, '2015-01-15 00:49:34.000000', 'consum', 0.0413, 'lps'),
	(653360, 133, '2015-01-15 00:49:35.000000', 'consum', 0.0223, 'lps'),
	(653361, 133, '2015-01-15 00:49:36.000000', 'consum', 0.0317, 'lps'),
	(653362, 133, '2015-01-15 00:49:37.000000', 'consum', 0.0274, 'lps'),
	(653363, 133, '2015-01-15 00:49:38.000000', 'consum', 0.0425, 'lps'),
	(653364, 133, '2015-01-15 00:49:39.000000', 'consum', 0.0227, 'lps'),
	(653365, 133, '2015-01-15 00:49:40.000000', 'consum', 0.0302, 'lps'),
	(653366, 133, '2015-01-15 00:49:41.000000', 'consum', 0.0403, 'lps'),
	(653367, 133, '2015-01-15 00:49:42.000000', 'consum', 0.0247, 'lps'),
	(653368, 133, '2015-01-15 00:49:43.000000', 'consum', 0.0251, 'lps'),
	(653369, 133, '2015-01-15 00:49:44.000000', 'consum', 0.0304, 'lps'),
	(653370, 133, '2015-01-15 00:49:45.000000', 'consum', 0.0341, 'lps'),
	(653371, 133, '2015-01-15 00:49:46.000000', 'consum', 0.0365, 'lps'),
	(653372, 133, '2015-01-15 00:49:47.000000', 'consum', 0.0376, 'lps'),
	(653373, 133, '2015-01-15 00:49:48.000000', 'consum', 0.0360, 'lps'),
	(653374, 133, '2015-01-15 00:49:49.000000', 'consum', 0.0246, 'lps'),
	(653375, 133, '2015-01-15 00:49:50.000000', 'consum', 0.0373, 'lps'),
	(653376, 133, '2015-01-15 00:49:51.000000', 'consum', 0.0268, 'lps'),
	(653377, 133, '2015-01-15 00:49:52.000000', 'consum', 0.0226, 'lps'),
	(653378, 133, '2015-01-15 00:49:53.000000', 'consum', 0.0335, 'lps'),
	(653379, 133, '2015-01-15 00:49:54.000000', 'consum', 0.0354, 'lps'),
	(653380, 133, '2015-01-15 00:49:55.000000', 'consum', 0.0340, 'lps'),
	(653381, 133, '2015-01-15 00:49:56.000000', 'consum', 0.0210, 'lps'),
	(653382, 133, '2015-01-15 00:49:57.000000', 'consum', 0.0253, 'lps'),
	(653383, 133, '2015-01-15 00:49:58.000000', 'consum', 0.0210, 'lps'),
	(653384, 133, '2015-01-15 00:49:59.000000', 'consum', 0.0297, 'lps'),
	(653385, 133, '2015-01-15 00:50:00.000000', 'consum', 0.0214, 'lps'),
	(653386, 133, '2015-01-15 00:50:01.000000', 'consum', 0.0402, 'lps'),
	(653387, 133, '2015-01-15 00:50:02.000000', 'consum', 0.0292, 'lps'),
	(653388, 133, '2015-01-15 00:50:03.000000', 'consum', 0.0260, 'lps'),
	(653389, 133, '2015-01-15 00:50:04.000000', 'consum', 0.0216, 'lps'),
	(653390, 133, '2015-01-15 00:50:05.000000', 'consum', 0.0305, 'lps'),
	(653391, 133, '2015-01-15 00:50:06.000000', 'consum', 0.0234, 'lps'),
	(653392, 133, '2015-01-15 00:50:07.000000', 'consum', 0.0263, 'lps'),
	(653393, 133, '2015-01-15 00:50:08.000000', 'consum', 0.0406, 'lps'),
	(653394, 133, '2015-01-15 00:50:09.000000', 'consum', 0.0377, 'lps'),
	(653395, 133, '2015-01-15 00:50:10.000000', 'consum', 0.0240, 'lps'),
	(653396, 133, '2015-01-15 00:50:11.000000', 'consum', 0.0296, 'lps'),
	(653397, 133, '2015-01-15 00:50:12.000000', 'consum', 0.0335, 'lps'),
	(653398, 133, '2015-01-15 00:50:13.000000', 'consum', 0.0357, 'lps'),
	(653399, 133, '2015-01-15 00:50:14.000000', 'consum', 0.0355, 'lps'),
	(653400, 133, '2015-01-15 00:50:15.000000', 'consum', 0.0277, 'lps'),
	(653401, 133, '2015-01-15 00:50:16.000000', 'consum', 0.0329, 'lps'),
	(653402, 133, '2015-01-15 00:50:17.000000', 'consum', 0.0385, 'lps'),
	(653403, 133, '2015-01-15 00:50:18.000000', 'consum', 0.0296, 'lps'),
	(653404, 133, '2015-01-15 00:50:19.000000', 'consum', 0.0331, 'lps'),
	(653405, 133, '2015-01-15 00:50:20.000000', 'consum', 0.0340, 'lps'),
	(653406, 133, '2015-01-15 00:50:21.000000', 'consum', 0.0281, 'lps'),
	(653407, 133, '2015-01-15 00:50:22.000000', 'consum', 0.0391, 'lps'),
	(653408, 133, '2015-01-15 00:50:23.000000', 'consum', 0.0254, 'lps'),
	(653409, 133, '2015-01-15 00:50:24.000000', 'consum', 0.0322, 'lps'),
	(653410, 133, '2015-01-15 00:50:25.000000', 'consum', 0.0421, 'lps'),
	(653411, 133, '2015-01-15 00:50:26.000000', 'consum', 0.0279, 'lps'),
	(653412, 133, '2015-01-15 00:50:27.000000', 'consum', 0.0356, 'lps'),
	(653413, 133, '2015-01-15 00:50:28.000000', 'consum', 0.0301, 'lps'),
	(653414, 133, '2015-01-15 00:50:29.000000', 'consum', 0.0227, 'lps'),
	(653415, 133, '2015-01-15 00:50:30.000000', 'consum', 0.0237, 'lps'),
	(653416, 133, '2015-01-15 00:50:31.000000', 'consum', 0.0296, 'lps'),
	(653417, 133, '2015-01-15 00:50:32.000000', 'consum', 0.0343, 'lps'),
	(653418, 133, '2015-01-15 00:50:33.000000', 'consum', 0.0399, 'lps'),
	(653419, 133, '2015-01-15 00:50:34.000000', 'consum', 0.0322, 'lps'),
	(653420, 133, '2015-01-15 00:50:35.000000', 'consum', 0.0421, 'lps'),
	(653421, 133, '2015-01-15 00:50:36.000000', 'consum', 0.0279, 'lps'),
	(653422, 133, '2015-01-15 00:50:37.000000', 'consum', 0.0355, 'lps'),
	(653423, 133, '2015-01-15 00:50:38.000000', 'consum', 0.0296, 'lps'),
	(653424, 133, '2015-01-15 00:50:39.000000', 'consum', 0.0422, 'lps'),
	(653425, 133, '2015-01-15 00:50:40.000000', 'consum', 0.0364, 'lps'),
	(653426, 133, '2015-01-15 00:50:41.000000', 'consum', 0.0341, 'lps'),
	(653427, 133, '2015-01-15 00:50:42.000000', 'consum', 0.0405, 'lps'),
	(653428, 133, '2015-01-15 00:50:43.000000', 'consum', 0.0357, 'lps'),
	(653429, 133, '2015-01-15 00:50:44.000000', 'consum', 0.0363, 'lps'),
	(653430, 133, '2015-01-15 00:50:45.000000', 'consum', 0.0318, 'lps'),
	(653431, 133, '2015-01-15 00:50:46.000000', 'consum', 0.0292, 'lps'),
	(653432, 133, '2015-01-15 00:50:47.000000', 'consum', 0.0295, 'lps'),
	(653433, 133, '2015-01-15 00:50:48.000000', 'consum', 0.0388, 'lps'),
	(653434, 133, '2015-01-15 00:50:49.000000', 'consum', 0.0414, 'lps'),
	(653435, 133, '2015-01-15 00:50:50.000000', 'consum', 0.0262, 'lps'),
	(653436, 133, '2015-01-15 00:50:51.000000', 'consum', 0.0293, 'lps'),
	(653437, 133, '2015-01-15 00:50:52.000000', 'consum', 0.0253, 'lps'),
	(653438, 133, '2015-01-15 00:50:53.000000', 'consum', 0.0391, 'lps'),
	(653439, 133, '2015-01-15 00:50:54.000000', 'consum', 0.0337, 'lps'),
	(653440, 133, '2015-01-15 00:50:55.000000', 'consum', 0.0303, 'lps'),
	(653441, 133, '2015-01-15 00:50:56.000000', 'consum', 0.0292, 'lps'),
	(653442, 133, '2015-01-15 00:50:57.000000', 'consum', 0.0345, 'lps'),
	(653443, 133, '2015-01-15 00:50:58.000000', 'consum', 0.0421, 'lps'),
	(653444, 133, '2015-01-15 00:50:59.000000', 'consum', 0.0425, 'lps'),
	(653445, 133, '2015-01-15 00:51:00.000000', 'consum', 0.0219, 'lps'),
	(653446, 133, '2015-01-15 00:51:01.000000', 'consum', 0.0261, 'lps'),
	(653447, 133, '2015-01-15 00:51:02.000000', 'consum', 0.0220, 'lps'),
	(653448, 133, '2015-01-15 00:51:03.000000', 'consum', 0.0328, 'lps'),
	(653449, 133, '2015-01-15 00:51:04.000000', 'consum', 0.0335, 'lps'),
	(653450, 133, '2015-01-15 00:51:05.000000', 'consum', 0.0267, 'lps'),
	(653451, 133, '2015-01-15 00:51:06.000000', 'consum', 0.0334, 'lps'),
	(653452, 133, '2015-01-15 00:51:07.000000', 'consum', 0.0227, 'lps'),
	(653453, 133, '2015-01-15 00:51:08.000000', 'consum', 0.0355, 'lps'),
	(653454, 133, '2015-01-15 00:51:09.000000', 'consum', 0.0236, 'lps'),
	(653455, 133, '2015-01-15 00:51:10.000000', 'consum', 0.0341, 'lps'),
	(653456, 133, '2015-01-15 00:51:11.000000', 'consum', 0.0351, 'lps'),
	(653457, 133, '2015-01-15 00:51:12.000000', 'consum', 0.0308, 'lps'),
	(653458, 133, '2015-01-15 00:51:13.000000', 'consum', 0.0274, 'lps'),
	(653459, 133, '2015-01-15 00:51:14.000000', 'consum', 0.0239, 'lps'),
	(653460, 133, '2015-01-15 00:51:15.000000', 'consum', 0.0381, 'lps'),
	(653461, 133, '2015-01-15 00:51:16.000000', 'consum', 0.0328, 'lps'),
	(653462, 133, '2015-01-15 00:51:17.000000', 'consum', 0.0287, 'lps'),
	(653463, 133, '2015-01-15 00:51:18.000000', 'consum', 0.0243, 'lps'),
	(653464, 133, '2015-01-15 00:51:19.000000', 'consum', 0.0358, 'lps'),
	(653465, 133, '2015-01-15 00:51:20.000000', 'consum', 0.0420, 'lps'),
	(653466, 133, '2015-01-15 00:51:21.000000', 'consum', 0.0380, 'lps'),
	(653467, 133, '2015-01-15 00:51:22.000000', 'consum', 0.0216, 'lps'),
	(653468, 133, '2015-01-15 00:51:23.000000', 'consum', 0.0379, 'lps'),
	(653469, 133, '2015-01-15 00:51:24.000000', 'consum', 0.0387, 'lps'),
	(653470, 133, '2015-01-15 00:51:25.000000', 'consum', 0.0374, 'lps'),
	(653471, 133, '2015-01-15 00:51:26.000000', 'consum', 0.0280, 'lps'),
	(653472, 133, '2015-01-15 00:51:27.000000', 'consum', 0.0285, 'lps'),
	(653473, 133, '2015-01-15 00:51:28.000000', 'consum', 0.0378, 'lps'),
	(653474, 133, '2015-01-15 00:51:29.000000', 'consum', 0.0388, 'lps'),
	(653475, 133, '2015-01-15 00:51:30.000000', 'consum', 0.0383, 'lps'),
	(653476, 133, '2015-01-15 00:51:31.000000', 'consum', 0.0324, 'lps'),
	(653477, 133, '2015-01-15 00:51:32.000000', 'consum', 0.0262, 'lps'),
	(653478, 133, '2015-01-15 00:51:33.000000', 'consum', 0.0345, 'lps'),
	(653479, 133, '2015-01-15 00:51:34.000000', 'consum', 0.0295, 'lps'),
	(653480, 133, '2015-01-15 00:51:35.000000', 'consum', 0.0230, 'lps'),
	(653481, 133, '2015-01-15 00:51:36.000000', 'consum', 0.0274, 'lps'),
	(653482, 133, '2015-01-15 00:51:37.000000', 'consum', 0.0254, 'lps'),
	(653483, 133, '2015-01-15 00:51:38.000000', 'consum', 0.0239, 'lps'),
	(653484, 133, '2015-01-15 00:51:39.000000', 'consum', 0.0224, 'lps'),
	(653485, 133, '2015-01-15 00:51:40.000000', 'consum', 0.0409, 'lps'),
	(653486, 133, '2015-01-15 00:51:41.000000', 'consum', 0.0296, 'lps'),
	(653487, 133, '2015-01-15 00:51:42.000000', 'consum', 0.0262, 'lps'),
	(653488, 133, '2015-01-15 00:51:43.000000', 'consum', 0.0211, 'lps'),
	(653489, 133, '2015-01-15 00:51:44.000000', 'consum', 0.0277, 'lps'),
	(653490, 133, '2015-01-15 00:51:45.000000', 'consum', 0.0325, 'lps'),
	(653491, 133, '2015-01-15 00:51:46.000000', 'consum', 0.0369, 'lps'),
	(653492, 133, '2015-01-15 00:51:47.000000', 'consum', 0.0224, 'lps'),
	(653493, 133, '2015-01-15 00:51:48.000000', 'consum', 0.0238, 'lps'),
	(653494, 133, '2015-01-15 00:51:49.000000', 'consum', 0.0308, 'lps'),
	(653495, 133, '2015-01-15 00:51:50.000000', 'consum', 0.0401, 'lps'),
	(653496, 133, '2015-01-15 00:51:51.000000', 'consum', 0.0222, 'lps'),
	(653497, 133, '2015-01-15 00:51:52.000000', 'consum', 0.0346, 'lps'),
	(653498, 133, '2015-01-15 00:51:53.000000', 'consum', 0.0420, 'lps'),
	(653499, 133, '2015-01-15 00:51:54.000000', 'consum', 0.0419, 'lps'),
	(653500, 133, '2015-01-15 00:51:55.000000', 'consum', 0.0407, 'lps'),
	(653501, 133, '2015-01-15 00:51:56.000000', 'consum', 0.0353, 'lps'),
	(653502, 133, '2015-01-15 00:51:57.000000', 'consum', 0.0332, 'lps'),
	(653503, 133, '2015-01-15 00:51:58.000000', 'consum', 0.0395, 'lps'),
	(653504, 133, '2015-01-15 00:51:59.000000', 'consum', 0.0333, 'lps'),
	(653505, 133, '2015-01-15 00:52:00.000000', 'consum', 0.0270, 'lps'),
	(653506, 133, '2015-01-15 00:52:01.000000', 'consum', 0.0358, 'lps'),
	(653507, 133, '2015-01-15 00:52:02.000000', 'consum', 0.0336, 'lps'),
	(653508, 133, '2015-01-15 00:52:03.000000', 'consum', 0.0397, 'lps'),
	(653509, 133, '2015-01-15 00:52:04.000000', 'consum', 0.0332, 'lps'),
	(653510, 133, '2015-01-15 00:52:05.000000', 'consum', 0.0260, 'lps'),
	(653511, 133, '2015-01-15 00:52:06.000000', 'consum', 0.0313, 'lps'),
	(653512, 133, '2015-01-15 00:52:07.000000', 'consum', 0.0359, 'lps'),
	(653513, 133, '2015-01-15 00:52:08.000000', 'consum', 0.0210, 'lps'),
	(653514, 133, '2015-01-15 00:52:09.000000', 'consum', 0.0415, 'lps'),
	(653515, 133, '2015-01-15 00:52:10.000000', 'consum', 0.0368, 'lps'),
	(653516, 133, '2015-01-15 00:52:11.000000', 'consum', 0.0384, 'lps'),
	(653517, 133, '2015-01-15 00:52:12.000000', 'consum', 0.0391, 'lps'),
	(653518, 133, '2015-01-15 00:52:13.000000', 'consum', 0.0376, 'lps'),
	(653519, 133, '2015-01-15 00:52:14.000000', 'consum', 0.0280, 'lps'),
	(653520, 133, '2015-01-15 00:52:15.000000', 'consum', 0.0279, 'lps'),
	(653521, 133, '2015-01-15 00:52:16.000000', 'consum', 0.0345, 'lps'),
	(653522, 133, '2015-01-15 00:52:17.000000', 'consum', 0.0245, 'lps'),
	(653523, 133, '2015-01-15 00:52:18.000000', 'consum', 0.0416, 'lps'),
	(653524, 133, '2015-01-15 00:52:19.000000', 'consum', 0.0265, 'lps'),
	(653525, 133, '2015-01-15 00:52:20.000000', 'consum', 0.0302, 'lps'),
	(653526, 133, '2015-01-15 00:52:21.000000', 'consum', 0.0287, 'lps'),
	(653527, 133, '2015-01-15 00:52:22.000000', 'consum', 0.0322, 'lps'),
	(653528, 133, '2015-01-15 00:52:23.000000', 'consum', 0.0321, 'lps'),
	(653529, 133, '2015-01-15 00:52:24.000000', 'consum', 0.0211, 'lps'),
	(653530, 133, '2015-01-15 00:52:25.000000', 'consum', 0.0317, 'lps'),
	(653531, 133, '2015-01-15 00:52:26.000000', 'consum', 0.0311, 'lps'),
	(653532, 133, '2015-01-15 00:52:27.000000', 'consum', 0.0394, 'lps'),
	(653533, 133, '2015-01-15 00:52:28.000000', 'consum', 0.0394, 'lps'),
	(653534, 133, '2015-01-15 00:52:29.000000', 'consum', 0.0362, 'lps'),
	(653535, 133, '2015-01-15 00:52:30.000000', 'consum', 0.0417, 'lps'),
	(653536, 133, '2015-01-15 00:52:31.000000', 'consum', 0.0357, 'lps'),
	(653537, 133, '2015-01-15 00:52:32.000000', 'consum', 0.0323, 'lps'),
	(653538, 133, '2015-01-15 00:52:33.000000', 'consum', 0.0336, 'lps'),
	(653539, 133, '2015-01-15 00:52:34.000000', 'consum', 0.0285, 'lps'),
	(653540, 133, '2015-01-15 00:52:35.000000', 'consum', 0.0425, 'lps'),
	(653541, 133, '2015-01-15 00:52:36.000000', 'consum', 0.0408, 'lps'),
	(653542, 133, '2015-01-15 00:52:37.000000', 'consum', 0.0340, 'lps'),
	(653543, 133, '2015-01-15 00:52:38.000000', 'consum', 0.0265, 'lps'),
	(653544, 133, '2015-01-15 00:52:39.000000', 'consum', 0.0315, 'lps'),
	(653545, 133, '2015-01-15 00:52:40.000000', 'consum', 0.0350, 'lps'),
	(653546, 133, '2015-01-15 00:52:41.000000', 'consum', 0.0382, 'lps'),
	(653547, 133, '2015-01-15 00:52:42.000000', 'consum', 0.0214, 'lps'),
	(653548, 133, '2015-01-15 00:52:43.000000', 'consum', 0.0367, 'lps'),
	(653549, 133, '2015-01-15 00:52:44.000000', 'consum', 0.0333, 'lps'),
	(653550, 133, '2015-01-15 00:52:45.000000', 'consum', 0.0352, 'lps'),
	(653551, 133, '2015-01-15 00:52:46.000000', 'consum', 0.0337, 'lps'),
	(653552, 133, '2015-01-15 00:52:47.000000', 'consum', 0.0419, 'lps'),
	(653553, 133, '2015-01-15 00:52:48.000000', 'consum', 0.0222, 'lps'),
	(653554, 133, '2015-01-15 00:52:49.000000', 'consum', 0.0296, 'lps'),
	(653555, 133, '2015-01-15 00:52:50.000000', 'consum', 0.0388, 'lps'),
	(653556, 133, '2015-01-15 00:52:51.000000', 'consum', 0.0407, 'lps'),
	(653557, 133, '2015-01-15 00:52:52.000000', 'consum', 0.0228, 'lps'),
	(653558, 133, '2015-01-15 00:52:53.000000', 'consum', 0.0362, 'lps'),
	(653559, 133, '2015-01-15 00:52:54.000000', 'consum', 0.0264, 'lps'),
	(653560, 133, '2015-01-15 00:52:55.000000', 'consum', 0.0244, 'lps'),
	(653561, 133, '2015-01-15 00:52:56.000000', 'consum', 0.0217, 'lps'),
	(653562, 133, '2015-01-15 00:52:57.000000', 'consum', 0.0359, 'lps'),
	(653563, 133, '2015-01-15 00:52:58.000000', 'consum', 0.0287, 'lps'),
	(653564, 133, '2015-01-15 00:52:59.000000', 'consum', 0.0362, 'lps'),
	(653565, 133, '2015-01-15 00:53:00.000000', 'consum', 0.0305, 'lps'),
	(653566, 133, '2015-01-15 00:53:01.000000', 'consum', 0.0233, 'lps'),
	(653567, 133, '2015-01-15 00:53:02.000000', 'consum', 0.0254, 'lps'),
	(653568, 133, '2015-01-15 00:53:03.000000', 'consum', 0.0365, 'lps'),
	(653569, 133, '2015-01-15 00:53:04.000000', 'consum', 0.0417, 'lps'),
	(653570, 133, '2015-01-15 00:53:05.000000', 'consum', 0.0349, 'lps'),
	(653571, 133, '2015-01-15 00:53:06.000000', 'consum', 0.0283, 'lps'),
	(653572, 133, '2015-01-15 00:53:07.000000', 'consum', 0.0374, 'lps'),
	(653573, 133, '2015-01-15 00:53:08.000000', 'consum', 0.0380, 'lps'),
	(653574, 133, '2015-01-15 00:53:09.000000', 'consum', 0.0350, 'lps'),
	(653575, 133, '2015-01-15 00:53:10.000000', 'consum', 0.0401, 'lps'),
	(653576, 133, '2015-01-15 00:53:11.000000', 'consum', 0.0311, 'lps'),
	(653577, 133, '2015-01-15 00:53:12.000000', 'consum', 0.0358, 'lps'),
	(653578, 133, '2015-01-15 00:53:13.000000', 'consum', 0.0215, 'lps'),
	(653579, 133, '2015-01-15 00:53:14.000000', 'consum', 0.0227, 'lps'),
	(653580, 133, '2015-01-15 00:53:15.000000', 'consum', 0.0279, 'lps'),
	(653581, 133, '2015-01-15 00:53:16.000000', 'consum', 0.0287, 'lps'),
	(653582, 133, '2015-01-15 00:53:17.000000', 'consum', 0.0388, 'lps'),
	(653583, 133, '2015-01-15 00:53:18.000000', 'consum', 0.0220, 'lps'),
	(653584, 133, '2015-01-15 00:53:19.000000', 'consum', 0.0378, 'lps'),
	(653585, 133, '2015-01-15 00:53:20.000000', 'consum', 0.0370, 'lps'),
	(653586, 133, '2015-01-15 00:53:21.000000', 'consum', 0.0287, 'lps'),
	(653587, 133, '2015-01-15 00:53:22.000000', 'consum', 0.0334, 'lps'),
	(653588, 133, '2015-01-15 00:53:23.000000', 'consum', 0.0382, 'lps'),
	(653589, 133, '2015-01-15 00:53:24.000000', 'consum', 0.0264, 'lps'),
	(653590, 133, '2015-01-15 00:53:25.000000', 'consum', 0.0400, 'lps'),
	(653591, 133, '2015-01-15 00:53:26.000000', 'consum', 0.0345, 'lps'),
	(653592, 133, '2015-01-15 00:53:27.000000', 'consum', 0.0318, 'lps'),
	(653593, 133, '2015-01-15 00:53:28.000000', 'consum', 0.0344, 'lps'),
	(653594, 133, '2015-01-15 00:53:29.000000', 'consum', 0.0340, 'lps'),
	(653595, 133, '2015-01-15 00:53:30.000000', 'consum', 0.0244, 'lps'),
	(653596, 133, '2015-01-15 00:53:31.000000', 'consum', 0.0421, 'lps'),
	(653597, 133, '2015-01-15 00:53:32.000000', 'consum', 0.0296, 'lps'),
	(653598, 133, '2015-01-15 00:53:33.000000', 'consum', 0.0225, 'lps'),
	(653599, 133, '2015-01-15 00:53:34.000000', 'consum', 0.0246, 'lps'),
	(653600, 133, '2015-01-15 00:53:35.000000', 'consum', 0.0345, 'lps'),
	(653601, 133, '2015-01-15 00:53:36.000000', 'consum', 0.0342, 'lps'),
	(653602, 133, '2015-01-15 00:53:37.000000', 'consum', 0.0249, 'lps'),
	(653603, 133, '2015-01-15 00:53:38.000000', 'consum', 0.0229, 'lps'),
	(653604, 133, '2015-01-15 00:53:39.000000', 'consum', 0.0402, 'lps'),
	(653605, 133, '2015-01-15 00:53:40.000000', 'consum', 0.0247, 'lps'),
	(653606, 133, '2015-01-15 00:53:41.000000', 'consum', 0.0254, 'lps'),
	(653607, 133, '2015-01-15 00:53:42.000000', 'consum', 0.0317, 'lps'),
	(653608, 133, '2015-01-15 00:53:43.000000', 'consum', 0.0400, 'lps'),
	(653609, 133, '2015-01-15 00:53:44.000000', 'consum', 0.0402, 'lps'),
	(653610, 133, '2015-01-15 00:53:45.000000', 'consum', 0.0386, 'lps'),
	(653611, 133, '2015-01-15 00:53:46.000000', 'consum', 0.0299, 'lps'),
	(653612, 133, '2015-01-15 00:53:47.000000', 'consum', 0.0342, 'lps'),
	(653613, 133, '2015-01-15 00:53:48.000000', 'consum', 0.0386, 'lps'),
	(653614, 133, '2015-01-15 00:53:49.000000', 'consum', 0.0262, 'lps'),
	(653615, 133, '2015-01-15 00:53:50.000000', 'consum', 0.0377, 'lps'),
	(653616, 133, '2015-01-15 00:53:51.000000', 'consum', 0.0237, 'lps'),
	(653617, 133, '2015-01-15 00:53:52.000000', 'consum', 0.0280, 'lps'),
	(653618, 133, '2015-01-15 00:53:53.000000', 'consum', 0.0264, 'lps'),
	(653619, 133, '2015-01-15 00:53:54.000000', 'consum', 0.0268, 'lps'),
	(653620, 133, '2015-01-15 00:53:55.000000', 'consum', 0.0340, 'lps'),
	(653621, 133, '2015-01-15 00:53:56.000000', 'consum', 0.0252, 'lps'),
	(653622, 133, '2015-01-15 00:53:57.000000', 'consum', 0.0248, 'lps'),
	(653623, 133, '2015-01-15 00:53:58.000000', 'consum', 0.0272, 'lps'),
	(653624, 133, '2015-01-15 00:53:59.000000', 'consum', 0.0409, 'lps'),
	(653625, 133, '2015-01-15 00:54:00.000000', 'consum', 0.0366, 'lps'),
	(653626, 133, '2015-01-15 00:54:01.000000', 'consum', 0.0393, 'lps'),
	(653627, 133, '2015-01-15 00:54:02.000000', 'consum', 0.0227, 'lps'),
	(653628, 133, '2015-01-15 00:54:03.000000', 'consum', 0.0395, 'lps'),
	(653629, 133, '2015-01-15 00:54:04.000000', 'consum', 0.0216, 'lps'),
	(653630, 133, '2015-01-15 00:54:05.000000', 'consum', 0.0337, 'lps'),
	(653631, 133, '2015-01-15 00:54:06.000000', 'consum', 0.0393, 'lps'),
	(653632, 133, '2015-01-15 00:54:07.000000', 'consum', 0.0311, 'lps'),
	(653633, 133, '2015-01-15 00:54:08.000000', 'consum', 0.0382, 'lps'),
	(653634, 133, '2015-01-15 00:54:09.000000', 'consum', 0.0334, 'lps'),
	(653635, 133, '2015-01-15 00:54:10.000000', 'consum', 0.0314, 'lps'),
	(653636, 133, '2015-01-15 00:54:11.000000', 'consum', 0.0361, 'lps'),
	(653637, 133, '2015-01-15 00:54:12.000000', 'consum', 0.0218, 'lps'),
	(653638, 133, '2015-01-15 00:54:13.000000', 'consum', 0.0230, 'lps'),
	(653639, 133, '2015-01-15 00:54:14.000000', 'consum', 0.0288, 'lps'),
	(653640, 133, '2015-01-15 00:54:15.000000', 'consum', 0.0322, 'lps'),
	(653641, 133, '2015-01-15 00:54:16.000000', 'consum', 0.0319, 'lps'),
	(653642, 133, '2015-01-15 00:54:17.000000', 'consum', 0.0422, 'lps'),
	(653643, 133, '2015-01-15 00:54:18.000000', 'consum', 0.0289, 'lps'),
	(653644, 133, '2015-01-15 00:54:19.000000', 'consum', 0.0406, 'lps'),
	(653645, 133, '2015-01-15 00:54:20.000000', 'consum', 0.0304, 'lps'),
	(653646, 133, '2015-01-15 00:54:21.000000', 'consum', 0.0306, 'lps'),
	(653647, 133, '2015-01-15 00:54:22.000000', 'consum', 0.0411, 'lps'),
	(653648, 133, '2015-01-15 00:54:23.000000', 'consum', 0.0278, 'lps'),
	(653649, 133, '2015-01-15 00:54:24.000000', 'consum', 0.0378, 'lps'),
	(653650, 133, '2015-01-15 00:54:25.000000', 'consum', 0.0415, 'lps'),
	(653651, 133, '2015-01-15 00:54:26.000000', 'consum', 0.0295, 'lps'),
	(653652, 133, '2015-01-15 00:54:27.000000', 'consum', 0.0240, 'lps'),
	(653653, 133, '2015-01-15 00:54:28.000000', 'consum', 0.0323, 'lps'),
	(653654, 133, '2015-01-15 00:54:29.000000', 'consum', 0.0250, 'lps'),
	(653655, 133, '2015-01-15 00:54:30.000000', 'consum', 0.0288, 'lps'),
	(653656, 133, '2015-01-15 00:54:31.000000', 'consum', 0.0265, 'lps'),
	(653657, 133, '2015-01-15 00:54:32.000000', 'consum', 0.0251, 'lps'),
	(653658, 133, '2015-01-15 00:54:33.000000', 'consum', 0.0249, 'lps'),
	(653659, 133, '2015-01-15 00:54:34.000000', 'consum', 0.0284, 'lps'),
	(653660, 133, '2015-01-15 00:54:35.000000', 'consum', 0.0244, 'lps'),
	(653661, 133, '2015-01-15 00:54:36.000000', 'consum', 0.0378, 'lps'),
	(653662, 133, '2015-01-15 00:54:37.000000', 'consum', 0.0295, 'lps'),
	(653663, 133, '2015-01-15 00:54:38.000000', 'consum', 0.0352, 'lps'),
	(653664, 133, '2015-01-15 00:54:39.000000', 'consum', 0.0229, 'lps'),
	(653665, 133, '2015-01-15 00:54:40.000000', 'consum', 0.0315, 'lps'),
	(653666, 133, '2015-01-15 00:54:41.000000', 'consum', 0.0245, 'lps'),
	(653667, 133, '2015-01-15 00:54:42.000000', 'consum', 0.0288, 'lps'),
	(653668, 133, '2015-01-15 00:54:43.000000', 'consum', 0.0279, 'lps'),
	(653669, 133, '2015-01-15 00:54:44.000000', 'consum', 0.0323, 'lps'),
	(653670, 133, '2015-01-15 00:54:45.000000', 'consum', 0.0348, 'lps'),
	(653671, 133, '2015-01-15 00:54:46.000000', 'consum', 0.0346, 'lps'),
	(653672, 133, '2015-01-15 00:54:47.000000', 'consum', 0.0260, 'lps'),
	(653673, 133, '2015-01-15 00:54:48.000000', 'consum', 0.0269, 'lps'),
	(653674, 133, '2015-01-15 00:54:49.000000', 'consum', 0.0354, 'lps'),
	(653675, 133, '2015-01-15 00:54:50.000000', 'consum', 0.0319, 'lps'),
	(653676, 133, '2015-01-15 00:54:51.000000', 'consum', 0.0323, 'lps'),
	(653677, 133, '2015-01-15 00:54:52.000000', 'consum', 0.0232, 'lps'),
	(653678, 133, '2015-01-15 00:54:53.000000', 'consum', 0.0414, 'lps'),
	(653679, 133, '2015-01-15 00:54:54.000000', 'consum', 0.0300, 'lps'),
	(653680, 133, '2015-01-15 00:54:55.000000', 'consum', 0.0264, 'lps'),
	(653681, 133, '2015-01-15 00:54:56.000000', 'consum', 0.0426, 'lps'),
	(653682, 133, '2015-01-15 00:54:57.000000', 'consum', 0.0262, 'lps'),
	(653683, 133, '2015-01-15 00:54:58.000000', 'consum', 0.0256, 'lps'),
	(653684, 133, '2015-01-15 00:54:59.000000', 'consum', 0.0286, 'lps'),
	(653685, 133, '2015-01-15 00:55:00.000000', 'consum', 0.0233, 'lps'),
	(653686, 133, '2015-01-15 00:55:01.000000', 'consum', 0.0317, 'lps'),
	(653687, 133, '2015-01-15 00:55:02.000000', 'consum', 0.0243, 'lps'),
	(653688, 133, '2015-01-15 00:55:03.000000', 'consum', 0.0269, 'lps'),
	(653689, 133, '2015-01-15 00:55:04.000000', 'consum', 0.0406, 'lps'),
	(653690, 133, '2015-01-15 00:55:05.000000', 'consum', 0.0364, 'lps'),
	(653691, 133, '2015-01-15 00:55:06.000000', 'consum', 0.0393, 'lps'),
	(653692, 133, '2015-01-15 00:55:07.000000', 'consum', 0.0228, 'lps'),
	(653693, 133, '2015-01-15 00:55:08.000000', 'consum', 0.0405, 'lps'),
	(653694, 133, '2015-01-15 00:55:09.000000', 'consum', 0.0262, 'lps'),
	(653695, 133, '2015-01-15 00:55:10.000000', 'consum', 0.0318, 'lps'),
	(653696, 133, '2015-01-15 00:55:11.000000', 'consum', 0.0379, 'lps'),
	(653697, 133, '2015-01-15 00:55:12.000000', 'consum', 0.0298, 'lps'),
	(653698, 133, '2015-01-15 00:55:13.000000', 'consum', 0.0359, 'lps'),
	(653699, 133, '2015-01-15 00:55:14.000000', 'consum', 0.0257, 'lps'),
	(653700, 133, '2015-01-15 00:55:15.000000', 'consum', 0.0215, 'lps'),
	(653701, 133, '2015-01-15 00:55:16.000000', 'consum', 0.0311, 'lps'),
	(653702, 133, '2015-01-15 00:55:17.000000', 'consum', 0.0268, 'lps'),
	(653703, 133, '2015-01-15 00:55:18.000000', 'consum', 0.0412, 'lps'),
	(653704, 133, '2015-01-15 00:55:19.000000', 'consum', 0.0397, 'lps'),
	(653705, 133, '2015-01-15 00:55:20.000000', 'consum', 0.0323, 'lps'),
	(653706, 133, '2015-01-15 00:55:21.000000', 'consum', 0.0216, 'lps'),
	(653707, 133, '2015-01-15 00:55:22.000000', 'consum', 0.0332, 'lps'),
	(653708, 133, '2015-01-15 00:55:23.000000', 'consum', 0.0371, 'lps'),
	(653709, 133, '2015-01-15 00:55:24.000000', 'consum', 0.0214, 'lps'),
	(653710, 133, '2015-01-15 00:55:25.000000', 'consum', 0.0397, 'lps'),
	(653711, 133, '2015-01-15 00:55:26.000000', 'consum', 0.0268, 'lps'),
	(653712, 133, '2015-01-15 00:55:27.000000', 'consum', 0.0373, 'lps'),
	(653713, 133, '2015-01-15 00:55:28.000000', 'consum', 0.0415, 'lps'),
	(653714, 133, '2015-01-15 00:55:29.000000', 'consum', 0.0316, 'lps'),
	(653715, 133, '2015-01-15 00:55:30.000000', 'consum', 0.0341, 'lps'),
	(653716, 133, '2015-01-15 00:55:31.000000', 'consum', 0.0330, 'lps'),
	(653717, 133, '2015-01-15 00:55:32.000000', 'consum', 0.0419, 'lps'),
	(653718, 133, '2015-01-15 00:55:33.000000', 'consum', 0.0243, 'lps'),
	(653719, 133, '2015-01-15 00:55:34.000000', 'consum', 0.0399, 'lps'),
	(653720, 133, '2015-01-15 00:55:35.000000', 'consum', 0.0406, 'lps'),
	(653721, 133, '2015-01-15 00:55:36.000000', 'consum', 0.0408, 'lps'),
	(653722, 133, '2015-01-15 00:55:37.000000', 'consum', 0.0393, 'lps'),
	(653723, 133, '2015-01-15 00:55:38.000000', 'consum', 0.0317, 'lps'),
	(653724, 133, '2015-01-15 00:55:39.000000', 'consum', 0.0411, 'lps'),
	(653725, 133, '2015-01-15 00:55:40.000000', 'consum', 0.0244, 'lps'),
	(653726, 133, '2015-01-15 00:55:41.000000', 'consum', 0.0213, 'lps'),
	(653727, 133, '2015-01-15 00:55:42.000000', 'consum', 0.0341, 'lps'),
	(653728, 133, '2015-01-15 00:55:43.000000', 'consum', 0.0421, 'lps'),
	(653729, 133, '2015-01-15 00:55:44.000000', 'consum', 0.0220, 'lps'),
	(653730, 133, '2015-01-15 00:55:45.000000', 'consum', 0.0279, 'lps'),
	(653731, 133, '2015-01-15 00:55:46.000000', 'consum', 0.0309, 'lps'),
	(653732, 133, '2015-01-15 00:55:47.000000', 'consum', 0.0281, 'lps'),
	(653733, 133, '2015-01-15 00:55:48.000000', 'consum', 0.0269, 'lps'),
	(653734, 133, '2015-01-15 00:55:49.000000', 'consum', 0.0293, 'lps'),
	(653735, 133, '2015-01-15 00:55:50.000000', 'consum', 0.0229, 'lps'),
	(653736, 133, '2015-01-15 00:55:51.000000', 'consum', 0.0275, 'lps'),
	(653737, 133, '2015-01-15 00:55:52.000000', 'consum', 0.0261, 'lps'),
	(653738, 133, '2015-01-15 00:55:53.000000', 'consum', 0.0270, 'lps'),
	(653739, 133, '2015-01-15 00:55:54.000000', 'consum', 0.0359, 'lps'),
	(653740, 133, '2015-01-15 00:55:55.000000', 'consum', 0.0342, 'lps'),
	(653741, 133, '2015-01-15 00:55:56.000000', 'consum', 0.0424, 'lps'),
	(653742, 133, '2015-01-15 00:55:57.000000', 'consum', 0.0234, 'lps'),
	(653743, 133, '2015-01-15 00:55:58.000000', 'consum', 0.0337, 'lps'),
	(653744, 133, '2015-01-15 00:55:59.000000', 'consum', 0.0342, 'lps'),
	(653745, 133, '2015-01-15 00:56:00.000000', 'consum', 0.0270, 'lps'),
	(653746, 133, '2015-01-15 00:56:01.000000', 'consum', 0.0334, 'lps'),
	(653747, 133, '2015-01-15 00:56:02.000000', 'consum', 0.0215, 'lps'),
	(653748, 133, '2015-01-15 00:56:03.000000', 'consum', 0.0297, 'lps'),
	(653749, 133, '2015-01-15 00:56:04.000000', 'consum', 0.0415, 'lps'),
	(653750, 133, '2015-01-15 00:56:05.000000', 'consum', 0.0325, 'lps'),
	(653751, 133, '2015-01-15 00:56:06.000000', 'consum', 0.0384, 'lps'),
	(653752, 133, '2015-01-15 00:56:07.000000', 'consum', 0.0304, 'lps'),
	(653753, 133, '2015-01-15 00:56:08.000000', 'consum', 0.0376, 'lps'),
	(653754, 133, '2015-01-15 00:56:09.000000', 'consum', 0.0322, 'lps'),
	(653755, 133, '2015-01-15 00:56:10.000000', 'consum', 0.0273, 'lps'),
	(653756, 133, '2015-01-15 00:56:11.000000', 'consum', 0.0406, 'lps'),
	(653757, 133, '2015-01-15 00:56:12.000000', 'consum', 0.0353, 'lps'),
	(653758, 133, '2015-01-15 00:56:13.000000', 'consum', 0.0337, 'lps'),
	(653759, 133, '2015-01-15 00:56:14.000000', 'consum', 0.0416, 'lps'),
	(653760, 133, '2015-01-15 00:56:15.000000', 'consum', 0.0424, 'lps'),
	(653761, 133, '2015-01-15 00:56:16.000000', 'consum', 0.0230, 'lps'),
	(653762, 133, '2015-01-15 00:56:17.000000', 'consum', 0.0319, 'lps'),
	(653763, 133, '2015-01-15 00:56:18.000000', 'consum', 0.0261, 'lps'),
	(653764, 133, '2015-01-15 00:56:19.000000', 'consum', 0.0356, 'lps'),
	(653765, 133, '2015-01-15 00:56:20.000000', 'consum', 0.0355, 'lps'),
	(653766, 133, '2015-01-15 00:56:21.000000', 'consum', 0.0279, 'lps'),
	(653767, 133, '2015-01-15 00:56:22.000000', 'consum', 0.0337, 'lps'),
	(653768, 133, '2015-01-15 00:56:23.000000', 'consum', 0.0420, 'lps'),
	(653769, 133, '2015-01-15 00:56:24.000000', 'consum', 0.0231, 'lps'),
	(653770, 133, '2015-01-15 00:56:25.000000', 'consum', 0.0337, 'lps'),
	(653771, 133, '2015-01-15 00:56:26.000000', 'consum', 0.0350, 'lps'),
	(653772, 133, '2015-01-15 00:56:27.000000', 'consum', 0.0309, 'lps'),
	(653773, 133, '2015-01-15 00:56:28.000000', 'consum', 0.0288, 'lps'),
	(653774, 133, '2015-01-15 00:56:29.000000', 'consum', 0.0301, 'lps'),
	(653775, 133, '2015-01-15 00:56:30.000000', 'consum', 0.0214, 'lps'),
	(653776, 133, '2015-01-15 00:56:31.000000', 'consum', 0.0392, 'lps'),
	(653777, 133, '2015-01-15 00:56:32.000000', 'consum', 0.0239, 'lps'),
	(653778, 133, '2015-01-15 00:56:33.000000', 'consum', 0.0245, 'lps'),
	(653779, 133, '2015-01-15 00:56:34.000000', 'consum', 0.0299, 'lps'),
	(653780, 133, '2015-01-15 00:56:35.000000', 'consum', 0.0335, 'lps'),
	(653781, 133, '2015-01-15 00:56:36.000000', 'consum', 0.0351, 'lps'),
	(653782, 133, '2015-01-15 00:56:37.000000', 'consum', 0.0321, 'lps'),
	(653783, 133, '2015-01-15 00:56:38.000000', 'consum', 0.0345, 'lps'),
	(653784, 133, '2015-01-15 00:56:39.000000', 'consum', 0.0336, 'lps'),
	(653785, 133, '2015-01-15 00:56:40.000000', 'consum', 0.0216, 'lps'),
	(653786, 133, '2015-01-15 00:56:41.000000', 'consum', 0.0298, 'lps'),
	(653787, 133, '2015-01-15 00:56:42.000000', 'consum', 0.0414, 'lps'),
	(653788, 133, '2015-01-15 00:56:43.000000', 'consum', 0.0317, 'lps'),
	(653789, 133, '2015-01-15 00:56:44.000000', 'consum', 0.0349, 'lps'),
	(653790, 133, '2015-01-15 00:56:45.000000', 'consum', 0.0368, 'lps'),
	(653791, 133, '2015-01-15 00:56:46.000000', 'consum', 0.0366, 'lps'),
	(653792, 133, '2015-01-15 00:56:47.000000', 'consum', 0.0298, 'lps'),
	(653793, 133, '2015-01-15 00:56:48.000000', 'consum', 0.0402, 'lps'),
	(653794, 133, '2015-01-15 00:56:49.000000', 'consum', 0.0257, 'lps'),
	(653795, 133, '2015-01-15 00:56:50.000000', 'consum', 0.0300, 'lps'),
	(653796, 133, '2015-01-15 00:56:51.000000', 'consum', 0.0305, 'lps'),
	(653797, 133, '2015-01-15 00:56:52.000000', 'consum', 0.0414, 'lps'),
	(653798, 133, '2015-01-15 00:56:53.000000', 'consum', 0.0294, 'lps'),
	(653799, 133, '2015-01-15 00:56:54.000000', 'consum', 0.0238, 'lps'),
	(653800, 133, '2015-01-15 00:56:55.000000', 'consum', 0.0315, 'lps'),
	(653801, 133, '2015-01-15 00:56:56.000000', 'consum', 0.0216, 'lps'),
	(653802, 133, '2015-01-15 00:56:57.000000', 'consum', 0.0362, 'lps'),
	(653803, 133, '2015-01-15 00:56:58.000000', 'consum', 0.0299, 'lps'),
	(653804, 133, '2015-01-15 00:56:59.000000', 'consum', 0.0417, 'lps'),
	(653805, 133, '2015-01-15 00:57:00.000000', 'consum', 0.0328, 'lps'),
	(653806, 133, '2015-01-15 00:57:01.000000', 'consum', 0.0397, 'lps'),
	(653807, 133, '2015-01-15 00:57:02.000000', 'consum', 0.0357, 'lps'),
	(653808, 133, '2015-01-15 00:57:03.000000', 'consum', 0.0385, 'lps'),
	(653809, 133, '2015-01-15 00:57:04.000000', 'consum', 0.0210, 'lps'),
	(653810, 133, '2015-01-15 00:57:05.000000', 'consum', 0.0337, 'lps'),
	(653811, 133, '2015-01-15 00:57:06.000000', 'consum', 0.0412, 'lps'),
	(653812, 133, '2015-01-15 00:57:07.000000', 'consum', 0.0404, 'lps'),
	(653813, 133, '2015-01-15 00:57:08.000000', 'consum', 0.0359, 'lps'),
	(653814, 133, '2015-01-15 00:57:09.000000', 'consum', 0.0372, 'lps'),
	(653815, 133, '2015-01-15 00:57:10.000000', 'consum', 0.0356, 'lps'),
	(653816, 133, '2015-01-15 00:57:11.000000', 'consum', 0.0238, 'lps'),
	(653817, 133, '2015-01-15 00:57:12.000000', 'consum', 0.0346, 'lps'),
	(653818, 133, '2015-01-15 00:57:13.000000', 'consum', 0.0372, 'lps'),
	(653819, 133, '2015-01-15 00:57:14.000000', 'consum', 0.0398, 'lps'),
	(653820, 133, '2015-01-15 00:57:15.000000', 'consum', 0.0227, 'lps'),
	(653821, 133, '2015-01-15 00:57:16.000000', 'consum', 0.0385, 'lps'),
	(653822, 133, '2015-01-15 00:57:17.000000', 'consum', 0.0381, 'lps'),
	(653823, 133, '2015-01-15 00:57:18.000000', 'consum', 0.0325, 'lps'),
	(653824, 133, '2015-01-15 00:57:19.000000', 'consum', 0.0272, 'lps'),
	(653825, 133, '2015-01-15 00:57:20.000000', 'consum', 0.0392, 'lps'),
	(653826, 133, '2015-01-15 00:57:21.000000', 'consum', 0.0282, 'lps'),
	(653827, 133, '2015-01-15 00:57:22.000000', 'consum', 0.0244, 'lps'),
	(653828, 133, '2015-01-15 00:57:23.000000', 'consum', 0.0379, 'lps'),
	(653829, 133, '2015-01-15 00:57:24.000000', 'consum', 0.0304, 'lps'),
	(653830, 133, '2015-01-15 00:57:25.000000', 'consum', 0.0392, 'lps'),
	(653831, 133, '2015-01-15 00:57:26.000000', 'consum', 0.0404, 'lps'),
	(653832, 133, '2015-01-15 00:57:27.000000', 'consum', 0.0416, 'lps'),
	(653833, 133, '2015-01-15 00:57:28.000000', 'consum', 0.0224, 'lps'),
	(653834, 133, '2015-01-15 00:57:29.000000', 'consum', 0.0313, 'lps'),
	(653835, 133, '2015-01-15 00:57:30.000000', 'consum', 0.0252, 'lps'),
	(653836, 133, '2015-01-15 00:57:31.000000', 'consum', 0.0326, 'lps'),
	(653837, 133, '2015-01-15 00:57:32.000000', 'consum', 0.0232, 'lps'),
	(653838, 133, '2015-01-15 00:57:33.000000', 'consum', 0.0407, 'lps'),
	(653839, 133, '2015-01-15 00:57:34.000000', 'consum', 0.0261, 'lps'),
	(653840, 133, '2015-01-15 00:57:35.000000', 'consum', 0.0307, 'lps'),
	(653841, 133, '2015-01-15 00:57:36.000000', 'consum', 0.0325, 'lps'),
	(653842, 133, '2015-01-15 00:57:37.000000', 'consum', 0.0281, 'lps'),
	(653843, 133, '2015-01-15 00:57:38.000000', 'consum', 0.0217, 'lps'),
	(653844, 133, '2015-01-15 00:57:39.000000', 'consum', 0.0250, 'lps'),
	(653845, 133, '2015-01-15 00:57:40.000000', 'consum', 0.0391, 'lps'),
	(653846, 133, '2015-01-15 00:57:41.000000', 'consum', 0.0346, 'lps'),
	(653847, 133, '2015-01-15 00:57:42.000000', 'consum', 0.0345, 'lps'),
	(653848, 133, '2015-01-15 00:57:43.000000', 'consum', 0.0263, 'lps'),
	(653849, 133, '2015-01-15 00:57:44.000000', 'consum', 0.0287, 'lps'),
	(653850, 133, '2015-01-15 00:57:45.000000', 'consum', 0.0221, 'lps'),
	(653851, 133, '2015-01-15 00:57:46.000000', 'consum', 0.0250, 'lps'),
	(653852, 133, '2015-01-15 00:57:47.000000', 'consum', 0.0379, 'lps'),
	(653853, 133, '2015-01-15 00:57:48.000000', 'consum', 0.0286, 'lps'),
	(653854, 133, '2015-01-15 00:57:49.000000', 'consum', 0.0297, 'lps'),
	(653855, 133, '2015-01-15 00:57:50.000000', 'consum', 0.0418, 'lps'),
	(653856, 133, '2015-01-15 00:57:51.000000', 'consum', 0.0340, 'lps'),
	(653857, 133, '2015-01-15 00:57:52.000000', 'consum', 0.0234, 'lps'),
	(653858, 133, '2015-01-15 00:57:53.000000', 'consum', 0.0376, 'lps'),
	(653859, 133, '2015-01-15 00:57:54.000000', 'consum', 0.0317, 'lps'),
	(653860, 133, '2015-01-15 00:57:55.000000', 'consum', 0.0248, 'lps'),
	(653861, 133, '2015-01-15 00:57:56.000000', 'consum', 0.0295, 'lps'),
	(653862, 133, '2015-01-15 00:57:57.000000', 'consum', 0.0304, 'lps'),
	(653863, 133, '2015-01-15 00:57:58.000000', 'consum', 0.0211, 'lps'),
	(653864, 133, '2015-01-15 00:57:59.000000', 'consum', 0.0368, 'lps'),
	(653865, 133, '2015-01-15 00:58:00.000000', 'consum', 0.0344, 'lps'),
	(653866, 133, '2015-01-15 00:58:01.000000', 'consum', 0.0407, 'lps'),
	(653867, 133, '2015-01-15 00:58:02.000000', 'consum', 0.0359, 'lps'),
	(653868, 133, '2015-01-15 00:58:03.000000', 'consum', 0.0365, 'lps'),
	(653869, 133, '2015-01-15 00:58:04.000000', 'consum', 0.0320, 'lps'),
	(653870, 133, '2015-01-15 00:58:05.000000', 'consum', 0.0295, 'lps'),
	(653871, 133, '2015-01-15 00:58:06.000000', 'consum', 0.0306, 'lps'),
	(653872, 133, '2015-01-15 00:58:07.000000', 'consum', 0.0219, 'lps'),
	(653873, 133, '2015-01-15 00:58:08.000000', 'consum', 0.0403, 'lps'),
	(653874, 133, '2015-01-15 00:58:09.000000', 'consum', 0.0279, 'lps'),
	(653875, 133, '2015-01-15 00:58:10.000000', 'consum', 0.0410, 'lps'),
	(653876, 133, '2015-01-15 00:58:11.000000', 'consum', 0.0355, 'lps'),
	(653877, 133, '2015-01-15 00:58:12.000000', 'consum', 0.0334, 'lps'),
	(653878, 133, '2015-01-15 00:58:13.000000', 'consum', 0.0395, 'lps'),
	(653879, 133, '2015-01-15 00:58:14.000000', 'consum', 0.0331, 'lps'),
	(653880, 133, '2015-01-15 00:58:15.000000', 'consum', 0.0260, 'lps'),
	(653881, 133, '2015-01-15 00:58:16.000000', 'consum', 0.0315, 'lps'),
	(653882, 133, '2015-01-15 00:58:17.000000', 'consum', 0.0370, 'lps'),
	(653883, 133, '2015-01-15 00:58:18.000000', 'consum', 0.0258, 'lps'),
	(653884, 133, '2015-01-15 00:58:19.000000', 'consum', 0.0407, 'lps'),
	(653885, 133, '2015-01-15 00:58:20.000000', 'consum', 0.0401, 'lps'),
	(653886, 133, '2015-01-15 00:58:21.000000', 'consum', 0.0357, 'lps'),
	(653887, 133, '2015-01-15 00:58:22.000000', 'consum', 0.0372, 'lps'),
	(653888, 133, '2015-01-15 00:58:23.000000', 'consum', 0.0361, 'lps'),
	(653889, 133, '2015-01-15 00:58:24.000000', 'consum', 0.0263, 'lps'),
	(653890, 133, '2015-01-15 00:58:25.000000', 'consum', 0.0241, 'lps'),
	(653891, 133, '2015-01-15 00:58:26.000000', 'consum', 0.0421, 'lps'),
	(653892, 133, '2015-01-15 00:58:27.000000', 'consum', 0.0304, 'lps'),
	(653893, 133, '2015-01-15 00:58:28.000000', 'consum', 0.0267, 'lps'),
	(653894, 133, '2015-01-15 00:58:29.000000', 'consum', 0.0214, 'lps'),
	(653895, 133, '2015-01-15 00:58:30.000000', 'consum', 0.0274, 'lps'),
	(653896, 133, '2015-01-15 00:58:31.000000', 'consum', 0.0303, 'lps'),
	(653897, 133, '2015-01-15 00:58:32.000000', 'consum', 0.0265, 'lps'),
	(653898, 133, '2015-01-15 00:58:33.000000', 'consum', 0.0424, 'lps'),
	(653899, 133, '2015-01-15 00:58:34.000000', 'consum', 0.0246, 'lps'),
	(653900, 133, '2015-01-15 00:58:35.000000', 'consum', 0.0401, 'lps'),
	(653901, 133, '2015-01-15 00:58:36.000000', 'consum', 0.0407, 'lps'),
	(653902, 133, '2015-01-15 00:58:37.000000', 'consum', 0.0403, 'lps'),
	(653903, 133, '2015-01-15 00:58:38.000000', 'consum', 0.0371, 'lps'),
	(653904, 133, '2015-01-15 00:58:39.000000', 'consum', 0.0218, 'lps'),
	(653905, 133, '2015-01-15 00:58:40.000000', 'consum', 0.0417, 'lps'),
	(653906, 134, '2015-01-15 00:00:00.000000', 'consum', 0.0281, 'lps'),
	(653907, 134, '2015-01-15 00:00:01.000000', 'consum', 0.0332, 'lps'),
	(653908, 134, '2015-01-15 00:00:02.000000', 'consum', 0.0292, 'lps'),
	(653909, 134, '2015-01-15 00:00:03.000000', 'consum', 0.0253, 'lps'),
	(653910, 134, '2015-01-15 00:00:04.000000', 'consum', 0.0337, 'lps'),
	(653911, 134, '2015-01-15 00:00:05.000000', 'consum', 0.0244, 'lps'),
	(653912, 134, '2015-01-15 00:00:06.000000', 'consum', 0.0314, 'lps'),
	(653913, 134, '2015-01-15 00:00:07.000000', 'consum', 0.0314, 'lps'),
	(653914, 134, '2015-01-15 00:00:08.000000', 'consum', 0.0259, 'lps'),
	(653915, 134, '2015-01-15 00:00:09.000000', 'consum', 0.0302, 'lps'),
	(653916, 134, '2015-01-15 00:00:10.000000', 'consum', 0.0365, 'lps'),
	(653917, 134, '2015-01-15 00:00:11.000000', 'consum', 0.0236, 'lps'),
	(653918, 134, '2015-01-15 00:00:12.000000', 'consum', 0.0348, 'lps'),
	(653919, 134, '2015-01-15 00:00:13.000000', 'consum', 0.0350, 'lps'),
	(653920, 134, '2015-01-15 00:00:14.000000', 'consum', 0.0339, 'lps'),
	(653921, 134, '2015-01-15 00:00:15.000000', 'consum', 0.0277, 'lps'),
	(653922, 134, '2015-01-15 00:00:16.000000', 'consum', 0.0314, 'lps'),
	(653923, 134, '2015-01-15 00:00:17.000000', 'consum', 0.0217, 'lps'),
	(653924, 134, '2015-01-15 00:00:18.000000', 'consum', 0.0247, 'lps'),
	(653925, 134, '2015-01-15 00:00:19.000000', 'consum', 0.0217, 'lps'),
	(653926, 134, '2015-01-15 00:00:20.000000', 'consum', 0.0291, 'lps'),
	(653927, 134, '2015-01-15 00:00:21.000000', 'consum', 0.0281, 'lps'),
	(653928, 134, '2015-01-15 00:00:22.000000', 'consum', 0.0321, 'lps'),
	(653929, 134, '2015-01-15 00:00:23.000000', 'consum', 0.0236, 'lps'),
	(653930, 134, '2015-01-15 00:00:24.000000', 'consum', 0.0323, 'lps'),
	(653931, 134, '2015-01-15 00:00:25.000000', 'consum', 0.0223, 'lps'),
	(653932, 134, '2015-01-15 00:00:26.000000', 'consum', 0.0253, 'lps'),
	(653933, 134, '2015-01-15 00:00:27.000000', 'consum', 0.0229, 'lps'),
	(653934, 134, '2015-01-15 00:00:28.000000', 'consum', 0.0334, 'lps'),
	(653935, 134, '2015-01-15 00:00:29.000000', 'consum', 0.0301, 'lps'),
	(653936, 134, '2015-01-15 00:00:30.000000', 'consum', 0.0292, 'lps'),
	(653937, 134, '2015-01-15 00:00:31.000000', 'consum', 0.0347, 'lps'),
	(653938, 134, '2015-01-15 00:00:32.000000', 'consum', 0.0333, 'lps'),
	(653939, 134, '2015-01-15 00:00:33.000000', 'consum', 0.0256, 'lps'),
	(653940, 134, '2015-01-15 00:00:34.000000', 'consum', 0.0230, 'lps'),
	(653941, 134, '2015-01-15 00:00:35.000000', 'consum', 0.0329, 'lps'),
	(653942, 134, '2015-01-15 00:00:36.000000', 'consum', 0.0275, 'lps'),
	(653943, 134, '2015-01-15 00:00:37.000000', 'consum', 0.0334, 'lps'),
	(653944, 134, '2015-01-15 00:00:38.000000', 'consum', 0.0320, 'lps'),
	(653945, 134, '2015-01-15 00:00:39.000000', 'consum', 0.0231, 'lps'),
	(653946, 134, '2015-01-15 00:00:40.000000', 'consum', 0.0303, 'lps'),
	(653947, 134, '2015-01-15 00:00:41.000000', 'consum', 0.0296, 'lps'),
	(653948, 134, '2015-01-15 00:00:42.000000', 'consum', 0.0361, 'lps'),
	(653949, 134, '2015-01-15 00:00:43.000000', 'consum', 0.0234, 'lps'),
	(653950, 134, '2015-01-15 00:00:44.000000', 'consum', 0.0351, 'lps'),
	(653951, 134, '2015-01-15 00:00:45.000000', 'consum', 0.0211, 'lps'),
	(653952, 134, '2015-01-15 00:00:46.000000', 'consum', 0.0268, 'lps'),
	(653953, 134, '2015-01-15 00:00:47.000000', 'consum', 0.0341, 'lps'),
	(653954, 134, '2015-01-15 00:00:48.000000', 'consum', 0.0215, 'lps'),
	(653955, 134, '2015-01-15 00:00:49.000000', 'consum', 0.0317, 'lps'),
	(653956, 134, '2015-01-15 00:00:50.000000', 'consum', 0.0257, 'lps'),
	(653957, 134, '2015-01-15 00:00:51.000000', 'consum', 0.0282, 'lps'),
	(653958, 134, '2015-01-15 00:00:52.000000', 'consum', 0.0273, 'lps'),
	(653959, 134, '2015-01-15 00:00:53.000000', 'consum', 0.0309, 'lps'),
	(653960, 134, '2015-01-15 00:00:54.000000', 'consum', 0.0358, 'lps'),
	(653961, 134, '2015-01-15 00:00:55.000000', 'consum', 0.0336, 'lps'),
	(653962, 134, '2015-01-15 00:00:56.000000', 'consum', 0.0239, 'lps'),
	(653963, 134, '2015-01-15 00:00:57.000000', 'consum', 0.0296, 'lps'),
	(653964, 134, '2015-01-15 00:00:58.000000', 'consum', 0.0235, 'lps'),
	(653965, 134, '2015-01-15 00:00:59.000000', 'consum', 0.0234, 'lps'),
	(653966, 134, '2015-01-15 00:01:00.000000', 'consum', 0.0258, 'lps'),
	(653967, 134, '2015-01-15 00:01:01.000000', 'consum', 0.0220, 'lps'),
	(653968, 134, '2015-01-15 00:01:02.000000', 'consum', 0.0276, 'lps'),
	(653969, 134, '2015-01-15 00:01:03.000000', 'consum', 0.0349, 'lps'),
	(653970, 134, '2015-01-15 00:01:04.000000', 'consum', 0.0236, 'lps'),
	(653971, 134, '2015-01-15 00:01:05.000000', 'consum', 0.0240, 'lps'),
	(653972, 134, '2015-01-15 00:01:06.000000', 'consum', 0.0284, 'lps'),
	(653973, 134, '2015-01-15 00:01:07.000000', 'consum', 0.0330, 'lps'),
	(653974, 134, '2015-01-15 00:01:08.000000', 'consum', 0.0274, 'lps'),
	(653975, 134, '2015-01-15 00:01:09.000000', 'consum', 0.0327, 'lps'),
	(653976, 134, '2015-01-15 00:01:10.000000', 'consum', 0.0288, 'lps'),
	(653977, 134, '2015-01-15 00:01:11.000000', 'consum', 0.0248, 'lps'),
	(653978, 134, '2015-01-15 00:01:12.000000', 'consum', 0.0325, 'lps'),
	(653979, 134, '2015-01-15 00:01:13.000000', 'consum', 0.0358, 'lps'),
	(653980, 134, '2015-01-15 00:01:14.000000', 'consum', 0.0287, 'lps'),
	(653981, 134, '2015-01-15 00:01:15.000000', 'consum', 0.0312, 'lps'),
	(653982, 134, '2015-01-15 00:01:16.000000', 'consum', 0.0331, 'lps'),
	(653983, 134, '2015-01-15 00:01:17.000000', 'consum', 0.0351, 'lps'),
	(653984, 134, '2015-01-15 00:01:18.000000', 'consum', 0.0235, 'lps'),
	(653985, 134, '2015-01-15 00:01:19.000000', 'consum', 0.0231, 'lps'),
	(653986, 134, '2015-01-15 00:01:20.000000', 'consum', 0.0239, 'lps'),
	(653987, 134, '2015-01-15 00:01:21.000000', 'consum', 0.0292, 'lps'),
	(653988, 134, '2015-01-15 00:01:22.000000', 'consum', 0.0217, 'lps'),
	(653989, 134, '2015-01-15 00:01:23.000000', 'consum', 0.0318, 'lps'),
	(653990, 134, '2015-01-15 00:01:24.000000', 'consum', 0.0255, 'lps'),
	(653991, 134, '2015-01-15 00:01:25.000000', 'consum', 0.0269, 'lps'),
	(653992, 134, '2015-01-15 00:01:26.000000', 'consum', 0.0214, 'lps'),
	(653993, 134, '2015-01-15 00:01:27.000000', 'consum', 0.0211, 'lps'),
	(653994, 134, '2015-01-15 00:01:28.000000', 'consum', 0.0363, 'lps'),
	(653995, 134, '2015-01-15 00:01:29.000000', 'consum', 0.0339, 'lps'),
	(653996, 134, '2015-01-15 00:01:30.000000', 'consum', 0.0239, 'lps'),
	(653997, 134, '2015-01-15 00:01:31.000000', 'consum', 0.0284, 'lps'),
	(653998, 134, '2015-01-15 00:01:32.000000', 'consum', 0.0335, 'lps'),
	(653999, 134, '2015-01-15 00:01:33.000000', 'consum', 0.0298, 'lps'),
	(654000, 134, '2015-01-15 00:01:34.000000', 'consum', 0.0277, 'lps'),
	(654001, 134, '2015-01-15 00:01:35.000000', 'consum', 0.0279, 'lps'),
	(654002, 134, '2015-01-15 00:01:36.000000', 'consum', 0.0354, 'lps'),
	(654003, 134, '2015-01-15 00:01:37.000000', 'consum', 0.0252, 'lps'),
	(654004, 134, '2015-01-15 00:01:38.000000', 'consum', 0.0302, 'lps'),
	(654005, 134, '2015-01-15 00:01:39.000000', 'consum', 0.0232, 'lps'),
	(654006, 134, '2015-01-15 00:01:40.000000', 'consum', 0.0357, 'lps'),
	(654007, 134, '2015-01-15 00:01:41.000000', 'consum', 0.0249, 'lps'),
	(654008, 134, '2015-01-15 00:01:42.000000', 'consum', 0.0280, 'lps'),
	(654009, 134, '2015-01-15 00:01:43.000000', 'consum', 0.0285, 'lps'),
	(654010, 134, '2015-01-15 00:01:44.000000', 'consum', 0.0216, 'lps'),
	(654011, 134, '2015-01-15 00:01:45.000000', 'consum', 0.0334, 'lps'),
	(654012, 134, '2015-01-15 00:01:46.000000', 'consum', 0.0339, 'lps'),
	(654013, 134, '2015-01-15 00:01:47.000000', 'consum', 0.0326, 'lps'),
	(654014, 134, '2015-01-15 00:01:48.000000', 'consum', 0.0246, 'lps'),
	(654015, 134, '2015-01-15 00:01:49.000000', 'consum', 0.0356, 'lps'),
	(654016, 134, '2015-01-15 00:01:50.000000', 'consum', 0.0357, 'lps'),
	(654017, 134, '2015-01-15 00:01:51.000000', 'consum', 0.0353, 'lps'),
	(654018, 134, '2015-01-15 00:01:52.000000', 'consum', 0.0325, 'lps'),
	(654019, 134, '2015-01-15 00:01:53.000000', 'consum', 0.0358, 'lps'),
	(654020, 134, '2015-01-15 00:01:54.000000', 'consum', 0.0289, 'lps'),
	(654021, 134, '2015-01-15 00:01:55.000000', 'consum', 0.0321, 'lps'),
	(654022, 134, '2015-01-15 00:01:56.000000', 'consum', 0.0211, 'lps'),
	(654023, 134, '2015-01-15 00:01:57.000000', 'consum', 0.0355, 'lps'),
	(654024, 134, '2015-01-15 00:01:58.000000', 'consum', 0.0302, 'lps'),
	(654025, 134, '2015-01-15 00:01:59.000000', 'consum', 0.0237, 'lps'),
	(654026, 134, '2015-01-15 00:02:00.000000', 'consum', 0.0225, 'lps'),
	(654027, 134, '2015-01-15 00:02:01.000000', 'consum', 0.0361, 'lps'),
	(654028, 134, '2015-01-15 00:02:02.000000', 'consum', 0.0291, 'lps'),
	(654029, 134, '2015-01-15 00:02:03.000000', 'consum', 0.0322, 'lps'),
	(654030, 134, '2015-01-15 00:02:04.000000', 'consum', 0.0367, 'lps'),
	(654031, 134, '2015-01-15 00:02:05.000000', 'consum', 0.0343, 'lps'),
	(654032, 134, '2015-01-15 00:02:06.000000', 'consum', 0.0249, 'lps'),
	(654033, 134, '2015-01-15 00:02:07.000000', 'consum', 0.0323, 'lps'),
	(654034, 134, '2015-01-15 00:02:08.000000', 'consum', 0.0343, 'lps'),
	(654035, 134, '2015-01-15 00:02:09.000000', 'consum', 0.0218, 'lps'),
	(654036, 134, '2015-01-15 00:02:10.000000', 'consum', 0.0327, 'lps'),
	(654037, 134, '2015-01-15 00:02:11.000000', 'consum', 0.0296, 'lps'),
	(654038, 134, '2015-01-15 00:02:12.000000', 'consum', 0.0288, 'lps'),
	(654039, 134, '2015-01-15 00:02:13.000000', 'consum', 0.0346, 'lps'),
	(654040, 134, '2015-01-15 00:02:14.000000', 'consum', 0.0338, 'lps'),
	(654041, 134, '2015-01-15 00:02:15.000000', 'consum', 0.0285, 'lps'),
	(654042, 134, '2015-01-15 00:02:16.000000', 'consum', 0.0359, 'lps'),
	(654043, 134, '2015-01-15 00:02:17.000000', 'consum', 0.0258, 'lps'),
	(654044, 134, '2015-01-15 00:02:18.000000', 'consum', 0.0321, 'lps'),
	(654045, 134, '2015-01-15 00:02:19.000000', 'consum', 0.0303, 'lps'),
	(654046, 134, '2015-01-15 00:02:20.000000', 'consum', 0.0343, 'lps'),
	(654047, 134, '2015-01-15 00:02:21.000000', 'consum', 0.0281, 'lps'),
	(654048, 134, '2015-01-15 00:02:22.000000', 'consum', 0.0325, 'lps'),
	(654049, 134, '2015-01-15 00:02:23.000000', 'consum', 0.0256, 'lps'),
	(654050, 134, '2015-01-15 00:02:24.000000', 'consum', 0.0253, 'lps'),
	(654051, 134, '2015-01-15 00:02:25.000000', 'consum', 0.0288, 'lps'),
	(654052, 134, '2015-01-15 00:02:26.000000', 'consum', 0.0314, 'lps'),
	(654053, 134, '2015-01-15 00:02:27.000000', 'consum', 0.0339, 'lps'),
	(654054, 134, '2015-01-15 00:02:28.000000', 'consum', 0.0229, 'lps'),
	(654055, 134, '2015-01-15 00:02:29.000000', 'consum', 0.0232, 'lps'),
	(654056, 134, '2015-01-15 00:02:30.000000', 'consum', 0.0264, 'lps'),
	(654057, 134, '2015-01-15 00:02:31.000000', 'consum', 0.0256, 'lps'),
	(654058, 134, '2015-01-15 00:02:32.000000', 'consum', 0.0278, 'lps'),
	(654059, 134, '2015-01-15 00:02:33.000000', 'consum', 0.0256, 'lps'),
	(654060, 134, '2015-01-15 00:02:34.000000', 'consum', 0.0236, 'lps'),
	(654061, 134, '2015-01-15 00:02:35.000000', 'consum', 0.0359, 'lps'),
	(654062, 134, '2015-01-15 00:02:36.000000', 'consum', 0.0248, 'lps'),
	(654063, 134, '2015-01-15 00:02:37.000000', 'consum', 0.0270, 'lps'),
	(654064, 134, '2015-01-15 00:02:38.000000', 'consum', 0.0236, 'lps'),
	(654065, 134, '2015-01-15 00:02:39.000000', 'consum', 0.0321, 'lps'),
	(654066, 134, '2015-01-15 00:02:40.000000', 'consum', 0.0214, 'lps'),
	(654067, 134, '2015-01-15 00:02:41.000000', 'consum', 0.0213, 'lps'),
	(654068, 134, '2015-01-15 00:02:42.000000', 'consum', 0.0211, 'lps'),
	(654069, 134, '2015-01-15 00:02:43.000000', 'consum', 0.0367, 'lps'),
	(654070, 134, '2015-01-15 00:02:44.000000', 'consum', 0.0360, 'lps'),
	(654071, 134, '2015-01-15 00:02:45.000000', 'consum', 0.0329, 'lps'),
	(654072, 134, '2015-01-15 00:02:46.000000', 'consum', 0.0358, 'lps'),
	(654073, 134, '2015-01-15 00:02:47.000000', 'consum', 0.0279, 'lps'),
	(654074, 134, '2015-01-15 00:02:48.000000', 'consum', 0.0267, 'lps'),
	(654075, 134, '2015-01-15 00:02:49.000000', 'consum', 0.0289, 'lps'),
	(654076, 134, '2015-01-15 00:02:50.000000', 'consum', 0.0276, 'lps'),
	(654077, 134, '2015-01-15 00:02:51.000000', 'consum', 0.0305, 'lps'),
	(654078, 134, '2015-01-15 00:02:52.000000', 'consum', 0.0329, 'lps'),
	(654079, 134, '2015-01-15 00:02:53.000000', 'consum', 0.0362, 'lps'),
	(654080, 134, '2015-01-15 00:02:54.000000', 'consum', 0.0297, 'lps'),
	(654081, 134, '2015-01-15 00:02:55.000000', 'consum', 0.0350, 'lps'),
	(654082, 134, '2015-01-15 00:02:56.000000', 'consum', 0.0333, 'lps'),
	(654083, 134, '2015-01-15 00:02:57.000000', 'consum', 0.0246, 'lps'),
	(654084, 134, '2015-01-15 00:02:58.000000', 'consum', 0.0338, 'lps'),
	(654085, 134, '2015-01-15 00:02:59.000000', 'consum', 0.0269, 'lps'),
	(654086, 134, '2015-01-15 00:03:00.000000', 'consum', 0.0277, 'lps'),
	(654087, 134, '2015-01-15 00:03:01.000000', 'consum', 0.0214, 'lps'),
	(654088, 134, '2015-01-15 00:03:02.000000', 'consum', 0.0344, 'lps'),
	(654089, 134, '2015-01-15 00:03:03.000000', 'consum', 0.0236, 'lps'),
	(654090, 134, '2015-01-15 00:03:04.000000', 'consum', 0.0254, 'lps'),
	(654091, 134, '2015-01-15 00:03:05.000000', 'consum', 0.0351, 'lps'),
	(654092, 134, '2015-01-15 00:03:06.000000', 'consum', 0.0313, 'lps'),
	(654093, 134, '2015-01-15 00:03:07.000000', 'consum', 0.0299, 'lps'),
	(654094, 134, '2015-01-15 00:03:08.000000', 'consum', 0.0348, 'lps'),
	(654095, 134, '2015-01-15 00:03:09.000000', 'consum', 0.0319, 'lps'),
	(654096, 134, '2015-01-15 00:03:10.000000', 'consum', 0.0341, 'lps'),
	(654097, 134, '2015-01-15 00:03:11.000000', 'consum', 0.0221, 'lps'),
	(654098, 134, '2015-01-15 00:03:12.000000', 'consum', 0.0348, 'lps'),
	(654099, 134, '2015-01-15 00:03:13.000000', 'consum', 0.0237, 'lps'),
	(654100, 134, '2015-01-15 00:03:14.000000', 'consum', 0.0244, 'lps'),
	(654101, 134, '2015-01-15 00:03:15.000000', 'consum', 0.0301, 'lps'),
	(654102, 134, '2015-01-15 00:03:16.000000', 'consum', 0.0247, 'lps'),
	(654103, 134, '2015-01-15 00:03:17.000000', 'consum', 0.0280, 'lps'),
	(654104, 134, '2015-01-15 00:03:18.000000', 'consum', 0.0291, 'lps'),
	(654105, 134, '2015-01-15 00:03:19.000000', 'consum', 0.0250, 'lps'),
	(654106, 134, '2015-01-15 00:03:20.000000', 'consum', 0.0325, 'lps'),
	(654107, 134, '2015-01-15 00:03:21.000000', 'consum', 0.0348, 'lps'),
	(654108, 134, '2015-01-15 00:03:22.000000', 'consum', 0.0241, 'lps'),
	(654109, 134, '2015-01-15 00:03:23.000000', 'consum', 0.0267, 'lps'),
	(654110, 134, '2015-01-15 00:03:24.000000', 'consum', 0.0245, 'lps'),
	(654111, 134, '2015-01-15 00:03:25.000000', 'consum', 0.0215, 'lps'),
	(654112, 134, '2015-01-15 00:03:26.000000', 'consum', 0.0287, 'lps'),
	(654113, 134, '2015-01-15 00:03:27.000000', 'consum', 0.0267, 'lps'),
	(654114, 134, '2015-01-15 00:03:28.000000', 'consum', 0.0263, 'lps'),
	(654115, 134, '2015-01-15 00:03:29.000000', 'consum', 0.0303, 'lps'),
	(654116, 134, '2015-01-15 00:03:30.000000', 'consum', 0.0361, 'lps'),
	(654117, 134, '2015-01-15 00:03:31.000000', 'consum', 0.0211, 'lps'),
	(654118, 134, '2015-01-15 00:03:32.000000', 'consum', 0.0235, 'lps'),
	(654119, 134, '2015-01-15 00:03:33.000000', 'consum', 0.0334, 'lps'),
	(654120, 134, '2015-01-15 00:03:34.000000', 'consum', 0.0280, 'lps'),
	(654121, 134, '2015-01-15 00:03:35.000000', 'consum', 0.0349, 'lps'),
	(654122, 134, '2015-01-15 00:03:36.000000', 'consum', 0.0223, 'lps'),
	(654123, 134, '2015-01-15 00:03:37.000000', 'consum', 0.0329, 'lps'),
	(654124, 134, '2015-01-15 00:03:38.000000', 'consum', 0.0293, 'lps'),
	(654125, 134, '2015-01-15 00:03:39.000000', 'consum', 0.0268, 'lps'),
	(654126, 134, '2015-01-15 00:03:40.000000', 'consum', 0.0251, 'lps'),
	(654127, 134, '2015-01-15 00:03:41.000000', 'consum', 0.0244, 'lps'),
	(654128, 134, '2015-01-15 00:03:42.000000', 'consum', 0.0257, 'lps'),
	(654129, 134, '2015-01-15 00:03:43.000000', 'consum', 0.0345, 'lps'),
	(654130, 134, '2015-01-15 00:03:44.000000', 'consum', 0.0267, 'lps'),
	(654131, 134, '2015-01-15 00:03:45.000000', 'consum', 0.0252, 'lps'),
	(654132, 134, '2015-01-15 00:03:46.000000', 'consum', 0.0247, 'lps'),
	(654133, 134, '2015-01-15 00:03:47.000000', 'consum', 0.0272, 'lps'),
	(654134, 134, '2015-01-15 00:03:48.000000', 'consum', 0.0251, 'lps'),
	(654135, 134, '2015-01-15 00:03:49.000000', 'consum', 0.0228, 'lps'),
	(654136, 134, '2015-01-15 00:03:50.000000', 'consum', 0.0337, 'lps'),
	(654137, 134, '2015-01-15 00:03:51.000000', 'consum', 0.0315, 'lps'),
	(654138, 134, '2015-01-15 00:03:52.000000', 'consum', 0.0355, 'lps'),
	(654139, 134, '2015-01-15 00:03:53.000000', 'consum', 0.0305, 'lps'),
	(654140, 134, '2015-01-15 00:03:54.000000', 'consum', 0.0253, 'lps'),
	(654141, 134, '2015-01-15 00:03:55.000000', 'consum', 0.0295, 'lps'),
	(654142, 134, '2015-01-15 00:03:56.000000', 'consum', 0.0350, 'lps'),
	(654143, 134, '2015-01-15 00:03:57.000000', 'consum', 0.0339, 'lps'),
	(654144, 134, '2015-01-15 00:03:58.000000', 'consum', 0.0278, 'lps'),
	(654145, 134, '2015-01-15 00:03:59.000000', 'consum', 0.0323, 'lps'),
	(654146, 134, '2015-01-15 00:04:00.000000', 'consum', 0.0256, 'lps'),
	(654147, 134, '2015-01-15 00:04:01.000000', 'consum', 0.0258, 'lps'),
	(654148, 134, '2015-01-15 00:04:02.000000', 'consum', 0.0311, 'lps'),
	(654149, 134, '2015-01-15 00:04:03.000000', 'consum', 0.0259, 'lps'),
	(654150, 134, '2015-01-15 00:04:04.000000', 'consum', 0.0307, 'lps'),
	(654151, 134, '2015-01-15 00:04:05.000000', 'consum', 0.0233, 'lps'),
	(654152, 134, '2015-01-15 00:04:06.000000', 'consum', 0.0351, 'lps'),
	(654153, 134, '2015-01-15 00:04:07.000000', 'consum', 0.0215, 'lps'),
	(654154, 134, '2015-01-15 00:04:08.000000', 'consum', 0.0286, 'lps'),
	(654155, 134, '2015-01-15 00:04:09.000000', 'consum', 0.0261, 'lps'),
	(654156, 134, '2015-01-15 00:04:10.000000', 'consum', 0.0237, 'lps'),
	(654157, 134, '2015-01-15 00:04:11.000000', 'consum', 0.0350, 'lps'),
	(654158, 134, '2015-01-15 00:04:12.000000', 'consum', 0.0354, 'lps'),
	(654159, 134, '2015-01-15 00:04:13.000000', 'consum', 0.0355, 'lps'),
	(654160, 134, '2015-01-15 00:04:14.000000', 'consum', 0.0345, 'lps'),
	(654161, 134, '2015-01-15 00:04:15.000000', 'consum', 0.0292, 'lps'),
	(654162, 134, '2015-01-15 00:04:16.000000', 'consum', 0.0214, 'lps'),
	(654163, 134, '2015-01-15 00:04:17.000000', 'consum', 0.0302, 'lps'),
	(654164, 134, '2015-01-15 00:04:18.000000', 'consum', 0.0340, 'lps'),
	(654165, 134, '2015-01-15 00:04:19.000000', 'consum', 0.0271, 'lps'),
	(654166, 134, '2015-01-15 00:04:20.000000', 'consum', 0.0283, 'lps'),
	(654167, 134, '2015-01-15 00:04:21.000000', 'consum', 0.0235, 'lps'),
	(654168, 134, '2015-01-15 00:04:22.000000', 'consum', 0.0274, 'lps'),
	(654169, 134, '2015-01-15 00:04:23.000000', 'consum', 0.0295, 'lps'),
	(654170, 134, '2015-01-15 00:04:24.000000', 'consum', 0.0289, 'lps'),
	(654171, 134, '2015-01-15 00:04:25.000000', 'consum', 0.0351, 'lps'),
	(654172, 134, '2015-01-15 00:04:26.000000', 'consum', 0.0360, 'lps'),
	(654173, 134, '2015-01-15 00:04:27.000000', 'consum', 0.0222, 'lps'),
	(654174, 134, '2015-01-15 00:04:28.000000', 'consum', 0.0294, 'lps'),
	(654175, 134, '2015-01-15 00:04:29.000000', 'consum', 0.0281, 'lps'),
	(654176, 134, '2015-01-15 00:04:30.000000', 'consum', 0.0312, 'lps'),
	(654177, 134, '2015-01-15 00:04:31.000000', 'consum', 0.0349, 'lps'),
	(654178, 134, '2015-01-15 00:04:32.000000', 'consum', 0.0285, 'lps'),
	(654179, 134, '2015-01-15 00:04:33.000000', 'consum', 0.0327, 'lps'),
	(654180, 134, '2015-01-15 00:04:34.000000', 'consum', 0.0256, 'lps'),
	(654181, 134, '2015-01-15 00:04:35.000000', 'consum', 0.0244, 'lps'),
	(654182, 134, '2015-01-15 00:04:36.000000', 'consum', 0.0244, 'lps'),
	(654183, 134, '2015-01-15 00:04:37.000000', 'consum', 0.0278, 'lps'),
	(654184, 134, '2015-01-15 00:04:38.000000', 'consum', 0.0293, 'lps'),
	(654185, 134, '2015-01-15 00:04:39.000000', 'consum', 0.0261, 'lps'),
	(654186, 134, '2015-01-15 00:04:40.000000', 'consum', 0.0217, 'lps'),
	(654187, 134, '2015-01-15 00:04:41.000000', 'consum', 0.0252, 'lps'),
	(654188, 134, '2015-01-15 00:04:42.000000', 'consum', 0.0240, 'lps'),
	(654189, 134, '2015-01-15 00:04:43.000000', 'consum', 0.0236, 'lps'),
	(654190, 134, '2015-01-15 00:04:44.000000', 'consum', 0.0250, 'lps'),
	(654191, 134, '2015-01-15 00:04:45.000000', 'consum', 0.0334, 'lps'),
	(654192, 134, '2015-01-15 00:04:46.000000', 'consum', 0.0235, 'lps'),
	(654193, 134, '2015-01-15 00:04:47.000000', 'consum', 0.0281, 'lps'),
	(654194, 134, '2015-01-15 00:04:48.000000', 'consum', 0.0330, 'lps'),
	(654195, 134, '2015-01-15 00:04:49.000000', 'consum', 0.0281, 'lps'),
	(654196, 134, '2015-01-15 00:04:50.000000', 'consum', 0.0365, 'lps'),
	(654197, 134, '2015-01-15 00:04:51.000000', 'consum', 0.0297, 'lps'),
	(654198, 134, '2015-01-15 00:04:52.000000', 'consum', 0.0339, 'lps'),
	(654199, 134, '2015-01-15 00:04:53.000000', 'consum', 0.0278, 'lps'),
	(654200, 134, '2015-01-15 00:04:54.000000', 'consum', 0.0320, 'lps'),
	(654201, 134, '2015-01-15 00:04:55.000000', 'consum', 0.0242, 'lps'),
	(654202, 134, '2015-01-15 00:04:56.000000', 'consum', 0.0356, 'lps'),
	(654203, 134, '2015-01-15 00:04:57.000000', 'consum', 0.0214, 'lps'),
	(654204, 134, '2015-01-15 00:04:58.000000', 'consum', 0.0266, 'lps'),
	(654205, 134, '2015-01-15 00:04:59.000000', 'consum', 0.0318, 'lps'),
	(654206, 134, '2015-01-15 00:05:00.000000', 'consum', 0.0269, 'lps'),
	(654207, 134, '2015-01-15 00:05:01.000000', 'consum', 0.0340, 'lps'),
	(654208, 134, '2015-01-15 00:05:02.000000', 'consum', 0.0367, 'lps'),
	(654209, 134, '2015-01-15 00:05:03.000000', 'consum', 0.0288, 'lps'),
	(654210, 134, '2015-01-15 00:05:04.000000', 'consum', 0.0288, 'lps'),
	(654211, 134, '2015-01-15 00:05:05.000000', 'consum', 0.0211, 'lps'),
	(654212, 134, '2015-01-15 00:05:06.000000', 'consum', 0.0295, 'lps'),
	(654213, 134, '2015-01-15 00:05:07.000000', 'consum', 0.0316, 'lps'),
	(654214, 134, '2015-01-15 00:05:08.000000', 'consum', 0.0330, 'lps'),
	(654215, 134, '2015-01-15 00:05:09.000000', 'consum', 0.0333, 'lps'),
	(654216, 134, '2015-01-15 00:05:10.000000', 'consum', 0.0306, 'lps'),
	(654217, 134, '2015-01-15 00:05:11.000000', 'consum', 0.0324, 'lps'),
	(654218, 134, '2015-01-15 00:05:12.000000', 'consum', 0.0332, 'lps'),
	(654219, 134, '2015-01-15 00:05:13.000000', 'consum', 0.0321, 'lps'),
	(654220, 134, '2015-01-15 00:05:14.000000', 'consum', 0.0243, 'lps'),
	(654221, 134, '2015-01-15 00:05:15.000000', 'consum', 0.0360, 'lps'),
	(654222, 134, '2015-01-15 00:05:16.000000', 'consum', 0.0226, 'lps'),
	(654223, 134, '2015-01-15 00:05:17.000000', 'consum', 0.0317, 'lps'),
	(654224, 134, '2015-01-15 00:05:18.000000', 'consum', 0.0223, 'lps'),
	(654225, 134, '2015-01-15 00:05:19.000000', 'consum', 0.0268, 'lps'),
	(654226, 134, '2015-01-15 00:05:20.000000', 'consum', 0.0306, 'lps'),
	(654227, 134, '2015-01-15 00:05:21.000000', 'consum', 0.0359, 'lps'),
	(654228, 134, '2015-01-15 00:05:22.000000', 'consum', 0.0350, 'lps'),
	(654229, 134, '2015-01-15 00:05:23.000000', 'consum', 0.0306, 'lps'),
	(654230, 134, '2015-01-15 00:05:24.000000', 'consum', 0.0273, 'lps'),
	(654231, 134, '2015-01-15 00:05:25.000000', 'consum', 0.0234, 'lps'),
	(654232, 134, '2015-01-15 00:05:26.000000', 'consum', 0.0300, 'lps'),
	(654233, 134, '2015-01-15 00:05:27.000000', 'consum', 0.0274, 'lps'),
	(654234, 134, '2015-01-15 00:05:28.000000', 'consum', 0.0261, 'lps'),
	(654235, 134, '2015-01-15 00:05:29.000000', 'consum', 0.0273, 'lps'),
	(654236, 134, '2015-01-15 00:05:30.000000', 'consum', 0.0214, 'lps'),
	(654237, 134, '2015-01-15 00:05:31.000000', 'consum', 0.0358, 'lps'),
	(654238, 134, '2015-01-15 00:05:32.000000', 'consum', 0.0305, 'lps'),
	(654239, 134, '2015-01-15 00:05:33.000000', 'consum', 0.0244, 'lps'),
	(654240, 134, '2015-01-15 00:05:34.000000', 'consum', 0.0251, 'lps'),
	(654241, 134, '2015-01-15 00:05:35.000000', 'consum', 0.0314, 'lps'),
	(654242, 134, '2015-01-15 00:05:36.000000', 'consum', 0.0291, 'lps'),
	(654243, 134, '2015-01-15 00:05:37.000000', 'consum', 0.0306, 'lps'),
	(654244, 134, '2015-01-15 00:05:38.000000', 'consum', 0.0289, 'lps'),
	(654245, 134, '2015-01-15 00:05:39.000000', 'consum', 0.0316, 'lps'),
	(654246, 134, '2015-01-15 00:05:40.000000', 'consum', 0.0346, 'lps'),
	(654247, 134, '2015-01-15 00:05:41.000000', 'consum', 0.0256, 'lps'),
	(654248, 134, '2015-01-15 00:05:42.000000', 'consum', 0.0349, 'lps'),
	(654249, 134, '2015-01-15 00:05:43.000000', 'consum', 0.0292, 'lps'),
	(654250, 134, '2015-01-15 00:05:44.000000', 'consum', 0.0361, 'lps'),
	(654251, 134, '2015-01-15 00:05:45.000000', 'consum', 0.0248, 'lps'),
	(654252, 134, '2015-01-15 00:05:46.000000', 'consum', 0.0261, 'lps'),
	(654253, 134, '2015-01-15 00:05:47.000000', 'consum', 0.0352, 'lps'),
	(654254, 134, '2015-01-15 00:05:48.000000', 'consum', 0.0295, 'lps'),
	(654255, 134, '2015-01-15 00:05:49.000000', 'consum', 0.0366, 'lps'),
	(654256, 134, '2015-01-15 00:05:50.000000', 'consum', 0.0262, 'lps'),
	(654257, 134, '2015-01-15 00:05:51.000000', 'consum', 0.0320, 'lps'),
	(654258, 134, '2015-01-15 00:05:52.000000', 'consum', 0.0288, 'lps'),
	(654259, 134, '2015-01-15 00:05:53.000000', 'consum', 0.0269, 'lps'),
	(654260, 134, '2015-01-15 00:05:54.000000', 'consum', 0.0270, 'lps'),
	(654261, 134, '2015-01-15 00:05:55.000000', 'consum', 0.0337, 'lps'),
	(654262, 134, '2015-01-15 00:05:56.000000', 'consum', 0.0347, 'lps'),
	(654263, 134, '2015-01-15 00:05:57.000000', 'consum', 0.0358, 'lps'),
	(654264, 134, '2015-01-15 00:05:58.000000', 'consum', 0.0222, 'lps'),
	(654265, 134, '2015-01-15 00:05:59.000000', 'consum', 0.0302, 'lps'),
	(654266, 134, '2015-01-15 00:06:00.000000', 'consum', 0.0320, 'lps'),
	(654267, 134, '2015-01-15 00:06:01.000000', 'consum', 0.0324, 'lps'),
	(654268, 134, '2015-01-15 00:06:02.000000', 'consum', 0.0291, 'lps'),
	(654269, 134, '2015-01-15 00:06:03.000000', 'consum', 0.0276, 'lps'),
	(654270, 134, '2015-01-15 00:06:04.000000', 'consum', 0.0297, 'lps'),
	(654271, 134, '2015-01-15 00:06:05.000000', 'consum', 0.0291, 'lps'),
	(654272, 134, '2015-01-15 00:06:06.000000', 'consum', 0.0353, 'lps'),
	(654273, 134, '2015-01-15 00:06:07.000000', 'consum', 0.0367, 'lps'),
	(654274, 134, '2015-01-15 00:06:08.000000', 'consum', 0.0249, 'lps'),
	(654275, 134, '2015-01-15 00:06:09.000000', 'consum', 0.0253, 'lps'),
	(654276, 134, '2015-01-15 00:06:10.000000', 'consum', 0.0308, 'lps'),
	(654277, 134, '2015-01-15 00:06:11.000000', 'consum', 0.0254, 'lps'),
	(654278, 134, '2015-01-15 00:06:12.000000', 'consum', 0.0295, 'lps'),
	(654279, 134, '2015-01-15 00:06:13.000000', 'consum', 0.0346, 'lps'),
	(654280, 134, '2015-01-15 00:06:14.000000', 'consum', 0.0320, 'lps'),
	(654281, 134, '2015-01-15 00:06:15.000000', 'consum', 0.0352, 'lps'),
	(654282, 134, '2015-01-15 00:06:16.000000', 'consum', 0.0276, 'lps'),
	(654283, 134, '2015-01-15 00:06:17.000000', 'consum', 0.0271, 'lps'),
	(654284, 134, '2015-01-15 00:06:18.000000', 'consum', 0.0320, 'lps'),
	(654285, 134, '2015-01-15 00:06:19.000000', 'consum', 0.0258, 'lps'),
	(654286, 134, '2015-01-15 00:06:20.000000', 'consum', 0.0280, 'lps'),
	(654287, 134, '2015-01-15 00:06:21.000000', 'consum', 0.0259, 'lps'),
	(654288, 134, '2015-01-15 00:06:22.000000', 'consum', 0.0245, 'lps'),
	(654289, 134, '2015-01-15 00:06:23.000000', 'consum', 0.0241, 'lps'),
	(654290, 134, '2015-01-15 00:06:24.000000', 'consum', 0.0257, 'lps'),
	(654291, 134, '2015-01-15 00:06:25.000000', 'consum', 0.0355, 'lps'),
	(654292, 134, '2015-01-15 00:06:26.000000', 'consum', 0.0318, 'lps'),
	(654293, 134, '2015-01-15 00:06:27.000000', 'consum', 0.0317, 'lps'),
	(654294, 134, '2015-01-15 00:06:28.000000', 'consum', 0.0265, 'lps'),
	(654295, 134, '2015-01-15 00:06:29.000000', 'consum', 0.0320, 'lps'),
	(654296, 134, '2015-01-15 00:06:30.000000', 'consum', 0.0280, 'lps'),
	(654297, 134, '2015-01-15 00:06:31.000000', 'consum', 0.0231, 'lps'),
	(654298, 134, '2015-01-15 00:06:32.000000', 'consum', 0.0263, 'lps'),
	(654299, 134, '2015-01-15 00:06:33.000000', 'consum', 0.0256, 'lps'),
	(654300, 134, '2015-01-15 00:06:34.000000', 'consum', 0.0282, 'lps'),
	(654301, 134, '2015-01-15 00:06:35.000000', 'consum', 0.0271, 'lps'),
	(654302, 134, '2015-01-15 00:06:36.000000', 'consum', 0.0303, 'lps'),
	(654303, 134, '2015-01-15 00:06:37.000000', 'consum', 0.0335, 'lps'),
	(654304, 134, '2015-01-15 00:06:38.000000', 'consum', 0.0238, 'lps'),
	(654305, 134, '2015-01-15 00:06:39.000000', 'consum', 0.0291, 'lps'),
	(654306, 134, '2015-01-15 00:06:40.000000', 'consum', 0.0218, 'lps'),
	(654307, 134, '2015-01-15 00:06:41.000000', 'consum', 0.0324, 'lps'),
	(654308, 134, '2015-01-15 00:06:42.000000', 'consum', 0.0282, 'lps'),
	(654309, 134, '2015-01-15 00:06:43.000000', 'consum', 0.0227, 'lps'),
	(654310, 134, '2015-01-15 00:06:44.000000', 'consum', 0.0239, 'lps'),
	(654311, 134, '2015-01-15 00:06:45.000000', 'consum', 0.0306, 'lps'),
	(654312, 134, '2015-01-15 00:06:46.000000', 'consum', 0.0286, 'lps'),
	(654313, 134, '2015-01-15 00:06:47.000000', 'consum', 0.0301, 'lps'),
	(654314, 134, '2015-01-15 00:06:48.000000', 'consum', 0.0282, 'lps'),
	(654315, 134, '2015-01-15 00:06:49.000000', 'consum', 0.0298, 'lps'),
	(654316, 134, '2015-01-15 00:06:50.000000', 'consum', 0.0275, 'lps'),
	(654317, 134, '2015-01-15 00:06:51.000000', 'consum', 0.0273, 'lps'),
	(654318, 134, '2015-01-15 00:06:52.000000', 'consum', 0.0332, 'lps'),
	(654319, 134, '2015-01-15 00:06:53.000000', 'consum', 0.0313, 'lps'),
	(654320, 134, '2015-01-15 00:06:54.000000', 'consum', 0.0359, 'lps'),
	(654321, 134, '2015-01-15 00:06:55.000000', 'consum', 0.0333, 'lps'),
	(654322, 134, '2015-01-15 00:06:56.000000', 'consum', 0.0218, 'lps'),
	(654323, 134, '2015-01-15 00:06:57.000000', 'consum', 0.0356, 'lps'),
	(654324, 134, '2015-01-15 00:06:58.000000', 'consum', 0.0285, 'lps'),
	(654325, 134, '2015-01-15 00:06:59.000000', 'consum', 0.0303, 'lps'),
	(654326, 134, '2015-01-15 00:07:00.000000', 'consum', 0.0296, 'lps'),
	(654327, 134, '2015-01-15 00:07:01.000000', 'consum', 0.0358, 'lps'),
	(654328, 134, '2015-01-15 00:07:02.000000', 'consum', 0.0221, 'lps'),
	(654329, 134, '2015-01-15 00:07:03.000000', 'consum', 0.0296, 'lps'),
	(654330, 134, '2015-01-15 00:07:04.000000', 'consum', 0.0291, 'lps'),
	(654331, 134, '2015-01-15 00:07:05.000000', 'consum', 0.0358, 'lps'),
	(654332, 134, '2015-01-15 00:07:06.000000', 'consum', 0.0233, 'lps'),
	(654333, 134, '2015-01-15 00:07:07.000000', 'consum', 0.0357, 'lps'),
	(654334, 134, '2015-01-15 00:07:08.000000', 'consum', 0.0245, 'lps'),
	(654335, 134, '2015-01-15 00:07:09.000000', 'consum', 0.0259, 'lps'),
	(654336, 134, '2015-01-15 00:07:10.000000', 'consum', 0.0353, 'lps'),
	(654337, 134, '2015-01-15 00:07:11.000000', 'consum', 0.0302, 'lps'),
	(654338, 134, '2015-01-15 00:07:12.000000', 'consum', 0.0244, 'lps'),
	(654339, 134, '2015-01-15 00:07:13.000000', 'consum', 0.0260, 'lps'),
	(654340, 134, '2015-01-15 00:07:14.000000', 'consum', 0.0357, 'lps'),
	(654341, 134, '2015-01-15 00:07:15.000000', 'consum', 0.0325, 'lps'),
	(654342, 134, '2015-01-15 00:07:16.000000', 'consum', 0.0343, 'lps'),
	(654343, 134, '2015-01-15 00:07:17.000000', 'consum', 0.0215, 'lps'),
	(654344, 134, '2015-01-15 00:07:18.000000', 'consum', 0.0310, 'lps'),
	(654345, 134, '2015-01-15 00:07:19.000000', 'consum', 0.0223, 'lps'),
	(654346, 134, '2015-01-15 00:07:20.000000', 'consum', 0.0290, 'lps'),
	(654347, 134, '2015-01-15 00:07:21.000000', 'consum', 0.0257, 'lps'),
	(654348, 134, '2015-01-15 00:07:22.000000', 'consum', 0.0363, 'lps'),
	(654349, 134, '2015-01-15 00:07:23.000000', 'consum', 0.0362, 'lps'),
	(654350, 134, '2015-01-15 00:07:24.000000', 'consum', 0.0351, 'lps'),
	(654351, 134, '2015-01-15 00:07:25.000000', 'consum', 0.0303, 'lps'),
	(654352, 134, '2015-01-15 00:07:26.000000', 'consum', 0.0251, 'lps'),
	(654353, 134, '2015-01-15 00:07:27.000000', 'consum', 0.0296, 'lps'),
	(654354, 134, '2015-01-15 00:07:28.000000', 'consum', 0.0358, 'lps'),
	(654355, 134, '2015-01-15 00:07:29.000000', 'consum', 0.0221, 'lps'),
	(654356, 134, '2015-01-15 00:07:30.000000', 'consum', 0.0293, 'lps'),
	(654357, 134, '2015-01-15 00:07:31.000000', 'consum', 0.0278, 'lps'),
	(654358, 134, '2015-01-15 00:07:32.000000', 'consum', 0.0302, 'lps'),
	(654359, 134, '2015-01-15 00:07:33.000000', 'consum', 0.0306, 'lps'),
	(654360, 134, '2015-01-15 00:07:34.000000', 'consum', 0.0258, 'lps'),
	(654361, 134, '2015-01-15 00:07:35.000000', 'consum', 0.0320, 'lps'),
	(654362, 134, '2015-01-15 00:07:36.000000', 'consum', 0.0300, 'lps'),
	(654363, 134, '2015-01-15 00:07:37.000000', 'consum', 0.0332, 'lps'),
	(654364, 134, '2015-01-15 00:07:38.000000', 'consum', 0.0234, 'lps'),
	(654365, 134, '2015-01-15 00:07:39.000000', 'consum', 0.0282, 'lps'),
	(654366, 134, '2015-01-15 00:07:40.000000', 'consum', 0.0340, 'lps'),
	(654367, 134, '2015-01-15 00:07:41.000000', 'consum', 0.0329, 'lps'),
	(654368, 134, '2015-01-15 00:07:42.000000', 'consum', 0.0255, 'lps'),
	(654369, 134, '2015-01-15 00:07:43.000000', 'consum', 0.0238, 'lps'),
	(654370, 134, '2015-01-15 00:07:44.000000', 'consum', 0.0217, 'lps'),
	(654371, 134, '2015-01-15 00:07:45.000000', 'consum', 0.0317, 'lps'),
	(654372, 134, '2015-01-15 00:07:46.000000', 'consum', 0.0249, 'lps'),
	(654373, 134, '2015-01-15 00:07:47.000000', 'consum', 0.0246, 'lps'),
	(654374, 134, '2015-01-15 00:07:48.000000', 'consum', 0.0272, 'lps'),
	(654375, 134, '2015-01-15 00:07:49.000000', 'consum', 0.0257, 'lps'),
	(654376, 134, '2015-01-15 00:07:50.000000', 'consum', 0.0256, 'lps'),
	(654377, 134, '2015-01-15 00:07:51.000000', 'consum', 0.0300, 'lps'),
	(654378, 134, '2015-01-15 00:07:52.000000', 'consum', 0.0363, 'lps'),
	(654379, 134, '2015-01-15 00:07:53.000000', 'consum', 0.0235, 'lps'),
	(654380, 134, '2015-01-15 00:07:54.000000', 'consum', 0.0349, 'lps'),
	(654381, 134, '2015-01-15 00:07:55.000000', 'consum', 0.0356, 'lps'),
	(654382, 134, '2015-01-15 00:07:56.000000', 'consum', 0.0364, 'lps'),
	(654383, 134, '2015-01-15 00:07:57.000000', 'consum', 0.0228, 'lps'),
	(654384, 134, '2015-01-15 00:07:58.000000', 'consum', 0.0314, 'lps'),
	(654385, 134, '2015-01-15 00:07:59.000000', 'consum', 0.0360, 'lps'),
	(654386, 134, '2015-01-15 00:08:00.000000', 'consum', 0.0333, 'lps'),
	(654387, 134, '2015-01-15 00:08:01.000000', 'consum', 0.0216, 'lps'),
	(654388, 134, '2015-01-15 00:08:02.000000', 'consum', 0.0346, 'lps'),
	(654389, 134, '2015-01-15 00:08:03.000000', 'consum', 0.0242, 'lps'),
	(654390, 134, '2015-01-15 00:08:04.000000', 'consum', 0.0278, 'lps'),
	(654391, 134, '2015-01-15 00:08:05.000000', 'consum', 0.0296, 'lps'),
	(654392, 134, '2015-01-15 00:08:06.000000', 'consum', 0.0280, 'lps'),
	(654393, 134, '2015-01-15 00:08:07.000000', 'consum', 0.0302, 'lps'),
	(654394, 134, '2015-01-15 00:08:08.000000', 'consum', 0.0300, 'lps'),
	(654395, 134, '2015-01-15 00:08:09.000000', 'consum', 0.0230, 'lps'),
	(654396, 134, '2015-01-15 00:08:10.000000', 'consum', 0.0355, 'lps'),
	(654397, 134, '2015-01-15 00:08:11.000000', 'consum', 0.0243, 'lps'),
	(654398, 134, '2015-01-15 00:08:12.000000', 'consum', 0.0256, 'lps'),
	(654399, 134, '2015-01-15 00:08:13.000000', 'consum', 0.0344, 'lps'),
	(654400, 134, '2015-01-15 00:08:14.000000', 'consum', 0.0265, 'lps'),
	(654401, 134, '2015-01-15 00:08:15.000000', 'consum', 0.0244, 'lps'),
	(654402, 134, '2015-01-15 00:08:16.000000', 'consum', 0.0214, 'lps'),
	(654403, 134, '2015-01-15 00:08:17.000000', 'consum', 0.0289, 'lps'),
	(654404, 134, '2015-01-15 00:08:18.000000', 'consum', 0.0274, 'lps'),
	(654405, 134, '2015-01-15 00:08:19.000000', 'consum', 0.0295, 'lps'),
	(654406, 134, '2015-01-15 00:08:20.000000', 'consum', 0.0287, 'lps'),
	(654407, 134, '2015-01-15 00:08:21.000000', 'consum', 0.0338, 'lps'),
	(654408, 134, '2015-01-15 00:08:22.000000', 'consum', 0.0306, 'lps'),
	(654409, 134, '2015-01-15 00:08:23.000000', 'consum', 0.0305, 'lps'),
	(654410, 134, '2015-01-15 00:08:24.000000', 'consum', 0.0239, 'lps'),
	(654411, 134, '2015-01-15 00:08:25.000000', 'consum', 0.0229, 'lps'),
	(654412, 134, '2015-01-15 00:08:26.000000', 'consum', 0.0220, 'lps'),
	(654413, 134, '2015-01-15 00:08:27.000000', 'consum', 0.0362, 'lps'),
	(654414, 134, '2015-01-15 00:08:28.000000', 'consum', 0.0309, 'lps'),
	(654415, 134, '2015-01-15 00:08:29.000000', 'consum', 0.0248, 'lps'),
	(654416, 134, '2015-01-15 00:08:30.000000', 'consum', 0.0262, 'lps'),
	(654417, 134, '2015-01-15 00:08:31.000000', 'consum', 0.0357, 'lps'),
	(654418, 134, '2015-01-15 00:08:32.000000', 'consum', 0.0315, 'lps'),
	(654419, 134, '2015-01-15 00:08:33.000000', 'consum', 0.0293, 'lps'),
	(654420, 134, '2015-01-15 00:08:34.000000', 'consum', 0.0309, 'lps'),
	(654421, 134, '2015-01-15 00:08:35.000000', 'consum', 0.0302, 'lps'),
	(654422, 134, '2015-01-15 00:08:36.000000', 'consum', 0.0215, 'lps'),
	(654423, 134, '2015-01-15 00:08:37.000000', 'consum', 0.0277, 'lps'),
	(654424, 134, '2015-01-15 00:08:38.000000', 'consum', 0.0212, 'lps'),
	(654425, 134, '2015-01-15 00:08:39.000000', 'consum', 0.0335, 'lps'),
	(654426, 134, '2015-01-15 00:08:40.000000', 'consum', 0.0355, 'lps'),
	(654427, 134, '2015-01-15 00:08:41.000000', 'consum', 0.0247, 'lps'),
	(654428, 134, '2015-01-15 00:08:42.000000', 'consum', 0.0277, 'lps'),
	(654429, 134, '2015-01-15 00:08:43.000000', 'consum', 0.0273, 'lps'),
	(654430, 134, '2015-01-15 00:08:44.000000', 'consum', 0.0328, 'lps'),
	(654431, 134, '2015-01-15 00:08:45.000000', 'consum', 0.0294, 'lps'),
	(654432, 134, '2015-01-15 00:08:46.000000', 'consum', 0.0275, 'lps'),
	(654433, 134, '2015-01-15 00:08:47.000000', 'consum', 0.0284, 'lps'),
	(654434, 134, '2015-01-15 00:08:48.000000', 'consum', 0.0228, 'lps'),
	(654435, 134, '2015-01-15 00:08:49.000000', 'consum', 0.0235, 'lps'),
	(654436, 134, '2015-01-15 00:08:50.000000', 'consum', 0.0281, 'lps'),
	(654437, 134, '2015-01-15 00:08:51.000000', 'consum', 0.0335, 'lps'),
	(654438, 134, '2015-01-15 00:08:52.000000', 'consum', 0.0307, 'lps'),
	(654439, 134, '2015-01-15 00:08:53.000000', 'consum', 0.0321, 'lps'),
	(654440, 134, '2015-01-15 00:08:54.000000', 'consum', 0.0315, 'lps'),
	(654441, 134, '2015-01-15 00:08:55.000000', 'consum', 0.0245, 'lps'),
	(654442, 134, '2015-01-15 00:08:56.000000', 'consum', 0.0228, 'lps'),
	(654443, 134, '2015-01-15 00:08:57.000000', 'consum', 0.0355, 'lps'),
	(654444, 134, '2015-01-15 00:08:58.000000', 'consum', 0.0251, 'lps'),
	(654445, 134, '2015-01-15 00:08:59.000000', 'consum', 0.0293, 'lps'),
	(654446, 134, '2015-01-15 00:09:00.000000', 'consum', 0.0347, 'lps'),
	(654447, 134, '2015-01-15 00:09:01.000000', 'consum', 0.0331, 'lps'),
	(654448, 134, '2015-01-15 00:09:02.000000', 'consum', 0.0247, 'lps'),
	(654449, 134, '2015-01-15 00:09:03.000000', 'consum', 0.0349, 'lps'),
	(654450, 134, '2015-01-15 00:09:04.000000', 'consum', 0.0319, 'lps'),
	(654451, 134, '2015-01-15 00:09:05.000000', 'consum', 0.0339, 'lps'),
	(654452, 134, '2015-01-15 00:09:06.000000', 'consum', 0.0212, 'lps'),
	(654453, 134, '2015-01-15 00:09:07.000000', 'consum', 0.0310, 'lps'),
	(654454, 134, '2015-01-15 00:09:08.000000', 'consum', 0.0227, 'lps'),
	(654455, 134, '2015-01-15 00:09:09.000000', 'consum', 0.0313, 'lps'),
	(654456, 134, '2015-01-15 00:09:10.000000', 'consum', 0.0358, 'lps'),
	(654457, 134, '2015-01-15 00:09:11.000000', 'consum', 0.0325, 'lps'),
	(654458, 134, '2015-01-15 00:09:12.000000', 'consum', 0.0342, 'lps'),
	(654459, 134, '2015-01-15 00:09:13.000000', 'consum', 0.0367, 'lps'),
	(654460, 134, '2015-01-15 00:09:14.000000', 'consum', 0.0282, 'lps'),
	(654461, 134, '2015-01-15 00:09:15.000000', 'consum', 0.0261, 'lps'),
	(654462, 134, '2015-01-15 00:09:16.000000', 'consum', 0.0246, 'lps'),
	(654463, 134, '2015-01-15 00:09:17.000000', 'consum', 0.0238, 'lps'),
	(654464, 134, '2015-01-15 00:09:18.000000', 'consum', 0.0244, 'lps'),
	(654465, 134, '2015-01-15 00:09:19.000000', 'consum', 0.0297, 'lps'),
	(654466, 134, '2015-01-15 00:09:20.000000', 'consum', 0.0225, 'lps'),
	(654467, 134, '2015-01-15 00:09:21.000000', 'consum', 0.0340, 'lps'),
	(654468, 134, '2015-01-15 00:09:22.000000', 'consum', 0.0344, 'lps'),
	(654469, 134, '2015-01-15 00:09:23.000000', 'consum', 0.0332, 'lps'),
	(654470, 134, '2015-01-15 00:09:24.000000', 'consum', 0.0260, 'lps'),
	(654471, 134, '2015-01-15 00:09:25.000000', 'consum', 0.0251, 'lps'),
	(654472, 134, '2015-01-15 00:09:26.000000', 'consum', 0.0268, 'lps'),
	(654473, 134, '2015-01-15 00:09:27.000000', 'consum', 0.0217, 'lps'),
	(654474, 134, '2015-01-15 00:09:28.000000', 'consum', 0.0229, 'lps'),
	(654475, 134, '2015-01-15 00:09:29.000000', 'consum', 0.0287, 'lps'),
	(654476, 134, '2015-01-15 00:09:30.000000', 'consum', 0.0222, 'lps'),
	(654477, 134, '2015-01-15 00:09:31.000000', 'consum', 0.0356, 'lps'),
	(654478, 134, '2015-01-15 00:09:32.000000', 'consum', 0.0271, 'lps'),
	(654479, 134, '2015-01-15 00:09:33.000000', 'consum', 0.0235, 'lps'),
	(654480, 134, '2015-01-15 00:09:34.000000', 'consum', 0.0309, 'lps'),
	(654481, 134, '2015-01-15 00:09:35.000000', 'consum', 0.0318, 'lps'),
	(654482, 134, '2015-01-15 00:09:36.000000', 'consum', 0.0294, 'lps'),
	(654483, 134, '2015-01-15 00:09:37.000000', 'consum', 0.0307, 'lps'),
	(654484, 134, '2015-01-15 00:09:38.000000', 'consum', 0.0286, 'lps'),
	(654485, 134, '2015-01-15 00:09:39.000000', 'consum', 0.0297, 'lps'),
	(654486, 134, '2015-01-15 00:09:40.000000', 'consum', 0.0261, 'lps'),
	(654487, 134, '2015-01-15 00:09:41.000000', 'consum', 0.0364, 'lps'),
	(654488, 134, '2015-01-15 00:09:42.000000', 'consum', 0.0351, 'lps'),
	(654489, 134, '2015-01-15 00:09:43.000000', 'consum', 0.0298, 'lps'),
	(654490, 134, '2015-01-15 00:09:44.000000', 'consum', 0.0226, 'lps'),
	(654491, 134, '2015-01-15 00:09:45.000000', 'consum', 0.0345, 'lps'),
	(654492, 134, '2015-01-15 00:09:46.000000', 'consum', 0.0362, 'lps'),
	(654493, 134, '2015-01-15 00:09:47.000000', 'consum', 0.0248, 'lps'),
	(654494, 134, '2015-01-15 00:09:48.000000', 'consum', 0.0263, 'lps'),
	(654495, 134, '2015-01-15 00:09:49.000000', 'consum', 0.0359, 'lps'),
	(654496, 134, '2015-01-15 00:09:50.000000', 'consum', 0.0323, 'lps'),
	(654497, 134, '2015-01-15 00:09:51.000000', 'consum', 0.0327, 'lps'),
	(654498, 134, '2015-01-15 00:09:52.000000', 'consum', 0.0300, 'lps'),
	(654499, 134, '2015-01-15 00:09:53.000000', 'consum', 0.0307, 'lps'),
	(654500, 134, '2015-01-15 00:09:54.000000', 'consum', 0.0270, 'lps'),
	(654501, 134, '2015-01-15 00:09:55.000000', 'consum', 0.0220, 'lps'),
	(654502, 134, '2015-01-15 00:09:56.000000', 'consum', 0.0238, 'lps'),
	(654503, 134, '2015-01-15 00:09:57.000000', 'consum', 0.0321, 'lps'),
	(654504, 134, '2015-01-15 00:09:58.000000', 'consum', 0.0366, 'lps'),
	(654505, 134, '2015-01-15 00:09:59.000000', 'consum', 0.0342, 'lps'),
	(654506, 134, '2015-01-15 00:10:00.000000', 'consum', 0.0243, 'lps'),
	(654507, 134, '2015-01-15 00:10:01.000000', 'consum', 0.0298, 'lps'),
	(654508, 134, '2015-01-15 00:10:02.000000', 'consum', 0.0234, 'lps'),
	(654509, 134, '2015-01-15 00:10:03.000000', 'consum', 0.0223, 'lps'),
	(654510, 134, '2015-01-15 00:10:04.000000', 'consum', 0.0362, 'lps'),
	(654511, 134, '2015-01-15 00:10:05.000000', 'consum', 0.0301, 'lps'),
	(654512, 134, '2015-01-15 00:10:06.000000', 'consum', 0.0367, 'lps'),
	(654513, 134, '2015-01-15 00:10:07.000000', 'consum', 0.0249, 'lps'),
	(654514, 134, '2015-01-15 00:10:08.000000', 'consum', 0.0250, 'lps'),
	(654515, 134, '2015-01-15 00:10:09.000000', 'consum', 0.0293, 'lps'),
	(654516, 134, '2015-01-15 00:10:10.000000', 'consum', 0.0346, 'lps'),
	(654517, 134, '2015-01-15 00:10:11.000000', 'consum', 0.0328, 'lps'),
	(654518, 134, '2015-01-15 00:10:12.000000', 'consum', 0.0234, 'lps'),
	(654519, 134, '2015-01-15 00:10:13.000000', 'consum', 0.0292, 'lps'),
	(654520, 134, '2015-01-15 00:10:14.000000', 'consum', 0.0233, 'lps'),
	(654521, 134, '2015-01-15 00:10:15.000000', 'consum', 0.0238, 'lps'),
	(654522, 134, '2015-01-15 00:10:16.000000', 'consum', 0.0281, 'lps'),
	(654523, 134, '2015-01-15 00:10:17.000000', 'consum', 0.0325, 'lps'),
	(654524, 134, '2015-01-15 00:10:18.000000', 'consum', 0.0256, 'lps'),
	(654525, 134, '2015-01-15 00:10:19.000000', 'consum', 0.0253, 'lps'),
	(654526, 134, '2015-01-15 00:10:20.000000', 'consum', 0.0288, 'lps'),
	(654527, 134, '2015-01-15 00:10:21.000000', 'consum', 0.0313, 'lps'),
	(654528, 134, '2015-01-15 00:10:22.000000', 'consum', 0.0334, 'lps'),
	(654529, 134, '2015-01-15 00:10:23.000000', 'consum', 0.0364, 'lps'),
	(654530, 134, '2015-01-15 00:10:24.000000', 'consum', 0.0294, 'lps'),
	(654531, 134, '2015-01-15 00:10:25.000000', 'consum', 0.0325, 'lps'),
	(654532, 134, '2015-01-15 00:10:26.000000', 'consum', 0.0220, 'lps'),
	(654533, 134, '2015-01-15 00:10:27.000000', 'consum', 0.0228, 'lps'),
	(654534, 134, '2015-01-15 00:10:28.000000', 'consum', 0.0272, 'lps'),
	(654535, 134, '2015-01-15 00:10:29.000000', 'consum', 0.0308, 'lps'),
	(654536, 134, '2015-01-15 00:10:30.000000', 'consum', 0.0355, 'lps'),
	(654537, 134, '2015-01-15 00:10:31.000000', 'consum', 0.0327, 'lps'),
	(654538, 134, '2015-01-15 00:10:32.000000', 'consum', 0.0362, 'lps'),
	(654539, 134, '2015-01-15 00:10:33.000000', 'consum', 0.0301, 'lps'),
	(654540, 134, '2015-01-15 00:10:34.000000', 'consum', 0.0366, 'lps'),
	(654541, 134, '2015-01-15 00:10:35.000000', 'consum', 0.0247, 'lps'),
	(654542, 134, '2015-01-15 00:10:36.000000', 'consum', 0.0243, 'lps'),
	(654543, 134, '2015-01-15 00:10:37.000000', 'consum', 0.0262, 'lps'),
	(654544, 134, '2015-01-15 00:10:38.000000', 'consum', 0.0216, 'lps'),
	(654545, 134, '2015-01-15 00:10:39.000000', 'consum', 0.0243, 'lps'),
	(654546, 134, '2015-01-15 00:10:40.000000', 'consum', 0.0355, 'lps'),
	(654547, 134, '2015-01-15 00:10:41.000000', 'consum', 0.0363, 'lps'),
	(654548, 134, '2015-01-15 00:10:42.000000', 'consum', 0.0227, 'lps'),
	(654549, 134, '2015-01-15 00:10:43.000000', 'consum', 0.0309, 'lps'),
	(654550, 134, '2015-01-15 00:10:44.000000', 'consum', 0.0338, 'lps'),
	(654551, 134, '2015-01-15 00:10:45.000000', 'consum', 0.0236, 'lps'),
	(654552, 134, '2015-01-15 00:10:46.000000', 'consum', 0.0275, 'lps'),
	(654553, 134, '2015-01-15 00:10:47.000000', 'consum', 0.0299, 'lps'),
	(654554, 134, '2015-01-15 00:10:48.000000', 'consum', 0.0301, 'lps'),
	(654555, 134, '2015-01-15 00:10:49.000000', 'consum', 0.0243, 'lps'),
	(654556, 134, '2015-01-15 00:10:50.000000', 'consum', 0.0260, 'lps'),
	(654557, 134, '2015-01-15 00:10:51.000000', 'consum', 0.0362, 'lps'),
	(654558, 134, '2015-01-15 00:10:52.000000', 'consum', 0.0344, 'lps'),
	(654559, 134, '2015-01-15 00:10:53.000000', 'consum', 0.0268, 'lps'),
	(654560, 134, '2015-01-15 00:10:54.000000', 'consum', 0.0258, 'lps'),
	(654561, 134, '2015-01-15 00:10:55.000000', 'consum', 0.0275, 'lps'),
	(654562, 134, '2015-01-15 00:10:56.000000', 'consum', 0.0233, 'lps'),
	(654563, 134, '2015-01-15 00:10:57.000000', 'consum', 0.0288, 'lps'),
	(654564, 134, '2015-01-15 00:10:58.000000', 'consum', 0.0216, 'lps'),
	(654565, 134, '2015-01-15 00:10:59.000000', 'consum', 0.0323, 'lps'),
	(654566, 134, '2015-01-15 00:11:00.000000', 'consum', 0.0282, 'lps'),
	(654567, 134, '2015-01-15 00:11:01.000000', 'consum', 0.0232, 'lps'),
	(654568, 134, '2015-01-15 00:11:02.000000', 'consum', 0.0264, 'lps'),
	(654569, 134, '2015-01-15 00:11:03.000000', 'consum', 0.0258, 'lps'),
	(654570, 134, '2015-01-15 00:11:04.000000', 'consum', 0.0285, 'lps'),
	(654571, 134, '2015-01-15 00:11:05.000000', 'consum', 0.0286, 'lps'),
	(654572, 134, '2015-01-15 00:11:06.000000', 'consum', 0.0363, 'lps'),
	(654573, 134, '2015-01-15 00:11:07.000000', 'consum', 0.0273, 'lps'),
	(654574, 134, '2015-01-15 00:11:08.000000', 'consum', 0.0224, 'lps'),
	(654575, 134, '2015-01-15 00:11:09.000000', 'consum', 0.0250, 'lps'),
	(654576, 134, '2015-01-15 00:11:10.000000', 'consum', 0.0213, 'lps'),
	(654577, 134, '2015-01-15 00:11:11.000000', 'consum', 0.0262, 'lps'),
	(654578, 134, '2015-01-15 00:11:12.000000', 'consum', 0.0303, 'lps'),
	(654579, 134, '2015-01-15 00:11:13.000000', 'consum', 0.0364, 'lps'),
	(654580, 134, '2015-01-15 00:11:14.000000', 'consum', 0.0225, 'lps'),
	(654581, 134, '2015-01-15 00:11:15.000000', 'consum', 0.0297, 'lps'),
	(654582, 134, '2015-01-15 00:11:16.000000', 'consum', 0.0286, 'lps'),
	(654583, 134, '2015-01-15 00:11:17.000000', 'consum', 0.0328, 'lps'),
	(654584, 134, '2015-01-15 00:11:18.000000', 'consum', 0.0256, 'lps'),
	(654585, 134, '2015-01-15 00:11:19.000000', 'consum', 0.0245, 'lps'),
	(654586, 134, '2015-01-15 00:11:20.000000', 'consum', 0.0247, 'lps'),
	(654587, 134, '2015-01-15 00:11:21.000000', 'consum', 0.0290, 'lps'),
	(654588, 134, '2015-01-15 00:11:22.000000', 'consum', 0.0343, 'lps'),
	(654589, 134, '2015-01-15 00:11:23.000000', 'consum', 0.0319, 'lps'),
	(654590, 134, '2015-01-15 00:11:24.000000', 'consum', 0.0356, 'lps'),
	(654591, 134, '2015-01-15 00:11:25.000000', 'consum', 0.0300, 'lps'),
	(654592, 134, '2015-01-15 00:11:26.000000', 'consum', 0.0220, 'lps'),
	(654593, 134, '2015-01-15 00:11:27.000000', 'consum', 0.0309, 'lps'),
	(654594, 134, '2015-01-15 00:11:28.000000', 'consum', 0.0357, 'lps'),
	(654595, 134, '2015-01-15 00:11:29.000000', 'consum', 0.0333, 'lps'),
	(654596, 134, '2015-01-15 00:11:30.000000', 'consum', 0.0226, 'lps'),
	(654597, 134, '2015-01-15 00:11:31.000000', 'consum', 0.0238, 'lps'),
	(654598, 134, '2015-01-15 00:11:32.000000', 'consum', 0.0302, 'lps'),
	(654599, 134, '2015-01-15 00:11:33.000000', 'consum', 0.0271, 'lps'),
	(654600, 134, '2015-01-15 00:11:34.000000', 'consum', 0.0239, 'lps'),
	(654601, 134, '2015-01-15 00:11:35.000000', 'consum', 0.0333, 'lps'),
	(654602, 134, '2015-01-15 00:11:36.000000', 'consum', 0.0261, 'lps'),
	(654603, 134, '2015-01-15 00:11:37.000000', 'consum', 0.0257, 'lps'),
	(654604, 134, '2015-01-15 00:11:38.000000', 'consum', 0.0290, 'lps'),
	(654605, 134, '2015-01-15 00:11:39.000000', 'consum', 0.0313, 'lps'),
	(654606, 134, '2015-01-15 00:11:40.000000', 'consum', 0.0329, 'lps'),
	(654607, 134, '2015-01-15 00:11:41.000000', 'consum', 0.0337, 'lps'),
	(654608, 134, '2015-01-15 00:11:42.000000', 'consum', 0.0330, 'lps'),
	(654609, 134, '2015-01-15 00:11:43.000000', 'consum', 0.0272, 'lps'),
	(654610, 134, '2015-01-15 00:11:44.000000', 'consum', 0.0320, 'lps'),
	(654611, 134, '2015-01-15 00:11:45.000000', 'consum', 0.0258, 'lps'),
	(654612, 134, '2015-01-15 00:11:46.000000', 'consum', 0.0279, 'lps'),
	(654613, 134, '2015-01-15 00:11:47.000000', 'consum', 0.0253, 'lps'),
	(654614, 134, '2015-01-15 00:11:48.000000', 'consum', 0.0217, 'lps'),
	(654615, 134, '2015-01-15 00:11:49.000000', 'consum', 0.0276, 'lps'),
	(654616, 134, '2015-01-15 00:11:50.000000', 'consum', 0.0360, 'lps'),
	(654617, 134, '2015-01-15 00:11:51.000000', 'consum', 0.0287, 'lps'),
	(654618, 134, '2015-01-15 00:11:52.000000', 'consum', 0.0307, 'lps'),
	(654619, 134, '2015-01-15 00:11:53.000000', 'consum', 0.0303, 'lps'),
	(654620, 134, '2015-01-15 00:11:54.000000', 'consum', 0.0230, 'lps'),
	(654621, 134, '2015-01-15 00:11:55.000000', 'consum', 0.0345, 'lps'),
	(654622, 134, '2015-01-15 00:11:56.000000', 'consum', 0.0354, 'lps'),
	(654623, 134, '2015-01-15 00:11:57.000000', 'consum', 0.0210, 'lps'),
	(654624, 134, '2015-01-15 00:11:58.000000', 'consum', 0.0249, 'lps'),
	(654625, 134, '2015-01-15 00:11:59.000000', 'consum', 0.0251, 'lps'),
	(654626, 134, '2015-01-15 00:12:00.000000', 'consum', 0.0297, 'lps'),
	(654627, 134, '2015-01-15 00:12:01.000000', 'consum', 0.0365, 'lps'),
	(654628, 134, '2015-01-15 00:12:02.000000', 'consum', 0.0251, 'lps'),
	(654629, 134, '2015-01-15 00:12:03.000000', 'consum', 0.0268, 'lps'),
	(654630, 134, '2015-01-15 00:12:04.000000', 'consum', 0.0217, 'lps'),
	(654631, 134, '2015-01-15 00:12:05.000000', 'consum', 0.0229, 'lps'),
	(654632, 134, '2015-01-15 00:12:06.000000', 'consum', 0.0287, 'lps'),
	(654633, 134, '2015-01-15 00:12:07.000000', 'consum', 0.0222, 'lps'),
	(654634, 134, '2015-01-15 00:12:08.000000', 'consum', 0.0353, 'lps'),
	(654635, 134, '2015-01-15 00:12:09.000000', 'consum', 0.0259, 'lps'),
	(654636, 134, '2015-01-15 00:12:10.000000', 'consum', 0.0342, 'lps'),
	(654637, 134, '2015-01-15 00:12:11.000000', 'consum', 0.0251, 'lps'),
	(654638, 134, '2015-01-15 00:12:12.000000', 'consum', 0.0335, 'lps'),
	(654639, 134, '2015-01-15 00:12:13.000000', 'consum', 0.0237, 'lps'),
	(654640, 134, '2015-01-15 00:12:14.000000', 'consum', 0.0287, 'lps'),
	(654641, 134, '2015-01-15 00:12:15.000000', 'consum', 0.0357, 'lps'),
	(654642, 134, '2015-01-15 00:12:16.000000', 'consum', 0.0240, 'lps'),
	(654643, 134, '2015-01-15 00:12:17.000000', 'consum', 0.0237, 'lps'),
	(654644, 134, '2015-01-15 00:12:18.000000', 'consum', 0.0254, 'lps'),
	(654645, 134, '2015-01-15 00:12:19.000000', 'consum', 0.0349, 'lps'),
	(654646, 134, '2015-01-15 00:12:20.000000', 'consum', 0.0299, 'lps'),
	(654647, 134, '2015-01-15 00:12:21.000000', 'consum', 0.0237, 'lps'),
	(654648, 134, '2015-01-15 00:12:22.000000', 'consum', 0.0240, 'lps'),
	(654649, 134, '2015-01-15 00:12:23.000000', 'consum', 0.0276, 'lps'),
	(654650, 134, '2015-01-15 00:12:24.000000', 'consum', 0.0295, 'lps'),
	(654651, 134, '2015-01-15 00:12:25.000000', 'consum', 0.0280, 'lps'),
	(654652, 134, '2015-01-15 00:12:26.000000', 'consum', 0.0305, 'lps'),
	(654653, 134, '2015-01-15 00:12:27.000000', 'consum', 0.0319, 'lps'),
	(654654, 134, '2015-01-15 00:12:28.000000', 'consum', 0.0310, 'lps'),
	(654655, 134, '2015-01-15 00:12:29.000000', 'consum', 0.0226, 'lps'),
	(654656, 134, '2015-01-15 00:12:30.000000', 'consum', 0.0306, 'lps'),
	(654657, 134, '2015-01-15 00:12:31.000000', 'consum', 0.0327, 'lps'),
	(654658, 134, '2015-01-15 00:12:32.000000', 'consum', 0.0351, 'lps'),
	(654659, 134, '2015-01-15 00:12:33.000000', 'consum', 0.0246, 'lps'),
	(654660, 134, '2015-01-15 00:12:34.000000', 'consum', 0.0285, 'lps'),
	(654661, 134, '2015-01-15 00:12:35.000000', 'consum', 0.0320, 'lps'),
	(654662, 134, '2015-01-15 00:12:36.000000', 'consum', 0.0219, 'lps'),
	(654663, 134, '2015-01-15 00:12:37.000000', 'consum', 0.0243, 'lps'),
	(654664, 134, '2015-01-15 00:12:38.000000', 'consum', 0.0350, 'lps'),
	(654665, 134, '2015-01-15 00:12:39.000000', 'consum', 0.0334, 'lps'),
	(654666, 134, '2015-01-15 00:12:40.000000', 'consum', 0.0252, 'lps'),
	(654667, 134, '2015-01-15 00:12:41.000000', 'consum', 0.0366, 'lps'),
	(654668, 134, '2015-01-15 00:12:42.000000', 'consum', 0.0232, 'lps'),
	(654669, 134, '2015-01-15 00:12:43.000000', 'consum', 0.0325, 'lps'),
	(654670, 134, '2015-01-15 00:12:44.000000', 'consum', 0.0246, 'lps'),
	(654671, 134, '2015-01-15 00:12:45.000000', 'consum', 0.0363, 'lps'),
	(654672, 134, '2015-01-15 00:12:46.000000', 'consum', 0.0234, 'lps'),
	(654673, 134, '2015-01-15 00:12:47.000000', 'consum', 0.0345, 'lps'),
	(654674, 134, '2015-01-15 00:12:48.000000', 'consum', 0.0342, 'lps'),
	(654675, 134, '2015-01-15 00:12:49.000000', 'consum', 0.0306, 'lps'),
	(654676, 134, '2015-01-15 00:12:50.000000', 'consum', 0.0294, 'lps'),
	(654677, 134, '2015-01-15 00:12:51.000000', 'consum', 0.0343, 'lps'),
	(654678, 134, '2015-01-15 00:12:52.000000', 'consum', 0.0307, 'lps'),
	(654679, 134, '2015-01-15 00:12:53.000000', 'consum', 0.0295, 'lps'),
	(654680, 134, '2015-01-15 00:12:54.000000', 'consum', 0.0346, 'lps'),
	(654681, 134, '2015-01-15 00:12:55.000000', 'consum', 0.0321, 'lps'),
	(654682, 134, '2015-01-15 00:12:56.000000', 'consum', 0.0356, 'lps'),
	(654683, 134, '2015-01-15 00:12:57.000000', 'consum', 0.0294, 'lps'),
	(654684, 134, '2015-01-15 00:12:58.000000', 'consum', 0.0348, 'lps'),
	(654685, 134, '2015-01-15 00:12:59.000000', 'consum', 0.0331, 'lps'),
	(654686, 134, '2015-01-15 00:13:00.000000', 'consum', 0.0246, 'lps'),
	(654687, 134, '2015-01-15 00:13:01.000000', 'consum', 0.0344, 'lps'),
	(654688, 134, '2015-01-15 00:13:02.000000', 'consum', 0.0297, 'lps'),
	(654689, 134, '2015-01-15 00:13:03.000000', 'consum', 0.0242, 'lps'),
	(654690, 134, '2015-01-15 00:13:04.000000', 'consum', 0.0270, 'lps'),
	(654691, 134, '2015-01-15 00:13:05.000000', 'consum', 0.0254, 'lps'),
	(654692, 134, '2015-01-15 00:13:06.000000', 'consum', 0.0252, 'lps'),
	(654693, 134, '2015-01-15 00:13:07.000000', 'consum', 0.0286, 'lps'),
	(654694, 134, '2015-01-15 00:13:08.000000', 'consum', 0.0309, 'lps'),
	(654695, 134, '2015-01-15 00:13:09.000000', 'consum', 0.0318, 'lps'),
	(654696, 134, '2015-01-15 00:13:10.000000', 'consum', 0.0294, 'lps'),
	(654697, 134, '2015-01-15 00:13:11.000000', 'consum', 0.0310, 'lps'),
	(654698, 134, '2015-01-15 00:13:12.000000', 'consum', 0.0299, 'lps'),
	(654699, 134, '2015-01-15 00:13:13.000000', 'consum', 0.0355, 'lps'),
	(654700, 134, '2015-01-15 00:13:14.000000', 'consum', 0.0351, 'lps'),
	(654701, 134, '2015-01-15 00:13:15.000000', 'consum', 0.0326, 'lps'),
	(654702, 134, '2015-01-15 00:13:16.000000', 'consum', 0.0365, 'lps'),
	(654703, 134, '2015-01-15 00:13:17.000000', 'consum', 0.0323, 'lps'),
	(654704, 134, '2015-01-15 00:13:18.000000', 'consum', 0.0308, 'lps'),
	(654705, 134, '2015-01-15 00:13:19.000000', 'consum', 0.0364, 'lps'),
	(654706, 134, '2015-01-15 00:13:20.000000', 'consum', 0.0214, 'lps'),
	(654707, 134, '2015-01-15 00:13:21.000000', 'consum', 0.0239, 'lps'),
	(654708, 134, '2015-01-15 00:13:22.000000', 'consum', 0.0344, 'lps'),
	(654709, 134, '2015-01-15 00:13:23.000000', 'consum', 0.0321, 'lps'),
	(654710, 134, '2015-01-15 00:13:24.000000', 'consum', 0.0362, 'lps'),
	(654711, 134, '2015-01-15 00:13:25.000000', 'consum', 0.0322, 'lps'),
	(654712, 134, '2015-01-15 00:13:26.000000', 'consum', 0.0317, 'lps'),
	(654713, 134, '2015-01-15 00:13:27.000000', 'consum', 0.0248, 'lps'),
	(654714, 134, '2015-01-15 00:13:28.000000', 'consum', 0.0241, 'lps'),
	(654715, 134, '2015-01-15 00:13:29.000000', 'consum', 0.0249, 'lps'),
	(654716, 134, '2015-01-15 00:13:30.000000', 'consum', 0.0312, 'lps'),
	(654717, 134, '2015-01-15 00:13:31.000000', 'consum', 0.0290, 'lps'),
	(654718, 134, '2015-01-15 00:13:32.000000', 'consum', 0.0303, 'lps'),
	(654719, 134, '2015-01-15 00:13:33.000000', 'consum', 0.0276, 'lps'),
	(654720, 134, '2015-01-15 00:13:34.000000', 'consum', 0.0263, 'lps'),
	(654721, 134, '2015-01-15 00:13:35.000000', 'consum', 0.0278, 'lps'),
	(654722, 134, '2015-01-15 00:13:36.000000', 'consum', 0.0233, 'lps'),
	(654723, 134, '2015-01-15 00:13:37.000000', 'consum', 0.0281, 'lps'),
	(654724, 134, '2015-01-15 00:13:38.000000', 'consum', 0.0339, 'lps'),
	(654725, 134, '2015-01-15 00:13:39.000000', 'consum', 0.0327, 'lps'),
	(654726, 134, '2015-01-15 00:13:40.000000', 'consum', 0.0250, 'lps'),
	(654727, 134, '2015-01-15 00:13:41.000000', 'consum', 0.0218, 'lps'),
	(654728, 134, '2015-01-15 00:13:42.000000', 'consum', 0.0287, 'lps'),
	(654729, 134, '2015-01-15 00:13:43.000000', 'consum', 0.0254, 'lps'),
	(654730, 134, '2015-01-15 00:13:44.000000', 'consum', 0.0360, 'lps'),
	(654731, 134, '2015-01-15 00:13:45.000000', 'consum', 0.0355, 'lps'),
	(654732, 134, '2015-01-15 00:13:46.000000', 'consum', 0.0328, 'lps'),
	(654733, 134, '2015-01-15 00:13:47.000000', 'consum', 0.0365, 'lps'),
	(654734, 134, '2015-01-15 00:13:48.000000', 'consum', 0.0316, 'lps'),
	(654735, 134, '2015-01-15 00:13:49.000000', 'consum', 0.0276, 'lps'),
	(654736, 134, '2015-01-15 00:13:50.000000', 'consum', 0.0223, 'lps'),
	(654737, 134, '2015-01-15 00:13:51.000000', 'consum', 0.0236, 'lps'),
	(654738, 134, '2015-01-15 00:13:52.000000', 'consum', 0.0302, 'lps'),
	(654739, 134, '2015-01-15 00:13:53.000000', 'consum', 0.0275, 'lps'),
	(654740, 134, '2015-01-15 00:13:54.000000', 'consum', 0.0260, 'lps'),
	(654741, 134, '2015-01-15 00:13:55.000000', 'consum', 0.0264, 'lps'),
	(654742, 134, '2015-01-15 00:13:56.000000', 'consum', 0.0331, 'lps'),
	(654743, 134, '2015-01-15 00:13:57.000000', 'consum', 0.0337, 'lps'),
	(654744, 134, '2015-01-15 00:13:58.000000', 'consum', 0.0327, 'lps'),
	(654745, 134, '2015-01-15 00:13:59.000000', 'consum', 0.0256, 'lps'),
	(654746, 134, '2015-01-15 00:14:00.000000', 'consum', 0.0247, 'lps'),
	(654747, 134, '2015-01-15 00:14:01.000000', 'consum', 0.0257, 'lps'),
	(654748, 134, '2015-01-15 00:14:02.000000', 'consum', 0.0333, 'lps'),
	(654749, 134, '2015-01-15 00:14:03.000000', 'consum', 0.0210, 'lps'),
	(654750, 134, '2015-01-15 00:14:04.000000', 'consum', 0.0319, 'lps'),
	(654751, 134, '2015-01-15 00:14:05.000000', 'consum', 0.0278, 'lps'),
	(654752, 134, '2015-01-15 00:14:06.000000', 'consum', 0.0225, 'lps'),
	(654753, 134, '2015-01-15 00:14:07.000000', 'consum', 0.0240, 'lps'),
	(654754, 134, '2015-01-15 00:14:08.000000', 'consum', 0.0315, 'lps'),
	(654755, 134, '2015-01-15 00:14:09.000000', 'consum', 0.0330, 'lps'),
	(654756, 134, '2015-01-15 00:14:10.000000', 'consum', 0.0337, 'lps'),
	(654757, 134, '2015-01-15 00:14:11.000000', 'consum', 0.0328, 'lps'),
	(654758, 134, '2015-01-15 00:14:12.000000', 'consum', 0.0262, 'lps'),
	(654759, 134, '2015-01-15 00:14:13.000000', 'consum', 0.0273, 'lps'),
	(654760, 134, '2015-01-15 00:14:14.000000', 'consum', 0.0212, 'lps'),
	(654761, 134, '2015-01-15 00:14:15.000000', 'consum', 0.0347, 'lps'),
	(654762, 134, '2015-01-15 00:14:16.000000', 'consum', 0.0259, 'lps'),
	(654763, 134, '2015-01-15 00:14:17.000000', 'consum', 0.0361, 'lps'),
	(654764, 134, '2015-01-15 00:14:18.000000', 'consum', 0.0344, 'lps'),
	(654765, 134, '2015-01-15 00:14:19.000000', 'consum', 0.0267, 'lps'),
	(654766, 134, '2015-01-15 00:14:20.000000', 'consum', 0.0255, 'lps'),
	(654767, 134, '2015-01-15 00:14:21.000000', 'consum', 0.0263, 'lps'),
	(654768, 134, '2015-01-15 00:14:22.000000', 'consum', 0.0341, 'lps'),
	(654769, 134, '2015-01-15 00:14:23.000000', 'consum', 0.0231, 'lps'),
	(654770, 134, '2015-01-15 00:14:24.000000', 'consum', 0.0239, 'lps'),
	(654771, 134, '2015-01-15 00:14:25.000000', 'consum', 0.0294, 'lps'),
	(654772, 134, '2015-01-15 00:14:26.000000', 'consum', 0.0227, 'lps'),
	(654773, 134, '2015-01-15 00:14:27.000000', 'consum', 0.0360, 'lps'),
	(654774, 134, '2015-01-15 00:14:28.000000', 'consum', 0.0275, 'lps'),
	(654775, 134, '2015-01-15 00:14:29.000000', 'consum', 0.0246, 'lps'),
	(654776, 134, '2015-01-15 00:14:30.000000', 'consum', 0.0352, 'lps'),
	(654777, 134, '2015-01-15 00:14:31.000000', 'consum', 0.0338, 'lps'),
	(654778, 134, '2015-01-15 00:14:32.000000', 'consum', 0.0267, 'lps'),
	(654779, 134, '2015-01-15 00:14:33.000000', 'consum', 0.0272, 'lps'),
	(654780, 134, '2015-01-15 00:14:34.000000', 'consum', 0.0347, 'lps'),
	(654781, 134, '2015-01-15 00:14:35.000000', 'consum', 0.0236, 'lps'),
	(654782, 134, '2015-01-15 00:14:36.000000', 'consum', 0.0243, 'lps'),
	(654783, 134, '2015-01-15 00:14:37.000000', 'consum', 0.0301, 'lps'),
	(654784, 134, '2015-01-15 00:14:38.000000', 'consum', 0.0251, 'lps'),
	(654785, 134, '2015-01-15 00:14:39.000000', 'consum', 0.0299, 'lps'),
	(654786, 134, '2015-01-15 00:14:40.000000', 'consum', 0.0219, 'lps'),
	(654787, 134, '2015-01-15 00:14:41.000000', 'consum', 0.0302, 'lps'),
	(654788, 134, '2015-01-15 00:14:42.000000', 'consum', 0.0327, 'lps'),
	(654789, 134, '2015-01-15 00:14:43.000000', 'consum', 0.0362, 'lps'),
	(654790, 134, '2015-01-15 00:14:44.000000', 'consum', 0.0303, 'lps'),
	(654791, 134, '2015-01-15 00:14:45.000000', 'consum', 0.0221, 'lps'),
	(654792, 134, '2015-01-15 00:14:46.000000', 'consum', 0.0301, 'lps'),
	(654793, 134, '2015-01-15 00:14:47.000000', 'consum', 0.0318, 'lps'),
	(654794, 134, '2015-01-15 00:14:48.000000', 'consum', 0.0321, 'lps'),
	(654795, 134, '2015-01-15 00:14:49.000000', 'consum', 0.0281, 'lps'),
	(654796, 134, '2015-01-15 00:14:50.000000', 'consum', 0.0235, 'lps'),
	(654797, 134, '2015-01-15 00:14:51.000000', 'consum', 0.0280, 'lps'),
	(654798, 134, '2015-01-15 00:14:52.000000', 'consum', 0.0327, 'lps'),
	(654799, 134, '2015-01-15 00:14:53.000000', 'consum', 0.0272, 'lps'),
	(654800, 134, '2015-01-15 00:14:54.000000', 'consum', 0.0324, 'lps'),
	(654801, 134, '2015-01-15 00:14:55.000000', 'consum', 0.0279, 'lps'),
	(654802, 134, '2015-01-15 00:14:56.000000', 'consum', 0.0215, 'lps'),
	(654803, 134, '2015-01-15 00:14:57.000000', 'consum', 0.0343, 'lps'),
	(654804, 134, '2015-01-15 00:14:58.000000', 'consum', 0.0229, 'lps'),
	(654805, 134, '2015-01-15 00:14:59.000000', 'consum', 0.0222, 'lps'),
	(654806, 134, '2015-01-15 00:15:00.000000', 'consum', 0.0215, 'lps'),
	(654807, 134, '2015-01-15 00:15:01.000000', 'consum', 0.0355, 'lps'),
	(654808, 134, '2015-01-15 00:15:02.000000', 'consum', 0.0290, 'lps'),
	(654809, 134, '2015-01-15 00:15:03.000000', 'consum', 0.0334, 'lps'),
	(654810, 134, '2015-01-15 00:15:04.000000', 'consum', 0.0274, 'lps'),
	(654811, 134, '2015-01-15 00:15:05.000000', 'consum', 0.0318, 'lps'),
	(654812, 134, '2015-01-15 00:15:06.000000', 'consum', 0.0243, 'lps'),
	(654813, 134, '2015-01-15 00:15:07.000000', 'consum', 0.0365, 'lps'),
	(654814, 134, '2015-01-15 00:15:08.000000', 'consum', 0.0257, 'lps'),
	(654815, 134, '2015-01-15 00:15:09.000000', 'consum', 0.0297, 'lps'),
	(654816, 134, '2015-01-15 00:15:10.000000', 'consum', 0.0345, 'lps'),
	(654817, 134, '2015-01-15 00:15:11.000000', 'consum', 0.0310, 'lps'),
	(654818, 134, '2015-01-15 00:15:12.000000', 'consum', 0.0303, 'lps'),
	(654819, 134, '2015-01-15 00:15:13.000000', 'consum', 0.0219, 'lps'),
	(654820, 134, '2015-01-15 00:15:14.000000', 'consum', 0.0290, 'lps'),
	(654821, 134, '2015-01-15 00:15:15.000000', 'consum', 0.0271, 'lps'),
	(654822, 134, '2015-01-15 00:15:16.000000', 'consum', 0.0273, 'lps'),
	(654823, 134, '2015-01-15 00:15:17.000000', 'consum', 0.0345, 'lps'),
	(654824, 134, '2015-01-15 00:15:18.000000', 'consum', 0.0219, 'lps'),
	(654825, 134, '2015-01-15 00:15:19.000000', 'consum', 0.0328, 'lps'),
	(654826, 134, '2015-01-15 00:15:20.000000', 'consum', 0.0299, 'lps'),
	(654827, 134, '2015-01-15 00:15:21.000000', 'consum', 0.0301, 'lps'),
	(654828, 134, '2015-01-15 00:15:22.000000', 'consum', 0.0239, 'lps'),
	(654829, 134, '2015-01-15 00:15:23.000000', 'consum', 0.0240, 'lps'),
	(654830, 134, '2015-01-15 00:15:24.000000', 'consum', 0.0273, 'lps'),
	(654831, 134, '2015-01-15 00:15:25.000000', 'consum', 0.0276, 'lps'),
	(654832, 134, '2015-01-15 00:15:26.000000', 'consum', 0.0355, 'lps'),
	(654833, 134, '2015-01-15 00:15:27.000000', 'consum', 0.0264, 'lps'),
	(654834, 134, '2015-01-15 00:15:28.000000', 'consum', 0.0358, 'lps'),
	(654835, 134, '2015-01-15 00:15:29.000000', 'consum', 0.0317, 'lps'),
	(654836, 134, '2015-01-15 00:15:30.000000', 'consum', 0.0302, 'lps'),
	(654837, 134, '2015-01-15 00:15:31.000000', 'consum', 0.0347, 'lps'),
	(654838, 134, '2015-01-15 00:15:32.000000', 'consum', 0.0305, 'lps'),
	(654839, 134, '2015-01-15 00:15:33.000000', 'consum', 0.0275, 'lps'),
	(654840, 134, '2015-01-15 00:15:34.000000', 'consum', 0.0252, 'lps'),
	(654841, 134, '2015-01-15 00:15:35.000000', 'consum', 0.0223, 'lps'),
	(654842, 134, '2015-01-15 00:15:36.000000', 'consum', 0.0310, 'lps'),
	(654843, 134, '2015-01-15 00:15:37.000000', 'consum', 0.0353, 'lps'),
	(654844, 134, '2015-01-15 00:15:38.000000', 'consum', 0.0312, 'lps'),
	(654845, 134, '2015-01-15 00:15:39.000000', 'consum', 0.0289, 'lps'),
	(654846, 134, '2015-01-15 00:15:40.000000', 'consum', 0.0299, 'lps'),
	(654847, 134, '2015-01-15 00:15:41.000000', 'consum', 0.0261, 'lps'),
	(654848, 134, '2015-01-15 00:15:42.000000', 'consum', 0.0357, 'lps'),
	(654849, 134, '2015-01-15 00:15:43.000000', 'consum', 0.0321, 'lps'),
	(654850, 134, '2015-01-15 00:15:44.000000', 'consum', 0.0321, 'lps'),
	(654851, 134, '2015-01-15 00:15:45.000000', 'consum', 0.0274, 'lps'),
	(654852, 134, '2015-01-15 00:15:46.000000', 'consum', 0.0358, 'lps'),
	(654853, 134, '2015-01-15 00:15:47.000000', 'consum', 0.0283, 'lps'),
	(654854, 134, '2015-01-15 00:15:48.000000', 'consum', 0.0289, 'lps'),
	(654855, 134, '2015-01-15 00:15:49.000000', 'consum', 0.0230, 'lps'),
	(654856, 134, '2015-01-15 00:15:50.000000', 'consum', 0.0231, 'lps'),
	(654857, 134, '2015-01-15 00:15:51.000000', 'consum', 0.0257, 'lps'),
	(654858, 134, '2015-01-15 00:15:52.000000', 'consum', 0.0224, 'lps'),
	(654859, 134, '2015-01-15 00:15:53.000000', 'consum', 0.0298, 'lps'),
	(654860, 134, '2015-01-15 00:15:54.000000', 'consum', 0.0291, 'lps'),
	(654861, 134, '2015-01-15 00:15:55.000000', 'consum', 0.0352, 'lps'),
	(654862, 134, '2015-01-15 00:15:56.000000', 'consum', 0.0360, 'lps'),
	(654863, 134, '2015-01-15 00:15:57.000000', 'consum', 0.0221, 'lps'),
	(654864, 134, '2015-01-15 00:15:58.000000', 'consum', 0.0290, 'lps'),
	(654865, 134, '2015-01-15 00:15:59.000000', 'consum', 0.0262, 'lps'),
	(654866, 134, '2015-01-15 00:16:00.000000', 'consum', 0.0230, 'lps'),
	(654867, 134, '2015-01-15 00:16:01.000000', 'consum', 0.0313, 'lps'),
	(654868, 134, '2015-01-15 00:16:02.000000', 'consum', 0.0349, 'lps'),
	(654869, 134, '2015-01-15 00:16:03.000000', 'consum', 0.0282, 'lps'),
	(654870, 134, '2015-01-15 00:16:04.000000', 'consum', 0.0312, 'lps'),
	(654871, 134, '2015-01-15 00:16:05.000000', 'consum', 0.0347, 'lps'),
	(654872, 134, '2015-01-15 00:16:06.000000', 'consum', 0.0272, 'lps'),
	(654873, 134, '2015-01-15 00:16:07.000000', 'consum', 0.0268, 'lps'),
	(654874, 134, '2015-01-15 00:16:08.000000', 'consum', 0.0314, 'lps'),
	(654875, 134, '2015-01-15 00:16:09.000000', 'consum', 0.0241, 'lps'),
	(654876, 134, '2015-01-15 00:16:10.000000', 'consum', 0.0213, 'lps'),
	(654877, 134, '2015-01-15 00:16:11.000000', 'consum', 0.0287, 'lps'),
	(654878, 134, '2015-01-15 00:16:12.000000', 'consum', 0.0273, 'lps'),
	(654879, 134, '2015-01-15 00:16:13.000000', 'consum', 0.0294, 'lps'),
	(654880, 134, '2015-01-15 00:16:14.000000', 'consum', 0.0284, 'lps'),
	(654881, 134, '2015-01-15 00:16:15.000000', 'consum', 0.0326, 'lps'),
	(654882, 134, '2015-01-15 00:16:16.000000', 'consum', 0.0254, 'lps'),
	(654883, 134, '2015-01-15 00:16:17.000000', 'consum', 0.0239, 'lps'),
	(654884, 134, '2015-01-15 00:16:18.000000', 'consum', 0.0226, 'lps'),
	(654885, 134, '2015-01-15 00:16:19.000000', 'consum', 0.0362, 'lps'),
	(654886, 134, '2015-01-15 00:16:20.000000', 'consum', 0.0289, 'lps'),
	(654887, 134, '2015-01-15 00:16:21.000000', 'consum', 0.0310, 'lps'),
	(654888, 134, '2015-01-15 00:16:22.000000', 'consum', 0.0313, 'lps'),
	(654889, 134, '2015-01-15 00:16:23.000000', 'consum', 0.0270, 'lps'),
	(654890, 134, '2015-01-15 00:16:24.000000', 'consum', 0.0358, 'lps'),
	(654891, 134, '2015-01-15 00:16:25.000000', 'consum', 0.0296, 'lps'),
	(654892, 134, '2015-01-15 00:16:26.000000', 'consum', 0.0356, 'lps'),
	(654893, 134, '2015-01-15 00:16:27.000000', 'consum', 0.0365, 'lps'),
	(654894, 134, '2015-01-15 00:16:28.000000', 'consum', 0.0233, 'lps'),
	(654895, 134, '2015-01-15 00:16:29.000000', 'consum', 0.0336, 'lps'),
	(654896, 134, '2015-01-15 00:16:30.000000', 'consum', 0.0295, 'lps'),
	(654897, 134, '2015-01-15 00:16:31.000000', 'consum', 0.0260, 'lps'),
	(654898, 134, '2015-01-15 00:16:32.000000', 'consum', 0.0363, 'lps'),
	(654899, 134, '2015-01-15 00:16:33.000000', 'consum', 0.0351, 'lps'),
	(654900, 134, '2015-01-15 00:16:34.000000', 'consum', 0.0299, 'lps'),
	(654901, 134, '2015-01-15 00:16:35.000000', 'consum', 0.0232, 'lps'),
	(654902, 134, '2015-01-15 00:16:36.000000', 'consum', 0.0211, 'lps'),
	(654903, 134, '2015-01-15 00:16:37.000000', 'consum', 0.0307, 'lps'),
	(654904, 134, '2015-01-15 00:16:38.000000', 'consum', 0.0218, 'lps'),
	(654905, 134, '2015-01-15 00:16:39.000000', 'consum', 0.0278, 'lps'),
	(654906, 134, '2015-01-15 00:16:40.000000', 'consum', 0.0367, 'lps'),
	(654907, 134, '2015-01-15 00:16:41.000000', 'consum', 0.0319, 'lps'),
	(654908, 134, '2015-01-15 00:16:42.000000', 'consum', 0.0285, 'lps'),
	(654909, 134, '2015-01-15 00:16:43.000000', 'consum', 0.0259, 'lps'),
	(654910, 134, '2015-01-15 00:16:44.000000', 'consum', 0.0229, 'lps'),
	(654911, 134, '2015-01-15 00:16:45.000000', 'consum', 0.0318, 'lps'),
	(654912, 134, '2015-01-15 00:16:46.000000', 'consum', 0.0221, 'lps'),
	(654913, 134, '2015-01-15 00:16:47.000000', 'consum', 0.0254, 'lps'),
	(654914, 134, '2015-01-15 00:16:48.000000', 'consum', 0.0242, 'lps'),
	(654915, 134, '2015-01-15 00:16:49.000000', 'consum', 0.0238, 'lps'),
	(654916, 134, '2015-01-15 00:16:50.000000', 'consum', 0.0256, 'lps'),
	(654917, 134, '2015-01-15 00:16:51.000000', 'consum', 0.0355, 'lps'),
	(654918, 134, '2015-01-15 00:16:52.000000', 'consum', 0.0323, 'lps'),
	(654919, 134, '2015-01-15 00:16:53.000000', 'consum', 0.0339, 'lps'),
	(654920, 134, '2015-01-15 00:16:54.000000', 'consum', 0.0361, 'lps'),
	(654921, 134, '2015-01-15 00:16:55.000000', 'consum', 0.0261, 'lps'),
	(654922, 134, '2015-01-15 00:16:56.000000', 'consum', 0.0328, 'lps'),
	(654923, 134, '2015-01-15 00:16:57.000000', 'consum', 0.0330, 'lps'),
	(654924, 134, '2015-01-15 00:16:58.000000', 'consum', 0.0302, 'lps'),
	(654925, 134, '2015-01-15 00:16:59.000000', 'consum', 0.0309, 'lps'),
	(654926, 134, '2015-01-15 00:17:00.000000', 'consum', 0.0271, 'lps'),
	(654927, 134, '2015-01-15 00:17:01.000000', 'consum', 0.0220, 'lps'),
	(654928, 134, '2015-01-15 00:17:02.000000', 'consum', 0.0234, 'lps'),
	(654929, 134, '2015-01-15 00:17:03.000000', 'consum', 0.0301, 'lps'),
	(654930, 134, '2015-01-15 00:17:04.000000', 'consum', 0.0279, 'lps'),
	(654931, 134, '2015-01-15 00:17:05.000000', 'consum', 0.0283, 'lps'),
	(654932, 134, '2015-01-15 00:17:06.000000', 'consum', 0.0366, 'lps'),
	(654933, 134, '2015-01-15 00:17:07.000000', 'consum', 0.0297, 'lps'),
	(654934, 134, '2015-01-15 00:17:08.000000', 'consum', 0.0337, 'lps'),
	(654935, 134, '2015-01-15 00:17:09.000000', 'consum', 0.0267, 'lps'),
	(654936, 134, '2015-01-15 00:17:10.000000', 'consum', 0.0273, 'lps'),
	(654937, 134, '2015-01-15 00:17:11.000000', 'consum', 0.0355, 'lps'),
	(654938, 134, '2015-01-15 00:17:12.000000', 'consum', 0.0272, 'lps'),
	(654939, 134, '2015-01-15 00:17:13.000000', 'consum', 0.0245, 'lps'),
	(654940, 134, '2015-01-15 00:17:14.000000', 'consum', 0.0356, 'lps'),
	(654941, 134, '2015-01-15 00:17:15.000000', 'consum', 0.0361, 'lps'),
	(654942, 134, '2015-01-15 00:17:16.000000', 'consum', 0.0214, 'lps'),
	(654943, 134, '2015-01-15 00:17:17.000000', 'consum', 0.0249, 'lps'),
	(654944, 134, '2015-01-15 00:17:18.000000', 'consum', 0.0237, 'lps'),
	(654945, 134, '2015-01-15 00:17:19.000000', 'consum', 0.0229, 'lps'),
	(654946, 134, '2015-01-15 00:17:20.000000', 'consum', 0.0225, 'lps'),
	(654947, 134, '2015-01-15 00:17:21.000000', 'consum', 0.0228, 'lps'),
	(654948, 134, '2015-01-15 00:17:22.000000', 'consum', 0.0254, 'lps'),
	(654949, 134, '2015-01-15 00:17:23.000000', 'consum', 0.0218, 'lps'),
	(654950, 134, '2015-01-15 00:17:24.000000', 'consum', 0.0279, 'lps'),
	(654951, 134, '2015-01-15 00:17:25.000000', 'consum', 0.0215, 'lps'),
	(654952, 134, '2015-01-15 00:17:26.000000', 'consum', 0.0345, 'lps'),
	(654953, 134, '2015-01-15 00:17:27.000000', 'consum', 0.0237, 'lps'),
	(654954, 134, '2015-01-15 00:17:28.000000', 'consum', 0.0258, 'lps'),
	(654955, 134, '2015-01-15 00:17:29.000000', 'consum', 0.0212, 'lps'),
	(654956, 134, '2015-01-15 00:17:30.000000', 'consum', 0.0232, 'lps'),
	(654957, 134, '2015-01-15 00:17:31.000000', 'consum', 0.0316, 'lps'),
	(654958, 134, '2015-01-15 00:17:32.000000', 'consum', 0.0360, 'lps'),
	(654959, 134, '2015-01-15 00:17:33.000000', 'consum', 0.0327, 'lps'),
	(654960, 134, '2015-01-15 00:17:34.000000', 'consum', 0.0344, 'lps'),
	(654961, 134, '2015-01-15 00:17:35.000000', 'consum', 0.0216, 'lps'),
	(654962, 134, '2015-01-15 00:17:36.000000', 'consum', 0.0309, 'lps'),
	(654963, 134, '2015-01-15 00:17:37.000000', 'consum', 0.0215, 'lps'),
	(654964, 134, '2015-01-15 00:17:38.000000', 'consum', 0.0254, 'lps'),
	(654965, 134, '2015-01-15 00:17:39.000000', 'consum', 0.0257, 'lps'),
	(654966, 134, '2015-01-15 00:17:40.000000', 'consum', 0.0316, 'lps'),
	(654967, 134, '2015-01-15 00:17:41.000000', 'consum', 0.0283, 'lps'),
	(654968, 134, '2015-01-15 00:17:42.000000', 'consum', 0.0256, 'lps'),
	(654969, 134, '2015-01-15 00:17:43.000000', 'consum', 0.0224, 'lps'),
	(654970, 134, '2015-01-15 00:17:44.000000', 'consum', 0.0300, 'lps'),
	(654971, 134, '2015-01-15 00:17:45.000000', 'consum', 0.0301, 'lps'),
	(654972, 134, '2015-01-15 00:17:46.000000', 'consum', 0.0240, 'lps'),
	(654973, 134, '2015-01-15 00:17:47.000000', 'consum', 0.0243, 'lps'),
	(654974, 134, '2015-01-15 00:17:48.000000', 'consum', 0.0285, 'lps'),
	(654975, 134, '2015-01-15 00:17:49.000000', 'consum', 0.0331, 'lps'),
	(654976, 134, '2015-01-15 00:17:50.000000', 'consum', 0.0272, 'lps'),
	(654977, 134, '2015-01-15 00:17:51.000000', 'consum', 0.0318, 'lps'),
	(654978, 134, '2015-01-15 00:17:52.000000', 'consum', 0.0249, 'lps'),
	(654979, 134, '2015-01-15 00:17:53.000000', 'consum', 0.0237, 'lps'),
	(654980, 134, '2015-01-15 00:17:54.000000', 'consum', 0.0230, 'lps'),
	(654981, 134, '2015-01-15 00:17:55.000000', 'consum', 0.0230, 'lps'),
	(654982, 134, '2015-01-15 00:17:56.000000', 'consum', 0.0248, 'lps'),
	(654983, 134, '2015-01-15 00:17:57.000000', 'consum', 0.0341, 'lps'),
	(654984, 134, '2015-01-15 00:17:58.000000', 'consum', 0.0279, 'lps'),
	(654985, 134, '2015-01-15 00:17:59.000000', 'consum', 0.0321, 'lps'),
	(654986, 134, '2015-01-15 00:18:00.000000', 'consum', 0.0240, 'lps'),
	(654987, 134, '2015-01-15 00:18:01.000000', 'consum', 0.0344, 'lps'),
	(654988, 134, '2015-01-15 00:18:02.000000', 'consum', 0.0318, 'lps'),
	(654989, 134, '2015-01-15 00:18:03.000000', 'consum', 0.0348, 'lps'),
	(654990, 134, '2015-01-15 00:18:04.000000', 'consum', 0.0261, 'lps'),
	(654991, 134, '2015-01-15 00:18:05.000000', 'consum', 0.0210, 'lps'),
	(654992, 134, '2015-01-15 00:18:06.000000', 'consum', 0.0214, 'lps'),
	(654993, 134, '2015-01-15 00:18:07.000000', 'consum', 0.0231, 'lps'),
	(654994, 134, '2015-01-15 00:18:08.000000', 'consum', 0.0302, 'lps'),
	(654995, 134, '2015-01-15 00:18:09.000000', 'consum', 0.0291, 'lps'),
	(654996, 134, '2015-01-15 00:18:10.000000', 'consum', 0.0341, 'lps'),
	(654997, 134, '2015-01-15 00:18:11.000000', 'consum', 0.0307, 'lps'),
	(654998, 134, '2015-01-15 00:18:12.000000', 'consum', 0.0301, 'lps'),
	(654999, 134, '2015-01-15 00:18:13.000000', 'consum', 0.0219, 'lps'),
	(655000, 134, '2015-01-15 00:18:14.000000', 'consum', 0.0296, 'lps'),
	(655001, 134, '2015-01-15 00:18:15.000000', 'consum', 0.0300, 'lps'),
	(655002, 134, '2015-01-15 00:18:16.000000', 'consum', 0.0245, 'lps'),
	(655003, 134, '2015-01-15 00:18:17.000000', 'consum', 0.0273, 'lps'),
	(655004, 134, '2015-01-15 00:18:18.000000', 'consum', 0.0261, 'lps'),
	(655005, 134, '2015-01-15 00:18:19.000000', 'consum', 0.0276, 'lps'),
	(655006, 134, '2015-01-15 00:18:20.000000', 'consum', 0.0231, 'lps'),
	(655007, 134, '2015-01-15 00:18:21.000000', 'consum', 0.0274, 'lps'),
	(655008, 134, '2015-01-15 00:18:22.000000', 'consum', 0.0311, 'lps'),
	(655009, 134, '2015-01-15 00:18:23.000000', 'consum', 0.0365, 'lps'),
	(655010, 134, '2015-01-15 00:18:24.000000', 'consum', 0.0210, 'lps'),
	(655011, 134, '2015-01-15 00:18:25.000000', 'consum', 0.0218, 'lps'),
	(655012, 134, '2015-01-15 00:18:26.000000', 'consum', 0.0250, 'lps'),
	(655013, 134, '2015-01-15 00:18:27.000000', 'consum', 0.0231, 'lps'),
	(655014, 134, '2015-01-15 00:18:28.000000', 'consum', 0.0351, 'lps'),
	(655015, 134, '2015-01-15 00:18:29.000000', 'consum', 0.0221, 'lps'),
	(655016, 134, '2015-01-15 00:18:30.000000', 'consum', 0.0317, 'lps'),
	(655017, 134, '2015-01-15 00:18:31.000000', 'consum', 0.0239, 'lps'),
	(655018, 134, '2015-01-15 00:18:32.000000', 'consum', 0.0351, 'lps'),
	(655019, 134, '2015-01-15 00:18:33.000000', 'consum', 0.0355, 'lps'),
	(655020, 134, '2015-01-15 00:18:34.000000', 'consum', 0.0353, 'lps'),
	(655021, 134, '2015-01-15 00:18:35.000000', 'consum', 0.0331, 'lps'),
	(655022, 134, '2015-01-15 00:18:36.000000', 'consum', 0.0232, 'lps'),
	(655023, 134, '2015-01-15 00:18:37.000000', 'consum', 0.0270, 'lps'),
	(655024, 134, '2015-01-15 00:18:38.000000', 'consum', 0.0288, 'lps'),
	(655025, 134, '2015-01-15 00:18:39.000000', 'consum', 0.0262, 'lps'),
	(655026, 134, '2015-01-15 00:18:40.000000', 'consum', 0.0236, 'lps'),
	(655027, 134, '2015-01-15 00:18:41.000000', 'consum', 0.0343, 'lps'),
	(655028, 134, '2015-01-15 00:18:42.000000', 'consum', 0.0324, 'lps'),
	(655029, 134, '2015-01-15 00:18:43.000000', 'consum', 0.0223, 'lps'),
	(655030, 134, '2015-01-15 00:18:44.000000', 'consum', 0.0248, 'lps'),
	(655031, 134, '2015-01-15 00:18:45.000000', 'consum', 0.0364, 'lps'),
	(655032, 134, '2015-01-15 00:18:46.000000', 'consum', 0.0232, 'lps'),
	(655033, 134, '2015-01-15 00:18:47.000000', 'consum', 0.0335, 'lps'),
	(655034, 134, '2015-01-15 00:18:48.000000', 'consum', 0.0294, 'lps'),
	(655035, 134, '2015-01-15 00:18:49.000000', 'consum', 0.0257, 'lps'),
	(655036, 134, '2015-01-15 00:18:50.000000', 'consum', 0.0350, 'lps'),
	(655037, 134, '2015-01-15 00:18:51.000000', 'consum', 0.0298, 'lps'),
	(655038, 134, '2015-01-15 00:18:52.000000', 'consum', 0.0228, 'lps'),
	(655039, 134, '2015-01-15 00:18:53.000000', 'consum', 0.0352, 'lps'),
	(655040, 134, '2015-01-15 00:18:54.000000', 'consum', 0.0235, 'lps'),
	(655041, 134, '2015-01-15 00:18:55.000000', 'consum', 0.0224, 'lps'),
	(655042, 134, '2015-01-15 00:18:56.000000', 'consum', 0.0364, 'lps'),
	(655043, 134, '2015-01-15 00:18:57.000000', 'consum', 0.0307, 'lps'),
	(655044, 134, '2015-01-15 00:18:58.000000', 'consum', 0.0233, 'lps'),
	(655045, 134, '2015-01-15 00:18:59.000000', 'consum', 0.0352, 'lps'),
	(655046, 134, '2015-01-15 00:19:00.000000', 'consum', 0.0217, 'lps'),
	(655047, 134, '2015-01-15 00:19:01.000000', 'consum', 0.0295, 'lps'),
	(655048, 134, '2015-01-15 00:19:02.000000', 'consum', 0.0300, 'lps'),
	(655049, 134, '2015-01-15 00:19:03.000000', 'consum', 0.0245, 'lps'),
	(655050, 134, '2015-01-15 00:19:04.000000', 'consum', 0.0275, 'lps'),
	(655051, 134, '2015-01-15 00:19:05.000000', 'consum', 0.0270, 'lps'),
	(655052, 134, '2015-01-15 00:19:06.000000', 'consum', 0.0317, 'lps'),
	(655053, 134, '2015-01-15 00:19:07.000000', 'consum', 0.0251, 'lps'),
	(655054, 134, '2015-01-15 00:19:08.000000', 'consum', 0.0251, 'lps'),
	(655055, 134, '2015-01-15 00:19:09.000000', 'consum', 0.0294, 'lps'),
	(655056, 134, '2015-01-15 00:19:10.000000', 'consum', 0.0348, 'lps'),
	(655057, 134, '2015-01-15 00:19:11.000000', 'consum', 0.0333, 'lps'),
	(655058, 134, '2015-01-15 00:19:12.000000', 'consum', 0.0255, 'lps'),
	(655059, 134, '2015-01-15 00:19:13.000000', 'consum', 0.0222, 'lps'),
	(655060, 134, '2015-01-15 00:19:14.000000', 'consum', 0.0293, 'lps'),
	(655061, 134, '2015-01-15 00:19:15.000000', 'consum', 0.0275, 'lps'),
	(655062, 134, '2015-01-15 00:19:16.000000', 'consum', 0.0285, 'lps'),
	(655063, 134, '2015-01-15 00:19:17.000000', 'consum', 0.0233, 'lps'),
	(655064, 134, '2015-01-15 00:19:18.000000', 'consum', 0.0259, 'lps'),
	(655065, 134, '2015-01-15 00:19:19.000000', 'consum', 0.0229, 'lps'),
	(655066, 134, '2015-01-15 00:19:20.000000', 'consum', 0.0316, 'lps'),
	(655067, 134, '2015-01-15 00:19:21.000000', 'consum', 0.0366, 'lps'),
	(655068, 134, '2015-01-15 00:19:22.000000', 'consum', 0.0357, 'lps'),
	(655069, 134, '2015-01-15 00:19:23.000000', 'consum', 0.0322, 'lps'),
	(655070, 134, '2015-01-15 00:19:24.000000', 'consum', 0.0326, 'lps'),
	(655071, 134, '2015-01-15 00:19:25.000000', 'consum', 0.0300, 'lps'),
	(655072, 134, '2015-01-15 00:19:26.000000', 'consum', 0.0310, 'lps'),
	(655073, 134, '2015-01-15 00:19:27.000000', 'consum', 0.0282, 'lps'),
	(655074, 134, '2015-01-15 00:19:28.000000', 'consum', 0.0272, 'lps'),
	(655075, 134, '2015-01-15 00:19:29.000000', 'consum', 0.0304, 'lps'),
	(655076, 134, '2015-01-15 00:19:30.000000', 'consum', 0.0335, 'lps'),
	(655077, 134, '2015-01-15 00:19:31.000000', 'consum', 0.0238, 'lps'),
	(655078, 134, '2015-01-15 00:19:32.000000', 'consum', 0.0292, 'lps'),
	(655079, 134, '2015-01-15 00:19:33.000000', 'consum', 0.0218, 'lps'),
	(655080, 134, '2015-01-15 00:19:34.000000', 'consum', 0.0324, 'lps'),
	(655081, 134, '2015-01-15 00:19:35.000000', 'consum', 0.0282, 'lps'),
	(655082, 134, '2015-01-15 00:19:36.000000', 'consum', 0.0229, 'lps'),
	(655083, 134, '2015-01-15 00:19:37.000000', 'consum', 0.0247, 'lps'),
	(655084, 134, '2015-01-15 00:19:38.000000', 'consum', 0.0338, 'lps'),
	(655085, 134, '2015-01-15 00:19:39.000000', 'consum', 0.0267, 'lps'),
	(655086, 134, '2015-01-15 00:19:40.000000', 'consum', 0.0268, 'lps'),
	(655087, 134, '2015-01-15 00:19:41.000000', 'consum', 0.0330, 'lps'),
	(655088, 134, '2015-01-15 00:19:42.000000', 'consum', 0.0320, 'lps'),
	(655089, 134, '2015-01-15 00:19:43.000000', 'consum', 0.0241, 'lps'),
	(655090, 134, '2015-01-15 00:19:44.000000', 'consum', 0.0354, 'lps'),
	(655091, 134, '2015-01-15 00:19:45.000000', 'consum', 0.0363, 'lps'),
	(655092, 134, '2015-01-15 00:19:46.000000', 'consum', 0.0229, 'lps'),
	(655093, 134, '2015-01-15 00:19:47.000000', 'consum', 0.0319, 'lps'),
	(655094, 134, '2015-01-15 00:19:48.000000', 'consum', 0.0223, 'lps'),
	(655095, 134, '2015-01-15 00:19:49.000000', 'consum', 0.0265, 'lps'),
	(655096, 134, '2015-01-15 00:19:50.000000', 'consum', 0.0290, 'lps'),
	(655097, 134, '2015-01-15 00:19:51.000000', 'consum', 0.0289, 'lps'),
	(655098, 134, '2015-01-15 00:19:52.000000', 'consum', 0.0362, 'lps'),
	(655099, 134, '2015-01-15 00:19:53.000000', 'consum', 0.0263, 'lps'),
	(655100, 134, '2015-01-15 00:19:54.000000', 'consum', 0.0333, 'lps'),
	(655101, 134, '2015-01-15 00:19:55.000000', 'consum', 0.0351, 'lps'),
	(655102, 134, '2015-01-15 00:19:56.000000', 'consum', 0.0230, 'lps'),
	(655103, 134, '2015-01-15 00:19:57.000000', 'consum', 0.0361, 'lps'),
	(655104, 134, '2015-01-15 00:19:58.000000', 'consum', 0.0275, 'lps'),
	(655105, 134, '2015-01-15 00:19:59.000000', 'consum', 0.0240, 'lps'),
	(655106, 134, '2015-01-15 00:20:00.000000', 'consum', 0.0325, 'lps'),
	(655107, 134, '2015-01-15 00:20:01.000000', 'consum', 0.0222, 'lps'),
	(655108, 134, '2015-01-15 00:20:02.000000', 'consum', 0.0238, 'lps'),
	(655109, 134, '2015-01-15 00:20:03.000000', 'consum', 0.0317, 'lps'),
	(655110, 134, '2015-01-15 00:20:04.000000', 'consum', 0.0346, 'lps'),
	(655111, 134, '2015-01-15 00:20:05.000000', 'consum', 0.0253, 'lps'),
	(655112, 134, '2015-01-15 00:20:06.000000', 'consum', 0.0333, 'lps'),
	(655113, 134, '2015-01-15 00:20:07.000000', 'consum', 0.0223, 'lps'),
	(655114, 134, '2015-01-15 00:20:08.000000', 'consum', 0.0223, 'lps'),
	(655115, 134, '2015-01-15 00:20:09.000000', 'consum', 0.0236, 'lps'),
	(655116, 134, '2015-01-15 00:20:10.000000', 'consum', 0.0303, 'lps'),
	(655117, 134, '2015-01-15 00:20:11.000000', 'consum', 0.0281, 'lps'),
	(655118, 134, '2015-01-15 00:20:12.000000', 'consum', 0.0288, 'lps'),
	(655119, 134, '2015-01-15 00:20:13.000000', 'consum', 0.0227, 'lps'),
	(655120, 134, '2015-01-15 00:20:14.000000', 'consum', 0.0219, 'lps'),
	(655121, 134, '2015-01-15 00:20:15.000000', 'consum', 0.0362, 'lps'),
	(655122, 134, '2015-01-15 00:20:16.000000', 'consum', 0.0314, 'lps'),
	(655123, 134, '2015-01-15 00:20:17.000000', 'consum', 0.0272, 'lps'),
	(655124, 134, '2015-01-15 00:20:18.000000', 'consum', 0.0210, 'lps'),
	(655125, 134, '2015-01-15 00:20:19.000000', 'consum', 0.0340, 'lps'),
	(655126, 134, '2015-01-15 00:20:20.000000', 'consum', 0.0231, 'lps'),
	(655127, 134, '2015-01-15 00:20:21.000000', 'consum', 0.0238, 'lps'),
	(655128, 134, '2015-01-15 00:20:22.000000', 'consum', 0.0289, 'lps'),
	(655129, 134, '2015-01-15 00:20:23.000000', 'consum', 0.0362, 'lps'),
	(655130, 134, '2015-01-15 00:20:24.000000', 'consum', 0.0261, 'lps'),
	(655131, 134, '2015-01-15 00:20:25.000000', 'consum', 0.0326, 'lps'),
	(655132, 134, '2015-01-15 00:20:26.000000', 'consum', 0.0323, 'lps'),
	(655133, 134, '2015-01-15 00:20:27.000000', 'consum', 0.0267, 'lps'),
	(655134, 134, '2015-01-15 00:20:28.000000', 'consum', 0.0316, 'lps'),
	(655135, 134, '2015-01-15 00:20:29.000000', 'consum', 0.0255, 'lps'),
	(655136, 134, '2015-01-15 00:20:30.000000', 'consum', 0.0272, 'lps'),
	(655137, 134, '2015-01-15 00:20:31.000000', 'consum', 0.0229, 'lps'),
	(655138, 134, '2015-01-15 00:20:32.000000', 'consum', 0.0280, 'lps'),
	(655139, 134, '2015-01-15 00:20:33.000000', 'consum', 0.0342, 'lps'),
	(655140, 134, '2015-01-15 00:20:34.000000', 'consum', 0.0345, 'lps'),
	(655141, 134, '2015-01-15 00:20:35.000000', 'consum', 0.0331, 'lps'),
	(655142, 134, '2015-01-15 00:20:36.000000', 'consum', 0.0252, 'lps'),
	(655143, 134, '2015-01-15 00:20:37.000000', 'consum', 0.0215, 'lps'),
	(655144, 134, '2015-01-15 00:20:38.000000', 'consum', 0.0268, 'lps'),
	(655145, 134, '2015-01-15 00:20:39.000000', 'consum', 0.0326, 'lps'),
	(655146, 134, '2015-01-15 00:20:40.000000', 'consum', 0.0304, 'lps'),
	(655147, 134, '2015-01-15 00:20:41.000000', 'consum', 0.0330, 'lps'),
	(655148, 134, '2015-01-15 00:20:42.000000', 'consum', 0.0213, 'lps'),
	(655149, 134, '2015-01-15 00:20:43.000000', 'consum', 0.0338, 'lps'),
	(655150, 134, '2015-01-15 00:20:44.000000', 'consum', 0.0212, 'lps'),
	(655151, 134, '2015-01-15 00:20:45.000000', 'consum', 0.0310, 'lps'),
	(655152, 134, '2015-01-15 00:20:46.000000', 'consum', 0.0230, 'lps'),
	(655153, 134, '2015-01-15 00:20:47.000000', 'consum', 0.0326, 'lps'),
	(655154, 134, '2015-01-15 00:20:48.000000', 'consum', 0.0255, 'lps'),
	(655155, 134, '2015-01-15 00:20:49.000000', 'consum', 0.0247, 'lps'),
	(655156, 134, '2015-01-15 00:20:50.000000', 'consum', 0.0262, 'lps'),
	(655157, 134, '2015-01-15 00:20:51.000000', 'consum', 0.0358, 'lps'),
	(655158, 134, '2015-01-15 00:20:52.000000', 'consum', 0.0321, 'lps'),
	(655159, 134, '2015-01-15 00:20:53.000000', 'consum', 0.0320, 'lps'),
	(655160, 134, '2015-01-15 00:20:54.000000', 'consum', 0.0269, 'lps'),
	(655161, 134, '2015-01-15 00:20:55.000000', 'consum', 0.0333, 'lps'),
	(655162, 134, '2015-01-15 00:20:56.000000', 'consum', 0.0335, 'lps'),
	(655163, 134, '2015-01-15 00:20:57.000000', 'consum', 0.0309, 'lps'),
	(655164, 134, '2015-01-15 00:20:58.000000', 'consum', 0.0332, 'lps'),
	(655165, 134, '2015-01-15 00:20:59.000000', 'consum', 0.0362, 'lps'),
	(655166, 134, '2015-01-15 00:21:00.000000', 'consum', 0.0288, 'lps'),
	(655167, 134, '2015-01-15 00:21:01.000000', 'consum', 0.0303, 'lps'),
	(655168, 134, '2015-01-15 00:21:02.000000', 'consum', 0.0285, 'lps'),
	(655169, 134, '2015-01-15 00:21:03.000000', 'consum', 0.0308, 'lps'),
	(655170, 134, '2015-01-15 00:21:04.000000', 'consum', 0.0314, 'lps'),
	(655171, 134, '2015-01-15 00:21:05.000000', 'consum', 0.0281, 'lps'),
	(655172, 134, '2015-01-15 00:21:06.000000', 'consum', 0.0252, 'lps'),
	(655173, 134, '2015-01-15 00:21:07.000000', 'consum', 0.0366, 'lps'),
	(655174, 134, '2015-01-15 00:21:08.000000', 'consum', 0.0234, 'lps'),
	(655175, 134, '2015-01-15 00:21:09.000000', 'consum', 0.0336, 'lps'),
	(655176, 134, '2015-01-15 00:21:10.000000', 'consum', 0.0295, 'lps'),
	(655177, 134, '2015-01-15 00:21:11.000000', 'consum', 0.0256, 'lps'),
	(655178, 134, '2015-01-15 00:21:12.000000', 'consum', 0.0345, 'lps'),
	(655179, 134, '2015-01-15 00:21:13.000000', 'consum', 0.0272, 'lps'),
	(655180, 134, '2015-01-15 00:21:14.000000', 'consum', 0.0275, 'lps'),
	(655181, 134, '2015-01-15 00:21:15.000000', 'consum', 0.0351, 'lps'),
	(655182, 134, '2015-01-15 00:21:16.000000', 'consum', 0.0244, 'lps'),
	(655183, 134, '2015-01-15 00:21:17.000000', 'consum', 0.0273, 'lps'),
	(655184, 134, '2015-01-15 00:21:18.000000', 'consum', 0.0267, 'lps'),
	(655185, 134, '2015-01-15 00:21:19.000000', 'consum', 0.0307, 'lps'),
	(655186, 134, '2015-01-15 00:21:20.000000', 'consum', 0.0364, 'lps'),
	(655187, 134, '2015-01-15 00:21:21.000000', 'consum', 0.0216, 'lps'),
	(655188, 134, '2015-01-15 00:21:22.000000', 'consum', 0.0254, 'lps'),
	(655189, 134, '2015-01-15 00:21:23.000000', 'consum', 0.0252, 'lps'),
	(655190, 134, '2015-01-15 00:21:24.000000', 'consum', 0.0292, 'lps'),
	(655191, 134, '2015-01-15 00:21:25.000000', 'consum', 0.0333, 'lps'),
	(655192, 134, '2015-01-15 00:21:26.000000', 'consum', 0.0264, 'lps'),
	(655193, 134, '2015-01-15 00:21:27.000000', 'consum', 0.0271, 'lps'),
	(655194, 134, '2015-01-15 00:21:28.000000', 'consum', 0.0353, 'lps'),
	(655195, 134, '2015-01-15 00:21:29.000000', 'consum', 0.0267, 'lps'),
	(655196, 134, '2015-01-15 00:21:30.000000', 'consum', 0.0227, 'lps'),
	(655197, 134, '2015-01-15 00:21:31.000000', 'consum', 0.0279, 'lps'),
	(655198, 134, '2015-01-15 00:21:32.000000', 'consum', 0.0350, 'lps'),
	(655199, 134, '2015-01-15 00:21:33.000000', 'consum', 0.0229, 'lps'),
	(655200, 134, '2015-01-15 00:21:34.000000', 'consum', 0.0360, 'lps'),
	(655201, 134, '2015-01-15 00:21:35.000000', 'consum', 0.0269, 'lps'),
	(655202, 134, '2015-01-15 00:21:36.000000', 'consum', 0.0216, 'lps'),
	(655203, 134, '2015-01-15 00:21:37.000000', 'consum', 0.0222, 'lps'),
	(655204, 134, '2015-01-15 00:21:38.000000', 'consum', 0.0253, 'lps'),
	(655205, 134, '2015-01-15 00:21:39.000000', 'consum', 0.0229, 'lps'),
	(655206, 134, '2015-01-15 00:21:40.000000', 'consum', 0.0335, 'lps'),
	(655207, 134, '2015-01-15 00:21:41.000000', 'consum', 0.0303, 'lps'),
	(655208, 134, '2015-01-15 00:21:42.000000', 'consum', 0.0304, 'lps'),
	(655209, 134, '2015-01-15 00:21:43.000000', 'consum', 0.0240, 'lps'),
	(655210, 134, '2015-01-15 00:21:44.000000', 'consum', 0.0238, 'lps'),
	(655211, 134, '2015-01-15 00:21:45.000000', 'consum', 0.0262, 'lps'),
	(655212, 134, '2015-01-15 00:21:46.000000', 'consum', 0.0229, 'lps'),
	(655213, 134, '2015-01-15 00:21:47.000000', 'consum', 0.0305, 'lps'),
	(655214, 134, '2015-01-15 00:21:48.000000', 'consum', 0.0313, 'lps'),
	(655215, 134, '2015-01-15 00:21:49.000000', 'consum', 0.0283, 'lps'),
	(655216, 134, '2015-01-15 00:21:50.000000', 'consum', 0.0265, 'lps'),
	(655217, 134, '2015-01-15 00:21:51.000000', 'consum', 0.0266, 'lps'),
	(655218, 134, '2015-01-15 00:21:52.000000', 'consum', 0.0328, 'lps'),
	(655219, 134, '2015-01-15 00:21:53.000000', 'consum', 0.0317, 'lps'),
	(655220, 134, '2015-01-15 00:21:54.000000', 'consum', 0.0233, 'lps'),
	(655221, 134, '2015-01-15 00:21:55.000000', 'consum', 0.0319, 'lps'),
	(655222, 134, '2015-01-15 00:21:56.000000', 'consum', 0.0214, 'lps'),
	(655223, 134, '2015-01-15 00:21:57.000000', 'consum', 0.0220, 'lps'),
	(655224, 134, '2015-01-15 00:21:58.000000', 'consum', 0.0247, 'lps'),
	(655225, 134, '2015-01-15 00:21:59.000000', 'consum', 0.0367, 'lps'),
	(655226, 134, '2015-01-15 00:22:00.000000', 'consum', 0.0253, 'lps'),
	(655227, 134, '2015-01-15 00:22:01.000000', 'consum', 0.0269, 'lps'),
	(655228, 134, '2015-01-15 00:22:02.000000', 'consum', 0.0218, 'lps'),
	(655229, 134, '2015-01-15 00:22:03.000000', 'consum', 0.0231, 'lps'),
	(655230, 134, '2015-01-15 00:22:04.000000', 'consum', 0.0293, 'lps'),
	(655231, 134, '2015-01-15 00:22:05.000000', 'consum', 0.0247, 'lps'),
	(655232, 134, '2015-01-15 00:22:06.000000', 'consum', 0.0304, 'lps'),
	(655233, 134, '2015-01-15 00:22:07.000000', 'consum', 0.0255, 'lps'),
	(655234, 134, '2015-01-15 00:22:08.000000', 'consum', 0.0309, 'lps'),
	(655235, 134, '2015-01-15 00:22:09.000000', 'consum', 0.0257, 'lps'),
	(655236, 134, '2015-01-15 00:22:10.000000', 'consum', 0.0307, 'lps'),
	(655237, 134, '2015-01-15 00:22:11.000000', 'consum', 0.0237, 'lps'),
	(655238, 134, '2015-01-15 00:22:12.000000', 'consum', 0.0212, 'lps'),
	(655239, 134, '2015-01-15 00:22:13.000000', 'consum', 0.0296, 'lps'),
	(655240, 134, '2015-01-15 00:22:14.000000', 'consum', 0.0320, 'lps'),
	(655241, 134, '2015-01-15 00:22:15.000000', 'consum', 0.0344, 'lps'),
	(655242, 134, '2015-01-15 00:22:16.000000', 'consum', 0.0234, 'lps'),
	(655243, 134, '2015-01-15 00:22:17.000000', 'consum', 0.0243, 'lps'),
	(655244, 134, '2015-01-15 00:22:18.000000', 'consum', 0.0306, 'lps'),
	(655245, 134, '2015-01-15 00:22:19.000000', 'consum', 0.0274, 'lps'),
	(655246, 134, '2015-01-15 00:22:20.000000', 'consum', 0.0242, 'lps'),
	(655247, 134, '2015-01-15 00:22:21.000000', 'consum', 0.0339, 'lps'),
	(655248, 134, '2015-01-15 00:22:22.000000', 'consum', 0.0284, 'lps'),
	(655249, 134, '2015-01-15 00:22:23.000000', 'consum', 0.0351, 'lps'),
	(655250, 134, '2015-01-15 00:22:24.000000', 'consum', 0.0221, 'lps'),
	(655251, 134, '2015-01-15 00:22:25.000000', 'consum', 0.0314, 'lps'),
	(655252, 134, '2015-01-15 00:22:26.000000', 'consum', 0.0224, 'lps'),
	(655253, 134, '2015-01-15 00:22:27.000000', 'consum', 0.0285, 'lps'),
	(655254, 134, '2015-01-15 00:22:28.000000', 'consum', 0.0228, 'lps'),
	(655255, 134, '2015-01-15 00:22:29.000000', 'consum', 0.0233, 'lps'),
	(655256, 134, '2015-01-15 00:22:30.000000', 'consum', 0.0271, 'lps'),
	(655257, 134, '2015-01-15 00:22:31.000000', 'consum', 0.0289, 'lps'),
	(655258, 134, '2015-01-15 00:22:32.000000', 'consum', 0.0263, 'lps'),
	(655259, 134, '2015-01-15 00:22:33.000000', 'consum', 0.0239, 'lps'),
	(655260, 134, '2015-01-15 00:22:34.000000', 'consum', 0.0356, 'lps'),
	(655261, 134, '2015-01-15 00:22:35.000000', 'consum', 0.0221, 'lps'),
	(655262, 134, '2015-01-15 00:22:36.000000', 'consum', 0.0301, 'lps'),
	(655263, 134, '2015-01-15 00:22:37.000000', 'consum', 0.0318, 'lps'),
	(655264, 134, '2015-01-15 00:22:38.000000', 'consum', 0.0317, 'lps'),
	(655265, 134, '2015-01-15 00:22:39.000000', 'consum', 0.0264, 'lps'),
	(655266, 134, '2015-01-15 00:22:40.000000', 'consum', 0.0319, 'lps'),
	(655267, 134, '2015-01-15 00:22:41.000000', 'consum', 0.0278, 'lps'),
	(655268, 134, '2015-01-15 00:22:42.000000', 'consum', 0.0223, 'lps'),
	(655269, 134, '2015-01-15 00:22:43.000000', 'consum', 0.0231, 'lps'),
	(655270, 134, '2015-01-15 00:22:44.000000', 'consum', 0.0277, 'lps'),
	(655271, 134, '2015-01-15 00:22:45.000000', 'consum', 0.0322, 'lps'),
	(655272, 134, '2015-01-15 00:22:46.000000', 'consum', 0.0252, 'lps'),
	(655273, 134, '2015-01-15 00:22:47.000000', 'consum', 0.0246, 'lps'),
	(655274, 134, '2015-01-15 00:22:48.000000', 'consum', 0.0264, 'lps'),
	(655275, 134, '2015-01-15 00:22:49.000000', 'consum', 0.0212, 'lps'),
	(655276, 134, '2015-01-15 00:22:50.000000', 'consum', 0.0219, 'lps'),
	(655277, 134, '2015-01-15 00:22:51.000000', 'consum', 0.0247, 'lps'),
	(655278, 134, '2015-01-15 00:22:52.000000', 'consum', 0.0211, 'lps'),
	(655279, 134, '2015-01-15 00:22:53.000000', 'consum', 0.0263, 'lps'),
	(655280, 134, '2015-01-15 00:22:54.000000', 'consum', 0.0312, 'lps'),
	(655281, 134, '2015-01-15 00:22:55.000000', 'consum', 0.0249, 'lps'),
	(655282, 134, '2015-01-15 00:22:56.000000', 'consum', 0.0256, 'lps'),
	(655283, 134, '2015-01-15 00:22:57.000000', 'consum', 0.0322, 'lps'),
	(655284, 134, '2015-01-15 00:22:58.000000', 'consum', 0.0318, 'lps'),
	(655285, 134, '2015-01-15 00:22:59.000000', 'consum', 0.0254, 'lps'),
	(655286, 134, '2015-01-15 00:23:00.000000', 'consum', 0.0267, 'lps'),
	(655287, 134, '2015-01-15 00:23:01.000000', 'consum', 0.0362, 'lps'),
	(655288, 134, '2015-01-15 00:23:02.000000', 'consum', 0.0327, 'lps'),
	(655289, 134, '2015-01-15 00:23:03.000000', 'consum', 0.0338, 'lps'),
	(655290, 134, '2015-01-15 00:23:04.000000', 'consum', 0.0340, 'lps'),
	(655291, 134, '2015-01-15 00:23:05.000000', 'consum', 0.0320, 'lps'),
	(655292, 134, '2015-01-15 00:23:06.000000', 'consum', 0.0212, 'lps'),
	(655293, 134, '2015-01-15 00:23:07.000000', 'consum', 0.0365, 'lps'),
	(655294, 134, '2015-01-15 00:23:08.000000', 'consum', 0.0346, 'lps'),
	(655295, 134, '2015-01-15 00:23:09.000000', 'consum', 0.0267, 'lps'),
	(655296, 134, '2015-01-15 00:23:10.000000', 'consum', 0.0247, 'lps'),
	(655297, 134, '2015-01-15 00:23:11.000000', 'consum', 0.0224, 'lps'),
	(655298, 134, '2015-01-15 00:23:12.000000', 'consum', 0.0328, 'lps'),
	(655299, 134, '2015-01-15 00:23:13.000000', 'consum', 0.0285, 'lps'),
	(655300, 134, '2015-01-15 00:23:14.000000', 'consum', 0.0232, 'lps'),
	(655301, 134, '2015-01-15 00:23:15.000000', 'consum', 0.0253, 'lps'),
	(655302, 134, '2015-01-15 00:23:16.000000', 'consum', 0.0361, 'lps'),
	(655303, 134, '2015-01-15 00:23:17.000000', 'consum', 0.0363, 'lps'),
	(655304, 134, '2015-01-15 00:23:18.000000', 'consum', 0.0363, 'lps'),
	(655305, 134, '2015-01-15 00:23:19.000000', 'consum', 0.0358, 'lps'),
	(655306, 134, '2015-01-15 00:23:20.000000', 'consum', 0.0332, 'lps'),
	(655307, 134, '2015-01-15 00:23:21.000000', 'consum', 0.0221, 'lps'),
	(655308, 134, '2015-01-15 00:23:22.000000', 'consum', 0.0213, 'lps'),
	(655309, 134, '2015-01-15 00:23:23.000000', 'consum', 0.0352, 'lps'),
	(655310, 134, '2015-01-15 00:23:24.000000', 'consum', 0.0278, 'lps'),
	(655311, 134, '2015-01-15 00:23:25.000000', 'consum', 0.0284, 'lps'),
	(655312, 134, '2015-01-15 00:23:26.000000', 'consum', 0.0218, 'lps'),
	(655313, 134, '2015-01-15 00:23:27.000000', 'consum', 0.0343, 'lps'),
	(655314, 134, '2015-01-15 00:23:28.000000', 'consum', 0.0221, 'lps'),
	(655315, 134, '2015-01-15 00:23:29.000000', 'consum', 0.0340, 'lps'),
	(655316, 134, '2015-01-15 00:23:30.000000', 'consum', 0.0355, 'lps'),
	(655317, 134, '2015-01-15 00:23:31.000000', 'consum', 0.0227, 'lps'),
	(655318, 134, '2015-01-15 00:23:32.000000', 'consum', 0.0334, 'lps'),
	(655319, 134, '2015-01-15 00:23:33.000000', 'consum', 0.0307, 'lps'),
	(655320, 134, '2015-01-15 00:23:34.000000', 'consum', 0.0324, 'lps'),
	(655321, 134, '2015-01-15 00:23:35.000000', 'consum', 0.0332, 'lps'),
	(655322, 134, '2015-01-15 00:23:36.000000', 'consum', 0.0321, 'lps'),
	(655323, 134, '2015-01-15 00:23:37.000000', 'consum', 0.0242, 'lps'),
	(655324, 134, '2015-01-15 00:23:38.000000', 'consum', 0.0352, 'lps'),
	(655325, 134, '2015-01-15 00:23:39.000000', 'consum', 0.0349, 'lps'),
	(655326, 134, '2015-01-15 00:23:40.000000', 'consum', 0.0324, 'lps'),
	(655327, 134, '2015-01-15 00:23:41.000000', 'consum', 0.0362, 'lps'),
	(655328, 134, '2015-01-15 00:23:42.000000', 'consum', 0.0311, 'lps'),
	(655329, 134, '2015-01-15 00:23:43.000000', 'consum', 0.0262, 'lps'),
	(655330, 134, '2015-01-15 00:23:44.000000', 'consum', 0.0324, 'lps'),
	(655331, 134, '2015-01-15 00:23:45.000000', 'consum', 0.0307, 'lps'),
	(655332, 134, '2015-01-15 00:23:46.000000', 'consum', 0.0356, 'lps'),
	(655333, 134, '2015-01-15 00:23:47.000000', 'consum', 0.0334, 'lps'),
	(655334, 134, '2015-01-15 00:23:48.000000', 'consum', 0.0235, 'lps'),
	(655335, 134, '2015-01-15 00:23:49.000000', 'consum', 0.0279, 'lps'),
	(655336, 134, '2015-01-15 00:23:50.000000', 'consum', 0.0324, 'lps'),
	(655337, 134, '2015-01-15 00:23:51.000000', 'consum', 0.0255, 'lps'),
	(655338, 134, '2015-01-15 00:23:52.000000', 'consum', 0.0250, 'lps'),
	(655339, 134, '2015-01-15 00:23:53.000000', 'consum', 0.0279, 'lps'),
	(655340, 134, '2015-01-15 00:23:54.000000', 'consum', 0.0276, 'lps'),
	(655341, 134, '2015-01-15 00:23:55.000000', 'consum', 0.0332, 'lps'),
	(655342, 134, '2015-01-15 00:23:56.000000', 'consum', 0.0309, 'lps'),
	(655343, 134, '2015-01-15 00:23:57.000000', 'consum', 0.0338, 'lps'),
	(655344, 134, '2015-01-15 00:23:58.000000', 'consum', 0.0236, 'lps'),
	(655345, 134, '2015-01-15 00:23:59.000000', 'consum', 0.0276, 'lps'),
	(655346, 134, '2015-01-15 00:24:00.000000', 'consum', 0.0302, 'lps'),
	(655347, 134, '2015-01-15 00:24:01.000000', 'consum', 0.0314, 'lps'),
	(655348, 134, '2015-01-15 00:24:02.000000', 'consum', 0.0299, 'lps'),
	(655349, 134, '2015-01-15 00:24:03.000000', 'consum', 0.0344, 'lps'),
	(655350, 134, '2015-01-15 00:24:04.000000', 'consum', 0.0297, 'lps'),
	(655351, 134, '2015-01-15 00:24:05.000000', 'consum', 0.0244, 'lps'),
	(655352, 134, '2015-01-15 00:24:06.000000', 'consum', 0.0278, 'lps'),
	(655353, 134, '2015-01-15 00:24:07.000000', 'consum', 0.0290, 'lps'),
	(655354, 134, '2015-01-15 00:24:08.000000', 'consum', 0.0247, 'lps'),
	(655355, 134, '2015-01-15 00:24:09.000000', 'consum', 0.0314, 'lps'),
	(655356, 134, '2015-01-15 00:24:10.000000', 'consum', 0.0305, 'lps'),
	(655357, 134, '2015-01-15 00:24:11.000000', 'consum', 0.0215, 'lps'),
	(655358, 134, '2015-01-15 00:24:12.000000', 'consum', 0.0266, 'lps'),
	(655359, 134, '2015-01-15 00:24:13.000000', 'consum', 0.0317, 'lps'),
	(655360, 134, '2015-01-15 00:24:14.000000', 'consum', 0.0260, 'lps'),
	(655361, 134, '2015-01-15 00:24:15.000000', 'consum', 0.0299, 'lps'),
	(655362, 134, '2015-01-15 00:24:16.000000', 'consum', 0.0346, 'lps'),
	(655363, 134, '2015-01-15 00:24:17.000000', 'consum', 0.0309, 'lps'),
	(655364, 134, '2015-01-15 00:24:18.000000', 'consum', 0.0298, 'lps'),
	(655365, 134, '2015-01-15 00:24:19.000000', 'consum', 0.0351, 'lps'),
	(655366, 134, '2015-01-15 00:24:20.000000', 'consum', 0.0336, 'lps'),
	(655367, 134, '2015-01-15 00:24:21.000000', 'consum', 0.0261, 'lps'),
	(655368, 134, '2015-01-15 00:24:22.000000', 'consum', 0.0246, 'lps'),
	(655369, 134, '2015-01-15 00:24:23.000000', 'consum', 0.0236, 'lps'),
	(655370, 134, '2015-01-15 00:24:24.000000', 'consum', 0.0231, 'lps'),
	(655371, 134, '2015-01-15 00:24:25.000000', 'consum', 0.0241, 'lps'),
	(655372, 134, '2015-01-15 00:24:26.000000', 'consum', 0.0300, 'lps'),
	(655373, 134, '2015-01-15 00:24:27.000000', 'consum', 0.0254, 'lps'),
	(655374, 134, '2015-01-15 00:24:28.000000', 'consum', 0.0319, 'lps'),
	(655375, 134, '2015-01-15 00:24:29.000000', 'consum', 0.0305, 'lps'),
	(655376, 134, '2015-01-15 00:24:30.000000', 'consum', 0.0361, 'lps'),
	(655377, 134, '2015-01-15 00:24:31.000000', 'consum', 0.0363, 'lps'),
	(655378, 134, '2015-01-15 00:24:32.000000', 'consum', 0.0366, 'lps'),
	(655379, 134, '2015-01-15 00:24:33.000000', 'consum', 0.0214, 'lps'),
	(655380, 134, '2015-01-15 00:24:34.000000', 'consum', 0.0239, 'lps'),
	(655381, 134, '2015-01-15 00:24:35.000000', 'consum', 0.0342, 'lps'),
	(655382, 134, '2015-01-15 00:24:36.000000', 'consum', 0.0309, 'lps'),
	(655383, 134, '2015-01-15 00:24:37.000000', 'consum', 0.0308, 'lps'),
	(655384, 134, '2015-01-15 00:24:38.000000', 'consum', 0.0247, 'lps'),
	(655385, 134, '2015-01-15 00:24:39.000000', 'consum', 0.0259, 'lps'),
	(655386, 134, '2015-01-15 00:24:40.000000', 'consum', 0.0347, 'lps'),
	(655387, 134, '2015-01-15 00:24:41.000000', 'consum', 0.0271, 'lps'),
	(655388, 134, '2015-01-15 00:24:42.000000', 'consum', 0.0264, 'lps'),
	(655389, 134, '2015-01-15 00:24:43.000000', 'consum', 0.0297, 'lps'),
	(655390, 134, '2015-01-15 00:24:44.000000', 'consum', 0.0324, 'lps'),
	(655391, 134, '2015-01-15 00:24:45.000000', 'consum', 0.0362, 'lps'),
	(655392, 134, '2015-01-15 00:24:46.000000', 'consum', 0.0313, 'lps'),
	(655393, 134, '2015-01-15 00:24:47.000000', 'consum', 0.0270, 'lps'),
	(655394, 134, '2015-01-15 00:24:48.000000', 'consum', 0.0361, 'lps'),
	(655395, 134, '2015-01-15 00:24:49.000000', 'consum', 0.0310, 'lps'),
	(655396, 134, '2015-01-15 00:24:50.000000', 'consum', 0.0258, 'lps'),
	(655397, 134, '2015-01-15 00:24:51.000000', 'consum', 0.0307, 'lps'),
	(655398, 134, '2015-01-15 00:24:52.000000', 'consum', 0.0238, 'lps'),
	(655399, 134, '2015-01-15 00:24:53.000000', 'consum', 0.0216, 'lps'),
	(655400, 134, '2015-01-15 00:24:54.000000', 'consum', 0.0316, 'lps'),
	(655401, 134, '2015-01-15 00:24:55.000000', 'consum', 0.0246, 'lps'),
	(655402, 134, '2015-01-15 00:24:56.000000', 'consum', 0.0232, 'lps'),
	(655403, 134, '2015-01-15 00:24:57.000000', 'consum', 0.0214, 'lps'),
	(655404, 134, '2015-01-15 00:24:58.000000', 'consum', 0.0323, 'lps'),
	(655405, 134, '2015-01-15 00:24:59.000000', 'consum', 0.0288, 'lps'),
	(655406, 134, '2015-01-15 00:25:00.000000', 'consum', 0.0261, 'lps'),
	(655407, 134, '2015-01-15 00:25:01.000000', 'consum', 0.0232, 'lps'),
	(655408, 134, '2015-01-15 00:25:02.000000', 'consum', 0.0325, 'lps'),
	(655409, 134, '2015-01-15 00:25:03.000000', 'consum', 0.0248, 'lps'),
	(655410, 134, '2015-01-15 00:25:04.000000', 'consum', 0.0211, 'lps'),
	(655411, 134, '2015-01-15 00:25:05.000000', 'consum', 0.0262, 'lps'),
	(655412, 134, '2015-01-15 00:25:06.000000', 'consum', 0.0308, 'lps'),
	(655413, 134, '2015-01-15 00:25:07.000000', 'consum', 0.0229, 'lps'),
	(655414, 134, '2015-01-15 00:25:08.000000', 'consum', 0.0328, 'lps'),
	(655415, 134, '2015-01-15 00:25:09.000000', 'consum', 0.0269, 'lps'),
	(655416, 134, '2015-01-15 00:25:10.000000', 'consum', 0.0311, 'lps'),
	(655417, 134, '2015-01-15 00:25:11.000000', 'consum', 0.0223, 'lps'),
	(655418, 134, '2015-01-15 00:25:12.000000', 'consum', 0.0286, 'lps'),
	(655419, 134, '2015-01-15 00:25:13.000000', 'consum', 0.0235, 'lps'),
	(655420, 134, '2015-01-15 00:25:14.000000', 'consum', 0.0267, 'lps'),
	(655421, 134, '2015-01-15 00:25:15.000000', 'consum', 0.0264, 'lps'),
	(655422, 134, '2015-01-15 00:25:16.000000', 'consum', 0.0306, 'lps'),
	(655423, 134, '2015-01-15 00:25:17.000000', 'consum', 0.0215, 'lps'),
	(655424, 134, '2015-01-15 00:25:18.000000', 'consum', 0.0263, 'lps'),
	(655425, 134, '2015-01-15 00:25:19.000000', 'consum', 0.0301, 'lps'),
	(655426, 134, '2015-01-15 00:25:20.000000', 'consum', 0.0349, 'lps'),
	(655427, 134, '2015-01-15 00:25:21.000000', 'consum', 0.0318, 'lps'),
	(655428, 134, '2015-01-15 00:25:22.000000', 'consum', 0.0333, 'lps'),
	(655429, 134, '2015-01-15 00:25:23.000000', 'consum', 0.0345, 'lps'),
	(655430, 134, '2015-01-15 00:25:24.000000', 'consum', 0.0359, 'lps'),
	(655431, 134, '2015-01-15 00:25:25.000000', 'consum', 0.0234, 'lps'),
	(655432, 134, '2015-01-15 00:25:26.000000', 'consum', 0.0357, 'lps'),
	(655433, 134, '2015-01-15 00:25:27.000000', 'consum', 0.0241, 'lps'),
	(655434, 134, '2015-01-15 00:25:28.000000', 'consum', 0.0239, 'lps'),
	(655435, 134, '2015-01-15 00:25:29.000000', 'consum', 0.0265, 'lps'),
	(655436, 134, '2015-01-15 00:25:30.000000', 'consum', 0.0241, 'lps'),
	(655437, 134, '2015-01-15 00:25:31.000000', 'consum', 0.0359, 'lps'),
	(655438, 134, '2015-01-15 00:25:32.000000', 'consum', 0.0230, 'lps'),
	(655439, 134, '2015-01-15 00:25:33.000000', 'consum', 0.0336, 'lps'),
	(655440, 134, '2015-01-15 00:25:34.000000', 'consum', 0.0309, 'lps'),
	(655441, 134, '2015-01-15 00:25:35.000000', 'consum', 0.0325, 'lps'),
	(655442, 134, '2015-01-15 00:25:36.000000', 'consum', 0.0330, 'lps'),
	(655443, 134, '2015-01-15 00:25:37.000000', 'consum', 0.0309, 'lps'),
	(655444, 134, '2015-01-15 00:25:38.000000', 'consum', 0.0347, 'lps'),
	(655445, 134, '2015-01-15 00:25:39.000000', 'consum', 0.0280, 'lps'),
	(655446, 134, '2015-01-15 00:25:40.000000', 'consum', 0.0307, 'lps'),
	(655447, 134, '2015-01-15 00:25:41.000000', 'consum', 0.0328, 'lps'),
	(655448, 134, '2015-01-15 00:25:42.000000', 'consum', 0.0354, 'lps'),
	(655449, 134, '2015-01-15 00:25:43.000000', 'consum', 0.0257, 'lps'),
	(655450, 134, '2015-01-15 00:25:44.000000', 'consum', 0.0332, 'lps'),
	(655451, 134, '2015-01-15 00:25:45.000000', 'consum', 0.0362, 'lps'),
	(655452, 134, '2015-01-15 00:25:46.000000', 'consum', 0.0291, 'lps'),
	(655453, 134, '2015-01-15 00:25:47.000000', 'consum', 0.0316, 'lps'),
	(655454, 134, '2015-01-15 00:25:48.000000', 'consum', 0.0339, 'lps'),
	(655455, 134, '2015-01-15 00:25:49.000000', 'consum', 0.0221, 'lps'),
	(655456, 134, '2015-01-15 00:25:50.000000', 'consum', 0.0355, 'lps'),
	(655457, 134, '2015-01-15 00:25:51.000000', 'consum', 0.0268, 'lps'),
	(655458, 134, '2015-01-15 00:25:52.000000', 'consum', 0.0226, 'lps'),
	(655459, 134, '2015-01-15 00:25:53.000000', 'consum', 0.0272, 'lps'),
	(655460, 134, '2015-01-15 00:25:54.000000', 'consum', 0.0314, 'lps'),
	(655461, 134, '2015-01-15 00:25:55.000000', 'consum', 0.0229, 'lps'),
	(655462, 134, '2015-01-15 00:25:56.000000', 'consum', 0.0309, 'lps'),
	(655463, 134, '2015-01-15 00:25:57.000000', 'consum', 0.0333, 'lps'),
	(655464, 134, '2015-01-15 00:25:58.000000', 'consum', 0.0214, 'lps'),
	(655465, 134, '2015-01-15 00:25:59.000000', 'consum', 0.0336, 'lps'),
	(655466, 134, '2015-01-15 00:26:00.000000', 'consum', 0.0352, 'lps'),
	(655467, 134, '2015-01-15 00:26:01.000000', 'consum', 0.0228, 'lps'),
	(655468, 134, '2015-01-15 00:26:02.000000', 'consum', 0.0349, 'lps'),
	(655469, 134, '2015-01-15 00:26:03.000000', 'consum', 0.0217, 'lps'),
	(655470, 134, '2015-01-15 00:26:04.000000', 'consum', 0.0304, 'lps'),
	(655471, 134, '2015-01-15 00:26:05.000000', 'consum', 0.0343, 'lps'),
	(655472, 134, '2015-01-15 00:26:06.000000', 'consum', 0.0278, 'lps'),
	(655473, 134, '2015-01-15 00:26:07.000000', 'consum', 0.0308, 'lps'),
	(655474, 134, '2015-01-15 00:26:08.000000', 'consum', 0.0339, 'lps'),
	(655475, 134, '2015-01-15 00:26:09.000000', 'consum', 0.0244, 'lps'),
	(655476, 134, '2015-01-15 00:26:10.000000', 'consum', 0.0311, 'lps'),
	(655477, 134, '2015-01-15 00:26:11.000000', 'consum', 0.0296, 'lps'),
	(655478, 134, '2015-01-15 00:26:12.000000', 'consum', 0.0339, 'lps'),
	(655479, 134, '2015-01-15 00:26:13.000000', 'consum', 0.0283, 'lps'),
	(655480, 134, '2015-01-15 00:26:14.000000', 'consum', 0.0346, 'lps'),
	(655481, 134, '2015-01-15 00:26:15.000000', 'consum', 0.0355, 'lps'),
	(655482, 134, '2015-01-15 00:26:16.000000', 'consum', 0.0213, 'lps'),
	(655483, 134, '2015-01-15 00:26:17.000000', 'consum', 0.0261, 'lps'),
	(655484, 134, '2015-01-15 00:26:18.000000', 'consum', 0.0301, 'lps'),
	(655485, 134, '2015-01-15 00:26:19.000000', 'consum', 0.0356, 'lps'),
	(655486, 134, '2015-01-15 00:26:20.000000', 'consum', 0.0349, 'lps'),
	(655487, 134, '2015-01-15 00:26:21.000000', 'consum', 0.0311, 'lps'),
	(655488, 134, '2015-01-15 00:26:22.000000', 'consum', 0.0296, 'lps'),
	(655489, 134, '2015-01-15 00:26:23.000000', 'consum', 0.0339, 'lps'),
	(655490, 134, '2015-01-15 00:26:24.000000', 'consum', 0.0279, 'lps'),
	(655491, 134, '2015-01-15 00:26:25.000000', 'consum', 0.0330, 'lps'),
	(655492, 134, '2015-01-15 00:26:26.000000', 'consum', 0.0288, 'lps'),
	(655493, 134, '2015-01-15 00:26:27.000000', 'consum', 0.0238, 'lps'),
	(655494, 134, '2015-01-15 00:26:28.000000', 'consum', 0.0274, 'lps'),
	(655495, 134, '2015-01-15 00:26:29.000000', 'consum', 0.0291, 'lps'),
	(655496, 134, '2015-01-15 00:26:30.000000', 'consum', 0.0263, 'lps'),
	(655497, 134, '2015-01-15 00:26:31.000000', 'consum', 0.0234, 'lps'),
	(655498, 134, '2015-01-15 00:26:32.000000', 'consum', 0.0331, 'lps'),
	(655499, 134, '2015-01-15 00:26:33.000000', 'consum', 0.0267, 'lps'),
	(655500, 134, '2015-01-15 00:26:34.000000', 'consum', 0.0291, 'lps'),
	(655501, 134, '2015-01-15 00:26:35.000000', 'consum', 0.0287, 'lps'),
	(655502, 134, '2015-01-15 00:26:36.000000', 'consum', 0.0352, 'lps'),
	(655503, 134, '2015-01-15 00:26:37.000000', 'consum', 0.0217, 'lps'),
	(655504, 134, '2015-01-15 00:26:38.000000', 'consum', 0.0294, 'lps'),
	(655505, 134, '2015-01-15 00:26:39.000000', 'consum', 0.0293, 'lps'),
	(655506, 134, '2015-01-15 00:26:40.000000', 'consum', 0.0217, 'lps'),
	(655507, 134, '2015-01-15 00:26:41.000000', 'consum', 0.0309, 'lps'),
	(655508, 134, '2015-01-15 00:26:42.000000', 'consum', 0.0213, 'lps'),
	(655509, 134, '2015-01-15 00:26:43.000000', 'consum', 0.0242, 'lps'),
	(655510, 134, '2015-01-15 00:26:44.000000', 'consum', 0.0365, 'lps'),
	(655511, 134, '2015-01-15 00:26:45.000000', 'consum', 0.0256, 'lps'),
	(655512, 134, '2015-01-15 00:26:46.000000', 'consum', 0.0289, 'lps'),
	(655513, 134, '2015-01-15 00:26:47.000000', 'consum', 0.0313, 'lps'),
	(655514, 134, '2015-01-15 00:26:48.000000', 'consum', 0.0329, 'lps'),
	(655515, 134, '2015-01-15 00:26:49.000000', 'consum', 0.0338, 'lps'),
	(655516, 134, '2015-01-15 00:26:50.000000', 'consum', 0.0335, 'lps'),
	(655517, 134, '2015-01-15 00:26:51.000000', 'consum', 0.0295, 'lps'),
	(655518, 134, '2015-01-15 00:26:52.000000', 'consum', 0.0262, 'lps'),
	(655519, 134, '2015-01-15 00:26:53.000000', 'consum', 0.0213, 'lps'),
	(655520, 134, '2015-01-15 00:26:54.000000', 'consum', 0.0227, 'lps'),
	(655521, 134, '2015-01-15 00:26:55.000000', 'consum', 0.0287, 'lps'),
	(655522, 134, '2015-01-15 00:26:56.000000', 'consum', 0.0230, 'lps'),
	(655523, 134, '2015-01-15 00:26:57.000000', 'consum', 0.0236, 'lps'),
	(655524, 134, '2015-01-15 00:26:58.000000', 'consum', 0.0282, 'lps'),
	(655525, 134, '2015-01-15 00:26:59.000000', 'consum', 0.0336, 'lps'),
	(655526, 134, '2015-01-15 00:27:00.000000', 'consum', 0.0306, 'lps'),
	(655527, 134, '2015-01-15 00:27:01.000000', 'consum', 0.0313, 'lps'),
	(655528, 134, '2015-01-15 00:27:02.000000', 'consum', 0.0278, 'lps'),
	(655529, 134, '2015-01-15 00:27:03.000000', 'consum', 0.0242, 'lps'),
	(655530, 134, '2015-01-15 00:27:04.000000', 'consum', 0.0327, 'lps'),
	(655531, 134, '2015-01-15 00:27:05.000000', 'consum', 0.0223, 'lps'),
	(655532, 134, '2015-01-15 00:27:06.000000', 'consum', 0.0242, 'lps'),
	(655533, 134, '2015-01-15 00:27:07.000000', 'consum', 0.0332, 'lps'),
	(655534, 134, '2015-01-15 00:27:08.000000', 'consum', 0.0248, 'lps'),
	(655535, 134, '2015-01-15 00:27:09.000000', 'consum', 0.0350, 'lps'),
	(655536, 134, '2015-01-15 00:27:10.000000', 'consum', 0.0325, 'lps'),
	(655537, 134, '2015-01-15 00:27:11.000000', 'consum', 0.0366, 'lps'),
	(655538, 134, '2015-01-15 00:27:12.000000', 'consum', 0.0327, 'lps'),
	(655539, 134, '2015-01-15 00:27:13.000000', 'consum', 0.0330, 'lps'),
	(655540, 134, '2015-01-15 00:27:14.000000', 'consum', 0.0302, 'lps'),
	(655541, 134, '2015-01-15 00:27:15.000000', 'consum', 0.0310, 'lps'),
	(655542, 134, '2015-01-15 00:27:16.000000', 'consum', 0.0275, 'lps'),
	(655543, 134, '2015-01-15 00:27:17.000000', 'consum', 0.0237, 'lps'),
	(655544, 134, '2015-01-15 00:27:18.000000', 'consum', 0.0307, 'lps'),
	(655545, 134, '2015-01-15 00:27:19.000000', 'consum', 0.0297, 'lps'),
	(655546, 134, '2015-01-15 00:27:20.000000', 'consum', 0.0358, 'lps'),
	(655547, 134, '2015-01-15 00:27:21.000000', 'consum', 0.0212, 'lps'),
	(655548, 134, '2015-01-15 00:27:22.000000', 'consum', 0.0254, 'lps'),
	(655549, 134, '2015-01-15 00:27:23.000000', 'consum', 0.0265, 'lps'),
	(655550, 134, '2015-01-15 00:27:24.000000', 'consum', 0.0353, 'lps'),
	(655551, 134, '2015-01-15 00:27:25.000000', 'consum', 0.0287, 'lps'),
	(655552, 134, '2015-01-15 00:27:26.000000', 'consum', 0.0326, 'lps'),
	(655553, 134, '2015-01-15 00:27:27.000000', 'consum', 0.0244, 'lps'),
	(655554, 134, '2015-01-15 00:27:28.000000', 'consum', 0.0345, 'lps'),
	(655555, 134, '2015-01-15 00:27:29.000000', 'consum', 0.0312, 'lps'),
	(655556, 134, '2015-01-15 00:27:30.000000', 'consum', 0.0317, 'lps'),
	(655557, 134, '2015-01-15 00:27:31.000000', 'consum', 0.0279, 'lps'),
	(655558, 134, '2015-01-15 00:27:32.000000', 'consum', 0.0233, 'lps'),
	(655559, 134, '2015-01-15 00:27:33.000000', 'consum', 0.0279, 'lps'),
	(655560, 134, '2015-01-15 00:27:34.000000', 'consum', 0.0329, 'lps'),
	(655561, 134, '2015-01-15 00:27:35.000000', 'consum', 0.0281, 'lps'),
	(655562, 134, '2015-01-15 00:27:36.000000', 'consum', 0.0365, 'lps'),
	(655563, 134, '2015-01-15 00:27:37.000000', 'consum', 0.0300, 'lps'),
	(655564, 134, '2015-01-15 00:27:38.000000', 'consum', 0.0353, 'lps'),
	(655565, 134, '2015-01-15 00:27:39.000000', 'consum', 0.0342, 'lps'),
	(655566, 134, '2015-01-15 00:27:40.000000', 'consum', 0.0280, 'lps'),
	(655567, 134, '2015-01-15 00:27:41.000000', 'consum', 0.0323, 'lps'),
	(655568, 134, '2015-01-15 00:27:42.000000', 'consum', 0.0252, 'lps'),
	(655569, 134, '2015-01-15 00:27:43.000000', 'consum', 0.0238, 'lps'),
	(655570, 134, '2015-01-15 00:27:44.000000', 'consum', 0.0226, 'lps'),
	(655571, 134, '2015-01-15 00:27:45.000000', 'consum', 0.0365, 'lps'),
	(655572, 134, '2015-01-15 00:27:46.000000', 'consum', 0.0304, 'lps'),
	(655573, 134, '2015-01-15 00:27:47.000000', 'consum', 0.0217, 'lps'),
	(655574, 134, '2015-01-15 00:27:48.000000', 'consum', 0.0280, 'lps'),
	(655575, 134, '2015-01-15 00:27:49.000000', 'consum', 0.0223, 'lps'),
	(655576, 134, '2015-01-15 00:27:50.000000', 'consum', 0.0225, 'lps'),
	(655577, 134, '2015-01-15 00:27:51.000000', 'consum', 0.0246, 'lps'),
	(655578, 134, '2015-01-15 00:27:52.000000', 'consum', 0.0344, 'lps'),
	(655579, 134, '2015-01-15 00:27:53.000000', 'consum', 0.0299, 'lps'),
	(655580, 134, '2015-01-15 00:27:54.000000', 'consum', 0.0254, 'lps'),
	(655581, 134, '2015-01-15 00:27:55.000000', 'consum', 0.0321, 'lps'),
	(655582, 134, '2015-01-15 00:27:56.000000', 'consum', 0.0319, 'lps'),
	(655583, 134, '2015-01-15 00:27:57.000000', 'consum', 0.0262, 'lps'),
	(655584, 134, '2015-01-15 00:27:58.000000', 'consum', 0.0302, 'lps'),
	(655585, 134, '2015-01-15 00:27:59.000000', 'consum', 0.0356, 'lps'),
	(655586, 134, '2015-01-15 00:28:00.000000', 'consum', 0.0350, 'lps'),
	(655587, 134, '2015-01-15 00:28:01.000000', 'consum', 0.0314, 'lps'),
	(655588, 134, '2015-01-15 00:28:02.000000', 'consum', 0.0312, 'lps'),
	(655589, 134, '2015-01-15 00:28:03.000000', 'consum', 0.0249, 'lps'),
	(655590, 134, '2015-01-15 00:28:04.000000', 'consum', 0.0259, 'lps'),
	(655591, 134, '2015-01-15 00:28:05.000000', 'consum', 0.0336, 'lps'),
	(655592, 134, '2015-01-15 00:28:06.000000', 'consum', 0.0219, 'lps'),
	(655593, 134, '2015-01-15 00:28:07.000000', 'consum', 0.0352, 'lps'),
	(655594, 134, '2015-01-15 00:28:08.000000', 'consum', 0.0260, 'lps'),
	(655595, 134, '2015-01-15 00:28:09.000000', 'consum', 0.0351, 'lps'),
	(655596, 134, '2015-01-15 00:28:10.000000', 'consum', 0.0293, 'lps'),
	(655597, 134, '2015-01-15 00:28:11.000000', 'consum', 0.0360, 'lps'),
	(655598, 134, '2015-01-15 00:28:12.000000', 'consum', 0.0238, 'lps'),
	(655599, 134, '2015-01-15 00:28:13.000000', 'consum', 0.0215, 'lps'),
	(655600, 134, '2015-01-15 00:28:14.000000', 'consum', 0.0312, 'lps'),
	(655601, 134, '2015-01-15 00:28:15.000000', 'consum', 0.0230, 'lps'),
	(655602, 134, '2015-01-15 00:28:16.000000', 'consum', 0.0320, 'lps'),
	(655603, 134, '2015-01-15 00:28:17.000000', 'consum', 0.0228, 'lps'),
	(655604, 134, '2015-01-15 00:28:18.000000', 'consum', 0.0287, 'lps'),
	(655605, 134, '2015-01-15 00:28:19.000000', 'consum', 0.0223, 'lps'),
	(655606, 134, '2015-01-15 00:28:20.000000', 'consum', 0.0364, 'lps'),
	(655607, 134, '2015-01-15 00:28:21.000000', 'consum', 0.0306, 'lps'),
	(655608, 134, '2015-01-15 00:28:22.000000', 'consum', 0.0231, 'lps'),
	(655609, 134, '2015-01-15 00:28:23.000000', 'consum', 0.0344, 'lps'),
	(655610, 134, '2015-01-15 00:28:24.000000', 'consum', 0.0342, 'lps'),
	(655611, 134, '2015-01-15 00:28:25.000000', 'consum', 0.0310, 'lps'),
	(655612, 134, '2015-01-15 00:28:26.000000', 'consum', 0.0316, 'lps'),
	(655613, 134, '2015-01-15 00:28:27.000000', 'consum', 0.0283, 'lps'),
	(655614, 134, '2015-01-15 00:28:28.000000', 'consum', 0.0256, 'lps'),
	(655615, 134, '2015-01-15 00:28:29.000000', 'consum', 0.0220, 'lps'),
	(655616, 134, '2015-01-15 00:28:30.000000', 'consum', 0.0283, 'lps'),
	(655617, 134, '2015-01-15 00:28:31.000000', 'consum', 0.0227, 'lps'),
	(655618, 134, '2015-01-15 00:28:32.000000', 'consum', 0.0235, 'lps'),
	(655619, 134, '2015-01-15 00:28:33.000000', 'consum', 0.0286, 'lps'),
	(655620, 134, '2015-01-15 00:28:34.000000', 'consum', 0.0357, 'lps'),
	(655621, 134, '2015-01-15 00:28:35.000000', 'consum', 0.0241, 'lps'),
	(655622, 134, '2015-01-15 00:28:36.000000', 'consum', 0.0243, 'lps'),
	(655623, 134, '2015-01-15 00:28:37.000000', 'consum', 0.0284, 'lps'),
	(655624, 134, '2015-01-15 00:28:38.000000', 'consum', 0.0321, 'lps'),
	(655625, 134, '2015-01-15 00:28:39.000000', 'consum', 0.0227, 'lps'),
	(655626, 134, '2015-01-15 00:28:40.000000', 'consum', 0.0278, 'lps'),
	(655627, 134, '2015-01-15 00:28:41.000000', 'consum', 0.0342, 'lps'),
	(655628, 134, '2015-01-15 00:28:42.000000', 'consum', 0.0349, 'lps'),
	(655629, 134, '2015-01-15 00:28:43.000000', 'consum', 0.0354, 'lps'),
	(655630, 134, '2015-01-15 00:28:44.000000', 'consum', 0.0355, 'lps'),
	(655631, 134, '2015-01-15 00:28:45.000000', 'consum', 0.0344, 'lps'),
	(655632, 134, '2015-01-15 00:28:46.000000', 'consum', 0.0287, 'lps'),
	(655633, 134, '2015-01-15 00:28:47.000000', 'consum', 0.0353, 'lps'),
	(655634, 134, '2015-01-15 00:28:48.000000', 'consum', 0.0219, 'lps'),
	(655635, 134, '2015-01-15 00:28:49.000000', 'consum', 0.0300, 'lps'),
	(655636, 134, '2015-01-15 00:28:50.000000', 'consum', 0.0320, 'lps'),
	(655637, 134, '2015-01-15 00:28:51.000000', 'consum', 0.0333, 'lps'),
	(655638, 134, '2015-01-15 00:28:52.000000', 'consum', 0.0338, 'lps'),
	(655639, 134, '2015-01-15 00:28:53.000000', 'consum', 0.0323, 'lps'),
	(655640, 134, '2015-01-15 00:28:54.000000', 'consum', 0.0231, 'lps'),
	(655641, 134, '2015-01-15 00:28:55.000000', 'consum', 0.0295, 'lps'),
	(655642, 134, '2015-01-15 00:28:56.000000', 'consum', 0.0257, 'lps'),
	(655643, 134, '2015-01-15 00:28:57.000000', 'consum', 0.0347, 'lps'),
	(655644, 134, '2015-01-15 00:28:58.000000', 'consum', 0.0281, 'lps'),
	(655645, 134, '2015-01-15 00:28:59.000000', 'consum', 0.0311, 'lps'),
	(655646, 134, '2015-01-15 00:29:00.000000', 'consum', 0.0345, 'lps'),
	(655647, 134, '2015-01-15 00:29:01.000000', 'consum', 0.0266, 'lps'),
	(655648, 134, '2015-01-15 00:29:02.000000', 'consum', 0.0243, 'lps'),
	(655649, 134, '2015-01-15 00:29:03.000000', 'consum', 0.0367, 'lps'),
	(655650, 134, '2015-01-15 00:29:04.000000', 'consum', 0.0265, 'lps'),
	(655651, 134, '2015-01-15 00:29:05.000000', 'consum', 0.0329, 'lps'),
	(655652, 134, '2015-01-15 00:29:06.000000', 'consum', 0.0324, 'lps'),
	(655653, 134, '2015-01-15 00:29:07.000000', 'consum', 0.0267, 'lps'),
	(655654, 134, '2015-01-15 00:29:08.000000', 'consum', 0.0311, 'lps'),
	(655655, 134, '2015-01-15 00:29:09.000000', 'consum', 0.0229, 'lps'),
	(655656, 134, '2015-01-15 00:29:10.000000', 'consum', 0.0316, 'lps'),
	(655657, 134, '2015-01-15 00:29:11.000000', 'consum', 0.0213, 'lps'),
	(655658, 134, '2015-01-15 00:29:12.000000', 'consum', 0.0221, 'lps'),
	(655659, 134, '2015-01-15 00:29:13.000000', 'consum', 0.0259, 'lps'),
	(655660, 134, '2015-01-15 00:29:14.000000', 'consum', 0.0263, 'lps'),
	(655661, 134, '2015-01-15 00:29:15.000000', 'consum', 0.0330, 'lps'),
	(655662, 134, '2015-01-15 00:29:16.000000', 'consum', 0.0336, 'lps'),
	(655663, 134, '2015-01-15 00:29:17.000000', 'consum', 0.0320, 'lps'),
	(655664, 134, '2015-01-15 00:29:18.000000', 'consum', 0.0226, 'lps'),
	(655665, 134, '2015-01-15 00:29:19.000000', 'consum', 0.0278, 'lps'),
	(655666, 134, '2015-01-15 00:29:20.000000', 'consum', 0.0342, 'lps'),
	(655667, 134, '2015-01-15 00:29:21.000000', 'consum', 0.0353, 'lps'),
	(655668, 134, '2015-01-15 00:29:22.000000', 'consum', 0.0214, 'lps'),
	(655669, 134, '2015-01-15 00:29:23.000000', 'consum', 0.0275, 'lps'),
	(655670, 134, '2015-01-15 00:29:24.000000', 'consum', 0.0363, 'lps'),
	(655671, 134, '2015-01-15 00:29:25.000000', 'consum', 0.0308, 'lps'),
	(655672, 134, '2015-01-15 00:29:26.000000', 'consum', 0.0241, 'lps'),
	(655673, 134, '2015-01-15 00:29:27.000000', 'consum', 0.0229, 'lps'),
	(655674, 134, '2015-01-15 00:29:28.000000', 'consum', 0.0212, 'lps'),
	(655675, 134, '2015-01-15 00:29:29.000000', 'consum', 0.0321, 'lps'),
	(655676, 134, '2015-01-15 00:29:30.000000', 'consum', 0.0287, 'lps'),
	(655677, 134, '2015-01-15 00:29:31.000000', 'consum', 0.0264, 'lps'),
	(655678, 134, '2015-01-15 00:29:32.000000', 'consum', 0.0246, 'lps'),
	(655679, 134, '2015-01-15 00:29:33.000000', 'consum', 0.0231, 'lps'),
	(655680, 134, '2015-01-15 00:29:34.000000', 'consum', 0.0366, 'lps'),
	(655681, 134, '2015-01-15 00:29:35.000000', 'consum', 0.0296, 'lps'),
	(655682, 134, '2015-01-15 00:29:36.000000', 'consum', 0.0328, 'lps'),
	(655683, 134, '2015-01-15 00:29:37.000000', 'consum', 0.0227, 'lps'),
	(655684, 134, '2015-01-15 00:29:38.000000', 'consum', 0.0257, 'lps'),
	(655685, 134, '2015-01-15 00:29:39.000000', 'consum', 0.0237, 'lps'),
	(655686, 134, '2015-01-15 00:29:40.000000', 'consum', 0.0363, 'lps'),
	(655687, 134, '2015-01-15 00:29:41.000000', 'consum', 0.0262, 'lps'),
	(655688, 134, '2015-01-15 00:29:42.000000', 'consum', 0.0326, 'lps'),
	(655689, 134, '2015-01-15 00:29:43.000000', 'consum', 0.0318, 'lps'),
	(655690, 134, '2015-01-15 00:29:44.000000', 'consum', 0.0245, 'lps'),
	(655691, 134, '2015-01-15 00:29:45.000000', 'consum', 0.0221, 'lps'),
	(655692, 134, '2015-01-15 00:29:46.000000', 'consum', 0.0318, 'lps'),
	(655693, 134, '2015-01-15 00:29:47.000000', 'consum', 0.0242, 'lps'),
	(655694, 134, '2015-01-15 00:29:48.000000', 'consum', 0.0363, 'lps'),
	(655695, 134, '2015-01-15 00:29:49.000000', 'consum', 0.0249, 'lps'),
	(655696, 134, '2015-01-15 00:29:50.000000', 'consum', 0.0262, 'lps'),
	(655697, 134, '2015-01-15 00:29:51.000000', 'consum', 0.0355, 'lps'),
	(655698, 134, '2015-01-15 00:29:52.000000', 'consum', 0.0304, 'lps'),
	(655699, 134, '2015-01-15 00:29:53.000000', 'consum', 0.0246, 'lps'),
	(655700, 134, '2015-01-15 00:29:54.000000', 'consum', 0.0265, 'lps'),
	(655701, 134, '2015-01-15 00:29:55.000000', 'consum', 0.0219, 'lps'),
	(655702, 134, '2015-01-15 00:29:56.000000', 'consum', 0.0247, 'lps'),
	(655703, 134, '2015-01-15 00:29:57.000000', 'consum', 0.0214, 'lps'),
	(655704, 134, '2015-01-15 00:29:58.000000', 'consum', 0.0275, 'lps'),
	(655705, 134, '2015-01-15 00:29:59.000000', 'consum', 0.0210, 'lps'),
	(655706, 134, '2015-01-15 00:30:00.000000', 'consum', 0.0332, 'lps'),
	(655707, 134, '2015-01-15 00:30:01.000000', 'consum', 0.0345, 'lps'),
	(655708, 134, '2015-01-15 00:30:02.000000', 'consum', 0.0360, 'lps'),
	(655709, 134, '2015-01-15 00:30:03.000000', 'consum', 0.0242, 'lps'),
	(655710, 134, '2015-01-15 00:30:04.000000', 'consum', 0.0236, 'lps'),
	(655711, 134, '2015-01-15 00:30:05.000000', 'consum', 0.0246, 'lps'),
	(655712, 134, '2015-01-15 00:30:06.000000', 'consum', 0.0311, 'lps'),
	(655713, 134, '2015-01-15 00:30:07.000000', 'consum', 0.0291, 'lps'),
	(655714, 134, '2015-01-15 00:30:08.000000', 'consum', 0.0311, 'lps'),
	(655715, 134, '2015-01-15 00:30:09.000000', 'consum', 0.0316, 'lps'),
	(655716, 134, '2015-01-15 00:30:10.000000', 'consum', 0.0281, 'lps'),
	(655717, 134, '2015-01-15 00:30:11.000000', 'consum', 0.0246, 'lps'),
	(655718, 134, '2015-01-15 00:30:12.000000', 'consum', 0.0338, 'lps'),
	(655719, 134, '2015-01-15 00:30:13.000000', 'consum', 0.0266, 'lps'),
	(655720, 134, '2015-01-15 00:30:14.000000', 'consum', 0.0264, 'lps'),
	(655721, 134, '2015-01-15 00:30:15.000000', 'consum', 0.0312, 'lps'),
	(655722, 134, '2015-01-15 00:30:16.000000', 'consum', 0.0244, 'lps'),
	(655723, 134, '2015-01-15 00:30:17.000000', 'consum', 0.0233, 'lps'),
	(655724, 134, '2015-01-15 00:30:18.000000', 'consum', 0.0221, 'lps'),
	(655725, 134, '2015-01-15 00:30:19.000000', 'consum', 0.0357, 'lps'),
	(655726, 134, '2015-01-15 00:30:20.000000', 'consum', 0.0278, 'lps'),
	(655727, 134, '2015-01-15 00:30:21.000000', 'consum', 0.0270, 'lps'),
	(655728, 134, '2015-01-15 00:30:22.000000', 'consum', 0.0306, 'lps'),
	(655729, 134, '2015-01-15 00:30:23.000000', 'consum', 0.0354, 'lps'),
	(655730, 134, '2015-01-15 00:30:24.000000', 'consum', 0.0325, 'lps'),
	(655731, 134, '2015-01-15 00:30:25.000000', 'consum', 0.0355, 'lps'),
	(655732, 134, '2015-01-15 00:30:26.000000', 'consum', 0.0272, 'lps'),
	(655733, 134, '2015-01-15 00:30:27.000000', 'consum', 0.0244, 'lps'),
	(655734, 134, '2015-01-15 00:30:28.000000', 'consum', 0.0352, 'lps'),
	(655735, 134, '2015-01-15 00:30:29.000000', 'consum', 0.0347, 'lps'),
	(655736, 134, '2015-01-15 00:30:30.000000', 'consum', 0.0309, 'lps'),
	(655737, 134, '2015-01-15 00:30:31.000000', 'consum', 0.0295, 'lps'),
	(655738, 134, '2015-01-15 00:30:32.000000', 'consum', 0.0340, 'lps'),
	(655739, 134, '2015-01-15 00:30:33.000000', 'consum', 0.0288, 'lps'),
	(655740, 134, '2015-01-15 00:30:34.000000', 'consum', 0.0213, 'lps'),
	(655741, 134, '2015-01-15 00:30:35.000000', 'consum', 0.0306, 'lps'),
	(655742, 134, '2015-01-15 00:30:36.000000', 'consum', 0.0365, 'lps'),
	(655743, 134, '2015-01-15 00:30:37.000000', 'consum', 0.0225, 'lps'),
	(655744, 134, '2015-01-15 00:30:38.000000', 'consum', 0.0294, 'lps'),
	(655745, 134, '2015-01-15 00:30:39.000000', 'consum', 0.0271, 'lps'),
	(655746, 134, '2015-01-15 00:30:40.000000', 'consum', 0.0261, 'lps'),
	(655747, 134, '2015-01-15 00:30:41.000000', 'consum', 0.0285, 'lps'),
	(655748, 134, '2015-01-15 00:30:42.000000', 'consum', 0.0275, 'lps'),
	(655749, 134, '2015-01-15 00:30:43.000000', 'consum', 0.0310, 'lps'),
	(655750, 134, '2015-01-15 00:30:44.000000', 'consum', 0.0358, 'lps'),
	(655751, 134, '2015-01-15 00:30:45.000000', 'consum', 0.0333, 'lps'),
	(655752, 134, '2015-01-15 00:30:46.000000', 'consum', 0.0224, 'lps'),
	(655753, 134, '2015-01-15 00:30:47.000000', 'consum', 0.0226, 'lps'),
	(655754, 134, '2015-01-15 00:30:48.000000', 'consum', 0.0250, 'lps'),
	(655755, 134, '2015-01-15 00:30:49.000000', 'consum', 0.0361, 'lps'),
	(655756, 134, '2015-01-15 00:30:50.000000', 'consum', 0.0215, 'lps'),
	(655757, 134, '2015-01-15 00:30:51.000000', 'consum', 0.0258, 'lps'),
	(655758, 134, '2015-01-15 00:30:52.000000', 'consum', 0.0276, 'lps'),
	(655759, 134, '2015-01-15 00:30:53.000000', 'consum', 0.0237, 'lps'),
	(655760, 134, '2015-01-15 00:30:54.000000', 'consum', 0.0305, 'lps'),
	(655761, 134, '2015-01-15 00:30:55.000000', 'consum', 0.0288, 'lps'),
	(655762, 134, '2015-01-15 00:30:56.000000', 'consum', 0.0319, 'lps'),
	(655763, 134, '2015-01-15 00:30:57.000000', 'consum', 0.0360, 'lps'),
	(655764, 134, '2015-01-15 00:30:58.000000', 'consum', 0.0320, 'lps'),
	(655765, 134, '2015-01-15 00:30:59.000000', 'consum', 0.0309, 'lps'),
	(655766, 134, '2015-01-15 00:31:00.000000', 'consum', 0.0216, 'lps'),
	(655767, 134, '2015-01-15 00:31:01.000000', 'consum', 0.0263, 'lps'),
	(655768, 134, '2015-01-15 00:31:02.000000', 'consum', 0.0297, 'lps'),
	(655769, 134, '2015-01-15 00:31:03.000000', 'consum', 0.0327, 'lps'),
	(655770, 134, '2015-01-15 00:31:04.000000', 'consum', 0.0222, 'lps'),
	(655771, 134, '2015-01-15 00:31:05.000000', 'consum', 0.0234, 'lps'),
	(655772, 134, '2015-01-15 00:31:06.000000', 'consum', 0.0296, 'lps'),
	(655773, 134, '2015-01-15 00:31:07.000000', 'consum', 0.0251, 'lps'),
	(655774, 134, '2015-01-15 00:31:08.000000', 'consum', 0.0314, 'lps'),
	(655775, 134, '2015-01-15 00:31:09.000000', 'consum', 0.0294, 'lps'),
	(655776, 134, '2015-01-15 00:31:10.000000', 'consum', 0.0319, 'lps'),
	(655777, 134, '2015-01-15 00:31:11.000000', 'consum', 0.0345, 'lps'),
	(655778, 134, '2015-01-15 00:31:12.000000', 'consum', 0.0243, 'lps'),
	(655779, 134, '2015-01-15 00:31:13.000000', 'consum', 0.0287, 'lps'),
	(655780, 134, '2015-01-15 00:31:14.000000', 'consum', 0.0339, 'lps'),
	(655781, 134, '2015-01-15 00:31:15.000000', 'consum', 0.0308, 'lps'),
	(655782, 134, '2015-01-15 00:31:16.000000', 'consum', 0.0311, 'lps'),
	(655783, 134, '2015-01-15 00:31:17.000000', 'consum', 0.0266, 'lps'),
	(655784, 134, '2015-01-15 00:31:18.000000', 'consum', 0.0346, 'lps'),
	(655785, 134, '2015-01-15 00:31:19.000000', 'consum', 0.0248, 'lps'),
	(655786, 134, '2015-01-15 00:31:20.000000', 'consum', 0.0310, 'lps'),
	(655787, 134, '2015-01-15 00:31:21.000000', 'consum', 0.0280, 'lps'),
	(655788, 134, '2015-01-15 00:31:22.000000', 'consum', 0.0259, 'lps'),
	(655789, 134, '2015-01-15 00:31:23.000000', 'consum', 0.0246, 'lps'),
	(655790, 134, '2015-01-15 00:31:24.000000', 'consum', 0.0242, 'lps'),
	(655791, 134, '2015-01-15 00:31:25.000000', 'consum', 0.0265, 'lps'),
	(655792, 134, '2015-01-15 00:31:26.000000', 'consum', 0.0230, 'lps'),
	(655793, 134, '2015-01-15 00:31:27.000000', 'consum', 0.0302, 'lps'),
	(655794, 134, '2015-01-15 00:31:28.000000', 'consum', 0.0297, 'lps'),
	(655795, 134, '2015-01-15 00:31:29.000000', 'consum', 0.0367, 'lps'),
	(655796, 134, '2015-01-15 00:31:30.000000', 'consum', 0.0262, 'lps'),
	(655797, 134, '2015-01-15 00:31:31.000000', 'consum', 0.0316, 'lps'),
	(655798, 134, '2015-01-15 00:31:32.000000', 'consum', 0.0267, 'lps'),
	(655799, 134, '2015-01-15 00:31:33.000000', 'consum', 0.0337, 'lps'),
	(655800, 134, '2015-01-15 00:31:34.000000', 'consum', 0.0358, 'lps'),
	(655801, 134, '2015-01-15 00:31:35.000000', 'consum', 0.0254, 'lps'),
	(655802, 134, '2015-01-15 00:31:36.000000', 'consum', 0.0301, 'lps'),
	(655803, 134, '2015-01-15 00:31:37.000000', 'consum', 0.0218, 'lps'),
	(655804, 134, '2015-01-15 00:31:38.000000', 'consum', 0.0295, 'lps'),
	(655805, 134, '2015-01-15 00:31:39.000000', 'consum', 0.0296, 'lps'),
	(655806, 134, '2015-01-15 00:31:40.000000', 'consum', 0.0225, 'lps'),
	(655807, 134, '2015-01-15 00:31:41.000000', 'consum', 0.0345, 'lps'),
	(655808, 134, '2015-01-15 00:31:42.000000', 'consum', 0.0210, 'lps'),
	(655809, 134, '2015-01-15 00:31:43.000000', 'consum', 0.0278, 'lps'),
	(655810, 134, '2015-01-15 00:31:44.000000', 'consum', 0.0236, 'lps'),
	(655811, 134, '2015-01-15 00:31:45.000000', 'consum', 0.0296, 'lps'),
	(655812, 134, '2015-01-15 00:31:46.000000', 'consum', 0.0243, 'lps'),
	(655813, 134, '2015-01-15 00:31:47.000000', 'consum', 0.0279, 'lps'),
	(655814, 134, '2015-01-15 00:31:48.000000', 'consum', 0.0295, 'lps'),
	(655815, 134, '2015-01-15 00:31:49.000000', 'consum', 0.0272, 'lps'),
	(655816, 134, '2015-01-15 00:31:50.000000', 'consum', 0.0265, 'lps'),
	(655817, 134, '2015-01-15 00:31:51.000000', 'consum', 0.0300, 'lps'),
	(655818, 134, '2015-01-15 00:31:52.000000', 'consum', 0.0339, 'lps'),
	(655819, 134, '2015-01-15 00:31:53.000000', 'consum', 0.0270, 'lps'),
	(655820, 134, '2015-01-15 00:31:54.000000', 'consum', 0.0280, 'lps'),
	(655821, 134, '2015-01-15 00:31:55.000000', 'consum', 0.0225, 'lps'),
	(655822, 134, '2015-01-15 00:31:56.000000', 'consum', 0.0231, 'lps'),
	(655823, 134, '2015-01-15 00:31:57.000000', 'consum', 0.0271, 'lps'),
	(655824, 134, '2015-01-15 00:31:58.000000', 'consum', 0.0293, 'lps'),
	(655825, 134, '2015-01-15 00:31:59.000000', 'consum', 0.0284, 'lps'),
	(655826, 134, '2015-01-15 00:32:00.000000', 'consum', 0.0333, 'lps'),
	(655827, 134, '2015-01-15 00:32:01.000000', 'consum', 0.0286, 'lps'),
	(655828, 134, '2015-01-15 00:32:02.000000', 'consum', 0.0224, 'lps'),
	(655829, 134, '2015-01-15 00:32:03.000000', 'consum', 0.0211, 'lps'),
	(655830, 134, '2015-01-15 00:32:04.000000', 'consum', 0.0330, 'lps'),
	(655831, 134, '2015-01-15 00:32:05.000000', 'consum', 0.0332, 'lps'),
	(655832, 134, '2015-01-15 00:32:06.000000', 'consum', 0.0303, 'lps'),
	(655833, 134, '2015-01-15 00:32:07.000000', 'consum', 0.0311, 'lps'),
	(655834, 134, '2015-01-15 00:32:08.000000', 'consum', 0.0279, 'lps'),
	(655835, 134, '2015-01-15 00:32:09.000000', 'consum', 0.0253, 'lps'),
	(655836, 134, '2015-01-15 00:32:10.000000', 'consum', 0.0217, 'lps'),
	(655837, 134, '2015-01-15 00:32:11.000000', 'consum', 0.0276, 'lps'),
	(655838, 134, '2015-01-15 00:32:12.000000', 'consum', 0.0361, 'lps'),
	(655839, 134, '2015-01-15 00:32:13.000000', 'consum', 0.0293, 'lps'),
	(655840, 134, '2015-01-15 00:32:14.000000', 'consum', 0.0332, 'lps'),
	(655841, 134, '2015-01-15 00:32:15.000000', 'consum', 0.0254, 'lps'),
	(655842, 134, '2015-01-15 00:32:16.000000', 'consum', 0.0222, 'lps'),
	(655843, 134, '2015-01-15 00:32:17.000000', 'consum', 0.0295, 'lps'),
	(655844, 134, '2015-01-15 00:32:18.000000', 'consum', 0.0285, 'lps'),
	(655845, 134, '2015-01-15 00:32:19.000000', 'consum', 0.0331, 'lps'),
	(655846, 134, '2015-01-15 00:32:20.000000', 'consum', 0.0274, 'lps'),
	(655847, 134, '2015-01-15 00:32:21.000000', 'consum', 0.0327, 'lps'),
	(655848, 134, '2015-01-15 00:32:22.000000', 'consum', 0.0287, 'lps'),
	(655849, 134, '2015-01-15 00:32:23.000000', 'consum', 0.0243, 'lps'),
	(655850, 134, '2015-01-15 00:32:24.000000', 'consum', 0.0303, 'lps'),
	(655851, 134, '2015-01-15 00:32:25.000000', 'consum', 0.0261, 'lps'),
	(655852, 134, '2015-01-15 00:32:26.000000', 'consum', 0.0345, 'lps'),
	(655853, 134, '2015-01-15 00:32:27.000000', 'consum', 0.0257, 'lps'),
	(655854, 134, '2015-01-15 00:32:28.000000', 'consum', 0.0359, 'lps'),
	(655855, 134, '2015-01-15 00:32:29.000000', 'consum', 0.0339, 'lps'),
	(655856, 134, '2015-01-15 00:32:30.000000', 'consum', 0.0251, 'lps'),
	(655857, 134, '2015-01-15 00:32:31.000000', 'consum', 0.0344, 'lps'),
	(655858, 134, '2015-01-15 00:32:32.000000', 'consum', 0.0285, 'lps'),
	(655859, 134, '2015-01-15 00:32:33.000000', 'consum', 0.0341, 'lps'),
	(655860, 134, '2015-01-15 00:32:34.000000', 'consum', 0.0323, 'lps'),
	(655861, 134, '2015-01-15 00:32:35.000000', 'consum', 0.0224, 'lps'),
	(655862, 134, '2015-01-15 00:32:36.000000', 'consum', 0.0258, 'lps'),
	(655863, 134, '2015-01-15 00:32:37.000000', 'consum', 0.0252, 'lps'),
	(655864, 134, '2015-01-15 00:32:38.000000', 'consum', 0.0275, 'lps'),
	(655865, 134, '2015-01-15 00:32:39.000000', 'consum', 0.0251, 'lps'),
	(655866, 134, '2015-01-15 00:32:40.000000', 'consum', 0.0220, 'lps'),
	(655867, 134, '2015-01-15 00:32:41.000000', 'consum', 0.0296, 'lps'),
	(655868, 134, '2015-01-15 00:32:42.000000', 'consum', 0.0294, 'lps'),
	(655869, 134, '2015-01-15 00:32:43.000000', 'consum', 0.0213, 'lps'),
	(655870, 134, '2015-01-15 00:32:44.000000', 'consum', 0.0293, 'lps'),
	(655871, 134, '2015-01-15 00:32:45.000000', 'consum', 0.0299, 'lps'),
	(655872, 134, '2015-01-15 00:32:46.000000', 'consum', 0.0249, 'lps'),
	(655873, 134, '2015-01-15 00:32:47.000000', 'consum', 0.0294, 'lps'),
	(655874, 134, '2015-01-15 00:32:48.000000', 'consum', 0.0359, 'lps'),
	(655875, 134, '2015-01-15 00:32:49.000000', 'consum', 0.0228, 'lps'),
	(655876, 134, '2015-01-15 00:32:50.000000', 'consum', 0.0327, 'lps'),
	(655877, 134, '2015-01-15 00:32:51.000000', 'consum', 0.0270, 'lps'),
	(655878, 134, '2015-01-15 00:32:52.000000', 'consum', 0.0315, 'lps'),
	(655879, 134, '2015-01-15 00:32:53.000000', 'consum', 0.0240, 'lps'),
	(655880, 134, '2015-01-15 00:32:54.000000', 'consum', 0.0361, 'lps'),
	(655881, 134, '2015-01-15 00:32:55.000000', 'consum', 0.0246, 'lps'),
	(655882, 134, '2015-01-15 00:32:56.000000', 'consum', 0.0252, 'lps'),
	(655883, 134, '2015-01-15 00:32:57.000000', 'consum', 0.0311, 'lps'),
	(655884, 134, '2015-01-15 00:32:58.000000', 'consum', 0.0274, 'lps'),
	(655885, 134, '2015-01-15 00:32:59.000000', 'consum', 0.0230, 'lps'),
	(655886, 134, '2015-01-15 00:33:00.000000', 'consum', 0.0273, 'lps'),
	(655887, 134, '2015-01-15 00:33:01.000000', 'consum', 0.0309, 'lps'),
	(655888, 134, '2015-01-15 00:33:02.000000', 'consum', 0.0360, 'lps'),
	(655889, 134, '2015-01-15 00:33:03.000000', 'consum', 0.0345, 'lps'),
	(655890, 134, '2015-01-15 00:33:04.000000', 'consum', 0.0278, 'lps'),
	(655891, 134, '2015-01-15 00:33:05.000000', 'consum', 0.0304, 'lps'),
	(655892, 134, '2015-01-15 00:33:06.000000', 'consum', 0.0319, 'lps'),
	(655893, 134, '2015-01-15 00:33:07.000000', 'consum', 0.0314, 'lps'),
	(655894, 134, '2015-01-15 00:33:08.000000', 'consum', 0.0244, 'lps'),
	(655895, 134, '2015-01-15 00:33:09.000000', 'consum', 0.0230, 'lps'),
	(655896, 134, '2015-01-15 00:33:10.000000', 'consum', 0.0363, 'lps'),
	(655897, 134, '2015-01-15 00:33:11.000000', 'consum', 0.0287, 'lps'),
	(655898, 134, '2015-01-15 00:33:12.000000', 'consum', 0.0292, 'lps'),
	(655899, 134, '2015-01-15 00:33:13.000000', 'consum', 0.0231, 'lps'),
	(655900, 134, '2015-01-15 00:33:14.000000', 'consum', 0.0227, 'lps'),
	(655901, 134, '2015-01-15 00:33:15.000000', 'consum', 0.0235, 'lps'),
	(655902, 134, '2015-01-15 00:33:16.000000', 'consum', 0.0285, 'lps'),
	(655903, 134, '2015-01-15 00:33:17.000000', 'consum', 0.0351, 'lps'),
	(655904, 134, '2015-01-15 00:33:18.000000', 'consum', 0.0216, 'lps'),
	(655905, 134, '2015-01-15 00:33:19.000000', 'consum', 0.0293, 'lps'),
	(655906, 134, '2015-01-15 00:33:20.000000', 'consum', 0.0290, 'lps'),
	(655907, 134, '2015-01-15 00:33:21.000000', 'consum', 0.0362, 'lps'),
	(655908, 134, '2015-01-15 00:33:22.000000', 'consum', 0.0256, 'lps'),
	(655909, 134, '2015-01-15 00:33:23.000000', 'consum', 0.0303, 'lps'),
	(655910, 134, '2015-01-15 00:33:24.000000', 'consum', 0.0220, 'lps'),
	(655911, 134, '2015-01-15 00:33:25.000000', 'consum', 0.0296, 'lps'),
	(655912, 134, '2015-01-15 00:33:26.000000', 'consum', 0.0297, 'lps'),
	(655913, 134, '2015-01-15 00:33:27.000000', 'consum', 0.0228, 'lps'),
	(655914, 134, '2015-01-15 00:33:28.000000', 'consum', 0.0357, 'lps'),
	(655915, 134, '2015-01-15 00:33:29.000000', 'consum', 0.0260, 'lps'),
	(655916, 134, '2015-01-15 00:33:30.000000', 'consum', 0.0333, 'lps'),
	(655917, 134, '2015-01-15 00:33:31.000000', 'consum', 0.0360, 'lps'),
	(655918, 134, '2015-01-15 00:33:32.000000', 'consum', 0.0277, 'lps'),
	(655919, 134, '2015-01-15 00:33:33.000000', 'consum', 0.0251, 'lps'),
	(655920, 134, '2015-01-15 00:33:34.000000', 'consum', 0.0214, 'lps'),
	(655921, 134, '2015-01-15 00:33:35.000000', 'consum', 0.0268, 'lps'),
	(655922, 134, '2015-01-15 00:33:36.000000', 'consum', 0.0328, 'lps'),
	(655923, 134, '2015-01-15 00:33:37.000000', 'consum', 0.0314, 'lps'),
	(655924, 134, '2015-01-15 00:33:38.000000', 'consum', 0.0215, 'lps'),
	(655925, 134, '2015-01-15 00:33:39.000000', 'consum', 0.0243, 'lps'),
	(655926, 134, '2015-01-15 00:33:40.000000', 'consum', 0.0357, 'lps'),
	(655927, 134, '2015-01-15 00:33:41.000000', 'consum', 0.0215, 'lps'),
	(655928, 134, '2015-01-15 00:33:42.000000', 'consum', 0.0271, 'lps'),
	(655929, 134, '2015-01-15 00:33:43.000000', 'consum', 0.0341, 'lps'),
	(655930, 134, '2015-01-15 00:33:44.000000', 'consum', 0.0367, 'lps'),
	(655931, 134, '2015-01-15 00:33:45.000000', 'consum', 0.0287, 'lps'),
	(655932, 134, '2015-01-15 00:33:46.000000', 'consum', 0.0282, 'lps'),
	(655933, 134, '2015-01-15 00:33:47.000000', 'consum', 0.0339, 'lps'),
	(655934, 134, '2015-01-15 00:33:48.000000', 'consum', 0.0322, 'lps'),
	(655935, 134, '2015-01-15 00:33:49.000000', 'consum', 0.0229, 'lps'),
	(655936, 134, '2015-01-15 00:33:50.000000', 'consum', 0.0283, 'lps'),
	(655937, 134, '2015-01-15 00:33:51.000000', 'consum', 0.0359, 'lps'),
	(655938, 134, '2015-01-15 00:33:52.000000', 'consum', 0.0265, 'lps'),
	(655939, 134, '2015-01-15 00:33:53.000000', 'consum', 0.0354, 'lps'),
	(655940, 134, '2015-01-15 00:33:54.000000', 'consum', 0.0292, 'lps'),
	(655941, 134, '2015-01-15 00:33:55.000000', 'consum', 0.0346, 'lps'),
	(655942, 134, '2015-01-15 00:33:56.000000', 'consum', 0.0330, 'lps'),
	(655943, 134, '2015-01-15 00:33:57.000000', 'consum', 0.0243, 'lps'),
	(655944, 134, '2015-01-15 00:33:58.000000', 'consum', 0.0333, 'lps'),
	(655945, 134, '2015-01-15 00:33:59.000000', 'consum', 0.0250, 'lps'),
	(655946, 134, '2015-01-15 00:34:00.000000', 'consum', 0.0361, 'lps'),
	(655947, 134, '2015-01-15 00:34:01.000000', 'consum', 0.0210, 'lps'),
	(655948, 134, '2015-01-15 00:34:02.000000', 'consum', 0.0233, 'lps'),
	(655949, 134, '2015-01-15 00:34:03.000000', 'consum', 0.0325, 'lps'),
	(655950, 134, '2015-01-15 00:34:04.000000', 'consum', 0.0244, 'lps'),
	(655951, 134, '2015-01-15 00:34:05.000000', 'consum', 0.0352, 'lps'),
	(655952, 134, '2015-01-15 00:34:06.000000', 'consum', 0.0344, 'lps'),
	(655953, 134, '2015-01-15 00:34:07.000000', 'consum', 0.0296, 'lps'),
	(655954, 134, '2015-01-15 00:34:08.000000', 'consum', 0.0241, 'lps'),
	(655955, 134, '2015-01-15 00:34:09.000000', 'consum', 0.0262, 'lps'),
	(655956, 134, '2015-01-15 00:34:10.000000', 'consum', 0.0221, 'lps'),
	(655957, 134, '2015-01-15 00:34:11.000000', 'consum', 0.0267, 'lps'),
	(655958, 134, '2015-01-15 00:34:12.000000', 'consum', 0.0307, 'lps'),
	(655959, 134, '2015-01-15 00:34:13.000000', 'consum', 0.0363, 'lps'),
	(655960, 134, '2015-01-15 00:34:14.000000', 'consum', 0.0211, 'lps'),
	(655961, 134, '2015-01-15 00:34:15.000000', 'consum', 0.0232, 'lps'),
	(655962, 134, '2015-01-15 00:34:16.000000', 'consum', 0.0316, 'lps'),
	(655963, 134, '2015-01-15 00:34:17.000000', 'consum', 0.0360, 'lps'),
	(655964, 134, '2015-01-15 00:34:18.000000', 'consum', 0.0325, 'lps'),
	(655965, 134, '2015-01-15 00:34:19.000000', 'consum', 0.0337, 'lps'),
	(655966, 134, '2015-01-15 00:34:20.000000', 'consum', 0.0341, 'lps'),
	(655967, 134, '2015-01-15 00:34:21.000000', 'consum', 0.0326, 'lps'),
	(655968, 134, '2015-01-15 00:34:22.000000', 'consum', 0.0241, 'lps'),
	(655969, 134, '2015-01-15 00:34:23.000000', 'consum', 0.0333, 'lps'),
	(655970, 134, '2015-01-15 00:34:24.000000', 'consum', 0.0258, 'lps'),
	(655971, 134, '2015-01-15 00:34:25.000000', 'consum', 0.0241, 'lps'),
	(655972, 134, '2015-01-15 00:34:26.000000', 'consum', 0.0219, 'lps'),
	(655973, 134, '2015-01-15 00:34:27.000000', 'consum', 0.0322, 'lps'),
	(655974, 134, '2015-01-15 00:34:28.000000', 'consum', 0.0269, 'lps'),
	(655975, 134, '2015-01-15 00:34:29.000000', 'consum', 0.0326, 'lps'),
	(655976, 134, '2015-01-15 00:34:30.000000', 'consum', 0.0301, 'lps'),
	(655977, 134, '2015-01-15 00:34:31.000000', 'consum', 0.0314, 'lps'),
	(655978, 134, '2015-01-15 00:34:32.000000', 'consum', 0.0300, 'lps'),
	(655979, 134, '2015-01-15 00:34:33.000000', 'consum', 0.0351, 'lps'),
	(655980, 134, '2015-01-15 00:34:34.000000', 'consum', 0.0329, 'lps'),
	(655981, 134, '2015-01-15 00:34:35.000000', 'consum', 0.0222, 'lps'),
	(655982, 134, '2015-01-15 00:34:36.000000', 'consum', 0.0231, 'lps'),
	(655983, 134, '2015-01-15 00:34:37.000000', 'consum', 0.0278, 'lps'),
	(655984, 134, '2015-01-15 00:34:38.000000', 'consum', 0.0330, 'lps'),
	(655985, 134, '2015-01-15 00:34:39.000000', 'consum', 0.0291, 'lps'),
	(655986, 134, '2015-01-15 00:34:40.000000', 'consum', 0.0257, 'lps'),
	(655987, 134, '2015-01-15 00:34:41.000000', 'consum', 0.0358, 'lps'),
	(655988, 134, '2015-01-15 00:34:42.000000', 'consum', 0.0334, 'lps'),
	(655989, 134, '2015-01-15 00:34:43.000000', 'consum', 0.0232, 'lps'),
	(655990, 134, '2015-01-15 00:34:44.000000', 'consum', 0.0262, 'lps'),
	(655991, 134, '2015-01-15 00:34:45.000000', 'consum', 0.0247, 'lps'),
	(655992, 134, '2015-01-15 00:34:46.000000', 'consum', 0.0241, 'lps'),
	(655993, 134, '2015-01-15 00:34:47.000000', 'consum', 0.0254, 'lps'),
	(655994, 134, '2015-01-15 00:34:48.000000', 'consum', 0.0338, 'lps'),
	(655995, 134, '2015-01-15 00:34:49.000000', 'consum', 0.0243, 'lps'),
	(655996, 134, '2015-01-15 00:34:50.000000', 'consum', 0.0310, 'lps'),
	(655997, 134, '2015-01-15 00:34:51.000000', 'consum', 0.0292, 'lps'),
	(655998, 134, '2015-01-15 00:34:52.000000', 'consum', 0.0323, 'lps'),
	(655999, 134, '2015-01-15 00:34:53.000000', 'consum', 0.0211, 'lps'),
	(656000, 134, '2015-01-15 00:34:54.000000', 'consum', 0.0352, 'lps'),
	(656001, 134, '2015-01-15 00:34:55.000000', 'consum', 0.0284, 'lps'),
	(656002, 134, '2015-01-15 00:34:56.000000', 'consum', 0.0312, 'lps'),
	(656003, 134, '2015-01-15 00:34:57.000000', 'consum', 0.0342, 'lps'),
	(656004, 134, '2015-01-15 00:34:58.000000', 'consum', 0.0250, 'lps'),
	(656005, 134, '2015-01-15 00:34:59.000000', 'consum', 0.0330, 'lps'),
	(656006, 134, '2015-01-15 00:35:00.000000', 'consum', 0.0216, 'lps'),
	(656007, 134, '2015-01-15 00:35:01.000000', 'consum', 0.0355, 'lps'),
	(656008, 134, '2015-01-15 00:35:02.000000', 'consum', 0.0283, 'lps'),
	(656009, 134, '2015-01-15 00:35:03.000000', 'consum', 0.0301, 'lps'),
	(656010, 134, '2015-01-15 00:35:04.000000', 'consum', 0.0289, 'lps'),
	(656011, 134, '2015-01-15 00:35:05.000000', 'consum', 0.0330, 'lps'),
	(656012, 134, '2015-01-15 00:35:06.000000', 'consum', 0.0260, 'lps'),
	(656013, 134, '2015-01-15 00:35:07.000000', 'consum', 0.0258, 'lps'),
	(656014, 134, '2015-01-15 00:35:08.000000', 'consum', 0.0302, 'lps'),
	(656015, 134, '2015-01-15 00:35:09.000000', 'consum', 0.0367, 'lps'),
	(656016, 134, '2015-01-15 00:35:10.000000', 'consum', 0.0247, 'lps'),
	(656017, 134, '2015-01-15 00:35:11.000000', 'consum', 0.0241, 'lps'),
	(656018, 134, '2015-01-15 00:35:12.000000', 'consum', 0.0253, 'lps'),
	(656019, 134, '2015-01-15 00:35:13.000000', 'consum', 0.0331, 'lps'),
	(656020, 134, '2015-01-15 00:35:14.000000', 'consum', 0.0214, 'lps'),
	(656021, 134, '2015-01-15 00:35:15.000000', 'consum', 0.0343, 'lps'),
	(656022, 134, '2015-01-15 00:35:16.000000', 'consum', 0.0230, 'lps'),
	(656023, 134, '2015-01-15 00:35:17.000000', 'consum', 0.0230, 'lps'),
	(656024, 134, '2015-01-15 00:35:18.000000', 'consum', 0.0248, 'lps'),
	(656025, 134, '2015-01-15 00:35:19.000000', 'consum', 0.0339, 'lps'),
	(656026, 134, '2015-01-15 00:35:20.000000', 'consum', 0.0270, 'lps'),
	(656027, 134, '2015-01-15 00:35:21.000000', 'consum', 0.0282, 'lps'),
	(656028, 134, '2015-01-15 00:35:22.000000', 'consum', 0.0233, 'lps'),
	(656029, 134, '2015-01-15 00:35:23.000000', 'consum', 0.0265, 'lps'),
	(656030, 134, '2015-01-15 00:35:24.000000', 'consum', 0.0261, 'lps'),
	(656031, 134, '2015-01-15 00:35:25.000000', 'consum', 0.0297, 'lps'),
	(656032, 134, '2015-01-15 00:35:26.000000', 'consum', 0.0338, 'lps'),
	(656033, 134, '2015-01-15 00:35:27.000000', 'consum', 0.0273, 'lps'),
	(656034, 134, '2015-01-15 00:35:28.000000', 'consum', 0.0297, 'lps'),
	(656035, 134, '2015-01-15 00:35:29.000000', 'consum', 0.0302, 'lps'),
	(656036, 134, '2015-01-15 00:35:30.000000', 'consum', 0.0250, 'lps'),
	(656037, 134, '2015-01-15 00:35:31.000000', 'consum', 0.0291, 'lps'),
	(656038, 134, '2015-01-15 00:35:32.000000', 'consum', 0.0341, 'lps'),
	(656039, 134, '2015-01-15 00:35:33.000000', 'consum', 0.0303, 'lps'),
	(656040, 134, '2015-01-15 00:35:34.000000', 'consum', 0.0284, 'lps'),
	(656041, 134, '2015-01-15 00:35:35.000000', 'consum', 0.0300, 'lps'),
	(656042, 134, '2015-01-15 00:35:36.000000', 'consum', 0.0282, 'lps'),
	(656043, 134, '2015-01-15 00:35:37.000000', 'consum', 0.0299, 'lps'),
	(656044, 134, '2015-01-15 00:35:38.000000', 'consum', 0.0282, 'lps'),
	(656045, 134, '2015-01-15 00:35:39.000000', 'consum', 0.0304, 'lps'),
	(656046, 134, '2015-01-15 00:35:40.000000', 'consum', 0.0308, 'lps'),
	(656047, 134, '2015-01-15 00:35:41.000000', 'consum', 0.0261, 'lps'),
	(656048, 134, '2015-01-15 00:35:42.000000', 'consum', 0.0327, 'lps'),
	(656049, 134, '2015-01-15 00:35:43.000000', 'consum', 0.0328, 'lps'),
	(656050, 134, '2015-01-15 00:35:44.000000', 'consum', 0.0291, 'lps'),
	(656051, 134, '2015-01-15 00:35:45.000000', 'consum', 0.0262, 'lps'),
	(656052, 134, '2015-01-15 00:35:46.000000', 'consum', 0.0227, 'lps'),
	(656053, 134, '2015-01-15 00:35:47.000000', 'consum', 0.0299, 'lps'),
	(656054, 134, '2015-01-15 00:35:48.000000', 'consum', 0.0287, 'lps'),
	(656055, 134, '2015-01-15 00:35:49.000000', 'consum', 0.0330, 'lps'),
	(656056, 134, '2015-01-15 00:35:50.000000', 'consum', 0.0263, 'lps'),
	(656057, 134, '2015-01-15 00:35:51.000000', 'consum', 0.0275, 'lps'),
	(656058, 134, '2015-01-15 00:35:52.000000', 'consum', 0.0217, 'lps'),
	(656059, 134, '2015-01-15 00:35:53.000000', 'consum', 0.0367, 'lps'),
	(656060, 134, '2015-01-15 00:35:54.000000', 'consum', 0.0342, 'lps'),
	(656061, 134, '2015-01-15 00:35:55.000000', 'consum', 0.0242, 'lps'),
	(656062, 134, '2015-01-15 00:35:56.000000', 'consum', 0.0289, 'lps'),
	(656063, 134, '2015-01-15 00:35:57.000000', 'consum', 0.0351, 'lps'),
	(656064, 134, '2015-01-15 00:35:58.000000', 'consum', 0.0364, 'lps'),
	(656065, 134, '2015-01-15 00:35:59.000000', 'consum', 0.0243, 'lps'),
	(656066, 134, '2015-01-15 00:36:00.000000', 'consum', 0.0227, 'lps'),
	(656067, 134, '2015-01-15 00:36:01.000000', 'consum', 0.0356, 'lps'),
	(656068, 134, '2015-01-15 00:36:02.000000', 'consum', 0.0256, 'lps'),
	(656069, 134, '2015-01-15 00:36:03.000000', 'consum', 0.0321, 'lps'),
	(656070, 134, '2015-01-15 00:36:04.000000', 'consum', 0.0309, 'lps'),
	(656071, 134, '2015-01-15 00:36:05.000000', 'consum', 0.0216, 'lps'),
	(656072, 134, '2015-01-15 00:36:06.000000', 'consum', 0.0260, 'lps'),
	(656073, 134, '2015-01-15 00:36:07.000000', 'consum', 0.0284, 'lps'),
	(656074, 134, '2015-01-15 00:36:08.000000', 'consum', 0.0271, 'lps'),
	(656075, 134, '2015-01-15 00:36:09.000000', 'consum', 0.0296, 'lps'),
	(656076, 134, '2015-01-15 00:36:10.000000', 'consum', 0.0300, 'lps'),
	(656077, 134, '2015-01-15 00:36:11.000000', 'consum', 0.0245, 'lps'),
	(656078, 134, '2015-01-15 00:36:12.000000', 'consum', 0.0270, 'lps'),
	(656079, 134, '2015-01-15 00:36:13.000000', 'consum', 0.0251, 'lps'),
	(656080, 134, '2015-01-15 00:36:14.000000', 'consum', 0.0234, 'lps'),
	(656081, 134, '2015-01-15 00:36:15.000000', 'consum', 0.0366, 'lps'),
	(656082, 134, '2015-01-15 00:36:16.000000', 'consum', 0.0287, 'lps'),
	(656083, 134, '2015-01-15 00:36:17.000000', 'consum', 0.0285, 'lps'),
	(656084, 134, '2015-01-15 00:36:18.000000', 'consum', 0.0354, 'lps'),
	(656085, 134, '2015-01-15 00:36:19.000000', 'consum', 0.0231, 'lps'),
	(656086, 134, '2015-01-15 00:36:20.000000', 'consum', 0.0356, 'lps'),
	(656087, 134, '2015-01-15 00:36:21.000000', 'consum', 0.0248, 'lps'),
	(656088, 134, '2015-01-15 00:36:22.000000', 'consum', 0.0279, 'lps'),
	(656089, 134, '2015-01-15 00:36:23.000000', 'consum', 0.0281, 'lps'),
	(656090, 134, '2015-01-15 00:36:24.000000', 'consum', 0.0359, 'lps'),
	(656091, 134, '2015-01-15 00:36:25.000000', 'consum', 0.0267, 'lps'),
	(656092, 134, '2015-01-15 00:36:26.000000', 'consum', 0.0210, 'lps'),
	(656093, 134, '2015-01-15 00:36:27.000000', 'consum', 0.0354, 'lps'),
	(656094, 134, '2015-01-15 00:36:28.000000', 'consum', 0.0297, 'lps'),
	(656095, 134, '2015-01-15 00:36:29.000000', 'consum', 0.0215, 'lps'),
	(656096, 134, '2015-01-15 00:36:30.000000', 'consum', 0.0291, 'lps'),
	(656097, 134, '2015-01-15 00:36:31.000000', 'consum', 0.0286, 'lps'),
	(656098, 134, '2015-01-15 00:36:32.000000', 'consum', 0.0346, 'lps'),
	(656099, 134, '2015-01-15 00:36:33.000000', 'consum', 0.0345, 'lps'),
	(656100, 134, '2015-01-15 00:36:34.000000', 'consum', 0.0320, 'lps'),
	(656101, 134, '2015-01-15 00:36:35.000000', 'consum', 0.0356, 'lps'),
	(656102, 134, '2015-01-15 00:36:36.000000', 'consum', 0.0293, 'lps'),
	(656103, 134, '2015-01-15 00:36:37.000000', 'consum', 0.0348, 'lps'),
	(656104, 134, '2015-01-15 00:36:38.000000', 'consum', 0.0334, 'lps'),
	(656105, 134, '2015-01-15 00:36:39.000000', 'consum', 0.0257, 'lps'),
	(656106, 134, '2015-01-15 00:36:40.000000', 'consum', 0.0234, 'lps'),
	(656107, 134, '2015-01-15 00:36:41.000000', 'consum', 0.0347, 'lps'),
	(656108, 134, '2015-01-15 00:36:42.000000', 'consum', 0.0350, 'lps'),
	(656109, 134, '2015-01-15 00:36:43.000000', 'consum', 0.0342, 'lps'),
	(656110, 134, '2015-01-15 00:36:44.000000', 'consum', 0.0290, 'lps'),
	(656111, 134, '2015-01-15 00:36:45.000000', 'consum', 0.0218, 'lps'),
	(656112, 134, '2015-01-15 00:36:46.000000', 'consum', 0.0324, 'lps'),
	(656113, 134, '2015-01-15 00:36:47.000000', 'consum', 0.0284, 'lps'),
	(656114, 134, '2015-01-15 00:36:48.000000', 'consum', 0.0238, 'lps'),
	(656115, 134, '2015-01-15 00:36:49.000000', 'consum', 0.0288, 'lps'),
	(656116, 134, '2015-01-15 00:36:50.000000', 'consum', 0.0356, 'lps'),
	(656117, 134, '2015-01-15 00:36:51.000000', 'consum', 0.0235, 'lps'),
	(656118, 134, '2015-01-15 00:36:52.000000', 'consum', 0.0212, 'lps'),
	(656119, 134, '2015-01-15 00:36:53.000000', 'consum', 0.0303, 'lps'),
	(656120, 134, '2015-01-15 00:36:54.000000', 'consum', 0.0355, 'lps'),
	(656121, 134, '2015-01-15 00:36:55.000000', 'consum', 0.0339, 'lps'),
	(656122, 134, '2015-01-15 00:36:56.000000', 'consum', 0.0265, 'lps'),
	(656123, 134, '2015-01-15 00:36:57.000000', 'consum', 0.0254, 'lps'),
	(656124, 134, '2015-01-15 00:36:58.000000', 'consum', 0.0264, 'lps'),
	(656125, 134, '2015-01-15 00:36:59.000000', 'consum', 0.0351, 'lps'),
	(656126, 134, '2015-01-15 00:37:00.000000', 'consum', 0.0279, 'lps'),
	(656127, 134, '2015-01-15 00:37:01.000000', 'consum', 0.0290, 'lps'),
	(656128, 134, '2015-01-15 00:37:02.000000', 'consum', 0.0245, 'lps'),
	(656129, 134, '2015-01-15 00:37:03.000000', 'consum', 0.0306, 'lps'),
	(656130, 134, '2015-01-15 00:37:04.000000', 'consum', 0.0267, 'lps'),
	(656131, 134, '2015-01-15 00:37:05.000000', 'consum', 0.0366, 'lps'),
	(656132, 134, '2015-01-15 00:37:06.000000', 'consum', 0.0347, 'lps'),
	(656133, 134, '2015-01-15 00:37:07.000000', 'consum', 0.0268, 'lps'),
	(656134, 134, '2015-01-15 00:37:08.000000', 'consum', 0.0249, 'lps'),
	(656135, 134, '2015-01-15 00:37:09.000000', 'consum', 0.0230, 'lps'),
	(656136, 134, '2015-01-15 00:37:10.000000', 'consum', 0.0350, 'lps'),
	(656137, 134, '2015-01-15 00:37:11.000000', 'consum', 0.0222, 'lps'),
	(656138, 134, '2015-01-15 00:37:12.000000', 'consum', 0.0323, 'lps'),
	(656139, 134, '2015-01-15 00:37:13.000000', 'consum', 0.0264, 'lps'),
	(656140, 134, '2015-01-15 00:37:14.000000', 'consum', 0.0299, 'lps'),
	(656141, 134, '2015-01-15 00:37:15.000000', 'consum', 0.0335, 'lps'),
	(656142, 134, '2015-01-15 00:37:16.000000', 'consum', 0.0255, 'lps'),
	(656143, 134, '2015-01-15 00:37:17.000000', 'consum', 0.0217, 'lps'),
	(656144, 134, '2015-01-15 00:37:18.000000', 'consum', 0.0269, 'lps'),
	(656145, 134, '2015-01-15 00:37:19.000000', 'consum', 0.0327, 'lps'),
	(656146, 134, '2015-01-15 00:37:20.000000', 'consum', 0.0303, 'lps'),
	(656147, 134, '2015-01-15 00:37:21.000000', 'consum', 0.0323, 'lps'),
	(656148, 134, '2015-01-15 00:37:22.000000', 'consum', 0.0338, 'lps'),
	(656149, 134, '2015-01-15 00:37:23.000000', 'consum', 0.0355, 'lps'),
	(656150, 134, '2015-01-15 00:37:24.000000', 'consum', 0.0235, 'lps'),
	(656151, 134, '2015-01-15 00:37:25.000000', 'consum', 0.0218, 'lps'),
	(656152, 134, '2015-01-15 00:37:26.000000', 'consum', 0.0333, 'lps'),
	(656153, 134, '2015-01-15 00:37:27.000000', 'consum', 0.0328, 'lps'),
	(656154, 134, '2015-01-15 00:37:28.000000', 'consum', 0.0275, 'lps'),
	(656155, 134, '2015-01-15 00:37:29.000000', 'consum', 0.0337, 'lps'),
	(656156, 134, '2015-01-15 00:37:30.000000', 'consum', 0.0336, 'lps'),
	(656157, 134, '2015-01-15 00:37:31.000000', 'consum', 0.0300, 'lps'),
	(656158, 134, '2015-01-15 00:37:32.000000', 'consum', 0.0283, 'lps'),
	(656159, 134, '2015-01-15 00:37:33.000000', 'consum', 0.0307, 'lps'),
	(656160, 134, '2015-01-15 00:37:34.000000', 'consum', 0.0318, 'lps'),
	(656161, 134, '2015-01-15 00:37:35.000000', 'consum', 0.0301, 'lps'),
	(656162, 134, '2015-01-15 00:37:36.000000', 'consum', 0.0343, 'lps'),
	(656163, 134, '2015-01-15 00:37:37.000000', 'consum', 0.0287, 'lps'),
	(656164, 134, '2015-01-15 00:37:38.000000', 'consum', 0.0354, 'lps'),
	(656165, 134, '2015-01-15 00:37:39.000000', 'consum', 0.0224, 'lps'),
	(656166, 134, '2015-01-15 00:37:40.000000', 'consum', 0.0323, 'lps'),
	(656167, 134, '2015-01-15 00:37:41.000000', 'consum', 0.0261, 'lps'),
	(656168, 134, '2015-01-15 00:37:42.000000', 'consum', 0.0283, 'lps'),
	(656169, 134, '2015-01-15 00:37:43.000000', 'consum', 0.0266, 'lps'),
	(656170, 134, '2015-01-15 00:37:44.000000', 'consum', 0.0272, 'lps'),
	(656171, 134, '2015-01-15 00:37:45.000000', 'consum', 0.0352, 'lps'),
	(656172, 134, '2015-01-15 00:37:46.000000', 'consum', 0.0260, 'lps'),
	(656173, 134, '2015-01-15 00:37:47.000000', 'consum', 0.0353, 'lps'),
	(656174, 134, '2015-01-15 00:37:48.000000', 'consum', 0.0299, 'lps'),
	(656175, 134, '2015-01-15 00:37:49.000000', 'consum', 0.0227, 'lps'),
	(656176, 134, '2015-01-15 00:37:50.000000', 'consum', 0.0343, 'lps'),
	(656177, 134, '2015-01-15 00:37:51.000000', 'consum', 0.0350, 'lps'),
	(656178, 134, '2015-01-15 00:37:52.000000', 'consum', 0.0356, 'lps'),
	(656179, 134, '2015-01-15 00:37:53.000000', 'consum', 0.0362, 'lps'),
	(656180, 134, '2015-01-15 00:37:54.000000', 'consum', 0.0218, 'lps'),
	(656181, 134, '2015-01-15 00:37:55.000000', 'consum', 0.0265, 'lps'),
	(656182, 134, '2015-01-15 00:37:56.000000', 'consum', 0.0307, 'lps'),
	(656183, 134, '2015-01-15 00:37:57.000000', 'consum', 0.0214, 'lps'),
	(656184, 134, '2015-01-15 00:37:58.000000', 'consum', 0.0255, 'lps'),
	(656185, 134, '2015-01-15 00:37:59.000000', 'consum', 0.0265, 'lps'),
	(656186, 134, '2015-01-15 00:38:00.000000', 'consum', 0.0352, 'lps'),
	(656187, 134, '2015-01-15 00:38:01.000000', 'consum', 0.0280, 'lps'),
	(656188, 134, '2015-01-15 00:38:02.000000', 'consum', 0.0295, 'lps'),
	(656189, 134, '2015-01-15 00:38:03.000000', 'consum', 0.0265, 'lps'),
	(656190, 134, '2015-01-15 00:38:04.000000', 'consum', 0.0231, 'lps'),
	(656191, 134, '2015-01-15 00:38:05.000000', 'consum', 0.0308, 'lps'),
	(656192, 134, '2015-01-15 00:38:06.000000', 'consum', 0.0321, 'lps'),
	(656193, 134, '2015-01-15 00:38:07.000000', 'consum', 0.0315, 'lps'),
	(656194, 134, '2015-01-15 00:38:08.000000', 'consum', 0.0244, 'lps'),
	(656195, 134, '2015-01-15 00:38:09.000000', 'consum', 0.0222, 'lps'),
	(656196, 134, '2015-01-15 00:38:10.000000', 'consum', 0.0327, 'lps'),
	(656197, 134, '2015-01-15 00:38:11.000000', 'consum', 0.0287, 'lps'),
	(656198, 134, '2015-01-15 00:38:12.000000', 'consum', 0.0242, 'lps'),
	(656199, 134, '2015-01-15 00:38:13.000000', 'consum', 0.0298, 'lps'),
	(656200, 134, '2015-01-15 00:38:14.000000', 'consum', 0.0240, 'lps'),
	(656201, 134, '2015-01-15 00:38:15.000000', 'consum', 0.0254, 'lps'),
	(656202, 134, '2015-01-15 00:38:16.000000', 'consum', 0.0342, 'lps'),
	(656203, 134, '2015-01-15 00:38:17.000000', 'consum', 0.0262, 'lps'),
	(656204, 134, '2015-01-15 00:38:18.000000', 'consum', 0.0235, 'lps'),
	(656205, 134, '2015-01-15 00:38:19.000000', 'consum', 0.0336, 'lps'),
	(656206, 134, '2015-01-15 00:38:20.000000', 'consum', 0.0290, 'lps'),
	(656207, 134, '2015-01-15 00:38:21.000000', 'consum', 0.0235, 'lps'),
	(656208, 134, '2015-01-15 00:38:22.000000', 'consum', 0.0255, 'lps'),
	(656209, 134, '2015-01-15 00:38:23.000000', 'consum', 0.0358, 'lps'),
	(656210, 134, '2015-01-15 00:38:24.000000', 'consum', 0.0341, 'lps'),
	(656211, 134, '2015-01-15 00:38:25.000000', 'consum', 0.0264, 'lps'),
	(656212, 134, '2015-01-15 00:38:26.000000', 'consum', 0.0246, 'lps'),
	(656213, 134, '2015-01-15 00:38:27.000000', 'consum', 0.0228, 'lps'),
	(656214, 134, '2015-01-15 00:38:28.000000', 'consum', 0.0352, 'lps'),
	(656215, 134, '2015-01-15 00:38:29.000000', 'consum', 0.0232, 'lps'),
	(656216, 134, '2015-01-15 00:38:30.000000', 'consum', 0.0211, 'lps'),
	(656217, 134, '2015-01-15 00:38:31.000000', 'consum', 0.0309, 'lps'),
	(656218, 134, '2015-01-15 00:38:32.000000', 'consum', 0.0228, 'lps'),
	(656219, 134, '2015-01-15 00:38:33.000000', 'consum', 0.0318, 'lps'),
	(656220, 134, '2015-01-15 00:38:34.000000', 'consum', 0.0224, 'lps'),
	(656221, 134, '2015-01-15 00:38:35.000000', 'consum', 0.0273, 'lps'),
	(656222, 134, '2015-01-15 00:38:36.000000', 'consum', 0.0325, 'lps'),
	(656223, 134, '2015-01-15 00:38:37.000000', 'consum', 0.0279, 'lps'),
	(656224, 134, '2015-01-15 00:38:38.000000', 'consum', 0.0214, 'lps'),
	(656225, 134, '2015-01-15 00:38:39.000000', 'consum', 0.0336, 'lps'),
	(656226, 134, '2015-01-15 00:38:40.000000', 'consum', 0.0355, 'lps'),
	(656227, 134, '2015-01-15 00:38:41.000000', 'consum', 0.0243, 'lps'),
	(656228, 134, '2015-01-15 00:38:42.000000', 'consum', 0.0254, 'lps'),
	(656229, 134, '2015-01-15 00:38:43.000000', 'consum', 0.0332, 'lps'),
	(656230, 134, '2015-01-15 00:38:44.000000', 'consum', 0.0214, 'lps'),
	(656231, 134, '2015-01-15 00:38:45.000000', 'consum', 0.0341, 'lps'),
	(656232, 134, '2015-01-15 00:38:46.000000', 'consum', 0.0221, 'lps'),
	(656233, 134, '2015-01-15 00:38:47.000000', 'consum', 0.0345, 'lps'),
	(656234, 134, '2015-01-15 00:38:48.000000', 'consum', 0.0222, 'lps'),
	(656235, 134, '2015-01-15 00:38:49.000000', 'consum', 0.0337, 'lps'),
	(656236, 134, '2015-01-15 00:38:50.000000', 'consum', 0.0337, 'lps'),
	(656237, 134, '2015-01-15 00:38:51.000000', 'consum', 0.0308, 'lps'),
	(656238, 134, '2015-01-15 00:38:52.000000', 'consum', 0.0317, 'lps'),
	(656239, 134, '2015-01-15 00:38:53.000000', 'consum', 0.0294, 'lps'),
	(656240, 134, '2015-01-15 00:38:54.000000', 'consum', 0.0310, 'lps'),
	(656241, 134, '2015-01-15 00:38:55.000000', 'consum', 0.0300, 'lps'),
	(656242, 134, '2015-01-15 00:38:56.000000', 'consum', 0.0363, 'lps'),
	(656243, 134, '2015-01-15 00:38:57.000000', 'consum', 0.0230, 'lps'),
	(656244, 134, '2015-01-15 00:38:58.000000', 'consum', 0.0323, 'lps'),
	(656245, 134, '2015-01-15 00:38:59.000000', 'consum', 0.0245, 'lps'),
	(656246, 134, '2015-01-15 00:39:00.000000', 'consum', 0.0362, 'lps'),
	(656247, 134, '2015-01-15 00:39:01.000000', 'consum', 0.0233, 'lps'),
	(656248, 134, '2015-01-15 00:39:02.000000', 'consum', 0.0343, 'lps'),
	(656249, 134, '2015-01-15 00:39:03.000000', 'consum', 0.0333, 'lps'),
	(656250, 134, '2015-01-15 00:39:04.000000', 'consum', 0.0270, 'lps'),
	(656251, 134, '2015-01-15 00:39:05.000000', 'consum', 0.0300, 'lps'),
	(656252, 134, '2015-01-15 00:39:06.000000', 'consum', 0.0322, 'lps'),
	(656253, 134, '2015-01-15 00:39:07.000000', 'consum', 0.0340, 'lps'),
	(656254, 134, '2015-01-15 00:39:08.000000', 'consum', 0.0210, 'lps'),
	(656255, 134, '2015-01-15 00:39:09.000000', 'consum', 0.0297, 'lps'),
	(656256, 134, '2015-01-15 00:39:10.000000', 'consum', 0.0326, 'lps'),
	(656257, 134, '2015-01-15 00:39:11.000000', 'consum', 0.0215, 'lps'),
	(656258, 134, '2015-01-15 00:39:12.000000', 'consum', 0.0360, 'lps'),
	(656259, 134, '2015-01-15 00:39:13.000000', 'consum', 0.0316, 'lps'),
	(656260, 134, '2015-01-15 00:39:14.000000', 'consum', 0.0290, 'lps'),
	(656261, 134, '2015-01-15 00:39:15.000000', 'consum', 0.0294, 'lps'),
	(656262, 134, '2015-01-15 00:39:16.000000', 'consum', 0.0229, 'lps'),
	(656263, 134, '2015-01-15 00:39:17.000000', 'consum', 0.0215, 'lps'),
	(656264, 134, '2015-01-15 00:39:18.000000', 'consum', 0.0335, 'lps'),
	(656265, 134, '2015-01-15 00:39:19.000000', 'consum', 0.0348, 'lps'),
	(656266, 134, '2015-01-15 00:39:20.000000', 'consum', 0.0367, 'lps'),
	(656267, 134, '2015-01-15 00:39:21.000000', 'consum', 0.0266, 'lps'),
	(656268, 134, '2015-01-15 00:39:22.000000', 'consum', 0.0334, 'lps'),
	(656269, 134, '2015-01-15 00:39:23.000000', 'consum', 0.0349, 'lps'),
	(656270, 134, '2015-01-15 00:39:24.000000', 'consum', 0.0216, 'lps'),
	(656271, 134, '2015-01-15 00:39:25.000000', 'consum', 0.0299, 'lps'),
	(656272, 134, '2015-01-15 00:39:26.000000', 'consum', 0.0321, 'lps'),
	(656273, 134, '2015-01-15 00:39:27.000000', 'consum', 0.0340, 'lps'),
	(656274, 134, '2015-01-15 00:39:28.000000', 'consum', 0.0211, 'lps'),
	(656275, 134, '2015-01-15 00:39:29.000000', 'consum', 0.0299, 'lps'),
	(656276, 134, '2015-01-15 00:39:30.000000', 'consum', 0.0338, 'lps'),
	(656277, 134, '2015-01-15 00:39:31.000000', 'consum', 0.0268, 'lps'),
	(656278, 134, '2015-01-15 00:39:32.000000', 'consum', 0.0276, 'lps'),
	(656279, 134, '2015-01-15 00:39:33.000000', 'consum', 0.0363, 'lps'),
	(656280, 134, '2015-01-15 00:39:34.000000', 'consum', 0.0304, 'lps'),
	(656281, 134, '2015-01-15 00:39:35.000000', 'consum', 0.0224, 'lps'),
	(656282, 134, '2015-01-15 00:39:36.000000', 'consum', 0.0314, 'lps'),
	(656283, 134, '2015-01-15 00:39:37.000000', 'consum', 0.0213, 'lps'),
	(656284, 134, '2015-01-15 00:39:38.000000', 'consum', 0.0228, 'lps'),
	(656285, 134, '2015-01-15 00:39:39.000000', 'consum', 0.0295, 'lps'),
	(656286, 134, '2015-01-15 00:39:40.000000', 'consum', 0.0263, 'lps'),
	(656287, 134, '2015-01-15 00:39:41.000000', 'consum', 0.0221, 'lps'),
	(656288, 134, '2015-01-15 00:39:42.000000', 'consum', 0.0265, 'lps'),
	(656289, 134, '2015-01-15 00:39:43.000000', 'consum', 0.0293, 'lps'),
	(656290, 134, '2015-01-15 00:39:44.000000', 'consum', 0.0303, 'lps'),
	(656291, 134, '2015-01-15 00:39:45.000000', 'consum', 0.0271, 'lps'),
	(656292, 134, '2015-01-15 00:39:46.000000', 'consum', 0.0233, 'lps'),
	(656293, 134, '2015-01-15 00:39:47.000000', 'consum', 0.0303, 'lps'),
	(656294, 134, '2015-01-15 00:39:48.000000', 'consum', 0.0291, 'lps'),
	(656295, 134, '2015-01-15 00:39:49.000000', 'consum', 0.0338, 'lps'),
	(656296, 134, '2015-01-15 00:39:50.000000', 'consum', 0.0289, 'lps'),
	(656297, 134, '2015-01-15 00:39:51.000000', 'consum', 0.0221, 'lps'),
	(656298, 134, '2015-01-15 00:39:52.000000', 'consum', 0.0345, 'lps'),
	(656299, 134, '2015-01-15 00:39:53.000000', 'consum', 0.0220, 'lps'),
	(656300, 134, '2015-01-15 00:39:54.000000', 'consum', 0.0331, 'lps'),
	(656301, 134, '2015-01-15 00:39:55.000000', 'consum', 0.0311, 'lps'),
	(656302, 134, '2015-01-15 00:39:56.000000', 'consum', 0.0354, 'lps'),
	(656303, 134, '2015-01-15 00:39:57.000000', 'consum', 0.0312, 'lps'),
	(656304, 134, '2015-01-15 00:39:58.000000', 'consum', 0.0286, 'lps'),
	(656305, 134, '2015-01-15 00:39:59.000000', 'consum', 0.0284, 'lps'),
	(656306, 134, '2015-01-15 00:40:00.000000', 'consum', 0.0355, 'lps'),
	(656307, 134, '2015-01-15 00:40:01.000000', 'consum', 0.0240, 'lps'),
	(656308, 134, '2015-01-15 00:40:02.000000', 'consum', 0.0241, 'lps'),
	(656309, 134, '2015-01-15 00:40:03.000000', 'consum', 0.0275, 'lps'),
	(656310, 134, '2015-01-15 00:40:04.000000', 'consum', 0.0285, 'lps'),
	(656311, 134, '2015-01-15 00:40:05.000000', 'consum', 0.0233, 'lps'),
	(656312, 134, '2015-01-15 00:40:06.000000', 'consum', 0.0259, 'lps'),
	(656313, 134, '2015-01-15 00:40:07.000000', 'consum', 0.0228, 'lps'),
	(656314, 134, '2015-01-15 00:40:08.000000', 'consum', 0.0312, 'lps'),
	(656315, 134, '2015-01-15 00:40:09.000000', 'consum', 0.0352, 'lps'),
	(656316, 134, '2015-01-15 00:40:10.000000', 'consum', 0.0296, 'lps'),
	(656317, 134, '2015-01-15 00:40:11.000000', 'consum', 0.0214, 'lps'),
	(656318, 134, '2015-01-15 00:40:12.000000', 'consum', 0.0291, 'lps'),
	(656319, 134, '2015-01-15 00:40:13.000000', 'consum', 0.0286, 'lps'),
	(656320, 134, '2015-01-15 00:40:14.000000', 'consum', 0.0346, 'lps'),
	(656321, 134, '2015-01-15 00:40:15.000000', 'consum', 0.0347, 'lps'),
	(656322, 134, '2015-01-15 00:40:16.000000', 'consum', 0.0329, 'lps'),
	(656323, 134, '2015-01-15 00:40:17.000000', 'consum', 0.0236, 'lps'),
	(656324, 134, '2015-01-15 00:40:18.000000', 'consum', 0.0301, 'lps'),
	(656325, 134, '2015-01-15 00:40:19.000000', 'consum', 0.0271, 'lps'),
	(656326, 134, '2015-01-15 00:40:20.000000', 'consum', 0.0241, 'lps'),
	(656327, 134, '2015-01-15 00:40:21.000000', 'consum', 0.0342, 'lps'),
	(656328, 134, '2015-01-15 00:40:22.000000', 'consum', 0.0302, 'lps'),
	(656329, 134, '2015-01-15 00:40:23.000000', 'consum', 0.0276, 'lps'),
	(656330, 134, '2015-01-15 00:40:24.000000', 'consum', 0.0262, 'lps'),
	(656331, 134, '2015-01-15 00:40:25.000000', 'consum', 0.0274, 'lps'),
	(656332, 134, '2015-01-15 00:40:26.000000', 'consum', 0.0214, 'lps'),
	(656333, 134, '2015-01-15 00:40:27.000000', 'consum', 0.0358, 'lps'),
	(656334, 134, '2015-01-15 00:40:28.000000', 'consum', 0.0304, 'lps'),
	(656335, 134, '2015-01-15 00:40:29.000000', 'consum', 0.0236, 'lps'),
	(656336, 134, '2015-01-15 00:40:30.000000', 'consum', 0.0218, 'lps'),
	(656337, 134, '2015-01-15 00:40:31.000000', 'consum', 0.0332, 'lps'),
	(656338, 134, '2015-01-15 00:40:32.000000', 'consum', 0.0321, 'lps'),
	(656339, 134, '2015-01-15 00:40:33.000000', 'consum', 0.0240, 'lps'),
	(656340, 134, '2015-01-15 00:40:34.000000', 'consum', 0.0347, 'lps'),
	(656341, 134, '2015-01-15 00:40:35.000000', 'consum', 0.0328, 'lps'),
	(656342, 134, '2015-01-15 00:40:36.000000', 'consum', 0.0234, 'lps'),
	(656343, 134, '2015-01-15 00:40:37.000000', 'consum', 0.0291, 'lps'),
	(656344, 134, '2015-01-15 00:40:38.000000', 'consum', 0.0228, 'lps'),
	(656345, 134, '2015-01-15 00:40:39.000000', 'consum', 0.0217, 'lps'),
	(656346, 134, '2015-01-15 00:40:40.000000', 'consum', 0.0348, 'lps'),
	(656347, 134, '2015-01-15 00:40:41.000000', 'consum', 0.0249, 'lps'),
	(656348, 134, '2015-01-15 00:40:42.000000', 'consum', 0.0306, 'lps'),
	(656349, 134, '2015-01-15 00:40:43.000000', 'consum', 0.0257, 'lps'),
	(656350, 134, '2015-01-15 00:40:44.000000', 'consum', 0.0315, 'lps'),
	(656351, 134, '2015-01-15 00:40:45.000000', 'consum', 0.0278, 'lps'),
	(656352, 134, '2015-01-15 00:40:46.000000', 'consum', 0.0237, 'lps'),
	(656353, 134, '2015-01-15 00:40:47.000000', 'consum', 0.0301, 'lps'),
	(656354, 134, '2015-01-15 00:40:48.000000', 'consum', 0.0265, 'lps'),
	(656355, 134, '2015-01-15 00:40:49.000000', 'consum', 0.0216, 'lps'),
	(656356, 134, '2015-01-15 00:40:50.000000', 'consum', 0.0233, 'lps'),
	(656357, 134, '2015-01-15 00:40:51.000000', 'consum', 0.0305, 'lps'),
	(656358, 134, '2015-01-15 00:40:52.000000', 'consum', 0.0301, 'lps'),
	(656359, 134, '2015-01-15 00:40:53.000000', 'consum', 0.0222, 'lps'),
	(656360, 134, '2015-01-15 00:40:54.000000', 'consum', 0.0316, 'lps'),
	(656361, 134, '2015-01-15 00:40:55.000000', 'consum', 0.0230, 'lps'),
	(656362, 134, '2015-01-15 00:40:56.000000', 'consum', 0.0307, 'lps'),
	(656363, 134, '2015-01-15 00:40:57.000000', 'consum', 0.0320, 'lps'),
	(656364, 134, '2015-01-15 00:40:58.000000', 'consum', 0.0310, 'lps'),
	(656365, 134, '2015-01-15 00:40:59.000000', 'consum', 0.0222, 'lps'),
	(656366, 134, '2015-01-15 00:41:00.000000', 'consum', 0.0286, 'lps'),
	(656367, 134, '2015-01-15 00:41:01.000000', 'consum', 0.0242, 'lps'),
	(656368, 134, '2015-01-15 00:41:02.000000', 'consum', 0.0297, 'lps'),
	(656369, 134, '2015-01-15 00:41:03.000000', 'consum', 0.0236, 'lps'),
	(656370, 134, '2015-01-15 00:41:04.000000', 'consum', 0.0236, 'lps'),
	(656371, 134, '2015-01-15 00:41:05.000000', 'consum', 0.0263, 'lps'),
	(656372, 134, '2015-01-15 00:41:06.000000', 'consum', 0.0241, 'lps'),
	(656373, 134, '2015-01-15 00:41:07.000000', 'consum', 0.0363, 'lps'),
	(656374, 134, '2015-01-15 00:41:08.000000', 'consum', 0.0252, 'lps'),
	(656375, 134, '2015-01-15 00:41:09.000000', 'consum', 0.0276, 'lps'),
	(656376, 134, '2015-01-15 00:41:10.000000', 'consum', 0.0256, 'lps'),
	(656377, 134, '2015-01-15 00:41:11.000000', 'consum', 0.0243, 'lps'),
	(656378, 134, '2015-01-15 00:41:12.000000', 'consum', 0.0239, 'lps'),
	(656379, 134, '2015-01-15 00:41:13.000000', 'consum', 0.0257, 'lps'),
	(656380, 134, '2015-01-15 00:41:14.000000', 'consum', 0.0358, 'lps'),
	(656381, 134, '2015-01-15 00:41:15.000000', 'consum', 0.0334, 'lps'),
	(656382, 134, '2015-01-15 00:41:16.000000', 'consum', 0.0230, 'lps'),
	(656383, 134, '2015-01-15 00:41:17.000000', 'consum', 0.0254, 'lps'),
	(656384, 134, '2015-01-15 00:41:18.000000', 'consum', 0.0213, 'lps'),
	(656385, 134, '2015-01-15 00:41:19.000000', 'consum', 0.0251, 'lps'),
	(656386, 134, '2015-01-15 00:41:20.000000', 'consum', 0.0251, 'lps'),
	(656387, 134, '2015-01-15 00:41:21.000000', 'consum', 0.0289, 'lps'),
	(656388, 134, '2015-01-15 00:41:22.000000', 'consum', 0.0325, 'lps'),
	(656389, 134, '2015-01-15 00:41:23.000000', 'consum', 0.0231, 'lps'),
	(656390, 134, '2015-01-15 00:41:24.000000', 'consum', 0.0288, 'lps'),
	(656391, 134, '2015-01-15 00:41:25.000000', 'consum', 0.0222, 'lps'),
	(656392, 134, '2015-01-15 00:41:26.000000', 'consum', 0.0353, 'lps'),
	(656393, 134, '2015-01-15 00:41:27.000000', 'consum', 0.0255, 'lps'),
	(656394, 134, '2015-01-15 00:41:28.000000', 'consum', 0.0325, 'lps'),
	(656395, 134, '2015-01-15 00:41:29.000000', 'consum', 0.0334, 'lps'),
	(656396, 134, '2015-01-15 00:41:30.000000', 'consum', 0.0326, 'lps'),
	(656397, 134, '2015-01-15 00:41:31.000000', 'consum', 0.0261, 'lps'),
	(656398, 134, '2015-01-15 00:41:32.000000', 'consum', 0.0278, 'lps'),
	(656399, 134, '2015-01-15 00:41:33.000000', 'consum', 0.0236, 'lps'),
	(656400, 134, '2015-01-15 00:41:34.000000', 'consum', 0.0296, 'lps'),
	(656401, 134, '2015-01-15 00:41:35.000000', 'consum', 0.0246, 'lps'),
	(656402, 134, '2015-01-15 00:41:36.000000', 'consum', 0.0292, 'lps'),
	(656403, 134, '2015-01-15 00:41:37.000000', 'consum', 0.0353, 'lps'),
	(656404, 134, '2015-01-15 00:41:38.000000', 'consum', 0.0364, 'lps'),
	(656405, 134, '2015-01-15 00:41:39.000000', 'consum', 0.0234, 'lps'),
	(656406, 134, '2015-01-15 00:41:40.000000', 'consum', 0.0345, 'lps'),
	(656407, 134, '2015-01-15 00:41:41.000000', 'consum', 0.0340, 'lps'),
	(656408, 134, '2015-01-15 00:41:42.000000', 'consum', 0.0297, 'lps'),
	(656409, 134, '2015-01-15 00:41:43.000000', 'consum', 0.0254, 'lps'),
	(656410, 134, '2015-01-15 00:41:44.000000', 'consum', 0.0326, 'lps'),
	(656411, 134, '2015-01-15 00:41:45.000000', 'consum', 0.0346, 'lps'),
	(656412, 134, '2015-01-15 00:41:46.000000', 'consum', 0.0223, 'lps'),
	(656413, 134, '2015-01-15 00:41:47.000000', 'consum', 0.0343, 'lps'),
	(656414, 134, '2015-01-15 00:41:48.000000', 'consum', 0.0363, 'lps'),
	(656415, 134, '2015-01-15 00:41:49.000000', 'consum', 0.0262, 'lps'),
	(656416, 134, '2015-01-15 00:41:50.000000', 'consum', 0.0324, 'lps'),
	(656417, 134, '2015-01-15 00:41:51.000000', 'consum', 0.0311, 'lps'),
	(656418, 134, '2015-01-15 00:41:52.000000', 'consum', 0.0216, 'lps'),
	(656419, 134, '2015-01-15 00:41:53.000000', 'consum', 0.0251, 'lps'),
	(656420, 134, '2015-01-15 00:41:54.000000', 'consum', 0.0240, 'lps'),
	(656421, 134, '2015-01-15 00:41:55.000000', 'consum', 0.0240, 'lps'),
	(656422, 134, '2015-01-15 00:41:56.000000', 'consum', 0.0268, 'lps'),
	(656423, 134, '2015-01-15 00:41:57.000000', 'consum', 0.0255, 'lps'),
	(656424, 134, '2015-01-15 00:41:58.000000', 'consum', 0.0260, 'lps'),
	(656425, 134, '2015-01-15 00:41:59.000000', 'consum', 0.0324, 'lps'),
	(656426, 134, '2015-01-15 00:42:00.000000', 'consum', 0.0315, 'lps'),
	(656427, 134, '2015-01-15 00:42:01.000000', 'consum', 0.0238, 'lps'),
	(656428, 134, '2015-01-15 00:42:02.000000', 'consum', 0.0350, 'lps'),
	(656429, 134, '2015-01-15 00:42:03.000000', 'consum', 0.0353, 'lps'),
	(656430, 134, '2015-01-15 00:42:04.000000', 'consum', 0.0346, 'lps'),
	(656431, 134, '2015-01-15 00:42:05.000000', 'consum', 0.0305, 'lps'),
	(656432, 134, '2015-01-15 00:42:06.000000', 'consum', 0.0278, 'lps'),
	(656433, 134, '2015-01-15 00:42:07.000000', 'consum', 0.0264, 'lps'),
	(656434, 134, '2015-01-15 00:42:08.000000', 'consum', 0.0276, 'lps'),
	(656435, 134, '2015-01-15 00:42:09.000000', 'consum', 0.0222, 'lps'),
	(656436, 134, '2015-01-15 00:42:10.000000', 'consum', 0.0231, 'lps'),
	(656437, 134, '2015-01-15 00:42:11.000000', 'consum', 0.0280, 'lps'),
	(656438, 134, '2015-01-15 00:42:12.000000', 'consum', 0.0340, 'lps'),
	(656439, 134, '2015-01-15 00:42:13.000000', 'consum', 0.0333, 'lps'),
	(656440, 134, '2015-01-15 00:42:14.000000', 'consum', 0.0278, 'lps'),
	(656441, 134, '2015-01-15 00:42:15.000000', 'consum', 0.0340, 'lps'),
	(656442, 134, '2015-01-15 00:42:16.000000', 'consum', 0.0341, 'lps'),
	(656443, 134, '2015-01-15 00:42:17.000000', 'consum', 0.0317, 'lps'),
	(656444, 134, '2015-01-15 00:42:18.000000', 'consum', 0.0351, 'lps'),
	(656445, 134, '2015-01-15 00:42:19.000000', 'consum', 0.0282, 'lps'),
	(656446, 134, '2015-01-15 00:42:20.000000', 'consum', 0.0302, 'lps'),
	(656447, 134, '2015-01-15 00:42:21.000000', 'consum', 0.0297, 'lps'),
	(656448, 134, '2015-01-15 00:42:22.000000', 'consum', 0.0211, 'lps'),
	(656449, 134, '2015-01-15 00:42:23.000000', 'consum', 0.0271, 'lps'),
	(656450, 134, '2015-01-15 00:42:24.000000', 'consum', 0.0353, 'lps'),
	(656451, 134, '2015-01-15 00:42:25.000000', 'consum', 0.0270, 'lps'),
	(656452, 134, '2015-01-15 00:42:26.000000', 'consum', 0.0237, 'lps'),
	(656453, 134, '2015-01-15 00:42:27.000000', 'consum', 0.0327, 'lps'),
	(656454, 134, '2015-01-15 00:42:28.000000', 'consum', 0.0238, 'lps'),
	(656455, 134, '2015-01-15 00:42:29.000000', 'consum', 0.0314, 'lps'),
	(656456, 134, '2015-01-15 00:42:30.000000', 'consum', 0.0333, 'lps'),
	(656457, 134, '2015-01-15 00:42:31.000000', 'consum', 0.0356, 'lps'),
	(656458, 134, '2015-01-15 00:42:32.000000', 'consum', 0.0257, 'lps'),
	(656459, 134, '2015-01-15 00:42:33.000000', 'consum', 0.0320, 'lps'),
	(656460, 134, '2015-01-15 00:42:34.000000', 'consum', 0.0304, 'lps'),
	(656461, 134, '2015-01-15 00:42:35.000000', 'consum', 0.0350, 'lps'),
	(656462, 134, '2015-01-15 00:42:36.000000', 'consum', 0.0315, 'lps'),
	(656463, 134, '2015-01-15 00:42:37.000000', 'consum', 0.0316, 'lps'),
	(656464, 134, '2015-01-15 00:42:38.000000', 'consum', 0.0265, 'lps'),
	(656465, 134, '2015-01-15 00:42:39.000000', 'consum', 0.0325, 'lps'),
	(656466, 134, '2015-01-15 00:42:40.000000', 'consum', 0.0306, 'lps'),
	(656467, 134, '2015-01-15 00:42:41.000000', 'consum', 0.0346, 'lps'),
	(656468, 134, '2015-01-15 00:42:42.000000', 'consum', 0.0287, 'lps'),
	(656469, 134, '2015-01-15 00:42:43.000000', 'consum', 0.0347, 'lps'),
	(656470, 134, '2015-01-15 00:42:44.000000', 'consum', 0.0346, 'lps'),
	(656471, 134, '2015-01-15 00:42:45.000000', 'consum', 0.0322, 'lps'),
	(656472, 134, '2015-01-15 00:42:46.000000', 'consum', 0.0364, 'lps'),
	(656473, 134, '2015-01-15 00:42:47.000000', 'consum', 0.0329, 'lps'),
	(656474, 134, '2015-01-15 00:42:48.000000', 'consum', 0.0344, 'lps'),
	(656475, 134, '2015-01-15 00:42:49.000000', 'consum', 0.0366, 'lps'),
	(656476, 134, '2015-01-15 00:42:50.000000', 'consum', 0.0272, 'lps'),
	(656477, 134, '2015-01-15 00:42:51.000000', 'consum', 0.0212, 'lps'),
	(656478, 134, '2015-01-15 00:42:52.000000', 'consum', 0.0348, 'lps'),
	(656479, 134, '2015-01-15 00:42:53.000000', 'consum', 0.0265, 'lps'),
	(656480, 134, '2015-01-15 00:42:54.000000', 'consum', 0.0227, 'lps'),
	(656481, 134, '2015-01-15 00:42:55.000000', 'consum', 0.0291, 'lps'),
	(656482, 134, '2015-01-15 00:42:56.000000', 'consum', 0.0247, 'lps'),
	(656483, 134, '2015-01-15 00:42:57.000000', 'consum', 0.0310, 'lps'),
	(656484, 134, '2015-01-15 00:42:58.000000', 'consum', 0.0284, 'lps'),
	(656485, 134, '2015-01-15 00:42:59.000000', 'consum', 0.0279, 'lps'),
	(656486, 134, '2015-01-15 00:43:00.000000', 'consum', 0.0335, 'lps'),
	(656487, 134, '2015-01-15 00:43:01.000000', 'consum', 0.0311, 'lps'),
	(656488, 134, '2015-01-15 00:43:02.000000', 'consum', 0.0341, 'lps'),
	(656489, 134, '2015-01-15 00:43:03.000000', 'consum', 0.0247, 'lps'),
	(656490, 134, '2015-01-15 00:43:04.000000', 'consum', 0.0317, 'lps'),
	(656491, 134, '2015-01-15 00:43:05.000000', 'consum', 0.0318, 'lps'),
	(656492, 134, '2015-01-15 00:43:06.000000', 'consum', 0.0272, 'lps'),
	(656493, 134, '2015-01-15 00:43:07.000000', 'consum', 0.0355, 'lps'),
	(656494, 134, '2015-01-15 00:43:08.000000', 'consum', 0.0277, 'lps'),
	(656495, 134, '2015-01-15 00:43:09.000000', 'consum', 0.0268, 'lps'),
	(656496, 134, '2015-01-15 00:43:10.000000', 'consum', 0.0297, 'lps'),
	(656497, 134, '2015-01-15 00:43:11.000000', 'consum', 0.0315, 'lps'),
	(656498, 134, '2015-01-15 00:43:12.000000', 'consum', 0.0315, 'lps'),
	(656499, 134, '2015-01-15 00:43:13.000000', 'consum', 0.0265, 'lps'),
	(656500, 134, '2015-01-15 00:43:14.000000', 'consum', 0.0326, 'lps'),
	(656501, 134, '2015-01-15 00:43:15.000000', 'consum', 0.0311, 'lps'),
	(656502, 134, '2015-01-15 00:43:16.000000', 'consum', 0.0367, 'lps'),
	(656503, 134, '2015-01-15 00:43:17.000000', 'consum', 0.0217, 'lps'),
	(656504, 134, '2015-01-15 00:43:18.000000', 'consum', 0.0250, 'lps'),
	(656505, 134, '2015-01-15 00:43:19.000000', 'consum', 0.0233, 'lps'),
	(656506, 134, '2015-01-15 00:43:20.000000', 'consum', 0.0361, 'lps'),
	(656507, 134, '2015-01-15 00:43:21.000000', 'consum', 0.0267, 'lps'),
	(656508, 134, '2015-01-15 00:43:22.000000', 'consum', 0.0358, 'lps'),
	(656509, 134, '2015-01-15 00:43:23.000000', 'consum', 0.0305, 'lps'),
	(656510, 134, '2015-01-15 00:43:24.000000', 'consum', 0.0243, 'lps'),
	(656511, 134, '2015-01-15 00:43:25.000000', 'consum', 0.0247, 'lps'),
	(656512, 134, '2015-01-15 00:43:26.000000', 'consum', 0.0298, 'lps'),
	(656513, 134, '2015-01-15 00:43:27.000000', 'consum', 0.0225, 'lps'),
	(656514, 134, '2015-01-15 00:43:28.000000', 'consum', 0.0334, 'lps'),
	(656515, 134, '2015-01-15 00:43:29.000000', 'consum', 0.0315, 'lps'),
	(656516, 134, '2015-01-15 00:43:30.000000', 'consum', 0.0361, 'lps'),
	(656517, 134, '2015-01-15 00:43:31.000000', 'consum', 0.0334, 'lps'),
	(656518, 134, '2015-01-15 00:43:32.000000', 'consum', 0.0219, 'lps'),
	(656519, 134, '2015-01-15 00:43:33.000000', 'consum', 0.0358, 'lps'),
	(656520, 134, '2015-01-15 00:43:34.000000', 'consum', 0.0293, 'lps'),
	(656521, 134, '2015-01-15 00:43:35.000000', 'consum', 0.0338, 'lps'),
	(656522, 134, '2015-01-15 00:43:36.000000', 'consum', 0.0284, 'lps'),
	(656523, 134, '2015-01-15 00:43:37.000000', 'consum', 0.0358, 'lps'),
	(656524, 134, '2015-01-15 00:43:38.000000', 'consum', 0.0251, 'lps'),
	(656525, 134, '2015-01-15 00:43:39.000000', 'consum', 0.0290, 'lps'),
	(656526, 134, '2015-01-15 00:43:40.000000', 'consum', 0.0327, 'lps'),
	(656527, 134, '2015-01-15 00:43:41.000000', 'consum', 0.0242, 'lps'),
	(656528, 134, '2015-01-15 00:43:42.000000', 'consum', 0.0336, 'lps'),
	(656529, 134, '2015-01-15 00:43:43.000000', 'consum', 0.0270, 'lps'),
	(656530, 134, '2015-01-15 00:43:44.000000', 'consum', 0.0289, 'lps'),
	(656531, 134, '2015-01-15 00:43:45.000000', 'consum', 0.0269, 'lps'),
	(656532, 134, '2015-01-15 00:43:46.000000', 'consum', 0.0269, 'lps'),
	(656533, 134, '2015-01-15 00:43:47.000000', 'consum', 0.0329, 'lps'),
	(656534, 134, '2015-01-15 00:43:48.000000', 'consum', 0.0312, 'lps'),
	(656535, 134, '2015-01-15 00:43:49.000000', 'consum', 0.0362, 'lps'),
	(656536, 134, '2015-01-15 00:43:50.000000', 'consum', 0.0351, 'lps'),
	(656537, 134, '2015-01-15 00:43:51.000000', 'consum', 0.0301, 'lps'),
	(656538, 134, '2015-01-15 00:43:52.000000', 'consum', 0.0244, 'lps'),
	(656539, 134, '2015-01-15 00:43:53.000000', 'consum', 0.0265, 'lps'),
	(656540, 134, '2015-01-15 00:43:54.000000', 'consum', 0.0225, 'lps'),
	(656541, 134, '2015-01-15 00:43:55.000000', 'consum', 0.0279, 'lps'),
	(656542, 134, '2015-01-15 00:43:56.000000', 'consum', 0.0353, 'lps'),
	(656543, 134, '2015-01-15 00:43:57.000000', 'consum', 0.0245, 'lps'),
	(656544, 134, '2015-01-15 00:43:58.000000', 'consum', 0.0274, 'lps'),
	(656545, 134, '2015-01-15 00:43:59.000000', 'consum', 0.0264, 'lps'),
	(656546, 134, '2015-01-15 00:44:00.000000', 'consum', 0.0290, 'lps'),
	(656547, 134, '2015-01-15 00:44:01.000000', 'consum', 0.0291, 'lps'),
	(656548, 134, '2015-01-15 00:44:02.000000', 'consum', 0.0216, 'lps'),
	(656549, 134, '2015-01-15 00:44:03.000000', 'consum', 0.0312, 'lps'),
	(656550, 134, '2015-01-15 00:44:04.000000', 'consum', 0.0231, 'lps'),
	(656551, 134, '2015-01-15 00:44:05.000000', 'consum', 0.0326, 'lps'),
	(656552, 134, '2015-01-15 00:44:06.000000', 'consum', 0.0254, 'lps'),
	(656553, 134, '2015-01-15 00:44:07.000000', 'consum', 0.0241, 'lps'),
	(656554, 134, '2015-01-15 00:44:08.000000', 'consum', 0.0231, 'lps'),
	(656555, 134, '2015-01-15 00:44:09.000000', 'consum', 0.0224, 'lps'),
	(656556, 134, '2015-01-15 00:44:10.000000', 'consum', 0.0218, 'lps'),
	(656557, 134, '2015-01-15 00:44:11.000000', 'consum', 0.0210, 'lps'),
	(656558, 134, '2015-01-15 00:44:12.000000', 'consum', 0.0341, 'lps'),
	(656559, 134, '2015-01-15 00:44:13.000000', 'consum', 0.0235, 'lps'),
	(656560, 134, '2015-01-15 00:44:14.000000', 'consum', 0.0258, 'lps'),
	(656561, 134, '2015-01-15 00:44:15.000000', 'consum', 0.0220, 'lps'),
	(656562, 134, '2015-01-15 00:44:16.000000', 'consum', 0.0272, 'lps'),
	(656563, 134, '2015-01-15 00:44:17.000000', 'consum', 0.0333, 'lps'),
	(656564, 134, '2015-01-15 00:44:18.000000', 'consum', 0.0324, 'lps'),
	(656565, 134, '2015-01-15 00:44:19.000000', 'consum', 0.0252, 'lps'),
	(656566, 134, '2015-01-15 00:44:20.000000', 'consum', 0.0236, 'lps'),
	(656567, 134, '2015-01-15 00:44:21.000000', 'consum', 0.0213, 'lps'),
	(656568, 134, '2015-01-15 00:44:22.000000', 'consum', 0.0309, 'lps'),
	(656569, 134, '2015-01-15 00:44:23.000000', 'consum', 0.0222, 'lps'),
	(656570, 134, '2015-01-15 00:44:24.000000', 'consum', 0.0288, 'lps'),
	(656571, 134, '2015-01-15 00:44:25.000000', 'consum', 0.0251, 'lps'),
	(656572, 134, '2015-01-15 00:44:26.000000', 'consum', 0.0338, 'lps'),
	(656573, 134, '2015-01-15 00:44:27.000000', 'consum', 0.0256, 'lps'),
	(656574, 134, '2015-01-15 00:44:28.000000', 'consum', 0.0211, 'lps'),
	(656575, 134, '2015-01-15 00:44:29.000000', 'consum', 0.0238, 'lps'),
	(656576, 134, '2015-01-15 00:44:30.000000', 'consum', 0.0346, 'lps'),
	(656577, 134, '2015-01-15 00:44:31.000000', 'consum', 0.0335, 'lps'),
	(656578, 134, '2015-01-15 00:44:32.000000', 'consum', 0.0267, 'lps'),
	(656579, 134, '2015-01-15 00:44:33.000000', 'consum', 0.0281, 'lps'),
	(656580, 134, '2015-01-15 00:44:34.000000', 'consum', 0.0236, 'lps'),
	(656581, 134, '2015-01-15 00:44:35.000000', 'consum', 0.0287, 'lps'),
	(656582, 134, '2015-01-15 00:44:36.000000', 'consum', 0.0357, 'lps'),
	(656583, 134, '2015-01-15 00:44:37.000000', 'consum', 0.0241, 'lps'),
	(656584, 134, '2015-01-15 00:44:38.000000', 'consum', 0.0240, 'lps'),
	(656585, 134, '2015-01-15 00:44:39.000000', 'consum', 0.0269, 'lps'),
	(656586, 134, '2015-01-15 00:44:40.000000', 'consum', 0.0258, 'lps'),
	(656587, 134, '2015-01-15 00:44:41.000000', 'consum', 0.0274, 'lps'),
	(656588, 134, '2015-01-15 00:44:42.000000', 'consum', 0.0229, 'lps'),
	(656589, 134, '2015-01-15 00:44:43.000000', 'consum', 0.0268, 'lps'),
	(656590, 134, '2015-01-15 00:44:44.000000', 'consum', 0.0289, 'lps'),
	(656591, 134, '2015-01-15 00:44:45.000000', 'consum', 0.0272, 'lps'),
	(656592, 134, '2015-01-15 00:44:46.000000', 'consum', 0.0285, 'lps'),
	(656593, 134, '2015-01-15 00:44:47.000000', 'consum', 0.0240, 'lps'),
	(656594, 134, '2015-01-15 00:44:48.000000', 'consum', 0.0293, 'lps'),
	(656595, 134, '2015-01-15 00:44:49.000000', 'consum', 0.0220, 'lps'),
	(656596, 134, '2015-01-15 00:44:50.000000', 'consum', 0.0328, 'lps'),
	(656597, 134, '2015-01-15 00:44:51.000000', 'consum', 0.0298, 'lps'),
	(656598, 134, '2015-01-15 00:44:52.000000', 'consum', 0.0295, 'lps'),
	(656599, 134, '2015-01-15 00:44:53.000000', 'consum', 0.0212, 'lps'),
	(656600, 134, '2015-01-15 00:44:54.000000', 'consum', 0.0281, 'lps'),
	(656601, 134, '2015-01-15 00:44:55.000000', 'consum', 0.0243, 'lps'),
	(656602, 134, '2015-01-15 00:44:56.000000', 'consum', 0.0323, 'lps'),
	(656603, 134, '2015-01-15 00:44:57.000000', 'consum', 0.0358, 'lps'),
	(656604, 134, '2015-01-15 00:44:58.000000', 'consum', 0.0296, 'lps'),
	(656605, 134, '2015-01-15 00:44:59.000000', 'consum', 0.0356, 'lps'),
	(656606, 134, '2015-01-15 00:45:00.000000', 'consum', 0.0210, 'lps'),
	(656607, 134, '2015-01-15 00:45:01.000000', 'consum', 0.0243, 'lps'),
	(656608, 134, '2015-01-15 00:45:02.000000', 'consum', 0.0221, 'lps'),
	(656609, 134, '2015-01-15 00:45:03.000000', 'consum', 0.0322, 'lps'),
	(656610, 134, '2015-01-15 00:45:04.000000', 'consum', 0.0264, 'lps'),
	(656611, 134, '2015-01-15 00:45:05.000000', 'consum', 0.0301, 'lps'),
	(656612, 134, '2015-01-15 00:45:06.000000', 'consum', 0.0347, 'lps'),
	(656613, 134, '2015-01-15 00:45:07.000000', 'consum', 0.0308, 'lps'),
	(656614, 134, '2015-01-15 00:45:08.000000', 'consum', 0.0286, 'lps'),
	(656615, 134, '2015-01-15 00:45:09.000000', 'consum', 0.0299, 'lps'),
	(656616, 134, '2015-01-15 00:45:10.000000', 'consum', 0.0269, 'lps'),
	(656617, 134, '2015-01-15 00:45:11.000000', 'consum', 0.0239, 'lps'),
	(656618, 134, '2015-01-15 00:45:12.000000', 'consum', 0.0335, 'lps'),
	(656619, 134, '2015-01-15 00:45:13.000000', 'consum', 0.0276, 'lps'),
	(656620, 134, '2015-01-15 00:45:14.000000', 'consum', 0.0322, 'lps'),
	(656621, 134, '2015-01-15 00:45:15.000000', 'consum', 0.0256, 'lps'),
	(656622, 134, '2015-01-15 00:45:16.000000', 'consum', 0.0262, 'lps'),
	(656623, 134, '2015-01-15 00:45:17.000000', 'consum', 0.0331, 'lps'),
	(656624, 134, '2015-01-15 00:45:18.000000', 'consum', 0.0347, 'lps'),
	(656625, 134, '2015-01-15 00:45:19.000000', 'consum', 0.0215, 'lps'),
	(656626, 134, '2015-01-15 00:45:20.000000', 'consum', 0.0300, 'lps'),
	(656627, 134, '2015-01-15 00:45:21.000000', 'consum', 0.0329, 'lps'),
	(656628, 134, '2015-01-15 00:45:22.000000', 'consum', 0.0218, 'lps'),
	(656629, 134, '2015-01-15 00:45:23.000000', 'consum', 0.0211, 'lps'),
	(656630, 134, '2015-01-15 00:45:24.000000', 'consum', 0.0350, 'lps'),
	(656631, 134, '2015-01-15 00:45:25.000000', 'consum', 0.0276, 'lps'),
	(656632, 134, '2015-01-15 00:45:26.000000', 'consum', 0.0280, 'lps'),
	(656633, 134, '2015-01-15 00:45:27.000000', 'consum', 0.0359, 'lps'),
	(656634, 134, '2015-01-15 00:45:28.000000', 'consum', 0.0272, 'lps'),
	(656635, 134, '2015-01-15 00:45:29.000000', 'consum', 0.0232, 'lps'),
	(656636, 134, '2015-01-15 00:45:30.000000', 'consum', 0.0291, 'lps'),
	(656637, 134, '2015-01-15 00:45:31.000000', 'consum', 0.0234, 'lps'),
	(656638, 134, '2015-01-15 00:45:32.000000', 'consum', 0.0247, 'lps'),
	(656639, 134, '2015-01-15 00:45:33.000000', 'consum', 0.0322, 'lps'),
	(656640, 134, '2015-01-15 00:45:34.000000', 'consum', 0.0345, 'lps'),
	(656641, 134, '2015-01-15 00:45:35.000000', 'consum', 0.0232, 'lps'),
	(656642, 134, '2015-01-15 00:45:36.000000', 'consum', 0.0231, 'lps'),
	(656643, 134, '2015-01-15 00:45:37.000000', 'consum', 0.0250, 'lps'),
	(656644, 134, '2015-01-15 00:45:38.000000', 'consum', 0.0349, 'lps'),
	(656645, 134, '2015-01-15 00:45:39.000000', 'consum', 0.0310, 'lps'),
	(656646, 134, '2015-01-15 00:45:40.000000', 'consum', 0.0294, 'lps'),
	(656647, 134, '2015-01-15 00:45:41.000000', 'consum', 0.0332, 'lps'),
	(656648, 134, '2015-01-15 00:45:42.000000', 'consum', 0.0251, 'lps'),
	(656649, 134, '2015-01-15 00:45:43.000000', 'consum', 0.0364, 'lps'),
	(656650, 134, '2015-01-15 00:45:44.000000', 'consum', 0.0228, 'lps'),
	(656651, 134, '2015-01-15 00:45:45.000000', 'consum', 0.0313, 'lps'),
	(656652, 134, '2015-01-15 00:45:46.000000', 'consum', 0.0355, 'lps'),
	(656653, 134, '2015-01-15 00:45:47.000000', 'consum', 0.0312, 'lps'),
	(656654, 134, '2015-01-15 00:45:48.000000', 'consum', 0.0283, 'lps'),
	(656655, 134, '2015-01-15 00:45:49.000000', 'consum', 0.0270, 'lps'),
	(656656, 134, '2015-01-15 00:45:50.000000', 'consum', 0.0291, 'lps'),
	(656657, 134, '2015-01-15 00:45:51.000000', 'consum', 0.0280, 'lps'),
	(656658, 134, '2015-01-15 00:45:52.000000', 'consum', 0.0314, 'lps'),
	(656659, 134, '2015-01-15 00:45:53.000000', 'consum', 0.0366, 'lps'),
	(656660, 134, '2015-01-15 00:45:54.000000', 'consum', 0.0360, 'lps'),
	(656661, 134, '2015-01-15 00:45:55.000000', 'consum', 0.0336, 'lps'),
	(656662, 134, '2015-01-15 00:45:56.000000', 'consum', 0.0232, 'lps'),
	(656663, 134, '2015-01-15 00:45:57.000000', 'consum', 0.0258, 'lps'),
	(656664, 134, '2015-01-15 00:45:58.000000', 'consum', 0.0228, 'lps'),
	(656665, 134, '2015-01-15 00:45:59.000000', 'consum', 0.0315, 'lps'),
	(656666, 134, '2015-01-15 00:46:00.000000', 'consum', 0.0365, 'lps'),
	(656667, 134, '2015-01-15 00:46:01.000000', 'consum', 0.0355, 'lps'),
	(656668, 134, '2015-01-15 00:46:02.000000', 'consum', 0.0311, 'lps'),
	(656669, 134, '2015-01-15 00:46:03.000000', 'consum', 0.0283, 'lps'),
	(656670, 134, '2015-01-15 00:46:04.000000', 'consum', 0.0271, 'lps'),
	(656671, 134, '2015-01-15 00:46:05.000000', 'consum', 0.0298, 'lps'),
	(656672, 134, '2015-01-15 00:46:06.000000', 'consum', 0.0307, 'lps'),
	(656673, 134, '2015-01-15 00:46:07.000000', 'consum', 0.0276, 'lps'),
	(656674, 134, '2015-01-15 00:46:08.000000', 'consum', 0.0249, 'lps'),
	(656675, 134, '2015-01-15 00:46:09.000000', 'consum', 0.0366, 'lps'),
	(656676, 134, '2015-01-15 00:46:10.000000', 'consum', 0.0241, 'lps'),
	(656677, 134, '2015-01-15 00:46:11.000000', 'consum', 0.0212, 'lps'),
	(656678, 134, '2015-01-15 00:46:12.000000', 'consum', 0.0287, 'lps'),
	(656679, 134, '2015-01-15 00:46:13.000000', 'consum', 0.0274, 'lps'),
	(656680, 134, '2015-01-15 00:46:14.000000', 'consum', 0.0300, 'lps'),
	(656681, 134, '2015-01-15 00:46:15.000000', 'consum', 0.0312, 'lps'),
	(656682, 134, '2015-01-15 00:46:16.000000', 'consum', 0.0290, 'lps'),
	(656683, 134, '2015-01-15 00:46:17.000000', 'consum', 0.0305, 'lps'),
	(656684, 134, '2015-01-15 00:46:18.000000', 'consum', 0.0290, 'lps'),
	(656685, 134, '2015-01-15 00:46:19.000000', 'consum', 0.0323, 'lps'),
	(656686, 134, '2015-01-15 00:46:20.000000', 'consum', 0.0219, 'lps'),
	(656687, 134, '2015-01-15 00:46:21.000000', 'consum', 0.0233, 'lps'),
	(656688, 134, '2015-01-15 00:46:22.000000', 'consum', 0.0300, 'lps'),
	(656689, 134, '2015-01-15 00:46:23.000000', 'consum', 0.0273, 'lps'),
	(656690, 134, '2015-01-15 00:46:24.000000', 'consum', 0.0256, 'lps'),
	(656691, 134, '2015-01-15 00:46:25.000000', 'consum', 0.0254, 'lps'),
	(656692, 134, '2015-01-15 00:46:26.000000', 'consum', 0.0291, 'lps'),
	(656693, 134, '2015-01-15 00:46:27.000000', 'consum', 0.0325, 'lps'),
	(656694, 134, '2015-01-15 00:46:28.000000', 'consum', 0.0228, 'lps'),
	(656695, 134, '2015-01-15 00:46:29.000000', 'consum', 0.0271, 'lps'),
	(656696, 134, '2015-01-15 00:46:30.000000', 'consum', 0.0302, 'lps'),
	(656697, 134, '2015-01-15 00:46:31.000000', 'consum', 0.0332, 'lps'),
	(656698, 134, '2015-01-15 00:46:32.000000', 'consum', 0.0229, 'lps'),
	(656699, 134, '2015-01-15 00:46:33.000000', 'consum', 0.0255, 'lps'),
	(656700, 134, '2015-01-15 00:46:34.000000', 'consum', 0.0218, 'lps'),
	(656701, 134, '2015-01-15 00:46:35.000000', 'consum', 0.0276, 'lps'),
	(656702, 134, '2015-01-15 00:46:36.000000', 'consum', 0.0359, 'lps'),
	(656703, 134, '2015-01-15 00:46:37.000000', 'consum', 0.0282, 'lps'),
	(656704, 134, '2015-01-15 00:46:38.000000', 'consum', 0.0280, 'lps'),
	(656705, 134, '2015-01-15 00:46:39.000000', 'consum', 0.0346, 'lps'),
	(656706, 134, '2015-01-15 00:46:40.000000', 'consum', 0.0366, 'lps'),
	(656707, 134, '2015-01-15 00:46:41.000000', 'consum', 0.0267, 'lps'),
	(656708, 134, '2015-01-15 00:46:42.000000', 'consum', 0.0342, 'lps'),
	(656709, 134, '2015-01-15 00:46:43.000000', 'consum', 0.0225, 'lps'),
	(656710, 134, '2015-01-15 00:46:44.000000', 'consum', 0.0364, 'lps'),
	(656711, 134, '2015-01-15 00:46:45.000000', 'consum', 0.0304, 'lps'),
	(656712, 134, '2015-01-15 00:46:46.000000', 'consum', 0.0220, 'lps'),
	(656713, 134, '2015-01-15 00:46:47.000000', 'consum', 0.0293, 'lps'),
	(656714, 134, '2015-01-15 00:46:48.000000', 'consum', 0.0278, 'lps'),
	(656715, 134, '2015-01-15 00:46:49.000000', 'consum', 0.0301, 'lps'),
	(656716, 134, '2015-01-15 00:46:50.000000', 'consum', 0.0304, 'lps'),
	(656717, 134, '2015-01-15 00:46:51.000000', 'consum', 0.0251, 'lps'),
	(656718, 134, '2015-01-15 00:46:52.000000', 'consum', 0.0289, 'lps'),
	(656719, 134, '2015-01-15 00:46:53.000000', 'consum', 0.0325, 'lps'),
	(656720, 134, '2015-01-15 00:46:54.000000', 'consum', 0.0233, 'lps'),
	(656721, 134, '2015-01-15 00:46:55.000000', 'consum', 0.0296, 'lps'),
	(656722, 134, '2015-01-15 00:46:56.000000', 'consum', 0.0255, 'lps'),
	(656723, 134, '2015-01-15 00:46:57.000000', 'consum', 0.0337, 'lps'),
	(656724, 134, '2015-01-15 00:46:58.000000', 'consum', 0.0237, 'lps'),
	(656725, 134, '2015-01-15 00:46:59.000000', 'consum', 0.0280, 'lps'),
	(656726, 134, '2015-01-15 00:47:00.000000', 'consum', 0.0323, 'lps'),
	(656727, 134, '2015-01-15 00:47:01.000000', 'consum', 0.0247, 'lps'),
	(656728, 134, '2015-01-15 00:47:02.000000', 'consum', 0.0215, 'lps'),
	(656729, 134, '2015-01-15 00:47:03.000000', 'consum', 0.0281, 'lps'),
	(656730, 134, '2015-01-15 00:47:04.000000', 'consum', 0.0238, 'lps'),
	(656731, 134, '2015-01-15 00:47:05.000000', 'consum', 0.0292, 'lps'),
	(656732, 134, '2015-01-15 00:47:06.000000', 'consum', 0.0223, 'lps'),
	(656733, 134, '2015-01-15 00:47:07.000000', 'consum', 0.0346, 'lps'),
	(656734, 134, '2015-01-15 00:47:08.000000', 'consum', 0.0218, 'lps'),
	(656735, 134, '2015-01-15 00:47:09.000000', 'consum', 0.0317, 'lps'),
	(656736, 134, '2015-01-15 00:47:10.000000', 'consum', 0.0249, 'lps'),
	(656737, 134, '2015-01-15 00:47:11.000000', 'consum', 0.0242, 'lps'),
	(656738, 134, '2015-01-15 00:47:12.000000', 'consum', 0.0253, 'lps'),
	(656739, 134, '2015-01-15 00:47:13.000000', 'consum', 0.0328, 'lps'),
	(656740, 134, '2015-01-15 00:47:14.000000', 'consum', 0.0359, 'lps'),
	(656741, 134, '2015-01-15 00:47:15.000000', 'consum', 0.0282, 'lps'),
	(656742, 134, '2015-01-15 00:47:16.000000', 'consum', 0.0282, 'lps'),
	(656743, 134, '2015-01-15 00:47:17.000000', 'consum', 0.0355, 'lps'),
	(656744, 134, '2015-01-15 00:47:18.000000', 'consum', 0.0244, 'lps'),
	(656745, 134, '2015-01-15 00:47:19.000000', 'consum', 0.0262, 'lps'),
	(656746, 134, '2015-01-15 00:47:20.000000', 'consum', 0.0213, 'lps'),
	(656747, 134, '2015-01-15 00:47:21.000000', 'consum', 0.0225, 'lps'),
	(656748, 134, '2015-01-15 00:47:22.000000', 'consum', 0.0279, 'lps'),
	(656749, 134, '2015-01-15 00:47:23.000000', 'consum', 0.0352, 'lps'),
	(656750, 134, '2015-01-15 00:47:24.000000', 'consum', 0.0240, 'lps'),
	(656751, 134, '2015-01-15 00:47:25.000000', 'consum', 0.0252, 'lps'),
	(656752, 134, '2015-01-15 00:47:26.000000', 'consum', 0.0329, 'lps'),
	(656753, 134, '2015-01-15 00:47:27.000000', 'consum', 0.0361, 'lps'),
	(656754, 134, '2015-01-15 00:47:28.000000', 'consum', 0.0296, 'lps'),
	(656755, 134, '2015-01-15 00:47:29.000000', 'consum', 0.0344, 'lps'),
	(656756, 134, '2015-01-15 00:47:30.000000', 'consum', 0.0306, 'lps'),
	(656757, 134, '2015-01-15 00:47:31.000000', 'consum', 0.0289, 'lps'),
	(656758, 134, '2015-01-15 00:47:32.000000', 'consum', 0.0317, 'lps'),
	(656759, 134, '2015-01-15 00:47:33.000000', 'consum', 0.0352, 'lps'),
	(656760, 134, '2015-01-15 00:47:34.000000', 'consum', 0.0283, 'lps'),
	(656761, 134, '2015-01-15 00:47:35.000000', 'consum', 0.0307, 'lps'),
	(656762, 134, '2015-01-15 00:47:36.000000', 'consum', 0.0320, 'lps'),
	(656763, 134, '2015-01-15 00:47:37.000000', 'consum', 0.0311, 'lps'),
	(656764, 134, '2015-01-15 00:47:38.000000', 'consum', 0.0228, 'lps'),
	(656765, 134, '2015-01-15 00:47:39.000000', 'consum', 0.0311, 'lps'),
	(656766, 134, '2015-01-15 00:47:40.000000', 'consum', 0.0348, 'lps'),
	(656767, 134, '2015-01-15 00:47:41.000000', 'consum', 0.0280, 'lps'),
	(656768, 134, '2015-01-15 00:47:42.000000', 'consum', 0.0307, 'lps'),
	(656769, 134, '2015-01-15 00:47:43.000000', 'consum', 0.0325, 'lps'),
	(656770, 134, '2015-01-15 00:47:44.000000', 'consum', 0.0336, 'lps'),
	(656771, 134, '2015-01-15 00:47:45.000000', 'consum', 0.0339, 'lps'),
	(656772, 134, '2015-01-15 00:47:46.000000', 'consum', 0.0317, 'lps'),
	(656773, 134, '2015-01-15 00:47:47.000000', 'consum', 0.0360, 'lps'),
	(656774, 134, '2015-01-15 00:47:48.000000', 'consum', 0.0324, 'lps'),
	(656775, 134, '2015-01-15 00:47:49.000000', 'consum', 0.0329, 'lps'),
	(656776, 134, '2015-01-15 00:47:50.000000', 'consum', 0.0304, 'lps'),
	(656777, 134, '2015-01-15 00:47:51.000000', 'consum', 0.0327, 'lps'),
	(656778, 134, '2015-01-15 00:47:52.000000', 'consum', 0.0353, 'lps'),
	(656779, 134, '2015-01-15 00:47:53.000000', 'consum', 0.0261, 'lps'),
	(656780, 134, '2015-01-15 00:47:54.000000', 'consum', 0.0352, 'lps'),
	(656781, 134, '2015-01-15 00:47:55.000000', 'consum', 0.0292, 'lps'),
	(656782, 134, '2015-01-15 00:47:56.000000', 'consum', 0.0353, 'lps'),
	(656783, 134, '2015-01-15 00:47:57.000000', 'consum', 0.0363, 'lps'),
	(656784, 134, '2015-01-15 00:47:58.000000', 'consum', 0.0233, 'lps'),
	(656785, 134, '2015-01-15 00:47:59.000000', 'consum', 0.0338, 'lps'),
	(656786, 134, '2015-01-15 00:48:00.000000', 'consum', 0.0309, 'lps'),
	(656787, 134, '2015-01-15 00:48:01.000000', 'consum', 0.0323, 'lps'),
	(656788, 134, '2015-01-15 00:48:02.000000', 'consum', 0.0318, 'lps'),
	(656789, 134, '2015-01-15 00:48:03.000000', 'consum', 0.0253, 'lps'),
	(656790, 134, '2015-01-15 00:48:04.000000', 'consum', 0.0259, 'lps'),
	(656791, 134, '2015-01-15 00:48:05.000000', 'consum', 0.0326, 'lps'),
	(656792, 134, '2015-01-15 00:48:06.000000', 'consum', 0.0329, 'lps'),
	(656793, 134, '2015-01-15 00:48:07.000000', 'consum', 0.0300, 'lps'),
	(656794, 134, '2015-01-15 00:48:08.000000', 'consum', 0.0302, 'lps'),
	(656795, 134, '2015-01-15 00:48:09.000000', 'consum', 0.0243, 'lps'),
	(656796, 134, '2015-01-15 00:48:10.000000', 'consum', 0.0259, 'lps'),
	(656797, 134, '2015-01-15 00:48:11.000000', 'consum', 0.0354, 'lps'),
	(656798, 134, '2015-01-15 00:48:12.000000', 'consum', 0.0310, 'lps'),
	(656799, 134, '2015-01-15 00:48:13.000000', 'consum', 0.0279, 'lps'),
	(656800, 134, '2015-01-15 00:48:14.000000', 'consum', 0.0257, 'lps'),
	(656801, 134, '2015-01-15 00:48:15.000000', 'consum', 0.0237, 'lps'),
	(656802, 134, '2015-01-15 00:48:16.000000', 'consum', 0.0363, 'lps'),
	(656803, 134, '2015-01-15 00:48:17.000000', 'consum', 0.0261, 'lps'),
	(656804, 134, '2015-01-15 00:48:18.000000', 'consum', 0.0325, 'lps'),
	(656805, 134, '2015-01-15 00:48:19.000000', 'consum', 0.0316, 'lps'),
	(656806, 134, '2015-01-15 00:48:20.000000', 'consum', 0.0236, 'lps'),
	(656807, 134, '2015-01-15 00:48:21.000000', 'consum', 0.0341, 'lps'),
	(656808, 134, '2015-01-15 00:48:22.000000', 'consum', 0.0313, 'lps'),
	(656809, 134, '2015-01-15 00:48:23.000000', 'consum', 0.0330, 'lps'),
	(656810, 134, '2015-01-15 00:48:24.000000', 'consum', 0.0345, 'lps'),
	(656811, 134, '2015-01-15 00:48:25.000000', 'consum', 0.0211, 'lps'),
	(656812, 134, '2015-01-15 00:48:26.000000', 'consum', 0.0284, 'lps'),
	(656813, 134, '2015-01-15 00:48:27.000000', 'consum', 0.0262, 'lps'),
	(656814, 134, '2015-01-15 00:48:28.000000', 'consum', 0.0247, 'lps'),
	(656815, 134, '2015-01-15 00:48:29.000000', 'consum', 0.0242, 'lps'),
	(656816, 134, '2015-01-15 00:48:30.000000', 'consum', 0.0257, 'lps'),
	(656817, 134, '2015-01-15 00:48:31.000000', 'consum', 0.0349, 'lps'),
	(656818, 134, '2015-01-15 00:48:32.000000', 'consum', 0.0291, 'lps'),
	(656819, 134, '2015-01-15 00:48:33.000000', 'consum', 0.0356, 'lps'),
	(656820, 134, '2015-01-15 00:48:34.000000', 'consum', 0.0226, 'lps'),
	(656821, 134, '2015-01-15 00:48:35.000000', 'consum', 0.0325, 'lps'),
	(656822, 134, '2015-01-15 00:48:36.000000', 'consum', 0.0265, 'lps'),
	(656823, 134, '2015-01-15 00:48:37.000000', 'consum', 0.0299, 'lps'),
	(656824, 134, '2015-01-15 00:48:38.000000', 'consum', 0.0333, 'lps'),
	(656825, 134, '2015-01-15 00:48:39.000000', 'consum', 0.0243, 'lps'),
	(656826, 134, '2015-01-15 00:48:40.000000', 'consum', 0.0320, 'lps'),
	(656827, 134, '2015-01-15 00:48:41.000000', 'consum', 0.0349, 'lps'),
	(656828, 134, '2015-01-15 00:48:42.000000', 'consum', 0.0256, 'lps'),
	(656829, 134, '2015-01-15 00:48:43.000000', 'consum', 0.0340, 'lps'),
	(656830, 134, '2015-01-15 00:48:44.000000', 'consum', 0.0248, 'lps'),
	(656831, 134, '2015-01-15 00:48:45.000000', 'consum', 0.0328, 'lps'),
	(656832, 134, '2015-01-15 00:48:46.000000', 'consum', 0.0212, 'lps'),
	(656833, 134, '2015-01-15 00:48:47.000000', 'consum', 0.0340, 'lps'),
	(656834, 134, '2015-01-15 00:48:48.000000', 'consum', 0.0221, 'lps'),
	(656835, 134, '2015-01-15 00:48:49.000000', 'consum', 0.0353, 'lps'),
	(656836, 134, '2015-01-15 00:48:50.000000', 'consum', 0.0257, 'lps'),
	(656837, 134, '2015-01-15 00:48:51.000000', 'consum', 0.0334, 'lps'),
	(656838, 134, '2015-01-15 00:48:52.000000', 'consum', 0.0218, 'lps'),
	(656839, 134, '2015-01-15 00:48:53.000000', 'consum', 0.0349, 'lps'),
	(656840, 134, '2015-01-15 00:48:54.000000', 'consum', 0.0249, 'lps'),
	(656841, 134, '2015-01-15 00:48:55.000000', 'consum', 0.0305, 'lps'),
	(656842, 134, '2015-01-15 00:48:56.000000', 'consum', 0.0255, 'lps'),
	(656843, 134, '2015-01-15 00:48:57.000000', 'consum', 0.0307, 'lps'),
	(656844, 134, '2015-01-15 00:48:58.000000', 'consum', 0.0244, 'lps'),
	(656845, 134, '2015-01-15 00:48:59.000000', 'consum', 0.0249, 'lps'),
	(656846, 134, '2015-01-15 00:49:00.000000', 'consum', 0.0304, 'lps'),
	(656847, 134, '2015-01-15 00:49:01.000000', 'consum', 0.0248, 'lps'),
	(656848, 134, '2015-01-15 00:49:02.000000', 'consum', 0.0276, 'lps'),
	(656849, 134, '2015-01-15 00:49:03.000000', 'consum', 0.0269, 'lps'),
	(656850, 134, '2015-01-15 00:49:04.000000', 'consum', 0.0305, 'lps'),
	(656851, 134, '2015-01-15 00:49:05.000000', 'consum', 0.0353, 'lps'),
	(656852, 134, '2015-01-15 00:49:06.000000', 'consum', 0.0323, 'lps'),
	(656853, 134, '2015-01-15 00:49:07.000000', 'consum', 0.0346, 'lps'),
	(656854, 134, '2015-01-15 00:49:08.000000', 'consum', 0.0235, 'lps'),
	(656855, 134, '2015-01-15 00:49:09.000000', 'consum', 0.0243, 'lps'),
	(656856, 134, '2015-01-15 00:49:10.000000', 'consum', 0.0303, 'lps'),
	(656857, 134, '2015-01-15 00:49:11.000000', 'consum', 0.0258, 'lps'),
	(656858, 134, '2015-01-15 00:49:12.000000', 'consum', 0.0329, 'lps'),
	(656859, 134, '2015-01-15 00:49:13.000000', 'consum', 0.0348, 'lps'),
	(656860, 134, '2015-01-15 00:49:14.000000', 'consum', 0.0228, 'lps'),
	(656861, 134, '2015-01-15 00:49:15.000000', 'consum', 0.0361, 'lps'),
	(656862, 134, '2015-01-15 00:49:16.000000', 'consum', 0.0278, 'lps'),
	(656863, 134, '2015-01-15 00:49:17.000000', 'consum', 0.0255, 'lps'),
	(656864, 134, '2015-01-15 00:49:18.000000', 'consum', 0.0233, 'lps'),
	(656865, 134, '2015-01-15 00:49:19.000000', 'consum', 0.0350, 'lps'),
	(656866, 134, '2015-01-15 00:49:20.000000', 'consum', 0.0364, 'lps'),
	(656867, 134, '2015-01-15 00:49:21.000000', 'consum', 0.0245, 'lps'),
	(656868, 134, '2015-01-15 00:49:22.000000', 'consum', 0.0241, 'lps'),
	(656869, 134, '2015-01-15 00:49:23.000000', 'consum', 0.0262, 'lps'),
	(656870, 134, '2015-01-15 00:49:24.000000', 'consum', 0.0218, 'lps'),
	(656871, 134, '2015-01-15 00:49:25.000000', 'consum', 0.0251, 'lps'),
	(656872, 134, '2015-01-15 00:49:26.000000', 'consum', 0.0234, 'lps'),
	(656873, 134, '2015-01-15 00:49:27.000000', 'consum', 0.0364, 'lps'),
	(656874, 134, '2015-01-15 00:49:28.000000', 'consum', 0.0278, 'lps'),
	(656875, 134, '2015-01-15 00:49:29.000000', 'consum', 0.0248, 'lps'),
	(656876, 134, '2015-01-15 00:49:30.000000', 'consum', 0.0354, 'lps'),
	(656877, 134, '2015-01-15 00:49:31.000000', 'consum', 0.0341, 'lps'),
	(656878, 134, '2015-01-15 00:49:32.000000', 'consum', 0.0276, 'lps'),
	(656879, 134, '2015-01-15 00:49:33.000000', 'consum', 0.0307, 'lps'),
	(656880, 134, '2015-01-15 00:49:34.000000', 'consum', 0.0339, 'lps'),
	(656881, 134, '2015-01-15 00:49:35.000000', 'consum', 0.0250, 'lps'),
	(656882, 134, '2015-01-15 00:49:36.000000', 'consum', 0.0338, 'lps'),
	(656883, 134, '2015-01-15 00:49:37.000000', 'consum', 0.0257, 'lps'),
	(656884, 134, '2015-01-15 00:49:38.000000', 'consum', 0.0218, 'lps'),
	(656885, 134, '2015-01-15 00:49:39.000000', 'consum', 0.0270, 'lps'),
	(656886, 134, '2015-01-15 00:49:40.000000', 'consum', 0.0327, 'lps'),
	(656887, 134, '2015-01-15 00:49:41.000000', 'consum', 0.0301, 'lps'),
	(656888, 134, '2015-01-15 00:49:42.000000', 'consum', 0.0315, 'lps'),
	(656889, 134, '2015-01-15 00:49:43.000000', 'consum', 0.0303, 'lps'),
	(656890, 134, '2015-01-15 00:49:44.000000', 'consum', 0.0360, 'lps'),
	(656891, 134, '2015-01-15 00:49:45.000000', 'consum', 0.0365, 'lps'),
	(656892, 134, '2015-01-15 00:49:46.000000', 'consum', 0.0219, 'lps'),
	(656893, 134, '2015-01-15 00:49:47.000000', 'consum', 0.0264, 'lps'),
	(656894, 134, '2015-01-15 00:49:48.000000', 'consum', 0.0298, 'lps'),
	(656895, 134, '2015-01-15 00:49:49.000000', 'consum', 0.0329, 'lps'),
	(656896, 134, '2015-01-15 00:49:50.000000', 'consum', 0.0224, 'lps'),
	(656897, 134, '2015-01-15 00:49:51.000000', 'consum', 0.0240, 'lps'),
	(656898, 134, '2015-01-15 00:49:52.000000', 'consum', 0.0317, 'lps'),
	(656899, 134, '2015-01-15 00:49:53.000000', 'consum', 0.0341, 'lps'),
	(656900, 134, '2015-01-15 00:49:54.000000', 'consum', 0.0230, 'lps'),
	(656901, 134, '2015-01-15 00:49:55.000000', 'consum', 0.0231, 'lps'),
	(656902, 134, '2015-01-15 00:49:56.000000', 'consum', 0.0254, 'lps'),
	(656903, 134, '2015-01-15 00:49:57.000000', 'consum', 0.0213, 'lps'),
	(656904, 134, '2015-01-15 00:49:58.000000', 'consum', 0.0251, 'lps'),
	(656905, 134, '2015-01-15 00:49:59.000000', 'consum', 0.0248, 'lps'),
	(656906, 134, '2015-01-15 00:50:00.000000', 'consum', 0.0276, 'lps'),
	(656907, 134, '2015-01-15 00:50:01.000000', 'consum', 0.0269, 'lps'),
	(656908, 134, '2015-01-15 00:50:02.000000', 'consum', 0.0306, 'lps'),
	(656909, 134, '2015-01-15 00:50:03.000000', 'consum', 0.0358, 'lps'),
	(656910, 134, '2015-01-15 00:50:04.000000', 'consum', 0.0347, 'lps'),
	(656911, 134, '2015-01-15 00:50:05.000000', 'consum', 0.0294, 'lps'),
	(656912, 134, '2015-01-15 00:50:06.000000', 'consum', 0.0219, 'lps'),
	(656913, 134, '2015-01-15 00:50:07.000000', 'consum', 0.0320, 'lps'),
	(656914, 134, '2015-01-15 00:50:08.000000', 'consum', 0.0258, 'lps'),
	(656915, 134, '2015-01-15 00:50:09.000000', 'consum', 0.0278, 'lps'),
	(656916, 134, '2015-01-15 00:50:10.000000', 'consum', 0.0250, 'lps'),
	(656917, 134, '2015-01-15 00:50:11.000000', 'consum', 0.0364, 'lps'),
	(656918, 134, '2015-01-15 00:50:12.000000', 'consum', 0.0229, 'lps'),
	(656919, 134, '2015-01-15 00:50:13.000000', 'consum', 0.0319, 'lps'),
	(656920, 134, '2015-01-15 00:50:14.000000', 'consum', 0.0221, 'lps'),
	(656921, 134, '2015-01-15 00:50:15.000000', 'consum', 0.0258, 'lps'),
	(656922, 134, '2015-01-15 00:50:16.000000', 'consum', 0.0256, 'lps'),
	(656923, 134, '2015-01-15 00:50:17.000000', 'consum', 0.0299, 'lps'),
	(656924, 134, '2015-01-15 00:50:18.000000', 'consum', 0.0360, 'lps'),
	(656925, 134, '2015-01-15 00:50:19.000000', 'consum', 0.0220, 'lps'),
	(656926, 134, '2015-01-15 00:50:20.000000', 'consum', 0.0283, 'lps'),
	(656927, 134, '2015-01-15 00:50:21.000000', 'consum', 0.0230, 'lps'),
	(656928, 134, '2015-01-15 00:50:22.000000', 'consum', 0.0248, 'lps'),
	(656929, 134, '2015-01-15 00:50:23.000000', 'consum', 0.0341, 'lps'),
	(656930, 134, '2015-01-15 00:50:24.000000', 'consum', 0.0279, 'lps'),
	(656931, 134, '2015-01-15 00:50:25.000000', 'consum', 0.0321, 'lps'),
	(656932, 134, '2015-01-15 00:50:26.000000', 'consum', 0.0241, 'lps'),
	(656933, 134, '2015-01-15 00:50:27.000000', 'consum', 0.0347, 'lps'),
	(656934, 134, '2015-01-15 00:50:28.000000', 'consum', 0.0329, 'lps'),
	(656935, 134, '2015-01-15 00:50:29.000000', 'consum', 0.0237, 'lps'),
	(656936, 134, '2015-01-15 00:50:30.000000', 'consum', 0.0305, 'lps'),
	(656937, 134, '2015-01-15 00:50:31.000000', 'consum', 0.0288, 'lps'),
	(656938, 134, '2015-01-15 00:50:32.000000', 'consum', 0.0314, 'lps'),
	(656939, 134, '2015-01-15 00:50:33.000000', 'consum', 0.0338, 'lps'),
	(656940, 134, '2015-01-15 00:50:34.000000', 'consum', 0.0226, 'lps'),
	(656941, 134, '2015-01-15 00:50:35.000000', 'consum', 0.0219, 'lps'),
	(656942, 134, '2015-01-15 00:50:36.000000', 'consum', 0.0366, 'lps'),
	(656943, 134, '2015-01-15 00:50:37.000000', 'consum', 0.0334, 'lps'),
	(656944, 134, '2015-01-15 00:50:38.000000', 'consum', 0.0362, 'lps'),
	(656945, 134, '2015-01-15 00:50:39.000000', 'consum', 0.0281, 'lps'),
	(656946, 134, '2015-01-15 00:50:40.000000', 'consum', 0.0268, 'lps'),
	(656947, 134, '2015-01-15 00:50:41.000000', 'consum', 0.0287, 'lps'),
	(656948, 134, '2015-01-15 00:50:42.000000', 'consum', 0.0266, 'lps'),
	(656949, 134, '2015-01-15 00:50:43.000000', 'consum', 0.0256, 'lps'),
	(656950, 134, '2015-01-15 00:50:44.000000', 'consum', 0.0275, 'lps'),
	(656951, 134, '2015-01-15 00:50:45.000000', 'consum', 0.0237, 'lps'),
	(656952, 134, '2015-01-15 00:50:46.000000', 'consum', 0.0308, 'lps'),
	(656953, 134, '2015-01-15 00:50:47.000000', 'consum', 0.0305, 'lps'),
	(656954, 134, '2015-01-15 00:50:48.000000', 'consum', 0.0235, 'lps'),
	(656955, 134, '2015-01-15 00:50:49.000000', 'consum', 0.0364, 'lps'),
	(656956, 134, '2015-01-15 00:50:50.000000', 'consum', 0.0274, 'lps'),
	(656957, 134, '2015-01-15 00:50:51.000000', 'consum', 0.0226, 'lps'),
	(656958, 134, '2015-01-15 00:50:52.000000', 'consum', 0.0257, 'lps'),
	(656959, 134, '2015-01-15 00:50:53.000000', 'consum', 0.0240, 'lps'),
	(656960, 134, '2015-01-15 00:50:54.000000', 'consum', 0.0218, 'lps'),
	(656961, 134, '2015-01-15 00:50:55.000000', 'consum', 0.0318, 'lps'),
	(656962, 134, '2015-01-15 00:50:56.000000', 'consum', 0.0253, 'lps'),
	(656963, 134, '2015-01-15 00:50:57.000000', 'consum', 0.0262, 'lps'),
	(656964, 134, '2015-01-15 00:50:58.000000', 'consum', 0.0339, 'lps'),
	(656965, 134, '2015-01-15 00:50:59.000000', 'consum', 0.0227, 'lps'),
	(656966, 134, '2015-01-15 00:51:00.000000', 'consum', 0.0226, 'lps'),
	(656967, 134, '2015-01-15 00:51:01.000000', 'consum', 0.0237, 'lps'),
	(656968, 134, '2015-01-15 00:51:02.000000', 'consum', 0.0300, 'lps'),
	(656969, 134, '2015-01-15 00:51:03.000000', 'consum', 0.0263, 'lps'),
	(656970, 134, '2015-01-15 00:51:04.000000', 'consum', 0.0365, 'lps'),
	(656971, 134, '2015-01-15 00:51:05.000000', 'consum', 0.0350, 'lps'),
	(656972, 134, '2015-01-15 00:51:06.000000', 'consum', 0.0287, 'lps'),
	(656973, 134, '2015-01-15 00:51:07.000000', 'consum', 0.0334, 'lps'),
	(656974, 134, '2015-01-15 00:51:08.000000', 'consum', 0.0283, 'lps'),
	(656975, 134, '2015-01-15 00:51:09.000000', 'consum', 0.0360, 'lps'),
	(656976, 134, '2015-01-15 00:51:10.000000', 'consum', 0.0271, 'lps'),
	(656977, 134, '2015-01-15 00:51:11.000000', 'consum', 0.0221, 'lps'),
	(656978, 134, '2015-01-15 00:51:12.000000', 'consum', 0.0243, 'lps'),
	(656979, 134, '2015-01-15 00:51:13.000000', 'consum', 0.0340, 'lps'),
	(656980, 134, '2015-01-15 00:51:14.000000', 'consum', 0.0289, 'lps'),
	(656981, 134, '2015-01-15 00:51:15.000000', 'consum', 0.0215, 'lps'),
	(656982, 134, '2015-01-15 00:51:16.000000', 'consum', 0.0313, 'lps'),
	(656983, 134, '2015-01-15 00:51:17.000000', 'consum', 0.0236, 'lps'),
	(656984, 134, '2015-01-15 00:51:18.000000', 'consum', 0.0350, 'lps'),
	(656985, 134, '2015-01-15 00:51:19.000000', 'consum', 0.0358, 'lps'),
	(656986, 134, '2015-01-15 00:51:20.000000', 'consum', 0.0214, 'lps'),
	(656987, 134, '2015-01-15 00:51:21.000000', 'consum', 0.0262, 'lps'),
	(656988, 134, '2015-01-15 00:51:22.000000', 'consum', 0.0299, 'lps'),
	(656989, 134, '2015-01-15 00:51:23.000000', 'consum', 0.0341, 'lps'),
	(656990, 134, '2015-01-15 00:51:24.000000', 'consum', 0.0281, 'lps'),
	(656991, 134, '2015-01-15 00:51:25.000000', 'consum', 0.0334, 'lps'),
	(656992, 134, '2015-01-15 00:51:26.000000', 'consum', 0.0298, 'lps'),
	(656993, 134, '2015-01-15 00:51:27.000000', 'consum', 0.0282, 'lps'),
	(656994, 134, '2015-01-15 00:51:28.000000', 'consum', 0.0305, 'lps'),
	(656995, 134, '2015-01-15 00:51:29.000000', 'consum', 0.0310, 'lps'),
	(656996, 134, '2015-01-15 00:51:30.000000', 'consum', 0.0268, 'lps'),
	(656997, 134, '2015-01-15 00:51:31.000000', 'consum', 0.0361, 'lps'),
	(656998, 134, '2015-01-15 00:51:32.000000', 'consum', 0.0316, 'lps'),
	(656999, 134, '2015-01-15 00:51:33.000000', 'consum', 0.0288, 'lps'),
	(657000, 134, '2015-01-15 00:51:34.000000', 'consum', 0.0280, 'lps'),
	(657001, 134, '2015-01-15 00:51:35.000000', 'consum', 0.0329, 'lps'),
	(657002, 134, '2015-01-15 00:51:36.000000', 'consum', 0.0281, 'lps'),
	(657003, 134, '2015-01-15 00:51:37.000000', 'consum', 0.0363, 'lps'),
	(657004, 134, '2015-01-15 00:51:38.000000', 'consum', 0.0292, 'lps'),
	(657005, 134, '2015-01-15 00:51:39.000000', 'consum', 0.0318, 'lps'),
	(657006, 134, '2015-01-15 00:51:40.000000', 'consum', 0.0345, 'lps'),
	(657007, 134, '2015-01-15 00:51:41.000000', 'consum', 0.0248, 'lps'),
	(657008, 134, '2015-01-15 00:51:42.000000', 'consum', 0.0312, 'lps'),
	(657009, 134, '2015-01-15 00:51:43.000000', 'consum', 0.0289, 'lps'),
	(657010, 134, '2015-01-15 00:51:44.000000', 'consum', 0.0300, 'lps'),
	(657011, 134, '2015-01-15 00:51:45.000000', 'consum', 0.0265, 'lps'),
	(657012, 134, '2015-01-15 00:51:46.000000', 'consum', 0.0216, 'lps'),
	(657013, 134, '2015-01-15 00:51:47.000000', 'consum', 0.0234, 'lps'),
	(657014, 134, '2015-01-15 00:51:48.000000', 'consum', 0.0312, 'lps'),
	(657015, 134, '2015-01-15 00:51:49.000000', 'consum', 0.0333, 'lps'),
	(657016, 134, '2015-01-15 00:51:50.000000', 'consum', 0.0362, 'lps'),
	(657017, 134, '2015-01-15 00:51:51.000000', 'consum', 0.0286, 'lps'),
	(657018, 134, '2015-01-15 00:51:52.000000', 'consum', 0.0292, 'lps'),
	(657019, 134, '2015-01-15 00:51:53.000000', 'consum', 0.0235, 'lps'),
	(657020, 134, '2015-01-15 00:51:54.000000', 'consum', 0.0247, 'lps'),
	(657021, 134, '2015-01-15 00:51:55.000000', 'consum', 0.0322, 'lps'),
	(657022, 134, '2015-01-15 00:51:56.000000', 'consum', 0.0342, 'lps'),
	(657023, 134, '2015-01-15 00:51:57.000000', 'consum', 0.0219, 'lps'),
	(657024, 134, '2015-01-15 00:51:58.000000', 'consum', 0.0333, 'lps'),
	(657025, 134, '2015-01-15 00:51:59.000000', 'consum', 0.0324, 'lps'),
	(657026, 134, '2015-01-15 00:52:00.000000', 'consum', 0.0253, 'lps'),
	(657027, 134, '2015-01-15 00:52:01.000000', 'consum', 0.0241, 'lps'),
	(657028, 134, '2015-01-15 00:52:02.000000', 'consum', 0.0238, 'lps'),
	(657029, 134, '2015-01-15 00:52:03.000000', 'consum', 0.0256, 'lps'),
	(657030, 134, '2015-01-15 00:52:04.000000', 'consum', 0.0358, 'lps'),
	(657031, 134, '2015-01-15 00:52:05.000000', 'consum', 0.0340, 'lps'),
	(657032, 134, '2015-01-15 00:52:06.000000', 'consum', 0.0255, 'lps'),
	(657033, 134, '2015-01-15 00:52:07.000000', 'consum', 0.0363, 'lps'),
	(657034, 134, '2015-01-15 00:52:08.000000', 'consum', 0.0367, 'lps'),
	(657035, 134, '2015-01-15 00:52:09.000000', 'consum', 0.0220, 'lps'),
	(657036, 134, '2015-01-15 00:52:10.000000', 'consum', 0.0263, 'lps'),
	(657037, 134, '2015-01-15 00:52:11.000000', 'consum', 0.0287, 'lps'),
	(657038, 134, '2015-01-15 00:52:12.000000', 'consum', 0.0281, 'lps'),
	(657039, 134, '2015-01-15 00:52:13.000000', 'consum', 0.0331, 'lps'),
	(657040, 134, '2015-01-15 00:52:14.000000', 'consum', 0.0290, 'lps'),
	(657041, 134, '2015-01-15 00:52:15.000000', 'consum', 0.0245, 'lps'),
	(657042, 134, '2015-01-15 00:52:16.000000', 'consum', 0.0303, 'lps'),
	(657043, 134, '2015-01-15 00:52:17.000000', 'consum', 0.0256, 'lps'),
	(657044, 134, '2015-01-15 00:52:18.000000', 'consum', 0.0318, 'lps'),
	(657045, 134, '2015-01-15 00:52:19.000000', 'consum', 0.0298, 'lps'),
	(657046, 134, '2015-01-15 00:52:20.000000', 'consum', 0.0327, 'lps'),
	(657047, 134, '2015-01-15 00:52:21.000000', 'consum', 0.0214, 'lps'),
	(657048, 134, '2015-01-15 00:52:22.000000', 'consum', 0.0352, 'lps'),
	(657049, 134, '2015-01-15 00:52:23.000000', 'consum', 0.0279, 'lps'),
	(657050, 134, '2015-01-15 00:52:24.000000', 'consum', 0.0286, 'lps'),
	(657051, 134, '2015-01-15 00:52:25.000000', 'consum', 0.0224, 'lps'),
	(657052, 134, '2015-01-15 00:52:26.000000', 'consum', 0.0212, 'lps'),
	(657053, 134, '2015-01-15 00:52:27.000000', 'consum', 0.0336, 'lps'),
	(657054, 134, '2015-01-15 00:52:28.000000', 'consum', 0.0361, 'lps'),
	(657055, 134, '2015-01-15 00:52:29.000000', 'consum', 0.0273, 'lps'),
	(657056, 134, '2015-01-15 00:52:30.000000', 'consum', 0.0230, 'lps'),
	(657057, 134, '2015-01-15 00:52:31.000000', 'consum', 0.0278, 'lps'),
	(657058, 134, '2015-01-15 00:52:32.000000', 'consum', 0.0335, 'lps'),
	(657059, 134, '2015-01-15 00:52:33.000000', 'consum', 0.0313, 'lps'),
	(657060, 134, '2015-01-15 00:52:34.000000', 'consum', 0.0352, 'lps'),
	(657061, 134, '2015-01-15 00:52:35.000000', 'consum', 0.0293, 'lps'),
	(657062, 134, '2015-01-15 00:52:36.000000', 'consum', 0.0359, 'lps'),
	(657063, 134, '2015-01-15 00:52:37.000000', 'consum', 0.0232, 'lps'),
	(657064, 134, '2015-01-15 00:52:38.000000', 'consum', 0.0348, 'lps'),
	(657065, 134, '2015-01-15 00:52:39.000000', 'consum', 0.0362, 'lps'),
	(657066, 134, '2015-01-15 00:52:40.000000', 'consum', 0.0239, 'lps'),
	(657067, 134, '2015-01-15 00:52:41.000000', 'consum', 0.0218, 'lps'),
	(657068, 134, '2015-01-15 00:52:42.000000', 'consum', 0.0318, 'lps'),
	(657069, 134, '2015-01-15 00:52:43.000000', 'consum', 0.0254, 'lps'),
	(657070, 134, '2015-01-15 00:52:44.000000', 'consum', 0.0262, 'lps'),
	(657071, 134, '2015-01-15 00:52:45.000000', 'consum', 0.0341, 'lps'),
	(657072, 134, '2015-01-15 00:52:46.000000', 'consum', 0.0236, 'lps'),
	(657073, 134, '2015-01-15 00:52:47.000000', 'consum', 0.0264, 'lps'),
	(657074, 134, '2015-01-15 00:52:48.000000', 'consum', 0.0245, 'lps'),
	(657075, 134, '2015-01-15 00:52:49.000000', 'consum', 0.0224, 'lps'),
	(657076, 134, '2015-01-15 00:52:50.000000', 'consum', 0.0333, 'lps'),
	(657077, 134, '2015-01-15 00:52:51.000000', 'consum', 0.0310, 'lps'),
	(657078, 134, '2015-01-15 00:52:52.000000', 'consum', 0.0343, 'lps'),
	(657079, 134, '2015-01-15 00:52:53.000000', 'consum', 0.0258, 'lps'),
	(657080, 134, '2015-01-15 00:52:54.000000', 'consum', 0.0366, 'lps'),
	(657081, 134, '2015-01-15 00:52:55.000000', 'consum', 0.0215, 'lps'),
	(657082, 134, '2015-01-15 00:52:56.000000', 'consum', 0.0240, 'lps'),
	(657083, 134, '2015-01-15 00:52:57.000000', 'consum', 0.0349, 'lps'),
	(657084, 134, '2015-01-15 00:52:58.000000', 'consum', 0.0339, 'lps'),
	(657085, 134, '2015-01-15 00:52:59.000000', 'consum', 0.0282, 'lps'),
	(657086, 134, '2015-01-15 00:53:00.000000', 'consum', 0.0339, 'lps'),
	(657087, 134, '2015-01-15 00:53:01.000000', 'consum', 0.0327, 'lps'),
	(657088, 134, '2015-01-15 00:53:02.000000', 'consum', 0.0248, 'lps'),
	(657089, 134, '2015-01-15 00:53:03.000000', 'consum', 0.0367, 'lps'),
	(657090, 134, '2015-01-15 00:53:04.000000', 'consum', 0.0251, 'lps'),
	(657091, 134, '2015-01-15 00:53:05.000000', 'consum', 0.0259, 'lps'),
	(657092, 134, '2015-01-15 00:53:06.000000', 'consum', 0.0331, 'lps'),
	(657093, 134, '2015-01-15 00:53:07.000000', 'consum', 0.0354, 'lps'),
	(657094, 134, '2015-01-15 00:53:08.000000', 'consum', 0.0250, 'lps'),
	(657095, 134, '2015-01-15 00:53:09.000000', 'consum', 0.0293, 'lps'),
	(657096, 134, '2015-01-15 00:53:10.000000', 'consum', 0.0350, 'lps'),
	(657097, 134, '2015-01-15 00:53:11.000000', 'consum', 0.0347, 'lps'),
	(657098, 134, '2015-01-15 00:53:12.000000', 'consum', 0.0316, 'lps'),
	(657099, 134, '2015-01-15 00:53:13.000000', 'consum', 0.0330, 'lps'),
	(657100, 134, '2015-01-15 00:53:14.000000', 'consum', 0.0334, 'lps'),
	(657101, 134, '2015-01-15 00:53:15.000000', 'consum', 0.0314, 'lps'),
	(657102, 134, '2015-01-15 00:53:16.000000', 'consum', 0.0358, 'lps'),
	(657103, 134, '2015-01-15 00:53:17.000000', 'consum', 0.0322, 'lps'),
	(657104, 134, '2015-01-15 00:53:18.000000', 'consum', 0.0325, 'lps'),
	(657105, 134, '2015-01-15 00:53:19.000000', 'consum', 0.0291, 'lps'),
	(657106, 134, '2015-01-15 00:53:20.000000', 'consum', 0.0272, 'lps'),
	(657107, 134, '2015-01-15 00:53:21.000000', 'consum', 0.0279, 'lps'),
	(657108, 134, '2015-01-15 00:53:22.000000', 'consum', 0.0211, 'lps'),
	(657109, 134, '2015-01-15 00:53:23.000000', 'consum', 0.0324, 'lps'),
	(657110, 134, '2015-01-15 00:53:24.000000', 'consum', 0.0305, 'lps'),
	(657111, 134, '2015-01-15 00:53:25.000000', 'consum', 0.0341, 'lps'),
	(657112, 134, '2015-01-15 00:53:26.000000', 'consum', 0.0266, 'lps'),
	(657113, 134, '2015-01-15 00:53:27.000000', 'consum', 0.0254, 'lps'),
	(657114, 134, '2015-01-15 00:53:28.000000', 'consum', 0.0262, 'lps'),
	(657115, 134, '2015-01-15 00:53:29.000000', 'consum', 0.0341, 'lps'),
	(657116, 134, '2015-01-15 00:53:30.000000', 'consum', 0.0233, 'lps'),
	(657117, 134, '2015-01-15 00:53:31.000000', 'consum', 0.0248, 'lps'),
	(657118, 134, '2015-01-15 00:53:32.000000', 'consum', 0.0333, 'lps'),
	(657119, 134, '2015-01-15 00:53:33.000000', 'consum', 0.0239, 'lps'),
	(657120, 134, '2015-01-15 00:53:34.000000', 'consum', 0.0301, 'lps'),
	(657121, 134, '2015-01-15 00:53:35.000000', 'consum', 0.0261, 'lps'),
	(657122, 134, '2015-01-15 00:53:36.000000', 'consum', 0.0354, 'lps'),
	(657123, 134, '2015-01-15 00:53:37.000000', 'consum', 0.0300, 'lps'),
	(657124, 134, '2015-01-15 00:53:38.000000', 'consum', 0.0230, 'lps'),
	(657125, 134, '2015-01-15 00:53:39.000000', 'consum', 0.0358, 'lps'),
	(657126, 134, '2015-01-15 00:53:40.000000', 'consum', 0.0256, 'lps'),
	(657127, 134, '2015-01-15 00:53:41.000000', 'consum', 0.0316, 'lps'),
	(657128, 134, '2015-01-15 00:53:42.000000', 'consum', 0.0283, 'lps'),
	(657129, 134, '2015-01-15 00:53:43.000000', 'consum', 0.0258, 'lps'),
	(657130, 134, '2015-01-15 00:53:44.000000', 'consum', 0.0232, 'lps'),
	(657131, 134, '2015-01-15 00:53:45.000000', 'consum', 0.0337, 'lps'),
	(657132, 134, '2015-01-15 00:53:46.000000', 'consum', 0.0302, 'lps'),
	(657133, 134, '2015-01-15 00:53:47.000000', 'consum', 0.0289, 'lps'),
	(657134, 134, '2015-01-15 00:53:48.000000', 'consum', 0.0331, 'lps'),
	(657135, 134, '2015-01-15 00:53:49.000000', 'consum', 0.0264, 'lps'),
	(657136, 134, '2015-01-15 00:53:50.000000', 'consum', 0.0273, 'lps'),
	(657137, 134, '2015-01-15 00:53:51.000000', 'consum', 0.0365, 'lps'),
	(657138, 134, '2015-01-15 00:53:52.000000', 'consum', 0.0324, 'lps'),
	(657139, 134, '2015-01-15 00:53:53.000000', 'consum', 0.0314, 'lps'),
	(657140, 134, '2015-01-15 00:53:54.000000', 'consum', 0.0232, 'lps'),
	(657141, 134, '2015-01-15 00:53:55.000000', 'consum', 0.0325, 'lps'),
	(657142, 134, '2015-01-15 00:53:56.000000', 'consum', 0.0245, 'lps'),
	(657143, 134, '2015-01-15 00:53:57.000000', 'consum', 0.0355, 'lps'),
	(657144, 134, '2015-01-15 00:53:58.000000', 'consum', 0.0358, 'lps'),
	(657145, 134, '2015-01-15 00:53:59.000000', 'consum', 0.0355, 'lps'),
	(657146, 134, '2015-01-15 00:54:00.000000', 'consum', 0.0335, 'lps'),
	(657147, 134, '2015-01-15 00:54:01.000000', 'consum', 0.0243, 'lps'),
	(657148, 134, '2015-01-15 00:54:02.000000', 'consum', 0.0318, 'lps'),
	(657149, 134, '2015-01-15 00:54:03.000000', 'consum', 0.0334, 'lps'),
	(657150, 134, '2015-01-15 00:54:04.000000', 'consum', 0.0349, 'lps'),
	(657151, 134, '2015-01-15 00:54:05.000000', 'consum', 0.0217, 'lps'),
	(657152, 134, '2015-01-15 00:54:06.000000', 'consum', 0.0303, 'lps'),
	(657153, 134, '2015-01-15 00:54:07.000000', 'consum', 0.0340, 'lps'),
	(657154, 134, '2015-01-15 00:54:08.000000', 'consum', 0.0264, 'lps'),
	(657155, 134, '2015-01-15 00:54:09.000000', 'consum', 0.0250, 'lps'),
	(657156, 134, '2015-01-15 00:54:10.000000', 'consum', 0.0247, 'lps'),
	(657157, 134, '2015-01-15 00:54:11.000000', 'consum', 0.0274, 'lps'),
	(657158, 134, '2015-01-15 00:54:12.000000', 'consum', 0.0264, 'lps'),
	(657159, 134, '2015-01-15 00:54:13.000000', 'consum', 0.0289, 'lps'),
	(657160, 134, '2015-01-15 00:54:14.000000', 'consum', 0.0286, 'lps'),
	(657161, 134, '2015-01-15 00:54:15.000000', 'consum', 0.0351, 'lps'),
	(657162, 134, '2015-01-15 00:54:16.000000', 'consum', 0.0214, 'lps'),
	(657163, 134, '2015-01-15 00:54:17.000000', 'consum', 0.0280, 'lps'),
	(657164, 134, '2015-01-15 00:54:18.000000', 'consum', 0.0234, 'lps'),
	(657165, 134, '2015-01-15 00:54:19.000000', 'consum', 0.0280, 'lps'),
	(657166, 134, '2015-01-15 00:54:20.000000', 'consum', 0.0329, 'lps'),
	(657167, 134, '2015-01-15 00:54:21.000000', 'consum', 0.0279, 'lps'),
	(657168, 134, '2015-01-15 00:54:22.000000', 'consum', 0.0356, 'lps'),
	(657169, 134, '2015-01-15 00:54:23.000000', 'consum', 0.0259, 'lps'),
	(657170, 134, '2015-01-15 00:54:24.000000', 'consum', 0.0334, 'lps'),
	(657171, 134, '2015-01-15 00:54:25.000000', 'consum', 0.0211, 'lps'),
	(657172, 134, '2015-01-15 00:54:26.000000', 'consum', 0.0318, 'lps'),
	(657173, 134, '2015-01-15 00:54:27.000000', 'consum', 0.0271, 'lps'),
	(657174, 134, '2015-01-15 00:54:28.000000', 'consum', 0.0350, 'lps'),
	(657175, 134, '2015-01-15 00:54:29.000000', 'consum', 0.0254, 'lps'),
	(657176, 134, '2015-01-15 00:54:30.000000', 'consum', 0.0328, 'lps'),
	(657177, 134, '2015-01-15 00:54:31.000000', 'consum', 0.0353, 'lps'),
	(657178, 134, '2015-01-15 00:54:32.000000', 'consum', 0.0254, 'lps'),
	(657179, 134, '2015-01-15 00:54:33.000000', 'consum', 0.0316, 'lps'),
	(657180, 134, '2015-01-15 00:54:34.000000', 'consum', 0.0293, 'lps'),
	(657181, 134, '2015-01-15 00:54:35.000000', 'consum', 0.0307, 'lps'),
	(657182, 134, '2015-01-15 00:54:36.000000', 'consum', 0.0288, 'lps'),
	(657183, 134, '2015-01-15 00:54:37.000000', 'consum', 0.0311, 'lps'),
	(657184, 134, '2015-01-15 00:54:38.000000', 'consum', 0.0321, 'lps'),
	(657185, 134, '2015-01-15 00:54:39.000000', 'consum', 0.0306, 'lps'),
	(657186, 134, '2015-01-15 00:54:40.000000', 'consum', 0.0356, 'lps'),
	(657187, 134, '2015-01-15 00:54:41.000000', 'consum', 0.0336, 'lps'),
	(657188, 134, '2015-01-15 00:54:42.000000', 'consum', 0.0245, 'lps'),
	(657189, 134, '2015-01-15 00:54:43.000000', 'consum', 0.0325, 'lps'),
	(657190, 134, '2015-01-15 00:54:44.000000', 'consum', 0.0362, 'lps'),
	(657191, 134, '2015-01-15 00:54:45.000000', 'consum', 0.0312, 'lps'),
	(657192, 134, '2015-01-15 00:54:46.000000', 'consum', 0.0264, 'lps'),
	(657193, 134, '2015-01-15 00:54:47.000000', 'consum', 0.0334, 'lps'),
	(657194, 134, '2015-01-15 00:54:48.000000', 'consum', 0.0349, 'lps'),
	(657195, 134, '2015-01-15 00:54:49.000000', 'consum', 0.0220, 'lps'),
	(657196, 134, '2015-01-15 00:54:50.000000', 'consum', 0.0317, 'lps'),
	(657197, 134, '2015-01-15 00:54:51.000000', 'consum', 0.0240, 'lps'),
	(657198, 134, '2015-01-15 00:54:52.000000', 'consum', 0.0358, 'lps'),
	(657199, 134, '2015-01-15 00:54:53.000000', 'consum', 0.0226, 'lps'),
	(657200, 134, '2015-01-15 00:54:54.000000', 'consum', 0.0319, 'lps'),
	(657201, 134, '2015-01-15 00:54:55.000000', 'consum', 0.0237, 'lps'),
	(657202, 134, '2015-01-15 00:54:56.000000', 'consum', 0.0334, 'lps'),
	(657203, 134, '2015-01-15 00:54:57.000000', 'consum', 0.0273, 'lps'),
	(657204, 134, '2015-01-15 00:54:58.000000', 'consum', 0.0312, 'lps'),
	(657205, 134, '2015-01-15 00:54:59.000000', 'consum', 0.0217, 'lps'),
	(657206, 134, '2015-01-15 00:55:00.000000', 'consum', 0.0256, 'lps'),
	(657207, 134, '2015-01-15 00:55:01.000000', 'consum', 0.0262, 'lps'),
	(657208, 134, '2015-01-15 00:55:02.000000', 'consum', 0.0333, 'lps'),
	(657209, 134, '2015-01-15 00:55:03.000000', 'consum', 0.0350, 'lps'),
	(657210, 134, '2015-01-15 00:55:04.000000', 'consum', 0.0229, 'lps'),
	(657211, 134, '2015-01-15 00:55:05.000000', 'consum', 0.0359, 'lps'),
	(657212, 134, '2015-01-15 00:55:06.000000', 'consum', 0.0265, 'lps'),
	(657213, 134, '2015-01-15 00:55:07.000000', 'consum', 0.0355, 'lps'),
	(657214, 134, '2015-01-15 00:55:08.000000', 'consum', 0.0296, 'lps'),
	(657215, 134, '2015-01-15 00:55:09.000000', 'consum', 0.0362, 'lps'),
	(657216, 134, '2015-01-15 00:55:10.000000', 'consum', 0.0242, 'lps'),
	(657217, 134, '2015-01-15 00:55:11.000000', 'consum', 0.0228, 'lps'),
	(657218, 134, '2015-01-15 00:55:12.000000', 'consum', 0.0364, 'lps'),
	(657219, 134, '2015-01-15 00:55:13.000000', 'consum', 0.0293, 'lps'),
	(657220, 134, '2015-01-15 00:55:14.000000', 'consum', 0.0323, 'lps'),
	(657221, 134, '2015-01-15 00:55:15.000000', 'consum', 0.0212, 'lps'),
	(657222, 134, '2015-01-15 00:55:16.000000', 'consum', 0.0353, 'lps'),
	(657223, 134, '2015-01-15 00:55:17.000000', 'consum', 0.0290, 'lps'),
	(657224, 134, '2015-01-15 00:55:18.000000', 'consum', 0.0339, 'lps'),
	(657225, 134, '2015-01-15 00:55:19.000000', 'consum', 0.0298, 'lps'),
	(657226, 134, '2015-01-15 00:55:20.000000', 'consum', 0.0263, 'lps'),
	(657227, 134, '2015-01-15 00:55:21.000000', 'consum', 0.0212, 'lps'),
	(657228, 134, '2015-01-15 00:55:22.000000', 'consum', 0.0219, 'lps'),
	(657229, 134, '2015-01-15 00:55:23.000000', 'consum', 0.0248, 'lps'),
	(657230, 134, '2015-01-15 00:55:24.000000', 'consum', 0.0219, 'lps'),
	(657231, 134, '2015-01-15 00:55:25.000000', 'consum', 0.0296, 'lps'),
	(657232, 134, '2015-01-15 00:55:26.000000', 'consum', 0.0299, 'lps'),
	(657233, 134, '2015-01-15 00:55:27.000000', 'consum', 0.0238, 'lps'),
	(657234, 134, '2015-01-15 00:55:28.000000', 'consum', 0.0244, 'lps'),
	(657235, 134, '2015-01-15 00:55:29.000000', 'consum', 0.0295, 'lps'),
	(657236, 134, '2015-01-15 00:55:30.000000', 'consum', 0.0217, 'lps'),
	(657237, 134, '2015-01-15 00:55:31.000000', 'consum', 0.0309, 'lps'),
	(657238, 134, '2015-01-15 00:55:32.000000', 'consum', 0.0210, 'lps'),
	(657239, 134, '2015-01-15 00:55:33.000000', 'consum', 0.0227, 'lps'),
	(657240, 134, '2015-01-15 00:55:34.000000', 'consum', 0.0296, 'lps'),
	(657241, 134, '2015-01-15 00:55:35.000000', 'consum', 0.0276, 'lps'),
	(657242, 134, '2015-01-15 00:55:36.000000', 'consum', 0.0282, 'lps'),
	(657243, 134, '2015-01-15 00:55:37.000000', 'consum', 0.0212, 'lps'),
	(657244, 134, '2015-01-15 00:55:38.000000', 'consum', 0.0323, 'lps'),
	(657245, 134, '2015-01-15 00:55:39.000000', 'consum', 0.0297, 'lps'),
	(657246, 134, '2015-01-15 00:55:40.000000', 'consum', 0.0303, 'lps'),
	(657247, 134, '2015-01-15 00:55:41.000000', 'consum', 0.0258, 'lps'),
	(657248, 134, '2015-01-15 00:55:42.000000', 'consum', 0.0329, 'lps'),
	(657249, 134, '2015-01-15 00:55:43.000000', 'consum', 0.0345, 'lps'),
	(657250, 134, '2015-01-15 00:55:44.000000', 'consum', 0.0212, 'lps'),
	(657251, 134, '2015-01-15 00:55:45.000000', 'consum', 0.0291, 'lps'),
	(657252, 134, '2015-01-15 00:55:46.000000', 'consum', 0.0291, 'lps'),
	(657253, 134, '2015-01-15 00:55:47.000000', 'consum', 0.0216, 'lps'),
	(657254, 134, '2015-01-15 00:55:48.000000', 'consum', 0.0315, 'lps'),
	(657255, 134, '2015-01-15 00:55:49.000000', 'consum', 0.0242, 'lps'),
	(657256, 134, '2015-01-15 00:55:50.000000', 'consum', 0.0214, 'lps'),
	(657257, 134, '2015-01-15 00:55:51.000000', 'consum', 0.0293, 'lps'),
	(657258, 134, '2015-01-15 00:55:52.000000', 'consum', 0.0297, 'lps'),
	(657259, 134, '2015-01-15 00:55:53.000000', 'consum', 0.0238, 'lps'),
	(657260, 134, '2015-01-15 00:55:54.000000', 'consum', 0.0250, 'lps'),
	(657261, 134, '2015-01-15 00:55:55.000000', 'consum', 0.0323, 'lps'),
	(657262, 134, '2015-01-15 00:55:56.000000', 'consum', 0.0341, 'lps'),
	(657263, 134, '2015-01-15 00:55:57.000000', 'consum', 0.0211, 'lps'),
	(657264, 134, '2015-01-15 00:55:58.000000', 'consum', 0.0296, 'lps'),
	(657265, 134, '2015-01-15 00:55:59.000000', 'consum', 0.0321, 'lps'),
	(657266, 134, '2015-01-15 00:56:00.000000', 'consum', 0.0348, 'lps'),
	(657267, 134, '2015-01-15 00:56:01.000000', 'consum', 0.0252, 'lps'),
	(657268, 134, '2015-01-15 00:56:02.000000', 'consum', 0.0325, 'lps'),
	(657269, 134, '2015-01-15 00:56:03.000000', 'consum', 0.0343, 'lps'),
	(657270, 134, '2015-01-15 00:56:04.000000', 'consum', 0.0212, 'lps'),
	(657271, 134, '2015-01-15 00:56:05.000000', 'consum', 0.0297, 'lps'),
	(657272, 134, '2015-01-15 00:56:06.000000', 'consum', 0.0323, 'lps'),
	(657273, 134, '2015-01-15 00:56:07.000000', 'consum', 0.0355, 'lps'),
	(657274, 134, '2015-01-15 00:56:08.000000', 'consum', 0.0282, 'lps'),
	(657275, 134, '2015-01-15 00:56:09.000000', 'consum', 0.0295, 'lps'),
	(657276, 134, '2015-01-15 00:56:10.000000', 'consum', 0.0262, 'lps'),
	(657277, 134, '2015-01-15 00:56:11.000000', 'consum', 0.0215, 'lps'),
	(657278, 134, '2015-01-15 00:56:12.000000', 'consum', 0.0236, 'lps'),
	(657279, 134, '2015-01-15 00:56:13.000000', 'consum', 0.0326, 'lps'),
	(657280, 134, '2015-01-15 00:56:14.000000', 'consum', 0.0240, 'lps'),
	(657281, 134, '2015-01-15 00:56:15.000000', 'consum', 0.0327, 'lps'),
	(657282, 134, '2015-01-15 00:56:16.000000', 'consum', 0.0231, 'lps'),
	(657283, 134, '2015-01-15 00:56:17.000000', 'consum', 0.0283, 'lps'),
	(657284, 134, '2015-01-15 00:56:18.000000', 'consum', 0.0351, 'lps'),
	(657285, 134, '2015-01-15 00:56:19.000000', 'consum', 0.0225, 'lps'),
	(657286, 134, '2015-01-15 00:56:20.000000', 'consum', 0.0337, 'lps'),
	(657287, 134, '2015-01-15 00:56:21.000000', 'consum', 0.0328, 'lps'),
	(657288, 134, '2015-01-15 00:56:22.000000', 'consum', 0.0259, 'lps'),
	(657289, 134, '2015-01-15 00:56:23.000000', 'consum', 0.0259, 'lps'),
	(657290, 134, '2015-01-15 00:56:24.000000', 'consum', 0.0310, 'lps'),
	(657291, 134, '2015-01-15 00:56:25.000000', 'consum', 0.0248, 'lps'),
	(657292, 134, '2015-01-15 00:56:26.000000', 'consum', 0.0256, 'lps'),
	(657293, 134, '2015-01-15 00:56:27.000000', 'consum', 0.0329, 'lps'),
	(657294, 134, '2015-01-15 00:56:28.000000', 'consum', 0.0349, 'lps'),
	(657295, 134, '2015-01-15 00:56:29.000000', 'consum', 0.0235, 'lps'),
	(657296, 134, '2015-01-15 00:56:30.000000', 'consum', 0.0234, 'lps'),
	(657297, 134, '2015-01-15 00:56:31.000000', 'consum', 0.0253, 'lps'),
	(657298, 134, '2015-01-15 00:56:32.000000', 'consum', 0.0357, 'lps'),
	(657299, 134, '2015-01-15 00:56:33.000000', 'consum', 0.0339, 'lps'),
	(657300, 134, '2015-01-15 00:56:34.000000', 'consum', 0.0258, 'lps'),
	(657301, 134, '2015-01-15 00:56:35.000000', 'consum', 0.0223, 'lps'),
	(657302, 134, '2015-01-15 00:56:36.000000', 'consum', 0.0289, 'lps'),
	(657303, 134, '2015-01-15 00:56:37.000000', 'consum', 0.0251, 'lps'),
	(657304, 134, '2015-01-15 00:56:38.000000', 'consum', 0.0334, 'lps'),
	(657305, 134, '2015-01-15 00:56:39.000000', 'consum', 0.0237, 'lps'),
	(657306, 134, '2015-01-15 00:56:40.000000', 'consum', 0.0287, 'lps'),
	(657307, 134, '2015-01-15 00:56:41.000000', 'consum', 0.0357, 'lps'),
	(657308, 134, '2015-01-15 00:56:42.000000', 'consum', 0.0239, 'lps'),
	(657309, 134, '2015-01-15 00:56:43.000000', 'consum', 0.0233, 'lps'),
	(657310, 134, '2015-01-15 00:56:44.000000', 'consum', 0.0237, 'lps'),
	(657311, 134, '2015-01-15 00:56:45.000000', 'consum', 0.0277, 'lps'),
	(657312, 134, '2015-01-15 00:56:46.000000', 'consum', 0.0306, 'lps'),
	(657313, 134, '2015-01-15 00:56:47.000000', 'consum', 0.0332, 'lps'),
	(657314, 134, '2015-01-15 00:56:48.000000', 'consum', 0.0215, 'lps'),
	(657315, 134, '2015-01-15 00:56:49.000000', 'consum', 0.0345, 'lps'),
	(657316, 134, '2015-01-15 00:56:50.000000', 'consum', 0.0238, 'lps'),
	(657317, 134, '2015-01-15 00:56:51.000000', 'consum', 0.0260, 'lps'),
	(657318, 134, '2015-01-15 00:56:52.000000', 'consum', 0.0222, 'lps'),
	(657319, 134, '2015-01-15 00:56:53.000000', 'consum', 0.0275, 'lps'),
	(657320, 134, '2015-01-15 00:56:54.000000', 'consum', 0.0344, 'lps'),
	(657321, 134, '2015-01-15 00:56:55.000000', 'consum', 0.0367, 'lps'),
	(657322, 134, '2015-01-15 00:56:56.000000', 'consum', 0.0278, 'lps'),
	(657323, 134, '2015-01-15 00:56:57.000000', 'consum', 0.0240, 'lps'),
	(657324, 134, '2015-01-15 00:56:58.000000', 'consum', 0.0312, 'lps'),
	(657325, 134, '2015-01-15 00:56:59.000000', 'consum', 0.0315, 'lps'),
	(657326, 134, '2015-01-15 00:57:00.000000', 'consum', 0.0273, 'lps'),
	(657327, 134, '2015-01-15 00:57:01.000000', 'consum', 0.0211, 'lps'),
	(657328, 134, '2015-01-15 00:57:02.000000', 'consum', 0.0343, 'lps'),
	(657329, 134, '2015-01-15 00:57:03.000000', 'consum', 0.0239, 'lps'),
	(657330, 134, '2015-01-15 00:57:04.000000', 'consum', 0.0274, 'lps'),
	(657331, 134, '2015-01-15 00:57:05.000000', 'consum', 0.0286, 'lps'),
	(657332, 134, '2015-01-15 00:57:06.000000', 'consum', 0.0240, 'lps'),
	(657333, 134, '2015-01-15 00:57:07.000000', 'consum', 0.0291, 'lps'),
	(657334, 134, '2015-01-15 00:57:08.000000', 'consum', 0.0210, 'lps'),
	(657335, 134, '2015-01-15 00:57:09.000000', 'consum', 0.0282, 'lps'),
	(657336, 134, '2015-01-15 00:57:10.000000', 'consum', 0.0255, 'lps'),
	(657337, 134, '2015-01-15 00:57:11.000000', 'consum', 0.0219, 'lps'),
	(657338, 134, '2015-01-15 00:57:12.000000', 'consum', 0.0280, 'lps'),
	(657339, 134, '2015-01-15 00:57:13.000000', 'consum', 0.0219, 'lps'),
	(657340, 134, '2015-01-15 00:57:14.000000', 'consum', 0.0359, 'lps'),
	(657341, 134, '2015-01-15 00:57:15.000000', 'consum', 0.0298, 'lps'),
	(657342, 134, '2015-01-15 00:57:16.000000', 'consum', 0.0360, 'lps'),
	(657343, 134, '2015-01-15 00:57:17.000000', 'consum', 0.0224, 'lps'),
	(657344, 134, '2015-01-15 00:57:18.000000', 'consum', 0.0302, 'lps'),
	(657345, 134, '2015-01-15 00:57:19.000000', 'consum', 0.0314, 'lps'),
	(657346, 134, '2015-01-15 00:57:20.000000', 'consum', 0.0297, 'lps'),
	(657347, 134, '2015-01-15 00:57:21.000000', 'consum', 0.0333, 'lps'),
	(657348, 134, '2015-01-15 00:57:22.000000', 'consum', 0.0247, 'lps'),
	(657349, 134, '2015-01-15 00:57:23.000000', 'consum', 0.0342, 'lps'),
	(657350, 134, '2015-01-15 00:57:24.000000', 'consum', 0.0286, 'lps'),
	(657351, 134, '2015-01-15 00:57:25.000000', 'consum', 0.0355, 'lps'),
	(657352, 134, '2015-01-15 00:57:26.000000', 'consum', 0.0232, 'lps'),
	(657353, 134, '2015-01-15 00:57:27.000000', 'consum', 0.0359, 'lps'),
	(657354, 134, '2015-01-15 00:57:28.000000', 'consum', 0.0258, 'lps'),
	(657355, 134, '2015-01-15 00:57:29.000000', 'consum', 0.0319, 'lps'),
	(657356, 134, '2015-01-15 00:57:30.000000', 'consum', 0.0294, 'lps'),
	(657357, 134, '2015-01-15 00:57:31.000000', 'consum', 0.0304, 'lps'),
	(657358, 134, '2015-01-15 00:57:32.000000', 'consum', 0.0273, 'lps'),
	(657359, 134, '2015-01-15 00:57:33.000000', 'consum', 0.0241, 'lps'),
	(657360, 134, '2015-01-15 00:57:34.000000', 'consum', 0.0337, 'lps'),
	(657361, 134, '2015-01-15 00:57:35.000000', 'consum', 0.0276, 'lps'),
	(657362, 134, '2015-01-15 00:57:36.000000', 'consum', 0.0317, 'lps'),
	(657363, 134, '2015-01-15 00:57:37.000000', 'consum', 0.0232, 'lps'),
	(657364, 134, '2015-01-15 00:57:38.000000', 'consum', 0.0316, 'lps'),
	(657365, 134, '2015-01-15 00:57:39.000000', 'consum', 0.0360, 'lps'),
	(657366, 134, '2015-01-15 00:57:40.000000', 'consum', 0.0327, 'lps'),
	(657367, 134, '2015-01-15 00:57:41.000000', 'consum', 0.0346, 'lps'),
	(657368, 134, '2015-01-15 00:57:42.000000', 'consum', 0.0221, 'lps'),
	(657369, 134, '2015-01-15 00:57:43.000000', 'consum', 0.0333, 'lps'),
	(657370, 134, '2015-01-15 00:57:44.000000', 'consum', 0.0317, 'lps'),
	(657371, 134, '2015-01-15 00:57:45.000000', 'consum', 0.0219, 'lps'),
	(657372, 134, '2015-01-15 00:57:46.000000', 'consum', 0.0253, 'lps'),
	(657373, 134, '2015-01-15 00:57:47.000000', 'consum', 0.0237, 'lps'),
	(657374, 134, '2015-01-15 00:57:48.000000', 'consum', 0.0219, 'lps'),
	(657375, 134, '2015-01-15 00:57:49.000000', 'consum', 0.0332, 'lps'),
	(657376, 134, '2015-01-15 00:57:50.000000', 'consum', 0.0321, 'lps'),
	(657377, 134, '2015-01-15 00:57:51.000000', 'consum', 0.0242, 'lps'),
	(657378, 134, '2015-01-15 00:57:52.000000', 'consum', 0.0352, 'lps'),
	(657379, 134, '2015-01-15 00:57:53.000000', 'consum', 0.0350, 'lps'),
	(657380, 134, '2015-01-15 00:57:54.000000', 'consum', 0.0327, 'lps'),
	(657381, 134, '2015-01-15 00:57:55.000000', 'consum', 0.0219, 'lps'),
	(657382, 134, '2015-01-15 00:57:56.000000', 'consum', 0.0220, 'lps'),
	(657383, 134, '2015-01-15 00:57:57.000000', 'consum', 0.0231, 'lps'),
	(657384, 134, '2015-01-15 00:57:58.000000', 'consum', 0.0288, 'lps'),
	(657385, 134, '2015-01-15 00:57:59.000000', 'consum', 0.0219, 'lps'),
	(657386, 134, '2015-01-15 00:58:00.000000', 'consum', 0.0339, 'lps'),
	(657387, 134, '2015-01-15 00:58:01.000000', 'consum', 0.0353, 'lps'),
	(657388, 134, '2015-01-15 00:58:02.000000', 'consum', 0.0223, 'lps'),
	(657389, 134, '2015-01-15 00:58:03.000000', 'consum', 0.0320, 'lps'),
	(657390, 134, '2015-01-15 00:58:04.000000', 'consum', 0.0247, 'lps'),
	(657391, 134, '2015-01-15 00:58:05.000000', 'consum', 0.0222, 'lps'),
	(657392, 134, '2015-01-15 00:58:06.000000', 'consum', 0.0320, 'lps'),
	(657393, 134, '2015-01-15 00:58:07.000000', 'consum', 0.0250, 'lps'),
	(657394, 134, '2015-01-15 00:58:08.000000', 'consum', 0.0240, 'lps'),
	(657395, 134, '2015-01-15 00:58:09.000000', 'consum', 0.0238, 'lps'),
	(657396, 134, '2015-01-15 00:58:10.000000', 'consum', 0.0263, 'lps'),
	(657397, 134, '2015-01-15 00:58:11.000000', 'consum', 0.0232, 'lps'),
	(657398, 134, '2015-01-15 00:58:12.000000', 'consum', 0.0321, 'lps'),
	(657399, 134, '2015-01-15 00:58:13.000000', 'consum', 0.0225, 'lps'),
	(657400, 134, '2015-01-15 00:58:14.000000', 'consum', 0.0270, 'lps'),
	(657401, 134, '2015-01-15 00:58:15.000000', 'consum', 0.0308, 'lps'),
	(657402, 134, '2015-01-15 00:58:16.000000', 'consum', 0.0361, 'lps'),
	(657403, 134, '2015-01-15 00:58:17.000000', 'consum', 0.0356, 'lps'),
	(657404, 134, '2015-01-15 00:58:18.000000', 'consum', 0.0328, 'lps'),
	(657405, 134, '2015-01-15 00:58:19.000000', 'consum', 0.0362, 'lps'),
	(657406, 134, '2015-01-15 00:58:20.000000', 'consum', 0.0300, 'lps'),
	(657407, 134, '2015-01-15 00:58:21.000000', 'consum', 0.0363, 'lps'),
	(657408, 134, '2015-01-15 00:58:22.000000', 'consum', 0.0234, 'lps'),
	(657409, 134, '2015-01-15 00:58:23.000000', 'consum', 0.0344, 'lps'),
	(657410, 134, '2015-01-15 00:58:24.000000', 'consum', 0.0333, 'lps'),
	(657411, 134, '2015-01-15 00:58:25.000000', 'consum', 0.0266, 'lps'),
	(657412, 134, '2015-01-15 00:58:26.000000', 'consum', 0.0278, 'lps'),
	(657413, 134, '2015-01-15 00:58:27.000000', 'consum', 0.0228, 'lps'),
	(657414, 134, '2015-01-15 00:58:28.000000', 'consum', 0.0252, 'lps'),
	(657415, 134, '2015-01-15 00:58:29.000000', 'consum', 0.0367, 'lps'),
	(657416, 134, '2015-01-15 00:58:30.000000', 'consum', 0.0237, 'lps'),
	(657417, 134, '2015-01-15 00:58:31.000000', 'consum', 0.0348, 'lps'),
	(657418, 134, '2015-01-15 00:58:32.000000', 'consum', 0.0347, 'lps'),
	(657419, 134, '2015-01-15 00:58:33.000000', 'consum', 0.0324, 'lps'),
	(657420, 134, '2015-01-15 00:58:34.000000', 'consum', 0.0210, 'lps'),
	(657421, 134, '2015-01-15 00:58:35.000000', 'consum', 0.0343, 'lps'),
	(657422, 134, '2015-01-15 00:58:36.000000', 'consum', 0.0244, 'lps'),
	(657423, 134, '2015-01-15 00:58:37.000000', 'consum', 0.0297, 'lps'),
	(657424, 134, '2015-01-15 00:58:38.000000', 'consum', 0.0229, 'lps'),
	(657425, 134, '2015-01-15 00:58:39.000000', 'consum', 0.0358, 'lps'),
	(657426, 134, '2015-01-15 00:58:40.000000', 'consum', 0.0261, 'lps'),
	(657427, 134, '2015-01-15 00:58:41.000000', 'consum', 0.0337, 'lps'),
	(657428, 134, '2015-01-15 00:58:42.000000', 'consum', 0.0217, 'lps'),
	(657429, 134, '2015-01-15 00:58:43.000000', 'consum', 0.0342, 'lps'),
	(657430, 134, '2015-01-15 00:58:44.000000', 'consum', 0.0218, 'lps'),
	(657431, 134, '2015-01-15 00:58:45.000000', 'consum', 0.0327, 'lps'),
	(657432, 134, '2015-01-15 00:58:46.000000', 'consum', 0.0299, 'lps'),
	(657433, 134, '2015-01-15 00:58:47.000000', 'consum', 0.0302, 'lps'),
	(657434, 134, '2015-01-15 00:58:48.000000', 'consum', 0.0248, 'lps'),
	(657435, 134, '2015-01-15 00:58:49.000000', 'consum', 0.0283, 'lps'),
	(657436, 134, '2015-01-15 00:58:50.000000', 'consum', 0.0303, 'lps'),
	(657437, 134, '2015-01-15 00:58:51.000000', 'consum', 0.0297, 'lps'),
	(657438, 134, '2015-01-15 00:58:52.000000', 'consum', 0.0211, 'lps'),
	(657439, 134, '2015-01-15 00:58:53.000000', 'consum', 0.0271, 'lps'),
	(657440, 134, '2015-01-15 00:58:54.000000', 'consum', 0.0353, 'lps'),
	(657441, 134, '2015-01-15 00:58:55.000000', 'consum', 0.0271, 'lps'),
	(657442, 134, '2015-01-15 00:58:56.000000', 'consum', 0.0241, 'lps'),
	(657443, 134, '2015-01-15 00:58:57.000000', 'consum', 0.0343, 'lps'),
	(657444, 134, '2015-01-15 00:58:58.000000', 'consum', 0.0306, 'lps'),
	(657445, 134, '2015-01-15 00:58:59.000000', 'consum', 0.0291, 'lps'),
	(657446, 134, '2015-01-15 00:59:00.000000', 'consum', 0.0331, 'lps'),
	(657447, 134, '2015-01-15 00:59:01.000000', 'consum', 0.0253, 'lps'),
	(657448, 134, '2015-01-15 00:59:02.000000', 'consum', 0.0223, 'lps'),
	(657449, 134, '2015-01-15 00:59:03.000000', 'consum', 0.0305, 'lps'),
	(657450, 134, '2015-01-15 00:59:04.000000', 'consum', 0.0328, 'lps'),
	(657451, 134, '2015-01-15 00:59:05.000000', 'consum', 0.0357, 'lps'),
	(657452, 134, '2015-01-15 00:59:06.000000', 'consum', 0.0277, 'lps'),
	(657453, 134, '2015-01-15 00:59:07.000000', 'consum', 0.0261, 'lps'),
	(657454, 134, '2015-01-15 00:59:08.000000', 'consum', 0.0264, 'lps'),
	(657455, 134, '2015-01-15 00:59:09.000000', 'consum', 0.0328, 'lps'),
	(657456, 134, '2015-01-15 00:59:10.000000', 'consum', 0.0321, 'lps'),
	(657457, 134, '2015-01-15 00:59:11.000000', 'consum', 0.0256, 'lps'),
	(657458, 134, '2015-01-15 00:59:12.000000', 'consum', 0.0263, 'lps'),
	(657459, 134, '2015-01-15 00:59:13.000000', 'consum', 0.0341, 'lps'),
	(657460, 134, '2015-01-15 00:59:14.000000', 'consum', 0.0229, 'lps'),
	(657461, 134, '2015-01-15 00:59:15.000000', 'consum', 0.0232, 'lps'),
	(657462, 134, '2015-01-15 00:59:16.000000', 'consum', 0.0261, 'lps'),
	(657463, 134, '2015-01-15 00:59:17.000000', 'consum', 0.0244, 'lps'),
	(657464, 134, '2015-01-15 00:59:18.000000', 'consum', 0.0225, 'lps'),
	(657465, 134, '2015-01-15 00:59:19.000000', 'consum', 0.0343, 'lps'),
	(657466, 134, '2015-01-15 00:59:20.000000', 'consum', 0.0357, 'lps'),
	(657467, 134, '2015-01-15 00:59:21.000000', 'consum', 0.0231, 'lps'),
	(657468, 134, '2015-01-15 00:59:22.000000', 'consum', 0.0348, 'lps'),
	(657469, 134, '2015-01-15 00:59:23.000000', 'consum', 0.0365, 'lps'),
	(657470, 134, '2015-01-15 00:59:24.000000', 'consum', 0.0255, 'lps'),
	(657471, 134, '2015-01-15 00:59:25.000000', 'consum', 0.0288, 'lps'),
	(657472, 134, '2015-01-15 00:59:26.000000', 'consum', 0.0305, 'lps'),
	(657473, 134, '2015-01-15 00:59:27.000000', 'consum', 0.0295, 'lps'),
	(657474, 134, '2015-01-15 00:59:28.000000', 'consum', 0.0348, 'lps'),
	(657475, 134, '2015-01-15 00:59:29.000000', 'consum', 0.0331, 'lps'),
	(657476, 134, '2015-01-15 00:59:30.000000', 'consum', 0.0243, 'lps'),
	(657477, 134, '2015-01-15 00:59:31.000000', 'consum', 0.0327, 'lps'),
	(657478, 134, '2015-01-15 00:59:32.000000', 'consum', 0.0223, 'lps'),
	(657479, 134, '2015-01-15 00:59:33.000000', 'consum', 0.0242, 'lps'),
	(657480, 134, '2015-01-15 00:59:34.000000', 'consum', 0.0331, 'lps'),
	(657481, 134, '2015-01-15 00:59:35.000000', 'consum', 0.0246, 'lps'),
	(657482, 134, '2015-01-15 00:59:36.000000', 'consum', 0.0343, 'lps'),
	(657483, 134, '2015-01-15 00:59:37.000000', 'consum', 0.0293, 'lps'),
	(657484, 134, '2015-01-15 00:59:38.000000', 'consum', 0.0226, 'lps'),
	(657485, 134, '2015-01-15 00:59:39.000000', 'consum', 0.0359, 'lps'),
	(657486, 134, '2015-01-15 00:59:40.000000', 'consum', 0.0273, 'lps'),
	(657487, 134, '2015-01-15 00:59:41.000000', 'consum', 0.0238, 'lps'),
	(657488, 134, '2015-01-15 00:59:42.000000', 'consum', 0.0319, 'lps'),
	(657489, 134, '2015-01-15 00:59:43.000000', 'consum', 0.0358, 'lps'),
	(657490, 134, '2015-01-15 00:59:44.000000', 'consum', 0.0304, 'lps'),
	(657491, 134, '2015-01-15 00:59:45.000000', 'consum', 0.0239, 'lps'),
	(657492, 134, '2015-01-15 00:59:46.000000', 'consum', 0.0231, 'lps'),
	(657493, 134, '2015-01-15 00:59:47.000000', 'consum', 0.0228, 'lps'),
	(657494, 134, '2015-01-15 00:59:48.000000', 'consum', 0.0238, 'lps'),
	(657495, 134, '2015-01-15 00:59:49.000000', 'consum', 0.0297, 'lps'),
	(657496, 134, '2015-01-15 00:59:50.000000', 'consum', 0.0243, 'lps'),
	(657497, 134, '2015-01-15 00:59:51.000000', 'consum', 0.0274, 'lps'),
	(657498, 134, '2015-01-15 00:59:52.000000', 'consum', 0.0275, 'lps'),
	(657499, 134, '2015-01-15 00:59:53.000000', 'consum', 0.0340, 'lps'),
	(657500, 134, '2015-01-15 00:59:54.000000', 'consum', 0.0352, 'lps'),
	(657501, 134, '2015-01-15 00:59:55.000000', 'consum', 0.0215, 'lps'),
	(657502, 134, '2015-01-15 00:59:56.000000', 'consum', 0.0284, 'lps'),
	(657503, 134, '2015-01-15 00:59:57.000000', 'consum', 0.0250, 'lps'),
	(657504, 134, '2015-01-15 00:59:58.000000', 'consum', 0.0346, 'lps'),
	(657505, 134, '2015-01-15 00:59:59.000000', 'consum', 0.0297, 'lps'),
	(657506, 134, '2015-01-15 01:00:00.000000', 'consum', 0.0236, 'lps'),
	(657507, 134, '2015-01-15 01:00:01.000000', 'consum', 0.0240, 'lps'),
	(657508, 134, '2015-01-15 01:00:02.000000', 'consum', 0.0281, 'lps'),
	(657509, 134, '2015-01-15 01:00:03.000000', 'consum', 0.0318, 'lps'),
	(657510, 134, '2015-01-15 01:00:04.000000', 'consum', 0.0222, 'lps'),
	(657511, 134, '2015-01-15 01:00:05.000000', 'consum', 0.0262, 'lps'),
	(657512, 134, '2015-01-15 01:00:06.000000', 'consum', 0.0275, 'lps'),
	(657513, 134, '2015-01-15 01:00:07.000000', 'consum', 0.0221, 'lps'),
	(657514, 134, '2015-01-15 01:00:08.000000', 'consum', 0.0228, 'lps'),
	(657515, 134, '2015-01-15 01:00:09.000000', 'consum', 0.0267, 'lps'),
	(657516, 134, '2015-01-15 01:00:10.000000', 'consum', 0.0285, 'lps'),
	(657517, 134, '2015-01-15 01:00:11.000000', 'consum', 0.0257, 'lps'),
	(657518, 134, '2015-01-15 01:00:12.000000', 'consum', 0.0219, 'lps'),
	(657519, 134, '2015-01-15 01:00:13.000000', 'consum', 0.0273, 'lps'),
	(657520, 134, '2015-01-15 01:00:14.000000', 'consum', 0.0342, 'lps'),
	(657521, 134, '2015-01-15 01:00:15.000000', 'consum', 0.0367, 'lps'),
	(657522, 134, '2015-01-15 01:00:16.000000', 'consum', 0.0280, 'lps'),
	(657523, 134, '2015-01-15 01:00:17.000000', 'consum', 0.0250, 'lps'),
	(657524, 134, '2015-01-15 01:00:18.000000', 'consum', 0.0359, 'lps'),
	(657525, 134, '2015-01-15 01:00:19.000000', 'consum', 0.0360, 'lps'),
	(657526, 134, '2015-01-15 01:00:20.000000', 'consum', 0.0357, 'lps'),
	(657527, 134, '2015-01-15 01:00:21.000000', 'consum', 0.0336, 'lps'),
	(657528, 134, '2015-01-15 01:00:22.000000', 'consum', 0.0242, 'lps'),
	(657529, 134, '2015-01-15 01:00:23.000000', 'consum', 0.0309, 'lps'),
	(657530, 134, '2015-01-15 01:00:24.000000', 'consum', 0.0295, 'lps'),
	(657531, 134, '2015-01-15 01:00:25.000000', 'consum', 0.0338, 'lps'),
	(657532, 134, '2015-01-15 01:00:26.000000', 'consum', 0.0281, 'lps'),
	(657533, 134, '2015-01-15 01:00:27.000000', 'consum', 0.0337, 'lps'),
	(657534, 134, '2015-01-15 01:00:28.000000', 'consum', 0.0319, 'lps'),
	(657535, 134, '2015-01-15 01:00:29.000000', 'consum', 0.0214, 'lps'),
	(657536, 134, '2015-01-15 01:00:30.000000', 'consum', 0.0221, 'lps'),
	(657537, 134, '2015-01-15 01:00:31.000000', 'consum', 0.0252, 'lps'),
	(657538, 134, '2015-01-15 01:00:32.000000', 'consum', 0.0232, 'lps'),
	(657539, 134, '2015-01-15 01:00:33.000000', 'consum', 0.0351, 'lps'),
	(657540, 134, '2015-01-15 01:00:34.000000', 'consum', 0.0219, 'lps'),
	(657541, 134, '2015-01-15 01:00:35.000000', 'consum', 0.0306, 'lps'),
	(657542, 134, '2015-01-15 01:00:36.000000', 'consum', 0.0348, 'lps'),
	(657543, 134, '2015-01-15 01:00:37.000000', 'consum', 0.0297, 'lps'),
	(657544, 134, '2015-01-15 01:00:38.000000', 'consum', 0.0229, 'lps'),
	(657545, 134, '2015-01-15 01:00:39.000000', 'consum', 0.0364, 'lps'),
	(657546, 134, '2015-01-15 01:00:40.000000', 'consum', 0.0288, 'lps'),
	(657547, 134, '2015-01-15 01:00:41.000000', 'consum', 0.0297, 'lps'),
	(657548, 134, '2015-01-15 01:00:42.000000', 'consum', 0.0254, 'lps'),
	(657549, 134, '2015-01-15 01:00:43.000000', 'consum', 0.0328, 'lps'),
	(657550, 134, '2015-01-15 01:00:44.000000', 'consum', 0.0354, 'lps'),
	(657551, 134, '2015-01-15 01:00:45.000000', 'consum', 0.0258, 'lps'),
	(657552, 134, '2015-01-15 01:00:46.000000', 'consum', 0.0335, 'lps'),
	(657553, 134, '2015-01-15 01:00:47.000000', 'consum', 0.0217, 'lps'),
	(657554, 134, '2015-01-15 01:00:48.000000', 'consum', 0.0347, 'lps'),
	(657555, 134, '2015-01-15 01:00:49.000000', 'consum', 0.0240, 'lps'),
	(657556, 134, '2015-01-15 01:00:50.000000', 'consum', 0.0267, 'lps'),
	(657557, 134, '2015-01-15 01:00:51.000000', 'consum', 0.0248, 'lps'),
	(657558, 134, '2015-01-15 01:00:52.000000', 'consum', 0.0229, 'lps'),
	(657559, 134, '2015-01-15 01:00:53.000000', 'consum', 0.0347, 'lps'),
	(657560, 134, '2015-01-15 01:00:54.000000', 'consum', 0.0367, 'lps'),
	(657561, 134, '2015-01-15 01:00:55.000000', 'consum', 0.0270, 'lps'),
	(657562, 134, '2015-01-15 01:00:56.000000', 'consum', 0.0353, 'lps'),
	(657563, 134, '2015-01-15 01:00:57.000000', 'consum', 0.0273, 'lps'),
	(657564, 134, '2015-01-15 01:00:58.000000', 'consum', 0.0255, 'lps'),
	(657565, 134, '2015-01-15 01:00:59.000000', 'consum', 0.0246, 'lps'),
	(657566, 134, '2015-01-15 01:01:00.000000', 'consum', 0.0253, 'lps'),
	(657567, 134, '2015-01-15 01:01:01.000000', 'consum', 0.0320, 'lps'),
	(657568, 134, '2015-01-15 01:01:02.000000', 'consum', 0.0316, 'lps'),
	(657569, 134, '2015-01-15 01:01:03.000000', 'consum', 0.0253, 'lps'),
	(657570, 134, '2015-01-15 01:01:04.000000', 'consum', 0.0267, 'lps'),
	(657571, 134, '2015-01-15 01:01:05.000000', 'consum', 0.0363, 'lps'),
	(657572, 134, '2015-01-15 01:01:06.000000', 'consum', 0.0332, 'lps'),
	(657573, 134, '2015-01-15 01:01:07.000000', 'consum', 0.0360, 'lps'),
	(657574, 134, '2015-01-15 01:01:08.000000', 'consum', 0.0279, 'lps'),
	(657575, 134, '2015-01-15 01:01:09.000000', 'consum', 0.0264, 'lps'),
	(657576, 134, '2015-01-15 01:01:10.000000', 'consum', 0.0273, 'lps'),
	(657577, 134, '2015-01-15 01:01:11.000000', 'consum', 0.0363, 'lps'),
	(657578, 134, '2015-01-15 01:01:12.000000', 'consum', 0.0311, 'lps'),
	(657579, 134, '2015-01-15 01:01:13.000000', 'consum', 0.0258, 'lps'),
	(657580, 134, '2015-01-15 01:01:14.000000', 'consum', 0.0304, 'lps'),
	(657581, 134, '2015-01-15 01:01:15.000000', 'consum', 0.0219, 'lps'),
	(657582, 134, '2015-01-15 01:01:16.000000', 'consum', 0.0293, 'lps'),
	(657583, 134, '2015-01-15 01:01:17.000000', 'consum', 0.0281, 'lps'),
	(657584, 134, '2015-01-15 01:01:18.000000', 'consum', 0.0318, 'lps'),
	(657585, 134, '2015-01-15 01:01:19.000000', 'consum', 0.0222, 'lps'),
	(657586, 134, '2015-01-15 01:01:20.000000', 'consum', 0.0262, 'lps'),
	(657587, 134, '2015-01-15 01:01:21.000000', 'consum', 0.0274, 'lps'),
	(657588, 134, '2015-01-15 01:01:22.000000', 'consum', 0.0218, 'lps'),
	(657589, 134, '2015-01-15 01:01:23.000000', 'consum', 0.0218, 'lps'),
	(657590, 134, '2015-01-15 01:01:24.000000', 'consum', 0.0226, 'lps'),
	(657591, 134, '2015-01-15 01:01:25.000000', 'consum', 0.0268, 'lps'),
	(657592, 134, '2015-01-15 01:01:26.000000', 'consum', 0.0293, 'lps'),
	(657593, 134, '2015-01-15 01:01:27.000000', 'consum', 0.0294, 'lps'),
	(657594, 134, '2015-01-15 01:01:28.000000', 'consum', 0.0224, 'lps'),
	(657595, 134, '2015-01-15 01:01:29.000000', 'consum', 0.0344, 'lps'),
	(657596, 134, '2015-01-15 01:01:30.000000', 'consum', 0.0364, 'lps'),
	(657597, 134, '2015-01-15 01:01:31.000000', 'consum', 0.0262, 'lps'),
	(657598, 134, '2015-01-15 01:01:32.000000', 'consum', 0.0325, 'lps'),
	(657599, 134, '2015-01-15 01:01:33.000000', 'consum', 0.0313, 'lps'),
	(657600, 134, '2015-01-15 01:01:34.000000', 'consum', 0.0223, 'lps'),
	(657601, 134, '2015-01-15 01:01:35.000000', 'consum', 0.0284, 'lps'),
	(657602, 134, '2015-01-15 01:01:36.000000', 'consum', 0.0226, 'lps'),
	(657603, 134, '2015-01-15 01:01:37.000000', 'consum', 0.0224, 'lps'),
	(657604, 134, '2015-01-15 01:01:38.000000', 'consum', 0.0235, 'lps'),
	(657605, 134, '2015-01-15 01:01:39.000000', 'consum', 0.0292, 'lps'),
	(657606, 134, '2015-01-15 01:01:40.000000', 'consum', 0.0231, 'lps'),
	(657607, 134, '2015-01-15 01:01:41.000000', 'consum', 0.0226, 'lps'),
	(657608, 134, '2015-01-15 01:01:42.000000', 'consum', 0.0227, 'lps'),
	(657609, 134, '2015-01-15 01:01:43.000000', 'consum', 0.0248, 'lps'),
	(657610, 134, '2015-01-15 01:01:44.000000', 'consum', 0.0352, 'lps'),
	(657611, 134, '2015-01-15 01:01:45.000000', 'consum', 0.0330, 'lps'),
	(657612, 134, '2015-01-15 01:01:46.000000', 'consum', 0.0226, 'lps'),
	(657613, 134, '2015-01-15 01:01:47.000000', 'consum', 0.0247, 'lps'),
	(657614, 134, '2015-01-15 01:01:48.000000', 'consum', 0.0347, 'lps'),
	(657615, 134, '2015-01-15 01:01:49.000000', 'consum', 0.0313, 'lps'),
	(657616, 134, '2015-01-15 01:01:50.000000', 'consum', 0.0313, 'lps'),
	(657617, 134, '2015-01-15 01:01:51.000000', 'consum', 0.0258, 'lps'),
	(657618, 134, '2015-01-15 01:01:52.000000', 'consum', 0.0299, 'lps'),
	(657619, 134, '2015-01-15 01:01:53.000000', 'consum', 0.0355, 'lps'),
	(657620, 134, '2015-01-15 01:01:54.000000', 'consum', 0.0353, 'lps'),
	(657621, 134, '2015-01-15 01:01:55.000000', 'consum', 0.0331, 'lps'),
	(657622, 134, '2015-01-15 01:01:56.000000', 'consum', 0.0229, 'lps'),
	(657623, 134, '2015-01-15 01:01:57.000000', 'consum', 0.0259, 'lps'),
	(657624, 134, '2015-01-15 01:01:58.000000', 'consum', 0.0241, 'lps'),
	(657625, 134, '2015-01-15 01:01:59.000000', 'consum', 0.0218, 'lps'),
	(657626, 134, '2015-01-15 01:02:00.000000', 'consum', 0.0315, 'lps'),
	(657627, 134, '2015-01-15 01:02:01.000000', 'consum', 0.0236, 'lps'),
	(657628, 134, '2015-01-15 01:02:02.000000', 'consum', 0.0343, 'lps'),
	(657629, 134, '2015-01-15 01:02:03.000000', 'consum', 0.0325, 'lps'),
	(657630, 134, '2015-01-15 01:02:04.000000', 'consum', 0.0226, 'lps'),
	(657631, 134, '2015-01-15 01:02:05.000000', 'consum', 0.0262, 'lps'),
	(657632, 134, '2015-01-15 01:02:06.000000', 'consum', 0.0264, 'lps'),
	(657633, 134, '2015-01-15 01:02:07.000000', 'consum', 0.0327, 'lps'),
	(657634, 134, '2015-01-15 01:02:08.000000', 'consum', 0.0317, 'lps'),
	(657635, 134, '2015-01-15 01:02:09.000000', 'consum', 0.0234, 'lps'),
	(657636, 134, '2015-01-15 01:02:10.000000', 'consum', 0.0328, 'lps'),
	(657637, 134, '2015-01-15 01:02:11.000000', 'consum', 0.0253, 'lps'),
	(657638, 134, '2015-01-15 01:02:12.000000', 'consum', 0.0229, 'lps'),
	(657639, 134, '2015-01-15 01:02:13.000000', 'consum', 0.0334, 'lps'),
	(657640, 134, '2015-01-15 01:02:14.000000', 'consum', 0.0302, 'lps'),
	(657641, 134, '2015-01-15 01:02:15.000000', 'consum', 0.0298, 'lps'),
	(657642, 134, '2015-01-15 01:02:16.000000', 'consum', 0.0216, 'lps'),
	(657643, 134, '2015-01-15 01:02:17.000000', 'consum', 0.0292, 'lps'),
	(657644, 134, '2015-01-15 01:02:18.000000', 'consum', 0.0287, 'lps'),
	(657645, 134, '2015-01-15 01:02:19.000000', 'consum', 0.0351, 'lps'),
	(657646, 134, '2015-01-15 01:02:20.000000', 'consum', 0.0210, 'lps'),
	(657647, 134, '2015-01-15 01:02:21.000000', 'consum', 0.0262, 'lps'),
	(657648, 134, '2015-01-15 01:02:22.000000', 'consum', 0.0311, 'lps'),
	(657649, 134, '2015-01-15 01:02:23.000000', 'consum', 0.0245, 'lps'),
	(657650, 134, '2015-01-15 01:02:24.000000', 'consum', 0.0239, 'lps'),
	(657651, 134, '2015-01-15 01:02:25.000000', 'consum', 0.0249, 'lps'),
	(657652, 134, '2015-01-15 01:02:26.000000', 'consum', 0.0320, 'lps'),
	(657653, 134, '2015-01-15 01:02:27.000000', 'consum', 0.0328, 'lps'),
	(657654, 134, '2015-01-15 01:02:28.000000', 'consum', 0.0311, 'lps'),
	(657655, 134, '2015-01-15 01:02:29.000000', 'consum', 0.0363, 'lps'),
	(657656, 134, '2015-01-15 01:02:30.000000', 'consum', 0.0357, 'lps'),
	(657657, 134, '2015-01-15 01:02:31.000000', 'consum', 0.0328, 'lps'),
	(657658, 134, '2015-01-15 01:02:32.000000', 'consum', 0.0358, 'lps'),
	(657659, 134, '2015-01-15 01:02:33.000000', 'consum', 0.0283, 'lps'),
	(657660, 134, '2015-01-15 01:02:34.000000', 'consum', 0.0289, 'lps'),
	(657661, 134, '2015-01-15 01:02:35.000000', 'consum', 0.0226, 'lps'),
	(657662, 134, '2015-01-15 01:02:36.000000', 'consum', 0.0213, 'lps'),
	(657663, 134, '2015-01-15 01:02:37.000000', 'consum', 0.0335, 'lps'),
	(657664, 134, '2015-01-15 01:02:38.000000', 'consum', 0.0354, 'lps'),
	(657665, 134, '2015-01-15 01:02:39.000000', 'consum', 0.0240, 'lps'),
	(657666, 134, '2015-01-15 01:02:40.000000', 'consum', 0.0245, 'lps'),
	(657667, 134, '2015-01-15 01:02:41.000000', 'consum', 0.0293, 'lps'),
	(657668, 134, '2015-01-15 01:02:42.000000', 'consum', 0.0363, 'lps'),
	(657669, 134, '2015-01-15 01:02:43.000000', 'consum', 0.0251, 'lps'),
	(657670, 134, '2015-01-15 01:02:44.000000', 'consum', 0.0275, 'lps'),
	(657671, 134, '2015-01-15 01:02:45.000000', 'consum', 0.0255, 'lps'),
	(657672, 134, '2015-01-15 01:02:46.000000', 'consum', 0.0238, 'lps'),
	(657673, 134, '2015-01-15 01:02:47.000000', 'consum', 0.0215, 'lps'),
	(657674, 134, '2015-01-15 01:02:48.000000', 'consum', 0.0310, 'lps'),
	(657675, 134, '2015-01-15 01:02:49.000000', 'consum', 0.0222, 'lps'),
	(657676, 134, '2015-01-15 01:02:50.000000', 'consum', 0.0285, 'lps'),
	(657677, 134, '2015-01-15 01:02:51.000000', 'consum', 0.0237, 'lps'),
	(657678, 134, '2015-01-15 01:02:52.000000', 'consum', 0.0275, 'lps'),
	(657679, 134, '2015-01-15 01:02:53.000000', 'consum', 0.0298, 'lps'),
	(657680, 134, '2015-01-15 01:02:54.000000', 'consum', 0.0299, 'lps'),
	(657681, 134, '2015-01-15 01:02:55.000000', 'consum', 0.0234, 'lps'),
	(657682, 134, '2015-01-15 01:02:56.000000', 'consum', 0.0221, 'lps'),
	(657683, 134, '2015-01-15 01:02:57.000000', 'consum', 0.0351, 'lps'),
	(657684, 134, '2015-01-15 01:02:58.000000', 'consum', 0.0249, 'lps'),
	(657685, 134, '2015-01-15 01:02:59.000000', 'consum', 0.0302, 'lps'),
	(657686, 134, '2015-01-15 01:03:00.000000', 'consum', 0.0234, 'lps'),
	(657687, 134, '2015-01-15 01:03:01.000000', 'consum', 0.0214, 'lps'),
	(657688, 134, '2015-01-15 01:03:02.000000', 'consum', 0.0316, 'lps'),
	(657689, 134, '2015-01-15 01:03:03.000000', 'consum', 0.0256, 'lps'),
	(657690, 134, '2015-01-15 01:03:04.000000', 'consum', 0.0278, 'lps'),
	(657691, 134, '2015-01-15 01:03:05.000000', 'consum', 0.0255, 'lps'),
	(657692, 134, '2015-01-15 01:03:06.000000', 'consum', 0.0231, 'lps'),
	(657693, 134, '2015-01-15 01:03:07.000000', 'consum', 0.0340, 'lps'),
	(657694, 134, '2015-01-15 01:03:08.000000', 'consum', 0.0323, 'lps'),
	(657695, 134, '2015-01-15 01:03:09.000000', 'consum', 0.0226, 'lps'),
	(657696, 134, '2015-01-15 01:03:10.000000', 'consum', 0.0268, 'lps'),
	(657697, 134, '2015-01-15 01:03:11.000000', 'consum', 0.0297, 'lps'),
	(657698, 134, '2015-01-15 01:03:12.000000', 'consum', 0.0311, 'lps'),
	(657699, 134, '2015-01-15 01:03:13.000000', 'consum', 0.0295, 'lps'),
	(657700, 134, '2015-01-15 01:03:14.000000', 'consum', 0.0335, 'lps'),
	(657701, 134, '2015-01-15 01:03:15.000000', 'consum', 0.0263, 'lps'),
	(657702, 134, '2015-01-15 01:03:16.000000', 'consum', 0.0259, 'lps'),
	(657703, 134, '2015-01-15 01:03:17.000000', 'consum', 0.0298, 'lps'),
	(657704, 134, '2015-01-15 01:03:18.000000', 'consum', 0.0343, 'lps'),
	(657705, 134, '2015-01-15 01:03:19.000000', 'consum', 0.0297, 'lps'),
	(657706, 134, '2015-01-15 01:03:20.000000', 'consum', 0.0248, 'lps'),
	(657707, 134, '2015-01-15 01:03:21.000000', 'consum', 0.0297, 'lps'),
	(657708, 134, '2015-01-15 01:03:22.000000', 'consum', 0.0215, 'lps'),
	(657709, 134, '2015-01-15 01:03:23.000000', 'consum', 0.0291, 'lps'),
	(657710, 134, '2015-01-15 01:03:24.000000', 'consum', 0.0284, 'lps'),
	(657711, 134, '2015-01-15 01:03:25.000000', 'consum', 0.0338, 'lps'),
	(657712, 134, '2015-01-15 01:03:26.000000', 'consum', 0.0312, 'lps'),
	(657713, 134, '2015-01-15 01:03:27.000000', 'consum', 0.0337, 'lps'),
	(657714, 134, '2015-01-15 01:03:28.000000', 'consum', 0.0222, 'lps'),
	(657715, 134, '2015-01-15 01:03:29.000000', 'consum', 0.0363, 'lps'),
	(657716, 134, '2015-01-15 01:03:30.000000', 'consum', 0.0307, 'lps'),
	(657717, 134, '2015-01-15 01:03:31.000000', 'consum', 0.0239, 'lps'),
	(657718, 134, '2015-01-15 01:03:32.000000', 'consum', 0.0220, 'lps'),
	(657719, 134, '2015-01-15 01:03:33.000000', 'consum', 0.0335, 'lps'),
	(657720, 134, '2015-01-15 01:03:34.000000', 'consum', 0.0328, 'lps'),
	(657721, 134, '2015-01-15 01:03:35.000000', 'consum', 0.0269, 'lps'),
	(657722, 134, '2015-01-15 01:03:36.000000', 'consum', 0.0308, 'lps'),
	(657723, 134, '2015-01-15 01:03:37.000000', 'consum', 0.0366, 'lps'),
	(657724, 134, '2015-01-15 01:03:38.000000', 'consum', 0.0222, 'lps'),
	(657725, 134, '2015-01-15 01:03:39.000000', 'consum', 0.0276, 'lps'),
	(657726, 134, '2015-01-15 01:03:40.000000', 'consum', 0.0347, 'lps'),
	(657727, 134, '2015-01-15 01:03:41.000000', 'consum', 0.0225, 'lps'),
	(657728, 134, '2015-01-15 01:03:42.000000', 'consum', 0.0347, 'lps'),
	(657729, 134, '2015-01-15 01:03:43.000000', 'consum', 0.0220, 'lps'),
	(657730, 134, '2015-01-15 01:03:44.000000', 'consum', 0.0321, 'lps'),
	(657731, 134, '2015-01-15 01:03:45.000000', 'consum', 0.0262, 'lps'),
	(657732, 134, '2015-01-15 01:03:46.000000', 'consum', 0.0295, 'lps'),
	(657733, 134, '2015-01-15 01:03:47.000000', 'consum', 0.0321, 'lps'),
	(657734, 134, '2015-01-15 01:03:48.000000', 'consum', 0.0352, 'lps'),
	(657735, 134, '2015-01-15 01:03:49.000000', 'consum', 0.0273, 'lps'),
	(657736, 134, '2015-01-15 01:03:50.000000', 'consum', 0.0259, 'lps'),
	(657737, 134, '2015-01-15 01:03:51.000000', 'consum', 0.0265, 'lps'),
	(657738, 134, '2015-01-15 01:03:52.000000', 'consum', 0.0338, 'lps'),
	(657739, 134, '2015-01-15 01:03:53.000000', 'consum', 0.0210, 'lps'),
	(657740, 134, '2015-01-15 01:03:54.000000', 'consum', 0.0303, 'lps'),
	(657741, 134, '2015-01-15 01:03:55.000000', 'consum', 0.0357, 'lps'),
	(657742, 134, '2015-01-15 01:03:56.000000', 'consum', 0.0352, 'lps'),
	(657743, 134, '2015-01-15 01:03:57.000000', 'consum', 0.0321, 'lps'),
	(657744, 134, '2015-01-15 01:03:58.000000', 'consum', 0.0341, 'lps'),
	(657745, 134, '2015-01-15 01:03:59.000000', 'consum', 0.0217, 'lps'),
	(657746, 134, '2015-01-15 01:04:00.000000', 'consum', 0.0327, 'lps'),
	(657747, 134, '2015-01-15 01:04:01.000000', 'consum', 0.0301, 'lps'),
	(657748, 134, '2015-01-15 01:04:02.000000', 'consum', 0.0315, 'lps'),
	(657749, 134, '2015-01-15 01:04:03.000000', 'consum', 0.0302, 'lps'),
	(657750, 134, '2015-01-15 01:04:04.000000', 'consum', 0.0358, 'lps'),
	(657751, 134, '2015-01-15 01:04:05.000000', 'consum', 0.0358, 'lps'),
	(657752, 134, '2015-01-15 01:04:06.000000', 'consum', 0.0349, 'lps'),
	(657753, 134, '2015-01-15 01:04:07.000000', 'consum', 0.0303, 'lps'),
	(657754, 134, '2015-01-15 01:04:08.000000', 'consum', 0.0258, 'lps'),
	(657755, 134, '2015-01-15 01:04:09.000000', 'consum', 0.0328, 'lps'),
	(657756, 134, '2015-01-15 01:04:10.000000', 'consum', 0.0343, 'lps'),
	(657757, 134, '2015-01-15 01:04:11.000000', 'consum', 0.0361, 'lps'),
	(657758, 134, '2015-01-15 01:04:12.000000', 'consum', 0.0251, 'lps'),
	(657759, 134, '2015-01-15 01:04:13.000000', 'consum', 0.0280, 'lps'),
	(657760, 134, '2015-01-15 01:04:14.000000', 'consum', 0.0279, 'lps'),
	(657761, 134, '2015-01-15 01:04:15.000000', 'consum', 0.0346, 'lps'),
	(657762, 134, '2015-01-15 01:04:16.000000', 'consum', 0.0210, 'lps'),
	(657763, 134, '2015-01-15 01:04:17.000000', 'consum', 0.0275, 'lps'),
	(657764, 134, '2015-01-15 01:04:18.000000', 'consum', 0.0219, 'lps'),
	(657765, 134, '2015-01-15 01:04:19.000000', 'consum', 0.0219, 'lps'),
	(657766, 134, '2015-01-15 01:04:20.000000', 'consum', 0.0229, 'lps'),
	(657767, 134, '2015-01-15 01:04:21.000000', 'consum', 0.0277, 'lps'),
	(657768, 134, '2015-01-15 01:04:22.000000', 'consum', 0.0331, 'lps'),
	(657769, 134, '2015-01-15 01:04:23.000000', 'consum', 0.0297, 'lps'),
	(657770, 134, '2015-01-15 01:04:24.000000', 'consum', 0.0285, 'lps'),
	(657771, 134, '2015-01-15 01:04:25.000000', 'consum', 0.0324, 'lps'),
	(657772, 134, '2015-01-15 01:04:26.000000', 'consum', 0.0240, 'lps'),
	(657773, 134, '2015-01-15 01:04:27.000000', 'consum', 0.0333, 'lps'),
	(657774, 134, '2015-01-15 01:04:28.000000', 'consum', 0.0262, 'lps'),
	(657775, 134, '2015-01-15 01:04:29.000000', 'consum', 0.0259, 'lps'),
	(657776, 134, '2015-01-15 01:04:30.000000', 'consum', 0.0300, 'lps'),
	(657777, 134, '2015-01-15 01:04:31.000000', 'consum', 0.0355, 'lps'),
	(657778, 134, '2015-01-15 01:04:32.000000', 'consum', 0.0349, 'lps'),
	(657779, 134, '2015-01-15 01:04:33.000000', 'consum', 0.0312, 'lps'),
	(657780, 134, '2015-01-15 01:04:34.000000', 'consum', 0.0306, 'lps'),
	(657781, 134, '2015-01-15 01:04:35.000000', 'consum', 0.0225, 'lps'),
	(657782, 134, '2015-01-15 01:04:36.000000', 'consum', 0.0314, 'lps'),
	(657783, 134, '2015-01-15 01:04:37.000000', 'consum', 0.0212, 'lps'),
	(657784, 134, '2015-01-15 01:04:38.000000', 'consum', 0.0222, 'lps'),
	(657785, 134, '2015-01-15 01:04:39.000000', 'consum', 0.0267, 'lps'),
	(657786, 134, '2015-01-15 01:04:40.000000', 'consum', 0.0302, 'lps'),
	(657787, 134, '2015-01-15 01:04:41.000000', 'consum', 0.0340, 'lps'),
	(657788, 134, '2015-01-15 01:04:42.000000', 'consum', 0.0267, 'lps'),
	(657789, 134, '2015-01-15 01:04:43.000000', 'consum', 0.0264, 'lps'),
	(657790, 134, '2015-01-15 01:04:44.000000', 'consum', 0.0311, 'lps'),
	(657791, 134, '2015-01-15 01:04:45.000000', 'consum', 0.0239, 'lps'),
	(657792, 134, '2015-01-15 01:04:46.000000', 'consum', 0.0367, 'lps'),
	(657793, 134, '2015-01-15 01:04:47.000000', 'consum', 0.0275, 'lps'),
	(657794, 134, '2015-01-15 01:04:48.000000', 'consum', 0.0225, 'lps'),
	(657795, 134, '2015-01-15 01:04:49.000000', 'consum', 0.0246, 'lps'),
	(657796, 134, '2015-01-15 01:04:50.000000', 'consum', 0.0347, 'lps'),
	(657797, 134, '2015-01-15 01:04:51.000000', 'consum', 0.0313, 'lps'),
	(657798, 134, '2015-01-15 01:04:52.000000', 'consum', 0.0316, 'lps'),
	(657799, 134, '2015-01-15 01:04:53.000000', 'consum', 0.0273, 'lps'),
	(657800, 134, '2015-01-15 01:04:54.000000', 'consum', 0.0366, 'lps'),
	(657801, 134, '2015-01-15 01:04:55.000000', 'consum', 0.0325, 'lps'),
	(657802, 134, '2015-01-15 01:04:56.000000', 'consum', 0.0319, 'lps'),
	(657803, 134, '2015-01-15 01:04:57.000000', 'consum', 0.0254, 'lps'),
	(657804, 134, '2015-01-15 01:04:58.000000', 'consum', 0.0262, 'lps'),
	(657805, 134, '2015-01-15 01:04:59.000000', 'consum', 0.0338, 'lps'),
	(657806, 134, '2015-01-15 01:05:00.000000', 'consum', 0.0218, 'lps'),
	(657807, 134, '2015-01-15 01:05:01.000000', 'consum', 0.0344, 'lps'),
	(657808, 134, '2015-01-15 01:05:02.000000', 'consum', 0.0221, 'lps'),
	(657809, 134, '2015-01-15 01:05:03.000000', 'consum', 0.0339, 'lps'),
	(657810, 134, '2015-01-15 01:05:04.000000', 'consum', 0.0349, 'lps'),
	(657811, 134, '2015-01-15 01:05:05.000000', 'consum', 0.0362, 'lps'),
	(657812, 134, '2015-01-15 01:05:06.000000', 'consum', 0.0237, 'lps'),
	(657813, 134, '2015-01-15 01:05:07.000000', 'consum', 0.0363, 'lps'),
	(657814, 134, '2015-01-15 01:05:08.000000', 'consum', 0.0260, 'lps'),
	(657815, 134, '2015-01-15 01:05:09.000000', 'consum', 0.0321, 'lps'),
	(657816, 134, '2015-01-15 01:05:10.000000', 'consum', 0.0299, 'lps'),
	(657817, 134, '2015-01-15 01:05:11.000000', 'consum', 0.0320, 'lps'),
	(657818, 134, '2015-01-15 01:05:12.000000', 'consum', 0.0337, 'lps'),
	(657819, 134, '2015-01-15 01:05:13.000000', 'consum', 0.0357, 'lps'),
	(657820, 134, '2015-01-15 01:05:14.000000', 'consum', 0.0251, 'lps'),
	(657821, 134, '2015-01-15 01:05:15.000000', 'consum', 0.0287, 'lps'),
	(657822, 134, '2015-01-15 01:05:16.000000', 'consum', 0.0318, 'lps'),
	(657823, 134, '2015-01-15 01:05:17.000000', 'consum', 0.0359, 'lps'),
	(657824, 134, '2015-01-15 01:05:18.000000', 'consum', 0.0317, 'lps'),
	(657825, 134, '2015-01-15 01:05:19.000000', 'consum', 0.0299, 'lps'),
	(657826, 134, '2015-01-15 01:05:20.000000', 'consum', 0.0333, 'lps'),
	(657827, 134, '2015-01-15 01:05:21.000000', 'consum', 0.0243, 'lps'),
	(657828, 134, '2015-01-15 01:05:22.000000', 'consum', 0.0324, 'lps'),
	(657829, 134, '2015-01-15 01:05:23.000000', 'consum', 0.0364, 'lps'),
	(657830, 134, '2015-01-15 01:05:24.000000', 'consum', 0.0324, 'lps'),
	(657831, 134, '2015-01-15 01:05:25.000000', 'consum', 0.0318, 'lps'),
	(657832, 134, '2015-01-15 01:05:26.000000', 'consum', 0.0252, 'lps'),
	(657833, 134, '2015-01-15 01:05:27.000000', 'consum', 0.0253, 'lps'),
	(657834, 134, '2015-01-15 01:05:28.000000', 'consum', 0.0299, 'lps'),
	(657835, 134, '2015-01-15 01:05:29.000000', 'consum', 0.0213, 'lps'),
	(657836, 134, '2015-01-15 01:05:30.000000', 'consum', 0.0273, 'lps'),
	(657837, 134, '2015-01-15 01:05:31.000000', 'consum', 0.0360, 'lps'),
	(657838, 134, '2015-01-15 01:05:32.000000', 'consum', 0.0296, 'lps'),
	(657839, 134, '2015-01-15 01:05:33.000000', 'consum', 0.0351, 'lps'),
	(657840, 134, '2015-01-15 01:05:34.000000', 'consum', 0.0339, 'lps'),
	(657841, 134, '2015-01-15 01:05:35.000000', 'consum', 0.0277, 'lps'),
	(657842, 134, '2015-01-15 01:05:36.000000', 'consum', 0.0315, 'lps'),
	(657843, 134, '2015-01-15 01:05:37.000000', 'consum', 0.0218, 'lps'),
	(657844, 134, '2015-01-15 01:05:38.000000', 'consum', 0.0253, 'lps'),
	(657845, 134, '2015-01-15 01:05:39.000000', 'consum', 0.0243, 'lps'),
	(657846, 134, '2015-01-15 01:05:40.000000', 'consum', 0.0247, 'lps'),
	(657847, 134, '2015-01-15 01:05:41.000000', 'consum', 0.0295, 'lps'),
	(657848, 134, '2015-01-15 01:05:42.000000', 'consum', 0.0367, 'lps'),
	(657849, 134, '2015-01-15 01:05:43.000000', 'consum', 0.0265, 'lps'),
	(657850, 134, '2015-01-15 01:05:44.000000', 'consum', 0.0330, 'lps'),
	(657851, 134, '2015-01-15 01:05:45.000000', 'consum', 0.0329, 'lps'),
	(657852, 134, '2015-01-15 01:05:46.000000', 'consum', 0.0290, 'lps'),
	(657853, 134, '2015-01-15 01:05:47.000000', 'consum', 0.0252, 'lps'),
	(657854, 134, '2015-01-15 01:05:48.000000', 'consum', 0.0339, 'lps'),
	(657855, 134, '2015-01-15 01:05:49.000000', 'consum', 0.0254, 'lps'),
	(657856, 134, '2015-01-15 01:05:50.000000', 'consum', 0.0361, 'lps'),
	(657857, 134, '2015-01-15 01:05:51.000000', 'consum', 0.0359, 'lps'),
	(657858, 134, '2015-01-15 01:05:52.000000', 'consum', 0.0346, 'lps'),
	(657859, 134, '2015-01-15 01:05:53.000000', 'consum', 0.0285, 'lps'),
	(657860, 134, '2015-01-15 01:05:54.000000', 'consum', 0.0336, 'lps'),
	(657861, 134, '2015-01-15 01:05:55.000000', 'consum', 0.0301, 'lps'),
	(657862, 134, '2015-01-15 01:05:56.000000', 'consum', 0.0285, 'lps'),
	(657863, 134, '2015-01-15 01:05:57.000000', 'consum', 0.0315, 'lps'),
	(657864, 134, '2015-01-15 01:05:58.000000', 'consum', 0.0352, 'lps'),
	(657865, 134, '2015-01-15 01:05:59.000000', 'consum', 0.0290, 'lps'),
	(657866, 134, '2015-01-15 01:06:00.000000', 'consum', 0.0341, 'lps'),
	(657867, 134, '2015-01-15 01:06:01.000000', 'consum', 0.0309, 'lps'),
	(657868, 134, '2015-01-15 01:06:02.000000', 'consum', 0.0314, 'lps'),
	(657869, 134, '2015-01-15 01:06:03.000000', 'consum', 0.0273, 'lps'),
	(657870, 134, '2015-01-15 01:06:04.000000', 'consum', 0.0216, 'lps'),
	(657871, 134, '2015-01-15 01:06:05.000000', 'consum', 0.0366, 'lps'),
	(657872, 134, '2015-01-15 01:06:06.000000', 'consum', 0.0342, 'lps'),
	(657873, 134, '2015-01-15 01:06:07.000000', 'consum', 0.0244, 'lps'),
	(657874, 134, '2015-01-15 01:06:08.000000', 'consum', 0.0302, 'lps'),
	(657875, 134, '2015-01-15 01:06:09.000000', 'consum', 0.0250, 'lps'),
	(657876, 134, '2015-01-15 01:06:10.000000', 'consum', 0.0293, 'lps'),
	(657877, 134, '2015-01-15 01:06:11.000000', 'consum', 0.0346, 'lps'),
	(657878, 134, '2015-01-15 01:06:12.000000', 'consum', 0.0328, 'lps'),
	(657879, 134, '2015-01-15 01:06:13.000000', 'consum', 0.0234, 'lps'),
	(657880, 134, '2015-01-15 01:06:14.000000', 'consum', 0.0293, 'lps'),
	(657881, 134, '2015-01-15 01:06:15.000000', 'consum', 0.0238, 'lps'),
	(657882, 134, '2015-01-15 01:06:16.000000', 'consum', 0.0257, 'lps'),
	(657883, 134, '2015-01-15 01:06:17.000000', 'consum', 0.0362, 'lps'),
	(657884, 134, '2015-01-15 01:06:18.000000', 'consum', 0.0356, 'lps'),
	(657885, 134, '2015-01-15 01:06:19.000000', 'consum', 0.0325, 'lps'),
	(657886, 134, '2015-01-15 01:06:20.000000', 'consum', 0.0350, 'lps'),
	(657887, 134, '2015-01-15 01:06:21.000000', 'consum', 0.0249, 'lps'),
	(657888, 134, '2015-01-15 01:06:22.000000', 'consum', 0.0301, 'lps'),
	(657889, 134, '2015-01-15 01:06:23.000000', 'consum', 0.0232, 'lps'),
	(657890, 134, '2015-01-15 01:06:24.000000', 'consum', 0.0366, 'lps'),
	(657891, 134, '2015-01-15 01:06:25.000000', 'consum', 0.0291, 'lps'),
	(657892, 134, '2015-01-15 01:06:26.000000', 'consum', 0.0304, 'lps'),
	(657893, 134, '2015-01-15 01:06:27.000000', 'consum', 0.0281, 'lps'),
	(657894, 134, '2015-01-15 01:06:28.000000', 'consum', 0.0284, 'lps'),
	(657895, 134, '2015-01-15 01:06:29.000000', 'consum', 0.0366, 'lps'),
	(657896, 134, '2015-01-15 01:06:30.000000', 'consum', 0.0295, 'lps'),
	(657897, 134, '2015-01-15 01:06:31.000000', 'consum', 0.0324, 'lps'),
	(657898, 134, '2015-01-15 01:06:32.000000', 'consum', 0.0211, 'lps'),
	(657899, 134, '2015-01-15 01:06:33.000000', 'consum', 0.0348, 'lps'),
	(657900, 134, '2015-01-15 01:06:34.000000', 'consum', 0.0267, 'lps'),
	(657901, 134, '2015-01-15 01:06:35.000000', 'consum', 0.0237, 'lps'),
	(657902, 134, '2015-01-15 01:06:36.000000', 'consum', 0.0331, 'lps'),
	(657903, 134, '2015-01-15 01:06:37.000000', 'consum', 0.0263, 'lps'),
	(657904, 134, '2015-01-15 01:06:38.000000', 'consum', 0.0271, 'lps'),
	(657905, 134, '2015-01-15 01:06:39.000000', 'consum', 0.0355, 'lps'),
	(657906, 134, '2015-01-15 01:06:40.000000', 'consum', 0.0281, 'lps'),
	(657907, 134, '2015-01-15 01:06:41.000000', 'consum', 0.0286, 'lps'),
	(657908, 134, '2015-01-15 01:06:42.000000', 'consum', 0.0222, 'lps'),
	(657909, 134, '2015-01-15 01:06:43.000000', 'consum', 0.0357, 'lps'),
	(657910, 134, '2015-01-15 01:06:44.000000', 'consum', 0.0279, 'lps'),
	(657911, 134, '2015-01-15 01:06:45.000000', 'consum', 0.0273, 'lps'),
	(657912, 134, '2015-01-15 01:06:46.000000', 'consum', 0.0319, 'lps'),
	(657913, 134, '2015-01-15 01:06:47.000000', 'consum', 0.0248, 'lps'),
	(657914, 134, '2015-01-15 01:06:48.000000', 'consum', 0.0233, 'lps'),
	(657915, 134, '2015-01-15 01:06:49.000000', 'consum', 0.0211, 'lps'),
	(657916, 134, '2015-01-15 01:06:50.000000', 'consum', 0.0303, 'lps'),
	(657917, 134, '2015-01-15 01:06:51.000000', 'consum', 0.0357, 'lps'),
	(657918, 134, '2015-01-15 01:06:52.000000', 'consum', 0.0351, 'lps'),
	(657919, 134, '2015-01-15 01:06:53.000000', 'consum', 0.0315, 'lps'),
	(657920, 134, '2015-01-15 01:06:54.000000', 'consum', 0.0314, 'lps'),
	(657921, 134, '2015-01-15 01:06:55.000000', 'consum', 0.0259, 'lps'),
	(657922, 134, '2015-01-15 01:06:56.000000', 'consum', 0.0301, 'lps'),
	(657923, 134, '2015-01-15 01:06:57.000000', 'consum', 0.0361, 'lps'),
	(657924, 134, '2015-01-15 01:06:58.000000', 'consum', 0.0218, 'lps'),
	(657925, 134, '2015-01-15 01:06:59.000000', 'consum', 0.0271, 'lps'),
	(657926, 134, '2015-01-15 01:07:00.000000', 'consum', 0.0334, 'lps'),
	(657927, 134, '2015-01-15 01:07:01.000000', 'consum', 0.0332, 'lps'),
	(657928, 134, '2015-01-15 01:07:02.000000', 'consum', 0.0292, 'lps'),
	(657929, 134, '2015-01-15 01:07:03.000000', 'consum', 0.0252, 'lps'),
	(657930, 134, '2015-01-15 01:07:04.000000', 'consum', 0.0335, 'lps'),
	(657931, 134, '2015-01-15 01:07:05.000000', 'consum', 0.0235, 'lps'),
	(657932, 134, '2015-01-15 01:07:06.000000', 'consum', 0.0274, 'lps'),
	(657933, 134, '2015-01-15 01:07:07.000000', 'consum', 0.0301, 'lps'),
	(657934, 134, '2015-01-15 01:07:08.000000', 'consum', 0.0314, 'lps'),
	(657935, 134, '2015-01-15 01:07:09.000000', 'consum', 0.0299, 'lps'),
	(657936, 134, '2015-01-15 01:07:10.000000', 'consum', 0.0345, 'lps'),
	(657937, 134, '2015-01-15 01:07:11.000000', 'consum', 0.0304, 'lps'),
	(657938, 134, '2015-01-15 01:07:12.000000', 'consum', 0.0273, 'lps'),
	(657939, 134, '2015-01-15 01:07:13.000000', 'consum', 0.0244, 'lps'),
	(657940, 134, '2015-01-15 01:07:14.000000', 'consum', 0.0349, 'lps'),
	(657941, 134, '2015-01-15 01:07:15.000000', 'consum', 0.0329, 'lps'),
	(657942, 134, '2015-01-15 01:07:16.000000', 'consum', 0.0233, 'lps'),
	(657943, 134, '2015-01-15 01:07:17.000000', 'consum', 0.0283, 'lps'),
	(657944, 134, '2015-01-15 01:07:18.000000', 'consum', 0.0348, 'lps'),
	(657945, 134, '2015-01-15 01:07:19.000000', 'consum', 0.0366, 'lps'),
	(657946, 134, '2015-01-15 01:07:20.000000', 'consum', 0.0259, 'lps'),
	(657947, 134, '2015-01-15 01:07:21.000000', 'consum', 0.0306, 'lps'),
	(657948, 134, '2015-01-15 01:07:22.000000', 'consum', 0.0227, 'lps'),
	(657949, 134, '2015-01-15 01:07:23.000000', 'consum', 0.0323, 'lps'),
	(657950, 134, '2015-01-15 01:07:24.000000', 'consum', 0.0253, 'lps'),
	(657951, 134, '2015-01-15 01:07:25.000000', 'consum', 0.0241, 'lps'),
	(657952, 134, '2015-01-15 01:07:26.000000', 'consum', 0.0239, 'lps'),
	(657953, 134, '2015-01-15 01:07:27.000000', 'consum', 0.0261, 'lps'),
	(657954, 134, '2015-01-15 01:07:28.000000', 'consum', 0.0220, 'lps'),
	(657955, 134, '2015-01-15 01:07:29.000000', 'consum', 0.0265, 'lps'),
	(657956, 134, '2015-01-15 01:07:30.000000', 'consum', 0.0300, 'lps'),
	(657957, 134, '2015-01-15 01:07:31.000000', 'consum', 0.0337, 'lps'),
	(657958, 134, '2015-01-15 01:07:32.000000', 'consum', 0.0259, 'lps'),
	(657959, 134, '2015-01-15 01:07:33.000000', 'consum', 0.0231, 'lps'),
	(657960, 134, '2015-01-15 01:07:34.000000', 'consum', 0.0326, 'lps'),
	(657961, 134, '2015-01-15 01:07:35.000000', 'consum', 0.0253, 'lps'),
	(657962, 134, '2015-01-15 01:07:36.000000', 'consum', 0.0239, 'lps'),
	(657963, 134, '2015-01-15 01:07:37.000000', 'consum', 0.0224, 'lps'),
	(657964, 134, '2015-01-15 01:07:38.000000', 'consum', 0.0351, 'lps'),
	(657965, 134, '2015-01-15 01:07:39.000000', 'consum', 0.0240, 'lps'),
	(657966, 134, '2015-01-15 01:07:40.000000', 'consum', 0.0257, 'lps'),
	(657967, 134, '2015-01-15 01:07:41.000000', 'consum', 0.0353, 'lps'),
	(657968, 134, '2015-01-15 01:07:42.000000', 'consum', 0.0313, 'lps'),
	(657969, 134, '2015-01-15 01:07:43.000000', 'consum', 0.0293, 'lps'),
	(657970, 134, '2015-01-15 01:07:44.000000', 'consum', 0.0320, 'lps'),
	(657971, 134, '2015-01-15 01:07:45.000000', 'consum', 0.0353, 'lps'),
	(657972, 134, '2015-01-15 01:07:46.000000', 'consum', 0.0280, 'lps'),
	(657973, 134, '2015-01-15 01:07:47.000000', 'consum', 0.0288, 'lps'),
	(657974, 134, '2015-01-15 01:07:48.000000', 'consum', 0.0232, 'lps'),
	(657975, 134, '2015-01-15 01:07:49.000000', 'consum', 0.0245, 'lps'),
	(657976, 134, '2015-01-15 01:07:50.000000', 'consum', 0.0320, 'lps'),
	(657977, 134, '2015-01-15 01:07:51.000000', 'consum', 0.0338, 'lps'),
	(657978, 134, '2015-01-15 01:07:52.000000', 'consum', 0.0363, 'lps'),
	(657979, 134, '2015-01-15 01:07:53.000000', 'consum', 0.0276, 'lps'),
	(657980, 134, '2015-01-15 01:07:54.000000', 'consum', 0.0239, 'lps'),
	(657981, 134, '2015-01-15 01:07:55.000000', 'consum', 0.0316, 'lps'),
	(657982, 134, '2015-01-15 01:07:56.000000', 'consum', 0.0335, 'lps'),
	(657983, 134, '2015-01-15 01:07:57.000000', 'consum', 0.0362, 'lps'),
	(657984, 134, '2015-01-15 01:07:58.000000', 'consum', 0.0279, 'lps'),
	(657985, 134, '2015-01-15 01:07:59.000000', 'consum', 0.0257, 'lps'),
	(657986, 134, '2015-01-15 01:08:00.000000', 'consum', 0.0239, 'lps'),
	(657987, 134, '2015-01-15 01:08:01.000000', 'consum', 0.0213, 'lps'),
	(657988, 134, '2015-01-15 01:08:02.000000', 'consum', 0.0297, 'lps'),
	(657989, 134, '2015-01-15 01:08:03.000000', 'consum', 0.0320, 'lps'),
	(657990, 134, '2015-01-15 01:08:04.000000', 'consum', 0.0341, 'lps'),
	(657991, 134, '2015-01-15 01:08:05.000000', 'consum', 0.0222, 'lps'),
	(657992, 134, '2015-01-15 01:08:06.000000', 'consum', 0.0350, 'lps'),
	(657993, 134, '2015-01-15 01:08:07.000000', 'consum', 0.0241, 'lps'),
	(657994, 134, '2015-01-15 01:08:08.000000', 'consum', 0.0261, 'lps'),
	(657995, 134, '2015-01-15 01:08:09.000000', 'consum', 0.0217, 'lps'),
	(657996, 134, '2015-01-15 01:08:10.000000', 'consum', 0.0249, 'lps'),
	(657997, 134, '2015-01-15 01:08:11.000000', 'consum', 0.0227, 'lps'),
	(657998, 134, '2015-01-15 01:08:12.000000', 'consum', 0.0337, 'lps'),
	(657999, 134, '2015-01-15 01:08:13.000000', 'consum', 0.0320, 'lps'),
	(658000, 134, '2015-01-15 01:08:14.000000', 'consum', 0.0222, 'lps'),
	(658001, 134, '2015-01-15 01:08:15.000000', 'consum', 0.0258, 'lps'),
	(658002, 134, '2015-01-15 01:08:16.000000', 'consum', 0.0254, 'lps'),
	(658003, 134, '2015-01-15 01:08:17.000000', 'consum', 0.0286, 'lps'),
	(658004, 134, '2015-01-15 01:08:18.000000', 'consum', 0.0302, 'lps'),
	(658005, 134, '2015-01-15 01:08:19.000000', 'consum', 0.0286, 'lps'),
	(658006, 134, '2015-01-15 01:08:20.000000', 'consum', 0.0313, 'lps'),
	(658007, 134, '2015-01-15 01:08:21.000000', 'consum', 0.0339, 'lps'),
	(658008, 134, '2015-01-15 01:08:22.000000', 'consum', 0.0232, 'lps'),
	(658009, 134, '2015-01-15 01:08:23.000000', 'consum', 0.0251, 'lps'),
	(658010, 134, '2015-01-15 01:08:24.000000', 'consum', 0.0346, 'lps'),
	(658011, 134, '2015-01-15 01:08:25.000000', 'consum', 0.0295, 'lps'),
	(658012, 134, '2015-01-15 01:08:26.000000', 'consum', 0.0229, 'lps'),
	(658013, 134, '2015-01-15 01:08:27.000000', 'consum', 0.0363, 'lps'),
	(658014, 134, '2015-01-15 01:08:28.000000', 'consum', 0.0290, 'lps'),
	(658015, 134, '2015-01-15 01:08:29.000000', 'consum', 0.0307, 'lps'),
	(658016, 134, '2015-01-15 01:08:30.000000', 'consum', 0.0299, 'lps'),
	(658017, 134, '2015-01-15 01:08:31.000000', 'consum', 0.0365, 'lps'),
	(658018, 134, '2015-01-15 01:08:32.000000', 'consum', 0.0245, 'lps'),
	(658019, 134, '2015-01-15 01:08:33.000000', 'consum', 0.0234, 'lps'),
	(658020, 134, '2015-01-15 01:08:34.000000', 'consum', 0.0228, 'lps'),
	(658021, 134, '2015-01-15 01:08:35.000000', 'consum', 0.0228, 'lps'),
	(658022, 134, '2015-01-15 01:08:36.000000', 'consum', 0.0246, 'lps'),
	(658023, 134, '2015-01-15 01:08:37.000000', 'consum', 0.0337, 'lps'),
	(658024, 134, '2015-01-15 01:08:38.000000', 'consum', 0.0264, 'lps'),
	(658025, 134, '2015-01-15 01:08:39.000000', 'consum', 0.0258, 'lps'),
	(658026, 134, '2015-01-15 01:08:40.000000', 'consum', 0.0289, 'lps'),
	(658027, 134, '2015-01-15 01:08:41.000000', 'consum', 0.0304, 'lps'),
	(658028, 134, '2015-01-15 01:08:42.000000', 'consum', 0.0286, 'lps'),
	(658029, 134, '2015-01-15 01:08:43.000000', 'consum', 0.0307, 'lps'),
	(658030, 134, '2015-01-15 01:08:44.000000', 'consum', 0.0309, 'lps'),
	(658031, 134, '2015-01-15 01:08:45.000000', 'consum', 0.0257, 'lps'),
	(658032, 134, '2015-01-15 01:08:46.000000', 'consum', 0.0308, 'lps'),
	(658033, 134, '2015-01-15 01:08:47.000000', 'consum', 0.0241, 'lps'),
	(658034, 134, '2015-01-15 01:08:48.000000', 'consum', 0.0229, 'lps'),
	(658035, 134, '2015-01-15 01:08:49.000000', 'consum', 0.0212, 'lps'),
	(658036, 134, '2015-01-15 01:08:50.000000', 'consum', 0.0324, 'lps'),
	(658037, 134, '2015-01-15 01:08:51.000000', 'consum', 0.0301, 'lps'),
	(658038, 134, '2015-01-15 01:08:52.000000', 'consum', 0.0324, 'lps'),
	(658039, 134, '2015-01-15 01:08:53.000000', 'consum', 0.0350, 'lps'),
	(658040, 134, '2015-01-15 01:08:54.000000', 'consum', 0.0251, 'lps'),
	(658041, 134, '2015-01-15 01:08:55.000000', 'consum', 0.0311, 'lps'),
	(658042, 134, '2015-01-15 01:08:56.000000', 'consum', 0.0277, 'lps'),
	(658043, 134, '2015-01-15 01:08:57.000000', 'consum', 0.0243, 'lps'),
	(658044, 134, '2015-01-15 01:08:58.000000', 'consum', 0.0331, 'lps'),
	(658045, 134, '2015-01-15 01:08:59.000000', 'consum', 0.0245, 'lps'),
	(658046, 134, '2015-01-15 01:09:00.000000', 'consum', 0.0337, 'lps'),
	(658047, 134, '2015-01-15 01:09:01.000000', 'consum', 0.0268, 'lps'),
	(658048, 134, '2015-01-15 01:09:02.000000', 'consum', 0.0278, 'lps'),
	(658049, 134, '2015-01-15 01:09:03.000000', 'consum', 0.0219, 'lps'),
	(658050, 134, '2015-01-15 01:09:04.000000', 'consum', 0.0366, 'lps'),
	(658051, 134, '2015-01-15 01:09:05.000000', 'consum', 0.0334, 'lps'),
	(658052, 134, '2015-01-15 01:09:06.000000', 'consum', 0.0360, 'lps'),
	(658053, 134, '2015-01-15 01:09:07.000000', 'consum', 0.0274, 'lps'),
	(658054, 134, '2015-01-15 01:09:08.000000', 'consum', 0.0239, 'lps'),
	(658055, 134, '2015-01-15 01:09:09.000000', 'consum', 0.0320, 'lps'),
	(658056, 134, '2015-01-15 01:09:10.000000', 'consum', 0.0359, 'lps'),
	(658057, 134, '2015-01-15 01:09:11.000000', 'consum', 0.0309, 'lps'),
	(658058, 134, '2015-01-15 01:09:12.000000', 'consum', 0.0260, 'lps'),
	(658059, 134, '2015-01-15 01:09:13.000000', 'consum', 0.0319, 'lps'),
	(658060, 134, '2015-01-15 01:09:14.000000', 'consum', 0.0293, 'lps'),
	(658061, 134, '2015-01-15 01:09:15.000000', 'consum', 0.0295, 'lps'),
	(658062, 134, '2015-01-15 01:09:16.000000', 'consum', 0.0228, 'lps'),
	(658063, 134, '2015-01-15 01:09:17.000000', 'consum', 0.0364, 'lps'),
	(658064, 134, '2015-01-15 01:09:18.000000', 'consum', 0.0294, 'lps'),
	(658065, 134, '2015-01-15 01:09:19.000000', 'consum', 0.0327, 'lps'),
	(658066, 134, '2015-01-15 01:09:20.000000', 'consum', 0.0227, 'lps'),
	(658067, 134, '2015-01-15 01:09:21.000000', 'consum', 0.0262, 'lps'),
	(658068, 134, '2015-01-15 01:09:22.000000', 'consum', 0.0262, 'lps'),
	(658069, 134, '2015-01-15 01:09:23.000000', 'consum', 0.0313, 'lps'),
	(658070, 134, '2015-01-15 01:09:24.000000', 'consum', 0.0253, 'lps'),
	(658071, 134, '2015-01-15 01:09:25.000000', 'consum', 0.0275, 'lps'),
	(658072, 134, '2015-01-15 01:09:26.000000', 'consum', 0.0249, 'lps'),
	(658073, 134, '2015-01-15 01:09:27.000000', 'consum', 0.0211, 'lps'),
	(658074, 134, '2015-01-15 01:09:28.000000', 'consum', 0.0254, 'lps'),
	(658075, 134, '2015-01-15 01:09:29.000000', 'consum', 0.0272, 'lps'),
	(658076, 134, '2015-01-15 01:09:30.000000', 'consum', 0.0230, 'lps'),
	(658077, 134, '2015-01-15 01:09:31.000000', 'consum', 0.0282, 'lps'),
	(658078, 134, '2015-01-15 01:09:32.000000', 'consum', 0.0354, 'lps'),
	(658079, 134, '2015-01-15 01:09:33.000000', 'consum', 0.0240, 'lps'),
	(658080, 134, '2015-01-15 01:09:34.000000', 'consum', 0.0243, 'lps'),
	(658081, 134, '2015-01-15 01:09:35.000000', 'consum', 0.0286, 'lps'),
	(658082, 134, '2015-01-15 01:09:36.000000', 'consum', 0.0335, 'lps'),
	(658083, 134, '2015-01-15 01:09:37.000000', 'consum', 0.0291, 'lps'),
	(658084, 134, '2015-01-15 01:09:38.000000', 'consum', 0.0239, 'lps'),
	(658085, 134, '2015-01-15 01:09:39.000000', 'consum', 0.0270, 'lps'),
	(658086, 134, '2015-01-15 01:09:40.000000', 'consum', 0.0265, 'lps'),
	(658087, 134, '2015-01-15 01:09:41.000000', 'consum', 0.0305, 'lps'),
	(658088, 134, '2015-01-15 01:09:42.000000', 'consum', 0.0362, 'lps'),
	(658089, 134, '2015-01-15 01:09:43.000000', 'consum', 0.0213, 'lps'),
	(658090, 134, '2015-01-15 01:09:44.000000', 'consum', 0.0244, 'lps'),
	(658091, 134, '2015-01-15 01:09:45.000000', 'consum', 0.0214, 'lps'),
	(658092, 134, '2015-01-15 01:09:46.000000', 'consum', 0.0287, 'lps'),
	(658093, 134, '2015-01-15 01:09:47.000000', 'consum', 0.0266, 'lps'),
	(658094, 134, '2015-01-15 01:09:48.000000', 'consum', 0.0260, 'lps'),
	(658095, 134, '2015-01-15 01:09:49.000000', 'consum', 0.0294, 'lps'),
	(658096, 134, '2015-01-15 01:09:50.000000', 'consum', 0.0323, 'lps'),
	(658097, 134, '2015-01-15 01:09:51.000000', 'consum', 0.0365, 'lps'),
	(658098, 134, '2015-01-15 01:09:52.000000', 'consum', 0.0329, 'lps'),
	(658099, 134, '2015-01-15 01:09:53.000000', 'consum', 0.0341, 'lps'),
	(658100, 134, '2015-01-15 01:09:54.000000', 'consum', 0.0353, 'lps'),
	(658101, 134, '2015-01-15 01:09:55.000000', 'consum', 0.0213, 'lps'),
	(658102, 134, '2015-01-15 01:09:56.000000', 'consum', 0.0272, 'lps'),
	(658103, 134, '2015-01-15 01:09:57.000000', 'consum', 0.0354, 'lps'),
	(658104, 134, '2015-01-15 01:09:58.000000', 'consum', 0.0269, 'lps'),
	(658105, 134, '2015-01-15 01:09:59.000000', 'consum', 0.0233, 'lps'),
	(658106, 134, '2015-01-15 01:10:00.000000', 'consum', 0.0308, 'lps'),
	(658107, 134, '2015-01-15 01:10:01.000000', 'consum', 0.0312, 'lps'),
	(658108, 134, '2015-01-15 01:10:02.000000', 'consum', 0.0271, 'lps'),
	(658109, 134, '2015-01-15 01:10:03.000000', 'consum', 0.0365, 'lps'),
	(658110, 134, '2015-01-15 01:10:04.000000', 'consum', 0.0331, 'lps'),
	(658111, 134, '2015-01-15 01:10:05.000000', 'consum', 0.0351, 'lps'),
	(658112, 134, '2015-01-15 01:10:06.000000', 'consum', 0.0234, 'lps'),
	(658113, 134, '2015-01-15 01:10:07.000000', 'consum', 0.0226, 'lps'),
	(658114, 134, '2015-01-15 01:10:08.000000', 'consum', 0.0219, 'lps'),
	(658115, 134, '2015-01-15 01:10:09.000000', 'consum', 0.0363, 'lps'),
	(658116, 134, '2015-01-15 01:10:10.000000', 'consum', 0.0318, 'lps'),
	(658117, 134, '2015-01-15 01:10:11.000000', 'consum', 0.0289, 'lps'),
	(658118, 134, '2015-01-15 01:10:12.000000', 'consum', 0.0283, 'lps'),
	(658119, 134, '2015-01-15 01:10:13.000000', 'consum', 0.0341, 'lps'),
	(658120, 134, '2015-01-15 01:10:14.000000', 'consum', 0.0327, 'lps'),
	(658121, 134, '2015-01-15 01:10:15.000000', 'consum', 0.0247, 'lps'),
	(658122, 134, '2015-01-15 01:10:16.000000', 'consum', 0.0358, 'lps'),
	(658123, 134, '2015-01-15 01:10:17.000000', 'consum', 0.0211, 'lps'),
	(658124, 134, '2015-01-15 01:10:18.000000', 'consum', 0.0243, 'lps'),
	(658125, 134, '2015-01-15 01:10:19.000000', 'consum', 0.0214, 'lps'),
	(658126, 134, '2015-01-15 01:10:20.000000', 'consum', 0.0291, 'lps'),
	(658127, 134, '2015-01-15 01:10:21.000000', 'consum', 0.0289, 'lps'),
	(658128, 134, '2015-01-15 01:10:22.000000', 'consum', 0.0361, 'lps'),
	(658129, 134, '2015-01-15 01:10:23.000000', 'consum', 0.0253, 'lps'),
	(658130, 134, '2015-01-15 01:10:24.000000', 'consum', 0.0290, 'lps'),
	(658131, 134, '2015-01-15 01:10:25.000000', 'consum', 0.0324, 'lps'),
	(658132, 134, '2015-01-15 01:10:26.000000', 'consum', 0.0223, 'lps'),
	(658133, 134, '2015-01-15 01:10:27.000000', 'consum', 0.0249, 'lps'),
	(658134, 134, '2015-01-15 01:10:28.000000', 'consum', 0.0211, 'lps'),
	(658135, 134, '2015-01-15 01:10:29.000000', 'consum', 0.0255, 'lps'),
	(658136, 134, '2015-01-15 01:10:30.000000', 'consum', 0.0274, 'lps'),
	(658137, 134, '2015-01-15 01:10:31.000000', 'consum', 0.0237, 'lps'),
	(658138, 134, '2015-01-15 01:10:32.000000', 'consum', 0.0311, 'lps'),
	(658139, 134, '2015-01-15 01:10:33.000000', 'consum', 0.0317, 'lps'),
	(658140, 134, '2015-01-15 01:10:34.000000', 'consum', 0.0288, 'lps'),
	(658141, 134, '2015-01-15 01:10:35.000000', 'consum', 0.0277, 'lps'),
	(658142, 134, '2015-01-15 01:10:36.000000', 'consum', 0.0312, 'lps'),
	(658143, 134, '2015-01-15 01:10:37.000000', 'consum', 0.0362, 'lps'),
	(658144, 134, '2015-01-15 01:10:38.000000', 'consum', 0.0347, 'lps'),
	(658145, 134, '2015-01-15 01:10:39.000000', 'consum', 0.0283, 'lps'),
	(658146, 134, '2015-01-15 01:10:40.000000', 'consum', 0.0322, 'lps'),
	(658147, 134, '2015-01-15 01:10:41.000000', 'consum', 0.0234, 'lps'),
	(658148, 134, '2015-01-15 01:10:42.000000', 'consum', 0.0314, 'lps'),
	(658149, 134, '2015-01-15 01:10:43.000000', 'consum', 0.0339, 'lps'),
	(658150, 134, '2015-01-15 01:10:44.000000', 'consum', 0.0228, 'lps'),
	(658151, 134, '2015-01-15 01:10:45.000000', 'consum', 0.0230, 'lps'),
	(658152, 134, '2015-01-15 01:10:46.000000', 'consum', 0.0258, 'lps'),
	(658153, 134, '2015-01-15 01:10:47.000000', 'consum', 0.0231, 'lps'),
	(658154, 134, '2015-01-15 01:10:48.000000', 'consum', 0.0332, 'lps'),
	(658155, 134, '2015-01-15 01:10:49.000000', 'consum', 0.0282, 'lps'),
	(658156, 134, '2015-01-15 01:10:50.000000', 'consum', 0.0361, 'lps'),
	(658157, 134, '2015-01-15 01:10:51.000000', 'consum', 0.0277, 'lps'),
	(658158, 134, '2015-01-15 01:10:52.000000', 'consum', 0.0248, 'lps'),
	(658159, 134, '2015-01-15 01:10:53.000000', 'consum', 0.0361, 'lps'),
	(658160, 134, '2015-01-15 01:10:54.000000', 'consum', 0.0217, 'lps'),
	(658161, 134, '2015-01-15 01:10:55.000000', 'consum', 0.0269, 'lps'),
	(658162, 134, '2015-01-15 01:10:56.000000', 'consum', 0.0326, 'lps'),
	(658163, 134, '2015-01-15 01:10:57.000000', 'consum', 0.0296, 'lps'),
	(658164, 134, '2015-01-15 01:10:58.000000', 'consum', 0.0292, 'lps'),
	(658165, 134, '2015-01-15 01:10:59.000000', 'consum', 0.0363, 'lps'),
	(658166, 134, '2015-01-15 01:11:00.000000', 'consum', 0.0256, 'lps'),
	(658167, 134, '2015-01-15 01:11:01.000000', 'consum', 0.0296, 'lps'),
	(658168, 134, '2015-01-15 01:11:02.000000', 'consum', 0.0347, 'lps'),
	(658169, 134, '2015-01-15 01:11:03.000000', 'consum', 0.0318, 'lps'),
	(658170, 134, '2015-01-15 01:11:04.000000', 'consum', 0.0343, 'lps'),
	(658171, 134, '2015-01-15 01:11:05.000000', 'consum', 0.0233, 'lps'),
	(658172, 134, '2015-01-15 01:11:06.000000', 'consum', 0.0245, 'lps'),
	(658173, 134, '2015-01-15 01:11:07.000000', 'consum', 0.0315, 'lps'),
	(658174, 134, '2015-01-15 01:11:08.000000', 'consum', 0.0316, 'lps'),
	(658175, 134, '2015-01-15 01:11:09.000000', 'consum', 0.0268, 'lps'),
	(658176, 134, '2015-01-15 01:11:10.000000', 'consum', 0.0339, 'lps'),
	(658177, 134, '2015-01-15 01:11:11.000000', 'consum', 0.0364, 'lps'),
	(658178, 134, '2015-01-15 01:11:12.000000', 'consum', 0.0279, 'lps'),
	(658179, 134, '2015-01-15 01:11:13.000000', 'consum', 0.0251, 'lps'),
	(658180, 134, '2015-01-15 01:11:14.000000', 'consum', 0.0367, 'lps'),
	(658181, 134, '2015-01-15 01:11:15.000000', 'consum', 0.0239, 'lps'),
	(658182, 134, '2015-01-15 01:11:16.000000', 'consum', 0.0358, 'lps'),
	(658183, 134, '2015-01-15 01:11:17.000000', 'consum', 0.0231, 'lps'),
	(658184, 134, '2015-01-15 01:11:18.000000', 'consum', 0.0347, 'lps'),
	(658185, 134, '2015-01-15 01:11:19.000000', 'consum', 0.0358, 'lps'),
	(658186, 134, '2015-01-15 01:11:20.000000', 'consum', 0.0223, 'lps'),
	(658187, 134, '2015-01-15 01:11:21.000000', 'consum', 0.0308, 'lps'),
	(658188, 134, '2015-01-15 01:11:22.000000', 'consum', 0.0343, 'lps'),
	(658189, 134, '2015-01-15 01:11:23.000000', 'consum', 0.0266, 'lps'),
	(658190, 134, '2015-01-15 01:11:24.000000', 'consum', 0.0248, 'lps'),
	(658191, 134, '2015-01-15 01:11:25.000000', 'consum', 0.0235, 'lps'),
	(658192, 134, '2015-01-15 01:11:26.000000', 'consum', 0.0220, 'lps'),
	(658193, 134, '2015-01-15 01:11:27.000000', 'consum', 0.0343, 'lps'),
	(658194, 134, '2015-01-15 01:11:28.000000', 'consum', 0.0212, 'lps'),
	(658195, 134, '2015-01-15 01:11:29.000000', 'consum', 0.0299, 'lps'),
	(658196, 134, '2015-01-15 01:11:30.000000', 'consum', 0.0331, 'lps'),
	(658197, 134, '2015-01-15 01:11:31.000000', 'consum', 0.0233, 'lps'),
	(658198, 134, '2015-01-15 01:11:32.000000', 'consum', 0.0277, 'lps'),
	(658199, 134, '2015-01-15 01:11:33.000000', 'consum', 0.0319, 'lps'),
	(658200, 134, '2015-01-15 01:11:34.000000', 'consum', 0.0239, 'lps'),
	(658201, 134, '2015-01-15 01:11:35.000000', 'consum', 0.0343, 'lps'),
	(658202, 134, '2015-01-15 01:11:36.000000', 'consum', 0.0315, 'lps'),
	(658203, 134, '2015-01-15 01:11:37.000000', 'consum', 0.0338, 'lps'),
	(658204, 134, '2015-01-15 01:11:38.000000', 'consum', 0.0217, 'lps'),
	(658205, 134, '2015-01-15 01:11:39.000000', 'consum', 0.0338, 'lps'),
	(658206, 134, '2015-01-15 01:11:40.000000', 'consum', 0.0355, 'lps'),
	(658207, 134, '2015-01-15 01:11:41.000000', 'consum', 0.0236, 'lps'),
	(658208, 134, '2015-01-15 01:11:42.000000', 'consum', 0.0219, 'lps'),
	(658209, 134, '2015-01-15 01:11:43.000000', 'consum', 0.0337, 'lps'),
	(658210, 134, '2015-01-15 01:11:44.000000', 'consum', 0.0345, 'lps'),
	(658211, 134, '2015-01-15 01:11:45.000000', 'consum', 0.0347, 'lps'),
	(658212, 134, '2015-01-15 01:11:46.000000', 'consum', 0.0333, 'lps'),
	(658213, 134, '2015-01-15 01:11:47.000000', 'consum', 0.0255, 'lps'),
	(658214, 134, '2015-01-15 01:11:48.000000', 'consum', 0.0223, 'lps'),
	(658215, 134, '2015-01-15 01:11:49.000000', 'consum', 0.0301, 'lps'),
	(658216, 134, '2015-01-15 01:11:50.000000', 'consum', 0.0310, 'lps'),
	(658217, 134, '2015-01-15 01:11:51.000000', 'consum', 0.0281, 'lps'),
	(658218, 134, '2015-01-15 01:11:52.000000', 'consum', 0.0264, 'lps'),
	(658219, 134, '2015-01-15 01:11:53.000000', 'consum', 0.0268, 'lps'),
	(658220, 134, '2015-01-15 01:11:54.000000', 'consum', 0.0338, 'lps'),
	(658221, 134, '2015-01-15 01:11:55.000000', 'consum', 0.0363, 'lps'),
	(658222, 134, '2015-01-15 01:11:56.000000', 'consum', 0.0273, 'lps'),
	(658223, 134, '2015-01-15 01:11:57.000000', 'consum', 0.0223, 'lps'),
	(658224, 134, '2015-01-15 01:11:58.000000', 'consum', 0.0247, 'lps'),
	(658225, 134, '2015-01-15 01:11:59.000000', 'consum', 0.0356, 'lps'),
	(658226, 134, '2015-01-15 01:12:00.000000', 'consum', 0.0354, 'lps'),
	(658227, 134, '2015-01-15 01:12:01.000000', 'consum', 0.0338, 'lps'),
	(658228, 134, '2015-01-15 01:12:02.000000', 'consum', 0.0257, 'lps'),
	(658229, 134, '2015-01-15 01:12:03.000000', 'consum', 0.0220, 'lps'),
	(658230, 134, '2015-01-15 01:12:04.000000', 'consum', 0.0278, 'lps'),
	(658231, 134, '2015-01-15 01:12:05.000000', 'consum', 0.0363, 'lps'),
	(658232, 134, '2015-01-15 01:12:06.000000', 'consum', 0.0298, 'lps'),
	(658233, 134, '2015-01-15 01:12:07.000000', 'consum', 0.0350, 'lps'),
	(658234, 134, '2015-01-15 01:12:08.000000', 'consum', 0.0332, 'lps'),
	(658235, 134, '2015-01-15 01:12:09.000000', 'consum', 0.0240, 'lps'),
	(658236, 134, '2015-01-15 01:12:10.000000', 'consum', 0.0310, 'lps'),
	(658237, 134, '2015-01-15 01:12:11.000000', 'consum', 0.0304, 'lps'),
	(658238, 134, '2015-01-15 01:12:12.000000', 'consum', 0.0224, 'lps'),
	(658239, 134, '2015-01-15 01:12:13.000000', 'consum', 0.0316, 'lps'),
	(658240, 134, '2015-01-15 01:12:14.000000', 'consum', 0.0223, 'lps'),
	(658241, 134, '2015-01-15 01:12:15.000000', 'consum', 0.0275, 'lps'),
	(658242, 134, '2015-01-15 01:12:16.000000', 'consum', 0.0337, 'lps'),
	(658243, 134, '2015-01-15 01:12:17.000000', 'consum', 0.0335, 'lps'),
	(658244, 134, '2015-01-15 01:12:18.000000', 'consum', 0.0296, 'lps'),
	(658245, 134, '2015-01-15 01:12:19.000000', 'consum', 0.0266, 'lps'),
	(658246, 134, '2015-01-15 01:12:20.000000', 'consum', 0.0233, 'lps'),
	(658247, 134, '2015-01-15 01:12:21.000000', 'consum', 0.0314, 'lps'),
	(658248, 134, '2015-01-15 01:12:22.000000', 'consum', 0.0345, 'lps'),
	(658249, 134, '2015-01-15 01:12:23.000000', 'consum', 0.0258, 'lps'),
	(658250, 134, '2015-01-15 01:12:24.000000', 'consum', 0.0360, 'lps'),
	(658251, 134, '2015-01-15 01:12:25.000000', 'consum', 0.0344, 'lps'),
	(658252, 134, '2015-01-15 01:12:26.000000', 'consum', 0.0270, 'lps'),
	(658253, 134, '2015-01-15 01:12:27.000000', 'consum', 0.0270, 'lps'),
	(658254, 134, '2015-01-15 01:12:28.000000', 'consum', 0.0327, 'lps'),
	(658255, 134, '2015-01-15 01:12:29.000000', 'consum', 0.0302, 'lps'),
	(658256, 134, '2015-01-15 01:12:30.000000', 'consum', 0.0321, 'lps'),
	(658257, 134, '2015-01-15 01:12:31.000000', 'consum', 0.0328, 'lps'),
	(658258, 134, '2015-01-15 01:12:32.000000', 'consum', 0.0310, 'lps'),
	(658259, 134, '2015-01-15 01:12:33.000000', 'consum', 0.0358, 'lps'),
	(658260, 134, '2015-01-15 01:12:34.000000', 'consum', 0.0335, 'lps'),
	(658261, 134, '2015-01-15 01:12:35.000000', 'consum', 0.0231, 'lps'),
	(658262, 134, '2015-01-15 01:12:36.000000', 'consum', 0.0258, 'lps'),
	(658263, 134, '2015-01-15 01:12:37.000000', 'consum', 0.0229, 'lps'),
	(658264, 134, '2015-01-15 01:12:38.000000', 'consum', 0.0319, 'lps'),
	(658265, 134, '2015-01-15 01:12:39.000000', 'consum', 0.0226, 'lps'),
	(658266, 134, '2015-01-15 01:12:40.000000', 'consum', 0.0280, 'lps'),
	(658267, 134, '2015-01-15 01:12:41.000000', 'consum', 0.0356, 'lps'),
	(658268, 134, '2015-01-15 01:12:42.000000', 'consum', 0.0253, 'lps'),
	(658269, 134, '2015-01-15 01:12:43.000000', 'consum', 0.0304, 'lps'),
	(658270, 134, '2015-01-15 01:12:44.000000', 'consum', 0.0238, 'lps'),
	(658271, 134, '2015-01-15 01:12:45.000000', 'consum', 0.0223, 'lps'),
	(658272, 134, '2015-01-15 01:12:46.000000', 'consum', 0.0353, 'lps'),
	(658273, 134, '2015-01-15 01:12:47.000000', 'consum', 0.0254, 'lps'),
	(658274, 134, '2015-01-15 01:12:48.000000', 'consum', 0.0315, 'lps'),
	(658275, 134, '2015-01-15 01:12:49.000000', 'consum', 0.0288, 'lps'),
	(658276, 134, '2015-01-15 01:12:50.000000', 'consum', 0.0285, 'lps'),
	(658277, 134, '2015-01-15 01:12:51.000000', 'consum', 0.0351, 'lps'),
	(658278, 134, '2015-01-15 01:12:52.000000', 'consum', 0.0216, 'lps'),
	(658279, 134, '2015-01-15 01:12:53.000000', 'consum', 0.0291, 'lps'),
	(658280, 134, '2015-01-15 01:12:54.000000', 'consum', 0.0283, 'lps'),
	(658281, 134, '2015-01-15 01:12:55.000000', 'consum', 0.0330, 'lps'),
	(658282, 134, '2015-01-15 01:12:56.000000', 'consum', 0.0278, 'lps'),
	(658283, 134, '2015-01-15 01:12:57.000000', 'consum', 0.0348, 'lps'),
	(658284, 134, '2015-01-15 01:12:58.000000', 'consum', 0.0221, 'lps'),
	(658285, 134, '2015-01-15 01:12:59.000000', 'consum', 0.0326, 'lps'),
	(658286, 134, '2015-01-15 01:13:00.000000', 'consum', 0.0285, 'lps'),
	(658287, 134, '2015-01-15 01:13:01.000000', 'consum', 0.0236, 'lps'),
	(658288, 134, '2015-01-15 01:13:02.000000', 'consum', 0.0273, 'lps'),
	(658289, 134, '2015-01-15 01:13:03.000000', 'consum', 0.0288, 'lps'),
	(658290, 134, '2015-01-15 01:13:04.000000', 'consum', 0.0257, 'lps'),
	(658291, 134, '2015-01-15 01:13:05.000000', 'consum', 0.0367, 'lps'),
	(658292, 134, '2015-01-15 01:13:06.000000', 'consum', 0.0225, 'lps'),
	(658293, 134, '2015-01-15 01:13:07.000000', 'consum', 0.0286, 'lps'),
	(658294, 134, '2015-01-15 01:13:08.000000', 'consum', 0.0232, 'lps'),
	(658295, 134, '2015-01-15 01:13:09.000000', 'consum', 0.0248, 'lps'),
	(658296, 134, '2015-01-15 01:13:10.000000', 'consum', 0.0334, 'lps'),
	(658297, 134, '2015-01-15 01:13:11.000000', 'consum', 0.0242, 'lps'),
	(658298, 134, '2015-01-15 01:13:12.000000', 'consum', 0.0314, 'lps'),
	(658299, 134, '2015-01-15 01:13:13.000000', 'consum', 0.0319, 'lps'),
	(658300, 134, '2015-01-15 01:13:14.000000', 'consum', 0.0287, 'lps'),
	(658301, 134, '2015-01-15 01:13:15.000000', 'consum', 0.0267, 'lps'),
	(658302, 134, '2015-01-15 01:13:16.000000', 'consum', 0.0266, 'lps'),
	(658303, 134, '2015-01-15 01:13:17.000000', 'consum', 0.0319, 'lps'),
	(658304, 134, '2015-01-15 01:13:18.000000', 'consum', 0.0273, 'lps'),
	(658305, 134, '2015-01-15 01:13:19.000000', 'consum', 0.0356, 'lps'),
	(658306, 134, '2015-01-15 01:13:20.000000', 'consum', 0.0277, 'lps'),
	(658307, 134, '2015-01-15 01:13:21.000000', 'consum', 0.0266, 'lps'),
	(658308, 134, '2015-01-15 01:13:22.000000', 'consum', 0.0287, 'lps'),
	(658309, 134, '2015-01-15 01:13:23.000000', 'consum', 0.0272, 'lps'),
	(658310, 134, '2015-01-15 01:13:24.000000', 'consum', 0.0291, 'lps'),
	(658311, 134, '2015-01-15 01:13:25.000000', 'consum', 0.0269, 'lps'),
	(658312, 134, '2015-01-15 01:13:26.000000', 'consum', 0.0264, 'lps'),
	(658313, 134, '2015-01-15 01:13:27.000000', 'consum', 0.0304, 'lps'),
	(658314, 134, '2015-01-15 01:13:28.000000', 'consum', 0.0361, 'lps'),
	(658315, 134, '2015-01-15 01:13:29.000000', 'consum', 0.0366, 'lps'),
	(658316, 134, '2015-01-15 01:13:30.000000', 'consum', 0.0222, 'lps'),
	(658317, 134, '2015-01-15 01:13:31.000000', 'consum', 0.0278, 'lps'),
	(658318, 134, '2015-01-15 01:13:32.000000', 'consum', 0.0355, 'lps'),
	(658319, 134, '2015-01-15 01:13:33.000000', 'consum', 0.0258, 'lps'),
	(658320, 134, '2015-01-15 01:13:34.000000', 'consum', 0.0331, 'lps'),
	(658321, 134, '2015-01-15 01:13:35.000000', 'consum', 0.0358, 'lps'),
	(658322, 134, '2015-01-15 01:13:36.000000', 'consum', 0.0268, 'lps'),
	(658323, 134, '2015-01-15 01:13:37.000000', 'consum', 0.0216, 'lps'),
	(658324, 134, '2015-01-15 01:13:38.000000', 'consum', 0.0224, 'lps'),
	(658325, 134, '2015-01-15 01:13:39.000000', 'consum', 0.0264, 'lps'),
	(658326, 134, '2015-01-15 01:13:40.000000', 'consum', 0.0280, 'lps'),
	(658327, 134, '2015-01-15 01:13:41.000000', 'consum', 0.0242, 'lps'),
	(658328, 134, '2015-01-15 01:13:42.000000', 'consum', 0.0316, 'lps'),
	(658329, 134, '2015-01-15 01:13:43.000000', 'consum', 0.0328, 'lps'),
	(658330, 134, '2015-01-15 01:13:44.000000', 'consum', 0.0325, 'lps'),
	(658331, 134, '2015-01-15 01:13:45.000000', 'consum', 0.0275, 'lps'),
	(658332, 134, '2015-01-15 01:13:46.000000', 'consum', 0.0347, 'lps'),
	(658333, 134, '2015-01-15 01:13:47.000000', 'consum', 0.0226, 'lps'),
	(658334, 134, '2015-01-15 01:13:48.000000', 'consum', 0.0354, 'lps'),
	(658335, 134, '2015-01-15 01:13:49.000000', 'consum', 0.0249, 'lps'),
	(658336, 134, '2015-01-15 01:13:50.000000', 'consum', 0.0291, 'lps'),
	(658337, 134, '2015-01-15 01:13:51.000000', 'consum', 0.0339, 'lps'),
	(658338, 134, '2015-01-15 01:13:52.000000', 'consum', 0.0298, 'lps'),
	(658339, 134, '2015-01-15 01:13:53.000000', 'consum', 0.0263, 'lps'),
	(658340, 134, '2015-01-15 01:13:54.000000', 'consum', 0.0211, 'lps'),
	(658341, 134, '2015-01-15 01:13:55.000000', 'consum', 0.0214, 'lps'),
	(658342, 134, '2015-01-15 01:13:56.000000', 'consum', 0.0229, 'lps'),
	(658343, 134, '2015-01-15 01:13:57.000000', 'consum', 0.0291, 'lps'),
	(658344, 134, '2015-01-15 01:13:58.000000', 'consum', 0.0244, 'lps'),
	(658345, 134, '2015-01-15 01:13:59.000000', 'consum', 0.0296, 'lps'),
	(658346, 134, '2015-01-15 01:14:00.000000', 'consum', 0.0224, 'lps'),
	(658347, 134, '2015-01-15 01:14:01.000000', 'consum', 0.0338, 'lps'),
	(658348, 134, '2015-01-15 01:14:02.000000', 'consum', 0.0334, 'lps'),
	(658349, 134, '2015-01-15 01:14:03.000000', 'consum', 0.0287, 'lps'),
	(658350, 134, '2015-01-15 01:14:04.000000', 'consum', 0.0225, 'lps'),
	(658351, 134, '2015-01-15 01:14:05.000000', 'consum', 0.0214, 'lps'),
	(658352, 134, '2015-01-15 01:14:06.000000', 'consum', 0.0343, 'lps'),
	(658353, 134, '2015-01-15 01:14:07.000000', 'consum', 0.0232, 'lps'),
	(658354, 134, '2015-01-15 01:14:08.000000', 'consum', 0.0237, 'lps'),
	(658355, 134, '2015-01-15 01:14:09.000000', 'consum', 0.0281, 'lps'),
	(658356, 134, '2015-01-15 01:14:10.000000', 'consum', 0.0324, 'lps'),
	(658357, 134, '2015-01-15 01:14:11.000000', 'consum', 0.0251, 'lps'),
	(658358, 134, '2015-01-15 01:14:12.000000', 'consum', 0.0233, 'lps'),
	(658359, 134, '2015-01-15 01:14:13.000000', 'consum', 0.0358, 'lps'),
	(658360, 134, '2015-01-15 01:14:14.000000', 'consum', 0.0252, 'lps'),
	(658361, 134, '2015-01-15 01:14:15.000000', 'consum', 0.0290, 'lps'),
	(658362, 134, '2015-01-15 01:14:16.000000', 'consum', 0.0328, 'lps'),
	(658363, 134, '2015-01-15 01:14:17.000000', 'consum', 0.0242, 'lps'),
	(658364, 134, '2015-01-15 01:14:18.000000', 'consum', 0.0336, 'lps'),
	(658365, 134, '2015-01-15 01:14:19.000000', 'consum', 0.0269, 'lps'),
	(658366, 134, '2015-01-15 01:14:20.000000', 'consum', 0.0287, 'lps'),
	(658367, 134, '2015-01-15 01:14:21.000000', 'consum', 0.0258, 'lps'),
	(658368, 134, '2015-01-15 01:14:22.000000', 'consum', 0.0221, 'lps'),
	(658369, 134, '2015-01-15 01:14:23.000000', 'consum', 0.0279, 'lps'),
	(658370, 134, '2015-01-15 01:14:24.000000', 'consum', 0.0364, 'lps'),
	(658371, 134, '2015-01-15 01:14:25.000000', 'consum', 0.0300, 'lps'),
	(658372, 134, '2015-01-15 01:14:26.000000', 'consum', 0.0355, 'lps'),
	(658373, 134, '2015-01-15 01:14:27.000000', 'consum', 0.0351, 'lps'),
	(658374, 134, '2015-01-15 01:14:28.000000', 'consum', 0.0324, 'lps'),
	(658375, 134, '2015-01-15 01:14:29.000000', 'consum', 0.0357, 'lps'),
	(658376, 134, '2015-01-15 01:14:30.000000', 'consum', 0.0285, 'lps'),
	(658377, 134, '2015-01-15 01:14:31.000000', 'consum', 0.0303, 'lps'),
	(658378, 134, '2015-01-15 01:14:32.000000', 'consum', 0.0294, 'lps'),
	(658379, 134, '2015-01-15 01:14:33.000000', 'consum', 0.0350, 'lps'),
	(658380, 134, '2015-01-15 01:14:34.000000', 'consum', 0.0345, 'lps'),
	(658381, 134, '2015-01-15 01:14:35.000000', 'consum', 0.0307, 'lps'),
	(658382, 134, '2015-01-15 01:14:36.000000', 'consum', 0.0289, 'lps'),
	(658383, 134, '2015-01-15 01:14:37.000000', 'consum', 0.0317, 'lps'),
	(658384, 134, '2015-01-15 01:14:38.000000', 'consum', 0.0348, 'lps'),
	(658385, 134, '2015-01-15 01:14:39.000000', 'consum', 0.0263, 'lps'),
	(658386, 134, '2015-01-15 01:14:40.000000', 'consum', 0.0219, 'lps'),
	(658387, 134, '2015-01-15 01:14:41.000000', 'consum', 0.0256, 'lps'),
	(658388, 135, '2015-01-15 00:00:00.000000', 'consum', 0.0212, 'lps'),
	(658389, 135, '2015-01-15 00:00:01.000000', 'consum', 0.0240, 'lps'),
	(658390, 135, '2015-01-15 00:00:02.000000', 'consum', 0.0279, 'lps'),
	(658391, 135, '2015-01-15 00:00:03.000000', 'consum', 0.0244, 'lps'),
	(658392, 135, '2015-01-15 00:00:04.000000', 'consum', 0.0248, 'lps'),
	(658393, 135, '2015-01-15 00:00:05.000000', 'consum', 0.0223, 'lps'),
	(658394, 135, '2015-01-15 00:00:06.000000', 'consum', 0.0236, 'lps'),
	(658395, 135, '2015-01-15 00:00:07.000000', 'consum', 0.0230, 'lps'),
	(658396, 135, '2015-01-15 00:00:08.000000', 'consum', 0.0229, 'lps'),
	(658397, 135, '2015-01-15 00:00:09.000000', 'consum', 0.0249, 'lps'),
	(658398, 135, '2015-01-15 00:00:10.000000', 'consum', 0.0273, 'lps'),
	(658399, 135, '2015-01-15 00:00:11.000000', 'consum', 0.0260, 'lps'),
	(658400, 135, '2015-01-15 00:00:12.000000', 'consum', 0.0271, 'lps'),
	(658401, 135, '2015-01-15 00:00:13.000000', 'consum', 0.0217, 'lps'),
	(658402, 135, '2015-01-15 00:00:14.000000', 'consum', 0.0213, 'lps'),
	(658403, 135, '2015-01-15 00:00:15.000000', 'consum', 0.0278, 'lps'),
	(658404, 135, '2015-01-15 00:00:16.000000', 'consum', 0.0245, 'lps'),
	(658405, 135, '2015-01-15 00:00:17.000000', 'consum', 0.0254, 'lps'),
	(658406, 135, '2015-01-15 00:00:18.000000', 'consum', 0.0254, 'lps'),
	(658407, 135, '2015-01-15 00:00:19.000000', 'consum', 0.0223, 'lps'),
	(658408, 135, '2015-01-15 00:00:20.000000', 'consum', 0.0216, 'lps'),
	(658409, 135, '2015-01-15 00:00:21.000000', 'consum', 0.0276, 'lps'),
	(658410, 135, '2015-01-15 00:00:22.000000', 'consum', 0.0228, 'lps'),
	(658411, 135, '2015-01-15 00:00:23.000000', 'consum', 0.0252, 'lps'),
	(658412, 135, '2015-01-15 00:00:24.000000', 'consum', 0.0216, 'lps'),
	(658413, 135, '2015-01-15 00:00:25.000000', 'consum', 0.0262, 'lps'),
	(658414, 135, '2015-01-15 00:00:26.000000', 'consum', 0.0230, 'lps'),
	(658415, 135, '2015-01-15 00:00:27.000000', 'consum', 0.0231, 'lps'),
	(658416, 135, '2015-01-15 00:00:28.000000', 'consum', 0.0253, 'lps'),
	(658417, 135, '2015-01-15 00:00:29.000000', 'consum', 0.0215, 'lps'),
	(658418, 135, '2015-01-15 00:00:30.000000', 'consum', 0.0257, 'lps'),
	(658419, 135, '2015-01-15 00:00:31.000000', 'consum', 0.0280, 'lps'),
	(658420, 135, '2015-01-15 00:00:32.000000', 'consum', 0.0272, 'lps'),
	(658421, 135, '2015-01-15 00:00:33.000000', 'consum', 0.0237, 'lps'),
	(658422, 135, '2015-01-15 00:00:34.000000', 'consum', 0.0231, 'lps'),
	(658423, 135, '2015-01-15 00:00:35.000000', 'consum', 0.0238, 'lps'),
	(658424, 135, '2015-01-15 00:00:36.000000', 'consum', 0.0211, 'lps'),
	(658425, 135, '2015-01-15 00:00:37.000000', 'consum', 0.0282, 'lps'),
	(658426, 135, '2015-01-15 00:00:38.000000', 'consum', 0.0272, 'lps'),
	(658427, 135, '2015-01-15 00:00:39.000000', 'consum', 0.0228, 'lps'),
	(658428, 135, '2015-01-15 00:00:40.000000', 'consum', 0.0262, 'lps'),
	(658429, 135, '2015-01-15 00:00:41.000000', 'consum', 0.0267, 'lps'),
	(658430, 135, '2015-01-15 00:00:42.000000', 'consum', 0.0269, 'lps'),
	(658431, 135, '2015-01-15 00:00:43.000000', 'consum', 0.0261, 'lps'),
	(658432, 135, '2015-01-15 00:00:44.000000', 'consum', 0.0211, 'lps'),
	(658433, 135, '2015-01-15 00:00:45.000000', 'consum', 0.0214, 'lps'),
	(658434, 135, '2015-01-15 00:00:46.000000', 'consum', 0.0224, 'lps'),
	(658435, 135, '2015-01-15 00:00:47.000000', 'consum', 0.0272, 'lps'),
	(658436, 135, '2015-01-15 00:00:48.000000', 'consum', 0.0254, 'lps'),
	(658437, 135, '2015-01-15 00:00:49.000000', 'consum', 0.0247, 'lps'),
	(658438, 135, '2015-01-15 00:00:50.000000', 'consum', 0.0264, 'lps'),
	(658439, 135, '2015-01-15 00:00:51.000000', 'consum', 0.0219, 'lps'),
	(658440, 135, '2015-01-15 00:00:52.000000', 'consum', 0.0243, 'lps'),
	(658441, 135, '2015-01-15 00:00:53.000000', 'consum', 0.0273, 'lps'),
	(658442, 135, '2015-01-15 00:00:54.000000', 'consum', 0.0277, 'lps'),
	(658443, 135, '2015-01-15 00:00:55.000000', 'consum', 0.0211, 'lps'),
	(658444, 135, '2015-01-15 00:00:56.000000', 'consum', 0.0235, 'lps'),
	(658445, 135, '2015-01-15 00:00:57.000000', 'consum', 0.0257, 'lps'),
	(658446, 135, '2015-01-15 00:00:58.000000', 'consum', 0.0224, 'lps'),
	(658447, 135, '2015-01-15 00:00:59.000000', 'consum', 0.0213, 'lps'),
	(658448, 135, '2015-01-15 00:01:00.000000', 'consum', 0.0257, 'lps'),
	(658449, 135, '2015-01-15 00:01:01.000000', 'consum', 0.0216, 'lps'),
	(658450, 135, '2015-01-15 00:01:02.000000', 'consum', 0.0248, 'lps'),
	(658451, 135, '2015-01-15 00:01:03.000000', 'consum', 0.0232, 'lps'),
	(658452, 135, '2015-01-15 00:01:04.000000', 'consum', 0.0283, 'lps'),
	(658453, 135, '2015-01-15 00:01:05.000000', 'consum', 0.0212, 'lps'),
	(658454, 135, '2015-01-15 00:01:06.000000', 'consum', 0.0224, 'lps'),
	(658455, 135, '2015-01-15 00:01:07.000000', 'consum', 0.0276, 'lps'),
	(658456, 135, '2015-01-15 00:01:08.000000', 'consum', 0.0276, 'lps'),
	(658457, 135, '2015-01-15 00:01:09.000000', 'consum', 0.0267, 'lps'),
	(658458, 135, '2015-01-15 00:01:10.000000', 'consum', 0.0224, 'lps'),
	(658459, 135, '2015-01-15 00:01:11.000000', 'consum', 0.0258, 'lps'),
	(658460, 135, '2015-01-15 00:01:12.000000', 'consum', 0.0260, 'lps'),
	(658461, 135, '2015-01-15 00:01:13.000000', 'consum', 0.0242, 'lps'),
	(658462, 135, '2015-01-15 00:01:14.000000', 'consum', 0.0221, 'lps'),
	(658463, 135, '2015-01-15 00:01:15.000000', 'consum', 0.0244, 'lps'),
	(658464, 135, '2015-01-15 00:01:16.000000', 'consum', 0.0274, 'lps'),
	(658465, 135, '2015-01-15 00:01:17.000000', 'consum', 0.0280, 'lps'),
	(658466, 135, '2015-01-15 00:01:18.000000', 'consum', 0.0219, 'lps'),
	(658467, 135, '2015-01-15 00:01:19.000000', 'consum', 0.0267, 'lps'),
	(658468, 135, '2015-01-15 00:01:20.000000', 'consum', 0.0248, 'lps'),
	(658469, 135, '2015-01-15 00:01:21.000000', 'consum', 0.0231, 'lps'),
	(658470, 135, '2015-01-15 00:01:22.000000', 'consum', 0.0273, 'lps'),
	(658471, 135, '2015-01-15 00:01:23.000000', 'consum', 0.0242, 'lps'),
	(658472, 135, '2015-01-15 00:01:24.000000', 'consum', 0.0255, 'lps'),
	(658473, 135, '2015-01-15 00:01:25.000000', 'consum', 0.0264, 'lps'),
	(658474, 135, '2015-01-15 00:01:26.000000', 'consum', 0.0272, 'lps'),
	(658475, 135, '2015-01-15 00:01:27.000000', 'consum', 0.0211, 'lps'),
	(658476, 135, '2015-01-15 00:01:28.000000', 'consum', 0.0250, 'lps'),
	(658477, 135, '2015-01-15 00:01:29.000000', 'consum', 0.0259, 'lps'),
	(658478, 135, '2015-01-15 00:01:30.000000', 'consum', 0.0263, 'lps'),
	(658479, 135, '2015-01-15 00:01:31.000000', 'consum', 0.0254, 'lps'),
	(658480, 135, '2015-01-15 00:01:32.000000', 'consum', 0.0272, 'lps'),
	(658481, 135, '2015-01-15 00:01:33.000000', 'consum', 0.0239, 'lps'),
	(658482, 135, '2015-01-15 00:01:34.000000', 'consum', 0.0243, 'lps'),
	(658483, 135, '2015-01-15 00:01:35.000000', 'consum', 0.0214, 'lps'),
	(658484, 135, '2015-01-15 00:01:36.000000', 'consum', 0.0281, 'lps'),
	(658485, 135, '2015-01-15 00:01:37.000000', 'consum', 0.0258, 'lps'),
	(658486, 135, '2015-01-15 00:01:38.000000', 'consum', 0.0237, 'lps'),
	(658487, 135, '2015-01-15 00:01:39.000000', 'consum', 0.0274, 'lps'),
	(658488, 135, '2015-01-15 00:01:40.000000', 'consum', 0.0227, 'lps'),
	(658489, 135, '2015-01-15 00:01:41.000000', 'consum', 0.0251, 'lps'),
	(658490, 135, '2015-01-15 00:01:42.000000', 'consum', 0.0219, 'lps'),
	(658491, 135, '2015-01-15 00:01:43.000000', 'consum', 0.0278, 'lps'),
	(658492, 135, '2015-01-15 00:01:44.000000', 'consum', 0.0229, 'lps'),
	(658493, 135, '2015-01-15 00:01:45.000000', 'consum', 0.0250, 'lps'),
	(658494, 135, '2015-01-15 00:01:46.000000', 'consum', 0.0277, 'lps'),
	(658495, 135, '2015-01-15 00:01:47.000000', 'consum', 0.0280, 'lps'),
	(658496, 135, '2015-01-15 00:01:48.000000', 'consum', 0.0212, 'lps'),
	(658497, 135, '2015-01-15 00:01:49.000000', 'consum', 0.0233, 'lps'),
	(658498, 135, '2015-01-15 00:01:50.000000', 'consum', 0.0245, 'lps'),
	(658499, 135, '2015-01-15 00:01:51.000000', 'consum', 0.0242, 'lps'),
	(658500, 135, '2015-01-15 00:01:52.000000', 'consum', 0.0266, 'lps'),
	(658501, 135, '2015-01-15 00:01:53.000000', 'consum', 0.0247, 'lps'),
	(658502, 135, '2015-01-15 00:01:54.000000', 'consum', 0.0226, 'lps'),
	(658503, 135, '2015-01-15 00:01:55.000000', 'consum', 0.0253, 'lps'),
	(658504, 135, '2015-01-15 00:01:56.000000', 'consum', 0.0229, 'lps'),
	(658505, 135, '2015-01-15 00:01:57.000000', 'consum', 0.0252, 'lps'),
	(658506, 135, '2015-01-15 00:01:58.000000', 'consum', 0.0214, 'lps'),
	(658507, 135, '2015-01-15 00:01:59.000000', 'consum', 0.0253, 'lps'),
	(658508, 135, '2015-01-15 00:02:00.000000', 'consum', 0.0266, 'lps'),
	(658509, 135, '2015-01-15 00:02:01.000000', 'consum', 0.0215, 'lps'),
	(658510, 135, '2015-01-15 00:02:02.000000', 'consum', 0.0216, 'lps'),
	(658511, 135, '2015-01-15 00:02:03.000000', 'consum', 0.0223, 'lps'),
	(658512, 135, '2015-01-15 00:02:04.000000', 'consum', 0.0258, 'lps'),
	(658513, 135, '2015-01-15 00:02:05.000000', 'consum', 0.0263, 'lps'),
	(658514, 135, '2015-01-15 00:02:06.000000', 'consum', 0.0256, 'lps'),
	(658515, 135, '2015-01-15 00:02:07.000000', 'consum', 0.0283, 'lps'),
	(658516, 135, '2015-01-15 00:02:08.000000', 'consum', 0.0214, 'lps'),
	(658517, 135, '2015-01-15 00:02:09.000000', 'consum', 0.0236, 'lps'),
	(658518, 135, '2015-01-15 00:02:10.000000', 'consum', 0.0255, 'lps'),
	(658519, 135, '2015-01-15 00:02:11.000000', 'consum', 0.0283, 'lps'),
	(658520, 135, '2015-01-15 00:02:12.000000', 'consum', 0.0219, 'lps'),
	(658521, 135, '2015-01-15 00:02:13.000000', 'consum', 0.0256, 'lps'),
	(658522, 135, '2015-01-15 00:02:14.000000', 'consum', 0.0268, 'lps'),
	(658523, 135, '2015-01-15 00:02:15.000000', 'consum', 0.0215, 'lps'),
	(658524, 135, '2015-01-15 00:02:16.000000', 'consum', 0.0281, 'lps'),
	(658525, 135, '2015-01-15 00:02:17.000000', 'consum', 0.0255, 'lps'),
	(658526, 135, '2015-01-15 00:02:18.000000', 'consum', 0.0223, 'lps'),
	(658527, 135, '2015-01-15 00:02:19.000000', 'consum', 0.0214, 'lps'),
	(658528, 135, '2015-01-15 00:02:20.000000', 'consum', 0.0265, 'lps'),
	(658529, 135, '2015-01-15 00:02:21.000000', 'consum', 0.0250, 'lps'),
	(658530, 135, '2015-01-15 00:02:22.000000', 'consum', 0.0249, 'lps'),
	(658531, 135, '2015-01-15 00:02:23.000000', 'consum', 0.0283, 'lps'),
	(658532, 135, '2015-01-15 00:02:24.000000', 'consum', 0.0236, 'lps'),
	(658533, 135, '2015-01-15 00:02:25.000000', 'consum', 0.0269, 'lps'),
	(658534, 135, '2015-01-15 00:02:26.000000', 'consum', 0.0282, 'lps'),
	(658535, 135, '2015-01-15 00:02:27.000000', 'consum', 0.0245, 'lps'),
	(658536, 135, '2015-01-15 00:02:28.000000', 'consum', 0.0243, 'lps'),
	(658537, 135, '2015-01-15 00:02:29.000000', 'consum', 0.0270, 'lps'),
	(658538, 135, '2015-01-15 00:02:30.000000', 'consum', 0.0265, 'lps'),
	(658539, 135, '2015-01-15 00:02:31.000000', 'consum', 0.0231, 'lps'),
	(658540, 135, '2015-01-15 00:02:32.000000', 'consum', 0.0224, 'lps'),
	(658541, 135, '2015-01-15 00:02:33.000000', 'consum', 0.0218, 'lps'),
	(658542, 135, '2015-01-15 00:02:34.000000', 'consum', 0.0282, 'lps'),
	(658543, 135, '2015-01-15 00:02:35.000000', 'consum', 0.0249, 'lps'),
	(658544, 135, '2015-01-15 00:02:36.000000', 'consum', 0.0267, 'lps'),
	(658545, 135, '2015-01-15 00:02:37.000000', 'consum', 0.0228, 'lps'),
	(658546, 135, '2015-01-15 00:02:38.000000', 'consum', 0.0279, 'lps'),
	(658547, 135, '2015-01-15 00:02:39.000000', 'consum', 0.0278, 'lps'),
	(658548, 135, '2015-01-15 00:02:40.000000', 'consum', 0.0270, 'lps'),
	(658549, 135, '2015-01-15 00:02:41.000000', 'consum', 0.0233, 'lps'),
	(658550, 135, '2015-01-15 00:02:42.000000', 'consum', 0.0221, 'lps'),
	(658551, 135, '2015-01-15 00:02:43.000000', 'consum', 0.0270, 'lps'),
	(658552, 135, '2015-01-15 00:02:44.000000', 'consum', 0.0255, 'lps'),
	(658553, 135, '2015-01-15 00:02:45.000000', 'consum', 0.0256, 'lps'),
	(658554, 135, '2015-01-15 00:02:46.000000', 'consum', 0.0233, 'lps'),
	(658555, 135, '2015-01-15 00:02:47.000000', 'consum', 0.0260, 'lps'),
	(658556, 135, '2015-01-15 00:02:48.000000', 'consum', 0.0242, 'lps'),
	(658557, 135, '2015-01-15 00:02:49.000000', 'consum', 0.0221, 'lps'),
	(658558, 135, '2015-01-15 00:02:50.000000', 'consum', 0.0245, 'lps'),
	(658559, 135, '2015-01-15 00:02:51.000000', 'consum', 0.0278, 'lps'),
	(658560, 135, '2015-01-15 00:02:52.000000', 'consum', 0.0224, 'lps'),
	(658561, 135, '2015-01-15 00:02:53.000000', 'consum', 0.0226, 'lps'),
	(658562, 135, '2015-01-15 00:02:54.000000', 'consum', 0.0245, 'lps'),
	(658563, 135, '2015-01-15 00:02:55.000000', 'consum', 0.0266, 'lps'),
	(658564, 135, '2015-01-15 00:02:56.000000', 'consum', 0.0235, 'lps'),
	(658565, 135, '2015-01-15 00:02:57.000000', 'consum', 0.0244, 'lps'),
	(658566, 135, '2015-01-15 00:02:58.000000', 'consum', 0.0229, 'lps'),
	(658567, 135, '2015-01-15 00:02:59.000000', 'consum', 0.0280, 'lps'),
	(658568, 135, '2015-01-15 00:03:00.000000', 'consum', 0.0280, 'lps'),
	(658569, 135, '2015-01-15 00:03:01.000000', 'consum', 0.0279, 'lps'),
	(658570, 135, '2015-01-15 00:03:02.000000', 'consum', 0.0269, 'lps'),
	(658571, 135, '2015-01-15 00:03:03.000000', 'consum', 0.0227, 'lps'),
	(658572, 135, '2015-01-15 00:03:04.000000', 'consum', 0.0265, 'lps'),
	(658573, 135, '2015-01-15 00:03:05.000000', 'consum', 0.0214, 'lps'),
	(658574, 135, '2015-01-15 00:03:06.000000', 'consum', 0.0212, 'lps'),
	(658575, 135, '2015-01-15 00:03:07.000000', 'consum', 0.0283, 'lps'),
	(658576, 135, '2015-01-15 00:03:08.000000', 'consum', 0.0275, 'lps'),
	(658577, 135, '2015-01-15 00:03:09.000000', 'consum', 0.0243, 'lps'),
	(658578, 135, '2015-01-15 00:03:10.000000', 'consum', 0.0252, 'lps'),
	(658579, 135, '2015-01-15 00:03:11.000000', 'consum', 0.0250, 'lps'),
	(658580, 135, '2015-01-15 00:03:12.000000', 'consum', 0.0211, 'lps'),
	(658581, 135, '2015-01-15 00:03:13.000000', 'consum', 0.0244, 'lps'),
	(658582, 135, '2015-01-15 00:03:14.000000', 'consum', 0.0226, 'lps'),
	(658583, 135, '2015-01-15 00:03:15.000000', 'consum', 0.0266, 'lps'),
	(658584, 135, '2015-01-15 00:03:16.000000', 'consum', 0.0219, 'lps'),
	(658585, 135, '2015-01-15 00:03:17.000000', 'consum', 0.0238, 'lps'),
	(658586, 135, '2015-01-15 00:03:18.000000', 'consum', 0.0247, 'lps'),
	(658587, 135, '2015-01-15 00:03:19.000000', 'consum', 0.0237, 'lps'),
	(658588, 135, '2015-01-15 00:03:20.000000', 'consum', 0.0236, 'lps'),
	(658589, 135, '2015-01-15 00:03:21.000000', 'consum', 0.0261, 'lps'),
	(658590, 135, '2015-01-15 00:03:22.000000', 'consum', 0.0237, 'lps'),
	(658591, 135, '2015-01-15 00:03:23.000000', 'consum', 0.0269, 'lps'),
	(658592, 135, '2015-01-15 00:03:24.000000', 'consum', 0.0277, 'lps'),
	(658593, 135, '2015-01-15 00:03:25.000000', 'consum', 0.0217, 'lps'),
	(658594, 135, '2015-01-15 00:03:26.000000', 'consum', 0.0270, 'lps'),
	(658595, 135, '2015-01-15 00:03:27.000000', 'consum', 0.0267, 'lps'),
	(658596, 135, '2015-01-15 00:03:28.000000', 'consum', 0.0239, 'lps'),
	(658597, 135, '2015-01-15 00:03:29.000000', 'consum', 0.0261, 'lps'),
	(658598, 135, '2015-01-15 00:03:30.000000', 'consum', 0.0232, 'lps'),
	(658599, 135, '2015-01-15 00:03:31.000000', 'consum', 0.0239, 'lps'),
	(658600, 135, '2015-01-15 00:03:32.000000', 'consum', 0.0217, 'lps'),
	(658601, 135, '2015-01-15 00:03:33.000000', 'consum', 0.0231, 'lps'),
	(658602, 135, '2015-01-15 00:03:34.000000', 'consum', 0.0221, 'lps'),
	(658603, 135, '2015-01-15 00:03:35.000000', 'consum', 0.0277, 'lps'),
	(658604, 135, '2015-01-15 00:03:36.000000', 'consum', 0.0215, 'lps'),
	(658605, 135, '2015-01-15 00:03:37.000000', 'consum', 0.0257, 'lps'),
	(658606, 135, '2015-01-15 00:03:38.000000', 'consum', 0.0211, 'lps'),
	(658607, 135, '2015-01-15 00:03:39.000000', 'consum', 0.0220, 'lps'),
	(658608, 135, '2015-01-15 00:03:40.000000', 'consum', 0.0257, 'lps'),
	(658609, 135, '2015-01-15 00:03:41.000000', 'consum', 0.0270, 'lps'),
	(658610, 135, '2015-01-15 00:03:42.000000', 'consum', 0.0220, 'lps'),
	(658611, 135, '2015-01-15 00:03:43.000000', 'consum', 0.0227, 'lps'),
	(658612, 135, '2015-01-15 00:03:44.000000', 'consum', 0.0267, 'lps'),
	(658613, 135, '2015-01-15 00:03:45.000000', 'consum', 0.0221, 'lps'),
	(658614, 135, '2015-01-15 00:03:46.000000', 'consum', 0.0245, 'lps'),
	(658615, 135, '2015-01-15 00:03:47.000000', 'consum', 0.0278, 'lps'),
	(658616, 135, '2015-01-15 00:03:48.000000', 'consum', 0.0224, 'lps'),
	(658617, 135, '2015-01-15 00:03:49.000000', 'consum', 0.0222, 'lps'),
	(658618, 135, '2015-01-15 00:03:50.000000', 'consum', 0.0231, 'lps'),
	(658619, 135, '2015-01-15 00:03:51.000000', 'consum', 0.0278, 'lps'),
	(658620, 135, '2015-01-15 00:03:52.000000', 'consum', 0.0267, 'lps'),
	(658621, 135, '2015-01-15 00:03:53.000000', 'consum', 0.0218, 'lps'),
	(658622, 135, '2015-01-15 00:03:54.000000', 'consum', 0.0228, 'lps'),
	(658623, 135, '2015-01-15 00:03:55.000000', 'consum', 0.0276, 'lps'),
	(658624, 135, '2015-01-15 00:03:56.000000', 'consum', 0.0265, 'lps'),
	(658625, 135, '2015-01-15 00:03:57.000000', 'consum', 0.0214, 'lps'),
	(658626, 135, '2015-01-15 00:03:58.000000', 'consum', 0.0214, 'lps'),
	(658627, 135, '2015-01-15 00:03:59.000000', 'consum', 0.0219, 'lps'),
	(658628, 135, '2015-01-15 00:04:00.000000', 'consum', 0.0241, 'lps'),
	(658629, 135, '2015-01-15 00:04:01.000000', 'consum', 0.0266, 'lps'),
	(658630, 135, '2015-01-15 00:04:02.000000', 'consum', 0.0250, 'lps'),
	(658631, 135, '2015-01-15 00:04:03.000000', 'consum', 0.0244, 'lps'),
	(658632, 135, '2015-01-15 00:04:04.000000', 'consum', 0.0259, 'lps'),
	(658633, 135, '2015-01-15 00:04:05.000000', 'consum', 0.0281, 'lps'),
	(658634, 135, '2015-01-15 00:04:06.000000', 'consum', 0.0269, 'lps'),
	(658635, 135, '2015-01-15 00:04:07.000000', 'consum', 0.0217, 'lps'),
	(658636, 135, '2015-01-15 00:04:08.000000', 'consum', 0.0219, 'lps'),
	(658637, 135, '2015-01-15 00:04:09.000000', 'consum', 0.0234, 'lps'),
	(658638, 135, '2015-01-15 00:04:10.000000', 'consum', 0.0231, 'lps'),
	(658639, 135, '2015-01-15 00:04:11.000000', 'consum', 0.0244, 'lps'),
	(658640, 135, '2015-01-15 00:04:12.000000', 'consum', 0.0242, 'lps'),
	(658641, 135, '2015-01-15 00:04:13.000000', 'consum', 0.0269, 'lps'),
	(658642, 135, '2015-01-15 00:04:14.000000', 'consum', 0.0261, 'lps'),
	(658643, 135, '2015-01-15 00:04:15.000000', 'consum', 0.0215, 'lps'),
	(658644, 135, '2015-01-15 00:04:16.000000', 'consum', 0.0230, 'lps'),
	(658645, 135, '2015-01-15 00:04:17.000000', 'consum', 0.0222, 'lps'),
	(658646, 135, '2015-01-15 00:04:18.000000', 'consum', 0.0210, 'lps'),
	(658647, 135, '2015-01-15 00:04:19.000000', 'consum', 0.0250, 'lps'),
	(658648, 135, '2015-01-15 00:04:20.000000', 'consum', 0.0262, 'lps'),
	(658649, 135, '2015-01-15 00:04:21.000000', 'consum', 0.0278, 'lps'),
	(658650, 135, '2015-01-15 00:04:22.000000', 'consum', 0.0246, 'lps'),
	(658651, 135, '2015-01-15 00:04:23.000000', 'consum', 0.0261, 'lps'),
	(658652, 135, '2015-01-15 00:04:24.000000', 'consum', 0.0282, 'lps'),
	(658653, 135, '2015-01-15 00:04:25.000000', 'consum', 0.0268, 'lps'),
	(658654, 135, '2015-01-15 00:04:26.000000', 'consum', 0.0212, 'lps'),
	(658655, 135, '2015-01-15 00:04:27.000000', 'consum', 0.0268, 'lps'),
	(658656, 135, '2015-01-15 00:04:28.000000', 'consum', 0.0275, 'lps'),
	(658657, 135, '2015-01-15 00:04:29.000000', 'consum', 0.0210, 'lps'),
	(658658, 135, '2015-01-15 00:04:30.000000', 'consum', 0.0240, 'lps'),
	(658659, 135, '2015-01-15 00:04:31.000000', 'consum', 0.0211, 'lps'),
	(658660, 135, '2015-01-15 00:04:32.000000', 'consum', 0.0275, 'lps'),
	(658661, 135, '2015-01-15 00:04:33.000000', 'consum', 0.0234, 'lps'),
	(658662, 135, '2015-01-15 00:04:34.000000', 'consum', 0.0213, 'lps'),
	(658663, 135, '2015-01-15 00:04:35.000000', 'consum', 0.0225, 'lps'),
	(658664, 135, '2015-01-15 00:04:36.000000', 'consum', 0.0276, 'lps'),
	(658665, 135, '2015-01-15 00:04:37.000000', 'consum', 0.0276, 'lps'),
	(658666, 135, '2015-01-15 00:04:38.000000', 'consum', 0.0267, 'lps'),
	(658667, 135, '2015-01-15 00:04:39.000000', 'consum', 0.0222, 'lps'),
	(658668, 135, '2015-01-15 00:04:40.000000', 'consum', 0.0249, 'lps'),
	(658669, 135, '2015-01-15 00:04:41.000000', 'consum', 0.0222, 'lps'),
	(658670, 135, '2015-01-15 00:04:42.000000', 'consum', 0.0225, 'lps'),
	(658671, 135, '2015-01-15 00:04:43.000000', 'consum', 0.0251, 'lps'),
	(658672, 135, '2015-01-15 00:04:44.000000', 'consum', 0.0224, 'lps'),
	(658673, 135, '2015-01-15 00:04:45.000000', 'consum', 0.0230, 'lps'),
	(658674, 135, '2015-01-15 00:04:46.000000', 'consum', 0.0270, 'lps'),
	(658675, 135, '2015-01-15 00:04:47.000000', 'consum', 0.0227, 'lps'),
	(658676, 135, '2015-01-15 00:04:48.000000', 'consum', 0.0265, 'lps'),
	(658677, 135, '2015-01-15 00:04:49.000000', 'consum', 0.0212, 'lps'),
	(658678, 135, '2015-01-15 00:04:50.000000', 'consum', 0.0277, 'lps'),
	(658679, 135, '2015-01-15 00:04:51.000000', 'consum', 0.0243, 'lps'),
	(658680, 135, '2015-01-15 00:04:52.000000', 'consum', 0.0250, 'lps'),
	(658681, 135, '2015-01-15 00:04:53.000000', 'consum', 0.0235, 'lps'),
	(658682, 135, '2015-01-15 00:04:54.000000', 'consum', 0.0215, 'lps'),
	(658683, 135, '2015-01-15 00:04:55.000000', 'consum', 0.0238, 'lps'),
	(658684, 135, '2015-01-15 00:04:56.000000', 'consum', 0.0258, 'lps'),
	(658685, 135, '2015-01-15 00:04:57.000000', 'consum', 0.0221, 'lps'),
	(658686, 135, '2015-01-15 00:04:58.000000', 'consum', 0.0270, 'lps'),
	(658687, 135, '2015-01-15 00:04:59.000000', 'consum', 0.0253, 'lps'),
	(658688, 135, '2015-01-15 00:05:00.000000', 'consum', 0.0245, 'lps'),
	(658689, 135, '2015-01-15 00:05:01.000000', 'consum', 0.0259, 'lps'),
	(658690, 135, '2015-01-15 00:05:02.000000', 'consum', 0.0276, 'lps'),
	(658691, 135, '2015-01-15 00:05:03.000000', 'consum', 0.0245, 'lps'),
	(658692, 135, '2015-01-15 00:05:04.000000', 'consum', 0.0260, 'lps'),
	(658693, 135, '2015-01-15 00:05:05.000000', 'consum', 0.0210, 'lps'),
	(658694, 135, '2015-01-15 00:05:06.000000', 'consum', 0.0281, 'lps'),
	(658695, 135, '2015-01-15 00:05:07.000000', 'consum', 0.0269, 'lps'),
	(658696, 135, '2015-01-15 00:05:08.000000', 'consum', 0.0218, 'lps'),
	(658697, 135, '2015-01-15 00:05:09.000000', 'consum', 0.0222, 'lps'),
	(658698, 135, '2015-01-15 00:05:10.000000', 'consum', 0.0247, 'lps'),
	(658699, 135, '2015-01-15 00:05:11.000000', 'consum', 0.0210, 'lps'),
	(658700, 135, '2015-01-15 00:05:12.000000', 'consum', 0.0247, 'lps'),
	(658701, 135, '2015-01-15 00:05:13.000000', 'consum', 0.0248, 'lps'),
	(658702, 135, '2015-01-15 00:05:14.000000', 'consum', 0.0218, 'lps'),
	(658703, 135, '2015-01-15 00:05:15.000000', 'consum', 0.0283, 'lps'),
	(658704, 135, '2015-01-15 00:05:16.000000', 'consum', 0.0254, 'lps'),
	(658705, 135, '2015-01-15 00:05:17.000000', 'consum', 0.0212, 'lps'),
	(658706, 135, '2015-01-15 00:05:18.000000', 'consum', 0.0237, 'lps'),
	(658707, 135, '2015-01-15 00:05:19.000000', 'consum', 0.0266, 'lps'),
	(658708, 135, '2015-01-15 00:05:20.000000', 'consum', 0.0260, 'lps'),
	(658709, 135, '2015-01-15 00:05:21.000000', 'consum', 0.0218, 'lps'),
	(658710, 135, '2015-01-15 00:05:22.000000', 'consum', 0.0248, 'lps'),
	(658711, 135, '2015-01-15 00:05:23.000000', 'consum', 0.0228, 'lps'),
	(658712, 135, '2015-01-15 00:05:24.000000', 'consum', 0.0260, 'lps'),
	(658713, 135, '2015-01-15 00:05:25.000000', 'consum', 0.0261, 'lps'),
	(658714, 135, '2015-01-15 00:05:26.000000', 'consum', 0.0243, 'lps'),
	(658715, 135, '2015-01-15 00:05:27.000000', 'consum', 0.0219, 'lps'),
	(658716, 135, '2015-01-15 00:05:28.000000', 'consum', 0.0233, 'lps'),
	(658717, 135, '2015-01-15 00:05:29.000000', 'consum', 0.0222, 'lps'),
	(658718, 135, '2015-01-15 00:05:30.000000', 'consum', 0.0278, 'lps'),
	(658719, 135, '2015-01-15 00:05:31.000000', 'consum', 0.0218, 'lps'),
	(658720, 135, '2015-01-15 00:05:32.000000', 'consum', 0.0266, 'lps'),
	(658721, 135, '2015-01-15 00:05:33.000000', 'consum', 0.0247, 'lps'),
	(658722, 135, '2015-01-15 00:05:34.000000', 'consum', 0.0227, 'lps'),
	(658723, 135, '2015-01-15 00:05:35.000000', 'consum', 0.0258, 'lps'),
	(658724, 135, '2015-01-15 00:05:36.000000', 'consum', 0.0250, 'lps'),
	(658725, 135, '2015-01-15 00:05:37.000000', 'consum', 0.0269, 'lps'),
	(658726, 135, '2015-01-15 00:05:38.000000', 'consum', 0.0237, 'lps'),
	(658727, 135, '2015-01-15 00:05:39.000000', 'consum', 0.0244, 'lps'),
	(658728, 135, '2015-01-15 00:05:40.000000', 'consum', 0.0223, 'lps'),
	(658729, 135, '2015-01-15 00:05:41.000000', 'consum', 0.0249, 'lps'),
	(658730, 135, '2015-01-15 00:05:42.000000', 'consum', 0.0220, 'lps'),
	(658731, 135, '2015-01-15 00:05:43.000000', 'consum', 0.0217, 'lps'),
	(658732, 135, '2015-01-15 00:05:44.000000', 'consum', 0.0215, 'lps'),
	(658733, 135, '2015-01-15 00:05:45.000000', 'consum', 0.0216, 'lps'),
	(658734, 135, '2015-01-15 00:05:46.000000', 'consum', 0.0223, 'lps'),
	(658735, 135, '2015-01-15 00:05:47.000000', 'consum', 0.0257, 'lps'),
	(658736, 135, '2015-01-15 00:05:48.000000', 'consum', 0.0259, 'lps'),
	(658737, 135, '2015-01-15 00:05:49.000000', 'consum', 0.0242, 'lps'),
	(658738, 135, '2015-01-15 00:05:50.000000', 'consum', 0.0222, 'lps'),
	(658739, 135, '2015-01-15 00:05:51.000000', 'consum', 0.0248, 'lps'),
	(658740, 135, '2015-01-15 00:05:52.000000', 'consum', 0.0217, 'lps'),
	(658741, 135, '2015-01-15 00:05:53.000000', 'consum', 0.0278, 'lps'),
	(658742, 135, '2015-01-15 00:05:54.000000', 'consum', 0.0233, 'lps'),
	(658743, 135, '2015-01-15 00:05:55.000000', 'consum', 0.0272, 'lps'),
	(658744, 135, '2015-01-15 00:05:56.000000', 'consum', 0.0229, 'lps'),
	(658745, 135, '2015-01-15 00:05:57.000000', 'consum', 0.0268, 'lps'),
	(658746, 135, '2015-01-15 00:05:58.000000', 'consum', 0.0221, 'lps'),
	(658747, 135, '2015-01-15 00:05:59.000000', 'consum', 0.0240, 'lps'),
	(658748, 135, '2015-01-15 00:06:00.000000', 'consum', 0.0254, 'lps'),
	(658749, 135, '2015-01-15 00:06:01.000000', 'consum', 0.0264, 'lps'),
	(658750, 135, '2015-01-15 00:06:02.000000', 'consum', 0.0276, 'lps'),
	(658751, 135, '2015-01-15 00:06:03.000000', 'consum', 0.0232, 'lps'),
	(658752, 135, '2015-01-15 00:06:04.000000', 'consum', 0.0267, 'lps'),
	(658753, 135, '2015-01-15 00:06:05.000000', 'consum', 0.0211, 'lps'),
	(658754, 135, '2015-01-15 00:06:06.000000', 'consum', 0.0266, 'lps'),
	(658755, 135, '2015-01-15 00:06:07.000000', 'consum', 0.0265, 'lps'),
	(658756, 135, '2015-01-15 00:06:08.000000', 'consum', 0.0245, 'lps'),
	(658757, 135, '2015-01-15 00:06:09.000000', 'consum', 0.0221, 'lps'),
	(658758, 135, '2015-01-15 00:06:10.000000', 'consum', 0.0233, 'lps'),
	(658759, 135, '2015-01-15 00:06:11.000000', 'consum', 0.0219, 'lps'),
	(658760, 135, '2015-01-15 00:06:12.000000', 'consum', 0.0259, 'lps'),
	(658761, 135, '2015-01-15 00:06:13.000000', 'consum', 0.0279, 'lps'),
	(658762, 135, '2015-01-15 00:06:14.000000', 'consum', 0.0264, 'lps'),
	(658763, 135, '2015-01-15 00:06:15.000000', 'consum', 0.0270, 'lps'),
	(658764, 135, '2015-01-15 00:06:16.000000', 'consum', 0.0278, 'lps'),
	(658765, 135, '2015-01-15 00:06:17.000000', 'consum', 0.0219, 'lps'),
	(658766, 135, '2015-01-15 00:06:18.000000', 'consum', 0.0275, 'lps'),
	(658767, 135, '2015-01-15 00:06:19.000000', 'consum', 0.0213, 'lps'),
	(658768, 135, '2015-01-15 00:06:20.000000', 'consum', 0.0250, 'lps'),
	(658769, 135, '2015-01-15 00:06:21.000000', 'consum', 0.0255, 'lps'),
	(658770, 135, '2015-01-15 00:06:22.000000', 'consum', 0.0242, 'lps'),
	(658771, 135, '2015-01-15 00:06:23.000000', 'consum', 0.0235, 'lps'),
	(658772, 135, '2015-01-15 00:06:24.000000', 'consum', 0.0240, 'lps'),
	(658773, 135, '2015-01-15 00:06:25.000000', 'consum', 0.0211, 'lps'),
	(658774, 135, '2015-01-15 00:06:26.000000', 'consum', 0.0274, 'lps'),
	(658775, 135, '2015-01-15 00:06:27.000000', 'consum', 0.0233, 'lps'),
	(658776, 135, '2015-01-15 00:06:28.000000', 'consum', 0.0281, 'lps'),
	(658777, 135, '2015-01-15 00:06:29.000000', 'consum', 0.0276, 'lps'),
	(658778, 135, '2015-01-15 00:06:30.000000', 'consum', 0.0251, 'lps'),
	(658779, 135, '2015-01-15 00:06:31.000000', 'consum', 0.0219, 'lps'),
	(658780, 135, '2015-01-15 00:06:32.000000', 'consum', 0.0280, 'lps'),
	(658781, 135, '2015-01-15 00:06:33.000000', 'consum', 0.0238, 'lps'),
	(658782, 135, '2015-01-15 00:06:34.000000', 'consum', 0.0214, 'lps'),
	(658783, 135, '2015-01-15 00:06:35.000000', 'consum', 0.0223, 'lps'),
	(658784, 135, '2015-01-15 00:06:36.000000', 'consum', 0.0260, 'lps'),
	(658785, 135, '2015-01-15 00:06:37.000000', 'consum', 0.0274, 'lps'),
	(658786, 135, '2015-01-15 00:06:38.000000', 'consum', 0.0231, 'lps'),
	(658787, 135, '2015-01-15 00:06:39.000000', 'consum', 0.0274, 'lps'),
	(658788, 135, '2015-01-15 00:06:40.000000', 'consum', 0.0243, 'lps'),
	(658789, 135, '2015-01-15 00:06:41.000000', 'consum', 0.0259, 'lps'),
	(658790, 135, '2015-01-15 00:06:42.000000', 'consum', 0.0210, 'lps'),
	(658791, 135, '2015-01-15 00:06:43.000000', 'consum', 0.0210, 'lps'),
	(658792, 135, '2015-01-15 00:06:44.000000', 'consum', 0.0213, 'lps'),
	(658793, 135, '2015-01-15 00:06:45.000000', 'consum', 0.0223, 'lps'),
	(658794, 135, '2015-01-15 00:06:46.000000', 'consum', 0.0266, 'lps'),
	(658795, 135, '2015-01-15 00:06:47.000000', 'consum', 0.0231, 'lps'),
	(658796, 135, '2015-01-15 00:06:48.000000', 'consum', 0.0220, 'lps'),
	(658797, 135, '2015-01-15 00:06:49.000000', 'consum', 0.0274, 'lps'),
	(658798, 135, '2015-01-15 00:06:50.000000', 'consum', 0.0278, 'lps'),
	(658799, 135, '2015-01-15 00:06:51.000000', 'consum', 0.0283, 'lps'),
	(658800, 135, '2015-01-15 00:06:52.000000', 'consum', 0.0222, 'lps'),
	(658801, 135, '2015-01-15 00:06:53.000000', 'consum', 0.0276, 'lps'),
	(658802, 135, '2015-01-15 00:06:54.000000', 'consum', 0.0283, 'lps'),
	(658803, 135, '2015-01-15 00:06:55.000000', 'consum', 0.0228, 'lps'),
	(658804, 135, '2015-01-15 00:06:56.000000', 'consum', 0.0230, 'lps'),
	(658805, 135, '2015-01-15 00:06:57.000000', 'consum', 0.0256, 'lps'),
	(658806, 135, '2015-01-15 00:06:58.000000', 'consum', 0.0233, 'lps'),
	(658807, 135, '2015-01-15 00:06:59.000000', 'consum', 0.0262, 'lps'),
	(658808, 135, '2015-01-15 00:07:00.000000', 'consum', 0.0254, 'lps'),
	(658809, 135, '2015-01-15 00:07:01.000000', 'consum', 0.0275, 'lps'),
	(658810, 135, '2015-01-15 00:07:02.000000', 'consum', 0.0255, 'lps'),
	(658811, 135, '2015-01-15 00:07:03.000000', 'consum', 0.0240, 'lps'),
	(658812, 135, '2015-01-15 00:07:04.000000', 'consum', 0.0226, 'lps'),
	(658813, 135, '2015-01-15 00:07:05.000000', 'consum', 0.0274, 'lps'),
	(658814, 135, '2015-01-15 00:07:06.000000', 'consum', 0.0261, 'lps'),
	(658815, 135, '2015-01-15 00:07:07.000000', 'consum', 0.0274, 'lps'),
	(658816, 135, '2015-01-15 00:07:08.000000', 'consum', 0.0231, 'lps'),
	(658817, 135, '2015-01-15 00:07:09.000000', 'consum', 0.0270, 'lps'),
	(658818, 135, '2015-01-15 00:07:10.000000', 'consum', 0.0227, 'lps'),
	(658819, 135, '2015-01-15 00:07:11.000000', 'consum', 0.0261, 'lps'),
	(658820, 135, '2015-01-15 00:07:12.000000', 'consum', 0.0269, 'lps'),
	(658821, 135, '2015-01-15 00:07:13.000000', 'consum', 0.0279, 'lps'),
	(658822, 135, '2015-01-15 00:07:14.000000', 'consum', 0.0228, 'lps'),
	(658823, 135, '2015-01-15 00:07:15.000000', 'consum', 0.0241, 'lps'),
	(658824, 135, '2015-01-15 00:07:16.000000', 'consum', 0.0239, 'lps'),
	(658825, 135, '2015-01-15 00:07:17.000000', 'consum', 0.0260, 'lps'),
	(658826, 135, '2015-01-15 00:07:18.000000', 'consum', 0.0228, 'lps'),
	(658827, 135, '2015-01-15 00:07:19.000000', 'consum', 0.0225, 'lps'),
	(658828, 135, '2015-01-15 00:07:20.000000', 'consum', 0.0231, 'lps'),
	(658829, 135, '2015-01-15 00:07:21.000000', 'consum', 0.0271, 'lps'),
	(658830, 135, '2015-01-15 00:07:22.000000', 'consum', 0.0228, 'lps'),
	(658831, 135, '2015-01-15 00:07:23.000000', 'consum', 0.0268, 'lps'),
	(658832, 135, '2015-01-15 00:07:24.000000', 'consum', 0.0224, 'lps'),
	(658833, 135, '2015-01-15 00:07:25.000000', 'consum', 0.0255, 'lps'),
	(658834, 135, '2015-01-15 00:07:26.000000', 'consum', 0.0246, 'lps'),
	(658835, 135, '2015-01-15 00:07:27.000000', 'consum', 0.0254, 'lps'),
	(658836, 135, '2015-01-15 00:07:28.000000', 'consum', 0.0251, 'lps'),
	(658837, 135, '2015-01-15 00:07:29.000000', 'consum', 0.0282, 'lps'),
	(658838, 135, '2015-01-15 00:07:30.000000', 'consum', 0.0226, 'lps'),
	(658839, 135, '2015-01-15 00:07:31.000000', 'consum', 0.0223, 'lps'),
	(658840, 135, '2015-01-15 00:07:32.000000', 'consum', 0.0229, 'lps'),
	(658841, 135, '2015-01-15 00:07:33.000000', 'consum', 0.0265, 'lps'),
	(658842, 135, '2015-01-15 00:07:34.000000', 'consum', 0.0279, 'lps'),
	(658843, 135, '2015-01-15 00:07:35.000000', 'consum', 0.0244, 'lps'),
	(658844, 135, '2015-01-15 00:07:36.000000', 'consum', 0.0246, 'lps'),
	(658845, 135, '2015-01-15 00:07:37.000000', 'consum', 0.0214, 'lps'),
	(658846, 135, '2015-01-15 00:07:38.000000', 'consum', 0.0271, 'lps'),
	(658847, 135, '2015-01-15 00:07:39.000000', 'consum', 0.0210, 'lps'),
	(658848, 135, '2015-01-15 00:07:40.000000', 'consum', 0.0246, 'lps'),
	(658849, 135, '2015-01-15 00:07:41.000000', 'consum', 0.0245, 'lps'),
	(658850, 135, '2015-01-15 00:07:42.000000', 'consum', 0.0278, 'lps'),
	(658851, 135, '2015-01-15 00:07:43.000000', 'consum', 0.0223, 'lps'),
	(658852, 135, '2015-01-15 00:07:44.000000', 'consum', 0.0221, 'lps'),
	(658853, 135, '2015-01-15 00:07:45.000000', 'consum', 0.0224, 'lps'),
	(658854, 135, '2015-01-15 00:07:46.000000', 'consum', 0.0248, 'lps'),
	(658855, 135, '2015-01-15 00:07:47.000000', 'consum', 0.0211, 'lps'),
	(658856, 135, '2015-01-15 00:07:48.000000', 'consum', 0.0248, 'lps'),
	(658857, 135, '2015-01-15 00:07:49.000000', 'consum', 0.0251, 'lps'),
	(658858, 135, '2015-01-15 00:07:50.000000', 'consum', 0.0228, 'lps'),
	(658859, 135, '2015-01-15 00:07:51.000000', 'consum', 0.0253, 'lps'),
	(658860, 135, '2015-01-15 00:07:52.000000', 'consum', 0.0222, 'lps'),
	(658861, 135, '2015-01-15 00:07:53.000000', 'consum', 0.0215, 'lps'),
	(658862, 135, '2015-01-15 00:07:54.000000', 'consum', 0.0273, 'lps'),
	(658863, 135, '2015-01-15 00:07:55.000000', 'consum', 0.0214, 'lps'),
	(658864, 135, '2015-01-15 00:07:56.000000', 'consum', 0.0266, 'lps'),
	(658865, 135, '2015-01-15 00:07:57.000000', 'consum', 0.0256, 'lps'),
	(658866, 135, '2015-01-15 00:07:58.000000', 'consum', 0.0273, 'lps'),
	(658867, 135, '2015-01-15 00:07:59.000000', 'consum', 0.0238, 'lps'),
	(658868, 135, '2015-01-15 00:08:00.000000', 'consum', 0.0237, 'lps'),
	(658869, 135, '2015-01-15 00:08:01.000000', 'consum', 0.0262, 'lps'),
	(658870, 135, '2015-01-15 00:08:02.000000', 'consum', 0.0241, 'lps'),
	(658871, 135, '2015-01-15 00:08:03.000000', 'consum', 0.0282, 'lps'),
	(658872, 135, '2015-01-15 00:08:04.000000', 'consum', 0.0258, 'lps'),
	(658873, 135, '2015-01-15 00:08:05.000000', 'consum', 0.0233, 'lps'),
	(658874, 135, '2015-01-15 00:08:06.000000', 'consum', 0.0256, 'lps'),
	(658875, 135, '2015-01-15 00:08:07.000000', 'consum', 0.0224, 'lps'),
	(658876, 135, '2015-01-15 00:08:08.000000', 'consum', 0.0217, 'lps'),
	(658877, 135, '2015-01-15 00:08:09.000000', 'consum', 0.0276, 'lps'),
	(658878, 135, '2015-01-15 00:08:10.000000', 'consum', 0.0223, 'lps'),
	(658879, 135, '2015-01-15 00:08:11.000000', 'consum', 0.0225, 'lps'),
	(658880, 135, '2015-01-15 00:08:12.000000', 'consum', 0.0248, 'lps'),
	(658881, 135, '2015-01-15 00:08:13.000000', 'consum', 0.0281, 'lps'),
	(658882, 135, '2015-01-15 00:08:14.000000', 'consum', 0.0231, 'lps'),
	(658883, 135, '2015-01-15 00:08:15.000000', 'consum', 0.0252, 'lps'),
	(658884, 135, '2015-01-15 00:08:16.000000', 'consum', 0.0280, 'lps'),
	(658885, 135, '2015-01-15 00:08:17.000000', 'consum', 0.0213, 'lps'),
	(658886, 135, '2015-01-15 00:08:18.000000', 'consum', 0.0239, 'lps'),
	(658887, 135, '2015-01-15 00:08:19.000000', 'consum', 0.0270, 'lps'),
	(658888, 135, '2015-01-15 00:08:20.000000', 'consum', 0.0276, 'lps'),
	(658889, 135, '2015-01-15 00:08:21.000000', 'consum', 0.0215, 'lps'),
	(658890, 135, '2015-01-15 00:08:22.000000', 'consum', 0.0258, 'lps'),
	(658891, 135, '2015-01-15 00:08:23.000000', 'consum', 0.0212, 'lps'),
	(658892, 135, '2015-01-15 00:08:24.000000', 'consum', 0.0225, 'lps'),
	(658893, 135, '2015-01-15 00:08:25.000000', 'consum', 0.0279, 'lps'),
	(658894, 135, '2015-01-15 00:08:26.000000', 'consum', 0.0215, 'lps'),
	(658895, 135, '2015-01-15 00:08:27.000000', 'consum', 0.0248, 'lps'),
	(658896, 135, '2015-01-15 00:08:28.000000', 'consum', 0.0241, 'lps'),
	(658897, 135, '2015-01-15 00:08:29.000000', 'consum', 0.0252, 'lps'),
	(658898, 135, '2015-01-15 00:08:30.000000', 'consum', 0.0252, 'lps'),
	(658899, 135, '2015-01-15 00:08:31.000000', 'consum', 0.0219, 'lps'),
	(658900, 135, '2015-01-15 00:08:32.000000', 'consum', 0.0281, 'lps'),
	(658901, 135, '2015-01-15 00:08:33.000000', 'consum', 0.0239, 'lps'),
	(658902, 135, '2015-01-15 00:08:34.000000', 'consum', 0.0217, 'lps'),
	(658903, 135, '2015-01-15 00:08:35.000000', 'consum', 0.0235, 'lps'),
	(658904, 135, '2015-01-15 00:08:36.000000', 'consum', 0.0237, 'lps'),
	(658905, 135, '2015-01-15 00:08:37.000000', 'consum', 0.0273, 'lps'),
	(658906, 135, '2015-01-15 00:08:38.000000', 'consum', 0.0222, 'lps'),
	(658907, 135, '2015-01-15 00:08:39.000000', 'consum', 0.0230, 'lps'),
	(658908, 135, '2015-01-15 00:08:40.000000', 'consum', 0.0272, 'lps'),
	(658909, 135, '2015-01-15 00:08:41.000000', 'consum', 0.0241, 'lps'),
	(658910, 135, '2015-01-15 00:08:42.000000', 'consum', 0.0251, 'lps'),
	(658911, 135, '2015-01-15 00:08:43.000000', 'consum', 0.0248, 'lps'),
	(658912, 135, '2015-01-15 00:08:44.000000', 'consum', 0.0280, 'lps'),
	(658913, 135, '2015-01-15 00:08:45.000000', 'consum', 0.0222, 'lps'),
	(658914, 135, '2015-01-15 00:08:46.000000', 'consum', 0.0211, 'lps'),
	(658915, 135, '2015-01-15 00:08:47.000000', 'consum', 0.0255, 'lps'),
	(658916, 135, '2015-01-15 00:08:48.000000', 'consum', 0.0281, 'lps'),
	(658917, 135, '2015-01-15 00:08:49.000000', 'consum', 0.0211, 'lps'),
	(658918, 135, '2015-01-15 00:08:50.000000', 'consum', 0.0225, 'lps'),
	(658919, 135, '2015-01-15 00:08:51.000000', 'consum', 0.0282, 'lps'),
	(658920, 135, '2015-01-15 00:08:52.000000', 'consum', 0.0229, 'lps'),
	(658921, 135, '2015-01-15 00:08:53.000000', 'consum', 0.0238, 'lps'),
	(658922, 135, '2015-01-15 00:08:54.000000', 'consum', 0.0218, 'lps'),
	(658923, 135, '2015-01-15 00:08:55.000000', 'consum', 0.0242, 'lps'),
	(658924, 135, '2015-01-15 00:08:56.000000', 'consum', 0.0270, 'lps'),
	(658925, 135, '2015-01-15 00:08:57.000000', 'consum', 0.0268, 'lps'),
	(658926, 135, '2015-01-15 00:08:58.000000', 'consum', 0.0248, 'lps'),
	(658927, 135, '2015-01-15 00:08:59.000000', 'consum', 0.0227, 'lps'),
	(658928, 135, '2015-01-15 00:09:00.000000', 'consum', 0.0255, 'lps'),
	(658929, 135, '2015-01-15 00:09:01.000000', 'consum', 0.0237, 'lps'),
	(658930, 135, '2015-01-15 00:09:02.000000', 'consum', 0.0211, 'lps'),
	(658931, 135, '2015-01-15 00:09:03.000000', 'consum', 0.0280, 'lps'),
	(658932, 135, '2015-01-15 00:09:04.000000', 'consum', 0.0262, 'lps'),
	(658933, 135, '2015-01-15 00:09:05.000000', 'consum', 0.0262, 'lps'),
	(658934, 135, '2015-01-15 00:09:06.000000', 'consum', 0.0241, 'lps'),
	(658935, 135, '2015-01-15 00:09:07.000000', 'consum', 0.0281, 'lps'),
	(658936, 135, '2015-01-15 00:09:08.000000', 'consum', 0.0252, 'lps'),
	(658937, 135, '2015-01-15 00:09:09.000000', 'consum', 0.0281, 'lps'),
	(658938, 135, '2015-01-15 00:09:10.000000', 'consum', 0.0218, 'lps'),
	(658939, 135, '2015-01-15 00:09:11.000000', 'consum', 0.0259, 'lps'),
	(658940, 135, '2015-01-15 00:09:12.000000', 'consum', 0.0211, 'lps'),
	(658941, 135, '2015-01-15 00:09:13.000000', 'consum', 0.0215, 'lps'),
	(658942, 135, '2015-01-15 00:09:14.000000', 'consum', 0.0234, 'lps'),
	(658943, 135, '2015-01-15 00:09:15.000000', 'consum', 0.0241, 'lps'),
	(658944, 135, '2015-01-15 00:09:16.000000', 'consum', 0.0220, 'lps'),
	(658945, 135, '2015-01-15 00:09:17.000000', 'consum', 0.0240, 'lps'),
	(658946, 135, '2015-01-15 00:09:18.000000', 'consum', 0.0257, 'lps'),
	(658947, 135, '2015-01-15 00:09:19.000000', 'consum', 0.0210, 'lps'),
	(658948, 135, '2015-01-15 00:09:20.000000', 'consum', 0.0215, 'lps'),
	(658949, 135, '2015-01-15 00:09:21.000000', 'consum', 0.0235, 'lps'),
	(658950, 135, '2015-01-15 00:09:22.000000', 'consum', 0.0247, 'lps'),
	(658951, 135, '2015-01-15 00:09:23.000000', 'consum', 0.0249, 'lps'),
	(658952, 135, '2015-01-15 00:09:24.000000', 'consum', 0.0217, 'lps'),
	(658953, 135, '2015-01-15 00:09:25.000000', 'consum', 0.0279, 'lps'),
	(658954, 135, '2015-01-15 00:09:26.000000', 'consum', 0.0237, 'lps'),
	(658955, 135, '2015-01-15 00:09:27.000000', 'consum', 0.0212, 'lps'),
	(658956, 135, '2015-01-15 00:09:28.000000', 'consum', 0.0215, 'lps'),
	(658957, 135, '2015-01-15 00:09:29.000000', 'consum', 0.0228, 'lps'),
	(658958, 135, '2015-01-15 00:09:30.000000', 'consum', 0.0214, 'lps'),
	(658959, 135, '2015-01-15 00:09:31.000000', 'consum', 0.0249, 'lps'),
	(658960, 135, '2015-01-15 00:09:32.000000', 'consum', 0.0247, 'lps'),
	(658961, 135, '2015-01-15 00:09:33.000000', 'consum', 0.0278, 'lps'),
	(658962, 135, '2015-01-15 00:09:34.000000', 'consum', 0.0217, 'lps'),
	(658963, 135, '2015-01-15 00:09:35.000000', 'consum', 0.0265, 'lps'),
	(658964, 135, '2015-01-15 00:09:36.000000', 'consum', 0.0244, 'lps'),
	(658965, 135, '2015-01-15 00:09:37.000000', 'consum', 0.0212, 'lps'),
	(658966, 135, '2015-01-15 00:09:38.000000', 'consum', 0.0268, 'lps'),
	(658967, 135, '2015-01-15 00:09:39.000000', 'consum', 0.0274, 'lps'),
	(658968, 135, '2015-01-15 00:09:40.000000', 'consum', 0.0281, 'lps'),
	(658969, 135, '2015-01-15 00:09:41.000000', 'consum', 0.0225, 'lps'),
	(658970, 135, '2015-01-15 00:09:42.000000', 'consum', 0.0221, 'lps'),
	(658971, 135, '2015-01-15 00:09:43.000000', 'consum', 0.0222, 'lps'),
	(658972, 135, '2015-01-15 00:09:44.000000', 'consum', 0.0238, 'lps'),
	(658973, 135, '2015-01-15 00:09:45.000000', 'consum', 0.0240, 'lps'),
	(658974, 135, '2015-01-15 00:09:46.000000', 'consum', 0.0274, 'lps'),
	(658975, 135, '2015-01-15 00:09:47.000000', 'consum', 0.0220, 'lps'),
	(658976, 135, '2015-01-15 00:09:48.000000', 'consum', 0.0218, 'lps'),
	(658977, 135, '2015-01-15 00:09:49.000000', 'consum', 0.0219, 'lps'),
	(658978, 135, '2015-01-15 00:09:50.000000', 'consum', 0.0232, 'lps'),
	(658979, 135, '2015-01-15 00:09:51.000000', 'consum', 0.0220, 'lps'),
	(658980, 135, '2015-01-15 00:09:52.000000', 'consum', 0.0267, 'lps'),
	(658981, 135, '2015-01-15 00:09:53.000000', 'consum', 0.0242, 'lps'),
	(658982, 135, '2015-01-15 00:09:54.000000', 'consum', 0.0276, 'lps'),
	(658983, 135, '2015-01-15 00:09:55.000000', 'consum', 0.0222, 'lps'),
	(658984, 135, '2015-01-15 00:09:56.000000', 'consum', 0.0220, 'lps'),
	(658985, 135, '2015-01-15 00:09:57.000000', 'consum', 0.0223, 'lps'),
	(658986, 135, '2015-01-15 00:09:58.000000', 'consum', 0.0249, 'lps'),
	(658987, 135, '2015-01-15 00:09:59.000000', 'consum', 0.0216, 'lps'),
	(658988, 135, '2015-01-15 00:10:00.000000', 'consum', 0.0273, 'lps'),
	(658989, 135, '2015-01-15 00:10:01.000000', 'consum', 0.0212, 'lps'),
	(658990, 135, '2015-01-15 00:10:02.000000', 'consum', 0.0251, 'lps'),
	(658991, 135, '2015-01-15 00:10:03.000000', 'consum', 0.0264, 'lps'),
	(658992, 135, '2015-01-15 00:10:04.000000', 'consum', 0.0283, 'lps'),
	(658993, 135, '2015-01-15 00:10:05.000000', 'consum', 0.0265, 'lps'),
	(658994, 135, '2015-01-15 00:10:06.000000', 'consum', 0.0266, 'lps'),
	(658995, 135, '2015-01-15 00:10:07.000000', 'consum', 0.0250, 'lps'),
	(658996, 135, '2015-01-15 00:10:08.000000', 'consum', 0.0243, 'lps'),
	(658997, 135, '2015-01-15 00:10:09.000000', 'consum', 0.0258, 'lps'),
	(658998, 135, '2015-01-15 00:10:10.000000', 'consum', 0.0275, 'lps'),
	(658999, 135, '2015-01-15 00:10:11.000000', 'consum', 0.0243, 'lps'),
	(659000, 135, '2015-01-15 00:10:12.000000', 'consum', 0.0256, 'lps'),
	(659001, 135, '2015-01-15 00:10:13.000000', 'consum', 0.0265, 'lps'),
	(659002, 135, '2015-01-15 00:10:14.000000', 'consum', 0.0275, 'lps'),
	(659003, 135, '2015-01-15 00:10:15.000000', 'consum', 0.0224, 'lps'),
	(659004, 135, '2015-01-15 00:10:16.000000', 'consum', 0.0231, 'lps'),
	(659005, 135, '2015-01-15 00:10:17.000000', 'consum', 0.0273, 'lps'),
	(659006, 135, '2015-01-15 00:10:18.000000', 'consum', 0.0240, 'lps'),
	(659007, 135, '2015-01-15 00:10:19.000000', 'consum', 0.0249, 'lps'),
	(659008, 135, '2015-01-15 00:10:20.000000', 'consum', 0.0238, 'lps'),
	(659009, 135, '2015-01-15 00:10:21.000000', 'consum', 0.0235, 'lps'),
	(659010, 135, '2015-01-15 00:10:22.000000', 'consum', 0.0253, 'lps'),
	(659011, 135, '2015-01-15 00:10:23.000000', 'consum', 0.0275, 'lps'),
	(659012, 135, '2015-01-15 00:10:24.000000', 'consum', 0.0259, 'lps'),
	(659013, 135, '2015-01-15 00:10:25.000000', 'consum', 0.0262, 'lps'),
	(659014, 135, '2015-01-15 00:10:26.000000', 'consum', 0.0250, 'lps'),
	(659015, 135, '2015-01-15 00:10:27.000000', 'consum', 0.0255, 'lps'),
	(659016, 135, '2015-01-15 00:10:28.000000', 'consum', 0.0238, 'lps'),
	(659017, 135, '2015-01-15 00:10:29.000000', 'consum', 0.0219, 'lps'),
	(659018, 135, '2015-01-15 00:10:30.000000', 'consum', 0.0243, 'lps'),
	(659019, 135, '2015-01-15 00:10:31.000000', 'consum', 0.0273, 'lps'),
	(659020, 135, '2015-01-15 00:10:32.000000', 'consum', 0.0281, 'lps'),
	(659021, 135, '2015-01-15 00:10:33.000000', 'consum', 0.0229, 'lps'),
	(659022, 135, '2015-01-15 00:10:34.000000', 'consum', 0.0239, 'lps'),
	(659023, 135, '2015-01-15 00:10:35.000000', 'consum', 0.0227, 'lps'),
	(659024, 135, '2015-01-15 00:10:36.000000', 'consum', 0.0281, 'lps'),
	(659025, 135, '2015-01-15 00:10:37.000000', 'consum', 0.0220, 'lps'),
	(659026, 135, '2015-01-15 00:10:38.000000', 'consum', 0.0270, 'lps'),
	(659027, 135, '2015-01-15 00:10:39.000000', 'consum', 0.0257, 'lps'),
	(659028, 135, '2015-01-15 00:10:40.000000', 'consum', 0.0268, 'lps'),
	(659029, 135, '2015-01-15 00:10:41.000000', 'consum', 0.0283, 'lps'),
	(659030, 135, '2015-01-15 00:10:42.000000', 'consum', 0.0255, 'lps'),
	(659031, 135, '2015-01-15 00:10:43.000000', 'consum', 0.0214, 'lps'),
	(659032, 135, '2015-01-15 00:10:44.000000', 'consum', 0.0247, 'lps'),
	(659033, 135, '2015-01-15 00:10:45.000000', 'consum', 0.0232, 'lps'),
	(659034, 135, '2015-01-15 00:10:46.000000', 'consum', 0.0212, 'lps'),
	(659035, 135, '2015-01-15 00:10:47.000000', 'consum', 0.0229, 'lps'),
	(659036, 135, '2015-01-15 00:10:48.000000', 'consum', 0.0226, 'lps'),
	(659037, 135, '2015-01-15 00:10:49.000000', 'consum', 0.0233, 'lps'),
	(659038, 135, '2015-01-15 00:10:50.000000', 'consum', 0.0276, 'lps'),
	(659039, 135, '2015-01-15 00:10:51.000000', 'consum', 0.0249, 'lps'),
	(659040, 135, '2015-01-15 00:10:52.000000', 'consum', 0.0281, 'lps'),
	(659041, 135, '2015-01-15 00:10:53.000000', 'consum', 0.0226, 'lps'),
	(659042, 135, '2015-01-15 00:10:54.000000', 'consum', 0.0229, 'lps'),
	(659043, 135, '2015-01-15 00:10:55.000000', 'consum', 0.0254, 'lps'),
	(659044, 135, '2015-01-15 00:10:56.000000', 'consum', 0.0228, 'lps'),
	(659045, 135, '2015-01-15 00:10:57.000000', 'consum', 0.0243, 'lps'),
	(659046, 135, '2015-01-15 00:10:58.000000', 'consum', 0.0248, 'lps'),
	(659047, 135, '2015-01-15 00:10:59.000000', 'consum', 0.0226, 'lps'),
	(659048, 135, '2015-01-15 00:11:00.000000', 'consum', 0.0249, 'lps'),
	(659049, 135, '2015-01-15 00:11:01.000000', 'consum', 0.0213, 'lps'),
	(659050, 135, '2015-01-15 00:11:02.000000', 'consum', 0.0254, 'lps'),
	(659051, 135, '2015-01-15 00:11:03.000000', 'consum', 0.0273, 'lps'),
	(659052, 135, '2015-01-15 00:11:04.000000', 'consum', 0.0248, 'lps'),
	(659053, 135, '2015-01-15 00:11:05.000000', 'consum', 0.0212, 'lps'),
	(659054, 135, '2015-01-15 00:11:06.000000', 'consum', 0.0252, 'lps'),
	(659055, 135, '2015-01-15 00:11:07.000000', 'consum', 0.0269, 'lps'),
	(659056, 135, '2015-01-15 00:11:08.000000', 'consum', 0.0232, 'lps'),
	(659057, 135, '2015-01-15 00:11:09.000000', 'consum', 0.0215, 'lps'),
	(659058, 135, '2015-01-15 00:11:10.000000', 'consum', 0.0245, 'lps'),
	(659059, 135, '2015-01-15 00:11:11.000000', 'consum', 0.0221, 'lps'),
	(659060, 135, '2015-01-15 00:11:12.000000', 'consum', 0.0235, 'lps'),
	(659061, 135, '2015-01-15 00:11:13.000000', 'consum', 0.0229, 'lps'),
	(659062, 135, '2015-01-15 00:11:14.000000', 'consum', 0.0231, 'lps'),
	(659063, 135, '2015-01-15 00:11:15.000000', 'consum', 0.0258, 'lps'),
	(659064, 135, '2015-01-15 00:11:16.000000', 'consum', 0.0240, 'lps'),
	(659065, 135, '2015-01-15 00:11:17.000000', 'consum', 0.0218, 'lps'),
	(659066, 135, '2015-01-15 00:11:18.000000', 'consum', 0.0231, 'lps'),
	(659067, 135, '2015-01-15 00:11:19.000000', 'consum', 0.0221, 'lps'),
	(659068, 135, '2015-01-15 00:11:20.000000', 'consum', 0.0276, 'lps'),
	(659069, 135, '2015-01-15 00:11:21.000000', 'consum', 0.0210, 'lps'),
	(659070, 135, '2015-01-15 00:11:22.000000', 'consum', 0.0234, 'lps'),
	(659071, 135, '2015-01-15 00:11:23.000000', 'consum', 0.0258, 'lps'),
	(659072, 135, '2015-01-15 00:11:24.000000', 'consum', 0.0228, 'lps'),
	(659073, 135, '2015-01-15 00:11:25.000000', 'consum', 0.0233, 'lps'),
	(659074, 135, '2015-01-15 00:11:26.000000', 'consum', 0.0269, 'lps'),
	(659075, 135, '2015-01-15 00:11:27.000000', 'consum', 0.0216, 'lps'),
	(659076, 135, '2015-01-15 00:11:28.000000', 'consum', 0.0211, 'lps'),
	(659077, 135, '2015-01-15 00:11:29.000000', 'consum', 0.0271, 'lps'),
	(659078, 135, '2015-01-15 00:11:30.000000', 'consum', 0.0218, 'lps'),
	(659079, 135, '2015-01-15 00:11:31.000000', 'consum', 0.0215, 'lps'),
	(659080, 135, '2015-01-15 00:11:32.000000', 'consum', 0.0210, 'lps'),
	(659081, 135, '2015-01-15 00:11:33.000000', 'consum', 0.0272, 'lps'),
	(659082, 135, '2015-01-15 00:11:34.000000', 'consum', 0.0225, 'lps'),
	(659083, 135, '2015-01-15 00:11:35.000000', 'consum', 0.0245, 'lps'),
	(659084, 135, '2015-01-15 00:11:36.000000', 'consum', 0.0267, 'lps'),
	(659085, 135, '2015-01-15 00:11:37.000000', 'consum', 0.0242, 'lps'),
	(659086, 135, '2015-01-15 00:11:38.000000', 'consum', 0.0272, 'lps'),
	(659087, 135, '2015-01-15 00:11:39.000000', 'consum', 0.0278, 'lps'),
	(659088, 135, '2015-01-15 00:11:40.000000', 'consum', 0.0218, 'lps'),
	(659089, 135, '2015-01-15 00:11:41.000000', 'consum', 0.0266, 'lps'),
	(659090, 135, '2015-01-15 00:11:42.000000', 'consum', 0.0246, 'lps'),
	(659091, 135, '2015-01-15 00:11:43.000000', 'consum', 0.0223, 'lps'),
	(659092, 135, '2015-01-15 00:11:44.000000', 'consum', 0.0240, 'lps'),
	(659093, 135, '2015-01-15 00:11:45.000000', 'consum', 0.0248, 'lps'),
	(659094, 135, '2015-01-15 00:11:46.000000', 'consum', 0.0235, 'lps'),
	(659095, 135, '2015-01-15 00:11:47.000000', 'consum', 0.0224, 'lps'),
	(659096, 135, '2015-01-15 00:11:48.000000', 'consum', 0.0277, 'lps'),
	(659097, 135, '2015-01-15 00:11:49.000000', 'consum', 0.0210, 'lps'),
	(659098, 135, '2015-01-15 00:11:50.000000', 'consum', 0.0230, 'lps'),
	(659099, 135, '2015-01-15 00:11:51.000000', 'consum', 0.0238, 'lps'),
	(659100, 135, '2015-01-15 00:11:52.000000', 'consum', 0.0217, 'lps'),
	(659101, 135, '2015-01-15 00:11:53.000000', 'consum', 0.0235, 'lps'),
	(659102, 135, '2015-01-15 00:11:54.000000', 'consum', 0.0242, 'lps'),
	(659103, 135, '2015-01-15 00:11:55.000000', 'consum', 0.0221, 'lps'),
	(659104, 135, '2015-01-15 00:11:56.000000', 'consum', 0.0244, 'lps'),
	(659105, 135, '2015-01-15 00:11:57.000000', 'consum', 0.0274, 'lps'),
	(659106, 135, '2015-01-15 00:11:58.000000', 'consum', 0.0279, 'lps'),
	(659107, 135, '2015-01-15 00:11:59.000000', 'consum', 0.0216, 'lps'),
	(659108, 135, '2015-01-15 00:12:00.000000', 'consum', 0.0255, 'lps'),
	(659109, 135, '2015-01-15 00:12:01.000000', 'consum', 0.0271, 'lps'),
	(659110, 135, '2015-01-15 00:12:02.000000', 'consum', 0.0232, 'lps'),
	(659111, 135, '2015-01-15 00:12:03.000000', 'consum', 0.0210, 'lps'),
	(659112, 135, '2015-01-15 00:12:04.000000', 'consum', 0.0221, 'lps'),
	(659113, 135, '2015-01-15 00:12:05.000000', 'consum', 0.0265, 'lps'),
	(659114, 135, '2015-01-15 00:12:06.000000', 'consum', 0.0231, 'lps'),
	(659115, 135, '2015-01-15 00:12:07.000000', 'consum', 0.0223, 'lps'),
	(659116, 135, '2015-01-15 00:12:08.000000', 'consum', 0.0211, 'lps'),
	(659117, 135, '2015-01-15 00:12:09.000000', 'consum', 0.0253, 'lps'),
	(659118, 135, '2015-01-15 00:12:10.000000', 'consum', 0.0272, 'lps'),
	(659119, 135, '2015-01-15 00:12:11.000000', 'consum', 0.0244, 'lps'),
	(659120, 135, '2015-01-15 00:12:12.000000', 'consum', 0.0267, 'lps'),
	(659121, 135, '2015-01-15 00:12:13.000000', 'consum', 0.0249, 'lps'),
	(659122, 135, '2015-01-15 00:12:14.000000', 'consum', 0.0233, 'lps'),
	(659123, 135, '2015-01-15 00:12:15.000000', 'consum', 0.0210, 'lps'),
	(659124, 135, '2015-01-15 00:12:16.000000', 'consum', 0.0212, 'lps'),
	(659125, 135, '2015-01-15 00:12:17.000000', 'consum', 0.0224, 'lps'),
	(659126, 135, '2015-01-15 00:12:18.000000', 'consum', 0.0274, 'lps'),
	(659127, 135, '2015-01-15 00:12:19.000000', 'consum', 0.0266, 'lps'),
	(659128, 135, '2015-01-15 00:12:20.000000', 'consum', 0.0225, 'lps'),
	(659129, 135, '2015-01-15 00:12:21.000000', 'consum', 0.0264, 'lps'),
	(659130, 135, '2015-01-15 00:12:22.000000', 'consum', 0.0214, 'lps'),
	(659131, 135, '2015-01-15 00:12:23.000000', 'consum', 0.0216, 'lps'),
	(659132, 135, '2015-01-15 00:12:24.000000', 'consum', 0.0229, 'lps'),
	(659133, 135, '2015-01-15 00:12:25.000000', 'consum', 0.0212, 'lps'),
	(659134, 135, '2015-01-15 00:12:26.000000', 'consum', 0.0239, 'lps'),
	(659135, 135, '2015-01-15 00:12:27.000000', 'consum', 0.0273, 'lps'),
	(659136, 135, '2015-01-15 00:12:28.000000', 'consum', 0.0220, 'lps'),
	(659137, 135, '2015-01-15 00:12:29.000000', 'consum', 0.0218, 'lps'),
	(659138, 135, '2015-01-15 00:12:30.000000', 'consum', 0.0222, 'lps'),
	(659139, 135, '2015-01-15 00:12:31.000000', 'consum', 0.0247, 'lps'),
	(659140, 135, '2015-01-15 00:12:32.000000', 'consum', 0.0210, 'lps'),
	(659141, 135, '2015-01-15 00:12:33.000000', 'consum', 0.0246, 'lps'),
	(659142, 135, '2015-01-15 00:12:34.000000', 'consum', 0.0244, 'lps'),
	(659143, 135, '2015-01-15 00:12:35.000000', 'consum', 0.0272, 'lps'),
	(659144, 135, '2015-01-15 00:12:36.000000', 'consum', 0.0270, 'lps'),
	(659145, 135, '2015-01-15 00:12:37.000000', 'consum', 0.0251, 'lps'),
	(659146, 135, '2015-01-15 00:12:38.000000', 'consum', 0.0237, 'lps'),
	(659147, 135, '2015-01-15 00:12:39.000000', 'consum', 0.0223, 'lps'),
	(659148, 135, '2015-01-15 00:12:40.000000', 'consum', 0.0268, 'lps'),
	(659149, 135, '2015-01-15 00:12:41.000000', 'consum', 0.0238, 'lps'),
	(659150, 135, '2015-01-15 00:12:42.000000', 'consum', 0.0253, 'lps'),
	(659151, 135, '2015-01-15 00:12:43.000000', 'consum', 0.0265, 'lps'),
	(659152, 135, '2015-01-15 00:12:44.000000', 'consum', 0.0211, 'lps'),
	(659153, 135, '2015-01-15 00:12:45.000000', 'consum', 0.0271, 'lps'),
	(659154, 135, '2015-01-15 00:12:46.000000', 'consum', 0.0216, 'lps'),
	(659155, 135, '2015-01-15 00:12:47.000000', 'consum', 0.0279, 'lps'),
	(659156, 135, '2015-01-15 00:12:48.000000', 'consum', 0.0244, 'lps'),
	(659157, 135, '2015-01-15 00:12:49.000000', 'consum', 0.0247, 'lps'),
	(659158, 135, '2015-01-15 00:12:50.000000', 'consum', 0.0220, 'lps'),
	(659159, 135, '2015-01-15 00:12:51.000000', 'consum', 0.0223, 'lps'),
	(659160, 135, '2015-01-15 00:12:52.000000', 'consum', 0.0245, 'lps'),
	(659161, 135, '2015-01-15 00:12:53.000000', 'consum', 0.0271, 'lps'),
	(659162, 135, '2015-01-15 00:12:54.000000', 'consum', 0.0265, 'lps'),
	(659163, 135, '2015-01-15 00:12:55.000000', 'consum', 0.0228, 'lps'),
	(659164, 135, '2015-01-15 00:12:56.000000', 'consum', 0.0282, 'lps'),
	(659165, 135, '2015-01-15 00:12:57.000000', 'consum', 0.0219, 'lps'),
	(659166, 135, '2015-01-15 00:12:58.000000', 'consum', 0.0265, 'lps'),
	(659167, 135, '2015-01-15 00:12:59.000000', 'consum', 0.0234, 'lps'),
	(659168, 135, '2015-01-15 00:13:00.000000', 'consum', 0.0240, 'lps'),
	(659169, 135, '2015-01-15 00:13:01.000000', 'consum', 0.0216, 'lps'),
	(659170, 135, '2015-01-15 00:13:02.000000', 'consum', 0.0222, 'lps'),
	(659171, 135, '2015-01-15 00:13:03.000000', 'consum', 0.0254, 'lps'),
	(659172, 135, '2015-01-15 00:13:04.000000', 'consum', 0.0247, 'lps'),
	(659173, 135, '2015-01-15 00:13:05.000000', 'consum', 0.0262, 'lps'),
	(659174, 135, '2015-01-15 00:13:06.000000', 'consum', 0.0214, 'lps'),
	(659175, 135, '2015-01-15 00:13:07.000000', 'consum', 0.0222, 'lps'),
	(659176, 135, '2015-01-15 00:13:08.000000', 'consum', 0.0259, 'lps'),
	(659177, 135, '2015-01-15 00:13:09.000000', 'consum', 0.0272, 'lps'),
	(659178, 135, '2015-01-15 00:13:10.000000', 'consum', 0.0224, 'lps'),
	(659179, 135, '2015-01-15 00:13:11.000000', 'consum', 0.0244, 'lps'),
	(659180, 135, '2015-01-15 00:13:12.000000', 'consum', 0.0264, 'lps'),
	(659181, 135, '2015-01-15 00:13:13.000000', 'consum', 0.0229, 'lps'),
	(659182, 135, '2015-01-15 00:13:14.000000', 'consum', 0.0216, 'lps'),
	(659183, 135, '2015-01-15 00:13:15.000000', 'consum', 0.0261, 'lps'),
	(659184, 135, '2015-01-15 00:13:16.000000', 'consum', 0.0222, 'lps'),
	(659185, 135, '2015-01-15 00:13:17.000000', 'consum', 0.0268, 'lps'),
	(659186, 135, '2015-01-15 00:13:18.000000', 'consum', 0.0244, 'lps'),
	(659187, 135, '2015-01-15 00:13:19.000000', 'consum', 0.0278, 'lps'),
	(659188, 135, '2015-01-15 00:13:20.000000', 'consum', 0.0225, 'lps'),
	(659189, 135, '2015-01-15 00:13:21.000000', 'consum', 0.0233, 'lps'),
	(659190, 135, '2015-01-15 00:13:22.000000', 'consum', 0.0279, 'lps'),
	(659191, 135, '2015-01-15 00:13:23.000000', 'consum', 0.0264, 'lps'),
	(659192, 135, '2015-01-15 00:13:24.000000', 'consum', 0.0272, 'lps'),
	(659193, 135, '2015-01-15 00:13:25.000000', 'consum', 0.0211, 'lps'),
	(659194, 135, '2015-01-15 00:13:26.000000', 'consum', 0.0252, 'lps'),
	(659195, 135, '2015-01-15 00:13:27.000000', 'consum', 0.0269, 'lps'),
	(659196, 135, '2015-01-15 00:13:28.000000', 'consum', 0.0232, 'lps'),
	(659197, 135, '2015-01-15 00:13:29.000000', 'consum', 0.0217, 'lps'),
	(659198, 135, '2015-01-15 00:13:30.000000', 'consum', 0.0256, 'lps'),
	(659199, 135, '2015-01-15 00:13:31.000000', 'consum', 0.0269, 'lps'),
	(659200, 135, '2015-01-15 00:13:32.000000', 'consum', 0.0219, 'lps'),
	(659201, 135, '2015-01-15 00:13:33.000000', 'consum', 0.0225, 'lps'),
	(659202, 135, '2015-01-15 00:13:34.000000', 'consum', 0.0262, 'lps'),
	(659203, 135, '2015-01-15 00:13:35.000000', 'consum', 0.0276, 'lps'),
	(659204, 135, '2015-01-15 00:13:36.000000', 'consum', 0.0238, 'lps'),
	(659205, 135, '2015-01-15 00:13:37.000000', 'consum', 0.0227, 'lps'),
	(659206, 135, '2015-01-15 00:13:38.000000', 'consum', 0.0283, 'lps'),
	(659207, 135, '2015-01-15 00:13:39.000000', 'consum', 0.0229, 'lps'),
	(659208, 135, '2015-01-15 00:13:40.000000', 'consum', 0.0233, 'lps'),
	(659209, 135, '2015-01-15 00:13:41.000000', 'consum', 0.0270, 'lps'),
	(659210, 135, '2015-01-15 00:13:42.000000', 'consum', 0.0221, 'lps'),
	(659211, 135, '2015-01-15 00:13:43.000000', 'consum', 0.0232, 'lps'),
	(659212, 135, '2015-01-15 00:13:44.000000', 'consum', 0.0213, 'lps'),
	(659213, 135, '2015-01-15 00:13:45.000000', 'consum', 0.0235, 'lps'),
	(659214, 135, '2015-01-15 00:13:46.000000', 'consum', 0.0253, 'lps'),
	(659215, 135, '2015-01-15 00:13:47.000000', 'consum', 0.0277, 'lps'),
	(659216, 135, '2015-01-15 00:13:48.000000', 'consum', 0.0268, 'lps'),
	(659217, 135, '2015-01-15 00:13:49.000000', 'consum', 0.0225, 'lps'),
	(659218, 135, '2015-01-15 00:13:50.000000', 'consum', 0.0260, 'lps'),
	(659219, 135, '2015-01-15 00:13:51.000000', 'consum', 0.0268, 'lps'),
	(659220, 135, '2015-01-15 00:13:52.000000', 'consum', 0.0276, 'lps'),
	(659221, 135, '2015-01-15 00:13:53.000000', 'consum', 0.0219, 'lps'),
	(659222, 135, '2015-01-15 00:13:54.000000', 'consum', 0.0279, 'lps'),
	(659223, 135, '2015-01-15 00:13:55.000000', 'consum', 0.0233, 'lps'),
	(659224, 135, '2015-01-15 00:13:56.000000', 'consum', 0.0266, 'lps'),
	(659225, 135, '2015-01-15 00:13:57.000000', 'consum', 0.0274, 'lps'),
	(659226, 135, '2015-01-15 00:13:58.000000', 'consum', 0.0216, 'lps'),
	(659227, 135, '2015-01-15 00:13:59.000000', 'consum', 0.0269, 'lps'),
	(659228, 135, '2015-01-15 00:14:00.000000', 'consum', 0.0267, 'lps'),
	(659229, 135, '2015-01-15 00:14:01.000000', 'consum', 0.0243, 'lps'),
	(659230, 135, '2015-01-15 00:14:02.000000', 'consum', 0.0279, 'lps'),
	(659231, 135, '2015-01-15 00:14:03.000000', 'consum', 0.0233, 'lps'),
	(659232, 135, '2015-01-15 00:14:04.000000', 'consum', 0.0265, 'lps'),
	(659233, 135, '2015-01-15 00:14:05.000000', 'consum', 0.0272, 'lps'),
	(659234, 135, '2015-01-15 00:14:06.000000', 'consum', 0.0282, 'lps'),
	(659235, 135, '2015-01-15 00:14:07.000000', 'consum', 0.0235, 'lps'),
	(659236, 135, '2015-01-15 00:14:08.000000', 'consum', 0.0268, 'lps'),
	(659237, 135, '2015-01-15 00:14:09.000000', 'consum', 0.0278, 'lps'),
	(659238, 135, '2015-01-15 00:14:10.000000', 'consum', 0.0228, 'lps'),
	(659239, 135, '2015-01-15 00:14:11.000000', 'consum', 0.0245, 'lps'),
	(659240, 135, '2015-01-15 00:14:12.000000', 'consum', 0.0259, 'lps'),
	(659241, 135, '2015-01-15 00:14:13.000000', 'consum', 0.0276, 'lps'),
	(659242, 135, '2015-01-15 00:14:14.000000', 'consum', 0.0243, 'lps'),
	(659243, 135, '2015-01-15 00:14:15.000000', 'consum', 0.0254, 'lps'),
	(659244, 135, '2015-01-15 00:14:16.000000', 'consum', 0.0257, 'lps'),
	(659245, 135, '2015-01-15 00:14:17.000000', 'consum', 0.0238, 'lps'),
	(659246, 135, '2015-01-15 00:14:18.000000', 'consum', 0.0210, 'lps'),
	(659247, 135, '2015-01-15 00:14:19.000000', 'consum', 0.0274, 'lps'),
	(659248, 135, '2015-01-15 00:14:20.000000', 'consum', 0.0235, 'lps'),
	(659249, 135, '2015-01-15 00:14:21.000000', 'consum', 0.0219, 'lps'),
	(659250, 135, '2015-01-15 00:14:22.000000', 'consum', 0.0252, 'lps'),
	(659251, 135, '2015-01-15 00:14:23.000000', 'consum', 0.0247, 'lps'),
	(659252, 135, '2015-01-15 00:14:24.000000', 'consum', 0.0268, 'lps'),
	(659253, 135, '2015-01-15 00:14:25.000000', 'consum', 0.0241, 'lps'),
	(659254, 135, '2015-01-15 00:14:26.000000', 'consum', 0.0267, 'lps'),
	(659255, 135, '2015-01-15 00:14:27.000000', 'consum', 0.0254, 'lps'),
	(659256, 135, '2015-01-15 00:14:28.000000', 'consum', 0.0261, 'lps'),
	(659257, 135, '2015-01-15 00:14:29.000000', 'consum', 0.0257, 'lps'),
	(659258, 135, '2015-01-15 00:14:30.000000', 'consum', 0.0219, 'lps'),
	(659259, 135, '2015-01-15 00:14:31.000000', 'consum', 0.0261, 'lps'),
	(659260, 135, '2015-01-15 00:14:32.000000', 'consum', 0.0219, 'lps'),
	(659261, 135, '2015-01-15 00:14:33.000000', 'consum', 0.0250, 'lps'),
	(659262, 135, '2015-01-15 00:14:34.000000', 'consum', 0.0237, 'lps'),
	(659263, 135, '2015-01-15 00:14:35.000000', 'consum', 0.0224, 'lps'),
	(659264, 135, '2015-01-15 00:14:36.000000', 'consum', 0.0274, 'lps'),
	(659265, 135, '2015-01-15 00:14:37.000000', 'consum', 0.0266, 'lps'),
	(659266, 135, '2015-01-15 00:14:38.000000', 'consum', 0.0223, 'lps'),
	(659267, 135, '2015-01-15 00:14:39.000000', 'consum', 0.0256, 'lps'),
	(659268, 135, '2015-01-15 00:14:40.000000', 'consum', 0.0252, 'lps'),
	(659269, 135, '2015-01-15 00:14:41.000000', 'consum', 0.0211, 'lps'),
	(659270, 135, '2015-01-15 00:14:42.000000', 'consum', 0.0238, 'lps'),
	(659271, 135, '2015-01-15 00:14:43.000000', 'consum', 0.0274, 'lps'),
	(659272, 135, '2015-01-15 00:14:44.000000', 'consum', 0.0225, 'lps'),
	(659273, 135, '2015-01-15 00:14:45.000000', 'consum', 0.0241, 'lps'),
	(659274, 135, '2015-01-15 00:14:46.000000', 'consum', 0.0247, 'lps'),
	(659275, 135, '2015-01-15 00:14:47.000000', 'consum', 0.0229, 'lps'),
	(659276, 135, '2015-01-15 00:14:48.000000', 'consum', 0.0266, 'lps'),
	(659277, 135, '2015-01-15 00:14:49.000000', 'consum', 0.0211, 'lps'),
	(659278, 135, '2015-01-15 00:14:50.000000', 'consum', 0.0270, 'lps'),
	(659279, 135, '2015-01-15 00:14:51.000000', 'consum', 0.0213, 'lps'),
	(659280, 135, '2015-01-15 00:14:52.000000', 'consum', 0.0268, 'lps'),
	(659281, 135, '2015-01-15 00:14:53.000000', 'consum', 0.0268, 'lps'),
	(659282, 135, '2015-01-15 00:14:54.000000', 'consum', 0.0253, 'lps'),
	(659283, 135, '2015-01-15 00:14:55.000000', 'consum', 0.0250, 'lps'),
	(659284, 135, '2015-01-15 00:14:56.000000', 'consum', 0.0282, 'lps'),
	(659285, 135, '2015-01-15 00:14:57.000000', 'consum', 0.0228, 'lps'),
	(659286, 135, '2015-01-15 00:14:58.000000', 'consum', 0.0233, 'lps'),
	(659287, 135, '2015-01-15 00:14:59.000000', 'consum', 0.0272, 'lps'),
	(659288, 135, '2015-01-15 00:15:00.000000', 'consum', 0.0230, 'lps'),
	(659289, 135, '2015-01-15 00:15:01.000000', 'consum', 0.0272, 'lps'),
	(659290, 135, '2015-01-15 00:15:02.000000', 'consum', 0.0239, 'lps'),
	(659291, 135, '2015-01-15 00:15:03.000000', 'consum', 0.0245, 'lps'),
	(659292, 135, '2015-01-15 00:15:04.000000', 'consum', 0.0223, 'lps'),
	(659293, 135, '2015-01-15 00:15:05.000000', 'consum', 0.0246, 'lps'),
	(659294, 135, '2015-01-15 00:15:06.000000', 'consum', 0.0277, 'lps'),
	(659295, 135, '2015-01-15 00:15:07.000000', 'consum', 0.0213, 'lps'),
	(659296, 135, '2015-01-15 00:15:08.000000', 'consum', 0.0249, 'lps'),
	(659297, 135, '2015-01-15 00:15:09.000000', 'consum', 0.0246, 'lps'),
	(659298, 135, '2015-01-15 00:15:10.000000', 'consum', 0.0276, 'lps'),
	(659299, 135, '2015-01-15 00:15:11.000000', 'consum', 0.0282, 'lps'),
	(659300, 135, '2015-01-15 00:15:12.000000', 'consum', 0.0225, 'lps'),
	(659301, 135, '2015-01-15 00:15:13.000000', 'consum', 0.0220, 'lps'),
	(659302, 135, '2015-01-15 00:15:14.000000', 'consum', 0.0212, 'lps'),
	(659303, 135, '2015-01-15 00:15:15.000000', 'consum', 0.0267, 'lps'),
	(659304, 135, '2015-01-15 00:15:16.000000', 'consum', 0.0268, 'lps'),
	(659305, 135, '2015-01-15 00:15:17.000000', 'consum', 0.0253, 'lps'),
	(659306, 135, '2015-01-15 00:15:18.000000', 'consum', 0.0252, 'lps'),
	(659307, 135, '2015-01-15 00:15:19.000000', 'consum', 0.0218, 'lps'),
	(659308, 135, '2015-01-15 00:15:20.000000', 'consum', 0.0272, 'lps'),
	(659309, 135, '2015-01-15 00:15:21.000000', 'consum', 0.0276, 'lps'),
	(659310, 135, '2015-01-15 00:15:22.000000', 'consum', 0.0278, 'lps'),
	(659311, 135, '2015-01-15 00:15:23.000000', 'consum', 0.0279, 'lps'),
	(659312, 135, '2015-01-15 00:15:24.000000', 'consum', 0.0280, 'lps'),
	(659313, 135, '2015-01-15 00:15:25.000000', 'consum', 0.0278, 'lps'),
	(659314, 135, '2015-01-15 00:15:26.000000', 'consum', 0.0265, 'lps'),
	(659315, 135, '2015-01-15 00:15:27.000000', 'consum', 0.0282, 'lps'),
	(659316, 135, '2015-01-15 00:15:28.000000', 'consum', 0.0258, 'lps'),
	(659317, 135, '2015-01-15 00:15:29.000000', 'consum', 0.0235, 'lps'),
	(659318, 135, '2015-01-15 00:15:30.000000', 'consum', 0.0267, 'lps'),
	(659319, 135, '2015-01-15 00:15:31.000000', 'consum', 0.0271, 'lps'),
	(659320, 135, '2015-01-15 00:15:32.000000', 'consum', 0.0270, 'lps'),
	(659321, 135, '2015-01-15 00:15:33.000000', 'consum', 0.0254, 'lps'),
	(659322, 135, '2015-01-15 00:15:34.000000', 'consum', 0.0249, 'lps'),
	(659323, 135, '2015-01-15 00:15:35.000000', 'consum', 0.0273, 'lps'),
	(659324, 135, '2015-01-15 00:15:36.000000', 'consum', 0.0260, 'lps'),
	(659325, 135, '2015-01-15 00:15:37.000000', 'consum', 0.0274, 'lps'),
	(659326, 135, '2015-01-15 00:15:38.000000', 'consum', 0.0233, 'lps'),
	(659327, 135, '2015-01-15 00:15:39.000000', 'consum', 0.0279, 'lps'),
	(659328, 135, '2015-01-15 00:15:40.000000', 'consum', 0.0266, 'lps'),
	(659329, 135, '2015-01-15 00:15:41.000000', 'consum', 0.0282, 'lps'),
	(659330, 135, '2015-01-15 00:15:42.000000', 'consum', 0.0255, 'lps'),
	(659331, 135, '2015-01-15 00:15:43.000000', 'consum', 0.0218, 'lps'),
	(659332, 135, '2015-01-15 00:15:44.000000', 'consum', 0.0264, 'lps'),
	(659333, 135, '2015-01-15 00:15:45.000000', 'consum', 0.0234, 'lps'),
	(659334, 135, '2015-01-15 00:15:46.000000', 'consum', 0.0241, 'lps'),
	(659335, 135, '2015-01-15 00:15:47.000000', 'consum', 0.0223, 'lps'),
	(659336, 135, '2015-01-15 00:15:48.000000', 'consum', 0.0254, 'lps'),
	(659337, 135, '2015-01-15 00:15:49.000000', 'consum', 0.0243, 'lps'),
	(659338, 135, '2015-01-15 00:15:50.000000', 'consum', 0.0244, 'lps'),
	(659339, 135, '2015-01-15 00:15:51.000000', 'consum', 0.0281, 'lps'),
	(659340, 135, '2015-01-15 00:15:52.000000', 'consum', 0.0241, 'lps'),
	(659341, 135, '2015-01-15 00:15:53.000000', 'consum', 0.0226, 'lps'),
	(659342, 135, '2015-01-15 00:15:54.000000', 'consum', 0.0272, 'lps'),
	(659343, 135, '2015-01-15 00:15:55.000000', 'consum', 0.0249, 'lps'),
	(659344, 135, '2015-01-15 00:15:56.000000', 'consum', 0.0222, 'lps'),
	(659345, 135, '2015-01-15 00:15:57.000000', 'consum', 0.0228, 'lps'),
	(659346, 135, '2015-01-15 00:15:58.000000', 'consum', 0.0262, 'lps'),
	(659347, 135, '2015-01-15 00:15:59.000000', 'consum', 0.0271, 'lps'),
	(659348, 135, '2015-01-15 00:16:00.000000', 'consum', 0.0212, 'lps'),
	(659349, 135, '2015-01-15 00:16:01.000000', 'consum', 0.0260, 'lps'),
	(659350, 135, '2015-01-15 00:16:02.000000', 'consum', 0.0233, 'lps'),
	(659351, 135, '2015-01-15 00:16:03.000000', 'consum', 0.0247, 'lps'),
	(659352, 135, '2015-01-15 00:16:04.000000', 'consum', 0.0255, 'lps'),
	(659353, 135, '2015-01-15 00:16:05.000000', 'consum', 0.0250, 'lps'),
	(659354, 135, '2015-01-15 00:16:06.000000', 'consum', 0.0274, 'lps'),
	(659355, 135, '2015-01-15 00:16:07.000000', 'consum', 0.0263, 'lps'),
	(659356, 135, '2015-01-15 00:16:08.000000', 'consum', 0.0210, 'lps'),
	(659357, 135, '2015-01-15 00:16:09.000000', 'consum', 0.0274, 'lps'),
	(659358, 135, '2015-01-15 00:16:10.000000', 'consum', 0.0236, 'lps'),
	(659359, 135, '2015-01-15 00:16:11.000000', 'consum', 0.0220, 'lps'),
	(659360, 135, '2015-01-15 00:16:12.000000', 'consum', 0.0256, 'lps'),
	(659361, 135, '2015-01-15 00:16:13.000000', 'consum', 0.0264, 'lps'),
	(659362, 135, '2015-01-15 00:16:14.000000', 'consum', 0.0269, 'lps'),
	(659363, 135, '2015-01-15 00:16:15.000000', 'consum', 0.0269, 'lps'),
	(659364, 135, '2015-01-15 00:16:16.000000', 'consum', 0.0252, 'lps'),
	(659365, 135, '2015-01-15 00:16:17.000000', 'consum', 0.0247, 'lps'),
	(659366, 135, '2015-01-15 00:16:18.000000', 'consum', 0.0269, 'lps'),
	(659367, 135, '2015-01-15 00:16:19.000000', 'consum', 0.0245, 'lps'),
	(659368, 135, '2015-01-15 00:16:20.000000', 'consum', 0.0211, 'lps'),
	(659369, 135, '2015-01-15 00:16:21.000000', 'consum', 0.0257, 'lps'),
	(659370, 135, '2015-01-15 00:16:22.000000', 'consum', 0.0219, 'lps'),
	(659371, 135, '2015-01-15 00:16:23.000000', 'consum', 0.0266, 'lps'),
	(659372, 135, '2015-01-15 00:16:24.000000', 'consum', 0.0238, 'lps'),
	(659373, 135, '2015-01-15 00:16:25.000000', 'consum', 0.0258, 'lps'),
	(659374, 135, '2015-01-15 00:16:26.000000', 'consum', 0.0217, 'lps'),
	(659375, 135, '2015-01-15 00:16:27.000000', 'consum', 0.0249, 'lps'),
	(659376, 135, '2015-01-15 00:16:28.000000', 'consum', 0.0236, 'lps'),
	(659377, 135, '2015-01-15 00:16:29.000000', 'consum', 0.0223, 'lps'),
	(659378, 135, '2015-01-15 00:16:30.000000', 'consum', 0.0274, 'lps'),
	(659379, 135, '2015-01-15 00:16:31.000000', 'consum', 0.0268, 'lps'),
	(659380, 135, '2015-01-15 00:16:32.000000', 'consum', 0.0234, 'lps'),
	(659381, 135, '2015-01-15 00:16:33.000000', 'consum', 0.0232, 'lps'),
	(659382, 135, '2015-01-15 00:16:34.000000', 'consum', 0.0247, 'lps'),
	(659383, 135, '2015-01-15 00:16:35.000000', 'consum', 0.0256, 'lps'),
	(659384, 135, '2015-01-15 00:16:36.000000', 'consum', 0.0254, 'lps'),
	(659385, 135, '2015-01-15 00:16:37.000000', 'consum', 0.0219, 'lps'),
	(659386, 135, '2015-01-15 00:16:38.000000', 'consum', 0.0274, 'lps'),
	(659387, 135, '2015-01-15 00:16:39.000000', 'consum', 0.0278, 'lps'),
	(659388, 135, '2015-01-15 00:16:40.000000', 'consum', 0.0214, 'lps'),
	(659389, 135, '2015-01-15 00:16:41.000000', 'consum', 0.0247, 'lps'),
	(659390, 135, '2015-01-15 00:16:42.000000', 'consum', 0.0237, 'lps'),
	(659391, 135, '2015-01-15 00:16:43.000000', 'consum', 0.0232, 'lps'),
	(659392, 135, '2015-01-15 00:16:44.000000', 'consum', 0.0241, 'lps'),
	(659393, 135, '2015-01-15 00:16:45.000000', 'consum', 0.0225, 'lps'),
	(659394, 135, '2015-01-15 00:16:46.000000', 'consum', 0.0265, 'lps'),
	(659395, 135, '2015-01-15 00:16:47.000000', 'consum', 0.0221, 'lps'),
	(659396, 135, '2015-01-15 00:16:48.000000', 'consum', 0.0248, 'lps'),
	(659397, 135, '2015-01-15 00:16:49.000000', 'consum', 0.0221, 'lps'),
	(659398, 135, '2015-01-15 00:16:50.000000', 'consum', 0.0224, 'lps'),
	(659399, 135, '2015-01-15 00:16:51.000000', 'consum', 0.0248, 'lps'),
	(659400, 135, '2015-01-15 00:16:52.000000', 'consum', 0.0211, 'lps'),
	(659401, 135, '2015-01-15 00:16:53.000000', 'consum', 0.0249, 'lps'),
	(659402, 135, '2015-01-15 00:16:54.000000', 'consum', 0.0254, 'lps'),
	(659403, 135, '2015-01-15 00:16:55.000000', 'consum', 0.0238, 'lps'),
	(659404, 135, '2015-01-15 00:16:56.000000', 'consum', 0.0221, 'lps'),
	(659405, 135, '2015-01-15 00:16:57.000000', 'consum', 0.0254, 'lps'),
	(659406, 135, '2015-01-15 00:16:58.000000', 'consum', 0.0249, 'lps'),
	(659407, 135, '2015-01-15 00:16:59.000000', 'consum', 0.0273, 'lps'),
	(659408, 135, '2015-01-15 00:17:00.000000', 'consum', 0.0262, 'lps'),
	(659409, 135, '2015-01-15 00:17:01.000000', 'consum', 0.0280, 'lps'),
	(659410, 135, '2015-01-15 00:17:02.000000', 'consum', 0.0259, 'lps'),
	(659411, 135, '2015-01-15 00:17:03.000000', 'consum', 0.0243, 'lps'),
	(659412, 135, '2015-01-15 00:17:04.000000', 'consum', 0.0229, 'lps'),
	(659413, 135, '2015-01-15 00:17:05.000000', 'consum', 0.0280, 'lps'),
	(659414, 135, '2015-01-15 00:17:06.000000', 'consum', 0.0280, 'lps'),
	(659415, 135, '2015-01-15 00:17:07.000000', 'consum', 0.0279, 'lps'),
	(659416, 135, '2015-01-15 00:17:08.000000', 'consum', 0.0272, 'lps'),
	(659417, 135, '2015-01-15 00:17:09.000000', 'consum', 0.0238, 'lps'),
	(659418, 135, '2015-01-15 00:17:10.000000', 'consum', 0.0240, 'lps'),
	(659419, 135, '2015-01-15 00:17:11.000000', 'consum', 0.0276, 'lps'),
	(659420, 135, '2015-01-15 00:17:12.000000', 'consum', 0.0229, 'lps'),
	(659421, 135, '2015-01-15 00:17:13.000000', 'consum', 0.0253, 'lps'),
	(659422, 135, '2015-01-15 00:17:14.000000', 'consum', 0.0222, 'lps'),
	(659423, 135, '2015-01-15 00:17:15.000000', 'consum', 0.0214, 'lps'),
	(659424, 135, '2015-01-15 00:17:16.000000', 'consum', 0.0271, 'lps'),
	(659425, 135, '2015-01-15 00:17:17.000000', 'consum', 0.0279, 'lps'),
	(659426, 135, '2015-01-15 00:17:18.000000', 'consum', 0.0224, 'lps'),
	(659427, 135, '2015-01-15 00:17:19.000000', 'consum', 0.0222, 'lps'),
	(659428, 135, '2015-01-15 00:17:20.000000', 'consum', 0.0230, 'lps'),
	(659429, 135, '2015-01-15 00:17:21.000000', 'consum', 0.0274, 'lps'),
	(659430, 135, '2015-01-15 00:17:22.000000', 'consum', 0.0247, 'lps'),
	(659431, 135, '2015-01-15 00:17:23.000000', 'consum', 0.0278, 'lps'),
	(659432, 135, '2015-01-15 00:17:24.000000', 'consum', 0.0217, 'lps'),
	(659433, 135, '2015-01-15 00:17:25.000000', 'consum', 0.0264, 'lps'),
	(659434, 135, '2015-01-15 00:17:26.000000', 'consum', 0.0238, 'lps'),
	(659435, 135, '2015-01-15 00:17:27.000000', 'consum', 0.0262, 'lps'),
	(659436, 135, '2015-01-15 00:17:28.000000', 'consum', 0.0240, 'lps'),
	(659437, 135, '2015-01-15 00:17:29.000000', 'consum', 0.0279, 'lps'),
	(659438, 135, '2015-01-15 00:17:30.000000', 'consum', 0.0242, 'lps'),
	(659439, 135, '2015-01-15 00:17:31.000000', 'consum', 0.0238, 'lps'),
	(659440, 135, '2015-01-15 00:17:32.000000', 'consum', 0.0253, 'lps'),
	(659441, 135, '2015-01-15 00:17:33.000000', 'consum', 0.0268, 'lps'),
	(659442, 135, '2015-01-15 00:17:34.000000', 'consum', 0.0226, 'lps'),
	(659443, 135, '2015-01-15 00:17:35.000000', 'consum', 0.0262, 'lps'),
	(659444, 135, '2015-01-15 00:17:36.000000', 'consum', 0.0275, 'lps'),
	(659445, 135, '2015-01-15 00:17:37.000000', 'consum', 0.0232, 'lps'),
	(659446, 135, '2015-01-15 00:17:38.000000', 'consum', 0.0273, 'lps'),
	(659447, 135, '2015-01-15 00:17:39.000000', 'consum', 0.0236, 'lps'),
	(659448, 135, '2015-01-15 00:17:40.000000', 'consum', 0.0225, 'lps'),
	(659449, 135, '2015-01-15 00:17:41.000000', 'consum', 0.0282, 'lps'),
	(659450, 135, '2015-01-15 00:17:42.000000', 'consum', 0.0232, 'lps'),
	(659451, 135, '2015-01-15 00:17:43.000000', 'consum', 0.0249, 'lps'),
	(659452, 135, '2015-01-15 00:17:44.000000', 'consum', 0.0268, 'lps'),
	(659453, 135, '2015-01-15 00:17:45.000000', 'consum', 0.0236, 'lps'),
	(659454, 135, '2015-01-15 00:17:46.000000', 'consum', 0.0239, 'lps'),
	(659455, 135, '2015-01-15 00:17:47.000000', 'consum', 0.0278, 'lps'),
	(659456, 135, '2015-01-15 00:17:48.000000', 'consum', 0.0243, 'lps'),
	(659457, 135, '2015-01-15 00:17:49.000000', 'consum', 0.0246, 'lps'),
	(659458, 135, '2015-01-15 00:17:50.000000', 'consum', 0.0218, 'lps'),
	(659459, 135, '2015-01-15 00:17:51.000000', 'consum', 0.0216, 'lps'),
	(659460, 135, '2015-01-15 00:17:52.000000', 'consum', 0.0215, 'lps'),
	(659461, 135, '2015-01-15 00:17:53.000000', 'consum', 0.0217, 'lps'),
	(659462, 135, '2015-01-15 00:17:54.000000', 'consum', 0.0229, 'lps'),
	(659463, 135, '2015-01-15 00:17:55.000000', 'consum', 0.0214, 'lps'),
	(659464, 135, '2015-01-15 00:17:56.000000', 'consum', 0.0246, 'lps'),
	(659465, 135, '2015-01-15 00:17:57.000000', 'consum', 0.0230, 'lps'),
	(659466, 135, '2015-01-15 00:17:58.000000', 'consum', 0.0276, 'lps'),
	(659467, 135, '2015-01-15 00:17:59.000000', 'consum', 0.0260, 'lps'),
	(659468, 135, '2015-01-15 00:18:00.000000', 'consum', 0.0263, 'lps'),
	(659469, 135, '2015-01-15 00:18:01.000000', 'consum', 0.0252, 'lps'),
	(659470, 135, '2015-01-15 00:18:02.000000', 'consum', 0.0262, 'lps'),
	(659471, 135, '2015-01-15 00:18:03.000000', 'consum', 0.0270, 'lps'),
	(659472, 135, '2015-01-15 00:18:04.000000', 'consum', 0.0282, 'lps'),
	(659473, 135, '2015-01-15 00:18:05.000000', 'consum', 0.0239, 'lps'),
	(659474, 135, '2015-01-15 00:18:06.000000', 'consum', 0.0216, 'lps'),
	(659475, 135, '2015-01-15 00:18:07.000000', 'consum', 0.0229, 'lps'),
	(659476, 135, '2015-01-15 00:18:08.000000', 'consum', 0.0212, 'lps'),
	(659477, 135, '2015-01-15 00:18:09.000000', 'consum', 0.0235, 'lps'),
	(659478, 135, '2015-01-15 00:18:10.000000', 'consum', 0.0259, 'lps'),
	(659479, 135, '2015-01-15 00:18:11.000000', 'consum', 0.0232, 'lps'),
	(659480, 135, '2015-01-15 00:18:12.000000', 'consum', 0.0248, 'lps'),
	(659481, 135, '2015-01-15 00:18:13.000000', 'consum', 0.0260, 'lps'),
	(659482, 135, '2015-01-15 00:18:14.000000', 'consum', 0.0271, 'lps'),
	(659483, 135, '2015-01-15 00:18:15.000000', 'consum', 0.0221, 'lps'),
	(659484, 135, '2015-01-15 00:18:16.000000', 'consum', 0.0227, 'lps'),
	(659485, 135, '2015-01-15 00:18:17.000000', 'consum', 0.0264, 'lps'),
	(659486, 135, '2015-01-15 00:18:18.000000', 'consum', 0.0279, 'lps'),
	(659487, 135, '2015-01-15 00:18:19.000000', 'consum', 0.0248, 'lps'),
	(659488, 135, '2015-01-15 00:18:20.000000', 'consum', 0.0267, 'lps'),
	(659489, 135, '2015-01-15 00:18:21.000000', 'consum', 0.0235, 'lps'),
	(659490, 135, '2015-01-15 00:18:22.000000', 'consum', 0.0237, 'lps'),
	(659491, 135, '2015-01-15 00:18:23.000000', 'consum', 0.0270, 'lps'),
	(659492, 135, '2015-01-15 00:18:24.000000', 'consum', 0.0282, 'lps'),
	(659493, 135, '2015-01-15 00:18:25.000000', 'consum', 0.0242, 'lps'),
	(659494, 135, '2015-01-15 00:18:26.000000', 'consum', 0.0230, 'lps'),
	(659495, 135, '2015-01-15 00:18:27.000000', 'consum', 0.0215, 'lps'),
	(659496, 135, '2015-01-15 00:18:28.000000', 'consum', 0.0249, 'lps'),
	(659497, 135, '2015-01-15 00:18:29.000000', 'consum', 0.0243, 'lps'),
	(659498, 135, '2015-01-15 00:18:30.000000', 'consum', 0.0256, 'lps'),
	(659499, 135, '2015-01-15 00:18:31.000000', 'consum', 0.0271, 'lps'),
	(659500, 135, '2015-01-15 00:18:32.000000', 'consum', 0.0228, 'lps'),
	(659501, 135, '2015-01-15 00:18:33.000000', 'consum', 0.0265, 'lps'),
	(659502, 135, '2015-01-15 00:18:34.000000', 'consum', 0.0283, 'lps'),
	(659503, 135, '2015-01-15 00:18:35.000000', 'consum', 0.0264, 'lps'),
	(659504, 135, '2015-01-15 00:18:36.000000', 'consum', 0.0260, 'lps'),
	(659505, 135, '2015-01-15 00:18:37.000000', 'consum', 0.0224, 'lps'),
	(659506, 135, '2015-01-15 00:18:38.000000', 'consum', 0.0277, 'lps'),
	(659507, 135, '2015-01-15 00:18:39.000000', 'consum', 0.0210, 'lps'),
	(659508, 135, '2015-01-15 00:18:40.000000', 'consum', 0.0232, 'lps'),
	(659509, 135, '2015-01-15 00:18:41.000000', 'consum', 0.0244, 'lps'),
	(659510, 135, '2015-01-15 00:18:42.000000', 'consum', 0.0241, 'lps'),
	(659511, 135, '2015-01-15 00:18:43.000000', 'consum', 0.0264, 'lps'),
	(659512, 135, '2015-01-15 00:18:44.000000', 'consum', 0.0240, 'lps'),
	(659513, 135, '2015-01-15 00:18:45.000000', 'consum', 0.0271, 'lps'),
	(659514, 135, '2015-01-15 00:18:46.000000', 'consum', 0.0277, 'lps'),
	(659515, 135, '2015-01-15 00:18:47.000000', 'consum', 0.0214, 'lps'),
	(659516, 135, '2015-01-15 00:18:48.000000', 'consum', 0.0251, 'lps'),
	(659517, 135, '2015-01-15 00:18:49.000000', 'consum', 0.0255, 'lps'),
	(659518, 135, '2015-01-15 00:18:50.000000', 'consum', 0.0239, 'lps'),
	(659519, 135, '2015-01-15 00:18:51.000000', 'consum', 0.0221, 'lps'),
	(659520, 135, '2015-01-15 00:18:52.000000', 'consum', 0.0251, 'lps'),
	(659521, 135, '2015-01-15 00:18:53.000000', 'consum', 0.0236, 'lps'),
	(659522, 135, '2015-01-15 00:18:54.000000', 'consum', 0.0217, 'lps'),
	(659523, 135, '2015-01-15 00:18:55.000000', 'consum', 0.0243, 'lps'),
	(659524, 135, '2015-01-15 00:18:56.000000', 'consum', 0.0279, 'lps'),
	(659525, 135, '2015-01-15 00:18:57.000000', 'consum', 0.0234, 'lps'),
	(659526, 135, '2015-01-15 00:18:58.000000', 'consum', 0.0272, 'lps'),
	(659527, 135, '2015-01-15 00:18:59.000000', 'consum', 0.0228, 'lps'),
	(659528, 135, '2015-01-15 00:19:00.000000', 'consum', 0.0263, 'lps'),
	(659529, 135, '2015-01-15 00:19:01.000000', 'consum', 0.0274, 'lps'),
	(659530, 135, '2015-01-15 00:19:02.000000', 'consum', 0.0221, 'lps'),
	(659531, 135, '2015-01-15 00:19:03.000000', 'consum', 0.0220, 'lps'),
	(659532, 135, '2015-01-15 00:19:04.000000', 'consum', 0.0231, 'lps'),
	(659533, 135, '2015-01-15 00:19:05.000000', 'consum', 0.0210, 'lps'),
	(659534, 135, '2015-01-15 00:19:06.000000', 'consum', 0.0222, 'lps'),
	(659535, 135, '2015-01-15 00:19:07.000000', 'consum', 0.0269, 'lps'),
	(659536, 135, '2015-01-15 00:19:08.000000', 'consum', 0.0248, 'lps'),
	(659537, 135, '2015-01-15 00:19:09.000000', 'consum', 0.0222, 'lps'),
	(659538, 135, '2015-01-15 00:19:10.000000', 'consum', 0.0233, 'lps'),
	(659539, 135, '2015-01-15 00:19:11.000000', 'consum', 0.0213, 'lps'),
	(659540, 135, '2015-01-15 00:19:12.000000', 'consum', 0.0232, 'lps'),
	(659541, 135, '2015-01-15 00:19:13.000000', 'consum', 0.0239, 'lps'),
	(659542, 135, '2015-01-15 00:19:14.000000', 'consum', 0.0215, 'lps'),
	(659543, 135, '2015-01-15 00:19:15.000000', 'consum', 0.0223, 'lps'),
	(659544, 135, '2015-01-15 00:19:16.000000', 'consum', 0.0261, 'lps'),
	(659545, 135, '2015-01-15 00:19:17.000000', 'consum', 0.0279, 'lps'),
	(659546, 135, '2015-01-15 00:19:18.000000', 'consum', 0.0255, 'lps'),
	(659547, 135, '2015-01-15 00:19:19.000000', 'consum', 0.0228, 'lps'),
	(659548, 135, '2015-01-15 00:19:20.000000', 'consum', 0.0240, 'lps'),
	(659549, 135, '2015-01-15 00:19:21.000000', 'consum', 0.0232, 'lps'),
	(659550, 135, '2015-01-15 00:19:22.000000', 'consum', 0.0229, 'lps'),
	(659551, 135, '2015-01-15 00:19:23.000000', 'consum', 0.0240, 'lps'),
	(659552, 135, '2015-01-15 00:19:24.000000', 'consum', 0.0231, 'lps'),
	(659553, 135, '2015-01-15 00:19:25.000000', 'consum', 0.0223, 'lps'),
	(659554, 135, '2015-01-15 00:19:26.000000', 'consum', 0.0212, 'lps'),
	(659555, 135, '2015-01-15 00:19:27.000000', 'consum', 0.0256, 'lps'),
	(659556, 135, '2015-01-15 00:19:28.000000', 'consum', 0.0213, 'lps'),
	(659557, 135, '2015-01-15 00:19:29.000000', 'consum', 0.0236, 'lps'),
	(659558, 135, '2015-01-15 00:19:30.000000', 'consum', 0.0258, 'lps'),
	(659559, 135, '2015-01-15 00:19:31.000000', 'consum', 0.0226, 'lps'),
	(659560, 135, '2015-01-15 00:19:32.000000', 'consum', 0.0218, 'lps'),
	(659561, 135, '2015-01-15 00:19:33.000000', 'consum', 0.0279, 'lps'),
	(659562, 135, '2015-01-15 00:19:34.000000', 'consum', 0.0235, 'lps'),
	(659563, 135, '2015-01-15 00:19:35.000000', 'consum', 0.0277, 'lps'),
	(659564, 135, '2015-01-15 00:19:36.000000', 'consum', 0.0248, 'lps'),
	(659565, 135, '2015-01-15 00:19:37.000000', 'consum', 0.0275, 'lps'),
	(659566, 135, '2015-01-15 00:19:38.000000', 'consum', 0.0273, 'lps'),
	(659567, 135, '2015-01-15 00:19:39.000000', 'consum', 0.0254, 'lps'),
	(659568, 135, '2015-01-15 00:19:40.000000', 'consum', 0.0244, 'lps'),
	(659569, 135, '2015-01-15 00:19:41.000000', 'consum', 0.0247, 'lps'),
	(659570, 135, '2015-01-15 00:19:42.000000', 'consum', 0.0221, 'lps'),
	(659571, 135, '2015-01-15 00:19:43.000000', 'consum', 0.0228, 'lps'),
	(659572, 135, '2015-01-15 00:19:44.000000', 'consum', 0.0269, 'lps'),
	(659573, 135, '2015-01-15 00:19:45.000000', 'consum', 0.0230, 'lps'),
	(659574, 135, '2015-01-15 00:19:46.000000', 'consum', 0.0280, 'lps'),
	(659575, 135, '2015-01-15 00:19:47.000000', 'consum', 0.0280, 'lps'),
	(659576, 135, '2015-01-15 00:19:48.000000', 'consum', 0.0278, 'lps'),
	(659577, 135, '2015-01-15 00:19:49.000000', 'consum', 0.0263, 'lps'),
	(659578, 135, '2015-01-15 00:19:50.000000', 'consum', 0.0272, 'lps'),
	(659579, 135, '2015-01-15 00:19:51.000000', 'consum', 0.0213, 'lps'),
	(659580, 135, '2015-01-15 00:19:52.000000', 'consum', 0.0261, 'lps'),
	(659581, 135, '2015-01-15 00:19:53.000000', 'consum', 0.0233, 'lps'),
	(659582, 135, '2015-01-15 00:19:54.000000', 'consum', 0.0250, 'lps'),
	(659583, 135, '2015-01-15 00:19:55.000000', 'consum', 0.0264, 'lps'),
	(659584, 135, '2015-01-15 00:19:56.000000', 'consum', 0.0215, 'lps'),
	(659585, 135, '2015-01-15 00:19:57.000000', 'consum', 0.0221, 'lps'),
	(659586, 135, '2015-01-15 00:19:58.000000', 'consum', 0.0248, 'lps'),
	(659587, 135, '2015-01-15 00:19:59.000000', 'consum', 0.0223, 'lps'),
	(659588, 135, '2015-01-15 00:20:00.000000', 'consum', 0.0232, 'lps'),
	(659589, 135, '2015-01-15 00:20:01.000000', 'consum', 0.0283, 'lps'),
	(659590, 135, '2015-01-15 00:20:02.000000', 'consum', 0.0215, 'lps'),
	(659591, 135, '2015-01-15 00:20:03.000000', 'consum', 0.0238, 'lps'),
	(659592, 135, '2015-01-15 00:20:04.000000', 'consum', 0.0263, 'lps'),
	(659593, 135, '2015-01-15 00:20:05.000000', 'consum', 0.0243, 'lps'),
	(659594, 135, '2015-01-15 00:20:06.000000', 'consum', 0.0214, 'lps'),
	(659595, 135, '2015-01-15 00:20:07.000000', 'consum', 0.0283, 'lps'),
	(659596, 135, '2015-01-15 00:20:08.000000', 'consum', 0.0266, 'lps'),
	(659597, 135, '2015-01-15 00:20:09.000000', 'consum', 0.0271, 'lps'),
	(659598, 135, '2015-01-15 00:20:10.000000', 'consum', 0.0274, 'lps'),
	(659599, 135, '2015-01-15 00:20:11.000000', 'consum', 0.0271, 'lps'),
	(659600, 135, '2015-01-15 00:20:12.000000', 'consum', 0.0252, 'lps'),
	(659601, 135, '2015-01-15 00:20:13.000000', 'consum', 0.0239, 'lps'),
	(659602, 135, '2015-01-15 00:20:14.000000', 'consum', 0.0227, 'lps'),
	(659603, 135, '2015-01-15 00:20:15.000000', 'consum', 0.0282, 'lps'),
	(659604, 135, '2015-01-15 00:20:16.000000', 'consum', 0.0224, 'lps'),
	(659605, 135, '2015-01-15 00:20:17.000000', 'consum', 0.0211, 'lps'),
	(659606, 135, '2015-01-15 00:20:18.000000', 'consum', 0.0250, 'lps'),
	(659607, 135, '2015-01-15 00:20:19.000000', 'consum', 0.0260, 'lps'),
	(659608, 135, '2015-01-15 00:20:20.000000', 'consum', 0.0266, 'lps'),
	(659609, 135, '2015-01-15 00:20:21.000000', 'consum', 0.0266, 'lps'),
	(659610, 135, '2015-01-15 00:20:22.000000', 'consum', 0.0247, 'lps'),
	(659611, 135, '2015-01-15 00:20:23.000000', 'consum', 0.0231, 'lps'),
	(659612, 135, '2015-01-15 00:20:24.000000', 'consum', 0.0275, 'lps'),
	(659613, 135, '2015-01-15 00:20:25.000000', 'consum', 0.0251, 'lps'),
	(659614, 135, '2015-01-15 00:20:26.000000', 'consum', 0.0221, 'lps'),
	(659615, 135, '2015-01-15 00:20:27.000000', 'consum', 0.0215, 'lps'),
	(659616, 135, '2015-01-15 00:20:28.000000', 'consum', 0.0276, 'lps'),
	(659617, 135, '2015-01-15 00:20:29.000000', 'consum', 0.0230, 'lps'),
	(659618, 135, '2015-01-15 00:20:30.000000', 'consum', 0.0261, 'lps'),
	(659619, 135, '2015-01-15 00:20:31.000000', 'consum', 0.0256, 'lps'),
	(659620, 135, '2015-01-15 00:20:32.000000', 'consum', 0.0214, 'lps'),
	(659621, 135, '2015-01-15 00:20:33.000000', 'consum', 0.0241, 'lps'),
	(659622, 135, '2015-01-15 00:20:34.000000', 'consum', 0.0278, 'lps'),
	(659623, 135, '2015-01-15 00:20:35.000000', 'consum', 0.0238, 'lps'),
	(659624, 135, '2015-01-15 00:20:36.000000', 'consum', 0.0219, 'lps'),
	(659625, 135, '2015-01-15 00:20:37.000000', 'consum', 0.0245, 'lps'),
	(659626, 135, '2015-01-15 00:20:38.000000', 'consum', 0.0283, 'lps'),
	(659627, 135, '2015-01-15 00:20:39.000000', 'consum', 0.0250, 'lps'),
	(659628, 135, '2015-01-15 00:20:40.000000', 'consum', 0.0265, 'lps'),
	(659629, 135, '2015-01-15 00:20:41.000000', 'consum', 0.0217, 'lps'),
	(659630, 135, '2015-01-15 00:20:42.000000', 'consum', 0.0227, 'lps'),
	(659631, 135, '2015-01-15 00:20:43.000000', 'consum', 0.0276, 'lps'),
	(659632, 135, '2015-01-15 00:20:44.000000', 'consum', 0.0267, 'lps'),
	(659633, 135, '2015-01-15 00:20:45.000000', 'consum', 0.0225, 'lps'),
	(659634, 135, '2015-01-15 00:20:46.000000', 'consum', 0.0263, 'lps'),
	(659635, 135, '2015-01-15 00:20:47.000000', 'consum', 0.0281, 'lps'),
	(659636, 135, '2015-01-15 00:20:48.000000', 'consum', 0.0257, 'lps'),
	(659637, 135, '2015-01-15 00:20:49.000000', 'consum', 0.0233, 'lps'),
	(659638, 135, '2015-01-15 00:20:50.000000', 'consum', 0.0261, 'lps'),
	(659639, 135, '2015-01-15 00:20:51.000000', 'consum', 0.0248, 'lps'),
	(659640, 135, '2015-01-15 00:20:52.000000', 'consum', 0.0247, 'lps'),
	(659641, 135, '2015-01-15 00:20:53.000000', 'consum', 0.0279, 'lps'),
	(659642, 135, '2015-01-15 00:20:54.000000', 'consum', 0.0225, 'lps'),
	(659643, 135, '2015-01-15 00:20:55.000000', 'consum', 0.0228, 'lps'),
	(659644, 135, '2015-01-15 00:20:56.000000', 'consum', 0.0254, 'lps'),
	(659645, 135, '2015-01-15 00:20:57.000000', 'consum', 0.0229, 'lps'),
	(659646, 135, '2015-01-15 00:20:58.000000', 'consum', 0.0245, 'lps'),
	(659647, 135, '2015-01-15 00:20:59.000000', 'consum', 0.0258, 'lps'),
	(659648, 135, '2015-01-15 00:21:00.000000', 'consum', 0.0269, 'lps'),
	(659649, 135, '2015-01-15 00:21:01.000000', 'consum', 0.0214, 'lps'),
	(659650, 135, '2015-01-15 00:21:02.000000', 'consum', 0.0277, 'lps'),
	(659651, 135, '2015-01-15 00:21:03.000000', 'consum', 0.0236, 'lps'),
	(659652, 135, '2015-01-15 00:21:04.000000', 'consum', 0.0213, 'lps'),
	(659653, 135, '2015-01-15 00:21:05.000000', 'consum', 0.0222, 'lps'),
	(659654, 135, '2015-01-15 00:21:06.000000', 'consum', 0.0260, 'lps'),
	(659655, 135, '2015-01-15 00:21:07.000000', 'consum', 0.0279, 'lps'),
	(659656, 135, '2015-01-15 00:21:08.000000', 'consum', 0.0258, 'lps'),
	(659657, 135, '2015-01-15 00:21:09.000000', 'consum', 0.0244, 'lps'),
	(659658, 135, '2015-01-15 00:21:10.000000', 'consum', 0.0234, 'lps'),
	(659659, 135, '2015-01-15 00:21:11.000000', 'consum', 0.0229, 'lps'),
	(659660, 135, '2015-01-15 00:21:12.000000', 'consum', 0.0235, 'lps'),
	(659661, 135, '2015-01-15 00:21:13.000000', 'consum', 0.0277, 'lps'),
	(659662, 135, '2015-01-15 00:21:14.000000', 'consum', 0.0249, 'lps'),
	(659663, 135, '2015-01-15 00:21:15.000000', 'consum', 0.0278, 'lps'),
	(659664, 135, '2015-01-15 00:21:16.000000', 'consum', 0.0210, 'lps'),
	(659665, 135, '2015-01-15 00:21:17.000000', 'consum', 0.0229, 'lps'),
	(659666, 135, '2015-01-15 00:21:18.000000', 'consum', 0.0233, 'lps'),
	(659667, 135, '2015-01-15 00:21:19.000000', 'consum', 0.0267, 'lps'),
	(659668, 135, '2015-01-15 00:21:20.000000', 'consum', 0.0277, 'lps'),
	(659669, 135, '2015-01-15 00:21:21.000000', 'consum', 0.0230, 'lps'),
	(659670, 135, '2015-01-15 00:21:22.000000', 'consum', 0.0255, 'lps'),
	(659671, 135, '2015-01-15 00:21:23.000000', 'consum', 0.0230, 'lps'),
	(659672, 135, '2015-01-15 00:21:24.000000', 'consum', 0.0246, 'lps'),
	(659673, 135, '2015-01-15 00:21:25.000000', 'consum', 0.0259, 'lps'),
	(659674, 135, '2015-01-15 00:21:26.000000', 'consum', 0.0273, 'lps'),
	(659675, 135, '2015-01-15 00:21:27.000000', 'consum', 0.0230, 'lps'),
	(659676, 135, '2015-01-15 00:21:28.000000', 'consum', 0.0269, 'lps'),
	(659677, 135, '2015-01-15 00:21:29.000000', 'consum', 0.0223, 'lps'),
	(659678, 135, '2015-01-15 00:21:30.000000', 'consum', 0.0246, 'lps'),
	(659679, 135, '2015-01-15 00:21:31.000000', 'consum', 0.0279, 'lps'),
	(659680, 135, '2015-01-15 00:21:32.000000', 'consum', 0.0225, 'lps'),
	(659681, 135, '2015-01-15 00:21:33.000000', 'consum', 0.0227, 'lps'),
	(659682, 135, '2015-01-15 00:21:34.000000', 'consum', 0.0250, 'lps'),
	(659683, 135, '2015-01-15 00:21:35.000000', 'consum', 0.0214, 'lps'),
	(659684, 135, '2015-01-15 00:21:36.000000', 'consum', 0.0255, 'lps'),
	(659685, 135, '2015-01-15 00:21:37.000000', 'consum', 0.0279, 'lps'),
	(659686, 135, '2015-01-15 00:21:38.000000', 'consum', 0.0271, 'lps'),
	(659687, 135, '2015-01-15 00:21:39.000000', 'consum', 0.0233, 'lps'),
	(659688, 135, '2015-01-15 00:21:40.000000', 'consum', 0.0218, 'lps'),
	(659689, 135, '2015-01-15 00:21:41.000000', 'consum', 0.0253, 'lps'),
	(659690, 135, '2015-01-15 00:21:42.000000', 'consum', 0.0256, 'lps'),
	(659691, 135, '2015-01-15 00:21:43.000000', 'consum', 0.0238, 'lps'),
	(659692, 135, '2015-01-15 00:21:44.000000', 'consum', 0.0212, 'lps'),
	(659693, 135, '2015-01-15 00:21:45.000000', 'consum', 0.0212, 'lps'),
	(659694, 135, '2015-01-15 00:21:46.000000', 'consum', 0.0215, 'lps'),
	(659695, 135, '2015-01-15 00:21:47.000000', 'consum', 0.0226, 'lps'),
	(659696, 135, '2015-01-15 00:21:48.000000', 'consum', 0.0279, 'lps'),
	(659697, 135, '2015-01-15 00:21:49.000000', 'consum', 0.0282, 'lps'),
	(659698, 135, '2015-01-15 00:21:50.000000', 'consum', 0.0218, 'lps'),
	(659699, 135, '2015-01-15 00:21:51.000000', 'consum', 0.0254, 'lps'),
	(659700, 135, '2015-01-15 00:21:52.000000', 'consum', 0.0258, 'lps'),
	(659701, 135, '2015-01-15 00:21:53.000000', 'consum', 0.0247, 'lps'),
	(659702, 135, '2015-01-15 00:21:54.000000', 'consum', 0.0252, 'lps'),
	(659703, 135, '2015-01-15 00:21:55.000000', 'consum', 0.0234, 'lps'),
	(659704, 135, '2015-01-15 00:21:56.000000', 'consum', 0.0280, 'lps'),
	(659705, 135, '2015-01-15 00:21:57.000000', 'consum', 0.0267, 'lps'),
	(659706, 135, '2015-01-15 00:21:58.000000', 'consum', 0.0212, 'lps'),
	(659707, 135, '2015-01-15 00:21:59.000000', 'consum', 0.0270, 'lps'),
	(659708, 135, '2015-01-15 00:22:00.000000', 'consum', 0.0282, 'lps'),
	(659709, 135, '2015-01-15 00:22:01.000000', 'consum', 0.0244, 'lps'),
	(659710, 135, '2015-01-15 00:22:02.000000', 'consum', 0.0236, 'lps'),
	(659711, 135, '2015-01-15 00:22:03.000000', 'consum', 0.0239, 'lps'),
	(659712, 135, '2015-01-15 00:22:04.000000', 'consum', 0.0279, 'lps'),
	(659713, 135, '2015-01-15 00:22:05.000000', 'consum', 0.0248, 'lps'),
	(659714, 135, '2015-01-15 00:22:06.000000', 'consum', 0.0265, 'lps'),
	(659715, 135, '2015-01-15 00:22:07.000000', 'consum', 0.0224, 'lps'),
	(659716, 135, '2015-01-15 00:22:08.000000', 'consum', 0.0265, 'lps'),
	(659717, 135, '2015-01-15 00:22:09.000000', 'consum', 0.0218, 'lps'),
	(659718, 135, '2015-01-15 00:22:10.000000', 'consum', 0.0237, 'lps'),
	(659719, 135, '2015-01-15 00:22:11.000000', 'consum', 0.0247, 'lps'),
	(659720, 135, '2015-01-15 00:22:12.000000', 'consum', 0.0240, 'lps'),
	(659721, 135, '2015-01-15 00:22:13.000000', 'consum', 0.0248, 'lps'),
	(659722, 135, '2015-01-15 00:22:14.000000', 'consum', 0.0236, 'lps'),
	(659723, 135, '2015-01-15 00:22:15.000000', 'consum', 0.0227, 'lps'),
	(659724, 135, '2015-01-15 00:22:16.000000', 'consum', 0.0216, 'lps'),
	(659725, 135, '2015-01-15 00:22:17.000000', 'consum', 0.0266, 'lps'),
	(659726, 135, '2015-01-15 00:22:18.000000', 'consum', 0.0248, 'lps'),
	(659727, 135, '2015-01-15 00:22:19.000000', 'consum', 0.0233, 'lps'),
	(659728, 135, '2015-01-15 00:22:20.000000', 'consum', 0.0212, 'lps'),
	(659729, 135, '2015-01-15 00:22:21.000000', 'consum', 0.0227, 'lps'),
	(659730, 135, '2015-01-15 00:22:22.000000', 'consum', 0.0212, 'lps'),
	(659731, 135, '2015-01-15 00:22:23.000000', 'consum', 0.0247, 'lps'),
	(659732, 135, '2015-01-15 00:22:24.000000', 'consum', 0.0240, 'lps'),
	(659733, 135, '2015-01-15 00:22:25.000000', 'consum', 0.0250, 'lps'),
	(659734, 135, '2015-01-15 00:22:26.000000', 'consum', 0.0246, 'lps'),
	(659735, 135, '2015-01-15 00:22:27.000000', 'consum', 0.0269, 'lps'),
	(659736, 135, '2015-01-15 00:22:28.000000', 'consum', 0.0250, 'lps'),
	(659737, 135, '2015-01-15 00:22:29.000000', 'consum', 0.0234, 'lps'),
	(659738, 135, '2015-01-15 00:22:30.000000', 'consum', 0.0211, 'lps'),
	(659739, 135, '2015-01-15 00:22:31.000000', 'consum', 0.0218, 'lps'),
	(659740, 135, '2015-01-15 00:22:32.000000', 'consum', 0.0247, 'lps'),
	(659741, 135, '2015-01-15 00:22:33.000000', 'consum', 0.0223, 'lps'),
	(659742, 135, '2015-01-15 00:22:34.000000', 'consum', 0.0238, 'lps'),
	(659743, 135, '2015-01-15 00:22:35.000000', 'consum', 0.0237, 'lps'),
	(659744, 135, '2015-01-15 00:22:36.000000', 'consum', 0.0260, 'lps'),
	(659745, 135, '2015-01-15 00:22:37.000000', 'consum', 0.0235, 'lps'),
	(659746, 135, '2015-01-15 00:22:38.000000', 'consum', 0.0258, 'lps'),
	(659747, 135, '2015-01-15 00:22:39.000000', 'consum', 0.0227, 'lps'),
	(659748, 135, '2015-01-15 00:22:40.000000', 'consum', 0.0225, 'lps'),
	(659749, 135, '2015-01-15 00:22:41.000000', 'consum', 0.0237, 'lps'),
	(659750, 135, '2015-01-15 00:22:42.000000', 'consum', 0.0223, 'lps'),
	(659751, 135, '2015-01-15 00:22:43.000000', 'consum', 0.0271, 'lps'),
	(659752, 135, '2015-01-15 00:22:44.000000', 'consum', 0.0255, 'lps'),
	(659753, 135, '2015-01-15 00:22:45.000000', 'consum', 0.0252, 'lps'),
	(659754, 135, '2015-01-15 00:22:46.000000', 'consum', 0.0283, 'lps'),
	(659755, 135, '2015-01-15 00:22:47.000000', 'consum', 0.0231, 'lps'),
	(659756, 135, '2015-01-15 00:22:48.000000', 'consum', 0.0244, 'lps'),
	(659757, 135, '2015-01-15 00:22:49.000000', 'consum', 0.0244, 'lps'),
	(659758, 135, '2015-01-15 00:22:50.000000', 'consum', 0.0277, 'lps'),
	(659759, 135, '2015-01-15 00:22:51.000000', 'consum', 0.0221, 'lps'),
	(659760, 135, '2015-01-15 00:22:52.000000', 'consum', 0.0212, 'lps'),
	(659761, 135, '2015-01-15 00:22:53.000000', 'consum', 0.0263, 'lps'),
	(659762, 135, '2015-01-15 00:22:54.000000', 'consum', 0.0249, 'lps'),
	(659763, 135, '2015-01-15 00:22:55.000000', 'consum', 0.0244, 'lps'),
	(659764, 135, '2015-01-15 00:22:56.000000', 'consum', 0.0263, 'lps'),
	(659765, 135, '2015-01-15 00:22:57.000000', 'consum', 0.0225, 'lps'),
	(659766, 135, '2015-01-15 00:22:58.000000', 'consum', 0.0276, 'lps'),
	(659767, 135, '2015-01-15 00:22:59.000000', 'consum', 0.0272, 'lps'),
	(659768, 135, '2015-01-15 00:23:00.000000', 'consum', 0.0248, 'lps'),
	(659769, 135, '2015-01-15 00:23:01.000000', 'consum', 0.0214, 'lps'),
	(659770, 135, '2015-01-15 00:23:02.000000', 'consum', 0.0267, 'lps'),
	(659771, 135, '2015-01-15 00:23:03.000000', 'consum', 0.0260, 'lps'),
	(659772, 135, '2015-01-15 00:23:04.000000', 'consum', 0.0217, 'lps'),
	(659773, 135, '2015-01-15 00:23:05.000000', 'consum', 0.0241, 'lps'),
	(659774, 135, '2015-01-15 00:23:06.000000', 'consum', 0.0272, 'lps'),
	(659775, 135, '2015-01-15 00:23:07.000000', 'consum', 0.0280, 'lps'),
	(659776, 135, '2015-01-15 00:23:08.000000', 'consum', 0.0227, 'lps'),
	(659777, 135, '2015-01-15 00:23:09.000000', 'consum', 0.0232, 'lps'),
	(659778, 135, '2015-01-15 00:23:10.000000', 'consum', 0.0271, 'lps'),
	(659779, 135, '2015-01-15 00:23:11.000000', 'consum', 0.0226, 'lps'),
	(659780, 135, '2015-01-15 00:23:12.000000', 'consum', 0.0258, 'lps'),
	(659781, 135, '2015-01-15 00:23:13.000000', 'consum', 0.0251, 'lps'),
	(659782, 135, '2015-01-15 00:23:14.000000', 'consum', 0.0275, 'lps'),
	(659783, 135, '2015-01-15 00:23:15.000000', 'consum', 0.0262, 'lps'),
	(659784, 135, '2015-01-15 00:23:16.000000', 'consum', 0.0276, 'lps'),
	(659785, 135, '2015-01-15 00:23:17.000000', 'consum', 0.0235, 'lps'),
	(659786, 135, '2015-01-15 00:23:18.000000', 'consum', 0.0214, 'lps'),
	(659787, 135, '2015-01-15 00:23:19.000000', 'consum', 0.0227, 'lps'),
	(659788, 135, '2015-01-15 00:23:20.000000', 'consum', 0.0283, 'lps'),
	(659789, 135, '2015-01-15 00:23:21.000000', 'consum', 0.0231, 'lps'),
	(659790, 135, '2015-01-15 00:23:22.000000', 'consum', 0.0242, 'lps'),
	(659791, 135, '2015-01-15 00:23:23.000000', 'consum', 0.0233, 'lps'),
	(659792, 135, '2015-01-15 00:23:24.000000', 'consum', 0.0230, 'lps'),
	(659793, 135, '2015-01-15 00:23:25.000000', 'consum', 0.0242, 'lps'),
	(659794, 135, '2015-01-15 00:23:26.000000', 'consum', 0.0235, 'lps'),
	(659795, 135, '2015-01-15 00:23:27.000000', 'consum', 0.0241, 'lps'),
	(659796, 135, '2015-01-15 00:23:28.000000', 'consum', 0.0216, 'lps'),
	(659797, 135, '2015-01-15 00:23:29.000000', 'consum', 0.0221, 'lps'),
	(659798, 135, '2015-01-15 00:23:30.000000', 'consum', 0.0249, 'lps'),
	(659799, 135, '2015-01-15 00:23:31.000000', 'consum', 0.0226, 'lps'),
	(659800, 135, '2015-01-15 00:23:32.000000', 'consum', 0.0245, 'lps'),
	(659801, 135, '2015-01-15 00:23:33.000000', 'consum', 0.0265, 'lps'),
	(659802, 135, '2015-01-15 00:23:34.000000', 'consum', 0.0230, 'lps'),
	(659803, 135, '2015-01-15 00:23:35.000000', 'consum', 0.0220, 'lps'),
	(659804, 135, '2015-01-15 00:23:36.000000', 'consum', 0.0277, 'lps'),
	(659805, 135, '2015-01-15 00:23:37.000000', 'consum', 0.0218, 'lps'),
	(659806, 135, '2015-01-15 00:23:38.000000', 'consum', 0.0274, 'lps'),
	(659807, 135, '2015-01-15 00:23:39.000000', 'consum', 0.0281, 'lps'),
	(659808, 135, '2015-01-15 00:23:40.000000', 'consum', 0.0226, 'lps'),
	(659809, 135, '2015-01-15 00:23:41.000000', 'consum', 0.0225, 'lps'),
	(659810, 135, '2015-01-15 00:23:42.000000', 'consum', 0.0240, 'lps'),
	(659811, 135, '2015-01-15 00:23:43.000000', 'consum', 0.0240, 'lps'),
	(659812, 135, '2015-01-15 00:23:44.000000', 'consum', 0.0270, 'lps'),
	(659813, 135, '2015-01-15 00:23:45.000000', 'consum', 0.0271, 'lps'),
	(659814, 135, '2015-01-15 00:23:46.000000', 'consum', 0.0263, 'lps'),
	(659815, 135, '2015-01-15 00:23:47.000000', 'consum', 0.0219, 'lps'),
	(659816, 135, '2015-01-15 00:23:48.000000', 'consum', 0.0246, 'lps'),
	(659817, 135, '2015-01-15 00:23:49.000000', 'consum', 0.0213, 'lps'),
	(659818, 135, '2015-01-15 00:23:50.000000', 'consum', 0.0267, 'lps'),
	(659819, 135, '2015-01-15 00:23:51.000000', 'consum', 0.0265, 'lps'),
	(659820, 135, '2015-01-15 00:23:52.000000', 'consum', 0.0242, 'lps'),
	(659821, 135, '2015-01-15 00:23:53.000000', 'consum', 0.0277, 'lps'),
	(659822, 135, '2015-01-15 00:23:54.000000', 'consum', 0.0228, 'lps'),
	(659823, 135, '2015-01-15 00:23:55.000000', 'consum', 0.0247, 'lps'),
	(659824, 135, '2015-01-15 00:23:56.000000', 'consum', 0.0270, 'lps'),
	(659825, 135, '2015-01-15 00:23:57.000000', 'consum', 0.0250, 'lps'),
	(659826, 135, '2015-01-15 00:23:58.000000', 'consum', 0.0231, 'lps'),
	(659827, 135, '2015-01-15 00:23:59.000000', 'consum', 0.0268, 'lps'),
	(659828, 135, '2015-01-15 00:24:00.000000', 'consum', 0.0216, 'lps'),
	(659829, 135, '2015-01-15 00:24:01.000000', 'consum', 0.0213, 'lps'),
	(659830, 135, '2015-01-15 00:24:02.000000', 'consum', 0.0283, 'lps'),
	(659831, 135, '2015-01-15 00:24:03.000000', 'consum', 0.0269, 'lps'),
	(659832, 135, '2015-01-15 00:24:04.000000', 'consum', 0.0214, 'lps'),
	(659833, 135, '2015-01-15 00:24:05.000000', 'consum', 0.0275, 'lps'),
	(659834, 135, '2015-01-15 00:24:06.000000', 'consum', 0.0228, 'lps'),
	(659835, 135, '2015-01-15 00:24:07.000000', 'consum', 0.0252, 'lps'),
	(659836, 135, '2015-01-15 00:24:08.000000', 'consum', 0.0218, 'lps'),
	(659837, 135, '2015-01-15 00:24:09.000000', 'consum', 0.0272, 'lps'),
	(659838, 135, '2015-01-15 00:24:10.000000', 'consum', 0.0276, 'lps'),
	(659839, 135, '2015-01-15 00:24:11.000000', 'consum', 0.0280, 'lps'),
	(659840, 135, '2015-01-15 00:24:12.000000', 'consum', 0.0214, 'lps'),
	(659841, 135, '2015-01-15 00:24:13.000000', 'consum', 0.0243, 'lps'),
	(659842, 135, '2015-01-15 00:24:14.000000', 'consum', 0.0215, 'lps'),
	(659843, 135, '2015-01-15 00:24:15.000000', 'consum', 0.0213, 'lps'),
	(659844, 135, '2015-01-15 00:24:16.000000', 'consum', 0.0283, 'lps'),
	(659845, 135, '2015-01-15 00:24:17.000000', 'consum', 0.0269, 'lps'),
	(659846, 135, '2015-01-15 00:24:18.000000', 'consum', 0.0213, 'lps'),
	(659847, 135, '2015-01-15 00:24:19.000000', 'consum', 0.0272, 'lps'),
	(659848, 135, '2015-01-15 00:24:20.000000', 'consum', 0.0217, 'lps'),
	(659849, 135, '2015-01-15 00:24:21.000000', 'consum', 0.0279, 'lps'),
	(659850, 135, '2015-01-15 00:24:22.000000', 'consum', 0.0239, 'lps'),
	(659851, 135, '2015-01-15 00:24:23.000000', 'consum', 0.0221, 'lps'),
	(659852, 135, '2015-01-15 00:24:24.000000', 'consum', 0.0254, 'lps'),
	(659853, 135, '2015-01-15 00:24:25.000000', 'consum', 0.0248, 'lps'),
	(659854, 135, '2015-01-15 00:24:26.000000', 'consum', 0.0268, 'lps'),
	(659855, 135, '2015-01-15 00:24:27.000000', 'consum', 0.0238, 'lps'),
	(659856, 135, '2015-01-15 00:24:28.000000', 'consum', 0.0251, 'lps'),
	(659857, 135, '2015-01-15 00:24:29.000000', 'consum', 0.0258, 'lps'),
	(659858, 135, '2015-01-15 00:24:30.000000', 'consum', 0.0255, 'lps'),
	(659859, 135, '2015-01-15 00:24:31.000000', 'consum', 0.0215, 'lps'),
	(659860, 135, '2015-01-15 00:24:32.000000', 'consum', 0.0248, 'lps'),
	(659861, 135, '2015-01-15 00:24:33.000000', 'consum', 0.0239, 'lps'),
	(659862, 135, '2015-01-15 00:24:34.000000', 'consum', 0.0240, 'lps'),
	(659863, 135, '2015-01-15 00:24:35.000000', 'consum', 0.0273, 'lps'),
	(659864, 135, '2015-01-15 00:24:36.000000', 'consum', 0.0215, 'lps'),
	(659865, 135, '2015-01-15 00:24:37.000000', 'consum', 0.0266, 'lps'),
	(659866, 135, '2015-01-15 00:24:38.000000', 'consum', 0.0256, 'lps'),
	(659867, 135, '2015-01-15 00:24:39.000000', 'consum', 0.0272, 'lps'),
	(659868, 135, '2015-01-15 00:24:40.000000', 'consum', 0.0234, 'lps'),
	(659869, 135, '2015-01-15 00:24:41.000000', 'consum', 0.0219, 'lps'),
	(659870, 135, '2015-01-15 00:24:42.000000', 'consum', 0.0259, 'lps'),
	(659871, 135, '2015-01-15 00:24:43.000000', 'consum', 0.0281, 'lps'),
	(659872, 135, '2015-01-15 00:24:44.000000', 'consum', 0.0270, 'lps'),
	(659873, 135, '2015-01-15 00:24:45.000000', 'consum', 0.0222, 'lps'),
	(659874, 135, '2015-01-15 00:24:46.000000', 'consum', 0.0240, 'lps'),
	(659875, 135, '2015-01-15 00:24:47.000000', 'consum', 0.0252, 'lps'),
	(659876, 135, '2015-01-15 00:24:48.000000', 'consum', 0.0253, 'lps'),
	(659877, 135, '2015-01-15 00:24:49.000000', 'consum', 0.0228, 'lps'),
	(659878, 135, '2015-01-15 00:24:50.000000', 'consum', 0.0244, 'lps'),
	(659879, 135, '2015-01-15 00:24:51.000000', 'consum', 0.0254, 'lps'),
	(659880, 135, '2015-01-15 00:24:52.000000', 'consum', 0.0255, 'lps'),
	(659881, 135, '2015-01-15 00:24:53.000000', 'consum', 0.0228, 'lps'),
	(659882, 135, '2015-01-15 00:24:54.000000', 'consum', 0.0238, 'lps'),
	(659883, 135, '2015-01-15 00:24:55.000000', 'consum', 0.0224, 'lps'),
	(659884, 135, '2015-01-15 00:24:56.000000', 'consum', 0.0269, 'lps'),
	(659885, 135, '2015-01-15 00:24:57.000000', 'consum', 0.0243, 'lps'),
	(659886, 135, '2015-01-15 00:24:58.000000', 'consum', 0.0273, 'lps'),
	(659887, 135, '2015-01-15 00:24:59.000000', 'consum', 0.0276, 'lps'),
	(659888, 135, '2015-01-15 00:25:00.000000', 'consum', 0.0280, 'lps'),
	(659889, 135, '2015-01-15 00:25:01.000000', 'consum', 0.0214, 'lps'),
	(659890, 135, '2015-01-15 00:25:02.000000', 'consum', 0.0242, 'lps'),
	(659891, 135, '2015-01-15 00:25:03.000000', 'consum', 0.0213, 'lps'),
	(659892, 135, '2015-01-15 00:25:04.000000', 'consum', 0.0274, 'lps'),
	(659893, 135, '2015-01-15 00:25:05.000000', 'consum', 0.0228, 'lps'),
	(659894, 135, '2015-01-15 00:25:06.000000', 'consum', 0.0254, 'lps'),
	(659895, 135, '2015-01-15 00:25:07.000000', 'consum', 0.0229, 'lps'),
	(659896, 135, '2015-01-15 00:25:08.000000', 'consum', 0.0250, 'lps'),
	(659897, 135, '2015-01-15 00:25:09.000000', 'consum', 0.0276, 'lps'),
	(659898, 135, '2015-01-15 00:25:10.000000', 'consum', 0.0276, 'lps'),
	(659899, 135, '2015-01-15 00:25:11.000000', 'consum', 0.0267, 'lps'),
	(659900, 135, '2015-01-15 00:25:12.000000', 'consum', 0.0225, 'lps'),
	(659901, 135, '2015-01-15 00:25:13.000000', 'consum', 0.0263, 'lps'),
	(659902, 135, '2015-01-15 00:25:14.000000', 'consum', 0.0282, 'lps'),
	(659903, 135, '2015-01-15 00:25:15.000000', 'consum', 0.0265, 'lps'),
	(659904, 135, '2015-01-15 00:25:16.000000', 'consum', 0.0266, 'lps'),
	(659905, 135, '2015-01-15 00:25:17.000000', 'consum', 0.0254, 'lps'),
	(659906, 135, '2015-01-15 00:25:18.000000', 'consum', 0.0262, 'lps'),
	(659907, 135, '2015-01-15 00:25:19.000000', 'consum', 0.0265, 'lps'),
	(659908, 135, '2015-01-15 00:25:20.000000', 'consum', 0.0256, 'lps'),
	(659909, 135, '2015-01-15 00:25:21.000000', 'consum', 0.0274, 'lps'),
	(659910, 135, '2015-01-15 00:25:22.000000', 'consum', 0.0246, 'lps'),
	(659911, 135, '2015-01-15 00:25:23.000000', 'consum', 0.0271, 'lps'),
	(659912, 135, '2015-01-15 00:25:24.000000', 'consum', 0.0258, 'lps'),
	(659913, 135, '2015-01-15 00:25:25.000000', 'consum', 0.0269, 'lps'),
	(659914, 135, '2015-01-15 00:25:26.000000', 'consum', 0.0213, 'lps'),
	(659915, 135, '2015-01-15 00:25:27.000000', 'consum', 0.0270, 'lps'),
	(659916, 135, '2015-01-15 00:25:28.000000', 'consum', 0.0278, 'lps'),
	(659917, 135, '2015-01-15 00:25:29.000000', 'consum', 0.0225, 'lps'),
	(659918, 135, '2015-01-15 00:25:30.000000', 'consum', 0.0230, 'lps'),
	(659919, 135, '2015-01-15 00:25:31.000000', 'consum', 0.0267, 'lps'),
	(659920, 135, '2015-01-15 00:25:32.000000', 'consum', 0.0211, 'lps'),
	(659921, 135, '2015-01-15 00:25:33.000000', 'consum', 0.0265, 'lps'),
	(659922, 135, '2015-01-15 00:25:34.000000', 'consum', 0.0263, 'lps'),
	(659923, 135, '2015-01-15 00:25:35.000000', 'consum', 0.0234, 'lps'),
	(659924, 135, '2015-01-15 00:25:36.000000', 'consum', 0.0247, 'lps'),
	(659925, 135, '2015-01-15 00:25:37.000000', 'consum', 0.0248, 'lps'),
	(659926, 135, '2015-01-15 00:25:38.000000', 'consum', 0.0217, 'lps'),
	(659927, 135, '2015-01-15 00:25:39.000000', 'consum', 0.0280, 'lps'),
	(659928, 135, '2015-01-15 00:25:40.000000', 'consum', 0.0241, 'lps'),
	(659929, 135, '2015-01-15 00:25:41.000000', 'consum', 0.0233, 'lps'),
	(659930, 135, '2015-01-15 00:25:42.000000', 'consum', 0.0231, 'lps'),
	(659931, 135, '2015-01-15 00:25:43.000000', 'consum', 0.0245, 'lps'),
	(659932, 135, '2015-01-15 00:25:44.000000', 'consum', 0.0250, 'lps'),
	(659933, 135, '2015-01-15 00:25:45.000000', 'consum', 0.0231, 'lps'),
	(659934, 135, '2015-01-15 00:25:46.000000', 'consum', 0.0270, 'lps'),
	(659935, 135, '2015-01-15 00:25:47.000000', 'consum', 0.0225, 'lps'),
	(659936, 135, '2015-01-15 00:25:48.000000', 'consum', 0.0254, 'lps'),
	(659937, 135, '2015-01-15 00:25:49.000000', 'consum', 0.0236, 'lps'),
	(659938, 135, '2015-01-15 00:25:50.000000', 'consum', 0.0282, 'lps'),
	(659939, 135, '2015-01-15 00:25:51.000000', 'consum', 0.0271, 'lps'),
	(659940, 135, '2015-01-15 00:25:52.000000', 'consum', 0.0227, 'lps'),
	(659941, 135, '2015-01-15 00:25:53.000000', 'consum', 0.0261, 'lps'),
	(659942, 135, '2015-01-15 00:25:54.000000', 'consum', 0.0266, 'lps'),
	(659943, 135, '2015-01-15 00:25:55.000000', 'consum', 0.0264, 'lps'),
	(659944, 135, '2015-01-15 00:25:56.000000', 'consum', 0.0236, 'lps'),
	(659945, 135, '2015-01-15 00:25:57.000000', 'consum', 0.0255, 'lps'),
	(659946, 135, '2015-01-15 00:25:58.000000', 'consum', 0.0282, 'lps'),
	(659947, 135, '2015-01-15 00:25:59.000000', 'consum', 0.0216, 'lps'),
	(659948, 135, '2015-01-15 00:26:00.000000', 'consum', 0.0243, 'lps'),
	(659949, 135, '2015-01-15 00:26:01.000000', 'consum', 0.0211, 'lps'),
	(659950, 135, '2015-01-15 00:26:02.000000', 'consum', 0.0267, 'lps'),
	(659951, 135, '2015-01-15 00:26:03.000000', 'consum', 0.0267, 'lps'),
	(659952, 135, '2015-01-15 00:26:04.000000', 'consum', 0.0251, 'lps'),
	(659953, 135, '2015-01-15 00:26:05.000000', 'consum', 0.0246, 'lps'),
	(659954, 135, '2015-01-15 00:26:06.000000', 'consum', 0.0266, 'lps'),
	(659955, 135, '2015-01-15 00:26:07.000000', 'consum', 0.0236, 'lps'),
	(659956, 135, '2015-01-15 00:26:08.000000', 'consum', 0.0246, 'lps'),
	(659957, 135, '2015-01-15 00:26:09.000000', 'consum', 0.0238, 'lps'),
	(659958, 135, '2015-01-15 00:26:10.000000', 'consum', 0.0241, 'lps'),
	(659959, 135, '2015-01-15 00:26:11.000000', 'consum', 0.0211, 'lps'),
	(659960, 135, '2015-01-15 00:26:12.000000', 'consum', 0.0267, 'lps'),
	(659961, 135, '2015-01-15 00:26:13.000000', 'consum', 0.0272, 'lps'),
	(659962, 135, '2015-01-15 00:26:14.000000', 'consum', 0.0278, 'lps'),
	(659963, 135, '2015-01-15 00:26:15.000000', 'consum', 0.0213, 'lps'),
	(659964, 135, '2015-01-15 00:26:16.000000', 'consum', 0.0243, 'lps'),
	(659965, 135, '2015-01-15 00:26:17.000000', 'consum', 0.0220, 'lps'),
	(659966, 135, '2015-01-15 00:26:18.000000', 'consum', 0.0235, 'lps'),
	(659967, 135, '2015-01-15 00:26:19.000000', 'consum', 0.0233, 'lps'),
	(659968, 135, '2015-01-15 00:26:20.000000', 'consum', 0.0248, 'lps'),
	(659969, 135, '2015-01-15 00:26:21.000000', 'consum', 0.0257, 'lps'),
	(659970, 135, '2015-01-15 00:26:22.000000', 'consum', 0.0259, 'lps'),
	(659971, 135, '2015-01-15 00:26:23.000000', 'consum', 0.0240, 'lps'),
	(659972, 135, '2015-01-15 00:26:24.000000', 'consum', 0.0212, 'lps'),
	(659973, 135, '2015-01-15 00:26:25.000000', 'consum', 0.0279, 'lps'),
	(659974, 135, '2015-01-15 00:26:26.000000', 'consum', 0.0252, 'lps'),
	(659975, 135, '2015-01-15 00:26:27.000000', 'consum', 0.0217, 'lps'),
	(659976, 135, '2015-01-15 00:26:28.000000', 'consum', 0.0265, 'lps'),
	(659977, 135, '2015-01-15 00:26:29.000000', 'consum', 0.0244, 'lps'),
	(659978, 135, '2015-01-15 00:26:30.000000', 'consum', 0.0214, 'lps'),
	(659979, 135, '2015-01-15 00:26:31.000000', 'consum', 0.0276, 'lps'),
	(659980, 135, '2015-01-15 00:26:32.000000', 'consum', 0.0232, 'lps'),
	(659981, 135, '2015-01-15 00:26:33.000000', 'consum', 0.0270, 'lps'),
	(659982, 135, '2015-01-15 00:26:34.000000', 'consum', 0.0223, 'lps'),
	(659983, 135, '2015-01-15 00:26:35.000000', 'consum', 0.0244, 'lps'),
	(659984, 135, '2015-01-15 00:26:36.000000', 'consum', 0.0269, 'lps'),
	(659985, 135, '2015-01-15 00:26:37.000000', 'consum', 0.0255, 'lps'),
	(659986, 135, '2015-01-15 00:26:38.000000', 'consum', 0.0259, 'lps'),
	(659987, 135, '2015-01-15 00:26:39.000000', 'consum', 0.0244, 'lps'),
	(659988, 135, '2015-01-15 00:26:40.000000', 'consum', 0.0234, 'lps'),
	(659989, 135, '2015-01-15 00:26:41.000000', 'consum', 0.0231, 'lps'),
	(659990, 135, '2015-01-15 00:26:42.000000', 'consum', 0.0242, 'lps'),
	(659991, 135, '2015-01-15 00:26:43.000000', 'consum', 0.0234, 'lps'),
	(659992, 135, '2015-01-15 00:26:44.000000', 'consum', 0.0234, 'lps'),
	(659993, 135, '2015-01-15 00:26:45.000000', 'consum', 0.0257, 'lps'),
	(659994, 135, '2015-01-15 00:26:46.000000', 'consum', 0.0227, 'lps'),
	(659995, 135, '2015-01-15 00:26:47.000000', 'consum', 0.0226, 'lps'),
	(659996, 135, '2015-01-15 00:26:48.000000', 'consum', 0.0242, 'lps'),
	(659997, 135, '2015-01-15 00:26:49.000000', 'consum', 0.0250, 'lps'),
	(659998, 135, '2015-01-15 00:26:50.000000', 'consum', 0.0238, 'lps'),
	(659999, 135, '2015-01-15 00:26:51.000000', 'consum', 0.0229, 'lps'),
	(660000, 135, '2015-01-15 00:26:52.000000', 'consum', 0.0225, 'lps'),
	(660001, 135, '2015-01-15 00:26:53.000000', 'consum', 0.0227, 'lps'),
	(660002, 135, '2015-01-15 00:26:54.000000', 'consum', 0.0250, 'lps'),
	(660003, 135, '2015-01-15 00:26:55.000000', 'consum', 0.0213, 'lps'),
	(660004, 135, '2015-01-15 00:26:56.000000', 'consum', 0.0253, 'lps'),
	(660005, 135, '2015-01-15 00:26:57.000000', 'consum', 0.0270, 'lps'),
	(660006, 135, '2015-01-15 00:26:58.000000', 'consum', 0.0231, 'lps'),
	(660007, 135, '2015-01-15 00:26:59.000000', 'consum', 0.0283, 'lps'),
	(660008, 135, '2015-01-15 00:27:00.000000', 'consum', 0.0216, 'lps'),
	(660009, 135, '2015-01-15 00:27:01.000000', 'consum', 0.0246, 'lps'),
	(660010, 135, '2015-01-15 00:27:02.000000', 'consum', 0.0223, 'lps'),
	(660011, 135, '2015-01-15 00:27:03.000000', 'consum', 0.0242, 'lps'),
	(660012, 135, '2015-01-15 00:27:04.000000', 'consum', 0.0256, 'lps'),
	(660013, 135, '2015-01-15 00:27:05.000000', 'consum', 0.0273, 'lps'),
	(660014, 135, '2015-01-15 00:27:06.000000', 'consum', 0.0239, 'lps'),
	(660015, 135, '2015-01-15 00:27:07.000000', 'consum', 0.0238, 'lps'),
	(660016, 135, '2015-01-15 00:27:08.000000', 'consum', 0.0266, 'lps'),
	(660017, 135, '2015-01-15 00:27:09.000000', 'consum', 0.0259, 'lps'),
	(660018, 135, '2015-01-15 00:27:10.000000', 'consum', 0.0213, 'lps'),
	(660019, 135, '2015-01-15 00:27:11.000000', 'consum', 0.0225, 'lps'),
	(660020, 135, '2015-01-15 00:27:12.000000', 'consum', 0.0279, 'lps'),
	(660021, 135, '2015-01-15 00:27:13.000000', 'consum', 0.0215, 'lps'),
	(660022, 135, '2015-01-15 00:27:14.000000', 'consum', 0.0248, 'lps'),
	(660023, 135, '2015-01-15 00:27:15.000000', 'consum', 0.0237, 'lps'),
	(660024, 135, '2015-01-15 00:27:16.000000', 'consum', 0.0233, 'lps'),
	(660025, 135, '2015-01-15 00:27:17.000000', 'consum', 0.0246, 'lps'),
	(660026, 135, '2015-01-15 00:27:18.000000', 'consum', 0.0246, 'lps'),
	(660027, 135, '2015-01-15 00:27:19.000000', 'consum', 0.0282, 'lps'),
	(660028, 135, '2015-01-15 00:27:20.000000', 'consum', 0.0242, 'lps'),
	(660029, 135, '2015-01-15 00:27:21.000000', 'consum', 0.0228, 'lps'),
	(660030, 135, '2015-01-15 00:27:22.000000', 'consum', 0.0278, 'lps'),
	(660031, 135, '2015-01-15 00:27:23.000000', 'consum', 0.0274, 'lps'),
	(660032, 135, '2015-01-15 00:27:24.000000', 'consum', 0.0251, 'lps'),
	(660033, 135, '2015-01-15 00:27:25.000000', 'consum', 0.0226, 'lps'),
	(660034, 135, '2015-01-15 00:27:26.000000', 'consum', 0.0240, 'lps'),
	(660035, 135, '2015-01-15 00:27:27.000000', 'consum', 0.0237, 'lps'),
	(660036, 135, '2015-01-15 00:27:28.000000', 'consum', 0.0258, 'lps'),
	(660037, 135, '2015-01-15 00:27:29.000000', 'consum', 0.0221, 'lps'),
	(660038, 135, '2015-01-15 00:27:30.000000', 'consum', 0.0269, 'lps'),
	(660039, 135, '2015-01-15 00:27:31.000000', 'consum', 0.0251, 'lps'),
	(660040, 135, '2015-01-15 00:27:32.000000', 'consum', 0.0236, 'lps'),
	(660041, 135, '2015-01-15 00:27:33.000000', 'consum', 0.0220, 'lps'),
	(660042, 135, '2015-01-15 00:27:34.000000', 'consum', 0.0255, 'lps'),
	(660043, 135, '2015-01-15 00:27:35.000000', 'consum', 0.0260, 'lps'),
	(660044, 135, '2015-01-15 00:27:36.000000', 'consum', 0.0249, 'lps'),
	(660045, 135, '2015-01-15 00:27:37.000000', 'consum', 0.0257, 'lps'),
	(660046, 135, '2015-01-15 00:27:38.000000', 'consum', 0.0255, 'lps'),
	(660047, 135, '2015-01-15 00:27:39.000000', 'consum', 0.0218, 'lps'),
	(660048, 135, '2015-01-15 00:27:40.000000', 'consum', 0.0264, 'lps'),
	(660049, 135, '2015-01-15 00:27:41.000000', 'consum', 0.0235, 'lps'),
	(660050, 135, '2015-01-15 00:27:42.000000', 'consum', 0.0246, 'lps'),
	(660051, 135, '2015-01-15 00:27:43.000000', 'consum', 0.0245, 'lps'),
	(660052, 135, '2015-01-15 00:27:44.000000', 'consum', 0.0274, 'lps'),
	(660053, 135, '2015-01-15 00:27:45.000000', 'consum', 0.0277, 'lps'),
	(660054, 135, '2015-01-15 00:27:46.000000', 'consum', 0.0283, 'lps'),
	(660055, 135, '2015-01-15 00:27:47.000000', 'consum', 0.0224, 'lps'),
	(660056, 135, '2015-01-15 00:27:48.000000', 'consum', 0.0283, 'lps'),
	(660057, 135, '2015-01-15 00:27:49.000000', 'consum', 0.0240, 'lps'),
	(660058, 135, '2015-01-15 00:27:50.000000', 'consum', 0.0216, 'lps'),
	(660059, 135, '2015-01-15 00:27:51.000000', 'consum', 0.0224, 'lps'),
	(660060, 135, '2015-01-15 00:27:52.000000', 'consum', 0.0260, 'lps'),
	(660061, 135, '2015-01-15 00:27:53.000000', 'consum', 0.0273, 'lps'),
	(660062, 135, '2015-01-15 00:27:54.000000', 'consum', 0.0226, 'lps'),
	(660063, 135, '2015-01-15 00:27:55.000000', 'consum', 0.0248, 'lps'),
	(660064, 135, '2015-01-15 00:27:56.000000', 'consum', 0.0280, 'lps'),
	(660065, 135, '2015-01-15 00:27:57.000000', 'consum', 0.0225, 'lps'),
	(660066, 135, '2015-01-15 00:27:58.000000', 'consum', 0.0224, 'lps'),
	(660067, 135, '2015-01-15 00:27:59.000000', 'consum', 0.0234, 'lps'),
	(660068, 135, '2015-01-15 00:28:00.000000', 'consum', 0.0213, 'lps'),
	(660069, 135, '2015-01-15 00:28:01.000000', 'consum', 0.0229, 'lps'),
	(660070, 135, '2015-01-15 00:28:02.000000', 'consum', 0.0225, 'lps'),
	(660071, 135, '2015-01-15 00:28:03.000000', 'consum', 0.0225, 'lps'),
	(660072, 135, '2015-01-15 00:28:04.000000', 'consum', 0.0241, 'lps'),
	(660073, 135, '2015-01-15 00:28:05.000000', 'consum', 0.0249, 'lps'),
	(660074, 135, '2015-01-15 00:28:06.000000', 'consum', 0.0235, 'lps'),
	(660075, 135, '2015-01-15 00:28:07.000000', 'consum', 0.0221, 'lps'),
	(660076, 135, '2015-01-15 00:28:08.000000', 'consum', 0.0262, 'lps'),
	(660077, 135, '2015-01-15 00:28:09.000000', 'consum', 0.0218, 'lps'),
	(660078, 135, '2015-01-15 00:28:10.000000', 'consum', 0.0241, 'lps'),
	(660079, 135, '2015-01-15 00:28:11.000000', 'consum', 0.0270, 'lps'),
	(660080, 135, '2015-01-15 00:28:12.000000', 'consum', 0.0268, 'lps'),
	(660081, 135, '2015-01-15 00:28:13.000000', 'consum', 0.0246, 'lps'),
	(660082, 135, '2015-01-15 00:28:14.000000', 'consum', 0.0218, 'lps'),
	(660083, 135, '2015-01-15 00:28:15.000000', 'consum', 0.0214, 'lps'),
	(660084, 135, '2015-01-15 00:28:16.000000', 'consum', 0.0282, 'lps'),
	(660085, 135, '2015-01-15 00:28:17.000000', 'consum', 0.0262, 'lps'),
	(660086, 135, '2015-01-15 00:28:18.000000', 'consum', 0.0253, 'lps'),
	(660087, 135, '2015-01-15 00:28:19.000000', 'consum', 0.0271, 'lps'),
	(660088, 135, '2015-01-15 00:28:20.000000', 'consum', 0.0239, 'lps'),
	(660089, 135, '2015-01-15 00:28:21.000000', 'consum', 0.0244, 'lps'),
	(660090, 135, '2015-01-15 00:28:22.000000', 'consum', 0.0223, 'lps'),
	(660091, 135, '2015-01-15 00:28:23.000000', 'consum', 0.0245, 'lps'),
	(660092, 135, '2015-01-15 00:28:24.000000', 'consum', 0.0272, 'lps'),
	(660093, 135, '2015-01-15 00:28:25.000000', 'consum', 0.0268, 'lps'),
	(660094, 135, '2015-01-15 00:28:26.000000', 'consum', 0.0243, 'lps'),
	(660095, 135, '2015-01-15 00:28:27.000000', 'consum', 0.0273, 'lps'),
	(660096, 135, '2015-01-15 00:28:28.000000', 'consum', 0.0281, 'lps'),
	(660097, 135, '2015-01-15 00:28:29.000000', 'consum', 0.0226, 'lps'),
	(660098, 135, '2015-01-15 00:28:30.000000', 'consum', 0.0225, 'lps'),
	(660099, 135, '2015-01-15 00:28:31.000000', 'consum', 0.0239, 'lps'),
	(660100, 135, '2015-01-15 00:28:32.000000', 'consum', 0.0237, 'lps'),
	(660101, 135, '2015-01-15 00:28:33.000000', 'consum', 0.0256, 'lps'),
	(660102, 135, '2015-01-15 00:28:34.000000', 'consum', 0.0213, 'lps'),
	(660103, 135, '2015-01-15 00:28:35.000000', 'consum', 0.0234, 'lps'),
	(660104, 135, '2015-01-15 00:28:36.000000', 'consum', 0.0249, 'lps'),
	(660105, 135, '2015-01-15 00:28:37.000000', 'consum', 0.0261, 'lps'),
	(660106, 135, '2015-01-15 00:28:38.000000', 'consum', 0.0274, 'lps'),
	(660107, 135, '2015-01-15 00:28:39.000000', 'consum', 0.0230, 'lps'),
	(660108, 135, '2015-01-15 00:28:40.000000', 'consum', 0.0264, 'lps'),
	(660109, 135, '2015-01-15 00:28:41.000000', 'consum', 0.0272, 'lps'),
	(660110, 135, '2015-01-15 00:28:42.000000', 'consum', 0.0212, 'lps'),
	(660111, 135, '2015-01-15 00:28:43.000000', 'consum', 0.0257, 'lps'),
	(660112, 135, '2015-01-15 00:28:44.000000', 'consum', 0.0218, 'lps'),
	(660113, 135, '2015-01-15 00:28:45.000000', 'consum', 0.0257, 'lps'),
	(660114, 135, '2015-01-15 00:28:46.000000', 'consum', 0.0273, 'lps'),
	(660115, 135, '2015-01-15 00:28:47.000000', 'consum', 0.0236, 'lps'),
	(660116, 135, '2015-01-15 00:28:48.000000', 'consum', 0.0225, 'lps'),
	(660117, 135, '2015-01-15 00:28:49.000000', 'consum', 0.0281, 'lps'),
	(660118, 135, '2015-01-15 00:28:50.000000', 'consum', 0.0224, 'lps'),
	(660119, 135, '2015-01-15 00:28:51.000000', 'consum', 0.0218, 'lps'),
	(660120, 135, '2015-01-15 00:28:52.000000', 'consum', 0.0281, 'lps'),
	(660121, 135, '2015-01-15 00:28:53.000000', 'consum', 0.0244, 'lps'),
	(660122, 135, '2015-01-15 00:28:54.000000', 'consum', 0.0242, 'lps'),
	(660123, 135, '2015-01-15 00:28:55.000000', 'consum', 0.0268, 'lps'),
	(660124, 135, '2015-01-15 00:28:56.000000', 'consum', 0.0257, 'lps'),
	(660125, 135, '2015-01-15 00:28:57.000000', 'consum', 0.0270, 'lps'),
	(660126, 135, '2015-01-15 00:28:58.000000', 'consum', 0.0222, 'lps'),
	(660127, 135, '2015-01-15 00:28:59.000000', 'consum', 0.0241, 'lps'),
	(660128, 135, '2015-01-15 00:29:00.000000', 'consum', 0.0254, 'lps'),
	(660129, 135, '2015-01-15 00:29:01.000000', 'consum', 0.0264, 'lps'),
	(660130, 135, '2015-01-15 00:29:02.000000', 'consum', 0.0275, 'lps'),
	(660131, 135, '2015-01-15 00:29:03.000000', 'consum', 0.0223, 'lps'),
	(660132, 135, '2015-01-15 00:29:04.000000', 'consum', 0.0230, 'lps'),
	(660133, 135, '2015-01-15 00:29:05.000000', 'consum', 0.0270, 'lps'),
	(660134, 135, '2015-01-15 00:29:06.000000', 'consum', 0.0232, 'lps'),
	(660135, 135, '2015-01-15 00:29:07.000000', 'consum', 0.0211, 'lps'),
	(660136, 135, '2015-01-15 00:29:08.000000', 'consum', 0.0225, 'lps'),
	(660137, 135, '2015-01-15 00:29:09.000000', 'consum', 0.0282, 'lps'),
	(660138, 135, '2015-01-15 00:29:10.000000', 'consum', 0.0231, 'lps'),
	(660139, 135, '2015-01-15 00:29:11.000000', 'consum', 0.0247, 'lps'),
	(660140, 135, '2015-01-15 00:29:12.000000', 'consum', 0.0257, 'lps'),
	(660141, 135, '2015-01-15 00:29:13.000000', 'consum', 0.0261, 'lps'),
	(660142, 135, '2015-01-15 00:29:14.000000', 'consum', 0.0252, 'lps'),
	(660143, 135, '2015-01-15 00:29:15.000000', 'consum', 0.0266, 'lps'),
	(660144, 135, '2015-01-15 00:29:16.000000', 'consum', 0.0218, 'lps'),
	(660145, 135, '2015-01-15 00:29:17.000000', 'consum', 0.0228, 'lps'),
	(660146, 135, '2015-01-15 00:29:18.000000', 'consum', 0.0276, 'lps'),
	(660147, 135, '2015-01-15 00:29:19.000000', 'consum', 0.0266, 'lps'),
	(660148, 135, '2015-01-15 00:29:20.000000', 'consum', 0.0220, 'lps'),
	(660149, 135, '2015-01-15 00:29:21.000000', 'consum', 0.0238, 'lps'),
	(660150, 135, '2015-01-15 00:29:22.000000', 'consum', 0.0246, 'lps'),
	(660151, 135, '2015-01-15 00:29:23.000000', 'consum', 0.0235, 'lps'),
	(660152, 135, '2015-01-15 00:29:24.000000', 'consum', 0.0226, 'lps'),
	(660153, 135, '2015-01-15 00:29:25.000000', 'consum', 0.0215, 'lps'),
	(660154, 135, '2015-01-15 00:29:26.000000', 'consum', 0.0261, 'lps'),
	(660155, 135, '2015-01-15 00:29:27.000000', 'consum', 0.0228, 'lps'),
	(660156, 135, '2015-01-15 00:29:28.000000', 'consum', 0.0224, 'lps'),
	(660157, 135, '2015-01-15 00:29:29.000000', 'consum', 0.0226, 'lps'),
	(660158, 135, '2015-01-15 00:29:30.000000', 'consum', 0.0250, 'lps'),
	(660159, 135, '2015-01-15 00:29:31.000000', 'consum', 0.0212, 'lps'),
	(660160, 135, '2015-01-15 00:29:32.000000', 'consum', 0.0248, 'lps'),
	(660161, 135, '2015-01-15 00:29:33.000000', 'consum', 0.0248, 'lps'),
	(660162, 135, '2015-01-15 00:29:34.000000', 'consum', 0.0212, 'lps'),
	(660163, 135, '2015-01-15 00:29:35.000000', 'consum', 0.0254, 'lps'),
	(660164, 135, '2015-01-15 00:29:36.000000', 'consum', 0.0278, 'lps'),
	(660165, 135, '2015-01-15 00:29:37.000000', 'consum', 0.0272, 'lps'),
	(660166, 135, '2015-01-15 00:29:38.000000', 'consum', 0.0239, 'lps'),
	(660167, 135, '2015-01-15 00:29:39.000000', 'consum', 0.0244, 'lps'),
	(660168, 135, '2015-01-15 00:29:40.000000', 'consum', 0.0219, 'lps'),
	(660169, 135, '2015-01-15 00:29:41.000000', 'consum', 0.0230, 'lps'),
	(660170, 135, '2015-01-15 00:29:42.000000', 'consum', 0.0281, 'lps'),
	(660171, 135, '2015-01-15 00:29:43.000000', 'consum', 0.0210, 'lps'),
	(660172, 135, '2015-01-15 00:29:44.000000', 'consum', 0.0221, 'lps'),
	(660173, 135, '2015-01-15 00:29:45.000000', 'consum', 0.0264, 'lps'),
	(660174, 135, '2015-01-15 00:29:46.000000', 'consum', 0.0226, 'lps'),
	(660175, 135, '2015-01-15 00:29:47.000000', 'consum', 0.0278, 'lps'),
	(660176, 135, '2015-01-15 00:29:48.000000', 'consum', 0.0281, 'lps'),
	(660177, 135, '2015-01-15 00:29:49.000000', 'consum', 0.0211, 'lps'),
	(660178, 135, '2015-01-15 00:29:50.000000', 'consum', 0.0227, 'lps'),
	(660179, 135, '2015-01-15 00:29:51.000000', 'consum', 0.0216, 'lps'),
	(660180, 135, '2015-01-15 00:29:52.000000', 'consum', 0.0266, 'lps'),
	(660181, 135, '2015-01-15 00:29:53.000000', 'consum', 0.0250, 'lps'),
	(660182, 135, '2015-01-15 00:29:54.000000', 'consum', 0.0243, 'lps'),
	(660183, 135, '2015-01-15 00:29:55.000000', 'consum', 0.0256, 'lps'),
	(660184, 135, '2015-01-15 00:29:56.000000', 'consum', 0.0268, 'lps'),
	(660185, 135, '2015-01-15 00:29:57.000000', 'consum', 0.0212, 'lps'),
	(660186, 135, '2015-01-15 00:29:58.000000', 'consum', 0.0268, 'lps'),
	(660187, 135, '2015-01-15 00:29:59.000000', 'consum', 0.0272, 'lps'),
	(660188, 135, '2015-01-15 00:30:00.000000', 'consum', 0.0273, 'lps'),
	(660189, 135, '2015-01-15 00:30:01.000000', 'consum', 0.0266, 'lps'),
	(660190, 135, '2015-01-15 00:30:02.000000', 'consum', 0.0228, 'lps'),
	(660191, 135, '2015-01-15 00:30:03.000000', 'consum', 0.0280, 'lps'),
	(660192, 135, '2015-01-15 00:30:04.000000', 'consum', 0.0211, 'lps'),
	(660193, 135, '2015-01-15 00:30:05.000000', 'consum', 0.0226, 'lps'),
	(660194, 135, '2015-01-15 00:30:06.000000', 'consum', 0.0213, 'lps'),
	(660195, 135, '2015-01-15 00:30:07.000000', 'consum', 0.0252, 'lps'),
	(660196, 135, '2015-01-15 00:30:08.000000', 'consum', 0.0262, 'lps'),
	(660197, 135, '2015-01-15 00:30:09.000000', 'consum', 0.0271, 'lps'),
	(660198, 135, '2015-01-15 00:30:10.000000', 'consum', 0.0214, 'lps'),
	(660199, 135, '2015-01-15 00:30:11.000000', 'consum', 0.0266, 'lps'),
	(660200, 135, '2015-01-15 00:30:12.000000', 'consum', 0.0259, 'lps'),
	(660201, 135, '2015-01-15 00:30:13.000000', 'consum', 0.0214, 'lps'),
	(660202, 135, '2015-01-15 00:30:14.000000', 'consum', 0.0233, 'lps'),
	(660203, 135, '2015-01-15 00:30:15.000000', 'consum', 0.0237, 'lps'),
	(660204, 135, '2015-01-15 00:30:16.000000', 'consum', 0.0277, 'lps'),
	(660205, 135, '2015-01-15 00:30:17.000000', 'consum', 0.0242, 'lps'),
	(660206, 135, '2015-01-15 00:30:18.000000', 'consum', 0.0245, 'lps'),
	(660207, 135, '2015-01-15 00:30:19.000000', 'consum', 0.0215, 'lps'),
	(660208, 135, '2015-01-15 00:30:20.000000', 'consum', 0.0277, 'lps'),
	(660209, 135, '2015-01-15 00:30:21.000000', 'consum', 0.0236, 'lps'),
	(660210, 135, '2015-01-15 00:30:22.000000', 'consum', 0.0215, 'lps'),
	(660211, 135, '2015-01-15 00:30:23.000000', 'consum', 0.0230, 'lps'),
	(660212, 135, '2015-01-15 00:30:24.000000', 'consum', 0.0222, 'lps'),
	(660213, 135, '2015-01-15 00:30:25.000000', 'consum', 0.0210, 'lps'),
	(660214, 135, '2015-01-15 00:30:26.000000', 'consum', 0.0247, 'lps'),
	(660215, 135, '2015-01-15 00:30:27.000000', 'consum', 0.0248, 'lps'),
	(660216, 135, '2015-01-15 00:30:28.000000', 'consum', 0.0217, 'lps'),
	(660217, 135, '2015-01-15 00:30:29.000000', 'consum', 0.0279, 'lps'),
	(660218, 135, '2015-01-15 00:30:30.000000', 'consum', 0.0237, 'lps'),
	(660219, 135, '2015-01-15 00:30:31.000000', 'consum', 0.0215, 'lps'),
	(660220, 135, '2015-01-15 00:30:32.000000', 'consum', 0.0227, 'lps'),
	(660221, 135, '2015-01-15 00:30:33.000000', 'consum', 0.0283, 'lps'),
	(660222, 135, '2015-01-15 00:30:34.000000', 'consum', 0.0227, 'lps'),
	(660223, 135, '2015-01-15 00:30:35.000000', 'consum', 0.0223, 'lps'),
	(660224, 135, '2015-01-15 00:30:36.000000', 'consum', 0.0226, 'lps'),
	(660225, 135, '2015-01-15 00:30:37.000000', 'consum', 0.0250, 'lps'),
	(660226, 135, '2015-01-15 00:30:38.000000', 'consum', 0.0215, 'lps'),
	(660227, 135, '2015-01-15 00:30:39.000000', 'consum', 0.0264, 'lps'),
	(660228, 135, '2015-01-15 00:30:40.000000', 'consum', 0.0244, 'lps'),
	(660229, 135, '2015-01-15 00:30:41.000000', 'consum', 0.0220, 'lps'),
	(660230, 135, '2015-01-15 00:30:42.000000', 'consum', 0.0230, 'lps'),
	(660231, 135, '2015-01-15 00:30:43.000000', 'consum', 0.0281, 'lps'),
	(660232, 135, '2015-01-15 00:30:44.000000', 'consum', 0.0282, 'lps'),
	(660233, 135, '2015-01-15 00:30:45.000000', 'consum', 0.0212, 'lps'),
	(660234, 135, '2015-01-15 00:30:46.000000', 'consum', 0.0226, 'lps'),
	(660235, 135, '2015-01-15 00:30:47.000000', 'consum', 0.0283, 'lps'),
	(660236, 135, '2015-01-15 00:30:48.000000', 'consum', 0.0233, 'lps'),
	(660237, 135, '2015-01-15 00:30:49.000000', 'consum', 0.0254, 'lps'),
	(660238, 135, '2015-01-15 00:30:50.000000', 'consum', 0.0213, 'lps'),
	(660239, 135, '2015-01-15 00:30:51.000000', 'consum', 0.0243, 'lps'),
	(660240, 135, '2015-01-15 00:30:52.000000', 'consum', 0.0219, 'lps'),
	(660241, 135, '2015-01-15 00:30:53.000000', 'consum', 0.0230, 'lps'),
	(660242, 135, '2015-01-15 00:30:54.000000', 'consum', 0.0283, 'lps'),
	(660243, 135, '2015-01-15 00:30:55.000000', 'consum', 0.0218, 'lps'),
	(660244, 135, '2015-01-15 00:30:56.000000', 'consum', 0.0255, 'lps'),
	(660245, 135, '2015-01-15 00:30:57.000000', 'consum', 0.0261, 'lps'),
	(660246, 135, '2015-01-15 00:30:58.000000', 'consum', 0.0259, 'lps'),
	(660247, 135, '2015-01-15 00:30:59.000000', 'consum', 0.0229, 'lps'),
	(660248, 135, '2015-01-15 00:31:00.000000', 'consum', 0.0233, 'lps'),
	(660249, 135, '2015-01-15 00:31:01.000000', 'consum', 0.0268, 'lps'),
	(660250, 135, '2015-01-15 00:31:02.000000', 'consum', 0.0211, 'lps'),
	(660251, 135, '2015-01-15 00:31:03.000000', 'consum', 0.0264, 'lps'),
	(660252, 135, '2015-01-15 00:31:04.000000', 'consum', 0.0253, 'lps'),
	(660253, 135, '2015-01-15 00:31:05.000000', 'consum', 0.0266, 'lps'),
	(660254, 135, '2015-01-15 00:31:06.000000', 'consum', 0.0211, 'lps'),
	(660255, 135, '2015-01-15 00:31:07.000000', 'consum', 0.0269, 'lps'),
	(660256, 135, '2015-01-15 00:31:08.000000', 'consum', 0.0280, 'lps'),
	(660257, 135, '2015-01-15 00:31:09.000000', 'consum', 0.0237, 'lps'),
	(660258, 135, '2015-01-15 00:31:10.000000', 'consum', 0.0282, 'lps'),
	(660259, 135, '2015-01-15 00:31:11.000000', 'consum', 0.0267, 'lps'),
	(660260, 135, '2015-01-15 00:31:12.000000', 'consum', 0.0280, 'lps'),
	(660261, 135, '2015-01-15 00:31:13.000000', 'consum', 0.0243, 'lps'),
	(660262, 135, '2015-01-15 00:31:14.000000', 'consum', 0.0239, 'lps'),
	(660263, 135, '2015-01-15 00:31:15.000000', 'consum', 0.0257, 'lps'),
	(660264, 135, '2015-01-15 00:31:16.000000', 'consum', 0.0282, 'lps'),
	(660265, 135, '2015-01-15 00:31:17.000000', 'consum', 0.0282, 'lps'),
	(660266, 135, '2015-01-15 00:31:18.000000', 'consum', 0.0283, 'lps'),
	(660267, 135, '2015-01-15 00:31:19.000000', 'consum', 0.0283, 'lps'),
	(660268, 135, '2015-01-15 00:31:20.000000', 'consum', 0.0283, 'lps'),
	(660269, 135, '2015-01-15 00:31:21.000000', 'consum', 0.0282, 'lps'),
	(660270, 135, '2015-01-15 00:31:22.000000', 'consum', 0.0277, 'lps'),
	(660271, 135, '2015-01-15 00:31:23.000000', 'consum', 0.0257, 'lps'),
	(660272, 135, '2015-01-15 00:31:24.000000', 'consum', 0.0245, 'lps'),
	(660273, 135, '2015-01-15 00:31:25.000000', 'consum', 0.0242, 'lps'),
	(660274, 135, '2015-01-15 00:31:26.000000', 'consum', 0.0268, 'lps'),
	(660275, 135, '2015-01-15 00:31:27.000000', 'consum', 0.0253, 'lps'),
	(660276, 135, '2015-01-15 00:31:28.000000', 'consum', 0.0255, 'lps'),
	(660277, 135, '2015-01-15 00:31:29.000000', 'consum', 0.0233, 'lps'),
	(660278, 135, '2015-01-15 00:31:30.000000', 'consum', 0.0264, 'lps'),
	(660279, 135, '2015-01-15 00:31:31.000000', 'consum', 0.0263, 'lps'),
	(660280, 135, '2015-01-15 00:31:32.000000', 'consum', 0.0241, 'lps'),
	(660281, 135, '2015-01-15 00:31:33.000000', 'consum', 0.0279, 'lps'),
	(660282, 135, '2015-01-15 00:31:34.000000', 'consum', 0.0243, 'lps'),
	(660283, 135, '2015-01-15 00:31:35.000000', 'consum', 0.0240, 'lps'),
	(660284, 135, '2015-01-15 00:31:36.000000', 'consum', 0.0264, 'lps'),
	(660285, 135, '2015-01-15 00:31:37.000000', 'consum', 0.0243, 'lps'),
	(660286, 135, '2015-01-15 00:31:38.000000', 'consum', 0.0211, 'lps'),
	(660287, 135, '2015-01-15 00:31:39.000000', 'consum', 0.0264, 'lps'),
	(660288, 135, '2015-01-15 00:31:40.000000', 'consum', 0.0258, 'lps'),
	(660289, 135, '2015-01-15 00:31:41.000000', 'consum', 0.0213, 'lps'),
	(660290, 135, '2015-01-15 00:31:42.000000', 'consum', 0.0230, 'lps'),
	(660291, 135, '2015-01-15 00:31:43.000000', 'consum', 0.0228, 'lps'),
	(660292, 135, '2015-01-15 00:31:44.000000', 'consum', 0.0241, 'lps'),
	(660293, 135, '2015-01-15 00:31:45.000000', 'consum', 0.0238, 'lps'),
	(660294, 135, '2015-01-15 00:31:46.000000', 'consum', 0.0256, 'lps'),
	(660295, 135, '2015-01-15 00:31:47.000000', 'consum', 0.0281, 'lps'),
	(660296, 135, '2015-01-15 00:31:48.000000', 'consum', 0.0281, 'lps'),
	(660297, 135, '2015-01-15 00:31:49.000000', 'consum', 0.0278, 'lps'),
	(660298, 135, '2015-01-15 00:31:50.000000', 'consum', 0.0262, 'lps'),
	(660299, 135, '2015-01-15 00:31:51.000000', 'consum', 0.0269, 'lps'),
	(660300, 135, '2015-01-15 00:31:52.000000', 'consum', 0.0274, 'lps'),
	(660301, 135, '2015-01-15 00:31:53.000000', 'consum', 0.0278, 'lps'),
	(660302, 135, '2015-01-15 00:31:54.000000', 'consum', 0.0212, 'lps'),
	(660303, 135, '2015-01-15 00:31:55.000000', 'consum', 0.0240, 'lps'),
	(660304, 135, '2015-01-15 00:31:56.000000', 'consum', 0.0280, 'lps'),
	(660305, 135, '2015-01-15 00:31:57.000000', 'consum', 0.0246, 'lps'),
	(660306, 135, '2015-01-15 00:31:58.000000', 'consum', 0.0256, 'lps'),
	(660307, 135, '2015-01-15 00:31:59.000000', 'consum', 0.0257, 'lps'),
	(660308, 135, '2015-01-15 00:32:00.000000', 'consum', 0.0235, 'lps'),
	(660309, 135, '2015-01-15 00:32:01.000000', 'consum', 0.0270, 'lps'),
	(660310, 135, '2015-01-15 00:32:02.000000', 'consum', 0.0212, 'lps'),
	(660311, 135, '2015-01-15 00:32:03.000000', 'consum', 0.0262, 'lps'),
	(660312, 135, '2015-01-15 00:32:04.000000', 'consum', 0.0242, 'lps'),
	(660313, 135, '2015-01-15 00:32:05.000000', 'consum', 0.0215, 'lps'),
	(660314, 135, '2015-01-15 00:32:06.000000', 'consum', 0.0215, 'lps'),
	(660315, 135, '2015-01-15 00:32:07.000000', 'consum', 0.0220, 'lps'),
	(660316, 135, '2015-01-15 00:32:08.000000', 'consum', 0.0246, 'lps'),
	(660317, 135, '2015-01-15 00:32:09.000000', 'consum', 0.0210, 'lps'),
	(660318, 135, '2015-01-15 00:32:10.000000', 'consum', 0.0252, 'lps'),
	(660319, 135, '2015-01-15 00:32:11.000000', 'consum', 0.0274, 'lps'),
	(660320, 135, '2015-01-15 00:32:12.000000', 'consum', 0.0254, 'lps'),
	(660321, 135, '2015-01-15 00:32:13.000000', 'consum', 0.0240, 'lps'),
	(660322, 135, '2015-01-15 00:32:14.000000', 'consum', 0.0229, 'lps'),
	(660323, 135, '2015-01-15 00:32:15.000000', 'consum', 0.0214, 'lps'),
	(660324, 135, '2015-01-15 00:32:16.000000', 'consum', 0.0247, 'lps'),
	(660325, 135, '2015-01-15 00:32:17.000000', 'consum', 0.0235, 'lps'),
	(660326, 135, '2015-01-15 00:32:18.000000', 'consum', 0.0227, 'lps'),
	(660327, 135, '2015-01-15 00:32:19.000000', 'consum', 0.0218, 'lps'),
	(660328, 135, '2015-01-15 00:32:20.000000', 'consum', 0.0273, 'lps'),
	(660329, 135, '2015-01-15 00:32:21.000000', 'consum', 0.0282, 'lps'),
	(660330, 135, '2015-01-15 00:32:22.000000', 'consum', 0.0232, 'lps'),
	(660331, 135, '2015-01-15 00:32:23.000000', 'consum', 0.0252, 'lps'),
	(660332, 135, '2015-01-15 00:32:24.000000', 'consum', 0.0282, 'lps'),
	(660333, 135, '2015-01-15 00:32:25.000000', 'consum', 0.0221, 'lps'),
	(660334, 135, '2015-01-15 00:32:26.000000', 'consum', 0.0271, 'lps'),
	(660335, 135, '2015-01-15 00:32:27.000000', 'consum', 0.0260, 'lps'),
	(660336, 135, '2015-01-15 00:32:28.000000', 'consum', 0.0277, 'lps'),
	(660337, 135, '2015-01-15 00:32:29.000000', 'consum', 0.0247, 'lps'),
	(660338, 135, '2015-01-15 00:32:30.000000', 'consum', 0.0269, 'lps'),
	(660339, 135, '2015-01-15 00:32:31.000000', 'consum', 0.0246, 'lps'),
	(660340, 135, '2015-01-15 00:32:32.000000', 'consum', 0.0214, 'lps'),
	(660341, 135, '2015-01-15 00:32:33.000000', 'consum', 0.0269, 'lps'),
	(660342, 135, '2015-01-15 00:32:34.000000', 'consum', 0.0272, 'lps'),
	(660343, 135, '2015-01-15 00:32:35.000000', 'consum', 0.0272, 'lps'),
	(660344, 135, '2015-01-15 00:32:36.000000', 'consum', 0.0258, 'lps'),
	(660345, 135, '2015-01-15 00:32:37.000000', 'consum', 0.0265, 'lps'),
	(660346, 135, '2015-01-15 00:32:38.000000', 'consum', 0.0267, 'lps'),
	(660347, 135, '2015-01-15 00:32:39.000000', 'consum', 0.0259, 'lps'),
	(660348, 135, '2015-01-15 00:32:40.000000', 'consum', 0.0281, 'lps'),
	(660349, 135, '2015-01-15 00:32:41.000000', 'consum', 0.0272, 'lps'),
	(660350, 135, '2015-01-15 00:32:42.000000', 'consum', 0.0235, 'lps'),
	(660351, 135, '2015-01-15 00:32:43.000000', 'consum', 0.0223, 'lps'),
	(660352, 135, '2015-01-15 00:32:44.000000', 'consum', 0.0272, 'lps'),
	(660353, 135, '2015-01-15 00:32:45.000000', 'consum', 0.0261, 'lps'),
	(660354, 135, '2015-01-15 00:32:46.000000', 'consum', 0.0279, 'lps'),
	(660355, 135, '2015-01-15 00:32:47.000000', 'consum', 0.0255, 'lps'),
	(660356, 135, '2015-01-15 00:32:48.000000', 'consum', 0.0230, 'lps'),
	(660357, 135, '2015-01-15 00:32:49.000000', 'consum', 0.0247, 'lps'),
	(660358, 135, '2015-01-15 00:32:50.000000', 'consum', 0.0261, 'lps'),
	(660359, 135, '2015-01-15 00:32:51.000000', 'consum', 0.0282, 'lps'),
	(660360, 135, '2015-01-15 00:32:52.000000', 'consum', 0.0267, 'lps'),
	(660361, 135, '2015-01-15 00:32:53.000000', 'consum', 0.0282, 'lps'),
	(660362, 135, '2015-01-15 00:32:54.000000', 'consum', 0.0249, 'lps'),
	(660363, 135, '2015-01-15 00:32:55.000000', 'consum', 0.0264, 'lps'),
	(660364, 135, '2015-01-15 00:32:56.000000', 'consum', 0.0217, 'lps'),
	(660365, 135, '2015-01-15 00:32:57.000000', 'consum', 0.0230, 'lps'),
	(660366, 135, '2015-01-15 00:32:58.000000', 'consum', 0.0217, 'lps'),
	(660367, 135, '2015-01-15 00:32:59.000000', 'consum', 0.0258, 'lps'),
	(660368, 135, '2015-01-15 00:33:00.000000', 'consum', 0.0281, 'lps'),
	(660369, 135, '2015-01-15 00:33:01.000000', 'consum', 0.0275, 'lps'),
	(660370, 135, '2015-01-15 00:33:02.000000', 'consum', 0.0250, 'lps'),
	(660371, 135, '2015-01-15 00:33:03.000000', 'consum', 0.0213, 'lps'),
	(660372, 135, '2015-01-15 00:33:04.000000', 'consum', 0.0256, 'lps'),
	(660373, 135, '2015-01-15 00:33:05.000000', 'consum', 0.0280, 'lps'),
	(660374, 135, '2015-01-15 00:33:06.000000', 'consum', 0.0277, 'lps'),
	(660375, 135, '2015-01-15 00:33:07.000000', 'consum', 0.0261, 'lps'),
	(660376, 135, '2015-01-15 00:33:08.000000', 'consum', 0.0264, 'lps'),
	(660377, 135, '2015-01-15 00:33:09.000000', 'consum', 0.0254, 'lps'),
	(660378, 135, '2015-01-15 00:33:10.000000', 'consum', 0.0267, 'lps'),
	(660379, 135, '2015-01-15 00:33:11.000000', 'consum', 0.0216, 'lps'),
	(660380, 135, '2015-01-15 00:33:12.000000', 'consum', 0.0216, 'lps'),
	(660381, 135, '2015-01-15 00:33:13.000000', 'consum', 0.0225, 'lps'),
	(660382, 135, '2015-01-15 00:33:14.000000', 'consum', 0.0266, 'lps'),
	(660383, 135, '2015-01-15 00:33:15.000000', 'consum', 0.0225, 'lps'),
	(660384, 135, '2015-01-15 00:33:16.000000', 'consum', 0.0265, 'lps'),
	(660385, 135, '2015-01-15 00:33:17.000000', 'consum', 0.0219, 'lps'),
	(660386, 135, '2015-01-15 00:33:18.000000', 'consum', 0.0238, 'lps'),
	(660387, 135, '2015-01-15 00:33:19.000000', 'consum', 0.0250, 'lps'),
	(660388, 135, '2015-01-15 00:33:20.000000', 'consum', 0.0250, 'lps'),
	(660389, 135, '2015-01-15 00:33:21.000000', 'consum', 0.0220, 'lps'),
	(660390, 135, '2015-01-15 00:33:22.000000', 'consum', 0.0213, 'lps'),
	(660391, 135, '2015-01-15 00:33:23.000000', 'consum', 0.0269, 'lps'),
	(660392, 135, '2015-01-15 00:33:24.000000', 'consum', 0.0274, 'lps'),
	(660393, 135, '2015-01-15 00:33:25.000000', 'consum', 0.0280, 'lps'),
	(660394, 135, '2015-01-15 00:33:26.000000', 'consum', 0.0220, 'lps'),
	(660395, 135, '2015-01-15 00:33:27.000000', 'consum', 0.0272, 'lps'),
	(660396, 135, '2015-01-15 00:33:28.000000', 'consum', 0.0270, 'lps'),
	(660397, 135, '2015-01-15 00:33:29.000000', 'consum', 0.0248, 'lps'),
	(660398, 135, '2015-01-15 00:33:30.000000', 'consum', 0.0224, 'lps'),
	(660399, 135, '2015-01-15 00:33:31.000000', 'consum', 0.0237, 'lps'),
	(660400, 135, '2015-01-15 00:33:32.000000', 'consum', 0.0231, 'lps'),
	(660401, 135, '2015-01-15 00:33:33.000000', 'consum', 0.0234, 'lps'),
	(660402, 135, '2015-01-15 00:33:34.000000', 'consum', 0.0268, 'lps'),
	(660403, 135, '2015-01-15 00:33:35.000000', 'consum', 0.0280, 'lps'),
	(660404, 135, '2015-01-15 00:33:36.000000', 'consum', 0.0237, 'lps'),
	(660405, 135, '2015-01-15 00:33:37.000000', 'consum', 0.0283, 'lps'),
	(660406, 135, '2015-01-15 00:33:38.000000', 'consum', 0.0274, 'lps'),
	(660407, 135, '2015-01-15 00:33:39.000000', 'consum', 0.0236, 'lps'),
	(660408, 135, '2015-01-15 00:33:40.000000', 'consum', 0.0223, 'lps'),
	(660409, 135, '2015-01-15 00:33:41.000000', 'consum', 0.0270, 'lps'),
	(660410, 135, '2015-01-15 00:33:42.000000', 'consum', 0.0250, 'lps'),
	(660411, 135, '2015-01-15 00:33:43.000000', 'consum', 0.0231, 'lps'),
	(660412, 135, '2015-01-15 00:33:44.000000', 'consum', 0.0270, 'lps'),
	(660413, 135, '2015-01-15 00:33:45.000000', 'consum', 0.0227, 'lps'),
	(660414, 135, '2015-01-15 00:33:46.000000', 'consum', 0.0263, 'lps'),
	(660415, 135, '2015-01-15 00:33:47.000000', 'consum', 0.0277, 'lps'),
	(660416, 135, '2015-01-15 00:33:48.000000', 'consum', 0.0239, 'lps'),
	(660417, 135, '2015-01-15 00:33:49.000000', 'consum', 0.0227, 'lps'),
	(660418, 135, '2015-01-15 00:33:50.000000', 'consum', 0.0211, 'lps'),
	(660419, 135, '2015-01-15 00:33:51.000000', 'consum', 0.0236, 'lps'),
	(660420, 135, '2015-01-15 00:33:52.000000', 'consum', 0.0263, 'lps'),
	(660421, 135, '2015-01-15 00:33:53.000000', 'consum', 0.0249, 'lps'),
	(660422, 135, '2015-01-15 00:33:54.000000', 'consum', 0.0249, 'lps'),
	(660423, 135, '2015-01-15 00:33:55.000000', 'consum', 0.0212, 'lps'),
	(660424, 135, '2015-01-15 00:33:56.000000', 'consum', 0.0253, 'lps'),
	(660425, 135, '2015-01-15 00:33:57.000000', 'consum', 0.0271, 'lps'),
	(660426, 135, '2015-01-15 00:33:58.000000', 'consum', 0.0238, 'lps'),
	(660427, 135, '2015-01-15 00:33:59.000000', 'consum', 0.0242, 'lps'),
	(660428, 135, '2015-01-15 00:34:00.000000', 'consum', 0.0214, 'lps'),
	(660429, 135, '2015-01-15 00:34:01.000000', 'consum', 0.0281, 'lps'),
	(660430, 135, '2015-01-15 00:34:02.000000', 'consum', 0.0257, 'lps'),
	(660431, 135, '2015-01-15 00:34:03.000000', 'consum', 0.0231, 'lps'),
	(660432, 135, '2015-01-15 00:34:04.000000', 'consum', 0.0250, 'lps'),
	(660433, 135, '2015-01-15 00:34:05.000000', 'consum', 0.0275, 'lps'),
	(660434, 135, '2015-01-15 00:34:06.000000', 'consum', 0.0265, 'lps'),
	(660435, 135, '2015-01-15 00:34:07.000000', 'consum', 0.0216, 'lps'),
	(660436, 135, '2015-01-15 00:34:08.000000', 'consum', 0.0225, 'lps'),
	(660437, 135, '2015-01-15 00:34:09.000000', 'consum', 0.0266, 'lps'),
	(660438, 135, '2015-01-15 00:34:10.000000', 'consum', 0.0223, 'lps'),
	(660439, 135, '2015-01-15 00:34:11.000000', 'consum', 0.0258, 'lps'),
	(660440, 135, '2015-01-15 00:34:12.000000', 'consum', 0.0264, 'lps'),
	(660441, 135, '2015-01-15 00:34:13.000000', 'consum', 0.0261, 'lps'),
	(660442, 135, '2015-01-15 00:34:14.000000', 'consum', 0.0228, 'lps'),
	(660443, 135, '2015-01-15 00:34:15.000000', 'consum', 0.0224, 'lps'),
	(660444, 135, '2015-01-15 00:34:16.000000', 'consum', 0.0224, 'lps'),
	(660445, 135, '2015-01-15 00:34:17.000000', 'consum', 0.0241, 'lps'),
	(660446, 135, '2015-01-15 00:34:18.000000', 'consum', 0.0250, 'lps'),
	(660447, 135, '2015-01-15 00:34:19.000000', 'consum', 0.0242, 'lps'),
	(660448, 135, '2015-01-15 00:34:20.000000', 'consum', 0.0252, 'lps'),
	(660449, 135, '2015-01-15 00:34:21.000000', 'consum', 0.0249, 'lps'),
	(660450, 135, '2015-01-15 00:34:22.000000', 'consum', 0.0279, 'lps'),
	(660451, 135, '2015-01-15 00:34:23.000000', 'consum', 0.0216, 'lps'),
	(660452, 135, '2015-01-15 00:34:24.000000', 'consum', 0.0255, 'lps'),
	(660453, 135, '2015-01-15 00:34:25.000000', 'consum', 0.0270, 'lps'),
	(660454, 135, '2015-01-15 00:34:26.000000', 'consum', 0.0226, 'lps'),
	(660455, 135, '2015-01-15 00:34:27.000000', 'consum', 0.0258, 'lps'),
	(660456, 135, '2015-01-15 00:34:28.000000', 'consum', 0.0258, 'lps'),
	(660457, 135, '2015-01-15 00:34:29.000000', 'consum', 0.0229, 'lps'),
	(660458, 135, '2015-01-15 00:34:30.000000', 'consum', 0.0238, 'lps'),
	(660459, 135, '2015-01-15 00:34:31.000000', 'consum', 0.0219, 'lps'),
	(660460, 135, '2015-01-15 00:34:32.000000', 'consum', 0.0246, 'lps'),
	(660461, 135, '2015-01-15 00:34:33.000000', 'consum', 0.0213, 'lps'),
	(660462, 135, '2015-01-15 00:34:34.000000', 'consum', 0.0267, 'lps'),
	(660463, 135, '2015-01-15 00:34:35.000000', 'consum', 0.0266, 'lps'),
	(660464, 135, '2015-01-15 00:34:36.000000', 'consum', 0.0246, 'lps'),
	(660465, 135, '2015-01-15 00:34:37.000000', 'consum', 0.0220, 'lps'),
	(660466, 135, '2015-01-15 00:34:38.000000', 'consum', 0.0226, 'lps'),
	(660467, 135, '2015-01-15 00:34:39.000000', 'consum', 0.0261, 'lps'),
	(660468, 135, '2015-01-15 00:34:40.000000', 'consum', 0.0271, 'lps'),
	(660469, 135, '2015-01-15 00:34:41.000000', 'consum', 0.0213, 'lps'),
	(660470, 135, '2015-01-15 00:34:42.000000', 'consum', 0.0266, 'lps'),
	(660471, 135, '2015-01-15 00:34:43.000000', 'consum', 0.0260, 'lps'),
	(660472, 135, '2015-01-15 00:34:44.000000', 'consum', 0.0218, 'lps'),
	(660473, 135, '2015-01-15 00:34:45.000000', 'consum', 0.0248, 'lps'),
	(660474, 135, '2015-01-15 00:34:46.000000', 'consum', 0.0228, 'lps'),
	(660475, 135, '2015-01-15 00:34:47.000000', 'consum', 0.0261, 'lps'),
	(660476, 135, '2015-01-15 00:34:48.000000', 'consum', 0.0262, 'lps'),
	(660477, 135, '2015-01-15 00:34:49.000000', 'consum', 0.0245, 'lps'),
	(660478, 135, '2015-01-15 00:34:50.000000', 'consum', 0.0230, 'lps'),
	(660479, 135, '2015-01-15 00:34:51.000000', 'consum', 0.0279, 'lps'),
	(660480, 135, '2015-01-15 00:34:52.000000', 'consum', 0.0273, 'lps'),
	(660481, 135, '2015-01-15 00:34:53.000000', 'consum', 0.0247, 'lps'),
	(660482, 135, '2015-01-15 00:34:54.000000', 'consum', 0.0277, 'lps'),
	(660483, 135, '2015-01-15 00:34:55.000000', 'consum', 0.0215, 'lps'),
	(660484, 135, '2015-01-15 00:34:56.000000', 'consum', 0.0256, 'lps'),
	(660485, 135, '2015-01-15 00:34:57.000000', 'consum', 0.0279, 'lps'),
	(660486, 135, '2015-01-15 00:34:58.000000', 'consum', 0.0267, 'lps'),
	(660487, 135, '2015-01-15 00:34:59.000000', 'consum', 0.0215, 'lps'),
	(660488, 135, '2015-01-15 00:35:00.000000', 'consum', 0.0213, 'lps'),
	(660489, 135, '2015-01-15 00:35:01.000000', 'consum', 0.0282, 'lps'),
	(660490, 135, '2015-01-15 00:35:02.000000', 'consum', 0.0268, 'lps'),
	(660491, 135, '2015-01-15 00:35:03.000000', 'consum', 0.0210, 'lps'),
	(660492, 135, '2015-01-15 00:35:04.000000', 'consum', 0.0260, 'lps'),
	(660493, 135, '2015-01-15 00:35:05.000000', 'consum', 0.0239, 'lps'),
	(660494, 135, '2015-01-15 00:35:06.000000', 'consum', 0.0278, 'lps'),
	(660495, 135, '2015-01-15 00:35:07.000000', 'consum', 0.0240, 'lps'),
	(660496, 135, '2015-01-15 00:35:08.000000', 'consum', 0.0234, 'lps'),
	(660497, 135, '2015-01-15 00:35:09.000000', 'consum', 0.0238, 'lps'),
	(660498, 135, '2015-01-15 00:35:10.000000', 'consum', 0.0280, 'lps'),
	(660499, 135, '2015-01-15 00:35:11.000000', 'consum', 0.0256, 'lps'),
	(660500, 135, '2015-01-15 00:35:12.000000', 'consum', 0.0229, 'lps'),
	(660501, 135, '2015-01-15 00:35:13.000000', 'consum', 0.0241, 'lps'),
	(660502, 135, '2015-01-15 00:35:14.000000', 'consum', 0.0234, 'lps'),
	(660503, 135, '2015-01-15 00:35:15.000000', 'consum', 0.0237, 'lps'),
	(660504, 135, '2015-01-15 00:35:16.000000', 'consum', 0.0276, 'lps'),
	(660505, 135, '2015-01-15 00:35:17.000000', 'consum', 0.0235, 'lps'),
	(660506, 135, '2015-01-15 00:35:18.000000', 'consum', 0.0214, 'lps'),
	(660507, 135, '2015-01-15 00:35:19.000000', 'consum', 0.0227, 'lps'),
	(660508, 135, '2015-01-15 00:35:20.000000', 'consum', 0.0210, 'lps'),
	(660509, 135, '2015-01-15 00:35:21.000000', 'consum', 0.0234, 'lps'),
	(660510, 135, '2015-01-15 00:35:22.000000', 'consum', 0.0258, 'lps'),
	(660511, 135, '2015-01-15 00:35:23.000000', 'consum', 0.0227, 'lps'),
	(660512, 135, '2015-01-15 00:35:24.000000', 'consum', 0.0229, 'lps'),
	(660513, 135, '2015-01-15 00:35:25.000000', 'consum', 0.0252, 'lps'),
	(660514, 135, '2015-01-15 00:35:26.000000', 'consum', 0.0215, 'lps'),
	(660515, 135, '2015-01-15 00:35:27.000000', 'consum', 0.0259, 'lps'),
	(660516, 135, '2015-01-15 00:35:28.000000', 'consum', 0.0220, 'lps'),
	(660517, 135, '2015-01-15 00:35:29.000000', 'consum', 0.0261, 'lps'),
	(660518, 135, '2015-01-15 00:35:30.000000', 'consum', 0.0212, 'lps'),
	(660519, 135, '2015-01-15 00:35:31.000000', 'consum', 0.0217, 'lps'),
	(660520, 135, '2015-01-15 00:35:32.000000', 'consum', 0.0241, 'lps'),
	(660521, 135, '2015-01-15 00:35:33.000000', 'consum', 0.0269, 'lps'),
	(660522, 135, '2015-01-15 00:35:34.000000', 'consum', 0.0264, 'lps'),
	(660523, 135, '2015-01-15 00:35:35.000000', 'consum', 0.0231, 'lps'),
	(660524, 135, '2015-01-15 00:35:36.000000', 'consum', 0.0228, 'lps'),
	(660525, 135, '2015-01-15 00:35:37.000000', 'consum', 0.0238, 'lps'),
	(660526, 135, '2015-01-15 00:35:38.000000', 'consum', 0.0222, 'lps'),
	(660527, 135, '2015-01-15 00:35:39.000000', 'consum', 0.0262, 'lps'),
	(660528, 135, '2015-01-15 00:35:40.000000', 'consum', 0.0211, 'lps'),
	(660529, 135, '2015-01-15 00:35:41.000000', 'consum', 0.0281, 'lps'),
	(660530, 135, '2015-01-15 00:35:42.000000', 'consum', 0.0267, 'lps'),
	(660531, 135, '2015-01-15 00:35:43.000000', 'consum', 0.0210, 'lps'),
	(660532, 135, '2015-01-15 00:35:44.000000', 'consum', 0.0261, 'lps'),
	(660533, 135, '2015-01-15 00:35:45.000000', 'consum', 0.0245, 'lps'),
	(660534, 135, '2015-01-15 00:35:46.000000', 'consum', 0.0232, 'lps'),
	(660535, 135, '2015-01-15 00:35:47.000000', 'consum', 0.0214, 'lps'),
	(660536, 135, '2015-01-15 00:35:48.000000', 'consum', 0.0240, 'lps'),
	(660537, 135, '2015-01-15 00:35:49.000000', 'consum', 0.0273, 'lps'),
	(660538, 135, '2015-01-15 00:35:50.000000', 'consum', 0.0214, 'lps'),
	(660539, 135, '2015-01-15 00:35:51.000000', 'consum', 0.0264, 'lps'),
	(660540, 135, '2015-01-15 00:35:52.000000', 'consum', 0.0244, 'lps'),
	(660541, 135, '2015-01-15 00:35:53.000000', 'consum', 0.0221, 'lps'),
	(660542, 135, '2015-01-15 00:35:54.000000', 'consum', 0.0239, 'lps'),
	(660543, 135, '2015-01-15 00:35:55.000000', 'consum', 0.0246, 'lps'),
	(660544, 135, '2015-01-15 00:35:56.000000', 'consum', 0.0231, 'lps'),
	(660545, 135, '2015-01-15 00:35:57.000000', 'consum', 0.0282, 'lps'),
	(660546, 135, '2015-01-15 00:35:58.000000', 'consum', 0.0283, 'lps'),
	(660547, 135, '2015-01-15 00:35:59.000000', 'consum', 0.0215, 'lps'),
	(660548, 135, '2015-01-15 00:36:00.000000', 'consum', 0.0236, 'lps'),
	(660549, 135, '2015-01-15 00:36:01.000000', 'consum', 0.0252, 'lps'),
	(660550, 135, '2015-01-15 00:36:02.000000', 'consum', 0.0270, 'lps'),
	(660551, 135, '2015-01-15 00:36:03.000000', 'consum', 0.0235, 'lps'),
	(660552, 135, '2015-01-15 00:36:04.000000', 'consum', 0.0231, 'lps'),
	(660553, 135, '2015-01-15 00:36:05.000000', 'consum', 0.0241, 'lps'),
	(660554, 135, '2015-01-15 00:36:06.000000', 'consum', 0.0227, 'lps'),
	(660555, 135, '2015-01-15 00:36:07.000000', 'consum', 0.0276, 'lps'),
	(660556, 135, '2015-01-15 00:36:08.000000', 'consum', 0.0269, 'lps'),
	(660557, 135, '2015-01-15 00:36:09.000000', 'consum', 0.0231, 'lps'),
	(660558, 135, '2015-01-15 00:36:10.000000', 'consum', 0.0214, 'lps'),
	(660559, 135, '2015-01-15 00:36:11.000000', 'consum', 0.0241, 'lps'),
	(660560, 135, '2015-01-15 00:36:12.000000', 'consum', 0.0279, 'lps'),
	(660561, 135, '2015-01-15 00:36:13.000000', 'consum', 0.0241, 'lps'),
	(660562, 135, '2015-01-15 00:36:14.000000', 'consum', 0.0233, 'lps'),
	(660563, 135, '2015-01-15 00:36:15.000000', 'consum', 0.0232, 'lps'),
	(660564, 135, '2015-01-15 00:36:16.000000', 'consum', 0.0250, 'lps'),
	(660565, 135, '2015-01-15 00:36:17.000000', 'consum', 0.0272, 'lps'),
	(660566, 135, '2015-01-15 00:36:18.000000', 'consum', 0.0251, 'lps'),
	(660567, 135, '2015-01-15 00:36:19.000000', 'consum', 0.0232, 'lps'),
	(660568, 135, '2015-01-15 00:36:20.000000', 'consum', 0.0270, 'lps'),
	(660569, 135, '2015-01-15 00:36:21.000000', 'consum', 0.0223, 'lps'),
	(660570, 135, '2015-01-15 00:36:22.000000', 'consum', 0.0243, 'lps'),
	(660571, 135, '2015-01-15 00:36:23.000000', 'consum', 0.0261, 'lps'),
	(660572, 135, '2015-01-15 00:36:24.000000', 'consum', 0.0222, 'lps'),
	(660573, 135, '2015-01-15 00:36:25.000000', 'consum', 0.0262, 'lps'),
	(660574, 135, '2015-01-15 00:36:26.000000', 'consum', 0.0214, 'lps'),
	(660575, 135, '2015-01-15 00:36:27.000000', 'consum', 0.0224, 'lps'),
	(660576, 135, '2015-01-15 00:36:28.000000', 'consum', 0.0269, 'lps'),
	(660577, 135, '2015-01-15 00:36:29.000000', 'consum', 0.0241, 'lps'),
	(660578, 135, '2015-01-15 00:36:30.000000', 'consum', 0.0260, 'lps'),
	(660579, 135, '2015-01-15 00:36:31.000000', 'consum', 0.0222, 'lps'),
	(660580, 135, '2015-01-15 00:36:32.000000', 'consum', 0.0269, 'lps'),
	(660581, 135, '2015-01-15 00:36:33.000000', 'consum', 0.0249, 'lps'),
	(660582, 135, '2015-01-15 00:36:34.000000', 'consum', 0.0225, 'lps'),
	(660583, 135, '2015-01-15 00:36:35.000000', 'consum', 0.0246, 'lps'),
	(660584, 135, '2015-01-15 00:36:36.000000', 'consum', 0.0268, 'lps'),
	(660585, 135, '2015-01-15 00:36:37.000000', 'consum', 0.0245, 'lps'),
	(660586, 135, '2015-01-15 00:36:38.000000', 'consum', 0.0214, 'lps'),
	(660587, 135, '2015-01-15 00:36:39.000000', 'consum', 0.0272, 'lps'),
	(660588, 135, '2015-01-15 00:36:40.000000', 'consum', 0.0214, 'lps'),
	(660589, 135, '2015-01-15 00:36:41.000000', 'consum', 0.0265, 'lps'),
	(660590, 135, '2015-01-15 00:36:42.000000', 'consum', 0.0251, 'lps'),
	(660591, 135, '2015-01-15 00:36:43.000000', 'consum', 0.0252, 'lps'),
	(660592, 135, '2015-01-15 00:36:44.000000', 'consum', 0.0221, 'lps'),
	(660593, 135, '2015-01-15 00:36:45.000000', 'consum', 0.0216, 'lps'),
	(660594, 135, '2015-01-15 00:36:46.000000', 'consum', 0.0282, 'lps'),
	(660595, 135, '2015-01-15 00:36:47.000000', 'consum', 0.0257, 'lps'),
	(660596, 135, '2015-01-15 00:36:48.000000', 'consum', 0.0228, 'lps'),
	(660597, 135, '2015-01-15 00:36:49.000000', 'consum', 0.0233, 'lps'),
	(660598, 135, '2015-01-15 00:36:50.000000', 'consum', 0.0271, 'lps'),
	(660599, 135, '2015-01-15 00:36:51.000000', 'consum', 0.0227, 'lps'),
	(660600, 135, '2015-01-15 00:36:52.000000', 'consum', 0.0260, 'lps'),
	(660601, 135, '2015-01-15 00:36:53.000000', 'consum', 0.0260, 'lps'),
	(660602, 135, '2015-01-15 00:36:54.000000', 'consum', 0.0236, 'lps'),
	(660603, 135, '2015-01-15 00:36:55.000000', 'consum', 0.0266, 'lps'),
	(660604, 135, '2015-01-15 00:36:56.000000', 'consum', 0.0262, 'lps'),
	(660605, 135, '2015-01-15 00:36:57.000000', 'consum', 0.0230, 'lps'),
	(660606, 135, '2015-01-15 00:36:58.000000', 'consum', 0.0227, 'lps'),
	(660607, 135, '2015-01-15 00:36:59.000000', 'consum', 0.0236, 'lps'),
	(660608, 135, '2015-01-15 00:37:00.000000', 'consum', 0.0215, 'lps'),
	(660609, 135, '2015-01-15 00:37:01.000000', 'consum', 0.0230, 'lps'),
	(660610, 135, '2015-01-15 00:37:02.000000', 'consum', 0.0223, 'lps'),
	(660611, 135, '2015-01-15 00:37:03.000000', 'consum', 0.0216, 'lps'),
	(660612, 135, '2015-01-15 00:37:04.000000', 'consum', 0.0276, 'lps'),
	(660613, 135, '2015-01-15 00:37:05.000000', 'consum', 0.0226, 'lps'),
	(660614, 135, '2015-01-15 00:37:06.000000', 'consum', 0.0242, 'lps'),
	(660615, 135, '2015-01-15 00:37:07.000000', 'consum', 0.0249, 'lps'),
	(660616, 135, '2015-01-15 00:37:08.000000', 'consum', 0.0234, 'lps'),
	(660617, 135, '2015-01-15 00:37:09.000000', 'consum', 0.0213, 'lps'),
	(660618, 135, '2015-01-15 00:37:10.000000', 'consum', 0.0228, 'lps'),
	(660619, 135, '2015-01-15 00:37:11.000000', 'consum', 0.0217, 'lps'),
	(660620, 135, '2015-01-15 00:37:12.000000', 'consum', 0.0268, 'lps'),
	(660621, 135, '2015-01-15 00:37:13.000000', 'consum', 0.0256, 'lps'),
	(660622, 135, '2015-01-15 00:37:14.000000', 'consum', 0.0264, 'lps'),
	(660623, 135, '2015-01-15 00:37:15.000000', 'consum', 0.0272, 'lps'),
	(660624, 135, '2015-01-15 00:37:16.000000', 'consum', 0.0211, 'lps'),
	(660625, 135, '2015-01-15 00:37:17.000000', 'consum', 0.0248, 'lps'),
	(660626, 135, '2015-01-15 00:37:18.000000', 'consum', 0.0253, 'lps'),
	(660627, 135, '2015-01-15 00:37:19.000000', 'consum', 0.0237, 'lps'),
	(660628, 135, '2015-01-15 00:37:20.000000', 'consum', 0.0215, 'lps'),
	(660629, 135, '2015-01-15 00:37:21.000000', 'consum', 0.0228, 'lps'),
	(660630, 135, '2015-01-15 00:37:22.000000', 'consum', 0.0214, 'lps'),
	(660631, 135, '2015-01-15 00:37:23.000000', 'consum', 0.0248, 'lps'),
	(660632, 135, '2015-01-15 00:37:24.000000', 'consum', 0.0242, 'lps'),
	(660633, 135, '2015-01-15 00:37:25.000000', 'consum', 0.0256, 'lps'),
	(660634, 135, '2015-01-15 00:37:26.000000', 'consum', 0.0271, 'lps'),
	(660635, 135, '2015-01-15 00:37:27.000000', 'consum', 0.0229, 'lps'),
	(660636, 135, '2015-01-15 00:37:28.000000', 'consum', 0.0269, 'lps'),
	(660637, 135, '2015-01-15 00:37:29.000000', 'consum', 0.0229, 'lps'),
	(660638, 135, '2015-01-15 00:37:30.000000', 'consum', 0.0277, 'lps'),
	(660639, 135, '2015-01-15 00:37:31.000000', 'consum', 0.0265, 'lps'),
	(660640, 135, '2015-01-15 00:37:32.000000', 'consum', 0.0212, 'lps'),
	(660641, 135, '2015-01-15 00:37:33.000000', 'consum', 0.0275, 'lps'),
	(660642, 135, '2015-01-15 00:37:34.000000', 'consum', 0.0237, 'lps'),
	(660643, 135, '2015-01-15 00:37:35.000000', 'consum', 0.0221, 'lps'),
	(660644, 135, '2015-01-15 00:37:36.000000', 'consum', 0.0261, 'lps'),
	(660645, 135, '2015-01-15 00:37:37.000000', 'consum', 0.0282, 'lps'),
	(660646, 135, '2015-01-15 00:37:38.000000', 'consum', 0.0269, 'lps'),
	(660647, 135, '2015-01-15 00:37:39.000000', 'consum', 0.0217, 'lps'),
	(660648, 135, '2015-01-15 00:37:40.000000', 'consum', 0.0217, 'lps'),
	(660649, 135, '2015-01-15 00:37:41.000000', 'consum', 0.0223, 'lps'),
	(660650, 135, '2015-01-15 00:37:42.000000', 'consum', 0.0254, 'lps'),
	(660651, 135, '2015-01-15 00:37:43.000000', 'consum', 0.0243, 'lps'),
	(660652, 135, '2015-01-15 00:37:44.000000', 'consum', 0.0246, 'lps'),
	(660653, 135, '2015-01-15 00:37:45.000000', 'consum', 0.0215, 'lps'),
	(660654, 135, '2015-01-15 00:37:46.000000', 'consum', 0.0275, 'lps'),
	(660655, 135, '2015-01-15 00:37:47.000000', 'consum', 0.0224, 'lps'),
	(660656, 135, '2015-01-15 00:37:48.000000', 'consum', 0.0236, 'lps'),
	(660657, 135, '2015-01-15 00:37:49.000000', 'consum', 0.0225, 'lps'),
	(660658, 135, '2015-01-15 00:37:50.000000', 'consum', 0.0282, 'lps'),
	(660659, 135, '2015-01-15 00:37:51.000000', 'consum', 0.0230, 'lps'),
	(660660, 135, '2015-01-15 00:37:52.000000', 'consum', 0.0241, 'lps'),
	(660661, 135, '2015-01-15 00:37:53.000000', 'consum', 0.0233, 'lps'),
	(660662, 135, '2015-01-15 00:37:54.000000', 'consum', 0.0232, 'lps'),
	(660663, 135, '2015-01-15 00:37:55.000000', 'consum', 0.0250, 'lps'),
	(660664, 135, '2015-01-15 00:37:56.000000', 'consum', 0.0273, 'lps'),
	(660665, 135, '2015-01-15 00:37:57.000000', 'consum', 0.0258, 'lps'),
	(660666, 135, '2015-01-15 00:37:58.000000', 'consum', 0.0262, 'lps'),
	(660667, 135, '2015-01-15 00:37:59.000000', 'consum', 0.0252, 'lps'),
	(660668, 135, '2015-01-15 00:38:00.000000', 'consum', 0.0266, 'lps'),
	(660669, 135, '2015-01-15 00:38:01.000000', 'consum', 0.0214, 'lps'),
	(660670, 135, '2015-01-15 00:38:02.000000', 'consum', 0.0210, 'lps'),
	(660671, 135, '2015-01-15 00:38:03.000000', 'consum', 0.0273, 'lps'),
	(660672, 135, '2015-01-15 00:38:04.000000', 'consum', 0.0230, 'lps'),
	(660673, 135, '2015-01-15 00:38:05.000000', 'consum', 0.0268, 'lps'),
	(660674, 135, '2015-01-15 00:38:06.000000', 'consum', 0.0218, 'lps'),
	(660675, 135, '2015-01-15 00:38:07.000000', 'consum', 0.0226, 'lps'),
	(660676, 135, '2015-01-15 00:38:08.000000', 'consum', 0.0266, 'lps'),
	(660677, 135, '2015-01-15 00:38:09.000000', 'consum', 0.0221, 'lps'),
	(660678, 135, '2015-01-15 00:38:10.000000', 'consum', 0.0246, 'lps'),
	(660679, 135, '2015-01-15 00:38:11.000000', 'consum', 0.0210, 'lps'),
	(660680, 135, '2015-01-15 00:38:12.000000', 'consum', 0.0250, 'lps'),
	(660681, 135, '2015-01-15 00:38:13.000000', 'consum', 0.0263, 'lps'),
	(660682, 135, '2015-01-15 00:38:14.000000', 'consum', 0.0279, 'lps'),
	(660683, 135, '2015-01-15 00:38:15.000000', 'consum', 0.0251, 'lps'),
	(660684, 135, '2015-01-15 00:38:16.000000', 'consum', 0.0283, 'lps'),
	(660685, 135, '2015-01-15 00:38:17.000000', 'consum', 0.0230, 'lps'),
	(660686, 135, '2015-01-15 00:38:18.000000', 'consum', 0.0238, 'lps'),
	(660687, 135, '2015-01-15 00:38:19.000000', 'consum', 0.0216, 'lps'),
	(660688, 135, '2015-01-15 00:38:20.000000', 'consum', 0.0230, 'lps'),
	(660689, 135, '2015-01-15 00:38:21.000000', 'consum', 0.0221, 'lps'),
	(660690, 135, '2015-01-15 00:38:22.000000', 'consum', 0.0277, 'lps'),
	(660691, 135, '2015-01-15 00:38:23.000000', 'consum', 0.0220, 'lps'),
	(660692, 135, '2015-01-15 00:38:24.000000', 'consum', 0.0278, 'lps'),
	(660693, 135, '2015-01-15 00:38:25.000000', 'consum', 0.0227, 'lps'),
	(660694, 135, '2015-01-15 00:38:26.000000', 'consum', 0.0237, 'lps'),
	(660695, 135, '2015-01-15 00:38:27.000000', 'consum', 0.0220, 'lps'),
	(660696, 135, '2015-01-15 00:38:28.000000', 'consum', 0.0256, 'lps'),
	(660697, 135, '2015-01-15 00:38:29.000000', 'consum', 0.0261, 'lps'),
	(660698, 135, '2015-01-15 00:38:30.000000', 'consum', 0.0254, 'lps'),
	(660699, 135, '2015-01-15 00:38:31.000000', 'consum', 0.0277, 'lps'),
	(660700, 135, '2015-01-15 00:38:32.000000', 'consum', 0.0265, 'lps'),
	(660701, 135, '2015-01-15 00:38:33.000000', 'consum', 0.0213, 'lps'),
	(660702, 135, '2015-01-15 00:38:34.000000', 'consum', 0.0281, 'lps'),
	(660703, 135, '2015-01-15 00:38:35.000000', 'consum', 0.0259, 'lps'),
	(660704, 135, '2015-01-15 00:38:36.000000', 'consum', 0.0244, 'lps'),
	(660705, 135, '2015-01-15 00:38:37.000000', 'consum', 0.0234, 'lps'),
	(660706, 135, '2015-01-15 00:38:38.000000', 'consum', 0.0229, 'lps'),
	(660707, 135, '2015-01-15 00:38:39.000000', 'consum', 0.0234, 'lps'),
	(660708, 135, '2015-01-15 00:38:40.000000', 'consum', 0.0273, 'lps'),
	(660709, 135, '2015-01-15 00:38:41.000000', 'consum', 0.0229, 'lps'),
	(660710, 135, '2015-01-15 00:38:42.000000', 'consum', 0.0267, 'lps'),
	(660711, 135, '2015-01-15 00:38:43.000000', 'consum', 0.0217, 'lps'),
	(660712, 135, '2015-01-15 00:38:44.000000', 'consum', 0.0222, 'lps'),
	(660713, 135, '2015-01-15 00:38:45.000000', 'consum', 0.0248, 'lps'),
	(660714, 135, '2015-01-15 00:38:46.000000', 'consum', 0.0217, 'lps'),
	(660715, 135, '2015-01-15 00:38:47.000000', 'consum', 0.0278, 'lps'),
	(660716, 135, '2015-01-15 00:38:48.000000', 'consum', 0.0237, 'lps'),
	(660717, 135, '2015-01-15 00:38:49.000000', 'consum', 0.0213, 'lps'),
	(660718, 135, '2015-01-15 00:38:50.000000', 'consum', 0.0219, 'lps'),
	(660719, 135, '2015-01-15 00:38:51.000000', 'consum', 0.0244, 'lps'),
	(660720, 135, '2015-01-15 00:38:52.000000', 'consum', 0.0283, 'lps'),
	(660721, 135, '2015-01-15 00:38:53.000000', 'consum', 0.0252, 'lps'),
	(660722, 135, '2015-01-15 00:38:54.000000', 'consum', 0.0275, 'lps'),
	(660723, 135, '2015-01-15 00:38:55.000000', 'consum', 0.0261, 'lps'),
	(660724, 135, '2015-01-15 00:38:56.000000', 'consum', 0.0269, 'lps'),
	(660725, 135, '2015-01-15 00:38:57.000000', 'consum', 0.0279, 'lps'),
	(660726, 135, '2015-01-15 00:38:58.000000', 'consum', 0.0229, 'lps'),
	(660727, 135, '2015-01-15 00:38:59.000000', 'consum', 0.0247, 'lps'),
	(660728, 135, '2015-01-15 00:39:00.000000', 'consum', 0.0265, 'lps'),
	(660729, 135, '2015-01-15 00:39:01.000000', 'consum', 0.0225, 'lps'),
	(660730, 135, '2015-01-15 00:39:02.000000', 'consum', 0.0271, 'lps'),
	(660731, 135, '2015-01-15 00:39:03.000000', 'consum', 0.0247, 'lps'),
	(660732, 135, '2015-01-15 00:39:04.000000', 'consum', 0.0215, 'lps'),
	(660733, 135, '2015-01-15 00:39:05.000000', 'consum', 0.0269, 'lps'),
	(660734, 135, '2015-01-15 00:39:06.000000', 'consum', 0.0270, 'lps'),
	(660735, 135, '2015-01-15 00:39:07.000000', 'consum', 0.0261, 'lps'),
	(660736, 135, '2015-01-15 00:39:08.000000', 'consum', 0.0211, 'lps'),
	(660737, 135, '2015-01-15 00:39:09.000000', 'consum', 0.0212, 'lps'),
	(660738, 135, '2015-01-15 00:39:10.000000', 'consum', 0.0217, 'lps'),
	(660739, 135, '2015-01-15 00:39:11.000000', 'consum', 0.0239, 'lps'),
	(660740, 135, '2015-01-15 00:39:12.000000', 'consum', 0.0259, 'lps'),
	(660741, 135, '2015-01-15 00:39:13.000000', 'consum', 0.0223, 'lps'),
	(660742, 135, '2015-01-15 00:39:14.000000', 'consum', 0.0274, 'lps'),
	(660743, 135, '2015-01-15 00:39:15.000000', 'consum', 0.0269, 'lps'),
	(660744, 135, '2015-01-15 00:39:16.000000', 'consum', 0.0242, 'lps'),
	(660745, 135, '2015-01-15 00:39:17.000000', 'consum', 0.0267, 'lps'),
	(660746, 135, '2015-01-15 00:39:18.000000', 'consum', 0.0252, 'lps'),
	(660747, 135, '2015-01-15 00:39:19.000000', 'consum', 0.0248, 'lps'),
	(660748, 135, '2015-01-15 00:39:20.000000', 'consum', 0.0276, 'lps'),
	(660749, 135, '2015-01-15 00:39:21.000000', 'consum', 0.0276, 'lps'),
	(660750, 135, '2015-01-15 00:39:22.000000', 'consum', 0.0270, 'lps'),
	(660751, 135, '2015-01-15 00:39:23.000000', 'consum', 0.0238, 'lps'),
	(660752, 135, '2015-01-15 00:39:24.000000', 'consum', 0.0245, 'lps'),
	(660753, 135, '2015-01-15 00:39:25.000000', 'consum', 0.0225, 'lps'),
	(660754, 135, '2015-01-15 00:39:26.000000', 'consum', 0.0257, 'lps'),
	(660755, 135, '2015-01-15 00:39:27.000000', 'consum', 0.0253, 'lps'),
	(660756, 135, '2015-01-15 00:39:28.000000', 'consum', 0.0282, 'lps'),
	(660757, 135, '2015-01-15 00:39:29.000000', 'consum', 0.0222, 'lps'),
	(660758, 135, '2015-01-15 00:39:30.000000', 'consum', 0.0278, 'lps'),
	(660759, 135, '2015-01-15 00:39:31.000000', 'consum', 0.0215, 'lps'),
	(660760, 135, '2015-01-15 00:39:32.000000', 'consum', 0.0254, 'lps'),
	(660761, 135, '2015-01-15 00:39:33.000000', 'consum', 0.0269, 'lps'),
	(660762, 135, '2015-01-15 00:39:34.000000', 'consum', 0.0226, 'lps'),
	(660763, 135, '2015-01-15 00:39:35.000000', 'consum', 0.0260, 'lps'),
	(660764, 135, '2015-01-15 00:39:36.000000', 'consum', 0.0263, 'lps'),
	(660765, 135, '2015-01-15 00:39:37.000000', 'consum', 0.0253, 'lps'),
	(660766, 135, '2015-01-15 00:39:38.000000', 'consum', 0.0267, 'lps'),
	(660767, 135, '2015-01-15 00:39:39.000000', 'consum', 0.0219, 'lps'),
	(660768, 135, '2015-01-15 00:39:40.000000', 'consum', 0.0231, 'lps'),
	(660769, 135, '2015-01-15 00:39:41.000000', 'consum', 0.0213, 'lps'),
	(660770, 135, '2015-01-15 00:39:42.000000', 'consum', 0.0238, 'lps'),
	(660771, 135, '2015-01-15 00:39:43.000000', 'consum', 0.0267, 'lps'),
	(660772, 135, '2015-01-15 00:39:44.000000', 'consum', 0.0264, 'lps'),
	(660773, 135, '2015-01-15 00:39:45.000000', 'consum', 0.0236, 'lps'),
	(660774, 135, '2015-01-15 00:39:46.000000', 'consum', 0.0252, 'lps'),
	(660775, 135, '2015-01-15 00:39:47.000000', 'consum', 0.0267, 'lps'),
	(660776, 135, '2015-01-15 00:39:48.000000', 'consum', 0.0220, 'lps'),
	(660777, 135, '2015-01-15 00:39:49.000000', 'consum', 0.0241, 'lps'),
	(660778, 135, '2015-01-15 00:39:50.000000', 'consum', 0.0261, 'lps'),
	(660779, 135, '2015-01-15 00:39:51.000000', 'consum', 0.0225, 'lps'),
	(660780, 135, '2015-01-15 00:39:52.000000', 'consum', 0.0281, 'lps'),
	(660781, 135, '2015-01-15 00:39:53.000000', 'consum', 0.0223, 'lps'),
	(660782, 135, '2015-01-15 00:39:54.000000', 'consum', 0.0210, 'lps'),
	(660783, 135, '2015-01-15 00:39:55.000000', 'consum', 0.0248, 'lps'),
	(660784, 135, '2015-01-15 00:39:56.000000', 'consum', 0.0250, 'lps'),
	(660785, 135, '2015-01-15 00:39:57.000000', 'consum', 0.0222, 'lps'),
	(660786, 135, '2015-01-15 00:39:58.000000', 'consum', 0.0227, 'lps'),
	(660787, 135, '2015-01-15 00:39:59.000000', 'consum', 0.0257, 'lps'),
	(660788, 135, '2015-01-15 00:40:00.000000', 'consum', 0.0246, 'lps'),
	(660789, 135, '2015-01-15 00:40:01.000000', 'consum', 0.0251, 'lps'),
	(660790, 135, '2015-01-15 00:40:02.000000', 'consum', 0.0232, 'lps'),
	(660791, 135, '2015-01-15 00:40:03.000000', 'consum', 0.0274, 'lps'),
	(660792, 135, '2015-01-15 00:40:04.000000', 'consum', 0.0242, 'lps'),
	(660793, 135, '2015-01-15 00:40:05.000000', 'consum', 0.0253, 'lps'),
	(660794, 135, '2015-01-15 00:40:06.000000', 'consum', 0.0254, 'lps'),
	(660795, 135, '2015-01-15 00:40:07.000000', 'consum', 0.0226, 'lps'),
	(660796, 135, '2015-01-15 00:40:08.000000', 'consum', 0.0234, 'lps'),
	(660797, 135, '2015-01-15 00:40:09.000000', 'consum', 0.0282, 'lps'),
	(660798, 135, '2015-01-15 00:40:10.000000', 'consum', 0.0277, 'lps'),
	(660799, 135, '2015-01-15 00:40:11.000000', 'consum', 0.0255, 'lps'),
	(660800, 135, '2015-01-15 00:40:12.000000', 'consum', 0.0234, 'lps'),
	(660801, 135, '2015-01-15 00:40:13.000000', 'consum', 0.0268, 'lps'),
	(660802, 135, '2015-01-15 00:40:14.000000', 'consum', 0.0282, 'lps'),
	(660803, 135, '2015-01-15 00:40:15.000000', 'consum', 0.0249, 'lps'),
	(660804, 135, '2015-01-15 00:40:16.000000', 'consum', 0.0261, 'lps'),
	(660805, 135, '2015-01-15 00:40:17.000000', 'consum', 0.0276, 'lps'),
	(660806, 135, '2015-01-15 00:40:18.000000', 'consum', 0.0240, 'lps'),
	(660807, 135, '2015-01-15 00:40:19.000000', 'consum', 0.0236, 'lps'),
	(660808, 135, '2015-01-15 00:40:20.000000', 'consum', 0.0250, 'lps'),
	(660809, 135, '2015-01-15 00:40:21.000000', 'consum', 0.0261, 'lps'),
	(660810, 135, '2015-01-15 00:40:22.000000', 'consum', 0.0269, 'lps'),
	(660811, 135, '2015-01-15 00:40:23.000000', 'consum', 0.0278, 'lps'),
	(660812, 135, '2015-01-15 00:40:24.000000', 'consum', 0.0225, 'lps'),
	(660813, 135, '2015-01-15 00:40:25.000000', 'consum', 0.0232, 'lps'),
	(660814, 135, '2015-01-15 00:40:26.000000', 'consum', 0.0276, 'lps'),
	(660815, 135, '2015-01-15 00:40:27.000000', 'consum', 0.0250, 'lps'),
	(660816, 135, '2015-01-15 00:40:28.000000', 'consum', 0.0213, 'lps'),
	(660817, 135, '2015-01-15 00:40:29.000000', 'consum', 0.0254, 'lps'),
	(660818, 135, '2015-01-15 00:40:30.000000', 'consum', 0.0273, 'lps'),
	(660819, 135, '2015-01-15 00:40:31.000000', 'consum', 0.0245, 'lps'),
	(660820, 135, '2015-01-15 00:40:32.000000', 'consum', 0.0270, 'lps'),
	(660821, 135, '2015-01-15 00:40:33.000000', 'consum', 0.0259, 'lps'),
	(660822, 135, '2015-01-15 00:40:34.000000', 'consum', 0.0276, 'lps'),
	(660823, 135, '2015-01-15 00:40:35.000000', 'consum', 0.0246, 'lps'),
	(660824, 135, '2015-01-15 00:40:36.000000', 'consum', 0.0264, 'lps'),
	(660825, 135, '2015-01-15 00:40:37.000000', 'consum', 0.0226, 'lps'),
	(660826, 135, '2015-01-15 00:40:38.000000', 'consum', 0.0276, 'lps'),
	(660827, 135, '2015-01-15 00:40:39.000000', 'consum', 0.0269, 'lps'),
	(660828, 135, '2015-01-15 00:40:40.000000', 'consum', 0.0236, 'lps'),
	(660829, 135, '2015-01-15 00:40:41.000000', 'consum', 0.0236, 'lps'),
	(660830, 135, '2015-01-15 00:40:42.000000', 'consum', 0.0265, 'lps'),
	(660831, 135, '2015-01-15 00:40:43.000000', 'consum', 0.0256, 'lps'),
	(660832, 135, '2015-01-15 00:40:44.000000', 'consum', 0.0279, 'lps'),
	(660833, 135, '2015-01-15 00:40:45.000000', 'consum', 0.0268, 'lps'),
	(660834, 135, '2015-01-15 00:40:46.000000', 'consum', 0.0219, 'lps'),
	(660835, 135, '2015-01-15 00:40:47.000000', 'consum', 0.0232, 'lps'),
	(660836, 135, '2015-01-15 00:40:48.000000', 'consum', 0.0217, 'lps'),
	(660837, 135, '2015-01-15 00:40:49.000000', 'consum', 0.0254, 'lps'),
	(660838, 135, '2015-01-15 00:40:50.000000', 'consum', 0.0261, 'lps'),
	(660839, 135, '2015-01-15 00:40:51.000000', 'consum', 0.0262, 'lps'),
	(660840, 135, '2015-01-15 00:40:52.000000', 'consum', 0.0241, 'lps'),
	(660841, 135, '2015-01-15 00:40:53.000000', 'consum', 0.0283, 'lps'),
	(660842, 135, '2015-01-15 00:40:54.000000', 'consum', 0.0261, 'lps'),
	(660843, 135, '2015-01-15 00:40:55.000000', 'consum', 0.0247, 'lps'),
	(660844, 135, '2015-01-15 00:40:56.000000', 'consum', 0.0243, 'lps'),
	(660845, 135, '2015-01-15 00:40:57.000000', 'consum', 0.0262, 'lps'),
	(660846, 135, '2015-01-15 00:40:58.000000', 'consum', 0.0225, 'lps'),
	(660847, 135, '2015-01-15 00:40:59.000000', 'consum', 0.0277, 'lps'),
	(660848, 135, '2015-01-15 00:41:00.000000', 'consum', 0.0280, 'lps'),
	(660849, 135, '2015-01-15 00:41:01.000000', 'consum', 0.0210, 'lps'),
	(660850, 135, '2015-01-15 00:41:02.000000', 'consum', 0.0224, 'lps'),
	(660851, 135, '2015-01-15 00:41:03.000000', 'consum', 0.0280, 'lps'),
	(660852, 135, '2015-01-15 00:41:04.000000', 'consum', 0.0223, 'lps'),
	(660853, 135, '2015-01-15 00:41:05.000000', 'consum', 0.0211, 'lps'),
	(660854, 135, '2015-01-15 00:41:06.000000', 'consum', 0.0254, 'lps'),
	(660855, 135, '2015-01-15 00:41:07.000000', 'consum', 0.0278, 'lps'),
	(660856, 135, '2015-01-15 00:41:08.000000', 'consum', 0.0270, 'lps'),
	(660857, 135, '2015-01-15 00:41:09.000000', 'consum', 0.0233, 'lps'),
	(660858, 135, '2015-01-15 00:41:10.000000', 'consum', 0.0218, 'lps'),
	(660859, 135, '2015-01-15 00:41:11.000000', 'consum', 0.0255, 'lps'),
	(660860, 135, '2015-01-15 00:41:12.000000', 'consum', 0.0266, 'lps'),
	(660861, 135, '2015-01-15 00:41:13.000000', 'consum', 0.0278, 'lps'),
	(660862, 135, '2015-01-15 00:41:14.000000', 'consum', 0.0238, 'lps'),
	(660863, 135, '2015-01-15 00:41:15.000000', 'consum', 0.0221, 'lps'),
	(660864, 135, '2015-01-15 00:41:16.000000', 'consum', 0.0253, 'lps'),
	(660865, 135, '2015-01-15 00:41:17.000000', 'consum', 0.0245, 'lps'),
	(660866, 135, '2015-01-15 00:41:18.000000', 'consum', 0.0255, 'lps'),
	(660867, 135, '2015-01-15 00:41:19.000000', 'consum', 0.0258, 'lps'),
	(660868, 135, '2015-01-15 00:41:20.000000', 'consum', 0.0243, 'lps'),
	(660869, 135, '2015-01-15 00:41:21.000000', 'consum', 0.0231, 'lps'),
	(660870, 135, '2015-01-15 00:41:22.000000', 'consum', 0.0215, 'lps'),
	(660871, 135, '2015-01-15 00:41:23.000000', 'consum', 0.0248, 'lps'),
	(660872, 135, '2015-01-15 00:41:24.000000', 'consum', 0.0239, 'lps'),
	(660873, 135, '2015-01-15 00:41:25.000000', 'consum', 0.0239, 'lps'),
	(660874, 135, '2015-01-15 00:41:26.000000', 'consum', 0.0270, 'lps'),
	(660875, 135, '2015-01-15 00:41:27.000000', 'consum', 0.0274, 'lps'),
	(660876, 135, '2015-01-15 00:41:28.000000', 'consum', 0.0277, 'lps'),
	(660877, 135, '2015-01-15 00:41:29.000000', 'consum', 0.0280, 'lps'),
	(660878, 135, '2015-01-15 00:41:30.000000', 'consum', 0.0212, 'lps'),
	(660879, 135, '2015-01-15 00:41:31.000000', 'consum', 0.0230, 'lps'),
	(660880, 135, '2015-01-15 00:41:32.000000', 'consum', 0.0231, 'lps'),
	(660881, 135, '2015-01-15 00:41:33.000000', 'consum', 0.0257, 'lps'),
	(660882, 135, '2015-01-15 00:41:34.000000', 'consum', 0.0235, 'lps'),
	(660883, 135, '2015-01-15 00:41:35.000000', 'consum', 0.0266, 'lps'),
	(660884, 135, '2015-01-15 00:41:36.000000', 'consum', 0.0270, 'lps'),
	(660885, 135, '2015-01-15 00:41:37.000000', 'consum', 0.0267, 'lps'),
	(660886, 135, '2015-01-15 00:41:38.000000', 'consum', 0.0240, 'lps'),
	(660887, 135, '2015-01-15 00:41:39.000000', 'consum', 0.0266, 'lps'),
	(660888, 135, '2015-01-15 00:41:40.000000', 'consum', 0.0254, 'lps'),
	(660889, 135, '2015-01-15 00:41:41.000000', 'consum', 0.0259, 'lps'),
	(660890, 135, '2015-01-15 00:41:42.000000', 'consum', 0.0250, 'lps'),
	(660891, 135, '2015-01-15 00:41:43.000000', 'consum', 0.0263, 'lps'),
	(660892, 135, '2015-01-15 00:41:44.000000', 'consum', 0.0282, 'lps'),
	(660893, 135, '2015-01-15 00:41:45.000000', 'consum', 0.0265, 'lps'),
	(660894, 135, '2015-01-15 00:41:46.000000', 'consum', 0.0267, 'lps'),
	(660895, 135, '2015-01-15 00:41:47.000000', 'consum', 0.0260, 'lps'),
	(660896, 135, '2015-01-15 00:41:48.000000', 'consum', 0.0212, 'lps'),
	(660897, 135, '2015-01-15 00:41:49.000000', 'consum', 0.0220, 'lps'),
	(660898, 135, '2015-01-15 00:41:50.000000', 'consum', 0.0256, 'lps'),
	(660899, 135, '2015-01-15 00:41:51.000000', 'consum', 0.0262, 'lps'),
	(660900, 135, '2015-01-15 00:41:52.000000', 'consum', 0.0257, 'lps'),
	(660901, 135, '2015-01-15 00:41:53.000000', 'consum', 0.0218, 'lps'),
	(660902, 135, '2015-01-15 00:41:54.000000', 'consum', 0.0255, 'lps'),
	(660903, 135, '2015-01-15 00:41:55.000000', 'consum', 0.0266, 'lps'),
	(660904, 135, '2015-01-15 00:41:56.000000', 'consum', 0.0279, 'lps'),
	(660905, 135, '2015-01-15 00:41:57.000000', 'consum', 0.0241, 'lps'),
	(660906, 135, '2015-01-15 00:41:58.000000', 'consum', 0.0231, 'lps'),
	(660907, 135, '2015-01-15 00:41:59.000000', 'consum', 0.0222, 'lps'),
	(660908, 135, '2015-01-15 00:42:00.000000', 'consum', 0.0210, 'lps'),
	(660909, 135, '2015-01-15 00:42:01.000000', 'consum', 0.0247, 'lps'),
	(660910, 135, '2015-01-15 00:42:02.000000', 'consum', 0.0250, 'lps'),
	(660911, 135, '2015-01-15 00:42:03.000000', 'consum', 0.0222, 'lps'),
	(660912, 135, '2015-01-15 00:42:04.000000', 'consum', 0.0225, 'lps'),
	(660913, 135, '2015-01-15 00:42:05.000000', 'consum', 0.0250, 'lps'),
	(660914, 135, '2015-01-15 00:42:06.000000', 'consum', 0.0220, 'lps'),
	(660915, 135, '2015-01-15 00:42:07.000000', 'consum', 0.0212, 'lps'),
	(660916, 135, '2015-01-15 00:42:08.000000', 'consum', 0.0263, 'lps'),
	(660917, 135, '2015-01-15 00:42:09.000000', 'consum', 0.0249, 'lps'),
	(660918, 135, '2015-01-15 00:42:10.000000', 'consum', 0.0248, 'lps'),
	(660919, 135, '2015-01-15 00:42:11.000000', 'consum', 0.0281, 'lps'),
	(660920, 135, '2015-01-15 00:42:12.000000', 'consum', 0.0232, 'lps'),
	(660921, 135, '2015-01-15 00:42:13.000000', 'consum', 0.0255, 'lps'),
	(660922, 135, '2015-01-15 00:42:14.000000', 'consum', 0.0222, 'lps'),
	(660923, 135, '2015-01-15 00:42:15.000000', 'consum', 0.0283, 'lps'),
	(660924, 135, '2015-01-15 00:42:16.000000', 'consum', 0.0242, 'lps'),
	(660925, 135, '2015-01-15 00:42:17.000000', 'consum', 0.0228, 'lps'),
	(660926, 135, '2015-01-15 00:42:18.000000', 'consum', 0.0278, 'lps'),
	(660927, 135, '2015-01-15 00:42:19.000000', 'consum', 0.0275, 'lps'),
	(660928, 135, '2015-01-15 00:42:20.000000', 'consum', 0.0255, 'lps'),
	(660929, 135, '2015-01-15 00:42:21.000000', 'consum', 0.0243, 'lps'),
	(660930, 135, '2015-01-15 00:42:22.000000', 'consum', 0.0239, 'lps'),
	(660931, 135, '2015-01-15 00:42:23.000000', 'consum', 0.0258, 'lps'),
	(660932, 135, '2015-01-15 00:42:24.000000', 'consum', 0.0213, 'lps'),
	(660933, 135, '2015-01-15 00:42:25.000000', 'consum', 0.0229, 'lps'),
	(660934, 135, '2015-01-15 00:42:26.000000', 'consum', 0.0225, 'lps'),
	(660935, 135, '2015-01-15 00:42:27.000000', 'consum', 0.0227, 'lps'),
	(660936, 135, '2015-01-15 00:42:28.000000', 'consum', 0.0251, 'lps'),
	(660937, 135, '2015-01-15 00:42:29.000000', 'consum', 0.0215, 'lps'),
	(660938, 135, '2015-01-15 00:42:30.000000', 'consum', 0.0261, 'lps'),
	(660939, 135, '2015-01-15 00:42:31.000000', 'consum', 0.0230, 'lps'),
	(660940, 135, '2015-01-15 00:42:32.000000', 'consum', 0.0231, 'lps'),
	(660941, 135, '2015-01-15 00:42:33.000000', 'consum', 0.0255, 'lps'),
	(660942, 135, '2015-01-15 00:42:34.000000', 'consum', 0.0225, 'lps'),
	(660943, 135, '2015-01-15 00:42:35.000000', 'consum', 0.0224, 'lps'),
	(660944, 135, '2015-01-15 00:42:36.000000', 'consum', 0.0236, 'lps'),
	(660945, 135, '2015-01-15 00:42:37.000000', 'consum', 0.0224, 'lps'),
	(660946, 135, '2015-01-15 00:42:38.000000', 'consum', 0.0275, 'lps'),
	(660947, 135, '2015-01-15 00:42:39.000000', 'consum', 0.0274, 'lps'),
	(660948, 135, '2015-01-15 00:42:40.000000', 'consum', 0.0262, 'lps'),
	(660949, 135, '2015-01-15 00:42:41.000000', 'consum', 0.0278, 'lps'),
	(660950, 135, '2015-01-15 00:42:42.000000', 'consum', 0.0245, 'lps'),
	(660951, 135, '2015-01-15 00:42:43.000000', 'consum', 0.0255, 'lps'),
	(660952, 135, '2015-01-15 00:42:44.000000', 'consum', 0.0259, 'lps'),
	(660953, 135, '2015-01-15 00:42:45.000000', 'consum', 0.0247, 'lps'),
	(660954, 135, '2015-01-15 00:42:46.000000', 'consum', 0.0246, 'lps'),
	(660955, 135, '2015-01-15 00:42:47.000000', 'consum', 0.0279, 'lps'),
	(660956, 135, '2015-01-15 00:42:48.000000', 'consum', 0.0227, 'lps'),
	(660957, 135, '2015-01-15 00:42:49.000000', 'consum', 0.0238, 'lps'),
	(660958, 135, '2015-01-15 00:42:50.000000', 'consum', 0.0224, 'lps'),
	(660959, 135, '2015-01-15 00:42:51.000000', 'consum', 0.0272, 'lps'),
	(660960, 135, '2015-01-15 00:42:52.000000', 'consum', 0.0256, 'lps'),
	(660961, 135, '2015-01-15 00:42:53.000000', 'consum', 0.0255, 'lps'),
	(660962, 135, '2015-01-15 00:42:54.000000', 'consum', 0.0222, 'lps'),
	(660963, 135, '2015-01-15 00:42:55.000000', 'consum', 0.0211, 'lps'),
	(660964, 135, '2015-01-15 00:42:56.000000', 'consum', 0.0251, 'lps'),
	(660965, 135, '2015-01-15 00:42:57.000000', 'consum', 0.0268, 'lps'),
	(660966, 135, '2015-01-15 00:42:58.000000', 'consum', 0.0227, 'lps'),
	(660967, 135, '2015-01-15 00:42:59.000000', 'consum', 0.0269, 'lps'),
	(660968, 135, '2015-01-15 00:43:00.000000', 'consum', 0.0233, 'lps'),
	(660969, 135, '2015-01-15 00:43:01.000000', 'consum', 0.0221, 'lps'),
	(660970, 135, '2015-01-15 00:43:02.000000', 'consum', 0.0272, 'lps'),
	(660971, 135, '2015-01-15 00:43:03.000000', 'consum', 0.0264, 'lps'),
	(660972, 135, '2015-01-15 00:43:04.000000', 'consum', 0.0222, 'lps'),
	(660973, 135, '2015-01-15 00:43:05.000000', 'consum', 0.0254, 'lps'),
	(660974, 135, '2015-01-15 00:43:06.000000', 'consum', 0.0248, 'lps'),
	(660975, 135, '2015-01-15 00:43:07.000000', 'consum', 0.0268, 'lps'),
	(660976, 135, '2015-01-15 00:43:08.000000', 'consum', 0.0239, 'lps'),
	(660977, 135, '2015-01-15 00:43:09.000000', 'consum', 0.0256, 'lps'),
	(660978, 135, '2015-01-15 00:43:10.000000', 'consum', 0.0281, 'lps'),
	(660979, 135, '2015-01-15 00:43:11.000000', 'consum', 0.0277, 'lps'),
	(660980, 135, '2015-01-15 00:43:12.000000', 'consum', 0.0258, 'lps'),
	(660981, 135, '2015-01-15 00:43:13.000000', 'consum', 0.0251, 'lps'),
	(660982, 135, '2015-01-15 00:43:14.000000', 'consum', 0.0269, 'lps'),
	(660983, 135, '2015-01-15 00:43:15.000000', 'consum', 0.0238, 'lps'),
	(660984, 135, '2015-01-15 00:43:16.000000', 'consum', 0.0245, 'lps'),
	(660985, 135, '2015-01-15 00:43:17.000000', 'consum', 0.0228, 'lps'),
	(660986, 135, '2015-01-15 00:43:18.000000', 'consum', 0.0271, 'lps'),
	(660987, 135, '2015-01-15 00:43:19.000000', 'consum', 0.0239, 'lps'),
	(660988, 135, '2015-01-15 00:43:20.000000', 'consum', 0.0248, 'lps'),
	(660989, 135, '2015-01-15 00:43:21.000000', 'consum', 0.0237, 'lps'),
	(660990, 135, '2015-01-15 00:43:22.000000', 'consum', 0.0231, 'lps'),
	(660991, 135, '2015-01-15 00:43:23.000000', 'consum', 0.0236, 'lps'),
	(660992, 135, '2015-01-15 00:43:24.000000', 'consum', 0.0278, 'lps'),
	(660993, 135, '2015-01-15 00:43:25.000000', 'consum', 0.0252, 'lps'),
	(660994, 135, '2015-01-15 00:43:26.000000', 'consum', 0.0213, 'lps'),
	(660995, 135, '2015-01-15 00:43:27.000000', 'consum', 0.0249, 'lps'),
	(660996, 135, '2015-01-15 00:43:28.000000', 'consum', 0.0248, 'lps'),
	(660997, 135, '2015-01-15 00:43:29.000000', 'consum', 0.0211, 'lps'),
	(660998, 135, '2015-01-15 00:43:30.000000', 'consum', 0.0247, 'lps'),
	(660999, 135, '2015-01-15 00:43:31.000000', 'consum', 0.0244, 'lps'),
	(661000, 135, '2015-01-15 00:43:32.000000', 'consum', 0.0272, 'lps'),
	(661001, 135, '2015-01-15 00:43:33.000000', 'consum', 0.0268, 'lps'),
	(661002, 135, '2015-01-15 00:43:34.000000', 'consum', 0.0242, 'lps'),
	(661003, 135, '2015-01-15 00:43:35.000000', 'consum', 0.0269, 'lps'),
	(661004, 135, '2015-01-15 00:43:36.000000', 'consum', 0.0260, 'lps'),
	(661005, 135, '2015-01-15 00:43:37.000000', 'consum', 0.0213, 'lps'),
	(661006, 135, '2015-01-15 00:43:38.000000', 'consum', 0.0222, 'lps'),
	(661007, 135, '2015-01-15 00:43:39.000000', 'consum', 0.0262, 'lps'),
	(661008, 135, '2015-01-15 00:43:40.000000', 'consum', 0.0214, 'lps'),
	(661009, 135, '2015-01-15 00:43:41.000000', 'consum', 0.0221, 'lps'),
	(661010, 135, '2015-01-15 00:43:42.000000', 'consum', 0.0254, 'lps'),
	(661011, 135, '2015-01-15 00:43:43.000000', 'consum', 0.0250, 'lps'),
	(661012, 135, '2015-01-15 00:43:44.000000', 'consum', 0.0279, 'lps'),
	(661013, 135, '2015-01-15 00:43:45.000000', 'consum', 0.0212, 'lps'),
	(661014, 135, '2015-01-15 00:43:46.000000', 'consum', 0.0235, 'lps'),
	(661015, 135, '2015-01-15 00:43:47.000000', 'consum', 0.0256, 'lps'),
	(661016, 135, '2015-01-15 00:43:48.000000', 'consum', 0.0219, 'lps'),
	(661017, 135, '2015-01-15 00:43:49.000000', 'consum', 0.0264, 'lps'),
	(661018, 135, '2015-01-15 00:43:50.000000', 'consum', 0.0231, 'lps'),
	(661019, 135, '2015-01-15 00:43:51.000000', 'consum', 0.0230, 'lps'),
	(661020, 135, '2015-01-15 00:43:52.000000', 'consum', 0.0246, 'lps'),
	(661021, 135, '2015-01-15 00:43:53.000000', 'consum', 0.0255, 'lps'),
	(661022, 135, '2015-01-15 00:43:54.000000', 'consum', 0.0257, 'lps'),
	(661023, 135, '2015-01-15 00:43:55.000000', 'consum', 0.0233, 'lps'),
	(661024, 135, '2015-01-15 00:43:56.000000', 'consum', 0.0261, 'lps'),
	(661025, 135, '2015-01-15 00:43:57.000000', 'consum', 0.0247, 'lps'),
	(661026, 135, '2015-01-15 00:43:58.000000', 'consum', 0.0243, 'lps'),
	(661027, 135, '2015-01-15 00:43:59.000000', 'consum', 0.0263, 'lps'),
	(661028, 135, '2015-01-15 00:44:00.000000', 'consum', 0.0229, 'lps'),
	(661029, 135, '2015-01-15 00:44:01.000000', 'consum', 0.0219, 'lps'),
	(661030, 135, '2015-01-15 00:44:02.000000', 'consum', 0.0275, 'lps'),
	(661031, 135, '2015-01-15 00:44:03.000000', 'consum', 0.0213, 'lps'),
	(661032, 135, '2015-01-15 00:44:04.000000', 'consum', 0.0250, 'lps'),
	(661033, 135, '2015-01-15 00:44:05.000000', 'consum', 0.0253, 'lps'),
	(661034, 135, '2015-01-15 00:44:06.000000', 'consum', 0.0232, 'lps'),
	(661035, 135, '2015-01-15 00:44:07.000000', 'consum', 0.0265, 'lps'),
	(661036, 135, '2015-01-15 00:44:08.000000', 'consum', 0.0274, 'lps'),
	(661037, 135, '2015-01-15 00:44:09.000000', 'consum', 0.0214, 'lps'),
	(661038, 135, '2015-01-15 00:44:10.000000', 'consum', 0.0263, 'lps'),
	(661039, 135, '2015-01-15 00:44:11.000000', 'consum', 0.0239, 'lps'),
	(661040, 135, '2015-01-15 00:44:12.000000', 'consum', 0.0273, 'lps'),
	(661041, 135, '2015-01-15 00:44:13.000000', 'consum', 0.0217, 'lps'),
	(661042, 135, '2015-01-15 00:44:14.000000', 'consum', 0.0278, 'lps'),
	(661043, 135, '2015-01-15 00:44:15.000000', 'consum', 0.0231, 'lps'),
	(661044, 135, '2015-01-15 00:44:16.000000', 'consum', 0.0261, 'lps'),
	(661045, 135, '2015-01-15 00:44:17.000000', 'consum', 0.0256, 'lps'),
	(661046, 135, '2015-01-15 00:44:18.000000', 'consum', 0.0211, 'lps'),
	(661047, 135, '2015-01-15 00:44:19.000000', 'consum', 0.0229, 'lps'),
	(661048, 135, '2015-01-15 00:44:20.000000', 'consum', 0.0225, 'lps'),
	(661049, 135, '2015-01-15 00:44:21.000000', 'consum', 0.0228, 'lps'),
	(661050, 135, '2015-01-15 00:44:22.000000', 'consum', 0.0257, 'lps'),
	(661051, 135, '2015-01-15 00:44:23.000000', 'consum', 0.0245, 'lps'),
	(661052, 135, '2015-01-15 00:44:24.000000', 'consum', 0.0243, 'lps'),
	(661053, 135, '2015-01-15 00:44:25.000000', 'consum', 0.0269, 'lps'),
	(661054, 135, '2015-01-15 00:44:26.000000', 'consum', 0.0258, 'lps'),
	(661055, 135, '2015-01-15 00:44:27.000000', 'consum', 0.0274, 'lps'),
	(661056, 135, '2015-01-15 00:44:28.000000', 'consum', 0.0240, 'lps'),
	(661057, 135, '2015-01-15 00:44:29.000000', 'consum', 0.0242, 'lps'),
	(661058, 135, '2015-01-15 00:44:30.000000', 'consum', 0.0281, 'lps'),
	(661059, 135, '2015-01-15 00:44:31.000000', 'consum', 0.0245, 'lps'),
	(661060, 135, '2015-01-15 00:44:32.000000', 'consum', 0.0249, 'lps'),
	(661061, 135, '2015-01-15 00:44:33.000000', 'consum', 0.0227, 'lps'),
	(661062, 135, '2015-01-15 00:44:34.000000', 'consum', 0.0250, 'lps'),
	(661063, 135, '2015-01-15 00:44:35.000000', 'consum', 0.0214, 'lps'),
	(661064, 135, '2015-01-15 00:44:36.000000', 'consum', 0.0257, 'lps'),
	(661065, 135, '2015-01-15 00:44:37.000000', 'consum', 0.0214, 'lps'),
	(661066, 135, '2015-01-15 00:44:38.000000', 'consum', 0.0235, 'lps'),
	(661067, 135, '2015-01-15 00:44:39.000000', 'consum', 0.0252, 'lps'),
	(661068, 135, '2015-01-15 00:44:40.000000', 'consum', 0.0270, 'lps'),
	(661069, 135, '2015-01-15 00:44:41.000000', 'consum', 0.0239, 'lps'),
	(661070, 135, '2015-01-15 00:44:42.000000', 'consum', 0.0246, 'lps'),
	(661071, 135, '2015-01-15 00:44:43.000000', 'consum', 0.0231, 'lps'),
	(661072, 135, '2015-01-15 00:44:44.000000', 'consum', 0.0280, 'lps'),
	(661073, 135, '2015-01-15 00:44:45.000000', 'consum', 0.0276, 'lps'),
	(661074, 135, '2015-01-15 00:44:46.000000', 'consum', 0.0256, 'lps'),
	(661075, 135, '2015-01-15 00:44:47.000000', 'consum', 0.0244, 'lps'),
	(661076, 135, '2015-01-15 00:44:48.000000', 'consum', 0.0240, 'lps'),
	(661077, 135, '2015-01-15 00:44:49.000000', 'consum', 0.0259, 'lps'),
	(661078, 135, '2015-01-15 00:44:50.000000', 'consum', 0.0218, 'lps'),
	(661079, 135, '2015-01-15 00:44:51.000000', 'consum', 0.0252, 'lps'),
	(661080, 135, '2015-01-15 00:44:52.000000', 'consum', 0.0247, 'lps'),
	(661081, 135, '2015-01-15 00:44:53.000000', 'consum', 0.0269, 'lps'),
	(661082, 135, '2015-01-15 00:44:54.000000', 'consum', 0.0249, 'lps'),
	(661083, 135, '2015-01-15 00:44:55.000000', 'consum', 0.0228, 'lps'),
	(661084, 135, '2015-01-15 00:44:56.000000', 'consum', 0.0258, 'lps'),
	(661085, 135, '2015-01-15 00:44:57.000000', 'consum', 0.0249, 'lps'),
	(661086, 135, '2015-01-15 00:44:58.000000', 'consum', 0.0259, 'lps'),
	(661087, 135, '2015-01-15 00:44:59.000000', 'consum', 0.0265, 'lps'),
	(661088, 135, '2015-01-15 00:45:00.000000', 'consum', 0.0265, 'lps'),
	(661089, 135, '2015-01-15 00:45:01.000000', 'consum', 0.0246, 'lps'),
	(661090, 135, '2015-01-15 00:45:02.000000', 'consum', 0.0225, 'lps'),
	(661091, 135, '2015-01-15 00:45:03.000000', 'consum', 0.0252, 'lps'),
	(661092, 135, '2015-01-15 00:45:04.000000', 'consum', 0.0227, 'lps'),
	(661093, 135, '2015-01-15 00:45:05.000000', 'consum', 0.0246, 'lps'),
	(661094, 135, '2015-01-15 00:45:06.000000', 'consum', 0.0263, 'lps'),
	(661095, 135, '2015-01-15 00:45:07.000000', 'consum', 0.0221, 'lps'),
	(661096, 135, '2015-01-15 00:45:08.000000', 'consum', 0.0254, 'lps'),
	(661097, 135, '2015-01-15 00:45:09.000000', 'consum', 0.0250, 'lps'),
	(661098, 135, '2015-01-15 00:45:10.000000', 'consum', 0.0277, 'lps'),
	(661099, 135, '2015-01-15 00:45:11.000000', 'consum', 0.0278, 'lps'),
	(661100, 135, '2015-01-15 00:45:12.000000', 'consum', 0.0278, 'lps'),
	(661101, 135, '2015-01-15 00:45:13.000000', 'consum', 0.0270, 'lps'),
	(661102, 135, '2015-01-15 00:45:14.000000', 'consum', 0.0234, 'lps'),
	(661103, 135, '2015-01-15 00:45:15.000000', 'consum', 0.0223, 'lps'),
	(661104, 135, '2015-01-15 00:45:16.000000', 'consum', 0.0277, 'lps'),
	(661105, 135, '2015-01-15 00:45:17.000000', 'consum', 0.0210, 'lps'),
	(661106, 135, '2015-01-15 00:45:18.000000', 'consum', 0.0231, 'lps'),
	(661107, 135, '2015-01-15 00:45:19.000000', 'consum', 0.0243, 'lps'),
	(661108, 135, '2015-01-15 00:45:20.000000', 'consum', 0.0240, 'lps'),
	(661109, 135, '2015-01-15 00:45:21.000000', 'consum', 0.0261, 'lps'),
	(661110, 135, '2015-01-15 00:45:22.000000', 'consum', 0.0227, 'lps'),
	(661111, 135, '2015-01-15 00:45:23.000000', 'consum', 0.0215, 'lps'),
	(661112, 135, '2015-01-15 00:45:24.000000', 'consum', 0.0260, 'lps'),
	(661113, 135, '2015-01-15 00:45:25.000000', 'consum', 0.0223, 'lps'),
	(661114, 135, '2015-01-15 00:45:26.000000', 'consum', 0.0276, 'lps'),
	(661115, 135, '2015-01-15 00:45:27.000000', 'consum', 0.0276, 'lps'),
	(661116, 135, '2015-01-15 00:45:28.000000', 'consum', 0.0270, 'lps'),
	(661117, 135, '2015-01-15 00:45:29.000000', 'consum', 0.0238, 'lps'),
	(661118, 135, '2015-01-15 00:45:30.000000', 'consum', 0.0243, 'lps'),
	(661119, 135, '2015-01-15 00:45:31.000000', 'consum', 0.0220, 'lps'),
	(661120, 135, '2015-01-15 00:45:32.000000', 'consum', 0.0234, 'lps'),
	(661121, 135, '2015-01-15 00:45:33.000000', 'consum', 0.0228, 'lps'),
	(661122, 135, '2015-01-15 00:45:34.000000', 'consum', 0.0226, 'lps'),
	(661123, 135, '2015-01-15 00:45:35.000000', 'consum', 0.0239, 'lps'),
	(661124, 135, '2015-01-15 00:45:36.000000', 'consum', 0.0231, 'lps'),
	(661125, 135, '2015-01-15 00:45:37.000000', 'consum', 0.0230, 'lps'),
	(661126, 135, '2015-01-15 00:45:38.000000', 'consum', 0.0247, 'lps'),
	(661127, 135, '2015-01-15 00:45:39.000000', 'consum', 0.0263, 'lps'),
	(661128, 135, '2015-01-15 00:45:40.000000', 'consum', 0.0216, 'lps'),
	(661129, 135, '2015-01-15 00:45:41.000000', 'consum', 0.0227, 'lps'),
	(661130, 135, '2015-01-15 00:45:42.000000', 'consum', 0.0279, 'lps'),
	(661131, 135, '2015-01-15 00:45:43.000000', 'consum', 0.0210, 'lps'),
	(661132, 135, '2015-01-15 00:45:44.000000', 'consum', 0.0224, 'lps'),
	(661133, 135, '2015-01-15 00:45:45.000000', 'consum', 0.0279, 'lps'),
	(661134, 135, '2015-01-15 00:45:46.000000', 'consum', 0.0218, 'lps'),
	(661135, 135, '2015-01-15 00:45:47.000000', 'consum', 0.0267, 'lps'),
	(661136, 135, '2015-01-15 00:45:48.000000', 'consum', 0.0249, 'lps'),
	(661137, 135, '2015-01-15 00:45:49.000000', 'consum', 0.0233, 'lps'),
	(661138, 135, '2015-01-15 00:45:50.000000', 'consum', 0.0210, 'lps'),
	(661139, 135, '2015-01-15 00:45:51.000000', 'consum', 0.0217, 'lps'),
	(661140, 135, '2015-01-15 00:45:52.000000', 'consum', 0.0245, 'lps'),
	(661141, 135, '2015-01-15 00:45:53.000000', 'consum', 0.0214, 'lps'),
	(661142, 135, '2015-01-15 00:45:54.000000', 'consum', 0.0276, 'lps'),
	(661143, 135, '2015-01-15 00:45:55.000000', 'consum', 0.0232, 'lps'),
	(661144, 135, '2015-01-15 00:45:56.000000', 'consum', 0.0270, 'lps'),
	(661145, 135, '2015-01-15 00:45:57.000000', 'consum', 0.0223, 'lps'),
	(661146, 135, '2015-01-15 00:45:58.000000', 'consum', 0.0245, 'lps'),
	(661147, 135, '2015-01-15 00:45:59.000000', 'consum', 0.0272, 'lps'),
	(661148, 135, '2015-01-15 00:46:00.000000', 'consum', 0.0265, 'lps'),
	(661149, 135, '2015-01-15 00:46:01.000000', 'consum', 0.0227, 'lps'),
	(661150, 135, '2015-01-15 00:46:02.000000', 'consum', 0.0280, 'lps'),
	(661151, 135, '2015-01-15 00:46:03.000000', 'consum', 0.0213, 'lps'),
	(661152, 135, '2015-01-15 00:46:04.000000', 'consum', 0.0236, 'lps'),
	(661153, 135, '2015-01-15 00:46:05.000000', 'consum', 0.0257, 'lps'),
	(661154, 135, '2015-01-15 00:46:06.000000', 'consum', 0.0219, 'lps'),
	(661155, 135, '2015-01-15 00:46:07.000000', 'consum', 0.0263, 'lps'),
	(661156, 135, '2015-01-15 00:46:08.000000', 'consum', 0.0227, 'lps'),
	(661157, 135, '2015-01-15 00:46:09.000000', 'consum', 0.0283, 'lps'),
	(661158, 135, '2015-01-15 00:46:10.000000', 'consum', 0.0227, 'lps'),
	(661159, 135, '2015-01-15 00:46:11.000000', 'consum', 0.0228, 'lps'),
	(661160, 135, '2015-01-15 00:46:12.000000', 'consum', 0.0248, 'lps'),
	(661161, 135, '2015-01-15 00:46:13.000000', 'consum', 0.0273, 'lps'),
	(661162, 135, '2015-01-15 00:46:14.000000', 'consum', 0.0264, 'lps'),
	(661163, 135, '2015-01-15 00:46:15.000000', 'consum', 0.0215, 'lps'),
	(661164, 135, '2015-01-15 00:46:16.000000', 'consum', 0.0225, 'lps'),
	(661165, 135, '2015-01-15 00:46:17.000000', 'consum', 0.0269, 'lps'),
	(661166, 135, '2015-01-15 00:46:18.000000', 'consum', 0.0239, 'lps'),
	(661167, 135, '2015-01-15 00:46:19.000000', 'consum', 0.0252, 'lps'),
	(661168, 135, '2015-01-15 00:46:20.000000', 'consum', 0.0261, 'lps'),
	(661169, 135, '2015-01-15 00:46:21.000000', 'consum', 0.0265, 'lps'),
	(661170, 135, '2015-01-15 00:46:22.000000', 'consum', 0.0257, 'lps'),
	(661171, 135, '2015-01-15 00:46:23.000000', 'consum', 0.0279, 'lps'),
	(661172, 135, '2015-01-15 00:46:24.000000', 'consum', 0.0270, 'lps'),
	(661173, 135, '2015-01-15 00:46:25.000000', 'consum', 0.0228, 'lps'),
	(661174, 135, '2015-01-15 00:46:26.000000', 'consum', 0.0268, 'lps'),
	(661175, 135, '2015-01-15 00:46:27.000000', 'consum', 0.0224, 'lps'),
	(661176, 135, '2015-01-15 00:46:28.000000', 'consum', 0.0254, 'lps'),
	(661177, 135, '2015-01-15 00:46:29.000000', 'consum', 0.0240, 'lps'),
	(661178, 135, '2015-01-15 00:46:30.000000', 'consum', 0.0231, 'lps'),
	(661179, 135, '2015-01-15 00:46:31.000000', 'consum', 0.0225, 'lps'),
	(661180, 135, '2015-01-15 00:46:32.000000', 'consum', 0.0221, 'lps'),
	(661181, 135, '2015-01-15 00:46:33.000000', 'consum', 0.0222, 'lps'),
	(661182, 135, '2015-01-15 00:46:34.000000', 'consum', 0.0235, 'lps'),
	(661183, 135, '2015-01-15 00:46:35.000000', 'consum', 0.0228, 'lps'),
	(661184, 135, '2015-01-15 00:46:36.000000', 'consum', 0.0224, 'lps'),
	(661185, 135, '2015-01-15 00:46:37.000000', 'consum', 0.0229, 'lps'),
	(661186, 135, '2015-01-15 00:46:38.000000', 'consum', 0.0262, 'lps'),
	(661187, 135, '2015-01-15 00:46:39.000000', 'consum', 0.0267, 'lps'),
	(661188, 135, '2015-01-15 00:46:40.000000', 'consum', 0.0263, 'lps'),
	(661189, 135, '2015-01-15 00:46:41.000000', 'consum', 0.0230, 'lps'),
	(661190, 135, '2015-01-15 00:46:42.000000', 'consum', 0.0227, 'lps'),
	(661191, 135, '2015-01-15 00:46:43.000000', 'consum', 0.0236, 'lps'),
	(661192, 135, '2015-01-15 00:46:44.000000', 'consum', 0.0216, 'lps'),
	(661193, 135, '2015-01-15 00:46:45.000000', 'consum', 0.0236, 'lps'),
	(661194, 135, '2015-01-15 00:46:46.000000', 'consum', 0.0248, 'lps'),
	(661195, 135, '2015-01-15 00:46:47.000000', 'consum', 0.0247, 'lps'),
	(661196, 135, '2015-01-15 00:46:48.000000', 'consum', 0.0283, 'lps'),
	(661197, 135, '2015-01-15 00:46:49.000000', 'consum', 0.0242, 'lps'),
	(661198, 135, '2015-01-15 00:46:50.000000', 'consum', 0.0225, 'lps'),
	(661199, 135, '2015-01-15 00:46:51.000000', 'consum', 0.0262, 'lps'),
	(661200, 135, '2015-01-15 00:46:52.000000', 'consum', 0.0280, 'lps'),
	(661201, 135, '2015-01-15 00:46:53.000000', 'consum', 0.0255, 'lps'),
	(661202, 135, '2015-01-15 00:46:54.000000', 'consum', 0.0227, 'lps'),
	(661203, 135, '2015-01-15 00:46:55.000000', 'consum', 0.0235, 'lps'),
	(661204, 135, '2015-01-15 00:46:56.000000', 'consum', 0.0282, 'lps'),
	(661205, 135, '2015-01-15 00:46:57.000000', 'consum', 0.0274, 'lps'),
	(661206, 135, '2015-01-15 00:46:58.000000', 'consum', 0.0239, 'lps'),
	(661207, 135, '2015-01-15 00:46:59.000000', 'consum', 0.0241, 'lps'),
	(661208, 135, '2015-01-15 00:47:00.000000', 'consum', 0.0275, 'lps'),
	(661209, 135, '2015-01-15 00:47:01.000000', 'consum', 0.0222, 'lps'),
	(661210, 135, '2015-01-15 00:47:02.000000', 'consum', 0.0225, 'lps'),
	(661211, 135, '2015-01-15 00:47:03.000000', 'consum', 0.0246, 'lps'),
	(661212, 135, '2015-01-15 00:47:04.000000', 'consum', 0.0275, 'lps'),
	(661213, 135, '2015-01-15 00:47:05.000000', 'consum', 0.0277, 'lps'),
	(661214, 135, '2015-01-15 00:47:06.000000', 'consum', 0.0277, 'lps'),
	(661215, 135, '2015-01-15 00:47:07.000000', 'consum', 0.0272, 'lps'),
	(661216, 135, '2015-01-15 00:47:08.000000', 'consum', 0.0244, 'lps'),
	(661217, 135, '2015-01-15 00:47:09.000000', 'consum', 0.0268, 'lps'),
	(661218, 135, '2015-01-15 00:47:10.000000', 'consum', 0.0251, 'lps'),
	(661219, 135, '2015-01-15 00:47:11.000000', 'consum', 0.0243, 'lps'),
	(661220, 135, '2015-01-15 00:47:12.000000', 'consum', 0.0253, 'lps'),
	(661221, 135, '2015-01-15 00:47:13.000000', 'consum', 0.0252, 'lps'),
	(661222, 135, '2015-01-15 00:47:14.000000', 'consum', 0.0217, 'lps'),
	(661223, 135, '2015-01-15 00:47:15.000000', 'consum', 0.0267, 'lps'),
	(661224, 135, '2015-01-15 00:47:16.000000', 'consum', 0.0253, 'lps'),
	(661225, 135, '2015-01-15 00:47:17.000000', 'consum', 0.0255, 'lps'),
	(661226, 135, '2015-01-15 00:47:18.000000', 'consum', 0.0234, 'lps'),
	(661227, 135, '2015-01-15 00:47:19.000000', 'consum', 0.0269, 'lps'),
	(661228, 135, '2015-01-15 00:47:20.000000', 'consum', 0.0283, 'lps'),
	(661229, 135, '2015-01-15 00:47:21.000000', 'consum', 0.0253, 'lps'),
	(661230, 135, '2015-01-15 00:47:22.000000', 'consum', 0.0281, 'lps'),
	(661231, 135, '2015-01-15 00:47:23.000000', 'consum', 0.0211, 'lps'),
	(661232, 135, '2015-01-15 00:47:24.000000', 'consum', 0.0228, 'lps'),
	(661233, 135, '2015-01-15 00:47:25.000000', 'consum', 0.0224, 'lps'),
	(661234, 135, '2015-01-15 00:47:26.000000', 'consum', 0.0225, 'lps'),
	(661235, 135, '2015-01-15 00:47:27.000000', 'consum', 0.0243, 'lps'),
	(661236, 135, '2015-01-15 00:47:28.000000', 'consum', 0.0257, 'lps'),
	(661237, 135, '2015-01-15 00:47:29.000000', 'consum', 0.0274, 'lps'),
	(661238, 135, '2015-01-15 00:47:30.000000', 'consum', 0.0242, 'lps'),
	(661239, 135, '2015-01-15 00:47:31.000000', 'consum', 0.0250, 'lps'),
	(661240, 135, '2015-01-15 00:47:32.000000', 'consum', 0.0242, 'lps'),
	(661241, 135, '2015-01-15 00:47:33.000000', 'consum', 0.0249, 'lps'),
	(661242, 135, '2015-01-15 00:47:34.000000', 'consum', 0.0234, 'lps'),
	(661243, 135, '2015-01-15 00:47:35.000000', 'consum', 0.0217, 'lps'),
	(661244, 135, '2015-01-15 00:47:36.000000', 'consum', 0.0244, 'lps'),
	(661245, 135, '2015-01-15 00:47:37.000000', 'consum', 0.0214, 'lps'),
	(661246, 135, '2015-01-15 00:47:38.000000', 'consum', 0.0278, 'lps'),
	(661247, 135, '2015-01-15 00:47:39.000000', 'consum', 0.0239, 'lps'),
	(661248, 135, '2015-01-15 00:47:40.000000', 'consum', 0.0227, 'lps'),
	(661249, 135, '2015-01-15 00:47:41.000000', 'consum', 0.0282, 'lps'),
	(661250, 135, '2015-01-15 00:47:42.000000', 'consum', 0.0223, 'lps'),
	(661251, 135, '2015-01-15 00:47:43.000000', 'consum', 0.0281, 'lps'),
	(661252, 135, '2015-01-15 00:47:44.000000', 'consum', 0.0231, 'lps'),
	(661253, 135, '2015-01-15 00:47:45.000000', 'consum', 0.0250, 'lps'),
	(661254, 135, '2015-01-15 00:47:46.000000', 'consum', 0.0274, 'lps'),
	(661255, 135, '2015-01-15 00:47:47.000000', 'consum', 0.0263, 'lps'),
	(661256, 135, '2015-01-15 00:47:48.000000', 'consum', 0.0283, 'lps'),
	(661257, 135, '2015-01-15 00:47:49.000000', 'consum', 0.0269, 'lps'),
	(661258, 135, '2015-01-15 00:47:50.000000', 'consum', 0.0214, 'lps'),
	(661259, 135, '2015-01-15 00:47:51.000000', 'consum', 0.0272, 'lps'),
	(661260, 135, '2015-01-15 00:47:52.000000', 'consum', 0.0216, 'lps'),
	(661261, 135, '2015-01-15 00:47:53.000000', 'consum', 0.0275, 'lps'),
	(661262, 135, '2015-01-15 00:47:54.000000', 'consum', 0.0223, 'lps'),
	(661263, 135, '2015-01-15 00:47:55.000000', 'consum', 0.0227, 'lps'),
	(661264, 135, '2015-01-15 00:47:56.000000', 'consum', 0.0256, 'lps'),
	(661265, 135, '2015-01-15 00:47:57.000000', 'consum', 0.0241, 'lps'),
	(661266, 135, '2015-01-15 00:47:58.000000', 'consum', 0.0228, 'lps'),
	(661267, 135, '2015-01-15 00:47:59.000000', 'consum', 0.0281, 'lps'),
	(661268, 135, '2015-01-15 00:48:00.000000', 'consum', 0.0215, 'lps'),
	(661269, 135, '2015-01-15 00:48:01.000000', 'consum', 0.0245, 'lps'),
	(661270, 135, '2015-01-15 00:48:02.000000', 'consum', 0.0224, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(661271, 135, '2015-01-15 00:48:03.000000', 'consum', 0.0250, 'lps'),
	(661272, 135, '2015-01-15 00:48:04.000000', 'consum', 0.0220, 'lps'),
	(661273, 135, '2015-01-15 00:48:05.000000', 'consum', 0.0213, 'lps'),
	(661274, 135, '2015-01-15 00:48:06.000000', 'consum', 0.0272, 'lps'),
	(661275, 135, '2015-01-15 00:48:07.000000', 'consum', 0.0214, 'lps'),
	(661276, 135, '2015-01-15 00:48:08.000000', 'consum', 0.0268, 'lps'),
	(661277, 135, '2015-01-15 00:48:09.000000', 'consum', 0.0266, 'lps'),
	(661278, 135, '2015-01-15 00:48:10.000000', 'consum', 0.0244, 'lps'),
	(661279, 135, '2015-01-15 00:48:11.000000', 'consum', 0.0283, 'lps'),
	(661280, 135, '2015-01-15 00:48:12.000000', 'consum', 0.0254, 'lps'),
	(661281, 135, '2015-01-15 00:48:13.000000', 'consum', 0.0283, 'lps'),
	(661282, 135, '2015-01-15 00:48:14.000000', 'consum', 0.0224, 'lps'),
	(661283, 135, '2015-01-15 00:48:15.000000', 'consum', 0.0281, 'lps'),
	(661284, 135, '2015-01-15 00:48:16.000000', 'consum', 0.0230, 'lps'),
	(661285, 135, '2015-01-15 00:48:17.000000', 'consum', 0.0245, 'lps'),
	(661286, 135, '2015-01-15 00:48:18.000000', 'consum', 0.0253, 'lps'),
	(661287, 135, '2015-01-15 00:48:19.000000', 'consum', 0.0244, 'lps'),
	(661288, 135, '2015-01-15 00:48:20.000000', 'consum', 0.0253, 'lps'),
	(661289, 135, '2015-01-15 00:48:21.000000', 'consum', 0.0248, 'lps'),
	(661290, 135, '2015-01-15 00:48:22.000000', 'consum', 0.0274, 'lps'),
	(661291, 135, '2015-01-15 00:48:23.000000', 'consum', 0.0267, 'lps'),
	(661292, 135, '2015-01-15 00:48:24.000000', 'consum', 0.0230, 'lps'),
	(661293, 135, '2015-01-15 00:48:25.000000', 'consum', 0.0212, 'lps'),
	(661294, 135, '2015-01-15 00:48:26.000000', 'consum', 0.0236, 'lps'),
	(661295, 135, '2015-01-15 00:48:27.000000', 'consum', 0.0261, 'lps'),
	(661296, 135, '2015-01-15 00:48:28.000000', 'consum', 0.0237, 'lps'),
	(661297, 135, '2015-01-15 00:48:29.000000', 'consum', 0.0267, 'lps'),
	(661298, 135, '2015-01-15 00:48:30.000000', 'consum', 0.0265, 'lps'),
	(661299, 135, '2015-01-15 00:48:31.000000', 'consum', 0.0243, 'lps'),
	(661300, 135, '2015-01-15 00:48:32.000000', 'consum', 0.0212, 'lps'),
	(661301, 135, '2015-01-15 00:48:33.000000', 'consum', 0.0266, 'lps'),
	(661302, 135, '2015-01-15 00:48:34.000000', 'consum', 0.0263, 'lps'),
	(661303, 135, '2015-01-15 00:48:35.000000', 'consum', 0.0235, 'lps'),
	(661304, 135, '2015-01-15 00:48:36.000000', 'consum', 0.0250, 'lps'),
	(661305, 135, '2015-01-15 00:48:37.000000', 'consum', 0.0263, 'lps'),
	(661306, 135, '2015-01-15 00:48:38.000000', 'consum', 0.0281, 'lps'),
	(661307, 135, '2015-01-15 00:48:39.000000', 'consum', 0.0259, 'lps'),
	(661308, 135, '2015-01-15 00:48:40.000000', 'consum', 0.0241, 'lps'),
	(661309, 135, '2015-01-15 00:48:41.000000', 'consum', 0.0217, 'lps'),
	(661310, 135, '2015-01-15 00:48:42.000000', 'consum', 0.0229, 'lps'),
	(661311, 135, '2015-01-15 00:48:43.000000', 'consum', 0.0211, 'lps'),
	(661312, 135, '2015-01-15 00:48:44.000000', 'consum', 0.0232, 'lps'),
	(661313, 135, '2015-01-15 00:48:45.000000', 'consum', 0.0244, 'lps'),
	(661314, 135, '2015-01-15 00:48:46.000000', 'consum', 0.0242, 'lps'),
	(661315, 135, '2015-01-15 00:48:47.000000', 'consum', 0.0266, 'lps'),
	(661316, 135, '2015-01-15 00:48:48.000000', 'consum', 0.0248, 'lps'),
	(661317, 135, '2015-01-15 00:48:49.000000', 'consum', 0.0233, 'lps'),
	(661318, 135, '2015-01-15 00:48:50.000000', 'consum', 0.0211, 'lps'),
	(661319, 135, '2015-01-15 00:48:51.000000', 'consum', 0.0222, 'lps'),
	(661320, 135, '2015-01-15 00:48:52.000000', 'consum', 0.0266, 'lps'),
	(661321, 135, '2015-01-15 00:48:53.000000', 'consum', 0.0232, 'lps'),
	(661322, 135, '2015-01-15 00:48:54.000000', 'consum', 0.0228, 'lps'),
	(661323, 135, '2015-01-15 00:48:55.000000', 'consum', 0.0233, 'lps'),
	(661324, 135, '2015-01-15 00:48:56.000000', 'consum', 0.0273, 'lps'),
	(661325, 135, '2015-01-15 00:48:57.000000', 'consum', 0.0234, 'lps'),
	(661326, 135, '2015-01-15 00:48:58.000000', 'consum', 0.0213, 'lps'),
	(661327, 135, '2015-01-15 00:48:59.000000', 'consum', 0.0231, 'lps'),
	(661328, 135, '2015-01-15 00:49:00.000000', 'consum', 0.0232, 'lps'),
	(661329, 135, '2015-01-15 00:49:01.000000', 'consum', 0.0255, 'lps'),
	(661330, 135, '2015-01-15 00:49:02.000000', 'consum', 0.0223, 'lps'),
	(661331, 135, '2015-01-15 00:49:03.000000', 'consum', 0.0215, 'lps'),
	(661332, 135, '2015-01-15 00:49:04.000000', 'consum', 0.0270, 'lps'),
	(661333, 135, '2015-01-15 00:49:05.000000', 'consum', 0.0275, 'lps'),
	(661334, 135, '2015-01-15 00:49:06.000000', 'consum', 0.0279, 'lps'),
	(661335, 135, '2015-01-15 00:49:07.000000', 'consum', 0.0213, 'lps'),
	(661336, 135, '2015-01-15 00:49:08.000000', 'consum', 0.0240, 'lps'),
	(661337, 135, '2015-01-15 00:49:09.000000', 'consum', 0.0278, 'lps'),
	(661338, 135, '2015-01-15 00:49:10.000000', 'consum', 0.0237, 'lps'),
	(661339, 135, '2015-01-15 00:49:11.000000', 'consum', 0.0216, 'lps'),
	(661340, 135, '2015-01-15 00:49:12.000000', 'consum', 0.0234, 'lps'),
	(661341, 135, '2015-01-15 00:49:13.000000', 'consum', 0.0240, 'lps'),
	(661342, 135, '2015-01-15 00:49:14.000000', 'consum', 0.0215, 'lps'),
	(661343, 135, '2015-01-15 00:49:15.000000', 'consum', 0.0219, 'lps'),
	(661344, 135, '2015-01-15 00:49:16.000000', 'consum', 0.0238, 'lps'),
	(661345, 135, '2015-01-15 00:49:17.000000', 'consum', 0.0252, 'lps'),
	(661346, 135, '2015-01-15 00:49:18.000000', 'consum', 0.0260, 'lps'),
	(661347, 135, '2015-01-15 00:49:19.000000', 'consum', 0.0264, 'lps'),
	(661348, 135, '2015-01-15 00:49:20.000000', 'consum', 0.0253, 'lps'),
	(661349, 135, '2015-01-15 00:49:21.000000', 'consum', 0.0265, 'lps'),
	(661350, 135, '2015-01-15 00:49:22.000000', 'consum', 0.0282, 'lps'),
	(661351, 135, '2015-01-15 00:49:23.000000', 'consum', 0.0257, 'lps'),
	(661352, 135, '2015-01-15 00:49:24.000000', 'consum', 0.0232, 'lps'),
	(661353, 135, '2015-01-15 00:49:25.000000', 'consum', 0.0250, 'lps'),
	(661354, 135, '2015-01-15 00:49:26.000000', 'consum', 0.0272, 'lps'),
	(661355, 135, '2015-01-15 00:49:27.000000', 'consum', 0.0254, 'lps'),
	(661356, 135, '2015-01-15 00:49:28.000000', 'consum', 0.0244, 'lps'),
	(661357, 135, '2015-01-15 00:49:29.000000', 'consum', 0.0248, 'lps'),
	(661358, 135, '2015-01-15 00:49:30.000000', 'consum', 0.0225, 'lps'),
	(661359, 135, '2015-01-15 00:49:31.000000', 'consum', 0.0245, 'lps'),
	(661360, 135, '2015-01-15 00:49:32.000000', 'consum', 0.0266, 'lps'),
	(661361, 135, '2015-01-15 00:49:33.000000', 'consum', 0.0239, 'lps'),
	(661362, 135, '2015-01-15 00:49:34.000000', 'consum', 0.0260, 'lps'),
	(661363, 135, '2015-01-15 00:49:35.000000', 'consum', 0.0226, 'lps'),
	(661364, 135, '2015-01-15 00:49:36.000000', 'consum', 0.0213, 'lps'),
	(661365, 135, '2015-01-15 00:49:37.000000', 'consum', 0.0254, 'lps'),
	(661366, 135, '2015-01-15 00:49:38.000000', 'consum', 0.0271, 'lps'),
	(661367, 135, '2015-01-15 00:49:39.000000', 'consum', 0.0237, 'lps'),
	(661368, 135, '2015-01-15 00:49:40.000000', 'consum', 0.0236, 'lps'),
	(661369, 135, '2015-01-15 00:49:41.000000', 'consum', 0.0260, 'lps'),
	(661370, 135, '2015-01-15 00:49:42.000000', 'consum', 0.0236, 'lps'),
	(661371, 135, '2015-01-15 00:49:43.000000', 'consum', 0.0262, 'lps'),
	(661372, 135, '2015-01-15 00:49:44.000000', 'consum', 0.0245, 'lps'),
	(661373, 135, '2015-01-15 00:49:45.000000', 'consum', 0.0230, 'lps'),
	(661374, 135, '2015-01-15 00:49:46.000000', 'consum', 0.0279, 'lps'),
	(661375, 135, '2015-01-15 00:49:47.000000', 'consum', 0.0273, 'lps'),
	(661376, 135, '2015-01-15 00:49:48.000000', 'consum', 0.0245, 'lps'),
	(661377, 135, '2015-01-15 00:49:49.000000', 'consum', 0.0270, 'lps'),
	(661378, 135, '2015-01-15 00:49:50.000000', 'consum', 0.0258, 'lps'),
	(661379, 135, '2015-01-15 00:49:51.000000', 'consum', 0.0272, 'lps'),
	(661380, 135, '2015-01-15 00:49:52.000000', 'consum', 0.0226, 'lps'),
	(661381, 135, '2015-01-15 00:49:53.000000', 'consum', 0.0252, 'lps'),
	(661382, 135, '2015-01-15 00:49:54.000000', 'consum', 0.0225, 'lps'),
	(661383, 135, '2015-01-15 00:49:55.000000', 'consum', 0.0235, 'lps'),
	(661384, 135, '2015-01-15 00:49:56.000000', 'consum', 0.0215, 'lps'),
	(661385, 135, '2015-01-15 00:49:57.000000', 'consum', 0.0236, 'lps'),
	(661386, 135, '2015-01-15 00:49:58.000000', 'consum', 0.0252, 'lps'),
	(661387, 135, '2015-01-15 00:49:59.000000', 'consum', 0.0269, 'lps'),
	(661388, 135, '2015-01-15 00:50:00.000000', 'consum', 0.0231, 'lps'),
	(661389, 135, '2015-01-15 00:50:01.000000', 'consum', 0.0211, 'lps'),
	(661390, 135, '2015-01-15 00:50:02.000000', 'consum', 0.0228, 'lps'),
	(661391, 135, '2015-01-15 00:50:03.000000', 'consum', 0.0222, 'lps'),
	(661392, 135, '2015-01-15 00:50:04.000000', 'consum', 0.0218, 'lps'),
	(661393, 135, '2015-01-15 00:50:05.000000', 'consum', 0.0215, 'lps'),
	(661394, 135, '2015-01-15 00:50:06.000000', 'consum', 0.0283, 'lps'),
	(661395, 135, '2015-01-15 00:50:07.000000', 'consum', 0.0267, 'lps'),
	(661396, 135, '2015-01-15 00:50:08.000000', 'consum', 0.0276, 'lps'),
	(661397, 135, '2015-01-15 00:50:09.000000', 'consum', 0.0219, 'lps'),
	(661398, 135, '2015-01-15 00:50:10.000000', 'consum', 0.0282, 'lps'),
	(661399, 135, '2015-01-15 00:50:11.000000', 'consum', 0.0248, 'lps'),
	(661400, 135, '2015-01-15 00:50:12.000000', 'consum', 0.0258, 'lps'),
	(661401, 135, '2015-01-15 00:50:13.000000', 'consum', 0.0261, 'lps'),
	(661402, 135, '2015-01-15 00:50:14.000000', 'consum', 0.0250, 'lps'),
	(661403, 135, '2015-01-15 00:50:15.000000', 'consum', 0.0257, 'lps'),
	(661404, 135, '2015-01-15 00:50:16.000000', 'consum', 0.0250, 'lps'),
	(661405, 135, '2015-01-15 00:50:17.000000', 'consum', 0.0269, 'lps'),
	(661406, 135, '2015-01-15 00:50:18.000000', 'consum', 0.0238, 'lps'),
	(661407, 135, '2015-01-15 00:50:19.000000', 'consum', 0.0247, 'lps'),
	(661408, 135, '2015-01-15 00:50:20.000000', 'consum', 0.0236, 'lps'),
	(661409, 135, '2015-01-15 00:50:21.000000', 'consum', 0.0233, 'lps'),
	(661410, 135, '2015-01-15 00:50:22.000000', 'consum', 0.0246, 'lps'),
	(661411, 135, '2015-01-15 00:50:23.000000', 'consum', 0.0246, 'lps'),
	(661412, 135, '2015-01-15 00:50:24.000000', 'consum', 0.0282, 'lps'),
	(661413, 135, '2015-01-15 00:50:25.000000', 'consum', 0.0244, 'lps'),
	(661414, 135, '2015-01-15 00:50:26.000000', 'consum', 0.0235, 'lps'),
	(661415, 135, '2015-01-15 00:50:27.000000', 'consum', 0.0234, 'lps'),
	(661416, 135, '2015-01-15 00:50:28.000000', 'consum', 0.0257, 'lps'),
	(661417, 135, '2015-01-15 00:50:29.000000', 'consum', 0.0224, 'lps'),
	(661418, 135, '2015-01-15 00:50:30.000000', 'consum', 0.0216, 'lps'),
	(661419, 135, '2015-01-15 00:50:31.000000', 'consum', 0.0270, 'lps'),
	(661420, 135, '2015-01-15 00:50:32.000000', 'consum', 0.0273, 'lps'),
	(661421, 135, '2015-01-15 00:50:33.000000', 'consum', 0.0270, 'lps'),
	(661422, 135, '2015-01-15 00:50:34.000000', 'consum', 0.0246, 'lps'),
	(661423, 135, '2015-01-15 00:50:35.000000', 'consum', 0.0210, 'lps'),
	(661424, 135, '2015-01-15 00:50:36.000000', 'consum', 0.0252, 'lps'),
	(661425, 135, '2015-01-15 00:50:37.000000', 'consum', 0.0273, 'lps'),
	(661426, 135, '2015-01-15 00:50:38.000000', 'consum', 0.0253, 'lps'),
	(661427, 135, '2015-01-15 00:50:39.000000', 'consum', 0.0235, 'lps'),
	(661428, 135, '2015-01-15 00:50:40.000000', 'consum', 0.0282, 'lps'),
	(661429, 135, '2015-01-15 00:50:41.000000', 'consum', 0.0271, 'lps'),
	(661430, 135, '2015-01-15 00:50:42.000000', 'consum', 0.0226, 'lps'),
	(661431, 135, '2015-01-15 00:50:43.000000', 'consum', 0.0258, 'lps'),
	(661432, 135, '2015-01-15 00:50:44.000000', 'consum', 0.0252, 'lps'),
	(661433, 135, '2015-01-15 00:50:45.000000', 'consum', 0.0279, 'lps'),
	(661434, 135, '2015-01-15 00:50:46.000000', 'consum', 0.0282, 'lps'),
	(661435, 135, '2015-01-15 00:50:47.000000', 'consum', 0.0213, 'lps'),
	(661436, 135, '2015-01-15 00:50:48.000000', 'consum', 0.0233, 'lps'),
	(661437, 135, '2015-01-15 00:50:49.000000', 'consum', 0.0241, 'lps'),
	(661438, 135, '2015-01-15 00:50:50.000000', 'consum', 0.0223, 'lps'),
	(661439, 135, '2015-01-15 00:50:51.000000', 'consum', 0.0258, 'lps'),
	(661440, 135, '2015-01-15 00:50:52.000000', 'consum', 0.0261, 'lps'),
	(661441, 135, '2015-01-15 00:50:53.000000', 'consum', 0.0247, 'lps'),
	(661442, 135, '2015-01-15 00:50:54.000000', 'consum', 0.0242, 'lps'),
	(661443, 135, '2015-01-15 00:50:55.000000', 'consum', 0.0260, 'lps'),
	(661444, 135, '2015-01-15 00:50:56.000000', 'consum', 0.0219, 'lps'),
	(661445, 135, '2015-01-15 00:50:57.000000', 'consum', 0.0251, 'lps'),
	(661446, 135, '2015-01-15 00:50:58.000000', 'consum', 0.0239, 'lps'),
	(661447, 135, '2015-01-15 00:50:59.000000', 'consum', 0.0235, 'lps'),
	(661448, 135, '2015-01-15 00:51:00.000000', 'consum', 0.0246, 'lps'),
	(661449, 135, '2015-01-15 00:51:01.000000', 'consum', 0.0245, 'lps'),
	(661450, 135, '2015-01-15 00:51:02.000000', 'consum', 0.0274, 'lps'),
	(661451, 135, '2015-01-15 00:51:03.000000', 'consum', 0.0279, 'lps'),
	(661452, 135, '2015-01-15 00:51:04.000000', 'consum', 0.0214, 'lps'),
	(661453, 135, '2015-01-15 00:51:05.000000', 'consum', 0.0245, 'lps'),
	(661454, 135, '2015-01-15 00:51:06.000000', 'consum', 0.0224, 'lps'),
	(661455, 135, '2015-01-15 00:51:07.000000', 'consum', 0.0253, 'lps'),
	(661456, 135, '2015-01-15 00:51:08.000000', 'consum', 0.0235, 'lps'),
	(661457, 135, '2015-01-15 00:51:09.000000', 'consum', 0.0280, 'lps'),
	(661458, 135, '2015-01-15 00:51:10.000000', 'consum', 0.0263, 'lps'),
	(661459, 135, '2015-01-15 00:51:11.000000', 'consum', 0.0268, 'lps'),
	(661460, 135, '2015-01-15 00:51:12.000000', 'consum', 0.0265, 'lps'),
	(661461, 135, '2015-01-15 00:51:13.000000', 'consum', 0.0240, 'lps'),
	(661462, 135, '2015-01-15 00:51:14.000000', 'consum', 0.0267, 'lps'),
	(661463, 135, '2015-01-15 00:51:15.000000', 'consum', 0.0258, 'lps'),
	(661464, 135, '2015-01-15 00:51:16.000000', 'consum', 0.0282, 'lps'),
	(661465, 135, '2015-01-15 00:51:17.000000', 'consum', 0.0276, 'lps'),
	(661466, 135, '2015-01-15 00:51:18.000000', 'consum', 0.0252, 'lps'),
	(661467, 135, '2015-01-15 00:51:19.000000', 'consum', 0.0221, 'lps'),
	(661468, 135, '2015-01-15 00:51:20.000000', 'consum', 0.0214, 'lps'),
	(661469, 135, '2015-01-15 00:51:21.000000', 'consum', 0.0270, 'lps'),
	(661470, 135, '2015-01-15 00:51:22.000000', 'consum', 0.0276, 'lps'),
	(661471, 135, '2015-01-15 00:51:23.000000', 'consum', 0.0215, 'lps'),
	(661472, 135, '2015-01-15 00:51:24.000000', 'consum', 0.0258, 'lps'),
	(661473, 135, '2015-01-15 00:51:25.000000', 'consum', 0.0212, 'lps'),
	(661474, 135, '2015-01-15 00:51:26.000000', 'consum', 0.0225, 'lps'),
	(661475, 135, '2015-01-15 00:51:27.000000', 'consum', 0.0281, 'lps'),
	(661476, 135, '2015-01-15 00:51:28.000000', 'consum', 0.0226, 'lps'),
	(661477, 135, '2015-01-15 00:51:29.000000', 'consum', 0.0223, 'lps'),
	(661478, 135, '2015-01-15 00:51:30.000000', 'consum', 0.0226, 'lps'),
	(661479, 135, '2015-01-15 00:51:31.000000', 'consum', 0.0253, 'lps'),
	(661480, 135, '2015-01-15 00:51:32.000000', 'consum', 0.0231, 'lps'),
	(661481, 135, '2015-01-15 00:51:33.000000', 'consum', 0.0259, 'lps'),
	(661482, 135, '2015-01-15 00:51:34.000000', 'consum', 0.0245, 'lps'),
	(661483, 135, '2015-01-15 00:51:35.000000', 'consum', 0.0239, 'lps'),
	(661484, 135, '2015-01-15 00:51:36.000000', 'consum', 0.0250, 'lps'),
	(661485, 135, '2015-01-15 00:51:37.000000', 'consum', 0.0251, 'lps'),
	(661486, 135, '2015-01-15 00:51:38.000000', 'consum', 0.0222, 'lps'),
	(661487, 135, '2015-01-15 00:51:39.000000', 'consum', 0.0221, 'lps'),
	(661488, 135, '2015-01-15 00:51:40.000000', 'consum', 0.0227, 'lps'),
	(661489, 135, '2015-01-15 00:51:41.000000', 'consum', 0.0266, 'lps'),
	(661490, 135, '2015-01-15 00:51:42.000000', 'consum', 0.0214, 'lps'),
	(661491, 135, '2015-01-15 00:51:43.000000', 'consum', 0.0213, 'lps'),
	(661492, 135, '2015-01-15 00:51:44.000000', 'consum', 0.0214, 'lps'),
	(661493, 135, '2015-01-15 00:51:45.000000', 'consum', 0.0220, 'lps'),
	(661494, 135, '2015-01-15 00:51:46.000000', 'consum', 0.0249, 'lps'),
	(661495, 135, '2015-01-15 00:51:47.000000', 'consum', 0.0227, 'lps'),
	(661496, 135, '2015-01-15 00:51:48.000000', 'consum', 0.0254, 'lps'),
	(661497, 135, '2015-01-15 00:51:49.000000', 'consum', 0.0229, 'lps'),
	(661498, 135, '2015-01-15 00:51:50.000000', 'consum', 0.0249, 'lps'),
	(661499, 135, '2015-01-15 00:51:51.000000', 'consum', 0.0274, 'lps'),
	(661500, 135, '2015-01-15 00:51:52.000000', 'consum', 0.0267, 'lps'),
	(661501, 135, '2015-01-15 00:51:53.000000', 'consum', 0.0230, 'lps'),
	(661502, 135, '2015-01-15 00:51:54.000000', 'consum', 0.0211, 'lps'),
	(661503, 135, '2015-01-15 00:51:55.000000', 'consum', 0.0229, 'lps'),
	(661504, 135, '2015-01-15 00:51:56.000000', 'consum', 0.0230, 'lps'),
	(661505, 135, '2015-01-15 00:51:57.000000', 'consum', 0.0254, 'lps'),
	(661506, 135, '2015-01-15 00:51:58.000000', 'consum', 0.0224, 'lps'),
	(661507, 135, '2015-01-15 00:51:59.000000', 'consum', 0.0221, 'lps'),
	(661508, 135, '2015-01-15 00:52:00.000000', 'consum', 0.0221, 'lps'),
	(661509, 135, '2015-01-15 00:52:01.000000', 'consum', 0.0236, 'lps'),
	(661510, 135, '2015-01-15 00:52:02.000000', 'consum', 0.0233, 'lps'),
	(661511, 135, '2015-01-15 00:52:03.000000', 'consum', 0.0247, 'lps'),
	(661512, 135, '2015-01-15 00:52:04.000000', 'consum', 0.0252, 'lps'),
	(661513, 135, '2015-01-15 00:52:05.000000', 'consum', 0.0237, 'lps'),
	(661514, 135, '2015-01-15 00:52:06.000000', 'consum', 0.0217, 'lps'),
	(661515, 135, '2015-01-15 00:52:07.000000', 'consum', 0.0241, 'lps'),
	(661516, 135, '2015-01-15 00:52:08.000000', 'consum', 0.0269, 'lps'),
	(661517, 135, '2015-01-15 00:52:09.000000', 'consum', 0.0264, 'lps'),
	(661518, 135, '2015-01-15 00:52:10.000000', 'consum', 0.0229, 'lps'),
	(661519, 135, '2015-01-15 00:52:11.000000', 'consum', 0.0219, 'lps'),
	(661520, 135, '2015-01-15 00:52:12.000000', 'consum', 0.0274, 'lps'),
	(661521, 135, '2015-01-15 00:52:13.000000', 'consum', 0.0278, 'lps'),
	(661522, 135, '2015-01-15 00:52:14.000000', 'consum', 0.0213, 'lps'),
	(661523, 135, '2015-01-15 00:52:15.000000', 'consum', 0.0244, 'lps'),
	(661524, 135, '2015-01-15 00:52:16.000000', 'consum', 0.0222, 'lps'),
	(661525, 135, '2015-01-15 00:52:17.000000', 'consum', 0.0244, 'lps'),
	(661526, 135, '2015-01-15 00:52:18.000000', 'consum', 0.0268, 'lps'),
	(661527, 135, '2015-01-15 00:52:19.000000', 'consum', 0.0253, 'lps'),
	(661528, 135, '2015-01-15 00:52:20.000000', 'consum', 0.0253, 'lps'),
	(661529, 135, '2015-01-15 00:52:21.000000', 'consum', 0.0219, 'lps'),
	(661530, 135, '2015-01-15 00:52:22.000000', 'consum', 0.0276, 'lps'),
	(661531, 135, '2015-01-15 00:52:23.000000', 'consum', 0.0217, 'lps'),
	(661532, 135, '2015-01-15 00:52:24.000000', 'consum', 0.0271, 'lps'),
	(661533, 135, '2015-01-15 00:52:25.000000', 'consum', 0.0271, 'lps'),
	(661534, 135, '2015-01-15 00:52:26.000000', 'consum', 0.0258, 'lps'),
	(661535, 135, '2015-01-15 00:52:27.000000', 'consum', 0.0268, 'lps'),
	(661536, 135, '2015-01-15 00:52:28.000000', 'consum', 0.0282, 'lps'),
	(661537, 135, '2015-01-15 00:52:29.000000', 'consum', 0.0247, 'lps'),
	(661538, 135, '2015-01-15 00:52:30.000000', 'consum', 0.0256, 'lps'),
	(661539, 135, '2015-01-15 00:52:31.000000', 'consum', 0.0254, 'lps'),
	(661540, 135, '2015-01-15 00:52:32.000000', 'consum', 0.0219, 'lps'),
	(661541, 135, '2015-01-15 00:52:33.000000', 'consum', 0.0272, 'lps'),
	(661542, 135, '2015-01-15 00:52:34.000000', 'consum', 0.0272, 'lps'),
	(661543, 135, '2015-01-15 00:52:35.000000', 'consum', 0.0259, 'lps'),
	(661544, 135, '2015-01-15 00:52:36.000000', 'consum', 0.0270, 'lps'),
	(661545, 135, '2015-01-15 00:52:37.000000', 'consum', 0.0215, 'lps'),
	(661546, 135, '2015-01-15 00:52:38.000000', 'consum', 0.0280, 'lps'),
	(661547, 135, '2015-01-15 00:52:39.000000', 'consum', 0.0247, 'lps'),
	(661548, 135, '2015-01-15 00:52:40.000000', 'consum', 0.0260, 'lps'),
	(661549, 135, '2015-01-15 00:52:41.000000', 'consum', 0.0276, 'lps'),
	(661550, 135, '2015-01-15 00:52:42.000000', 'consum', 0.0241, 'lps'),
	(661551, 135, '2015-01-15 00:52:43.000000', 'consum', 0.0243, 'lps'),
	(661552, 135, '2015-01-15 00:52:44.000000', 'consum', 0.0282, 'lps'),
	(661553, 135, '2015-01-15 00:52:45.000000', 'consum', 0.0251, 'lps'),
	(661554, 135, '2015-01-15 00:52:46.000000', 'consum', 0.0274, 'lps'),
	(661555, 135, '2015-01-15 00:52:47.000000', 'consum', 0.0257, 'lps'),
	(661556, 135, '2015-01-15 00:52:48.000000', 'consum', 0.0253, 'lps'),
	(661557, 135, '2015-01-15 00:52:49.000000', 'consum', 0.0212, 'lps'),
	(661558, 135, '2015-01-15 00:52:50.000000', 'consum', 0.0239, 'lps'),
	(661559, 135, '2015-01-15 00:52:51.000000', 'consum', 0.0275, 'lps'),
	(661560, 135, '2015-01-15 00:52:52.000000', 'consum', 0.0227, 'lps'),
	(661561, 135, '2015-01-15 00:52:53.000000', 'consum', 0.0248, 'lps'),
	(661562, 135, '2015-01-15 00:52:54.000000', 'consum', 0.0277, 'lps'),
	(661563, 135, '2015-01-15 00:52:55.000000', 'consum', 0.0210, 'lps'),
	(661564, 135, '2015-01-15 00:52:56.000000', 'consum', 0.0230, 'lps'),
	(661565, 135, '2015-01-15 00:52:57.000000', 'consum', 0.0236, 'lps'),
	(661566, 135, '2015-01-15 00:52:58.000000', 'consum', 0.0281, 'lps'),
	(661567, 135, '2015-01-15 00:52:59.000000', 'consum', 0.0266, 'lps'),
	(661568, 135, '2015-01-15 00:53:00.000000', 'consum', 0.0278, 'lps'),
	(661569, 135, '2015-01-15 00:53:01.000000', 'consum', 0.0235, 'lps'),
	(661570, 135, '2015-01-15 00:53:02.000000', 'consum', 0.0280, 'lps'),
	(661571, 135, '2015-01-15 00:53:03.000000', 'consum', 0.0263, 'lps'),
	(661572, 135, '2015-01-15 00:53:04.000000', 'consum', 0.0263, 'lps'),
	(661573, 135, '2015-01-15 00:53:05.000000', 'consum', 0.0245, 'lps'),
	(661574, 135, '2015-01-15 00:53:06.000000', 'consum', 0.0227, 'lps'),
	(661575, 135, '2015-01-15 00:53:07.000000', 'consum', 0.0266, 'lps'),
	(661576, 135, '2015-01-15 00:53:08.000000', 'consum', 0.0215, 'lps'),
	(661577, 135, '2015-01-15 00:53:09.000000', 'consum', 0.0216, 'lps'),
	(661578, 135, '2015-01-15 00:53:10.000000', 'consum', 0.0225, 'lps'),
	(661579, 135, '2015-01-15 00:53:11.000000', 'consum', 0.0270, 'lps'),
	(661580, 135, '2015-01-15 00:53:12.000000', 'consum', 0.0241, 'lps'),
	(661581, 135, '2015-01-15 00:53:13.000000', 'consum', 0.0262, 'lps'),
	(661582, 135, '2015-01-15 00:53:14.000000', 'consum', 0.0226, 'lps'),
	(661583, 135, '2015-01-15 00:53:15.000000', 'consum', 0.0212, 'lps'),
	(661584, 135, '2015-01-15 00:53:16.000000', 'consum', 0.0244, 'lps'),
	(661585, 135, '2015-01-15 00:53:17.000000', 'consum', 0.0226, 'lps'),
	(661586, 135, '2015-01-15 00:53:18.000000', 'consum', 0.0264, 'lps'),
	(661587, 135, '2015-01-15 00:53:19.000000', 'consum', 0.0283, 'lps'),
	(661588, 135, '2015-01-15 00:53:20.000000', 'consum', 0.0267, 'lps'),
	(661589, 135, '2015-01-15 00:53:21.000000', 'consum', 0.0278, 'lps'),
	(661590, 135, '2015-01-15 00:53:22.000000', 'consum', 0.0229, 'lps'),
	(661591, 135, '2015-01-15 00:53:23.000000', 'consum', 0.0252, 'lps'),
	(661592, 135, '2015-01-15 00:53:24.000000', 'consum', 0.0216, 'lps'),
	(661593, 135, '2015-01-15 00:53:25.000000', 'consum', 0.0261, 'lps'),
	(661594, 135, '2015-01-15 00:53:26.000000', 'consum', 0.0225, 'lps'),
	(661595, 135, '2015-01-15 00:53:27.000000', 'consum', 0.0280, 'lps'),
	(661596, 135, '2015-01-15 00:53:28.000000', 'consum', 0.0220, 'lps'),
	(661597, 135, '2015-01-15 00:53:29.000000', 'consum', 0.0273, 'lps'),
	(661598, 135, '2015-01-15 00:53:30.000000', 'consum', 0.0273, 'lps'),
	(661599, 135, '2015-01-15 00:53:31.000000', 'consum', 0.0263, 'lps'),
	(661600, 135, '2015-01-15 00:53:32.000000', 'consum', 0.0212, 'lps'),
	(661601, 135, '2015-01-15 00:53:33.000000', 'consum', 0.0283, 'lps'),
	(661602, 135, '2015-01-15 00:53:34.000000', 'consum', 0.0275, 'lps'),
	(661603, 135, '2015-01-15 00:53:35.000000', 'consum', 0.0243, 'lps'),
	(661604, 135, '2015-01-15 00:53:36.000000', 'consum', 0.0253, 'lps'),
	(661605, 135, '2015-01-15 00:53:37.000000', 'consum', 0.0254, 'lps'),
	(661606, 135, '2015-01-15 00:53:38.000000', 'consum', 0.0226, 'lps'),
	(661607, 135, '2015-01-15 00:53:39.000000', 'consum', 0.0231, 'lps'),
	(661608, 135, '2015-01-15 00:53:40.000000', 'consum', 0.0270, 'lps'),
	(661609, 135, '2015-01-15 00:53:41.000000', 'consum', 0.0224, 'lps'),
	(661610, 135, '2015-01-15 00:53:42.000000', 'consum', 0.0247, 'lps'),
	(661611, 135, '2015-01-15 00:53:43.000000', 'consum', 0.0283, 'lps'),
	(661612, 135, '2015-01-15 00:53:44.000000', 'consum', 0.0240, 'lps'),
	(661613, 135, '2015-01-15 00:53:45.000000', 'consum', 0.0216, 'lps'),
	(661614, 135, '2015-01-15 00:53:46.000000', 'consum', 0.0226, 'lps'),
	(661615, 135, '2015-01-15 00:53:47.000000', 'consum', 0.0273, 'lps'),
	(661616, 135, '2015-01-15 00:53:48.000000', 'consum', 0.0255, 'lps'),
	(661617, 135, '2015-01-15 00:53:49.000000', 'consum', 0.0245, 'lps'),
	(661618, 135, '2015-01-15 00:53:50.000000', 'consum', 0.0253, 'lps'),
	(661619, 135, '2015-01-15 00:53:51.000000', 'consum', 0.0245, 'lps'),
	(661620, 135, '2015-01-15 00:53:52.000000', 'consum', 0.0256, 'lps'),
	(661621, 135, '2015-01-15 00:53:53.000000', 'consum', 0.0264, 'lps'),
	(661622, 135, '2015-01-15 00:53:54.000000', 'consum', 0.0265, 'lps'),
	(661623, 135, '2015-01-15 00:53:55.000000', 'consum', 0.0251, 'lps'),
	(661624, 135, '2015-01-15 00:53:56.000000', 'consum', 0.0250, 'lps'),
	(661625, 135, '2015-01-15 00:53:57.000000', 'consum', 0.0215, 'lps'),
	(661626, 135, '2015-01-15 00:53:58.000000', 'consum', 0.0264, 'lps'),
	(661627, 135, '2015-01-15 00:53:59.000000', 'consum', 0.0243, 'lps'),
	(661628, 135, '2015-01-15 00:54:00.000000', 'consum', 0.0213, 'lps'),
	(661629, 135, '2015-01-15 00:54:01.000000', 'consum', 0.0273, 'lps'),
	(661630, 135, '2015-01-15 00:54:02.000000', 'consum', 0.0222, 'lps'),
	(661631, 135, '2015-01-15 00:54:03.000000', 'consum', 0.0228, 'lps'),
	(661632, 135, '2015-01-15 00:54:04.000000', 'consum', 0.0264, 'lps'),
	(661633, 135, '2015-01-15 00:54:05.000000', 'consum', 0.0281, 'lps'),
	(661634, 135, '2015-01-15 00:54:06.000000', 'consum', 0.0256, 'lps'),
	(661635, 135, '2015-01-15 00:54:07.000000', 'consum', 0.0227, 'lps'),
	(661636, 135, '2015-01-15 00:54:08.000000', 'consum', 0.0233, 'lps'),
	(661637, 135, '2015-01-15 00:54:09.000000', 'consum', 0.0272, 'lps'),
	(661638, 135, '2015-01-15 00:54:10.000000', 'consum', 0.0232, 'lps'),
	(661639, 135, '2015-01-15 00:54:11.000000', 'consum', 0.0280, 'lps'),
	(661640, 135, '2015-01-15 00:54:12.000000', 'consum', 0.0274, 'lps'),
	(661641, 135, '2015-01-15 00:54:13.000000', 'consum', 0.0246, 'lps'),
	(661642, 135, '2015-01-15 00:54:14.000000', 'consum', 0.0274, 'lps'),
	(661643, 135, '2015-01-15 00:54:15.000000', 'consum', 0.0276, 'lps'),
	(661644, 135, '2015-01-15 00:54:16.000000', 'consum', 0.0271, 'lps'),
	(661645, 135, '2015-01-15 00:54:17.000000', 'consum', 0.0243, 'lps'),
	(661646, 135, '2015-01-15 00:54:18.000000', 'consum', 0.0269, 'lps'),
	(661647, 135, '2015-01-15 00:54:19.000000', 'consum', 0.0259, 'lps'),
	(661648, 135, '2015-01-15 00:54:20.000000', 'consum', 0.0277, 'lps'),
	(661649, 135, '2015-01-15 00:54:21.000000', 'consum', 0.0251, 'lps'),
	(661650, 135, '2015-01-15 00:54:22.000000', 'consum', 0.0213, 'lps'),
	(661651, 135, '2015-01-15 00:54:23.000000', 'consum', 0.0253, 'lps'),
	(661652, 135, '2015-01-15 00:54:24.000000', 'consum', 0.0267, 'lps'),
	(661653, 135, '2015-01-15 00:54:25.000000', 'consum', 0.0219, 'lps'),
	(661654, 135, '2015-01-15 00:54:26.000000', 'consum', 0.0233, 'lps'),
	(661655, 135, '2015-01-15 00:54:27.000000', 'consum', 0.0224, 'lps'),
	(661656, 135, '2015-01-15 00:54:28.000000', 'consum', 0.0211, 'lps'),
	(661657, 135, '2015-01-15 00:54:29.000000', 'consum', 0.0248, 'lps'),
	(661658, 135, '2015-01-15 00:54:30.000000', 'consum', 0.0248, 'lps'),
	(661659, 135, '2015-01-15 00:54:31.000000', 'consum', 0.0213, 'lps'),
	(661660, 135, '2015-01-15 00:54:32.000000', 'consum', 0.0259, 'lps'),
	(661661, 135, '2015-01-15 00:54:33.000000', 'consum', 0.0227, 'lps'),
	(661662, 135, '2015-01-15 00:54:34.000000', 'consum', 0.0220, 'lps'),
	(661663, 135, '2015-01-15 00:54:35.000000', 'consum', 0.0211, 'lps'),
	(661664, 135, '2015-01-15 00:54:36.000000', 'consum', 0.0261, 'lps'),
	(661665, 135, '2015-01-15 00:54:37.000000', 'consum', 0.0239, 'lps'),
	(661666, 135, '2015-01-15 00:54:38.000000', 'consum', 0.0277, 'lps'),
	(661667, 135, '2015-01-15 00:54:39.000000', 'consum', 0.0236, 'lps'),
	(661668, 135, '2015-01-15 00:54:40.000000', 'consum', 0.0212, 'lps'),
	(661669, 135, '2015-01-15 00:54:41.000000', 'consum', 0.0218, 'lps'),
	(661670, 135, '2015-01-15 00:54:42.000000', 'consum', 0.0244, 'lps'),
	(661671, 135, '2015-01-15 00:54:43.000000', 'consum', 0.0281, 'lps'),
	(661672, 135, '2015-01-15 00:54:44.000000', 'consum', 0.0243, 'lps'),
	(661673, 135, '2015-01-15 00:54:45.000000', 'consum', 0.0238, 'lps'),
	(661674, 135, '2015-01-15 00:54:46.000000', 'consum', 0.0250, 'lps'),
	(661675, 135, '2015-01-15 00:54:47.000000', 'consum', 0.0252, 'lps'),
	(661676, 135, '2015-01-15 00:54:48.000000', 'consum', 0.0225, 'lps'),
	(661677, 135, '2015-01-15 00:54:49.000000', 'consum', 0.0234, 'lps'),
	(661678, 135, '2015-01-15 00:54:50.000000', 'consum', 0.0214, 'lps'),
	(661679, 135, '2015-01-15 00:54:51.000000', 'consum', 0.0232, 'lps'),
	(661680, 135, '2015-01-15 00:54:52.000000', 'consum', 0.0234, 'lps'),
	(661681, 135, '2015-01-15 00:54:53.000000', 'consum', 0.0264, 'lps'),
	(661682, 135, '2015-01-15 00:54:54.000000', 'consum', 0.0259, 'lps'),
	(661683, 135, '2015-01-15 00:54:55.000000', 'consum', 0.0219, 'lps'),
	(661684, 135, '2015-01-15 00:54:56.000000', 'consum', 0.0260, 'lps'),
	(661685, 135, '2015-01-15 00:54:57.000000', 'consum', 0.0282, 'lps'),
	(661686, 135, '2015-01-15 00:54:58.000000', 'consum', 0.0276, 'lps'),
	(661687, 135, '2015-01-15 00:54:59.000000', 'consum', 0.0248, 'lps'),
	(661688, 135, '2015-01-15 00:55:00.000000', 'consum', 0.0276, 'lps'),
	(661689, 135, '2015-01-15 00:55:01.000000', 'consum', 0.0281, 'lps'),
	(661690, 135, '2015-01-15 00:55:02.000000', 'consum', 0.0219, 'lps'),
	(661691, 135, '2015-01-15 00:55:03.000000', 'consum', 0.0265, 'lps'),
	(661692, 135, '2015-01-15 00:55:04.000000', 'consum', 0.0237, 'lps'),
	(661693, 135, '2015-01-15 00:55:05.000000', 'consum', 0.0252, 'lps'),
	(661694, 135, '2015-01-15 00:55:06.000000', 'consum', 0.0267, 'lps'),
	(661695, 135, '2015-01-15 00:55:07.000000', 'consum', 0.0223, 'lps'),
	(661696, 135, '2015-01-15 00:55:08.000000', 'consum', 0.0251, 'lps'),
	(661697, 135, '2015-01-15 00:55:09.000000', 'consum', 0.0228, 'lps'),
	(661698, 135, '2015-01-15 00:55:10.000000', 'consum', 0.0250, 'lps'),
	(661699, 135, '2015-01-15 00:55:11.000000', 'consum', 0.0212, 'lps'),
	(661700, 135, '2015-01-15 00:55:12.000000', 'consum', 0.0247, 'lps'),
	(661701, 135, '2015-01-15 00:55:13.000000', 'consum', 0.0240, 'lps'),
	(661702, 135, '2015-01-15 00:55:14.000000', 'consum', 0.0251, 'lps'),
	(661703, 135, '2015-01-15 00:55:15.000000', 'consum', 0.0252, 'lps'),
	(661704, 135, '2015-01-15 00:55:16.000000', 'consum', 0.0224, 'lps'),
	(661705, 135, '2015-01-15 00:55:17.000000', 'consum', 0.0226, 'lps'),
	(661706, 135, '2015-01-15 00:55:18.000000', 'consum', 0.0250, 'lps'),
	(661707, 135, '2015-01-15 00:55:19.000000', 'consum', 0.0214, 'lps'),
	(661708, 135, '2015-01-15 00:55:20.000000', 'consum', 0.0257, 'lps'),
	(661709, 135, '2015-01-15 00:55:21.000000', 'consum', 0.0213, 'lps'),
	(661710, 135, '2015-01-15 00:55:22.000000', 'consum', 0.0234, 'lps'),
	(661711, 135, '2015-01-15 00:55:23.000000', 'consum', 0.0248, 'lps'),
	(661712, 135, '2015-01-15 00:55:24.000000', 'consum', 0.0252, 'lps'),
	(661713, 135, '2015-01-15 00:55:25.000000', 'consum', 0.0235, 'lps'),
	(661714, 135, '2015-01-15 00:55:26.000000', 'consum', 0.0281, 'lps'),
	(661715, 135, '2015-01-15 00:55:27.000000', 'consum', 0.0269, 'lps'),
	(661716, 135, '2015-01-15 00:55:28.000000', 'consum', 0.0220, 'lps'),
	(661717, 135, '2015-01-15 00:55:29.000000', 'consum', 0.0229, 'lps'),
	(661718, 135, '2015-01-15 00:55:30.000000', 'consum', 0.0275, 'lps'),
	(661719, 135, '2015-01-15 00:55:31.000000', 'consum', 0.0258, 'lps'),
	(661720, 135, '2015-01-15 00:55:32.000000', 'consum', 0.0256, 'lps'),
	(661721, 135, '2015-01-15 00:55:33.000000', 'consum', 0.0224, 'lps'),
	(661722, 135, '2015-01-15 00:55:34.000000', 'consum', 0.0216, 'lps'),
	(661723, 135, '2015-01-15 00:55:35.000000', 'consum', 0.0270, 'lps'),
	(661724, 135, '2015-01-15 00:55:36.000000', 'consum', 0.0271, 'lps'),
	(661725, 135, '2015-01-15 00:55:37.000000', 'consum', 0.0261, 'lps'),
	(661726, 135, '2015-01-15 00:55:38.000000', 'consum', 0.0281, 'lps'),
	(661727, 135, '2015-01-15 00:55:39.000000', 'consum', 0.0268, 'lps'),
	(661728, 135, '2015-01-15 00:55:40.000000', 'consum', 0.0211, 'lps'),
	(661729, 135, '2015-01-15 00:55:41.000000', 'consum', 0.0263, 'lps'),
	(661730, 135, '2015-01-15 00:55:42.000000', 'consum', 0.0250, 'lps'),
	(661731, 135, '2015-01-15 00:55:43.000000', 'consum', 0.0251, 'lps'),
	(661732, 135, '2015-01-15 00:55:44.000000', 'consum', 0.0224, 'lps'),
	(661733, 135, '2015-01-15 00:55:45.000000', 'consum', 0.0230, 'lps'),
	(661734, 135, '2015-01-15 00:55:46.000000', 'consum', 0.0270, 'lps'),
	(661735, 135, '2015-01-15 00:55:47.000000', 'consum', 0.0228, 'lps'),
	(661736, 135, '2015-01-15 00:55:48.000000', 'consum', 0.0267, 'lps'),
	(661737, 135, '2015-01-15 00:55:49.000000', 'consum', 0.0220, 'lps'),
	(661738, 135, '2015-01-15 00:55:50.000000', 'consum', 0.0237, 'lps'),
	(661739, 135, '2015-01-15 00:55:51.000000', 'consum', 0.0244, 'lps'),
	(661740, 135, '2015-01-15 00:55:52.000000', 'consum', 0.0224, 'lps'),
	(661741, 135, '2015-01-15 00:55:53.000000', 'consum', 0.0251, 'lps'),
	(661742, 135, '2015-01-15 00:55:54.000000', 'consum', 0.0226, 'lps'),
	(661743, 135, '2015-01-15 00:55:55.000000', 'consum', 0.0243, 'lps'),
	(661744, 135, '2015-01-15 00:55:56.000000', 'consum', 0.0254, 'lps'),
	(661745, 135, '2015-01-15 00:55:57.000000', 'consum', 0.0258, 'lps'),
	(661746, 135, '2015-01-15 00:55:58.000000', 'consum', 0.0244, 'lps'),
	(661747, 135, '2015-01-15 00:55:59.000000', 'consum', 0.0235, 'lps'),
	(661748, 135, '2015-01-15 00:56:00.000000', 'consum', 0.0236, 'lps'),
	(661749, 135, '2015-01-15 00:56:01.000000', 'consum', 0.0265, 'lps'),
	(661750, 135, '2015-01-15 00:56:02.000000', 'consum', 0.0257, 'lps'),
	(661751, 135, '2015-01-15 00:56:03.000000', 'consum', 0.0283, 'lps'),
	(661752, 135, '2015-01-15 00:56:04.000000', 'consum', 0.0212, 'lps'),
	(661753, 135, '2015-01-15 00:56:05.000000', 'consum', 0.0222, 'lps'),
	(661754, 135, '2015-01-15 00:56:06.000000', 'consum', 0.0265, 'lps'),
	(661755, 135, '2015-01-15 00:56:07.000000', 'consum', 0.0228, 'lps'),
	(661756, 135, '2015-01-15 00:56:08.000000', 'consum', 0.0210, 'lps'),
	(661757, 135, '2015-01-15 00:56:09.000000', 'consum', 0.0229, 'lps'),
	(661758, 135, '2015-01-15 00:56:10.000000', 'consum', 0.0234, 'lps'),
	(661759, 135, '2015-01-15 00:56:11.000000', 'consum', 0.0271, 'lps'),
	(661760, 135, '2015-01-15 00:56:12.000000', 'consum', 0.0222, 'lps'),
	(661761, 135, '2015-01-15 00:56:13.000000', 'consum', 0.0234, 'lps'),
	(661762, 135, '2015-01-15 00:56:14.000000', 'consum', 0.0223, 'lps'),
	(661763, 135, '2015-01-15 00:56:15.000000', 'consum', 0.0276, 'lps'),
	(661764, 135, '2015-01-15 00:56:16.000000', 'consum', 0.0279, 'lps'),
	(661765, 135, '2015-01-15 00:56:17.000000', 'consum', 0.0210, 'lps'),
	(661766, 135, '2015-01-15 00:56:18.000000', 'consum', 0.0227, 'lps'),
	(661767, 135, '2015-01-15 00:56:19.000000', 'consum', 0.0222, 'lps'),
	(661768, 135, '2015-01-15 00:56:20.000000', 'consum', 0.0219, 'lps'),
	(661769, 135, '2015-01-15 00:56:21.000000', 'consum', 0.0217, 'lps'),
	(661770, 135, '2015-01-15 00:56:22.000000', 'consum', 0.0221, 'lps'),
	(661771, 135, '2015-01-15 00:56:23.000000', 'consum', 0.0243, 'lps'),
	(661772, 135, '2015-01-15 00:56:24.000000', 'consum', 0.0268, 'lps'),
	(661773, 135, '2015-01-15 00:56:25.000000', 'consum', 0.0255, 'lps'),
	(661774, 135, '2015-01-15 00:56:26.000000', 'consum', 0.0260, 'lps'),
	(661775, 135, '2015-01-15 00:56:27.000000', 'consum', 0.0253, 'lps'),
	(661776, 135, '2015-01-15 00:56:28.000000', 'consum', 0.0276, 'lps'),
	(661777, 135, '2015-01-15 00:56:29.000000', 'consum', 0.0264, 'lps'),
	(661778, 135, '2015-01-15 00:56:30.000000', 'consum', 0.0210, 'lps'),
	(661779, 135, '2015-01-15 00:56:31.000000', 'consum', 0.0267, 'lps'),
	(661780, 135, '2015-01-15 00:56:32.000000', 'consum', 0.0276, 'lps'),
	(661781, 135, '2015-01-15 00:56:33.000000', 'consum', 0.0220, 'lps'),
	(661782, 135, '2015-01-15 00:56:34.000000', 'consum', 0.0212, 'lps'),
	(661783, 135, '2015-01-15 00:56:35.000000', 'consum', 0.0263, 'lps'),
	(661784, 135, '2015-01-15 00:56:36.000000', 'consum', 0.0247, 'lps'),
	(661785, 135, '2015-01-15 00:56:37.000000', 'consum', 0.0238, 'lps'),
	(661786, 135, '2015-01-15 00:56:38.000000', 'consum', 0.0239, 'lps'),
	(661787, 135, '2015-01-15 00:56:39.000000', 'consum', 0.0271, 'lps'),
	(661788, 135, '2015-01-15 00:56:40.000000', 'consum', 0.0281, 'lps'),
	(661789, 135, '2015-01-15 00:56:41.000000', 'consum', 0.0235, 'lps'),
	(661790, 135, '2015-01-15 00:56:42.000000', 'consum', 0.0268, 'lps'),
	(661791, 135, '2015-01-15 00:56:43.000000', 'consum', 0.0279, 'lps'),
	(661792, 135, '2015-01-15 00:56:44.000000', 'consum', 0.0233, 'lps'),
	(661793, 135, '2015-01-15 00:56:45.000000', 'consum', 0.0268, 'lps'),
	(661794, 135, '2015-01-15 00:56:46.000000', 'consum', 0.0282, 'lps'),
	(661795, 135, '2015-01-15 00:56:47.000000', 'consum', 0.0248, 'lps'),
	(661796, 135, '2015-01-15 00:56:48.000000', 'consum', 0.0260, 'lps'),
	(661797, 135, '2015-01-15 00:56:49.000000', 'consum', 0.0270, 'lps'),
	(661798, 135, '2015-01-15 00:56:50.000000', 'consum', 0.0214, 'lps'),
	(661799, 135, '2015-01-15 00:56:51.000000', 'consum', 0.0274, 'lps'),
	(661800, 135, '2015-01-15 00:56:52.000000', 'consum', 0.0223, 'lps'),
	(661801, 135, '2015-01-15 00:56:53.000000', 'consum', 0.0231, 'lps'),
	(661802, 135, '2015-01-15 00:56:54.000000', 'consum', 0.0276, 'lps'),
	(661803, 135, '2015-01-15 00:56:55.000000', 'consum', 0.0254, 'lps'),
	(661804, 135, '2015-01-15 00:56:56.000000', 'consum', 0.0233, 'lps'),
	(661805, 135, '2015-01-15 00:56:57.000000', 'consum', 0.0268, 'lps'),
	(661806, 135, '2015-01-15 00:56:58.000000', 'consum', 0.0211, 'lps'),
	(661807, 135, '2015-01-15 00:56:59.000000', 'consum', 0.0263, 'lps'),
	(661808, 135, '2015-01-15 00:57:00.000000', 'consum', 0.0249, 'lps'),
	(661809, 135, '2015-01-15 00:57:01.000000', 'consum', 0.0247, 'lps'),
	(661810, 135, '2015-01-15 00:57:02.000000', 'consum', 0.0277, 'lps'),
	(661811, 135, '2015-01-15 00:57:03.000000', 'consum', 0.0214, 'lps'),
	(661812, 135, '2015-01-15 00:57:04.000000', 'consum', 0.0252, 'lps'),
	(661813, 135, '2015-01-15 00:57:05.000000', 'consum', 0.0259, 'lps'),
	(661814, 135, '2015-01-15 00:57:06.000000', 'consum', 0.0255, 'lps'),
	(661815, 135, '2015-01-15 00:57:07.000000', 'consum', 0.0216, 'lps'),
	(661816, 135, '2015-01-15 00:57:08.000000', 'consum', 0.0254, 'lps'),
	(661817, 135, '2015-01-15 00:57:09.000000', 'consum', 0.0263, 'lps'),
	(661818, 135, '2015-01-15 00:57:10.000000', 'consum', 0.0269, 'lps'),
	(661819, 135, '2015-01-15 00:57:11.000000', 'consum', 0.0273, 'lps'),
	(661820, 135, '2015-01-15 00:57:12.000000', 'consum', 0.0276, 'lps'),
	(661821, 135, '2015-01-15 00:57:13.000000', 'consum', 0.0278, 'lps'),
	(661822, 135, '2015-01-15 00:57:14.000000', 'consum', 0.0277, 'lps'),
	(661823, 135, '2015-01-15 00:57:15.000000', 'consum', 0.0270, 'lps'),
	(661824, 135, '2015-01-15 00:57:16.000000', 'consum', 0.0233, 'lps'),
	(661825, 135, '2015-01-15 00:57:17.000000', 'consum', 0.0222, 'lps'),
	(661826, 135, '2015-01-15 00:57:18.000000', 'consum', 0.0275, 'lps'),
	(661827, 135, '2015-01-15 00:57:19.000000', 'consum', 0.0275, 'lps'),
	(661828, 135, '2015-01-15 00:57:20.000000', 'consum', 0.0270, 'lps'),
	(661829, 135, '2015-01-15 00:57:21.000000', 'consum', 0.0240, 'lps'),
	(661830, 135, '2015-01-15 00:57:22.000000', 'consum', 0.0254, 'lps'),
	(661831, 135, '2015-01-15 00:57:23.000000', 'consum', 0.0266, 'lps'),
	(661832, 135, '2015-01-15 00:57:24.000000', 'consum', 0.0283, 'lps'),
	(661833, 135, '2015-01-15 00:57:25.000000', 'consum', 0.0263, 'lps'),
	(661834, 135, '2015-01-15 00:57:26.000000', 'consum', 0.0255, 'lps'),
	(661835, 135, '2015-01-15 00:57:27.000000', 'consum', 0.0276, 'lps'),
	(661836, 135, '2015-01-15 00:57:28.000000', 'consum', 0.0259, 'lps'),
	(661837, 135, '2015-01-15 00:57:29.000000', 'consum', 0.0256, 'lps'),
	(661838, 135, '2015-01-15 00:57:30.000000', 'consum', 0.0218, 'lps'),
	(661839, 135, '2015-01-15 00:57:31.000000', 'consum', 0.0264, 'lps'),
	(661840, 135, '2015-01-15 00:57:32.000000', 'consum', 0.0232, 'lps'),
	(661841, 135, '2015-01-15 00:57:33.000000', 'consum', 0.0231, 'lps'),
	(661842, 135, '2015-01-15 00:57:34.000000', 'consum', 0.0252, 'lps'),
	(661843, 135, '2015-01-15 00:57:35.000000', 'consum', 0.0283, 'lps'),
	(661844, 135, '2015-01-15 00:57:36.000000', 'consum', 0.0229, 'lps'),
	(661845, 135, '2015-01-15 00:57:37.000000', 'consum', 0.0234, 'lps'),
	(661846, 135, '2015-01-15 00:57:38.000000', 'consum', 0.0273, 'lps'),
	(661847, 135, '2015-01-15 00:57:39.000000', 'consum', 0.0234, 'lps'),
	(661848, 135, '2015-01-15 00:57:40.000000', 'consum', 0.0212, 'lps'),
	(661849, 135, '2015-01-15 00:57:41.000000', 'consum', 0.0223, 'lps'),
	(661850, 135, '2015-01-15 00:57:42.000000', 'consum', 0.0271, 'lps'),
	(661851, 135, '2015-01-15 00:57:43.000000', 'consum', 0.0255, 'lps'),
	(661852, 135, '2015-01-15 00:57:44.000000', 'consum', 0.0254, 'lps'),
	(661853, 135, '2015-01-15 00:57:45.000000', 'consum', 0.0219, 'lps'),
	(661854, 135, '2015-01-15 00:57:46.000000', 'consum', 0.0270, 'lps'),
	(661855, 135, '2015-01-15 00:57:47.000000', 'consum', 0.0265, 'lps'),
	(661856, 135, '2015-01-15 00:57:48.000000', 'consum', 0.0228, 'lps'),
	(661857, 135, '2015-01-15 00:57:49.000000', 'consum', 0.0211, 'lps'),
	(661858, 135, '2015-01-15 00:57:50.000000', 'consum', 0.0236, 'lps'),
	(661859, 135, '2015-01-15 00:57:51.000000', 'consum', 0.0262, 'lps'),
	(661860, 135, '2015-01-15 00:57:52.000000', 'consum', 0.0244, 'lps'),
	(661861, 135, '2015-01-15 00:57:53.000000', 'consum', 0.0226, 'lps'),
	(661862, 135, '2015-01-15 00:57:54.000000', 'consum', 0.0264, 'lps'),
	(661863, 135, '2015-01-15 00:57:55.000000', 'consum', 0.0283, 'lps'),
	(661864, 135, '2015-01-15 00:57:56.000000', 'consum', 0.0266, 'lps'),
	(661865, 135, '2015-01-15 00:57:57.000000', 'consum', 0.0271, 'lps'),
	(661866, 135, '2015-01-15 00:57:58.000000', 'consum', 0.0273, 'lps'),
	(661867, 135, '2015-01-15 00:57:59.000000', 'consum', 0.0271, 'lps'),
	(661868, 135, '2015-01-15 00:58:00.000000', 'consum', 0.0250, 'lps'),
	(661869, 135, '2015-01-15 00:58:01.000000', 'consum', 0.0227, 'lps'),
	(661870, 135, '2015-01-15 00:58:02.000000', 'consum', 0.0249, 'lps'),
	(661871, 135, '2015-01-15 00:58:03.000000', 'consum', 0.0280, 'lps'),
	(661872, 135, '2015-01-15 00:58:04.000000', 'consum', 0.0225, 'lps'),
	(661873, 135, '2015-01-15 00:58:05.000000', 'consum', 0.0220, 'lps'),
	(661874, 135, '2015-01-15 00:58:06.000000', 'consum', 0.0217, 'lps'),
	(661875, 135, '2015-01-15 00:58:07.000000', 'consum', 0.0214, 'lps'),
	(661876, 135, '2015-01-15 00:58:08.000000', 'consum', 0.0211, 'lps'),
	(661877, 135, '2015-01-15 00:58:09.000000', 'consum', 0.0277, 'lps'),
	(661878, 135, '2015-01-15 00:58:10.000000', 'consum', 0.0246, 'lps'),
	(661879, 135, '2015-01-15 00:58:11.000000', 'consum', 0.0264, 'lps'),
	(661880, 135, '2015-01-15 00:58:12.000000', 'consum', 0.0223, 'lps'),
	(661881, 135, '2015-01-15 00:58:13.000000', 'consum', 0.0263, 'lps'),
	(661882, 135, '2015-01-15 00:58:14.000000', 'consum', 0.0216, 'lps'),
	(661883, 135, '2015-01-15 00:58:15.000000', 'consum', 0.0229, 'lps'),
	(661884, 135, '2015-01-15 00:58:16.000000', 'consum', 0.0211, 'lps'),
	(661885, 135, '2015-01-15 00:58:17.000000', 'consum', 0.0235, 'lps'),
	(661886, 135, '2015-01-15 00:58:18.000000', 'consum', 0.0259, 'lps'),
	(661887, 135, '2015-01-15 00:58:19.000000', 'consum', 0.0231, 'lps'),
	(661888, 135, '2015-01-15 00:58:20.000000', 'consum', 0.0243, 'lps'),
	(661889, 135, '2015-01-15 00:58:21.000000', 'consum', 0.0238, 'lps'),
	(661890, 135, '2015-01-15 00:58:22.000000', 'consum', 0.0254, 'lps'),
	(661891, 135, '2015-01-15 00:58:23.000000', 'consum', 0.0269, 'lps'),
	(661892, 135, '2015-01-15 00:58:24.000000', 'consum', 0.0229, 'lps'),
	(661893, 135, '2015-01-15 00:58:25.000000', 'consum', 0.0273, 'lps'),
	(661894, 135, '2015-01-15 00:58:26.000000', 'consum', 0.0250, 'lps'),
	(661895, 135, '2015-01-15 00:58:27.000000', 'consum', 0.0220, 'lps'),
	(661896, 135, '2015-01-15 00:58:28.000000', 'consum', 0.0215, 'lps'),
	(661897, 135, '2015-01-15 00:58:29.000000', 'consum', 0.0279, 'lps'),
	(661898, 135, '2015-01-15 00:58:30.000000', 'consum', 0.0245, 'lps'),
	(661899, 135, '2015-01-15 00:58:31.000000', 'consum', 0.0254, 'lps'),
	(661900, 135, '2015-01-15 00:58:32.000000', 'consum', 0.0251, 'lps'),
	(661901, 135, '2015-01-15 00:58:33.000000', 'consum', 0.0282, 'lps'),
	(661902, 135, '2015-01-15 00:58:34.000000', 'consum', 0.0226, 'lps'),
	(661903, 135, '2015-01-15 00:58:35.000000', 'consum', 0.0224, 'lps'),
	(661904, 135, '2015-01-15 00:58:36.000000', 'consum', 0.0231, 'lps'),
	(661905, 135, '2015-01-15 00:58:37.000000', 'consum', 0.0273, 'lps'),
	(661906, 135, '2015-01-15 00:58:38.000000', 'consum', 0.0240, 'lps'),
	(661907, 135, '2015-01-15 00:58:39.000000', 'consum', 0.0245, 'lps'),
	(661908, 135, '2015-01-15 00:58:40.000000', 'consum', 0.0221, 'lps'),
	(661909, 135, '2015-01-15 00:58:41.000000', 'consum', 0.0236, 'lps'),
	(661910, 135, '2015-01-15 00:58:42.000000', 'consum', 0.0234, 'lps'),
	(661911, 135, '2015-01-15 00:58:43.000000', 'consum', 0.0251, 'lps'),
	(661912, 135, '2015-01-15 00:58:44.000000', 'consum', 0.0269, 'lps'),
	(661913, 135, '2015-01-15 00:58:45.000000', 'consum', 0.0236, 'lps'),
	(661914, 135, '2015-01-15 00:58:46.000000', 'consum', 0.0238, 'lps'),
	(661915, 135, '2015-01-15 00:58:47.000000', 'consum', 0.0273, 'lps'),
	(661916, 135, '2015-01-15 00:58:48.000000', 'consum', 0.0218, 'lps'),
	(661917, 135, '2015-01-15 00:58:49.000000', 'consum', 0.0282, 'lps'),
	(661918, 135, '2015-01-15 00:58:50.000000', 'consum', 0.0252, 'lps'),
	(661919, 135, '2015-01-15 00:58:51.000000', 'consum', 0.0280, 'lps'),
	(661920, 135, '2015-01-15 00:58:52.000000', 'consum', 0.0213, 'lps'),
	(661921, 135, '2015-01-15 00:58:53.000000', 'consum', 0.0237, 'lps'),
	(661922, 135, '2015-01-15 00:58:54.000000', 'consum', 0.0261, 'lps'),
	(661923, 135, '2015-01-15 00:58:55.000000', 'consum', 0.0238, 'lps'),
	(661924, 135, '2015-01-15 00:58:56.000000', 'consum', 0.0269, 'lps'),
	(661925, 135, '2015-01-15 00:58:57.000000', 'consum', 0.0275, 'lps'),
	(661926, 135, '2015-01-15 00:58:58.000000', 'consum', 0.0212, 'lps'),
	(661927, 135, '2015-01-15 00:58:59.000000', 'consum', 0.0248, 'lps'),
	(661928, 135, '2015-01-15 00:59:00.000000', 'consum', 0.0244, 'lps'),
	(661929, 135, '2015-01-15 00:59:01.000000', 'consum', 0.0267, 'lps'),
	(661930, 135, '2015-01-15 00:59:02.000000', 'consum', 0.0246, 'lps'),
	(661931, 135, '2015-01-15 00:59:03.000000', 'consum', 0.0221, 'lps'),
	(661932, 135, '2015-01-15 00:59:04.000000', 'consum', 0.0230, 'lps'),
	(661933, 135, '2015-01-15 00:59:05.000000', 'consum', 0.0278, 'lps'),
	(661934, 135, '2015-01-15 00:59:06.000000', 'consum', 0.0266, 'lps'),
	(661935, 135, '2015-01-15 00:59:07.000000', 'consum', 0.0216, 'lps'),
	(661936, 135, '2015-01-15 00:59:08.000000', 'consum', 0.0218, 'lps'),
	(661937, 135, '2015-01-15 00:59:09.000000', 'consum', 0.0232, 'lps'),
	(661938, 135, '2015-01-15 00:59:10.000000', 'consum', 0.0223, 'lps'),
	(661939, 135, '2015-01-15 00:59:11.000000', 'consum', 0.0210, 'lps'),
	(661940, 135, '2015-01-15 00:59:12.000000', 'consum', 0.0246, 'lps'),
	(661941, 135, '2015-01-15 00:59:13.000000', 'consum', 0.0243, 'lps'),
	(661942, 135, '2015-01-15 00:59:14.000000', 'consum', 0.0266, 'lps'),
	(661943, 135, '2015-01-15 00:59:15.000000', 'consum', 0.0243, 'lps'),
	(661944, 135, '2015-01-15 00:59:16.000000', 'consum', 0.0280, 'lps'),
	(661945, 135, '2015-01-15 00:59:17.000000', 'consum', 0.0243, 'lps'),
	(661946, 135, '2015-01-15 00:59:18.000000', 'consum', 0.0236, 'lps'),
	(661947, 135, '2015-01-15 00:59:19.000000', 'consum', 0.0244, 'lps'),
	(661948, 135, '2015-01-15 00:59:20.000000', 'consum', 0.0228, 'lps'),
	(661949, 135, '2015-01-15 00:59:21.000000', 'consum', 0.0273, 'lps'),
	(661950, 135, '2015-01-15 00:59:22.000000', 'consum', 0.0251, 'lps'),
	(661951, 135, '2015-01-15 00:59:23.000000', 'consum', 0.0226, 'lps'),
	(661952, 135, '2015-01-15 00:59:24.000000', 'consum', 0.0240, 'lps'),
	(661953, 135, '2015-01-15 00:59:25.000000', 'consum', 0.0238, 'lps'),
	(661954, 135, '2015-01-15 00:59:26.000000', 'consum', 0.0262, 'lps'),
	(661955, 135, '2015-01-15 00:59:27.000000', 'consum', 0.0236, 'lps'),
	(661956, 135, '2015-01-15 00:59:28.000000', 'consum', 0.0261, 'lps'),
	(661957, 135, '2015-01-15 00:59:29.000000', 'consum', 0.0237, 'lps'),
	(661958, 135, '2015-01-15 00:59:30.000000', 'consum', 0.0268, 'lps'),
	(661959, 135, '2015-01-15 00:59:31.000000', 'consum', 0.0271, 'lps'),
	(661960, 135, '2015-01-15 00:59:32.000000', 'consum', 0.0266, 'lps'),
	(661961, 135, '2015-01-15 00:59:33.000000', 'consum', 0.0234, 'lps'),
	(661962, 135, '2015-01-15 00:59:34.000000', 'consum', 0.0238, 'lps'),
	(661963, 135, '2015-01-15 00:59:35.000000', 'consum', 0.0279, 'lps'),
	(661964, 135, '2015-01-15 00:59:36.000000', 'consum', 0.0247, 'lps'),
	(661965, 135, '2015-01-15 00:59:37.000000', 'consum', 0.0263, 'lps'),
	(661966, 135, '2015-01-15 00:59:38.000000', 'consum', 0.0217, 'lps'),
	(661967, 135, '2015-01-15 00:59:39.000000', 'consum', 0.0234, 'lps'),
	(661968, 135, '2015-01-15 00:59:40.000000', 'consum', 0.0237, 'lps'),
	(661969, 135, '2015-01-15 00:59:41.000000', 'consum', 0.0272, 'lps'),
	(661970, 135, '2015-01-15 00:59:42.000000', 'consum', 0.0220, 'lps'),
	(661971, 135, '2015-01-15 00:59:43.000000', 'consum', 0.0221, 'lps'),
	(661972, 135, '2015-01-15 00:59:44.000000', 'consum', 0.0235, 'lps'),
	(661973, 135, '2015-01-15 00:59:45.000000', 'consum', 0.0227, 'lps'),
	(661974, 135, '2015-01-15 00:59:46.000000', 'consum', 0.0224, 'lps'),
	(661975, 135, '2015-01-15 00:59:47.000000', 'consum', 0.0228, 'lps'),
	(661976, 135, '2015-01-15 00:59:48.000000', 'consum', 0.0256, 'lps'),
	(661977, 135, '2015-01-15 00:59:49.000000', 'consum', 0.0242, 'lps'),
	(661978, 135, '2015-01-15 00:59:50.000000', 'consum', 0.0231, 'lps'),
	(661979, 135, '2015-01-15 00:59:51.000000', 'consum', 0.0219, 'lps'),
	(661980, 135, '2015-01-15 00:59:52.000000', 'consum', 0.0268, 'lps'),
	(661981, 135, '2015-01-15 00:59:53.000000', 'consum', 0.0249, 'lps'),
	(661982, 135, '2015-01-15 00:59:54.000000', 'consum', 0.0234, 'lps'),
	(661983, 135, '2015-01-15 00:59:55.000000', 'consum', 0.0214, 'lps'),
	(661984, 135, '2015-01-15 00:59:56.000000', 'consum', 0.0229, 'lps'),
	(661985, 135, '2015-01-15 00:59:57.000000', 'consum', 0.0223, 'lps'),
	(661986, 135, '2015-01-15 00:59:58.000000', 'consum', 0.0218, 'lps'),
	(661987, 135, '2015-01-15 00:59:59.000000', 'consum', 0.0212, 'lps'),
	(661988, 135, '2015-01-15 01:00:00.000000', 'consum', 0.0269, 'lps'),
	(661989, 135, '2015-01-15 01:00:01.000000', 'consum', 0.0277, 'lps'),
	(661990, 135, '2015-01-15 01:00:02.000000', 'consum', 0.0222, 'lps'),
	(661991, 135, '2015-01-15 01:00:03.000000', 'consum', 0.0218, 'lps'),
	(661992, 135, '2015-01-15 01:00:04.000000', 'consum', 0.0216, 'lps'),
	(661993, 135, '2015-01-15 01:00:05.000000', 'consum', 0.0214, 'lps'),
	(661994, 135, '2015-01-15 01:00:06.000000', 'consum', 0.0214, 'lps'),
	(661995, 135, '2015-01-15 01:00:07.000000', 'consum', 0.0217, 'lps'),
	(661996, 135, '2015-01-15 01:00:08.000000', 'consum', 0.0236, 'lps'),
	(661997, 135, '2015-01-15 01:00:09.000000', 'consum', 0.0242, 'lps'),
	(661998, 135, '2015-01-15 01:00:10.000000', 'consum', 0.0221, 'lps'),
	(661999, 135, '2015-01-15 01:00:11.000000', 'consum', 0.0241, 'lps'),
	(662000, 135, '2015-01-15 01:00:12.000000', 'consum', 0.0261, 'lps'),
	(662001, 135, '2015-01-15 01:00:13.000000', 'consum', 0.0225, 'lps'),
	(662002, 135, '2015-01-15 01:00:14.000000', 'consum', 0.0281, 'lps'),
	(662003, 135, '2015-01-15 01:00:15.000000', 'consum', 0.0224, 'lps'),
	(662004, 135, '2015-01-15 01:00:16.000000', 'consum', 0.0216, 'lps'),
	(662005, 135, '2015-01-15 01:00:17.000000', 'consum', 0.0270, 'lps'),
	(662006, 135, '2015-01-15 01:00:18.000000', 'consum', 0.0274, 'lps'),
	(662007, 135, '2015-01-15 01:00:19.000000', 'consum', 0.0274, 'lps'),
	(662008, 135, '2015-01-15 01:00:20.000000', 'consum', 0.0266, 'lps'),
	(662009, 135, '2015-01-15 01:00:21.000000', 'consum', 0.0222, 'lps'),
	(662010, 135, '2015-01-15 01:00:22.000000', 'consum', 0.0252, 'lps'),
	(662011, 135, '2015-01-15 01:00:23.000000', 'consum', 0.0235, 'lps'),
	(662012, 135, '2015-01-15 01:00:24.000000', 'consum', 0.0211, 'lps'),
	(662013, 135, '2015-01-15 01:00:25.000000', 'consum', 0.0215, 'lps'),
	(662014, 135, '2015-01-15 01:00:26.000000', 'consum', 0.0232, 'lps'),
	(662015, 135, '2015-01-15 01:00:27.000000', 'consum', 0.0231, 'lps'),
	(662016, 135, '2015-01-15 01:00:28.000000', 'consum', 0.0249, 'lps'),
	(662017, 135, '2015-01-15 01:00:29.000000', 'consum', 0.0267, 'lps'),
	(662018, 135, '2015-01-15 01:00:30.000000', 'consum', 0.0232, 'lps'),
	(662019, 135, '2015-01-15 01:00:31.000000', 'consum', 0.0224, 'lps'),
	(662020, 135, '2015-01-15 01:00:32.000000', 'consum', 0.0216, 'lps'),
	(662021, 135, '2015-01-15 01:00:33.000000', 'consum', 0.0272, 'lps'),
	(662022, 135, '2015-01-15 01:00:34.000000', 'consum', 0.0281, 'lps'),
	(662023, 135, '2015-01-15 01:00:35.000000', 'consum', 0.0233, 'lps'),
	(662024, 135, '2015-01-15 01:00:36.000000', 'consum', 0.0257, 'lps'),
	(662025, 135, '2015-01-15 01:00:37.000000', 'consum', 0.0230, 'lps'),
	(662026, 135, '2015-01-15 01:00:38.000000', 'consum', 0.0244, 'lps'),
	(662027, 135, '2015-01-15 01:00:39.000000', 'consum', 0.0246, 'lps'),
	(662028, 135, '2015-01-15 01:00:40.000000', 'consum', 0.0213, 'lps'),
	(662029, 135, '2015-01-15 01:00:41.000000', 'consum', 0.0268, 'lps'),
	(662030, 135, '2015-01-15 01:00:42.000000', 'consum', 0.0268, 'lps'),
	(662031, 135, '2015-01-15 01:00:43.000000', 'consum', 0.0251, 'lps'),
	(662032, 135, '2015-01-15 01:00:44.000000', 'consum', 0.0244, 'lps'),
	(662033, 135, '2015-01-15 01:00:45.000000', 'consum', 0.0255, 'lps'),
	(662034, 135, '2015-01-15 01:00:46.000000', 'consum', 0.0261, 'lps'),
	(662035, 135, '2015-01-15 01:00:47.000000', 'consum', 0.0255, 'lps'),
	(662036, 135, '2015-01-15 01:00:48.000000', 'consum', 0.0282, 'lps'),
	(662037, 135, '2015-01-15 01:00:49.000000', 'consum', 0.0213, 'lps'),
	(662038, 135, '2015-01-15 01:00:50.000000', 'consum', 0.0233, 'lps'),
	(662039, 135, '2015-01-15 01:00:51.000000', 'consum', 0.0241, 'lps'),
	(662040, 135, '2015-01-15 01:00:52.000000', 'consum', 0.0223, 'lps'),
	(662041, 135, '2015-01-15 01:00:53.000000', 'consum', 0.0257, 'lps'),
	(662042, 135, '2015-01-15 01:00:54.000000', 'consum', 0.0257, 'lps'),
	(662043, 135, '2015-01-15 01:00:55.000000', 'consum', 0.0232, 'lps'),
	(662044, 135, '2015-01-15 01:00:56.000000', 'consum', 0.0254, 'lps'),
	(662045, 135, '2015-01-15 01:00:57.000000', 'consum', 0.0216, 'lps'),
	(662046, 135, '2015-01-15 01:00:58.000000', 'consum', 0.0257, 'lps'),
	(662047, 135, '2015-01-15 01:00:59.000000', 'consum', 0.0277, 'lps'),
	(662048, 135, '2015-01-15 01:01:00.000000', 'consum', 0.0259, 'lps'),
	(662049, 135, '2015-01-15 01:01:01.000000', 'consum', 0.0252, 'lps'),
	(662050, 135, '2015-01-15 01:01:02.000000', 'consum', 0.0273, 'lps'),
	(662051, 135, '2015-01-15 01:01:03.000000', 'consum', 0.0253, 'lps'),
	(662052, 135, '2015-01-15 01:01:04.000000', 'consum', 0.0238, 'lps'),
	(662053, 135, '2015-01-15 01:01:05.000000', 'consum', 0.0218, 'lps'),
	(662054, 135, '2015-01-15 01:01:06.000000', 'consum', 0.0243, 'lps'),
	(662055, 135, '2015-01-15 01:01:07.000000', 'consum', 0.0278, 'lps'),
	(662056, 135, '2015-01-15 01:01:08.000000', 'consum', 0.0229, 'lps'),
	(662057, 135, '2015-01-15 01:01:09.000000', 'consum', 0.0248, 'lps'),
	(662058, 135, '2015-01-15 01:01:10.000000', 'consum', 0.0272, 'lps'),
	(662059, 135, '2015-01-15 01:01:11.000000', 'consum', 0.0258, 'lps'),
	(662060, 135, '2015-01-15 01:01:12.000000', 'consum', 0.0265, 'lps'),
	(662061, 135, '2015-01-15 01:01:13.000000', 'consum', 0.0268, 'lps'),
	(662062, 135, '2015-01-15 01:01:14.000000', 'consum', 0.0259, 'lps'),
	(662063, 135, '2015-01-15 01:01:15.000000', 'consum', 0.0282, 'lps'),
	(662064, 135, '2015-01-15 01:01:16.000000', 'consum', 0.0277, 'lps'),
	(662065, 135, '2015-01-15 01:01:17.000000', 'consum', 0.0256, 'lps'),
	(662066, 135, '2015-01-15 01:01:18.000000', 'consum', 0.0237, 'lps'),
	(662067, 135, '2015-01-15 01:01:19.000000', 'consum', 0.0283, 'lps'),
	(662068, 135, '2015-01-15 01:01:20.000000', 'consum', 0.0274, 'lps'),
	(662069, 135, '2015-01-15 01:01:21.000000', 'consum', 0.0235, 'lps'),
	(662070, 135, '2015-01-15 01:01:22.000000', 'consum', 0.0217, 'lps'),
	(662071, 135, '2015-01-15 01:01:23.000000', 'consum', 0.0247, 'lps'),
	(662072, 135, '2015-01-15 01:01:24.000000', 'consum', 0.0226, 'lps'),
	(662073, 135, '2015-01-15 01:01:25.000000', 'consum', 0.0252, 'lps'),
	(662074, 135, '2015-01-15 01:01:26.000000', 'consum', 0.0225, 'lps'),
	(662075, 135, '2015-01-15 01:01:27.000000', 'consum', 0.0232, 'lps'),
	(662076, 135, '2015-01-15 01:01:28.000000', 'consum', 0.0276, 'lps'),
	(662077, 135, '2015-01-15 01:01:29.000000', 'consum', 0.0252, 'lps'),
	(662078, 135, '2015-01-15 01:01:30.000000', 'consum', 0.0223, 'lps'),
	(662079, 135, '2015-01-15 01:01:31.000000', 'consum', 0.0223, 'lps'),
	(662080, 135, '2015-01-15 01:01:32.000000', 'consum', 0.0238, 'lps'),
	(662081, 135, '2015-01-15 01:01:33.000000', 'consum', 0.0237, 'lps'),
	(662082, 135, '2015-01-15 01:01:34.000000', 'consum', 0.0259, 'lps'),
	(662083, 135, '2015-01-15 01:01:35.000000', 'consum', 0.0230, 'lps'),
	(662084, 135, '2015-01-15 01:01:36.000000', 'consum', 0.0237, 'lps'),
	(662085, 135, '2015-01-15 01:01:37.000000', 'consum', 0.0212, 'lps'),
	(662086, 135, '2015-01-15 01:01:38.000000', 'consum', 0.0211, 'lps'),
	(662087, 135, '2015-01-15 01:01:39.000000', 'consum', 0.0213, 'lps'),
	(662088, 135, '2015-01-15 01:01:40.000000', 'consum', 0.0219, 'lps'),
	(662089, 135, '2015-01-15 01:01:41.000000', 'consum', 0.0247, 'lps'),
	(662090, 135, '2015-01-15 01:01:42.000000', 'consum', 0.0221, 'lps'),
	(662091, 135, '2015-01-15 01:01:43.000000', 'consum', 0.0228, 'lps'),
	(662092, 135, '2015-01-15 01:01:44.000000', 'consum', 0.0267, 'lps'),
	(662093, 135, '2015-01-15 01:01:45.000000', 'consum', 0.0219, 'lps'),
	(662094, 135, '2015-01-15 01:01:46.000000', 'consum', 0.0234, 'lps'),
	(662095, 135, '2015-01-15 01:01:47.000000', 'consum', 0.0230, 'lps'),
	(662096, 135, '2015-01-15 01:01:48.000000', 'consum', 0.0237, 'lps'),
	(662097, 135, '2015-01-15 01:01:49.000000', 'consum', 0.0211, 'lps'),
	(662098, 135, '2015-01-15 01:01:50.000000', 'consum', 0.0281, 'lps'),
	(662099, 135, '2015-01-15 01:01:51.000000', 'consum', 0.0270, 'lps'),
	(662100, 135, '2015-01-15 01:01:52.000000', 'consum', 0.0222, 'lps'),
	(662101, 135, '2015-01-15 01:01:53.000000', 'consum', 0.0237, 'lps'),
	(662102, 135, '2015-01-15 01:01:54.000000', 'consum', 0.0235, 'lps'),
	(662103, 135, '2015-01-15 01:01:55.000000', 'consum', 0.0257, 'lps'),
	(662104, 135, '2015-01-15 01:01:56.000000', 'consum', 0.0221, 'lps'),
	(662105, 135, '2015-01-15 01:01:57.000000', 'consum', 0.0272, 'lps'),
	(662106, 135, '2015-01-15 01:01:58.000000', 'consum', 0.0268, 'lps'),
	(662107, 135, '2015-01-15 01:01:59.000000', 'consum', 0.0239, 'lps'),
	(662108, 135, '2015-01-15 01:02:00.000000', 'consum', 0.0257, 'lps'),
	(662109, 135, '2015-01-15 01:02:01.000000', 'consum', 0.0283, 'lps'),
	(662110, 135, '2015-01-15 01:02:02.000000', 'consum', 0.0212, 'lps'),
	(662111, 135, '2015-01-15 01:02:03.000000', 'consum', 0.0223, 'lps'),
	(662112, 135, '2015-01-15 01:02:04.000000', 'consum', 0.0269, 'lps'),
	(662113, 135, '2015-01-15 01:02:05.000000', 'consum', 0.0244, 'lps'),
	(662114, 135, '2015-01-15 01:02:06.000000', 'consum', 0.0279, 'lps'),
	(662115, 135, '2015-01-15 01:02:07.000000', 'consum', 0.0233, 'lps'),
	(662116, 135, '2015-01-15 01:02:08.000000', 'consum', 0.0266, 'lps'),
	(662117, 135, '2015-01-15 01:02:09.000000', 'consum', 0.0271, 'lps'),
	(662118, 135, '2015-01-15 01:02:10.000000', 'consum', 0.0276, 'lps'),
	(662119, 135, '2015-01-15 01:02:11.000000', 'consum', 0.0210, 'lps'),
	(662120, 135, '2015-01-15 01:02:12.000000', 'consum', 0.0234, 'lps'),
	(662121, 135, '2015-01-15 01:02:13.000000', 'consum', 0.0258, 'lps'),
	(662122, 135, '2015-01-15 01:02:14.000000', 'consum', 0.0228, 'lps'),
	(662123, 135, '2015-01-15 01:02:15.000000', 'consum', 0.0230, 'lps'),
	(662124, 135, '2015-01-15 01:02:16.000000', 'consum', 0.0257, 'lps'),
	(662125, 135, '2015-01-15 01:02:17.000000', 'consum', 0.0239, 'lps'),
	(662126, 135, '2015-01-15 01:02:18.000000', 'consum', 0.0214, 'lps'),
	(662127, 135, '2015-01-15 01:02:19.000000', 'consum', 0.0219, 'lps'),
	(662128, 135, '2015-01-15 01:02:20.000000', 'consum', 0.0242, 'lps'),
	(662129, 135, '2015-01-15 01:02:21.000000', 'consum', 0.0272, 'lps'),
	(662130, 135, '2015-01-15 01:02:22.000000', 'consum', 0.0273, 'lps'),
	(662131, 135, '2015-01-15 01:02:23.000000', 'consum', 0.0267, 'lps'),
	(662132, 135, '2015-01-15 01:02:24.000000', 'consum', 0.0233, 'lps'),
	(662133, 135, '2015-01-15 01:02:25.000000', 'consum', 0.0228, 'lps'),
	(662134, 135, '2015-01-15 01:02:26.000000', 'consum', 0.0230, 'lps'),
	(662135, 135, '2015-01-15 01:02:27.000000', 'consum', 0.0255, 'lps'),
	(662136, 135, '2015-01-15 01:02:28.000000', 'consum', 0.0231, 'lps'),
	(662137, 135, '2015-01-15 01:02:29.000000', 'consum', 0.0255, 'lps'),
	(662138, 135, '2015-01-15 01:02:30.000000', 'consum', 0.0224, 'lps'),
	(662139, 135, '2015-01-15 01:02:31.000000', 'consum', 0.0218, 'lps'),
	(662140, 135, '2015-01-15 01:02:32.000000', 'consum', 0.0283, 'lps'),
	(662141, 135, '2015-01-15 01:02:33.000000', 'consum', 0.0255, 'lps'),
	(662142, 135, '2015-01-15 01:02:34.000000', 'consum', 0.0216, 'lps'),
	(662143, 135, '2015-01-15 01:02:35.000000', 'consum', 0.0254, 'lps'),
	(662144, 135, '2015-01-15 01:02:36.000000', 'consum', 0.0265, 'lps'),
	(662145, 135, '2015-01-15 01:02:37.000000', 'consum', 0.0278, 'lps'),
	(662146, 135, '2015-01-15 01:02:38.000000', 'consum', 0.0238, 'lps'),
	(662147, 135, '2015-01-15 01:02:39.000000', 'consum', 0.0219, 'lps'),
	(662148, 135, '2015-01-15 01:02:40.000000', 'consum', 0.0245, 'lps'),
	(662149, 135, '2015-01-15 01:02:41.000000', 'consum', 0.0214, 'lps'),
	(662150, 135, '2015-01-15 01:02:42.000000', 'consum', 0.0271, 'lps'),
	(662151, 135, '2015-01-15 01:02:43.000000', 'consum', 0.0282, 'lps'),
	(662152, 135, '2015-01-15 01:02:44.000000', 'consum', 0.0239, 'lps'),
	(662153, 135, '2015-01-15 01:02:45.000000', 'consum', 0.0214, 'lps'),
	(662154, 135, '2015-01-15 01:02:46.000000', 'consum', 0.0219, 'lps'),
	(662155, 135, '2015-01-15 01:02:47.000000', 'consum', 0.0240, 'lps'),
	(662156, 135, '2015-01-15 01:02:48.000000', 'consum', 0.0262, 'lps'),
	(662157, 135, '2015-01-15 01:02:49.000000', 'consum', 0.0234, 'lps'),
	(662158, 135, '2015-01-15 01:02:50.000000', 'consum', 0.0247, 'lps'),
	(662159, 135, '2015-01-15 01:02:51.000000', 'consum', 0.0249, 'lps'),
	(662160, 135, '2015-01-15 01:02:52.000000', 'consum', 0.0220, 'lps'),
	(662161, 135, '2015-01-15 01:02:53.000000', 'consum', 0.0217, 'lps'),
	(662162, 135, '2015-01-15 01:02:54.000000', 'consum', 0.0217, 'lps'),
	(662163, 135, '2015-01-15 01:02:55.000000', 'consum', 0.0222, 'lps'),
	(662164, 135, '2015-01-15 01:02:56.000000', 'consum', 0.0251, 'lps'),
	(662165, 135, '2015-01-15 01:02:57.000000', 'consum', 0.0230, 'lps'),
	(662166, 135, '2015-01-15 01:02:58.000000', 'consum', 0.0262, 'lps'),
	(662167, 135, '2015-01-15 01:02:59.000000', 'consum', 0.0265, 'lps'),
	(662168, 135, '2015-01-15 01:03:00.000000', 'consum', 0.0253, 'lps'),
	(662169, 135, '2015-01-15 01:03:01.000000', 'consum', 0.0263, 'lps'),
	(662170, 135, '2015-01-15 01:03:02.000000', 'consum', 0.0270, 'lps'),
	(662171, 135, '2015-01-15 01:03:03.000000', 'consum', 0.0277, 'lps'),
	(662172, 135, '2015-01-15 01:03:04.000000', 'consum', 0.0219, 'lps'),
	(662173, 135, '2015-01-15 01:03:05.000000', 'consum', 0.0277, 'lps'),
	(662174, 135, '2015-01-15 01:03:06.000000', 'consum', 0.0222, 'lps'),
	(662175, 135, '2015-01-15 01:03:07.000000', 'consum', 0.0219, 'lps'),
	(662176, 135, '2015-01-15 01:03:08.000000', 'consum', 0.0218, 'lps'),
	(662177, 135, '2015-01-15 01:03:09.000000', 'consum', 0.0224, 'lps'),
	(662178, 135, '2015-01-15 01:03:10.000000', 'consum', 0.0256, 'lps'),
	(662179, 135, '2015-01-15 01:03:11.000000', 'consum', 0.0249, 'lps'),
	(662180, 135, '2015-01-15 01:03:12.000000', 'consum', 0.0269, 'lps'),
	(662181, 135, '2015-01-15 01:03:13.000000', 'consum', 0.0242, 'lps'),
	(662182, 135, '2015-01-15 01:03:14.000000', 'consum', 0.0267, 'lps'),
	(662183, 135, '2015-01-15 01:03:15.000000', 'consum', 0.0251, 'lps'),
	(662184, 135, '2015-01-15 01:03:16.000000', 'consum', 0.0246, 'lps'),
	(662185, 135, '2015-01-15 01:03:17.000000', 'consum', 0.0266, 'lps'),
	(662186, 135, '2015-01-15 01:03:18.000000', 'consum', 0.0237, 'lps'),
	(662187, 135, '2015-01-15 01:03:19.000000', 'consum', 0.0250, 'lps'),
	(662188, 135, '2015-01-15 01:03:20.000000', 'consum', 0.0254, 'lps'),
	(662189, 135, '2015-01-15 01:03:21.000000', 'consum', 0.0235, 'lps'),
	(662190, 135, '2015-01-15 01:03:22.000000', 'consum', 0.0281, 'lps'),
	(662191, 135, '2015-01-15 01:03:23.000000', 'consum', 0.0267, 'lps'),
	(662192, 135, '2015-01-15 01:03:24.000000', 'consum', 0.0283, 'lps'),
	(662193, 135, '2015-01-15 01:03:25.000000', 'consum', 0.0257, 'lps'),
	(662194, 135, '2015-01-15 01:03:26.000000', 'consum', 0.0225, 'lps'),
	(662195, 135, '2015-01-15 01:03:27.000000', 'consum', 0.0219, 'lps'),
	(662196, 135, '2015-01-15 01:03:28.000000', 'consum', 0.0210, 'lps'),
	(662197, 135, '2015-01-15 01:03:29.000000', 'consum', 0.0257, 'lps'),
	(662198, 135, '2015-01-15 01:03:30.000000', 'consum', 0.0223, 'lps'),
	(662199, 135, '2015-01-15 01:03:31.000000', 'consum', 0.0283, 'lps'),
	(662200, 135, '2015-01-15 01:03:32.000000', 'consum', 0.0241, 'lps'),
	(662201, 135, '2015-01-15 01:03:33.000000', 'consum', 0.0222, 'lps'),
	(662202, 135, '2015-01-15 01:03:34.000000', 'consum', 0.0250, 'lps'),
	(662203, 135, '2015-01-15 01:03:35.000000', 'consum', 0.0228, 'lps'),
	(662204, 135, '2015-01-15 01:03:36.000000', 'consum', 0.0253, 'lps'),
	(662205, 135, '2015-01-15 01:03:37.000000', 'consum', 0.0224, 'lps'),
	(662206, 135, '2015-01-15 01:03:38.000000', 'consum', 0.0227, 'lps'),
	(662207, 135, '2015-01-15 01:03:39.000000', 'consum', 0.0252, 'lps'),
	(662208, 135, '2015-01-15 01:03:40.000000', 'consum', 0.0222, 'lps'),
	(662209, 135, '2015-01-15 01:03:41.000000', 'consum', 0.0220, 'lps'),
	(662210, 135, '2015-01-15 01:03:42.000000', 'consum', 0.0223, 'lps'),
	(662211, 135, '2015-01-15 01:03:43.000000', 'consum', 0.0245, 'lps'),
	(662212, 135, '2015-01-15 01:03:44.000000', 'consum', 0.0271, 'lps'),
	(662213, 135, '2015-01-15 01:03:45.000000', 'consum', 0.0265, 'lps'),
	(662214, 135, '2015-01-15 01:03:46.000000', 'consum', 0.0226, 'lps'),
	(662215, 135, '2015-01-15 01:03:47.000000', 'consum', 0.0273, 'lps'),
	(662216, 135, '2015-01-15 01:03:48.000000', 'consum', 0.0257, 'lps'),
	(662217, 135, '2015-01-15 01:03:49.000000', 'consum', 0.0257, 'lps'),
	(662218, 135, '2015-01-15 01:03:50.000000', 'consum', 0.0229, 'lps'),
	(662219, 135, '2015-01-15 01:03:51.000000', 'consum', 0.0241, 'lps'),
	(662220, 135, '2015-01-15 01:03:52.000000', 'consum', 0.0232, 'lps'),
	(662221, 135, '2015-01-15 01:03:53.000000', 'consum', 0.0227, 'lps'),
	(662222, 135, '2015-01-15 01:03:54.000000', 'consum', 0.0231, 'lps'),
	(662223, 135, '2015-01-15 01:03:55.000000', 'consum', 0.0264, 'lps'),
	(662224, 135, '2015-01-15 01:03:56.000000', 'consum', 0.0271, 'lps'),
	(662225, 135, '2015-01-15 01:03:57.000000', 'consum', 0.0280, 'lps'),
	(662226, 135, '2015-01-15 01:03:58.000000', 'consum', 0.0228, 'lps'),
	(662227, 135, '2015-01-15 01:03:59.000000', 'consum', 0.0240, 'lps'),
	(662228, 135, '2015-01-15 01:04:00.000000', 'consum', 0.0233, 'lps'),
	(662229, 135, '2015-01-15 01:04:01.000000', 'consum', 0.0233, 'lps'),
	(662230, 135, '2015-01-15 01:04:02.000000', 'consum', 0.0257, 'lps'),
	(662231, 135, '2015-01-15 01:04:03.000000', 'consum', 0.0228, 'lps'),
	(662232, 135, '2015-01-15 01:04:04.000000', 'consum', 0.0233, 'lps'),
	(662233, 135, '2015-01-15 01:04:05.000000', 'consum', 0.0271, 'lps'),
	(662234, 135, '2015-01-15 01:04:06.000000', 'consum', 0.0227, 'lps'),
	(662235, 135, '2015-01-15 01:04:07.000000', 'consum', 0.0257, 'lps'),
	(662236, 135, '2015-01-15 01:04:08.000000', 'consum', 0.0249, 'lps'),
	(662237, 135, '2015-01-15 01:04:09.000000', 'consum', 0.0265, 'lps'),
	(662238, 135, '2015-01-15 01:04:10.000000', 'consum', 0.0221, 'lps'),
	(662239, 135, '2015-01-15 01:04:11.000000', 'consum', 0.0246, 'lps'),
	(662240, 135, '2015-01-15 01:04:12.000000', 'consum', 0.0283, 'lps'),
	(662241, 135, '2015-01-15 01:04:13.000000', 'consum', 0.0248, 'lps'),
	(662242, 135, '2015-01-15 01:04:14.000000', 'consum', 0.0256, 'lps'),
	(662243, 135, '2015-01-15 01:04:15.000000', 'consum', 0.0250, 'lps'),
	(662244, 135, '2015-01-15 01:04:16.000000', 'consum', 0.0275, 'lps'),
	(662245, 135, '2015-01-15 01:04:17.000000', 'consum', 0.0265, 'lps'),
	(662246, 135, '2015-01-15 01:04:18.000000', 'consum', 0.0219, 'lps'),
	(662247, 135, '2015-01-15 01:04:19.000000', 'consum', 0.0237, 'lps'),
	(662248, 135, '2015-01-15 01:04:20.000000', 'consum', 0.0247, 'lps'),
	(662249, 135, '2015-01-15 01:04:21.000000', 'consum', 0.0238, 'lps'),
	(662250, 135, '2015-01-15 01:04:22.000000', 'consum', 0.0241, 'lps'),
	(662251, 135, '2015-01-15 01:04:23.000000', 'consum', 0.0280, 'lps'),
	(662252, 135, '2015-01-15 01:04:24.000000', 'consum', 0.0244, 'lps'),
	(662253, 135, '2015-01-15 01:04:25.000000', 'consum', 0.0247, 'lps'),
	(662254, 135, '2015-01-15 01:04:26.000000', 'consum', 0.0218, 'lps'),
	(662255, 135, '2015-01-15 01:04:27.000000', 'consum', 0.0213, 'lps'),
	(662256, 135, '2015-01-15 01:04:28.000000', 'consum', 0.0276, 'lps'),
	(662257, 135, '2015-01-15 01:04:29.000000', 'consum', 0.0234, 'lps'),
	(662258, 135, '2015-01-15 01:04:30.000000', 'consum', 0.0281, 'lps'),
	(662259, 135, '2015-01-15 01:04:31.000000', 'consum', 0.0274, 'lps'),
	(662260, 135, '2015-01-15 01:04:32.000000', 'consum', 0.0242, 'lps'),
	(662261, 135, '2015-01-15 01:04:33.000000', 'consum', 0.0253, 'lps'),
	(662262, 135, '2015-01-15 01:04:34.000000', 'consum', 0.0254, 'lps'),
	(662263, 135, '2015-01-15 01:04:35.000000', 'consum', 0.0230, 'lps'),
	(662264, 135, '2015-01-15 01:04:36.000000', 'consum', 0.0250, 'lps'),
	(662265, 135, '2015-01-15 01:04:37.000000', 'consum', 0.0278, 'lps'),
	(662266, 135, '2015-01-15 01:04:38.000000', 'consum', 0.0210, 'lps'),
	(662267, 135, '2015-01-15 01:04:39.000000', 'consum', 0.0227, 'lps'),
	(662268, 135, '2015-01-15 01:04:40.000000', 'consum', 0.0223, 'lps'),
	(662269, 135, '2015-01-15 01:04:41.000000', 'consum', 0.0223, 'lps'),
	(662270, 135, '2015-01-15 01:04:42.000000', 'consum', 0.0238, 'lps'),
	(662271, 135, '2015-01-15 01:04:43.000000', 'consum', 0.0238, 'lps'),
	(662272, 135, '2015-01-15 01:04:44.000000', 'consum', 0.0268, 'lps'),
	(662273, 135, '2015-01-15 01:04:45.000000', 'consum', 0.0265, 'lps'),
	(662274, 135, '2015-01-15 01:04:46.000000', 'consum', 0.0240, 'lps'),
	(662275, 135, '2015-01-15 01:04:47.000000', 'consum', 0.0270, 'lps'),
	(662276, 135, '2015-01-15 01:04:48.000000', 'consum', 0.0271, 'lps'),
	(662277, 135, '2015-01-15 01:04:49.000000', 'consum', 0.0262, 'lps'),
	(662278, 135, '2015-01-15 01:04:50.000000', 'consum', 0.0211, 'lps'),
	(662279, 135, '2015-01-15 01:04:51.000000', 'consum', 0.0211, 'lps'),
	(662280, 135, '2015-01-15 01:04:52.000000', 'consum', 0.0212, 'lps'),
	(662281, 135, '2015-01-15 01:04:53.000000', 'consum', 0.0217, 'lps'),
	(662282, 135, '2015-01-15 01:04:54.000000', 'consum', 0.0242, 'lps'),
	(662283, 135, '2015-01-15 01:04:55.000000', 'consum', 0.0272, 'lps'),
	(662284, 135, '2015-01-15 01:04:56.000000', 'consum', 0.0278, 'lps'),
	(662285, 135, '2015-01-15 01:04:57.000000', 'consum', 0.0217, 'lps'),
	(662286, 135, '2015-01-15 01:04:58.000000', 'consum', 0.0262, 'lps'),
	(662287, 135, '2015-01-15 01:04:59.000000', 'consum', 0.0227, 'lps'),
	(662288, 135, '2015-01-15 01:05:00.000000', 'consum', 0.0213, 'lps'),
	(662289, 135, '2015-01-15 01:05:01.000000', 'consum', 0.0247, 'lps'),
	(662290, 135, '2015-01-15 01:05:02.000000', 'consum', 0.0242, 'lps'),
	(662291, 135, '2015-01-15 01:05:03.000000', 'consum', 0.0256, 'lps'),
	(662292, 135, '2015-01-15 01:05:04.000000', 'consum', 0.0274, 'lps'),
	(662293, 135, '2015-01-15 01:05:05.000000', 'consum', 0.0242, 'lps'),
	(662294, 135, '2015-01-15 01:05:06.000000', 'consum', 0.0251, 'lps'),
	(662295, 135, '2015-01-15 01:05:07.000000', 'consum', 0.0249, 'lps'),
	(662296, 135, '2015-01-15 01:05:08.000000', 'consum', 0.0280, 'lps'),
	(662297, 135, '2015-01-15 01:05:09.000000', 'consum', 0.0222, 'lps'),
	(662298, 135, '2015-01-15 01:05:10.000000', 'consum', 0.0210, 'lps'),
	(662299, 135, '2015-01-15 01:05:11.000000', 'consum', 0.0247, 'lps'),
	(662300, 135, '2015-01-15 01:05:12.000000', 'consum', 0.0249, 'lps'),
	(662301, 135, '2015-01-15 01:05:13.000000', 'consum', 0.0222, 'lps'),
	(662302, 135, '2015-01-15 01:05:14.000000', 'consum', 0.0225, 'lps'),
	(662303, 135, '2015-01-15 01:05:15.000000', 'consum', 0.0252, 'lps'),
	(662304, 135, '2015-01-15 01:05:16.000000', 'consum', 0.0226, 'lps'),
	(662305, 135, '2015-01-15 01:05:17.000000', 'consum', 0.0239, 'lps'),
	(662306, 135, '2015-01-15 01:05:18.000000', 'consum', 0.0231, 'lps'),
	(662307, 135, '2015-01-15 01:05:19.000000', 'consum', 0.0232, 'lps'),
	(662308, 135, '2015-01-15 01:05:20.000000', 'consum', 0.0257, 'lps'),
	(662309, 135, '2015-01-15 01:05:21.000000', 'consum', 0.0230, 'lps'),
	(662310, 135, '2015-01-15 01:05:22.000000', 'consum', 0.0246, 'lps'),
	(662311, 135, '2015-01-15 01:05:23.000000', 'consum', 0.0253, 'lps'),
	(662312, 135, '2015-01-15 01:05:24.000000', 'consum', 0.0245, 'lps'),
	(662313, 135, '2015-01-15 01:05:25.000000', 'consum', 0.0258, 'lps'),
	(662314, 135, '2015-01-15 01:05:26.000000', 'consum', 0.0271, 'lps'),
	(662315, 135, '2015-01-15 01:05:27.000000', 'consum', 0.0224, 'lps'),
	(662316, 135, '2015-01-15 01:05:28.000000', 'consum', 0.0246, 'lps'),
	(662317, 135, '2015-01-15 01:05:29.000000', 'consum', 0.0275, 'lps'),
	(662318, 135, '2015-01-15 01:05:30.000000', 'consum', 0.0281, 'lps'),
	(662319, 135, '2015-01-15 01:05:31.000000', 'consum', 0.0219, 'lps'),
	(662320, 135, '2015-01-15 01:05:32.000000', 'consum', 0.0265, 'lps'),
	(662321, 135, '2015-01-15 01:05:33.000000', 'consum', 0.0236, 'lps'),
	(662322, 135, '2015-01-15 01:05:34.000000', 'consum', 0.0249, 'lps'),
	(662323, 135, '2015-01-15 01:05:35.000000', 'consum', 0.0254, 'lps'),
	(662324, 135, '2015-01-15 01:05:36.000000', 'consum', 0.0239, 'lps'),
	(662325, 135, '2015-01-15 01:05:37.000000', 'consum', 0.0223, 'lps'),
	(662326, 135, '2015-01-15 01:05:38.000000', 'consum', 0.0265, 'lps'),
	(662327, 135, '2015-01-15 01:05:39.000000', 'consum', 0.0224, 'lps'),
	(662328, 135, '2015-01-15 01:05:40.000000', 'consum', 0.0262, 'lps'),
	(662329, 135, '2015-01-15 01:05:41.000000', 'consum', 0.0283, 'lps'),
	(662330, 135, '2015-01-15 01:05:42.000000', 'consum', 0.0268, 'lps'),
	(662331, 135, '2015-01-15 01:05:43.000000', 'consum', 0.0211, 'lps'),
	(662332, 135, '2015-01-15 01:05:44.000000', 'consum', 0.0263, 'lps'),
	(662333, 135, '2015-01-15 01:05:45.000000', 'consum', 0.0249, 'lps'),
	(662334, 135, '2015-01-15 01:05:46.000000', 'consum', 0.0246, 'lps'),
	(662335, 135, '2015-01-15 01:05:47.000000', 'consum', 0.0273, 'lps'),
	(662336, 135, '2015-01-15 01:05:48.000000', 'consum', 0.0269, 'lps'),
	(662337, 135, '2015-01-15 01:05:49.000000', 'consum', 0.0245, 'lps'),
	(662338, 135, '2015-01-15 01:05:50.000000', 'consum', 0.0280, 'lps'),
	(662339, 135, '2015-01-15 01:05:51.000000', 'consum', 0.0233, 'lps'),
	(662340, 135, '2015-01-15 01:05:52.000000', 'consum', 0.0264, 'lps'),
	(662341, 135, '2015-01-15 01:05:53.000000', 'consum', 0.0264, 'lps'),
	(662342, 135, '2015-01-15 01:05:54.000000', 'consum', 0.0246, 'lps'),
	(662343, 135, '2015-01-15 01:05:55.000000', 'consum', 0.0226, 'lps'),
	(662344, 135, '2015-01-15 01:05:56.000000', 'consum', 0.0256, 'lps'),
	(662345, 135, '2015-01-15 01:05:57.000000', 'consum', 0.0244, 'lps'),
	(662346, 135, '2015-01-15 01:05:58.000000', 'consum', 0.0244, 'lps'),
	(662347, 135, '2015-01-15 01:05:59.000000', 'consum', 0.0279, 'lps'),
	(662348, 135, '2015-01-15 01:06:00.000000', 'consum', 0.0231, 'lps'),
	(662349, 135, '2015-01-15 01:06:01.000000', 'consum', 0.0257, 'lps'),
	(662350, 135, '2015-01-15 01:06:02.000000', 'consum', 0.0235, 'lps'),
	(662351, 135, '2015-01-15 01:06:03.000000', 'consum', 0.0269, 'lps'),
	(662352, 135, '2015-01-15 01:06:04.000000', 'consum', 0.0280, 'lps'),
	(662353, 135, '2015-01-15 01:06:05.000000', 'consum', 0.0237, 'lps'),
	(662354, 135, '2015-01-15 01:06:06.000000', 'consum', 0.0283, 'lps'),
	(662355, 135, '2015-01-15 01:06:07.000000', 'consum', 0.0273, 'lps'),
	(662356, 135, '2015-01-15 01:06:08.000000', 'consum', 0.0231, 'lps'),
	(662357, 135, '2015-01-15 01:06:09.000000', 'consum', 0.0276, 'lps'),
	(662358, 135, '2015-01-15 01:06:10.000000', 'consum', 0.0257, 'lps'),
	(662359, 135, '2015-01-15 01:06:11.000000', 'consum', 0.0245, 'lps'),
	(662360, 135, '2015-01-15 01:06:12.000000', 'consum', 0.0246, 'lps'),
	(662361, 135, '2015-01-15 01:06:13.000000', 'consum', 0.0211, 'lps'),
	(662362, 135, '2015-01-15 01:06:14.000000', 'consum', 0.0257, 'lps'),
	(662363, 135, '2015-01-15 01:06:15.000000', 'consum', 0.0220, 'lps'),
	(662364, 135, '2015-01-15 01:06:16.000000', 'consum', 0.0268, 'lps'),
	(662365, 135, '2015-01-15 01:06:17.000000', 'consum', 0.0249, 'lps'),
	(662366, 135, '2015-01-15 01:06:18.000000', 'consum', 0.0233, 'lps'),
	(662367, 135, '2015-01-15 01:06:19.000000', 'consum', 0.0279, 'lps'),
	(662368, 135, '2015-01-15 01:06:20.000000', 'consum', 0.0267, 'lps'),
	(662369, 135, '2015-01-15 01:06:21.000000', 'consum', 0.0216, 'lps'),
	(662370, 135, '2015-01-15 01:06:22.000000', 'consum', 0.0214, 'lps'),
	(662371, 135, '2015-01-15 01:06:23.000000', 'consum', 0.0214, 'lps'),
	(662372, 135, '2015-01-15 01:06:24.000000', 'consum', 0.0220, 'lps'),
	(662373, 135, '2015-01-15 01:06:25.000000', 'consum', 0.0249, 'lps'),
	(662374, 135, '2015-01-15 01:06:26.000000', 'consum', 0.0227, 'lps'),
	(662375, 135, '2015-01-15 01:06:27.000000', 'consum', 0.0252, 'lps'),
	(662376, 135, '2015-01-15 01:06:28.000000', 'consum', 0.0221, 'lps'),
	(662377, 135, '2015-01-15 01:06:29.000000', 'consum', 0.0216, 'lps'),
	(662378, 135, '2015-01-15 01:06:30.000000', 'consum', 0.0280, 'lps'),
	(662379, 135, '2015-01-15 01:06:31.000000', 'consum', 0.0247, 'lps'),
	(662380, 135, '2015-01-15 01:06:32.000000', 'consum', 0.0257, 'lps'),
	(662381, 135, '2015-01-15 01:06:33.000000', 'consum', 0.0263, 'lps'),
	(662382, 135, '2015-01-15 01:06:34.000000', 'consum', 0.0260, 'lps'),
	(662383, 135, '2015-01-15 01:06:35.000000', 'consum', 0.0226, 'lps'),
	(662384, 135, '2015-01-15 01:06:36.000000', 'consum', 0.0217, 'lps'),
	(662385, 135, '2015-01-15 01:06:37.000000', 'consum', 0.0270, 'lps'),
	(662386, 135, '2015-01-15 01:06:38.000000', 'consum', 0.0267, 'lps'),
	(662387, 135, '2015-01-15 01:06:39.000000', 'consum', 0.0241, 'lps'),
	(662388, 135, '2015-01-15 01:06:40.000000', 'consum', 0.0270, 'lps'),
	(662389, 135, '2015-01-15 01:06:41.000000', 'consum', 0.0267, 'lps'),
	(662390, 135, '2015-01-15 01:06:42.000000', 'consum', 0.0243, 'lps'),
	(662391, 135, '2015-01-15 01:06:43.000000', 'consum', 0.0278, 'lps'),
	(662392, 135, '2015-01-15 01:06:44.000000', 'consum', 0.0228, 'lps'),
	(662393, 135, '2015-01-15 01:06:45.000000', 'consum', 0.0245, 'lps'),
	(662394, 135, '2015-01-15 01:06:46.000000', 'consum', 0.0257, 'lps'),
	(662395, 135, '2015-01-15 01:06:47.000000', 'consum', 0.0267, 'lps'),
	(662396, 135, '2015-01-15 01:06:48.000000', 'consum', 0.0279, 'lps'),
	(662397, 135, '2015-01-15 01:06:49.000000', 'consum', 0.0236, 'lps'),
	(662398, 135, '2015-01-15 01:06:50.000000', 'consum', 0.0281, 'lps'),
	(662399, 135, '2015-01-15 01:06:51.000000', 'consum', 0.0267, 'lps'),
	(662400, 135, '2015-01-15 01:06:52.000000', 'consum', 0.0210, 'lps'),
	(662401, 135, '2015-01-15 01:06:53.000000', 'consum', 0.0258, 'lps'),
	(662402, 135, '2015-01-15 01:06:54.000000', 'consum', 0.0231, 'lps'),
	(662403, 135, '2015-01-15 01:06:55.000000', 'consum', 0.0245, 'lps'),
	(662404, 135, '2015-01-15 01:06:56.000000', 'consum', 0.0250, 'lps'),
	(662405, 135, '2015-01-15 01:06:57.000000', 'consum', 0.0232, 'lps'),
	(662406, 135, '2015-01-15 01:06:58.000000', 'consum', 0.0272, 'lps'),
	(662407, 135, '2015-01-15 01:06:59.000000', 'consum', 0.0235, 'lps'),
	(662408, 135, '2015-01-15 01:07:00.000000', 'consum', 0.0222, 'lps'),
	(662409, 135, '2015-01-15 01:07:01.000000', 'consum', 0.0268, 'lps'),
	(662410, 135, '2015-01-15 01:07:02.000000', 'consum', 0.0243, 'lps'),
	(662411, 135, '2015-01-15 01:07:03.000000', 'consum', 0.0275, 'lps'),
	(662412, 135, '2015-01-15 01:07:04.000000', 'consum', 0.0215, 'lps'),
	(662413, 135, '2015-01-15 01:07:05.000000', 'consum', 0.0261, 'lps'),
	(662414, 135, '2015-01-15 01:07:06.000000', 'consum', 0.0230, 'lps'),
	(662415, 135, '2015-01-15 01:07:07.000000', 'consum', 0.0230, 'lps'),
	(662416, 135, '2015-01-15 01:07:08.000000', 'consum', 0.0251, 'lps'),
	(662417, 135, '2015-01-15 01:07:09.000000', 'consum', 0.0281, 'lps'),
	(662418, 135, '2015-01-15 01:07:10.000000', 'consum', 0.0220, 'lps'),
	(662419, 135, '2015-01-15 01:07:11.000000', 'consum', 0.0272, 'lps'),
	(662420, 135, '2015-01-15 01:07:12.000000', 'consum', 0.0268, 'lps'),
	(662421, 135, '2015-01-15 01:07:13.000000', 'consum', 0.0242, 'lps'),
	(662422, 135, '2015-01-15 01:07:14.000000', 'consum', 0.0267, 'lps'),
	(662423, 135, '2015-01-15 01:07:15.000000', 'consum', 0.0253, 'lps'),
	(662424, 135, '2015-01-15 01:07:16.000000', 'consum', 0.0255, 'lps'),
	(662425, 135, '2015-01-15 01:07:17.000000', 'consum', 0.0231, 'lps'),
	(662426, 135, '2015-01-15 01:07:18.000000', 'consum', 0.0255, 'lps'),
	(662427, 135, '2015-01-15 01:07:19.000000', 'consum', 0.0225, 'lps'),
	(662428, 135, '2015-01-15 01:07:20.000000', 'consum', 0.0223, 'lps'),
	(662429, 135, '2015-01-15 01:07:21.000000', 'consum', 0.0233, 'lps'),
	(662430, 135, '2015-01-15 01:07:22.000000', 'consum', 0.0212, 'lps'),
	(662431, 135, '2015-01-15 01:07:23.000000', 'consum', 0.0224, 'lps'),
	(662432, 135, '2015-01-15 01:07:24.000000', 'consum', 0.0276, 'lps'),
	(662433, 135, '2015-01-15 01:07:25.000000', 'consum', 0.0274, 'lps'),
	(662434, 135, '2015-01-15 01:07:26.000000', 'consum', 0.0261, 'lps'),
	(662435, 135, '2015-01-15 01:07:27.000000', 'consum', 0.0272, 'lps'),
	(662436, 135, '2015-01-15 01:07:28.000000', 'consum', 0.0219, 'lps'),
	(662437, 135, '2015-01-15 01:07:29.000000', 'consum', 0.0218, 'lps'),
	(662438, 135, '2015-01-15 01:07:30.000000', 'consum', 0.0224, 'lps'),
	(662439, 135, '2015-01-15 01:07:31.000000', 'consum', 0.0258, 'lps'),
	(662440, 135, '2015-01-15 01:07:32.000000', 'consum', 0.0259, 'lps'),
	(662441, 135, '2015-01-15 01:07:33.000000', 'consum', 0.0237, 'lps'),
	(662442, 135, '2015-01-15 01:07:34.000000', 'consum', 0.0275, 'lps'),
	(662443, 135, '2015-01-15 01:07:35.000000', 'consum', 0.0230, 'lps'),
	(662444, 135, '2015-01-15 01:07:36.000000', 'consum', 0.0263, 'lps'),
	(662445, 135, '2015-01-15 01:07:37.000000', 'consum', 0.0270, 'lps'),
	(662446, 135, '2015-01-15 01:07:38.000000', 'consum', 0.0278, 'lps'),
	(662447, 135, '2015-01-15 01:07:39.000000', 'consum', 0.0223, 'lps'),
	(662448, 135, '2015-01-15 01:07:40.000000', 'consum', 0.0217, 'lps'),
	(662449, 135, '2015-01-15 01:07:41.000000', 'consum', 0.0282, 'lps'),
	(662450, 135, '2015-01-15 01:07:42.000000', 'consum', 0.0253, 'lps'),
	(662451, 135, '2015-01-15 01:07:43.000000', 'consum', 0.0211, 'lps'),
	(662452, 135, '2015-01-15 01:07:44.000000', 'consum', 0.0233, 'lps'),
	(662453, 135, '2015-01-15 01:07:45.000000', 'consum', 0.0248, 'lps'),
	(662454, 135, '2015-01-15 01:07:46.000000', 'consum', 0.0259, 'lps'),
	(662455, 135, '2015-01-15 01:07:47.000000', 'consum', 0.0265, 'lps'),
	(662456, 135, '2015-01-15 01:07:48.000000', 'consum', 0.0267, 'lps'),
	(662457, 135, '2015-01-15 01:07:49.000000', 'consum', 0.0254, 'lps'),
	(662458, 135, '2015-01-15 01:07:50.000000', 'consum', 0.0262, 'lps'),
	(662459, 135, '2015-01-15 01:07:51.000000', 'consum', 0.0265, 'lps'),
	(662460, 135, '2015-01-15 01:07:52.000000', 'consum', 0.0255, 'lps'),
	(662461, 135, '2015-01-15 01:07:53.000000', 'consum', 0.0271, 'lps'),
	(662462, 135, '2015-01-15 01:07:54.000000', 'consum', 0.0230, 'lps'),
	(662463, 135, '2015-01-15 01:07:55.000000', 'consum', 0.0276, 'lps'),
	(662464, 135, '2015-01-15 01:07:56.000000', 'consum', 0.0259, 'lps'),
	(662465, 135, '2015-01-15 01:07:57.000000', 'consum', 0.0259, 'lps'),
	(662466, 135, '2015-01-15 01:07:58.000000', 'consum', 0.0234, 'lps'),
	(662467, 135, '2015-01-15 01:07:59.000000', 'consum', 0.0256, 'lps'),
	(662468, 135, '2015-01-15 01:08:00.000000', 'consum', 0.0222, 'lps'),
	(662469, 135, '2015-01-15 01:08:01.000000', 'consum', 0.0280, 'lps'),
	(662470, 135, '2015-01-15 01:08:02.000000', 'consum', 0.0228, 'lps'),
	(662471, 135, '2015-01-15 01:08:03.000000', 'consum', 0.0237, 'lps'),
	(662472, 135, '2015-01-15 01:08:04.000000', 'consum', 0.0219, 'lps'),
	(662473, 135, '2015-01-15 01:08:05.000000', 'consum', 0.0249, 'lps'),
	(662474, 135, '2015-01-15 01:08:06.000000', 'consum', 0.0232, 'lps'),
	(662475, 135, '2015-01-15 01:08:07.000000', 'consum', 0.0276, 'lps'),
	(662476, 135, '2015-01-15 01:08:08.000000', 'consum', 0.0252, 'lps'),
	(662477, 135, '2015-01-15 01:08:09.000000', 'consum', 0.0223, 'lps'),
	(662478, 135, '2015-01-15 01:08:10.000000', 'consum', 0.0225, 'lps'),
	(662479, 135, '2015-01-15 01:08:11.000000', 'consum', 0.0246, 'lps'),
	(662480, 135, '2015-01-15 01:08:12.000000', 'consum', 0.0272, 'lps'),
	(662481, 135, '2015-01-15 01:08:13.000000', 'consum', 0.0266, 'lps'),
	(662482, 135, '2015-01-15 01:08:14.000000', 'consum', 0.0229, 'lps'),
	(662483, 135, '2015-01-15 01:08:15.000000', 'consum', 0.0210, 'lps'),
	(662484, 135, '2015-01-15 01:08:16.000000', 'consum', 0.0230, 'lps'),
	(662485, 135, '2015-01-15 01:08:17.000000', 'consum', 0.0234, 'lps'),
	(662486, 135, '2015-01-15 01:08:18.000000', 'consum', 0.0271, 'lps'),
	(662487, 135, '2015-01-15 01:08:19.000000', 'consum', 0.0221, 'lps'),
	(662488, 135, '2015-01-15 01:08:20.000000', 'consum', 0.0231, 'lps'),
	(662489, 135, '2015-01-15 01:08:21.000000', 'consum', 0.0283, 'lps'),
	(662490, 135, '2015-01-15 01:08:22.000000', 'consum', 0.0216, 'lps'),
	(662491, 135, '2015-01-15 01:08:23.000000', 'consum', 0.0242, 'lps'),
	(662492, 135, '2015-01-15 01:08:24.000000', 'consum', 0.0282, 'lps'),
	(662493, 135, '2015-01-15 01:08:25.000000', 'consum', 0.0249, 'lps'),
	(662494, 135, '2015-01-15 01:08:26.000000', 'consum', 0.0264, 'lps'),
	(662495, 135, '2015-01-15 01:08:27.000000', 'consum', 0.0215, 'lps'),
	(662496, 135, '2015-01-15 01:08:28.000000', 'consum', 0.0221, 'lps'),
	(662497, 135, '2015-01-15 01:08:29.000000', 'consum', 0.0252, 'lps'),
	(662498, 135, '2015-01-15 01:08:30.000000', 'consum', 0.0239, 'lps'),
	(662499, 135, '2015-01-15 01:08:31.000000', 'consum', 0.0231, 'lps'),
	(662500, 135, '2015-01-15 01:08:32.000000', 'consum', 0.0227, 'lps'),
	(662501, 135, '2015-01-15 01:08:33.000000', 'consum', 0.0233, 'lps'),
	(662502, 135, '2015-01-15 01:08:34.000000', 'consum', 0.0273, 'lps'),
	(662503, 135, '2015-01-15 01:08:35.000000', 'consum', 0.0234, 'lps'),
	(662504, 135, '2015-01-15 01:08:36.000000', 'consum', 0.0216, 'lps'),
	(662505, 135, '2015-01-15 01:08:37.000000', 'consum', 0.0242, 'lps'),
	(662506, 135, '2015-01-15 01:08:38.000000', 'consum', 0.0278, 'lps'),
	(662507, 135, '2015-01-15 01:08:39.000000', 'consum', 0.0234, 'lps'),
	(662508, 135, '2015-01-15 01:08:40.000000', 'consum', 0.0275, 'lps'),
	(662509, 135, '2015-01-15 01:08:41.000000', 'consum', 0.0242, 'lps'),
	(662510, 135, '2015-01-15 01:08:42.000000', 'consum', 0.0249, 'lps'),
	(662511, 135, '2015-01-15 01:08:43.000000', 'consum', 0.0235, 'lps'),
	(662512, 135, '2015-01-15 01:08:44.000000', 'consum', 0.0219, 'lps'),
	(662513, 135, '2015-01-15 01:08:45.000000', 'consum', 0.0253, 'lps'),
	(662514, 135, '2015-01-15 01:08:46.000000', 'consum', 0.0251, 'lps'),
	(662515, 135, '2015-01-15 01:08:47.000000', 'consum', 0.0211, 'lps'),
	(662516, 135, '2015-01-15 01:08:48.000000', 'consum', 0.0244, 'lps'),
	(662517, 135, '2015-01-15 01:08:49.000000', 'consum', 0.0226, 'lps'),
	(662518, 135, '2015-01-15 01:08:50.000000', 'consum', 0.0265, 'lps'),
	(662519, 135, '2015-01-15 01:08:51.000000', 'consum', 0.0216, 'lps'),
	(662520, 135, '2015-01-15 01:08:52.000000', 'consum', 0.0224, 'lps'),
	(662521, 135, '2015-01-15 01:08:53.000000', 'consum', 0.0261, 'lps'),
	(662522, 135, '2015-01-15 01:08:54.000000', 'consum', 0.0274, 'lps'),
	(662523, 135, '2015-01-15 01:08:55.000000', 'consum', 0.0232, 'lps'),
	(662524, 135, '2015-01-15 01:08:56.000000', 'consum', 0.0274, 'lps'),
	(662525, 135, '2015-01-15 01:08:57.000000', 'consum', 0.0243, 'lps'),
	(662526, 135, '2015-01-15 01:08:58.000000', 'consum', 0.0260, 'lps'),
	(662527, 135, '2015-01-15 01:08:59.000000', 'consum', 0.0211, 'lps'),
	(662528, 135, '2015-01-15 01:09:00.000000', 'consum', 0.0214, 'lps'),
	(662529, 135, '2015-01-15 01:09:01.000000', 'consum', 0.0228, 'lps'),
	(662530, 135, '2015-01-15 01:09:02.000000', 'consum', 0.0215, 'lps'),
	(662531, 135, '2015-01-15 01:09:03.000000', 'consum', 0.0255, 'lps'),
	(662532, 135, '2015-01-15 01:09:04.000000', 'consum', 0.0273, 'lps'),
	(662533, 135, '2015-01-15 01:09:05.000000', 'consum', 0.0242, 'lps'),
	(662534, 135, '2015-01-15 01:09:06.000000', 'consum', 0.0254, 'lps'),
	(662535, 135, '2015-01-15 01:09:07.000000', 'consum', 0.0262, 'lps'),
	(662536, 135, '2015-01-15 01:09:08.000000', 'consum', 0.0266, 'lps'),
	(662537, 135, '2015-01-15 01:09:09.000000', 'consum', 0.0261, 'lps'),
	(662538, 135, '2015-01-15 01:09:10.000000', 'consum', 0.0220, 'lps'),
	(662539, 135, '2015-01-15 01:09:11.000000', 'consum', 0.0258, 'lps'),
	(662540, 135, '2015-01-15 01:09:12.000000', 'consum', 0.0271, 'lps'),
	(662541, 135, '2015-01-15 01:09:13.000000', 'consum', 0.0224, 'lps'),
	(662542, 135, '2015-01-15 01:09:14.000000', 'consum', 0.0245, 'lps'),
	(662543, 135, '2015-01-15 01:09:15.000000', 'consum', 0.0270, 'lps'),
	(662544, 135, '2015-01-15 01:09:16.000000', 'consum', 0.0256, 'lps'),
	(662545, 135, '2015-01-15 01:09:17.000000', 'consum', 0.0263, 'lps'),
	(662546, 135, '2015-01-15 01:09:18.000000', 'consum', 0.0261, 'lps'),
	(662547, 135, '2015-01-15 01:09:19.000000', 'consum', 0.0233, 'lps'),
	(662548, 135, '2015-01-15 01:09:20.000000', 'consum', 0.0248, 'lps'),
	(662549, 135, '2015-01-15 01:09:21.000000', 'consum', 0.0255, 'lps'),
	(662550, 135, '2015-01-15 01:09:22.000000', 'consum', 0.0249, 'lps'),
	(662551, 135, '2015-01-15 01:09:23.000000', 'consum', 0.0272, 'lps'),
	(662552, 135, '2015-01-15 01:09:24.000000', 'consum', 0.0253, 'lps'),
	(662553, 135, '2015-01-15 01:09:25.000000', 'consum', 0.0239, 'lps'),
	(662554, 135, '2015-01-15 01:09:26.000000', 'consum', 0.0227, 'lps'),
	(662555, 135, '2015-01-15 01:09:27.000000', 'consum', 0.0283, 'lps'),
	(662556, 135, '2015-01-15 01:09:28.000000', 'consum', 0.0227, 'lps'),
	(662557, 135, '2015-01-15 01:09:29.000000', 'consum', 0.0227, 'lps'),
	(662558, 135, '2015-01-15 01:09:30.000000', 'consum', 0.0241, 'lps'),
	(662559, 135, '2015-01-15 01:09:31.000000', 'consum', 0.0244, 'lps'),
	(662560, 135, '2015-01-15 01:09:32.000000', 'consum', 0.0211, 'lps'),
	(662561, 135, '2015-01-15 01:09:33.000000', 'consum', 0.0261, 'lps'),
	(662562, 135, '2015-01-15 01:09:34.000000', 'consum', 0.0240, 'lps'),
	(662563, 135, '2015-01-15 01:09:35.000000', 'consum', 0.0283, 'lps'),
	(662564, 135, '2015-01-15 01:09:36.000000', 'consum', 0.0261, 'lps'),
	(662565, 135, '2015-01-15 01:09:37.000000', 'consum', 0.0248, 'lps'),
	(662566, 135, '2015-01-15 01:09:38.000000', 'consum', 0.0249, 'lps'),
	(662567, 135, '2015-01-15 01:09:39.000000', 'consum', 0.0218, 'lps'),
	(662568, 135, '2015-01-15 01:09:40.000000', 'consum', 0.0280, 'lps'),
	(662569, 135, '2015-01-15 01:09:41.000000', 'consum', 0.0240, 'lps'),
	(662570, 135, '2015-01-15 01:09:42.000000', 'consum', 0.0225, 'lps'),
	(662571, 135, '2015-01-15 01:09:43.000000', 'consum', 0.0268, 'lps'),
	(662572, 135, '2015-01-15 01:09:44.000000', 'consum', 0.0235, 'lps'),
	(662573, 135, '2015-01-15 01:09:45.000000', 'consum', 0.0234, 'lps'),
	(662574, 135, '2015-01-15 01:09:46.000000', 'consum', 0.0257, 'lps'),
	(662575, 135, '2015-01-15 01:09:47.000000', 'consum', 0.0224, 'lps'),
	(662576, 135, '2015-01-15 01:09:48.000000', 'consum', 0.0214, 'lps'),
	(662577, 135, '2015-01-15 01:09:49.000000', 'consum', 0.0263, 'lps'),
	(662578, 135, '2015-01-15 01:09:50.000000', 'consum', 0.0240, 'lps'),
	(662579, 135, '2015-01-15 01:09:51.000000', 'consum', 0.0276, 'lps'),
	(662580, 135, '2015-01-15 01:09:52.000000', 'consum', 0.0228, 'lps'),
	(662581, 135, '2015-01-15 01:09:53.000000', 'consum', 0.0253, 'lps'),
	(662582, 135, '2015-01-15 01:09:54.000000', 'consum', 0.0221, 'lps'),
	(662583, 135, '2015-01-15 01:09:55.000000', 'consum', 0.0212, 'lps'),
	(662584, 135, '2015-01-15 01:09:56.000000', 'consum', 0.0259, 'lps'),
	(662585, 135, '2015-01-15 01:09:57.000000', 'consum', 0.0230, 'lps'),
	(662586, 135, '2015-01-15 01:09:58.000000', 'consum', 0.0238, 'lps'),
	(662587, 135, '2015-01-15 01:09:59.000000', 'consum', 0.0217, 'lps'),
	(662588, 135, '2015-01-15 01:10:00.000000', 'consum', 0.0235, 'lps'),
	(662589, 135, '2015-01-15 01:10:01.000000', 'consum', 0.0239, 'lps'),
	(662590, 135, '2015-01-15 01:10:02.000000', 'consum', 0.0280, 'lps'),
	(662591, 135, '2015-01-15 01:10:03.000000', 'consum', 0.0254, 'lps'),
	(662592, 135, '2015-01-15 01:10:04.000000', 'consum', 0.0219, 'lps'),
	(662593, 135, '2015-01-15 01:10:05.000000', 'consum', 0.0271, 'lps'),
	(662594, 135, '2015-01-15 01:10:06.000000', 'consum', 0.0268, 'lps'),
	(662595, 135, '2015-01-15 01:10:07.000000', 'consum', 0.0242, 'lps'),
	(662596, 135, '2015-01-15 01:10:08.000000', 'consum', 0.0270, 'lps'),
	(662597, 135, '2015-01-15 01:10:09.000000', 'consum', 0.0265, 'lps'),
	(662598, 135, '2015-01-15 01:10:10.000000', 'consum', 0.0234, 'lps'),
	(662599, 135, '2015-01-15 01:10:11.000000', 'consum', 0.0239, 'lps'),
	(662600, 135, '2015-01-15 01:10:12.000000', 'consum', 0.0283, 'lps'),
	(662601, 135, '2015-01-15 01:10:13.000000', 'consum', 0.0267, 'lps'),
	(662602, 135, '2015-01-15 01:10:14.000000', 'consum', 0.0274, 'lps'),
	(662603, 135, '2015-01-15 01:10:15.000000', 'consum', 0.0214, 'lps'),
	(662604, 135, '2015-01-15 01:10:16.000000', 'consum', 0.0262, 'lps'),
	(662605, 135, '2015-01-15 01:10:17.000000', 'consum', 0.0234, 'lps'),
	(662606, 135, '2015-01-15 01:10:18.000000', 'consum', 0.0248, 'lps'),
	(662607, 135, '2015-01-15 01:10:19.000000', 'consum', 0.0254, 'lps'),
	(662608, 135, '2015-01-15 01:10:20.000000', 'consum', 0.0242, 'lps'),
	(662609, 135, '2015-01-15 01:10:21.000000', 'consum', 0.0237, 'lps'),
	(662610, 135, '2015-01-15 01:10:22.000000', 'consum', 0.0253, 'lps'),
	(662611, 135, '2015-01-15 01:10:23.000000', 'consum', 0.0271, 'lps'),
	(662612, 135, '2015-01-15 01:10:24.000000', 'consum', 0.0237, 'lps'),
	(662613, 135, '2015-01-15 01:10:25.000000', 'consum', 0.0235, 'lps'),
	(662614, 135, '2015-01-15 01:10:26.000000', 'consum', 0.0257, 'lps'),
	(662615, 135, '2015-01-15 01:10:27.000000', 'consum', 0.0222, 'lps'),
	(662616, 135, '2015-01-15 01:10:28.000000', 'consum', 0.0277, 'lps'),
	(662617, 135, '2015-01-15 01:10:29.000000', 'consum', 0.0213, 'lps'),
	(662618, 135, '2015-01-15 01:10:30.000000', 'consum', 0.0248, 'lps'),
	(662619, 135, '2015-01-15 01:10:31.000000', 'consum', 0.0242, 'lps'),
	(662620, 135, '2015-01-15 01:10:32.000000', 'consum', 0.0257, 'lps'),
	(662621, 135, '2015-01-15 01:10:33.000000', 'consum', 0.0276, 'lps'),
	(662622, 135, '2015-01-15 01:10:34.000000', 'consum', 0.0252, 'lps'),
	(662623, 135, '2015-01-15 01:10:35.000000', 'consum', 0.0220, 'lps'),
	(662624, 135, '2015-01-15 01:10:36.000000', 'consum', 0.0283, 'lps'),
	(662625, 135, '2015-01-15 01:10:37.000000', 'consum', 0.0250, 'lps'),
	(662626, 135, '2015-01-15 01:10:38.000000', 'consum', 0.0264, 'lps'),
	(662627, 135, '2015-01-15 01:10:39.000000', 'consum', 0.0214, 'lps'),
	(662628, 135, '2015-01-15 01:10:40.000000', 'consum', 0.0217, 'lps'),
	(662629, 135, '2015-01-15 01:10:41.000000', 'consum', 0.0232, 'lps'),
	(662630, 135, '2015-01-15 01:10:42.000000', 'consum', 0.0225, 'lps'),
	(662631, 135, '2015-01-15 01:10:43.000000', 'consum', 0.0221, 'lps'),
	(662632, 135, '2015-01-15 01:10:44.000000', 'consum', 0.0218, 'lps'),
	(662633, 135, '2015-01-15 01:10:45.000000', 'consum', 0.0219, 'lps'),
	(662634, 135, '2015-01-15 01:10:46.000000', 'consum', 0.0230, 'lps'),
	(662635, 135, '2015-01-15 01:10:47.000000', 'consum', 0.0210, 'lps'),
	(662636, 135, '2015-01-15 01:10:48.000000', 'consum', 0.0225, 'lps'),
	(662637, 135, '2015-01-15 01:10:49.000000', 'consum', 0.0212, 'lps'),
	(662638, 135, '2015-01-15 01:10:50.000000', 'consum', 0.0248, 'lps'),
	(662639, 135, '2015-01-15 01:10:51.000000', 'consum', 0.0249, 'lps'),
	(662640, 135, '2015-01-15 01:10:52.000000', 'consum', 0.0216, 'lps'),
	(662641, 135, '2015-01-15 01:10:53.000000', 'consum', 0.0273, 'lps'),
	(662642, 135, '2015-01-15 01:10:54.000000', 'consum', 0.0213, 'lps'),
	(662643, 135, '2015-01-15 01:10:55.000000', 'consum', 0.0256, 'lps'),
	(662644, 135, '2015-01-15 01:10:56.000000', 'consum', 0.0283, 'lps'),
	(662645, 135, '2015-01-15 01:10:57.000000', 'consum', 0.0215, 'lps'),
	(662646, 135, '2015-01-15 01:10:58.000000', 'consum', 0.0238, 'lps'),
	(662647, 135, '2015-01-15 01:10:59.000000', 'consum', 0.0261, 'lps'),
	(662648, 135, '2015-01-15 01:11:00.000000', 'consum', 0.0234, 'lps'),
	(662649, 135, '2015-01-15 01:11:01.000000', 'consum', 0.0253, 'lps'),
	(662650, 135, '2015-01-15 01:11:02.000000', 'consum', 0.0277, 'lps'),
	(662651, 135, '2015-01-15 01:11:03.000000', 'consum', 0.0269, 'lps'),
	(662652, 135, '2015-01-15 01:11:04.000000', 'consum', 0.0229, 'lps'),
	(662653, 135, '2015-01-15 01:11:05.000000', 'consum', 0.0279, 'lps'),
	(662654, 135, '2015-01-15 01:11:06.000000', 'consum', 0.0274, 'lps'),
	(662655, 135, '2015-01-15 01:11:07.000000', 'consum', 0.0250, 'lps'),
	(662656, 135, '2015-01-15 01:11:08.000000', 'consum', 0.0220, 'lps'),
	(662657, 135, '2015-01-15 01:11:09.000000', 'consum', 0.0215, 'lps'),
	(662658, 135, '2015-01-15 01:11:10.000000', 'consum', 0.0278, 'lps'),
	(662659, 135, '2015-01-15 01:11:11.000000', 'consum', 0.0241, 'lps'),
	(662660, 135, '2015-01-15 01:11:12.000000', 'consum', 0.0233, 'lps'),
	(662661, 135, '2015-01-15 01:11:13.000000', 'consum', 0.0234, 'lps'),
	(662662, 135, '2015-01-15 01:11:14.000000', 'consum', 0.0261, 'lps'),
	(662663, 135, '2015-01-15 01:11:15.000000', 'consum', 0.0245, 'lps'),
	(662664, 135, '2015-01-15 01:11:16.000000', 'consum', 0.0235, 'lps'),
	(662665, 135, '2015-01-15 01:11:17.000000', 'consum', 0.0227, 'lps'),
	(662666, 135, '2015-01-15 01:11:18.000000', 'consum', 0.0222, 'lps'),
	(662667, 135, '2015-01-15 01:11:19.000000', 'consum', 0.0219, 'lps'),
	(662668, 135, '2015-01-15 01:11:20.000000', 'consum', 0.0219, 'lps'),
	(662669, 135, '2015-01-15 01:11:21.000000', 'consum', 0.0229, 'lps'),
	(662670, 135, '2015-01-15 01:11:22.000000', 'consum', 0.0279, 'lps'),
	(662671, 135, '2015-01-15 01:11:23.000000', 'consum', 0.0275, 'lps'),
	(662672, 135, '2015-01-15 01:11:24.000000', 'consum', 0.0256, 'lps'),
	(662673, 135, '2015-01-15 01:11:25.000000', 'consum', 0.0247, 'lps'),
	(662674, 135, '2015-01-15 01:11:26.000000', 'consum', 0.0255, 'lps'),
	(662675, 135, '2015-01-15 01:11:27.000000', 'consum', 0.0250, 'lps'),
	(662676, 135, '2015-01-15 01:11:28.000000', 'consum', 0.0276, 'lps'),
	(662677, 135, '2015-01-15 01:11:29.000000', 'consum', 0.0275, 'lps'),
	(662678, 135, '2015-01-15 01:11:30.000000', 'consum', 0.0260, 'lps'),
	(662679, 135, '2015-01-15 01:11:31.000000', 'consum', 0.0267, 'lps'),
	(662680, 135, '2015-01-15 01:11:32.000000', 'consum', 0.0272, 'lps'),
	(662681, 135, '2015-01-15 01:11:33.000000', 'consum', 0.0277, 'lps'),
	(662682, 135, '2015-01-15 01:11:34.000000', 'consum', 0.0211, 'lps'),
	(662683, 135, '2015-01-15 01:11:35.000000', 'consum', 0.0236, 'lps'),
	(662684, 135, '2015-01-15 01:11:36.000000', 'consum', 0.0265, 'lps'),
	(662685, 135, '2015-01-15 01:11:37.000000', 'consum', 0.0259, 'lps'),
	(662686, 135, '2015-01-15 01:11:38.000000', 'consum', 0.0217, 'lps'),
	(662687, 135, '2015-01-15 01:11:39.000000', 'consum', 0.0247, 'lps'),
	(662688, 135, '2015-01-15 01:11:40.000000', 'consum', 0.0227, 'lps'),
	(662689, 135, '2015-01-15 01:11:41.000000', 'consum', 0.0256, 'lps'),
	(662690, 135, '2015-01-15 01:11:42.000000', 'consum', 0.0243, 'lps'),
	(662691, 135, '2015-01-15 01:11:43.000000', 'consum', 0.0236, 'lps'),
	(662692, 135, '2015-01-15 01:11:44.000000', 'consum', 0.0244, 'lps'),
	(662693, 135, '2015-01-15 01:11:45.000000', 'consum', 0.0228, 'lps'),
	(662694, 135, '2015-01-15 01:11:46.000000', 'consum', 0.0273, 'lps'),
	(662695, 135, '2015-01-15 01:11:47.000000', 'consum', 0.0250, 'lps'),
	(662696, 135, '2015-01-15 01:11:48.000000', 'consum', 0.0220, 'lps'),
	(662697, 135, '2015-01-15 01:11:49.000000', 'consum', 0.0215, 'lps'),
	(662698, 135, '2015-01-15 01:11:50.000000', 'consum', 0.0280, 'lps'),
	(662699, 135, '2015-01-15 01:11:51.000000', 'consum', 0.0249, 'lps'),
	(662700, 135, '2015-01-15 01:11:52.000000', 'consum', 0.0270, 'lps'),
	(662701, 135, '2015-01-15 01:11:53.000000', 'consum', 0.0243, 'lps'),
	(662702, 135, '2015-01-15 01:11:54.000000', 'consum', 0.0272, 'lps'),
	(662703, 135, '2015-01-15 01:11:55.000000', 'consum', 0.0272, 'lps'),
	(662704, 135, '2015-01-15 01:11:56.000000', 'consum', 0.0259, 'lps'),
	(662705, 135, '2015-01-15 01:11:57.000000', 'consum', 0.0272, 'lps'),
	(662706, 135, '2015-01-15 01:11:58.000000', 'consum', 0.0227, 'lps'),
	(662707, 135, '2015-01-15 01:11:59.000000', 'consum', 0.0254, 'lps'),
	(662708, 135, '2015-01-15 01:12:00.000000', 'consum', 0.0233, 'lps'),
	(662709, 135, '2015-01-15 01:12:01.000000', 'consum', 0.0266, 'lps'),
	(662710, 135, '2015-01-15 01:12:02.000000', 'consum', 0.0276, 'lps'),
	(662711, 135, '2015-01-15 01:12:03.000000', 'consum', 0.0223, 'lps'),
	(662712, 135, '2015-01-15 01:12:04.000000', 'consum', 0.0225, 'lps'),
	(662713, 135, '2015-01-15 01:12:05.000000', 'consum', 0.0248, 'lps'),
	(662714, 135, '2015-01-15 01:12:06.000000', 'consum', 0.0280, 'lps'),
	(662715, 135, '2015-01-15 01:12:07.000000', 'consum', 0.0227, 'lps'),
	(662716, 135, '2015-01-15 01:12:08.000000', 'consum', 0.0233, 'lps'),
	(662717, 135, '2015-01-15 01:12:09.000000', 'consum', 0.0274, 'lps'),
	(662718, 135, '2015-01-15 01:12:10.000000', 'consum', 0.0238, 'lps'),
	(662719, 135, '2015-01-15 01:12:11.000000', 'consum', 0.0232, 'lps'),
	(662720, 135, '2015-01-15 01:12:12.000000', 'consum', 0.0237, 'lps'),
	(662721, 135, '2015-01-15 01:12:13.000000', 'consum', 0.0281, 'lps'),
	(662722, 135, '2015-01-15 01:12:14.000000', 'consum', 0.0262, 'lps'),
	(662723, 135, '2015-01-15 01:12:15.000000', 'consum', 0.0257, 'lps'),
	(662724, 135, '2015-01-15 01:12:16.000000', 'consum', 0.0217, 'lps'),
	(662725, 135, '2015-01-15 01:12:17.000000', 'consum', 0.0252, 'lps'),
	(662726, 135, '2015-01-15 01:12:18.000000', 'consum', 0.0252, 'lps'),
	(662727, 135, '2015-01-15 01:12:19.000000', 'consum', 0.0219, 'lps'),
	(662728, 135, '2015-01-15 01:12:20.000000', 'consum', 0.0277, 'lps'),
	(662729, 135, '2015-01-15 01:12:21.000000', 'consum', 0.0221, 'lps'),
	(662730, 135, '2015-01-15 01:12:22.000000', 'consum', 0.0215, 'lps'),
	(662731, 135, '2015-01-15 01:12:23.000000', 'consum', 0.0277, 'lps'),
	(662732, 135, '2015-01-15 01:12:24.000000', 'consum', 0.0234, 'lps'),
	(662733, 135, '2015-01-15 01:12:25.000000', 'consum', 0.0276, 'lps'),
	(662734, 135, '2015-01-15 01:12:26.000000', 'consum', 0.0247, 'lps'),
	(662735, 135, '2015-01-15 01:12:27.000000', 'consum', 0.0274, 'lps'),
	(662736, 135, '2015-01-15 01:12:28.000000', 'consum', 0.0269, 'lps'),
	(662737, 135, '2015-01-15 01:12:29.000000', 'consum', 0.0238, 'lps'),
	(662738, 135, '2015-01-15 01:12:30.000000', 'consum', 0.0249, 'lps'),
	(662739, 135, '2015-01-15 01:12:31.000000', 'consum', 0.0249, 'lps'),
	(662740, 135, '2015-01-15 01:12:32.000000', 'consum', 0.0214, 'lps'),
	(662741, 135, '2015-01-15 01:12:33.000000', 'consum', 0.0259, 'lps'),
	(662742, 135, '2015-01-15 01:12:34.000000', 'consum', 0.0223, 'lps'),
	(662743, 135, '2015-01-15 01:12:35.000000', 'consum', 0.0277, 'lps'),
	(662744, 135, '2015-01-15 01:12:36.000000', 'consum', 0.0283, 'lps'),
	(662745, 135, '2015-01-15 01:12:37.000000', 'consum', 0.0226, 'lps'),
	(662746, 135, '2015-01-15 01:12:38.000000', 'consum', 0.0221, 'lps'),
	(662747, 135, '2015-01-15 01:12:39.000000', 'consum', 0.0218, 'lps'),
	(662748, 135, '2015-01-15 01:12:40.000000', 'consum', 0.0218, 'lps'),
	(662749, 135, '2015-01-15 01:12:41.000000', 'consum', 0.0226, 'lps'),
	(662750, 135, '2015-01-15 01:12:42.000000', 'consum', 0.0268, 'lps'),
	(662751, 135, '2015-01-15 01:12:43.000000', 'consum', 0.0229, 'lps'),
	(662752, 135, '2015-01-15 01:12:44.000000', 'consum', 0.0279, 'lps'),
	(662753, 135, '2015-01-15 01:12:45.000000', 'consum', 0.0279, 'lps'),
	(662754, 135, '2015-01-15 01:12:46.000000', 'consum', 0.0273, 'lps'),
	(662755, 135, '2015-01-15 01:12:47.000000', 'consum', 0.0247, 'lps'),
	(662756, 135, '2015-01-15 01:12:48.000000', 'consum', 0.0277, 'lps'),
	(662757, 135, '2015-01-15 01:12:49.000000', 'consum', 0.0213, 'lps'),
	(662758, 135, '2015-01-15 01:12:50.000000', 'consum', 0.0247, 'lps'),
	(662759, 135, '2015-01-15 01:12:51.000000', 'consum', 0.0238, 'lps'),
	(662760, 135, '2015-01-15 01:12:52.000000', 'consum', 0.0238, 'lps'),
	(662761, 135, '2015-01-15 01:12:53.000000', 'consum', 0.0270, 'lps'),
	(662762, 135, '2015-01-15 01:12:54.000000', 'consum', 0.0275, 'lps'),
	(662763, 135, '2015-01-15 01:12:55.000000', 'consum', 0.0210, 'lps'),
	(662764, 135, '2015-01-15 01:12:56.000000', 'consum', 0.0236, 'lps'),
	(662765, 135, '2015-01-15 01:12:57.000000', 'consum', 0.0266, 'lps'),
	(662766, 135, '2015-01-15 01:12:58.000000', 'consum', 0.0266, 'lps'),
	(662767, 135, '2015-01-15 01:12:59.000000', 'consum', 0.0248, 'lps'),
	(662768, 135, '2015-01-15 01:13:00.000000', 'consum', 0.0232, 'lps'),
	(662769, 135, '2015-01-15 01:13:01.000000', 'consum', 0.0282, 'lps'),
	(662770, 135, '2015-01-15 01:13:02.000000', 'consum', 0.0282, 'lps'),
	(662771, 135, '2015-01-15 01:13:03.000000', 'consum', 0.0282, 'lps'),
	(662772, 135, '2015-01-15 01:13:04.000000', 'consum', 0.0278, 'lps'),
	(662773, 135, '2015-01-15 01:13:05.000000', 'consum', 0.0263, 'lps'),
	(662774, 135, '2015-01-15 01:13:06.000000', 'consum', 0.0272, 'lps'),
	(662775, 135, '2015-01-15 01:13:07.000000', 'consum', 0.0211, 'lps'),
	(662776, 135, '2015-01-15 01:13:08.000000', 'consum', 0.0254, 'lps'),
	(662777, 135, '2015-01-15 01:13:09.000000', 'consum', 0.0279, 'lps'),
	(662778, 135, '2015-01-15 01:13:10.000000', 'consum', 0.0277, 'lps'),
	(662779, 135, '2015-01-15 01:13:11.000000', 'consum', 0.0262, 'lps'),
	(662780, 135, '2015-01-15 01:13:12.000000', 'consum', 0.0269, 'lps'),
	(662781, 135, '2015-01-15 01:13:13.000000', 'consum', 0.0275, 'lps'),
	(662782, 135, '2015-01-15 01:13:14.000000', 'consum', 0.0211, 'lps'),
	(662783, 135, '2015-01-15 01:13:15.000000', 'consum', 0.0244, 'lps'),
	(662784, 135, '2015-01-15 01:13:16.000000', 'consum', 0.0227, 'lps'),
	(662785, 135, '2015-01-15 01:13:17.000000', 'consum', 0.0267, 'lps'),
	(662786, 135, '2015-01-15 01:13:18.000000', 'consum', 0.0225, 'lps'),
	(662787, 135, '2015-01-15 01:13:19.000000', 'consum', 0.0261, 'lps'),
	(662788, 135, '2015-01-15 01:13:20.000000', 'consum', 0.0271, 'lps'),
	(662789, 135, '2015-01-15 01:13:21.000000', 'consum', 0.0218, 'lps'),
	(662790, 135, '2015-01-15 01:13:22.000000', 'consum', 0.0213, 'lps'),
	(662791, 135, '2015-01-15 01:13:23.000000', 'consum', 0.0276, 'lps'),
	(662792, 135, '2015-01-15 01:13:24.000000', 'consum', 0.0234, 'lps'),
	(662793, 135, '2015-01-15 01:13:25.000000', 'consum', 0.0283, 'lps'),
	(662794, 135, '2015-01-15 01:13:26.000000', 'consum', 0.0280, 'lps'),
	(662795, 135, '2015-01-15 01:13:27.000000', 'consum', 0.0268, 'lps'),
	(662796, 135, '2015-01-15 01:13:28.000000', 'consum', 0.0216, 'lps'),
	(662797, 135, '2015-01-15 01:13:29.000000', 'consum', 0.0215, 'lps'),
	(662798, 135, '2015-01-15 01:13:30.000000', 'consum', 0.0218, 'lps'),
	(662799, 135, '2015-01-15 01:13:31.000000', 'consum', 0.0234, 'lps'),
	(662800, 135, '2015-01-15 01:13:32.000000', 'consum', 0.0233, 'lps'),
	(662801, 135, '2015-01-15 01:13:33.000000', 'consum', 0.0252, 'lps'),
	(662802, 135, '2015-01-15 01:13:34.000000', 'consum', 0.0278, 'lps'),
	(662803, 135, '2015-01-15 01:13:35.000000', 'consum', 0.0277, 'lps'),
	(662804, 135, '2015-01-15 01:13:36.000000', 'consum', 0.0270, 'lps'),
	(662805, 135, '2015-01-15 01:13:37.000000', 'consum', 0.0232, 'lps'),
	(662806, 135, '2015-01-15 01:13:38.000000', 'consum', 0.0215, 'lps'),
	(662807, 135, '2015-01-15 01:13:39.000000', 'consum', 0.0242, 'lps'),
	(662808, 135, '2015-01-15 01:13:40.000000', 'consum', 0.0210, 'lps'),
	(662809, 135, '2015-01-15 01:13:41.000000', 'consum', 0.0262, 'lps'),
	(662810, 135, '2015-01-15 01:13:42.000000', 'consum', 0.0248, 'lps'),
	(662811, 135, '2015-01-15 01:13:43.000000', 'consum', 0.0245, 'lps'),
	(662812, 135, '2015-01-15 01:13:44.000000', 'consum', 0.0270, 'lps'),
	(662813, 135, '2015-01-15 01:13:45.000000', 'consum', 0.0258, 'lps'),
	(662814, 135, '2015-01-15 01:13:46.000000', 'consum', 0.0273, 'lps'),
	(662815, 135, '2015-01-15 01:13:47.000000', 'consum', 0.0230, 'lps'),
	(662816, 135, '2015-01-15 01:13:48.000000', 'consum', 0.0272, 'lps'),
	(662817, 135, '2015-01-15 01:13:49.000000', 'consum', 0.0237, 'lps'),
	(662818, 135, '2015-01-15 01:13:50.000000', 'consum', 0.0236, 'lps'),
	(662819, 135, '2015-01-15 01:13:51.000000', 'consum', 0.0256, 'lps'),
	(662820, 135, '2015-01-15 01:13:52.000000', 'consum', 0.0216, 'lps'),
	(662821, 135, '2015-01-15 01:13:53.000000', 'consum', 0.0250, 'lps'),
	(662822, 135, '2015-01-15 01:13:54.000000', 'consum', 0.0246, 'lps'),
	(662823, 135, '2015-01-15 01:13:55.000000', 'consum', 0.0271, 'lps'),
	(662824, 135, '2015-01-15 01:13:56.000000', 'consum', 0.0260, 'lps'),
	(662825, 135, '2015-01-15 01:13:57.000000', 'consum', 0.0278, 'lps'),
	(662826, 135, '2015-01-15 01:13:58.000000', 'consum', 0.0251, 'lps'),
	(662827, 135, '2015-01-15 01:13:59.000000', 'consum', 0.0212, 'lps'),
	(662828, 135, '2015-01-15 01:14:00.000000', 'consum', 0.0246, 'lps'),
	(662829, 135, '2015-01-15 01:14:01.000000', 'consum', 0.0235, 'lps'),
	(662830, 135, '2015-01-15 01:14:02.000000', 'consum', 0.0227, 'lps'),
	(662831, 135, '2015-01-15 01:14:03.000000', 'consum', 0.0222, 'lps'),
	(662832, 135, '2015-01-15 01:14:04.000000', 'consum', 0.0218, 'lps'),
	(662833, 135, '2015-01-15 01:14:05.000000', 'consum', 0.0216, 'lps'),
	(662834, 135, '2015-01-15 01:14:06.000000', 'consum', 0.0214, 'lps'),
	(662835, 135, '2015-01-15 01:14:07.000000', 'consum', 0.0213, 'lps'),
	(662836, 135, '2015-01-15 01:14:08.000000', 'consum', 0.0215, 'lps'),
	(662837, 135, '2015-01-15 01:14:09.000000', 'consum', 0.0226, 'lps'),
	(662838, 135, '2015-01-15 01:14:10.000000', 'consum', 0.0274, 'lps'),
	(662839, 135, '2015-01-15 01:14:11.000000', 'consum', 0.0261, 'lps'),
	(662840, 135, '2015-01-15 01:14:12.000000', 'consum', 0.0272, 'lps'),
	(662841, 135, '2015-01-15 01:14:13.000000', 'consum', 0.0221, 'lps'),
	(662842, 135, '2015-01-15 01:14:14.000000', 'consum', 0.0226, 'lps'),
	(662843, 135, '2015-01-15 01:14:15.000000', 'consum', 0.0259, 'lps'),
	(662844, 135, '2015-01-15 01:14:16.000000', 'consum', 0.0260, 'lps'),
	(662845, 135, '2015-01-15 01:14:17.000000', 'consum', 0.0240, 'lps'),
	(662846, 135, '2015-01-15 01:14:18.000000', 'consum', 0.0210, 'lps'),
	(662847, 135, '2015-01-15 01:14:19.000000', 'consum', 0.0267, 'lps'),
	(662848, 135, '2015-01-15 01:14:20.000000', 'consum', 0.0276, 'lps'),
	(662849, 135, '2015-01-15 01:14:21.000000', 'consum', 0.0220, 'lps'),
	(662850, 135, '2015-01-15 01:14:22.000000', 'consum', 0.0211, 'lps'),
	(662851, 135, '2015-01-15 01:14:23.000000', 'consum', 0.0258, 'lps'),
	(662852, 135, '2015-01-15 01:14:24.000000', 'consum', 0.0226, 'lps'),
	(662853, 135, '2015-01-15 01:14:25.000000', 'consum', 0.0221, 'lps'),
	(662854, 135, '2015-01-15 01:14:26.000000', 'consum', 0.0216, 'lps'),
	(662855, 135, '2015-01-15 01:14:27.000000', 'consum', 0.0282, 'lps'),
	(662856, 135, '2015-01-15 01:14:28.000000', 'consum', 0.0255, 'lps'),
	(662857, 135, '2015-01-15 01:14:29.000000', 'consum', 0.0220, 'lps'),
	(662858, 135, '2015-01-15 01:14:30.000000', 'consum', 0.0274, 'lps'),
	(662859, 135, '2015-01-15 01:14:31.000000', 'consum', 0.0280, 'lps'),
	(662860, 135, '2015-01-15 01:14:32.000000', 'consum', 0.0219, 'lps'),
	(662861, 135, '2015-01-15 01:14:33.000000', 'consum', 0.0268, 'lps'),
	(662862, 135, '2015-01-15 01:14:34.000000', 'consum', 0.0249, 'lps'),
	(662863, 135, '2015-01-15 01:14:35.000000', 'consum', 0.0235, 'lps'),
	(662864, 135, '2015-01-15 01:14:36.000000', 'consum', 0.0218, 'lps'),
	(662865, 135, '2015-01-15 01:14:37.000000', 'consum', 0.0250, 'lps'),
	(662866, 135, '2015-01-15 01:14:38.000000', 'consum', 0.0239, 'lps'),
	(662867, 135, '2015-01-15 01:14:39.000000', 'consum', 0.0234, 'lps'),
	(662868, 135, '2015-01-15 01:14:40.000000', 'consum', 0.0245, 'lps'),
	(662869, 135, '2015-01-15 01:14:41.000000', 'consum', 0.0240, 'lps'),
	(662870, 135, '2015-01-15 01:14:42.000000', 'consum', 0.0254, 'lps'),
	(662871, 135, '2015-01-15 01:14:43.000000', 'consum', 0.0268, 'lps'),
	(662872, 135, '2015-01-15 01:14:44.000000', 'consum', 0.0218, 'lps'),
	(662873, 135, '2015-01-15 01:14:45.000000', 'consum', 0.0226, 'lps'),
	(662874, 135, '2015-01-15 01:14:46.000000', 'consum', 0.0265, 'lps'),
	(662875, 135, '2015-01-15 01:14:47.000000', 'consum', 0.0215, 'lps'),
	(662876, 135, '2015-01-15 01:14:48.000000', 'consum', 0.0218, 'lps'),
	(662877, 135, '2015-01-15 01:14:49.000000', 'consum', 0.0236, 'lps'),
	(662878, 135, '2015-01-15 01:14:50.000000', 'consum', 0.0245, 'lps'),
	(662879, 135, '2015-01-15 01:14:51.000000', 'consum', 0.0231, 'lps'),
	(662880, 135, '2015-01-15 01:14:52.000000', 'consum', 0.0212, 'lps'),
	(662881, 135, '2015-01-15 01:14:53.000000', 'consum', 0.0229, 'lps'),
	(662882, 135, '2015-01-15 01:14:54.000000', 'consum', 0.0226, 'lps'),
	(662883, 135, '2015-01-15 01:14:55.000000', 'consum', 0.0236, 'lps'),
	(662884, 135, '2015-01-15 01:14:56.000000', 'consum', 0.0217, 'lps'),
	(662885, 135, '2015-01-15 01:14:57.000000', 'consum', 0.0243, 'lps'),
	(662886, 135, '2015-01-15 01:14:58.000000', 'consum', 0.0278, 'lps'),
	(662887, 135, '2015-01-15 01:14:59.000000', 'consum', 0.0229, 'lps'),
	(662888, 135, '2015-01-15 01:15:00.000000', 'consum', 0.0253, 'lps'),
	(662889, 135, '2015-01-15 01:15:01.000000', 'consum', 0.0217, 'lps'),
	(662890, 135, '2015-01-15 01:15:02.000000', 'consum', 0.0268, 'lps'),
	(662891, 135, '2015-01-15 01:15:03.000000', 'consum', 0.0255, 'lps'),
	(662892, 135, '2015-01-15 01:15:04.000000', 'consum', 0.0263, 'lps'),
	(662893, 135, '2015-01-15 01:15:05.000000', 'consum', 0.0265, 'lps'),
	(662894, 135, '2015-01-15 01:15:06.000000', 'consum', 0.0253, 'lps'),
	(662895, 135, '2015-01-15 01:15:07.000000', 'consum', 0.0262, 'lps'),
	(662896, 135, '2015-01-15 01:15:08.000000', 'consum', 0.0264, 'lps'),
	(662897, 135, '2015-01-15 01:15:09.000000', 'consum', 0.0254, 'lps'),
	(662898, 135, '2015-01-15 01:15:10.000000', 'consum', 0.0268, 'lps'),
	(662899, 135, '2015-01-15 01:15:11.000000', 'consum', 0.0222, 'lps'),
	(662900, 135, '2015-01-15 01:15:12.000000', 'consum', 0.0242, 'lps'),
	(662901, 135, '2015-01-15 01:15:13.000000', 'consum', 0.0259, 'lps'),
	(662902, 135, '2015-01-15 01:15:14.000000', 'consum', 0.0214, 'lps'),
	(662903, 135, '2015-01-15 01:15:15.000000', 'consum', 0.0231, 'lps'),
	(662904, 135, '2015-01-15 01:15:16.000000', 'consum', 0.0228, 'lps'),
	(662905, 135, '2015-01-15 01:15:17.000000', 'consum', 0.0239, 'lps'),
	(662906, 135, '2015-01-15 01:15:18.000000', 'consum', 0.0228, 'lps'),
	(662907, 135, '2015-01-15 01:15:19.000000', 'consum', 0.0215, 'lps'),
	(662908, 135, '2015-01-15 01:15:20.000000', 'consum', 0.0253, 'lps'),
	(662909, 135, '2015-01-15 01:15:21.000000', 'consum', 0.0265, 'lps'),
	(662910, 135, '2015-01-15 01:15:22.000000', 'consum', 0.0280, 'lps'),
	(662911, 135, '2015-01-15 01:15:23.000000', 'consum', 0.0247, 'lps'),
	(662912, 135, '2015-01-15 01:15:24.000000', 'consum', 0.0261, 'lps'),
	(662913, 135, '2015-01-15 01:15:25.000000', 'consum', 0.0281, 'lps'),
	(662914, 135, '2015-01-15 01:15:26.000000', 'consum', 0.0265, 'lps'),
	(662915, 135, '2015-01-15 01:15:27.000000', 'consum', 0.0272, 'lps'),
	(662916, 135, '2015-01-15 01:15:28.000000', 'consum', 0.0281, 'lps'),
	(662917, 135, '2015-01-15 01:15:29.000000', 'consum', 0.0233, 'lps'),
	(662918, 135, '2015-01-15 01:15:30.000000', 'consum', 0.0258, 'lps'),
	(662919, 135, '2015-01-15 01:15:31.000000', 'consum', 0.0236, 'lps'),
	(662920, 135, '2015-01-15 01:15:32.000000', 'consum', 0.0268, 'lps'),
	(662921, 135, '2015-01-15 01:15:33.000000', 'consum', 0.0277, 'lps'),
	(662922, 135, '2015-01-15 01:15:34.000000', 'consum', 0.0223, 'lps'),
	(662923, 135, '2015-01-15 01:15:35.000000', 'consum', 0.0223, 'lps'),
	(662924, 135, '2015-01-15 01:15:36.000000', 'consum', 0.0234, 'lps'),
	(662925, 135, '2015-01-15 01:15:37.000000', 'consum', 0.0219, 'lps'),
	(662926, 135, '2015-01-15 01:15:38.000000', 'consum', 0.0257, 'lps'),
	(662927, 135, '2015-01-15 01:15:39.000000', 'consum', 0.0272, 'lps'),
	(662928, 135, '2015-01-15 01:15:40.000000', 'consum', 0.0231, 'lps'),
	(662929, 135, '2015-01-15 01:15:41.000000', 'consum', 0.0277, 'lps'),
	(662930, 135, '2015-01-15 01:15:42.000000', 'consum', 0.0261, 'lps'),
	(662931, 135, '2015-01-15 01:15:43.000000', 'consum', 0.0265, 'lps'),
	(662932, 135, '2015-01-15 01:15:44.000000', 'consum', 0.0256, 'lps'),
	(662933, 135, '2015-01-15 01:15:45.000000', 'consum', 0.0278, 'lps'),
	(662934, 135, '2015-01-15 01:15:46.000000', 'consum', 0.0266, 'lps'),
	(662935, 135, '2015-01-15 01:15:47.000000', 'consum', 0.0283, 'lps'),
	(662936, 135, '2015-01-15 01:15:48.000000', 'consum', 0.0260, 'lps'),
	(662937, 135, '2015-01-15 01:15:49.000000', 'consum', 0.0243, 'lps'),
	(662938, 135, '2015-01-15 01:15:50.000000', 'consum', 0.0225, 'lps'),
	(662939, 135, '2015-01-15 01:15:51.000000', 'consum', 0.0261, 'lps'),
	(662940, 135, '2015-01-15 01:15:52.000000', 'consum', 0.0270, 'lps'),
	(662941, 135, '2015-01-15 01:15:53.000000', 'consum', 0.0212, 'lps'),
	(662942, 135, '2015-01-15 01:15:54.000000', 'consum', 0.0260, 'lps'),
	(662943, 135, '2015-01-15 01:15:55.000000', 'consum', 0.0233, 'lps'),
	(662944, 135, '2015-01-15 01:15:56.000000', 'consum', 0.0248, 'lps'),
	(662945, 135, '2015-01-15 01:15:57.000000', 'consum', 0.0259, 'lps'),
	(662946, 135, '2015-01-15 01:15:58.000000', 'consum', 0.0268, 'lps'),
	(662947, 135, '2015-01-15 01:15:59.000000', 'consum', 0.0277, 'lps'),
	(662948, 135, '2015-01-15 01:16:00.000000', 'consum', 0.0225, 'lps'),
	(662949, 135, '2015-01-15 01:16:01.000000', 'consum', 0.0233, 'lps'),
	(662950, 135, '2015-01-15 01:16:02.000000', 'consum', 0.0279, 'lps'),
	(662951, 135, '2015-01-15 01:16:03.000000', 'consum', 0.0266, 'lps'),
	(662952, 135, '2015-01-15 01:16:04.000000', 'consum', 0.0282, 'lps'),
	(662953, 135, '2015-01-15 01:16:05.000000', 'consum', 0.0253, 'lps'),
	(662954, 135, '2015-01-15 01:16:06.000000', 'consum', 0.0212, 'lps'),
	(662955, 135, '2015-01-15 01:16:07.000000', 'consum', 0.0239, 'lps'),
	(662956, 135, '2015-01-15 01:16:08.000000', 'consum', 0.0275, 'lps'),
	(662957, 135, '2015-01-15 01:16:09.000000', 'consum', 0.0226, 'lps'),
	(662958, 135, '2015-01-15 01:16:10.000000', 'consum', 0.0244, 'lps'),
	(662959, 135, '2015-01-15 01:16:11.000000', 'consum', 0.0257, 'lps'),
	(662960, 135, '2015-01-15 01:16:12.000000', 'consum', 0.0271, 'lps'),
	(662961, 135, '2015-01-15 01:16:13.000000', 'consum', 0.0228, 'lps'),
	(662962, 135, '2015-01-15 01:16:14.000000', 'consum', 0.0266, 'lps'),
	(662963, 135, '2015-01-15 01:16:15.000000', 'consum', 0.0211, 'lps'),
	(662964, 135, '2015-01-15 01:16:16.000000', 'consum', 0.0272, 'lps'),
	(662965, 135, '2015-01-15 01:16:17.000000', 'consum', 0.0222, 'lps'),
	(662966, 135, '2015-01-15 01:16:18.000000', 'consum', 0.0230, 'lps'),
	(662967, 135, '2015-01-15 01:16:19.000000', 'consum', 0.0276, 'lps'),
	(662968, 135, '2015-01-15 01:16:20.000000', 'consum', 0.0257, 'lps'),
	(662969, 135, '2015-01-15 01:16:21.000000', 'consum', 0.0248, 'lps'),
	(662970, 135, '2015-01-15 01:16:22.000000', 'consum', 0.0258, 'lps'),
	(662971, 135, '2015-01-15 01:16:23.000000', 'consum', 0.0265, 'lps'),
	(662972, 135, '2015-01-15 01:16:24.000000', 'consum', 0.0268, 'lps'),
	(662973, 135, '2015-01-15 01:16:25.000000', 'consum', 0.0260, 'lps'),
	(662974, 135, '2015-01-15 01:16:26.000000', 'consum', 0.0214, 'lps'),
	(662975, 135, '2015-01-15 01:16:27.000000', 'consum', 0.0226, 'lps'),
	(662976, 135, '2015-01-15 01:16:28.000000', 'consum', 0.0278, 'lps'),
	(662977, 135, '2015-01-15 01:16:29.000000', 'consum', 0.0283, 'lps'),
	(662978, 135, '2015-01-15 01:16:30.000000', 'consum', 0.0221, 'lps'),
	(662979, 135, '2015-01-15 01:16:31.000000', 'consum', 0.0269, 'lps'),
	(662980, 135, '2015-01-15 01:16:32.000000', 'consum', 0.0252, 'lps'),
	(662981, 135, '2015-01-15 01:16:33.000000', 'consum', 0.0241, 'lps'),
	(662982, 135, '2015-01-15 01:16:34.000000', 'consum', 0.0242, 'lps'),
	(662983, 135, '2015-01-15 01:16:35.000000', 'consum', 0.0275, 'lps'),
	(662984, 135, '2015-01-15 01:16:36.000000', 'consum', 0.0219, 'lps'),
	(662985, 135, '2015-01-15 01:16:37.000000', 'consum', 0.0282, 'lps'),
	(662986, 135, '2015-01-15 01:16:38.000000', 'consum', 0.0247, 'lps'),
	(662987, 135, '2015-01-15 01:16:39.000000', 'consum', 0.0255, 'lps'),
	(662988, 135, '2015-01-15 01:16:40.000000', 'consum', 0.0252, 'lps'),
	(662989, 135, '2015-01-15 01:16:41.000000', 'consum', 0.0282, 'lps'),
	(662990, 135, '2015-01-15 01:16:42.000000', 'consum', 0.0226, 'lps'),
	(662991, 135, '2015-01-15 01:16:43.000000', 'consum', 0.0220, 'lps'),
	(662992, 135, '2015-01-15 01:16:44.000000', 'consum', 0.0212, 'lps'),
	(662993, 135, '2015-01-15 01:16:45.000000', 'consum', 0.0263, 'lps'),
	(662994, 135, '2015-01-15 01:16:46.000000', 'consum', 0.0250, 'lps'),
	(662995, 135, '2015-01-15 01:16:47.000000', 'consum', 0.0251, 'lps'),
	(662996, 135, '2015-01-15 01:16:48.000000', 'consum', 0.0221, 'lps'),
	(662997, 135, '2015-01-15 01:16:49.000000', 'consum', 0.0216, 'lps'),
	(662998, 135, '2015-01-15 01:16:50.000000', 'consum', 0.0282, 'lps'),
	(662999, 135, '2015-01-15 01:16:51.000000', 'consum', 0.0254, 'lps'),
	(663000, 135, '2015-01-15 01:16:52.000000', 'consum', 0.0218, 'lps'),
	(663001, 135, '2015-01-15 01:16:53.000000', 'consum', 0.0266, 'lps'),
	(663002, 135, '2015-01-15 01:16:54.000000', 'consum', 0.0245, 'lps'),
	(663003, 135, '2015-01-15 01:16:55.000000', 'consum', 0.0217, 'lps'),
	(663004, 135, '2015-01-15 01:16:56.000000', 'consum', 0.0213, 'lps'),
	(663005, 135, '2015-01-15 01:16:57.000000', 'consum', 0.0279, 'lps'),
	(663006, 135, '2015-01-15 01:16:58.000000', 'consum', 0.0251, 'lps'),
	(663007, 135, '2015-01-15 01:16:59.000000', 'consum', 0.0282, 'lps'),
	(663008, 135, '2015-01-15 01:17:00.000000', 'consum', 0.0225, 'lps'),
	(663009, 135, '2015-01-15 01:17:01.000000', 'consum', 0.0219, 'lps'),
	(663010, 135, '2015-01-15 01:17:02.000000', 'consum', 0.0211, 'lps'),
	(663011, 135, '2015-01-15 01:17:03.000000', 'consum', 0.0263, 'lps'),
	(663012, 135, '2015-01-15 01:17:04.000000', 'consum', 0.0250, 'lps'),
	(663013, 135, '2015-01-15 01:17:05.000000', 'consum', 0.0250, 'lps'),
	(663014, 135, '2015-01-15 01:17:06.000000', 'consum', 0.0218, 'lps'),
	(663015, 135, '2015-01-15 01:17:07.000000', 'consum', 0.0279, 'lps'),
	(663016, 135, '2015-01-15 01:17:08.000000', 'consum', 0.0237, 'lps'),
	(663017, 135, '2015-01-15 01:17:09.000000', 'consum', 0.0211, 'lps'),
	(663018, 135, '2015-01-15 01:17:10.000000', 'consum', 0.0281, 'lps'),
	(663019, 135, '2015-01-15 01:17:11.000000', 'consum', 0.0270, 'lps'),
	(663020, 135, '2015-01-15 01:17:12.000000', 'consum', 0.0220, 'lps'),
	(663021, 135, '2015-01-15 01:17:13.000000', 'consum', 0.0228, 'lps'),
	(663022, 135, '2015-01-15 01:17:14.000000', 'consum', 0.0273, 'lps'),
	(663023, 135, '2015-01-15 01:17:15.000000', 'consum', 0.0248, 'lps'),
	(663024, 135, '2015-01-15 01:17:16.000000', 'consum', 0.0214, 'lps'),
	(663025, 135, '2015-01-15 01:17:17.000000', 'consum', 0.0261, 'lps'),
	(663026, 135, '2015-01-15 01:17:18.000000', 'consum', 0.0233, 'lps'),
	(663027, 135, '2015-01-15 01:17:19.000000', 'consum', 0.0245, 'lps'),
	(663028, 135, '2015-01-15 01:17:20.000000', 'consum', 0.0243, 'lps'),
	(663029, 135, '2015-01-15 01:17:21.000000', 'consum', 0.0272, 'lps'),
	(663030, 135, '2015-01-15 01:17:22.000000', 'consum', 0.0274, 'lps'),
	(663031, 135, '2015-01-15 01:17:23.000000', 'consum', 0.0269, 'lps'),
	(663032, 135, '2015-01-15 01:17:24.000000', 'consum', 0.0241, 'lps'),
	(663033, 135, '2015-01-15 01:17:25.000000', 'consum', 0.0261, 'lps'),
	(663034, 135, '2015-01-15 01:17:26.000000', 'consum', 0.0226, 'lps'),
	(663035, 135, '2015-01-15 01:17:27.000000', 'consum', 0.0213, 'lps'),
	(663036, 135, '2015-01-15 01:17:28.000000', 'consum', 0.0248, 'lps'),
	(663037, 135, '2015-01-15 01:17:29.000000', 'consum', 0.0245, 'lps'),
	(663038, 135, '2015-01-15 01:17:30.000000', 'consum', 0.0274, 'lps'),
	(663039, 135, '2015-01-15 01:17:31.000000', 'consum', 0.0274, 'lps'),
	(663040, 135, '2015-01-15 01:17:32.000000', 'consum', 0.0264, 'lps'),
	(663041, 135, '2015-01-15 01:17:33.000000', 'consum', 0.0215, 'lps'),
	(663042, 135, '2015-01-15 01:17:34.000000', 'consum', 0.0221, 'lps'),
	(663043, 135, '2015-01-15 01:17:35.000000', 'consum', 0.0252, 'lps'),
	(663044, 135, '2015-01-15 01:17:36.000000', 'consum', 0.0240, 'lps'),
	(663045, 135, '2015-01-15 01:17:37.000000', 'consum', 0.0234, 'lps'),
	(663046, 135, '2015-01-15 01:17:38.000000', 'consum', 0.0240, 'lps'),
	(663047, 135, '2015-01-15 01:17:39.000000', 'consum', 0.0213, 'lps'),
	(663048, 135, '2015-01-15 01:17:40.000000', 'consum', 0.0283, 'lps'),
	(663049, 135, '2015-01-15 01:17:41.000000', 'consum', 0.0272, 'lps'),
	(663050, 135, '2015-01-15 01:17:42.000000', 'consum', 0.0229, 'lps'),
	(663051, 135, '2015-01-15 01:17:43.000000', 'consum', 0.0265, 'lps'),
	(663052, 135, '2015-01-15 01:17:44.000000', 'consum', 0.0283, 'lps'),
	(663053, 135, '2015-01-15 01:17:45.000000', 'consum', 0.0263, 'lps'),
	(663054, 135, '2015-01-15 01:17:46.000000', 'consum', 0.0254, 'lps'),
	(663055, 135, '2015-01-15 01:17:47.000000', 'consum', 0.0271, 'lps'),
	(663056, 135, '2015-01-15 01:17:48.000000', 'consum', 0.0238, 'lps'),
	(663057, 135, '2015-01-15 01:17:49.000000', 'consum', 0.0241, 'lps'),
	(663058, 135, '2015-01-15 01:17:50.000000', 'consum', 0.0279, 'lps'),
	(663059, 135, '2015-01-15 01:17:51.000000', 'consum', 0.0244, 'lps'),
	(663060, 135, '2015-01-15 01:17:52.000000', 'consum', 0.0246, 'lps'),
	(663061, 135, '2015-01-15 01:17:53.000000', 'consum', 0.0215, 'lps'),
	(663062, 135, '2015-01-15 01:17:54.000000', 'consum', 0.0274, 'lps'),
	(663063, 135, '2015-01-15 01:17:55.000000', 'consum', 0.0219, 'lps'),
	(663064, 135, '2015-01-15 01:17:56.000000', 'consum', 0.0212, 'lps'),
	(663065, 135, '2015-01-15 01:17:57.000000', 'consum', 0.0266, 'lps'),
	(663066, 135, '2015-01-15 01:17:58.000000', 'consum', 0.0265, 'lps'),
	(663067, 135, '2015-01-15 01:17:59.000000', 'consum', 0.0244, 'lps'),
	(663068, 135, '2015-01-15 01:18:00.000000', 'consum', 0.0214, 'lps'),
	(663069, 135, '2015-01-15 01:18:01.000000', 'consum', 0.0277, 'lps'),
	(663070, 135, '2015-01-15 01:18:02.000000', 'consum', 0.0238, 'lps'),
	(663071, 135, '2015-01-15 01:18:03.000000', 'consum', 0.0222, 'lps'),
	(663072, 135, '2015-01-15 01:18:04.000000', 'consum', 0.0260, 'lps'),
	(663073, 135, '2015-01-15 01:18:05.000000', 'consum', 0.0279, 'lps'),
	(663074, 135, '2015-01-15 01:18:06.000000', 'consum', 0.0258, 'lps'),
	(663075, 135, '2015-01-15 01:18:07.000000', 'consum', 0.0242, 'lps'),
	(663076, 135, '2015-01-15 01:18:08.000000', 'consum', 0.0226, 'lps'),
	(663077, 135, '2015-01-15 01:18:09.000000', 'consum', 0.0270, 'lps'),
	(663078, 135, '2015-01-15 01:18:10.000000', 'consum', 0.0241, 'lps'),
	(663079, 135, '2015-01-15 01:18:11.000000', 'consum', 0.0259, 'lps'),
	(663080, 135, '2015-01-15 01:18:12.000000', 'consum', 0.0215, 'lps'),
	(663081, 135, '2015-01-15 01:18:13.000000', 'consum', 0.0237, 'lps'),
	(663082, 135, '2015-01-15 01:18:14.000000', 'consum', 0.0256, 'lps'),
	(663083, 135, '2015-01-15 01:18:15.000000', 'consum', 0.0213, 'lps'),
	(663084, 135, '2015-01-15 01:18:16.000000', 'consum', 0.0233, 'lps'),
	(663085, 135, '2015-01-15 01:18:17.000000', 'consum', 0.0245, 'lps'),
	(663086, 135, '2015-01-15 01:18:18.000000', 'consum', 0.0242, 'lps'),
	(663087, 135, '2015-01-15 01:18:19.000000', 'consum', 0.0264, 'lps'),
	(663088, 135, '2015-01-15 01:18:20.000000', 'consum', 0.0239, 'lps'),
	(663089, 135, '2015-01-15 01:18:21.000000', 'consum', 0.0265, 'lps'),
	(663090, 135, '2015-01-15 01:18:22.000000', 'consum', 0.0252, 'lps'),
	(663091, 135, '2015-01-15 01:18:23.000000', 'consum', 0.0255, 'lps'),
	(663092, 135, '2015-01-15 01:18:24.000000', 'consum', 0.0235, 'lps'),
	(663093, 135, '2015-01-15 01:18:25.000000', 'consum', 0.0275, 'lps'),
	(663094, 135, '2015-01-15 01:18:26.000000', 'consum', 0.0241, 'lps'),
	(663095, 135, '2015-01-15 01:18:27.000000', 'consum', 0.0241, 'lps'),
	(663096, 135, '2015-01-15 01:18:28.000000', 'consum', 0.0273, 'lps'),
	(663097, 135, '2015-01-15 01:18:29.000000', 'consum', 0.0210, 'lps'),
	(663098, 135, '2015-01-15 01:18:30.000000', 'consum', 0.0245, 'lps'),
	(663099, 135, '2015-01-15 01:18:31.000000', 'consum', 0.0239, 'lps'),
	(663100, 135, '2015-01-15 01:18:32.000000', 'consum', 0.0248, 'lps'),
	(663101, 135, '2015-01-15 01:18:33.000000', 'consum', 0.0242, 'lps'),
	(663102, 135, '2015-01-15 01:18:34.000000', 'consum', 0.0254, 'lps'),
	(663103, 135, '2015-01-15 01:18:35.000000', 'consum', 0.0263, 'lps'),
	(663104, 135, '2015-01-15 01:18:36.000000', 'consum', 0.0266, 'lps'),
	(663105, 135, '2015-01-15 01:18:37.000000', 'consum', 0.0261, 'lps'),
	(663106, 135, '2015-01-15 01:18:38.000000', 'consum', 0.0223, 'lps'),
	(663107, 135, '2015-01-15 01:18:39.000000', 'consum', 0.0268, 'lps'),
	(663108, 135, '2015-01-15 01:18:40.000000', 'consum', 0.0241, 'lps'),
	(663109, 135, '2015-01-15 01:18:41.000000', 'consum', 0.0267, 'lps'),
	(663110, 135, '2015-01-15 01:18:42.000000', 'consum', 0.0256, 'lps'),
	(663111, 135, '2015-01-15 01:18:43.000000', 'consum', 0.0266, 'lps'),
	(663112, 135, '2015-01-15 01:18:44.000000', 'consum', 0.0278, 'lps'),
	(663113, 135, '2015-01-15 01:18:45.000000', 'consum', 0.0237, 'lps'),
	(663114, 135, '2015-01-15 01:18:46.000000', 'consum', 0.0214, 'lps'),
	(663115, 135, '2015-01-15 01:18:47.000000', 'consum', 0.0225, 'lps'),
	(663116, 135, '2015-01-15 01:18:48.000000', 'consum', 0.0271, 'lps'),
	(663117, 135, '2015-01-15 01:18:49.000000', 'consum', 0.0248, 'lps'),
	(663118, 135, '2015-01-15 01:18:50.000000', 'consum', 0.0218, 'lps'),
	(663119, 135, '2015-01-15 01:18:51.000000', 'consum', 0.0212, 'lps'),
	(663120, 135, '2015-01-15 01:18:52.000000', 'consum', 0.0270, 'lps'),
	(663121, 135, '2015-01-15 01:18:53.000000', 'consum', 0.0210, 'lps'),
	(663122, 135, '2015-01-15 01:18:54.000000', 'consum', 0.0250, 'lps'),
	(663123, 135, '2015-01-15 01:18:55.000000', 'consum', 0.0263, 'lps'),
	(663124, 135, '2015-01-15 01:18:56.000000', 'consum', 0.0282, 'lps'),
	(663125, 135, '2015-01-15 01:18:57.000000', 'consum', 0.0261, 'lps'),
	(663126, 135, '2015-01-15 01:18:58.000000', 'consum', 0.0252, 'lps'),
	(663127, 135, '2015-01-15 01:18:59.000000', 'consum', 0.0269, 'lps'),
	(663128, 135, '2015-01-15 01:19:00.000000', 'consum', 0.0230, 'lps'),
	(663129, 135, '2015-01-15 01:19:01.000000', 'consum', 0.0280, 'lps'),
	(663130, 135, '2015-01-15 01:19:02.000000', 'consum', 0.0280, 'lps'),
	(663131, 135, '2015-01-15 01:19:03.000000', 'consum', 0.0278, 'lps'),
	(663132, 135, '2015-01-15 01:19:04.000000', 'consum', 0.0265, 'lps'),
	(663133, 135, '2015-01-15 01:19:05.000000', 'consum', 0.0282, 'lps'),
	(663134, 136, '2015-01-15 00:00:00.000000', 'consum', 0.0227, 'lps'),
	(663135, 136, '2015-01-15 00:00:01.000000', 'consum', 0.0354, 'lps'),
	(663136, 136, '2015-01-15 00:00:02.000000', 'consum', 0.0295, 'lps'),
	(663137, 136, '2015-01-15 00:00:03.000000', 'consum', 0.0349, 'lps'),
	(663138, 136, '2015-01-15 00:00:04.000000', 'consum', 0.0356, 'lps'),
	(663139, 136, '2015-01-15 00:00:05.000000', 'consum', 0.0232, 'lps'),
	(663140, 136, '2015-01-15 00:00:06.000000', 'consum', 0.0322, 'lps'),
	(663141, 136, '2015-01-15 00:00:07.000000', 'consum', 0.0263, 'lps'),
	(663142, 136, '2015-01-15 00:00:08.000000', 'consum', 0.0285, 'lps'),
	(663143, 136, '2015-01-15 00:00:09.000000', 'consum', 0.0280, 'lps'),
	(663144, 136, '2015-01-15 00:00:10.000000', 'consum', 0.0335, 'lps'),
	(663145, 136, '2015-01-15 00:00:11.000000', 'consum', 0.0331, 'lps'),
	(663146, 136, '2015-01-15 00:00:12.000000', 'consum', 0.0295, 'lps'),
	(663147, 136, '2015-01-15 00:00:13.000000', 'consum', 0.0271, 'lps'),
	(663148, 136, '2015-01-15 00:00:14.000000', 'consum', 0.0260, 'lps'),
	(663149, 136, '2015-01-15 00:00:15.000000', 'consum', 0.0278, 'lps'),
	(663150, 136, '2015-01-15 00:00:16.000000', 'consum', 0.0253, 'lps'),
	(663151, 136, '2015-01-15 00:00:17.000000', 'consum', 0.0224, 'lps'),
	(663152, 136, '2015-01-15 00:00:18.000000', 'consum', 0.0297, 'lps'),
	(663153, 136, '2015-01-15 00:00:19.000000', 'consum', 0.0309, 'lps'),
	(663154, 136, '2015-01-15 00:00:20.000000', 'consum', 0.0299, 'lps'),
	(663155, 136, '2015-01-15 00:00:21.000000', 'consum', 0.0211, 'lps'),
	(663156, 136, '2015-01-15 00:00:22.000000', 'consum', 0.0244, 'lps'),
	(663157, 136, '2015-01-15 00:00:23.000000', 'consum', 0.0231, 'lps'),
	(663158, 136, '2015-01-15 00:00:24.000000', 'consum', 0.0210, 'lps'),
	(663159, 136, '2015-01-15 00:00:25.000000', 'consum', 0.0298, 'lps'),
	(663160, 136, '2015-01-15 00:00:26.000000', 'consum', 0.0356, 'lps'),
	(663161, 136, '2015-01-15 00:00:27.000000', 'consum', 0.0235, 'lps'),
	(663162, 136, '2015-01-15 00:00:28.000000', 'consum', 0.0338, 'lps'),
	(663163, 136, '2015-01-15 00:00:29.000000', 'consum', 0.0335, 'lps'),
	(663164, 136, '2015-01-15 00:00:30.000000', 'consum', 0.0304, 'lps'),
	(663165, 136, '2015-01-15 00:00:31.000000', 'consum', 0.0305, 'lps'),
	(663166, 136, '2015-01-15 00:00:32.000000', 'consum', 0.0258, 'lps'),
	(663167, 136, '2015-01-15 00:00:33.000000', 'consum', 0.0311, 'lps'),
	(663168, 136, '2015-01-15 00:00:34.000000', 'consum', 0.0279, 'lps'),
	(663169, 136, '2015-01-15 00:00:35.000000', 'consum', 0.0252, 'lps'),
	(663170, 136, '2015-01-15 00:00:36.000000', 'consum', 0.0212, 'lps'),
	(663171, 136, '2015-01-15 00:00:37.000000', 'consum', 0.0241, 'lps'),
	(663172, 136, '2015-01-15 00:00:38.000000', 'consum', 0.0215, 'lps'),
	(663173, 136, '2015-01-15 00:00:39.000000', 'consum', 0.0289, 'lps'),
	(663174, 136, '2015-01-15 00:00:40.000000', 'consum', 0.0295, 'lps'),
	(663175, 136, '2015-01-15 00:00:41.000000', 'consum', 0.0252, 'lps'),
	(663176, 136, '2015-01-15 00:00:42.000000', 'consum', 0.0313, 'lps'),
	(663177, 136, '2015-01-15 00:00:43.000000', 'consum', 0.0304, 'lps'),
	(663178, 136, '2015-01-15 00:00:44.000000', 'consum', 0.0225, 'lps'),
	(663179, 136, '2015-01-15 00:00:45.000000', 'consum', 0.0297, 'lps'),
	(663180, 136, '2015-01-15 00:00:46.000000', 'consum', 0.0308, 'lps'),
	(663181, 136, '2015-01-15 00:00:47.000000', 'consum', 0.0291, 'lps'),
	(663182, 136, '2015-01-15 00:00:48.000000', 'consum', 0.0321, 'lps'),
	(663183, 136, '2015-01-15 00:00:49.000000', 'consum', 0.0230, 'lps'),
	(663184, 136, '2015-01-15 00:00:50.000000', 'consum', 0.0272, 'lps'),
	(663185, 136, '2015-01-15 00:00:51.000000', 'consum', 0.0311, 'lps'),
	(663186, 136, '2015-01-15 00:00:52.000000', 'consum', 0.0239, 'lps'),
	(663187, 136, '2015-01-15 00:00:53.000000', 'consum', 0.0343, 'lps'),
	(663188, 136, '2015-01-15 00:00:54.000000', 'consum', 0.0351, 'lps'),
	(663189, 136, '2015-01-15 00:00:55.000000', 'consum', 0.0220, 'lps'),
	(663190, 136, '2015-01-15 00:00:56.000000', 'consum', 0.0279, 'lps'),
	(663191, 136, '2015-01-15 00:00:57.000000', 'consum', 0.0232, 'lps'),
	(663192, 136, '2015-01-15 00:00:58.000000', 'consum', 0.0262, 'lps'),
	(663193, 136, '2015-01-15 00:00:59.000000', 'consum', 0.0256, 'lps'),
	(663194, 136, '2015-01-15 00:01:00.000000', 'consum', 0.0284, 'lps'),
	(663195, 136, '2015-01-15 00:01:01.000000', 'consum', 0.0295, 'lps'),
	(663196, 136, '2015-01-15 00:01:02.000000', 'consum', 0.0266, 'lps'),
	(663197, 136, '2015-01-15 00:01:03.000000', 'consum', 0.0237, 'lps'),
	(663198, 136, '2015-01-15 00:01:04.000000', 'consum', 0.0324, 'lps'),
	(663199, 136, '2015-01-15 00:01:05.000000', 'consum', 0.0257, 'lps'),
	(663200, 136, '2015-01-15 00:01:06.000000', 'consum', 0.0253, 'lps'),
	(663201, 136, '2015-01-15 00:01:07.000000', 'consum', 0.0282, 'lps'),
	(663202, 136, '2015-01-15 00:01:08.000000', 'consum', 0.0294, 'lps'),
	(663203, 136, '2015-01-15 00:01:09.000000', 'consum', 0.0266, 'lps'),
	(663204, 136, '2015-01-15 00:01:10.000000', 'consum', 0.0242, 'lps'),
	(663205, 136, '2015-01-15 00:01:11.000000', 'consum', 0.0350, 'lps'),
	(663206, 136, '2015-01-15 00:01:12.000000', 'consum', 0.0226, 'lps'),
	(663207, 136, '2015-01-15 00:01:13.000000', 'consum', 0.0309, 'lps'),
	(663208, 136, '2015-01-15 00:01:14.000000', 'consum', 0.0220, 'lps'),
	(663209, 136, '2015-01-15 00:01:15.000000', 'consum', 0.0255, 'lps'),
	(663210, 136, '2015-01-15 00:01:16.000000', 'consum', 0.0260, 'lps'),
	(663211, 136, '2015-01-15 00:01:17.000000', 'consum', 0.0326, 'lps'),
	(663212, 136, '2015-01-15 00:01:18.000000', 'consum', 0.0347, 'lps'),
	(663213, 136, '2015-01-15 00:01:19.000000', 'consum', 0.0251, 'lps'),
	(663214, 136, '2015-01-15 00:01:20.000000', 'consum', 0.0298, 'lps'),
	(663215, 136, '2015-01-15 00:01:21.000000', 'consum', 0.0236, 'lps'),
	(663216, 136, '2015-01-15 00:01:22.000000', 'consum', 0.0221, 'lps'),
	(663217, 136, '2015-01-15 00:01:23.000000', 'consum', 0.0334, 'lps'),
	(663218, 136, '2015-01-15 00:01:24.000000', 'consum', 0.0213, 'lps'),
	(663219, 136, '2015-01-15 00:01:25.000000', 'consum', 0.0291, 'lps'),
	(663220, 136, '2015-01-15 00:01:26.000000', 'consum', 0.0313, 'lps'),
	(663221, 136, '2015-01-15 00:01:27.000000', 'consum', 0.0334, 'lps'),
	(663222, 136, '2015-01-15 00:01:28.000000', 'consum', 0.0229, 'lps'),
	(663223, 136, '2015-01-15 00:01:29.000000', 'consum', 0.0228, 'lps'),
	(663224, 136, '2015-01-15 00:01:30.000000', 'consum', 0.0243, 'lps'),
	(663225, 136, '2015-01-15 00:01:31.000000', 'consum', 0.0323, 'lps'),
	(663226, 136, '2015-01-15 00:01:32.000000', 'consum', 0.0233, 'lps'),
	(663227, 136, '2015-01-15 00:01:33.000000', 'consum', 0.0281, 'lps'),
	(663228, 136, '2015-01-15 00:01:34.000000', 'consum', 0.0348, 'lps'),
	(663229, 136, '2015-01-15 00:01:35.000000', 'consum', 0.0248, 'lps'),
	(663230, 136, '2015-01-15 00:01:36.000000', 'consum', 0.0279, 'lps'),
	(663231, 136, '2015-01-15 00:01:37.000000', 'consum', 0.0295, 'lps'),
	(663232, 136, '2015-01-15 00:01:38.000000', 'consum', 0.0282, 'lps'),
	(663233, 136, '2015-01-15 00:01:39.000000', 'consum', 0.0315, 'lps'),
	(663234, 136, '2015-01-15 00:01:40.000000', 'consum', 0.0227, 'lps'),
	(663235, 136, '2015-01-15 00:01:41.000000', 'consum', 0.0274, 'lps'),
	(663236, 136, '2015-01-15 00:01:42.000000', 'consum', 0.0332, 'lps'),
	(663237, 136, '2015-01-15 00:01:43.000000', 'consum', 0.0336, 'lps'),
	(663238, 136, '2015-01-15 00:01:44.000000', 'consum', 0.0328, 'lps'),
	(663239, 136, '2015-01-15 00:01:45.000000', 'consum', 0.0275, 'lps'),
	(663240, 136, '2015-01-15 00:01:46.000000', 'consum', 0.0328, 'lps'),
	(663241, 136, '2015-01-15 00:01:47.000000', 'consum', 0.0311, 'lps'),
	(663242, 136, '2015-01-15 00:01:48.000000', 'consum', 0.0214, 'lps'),
	(663243, 136, '2015-01-15 00:01:49.000000', 'consum', 0.0222, 'lps'),
	(663244, 136, '2015-01-15 00:01:50.000000', 'consum', 0.0260, 'lps'),
	(663245, 136, '2015-01-15 00:01:51.000000', 'consum', 0.0276, 'lps'),
	(663246, 136, '2015-01-15 00:01:52.000000', 'consum', 0.0243, 'lps'),
	(663247, 136, '2015-01-15 00:01:53.000000', 'consum', 0.0325, 'lps'),
	(663248, 136, '2015-01-15 00:01:54.000000', 'consum', 0.0245, 'lps'),
	(663249, 136, '2015-01-15 00:01:55.000000', 'consum', 0.0336, 'lps'),
	(663250, 136, '2015-01-15 00:01:56.000000', 'consum', 0.0295, 'lps'),
	(663251, 136, '2015-01-15 00:01:57.000000', 'consum', 0.0257, 'lps'),
	(663252, 136, '2015-01-15 00:01:58.000000', 'consum', 0.0337, 'lps'),
	(663253, 136, '2015-01-15 00:01:59.000000', 'consum', 0.0264, 'lps'),
	(663254, 136, '2015-01-15 00:02:00.000000', 'consum', 0.0247, 'lps'),
	(663255, 136, '2015-01-15 00:02:01.000000', 'consum', 0.0233, 'lps'),
	(663256, 136, '2015-01-15 00:02:02.000000', 'consum', 0.0212, 'lps'),
	(663257, 136, '2015-01-15 00:02:03.000000', 'consum', 0.0302, 'lps'),
	(663258, 136, '2015-01-15 00:02:04.000000', 'consum', 0.0221, 'lps'),
	(663259, 136, '2015-01-15 00:02:05.000000', 'consum', 0.0285, 'lps'),
	(663260, 136, '2015-01-15 00:02:06.000000', 'consum', 0.0259, 'lps'),
	(663261, 136, '2015-01-15 00:02:07.000000', 'consum', 0.0228, 'lps'),
	(663262, 136, '2015-01-15 00:02:08.000000', 'consum', 0.0301, 'lps'),
	(663263, 136, '2015-01-15 00:02:09.000000', 'consum', 0.0320, 'lps'),
	(663264, 136, '2015-01-15 00:02:10.000000', 'consum', 0.0338, 'lps'),
	(663265, 136, '2015-01-15 00:02:11.000000', 'consum', 0.0226, 'lps'),
	(663266, 136, '2015-01-15 00:02:12.000000', 'consum', 0.0349, 'lps'),
	(663267, 136, '2015-01-15 00:02:13.000000', 'consum', 0.0268, 'lps'),
	(663268, 136, '2015-01-15 00:02:14.000000', 'consum', 0.0233, 'lps'),
	(663269, 136, '2015-01-15 00:02:15.000000', 'consum', 0.0295, 'lps'),
	(663270, 136, '2015-01-15 00:02:16.000000', 'consum', 0.0276, 'lps'),
	(663271, 136, '2015-01-15 00:02:17.000000', 'consum', 0.0284, 'lps'),
	(663272, 136, '2015-01-15 00:02:18.000000', 'consum', 0.0237, 'lps'),
	(663273, 136, '2015-01-15 00:02:19.000000', 'consum', 0.0270, 'lps'),
	(663274, 136, '2015-01-15 00:02:20.000000', 'consum', 0.0281, 'lps'),
	(663275, 136, '2015-01-15 00:02:21.000000', 'consum', 0.0238, 'lps'),
	(663276, 136, '2015-01-15 00:02:22.000000', 'consum', 0.0283, 'lps'),
	(663277, 136, '2015-01-15 00:02:23.000000', 'consum', 0.0348, 'lps'),
	(663278, 136, '2015-01-15 00:02:24.000000', 'consum', 0.0239, 'lps'),
	(663279, 136, '2015-01-15 00:02:25.000000', 'consum', 0.0238, 'lps'),
	(663280, 136, '2015-01-15 00:02:26.000000', 'consum', 0.0261, 'lps'),
	(663281, 136, '2015-01-15 00:02:27.000000', 'consum', 0.0234, 'lps'),
	(663282, 136, '2015-01-15 00:02:28.000000', 'consum', 0.0326, 'lps'),
	(663283, 136, '2015-01-15 00:02:29.000000', 'consum', 0.0275, 'lps'),
	(663284, 136, '2015-01-15 00:02:30.000000', 'consum', 0.0337, 'lps'),
	(663285, 136, '2015-01-15 00:02:31.000000', 'consum', 0.0210, 'lps'),
	(663286, 136, '2015-01-15 00:02:32.000000', 'consum', 0.0268, 'lps'),
	(663287, 136, '2015-01-15 00:02:33.000000', 'consum', 0.0355, 'lps'),
	(663288, 136, '2015-01-15 00:02:34.000000', 'consum', 0.0322, 'lps'),
	(663289, 136, '2015-01-15 00:02:35.000000', 'consum', 0.0333, 'lps'),
	(663290, 136, '2015-01-15 00:02:36.000000', 'consum', 0.0345, 'lps'),
	(663291, 136, '2015-01-15 00:02:37.000000', 'consum', 0.0222, 'lps'),
	(663292, 136, '2015-01-15 00:02:38.000000', 'consum', 0.0306, 'lps'),
	(663293, 136, '2015-01-15 00:02:39.000000', 'consum', 0.0214, 'lps'),
	(663294, 136, '2015-01-15 00:02:40.000000', 'consum', 0.0235, 'lps'),
	(663295, 136, '2015-01-15 00:02:41.000000', 'consum', 0.0323, 'lps'),
	(663296, 136, '2015-01-15 00:02:42.000000', 'consum', 0.0260, 'lps'),
	(663297, 136, '2015-01-15 00:02:43.000000', 'consum', 0.0269, 'lps'),
	(663298, 136, '2015-01-15 00:02:44.000000', 'consum', 0.0210, 'lps'),
	(663299, 136, '2015-01-15 00:02:45.000000', 'consum', 0.0324, 'lps'),
	(663300, 136, '2015-01-15 00:02:46.000000', 'consum', 0.0343, 'lps'),
	(663301, 136, '2015-01-15 00:02:47.000000', 'consum', 0.0239, 'lps'),
	(663302, 136, '2015-01-15 00:02:48.000000', 'consum', 0.0250, 'lps'),
	(663303, 136, '2015-01-15 00:02:49.000000', 'consum', 0.0323, 'lps'),
	(663304, 136, '2015-01-15 00:02:50.000000', 'consum', 0.0213, 'lps'),
	(663305, 136, '2015-01-15 00:02:51.000000', 'consum', 0.0329, 'lps'),
	(663306, 136, '2015-01-15 00:02:52.000000', 'consum', 0.0356, 'lps'),
	(663307, 136, '2015-01-15 00:02:53.000000', 'consum', 0.0291, 'lps'),
	(663308, 136, '2015-01-15 00:02:54.000000', 'consum', 0.0322, 'lps'),
	(663309, 136, '2015-01-15 00:02:55.000000', 'consum', 0.0236, 'lps'),
	(663310, 136, '2015-01-15 00:02:56.000000', 'consum', 0.0297, 'lps'),
	(663311, 136, '2015-01-15 00:02:57.000000', 'consum', 0.0272, 'lps'),
	(663312, 136, '2015-01-15 00:02:58.000000', 'consum', 0.0262, 'lps'),
	(663313, 136, '2015-01-15 00:02:59.000000', 'consum', 0.0282, 'lps'),
	(663314, 136, '2015-01-15 00:03:00.000000', 'consum', 0.0268, 'lps'),
	(663315, 136, '2015-01-15 00:03:01.000000', 'consum', 0.0284, 'lps'),
	(663316, 136, '2015-01-15 00:03:02.000000', 'consum', 0.0261, 'lps'),
	(663317, 136, '2015-01-15 00:03:03.000000', 'consum', 0.0241, 'lps'),
	(663318, 136, '2015-01-15 00:03:04.000000', 'consum', 0.0214, 'lps'),
	(663319, 136, '2015-01-15 00:03:05.000000', 'consum', 0.0284, 'lps'),
	(663320, 136, '2015-01-15 00:03:06.000000', 'consum', 0.0274, 'lps'),
	(663321, 136, '2015-01-15 00:03:07.000000', 'consum', 0.0310, 'lps'),
	(663322, 136, '2015-01-15 00:03:08.000000', 'consum', 0.0226, 'lps'),
	(663323, 136, '2015-01-15 00:03:09.000000', 'consum', 0.0281, 'lps'),
	(663324, 136, '2015-01-15 00:03:10.000000', 'consum', 0.0226, 'lps'),
	(663325, 136, '2015-01-15 00:03:11.000000', 'consum', 0.0225, 'lps'),
	(663326, 136, '2015-01-15 00:03:12.000000', 'consum', 0.0235, 'lps'),
	(663327, 136, '2015-01-15 00:03:13.000000', 'consum', 0.0293, 'lps'),
	(663328, 136, '2015-01-15 00:03:14.000000', 'consum', 0.0255, 'lps'),
	(663329, 136, '2015-01-15 00:03:15.000000', 'consum', 0.0336, 'lps'),
	(663330, 136, '2015-01-15 00:03:16.000000', 'consum', 0.0263, 'lps'),
	(663331, 136, '2015-01-15 00:03:17.000000', 'consum', 0.0244, 'lps'),
	(663332, 136, '2015-01-15 00:03:18.000000', 'consum', 0.0224, 'lps'),
	(663333, 136, '2015-01-15 00:03:19.000000', 'consum', 0.0324, 'lps'),
	(663334, 136, '2015-01-15 00:03:20.000000', 'consum', 0.0297, 'lps'),
	(663335, 136, '2015-01-15 00:03:21.000000', 'consum', 0.0303, 'lps'),
	(663336, 136, '2015-01-15 00:03:22.000000', 'consum', 0.0267, 'lps'),
	(663337, 136, '2015-01-15 00:03:23.000000', 'consum', 0.0218, 'lps'),
	(663338, 136, '2015-01-15 00:03:24.000000', 'consum', 0.0226, 'lps'),
	(663339, 136, '2015-01-15 00:03:25.000000', 'consum', 0.0267, 'lps'),
	(663340, 136, '2015-01-15 00:03:26.000000', 'consum', 0.0302, 'lps'),
	(663341, 136, '2015-01-15 00:03:27.000000', 'consum', 0.0352, 'lps'),
	(663342, 136, '2015-01-15 00:03:28.000000', 'consum', 0.0349, 'lps'),
	(663343, 136, '2015-01-15 00:03:29.000000', 'consum', 0.0332, 'lps'),
	(663344, 136, '2015-01-15 00:03:30.000000', 'consum', 0.0256, 'lps'),
	(663345, 136, '2015-01-15 00:03:31.000000', 'consum', 0.0225, 'lps'),
	(663346, 136, '2015-01-15 00:03:32.000000', 'consum', 0.0291, 'lps'),
	(663347, 136, '2015-01-15 00:03:33.000000', 'consum', 0.0276, 'lps'),
	(663348, 136, '2015-01-15 00:03:34.000000', 'consum', 0.0301, 'lps'),
	(663349, 136, '2015-01-15 00:03:35.000000', 'consum', 0.0317, 'lps'),
	(663350, 136, '2015-01-15 00:03:36.000000', 'consum', 0.0328, 'lps'),
	(663351, 136, '2015-01-15 00:03:37.000000', 'consum', 0.0331, 'lps'),
	(663352, 136, '2015-01-15 00:03:38.000000', 'consum', 0.0317, 'lps'),
	(663353, 136, '2015-01-15 00:03:39.000000', 'consum', 0.0235, 'lps'),
	(663354, 136, '2015-01-15 00:03:40.000000', 'consum', 0.0306, 'lps'),
	(663355, 136, '2015-01-15 00:03:41.000000', 'consum', 0.0322, 'lps'),
	(663356, 136, '2015-01-15 00:03:42.000000', 'consum', 0.0337, 'lps'),
	(663357, 136, '2015-01-15 00:03:43.000000', 'consum', 0.0213, 'lps'),
	(663358, 136, '2015-01-15 00:03:44.000000', 'consum', 0.0289, 'lps'),
	(663359, 136, '2015-01-15 00:03:45.000000', 'consum', 0.0300, 'lps'),
	(663360, 136, '2015-01-15 00:03:46.000000', 'consum', 0.0278, 'lps'),
	(663361, 136, '2015-01-15 00:03:47.000000', 'consum', 0.0280, 'lps'),
	(663362, 136, '2015-01-15 00:03:48.000000', 'consum', 0.0355, 'lps'),
	(663363, 136, '2015-01-15 00:03:49.000000', 'consum', 0.0285, 'lps'),
	(663364, 136, '2015-01-15 00:03:50.000000', 'consum', 0.0298, 'lps'),
	(663365, 136, '2015-01-15 00:03:51.000000', 'consum', 0.0277, 'lps'),
	(663366, 136, '2015-01-15 00:03:52.000000', 'consum', 0.0281, 'lps'),
	(663367, 136, '2015-01-15 00:03:53.000000', 'consum', 0.0219, 'lps'),
	(663368, 136, '2015-01-15 00:03:54.000000', 'consum', 0.0335, 'lps'),
	(663369, 136, '2015-01-15 00:03:55.000000', 'consum', 0.0220, 'lps'),
	(663370, 136, '2015-01-15 00:03:56.000000', 'consum', 0.0326, 'lps'),
	(663371, 136, '2015-01-15 00:03:57.000000', 'consum', 0.0321, 'lps'),
	(663372, 136, '2015-01-15 00:03:58.000000', 'consum', 0.0268, 'lps'),
	(663373, 136, '2015-01-15 00:03:59.000000', 'consum', 0.0316, 'lps'),
	(663374, 136, '2015-01-15 00:04:00.000000', 'consum', 0.0272, 'lps'),
	(663375, 136, '2015-01-15 00:04:01.000000', 'consum', 0.0352, 'lps'),
	(663376, 136, '2015-01-15 00:04:02.000000', 'consum', 0.0291, 'lps'),
	(663377, 136, '2015-01-15 00:04:03.000000', 'consum', 0.0336, 'lps'),
	(663378, 136, '2015-01-15 00:04:04.000000', 'consum', 0.0304, 'lps'),
	(663379, 136, '2015-01-15 00:04:05.000000', 'consum', 0.0303, 'lps'),
	(663380, 136, '2015-01-15 00:04:06.000000', 'consum', 0.0246, 'lps'),
	(663381, 136, '2015-01-15 00:04:07.000000', 'consum', 0.0258, 'lps'),
	(663382, 136, '2015-01-15 00:04:08.000000', 'consum', 0.0342, 'lps'),
	(663383, 136, '2015-01-15 00:04:09.000000', 'consum', 0.0287, 'lps'),
	(663384, 136, '2015-01-15 00:04:10.000000', 'consum', 0.0345, 'lps'),
	(663385, 136, '2015-01-15 00:04:11.000000', 'consum', 0.0216, 'lps'),
	(663386, 136, '2015-01-15 00:04:12.000000', 'consum', 0.0276, 'lps'),
	(663387, 136, '2015-01-15 00:04:13.000000', 'consum', 0.0230, 'lps'),
	(663388, 136, '2015-01-15 00:04:14.000000', 'consum', 0.0258, 'lps'),
	(663389, 136, '2015-01-15 00:04:15.000000', 'consum', 0.0243, 'lps'),
	(663390, 136, '2015-01-15 00:04:16.000000', 'consum', 0.0232, 'lps'),
	(663391, 136, '2015-01-15 00:04:17.000000', 'consum', 0.0219, 'lps'),
	(663392, 136, '2015-01-15 00:04:18.000000', 'consum', 0.0339, 'lps'),
	(663393, 136, '2015-01-15 00:04:19.000000', 'consum', 0.0242, 'lps'),
	(663394, 136, '2015-01-15 00:04:20.000000', 'consum', 0.0276, 'lps'),
	(663395, 136, '2015-01-15 00:04:21.000000', 'consum', 0.0296, 'lps'),
	(663396, 136, '2015-01-15 00:04:22.000000', 'consum', 0.0295, 'lps'),
	(663397, 136, '2015-01-15 00:04:23.000000', 'consum', 0.0231, 'lps'),
	(663398, 136, '2015-01-15 00:04:24.000000', 'consum', 0.0355, 'lps'),
	(663399, 136, '2015-01-15 00:04:25.000000', 'consum', 0.0283, 'lps'),
	(663400, 136, '2015-01-15 00:04:26.000000', 'consum', 0.0288, 'lps'),
	(663401, 136, '2015-01-15 00:04:27.000000', 'consum', 0.0234, 'lps'),
	(663402, 136, '2015-01-15 00:04:28.000000', 'consum', 0.0245, 'lps'),
	(663403, 136, '2015-01-15 00:04:29.000000', 'consum', 0.0313, 'lps'),
	(663404, 136, '2015-01-15 00:04:30.000000', 'consum', 0.0327, 'lps'),
	(663405, 136, '2015-01-15 00:04:31.000000', 'consum', 0.0338, 'lps'),
	(663406, 136, '2015-01-15 00:04:32.000000', 'consum', 0.0352, 'lps'),
	(663407, 136, '2015-01-15 00:04:33.000000', 'consum', 0.0245, 'lps'),
	(663408, 136, '2015-01-15 00:04:34.000000', 'consum', 0.0253, 'lps'),
	(663409, 136, '2015-01-15 00:04:35.000000', 'consum', 0.0321, 'lps'),
	(663410, 136, '2015-01-15 00:04:36.000000', 'consum', 0.0340, 'lps'),
	(663411, 136, '2015-01-15 00:04:37.000000', 'consum', 0.0234, 'lps'),
	(663412, 136, '2015-01-15 00:04:38.000000', 'consum', 0.0235, 'lps'),
	(663413, 136, '2015-01-15 00:04:39.000000', 'consum', 0.0265, 'lps'),
	(663414, 136, '2015-01-15 00:04:40.000000', 'consum', 0.0264, 'lps'),
	(663415, 136, '2015-01-15 00:04:41.000000', 'consum', 0.0315, 'lps'),
	(663416, 136, '2015-01-15 00:04:42.000000', 'consum', 0.0281, 'lps'),
	(663417, 136, '2015-01-15 00:04:43.000000', 'consum', 0.0250, 'lps'),
	(663418, 136, '2015-01-15 00:04:44.000000', 'consum', 0.0345, 'lps'),
	(663419, 136, '2015-01-15 00:04:45.000000', 'consum', 0.0324, 'lps'),
	(663420, 136, '2015-01-15 00:04:46.000000', 'consum', 0.0230, 'lps'),
	(663421, 136, '2015-01-15 00:04:47.000000', 'consum', 0.0262, 'lps'),
	(663422, 136, '2015-01-15 00:04:48.000000', 'consum', 0.0264, 'lps'),
	(663423, 136, '2015-01-15 00:04:49.000000', 'consum', 0.0322, 'lps'),
	(663424, 136, '2015-01-15 00:04:50.000000', 'consum', 0.0317, 'lps'),
	(663425, 136, '2015-01-15 00:04:51.000000', 'consum', 0.0260, 'lps'),
	(663426, 136, '2015-01-15 00:04:52.000000', 'consum', 0.0289, 'lps'),
	(663427, 136, '2015-01-15 00:04:53.000000', 'consum', 0.0309, 'lps'),
	(663428, 136, '2015-01-15 00:04:54.000000', 'consum', 0.0320, 'lps'),
	(663429, 136, '2015-01-15 00:04:55.000000', 'consum', 0.0318, 'lps'),
	(663430, 136, '2015-01-15 00:04:56.000000', 'consum', 0.0273, 'lps'),
	(663431, 136, '2015-01-15 00:04:57.000000', 'consum', 0.0348, 'lps'),
	(663432, 136, '2015-01-15 00:04:58.000000', 'consum', 0.0269, 'lps'),
	(663433, 136, '2015-01-15 00:04:59.000000', 'consum', 0.0240, 'lps'),
	(663434, 136, '2015-01-15 00:05:00.000000', 'consum', 0.0332, 'lps'),
	(663435, 136, '2015-01-15 00:05:01.000000', 'consum', 0.0288, 'lps'),
	(663436, 136, '2015-01-15 00:05:02.000000', 'consum', 0.0236, 'lps'),
	(663437, 136, '2015-01-15 00:05:03.000000', 'consum', 0.0254, 'lps'),
	(663438, 136, '2015-01-15 00:05:04.000000', 'consum', 0.0352, 'lps'),
	(663439, 136, '2015-01-15 00:05:05.000000', 'consum', 0.0346, 'lps'),
	(663440, 136, '2015-01-15 00:05:06.000000', 'consum', 0.0317, 'lps'),
	(663441, 136, '2015-01-15 00:05:07.000000', 'consum', 0.0340, 'lps'),
	(663442, 136, '2015-01-15 00:05:08.000000', 'consum', 0.0246, 'lps'),
	(663443, 136, '2015-01-15 00:05:09.000000', 'consum', 0.0292, 'lps'),
	(663444, 136, '2015-01-15 00:05:10.000000', 'consum', 0.0218, 'lps'),
	(663445, 136, '2015-01-15 00:05:11.000000', 'consum', 0.0298, 'lps'),
	(663446, 136, '2015-01-15 00:05:12.000000', 'consum', 0.0333, 'lps'),
	(663447, 136, '2015-01-15 00:05:13.000000', 'consum', 0.0267, 'lps'),
	(663448, 136, '2015-01-15 00:05:14.000000', 'consum', 0.0275, 'lps'),
	(663449, 136, '2015-01-15 00:05:15.000000', 'consum', 0.0215, 'lps'),
	(663450, 136, '2015-01-15 00:05:16.000000', 'consum', 0.0337, 'lps'),
	(663451, 136, '2015-01-15 00:05:17.000000', 'consum', 0.0243, 'lps'),
	(663452, 136, '2015-01-15 00:05:18.000000', 'consum', 0.0289, 'lps'),
	(663453, 136, '2015-01-15 00:05:19.000000', 'consum', 0.0212, 'lps'),
	(663454, 136, '2015-01-15 00:05:20.000000', 'consum', 0.0277, 'lps'),
	(663455, 136, '2015-01-15 00:05:21.000000', 'consum', 0.0247, 'lps'),
	(663456, 136, '2015-01-15 00:05:22.000000', 'consum', 0.0341, 'lps'),
	(663457, 136, '2015-01-15 00:05:23.000000', 'consum', 0.0311, 'lps'),
	(663458, 136, '2015-01-15 00:05:24.000000', 'consum', 0.0325, 'lps'),
	(663459, 136, '2015-01-15 00:05:25.000000', 'consum', 0.0336, 'lps'),
	(663460, 136, '2015-01-15 00:05:26.000000', 'consum', 0.0346, 'lps'),
	(663461, 136, '2015-01-15 00:05:27.000000', 'consum', 0.0220, 'lps'),
	(663462, 136, '2015-01-15 00:05:28.000000', 'consum', 0.0291, 'lps'),
	(663463, 136, '2015-01-15 00:05:29.000000', 'consum', 0.0294, 'lps'),
	(663464, 136, '2015-01-15 00:05:30.000000', 'consum', 0.0239, 'lps'),
	(663465, 136, '2015-01-15 00:05:31.000000', 'consum', 0.0252, 'lps'),
	(663466, 136, '2015-01-15 00:05:32.000000', 'consum', 0.0333, 'lps'),
	(663467, 136, '2015-01-15 00:05:33.000000', 'consum', 0.0257, 'lps'),
	(663468, 136, '2015-01-15 00:05:34.000000', 'consum', 0.0226, 'lps'),
	(663469, 136, '2015-01-15 00:05:35.000000', 'consum', 0.0297, 'lps'),
	(663470, 136, '2015-01-15 00:05:36.000000', 'consum', 0.0303, 'lps'),
	(663471, 136, '2015-01-15 00:05:37.000000', 'consum', 0.0265, 'lps'),
	(663472, 136, '2015-01-15 00:05:38.000000', 'consum', 0.0210, 'lps'),
	(663473, 136, '2015-01-15 00:05:39.000000', 'consum', 0.0338, 'lps'),
	(663474, 136, '2015-01-15 00:05:40.000000', 'consum', 0.0263, 'lps'),
	(663475, 136, '2015-01-15 00:05:41.000000', 'consum', 0.0239, 'lps'),
	(663476, 136, '2015-01-15 00:05:42.000000', 'consum', 0.0341, 'lps'),
	(663477, 136, '2015-01-15 00:05:43.000000', 'consum', 0.0339, 'lps'),
	(663478, 136, '2015-01-15 00:05:44.000000', 'consum', 0.0317, 'lps'),
	(663479, 136, '2015-01-15 00:05:45.000000', 'consum', 0.0210, 'lps'),
	(663480, 136, '2015-01-15 00:05:46.000000', 'consum', 0.0330, 'lps'),
	(663481, 136, '2015-01-15 00:05:47.000000', 'consum', 0.0224, 'lps'),
	(663482, 136, '2015-01-15 00:05:48.000000', 'consum', 0.0212, 'lps'),
	(663483, 136, '2015-01-15 00:05:49.000000', 'consum', 0.0326, 'lps'),
	(663484, 136, '2015-01-15 00:05:50.000000', 'consum', 0.0344, 'lps'),
	(663485, 136, '2015-01-15 00:05:51.000000', 'consum', 0.0236, 'lps'),
	(663486, 136, '2015-01-15 00:05:52.000000', 'consum', 0.0236, 'lps'),
	(663487, 136, '2015-01-15 00:05:53.000000', 'consum', 0.0262, 'lps'),
	(663488, 136, '2015-01-15 00:05:54.000000', 'consum', 0.0246, 'lps'),
	(663489, 136, '2015-01-15 00:05:55.000000', 'consum', 0.0232, 'lps'),
	(663490, 136, '2015-01-15 00:05:56.000000', 'consum', 0.0214, 'lps'),
	(663491, 136, '2015-01-15 00:05:57.000000', 'consum', 0.0309, 'lps'),
	(663492, 136, '2015-01-15 00:05:58.000000', 'consum', 0.0255, 'lps'),
	(663493, 136, '2015-01-15 00:05:59.000000', 'consum', 0.0286, 'lps'),
	(663494, 136, '2015-01-15 00:06:00.000000', 'consum', 0.0309, 'lps'),
	(663495, 136, '2015-01-15 00:06:01.000000', 'consum', 0.0329, 'lps'),
	(663496, 136, '2015-01-15 00:06:02.000000', 'consum', 0.0214, 'lps'),
	(663497, 136, '2015-01-15 00:06:03.000000', 'consum', 0.0316, 'lps'),
	(663498, 136, '2015-01-15 00:06:04.000000', 'consum', 0.0287, 'lps'),
	(663499, 136, '2015-01-15 00:06:05.000000', 'consum', 0.0278, 'lps'),
	(663500, 136, '2015-01-15 00:06:06.000000', 'consum', 0.0319, 'lps'),
	(663501, 136, '2015-01-15 00:06:07.000000', 'consum', 0.0257, 'lps'),
	(663502, 136, '2015-01-15 00:06:08.000000', 'consum', 0.0267, 'lps'),
	(663503, 136, '2015-01-15 00:06:09.000000', 'consum', 0.0353, 'lps'),
	(663504, 136, '2015-01-15 00:06:10.000000', 'consum', 0.0316, 'lps'),
	(663505, 136, '2015-01-15 00:06:11.000000', 'consum', 0.0310, 'lps'),
	(663506, 136, '2015-01-15 00:06:12.000000', 'consum', 0.0245, 'lps'),
	(663507, 136, '2015-01-15 00:06:13.000000', 'consum', 0.0233, 'lps'),
	(663508, 136, '2015-01-15 00:06:14.000000', 'consum', 0.0221, 'lps'),
	(663509, 136, '2015-01-15 00:06:15.000000', 'consum', 0.0343, 'lps'),
	(663510, 136, '2015-01-15 00:06:16.000000', 'consum', 0.0254, 'lps'),
	(663511, 136, '2015-01-15 00:06:17.000000', 'consum', 0.0324, 'lps'),
	(663512, 136, '2015-01-15 00:06:18.000000', 'consum', 0.0211, 'lps'),
	(663513, 136, '2015-01-15 00:06:19.000000', 'consum', 0.0313, 'lps'),
	(663514, 136, '2015-01-15 00:06:20.000000', 'consum', 0.0280, 'lps'),
	(663515, 136, '2015-01-15 00:06:21.000000', 'consum', 0.0250, 'lps'),
	(663516, 136, '2015-01-15 00:06:22.000000', 'consum', 0.0351, 'lps'),
	(663517, 136, '2015-01-15 00:06:23.000000', 'consum', 0.0353, 'lps'),
	(663518, 136, '2015-01-15 00:06:24.000000', 'consum', 0.0210, 'lps'),
	(663519, 136, '2015-01-15 00:06:25.000000', 'consum', 0.0223, 'lps'),
	(663520, 136, '2015-01-15 00:06:26.000000', 'consum', 0.0273, 'lps'),
	(663521, 136, '2015-01-15 00:06:27.000000', 'consum', 0.0342, 'lps'),
	(663522, 136, '2015-01-15 00:06:28.000000', 'consum', 0.0239, 'lps'),
	(663523, 136, '2015-01-15 00:06:29.000000', 'consum', 0.0255, 'lps'),
	(663524, 136, '2015-01-15 00:06:30.000000', 'consum', 0.0348, 'lps'),
	(663525, 136, '2015-01-15 00:06:31.000000', 'consum', 0.0326, 'lps'),
	(663526, 136, '2015-01-15 00:06:32.000000', 'consum', 0.0227, 'lps'),
	(663527, 136, '2015-01-15 00:06:33.000000', 'consum', 0.0241, 'lps'),
	(663528, 136, '2015-01-15 00:06:34.000000', 'consum', 0.0313, 'lps'),
	(663529, 136, '2015-01-15 00:06:35.000000', 'consum', 0.0342, 'lps'),
	(663530, 136, '2015-01-15 00:06:36.000000', 'consum', 0.0267, 'lps'),
	(663531, 136, '2015-01-15 00:06:37.000000', 'consum', 0.0246, 'lps'),
	(663532, 136, '2015-01-15 00:06:38.000000', 'consum', 0.0221, 'lps'),
	(663533, 136, '2015-01-15 00:06:39.000000', 'consum', 0.0305, 'lps'),
	(663534, 136, '2015-01-15 00:06:40.000000', 'consum', 0.0356, 'lps'),
	(663535, 136, '2015-01-15 00:06:41.000000', 'consum', 0.0217, 'lps'),
	(663536, 136, '2015-01-15 00:06:42.000000', 'consum', 0.0246, 'lps'),
	(663537, 136, '2015-01-15 00:06:43.000000', 'consum', 0.0223, 'lps'),
	(663538, 136, '2015-01-15 00:06:44.000000', 'consum', 0.0314, 'lps'),
	(663539, 136, '2015-01-15 00:06:45.000000', 'consum', 0.0250, 'lps'),
	(663540, 136, '2015-01-15 00:06:46.000000', 'consum', 0.0244, 'lps'),
	(663541, 136, '2015-01-15 00:06:47.000000', 'consum', 0.0263, 'lps'),
	(663542, 136, '2015-01-15 00:06:48.000000', 'consum', 0.0224, 'lps'),
	(663543, 136, '2015-01-15 00:06:49.000000', 'consum', 0.0270, 'lps'),
	(663544, 136, '2015-01-15 00:06:50.000000', 'consum', 0.0321, 'lps'),
	(663545, 136, '2015-01-15 00:06:51.000000', 'consum', 0.0293, 'lps'),
	(663546, 136, '2015-01-15 00:06:52.000000', 'consum', 0.0291, 'lps'),
	(663547, 136, '2015-01-15 00:06:53.000000', 'consum', 0.0222, 'lps'),
	(663548, 136, '2015-01-15 00:06:54.000000', 'consum', 0.0318, 'lps'),
	(663549, 136, '2015-01-15 00:06:55.000000', 'consum', 0.0275, 'lps'),
	(663550, 136, '2015-01-15 00:06:56.000000', 'consum', 0.0213, 'lps'),
	(663551, 136, '2015-01-15 00:06:57.000000', 'consum', 0.0325, 'lps'),
	(663552, 136, '2015-01-15 00:06:58.000000', 'consum', 0.0336, 'lps'),
	(663553, 136, '2015-01-15 00:06:59.000000', 'consum', 0.0347, 'lps'),
	(663554, 136, '2015-01-15 00:07:00.000000', 'consum', 0.0225, 'lps'),
	(663555, 136, '2015-01-15 00:07:01.000000', 'consum', 0.0313, 'lps'),
	(663556, 136, '2015-01-15 00:07:02.000000', 'consum', 0.0242, 'lps'),
	(663557, 136, '2015-01-15 00:07:03.000000', 'consum', 0.0356, 'lps'),
	(663558, 136, '2015-01-15 00:07:04.000000', 'consum', 0.0255, 'lps'),
	(663559, 136, '2015-01-15 00:07:05.000000', 'consum', 0.0294, 'lps'),
	(663560, 136, '2015-01-15 00:07:06.000000', 'consum', 0.0346, 'lps'),
	(663561, 136, '2015-01-15 00:07:07.000000', 'consum', 0.0344, 'lps'),
	(663562, 136, '2015-01-15 00:07:08.000000', 'consum', 0.0327, 'lps'),
	(663563, 136, '2015-01-15 00:07:09.000000', 'consum', 0.0244, 'lps'),
	(663564, 136, '2015-01-15 00:07:10.000000', 'consum', 0.0327, 'lps'),
	(663565, 136, '2015-01-15 00:07:11.000000', 'consum', 0.0251, 'lps'),
	(663566, 136, '2015-01-15 00:07:12.000000', 'consum', 0.0211, 'lps'),
	(663567, 136, '2015-01-15 00:07:13.000000', 'consum', 0.0240, 'lps'),
	(663568, 136, '2015-01-15 00:07:14.000000', 'consum', 0.0211, 'lps'),
	(663569, 136, '2015-01-15 00:07:15.000000', 'consum', 0.0271, 'lps'),
	(663570, 136, '2015-01-15 00:07:16.000000', 'consum', 0.0217, 'lps'),
	(663571, 136, '2015-01-15 00:07:17.000000', 'consum', 0.0212, 'lps'),
	(663572, 136, '2015-01-15 00:07:18.000000', 'consum', 0.0345, 'lps'),
	(663573, 136, '2015-01-15 00:07:19.000000', 'consum', 0.0292, 'lps'),
	(663574, 136, '2015-01-15 00:07:20.000000', 'consum', 0.0214, 'lps'),
	(663575, 136, '2015-01-15 00:07:21.000000', 'consum', 0.0280, 'lps'),
	(663576, 136, '2015-01-15 00:07:22.000000', 'consum', 0.0253, 'lps'),
	(663577, 136, '2015-01-15 00:07:23.000000', 'consum', 0.0214, 'lps'),
	(663578, 136, '2015-01-15 00:07:24.000000', 'consum', 0.0252, 'lps'),
	(663579, 136, '2015-01-15 00:07:25.000000', 'consum', 0.0261, 'lps'),
	(663580, 136, '2015-01-15 00:07:26.000000', 'consum', 0.0340, 'lps'),
	(663581, 136, '2015-01-15 00:07:27.000000', 'consum', 0.0265, 'lps'),
	(663582, 136, '2015-01-15 00:07:28.000000', 'consum', 0.0243, 'lps'),
	(663583, 136, '2015-01-15 00:07:29.000000', 'consum', 0.0356, 'lps'),
	(663584, 136, '2015-01-15 00:07:30.000000', 'consum', 0.0253, 'lps'),
	(663585, 136, '2015-01-15 00:07:31.000000', 'consum', 0.0281, 'lps'),
	(663586, 136, '2015-01-15 00:07:32.000000', 'consum', 0.0292, 'lps'),
	(663587, 136, '2015-01-15 00:07:33.000000', 'consum', 0.0258, 'lps'),
	(663588, 136, '2015-01-15 00:07:34.000000', 'consum', 0.0353, 'lps'),
	(663589, 136, '2015-01-15 00:07:35.000000', 'consum', 0.0342, 'lps'),
	(663590, 136, '2015-01-15 00:07:36.000000', 'consum', 0.0293, 'lps'),
	(663591, 136, '2015-01-15 00:07:37.000000', 'consum', 0.0228, 'lps'),
	(663592, 136, '2015-01-15 00:07:38.000000', 'consum', 0.0346, 'lps'),
	(663593, 136, '2015-01-15 00:07:39.000000', 'consum', 0.0249, 'lps'),
	(663594, 136, '2015-01-15 00:07:40.000000', 'consum', 0.0293, 'lps'),
	(663595, 136, '2015-01-15 00:07:41.000000', 'consum', 0.0215, 'lps'),
	(663596, 136, '2015-01-15 00:07:42.000000', 'consum', 0.0278, 'lps'),
	(663597, 136, '2015-01-15 00:07:43.000000', 'consum', 0.0241, 'lps'),
	(663598, 136, '2015-01-15 00:07:44.000000', 'consum', 0.0308, 'lps'),
	(663599, 136, '2015-01-15 00:07:45.000000', 'consum', 0.0316, 'lps'),
	(663600, 136, '2015-01-15 00:07:46.000000', 'consum', 0.0298, 'lps'),
	(663601, 136, '2015-01-15 00:07:47.000000', 'consum', 0.0334, 'lps'),
	(663602, 136, '2015-01-15 00:07:48.000000', 'consum', 0.0273, 'lps'),
	(663603, 136, '2015-01-15 00:07:49.000000', 'consum', 0.0301, 'lps'),
	(663604, 136, '2015-01-15 00:07:50.000000', 'consum', 0.0328, 'lps'),
	(663605, 136, '2015-01-15 00:07:51.000000', 'consum', 0.0235, 'lps'),
	(663606, 136, '2015-01-15 00:07:52.000000', 'consum', 0.0275, 'lps'),
	(663607, 136, '2015-01-15 00:07:53.000000', 'consum', 0.0314, 'lps'),
	(663608, 136, '2015-01-15 00:07:54.000000', 'consum', 0.0242, 'lps'),
	(663609, 136, '2015-01-15 00:07:55.000000', 'consum', 0.0352, 'lps'),
	(663610, 136, '2015-01-15 00:07:56.000000', 'consum', 0.0235, 'lps'),
	(663611, 136, '2015-01-15 00:07:57.000000', 'consum', 0.0349, 'lps'),
	(663612, 136, '2015-01-15 00:07:58.000000', 'consum', 0.0246, 'lps'),
	(663613, 136, '2015-01-15 00:07:59.000000', 'consum', 0.0266, 'lps'),
	(663614, 136, '2015-01-15 00:08:00.000000', 'consum', 0.0235, 'lps'),
	(663615, 136, '2015-01-15 00:08:01.000000', 'consum', 0.0314, 'lps'),
	(663616, 136, '2015-01-15 00:08:02.000000', 'consum', 0.0215, 'lps'),
	(663617, 136, '2015-01-15 00:08:03.000000', 'consum', 0.0219, 'lps'),
	(663618, 136, '2015-01-15 00:08:04.000000', 'consum', 0.0241, 'lps'),
	(663619, 136, '2015-01-15 00:08:05.000000', 'consum', 0.0338, 'lps'),
	(663620, 136, '2015-01-15 00:08:06.000000', 'consum', 0.0316, 'lps'),
	(663621, 136, '2015-01-15 00:08:07.000000', 'consum', 0.0355, 'lps'),
	(663622, 136, '2015-01-15 00:08:08.000000', 'consum', 0.0323, 'lps'),
	(663623, 136, '2015-01-15 00:08:09.000000', 'consum', 0.0340, 'lps'),
	(663624, 136, '2015-01-15 00:08:10.000000', 'consum', 0.0230, 'lps'),
	(663625, 136, '2015-01-15 00:08:11.000000', 'consum', 0.0215, 'lps'),
	(663626, 136, '2015-01-15 00:08:12.000000', 'consum', 0.0322, 'lps'),
	(663627, 136, '2015-01-15 00:08:13.000000', 'consum', 0.0312, 'lps'),
	(663628, 136, '2015-01-15 00:08:14.000000', 'consum', 0.0241, 'lps'),
	(663629, 136, '2015-01-15 00:08:15.000000', 'consum', 0.0351, 'lps'),
	(663630, 136, '2015-01-15 00:08:16.000000', 'consum', 0.0234, 'lps'),
	(663631, 136, '2015-01-15 00:08:17.000000', 'consum', 0.0352, 'lps'),
	(663632, 136, '2015-01-15 00:08:18.000000', 'consum', 0.0257, 'lps'),
	(663633, 136, '2015-01-15 00:08:19.000000', 'consum', 0.0313, 'lps'),
	(663634, 136, '2015-01-15 00:08:20.000000', 'consum', 0.0290, 'lps'),
	(663635, 136, '2015-01-15 00:08:21.000000', 'consum', 0.0304, 'lps'),
	(663636, 136, '2015-01-15 00:08:22.000000', 'consum', 0.0293, 'lps'),
	(663637, 136, '2015-01-15 00:08:23.000000', 'consum', 0.0344, 'lps'),
	(663638, 136, '2015-01-15 00:08:24.000000', 'consum', 0.0337, 'lps'),
	(663639, 136, '2015-01-15 00:08:25.000000', 'consum', 0.0295, 'lps'),
	(663640, 136, '2015-01-15 00:08:26.000000', 'consum', 0.0254, 'lps'),
	(663641, 136, '2015-01-15 00:08:27.000000', 'consum', 0.0325, 'lps'),
	(663642, 136, '2015-01-15 00:08:28.000000', 'consum', 0.0210, 'lps'),
	(663643, 136, '2015-01-15 00:08:29.000000', 'consum', 0.0307, 'lps'),
	(663644, 136, '2015-01-15 00:08:30.000000', 'consum', 0.0254, 'lps'),
	(663645, 136, '2015-01-15 00:08:31.000000', 'consum', 0.0286, 'lps'),
	(663646, 136, '2015-01-15 00:08:32.000000', 'consum', 0.0312, 'lps'),
	(663647, 136, '2015-01-15 00:08:33.000000', 'consum', 0.0347, 'lps'),
	(663648, 136, '2015-01-15 00:08:34.000000', 'consum', 0.0295, 'lps'),
	(663649, 136, '2015-01-15 00:08:35.000000', 'consum', 0.0225, 'lps'),
	(663650, 136, '2015-01-15 00:08:36.000000', 'consum', 0.0323, 'lps'),
	(663651, 136, '2015-01-15 00:08:37.000000', 'consum', 0.0289, 'lps'),
	(663652, 136, '2015-01-15 00:08:38.000000', 'consum', 0.0269, 'lps'),
	(663653, 136, '2015-01-15 00:08:39.000000', 'consum', 0.0266, 'lps'),
	(663654, 136, '2015-01-15 00:08:40.000000', 'consum', 0.0315, 'lps'),
	(663655, 136, '2015-01-15 00:08:41.000000', 'consum', 0.0275, 'lps'),
	(663656, 136, '2015-01-15 00:08:42.000000', 'consum', 0.0219, 'lps'),
	(663657, 136, '2015-01-15 00:08:43.000000', 'consum', 0.0354, 'lps'),
	(663658, 136, '2015-01-15 00:08:44.000000', 'consum', 0.0317, 'lps'),
	(663659, 136, '2015-01-15 00:08:45.000000', 'consum', 0.0312, 'lps'),
	(663660, 136, '2015-01-15 00:08:46.000000', 'consum', 0.0254, 'lps'),
	(663661, 136, '2015-01-15 00:08:47.000000', 'consum', 0.0273, 'lps'),
	(663662, 136, '2015-01-15 00:08:48.000000', 'consum', 0.0244, 'lps'),
	(663663, 136, '2015-01-15 00:08:49.000000', 'consum', 0.0340, 'lps'),
	(663664, 136, '2015-01-15 00:08:50.000000', 'consum', 0.0319, 'lps'),
	(663665, 136, '2015-01-15 00:08:51.000000', 'consum', 0.0216, 'lps'),
	(663666, 136, '2015-01-15 00:08:52.000000', 'consum', 0.0356, 'lps'),
	(663667, 136, '2015-01-15 00:08:53.000000', 'consum', 0.0336, 'lps'),
	(663668, 136, '2015-01-15 00:08:54.000000', 'consum', 0.0253, 'lps'),
	(663669, 136, '2015-01-15 00:08:55.000000', 'consum', 0.0342, 'lps'),
	(663670, 136, '2015-01-15 00:08:56.000000', 'consum', 0.0299, 'lps'),
	(663671, 136, '2015-01-15 00:08:57.000000', 'consum', 0.0263, 'lps'),
	(663672, 136, '2015-01-15 00:08:58.000000', 'consum', 0.0352, 'lps'),
	(663673, 136, '2015-01-15 00:08:59.000000', 'consum', 0.0323, 'lps'),
	(663674, 136, '2015-01-15 00:09:00.000000', 'consum', 0.0347, 'lps'),
	(663675, 136, '2015-01-15 00:09:01.000000', 'consum', 0.0266, 'lps'),
	(663676, 136, '2015-01-15 00:09:02.000000', 'consum', 0.0224, 'lps'),
	(663677, 136, '2015-01-15 00:09:03.000000', 'consum', 0.0259, 'lps'),
	(663678, 136, '2015-01-15 00:09:04.000000', 'consum', 0.0267, 'lps'),
	(663679, 136, '2015-01-15 00:09:05.000000', 'consum', 0.0350, 'lps'),
	(663680, 136, '2015-01-15 00:09:06.000000', 'consum', 0.0298, 'lps'),
	(663681, 136, '2015-01-15 00:09:07.000000', 'consum', 0.0231, 'lps'),
	(663682, 136, '2015-01-15 00:09:08.000000', 'consum', 0.0346, 'lps'),
	(663683, 136, '2015-01-15 00:09:09.000000', 'consum', 0.0237, 'lps'),
	(663684, 136, '2015-01-15 00:09:10.000000', 'consum', 0.0233, 'lps'),
	(663685, 136, '2015-01-15 00:09:11.000000', 'consum', 0.0243, 'lps'),
	(663686, 136, '2015-01-15 00:09:12.000000', 'consum', 0.0309, 'lps'),
	(663687, 136, '2015-01-15 00:09:13.000000', 'consum', 0.0311, 'lps'),
	(663688, 136, '2015-01-15 00:09:14.000000', 'consum', 0.0271, 'lps'),
	(663689, 136, '2015-01-15 00:09:15.000000', 'consum', 0.0213, 'lps'),
	(663690, 136, '2015-01-15 00:09:16.000000', 'consum', 0.0335, 'lps'),
	(663691, 136, '2015-01-15 00:09:17.000000', 'consum', 0.0238, 'lps'),
	(663692, 136, '2015-01-15 00:09:18.000000', 'consum', 0.0273, 'lps'),
	(663693, 136, '2015-01-15 00:09:19.000000', 'consum', 0.0291, 'lps'),
	(663694, 136, '2015-01-15 00:09:20.000000', 'consum', 0.0282, 'lps'),
	(663695, 136, '2015-01-15 00:09:21.000000', 'consum', 0.0327, 'lps'),
	(663696, 136, '2015-01-15 00:09:22.000000', 'consum', 0.0285, 'lps'),
	(663697, 136, '2015-01-15 00:09:23.000000', 'consum', 0.0234, 'lps'),
	(663698, 136, '2015-01-15 00:09:24.000000', 'consum', 0.0251, 'lps'),
	(663699, 136, '2015-01-15 00:09:25.000000', 'consum', 0.0346, 'lps'),
	(663700, 136, '2015-01-15 00:09:26.000000', 'consum', 0.0327, 'lps'),
	(663701, 136, '2015-01-15 00:09:27.000000', 'consum', 0.0240, 'lps'),
	(663702, 136, '2015-01-15 00:09:28.000000', 'consum', 0.0303, 'lps'),
	(663703, 136, '2015-01-15 00:09:29.000000', 'consum', 0.0292, 'lps'),
	(663704, 136, '2015-01-15 00:09:30.000000', 'consum', 0.0342, 'lps'),
	(663705, 136, '2015-01-15 00:09:31.000000', 'consum', 0.0329, 'lps'),
	(663706, 136, '2015-01-15 00:09:32.000000', 'consum', 0.0262, 'lps'),
	(663707, 136, '2015-01-15 00:09:33.000000', 'consum', 0.0261, 'lps'),
	(663708, 136, '2015-01-15 00:09:34.000000', 'consum', 0.0309, 'lps'),
	(663709, 136, '2015-01-15 00:09:35.000000', 'consum', 0.0259, 'lps'),
	(663710, 136, '2015-01-15 00:09:36.000000', 'consum', 0.0307, 'lps'),
	(663711, 136, '2015-01-15 00:09:37.000000', 'consum', 0.0252, 'lps'),
	(663712, 136, '2015-01-15 00:09:38.000000', 'consum', 0.0278, 'lps'),
	(663713, 136, '2015-01-15 00:09:39.000000', 'consum', 0.0276, 'lps'),
	(663714, 136, '2015-01-15 00:09:40.000000', 'consum', 0.0339, 'lps'),
	(663715, 136, '2015-01-15 00:09:41.000000', 'consum', 0.0217, 'lps'),
	(663716, 136, '2015-01-15 00:09:42.000000', 'consum', 0.0297, 'lps'),
	(663717, 136, '2015-01-15 00:09:43.000000', 'consum', 0.0330, 'lps'),
	(663718, 136, '2015-01-15 00:09:44.000000', 'consum', 0.0257, 'lps'),
	(663719, 136, '2015-01-15 00:09:45.000000', 'consum', 0.0230, 'lps'),
	(663720, 136, '2015-01-15 00:09:46.000000', 'consum', 0.0319, 'lps'),
	(663721, 136, '2015-01-15 00:09:47.000000', 'consum', 0.0253, 'lps'),
	(663722, 136, '2015-01-15 00:09:48.000000', 'consum', 0.0244, 'lps'),
	(663723, 136, '2015-01-15 00:09:49.000000', 'consum', 0.0255, 'lps'),
	(663724, 136, '2015-01-15 00:09:50.000000', 'consum', 0.0332, 'lps'),
	(663725, 136, '2015-01-15 00:09:51.000000', 'consum', 0.0245, 'lps'),
	(663726, 136, '2015-01-15 00:09:52.000000', 'consum', 0.0312, 'lps'),
	(663727, 136, '2015-01-15 00:09:53.000000', 'consum', 0.0321, 'lps'),
	(663728, 136, '2015-01-15 00:09:54.000000', 'consum', 0.0313, 'lps'),
	(663729, 136, '2015-01-15 00:09:55.000000', 'consum', 0.0247, 'lps'),
	(663730, 136, '2015-01-15 00:09:56.000000', 'consum', 0.0231, 'lps'),
	(663731, 136, '2015-01-15 00:09:57.000000', 'consum', 0.0354, 'lps'),
	(663732, 136, '2015-01-15 00:09:58.000000', 'consum', 0.0277, 'lps'),
	(663733, 136, '2015-01-15 00:09:59.000000', 'consum', 0.0262, 'lps'),
	(663734, 136, '2015-01-15 00:10:00.000000', 'consum', 0.0268, 'lps'),
	(663735, 136, '2015-01-15 00:10:01.000000', 'consum', 0.0346, 'lps'),
	(663736, 136, '2015-01-15 00:10:02.000000', 'consum', 0.0277, 'lps'),
	(663737, 136, '2015-01-15 00:10:03.000000', 'consum', 0.0281, 'lps'),
	(663738, 136, '2015-01-15 00:10:04.000000', 'consum', 0.0221, 'lps'),
	(663739, 136, '2015-01-15 00:10:05.000000', 'consum', 0.0343, 'lps'),
	(663740, 136, '2015-01-15 00:10:06.000000', 'consum', 0.0257, 'lps'),
	(663741, 136, '2015-01-15 00:10:07.000000', 'consum', 0.0339, 'lps'),
	(663742, 136, '2015-01-15 00:10:08.000000', 'consum', 0.0276, 'lps'),
	(663743, 136, '2015-01-15 00:10:09.000000', 'consum', 0.0297, 'lps'),
	(663744, 136, '2015-01-15 00:10:10.000000', 'consum', 0.0303, 'lps'),
	(663745, 136, '2015-01-15 00:10:11.000000', 'consum', 0.0269, 'lps'),
	(663746, 136, '2015-01-15 00:10:12.000000', 'consum', 0.0223, 'lps'),
	(663747, 136, '2015-01-15 00:10:13.000000', 'consum', 0.0247, 'lps'),
	(663748, 136, '2015-01-15 00:10:14.000000', 'consum', 0.0210, 'lps'),
	(663749, 136, '2015-01-15 00:10:15.000000', 'consum', 0.0246, 'lps'),
	(663750, 136, '2015-01-15 00:10:16.000000', 'consum', 0.0242, 'lps'),
	(663751, 136, '2015-01-15 00:10:17.000000', 'consum', 0.0264, 'lps'),
	(663752, 136, '2015-01-15 00:10:18.000000', 'consum', 0.0239, 'lps'),
	(663753, 136, '2015-01-15 00:10:19.000000', 'consum', 0.0339, 'lps'),
	(663754, 136, '2015-01-15 00:10:20.000000', 'consum', 0.0327, 'lps'),
	(663755, 136, '2015-01-15 00:10:21.000000', 'consum', 0.0263, 'lps'),
	(663756, 136, '2015-01-15 00:10:22.000000', 'consum', 0.0272, 'lps'),
	(663757, 136, '2015-01-15 00:10:23.000000', 'consum', 0.0215, 'lps'),
	(663758, 136, '2015-01-15 00:10:24.000000', 'consum', 0.0344, 'lps'),
	(663759, 136, '2015-01-15 00:10:25.000000', 'consum', 0.0275, 'lps'),
	(663760, 136, '2015-01-15 00:10:26.000000', 'consum', 0.0283, 'lps'),
	(663761, 136, '2015-01-15 00:10:27.000000', 'consum', 0.0233, 'lps'),
	(663762, 136, '2015-01-15 00:10:28.000000', 'consum', 0.0253, 'lps'),
	(663763, 136, '2015-01-15 00:10:29.000000', 'consum', 0.0211, 'lps'),
	(663764, 136, '2015-01-15 00:10:30.000000', 'consum', 0.0233, 'lps'),
	(663765, 136, '2015-01-15 00:10:31.000000', 'consum', 0.0321, 'lps'),
	(663766, 136, '2015-01-15 00:10:32.000000', 'consum', 0.0257, 'lps'),
	(663767, 136, '2015-01-15 00:10:33.000000', 'consum', 0.0259, 'lps'),
	(663768, 136, '2015-01-15 00:10:34.000000', 'consum', 0.0315, 'lps'),
	(663769, 136, '2015-01-15 00:10:35.000000', 'consum', 0.0293, 'lps'),
	(663770, 136, '2015-01-15 00:10:36.000000', 'consum', 0.0311, 'lps'),
	(663771, 136, '2015-01-15 00:10:37.000000', 'consum', 0.0319, 'lps'),
	(663772, 136, '2015-01-15 00:10:38.000000', 'consum', 0.0306, 'lps'),
	(663773, 136, '2015-01-15 00:10:39.000000', 'consum', 0.0215, 'lps'),
	(663774, 136, '2015-01-15 00:10:40.000000', 'consum', 0.0243, 'lps'),
	(663775, 136, '2015-01-15 00:10:41.000000', 'consum', 0.0213, 'lps'),
	(663776, 136, '2015-01-15 00:10:42.000000', 'consum', 0.0275, 'lps'),
	(663777, 136, '2015-01-15 00:10:43.000000', 'consum', 0.0230, 'lps'),
	(663778, 136, '2015-01-15 00:10:44.000000', 'consum', 0.0262, 'lps'),
	(663779, 136, '2015-01-15 00:10:45.000000', 'consum', 0.0266, 'lps'),
	(663780, 136, '2015-01-15 00:10:46.000000', 'consum', 0.0332, 'lps'),
	(663781, 136, '2015-01-15 00:10:47.000000', 'consum', 0.0213, 'lps'),
	(663782, 136, '2015-01-15 00:10:48.000000', 'consum', 0.0301, 'lps'),
	(663783, 136, '2015-01-15 00:10:49.000000', 'consum', 0.0215, 'lps'),
	(663784, 136, '2015-01-15 00:10:50.000000', 'consum', 0.0257, 'lps'),
	(663785, 136, '2015-01-15 00:10:51.000000', 'consum', 0.0281, 'lps'),
	(663786, 136, '2015-01-15 00:10:52.000000', 'consum', 0.0281, 'lps'),
	(663787, 136, '2015-01-15 00:10:53.000000', 'consum', 0.0351, 'lps'),
	(663788, 136, '2015-01-15 00:10:54.000000', 'consum', 0.0262, 'lps'),
	(663789, 136, '2015-01-15 00:10:55.000000', 'consum', 0.0343, 'lps'),
	(663790, 136, '2015-01-15 00:10:56.000000', 'consum', 0.0276, 'lps'),
	(663791, 136, '2015-01-15 00:10:57.000000', 'consum', 0.0289, 'lps'),
	(663792, 136, '2015-01-15 00:10:58.000000', 'consum', 0.0260, 'lps'),
	(663793, 136, '2015-01-15 00:10:59.000000', 'consum', 0.0225, 'lps'),
	(663794, 136, '2015-01-15 00:11:00.000000', 'consum', 0.0280, 'lps'),
	(663795, 136, '2015-01-15 00:11:01.000000', 'consum', 0.0223, 'lps'),
	(663796, 136, '2015-01-15 00:11:02.000000', 'consum', 0.0213, 'lps'),
	(663797, 136, '2015-01-15 00:11:03.000000', 'consum', 0.0334, 'lps'),
	(663798, 136, '2015-01-15 00:11:04.000000', 'consum', 0.0234, 'lps'),
	(663799, 136, '2015-01-15 00:11:05.000000', 'consum', 0.0254, 'lps'),
	(663800, 136, '2015-01-15 00:11:06.000000', 'consum', 0.0355, 'lps'),
	(663801, 136, '2015-01-15 00:11:07.000000', 'consum', 0.0218, 'lps'),
	(663802, 136, '2015-01-15 00:11:08.000000', 'consum', 0.0254, 'lps'),
	(663803, 136, '2015-01-15 00:11:09.000000', 'consum', 0.0260, 'lps'),
	(663804, 136, '2015-01-15 00:11:10.000000', 'consum', 0.0327, 'lps'),
	(663805, 136, '2015-01-15 00:11:11.000000', 'consum', 0.0354, 'lps'),
	(663806, 136, '2015-01-15 00:11:12.000000', 'consum', 0.0285, 'lps'),
	(663807, 136, '2015-01-15 00:11:13.000000', 'consum', 0.0301, 'lps'),
	(663808, 136, '2015-01-15 00:11:14.000000', 'consum', 0.0292, 'lps'),
	(663809, 136, '2015-01-15 00:11:15.000000', 'consum', 0.0349, 'lps'),
	(663810, 136, '2015-01-15 00:11:16.000000', 'consum', 0.0218, 'lps'),
	(663811, 136, '2015-01-15 00:11:17.000000', 'consum', 0.0276, 'lps'),
	(663812, 136, '2015-01-15 00:11:18.000000', 'consum', 0.0220, 'lps'),
	(663813, 136, '2015-01-15 00:11:19.000000', 'consum', 0.0356, 'lps'),
	(663814, 136, '2015-01-15 00:11:20.000000', 'consum', 0.0325, 'lps'),
	(663815, 136, '2015-01-15 00:11:21.000000', 'consum', 0.0348, 'lps'),
	(663816, 136, '2015-01-15 00:11:22.000000', 'consum', 0.0262, 'lps'),
	(663817, 136, '2015-01-15 00:11:23.000000', 'consum', 0.0348, 'lps'),
	(663818, 136, '2015-01-15 00:11:24.000000', 'consum', 0.0306, 'lps'),
	(663819, 136, '2015-01-15 00:11:25.000000', 'consum', 0.0276, 'lps'),
	(663820, 136, '2015-01-15 00:11:26.000000', 'consum', 0.0252, 'lps'),
	(663821, 136, '2015-01-15 00:11:27.000000', 'consum', 0.0224, 'lps'),
	(663822, 136, '2015-01-15 00:11:28.000000', 'consum', 0.0299, 'lps'),
	(663823, 136, '2015-01-15 00:11:29.000000', 'consum', 0.0322, 'lps'),
	(663824, 136, '2015-01-15 00:11:30.000000', 'consum', 0.0356, 'lps'),
	(663825, 136, '2015-01-15 00:11:31.000000', 'consum', 0.0311, 'lps'),
	(663826, 136, '2015-01-15 00:11:32.000000', 'consum', 0.0275, 'lps'),
	(663827, 136, '2015-01-15 00:11:33.000000', 'consum', 0.0234, 'lps'),
	(663828, 136, '2015-01-15 00:11:34.000000', 'consum', 0.0284, 'lps'),
	(663829, 136, '2015-01-15 00:11:35.000000', 'consum', 0.0213, 'lps'),
	(663830, 136, '2015-01-15 00:11:36.000000', 'consum', 0.0296, 'lps'),
	(663831, 136, '2015-01-15 00:11:37.000000', 'consum', 0.0341, 'lps'),
	(663832, 136, '2015-01-15 00:11:38.000000', 'consum', 0.0311, 'lps'),
	(663833, 136, '2015-01-15 00:11:39.000000', 'consum', 0.0324, 'lps'),
	(663834, 136, '2015-01-15 00:11:40.000000', 'consum', 0.0331, 'lps'),
	(663835, 136, '2015-01-15 00:11:41.000000', 'consum', 0.0327, 'lps'),
	(663836, 136, '2015-01-15 00:11:42.000000', 'consum', 0.0283, 'lps'),
	(663837, 136, '2015-01-15 00:11:43.000000', 'consum', 0.0224, 'lps'),
	(663838, 136, '2015-01-15 00:11:44.000000', 'consum', 0.0212, 'lps'),
	(663839, 136, '2015-01-15 00:11:45.000000', 'consum', 0.0322, 'lps'),
	(663840, 136, '2015-01-15 00:11:46.000000', 'consum', 0.0326, 'lps'),
	(663841, 136, '2015-01-15 00:11:47.000000', 'consum', 0.0308, 'lps'),
	(663842, 136, '2015-01-15 00:11:48.000000', 'consum', 0.0353, 'lps'),
	(663843, 136, '2015-01-15 00:11:49.000000', 'consum', 0.0338, 'lps'),
	(663844, 136, '2015-01-15 00:11:50.000000', 'consum', 0.0273, 'lps'),
	(663845, 136, '2015-01-15 00:11:51.000000', 'consum', 0.0290, 'lps'),
	(663846, 136, '2015-01-15 00:11:52.000000', 'consum', 0.0275, 'lps'),
	(663847, 136, '2015-01-15 00:11:53.000000', 'consum', 0.0294, 'lps'),
	(663848, 136, '2015-01-15 00:11:54.000000', 'consum', 0.0291, 'lps'),
	(663849, 136, '2015-01-15 00:11:55.000000', 'consum', 0.0213, 'lps'),
	(663850, 136, '2015-01-15 00:11:56.000000', 'consum', 0.0278, 'lps'),
	(663851, 136, '2015-01-15 00:11:57.000000', 'consum', 0.0247, 'lps'),
	(663852, 136, '2015-01-15 00:11:58.000000', 'consum', 0.0340, 'lps'),
	(663853, 136, '2015-01-15 00:11:59.000000', 'consum', 0.0308, 'lps'),
	(663854, 136, '2015-01-15 00:12:00.000000', 'consum', 0.0311, 'lps'),
	(663855, 136, '2015-01-15 00:12:01.000000', 'consum', 0.0273, 'lps'),
	(663856, 136, '2015-01-15 00:12:02.000000', 'consum', 0.0225, 'lps'),
	(663857, 136, '2015-01-15 00:12:03.000000', 'consum', 0.0243, 'lps'),
	(663858, 136, '2015-01-15 00:12:04.000000', 'consum', 0.0330, 'lps'),
	(663859, 136, '2015-01-15 00:12:05.000000', 'consum', 0.0270, 'lps'),
	(663860, 136, '2015-01-15 00:12:06.000000', 'consum', 0.0297, 'lps'),
	(663861, 136, '2015-01-15 00:12:07.000000', 'consum', 0.0318, 'lps'),
	(663862, 136, '2015-01-15 00:12:08.000000', 'consum', 0.0345, 'lps'),
	(663863, 136, '2015-01-15 00:12:09.000000', 'consum', 0.0266, 'lps'),
	(663864, 136, '2015-01-15 00:12:10.000000', 'consum', 0.0233, 'lps'),
	(663865, 136, '2015-01-15 00:12:11.000000', 'consum', 0.0303, 'lps'),
	(663866, 136, '2015-01-15 00:12:12.000000', 'consum', 0.0313, 'lps'),
	(663867, 136, '2015-01-15 00:12:13.000000', 'consum', 0.0299, 'lps'),
	(663868, 136, '2015-01-15 00:12:14.000000', 'consum', 0.0347, 'lps'),
	(663869, 136, '2015-01-15 00:12:15.000000', 'consum', 0.0334, 'lps'),
	(663870, 136, '2015-01-15 00:12:16.000000', 'consum', 0.0274, 'lps'),
	(663871, 136, '2015-01-15 00:12:17.000000', 'consum', 0.0303, 'lps'),
	(663872, 136, '2015-01-15 00:12:18.000000', 'consum', 0.0337, 'lps'),
	(663873, 136, '2015-01-15 00:12:19.000000', 'consum', 0.0274, 'lps'),
	(663874, 136, '2015-01-15 00:12:20.000000', 'consum', 0.0295, 'lps'),
	(663875, 136, '2015-01-15 00:12:21.000000', 'consum', 0.0298, 'lps'),
	(663876, 136, '2015-01-15 00:12:22.000000', 'consum', 0.0248, 'lps'),
	(663877, 136, '2015-01-15 00:12:23.000000', 'consum', 0.0283, 'lps'),
	(663878, 136, '2015-01-15 00:12:24.000000', 'consum', 0.0315, 'lps'),
	(663879, 136, '2015-01-15 00:12:25.000000', 'consum', 0.0222, 'lps'),
	(663880, 136, '2015-01-15 00:12:26.000000', 'consum', 0.0250, 'lps'),
	(663881, 136, '2015-01-15 00:12:27.000000', 'consum', 0.0228, 'lps'),
	(663882, 136, '2015-01-15 00:12:28.000000', 'consum', 0.0328, 'lps'),
	(663883, 136, '2015-01-15 00:12:29.000000', 'consum', 0.0306, 'lps'),
	(663884, 136, '2015-01-15 00:12:30.000000', 'consum', 0.0335, 'lps'),
	(663885, 136, '2015-01-15 00:12:31.000000', 'consum', 0.0254, 'lps'),
	(663886, 136, '2015-01-15 00:12:32.000000', 'consum', 0.0348, 'lps'),
	(663887, 136, '2015-01-15 00:12:33.000000', 'consum', 0.0328, 'lps'),
	(663888, 136, '2015-01-15 00:12:34.000000', 'consum', 0.0241, 'lps'),
	(663889, 136, '2015-01-15 00:12:35.000000', 'consum', 0.0305, 'lps'),
	(663890, 136, '2015-01-15 00:12:36.000000', 'consum', 0.0298, 'lps'),
	(663891, 136, '2015-01-15 00:12:37.000000', 'consum', 0.0217, 'lps'),
	(663892, 136, '2015-01-15 00:12:38.000000', 'consum', 0.0278, 'lps'),
	(663893, 136, '2015-01-15 00:12:39.000000', 'consum', 0.0235, 'lps'),
	(663894, 136, '2015-01-15 00:12:40.000000', 'consum', 0.0279, 'lps'),
	(663895, 136, '2015-01-15 00:12:41.000000', 'consum', 0.0332, 'lps'),
	(663896, 136, '2015-01-15 00:12:42.000000', 'consum', 0.0319, 'lps'),
	(663897, 136, '2015-01-15 00:12:43.000000', 'consum', 0.0244, 'lps'),
	(663898, 136, '2015-01-15 00:12:44.000000', 'consum', 0.0345, 'lps'),
	(663899, 136, '2015-01-15 00:12:45.000000', 'consum', 0.0345, 'lps'),
	(663900, 136, '2015-01-15 00:12:46.000000', 'consum', 0.0332, 'lps'),
	(663901, 136, '2015-01-15 00:12:47.000000', 'consum', 0.0267, 'lps'),
	(663902, 136, '2015-01-15 00:12:48.000000', 'consum', 0.0279, 'lps'),
	(663903, 136, '2015-01-15 00:12:49.000000', 'consum', 0.0239, 'lps'),
	(663904, 136, '2015-01-15 00:12:50.000000', 'consum', 0.0293, 'lps'),
	(663905, 136, '2015-01-15 00:12:51.000000', 'consum', 0.0243, 'lps'),
	(663906, 136, '2015-01-15 00:12:52.000000', 'consum', 0.0277, 'lps'),
	(663907, 136, '2015-01-15 00:12:53.000000', 'consum', 0.0297, 'lps'),
	(663908, 136, '2015-01-15 00:12:54.000000', 'consum', 0.0298, 'lps'),
	(663909, 136, '2015-01-15 00:12:55.000000', 'consum', 0.0243, 'lps'),
	(663910, 136, '2015-01-15 00:12:56.000000', 'consum', 0.0260, 'lps'),
	(663911, 136, '2015-01-15 00:12:57.000000', 'consum', 0.0214, 'lps'),
	(663912, 136, '2015-01-15 00:12:58.000000', 'consum', 0.0229, 'lps'),
	(663913, 136, '2015-01-15 00:12:59.000000', 'consum', 0.0290, 'lps'),
	(663914, 136, '2015-01-15 00:13:00.000000', 'consum', 0.0261, 'lps'),
	(663915, 136, '2015-01-15 00:13:01.000000', 'consum', 0.0225, 'lps'),
	(663916, 136, '2015-01-15 00:13:02.000000', 'consum', 0.0279, 'lps'),
	(663917, 136, '2015-01-15 00:13:03.000000', 'consum', 0.0217, 'lps'),
	(663918, 136, '2015-01-15 00:13:04.000000', 'consum', 0.0335, 'lps'),
	(663919, 136, '2015-01-15 00:13:05.000000', 'consum', 0.0223, 'lps'),
	(663920, 136, '2015-01-15 00:13:06.000000', 'consum', 0.0344, 'lps'),
	(663921, 136, '2015-01-15 00:13:07.000000', 'consum', 0.0254, 'lps'),
	(663922, 136, '2015-01-15 00:13:08.000000', 'consum', 0.0323, 'lps'),
	(663923, 136, '2015-01-15 00:13:09.000000', 'consum', 0.0347, 'lps'),
	(663924, 136, '2015-01-15 00:13:10.000000', 'consum', 0.0264, 'lps'),
	(663925, 136, '2015-01-15 00:13:11.000000', 'consum', 0.0216, 'lps'),
	(663926, 136, '2015-01-15 00:13:12.000000', 'consum', 0.0225, 'lps'),
	(663927, 136, '2015-01-15 00:13:13.000000', 'consum', 0.0269, 'lps'),
	(663928, 136, '2015-01-15 00:13:14.000000', 'consum', 0.0313, 'lps'),
	(663929, 136, '2015-01-15 00:13:15.000000', 'consum', 0.0254, 'lps'),
	(663930, 136, '2015-01-15 00:13:16.000000', 'consum', 0.0270, 'lps'),
	(663931, 136, '2015-01-15 00:13:17.000000', 'consum', 0.0232, 'lps'),
	(663932, 136, '2015-01-15 00:13:18.000000', 'consum', 0.0285, 'lps'),
	(663933, 136, '2015-01-15 00:13:19.000000', 'consum', 0.0225, 'lps'),
	(663934, 136, '2015-01-15 00:13:20.000000', 'consum', 0.0210, 'lps'),
	(663935, 136, '2015-01-15 00:13:21.000000', 'consum', 0.0311, 'lps'),
	(663936, 136, '2015-01-15 00:13:22.000000', 'consum', 0.0273, 'lps'),
	(663937, 136, '2015-01-15 00:13:23.000000', 'consum', 0.0223, 'lps'),
	(663938, 136, '2015-01-15 00:13:24.000000', 'consum', 0.0234, 'lps'),
	(663939, 136, '2015-01-15 00:13:25.000000', 'consum', 0.0293, 'lps'),
	(663940, 136, '2015-01-15 00:13:26.000000', 'consum', 0.0259, 'lps'),
	(663941, 136, '2015-01-15 00:13:27.000000', 'consum', 0.0354, 'lps'),
	(663942, 136, '2015-01-15 00:13:28.000000', 'consum', 0.0340, 'lps'),
	(663943, 136, '2015-01-15 00:13:29.000000', 'consum', 0.0283, 'lps'),
	(663944, 136, '2015-01-15 00:13:30.000000', 'consum', 0.0330, 'lps'),
	(663945, 136, '2015-01-15 00:13:31.000000', 'consum', 0.0301, 'lps'),
	(663946, 136, '2015-01-15 00:13:32.000000', 'consum', 0.0302, 'lps'),
	(663947, 136, '2015-01-15 00:13:33.000000', 'consum', 0.0252, 'lps'),
	(663948, 136, '2015-01-15 00:13:34.000000', 'consum', 0.0293, 'lps'),
	(663949, 136, '2015-01-15 00:13:35.000000', 'consum', 0.0352, 'lps'),
	(663950, 136, '2015-01-15 00:13:36.000000', 'consum', 0.0231, 'lps'),
	(663951, 136, '2015-01-15 00:13:37.000000', 'consum', 0.0331, 'lps'),
	(663952, 136, '2015-01-15 00:13:38.000000', 'consum', 0.0310, 'lps'),
	(663953, 136, '2015-01-15 00:13:39.000000', 'consum', 0.0350, 'lps'),
	(663954, 136, '2015-01-15 00:13:40.000000', 'consum', 0.0314, 'lps'),
	(663955, 136, '2015-01-15 00:13:41.000000', 'consum', 0.0309, 'lps'),
	(663956, 136, '2015-01-15 00:13:42.000000', 'consum', 0.0249, 'lps'),
	(663957, 136, '2015-01-15 00:13:43.000000', 'consum', 0.0255, 'lps'),
	(663958, 136, '2015-01-15 00:13:44.000000', 'consum', 0.0319, 'lps'),
	(663959, 136, '2015-01-15 00:13:45.000000', 'consum', 0.0325, 'lps'),
	(663960, 136, '2015-01-15 00:13:46.000000', 'consum', 0.0310, 'lps'),
	(663961, 136, '2015-01-15 00:13:47.000000', 'consum', 0.0221, 'lps'),
	(663962, 136, '2015-01-15 00:13:48.000000', 'consum', 0.0258, 'lps'),
	(663963, 136, '2015-01-15 00:13:49.000000', 'consum', 0.0272, 'lps'),
	(663964, 136, '2015-01-15 00:13:50.000000', 'consum', 0.0228, 'lps'),
	(663965, 136, '2015-01-15 00:13:51.000000', 'consum', 0.0261, 'lps'),
	(663966, 136, '2015-01-15 00:13:52.000000', 'consum', 0.0265, 'lps'),
	(663967, 136, '2015-01-15 00:13:53.000000', 'consum', 0.0332, 'lps'),
	(663968, 136, '2015-01-15 00:13:54.000000', 'consum', 0.0213, 'lps'),
	(663969, 136, '2015-01-15 00:13:55.000000', 'consum', 0.0303, 'lps'),
	(663970, 136, '2015-01-15 00:13:56.000000', 'consum', 0.0224, 'lps'),
	(663971, 136, '2015-01-15 00:13:57.000000', 'consum', 0.0297, 'lps'),
	(663972, 136, '2015-01-15 00:13:58.000000', 'consum', 0.0310, 'lps'),
	(663973, 136, '2015-01-15 00:13:59.000000', 'consum', 0.0301, 'lps'),
	(663974, 136, '2015-01-15 00:14:00.000000', 'consum', 0.0218, 'lps'),
	(663975, 136, '2015-01-15 00:14:01.000000', 'consum', 0.0273, 'lps'),
	(663976, 136, '2015-01-15 00:14:02.000000', 'consum', 0.0355, 'lps'),
	(663977, 136, '2015-01-15 00:14:03.000000', 'consum', 0.0304, 'lps'),
	(663978, 136, '2015-01-15 00:14:04.000000', 'consum', 0.0247, 'lps'),
	(663979, 136, '2015-01-15 00:14:05.000000', 'consum', 0.0261, 'lps'),
	(663980, 136, '2015-01-15 00:14:06.000000', 'consum', 0.0352, 'lps'),
	(663981, 136, '2015-01-15 00:14:07.000000', 'consum', 0.0328, 'lps'),
	(663982, 136, '2015-01-15 00:14:08.000000', 'consum', 0.0226, 'lps'),
	(663983, 136, '2015-01-15 00:14:09.000000', 'consum', 0.0231, 'lps'),
	(663984, 136, '2015-01-15 00:14:10.000000', 'consum', 0.0268, 'lps'),
	(663985, 136, '2015-01-15 00:14:11.000000', 'consum', 0.0289, 'lps'),
	(663986, 136, '2015-01-15 00:14:12.000000', 'consum', 0.0283, 'lps'),
	(663987, 136, '2015-01-15 00:14:13.000000', 'consum', 0.0342, 'lps'),
	(663988, 136, '2015-01-15 00:14:14.000000', 'consum', 0.0211, 'lps'),
	(663989, 136, '2015-01-15 00:14:15.000000', 'consum', 0.0257, 'lps'),
	(663990, 136, '2015-01-15 00:14:16.000000', 'consum', 0.0299, 'lps'),
	(663991, 136, '2015-01-15 00:14:17.000000', 'consum', 0.0218, 'lps'),
	(663992, 136, '2015-01-15 00:14:18.000000', 'consum', 0.0278, 'lps'),
	(663993, 136, '2015-01-15 00:14:19.000000', 'consum', 0.0232, 'lps'),
	(663994, 136, '2015-01-15 00:14:20.000000', 'consum', 0.0265, 'lps'),
	(663995, 136, '2015-01-15 00:14:21.000000', 'consum', 0.0272, 'lps'),
	(663996, 136, '2015-01-15 00:14:22.000000', 'consum', 0.0354, 'lps'),
	(663997, 136, '2015-01-15 00:14:23.000000', 'consum', 0.0303, 'lps'),
	(663998, 136, '2015-01-15 00:14:24.000000', 'consum', 0.0246, 'lps'),
	(663999, 136, '2015-01-15 00:14:25.000000', 'consum', 0.0256, 'lps'),
	(664000, 136, '2015-01-15 00:14:26.000000', 'consum', 0.0334, 'lps'),
	(664001, 136, '2015-01-15 00:14:27.000000', 'consum', 0.0253, 'lps'),
	(664002, 136, '2015-01-15 00:14:28.000000', 'consum', 0.0347, 'lps'),
	(664003, 136, '2015-01-15 00:14:29.000000', 'consum', 0.0325, 'lps'),
	(664004, 136, '2015-01-15 00:14:30.000000', 'consum', 0.0229, 'lps'),
	(664005, 136, '2015-01-15 00:14:31.000000', 'consum', 0.0255, 'lps'),
	(664006, 136, '2015-01-15 00:14:32.000000', 'consum', 0.0232, 'lps'),
	(664007, 136, '2015-01-15 00:14:33.000000', 'consum', 0.0331, 'lps'),
	(664008, 136, '2015-01-15 00:14:34.000000', 'consum', 0.0311, 'lps'),
	(664009, 136, '2015-01-15 00:14:35.000000', 'consum', 0.0350, 'lps'),
	(664010, 136, '2015-01-15 00:14:36.000000', 'consum', 0.0314, 'lps'),
	(664011, 136, '2015-01-15 00:14:37.000000', 'consum', 0.0312, 'lps'),
	(664012, 136, '2015-01-15 00:14:38.000000', 'consum', 0.0262, 'lps'),
	(664013, 136, '2015-01-15 00:14:39.000000', 'consum', 0.0312, 'lps'),
	(664014, 136, '2015-01-15 00:14:40.000000', 'consum', 0.0269, 'lps'),
	(664015, 136, '2015-01-15 00:14:41.000000', 'consum', 0.0346, 'lps'),
	(664016, 136, '2015-01-15 00:14:42.000000', 'consum', 0.0274, 'lps'),
	(664017, 136, '2015-01-15 00:14:43.000000', 'consum', 0.0269, 'lps'),
	(664018, 136, '2015-01-15 00:14:44.000000', 'consum', 0.0312, 'lps'),
	(664019, 136, '2015-01-15 00:14:45.000000', 'consum', 0.0251, 'lps'),
	(664020, 136, '2015-01-15 00:14:46.000000', 'consum', 0.0256, 'lps'),
	(664021, 136, '2015-01-15 00:14:47.000000', 'consum', 0.0318, 'lps'),
	(664022, 136, '2015-01-15 00:14:48.000000', 'consum', 0.0318, 'lps'),
	(664023, 136, '2015-01-15 00:14:49.000000', 'consum', 0.0279, 'lps'),
	(664024, 136, '2015-01-15 00:14:50.000000', 'consum', 0.0231, 'lps'),
	(664025, 136, '2015-01-15 00:14:51.000000', 'consum', 0.0257, 'lps'),
	(664026, 136, '2015-01-15 00:14:52.000000', 'consum', 0.0233, 'lps'),
	(664027, 136, '2015-01-15 00:14:53.000000', 'consum', 0.0335, 'lps'),
	(664028, 136, '2015-01-15 00:14:54.000000', 'consum', 0.0323, 'lps'),
	(664029, 136, '2015-01-15 00:14:55.000000', 'consum', 0.0254, 'lps'),
	(664030, 136, '2015-01-15 00:14:56.000000', 'consum', 0.0238, 'lps'),
	(664031, 136, '2015-01-15 00:14:57.000000', 'consum', 0.0219, 'lps'),
	(664032, 136, '2015-01-15 00:14:58.000000', 'consum', 0.0320, 'lps'),
	(664033, 136, '2015-01-15 00:14:59.000000', 'consum', 0.0290, 'lps'),
	(664034, 136, '2015-01-15 00:15:00.000000', 'consum', 0.0282, 'lps'),
	(664035, 136, '2015-01-15 00:15:01.000000', 'consum', 0.0330, 'lps'),
	(664036, 136, '2015-01-15 00:15:02.000000', 'consum', 0.0299, 'lps'),
	(664037, 136, '2015-01-15 00:15:03.000000', 'consum', 0.0296, 'lps'),
	(664038, 136, '2015-01-15 00:15:04.000000', 'consum', 0.0227, 'lps'),
	(664039, 136, '2015-01-15 00:15:05.000000', 'consum', 0.0332, 'lps'),
	(664040, 136, '2015-01-15 00:15:06.000000', 'consum', 0.0330, 'lps'),
	(664041, 136, '2015-01-15 00:15:07.000000', 'consum', 0.0296, 'lps'),
	(664042, 136, '2015-01-15 00:15:08.000000', 'consum', 0.0281, 'lps'),
	(664043, 136, '2015-01-15 00:15:09.000000', 'consum', 0.0309, 'lps'),
	(664044, 136, '2015-01-15 00:15:10.000000', 'consum', 0.0343, 'lps'),
	(664045, 136, '2015-01-15 00:15:11.000000', 'consum', 0.0285, 'lps'),
	(664046, 136, '2015-01-15 00:15:12.000000', 'consum', 0.0334, 'lps'),
	(664047, 136, '2015-01-15 00:15:13.000000', 'consum', 0.0310, 'lps'),
	(664048, 136, '2015-01-15 00:15:14.000000', 'consum', 0.0340, 'lps'),
	(664049, 136, '2015-01-15 00:15:15.000000', 'consum', 0.0266, 'lps'),
	(664050, 136, '2015-01-15 00:15:16.000000', 'consum', 0.0246, 'lps'),
	(664051, 136, '2015-01-15 00:15:17.000000', 'consum', 0.0223, 'lps'),
	(664052, 136, '2015-01-15 00:15:18.000000', 'consum', 0.0313, 'lps'),
	(664053, 136, '2015-01-15 00:15:19.000000', 'consum', 0.0248, 'lps'),
	(664054, 136, '2015-01-15 00:15:20.000000', 'consum', 0.0240, 'lps'),
	(664055, 136, '2015-01-15 00:15:21.000000', 'consum', 0.0243, 'lps'),
	(664056, 136, '2015-01-15 00:15:22.000000', 'consum', 0.0288, 'lps'),
	(664057, 136, '2015-01-15 00:15:23.000000', 'consum', 0.0355, 'lps'),
	(664058, 136, '2015-01-15 00:15:24.000000', 'consum', 0.0261, 'lps'),
	(664059, 136, '2015-01-15 00:15:25.000000', 'consum', 0.0322, 'lps'),
	(664060, 136, '2015-01-15 00:15:26.000000', 'consum', 0.0324, 'lps'),
	(664061, 136, '2015-01-15 00:15:27.000000', 'consum', 0.0299, 'lps'),
	(664062, 136, '2015-01-15 00:15:28.000000', 'consum', 0.0314, 'lps'),
	(664063, 136, '2015-01-15 00:15:29.000000', 'consum', 0.0315, 'lps'),
	(664064, 136, '2015-01-15 00:15:30.000000', 'consum', 0.0275, 'lps'),
	(664065, 136, '2015-01-15 00:15:31.000000', 'consum', 0.0223, 'lps'),
	(664066, 136, '2015-01-15 00:15:32.000000', 'consum', 0.0228, 'lps'),
	(664067, 136, '2015-01-15 00:15:33.000000', 'consum', 0.0259, 'lps'),
	(664068, 136, '2015-01-15 00:15:34.000000', 'consum', 0.0254, 'lps'),
	(664069, 136, '2015-01-15 00:15:35.000000', 'consum', 0.0285, 'lps'),
	(664070, 136, '2015-01-15 00:15:36.000000', 'consum', 0.0304, 'lps'),
	(664071, 136, '2015-01-15 00:15:37.000000', 'consum', 0.0311, 'lps'),
	(664072, 136, '2015-01-15 00:15:38.000000', 'consum', 0.0287, 'lps'),
	(664073, 136, '2015-01-15 00:15:39.000000', 'consum', 0.0291, 'lps'),
	(664074, 136, '2015-01-15 00:15:40.000000', 'consum', 0.0237, 'lps'),
	(664075, 136, '2015-01-15 00:15:41.000000', 'consum', 0.0250, 'lps'),
	(664076, 136, '2015-01-15 00:15:42.000000', 'consum', 0.0329, 'lps'),
	(664077, 136, '2015-01-15 00:15:43.000000', 'consum', 0.0245, 'lps'),
	(664078, 136, '2015-01-15 00:15:44.000000', 'consum', 0.0321, 'lps'),
	(664079, 136, '2015-01-15 00:15:45.000000', 'consum', 0.0221, 'lps'),
	(664080, 136, '2015-01-15 00:15:46.000000', 'consum', 0.0226, 'lps'),
	(664081, 136, '2015-01-15 00:15:47.000000', 'consum', 0.0258, 'lps'),
	(664082, 136, '2015-01-15 00:15:48.000000', 'consum', 0.0253, 'lps'),
	(664083, 136, '2015-01-15 00:15:49.000000', 'consum', 0.0284, 'lps'),
	(664084, 136, '2015-01-15 00:15:50.000000', 'consum', 0.0305, 'lps'),
	(664085, 136, '2015-01-15 00:15:51.000000', 'consum', 0.0314, 'lps'),
	(664086, 136, '2015-01-15 00:15:52.000000', 'consum', 0.0300, 'lps'),
	(664087, 136, '2015-01-15 00:15:53.000000', 'consum', 0.0349, 'lps'),
	(664088, 136, '2015-01-15 00:15:54.000000', 'consum', 0.0340, 'lps'),
	(664089, 136, '2015-01-15 00:15:55.000000', 'consum', 0.0297, 'lps'),
	(664090, 136, '2015-01-15 00:15:56.000000', 'consum', 0.0258, 'lps'),
	(664091, 136, '2015-01-15 00:15:57.000000', 'consum', 0.0334, 'lps'),
	(664092, 136, '2015-01-15 00:15:58.000000', 'consum', 0.0246, 'lps'),
	(664093, 136, '2015-01-15 00:15:59.000000', 'consum', 0.0311, 'lps'),
	(664094, 136, '2015-01-15 00:16:00.000000', 'consum', 0.0315, 'lps'),
	(664095, 136, '2015-01-15 00:16:01.000000', 'consum', 0.0284, 'lps'),
	(664096, 136, '2015-01-15 00:16:02.000000', 'consum', 0.0266, 'lps'),
	(664097, 136, '2015-01-15 00:16:03.000000', 'consum', 0.0270, 'lps'),
	(664098, 136, '2015-01-15 00:16:04.000000', 'consum', 0.0340, 'lps'),
	(664099, 136, '2015-01-15 00:16:05.000000', 'consum', 0.0240, 'lps'),
	(664100, 136, '2015-01-15 00:16:06.000000', 'consum', 0.0267, 'lps'),
	(664101, 136, '2015-01-15 00:16:07.000000', 'consum', 0.0256, 'lps'),
	(664102, 136, '2015-01-15 00:16:08.000000', 'consum', 0.0271, 'lps'),
	(664103, 136, '2015-01-15 00:16:09.000000', 'consum', 0.0230, 'lps'),
	(664104, 136, '2015-01-15 00:16:10.000000', 'consum', 0.0273, 'lps'),
	(664105, 136, '2015-01-15 00:16:11.000000', 'consum', 0.0322, 'lps'),
	(664106, 136, '2015-01-15 00:16:12.000000', 'consum', 0.0284, 'lps'),
	(664107, 136, '2015-01-15 00:16:13.000000', 'consum', 0.0246, 'lps'),
	(664108, 136, '2015-01-15 00:16:14.000000', 'consum', 0.0317, 'lps'),
	(664109, 136, '2015-01-15 00:16:15.000000', 'consum', 0.0341, 'lps'),
	(664110, 136, '2015-01-15 00:16:16.000000', 'consum', 0.0250, 'lps'),
	(664111, 136, '2015-01-15 00:16:17.000000', 'consum', 0.0314, 'lps'),
	(664112, 136, '2015-01-15 00:16:18.000000', 'consum', 0.0317, 'lps'),
	(664113, 136, '2015-01-15 00:16:19.000000', 'consum', 0.0287, 'lps'),
	(664114, 136, '2015-01-15 00:16:20.000000', 'consum', 0.0275, 'lps'),
	(664115, 136, '2015-01-15 00:16:21.000000', 'consum', 0.0302, 'lps'),
	(664116, 136, '2015-01-15 00:16:22.000000', 'consum', 0.0331, 'lps'),
	(664117, 136, '2015-01-15 00:16:23.000000', 'consum', 0.0243, 'lps'),
	(664118, 136, '2015-01-15 00:16:24.000000', 'consum', 0.0309, 'lps'),
	(664119, 136, '2015-01-15 00:16:25.000000', 'consum', 0.0310, 'lps'),
	(664120, 136, '2015-01-15 00:16:26.000000', 'consum', 0.0268, 'lps'),
	(664121, 136, '2015-01-15 00:16:27.000000', 'consum', 0.0345, 'lps'),
	(664122, 136, '2015-01-15 00:16:28.000000', 'consum', 0.0273, 'lps'),
	(664123, 136, '2015-01-15 00:16:29.000000', 'consum', 0.0267, 'lps'),
	(664124, 136, '2015-01-15 00:16:30.000000', 'consum', 0.0304, 'lps'),
	(664125, 136, '2015-01-15 00:16:31.000000', 'consum', 0.0218, 'lps'),
	(664126, 136, '2015-01-15 00:16:32.000000', 'consum', 0.0264, 'lps'),
	(664127, 136, '2015-01-15 00:16:33.000000', 'consum', 0.0308, 'lps'),
	(664128, 136, '2015-01-15 00:16:34.000000', 'consum', 0.0244, 'lps'),
	(664129, 136, '2015-01-15 00:16:35.000000', 'consum', 0.0234, 'lps'),
	(664130, 136, '2015-01-15 00:16:36.000000', 'consum', 0.0230, 'lps'),
	(664131, 136, '2015-01-15 00:16:37.000000', 'consum', 0.0236, 'lps'),
	(664132, 136, '2015-01-15 00:16:38.000000', 'consum', 0.0280, 'lps'),
	(664133, 136, '2015-01-15 00:16:39.000000', 'consum', 0.0337, 'lps'),
	(664134, 136, '2015-01-15 00:16:40.000000', 'consum', 0.0339, 'lps'),
	(664135, 136, '2015-01-15 00:16:41.000000', 'consum', 0.0330, 'lps'),
	(664136, 136, '2015-01-15 00:16:42.000000', 'consum', 0.0278, 'lps'),
	(664137, 136, '2015-01-15 00:16:43.000000', 'consum', 0.0335, 'lps'),
	(664138, 136, '2015-01-15 00:16:44.000000', 'consum', 0.0340, 'lps'),
	(664139, 136, '2015-01-15 00:16:45.000000', 'consum', 0.0338, 'lps'),
	(664140, 136, '2015-01-15 00:16:46.000000', 'consum', 0.0314, 'lps'),
	(664141, 136, '2015-01-15 00:16:47.000000', 'consum', 0.0347, 'lps'),
	(664142, 136, '2015-01-15 00:16:48.000000', 'consum', 0.0289, 'lps'),
	(664143, 136, '2015-01-15 00:16:49.000000', 'consum', 0.0343, 'lps'),
	(664144, 136, '2015-01-15 00:16:50.000000', 'consum', 0.0342, 'lps'),
	(664145, 136, '2015-01-15 00:16:51.000000', 'consum', 0.0325, 'lps'),
	(664146, 136, '2015-01-15 00:16:52.000000', 'consum', 0.0242, 'lps'),
	(664147, 136, '2015-01-15 00:16:53.000000', 'consum', 0.0321, 'lps'),
	(664148, 136, '2015-01-15 00:16:54.000000', 'consum', 0.0228, 'lps'),
	(664149, 136, '2015-01-15 00:16:55.000000', 'consum', 0.0263, 'lps'),
	(664150, 136, '2015-01-15 00:16:56.000000', 'consum', 0.0273, 'lps'),
	(664151, 136, '2015-01-15 00:16:57.000000', 'consum', 0.0221, 'lps'),
	(664152, 136, '2015-01-15 00:16:58.000000', 'consum', 0.0224, 'lps'),
	(664153, 136, '2015-01-15 00:16:59.000000', 'consum', 0.0246, 'lps'),
	(664154, 136, '2015-01-15 00:17:00.000000', 'consum', 0.0350, 'lps'),
	(664155, 136, '2015-01-15 00:17:01.000000', 'consum', 0.0214, 'lps'),
	(664156, 136, '2015-01-15 00:17:02.000000', 'consum', 0.0249, 'lps'),
	(664157, 136, '2015-01-15 00:17:03.000000', 'consum', 0.0249, 'lps'),
	(664158, 136, '2015-01-15 00:17:04.000000', 'consum', 0.0289, 'lps'),
	(664159, 136, '2015-01-15 00:17:05.000000', 'consum', 0.0341, 'lps'),
	(664160, 136, '2015-01-15 00:17:06.000000', 'consum', 0.0332, 'lps'),
	(664161, 136, '2015-01-15 00:17:07.000000', 'consum', 0.0283, 'lps'),
	(664162, 136, '2015-01-15 00:17:08.000000', 'consum', 0.0355, 'lps'),
	(664163, 136, '2015-01-15 00:17:09.000000', 'consum', 0.0276, 'lps'),
	(664164, 136, '2015-01-15 00:17:10.000000', 'consum', 0.0254, 'lps'),
	(664165, 136, '2015-01-15 00:17:11.000000', 'consum', 0.0233, 'lps'),
	(664166, 136, '2015-01-15 00:17:12.000000', 'consum', 0.0342, 'lps'),
	(664167, 136, '2015-01-15 00:17:13.000000', 'consum', 0.0210, 'lps'),
	(664168, 136, '2015-01-15 00:17:14.000000', 'consum', 0.0257, 'lps'),
	(664169, 136, '2015-01-15 00:17:15.000000', 'consum', 0.0296, 'lps'),
	(664170, 136, '2015-01-15 00:17:16.000000', 'consum', 0.0355, 'lps'),
	(664171, 136, '2015-01-15 00:17:17.000000', 'consum', 0.0236, 'lps'),
	(664172, 136, '2015-01-15 00:17:18.000000', 'consum', 0.0345, 'lps'),
	(664173, 136, '2015-01-15 00:17:19.000000', 'consum', 0.0221, 'lps'),
	(664174, 136, '2015-01-15 00:17:20.000000', 'consum', 0.0301, 'lps'),
	(664175, 136, '2015-01-15 00:17:21.000000', 'consum', 0.0339, 'lps'),
	(664176, 136, '2015-01-15 00:17:22.000000', 'consum', 0.0289, 'lps'),
	(664177, 136, '2015-01-15 00:17:23.000000', 'consum', 0.0217, 'lps'),
	(664178, 136, '2015-01-15 00:17:24.000000', 'consum', 0.0304, 'lps'),
	(664179, 136, '2015-01-15 00:17:25.000000', 'consum', 0.0219, 'lps'),
	(664180, 136, '2015-01-15 00:17:26.000000', 'consum', 0.0268, 'lps'),
	(664181, 136, '2015-01-15 00:17:27.000000', 'consum', 0.0328, 'lps'),
	(664182, 136, '2015-01-15 00:17:28.000000', 'consum', 0.0329, 'lps'),
	(664183, 136, '2015-01-15 00:17:29.000000', 'consum', 0.0307, 'lps'),
	(664184, 136, '2015-01-15 00:17:30.000000', 'consum', 0.0336, 'lps'),
	(664185, 136, '2015-01-15 00:17:31.000000', 'consum', 0.0255, 'lps'),
	(664186, 136, '2015-01-15 00:17:32.000000', 'consum', 0.0352, 'lps'),
	(664187, 136, '2015-01-15 00:17:33.000000', 'consum', 0.0347, 'lps'),
	(664188, 136, '2015-01-15 00:17:34.000000', 'consum', 0.0321, 'lps'),
	(664189, 136, '2015-01-15 00:17:35.000000', 'consum', 0.0353, 'lps'),
	(664190, 136, '2015-01-15 00:17:36.000000', 'consum', 0.0298, 'lps'),
	(664191, 136, '2015-01-15 00:17:37.000000', 'consum', 0.0223, 'lps'),
	(664192, 136, '2015-01-15 00:17:38.000000', 'consum', 0.0307, 'lps'),
	(664193, 136, '2015-01-15 00:17:39.000000', 'consum', 0.0215, 'lps'),
	(664194, 136, '2015-01-15 00:17:40.000000', 'consum', 0.0237, 'lps'),
	(664195, 136, '2015-01-15 00:17:41.000000', 'consum', 0.0330, 'lps'),
	(664196, 136, '2015-01-15 00:17:42.000000', 'consum', 0.0290, 'lps'),
	(664197, 136, '2015-01-15 00:17:43.000000', 'consum', 0.0250, 'lps'),
	(664198, 136, '2015-01-15 00:17:44.000000', 'consum', 0.0316, 'lps'),
	(664199, 136, '2015-01-15 00:17:45.000000', 'consum', 0.0330, 'lps'),
	(664200, 136, '2015-01-15 00:17:46.000000', 'consum', 0.0342, 'lps'),
	(664201, 136, '2015-01-15 00:17:47.000000', 'consum', 0.0218, 'lps'),
	(664202, 136, '2015-01-15 00:17:48.000000', 'consum', 0.0294, 'lps'),
	(664203, 136, '2015-01-15 00:17:49.000000', 'consum', 0.0315, 'lps'),
	(664204, 136, '2015-01-15 00:17:50.000000', 'consum', 0.0336, 'lps'),
	(664205, 136, '2015-01-15 00:17:51.000000', 'consum', 0.0232, 'lps'),
	(664206, 136, '2015-01-15 00:17:52.000000', 'consum', 0.0235, 'lps'),
	(664207, 136, '2015-01-15 00:17:53.000000', 'consum', 0.0271, 'lps'),
	(664208, 136, '2015-01-15 00:17:54.000000', 'consum', 0.0294, 'lps'),
	(664209, 136, '2015-01-15 00:17:55.000000', 'consum', 0.0299, 'lps'),
	(664210, 136, '2015-01-15 00:17:56.000000', 'consum', 0.0259, 'lps'),
	(664211, 136, '2015-01-15 00:17:57.000000', 'consum', 0.0333, 'lps'),
	(664212, 136, '2015-01-15 00:17:58.000000', 'consum', 0.0237, 'lps'),
	(664213, 136, '2015-01-15 00:17:59.000000', 'consum', 0.0272, 'lps'),
	(664214, 136, '2015-01-15 00:18:00.000000', 'consum', 0.0291, 'lps'),
	(664215, 136, '2015-01-15 00:18:01.000000', 'consum', 0.0285, 'lps'),
	(664216, 136, '2015-01-15 00:18:02.000000', 'consum', 0.0341, 'lps'),
	(664217, 136, '2015-01-15 00:18:03.000000', 'consum', 0.0346, 'lps'),
	(664218, 136, '2015-01-15 00:18:04.000000', 'consum', 0.0349, 'lps'),
	(664219, 136, '2015-01-15 00:18:05.000000', 'consum', 0.0352, 'lps'),
	(664220, 136, '2015-01-15 00:18:06.000000', 'consum', 0.0354, 'lps'),
	(664221, 136, '2015-01-15 00:18:07.000000', 'consum', 0.0214, 'lps'),
	(664222, 136, '2015-01-15 00:18:08.000000', 'consum', 0.0237, 'lps'),
	(664223, 136, '2015-01-15 00:18:09.000000', 'consum', 0.0335, 'lps'),
	(664224, 136, '2015-01-15 00:18:10.000000', 'consum', 0.0311, 'lps'),
	(664225, 136, '2015-01-15 00:18:11.000000', 'consum', 0.0342, 'lps'),
	(664226, 136, '2015-01-15 00:18:12.000000', 'consum', 0.0273, 'lps'),
	(664227, 136, '2015-01-15 00:18:13.000000', 'consum', 0.0276, 'lps'),
	(664228, 136, '2015-01-15 00:18:14.000000', 'consum', 0.0350, 'lps'),
	(664229, 136, '2015-01-15 00:18:15.000000', 'consum', 0.0273, 'lps'),
	(664230, 136, '2015-01-15 00:18:16.000000', 'consum', 0.0251, 'lps'),
	(664231, 136, '2015-01-15 00:18:17.000000', 'consum', 0.0226, 'lps'),
	(664232, 136, '2015-01-15 00:18:18.000000', 'consum', 0.0317, 'lps'),
	(664233, 136, '2015-01-15 00:18:19.000000', 'consum', 0.0254, 'lps'),
	(664234, 136, '2015-01-15 00:18:20.000000', 'consum', 0.0259, 'lps'),
	(664235, 136, '2015-01-15 00:18:21.000000', 'consum', 0.0322, 'lps'),
	(664236, 136, '2015-01-15 00:18:22.000000', 'consum', 0.0330, 'lps'),
	(664237, 136, '2015-01-15 00:18:23.000000', 'consum', 0.0328, 'lps'),
	(664238, 136, '2015-01-15 00:18:24.000000', 'consum', 0.0292, 'lps'),
	(664239, 136, '2015-01-15 00:18:25.000000', 'consum', 0.0267, 'lps'),
	(664240, 136, '2015-01-15 00:18:26.000000', 'consum', 0.0250, 'lps'),
	(664241, 136, '2015-01-15 00:18:27.000000', 'consum', 0.0241, 'lps'),
	(664242, 136, '2015-01-15 00:18:28.000000', 'consum', 0.0243, 'lps'),
	(664243, 136, '2015-01-15 00:18:29.000000', 'consum', 0.0284, 'lps'),
	(664244, 136, '2015-01-15 00:18:30.000000', 'consum', 0.0335, 'lps'),
	(664245, 136, '2015-01-15 00:18:31.000000', 'consum', 0.0321, 'lps'),
	(664246, 136, '2015-01-15 00:18:32.000000', 'consum', 0.0241, 'lps'),
	(664247, 136, '2015-01-15 00:18:33.000000', 'consum', 0.0329, 'lps'),
	(664248, 136, '2015-01-15 00:18:34.000000', 'consum', 0.0269, 'lps'),
	(664249, 136, '2015-01-15 00:18:35.000000', 'consum', 0.0298, 'lps'),
	(664250, 136, '2015-01-15 00:18:36.000000', 'consum', 0.0325, 'lps'),
	(664251, 136, '2015-01-15 00:18:37.000000', 'consum', 0.0228, 'lps'),
	(664252, 136, '2015-01-15 00:18:38.000000', 'consum', 0.0247, 'lps'),
	(664253, 136, '2015-01-15 00:18:39.000000', 'consum', 0.0344, 'lps'),
	(664254, 136, '2015-01-15 00:18:40.000000', 'consum', 0.0329, 'lps'),
	(664255, 136, '2015-01-15 00:18:41.000000', 'consum', 0.0257, 'lps'),
	(664256, 136, '2015-01-15 00:18:42.000000', 'consum', 0.0233, 'lps'),
	(664257, 136, '2015-01-15 00:18:43.000000', 'consum', 0.0333, 'lps'),
	(664258, 136, '2015-01-15 00:18:44.000000', 'consum', 0.0316, 'lps'),
	(664259, 136, '2015-01-15 00:18:45.000000', 'consum', 0.0226, 'lps'),
	(664260, 136, '2015-01-15 00:18:46.000000', 'consum', 0.0265, 'lps'),
	(664261, 136, '2015-01-15 00:18:47.000000', 'consum', 0.0291, 'lps'),
	(664262, 136, '2015-01-15 00:18:48.000000', 'consum', 0.0304, 'lps'),
	(664263, 136, '2015-01-15 00:18:49.000000', 'consum', 0.0289, 'lps'),
	(664264, 136, '2015-01-15 00:18:50.000000', 'consum', 0.0326, 'lps'),
	(664265, 136, '2015-01-15 00:18:51.000000', 'consum', 0.0259, 'lps'),
	(664266, 136, '2015-01-15 00:18:52.000000', 'consum', 0.0253, 'lps'),
	(664267, 136, '2015-01-15 00:18:53.000000', 'consum', 0.0281, 'lps'),
	(664268, 136, '2015-01-15 00:18:54.000000', 'consum', 0.0288, 'lps'),
	(664269, 136, '2015-01-15 00:18:55.000000', 'consum', 0.0239, 'lps'),
	(664270, 136, '2015-01-15 00:18:56.000000', 'consum', 0.0271, 'lps'),
	(664271, 136, '2015-01-15 00:18:57.000000', 'consum', 0.0281, 'lps'),
	(664272, 136, '2015-01-15 00:18:58.000000', 'consum', 0.0233, 'lps'),
	(664273, 136, '2015-01-15 00:18:59.000000', 'consum', 0.0263, 'lps'),
	(664274, 136, '2015-01-15 00:19:00.000000', 'consum', 0.0257, 'lps'),
	(664275, 136, '2015-01-15 00:19:01.000000', 'consum', 0.0289, 'lps'),
	(664276, 136, '2015-01-15 00:19:02.000000', 'consum', 0.0315, 'lps'),
	(664277, 136, '2015-01-15 00:19:03.000000', 'consum', 0.0351, 'lps'),
	(664278, 136, '2015-01-15 00:19:04.000000', 'consum', 0.0309, 'lps'),
	(664279, 136, '2015-01-15 00:19:05.000000', 'consum', 0.0280, 'lps'),
	(664280, 136, '2015-01-15 00:19:06.000000', 'consum', 0.0263, 'lps'),
	(664281, 136, '2015-01-15 00:19:07.000000', 'consum', 0.0269, 'lps'),
	(664282, 136, '2015-01-15 00:19:08.000000', 'consum', 0.0343, 'lps'),
	(664283, 136, '2015-01-15 00:19:09.000000', 'consum', 0.0259, 'lps'),
	(664284, 136, '2015-01-15 00:19:10.000000', 'consum', 0.0352, 'lps'),
	(664285, 136, '2015-01-15 00:19:11.000000', 'consum', 0.0331, 'lps'),
	(664286, 136, '2015-01-15 00:19:12.000000', 'consum', 0.0241, 'lps'),
	(664287, 136, '2015-01-15 00:19:13.000000', 'consum', 0.0296, 'lps'),
	(664288, 136, '2015-01-15 00:19:14.000000', 'consum', 0.0256, 'lps'),
	(664289, 136, '2015-01-15 00:19:15.000000', 'consum', 0.0326, 'lps'),
	(664290, 136, '2015-01-15 00:19:16.000000', 'consum', 0.0215, 'lps'),
	(664291, 136, '2015-01-15 00:19:17.000000', 'consum', 0.0328, 'lps'),
	(664292, 136, '2015-01-15 00:19:18.000000', 'consum', 0.0346, 'lps'),
	(664293, 136, '2015-01-15 00:19:19.000000', 'consum', 0.0240, 'lps'),
	(664294, 136, '2015-01-15 00:19:20.000000', 'consum', 0.0248, 'lps'),
	(664295, 136, '2015-01-15 00:19:21.000000', 'consum', 0.0311, 'lps'),
	(664296, 136, '2015-01-15 00:19:22.000000', 'consum', 0.0306, 'lps'),
	(664297, 136, '2015-01-15 00:19:23.000000', 'consum', 0.0241, 'lps'),
	(664298, 136, '2015-01-15 00:19:24.000000', 'consum', 0.0223, 'lps'),
	(664299, 136, '2015-01-15 00:19:25.000000', 'consum', 0.0330, 'lps'),
	(664300, 136, '2015-01-15 00:19:26.000000', 'consum', 0.0330, 'lps'),
	(664301, 136, '2015-01-15 00:19:27.000000', 'consum', 0.0303, 'lps'),
	(664302, 136, '2015-01-15 00:19:28.000000', 'consum', 0.0317, 'lps'),
	(664303, 136, '2015-01-15 00:19:29.000000', 'consum', 0.0317, 'lps'),
	(664304, 136, '2015-01-15 00:19:30.000000', 'consum', 0.0280, 'lps'),
	(664305, 136, '2015-01-15 00:19:31.000000', 'consum', 0.0238, 'lps'),
	(664306, 136, '2015-01-15 00:19:32.000000', 'consum', 0.0289, 'lps'),
	(664307, 136, '2015-01-15 00:19:33.000000', 'consum', 0.0226, 'lps'),
	(664308, 136, '2015-01-15 00:19:34.000000', 'consum', 0.0346, 'lps'),
	(664309, 136, '2015-01-15 00:19:35.000000', 'consum', 0.0256, 'lps'),
	(664310, 136, '2015-01-15 00:19:36.000000', 'consum', 0.0325, 'lps'),
	(664311, 136, '2015-01-15 00:19:37.000000', 'consum', 0.0354, 'lps'),
	(664312, 136, '2015-01-15 00:19:38.000000', 'consum', 0.0294, 'lps'),
	(664313, 136, '2015-01-15 00:19:39.000000', 'consum', 0.0342, 'lps'),
	(664314, 136, '2015-01-15 00:19:40.000000', 'consum', 0.0325, 'lps'),
	(664315, 136, '2015-01-15 00:19:41.000000', 'consum', 0.0245, 'lps'),
	(664316, 136, '2015-01-15 00:19:42.000000', 'consum', 0.0331, 'lps'),
	(664317, 136, '2015-01-15 00:19:43.000000', 'consum', 0.0271, 'lps'),
	(664318, 136, '2015-01-15 00:19:44.000000', 'consum', 0.0301, 'lps'),
	(664319, 136, '2015-01-15 00:19:45.000000', 'consum', 0.0336, 'lps'),
	(664320, 136, '2015-01-15 00:19:46.000000', 'consum', 0.0273, 'lps'),
	(664321, 136, '2015-01-15 00:19:47.000000', 'consum', 0.0294, 'lps'),
	(664322, 136, '2015-01-15 00:19:48.000000', 'consum', 0.0295, 'lps'),
	(664323, 136, '2015-01-15 00:19:49.000000', 'consum', 0.0237, 'lps'),
	(664324, 136, '2015-01-15 00:19:50.000000', 'consum', 0.0236, 'lps'),
	(664325, 136, '2015-01-15 00:19:51.000000', 'consum', 0.0262, 'lps'),
	(664326, 136, '2015-01-15 00:19:52.000000', 'consum', 0.0245, 'lps'),
	(664327, 136, '2015-01-15 00:19:53.000000', 'consum', 0.0230, 'lps'),
	(664328, 136, '2015-01-15 00:19:54.000000', 'consum', 0.0354, 'lps'),
	(664329, 136, '2015-01-15 00:19:55.000000', 'consum', 0.0280, 'lps'),
	(664330, 136, '2015-01-15 00:19:56.000000', 'consum', 0.0276, 'lps'),
	(664331, 136, '2015-01-15 00:19:57.000000', 'consum', 0.0329, 'lps'),
	(664332, 136, '2015-01-15 00:19:58.000000', 'consum', 0.0313, 'lps'),
	(664333, 136, '2015-01-15 00:19:59.000000', 'consum', 0.0223, 'lps'),
	(664334, 136, '2015-01-15 00:20:00.000000', 'consum', 0.0258, 'lps'),
	(664335, 136, '2015-01-15 00:20:01.000000', 'consum', 0.0267, 'lps'),
	(664336, 136, '2015-01-15 00:20:02.000000', 'consum', 0.0349, 'lps'),
	(664337, 136, '2015-01-15 00:20:03.000000', 'consum', 0.0294, 'lps'),
	(664338, 136, '2015-01-15 00:20:04.000000', 'consum', 0.0215, 'lps'),
	(664339, 136, '2015-01-15 00:20:05.000000', 'consum', 0.0277, 'lps'),
	(664340, 136, '2015-01-15 00:20:06.000000', 'consum', 0.0235, 'lps'),
	(664341, 136, '2015-01-15 00:20:07.000000', 'consum', 0.0283, 'lps'),
	(664342, 136, '2015-01-15 00:20:08.000000', 'consum', 0.0353, 'lps'),
	(664343, 136, '2015-01-15 00:20:09.000000', 'consum', 0.0264, 'lps'),
	(664344, 136, '2015-01-15 00:20:10.000000', 'consum', 0.0344, 'lps'),
	(664345, 136, '2015-01-15 00:20:11.000000', 'consum', 0.0281, 'lps'),
	(664346, 136, '2015-01-15 00:20:12.000000', 'consum', 0.0311, 'lps'),
	(664347, 136, '2015-01-15 00:20:13.000000', 'consum', 0.0353, 'lps'),
	(664348, 136, '2015-01-15 00:20:14.000000', 'consum', 0.0331, 'lps'),
	(664349, 136, '2015-01-15 00:20:15.000000', 'consum', 0.0239, 'lps'),
	(664350, 136, '2015-01-15 00:20:16.000000', 'consum', 0.0288, 'lps'),
	(664351, 136, '2015-01-15 00:20:17.000000', 'consum', 0.0217, 'lps'),
	(664352, 136, '2015-01-15 00:20:18.000000', 'consum', 0.0305, 'lps'),
	(664353, 136, '2015-01-15 00:20:19.000000', 'consum', 0.0225, 'lps'),
	(664354, 136, '2015-01-15 00:20:20.000000', 'consum', 0.0296, 'lps'),
	(664355, 136, '2015-01-15 00:20:21.000000', 'consum', 0.0298, 'lps'),
	(664356, 136, '2015-01-15 00:20:22.000000', 'consum', 0.0247, 'lps'),
	(664357, 136, '2015-01-15 00:20:23.000000', 'consum', 0.0279, 'lps'),
	(664358, 136, '2015-01-15 00:20:24.000000', 'consum', 0.0299, 'lps'),
	(664359, 136, '2015-01-15 00:20:25.000000', 'consum', 0.0301, 'lps'),
	(664360, 136, '2015-01-15 00:20:26.000000', 'consum', 0.0250, 'lps'),
	(664361, 136, '2015-01-15 00:20:27.000000', 'consum', 0.0284, 'lps'),
	(664362, 136, '2015-01-15 00:20:28.000000', 'consum', 0.0315, 'lps'),
	(664363, 136, '2015-01-15 00:20:29.000000', 'consum', 0.0220, 'lps'),
	(664364, 136, '2015-01-15 00:20:30.000000', 'consum', 0.0239, 'lps'),
	(664365, 136, '2015-01-15 00:20:31.000000', 'consum', 0.0327, 'lps'),
	(664366, 136, '2015-01-15 00:20:32.000000', 'consum', 0.0267, 'lps'),
	(664367, 136, '2015-01-15 00:20:33.000000', 'consum', 0.0291, 'lps'),
	(664368, 136, '2015-01-15 00:20:34.000000', 'consum', 0.0297, 'lps'),
	(664369, 136, '2015-01-15 00:20:35.000000', 'consum', 0.0255, 'lps'),
	(664370, 136, '2015-01-15 00:20:36.000000', 'consum', 0.0321, 'lps'),
	(664371, 136, '2015-01-15 00:20:37.000000', 'consum', 0.0336, 'lps'),
	(664372, 136, '2015-01-15 00:20:38.000000', 'consum', 0.0215, 'lps'),
	(664373, 136, '2015-01-15 00:20:39.000000', 'consum', 0.0297, 'lps'),
	(664374, 136, '2015-01-15 00:20:40.000000', 'consum', 0.0335, 'lps'),
	(664375, 136, '2015-01-15 00:20:41.000000', 'consum', 0.0284, 'lps'),
	(664376, 136, '2015-01-15 00:20:42.000000', 'consum', 0.0352, 'lps'),
	(664377, 136, '2015-01-15 00:20:43.000000', 'consum', 0.0255, 'lps'),
	(664378, 136, '2015-01-15 00:20:44.000000', 'consum', 0.0305, 'lps'),
	(664379, 136, '2015-01-15 00:20:45.000000', 'consum', 0.0257, 'lps'),
	(664380, 136, '2015-01-15 00:20:46.000000', 'consum', 0.0306, 'lps'),
	(664381, 136, '2015-01-15 00:20:47.000000', 'consum', 0.0256, 'lps'),
	(664382, 136, '2015-01-15 00:20:48.000000', 'consum', 0.0300, 'lps'),
	(664383, 136, '2015-01-15 00:20:49.000000', 'consum', 0.0230, 'lps'),
	(664384, 136, '2015-01-15 00:20:50.000000', 'consum', 0.0334, 'lps'),
	(664385, 136, '2015-01-15 00:20:51.000000', 'consum', 0.0330, 'lps'),
	(664386, 136, '2015-01-15 00:20:52.000000', 'consum', 0.0290, 'lps'),
	(664387, 136, '2015-01-15 00:20:53.000000', 'consum', 0.0253, 'lps'),
	(664388, 136, '2015-01-15 00:20:54.000000', 'consum', 0.0331, 'lps'),
	(664389, 136, '2015-01-15 00:20:55.000000', 'consum', 0.0246, 'lps'),
	(664390, 136, '2015-01-15 00:20:56.000000', 'consum', 0.0319, 'lps'),
	(664391, 136, '2015-01-15 00:20:57.000000', 'consum', 0.0356, 'lps'),
	(664392, 136, '2015-01-15 00:20:58.000000', 'consum', 0.0321, 'lps'),
	(664393, 136, '2015-01-15 00:20:59.000000', 'consum', 0.0324, 'lps'),
	(664394, 136, '2015-01-15 00:21:00.000000', 'consum', 0.0302, 'lps'),
	(664395, 136, '2015-01-15 00:21:01.000000', 'consum', 0.0327, 'lps'),
	(664396, 136, '2015-01-15 00:21:02.000000', 'consum', 0.0224, 'lps'),
	(664397, 136, '2015-01-15 00:21:03.000000', 'consum', 0.0227, 'lps'),
	(664398, 136, '2015-01-15 00:21:04.000000', 'consum', 0.0252, 'lps'),
	(664399, 136, '2015-01-15 00:21:05.000000', 'consum', 0.0223, 'lps'),
	(664400, 136, '2015-01-15 00:21:06.000000', 'consum', 0.0298, 'lps'),
	(664401, 136, '2015-01-15 00:21:07.000000', 'consum', 0.0317, 'lps'),
	(664402, 136, '2015-01-15 00:21:08.000000', 'consum', 0.0335, 'lps'),
	(664403, 136, '2015-01-15 00:21:09.000000', 'consum', 0.0220, 'lps'),
	(664404, 136, '2015-01-15 00:21:10.000000', 'consum', 0.0327, 'lps'),
	(664405, 136, '2015-01-15 00:21:11.000000', 'consum', 0.0326, 'lps'),
	(664406, 136, '2015-01-15 00:21:12.000000', 'consum', 0.0290, 'lps'),
	(664407, 136, '2015-01-15 00:21:13.000000', 'consum', 0.0262, 'lps'),
	(664408, 136, '2015-01-15 00:21:14.000000', 'consum', 0.0229, 'lps'),
	(664409, 136, '2015-01-15 00:21:15.000000', 'consum', 0.0299, 'lps'),
	(664410, 136, '2015-01-15 00:21:16.000000', 'consum', 0.0306, 'lps'),
	(664411, 136, '2015-01-15 00:21:17.000000', 'consum', 0.0275, 'lps'),
	(664412, 136, '2015-01-15 00:21:18.000000', 'consum', 0.0247, 'lps'),
	(664413, 136, '2015-01-15 00:21:19.000000', 'consum', 0.0347, 'lps'),
	(664414, 136, '2015-01-15 00:21:20.000000', 'consum', 0.0345, 'lps'),
	(664415, 136, '2015-01-15 00:21:21.000000', 'consum', 0.0329, 'lps'),
	(664416, 136, '2015-01-15 00:21:22.000000', 'consum', 0.0251, 'lps'),
	(664417, 136, '2015-01-15 00:21:23.000000', 'consum', 0.0354, 'lps'),
	(664418, 136, '2015-01-15 00:21:24.000000', 'consum', 0.0218, 'lps'),
	(664419, 136, '2015-01-15 00:21:25.000000', 'consum', 0.0259, 'lps'),
	(664420, 136, '2015-01-15 00:21:26.000000', 'consum', 0.0286, 'lps'),
	(664421, 136, '2015-01-15 00:21:27.000000', 'consum', 0.0296, 'lps'),
	(664422, 136, '2015-01-15 00:21:28.000000', 'consum', 0.0264, 'lps'),
	(664423, 136, '2015-01-15 00:21:29.000000', 'consum', 0.0224, 'lps'),
	(664424, 136, '2015-01-15 00:21:30.000000', 'consum', 0.0263, 'lps'),
	(664425, 136, '2015-01-15 00:21:31.000000', 'consum', 0.0288, 'lps'),
	(664426, 136, '2015-01-15 00:21:32.000000', 'consum', 0.0296, 'lps'),
	(664427, 136, '2015-01-15 00:21:33.000000', 'consum', 0.0256, 'lps'),
	(664428, 136, '2015-01-15 00:21:34.000000', 'consum', 0.0333, 'lps'),
	(664429, 136, '2015-01-15 00:21:35.000000', 'consum', 0.0245, 'lps'),
	(664430, 136, '2015-01-15 00:21:36.000000', 'consum', 0.0311, 'lps'),
	(664431, 136, '2015-01-15 00:21:37.000000', 'consum', 0.0314, 'lps'),
	(664432, 136, '2015-01-15 00:21:38.000000', 'consum', 0.0284, 'lps'),
	(664433, 136, '2015-01-15 00:21:39.000000', 'consum', 0.0266, 'lps'),
	(664434, 136, '2015-01-15 00:21:40.000000', 'consum', 0.0267, 'lps'),
	(664435, 136, '2015-01-15 00:21:41.000000', 'consum', 0.0331, 'lps'),
	(664436, 136, '2015-01-15 00:21:42.000000', 'consum', 0.0350, 'lps'),
	(664437, 136, '2015-01-15 00:21:43.000000', 'consum', 0.0254, 'lps'),
	(664438, 136, '2015-01-15 00:21:44.000000', 'consum', 0.0302, 'lps'),
	(664439, 136, '2015-01-15 00:21:45.000000', 'consum', 0.0245, 'lps'),
	(664440, 136, '2015-01-15 00:21:46.000000', 'consum', 0.0256, 'lps'),
	(664441, 136, '2015-01-15 00:21:47.000000', 'consum', 0.0336, 'lps'),
	(664442, 136, '2015-01-15 00:21:48.000000', 'consum', 0.0262, 'lps'),
	(664443, 136, '2015-01-15 00:21:49.000000', 'consum', 0.0240, 'lps'),
	(664444, 136, '2015-01-15 00:21:50.000000', 'consum', 0.0351, 'lps'),
	(664445, 136, '2015-01-15 00:21:51.000000', 'consum', 0.0240, 'lps'),
	(664446, 136, '2015-01-15 00:21:52.000000', 'consum', 0.0228, 'lps'),
	(664447, 136, '2015-01-15 00:21:53.000000', 'consum', 0.0212, 'lps'),
	(664448, 136, '2015-01-15 00:21:54.000000', 'consum', 0.0315, 'lps'),
	(664449, 136, '2015-01-15 00:21:55.000000', 'consum', 0.0288, 'lps'),
	(664450, 136, '2015-01-15 00:21:56.000000', 'consum', 0.0283, 'lps'),
	(664451, 136, '2015-01-15 00:21:57.000000', 'consum', 0.0344, 'lps'),
	(664452, 136, '2015-01-15 00:21:58.000000', 'consum', 0.0219, 'lps'),
	(664453, 136, '2015-01-15 00:21:59.000000', 'consum', 0.0294, 'lps'),
	(664454, 136, '2015-01-15 00:22:00.000000', 'consum', 0.0310, 'lps'),
	(664455, 136, '2015-01-15 00:22:01.000000', 'consum', 0.0313, 'lps'),
	(664456, 136, '2015-01-15 00:22:02.000000', 'consum', 0.0276, 'lps'),
	(664457, 136, '2015-01-15 00:22:03.000000', 'consum', 0.0232, 'lps'),
	(664458, 136, '2015-01-15 00:22:04.000000', 'consum', 0.0270, 'lps'),
	(664459, 136, '2015-01-15 00:22:05.000000', 'consum', 0.0299, 'lps'),
	(664460, 136, '2015-01-15 00:22:06.000000', 'consum', 0.0328, 'lps'),
	(664461, 136, '2015-01-15 00:22:07.000000', 'consum', 0.0240, 'lps'),
	(664462, 136, '2015-01-15 00:22:08.000000', 'consum', 0.0301, 'lps'),
	(664463, 136, '2015-01-15 00:22:09.000000', 'consum', 0.0281, 'lps'),
	(664464, 136, '2015-01-15 00:22:10.000000', 'consum', 0.0292, 'lps'),
	(664465, 136, '2015-01-15 00:22:11.000000', 'consum', 0.0260, 'lps'),
	(664466, 136, '2015-01-15 00:22:12.000000', 'consum', 0.0214, 'lps'),
	(664467, 136, '2015-01-15 00:22:13.000000', 'consum', 0.0227, 'lps'),
	(664468, 136, '2015-01-15 00:22:14.000000', 'consum', 0.0285, 'lps'),
	(664469, 136, '2015-01-15 00:22:15.000000', 'consum', 0.0240, 'lps'),
	(664470, 136, '2015-01-15 00:22:16.000000', 'consum', 0.0282, 'lps'),
	(664471, 136, '2015-01-15 00:22:17.000000', 'consum', 0.0336, 'lps'),
	(664472, 136, '2015-01-15 00:22:18.000000', 'consum', 0.0329, 'lps'),
	(664473, 136, '2015-01-15 00:22:19.000000', 'consum', 0.0280, 'lps'),
	(664474, 136, '2015-01-15 00:22:20.000000', 'consum', 0.0351, 'lps'),
	(664475, 136, '2015-01-15 00:22:21.000000', 'consum', 0.0266, 'lps'),
	(664476, 136, '2015-01-15 00:22:22.000000', 'consum', 0.0212, 'lps'),
	(664477, 136, '2015-01-15 00:22:23.000000', 'consum', 0.0348, 'lps'),
	(664478, 136, '2015-01-15 00:22:24.000000', 'consum', 0.0306, 'lps'),
	(664479, 136, '2015-01-15 00:22:25.000000', 'consum', 0.0276, 'lps'),
	(664480, 136, '2015-01-15 00:22:26.000000', 'consum', 0.0251, 'lps'),
	(664481, 136, '2015-01-15 00:22:27.000000', 'consum', 0.0218, 'lps'),
	(664482, 136, '2015-01-15 00:22:28.000000', 'consum', 0.0274, 'lps'),
	(664483, 136, '2015-01-15 00:22:29.000000', 'consum', 0.0215, 'lps'),
	(664484, 136, '2015-01-15 00:22:30.000000', 'consum', 0.0337, 'lps'),
	(664485, 136, '2015-01-15 00:22:31.000000', 'consum', 0.0241, 'lps'),
	(664486, 136, '2015-01-15 00:22:32.000000', 'consum', 0.0277, 'lps'),
	(664487, 136, '2015-01-15 00:22:33.000000', 'consum', 0.0308, 'lps'),
	(664488, 136, '2015-01-15 00:22:34.000000', 'consum', 0.0353, 'lps'),
	(664489, 136, '2015-01-15 00:22:35.000000', 'consum', 0.0338, 'lps'),
	(664490, 136, '2015-01-15 00:22:36.000000', 'consum', 0.0275, 'lps'),
	(664491, 136, '2015-01-15 00:22:37.000000', 'consum', 0.0297, 'lps'),
	(664492, 136, '2015-01-15 00:22:38.000000', 'consum', 0.0302, 'lps'),
	(664493, 136, '2015-01-15 00:22:39.000000', 'consum', 0.0266, 'lps'),
	(664494, 136, '2015-01-15 00:22:40.000000', 'consum', 0.0212, 'lps'),
	(664495, 136, '2015-01-15 00:22:41.000000', 'consum', 0.0347, 'lps'),
	(664496, 136, '2015-01-15 00:22:42.000000', 'consum', 0.0300, 'lps'),
	(664497, 136, '2015-01-15 00:22:43.000000', 'consum', 0.0253, 'lps'),
	(664498, 136, '2015-01-15 00:22:44.000000', 'consum', 0.0299, 'lps'),
	(664499, 136, '2015-01-15 00:22:45.000000', 'consum', 0.0235, 'lps'),
	(664500, 136, '2015-01-15 00:22:46.000000', 'consum', 0.0216, 'lps'),
	(664501, 136, '2015-01-15 00:22:47.000000', 'consum', 0.0311, 'lps'),
	(664502, 136, '2015-01-15 00:22:48.000000', 'consum', 0.0259, 'lps'),
	(664503, 136, '2015-01-15 00:22:49.000000', 'consum', 0.0297, 'lps'),
	(664504, 136, '2015-01-15 00:22:50.000000', 'consum', 0.0354, 'lps'),
	(664505, 136, '2015-01-15 00:22:51.000000', 'consum', 0.0227, 'lps'),
	(664506, 136, '2015-01-15 00:22:52.000000', 'consum', 0.0306, 'lps'),
	(664507, 136, '2015-01-15 00:22:53.000000', 'consum', 0.0344, 'lps'),
	(664508, 136, '2015-01-15 00:22:54.000000', 'consum', 0.0300, 'lps'),
	(664509, 136, '2015-01-15 00:22:55.000000', 'consum', 0.0260, 'lps'),
	(664510, 136, '2015-01-15 00:22:56.000000', 'consum', 0.0335, 'lps'),
	(664511, 136, '2015-01-15 00:22:57.000000', 'consum', 0.0246, 'lps'),
	(664512, 136, '2015-01-15 00:22:58.000000', 'consum', 0.0308, 'lps'),
	(664513, 136, '2015-01-15 00:22:59.000000', 'consum', 0.0299, 'lps'),
	(664514, 136, '2015-01-15 00:23:00.000000', 'consum', 0.0213, 'lps'),
	(664515, 136, '2015-01-15 00:23:01.000000', 'consum', 0.0255, 'lps'),
	(664516, 136, '2015-01-15 00:23:02.000000', 'consum', 0.0278, 'lps'),
	(664517, 136, '2015-01-15 00:23:03.000000', 'consum', 0.0269, 'lps'),
	(664518, 136, '2015-01-15 00:23:04.000000', 'consum', 0.0301, 'lps'),
	(664519, 136, '2015-01-15 00:23:05.000000', 'consum', 0.0342, 'lps'),
	(664520, 136, '2015-01-15 00:23:06.000000', 'consum', 0.0302, 'lps'),
	(664521, 136, '2015-01-15 00:23:07.000000', 'consum', 0.0278, 'lps'),
	(664522, 136, '2015-01-15 00:23:08.000000', 'consum', 0.0271, 'lps'),
	(664523, 136, '2015-01-15 00:23:09.000000', 'consum', 0.0311, 'lps'),
	(664524, 136, '2015-01-15 00:23:10.000000', 'consum', 0.0240, 'lps'),
	(664525, 136, '2015-01-15 00:23:11.000000', 'consum', 0.0350, 'lps'),
	(664526, 136, '2015-01-15 00:23:12.000000', 'consum', 0.0234, 'lps'),
	(664527, 136, '2015-01-15 00:23:13.000000', 'consum', 0.0352, 'lps'),
	(664528, 136, '2015-01-15 00:23:14.000000', 'consum', 0.0259, 'lps'),
	(664529, 136, '2015-01-15 00:23:15.000000', 'consum', 0.0326, 'lps'),
	(664530, 136, '2015-01-15 00:23:16.000000', 'consum', 0.0349, 'lps'),
	(664531, 136, '2015-01-15 00:23:17.000000', 'consum', 0.0262, 'lps'),
	(664532, 136, '2015-01-15 00:23:18.000000', 'consum', 0.0348, 'lps'),
	(664533, 136, '2015-01-15 00:23:19.000000', 'consum', 0.0302, 'lps'),
	(664534, 136, '2015-01-15 00:23:20.000000', 'consum', 0.0257, 'lps'),
	(664535, 136, '2015-01-15 00:23:21.000000', 'consum', 0.0315, 'lps'),
	(664536, 136, '2015-01-15 00:23:22.000000', 'consum', 0.0302, 'lps'),
	(664537, 136, '2015-01-15 00:23:23.000000', 'consum', 0.0353, 'lps'),
	(664538, 136, '2015-01-15 00:23:24.000000', 'consum', 0.0212, 'lps'),
	(664539, 136, '2015-01-15 00:23:25.000000', 'consum', 0.0230, 'lps'),
	(664540, 136, '2015-01-15 00:23:26.000000', 'consum', 0.0304, 'lps'),
	(664541, 136, '2015-01-15 00:23:27.000000', 'consum', 0.0325, 'lps'),
	(664542, 136, '2015-01-15 00:23:28.000000', 'consum', 0.0213, 'lps'),
	(664543, 136, '2015-01-15 00:23:29.000000', 'consum', 0.0321, 'lps'),
	(664544, 136, '2015-01-15 00:23:30.000000', 'consum', 0.0315, 'lps'),
	(664545, 136, '2015-01-15 00:23:31.000000', 'consum', 0.0255, 'lps'),
	(664546, 136, '2015-01-15 00:23:32.000000', 'consum', 0.0266, 'lps'),
	(664547, 136, '2015-01-15 00:23:33.000000', 'consum', 0.0212, 'lps'),
	(664548, 136, '2015-01-15 00:23:34.000000', 'consum', 0.0344, 'lps'),
	(664549, 136, '2015-01-15 00:23:35.000000', 'consum', 0.0288, 'lps'),
	(664550, 136, '2015-01-15 00:23:36.000000', 'consum', 0.0346, 'lps'),
	(664551, 136, '2015-01-15 00:23:37.000000', 'consum', 0.0214, 'lps'),
	(664552, 136, '2015-01-15 00:23:38.000000', 'consum', 0.0264, 'lps'),
	(664553, 136, '2015-01-15 00:23:39.000000', 'consum', 0.0320, 'lps'),
	(664554, 136, '2015-01-15 00:23:40.000000', 'consum', 0.0305, 'lps'),
	(664555, 136, '2015-01-15 00:23:41.000000', 'consum', 0.0355, 'lps'),
	(664556, 136, '2015-01-15 00:23:42.000000', 'consum', 0.0355, 'lps'),
	(664557, 136, '2015-01-15 00:23:43.000000', 'consum', 0.0355, 'lps'),
	(664558, 136, '2015-01-15 00:23:44.000000', 'consum', 0.0354, 'lps'),
	(664559, 136, '2015-01-15 00:23:45.000000', 'consum', 0.0350, 'lps'),
	(664560, 136, '2015-01-15 00:23:46.000000', 'consum', 0.0331, 'lps'),
	(664561, 136, '2015-01-15 00:23:47.000000', 'consum', 0.0248, 'lps'),
	(664562, 136, '2015-01-15 00:23:48.000000', 'consum', 0.0333, 'lps'),
	(664563, 136, '2015-01-15 00:23:49.000000', 'consum', 0.0268, 'lps'),
	(664564, 136, '2015-01-15 00:23:50.000000', 'consum', 0.0279, 'lps'),
	(664565, 136, '2015-01-15 00:23:51.000000', 'consum', 0.0236, 'lps'),
	(664566, 136, '2015-01-15 00:23:52.000000', 'consum', 0.0279, 'lps'),
	(664567, 136, '2015-01-15 00:23:53.000000', 'consum', 0.0332, 'lps'),
	(664568, 136, '2015-01-15 00:23:54.000000', 'consum', 0.0320, 'lps'),
	(664569, 136, '2015-01-15 00:23:55.000000', 'consum', 0.0245, 'lps'),
	(664570, 136, '2015-01-15 00:23:56.000000', 'consum', 0.0350, 'lps'),
	(664571, 136, '2015-01-15 00:23:57.000000', 'consum', 0.0219, 'lps'),
	(664572, 136, '2015-01-15 00:23:58.000000', 'consum', 0.0274, 'lps'),
	(664573, 136, '2015-01-15 00:23:59.000000', 'consum', 0.0211, 'lps'),
	(664574, 136, '2015-01-15 00:24:00.000000', 'consum', 0.0317, 'lps'),
	(664575, 136, '2015-01-15 00:24:01.000000', 'consum', 0.0300, 'lps'),
	(664576, 136, '2015-01-15 00:24:02.000000', 'consum', 0.0342, 'lps'),
	(664577, 136, '2015-01-15 00:24:03.000000', 'consum', 0.0304, 'lps'),
	(664578, 136, '2015-01-15 00:24:04.000000', 'consum', 0.0284, 'lps'),
	(664579, 136, '2015-01-15 00:24:05.000000', 'consum', 0.0301, 'lps'),
	(664580, 136, '2015-01-15 00:24:06.000000', 'consum', 0.0295, 'lps'),
	(664581, 136, '2015-01-15 00:24:07.000000', 'consum', 0.0218, 'lps'),
	(664582, 136, '2015-01-15 00:24:08.000000', 'consum', 0.0287, 'lps'),
	(664583, 136, '2015-01-15 00:24:09.000000', 'consum', 0.0280, 'lps'),
	(664584, 136, '2015-01-15 00:24:10.000000', 'consum', 0.0329, 'lps'),
	(664585, 136, '2015-01-15 00:24:11.000000', 'consum', 0.0299, 'lps'),
	(664586, 136, '2015-01-15 00:24:12.000000', 'consum', 0.0301, 'lps'),
	(664587, 136, '2015-01-15 00:24:13.000000', 'consum', 0.0253, 'lps'),
	(664588, 136, '2015-01-15 00:24:14.000000', 'consum', 0.0297, 'lps'),
	(664589, 136, '2015-01-15 00:24:15.000000', 'consum', 0.0224, 'lps'),
	(664590, 136, '2015-01-15 00:24:16.000000', 'consum', 0.0311, 'lps'),
	(664591, 136, '2015-01-15 00:24:17.000000', 'consum', 0.0233, 'lps'),
	(664592, 136, '2015-01-15 00:24:18.000000', 'consum', 0.0318, 'lps'),
	(664593, 136, '2015-01-15 00:24:19.000000', 'consum', 0.0241, 'lps'),
	(664594, 136, '2015-01-15 00:24:20.000000', 'consum', 0.0337, 'lps'),
	(664595, 136, '2015-01-15 00:24:21.000000', 'consum', 0.0309, 'lps'),
	(664596, 136, '2015-01-15 00:24:22.000000', 'consum', 0.0325, 'lps'),
	(664597, 136, '2015-01-15 00:24:23.000000', 'consum', 0.0340, 'lps'),
	(664598, 136, '2015-01-15 00:24:24.000000', 'consum', 0.0223, 'lps'),
	(664599, 136, '2015-01-15 00:24:25.000000', 'consum', 0.0327, 'lps'),
	(664600, 136, '2015-01-15 00:24:26.000000', 'consum', 0.0316, 'lps'),
	(664601, 136, '2015-01-15 00:24:27.000000', 'consum', 0.0241, 'lps'),
	(664602, 136, '2015-01-15 00:24:28.000000', 'consum', 0.0340, 'lps'),
	(664603, 136, '2015-01-15 00:24:29.000000', 'consum', 0.0329, 'lps'),
	(664604, 136, '2015-01-15 00:24:30.000000', 'consum', 0.0268, 'lps'),
	(664605, 136, '2015-01-15 00:24:31.000000', 'consum', 0.0288, 'lps'),
	(664606, 136, '2015-01-15 00:24:32.000000', 'consum', 0.0283, 'lps'),
	(664607, 136, '2015-01-15 00:24:33.000000', 'consum', 0.0339, 'lps'),
	(664608, 136, '2015-01-15 00:24:34.000000', 'consum', 0.0345, 'lps'),
	(664609, 136, '2015-01-15 00:24:35.000000', 'consum', 0.0349, 'lps'),
	(664610, 136, '2015-01-15 00:24:36.000000', 'consum', 0.0355, 'lps'),
	(664611, 136, '2015-01-15 00:24:37.000000', 'consum', 0.0223, 'lps'),
	(664612, 136, '2015-01-15 00:24:38.000000', 'consum', 0.0284, 'lps'),
	(664613, 136, '2015-01-15 00:24:39.000000', 'consum', 0.0246, 'lps'),
	(664614, 136, '2015-01-15 00:24:40.000000', 'consum', 0.0316, 'lps'),
	(664615, 136, '2015-01-15 00:24:41.000000', 'consum', 0.0337, 'lps'),
	(664616, 136, '2015-01-15 00:24:42.000000', 'consum', 0.0233, 'lps'),
	(664617, 136, '2015-01-15 00:24:43.000000', 'consum', 0.0237, 'lps'),
	(664618, 136, '2015-01-15 00:24:44.000000', 'consum', 0.0280, 'lps'),
	(664619, 136, '2015-01-15 00:24:45.000000', 'consum', 0.0333, 'lps'),
	(664620, 136, '2015-01-15 00:24:46.000000', 'consum', 0.0319, 'lps'),
	(664621, 136, '2015-01-15 00:24:47.000000', 'consum', 0.0239, 'lps'),
	(664622, 136, '2015-01-15 00:24:48.000000', 'consum', 0.0325, 'lps'),
	(664623, 136, '2015-01-15 00:24:49.000000', 'consum', 0.0256, 'lps'),
	(664624, 136, '2015-01-15 00:24:50.000000', 'consum', 0.0244, 'lps'),
	(664625, 136, '2015-01-15 00:24:51.000000', 'consum', 0.0243, 'lps'),
	(664626, 136, '2015-01-15 00:24:52.000000', 'consum', 0.0272, 'lps'),
	(664627, 136, '2015-01-15 00:24:53.000000', 'consum', 0.0275, 'lps'),
	(664628, 136, '2015-01-15 00:24:54.000000', 'consum', 0.0350, 'lps'),
	(664629, 136, '2015-01-15 00:24:55.000000', 'consum', 0.0272, 'lps'),
	(664630, 136, '2015-01-15 00:24:56.000000', 'consum', 0.0249, 'lps'),
	(664631, 136, '2015-01-15 00:24:57.000000', 'consum', 0.0221, 'lps'),
	(664632, 136, '2015-01-15 00:24:58.000000', 'consum', 0.0293, 'lps'),
	(664633, 136, '2015-01-15 00:24:59.000000', 'consum', 0.0299, 'lps'),
	(664634, 136, '2015-01-15 00:25:00.000000', 'consum', 0.0262, 'lps'),
	(664635, 136, '2015-01-15 00:25:01.000000', 'consum', 0.0349, 'lps'),
	(664636, 136, '2015-01-15 00:25:02.000000', 'consum', 0.0307, 'lps'),
	(664637, 136, '2015-01-15 00:25:03.000000', 'consum', 0.0277, 'lps'),
	(664638, 136, '2015-01-15 00:25:04.000000', 'consum', 0.0258, 'lps'),
	(664639, 136, '2015-01-15 00:25:05.000000', 'consum', 0.0250, 'lps'),
	(664640, 136, '2015-01-15 00:25:06.000000', 'consum', 0.0265, 'lps'),
	(664641, 136, '2015-01-15 00:25:07.000000', 'consum', 0.0218, 'lps'),
	(664642, 136, '2015-01-15 00:25:08.000000', 'consum', 0.0231, 'lps'),
	(664643, 136, '2015-01-15 00:25:09.000000', 'consum', 0.0295, 'lps'),
	(664644, 136, '2015-01-15 00:25:10.000000', 'consum', 0.0277, 'lps'),
	(664645, 136, '2015-01-15 00:25:11.000000', 'consum', 0.0290, 'lps'),
	(664646, 136, '2015-01-15 00:25:12.000000', 'consum', 0.0262, 'lps'),
	(664647, 136, '2015-01-15 00:25:13.000000', 'consum', 0.0232, 'lps'),
	(664648, 136, '2015-01-15 00:25:14.000000', 'consum', 0.0310, 'lps'),
	(664649, 136, '2015-01-15 00:25:15.000000', 'consum', 0.0349, 'lps'),
	(664650, 136, '2015-01-15 00:25:16.000000', 'consum', 0.0315, 'lps'),
	(664651, 136, '2015-01-15 00:25:17.000000', 'consum', 0.0317, 'lps'),
	(664652, 136, '2015-01-15 00:25:18.000000', 'consum', 0.0284, 'lps'),
	(664653, 136, '2015-01-15 00:25:19.000000', 'consum', 0.0260, 'lps'),
	(664654, 136, '2015-01-15 00:25:20.000000', 'consum', 0.0237, 'lps'),
	(664655, 136, '2015-01-15 00:25:21.000000', 'consum', 0.0344, 'lps'),
	(664656, 136, '2015-01-15 00:25:22.000000', 'consum', 0.0212, 'lps'),
	(664657, 136, '2015-01-15 00:25:23.000000', 'consum', 0.0261, 'lps'),
	(664658, 136, '2015-01-15 00:25:24.000000', 'consum', 0.0309, 'lps'),
	(664659, 136, '2015-01-15 00:25:25.000000', 'consum', 0.0259, 'lps'),
	(664660, 136, '2015-01-15 00:25:26.000000', 'consum', 0.0307, 'lps'),
	(664661, 136, '2015-01-15 00:25:27.000000', 'consum', 0.0252, 'lps'),
	(664662, 136, '2015-01-15 00:25:28.000000', 'consum', 0.0278, 'lps'),
	(664663, 136, '2015-01-15 00:25:29.000000', 'consum', 0.0278, 'lps'),
	(664664, 136, '2015-01-15 00:25:30.000000', 'consum', 0.0348, 'lps'),
	(664665, 136, '2015-01-15 00:25:31.000000', 'consum', 0.0255, 'lps'),
	(664666, 136, '2015-01-15 00:25:32.000000', 'consum', 0.0313, 'lps'),
	(664667, 136, '2015-01-15 00:25:33.000000', 'consum', 0.0299, 'lps'),
	(664668, 136, '2015-01-15 00:25:34.000000', 'consum', 0.0347, 'lps'),
	(664669, 136, '2015-01-15 00:25:35.000000', 'consum', 0.0335, 'lps'),
	(664670, 136, '2015-01-15 00:25:36.000000', 'consum', 0.0275, 'lps'),
	(664671, 136, '2015-01-15 00:25:37.000000', 'consum', 0.0309, 'lps'),
	(664672, 136, '2015-01-15 00:25:38.000000', 'consum', 0.0216, 'lps'),
	(664673, 136, '2015-01-15 00:25:39.000000', 'consum', 0.0236, 'lps'),
	(664674, 136, '2015-01-15 00:25:40.000000', 'consum', 0.0323, 'lps'),
	(664675, 136, '2015-01-15 00:25:41.000000', 'consum', 0.0255, 'lps'),
	(664676, 136, '2015-01-15 00:25:42.000000', 'consum', 0.0247, 'lps'),
	(664677, 136, '2015-01-15 00:25:43.000000', 'consum', 0.0258, 'lps'),
	(664678, 136, '2015-01-15 00:25:44.000000', 'consum', 0.0342, 'lps'),
	(664679, 136, '2015-01-15 00:25:45.000000', 'consum', 0.0284, 'lps'),
	(664680, 136, '2015-01-15 00:25:46.000000', 'consum', 0.0332, 'lps'),
	(664681, 136, '2015-01-15 00:25:47.000000', 'consum', 0.0306, 'lps'),
	(664682, 136, '2015-01-15 00:25:48.000000', 'consum', 0.0324, 'lps'),
	(664683, 136, '2015-01-15 00:25:49.000000', 'consum', 0.0347, 'lps'),
	(664684, 136, '2015-01-15 00:25:50.000000', 'consum', 0.0257, 'lps'),
	(664685, 136, '2015-01-15 00:25:51.000000', 'consum', 0.0327, 'lps'),
	(664686, 136, '2015-01-15 00:25:52.000000', 'consum', 0.0217, 'lps'),
	(664687, 136, '2015-01-15 00:25:53.000000', 'consum', 0.0333, 'lps'),
	(664688, 136, '2015-01-15 00:25:54.000000', 'consum', 0.0218, 'lps'),
	(664689, 136, '2015-01-15 00:25:55.000000', 'consum', 0.0322, 'lps'),
	(664690, 136, '2015-01-15 00:25:56.000000', 'consum', 0.0306, 'lps'),
	(664691, 136, '2015-01-15 00:25:57.000000', 'consum', 0.0355, 'lps'),
	(664692, 136, '2015-01-15 00:25:58.000000', 'consum', 0.0352, 'lps'),
	(664693, 136, '2015-01-15 00:25:59.000000', 'consum', 0.0338, 'lps'),
	(664694, 136, '2015-01-15 00:26:00.000000', 'consum', 0.0277, 'lps'),
	(664695, 136, '2015-01-15 00:26:01.000000', 'consum', 0.0311, 'lps'),
	(664696, 136, '2015-01-15 00:26:02.000000', 'consum', 0.0219, 'lps'),
	(664697, 136, '2015-01-15 00:26:03.000000', 'consum', 0.0247, 'lps'),
	(664698, 136, '2015-01-15 00:26:04.000000', 'consum', 0.0223, 'lps'),
	(664699, 136, '2015-01-15 00:26:05.000000', 'consum', 0.0311, 'lps'),
	(664700, 136, '2015-01-15 00:26:06.000000', 'consum', 0.0234, 'lps'),
	(664701, 136, '2015-01-15 00:26:07.000000', 'consum', 0.0322, 'lps'),
	(664702, 136, '2015-01-15 00:26:08.000000', 'consum', 0.0257, 'lps'),
	(664703, 136, '2015-01-15 00:26:09.000000', 'consum', 0.0258, 'lps'),
	(664704, 136, '2015-01-15 00:26:10.000000', 'consum', 0.0307, 'lps'),
	(664705, 136, '2015-01-15 00:26:11.000000', 'consum', 0.0260, 'lps'),
	(664706, 136, '2015-01-15 00:26:12.000000', 'consum', 0.0315, 'lps'),
	(664707, 136, '2015-01-15 00:26:13.000000', 'consum', 0.0292, 'lps'),
	(664708, 136, '2015-01-15 00:26:14.000000', 'consum', 0.0306, 'lps'),
	(664709, 136, '2015-01-15 00:26:15.000000', 'consum', 0.0297, 'lps'),
	(664710, 136, '2015-01-15 00:26:16.000000', 'consum', 0.0211, 'lps'),
	(664711, 136, '2015-01-15 00:26:17.000000', 'consum', 0.0246, 'lps'),
	(664712, 136, '2015-01-15 00:26:18.000000', 'consum', 0.0243, 'lps'),
	(664713, 136, '2015-01-15 00:26:19.000000', 'consum', 0.0268, 'lps'),
	(664714, 136, '2015-01-15 00:26:20.000000', 'consum', 0.0256, 'lps'),
	(664715, 136, '2015-01-15 00:26:21.000000', 'consum', 0.0264, 'lps'),
	(664716, 136, '2015-01-15 00:26:22.000000', 'consum', 0.0342, 'lps'),
	(664717, 136, '2015-01-15 00:26:23.000000', 'consum', 0.0270, 'lps'),
	(664718, 136, '2015-01-15 00:26:24.000000', 'consum', 0.0260, 'lps'),
	(664719, 136, '2015-01-15 00:26:25.000000', 'consum', 0.0283, 'lps'),
	(664720, 136, '2015-01-15 00:26:26.000000', 'consum', 0.0275, 'lps'),
	(664721, 136, '2015-01-15 00:26:27.000000', 'consum', 0.0319, 'lps'),
	(664722, 136, '2015-01-15 00:26:28.000000', 'consum', 0.0267, 'lps'),
	(664723, 136, '2015-01-15 00:26:29.000000', 'consum', 0.0315, 'lps'),
	(664724, 136, '2015-01-15 00:26:30.000000', 'consum', 0.0271, 'lps'),
	(664725, 136, '2015-01-15 00:26:31.000000', 'consum', 0.0347, 'lps'),
	(664726, 136, '2015-01-15 00:26:32.000000', 'consum', 0.0271, 'lps'),
	(664727, 136, '2015-01-15 00:26:33.000000', 'consum', 0.0251, 'lps'),
	(664728, 136, '2015-01-15 00:26:34.000000', 'consum', 0.0232, 'lps'),
	(664729, 136, '2015-01-15 00:26:35.000000', 'consum', 0.0346, 'lps'),
	(664730, 136, '2015-01-15 00:26:36.000000', 'consum', 0.0236, 'lps'),
	(664731, 136, '2015-01-15 00:26:37.000000', 'consum', 0.0227, 'lps'),
	(664732, 136, '2015-01-15 00:26:38.000000', 'consum', 0.0219, 'lps'),
	(664733, 136, '2015-01-15 00:26:39.000000', 'consum', 0.0350, 'lps'),
	(664734, 136, '2015-01-15 00:26:40.000000', 'consum', 0.0293, 'lps'),
	(664735, 136, '2015-01-15 00:26:41.000000', 'consum', 0.0356, 'lps'),
	(664736, 136, '2015-01-15 00:26:42.000000', 'consum', 0.0251, 'lps'),
	(664737, 136, '2015-01-15 00:26:43.000000', 'consum', 0.0272, 'lps'),
	(664738, 136, '2015-01-15 00:26:44.000000', 'consum', 0.0250, 'lps'),
	(664739, 136, '2015-01-15 00:26:45.000000', 'consum', 0.0225, 'lps'),
	(664740, 136, '2015-01-15 00:26:46.000000', 'consum', 0.0314, 'lps'),
	(664741, 136, '2015-01-15 00:26:47.000000', 'consum', 0.0243, 'lps'),
	(664742, 136, '2015-01-15 00:26:48.000000', 'consum', 0.0356, 'lps'),
	(664743, 136, '2015-01-15 00:26:49.000000', 'consum', 0.0253, 'lps'),
	(664744, 136, '2015-01-15 00:26:50.000000', 'consum', 0.0283, 'lps'),
	(664745, 136, '2015-01-15 00:26:51.000000', 'consum', 0.0298, 'lps'),
	(664746, 136, '2015-01-15 00:26:52.000000', 'consum', 0.0285, 'lps'),
	(664747, 136, '2015-01-15 00:26:53.000000', 'consum', 0.0321, 'lps'),
	(664748, 136, '2015-01-15 00:26:54.000000', 'consum', 0.0247, 'lps'),
	(664749, 136, '2015-01-15 00:26:55.000000', 'consum', 0.0210, 'lps'),
	(664750, 136, '2015-01-15 00:26:56.000000', 'consum', 0.0247, 'lps'),
	(664751, 136, '2015-01-15 00:26:57.000000', 'consum', 0.0246, 'lps'),
	(664752, 136, '2015-01-15 00:26:58.000000', 'consum', 0.0282, 'lps'),
	(664753, 136, '2015-01-15 00:26:59.000000', 'consum', 0.0317, 'lps'),
	(664754, 136, '2015-01-15 00:27:00.000000', 'consum', 0.0233, 'lps'),
	(664755, 136, '2015-01-15 00:27:01.000000', 'consum', 0.0297, 'lps'),
	(664756, 136, '2015-01-15 00:27:02.000000', 'consum', 0.0286, 'lps'),
	(664757, 136, '2015-01-15 00:27:03.000000', 'consum', 0.0327, 'lps'),
	(664758, 136, '2015-01-15 00:27:04.000000', 'consum', 0.0276, 'lps'),
	(664759, 136, '2015-01-15 00:27:05.000000', 'consum', 0.0333, 'lps'),
	(664760, 136, '2015-01-15 00:27:06.000000', 'consum', 0.0336, 'lps'),
	(664761, 136, '2015-01-15 00:27:07.000000', 'consum', 0.0324, 'lps'),
	(664762, 136, '2015-01-15 00:27:08.000000', 'consum', 0.0256, 'lps'),
	(664763, 136, '2015-01-15 00:27:09.000000', 'consum', 0.0246, 'lps'),
	(664764, 136, '2015-01-15 00:27:10.000000', 'consum', 0.0250, 'lps'),
	(664765, 136, '2015-01-15 00:27:11.000000', 'consum', 0.0305, 'lps'),
	(664766, 136, '2015-01-15 00:27:12.000000', 'consum', 0.0270, 'lps'),
	(664767, 136, '2015-01-15 00:27:13.000000', 'consum', 0.0226, 'lps'),
	(664768, 136, '2015-01-15 00:27:14.000000', 'consum', 0.0259, 'lps'),
	(664769, 136, '2015-01-15 00:27:15.000000', 'consum', 0.0259, 'lps'),
	(664770, 136, '2015-01-15 00:27:16.000000', 'consum', 0.0309, 'lps'),
	(664771, 136, '2015-01-15 00:27:17.000000', 'consum', 0.0265, 'lps'),
	(664772, 136, '2015-01-15 00:27:18.000000', 'consum', 0.0337, 'lps'),
	(664773, 136, '2015-01-15 00:27:19.000000', 'consum', 0.0239, 'lps'),
	(664774, 136, '2015-01-15 00:27:20.000000', 'consum', 0.0266, 'lps'),
	(664775, 136, '2015-01-15 00:27:21.000000', 'consum', 0.0259, 'lps'),
	(664776, 136, '2015-01-15 00:27:22.000000', 'consum', 0.0289, 'lps'),
	(664777, 136, '2015-01-15 00:27:23.000000', 'consum', 0.0308, 'lps'),
	(664778, 136, '2015-01-15 00:27:24.000000', 'consum', 0.0319, 'lps'),
	(664779, 136, '2015-01-15 00:27:25.000000', 'consum', 0.0314, 'lps'),
	(664780, 136, '2015-01-15 00:27:26.000000', 'consum', 0.0255, 'lps'),
	(664781, 136, '2015-01-15 00:27:27.000000', 'consum', 0.0273, 'lps'),
	(664782, 136, '2015-01-15 00:27:28.000000', 'consum', 0.0242, 'lps'),
	(664783, 136, '2015-01-15 00:27:29.000000', 'consum', 0.0327, 'lps'),
	(664784, 136, '2015-01-15 00:27:30.000000', 'consum', 0.0261, 'lps'),
	(664785, 136, '2015-01-15 00:27:31.000000', 'consum', 0.0261, 'lps'),
	(664786, 136, '2015-01-15 00:27:32.000000', 'consum', 0.0311, 'lps'),
	(664787, 136, '2015-01-15 00:27:33.000000', 'consum', 0.0271, 'lps'),
	(664788, 136, '2015-01-15 00:27:34.000000', 'consum', 0.0213, 'lps'),
	(664789, 136, '2015-01-15 00:27:35.000000', 'consum', 0.0335, 'lps'),
	(664790, 136, '2015-01-15 00:27:36.000000', 'consum', 0.0238, 'lps'),
	(664791, 136, '2015-01-15 00:27:37.000000', 'consum', 0.0268, 'lps'),
	(664792, 136, '2015-01-15 00:27:38.000000', 'consum', 0.0272, 'lps'),
	(664793, 136, '2015-01-15 00:27:39.000000', 'consum', 0.0346, 'lps'),
	(664794, 136, '2015-01-15 00:27:40.000000', 'consum', 0.0265, 'lps'),
	(664795, 136, '2015-01-15 00:27:41.000000', 'consum', 0.0224, 'lps'),
	(664796, 136, '2015-01-15 00:27:42.000000', 'consum', 0.0261, 'lps'),
	(664797, 136, '2015-01-15 00:27:43.000000', 'consum', 0.0276, 'lps'),
	(664798, 136, '2015-01-15 00:27:44.000000', 'consum', 0.0243, 'lps'),
	(664799, 136, '2015-01-15 00:27:45.000000', 'consum', 0.0325, 'lps'),
	(664800, 136, '2015-01-15 00:27:46.000000', 'consum', 0.0244, 'lps'),
	(664801, 136, '2015-01-15 00:27:47.000000', 'consum', 0.0330, 'lps'),
	(664802, 136, '2015-01-15 00:27:48.000000', 'consum', 0.0267, 'lps'),
	(664803, 136, '2015-01-15 00:27:49.000000', 'consum', 0.0285, 'lps'),
	(664804, 136, '2015-01-15 00:27:50.000000', 'consum', 0.0265, 'lps'),
	(664805, 136, '2015-01-15 00:27:51.000000', 'consum', 0.0262, 'lps'),
	(664806, 136, '2015-01-15 00:27:52.000000', 'consum', 0.0305, 'lps'),
	(664807, 136, '2015-01-15 00:27:53.000000', 'consum', 0.0237, 'lps'),
	(664808, 136, '2015-01-15 00:27:54.000000', 'consum', 0.0354, 'lps'),
	(664809, 136, '2015-01-15 00:27:55.000000', 'consum', 0.0260, 'lps'),
	(664810, 136, '2015-01-15 00:27:56.000000', 'consum', 0.0323, 'lps'),
	(664811, 136, '2015-01-15 00:27:57.000000', 'consum', 0.0332, 'lps'),
	(664812, 136, '2015-01-15 00:27:58.000000', 'consum', 0.0333, 'lps'),
	(664813, 136, '2015-01-15 00:27:59.000000', 'consum', 0.0313, 'lps'),
	(664814, 136, '2015-01-15 00:28:00.000000', 'consum', 0.0355, 'lps'),
	(664815, 136, '2015-01-15 00:28:01.000000', 'consum', 0.0333, 'lps'),
	(664816, 136, '2015-01-15 00:28:02.000000', 'consum', 0.0246, 'lps'),
	(664817, 136, '2015-01-15 00:28:03.000000', 'consum', 0.0313, 'lps'),
	(664818, 136, '2015-01-15 00:28:04.000000', 'consum', 0.0324, 'lps'),
	(664819, 136, '2015-01-15 00:28:05.000000', 'consum', 0.0326, 'lps'),
	(664820, 136, '2015-01-15 00:28:06.000000', 'consum', 0.0302, 'lps'),
	(664821, 136, '2015-01-15 00:28:07.000000', 'consum', 0.0320, 'lps'),
	(664822, 136, '2015-01-15 00:28:08.000000', 'consum', 0.0340, 'lps'),
	(664823, 136, '2015-01-15 00:28:09.000000', 'consum', 0.0235, 'lps'),
	(664824, 136, '2015-01-15 00:28:10.000000', 'consum', 0.0239, 'lps'),
	(664825, 136, '2015-01-15 00:28:11.000000', 'consum', 0.0279, 'lps'),
	(664826, 136, '2015-01-15 00:28:12.000000', 'consum', 0.0325, 'lps'),
	(664827, 136, '2015-01-15 00:28:13.000000', 'consum', 0.0281, 'lps'),
	(664828, 136, '2015-01-15 00:28:14.000000', 'consum', 0.0224, 'lps'),
	(664829, 136, '2015-01-15 00:28:15.000000', 'consum', 0.0212, 'lps'),
	(664830, 136, '2015-01-15 00:28:16.000000', 'consum', 0.0325, 'lps'),
	(664831, 136, '2015-01-15 00:28:17.000000', 'consum', 0.0340, 'lps'),
	(664832, 136, '2015-01-15 00:28:18.000000', 'consum', 0.0222, 'lps'),
	(664833, 136, '2015-01-15 00:28:19.000000', 'consum', 0.0319, 'lps'),
	(664834, 136, '2015-01-15 00:28:20.000000', 'consum', 0.0281, 'lps'),
	(664835, 136, '2015-01-15 00:28:21.000000', 'consum', 0.0237, 'lps'),
	(664836, 136, '2015-01-15 00:28:22.000000', 'consum', 0.0281, 'lps'),
	(664837, 136, '2015-01-15 00:28:23.000000', 'consum', 0.0336, 'lps'),
	(664838, 136, '2015-01-15 00:28:24.000000', 'consum', 0.0335, 'lps'),
	(664839, 136, '2015-01-15 00:28:25.000000', 'consum', 0.0311, 'lps'),
	(664840, 136, '2015-01-15 00:28:26.000000', 'consum', 0.0340, 'lps'),
	(664841, 136, '2015-01-15 00:28:27.000000', 'consum', 0.0265, 'lps'),
	(664842, 136, '2015-01-15 00:28:28.000000', 'consum', 0.0242, 'lps'),
	(664843, 136, '2015-01-15 00:28:29.000000', 'consum', 0.0350, 'lps'),
	(664844, 136, '2015-01-15 00:28:30.000000', 'consum', 0.0229, 'lps'),
	(664845, 136, '2015-01-15 00:28:31.000000', 'consum', 0.0327, 'lps'),
	(664846, 136, '2015-01-15 00:28:32.000000', 'consum', 0.0297, 'lps'),
	(664847, 136, '2015-01-15 00:28:33.000000', 'consum', 0.0295, 'lps'),
	(664848, 136, '2015-01-15 00:28:34.000000', 'consum', 0.0226, 'lps'),
	(664849, 136, '2015-01-15 00:28:35.000000', 'consum', 0.0332, 'lps'),
	(664850, 136, '2015-01-15 00:28:36.000000', 'consum', 0.0329, 'lps'),
	(664851, 136, '2015-01-15 00:28:37.000000', 'consum', 0.0294, 'lps'),
	(664852, 136, '2015-01-15 00:28:38.000000', 'consum', 0.0275, 'lps'),
	(664853, 136, '2015-01-15 00:28:39.000000', 'consum', 0.0282, 'lps'),
	(664854, 136, '2015-01-15 00:28:40.000000', 'consum', 0.0227, 'lps'),
	(664855, 136, '2015-01-15 00:28:41.000000', 'consum', 0.0230, 'lps'),
	(664856, 136, '2015-01-15 00:28:42.000000', 'consum', 0.0256, 'lps'),
	(664857, 136, '2015-01-15 00:28:43.000000', 'consum', 0.0235, 'lps'),
	(664858, 136, '2015-01-15 00:28:44.000000', 'consum', 0.0344, 'lps'),
	(664859, 136, '2015-01-15 00:28:45.000000', 'consum', 0.0216, 'lps'),
	(664860, 136, '2015-01-15 00:28:46.000000', 'consum', 0.0281, 'lps'),
	(664861, 136, '2015-01-15 00:28:47.000000', 'consum', 0.0251, 'lps'),
	(664862, 136, '2015-01-15 00:28:48.000000', 'consum', 0.0352, 'lps'),
	(664863, 136, '2015-01-15 00:28:49.000000', 'consum', 0.0356, 'lps'),
	(664864, 136, '2015-01-15 00:28:50.000000', 'consum', 0.0220, 'lps'),
	(664865, 136, '2015-01-15 00:28:51.000000', 'consum', 0.0263, 'lps'),
	(664866, 136, '2015-01-15 00:28:52.000000', 'consum', 0.0299, 'lps'),
	(664867, 136, '2015-01-15 00:28:53.000000', 'consum', 0.0350, 'lps'),
	(664868, 136, '2015-01-15 00:28:54.000000', 'consum', 0.0351, 'lps'),
	(664869, 136, '2015-01-15 00:28:55.000000', 'consum', 0.0346, 'lps'),
	(664870, 136, '2015-01-15 00:28:56.000000', 'consum', 0.0319, 'lps'),
	(664871, 136, '2015-01-15 00:28:57.000000', 'consum', 0.0351, 'lps'),
	(664872, 136, '2015-01-15 00:28:58.000000', 'consum', 0.0294, 'lps'),
	(664873, 136, '2015-01-15 00:28:59.000000', 'consum', 0.0354, 'lps'),
	(664874, 136, '2015-01-15 00:29:00.000000', 'consum', 0.0237, 'lps'),
	(664875, 136, '2015-01-15 00:29:01.000000', 'consum', 0.0355, 'lps'),
	(664876, 136, '2015-01-15 00:29:02.000000', 'consum', 0.0265, 'lps'),
	(664877, 136, '2015-01-15 00:29:03.000000', 'consum', 0.0345, 'lps'),
	(664878, 136, '2015-01-15 00:29:04.000000', 'consum', 0.0280, 'lps'),
	(664879, 136, '2015-01-15 00:29:05.000000', 'consum', 0.0304, 'lps'),
	(664880, 136, '2015-01-15 00:29:06.000000', 'consum', 0.0324, 'lps'),
	(664881, 136, '2015-01-15 00:29:07.000000', 'consum', 0.0349, 'lps'),
	(664882, 136, '2015-01-15 00:29:08.000000', 'consum', 0.0272, 'lps'),
	(664883, 136, '2015-01-15 00:29:09.000000', 'consum', 0.0250, 'lps'),
	(664884, 136, '2015-01-15 00:29:10.000000', 'consum', 0.0223, 'lps'),
	(664885, 136, '2015-01-15 00:29:11.000000', 'consum', 0.0302, 'lps'),
	(664886, 136, '2015-01-15 00:29:12.000000', 'consum', 0.0340, 'lps'),
	(664887, 136, '2015-01-15 00:29:13.000000', 'consum', 0.0291, 'lps'),
	(664888, 136, '2015-01-15 00:29:14.000000', 'consum', 0.0223, 'lps'),
	(664889, 136, '2015-01-15 00:29:15.000000', 'consum', 0.0328, 'lps'),
	(664890, 136, '2015-01-15 00:29:16.000000', 'consum', 0.0321, 'lps'),
	(664891, 136, '2015-01-15 00:29:17.000000', 'consum', 0.0264, 'lps'),
	(664892, 136, '2015-01-15 00:29:18.000000', 'consum', 0.0295, 'lps'),
	(664893, 136, '2015-01-15 00:29:19.000000', 'consum', 0.0327, 'lps'),
	(664894, 136, '2015-01-15 00:29:20.000000', 'consum', 0.0247, 'lps'),
	(664895, 136, '2015-01-15 00:29:21.000000', 'consum', 0.0336, 'lps'),
	(664896, 136, '2015-01-15 00:29:22.000000', 'consum', 0.0290, 'lps'),
	(664897, 136, '2015-01-15 00:29:23.000000', 'consum', 0.0233, 'lps'),
	(664898, 136, '2015-01-15 00:29:24.000000', 'consum', 0.0233, 'lps'),
	(664899, 136, '2015-01-15 00:29:25.000000', 'consum', 0.0256, 'lps'),
	(664900, 136, '2015-01-15 00:29:26.000000', 'consum', 0.0222, 'lps'),
	(664901, 136, '2015-01-15 00:29:27.000000', 'consum', 0.0283, 'lps'),
	(664902, 136, '2015-01-15 00:29:28.000000', 'consum', 0.0243, 'lps'),
	(664903, 136, '2015-01-15 00:29:29.000000', 'consum', 0.0304, 'lps'),
	(664904, 136, '2015-01-15 00:29:30.000000', 'consum', 0.0287, 'lps'),
	(664905, 136, '2015-01-15 00:29:31.000000', 'consum', 0.0315, 'lps'),
	(664906, 136, '2015-01-15 00:29:32.000000', 'consum', 0.0356, 'lps'),
	(664907, 136, '2015-01-15 00:29:33.000000', 'consum', 0.0332, 'lps'),
	(664908, 136, '2015-01-15 00:29:34.000000', 'consum', 0.0234, 'lps'),
	(664909, 136, '2015-01-15 00:29:35.000000', 'consum', 0.0258, 'lps'),
	(664910, 136, '2015-01-15 00:29:36.000000', 'consum', 0.0231, 'lps'),
	(664911, 136, '2015-01-15 00:29:37.000000', 'consum', 0.0322, 'lps'),
	(664912, 136, '2015-01-15 00:29:38.000000', 'consum', 0.0263, 'lps'),
	(664913, 136, '2015-01-15 00:29:39.000000', 'consum', 0.0287, 'lps'),
	(664914, 136, '2015-01-15 00:29:40.000000', 'consum', 0.0290, 'lps'),
	(664915, 136, '2015-01-15 00:29:41.000000', 'consum', 0.0234, 'lps'),
	(664916, 136, '2015-01-15 00:29:42.000000', 'consum', 0.0238, 'lps'),
	(664917, 136, '2015-01-15 00:29:43.000000', 'consum', 0.0278, 'lps'),
	(664918, 136, '2015-01-15 00:29:44.000000', 'consum', 0.0321, 'lps'),
	(664919, 136, '2015-01-15 00:29:45.000000', 'consum', 0.0265, 'lps'),
	(664920, 136, '2015-01-15 00:29:46.000000', 'consum', 0.0298, 'lps'),
	(664921, 136, '2015-01-15 00:29:47.000000', 'consum', 0.0341, 'lps'),
	(664922, 136, '2015-01-15 00:29:48.000000', 'consum', 0.0308, 'lps'),
	(664923, 136, '2015-01-15 00:29:49.000000', 'consum', 0.0308, 'lps'),
	(664924, 136, '2015-01-15 00:29:50.000000', 'consum', 0.0256, 'lps'),
	(664925, 136, '2015-01-15 00:29:51.000000', 'consum', 0.0297, 'lps'),
	(664926, 136, '2015-01-15 00:29:52.000000', 'consum', 0.0214, 'lps'),
	(664927, 136, '2015-01-15 00:29:53.000000', 'consum', 0.0263, 'lps'),
	(664928, 136, '2015-01-15 00:29:54.000000', 'consum', 0.0316, 'lps'),
	(664929, 136, '2015-01-15 00:29:55.000000', 'consum', 0.0290, 'lps'),
	(664930, 136, '2015-01-15 00:29:56.000000', 'consum', 0.0289, 'lps'),
	(664931, 136, '2015-01-15 00:29:57.000000', 'consum', 0.0220, 'lps'),
	(664932, 136, '2015-01-15 00:29:58.000000', 'consum', 0.0319, 'lps'),
	(664933, 136, '2015-01-15 00:29:59.000000', 'consum', 0.0283, 'lps'),
	(664934, 136, '2015-01-15 00:30:00.000000', 'consum', 0.0250, 'lps'),
	(664935, 136, '2015-01-15 00:30:01.000000', 'consum', 0.0339, 'lps'),
	(664936, 136, '2015-01-15 00:30:02.000000', 'consum', 0.0293, 'lps'),
	(664937, 136, '2015-01-15 00:30:03.000000', 'consum', 0.0239, 'lps'),
	(664938, 136, '2015-01-15 00:30:04.000000', 'consum', 0.0255, 'lps'),
	(664939, 136, '2015-01-15 00:30:05.000000', 'consum', 0.0347, 'lps'),
	(664940, 136, '2015-01-15 00:30:06.000000', 'consum', 0.0321, 'lps'),
	(664941, 136, '2015-01-15 00:30:07.000000', 'consum', 0.0352, 'lps'),
	(664942, 136, '2015-01-15 00:30:08.000000', 'consum', 0.0296, 'lps'),
	(664943, 136, '2015-01-15 00:30:09.000000', 'consum', 0.0212, 'lps'),
	(664944, 136, '2015-01-15 00:30:10.000000', 'consum', 0.0259, 'lps'),
	(664945, 136, '2015-01-15 00:30:11.000000', 'consum', 0.0300, 'lps'),
	(664946, 136, '2015-01-15 00:30:12.000000', 'consum', 0.0220, 'lps'),
	(664947, 136, '2015-01-15 00:30:13.000000', 'consum', 0.0284, 'lps'),
	(664948, 136, '2015-01-15 00:30:14.000000', 'consum', 0.0256, 'lps'),
	(664949, 136, '2015-01-15 00:30:15.000000', 'consum', 0.0221, 'lps'),
	(664950, 136, '2015-01-15 00:30:16.000000', 'consum', 0.0272, 'lps'),
	(664951, 136, '2015-01-15 00:30:17.000000', 'consum', 0.0340, 'lps'),
	(664952, 136, '2015-01-15 00:30:18.000000', 'consum', 0.0235, 'lps'),
	(664953, 136, '2015-01-15 00:30:19.000000', 'consum', 0.0240, 'lps'),
	(664954, 136, '2015-01-15 00:30:20.000000', 'consum', 0.0284, 'lps'),
	(664955, 136, '2015-01-15 00:30:21.000000', 'consum', 0.0344, 'lps'),
	(664956, 136, '2015-01-15 00:30:22.000000', 'consum', 0.0220, 'lps'),
	(664957, 136, '2015-01-15 00:30:23.000000', 'consum', 0.0296, 'lps'),
	(664958, 136, '2015-01-15 00:30:24.000000', 'consum', 0.0320, 'lps'),
	(664959, 136, '2015-01-15 00:30:25.000000', 'consum', 0.0353, 'lps'),
	(664960, 136, '2015-01-15 00:30:26.000000', 'consum', 0.0300, 'lps'),
	(664961, 136, '2015-01-15 00:30:27.000000', 'consum', 0.0234, 'lps'),
	(664962, 136, '2015-01-15 00:30:28.000000', 'consum', 0.0354, 'lps'),
	(664963, 136, '2015-01-15 00:30:29.000000', 'consum', 0.0272, 'lps'),
	(664964, 136, '2015-01-15 00:30:30.000000', 'consum', 0.0233, 'lps'),
	(664965, 136, '2015-01-15 00:30:31.000000', 'consum', 0.0287, 'lps'),
	(664966, 136, '2015-01-15 00:30:32.000000', 'consum', 0.0232, 'lps'),
	(664967, 136, '2015-01-15 00:30:33.000000', 'consum', 0.0238, 'lps'),
	(664968, 136, '2015-01-15 00:30:34.000000', 'consum', 0.0285, 'lps'),
	(664969, 136, '2015-01-15 00:30:35.000000', 'consum', 0.0352, 'lps'),
	(664970, 136, '2015-01-15 00:30:36.000000', 'consum', 0.0255, 'lps'),
	(664971, 136, '2015-01-15 00:30:37.000000', 'consum', 0.0306, 'lps'),
	(664972, 136, '2015-01-15 00:30:38.000000', 'consum', 0.0258, 'lps'),
	(664973, 136, '2015-01-15 00:30:39.000000', 'consum', 0.0312, 'lps'),
	(664974, 136, '2015-01-15 00:30:40.000000', 'consum', 0.0283, 'lps'),
	(664975, 136, '2015-01-15 00:30:41.000000', 'consum', 0.0268, 'lps'),
	(664976, 136, '2015-01-15 00:30:42.000000', 'consum', 0.0282, 'lps'),
	(664977, 136, '2015-01-15 00:30:43.000000', 'consum', 0.0248, 'lps'),
	(664978, 136, '2015-01-15 00:30:44.000000', 'consum', 0.0331, 'lps'),
	(664979, 136, '2015-01-15 00:30:45.000000', 'consum', 0.0260, 'lps'),
	(664980, 136, '2015-01-15 00:30:46.000000', 'consum', 0.0246, 'lps'),
	(664981, 136, '2015-01-15 00:30:47.000000', 'consum', 0.0239, 'lps'),
	(664982, 136, '2015-01-15 00:30:48.000000', 'consum', 0.0248, 'lps'),
	(664983, 136, '2015-01-15 00:30:49.000000', 'consum', 0.0313, 'lps'),
	(664984, 136, '2015-01-15 00:30:50.000000', 'consum', 0.0319, 'lps'),
	(664985, 136, '2015-01-15 00:30:51.000000', 'consum', 0.0300, 'lps'),
	(664986, 136, '2015-01-15 00:30:52.000000', 'consum', 0.0331, 'lps'),
	(664987, 136, '2015-01-15 00:30:53.000000', 'consum', 0.0252, 'lps'),
	(664988, 136, '2015-01-15 00:30:54.000000', 'consum', 0.0351, 'lps'),
	(664989, 136, '2015-01-15 00:30:55.000000', 'consum', 0.0350, 'lps'),
	(664990, 136, '2015-01-15 00:30:56.000000', 'consum', 0.0340, 'lps'),
	(664991, 136, '2015-01-15 00:30:57.000000', 'consum', 0.0295, 'lps'),
	(664992, 136, '2015-01-15 00:30:58.000000', 'consum', 0.0247, 'lps'),
	(664993, 136, '2015-01-15 00:30:59.000000', 'consum', 0.0284, 'lps'),
	(664994, 136, '2015-01-15 00:31:00.000000', 'consum', 0.0322, 'lps'),
	(664995, 136, '2015-01-15 00:31:01.000000', 'consum', 0.0257, 'lps'),
	(664996, 136, '2015-01-15 00:31:02.000000', 'consum', 0.0254, 'lps'),
	(664997, 136, '2015-01-15 00:31:03.000000', 'consum', 0.0290, 'lps'),
	(664998, 136, '2015-01-15 00:31:04.000000', 'consum', 0.0332, 'lps'),
	(664999, 136, '2015-01-15 00:31:05.000000', 'consum', 0.0286, 'lps'),
	(665000, 136, '2015-01-15 00:31:06.000000', 'consum', 0.0226, 'lps'),
	(665001, 136, '2015-01-15 00:31:07.000000', 'consum', 0.0211, 'lps'),
	(665002, 136, '2015-01-15 00:31:08.000000', 'consum', 0.0312, 'lps'),
	(665003, 136, '2015-01-15 00:31:09.000000', 'consum', 0.0278, 'lps'),
	(665004, 136, '2015-01-15 00:31:10.000000', 'consum', 0.0242, 'lps'),
	(665005, 136, '2015-01-15 00:31:11.000000', 'consum', 0.0314, 'lps'),
	(665006, 136, '2015-01-15 00:31:12.000000', 'consum', 0.0340, 'lps'),
	(665007, 136, '2015-01-15 00:31:13.000000', 'consum', 0.0256, 'lps'),
	(665008, 136, '2015-01-15 00:31:14.000000', 'consum', 0.0345, 'lps'),
	(665009, 136, '2015-01-15 00:31:15.000000', 'consum', 0.0307, 'lps'),
	(665010, 136, '2015-01-15 00:31:16.000000', 'consum', 0.0289, 'lps'),
	(665011, 136, '2015-01-15 00:31:17.000000', 'consum', 0.0315, 'lps'),
	(665012, 136, '2015-01-15 00:31:18.000000', 'consum', 0.0350, 'lps'),
	(665013, 136, '2015-01-15 00:31:19.000000', 'consum', 0.0301, 'lps'),
	(665014, 136, '2015-01-15 00:31:20.000000', 'consum', 0.0248, 'lps'),
	(665015, 136, '2015-01-15 00:31:21.000000', 'consum', 0.0272, 'lps'),
	(665016, 136, '2015-01-15 00:31:22.000000', 'consum', 0.0261, 'lps'),
	(665017, 136, '2015-01-15 00:31:23.000000', 'consum', 0.0277, 'lps'),
	(665018, 136, '2015-01-15 00:31:24.000000', 'consum', 0.0248, 'lps'),
	(665019, 136, '2015-01-15 00:31:25.000000', 'consum', 0.0348, 'lps'),
	(665020, 136, '2015-01-15 00:31:26.000000', 'consum', 0.0344, 'lps'),
	(665021, 136, '2015-01-15 00:31:27.000000', 'consum', 0.0317, 'lps'),
	(665022, 136, '2015-01-15 00:31:28.000000', 'consum', 0.0347, 'lps'),
	(665023, 136, '2015-01-15 00:31:29.000000', 'consum', 0.0278, 'lps'),
	(665024, 136, '2015-01-15 00:31:30.000000', 'consum', 0.0287, 'lps'),
	(665025, 136, '2015-01-15 00:31:31.000000', 'consum', 0.0245, 'lps'),
	(665026, 136, '2015-01-15 00:31:32.000000', 'consum', 0.0301, 'lps'),
	(665027, 136, '2015-01-15 00:31:33.000000', 'consum', 0.0265, 'lps'),
	(665028, 136, '2015-01-15 00:31:34.000000', 'consum', 0.0215, 'lps'),
	(665029, 136, '2015-01-15 00:31:35.000000', 'consum', 0.0217, 'lps'),
	(665030, 136, '2015-01-15 00:31:36.000000', 'consum', 0.0229, 'lps'),
	(665031, 136, '2015-01-15 00:31:37.000000', 'consum', 0.0286, 'lps'),
	(665032, 136, '2015-01-15 00:31:38.000000', 'consum', 0.0238, 'lps'),
	(665033, 136, '2015-01-15 00:31:39.000000', 'consum', 0.0271, 'lps'),
	(665034, 136, '2015-01-15 00:31:40.000000', 'consum', 0.0286, 'lps'),
	(665035, 136, '2015-01-15 00:31:41.000000', 'consum', 0.0258, 'lps'),
	(665036, 136, '2015-01-15 00:31:42.000000', 'consum', 0.0225, 'lps'),
	(665037, 136, '2015-01-15 00:31:43.000000', 'consum', 0.0286, 'lps'),
	(665038, 136, '2015-01-15 00:31:44.000000', 'consum', 0.0251, 'lps'),
	(665039, 136, '2015-01-15 00:31:45.000000', 'consum', 0.0337, 'lps'),
	(665040, 136, '2015-01-15 00:31:46.000000', 'consum', 0.0282, 'lps'),
	(665041, 136, '2015-01-15 00:31:47.000000', 'consum', 0.0337, 'lps'),
	(665042, 136, '2015-01-15 00:31:48.000000', 'consum', 0.0337, 'lps'),
	(665043, 136, '2015-01-15 00:31:49.000000', 'consum', 0.0314, 'lps'),
	(665044, 136, '2015-01-15 00:31:50.000000', 'consum', 0.0349, 'lps'),
	(665045, 136, '2015-01-15 00:31:51.000000', 'consum', 0.0301, 'lps'),
	(665046, 136, '2015-01-15 00:31:52.000000', 'consum', 0.0250, 'lps'),
	(665047, 136, '2015-01-15 00:31:53.000000', 'consum', 0.0283, 'lps'),
	(665048, 136, '2015-01-15 00:31:54.000000', 'consum', 0.0309, 'lps'),
	(665049, 136, '2015-01-15 00:31:55.000000', 'consum', 0.0338, 'lps'),
	(665050, 136, '2015-01-15 00:31:56.000000', 'consum', 0.0261, 'lps'),
	(665051, 136, '2015-01-15 00:31:57.000000', 'consum', 0.0228, 'lps'),
	(665052, 136, '2015-01-15 00:31:58.000000', 'consum', 0.0295, 'lps'),
	(665053, 136, '2015-01-15 00:31:59.000000', 'consum', 0.0289, 'lps'),
	(665054, 136, '2015-01-15 00:32:00.000000', 'consum', 0.0347, 'lps'),
	(665055, 136, '2015-01-15 00:32:01.000000', 'consum', 0.0221, 'lps'),
	(665056, 136, '2015-01-15 00:32:02.000000', 'consum', 0.0292, 'lps'),
	(665057, 136, '2015-01-15 00:32:03.000000', 'consum', 0.0296, 'lps'),
	(665058, 136, '2015-01-15 00:32:04.000000', 'consum', 0.0247, 'lps'),
	(665059, 136, '2015-01-15 00:32:05.000000', 'consum', 0.0284, 'lps'),
	(665060, 136, '2015-01-15 00:32:06.000000', 'consum', 0.0322, 'lps'),
	(665061, 136, '2015-01-15 00:32:07.000000', 'consum', 0.0255, 'lps'),
	(665062, 136, '2015-01-15 00:32:08.000000', 'consum', 0.0247, 'lps'),
	(665063, 136, '2015-01-15 00:32:09.000000', 'consum', 0.0259, 'lps'),
	(665064, 136, '2015-01-15 00:32:10.000000', 'consum', 0.0345, 'lps'),
	(665065, 136, '2015-01-15 00:32:11.000000', 'consum', 0.0297, 'lps'),
	(665066, 136, '2015-01-15 00:32:12.000000', 'consum', 0.0243, 'lps'),
	(665067, 136, '2015-01-15 00:32:13.000000', 'consum', 0.0259, 'lps'),
	(665068, 136, '2015-01-15 00:32:14.000000', 'consum', 0.0212, 'lps'),
	(665069, 136, '2015-01-15 00:32:15.000000', 'consum', 0.0220, 'lps'),
	(665070, 136, '2015-01-15 00:32:16.000000', 'consum', 0.0255, 'lps'),
	(665071, 136, '2015-01-15 00:32:17.000000', 'consum', 0.0256, 'lps'),
	(665072, 136, '2015-01-15 00:32:18.000000', 'consum', 0.0307, 'lps'),
	(665073, 136, '2015-01-15 00:32:19.000000', 'consum', 0.0265, 'lps'),
	(665074, 136, '2015-01-15 00:32:20.000000', 'consum', 0.0342, 'lps'),
	(665075, 136, '2015-01-15 00:32:21.000000', 'consum', 0.0264, 'lps'),
	(665076, 136, '2015-01-15 00:32:22.000000', 'consum', 0.0233, 'lps'),
	(665077, 136, '2015-01-15 00:32:23.000000', 'consum', 0.0308, 'lps'),
	(665078, 136, '2015-01-15 00:32:24.000000', 'consum', 0.0339, 'lps'),
	(665079, 136, '2015-01-15 00:32:25.000000', 'consum', 0.0265, 'lps'),
	(665080, 136, '2015-01-15 00:32:26.000000', 'consum', 0.0248, 'lps'),
	(665081, 136, '2015-01-15 00:32:27.000000', 'consum', 0.0236, 'lps'),
	(665082, 136, '2015-01-15 00:32:28.000000', 'consum', 0.0224, 'lps'),
	(665083, 136, '2015-01-15 00:32:29.000000', 'consum', 0.0351, 'lps'),
	(665084, 136, '2015-01-15 00:32:30.000000', 'consum', 0.0287, 'lps'),
	(665085, 136, '2015-01-15 00:32:31.000000', 'consum', 0.0317, 'lps'),
	(665086, 136, '2015-01-15 00:32:32.000000', 'consum', 0.0220, 'lps'),
	(665087, 136, '2015-01-15 00:32:33.000000', 'consum', 0.0234, 'lps'),
	(665088, 136, '2015-01-15 00:32:34.000000', 'consum', 0.0299, 'lps'),
	(665089, 136, '2015-01-15 00:32:35.000000', 'consum', 0.0291, 'lps'),
	(665090, 136, '2015-01-15 00:32:36.000000', 'consum', 0.0348, 'lps'),
	(665091, 136, '2015-01-15 00:32:37.000000', 'consum', 0.0217, 'lps'),
	(665092, 136, '2015-01-15 00:32:38.000000', 'consum', 0.0270, 'lps'),
	(665093, 136, '2015-01-15 00:32:39.000000', 'consum', 0.0346, 'lps'),
	(665094, 136, '2015-01-15 00:32:40.000000', 'consum', 0.0268, 'lps'),
	(665095, 136, '2015-01-15 00:32:41.000000', 'consum', 0.0238, 'lps'),
	(665096, 136, '2015-01-15 00:32:42.000000', 'consum', 0.0324, 'lps'),
	(665097, 136, '2015-01-15 00:32:43.000000', 'consum', 0.0257, 'lps'),
	(665098, 136, '2015-01-15 00:32:44.000000', 'consum', 0.0249, 'lps'),
	(665099, 136, '2015-01-15 00:32:45.000000', 'consum', 0.0267, 'lps'),
	(665100, 136, '2015-01-15 00:32:46.000000', 'consum', 0.0229, 'lps'),
	(665101, 136, '2015-01-15 00:32:47.000000', 'consum', 0.0283, 'lps'),
	(665102, 136, '2015-01-15 00:32:48.000000', 'consum', 0.0223, 'lps'),
	(665103, 136, '2015-01-15 00:32:49.000000', 'consum', 0.0349, 'lps'),
	(665104, 136, '2015-01-15 00:32:50.000000', 'consum', 0.0281, 'lps'),
	(665105, 136, '2015-01-15 00:32:51.000000', 'consum', 0.0296, 'lps'),
	(665106, 136, '2015-01-15 00:32:52.000000', 'consum', 0.0278, 'lps'),
	(665107, 136, '2015-01-15 00:32:53.000000', 'consum', 0.0295, 'lps'),
	(665108, 136, '2015-01-15 00:32:54.000000', 'consum', 0.0284, 'lps'),
	(665109, 136, '2015-01-15 00:32:55.000000', 'consum', 0.0324, 'lps'),
	(665110, 136, '2015-01-15 00:32:56.000000', 'consum', 0.0264, 'lps'),
	(665111, 136, '2015-01-15 00:32:57.000000', 'consum', 0.0288, 'lps'),
	(665112, 136, '2015-01-15 00:32:58.000000', 'consum', 0.0290, 'lps'),
	(665113, 136, '2015-01-15 00:32:59.000000', 'consum', 0.0228, 'lps'),
	(665114, 136, '2015-01-15 00:33:00.000000', 'consum', 0.0356, 'lps'),
	(665115, 136, '2015-01-15 00:33:01.000000', 'consum', 0.0298, 'lps'),
	(665116, 136, '2015-01-15 00:33:02.000000', 'consum', 0.0213, 'lps'),
	(665117, 136, '2015-01-15 00:33:03.000000', 'consum', 0.0257, 'lps'),
	(665118, 136, '2015-01-15 00:33:04.000000', 'consum', 0.0287, 'lps'),
	(665119, 136, '2015-01-15 00:33:05.000000', 'consum', 0.0308, 'lps'),
	(665120, 136, '2015-01-15 00:33:06.000000', 'consum', 0.0325, 'lps'),
	(665121, 136, '2015-01-15 00:33:07.000000', 'consum', 0.0341, 'lps'),
	(665122, 136, '2015-01-15 00:33:08.000000', 'consum', 0.0229, 'lps'),
	(665123, 136, '2015-01-15 00:33:09.000000', 'consum', 0.0353, 'lps'),
	(665124, 136, '2015-01-15 00:33:10.000000', 'consum', 0.0279, 'lps'),
	(665125, 136, '2015-01-15 00:33:11.000000', 'consum', 0.0275, 'lps'),
	(665126, 136, '2015-01-15 00:33:12.000000', 'consum', 0.0330, 'lps'),
	(665127, 136, '2015-01-15 00:33:13.000000', 'consum', 0.0321, 'lps'),
	(665128, 136, '2015-01-15 00:33:14.000000', 'consum', 0.0258, 'lps'),
	(665129, 136, '2015-01-15 00:33:15.000000', 'consum', 0.0264, 'lps'),
	(665130, 136, '2015-01-15 00:33:16.000000', 'consum', 0.0338, 'lps'),
	(665131, 136, '2015-01-15 00:33:17.000000', 'consum', 0.0247, 'lps'),
	(665132, 136, '2015-01-15 00:33:18.000000', 'consum', 0.0306, 'lps'),
	(665133, 136, '2015-01-15 00:33:19.000000', 'consum', 0.0287, 'lps'),
	(665134, 136, '2015-01-15 00:33:20.000000', 'consum', 0.0305, 'lps'),
	(665135, 136, '2015-01-15 00:33:21.000000', 'consum', 0.0310, 'lps'),
	(665136, 136, '2015-01-15 00:33:22.000000', 'consum', 0.0278, 'lps'),
	(665137, 136, '2015-01-15 00:33:23.000000', 'consum', 0.0251, 'lps'),
	(665138, 136, '2015-01-15 00:33:24.000000', 'consum', 0.0356, 'lps'),
	(665139, 136, '2015-01-15 00:33:25.000000', 'consum', 0.0230, 'lps'),
	(665140, 136, '2015-01-15 00:33:26.000000', 'consum', 0.0312, 'lps'),
	(665141, 136, '2015-01-15 00:33:27.000000', 'consum', 0.0221, 'lps'),
	(665142, 136, '2015-01-15 00:33:28.000000', 'consum', 0.0254, 'lps'),
	(665143, 136, '2015-01-15 00:33:29.000000', 'consum', 0.0250, 'lps'),
	(665144, 136, '2015-01-15 00:33:30.000000', 'consum', 0.0279, 'lps'),
	(665145, 136, '2015-01-15 00:33:31.000000', 'consum', 0.0287, 'lps'),
	(665146, 136, '2015-01-15 00:33:32.000000', 'consum', 0.0241, 'lps'),
	(665147, 136, '2015-01-15 00:33:33.000000', 'consum', 0.0283, 'lps'),
	(665148, 136, '2015-01-15 00:33:34.000000', 'consum', 0.0337, 'lps'),
	(665149, 136, '2015-01-15 00:33:35.000000', 'consum', 0.0329, 'lps'),
	(665150, 136, '2015-01-15 00:33:36.000000', 'consum', 0.0280, 'lps'),
	(665151, 136, '2015-01-15 00:33:37.000000', 'consum', 0.0349, 'lps'),
	(665152, 136, '2015-01-15 00:33:38.000000', 'consum', 0.0256, 'lps'),
	(665153, 136, '2015-01-15 00:33:39.000000', 'consum', 0.0315, 'lps'),
	(665154, 136, '2015-01-15 00:33:40.000000', 'consum', 0.0304, 'lps'),
	(665155, 136, '2015-01-15 00:33:41.000000', 'consum', 0.0220, 'lps'),
	(665156, 136, '2015-01-15 00:33:42.000000', 'consum', 0.0271, 'lps'),
	(665157, 136, '2015-01-15 00:33:43.000000', 'consum', 0.0338, 'lps'),
	(665158, 136, '2015-01-15 00:33:44.000000', 'consum', 0.0227, 'lps'),
	(665159, 136, '2015-01-15 00:33:45.000000', 'consum', 0.0354, 'lps'),
	(665160, 136, '2015-01-15 00:33:46.000000', 'consum', 0.0290, 'lps'),
	(665161, 136, '2015-01-15 00:33:47.000000', 'consum', 0.0325, 'lps'),
	(665162, 136, '2015-01-15 00:33:48.000000', 'consum', 0.0251, 'lps'),
	(665163, 136, '2015-01-15 00:33:49.000000', 'consum', 0.0217, 'lps'),
	(665164, 136, '2015-01-15 00:33:50.000000', 'consum', 0.0269, 'lps'),
	(665165, 136, '2015-01-15 00:33:51.000000', 'consum', 0.0338, 'lps'),
	(665166, 136, '2015-01-15 00:33:52.000000', 'consum', 0.0232, 'lps'),
	(665167, 136, '2015-01-15 00:33:53.000000', 'consum', 0.0232, 'lps'),
	(665168, 136, '2015-01-15 00:33:54.000000', 'consum', 0.0254, 'lps'),
	(665169, 136, '2015-01-15 00:33:55.000000', 'consum', 0.0216, 'lps'),
	(665170, 136, '2015-01-15 00:33:56.000000', 'consum', 0.0256, 'lps'),
	(665171, 136, '2015-01-15 00:33:57.000000', 'consum', 0.0274, 'lps'),
	(665172, 136, '2015-01-15 00:33:58.000000', 'consum', 0.0246, 'lps'),
	(665173, 136, '2015-01-15 00:33:59.000000', 'consum', 0.0345, 'lps'),
	(665174, 136, '2015-01-15 00:34:00.000000', 'consum', 0.0338, 'lps'),
	(665175, 136, '2015-01-15 00:34:01.000000', 'consum', 0.0299, 'lps'),
	(665176, 136, '2015-01-15 00:34:02.000000', 'consum', 0.0269, 'lps'),
	(665177, 136, '2015-01-15 00:34:03.000000', 'consum', 0.0241, 'lps'),
	(665178, 136, '2015-01-15 00:34:04.000000', 'consum', 0.0334, 'lps'),
	(665179, 136, '2015-01-15 00:34:05.000000', 'consum', 0.0296, 'lps'),
	(665180, 136, '2015-01-15 00:34:06.000000', 'consum', 0.0269, 'lps'),
	(665181, 136, '2015-01-15 00:34:07.000000', 'consum', 0.0250, 'lps'),
	(665182, 136, '2015-01-15 00:34:08.000000', 'consum', 0.0231, 'lps'),
	(665183, 136, '2015-01-15 00:34:09.000000', 'consum', 0.0341, 'lps'),
	(665184, 136, '2015-01-15 00:34:10.000000', 'consum', 0.0216, 'lps'),
	(665185, 136, '2015-01-15 00:34:11.000000', 'consum', 0.0287, 'lps'),
	(665186, 136, '2015-01-15 00:34:12.000000', 'consum', 0.0284, 'lps'),
	(665187, 136, '2015-01-15 00:34:13.000000', 'consum', 0.0352, 'lps'),
	(665188, 136, '2015-01-15 00:34:14.000000', 'consum', 0.0254, 'lps'),
	(665189, 136, '2015-01-15 00:34:15.000000', 'consum', 0.0301, 'lps'),
	(665190, 136, '2015-01-15 00:34:16.000000', 'consum', 0.0238, 'lps'),
	(665191, 136, '2015-01-15 00:34:17.000000', 'consum', 0.0225, 'lps'),
	(665192, 136, '2015-01-15 00:34:18.000000', 'consum', 0.0350, 'lps'),
	(665193, 136, '2015-01-15 00:34:19.000000', 'consum', 0.0278, 'lps'),
	(665194, 136, '2015-01-15 00:34:20.000000', 'consum', 0.0276, 'lps'),
	(665195, 136, '2015-01-15 00:34:21.000000', 'consum', 0.0337, 'lps'),
	(665196, 136, '2015-01-15 00:34:22.000000', 'consum', 0.0352, 'lps'),
	(665197, 136, '2015-01-15 00:34:23.000000', 'consum', 0.0247, 'lps'),
	(665198, 136, '2015-01-15 00:34:24.000000', 'consum', 0.0265, 'lps'),
	(665199, 136, '2015-01-15 00:34:25.000000', 'consum', 0.0226, 'lps'),
	(665200, 136, '2015-01-15 00:34:26.000000', 'consum', 0.0271, 'lps'),
	(665201, 136, '2015-01-15 00:34:27.000000', 'consum', 0.0323, 'lps'),
	(665202, 136, '2015-01-15 00:34:28.000000', 'consum', 0.0298, 'lps'),
	(665203, 136, '2015-01-15 00:34:29.000000', 'consum', 0.0312, 'lps'),
	(665204, 136, '2015-01-15 00:34:30.000000', 'consum', 0.0310, 'lps'),
	(665205, 136, '2015-01-15 00:34:31.000000', 'consum', 0.0257, 'lps'),
	(665206, 136, '2015-01-15 00:34:32.000000', 'consum', 0.0290, 'lps'),
	(665207, 136, '2015-01-15 00:34:33.000000', 'consum', 0.0326, 'lps'),
	(665208, 136, '2015-01-15 00:34:34.000000', 'consum', 0.0255, 'lps'),
	(665209, 136, '2015-01-15 00:34:35.000000', 'consum', 0.0235, 'lps'),
	(665210, 136, '2015-01-15 00:34:36.000000', 'consum', 0.0347, 'lps'),
	(665211, 136, '2015-01-15 00:34:37.000000', 'consum', 0.0234, 'lps'),
	(665212, 136, '2015-01-15 00:34:38.000000', 'consum', 0.0212, 'lps'),
	(665213, 136, '2015-01-15 00:34:39.000000', 'consum', 0.0295, 'lps'),
	(665214, 136, '2015-01-15 00:34:40.000000', 'consum', 0.0335, 'lps'),
	(665215, 136, '2015-01-15 00:34:41.000000', 'consum', 0.0288, 'lps'),
	(665216, 136, '2015-01-15 00:34:42.000000', 'consum', 0.0224, 'lps'),
	(665217, 136, '2015-01-15 00:34:43.000000', 'consum', 0.0340, 'lps'),
	(665218, 136, '2015-01-15 00:34:44.000000', 'consum', 0.0230, 'lps'),
	(665219, 136, '2015-01-15 00:34:45.000000', 'consum', 0.0217, 'lps'),
	(665220, 136, '2015-01-15 00:34:46.000000', 'consum', 0.0332, 'lps'),
	(665221, 136, '2015-01-15 00:34:47.000000', 'consum', 0.0356, 'lps'),
	(665222, 136, '2015-01-15 00:34:48.000000', 'consum', 0.0282, 'lps'),
	(665223, 136, '2015-01-15 00:34:49.000000', 'consum', 0.0280, 'lps'),
	(665224, 136, '2015-01-15 00:34:50.000000', 'consum', 0.0345, 'lps'),
	(665225, 136, '2015-01-15 00:34:51.000000', 'consum', 0.0235, 'lps'),
	(665226, 136, '2015-01-15 00:34:52.000000', 'consum', 0.0222, 'lps'),
	(665227, 136, '2015-01-15 00:34:53.000000', 'consum', 0.0343, 'lps'),
	(665228, 136, '2015-01-15 00:34:54.000000', 'consum', 0.0252, 'lps'),
	(665229, 136, '2015-01-15 00:34:55.000000', 'consum', 0.0316, 'lps'),
	(665230, 136, '2015-01-15 00:34:56.000000', 'consum', 0.0322, 'lps'),
	(665231, 136, '2015-01-15 00:34:57.000000', 'consum', 0.0305, 'lps'),
	(665232, 136, '2015-01-15 00:34:58.000000', 'consum', 0.0349, 'lps'),
	(665233, 136, '2015-01-15 00:34:59.000000', 'consum', 0.0327, 'lps'),
	(665234, 136, '2015-01-15 00:35:00.000000', 'consum', 0.0230, 'lps'),
	(665235, 136, '2015-01-15 00:35:01.000000', 'consum', 0.0254, 'lps'),
	(665236, 136, '2015-01-15 00:35:02.000000', 'consum', 0.0225, 'lps'),
	(665237, 136, '2015-01-15 00:35:03.000000', 'consum', 0.0301, 'lps'),
	(665238, 136, '2015-01-15 00:35:04.000000', 'consum', 0.0324, 'lps'),
	(665239, 136, '2015-01-15 00:35:05.000000', 'consum', 0.0214, 'lps'),
	(665240, 136, '2015-01-15 00:35:06.000000', 'consum', 0.0332, 'lps'),
	(665241, 136, '2015-01-15 00:35:07.000000', 'consum', 0.0219, 'lps'),
	(665242, 136, '2015-01-15 00:35:08.000000', 'consum', 0.0329, 'lps'),
	(665243, 136, '2015-01-15 00:35:09.000000', 'consum', 0.0339, 'lps'),
	(665244, 136, '2015-01-15 00:35:10.000000', 'consum', 0.0352, 'lps'),
	(665245, 136, '2015-01-15 00:35:11.000000', 'consum', 0.0240, 'lps'),
	(665246, 136, '2015-01-15 00:35:12.000000', 'consum', 0.0229, 'lps'),
	(665247, 136, '2015-01-15 00:35:13.000000', 'consum', 0.0214, 'lps'),
	(665248, 136, '2015-01-15 00:35:14.000000', 'consum', 0.0320, 'lps'),
	(665249, 136, '2015-01-15 00:35:15.000000', 'consum', 0.0310, 'lps'),
	(665250, 136, '2015-01-15 00:35:16.000000', 'consum', 0.0231, 'lps'),
	(665251, 136, '2015-01-15 00:35:17.000000', 'consum', 0.0310, 'lps'),
	(665252, 136, '2015-01-15 00:35:18.000000', 'consum', 0.0354, 'lps'),
	(665253, 136, '2015-01-15 00:35:19.000000', 'consum', 0.0336, 'lps'),
	(665254, 136, '2015-01-15 00:35:20.000000', 'consum', 0.0261, 'lps'),
	(665255, 136, '2015-01-15 00:35:21.000000', 'consum', 0.0235, 'lps'),
	(665256, 136, '2015-01-15 00:35:22.000000', 'consum', 0.0330, 'lps'),
	(665257, 136, '2015-01-15 00:35:23.000000', 'consum', 0.0294, 'lps'),
	(665258, 136, '2015-01-15 00:35:24.000000', 'consum', 0.0270, 'lps'),
	(665259, 136, '2015-01-15 00:35:25.000000', 'consum', 0.0258, 'lps'),
	(665260, 136, '2015-01-15 00:35:26.000000', 'consum', 0.0270, 'lps'),
	(665261, 136, '2015-01-15 00:35:27.000000', 'consum', 0.0218, 'lps'),
	(665262, 136, '2015-01-15 00:35:28.000000', 'consum', 0.0221, 'lps'),
	(665263, 136, '2015-01-15 00:35:29.000000', 'consum', 0.0241, 'lps'),
	(665264, 136, '2015-01-15 00:35:30.000000', 'consum', 0.0330, 'lps'),
	(665265, 136, '2015-01-15 00:35:31.000000', 'consum', 0.0277, 'lps'),
	(665266, 136, '2015-01-15 00:35:32.000000', 'consum', 0.0334, 'lps'),
	(665267, 136, '2015-01-15 00:35:33.000000', 'consum', 0.0336, 'lps'),
	(665268, 136, '2015-01-15 00:35:34.000000', 'consum', 0.0320, 'lps'),
	(665269, 136, '2015-01-15 00:35:35.000000', 'consum', 0.0237, 'lps'),
	(665270, 136, '2015-01-15 00:35:36.000000', 'consum', 0.0309, 'lps'),
	(665271, 136, '2015-01-15 00:35:37.000000', 'consum', 0.0332, 'lps'),
	(665272, 136, '2015-01-15 00:35:38.000000', 'consum', 0.0228, 'lps'),
	(665273, 136, '2015-01-15 00:35:39.000000', 'consum', 0.0228, 'lps'),
	(665274, 136, '2015-01-15 00:35:40.000000', 'consum', 0.0246, 'lps'),
	(665275, 136, '2015-01-15 00:35:41.000000', 'consum', 0.0335, 'lps'),
	(665276, 136, '2015-01-15 00:35:42.000000', 'consum', 0.0290, 'lps'),
	(665277, 136, '2015-01-15 00:35:43.000000', 'consum', 0.0232, 'lps'),
	(665278, 136, '2015-01-15 00:35:44.000000', 'consum', 0.0230, 'lps'),
	(665279, 136, '2015-01-15 00:35:45.000000', 'consum', 0.0243, 'lps'),
	(665280, 136, '2015-01-15 00:35:46.000000', 'consum', 0.0318, 'lps'),
	(665281, 136, '2015-01-15 00:35:47.000000', 'consum', 0.0355, 'lps'),
	(665282, 136, '2015-01-15 00:35:48.000000', 'consum', 0.0319, 'lps'),
	(665283, 136, '2015-01-15 00:35:49.000000', 'consum', 0.0321, 'lps'),
	(665284, 136, '2015-01-15 00:35:50.000000', 'consum', 0.0292, 'lps'),
	(665285, 136, '2015-01-15 00:35:51.000000', 'consum', 0.0288, 'lps'),
	(665286, 136, '2015-01-15 00:35:52.000000', 'consum', 0.0353, 'lps'),
	(665287, 136, '2015-01-15 00:35:53.000000', 'consum', 0.0252, 'lps'),
	(665288, 136, '2015-01-15 00:35:54.000000', 'consum', 0.0286, 'lps'),
	(665289, 136, '2015-01-15 00:35:55.000000', 'consum', 0.0319, 'lps'),
	(665290, 136, '2015-01-15 00:35:56.000000', 'consum', 0.0231, 'lps'),
	(665291, 136, '2015-01-15 00:35:57.000000', 'consum', 0.0282, 'lps'),
	(665292, 136, '2015-01-15 00:35:58.000000', 'consum', 0.0213, 'lps'),
	(665293, 136, '2015-01-15 00:35:59.000000', 'consum', 0.0305, 'lps'),
	(665294, 136, '2015-01-15 00:36:00.000000', 'consum', 0.0237, 'lps'),
	(665295, 136, '2015-01-15 00:36:01.000000', 'consum', 0.0352, 'lps'),
	(665296, 136, '2015-01-15 00:36:02.000000', 'consum', 0.0254, 'lps'),
	(665297, 136, '2015-01-15 00:36:03.000000', 'consum', 0.0297, 'lps'),
	(665298, 136, '2015-01-15 00:36:04.000000', 'consum', 0.0221, 'lps'),
	(665299, 136, '2015-01-15 00:36:05.000000', 'consum', 0.0296, 'lps'),
	(665300, 136, '2015-01-15 00:36:06.000000', 'consum', 0.0313, 'lps'),
	(665301, 136, '2015-01-15 00:36:07.000000', 'consum', 0.0323, 'lps'),
	(665302, 136, '2015-01-15 00:36:08.000000', 'consum', 0.0317, 'lps'),
	(665303, 136, '2015-01-15 00:36:09.000000', 'consum', 0.0259, 'lps'),
	(665304, 136, '2015-01-15 00:36:10.000000', 'consum', 0.0281, 'lps'),
	(665305, 136, '2015-01-15 00:36:11.000000', 'consum', 0.0272, 'lps'),
	(665306, 136, '2015-01-15 00:36:12.000000', 'consum', 0.0307, 'lps'),
	(665307, 136, '2015-01-15 00:36:13.000000', 'consum', 0.0216, 'lps'),
	(665308, 136, '2015-01-15 00:36:14.000000', 'consum', 0.0243, 'lps'),
	(665309, 136, '2015-01-15 00:36:15.000000', 'consum', 0.0211, 'lps'),
	(665310, 136, '2015-01-15 00:36:16.000000', 'consum', 0.0263, 'lps'),
	(665311, 136, '2015-01-15 00:36:17.000000', 'consum', 0.0328, 'lps'),
	(665312, 136, '2015-01-15 00:36:18.000000', 'consum', 0.0344, 'lps'),
	(665313, 136, '2015-01-15 00:36:19.000000', 'consum', 0.0235, 'lps'),
	(665314, 136, '2015-01-15 00:36:20.000000', 'consum', 0.0225, 'lps'),
	(665315, 136, '2015-01-15 00:36:21.000000', 'consum', 0.0212, 'lps'),
	(665316, 136, '2015-01-15 00:36:22.000000', 'consum', 0.0321, 'lps'),
	(665317, 136, '2015-01-15 00:36:23.000000', 'consum', 0.0318, 'lps'),
	(665318, 136, '2015-01-15 00:36:24.000000', 'consum', 0.0270, 'lps'),
	(665319, 136, '2015-01-15 00:36:25.000000', 'consum', 0.0334, 'lps'),
	(665320, 136, '2015-01-15 00:36:26.000000', 'consum', 0.0211, 'lps'),
	(665321, 136, '2015-01-15 00:36:27.000000', 'consum', 0.0284, 'lps'),
	(665322, 136, '2015-01-15 00:36:28.000000', 'consum', 0.0283, 'lps'),
	(665323, 136, '2015-01-15 00:36:29.000000', 'consum', 0.0352, 'lps'),
	(665324, 136, '2015-01-15 00:36:30.000000', 'consum', 0.0263, 'lps'),
	(665325, 136, '2015-01-15 00:36:31.000000', 'consum', 0.0344, 'lps'),
	(665326, 136, '2015-01-15 00:36:32.000000', 'consum', 0.0279, 'lps'),
	(665327, 136, '2015-01-15 00:36:33.000000', 'consum', 0.0301, 'lps'),
	(665328, 136, '2015-01-15 00:36:34.000000', 'consum', 0.0310, 'lps'),
	(665329, 136, '2015-01-15 00:36:35.000000', 'consum', 0.0290, 'lps'),
	(665330, 136, '2015-01-15 00:36:36.000000', 'consum', 0.0312, 'lps'),
	(665331, 136, '2015-01-15 00:36:37.000000', 'consum', 0.0332, 'lps'),
	(665332, 136, '2015-01-15 00:36:38.000000', 'consum', 0.0223, 'lps'),
	(665333, 136, '2015-01-15 00:36:39.000000', 'consum', 0.0347, 'lps'),
	(665334, 136, '2015-01-15 00:36:40.000000', 'consum', 0.0271, 'lps'),
	(665335, 136, '2015-01-15 00:36:41.000000', 'consum', 0.0251, 'lps'),
	(665336, 136, '2015-01-15 00:36:42.000000', 'consum', 0.0232, 'lps'),
	(665337, 136, '2015-01-15 00:36:43.000000', 'consum', 0.0345, 'lps'),
	(665338, 136, '2015-01-15 00:36:44.000000', 'consum', 0.0233, 'lps'),
	(665339, 136, '2015-01-15 00:36:45.000000', 'consum', 0.0214, 'lps'),
	(665340, 136, '2015-01-15 00:36:46.000000', 'consum', 0.0308, 'lps'),
	(665341, 136, '2015-01-15 00:36:47.000000', 'consum', 0.0249, 'lps'),
	(665342, 136, '2015-01-15 00:36:48.000000', 'consum', 0.0259, 'lps'),
	(665343, 136, '2015-01-15 00:36:49.000000', 'consum', 0.0340, 'lps'),
	(665344, 136, '2015-01-15 00:36:50.000000', 'consum', 0.0269, 'lps'),
	(665345, 136, '2015-01-15 00:36:51.000000', 'consum', 0.0263, 'lps'),
	(665346, 136, '2015-01-15 00:36:52.000000', 'consum', 0.0301, 'lps'),
	(665347, 136, '2015-01-15 00:36:53.000000', 'consum', 0.0210, 'lps'),
	(665348, 136, '2015-01-15 00:36:54.000000', 'consum', 0.0234, 'lps'),
	(665349, 136, '2015-01-15 00:36:55.000000', 'consum', 0.0329, 'lps'),
	(665350, 136, '2015-01-15 00:36:56.000000', 'consum', 0.0294, 'lps'),
	(665351, 136, '2015-01-15 00:36:57.000000', 'consum', 0.0271, 'lps'),
	(665352, 136, '2015-01-15 00:36:58.000000', 'consum', 0.0263, 'lps'),
	(665353, 136, '2015-01-15 00:36:59.000000', 'consum', 0.0294, 'lps'),
	(665354, 136, '2015-01-15 00:37:00.000000', 'consum', 0.0326, 'lps'),
	(665355, 136, '2015-01-15 00:37:01.000000', 'consum', 0.0245, 'lps'),
	(665356, 136, '2015-01-15 00:37:02.000000', 'consum', 0.0329, 'lps'),
	(665357, 136, '2015-01-15 00:37:03.000000', 'consum', 0.0259, 'lps'),
	(665358, 136, '2015-01-15 00:37:04.000000', 'consum', 0.0246, 'lps'),
	(665359, 136, '2015-01-15 00:37:05.000000', 'consum', 0.0243, 'lps'),
	(665360, 136, '2015-01-15 00:37:06.000000', 'consum', 0.0266, 'lps'),
	(665361, 136, '2015-01-15 00:37:07.000000', 'consum', 0.0246, 'lps'),
	(665362, 136, '2015-01-15 00:37:08.000000', 'consum', 0.0224, 'lps'),
	(665363, 136, '2015-01-15 00:37:09.000000', 'consum', 0.0316, 'lps'),
	(665364, 136, '2015-01-15 00:37:10.000000', 'consum', 0.0261, 'lps'),
	(665365, 136, '2015-01-15 00:37:11.000000', 'consum', 0.0292, 'lps'),
	(665366, 136, '2015-01-15 00:37:12.000000', 'consum', 0.0321, 'lps'),
	(665367, 136, '2015-01-15 00:37:13.000000', 'consum', 0.0228, 'lps'),
	(665368, 136, '2015-01-15 00:37:14.000000', 'consum', 0.0258, 'lps'),
	(665369, 136, '2015-01-15 00:37:15.000000', 'consum', 0.0251, 'lps'),
	(665370, 136, '2015-01-15 00:37:16.000000', 'consum', 0.0273, 'lps'),
	(665371, 136, '2015-01-15 00:37:17.000000', 'consum', 0.0255, 'lps'),
	(665372, 136, '2015-01-15 00:37:18.000000', 'consum', 0.0248, 'lps'),
	(665373, 136, '2015-01-15 00:37:19.000000', 'consum', 0.0264, 'lps'),
	(665374, 136, '2015-01-15 00:37:20.000000', 'consum', 0.0219, 'lps'),
	(665375, 136, '2015-01-15 00:37:21.000000', 'consum', 0.0243, 'lps'),
	(665376, 136, '2015-01-15 00:37:22.000000', 'consum', 0.0347, 'lps'),
	(665377, 136, '2015-01-15 00:37:23.000000', 'consum', 0.0355, 'lps'),
	(665378, 136, '2015-01-15 00:37:24.000000', 'consum', 0.0229, 'lps'),
	(665379, 136, '2015-01-15 00:37:25.000000', 'consum', 0.0312, 'lps'),
	(665380, 136, '2015-01-15 00:37:26.000000', 'consum', 0.0223, 'lps'),
	(665381, 136, '2015-01-15 00:37:27.000000', 'consum', 0.0264, 'lps'),
	(665382, 136, '2015-01-15 00:37:28.000000', 'consum', 0.0293, 'lps'),
	(665383, 136, '2015-01-15 00:37:29.000000', 'consum', 0.0318, 'lps'),
	(665384, 136, '2015-01-15 00:37:30.000000', 'consum', 0.0355, 'lps'),
	(665385, 136, '2015-01-15 00:37:31.000000', 'consum', 0.0315, 'lps'),
	(665386, 136, '2015-01-15 00:37:32.000000', 'consum', 0.0303, 'lps'),
	(665387, 136, '2015-01-15 00:37:33.000000', 'consum', 0.0212, 'lps'),
	(665388, 136, '2015-01-15 00:37:34.000000', 'consum', 0.0237, 'lps'),
	(665389, 136, '2015-01-15 00:37:35.000000', 'consum', 0.0338, 'lps'),
	(665390, 136, '2015-01-15 00:37:36.000000', 'consum', 0.0328, 'lps'),
	(665391, 136, '2015-01-15 00:37:37.000000', 'consum', 0.0271, 'lps'),
	(665392, 136, '2015-01-15 00:37:38.000000', 'consum', 0.0309, 'lps'),
	(665393, 136, '2015-01-15 00:37:39.000000', 'consum', 0.0228, 'lps'),
	(665394, 136, '2015-01-15 00:37:40.000000', 'consum', 0.0298, 'lps'),
	(665395, 136, '2015-01-15 00:37:41.000000', 'consum', 0.0302, 'lps'),
	(665396, 136, '2015-01-15 00:37:42.000000', 'consum', 0.0259, 'lps'),
	(665397, 136, '2015-01-15 00:37:43.000000', 'consum', 0.0326, 'lps'),
	(665398, 136, '2015-01-15 00:37:44.000000', 'consum', 0.0350, 'lps'),
	(665399, 136, '2015-01-15 00:37:45.000000', 'consum', 0.0270, 'lps'),
	(665400, 136, '2015-01-15 00:37:46.000000', 'consum', 0.0235, 'lps'),
	(665401, 136, '2015-01-15 00:37:47.000000', 'consum', 0.0302, 'lps'),
	(665402, 136, '2015-01-15 00:37:48.000000', 'consum', 0.0304, 'lps'),
	(665403, 136, '2015-01-15 00:37:49.000000', 'consum', 0.0256, 'lps'),
	(665404, 136, '2015-01-15 00:37:50.000000', 'consum', 0.0306, 'lps'),
	(665405, 136, '2015-01-15 00:37:51.000000', 'consum', 0.0259, 'lps'),
	(665406, 136, '2015-01-15 00:37:52.000000', 'consum', 0.0313, 'lps'),
	(665407, 136, '2015-01-15 00:37:53.000000', 'consum', 0.0285, 'lps'),
	(665408, 136, '2015-01-15 00:37:54.000000', 'consum', 0.0275, 'lps'),
	(665409, 136, '2015-01-15 00:37:55.000000', 'consum', 0.0313, 'lps'),
	(665410, 136, '2015-01-15 00:37:56.000000', 'consum', 0.0234, 'lps'),
	(665411, 136, '2015-01-15 00:37:57.000000', 'consum', 0.0316, 'lps'),
	(665412, 136, '2015-01-15 00:37:58.000000', 'consum', 0.0227, 'lps'),
	(665413, 136, '2015-01-15 00:37:59.000000', 'consum', 0.0272, 'lps'),
	(665414, 136, '2015-01-15 00:38:00.000000', 'consum', 0.0323, 'lps'),
	(665415, 136, '2015-01-15 00:38:01.000000', 'consum', 0.0293, 'lps'),
	(665416, 136, '2015-01-15 00:38:02.000000', 'consum', 0.0290, 'lps'),
	(665417, 136, '2015-01-15 00:38:03.000000', 'consum', 0.0213, 'lps'),
	(665418, 136, '2015-01-15 00:38:04.000000', 'consum', 0.0280, 'lps'),
	(665419, 136, '2015-01-15 00:38:05.000000', 'consum', 0.0257, 'lps'),
	(665420, 136, '2015-01-15 00:38:06.000000', 'consum', 0.0237, 'lps'),
	(665421, 136, '2015-01-15 00:38:07.000000', 'consum', 0.0351, 'lps'),
	(665422, 136, '2015-01-15 00:38:08.000000', 'consum', 0.0245, 'lps'),
	(665423, 136, '2015-01-15 00:38:09.000000', 'consum', 0.0259, 'lps'),
	(665424, 136, '2015-01-15 00:38:10.000000', 'consum', 0.0348, 'lps'),
	(665425, 136, '2015-01-15 00:38:11.000000', 'consum', 0.0312, 'lps'),
	(665426, 136, '2015-01-15 00:38:12.000000', 'consum', 0.0307, 'lps'),
	(665427, 136, '2015-01-15 00:38:13.000000', 'consum', 0.0243, 'lps'),
	(665428, 136, '2015-01-15 00:38:14.000000', 'consum', 0.0233, 'lps'),
	(665429, 136, '2015-01-15 00:38:15.000000', 'consum', 0.0226, 'lps'),
	(665430, 136, '2015-01-15 00:38:16.000000', 'consum', 0.0222, 'lps'),
	(665431, 136, '2015-01-15 00:38:17.000000', 'consum', 0.0223, 'lps'),
	(665432, 136, '2015-01-15 00:38:18.000000', 'consum', 0.0237, 'lps'),
	(665433, 136, '2015-01-15 00:38:19.000000', 'consum', 0.0307, 'lps'),
	(665434, 136, '2015-01-15 00:38:20.000000', 'consum', 0.0319, 'lps'),
	(665435, 136, '2015-01-15 00:38:21.000000', 'consum', 0.0321, 'lps'),
	(665436, 136, '2015-01-15 00:38:22.000000', 'consum', 0.0288, 'lps'),
	(665437, 136, '2015-01-15 00:38:23.000000', 'consum', 0.0269, 'lps'),
	(665438, 136, '2015-01-15 00:38:24.000000', 'consum', 0.0272, 'lps'),
	(665439, 136, '2015-01-15 00:38:25.000000', 'consum', 0.0342, 'lps'),
	(665440, 136, '2015-01-15 00:38:26.000000', 'consum', 0.0245, 'lps'),
	(665441, 136, '2015-01-15 00:38:27.000000', 'consum', 0.0284, 'lps'),
	(665442, 136, '2015-01-15 00:38:28.000000', 'consum', 0.0329, 'lps'),
	(665443, 136, '2015-01-15 00:38:29.000000', 'consum', 0.0289, 'lps'),
	(665444, 136, '2015-01-15 00:38:30.000000', 'consum', 0.0248, 'lps'),
	(665445, 136, '2015-01-15 00:38:31.000000', 'consum', 0.0313, 'lps'),
	(665446, 136, '2015-01-15 00:38:32.000000', 'consum', 0.0314, 'lps'),
	(665447, 136, '2015-01-15 00:38:33.000000', 'consum', 0.0275, 'lps'),
	(665448, 136, '2015-01-15 00:38:34.000000', 'consum', 0.0224, 'lps'),
	(665449, 136, '2015-01-15 00:38:35.000000', 'consum', 0.0233, 'lps'),
	(665450, 136, '2015-01-15 00:38:36.000000', 'consum', 0.0284, 'lps'),
	(665451, 136, '2015-01-15 00:38:37.000000', 'consum', 0.0215, 'lps'),
	(665452, 136, '2015-01-15 00:38:38.000000', 'consum', 0.0309, 'lps'),
	(665453, 136, '2015-01-15 00:38:39.000000', 'consum', 0.0249, 'lps'),
	(665454, 136, '2015-01-15 00:38:40.000000', 'consum', 0.0257, 'lps'),
	(665455, 136, '2015-01-15 00:38:41.000000', 'consum', 0.0328, 'lps'),
	(665456, 136, '2015-01-15 00:38:42.000000', 'consum', 0.0220, 'lps'),
	(665457, 136, '2015-01-15 00:38:43.000000', 'consum', 0.0347, 'lps'),
	(665458, 136, '2015-01-15 00:38:44.000000', 'consum', 0.0275, 'lps'),
	(665459, 136, '2015-01-15 00:38:45.000000', 'consum', 0.0273, 'lps'),
	(665460, 136, '2015-01-15 00:38:46.000000', 'consum', 0.0328, 'lps'),
	(665461, 136, '2015-01-15 00:38:47.000000', 'consum', 0.0321, 'lps'),
	(665462, 136, '2015-01-15 00:38:48.000000', 'consum', 0.0263, 'lps'),
	(665463, 136, '2015-01-15 00:38:49.000000', 'consum', 0.0289, 'lps'),
	(665464, 136, '2015-01-15 00:38:50.000000', 'consum', 0.0301, 'lps'),
	(665465, 136, '2015-01-15 00:38:51.000000', 'consum', 0.0282, 'lps'),
	(665466, 136, '2015-01-15 00:38:52.000000', 'consum', 0.0296, 'lps'),
	(665467, 136, '2015-01-15 00:38:53.000000', 'consum', 0.0276, 'lps'),
	(665468, 136, '2015-01-15 00:38:54.000000', 'consum', 0.0284, 'lps'),
	(665469, 136, '2015-01-15 00:38:55.000000', 'consum', 0.0235, 'lps'),
	(665470, 136, '2015-01-15 00:38:56.000000', 'consum', 0.0260, 'lps'),
	(665471, 136, '2015-01-15 00:38:57.000000', 'consum', 0.0241, 'lps'),
	(665472, 136, '2015-01-15 00:38:58.000000', 'consum', 0.0215, 'lps'),
	(665473, 136, '2015-01-15 00:38:59.000000', 'consum', 0.0288, 'lps'),
	(665474, 136, '2015-01-15 00:39:00.000000', 'consum', 0.0291, 'lps'),
	(665475, 136, '2015-01-15 00:39:01.000000', 'consum', 0.0237, 'lps'),
	(665476, 136, '2015-01-15 00:39:02.000000', 'consum', 0.0249, 'lps'),
	(665477, 136, '2015-01-15 00:39:03.000000', 'consum', 0.0325, 'lps'),
	(665478, 136, '2015-01-15 00:39:04.000000', 'consum', 0.0228, 'lps'),
	(665479, 136, '2015-01-15 00:39:05.000000', 'consum', 0.0249, 'lps'),
	(665480, 136, '2015-01-15 00:39:06.000000', 'consum', 0.0353, 'lps'),
	(665481, 136, '2015-01-15 00:39:07.000000', 'consum', 0.0221, 'lps'),
	(665482, 136, '2015-01-15 00:39:08.000000', 'consum', 0.0275, 'lps'),
	(665483, 136, '2015-01-15 00:39:09.000000', 'consum', 0.0356, 'lps'),
	(665484, 136, '2015-01-15 00:39:10.000000', 'consum', 0.0305, 'lps'),
	(665485, 136, '2015-01-15 00:39:11.000000', 'consum', 0.0248, 'lps'),
	(665486, 136, '2015-01-15 00:39:12.000000', 'consum', 0.0260, 'lps'),
	(665487, 136, '2015-01-15 00:39:13.000000', 'consum', 0.0349, 'lps'),
	(665488, 136, '2015-01-15 00:39:14.000000', 'consum', 0.0313, 'lps'),
	(665489, 136, '2015-01-15 00:39:15.000000', 'consum', 0.0309, 'lps'),
	(665490, 136, '2015-01-15 00:39:16.000000', 'consum', 0.0248, 'lps'),
	(665491, 136, '2015-01-15 00:39:17.000000', 'consum', 0.0250, 'lps'),
	(665492, 136, '2015-01-15 00:39:18.000000', 'consum', 0.0297, 'lps'),
	(665493, 136, '2015-01-15 00:39:19.000000', 'consum', 0.0231, 'lps'),
	(665494, 136, '2015-01-15 00:39:20.000000', 'consum', 0.0349, 'lps'),
	(665495, 136, '2015-01-15 00:39:21.000000', 'consum', 0.0255, 'lps'),
	(665496, 136, '2015-01-15 00:39:22.000000', 'consum', 0.0312, 'lps'),
	(665497, 136, '2015-01-15 00:39:23.000000', 'consum', 0.0291, 'lps'),
	(665498, 136, '2015-01-15 00:39:24.000000', 'consum', 0.0309, 'lps'),
	(665499, 136, '2015-01-15 00:39:25.000000', 'consum', 0.0314, 'lps'),
	(665500, 136, '2015-01-15 00:39:26.000000', 'consum', 0.0289, 'lps'),
	(665501, 136, '2015-01-15 00:39:27.000000', 'consum', 0.0292, 'lps'),
	(665502, 136, '2015-01-15 00:39:28.000000', 'consum', 0.0236, 'lps'),
	(665503, 136, '2015-01-15 00:39:29.000000', 'consum', 0.0241, 'lps'),
	(665504, 136, '2015-01-15 00:39:30.000000', 'consum', 0.0290, 'lps'),
	(665505, 136, '2015-01-15 00:39:31.000000', 'consum', 0.0224, 'lps'),
	(665506, 136, '2015-01-15 00:39:32.000000', 'consum', 0.0332, 'lps'),
	(665507, 136, '2015-01-15 00:39:33.000000', 'consum', 0.0338, 'lps'),
	(665508, 136, '2015-01-15 00:39:34.000000', 'consum', 0.0337, 'lps'),
	(665509, 136, '2015-01-15 00:39:35.000000', 'consum', 0.0316, 'lps'),
	(665510, 136, '2015-01-15 00:39:36.000000', 'consum', 0.0211, 'lps'),
	(665511, 136, '2015-01-15 00:39:37.000000', 'consum', 0.0339, 'lps'),
	(665512, 136, '2015-01-15 00:39:38.000000', 'consum', 0.0263, 'lps'),
	(665513, 136, '2015-01-15 00:39:39.000000', 'consum', 0.0237, 'lps'),
	(665514, 136, '2015-01-15 00:39:40.000000', 'consum', 0.0333, 'lps'),
	(665515, 136, '2015-01-15 00:39:41.000000', 'consum', 0.0303, 'lps'),
	(665516, 136, '2015-01-15 00:39:42.000000', 'consum', 0.0306, 'lps'),
	(665517, 136, '2015-01-15 00:39:43.000000', 'consum', 0.0264, 'lps'),
	(665518, 136, '2015-01-15 00:39:44.000000', 'consum', 0.0339, 'lps'),
	(665519, 136, '2015-01-15 00:39:45.000000', 'consum', 0.0253, 'lps'),
	(665520, 136, '2015-01-15 00:39:46.000000', 'consum', 0.0334, 'lps'),
	(665521, 136, '2015-01-15 00:39:47.000000', 'consum', 0.0260, 'lps'),
	(665522, 136, '2015-01-15 00:39:48.000000', 'consum', 0.0235, 'lps'),
	(665523, 136, '2015-01-15 00:39:49.000000', 'consum', 0.0335, 'lps'),
	(665524, 136, '2015-01-15 00:39:50.000000', 'consum', 0.0316, 'lps'),
	(665525, 136, '2015-01-15 00:39:51.000000', 'consum', 0.0219, 'lps'),
	(665526, 136, '2015-01-15 00:39:52.000000', 'consum', 0.0232, 'lps'),
	(665527, 136, '2015-01-15 00:39:53.000000', 'consum', 0.0294, 'lps'),
	(665528, 136, '2015-01-15 00:39:54.000000', 'consum', 0.0272, 'lps'),
	(665529, 136, '2015-01-15 00:39:55.000000', 'consum', 0.0268, 'lps'),
	(665530, 136, '2015-01-15 00:39:56.000000', 'consum', 0.0313, 'lps'),
	(665531, 136, '2015-01-15 00:39:57.000000', 'consum', 0.0257, 'lps'),
	(665532, 136, '2015-01-15 00:39:58.000000', 'consum', 0.0284, 'lps'),
	(665533, 136, '2015-01-15 00:39:59.000000', 'consum', 0.0291, 'lps'),
	(665534, 136, '2015-01-15 00:40:00.000000', 'consum', 0.0246, 'lps'),
	(665535, 136, '2015-01-15 00:40:01.000000', 'consum', 0.0296, 'lps'),
	(665536, 136, '2015-01-15 00:40:02.000000', 'consum', 0.0240, 'lps'),
	(665537, 136, '2015-01-15 00:40:03.000000', 'consum', 0.0247, 'lps'),
	(665538, 136, '2015-01-15 00:40:04.000000', 'consum', 0.0307, 'lps'),
	(665539, 136, '2015-01-15 00:40:05.000000', 'consum', 0.0290, 'lps'),
	(665540, 136, '2015-01-15 00:40:06.000000', 'consum', 0.0318, 'lps'),
	(665541, 136, '2015-01-15 00:40:07.000000', 'consum', 0.0217, 'lps'),
	(665542, 136, '2015-01-15 00:40:08.000000', 'consum', 0.0216, 'lps'),
	(665543, 136, '2015-01-15 00:40:09.000000', 'consum', 0.0220, 'lps'),
	(665544, 136, '2015-01-15 00:40:10.000000', 'consum', 0.0242, 'lps'),
	(665545, 136, '2015-01-15 00:40:11.000000', 'consum', 0.0343, 'lps'),
	(665546, 136, '2015-01-15 00:40:12.000000', 'consum', 0.0335, 'lps'),
	(665547, 136, '2015-01-15 00:40:13.000000', 'consum', 0.0289, 'lps'),
	(665548, 136, '2015-01-15 00:40:14.000000', 'consum', 0.0234, 'lps'),
	(665549, 136, '2015-01-15 00:40:15.000000', 'consum', 0.0237, 'lps'),
	(665550, 136, '2015-01-15 00:40:16.000000', 'consum', 0.0276, 'lps'),
	(665551, 136, '2015-01-15 00:40:17.000000', 'consum', 0.0310, 'lps'),
	(665552, 136, '2015-01-15 00:40:18.000000', 'consum', 0.0218, 'lps'),
	(665553, 136, '2015-01-15 00:40:19.000000', 'consum', 0.0244, 'lps'),
	(665554, 136, '2015-01-15 00:40:20.000000', 'consum', 0.0212, 'lps'),
	(665555, 136, '2015-01-15 00:40:21.000000', 'consum', 0.0266, 'lps'),
	(665556, 136, '2015-01-15 00:40:22.000000', 'consum', 0.0335, 'lps'),
	(665557, 136, '2015-01-15 00:40:23.000000', 'consum', 0.0227, 'lps'),
	(665558, 136, '2015-01-15 00:40:24.000000', 'consum', 0.0216, 'lps'),
	(665559, 136, '2015-01-15 00:40:25.000000', 'consum', 0.0337, 'lps'),
	(665560, 136, '2015-01-15 00:40:26.000000', 'consum', 0.0237, 'lps'),
	(665561, 136, '2015-01-15 00:40:27.000000', 'consum', 0.0258, 'lps'),
	(665562, 136, '2015-01-15 00:40:28.000000', 'consum', 0.0223, 'lps'),
	(665563, 136, '2015-01-15 00:40:29.000000', 'consum', 0.0280, 'lps'),
	(665564, 136, '2015-01-15 00:40:30.000000', 'consum', 0.0225, 'lps'),
	(665565, 136, '2015-01-15 00:40:31.000000', 'consum', 0.0224, 'lps'),
	(665566, 136, '2015-01-15 00:40:32.000000', 'consum', 0.0236, 'lps'),
	(665567, 136, '2015-01-15 00:40:33.000000', 'consum', 0.0298, 'lps'),
	(665568, 136, '2015-01-15 00:40:34.000000', 'consum', 0.0278, 'lps'),
	(665569, 136, '2015-01-15 00:40:35.000000', 'consum', 0.0286, 'lps'),
	(665570, 136, '2015-01-15 00:40:36.000000', 'consum', 0.0239, 'lps'),
	(665571, 136, '2015-01-15 00:40:37.000000', 'consum', 0.0277, 'lps'),
	(665572, 136, '2015-01-15 00:40:38.000000', 'consum', 0.0309, 'lps'),
	(665573, 136, '2015-01-15 00:40:39.000000', 'consum', 0.0212, 'lps'),
	(665574, 136, '2015-01-15 00:40:40.000000', 'consum', 0.0217, 'lps'),
	(665575, 136, '2015-01-15 00:40:41.000000', 'consum', 0.0240, 'lps'),
	(665576, 136, '2015-01-15 00:40:42.000000', 'consum', 0.0341, 'lps'),
	(665577, 136, '2015-01-15 00:40:43.000000', 'consum', 0.0334, 'lps'),
	(665578, 136, '2015-01-15 00:40:44.000000', 'consum', 0.0289, 'lps'),
	(665579, 136, '2015-01-15 00:40:45.000000', 'consum', 0.0233, 'lps'),
	(665580, 136, '2015-01-15 00:40:46.000000', 'consum', 0.0235, 'lps'),
	(665581, 136, '2015-01-15 00:40:47.000000', 'consum', 0.0267, 'lps'),
	(665582, 136, '2015-01-15 00:40:48.000000', 'consum', 0.0274, 'lps'),
	(665583, 136, '2015-01-15 00:40:49.000000', 'consum', 0.0211, 'lps'),
	(665584, 136, '2015-01-15 00:40:50.000000', 'consum', 0.0318, 'lps'),
	(665585, 136, '2015-01-15 00:40:51.000000', 'consum', 0.0308, 'lps'),
	(665586, 136, '2015-01-15 00:40:52.000000', 'consum', 0.0228, 'lps'),
	(665587, 136, '2015-01-15 00:40:53.000000', 'consum', 0.0300, 'lps'),
	(665588, 136, '2015-01-15 00:40:54.000000', 'consum', 0.0314, 'lps'),
	(665589, 136, '2015-01-15 00:40:55.000000', 'consum', 0.0311, 'lps'),
	(665590, 136, '2015-01-15 00:40:56.000000', 'consum', 0.0258, 'lps'),
	(665591, 136, '2015-01-15 00:40:57.000000', 'consum', 0.0293, 'lps'),
	(665592, 136, '2015-01-15 00:40:58.000000', 'consum', 0.0333, 'lps'),
	(665593, 136, '2015-01-15 00:40:59.000000', 'consum', 0.0286, 'lps'),
	(665594, 136, '2015-01-15 00:41:00.000000', 'consum', 0.0221, 'lps'),
	(665595, 136, '2015-01-15 00:41:01.000000', 'consum', 0.0330, 'lps'),
	(665596, 136, '2015-01-15 00:41:02.000000', 'consum', 0.0336, 'lps'),
	(665597, 136, '2015-01-15 00:41:03.000000', 'consum', 0.0333, 'lps'),
	(665598, 136, '2015-01-15 00:41:04.000000', 'consum', 0.0303, 'lps'),
	(665599, 136, '2015-01-15 00:41:05.000000', 'consum', 0.0307, 'lps'),
	(665600, 136, '2015-01-15 00:41:06.000000', 'consum', 0.0270, 'lps'),
	(665601, 136, '2015-01-15 00:41:07.000000', 'consum', 0.0220, 'lps'),
	(665602, 136, '2015-01-15 00:41:08.000000', 'consum', 0.0228, 'lps'),
	(665603, 136, '2015-01-15 00:41:09.000000', 'consum', 0.0271, 'lps'),
	(665604, 136, '2015-01-15 00:41:10.000000', 'consum', 0.0314, 'lps'),
	(665605, 136, '2015-01-15 00:41:11.000000', 'consum', 0.0254, 'lps'),
	(665606, 136, '2015-01-15 00:41:12.000000', 'consum', 0.0264, 'lps'),
	(665607, 136, '2015-01-15 00:41:13.000000', 'consum', 0.0350, 'lps'),
	(665608, 136, '2015-01-15 00:41:14.000000', 'consum', 0.0309, 'lps'),
	(665609, 136, '2015-01-15 00:41:15.000000', 'consum', 0.0282, 'lps'),
	(665610, 136, '2015-01-15 00:41:16.000000', 'consum', 0.0277, 'lps'),
	(665611, 136, '2015-01-15 00:41:17.000000', 'consum', 0.0327, 'lps'),
	(665612, 136, '2015-01-15 00:41:18.000000', 'consum', 0.0302, 'lps'),
	(665613, 136, '2015-01-15 00:41:19.000000', 'consum', 0.0318, 'lps'),
	(665614, 136, '2015-01-15 00:41:20.000000', 'consum', 0.0326, 'lps'),
	(665615, 136, '2015-01-15 00:41:21.000000', 'consum', 0.0322, 'lps'),
	(665616, 136, '2015-01-15 00:41:22.000000', 'consum', 0.0276, 'lps'),
	(665617, 136, '2015-01-15 00:41:23.000000', 'consum', 0.0349, 'lps'),
	(665618, 136, '2015-01-15 00:41:24.000000', 'consum', 0.0269, 'lps'),
	(665619, 136, '2015-01-15 00:41:25.000000', 'consum', 0.0233, 'lps'),
	(665620, 136, '2015-01-15 00:41:26.000000', 'consum', 0.0299, 'lps'),
	(665621, 136, '2015-01-15 00:41:27.000000', 'consum', 0.0289, 'lps'),
	(665622, 136, '2015-01-15 00:41:28.000000', 'consum', 0.0339, 'lps'),
	(665623, 136, '2015-01-15 00:41:29.000000', 'consum', 0.0327, 'lps'),
	(665624, 136, '2015-01-15 00:41:30.000000', 'consum', 0.0259, 'lps'),
	(665625, 136, '2015-01-15 00:41:31.000000', 'consum', 0.0253, 'lps'),
	(665626, 136, '2015-01-15 00:41:32.000000', 'consum', 0.0279, 'lps'),
	(665627, 136, '2015-01-15 00:41:33.000000', 'consum', 0.0278, 'lps'),
	(665628, 136, '2015-01-15 00:41:34.000000', 'consum', 0.0342, 'lps'),
	(665629, 136, '2015-01-15 00:41:35.000000', 'consum', 0.0227, 'lps'),
	(665630, 136, '2015-01-15 00:41:36.000000', 'consum', 0.0340, 'lps'),
	(665631, 136, '2015-01-15 00:41:37.000000', 'consum', 0.0220, 'lps'),
	(665632, 136, '2015-01-15 00:41:38.000000', 'consum', 0.0312, 'lps'),
	(665633, 136, '2015-01-15 00:41:39.000000', 'consum', 0.0249, 'lps'),
	(665634, 136, '2015-01-15 00:41:40.000000', 'consum', 0.0246, 'lps'),
	(665635, 136, '2015-01-15 00:41:41.000000', 'consum', 0.0274, 'lps'),
	(665636, 136, '2015-01-15 00:41:42.000000', 'consum', 0.0275, 'lps'),
	(665637, 136, '2015-01-15 00:41:43.000000', 'consum', 0.0344, 'lps'),
	(665638, 136, '2015-01-15 00:41:44.000000', 'consum', 0.0243, 'lps'),
	(665639, 136, '2015-01-15 00:41:45.000000', 'consum', 0.0268, 'lps'),
	(665640, 136, '2015-01-15 00:41:46.000000', 'consum', 0.0254, 'lps'),
	(665641, 136, '2015-01-15 00:41:47.000000', 'consum', 0.0256, 'lps'),
	(665642, 136, '2015-01-15 00:41:48.000000', 'consum', 0.0310, 'lps'),
	(665643, 136, '2015-01-15 00:41:49.000000', 'consum', 0.0278, 'lps'),
	(665644, 136, '2015-01-15 00:41:50.000000', 'consum', 0.0251, 'lps'),
	(665645, 136, '2015-01-15 00:41:51.000000', 'consum', 0.0210, 'lps'),
	(665646, 136, '2015-01-15 00:41:52.000000', 'consum', 0.0236, 'lps'),
	(665647, 136, '2015-01-15 00:41:53.000000', 'consum', 0.0340, 'lps'),
	(665648, 136, '2015-01-15 00:41:54.000000', 'consum', 0.0340, 'lps'),
	(665649, 136, '2015-01-15 00:41:55.000000', 'consum', 0.0324, 'lps'),
	(665650, 136, '2015-01-15 00:41:56.000000', 'consum', 0.0243, 'lps'),
	(665651, 136, '2015-01-15 00:41:57.000000', 'consum', 0.0328, 'lps'),
	(665652, 136, '2015-01-15 00:41:58.000000', 'consum', 0.0260, 'lps'),
	(665653, 136, '2015-01-15 00:41:59.000000', 'consum', 0.0253, 'lps'),
	(665654, 136, '2015-01-15 00:42:00.000000', 'consum', 0.0276, 'lps'),
	(665655, 136, '2015-01-15 00:42:01.000000', 'consum', 0.0265, 'lps'),
	(665656, 136, '2015-01-15 00:42:02.000000', 'consum', 0.0286, 'lps'),
	(665657, 136, '2015-01-15 00:42:03.000000', 'consum', 0.0279, 'lps'),
	(665658, 136, '2015-01-15 00:42:04.000000', 'consum', 0.0328, 'lps'),
	(665659, 136, '2015-01-15 00:42:05.000000', 'consum', 0.0300, 'lps'),
	(665660, 136, '2015-01-15 00:42:06.000000', 'consum', 0.0307, 'lps'),
	(665661, 136, '2015-01-15 00:42:07.000000', 'consum', 0.0277, 'lps'),
	(665662, 136, '2015-01-15 00:42:08.000000', 'consum', 0.0256, 'lps'),
	(665663, 136, '2015-01-15 00:42:09.000000', 'consum', 0.0238, 'lps'),
	(665664, 136, '2015-01-15 00:42:10.000000', 'consum', 0.0211, 'lps'),
	(665665, 136, '2015-01-15 00:42:11.000000', 'consum', 0.0280, 'lps'),
	(665666, 136, '2015-01-15 00:42:12.000000', 'consum', 0.0265, 'lps'),
	(665667, 136, '2015-01-15 00:42:13.000000', 'consum', 0.0273, 'lps'),
	(665668, 136, '2015-01-15 00:42:14.000000', 'consum', 0.0216, 'lps'),
	(665669, 136, '2015-01-15 00:42:15.000000', 'consum', 0.0346, 'lps'),
	(665670, 136, '2015-01-15 00:42:16.000000', 'consum', 0.0284, 'lps'),
	(665671, 136, '2015-01-15 00:42:17.000000', 'consum', 0.0319, 'lps'),
	(665672, 136, '2015-01-15 00:42:18.000000', 'consum', 0.0239, 'lps'),
	(665673, 136, '2015-01-15 00:42:19.000000', 'consum', 0.0323, 'lps'),
	(665674, 136, '2015-01-15 00:42:20.000000', 'consum', 0.0249, 'lps'),
	(665675, 136, '2015-01-15 00:42:21.000000', 'consum', 0.0211, 'lps'),
	(665676, 136, '2015-01-15 00:42:22.000000', 'consum', 0.0248, 'lps'),
	(665677, 136, '2015-01-15 00:42:23.000000', 'consum', 0.0249, 'lps'),
	(665678, 136, '2015-01-15 00:42:24.000000', 'consum', 0.0291, 'lps'),
	(665679, 136, '2015-01-15 00:42:25.000000', 'consum', 0.0351, 'lps'),
	(665680, 136, '2015-01-15 00:42:26.000000', 'consum', 0.0231, 'lps'),
	(665681, 136, '2015-01-15 00:42:27.000000', 'consum', 0.0333, 'lps'),
	(665682, 136, '2015-01-15 00:42:28.000000', 'consum', 0.0321, 'lps'),
	(665683, 136, '2015-01-15 00:42:29.000000', 'consum', 0.0252, 'lps'),
	(665684, 136, '2015-01-15 00:42:30.000000', 'consum', 0.0232, 'lps'),
	(665685, 136, '2015-01-15 00:42:31.000000', 'consum', 0.0344, 'lps'),
	(665686, 136, '2015-01-15 00:42:32.000000', 'consum', 0.0226, 'lps'),
	(665687, 136, '2015-01-15 00:42:33.000000', 'consum', 0.0330, 'lps'),
	(665688, 136, '2015-01-15 00:42:34.000000', 'consum', 0.0322, 'lps'),
	(665689, 136, '2015-01-15 00:42:35.000000', 'consum', 0.0262, 'lps'),
	(665690, 136, '2015-01-15 00:42:36.000000', 'consum', 0.0284, 'lps'),
	(665691, 136, '2015-01-15 00:42:37.000000', 'consum', 0.0276, 'lps'),
	(665692, 136, '2015-01-15 00:42:38.000000', 'consum', 0.0318, 'lps'),
	(665693, 136, '2015-01-15 00:42:39.000000', 'consum', 0.0259, 'lps'),
	(665694, 136, '2015-01-15 00:42:40.000000', 'consum', 0.0279, 'lps'),
	(665695, 136, '2015-01-15 00:42:41.000000', 'consum', 0.0261, 'lps'),
	(665696, 136, '2015-01-15 00:42:42.000000', 'consum', 0.0260, 'lps'),
	(665697, 136, '2015-01-15 00:42:43.000000', 'consum', 0.0306, 'lps'),
	(665698, 136, '2015-01-15 00:42:44.000000', 'consum', 0.0246, 'lps'),
	(665699, 136, '2015-01-15 00:42:45.000000', 'consum', 0.0248, 'lps'),
	(665700, 136, '2015-01-15 00:42:46.000000', 'consum', 0.0295, 'lps'),
	(665701, 136, '2015-01-15 00:42:47.000000', 'consum', 0.0228, 'lps'),
	(665702, 136, '2015-01-15 00:42:48.000000', 'consum', 0.0338, 'lps'),
	(665703, 136, '2015-01-15 00:42:49.000000', 'consum', 0.0210, 'lps'),
	(665704, 136, '2015-01-15 00:42:50.000000', 'consum', 0.0268, 'lps'),
	(665705, 136, '2015-01-15 00:42:51.000000', 'consum', 0.0355, 'lps'),
	(665706, 136, '2015-01-15 00:42:52.000000', 'consum', 0.0317, 'lps'),
	(665707, 136, '2015-01-15 00:42:53.000000', 'consum', 0.0311, 'lps'),
	(665708, 136, '2015-01-15 00:42:54.000000', 'consum', 0.0247, 'lps'),
	(665709, 136, '2015-01-15 00:42:55.000000', 'consum', 0.0240, 'lps'),
	(665710, 136, '2015-01-15 00:42:56.000000', 'consum', 0.0249, 'lps'),
	(665711, 136, '2015-01-15 00:42:57.000000', 'consum', 0.0314, 'lps'),
	(665712, 136, '2015-01-15 00:42:58.000000', 'consum', 0.0323, 'lps'),
	(665713, 136, '2015-01-15 00:42:59.000000', 'consum', 0.0314, 'lps'),
	(665714, 136, '2015-01-15 00:43:00.000000', 'consum', 0.0243, 'lps'),
	(665715, 136, '2015-01-15 00:43:01.000000', 'consum', 0.0213, 'lps'),
	(665716, 136, '2015-01-15 00:43:02.000000', 'consum', 0.0274, 'lps'),
	(665717, 136, '2015-01-15 00:43:03.000000', 'consum', 0.0228, 'lps'),
	(665718, 136, '2015-01-15 00:43:04.000000', 'consum', 0.0256, 'lps'),
	(665719, 136, '2015-01-15 00:43:05.000000', 'consum', 0.0238, 'lps'),
	(665720, 136, '2015-01-15 00:43:06.000000', 'consum', 0.0211, 'lps'),
	(665721, 136, '2015-01-15 00:43:07.000000', 'consum', 0.0280, 'lps'),
	(665722, 136, '2015-01-15 00:43:08.000000', 'consum', 0.0265, 'lps'),
	(665723, 136, '2015-01-15 00:43:09.000000', 'consum', 0.0276, 'lps'),
	(665724, 136, '2015-01-15 00:43:10.000000', 'consum', 0.0227, 'lps'),
	(665725, 136, '2015-01-15 00:43:11.000000', 'consum', 0.0246, 'lps'),
	(665726, 136, '2015-01-15 00:43:12.000000', 'consum', 0.0339, 'lps'),
	(665727, 136, '2015-01-15 00:43:13.000000', 'consum', 0.0307, 'lps'),
	(665728, 136, '2015-01-15 00:43:14.000000', 'consum', 0.0306, 'lps'),
	(665729, 136, '2015-01-15 00:43:15.000000', 'consum', 0.0255, 'lps'),
	(665730, 136, '2015-01-15 00:43:16.000000', 'consum', 0.0292, 'lps'),
	(665731, 136, '2015-01-15 00:43:17.000000', 'consum', 0.0340, 'lps'),
	(665732, 136, '2015-01-15 00:43:18.000000', 'consum', 0.0320, 'lps'),
	(665733, 136, '2015-01-15 00:43:19.000000', 'consum', 0.0224, 'lps'),
	(665734, 136, '2015-01-15 00:43:20.000000', 'consum', 0.0243, 'lps'),
	(665735, 136, '2015-01-15 00:43:21.000000', 'consum', 0.0336, 'lps'),
	(665736, 136, '2015-01-15 00:43:22.000000', 'consum', 0.0301, 'lps'),
	(665737, 136, '2015-01-15 00:43:23.000000', 'consum', 0.0288, 'lps'),
	(665738, 136, '2015-01-15 00:43:24.000000', 'consum', 0.0325, 'lps'),
	(665739, 136, '2015-01-15 00:43:25.000000', 'consum', 0.0258, 'lps'),
	(665740, 136, '2015-01-15 00:43:26.000000', 'consum', 0.0253, 'lps'),
	(665741, 136, '2015-01-15 00:43:27.000000', 'consum', 0.0280, 'lps'),
	(665742, 136, '2015-01-15 00:43:28.000000', 'consum', 0.0284, 'lps'),
	(665743, 136, '2015-01-15 00:43:29.000000', 'consum', 0.0226, 'lps'),
	(665744, 136, '2015-01-15 00:43:30.000000', 'consum', 0.0214, 'lps'),
	(665745, 136, '2015-01-15 00:43:31.000000', 'consum', 0.0328, 'lps'),
	(665746, 136, '2015-01-15 00:43:32.000000', 'consum', 0.0350, 'lps'),
	(665747, 136, '2015-01-15 00:43:33.000000', 'consum', 0.0260, 'lps'),
	(665748, 136, '2015-01-15 00:43:34.000000', 'consum', 0.0334, 'lps'),
	(665749, 136, '2015-01-15 00:43:35.000000', 'consum', 0.0241, 'lps'),
	(665750, 136, '2015-01-15 00:43:36.000000', 'consum', 0.0286, 'lps'),
	(665751, 136, '2015-01-15 00:43:37.000000', 'consum', 0.0351, 'lps'),
	(665752, 136, '2015-01-15 00:43:38.000000', 'consum', 0.0247, 'lps'),
	(665753, 136, '2015-01-15 00:43:39.000000', 'consum', 0.0265, 'lps'),
	(665754, 136, '2015-01-15 00:43:40.000000', 'consum', 0.0229, 'lps'),
	(665755, 136, '2015-01-15 00:43:41.000000', 'consum', 0.0288, 'lps'),
	(665756, 136, '2015-01-15 00:43:42.000000', 'consum', 0.0250, 'lps'),
	(665757, 136, '2015-01-15 00:43:43.000000', 'consum', 0.0324, 'lps'),
	(665758, 136, '2015-01-15 00:43:44.000000', 'consum', 0.0219, 'lps'),
	(665759, 136, '2015-01-15 00:43:45.000000', 'consum', 0.0353, 'lps'),
	(665760, 136, '2015-01-15 00:43:46.000000', 'consum', 0.0313, 'lps'),
	(665761, 136, '2015-01-15 00:43:47.000000', 'consum', 0.0294, 'lps'),
	(665762, 136, '2015-01-15 00:43:48.000000', 'consum', 0.0321, 'lps'),
	(665763, 136, '2015-01-15 00:43:49.000000', 'consum', 0.0221, 'lps'),
	(665764, 136, '2015-01-15 00:43:50.000000', 'consum', 0.0226, 'lps'),
	(665765, 136, '2015-01-15 00:43:51.000000', 'consum', 0.0259, 'lps'),
	(665766, 136, '2015-01-15 00:43:52.000000', 'consum', 0.0259, 'lps'),
	(665767, 136, '2015-01-15 00:43:53.000000', 'consum', 0.0310, 'lps'),
	(665768, 136, '2015-01-15 00:43:54.000000', 'consum', 0.0269, 'lps'),
	(665769, 136, '2015-01-15 00:43:55.000000', 'consum', 0.0353, 'lps'),
	(665770, 136, '2015-01-15 00:43:56.000000', 'consum', 0.0305, 'lps'),
	(665771, 136, '2015-01-15 00:43:57.000000', 'consum', 0.0257, 'lps'),
	(665772, 136, '2015-01-15 00:43:58.000000', 'consum', 0.0310, 'lps'),
	(665773, 136, '2015-01-15 00:43:59.000000', 'consum', 0.0272, 'lps'),
	(665774, 136, '2015-01-15 00:44:00.000000', 'consum', 0.0224, 'lps'),
	(665775, 136, '2015-01-15 00:44:01.000000', 'consum', 0.0240, 'lps'),
	(665776, 136, '2015-01-15 00:44:02.000000', 'consum', 0.0318, 'lps'),
	(665777, 136, '2015-01-15 00:44:03.000000', 'consum', 0.0219, 'lps'),
	(665778, 136, '2015-01-15 00:44:04.000000', 'consum', 0.0227, 'lps'),
	(665779, 136, '2015-01-15 00:44:05.000000', 'consum', 0.0270, 'lps'),
	(665780, 136, '2015-01-15 00:44:06.000000', 'consum', 0.0311, 'lps'),
	(665781, 136, '2015-01-15 00:44:07.000000', 'consum', 0.0242, 'lps'),
	(665782, 136, '2015-01-15 00:44:08.000000', 'consum', 0.0215, 'lps'),
	(665783, 136, '2015-01-15 00:44:09.000000', 'consum', 0.0287, 'lps'),
	(665784, 136, '2015-01-15 00:44:10.000000', 'consum', 0.0284, 'lps'),
	(665785, 136, '2015-01-15 00:44:11.000000', 'consum', 0.0353, 'lps'),
	(665786, 136, '2015-01-15 00:44:12.000000', 'consum', 0.0260, 'lps'),
	(665787, 136, '2015-01-15 00:44:13.000000', 'consum', 0.0326, 'lps'),
	(665788, 136, '2015-01-15 00:44:14.000000', 'consum', 0.0346, 'lps'),
	(665789, 136, '2015-01-15 00:44:15.000000', 'consum', 0.0247, 'lps'),
	(665790, 136, '2015-01-15 00:44:16.000000', 'consum', 0.0283, 'lps'),
	(665791, 136, '2015-01-15 00:44:17.000000', 'consum', 0.0317, 'lps'),
	(665792, 136, '2015-01-15 00:44:18.000000', 'consum', 0.0235, 'lps'),
	(665793, 136, '2015-01-15 00:44:19.000000', 'consum', 0.0306, 'lps'),
	(665794, 136, '2015-01-15 00:44:20.000000', 'consum', 0.0321, 'lps'),
	(665795, 136, '2015-01-15 00:44:21.000000', 'consum', 0.0333, 'lps'),
	(665796, 136, '2015-01-15 00:44:22.000000', 'consum', 0.0343, 'lps'),
	(665797, 136, '2015-01-15 00:44:23.000000', 'consum', 0.0211, 'lps'),
	(665798, 136, '2015-01-15 00:44:24.000000', 'consum', 0.0261, 'lps'),
	(665799, 136, '2015-01-15 00:44:25.000000', 'consum', 0.0315, 'lps'),
	(665800, 136, '2015-01-15 00:44:26.000000', 'consum', 0.0290, 'lps'),
	(665801, 136, '2015-01-15 00:44:27.000000', 'consum', 0.0293, 'lps'),
	(665802, 136, '2015-01-15 00:44:28.000000', 'consum', 0.0238, 'lps'),
	(665803, 136, '2015-01-15 00:44:29.000000', 'consum', 0.0248, 'lps'),
	(665804, 136, '2015-01-15 00:44:30.000000', 'consum', 0.0317, 'lps'),
	(665805, 136, '2015-01-15 00:44:31.000000', 'consum', 0.0337, 'lps'),
	(665806, 136, '2015-01-15 00:44:32.000000', 'consum', 0.0233, 'lps'),
	(665807, 136, '2015-01-15 00:44:33.000000', 'consum', 0.0236, 'lps'),
	(665808, 136, '2015-01-15 00:44:34.000000', 'consum', 0.0273, 'lps'),
	(665809, 136, '2015-01-15 00:44:35.000000', 'consum', 0.0299, 'lps'),
	(665810, 136, '2015-01-15 00:44:36.000000', 'consum', 0.0318, 'lps'),
	(665811, 136, '2015-01-15 00:44:37.000000', 'consum', 0.0339, 'lps'),
	(665812, 136, '2015-01-15 00:44:38.000000', 'consum', 0.0236, 'lps'),
	(665813, 136, '2015-01-15 00:44:39.000000', 'consum', 0.0247, 'lps'),
	(665814, 136, '2015-01-15 00:44:40.000000', 'consum', 0.0316, 'lps'),
	(665815, 136, '2015-01-15 00:44:41.000000', 'consum', 0.0338, 'lps'),
	(665816, 136, '2015-01-15 00:44:42.000000', 'consum', 0.0240, 'lps'),
	(665817, 136, '2015-01-15 00:44:43.000000', 'consum', 0.0268, 'lps'),
	(665818, 136, '2015-01-15 00:44:44.000000', 'consum', 0.0263, 'lps'),
	(665819, 136, '2015-01-15 00:44:45.000000', 'consum', 0.0302, 'lps'),
	(665820, 136, '2015-01-15 00:44:46.000000', 'consum', 0.0218, 'lps'),
	(665821, 136, '2015-01-15 00:44:47.000000', 'consum', 0.0268, 'lps'),
	(665822, 136, '2015-01-15 00:44:48.000000', 'consum', 0.0328, 'lps'),
	(665823, 136, '2015-01-15 00:44:49.000000', 'consum', 0.0333, 'lps'),
	(665824, 136, '2015-01-15 00:44:50.000000', 'consum', 0.0326, 'lps'),
	(665825, 136, '2015-01-15 00:44:51.000000', 'consum', 0.0276, 'lps'),
	(665826, 136, '2015-01-15 00:44:52.000000', 'consum', 0.0336, 'lps'),
	(665827, 136, '2015-01-15 00:44:53.000000', 'consum', 0.0351, 'lps'),
	(665828, 136, '2015-01-15 00:44:54.000000', 'consum', 0.0244, 'lps'),
	(665829, 136, '2015-01-15 00:44:55.000000', 'consum', 0.0251, 'lps'),
	(665830, 136, '2015-01-15 00:44:56.000000', 'consum', 0.0313, 'lps'),
	(665831, 136, '2015-01-15 00:44:57.000000', 'consum', 0.0310, 'lps'),
	(665832, 136, '2015-01-15 00:44:58.000000', 'consum', 0.0253, 'lps'),
	(665833, 136, '2015-01-15 00:44:59.000000', 'consum', 0.0275, 'lps'),
	(665834, 136, '2015-01-15 00:45:00.000000', 'consum', 0.0258, 'lps'),
	(665835, 136, '2015-01-15 00:45:01.000000', 'consum', 0.0256, 'lps'),
	(665836, 136, '2015-01-15 00:45:02.000000', 'consum', 0.0297, 'lps'),
	(665837, 136, '2015-01-15 00:45:03.000000', 'consum', 0.0215, 'lps'),
	(665838, 136, '2015-01-15 00:45:04.000000', 'consum', 0.0267, 'lps'),
	(665839, 136, '2015-01-15 00:45:05.000000', 'consum', 0.0335, 'lps'),
	(665840, 136, '2015-01-15 00:45:06.000000', 'consum', 0.0222, 'lps'),
	(665841, 136, '2015-01-15 00:45:07.000000', 'consum', 0.0336, 'lps'),
	(665842, 136, '2015-01-15 00:45:08.000000', 'consum', 0.0216, 'lps'),
	(665843, 136, '2015-01-15 00:45:09.000000', 'consum', 0.0304, 'lps'),
	(665844, 136, '2015-01-15 00:45:10.000000', 'consum', 0.0220, 'lps'),
	(665845, 136, '2015-01-15 00:45:11.000000', 'consum', 0.0275, 'lps'),
	(665846, 136, '2015-01-15 00:45:12.000000', 'consum', 0.0356, 'lps'),
	(665847, 136, '2015-01-15 00:45:13.000000', 'consum', 0.0308, 'lps'),
	(665848, 136, '2015-01-15 00:45:14.000000', 'consum', 0.0259, 'lps'),
	(665849, 136, '2015-01-15 00:45:15.000000', 'consum', 0.0310, 'lps'),
	(665850, 136, '2015-01-15 00:45:16.000000', 'consum', 0.0268, 'lps'),
	(665851, 136, '2015-01-15 00:45:17.000000', 'consum', 0.0347, 'lps'),
	(665852, 136, '2015-01-15 00:45:18.000000', 'consum', 0.0283, 'lps'),
	(665853, 136, '2015-01-15 00:45:19.000000', 'consum', 0.0310, 'lps'),
	(665854, 136, '2015-01-15 00:45:20.000000', 'consum', 0.0344, 'lps'),
	(665855, 136, '2015-01-15 00:45:21.000000', 'consum', 0.0289, 'lps'),
	(665856, 136, '2015-01-15 00:45:22.000000', 'consum', 0.0347, 'lps'),
	(665857, 136, '2015-01-15 00:45:23.000000', 'consum', 0.0221, 'lps'),
	(665858, 136, '2015-01-15 00:45:24.000000', 'consum', 0.0292, 'lps'),
	(665859, 136, '2015-01-15 00:45:25.000000', 'consum', 0.0296, 'lps'),
	(665860, 136, '2015-01-15 00:45:26.000000', 'consum', 0.0247, 'lps'),
	(665861, 136, '2015-01-15 00:45:27.000000', 'consum', 0.0286, 'lps'),
	(665862, 136, '2015-01-15 00:45:28.000000', 'consum', 0.0331, 'lps'),
	(665863, 136, '2015-01-15 00:45:29.000000', 'consum', 0.0294, 'lps'),
	(665864, 136, '2015-01-15 00:45:30.000000', 'consum', 0.0267, 'lps'),
	(665865, 136, '2015-01-15 00:45:31.000000', 'consum', 0.0244, 'lps'),
	(665866, 136, '2015-01-15 00:45:32.000000', 'consum', 0.0355, 'lps'),
	(665867, 136, '2015-01-15 00:45:33.000000', 'consum', 0.0245, 'lps'),
	(665868, 136, '2015-01-15 00:45:34.000000', 'consum', 0.0245, 'lps'),
	(665869, 136, '2015-01-15 00:45:35.000000', 'consum', 0.0283, 'lps'),
	(665870, 136, '2015-01-15 00:45:36.000000', 'consum', 0.0321, 'lps'),
	(665871, 136, '2015-01-15 00:45:37.000000', 'consum', 0.0251, 'lps'),
	(665872, 136, '2015-01-15 00:45:38.000000', 'consum', 0.0233, 'lps'),
	(665873, 136, '2015-01-15 00:45:39.000000', 'consum', 0.0347, 'lps'),
	(665874, 136, '2015-01-15 00:45:40.000000', 'consum', 0.0239, 'lps'),
	(665875, 136, '2015-01-15 00:45:41.000000', 'consum', 0.0239, 'lps'),
	(665876, 136, '2015-01-15 00:45:42.000000', 'consum', 0.0270, 'lps'),
	(665877, 136, '2015-01-15 00:45:43.000000', 'consum', 0.0274, 'lps'),
	(665878, 136, '2015-01-15 00:45:44.000000', 'consum', 0.0353, 'lps'),
	(665879, 136, '2015-01-15 00:45:45.000000', 'consum', 0.0292, 'lps'),
	(665880, 136, '2015-01-15 00:45:46.000000', 'consum', 0.0337, 'lps'),
	(665881, 136, '2015-01-15 00:45:47.000000', 'consum', 0.0304, 'lps'),
	(665882, 136, '2015-01-15 00:45:48.000000', 'consum', 0.0302, 'lps'),
	(665883, 136, '2015-01-15 00:45:49.000000', 'consum', 0.0242, 'lps'),
	(665884, 136, '2015-01-15 00:45:50.000000', 'consum', 0.0242, 'lps'),
	(665885, 136, '2015-01-15 00:45:51.000000', 'consum', 0.0272, 'lps'),
	(665886, 136, '2015-01-15 00:45:52.000000', 'consum', 0.0279, 'lps'),
	(665887, 136, '2015-01-15 00:45:53.000000', 'consum', 0.0221, 'lps'),
	(665888, 136, '2015-01-15 00:45:54.000000', 'consum', 0.0353, 'lps'),
	(665889, 136, '2015-01-15 00:45:55.000000', 'consum', 0.0305, 'lps'),
	(665890, 136, '2015-01-15 00:45:56.000000', 'consum', 0.0258, 'lps'),
	(665891, 136, '2015-01-15 00:45:57.000000', 'consum', 0.0313, 'lps'),
	(665892, 136, '2015-01-15 00:45:58.000000', 'consum', 0.0285, 'lps'),
	(665893, 136, '2015-01-15 00:45:59.000000', 'consum', 0.0278, 'lps'),
	(665894, 136, '2015-01-15 00:46:00.000000', 'consum', 0.0324, 'lps'),
	(665895, 136, '2015-01-15 00:46:01.000000', 'consum', 0.0285, 'lps'),
	(665896, 136, '2015-01-15 00:46:02.000000', 'consum', 0.0244, 'lps'),
	(665897, 136, '2015-01-15 00:46:03.000000', 'consum', 0.0300, 'lps'),
	(665898, 136, '2015-01-15 00:46:04.000000', 'consum', 0.0264, 'lps'),
	(665899, 136, '2015-01-15 00:46:05.000000', 'consum', 0.0213, 'lps'),
	(665900, 136, '2015-01-15 00:46:06.000000', 'consum', 0.0356, 'lps'),
	(665901, 136, '2015-01-15 00:46:07.000000', 'consum', 0.0345, 'lps'),
	(665902, 136, '2015-01-15 00:46:08.000000', 'consum', 0.0302, 'lps'),
	(665903, 136, '2015-01-15 00:46:09.000000', 'consum', 0.0262, 'lps'),
	(665904, 136, '2015-01-15 00:46:10.000000', 'consum', 0.0344, 'lps'),
	(665905, 136, '2015-01-15 00:46:11.000000', 'consum', 0.0283, 'lps'),
	(665906, 136, '2015-01-15 00:46:12.000000', 'consum', 0.0319, 'lps'),
	(665907, 136, '2015-01-15 00:46:13.000000', 'consum', 0.0243, 'lps'),
	(665908, 136, '2015-01-15 00:46:14.000000', 'consum', 0.0342, 'lps'),
	(665909, 136, '2015-01-15 00:46:15.000000', 'consum', 0.0329, 'lps'),
	(665910, 136, '2015-01-15 00:46:16.000000', 'consum', 0.0265, 'lps'),
	(665911, 136, '2015-01-15 00:46:17.000000', 'consum', 0.0273, 'lps'),
	(665912, 136, '2015-01-15 00:46:18.000000', 'consum', 0.0214, 'lps'),
	(665913, 136, '2015-01-15 00:46:19.000000', 'consum', 0.0337, 'lps'),
	(665914, 136, '2015-01-15 00:46:20.000000', 'consum', 0.0246, 'lps'),
	(665915, 136, '2015-01-15 00:46:21.000000', 'consum', 0.0303, 'lps'),
	(665916, 136, '2015-01-15 00:46:22.000000', 'consum', 0.0272, 'lps'),
	(665917, 136, '2015-01-15 00:46:23.000000', 'consum', 0.0243, 'lps'),
	(665918, 136, '2015-01-15 00:46:24.000000', 'consum', 0.0336, 'lps'),
	(665919, 136, '2015-01-15 00:46:25.000000', 'consum', 0.0300, 'lps'),
	(665920, 136, '2015-01-15 00:46:26.000000', 'consum', 0.0284, 'lps'),
	(665921, 136, '2015-01-15 00:46:27.000000', 'consum', 0.0309, 'lps'),
	(665922, 136, '2015-01-15 00:46:28.000000', 'consum', 0.0336, 'lps'),
	(665923, 136, '2015-01-15 00:46:29.000000', 'consum', 0.0252, 'lps'),
	(665924, 136, '2015-01-15 00:46:30.000000', 'consum', 0.0334, 'lps'),
	(665925, 136, '2015-01-15 00:46:31.000000', 'consum', 0.0263, 'lps'),
	(665926, 136, '2015-01-15 00:46:32.000000', 'consum', 0.0253, 'lps'),
	(665927, 136, '2015-01-15 00:46:33.000000', 'consum', 0.0264, 'lps'),
	(665928, 136, '2015-01-15 00:46:34.000000', 'consum', 0.0354, 'lps'),
	(665929, 136, '2015-01-15 00:46:35.000000', 'consum', 0.0326, 'lps'),
	(665930, 136, '2015-01-15 00:46:36.000000', 'consum', 0.0213, 'lps'),
	(665931, 136, '2015-01-15 00:46:37.000000', 'consum', 0.0316, 'lps'),
	(665932, 136, '2015-01-15 00:46:38.000000', 'consum', 0.0291, 'lps'),
	(665933, 136, '2015-01-15 00:46:39.000000', 'consum', 0.0298, 'lps'),
	(665934, 136, '2015-01-15 00:46:40.000000', 'consum', 0.0262, 'lps'),
	(665935, 136, '2015-01-15 00:46:41.000000', 'consum', 0.0352, 'lps'),
	(665936, 136, '2015-01-15 00:46:42.000000', 'consum', 0.0325, 'lps'),
	(665937, 136, '2015-01-15 00:46:43.000000', 'consum', 0.0214, 'lps'),
	(665938, 136, '2015-01-15 00:46:44.000000', 'consum', 0.0324, 'lps'),
	(665939, 136, '2015-01-15 00:46:45.000000', 'consum', 0.0326, 'lps'),
	(665940, 136, '2015-01-15 00:46:46.000000', 'consum', 0.0303, 'lps'),
	(665941, 136, '2015-01-15 00:46:47.000000', 'consum', 0.0328, 'lps'),
	(665942, 136, '2015-01-15 00:46:48.000000', 'consum', 0.0227, 'lps'),
	(665943, 136, '2015-01-15 00:46:49.000000', 'consum', 0.0234, 'lps'),
	(665944, 136, '2015-01-15 00:46:50.000000', 'consum', 0.0281, 'lps'),
	(665945, 136, '2015-01-15 00:46:51.000000', 'consum', 0.0347, 'lps'),
	(665946, 136, '2015-01-15 00:46:52.000000', 'consum', 0.0241, 'lps'),
	(665947, 136, '2015-01-15 00:46:53.000000', 'consum', 0.0251, 'lps'),
	(665948, 136, '2015-01-15 00:46:54.000000', 'consum', 0.0319, 'lps'),
	(665949, 136, '2015-01-15 00:46:55.000000', 'consum', 0.0340, 'lps'),
	(665950, 136, '2015-01-15 00:46:56.000000', 'consum', 0.0239, 'lps'),
	(665951, 136, '2015-01-15 00:46:57.000000', 'consum', 0.0258, 'lps'),
	(665952, 136, '2015-01-15 00:46:58.000000', 'consum', 0.0219, 'lps'),
	(665953, 136, '2015-01-15 00:46:59.000000', 'consum', 0.0260, 'lps'),
	(665954, 136, '2015-01-15 00:47:00.000000', 'consum', 0.0284, 'lps'),
	(665955, 136, '2015-01-15 00:47:01.000000', 'consum', 0.0283, 'lps'),
	(665956, 136, '2015-01-15 00:47:02.000000', 'consum', 0.0353, 'lps'),
	(665957, 136, '2015-01-15 00:47:03.000000', 'consum', 0.0267, 'lps'),
	(665958, 136, '2015-01-15 00:47:04.000000', 'consum', 0.0213, 'lps'),
	(665959, 136, '2015-01-15 00:47:05.000000', 'consum', 0.0350, 'lps'),
	(665960, 136, '2015-01-15 00:47:06.000000', 'consum', 0.0314, 'lps'),
	(665961, 136, '2015-01-15 00:47:07.000000', 'consum', 0.0309, 'lps'),
	(665962, 136, '2015-01-15 00:47:08.000000', 'consum', 0.0246, 'lps'),
	(665963, 136, '2015-01-15 00:47:09.000000', 'consum', 0.0239, 'lps'),
	(665964, 136, '2015-01-15 00:47:10.000000', 'consum', 0.0249, 'lps'),
	(665965, 136, '2015-01-15 00:47:11.000000', 'consum', 0.0318, 'lps'),
	(665966, 136, '2015-01-15 00:47:12.000000', 'consum', 0.0338, 'lps'),
	(665967, 136, '2015-01-15 00:47:13.000000', 'consum', 0.0232, 'lps'),
	(665968, 136, '2015-01-15 00:47:14.000000', 'consum', 0.0234, 'lps'),
	(665969, 136, '2015-01-15 00:47:15.000000', 'consum', 0.0262, 'lps'),
	(665970, 136, '2015-01-15 00:47:16.000000', 'consum', 0.0250, 'lps'),
	(665971, 136, '2015-01-15 00:47:17.000000', 'consum', 0.0257, 'lps'),
	(665972, 136, '2015-01-15 00:47:18.000000', 'consum', 0.0327, 'lps'),
	(665973, 136, '2015-01-15 00:47:19.000000', 'consum', 0.0211, 'lps'),
	(665974, 136, '2015-01-15 00:47:20.000000', 'consum', 0.0308, 'lps'),
	(665975, 136, '2015-01-15 00:47:21.000000', 'consum', 0.0254, 'lps'),
	(665976, 136, '2015-01-15 00:47:22.000000', 'consum', 0.0285, 'lps'),
	(665977, 136, '2015-01-15 00:47:23.000000', 'consum', 0.0306, 'lps'),
	(665978, 136, '2015-01-15 00:47:24.000000', 'consum', 0.0320, 'lps'),
	(665979, 136, '2015-01-15 00:47:25.000000', 'consum', 0.0322, 'lps'),
	(665980, 136, '2015-01-15 00:47:26.000000', 'consum', 0.0297, 'lps'),
	(665981, 136, '2015-01-15 00:47:27.000000', 'consum', 0.0309, 'lps'),
	(665982, 136, '2015-01-15 00:47:28.000000', 'consum', 0.0295, 'lps'),
	(665983, 136, '2015-01-15 00:47:29.000000', 'consum', 0.0341, 'lps'),
	(665984, 136, '2015-01-15 00:47:30.000000', 'consum', 0.0317, 'lps'),
	(665985, 136, '2015-01-15 00:47:31.000000', 'consum', 0.0352, 'lps'),
	(665986, 136, '2015-01-15 00:47:32.000000', 'consum', 0.0303, 'lps'),
	(665987, 136, '2015-01-15 00:47:33.000000', 'consum', 0.0253, 'lps'),
	(665988, 136, '2015-01-15 00:47:34.000000', 'consum', 0.0293, 'lps'),
	(665989, 136, '2015-01-15 00:47:35.000000', 'consum', 0.0348, 'lps'),
	(665990, 136, '2015-01-15 00:47:36.000000', 'consum', 0.0211, 'lps'),
	(665991, 136, '2015-01-15 00:47:37.000000', 'consum', 0.0241, 'lps'),
	(665992, 136, '2015-01-15 00:47:38.000000', 'consum', 0.0215, 'lps'),
	(665993, 136, '2015-01-15 00:47:39.000000', 'consum', 0.0289, 'lps'),
	(665994, 136, '2015-01-15 00:47:40.000000', 'consum', 0.0298, 'lps'),
	(665995, 136, '2015-01-15 00:47:41.000000', 'consum', 0.0266, 'lps'),
	(665996, 136, '2015-01-15 00:47:42.000000', 'consum', 0.0227, 'lps'),
	(665997, 136, '2015-01-15 00:47:43.000000', 'consum', 0.0275, 'lps'),
	(665998, 136, '2015-01-15 00:47:44.000000', 'consum', 0.0337, 'lps'),
	(665999, 136, '2015-01-15 00:47:45.000000', 'consum', 0.0210, 'lps'),
	(666000, 136, '2015-01-15 00:47:46.000000', 'consum', 0.0272, 'lps'),
	(666001, 136, '2015-01-15 00:47:47.000000', 'consum', 0.0224, 'lps'),
	(666002, 136, '2015-01-15 00:47:48.000000', 'consum', 0.0242, 'lps'),
	(666003, 136, '2015-01-15 00:47:49.000000', 'consum', 0.0330, 'lps'),
	(666004, 136, '2015-01-15 00:47:50.000000', 'consum', 0.0272, 'lps'),
	(666005, 136, '2015-01-15 00:47:51.000000', 'consum', 0.0308, 'lps'),
	(666006, 136, '2015-01-15 00:47:52.000000', 'consum', 0.0221, 'lps'),
	(666007, 136, '2015-01-15 00:47:53.000000', 'consum', 0.0266, 'lps'),
	(666008, 136, '2015-01-15 00:47:54.000000', 'consum', 0.0308, 'lps'),
	(666009, 136, '2015-01-15 00:47:55.000000', 'consum', 0.0241, 'lps'),
	(666010, 136, '2015-01-15 00:47:56.000000', 'consum', 0.0218, 'lps'),
	(666011, 136, '2015-01-15 00:47:57.000000', 'consum', 0.0306, 'lps'),
	(666012, 136, '2015-01-15 00:47:58.000000', 'consum', 0.0222, 'lps'),
	(666013, 136, '2015-01-15 00:47:59.000000', 'consum', 0.0280, 'lps'),
	(666014, 136, '2015-01-15 00:48:00.000000', 'consum', 0.0229, 'lps'),
	(666015, 136, '2015-01-15 00:48:01.000000', 'consum', 0.0244, 'lps'),
	(666016, 136, '2015-01-15 00:48:02.000000', 'consum', 0.0324, 'lps'),
	(666017, 136, '2015-01-15 00:48:03.000000', 'consum', 0.0238, 'lps'),
	(666018, 136, '2015-01-15 00:48:04.000000', 'consum', 0.0303, 'lps'),
	(666019, 136, '2015-01-15 00:48:05.000000', 'consum', 0.0297, 'lps'),
	(666020, 136, '2015-01-15 00:48:06.000000', 'consum', 0.0220, 'lps'),
	(666021, 136, '2015-01-15 00:48:07.000000', 'consum', 0.0294, 'lps'),
	(666022, 136, '2015-01-15 00:48:08.000000', 'consum', 0.0307, 'lps'),
	(666023, 136, '2015-01-15 00:48:09.000000', 'consum', 0.0296, 'lps'),
	(666024, 136, '2015-01-15 00:48:10.000000', 'consum', 0.0351, 'lps'),
	(666025, 136, '2015-01-15 00:48:11.000000', 'consum', 0.0213, 'lps'),
	(666026, 136, '2015-01-15 00:48:12.000000', 'consum', 0.0246, 'lps'),
	(666027, 136, '2015-01-15 00:48:13.000000', 'consum', 0.0235, 'lps'),
	(666028, 136, '2015-01-15 00:48:14.000000', 'consum', 0.0226, 'lps'),
	(666029, 136, '2015-01-15 00:48:15.000000', 'consum', 0.0214, 'lps'),
	(666030, 136, '2015-01-15 00:48:16.000000', 'consum', 0.0333, 'lps'),
	(666031, 136, '2015-01-15 00:48:17.000000', 'consum', 0.0223, 'lps'),
	(666032, 136, '2015-01-15 00:48:18.000000', 'consum', 0.0350, 'lps'),
	(666033, 136, '2015-01-15 00:48:19.000000', 'consum', 0.0282, 'lps'),
	(666034, 136, '2015-01-15 00:48:20.000000', 'consum', 0.0297, 'lps'),
	(666035, 136, '2015-01-15 00:48:21.000000', 'consum', 0.0283, 'lps'),
	(666036, 136, '2015-01-15 00:48:22.000000', 'consum', 0.0317, 'lps'),
	(666037, 136, '2015-01-15 00:48:23.000000', 'consum', 0.0229, 'lps'),
	(666038, 136, '2015-01-15 00:48:24.000000', 'consum', 0.0279, 'lps'),
	(666039, 136, '2015-01-15 00:48:25.000000', 'consum', 0.0350, 'lps'),
	(666040, 136, '2015-01-15 00:48:26.000000', 'consum', 0.0265, 'lps'),
	(666041, 136, '2015-01-15 00:48:27.000000', 'consum', 0.0212, 'lps'),
	(666042, 136, '2015-01-15 00:48:28.000000', 'consum', 0.0348, 'lps'),
	(666043, 136, '2015-01-15 00:48:29.000000', 'consum', 0.0307, 'lps'),
	(666044, 136, '2015-01-15 00:48:30.000000', 'consum', 0.0283, 'lps'),
	(666045, 136, '2015-01-15 00:48:31.000000', 'consum', 0.0282, 'lps'),
	(666046, 136, '2015-01-15 00:48:32.000000', 'consum', 0.0352, 'lps'),
	(666047, 136, '2015-01-15 00:48:33.000000', 'consum', 0.0265, 'lps'),
	(666048, 136, '2015-01-15 00:48:34.000000', 'consum', 0.0351, 'lps'),
	(666049, 136, '2015-01-15 00:48:35.000000', 'consum', 0.0312, 'lps'),
	(666050, 136, '2015-01-15 00:48:36.000000', 'consum', 0.0298, 'lps'),
	(666051, 136, '2015-01-15 00:48:37.000000', 'consum', 0.0341, 'lps'),
	(666052, 136, '2015-01-15 00:48:38.000000', 'consum', 0.0311, 'lps'),
	(666053, 136, '2015-01-15 00:48:39.000000', 'consum', 0.0323, 'lps'),
	(666054, 136, '2015-01-15 00:48:40.000000', 'consum', 0.0324, 'lps'),
	(666055, 136, '2015-01-15 00:48:41.000000', 'consum', 0.0293, 'lps'),
	(666056, 136, '2015-01-15 00:48:42.000000', 'consum', 0.0285, 'lps'),
	(666057, 136, '2015-01-15 00:48:43.000000', 'consum', 0.0335, 'lps'),
	(666058, 136, '2015-01-15 00:48:44.000000', 'consum', 0.0316, 'lps'),
	(666059, 136, '2015-01-15 00:48:45.000000', 'consum', 0.0220, 'lps'),
	(666060, 136, '2015-01-15 00:48:46.000000', 'consum', 0.0237, 'lps'),
	(666061, 136, '2015-01-15 00:48:47.000000', 'consum', 0.0317, 'lps'),
	(666062, 136, '2015-01-15 00:48:48.000000', 'consum', 0.0222, 'lps'),
	(666063, 136, '2015-01-15 00:48:49.000000', 'consum', 0.0242, 'lps'),
	(666064, 136, '2015-01-15 00:48:50.000000', 'consum', 0.0334, 'lps'),
	(666065, 136, '2015-01-15 00:48:51.000000', 'consum', 0.0295, 'lps'),
	(666066, 136, '2015-01-15 00:48:52.000000', 'consum', 0.0263, 'lps'),
	(666067, 136, '2015-01-15 00:48:53.000000', 'consum', 0.0221, 'lps'),
	(666068, 136, '2015-01-15 00:48:54.000000', 'consum', 0.0255, 'lps'),
	(666069, 136, '2015-01-15 00:48:55.000000', 'consum', 0.0252, 'lps'),
	(666070, 136, '2015-01-15 00:48:56.000000', 'consum', 0.0288, 'lps'),
	(666071, 136, '2015-01-15 00:48:57.000000', 'consum', 0.0326, 'lps'),
	(666072, 136, '2015-01-15 00:48:58.000000', 'consum', 0.0262, 'lps'),
	(666073, 136, '2015-01-15 00:48:59.000000', 'consum', 0.0270, 'lps'),
	(666074, 136, '2015-01-15 00:49:00.000000', 'consum', 0.0355, 'lps'),
	(666075, 136, '2015-01-15 00:49:01.000000', 'consum', 0.0316, 'lps'),
	(666076, 136, '2015-01-15 00:49:02.000000', 'consum', 0.0304, 'lps'),
	(666077, 136, '2015-01-15 00:49:03.000000', 'consum', 0.0214, 'lps'),
	(666078, 136, '2015-01-15 00:49:04.000000', 'consum', 0.0245, 'lps'),
	(666079, 136, '2015-01-15 00:49:05.000000', 'consum', 0.0227, 'lps'),
	(666080, 136, '2015-01-15 00:49:06.000000', 'consum', 0.0339, 'lps'),
	(666081, 136, '2015-01-15 00:49:07.000000', 'consum', 0.0213, 'lps'),
	(666082, 136, '2015-01-15 00:49:08.000000', 'consum', 0.0280, 'lps'),
	(666083, 136, '2015-01-15 00:49:09.000000', 'consum', 0.0260, 'lps'),
	(666084, 136, '2015-01-15 00:49:10.000000', 'consum', 0.0250, 'lps'),
	(666085, 136, '2015-01-15 00:49:11.000000', 'consum', 0.0259, 'lps'),
	(666086, 136, '2015-01-15 00:49:12.000000', 'consum', 0.0335, 'lps'),
	(666087, 136, '2015-01-15 00:49:13.000000', 'consum', 0.0247, 'lps'),
	(666088, 136, '2015-01-15 00:49:14.000000', 'consum', 0.0316, 'lps'),
	(666089, 136, '2015-01-15 00:49:15.000000', 'consum', 0.0335, 'lps'),
	(666090, 136, '2015-01-15 00:49:16.000000', 'consum', 0.0223, 'lps'),
	(666091, 136, '2015-01-15 00:49:17.000000', 'consum', 0.0344, 'lps'),
	(666092, 136, '2015-01-15 00:49:18.000000', 'consum', 0.0252, 'lps'),
	(666093, 136, '2015-01-15 00:49:19.000000', 'consum', 0.0313, 'lps'),
	(666094, 136, '2015-01-15 00:49:20.000000', 'consum', 0.0306, 'lps'),
	(666095, 136, '2015-01-15 00:49:21.000000', 'consum', 0.0233, 'lps'),
	(666096, 136, '2015-01-15 00:49:22.000000', 'consum', 0.0331, 'lps'),
	(666097, 136, '2015-01-15 00:49:23.000000', 'consum', 0.0305, 'lps'),
	(666098, 136, '2015-01-15 00:49:24.000000', 'consum', 0.0324, 'lps'),
	(666099, 136, '2015-01-15 00:49:25.000000', 'consum', 0.0350, 'lps'),
	(666100, 136, '2015-01-15 00:49:26.000000', 'consum', 0.0274, 'lps'),
	(666101, 136, '2015-01-15 00:49:27.000000', 'consum', 0.0257, 'lps'),
	(666102, 136, '2015-01-15 00:49:28.000000', 'consum', 0.0255, 'lps'),
	(666103, 136, '2015-01-15 00:49:29.000000', 'consum', 0.0294, 'lps'),
	(666104, 136, '2015-01-15 00:49:30.000000', 'consum', 0.0347, 'lps'),
	(666105, 136, '2015-01-15 00:49:31.000000', 'consum', 0.0351, 'lps'),
	(666106, 136, '2015-01-15 00:49:32.000000', 'consum', 0.0211, 'lps'),
	(666107, 136, '2015-01-15 00:49:33.000000', 'consum', 0.0234, 'lps'),
	(666108, 136, '2015-01-15 00:49:34.000000', 'consum', 0.0328, 'lps'),
	(666109, 136, '2015-01-15 00:49:35.000000', 'consum', 0.0287, 'lps'),
	(666110, 136, '2015-01-15 00:49:36.000000', 'consum', 0.0239, 'lps'),
	(666111, 136, '2015-01-15 00:49:37.000000', 'consum', 0.0275, 'lps'),
	(666112, 136, '2015-01-15 00:49:38.000000', 'consum', 0.0299, 'lps'),
	(666113, 136, '2015-01-15 00:49:39.000000', 'consum', 0.0316, 'lps'),
	(666114, 136, '2015-01-15 00:49:40.000000', 'consum', 0.0326, 'lps'),
	(666115, 136, '2015-01-15 00:49:41.000000', 'consum', 0.0327, 'lps'),
	(666116, 136, '2015-01-15 00:49:42.000000', 'consum', 0.0299, 'lps'),
	(666117, 136, '2015-01-15 00:49:43.000000', 'consum', 0.0306, 'lps'),
	(666118, 136, '2015-01-15 00:49:44.000000', 'consum', 0.0276, 'lps'),
	(666119, 136, '2015-01-15 00:49:45.000000', 'consum', 0.0250, 'lps'),
	(666120, 136, '2015-01-15 00:49:46.000000', 'consum', 0.0215, 'lps'),
	(666121, 136, '2015-01-15 00:49:47.000000', 'consum', 0.0263, 'lps'),
	(666122, 136, '2015-01-15 00:49:48.000000', 'consum', 0.0313, 'lps'),
	(666123, 136, '2015-01-15 00:49:49.000000', 'consum', 0.0272, 'lps'),
	(666124, 136, '2015-01-15 00:49:50.000000', 'consum', 0.0213, 'lps'),
	(666125, 136, '2015-01-15 00:49:51.000000', 'consum', 0.0332, 'lps'),
	(666126, 136, '2015-01-15 00:49:52.000000', 'consum', 0.0222, 'lps'),
	(666127, 136, '2015-01-15 00:49:53.000000', 'consum', 0.0347, 'lps'),
	(666128, 136, '2015-01-15 00:49:54.000000', 'consum', 0.0270, 'lps'),
	(666129, 136, '2015-01-15 00:49:55.000000', 'consum', 0.0248, 'lps'),
	(666130, 136, '2015-01-15 00:49:56.000000', 'consum', 0.0221, 'lps'),
	(666131, 136, '2015-01-15 00:49:57.000000', 'consum', 0.0299, 'lps'),
	(666132, 136, '2015-01-15 00:49:58.000000', 'consum', 0.0328, 'lps'),
	(666133, 136, '2015-01-15 00:49:59.000000', 'consum', 0.0240, 'lps'),
	(666134, 136, '2015-01-15 00:50:00.000000', 'consum', 0.0300, 'lps'),
	(666135, 136, '2015-01-15 00:50:01.000000', 'consum', 0.0277, 'lps'),
	(666136, 136, '2015-01-15 00:50:02.000000', 'consum', 0.0273, 'lps'),
	(666137, 136, '2015-01-15 00:50:03.000000', 'consum', 0.0326, 'lps'),
	(666138, 136, '2015-01-15 00:50:04.000000', 'consum', 0.0308, 'lps'),
	(666139, 136, '2015-01-15 00:50:05.000000', 'consum', 0.0352, 'lps'),
	(666140, 136, '2015-01-15 00:50:06.000000', 'consum', 0.0334, 'lps'),
	(666141, 136, '2015-01-15 00:50:07.000000', 'consum', 0.0258, 'lps'),
	(666142, 136, '2015-01-15 00:50:08.000000', 'consum', 0.0224, 'lps'),
	(666143, 136, '2015-01-15 00:50:09.000000', 'consum', 0.0286, 'lps'),
	(666144, 136, '2015-01-15 00:50:10.000000', 'consum', 0.0253, 'lps'),
	(666145, 136, '2015-01-15 00:50:11.000000', 'consum', 0.0343, 'lps'),
	(666146, 136, '2015-01-15 00:50:12.000000', 'consum', 0.0307, 'lps'),
	(666147, 136, '2015-01-15 00:50:13.000000', 'consum', 0.0295, 'lps'),
	(666148, 136, '2015-01-15 00:50:14.000000', 'consum', 0.0344, 'lps'),
	(666149, 136, '2015-01-15 00:50:15.000000', 'consum', 0.0330, 'lps'),
	(666150, 136, '2015-01-15 00:50:16.000000', 'consum', 0.0265, 'lps'),
	(666151, 136, '2015-01-15 00:50:17.000000', 'consum', 0.0270, 'lps'),
	(666152, 136, '2015-01-15 00:50:18.000000', 'consum', 0.0348, 'lps'),
	(666153, 136, '2015-01-15 00:50:19.000000', 'consum', 0.0279, 'lps'),
	(666154, 136, '2015-01-15 00:50:20.000000', 'consum', 0.0289, 'lps'),
	(666155, 136, '2015-01-15 00:50:21.000000', 'consum', 0.0253, 'lps'),
	(666156, 136, '2015-01-15 00:50:22.000000', 'consum', 0.0332, 'lps'),
	(666157, 136, '2015-01-15 00:50:23.000000', 'consum', 0.0253, 'lps'),
	(666158, 136, '2015-01-15 00:50:24.000000', 'consum', 0.0353, 'lps'),
	(666159, 136, '2015-01-15 00:50:25.000000', 'consum', 0.0355, 'lps'),
	(666160, 136, '2015-01-15 00:50:26.000000', 'consum', 0.0214, 'lps'),
	(666161, 136, '2015-01-15 00:50:27.000000', 'consum', 0.0234, 'lps'),
	(666162, 136, '2015-01-15 00:50:28.000000', 'consum', 0.0321, 'lps'),
	(666163, 136, '2015-01-15 00:50:29.000000', 'consum', 0.0250, 'lps'),
	(666164, 136, '2015-01-15 00:50:30.000000', 'consum', 0.0225, 'lps'),
	(666165, 136, '2015-01-15 00:50:31.000000', 'consum', 0.0315, 'lps'),
	(666166, 136, '2015-01-15 00:50:32.000000', 'consum', 0.0248, 'lps'),
	(666167, 136, '2015-01-15 00:50:33.000000', 'consum', 0.0232, 'lps'),
	(666168, 136, '2015-01-15 00:50:34.000000', 'consum', 0.0356, 'lps'),
	(666169, 136, '2015-01-15 00:50:35.000000', 'consum', 0.0284, 'lps'),
	(666170, 136, '2015-01-15 00:50:36.000000', 'consum', 0.0289, 'lps'),
	(666171, 136, '2015-01-15 00:50:37.000000', 'consum', 0.0239, 'lps'),
	(666172, 136, '2015-01-15 00:50:38.000000', 'consum', 0.0263, 'lps'),
	(666173, 136, '2015-01-15 00:50:39.000000', 'consum', 0.0242, 'lps'),
	(666174, 136, '2015-01-15 00:50:40.000000', 'consum', 0.0212, 'lps'),
	(666175, 136, '2015-01-15 00:50:41.000000', 'consum', 0.0272, 'lps'),
	(666176, 136, '2015-01-15 00:50:42.000000', 'consum', 0.0222, 'lps'),
	(666177, 136, '2015-01-15 00:50:43.000000', 'consum', 0.0229, 'lps'),
	(666178, 136, '2015-01-15 00:50:44.000000', 'consum', 0.0272, 'lps'),
	(666179, 136, '2015-01-15 00:50:45.000000', 'consum', 0.0315, 'lps'),
	(666180, 136, '2015-01-15 00:50:46.000000', 'consum', 0.0257, 'lps'),
	(666181, 136, '2015-01-15 00:50:47.000000', 'consum', 0.0276, 'lps'),
	(666182, 136, '2015-01-15 00:50:48.000000', 'consum', 0.0253, 'lps'),
	(666183, 136, '2015-01-15 00:50:49.000000', 'consum', 0.0226, 'lps'),
	(666184, 136, '2015-01-15 00:50:50.000000', 'consum', 0.0309, 'lps'),
	(666185, 136, '2015-01-15 00:50:51.000000', 'consum', 0.0217, 'lps'),
	(666186, 136, '2015-01-15 00:50:52.000000', 'consum', 0.0241, 'lps'),
	(666187, 136, '2015-01-15 00:50:53.000000', 'consum', 0.0347, 'lps'),
	(666188, 136, '2015-01-15 00:50:54.000000', 'consum', 0.0215, 'lps'),
	(666189, 136, '2015-01-15 00:50:55.000000', 'consum', 0.0266, 'lps'),
	(666190, 136, '2015-01-15 00:50:56.000000', 'consum', 0.0327, 'lps'),
	(666191, 136, '2015-01-15 00:50:57.000000', 'consum', 0.0333, 'lps'),
	(666192, 136, '2015-01-15 00:50:58.000000', 'consum', 0.0330, 'lps'),
	(666193, 136, '2015-01-15 00:50:59.000000', 'consum', 0.0292, 'lps'),
	(666194, 136, '2015-01-15 00:51:00.000000', 'consum', 0.0260, 'lps'),
	(666195, 136, '2015-01-15 00:51:01.000000', 'consum', 0.0215, 'lps'),
	(666196, 136, '2015-01-15 00:51:02.000000', 'consum', 0.0232, 'lps'),
	(666197, 136, '2015-01-15 00:51:03.000000', 'consum', 0.0305, 'lps'),
	(666198, 136, '2015-01-15 00:51:04.000000', 'consum', 0.0327, 'lps'),
	(666199, 136, '2015-01-15 00:51:05.000000', 'consum', 0.0217, 'lps'),
	(666200, 136, '2015-01-15 00:51:06.000000', 'consum', 0.0333, 'lps'),
	(666201, 136, '2015-01-15 00:51:07.000000', 'consum', 0.0220, 'lps'),
	(666202, 136, '2015-01-15 00:51:08.000000', 'consum', 0.0329, 'lps'),
	(666203, 136, '2015-01-15 00:51:09.000000', 'consum', 0.0335, 'lps'),
	(666204, 136, '2015-01-15 00:51:10.000000', 'consum', 0.0333, 'lps'),
	(666205, 136, '2015-01-15 00:51:11.000000', 'consum', 0.0303, 'lps'),
	(666206, 136, '2015-01-15 00:51:12.000000', 'consum', 0.0307, 'lps'),
	(666207, 136, '2015-01-15 00:51:13.000000', 'consum', 0.0268, 'lps'),
	(666208, 136, '2015-01-15 00:51:14.000000', 'consum', 0.0356, 'lps'),
	(666209, 136, '2015-01-15 00:51:15.000000', 'consum', 0.0325, 'lps'),
	(666210, 136, '2015-01-15 00:51:16.000000', 'consum', 0.0349, 'lps'),
	(666211, 136, '2015-01-15 00:51:17.000000', 'consum', 0.0265, 'lps'),
	(666212, 136, '2015-01-15 00:51:18.000000', 'consum', 0.0216, 'lps'),
	(666213, 136, '2015-01-15 00:51:19.000000', 'consum', 0.0221, 'lps'),
	(666214, 136, '2015-01-15 00:51:20.000000', 'consum', 0.0248, 'lps'),
	(666215, 136, '2015-01-15 00:51:21.000000', 'consum', 0.0222, 'lps'),
	(666216, 136, '2015-01-15 00:51:22.000000', 'consum', 0.0304, 'lps'),
	(666217, 136, '2015-01-15 00:51:23.000000', 'consum', 0.0349, 'lps'),
	(666218, 136, '2015-01-15 00:51:24.000000', 'consum', 0.0330, 'lps'),
	(666219, 136, '2015-01-15 00:51:25.000000', 'consum', 0.0246, 'lps'),
	(666220, 136, '2015-01-15 00:51:26.000000', 'consum', 0.0325, 'lps'),
	(666221, 136, '2015-01-15 00:51:27.000000', 'consum', 0.0237, 'lps'),
	(666222, 136, '2015-01-15 00:51:28.000000', 'consum', 0.0293, 'lps'),
	(666223, 136, '2015-01-15 00:51:29.000000', 'consum', 0.0252, 'lps'),
	(666224, 136, '2015-01-15 00:51:30.000000', 'consum', 0.0317, 'lps'),
	(666225, 136, '2015-01-15 00:51:31.000000', 'consum', 0.0325, 'lps'),
	(666226, 136, '2015-01-15 00:51:32.000000', 'consum', 0.0318, 'lps'),
	(666227, 136, '2015-01-15 00:51:33.000000', 'consum', 0.0260, 'lps'),
	(666228, 136, '2015-01-15 00:51:34.000000', 'consum', 0.0282, 'lps'),
	(666229, 136, '2015-01-15 00:51:35.000000', 'consum', 0.0273, 'lps'),
	(666230, 136, '2015-01-15 00:51:36.000000', 'consum', 0.0311, 'lps'),
	(666231, 136, '2015-01-15 00:51:37.000000', 'consum', 0.0233, 'lps'),
	(666232, 136, '2015-01-15 00:51:38.000000', 'consum', 0.0315, 'lps'),
	(666233, 136, '2015-01-15 00:51:39.000000', 'consum', 0.0228, 'lps'),
	(666234, 136, '2015-01-15 00:51:40.000000', 'consum', 0.0277, 'lps'),
	(666235, 136, '2015-01-15 00:51:41.000000', 'consum', 0.0345, 'lps'),
	(666236, 136, '2015-01-15 00:51:42.000000', 'consum', 0.0245, 'lps'),
	(666237, 136, '2015-01-15 00:51:43.000000', 'consum', 0.0273, 'lps'),
	(666238, 136, '2015-01-15 00:51:44.000000', 'consum', 0.0275, 'lps'),
	(666239, 136, '2015-01-15 00:51:45.000000', 'consum', 0.0346, 'lps'),
	(666240, 136, '2015-01-15 00:51:46.000000', 'consum', 0.0254, 'lps'),
	(666241, 136, '2015-01-15 00:51:47.000000', 'consum', 0.0318, 'lps'),
	(666242, 136, '2015-01-15 00:51:48.000000', 'consum', 0.0322, 'lps'),
	(666243, 136, '2015-01-15 00:51:49.000000', 'consum', 0.0302, 'lps'),
	(666244, 136, '2015-01-15 00:51:50.000000', 'consum', 0.0332, 'lps'),
	(666245, 136, '2015-01-15 00:51:51.000000', 'consum', 0.0251, 'lps'),
	(666246, 136, '2015-01-15 00:51:52.000000', 'consum', 0.0345, 'lps'),
	(666247, 136, '2015-01-15 00:51:53.000000', 'consum', 0.0322, 'lps'),
	(666248, 136, '2015-01-15 00:51:54.000000', 'consum', 0.0217, 'lps'),
	(666249, 136, '2015-01-15 00:51:55.000000', 'consum', 0.0351, 'lps'),
	(666250, 136, '2015-01-15 00:51:56.000000', 'consum', 0.0307, 'lps'),
	(666251, 136, '2015-01-15 00:51:57.000000', 'consum', 0.0271, 'lps'),
	(666252, 136, '2015-01-15 00:51:58.000000', 'consum', 0.0224, 'lps'),
	(666253, 136, '2015-01-15 00:51:59.000000', 'consum', 0.0246, 'lps'),
	(666254, 136, '2015-01-15 00:52:00.000000', 'consum', 0.0349, 'lps'),
	(666255, 136, '2015-01-15 00:52:01.000000', 'consum', 0.0211, 'lps'),
	(666256, 136, '2015-01-15 00:52:02.000000', 'consum', 0.0236, 'lps'),
	(666257, 136, '2015-01-15 00:52:03.000000', 'consum', 0.0340, 'lps'),
	(666258, 136, '2015-01-15 00:52:04.000000', 'consum', 0.0342, 'lps'),
	(666259, 136, '2015-01-15 00:52:05.000000', 'consum', 0.0334, 'lps'),
	(666260, 136, '2015-01-15 00:52:06.000000', 'consum', 0.0288, 'lps'),
	(666261, 136, '2015-01-15 00:52:07.000000', 'consum', 0.0226, 'lps'),
	(666262, 136, '2015-01-15 00:52:08.000000', 'consum', 0.0351, 'lps'),
	(666263, 136, '2015-01-15 00:52:09.000000', 'consum', 0.0279, 'lps'),
	(666264, 136, '2015-01-15 00:52:10.000000', 'consum', 0.0279, 'lps'),
	(666265, 136, '2015-01-15 00:52:11.000000', 'consum', 0.0349, 'lps'),
	(666266, 136, '2015-01-15 00:52:12.000000', 'consum', 0.0257, 'lps'),
	(666267, 136, '2015-01-15 00:52:13.000000', 'consum', 0.0323, 'lps'),
	(666268, 136, '2015-01-15 00:52:14.000000', 'consum', 0.0342, 'lps'),
	(666269, 136, '2015-01-15 00:52:15.000000', 'consum', 0.0235, 'lps'),
	(666270, 136, '2015-01-15 00:52:16.000000', 'consum', 0.0234, 'lps'),
	(666271, 136, '2015-01-15 00:52:17.000000', 'consum', 0.0257, 'lps'),
	(666272, 136, '2015-01-15 00:52:18.000000', 'consum', 0.0225, 'lps'),
	(666273, 136, '2015-01-15 00:52:19.000000', 'consum', 0.0293, 'lps'),
	(666274, 136, '2015-01-15 00:52:20.000000', 'consum', 0.0287, 'lps'),
	(666275, 136, '2015-01-15 00:52:21.000000', 'consum', 0.0345, 'lps'),
	(666276, 136, '2015-01-15 00:52:22.000000', 'consum', 0.0214, 'lps'),
	(666277, 136, '2015-01-15 00:52:23.000000', 'consum', 0.0269, 'lps'),
	(666278, 136, '2015-01-15 00:52:24.000000', 'consum', 0.0343, 'lps'),
	(666279, 136, '2015-01-15 00:52:25.000000', 'consum', 0.0258, 'lps'),
	(666280, 136, '2015-01-15 00:52:26.000000', 'consum', 0.0344, 'lps'),
	(666281, 136, '2015-01-15 00:52:27.000000', 'consum', 0.0298, 'lps'),
	(666282, 136, '2015-01-15 00:52:28.000000', 'consum', 0.0247, 'lps'),
	(666283, 136, '2015-01-15 00:52:29.000000', 'consum', 0.0279, 'lps'),
	(666284, 136, '2015-01-15 00:52:30.000000', 'consum', 0.0298, 'lps'),
	(666285, 136, '2015-01-15 00:52:31.000000', 'consum', 0.0296, 'lps'),
	(666286, 136, '2015-01-15 00:52:32.000000', 'consum', 0.0232, 'lps'),
	(666287, 136, '2015-01-15 00:52:33.000000', 'consum', 0.0353, 'lps'),
	(666288, 136, '2015-01-15 00:52:34.000000', 'consum', 0.0272, 'lps'),
	(666289, 136, '2015-01-15 00:52:35.000000', 'consum', 0.0238, 'lps'),
	(666290, 136, '2015-01-15 00:52:36.000000', 'consum', 0.0311, 'lps'),
	(666291, 136, '2015-01-15 00:52:37.000000', 'consum', 0.0340, 'lps'),
	(666292, 136, '2015-01-15 00:52:38.000000', 'consum', 0.0263, 'lps'),
	(666293, 136, '2015-01-15 00:52:39.000000', 'consum', 0.0230, 'lps'),
	(666294, 136, '2015-01-15 00:52:40.000000', 'consum', 0.0300, 'lps'),
	(666295, 136, '2015-01-15 00:52:41.000000', 'consum', 0.0307, 'lps'),
	(666296, 136, '2015-01-15 00:52:42.000000', 'consum', 0.0277, 'lps'),
	(666297, 136, '2015-01-15 00:52:43.000000', 'consum', 0.0253, 'lps'),
	(666298, 136, '2015-01-15 00:52:44.000000', 'consum', 0.0227, 'lps'),
	(666299, 136, '2015-01-15 00:52:45.000000', 'consum', 0.0315, 'lps'),
	(666300, 136, '2015-01-15 00:52:46.000000', 'consum', 0.0242, 'lps'),
	(666301, 136, '2015-01-15 00:52:47.000000', 'consum', 0.0347, 'lps'),
	(666302, 136, '2015-01-15 00:52:48.000000', 'consum', 0.0215, 'lps'),
	(666303, 136, '2015-01-15 00:52:49.000000', 'consum', 0.0264, 'lps'),
	(666304, 136, '2015-01-15 00:52:50.000000', 'consum', 0.0317, 'lps'),
	(666305, 136, '2015-01-15 00:52:51.000000', 'consum', 0.0292, 'lps'),
	(666306, 136, '2015-01-15 00:52:52.000000', 'consum', 0.0297, 'lps'),
	(666307, 136, '2015-01-15 00:52:53.000000', 'consum', 0.0254, 'lps'),
	(666308, 136, '2015-01-15 00:52:54.000000', 'consum', 0.0317, 'lps'),
	(666309, 136, '2015-01-15 00:52:55.000000', 'consum', 0.0319, 'lps'),
	(666310, 136, '2015-01-15 00:52:56.000000', 'consum', 0.0290, 'lps'),
	(666311, 136, '2015-01-15 00:52:57.000000', 'consum', 0.0280, 'lps'),
	(666312, 136, '2015-01-15 00:52:58.000000', 'consum', 0.0322, 'lps'),
	(666313, 136, '2015-01-15 00:52:59.000000', 'consum', 0.0264, 'lps'),
	(666314, 136, '2015-01-15 00:53:00.000000', 'consum', 0.0295, 'lps'),
	(666315, 136, '2015-01-15 00:53:01.000000', 'consum', 0.0325, 'lps'),
	(666316, 136, '2015-01-15 00:53:02.000000', 'consum', 0.0236, 'lps'),
	(666317, 136, '2015-01-15 00:53:03.000000', 'consum', 0.0288, 'lps'),
	(666318, 136, '2015-01-15 00:53:04.000000', 'consum', 0.0230, 'lps'),
	(666319, 136, '2015-01-15 00:53:05.000000', 'consum', 0.0223, 'lps'),
	(666320, 136, '2015-01-15 00:53:06.000000', 'consum', 0.0214, 'lps'),
	(666321, 136, '2015-01-15 00:53:07.000000', 'consum', 0.0340, 'lps'),
	(666322, 136, '2015-01-15 00:53:08.000000', 'consum', 0.0259, 'lps'),
	(666323, 136, '2015-01-15 00:53:09.000000', 'consum', 0.0215, 'lps'),
	(666324, 136, '2015-01-15 00:53:10.000000', 'consum', 0.0233, 'lps'),
	(666325, 136, '2015-01-15 00:53:11.000000', 'consum', 0.0310, 'lps'),
	(666326, 136, '2015-01-15 00:53:12.000000', 'consum', 0.0348, 'lps'),
	(666327, 136, '2015-01-15 00:53:13.000000', 'consum', 0.0307, 'lps'),
	(666328, 136, '2015-01-15 00:53:14.000000', 'consum', 0.0283, 'lps'),
	(666329, 136, '2015-01-15 00:53:15.000000', 'consum', 0.0284, 'lps'),
	(666330, 136, '2015-01-15 00:53:16.000000', 'consum', 0.0216, 'lps'),
	(666331, 136, '2015-01-15 00:53:17.000000', 'consum', 0.0311, 'lps'),
	(666332, 136, '2015-01-15 00:53:18.000000', 'consum', 0.0258, 'lps'),
	(666333, 136, '2015-01-15 00:53:19.000000', 'consum', 0.0291, 'lps'),
	(666334, 136, '2015-01-15 00:53:20.000000', 'consum', 0.0328, 'lps'),
	(666335, 136, '2015-01-15 00:53:21.000000', 'consum', 0.0262, 'lps'),
	(666336, 136, '2015-01-15 00:53:22.000000', 'consum', 0.0265, 'lps'),
	(666337, 136, '2015-01-15 00:53:23.000000', 'consum', 0.0330, 'lps'),
	(666338, 136, '2015-01-15 00:53:24.000000', 'consum', 0.0351, 'lps'),
	(666339, 136, '2015-01-15 00:53:25.000000', 'consum', 0.0260, 'lps'),
	(666340, 136, '2015-01-15 00:53:26.000000', 'consum', 0.0332, 'lps'),
	(666341, 136, '2015-01-15 00:53:27.000000', 'consum', 0.0229, 'lps'),
	(666342, 136, '2015-01-15 00:53:28.000000', 'consum', 0.0233, 'lps'),
	(666343, 136, '2015-01-15 00:53:29.000000', 'consum', 0.0270, 'lps'),
	(666344, 136, '2015-01-15 00:53:30.000000', 'consum', 0.0294, 'lps'),
	(666345, 136, '2015-01-15 00:53:31.000000', 'consum', 0.0302, 'lps'),
	(666346, 136, '2015-01-15 00:53:32.000000', 'consum', 0.0274, 'lps'),
	(666347, 136, '2015-01-15 00:53:33.000000', 'consum', 0.0255, 'lps'),
	(666348, 136, '2015-01-15 00:53:34.000000', 'consum', 0.0241, 'lps'),
	(666349, 136, '2015-01-15 00:53:35.000000', 'consum', 0.0231, 'lps'),
	(666350, 136, '2015-01-15 00:53:36.000000', 'consum', 0.0224, 'lps'),
	(666351, 136, '2015-01-15 00:53:37.000000', 'consum', 0.0215, 'lps'),
	(666352, 136, '2015-01-15 00:53:38.000000', 'consum', 0.0343, 'lps'),
	(666353, 136, '2015-01-15 00:53:39.000000', 'consum', 0.0271, 'lps'),
	(666354, 136, '2015-01-15 00:53:40.000000', 'consum', 0.0264, 'lps'),
	(666355, 136, '2015-01-15 00:53:41.000000', 'consum', 0.0298, 'lps'),
	(666356, 136, '2015-01-15 00:53:42.000000', 'consum', 0.0342, 'lps'),
	(666357, 136, '2015-01-15 00:53:43.000000', 'consum', 0.0311, 'lps'),
	(666358, 136, '2015-01-15 00:53:44.000000', 'consum', 0.0320, 'lps'),
	(666359, 136, '2015-01-15 00:53:45.000000', 'consum', 0.0312, 'lps'),
	(666360, 136, '2015-01-15 00:53:46.000000', 'consum', 0.0244, 'lps'),
	(666361, 136, '2015-01-15 00:53:47.000000', 'consum', 0.0220, 'lps'),
	(666362, 136, '2015-01-15 00:53:48.000000', 'consum', 0.0306, 'lps'),
	(666363, 136, '2015-01-15 00:53:49.000000', 'consum', 0.0219, 'lps'),
	(666364, 136, '2015-01-15 00:53:50.000000', 'consum', 0.0262, 'lps'),
	(666365, 136, '2015-01-15 00:53:51.000000', 'consum', 0.0296, 'lps'),
	(666366, 136, '2015-01-15 00:53:52.000000', 'consum', 0.0339, 'lps'),
	(666367, 136, '2015-01-15 00:53:53.000000', 'consum', 0.0303, 'lps'),
	(666368, 136, '2015-01-15 00:53:54.000000', 'consum', 0.0288, 'lps'),
	(666369, 136, '2015-01-15 00:53:55.000000', 'consum', 0.0322, 'lps'),
	(666370, 136, '2015-01-15 00:53:56.000000', 'consum', 0.0242, 'lps'),
	(666371, 136, '2015-01-15 00:53:57.000000', 'consum', 0.0327, 'lps'),
	(666372, 136, '2015-01-15 00:53:58.000000', 'consum', 0.0261, 'lps'),
	(666373, 136, '2015-01-15 00:53:59.000000', 'consum', 0.0259, 'lps'),
	(666374, 136, '2015-01-15 00:54:00.000000', 'consum', 0.0306, 'lps'),
	(666375, 136, '2015-01-15 00:54:01.000000', 'consum', 0.0246, 'lps'),
	(666376, 136, '2015-01-15 00:54:02.000000', 'consum', 0.0250, 'lps'),
	(666377, 136, '2015-01-15 00:54:03.000000', 'consum', 0.0302, 'lps'),
	(666378, 136, '2015-01-15 00:54:04.000000', 'consum', 0.0256, 'lps'),
	(666379, 136, '2015-01-15 00:54:05.000000', 'consum', 0.0311, 'lps'),
	(666380, 136, '2015-01-15 00:54:06.000000', 'consum', 0.0283, 'lps'),
	(666381, 136, '2015-01-15 00:54:07.000000', 'consum', 0.0274, 'lps'),
	(666382, 136, '2015-01-15 00:54:08.000000', 'consum', 0.0309, 'lps'),
	(666383, 136, '2015-01-15 00:54:09.000000', 'consum', 0.0222, 'lps'),
	(666384, 136, '2015-01-15 00:54:10.000000', 'consum', 0.0265, 'lps'),
	(666385, 136, '2015-01-15 00:54:11.000000', 'consum', 0.0304, 'lps'),
	(666386, 136, '2015-01-15 00:54:12.000000', 'consum', 0.0222, 'lps'),
	(666387, 136, '2015-01-15 00:54:13.000000', 'consum', 0.0282, 'lps'),
	(666388, 136, '2015-01-15 00:54:14.000000', 'consum', 0.0241, 'lps'),
	(666389, 136, '2015-01-15 00:54:15.000000', 'consum', 0.0296, 'lps'),
	(666390, 136, '2015-01-15 00:54:16.000000', 'consum', 0.0254, 'lps'),
	(666391, 136, '2015-01-15 00:54:17.000000', 'consum', 0.0320, 'lps'),
	(666392, 136, '2015-01-15 00:54:18.000000', 'consum', 0.0333, 'lps'),
	(666393, 136, '2015-01-15 00:54:19.000000', 'consum', 0.0349, 'lps'),
	(666394, 136, '2015-01-15 00:54:20.000000', 'consum', 0.0242, 'lps'),
	(666395, 136, '2015-01-15 00:54:21.000000', 'consum', 0.0250, 'lps'),
	(666396, 136, '2015-01-15 00:54:22.000000', 'consum', 0.0312, 'lps'),
	(666397, 136, '2015-01-15 00:54:23.000000', 'consum', 0.0309, 'lps'),
	(666398, 136, '2015-01-15 00:54:24.000000', 'consum', 0.0251, 'lps'),
	(666399, 136, '2015-01-15 00:54:25.000000', 'consum', 0.0264, 'lps'),
	(666400, 136, '2015-01-15 00:54:26.000000', 'consum', 0.0212, 'lps'),
	(666401, 136, '2015-01-15 00:54:27.000000', 'consum', 0.0354, 'lps'),
	(666402, 136, '2015-01-15 00:54:28.000000', 'consum', 0.0334, 'lps'),
	(666403, 136, '2015-01-15 00:54:29.000000', 'consum', 0.0253, 'lps'),
	(666404, 136, '2015-01-15 00:54:30.000000', 'consum', 0.0347, 'lps'),
	(666405, 136, '2015-01-15 00:54:31.000000', 'consum', 0.0324, 'lps'),
	(666406, 136, '2015-01-15 00:54:32.000000', 'consum', 0.0223, 'lps'),
	(666407, 136, '2015-01-15 00:54:33.000000', 'consum', 0.0230, 'lps'),
	(666408, 136, '2015-01-15 00:54:34.000000', 'consum', 0.0269, 'lps'),
	(666409, 136, '2015-01-15 00:54:35.000000', 'consum', 0.0301, 'lps'),
	(666410, 136, '2015-01-15 00:54:36.000000', 'consum', 0.0340, 'lps'),
	(666411, 136, '2015-01-15 00:54:37.000000', 'consum', 0.0293, 'lps'),
	(666412, 136, '2015-01-15 00:54:38.000000', 'consum', 0.0238, 'lps'),
	(666413, 136, '2015-01-15 00:54:39.000000', 'consum', 0.0247, 'lps'),
	(666414, 136, '2015-01-15 00:54:40.000000', 'consum', 0.0311, 'lps'),
	(666415, 136, '2015-01-15 00:54:41.000000', 'consum', 0.0312, 'lps'),
	(666416, 136, '2015-01-15 00:54:42.000000', 'consum', 0.0272, 'lps'),
	(666417, 136, '2015-01-15 00:54:43.000000', 'consum', 0.0211, 'lps'),
	(666418, 136, '2015-01-15 00:54:44.000000', 'consum', 0.0326, 'lps'),
	(666419, 136, '2015-01-15 00:54:45.000000', 'consum', 0.0348, 'lps'),
	(666420, 136, '2015-01-15 00:54:46.000000', 'consum', 0.0256, 'lps'),
	(666421, 136, '2015-01-15 00:54:47.000000', 'consum', 0.0322, 'lps'),
	(666422, 136, '2015-01-15 00:54:48.000000', 'consum', 0.0337, 'lps'),
	(666423, 136, '2015-01-15 00:54:49.000000', 'consum', 0.0214, 'lps'),
	(666424, 136, '2015-01-15 00:54:50.000000', 'consum', 0.0294, 'lps'),
	(666425, 136, '2015-01-15 00:54:51.000000', 'consum', 0.0324, 'lps'),
	(666426, 136, '2015-01-15 00:54:52.000000', 'consum', 0.0232, 'lps'),
	(666427, 136, '2015-01-15 00:54:53.000000', 'consum', 0.0274, 'lps'),
	(666428, 136, '2015-01-15 00:54:54.000000', 'consum', 0.0318, 'lps'),
	(666429, 136, '2015-01-15 00:54:55.000000', 'consum', 0.0265, 'lps'),
	(666430, 136, '2015-01-15 00:54:56.000000', 'consum', 0.0307, 'lps'),
	(666431, 136, '2015-01-15 00:54:57.000000', 'consum', 0.0237, 'lps'),
	(666432, 136, '2015-01-15 00:54:58.000000', 'consum', 0.0349, 'lps'),
	(666433, 136, '2015-01-15 00:54:59.000000', 'consum', 0.0237, 'lps'),
	(666434, 136, '2015-01-15 00:55:00.000000', 'consum', 0.0222, 'lps'),
	(666435, 136, '2015-01-15 00:55:01.000000', 'consum', 0.0335, 'lps'),
	(666436, 136, '2015-01-15 00:55:02.000000', 'consum', 0.0215, 'lps'),
	(666437, 136, '2015-01-15 00:55:03.000000', 'consum', 0.0298, 'lps'),
	(666438, 136, '2015-01-15 00:55:04.000000', 'consum', 0.0343, 'lps'),
	(666439, 136, '2015-01-15 00:55:05.000000', 'consum', 0.0318, 'lps'),
	(666440, 136, '2015-01-15 00:55:06.000000', 'consum', 0.0349, 'lps'),
	(666441, 136, '2015-01-15 00:55:07.000000', 'consum', 0.0290, 'lps'),
	(666442, 136, '2015-01-15 00:55:08.000000', 'consum', 0.0338, 'lps'),
	(666443, 136, '2015-01-15 00:55:09.000000', 'consum', 0.0316, 'lps'),
	(666444, 136, '2015-01-15 00:55:10.000000', 'consum', 0.0212, 'lps'),
	(666445, 136, '2015-01-15 00:55:11.000000', 'consum', 0.0342, 'lps'),
	(666446, 136, '2015-01-15 00:55:12.000000', 'consum', 0.0278, 'lps'),
	(666447, 136, '2015-01-15 00:55:13.000000', 'consum', 0.0303, 'lps'),
	(666448, 136, '2015-01-15 00:55:14.000000', 'consum', 0.0322, 'lps'),
	(666449, 136, '2015-01-15 00:55:15.000000', 'consum', 0.0344, 'lps'),
	(666450, 136, '2015-01-15 00:55:16.000000', 'consum', 0.0251, 'lps'),
	(666451, 136, '2015-01-15 00:55:17.000000', 'consum', 0.0309, 'lps'),
	(666452, 136, '2015-01-15 00:55:18.000000', 'consum', 0.0289, 'lps'),
	(666453, 136, '2015-01-15 00:55:19.000000', 'consum', 0.0306, 'lps'),
	(666454, 136, '2015-01-15 00:55:20.000000', 'consum', 0.0308, 'lps'),
	(666455, 136, '2015-01-15 00:55:21.000000', 'consum', 0.0267, 'lps'),
	(666456, 136, '2015-01-15 00:55:22.000000', 'consum', 0.0347, 'lps'),
	(666457, 136, '2015-01-15 00:55:23.000000', 'consum', 0.0283, 'lps'),
	(666458, 136, '2015-01-15 00:55:24.000000', 'consum', 0.0314, 'lps'),
	(666459, 136, '2015-01-15 00:55:25.000000', 'consum', 0.0216, 'lps'),
	(666460, 136, '2015-01-15 00:55:26.000000', 'consum', 0.0221, 'lps'),
	(666461, 136, '2015-01-15 00:55:27.000000', 'consum', 0.0247, 'lps'),
	(666462, 136, '2015-01-15 00:55:28.000000', 'consum', 0.0217, 'lps'),
	(666463, 136, '2015-01-15 00:55:29.000000', 'consum', 0.0280, 'lps'),
	(666464, 136, '2015-01-15 00:55:30.000000', 'consum', 0.0248, 'lps'),
	(666465, 136, '2015-01-15 00:55:31.000000', 'consum', 0.0337, 'lps'),
	(666466, 136, '2015-01-15 00:55:32.000000', 'consum', 0.0291, 'lps'),
	(666467, 136, '2015-01-15 00:55:33.000000', 'consum', 0.0235, 'lps'),
	(666468, 136, '2015-01-15 00:55:34.000000', 'consum', 0.0240, 'lps'),
	(666469, 136, '2015-01-15 00:55:35.000000', 'consum', 0.0286, 'lps'),
	(666470, 136, '2015-01-15 00:55:36.000000', 'consum', 0.0355, 'lps'),
	(666471, 136, '2015-01-15 00:55:37.000000', 'consum', 0.0263, 'lps'),
	(666472, 136, '2015-01-15 00:55:38.000000', 'consum', 0.0337, 'lps'),
	(666473, 136, '2015-01-15 00:55:39.000000', 'consum', 0.0244, 'lps'),
	(666474, 136, '2015-01-15 00:55:40.000000', 'consum', 0.0295, 'lps'),
	(666475, 136, '2015-01-15 00:55:41.000000', 'consum', 0.0240, 'lps'),
	(666476, 136, '2015-01-15 00:55:42.000000', 'consum', 0.0251, 'lps'),
	(666477, 136, '2015-01-15 00:55:43.000000', 'consum', 0.0327, 'lps'),
	(666478, 136, '2015-01-15 00:55:44.000000', 'consum', 0.0229, 'lps'),
	(666479, 136, '2015-01-15 00:55:45.000000', 'consum', 0.0252, 'lps'),
	(666480, 136, '2015-01-15 00:55:46.000000', 'consum', 0.0214, 'lps'),
	(666481, 136, '2015-01-15 00:55:47.000000', 'consum', 0.0250, 'lps'),
	(666482, 136, '2015-01-15 00:55:48.000000', 'consum', 0.0254, 'lps'),
	(666483, 136, '2015-01-15 00:55:49.000000', 'consum', 0.0311, 'lps'),
	(666484, 136, '2015-01-15 00:55:50.000000', 'consum', 0.0288, 'lps'),
	(666485, 136, '2015-01-15 00:55:51.000000', 'consum', 0.0298, 'lps'),
	(666486, 136, '2015-01-15 00:55:52.000000', 'consum', 0.0271, 'lps'),
	(666487, 136, '2015-01-15 00:55:53.000000', 'consum', 0.0248, 'lps'),
	(666488, 136, '2015-01-15 00:55:54.000000', 'consum', 0.0221, 'lps'),
	(666489, 136, '2015-01-15 00:55:55.000000', 'consum', 0.0297, 'lps'),
	(666490, 136, '2015-01-15 00:55:56.000000', 'consum', 0.0320, 'lps'),
	(666491, 136, '2015-01-15 00:55:57.000000', 'consum', 0.0351, 'lps'),
	(666492, 136, '2015-01-15 00:55:58.000000', 'consum', 0.0294, 'lps'),
	(666493, 136, '2015-01-15 00:55:59.000000', 'consum', 0.0351, 'lps'),
	(666494, 136, '2015-01-15 00:56:00.000000', 'consum', 0.0224, 'lps'),
	(666495, 136, '2015-01-15 00:56:01.000000', 'consum', 0.0297, 'lps'),
	(666496, 136, '2015-01-15 00:56:02.000000', 'consum', 0.0312, 'lps'),
	(666497, 136, '2015-01-15 00:56:03.000000', 'consum', 0.0313, 'lps'),
	(666498, 136, '2015-01-15 00:56:04.000000', 'consum', 0.0273, 'lps'),
	(666499, 136, '2015-01-15 00:56:05.000000', 'consum', 0.0215, 'lps'),
	(666500, 136, '2015-01-15 00:56:06.000000', 'consum', 0.0342, 'lps'),
	(666501, 136, '2015-01-15 00:56:07.000000', 'consum', 0.0268, 'lps'),
	(666502, 136, '2015-01-15 00:56:08.000000', 'consum', 0.0251, 'lps'),
	(666503, 136, '2015-01-15 00:56:09.000000', 'consum', 0.0240, 'lps'),
	(666504, 136, '2015-01-15 00:56:10.000000', 'consum', 0.0236, 'lps'),
	(666505, 136, '2015-01-15 00:56:11.000000', 'consum', 0.0254, 'lps'),
	(666506, 136, '2015-01-15 00:56:12.000000', 'consum', 0.0350, 'lps'),
	(666507, 136, '2015-01-15 00:56:13.000000', 'consum', 0.0337, 'lps'),
	(666508, 136, '2015-01-15 00:56:14.000000', 'consum', 0.0280, 'lps'),
	(666509, 136, '2015-01-15 00:56:15.000000', 'consum', 0.0325, 'lps'),
	(666510, 136, '2015-01-15 00:56:16.000000', 'consum', 0.0281, 'lps'),
	(666511, 136, '2015-01-15 00:56:17.000000', 'consum', 0.0220, 'lps'),
	(666512, 136, '2015-01-15 00:56:18.000000', 'consum', 0.0341, 'lps'),
	(666513, 136, '2015-01-15 00:56:19.000000', 'consum', 0.0249, 'lps'),
	(666514, 136, '2015-01-15 00:56:20.000000', 'consum', 0.0308, 'lps'),
	(666515, 136, '2015-01-15 00:56:21.000000', 'consum', 0.0287, 'lps'),
	(666516, 136, '2015-01-15 00:56:22.000000', 'consum', 0.0300, 'lps'),
	(666517, 136, '2015-01-15 00:56:23.000000', 'consum', 0.0286, 'lps'),
	(666518, 136, '2015-01-15 00:56:24.000000', 'consum', 0.0319, 'lps'),
	(666519, 136, '2015-01-15 00:56:25.000000', 'consum', 0.0233, 'lps'),
	(666520, 136, '2015-01-15 00:56:26.000000', 'consum', 0.0292, 'lps'),
	(666521, 136, '2015-01-15 00:56:27.000000', 'consum', 0.0260, 'lps'),
	(666522, 136, '2015-01-15 00:56:28.000000', 'consum', 0.0213, 'lps'),
	(666523, 136, '2015-01-15 00:56:29.000000', 'consum', 0.0223, 'lps'),
	(666524, 136, '2015-01-15 00:56:30.000000', 'consum', 0.0264, 'lps'),
	(666525, 136, '2015-01-15 00:56:31.000000', 'consum', 0.0297, 'lps'),
	(666526, 136, '2015-01-15 00:56:32.000000', 'consum', 0.0336, 'lps'),
	(666527, 136, '2015-01-15 00:56:33.000000', 'consum', 0.0286, 'lps'),
	(666528, 136, '2015-01-15 00:56:34.000000', 'consum', 0.0213, 'lps'),
	(666529, 136, '2015-01-15 00:56:35.000000', 'consum', 0.0290, 'lps'),
	(666530, 136, '2015-01-15 00:56:36.000000', 'consum', 0.0307, 'lps'),
	(666531, 136, '2015-01-15 00:56:37.000000', 'consum', 0.0311, 'lps'),
	(666532, 136, '2015-01-15 00:56:38.000000', 'consum', 0.0275, 'lps'),
	(666533, 136, '2015-01-15 00:56:39.000000', 'consum', 0.0232, 'lps'),
	(666534, 136, '2015-01-15 00:56:40.000000', 'consum', 0.0274, 'lps'),
	(666535, 136, '2015-01-15 00:56:41.000000', 'consum', 0.0316, 'lps'),
	(666536, 136, '2015-01-15 00:56:42.000000', 'consum', 0.0255, 'lps'),
	(666537, 136, '2015-01-15 00:56:43.000000', 'consum', 0.0265, 'lps'),
	(666538, 136, '2015-01-15 00:56:44.000000', 'consum', 0.0351, 'lps'),
	(666539, 136, '2015-01-15 00:56:45.000000', 'consum', 0.0308, 'lps'),
	(666540, 136, '2015-01-15 00:56:46.000000', 'consum', 0.0280, 'lps'),
	(666541, 136, '2015-01-15 00:56:47.000000', 'consum', 0.0263, 'lps'),
	(666542, 136, '2015-01-15 00:56:48.000000', 'consum', 0.0269, 'lps'),
	(666543, 136, '2015-01-15 00:56:49.000000', 'consum', 0.0344, 'lps'),
	(666544, 136, '2015-01-15 00:56:50.000000', 'consum', 0.0264, 'lps'),
	(666545, 136, '2015-01-15 00:56:51.000000', 'consum', 0.0223, 'lps'),
	(666546, 136, '2015-01-15 00:56:52.000000', 'consum', 0.0262, 'lps'),
	(666547, 136, '2015-01-15 00:56:53.000000', 'consum', 0.0283, 'lps'),
	(666548, 136, '2015-01-15 00:56:54.000000', 'consum', 0.0273, 'lps'),
	(666549, 136, '2015-01-15 00:56:55.000000', 'consum', 0.0308, 'lps'),
	(666550, 136, '2015-01-15 00:56:56.000000', 'consum', 0.0217, 'lps'),
	(666551, 136, '2015-01-15 00:56:57.000000', 'consum', 0.0246, 'lps'),
	(666552, 136, '2015-01-15 00:56:58.000000', 'consum', 0.0223, 'lps'),
	(666553, 136, '2015-01-15 00:56:59.000000', 'consum', 0.0312, 'lps'),
	(666554, 136, '2015-01-15 00:57:00.000000', 'consum', 0.0241, 'lps'),
	(666555, 136, '2015-01-15 00:57:01.000000', 'consum', 0.0354, 'lps'),
	(666556, 136, '2015-01-15 00:57:02.000000', 'consum', 0.0252, 'lps'),
	(666557, 136, '2015-01-15 00:57:03.000000', 'consum', 0.0279, 'lps'),
	(666558, 136, '2015-01-15 00:57:04.000000', 'consum', 0.0284, 'lps'),
	(666559, 136, '2015-01-15 00:57:05.000000', 'consum', 0.0225, 'lps'),
	(666560, 136, '2015-01-15 00:57:06.000000', 'consum', 0.0213, 'lps'),
	(666561, 136, '2015-01-15 00:57:07.000000', 'consum', 0.0325, 'lps'),
	(666562, 136, '2015-01-15 00:57:08.000000', 'consum', 0.0336, 'lps'),
	(666563, 136, '2015-01-15 00:57:09.000000', 'consum', 0.0350, 'lps'),
	(666564, 136, '2015-01-15 00:57:10.000000', 'consum', 0.0238, 'lps'),
	(666565, 136, '2015-01-15 00:57:11.000000', 'consum', 0.0226, 'lps'),
	(666566, 136, '2015-01-15 00:57:12.000000', 'consum', 0.0352, 'lps'),
	(666567, 136, '2015-01-15 00:57:13.000000', 'consum', 0.0284, 'lps'),
	(666568, 136, '2015-01-15 00:57:14.000000', 'consum', 0.0301, 'lps'),
	(666569, 136, '2015-01-15 00:57:15.000000', 'consum', 0.0299, 'lps'),
	(666570, 136, '2015-01-15 00:57:16.000000', 'consum', 0.0232, 'lps'),
	(666571, 136, '2015-01-15 00:57:17.000000', 'consum', 0.0350, 'lps'),
	(666572, 136, '2015-01-15 00:57:18.000000', 'consum', 0.0254, 'lps'),
	(666573, 136, '2015-01-15 00:57:19.000000', 'consum', 0.0306, 'lps'),
	(666574, 136, '2015-01-15 00:57:20.000000', 'consum', 0.0265, 'lps'),
	(666575, 136, '2015-01-15 00:57:21.000000', 'consum', 0.0344, 'lps'),
	(666576, 136, '2015-01-15 00:57:22.000000', 'consum', 0.0274, 'lps'),
	(666577, 136, '2015-01-15 00:57:23.000000', 'consum', 0.0275, 'lps'),
	(666578, 136, '2015-01-15 00:57:24.000000', 'consum', 0.0346, 'lps'),
	(666579, 136, '2015-01-15 00:57:25.000000', 'consum', 0.0252, 'lps'),
	(666580, 136, '2015-01-15 00:57:26.000000', 'consum', 0.0307, 'lps'),
	(666581, 136, '2015-01-15 00:57:27.000000', 'consum', 0.0277, 'lps'),
	(666582, 136, '2015-01-15 00:57:28.000000', 'consum', 0.0253, 'lps'),
	(666583, 136, '2015-01-15 00:57:29.000000', 'consum', 0.0225, 'lps'),
	(666584, 136, '2015-01-15 00:57:30.000000', 'consum', 0.0302, 'lps'),
	(666585, 136, '2015-01-15 00:57:31.000000', 'consum', 0.0332, 'lps'),
	(666586, 136, '2015-01-15 00:57:32.000000', 'consum', 0.0250, 'lps'),
	(666587, 136, '2015-01-15 00:57:33.000000', 'consum', 0.0341, 'lps'),
	(666588, 136, '2015-01-15 00:57:34.000000', 'consum', 0.0303, 'lps'),
	(666589, 136, '2015-01-15 00:57:35.000000', 'consum', 0.0281, 'lps'),
	(666590, 136, '2015-01-15 00:57:36.000000', 'consum', 0.0289, 'lps'),
	(666591, 136, '2015-01-15 00:57:37.000000', 'consum', 0.0246, 'lps'),
	(666592, 136, '2015-01-15 00:57:38.000000', 'consum', 0.0299, 'lps'),
	(666593, 136, '2015-01-15 00:57:39.000000', 'consum', 0.0254, 'lps'),
	(666594, 136, '2015-01-15 00:57:40.000000', 'consum', 0.0312, 'lps'),
	(666595, 136, '2015-01-15 00:57:41.000000', 'consum', 0.0295, 'lps'),
	(666596, 136, '2015-01-15 00:57:42.000000', 'consum', 0.0330, 'lps'),
	(666597, 136, '2015-01-15 00:57:43.000000', 'consum', 0.0258, 'lps'),
	(666598, 136, '2015-01-15 00:57:44.000000', 'consum', 0.0241, 'lps'),
	(666599, 136, '2015-01-15 00:57:45.000000', 'consum', 0.0221, 'lps'),
	(666600, 136, '2015-01-15 00:57:46.000000', 'consum', 0.0319, 'lps'),
	(666601, 136, '2015-01-15 00:57:47.000000', 'consum', 0.0281, 'lps'),
	(666602, 136, '2015-01-15 00:57:48.000000', 'consum', 0.0240, 'lps'),
	(666603, 136, '2015-01-15 00:57:49.000000', 'consum', 0.0294, 'lps'),
	(666604, 136, '2015-01-15 00:57:50.000000', 'consum', 0.0246, 'lps'),
	(666605, 136, '2015-01-15 00:57:51.000000', 'consum', 0.0284, 'lps'),
	(666606, 136, '2015-01-15 00:57:52.000000', 'consum', 0.0326, 'lps'),
	(666607, 136, '2015-01-15 00:57:53.000000', 'consum', 0.0276, 'lps'),
	(666608, 136, '2015-01-15 00:57:54.000000', 'consum', 0.0338, 'lps'),
	(666609, 136, '2015-01-15 00:57:55.000000', 'consum', 0.0212, 'lps'),
	(666610, 136, '2015-01-15 00:57:56.000000', 'consum', 0.0275, 'lps'),
	(666611, 136, '2015-01-15 00:57:57.000000', 'consum', 0.0239, 'lps'),
	(666612, 136, '2015-01-15 00:57:58.000000', 'consum', 0.0306, 'lps'),
	(666613, 136, '2015-01-15 00:57:59.000000', 'consum', 0.0310, 'lps'),
	(666614, 136, '2015-01-15 00:58:00.000000', 'consum', 0.0273, 'lps'),
	(666615, 136, '2015-01-15 00:58:01.000000', 'consum', 0.0228, 'lps'),
	(666616, 136, '2015-01-15 00:58:02.000000', 'consum', 0.0258, 'lps'),
	(666617, 136, '2015-01-15 00:58:03.000000', 'consum', 0.0249, 'lps'),
	(666618, 136, '2015-01-15 00:58:04.000000', 'consum', 0.0261, 'lps'),
	(666619, 136, '2015-01-15 00:58:05.000000', 'consum', 0.0349, 'lps'),
	(666620, 136, '2015-01-15 00:58:06.000000', 'consum', 0.0310, 'lps'),
	(666621, 136, '2015-01-15 00:58:07.000000', 'consum', 0.0294, 'lps'),
	(666622, 136, '2015-01-15 00:58:08.000000', 'consum', 0.0329, 'lps'),
	(666623, 136, '2015-01-15 00:58:09.000000', 'consum', 0.0263, 'lps'),
	(666624, 136, '2015-01-15 00:58:10.000000', 'consum', 0.0263, 'lps'),
	(666625, 136, '2015-01-15 00:58:11.000000', 'consum', 0.0317, 'lps'),
	(666626, 136, '2015-01-15 00:58:12.000000', 'consum', 0.0293, 'lps'),
	(666627, 136, '2015-01-15 00:58:13.000000', 'consum', 0.0306, 'lps'),
	(666628, 136, '2015-01-15 00:58:14.000000', 'consum', 0.0294, 'lps'),
	(666629, 136, '2015-01-15 00:58:15.000000', 'consum', 0.0342, 'lps'),
	(666630, 136, '2015-01-15 00:58:16.000000', 'consum', 0.0326, 'lps'),
	(666631, 136, '2015-01-15 00:58:17.000000', 'consum', 0.0247, 'lps'),
	(666632, 136, '2015-01-15 00:58:18.000000', 'consum', 0.0343, 'lps'),
	(666633, 136, '2015-01-15 00:58:19.000000', 'consum', 0.0322, 'lps'),
	(666634, 136, '2015-01-15 00:58:20.000000', 'consum', 0.0225, 'lps'),
	(666635, 136, '2015-01-15 00:58:21.000000', 'consum', 0.0242, 'lps'),
	(666636, 136, '2015-01-15 00:58:22.000000', 'consum', 0.0328, 'lps'),
	(666637, 136, '2015-01-15 00:58:23.000000', 'consum', 0.0264, 'lps'),
	(666638, 136, '2015-01-15 00:58:24.000000', 'consum', 0.0274, 'lps'),
	(666639, 136, '2015-01-15 00:58:25.000000', 'consum', 0.0219, 'lps'),
	(666640, 136, '2015-01-15 00:58:26.000000', 'consum', 0.0212, 'lps'),
	(666641, 136, '2015-01-15 00:58:27.000000', 'consum', 0.0342, 'lps'),
	(666642, 136, '2015-01-15 00:58:28.000000', 'consum', 0.0273, 'lps'),
	(666643, 136, '2015-01-15 00:58:29.000000', 'consum', 0.0280, 'lps'),
	(666644, 136, '2015-01-15 00:58:30.000000', 'consum', 0.0222, 'lps'),
	(666645, 136, '2015-01-15 00:58:31.000000', 'consum', 0.0353, 'lps'),
	(666646, 136, '2015-01-15 00:58:32.000000', 'consum', 0.0304, 'lps'),
	(666647, 136, '2015-01-15 00:58:33.000000', 'consum', 0.0252, 'lps'),
	(666648, 136, '2015-01-15 00:58:34.000000', 'consum', 0.0286, 'lps'),
	(666649, 136, '2015-01-15 00:58:35.000000', 'consum', 0.0317, 'lps'),
	(666650, 136, '2015-01-15 00:58:36.000000', 'consum', 0.0223, 'lps'),
	(666651, 136, '2015-01-15 00:58:37.000000', 'consum', 0.0247, 'lps'),
	(666652, 136, '2015-01-15 00:58:38.000000', 'consum', 0.0212, 'lps'),
	(666653, 136, '2015-01-15 00:58:39.000000', 'consum', 0.0253, 'lps'),
	(666654, 136, '2015-01-15 00:58:40.000000', 'consum', 0.0276, 'lps'),
	(666655, 136, '2015-01-15 00:58:41.000000', 'consum', 0.0265, 'lps'),
	(666656, 136, '2015-01-15 00:58:42.000000', 'consum', 0.0285, 'lps'),
	(666657, 136, '2015-01-15 00:58:43.000000', 'consum', 0.0273, 'lps'),
	(666658, 136, '2015-01-15 00:58:44.000000', 'consum', 0.0300, 'lps'),
	(666659, 136, '2015-01-15 00:58:45.000000', 'consum', 0.0327, 'lps'),
	(666660, 136, '2015-01-15 00:58:46.000000', 'consum', 0.0231, 'lps'),
	(666661, 136, '2015-01-15 00:58:47.000000', 'consum', 0.0260, 'lps'),
	(666662, 136, '2015-01-15 00:58:48.000000', 'consum', 0.0248, 'lps'),
	(666663, 136, '2015-01-15 00:58:49.000000', 'consum', 0.0253, 'lps'),
	(666664, 136, '2015-01-15 00:58:50.000000', 'consum', 0.0311, 'lps'),
	(666665, 136, '2015-01-15 00:58:51.000000', 'consum', 0.0291, 'lps'),
	(666666, 136, '2015-01-15 00:58:52.000000', 'consum', 0.0312, 'lps'),
	(666667, 136, '2015-01-15 00:58:53.000000', 'consum', 0.0333, 'lps'),
	(666668, 136, '2015-01-15 00:58:54.000000', 'consum', 0.0225, 'lps'),
	(666669, 136, '2015-01-15 00:58:55.000000', 'consum', 0.0355, 'lps'),
	(666670, 136, '2015-01-15 00:58:56.000000', 'consum', 0.0305, 'lps'),
	(666671, 136, '2015-01-15 00:58:57.000000', 'consum', 0.0249, 'lps'),
	(666672, 136, '2015-01-15 00:58:58.000000', 'consum', 0.0266, 'lps'),
	(666673, 136, '2015-01-15 00:58:59.000000', 'consum', 0.0229, 'lps'),
	(666674, 136, '2015-01-15 00:59:00.000000', 'consum', 0.0284, 'lps'),
	(666675, 136, '2015-01-15 00:59:01.000000', 'consum', 0.0230, 'lps'),
	(666676, 136, '2015-01-15 00:59:02.000000', 'consum', 0.0237, 'lps'),
	(666677, 136, '2015-01-15 00:59:03.000000', 'consum', 0.0283, 'lps'),
	(666678, 136, '2015-01-15 00:59:04.000000', 'consum', 0.0349, 'lps'),
	(666679, 136, '2015-01-15 00:59:05.000000', 'consum', 0.0245, 'lps'),
	(666680, 136, '2015-01-15 00:59:06.000000', 'consum', 0.0264, 'lps'),
	(666681, 136, '2015-01-15 00:59:07.000000', 'consum', 0.0225, 'lps'),
	(666682, 136, '2015-01-15 00:59:08.000000', 'consum', 0.0274, 'lps'),
	(666683, 136, '2015-01-15 00:59:09.000000', 'consum', 0.0337, 'lps'),
	(666684, 136, '2015-01-15 00:59:10.000000', 'consum', 0.0212, 'lps'),
	(666685, 136, '2015-01-15 00:59:11.000000', 'consum', 0.0280, 'lps'),
	(666686, 136, '2015-01-15 00:59:12.000000', 'consum', 0.0263, 'lps'),
	(666687, 136, '2015-01-15 00:59:13.000000', 'consum', 0.0264, 'lps'),
	(666688, 136, '2015-01-15 00:59:14.000000', 'consum', 0.0323, 'lps'),
	(666689, 136, '2015-01-15 00:59:15.000000', 'consum', 0.0321, 'lps'),
	(666690, 136, '2015-01-15 00:59:16.000000', 'consum', 0.0277, 'lps'),
	(666691, 136, '2015-01-15 00:59:17.000000', 'consum', 0.0211, 'lps'),
	(666692, 136, '2015-01-15 00:59:18.000000', 'consum', 0.0311, 'lps'),
	(666693, 136, '2015-01-15 00:59:19.000000', 'consum', 0.0269, 'lps'),
	(666694, 136, '2015-01-15 00:59:20.000000', 'consum', 0.0351, 'lps'),
	(666695, 136, '2015-01-15 00:59:21.000000', 'consum', 0.0297, 'lps'),
	(666696, 136, '2015-01-15 00:59:22.000000', 'consum', 0.0221, 'lps'),
	(666697, 136, '2015-01-15 00:59:23.000000', 'consum', 0.0298, 'lps'),
	(666698, 136, '2015-01-15 00:59:24.000000', 'consum', 0.0326, 'lps'),
	(666699, 136, '2015-01-15 00:59:25.000000', 'consum', 0.0230, 'lps'),
	(666700, 136, '2015-01-15 00:59:26.000000', 'consum', 0.0258, 'lps'),
	(666701, 136, '2015-01-15 00:59:27.000000', 'consum', 0.0243, 'lps'),
	(666702, 136, '2015-01-15 00:59:28.000000', 'consum', 0.0233, 'lps'),
	(666703, 136, '2015-01-15 00:59:29.000000', 'consum', 0.0225, 'lps'),
	(666704, 136, '2015-01-15 00:59:30.000000', 'consum', 0.0218, 'lps'),
	(666705, 136, '2015-01-15 00:59:31.000000', 'consum', 0.0350, 'lps'),
	(666706, 136, '2015-01-15 00:59:32.000000', 'consum', 0.0299, 'lps'),
	(666707, 136, '2015-01-15 00:59:33.000000', 'consum', 0.0237, 'lps'),
	(666708, 136, '2015-01-15 00:59:34.000000', 'consum', 0.0226, 'lps'),
	(666709, 136, '2015-01-15 00:59:35.000000', 'consum', 0.0354, 'lps'),
	(666710, 136, '2015-01-15 00:59:36.000000', 'consum', 0.0297, 'lps'),
	(666711, 136, '2015-01-15 00:59:37.000000', 'consum', 0.0214, 'lps'),
	(666712, 136, '2015-01-15 00:59:38.000000', 'consum', 0.0263, 'lps'),
	(666713, 136, '2015-01-15 00:59:39.000000', 'consum', 0.0316, 'lps'),
	(666714, 136, '2015-01-15 00:59:40.000000', 'consum', 0.0286, 'lps'),
	(666715, 136, '2015-01-15 00:59:41.000000', 'consum', 0.0276, 'lps'),
	(666716, 136, '2015-01-15 00:59:42.000000', 'consum', 0.0309, 'lps'),
	(666717, 136, '2015-01-15 00:59:43.000000', 'consum', 0.0216, 'lps'),
	(666718, 136, '2015-01-15 00:59:44.000000', 'consum', 0.0237, 'lps'),
	(666719, 136, '2015-01-15 00:59:45.000000', 'consum', 0.0327, 'lps'),
	(666720, 136, '2015-01-15 00:59:46.000000', 'consum', 0.0275, 'lps'),
	(666721, 136, '2015-01-15 00:59:47.000000', 'consum', 0.0329, 'lps'),
	(666722, 136, '2015-01-15 00:59:48.000000', 'consum', 0.0318, 'lps'),
	(666723, 136, '2015-01-15 00:59:49.000000', 'consum', 0.0245, 'lps'),
	(666724, 136, '2015-01-15 00:59:50.000000', 'consum', 0.0356, 'lps'),
	(666725, 136, '2015-01-15 00:59:51.000000', 'consum', 0.0249, 'lps'),
	(666726, 136, '2015-01-15 00:59:52.000000', 'consum', 0.0259, 'lps'),
	(666727, 132, '2015-02-01 00:00:00.000000', 'consum', 0.0270, 'lps'),
	(666728, 132, '2015-02-01 00:00:01.000000', 'consum', 0.0242, 'lps'),
	(666729, 132, '2015-02-01 00:00:02.000000', 'consum', 0.0309, 'lps'),
	(666730, 132, '2015-02-01 00:00:03.000000', 'consum', 0.0260, 'lps'),
	(666731, 132, '2015-02-01 00:00:04.000000', 'consum', 0.0281, 'lps'),
	(666732, 132, '2015-02-01 00:00:05.000000', 'consum', 0.0300, 'lps'),
	(666733, 132, '2015-02-01 00:00:06.000000', 'consum', 0.0216, 'lps'),
	(666734, 132, '2015-02-01 00:00:07.000000', 'consum', 0.0319, 'lps'),
	(666735, 132, '2015-02-01 00:00:08.000000', 'consum', 0.0270, 'lps'),
	(666736, 132, '2015-02-01 00:00:09.000000', 'consum', 0.0303, 'lps'),
	(666737, 132, '2015-02-01 00:00:10.000000', 'consum', 0.0263, 'lps'),
	(666738, 132, '2015-02-01 00:00:11.000000', 'consum', 0.0313, 'lps'),
	(666739, 132, '2015-02-01 00:00:12.000000', 'consum', 0.0218, 'lps'),
	(666740, 132, '2015-02-01 00:00:13.000000', 'consum', 0.0291, 'lps'),
	(666741, 132, '2015-02-01 00:00:14.000000', 'consum', 0.0244, 'lps'),
	(666742, 132, '2015-02-01 00:00:15.000000', 'consum', 0.0253, 'lps'),
	(666743, 132, '2015-02-01 00:00:16.000000', 'consum', 0.0322, 'lps'),
	(666744, 132, '2015-02-01 00:00:17.000000', 'consum', 0.0292, 'lps'),
	(666745, 132, '2015-02-01 00:00:18.000000', 'consum', 0.0287, 'lps'),
	(666746, 132, '2015-02-01 00:00:19.000000', 'consum', 0.0234, 'lps'),
	(666747, 132, '2015-02-01 00:00:20.000000', 'consum', 0.0214, 'lps'),
	(666748, 132, '2015-02-01 00:00:21.000000', 'consum', 0.0276, 'lps'),
	(666749, 132, '2015-02-01 00:00:22.000000', 'consum', 0.0295, 'lps'),
	(666750, 132, '2015-02-01 00:00:23.000000', 'consum', 0.0324, 'lps'),
	(666751, 132, '2015-02-01 00:00:24.000000', 'consum', 0.0293, 'lps'),
	(666752, 132, '2015-02-01 00:00:25.000000', 'consum', 0.0282, 'lps'),
	(666753, 132, '2015-02-01 00:00:26.000000', 'consum', 0.0321, 'lps'),
	(666754, 132, '2015-02-01 00:00:27.000000', 'consum', 0.0318, 'lps'),
	(666755, 132, '2015-02-01 00:00:28.000000', 'consum', 0.0300, 'lps'),
	(666756, 132, '2015-02-01 00:00:29.000000', 'consum', 0.0222, 'lps'),
	(666757, 132, '2015-02-01 00:00:30.000000', 'consum', 0.0233, 'lps'),
	(666758, 132, '2015-02-01 00:00:31.000000', 'consum', 0.0291, 'lps'),
	(666759, 132, '2015-02-01 00:00:32.000000', 'consum', 0.0313, 'lps'),
	(666760, 132, '2015-02-01 00:00:33.000000', 'consum', 0.0250, 'lps'),
	(666761, 132, '2015-02-01 00:00:34.000000', 'consum', 0.0216, 'lps'),
	(666762, 132, '2015-02-01 00:00:35.000000', 'consum', 0.0240, 'lps'),
	(666763, 132, '2015-02-01 00:00:36.000000', 'consum', 0.0225, 'lps'),
	(666764, 132, '2015-02-01 00:00:37.000000', 'consum', 0.0309, 'lps'),
	(666765, 132, '2015-02-01 00:00:38.000000', 'consum', 0.0316, 'lps'),
	(666766, 132, '2015-02-01 00:00:39.000000', 'consum', 0.0212, 'lps'),
	(666767, 132, '2015-02-01 00:00:40.000000', 'consum', 0.0248, 'lps'),
	(666768, 132, '2015-02-01 00:00:41.000000', 'consum', 0.0281, 'lps'),
	(666769, 132, '2015-02-01 00:00:42.000000', 'consum', 0.0217, 'lps'),
	(666770, 132, '2015-02-01 00:00:43.000000', 'consum', 0.0265, 'lps'),
	(666771, 132, '2015-02-01 00:00:44.000000', 'consum', 0.0232, 'lps'),
	(666772, 132, '2015-02-01 00:00:45.000000', 'consum', 0.0272, 'lps'),
	(666773, 132, '2015-02-01 00:00:46.000000', 'consum', 0.0222, 'lps'),
	(666774, 132, '2015-02-01 00:00:47.000000', 'consum', 0.0316, 'lps'),
	(666775, 132, '2015-02-01 00:00:48.000000', 'consum', 0.0239, 'lps'),
	(666776, 132, '2015-02-01 00:00:49.000000', 'consum', 0.0273, 'lps'),
	(666777, 132, '2015-02-01 00:00:50.000000', 'consum', 0.0319, 'lps'),
	(666778, 132, '2015-02-01 00:00:51.000000', 'consum', 0.0222, 'lps'),
	(666779, 132, '2015-02-01 00:00:52.000000', 'consum', 0.0289, 'lps'),
	(666780, 132, '2015-02-01 00:00:53.000000', 'consum', 0.0220, 'lps'),
	(666781, 132, '2015-02-01 00:00:54.000000', 'consum', 0.0259, 'lps'),
	(666782, 132, '2015-02-01 00:00:55.000000', 'consum', 0.0308, 'lps'),
	(666783, 132, '2015-02-01 00:00:56.000000', 'consum', 0.0321, 'lps'),
	(666784, 132, '2015-02-01 00:00:57.000000', 'consum', 0.0242, 'lps'),
	(666785, 132, '2015-02-01 00:00:58.000000', 'consum', 0.0267, 'lps'),
	(666786, 132, '2015-02-01 00:00:59.000000', 'consum', 0.0284, 'lps'),
	(666787, 132, '2015-02-01 00:01:00.000000', 'consum', 0.0294, 'lps'),
	(666788, 132, '2015-02-01 00:01:01.000000', 'consum', 0.0290, 'lps'),
	(666789, 132, '2015-02-01 00:01:02.000000', 'consum', 0.0245, 'lps'),
	(666790, 132, '2015-02-01 00:01:03.000000', 'consum', 0.0261, 'lps'),
	(666791, 132, '2015-02-01 00:01:04.000000', 'consum', 0.0245, 'lps'),
	(666792, 132, '2015-02-01 00:01:05.000000', 'consum', 0.0234, 'lps'),
	(666793, 132, '2015-02-01 00:01:06.000000', 'consum', 0.0223, 'lps'),
	(666794, 132, '2015-02-01 00:01:07.000000', 'consum', 0.0319, 'lps'),
	(666795, 132, '2015-02-01 00:01:08.000000', 'consum', 0.0254, 'lps'),
	(666796, 132, '2015-02-01 00:01:09.000000', 'consum', 0.0219, 'lps'),
	(666797, 132, '2015-02-01 00:01:10.000000', 'consum', 0.0240, 'lps'),
	(666798, 132, '2015-02-01 00:01:11.000000', 'consum', 0.0218, 'lps'),
	(666799, 132, '2015-02-01 00:01:12.000000', 'consum', 0.0277, 'lps'),
	(666800, 132, '2015-02-01 00:01:13.000000', 'consum', 0.0291, 'lps'),
	(666801, 132, '2015-02-01 00:01:14.000000', 'consum', 0.0295, 'lps'),
	(666802, 132, '2015-02-01 00:01:15.000000', 'consum', 0.0278, 'lps'),
	(666803, 132, '2015-02-01 00:01:16.000000', 'consum', 0.0297, 'lps'),
	(666804, 132, '2015-02-01 00:01:17.000000', 'consum', 0.0324, 'lps'),
	(666805, 132, '2015-02-01 00:01:18.000000', 'consum', 0.0289, 'lps'),
	(666806, 132, '2015-02-01 00:01:19.000000', 'consum', 0.0262, 'lps'),
	(666807, 132, '2015-02-01 00:01:20.000000', 'consum', 0.0233, 'lps'),
	(666808, 132, '2015-02-01 00:01:21.000000', 'consum', 0.0284, 'lps'),
	(666809, 132, '2015-02-01 00:01:22.000000', 'consum', 0.0282, 'lps'),
	(666810, 132, '2015-02-01 00:01:23.000000', 'consum', 0.0233, 'lps'),
	(666811, 132, '2015-02-01 00:01:24.000000', 'consum', 0.0223, 'lps'),
	(666812, 132, '2015-02-01 00:01:25.000000', 'consum', 0.0322, 'lps'),
	(666813, 132, '2015-02-01 00:01:26.000000', 'consum', 0.0269, 'lps'),
	(666814, 132, '2015-02-01 00:01:27.000000', 'consum', 0.0285, 'lps'),
	(666815, 132, '2015-02-01 00:01:28.000000', 'consum', 0.0292, 'lps'),
	(666816, 132, '2015-02-01 00:01:29.000000', 'consum', 0.0280, 'lps'),
	(666817, 132, '2015-02-01 00:01:30.000000', 'consum', 0.0316, 'lps'),
	(666818, 132, '2015-02-01 00:01:31.000000', 'consum', 0.0296, 'lps'),
	(666819, 132, '2015-02-01 00:01:32.000000', 'consum', 0.0323, 'lps'),
	(666820, 132, '2015-02-01 00:01:33.000000', 'consum', 0.0286, 'lps'),
	(666821, 132, '2015-02-01 00:01:34.000000', 'consum', 0.0250, 'lps'),
	(666822, 132, '2015-02-01 00:01:35.000000', 'consum', 0.0301, 'lps'),
	(666823, 132, '2015-02-01 00:01:36.000000', 'consum', 0.0312, 'lps'),
	(666824, 132, '2015-02-01 00:01:37.000000', 'consum', 0.0214, 'lps'),
	(666825, 132, '2015-02-01 00:01:38.000000', 'consum', 0.0275, 'lps'),
	(666826, 132, '2015-02-01 00:01:39.000000', 'consum', 0.0289, 'lps'),
	(666827, 132, '2015-02-01 00:01:40.000000', 'consum', 0.0297, 'lps'),
	(666828, 132, '2015-02-01 00:01:41.000000', 'consum', 0.0293, 'lps'),
	(666829, 132, '2015-02-01 00:01:42.000000', 'consum', 0.0247, 'lps'),
	(666830, 132, '2015-02-01 00:01:43.000000', 'consum', 0.0264, 'lps'),
	(666831, 132, '2015-02-01 00:01:44.000000', 'consum', 0.0253, 'lps'),
	(666832, 132, '2015-02-01 00:01:45.000000', 'consum', 0.0265, 'lps'),
	(666833, 132, '2015-02-01 00:01:46.000000', 'consum', 0.0241, 'lps'),
	(666834, 132, '2015-02-01 00:01:47.000000', 'consum', 0.0314, 'lps'),
	(666835, 132, '2015-02-01 00:01:48.000000', 'consum', 0.0291, 'lps'),
	(666836, 132, '2015-02-01 00:01:49.000000', 'consum', 0.0302, 'lps'),
	(666837, 132, '2015-02-01 00:01:50.000000', 'consum', 0.0313, 'lps'),
	(666838, 132, '2015-02-01 00:01:51.000000', 'consum', 0.0218, 'lps'),
	(666839, 132, '2015-02-01 00:01:52.000000', 'consum', 0.0290, 'lps'),
	(666840, 132, '2015-02-01 00:01:53.000000', 'consum', 0.0238, 'lps'),
	(666841, 132, '2015-02-01 00:01:54.000000', 'consum', 0.0226, 'lps'),
	(666842, 132, '2015-02-01 00:01:55.000000', 'consum', 0.0324, 'lps'),
	(666843, 132, '2015-02-01 00:01:56.000000', 'consum', 0.0266, 'lps'),
	(666844, 132, '2015-02-01 00:01:57.000000', 'consum', 0.0266, 'lps'),
	(666845, 132, '2015-02-01 00:01:58.000000', 'consum', 0.0320, 'lps'),
	(666846, 132, '2015-02-01 00:01:59.000000', 'consum', 0.0247, 'lps'),
	(666847, 132, '2015-02-01 00:02:00.000000', 'consum', 0.0298, 'lps'),
	(666848, 132, '2015-02-01 00:02:01.000000', 'consum', 0.0307, 'lps'),
	(666849, 132, '2015-02-01 00:02:02.000000', 'consum', 0.0314, 'lps'),
	(666850, 132, '2015-02-01 00:02:03.000000', 'consum', 0.0323, 'lps'),
	(666851, 132, '2015-02-01 00:02:04.000000', 'consum', 0.0232, 'lps'),
	(666852, 132, '2015-02-01 00:02:05.000000', 'consum', 0.0215, 'lps'),
	(666853, 132, '2015-02-01 00:02:06.000000', 'consum', 0.0283, 'lps'),
	(666854, 132, '2015-02-01 00:02:07.000000', 'consum', 0.0215, 'lps'),
	(666855, 132, '2015-02-01 00:02:08.000000', 'consum', 0.0246, 'lps'),
	(666856, 132, '2015-02-01 00:02:09.000000', 'consum', 0.0260, 'lps'),
	(666857, 132, '2015-02-01 00:02:10.000000', 'consum', 0.0238, 'lps'),
	(666858, 132, '2015-02-01 00:02:11.000000', 'consum', 0.0317, 'lps'),
	(666859, 132, '2015-02-01 00:02:12.000000', 'consum', 0.0315, 'lps'),
	(666860, 132, '2015-02-01 00:02:13.000000', 'consum', 0.0296, 'lps'),
	(666861, 132, '2015-02-01 00:02:14.000000', 'consum', 0.0324, 'lps'),
	(666862, 132, '2015-02-01 00:02:15.000000', 'consum', 0.0294, 'lps'),
	(666863, 132, '2015-02-01 00:02:16.000000', 'consum', 0.0287, 'lps'),
	(666864, 132, '2015-02-01 00:02:17.000000', 'consum', 0.0228, 'lps'),
	(666865, 132, '2015-02-01 00:02:18.000000', 'consum', 0.0299, 'lps'),
	(666866, 132, '2015-02-01 00:02:19.000000', 'consum', 0.0256, 'lps'),
	(666867, 132, '2015-02-01 00:02:20.000000', 'consum', 0.0289, 'lps'),
	(666868, 132, '2015-02-01 00:02:21.000000', 'consum', 0.0236, 'lps'),
	(666869, 132, '2015-02-01 00:02:22.000000', 'consum', 0.0218, 'lps'),
	(666870, 132, '2015-02-01 00:02:23.000000', 'consum', 0.0290, 'lps'),
	(666871, 132, '2015-02-01 00:02:24.000000', 'consum', 0.0237, 'lps'),
	(666872, 132, '2015-02-01 00:02:25.000000', 'consum', 0.0224, 'lps'),
	(666873, 132, '2015-02-01 00:02:26.000000', 'consum', 0.0312, 'lps'),
	(666874, 132, '2015-02-01 00:02:27.000000', 'consum', 0.0218, 'lps'),
	(666875, 132, '2015-02-01 00:02:28.000000', 'consum', 0.0290, 'lps'),
	(666876, 132, '2015-02-01 00:02:29.000000', 'consum', 0.0240, 'lps'),
	(666877, 132, '2015-02-01 00:02:30.000000', 'consum', 0.0234, 'lps'),
	(666878, 132, '2015-02-01 00:02:31.000000', 'consum', 0.0244, 'lps'),
	(666879, 132, '2015-02-01 00:02:32.000000', 'consum', 0.0305, 'lps'),
	(666880, 132, '2015-02-01 00:02:33.000000', 'consum', 0.0237, 'lps'),
	(666881, 132, '2015-02-01 00:02:34.000000', 'consum', 0.0293, 'lps'),
	(666882, 132, '2015-02-01 00:02:35.000000', 'consum', 0.0311, 'lps'),
	(666883, 132, '2015-02-01 00:02:36.000000', 'consum', 0.0235, 'lps'),
	(666884, 132, '2015-02-01 00:02:37.000000', 'consum', 0.0263, 'lps'),
	(666885, 132, '2015-02-01 00:02:38.000000', 'consum', 0.0285, 'lps'),
	(666886, 132, '2015-02-01 00:02:39.000000', 'consum', 0.0309, 'lps'),
	(666887, 132, '2015-02-01 00:02:40.000000', 'consum', 0.0251, 'lps'),
	(666888, 132, '2015-02-01 00:02:41.000000', 'consum', 0.0234, 'lps'),
	(666889, 132, '2015-02-01 00:02:42.000000', 'consum', 0.0322, 'lps'),
	(666890, 132, '2015-02-01 00:02:43.000000', 'consum', 0.0234, 'lps'),
	(666891, 132, '2015-02-01 00:02:44.000000', 'consum', 0.0227, 'lps'),
	(666892, 132, '2015-02-01 00:02:45.000000', 'consum', 0.0222, 'lps'),
	(666893, 132, '2015-02-01 00:02:46.000000', 'consum', 0.0221, 'lps'),
	(666894, 132, '2015-02-01 00:02:47.000000', 'consum', 0.0230, 'lps'),
	(666895, 132, '2015-02-01 00:02:48.000000', 'consum', 0.0276, 'lps'),
	(666896, 132, '2015-02-01 00:02:49.000000', 'consum', 0.0251, 'lps'),
	(666897, 132, '2015-02-01 00:02:50.000000', 'consum', 0.0215, 'lps'),
	(666898, 132, '2015-02-01 00:02:51.000000', 'consum', 0.0231, 'lps'),
	(666899, 132, '2015-02-01 00:02:52.000000', 'consum', 0.0298, 'lps'),
	(666900, 132, '2015-02-01 00:02:53.000000', 'consum', 0.0240, 'lps'),
	(666901, 132, '2015-02-01 00:02:54.000000', 'consum', 0.0214, 'lps'),
	(666902, 132, '2015-02-01 00:02:55.000000', 'consum', 0.0255, 'lps'),
	(666903, 132, '2015-02-01 00:02:56.000000', 'consum', 0.0307, 'lps'),
	(666904, 132, '2015-02-01 00:02:57.000000', 'consum', 0.0214, 'lps'),
	(666905, 132, '2015-02-01 00:02:58.000000', 'consum', 0.0287, 'lps'),
	(666906, 132, '2015-02-01 00:02:59.000000', 'consum', 0.0236, 'lps'),
	(666907, 132, '2015-02-01 00:03:00.000000', 'consum', 0.0224, 'lps'),
	(666908, 132, '2015-02-01 00:03:01.000000', 'consum', 0.0317, 'lps'),
	(666909, 132, '2015-02-01 00:03:02.000000', 'consum', 0.0242, 'lps'),
	(666910, 132, '2015-02-01 00:03:03.000000', 'consum', 0.0281, 'lps'),
	(666911, 132, '2015-02-01 00:03:04.000000', 'consum', 0.0237, 'lps'),
	(666912, 132, '2015-02-01 00:03:05.000000', 'consum', 0.0251, 'lps'),
	(666913, 132, '2015-02-01 00:03:06.000000', 'consum', 0.0216, 'lps'),
	(666914, 132, '2015-02-01 00:03:07.000000', 'consum', 0.0234, 'lps'),
	(666915, 132, '2015-02-01 00:03:08.000000', 'consum', 0.0313, 'lps'),
	(666916, 132, '2015-02-01 00:03:09.000000', 'consum', 0.0305, 'lps'),
	(666917, 132, '2015-02-01 00:03:10.000000', 'consum', 0.0262, 'lps'),
	(666918, 132, '2015-02-01 00:03:11.000000', 'consum', 0.0303, 'lps'),
	(666919, 132, '2015-02-01 00:03:12.000000', 'consum', 0.0284, 'lps'),
	(666920, 132, '2015-02-01 00:03:13.000000', 'consum', 0.0303, 'lps'),
	(666921, 132, '2015-02-01 00:03:14.000000', 'consum', 0.0223, 'lps'),
	(666922, 132, '2015-02-01 00:03:15.000000', 'consum', 0.0228, 'lps'),
	(666923, 132, '2015-02-01 00:03:16.000000', 'consum', 0.0263, 'lps'),
	(666924, 132, '2015-02-01 00:03:17.000000', 'consum', 0.0305, 'lps'),
	(666925, 132, '2015-02-01 00:03:18.000000', 'consum', 0.0292, 'lps'),
	(666926, 132, '2015-02-01 00:03:19.000000', 'consum', 0.0222, 'lps'),
	(666927, 132, '2015-02-01 00:03:20.000000', 'consum', 0.0256, 'lps'),
	(666928, 132, '2015-02-01 00:03:21.000000', 'consum', 0.0287, 'lps'),
	(666929, 132, '2015-02-01 00:03:22.000000', 'consum', 0.0227, 'lps'),
	(666930, 132, '2015-02-01 00:03:23.000000', 'consum', 0.0294, 'lps'),
	(666931, 132, '2015-02-01 00:03:24.000000', 'consum', 0.0234, 'lps'),
	(666932, 132, '2015-02-01 00:03:25.000000', 'consum', 0.0311, 'lps'),
	(666933, 132, '2015-02-01 00:03:26.000000', 'consum', 0.0295, 'lps'),
	(666934, 132, '2015-02-01 00:03:27.000000', 'consum', 0.0217, 'lps'),
	(666935, 132, '2015-02-01 00:03:28.000000', 'consum', 0.0221, 'lps'),
	(666936, 132, '2015-02-01 00:03:29.000000', 'consum', 0.0247, 'lps'),
	(666937, 132, '2015-02-01 00:03:30.000000', 'consum', 0.0247, 'lps'),
	(666938, 132, '2015-02-01 00:03:31.000000', 'consum', 0.0282, 'lps'),
	(666939, 132, '2015-02-01 00:03:32.000000', 'consum', 0.0227, 'lps'),
	(666940, 132, '2015-02-01 00:03:33.000000', 'consum', 0.0313, 'lps'),
	(666941, 132, '2015-02-01 00:03:34.000000', 'consum', 0.0324, 'lps'),
	(666942, 132, '2015-02-01 00:03:35.000000', 'consum', 0.0242, 'lps'),
	(666943, 132, '2015-02-01 00:03:36.000000', 'consum', 0.0261, 'lps'),
	(666944, 132, '2015-02-01 00:03:37.000000', 'consum', 0.0253, 'lps'),
	(666945, 132, '2015-02-01 00:03:38.000000', 'consum', 0.0273, 'lps'),
	(666946, 132, '2015-02-01 00:03:39.000000', 'consum', 0.0280, 'lps'),
	(666947, 132, '2015-02-01 00:03:40.000000', 'consum', 0.0256, 'lps'),
	(666948, 132, '2015-02-01 00:03:41.000000', 'consum', 0.0231, 'lps'),
	(666949, 132, '2015-02-01 00:03:42.000000', 'consum', 0.0292, 'lps'),
	(666950, 132, '2015-02-01 00:03:43.000000', 'consum', 0.0325, 'lps'),
	(666951, 132, '2015-02-01 00:03:44.000000', 'consum', 0.0308, 'lps'),
	(666952, 132, '2015-02-01 00:03:45.000000', 'consum', 0.0241, 'lps'),
	(666953, 132, '2015-02-01 00:03:46.000000', 'consum', 0.0303, 'lps'),
	(666954, 132, '2015-02-01 00:03:47.000000', 'consum', 0.0235, 'lps'),
	(666955, 132, '2015-02-01 00:03:48.000000', 'consum', 0.0288, 'lps'),
	(666956, 132, '2015-02-01 00:03:49.000000', 'consum', 0.0293, 'lps'),
	(666957, 132, '2015-02-01 00:03:50.000000', 'consum', 0.0275, 'lps'),
	(666958, 132, '2015-02-01 00:03:51.000000', 'consum', 0.0289, 'lps'),
	(666959, 132, '2015-02-01 00:03:52.000000', 'consum', 0.0293, 'lps'),
	(666960, 132, '2015-02-01 00:03:53.000000', 'consum', 0.0272, 'lps'),
	(666961, 132, '2015-02-01 00:03:54.000000', 'consum', 0.0271, 'lps'),
	(666962, 132, '2015-02-01 00:03:55.000000', 'consum', 0.0212, 'lps'),
	(666963, 132, '2015-02-01 00:03:56.000000', 'consum', 0.0271, 'lps'),
	(666964, 132, '2015-02-01 00:03:57.000000', 'consum', 0.0279, 'lps'),
	(666965, 132, '2015-02-01 00:03:58.000000', 'consum', 0.0255, 'lps'),
	(666966, 132, '2015-02-01 00:03:59.000000', 'consum', 0.0227, 'lps'),
	(666967, 132, '2015-02-01 00:04:00.000000', 'consum', 0.0278, 'lps'),
	(666968, 132, '2015-02-01 00:04:01.000000', 'consum', 0.0269, 'lps'),
	(666969, 132, '2015-02-01 00:04:02.000000', 'consum', 0.0298, 'lps'),
	(666970, 132, '2015-02-01 00:04:03.000000', 'consum', 0.0245, 'lps'),
	(666971, 132, '2015-02-01 00:04:04.000000', 'consum', 0.0235, 'lps'),
	(666972, 132, '2015-02-01 00:04:05.000000', 'consum', 0.0233, 'lps'),
	(666973, 132, '2015-02-01 00:04:06.000000', 'consum', 0.0250, 'lps'),
	(666974, 132, '2015-02-01 00:04:07.000000', 'consum', 0.0225, 'lps'),
	(666975, 132, '2015-02-01 00:04:08.000000', 'consum', 0.0283, 'lps'),
	(666976, 132, '2015-02-01 00:04:09.000000', 'consum', 0.0298, 'lps'),
	(666977, 132, '2015-02-01 00:04:10.000000', 'consum', 0.0314, 'lps'),
	(666978, 132, '2015-02-01 00:04:11.000000', 'consum', 0.0235, 'lps'),
	(666979, 132, '2015-02-01 00:04:12.000000', 'consum', 0.0257, 'lps'),
	(666980, 132, '2015-02-01 00:04:13.000000', 'consum', 0.0254, 'lps'),
	(666981, 132, '2015-02-01 00:04:14.000000', 'consum', 0.0288, 'lps'),
	(666982, 132, '2015-02-01 00:04:15.000000', 'consum', 0.0236, 'lps'),
	(666983, 132, '2015-02-01 00:04:16.000000', 'consum', 0.0224, 'lps'),
	(666984, 132, '2015-02-01 00:04:17.000000', 'consum', 0.0316, 'lps'),
	(666985, 132, '2015-02-01 00:04:18.000000', 'consum', 0.0238, 'lps'),
	(666986, 132, '2015-02-01 00:04:19.000000', 'consum', 0.0263, 'lps'),
	(666987, 132, '2015-02-01 00:04:20.000000', 'consum', 0.0277, 'lps'),
	(666988, 132, '2015-02-01 00:04:21.000000', 'consum', 0.0268, 'lps'),
	(666989, 132, '2015-02-01 00:04:22.000000', 'consum', 0.0302, 'lps'),
	(666990, 132, '2015-02-01 00:04:23.000000', 'consum', 0.0264, 'lps'),
	(666991, 132, '2015-02-01 00:04:24.000000', 'consum', 0.0318, 'lps'),
	(666992, 132, '2015-02-01 00:04:25.000000', 'consum', 0.0243, 'lps'),
	(666993, 132, '2015-02-01 00:04:26.000000', 'consum', 0.0284, 'lps'),
	(666994, 132, '2015-02-01 00:04:27.000000', 'consum', 0.0247, 'lps'),
	(666995, 132, '2015-02-01 00:04:28.000000', 'consum', 0.0292, 'lps'),
	(666996, 132, '2015-02-01 00:04:29.000000', 'consum', 0.0277, 'lps'),
	(666997, 132, '2015-02-01 00:04:30.000000', 'consum', 0.0298, 'lps'),
	(666998, 132, '2015-02-01 00:04:31.000000', 'consum', 0.0219, 'lps'),
	(666999, 132, '2015-02-01 00:04:32.000000', 'consum', 0.0223, 'lps'),
	(667000, 132, '2015-02-01 00:04:33.000000', 'consum', 0.0246, 'lps'),
	(667001, 132, '2015-02-01 00:04:34.000000', 'consum', 0.0239, 'lps'),
	(667002, 132, '2015-02-01 00:04:35.000000', 'consum', 0.0247, 'lps'),
	(667003, 132, '2015-02-01 00:04:36.000000', 'consum', 0.0306, 'lps'),
	(667004, 132, '2015-02-01 00:04:37.000000', 'consum', 0.0235, 'lps'),
	(667005, 132, '2015-02-01 00:04:38.000000', 'consum', 0.0276, 'lps'),
	(667006, 132, '2015-02-01 00:04:39.000000', 'consum', 0.0237, 'lps'),
	(667007, 132, '2015-02-01 00:04:40.000000', 'consum', 0.0262, 'lps'),
	(667008, 132, '2015-02-01 00:04:41.000000', 'consum', 0.0275, 'lps'),
	(667009, 132, '2015-02-01 00:04:42.000000', 'consum', 0.0261, 'lps'),
	(667010, 132, '2015-02-01 00:04:43.000000', 'consum', 0.0272, 'lps'),
	(667011, 132, '2015-02-01 00:04:44.000000', 'consum', 0.0250, 'lps'),
	(667012, 132, '2015-02-01 00:04:45.000000', 'consum', 0.0225, 'lps'),
	(667013, 132, '2015-02-01 00:04:46.000000', 'consum', 0.0283, 'lps'),
	(667014, 132, '2015-02-01 00:04:47.000000', 'consum', 0.0296, 'lps'),
	(667015, 132, '2015-02-01 00:04:48.000000', 'consum', 0.0307, 'lps'),
	(667016, 132, '2015-02-01 00:04:49.000000', 'consum', 0.0320, 'lps'),
	(667017, 132, '2015-02-01 00:04:50.000000', 'consum', 0.0237, 'lps'),
	(667018, 132, '2015-02-01 00:04:51.000000', 'consum', 0.0246, 'lps'),
	(667019, 132, '2015-02-01 00:04:52.000000', 'consum', 0.0313, 'lps'),
	(667020, 132, '2015-02-01 00:04:53.000000', 'consum', 0.0269, 'lps'),
	(667021, 132, '2015-02-01 00:04:54.000000', 'consum', 0.0313, 'lps'),
	(667022, 132, '2015-02-01 00:04:55.000000', 'consum', 0.0314, 'lps'),
	(667023, 132, '2015-02-01 00:04:56.000000', 'consum', 0.0306, 'lps'),
	(667024, 132, '2015-02-01 00:04:57.000000', 'consum', 0.0265, 'lps'),
	(667025, 132, '2015-02-01 00:04:58.000000', 'consum', 0.0311, 'lps'),
	(667026, 132, '2015-02-01 00:04:59.000000', 'consum', 0.0319, 'lps'),
	(667027, 132, '2015-02-01 00:05:00.000000', 'consum', 0.0221, 'lps'),
	(667028, 132, '2015-02-01 00:05:01.000000', 'consum', 0.0288, 'lps'),
	(667029, 132, '2015-02-01 00:05:02.000000', 'consum', 0.0217, 'lps'),
	(667030, 132, '2015-02-01 00:05:03.000000', 'consum', 0.0244, 'lps'),
	(667031, 132, '2015-02-01 00:05:04.000000', 'consum', 0.0243, 'lps'),
	(667032, 132, '2015-02-01 00:05:05.000000', 'consum', 0.0272, 'lps'),
	(667033, 132, '2015-02-01 00:05:06.000000', 'consum', 0.0307, 'lps'),
	(667034, 132, '2015-02-01 00:05:07.000000', 'consum', 0.0279, 'lps'),
	(667035, 132, '2015-02-01 00:05:08.000000', 'consum', 0.0262, 'lps'),
	(667036, 132, '2015-02-01 00:05:09.000000', 'consum', 0.0263, 'lps'),
	(667037, 132, '2015-02-01 00:05:10.000000', 'consum', 0.0322, 'lps'),
	(667038, 132, '2015-02-01 00:05:11.000000', 'consum', 0.0262, 'lps'),
	(667039, 132, '2015-02-01 00:05:12.000000', 'consum', 0.0252, 'lps'),
	(667040, 132, '2015-02-01 00:05:13.000000', 'consum', 0.0266, 'lps'),
	(667041, 132, '2015-02-01 00:05:14.000000', 'consum', 0.0246, 'lps'),
	(667042, 132, '2015-02-01 00:05:15.000000', 'consum', 0.0222, 'lps'),
	(667043, 132, '2015-02-01 00:05:16.000000', 'consum', 0.0279, 'lps'),
	(667044, 132, '2015-02-01 00:05:17.000000', 'consum', 0.0287, 'lps'),
	(667045, 132, '2015-02-01 00:05:18.000000', 'consum', 0.0273, 'lps'),
	(667046, 132, '2015-02-01 00:05:19.000000', 'consum', 0.0294, 'lps'),
	(667047, 132, '2015-02-01 00:05:20.000000', 'consum', 0.0210, 'lps'),
	(667048, 132, '2015-02-01 00:05:21.000000', 'consum', 0.0308, 'lps'),
	(667049, 132, '2015-02-01 00:05:22.000000', 'consum', 0.0236, 'lps'),
	(667050, 132, '2015-02-01 00:05:23.000000', 'consum', 0.0279, 'lps'),
	(667051, 132, '2015-02-01 00:05:24.000000', 'consum', 0.0246, 'lps'),
	(667052, 132, '2015-02-01 00:05:25.000000', 'consum', 0.0298, 'lps'),
	(667053, 132, '2015-02-01 00:05:26.000000', 'consum', 0.0311, 'lps'),
	(667054, 132, '2015-02-01 00:05:27.000000', 'consum', 0.0221, 'lps'),
	(667055, 132, '2015-02-01 00:05:28.000000', 'consum', 0.0309, 'lps'),
	(667056, 132, '2015-02-01 00:05:29.000000', 'consum', 0.0325, 'lps'),
	(667057, 132, '2015-02-01 00:05:30.000000', 'consum', 0.0258, 'lps'),
	(667058, 132, '2015-02-01 00:05:31.000000', 'consum', 0.0220, 'lps'),
	(667059, 132, '2015-02-01 00:05:32.000000', 'consum', 0.0232, 'lps'),
	(667060, 132, '2015-02-01 00:05:33.000000', 'consum', 0.0290, 'lps'),
	(667061, 132, '2015-02-01 00:05:34.000000', 'consum', 0.0311, 'lps'),
	(667062, 132, '2015-02-01 00:05:35.000000', 'consum', 0.0247, 'lps'),
	(667063, 132, '2015-02-01 00:05:36.000000', 'consum', 0.0323, 'lps'),
	(667064, 132, '2015-02-01 00:05:37.000000', 'consum', 0.0316, 'lps'),
	(667065, 132, '2015-02-01 00:05:38.000000', 'consum', 0.0285, 'lps'),
	(667066, 132, '2015-02-01 00:05:39.000000', 'consum', 0.0268, 'lps'),
	(667067, 132, '2015-02-01 00:05:40.000000', 'consum', 0.0277, 'lps'),
	(667068, 132, '2015-02-01 00:05:41.000000', 'consum', 0.0255, 'lps'),
	(667069, 132, '2015-02-01 00:05:42.000000', 'consum', 0.0235, 'lps'),
	(667070, 132, '2015-02-01 00:05:43.000000', 'consum', 0.0314, 'lps'),
	(667071, 132, '2015-02-01 00:05:44.000000', 'consum', 0.0308, 'lps'),
	(667072, 132, '2015-02-01 00:05:45.000000', 'consum', 0.0275, 'lps'),
	(667073, 132, '2015-02-01 00:05:46.000000', 'consum', 0.0241, 'lps'),
	(667074, 132, '2015-02-01 00:05:47.000000', 'consum', 0.0285, 'lps'),
	(667075, 132, '2015-02-01 00:05:48.000000', 'consum', 0.0263, 'lps'),
	(667076, 132, '2015-02-01 00:05:49.000000', 'consum', 0.0248, 'lps'),
	(667077, 132, '2015-02-01 00:05:50.000000', 'consum', 0.0241, 'lps'),
	(667078, 132, '2015-02-01 00:05:51.000000', 'consum', 0.0253, 'lps'),
	(667079, 132, '2015-02-01 00:05:52.000000', 'consum', 0.0217, 'lps'),
	(667080, 132, '2015-02-01 00:05:53.000000', 'consum', 0.0232, 'lps'),
	(667081, 132, '2015-02-01 00:05:54.000000', 'consum', 0.0299, 'lps'),
	(667082, 132, '2015-02-01 00:05:55.000000', 'consum', 0.0242, 'lps'),
	(667083, 132, '2015-02-01 00:05:56.000000', 'consum', 0.0219, 'lps'),
	(667084, 132, '2015-02-01 00:05:57.000000', 'consum', 0.0277, 'lps'),
	(667085, 132, '2015-02-01 00:05:58.000000', 'consum', 0.0284, 'lps'),
	(667086, 132, '2015-02-01 00:05:59.000000', 'consum', 0.0263, 'lps'),
	(667087, 132, '2015-02-01 00:06:00.000000', 'consum', 0.0255, 'lps'),
	(667088, 132, '2015-02-01 00:06:01.000000', 'consum', 0.0274, 'lps'),
	(667089, 132, '2015-02-01 00:06:02.000000', 'consum', 0.0283, 'lps'),
	(667090, 132, '2015-02-01 00:06:03.000000', 'consum', 0.0265, 'lps'),
	(667091, 132, '2015-02-01 00:06:04.000000', 'consum', 0.0266, 'lps'),
	(667092, 132, '2015-02-01 00:06:05.000000', 'consum', 0.0210, 'lps'),
	(667093, 132, '2015-02-01 00:06:06.000000', 'consum', 0.0276, 'lps'),
	(667094, 132, '2015-02-01 00:06:07.000000', 'consum', 0.0309, 'lps'),
	(667095, 132, '2015-02-01 00:06:08.000000', 'consum', 0.0273, 'lps'),
	(667096, 132, '2015-02-01 00:06:09.000000', 'consum', 0.0229, 'lps'),
	(667097, 132, '2015-02-01 00:06:10.000000', 'consum', 0.0232, 'lps'),
	(667098, 132, '2015-02-01 00:06:11.000000', 'consum', 0.0264, 'lps'),
	(667099, 132, '2015-02-01 00:06:12.000000', 'consum', 0.0297, 'lps'),
	(667100, 132, '2015-02-01 00:06:13.000000', 'consum', 0.0253, 'lps'),
	(667101, 132, '2015-02-01 00:06:14.000000', 'consum', 0.0279, 'lps'),
	(667102, 132, '2015-02-01 00:06:15.000000', 'consum', 0.0313, 'lps'),
	(667103, 132, '2015-02-01 00:06:16.000000', 'consum', 0.0285, 'lps'),
	(667104, 132, '2015-02-01 00:06:17.000000', 'consum', 0.0278, 'lps'),
	(667105, 132, '2015-02-01 00:06:18.000000', 'consum', 0.0324, 'lps'),
	(667106, 132, '2015-02-01 00:06:19.000000', 'consum', 0.0228, 'lps'),
	(667107, 132, '2015-02-01 00:06:20.000000', 'consum', 0.0307, 'lps'),
	(667108, 132, '2015-02-01 00:06:21.000000', 'consum', 0.0292, 'lps'),
	(667109, 132, '2015-02-01 00:06:22.000000', 'consum', 0.0215, 'lps'),
	(667110, 132, '2015-02-01 00:06:23.000000', 'consum', 0.0223, 'lps'),
	(667111, 132, '2015-02-01 00:06:24.000000', 'consum', 0.0258, 'lps'),
	(667112, 132, '2015-02-01 00:06:25.000000', 'consum', 0.0298, 'lps'),
	(667113, 132, '2015-02-01 00:06:26.000000', 'consum', 0.0272, 'lps'),
	(667114, 132, '2015-02-01 00:06:27.000000', 'consum', 0.0259, 'lps'),
	(667115, 132, '2015-02-01 00:06:28.000000', 'consum', 0.0268, 'lps'),
	(667116, 132, '2015-02-01 00:06:29.000000', 'consum', 0.0237, 'lps'),
	(667117, 132, '2015-02-01 00:06:30.000000', 'consum', 0.0290, 'lps'),
	(667118, 132, '2015-02-01 00:06:31.000000', 'consum', 0.0297, 'lps'),
	(667119, 132, '2015-02-01 00:06:32.000000', 'consum', 0.0288, 'lps'),
	(667120, 132, '2015-02-01 00:06:33.000000', 'consum', 0.0222, 'lps'),
	(667121, 132, '2015-02-01 00:06:34.000000', 'consum', 0.0271, 'lps'),
	(667122, 132, '2015-02-01 00:06:35.000000', 'consum', 0.0246, 'lps'),
	(667123, 132, '2015-02-01 00:06:36.000000', 'consum', 0.0325, 'lps'),
	(667124, 132, '2015-02-01 00:06:37.000000', 'consum', 0.0213, 'lps'),
	(667125, 132, '2015-02-01 00:06:38.000000', 'consum', 0.0229, 'lps'),
	(667126, 132, '2015-02-01 00:06:39.000000', 'consum', 0.0298, 'lps'),
	(667127, 132, '2015-02-01 00:06:40.000000', 'consum', 0.0244, 'lps'),
	(667128, 132, '2015-02-01 00:06:41.000000', 'consum', 0.0233, 'lps'),
	(667129, 132, '2015-02-01 00:06:42.000000', 'consum', 0.0223, 'lps'),
	(667130, 132, '2015-02-01 00:06:43.000000', 'consum', 0.0324, 'lps'),
	(667131, 132, '2015-02-01 00:06:44.000000', 'consum', 0.0275, 'lps'),
	(667132, 132, '2015-02-01 00:06:45.000000', 'consum', 0.0312, 'lps'),
	(667133, 132, '2015-02-01 00:06:46.000000', 'consum', 0.0294, 'lps'),
	(667134, 132, '2015-02-01 00:06:47.000000', 'consum', 0.0323, 'lps'),
	(667135, 132, '2015-02-01 00:06:48.000000', 'consum', 0.0291, 'lps'),
	(667136, 132, '2015-02-01 00:06:49.000000', 'consum', 0.0277, 'lps'),
	(667137, 132, '2015-02-01 00:06:50.000000', 'consum', 0.0301, 'lps'),
	(667138, 132, '2015-02-01 00:06:51.000000', 'consum', 0.0233, 'lps'),
	(667139, 132, '2015-02-01 00:06:52.000000', 'consum', 0.0286, 'lps'),
	(667140, 132, '2015-02-01 00:06:53.000000', 'consum', 0.0289, 'lps'),
	(667141, 132, '2015-02-01 00:06:54.000000', 'consum', 0.0262, 'lps'),
	(667142, 132, '2015-02-01 00:06:55.000000', 'consum', 0.0235, 'lps'),
	(667143, 132, '2015-02-01 00:06:56.000000', 'consum', 0.0294, 'lps'),
	(667144, 132, '2015-02-01 00:06:57.000000', 'consum', 0.0322, 'lps'),
	(667145, 132, '2015-02-01 00:06:58.000000', 'consum', 0.0286, 'lps'),
	(667146, 132, '2015-02-01 00:06:59.000000', 'consum', 0.0254, 'lps'),
	(667147, 132, '2015-02-01 00:07:00.000000', 'consum', 0.0318, 'lps'),
	(667148, 132, '2015-02-01 00:07:01.000000', 'consum', 0.0272, 'lps'),
	(667149, 132, '2015-02-01 00:07:02.000000', 'consum', 0.0311, 'lps'),
	(667150, 132, '2015-02-01 00:07:03.000000', 'consum', 0.0297, 'lps'),
	(667151, 132, '2015-02-01 00:07:04.000000', 'consum', 0.0228, 'lps'),
	(667152, 132, '2015-02-01 00:07:05.000000', 'consum', 0.0271, 'lps'),
	(667153, 132, '2015-02-01 00:07:06.000000', 'consum', 0.0229, 'lps'),
	(667154, 132, '2015-02-01 00:07:07.000000', 'consum', 0.0240, 'lps'),
	(667155, 132, '2015-02-01 00:07:08.000000', 'consum', 0.0302, 'lps'),
	(667156, 132, '2015-02-01 00:07:09.000000', 'consum', 0.0232, 'lps'),
	(667157, 132, '2015-02-01 00:07:10.000000', 'consum', 0.0276, 'lps'),
	(667158, 132, '2015-02-01 00:07:11.000000', 'consum', 0.0244, 'lps'),
	(667159, 132, '2015-02-01 00:07:12.000000', 'consum', 0.0297, 'lps'),
	(667160, 132, '2015-02-01 00:07:13.000000', 'consum', 0.0312, 'lps'),
	(667161, 132, '2015-02-01 00:07:14.000000', 'consum', 0.0227, 'lps'),
	(667162, 132, '2015-02-01 00:07:15.000000', 'consum', 0.0222, 'lps'),
	(667163, 132, '2015-02-01 00:07:16.000000', 'consum', 0.0218, 'lps'),
	(667164, 132, '2015-02-01 00:07:17.000000', 'consum', 0.0216, 'lps'),
	(667165, 132, '2015-02-01 00:07:18.000000', 'consum', 0.0216, 'lps'),
	(667166, 132, '2015-02-01 00:07:19.000000', 'consum', 0.0223, 'lps'),
	(667167, 132, '2015-02-01 00:07:20.000000', 'consum', 0.0258, 'lps'),
	(667168, 132, '2015-02-01 00:07:21.000000', 'consum', 0.0295, 'lps'),
	(667169, 132, '2015-02-01 00:07:22.000000', 'consum', 0.0261, 'lps'),
	(667170, 132, '2015-02-01 00:07:23.000000', 'consum', 0.0210, 'lps'),
	(667171, 132, '2015-02-01 00:07:24.000000', 'consum', 0.0287, 'lps'),
	(667172, 132, '2015-02-01 00:07:25.000000', 'consum', 0.0250, 'lps'),
	(667173, 132, '2015-02-01 00:07:26.000000', 'consum', 0.0296, 'lps'),
	(667174, 132, '2015-02-01 00:07:27.000000', 'consum', 0.0288, 'lps'),
	(667175, 132, '2015-02-01 00:07:28.000000', 'consum', 0.0224, 'lps'),
	(667176, 132, '2015-02-01 00:07:29.000000', 'consum', 0.0281, 'lps'),
	(667177, 132, '2015-02-01 00:07:30.000000', 'consum', 0.0292, 'lps'),
	(667178, 132, '2015-02-01 00:07:31.000000', 'consum', 0.0289, 'lps'),
	(667179, 132, '2015-02-01 00:07:32.000000', 'consum', 0.0245, 'lps'),
	(667180, 132, '2015-02-01 00:07:33.000000', 'consum', 0.0263, 'lps'),
	(667181, 132, '2015-02-01 00:07:34.000000', 'consum', 0.0256, 'lps'),
	(667182, 132, '2015-02-01 00:07:35.000000', 'consum', 0.0280, 'lps'),
	(667183, 132, '2015-02-01 00:07:36.000000', 'consum', 0.0305, 'lps'),
	(667184, 132, '2015-02-01 00:07:37.000000', 'consum', 0.0246, 'lps'),
	(667185, 132, '2015-02-01 00:07:38.000000', 'consum', 0.0221, 'lps'),
	(667186, 132, '2015-02-01 00:07:39.000000', 'consum', 0.0273, 'lps'),
	(667187, 132, '2015-02-01 00:07:40.000000', 'consum', 0.0262, 'lps'),
	(667188, 132, '2015-02-01 00:07:41.000000', 'consum', 0.0282, 'lps'),
	(667189, 132, '2015-02-01 00:07:42.000000', 'consum', 0.0296, 'lps'),
	(667190, 132, '2015-02-01 00:07:43.000000', 'consum', 0.0312, 'lps'),
	(667191, 132, '2015-02-01 00:07:44.000000', 'consum', 0.0227, 'lps'),
	(667192, 132, '2015-02-01 00:07:45.000000', 'consum', 0.0222, 'lps'),
	(667193, 132, '2015-02-01 00:07:46.000000', 'consum', 0.0222, 'lps'),
	(667194, 132, '2015-02-01 00:07:47.000000', 'consum', 0.0232, 'lps'),
	(667195, 132, '2015-02-01 00:07:48.000000', 'consum', 0.0284, 'lps'),
	(667196, 132, '2015-02-01 00:07:49.000000', 'consum', 0.0282, 'lps'),
	(667197, 132, '2015-02-01 00:07:50.000000', 'consum', 0.0235, 'lps'),
	(667198, 132, '2015-02-01 00:07:51.000000', 'consum', 0.0235, 'lps'),
	(667199, 132, '2015-02-01 00:07:52.000000', 'consum', 0.0259, 'lps'),
	(667200, 132, '2015-02-01 00:07:53.000000', 'consum', 0.0265, 'lps'),
	(667201, 132, '2015-02-01 00:07:54.000000', 'consum', 0.0221, 'lps'),
	(667202, 132, '2015-02-01 00:07:55.000000', 'consum', 0.0218, 'lps'),
	(667203, 132, '2015-02-01 00:07:56.000000', 'consum', 0.0216, 'lps'),
	(667204, 132, '2015-02-01 00:07:57.000000', 'consum', 0.0219, 'lps'),
	(667205, 132, '2015-02-01 00:07:58.000000', 'consum', 0.0235, 'lps'),
	(667206, 132, '2015-02-01 00:07:59.000000', 'consum', 0.0309, 'lps'),
	(667207, 132, '2015-02-01 00:08:00.000000', 'consum', 0.0281, 'lps'),
	(667208, 132, '2015-02-01 00:08:01.000000', 'consum', 0.0269, 'lps'),
	(667209, 132, '2015-02-01 00:08:02.000000', 'consum', 0.0294, 'lps'),
	(667210, 132, '2015-02-01 00:08:03.000000', 'consum', 0.0223, 'lps'),
	(667211, 132, '2015-02-01 00:08:04.000000', 'consum', 0.0252, 'lps'),
	(667212, 132, '2015-02-01 00:08:05.000000', 'consum', 0.0268, 'lps'),
	(667213, 132, '2015-02-01 00:08:06.000000', 'consum', 0.0259, 'lps'),
	(667214, 132, '2015-02-01 00:08:07.000000', 'consum', 0.0280, 'lps'),
	(667215, 132, '2015-02-01 00:08:08.000000', 'consum', 0.0297, 'lps'),
	(667216, 132, '2015-02-01 00:08:09.000000', 'consum', 0.0319, 'lps'),
	(667217, 132, '2015-02-01 00:08:10.000000', 'consum', 0.0262, 'lps'),
	(667218, 132, '2015-02-01 00:08:11.000000', 'consum', 0.0261, 'lps'),
	(667219, 132, '2015-02-01 00:08:12.000000', 'consum', 0.0308, 'lps'),
	(667220, 132, '2015-02-01 00:08:13.000000', 'consum', 0.0316, 'lps'),
	(667221, 132, '2015-02-01 00:08:14.000000', 'consum', 0.0215, 'lps'),
	(667222, 132, '2015-02-01 00:08:15.000000', 'consum', 0.0265, 'lps'),
	(667223, 132, '2015-02-01 00:08:16.000000', 'consum', 0.0240, 'lps'),
	(667224, 132, '2015-02-01 00:08:17.000000', 'consum', 0.0312, 'lps'),
	(667225, 132, '2015-02-01 00:08:18.000000', 'consum', 0.0281, 'lps'),
	(667226, 132, '2015-02-01 00:08:19.000000', 'consum', 0.0259, 'lps'),
	(667227, 132, '2015-02-01 00:08:20.000000', 'consum', 0.0244, 'lps'),
	(667228, 132, '2015-02-01 00:08:21.000000', 'consum', 0.0234, 'lps'),
	(667229, 132, '2015-02-01 00:08:22.000000', 'consum', 0.0229, 'lps'),
	(667230, 132, '2015-02-01 00:08:23.000000', 'consum', 0.0232, 'lps'),
	(667231, 132, '2015-02-01 00:08:24.000000', 'consum', 0.0265, 'lps'),
	(667232, 132, '2015-02-01 00:08:25.000000', 'consum', 0.0301, 'lps'),
	(667233, 132, '2015-02-01 00:08:26.000000', 'consum', 0.0268, 'lps'),
	(667234, 132, '2015-02-01 00:08:27.000000', 'consum', 0.0229, 'lps'),
	(667235, 132, '2015-02-01 00:08:28.000000', 'consum', 0.0246, 'lps'),
	(667236, 132, '2015-02-01 00:08:29.000000', 'consum', 0.0220, 'lps'),
	(667237, 132, '2015-02-01 00:08:30.000000', 'consum', 0.0268, 'lps'),
	(667238, 132, '2015-02-01 00:08:31.000000', 'consum', 0.0239, 'lps'),
	(667239, 132, '2015-02-01 00:08:32.000000', 'consum', 0.0298, 'lps'),
	(667240, 132, '2015-02-01 00:08:33.000000', 'consum', 0.0217, 'lps'),
	(667241, 132, '2015-02-01 00:08:34.000000', 'consum', 0.0210, 'lps'),
	(667242, 132, '2015-02-01 00:08:35.000000', 'consum', 0.0307, 'lps'),
	(667243, 132, '2015-02-01 00:08:36.000000', 'consum', 0.0233, 'lps'),
	(667244, 132, '2015-02-01 00:08:37.000000', 'consum', 0.0266, 'lps'),
	(667245, 132, '2015-02-01 00:08:38.000000', 'consum', 0.0304, 'lps'),
	(667246, 132, '2015-02-01 00:08:39.000000', 'consum', 0.0280, 'lps'),
	(667247, 132, '2015-02-01 00:08:40.000000', 'consum', 0.0281, 'lps'),
	(667248, 132, '2015-02-01 00:08:41.000000', 'consum', 0.0238, 'lps'),
	(667249, 132, '2015-02-01 00:08:42.000000', 'consum', 0.0254, 'lps'),
	(667250, 132, '2015-02-01 00:08:43.000000', 'consum', 0.0231, 'lps'),
	(667251, 132, '2015-02-01 00:08:44.000000', 'consum', 0.0298, 'lps'),
	(667252, 132, '2015-02-01 00:08:45.000000', 'consum', 0.0239, 'lps'),
	(667253, 132, '2015-02-01 00:08:46.000000', 'consum', 0.0210, 'lps'),
	(667254, 132, '2015-02-01 00:08:47.000000', 'consum', 0.0239, 'lps'),
	(667255, 132, '2015-02-01 00:08:48.000000', 'consum', 0.0238, 'lps'),
	(667256, 132, '2015-02-01 00:08:49.000000', 'consum', 0.0262, 'lps'),
	(667257, 132, '2015-02-01 00:08:50.000000', 'consum', 0.0274, 'lps'),
	(667258, 132, '2015-02-01 00:08:51.000000', 'consum', 0.0256, 'lps'),
	(667259, 132, '2015-02-01 00:08:52.000000', 'consum', 0.0251, 'lps'),
	(667260, 132, '2015-02-01 00:08:53.000000', 'consum', 0.0278, 'lps'),
	(667261, 132, '2015-02-01 00:08:54.000000', 'consum', 0.0311, 'lps'),
	(667262, 132, '2015-02-01 00:08:55.000000', 'consum', 0.0280, 'lps'),
	(667263, 132, '2015-02-01 00:08:56.000000', 'consum', 0.0258, 'lps'),
	(667264, 132, '2015-02-01 00:08:57.000000', 'consum', 0.0241, 'lps'),
	(667265, 132, '2015-02-01 00:08:58.000000', 'consum', 0.0221, 'lps'),
	(667266, 132, '2015-02-01 00:08:59.000000', 'consum', 0.0288, 'lps'),
	(667267, 132, '2015-02-01 00:09:00.000000', 'consum', 0.0218, 'lps'),
	(667268, 132, '2015-02-01 00:09:01.000000', 'consum', 0.0249, 'lps'),
	(667269, 132, '2015-02-01 00:09:02.000000', 'consum', 0.0264, 'lps'),
	(667270, 132, '2015-02-01 00:09:03.000000', 'consum', 0.0250, 'lps'),
	(667271, 132, '2015-02-01 00:09:04.000000', 'consum', 0.0249, 'lps'),
	(667272, 132, '2015-02-01 00:09:05.000000', 'consum', 0.0285, 'lps'),
	(667273, 132, '2015-02-01 00:09:06.000000', 'consum', 0.0235, 'lps'),
	(667274, 132, '2015-02-01 00:09:07.000000', 'consum', 0.0225, 'lps'),
	(667275, 132, '2015-02-01 00:09:08.000000', 'consum', 0.0214, 'lps'),
	(667276, 132, '2015-02-01 00:09:09.000000', 'consum', 0.0298, 'lps'),
	(667277, 132, '2015-02-01 00:09:10.000000', 'consum', 0.0294, 'lps'),
	(667278, 132, '2015-02-01 00:09:11.000000', 'consum', 0.0249, 'lps'),
	(667279, 132, '2015-02-01 00:09:12.000000', 'consum', 0.0271, 'lps'),
	(667280, 132, '2015-02-01 00:09:13.000000', 'consum', 0.0283, 'lps'),
	(667281, 132, '2015-02-01 00:09:14.000000', 'consum', 0.0276, 'lps'),
	(667282, 132, '2015-02-01 00:09:15.000000', 'consum', 0.0322, 'lps'),
	(667283, 132, '2015-02-01 00:09:16.000000', 'consum', 0.0222, 'lps'),
	(667284, 132, '2015-02-01 00:09:17.000000', 'consum', 0.0286, 'lps'),
	(667285, 132, '2015-02-01 00:09:18.000000', 'consum', 0.0320, 'lps'),
	(667286, 132, '2015-02-01 00:09:19.000000', 'consum', 0.0302, 'lps'),
	(667287, 132, '2015-02-01 00:09:20.000000', 'consum', 0.0222, 'lps'),
	(667288, 132, '2015-02-01 00:09:21.000000', 'consum', 0.0227, 'lps'),
	(667289, 132, '2015-02-01 00:09:22.000000', 'consum', 0.0260, 'lps'),
	(667290, 132, '2015-02-01 00:09:23.000000', 'consum', 0.0295, 'lps'),
	(667291, 132, '2015-02-01 00:09:24.000000', 'consum', 0.0254, 'lps'),
	(667292, 132, '2015-02-01 00:09:25.000000', 'consum', 0.0290, 'lps'),
	(667293, 132, '2015-02-01 00:09:26.000000', 'consum', 0.0246, 'lps'),
	(667294, 132, '2015-02-01 00:09:27.000000', 'consum', 0.0268, 'lps'),
	(667295, 132, '2015-02-01 00:09:28.000000', 'consum', 0.0274, 'lps'),
	(667296, 132, '2015-02-01 00:09:29.000000', 'consum', 0.0242, 'lps'),
	(667297, 132, '2015-02-01 00:09:30.000000', 'consum', 0.0296, 'lps'),
	(667298, 132, '2015-02-01 00:09:31.000000', 'consum', 0.0312, 'lps'),
	(667299, 132, '2015-02-01 00:09:32.000000', 'consum', 0.0232, 'lps'),
	(667300, 132, '2015-02-01 00:09:33.000000', 'consum', 0.0244, 'lps'),
	(667301, 132, '2015-02-01 00:09:34.000000', 'consum', 0.0315, 'lps'),
	(667302, 132, '2015-02-01 00:09:35.000000', 'consum', 0.0285, 'lps'),
	(667303, 132, '2015-02-01 00:09:36.000000', 'consum', 0.0272, 'lps'),
	(667304, 132, '2015-02-01 00:09:37.000000', 'consum', 0.0294, 'lps'),
	(667305, 132, '2015-02-01 00:09:38.000000', 'consum', 0.0215, 'lps'),
	(667306, 132, '2015-02-01 00:09:39.000000', 'consum', 0.0214, 'lps'),
	(667307, 132, '2015-02-01 00:09:40.000000', 'consum', 0.0216, 'lps'),
	(667308, 132, '2015-02-01 00:09:41.000000', 'consum', 0.0228, 'lps'),
	(667309, 132, '2015-02-01 00:09:42.000000', 'consum', 0.0284, 'lps'),
	(667310, 132, '2015-02-01 00:09:43.000000', 'consum', 0.0292, 'lps'),
	(667311, 132, '2015-02-01 00:09:44.000000', 'consum', 0.0284, 'lps'),
	(667312, 132, '2015-02-01 00:09:45.000000', 'consum', 0.0216, 'lps'),
	(667313, 132, '2015-02-01 00:09:46.000000', 'consum', 0.0252, 'lps'),
	(667314, 132, '2015-02-01 00:09:47.000000', 'consum', 0.0289, 'lps'),
	(667315, 132, '2015-02-01 00:09:48.000000', 'consum', 0.0244, 'lps'),
	(667316, 132, '2015-02-01 00:09:49.000000', 'consum', 0.0261, 'lps'),
	(667317, 132, '2015-02-01 00:09:50.000000', 'consum', 0.0246, 'lps'),
	(667318, 132, '2015-02-01 00:09:51.000000', 'consum', 0.0238, 'lps'),
	(667319, 132, '2015-02-01 00:09:52.000000', 'consum', 0.0241, 'lps'),
	(667320, 132, '2015-02-01 00:09:53.000000', 'consum', 0.0283, 'lps'),
	(667321, 132, '2015-02-01 00:09:54.000000', 'consum', 0.0250, 'lps'),
	(667322, 132, '2015-02-01 00:09:55.000000', 'consum', 0.0310, 'lps'),
	(667323, 132, '2015-02-01 00:09:56.000000', 'consum', 0.0239, 'lps'),
	(667324, 132, '2015-02-01 00:09:57.000000', 'consum', 0.0291, 'lps'),
	(667325, 132, '2015-02-01 00:09:58.000000', 'consum', 0.0294, 'lps'),
	(667326, 132, '2015-02-01 00:09:59.000000', 'consum', 0.0271, 'lps'),
	(667327, 132, '2015-02-01 00:10:00.000000', 'consum', 0.0266, 'lps'),
	(667328, 132, '2015-02-01 00:10:01.000000', 'consum', 0.0306, 'lps'),
	(667329, 132, '2015-02-01 00:10:02.000000', 'consum', 0.0291, 'lps'),
	(667330, 132, '2015-02-01 00:10:03.000000', 'consum', 0.0212, 'lps'),
	(667331, 132, '2015-02-01 00:10:04.000000', 'consum', 0.0325, 'lps'),
	(667332, 132, '2015-02-01 00:10:05.000000', 'consum', 0.0316, 'lps'),
	(667333, 132, '2015-02-01 00:10:06.000000', 'consum', 0.0278, 'lps'),
	(667334, 132, '2015-02-01 00:10:07.000000', 'consum', 0.0232, 'lps'),
	(667335, 132, '2015-02-01 00:10:08.000000', 'consum', 0.0233, 'lps'),
	(667336, 132, '2015-02-01 00:10:09.000000', 'consum', 0.0258, 'lps'),
	(667337, 132, '2015-02-01 00:10:10.000000', 'consum', 0.0266, 'lps'),
	(667338, 132, '2015-02-01 00:10:11.000000', 'consum', 0.0231, 'lps'),
	(667339, 132, '2015-02-01 00:10:12.000000', 'consum', 0.0264, 'lps'),
	(667340, 132, '2015-02-01 00:10:13.000000', 'consum', 0.0299, 'lps'),
	(667341, 132, '2015-02-01 00:10:14.000000', 'consum', 0.0263, 'lps'),
	(667342, 132, '2015-02-01 00:10:15.000000', 'consum', 0.0210, 'lps'),
	(667343, 132, '2015-02-01 00:10:16.000000', 'consum', 0.0281, 'lps'),
	(667344, 132, '2015-02-01 00:10:17.000000', 'consum', 0.0218, 'lps'),
	(667345, 132, '2015-02-01 00:10:18.000000', 'consum', 0.0272, 'lps'),
	(667346, 132, '2015-02-01 00:10:19.000000', 'consum', 0.0261, 'lps'),
	(667347, 132, '2015-02-01 00:10:20.000000', 'consum', 0.0283, 'lps'),
	(667348, 132, '2015-02-01 00:10:21.000000', 'consum', 0.0304, 'lps'),
	(667349, 132, '2015-02-01 00:10:22.000000', 'consum', 0.0230, 'lps'),
	(667350, 132, '2015-02-01 00:10:23.000000', 'consum', 0.0260, 'lps'),
	(667351, 132, '2015-02-01 00:10:24.000000', 'consum', 0.0286, 'lps'),
	(667352, 132, '2015-02-01 00:10:25.000000', 'consum', 0.0323, 'lps'),
	(667353, 132, '2015-02-01 00:10:26.000000', 'consum', 0.0315, 'lps'),
	(667354, 132, '2015-02-01 00:10:27.000000', 'consum', 0.0283, 'lps'),
	(667355, 132, '2015-02-01 00:10:28.000000', 'consum', 0.0259, 'lps'),
	(667356, 132, '2015-02-01 00:10:29.000000', 'consum', 0.0235, 'lps'),
	(667357, 132, '2015-02-01 00:10:30.000000', 'consum', 0.0307, 'lps'),
	(667358, 132, '2015-02-01 00:10:31.000000', 'consum', 0.0272, 'lps'),
	(667359, 132, '2015-02-01 00:10:32.000000', 'consum', 0.0229, 'lps'),
	(667360, 132, '2015-02-01 00:10:33.000000', 'consum', 0.0237, 'lps'),
	(667361, 132, '2015-02-01 00:10:34.000000', 'consum', 0.0289, 'lps'),
	(667362, 132, '2015-02-01 00:10:35.000000', 'consum', 0.0290, 'lps'),
	(667363, 132, '2015-02-01 00:10:36.000000', 'consum', 0.0258, 'lps'),
	(667364, 132, '2015-02-01 00:10:37.000000', 'consum', 0.0213, 'lps'),
	(667365, 132, '2015-02-01 00:10:38.000000', 'consum', 0.0311, 'lps'),
	(667366, 132, '2015-02-01 00:10:39.000000', 'consum', 0.0243, 'lps'),
	(667367, 132, '2015-02-01 00:10:40.000000', 'consum', 0.0303, 'lps'),
	(667368, 132, '2015-02-01 00:10:41.000000', 'consum', 0.0230, 'lps'),
	(667369, 132, '2015-02-01 00:10:42.000000', 'consum', 0.0263, 'lps'),
	(667370, 132, '2015-02-01 00:10:43.000000', 'consum', 0.0298, 'lps'),
	(667371, 132, '2015-02-01 00:10:44.000000', 'consum', 0.0260, 'lps'),
	(667372, 132, '2015-02-01 00:10:45.000000', 'consum', 0.0313, 'lps'),
	(667373, 132, '2015-02-01 00:10:46.000000', 'consum', 0.0226, 'lps'),
	(667374, 132, '2015-02-01 00:10:47.000000', 'consum', 0.0217, 'lps'),
	(667375, 132, '2015-02-01 00:10:48.000000', 'consum', 0.0310, 'lps'),
	(667376, 132, '2015-02-01 00:10:49.000000', 'consum', 0.0228, 'lps'),
	(667377, 132, '2015-02-01 00:10:50.000000', 'consum', 0.0231, 'lps'),
	(667378, 132, '2015-02-01 00:10:51.000000', 'consum', 0.0261, 'lps'),
	(667379, 132, '2015-02-01 00:10:52.000000', 'consum', 0.0288, 'lps'),
	(667380, 132, '2015-02-01 00:10:53.000000', 'consum', 0.0215, 'lps'),
	(667381, 132, '2015-02-01 00:10:54.000000', 'consum', 0.0233, 'lps'),
	(667382, 132, '2015-02-01 00:10:55.000000', 'consum', 0.0309, 'lps'),
	(667383, 132, '2015-02-01 00:10:56.000000', 'consum', 0.0291, 'lps'),
	(667384, 132, '2015-02-01 00:10:57.000000', 'consum', 0.0317, 'lps'),
	(667385, 132, '2015-02-01 00:10:58.000000', 'consum', 0.0270, 'lps'),
	(667386, 132, '2015-02-01 00:10:59.000000', 'consum', 0.0306, 'lps'),
	(667387, 132, '2015-02-01 00:11:00.000000', 'consum', 0.0278, 'lps'),
	(667388, 132, '2015-02-01 00:11:01.000000', 'consum', 0.0265, 'lps'),
	(667389, 132, '2015-02-01 00:11:02.000000', 'consum', 0.0280, 'lps'),
	(667390, 132, '2015-02-01 00:11:03.000000', 'consum', 0.0279, 'lps'),
	(667391, 132, '2015-02-01 00:11:04.000000', 'consum', 0.0230, 'lps'),
	(667392, 132, '2015-02-01 00:11:05.000000', 'consum', 0.0218, 'lps'),
	(667393, 132, '2015-02-01 00:11:06.000000', 'consum', 0.0307, 'lps'),
	(667394, 132, '2015-02-01 00:11:07.000000', 'consum', 0.0323, 'lps'),
	(667395, 132, '2015-02-01 00:11:08.000000', 'consum', 0.0254, 'lps'),
	(667396, 132, '2015-02-01 00:11:09.000000', 'consum', 0.0321, 'lps'),
	(667397, 132, '2015-02-01 00:11:10.000000', 'consum', 0.0288, 'lps'),
	(667398, 132, '2015-02-01 00:11:11.000000', 'consum', 0.0268, 'lps'),
	(667399, 132, '2015-02-01 00:11:12.000000', 'consum', 0.0265, 'lps'),
	(667400, 132, '2015-02-01 00:11:13.000000', 'consum', 0.0314, 'lps'),
	(667401, 132, '2015-02-01 00:11:14.000000', 'consum', 0.0214, 'lps'),
	(667402, 132, '2015-02-01 00:11:15.000000', 'consum', 0.0269, 'lps'),
	(667403, 132, '2015-02-01 00:11:16.000000', 'consum', 0.0259, 'lps'),
	(667404, 132, '2015-02-01 00:11:17.000000', 'consum', 0.0282, 'lps'),
	(667405, 132, '2015-02-01 00:11:18.000000', 'consum', 0.0304, 'lps'),
	(667406, 132, '2015-02-01 00:11:19.000000', 'consum', 0.0234, 'lps'),
	(667407, 132, '2015-02-01 00:11:20.000000', 'consum', 0.0280, 'lps'),
	(667408, 132, '2015-02-01 00:11:21.000000', 'consum', 0.0255, 'lps'),
	(667409, 132, '2015-02-01 00:11:22.000000', 'consum', 0.0228, 'lps'),
	(667410, 132, '2015-02-01 00:11:23.000000', 'consum', 0.0282, 'lps'),
	(667411, 132, '2015-02-01 00:11:24.000000', 'consum', 0.0283, 'lps'),
	(667412, 132, '2015-02-01 00:11:25.000000', 'consum', 0.0243, 'lps'),
	(667413, 132, '2015-02-01 00:11:26.000000', 'consum', 0.0275, 'lps'),
	(667414, 132, '2015-02-01 00:11:27.000000', 'consum', 0.0319, 'lps'),
	(667415, 132, '2015-02-01 00:11:28.000000', 'consum', 0.0214, 'lps'),
	(667416, 132, '2015-02-01 00:11:29.000000', 'consum', 0.0250, 'lps'),
	(667417, 132, '2015-02-01 00:11:30.000000', 'consum', 0.0282, 'lps'),
	(667418, 132, '2015-02-01 00:11:31.000000', 'consum', 0.0220, 'lps'),
	(667419, 132, '2015-02-01 00:11:32.000000', 'consum', 0.0278, 'lps'),
	(667420, 132, '2015-02-01 00:11:33.000000', 'consum', 0.0287, 'lps'),
	(667421, 132, '2015-02-01 00:11:34.000000', 'consum', 0.0274, 'lps'),
	(667422, 132, '2015-02-01 00:11:35.000000', 'consum', 0.0302, 'lps'),
	(667423, 132, '2015-02-01 00:11:36.000000', 'consum', 0.0246, 'lps'),
	(667424, 132, '2015-02-01 00:11:37.000000', 'consum', 0.0231, 'lps'),
	(667425, 132, '2015-02-01 00:11:38.000000', 'consum', 0.0324, 'lps'),
	(667426, 132, '2015-02-01 00:11:39.000000', 'consum', 0.0255, 'lps'),
	(667427, 132, '2015-02-01 00:11:40.000000', 'consum', 0.0323, 'lps'),
	(667428, 132, '2015-02-01 00:11:41.000000', 'consum', 0.0294, 'lps'),
	(667429, 132, '2015-02-01 00:11:42.000000', 'consum', 0.0290, 'lps'),
	(667430, 132, '2015-02-01 00:11:43.000000', 'consum', 0.0241, 'lps'),
	(667431, 132, '2015-02-01 00:11:44.000000', 'consum', 0.0245, 'lps'),
	(667432, 132, '2015-02-01 00:11:45.000000', 'consum', 0.0291, 'lps'),
	(667433, 132, '2015-02-01 00:11:46.000000', 'consum', 0.0278, 'lps'),
	(667434, 132, '2015-02-01 00:11:47.000000', 'consum', 0.0309, 'lps'),
	(667435, 132, '2015-02-01 00:11:48.000000', 'consum', 0.0270, 'lps'),
	(667436, 132, '2015-02-01 00:11:49.000000', 'consum', 0.0212, 'lps'),
	(667437, 132, '2015-02-01 00:11:50.000000', 'consum', 0.0275, 'lps'),
	(667438, 132, '2015-02-01 00:11:51.000000', 'consum', 0.0296, 'lps'),
	(667439, 132, '2015-02-01 00:11:52.000000', 'consum', 0.0215, 'lps'),
	(667440, 132, '2015-02-01 00:11:53.000000', 'consum', 0.0323, 'lps'),
	(667441, 132, '2015-02-01 00:11:54.000000', 'consum', 0.0300, 'lps'),
	(667442, 132, '2015-02-01 00:11:55.000000', 'consum', 0.0318, 'lps'),
	(667443, 132, '2015-02-01 00:11:56.000000', 'consum', 0.0249, 'lps'),
	(667444, 132, '2015-02-01 00:11:57.000000', 'consum', 0.0315, 'lps'),
	(667445, 132, '2015-02-01 00:11:58.000000', 'consum', 0.0269, 'lps'),
	(667446, 132, '2015-02-01 00:11:59.000000', 'consum', 0.0307, 'lps'),
	(667447, 132, '2015-02-01 00:12:00.000000', 'consum', 0.0288, 'lps'),
	(667448, 132, '2015-02-01 00:12:01.000000', 'consum', 0.0308, 'lps'),
	(667449, 132, '2015-02-01 00:12:02.000000', 'consum', 0.0236, 'lps'),
	(667450, 132, '2015-02-01 00:12:03.000000', 'consum', 0.0278, 'lps'),
	(667451, 132, '2015-02-01 00:12:04.000000', 'consum', 0.0239, 'lps'),
	(667452, 132, '2015-02-01 00:12:05.000000', 'consum', 0.0270, 'lps'),
	(667453, 132, '2015-02-01 00:12:06.000000', 'consum', 0.0307, 'lps'),
	(667454, 132, '2015-02-01 00:12:07.000000', 'consum', 0.0281, 'lps'),
	(667455, 132, '2015-02-01 00:12:08.000000', 'consum', 0.0276, 'lps'),
	(667456, 132, '2015-02-01 00:12:09.000000', 'consum', 0.0210, 'lps'),
	(667457, 132, '2015-02-01 00:12:10.000000', 'consum', 0.0244, 'lps'),
	(667458, 132, '2015-02-01 00:12:11.000000', 'consum', 0.0267, 'lps'),
	(667459, 132, '2015-02-01 00:12:12.000000', 'consum', 0.0275, 'lps'),
	(667460, 132, '2015-02-01 00:12:13.000000', 'consum', 0.0250, 'lps'),
	(667461, 132, '2015-02-01 00:12:14.000000', 'consum', 0.0213, 'lps'),
	(667462, 132, '2015-02-01 00:12:15.000000', 'consum', 0.0223, 'lps'),
	(667463, 132, '2015-02-01 00:12:16.000000', 'consum', 0.0268, 'lps'),
	(667464, 132, '2015-02-01 00:12:17.000000', 'consum', 0.0229, 'lps'),
	(667465, 132, '2015-02-01 00:12:18.000000', 'consum', 0.0246, 'lps'),
	(667466, 132, '2015-02-01 00:12:19.000000', 'consum', 0.0218, 'lps'),
	(667467, 132, '2015-02-01 00:12:20.000000', 'consum', 0.0260, 'lps'),
	(667468, 132, '2015-02-01 00:12:21.000000', 'consum', 0.0320, 'lps'),
	(667469, 132, '2015-02-01 00:12:22.000000', 'consum', 0.0261, 'lps'),
	(667470, 132, '2015-02-01 00:12:23.000000', 'consum', 0.0254, 'lps'),
	(667471, 132, '2015-02-01 00:12:24.000000', 'consum', 0.0277, 'lps'),
	(667472, 132, '2015-02-01 00:12:25.000000', 'consum', 0.0299, 'lps'),
	(667473, 132, '2015-02-01 00:12:26.000000', 'consum', 0.0221, 'lps'),
	(667474, 132, '2015-02-01 00:12:27.000000', 'consum', 0.0229, 'lps'),
	(667475, 132, '2015-02-01 00:12:28.000000', 'consum', 0.0272, 'lps'),
	(667476, 132, '2015-02-01 00:12:29.000000', 'consum', 0.0232, 'lps'),
	(667477, 132, '2015-02-01 00:12:30.000000', 'consum', 0.0251, 'lps'),
	(667478, 132, '2015-02-01 00:12:31.000000', 'consum', 0.0233, 'lps'),
	(667479, 132, '2015-02-01 00:12:32.000000', 'consum', 0.0318, 'lps'),
	(667480, 132, '2015-02-01 00:12:33.000000', 'consum', 0.0220, 'lps'),
	(667481, 132, '2015-02-01 00:12:34.000000', 'consum', 0.0282, 'lps'),
	(667482, 132, '2015-02-01 00:12:35.000000', 'consum', 0.0311, 'lps'),
	(667483, 132, '2015-02-01 00:12:36.000000', 'consum', 0.0266, 'lps'),
	(667484, 132, '2015-02-01 00:12:37.000000', 'consum', 0.0305, 'lps'),
	(667485, 132, '2015-02-01 00:12:38.000000', 'consum', 0.0283, 'lps'),
	(667486, 132, '2015-02-01 00:12:39.000000', 'consum', 0.0291, 'lps'),
	(667487, 132, '2015-02-01 00:12:40.000000', 'consum', 0.0280, 'lps'),
	(667488, 132, '2015-02-01 00:12:41.000000', 'consum', 0.0318, 'lps'),
	(667489, 132, '2015-02-01 00:12:42.000000', 'consum', 0.0307, 'lps'),
	(667490, 132, '2015-02-01 00:12:43.000000', 'consum', 0.0256, 'lps'),
	(667491, 132, '2015-02-01 00:12:44.000000', 'consum', 0.0267, 'lps'),
	(667492, 132, '2015-02-01 00:12:45.000000', 'consum', 0.0240, 'lps'),
	(667493, 132, '2015-02-01 00:12:46.000000', 'consum', 0.0306, 'lps'),
	(667494, 132, '2015-02-01 00:12:47.000000', 'consum', 0.0254, 'lps'),
	(667495, 132, '2015-02-01 00:12:48.000000', 'consum', 0.0257, 'lps'),
	(667496, 132, '2015-02-01 00:12:49.000000', 'consum', 0.0313, 'lps'),
	(667497, 132, '2015-02-01 00:12:50.000000', 'consum', 0.0235, 'lps'),
	(667498, 132, '2015-02-01 00:12:51.000000', 'consum', 0.0260, 'lps'),
	(667499, 132, '2015-02-01 00:12:52.000000', 'consum', 0.0270, 'lps'),
	(667500, 132, '2015-02-01 00:12:53.000000', 'consum', 0.0245, 'lps'),
	(667501, 132, '2015-02-01 00:12:54.000000', 'consum', 0.0321, 'lps'),
	(667502, 132, '2015-02-01 00:12:55.000000', 'consum', 0.0312, 'lps'),
	(667503, 132, '2015-02-01 00:12:56.000000', 'consum', 0.0271, 'lps'),
	(667504, 132, '2015-02-01 00:12:57.000000', 'consum', 0.0324, 'lps'),
	(667505, 132, '2015-02-01 00:12:58.000000', 'consum', 0.0252, 'lps'),
	(667506, 132, '2015-02-01 00:12:59.000000', 'consum', 0.0308, 'lps'),
	(667507, 132, '2015-02-01 00:13:00.000000', 'consum', 0.0229, 'lps'),
	(667508, 132, '2015-02-01 00:13:01.000000', 'consum', 0.0242, 'lps'),
	(667509, 132, '2015-02-01 00:13:02.000000', 'consum', 0.0312, 'lps'),
	(667510, 132, '2015-02-01 00:13:03.000000', 'consum', 0.0278, 'lps'),
	(667511, 132, '2015-02-01 00:13:04.000000', 'consum', 0.0246, 'lps'),
	(667512, 132, '2015-02-01 00:13:05.000000', 'consum', 0.0302, 'lps'),
	(667513, 132, '2015-02-01 00:13:06.000000', 'consum', 0.0213, 'lps'),
	(667514, 132, '2015-02-01 00:13:07.000000', 'consum', 0.0297, 'lps'),
	(667515, 132, '2015-02-01 00:13:08.000000', 'consum', 0.0287, 'lps'),
	(667516, 132, '2015-02-01 00:13:09.000000', 'consum', 0.0222, 'lps'),
	(667517, 132, '2015-02-01 00:13:10.000000', 'consum', 0.0269, 'lps'),
	(667518, 132, '2015-02-01 00:13:11.000000', 'consum', 0.0237, 'lps'),
	(667519, 132, '2015-02-01 00:13:12.000000', 'consum', 0.0285, 'lps'),
	(667520, 132, '2015-02-01 00:13:13.000000', 'consum', 0.0272, 'lps'),
	(667521, 132, '2015-02-01 00:13:14.000000', 'consum', 0.0298, 'lps'),
	(667522, 132, '2015-02-01 00:13:15.000000', 'consum', 0.0230, 'lps'),
	(667523, 132, '2015-02-01 00:13:16.000000', 'consum', 0.0280, 'lps'),
	(667524, 132, '2015-02-01 00:13:17.000000', 'consum', 0.0267, 'lps'),
	(667525, 132, '2015-02-01 00:13:18.000000', 'consum', 0.0288, 'lps'),
	(667526, 132, '2015-02-01 00:13:19.000000', 'consum', 0.0313, 'lps'),
	(667527, 132, '2015-02-01 00:13:20.000000', 'consum', 0.0259, 'lps'),
	(667528, 132, '2015-02-01 00:13:21.000000', 'consum', 0.0261, 'lps'),
	(667529, 132, '2015-02-01 00:13:22.000000', 'consum', 0.0319, 'lps'),
	(667530, 132, '2015-02-01 00:13:23.000000', 'consum', 0.0254, 'lps'),
	(667531, 132, '2015-02-01 00:13:24.000000', 'consum', 0.0218, 'lps'),
	(667532, 132, '2015-02-01 00:13:25.000000', 'consum', 0.0238, 'lps'),
	(667533, 132, '2015-02-01 00:13:26.000000', 'consum', 0.0324, 'lps'),
	(667534, 132, '2015-02-01 00:13:27.000000', 'consum', 0.0233, 'lps'),
	(667535, 132, '2015-02-01 00:13:28.000000', 'consum', 0.0217, 'lps'),
	(667536, 132, '2015-02-01 00:13:29.000000', 'consum', 0.0293, 'lps'),
	(667537, 132, '2015-02-01 00:13:30.000000', 'consum', 0.0257, 'lps'),
	(667538, 132, '2015-02-01 00:13:31.000000', 'consum', 0.0312, 'lps'),
	(667539, 132, '2015-02-01 00:13:32.000000', 'consum', 0.0233, 'lps'),
	(667540, 132, '2015-02-01 00:13:33.000000', 'consum', 0.0251, 'lps'),
	(667541, 132, '2015-02-01 00:13:34.000000', 'consum', 0.0229, 'lps'),
	(667542, 132, '2015-02-01 00:13:35.000000', 'consum', 0.0299, 'lps'),
	(667543, 132, '2015-02-01 00:13:36.000000', 'consum', 0.0251, 'lps'),
	(667544, 132, '2015-02-01 00:13:37.000000', 'consum', 0.0266, 'lps'),
	(667545, 132, '2015-02-01 00:13:38.000000', 'consum', 0.0249, 'lps'),
	(667546, 132, '2015-02-01 00:13:39.000000', 'consum', 0.0240, 'lps'),
	(667547, 132, '2015-02-01 00:13:40.000000', 'consum', 0.0244, 'lps'),
	(667548, 132, '2015-02-01 00:13:41.000000', 'consum', 0.0289, 'lps'),
	(667549, 132, '2015-02-01 00:13:42.000000', 'consum', 0.0273, 'lps'),
	(667550, 132, '2015-02-01 00:13:43.000000', 'consum', 0.0290, 'lps'),
	(667551, 132, '2015-02-01 00:13:44.000000', 'consum', 0.0303, 'lps'),
	(667552, 132, '2015-02-01 00:13:45.000000', 'consum', 0.0319, 'lps'),
	(667553, 132, '2015-02-01 00:13:46.000000', 'consum', 0.0246, 'lps'),
	(667554, 132, '2015-02-01 00:13:47.000000', 'consum', 0.0294, 'lps'),
	(667555, 132, '2015-02-01 00:13:48.000000', 'consum', 0.0293, 'lps'),
	(667556, 132, '2015-02-01 00:13:49.000000', 'consum', 0.0258, 'lps'),
	(667557, 132, '2015-02-01 00:13:50.000000', 'consum', 0.0315, 'lps'),
	(667558, 132, '2015-02-01 00:13:51.000000', 'consum', 0.0243, 'lps'),
	(667559, 132, '2015-02-01 00:13:52.000000', 'consum', 0.0293, 'lps'),
	(667560, 132, '2015-02-01 00:13:53.000000', 'consum', 0.0297, 'lps'),
	(667561, 132, '2015-02-01 00:13:54.000000', 'consum', 0.0279, 'lps'),
	(667562, 132, '2015-02-01 00:13:55.000000', 'consum', 0.0294, 'lps'),
	(667563, 132, '2015-02-01 00:13:56.000000', 'consum', 0.0307, 'lps'),
	(667564, 132, '2015-02-01 00:13:57.000000', 'consum', 0.0213, 'lps'),
	(667565, 132, '2015-02-01 00:13:58.000000', 'consum', 0.0281, 'lps'),
	(667566, 132, '2015-02-01 00:13:59.000000', 'consum', 0.0324, 'lps'),
	(667567, 132, '2015-02-01 00:14:00.000000', 'consum', 0.0220, 'lps'),
	(667568, 132, '2015-02-01 00:14:01.000000', 'consum', 0.0266, 'lps'),
	(667569, 132, '2015-02-01 00:14:02.000000', 'consum', 0.0227, 'lps'),
	(667570, 132, '2015-02-01 00:14:03.000000', 'consum', 0.0245, 'lps'),
	(667571, 132, '2015-02-01 00:14:04.000000', 'consum', 0.0216, 'lps'),
	(667572, 132, '2015-02-01 00:14:05.000000', 'consum', 0.0254, 'lps'),
	(667573, 132, '2015-02-01 00:14:06.000000', 'consum', 0.0298, 'lps'),
	(667574, 132, '2015-02-01 00:14:07.000000', 'consum', 0.0284, 'lps'),
	(667575, 132, '2015-02-01 00:14:08.000000', 'consum', 0.0317, 'lps'),
	(667576, 132, '2015-02-01 00:14:09.000000', 'consum', 0.0294, 'lps'),
	(667577, 132, '2015-02-01 00:14:10.000000', 'consum', 0.0306, 'lps'),
	(667578, 132, '2015-02-01 00:14:11.000000', 'consum', 0.0324, 'lps'),
	(667579, 132, '2015-02-01 00:14:12.000000', 'consum', 0.0260, 'lps'),
	(667580, 132, '2015-02-01 00:14:13.000000', 'consum', 0.0236, 'lps'),
	(667581, 132, '2015-02-01 00:14:14.000000', 'consum', 0.0307, 'lps'),
	(667582, 132, '2015-02-01 00:14:15.000000', 'consum', 0.0267, 'lps'),
	(667583, 132, '2015-02-01 00:14:16.000000', 'consum', 0.0323, 'lps'),
	(667584, 132, '2015-02-01 00:14:17.000000', 'consum', 0.0257, 'lps'),
	(667585, 132, '2015-02-01 00:14:18.000000', 'consum', 0.0222, 'lps'),
	(667586, 132, '2015-02-01 00:14:19.000000', 'consum', 0.0245, 'lps'),
	(667587, 132, '2015-02-01 00:14:20.000000', 'consum', 0.0233, 'lps'),
	(667588, 132, '2015-02-01 00:14:21.000000', 'consum', 0.0223, 'lps'),
	(667589, 132, '2015-02-01 00:14:22.000000', 'consum', 0.0320, 'lps'),
	(667590, 132, '2015-02-01 00:14:23.000000', 'consum', 0.0257, 'lps'),
	(667591, 132, '2015-02-01 00:14:24.000000', 'consum', 0.0233, 'lps'),
	(667592, 132, '2015-02-01 00:14:25.000000', 'consum', 0.0300, 'lps'),
	(667593, 132, '2015-02-01 00:14:26.000000', 'consum', 0.0243, 'lps'),
	(667594, 132, '2015-02-01 00:14:27.000000', 'consum', 0.0222, 'lps'),
	(667595, 132, '2015-02-01 00:14:28.000000', 'consum', 0.0286, 'lps'),
	(667596, 132, '2015-02-01 00:14:29.000000', 'consum', 0.0324, 'lps'),
	(667597, 132, '2015-02-01 00:14:30.000000', 'consum', 0.0321, 'lps'),
	(667598, 132, '2015-02-01 00:14:31.000000', 'consum', 0.0305, 'lps'),
	(667599, 132, '2015-02-01 00:14:32.000000', 'consum', 0.0237, 'lps'),
	(667600, 132, '2015-02-01 00:14:33.000000', 'consum', 0.0294, 'lps'),
	(667601, 132, '2015-02-01 00:14:34.000000', 'consum', 0.0316, 'lps'),
	(667602, 132, '2015-02-01 00:14:35.000000', 'consum', 0.0255, 'lps'),
	(667603, 132, '2015-02-01 00:14:36.000000', 'consum', 0.0235, 'lps'),
	(667604, 132, '2015-02-01 00:14:37.000000', 'consum', 0.0318, 'lps'),
	(667605, 132, '2015-02-01 00:14:38.000000', 'consum', 0.0211, 'lps'),
	(667606, 132, '2015-02-01 00:14:39.000000', 'consum', 0.0241, 'lps'),
	(667607, 132, '2015-02-01 00:14:40.000000', 'consum', 0.0246, 'lps'),
	(667608, 132, '2015-02-01 00:14:41.000000', 'consum', 0.0297, 'lps'),
	(667609, 132, '2015-02-01 00:14:42.000000', 'consum', 0.0304, 'lps'),
	(667610, 132, '2015-02-01 00:14:43.000000', 'consum', 0.0303, 'lps'),
	(667611, 132, '2015-02-01 00:14:44.000000', 'consum', 0.0280, 'lps'),
	(667612, 132, '2015-02-01 00:14:45.000000', 'consum', 0.0279, 'lps'),
	(667613, 132, '2015-02-01 00:14:46.000000', 'consum', 0.0232, 'lps'),
	(667614, 132, '2015-02-01 00:14:47.000000', 'consum', 0.0228, 'lps'),
	(667615, 132, '2015-02-01 00:14:48.000000', 'consum', 0.0234, 'lps'),
	(667616, 132, '2015-02-01 00:14:49.000000', 'consum', 0.0278, 'lps'),
	(667617, 132, '2015-02-01 00:14:50.000000', 'consum', 0.0246, 'lps'),
	(667618, 132, '2015-02-01 00:14:51.000000', 'consum', 0.0301, 'lps'),
	(667619, 132, '2015-02-01 00:14:52.000000', 'consum', 0.0325, 'lps'),
	(667620, 132, '2015-02-01 00:14:53.000000', 'consum', 0.0280, 'lps'),
	(667621, 132, '2015-02-01 00:14:54.000000', 'consum', 0.0216, 'lps'),
	(667622, 132, '2015-02-01 00:14:55.000000', 'consum', 0.0262, 'lps'),
	(667623, 132, '2015-02-01 00:14:56.000000', 'consum', 0.0221, 'lps'),
	(667624, 132, '2015-02-01 00:14:57.000000', 'consum', 0.0223, 'lps'),
	(667625, 132, '2015-02-01 00:14:58.000000', 'consum', 0.0246, 'lps'),
	(667626, 132, '2015-02-01 00:14:59.000000', 'consum', 0.0236, 'lps'),
	(667627, 132, '2015-02-01 00:15:00.000000', 'consum', 0.0231, 'lps'),
	(667628, 132, '2015-02-01 00:15:01.000000', 'consum', 0.0237, 'lps'),
	(667629, 132, '2015-02-01 00:15:02.000000', 'consum', 0.0281, 'lps'),
	(667630, 132, '2015-02-01 00:15:03.000000', 'consum', 0.0256, 'lps'),
	(667631, 132, '2015-02-01 00:15:04.000000', 'consum', 0.0225, 'lps'),
	(667632, 132, '2015-02-01 00:15:05.000000', 'consum', 0.0265, 'lps'),
	(667633, 132, '2015-02-01 00:15:06.000000', 'consum', 0.0324, 'lps'),
	(667634, 132, '2015-02-01 00:15:07.000000', 'consum', 0.0266, 'lps'),
	(667635, 132, '2015-02-01 00:15:08.000000', 'consum', 0.0267, 'lps'),
	(667636, 132, '2015-02-01 00:15:09.000000', 'consum', 0.0211, 'lps'),
	(667637, 132, '2015-02-01 00:15:10.000000', 'consum', 0.0278, 'lps'),
	(667638, 132, '2015-02-01 00:15:11.000000', 'consum', 0.0314, 'lps'),
	(667639, 132, '2015-02-01 00:15:12.000000', 'consum', 0.0293, 'lps'),
	(667640, 132, '2015-02-01 00:15:13.000000', 'consum', 0.0315, 'lps'),
	(667641, 132, '2015-02-01 00:15:14.000000', 'consum', 0.0255, 'lps'),
	(667642, 132, '2015-02-01 00:15:15.000000', 'consum', 0.0237, 'lps'),
	(667643, 132, '2015-02-01 00:15:16.000000', 'consum', 0.0325, 'lps'),
	(667644, 132, '2015-02-01 00:15:17.000000', 'consum', 0.0240, 'lps'),
	(667645, 132, '2015-02-01 00:15:18.000000', 'consum', 0.0250, 'lps'),
	(667646, 132, '2015-02-01 00:15:19.000000', 'consum', 0.0320, 'lps'),
	(667647, 132, '2015-02-01 00:15:20.000000', 'consum', 0.0293, 'lps'),
	(667648, 132, '2015-02-01 00:15:21.000000', 'consum', 0.0295, 'lps'),
	(667649, 132, '2015-02-01 00:15:22.000000', 'consum', 0.0272, 'lps'),
	(667650, 132, '2015-02-01 00:15:23.000000', 'consum', 0.0265, 'lps'),
	(667651, 132, '2015-02-01 00:15:24.000000', 'consum', 0.0300, 'lps'),
	(667652, 132, '2015-02-01 00:15:25.000000', 'consum', 0.0263, 'lps'),
	(667653, 132, '2015-02-01 00:15:26.000000', 'consum', 0.0323, 'lps'),
	(667654, 132, '2015-02-01 00:15:27.000000', 'consum', 0.0268, 'lps'),
	(667655, 132, '2015-02-01 00:15:28.000000', 'consum', 0.0276, 'lps'),
	(667656, 132, '2015-02-01 00:15:29.000000', 'consum', 0.0251, 'lps'),
	(667657, 132, '2015-02-01 00:15:30.000000', 'consum', 0.0218, 'lps'),
	(667658, 132, '2015-02-01 00:15:31.000000', 'consum', 0.0244, 'lps'),
	(667659, 132, '2015-02-01 00:15:32.000000', 'consum', 0.0242, 'lps'),
	(667660, 132, '2015-02-01 00:15:33.000000', 'consum', 0.0266, 'lps'),
	(667661, 132, '2015-02-01 00:15:34.000000', 'consum', 0.0278, 'lps'),
	(667662, 132, '2015-02-01 00:15:35.000000', 'consum', 0.0267, 'lps'),
	(667663, 132, '2015-02-01 00:15:36.000000', 'consum', 0.0293, 'lps'),
	(667664, 132, '2015-02-01 00:15:37.000000', 'consum', 0.0221, 'lps'),
	(667665, 132, '2015-02-01 00:15:38.000000', 'consum', 0.0249, 'lps'),
	(667666, 132, '2015-02-01 00:15:39.000000', 'consum', 0.0255, 'lps'),
	(667667, 132, '2015-02-01 00:15:40.000000', 'consum', 0.0319, 'lps'),
	(667668, 132, '2015-02-01 00:15:41.000000', 'consum', 0.0271, 'lps'),
	(667669, 132, '2015-02-01 00:15:42.000000', 'consum', 0.0305, 'lps'),
	(667670, 132, '2015-02-01 00:15:43.000000', 'consum', 0.0272, 'lps'),
	(667671, 132, '2015-02-01 00:15:44.000000', 'consum', 0.0235, 'lps'),
	(667672, 132, '2015-02-01 00:15:45.000000', 'consum', 0.0264, 'lps'),
	(667673, 132, '2015-02-01 00:15:46.000000', 'consum', 0.0290, 'lps'),
	(667674, 132, '2015-02-01 00:15:47.000000', 'consum', 0.0216, 'lps'),
	(667675, 132, '2015-02-01 00:15:48.000000', 'consum', 0.0234, 'lps'),
	(667676, 132, '2015-02-01 00:15:49.000000', 'consum', 0.0313, 'lps'),
	(667677, 132, '2015-02-01 00:15:50.000000', 'consum', 0.0304, 'lps'),
	(667678, 132, '2015-02-01 00:15:51.000000', 'consum', 0.0255, 'lps'),
	(667679, 132, '2015-02-01 00:15:52.000000', 'consum', 0.0272, 'lps'),
	(667680, 132, '2015-02-01 00:15:53.000000', 'consum', 0.0267, 'lps'),
	(667681, 132, '2015-02-01 00:15:54.000000', 'consum', 0.0309, 'lps'),
	(667682, 132, '2015-02-01 00:15:55.000000', 'consum', 0.0303, 'lps'),
	(667683, 132, '2015-02-01 00:15:56.000000', 'consum', 0.0261, 'lps'),
	(667684, 132, '2015-02-01 00:15:57.000000', 'consum', 0.0305, 'lps'),
	(667685, 132, '2015-02-01 00:15:58.000000', 'consum', 0.0299, 'lps'),
	(667686, 132, '2015-02-01 00:15:59.000000', 'consum', 0.0255, 'lps'),
	(667687, 132, '2015-02-01 00:16:00.000000', 'consum', 0.0286, 'lps'),
	(667688, 132, '2015-02-01 00:16:01.000000', 'consum', 0.0222, 'lps'),
	(667689, 132, '2015-02-01 00:16:02.000000', 'consum', 0.0273, 'lps'),
	(667690, 132, '2015-02-01 00:16:03.000000', 'consum', 0.0261, 'lps'),
	(667691, 132, '2015-02-01 00:16:04.000000', 'consum', 0.0274, 'lps'),
	(667692, 132, '2015-02-01 00:16:05.000000', 'consum', 0.0261, 'lps'),
	(667693, 132, '2015-02-01 00:16:06.000000', 'consum', 0.0276, 'lps'),
	(667694, 132, '2015-02-01 00:16:07.000000', 'consum', 0.0272, 'lps'),
	(667695, 132, '2015-02-01 00:16:08.000000', 'consum', 0.0322, 'lps'),
	(667696, 132, '2015-02-01 00:16:09.000000', 'consum', 0.0237, 'lps'),
	(667697, 132, '2015-02-01 00:16:10.000000', 'consum', 0.0240, 'lps'),
	(667698, 132, '2015-02-01 00:16:11.000000', 'consum', 0.0282, 'lps'),
	(667699, 132, '2015-02-01 00:16:12.000000', 'consum', 0.0245, 'lps'),
	(667700, 132, '2015-02-01 00:16:13.000000', 'consum', 0.0287, 'lps'),
	(667701, 132, '2015-02-01 00:16:14.000000', 'consum', 0.0259, 'lps'),
	(667702, 132, '2015-02-01 00:16:15.000000', 'consum', 0.0224, 'lps'),
	(667703, 132, '2015-02-01 00:16:16.000000', 'consum', 0.0251, 'lps'),
	(667704, 132, '2015-02-01 00:16:17.000000', 'consum', 0.0258, 'lps'),
	(667705, 132, '2015-02-01 00:16:18.000000', 'consum', 0.0211, 'lps'),
	(667706, 132, '2015-02-01 00:16:19.000000', 'consum', 0.0301, 'lps'),
	(667707, 132, '2015-02-01 00:16:20.000000', 'consum', 0.0316, 'lps'),
	(667708, 132, '2015-02-01 00:16:21.000000', 'consum', 0.0236, 'lps'),
	(667709, 132, '2015-02-01 00:16:22.000000', 'consum', 0.0254, 'lps'),
	(667710, 132, '2015-02-01 00:16:23.000000', 'consum', 0.0237, 'lps'),
	(667711, 132, '2015-02-01 00:16:24.000000', 'consum', 0.0212, 'lps'),
	(667712, 132, '2015-02-01 00:16:25.000000', 'consum', 0.0256, 'lps'),
	(667713, 132, '2015-02-01 00:16:26.000000', 'consum', 0.0317, 'lps'),
	(667714, 132, '2015-02-01 00:16:27.000000', 'consum', 0.0261, 'lps'),
	(667715, 132, '2015-02-01 00:16:28.000000', 'consum', 0.0259, 'lps'),
	(667716, 132, '2015-02-01 00:16:29.000000', 'consum', 0.0302, 'lps'),
	(667717, 132, '2015-02-01 00:16:30.000000', 'consum', 0.0291, 'lps'),
	(667718, 132, '2015-02-01 00:16:31.000000', 'consum', 0.0224, 'lps'),
	(667719, 132, '2015-02-01 00:16:32.000000', 'consum', 0.0270, 'lps'),
	(667720, 132, '2015-02-01 00:16:33.000000', 'consum', 0.0235, 'lps'),
	(667721, 132, '2015-02-01 00:16:34.000000', 'consum', 0.0273, 'lps'),
	(667722, 132, '2015-02-01 00:16:35.000000', 'consum', 0.0218, 'lps'),
	(667723, 132, '2015-02-01 00:16:36.000000', 'consum', 0.0294, 'lps'),
	(667724, 132, '2015-02-01 00:16:37.000000', 'consum', 0.0260, 'lps'),
	(667725, 132, '2015-02-01 00:16:38.000000', 'consum', 0.0324, 'lps'),
	(667726, 132, '2015-02-01 00:16:39.000000', 'consum', 0.0282, 'lps'),
	(667727, 132, '2015-02-01 00:16:40.000000', 'consum', 0.0227, 'lps'),
	(667728, 132, '2015-02-01 00:16:41.000000', 'consum', 0.0313, 'lps'),
	(667729, 132, '2015-02-01 00:16:42.000000', 'consum', 0.0210, 'lps'),
	(667730, 132, '2015-02-01 00:16:43.000000', 'consum', 0.0252, 'lps'),
	(667731, 132, '2015-02-01 00:16:44.000000', 'consum', 0.0302, 'lps'),
	(667732, 132, '2015-02-01 00:16:45.000000', 'consum', 0.0311, 'lps'),
	(667733, 132, '2015-02-01 00:16:46.000000', 'consum', 0.0210, 'lps'),
	(667734, 132, '2015-02-01 00:16:47.000000', 'consum', 0.0256, 'lps'),
	(667735, 132, '2015-02-01 00:16:48.000000', 'consum', 0.0324, 'lps'),
	(667736, 132, '2015-02-01 00:16:49.000000', 'consum', 0.0296, 'lps'),
	(667737, 132, '2015-02-01 00:16:50.000000', 'consum', 0.0295, 'lps'),
	(667738, 132, '2015-02-01 00:16:51.000000', 'consum', 0.0265, 'lps'),
	(667739, 132, '2015-02-01 00:16:52.000000', 'consum', 0.0228, 'lps'),
	(667740, 132, '2015-02-01 00:16:53.000000', 'consum', 0.0254, 'lps'),
	(667741, 132, '2015-02-01 00:16:54.000000', 'consum', 0.0257, 'lps'),
	(667742, 132, '2015-02-01 00:16:55.000000', 'consum', 0.0317, 'lps'),
	(667743, 132, '2015-02-01 00:16:56.000000', 'consum', 0.0254, 'lps'),
	(667744, 132, '2015-02-01 00:16:57.000000', 'consum', 0.0228, 'lps'),
	(667745, 132, '2015-02-01 00:16:58.000000', 'consum', 0.0282, 'lps'),
	(667746, 132, '2015-02-01 00:16:59.000000', 'consum', 0.0286, 'lps'),
	(667747, 132, '2015-02-01 00:17:00.000000', 'consum', 0.0260, 'lps'),
	(667748, 132, '2015-02-01 00:17:01.000000', 'consum', 0.0230, 'lps'),
	(667749, 132, '2015-02-01 00:17:02.000000', 'consum', 0.0279, 'lps'),
	(667750, 132, '2015-02-01 00:17:03.000000', 'consum', 0.0261, 'lps'),
	(667751, 132, '2015-02-01 00:17:04.000000', 'consum', 0.0259, 'lps'),
	(667752, 132, '2015-02-01 00:17:05.000000', 'consum', 0.0302, 'lps'),
	(667753, 132, '2015-02-01 00:17:06.000000', 'consum', 0.0292, 'lps'),
	(667754, 132, '2015-02-01 00:17:07.000000', 'consum', 0.0231, 'lps'),
	(667755, 132, '2015-02-01 00:17:08.000000', 'consum', 0.0298, 'lps'),
	(667756, 132, '2015-02-01 00:17:09.000000', 'consum', 0.0239, 'lps'),
	(667757, 132, '2015-02-01 00:17:10.000000', 'consum', 0.0210, 'lps'),
	(667758, 132, '2015-02-01 00:17:11.000000', 'consum', 0.0237, 'lps'),
	(667759, 132, '2015-02-01 00:17:12.000000', 'consum', 0.0232, 'lps'),
	(667760, 132, '2015-02-01 00:17:13.000000', 'consum', 0.0237, 'lps'),
	(667761, 132, '2015-02-01 00:17:14.000000', 'consum', 0.0281, 'lps'),
	(667762, 132, '2015-02-01 00:17:15.000000', 'consum', 0.0254, 'lps'),
	(667763, 132, '2015-02-01 00:17:16.000000', 'consum', 0.0216, 'lps'),
	(667764, 132, '2015-02-01 00:17:17.000000', 'consum', 0.0223, 'lps'),
	(667765, 132, '2015-02-01 00:17:18.000000', 'consum', 0.0260, 'lps'),
	(667766, 132, '2015-02-01 00:17:19.000000', 'consum', 0.0306, 'lps'),
	(667767, 132, '2015-02-01 00:17:20.000000', 'consum', 0.0309, 'lps'),
	(667768, 132, '2015-02-01 00:17:21.000000', 'consum', 0.0302, 'lps'),
	(667769, 132, '2015-02-01 00:17:22.000000', 'consum', 0.0257, 'lps'),
	(667770, 132, '2015-02-01 00:17:23.000000', 'consum', 0.0284, 'lps'),
	(667771, 132, '2015-02-01 00:17:24.000000', 'consum', 0.0325, 'lps'),
	(667772, 132, '2015-02-01 00:17:25.000000', 'consum', 0.0217, 'lps'),
	(667773, 132, '2015-02-01 00:17:26.000000', 'consum', 0.0247, 'lps'),
	(667774, 132, '2015-02-01 00:17:27.000000', 'consum', 0.0258, 'lps'),
	(667775, 132, '2015-02-01 00:17:28.000000', 'consum', 0.0224, 'lps'),
	(667776, 132, '2015-02-01 00:17:29.000000', 'consum', 0.0253, 'lps'),
	(667777, 132, '2015-02-01 00:17:30.000000', 'consum', 0.0266, 'lps'),
	(667778, 132, '2015-02-01 00:17:31.000000', 'consum', 0.0247, 'lps'),
	(667779, 132, '2015-02-01 00:17:32.000000', 'consum', 0.0228, 'lps'),
	(667780, 132, '2015-02-01 00:17:33.000000', 'consum', 0.0303, 'lps'),
	(667781, 132, '2015-02-01 00:17:34.000000', 'consum', 0.0274, 'lps'),
	(667782, 132, '2015-02-01 00:17:35.000000', 'consum', 0.0254, 'lps'),
	(667783, 132, '2015-02-01 00:17:36.000000', 'consum', 0.0236, 'lps'),
	(667784, 132, '2015-02-01 00:17:37.000000', 'consum', 0.0210, 'lps'),
	(667785, 132, '2015-02-01 00:17:38.000000', 'consum', 0.0248, 'lps'),
	(667786, 132, '2015-02-01 00:17:39.000000', 'consum', 0.0283, 'lps'),
	(667787, 132, '2015-02-01 00:17:40.000000', 'consum', 0.0231, 'lps'),
	(667788, 132, '2015-02-01 00:17:41.000000', 'consum', 0.0210, 'lps'),
	(667789, 132, '2015-02-01 00:17:42.000000', 'consum', 0.0265, 'lps'),
	(667790, 132, '2015-02-01 00:17:43.000000', 'consum', 0.0256, 'lps'),
	(667791, 132, '2015-02-01 00:17:44.000000', 'consum', 0.0272, 'lps'),
	(667792, 132, '2015-02-01 00:17:45.000000', 'consum', 0.0269, 'lps'),
	(667793, 132, '2015-02-01 00:17:46.000000', 'consum', 0.0318, 'lps'),
	(667794, 132, '2015-02-01 00:17:47.000000', 'consum', 0.0225, 'lps'),
	(667795, 132, '2015-02-01 00:17:48.000000', 'consum', 0.0311, 'lps'),
	(667796, 132, '2015-02-01 00:17:49.000000', 'consum', 0.0323, 'lps'),
	(667797, 132, '2015-02-01 00:17:50.000000', 'consum', 0.0240, 'lps'),
	(667798, 132, '2015-02-01 00:17:51.000000', 'consum', 0.0253, 'lps'),
	(667799, 132, '2015-02-01 00:17:52.000000', 'consum', 0.0220, 'lps'),
	(667800, 132, '2015-02-01 00:17:53.000000', 'consum', 0.0247, 'lps'),
	(667801, 132, '2015-02-01 00:17:54.000000', 'consum', 0.0250, 'lps'),
	(667802, 132, '2015-02-01 00:17:55.000000', 'consum', 0.0297, 'lps'),
	(667803, 132, '2015-02-01 00:17:56.000000', 'consum', 0.0297, 'lps'),
	(667804, 132, '2015-02-01 00:17:57.000000', 'consum', 0.0268, 'lps'),
	(667805, 132, '2015-02-01 00:17:58.000000', 'consum', 0.0237, 'lps'),
	(667806, 132, '2015-02-01 00:17:59.000000', 'consum', 0.0289, 'lps'),
	(667807, 132, '2015-02-01 00:18:00.000000', 'consum', 0.0293, 'lps'),
	(667808, 132, '2015-02-01 00:18:01.000000', 'consum', 0.0270, 'lps'),
	(667809, 132, '2015-02-01 00:18:02.000000', 'consum', 0.0265, 'lps'),
	(667810, 132, '2015-02-01 00:18:03.000000', 'consum', 0.0304, 'lps'),
	(667811, 132, '2015-02-01 00:18:04.000000', 'consum', 0.0282, 'lps'),
	(667812, 132, '2015-02-01 00:18:05.000000', 'consum', 0.0290, 'lps'),
	(667813, 132, '2015-02-01 00:18:06.000000', 'consum', 0.0277, 'lps'),
	(667814, 132, '2015-02-01 00:18:07.000000', 'consum', 0.0305, 'lps'),
	(667815, 132, '2015-02-01 00:18:08.000000', 'consum', 0.0253, 'lps'),
	(667816, 132, '2015-02-01 00:18:09.000000', 'consum', 0.0258, 'lps'),
	(667817, 132, '2015-02-01 00:18:10.000000', 'consum', 0.0321, 'lps'),
	(667818, 132, '2015-02-01 00:18:11.000000', 'consum', 0.0272, 'lps'),
	(667819, 132, '2015-02-01 00:18:12.000000', 'consum', 0.0303, 'lps'),
	(667820, 132, '2015-02-01 00:18:13.000000', 'consum', 0.0257, 'lps'),
	(667821, 132, '2015-02-01 00:18:14.000000', 'consum', 0.0284, 'lps'),
	(667822, 132, '2015-02-01 00:18:15.000000', 'consum', 0.0321, 'lps'),
	(667823, 132, '2015-02-01 00:18:16.000000', 'consum', 0.0314, 'lps'),
	(667824, 132, '2015-02-01 00:18:17.000000', 'consum', 0.0282, 'lps'),
	(667825, 132, '2015-02-01 00:18:18.000000', 'consum', 0.0256, 'lps'),
	(667826, 132, '2015-02-01 00:18:19.000000', 'consum', 0.0227, 'lps'),
	(667827, 132, '2015-02-01 00:18:20.000000', 'consum', 0.0271, 'lps'),
	(667828, 132, '2015-02-01 00:18:21.000000', 'consum', 0.0232, 'lps'),
	(667829, 132, '2015-02-01 00:18:22.000000', 'consum', 0.0254, 'lps'),
	(667830, 132, '2015-02-01 00:18:23.000000', 'consum', 0.0248, 'lps'),
	(667831, 132, '2015-02-01 00:18:24.000000', 'consum', 0.0267, 'lps'),
	(667832, 132, '2015-02-01 00:18:25.000000', 'consum', 0.0268, 'lps'),
	(667833, 132, '2015-02-01 00:18:26.000000', 'consum', 0.0213, 'lps'),
	(667834, 132, '2015-02-01 00:18:27.000000', 'consum', 0.0285, 'lps'),
	(667835, 132, '2015-02-01 00:18:28.000000', 'consum', 0.0228, 'lps'),
	(667836, 132, '2015-02-01 00:18:29.000000', 'consum', 0.0307, 'lps'),
	(667837, 132, '2015-02-01 00:18:30.000000', 'consum', 0.0291, 'lps'),
	(667838, 132, '2015-02-01 00:18:31.000000', 'consum', 0.0212, 'lps'),
	(667839, 132, '2015-02-01 00:18:32.000000', 'consum', 0.0324, 'lps'),
	(667840, 132, '2015-02-01 00:18:33.000000', 'consum', 0.0313, 'lps'),
	(667841, 132, '2015-02-01 00:18:34.000000', 'consum', 0.0265, 'lps'),
	(667842, 132, '2015-02-01 00:18:35.000000', 'consum', 0.0293, 'lps'),
	(667843, 132, '2015-02-01 00:18:36.000000', 'consum', 0.0229, 'lps'),
	(667844, 132, '2015-02-01 00:18:37.000000', 'consum', 0.0287, 'lps'),
	(667845, 132, '2015-02-01 00:18:38.000000', 'consum', 0.0307, 'lps'),
	(667846, 132, '2015-02-01 00:18:39.000000', 'consum', 0.0233, 'lps'),
	(667847, 132, '2015-02-01 00:18:40.000000', 'consum', 0.0268, 'lps'),
	(667848, 132, '2015-02-01 00:18:41.000000', 'consum', 0.0313, 'lps'),
	(667849, 132, '2015-02-01 00:18:42.000000', 'consum', 0.0321, 'lps'),
	(667850, 132, '2015-02-01 00:18:43.000000', 'consum', 0.0225, 'lps'),
	(667851, 132, '2015-02-01 00:18:44.000000', 'consum', 0.0299, 'lps'),
	(667852, 132, '2015-02-01 00:18:45.000000', 'consum', 0.0261, 'lps'),
	(667853, 132, '2015-02-01 00:18:46.000000', 'consum', 0.0317, 'lps'),
	(667854, 132, '2015-02-01 00:18:47.000000', 'consum', 0.0242, 'lps'),
	(667855, 132, '2015-02-01 00:18:48.000000', 'consum', 0.0282, 'lps'),
	(667856, 132, '2015-02-01 00:18:49.000000', 'consum', 0.0243, 'lps'),
	(667857, 132, '2015-02-01 00:18:50.000000', 'consum', 0.0275, 'lps'),
	(667858, 132, '2015-02-01 00:18:51.000000', 'consum', 0.0322, 'lps'),
	(667859, 132, '2015-02-01 00:18:52.000000', 'consum', 0.0227, 'lps'),
	(667860, 132, '2015-02-01 00:18:53.000000', 'consum', 0.0307, 'lps'),
	(667861, 132, '2015-02-01 00:18:54.000000', 'consum', 0.0296, 'lps'),
	(667862, 132, '2015-02-01 00:18:55.000000', 'consum', 0.0233, 'lps'),
	(667863, 132, '2015-02-01 00:18:56.000000', 'consum', 0.0301, 'lps'),
	(667864, 132, '2015-02-01 00:18:57.000000', 'consum', 0.0248, 'lps'),
	(667865, 132, '2015-02-01 00:18:58.000000', 'consum', 0.0244, 'lps'),
	(667866, 132, '2015-02-01 00:18:59.000000', 'consum', 0.0267, 'lps'),
	(667867, 132, '2015-02-01 00:19:00.000000', 'consum', 0.0277, 'lps'),
	(667868, 132, '2015-02-01 00:19:01.000000', 'consum', 0.0259, 'lps'),
	(667869, 132, '2015-02-01 00:19:02.000000', 'consum', 0.0256, 'lps'),
	(667870, 132, '2015-02-01 00:19:03.000000', 'consum', 0.0293, 'lps'),
	(667871, 132, '2015-02-01 00:19:04.000000', 'consum', 0.0256, 'lps'),
	(667872, 132, '2015-02-01 00:19:05.000000', 'consum', 0.0306, 'lps'),
	(667873, 132, '2015-02-01 00:19:06.000000', 'consum', 0.0319, 'lps'),
	(667874, 132, '2015-02-01 00:19:07.000000', 'consum', 0.0238, 'lps'),
	(667875, 132, '2015-02-01 00:19:08.000000', 'consum', 0.0256, 'lps'),
	(667876, 132, '2015-02-01 00:19:09.000000', 'consum', 0.0242, 'lps'),
	(667877, 132, '2015-02-01 00:19:10.000000', 'consum', 0.0229, 'lps'),
	(667878, 132, '2015-02-01 00:19:11.000000', 'consum', 0.0210, 'lps'),
	(667879, 132, '2015-02-01 00:19:12.000000', 'consum', 0.0270, 'lps'),
	(667880, 132, '2015-02-01 00:19:13.000000', 'consum', 0.0277, 'lps'),
	(667881, 132, '2015-02-01 00:19:14.000000', 'consum', 0.0252, 'lps'),
	(667882, 132, '2015-02-01 00:19:15.000000', 'consum', 0.0219, 'lps'),
	(667883, 132, '2015-02-01 00:19:16.000000', 'consum', 0.0247, 'lps'),
	(667884, 132, '2015-02-01 00:19:17.000000', 'consum', 0.0250, 'lps'),
	(667885, 132, '2015-02-01 00:19:18.000000', 'consum', 0.0301, 'lps'),
	(667886, 132, '2015-02-01 00:19:19.000000', 'consum', 0.0311, 'lps'),
	(667887, 132, '2015-02-01 00:19:20.000000', 'consum', 0.0212, 'lps'),
	(667888, 132, '2015-02-01 00:19:21.000000', 'consum', 0.0267, 'lps'),
	(667889, 132, '2015-02-01 00:19:22.000000', 'consum', 0.0254, 'lps'),
	(667890, 132, '2015-02-01 00:19:23.000000', 'consum', 0.0263, 'lps'),
	(667891, 132, '2015-02-01 00:19:24.000000', 'consum', 0.0227, 'lps'),
	(667892, 132, '2015-02-01 00:19:25.000000', 'consum', 0.0253, 'lps'),
	(667893, 132, '2015-02-01 00:19:26.000000', 'consum', 0.0258, 'lps'),
	(667894, 132, '2015-02-01 00:19:27.000000', 'consum', 0.0322, 'lps'),
	(667895, 132, '2015-02-01 00:19:28.000000', 'consum', 0.0279, 'lps'),
	(667896, 132, '2015-02-01 00:19:29.000000', 'consum', 0.0220, 'lps'),
	(667897, 132, '2015-02-01 00:19:30.000000', 'consum', 0.0283, 'lps'),
	(667898, 132, '2015-02-01 00:19:31.000000', 'consum', 0.0316, 'lps'),
	(667899, 132, '2015-02-01 00:19:32.000000', 'consum', 0.0290, 'lps'),
	(667900, 132, '2015-02-01 00:19:33.000000', 'consum', 0.0291, 'lps'),
	(667901, 132, '2015-02-01 00:19:34.000000', 'consum', 0.0259, 'lps'),
	(667902, 132, '2015-02-01 00:19:35.000000', 'consum', 0.0214, 'lps'),
	(667903, 132, '2015-02-01 00:19:36.000000', 'consum', 0.0316, 'lps'),
	(667904, 132, '2015-02-01 00:19:37.000000', 'consum', 0.0263, 'lps'),
	(667905, 132, '2015-02-01 00:19:38.000000', 'consum', 0.0275, 'lps'),
	(667906, 132, '2015-02-01 00:19:39.000000', 'consum', 0.0260, 'lps'),
	(667907, 132, '2015-02-01 00:19:40.000000', 'consum', 0.0266, 'lps'),
	(667908, 132, '2015-02-01 00:19:41.000000', 'consum', 0.0226, 'lps'),
	(667909, 132, '2015-02-01 00:19:42.000000', 'consum', 0.0237, 'lps'),
	(667910, 132, '2015-02-01 00:19:43.000000', 'consum', 0.0300, 'lps'),
	(667911, 132, '2015-02-01 00:19:44.000000', 'consum', 0.0229, 'lps'),
	(667912, 132, '2015-02-01 00:19:45.000000', 'consum', 0.0266, 'lps'),
	(667913, 132, '2015-02-01 00:19:46.000000', 'consum', 0.0321, 'lps'),
	(667914, 132, '2015-02-01 00:19:47.000000', 'consum', 0.0246, 'lps'),
	(667915, 132, '2015-02-01 00:19:48.000000', 'consum', 0.0291, 'lps'),
	(667916, 132, '2015-02-01 00:19:49.000000', 'consum', 0.0275, 'lps'),
	(667917, 132, '2015-02-01 00:19:50.000000', 'consum', 0.0291, 'lps'),
	(667918, 132, '2015-02-01 00:19:51.000000', 'consum', 0.0307, 'lps'),
	(667919, 132, '2015-02-01 00:19:52.000000', 'consum', 0.0220, 'lps'),
	(667920, 132, '2015-02-01 00:19:53.000000', 'consum', 0.0319, 'lps'),
	(667921, 132, '2015-02-01 00:19:54.000000', 'consum', 0.0261, 'lps'),
	(667922, 132, '2015-02-01 00:19:55.000000', 'consum', 0.0254, 'lps'),
	(667923, 132, '2015-02-01 00:19:56.000000', 'consum', 0.0278, 'lps'),
	(667924, 132, '2015-02-01 00:19:57.000000', 'consum', 0.0302, 'lps'),
	(667925, 132, '2015-02-01 00:19:58.000000', 'consum', 0.0236, 'lps'),
	(667926, 132, '2015-02-01 00:19:59.000000', 'consum', 0.0296, 'lps'),
	(667927, 132, '2015-02-01 00:20:00.000000', 'consum', 0.0216, 'lps'),
	(667928, 132, '2015-02-01 00:20:01.000000', 'consum', 0.0211, 'lps'),
	(667929, 132, '2015-02-01 00:20:02.000000', 'consum', 0.0317, 'lps'),
	(667930, 132, '2015-02-01 00:20:03.000000', 'consum', 0.0275, 'lps'),
	(667931, 132, '2015-02-01 00:20:04.000000', 'consum', 0.0217, 'lps'),
	(667932, 132, '2015-02-01 00:20:05.000000', 'consum', 0.0282, 'lps'),
	(667933, 132, '2015-02-01 00:20:06.000000', 'consum', 0.0315, 'lps'),
	(667934, 132, '2015-02-01 00:20:07.000000', 'consum', 0.0291, 'lps'),
	(667935, 132, '2015-02-01 00:20:08.000000', 'consum', 0.0298, 'lps'),
	(667936, 132, '2015-02-01 00:20:09.000000', 'consum', 0.0291, 'lps'),
	(667937, 132, '2015-02-01 00:20:10.000000', 'consum', 0.0237, 'lps'),
	(667938, 132, '2015-02-01 00:20:11.000000', 'consum', 0.0218, 'lps'),
	(667939, 132, '2015-02-01 00:20:12.000000', 'consum', 0.0286, 'lps'),
	(667940, 132, '2015-02-01 00:20:13.000000', 'consum', 0.0220, 'lps'),
	(667941, 132, '2015-02-01 00:20:14.000000', 'consum', 0.0264, 'lps'),
	(667942, 132, '2015-02-01 00:20:15.000000', 'consum', 0.0220, 'lps'),
	(667943, 132, '2015-02-01 00:20:16.000000', 'consum', 0.0213, 'lps'),
	(667944, 132, '2015-02-01 00:20:17.000000', 'consum', 0.0310, 'lps'),
	(667945, 132, '2015-02-01 00:20:18.000000', 'consum', 0.0239, 'lps'),
	(667946, 132, '2015-02-01 00:20:19.000000', 'consum', 0.0288, 'lps'),
	(667947, 132, '2015-02-01 00:20:20.000000', 'consum', 0.0281, 'lps'),
	(667948, 132, '2015-02-01 00:20:21.000000', 'consum', 0.0215, 'lps'),
	(667949, 132, '2015-02-01 00:20:22.000000', 'consum', 0.0257, 'lps'),
	(667950, 132, '2015-02-01 00:20:23.000000', 'consum', 0.0312, 'lps'),
	(667951, 132, '2015-02-01 00:20:24.000000', 'consum', 0.0233, 'lps'),
	(667952, 132, '2015-02-01 00:20:25.000000', 'consum', 0.0249, 'lps'),
	(667953, 132, '2015-02-01 00:20:26.000000', 'consum', 0.0222, 'lps'),
	(667954, 132, '2015-02-01 00:20:27.000000', 'consum', 0.0271, 'lps'),
	(667955, 132, '2015-02-01 00:20:28.000000', 'consum', 0.0246, 'lps'),
	(667956, 132, '2015-02-01 00:20:29.000000', 'consum', 0.0322, 'lps'),
	(667957, 132, '2015-02-01 00:20:30.000000', 'consum', 0.0314, 'lps'),
	(667958, 132, '2015-02-01 00:20:31.000000', 'consum', 0.0282, 'lps'),
	(667959, 132, '2015-02-01 00:20:32.000000', 'consum', 0.0255, 'lps'),
	(667960, 132, '2015-02-01 00:20:33.000000', 'consum', 0.0220, 'lps'),
	(667961, 132, '2015-02-01 00:20:34.000000', 'consum', 0.0242, 'lps'),
	(667962, 132, '2015-02-01 00:20:35.000000', 'consum', 0.0223, 'lps'),
	(667963, 132, '2015-02-01 00:20:36.000000', 'consum', 0.0299, 'lps'),
	(667964, 132, '2015-02-01 00:20:37.000000', 'consum', 0.0265, 'lps'),
	(667965, 132, '2015-02-01 00:20:38.000000', 'consum', 0.0219, 'lps'),
	(667966, 132, '2015-02-01 00:20:39.000000', 'consum', 0.0322, 'lps'),
	(667967, 132, '2015-02-01 00:20:40.000000', 'consum', 0.0279, 'lps'),
	(667968, 132, '2015-02-01 00:20:41.000000', 'consum', 0.0219, 'lps'),
	(667969, 132, '2015-02-01 00:20:42.000000', 'consum', 0.0281, 'lps'),
	(667970, 132, '2015-02-01 00:20:43.000000', 'consum', 0.0306, 'lps'),
	(667971, 132, '2015-02-01 00:20:44.000000', 'consum', 0.0248, 'lps'),
	(667972, 132, '2015-02-01 00:20:45.000000', 'consum', 0.0228, 'lps'),
	(667973, 132, '2015-02-01 00:20:46.000000', 'consum', 0.0301, 'lps'),
	(667974, 132, '2015-02-01 00:20:47.000000', 'consum', 0.0265, 'lps'),
	(667975, 132, '2015-02-01 00:20:48.000000', 'consum', 0.0211, 'lps'),
	(667976, 132, '2015-02-01 00:20:49.000000', 'consum', 0.0281, 'lps'),
	(667977, 132, '2015-02-01 00:20:50.000000', 'consum', 0.0216, 'lps'),
	(667978, 132, '2015-02-01 00:20:51.000000', 'consum', 0.0261, 'lps'),
	(667979, 132, '2015-02-01 00:20:52.000000', 'consum', 0.0216, 'lps'),
	(667980, 132, '2015-02-01 00:20:53.000000', 'consum', 0.0317, 'lps'),
	(667981, 132, '2015-02-01 00:20:54.000000', 'consum', 0.0263, 'lps'),
	(667982, 132, '2015-02-01 00:20:55.000000', 'consum', 0.0273, 'lps'),
	(667983, 132, '2015-02-01 00:20:56.000000', 'consum', 0.0248, 'lps'),
	(667984, 132, '2015-02-01 00:20:57.000000', 'consum', 0.0211, 'lps'),
	(667985, 132, '2015-02-01 00:20:58.000000', 'consum', 0.0218, 'lps'),
	(667986, 132, '2015-02-01 00:20:59.000000', 'consum', 0.0249, 'lps'),
	(667987, 132, '2015-02-01 00:21:00.000000', 'consum', 0.0266, 'lps'),
	(667988, 132, '2015-02-01 00:21:01.000000', 'consum', 0.0257, 'lps'),
	(667989, 132, '2015-02-01 00:21:02.000000', 'consum', 0.0276, 'lps'),
	(667990, 132, '2015-02-01 00:21:03.000000', 'consum', 0.0283, 'lps'),
	(667991, 132, '2015-02-01 00:21:04.000000', 'consum', 0.0264, 'lps'),
	(667992, 132, '2015-02-01 00:21:05.000000', 'consum', 0.0262, 'lps'),
	(667993, 132, '2015-02-01 00:21:06.000000', 'consum', 0.0309, 'lps'),
	(667994, 132, '2015-02-01 00:21:07.000000', 'consum', 0.0316, 'lps'),
	(667995, 132, '2015-02-01 00:21:08.000000', 'consum', 0.0212, 'lps'),
	(667996, 132, '2015-02-01 00:21:09.000000', 'consum', 0.0249, 'lps'),
	(667997, 132, '2015-02-01 00:21:10.000000', 'consum', 0.0283, 'lps'),
	(667998, 132, '2015-02-01 00:21:11.000000', 'consum', 0.0228, 'lps'),
	(667999, 132, '2015-02-01 00:21:12.000000', 'consum', 0.0312, 'lps'),
	(668000, 132, '2015-02-01 00:21:13.000000', 'consum', 0.0319, 'lps'),
	(668001, 132, '2015-02-01 00:21:14.000000', 'consum', 0.0216, 'lps'),
	(668002, 132, '2015-02-01 00:21:15.000000', 'consum', 0.0264, 'lps'),
	(668003, 132, '2015-02-01 00:21:16.000000', 'consum', 0.0228, 'lps'),
	(668004, 132, '2015-02-01 00:21:17.000000', 'consum', 0.0256, 'lps'),
	(668005, 132, '2015-02-01 00:21:18.000000', 'consum', 0.0268, 'lps'),
	(668006, 132, '2015-02-01 00:21:19.000000', 'consum', 0.0249, 'lps'),
	(668007, 132, '2015-02-01 00:21:20.000000', 'consum', 0.0233, 'lps'),
	(668008, 132, '2015-02-01 00:21:21.000000', 'consum', 0.0323, 'lps'),
	(668009, 132, '2015-02-01 00:21:22.000000', 'consum', 0.0241, 'lps'),
	(668010, 132, '2015-02-01 00:21:23.000000', 'consum', 0.0258, 'lps'),
	(668011, 132, '2015-02-01 00:21:24.000000', 'consum', 0.0242, 'lps'),
	(668012, 132, '2015-02-01 00:21:25.000000', 'consum', 0.0228, 'lps'),
	(668013, 132, '2015-02-01 00:21:26.000000', 'consum', 0.0319, 'lps'),
	(668014, 132, '2015-02-01 00:21:27.000000', 'consum', 0.0240, 'lps'),
	(668015, 132, '2015-02-01 00:21:28.000000', 'consum', 0.0263, 'lps'),
	(668016, 132, '2015-02-01 00:21:29.000000', 'consum', 0.0272, 'lps'),
	(668017, 132, '2015-02-01 00:21:30.000000', 'consum', 0.0244, 'lps'),
	(668018, 132, '2015-02-01 00:21:31.000000', 'consum', 0.0309, 'lps'),
	(668019, 132, '2015-02-01 00:21:32.000000', 'consum', 0.0258, 'lps'),
	(668020, 132, '2015-02-01 00:21:33.000000', 'consum', 0.0267, 'lps'),
	(668021, 132, '2015-02-01 00:21:34.000000', 'consum', 0.0236, 'lps'),
	(668022, 132, '2015-02-01 00:21:35.000000', 'consum', 0.0284, 'lps'),
	(668023, 132, '2015-02-01 00:21:36.000000', 'consum', 0.0272, 'lps'),
	(668024, 132, '2015-02-01 00:21:37.000000', 'consum', 0.0301, 'lps'),
	(668025, 132, '2015-02-01 00:21:38.000000', 'consum', 0.0244, 'lps'),
	(668026, 132, '2015-02-01 00:21:39.000000', 'consum', 0.0223, 'lps'),
	(668027, 132, '2015-02-01 00:21:40.000000', 'consum', 0.0291, 'lps'),
	(668028, 132, '2015-02-01 00:21:41.000000', 'consum', 0.0228, 'lps'),
	(668029, 132, '2015-02-01 00:21:42.000000', 'consum', 0.0290, 'lps'),
	(668030, 132, '2015-02-01 00:21:43.000000', 'consum', 0.0325, 'lps'),
	(668031, 132, '2015-02-01 00:21:44.000000', 'consum', 0.0313, 'lps'),
	(668032, 132, '2015-02-01 00:21:45.000000', 'consum', 0.0264, 'lps'),
	(668033, 132, '2015-02-01 00:21:46.000000', 'consum', 0.0287, 'lps'),
	(668034, 132, '2015-02-01 00:21:47.000000', 'consum', 0.0320, 'lps'),
	(668035, 132, '2015-02-01 00:21:48.000000', 'consum', 0.0295, 'lps'),
	(668036, 132, '2015-02-01 00:21:49.000000', 'consum', 0.0305, 'lps'),
	(668037, 132, '2015-02-01 00:21:50.000000', 'consum', 0.0317, 'lps'),
	(668038, 132, '2015-02-01 00:21:51.000000', 'consum', 0.0230, 'lps'),
	(668039, 132, '2015-02-01 00:21:52.000000', 'consum', 0.0218, 'lps'),
	(668040, 132, '2015-02-01 00:21:53.000000', 'consum', 0.0306, 'lps'),
	(668041, 132, '2015-02-01 00:21:54.000000', 'consum', 0.0321, 'lps'),
	(668042, 132, '2015-02-01 00:21:55.000000', 'consum', 0.0246, 'lps'),
	(668043, 132, '2015-02-01 00:21:56.000000', 'consum', 0.0289, 'lps'),
	(668044, 132, '2015-02-01 00:21:57.000000', 'consum', 0.0266, 'lps'),
	(668045, 132, '2015-02-01 00:21:58.000000', 'consum', 0.0252, 'lps'),
	(668046, 132, '2015-02-01 00:21:59.000000', 'consum', 0.0253, 'lps'),
	(668047, 132, '2015-02-01 00:22:00.000000', 'consum', 0.0300, 'lps'),
	(668048, 132, '2015-02-01 00:22:01.000000', 'consum', 0.0301, 'lps'),
	(668049, 132, '2015-02-01 00:22:02.000000', 'consum', 0.0279, 'lps'),
	(668050, 132, '2015-02-01 00:22:03.000000', 'consum', 0.0282, 'lps'),
	(668051, 132, '2015-02-01 00:22:04.000000', 'consum', 0.0247, 'lps'),
	(668052, 132, '2015-02-01 00:22:05.000000', 'consum', 0.0297, 'lps'),
	(668053, 132, '2015-02-01 00:22:06.000000', 'consum', 0.0303, 'lps'),
	(668054, 132, '2015-02-01 00:22:07.000000', 'consum', 0.0297, 'lps'),
	(668055, 132, '2015-02-01 00:22:08.000000', 'consum', 0.0252, 'lps'),
	(668056, 132, '2015-02-01 00:22:09.000000', 'consum', 0.0275, 'lps'),
	(668057, 132, '2015-02-01 00:22:10.000000', 'consum', 0.0294, 'lps'),
	(668058, 132, '2015-02-01 00:22:11.000000', 'consum', 0.0318, 'lps'),
	(668059, 132, '2015-02-01 00:22:12.000000', 'consum', 0.0268, 'lps'),
	(668060, 132, '2015-02-01 00:22:13.000000', 'consum', 0.0292, 'lps'),
	(668061, 132, '2015-02-01 00:22:14.000000', 'consum', 0.0217, 'lps'),
	(668062, 132, '2015-02-01 00:22:15.000000', 'consum', 0.0228, 'lps'),
	(668063, 132, '2015-02-01 00:22:16.000000', 'consum', 0.0279, 'lps'),
	(668064, 132, '2015-02-01 00:22:17.000000', 'consum', 0.0271, 'lps'),
	(668065, 132, '2015-02-01 00:22:18.000000', 'consum', 0.0309, 'lps'),
	(668066, 132, '2015-02-01 00:22:19.000000', 'consum', 0.0289, 'lps'),
	(668067, 132, '2015-02-01 00:22:20.000000', 'consum', 0.0310, 'lps'),
	(668068, 132, '2015-02-01 00:22:21.000000', 'consum', 0.0242, 'lps'),
	(668069, 132, '2015-02-01 00:22:22.000000', 'consum', 0.0302, 'lps'),
	(668070, 132, '2015-02-01 00:22:23.000000', 'consum', 0.0225, 'lps'),
	(668071, 132, '2015-02-01 00:22:24.000000', 'consum', 0.0241, 'lps'),
	(668072, 132, '2015-02-01 00:22:25.000000', 'consum', 0.0322, 'lps'),
	(668073, 132, '2015-02-01 00:22:26.000000', 'consum', 0.0212, 'lps'),
	(668074, 132, '2015-02-01 00:22:27.000000', 'consum', 0.0235, 'lps'),
	(668075, 132, '2015-02-01 00:22:28.000000', 'consum', 0.0211, 'lps'),
	(668076, 132, '2015-02-01 00:22:29.000000', 'consum', 0.0258, 'lps'),
	(668077, 132, '2015-02-01 00:22:30.000000', 'consum', 0.0214, 'lps'),
	(668078, 132, '2015-02-01 00:22:31.000000', 'consum', 0.0319, 'lps'),
	(668079, 132, '2015-02-01 00:22:32.000000', 'consum', 0.0278, 'lps'),
	(668080, 132, '2015-02-01 00:22:33.000000', 'consum', 0.0224, 'lps'),
	(668081, 132, '2015-02-01 00:22:34.000000', 'consum', 0.0308, 'lps'),
	(668082, 132, '2015-02-01 00:22:35.000000', 'consum', 0.0310, 'lps'),
	(668083, 132, '2015-02-01 00:22:36.000000', 'consum', 0.0303, 'lps'),
	(668084, 132, '2015-02-01 00:22:37.000000', 'consum', 0.0260, 'lps'),
	(668085, 132, '2015-02-01 00:22:38.000000', 'consum', 0.0294, 'lps'),
	(668086, 132, '2015-02-01 00:22:39.000000', 'consum', 0.0251, 'lps'),
	(668087, 132, '2015-02-01 00:22:40.000000', 'consum', 0.0279, 'lps'),
	(668088, 132, '2015-02-01 00:22:41.000000', 'consum', 0.0316, 'lps'),
	(668089, 132, '2015-02-01 00:22:42.000000', 'consum', 0.0303, 'lps'),
	(668090, 132, '2015-02-01 00:22:43.000000', 'consum', 0.0240, 'lps'),
	(668091, 132, '2015-02-01 00:22:44.000000', 'consum', 0.0313, 'lps'),
	(668092, 132, '2015-02-01 00:22:45.000000', 'consum', 0.0290, 'lps'),
	(668093, 132, '2015-02-01 00:22:46.000000', 'consum', 0.0299, 'lps'),
	(668094, 132, '2015-02-01 00:22:47.000000', 'consum', 0.0299, 'lps'),
	(668095, 132, '2015-02-01 00:22:48.000000', 'consum', 0.0275, 'lps'),
	(668096, 132, '2015-02-01 00:22:49.000000', 'consum', 0.0265, 'lps'),
	(668097, 132, '2015-02-01 00:22:50.000000', 'consum', 0.0293, 'lps'),
	(668098, 132, '2015-02-01 00:22:51.000000', 'consum', 0.0230, 'lps'),
	(668099, 132, '2015-02-01 00:22:52.000000', 'consum', 0.0292, 'lps'),
	(668100, 132, '2015-02-01 00:22:53.000000', 'consum', 0.0214, 'lps'),
	(668101, 132, '2015-02-01 00:22:54.000000', 'consum', 0.0214, 'lps'),
	(668102, 132, '2015-02-01 00:22:55.000000', 'consum', 0.0220, 'lps'),
	(668103, 132, '2015-02-01 00:22:56.000000', 'consum', 0.0246, 'lps'),
	(668104, 132, '2015-02-01 00:22:57.000000', 'consum', 0.0247, 'lps'),
	(668105, 132, '2015-02-01 00:22:58.000000', 'consum', 0.0289, 'lps'),
	(668106, 132, '2015-02-01 00:22:59.000000', 'consum', 0.0259, 'lps'),
	(668107, 132, '2015-02-01 00:23:00.000000', 'consum', 0.0221, 'lps'),
	(668108, 132, '2015-02-01 00:23:01.000000', 'consum', 0.0233, 'lps'),
	(668109, 132, '2015-02-01 00:23:02.000000', 'consum', 0.0293, 'lps'),
	(668110, 132, '2015-02-01 00:23:03.000000', 'consum', 0.0325, 'lps'),
	(668111, 132, '2015-02-01 00:23:04.000000', 'consum', 0.0302, 'lps'),
	(668112, 132, '2015-02-01 00:23:05.000000', 'consum', 0.0211, 'lps'),
	(668113, 132, '2015-02-01 00:23:06.000000', 'consum', 0.0288, 'lps'),
	(668114, 132, '2015-02-01 00:23:07.000000', 'consum', 0.0248, 'lps'),
	(668115, 132, '2015-02-01 00:23:08.000000', 'consum', 0.0282, 'lps'),
	(668116, 132, '2015-02-01 00:23:09.000000', 'consum', 0.0225, 'lps'),
	(668117, 132, '2015-02-01 00:23:10.000000', 'consum', 0.0302, 'lps'),
	(668118, 132, '2015-02-01 00:23:11.000000', 'consum', 0.0276, 'lps'),
	(668119, 132, '2015-02-01 00:23:12.000000', 'consum', 0.0265, 'lps'),
	(668120, 132, '2015-02-01 00:23:13.000000', 'consum', 0.0290, 'lps'),
	(668121, 132, '2015-02-01 00:23:14.000000', 'consum', 0.0212, 'lps'),
	(668122, 132, '2015-02-01 00:23:15.000000', 'consum', 0.0211, 'lps'),
	(668123, 132, '2015-02-01 00:23:16.000000', 'consum', 0.0325, 'lps'),
	(668124, 132, '2015-02-01 00:23:17.000000', 'consum', 0.0320, 'lps'),
	(668125, 132, '2015-02-01 00:23:18.000000', 'consum', 0.0300, 'lps'),
	(668126, 132, '2015-02-01 00:23:19.000000', 'consum', 0.0214, 'lps'),
	(668127, 132, '2015-02-01 00:23:20.000000', 'consum', 0.0309, 'lps'),
	(668128, 132, '2015-02-01 00:23:21.000000', 'consum', 0.0228, 'lps'),
	(668129, 132, '2015-02-01 00:23:22.000000', 'consum', 0.0236, 'lps'),
	(668130, 132, '2015-02-01 00:23:23.000000', 'consum', 0.0287, 'lps'),
	(668131, 132, '2015-02-01 00:23:24.000000', 'consum', 0.0285, 'lps'),
	(668132, 132, '2015-02-01 00:23:25.000000', 'consum', 0.0239, 'lps'),
	(668133, 132, '2015-02-01 00:23:26.000000', 'consum', 0.0245, 'lps'),
	(668134, 132, '2015-02-01 00:23:27.000000', 'consum', 0.0301, 'lps'),
	(668135, 132, '2015-02-01 00:23:28.000000', 'consum', 0.0212, 'lps'),
	(668136, 132, '2015-02-01 00:23:29.000000', 'consum', 0.0296, 'lps'),
	(668137, 132, '2015-02-01 00:23:30.000000', 'consum', 0.0288, 'lps'),
	(668138, 132, '2015-02-01 00:23:31.000000', 'consum', 0.0224, 'lps'),
	(668139, 132, '2015-02-01 00:23:32.000000', 'consum', 0.0279, 'lps'),
	(668140, 132, '2015-02-01 00:23:33.000000', 'consum', 0.0280, 'lps'),
	(668141, 132, '2015-02-01 00:23:34.000000', 'consum', 0.0238, 'lps'),
	(668142, 132, '2015-02-01 00:23:35.000000', 'consum', 0.0255, 'lps'),
	(668143, 132, '2015-02-01 00:23:36.000000', 'consum', 0.0239, 'lps'),
	(668144, 132, '2015-02-01 00:23:37.000000', 'consum', 0.0218, 'lps'),
	(668145, 132, '2015-02-01 00:23:38.000000', 'consum', 0.0281, 'lps'),
	(668146, 132, '2015-02-01 00:23:39.000000', 'consum', 0.0310, 'lps'),
	(668147, 132, '2015-02-01 00:23:40.000000', 'consum', 0.0265, 'lps'),
	(668148, 132, '2015-02-01 00:23:41.000000', 'consum', 0.0302, 'lps'),
	(668149, 132, '2015-02-01 00:23:42.000000', 'consum', 0.0271, 'lps'),
	(668150, 132, '2015-02-01 00:23:43.000000', 'consum', 0.0242, 'lps'),
	(668151, 132, '2015-02-01 00:23:44.000000', 'consum', 0.0301, 'lps'),
	(668152, 132, '2015-02-01 00:23:45.000000', 'consum', 0.0221, 'lps'),
	(668153, 132, '2015-02-01 00:23:46.000000', 'consum', 0.0226, 'lps'),
	(668154, 132, '2015-02-01 00:23:47.000000', 'consum', 0.0256, 'lps'),
	(668155, 132, '2015-02-01 00:23:48.000000', 'consum', 0.0277, 'lps'),
	(668156, 132, '2015-02-01 00:23:49.000000', 'consum', 0.0292, 'lps'),
	(668157, 132, '2015-02-01 00:23:50.000000', 'consum', 0.0303, 'lps'),
	(668158, 132, '2015-02-01 00:23:51.000000', 'consum', 0.0312, 'lps'),
	(668159, 132, '2015-02-01 00:23:52.000000', 'consum', 0.0211, 'lps'),
	(668160, 132, '2015-02-01 00:23:53.000000', 'consum', 0.0257, 'lps'),
	(668161, 132, '2015-02-01 00:23:54.000000', 'consum', 0.0212, 'lps'),
	(668162, 132, '2015-02-01 00:23:55.000000', 'consum', 0.0309, 'lps'),
	(668163, 132, '2015-02-01 00:23:56.000000', 'consum', 0.0237, 'lps'),
	(668164, 132, '2015-02-01 00:23:57.000000', 'consum', 0.0280, 'lps'),
	(668165, 132, '2015-02-01 00:23:58.000000', 'consum', 0.0248, 'lps'),
	(668166, 132, '2015-02-01 00:23:59.000000', 'consum', 0.0307, 'lps'),
	(668167, 132, '2015-02-01 00:24:00.000000', 'consum', 0.0233, 'lps'),
	(668168, 132, '2015-02-01 00:24:01.000000', 'consum', 0.0268, 'lps'),
	(668169, 132, '2015-02-01 00:24:02.000000', 'consum', 0.0314, 'lps'),
	(668170, 132, '2015-02-01 00:24:03.000000', 'consum', 0.0210, 'lps'),
	(668171, 132, '2015-02-01 00:24:04.000000', 'consum', 0.0244, 'lps'),
	(668172, 132, '2015-02-01 00:24:05.000000', 'consum', 0.0265, 'lps'),
	(668173, 132, '2015-02-01 00:24:06.000000', 'consum', 0.0268, 'lps'),
	(668174, 132, '2015-02-01 00:24:07.000000', 'consum', 0.0219, 'lps'),
	(668175, 132, '2015-02-01 00:24:08.000000', 'consum', 0.0312, 'lps'),
	(668176, 132, '2015-02-01 00:24:09.000000', 'consum', 0.0232, 'lps'),
	(668177, 132, '2015-02-01 00:24:10.000000', 'consum', 0.0244, 'lps'),
	(668178, 132, '2015-02-01 00:24:11.000000', 'consum', 0.0314, 'lps'),
	(668179, 132, '2015-02-01 00:24:12.000000', 'consum', 0.0282, 'lps'),
	(668180, 132, '2015-02-01 00:24:13.000000', 'consum', 0.0259, 'lps'),
	(668181, 132, '2015-02-01 00:24:14.000000', 'consum', 0.0239, 'lps'),
	(668182, 132, '2015-02-01 00:24:15.000000', 'consum', 0.0324, 'lps'),
	(668183, 132, '2015-02-01 00:24:16.000000', 'consum', 0.0230, 'lps'),
	(668184, 132, '2015-02-01 00:24:17.000000', 'consum', 0.0318, 'lps'),
	(668185, 132, '2015-02-01 00:24:18.000000', 'consum', 0.0224, 'lps'),
	(668186, 132, '2015-02-01 00:24:19.000000', 'consum', 0.0304, 'lps'),
	(668187, 132, '2015-02-01 00:24:20.000000', 'consum', 0.0293, 'lps'),
	(668188, 132, '2015-02-01 00:24:21.000000', 'consum', 0.0228, 'lps'),
	(668189, 132, '2015-02-01 00:24:22.000000', 'consum', 0.0284, 'lps'),
	(668190, 132, '2015-02-01 00:24:23.000000', 'consum', 0.0295, 'lps'),
	(668191, 132, '2015-02-01 00:24:24.000000', 'consum', 0.0296, 'lps'),
	(668192, 132, '2015-02-01 00:24:25.000000', 'consum', 0.0271, 'lps'),
	(668193, 132, '2015-02-01 00:24:26.000000', 'consum', 0.0258, 'lps'),
	(668194, 132, '2015-02-01 00:24:27.000000', 'consum', 0.0268, 'lps'),
	(668195, 132, '2015-02-01 00:24:28.000000', 'consum', 0.0238, 'lps'),
	(668196, 132, '2015-02-01 00:24:29.000000', 'consum', 0.0293, 'lps'),
	(668197, 132, '2015-02-01 00:24:30.000000', 'consum', 0.0312, 'lps'),
	(668198, 132, '2015-02-01 00:24:31.000000', 'consum', 0.0238, 'lps'),
	(668199, 132, '2015-02-01 00:24:32.000000', 'consum', 0.0275, 'lps'),
	(668200, 132, '2015-02-01 00:24:33.000000', 'consum', 0.0222, 'lps'),
	(668201, 132, '2015-02-01 00:24:34.000000', 'consum', 0.0305, 'lps'),
	(668202, 132, '2015-02-01 00:24:35.000000', 'consum', 0.0302, 'lps'),
	(668203, 132, '2015-02-01 00:24:36.000000', 'consum', 0.0272, 'lps'),
	(668204, 132, '2015-02-01 00:24:37.000000', 'consum', 0.0242, 'lps'),
	(668205, 132, '2015-02-01 00:24:38.000000', 'consum', 0.0301, 'lps'),
	(668206, 132, '2015-02-01 00:24:39.000000', 'consum', 0.0223, 'lps'),
	(668207, 132, '2015-02-01 00:24:40.000000', 'consum', 0.0232, 'lps'),
	(668208, 132, '2015-02-01 00:24:41.000000', 'consum', 0.0281, 'lps'),
	(668209, 132, '2015-02-01 00:24:42.000000', 'consum', 0.0271, 'lps'),
	(668210, 132, '2015-02-01 00:24:43.000000', 'consum', 0.0299, 'lps'),
	(668211, 132, '2015-02-01 00:24:44.000000', 'consum', 0.0242, 'lps'),
	(668212, 132, '2015-02-01 00:24:45.000000', 'consum', 0.0220, 'lps'),
	(668213, 132, '2015-02-01 00:24:46.000000', 'consum', 0.0282, 'lps'),
	(668214, 132, '2015-02-01 00:24:47.000000', 'consum', 0.0305, 'lps'),
	(668215, 132, '2015-02-01 00:24:48.000000', 'consum', 0.0239, 'lps'),
	(668216, 132, '2015-02-01 00:24:49.000000', 'consum', 0.0303, 'lps'),
	(668217, 132, '2015-02-01 00:24:50.000000', 'consum', 0.0240, 'lps'),
	(668218, 132, '2015-02-01 00:24:51.000000', 'consum', 0.0315, 'lps'),
	(668219, 132, '2015-02-01 00:24:52.000000', 'consum', 0.0295, 'lps'),
	(668220, 132, '2015-02-01 00:24:53.000000', 'consum', 0.0324, 'lps'),
	(668221, 132, '2015-02-01 00:24:54.000000', 'consum', 0.0290, 'lps'),
	(668222, 132, '2015-02-01 00:24:55.000000', 'consum', 0.0269, 'lps'),
	(668223, 132, '2015-02-01 00:24:56.000000', 'consum', 0.0264, 'lps'),
	(668224, 132, '2015-02-01 00:24:57.000000', 'consum', 0.0305, 'lps'),
	(668225, 132, '2015-02-01 00:24:58.000000', 'consum', 0.0292, 'lps'),
	(668226, 132, '2015-02-01 00:24:59.000000', 'consum', 0.0220, 'lps'),
	(668227, 132, '2015-02-01 00:25:00.000000', 'consum', 0.0244, 'lps'),
	(668228, 132, '2015-02-01 00:25:01.000000', 'consum', 0.0236, 'lps'),
	(668229, 132, '2015-02-01 00:25:02.000000', 'consum', 0.0240, 'lps'),
	(668230, 132, '2015-02-01 00:25:03.000000', 'consum', 0.0282, 'lps'),
	(668231, 132, '2015-02-01 00:25:04.000000', 'consum', 0.0248, 'lps'),
	(668232, 132, '2015-02-01 00:25:05.000000', 'consum', 0.0299, 'lps'),
	(668233, 132, '2015-02-01 00:25:06.000000', 'consum', 0.0312, 'lps'),
	(668234, 132, '2015-02-01 00:25:07.000000', 'consum', 0.0221, 'lps'),
	(668235, 132, '2015-02-01 00:25:08.000000', 'consum', 0.0307, 'lps'),
	(668236, 132, '2015-02-01 00:25:09.000000', 'consum', 0.0316, 'lps'),
	(668237, 132, '2015-02-01 00:25:10.000000', 'consum', 0.0215, 'lps'),
	(668238, 132, '2015-02-01 00:25:11.000000', 'consum', 0.0267, 'lps'),
	(668239, 132, '2015-02-01 00:25:12.000000', 'consum', 0.0246, 'lps'),
	(668240, 132, '2015-02-01 00:25:13.000000', 'consum', 0.0222, 'lps'),
	(668241, 132, '2015-02-01 00:25:14.000000', 'consum', 0.0279, 'lps'),
	(668242, 132, '2015-02-01 00:25:15.000000', 'consum', 0.0288, 'lps'),
	(668243, 132, '2015-02-01 00:25:16.000000', 'consum', 0.0277, 'lps'),
	(668244, 132, '2015-02-01 00:25:17.000000', 'consum', 0.0310, 'lps'),
	(668245, 132, '2015-02-01 00:25:18.000000', 'consum', 0.0278, 'lps'),
	(668246, 132, '2015-02-01 00:25:19.000000', 'consum', 0.0252, 'lps'),
	(668247, 132, '2015-02-01 00:25:20.000000', 'consum', 0.0217, 'lps'),
	(668248, 132, '2015-02-01 00:25:21.000000', 'consum', 0.0234, 'lps'),
	(668249, 132, '2015-02-01 00:25:22.000000', 'consum', 0.0309, 'lps'),
	(668250, 132, '2015-02-01 00:25:23.000000', 'consum', 0.0286, 'lps'),
	(668251, 132, '2015-02-01 00:25:24.000000', 'consum', 0.0292, 'lps'),
	(668252, 132, '2015-02-01 00:25:25.000000', 'consum', 0.0277, 'lps'),
	(668253, 132, '2015-02-01 00:25:26.000000', 'consum', 0.0301, 'lps'),
	(668254, 132, '2015-02-01 00:25:27.000000', 'consum', 0.0230, 'lps'),
	(668255, 132, '2015-02-01 00:25:28.000000', 'consum', 0.0271, 'lps'),
	(668256, 132, '2015-02-01 00:25:29.000000', 'consum', 0.0225, 'lps'),
	(668257, 132, '2015-02-01 00:25:30.000000', 'consum', 0.0216, 'lps'),
	(668258, 132, '2015-02-01 00:25:31.000000', 'consum', 0.0314, 'lps'),
	(668259, 132, '2015-02-01 00:25:32.000000', 'consum', 0.0248, 'lps'),
	(668260, 132, '2015-02-01 00:25:33.000000', 'consum', 0.0320, 'lps'),
	(668261, 132, '2015-02-01 00:25:34.000000', 'consum', 0.0297, 'lps'),
	(668262, 132, '2015-02-01 00:25:35.000000', 'consum', 0.0317, 'lps'),
	(668263, 132, '2015-02-01 00:25:36.000000', 'consum', 0.0253, 'lps'),
	(668264, 132, '2015-02-01 00:25:37.000000', 'consum', 0.0221, 'lps'),
	(668265, 132, '2015-02-01 00:25:38.000000', 'consum', 0.0253, 'lps'),
	(668266, 132, '2015-02-01 00:25:39.000000', 'consum', 0.0277, 'lps'),
	(668267, 132, '2015-02-01 00:25:40.000000', 'consum', 0.0300, 'lps'),
	(668268, 132, '2015-02-01 00:25:41.000000', 'consum', 0.0227, 'lps'),
	(668269, 132, '2015-02-01 00:25:42.000000', 'consum', 0.0257, 'lps'),
	(668270, 132, '2015-02-01 00:25:43.000000', 'consum', 0.0279, 'lps'),
	(668271, 132, '2015-02-01 00:25:44.000000', 'consum', 0.0299, 'lps'),
	(668272, 132, '2015-02-01 00:25:45.000000', 'consum', 0.0216, 'lps'),
	(668273, 132, '2015-02-01 00:25:46.000000', 'consum', 0.0321, 'lps'),
	(668274, 132, '2015-02-01 00:25:47.000000', 'consum', 0.0284, 'lps'),
	(668275, 132, '2015-02-01 00:25:48.000000', 'consum', 0.0247, 'lps'),
	(668276, 132, '2015-02-01 00:25:49.000000', 'consum', 0.0291, 'lps'),
	(668277, 132, '2015-02-01 00:25:50.000000', 'consum', 0.0271, 'lps'),
	(668278, 132, '2015-02-01 00:25:51.000000', 'consum', 0.0272, 'lps'),
	(668279, 132, '2015-02-01 00:25:52.000000', 'consum', 0.0222, 'lps'),
	(668280, 132, '2015-02-01 00:25:53.000000', 'consum', 0.0315, 'lps'),
	(668281, 132, '2015-02-01 00:25:54.000000', 'consum', 0.0236, 'lps'),
	(668282, 132, '2015-02-01 00:25:55.000000', 'consum', 0.0259, 'lps'),
	(668283, 132, '2015-02-01 00:25:56.000000', 'consum', 0.0259, 'lps'),
	(668284, 132, '2015-02-01 00:25:57.000000', 'consum', 0.0309, 'lps'),
	(668285, 132, '2015-02-01 00:25:58.000000', 'consum', 0.0212, 'lps'),
	(668286, 132, '2015-02-01 00:25:59.000000', 'consum', 0.0270, 'lps'),
	(668287, 132, '2015-02-01 00:26:00.000000', 'consum', 0.0275, 'lps'),
	(668288, 132, '2015-02-01 00:26:01.000000', 'consum', 0.0237, 'lps'),
	(668289, 132, '2015-02-01 00:26:02.000000', 'consum', 0.0266, 'lps'),
	(668290, 132, '2015-02-01 00:26:03.000000', 'consum', 0.0292, 'lps'),
	(668291, 132, '2015-02-01 00:26:04.000000', 'consum', 0.0224, 'lps'),
	(668292, 132, '2015-02-01 00:26:05.000000', 'consum', 0.0264, 'lps'),
	(668293, 132, '2015-02-01 00:26:06.000000', 'consum', 0.0323, 'lps'),
	(668294, 132, '2015-02-01 00:26:07.000000', 'consum', 0.0264, 'lps'),
	(668295, 132, '2015-02-01 00:26:08.000000', 'consum', 0.0257, 'lps'),
	(668296, 132, '2015-02-01 00:26:09.000000', 'consum', 0.0286, 'lps'),
	(668297, 132, '2015-02-01 00:26:10.000000', 'consum', 0.0216, 'lps'),
	(668298, 132, '2015-02-01 00:26:11.000000', 'consum', 0.0246, 'lps'),
	(668299, 132, '2015-02-01 00:26:12.000000', 'consum', 0.0255, 'lps'),
	(668300, 132, '2015-02-01 00:26:13.000000', 'consum', 0.0212, 'lps'),
	(668301, 132, '2015-02-01 00:26:14.000000', 'consum', 0.0319, 'lps'),
	(668302, 132, '2015-02-01 00:26:15.000000', 'consum', 0.0285, 'lps'),
	(668303, 132, '2015-02-01 00:26:16.000000', 'consum', 0.0257, 'lps'),
	(668304, 132, '2015-02-01 00:26:17.000000', 'consum', 0.0222, 'lps'),
	(668305, 132, '2015-02-01 00:26:18.000000', 'consum', 0.0243, 'lps'),
	(668306, 132, '2015-02-01 00:26:19.000000', 'consum', 0.0227, 'lps'),
	(668307, 132, '2015-02-01 00:26:20.000000', 'consum', 0.0309, 'lps'),
	(668308, 132, '2015-02-01 00:26:21.000000', 'consum', 0.0310, 'lps'),
	(668309, 132, '2015-02-01 00:26:22.000000', 'consum', 0.0296, 'lps'),
	(668310, 132, '2015-02-01 00:26:23.000000', 'consum', 0.0222, 'lps'),
	(668311, 132, '2015-02-01 00:26:24.000000', 'consum', 0.0248, 'lps'),
	(668312, 132, '2015-02-01 00:26:25.000000', 'consum', 0.0247, 'lps'),
	(668313, 132, '2015-02-01 00:26:26.000000', 'consum', 0.0283, 'lps'),
	(668314, 132, '2015-02-01 00:26:27.000000', 'consum', 0.0233, 'lps'),
	(668315, 132, '2015-02-01 00:26:28.000000', 'consum', 0.0223, 'lps'),
	(668316, 132, '2015-02-01 00:26:29.000000', 'consum', 0.0321, 'lps'),
	(668317, 132, '2015-02-01 00:26:30.000000', 'consum', 0.0264, 'lps'),
	(668318, 132, '2015-02-01 00:26:31.000000', 'consum', 0.0264, 'lps'),
	(668319, 132, '2015-02-01 00:26:32.000000', 'consum', 0.0317, 'lps'),
	(668320, 132, '2015-02-01 00:26:33.000000', 'consum', 0.0234, 'lps'),
	(668321, 132, '2015-02-01 00:26:34.000000', 'consum', 0.0243, 'lps'),
	(668322, 132, '2015-02-01 00:26:35.000000', 'consum', 0.0306, 'lps'),
	(668323, 132, '2015-02-01 00:26:36.000000', 'consum', 0.0240, 'lps'),
	(668324, 132, '2015-02-01 00:26:37.000000', 'consum', 0.0304, 'lps'),
	(668325, 132, '2015-02-01 00:26:38.000000', 'consum', 0.0244, 'lps'),
	(668326, 132, '2015-02-01 00:26:39.000000', 'consum', 0.0216, 'lps'),
	(668327, 132, '2015-02-01 00:26:40.000000', 'consum', 0.0252, 'lps'),
	(668328, 132, '2015-02-01 00:26:41.000000', 'consum', 0.0287, 'lps'),
	(668329, 132, '2015-02-01 00:26:42.000000', 'consum', 0.0236, 'lps'),
	(668330, 132, '2015-02-01 00:26:43.000000', 'consum', 0.0225, 'lps'),
	(668331, 132, '2015-02-01 00:26:44.000000', 'consum', 0.0210, 'lps'),
	(668332, 132, '2015-02-01 00:26:45.000000', 'consum', 0.0280, 'lps'),
	(668333, 132, '2015-02-01 00:26:46.000000', 'consum', 0.0214, 'lps'),
	(668334, 132, '2015-02-01 00:26:47.000000', 'consum', 0.0252, 'lps'),
	(668335, 132, '2015-02-01 00:26:48.000000', 'consum', 0.0292, 'lps'),
	(668336, 132, '2015-02-01 00:26:49.000000', 'consum', 0.0263, 'lps'),
	(668337, 132, '2015-02-01 00:26:50.000000', 'consum', 0.0231, 'lps'),
	(668338, 132, '2015-02-01 00:26:51.000000', 'consum', 0.0271, 'lps'),
	(668339, 132, '2015-02-01 00:26:52.000000', 'consum', 0.0220, 'lps'),
	(668340, 132, '2015-02-01 00:26:53.000000', 'consum', 0.0311, 'lps'),
	(668341, 132, '2015-02-01 00:26:54.000000', 'consum', 0.0220, 'lps'),
	(668342, 132, '2015-02-01 00:26:55.000000', 'consum', 0.0308, 'lps'),
	(668343, 132, '2015-02-01 00:26:56.000000', 'consum', 0.0319, 'lps'),
	(668344, 132, '2015-02-01 00:26:57.000000', 'consum', 0.0232, 'lps'),
	(668345, 132, '2015-02-01 00:26:58.000000', 'consum', 0.0223, 'lps'),
	(668346, 132, '2015-02-01 00:26:59.000000', 'consum', 0.0210, 'lps'),
	(668347, 132, '2015-02-01 00:27:00.000000', 'consum', 0.0287, 'lps'),
	(668348, 132, '2015-02-01 00:27:01.000000', 'consum', 0.0249, 'lps'),
	(668349, 132, '2015-02-01 00:27:02.000000', 'consum', 0.0289, 'lps'),
	(668350, 132, '2015-02-01 00:27:03.000000', 'consum', 0.0259, 'lps'),
	(668351, 132, '2015-02-01 00:27:04.000000', 'consum', 0.0218, 'lps'),
	(668352, 132, '2015-02-01 00:27:05.000000', 'consum', 0.0220, 'lps'),
	(668353, 132, '2015-02-01 00:27:06.000000', 'consum', 0.0236, 'lps'),
	(668354, 132, '2015-02-01 00:27:07.000000', 'consum', 0.0310, 'lps'),
	(668355, 132, '2015-02-01 00:27:08.000000', 'consum', 0.0286, 'lps'),
	(668356, 132, '2015-02-01 00:27:09.000000', 'consum', 0.0291, 'lps'),
	(668357, 132, '2015-02-01 00:27:10.000000', 'consum', 0.0270, 'lps'),
	(668358, 132, '2015-02-01 00:27:11.000000', 'consum', 0.0268, 'lps'),
	(668359, 132, '2015-02-01 00:27:12.000000', 'consum', 0.0321, 'lps'),
	(668360, 132, '2015-02-01 00:27:13.000000', 'consum', 0.0242, 'lps'),
	(668361, 132, '2015-02-01 00:27:14.000000', 'consum', 0.0270, 'lps'),
	(668362, 132, '2015-02-01 00:27:15.000000', 'consum', 0.0297, 'lps'),
	(668363, 132, '2015-02-01 00:27:16.000000', 'consum', 0.0236, 'lps'),
	(668364, 132, '2015-02-01 00:27:17.000000', 'consum', 0.0309, 'lps'),
	(668365, 132, '2015-02-01 00:27:18.000000', 'consum', 0.0281, 'lps'),
	(668366, 132, '2015-02-01 00:27:19.000000', 'consum', 0.0270, 'lps'),
	(668367, 132, '2015-02-01 00:27:20.000000', 'consum', 0.0296, 'lps'),
	(668368, 132, '2015-02-01 00:27:21.000000', 'consum', 0.0230, 'lps'),
	(668369, 132, '2015-02-01 00:27:22.000000', 'consum', 0.0282, 'lps'),
	(668370, 132, '2015-02-01 00:27:23.000000', 'consum', 0.0280, 'lps'),
	(668371, 132, '2015-02-01 00:27:24.000000', 'consum', 0.0228, 'lps'),
	(668372, 132, '2015-02-01 00:27:25.000000', 'consum', 0.0323, 'lps'),
	(668373, 132, '2015-02-01 00:27:26.000000', 'consum', 0.0258, 'lps'),
	(668374, 132, '2015-02-01 00:27:27.000000', 'consum', 0.0228, 'lps'),
	(668375, 132, '2015-02-01 00:27:28.000000', 'consum', 0.0272, 'lps'),
	(668376, 132, '2015-02-01 00:27:29.000000', 'consum', 0.0236, 'lps'),
	(668377, 132, '2015-02-01 00:27:30.000000', 'consum', 0.0270, 'lps'),
	(668378, 132, '2015-02-01 00:27:31.000000', 'consum', 0.0315, 'lps'),
	(668379, 132, '2015-02-01 00:27:32.000000', 'consum', 0.0323, 'lps'),
	(668380, 132, '2015-02-01 00:27:33.000000', 'consum', 0.0231, 'lps'),
	(668381, 132, '2015-02-01 00:27:34.000000', 'consum', 0.0324, 'lps'),
	(668382, 132, '2015-02-01 00:27:35.000000', 'consum', 0.0253, 'lps'),
	(668383, 132, '2015-02-01 00:27:36.000000', 'consum', 0.0317, 'lps'),
	(668384, 132, '2015-02-01 00:27:37.000000', 'consum', 0.0268, 'lps'),
	(668385, 132, '2015-02-01 00:27:38.000000', 'consum', 0.0295, 'lps'),
	(668386, 132, '2015-02-01 00:27:39.000000', 'consum', 0.0229, 'lps'),
	(668387, 132, '2015-02-01 00:27:40.000000', 'consum', 0.0281, 'lps'),
	(668388, 132, '2015-02-01 00:27:41.000000', 'consum', 0.0278, 'lps'),
	(668389, 132, '2015-02-01 00:27:42.000000', 'consum', 0.0220, 'lps'),
	(668390, 132, '2015-02-01 00:27:43.000000', 'consum', 0.0288, 'lps'),
	(668391, 132, '2015-02-01 00:27:44.000000', 'consum', 0.0222, 'lps'),
	(668392, 132, '2015-02-01 00:27:45.000000', 'consum', 0.0269, 'lps'),
	(668393, 132, '2015-02-01 00:27:46.000000', 'consum', 0.0240, 'lps'),
	(668394, 132, '2015-02-01 00:27:47.000000', 'consum', 0.0296, 'lps'),
	(668395, 132, '2015-02-01 00:27:48.000000', 'consum', 0.0320, 'lps'),
	(668396, 132, '2015-02-01 00:27:49.000000', 'consum', 0.0270, 'lps'),
	(668397, 132, '2015-02-01 00:27:50.000000', 'consum', 0.0297, 'lps'),
	(668398, 132, '2015-02-01 00:27:51.000000', 'consum', 0.0234, 'lps'),
	(668399, 132, '2015-02-01 00:27:52.000000', 'consum', 0.0300, 'lps'),
	(668400, 132, '2015-02-01 00:27:53.000000', 'consum', 0.0241, 'lps'),
	(668401, 132, '2015-02-01 00:27:54.000000', 'consum', 0.0213, 'lps'),
	(668402, 132, '2015-02-01 00:27:55.000000', 'consum', 0.0246, 'lps'),
	(668403, 132, '2015-02-01 00:27:56.000000', 'consum', 0.0267, 'lps'),
	(668404, 132, '2015-02-01 00:27:57.000000', 'consum', 0.0269, 'lps'),
	(668405, 132, '2015-02-01 00:27:58.000000', 'consum', 0.0222, 'lps'),
	(668406, 132, '2015-02-01 00:27:59.000000', 'consum', 0.0324, 'lps'),
	(668407, 132, '2015-02-01 00:28:00.000000', 'consum', 0.0280, 'lps'),
	(668408, 132, '2015-02-01 00:28:01.000000', 'consum', 0.0220, 'lps'),
	(668409, 132, '2015-02-01 00:28:02.000000', 'consum', 0.0281, 'lps'),
	(668410, 132, '2015-02-01 00:28:03.000000', 'consum', 0.0306, 'lps'),
	(668411, 132, '2015-02-01 00:28:04.000000', 'consum', 0.0243, 'lps'),
	(668412, 132, '2015-02-01 00:28:05.000000', 'consum', 0.0321, 'lps'),
	(668413, 132, '2015-02-01 00:28:06.000000', 'consum', 0.0317, 'lps'),
	(668414, 132, '2015-02-01 00:28:07.000000', 'consum', 0.0296, 'lps'),
	(668415, 132, '2015-02-01 00:28:08.000000', 'consum', 0.0321, 'lps'),
	(668416, 132, '2015-02-01 00:28:09.000000', 'consum', 0.0274, 'lps'),
	(668417, 132, '2015-02-01 00:28:10.000000', 'consum', 0.0314, 'lps'),
	(668418, 132, '2015-02-01 00:28:11.000000', 'consum', 0.0307, 'lps'),
	(668419, 132, '2015-02-01 00:28:12.000000', 'consum', 0.0267, 'lps'),
	(668420, 132, '2015-02-01 00:28:13.000000', 'consum', 0.0323, 'lps'),
	(668421, 132, '2015-02-01 00:28:14.000000', 'consum', 0.0253, 'lps'),
	(668422, 132, '2015-02-01 00:28:15.000000', 'consum', 0.0319, 'lps'),
	(668423, 132, '2015-02-01 00:28:16.000000', 'consum', 0.0279, 'lps'),
	(668424, 132, '2015-02-01 00:28:17.000000', 'consum', 0.0228, 'lps'),
	(668425, 132, '2015-02-01 00:28:18.000000', 'consum', 0.0212, 'lps'),
	(668426, 132, '2015-02-01 00:28:19.000000', 'consum', 0.0279, 'lps'),
	(668427, 132, '2015-02-01 00:28:20.000000', 'consum', 0.0319, 'lps'),
	(668428, 132, '2015-02-01 00:28:21.000000', 'consum', 0.0317, 'lps'),
	(668429, 132, '2015-02-01 00:28:22.000000', 'consum', 0.0304, 'lps'),
	(668430, 132, '2015-02-01 00:28:23.000000', 'consum', 0.0241, 'lps'),
	(668431, 132, '2015-02-01 00:28:24.000000', 'consum', 0.0315, 'lps'),
	(668432, 132, '2015-02-01 00:28:25.000000', 'consum', 0.0296, 'lps'),
	(668433, 132, '2015-02-01 00:28:26.000000', 'consum', 0.0323, 'lps'),
	(668434, 132, '2015-02-01 00:28:27.000000', 'consum', 0.0289, 'lps'),
	(668435, 132, '2015-02-01 00:28:28.000000', 'consum', 0.0264, 'lps'),
	(668436, 132, '2015-02-01 00:28:29.000000', 'consum', 0.0244, 'lps'),
	(668437, 132, '2015-02-01 00:28:30.000000', 'consum', 0.0219, 'lps'),
	(668438, 132, '2015-02-01 00:28:31.000000', 'consum', 0.0267, 'lps'),
	(668439, 132, '2015-02-01 00:28:32.000000', 'consum', 0.0240, 'lps'),
	(668440, 132, '2015-02-01 00:28:33.000000', 'consum', 0.0303, 'lps'),
	(668441, 132, '2015-02-01 00:28:34.000000', 'consum', 0.0238, 'lps'),
	(668442, 132, '2015-02-01 00:28:35.000000', 'consum', 0.0302, 'lps'),
	(668443, 132, '2015-02-01 00:28:36.000000', 'consum', 0.0242, 'lps'),
	(668444, 132, '2015-02-01 00:28:37.000000', 'consum', 0.0324, 'lps'),
	(668445, 132, '2015-02-01 00:28:38.000000', 'consum', 0.0221, 'lps'),
	(668446, 132, '2015-02-01 00:28:39.000000', 'consum', 0.0271, 'lps'),
	(668447, 132, '2015-02-01 00:28:40.000000', 'consum', 0.0250, 'lps'),
	(668448, 132, '2015-02-01 00:28:41.000000', 'consum', 0.0227, 'lps'),
	(668449, 132, '2015-02-01 00:28:42.000000', 'consum', 0.0291, 'lps'),
	(668450, 132, '2015-02-01 00:28:43.000000', 'consum', 0.0216, 'lps'),
	(668451, 132, '2015-02-01 00:28:44.000000', 'consum', 0.0232, 'lps'),
	(668452, 132, '2015-02-01 00:28:45.000000', 'consum', 0.0300, 'lps'),
	(668453, 132, '2015-02-01 00:28:46.000000', 'consum', 0.0249, 'lps'),
	(668454, 132, '2015-02-01 00:28:47.000000', 'consum', 0.0249, 'lps'),
	(668455, 132, '2015-02-01 00:28:48.000000', 'consum', 0.0290, 'lps'),
	(668456, 132, '2015-02-01 00:28:49.000000', 'consum', 0.0263, 'lps'),
	(668457, 132, '2015-02-01 00:28:50.000000', 'consum', 0.0236, 'lps'),
	(668458, 132, '2015-02-01 00:28:51.000000', 'consum', 0.0294, 'lps'),
	(668459, 132, '2015-02-01 00:28:52.000000', 'consum', 0.0323, 'lps'),
	(668460, 132, '2015-02-01 00:28:53.000000', 'consum', 0.0291, 'lps'),
	(668461, 132, '2015-02-01 00:28:54.000000', 'consum', 0.0276, 'lps'),
	(668462, 132, '2015-02-01 00:28:55.000000', 'consum', 0.0297, 'lps'),
	(668463, 132, '2015-02-01 00:28:56.000000', 'consum', 0.0217, 'lps'),
	(668464, 132, '2015-02-01 00:28:57.000000', 'consum', 0.0215, 'lps'),
	(668465, 132, '2015-02-01 00:28:58.000000', 'consum', 0.0216, 'lps'),
	(668466, 132, '2015-02-01 00:28:59.000000', 'consum', 0.0225, 'lps'),
	(668467, 132, '2015-02-01 00:29:00.000000', 'consum', 0.0267, 'lps'),
	(668468, 132, '2015-02-01 00:29:01.000000', 'consum', 0.0217, 'lps'),
	(668469, 132, '2015-02-01 00:29:02.000000', 'consum', 0.0310, 'lps'),
	(668470, 132, '2015-02-01 00:29:03.000000', 'consum', 0.0223, 'lps'),
	(668471, 132, '2015-02-01 00:29:04.000000', 'consum', 0.0323, 'lps'),
	(668472, 132, '2015-02-01 00:29:05.000000', 'consum', 0.0273, 'lps'),
	(668473, 132, '2015-02-01 00:29:06.000000', 'consum', 0.0305, 'lps'),
	(668474, 132, '2015-02-01 00:29:07.000000', 'consum', 0.0261, 'lps'),
	(668475, 132, '2015-02-01 00:29:08.000000', 'consum', 0.0299, 'lps'),
	(668476, 132, '2015-02-01 00:29:09.000000', 'consum', 0.0268, 'lps'),
	(668477, 132, '2015-02-01 00:29:10.000000', 'consum', 0.0235, 'lps'),
	(668478, 132, '2015-02-01 00:29:11.000000', 'consum', 0.0278, 'lps'),
	(668479, 132, '2015-02-01 00:29:12.000000', 'consum', 0.0243, 'lps'),
	(668480, 132, '2015-02-01 00:29:13.000000', 'consum', 0.0286, 'lps'),
	(668481, 132, '2015-02-01 00:29:14.000000', 'consum', 0.0259, 'lps'),
	(668482, 132, '2015-02-01 00:29:15.000000', 'consum', 0.0230, 'lps'),
	(668483, 132, '2015-02-01 00:29:16.000000', 'consum', 0.0280, 'lps'),
	(668484, 132, '2015-02-01 00:29:17.000000', 'consum', 0.0269, 'lps'),
	(668485, 132, '2015-02-01 00:29:18.000000', 'consum', 0.0296, 'lps'),
	(668486, 132, '2015-02-01 00:29:19.000000', 'consum', 0.0232, 'lps'),
	(668487, 132, '2015-02-01 00:29:20.000000', 'consum', 0.0294, 'lps'),
	(668488, 132, '2015-02-01 00:29:21.000000', 'consum', 0.0215, 'lps'),
	(668489, 132, '2015-02-01 00:29:22.000000', 'consum', 0.0215, 'lps'),
	(668490, 132, '2015-02-01 00:29:23.000000', 'consum', 0.0221, 'lps'),
	(668491, 132, '2015-02-01 00:29:24.000000', 'consum', 0.0249, 'lps'),
	(668492, 132, '2015-02-01 00:29:25.000000', 'consum', 0.0259, 'lps'),
	(668493, 132, '2015-02-01 00:29:26.000000', 'consum', 0.0220, 'lps'),
	(668494, 132, '2015-02-01 00:29:27.000000', 'consum', 0.0230, 'lps'),
	(668495, 132, '2015-02-01 00:29:28.000000', 'consum', 0.0281, 'lps'),
	(668496, 132, '2015-02-01 00:29:29.000000', 'consum', 0.0274, 'lps'),
	(668497, 132, '2015-02-01 00:29:30.000000', 'consum', 0.0315, 'lps'),
	(668498, 132, '2015-02-01 00:29:31.000000', 'consum', 0.0313, 'lps'),
	(668499, 132, '2015-02-01 00:29:32.000000', 'consum', 0.0296, 'lps'),
	(668500, 132, '2015-02-01 00:29:33.000000', 'consum', 0.0216, 'lps'),
	(668501, 132, '2015-02-01 00:29:34.000000', 'consum', 0.0213, 'lps'),
	(668502, 132, '2015-02-01 00:29:35.000000', 'consum', 0.0324, 'lps'),
	(668503, 132, '2015-02-01 00:29:36.000000', 'consum', 0.0307, 'lps'),
	(668504, 132, '2015-02-01 00:29:37.000000', 'consum', 0.0236, 'lps'),
	(668505, 132, '2015-02-01 00:29:38.000000', 'consum', 0.0283, 'lps'),
	(668506, 132, '2015-02-01 00:29:39.000000', 'consum', 0.0264, 'lps'),
	(668507, 132, '2015-02-01 00:29:40.000000', 'consum', 0.0261, 'lps'),
	(668508, 132, '2015-02-01 00:29:41.000000', 'consum', 0.0306, 'lps'),
	(668509, 132, '2015-02-01 00:29:42.000000', 'consum', 0.0304, 'lps'),
	(668510, 132, '2015-02-01 00:29:43.000000', 'consum', 0.0278, 'lps'),
	(668511, 132, '2015-02-01 00:29:44.000000', 'consum', 0.0267, 'lps'),
	(668512, 132, '2015-02-01 00:29:45.000000', 'consum', 0.0292, 'lps'),
	(668513, 132, '2015-02-01 00:29:46.000000', 'consum', 0.0215, 'lps'),
	(668514, 132, '2015-02-01 00:29:47.000000', 'consum', 0.0225, 'lps'),
	(668515, 132, '2015-02-01 00:29:48.000000', 'consum', 0.0269, 'lps'),
	(668516, 132, '2015-02-01 00:29:49.000000', 'consum', 0.0227, 'lps'),
	(668517, 132, '2015-02-01 00:29:50.000000', 'consum', 0.0237, 'lps'),
	(668518, 132, '2015-02-01 00:29:51.000000', 'consum', 0.0294, 'lps'),
	(668519, 132, '2015-02-01 00:29:52.000000', 'consum', 0.0317, 'lps'),
	(668520, 132, '2015-02-01 00:29:53.000000', 'consum', 0.0263, 'lps'),
	(668521, 132, '2015-02-01 00:29:54.000000', 'consum', 0.0268, 'lps'),
	(668522, 132, '2015-02-01 00:29:55.000000', 'consum', 0.0226, 'lps'),
	(668523, 132, '2015-02-01 00:29:56.000000', 'consum', 0.0232, 'lps'),
	(668524, 132, '2015-02-01 00:29:57.000000', 'consum', 0.0274, 'lps'),
	(668525, 132, '2015-02-01 00:29:58.000000', 'consum', 0.0232, 'lps'),
	(668526, 132, '2015-02-01 00:29:59.000000', 'consum', 0.0245, 'lps'),
	(668527, 132, '2015-02-01 00:30:00.000000', 'consum', 0.0320, 'lps'),
	(668528, 132, '2015-02-01 00:30:01.000000', 'consum', 0.0309, 'lps'),
	(668529, 132, '2015-02-01 00:30:02.000000', 'consum', 0.0256, 'lps'),
	(668530, 132, '2015-02-01 00:30:03.000000', 'consum', 0.0263, 'lps'),
	(668531, 132, '2015-02-01 00:30:04.000000', 'consum', 0.0218, 'lps'),
	(668532, 132, '2015-02-01 00:30:05.000000', 'consum', 0.0210, 'lps'),
	(668533, 132, '2015-02-01 00:30:06.000000', 'consum', 0.0300, 'lps'),
	(668534, 132, '2015-02-01 00:30:07.000000', 'consum', 0.0315, 'lps'),
	(668535, 132, '2015-02-01 00:30:08.000000', 'consum', 0.0234, 'lps'),
	(668536, 132, '2015-02-01 00:30:09.000000', 'consum', 0.0246, 'lps'),
	(668537, 132, '2015-02-01 00:30:10.000000', 'consum', 0.0317, 'lps'),
	(668538, 132, '2015-02-01 00:30:11.000000', 'consum', 0.0290, 'lps'),
	(668539, 132, '2015-02-01 00:30:12.000000', 'consum', 0.0289, 'lps'),
	(668540, 132, '2015-02-01 00:30:13.000000', 'consum', 0.0249, 'lps'),
	(668541, 132, '2015-02-01 00:30:14.000000', 'consum', 0.0285, 'lps'),
	(668542, 132, '2015-02-01 00:30:15.000000', 'consum', 0.0236, 'lps'),
	(668543, 132, '2015-02-01 00:30:16.000000', 'consum', 0.0232, 'lps'),
	(668544, 132, '2015-02-01 00:30:17.000000', 'consum', 0.0242, 'lps'),
	(668545, 132, '2015-02-01 00:30:18.000000', 'consum', 0.0306, 'lps'),
	(668546, 132, '2015-02-01 00:30:19.000000', 'consum', 0.0244, 'lps'),
	(668547, 132, '2015-02-01 00:30:20.000000', 'consum', 0.0211, 'lps'),
	(668548, 132, '2015-02-01 00:30:21.000000', 'consum', 0.0229, 'lps'),
	(668549, 132, '2015-02-01 00:30:22.000000', 'consum', 0.0304, 'lps'),
	(668550, 132, '2015-02-01 00:30:23.000000', 'consum', 0.0272, 'lps'),
	(668551, 132, '2015-02-01 00:30:24.000000', 'consum', 0.0241, 'lps'),
	(668552, 132, '2015-02-01 00:30:25.000000', 'consum', 0.0293, 'lps'),
	(668553, 132, '2015-02-01 00:30:26.000000', 'consum', 0.0301, 'lps'),
	(668554, 132, '2015-02-01 00:30:27.000000', 'consum', 0.0302, 'lps'),
	(668555, 132, '2015-02-01 00:30:28.000000', 'consum', 0.0279, 'lps'),
	(668556, 132, '2015-02-01 00:30:29.000000', 'consum', 0.0280, 'lps'),
	(668557, 132, '2015-02-01 00:30:30.000000', 'consum', 0.0237, 'lps'),
	(668558, 132, '2015-02-01 00:30:31.000000', 'consum', 0.0252, 'lps'),
	(668559, 132, '2015-02-01 00:30:32.000000', 'consum', 0.0225, 'lps'),
	(668560, 132, '2015-02-01 00:30:33.000000', 'consum', 0.0274, 'lps'),
	(668561, 132, '2015-02-01 00:30:34.000000', 'consum', 0.0254, 'lps'),
	(668562, 132, '2015-02-01 00:30:35.000000', 'consum', 0.0237, 'lps'),
	(668563, 132, '2015-02-01 00:30:36.000000', 'consum', 0.0215, 'lps'),
	(668564, 132, '2015-02-01 00:30:37.000000', 'consum', 0.0269, 'lps'),
	(668565, 132, '2015-02-01 00:30:38.000000', 'consum', 0.0258, 'lps'),
	(668566, 132, '2015-02-01 00:30:39.000000', 'consum', 0.0276, 'lps'),
	(668567, 132, '2015-02-01 00:30:40.000000', 'consum', 0.0279, 'lps'),
	(668568, 132, '2015-02-01 00:30:41.000000', 'consum', 0.0241, 'lps'),
	(668569, 132, '2015-02-01 00:30:42.000000', 'consum', 0.0273, 'lps'),
	(668570, 132, '2015-02-01 00:30:43.000000', 'consum', 0.0319, 'lps'),
	(668571, 132, '2015-02-01 00:30:44.000000', 'consum', 0.0216, 'lps'),
	(668572, 132, '2015-02-01 00:30:45.000000', 'consum', 0.0263, 'lps'),
	(668573, 132, '2015-02-01 00:30:46.000000', 'consum', 0.0225, 'lps'),
	(668574, 132, '2015-02-01 00:30:47.000000', 'consum', 0.0241, 'lps'),
	(668575, 132, '2015-02-01 00:30:48.000000', 'consum', 0.0320, 'lps'),
	(668576, 132, '2015-02-01 00:30:49.000000', 'consum', 0.0321, 'lps'),
	(668577, 132, '2015-02-01 00:30:50.000000', 'consum', 0.0321, 'lps'),
	(668578, 132, '2015-02-01 00:30:51.000000', 'consum', 0.0315, 'lps'),
	(668579, 132, '2015-02-01 00:30:52.000000', 'consum', 0.0287, 'lps'),
	(668580, 132, '2015-02-01 00:30:53.000000', 'consum', 0.0278, 'lps'),
	(668581, 132, '2015-02-01 00:30:54.000000', 'consum', 0.0323, 'lps'),
	(668582, 132, '2015-02-01 00:30:55.000000', 'consum', 0.0221, 'lps'),
	(668583, 132, '2015-02-01 00:30:56.000000', 'consum', 0.0276, 'lps'),
	(668584, 132, '2015-02-01 00:30:57.000000', 'consum', 0.0276, 'lps'),
	(668585, 132, '2015-02-01 00:30:58.000000', 'consum', 0.0226, 'lps'),
	(668586, 132, '2015-02-01 00:30:59.000000', 'consum', 0.0210, 'lps'),
	(668587, 132, '2015-02-01 00:31:00.000000', 'consum', 0.0275, 'lps'),
	(668588, 132, '2015-02-01 00:31:01.000000', 'consum', 0.0307, 'lps'),
	(668589, 132, '2015-02-01 00:31:02.000000', 'consum', 0.0265, 'lps'),
	(668590, 132, '2015-02-01 00:31:03.000000', 'consum', 0.0314, 'lps'),
	(668591, 132, '2015-02-01 00:31:04.000000', 'consum', 0.0216, 'lps'),
	(668592, 132, '2015-02-01 00:31:05.000000', 'consum', 0.0277, 'lps'),
	(668593, 132, '2015-02-01 00:31:06.000000', 'consum', 0.0296, 'lps'),
	(668594, 132, '2015-02-01 00:31:07.000000', 'consum', 0.0323, 'lps'),
	(668595, 132, '2015-02-01 00:31:08.000000', 'consum', 0.0284, 'lps'),
	(668596, 132, '2015-02-01 00:31:09.000000', 'consum', 0.0241, 'lps'),
	(668597, 132, '2015-02-01 00:31:10.000000', 'consum', 0.0261, 'lps'),
	(668598, 132, '2015-02-01 00:31:11.000000', 'consum', 0.0255, 'lps'),
	(668599, 132, '2015-02-01 00:31:12.000000', 'consum', 0.0284, 'lps'),
	(668600, 132, '2015-02-01 00:31:13.000000', 'consum', 0.0215, 'lps'),
	(668601, 132, '2015-02-01 00:31:14.000000', 'consum', 0.0245, 'lps'),
	(668602, 132, '2015-02-01 00:31:15.000000', 'consum', 0.0252, 'lps'),
	(668603, 132, '2015-02-01 00:31:16.000000', 'consum', 0.0317, 'lps'),
	(668604, 132, '2015-02-01 00:31:17.000000', 'consum', 0.0270, 'lps'),
	(668605, 132, '2015-02-01 00:31:18.000000', 'consum', 0.0305, 'lps'),
	(668606, 132, '2015-02-01 00:31:19.000000', 'consum', 0.0276, 'lps'),
	(668607, 132, '2015-02-01 00:31:20.000000', 'consum', 0.0253, 'lps'),
	(668608, 132, '2015-02-01 00:31:21.000000', 'consum', 0.0228, 'lps'),
	(668609, 132, '2015-02-01 00:31:22.000000', 'consum', 0.0289, 'lps'),
	(668610, 132, '2015-02-01 00:31:23.000000', 'consum', 0.0320, 'lps'),
	(668611, 132, '2015-02-01 00:31:24.000000', 'consum', 0.0292, 'lps'),
	(668612, 132, '2015-02-01 00:31:25.000000', 'consum', 0.0291, 'lps'),
	(668613, 132, '2015-02-01 00:31:26.000000', 'consum', 0.0254, 'lps'),
	(668614, 132, '2015-02-01 00:31:27.000000', 'consum', 0.0303, 'lps'),
	(668615, 132, '2015-02-01 00:31:28.000000', 'consum', 0.0310, 'lps'),
	(668616, 132, '2015-02-01 00:31:29.000000', 'consum', 0.0315, 'lps'),
	(668617, 132, '2015-02-01 00:31:30.000000', 'consum', 0.0321, 'lps'),
	(668618, 132, '2015-02-01 00:31:31.000000', 'consum', 0.0216, 'lps'),
	(668619, 132, '2015-02-01 00:31:32.000000', 'consum', 0.0257, 'lps'),
	(668620, 132, '2015-02-01 00:31:33.000000', 'consum', 0.0311, 'lps'),
	(668621, 132, '2015-02-01 00:31:34.000000', 'consum', 0.0229, 'lps'),
	(668622, 132, '2015-02-01 00:31:35.000000', 'consum', 0.0232, 'lps'),
	(668623, 132, '2015-02-01 00:31:36.000000', 'consum', 0.0263, 'lps'),
	(668624, 132, '2015-02-01 00:31:37.000000', 'consum', 0.0294, 'lps'),
	(668625, 132, '2015-02-01 00:31:38.000000', 'consum', 0.0241, 'lps'),
	(668626, 132, '2015-02-01 00:31:39.000000', 'consum', 0.0229, 'lps'),
	(668627, 132, '2015-02-01 00:31:40.000000', 'consum', 0.0212, 'lps'),
	(668628, 132, '2015-02-01 00:31:41.000000', 'consum', 0.0281, 'lps'),
	(668629, 132, '2015-02-01 00:31:42.000000', 'consum', 0.0325, 'lps'),
	(668630, 132, '2015-02-01 00:31:43.000000', 'consum', 0.0225, 'lps'),
	(668631, 132, '2015-02-01 00:31:44.000000', 'consum', 0.0289, 'lps'),
	(668632, 132, '2015-02-01 00:31:45.000000', 'consum', 0.0213, 'lps'),
	(668633, 132, '2015-02-01 00:31:46.000000', 'consum', 0.0222, 'lps'),
	(668634, 132, '2015-02-01 00:31:47.000000', 'consum', 0.0261, 'lps'),
	(668635, 132, '2015-02-01 00:31:48.000000', 'consum', 0.0313, 'lps'),
	(668636, 132, '2015-02-01 00:31:49.000000', 'consum', 0.0225, 'lps'),
	(668637, 132, '2015-02-01 00:31:50.000000', 'consum', 0.0324, 'lps'),
	(668638, 132, '2015-02-01 00:31:51.000000', 'consum', 0.0270, 'lps'),
	(668639, 132, '2015-02-01 00:31:52.000000', 'consum', 0.0286, 'lps'),
	(668640, 132, '2015-02-01 00:31:53.000000', 'consum', 0.0293, 'lps'),
	(668641, 132, '2015-02-01 00:31:54.000000', 'consum', 0.0282, 'lps'),
	(668642, 132, '2015-02-01 00:31:55.000000', 'consum', 0.0322, 'lps'),
	(668643, 132, '2015-02-01 00:31:56.000000', 'consum', 0.0323, 'lps'),
	(668644, 132, '2015-02-01 00:31:57.000000', 'consum', 0.0324, 'lps'),
	(668645, 132, '2015-02-01 00:31:58.000000', 'consum', 0.0323, 'lps'),
	(668646, 132, '2015-02-01 00:31:59.000000', 'consum', 0.0319, 'lps'),
	(668647, 132, '2015-02-01 00:32:00.000000', 'consum', 0.0299, 'lps'),
	(668648, 132, '2015-02-01 00:32:01.000000', 'consum', 0.0215, 'lps'),
	(668649, 132, '2015-02-01 00:32:02.000000', 'consum', 0.0314, 'lps'),
	(668650, 132, '2015-02-01 00:32:03.000000', 'consum', 0.0252, 'lps'),
	(668651, 132, '2015-02-01 00:32:04.000000', 'consum', 0.0225, 'lps'),
	(668652, 132, '2015-02-01 00:32:05.000000', 'consum', 0.0276, 'lps'),
	(668653, 132, '2015-02-01 00:32:06.000000', 'consum', 0.0263, 'lps'),
	(668654, 132, '2015-02-01 00:32:07.000000', 'consum', 0.0278, 'lps'),
	(668655, 132, '2015-02-01 00:32:08.000000', 'consum', 0.0276, 'lps'),
	(668656, 132, '2015-02-01 00:32:09.000000', 'consum', 0.0219, 'lps'),
	(668657, 132, '2015-02-01 00:32:10.000000', 'consum', 0.0291, 'lps'),
	(668658, 132, '2015-02-01 00:32:11.000000', 'consum', 0.0241, 'lps'),
	(668659, 132, '2015-02-01 00:32:12.000000', 'consum', 0.0236, 'lps'),
	(668660, 132, '2015-02-01 00:32:13.000000', 'consum', 0.0247, 'lps'),
	(668661, 132, '2015-02-01 00:32:14.000000', 'consum', 0.0320, 'lps'),
	(668662, 132, '2015-02-01 00:32:15.000000', 'consum', 0.0303, 'lps'),
	(668663, 132, '2015-02-01 00:32:16.000000', 'consum', 0.0226, 'lps'),
	(668664, 132, '2015-02-01 00:32:17.000000', 'consum', 0.0243, 'lps'),
	(668665, 132, '2015-02-01 00:32:18.000000', 'consum', 0.0215, 'lps'),
	(668666, 132, '2015-02-01 00:32:19.000000', 'consum', 0.0249, 'lps'),
	(668667, 132, '2015-02-01 00:32:20.000000', 'consum', 0.0278, 'lps'),
	(668668, 132, '2015-02-01 00:32:21.000000', 'consum', 0.0316, 'lps'),
	(668669, 132, '2015-02-01 00:32:22.000000', 'consum', 0.0303, 'lps'),
	(668670, 132, '2015-02-01 00:32:23.000000', 'consum', 0.0244, 'lps'),
	(668671, 132, '2015-02-01 00:32:24.000000', 'consum', 0.0217, 'lps'),
	(668672, 132, '2015-02-01 00:32:25.000000', 'consum', 0.0261, 'lps'),
	(668673, 132, '2015-02-01 00:32:26.000000', 'consum', 0.0212, 'lps'),
	(668674, 132, '2015-02-01 00:32:27.000000', 'consum', 0.0298, 'lps'),
	(668675, 132, '2015-02-01 00:32:28.000000', 'consum', 0.0296, 'lps'),
	(668676, 132, '2015-02-01 00:32:29.000000', 'consum', 0.0261, 'lps'),
	(668677, 132, '2015-02-01 00:32:30.000000', 'consum', 0.0324, 'lps'),
	(668678, 132, '2015-02-01 00:32:31.000000', 'consum', 0.0278, 'lps'),
	(668679, 132, '2015-02-01 00:32:32.000000', 'consum', 0.0210, 'lps'),
	(668680, 132, '2015-02-01 00:32:33.000000', 'consum', 0.0237, 'lps'),
	(668681, 132, '2015-02-01 00:32:34.000000', 'consum', 0.0230, 'lps'),
	(668682, 132, '2015-02-01 00:32:35.000000', 'consum', 0.0228, 'lps'),
	(668683, 132, '2015-02-01 00:32:36.000000', 'consum', 0.0243, 'lps'),
	(668684, 132, '2015-02-01 00:32:37.000000', 'consum', 0.0319, 'lps'),
	(668685, 132, '2015-02-01 00:32:38.000000', 'consum', 0.0310, 'lps'),
	(668686, 132, '2015-02-01 00:32:39.000000', 'consum', 0.0266, 'lps'),
	(668687, 132, '2015-02-01 00:32:40.000000', 'consum', 0.0306, 'lps'),
	(668688, 132, '2015-02-01 00:32:41.000000', 'consum', 0.0291, 'lps'),
	(668689, 132, '2015-02-01 00:32:42.000000', 'consum', 0.0211, 'lps'),
	(668690, 132, '2015-02-01 00:32:43.000000', 'consum', 0.0321, 'lps'),
	(668691, 132, '2015-02-01 00:32:44.000000', 'consum', 0.0299, 'lps'),
	(668692, 132, '2015-02-01 00:32:45.000000', 'consum', 0.0324, 'lps'),
	(668693, 132, '2015-02-01 00:32:46.000000', 'consum', 0.0278, 'lps'),
	(668694, 132, '2015-02-01 00:32:47.000000', 'consum', 0.0212, 'lps'),
	(668695, 132, '2015-02-01 00:32:48.000000', 'consum', 0.0247, 'lps'),
	(668696, 132, '2015-02-01 00:32:49.000000', 'consum', 0.0273, 'lps'),
	(668697, 132, '2015-02-01 00:32:50.000000', 'consum', 0.0300, 'lps'),
	(668698, 132, '2015-02-01 00:32:51.000000', 'consum', 0.0238, 'lps'),
	(668699, 132, '2015-02-01 00:32:52.000000', 'consum', 0.0313, 'lps'),
	(668700, 132, '2015-02-01 00:32:53.000000', 'consum', 0.0295, 'lps'),
	(668701, 132, '2015-02-01 00:32:54.000000', 'consum', 0.0324, 'lps'),
	(668702, 132, '2015-02-01 00:32:55.000000', 'consum', 0.0296, 'lps'),
	(668703, 132, '2015-02-01 00:32:56.000000', 'consum', 0.0297, 'lps'),
	(668704, 132, '2015-02-01 00:32:57.000000', 'consum', 0.0270, 'lps'),
	(668705, 132, '2015-02-01 00:32:58.000000', 'consum', 0.0253, 'lps'),
	(668706, 132, '2015-02-01 00:32:59.000000', 'consum', 0.0243, 'lps'),
	(668707, 132, '2015-02-01 00:33:00.000000', 'consum', 0.0246, 'lps'),
	(668708, 132, '2015-02-01 00:33:01.000000', 'consum', 0.0291, 'lps'),
	(668709, 132, '2015-02-01 00:33:02.000000', 'consum', 0.0277, 'lps'),
	(668710, 132, '2015-02-01 00:33:03.000000', 'consum', 0.0302, 'lps'),
	(668711, 132, '2015-02-01 00:33:04.000000', 'consum', 0.0237, 'lps'),
	(668712, 132, '2015-02-01 00:33:05.000000', 'consum', 0.0302, 'lps'),
	(668713, 132, '2015-02-01 00:33:06.000000', 'consum', 0.0242, 'lps'),
	(668714, 132, '2015-02-01 00:33:07.000000', 'consum', 0.0325, 'lps'),
	(668715, 132, '2015-02-01 00:33:08.000000', 'consum', 0.0227, 'lps'),
	(668716, 132, '2015-02-01 00:33:09.000000', 'consum', 0.0300, 'lps'),
	(668717, 132, '2015-02-01 00:33:10.000000', 'consum', 0.0259, 'lps'),
	(668718, 132, '2015-02-01 00:33:11.000000', 'consum', 0.0301, 'lps'),
	(668719, 132, '2015-02-01 00:33:12.000000', 'consum', 0.0289, 'lps'),
	(668720, 132, '2015-02-01 00:33:13.000000', 'consum', 0.0214, 'lps'),
	(668721, 132, '2015-02-01 00:33:14.000000', 'consum', 0.0227, 'lps'),
	(668722, 132, '2015-02-01 00:33:15.000000', 'consum', 0.0284, 'lps'),
	(668723, 132, '2015-02-01 00:33:16.000000', 'consum', 0.0297, 'lps'),
	(668724, 132, '2015-02-01 00:33:17.000000', 'consum', 0.0309, 'lps'),
	(668725, 132, '2015-02-01 00:33:18.000000', 'consum', 0.0325, 'lps'),
	(668726, 132, '2015-02-01 00:33:19.000000', 'consum', 0.0260, 'lps'),
	(668727, 132, '2015-02-01 00:33:20.000000', 'consum', 0.0229, 'lps'),
	(668728, 132, '2015-02-01 00:33:21.000000', 'consum', 0.0271, 'lps'),
	(668729, 132, '2015-02-01 00:33:22.000000', 'consum', 0.0228, 'lps'),
	(668730, 132, '2015-02-01 00:33:23.000000', 'consum', 0.0235, 'lps'),
	(668731, 132, '2015-02-01 00:33:24.000000', 'consum', 0.0280, 'lps'),
	(668732, 132, '2015-02-01 00:33:25.000000', 'consum', 0.0254, 'lps'),
	(668733, 132, '2015-02-01 00:33:26.000000', 'consum', 0.0219, 'lps'),
	(668734, 132, '2015-02-01 00:33:27.000000', 'consum', 0.0240, 'lps'),
	(668735, 132, '2015-02-01 00:33:28.000000', 'consum', 0.0217, 'lps'),
	(668736, 132, '2015-02-01 00:33:29.000000', 'consum', 0.0273, 'lps'),
	(668737, 132, '2015-02-01 00:33:30.000000', 'consum', 0.0270, 'lps'),
	(668738, 132, '2015-02-01 00:33:31.000000', 'consum', 0.0323, 'lps'),
	(668739, 132, '2015-02-01 00:33:32.000000', 'consum', 0.0247, 'lps'),
	(668740, 132, '2015-02-01 00:33:33.000000', 'consum', 0.0291, 'lps'),
	(668741, 132, '2015-02-01 00:33:34.000000', 'consum', 0.0269, 'lps'),
	(668742, 132, '2015-02-01 00:33:35.000000', 'consum', 0.0265, 'lps'),
	(668743, 132, '2015-02-01 00:33:36.000000', 'consum', 0.0306, 'lps'),
	(668744, 132, '2015-02-01 00:33:37.000000', 'consum', 0.0297, 'lps'),
	(668745, 132, '2015-02-01 00:33:38.000000', 'consum', 0.0238, 'lps'),
	(668746, 132, '2015-02-01 00:33:39.000000', 'consum', 0.0325, 'lps'),
	(668747, 132, '2015-02-01 00:33:40.000000', 'consum', 0.0235, 'lps'),
	(668748, 132, '2015-02-01 00:33:41.000000', 'consum', 0.0222, 'lps'),
	(668749, 132, '2015-02-01 00:33:42.000000', 'consum', 0.0311, 'lps'),
	(668750, 132, '2015-02-01 00:33:43.000000', 'consum', 0.0215, 'lps'),
	(668751, 132, '2015-02-01 00:33:44.000000', 'consum', 0.0280, 'lps'),
	(668752, 132, '2015-02-01 00:33:45.000000', 'consum', 0.0316, 'lps'),
	(668753, 132, '2015-02-01 00:33:46.000000', 'consum', 0.0296, 'lps'),
	(668754, 132, '2015-02-01 00:33:47.000000', 'consum', 0.0325, 'lps'),
	(668755, 132, '2015-02-01 00:33:48.000000', 'consum', 0.0296, 'lps'),
	(668756, 132, '2015-02-01 00:33:49.000000', 'consum', 0.0296, 'lps'),
	(668757, 132, '2015-02-01 00:33:50.000000', 'consum', 0.0265, 'lps'),
	(668758, 132, '2015-02-01 00:33:51.000000', 'consum', 0.0227, 'lps'),
	(668759, 132, '2015-02-01 00:33:52.000000', 'consum', 0.0248, 'lps'),
	(668760, 132, '2015-02-01 00:33:53.000000', 'consum', 0.0231, 'lps'),
	(668761, 132, '2015-02-01 00:33:54.000000', 'consum', 0.0319, 'lps'),
	(668762, 132, '2015-02-01 00:33:55.000000', 'consum', 0.0230, 'lps'),
	(668763, 132, '2015-02-01 00:33:56.000000', 'consum', 0.0214, 'lps'),
	(668764, 132, '2015-02-01 00:33:57.000000', 'consum', 0.0287, 'lps'),
	(668765, 132, '2015-02-01 00:33:58.000000', 'consum', 0.0235, 'lps'),
	(668766, 132, '2015-02-01 00:33:59.000000', 'consum', 0.0222, 'lps'),
	(668767, 132, '2015-02-01 00:34:00.000000', 'consum', 0.0311, 'lps'),
	(668768, 132, '2015-02-01 00:34:01.000000', 'consum', 0.0216, 'lps'),
	(668769, 132, '2015-02-01 00:34:02.000000', 'consum', 0.0284, 'lps'),
	(668770, 132, '2015-02-01 00:34:03.000000', 'consum', 0.0215, 'lps'),
	(668771, 132, '2015-02-01 00:34:04.000000', 'consum', 0.0246, 'lps'),
	(668772, 132, '2015-02-01 00:34:05.000000', 'consum', 0.0258, 'lps'),
	(668773, 132, '2015-02-01 00:34:06.000000', 'consum', 0.0226, 'lps'),
	(668774, 132, '2015-02-01 00:34:07.000000', 'consum', 0.0262, 'lps'),
	(668775, 132, '2015-02-01 00:34:08.000000', 'consum', 0.0307, 'lps'),
	(668776, 132, '2015-02-01 00:34:09.000000', 'consum', 0.0307, 'lps'),
	(668777, 132, '2015-02-01 00:34:10.000000', 'consum', 0.0288, 'lps'),
	(668778, 132, '2015-02-01 00:34:11.000000', 'consum', 0.0311, 'lps'),
	(668779, 132, '2015-02-01 00:34:12.000000', 'consum', 0.0250, 'lps'),
	(668780, 132, '2015-02-01 00:34:13.000000', 'consum', 0.0225, 'lps'),
	(668781, 132, '2015-02-01 00:34:14.000000', 'consum', 0.0278, 'lps'),
	(668782, 132, '2015-02-01 00:34:15.000000', 'consum', 0.0275, 'lps'),
	(668783, 132, '2015-02-01 00:34:16.000000', 'consum', 0.0217, 'lps'),
	(668784, 132, '2015-02-01 00:34:17.000000', 'consum', 0.0279, 'lps'),
	(668785, 132, '2015-02-01 00:34:18.000000', 'consum', 0.0306, 'lps'),
	(668786, 132, '2015-02-01 00:34:19.000000', 'consum', 0.0251, 'lps'),
	(668787, 132, '2015-02-01 00:34:20.000000', 'consum', 0.0244, 'lps'),
	(668788, 132, '2015-02-01 00:34:21.000000', 'consum', 0.0255, 'lps'),
	(668789, 132, '2015-02-01 00:34:22.000000', 'consum', 0.0221, 'lps'),
	(668790, 132, '2015-02-01 00:34:23.000000', 'consum', 0.0243, 'lps'),
	(668791, 132, '2015-02-01 00:34:24.000000', 'consum', 0.0227, 'lps'),
	(668792, 132, '2015-02-01 00:34:25.000000', 'consum', 0.0315, 'lps'),
	(668793, 132, '2015-02-01 00:34:26.000000', 'consum', 0.0220, 'lps'),
	(668794, 132, '2015-02-01 00:34:27.000000', 'consum', 0.0292, 'lps'),
	(668795, 132, '2015-02-01 00:34:28.000000', 'consum', 0.0244, 'lps'),
	(668796, 132, '2015-02-01 00:34:29.000000', 'consum', 0.0251, 'lps'),
	(668797, 132, '2015-02-01 00:34:30.000000', 'consum', 0.0312, 'lps'),
	(668798, 132, '2015-02-01 00:34:31.000000', 'consum', 0.0250, 'lps'),
	(668799, 132, '2015-02-01 00:34:32.000000', 'consum', 0.0220, 'lps'),
	(668800, 132, '2015-02-01 00:34:33.000000', 'consum', 0.0257, 'lps'),
	(668801, 132, '2015-02-01 00:34:34.000000', 'consum', 0.0301, 'lps'),
	(668802, 132, '2015-02-01 00:34:35.000000', 'consum', 0.0290, 'lps'),
	(668803, 132, '2015-02-01 00:34:36.000000', 'consum', 0.0225, 'lps'),
	(668804, 132, '2015-02-01 00:34:37.000000', 'consum', 0.0274, 'lps'),
	(668805, 132, '2015-02-01 00:34:38.000000', 'consum', 0.0254, 'lps'),
	(668806, 132, '2015-02-01 00:34:39.000000', 'consum', 0.0237, 'lps'),
	(668807, 132, '2015-02-01 00:34:40.000000', 'consum', 0.0216, 'lps'),
	(668808, 132, '2015-02-01 00:34:41.000000', 'consum', 0.0273, 'lps'),
	(668809, 132, '2015-02-01 00:34:42.000000', 'consum', 0.0276, 'lps'),
	(668810, 132, '2015-02-01 00:34:43.000000', 'consum', 0.0236, 'lps'),
	(668811, 132, '2015-02-01 00:34:44.000000', 'consum', 0.0257, 'lps'),
	(668812, 132, '2015-02-01 00:34:45.000000', 'consum', 0.0252, 'lps'),
	(668813, 132, '2015-02-01 00:34:46.000000', 'consum', 0.0280, 'lps'),
	(668814, 132, '2015-02-01 00:34:47.000000', 'consum', 0.0318, 'lps'),
	(668815, 132, '2015-02-01 00:34:48.000000', 'consum', 0.0309, 'lps'),
	(668816, 132, '2015-02-01 00:34:49.000000', 'consum', 0.0266, 'lps'),
	(668817, 132, '2015-02-01 00:34:50.000000', 'consum', 0.0308, 'lps'),
	(668818, 132, '2015-02-01 00:34:51.000000', 'consum', 0.0303, 'lps'),
	(668819, 132, '2015-02-01 00:34:52.000000', 'consum', 0.0264, 'lps'),
	(668820, 132, '2015-02-01 00:34:53.000000', 'consum', 0.0320, 'lps'),
	(668821, 132, '2015-02-01 00:34:54.000000', 'consum', 0.0248, 'lps'),
	(668822, 132, '2015-02-01 00:34:55.000000', 'consum', 0.0302, 'lps'),
	(668823, 132, '2015-02-01 00:34:56.000000', 'consum', 0.0324, 'lps'),
	(668824, 132, '2015-02-01 00:34:57.000000', 'consum', 0.0275, 'lps'),
	(668825, 132, '2015-02-01 00:34:58.000000', 'consum', 0.0307, 'lps'),
	(668826, 132, '2015-02-01 00:34:59.000000', 'consum', 0.0268, 'lps'),
	(668827, 132, '2015-02-01 00:35:00.000000', 'consum', 0.0325, 'lps'),
	(668828, 132, '2015-02-01 00:35:01.000000', 'consum', 0.0265, 'lps'),
	(668829, 132, '2015-02-01 00:35:02.000000', 'consum', 0.0257, 'lps'),
	(668830, 132, '2015-02-01 00:35:03.000000', 'consum', 0.0280, 'lps'),
	(668831, 132, '2015-02-01 00:35:04.000000', 'consum', 0.0303, 'lps'),
	(668832, 132, '2015-02-01 00:35:05.000000', 'consum', 0.0235, 'lps'),
	(668833, 132, '2015-02-01 00:35:06.000000', 'consum', 0.0287, 'lps'),
	(668834, 132, '2015-02-01 00:35:07.000000', 'consum', 0.0288, 'lps'),
	(668835, 132, '2015-02-01 00:35:08.000000', 'consum', 0.0253, 'lps'),
	(668836, 132, '2015-02-01 00:35:09.000000', 'consum', 0.0309, 'lps'),
	(668837, 132, '2015-02-01 00:35:10.000000', 'consum', 0.0227, 'lps'),
	(668838, 132, '2015-02-01 00:35:11.000000', 'consum', 0.0231, 'lps'),
	(668839, 132, '2015-02-01 00:35:12.000000', 'consum', 0.0264, 'lps'),
	(668840, 132, '2015-02-01 00:35:13.000000', 'consum', 0.0302, 'lps'),
	(668841, 132, '2015-02-01 00:35:14.000000', 'consum', 0.0278, 'lps'),
	(668842, 132, '2015-02-01 00:35:15.000000', 'consum', 0.0275, 'lps'),
	(668843, 132, '2015-02-01 00:35:16.000000', 'consum', 0.0214, 'lps'),
	(668844, 132, '2015-02-01 00:35:17.000000', 'consum', 0.0269, 'lps'),
	(668845, 132, '2015-02-01 00:35:18.000000', 'consum', 0.0262, 'lps'),
	(668846, 132, '2015-02-01 00:35:19.000000', 'consum', 0.0293, 'lps'),
	(668847, 132, '2015-02-01 00:35:20.000000', 'consum', 0.0236, 'lps'),
	(668848, 132, '2015-02-01 00:35:21.000000', 'consum', 0.0324, 'lps'),
	(668849, 132, '2015-02-01 00:35:22.000000', 'consum', 0.0238, 'lps'),
	(668850, 132, '2015-02-01 00:35:23.000000', 'consum', 0.0243, 'lps'),
	(668851, 132, '2015-02-01 00:35:24.000000', 'consum', 0.0288, 'lps'),
	(668852, 132, '2015-02-01 00:35:25.000000', 'consum', 0.0273, 'lps'),
	(668853, 132, '2015-02-01 00:35:26.000000', 'consum', 0.0290, 'lps'),
	(668854, 132, '2015-02-01 00:35:27.000000', 'consum', 0.0304, 'lps'),
	(668855, 132, '2015-02-01 00:35:28.000000', 'consum', 0.0210, 'lps'),
	(668856, 132, '2015-02-01 00:35:29.000000', 'consum', 0.0278, 'lps'),
	(668857, 132, '2015-02-01 00:35:30.000000', 'consum', 0.0316, 'lps'),
	(668858, 132, '2015-02-01 00:35:31.000000', 'consum', 0.0306, 'lps'),
	(668859, 132, '2015-02-01 00:35:32.000000', 'consum', 0.0255, 'lps'),
	(668860, 132, '2015-02-01 00:35:33.000000', 'consum', 0.0263, 'lps'),
	(668861, 132, '2015-02-01 00:35:34.000000', 'consum', 0.0224, 'lps'),
	(668862, 132, '2015-02-01 00:35:35.000000', 'consum', 0.0238, 'lps'),
	(668863, 132, '2015-02-01 00:35:36.000000', 'consum', 0.0311, 'lps'),
	(668864, 132, '2015-02-01 00:35:37.000000', 'consum', 0.0281, 'lps'),
	(668865, 132, '2015-02-01 00:35:38.000000', 'consum', 0.0264, 'lps'),
	(668866, 132, '2015-02-01 00:35:39.000000', 'consum', 0.0266, 'lps'),
	(668867, 132, '2015-02-01 00:35:40.000000', 'consum', 0.0211, 'lps'),
	(668868, 132, '2015-02-01 00:35:41.000000', 'consum', 0.0282, 'lps'),
	(668869, 132, '2015-02-01 00:35:42.000000', 'consum', 0.0220, 'lps'),
	(668870, 132, '2015-02-01 00:35:43.000000', 'consum', 0.0277, 'lps'),
	(668871, 132, '2015-02-01 00:35:44.000000', 'consum', 0.0284, 'lps'),
	(668872, 132, '2015-02-01 00:35:45.000000', 'consum', 0.0264, 'lps'),
	(668873, 132, '2015-02-01 00:35:46.000000', 'consum', 0.0259, 'lps'),
	(668874, 132, '2015-02-01 00:35:47.000000', 'consum', 0.0291, 'lps'),
	(668875, 132, '2015-02-01 00:35:48.000000', 'consum', 0.0236, 'lps'),
	(668876, 132, '2015-02-01 00:35:49.000000', 'consum', 0.0215, 'lps'),
	(668877, 132, '2015-02-01 00:35:50.000000', 'consum', 0.0274, 'lps'),
	(668878, 132, '2015-02-01 00:35:51.000000', 'consum', 0.0285, 'lps'),
	(668879, 132, '2015-02-01 00:35:52.000000', 'consum', 0.0274, 'lps'),
	(668880, 132, '2015-02-01 00:35:53.000000', 'consum', 0.0308, 'lps'),
	(668881, 132, '2015-02-01 00:35:54.000000', 'consum', 0.0277, 'lps'),
	(668882, 132, '2015-02-01 00:35:55.000000', 'consum', 0.0250, 'lps'),
	(668883, 132, '2015-02-01 00:35:56.000000', 'consum', 0.0325, 'lps'),
	(668884, 132, '2015-02-01 00:35:57.000000', 'consum', 0.0320, 'lps'),
	(668885, 132, '2015-02-01 00:35:58.000000', 'consum', 0.0297, 'lps'),
	(668886, 132, '2015-02-01 00:35:59.000000', 'consum', 0.0316, 'lps'),
	(668887, 132, '2015-02-01 00:36:00.000000', 'consum', 0.0248, 'lps'),
	(668888, 132, '2015-02-01 00:36:01.000000', 'consum', 0.0314, 'lps'),
	(668889, 132, '2015-02-01 00:36:02.000000', 'consum', 0.0270, 'lps'),
	(668890, 132, '2015-02-01 00:36:03.000000', 'consum', 0.0312, 'lps'),
	(668891, 132, '2015-02-01 00:36:04.000000', 'consum', 0.0309, 'lps'),
	(668892, 132, '2015-02-01 00:36:05.000000', 'consum', 0.0285, 'lps'),
	(668893, 132, '2015-02-01 00:36:06.000000', 'consum', 0.0286, 'lps'),
	(668894, 132, '2015-02-01 00:36:07.000000', 'consum', 0.0250, 'lps'),
	(668895, 132, '2015-02-01 00:36:08.000000', 'consum', 0.0297, 'lps'),
	(668896, 132, '2015-02-01 00:36:09.000000', 'consum', 0.0295, 'lps'),
	(668897, 132, '2015-02-01 00:36:10.000000', 'consum', 0.0258, 'lps'),
	(668898, 132, '2015-02-01 00:36:11.000000', 'consum', 0.0311, 'lps'),
	(668899, 132, '2015-02-01 00:36:12.000000', 'consum', 0.0223, 'lps'),
	(668900, 132, '2015-02-01 00:36:13.000000', 'consum', 0.0320, 'lps'),
	(668901, 132, '2015-02-01 00:36:14.000000', 'consum', 0.0260, 'lps'),
	(668902, 132, '2015-02-01 00:36:15.000000', 'consum', 0.0244, 'lps'),
	(668903, 132, '2015-02-01 00:36:16.000000', 'consum', 0.0230, 'lps'),
	(668904, 132, '2015-02-01 00:36:17.000000', 'consum', 0.0324, 'lps'),
	(668905, 132, '2015-02-01 00:36:18.000000', 'consum', 0.0259, 'lps'),
	(668906, 132, '2015-02-01 00:36:19.000000', 'consum', 0.0230, 'lps'),
	(668907, 132, '2015-02-01 00:36:20.000000', 'consum', 0.0280, 'lps'),
	(668908, 132, '2015-02-01 00:36:21.000000', 'consum', 0.0267, 'lps'),
	(668909, 132, '2015-02-01 00:36:22.000000', 'consum', 0.0288, 'lps'),
	(668910, 132, '2015-02-01 00:36:23.000000', 'consum', 0.0311, 'lps'),
	(668911, 132, '2015-02-01 00:36:24.000000', 'consum', 0.0249, 'lps'),
	(668912, 132, '2015-02-01 00:36:25.000000', 'consum', 0.0219, 'lps'),
	(668913, 132, '2015-02-01 00:36:26.000000', 'consum', 0.0257, 'lps'),
	(668914, 132, '2015-02-01 00:36:27.000000', 'consum', 0.0300, 'lps'),
	(668915, 132, '2015-02-01 00:36:28.000000', 'consum', 0.0289, 'lps'),
	(668916, 132, '2015-02-01 00:36:29.000000', 'consum', 0.0219, 'lps'),
	(668917, 132, '2015-02-01 00:36:30.000000', 'consum', 0.0251, 'lps'),
	(668918, 132, '2015-02-01 00:36:31.000000', 'consum', 0.0272, 'lps'),
	(668919, 132, '2015-02-01 00:36:32.000000', 'consum', 0.0283, 'lps'),
	(668920, 132, '2015-02-01 00:36:33.000000', 'consum', 0.0274, 'lps'),
	(668921, 132, '2015-02-01 00:36:34.000000', 'consum', 0.0310, 'lps'),
	(668922, 132, '2015-02-01 00:36:35.000000', 'consum', 0.0286, 'lps'),
	(668923, 132, '2015-02-01 00:36:36.000000', 'consum', 0.0291, 'lps'),
	(668924, 132, '2015-02-01 00:36:37.000000', 'consum', 0.0270, 'lps'),
	(668925, 132, '2015-02-01 00:36:38.000000', 'consum', 0.0268, 'lps'),
	(668926, 132, '2015-02-01 00:36:39.000000', 'consum', 0.0321, 'lps'),
	(668927, 132, '2015-02-01 00:36:40.000000', 'consum', 0.0244, 'lps'),
	(668928, 132, '2015-02-01 00:36:41.000000', 'consum', 0.0280, 'lps'),
	(668929, 132, '2015-02-01 00:36:42.000000', 'consum', 0.0227, 'lps'),
	(668930, 132, '2015-02-01 00:36:43.000000', 'consum', 0.0315, 'lps'),
	(668931, 132, '2015-02-01 00:36:44.000000', 'consum', 0.0221, 'lps'),
	(668932, 132, '2015-02-01 00:36:45.000000', 'consum', 0.0301, 'lps'),
	(668933, 132, '2015-02-01 00:36:46.000000', 'consum', 0.0282, 'lps'),
	(668934, 132, '2015-02-01 00:36:47.000000', 'consum', 0.0299, 'lps'),
	(668935, 132, '2015-02-01 00:36:48.000000', 'consum', 0.0325, 'lps'),
	(668936, 132, '2015-02-01 00:36:49.000000', 'consum', 0.0284, 'lps'),
	(668937, 132, '2015-02-01 00:36:50.000000', 'consum', 0.0238, 'lps'),
	(668938, 132, '2015-02-01 00:36:51.000000', 'consum', 0.0243, 'lps'),
	(668939, 132, '2015-02-01 00:36:52.000000', 'consum', 0.0290, 'lps'),
	(668940, 132, '2015-02-01 00:36:53.000000', 'consum', 0.0281, 'lps'),
	(668941, 132, '2015-02-01 00:36:54.000000', 'consum', 0.0211, 'lps'),
	(668942, 132, '2015-02-01 00:36:55.000000', 'consum', 0.0234, 'lps'),
	(668943, 132, '2015-02-01 00:36:56.000000', 'consum', 0.0210, 'lps'),
	(668944, 132, '2015-02-01 00:36:57.000000', 'consum', 0.0255, 'lps'),
	(668945, 132, '2015-02-01 00:36:58.000000', 'consum', 0.0319, 'lps'),
	(668946, 132, '2015-02-01 00:36:59.000000', 'consum', 0.0274, 'lps'),
	(668947, 132, '2015-02-01 00:37:00.000000', 'consum', 0.0320, 'lps'),
	(668948, 132, '2015-02-01 00:37:01.000000', 'consum', 0.0218, 'lps'),
	(668949, 132, '2015-02-01 00:37:02.000000', 'consum', 0.0269, 'lps'),
	(668950, 132, '2015-02-01 00:37:03.000000', 'consum', 0.0251, 'lps'),
	(668951, 132, '2015-02-01 00:37:04.000000', 'consum', 0.0236, 'lps'),
	(668952, 132, '2015-02-01 00:37:05.000000', 'consum', 0.0218, 'lps'),
	(668953, 132, '2015-02-01 00:37:06.000000', 'consum', 0.0290, 'lps'),
	(668954, 132, '2015-02-01 00:37:07.000000', 'consum', 0.0239, 'lps'),
	(668955, 132, '2015-02-01 00:37:08.000000', 'consum', 0.0229, 'lps'),
	(668956, 132, '2015-02-01 00:37:09.000000', 'consum', 0.0219, 'lps'),
	(668957, 132, '2015-02-01 00:37:10.000000', 'consum', 0.0316, 'lps'),
	(668958, 132, '2015-02-01 00:37:11.000000', 'consum', 0.0248, 'lps'),
	(668959, 132, '2015-02-01 00:37:12.000000', 'consum', 0.0315, 'lps'),
	(668960, 132, '2015-02-01 00:37:13.000000', 'consum', 0.0273, 'lps'),
	(668961, 132, '2015-02-01 00:37:14.000000', 'consum', 0.0325, 'lps'),
	(668962, 132, '2015-02-01 00:37:15.000000', 'consum', 0.0251, 'lps'),
	(668963, 132, '2015-02-01 00:37:16.000000', 'consum', 0.0300, 'lps'),
	(668964, 132, '2015-02-01 00:37:17.000000', 'consum', 0.0305, 'lps'),
	(668965, 132, '2015-02-01 00:37:18.000000', 'consum', 0.0300, 'lps'),
	(668966, 132, '2015-02-01 00:37:19.000000', 'consum', 0.0262, 'lps'),
	(668967, 132, '2015-02-01 00:37:20.000000', 'consum', 0.0314, 'lps'),
	(668968, 132, '2015-02-01 00:37:21.000000', 'consum', 0.0226, 'lps'),
	(668969, 132, '2015-02-01 00:37:22.000000', 'consum', 0.0325, 'lps'),
	(668970, 132, '2015-02-01 00:37:23.000000', 'consum', 0.0277, 'lps'),
	(668971, 132, '2015-02-01 00:37:24.000000', 'consum', 0.0314, 'lps'),
	(668972, 132, '2015-02-01 00:37:25.000000', 'consum', 0.0297, 'lps'),
	(668973, 132, '2015-02-01 00:37:26.000000', 'consum', 0.0218, 'lps'),
	(668974, 132, '2015-02-01 00:37:27.000000', 'consum', 0.0221, 'lps'),
	(668975, 132, '2015-02-01 00:37:28.000000', 'consum', 0.0242, 'lps'),
	(668976, 132, '2015-02-01 00:37:29.000000', 'consum', 0.0220, 'lps'),
	(668977, 132, '2015-02-01 00:37:30.000000', 'consum', 0.0280, 'lps'),
	(668978, 132, '2015-02-01 00:37:31.000000', 'consum', 0.0300, 'lps'),
	(668979, 132, '2015-02-01 00:37:32.000000', 'consum', 0.0217, 'lps'),
	(668980, 132, '2015-02-01 00:37:33.000000', 'consum', 0.0210, 'lps'),
	(668981, 132, '2015-02-01 00:37:34.000000', 'consum', 0.0302, 'lps'),
	(668982, 132, '2015-02-01 00:37:35.000000', 'consum', 0.0210, 'lps'),
	(668983, 132, '2015-02-01 00:37:36.000000', 'consum', 0.0280, 'lps'),
	(668984, 132, '2015-02-01 00:37:37.000000', 'consum', 0.0213, 'lps'),
	(668985, 132, '2015-02-01 00:37:38.000000', 'consum', 0.0250, 'lps'),
	(668986, 132, '2015-02-01 00:37:39.000000', 'consum', 0.0283, 'lps'),
	(668987, 132, '2015-02-01 00:37:40.000000', 'consum', 0.0225, 'lps'),
	(668988, 132, '2015-02-01 00:37:41.000000', 'consum', 0.0297, 'lps'),
	(668989, 132, '2015-02-01 00:37:42.000000', 'consum', 0.0254, 'lps'),
	(668990, 132, '2015-02-01 00:37:43.000000', 'consum', 0.0287, 'lps'),
	(668991, 132, '2015-02-01 00:37:44.000000', 'consum', 0.0228, 'lps'),
	(668992, 132, '2015-02-01 00:37:45.000000', 'consum', 0.0303, 'lps'),
	(668993, 132, '2015-02-01 00:37:46.000000', 'consum', 0.0273, 'lps'),
	(668994, 132, '2015-02-01 00:37:47.000000', 'consum', 0.0248, 'lps'),
	(668995, 132, '2015-02-01 00:37:48.000000', 'consum', 0.0212, 'lps'),
	(668996, 132, '2015-02-01 00:37:49.000000', 'consum', 0.0220, 'lps'),
	(668997, 132, '2015-02-01 00:37:50.000000', 'consum', 0.0257, 'lps'),
	(668998, 132, '2015-02-01 00:37:51.000000', 'consum', 0.0298, 'lps'),
	(668999, 132, '2015-02-01 00:37:52.000000', 'consum', 0.0280, 'lps'),
	(669000, 132, '2015-02-01 00:37:53.000000', 'consum', 0.0295, 'lps'),
	(669001, 132, '2015-02-01 00:37:54.000000', 'consum', 0.0307, 'lps'),
	(669002, 132, '2015-02-01 00:37:55.000000', 'consum', 0.0212, 'lps'),
	(669003, 132, '2015-02-01 00:37:56.000000', 'consum', 0.0276, 'lps'),
	(669004, 132, '2015-02-01 00:37:57.000000', 'consum', 0.0303, 'lps'),
	(669005, 132, '2015-02-01 00:37:58.000000', 'consum', 0.0246, 'lps'),
	(669006, 132, '2015-02-01 00:37:59.000000', 'consum', 0.0226, 'lps'),
	(669007, 132, '2015-02-01 00:38:00.000000', 'consum', 0.0300, 'lps'),
	(669008, 132, '2015-02-01 00:38:01.000000', 'consum', 0.0265, 'lps'),
	(669009, 132, '2015-02-01 00:38:02.000000', 'consum', 0.0216, 'lps'),
	(669010, 132, '2015-02-01 00:38:03.000000', 'consum', 0.0308, 'lps'),
	(669011, 132, '2015-02-01 00:38:04.000000', 'consum', 0.0216, 'lps'),
	(669012, 132, '2015-02-01 00:38:05.000000', 'consum', 0.0294, 'lps'),
	(669013, 132, '2015-02-01 00:38:06.000000', 'consum', 0.0266, 'lps'),
	(669014, 132, '2015-02-01 00:38:07.000000', 'consum', 0.0237, 'lps'),
	(669015, 132, '2015-02-01 00:38:08.000000', 'consum', 0.0296, 'lps'),
	(669016, 132, '2015-02-01 00:38:09.000000', 'consum', 0.0212, 'lps'),
	(669017, 132, '2015-02-01 00:38:10.000000', 'consum', 0.0309, 'lps'),
	(669018, 132, '2015-02-01 00:38:11.000000', 'consum', 0.0237, 'lps'),
	(669019, 132, '2015-02-01 00:38:12.000000', 'consum', 0.0280, 'lps'),
	(669020, 132, '2015-02-01 00:38:13.000000', 'consum', 0.0247, 'lps'),
	(669021, 132, '2015-02-01 00:38:14.000000', 'consum', 0.0303, 'lps'),
	(669022, 132, '2015-02-01 00:38:15.000000', 'consum', 0.0214, 'lps'),
	(669023, 132, '2015-02-01 00:38:16.000000', 'consum', 0.0301, 'lps'),
	(669024, 132, '2015-02-01 00:38:17.000000', 'consum', 0.0304, 'lps'),
	(669025, 132, '2015-02-01 00:38:18.000000', 'consum', 0.0293, 'lps'),
	(669026, 132, '2015-02-01 00:38:19.000000', 'consum', 0.0226, 'lps'),
	(669027, 132, '2015-02-01 00:38:20.000000', 'consum', 0.0273, 'lps'),
	(669028, 132, '2015-02-01 00:38:21.000000', 'consum', 0.0247, 'lps'),
	(669029, 132, '2015-02-01 00:38:22.000000', 'consum', 0.0323, 'lps'),
	(669030, 132, '2015-02-01 00:38:23.000000', 'consum', 0.0314, 'lps'),
	(669031, 132, '2015-02-01 00:38:24.000000', 'consum', 0.0278, 'lps'),
	(669032, 132, '2015-02-01 00:38:25.000000', 'consum', 0.0237, 'lps'),
	(669033, 132, '2015-02-01 00:38:26.000000', 'consum', 0.0259, 'lps'),
	(669034, 132, '2015-02-01 00:38:27.000000', 'consum', 0.0256, 'lps'),
	(669035, 132, '2015-02-01 00:38:28.000000', 'consum', 0.0296, 'lps'),
	(669036, 132, '2015-02-01 00:38:29.000000', 'consum', 0.0269, 'lps'),
	(669037, 132, '2015-02-01 00:38:30.000000', 'consum', 0.0248, 'lps'),
	(669038, 132, '2015-02-01 00:38:31.000000', 'consum', 0.0224, 'lps'),
	(669039, 132, '2015-02-01 00:38:32.000000', 'consum', 0.0283, 'lps'),
	(669040, 132, '2015-02-01 00:38:33.000000', 'consum', 0.0302, 'lps'),
	(669041, 132, '2015-02-01 00:38:34.000000', 'consum', 0.0217, 'lps'),
	(669042, 132, '2015-02-01 00:38:35.000000', 'consum', 0.0321, 'lps'),
	(669043, 132, '2015-02-01 00:38:36.000000', 'consum', 0.0277, 'lps'),
	(669044, 132, '2015-02-01 00:38:37.000000', 'consum', 0.0214, 'lps'),
	(669045, 132, '2015-02-01 00:38:38.000000', 'consum', 0.0262, 'lps'),
	(669046, 132, '2015-02-01 00:38:39.000000', 'consum', 0.0226, 'lps'),
	(669047, 132, '2015-02-01 00:38:40.000000', 'consum', 0.0253, 'lps'),
	(669048, 132, '2015-02-01 00:38:41.000000', 'consum', 0.0258, 'lps'),
	(669049, 132, '2015-02-01 00:38:42.000000', 'consum', 0.0323, 'lps'),
	(669050, 132, '2015-02-01 00:38:43.000000', 'consum', 0.0281, 'lps'),
	(669051, 132, '2015-02-01 00:38:44.000000', 'consum', 0.0230, 'lps'),
	(669052, 132, '2015-02-01 00:38:45.000000', 'consum', 0.0213, 'lps'),
	(669053, 132, '2015-02-01 00:38:46.000000', 'consum', 0.0281, 'lps'),
	(669054, 132, '2015-02-01 00:38:47.000000', 'consum', 0.0323, 'lps'),
	(669055, 132, '2015-02-01 00:38:48.000000', 'consum', 0.0216, 'lps'),
	(669056, 132, '2015-02-01 00:38:49.000000', 'consum', 0.0248, 'lps'),
	(669057, 132, '2015-02-01 00:38:50.000000', 'consum', 0.0267, 'lps'),
	(669058, 132, '2015-02-01 00:38:51.000000', 'consum', 0.0266, 'lps'),
	(669059, 132, '2015-02-01 00:38:52.000000', 'consum', 0.0318, 'lps'),
	(669060, 132, '2015-02-01 00:38:53.000000', 'consum', 0.0234, 'lps'),
	(669061, 132, '2015-02-01 00:38:54.000000', 'consum', 0.0239, 'lps'),
	(669062, 132, '2015-02-01 00:38:55.000000', 'consum', 0.0286, 'lps'),
	(669063, 132, '2015-02-01 00:38:56.000000', 'consum', 0.0270, 'lps'),
	(669064, 132, '2015-02-01 00:38:57.000000', 'consum', 0.0282, 'lps'),
	(669065, 132, '2015-02-01 00:38:58.000000', 'consum', 0.0273, 'lps'),
	(669066, 132, '2015-02-01 00:38:59.000000', 'consum', 0.0311, 'lps'),
	(669067, 132, '2015-02-01 00:39:00.000000', 'consum', 0.0293, 'lps'),
	(669068, 132, '2015-02-01 00:39:01.000000', 'consum', 0.0323, 'lps'),
	(669069, 132, '2015-02-01 00:39:02.000000', 'consum', 0.0295, 'lps'),
	(669070, 132, '2015-02-01 00:39:03.000000', 'consum', 0.0298, 'lps'),
	(669071, 132, '2015-02-01 00:39:04.000000', 'consum', 0.0278, 'lps'),
	(669072, 132, '2015-02-01 00:39:05.000000', 'consum', 0.0286, 'lps'),
	(669073, 132, '2015-02-01 00:39:06.000000', 'consum', 0.0272, 'lps'),
	(669074, 132, '2015-02-01 00:39:07.000000', 'consum', 0.0292, 'lps'),
	(669075, 132, '2015-02-01 00:39:08.000000', 'consum', 0.0318, 'lps'),
	(669076, 132, '2015-02-01 00:39:09.000000', 'consum', 0.0275, 'lps'),
	(669077, 132, '2015-02-01 00:39:10.000000', 'consum', 0.0325, 'lps'),
	(669078, 132, '2015-02-01 00:39:11.000000', 'consum', 0.0242, 'lps'),
	(669079, 132, '2015-02-01 00:39:12.000000', 'consum', 0.0259, 'lps'),
	(669080, 132, '2015-02-01 00:39:13.000000', 'consum', 0.0241, 'lps'),
	(669081, 132, '2015-02-01 00:39:14.000000', 'consum', 0.0222, 'lps'),
	(669082, 132, '2015-02-01 00:39:15.000000', 'consum', 0.0291, 'lps'),
	(669083, 132, '2015-02-01 00:39:16.000000', 'consum', 0.0231, 'lps'),
	(669084, 132, '2015-02-01 00:39:17.000000', 'consum', 0.0305, 'lps'),
	(669085, 132, '2015-02-01 00:39:18.000000', 'consum', 0.0275, 'lps'),
	(669086, 132, '2015-02-01 00:39:19.000000', 'consum', 0.0250, 'lps'),
	(669087, 132, '2015-02-01 00:39:20.000000', 'consum', 0.0217, 'lps'),
	(669088, 132, '2015-02-01 00:39:21.000000', 'consum', 0.0241, 'lps'),
	(669089, 132, '2015-02-01 00:39:22.000000', 'consum', 0.0228, 'lps'),
	(669090, 132, '2015-02-01 00:39:23.000000', 'consum', 0.0323, 'lps'),
	(669091, 132, '2015-02-01 00:39:24.000000', 'consum', 0.0257, 'lps'),
	(669092, 132, '2015-02-01 00:39:25.000000', 'consum', 0.0225, 'lps'),
	(669093, 132, '2015-02-01 00:39:26.000000', 'consum', 0.0260, 'lps'),
	(669094, 132, '2015-02-01 00:39:27.000000', 'consum', 0.0298, 'lps'),
	(669095, 132, '2015-02-01 00:39:28.000000', 'consum', 0.0267, 'lps'),
	(669096, 132, '2015-02-01 00:39:29.000000', 'consum', 0.0235, 'lps'),
	(669097, 132, '2015-02-01 00:39:30.000000', 'consum', 0.0279, 'lps'),
	(669098, 132, '2015-02-01 00:39:31.000000', 'consum', 0.0247, 'lps'),
	(669099, 132, '2015-02-01 00:39:32.000000', 'consum', 0.0307, 'lps'),
	(669100, 132, '2015-02-01 00:39:33.000000', 'consum', 0.0236, 'lps'),
	(669101, 132, '2015-02-01 00:39:34.000000', 'consum', 0.0283, 'lps'),
	(669102, 132, '2015-02-01 00:39:35.000000', 'consum', 0.0262, 'lps'),
	(669103, 132, '2015-02-01 00:39:36.000000', 'consum', 0.0254, 'lps'),
	(669104, 132, '2015-02-01 00:39:37.000000', 'consum', 0.0274, 'lps'),
	(669105, 132, '2015-02-01 00:39:38.000000', 'consum', 0.0283, 'lps'),
	(669106, 132, '2015-02-01 00:39:39.000000', 'consum', 0.0268, 'lps'),
	(669107, 132, '2015-02-01 00:39:40.000000', 'consum', 0.0282, 'lps'),
	(669108, 132, '2015-02-01 00:39:41.000000', 'consum', 0.0279, 'lps'),
	(669109, 132, '2015-02-01 00:39:42.000000', 'consum', 0.0224, 'lps'),
	(669110, 132, '2015-02-01 00:39:43.000000', 'consum', 0.0305, 'lps'),
	(669111, 132, '2015-02-01 00:39:44.000000', 'consum', 0.0297, 'lps'),
	(669112, 132, '2015-02-01 00:39:45.000000', 'consum', 0.0246, 'lps'),
	(669113, 132, '2015-02-01 00:39:46.000000', 'consum', 0.0243, 'lps'),
	(669114, 132, '2015-02-01 00:39:47.000000', 'consum', 0.0268, 'lps'),
	(669115, 132, '2015-02-01 00:39:48.000000', 'consum', 0.0288, 'lps'),
	(669116, 132, '2015-02-01 00:39:49.000000', 'consum', 0.0307, 'lps'),
	(669117, 132, '2015-02-01 00:39:50.000000', 'consum', 0.0230, 'lps'),
	(669118, 132, '2015-02-01 00:39:51.000000', 'consum', 0.0252, 'lps'),
	(669119, 132, '2015-02-01 00:39:52.000000', 'consum', 0.0242, 'lps'),
	(669120, 132, '2015-02-01 00:39:53.000000', 'consum', 0.0248, 'lps'),
	(669121, 132, '2015-02-01 00:39:54.000000', 'consum', 0.0304, 'lps'),
	(669122, 132, '2015-02-01 00:39:55.000000', 'consum', 0.0219, 'lps'),
	(669123, 132, '2015-02-01 00:39:56.000000', 'consum', 0.0321, 'lps'),
	(669124, 132, '2015-02-01 00:39:57.000000', 'consum', 0.0275, 'lps'),
	(669125, 132, '2015-02-01 00:39:58.000000', 'consum', 0.0319, 'lps'),
	(669126, 132, '2015-02-01 00:39:59.000000', 'consum', 0.0212, 'lps'),
	(669127, 132, '2015-02-01 00:40:00.000000', 'consum', 0.0240, 'lps'),
	(669128, 132, '2015-02-01 00:40:01.000000', 'consum', 0.0240, 'lps'),
	(669129, 132, '2015-02-01 00:40:02.000000', 'consum', 0.0270, 'lps'),
	(669130, 132, '2015-02-01 00:40:03.000000', 'consum', 0.0304, 'lps'),
	(669131, 132, '2015-02-01 00:40:04.000000', 'consum', 0.0269, 'lps'),
	(669132, 132, '2015-02-01 00:40:05.000000', 'consum', 0.0222, 'lps'),
	(669133, 132, '2015-02-01 00:40:06.000000', 'consum', 0.0212, 'lps'),
	(669134, 132, '2015-02-01 00:40:07.000000', 'consum', 0.0298, 'lps'),
	(669135, 132, '2015-02-01 00:40:08.000000', 'consum', 0.0297, 'lps'),
	(669136, 132, '2015-02-01 00:40:09.000000', 'consum', 0.0264, 'lps'),
	(669137, 132, '2015-02-01 00:40:10.000000', 'consum', 0.0221, 'lps'),
	(669138, 132, '2015-02-01 00:40:11.000000', 'consum', 0.0220, 'lps'),
	(669139, 132, '2015-02-01 00:40:12.000000', 'consum', 0.0229, 'lps'),
	(669140, 132, '2015-02-01 00:40:13.000000', 'consum', 0.0272, 'lps'),
	(669141, 132, '2015-02-01 00:40:14.000000', 'consum', 0.0235, 'lps'),
	(669142, 132, '2015-02-01 00:40:15.000000', 'consum', 0.0262, 'lps'),
	(669143, 132, '2015-02-01 00:40:16.000000', 'consum', 0.0283, 'lps'),
	(669144, 132, '2015-02-01 00:40:17.000000', 'consum', 0.0301, 'lps'),
	(669145, 132, '2015-02-01 00:40:18.000000', 'consum', 0.0215, 'lps'),
	(669146, 132, '2015-02-01 00:40:19.000000', 'consum', 0.0312, 'lps'),
	(669147, 132, '2015-02-01 00:40:20.000000', 'consum', 0.0240, 'lps'),
	(669148, 132, '2015-02-01 00:40:21.000000', 'consum', 0.0289, 'lps'),
	(669149, 132, '2015-02-01 00:40:22.000000', 'consum', 0.0281, 'lps'),
	(669150, 132, '2015-02-01 00:40:23.000000', 'consum', 0.0213, 'lps'),
	(669151, 132, '2015-02-01 00:40:24.000000', 'consum', 0.0243, 'lps'),
	(669152, 132, '2015-02-01 00:40:25.000000', 'consum', 0.0253, 'lps'),
	(669153, 132, '2015-02-01 00:40:26.000000', 'consum', 0.0324, 'lps'),
	(669154, 132, '2015-02-01 00:40:27.000000', 'consum', 0.0303, 'lps'),
	(669155, 132, '2015-02-01 00:40:28.000000', 'consum', 0.0218, 'lps'),
	(669156, 132, '2015-02-01 00:40:29.000000', 'consum', 0.0319, 'lps'),
	(669157, 132, '2015-02-01 00:40:30.000000', 'consum', 0.0268, 'lps'),
	(669158, 132, '2015-02-01 00:40:31.000000', 'consum', 0.0289, 'lps'),
	(669159, 132, '2015-02-01 00:40:32.000000', 'consum', 0.0314, 'lps'),
	(669160, 132, '2015-02-01 00:40:33.000000', 'consum', 0.0265, 'lps'),
	(669161, 132, '2015-02-01 00:40:34.000000', 'consum', 0.0287, 'lps'),
	(669162, 132, '2015-02-01 00:40:35.000000', 'consum', 0.0316, 'lps'),
	(669163, 132, '2015-02-01 00:40:36.000000', 'consum', 0.0279, 'lps'),
	(669164, 132, '2015-02-01 00:40:37.000000', 'consum', 0.0236, 'lps'),
	(669165, 132, '2015-02-01 00:40:38.000000', 'consum', 0.0250, 'lps'),
	(669166, 132, '2015-02-01 00:40:39.000000', 'consum', 0.0217, 'lps'),
	(669167, 132, '2015-02-01 00:40:40.000000', 'consum', 0.0241, 'lps'),
	(669168, 132, '2015-02-01 00:40:41.000000', 'consum', 0.0228, 'lps'),
	(669169, 132, '2015-02-01 00:40:42.000000', 'consum', 0.0324, 'lps'),
	(669170, 132, '2015-02-01 00:40:43.000000', 'consum', 0.0263, 'lps'),
	(669171, 132, '2015-02-01 00:40:44.000000', 'consum', 0.0248, 'lps'),
	(669172, 132, '2015-02-01 00:40:45.000000', 'consum', 0.0244, 'lps'),
	(669173, 132, '2015-02-01 00:40:46.000000', 'consum', 0.0266, 'lps'),
	(669174, 132, '2015-02-01 00:40:47.000000', 'consum', 0.0270, 'lps'),
	(669175, 132, '2015-02-01 00:40:48.000000', 'consum', 0.0227, 'lps'),
	(669176, 132, '2015-02-01 00:40:49.000000', 'consum', 0.0233, 'lps'),
	(669177, 132, '2015-02-01 00:40:50.000000', 'consum', 0.0275, 'lps'),
	(669178, 132, '2015-02-01 00:40:51.000000', 'consum', 0.0235, 'lps'),
	(669179, 132, '2015-02-01 00:40:52.000000', 'consum', 0.0256, 'lps'),
	(669180, 132, '2015-02-01 00:40:53.000000', 'consum', 0.0248, 'lps'),
	(669181, 132, '2015-02-01 00:40:54.000000', 'consum', 0.0264, 'lps'),
	(669182, 132, '2015-02-01 00:40:55.000000', 'consum', 0.0252, 'lps'),
	(669183, 132, '2015-02-01 00:40:56.000000', 'consum', 0.0257, 'lps'),
	(669184, 132, '2015-02-01 00:40:57.000000', 'consum', 0.0320, 'lps'),
	(669185, 132, '2015-02-01 00:40:58.000000', 'consum', 0.0271, 'lps'),
	(669186, 132, '2015-02-01 00:40:59.000000', 'consum', 0.0303, 'lps'),
	(669187, 132, '2015-02-01 00:41:00.000000', 'consum', 0.0259, 'lps'),
	(669188, 132, '2015-02-01 00:41:01.000000', 'consum', 0.0292, 'lps'),
	(669189, 132, '2015-02-01 00:41:02.000000', 'consum', 0.0243, 'lps'),
	(669190, 132, '2015-02-01 00:41:03.000000', 'consum', 0.0245, 'lps'),
	(669191, 132, '2015-02-01 00:41:04.000000', 'consum', 0.0285, 'lps'),
	(669192, 132, '2015-02-01 00:41:05.000000', 'consum', 0.0249, 'lps'),
	(669193, 132, '2015-02-01 00:41:06.000000', 'consum', 0.0299, 'lps'),
	(669194, 132, '2015-02-01 00:41:07.000000', 'consum', 0.0303, 'lps'),
	(669195, 132, '2015-02-01 00:41:08.000000', 'consum', 0.0293, 'lps'),
	(669196, 132, '2015-02-01 00:41:09.000000', 'consum', 0.0233, 'lps'),
	(669197, 132, '2015-02-01 00:41:10.000000', 'consum', 0.0308, 'lps'),
	(669198, 132, '2015-02-01 00:41:11.000000', 'consum', 0.0284, 'lps'),
	(669199, 132, '2015-02-01 00:41:12.000000', 'consum', 0.0286, 'lps'),
	(669200, 132, '2015-02-01 00:41:13.000000', 'consum', 0.0252, 'lps'),
	(669201, 132, '2015-02-01 00:41:14.000000', 'consum', 0.0309, 'lps'),
	(669202, 132, '2015-02-01 00:41:15.000000', 'consum', 0.0233, 'lps'),
	(669203, 132, '2015-02-01 00:41:16.000000', 'consum', 0.0261, 'lps'),
	(669204, 132, '2015-02-01 00:41:17.000000', 'consum', 0.0281, 'lps'),
	(669205, 132, '2015-02-01 00:41:18.000000', 'consum', 0.0294, 'lps'),
	(669206, 132, '2015-02-01 00:41:19.000000', 'consum', 0.0302, 'lps'),
	(669207, 132, '2015-02-01 00:41:20.000000', 'consum', 0.0303, 'lps'),
	(669208, 132, '2015-02-01 00:41:21.000000', 'consum', 0.0282, 'lps'),
	(669209, 132, '2015-02-01 00:41:22.000000', 'consum', 0.0290, 'lps'),
	(669210, 132, '2015-02-01 00:41:23.000000', 'consum', 0.0282, 'lps'),
	(669211, 132, '2015-02-01 00:41:24.000000', 'consum', 0.0211, 'lps'),
	(669212, 132, '2015-02-01 00:41:25.000000', 'consum', 0.0235, 'lps'),
	(669213, 132, '2015-02-01 00:41:26.000000', 'consum', 0.0216, 'lps'),
	(669214, 132, '2015-02-01 00:41:27.000000', 'consum', 0.0280, 'lps'),
	(669215, 132, '2015-02-01 00:41:28.000000', 'consum', 0.0313, 'lps'),
	(669216, 132, '2015-02-01 00:41:29.000000', 'consum', 0.0281, 'lps'),
	(669217, 132, '2015-02-01 00:41:30.000000', 'consum', 0.0256, 'lps'),
	(669218, 132, '2015-02-01 00:41:31.000000', 'consum', 0.0227, 'lps'),
	(669219, 132, '2015-02-01 00:41:32.000000', 'consum', 0.0276, 'lps'),
	(669220, 132, '2015-02-01 00:41:33.000000', 'consum', 0.0256, 'lps'),
	(669221, 132, '2015-02-01 00:41:34.000000', 'consum', 0.0245, 'lps'),
	(669222, 132, '2015-02-01 00:41:35.000000', 'consum', 0.0244, 'lps'),
	(669223, 132, '2015-02-01 00:41:36.000000', 'consum', 0.0279, 'lps'),
	(669224, 132, '2015-02-01 00:41:37.000000', 'consum', 0.0219, 'lps'),
	(669225, 132, '2015-02-01 00:41:38.000000', 'consum', 0.0280, 'lps'),
	(669226, 132, '2015-02-01 00:41:39.000000', 'consum', 0.0304, 'lps'),
	(669227, 132, '2015-02-01 00:41:40.000000', 'consum', 0.0239, 'lps'),
	(669228, 132, '2015-02-01 00:41:41.000000', 'consum', 0.0303, 'lps'),
	(669229, 132, '2015-02-01 00:41:42.000000', 'consum', 0.0239, 'lps'),
	(669230, 132, '2015-02-01 00:41:43.000000', 'consum', 0.0312, 'lps'),
	(669231, 132, '2015-02-01 00:41:44.000000', 'consum', 0.0282, 'lps'),
	(669232, 132, '2015-02-01 00:41:45.000000', 'consum', 0.0267, 'lps'),
	(669233, 132, '2015-02-01 00:41:46.000000', 'consum', 0.0279, 'lps'),
	(669234, 132, '2015-02-01 00:41:47.000000', 'consum', 0.0267, 'lps'),
	(669235, 132, '2015-02-01 00:41:48.000000', 'consum', 0.0292, 'lps'),
	(669236, 132, '2015-02-01 00:41:49.000000', 'consum', 0.0214, 'lps'),
	(669237, 132, '2015-02-01 00:41:50.000000', 'consum', 0.0217, 'lps'),
	(669238, 132, '2015-02-01 00:41:51.000000', 'consum', 0.0234, 'lps'),
	(669239, 132, '2015-02-01 00:41:52.000000', 'consum', 0.0310, 'lps'),
	(669240, 132, '2015-02-01 00:41:53.000000', 'consum', 0.0290, 'lps'),
	(669241, 132, '2015-02-01 00:41:54.000000', 'consum', 0.0312, 'lps'),
	(669242, 132, '2015-02-01 00:41:55.000000', 'consum', 0.0248, 'lps'),
	(669243, 132, '2015-02-01 00:41:56.000000', 'consum', 0.0324, 'lps'),
	(669244, 132, '2015-02-01 00:41:57.000000', 'consum', 0.0322, 'lps'),
	(669245, 132, '2015-02-01 00:41:58.000000', 'consum', 0.0310, 'lps'),
	(669246, 132, '2015-02-01 00:41:59.000000', 'consum', 0.0260, 'lps'),
	(669247, 132, '2015-02-01 00:42:00.000000', 'consum', 0.0274, 'lps'),
	(669248, 132, '2015-02-01 00:42:01.000000', 'consum', 0.0265, 'lps'),
	(669249, 132, '2015-02-01 00:42:02.000000', 'consum', 0.0296, 'lps'),
	(669250, 132, '2015-02-01 00:42:03.000000', 'consum', 0.0242, 'lps'),
	(669251, 132, '2015-02-01 00:42:04.000000', 'consum', 0.0229, 'lps'),
	(669252, 132, '2015-02-01 00:42:05.000000', 'consum', 0.0323, 'lps'),
	(669253, 132, '2015-02-01 00:42:06.000000', 'consum', 0.0258, 'lps'),
	(669254, 132, '2015-02-01 00:42:07.000000', 'consum', 0.0225, 'lps'),
	(669255, 132, '2015-02-01 00:42:08.000000', 'consum', 0.0259, 'lps'),
	(669256, 132, '2015-02-01 00:42:09.000000', 'consum', 0.0294, 'lps'),
	(669257, 132, '2015-02-01 00:42:10.000000', 'consum', 0.0250, 'lps'),
	(669258, 132, '2015-02-01 00:42:11.000000', 'consum', 0.0275, 'lps'),
	(669259, 132, '2015-02-01 00:42:12.000000', 'consum', 0.0301, 'lps'),
	(669260, 132, '2015-02-01 00:42:13.000000', 'consum', 0.0237, 'lps'),
	(669261, 132, '2015-02-01 00:42:14.000000', 'consum', 0.0306, 'lps'),
	(669262, 132, '2015-02-01 00:42:15.000000', 'consum', 0.0260, 'lps'),
	(669263, 132, '2015-02-01 00:42:16.000000', 'consum', 0.0290, 'lps'),
	(669264, 132, '2015-02-01 00:42:17.000000', 'consum', 0.0227, 'lps'),
	(669265, 132, '2015-02-01 00:42:18.000000', 'consum', 0.0288, 'lps'),
	(669266, 132, '2015-02-01 00:42:19.000000', 'consum', 0.0319, 'lps'),
	(669267, 132, '2015-02-01 00:42:20.000000', 'consum', 0.0287, 'lps'),
	(669268, 132, '2015-02-01 00:42:21.000000', 'consum', 0.0268, 'lps'),
	(669269, 132, '2015-02-01 00:42:22.000000', 'consum', 0.0271, 'lps'),
	(669270, 132, '2015-02-01 00:42:23.000000', 'consum', 0.0227, 'lps'),
	(669271, 132, '2015-02-01 00:42:24.000000', 'consum', 0.0228, 'lps'),
	(669272, 132, '2015-02-01 00:42:25.000000', 'consum', 0.0250, 'lps'),
	(669273, 132, '2015-02-01 00:42:26.000000', 'consum', 0.0239, 'lps'),
	(669274, 132, '2015-02-01 00:42:27.000000', 'consum', 0.0237, 'lps'),
	(669275, 132, '2015-02-01 00:42:28.000000', 'consum', 0.0257, 'lps'),
	(669276, 132, '2015-02-01 00:42:29.000000', 'consum', 0.0247, 'lps'),
	(669277, 132, '2015-02-01 00:42:30.000000', 'consum', 0.0258, 'lps'),
	(669278, 132, '2015-02-01 00:42:31.000000', 'consum', 0.0220, 'lps'),
	(669279, 132, '2015-02-01 00:42:32.000000', 'consum', 0.0235, 'lps'),
	(669280, 132, '2015-02-01 00:42:33.000000', 'consum', 0.0303, 'lps'),
	(669281, 132, '2015-02-01 00:42:34.000000', 'consum', 0.0254, 'lps'),
	(669282, 132, '2015-02-01 00:42:35.000000', 'consum', 0.0265, 'lps'),
	(669283, 132, '2015-02-01 00:42:36.000000', 'consum', 0.0240, 'lps'),
	(669284, 132, '2015-02-01 00:42:37.000000', 'consum', 0.0311, 'lps'),
	(669285, 132, '2015-02-01 00:42:38.000000', 'consum', 0.0277, 'lps'),
	(669286, 132, '2015-02-01 00:42:39.000000', 'consum', 0.0244, 'lps'),
	(669287, 132, '2015-02-01 00:42:40.000000', 'consum', 0.0294, 'lps'),
	(669288, 132, '2015-02-01 00:42:41.000000', 'consum', 0.0299, 'lps'),
	(669289, 132, '2015-02-01 00:42:42.000000', 'consum', 0.0285, 'lps'),
	(669290, 132, '2015-02-01 00:42:43.000000', 'consum', 0.0318, 'lps'),
	(669291, 132, '2015-02-01 00:42:44.000000', 'consum', 0.0296, 'lps'),
	(669292, 132, '2015-02-01 00:42:45.000000', 'consum', 0.0313, 'lps'),
	(669293, 132, '2015-02-01 00:42:46.000000', 'consum', 0.0239, 'lps'),
	(669294, 132, '2015-02-01 00:42:47.000000', 'consum', 0.0277, 'lps'),
	(669295, 132, '2015-02-01 00:42:48.000000', 'consum', 0.0227, 'lps'),
	(669296, 132, '2015-02-01 00:42:49.000000', 'consum', 0.0212, 'lps'),
	(669297, 132, '2015-02-01 00:42:50.000000', 'consum', 0.0283, 'lps'),
	(669298, 132, '2015-02-01 00:42:51.000000', 'consum', 0.0224, 'lps'),
	(669299, 132, '2015-02-01 00:42:52.000000', 'consum', 0.0291, 'lps'),
	(669300, 132, '2015-02-01 00:42:53.000000', 'consum', 0.0226, 'lps'),
	(669301, 132, '2015-02-01 00:42:54.000000', 'consum', 0.0282, 'lps'),
	(669302, 132, '2015-02-01 00:42:55.000000', 'consum', 0.0288, 'lps'),
	(669303, 132, '2015-02-01 00:42:56.000000', 'consum', 0.0268, 'lps'),
	(669304, 132, '2015-02-01 00:42:57.000000', 'consum', 0.0265, 'lps'),
	(669305, 132, '2015-02-01 00:42:58.000000', 'consum', 0.0315, 'lps'),
	(669306, 132, '2015-02-01 00:42:59.000000', 'consum', 0.0221, 'lps'),
	(669307, 132, '2015-02-01 00:43:00.000000', 'consum', 0.0300, 'lps'),
	(669308, 132, '2015-02-01 00:43:01.000000', 'consum', 0.0279, 'lps'),
	(669309, 132, '2015-02-01 00:43:02.000000', 'consum', 0.0285, 'lps'),
	(669310, 132, '2015-02-01 00:43:03.000000', 'consum', 0.0262, 'lps'),
	(669311, 132, '2015-02-01 00:43:04.000000', 'consum', 0.0248, 'lps'),
	(669312, 132, '2015-02-01 00:43:05.000000', 'consum', 0.0243, 'lps'),
	(669313, 132, '2015-02-01 00:43:06.000000', 'consum', 0.0260, 'lps'),
	(669314, 132, '2015-02-01 00:43:07.000000', 'consum', 0.0248, 'lps'),
	(669315, 132, '2015-02-01 00:43:08.000000', 'consum', 0.0251, 'lps'),
	(669316, 132, '2015-02-01 00:43:09.000000', 'consum', 0.0302, 'lps'),
	(669317, 132, '2015-02-01 00:43:10.000000', 'consum', 0.0313, 'lps'),
	(669318, 132, '2015-02-01 00:43:11.000000', 'consum', 0.0219, 'lps'),
	(669319, 132, '2015-02-01 00:43:12.000000', 'consum', 0.0296, 'lps'),
	(669320, 132, '2015-02-01 00:43:13.000000', 'consum', 0.0264, 'lps'),
	(669321, 132, '2015-02-01 00:43:14.000000', 'consum', 0.0224, 'lps'),
	(669322, 132, '2015-02-01 00:43:15.000000', 'consum', 0.0233, 'lps'),
	(669323, 132, '2015-02-01 00:43:16.000000', 'consum', 0.0282, 'lps'),
	(669324, 132, '2015-02-01 00:43:17.000000', 'consum', 0.0272, 'lps'),
	(669325, 132, '2015-02-01 00:43:18.000000', 'consum', 0.0304, 'lps'),
	(669326, 132, '2015-02-01 00:43:19.000000', 'consum', 0.0262, 'lps'),
	(669327, 132, '2015-02-01 00:43:20.000000', 'consum', 0.0303, 'lps'),
	(669328, 132, '2015-02-01 00:43:21.000000', 'consum', 0.0288, 'lps'),
	(669329, 132, '2015-02-01 00:43:22.000000', 'consum', 0.0320, 'lps'),
	(669330, 132, '2015-02-01 00:43:23.000000', 'consum', 0.0297, 'lps'),
	(669331, 132, '2015-02-01 00:43:24.000000', 'consum', 0.0315, 'lps'),
	(669332, 132, '2015-02-01 00:43:25.000000', 'consum', 0.0241, 'lps'),
	(669333, 132, '2015-02-01 00:43:26.000000', 'consum', 0.0286, 'lps'),
	(669334, 132, '2015-02-01 00:43:27.000000', 'consum', 0.0262, 'lps'),
	(669335, 132, '2015-02-01 00:43:28.000000', 'consum', 0.0242, 'lps'),
	(669336, 132, '2015-02-01 00:43:29.000000', 'consum', 0.0214, 'lps'),
	(669337, 132, '2015-02-01 00:43:30.000000', 'consum', 0.0253, 'lps'),
	(669338, 132, '2015-02-01 00:43:31.000000', 'consum', 0.0299, 'lps'),
	(669339, 132, '2015-02-01 00:43:32.000000', 'consum', 0.0291, 'lps'),
	(669340, 132, '2015-02-01 00:43:33.000000', 'consum', 0.0233, 'lps'),
	(669341, 132, '2015-02-01 00:43:34.000000', 'consum', 0.0314, 'lps'),
	(669342, 132, '2015-02-01 00:43:35.000000', 'consum', 0.0314, 'lps'),
	(669343, 132, '2015-02-01 00:43:36.000000', 'consum', 0.0303, 'lps'),
	(669344, 132, '2015-02-01 00:43:37.000000', 'consum', 0.0246, 'lps'),
	(669345, 132, '2015-02-01 00:43:38.000000', 'consum', 0.0228, 'lps'),
	(669346, 132, '2015-02-01 00:43:39.000000', 'consum', 0.0309, 'lps'),
	(669347, 132, '2015-02-01 00:43:40.000000', 'consum', 0.0302, 'lps'),
	(669348, 132, '2015-02-01 00:43:41.000000', 'consum', 0.0260, 'lps'),
	(669349, 132, '2015-02-01 00:43:42.000000', 'consum', 0.0301, 'lps'),
	(669350, 132, '2015-02-01 00:43:43.000000', 'consum', 0.0281, 'lps'),
	(669351, 132, '2015-02-01 00:43:44.000000', 'consum', 0.0293, 'lps'),
	(669352, 132, '2015-02-01 00:43:45.000000', 'consum', 0.0296, 'lps'),
	(669353, 132, '2015-02-01 00:43:46.000000', 'consum', 0.0278, 'lps'),
	(669354, 132, '2015-02-01 00:43:47.000000', 'consum', 0.0292, 'lps'),
	(669355, 132, '2015-02-01 00:43:48.000000', 'consum', 0.0300, 'lps'),
	(669356, 132, '2015-02-01 00:43:49.000000', 'consum', 0.0300, 'lps'),
	(669357, 132, '2015-02-01 00:43:50.000000', 'consum', 0.0273, 'lps'),
	(669358, 132, '2015-02-01 00:43:51.000000', 'consum', 0.0254, 'lps'),
	(669359, 132, '2015-02-01 00:43:52.000000', 'consum', 0.0242, 'lps'),
	(669360, 132, '2015-02-01 00:43:53.000000', 'consum', 0.0238, 'lps'),
	(669361, 132, '2015-02-01 00:43:54.000000', 'consum', 0.0256, 'lps'),
	(669362, 132, '2015-02-01 00:43:55.000000', 'consum', 0.0242, 'lps'),
	(669363, 132, '2015-02-01 00:43:56.000000', 'consum', 0.0231, 'lps'),
	(669364, 132, '2015-02-01 00:43:57.000000', 'consum', 0.0220, 'lps'),
	(669365, 132, '2015-02-01 00:43:58.000000', 'consum', 0.0313, 'lps'),
	(669366, 132, '2015-02-01 00:43:59.000000', 'consum', 0.0230, 'lps'),
	(669367, 132, '2015-02-01 00:44:00.000000', 'consum', 0.0233, 'lps'),
	(669368, 132, '2015-02-01 00:44:01.000000', 'consum', 0.0265, 'lps'),
	(669369, 132, '2015-02-01 00:44:02.000000', 'consum', 0.0304, 'lps'),
	(669370, 132, '2015-02-01 00:44:03.000000', 'consum', 0.0281, 'lps'),
	(669371, 132, '2015-02-01 00:44:04.000000', 'consum', 0.0284, 'lps'),
	(669372, 132, '2015-02-01 00:44:05.000000', 'consum', 0.0251, 'lps'),
	(669373, 132, '2015-02-01 00:44:06.000000', 'consum', 0.0311, 'lps'),
	(669374, 132, '2015-02-01 00:44:07.000000', 'consum', 0.0242, 'lps'),
	(669375, 132, '2015-02-01 00:44:08.000000', 'consum', 0.0301, 'lps'),
	(669376, 132, '2015-02-01 00:44:09.000000', 'consum', 0.0219, 'lps'),
	(669377, 132, '2015-02-01 00:44:10.000000', 'consum', 0.0218, 'lps'),
	(669378, 132, '2015-02-01 00:44:11.000000', 'consum', 0.0221, 'lps'),
	(669379, 132, '2015-02-01 00:44:12.000000', 'consum', 0.0243, 'lps'),
	(669380, 132, '2015-02-01 00:44:13.000000', 'consum', 0.0225, 'lps'),
	(669381, 132, '2015-02-01 00:44:14.000000', 'consum', 0.0304, 'lps'),
	(669382, 132, '2015-02-01 00:44:15.000000', 'consum', 0.0289, 'lps'),
	(669383, 132, '2015-02-01 00:44:16.000000', 'consum', 0.0321, 'lps'),
	(669384, 132, '2015-02-01 00:44:17.000000', 'consum', 0.0296, 'lps'),
	(669385, 132, '2015-02-01 00:44:18.000000', 'consum', 0.0306, 'lps'),
	(669386, 132, '2015-02-01 00:44:19.000000', 'consum', 0.0320, 'lps'),
	(669387, 132, '2015-02-01 00:44:20.000000', 'consum', 0.0238, 'lps'),
	(669388, 132, '2015-02-01 00:44:21.000000', 'consum', 0.0254, 'lps'),
	(669389, 132, '2015-02-01 00:44:22.000000', 'consum', 0.0229, 'lps'),
	(669390, 132, '2015-02-01 00:44:23.000000', 'consum', 0.0289, 'lps'),
	(669391, 132, '2015-02-01 00:44:24.000000', 'consum', 0.0318, 'lps'),
	(669392, 132, '2015-02-01 00:44:25.000000', 'consum', 0.0279, 'lps'),
	(669393, 132, '2015-02-01 00:44:26.000000', 'consum', 0.0233, 'lps'),
	(669394, 132, '2015-02-01 00:44:27.000000', 'consum', 0.0235, 'lps'),
	(669395, 132, '2015-02-01 00:44:28.000000', 'consum', 0.0267, 'lps'),
	(669396, 132, '2015-02-01 00:44:29.000000', 'consum', 0.0303, 'lps'),
	(669397, 132, '2015-02-01 00:44:30.000000', 'consum', 0.0272, 'lps'),
	(669398, 132, '2015-02-01 00:44:31.000000', 'consum', 0.0240, 'lps'),
	(669399, 132, '2015-02-01 00:44:32.000000', 'consum', 0.0294, 'lps'),
	(669400, 132, '2015-02-01 00:44:33.000000', 'consum', 0.0307, 'lps'),
	(669401, 132, '2015-02-01 00:44:34.000000', 'consum', 0.0210, 'lps'),
	(669402, 132, '2015-02-01 00:44:35.000000', 'consum', 0.0270, 'lps'),
	(669403, 132, '2015-02-01 00:44:36.000000', 'consum', 0.0275, 'lps'),
	(669404, 132, '2015-02-01 00:44:37.000000', 'consum', 0.0243, 'lps'),
	(669405, 132, '2015-02-01 00:44:38.000000', 'consum', 0.0295, 'lps'),
	(669406, 132, '2015-02-01 00:44:39.000000', 'consum', 0.0306, 'lps'),
	(669407, 132, '2015-02-01 00:44:40.000000', 'consum', 0.0319, 'lps'),
	(669408, 132, '2015-02-01 00:44:41.000000', 'consum', 0.0237, 'lps'),
	(669409, 132, '2015-02-01 00:44:42.000000', 'consum', 0.0249, 'lps'),
	(669410, 132, '2015-02-01 00:44:43.000000', 'consum', 0.0323, 'lps'),
	(669411, 132, '2015-02-01 00:44:44.000000', 'consum', 0.0310, 'lps'),
	(669412, 132, '2015-02-01 00:44:45.000000', 'consum', 0.0258, 'lps'),
	(669413, 132, '2015-02-01 00:44:46.000000', 'consum', 0.0264, 'lps'),
	(669414, 132, '2015-02-01 00:44:47.000000', 'consum', 0.0223, 'lps'),
	(669415, 132, '2015-02-01 00:44:48.000000', 'consum', 0.0231, 'lps'),
	(669416, 132, '2015-02-01 00:44:49.000000', 'consum', 0.0273, 'lps'),
	(669417, 132, '2015-02-01 00:44:50.000000', 'consum', 0.0233, 'lps'),
	(669418, 132, '2015-02-01 00:44:51.000000', 'consum', 0.0250, 'lps'),
	(669419, 132, '2015-02-01 00:44:52.000000', 'consum', 0.0227, 'lps'),
	(669420, 132, '2015-02-01 00:44:53.000000', 'consum', 0.0291, 'lps'),
	(669421, 132, '2015-02-01 00:44:54.000000', 'consum', 0.0218, 'lps'),
	(669422, 132, '2015-02-01 00:44:55.000000', 'consum', 0.0239, 'lps'),
	(669423, 132, '2015-02-01 00:44:56.000000', 'consum', 0.0216, 'lps'),
	(669424, 132, '2015-02-01 00:44:57.000000', 'consum', 0.0267, 'lps'),
	(669425, 132, '2015-02-01 00:44:58.000000', 'consum', 0.0247, 'lps'),
	(669426, 132, '2015-02-01 00:44:59.000000', 'consum', 0.0226, 'lps'),
	(669427, 132, '2015-02-01 00:45:00.000000', 'consum', 0.0292, 'lps'),
	(669428, 132, '2015-02-01 00:45:01.000000', 'consum', 0.0227, 'lps'),
	(669429, 132, '2015-02-01 00:45:02.000000', 'consum', 0.0282, 'lps'),
	(669430, 132, '2015-02-01 00:45:03.000000', 'consum', 0.0286, 'lps'),
	(669431, 132, '2015-02-01 00:45:04.000000', 'consum', 0.0261, 'lps'),
	(669432, 132, '2015-02-01 00:45:05.000000', 'consum', 0.0235, 'lps'),
	(669433, 132, '2015-02-01 00:45:06.000000', 'consum', 0.0297, 'lps'),
	(669434, 132, '2015-02-01 00:45:07.000000', 'consum', 0.0225, 'lps'),
	(669435, 132, '2015-02-01 00:45:08.000000', 'consum', 0.0255, 'lps'),
	(669436, 132, '2015-02-01 00:45:09.000000', 'consum', 0.0273, 'lps'),
	(669437, 132, '2015-02-01 00:45:10.000000', 'consum', 0.0277, 'lps'),
	(669438, 132, '2015-02-01 00:45:11.000000', 'consum', 0.0238, 'lps'),
	(669439, 132, '2015-02-01 00:45:12.000000', 'consum', 0.0265, 'lps'),
	(669440, 132, '2015-02-01 00:45:13.000000', 'consum', 0.0288, 'lps'),
	(669441, 132, '2015-02-01 00:45:14.000000', 'consum', 0.0318, 'lps'),
	(669442, 132, '2015-02-01 00:45:15.000000', 'consum', 0.0287, 'lps'),
	(669443, 132, '2015-02-01 00:45:16.000000', 'consum', 0.0270, 'lps'),
	(669444, 132, '2015-02-01 00:45:17.000000', 'consum', 0.0278, 'lps'),
	(669445, 132, '2015-02-01 00:45:18.000000', 'consum', 0.0255, 'lps'),
	(669446, 132, '2015-02-01 00:45:19.000000', 'consum', 0.0231, 'lps'),
	(669447, 132, '2015-02-01 00:45:20.000000', 'consum', 0.0298, 'lps'),
	(669448, 132, '2015-02-01 00:45:21.000000', 'consum', 0.0240, 'lps'),
	(669449, 132, '2015-02-01 00:45:22.000000', 'consum', 0.0213, 'lps'),
	(669450, 132, '2015-02-01 00:45:23.000000', 'consum', 0.0252, 'lps'),
	(669451, 132, '2015-02-01 00:45:24.000000', 'consum', 0.0294, 'lps'),
	(669452, 132, '2015-02-01 00:45:25.000000', 'consum', 0.0272, 'lps'),
	(669453, 132, '2015-02-01 00:45:26.000000', 'consum', 0.0267, 'lps'),
	(669454, 132, '2015-02-01 00:45:27.000000', 'consum', 0.0312, 'lps'),
	(669455, 132, '2015-02-01 00:45:28.000000', 'consum', 0.0316, 'lps'),
	(669456, 132, '2015-02-01 00:45:29.000000', 'consum', 0.0320, 'lps'),
	(669457, 132, '2015-02-01 00:45:30.000000', 'consum', 0.0211, 'lps'),
	(669458, 132, '2015-02-01 00:45:31.000000', 'consum', 0.0232, 'lps'),
	(669459, 132, '2015-02-01 00:45:32.000000', 'consum', 0.0320, 'lps'),
	(669460, 132, '2015-02-01 00:45:33.000000', 'consum', 0.0228, 'lps'),
	(669461, 132, '2015-02-01 00:45:34.000000', 'consum', 0.0319, 'lps'),
	(669462, 132, '2015-02-01 00:45:35.000000', 'consum', 0.0237, 'lps'),
	(669463, 132, '2015-02-01 00:45:36.000000', 'consum', 0.0253, 'lps'),
	(669464, 132, '2015-02-01 00:45:37.000000', 'consum', 0.0227, 'lps'),
	(669465, 132, '2015-02-01 00:45:38.000000', 'consum', 0.0282, 'lps'),
	(669466, 132, '2015-02-01 00:45:39.000000', 'consum', 0.0289, 'lps'),
	(669467, 132, '2015-02-01 00:45:40.000000', 'consum', 0.0274, 'lps'),
	(669468, 132, '2015-02-01 00:45:41.000000', 'consum', 0.0291, 'lps'),
	(669469, 132, '2015-02-01 00:45:42.000000', 'consum', 0.0311, 'lps'),
	(669470, 132, '2015-02-01 00:45:43.000000', 'consum', 0.0238, 'lps'),
	(669471, 132, '2015-02-01 00:45:44.000000', 'consum', 0.0279, 'lps'),
	(669472, 132, '2015-02-01 00:45:45.000000', 'consum', 0.0240, 'lps'),
	(669473, 132, '2015-02-01 00:45:46.000000', 'consum', 0.0271, 'lps'),
	(669474, 132, '2015-02-01 00:45:47.000000', 'consum', 0.0308, 'lps'),
	(669475, 132, '2015-02-01 00:45:48.000000', 'consum', 0.0285, 'lps'),
	(669476, 132, '2015-02-01 00:45:49.000000', 'consum', 0.0294, 'lps'),
	(669477, 132, '2015-02-01 00:45:50.000000', 'consum', 0.0289, 'lps'),
	(669478, 132, '2015-02-01 00:45:51.000000', 'consum', 0.0238, 'lps'),
	(669479, 132, '2015-02-01 00:45:52.000000', 'consum', 0.0230, 'lps'),
	(669480, 132, '2015-02-01 00:45:53.000000', 'consum', 0.0224, 'lps'),
	(669481, 132, '2015-02-01 00:45:54.000000', 'consum', 0.0220, 'lps'),
	(669482, 132, '2015-02-01 00:45:55.000000', 'consum', 0.0222, 'lps'),
	(669483, 132, '2015-02-01 00:45:56.000000', 'consum', 0.0237, 'lps'),
	(669484, 132, '2015-02-01 00:45:57.000000', 'consum', 0.0311, 'lps'),
	(669485, 132, '2015-02-01 00:45:58.000000', 'consum', 0.0288, 'lps'),
	(669486, 132, '2015-02-01 00:45:59.000000', 'consum', 0.0295, 'lps'),
	(669487, 132, '2015-02-01 00:46:00.000000', 'consum', 0.0285, 'lps'),
	(669488, 132, '2015-02-01 00:46:01.000000', 'consum', 0.0216, 'lps'),
	(669489, 132, '2015-02-01 00:46:02.000000', 'consum', 0.0247, 'lps'),
	(669490, 132, '2015-02-01 00:46:03.000000', 'consum', 0.0261, 'lps'),
	(669491, 132, '2015-02-01 00:46:04.000000', 'consum', 0.0239, 'lps'),
	(669492, 132, '2015-02-01 00:46:05.000000', 'consum', 0.0319, 'lps'),
	(669493, 132, '2015-02-01 00:46:06.000000', 'consum', 0.0318, 'lps'),
	(669494, 132, '2015-02-01 00:46:07.000000', 'consum', 0.0309, 'lps'),
	(669495, 132, '2015-02-01 00:46:08.000000', 'consum', 0.0266, 'lps'),
	(669496, 132, '2015-02-01 00:46:09.000000', 'consum', 0.0307, 'lps'),
	(669497, 132, '2015-02-01 00:46:10.000000', 'consum', 0.0297, 'lps'),
	(669498, 132, '2015-02-01 00:46:11.000000', 'consum', 0.0240, 'lps'),
	(669499, 132, '2015-02-01 00:46:12.000000', 'consum', 0.0214, 'lps'),
	(669500, 132, '2015-02-01 00:46:13.000000', 'consum', 0.0257, 'lps'),
	(669501, 132, '2015-02-01 00:46:14.000000', 'consum', 0.0317, 'lps'),
	(669502, 132, '2015-02-01 00:46:15.000000', 'consum', 0.0257, 'lps'),
	(669503, 132, '2015-02-01 00:46:16.000000', 'consum', 0.0241, 'lps'),
	(669504, 132, '2015-02-01 00:46:17.000000', 'consum', 0.0222, 'lps'),
	(669505, 132, '2015-02-01 00:46:18.000000', 'consum', 0.0295, 'lps'),
	(669506, 132, '2015-02-01 00:46:19.000000', 'consum', 0.0249, 'lps'),
	(669507, 132, '2015-02-01 00:46:20.000000', 'consum', 0.0270, 'lps'),
	(669508, 132, '2015-02-01 00:46:21.000000', 'consum', 0.0277, 'lps'),
	(669509, 132, '2015-02-01 00:46:22.000000', 'consum', 0.0248, 'lps'),
	(669510, 132, '2015-02-01 00:46:23.000000', 'consum', 0.0316, 'lps'),
	(669511, 132, '2015-02-01 00:46:24.000000', 'consum', 0.0281, 'lps'),
	(669512, 132, '2015-02-01 00:46:25.000000', 'consum', 0.0244, 'lps'),
	(669513, 132, '2015-02-01 00:46:26.000000', 'consum', 0.0284, 'lps'),
	(669514, 132, '2015-02-01 00:46:27.000000', 'consum', 0.0246, 'lps'),
	(669515, 132, '2015-02-01 00:46:28.000000', 'consum', 0.0284, 'lps'),
	(669516, 132, '2015-02-01 00:46:29.000000', 'consum', 0.0241, 'lps'),
	(669517, 132, '2015-02-01 00:46:30.000000', 'consum', 0.0261, 'lps'),
	(669518, 132, '2015-02-01 00:46:31.000000', 'consum', 0.0257, 'lps'),
	(669519, 132, '2015-02-01 00:46:32.000000', 'consum', 0.0291, 'lps'),
	(669520, 132, '2015-02-01 00:46:33.000000', 'consum', 0.0244, 'lps'),
	(669521, 132, '2015-02-01 00:46:34.000000', 'consum', 0.0252, 'lps'),
	(669522, 132, '2015-02-01 00:46:35.000000', 'consum', 0.0320, 'lps'),
	(669523, 132, '2015-02-01 00:46:36.000000', 'consum', 0.0284, 'lps'),
	(669524, 132, '2015-02-01 00:46:37.000000', 'consum', 0.0253, 'lps'),
	(669525, 132, '2015-02-01 00:46:38.000000', 'consum', 0.0317, 'lps'),
	(669526, 132, '2015-02-01 00:46:39.000000', 'consum', 0.0268, 'lps'),
	(669527, 132, '2015-02-01 00:46:40.000000', 'consum', 0.0297, 'lps'),
	(669528, 132, '2015-02-01 00:46:41.000000', 'consum', 0.0238, 'lps'),
	(669529, 132, '2015-02-01 00:46:42.000000', 'consum', 0.0321, 'lps'),
	(669530, 132, '2015-02-01 00:46:43.000000', 'consum', 0.0218, 'lps'),
	(669531, 132, '2015-02-01 00:46:44.000000', 'consum', 0.0267, 'lps'),
	(669532, 132, '2015-02-01 00:46:45.000000', 'consum', 0.0237, 'lps'),
	(669533, 132, '2015-02-01 00:46:46.000000', 'consum', 0.0292, 'lps'),
	(669534, 132, '2015-02-01 00:46:47.000000', 'consum', 0.0307, 'lps'),
	(669535, 132, '2015-02-01 00:46:48.000000', 'consum', 0.0219, 'lps'),
	(669536, 132, '2015-02-01 00:46:49.000000', 'consum', 0.0313, 'lps'),
	(669537, 132, '2015-02-01 00:46:50.000000', 'consum', 0.0235, 'lps'),
	(669538, 132, '2015-02-01 00:46:51.000000', 'consum', 0.0256, 'lps'),
	(669539, 132, '2015-02-01 00:46:52.000000', 'consum', 0.0250, 'lps'),
	(669540, 132, '2015-02-01 00:46:53.000000', 'consum', 0.0271, 'lps'),
	(669541, 132, '2015-02-01 00:46:54.000000', 'consum', 0.0281, 'lps'),
	(669542, 132, '2015-02-01 00:46:55.000000', 'consum', 0.0266, 'lps'),
	(669543, 132, '2015-02-01 00:46:56.000000', 'consum', 0.0278, 'lps'),
	(669544, 132, '2015-02-01 00:46:57.000000', 'consum', 0.0265, 'lps'),
	(669545, 132, '2015-02-01 00:46:58.000000', 'consum', 0.0284, 'lps'),
	(669546, 132, '2015-02-01 00:46:59.000000', 'consum', 0.0298, 'lps'),
	(669547, 132, '2015-02-01 00:47:00.000000', 'consum', 0.0312, 'lps'),
	(669548, 132, '2015-02-01 00:47:01.000000', 'consum', 0.0227, 'lps'),
	(669549, 132, '2015-02-01 00:47:02.000000', 'consum', 0.0219, 'lps'),
	(669550, 132, '2015-02-01 00:47:03.000000', 'consum', 0.0322, 'lps'),
	(669551, 132, '2015-02-01 00:47:04.000000', 'consum', 0.0278, 'lps'),
	(669552, 132, '2015-02-01 00:47:05.000000', 'consum', 0.0216, 'lps'),
	(669553, 132, '2015-02-01 00:47:06.000000', 'consum', 0.0267, 'lps'),
	(669554, 132, '2015-02-01 00:47:07.000000', 'consum', 0.0245, 'lps'),
	(669555, 132, '2015-02-01 00:47:08.000000', 'consum', 0.0214, 'lps'),
	(669556, 132, '2015-02-01 00:47:09.000000', 'consum', 0.0242, 'lps'),
	(669557, 132, '2015-02-01 00:47:10.000000', 'consum', 0.0242, 'lps'),
	(669558, 132, '2015-02-01 00:47:11.000000', 'consum', 0.0276, 'lps'),
	(669559, 132, '2015-02-01 00:47:12.000000', 'consum', 0.0213, 'lps'),
	(669560, 132, '2015-02-01 00:47:13.000000', 'consum', 0.0257, 'lps'),
	(669561, 132, '2015-02-01 00:47:14.000000', 'consum', 0.0321, 'lps'),
	(669562, 132, '2015-02-01 00:47:15.000000', 'consum', 0.0278, 'lps'),
	(669563, 132, '2015-02-01 00:47:16.000000', 'consum', 0.0216, 'lps'),
	(669564, 132, '2015-02-01 00:47:17.000000', 'consum', 0.0268, 'lps'),
	(669565, 132, '2015-02-01 00:47:18.000000', 'consum', 0.0251, 'lps'),
	(669566, 132, '2015-02-01 00:47:19.000000', 'consum', 0.0241, 'lps'),
	(669567, 132, '2015-02-01 00:47:20.000000', 'consum', 0.0242, 'lps'),
	(669568, 132, '2015-02-01 00:47:21.000000', 'consum', 0.0279, 'lps'),
	(669569, 132, '2015-02-01 00:47:22.000000', 'consum', 0.0229, 'lps'),
	(669570, 132, '2015-02-01 00:47:23.000000', 'consum', 0.0213, 'lps'),
	(669571, 132, '2015-02-01 00:47:24.000000', 'consum', 0.0283, 'lps'),
	(669572, 132, '2015-02-01 00:47:25.000000', 'consum', 0.0218, 'lps'),
	(669573, 132, '2015-02-01 00:47:26.000000', 'consum', 0.0267, 'lps'),
	(669574, 132, '2015-02-01 00:47:27.000000', 'consum', 0.0236, 'lps'),
	(669575, 132, '2015-02-01 00:47:28.000000', 'consum', 0.0287, 'lps'),
	(669576, 132, '2015-02-01 00:47:29.000000', 'consum', 0.0284, 'lps'),
	(669577, 132, '2015-02-01 00:47:30.000000', 'consum', 0.0232, 'lps'),
	(669578, 132, '2015-02-01 00:47:31.000000', 'consum', 0.0218, 'lps'),
	(669579, 132, '2015-02-01 00:47:32.000000', 'consum', 0.0299, 'lps'),
	(669580, 132, '2015-02-01 00:47:33.000000', 'consum', 0.0285, 'lps'),
	(669581, 132, '2015-02-01 00:47:34.000000', 'consum', 0.0318, 'lps'),
	(669582, 132, '2015-02-01 00:47:35.000000', 'consum', 0.0292, 'lps'),
	(669583, 132, '2015-02-01 00:47:36.000000', 'consum', 0.0297, 'lps'),
	(669584, 132, '2015-02-01 00:47:37.000000', 'consum', 0.0283, 'lps'),
	(669585, 132, '2015-02-01 00:47:38.000000', 'consum', 0.0316, 'lps'),
	(669586, 132, '2015-02-01 00:47:39.000000', 'consum', 0.0291, 'lps'),
	(669587, 132, '2015-02-01 00:47:40.000000', 'consum', 0.0295, 'lps'),
	(669588, 132, '2015-02-01 00:47:41.000000', 'consum', 0.0279, 'lps'),
	(669589, 132, '2015-02-01 00:47:42.000000', 'consum', 0.0300, 'lps'),
	(669590, 132, '2015-02-01 00:47:43.000000', 'consum', 0.0221, 'lps'),
	(669591, 132, '2015-02-01 00:47:44.000000', 'consum', 0.0228, 'lps'),
	(669592, 132, '2015-02-01 00:47:45.000000', 'consum', 0.0266, 'lps'),
	(669593, 132, '2015-02-01 00:47:46.000000', 'consum', 0.0320, 'lps'),
	(669594, 132, '2015-02-01 00:47:47.000000', 'consum', 0.0246, 'lps'),
	(669595, 132, '2015-02-01 00:47:48.000000', 'consum', 0.0291, 'lps'),
	(669596, 132, '2015-02-01 00:47:49.000000', 'consum', 0.0275, 'lps'),
	(669597, 132, '2015-02-01 00:47:50.000000', 'consum', 0.0293, 'lps'),
	(669598, 132, '2015-02-01 00:47:51.000000', 'consum', 0.0315, 'lps'),
	(669599, 132, '2015-02-01 00:47:52.000000', 'consum', 0.0253, 'lps'),
	(669600, 132, '2015-02-01 00:47:53.000000', 'consum', 0.0226, 'lps'),
	(669601, 132, '2015-02-01 00:47:54.000000', 'consum', 0.0280, 'lps'),
	(669602, 132, '2015-02-01 00:47:55.000000', 'consum', 0.0279, 'lps'),
	(669603, 132, '2015-02-01 00:47:56.000000', 'consum', 0.0230, 'lps'),
	(669604, 132, '2015-02-01 00:47:57.000000', 'consum', 0.0219, 'lps'),
	(669605, 132, '2015-02-01 00:47:58.000000', 'consum', 0.0311, 'lps'),
	(669606, 132, '2015-02-01 00:47:59.000000', 'consum', 0.0224, 'lps'),
	(669607, 132, '2015-02-01 00:48:00.000000', 'consum', 0.0212, 'lps'),
	(669608, 132, '2015-02-01 00:48:01.000000', 'consum', 0.0293, 'lps'),
	(669609, 132, '2015-02-01 00:48:02.000000', 'consum', 0.0272, 'lps'),
	(669610, 132, '2015-02-01 00:48:03.000000', 'consum', 0.0273, 'lps'),
	(669611, 132, '2015-02-01 00:48:04.000000', 'consum', 0.0220, 'lps'),
	(669612, 132, '2015-02-01 00:48:05.000000', 'consum', 0.0306, 'lps'),
	(669613, 132, '2015-02-01 00:48:06.000000', 'consum', 0.0314, 'lps'),
	(669614, 132, '2015-02-01 00:48:07.000000', 'consum', 0.0325, 'lps'),
	(669615, 132, '2015-02-01 00:48:08.000000', 'consum', 0.0240, 'lps'),
	(669616, 132, '2015-02-01 00:48:09.000000', 'consum', 0.0249, 'lps'),
	(669617, 132, '2015-02-01 00:48:10.000000', 'consum', 0.0315, 'lps'),
	(669618, 132, '2015-02-01 00:48:11.000000', 'consum', 0.0269, 'lps'),
	(669619, 132, '2015-02-01 00:48:12.000000', 'consum', 0.0309, 'lps'),
	(669620, 132, '2015-02-01 00:48:13.000000', 'consum', 0.0295, 'lps'),
	(669621, 132, '2015-02-01 00:48:14.000000', 'consum', 0.0225, 'lps'),
	(669622, 132, '2015-02-01 00:48:15.000000', 'consum', 0.0261, 'lps'),
	(669623, 132, '2015-02-01 00:48:16.000000', 'consum', 0.0305, 'lps'),
	(669624, 132, '2015-02-01 00:48:17.000000', 'consum', 0.0301, 'lps'),
	(669625, 132, '2015-02-01 00:48:18.000000', 'consum', 0.0263, 'lps'),
	(669626, 132, '2015-02-01 00:48:19.000000', 'consum', 0.0317, 'lps'),
	(669627, 132, '2015-02-01 00:48:20.000000', 'consum', 0.0242, 'lps'),
	(669628, 132, '2015-02-01 00:48:21.000000', 'consum', 0.0279, 'lps'),
	(669629, 132, '2015-02-01 00:48:22.000000', 'consum', 0.0229, 'lps'),
	(669630, 132, '2015-02-01 00:48:23.000000', 'consum', 0.0216, 'lps'),
	(669631, 132, '2015-02-01 00:48:24.000000', 'consum', 0.0296, 'lps'),
	(669632, 132, '2015-02-01 00:48:25.000000', 'consum', 0.0277, 'lps'),
	(669633, 132, '2015-02-01 00:48:26.000000', 'consum', 0.0285, 'lps'),
	(669634, 132, '2015-02-01 00:48:27.000000', 'consum', 0.0270, 'lps'),
	(669635, 132, '2015-02-01 00:48:28.000000', 'consum', 0.0286, 'lps'),
	(669636, 132, '2015-02-01 00:48:29.000000', 'consum', 0.0296, 'lps'),
	(669637, 132, '2015-02-01 00:48:30.000000', 'consum', 0.0295, 'lps'),
	(669638, 132, '2015-02-01 00:48:31.000000', 'consum', 0.0260, 'lps'),
	(669639, 132, '2015-02-01 00:48:32.000000', 'consum', 0.0325, 'lps'),
	(669640, 132, '2015-02-01 00:48:33.000000', 'consum', 0.0284, 'lps'),
	(669641, 132, '2015-02-01 00:48:34.000000', 'consum', 0.0237, 'lps'),
	(669642, 132, '2015-02-01 00:48:35.000000', 'consum', 0.0239, 'lps'),
	(669643, 132, '2015-02-01 00:48:36.000000', 'consum', 0.0273, 'lps'),
	(669644, 132, '2015-02-01 00:48:37.000000', 'consum', 0.0325, 'lps'),
	(669645, 132, '2015-02-01 00:48:38.000000', 'consum', 0.0247, 'lps'),
	(669646, 132, '2015-02-01 00:48:39.000000', 'consum', 0.0283, 'lps'),
	(669647, 132, '2015-02-01 00:48:40.000000', 'consum', 0.0231, 'lps'),
	(669648, 132, '2015-02-01 00:48:41.000000', 'consum', 0.0213, 'lps'),
	(669649, 132, '2015-02-01 00:48:42.000000', 'consum', 0.0278, 'lps'),
	(669650, 132, '2015-02-01 00:48:43.000000', 'consum', 0.0308, 'lps'),
	(669651, 132, '2015-02-01 00:48:44.000000', 'consum', 0.0267, 'lps'),
	(669652, 132, '2015-02-01 00:48:45.000000', 'consum', 0.0316, 'lps'),
	(669653, 132, '2015-02-01 00:48:46.000000', 'consum', 0.0220, 'lps'),
	(669654, 132, '2015-02-01 00:48:47.000000', 'consum', 0.0292, 'lps'),
	(669655, 132, '2015-02-01 00:48:48.000000', 'consum', 0.0241, 'lps'),
	(669656, 132, '2015-02-01 00:48:49.000000', 'consum', 0.0236, 'lps'),
	(669657, 132, '2015-02-01 00:48:50.000000', 'consum', 0.0246, 'lps'),
	(669658, 132, '2015-02-01 00:48:51.000000', 'consum', 0.0313, 'lps'),
	(669659, 132, '2015-02-01 00:48:52.000000', 'consum', 0.0268, 'lps'),
	(669660, 132, '2015-02-01 00:48:53.000000', 'consum', 0.0310, 'lps'),
	(669661, 132, '2015-02-01 00:48:54.000000', 'consum', 0.0305, 'lps'),
	(669662, 132, '2015-02-01 00:48:55.000000', 'consum', 0.0269, 'lps'),
	(669663, 132, '2015-02-01 00:48:56.000000', 'consum', 0.0222, 'lps'),
	(669664, 132, '2015-02-01 00:48:57.000000', 'consum', 0.0323, 'lps'),
	(669665, 132, '2015-02-01 00:48:58.000000', 'consum', 0.0278, 'lps'),
	(669666, 132, '2015-02-01 00:48:59.000000', 'consum', 0.0324, 'lps'),
	(669667, 132, '2015-02-01 00:49:00.000000', 'consum', 0.0232, 'lps'),
	(669668, 132, '2015-02-01 00:49:01.000000', 'consum', 0.0325, 'lps'),
	(669669, 132, '2015-02-01 00:49:02.000000', 'consum', 0.0257, 'lps'),
	(669670, 132, '2015-02-01 00:49:03.000000', 'consum', 0.0214, 'lps'),
	(669671, 132, '2015-02-01 00:49:04.000000', 'consum', 0.0322, 'lps'),
	(669672, 132, '2015-02-01 00:49:05.000000', 'consum', 0.0295, 'lps'),
	(669673, 132, '2015-02-01 00:49:06.000000', 'consum', 0.0297, 'lps'),
	(669674, 132, '2015-02-01 00:49:07.000000', 'consum', 0.0278, 'lps'),
	(669675, 132, '2015-02-01 00:49:08.000000', 'consum', 0.0289, 'lps'),
	(669676, 132, '2015-02-01 00:49:09.000000', 'consum', 0.0287, 'lps'),
	(669677, 132, '2015-02-01 00:49:10.000000', 'consum', 0.0240, 'lps'),
	(669678, 132, '2015-02-01 00:49:11.000000', 'consum', 0.0246, 'lps'),
	(669679, 132, '2015-02-01 00:49:12.000000', 'consum', 0.0299, 'lps'),
	(669680, 132, '2015-02-01 00:49:13.000000', 'consum', 0.0315, 'lps'),
	(669681, 132, '2015-02-01 00:49:14.000000', 'consum', 0.0238, 'lps'),
	(669682, 132, '2015-02-01 00:49:15.000000', 'consum', 0.0269, 'lps'),
	(669683, 132, '2015-02-01 00:49:16.000000', 'consum', 0.0305, 'lps'),
	(669684, 132, '2015-02-01 00:49:17.000000', 'consum', 0.0276, 'lps'),
	(669685, 132, '2015-02-01 00:49:18.000000', 'consum', 0.0256, 'lps'),
	(669686, 132, '2015-02-01 00:49:19.000000', 'consum', 0.0243, 'lps'),
	(669687, 132, '2015-02-01 00:49:20.000000', 'consum', 0.0238, 'lps'),
	(669688, 132, '2015-02-01 00:49:21.000000', 'consum', 0.0252, 'lps'),
	(669689, 132, '2015-02-01 00:49:22.000000', 'consum', 0.0220, 'lps'),
	(669690, 132, '2015-02-01 00:49:23.000000', 'consum', 0.0251, 'lps'),
	(669691, 132, '2015-02-01 00:49:24.000000', 'consum', 0.0267, 'lps'),
	(669692, 132, '2015-02-01 00:49:25.000000', 'consum', 0.0257, 'lps'),
	(669693, 132, '2015-02-01 00:49:26.000000', 'consum', 0.0276, 'lps'),
	(669694, 132, '2015-02-01 00:49:27.000000', 'consum', 0.0282, 'lps'),
	(669695, 132, '2015-02-01 00:49:28.000000', 'consum', 0.0259, 'lps'),
	(669696, 132, '2015-02-01 00:49:29.000000', 'consum', 0.0237, 'lps'),
	(669697, 132, '2015-02-01 00:49:30.000000', 'consum', 0.0317, 'lps'),
	(669698, 132, '2015-02-01 00:49:31.000000', 'consum', 0.0317, 'lps'),
	(669699, 132, '2015-02-01 00:49:32.000000', 'consum', 0.0309, 'lps'),
	(669700, 132, '2015-02-01 00:49:33.000000', 'consum', 0.0265, 'lps'),
	(669701, 132, '2015-02-01 00:49:34.000000', 'consum', 0.0307, 'lps'),
	(669702, 132, '2015-02-01 00:49:35.000000', 'consum', 0.0299, 'lps'),
	(669703, 132, '2015-02-01 00:49:36.000000', 'consum', 0.0246, 'lps'),
	(669704, 132, '2015-02-01 00:49:37.000000', 'consum', 0.0241, 'lps'),
	(669705, 132, '2015-02-01 00:49:38.000000', 'consum', 0.0257, 'lps'),
	(669706, 132, '2015-02-01 00:49:39.000000', 'consum', 0.0236, 'lps'),
	(669707, 132, '2015-02-01 00:49:40.000000', 'consum', 0.0316, 'lps'),
	(669708, 132, '2015-02-01 00:49:41.000000', 'consum', 0.0315, 'lps'),
	(669709, 132, '2015-02-01 00:49:42.000000', 'consum', 0.0302, 'lps'),
	(669710, 132, '2015-02-01 00:49:43.000000', 'consum', 0.0239, 'lps'),
	(669711, 132, '2015-02-01 00:49:44.000000', 'consum', 0.0311, 'lps'),
	(669712, 132, '2015-02-01 00:49:45.000000', 'consum', 0.0281, 'lps'),
	(669713, 132, '2015-02-01 00:49:46.000000', 'consum', 0.0261, 'lps'),
	(669714, 132, '2015-02-01 00:49:47.000000', 'consum', 0.0252, 'lps'),
	(669715, 132, '2015-02-01 00:49:48.000000', 'consum', 0.0269, 'lps'),
	(669716, 132, '2015-02-01 00:49:49.000000', 'consum', 0.0264, 'lps'),
	(669717, 132, '2015-02-01 00:49:50.000000', 'consum', 0.0302, 'lps'),
	(669718, 132, '2015-02-01 00:49:51.000000', 'consum', 0.0277, 'lps'),
	(669719, 132, '2015-02-01 00:49:52.000000', 'consum', 0.0269, 'lps'),
	(669720, 132, '2015-02-01 00:49:53.000000', 'consum', 0.0306, 'lps'),
	(669721, 132, '2015-02-01 00:49:54.000000', 'consum', 0.0280, 'lps'),
	(669722, 132, '2015-02-01 00:49:55.000000', 'consum', 0.0275, 'lps'),
	(669723, 132, '2015-02-01 00:49:56.000000', 'consum', 0.0324, 'lps'),
	(669724, 132, '2015-02-01 00:49:57.000000', 'consum', 0.0240, 'lps'),
	(669725, 132, '2015-02-01 00:49:58.000000', 'consum', 0.0247, 'lps'),
	(669726, 132, '2015-02-01 00:49:59.000000', 'consum', 0.0308, 'lps'),
	(669727, 132, '2015-02-01 00:50:00.000000', 'consum', 0.0240, 'lps'),
	(669728, 132, '2015-02-01 00:50:01.000000', 'consum', 0.0300, 'lps'),
	(669729, 132, '2015-02-01 00:50:02.000000', 'consum', 0.0223, 'lps'),
	(669730, 132, '2015-02-01 00:50:03.000000', 'consum', 0.0238, 'lps'),
	(669731, 132, '2015-02-01 00:50:04.000000', 'consum', 0.0310, 'lps'),
	(669732, 132, '2015-02-01 00:50:05.000000', 'consum', 0.0278, 'lps'),
	(669733, 132, '2015-02-01 00:50:06.000000', 'consum', 0.0252, 'lps'),
	(669734, 132, '2015-02-01 00:50:07.000000', 'consum', 0.0217, 'lps'),
	(669735, 132, '2015-02-01 00:50:08.000000', 'consum', 0.0233, 'lps'),
	(669736, 132, '2015-02-01 00:50:09.000000', 'consum', 0.0307, 'lps'),
	(669737, 132, '2015-02-01 00:50:10.000000', 'consum', 0.0277, 'lps'),
	(669738, 132, '2015-02-01 00:50:11.000000', 'consum', 0.0254, 'lps'),
	(669739, 132, '2015-02-01 00:50:12.000000', 'consum', 0.0231, 'lps'),
	(669740, 132, '2015-02-01 00:50:13.000000', 'consum', 0.0297, 'lps'),
	(669741, 132, '2015-02-01 00:50:14.000000', 'consum', 0.0238, 'lps'),
	(669742, 132, '2015-02-01 00:50:15.000000', 'consum', 0.0318, 'lps'),
	(669743, 132, '2015-02-01 00:50:16.000000', 'consum', 0.0319, 'lps'),
	(669744, 132, '2015-02-01 00:50:17.000000', 'consum', 0.0317, 'lps'),
	(669745, 132, '2015-02-01 00:50:18.000000', 'consum', 0.0302, 'lps'),
	(669746, 132, '2015-02-01 00:50:19.000000', 'consum', 0.0233, 'lps'),
	(669747, 132, '2015-02-01 00:50:20.000000', 'consum', 0.0282, 'lps'),
	(669748, 132, '2015-02-01 00:50:21.000000', 'consum', 0.0271, 'lps'),
	(669749, 132, '2015-02-01 00:50:22.000000', 'consum', 0.0296, 'lps'),
	(669750, 132, '2015-02-01 00:50:23.000000', 'consum', 0.0229, 'lps'),
	(669751, 132, '2015-02-01 00:50:24.000000', 'consum', 0.0278, 'lps'),
	(669752, 132, '2015-02-01 00:50:25.000000', 'consum', 0.0260, 'lps'),
	(669753, 132, '2015-02-01 00:50:26.000000', 'consum', 0.0256, 'lps'),
	(669754, 132, '2015-02-01 00:50:27.000000', 'consum', 0.0293, 'lps'),
	(669755, 132, '2015-02-01 00:50:28.000000', 'consum', 0.0255, 'lps'),
	(669756, 132, '2015-02-01 00:50:29.000000', 'consum', 0.0302, 'lps'),
	(669757, 132, '2015-02-01 00:50:30.000000', 'consum', 0.0304, 'lps'),
	(669758, 132, '2015-02-01 00:50:31.000000', 'consum', 0.0286, 'lps'),
	(669759, 132, '2015-02-01 00:50:32.000000', 'consum', 0.0312, 'lps'),
	(669760, 132, '2015-02-01 00:50:33.000000', 'consum', 0.0260, 'lps'),
	(669761, 132, '2015-02-01 00:50:34.000000', 'consum', 0.0269, 'lps'),
	(669762, 132, '2015-02-01 00:50:35.000000', 'consum', 0.0239, 'lps'),
	(669763, 132, '2015-02-01 00:50:36.000000', 'consum', 0.0297, 'lps'),
	(669764, 132, '2015-02-01 00:50:37.000000', 'consum', 0.0325, 'lps'),
	(669765, 132, '2015-02-01 00:50:38.000000', 'consum', 0.0293, 'lps'),
	(669766, 132, '2015-02-01 00:50:39.000000', 'consum', 0.0282, 'lps'),
	(669767, 132, '2015-02-01 00:50:40.000000', 'consum', 0.0321, 'lps'),
	(669768, 132, '2015-02-01 00:50:41.000000', 'consum', 0.0316, 'lps'),
	(669769, 132, '2015-02-01 00:50:42.000000', 'consum', 0.0290, 'lps'),
	(669770, 132, '2015-02-01 00:50:43.000000', 'consum', 0.0295, 'lps'),
	(669771, 132, '2015-02-01 00:50:44.000000', 'consum', 0.0277, 'lps'),
	(669772, 132, '2015-02-01 00:50:45.000000', 'consum', 0.0293, 'lps'),
	(669773, 132, '2015-02-01 00:50:46.000000', 'consum', 0.0309, 'lps'),
	(669774, 132, '2015-02-01 00:50:47.000000', 'consum', 0.0222, 'lps'),
	(669775, 132, '2015-02-01 00:50:48.000000', 'consum', 0.0324, 'lps'),
	(669776, 132, '2015-02-01 00:50:49.000000', 'consum', 0.0280, 'lps'),
	(669777, 132, '2015-02-01 00:50:50.000000', 'consum', 0.0219, 'lps'),
	(669778, 132, '2015-02-01 00:50:51.000000', 'consum', 0.0278, 'lps'),
	(669779, 132, '2015-02-01 00:50:52.000000', 'consum', 0.0289, 'lps'),
	(669780, 132, '2015-02-01 00:50:53.000000', 'consum', 0.0288, 'lps'),
	(669781, 132, '2015-02-01 00:50:54.000000', 'consum', 0.0245, 'lps'),
	(669782, 132, '2015-02-01 00:50:55.000000', 'consum', 0.0270, 'lps'),
	(669783, 132, '2015-02-01 00:50:56.000000', 'consum', 0.0289, 'lps'),
	(669784, 132, '2015-02-01 00:50:57.000000', 'consum', 0.0308, 'lps'),
	(669785, 132, '2015-02-01 00:50:58.000000', 'consum', 0.0233, 'lps'),
	(669786, 132, '2015-02-01 00:50:59.000000', 'consum', 0.0262, 'lps'),
	(669787, 132, '2015-02-01 00:51:00.000000', 'consum', 0.0287, 'lps'),
	(669788, 132, '2015-02-01 00:51:01.000000', 'consum', 0.0321, 'lps'),
	(669789, 132, '2015-02-01 00:51:02.000000', 'consum', 0.0303, 'lps'),
	(669790, 132, '2015-02-01 00:51:03.000000', 'consum', 0.0228, 'lps'),
	(669791, 132, '2015-02-01 00:51:04.000000', 'consum', 0.0254, 'lps'),
	(669792, 132, '2015-02-01 00:51:05.000000', 'consum', 0.0258, 'lps'),
	(669793, 132, '2015-02-01 00:51:06.000000', 'consum', 0.0319, 'lps'),
	(669794, 132, '2015-02-01 00:51:07.000000', 'consum', 0.0263, 'lps'),
	(669795, 132, '2015-02-01 00:51:08.000000', 'consum', 0.0265, 'lps'),
	(669796, 132, '2015-02-01 00:51:09.000000', 'consum', 0.0211, 'lps'),
	(669797, 132, '2015-02-01 00:51:10.000000', 'consum', 0.0282, 'lps'),
	(669798, 132, '2015-02-01 00:51:11.000000', 'consum', 0.0220, 'lps'),
	(669799, 132, '2015-02-01 00:51:12.000000', 'consum', 0.0275, 'lps'),
	(669800, 132, '2015-02-01 00:51:13.000000', 'consum', 0.0275, 'lps'),
	(669801, 132, '2015-02-01 00:51:14.000000', 'consum', 0.0225, 'lps'),
	(669802, 132, '2015-02-01 00:51:15.000000', 'consum', 0.0321, 'lps'),
	(669803, 132, '2015-02-01 00:51:16.000000', 'consum', 0.0259, 'lps'),
	(669804, 132, '2015-02-01 00:51:17.000000', 'consum', 0.0238, 'lps'),
	(669805, 132, '2015-02-01 00:51:18.000000', 'consum', 0.0318, 'lps'),
	(669806, 132, '2015-02-01 00:51:19.000000', 'consum', 0.0318, 'lps'),
	(669807, 132, '2015-02-01 00:51:20.000000', 'consum', 0.0312, 'lps'),
	(669808, 132, '2015-02-01 00:51:21.000000', 'consum', 0.0282, 'lps'),
	(669809, 132, '2015-02-01 00:51:22.000000', 'consum', 0.0263, 'lps'),
	(669810, 132, '2015-02-01 00:51:23.000000', 'consum', 0.0259, 'lps'),
	(669811, 132, '2015-02-01 00:51:24.000000', 'consum', 0.0296, 'lps'),
	(669812, 132, '2015-02-01 00:51:25.000000', 'consum', 0.0262, 'lps'),
	(669813, 132, '2015-02-01 00:51:26.000000', 'consum', 0.0211, 'lps'),
	(669814, 132, '2015-02-01 00:51:27.000000', 'consum', 0.0291, 'lps'),
	(669815, 132, '2015-02-01 00:51:28.000000', 'consum', 0.0264, 'lps'),
	(669816, 132, '2015-02-01 00:51:29.000000', 'consum', 0.0240, 'lps'),
	(669817, 132, '2015-02-01 00:51:30.000000', 'consum', 0.0312, 'lps'),
	(669818, 132, '2015-02-01 00:51:31.000000', 'consum', 0.0283, 'lps'),
	(669819, 132, '2015-02-01 00:51:32.000000', 'consum', 0.0268, 'lps'),
	(669820, 132, '2015-02-01 00:51:33.000000', 'consum', 0.0282, 'lps'),
	(669821, 132, '2015-02-01 00:51:34.000000', 'consum', 0.0281, 'lps'),
	(669822, 132, '2015-02-01 00:51:35.000000', 'consum', 0.0232, 'lps'),
	(669823, 132, '2015-02-01 00:51:36.000000', 'consum', 0.0226, 'lps'),
	(669824, 132, '2015-02-01 00:51:37.000000', 'consum', 0.0223, 'lps'),
	(669825, 132, '2015-02-01 00:51:38.000000', 'consum', 0.0227, 'lps'),
	(669826, 132, '2015-02-01 00:51:39.000000', 'consum', 0.0256, 'lps'),
	(669827, 132, '2015-02-01 00:51:40.000000', 'consum', 0.0274, 'lps'),
	(669828, 132, '2015-02-01 00:51:41.000000', 'consum', 0.0278, 'lps'),
	(669829, 132, '2015-02-01 00:51:42.000000', 'consum', 0.0242, 'lps'),
	(669830, 132, '2015-02-01 00:51:43.000000', 'consum', 0.0283, 'lps'),
	(669831, 132, '2015-02-01 00:51:44.000000', 'consum', 0.0245, 'lps'),
	(669832, 132, '2015-02-01 00:51:45.000000', 'consum', 0.0283, 'lps'),
	(669833, 132, '2015-02-01 00:51:46.000000', 'consum', 0.0239, 'lps'),
	(669834, 132, '2015-02-01 00:51:47.000000', 'consum', 0.0254, 'lps'),
	(669835, 132, '2015-02-01 00:51:48.000000', 'consum', 0.0227, 'lps'),
	(669836, 132, '2015-02-01 00:51:49.000000', 'consum', 0.0277, 'lps'),
	(669837, 132, '2015-02-01 00:51:50.000000', 'consum', 0.0266, 'lps'),
	(669838, 132, '2015-02-01 00:51:51.000000', 'consum', 0.0286, 'lps'),
	(669839, 132, '2015-02-01 00:51:52.000000', 'consum', 0.0308, 'lps'),
	(669840, 132, '2015-02-01 00:51:53.000000', 'consum', 0.0242, 'lps'),
	(669841, 132, '2015-02-01 00:51:54.000000', 'consum', 0.0306, 'lps'),
	(669842, 132, '2015-02-01 00:51:55.000000', 'consum', 0.0249, 'lps'),
	(669843, 132, '2015-02-01 00:51:56.000000', 'consum', 0.0233, 'lps'),
	(669844, 132, '2015-02-01 00:51:57.000000', 'consum', 0.0325, 'lps'),
	(669845, 132, '2015-02-01 00:51:58.000000', 'consum', 0.0253, 'lps'),
	(669846, 132, '2015-02-01 00:51:59.000000', 'consum', 0.0312, 'lps'),
	(669847, 132, '2015-02-01 00:52:00.000000', 'consum', 0.0244, 'lps'),
	(669848, 132, '2015-02-01 00:52:01.000000', 'consum', 0.0308, 'lps'),
	(669849, 132, '2015-02-01 00:52:02.000000', 'consum', 0.0250, 'lps'),
	(669850, 132, '2015-02-01 00:52:03.000000', 'consum', 0.0230, 'lps'),
	(669851, 132, '2015-02-01 00:52:04.000000', 'consum', 0.0307, 'lps'),
	(669852, 132, '2015-02-01 00:52:05.000000', 'consum', 0.0288, 'lps'),
	(669853, 132, '2015-02-01 00:52:06.000000', 'consum', 0.0310, 'lps'),
	(669854, 132, '2015-02-01 00:52:07.000000', 'consum', 0.0242, 'lps'),
	(669855, 132, '2015-02-01 00:52:08.000000', 'consum', 0.0305, 'lps'),
	(669856, 132, '2015-02-01 00:52:09.000000', 'consum', 0.0241, 'lps'),
	(669857, 132, '2015-02-01 00:52:10.000000', 'consum', 0.0311, 'lps'),
	(669858, 132, '2015-02-01 00:52:11.000000', 'consum', 0.0276, 'lps'),
	(669859, 132, '2015-02-01 00:52:12.000000', 'consum', 0.0239, 'lps'),
	(669860, 132, '2015-02-01 00:52:13.000000', 'consum', 0.0272, 'lps'),
	(669861, 132, '2015-02-01 00:52:14.000000', 'consum', 0.0316, 'lps'),
	(669862, 132, '2015-02-01 00:52:15.000000', 'consum', 0.0324, 'lps'),
	(669863, 132, '2015-02-01 00:52:16.000000', 'consum', 0.0231, 'lps'),
	(669864, 132, '2015-02-01 00:52:17.000000', 'consum', 0.0321, 'lps'),
	(669865, 132, '2015-02-01 00:52:18.000000', 'consum', 0.0238, 'lps'),
	(669866, 132, '2015-02-01 00:52:19.000000', 'consum', 0.0252, 'lps'),
	(669867, 132, '2015-02-01 00:52:20.000000', 'consum', 0.0217, 'lps'),
	(669868, 132, '2015-02-01 00:52:21.000000', 'consum', 0.0238, 'lps'),
	(669869, 132, '2015-02-01 00:52:22.000000', 'consum', 0.0215, 'lps'),
	(669870, 132, '2015-02-01 00:52:23.000000', 'consum', 0.0265, 'lps'),
	(669871, 132, '2015-02-01 00:52:24.000000', 'consum', 0.0237, 'lps'),
	(669872, 132, '2015-02-01 00:52:25.000000', 'consum', 0.0299, 'lps'),
	(669873, 132, '2015-02-01 00:52:26.000000', 'consum', 0.0225, 'lps'),
	(669874, 132, '2015-02-01 00:52:27.000000', 'consum', 0.0251, 'lps'),
	(669875, 132, '2015-02-01 00:52:28.000000', 'consum', 0.0254, 'lps'),
	(669876, 132, '2015-02-01 00:52:29.000000', 'consum', 0.0310, 'lps'),
	(669877, 132, '2015-02-01 00:52:30.000000', 'consum', 0.0228, 'lps'),
	(669878, 132, '2015-02-01 00:52:31.000000', 'consum', 0.0233, 'lps'),
	(669879, 132, '2015-02-01 00:52:32.000000', 'consum', 0.0273, 'lps'),
	(669880, 132, '2015-02-01 00:52:33.000000', 'consum', 0.0224, 'lps'),
	(669881, 132, '2015-02-01 00:52:34.000000', 'consum', 0.0324, 'lps'),
	(669882, 132, '2015-02-01 00:52:35.000000', 'consum', 0.0272, 'lps'),
	(669883, 132, '2015-02-01 00:52:36.000000', 'consum', 0.0298, 'lps'),
	(669884, 132, '2015-02-01 00:52:37.000000', 'consum', 0.0229, 'lps'),
	(669885, 132, '2015-02-01 00:52:38.000000', 'consum', 0.0276, 'lps'),
	(669886, 132, '2015-02-01 00:52:39.000000', 'consum', 0.0249, 'lps'),
	(669887, 132, '2015-02-01 00:52:40.000000', 'consum', 0.0324, 'lps'),
	(669888, 132, '2015-02-01 00:52:41.000000', 'consum', 0.0315, 'lps'),
	(669889, 132, '2015-02-01 00:52:42.000000', 'consum', 0.0278, 'lps'),
	(669890, 132, '2015-02-01 00:52:43.000000', 'consum', 0.0235, 'lps'),
	(669891, 132, '2015-02-01 00:52:44.000000', 'consum', 0.0247, 'lps'),
	(669892, 132, '2015-02-01 00:52:45.000000', 'consum', 0.0321, 'lps'),
	(669893, 132, '2015-02-01 00:52:46.000000', 'consum', 0.0306, 'lps'),
	(669894, 132, '2015-02-01 00:52:47.000000', 'consum', 0.0243, 'lps'),
	(669895, 132, '2015-02-01 00:52:48.000000', 'consum', 0.0319, 'lps'),
	(669896, 132, '2015-02-01 00:52:49.000000', 'consum', 0.0310, 'lps'),
	(669897, 132, '2015-02-01 00:52:50.000000', 'consum', 0.0268, 'lps'),
	(669898, 132, '2015-02-01 00:52:51.000000', 'consum', 0.0316, 'lps'),
	(669899, 132, '2015-02-01 00:52:52.000000', 'consum', 0.0217, 'lps'),
	(669900, 132, '2015-02-01 00:52:53.000000', 'consum', 0.0275, 'lps'),
	(669901, 132, '2015-02-01 00:52:54.000000', 'consum', 0.0283, 'lps'),
	(669902, 132, '2015-02-01 00:52:55.000000', 'consum', 0.0265, 'lps'),
	(669903, 132, '2015-02-01 00:52:56.000000', 'consum', 0.0267, 'lps'),
	(669904, 132, '2015-02-01 00:52:57.000000', 'consum', 0.0214, 'lps'),
	(669905, 132, '2015-02-01 00:52:58.000000', 'consum', 0.0290, 'lps'),
	(669906, 132, '2015-02-01 00:52:59.000000', 'consum', 0.0251, 'lps'),
	(669907, 132, '2015-02-01 00:53:00.000000', 'consum', 0.0294, 'lps'),
	(669908, 132, '2015-02-01 00:53:01.000000', 'consum', 0.0274, 'lps'),
	(669909, 132, '2015-02-01 00:53:02.000000', 'consum', 0.0278, 'lps'),
	(669910, 132, '2015-02-01 00:53:03.000000', 'consum', 0.0244, 'lps'),
	(669911, 132, '2015-02-01 00:53:04.000000', 'consum', 0.0293, 'lps'),
	(669912, 132, '2015-02-01 00:53:05.000000', 'consum', 0.0290, 'lps'),
	(669913, 132, '2015-02-01 00:53:06.000000', 'consum', 0.0248, 'lps'),
	(669914, 132, '2015-02-01 00:53:07.000000', 'consum', 0.0273, 'lps'),
	(669915, 132, '2015-02-01 00:53:08.000000', 'consum', 0.0298, 'lps'),
	(669916, 132, '2015-02-01 00:53:09.000000', 'consum', 0.0227, 'lps'),
	(669917, 132, '2015-02-01 00:53:10.000000', 'consum', 0.0265, 'lps'),
	(669918, 132, '2015-02-01 00:53:11.000000', 'consum', 0.0317, 'lps'),
	(669919, 132, '2015-02-01 00:53:12.000000', 'consum', 0.0233, 'lps'),
	(669920, 132, '2015-02-01 00:53:13.000000', 'consum', 0.0235, 'lps'),
	(669921, 132, '2015-02-01 00:53:14.000000', 'consum', 0.0269, 'lps'),
	(669922, 132, '2015-02-01 00:53:15.000000', 'consum', 0.0314, 'lps'),
	(669923, 132, '2015-02-01 00:53:16.000000', 'consum', 0.0320, 'lps'),
	(669924, 132, '2015-02-01 00:53:17.000000', 'consum', 0.0217, 'lps'),
	(669925, 132, '2015-02-01 00:53:18.000000', 'consum', 0.0265, 'lps'),
	(669926, 132, '2015-02-01 00:53:19.000000', 'consum', 0.0232, 'lps'),
	(669927, 132, '2015-02-01 00:53:20.000000', 'consum', 0.0273, 'lps'),
	(669928, 132, '2015-02-01 00:53:21.000000', 'consum', 0.0227, 'lps'),
	(669929, 132, '2015-02-01 00:53:22.000000', 'consum', 0.0223, 'lps'),
	(669930, 132, '2015-02-01 00:53:23.000000', 'consum', 0.0225, 'lps'),
	(669931, 132, '2015-02-01 00:53:24.000000', 'consum', 0.0247, 'lps'),
	(669932, 132, '2015-02-01 00:53:25.000000', 'consum', 0.0234, 'lps'),
	(669933, 132, '2015-02-01 00:53:26.000000', 'consum', 0.0218, 'lps'),
	(669934, 132, '2015-02-01 00:53:27.000000', 'consum', 0.0296, 'lps'),
	(669935, 132, '2015-02-01 00:53:28.000000', 'consum', 0.0267, 'lps'),
	(669936, 132, '2015-02-01 00:53:29.000000', 'consum', 0.0237, 'lps'),
	(669937, 132, '2015-02-01 00:53:30.000000', 'consum', 0.0292, 'lps'),
	(669938, 132, '2015-02-01 00:53:31.000000', 'consum', 0.0307, 'lps'),
	(669939, 132, '2015-02-01 00:53:32.000000', 'consum', 0.0218, 'lps'),
	(669940, 132, '2015-02-01 00:53:33.000000', 'consum', 0.0308, 'lps'),
	(669941, 132, '2015-02-01 00:53:34.000000', 'consum', 0.0210, 'lps'),
	(669942, 132, '2015-02-01 00:53:35.000000', 'consum', 0.0265, 'lps'),
	(669943, 132, '2015-02-01 00:53:36.000000', 'consum', 0.0254, 'lps'),
	(669944, 132, '2015-02-01 00:53:37.000000', 'consum', 0.0266, 'lps'),
	(669945, 132, '2015-02-01 00:53:38.000000', 'consum', 0.0241, 'lps'),
	(669946, 132, '2015-02-01 00:53:39.000000', 'consum', 0.0314, 'lps'),
	(669947, 132, '2015-02-01 00:53:40.000000', 'consum', 0.0288, 'lps'),
	(669948, 132, '2015-02-01 00:53:41.000000', 'consum', 0.0290, 'lps'),
	(669949, 132, '2015-02-01 00:53:42.000000', 'consum', 0.0261, 'lps'),
	(669950, 132, '2015-02-01 00:53:43.000000', 'consum', 0.0226, 'lps'),
	(669951, 132, '2015-02-01 00:53:44.000000', 'consum', 0.0254, 'lps'),
	(669952, 132, '2015-02-01 00:53:45.000000', 'consum', 0.0264, 'lps'),
	(669953, 132, '2015-02-01 00:53:46.000000', 'consum', 0.0232, 'lps'),
	(669954, 132, '2015-02-01 00:53:47.000000', 'consum', 0.0276, 'lps'),
	(669955, 132, '2015-02-01 00:53:48.000000', 'consum', 0.0243, 'lps'),
	(669956, 132, '2015-02-01 00:53:49.000000', 'consum', 0.0294, 'lps'),
	(669957, 132, '2015-02-01 00:53:50.000000', 'consum', 0.0301, 'lps'),
	(669958, 132, '2015-02-01 00:53:51.000000', 'consum', 0.0296, 'lps'),
	(669959, 132, '2015-02-01 00:53:52.000000', 'consum', 0.0250, 'lps'),
	(669960, 132, '2015-02-01 00:53:53.000000', 'consum', 0.0269, 'lps'),
	(669961, 132, '2015-02-01 00:53:54.000000', 'consum', 0.0269, 'lps'),
	(669962, 132, '2015-02-01 00:53:55.000000', 'consum', 0.0213, 'lps'),
	(669963, 132, '2015-02-01 00:53:56.000000', 'consum', 0.0279, 'lps'),
	(669964, 132, '2015-02-01 00:53:57.000000', 'consum', 0.0317, 'lps'),
	(669965, 132, '2015-02-01 00:53:58.000000', 'consum', 0.0307, 'lps'),
	(669966, 132, '2015-02-01 00:53:59.000000', 'consum', 0.0258, 'lps'),
	(669967, 132, '2015-02-01 00:54:00.000000', 'consum', 0.0273, 'lps'),
	(669968, 132, '2015-02-01 00:54:01.000000', 'consum', 0.0269, 'lps'),
	(669969, 132, '2015-02-01 00:54:02.000000', 'consum', 0.0314, 'lps'),
	(669970, 132, '2015-02-01 00:54:03.000000', 'consum', 0.0321, 'lps'),
	(669971, 132, '2015-02-01 00:54:04.000000', 'consum', 0.0221, 'lps'),
	(669972, 132, '2015-02-01 00:54:05.000000', 'consum', 0.0283, 'lps'),
	(669973, 132, '2015-02-01 00:54:06.000000', 'consum', 0.0311, 'lps'),
	(669974, 132, '2015-02-01 00:54:07.000000', 'consum', 0.0264, 'lps'),
	(669975, 132, '2015-02-01 00:54:08.000000', 'consum', 0.0294, 'lps'),
	(669976, 132, '2015-02-01 00:54:09.000000', 'consum', 0.0235, 'lps'),
	(669977, 132, '2015-02-01 00:54:10.000000', 'consum', 0.0316, 'lps'),
	(669978, 132, '2015-02-01 00:54:11.000000', 'consum', 0.0316, 'lps'),
	(669979, 132, '2015-02-01 00:54:12.000000', 'consum', 0.0306, 'lps'),
	(669980, 132, '2015-02-01 00:54:13.000000', 'consum', 0.0258, 'lps'),
	(669981, 132, '2015-02-01 00:54:14.000000', 'consum', 0.0278, 'lps'),
	(669982, 132, '2015-02-01 00:54:15.000000', 'consum', 0.0290, 'lps'),
	(669983, 132, '2015-02-01 00:54:16.000000', 'consum', 0.0292, 'lps'),
	(669984, 132, '2015-02-01 00:54:17.000000', 'consum', 0.0264, 'lps'),
	(669985, 132, '2015-02-01 00:54:18.000000', 'consum', 0.0233, 'lps'),
	(669986, 132, '2015-02-01 00:54:19.000000', 'consum', 0.0281, 'lps'),
	(669987, 132, '2015-02-01 00:54:20.000000', 'consum', 0.0265, 'lps'),
	(669988, 132, '2015-02-01 00:54:21.000000', 'consum', 0.0271, 'lps'),
	(669989, 132, '2015-02-01 00:54:22.000000', 'consum', 0.0234, 'lps'),
	(669990, 132, '2015-02-01 00:54:23.000000', 'consum', 0.0264, 'lps'),
	(669991, 132, '2015-02-01 00:54:24.000000', 'consum', 0.0294, 'lps'),
	(669992, 132, '2015-02-01 00:54:25.000000', 'consum', 0.0237, 'lps'),
	(669993, 132, '2015-02-01 00:54:26.000000', 'consum', 0.0325, 'lps'),
	(669994, 132, '2015-02-01 00:54:27.000000', 'consum', 0.0240, 'lps'),
	(669995, 132, '2015-02-01 00:54:28.000000', 'consum', 0.0247, 'lps'),
	(669996, 132, '2015-02-01 00:54:29.000000', 'consum', 0.0306, 'lps'),
	(669997, 132, '2015-02-01 00:54:30.000000', 'consum', 0.0232, 'lps'),
	(669998, 132, '2015-02-01 00:54:31.000000', 'consum', 0.0264, 'lps'),
	(669999, 132, '2015-02-01 00:54:32.000000', 'consum', 0.0300, 'lps'),
	(670000, 132, '2015-02-01 00:54:33.000000', 'consum', 0.0267, 'lps'),
	(670001, 132, '2015-02-01 00:54:34.000000', 'consum', 0.0226, 'lps'),
	(670002, 132, '2015-02-01 00:54:35.000000', 'consum', 0.0232, 'lps'),
	(670003, 132, '2015-02-01 00:54:36.000000', 'consum', 0.0276, 'lps'),
	(670004, 132, '2015-02-01 00:54:37.000000', 'consum', 0.0241, 'lps'),
	(670005, 132, '2015-02-01 00:54:38.000000', 'consum', 0.0282, 'lps'),
	(670006, 132, '2015-02-01 00:54:39.000000', 'consum', 0.0248, 'lps'),
	(670007, 132, '2015-02-01 00:54:40.000000', 'consum', 0.0301, 'lps'),
	(670008, 132, '2015-02-01 00:54:41.000000', 'consum', 0.0319, 'lps'),
	(670009, 132, '2015-02-01 00:54:42.000000', 'consum', 0.0250, 'lps'),
	(670010, 132, '2015-02-01 00:54:43.000000', 'consum', 0.0314, 'lps'),
	(670011, 132, '2015-02-01 00:54:44.000000', 'consum', 0.0263, 'lps'),
	(670012, 132, '2015-02-01 00:54:45.000000', 'consum', 0.0280, 'lps'),
	(670013, 132, '2015-02-01 00:54:46.000000', 'consum', 0.0286, 'lps'),
	(670014, 132, '2015-02-01 00:54:47.000000', 'consum', 0.0264, 'lps'),
	(670015, 132, '2015-02-01 00:54:48.000000', 'consum', 0.0251, 'lps'),
	(670016, 132, '2015-02-01 00:54:49.000000', 'consum', 0.0256, 'lps'),
	(670017, 132, '2015-02-01 00:54:50.000000', 'consum', 0.0317, 'lps'),
	(670018, 132, '2015-02-01 00:54:51.000000', 'consum', 0.0260, 'lps'),
	(670019, 132, '2015-02-01 00:54:52.000000', 'consum', 0.0253, 'lps'),
	(670020, 132, '2015-02-01 00:54:53.000000', 'consum', 0.0279, 'lps'),
	(670021, 132, '2015-02-01 00:54:54.000000', 'consum', 0.0308, 'lps'),
	(670022, 132, '2015-02-01 00:54:55.000000', 'consum', 0.0263, 'lps'),
	(670023, 132, '2015-02-01 00:54:56.000000', 'consum', 0.0296, 'lps'),
	(670024, 132, '2015-02-01 00:54:57.000000', 'consum', 0.0248, 'lps'),
	(670025, 132, '2015-02-01 00:54:58.000000', 'consum', 0.0261, 'lps'),
	(670026, 132, '2015-02-01 00:54:59.000000', 'consum', 0.0236, 'lps'),
	(670027, 132, '2015-02-01 00:55:00.000000', 'consum', 0.0301, 'lps'),
	(670028, 132, '2015-02-01 00:55:01.000000', 'consum', 0.0239, 'lps'),
	(670029, 132, '2015-02-01 00:55:02.000000', 'consum', 0.0314, 'lps'),
	(670030, 132, '2015-02-01 00:55:03.000000', 'consum', 0.0296, 'lps'),
	(670031, 132, '2015-02-01 00:55:04.000000', 'consum', 0.0213, 'lps'),
	(670032, 132, '2015-02-01 00:55:05.000000', 'consum', 0.0315, 'lps'),
	(670033, 132, '2015-02-01 00:55:06.000000', 'consum', 0.0265, 'lps'),
	(670034, 132, '2015-02-01 00:55:07.000000', 'consum', 0.0283, 'lps'),
	(670035, 132, '2015-02-01 00:55:08.000000', 'consum', 0.0296, 'lps'),
	(670036, 132, '2015-02-01 00:55:09.000000', 'consum', 0.0306, 'lps'),
	(670037, 132, '2015-02-01 00:55:10.000000', 'consum', 0.0318, 'lps'),
	(670038, 132, '2015-02-01 00:55:11.000000', 'consum', 0.0228, 'lps'),
	(670039, 132, '2015-02-01 00:55:12.000000', 'consum', 0.0210, 'lps'),
	(670040, 132, '2015-02-01 00:55:13.000000', 'consum', 0.0271, 'lps'),
	(670041, 132, '2015-02-01 00:55:14.000000', 'consum', 0.0284, 'lps'),
	(670042, 132, '2015-02-01 00:55:15.000000', 'consum', 0.0283, 'lps'),
	(670043, 132, '2015-02-01 00:55:16.000000', 'consum', 0.0235, 'lps'),
	(670044, 132, '2015-02-01 00:55:17.000000', 'consum', 0.0232, 'lps'),
	(670045, 132, '2015-02-01 00:55:18.000000', 'consum', 0.0246, 'lps'),
	(670046, 132, '2015-02-01 00:55:19.000000', 'consum', 0.0325, 'lps'),
	(670047, 132, '2015-02-01 00:55:20.000000', 'consum', 0.0215, 'lps'),
	(670048, 132, '2015-02-01 00:55:21.000000', 'consum', 0.0239, 'lps'),
	(670049, 132, '2015-02-01 00:55:22.000000', 'consum', 0.0224, 'lps'),
	(670050, 132, '2015-02-01 00:55:23.000000', 'consum', 0.0309, 'lps'),
	(670051, 132, '2015-02-01 00:55:24.000000', 'consum', 0.0314, 'lps'),
	(670052, 132, '2015-02-01 00:55:25.000000', 'consum', 0.0318, 'lps'),
	(670053, 132, '2015-02-01 00:55:26.000000', 'consum', 0.0324, 'lps'),
	(670054, 132, '2015-02-01 00:55:27.000000', 'consum', 0.0222, 'lps'),
	(670055, 132, '2015-02-01 00:55:28.000000', 'consum', 0.0277, 'lps'),
	(670056, 132, '2015-02-01 00:55:29.000000', 'consum', 0.0277, 'lps'),
	(670057, 132, '2015-02-01 00:55:30.000000', 'consum', 0.0230, 'lps'),
	(670058, 132, '2015-02-01 00:55:31.000000', 'consum', 0.0225, 'lps'),
	(670059, 132, '2015-02-01 00:55:32.000000', 'consum', 0.0226, 'lps'),
	(670060, 132, '2015-02-01 00:55:33.000000', 'consum', 0.0246, 'lps'),
	(670061, 132, '2015-02-01 00:55:34.000000', 'consum', 0.0225, 'lps'),
	(670062, 132, '2015-02-01 00:55:35.000000', 'consum', 0.0294, 'lps'),
	(670063, 132, '2015-02-01 00:55:36.000000', 'consum', 0.0237, 'lps'),
	(670064, 132, '2015-02-01 00:55:37.000000', 'consum', 0.0210, 'lps'),
	(670065, 132, '2015-02-01 00:55:38.000000', 'consum', 0.0246, 'lps'),
	(670066, 132, '2015-02-01 00:55:39.000000', 'consum', 0.0275, 'lps'),
	(670067, 132, '2015-02-01 00:55:40.000000', 'consum', 0.0310, 'lps'),
	(670068, 132, '2015-02-01 00:55:41.000000', 'consum', 0.0285, 'lps'),
	(670069, 132, '2015-02-01 00:55:42.000000', 'consum', 0.0286, 'lps'),
	(670070, 132, '2015-02-01 00:55:43.000000', 'consum', 0.0247, 'lps'),
	(670071, 132, '2015-02-01 00:55:44.000000', 'consum', 0.0287, 'lps'),
	(670072, 132, '2015-02-01 00:55:45.000000', 'consum', 0.0249, 'lps'),
	(670073, 132, '2015-02-01 00:55:46.000000', 'consum', 0.0293, 'lps'),
	(670074, 132, '2015-02-01 00:55:47.000000', 'consum', 0.0274, 'lps'),
	(670075, 132, '2015-02-01 00:55:48.000000', 'consum', 0.0283, 'lps'),
	(670076, 132, '2015-02-01 00:55:49.000000', 'consum', 0.0267, 'lps'),
	(670077, 132, '2015-02-01 00:55:50.000000', 'consum', 0.0275, 'lps'),
	(670078, 132, '2015-02-01 00:55:51.000000', 'consum', 0.0248, 'lps'),
	(670079, 132, '2015-02-01 00:55:52.000000', 'consum', 0.0323, 'lps'),
	(670080, 132, '2015-02-01 00:55:53.000000', 'consum', 0.0313, 'lps'),
	(670081, 132, '2015-02-01 00:55:54.000000', 'consum', 0.0270, 'lps'),
	(670082, 132, '2015-02-01 00:55:55.000000', 'consum', 0.0317, 'lps'),
	(670083, 132, '2015-02-01 00:55:56.000000', 'consum', 0.0220, 'lps'),
	(670084, 132, '2015-02-01 00:55:57.000000', 'consum', 0.0287, 'lps'),
	(670085, 132, '2015-02-01 00:55:58.000000', 'consum', 0.0217, 'lps'),
	(670086, 132, '2015-02-01 00:55:59.000000', 'consum', 0.0247, 'lps'),
	(670087, 132, '2015-02-01 00:56:00.000000', 'consum', 0.0259, 'lps'),
	(670088, 132, '2015-02-01 00:56:01.000000', 'consum', 0.0229, 'lps'),
	(670089, 132, '2015-02-01 00:56:02.000000', 'consum', 0.0274, 'lps'),
	(670090, 132, '2015-02-01 00:56:03.000000', 'consum', 0.0241, 'lps'),
	(670091, 132, '2015-02-01 00:56:04.000000', 'consum', 0.0289, 'lps'),
	(670092, 132, '2015-02-01 00:56:05.000000', 'consum', 0.0281, 'lps'),
	(670093, 132, '2015-02-01 00:56:06.000000', 'consum', 0.0213, 'lps'),
	(670094, 132, '2015-02-01 00:56:07.000000', 'consum', 0.0242, 'lps'),
	(670095, 132, '2015-02-01 00:56:08.000000', 'consum', 0.0247, 'lps'),
	(670096, 132, '2015-02-01 00:56:09.000000', 'consum', 0.0301, 'lps'),
	(670097, 132, '2015-02-01 00:56:10.000000', 'consum', 0.0321, 'lps'),
	(670098, 132, '2015-02-01 00:56:11.000000', 'consum', 0.0260, 'lps'),
	(670099, 132, '2015-02-01 00:56:12.000000', 'consum', 0.0244, 'lps'),
	(670100, 132, '2015-02-01 00:56:13.000000', 'consum', 0.0228, 'lps'),
	(670101, 132, '2015-02-01 00:56:14.000000', 'consum', 0.0318, 'lps'),
	(670102, 132, '2015-02-01 00:56:15.000000', 'consum', 0.0231, 'lps'),
	(670103, 132, '2015-02-01 00:56:16.000000', 'consum', 0.0225, 'lps'),
	(670104, 132, '2015-02-01 00:56:17.000000', 'consum', 0.0222, 'lps'),
	(670105, 132, '2015-02-01 00:56:18.000000', 'consum', 0.0225, 'lps'),
	(670106, 132, '2015-02-01 00:56:19.000000', 'consum', 0.0249, 'lps'),
	(670107, 132, '2015-02-01 00:56:20.000000', 'consum', 0.0246, 'lps'),
	(670108, 132, '2015-02-01 00:56:21.000000', 'consum', 0.0271, 'lps'),
	(670109, 132, '2015-02-01 00:56:22.000000', 'consum', 0.0294, 'lps'),
	(670110, 132, '2015-02-01 00:56:23.000000', 'consum', 0.0213, 'lps'),
	(670111, 132, '2015-02-01 00:56:24.000000', 'consum', 0.0321, 'lps'),
	(670112, 132, '2015-02-01 00:56:25.000000', 'consum', 0.0292, 'lps'),
	(670113, 132, '2015-02-01 00:56:26.000000', 'consum', 0.0287, 'lps'),
	(670114, 132, '2015-02-01 00:56:27.000000', 'consum', 0.0236, 'lps'),
	(670115, 132, '2015-02-01 00:56:28.000000', 'consum', 0.0225, 'lps'),
	(670116, 132, '2015-02-01 00:56:29.000000', 'consum', 0.0323, 'lps'),
	(670117, 132, '2015-02-01 00:56:30.000000', 'consum', 0.0265, 'lps'),
	(670118, 132, '2015-02-01 00:56:31.000000', 'consum', 0.0265, 'lps'),
	(670119, 132, '2015-02-01 00:56:32.000000', 'consum', 0.0319, 'lps'),
	(670120, 132, '2015-02-01 00:56:33.000000', 'consum', 0.0244, 'lps'),
	(670121, 132, '2015-02-01 00:56:34.000000', 'consum', 0.0283, 'lps'),
	(670122, 132, '2015-02-01 00:56:35.000000', 'consum', 0.0243, 'lps'),
	(670123, 132, '2015-02-01 00:56:36.000000', 'consum', 0.0274, 'lps'),
	(670124, 132, '2015-02-01 00:56:37.000000', 'consum', 0.0313, 'lps'),
	(670125, 132, '2015-02-01 00:56:38.000000', 'consum', 0.0302, 'lps'),
	(670126, 132, '2015-02-01 00:56:39.000000', 'consum', 0.0245, 'lps'),
	(670127, 132, '2015-02-01 00:56:40.000000', 'consum', 0.0225, 'lps'),
	(670128, 132, '2015-02-01 00:56:41.000000', 'consum', 0.0299, 'lps'),
	(670129, 132, '2015-02-01 00:56:42.000000', 'consum', 0.0260, 'lps'),
	(670130, 132, '2015-02-01 00:56:43.000000', 'consum', 0.0312, 'lps'),
	(670131, 132, '2015-02-01 00:56:44.000000', 'consum', 0.0223, 'lps'),
	(670132, 132, '2015-02-01 00:56:45.000000', 'consum', 0.0317, 'lps'),
	(670133, 132, '2015-02-01 00:56:46.000000', 'consum', 0.0244, 'lps'),
	(670134, 132, '2015-02-01 00:56:47.000000', 'consum', 0.0291, 'lps'),
	(670135, 132, '2015-02-01 00:56:48.000000', 'consum', 0.0281, 'lps'),
	(670136, 132, '2015-02-01 00:56:49.000000', 'consum', 0.0322, 'lps'),
	(670137, 132, '2015-02-01 00:56:50.000000', 'consum', 0.0211, 'lps'),
	(670138, 132, '2015-02-01 00:56:51.000000', 'consum', 0.0225, 'lps'),
	(670139, 132, '2015-02-01 00:56:52.000000', 'consum', 0.0283, 'lps'),
	(670140, 132, '2015-02-01 00:56:53.000000', 'consum', 0.0301, 'lps'),
	(670141, 132, '2015-02-01 00:56:54.000000', 'consum', 0.0211, 'lps'),
	(670142, 132, '2015-02-01 00:56:55.000000', 'consum', 0.0292, 'lps'),
	(670143, 132, '2015-02-01 00:56:56.000000', 'consum', 0.0269, 'lps'),
	(670144, 132, '2015-02-01 00:56:57.000000', 'consum', 0.0261, 'lps'),
	(670145, 132, '2015-02-01 00:56:58.000000', 'consum', 0.0289, 'lps'),
	(670146, 132, '2015-02-01 00:56:59.000000', 'consum', 0.0219, 'lps'),
	(670147, 132, '2015-02-01 00:57:00.000000', 'consum', 0.0252, 'lps'),
	(670148, 132, '2015-02-01 00:57:01.000000', 'consum', 0.0278, 'lps'),
	(670149, 132, '2015-02-01 00:57:02.000000', 'consum', 0.0306, 'lps'),
	(670150, 132, '2015-02-01 00:57:03.000000', 'consum', 0.0256, 'lps'),
	(670151, 132, '2015-02-01 00:57:04.000000', 'consum', 0.0268, 'lps'),
	(670152, 132, '2015-02-01 00:57:05.000000', 'consum', 0.0245, 'lps'),
	(670153, 132, '2015-02-01 00:57:06.000000', 'consum', 0.0212, 'lps'),
	(670154, 132, '2015-02-01 00:57:07.000000', 'consum', 0.0232, 'lps'),
	(670155, 132, '2015-02-01 00:57:08.000000', 'consum', 0.0315, 'lps'),
	(670156, 132, '2015-02-01 00:57:09.000000', 'consum', 0.0322, 'lps'),
	(670157, 132, '2015-02-01 00:57:10.000000', 'consum', 0.0221, 'lps'),
	(670158, 132, '2015-02-01 00:57:11.000000', 'consum', 0.0280, 'lps'),
	(670159, 132, '2015-02-01 00:57:12.000000', 'consum', 0.0294, 'lps'),
	(670160, 132, '2015-02-01 00:57:13.000000', 'consum', 0.0307, 'lps'),
	(670161, 132, '2015-02-01 00:57:14.000000', 'consum', 0.0210, 'lps'),
	(670162, 132, '2015-02-01 00:57:15.000000', 'consum', 0.0268, 'lps'),
	(670163, 132, '2015-02-01 00:57:16.000000', 'consum', 0.0268, 'lps'),
	(670164, 132, '2015-02-01 00:57:17.000000', 'consum', 0.0210, 'lps'),
	(670165, 132, '2015-02-01 00:57:18.000000', 'consum', 0.0267, 'lps'),
	(670166, 132, '2015-02-01 00:57:19.000000', 'consum', 0.0264, 'lps'),
	(670167, 132, '2015-02-01 00:57:20.000000', 'consum', 0.0311, 'lps'),
	(670168, 132, '2015-02-01 00:57:21.000000', 'consum', 0.0319, 'lps'),
	(670169, 132, '2015-02-01 00:57:22.000000', 'consum', 0.0224, 'lps'),
	(670170, 132, '2015-02-01 00:57:23.000000', 'consum', 0.0299, 'lps'),
	(670171, 132, '2015-02-01 00:57:24.000000', 'consum', 0.0267, 'lps'),
	(670172, 132, '2015-02-01 00:57:25.000000', 'consum', 0.0226, 'lps'),
	(670173, 132, '2015-02-01 00:57:26.000000', 'consum', 0.0238, 'lps'),
	(670174, 132, '2015-02-01 00:57:27.000000', 'consum', 0.0301, 'lps'),
	(670175, 132, '2015-02-01 00:57:28.000000', 'consum', 0.0232, 'lps'),
	(670176, 132, '2015-02-01 00:57:29.000000', 'consum', 0.0282, 'lps'),
	(670177, 132, '2015-02-01 00:57:30.000000', 'consum', 0.0272, 'lps'),
	(670178, 132, '2015-02-01 00:57:31.000000', 'consum', 0.0304, 'lps'),
	(670179, 132, '2015-02-01 00:57:32.000000', 'consum', 0.0261, 'lps'),
	(670180, 132, '2015-02-01 00:57:33.000000', 'consum', 0.0300, 'lps'),
	(670181, 132, '2015-02-01 00:57:34.000000', 'consum', 0.0277, 'lps'),
	(670182, 132, '2015-02-01 00:57:35.000000', 'consum', 0.0276, 'lps'),
	(670183, 132, '2015-02-01 00:57:36.000000', 'consum', 0.0224, 'lps'),
	(670184, 132, '2015-02-01 00:57:37.000000', 'consum', 0.0313, 'lps'),
	(670185, 132, '2015-02-01 00:57:38.000000', 'consum', 0.0220, 'lps'),
	(670186, 132, '2015-02-01 00:57:39.000000', 'consum', 0.0298, 'lps'),
	(670187, 132, '2015-02-01 00:57:40.000000', 'consum', 0.0276, 'lps'),
	(670188, 132, '2015-02-01 00:57:41.000000', 'consum', 0.0273, 'lps'),
	(670189, 132, '2015-02-01 00:57:42.000000', 'consum', 0.0213, 'lps'),
	(670190, 132, '2015-02-01 00:57:43.000000', 'consum', 0.0269, 'lps'),
	(670191, 132, '2015-02-01 00:57:44.000000', 'consum', 0.0262, 'lps'),
	(670192, 132, '2015-02-01 00:57:45.000000', 'consum', 0.0295, 'lps'),
	(670193, 132, '2015-02-01 00:57:46.000000', 'consum', 0.0249, 'lps'),
	(670194, 132, '2015-02-01 00:57:47.000000', 'consum', 0.0267, 'lps'),
	(670195, 132, '2015-02-01 00:57:48.000000', 'consum', 0.0262, 'lps'),
	(670196, 132, '2015-02-01 00:57:49.000000', 'consum', 0.0300, 'lps'),
	(670197, 132, '2015-02-01 00:57:50.000000', 'consum', 0.0273, 'lps'),
	(670198, 132, '2015-02-01 00:57:51.000000', 'consum', 0.0255, 'lps'),
	(670199, 132, '2015-02-01 00:57:52.000000', 'consum', 0.0246, 'lps'),
	(670200, 132, '2015-02-01 00:57:53.000000', 'consum', 0.0255, 'lps'),
	(670201, 132, '2015-02-01 00:57:54.000000', 'consum', 0.0211, 'lps'),
	(670202, 132, '2015-02-01 00:57:55.000000', 'consum', 0.0314, 'lps'),
	(670203, 132, '2015-02-01 00:57:56.000000', 'consum', 0.0264, 'lps'),
	(670204, 132, '2015-02-01 00:57:57.000000', 'consum', 0.0282, 'lps'),
	(670205, 132, '2015-02-01 00:57:58.000000', 'consum', 0.0292, 'lps'),
	(670206, 132, '2015-02-01 00:57:59.000000', 'consum', 0.0290, 'lps'),
	(670207, 132, '2015-02-01 00:58:00.000000', 'consum', 0.0248, 'lps'),
	(670208, 132, '2015-02-01 00:58:01.000000', 'consum', 0.0278, 'lps'),
	(670209, 132, '2015-02-01 00:58:02.000000', 'consum', 0.0321, 'lps'),
	(670210, 132, '2015-02-01 00:58:03.000000', 'consum', 0.0214, 'lps'),
	(670211, 132, '2015-02-01 00:58:04.000000', 'consum', 0.0244, 'lps'),
	(670212, 132, '2015-02-01 00:58:05.000000', 'consum', 0.0253, 'lps'),
	(670213, 132, '2015-02-01 00:58:06.000000', 'consum', 0.0325, 'lps'),
	(670214, 132, '2015-02-01 00:58:07.000000', 'consum', 0.0306, 'lps'),
	(670215, 132, '2015-02-01 00:58:08.000000', 'consum', 0.0231, 'lps'),
	(670216, 132, '2015-02-01 00:58:09.000000', 'consum', 0.0257, 'lps'),
	(670217, 132, '2015-02-01 00:58:10.000000', 'consum', 0.0270, 'lps'),
	(670218, 132, '2015-02-01 00:58:11.000000', 'consum', 0.0252, 'lps'),
	(670219, 132, '2015-02-01 00:58:12.000000', 'consum', 0.0242, 'lps'),
	(670220, 132, '2015-02-01 00:58:13.000000', 'consum', 0.0244, 'lps'),
	(670221, 132, '2015-02-01 00:58:14.000000', 'consum', 0.0284, 'lps'),
	(670222, 132, '2015-02-01 00:58:15.000000', 'consum', 0.0245, 'lps'),
	(670223, 132, '2015-02-01 00:58:16.000000', 'consum', 0.0280, 'lps'),
	(670224, 132, '2015-02-01 00:58:17.000000', 'consum', 0.0222, 'lps'),
	(670225, 132, '2015-02-01 00:58:18.000000', 'consum', 0.0294, 'lps'),
	(670226, 132, '2015-02-01 00:58:19.000000', 'consum', 0.0247, 'lps'),
	(670227, 132, '2015-02-01 00:58:20.000000', 'consum', 0.0261, 'lps'),
	(670228, 132, '2015-02-01 00:58:21.000000', 'consum', 0.0236, 'lps'),
	(670229, 132, '2015-02-01 00:58:22.000000', 'consum', 0.0303, 'lps'),
	(670230, 132, '2015-02-01 00:58:23.000000', 'consum', 0.0250, 'lps'),
	(670231, 132, '2015-02-01 00:58:24.000000', 'consum', 0.0250, 'lps'),
	(670232, 132, '2015-02-01 00:58:25.000000', 'consum', 0.0288, 'lps'),
	(670233, 132, '2015-02-01 00:58:26.000000', 'consum', 0.0249, 'lps'),
	(670234, 132, '2015-02-01 00:58:27.000000', 'consum', 0.0289, 'lps'),
	(670235, 132, '2015-02-01 00:58:28.000000', 'consum', 0.0254, 'lps'),
	(670236, 132, '2015-02-01 00:58:29.000000', 'consum', 0.0310, 'lps'),
	(670237, 132, '2015-02-01 00:58:30.000000', 'consum', 0.0232, 'lps'),
	(670238, 132, '2015-02-01 00:58:31.000000', 'consum', 0.0251, 'lps'),
	(670239, 132, '2015-02-01 00:58:32.000000', 'consum', 0.0235, 'lps'),
	(670240, 132, '2015-02-01 00:58:33.000000', 'consum', 0.0210, 'lps'),
	(670241, 132, '2015-02-01 00:58:34.000000', 'consum', 0.0253, 'lps'),
	(670242, 132, '2015-02-01 00:58:35.000000', 'consum', 0.0308, 'lps'),
	(670243, 132, '2015-02-01 00:58:36.000000', 'consum', 0.0224, 'lps'),
	(670244, 132, '2015-02-01 00:58:37.000000', 'consum', 0.0218, 'lps'),
	(670245, 132, '2015-02-01 00:58:38.000000', 'consum', 0.0324, 'lps'),
	(670246, 132, '2015-02-01 00:58:39.000000', 'consum', 0.0292, 'lps'),
	(670247, 132, '2015-02-01 00:58:40.000000', 'consum', 0.0281, 'lps'),
	(670248, 132, '2015-02-01 00:58:41.000000', 'consum', 0.0317, 'lps'),
	(670249, 132, '2015-02-01 00:58:42.000000', 'consum', 0.0303, 'lps'),
	(670250, 132, '2015-02-01 00:58:43.000000', 'consum', 0.0239, 'lps'),
	(670251, 132, '2015-02-01 00:58:44.000000', 'consum', 0.0308, 'lps'),
	(670252, 132, '2015-02-01 00:58:45.000000', 'consum', 0.0265, 'lps'),
	(670253, 132, '2015-02-01 00:58:46.000000', 'consum', 0.0309, 'lps'),
	(670254, 132, '2015-02-01 00:58:47.000000', 'consum', 0.0306, 'lps'),
	(670255, 132, '2015-02-01 00:58:48.000000', 'consum', 0.0279, 'lps'),
	(670256, 132, '2015-02-01 00:58:49.000000', 'consum', 0.0269, 'lps'),
	(670257, 132, '2015-02-01 00:58:50.000000', 'consum', 0.0295, 'lps'),
	(670258, 132, '2015-02-01 00:58:51.000000', 'consum', 0.0229, 'lps'),
	(670259, 132, '2015-02-01 00:58:52.000000', 'consum', 0.0282, 'lps'),
	(670260, 132, '2015-02-01 00:58:53.000000', 'consum', 0.0282, 'lps'),
	(670261, 132, '2015-02-01 00:58:54.000000', 'consum', 0.0237, 'lps'),
	(670262, 132, '2015-02-01 00:58:55.000000', 'consum', 0.0246, 'lps'),
	(670263, 132, '2015-02-01 00:58:56.000000', 'consum', 0.0309, 'lps'),
	(670264, 132, '2015-02-01 00:58:57.000000', 'consum', 0.0250, 'lps'),
	(670265, 132, '2015-02-01 00:58:58.000000', 'consum', 0.0228, 'lps'),
	(670266, 132, '2015-02-01 00:58:59.000000', 'consum', 0.0299, 'lps'),
	(670267, 132, '2015-02-01 00:59:00.000000', 'consum', 0.0253, 'lps'),
	(670268, 132, '2015-02-01 00:59:01.000000', 'consum', 0.0273, 'lps'),
	(670269, 132, '2015-02-01 00:59:02.000000', 'consum', 0.0282, 'lps'),
	(670270, 132, '2015-02-01 00:59:03.000000', 'consum', 0.0264, 'lps'),
	(670271, 132, '2015-02-01 00:59:04.000000', 'consum', 0.0264, 'lps'),
	(670272, 132, '2015-02-01 00:59:05.000000', 'consum', 0.0320, 'lps'),
	(670273, 132, '2015-02-01 00:59:06.000000', 'consum', 0.0250, 'lps'),
	(670274, 132, '2015-02-01 00:59:07.000000', 'consum', 0.0313, 'lps'),
	(670275, 132, '2015-02-01 00:59:08.000000', 'consum', 0.0256, 'lps'),
	(670276, 132, '2015-02-01 00:59:09.000000', 'consum', 0.0249, 'lps'),
	(670277, 132, '2015-02-01 00:59:10.000000', 'consum', 0.0269, 'lps'),
	(670278, 132, '2015-02-01 00:59:11.000000', 'consum', 0.0269, 'lps'),
	(670279, 132, '2015-02-01 00:59:12.000000', 'consum', 0.0215, 'lps'),
	(670280, 132, '2015-02-01 00:59:13.000000', 'consum', 0.0291, 'lps'),
	(670281, 132, '2015-02-01 00:59:14.000000', 'consum', 0.0254, 'lps'),
	(670282, 132, '2015-02-01 00:59:15.000000', 'consum', 0.0300, 'lps'),
	(670283, 132, '2015-02-01 00:59:16.000000', 'consum', 0.0300, 'lps'),
	(670284, 132, '2015-02-01 00:59:17.000000', 'consum', 0.0272, 'lps'),
	(670285, 132, '2015-02-01 00:59:18.000000', 'consum', 0.0249, 'lps'),
	(670286, 132, '2015-02-01 00:59:19.000000', 'consum', 0.0223, 'lps'),
	(670287, 132, '2015-02-01 00:59:20.000000', 'consum', 0.0272, 'lps'),
	(670288, 132, '2015-02-01 00:59:21.000000', 'consum', 0.0249, 'lps'),
	(670289, 132, '2015-02-01 00:59:22.000000', 'consum', 0.0220, 'lps'),
	(670290, 132, '2015-02-01 00:59:23.000000', 'consum', 0.0260, 'lps'),
	(670291, 132, '2015-02-01 00:59:24.000000', 'consum', 0.0315, 'lps'),
	(670292, 132, '2015-02-01 00:59:25.000000', 'consum', 0.0235, 'lps'),
	(670293, 132, '2015-02-01 00:59:26.000000', 'consum', 0.0254, 'lps'),
	(670294, 132, '2015-02-01 00:59:27.000000', 'consum', 0.0239, 'lps'),
	(670295, 132, '2015-02-01 00:59:28.000000', 'consum', 0.0222, 'lps'),
	(670296, 132, '2015-02-01 00:59:29.000000', 'consum', 0.0299, 'lps'),
	(670297, 132, '2015-02-01 00:59:30.000000', 'consum', 0.0274, 'lps'),
	(670298, 132, '2015-02-01 00:59:31.000000', 'consum', 0.0263, 'lps'),
	(670299, 132, '2015-02-01 00:59:32.000000', 'consum', 0.0285, 'lps'),
	(670300, 132, '2015-02-01 00:59:33.000000', 'consum', 0.0310, 'lps'),
	(670301, 132, '2015-02-01 00:59:34.000000', 'consum', 0.0254, 'lps'),
	(670302, 132, '2015-02-01 00:59:35.000000', 'consum', 0.0248, 'lps'),
	(670303, 132, '2015-02-01 00:59:36.000000', 'consum', 0.0266, 'lps'),
	(670304, 132, '2015-02-01 00:59:37.000000', 'consum', 0.0259, 'lps'),
	(670305, 132, '2015-02-01 00:59:38.000000', 'consum', 0.0290, 'lps'),
	(670306, 132, '2015-02-01 00:59:39.000000', 'consum', 0.0232, 'lps'),
	(670307, 132, '2015-02-01 00:59:40.000000', 'consum', 0.0312, 'lps'),
	(670308, 132, '2015-02-01 00:59:41.000000', 'consum', 0.0307, 'lps'),
	(670309, 132, '2015-02-01 00:59:42.000000', 'consum', 0.0275, 'lps'),
	(670310, 132, '2015-02-01 00:59:43.000000', 'consum', 0.0242, 'lps'),
	(670311, 132, '2015-02-01 00:59:44.000000', 'consum', 0.0294, 'lps'),
	(670312, 132, '2015-02-01 00:59:45.000000', 'consum', 0.0299, 'lps'),
	(670313, 132, '2015-02-01 00:59:46.000000', 'consum', 0.0291, 'lps'),
	(670314, 132, '2015-02-01 00:59:47.000000', 'consum', 0.0230, 'lps'),
	(670315, 132, '2015-02-01 00:59:48.000000', 'consum', 0.0302, 'lps'),
	(670316, 132, '2015-02-01 00:59:49.000000', 'consum', 0.0260, 'lps'),
	(670317, 132, '2015-02-01 00:59:50.000000', 'consum', 0.0302, 'lps'),
	(670318, 132, '2015-02-01 00:59:51.000000', 'consum', 0.0289, 'lps'),
	(670319, 132, '2015-02-01 00:59:52.000000', 'consum', 0.0211, 'lps'),
	(670320, 132, '2015-02-01 00:59:53.000000', 'consum', 0.0212, 'lps'),
	(670321, 132, '2015-02-01 00:59:54.000000', 'consum', 0.0219, 'lps'),
	(670322, 132, '2015-02-01 00:59:55.000000', 'consum', 0.0248, 'lps'),
	(670323, 132, '2015-02-01 00:59:56.000000', 'consum', 0.0256, 'lps'),
	(670324, 132, '2015-02-01 00:59:57.000000', 'consum', 0.0211, 'lps'),
	(670325, 132, '2015-02-01 00:59:58.000000', 'consum', 0.0311, 'lps'),
	(670326, 132, '2015-02-01 00:59:59.000000', 'consum', 0.0247, 'lps'),
	(670327, 132, '2015-02-01 01:00:00.000000', 'consum', 0.0210, 'lps'),
	(670328, 132, '2015-02-01 01:00:01.000000', 'consum', 0.0215, 'lps'),
	(670329, 132, '2015-02-01 01:00:02.000000', 'consum', 0.0234, 'lps'),
	(670330, 132, '2015-02-01 01:00:03.000000', 'consum', 0.0316, 'lps'),
	(670331, 132, '2015-02-01 01:00:04.000000', 'consum', 0.0322, 'lps'),
	(670332, 132, '2015-02-01 01:00:05.000000', 'consum', 0.0218, 'lps'),
	(670333, 132, '2015-02-01 01:00:06.000000', 'consum', 0.0266, 'lps'),
	(670334, 132, '2015-02-01 01:00:07.000000', 'consum', 0.0232, 'lps'),
	(670335, 132, '2015-02-01 01:00:08.000000', 'consum', 0.0268, 'lps'),
	(670336, 132, '2015-02-01 01:00:09.000000', 'consum', 0.0318, 'lps'),
	(670337, 132, '2015-02-01 01:00:10.000000', 'consum', 0.0230, 'lps'),
	(670338, 132, '2015-02-01 01:00:11.000000', 'consum', 0.0219, 'lps'),
	(670339, 132, '2015-02-01 01:00:12.000000', 'consum', 0.0312, 'lps'),
	(670340, 132, '2015-02-01 01:00:13.000000', 'consum', 0.0227, 'lps'),
	(670341, 132, '2015-02-01 01:00:14.000000', 'consum', 0.0221, 'lps'),
	(670342, 132, '2015-02-01 01:00:15.000000', 'consum', 0.0218, 'lps'),
	(670343, 132, '2015-02-01 01:00:16.000000', 'consum', 0.0214, 'lps'),
	(670344, 132, '2015-02-01 01:00:17.000000', 'consum', 0.0324, 'lps'),
	(670345, 132, '2015-02-01 01:00:18.000000', 'consum', 0.0305, 'lps'),
	(670346, 132, '2015-02-01 01:00:19.000000', 'consum', 0.0228, 'lps'),
	(670347, 132, '2015-02-01 01:00:20.000000', 'consum', 0.0246, 'lps'),
	(670348, 132, '2015-02-01 01:00:21.000000', 'consum', 0.0221, 'lps'),
	(670349, 132, '2015-02-01 01:00:22.000000', 'consum', 0.0272, 'lps'),
	(670350, 132, '2015-02-01 01:00:23.000000', 'consum', 0.0258, 'lps'),
	(670351, 132, '2015-02-01 01:00:24.000000', 'consum', 0.0264, 'lps'),
	(670352, 132, '2015-02-01 01:00:25.000000', 'consum', 0.0220, 'lps'),
	(670353, 132, '2015-02-01 01:00:26.000000', 'consum', 0.0214, 'lps'),
	(670354, 132, '2015-02-01 01:00:27.000000', 'consum', 0.0317, 'lps'),
	(670355, 132, '2015-02-01 01:00:28.000000', 'consum', 0.0268, 'lps'),
	(670356, 132, '2015-02-01 01:00:29.000000', 'consum', 0.0296, 'lps'),
	(670357, 132, '2015-02-01 01:00:30.000000', 'consum', 0.0237, 'lps'),
	(670358, 132, '2015-02-01 01:00:31.000000', 'consum', 0.0318, 'lps'),
	(670359, 132, '2015-02-01 01:00:32.000000', 'consum', 0.0320, 'lps'),
	(670360, 132, '2015-02-01 01:00:33.000000', 'consum', 0.0320, 'lps'),
	(670361, 132, '2015-02-01 01:00:34.000000', 'consum', 0.0317, 'lps'),
	(670362, 132, '2015-02-01 01:00:35.000000', 'consum', 0.0299, 'lps'),
	(670363, 132, '2015-02-01 01:00:36.000000', 'consum', 0.0219, 'lps'),
	(670364, 132, '2015-02-01 01:00:37.000000', 'consum', 0.0220, 'lps'),
	(670365, 132, '2015-02-01 01:00:38.000000', 'consum', 0.0233, 'lps'),
	(670366, 132, '2015-02-01 01:00:39.000000', 'consum', 0.0295, 'lps'),
	(670367, 132, '2015-02-01 01:00:40.000000', 'consum', 0.0221, 'lps'),
	(670368, 132, '2015-02-01 01:00:41.000000', 'consum', 0.0242, 'lps'),
	(670369, 132, '2015-02-01 01:00:42.000000', 'consum', 0.0221, 'lps'),
	(670370, 132, '2015-02-01 01:00:43.000000', 'consum', 0.0284, 'lps'),
	(670371, 132, '2015-02-01 01:00:44.000000', 'consum', 0.0316, 'lps'),
	(670372, 132, '2015-02-01 01:00:45.000000', 'consum', 0.0286, 'lps'),
	(670373, 132, '2015-02-01 01:00:46.000000', 'consum', 0.0272, 'lps'),
	(670374, 132, '2015-02-01 01:00:47.000000', 'consum', 0.0294, 'lps'),
	(670375, 132, '2015-02-01 01:00:48.000000', 'consum', 0.0213, 'lps'),
	(670376, 132, '2015-02-01 01:00:49.000000', 'consum', 0.0322, 'lps'),
	(670377, 132, '2015-02-01 01:00:50.000000', 'consum', 0.0296, 'lps'),
	(670378, 132, '2015-02-01 01:00:51.000000', 'consum', 0.0304, 'lps'),
	(670379, 132, '2015-02-01 01:00:52.000000', 'consum', 0.0308, 'lps'),
	(670380, 132, '2015-02-01 01:00:53.000000', 'consum', 0.0302, 'lps'),
	(670381, 132, '2015-02-01 01:00:54.000000', 'consum', 0.0261, 'lps'),
	(670382, 132, '2015-02-01 01:00:55.000000', 'consum', 0.0305, 'lps'),
	(670383, 132, '2015-02-01 01:00:56.000000', 'consum', 0.0299, 'lps'),
	(670384, 132, '2015-02-01 01:00:57.000000', 'consum', 0.0255, 'lps'),
	(670385, 132, '2015-02-01 01:00:58.000000', 'consum', 0.0285, 'lps'),
	(670386, 132, '2015-02-01 01:00:59.000000', 'consum', 0.0219, 'lps'),
	(670387, 132, '2015-02-01 01:01:00.000000', 'consum', 0.0264, 'lps'),
	(670388, 132, '2015-02-01 01:01:01.000000', 'consum', 0.0218, 'lps'),
	(670389, 132, '2015-02-01 01:01:02.000000', 'consum', 0.0323, 'lps'),
	(670390, 132, '2015-02-01 01:01:03.000000', 'consum', 0.0285, 'lps'),
	(670391, 132, '2015-02-01 01:01:04.000000', 'consum', 0.0248, 'lps'),
	(670392, 132, '2015-02-01 01:01:05.000000', 'consum', 0.0291, 'lps'),
	(670393, 132, '2015-02-01 01:01:06.000000', 'consum', 0.0271, 'lps'),
	(670394, 132, '2015-02-01 01:01:07.000000', 'consum', 0.0272, 'lps'),
	(670395, 132, '2015-02-01 01:01:08.000000', 'consum', 0.0221, 'lps'),
	(670396, 132, '2015-02-01 01:01:09.000000', 'consum', 0.0312, 'lps'),
	(670397, 132, '2015-02-01 01:01:10.000000', 'consum', 0.0224, 'lps'),
	(670398, 132, '2015-02-01 01:01:11.000000', 'consum', 0.0324, 'lps'),
	(670399, 132, '2015-02-01 01:01:12.000000', 'consum', 0.0271, 'lps'),
	(670400, 132, '2015-02-01 01:01:13.000000', 'consum', 0.0293, 'lps'),
	(670401, 132, '2015-02-01 01:01:14.000000', 'consum', 0.0324, 'lps'),
	(670402, 132, '2015-02-01 01:01:15.000000', 'consum', 0.0300, 'lps'),
	(670403, 132, '2015-02-01 01:01:16.000000', 'consum', 0.0318, 'lps'),
	(670404, 132, '2015-02-01 01:01:17.000000', 'consum', 0.0247, 'lps'),
	(670405, 132, '2015-02-01 01:01:18.000000', 'consum', 0.0306, 'lps'),
	(670406, 132, '2015-02-01 01:01:19.000000', 'consum', 0.0230, 'lps'),
	(670407, 132, '2015-02-01 01:01:20.000000', 'consum', 0.0257, 'lps'),
	(670408, 132, '2015-02-01 01:01:21.000000', 'consum', 0.0266, 'lps'),
	(670409, 132, '2015-02-01 01:01:22.000000', 'consum', 0.0236, 'lps'),
	(670410, 132, '2015-02-01 01:01:23.000000', 'consum', 0.0288, 'lps'),
	(670411, 132, '2015-02-01 01:01:24.000000', 'consum', 0.0291, 'lps'),
	(670412, 132, '2015-02-01 01:01:25.000000', 'consum', 0.0267, 'lps'),
	(670413, 132, '2015-02-01 01:01:26.000000', 'consum', 0.0252, 'lps'),
	(670414, 132, '2015-02-01 01:01:27.000000', 'consum', 0.0247, 'lps'),
	(670415, 132, '2015-02-01 01:01:28.000000', 'consum', 0.0273, 'lps'),
	(670416, 132, '2015-02-01 01:01:29.000000', 'consum', 0.0297, 'lps'),
	(670417, 132, '2015-02-01 01:01:30.000000', 'consum', 0.0223, 'lps'),
	(670418, 132, '2015-02-01 01:01:31.000000', 'consum', 0.0247, 'lps'),
	(670419, 132, '2015-02-01 01:01:32.000000', 'consum', 0.0240, 'lps'),
	(670420, 132, '2015-02-01 01:01:33.000000', 'consum', 0.0252, 'lps'),
	(670421, 132, '2015-02-01 01:01:34.000000', 'consum', 0.0214, 'lps'),
	(670422, 132, '2015-02-01 01:01:35.000000', 'consum', 0.0218, 'lps'),
	(670423, 132, '2015-02-01 01:01:36.000000', 'consum', 0.0239, 'lps'),
	(670424, 132, '2015-02-01 01:01:37.000000', 'consum', 0.0217, 'lps'),
	(670425, 132, '2015-02-01 01:01:38.000000', 'consum', 0.0275, 'lps'),
	(670426, 132, '2015-02-01 01:01:39.000000', 'consum', 0.0282, 'lps'),
	(670427, 132, '2015-02-01 01:01:40.000000', 'consum', 0.0259, 'lps'),
	(670428, 132, '2015-02-01 01:01:41.000000', 'consum', 0.0239, 'lps'),
	(670429, 132, '2015-02-01 01:01:42.000000', 'consum', 0.0324, 'lps'),
	(670430, 132, '2015-02-01 01:01:43.000000', 'consum', 0.0232, 'lps'),
	(670431, 132, '2015-02-01 01:01:44.000000', 'consum', 0.0325, 'lps'),
	(670432, 132, '2015-02-01 01:01:45.000000', 'consum', 0.0254, 'lps'),
	(670433, 132, '2015-02-01 01:01:46.000000', 'consum', 0.0317, 'lps'),
	(670434, 132, '2015-02-01 01:01:47.000000', 'consum', 0.0265, 'lps'),
	(670435, 132, '2015-02-01 01:01:48.000000', 'consum', 0.0283, 'lps'),
	(670436, 132, '2015-02-01 01:01:49.000000', 'consum', 0.0294, 'lps'),
	(670437, 132, '2015-02-01 01:01:50.000000', 'consum', 0.0293, 'lps'),
	(670438, 132, '2015-02-01 01:01:51.000000', 'consum', 0.0261, 'lps'),
	(670439, 132, '2015-02-01 01:01:52.000000', 'consum', 0.0215, 'lps'),
	(670440, 132, '2015-02-01 01:01:53.000000', 'consum', 0.0316, 'lps'),
	(670441, 132, '2015-02-01 01:01:54.000000', 'consum', 0.0258, 'lps'),
	(670442, 132, '2015-02-01 01:01:55.000000', 'consum', 0.0252, 'lps'),
	(670443, 132, '2015-02-01 01:01:56.000000', 'consum', 0.0275, 'lps'),
	(670444, 132, '2015-02-01 01:01:57.000000', 'consum', 0.0293, 'lps'),
	(670445, 132, '2015-02-01 01:01:58.000000', 'consum', 0.0314, 'lps'),
	(670446, 132, '2015-02-01 01:01:59.000000', 'consum', 0.0250, 'lps'),
	(670447, 132, '2015-02-01 01:02:00.000000', 'consum', 0.0217, 'lps'),
	(670448, 132, '2015-02-01 01:02:01.000000', 'consum', 0.0238, 'lps'),
	(670449, 132, '2015-02-01 01:02:02.000000', 'consum', 0.0215, 'lps'),
	(670450, 132, '2015-02-01 01:02:03.000000', 'consum', 0.0267, 'lps'),
	(670451, 132, '2015-02-01 01:02:04.000000', 'consum', 0.0247, 'lps'),
	(670452, 132, '2015-02-01 01:02:05.000000', 'consum', 0.0226, 'lps'),
	(670453, 132, '2015-02-01 01:02:06.000000', 'consum', 0.0294, 'lps'),
	(670454, 132, '2015-02-01 01:02:07.000000', 'consum', 0.0235, 'lps'),
	(670455, 132, '2015-02-01 01:02:08.000000', 'consum', 0.0318, 'lps'),
	(670456, 132, '2015-02-01 01:02:09.000000', 'consum', 0.0325, 'lps'),
	(670457, 132, '2015-02-01 01:02:10.000000', 'consum', 0.0231, 'lps'),
	(670458, 132, '2015-02-01 01:02:11.000000', 'consum', 0.0317, 'lps'),
	(670459, 132, '2015-02-01 01:02:12.000000', 'consum', 0.0220, 'lps'),
	(670460, 132, '2015-02-01 01:02:13.000000', 'consum', 0.0289, 'lps'),
	(670461, 132, '2015-02-01 01:02:14.000000', 'consum', 0.0224, 'lps'),
	(670462, 132, '2015-02-01 01:02:15.000000', 'consum', 0.0279, 'lps'),
	(670463, 132, '2015-02-01 01:02:16.000000', 'consum', 0.0280, 'lps'),
	(670464, 132, '2015-02-01 01:02:17.000000', 'consum', 0.0239, 'lps'),
	(670465, 132, '2015-02-01 01:02:18.000000', 'consum', 0.0259, 'lps'),
	(670466, 132, '2015-02-01 01:02:19.000000', 'consum', 0.0254, 'lps'),
	(670467, 132, '2015-02-01 01:02:20.000000', 'consum', 0.0282, 'lps'),
	(670468, 132, '2015-02-01 01:02:21.000000', 'consum', 0.0324, 'lps'),
	(670469, 132, '2015-02-01 01:02:22.000000', 'consum', 0.0214, 'lps'),
	(670470, 132, '2015-02-01 01:02:23.000000', 'consum', 0.0240, 'lps'),
	(670471, 132, '2015-02-01 01:02:24.000000', 'consum', 0.0231, 'lps'),
	(670472, 132, '2015-02-01 01:02:25.000000', 'consum', 0.0226, 'lps'),
	(670473, 132, '2015-02-01 01:02:26.000000', 'consum', 0.0228, 'lps'),
	(670474, 132, '2015-02-01 01:02:27.000000', 'consum', 0.0251, 'lps'),
	(670475, 132, '2015-02-01 01:02:28.000000', 'consum', 0.0247, 'lps'),
	(670476, 132, '2015-02-01 01:02:29.000000', 'consum', 0.0272, 'lps'),
	(670477, 132, '2015-02-01 01:02:30.000000', 'consum', 0.0293, 'lps'),
	(670478, 132, '2015-02-01 01:02:31.000000', 'consum', 0.0323, 'lps'),
	(670479, 132, '2015-02-01 01:02:32.000000', 'consum', 0.0294, 'lps'),
	(670480, 132, '2015-02-01 01:02:33.000000', 'consum', 0.0294, 'lps'),
	(670481, 132, '2015-02-01 01:02:34.000000', 'consum', 0.0261, 'lps'),
	(670482, 132, '2015-02-01 01:02:35.000000', 'consum', 0.0213, 'lps'),
	(670483, 132, '2015-02-01 01:02:36.000000', 'consum', 0.0307, 'lps'),
	(670484, 132, '2015-02-01 01:02:37.000000', 'consum', 0.0219, 'lps'),
	(670485, 132, '2015-02-01 01:02:38.000000', 'consum', 0.0314, 'lps'),
	(670486, 132, '2015-02-01 01:02:39.000000', 'consum', 0.0239, 'lps'),
	(670487, 132, '2015-02-01 01:02:40.000000', 'consum', 0.0274, 'lps'),
	(670488, 132, '2015-02-01 01:02:41.000000', 'consum', 0.0212, 'lps'),
	(670489, 132, '2015-02-01 01:02:42.000000', 'consum', 0.0263, 'lps'),
	(670490, 132, '2015-02-01 01:02:43.000000', 'consum', 0.0235, 'lps'),
	(670491, 132, '2015-02-01 01:02:44.000000', 'consum', 0.0294, 'lps'),
	(670492, 132, '2015-02-01 01:02:45.000000', 'consum', 0.0322, 'lps'),
	(670493, 132, '2015-02-01 01:02:46.000000', 'consum', 0.0286, 'lps'),
	(670494, 132, '2015-02-01 01:02:47.000000', 'consum', 0.0254, 'lps'),
	(670495, 132, '2015-02-01 01:02:48.000000', 'consum', 0.0319, 'lps'),
	(670496, 132, '2015-02-01 01:02:49.000000', 'consum', 0.0277, 'lps'),
	(670497, 132, '2015-02-01 01:02:50.000000', 'consum', 0.0219, 'lps'),
	(670498, 132, '2015-02-01 01:02:51.000000', 'consum', 0.0284, 'lps'),
	(670499, 132, '2015-02-01 01:02:52.000000', 'consum', 0.0325, 'lps'),
	(670500, 132, '2015-02-01 01:02:53.000000', 'consum', 0.0212, 'lps'),
	(670501, 132, '2015-02-01 01:02:54.000000', 'consum', 0.0225, 'lps'),
	(670502, 132, '2015-02-01 01:02:55.000000', 'consum', 0.0279, 'lps'),
	(670503, 132, '2015-02-01 01:02:56.000000', 'consum', 0.0280, 'lps'),
	(670504, 132, '2015-02-01 01:02:57.000000', 'consum', 0.0238, 'lps'),
	(670505, 132, '2015-02-01 01:02:58.000000', 'consum', 0.0254, 'lps'),
	(670506, 132, '2015-02-01 01:02:59.000000', 'consum', 0.0233, 'lps'),
	(670507, 132, '2015-02-01 01:03:00.000000', 'consum', 0.0307, 'lps'),
	(670508, 132, '2015-02-01 01:03:01.000000', 'consum', 0.0280, 'lps'),
	(670509, 132, '2015-02-01 01:03:02.000000', 'consum', 0.0270, 'lps'),
	(670510, 132, '2015-02-01 01:03:03.000000', 'consum', 0.0299, 'lps'),
	(670511, 132, '2015-02-01 01:03:04.000000', 'consum', 0.0242, 'lps'),
	(670512, 132, '2015-02-01 01:03:05.000000', 'consum', 0.0221, 'lps'),
	(670513, 132, '2015-02-01 01:03:06.000000', 'consum', 0.0287, 'lps'),
	(670514, 132, '2015-02-01 01:03:07.000000', 'consum', 0.0214, 'lps'),
	(670515, 132, '2015-02-01 01:03:08.000000', 'consum', 0.0232, 'lps'),
	(670516, 132, '2015-02-01 01:03:09.000000', 'consum', 0.0308, 'lps'),
	(670517, 132, '2015-02-01 01:03:10.000000', 'consum', 0.0288, 'lps'),
	(670518, 132, '2015-02-01 01:03:11.000000', 'consum', 0.0307, 'lps'),
	(670519, 132, '2015-02-01 01:03:12.000000', 'consum', 0.0229, 'lps'),
	(670520, 132, '2015-02-01 01:03:13.000000', 'consum', 0.0247, 'lps'),
	(670521, 132, '2015-02-01 01:03:14.000000', 'consum', 0.0222, 'lps'),
	(670522, 132, '2015-02-01 01:03:15.000000', 'consum', 0.0274, 'lps'),
	(670523, 132, '2015-02-01 01:03:16.000000', 'consum', 0.0264, 'lps'),
	(670524, 132, '2015-02-01 01:03:17.000000', 'consum', 0.0287, 'lps'),
	(670525, 132, '2015-02-01 01:03:18.000000', 'consum', 0.0319, 'lps'),
	(670526, 132, '2015-02-01 01:03:19.000000', 'consum', 0.0294, 'lps'),
	(670527, 132, '2015-02-01 01:03:20.000000', 'consum', 0.0301, 'lps'),
	(670528, 132, '2015-02-01 01:03:21.000000', 'consum', 0.0299, 'lps'),
	(670529, 132, '2015-02-01 01:03:22.000000', 'consum', 0.0266, 'lps'),
	(670530, 132, '2015-02-01 01:03:23.000000', 'consum', 0.0225, 'lps'),
	(670531, 132, '2015-02-01 01:03:24.000000', 'consum', 0.0232, 'lps'),
	(670532, 132, '2015-02-01 01:03:25.000000', 'consum', 0.0276, 'lps'),
	(670533, 132, '2015-02-01 01:03:26.000000', 'consum', 0.0244, 'lps'),
	(670534, 132, '2015-02-01 01:03:27.000000', 'consum', 0.0297, 'lps'),
	(670535, 132, '2015-02-01 01:03:28.000000', 'consum', 0.0310, 'lps'),
	(670536, 132, '2015-02-01 01:03:29.000000', 'consum', 0.0218, 'lps'),
	(670537, 132, '2015-02-01 01:03:30.000000', 'consum', 0.0298, 'lps'),
	(670538, 132, '2015-02-01 01:03:31.000000', 'consum', 0.0277, 'lps'),
	(670539, 132, '2015-02-01 01:03:32.000000', 'consum', 0.0284, 'lps'),
	(670540, 132, '2015-02-01 01:03:33.000000', 'consum', 0.0264, 'lps'),
	(670541, 132, '2015-02-01 01:03:34.000000', 'consum', 0.0258, 'lps'),
	(670542, 132, '2015-02-01 01:03:35.000000', 'consum', 0.0288, 'lps'),
	(670543, 132, '2015-02-01 01:03:36.000000', 'consum', 0.0223, 'lps'),
	(670544, 132, '2015-02-01 01:03:37.000000', 'consum', 0.0274, 'lps'),
	(670545, 132, '2015-02-01 01:03:38.000000', 'consum', 0.0261, 'lps'),
	(670546, 132, '2015-02-01 01:03:39.000000', 'consum', 0.0275, 'lps'),
	(670547, 132, '2015-02-01 01:03:40.000000', 'consum', 0.0264, 'lps'),
	(670548, 132, '2015-02-01 01:03:41.000000', 'consum', 0.0284, 'lps'),
	(670549, 132, '2015-02-01 01:03:42.000000', 'consum', 0.0306, 'lps'),
	(670550, 132, '2015-02-01 01:03:43.000000', 'consum', 0.0235, 'lps'),
	(670551, 132, '2015-02-01 01:03:44.000000', 'consum', 0.0278, 'lps'),
	(670552, 132, '2015-02-01 01:03:45.000000', 'consum', 0.0244, 'lps'),
	(670553, 132, '2015-02-01 01:03:46.000000', 'consum', 0.0294, 'lps'),
	(670554, 132, '2015-02-01 01:03:47.000000', 'consum', 0.0295, 'lps'),
	(670555, 132, '2015-02-01 01:03:48.000000', 'consum', 0.0270, 'lps'),
	(670556, 132, '2015-02-01 01:03:49.000000', 'consum', 0.0254, 'lps'),
	(670557, 132, '2015-02-01 01:03:50.000000', 'consum', 0.0250, 'lps'),
	(670558, 132, '2015-02-01 01:03:51.000000', 'consum', 0.0280, 'lps'),
	(670559, 132, '2015-02-01 01:03:52.000000', 'consum', 0.0324, 'lps'),
	(670560, 132, '2015-02-01 01:03:53.000000', 'consum', 0.0221, 'lps'),
	(670561, 132, '2015-02-01 01:03:54.000000', 'consum', 0.0272, 'lps'),
	(670562, 132, '2015-02-01 01:03:55.000000', 'consum', 0.0257, 'lps'),
	(670563, 132, '2015-02-01 01:03:56.000000', 'consum', 0.0260, 'lps'),
	(670564, 132, '2015-02-01 01:03:57.000000', 'consum', 0.0319, 'lps'),
	(670565, 132, '2015-02-01 01:03:58.000000', 'consum', 0.0256, 'lps'),
	(670566, 132, '2015-02-01 01:03:59.000000', 'consum', 0.0230, 'lps'),
	(670567, 132, '2015-02-01 01:04:00.000000', 'consum', 0.0287, 'lps'),
	(670568, 132, '2015-02-01 01:04:01.000000', 'consum', 0.0304, 'lps'),
	(670569, 132, '2015-02-01 01:04:02.000000', 'consum', 0.0219, 'lps'),
	(670570, 132, '2015-02-01 01:04:03.000000', 'consum', 0.0321, 'lps'),
	(670571, 132, '2015-02-01 01:04:04.000000', 'consum', 0.0274, 'lps'),
	(670572, 132, '2015-02-01 01:04:05.000000', 'consum', 0.0314, 'lps'),
	(670573, 132, '2015-02-01 01:04:06.000000', 'consum', 0.0307, 'lps'),
	(670574, 132, '2015-02-01 01:04:07.000000', 'consum', 0.0266, 'lps'),
	(670575, 132, '2015-02-01 01:04:08.000000', 'consum', 0.0316, 'lps'),
	(670576, 132, '2015-02-01 01:04:09.000000', 'consum', 0.0223, 'lps'),
	(670577, 132, '2015-02-01 01:04:10.000000', 'consum', 0.0308, 'lps'),
	(670578, 132, '2015-02-01 01:04:11.000000', 'consum', 0.0314, 'lps'),
	(670579, 132, '2015-02-01 01:04:12.000000', 'consum', 0.0319, 'lps'),
	(670580, 132, '2015-02-01 01:04:13.000000', 'consum', 0.0211, 'lps'),
	(670581, 132, '2015-02-01 01:04:14.000000', 'consum', 0.0238, 'lps'),
	(670582, 132, '2015-02-01 01:04:15.000000', 'consum', 0.0230, 'lps'),
	(670583, 132, '2015-02-01 01:04:16.000000', 'consum', 0.0229, 'lps'),
	(670584, 132, '2015-02-01 01:04:17.000000', 'consum', 0.0244, 'lps'),
	(670585, 132, '2015-02-01 01:04:18.000000', 'consum', 0.0323, 'lps'),
	(670586, 132, '2015-02-01 01:04:19.000000', 'consum', 0.0325, 'lps'),
	(670587, 132, '2015-02-01 01:04:20.000000', 'consum', 0.0213, 'lps'),
	(670588, 132, '2015-02-01 01:04:21.000000', 'consum', 0.0231, 'lps'),
	(670589, 132, '2015-02-01 01:04:22.000000', 'consum', 0.0307, 'lps'),
	(670590, 132, '2015-02-01 01:04:23.000000', 'consum', 0.0285, 'lps'),
	(670591, 132, '2015-02-01 01:04:24.000000', 'consum', 0.0296, 'lps'),
	(670592, 132, '2015-02-01 01:04:25.000000', 'consum', 0.0296, 'lps'),
	(670593, 132, '2015-02-01 01:04:26.000000', 'consum', 0.0267, 'lps'),
	(670594, 132, '2015-02-01 01:04:27.000000', 'consum', 0.0237, 'lps'),
	(670595, 132, '2015-02-01 01:04:28.000000', 'consum', 0.0292, 'lps'),
	(670596, 132, '2015-02-01 01:04:29.000000', 'consum', 0.0305, 'lps'),
	(670597, 132, '2015-02-01 01:04:30.000000', 'consum', 0.0324, 'lps'),
	(670598, 132, '2015-02-01 01:04:31.000000', 'consum', 0.0265, 'lps'),
	(670599, 132, '2015-02-01 01:04:32.000000', 'consum', 0.0261, 'lps'),
	(670600, 132, '2015-02-01 01:04:33.000000', 'consum', 0.0299, 'lps'),
	(670601, 132, '2015-02-01 01:04:34.000000', 'consum', 0.0269, 'lps'),
	(670602, 132, '2015-02-01 01:04:35.000000', 'consum', 0.0241, 'lps'),
	(670603, 132, '2015-02-01 01:04:36.000000', 'consum', 0.0304, 'lps'),
	(670604, 132, '2015-02-01 01:04:37.000000', 'consum', 0.0237, 'lps'),
	(670605, 132, '2015-02-01 01:04:38.000000', 'consum', 0.0297, 'lps'),
	(670606, 132, '2015-02-01 01:04:39.000000', 'consum', 0.0218, 'lps'),
	(670607, 132, '2015-02-01 01:04:40.000000', 'consum', 0.0219, 'lps'),
	(670608, 132, '2015-02-01 01:04:41.000000', 'consum', 0.0232, 'lps'),
	(670609, 132, '2015-02-01 01:04:42.000000', 'consum', 0.0292, 'lps'),
	(670610, 132, '2015-02-01 01:04:43.000000', 'consum', 0.0323, 'lps'),
	(670611, 132, '2015-02-01 01:04:44.000000', 'consum', 0.0300, 'lps'),
	(670612, 132, '2015-02-01 01:04:45.000000', 'consum', 0.0320, 'lps'),
	(670613, 132, '2015-02-01 01:04:46.000000', 'consum', 0.0257, 'lps'),
	(670614, 132, '2015-02-01 01:04:47.000000', 'consum', 0.0231, 'lps'),
	(670615, 132, '2015-02-01 01:04:48.000000', 'consum', 0.0291, 'lps'),
	(670616, 132, '2015-02-01 01:04:49.000000', 'consum', 0.0319, 'lps'),
	(670617, 132, '2015-02-01 01:04:50.000000', 'consum', 0.0284, 'lps'),
	(670618, 132, '2015-02-01 01:04:51.000000', 'consum', 0.0250, 'lps'),
	(670619, 132, '2015-02-01 01:04:52.000000', 'consum', 0.0308, 'lps'),
	(670620, 132, '2015-02-01 01:04:53.000000', 'consum', 0.0231, 'lps'),
	(670621, 132, '2015-02-01 01:04:54.000000', 'consum', 0.0254, 'lps'),
	(670622, 132, '2015-02-01 01:04:55.000000', 'consum', 0.0252, 'lps'),
	(670623, 132, '2015-02-01 01:04:56.000000', 'consum', 0.0288, 'lps'),
	(670624, 132, '2015-02-01 01:04:57.000000', 'consum', 0.0245, 'lps'),
	(670625, 132, '2015-02-01 01:04:58.000000', 'consum', 0.0264, 'lps'),
	(670626, 132, '2015-02-01 01:04:59.000000', 'consum', 0.0260, 'lps'),
	(670627, 132, '2015-02-01 01:05:00.000000', 'consum', 0.0299, 'lps'),
	(670628, 132, '2015-02-01 01:05:01.000000', 'consum', 0.0272, 'lps'),
	(670629, 132, '2015-02-01 01:05:02.000000', 'consum', 0.0254, 'lps'),
	(670630, 132, '2015-02-01 01:05:03.000000', 'consum', 0.0246, 'lps'),
	(670631, 132, '2015-02-01 01:05:04.000000', 'consum', 0.0259, 'lps'),
	(670632, 132, '2015-02-01 01:05:05.000000', 'consum', 0.0228, 'lps'),
	(670633, 132, '2015-02-01 01:05:06.000000', 'consum', 0.0273, 'lps'),
	(670634, 132, '2015-02-01 01:05:07.000000', 'consum', 0.0240, 'lps'),
	(670635, 132, '2015-02-01 01:05:08.000000', 'consum', 0.0286, 'lps'),
	(670636, 132, '2015-02-01 01:05:09.000000', 'consum', 0.0267, 'lps'),
	(670637, 132, '2015-02-01 01:05:10.000000', 'consum', 0.0268, 'lps'),
	(670638, 132, '2015-02-01 01:05:11.000000', 'consum', 0.0216, 'lps'),
	(670639, 132, '2015-02-01 01:05:12.000000', 'consum', 0.0297, 'lps'),
	(670640, 132, '2015-02-01 01:05:13.000000', 'consum', 0.0281, 'lps'),
	(670641, 132, '2015-02-01 01:05:14.000000', 'consum', 0.0305, 'lps'),
	(670642, 132, '2015-02-01 01:05:15.000000', 'consum', 0.0241, 'lps'),
	(670643, 132, '2015-02-01 01:05:16.000000', 'consum', 0.0312, 'lps'),
	(670644, 132, '2015-02-01 01:05:17.000000', 'consum', 0.0277, 'lps'),
	(670645, 132, '2015-02-01 01:05:18.000000', 'consum', 0.0242, 'lps'),
	(670646, 132, '2015-02-01 01:05:19.000000', 'consum', 0.0284, 'lps'),
	(670647, 132, '2015-02-01 01:05:20.000000', 'consum', 0.0253, 'lps'),
	(670648, 132, '2015-02-01 01:05:21.000000', 'consum', 0.0318, 'lps'),
	(670649, 132, '2015-02-01 01:05:22.000000', 'consum', 0.0273, 'lps'),
	(670650, 132, '2015-02-01 01:05:23.000000', 'consum', 0.0317, 'lps'),
	(670651, 132, '2015-02-01 01:05:24.000000', 'consum', 0.0211, 'lps'),
	(670652, 132, '2015-02-01 01:05:25.000000', 'consum', 0.0241, 'lps'),
	(670653, 132, '2015-02-01 01:05:26.000000', 'consum', 0.0246, 'lps'),
	(670654, 132, '2015-02-01 01:05:27.000000', 'consum', 0.0298, 'lps'),
	(670655, 132, '2015-02-01 01:05:28.000000', 'consum', 0.0309, 'lps'),
	(670656, 132, '2015-02-01 01:05:29.000000', 'consum', 0.0325, 'lps'),
	(670657, 132, '2015-02-01 01:05:30.000000', 'consum', 0.0259, 'lps'),
	(670658, 132, '2015-02-01 01:05:31.000000', 'consum', 0.0224, 'lps'),
	(670659, 132, '2015-02-01 01:05:32.000000', 'consum', 0.0252, 'lps'),
	(670660, 132, '2015-02-01 01:05:33.000000', 'consum', 0.0260, 'lps'),
	(670661, 132, '2015-02-01 01:05:34.000000', 'consum', 0.0221, 'lps'),
	(670662, 132, '2015-02-01 01:05:35.000000', 'consum', 0.0228, 'lps'),
	(670663, 132, '2015-02-01 01:05:36.000000', 'consum', 0.0271, 'lps'),
	(670664, 132, '2015-02-01 01:05:37.000000', 'consum', 0.0229, 'lps'),
	(670665, 132, '2015-02-01 01:05:38.000000', 'consum', 0.0237, 'lps'),
	(670666, 132, '2015-02-01 01:05:39.000000', 'consum', 0.0291, 'lps'),
	(670667, 132, '2015-02-01 01:05:40.000000', 'consum', 0.0302, 'lps'),
	(670668, 132, '2015-02-01 01:05:41.000000', 'consum', 0.0312, 'lps'),
	(670669, 132, '2015-02-01 01:05:42.000000', 'consum', 0.0212, 'lps'),
	(670670, 132, '2015-02-01 01:05:43.000000', 'consum', 0.0262, 'lps'),
	(670671, 132, '2015-02-01 01:05:44.000000', 'consum', 0.0234, 'lps'),
	(670672, 132, '2015-02-01 01:05:45.000000', 'consum', 0.0288, 'lps'),
	(670673, 132, '2015-02-01 01:05:46.000000', 'consum', 0.0298, 'lps'),
	(670674, 132, '2015-02-01 01:05:47.000000', 'consum', 0.0299, 'lps'),
	(670675, 132, '2015-02-01 01:05:48.000000', 'consum', 0.0275, 'lps'),
	(670676, 132, '2015-02-01 01:05:49.000000', 'consum', 0.0268, 'lps'),
	(670677, 132, '2015-02-01 01:05:50.000000', 'consum', 0.0304, 'lps'),
	(670678, 132, '2015-02-01 01:05:51.000000', 'consum', 0.0278, 'lps'),
	(670679, 132, '2015-02-01 01:05:52.000000', 'consum', 0.0269, 'lps'),
	(670680, 132, '2015-02-01 01:05:53.000000', 'consum', 0.0300, 'lps'),
	(670681, 132, '2015-02-01 01:05:54.000000', 'consum', 0.0252, 'lps'),
	(670682, 132, '2015-02-01 01:05:55.000000', 'consum', 0.0264, 'lps'),
	(670683, 132, '2015-02-01 01:05:56.000000', 'consum', 0.0242, 'lps'),
	(670684, 132, '2015-02-01 01:05:57.000000', 'consum', 0.0323, 'lps'),
	(670685, 132, '2015-02-01 01:05:58.000000', 'consum', 0.0216, 'lps'),
	(670686, 132, '2015-02-01 01:05:59.000000', 'consum', 0.0251, 'lps'),
	(670687, 132, '2015-02-01 01:06:00.000000', 'consum', 0.0282, 'lps'),
	(670688, 132, '2015-02-01 01:06:01.000000', 'consum', 0.0213, 'lps'),
	(670689, 132, '2015-02-01 01:06:02.000000', 'consum', 0.0245, 'lps'),
	(670690, 132, '2015-02-01 01:06:03.000000', 'consum', 0.0257, 'lps'),
	(670691, 132, '2015-02-01 01:06:04.000000', 'consum', 0.0224, 'lps'),
	(670692, 132, '2015-02-01 01:06:05.000000', 'consum', 0.0256, 'lps'),
	(670693, 132, '2015-02-01 01:06:06.000000', 'consum', 0.0281, 'lps'),
	(670694, 132, '2015-02-01 01:06:07.000000', 'consum', 0.0313, 'lps'),
	(670695, 132, '2015-02-01 01:06:08.000000', 'consum', 0.0282, 'lps'),
	(670696, 132, '2015-02-01 01:06:09.000000', 'consum', 0.0261, 'lps'),
	(670697, 132, '2015-02-01 01:06:10.000000', 'consum', 0.0250, 'lps'),
	(670698, 132, '2015-02-01 01:06:11.000000', 'consum', 0.0257, 'lps'),
	(670699, 132, '2015-02-01 01:06:12.000000', 'consum', 0.0211, 'lps'),
	(670700, 132, '2015-02-01 01:06:13.000000', 'consum', 0.0306, 'lps'),
	(670701, 132, '2015-02-01 01:06:14.000000', 'consum', 0.0222, 'lps'),
	(670702, 132, '2015-02-01 01:06:15.000000', 'consum', 0.0216, 'lps'),
	(670703, 132, '2015-02-01 01:06:16.000000', 'consum', 0.0320, 'lps'),
	(670704, 132, '2015-02-01 01:06:17.000000', 'consum', 0.0277, 'lps'),
	(670705, 132, '2015-02-01 01:06:18.000000', 'consum', 0.0215, 'lps'),
	(670706, 132, '2015-02-01 01:06:19.000000', 'consum', 0.0270, 'lps'),
	(670707, 132, '2015-02-01 01:06:20.000000', 'consum', 0.0260, 'lps'),
	(670708, 132, '2015-02-01 01:06:21.000000', 'consum', 0.0282, 'lps'),
	(670709, 132, '2015-02-01 01:06:22.000000', 'consum', 0.0304, 'lps'),
	(670710, 132, '2015-02-01 01:06:23.000000', 'consum', 0.0232, 'lps'),
	(670711, 132, '2015-02-01 01:06:24.000000', 'consum', 0.0272, 'lps'),
	(670712, 132, '2015-02-01 01:06:25.000000', 'consum', 0.0221, 'lps'),
	(670713, 132, '2015-02-01 01:06:26.000000', 'consum', 0.0310, 'lps'),
	(670714, 132, '2015-02-01 01:06:27.000000', 'consum', 0.0215, 'lps'),
	(670715, 132, '2015-02-01 01:06:28.000000', 'consum', 0.0285, 'lps'),
	(670716, 132, '2015-02-01 01:06:29.000000', 'consum', 0.0222, 'lps'),
	(670717, 132, '2015-02-01 01:06:30.000000', 'consum', 0.0278, 'lps'),
	(670718, 132, '2015-02-01 01:06:31.000000', 'consum', 0.0280, 'lps'),
	(670719, 132, '2015-02-01 01:06:32.000000', 'consum', 0.0243, 'lps'),
	(670720, 132, '2015-02-01 01:06:33.000000', 'consum', 0.0280, 'lps'),
	(670721, 132, '2015-02-01 01:06:34.000000', 'consum', 0.0230, 'lps'),
	(670722, 132, '2015-02-01 01:06:35.000000', 'consum', 0.0218, 'lps'),
	(670723, 132, '2015-02-01 01:06:36.000000', 'consum', 0.0304, 'lps'),
	(670724, 132, '2015-02-01 01:06:37.000000', 'consum', 0.0311, 'lps'),
	(670725, 132, '2015-02-01 01:06:38.000000', 'consum', 0.0317, 'lps'),
	(670726, 132, '2015-02-01 01:06:39.000000', 'consum', 0.0212, 'lps'),
	(670727, 132, '2015-02-01 01:06:40.000000', 'consum', 0.0246, 'lps'),
	(670728, 132, '2015-02-01 01:06:41.000000', 'consum', 0.0268, 'lps'),
	(670729, 132, '2015-02-01 01:06:42.000000', 'consum', 0.0276, 'lps'),
	(670730, 132, '2015-02-01 01:06:43.000000', 'consum', 0.0251, 'lps'),
	(670731, 132, '2015-02-01 01:06:44.000000', 'consum', 0.0216, 'lps'),
	(670732, 132, '2015-02-01 01:06:45.000000', 'consum', 0.0234, 'lps'),
	(670733, 132, '2015-02-01 01:06:46.000000', 'consum', 0.0312, 'lps'),
	(670734, 132, '2015-02-01 01:06:47.000000', 'consum', 0.0301, 'lps'),
	(670735, 132, '2015-02-01 01:06:48.000000', 'consum', 0.0243, 'lps'),
	(670736, 132, '2015-02-01 01:06:49.000000', 'consum', 0.0219, 'lps'),
	(670737, 132, '2015-02-01 01:06:50.000000', 'consum', 0.0273, 'lps'),
	(670738, 132, '2015-02-01 01:06:51.000000', 'consum', 0.0267, 'lps'),
	(670739, 132, '2015-02-01 01:06:52.000000', 'consum', 0.0307, 'lps'),
	(670740, 132, '2015-02-01 01:06:53.000000', 'consum', 0.0291, 'lps'),
	(670741, 132, '2015-02-01 01:06:54.000000', 'consum', 0.0325, 'lps'),
	(670742, 132, '2015-02-01 01:06:55.000000', 'consum', 0.0309, 'lps'),
	(670743, 132, '2015-02-01 01:06:56.000000', 'consum', 0.0244, 'lps'),
	(670744, 132, '2015-02-01 01:06:57.000000', 'consum', 0.0319, 'lps'),
	(670745, 132, '2015-02-01 01:06:58.000000', 'consum', 0.0302, 'lps'),
	(670746, 132, '2015-02-01 01:06:59.000000', 'consum', 0.0229, 'lps'),
	(670747, 132, '2015-02-01 01:07:00.000000', 'consum', 0.0263, 'lps'),
	(670748, 132, '2015-02-01 01:07:01.000000', 'consum', 0.0302, 'lps'),
	(670749, 132, '2015-02-01 01:07:02.000000', 'consum', 0.0280, 'lps'),
	(670750, 132, '2015-02-01 01:07:03.000000', 'consum', 0.0283, 'lps'),
	(670751, 132, '2015-02-01 01:07:04.000000', 'consum', 0.0251, 'lps'),
	(670752, 132, '2015-02-01 01:07:05.000000', 'consum', 0.0311, 'lps'),
	(670753, 132, '2015-02-01 01:07:06.000000', 'consum', 0.0245, 'lps'),
	(670754, 132, '2015-02-01 01:07:07.000000', 'consum', 0.0316, 'lps'),
	(670755, 132, '2015-02-01 01:07:08.000000', 'consum', 0.0285, 'lps'),
	(670756, 132, '2015-02-01 01:07:09.000000', 'consum', 0.0267, 'lps'),
	(670757, 132, '2015-02-01 01:07:10.000000', 'consum', 0.0272, 'lps'),
	(670758, 132, '2015-02-01 01:07:11.000000', 'consum', 0.0235, 'lps'),
	(670759, 132, '2015-02-01 01:07:12.000000', 'consum', 0.0266, 'lps'),
	(670760, 132, '2015-02-01 01:07:13.000000', 'consum', 0.0297, 'lps'),
	(670761, 132, '2015-02-01 01:07:14.000000', 'consum', 0.0247, 'lps'),
	(670762, 132, '2015-02-01 01:07:15.000000', 'consum', 0.0248, 'lps'),
	(670763, 132, '2015-02-01 01:07:16.000000', 'consum', 0.0293, 'lps'),
	(670764, 132, '2015-02-01 01:07:17.000000', 'consum', 0.0277, 'lps'),
	(670765, 132, '2015-02-01 01:07:18.000000', 'consum', 0.0296, 'lps'),
	(670766, 132, '2015-02-01 01:07:19.000000', 'consum', 0.0210, 'lps'),
	(670767, 132, '2015-02-01 01:07:20.000000', 'consum', 0.0298, 'lps'),
	(670768, 132, '2015-02-01 01:07:21.000000', 'consum', 0.0304, 'lps'),
	(670769, 132, '2015-02-01 01:07:22.000000', 'consum', 0.0299, 'lps'),
	(670770, 132, '2015-02-01 01:07:23.000000', 'consum', 0.0259, 'lps'),
	(670771, 132, '2015-02-01 01:07:24.000000', 'consum', 0.0304, 'lps'),
	(670772, 132, '2015-02-01 01:07:25.000000', 'consum', 0.0299, 'lps'),
	(670773, 132, '2015-02-01 01:07:26.000000', 'consum', 0.0261, 'lps'),
	(670774, 132, '2015-02-01 01:07:27.000000', 'consum', 0.0315, 'lps'),
	(670775, 132, '2015-02-01 01:07:28.000000', 'consum', 0.0232, 'lps'),
	(670776, 132, '2015-02-01 01:07:29.000000', 'consum', 0.0239, 'lps'),
	(670777, 132, '2015-02-01 01:07:30.000000', 'consum', 0.0287, 'lps'),
	(670778, 132, '2015-02-01 01:07:31.000000', 'consum', 0.0280, 'lps'),
	(670779, 132, '2015-02-01 01:07:32.000000', 'consum', 0.0210, 'lps'),
	(670780, 132, '2015-02-01 01:07:33.000000', 'consum', 0.0236, 'lps'),
	(670781, 132, '2015-02-01 01:07:34.000000', 'consum', 0.0223, 'lps'),
	(670782, 132, '2015-02-01 01:07:35.000000', 'consum', 0.0314, 'lps'),
	(670783, 132, '2015-02-01 01:07:36.000000', 'consum', 0.0225, 'lps'),
	(670784, 132, '2015-02-01 01:07:37.000000', 'consum', 0.0324, 'lps'),
	(670785, 132, '2015-02-01 01:07:38.000000', 'consum', 0.0270, 'lps'),
	(670786, 132, '2015-02-01 01:07:39.000000', 'consum', 0.0285, 'lps'),
	(670787, 132, '2015-02-01 01:07:40.000000', 'consum', 0.0290, 'lps'),
	(670788, 132, '2015-02-01 01:07:41.000000', 'consum', 0.0269, 'lps'),
	(670789, 132, '2015-02-01 01:07:42.000000', 'consum', 0.0264, 'lps'),
	(670790, 132, '2015-02-01 01:07:43.000000', 'consum', 0.0304, 'lps'),
	(670791, 132, '2015-02-01 01:07:44.000000', 'consum', 0.0288, 'lps'),
	(670792, 132, '2015-02-01 01:07:45.000000', 'consum', 0.0317, 'lps'),
	(670793, 132, '2015-02-01 01:07:46.000000', 'consum', 0.0279, 'lps'),
	(670794, 132, '2015-02-01 01:07:47.000000', 'consum', 0.0235, 'lps'),
	(670795, 132, '2015-02-01 01:07:48.000000', 'consum', 0.0244, 'lps'),
	(670796, 132, '2015-02-01 01:07:49.000000', 'consum', 0.0305, 'lps'),
	(670797, 132, '2015-02-01 01:07:50.000000', 'consum', 0.0234, 'lps'),
	(670798, 132, '2015-02-01 01:07:51.000000', 'consum', 0.0281, 'lps'),
	(670799, 132, '2015-02-01 01:07:52.000000', 'consum', 0.0258, 'lps'),
	(670800, 132, '2015-02-01 01:07:53.000000', 'consum', 0.0239, 'lps'),
	(670801, 132, '2015-02-01 01:07:54.000000', 'consum', 0.0213, 'lps'),
	(670802, 132, '2015-02-01 01:07:55.000000', 'consum', 0.0255, 'lps'),
	(670803, 132, '2015-02-01 01:07:56.000000', 'consum', 0.0309, 'lps'),
	(670804, 132, '2015-02-01 01:07:57.000000', 'consum', 0.0225, 'lps'),
	(670805, 132, '2015-02-01 01:07:58.000000', 'consum', 0.0218, 'lps'),
	(670806, 132, '2015-02-01 01:07:59.000000', 'consum', 0.0324, 'lps'),
	(670807, 132, '2015-02-01 01:08:00.000000', 'consum', 0.0292, 'lps'),
	(670808, 132, '2015-02-01 01:08:01.000000', 'consum', 0.0277, 'lps'),
	(670809, 132, '2015-02-01 01:08:02.000000', 'consum', 0.0299, 'lps'),
	(670810, 132, '2015-02-01 01:08:03.000000', 'consum', 0.0222, 'lps'),
	(670811, 132, '2015-02-01 01:08:04.000000', 'consum', 0.0235, 'lps'),
	(670812, 132, '2015-02-01 01:08:05.000000', 'consum', 0.0301, 'lps'),
	(670813, 132, '2015-02-01 01:08:06.000000', 'consum', 0.0241, 'lps'),
	(670814, 132, '2015-02-01 01:08:07.000000', 'consum', 0.0324, 'lps'),
	(670815, 132, '2015-02-01 01:08:08.000000', 'consum', 0.0223, 'lps'),
	(670816, 132, '2015-02-01 01:08:09.000000', 'consum', 0.0282, 'lps'),
	(670817, 132, '2015-02-01 01:08:10.000000', 'consum', 0.0300, 'lps'),
	(670818, 132, '2015-02-01 01:08:11.000000', 'consum', 0.0214, 'lps'),
	(670819, 132, '2015-02-01 01:08:12.000000', 'consum', 0.0308, 'lps'),
	(670820, 132, '2015-02-01 01:08:13.000000', 'consum', 0.0225, 'lps'),
	(670821, 132, '2015-02-01 01:08:14.000000', 'consum', 0.0223, 'lps'),
	(670822, 132, '2015-02-01 01:08:15.000000', 'consum', 0.0230, 'lps'),
	(670823, 132, '2015-02-01 01:08:16.000000', 'consum', 0.0274, 'lps'),
	(670824, 132, '2015-02-01 01:08:17.000000', 'consum', 0.0236, 'lps'),
	(670825, 132, '2015-02-01 01:08:18.000000', 'consum', 0.0265, 'lps'),
	(670826, 132, '2015-02-01 01:08:19.000000', 'consum', 0.0290, 'lps'),
	(670827, 132, '2015-02-01 01:08:20.000000', 'consum', 0.0216, 'lps'),
	(670828, 132, '2015-02-01 01:08:21.000000', 'consum', 0.0232, 'lps'),
	(670829, 132, '2015-02-01 01:08:22.000000', 'consum', 0.0302, 'lps'),
	(670830, 132, '2015-02-01 01:08:23.000000', 'consum', 0.0255, 'lps'),
	(670831, 132, '2015-02-01 01:08:24.000000', 'consum', 0.0275, 'lps'),
	(670832, 132, '2015-02-01 01:08:25.000000', 'consum', 0.0285, 'lps'),
	(670833, 132, '2015-02-01 01:08:26.000000', 'consum', 0.0274, 'lps'),
	(670834, 132, '2015-02-01 01:08:27.000000', 'consum', 0.0306, 'lps'),
	(670835, 132, '2015-02-01 01:08:28.000000', 'consum', 0.0265, 'lps'),
	(670836, 132, '2015-02-01 01:08:29.000000', 'consum', 0.0314, 'lps'),
	(670837, 132, '2015-02-01 01:08:30.000000', 'consum', 0.0220, 'lps'),
	(670838, 132, '2015-02-01 01:08:31.000000', 'consum', 0.0294, 'lps'),
	(670839, 132, '2015-02-01 01:08:32.000000', 'consum', 0.0254, 'lps'),
	(670840, 132, '2015-02-01 01:08:33.000000', 'consum', 0.0295, 'lps'),
	(670841, 132, '2015-02-01 01:08:34.000000', 'consum', 0.0271, 'lps'),
	(670842, 132, '2015-02-01 01:08:35.000000', 'consum', 0.0260, 'lps'),
	(670843, 132, '2015-02-01 01:08:36.000000', 'consum', 0.0279, 'lps'),
	(670844, 132, '2015-02-01 01:08:37.000000', 'consum', 0.0287, 'lps'),
	(670845, 132, '2015-02-01 01:08:38.000000', 'consum', 0.0273, 'lps'),
	(670846, 132, '2015-02-01 01:08:39.000000', 'consum', 0.0297, 'lps'),
	(670847, 132, '2015-02-01 01:08:40.000000', 'consum', 0.0221, 'lps'),
	(670848, 132, '2015-02-01 01:08:41.000000', 'consum', 0.0238, 'lps'),
	(670849, 132, '2015-02-01 01:08:42.000000', 'consum', 0.0318, 'lps'),
	(670850, 132, '2015-02-01 01:08:43.000000', 'consum', 0.0318, 'lps'),
	(670851, 132, '2015-02-01 01:08:44.000000', 'consum', 0.0310, 'lps'),
	(670852, 132, '2015-02-01 01:08:45.000000', 'consum', 0.0270, 'lps'),
	(670853, 132, '2015-02-01 01:08:46.000000', 'consum', 0.0213, 'lps'),
	(670854, 132, '2015-02-01 01:08:47.000000', 'consum', 0.0276, 'lps'),
	(670855, 132, '2015-02-01 01:08:48.000000', 'consum', 0.0299, 'lps'),
	(670856, 132, '2015-02-01 01:08:49.000000', 'consum', 0.0227, 'lps'),
	(670857, 132, '2015-02-01 01:08:50.000000', 'consum', 0.0260, 'lps'),
	(670858, 132, '2015-02-01 01:08:51.000000', 'consum', 0.0295, 'lps'),
	(670859, 132, '2015-02-01 01:08:52.000000', 'consum', 0.0251, 'lps'),
	(670860, 132, '2015-02-01 01:08:53.000000', 'consum', 0.0278, 'lps'),
	(670861, 132, '2015-02-01 01:08:54.000000', 'consum', 0.0313, 'lps'),
	(670862, 132, '2015-02-01 01:08:55.000000', 'consum', 0.0289, 'lps'),
	(670863, 132, '2015-02-01 01:08:56.000000', 'consum', 0.0296, 'lps'),
	(670864, 132, '2015-02-01 01:08:57.000000', 'consum', 0.0289, 'lps'),
	(670865, 132, '2015-02-01 01:08:58.000000', 'consum', 0.0230, 'lps'),
	(670866, 132, '2015-02-01 01:08:59.000000', 'consum', 0.0306, 'lps'),
	(670867, 132, '2015-02-01 01:09:00.000000', 'consum', 0.0284, 'lps'),
	(670868, 132, '2015-02-01 01:09:01.000000', 'consum', 0.0293, 'lps'),
	(670869, 132, '2015-02-01 01:09:02.000000', 'consum', 0.0286, 'lps'),
	(670870, 132, '2015-02-01 01:09:03.000000', 'consum', 0.0227, 'lps'),
	(670871, 132, '2015-02-01 01:09:04.000000', 'consum', 0.0299, 'lps'),
	(670872, 132, '2015-02-01 01:09:05.000000', 'consum', 0.0254, 'lps'),
	(670873, 132, '2015-02-01 01:09:06.000000', 'consum', 0.0282, 'lps'),
	(670874, 132, '2015-02-01 01:09:07.000000', 'consum', 0.0323, 'lps'),
	(670875, 132, '2015-02-01 01:09:08.000000', 'consum', 0.0212, 'lps'),
	(670876, 132, '2015-02-01 01:09:09.000000', 'consum', 0.0227, 'lps'),
	(670877, 132, '2015-02-01 01:09:10.000000', 'consum', 0.0290, 'lps'),
	(670878, 132, '2015-02-01 01:09:11.000000', 'consum', 0.0212, 'lps'),
	(670879, 132, '2015-02-01 01:09:12.000000', 'consum', 0.0213, 'lps'),
	(670880, 132, '2015-02-01 01:09:13.000000', 'consum', 0.0220, 'lps'),
	(670881, 132, '2015-02-01 01:09:14.000000', 'consum', 0.0249, 'lps'),
	(670882, 132, '2015-02-01 01:09:15.000000', 'consum', 0.0261, 'lps'),
	(670883, 132, '2015-02-01 01:09:16.000000', 'consum', 0.0231, 'lps'),
	(670884, 132, '2015-02-01 01:09:17.000000', 'consum', 0.0280, 'lps'),
	(670885, 132, '2015-02-01 01:09:18.000000', 'consum', 0.0264, 'lps'),
	(670886, 132, '2015-02-01 01:09:19.000000', 'consum', 0.0270, 'lps'),
	(670887, 132, '2015-02-01 01:09:20.000000', 'consum', 0.0232, 'lps'),
	(670888, 132, '2015-02-01 01:09:21.000000', 'consum', 0.0257, 'lps'),
	(670889, 132, '2015-02-01 01:09:22.000000', 'consum', 0.0262, 'lps'),
	(670890, 132, '2015-02-01 01:09:23.000000', 'consum', 0.0214, 'lps'),
	(670891, 132, '2015-02-01 01:09:24.000000', 'consum', 0.0309, 'lps'),
	(670892, 132, '2015-02-01 01:09:25.000000', 'consum', 0.0226, 'lps'),
	(670893, 132, '2015-02-01 01:09:26.000000', 'consum', 0.0228, 'lps'),
	(670894, 132, '2015-02-01 01:09:27.000000', 'consum', 0.0251, 'lps'),
	(670895, 132, '2015-02-01 01:09:28.000000', 'consum', 0.0244, 'lps'),
	(670896, 132, '2015-02-01 01:09:29.000000', 'consum', 0.0260, 'lps'),
	(670897, 132, '2015-02-01 01:09:30.000000', 'consum', 0.0243, 'lps'),
	(670898, 132, '2015-02-01 01:09:31.000000', 'consum', 0.0224, 'lps'),
	(670899, 132, '2015-02-01 01:09:32.000000', 'consum', 0.0299, 'lps'),
	(670900, 132, '2015-02-01 01:09:33.000000', 'consum', 0.0266, 'lps'),
	(670901, 132, '2015-02-01 01:09:34.000000', 'consum', 0.0221, 'lps'),
	(670902, 132, '2015-02-01 01:09:35.000000', 'consum', 0.0213, 'lps'),
	(670903, 132, '2015-02-01 01:09:36.000000', 'consum', 0.0309, 'lps'),
	(670904, 132, '2015-02-01 01:09:37.000000', 'consum', 0.0231, 'lps'),
	(670905, 132, '2015-02-01 01:09:38.000000', 'consum', 0.0252, 'lps'),
	(670906, 132, '2015-02-01 01:09:39.000000', 'consum', 0.0239, 'lps'),
	(670907, 132, '2015-02-01 01:09:40.000000', 'consum', 0.0233, 'lps'),
	(670908, 132, '2015-02-01 01:09:41.000000', 'consum', 0.0238, 'lps'),
	(670909, 132, '2015-02-01 01:09:42.000000', 'consum', 0.0279, 'lps'),
	(670910, 132, '2015-02-01 01:09:43.000000', 'consum', 0.0241, 'lps'),
	(670911, 132, '2015-02-01 01:09:44.000000', 'consum', 0.0273, 'lps'),
	(670912, 132, '2015-02-01 01:09:45.000000', 'consum', 0.0318, 'lps'),
	(670913, 132, '2015-02-01 01:09:46.000000', 'consum', 0.0213, 'lps'),
	(670914, 132, '2015-02-01 01:09:47.000000', 'consum', 0.0250, 'lps'),
	(670915, 132, '2015-02-01 01:09:48.000000', 'consum', 0.0286, 'lps'),
	(670916, 132, '2015-02-01 01:09:49.000000', 'consum', 0.0237, 'lps'),
	(670917, 132, '2015-02-01 01:09:50.000000', 'consum', 0.0236, 'lps'),
	(670918, 132, '2015-02-01 01:09:51.000000', 'consum', 0.0259, 'lps'),
	(670919, 132, '2015-02-01 01:09:52.000000', 'consum', 0.0260, 'lps'),
	(670920, 132, '2015-02-01 01:09:53.000000', 'consum', 0.0313, 'lps'),
	(670921, 132, '2015-02-01 01:09:54.000000', 'consum', 0.0227, 'lps'),
	(670922, 132, '2015-02-01 01:09:55.000000', 'consum', 0.0217, 'lps'),
	(670923, 132, '2015-02-01 01:09:56.000000', 'consum', 0.0314, 'lps'),
	(670924, 132, '2015-02-01 01:09:57.000000', 'consum', 0.0243, 'lps'),
	(670925, 132, '2015-02-01 01:09:58.000000', 'consum', 0.0295, 'lps'),
	(670926, 132, '2015-02-01 01:09:59.000000', 'consum', 0.0306, 'lps'),
	(670927, 132, '2015-02-01 01:10:00.000000', 'consum', 0.0317, 'lps'),
	(670928, 132, '2015-02-01 01:10:01.000000', 'consum', 0.0227, 'lps'),
	(670929, 132, '2015-02-01 01:10:02.000000', 'consum', 0.0323, 'lps'),
	(670930, 132, '2015-02-01 01:10:03.000000', 'consum', 0.0261, 'lps'),
	(670931, 132, '2015-02-01 01:10:04.000000', 'consum', 0.0243, 'lps'),
	(670932, 132, '2015-02-01 01:10:05.000000', 'consum', 0.0223, 'lps'),
	(670933, 132, '2015-02-01 01:10:06.000000', 'consum', 0.0292, 'lps'),
	(670934, 132, '2015-02-01 01:10:07.000000', 'consum', 0.0233, 'lps'),
	(670935, 132, '2015-02-01 01:10:08.000000', 'consum', 0.0311, 'lps'),
	(670936, 132, '2015-02-01 01:10:09.000000', 'consum', 0.0298, 'lps'),
	(670937, 132, '2015-02-01 01:10:10.000000', 'consum', 0.0232, 'lps'),
	(670938, 132, '2015-02-01 01:10:11.000000', 'consum', 0.0290, 'lps'),
	(670939, 132, '2015-02-01 01:10:12.000000', 'consum', 0.0310, 'lps'),
	(670940, 132, '2015-02-01 01:10:13.000000', 'consum', 0.0239, 'lps'),
	(670941, 132, '2015-02-01 01:10:14.000000', 'consum', 0.0289, 'lps'),
	(670942, 132, '2015-02-01 01:10:15.000000', 'consum', 0.0285, 'lps'),
	(670943, 132, '2015-02-01 01:10:16.000000', 'consum', 0.0231, 'lps'),
	(670944, 132, '2015-02-01 01:10:17.000000', 'consum', 0.0323, 'lps'),
	(670945, 132, '2015-02-01 01:10:18.000000', 'consum', 0.0251, 'lps'),
	(670946, 132, '2015-02-01 01:10:19.000000', 'consum', 0.0307, 'lps'),
	(670947, 132, '2015-02-01 01:10:20.000000', 'consum', 0.0224, 'lps'),
	(670948, 132, '2015-02-01 01:10:21.000000', 'consum', 0.0221, 'lps'),
	(670949, 132, '2015-02-01 01:10:22.000000', 'consum', 0.0226, 'lps'),
	(670950, 132, '2015-02-01 01:10:23.000000', 'consum', 0.0255, 'lps'),
	(670951, 132, '2015-02-01 01:10:24.000000', 'consum', 0.0271, 'lps'),
	(670952, 132, '2015-02-01 01:10:25.000000', 'consum', 0.0267, 'lps'),
	(670953, 132, '2015-02-01 01:10:26.000000', 'consum', 0.0311, 'lps'),
	(670954, 132, '2015-02-01 01:10:27.000000', 'consum', 0.0313, 'lps'),
	(670955, 132, '2015-02-01 01:10:28.000000', 'consum', 0.0308, 'lps'),
	(670956, 132, '2015-02-01 01:10:29.000000', 'consum', 0.0275, 'lps'),
	(670957, 132, '2015-02-01 01:10:30.000000', 'consum', 0.0242, 'lps'),
	(670958, 132, '2015-02-01 01:10:31.000000', 'consum', 0.0289, 'lps'),
	(670959, 132, '2015-02-01 01:10:32.000000', 'consum', 0.0279, 'lps'),
	(670960, 132, '2015-02-01 01:10:33.000000', 'consum', 0.0319, 'lps'),
	(670961, 132, '2015-02-01 01:10:34.000000', 'consum', 0.0315, 'lps'),
	(670962, 132, '2015-02-01 01:10:35.000000', 'consum', 0.0292, 'lps'),
	(670963, 132, '2015-02-01 01:10:36.000000', 'consum', 0.0305, 'lps'),
	(670964, 132, '2015-02-01 01:10:37.000000', 'consum', 0.0210, 'lps'),
	(670965, 132, '2015-02-01 01:10:38.000000', 'consum', 0.0272, 'lps'),
	(670966, 132, '2015-02-01 01:10:39.000000', 'consum', 0.0290, 'lps'),
	(670967, 132, '2015-02-01 01:10:40.000000', 'consum', 0.0307, 'lps'),
	(670968, 132, '2015-02-01 01:10:41.000000', 'consum', 0.0222, 'lps'),
	(670969, 132, '2015-02-01 01:10:42.000000', 'consum', 0.0213, 'lps'),
	(670970, 132, '2015-02-01 01:10:43.000000', 'consum', 0.0304, 'lps'),
	(670971, 132, '2015-02-01 01:10:44.000000', 'consum', 0.0324, 'lps'),
	(670972, 132, '2015-02-01 01:10:45.000000', 'consum', 0.0266, 'lps'),
	(670973, 132, '2015-02-01 01:10:46.000000', 'consum', 0.0267, 'lps'),
	(670974, 132, '2015-02-01 01:10:47.000000', 'consum', 0.0210, 'lps'),
	(670975, 132, '2015-02-01 01:10:48.000000', 'consum', 0.0272, 'lps'),
	(670976, 132, '2015-02-01 01:10:49.000000', 'consum', 0.0287, 'lps'),
	(670977, 132, '2015-02-01 01:10:50.000000', 'consum', 0.0294, 'lps'),
	(670978, 132, '2015-02-01 01:10:51.000000', 'consum', 0.0282, 'lps'),
	(670979, 132, '2015-02-01 01:10:52.000000', 'consum', 0.0321, 'lps'),
	(670980, 132, '2015-02-01 01:10:53.000000', 'consum', 0.0315, 'lps'),
	(670981, 132, '2015-02-01 01:10:54.000000', 'consum', 0.0289, 'lps'),
	(670982, 132, '2015-02-01 01:10:55.000000', 'consum', 0.0291, 'lps'),
	(670983, 132, '2015-02-01 01:10:56.000000', 'consum', 0.0261, 'lps'),
	(670984, 132, '2015-02-01 01:10:57.000000', 'consum', 0.0224, 'lps'),
	(670985, 132, '2015-02-01 01:10:58.000000', 'consum', 0.0241, 'lps'),
	(670986, 132, '2015-02-01 01:10:59.000000', 'consum', 0.0325, 'lps'),
	(670987, 132, '2015-02-01 01:11:00.000000', 'consum', 0.0227, 'lps'),
	(670988, 132, '2015-02-01 01:11:01.000000', 'consum', 0.0301, 'lps'),
	(670989, 132, '2015-02-01 01:11:02.000000', 'consum', 0.0264, 'lps'),
	(670990, 132, '2015-02-01 01:11:03.000000', 'consum', 0.0323, 'lps'),
	(670991, 132, '2015-02-01 01:11:04.000000', 'consum', 0.0265, 'lps'),
	(670992, 132, '2015-02-01 01:11:05.000000', 'consum', 0.0265, 'lps'),
	(670993, 132, '2015-02-01 01:11:06.000000', 'consum', 0.0320, 'lps'),
	(670994, 132, '2015-02-01 01:11:07.000000', 'consum', 0.0245, 'lps'),
	(670995, 132, '2015-02-01 01:11:08.000000', 'consum', 0.0291, 'lps'),
	(670996, 132, '2015-02-01 01:11:09.000000', 'consum', 0.0276, 'lps'),
	(670997, 132, '2015-02-01 01:11:10.000000', 'consum', 0.0300, 'lps'),
	(670998, 132, '2015-02-01 01:11:11.000000', 'consum', 0.0231, 'lps'),
	(670999, 132, '2015-02-01 01:11:12.000000', 'consum', 0.0276, 'lps'),
	(671000, 132, '2015-02-01 01:11:13.000000', 'consum', 0.0244, 'lps'),
	(671001, 132, '2015-02-01 01:11:14.000000', 'consum', 0.0299, 'lps'),
	(671002, 132, '2015-02-01 01:11:15.000000', 'consum', 0.0323, 'lps'),
	(671003, 132, '2015-02-01 01:11:16.000000', 'consum', 0.0274, 'lps'),
	(671004, 132, '2015-02-01 01:11:17.000000', 'consum', 0.0308, 'lps'),
	(671005, 132, '2015-02-01 01:11:18.000000', 'consum', 0.0276, 'lps'),
	(671006, 132, '2015-02-01 01:11:19.000000', 'consum', 0.0248, 'lps'),
	(671007, 132, '2015-02-01 01:11:20.000000', 'consum', 0.0318, 'lps'),
	(671008, 132, '2015-02-01 01:11:21.000000', 'consum', 0.0290, 'lps'),
	(671009, 132, '2015-02-01 01:11:22.000000', 'consum', 0.0287, 'lps'),
	(671010, 132, '2015-02-01 01:11:23.000000', 'consum', 0.0238, 'lps'),
	(671011, 132, '2015-02-01 01:11:24.000000', 'consum', 0.0235, 'lps'),
	(671012, 132, '2015-02-01 01:11:25.000000', 'consum', 0.0250, 'lps'),
	(671013, 132, '2015-02-01 01:11:26.000000', 'consum', 0.0222, 'lps'),
	(671014, 132, '2015-02-01 01:11:27.000000', 'consum', 0.0267, 'lps'),
	(671015, 132, '2015-02-01 01:11:28.000000', 'consum', 0.0225, 'lps'),
	(671016, 132, '2015-02-01 01:11:29.000000', 'consum', 0.0233, 'lps'),
	(671017, 132, '2015-02-01 01:11:30.000000', 'consum', 0.0279, 'lps'),
	(671018, 132, '2015-02-01 01:11:31.000000', 'consum', 0.0255, 'lps'),
	(671019, 132, '2015-02-01 01:11:32.000000', 'consum', 0.0229, 'lps'),
	(671020, 132, '2015-02-01 01:11:33.000000', 'consum', 0.0287, 'lps'),
	(671021, 132, '2015-02-01 01:11:34.000000', 'consum', 0.0306, 'lps'),
	(671022, 132, '2015-02-01 01:11:35.000000', 'consum', 0.0229, 'lps'),
	(671023, 132, '2015-02-01 01:11:36.000000', 'consum', 0.0247, 'lps'),
	(671024, 132, '2015-02-01 01:11:37.000000', 'consum', 0.0223, 'lps'),
	(671025, 132, '2015-02-01 01:11:38.000000', 'consum', 0.0280, 'lps'),
	(671026, 132, '2015-02-01 01:11:39.000000', 'consum', 0.0290, 'lps'),
	(671027, 132, '2015-02-01 01:11:40.000000', 'consum', 0.0285, 'lps'),
	(671028, 132, '2015-02-01 01:11:41.000000', 'consum', 0.0229, 'lps'),
	(671029, 132, '2015-02-01 01:11:42.000000', 'consum', 0.0313, 'lps'),
	(671030, 132, '2015-02-01 01:11:43.000000', 'consum', 0.0321, 'lps'),
	(671031, 132, '2015-02-01 01:11:44.000000', 'consum', 0.0224, 'lps'),
	(671032, 132, '2015-02-01 01:11:45.000000', 'consum', 0.0296, 'lps'),
	(671033, 132, '2015-02-01 01:11:46.000000', 'consum', 0.0250, 'lps'),
	(671034, 132, '2015-02-01 01:11:47.000000', 'consum', 0.0267, 'lps'),
	(671035, 132, '2015-02-01 01:11:48.000000', 'consum', 0.0261, 'lps'),
	(671036, 132, '2015-02-01 01:11:49.000000', 'consum', 0.0294, 'lps'),
	(671037, 132, '2015-02-01 01:11:50.000000', 'consum', 0.0246, 'lps'),
	(671038, 132, '2015-02-01 01:11:51.000000', 'consum', 0.0253, 'lps'),
	(671039, 132, '2015-02-01 01:11:52.000000', 'consum', 0.0318, 'lps'),
	(671040, 132, '2015-02-01 01:11:53.000000', 'consum', 0.0275, 'lps'),
	(671041, 133, '2015-02-01 00:00:00.000000', 'consum', 0.0210, 'lps'),
	(671042, 133, '2015-02-01 00:00:01.000000', 'consum', 0.0220, 'lps'),
	(671043, 133, '2015-02-01 00:00:02.000000', 'consum', 0.0213, 'lps'),
	(671044, 133, '2015-02-01 00:00:03.000000', 'consum', 0.0219, 'lps'),
	(671045, 133, '2015-02-01 00:00:04.000000', 'consum', 0.0213, 'lps'),
	(671046, 133, '2015-02-01 00:00:05.000000', 'consum', 0.0221, 'lps'),
	(671047, 133, '2015-02-01 00:00:06.000000', 'consum', 0.0220, 'lps'),
	(671048, 133, '2015-02-01 00:00:07.000000', 'consum', 0.0216, 'lps'),
	(671049, 133, '2015-02-01 00:00:08.000000', 'consum', 0.0212, 'lps'),
	(671050, 133, '2015-02-01 00:00:09.000000', 'consum', 0.0212, 'lps'),
	(671051, 133, '2015-02-01 00:00:10.000000', 'consum', 0.0215, 'lps'),
	(671052, 133, '2015-02-01 00:00:11.000000', 'consum', 0.0217, 'lps'),
	(671053, 133, '2015-02-01 00:00:12.000000', 'consum', 0.0219, 'lps'),
	(671054, 133, '2015-02-01 00:00:13.000000', 'consum', 0.0221, 'lps'),
	(671055, 133, '2015-02-01 00:00:14.000000', 'consum', 0.0214, 'lps'),
	(671056, 133, '2015-02-01 00:00:15.000000', 'consum', 0.0213, 'lps'),
	(671057, 133, '2015-02-01 00:00:16.000000', 'consum', 0.0210, 'lps'),
	(671058, 133, '2015-02-01 00:00:17.000000', 'consum', 0.0216, 'lps'),
	(671059, 133, '2015-02-01 00:00:18.000000', 'consum', 0.0216, 'lps'),
	(671060, 133, '2015-02-01 00:00:19.000000', 'consum', 0.0221, 'lps'),
	(671061, 133, '2015-02-01 00:00:20.000000', 'consum', 0.0213, 'lps'),
	(671062, 133, '2015-02-01 00:00:21.000000', 'consum', 0.0216, 'lps'),
	(671063, 133, '2015-02-01 00:00:22.000000', 'consum', 0.0218, 'lps'),
	(671064, 133, '2015-02-01 00:00:23.000000', 'consum', 0.0210, 'lps'),
	(671065, 133, '2015-02-01 00:00:24.000000', 'consum', 0.0212, 'lps'),
	(671066, 133, '2015-02-01 00:00:25.000000', 'consum', 0.0220, 'lps'),
	(671067, 133, '2015-02-01 00:00:26.000000', 'consum', 0.0219, 'lps'),
	(671068, 133, '2015-02-01 00:00:27.000000', 'consum', 0.0212, 'lps'),
	(671069, 133, '2015-02-01 00:00:28.000000', 'consum', 0.0220, 'lps'),
	(671070, 133, '2015-02-01 00:00:29.000000', 'consum', 0.0217, 'lps'),
	(671071, 133, '2015-02-01 00:00:30.000000', 'consum', 0.0216, 'lps'),
	(671072, 133, '2015-02-01 00:00:31.000000', 'consum', 0.0221, 'lps'),
	(671073, 133, '2015-02-01 00:00:32.000000', 'consum', 0.0221, 'lps'),
	(671074, 133, '2015-02-01 00:00:33.000000', 'consum', 0.0219, 'lps'),
	(671075, 133, '2015-02-01 00:00:34.000000', 'consum', 0.0214, 'lps'),
	(671076, 133, '2015-02-01 00:00:35.000000', 'consum', 0.0215, 'lps'),
	(671077, 133, '2015-02-01 00:00:36.000000', 'consum', 0.0210, 'lps'),
	(671078, 133, '2015-02-01 00:00:37.000000', 'consum', 0.0210, 'lps'),
	(671079, 133, '2015-02-01 00:00:38.000000', 'consum', 0.0221, 'lps'),
	(671080, 133, '2015-02-01 00:00:39.000000', 'consum', 0.0219, 'lps'),
	(671081, 133, '2015-02-01 00:00:40.000000', 'consum', 0.0221, 'lps'),
	(671082, 133, '2015-02-01 00:00:41.000000', 'consum', 0.0216, 'lps'),
	(671083, 133, '2015-02-01 00:00:42.000000', 'consum', 0.0220, 'lps'),
	(671084, 133, '2015-02-01 00:00:43.000000', 'consum', 0.0218, 'lps'),
	(671085, 133, '2015-02-01 00:00:44.000000', 'consum', 0.0218, 'lps'),
	(671086, 133, '2015-02-01 00:00:45.000000', 'consum', 0.0218, 'lps'),
	(671087, 133, '2015-02-01 00:00:46.000000', 'consum', 0.0211, 'lps'),
	(671088, 133, '2015-02-01 00:00:47.000000', 'consum', 0.0217, 'lps'),
	(671089, 133, '2015-02-01 00:00:48.000000', 'consum', 0.0220, 'lps'),
	(671090, 133, '2015-02-01 00:00:49.000000', 'consum', 0.0216, 'lps'),
	(671091, 133, '2015-02-01 00:00:50.000000', 'consum', 0.0210, 'lps'),
	(671092, 133, '2015-02-01 00:00:51.000000', 'consum', 0.0215, 'lps'),
	(671093, 133, '2015-02-01 00:00:52.000000', 'consum', 0.0213, 'lps'),
	(671094, 133, '2015-02-01 00:00:53.000000', 'consum', 0.0212, 'lps'),
	(671095, 133, '2015-02-01 00:00:54.000000', 'consum', 0.0210, 'lps'),
	(671096, 133, '2015-02-01 00:00:55.000000', 'consum', 0.0218, 'lps'),
	(671097, 133, '2015-02-01 00:00:56.000000', 'consum', 0.0214, 'lps'),
	(671098, 133, '2015-02-01 00:00:57.000000', 'consum', 0.0216, 'lps'),
	(671099, 133, '2015-02-01 00:00:58.000000', 'consum', 0.0219, 'lps'),
	(671100, 133, '2015-02-01 00:00:59.000000', 'consum', 0.0213, 'lps'),
	(671101, 133, '2015-02-01 00:01:00.000000', 'consum', 0.0210, 'lps'),
	(671102, 133, '2015-02-01 00:01:01.000000', 'consum', 0.0214, 'lps'),
	(671103, 133, '2015-02-01 00:01:02.000000', 'consum', 0.0217, 'lps'),
	(671104, 133, '2015-02-01 00:01:03.000000', 'consum', 0.0221, 'lps'),
	(671105, 133, '2015-02-01 00:01:04.000000', 'consum', 0.0221, 'lps'),
	(671106, 133, '2015-02-01 00:01:05.000000', 'consum', 0.0220, 'lps'),
	(671107, 133, '2015-02-01 00:01:06.000000', 'consum', 0.0216, 'lps'),
	(671108, 133, '2015-02-01 00:01:07.000000', 'consum', 0.0221, 'lps'),
	(671109, 133, '2015-02-01 00:01:08.000000', 'consum', 0.0213, 'lps'),
	(671110, 133, '2015-02-01 00:01:09.000000', 'consum', 0.0216, 'lps'),
	(671111, 133, '2015-02-01 00:01:10.000000', 'consum', 0.0210, 'lps'),
	(671112, 133, '2015-02-01 00:01:11.000000', 'consum', 0.0213, 'lps'),
	(671113, 133, '2015-02-01 00:01:12.000000', 'consum', 0.0216, 'lps'),
	(671114, 133, '2015-02-01 00:01:13.000000', 'consum', 0.0220, 'lps'),
	(671115, 133, '2015-02-01 00:01:14.000000', 'consum', 0.0219, 'lps'),
	(671116, 133, '2015-02-01 00:01:15.000000', 'consum', 0.0214, 'lps'),
	(671117, 133, '2015-02-01 00:01:16.000000', 'consum', 0.0216, 'lps'),
	(671118, 133, '2015-02-01 00:01:17.000000', 'consum', 0.0217, 'lps'),
	(671119, 133, '2015-02-01 00:01:18.000000', 'consum', 0.0214, 'lps'),
	(671120, 133, '2015-02-01 00:01:19.000000', 'consum', 0.0211, 'lps'),
	(671121, 133, '2015-02-01 00:01:20.000000', 'consum', 0.0213, 'lps'),
	(671122, 133, '2015-02-01 00:01:21.000000', 'consum', 0.0211, 'lps'),
	(671123, 133, '2015-02-01 00:01:22.000000', 'consum', 0.0220, 'lps'),
	(671124, 133, '2015-02-01 00:01:23.000000', 'consum', 0.0219, 'lps'),
	(671125, 133, '2015-02-01 00:01:24.000000', 'consum', 0.0214, 'lps'),
	(671126, 133, '2015-02-01 00:01:25.000000', 'consum', 0.0214, 'lps'),
	(671127, 133, '2015-02-01 00:01:26.000000', 'consum', 0.0220, 'lps'),
	(671128, 133, '2015-02-01 00:01:27.000000', 'consum', 0.0210, 'lps'),
	(671129, 133, '2015-02-01 00:01:28.000000', 'consum', 0.0219, 'lps'),
	(671130, 133, '2015-02-01 00:01:29.000000', 'consum', 0.0221, 'lps'),
	(671131, 133, '2015-02-01 00:01:30.000000', 'consum', 0.0213, 'lps'),
	(671132, 133, '2015-02-01 00:01:31.000000', 'consum', 0.0215, 'lps'),
	(671133, 133, '2015-02-01 00:01:32.000000', 'consum', 0.0217, 'lps'),
	(671134, 133, '2015-02-01 00:01:33.000000', 'consum', 0.0217, 'lps'),
	(671135, 133, '2015-02-01 00:01:34.000000', 'consum', 0.0215, 'lps'),
	(671136, 133, '2015-02-01 00:01:35.000000', 'consum', 0.0212, 'lps'),
	(671137, 133, '2015-02-01 00:01:36.000000', 'consum', 0.0220, 'lps'),
	(671138, 133, '2015-02-01 00:01:37.000000', 'consum', 0.0219, 'lps'),
	(671139, 133, '2015-02-01 00:01:38.000000', 'consum', 0.0211, 'lps'),
	(671140, 133, '2015-02-01 00:01:39.000000', 'consum', 0.0213, 'lps'),
	(671141, 133, '2015-02-01 00:01:40.000000', 'consum', 0.0210, 'lps'),
	(671142, 133, '2015-02-01 00:01:41.000000', 'consum', 0.0213, 'lps'),
	(671143, 133, '2015-02-01 00:01:42.000000', 'consum', 0.0215, 'lps'),
	(671144, 133, '2015-02-01 00:01:43.000000', 'consum', 0.0214, 'lps'),
	(671145, 133, '2015-02-01 00:01:44.000000', 'consum', 0.0214, 'lps'),
	(671146, 133, '2015-02-01 00:01:45.000000', 'consum', 0.0219, 'lps'),
	(671147, 133, '2015-02-01 00:01:46.000000', 'consum', 0.0219, 'lps'),
	(671148, 133, '2015-02-01 00:01:47.000000', 'consum', 0.0218, 'lps'),
	(671149, 133, '2015-02-01 00:01:48.000000', 'consum', 0.0210, 'lps'),
	(671150, 133, '2015-02-01 00:01:49.000000', 'consum', 0.0210, 'lps'),
	(671151, 133, '2015-02-01 00:01:50.000000', 'consum', 0.0213, 'lps'),
	(671152, 133, '2015-02-01 00:01:51.000000', 'consum', 0.0213, 'lps'),
	(671153, 133, '2015-02-01 00:01:52.000000', 'consum', 0.0216, 'lps'),
	(671154, 133, '2015-02-01 00:01:53.000000', 'consum', 0.0221, 'lps'),
	(671155, 133, '2015-02-01 00:01:54.000000', 'consum', 0.0211, 'lps'),
	(671156, 133, '2015-02-01 00:01:55.000000', 'consum', 0.0219, 'lps'),
	(671157, 133, '2015-02-01 00:01:56.000000', 'consum', 0.0216, 'lps'),
	(671158, 133, '2015-02-01 00:01:57.000000', 'consum', 0.0213, 'lps'),
	(671159, 133, '2015-02-01 00:01:58.000000', 'consum', 0.0218, 'lps'),
	(671160, 133, '2015-02-01 00:01:59.000000', 'consum', 0.0218, 'lps'),
	(671161, 133, '2015-02-01 00:02:00.000000', 'consum', 0.0214, 'lps'),
	(671162, 133, '2015-02-01 00:02:01.000000', 'consum', 0.0221, 'lps'),
	(671163, 133, '2015-02-01 00:02:02.000000', 'consum', 0.0217, 'lps'),
	(671164, 133, '2015-02-01 00:02:03.000000', 'consum', 0.0211, 'lps'),
	(671165, 133, '2015-02-01 00:02:04.000000', 'consum', 0.0218, 'lps'),
	(671166, 133, '2015-02-01 00:02:05.000000', 'consum', 0.0211, 'lps'),
	(671167, 133, '2015-02-01 00:02:06.000000', 'consum', 0.0214, 'lps'),
	(671168, 133, '2015-02-01 00:02:07.000000', 'consum', 0.0219, 'lps'),
	(671169, 133, '2015-02-01 00:02:08.000000', 'consum', 0.0218, 'lps'),
	(671170, 133, '2015-02-01 00:02:09.000000', 'consum', 0.0210, 'lps'),
	(671171, 133, '2015-02-01 00:02:10.000000', 'consum', 0.0211, 'lps'),
	(671172, 133, '2015-02-01 00:02:11.000000', 'consum', 0.0214, 'lps'),
	(671173, 133, '2015-02-01 00:02:12.000000', 'consum', 0.0217, 'lps'),
	(671174, 133, '2015-02-01 00:02:13.000000', 'consum', 0.0221, 'lps'),
	(671175, 133, '2015-02-01 00:02:14.000000', 'consum', 0.0211, 'lps'),
	(671176, 133, '2015-02-01 00:02:15.000000', 'consum', 0.0215, 'lps'),
	(671177, 133, '2015-02-01 00:02:16.000000', 'consum', 0.0212, 'lps'),
	(671178, 133, '2015-02-01 00:02:17.000000', 'consum', 0.0214, 'lps'),
	(671179, 133, '2015-02-01 00:02:18.000000', 'consum', 0.0215, 'lps'),
	(671180, 133, '2015-02-01 00:02:19.000000', 'consum', 0.0211, 'lps'),
	(671181, 133, '2015-02-01 00:02:20.000000', 'consum', 0.0211, 'lps'),
	(671182, 133, '2015-02-01 00:02:21.000000', 'consum', 0.0214, 'lps'),
	(671183, 133, '2015-02-01 00:02:22.000000', 'consum', 0.0214, 'lps'),
	(671184, 133, '2015-02-01 00:02:23.000000', 'consum', 0.0220, 'lps'),
	(671185, 133, '2015-02-01 00:02:24.000000', 'consum', 0.0213, 'lps'),
	(671186, 133, '2015-02-01 00:02:25.000000', 'consum', 0.0220, 'lps'),
	(671187, 133, '2015-02-01 00:02:26.000000', 'consum', 0.0216, 'lps'),
	(671188, 133, '2015-02-01 00:02:27.000000', 'consum', 0.0211, 'lps'),
	(671189, 133, '2015-02-01 00:02:28.000000', 'consum', 0.0220, 'lps'),
	(671190, 133, '2015-02-01 00:02:29.000000', 'consum', 0.0221, 'lps'),
	(671191, 133, '2015-02-01 00:02:30.000000', 'consum', 0.0210, 'lps'),
	(671192, 133, '2015-02-01 00:02:31.000000', 'consum', 0.0216, 'lps'),
	(671193, 133, '2015-02-01 00:02:32.000000', 'consum', 0.0214, 'lps'),
	(671194, 133, '2015-02-01 00:02:33.000000', 'consum', 0.0215, 'lps'),
	(671195, 133, '2015-02-01 00:02:34.000000', 'consum', 0.0211, 'lps'),
	(671196, 133, '2015-02-01 00:02:35.000000', 'consum', 0.0213, 'lps'),
	(671197, 133, '2015-02-01 00:02:36.000000', 'consum', 0.0212, 'lps'),
	(671198, 133, '2015-02-01 00:02:37.000000', 'consum', 0.0210, 'lps'),
	(671199, 133, '2015-02-01 00:02:38.000000', 'consum', 0.0216, 'lps'),
	(671200, 133, '2015-02-01 00:02:39.000000', 'consum', 0.0219, 'lps'),
	(671201, 133, '2015-02-01 00:02:40.000000', 'consum', 0.0211, 'lps'),
	(671202, 133, '2015-02-01 00:02:41.000000', 'consum', 0.0213, 'lps'),
	(671203, 133, '2015-02-01 00:02:42.000000', 'consum', 0.0211, 'lps'),
	(671204, 133, '2015-02-01 00:02:43.000000', 'consum', 0.0218, 'lps'),
	(671205, 133, '2015-02-01 00:02:44.000000', 'consum', 0.0211, 'lps'),
	(671206, 133, '2015-02-01 00:02:45.000000', 'consum', 0.0215, 'lps'),
	(671207, 133, '2015-02-01 00:02:46.000000', 'consum', 0.0221, 'lps'),
	(671208, 133, '2015-02-01 00:02:47.000000', 'consum', 0.0215, 'lps'),
	(671209, 133, '2015-02-01 00:02:48.000000', 'consum', 0.0215, 'lps'),
	(671210, 133, '2015-02-01 00:02:49.000000', 'consum', 0.0221, 'lps'),
	(671211, 133, '2015-02-01 00:02:50.000000', 'consum', 0.0212, 'lps'),
	(671212, 133, '2015-02-01 00:02:51.000000', 'consum', 0.0212, 'lps'),
	(671213, 133, '2015-02-01 00:02:52.000000', 'consum', 0.0216, 'lps'),
	(671214, 133, '2015-02-01 00:02:53.000000', 'consum', 0.0221, 'lps'),
	(671215, 133, '2015-02-01 00:02:54.000000', 'consum', 0.0212, 'lps'),
	(671216, 133, '2015-02-01 00:02:55.000000', 'consum', 0.0213, 'lps'),
	(671217, 133, '2015-02-01 00:02:56.000000', 'consum', 0.0217, 'lps'),
	(671218, 133, '2015-02-01 00:02:57.000000', 'consum', 0.0212, 'lps'),
	(671219, 133, '2015-02-01 00:02:58.000000', 'consum', 0.0212, 'lps'),
	(671220, 133, '2015-02-01 00:02:59.000000', 'consum', 0.0215, 'lps'),
	(671221, 133, '2015-02-01 00:03:00.000000', 'consum', 0.0220, 'lps'),
	(671222, 133, '2015-02-01 00:03:01.000000', 'consum', 0.0218, 'lps'),
	(671223, 133, '2015-02-01 00:03:02.000000', 'consum', 0.0221, 'lps'),
	(671224, 133, '2015-02-01 00:03:03.000000', 'consum', 0.0218, 'lps'),
	(671225, 133, '2015-02-01 00:03:04.000000', 'consum', 0.0217, 'lps'),
	(671226, 133, '2015-02-01 00:03:05.000000', 'consum', 0.0220, 'lps'),
	(671227, 133, '2015-02-01 00:03:06.000000', 'consum', 0.0218, 'lps'),
	(671228, 133, '2015-02-01 00:03:07.000000', 'consum', 0.0219, 'lps'),
	(671229, 133, '2015-02-01 00:03:08.000000', 'consum', 0.0219, 'lps'),
	(671230, 133, '2015-02-01 00:03:09.000000', 'consum', 0.0216, 'lps'),
	(671231, 133, '2015-02-01 00:03:10.000000', 'consum', 0.0215, 'lps'),
	(671232, 133, '2015-02-01 00:03:11.000000', 'consum', 0.0219, 'lps'),
	(671233, 133, '2015-02-01 00:03:12.000000', 'consum', 0.0213, 'lps'),
	(671234, 133, '2015-02-01 00:03:13.000000', 'consum', 0.0214, 'lps'),
	(671235, 133, '2015-02-01 00:03:14.000000', 'consum', 0.0218, 'lps'),
	(671236, 133, '2015-02-01 00:03:15.000000', 'consum', 0.0217, 'lps'),
	(671237, 133, '2015-02-01 00:03:16.000000', 'consum', 0.0220, 'lps'),
	(671238, 133, '2015-02-01 00:03:17.000000', 'consum', 0.0218, 'lps'),
	(671239, 133, '2015-02-01 00:03:18.000000', 'consum', 0.0217, 'lps'),
	(671240, 133, '2015-02-01 00:03:19.000000', 'consum', 0.0213, 'lps'),
	(671241, 133, '2015-02-01 00:03:20.000000', 'consum', 0.0214, 'lps'),
	(671242, 133, '2015-02-01 00:03:21.000000', 'consum', 0.0211, 'lps'),
	(671243, 133, '2015-02-01 00:03:22.000000', 'consum', 0.0214, 'lps'),
	(671244, 133, '2015-02-01 00:03:23.000000', 'consum', 0.0215, 'lps'),
	(671245, 133, '2015-02-01 00:03:24.000000', 'consum', 0.0212, 'lps'),
	(671246, 133, '2015-02-01 00:03:25.000000', 'consum', 0.0216, 'lps'),
	(671247, 133, '2015-02-01 00:03:26.000000', 'consum', 0.0213, 'lps'),
	(671248, 133, '2015-02-01 00:03:27.000000', 'consum', 0.0217, 'lps'),
	(671249, 133, '2015-02-01 00:03:28.000000', 'consum', 0.0214, 'lps'),
	(671250, 133, '2015-02-01 00:03:29.000000', 'consum', 0.0221, 'lps'),
	(671251, 133, '2015-02-01 00:03:30.000000', 'consum', 0.0219, 'lps'),
	(671252, 133, '2015-02-01 00:03:31.000000', 'consum', 0.0210, 'lps'),
	(671253, 133, '2015-02-01 00:03:32.000000', 'consum', 0.0221, 'lps'),
	(671254, 133, '2015-02-01 00:03:33.000000', 'consum', 0.0217, 'lps'),
	(671255, 133, '2015-02-01 00:03:34.000000', 'consum', 0.0210, 'lps'),
	(671256, 133, '2015-02-01 00:03:35.000000', 'consum', 0.0215, 'lps'),
	(671257, 133, '2015-02-01 00:03:36.000000', 'consum', 0.0221, 'lps'),
	(671258, 133, '2015-02-01 00:03:37.000000', 'consum', 0.0218, 'lps'),
	(671259, 133, '2015-02-01 00:03:38.000000', 'consum', 0.0216, 'lps'),
	(671260, 133, '2015-02-01 00:03:39.000000', 'consum', 0.0218, 'lps'),
	(671261, 133, '2015-02-01 00:03:40.000000', 'consum', 0.0220, 'lps'),
	(671262, 133, '2015-02-01 00:03:41.000000', 'consum', 0.0213, 'lps'),
	(671263, 133, '2015-02-01 00:03:42.000000', 'consum', 0.0217, 'lps'),
	(671264, 133, '2015-02-01 00:03:43.000000', 'consum', 0.0215, 'lps'),
	(671265, 133, '2015-02-01 00:03:44.000000', 'consum', 0.0214, 'lps'),
	(671266, 133, '2015-02-01 00:03:45.000000', 'consum', 0.0215, 'lps'),
	(671267, 133, '2015-02-01 00:03:46.000000', 'consum', 0.0212, 'lps'),
	(671268, 133, '2015-02-01 00:03:47.000000', 'consum', 0.0219, 'lps'),
	(671269, 133, '2015-02-01 00:03:48.000000', 'consum', 0.0211, 'lps'),
	(671270, 133, '2015-02-01 00:03:49.000000', 'consum', 0.0214, 'lps'),
	(671271, 133, '2015-02-01 00:03:50.000000', 'consum', 0.0215, 'lps'),
	(671272, 133, '2015-02-01 00:03:51.000000', 'consum', 0.0211, 'lps'),
	(671273, 133, '2015-02-01 00:03:52.000000', 'consum', 0.0212, 'lps'),
	(671274, 133, '2015-02-01 00:03:53.000000', 'consum', 0.0219, 'lps'),
	(671275, 133, '2015-02-01 00:03:54.000000', 'consum', 0.0212, 'lps'),
	(671276, 133, '2015-02-01 00:03:55.000000', 'consum', 0.0218, 'lps'),
	(671277, 133, '2015-02-01 00:03:56.000000', 'consum', 0.0210, 'lps'),
	(671278, 133, '2015-02-01 00:03:57.000000', 'consum', 0.0220, 'lps'),
	(671279, 133, '2015-02-01 00:03:58.000000', 'consum', 0.0214, 'lps'),
	(671280, 133, '2015-02-01 00:03:59.000000', 'consum', 0.0214, 'lps'),
	(671281, 133, '2015-02-01 00:04:00.000000', 'consum', 0.0218, 'lps'),
	(671282, 133, '2015-02-01 00:04:01.000000', 'consum', 0.0214, 'lps'),
	(671283, 133, '2015-02-01 00:04:02.000000', 'consum', 0.0219, 'lps'),
	(671284, 133, '2015-02-01 00:04:03.000000', 'consum', 0.0220, 'lps'),
	(671285, 133, '2015-02-01 00:04:04.000000', 'consum', 0.0221, 'lps'),
	(671286, 133, '2015-02-01 00:04:05.000000', 'consum', 0.0211, 'lps'),
	(671287, 133, '2015-02-01 00:04:06.000000', 'consum', 0.0220, 'lps'),
	(671288, 133, '2015-02-01 00:04:07.000000', 'consum', 0.0221, 'lps'),
	(671289, 133, '2015-02-01 00:04:08.000000', 'consum', 0.0211, 'lps'),
	(671290, 133, '2015-02-01 00:04:09.000000', 'consum', 0.0219, 'lps'),
	(671291, 133, '2015-02-01 00:04:10.000000', 'consum', 0.0216, 'lps'),
	(671292, 133, '2015-02-01 00:04:11.000000', 'consum', 0.0215, 'lps'),
	(671293, 133, '2015-02-01 00:04:12.000000', 'consum', 0.0216, 'lps'),
	(671294, 133, '2015-02-01 00:04:13.000000', 'consum', 0.0214, 'lps'),
	(671295, 133, '2015-02-01 00:04:14.000000', 'consum', 0.0214, 'lps'),
	(671296, 133, '2015-02-01 00:04:15.000000', 'consum', 0.0216, 'lps'),
	(671297, 133, '2015-02-01 00:04:16.000000', 'consum', 0.0219, 'lps'),
	(671298, 133, '2015-02-01 00:04:17.000000', 'consum', 0.0211, 'lps'),
	(671299, 133, '2015-02-01 00:04:18.000000', 'consum', 0.0213, 'lps'),
	(671300, 133, '2015-02-01 00:04:19.000000', 'consum', 0.0212, 'lps'),
	(671301, 133, '2015-02-01 00:04:20.000000', 'consum', 0.0221, 'lps'),
	(671302, 133, '2015-02-01 00:04:21.000000', 'consum', 0.0213, 'lps'),
	(671303, 133, '2015-02-01 00:04:22.000000', 'consum', 0.0215, 'lps'),
	(671304, 133, '2015-02-01 00:04:23.000000', 'consum', 0.0215, 'lps'),
	(671305, 133, '2015-02-01 00:04:24.000000', 'consum', 0.0220, 'lps'),
	(671306, 133, '2015-02-01 00:04:25.000000', 'consum', 0.0210, 'lps'),
	(671307, 133, '2015-02-01 00:04:26.000000', 'consum', 0.0218, 'lps'),
	(671308, 133, '2015-02-01 00:04:27.000000', 'consum', 0.0212, 'lps'),
	(671309, 133, '2015-02-01 00:04:28.000000', 'consum', 0.0221, 'lps'),
	(671310, 133, '2015-02-01 00:04:29.000000', 'consum', 0.0211, 'lps'),
	(671311, 133, '2015-02-01 00:04:30.000000', 'consum', 0.0220, 'lps'),
	(671312, 133, '2015-02-01 00:04:31.000000', 'consum', 0.0219, 'lps'),
	(671313, 133, '2015-02-01 00:04:32.000000', 'consum', 0.0216, 'lps'),
	(671314, 133, '2015-02-01 00:04:33.000000', 'consum', 0.0212, 'lps'),
	(671315, 133, '2015-02-01 00:04:34.000000', 'consum', 0.0216, 'lps'),
	(671316, 133, '2015-02-01 00:04:35.000000', 'consum', 0.0212, 'lps'),
	(671317, 133, '2015-02-01 00:04:36.000000', 'consum', 0.0213, 'lps'),
	(671318, 133, '2015-02-01 00:04:37.000000', 'consum', 0.0218, 'lps'),
	(671319, 133, '2015-02-01 00:04:38.000000', 'consum', 0.0217, 'lps'),
	(671320, 133, '2015-02-01 00:04:39.000000', 'consum', 0.0221, 'lps'),
	(671321, 133, '2015-02-01 00:04:40.000000', 'consum', 0.0210, 'lps'),
	(671322, 133, '2015-02-01 00:04:41.000000', 'consum', 0.0212, 'lps'),
	(671323, 133, '2015-02-01 00:04:42.000000', 'consum', 0.0221, 'lps'),
	(671324, 133, '2015-02-01 00:04:43.000000', 'consum', 0.0214, 'lps'),
	(671325, 133, '2015-02-01 00:04:44.000000', 'consum', 0.0219, 'lps'),
	(671326, 133, '2015-02-01 00:04:45.000000', 'consum', 0.0219, 'lps'),
	(671327, 133, '2015-02-01 00:04:46.000000', 'consum', 0.0216, 'lps'),
	(671328, 133, '2015-02-01 00:04:47.000000', 'consum', 0.0214, 'lps'),
	(671329, 133, '2015-02-01 00:04:48.000000', 'consum', 0.0213, 'lps'),
	(671330, 133, '2015-02-01 00:04:49.000000', 'consum', 0.0212, 'lps'),
	(671331, 133, '2015-02-01 00:04:50.000000', 'consum', 0.0213, 'lps'),
	(671332, 133, '2015-02-01 00:04:51.000000', 'consum', 0.0218, 'lps'),
	(671333, 133, '2015-02-01 00:04:52.000000', 'consum', 0.0218, 'lps'),
	(671334, 133, '2015-02-01 00:04:53.000000', 'consum', 0.0217, 'lps'),
	(671335, 133, '2015-02-01 00:04:54.000000', 'consum', 0.0219, 'lps'),
	(671336, 133, '2015-02-01 00:04:55.000000', 'consum', 0.0210, 'lps'),
	(671337, 133, '2015-02-01 00:04:56.000000', 'consum', 0.0218, 'lps'),
	(671338, 133, '2015-02-01 00:04:57.000000', 'consum', 0.0217, 'lps'),
	(671339, 133, '2015-02-01 00:04:58.000000', 'consum', 0.0221, 'lps'),
	(671340, 133, '2015-02-01 00:04:59.000000', 'consum', 0.0220, 'lps'),
	(671341, 133, '2015-02-01 00:05:00.000000', 'consum', 0.0216, 'lps'),
	(671342, 133, '2015-02-01 00:05:01.000000', 'consum', 0.0211, 'lps'),
	(671343, 133, '2015-02-01 00:05:02.000000', 'consum', 0.0220, 'lps'),
	(671344, 133, '2015-02-01 00:05:03.000000', 'consum', 0.0220, 'lps'),
	(671345, 133, '2015-02-01 00:05:04.000000', 'consum', 0.0220, 'lps'),
	(671346, 133, '2015-02-01 00:05:05.000000', 'consum', 0.0220, 'lps'),
	(671347, 133, '2015-02-01 00:05:06.000000', 'consum', 0.0219, 'lps'),
	(671348, 133, '2015-02-01 00:05:07.000000', 'consum', 0.0210, 'lps'),
	(671349, 133, '2015-02-01 00:05:08.000000', 'consum', 0.0211, 'lps'),
	(671350, 133, '2015-02-01 00:05:09.000000', 'consum', 0.0214, 'lps'),
	(671351, 133, '2015-02-01 00:05:10.000000', 'consum', 0.0217, 'lps'),
	(671352, 133, '2015-02-01 00:05:11.000000', 'consum', 0.0221, 'lps'),
	(671353, 133, '2015-02-01 00:05:12.000000', 'consum', 0.0220, 'lps'),
	(671354, 133, '2015-02-01 00:05:13.000000', 'consum', 0.0218, 'lps'),
	(671355, 133, '2015-02-01 00:05:14.000000', 'consum', 0.0218, 'lps'),
	(671356, 133, '2015-02-01 00:05:15.000000', 'consum', 0.0215, 'lps'),
	(671357, 133, '2015-02-01 00:05:16.000000', 'consum', 0.0210, 'lps'),
	(671358, 133, '2015-02-01 00:05:17.000000', 'consum', 0.0220, 'lps'),
	(671359, 133, '2015-02-01 00:05:18.000000', 'consum', 0.0212, 'lps'),
	(671360, 133, '2015-02-01 00:05:19.000000', 'consum', 0.0215, 'lps'),
	(671361, 133, '2015-02-01 00:05:20.000000', 'consum', 0.0218, 'lps'),
	(671362, 133, '2015-02-01 00:05:21.000000', 'consum', 0.0210, 'lps'),
	(671363, 133, '2015-02-01 00:05:22.000000', 'consum', 0.0213, 'lps'),
	(671364, 133, '2015-02-01 00:05:23.000000', 'consum', 0.0213, 'lps'),
	(671365, 133, '2015-02-01 00:05:24.000000', 'consum', 0.0216, 'lps'),
	(671366, 133, '2015-02-01 00:05:25.000000', 'consum', 0.0218, 'lps'),
	(671367, 133, '2015-02-01 00:05:26.000000', 'consum', 0.0210, 'lps'),
	(671368, 133, '2015-02-01 00:05:27.000000', 'consum', 0.0212, 'lps'),
	(671369, 133, '2015-02-01 00:05:28.000000', 'consum', 0.0218, 'lps'),
	(671370, 133, '2015-02-01 00:05:29.000000', 'consum', 0.0221, 'lps'),
	(671371, 133, '2015-02-01 00:05:30.000000', 'consum', 0.0220, 'lps'),
	(671372, 133, '2015-02-01 00:05:31.000000', 'consum', 0.0212, 'lps'),
	(671373, 133, '2015-02-01 00:05:32.000000', 'consum', 0.0216, 'lps'),
	(671374, 133, '2015-02-01 00:05:33.000000', 'consum', 0.0221, 'lps'),
	(671375, 133, '2015-02-01 00:05:34.000000', 'consum', 0.0215, 'lps'),
	(671376, 133, '2015-02-01 00:05:35.000000', 'consum', 0.0211, 'lps'),
	(671377, 133, '2015-02-01 00:05:36.000000', 'consum', 0.0213, 'lps'),
	(671378, 133, '2015-02-01 00:05:37.000000', 'consum', 0.0221, 'lps'),
	(671379, 133, '2015-02-01 00:05:38.000000', 'consum', 0.0210, 'lps'),
	(671380, 133, '2015-02-01 00:05:39.000000', 'consum', 0.0213, 'lps'),
	(671381, 133, '2015-02-01 00:05:40.000000', 'consum', 0.0214, 'lps'),
	(671382, 133, '2015-02-01 00:05:41.000000', 'consum', 0.0220, 'lps'),
	(671383, 133, '2015-02-01 00:05:42.000000', 'consum', 0.0214, 'lps'),
	(671384, 133, '2015-02-01 00:05:43.000000', 'consum', 0.0213, 'lps'),
	(671385, 133, '2015-02-01 00:05:44.000000', 'consum', 0.0212, 'lps'),
	(671386, 133, '2015-02-01 00:05:45.000000', 'consum', 0.0214, 'lps'),
	(671387, 133, '2015-02-01 00:05:46.000000', 'consum', 0.0212, 'lps'),
	(671388, 133, '2015-02-01 00:05:47.000000', 'consum', 0.0218, 'lps'),
	(671389, 133, '2015-02-01 00:05:48.000000', 'consum', 0.0211, 'lps'),
	(671390, 133, '2015-02-01 00:05:49.000000', 'consum', 0.0216, 'lps'),
	(671391, 133, '2015-02-01 00:05:50.000000', 'consum', 0.0211, 'lps'),
	(671392, 133, '2015-02-01 00:05:51.000000', 'consum', 0.0211, 'lps'),
	(671393, 133, '2015-02-01 00:05:52.000000', 'consum', 0.0214, 'lps'),
	(671394, 133, '2015-02-01 00:05:53.000000', 'consum', 0.0215, 'lps'),
	(671395, 133, '2015-02-01 00:05:54.000000', 'consum', 0.0221, 'lps'),
	(671396, 133, '2015-02-01 00:05:55.000000', 'consum', 0.0218, 'lps'),
	(671397, 133, '2015-02-01 00:05:56.000000', 'consum', 0.0215, 'lps'),
	(671398, 133, '2015-02-01 00:05:57.000000', 'consum', 0.0211, 'lps'),
	(671399, 133, '2015-02-01 00:05:58.000000', 'consum', 0.0211, 'lps'),
	(671400, 133, '2015-02-01 00:05:59.000000', 'consum', 0.0215, 'lps'),
	(671401, 133, '2015-02-01 00:06:00.000000', 'consum', 0.0221, 'lps'),
	(671402, 133, '2015-02-01 00:06:01.000000', 'consum', 0.0214, 'lps'),
	(671403, 133, '2015-02-01 00:06:02.000000', 'consum', 0.0211, 'lps'),
	(671404, 133, '2015-02-01 00:06:03.000000', 'consum', 0.0216, 'lps'),
	(671405, 133, '2015-02-01 00:06:04.000000', 'consum', 0.0214, 'lps'),
	(671406, 133, '2015-02-01 00:06:05.000000', 'consum', 0.0210, 'lps'),
	(671407, 133, '2015-02-01 00:06:06.000000', 'consum', 0.0211, 'lps'),
	(671408, 133, '2015-02-01 00:06:07.000000', 'consum', 0.0216, 'lps'),
	(671409, 133, '2015-02-01 00:06:08.000000', 'consum', 0.0214, 'lps'),
	(671410, 133, '2015-02-01 00:06:09.000000', 'consum', 0.0211, 'lps'),
	(671411, 133, '2015-02-01 00:06:10.000000', 'consum', 0.0216, 'lps'),
	(671412, 133, '2015-02-01 00:06:11.000000', 'consum', 0.0215, 'lps'),
	(671413, 133, '2015-02-01 00:06:12.000000', 'consum', 0.0218, 'lps'),
	(671414, 133, '2015-02-01 00:06:13.000000', 'consum', 0.0212, 'lps'),
	(671415, 133, '2015-02-01 00:06:14.000000', 'consum', 0.0219, 'lps'),
	(671416, 133, '2015-02-01 00:06:15.000000', 'consum', 0.0213, 'lps'),
	(671417, 133, '2015-02-01 00:06:16.000000', 'consum', 0.0210, 'lps'),
	(671418, 133, '2015-02-01 00:06:17.000000', 'consum', 0.0214, 'lps'),
	(671419, 133, '2015-02-01 00:06:18.000000', 'consum', 0.0218, 'lps'),
	(671420, 133, '2015-02-01 00:06:19.000000', 'consum', 0.0214, 'lps'),
	(671421, 133, '2015-02-01 00:06:20.000000', 'consum', 0.0220, 'lps'),
	(671422, 133, '2015-02-01 00:06:21.000000', 'consum', 0.0214, 'lps'),
	(671423, 133, '2015-02-01 00:06:22.000000', 'consum', 0.0221, 'lps'),
	(671424, 133, '2015-02-01 00:06:23.000000', 'consum', 0.0221, 'lps'),
	(671425, 133, '2015-02-01 00:06:24.000000', 'consum', 0.0219, 'lps'),
	(671426, 133, '2015-02-01 00:06:25.000000', 'consum', 0.0211, 'lps'),
	(671427, 133, '2015-02-01 00:06:26.000000', 'consum', 0.0211, 'lps'),
	(671428, 133, '2015-02-01 00:06:27.000000', 'consum', 0.0211, 'lps'),
	(671429, 133, '2015-02-01 00:06:28.000000', 'consum', 0.0215, 'lps'),
	(671430, 133, '2015-02-01 00:06:29.000000', 'consum', 0.0220, 'lps'),
	(671431, 133, '2015-02-01 00:06:30.000000', 'consum', 0.0211, 'lps'),
	(671432, 133, '2015-02-01 00:06:31.000000', 'consum', 0.0210, 'lps'),
	(671433, 133, '2015-02-01 00:06:32.000000', 'consum', 0.0217, 'lps'),
	(671434, 133, '2015-02-01 00:06:33.000000', 'consum', 0.0210, 'lps'),
	(671435, 133, '2015-02-01 00:06:34.000000', 'consum', 0.0213, 'lps'),
	(671436, 133, '2015-02-01 00:06:35.000000', 'consum', 0.0216, 'lps'),
	(671437, 133, '2015-02-01 00:06:36.000000', 'consum', 0.0216, 'lps'),
	(671438, 133, '2015-02-01 00:06:37.000000', 'consum', 0.0213, 'lps'),
	(671439, 133, '2015-02-01 00:06:38.000000', 'consum', 0.0219, 'lps'),
	(671440, 133, '2015-02-01 00:06:39.000000', 'consum', 0.0221, 'lps'),
	(671441, 133, '2015-02-01 00:06:40.000000', 'consum', 0.0214, 'lps'),
	(671442, 133, '2015-02-01 00:06:41.000000', 'consum', 0.0210, 'lps'),
	(671443, 133, '2015-02-01 00:06:42.000000', 'consum', 0.0212, 'lps'),
	(671444, 133, '2015-02-01 00:06:43.000000', 'consum', 0.0219, 'lps'),
	(671445, 133, '2015-02-01 00:06:44.000000', 'consum', 0.0214, 'lps'),
	(671446, 133, '2015-02-01 00:06:45.000000', 'consum', 0.0217, 'lps'),
	(671447, 133, '2015-02-01 00:06:46.000000', 'consum', 0.0221, 'lps'),
	(671448, 133, '2015-02-01 00:06:47.000000', 'consum', 0.0220, 'lps'),
	(671449, 133, '2015-02-01 00:06:48.000000', 'consum', 0.0215, 'lps'),
	(671450, 133, '2015-02-01 00:06:49.000000', 'consum', 0.0218, 'lps'),
	(671451, 133, '2015-02-01 00:06:50.000000', 'consum', 0.0213, 'lps'),
	(671452, 133, '2015-02-01 00:06:51.000000', 'consum', 0.0212, 'lps'),
	(671453, 133, '2015-02-01 00:06:52.000000', 'consum', 0.0213, 'lps'),
	(671454, 133, '2015-02-01 00:06:53.000000', 'consum', 0.0220, 'lps'),
	(671455, 133, '2015-02-01 00:06:54.000000', 'consum', 0.0215, 'lps'),
	(671456, 133, '2015-02-01 00:06:55.000000', 'consum', 0.0216, 'lps'),
	(671457, 133, '2015-02-01 00:06:56.000000', 'consum', 0.0215, 'lps'),
	(671458, 133, '2015-02-01 00:06:57.000000', 'consum', 0.0219, 'lps'),
	(671459, 133, '2015-02-01 00:06:58.000000', 'consum', 0.0215, 'lps'),
	(671460, 133, '2015-02-01 00:06:59.000000', 'consum', 0.0210, 'lps'),
	(671461, 133, '2015-02-01 00:07:00.000000', 'consum', 0.0219, 'lps'),
	(671462, 133, '2015-02-01 00:07:01.000000', 'consum', 0.0221, 'lps'),
	(671463, 133, '2015-02-01 00:07:02.000000', 'consum', 0.0214, 'lps'),
	(671464, 133, '2015-02-01 00:07:03.000000', 'consum', 0.0219, 'lps'),
	(671465, 133, '2015-02-01 00:07:04.000000', 'consum', 0.0220, 'lps'),
	(671466, 133, '2015-02-01 00:07:05.000000', 'consum', 0.0211, 'lps'),
	(671467, 133, '2015-02-01 00:07:06.000000', 'consum', 0.0220, 'lps'),
	(671468, 133, '2015-02-01 00:07:07.000000', 'consum', 0.0221, 'lps'),
	(671469, 133, '2015-02-01 00:07:08.000000', 'consum', 0.0213, 'lps'),
	(671470, 133, '2015-02-01 00:07:09.000000', 'consum', 0.0214, 'lps'),
	(671471, 133, '2015-02-01 00:07:10.000000', 'consum', 0.0211, 'lps'),
	(671472, 133, '2015-02-01 00:07:11.000000', 'consum', 0.0217, 'lps'),
	(671473, 133, '2015-02-01 00:07:12.000000', 'consum', 0.0217, 'lps'),
	(671474, 133, '2015-02-01 00:07:13.000000', 'consum', 0.0214, 'lps'),
	(671475, 133, '2015-02-01 00:07:14.000000', 'consum', 0.0220, 'lps'),
	(671476, 133, '2015-02-01 00:07:15.000000', 'consum', 0.0213, 'lps'),
	(671477, 133, '2015-02-01 00:07:16.000000', 'consum', 0.0221, 'lps'),
	(671478, 133, '2015-02-01 00:07:17.000000', 'consum', 0.0219, 'lps'),
	(671479, 133, '2015-02-01 00:07:18.000000', 'consum', 0.0211, 'lps'),
	(671480, 133, '2015-02-01 00:07:19.000000', 'consum', 0.0210, 'lps'),
	(671481, 133, '2015-02-01 00:07:20.000000', 'consum', 0.0211, 'lps'),
	(671482, 133, '2015-02-01 00:07:21.000000', 'consum', 0.0215, 'lps'),
	(671483, 133, '2015-02-01 00:07:22.000000', 'consum', 0.0220, 'lps'),
	(671484, 133, '2015-02-01 00:07:23.000000', 'consum', 0.0221, 'lps'),
	(671485, 133, '2015-02-01 00:07:24.000000', 'consum', 0.0213, 'lps'),
	(671486, 133, '2015-02-01 00:07:25.000000', 'consum', 0.0214, 'lps'),
	(671487, 133, '2015-02-01 00:07:26.000000', 'consum', 0.0221, 'lps'),
	(671488, 133, '2015-02-01 00:07:27.000000', 'consum', 0.0220, 'lps'),
	(671489, 133, '2015-02-01 00:07:28.000000', 'consum', 0.0215, 'lps'),
	(671490, 133, '2015-02-01 00:07:29.000000', 'consum', 0.0218, 'lps'),
	(671491, 133, '2015-02-01 00:07:30.000000', 'consum', 0.0221, 'lps'),
	(671492, 133, '2015-02-01 00:07:31.000000', 'consum', 0.0219, 'lps'),
	(671493, 133, '2015-02-01 00:07:32.000000', 'consum', 0.0212, 'lps'),
	(671494, 133, '2015-02-01 00:07:33.000000', 'consum', 0.0215, 'lps'),
	(671495, 133, '2015-02-01 00:07:34.000000', 'consum', 0.0219, 'lps'),
	(671496, 133, '2015-02-01 00:07:35.000000', 'consum', 0.0218, 'lps'),
	(671497, 133, '2015-02-01 00:07:36.000000', 'consum', 0.0221, 'lps'),
	(671498, 133, '2015-02-01 00:07:37.000000', 'consum', 0.0220, 'lps'),
	(671499, 133, '2015-02-01 00:07:38.000000', 'consum', 0.0213, 'lps'),
	(671500, 133, '2015-02-01 00:07:39.000000', 'consum', 0.0220, 'lps'),
	(671501, 133, '2015-02-01 00:07:40.000000', 'consum', 0.0214, 'lps'),
	(671502, 133, '2015-02-01 00:07:41.000000', 'consum', 0.0214, 'lps'),
	(671503, 133, '2015-02-01 00:07:42.000000', 'consum', 0.0218, 'lps'),
	(671504, 133, '2015-02-01 00:07:43.000000', 'consum', 0.0216, 'lps'),
	(671505, 133, '2015-02-01 00:07:44.000000', 'consum', 0.0215, 'lps'),
	(671506, 133, '2015-02-01 00:07:45.000000', 'consum', 0.0219, 'lps'),
	(671507, 133, '2015-02-01 00:07:46.000000', 'consum', 0.0217, 'lps'),
	(671508, 133, '2015-02-01 00:07:47.000000', 'consum', 0.0218, 'lps'),
	(671509, 133, '2015-02-01 00:07:48.000000', 'consum', 0.0218, 'lps'),
	(671510, 133, '2015-02-01 00:07:49.000000', 'consum', 0.0214, 'lps'),
	(671511, 133, '2015-02-01 00:07:50.000000', 'consum', 0.0218, 'lps'),
	(671512, 133, '2015-02-01 00:07:51.000000', 'consum', 0.0215, 'lps'),
	(671513, 133, '2015-02-01 00:07:52.000000', 'consum', 0.0212, 'lps'),
	(671514, 133, '2015-02-01 00:07:53.000000', 'consum', 0.0219, 'lps'),
	(671515, 133, '2015-02-01 00:07:54.000000', 'consum', 0.0211, 'lps'),
	(671516, 133, '2015-02-01 00:07:55.000000', 'consum', 0.0212, 'lps'),
	(671517, 133, '2015-02-01 00:07:56.000000', 'consum', 0.0217, 'lps'),
	(671518, 133, '2015-02-01 00:07:57.000000', 'consum', 0.0218, 'lps'),
	(671519, 133, '2015-02-01 00:07:58.000000', 'consum', 0.0217, 'lps'),
	(671520, 133, '2015-02-01 00:07:59.000000', 'consum', 0.0219, 'lps'),
	(671521, 133, '2015-02-01 00:08:00.000000', 'consum', 0.0213, 'lps'),
	(671522, 133, '2015-02-01 00:08:01.000000', 'consum', 0.0210, 'lps'),
	(671523, 133, '2015-02-01 00:08:02.000000', 'consum', 0.0215, 'lps'),
	(671524, 133, '2015-02-01 00:08:03.000000', 'consum', 0.0220, 'lps'),
	(671525, 133, '2015-02-01 00:08:04.000000', 'consum', 0.0212, 'lps'),
	(671526, 133, '2015-02-01 00:08:05.000000', 'consum', 0.0216, 'lps'),
	(671527, 133, '2015-02-01 00:08:06.000000', 'consum', 0.0220, 'lps'),
	(671528, 133, '2015-02-01 00:08:07.000000', 'consum', 0.0217, 'lps'),
	(671529, 133, '2015-02-01 00:08:08.000000', 'consum', 0.0218, 'lps'),
	(671530, 133, '2015-02-01 00:08:09.000000', 'consum', 0.0218, 'lps'),
	(671531, 133, '2015-02-01 00:08:10.000000', 'consum', 0.0215, 'lps'),
	(671532, 133, '2015-02-01 00:08:11.000000', 'consum', 0.0212, 'lps'),
	(671533, 133, '2015-02-01 00:08:12.000000', 'consum', 0.0219, 'lps'),
	(671534, 133, '2015-02-01 00:08:13.000000', 'consum', 0.0210, 'lps'),
	(671535, 133, '2015-02-01 00:08:14.000000', 'consum', 0.0221, 'lps'),
	(671536, 133, '2015-02-01 00:08:15.000000', 'consum', 0.0219, 'lps'),
	(671537, 133, '2015-02-01 00:08:16.000000', 'consum', 0.0210, 'lps'),
	(671538, 133, '2015-02-01 00:08:17.000000', 'consum', 0.0217, 'lps'),
	(671539, 133, '2015-02-01 00:08:18.000000', 'consum', 0.0212, 'lps'),
	(671540, 133, '2015-02-01 00:08:19.000000', 'consum', 0.0210, 'lps'),
	(671541, 133, '2015-02-01 00:08:20.000000', 'consum', 0.0216, 'lps'),
	(671542, 133, '2015-02-01 00:08:21.000000', 'consum', 0.0217, 'lps'),
	(671543, 133, '2015-02-01 00:08:22.000000', 'consum', 0.0214, 'lps'),
	(671544, 133, '2015-02-01 00:08:23.000000', 'consum', 0.0212, 'lps'),
	(671545, 133, '2015-02-01 00:08:24.000000', 'consum', 0.0218, 'lps'),
	(671546, 133, '2015-02-01 00:08:25.000000', 'consum', 0.0221, 'lps'),
	(671547, 133, '2015-02-01 00:08:26.000000', 'consum', 0.0219, 'lps'),
	(671548, 133, '2015-02-01 00:08:27.000000', 'consum', 0.0221, 'lps'),
	(671549, 133, '2015-02-01 00:08:28.000000', 'consum', 0.0216, 'lps'),
	(671550, 133, '2015-02-01 00:08:29.000000', 'consum', 0.0218, 'lps'),
	(671551, 133, '2015-02-01 00:08:30.000000', 'consum', 0.0210, 'lps'),
	(671552, 133, '2015-02-01 00:08:31.000000', 'consum', 0.0212, 'lps'),
	(671553, 133, '2015-02-01 00:08:32.000000', 'consum', 0.0217, 'lps'),
	(671554, 133, '2015-02-01 00:08:33.000000', 'consum', 0.0217, 'lps'),
	(671555, 133, '2015-02-01 00:08:34.000000', 'consum', 0.0210, 'lps'),
	(671556, 133, '2015-02-01 00:08:35.000000', 'consum', 0.0217, 'lps'),
	(671557, 133, '2015-02-01 00:08:36.000000', 'consum', 0.0220, 'lps'),
	(671558, 133, '2015-02-01 00:08:37.000000', 'consum', 0.0215, 'lps'),
	(671559, 133, '2015-02-01 00:08:38.000000', 'consum', 0.0219, 'lps'),
	(671560, 133, '2015-02-01 00:08:39.000000', 'consum', 0.0217, 'lps'),
	(671561, 133, '2015-02-01 00:08:40.000000', 'consum', 0.0217, 'lps'),
	(671562, 133, '2015-02-01 00:08:41.000000', 'consum', 0.0213, 'lps'),
	(671563, 133, '2015-02-01 00:08:42.000000', 'consum', 0.0216, 'lps'),
	(671564, 133, '2015-02-01 00:08:43.000000', 'consum', 0.0210, 'lps'),
	(671565, 133, '2015-02-01 00:08:44.000000', 'consum', 0.0214, 'lps'),
	(671566, 133, '2015-02-01 00:08:45.000000', 'consum', 0.0218, 'lps'),
	(671567, 133, '2015-02-01 00:08:46.000000', 'consum', 0.0214, 'lps'),
	(671568, 133, '2015-02-01 00:08:47.000000', 'consum', 0.0210, 'lps'),
	(671569, 133, '2015-02-01 00:08:48.000000', 'consum', 0.0219, 'lps'),
	(671570, 133, '2015-02-01 00:08:49.000000', 'consum', 0.0219, 'lps'),
	(671571, 133, '2015-02-01 00:08:50.000000', 'consum', 0.0218, 'lps'),
	(671572, 133, '2015-02-01 00:08:51.000000', 'consum', 0.0210, 'lps'),
	(671573, 133, '2015-02-01 00:08:52.000000', 'consum', 0.0213, 'lps'),
	(671574, 133, '2015-02-01 00:08:53.000000', 'consum', 0.0214, 'lps'),
	(671575, 133, '2015-02-01 00:08:54.000000', 'consum', 0.0219, 'lps'),
	(671576, 133, '2015-02-01 00:08:55.000000', 'consum', 0.0210, 'lps'),
	(671577, 133, '2015-02-01 00:08:56.000000', 'consum', 0.0220, 'lps'),
	(671578, 133, '2015-02-01 00:08:57.000000', 'consum', 0.0221, 'lps'),
	(671579, 133, '2015-02-01 00:08:58.000000', 'consum', 0.0215, 'lps'),
	(671580, 133, '2015-02-01 00:08:59.000000', 'consum', 0.0214, 'lps'),
	(671581, 133, '2015-02-01 00:09:00.000000', 'consum', 0.0217, 'lps'),
	(671582, 133, '2015-02-01 00:09:01.000000', 'consum', 0.0221, 'lps'),
	(671583, 133, '2015-02-01 00:09:02.000000', 'consum', 0.0218, 'lps'),
	(671584, 133, '2015-02-01 00:09:03.000000', 'consum', 0.0218, 'lps'),
	(671585, 133, '2015-02-01 00:09:04.000000', 'consum', 0.0216, 'lps'),
	(671586, 133, '2015-02-01 00:09:05.000000', 'consum', 0.0214, 'lps'),
	(671587, 133, '2015-02-01 00:09:06.000000', 'consum', 0.0215, 'lps'),
	(671588, 133, '2015-02-01 00:09:07.000000', 'consum', 0.0210, 'lps'),
	(671589, 133, '2015-02-01 00:09:08.000000', 'consum', 0.0219, 'lps'),
	(671590, 133, '2015-02-01 00:09:09.000000', 'consum', 0.0220, 'lps'),
	(671591, 133, '2015-02-01 00:09:10.000000', 'consum', 0.0220, 'lps'),
	(671592, 133, '2015-02-01 00:09:11.000000', 'consum', 0.0210, 'lps'),
	(671593, 133, '2015-02-01 00:09:12.000000', 'consum', 0.0213, 'lps'),
	(671594, 133, '2015-02-01 00:09:13.000000', 'consum', 0.0215, 'lps'),
	(671595, 133, '2015-02-01 00:09:14.000000', 'consum', 0.0214, 'lps'),
	(671596, 133, '2015-02-01 00:09:15.000000', 'consum', 0.0214, 'lps'),
	(671597, 133, '2015-02-01 00:09:16.000000', 'consum', 0.0219, 'lps'),
	(671598, 133, '2015-02-01 00:09:17.000000', 'consum', 0.0219, 'lps'),
	(671599, 133, '2015-02-01 00:09:18.000000', 'consum', 0.0219, 'lps'),
	(671600, 133, '2015-02-01 00:09:19.000000', 'consum', 0.0215, 'lps'),
	(671601, 133, '2015-02-01 00:09:20.000000', 'consum', 0.0219, 'lps'),
	(671602, 133, '2015-02-01 00:09:21.000000', 'consum', 0.0217, 'lps'),
	(671603, 133, '2015-02-01 00:09:22.000000', 'consum', 0.0221, 'lps'),
	(671604, 133, '2015-02-01 00:09:23.000000', 'consum', 0.0218, 'lps'),
	(671605, 133, '2015-02-01 00:09:24.000000', 'consum', 0.0218, 'lps'),
	(671606, 133, '2015-02-01 00:09:25.000000', 'consum', 0.0217, 'lps'),
	(671607, 133, '2015-02-01 00:09:26.000000', 'consum', 0.0219, 'lps'),
	(671608, 133, '2015-02-01 00:09:27.000000', 'consum', 0.0211, 'lps'),
	(671609, 133, '2015-02-01 00:09:28.000000', 'consum', 0.0214, 'lps'),
	(671610, 133, '2015-02-01 00:09:29.000000', 'consum', 0.0215, 'lps'),
	(671611, 133, '2015-02-01 00:09:30.000000', 'consum', 0.0221, 'lps'),
	(671612, 133, '2015-02-01 00:09:31.000000', 'consum', 0.0218, 'lps'),
	(671613, 133, '2015-02-01 00:09:32.000000', 'consum', 0.0214, 'lps'),
	(671614, 133, '2015-02-01 00:09:33.000000', 'consum', 0.0210, 'lps'),
	(671615, 133, '2015-02-01 00:09:34.000000', 'consum', 0.0220, 'lps'),
	(671616, 133, '2015-02-01 00:09:35.000000', 'consum', 0.0212, 'lps'),
	(671617, 133, '2015-02-01 00:09:36.000000', 'consum', 0.0216, 'lps'),
	(671618, 133, '2015-02-01 00:09:37.000000', 'consum', 0.0220, 'lps'),
	(671619, 133, '2015-02-01 00:09:38.000000', 'consum', 0.0220, 'lps'),
	(671620, 133, '2015-02-01 00:09:39.000000', 'consum', 0.0220, 'lps'),
	(671621, 133, '2015-02-01 00:09:40.000000', 'consum', 0.0219, 'lps'),
	(671622, 133, '2015-02-01 00:09:41.000000', 'consum', 0.0213, 'lps'),
	(671623, 133, '2015-02-01 00:09:42.000000', 'consum', 0.0212, 'lps'),
	(671624, 133, '2015-02-01 00:09:43.000000', 'consum', 0.0221, 'lps'),
	(671625, 133, '2015-02-01 00:09:44.000000', 'consum', 0.0212, 'lps'),
	(671626, 133, '2015-02-01 00:09:45.000000', 'consum', 0.0211, 'lps'),
	(671627, 133, '2015-02-01 00:09:46.000000', 'consum', 0.0220, 'lps'),
	(671628, 133, '2015-02-01 00:09:47.000000', 'consum', 0.0211, 'lps'),
	(671629, 133, '2015-02-01 00:09:48.000000', 'consum', 0.0210, 'lps'),
	(671630, 133, '2015-02-01 00:09:49.000000', 'consum', 0.0220, 'lps'),
	(671631, 133, '2015-02-01 00:09:50.000000', 'consum', 0.0214, 'lps'),
	(671632, 133, '2015-02-01 00:09:51.000000', 'consum', 0.0210, 'lps'),
	(671633, 133, '2015-02-01 00:09:52.000000', 'consum', 0.0211, 'lps'),
	(671634, 133, '2015-02-01 00:09:53.000000', 'consum', 0.0217, 'lps'),
	(671635, 133, '2015-02-01 00:09:54.000000', 'consum', 0.0219, 'lps'),
	(671636, 133, '2015-02-01 00:09:55.000000', 'consum', 0.0221, 'lps'),
	(671637, 133, '2015-02-01 00:09:56.000000', 'consum', 0.0216, 'lps'),
	(671638, 133, '2015-02-01 00:09:57.000000', 'consum', 0.0218, 'lps'),
	(671639, 133, '2015-02-01 00:09:58.000000', 'consum', 0.0220, 'lps'),
	(671640, 133, '2015-02-01 00:09:59.000000', 'consum', 0.0215, 'lps'),
	(671641, 133, '2015-02-01 00:10:00.000000', 'consum', 0.0217, 'lps'),
	(671642, 133, '2015-02-01 00:10:01.000000', 'consum', 0.0217, 'lps'),
	(671643, 133, '2015-02-01 00:10:02.000000', 'consum', 0.0214, 'lps'),
	(671644, 133, '2015-02-01 00:10:03.000000', 'consum', 0.0210, 'lps'),
	(671645, 133, '2015-02-01 00:10:04.000000', 'consum', 0.0212, 'lps'),
	(671646, 133, '2015-02-01 00:10:05.000000', 'consum', 0.0217, 'lps'),
	(671647, 133, '2015-02-01 00:10:06.000000', 'consum', 0.0216, 'lps'),
	(671648, 133, '2015-02-01 00:10:07.000000', 'consum', 0.0221, 'lps'),
	(671649, 133, '2015-02-01 00:10:08.000000', 'consum', 0.0210, 'lps'),
	(671650, 133, '2015-02-01 00:10:09.000000', 'consum', 0.0212, 'lps'),
	(671651, 133, '2015-02-01 00:10:10.000000', 'consum', 0.0212, 'lps'),
	(671652, 133, '2015-02-01 00:10:11.000000', 'consum', 0.0213, 'lps'),
	(671653, 133, '2015-02-01 00:10:12.000000', 'consum', 0.0220, 'lps'),
	(671654, 133, '2015-02-01 00:10:13.000000', 'consum', 0.0215, 'lps'),
	(671655, 133, '2015-02-01 00:10:14.000000', 'consum', 0.0218, 'lps'),
	(671656, 133, '2015-02-01 00:10:15.000000', 'consum', 0.0213, 'lps'),
	(671657, 133, '2015-02-01 00:10:16.000000', 'consum', 0.0210, 'lps'),
	(671658, 133, '2015-02-01 00:10:17.000000', 'consum', 0.0216, 'lps'),
	(671659, 133, '2015-02-01 00:10:18.000000', 'consum', 0.0218, 'lps'),
	(671660, 133, '2015-02-01 00:10:19.000000', 'consum', 0.0218, 'lps'),
	(671661, 133, '2015-02-01 00:10:20.000000', 'consum', 0.0213, 'lps'),
	(671662, 133, '2015-02-01 00:10:21.000000', 'consum', 0.0216, 'lps'),
	(671663, 133, '2015-02-01 00:10:22.000000', 'consum', 0.0219, 'lps'),
	(671664, 133, '2015-02-01 00:10:23.000000', 'consum', 0.0215, 'lps'),
	(671665, 133, '2015-02-01 00:10:24.000000', 'consum', 0.0221, 'lps'),
	(671666, 133, '2015-02-01 00:10:25.000000', 'consum', 0.0214, 'lps'),
	(671667, 133, '2015-02-01 00:10:26.000000', 'consum', 0.0211, 'lps'),
	(671668, 133, '2015-02-01 00:10:27.000000', 'consum', 0.0213, 'lps'),
	(671669, 133, '2015-02-01 00:10:28.000000', 'consum', 0.0212, 'lps'),
	(671670, 133, '2015-02-01 00:10:29.000000', 'consum', 0.0213, 'lps'),
	(671671, 133, '2015-02-01 00:10:30.000000', 'consum', 0.0218, 'lps'),
	(671672, 133, '2015-02-01 00:10:31.000000', 'consum', 0.0217, 'lps'),
	(671673, 133, '2015-02-01 00:10:32.000000', 'consum', 0.0210, 'lps'),
	(671674, 133, '2015-02-01 00:10:33.000000', 'consum', 0.0214, 'lps'),
	(671675, 133, '2015-02-01 00:10:34.000000', 'consum', 0.0219, 'lps'),
	(671676, 133, '2015-02-01 00:10:35.000000', 'consum', 0.0218, 'lps'),
	(671677, 133, '2015-02-01 00:10:36.000000', 'consum', 0.0211, 'lps'),
	(671678, 133, '2015-02-01 00:10:37.000000', 'consum', 0.0218, 'lps'),
	(671679, 133, '2015-02-01 00:10:38.000000', 'consum', 0.0212, 'lps'),
	(671680, 133, '2015-02-01 00:10:39.000000', 'consum', 0.0218, 'lps'),
	(671681, 133, '2015-02-01 00:10:40.000000', 'consum', 0.0220, 'lps'),
	(671682, 133, '2015-02-01 00:10:41.000000', 'consum', 0.0212, 'lps'),
	(671683, 133, '2015-02-01 00:10:42.000000', 'consum', 0.0214, 'lps'),
	(671684, 133, '2015-02-01 00:10:43.000000', 'consum', 0.0213, 'lps'),
	(671685, 133, '2015-02-01 00:10:44.000000', 'consum', 0.0213, 'lps'),
	(671686, 133, '2015-02-01 00:10:45.000000', 'consum', 0.0218, 'lps'),
	(671687, 133, '2015-02-01 00:10:46.000000', 'consum', 0.0216, 'lps'),
	(671688, 133, '2015-02-01 00:10:47.000000', 'consum', 0.0216, 'lps'),
	(671689, 133, '2015-02-01 00:10:48.000000', 'consum', 0.0213, 'lps'),
	(671690, 133, '2015-02-01 00:10:49.000000', 'consum', 0.0219, 'lps'),
	(671691, 133, '2015-02-01 00:10:50.000000', 'consum', 0.0221, 'lps'),
	(671692, 133, '2015-02-01 00:10:51.000000', 'consum', 0.0214, 'lps'),
	(671693, 133, '2015-02-01 00:10:52.000000', 'consum', 0.0210, 'lps'),
	(671694, 133, '2015-02-01 00:10:53.000000', 'consum', 0.0213, 'lps'),
	(671695, 133, '2015-02-01 00:10:54.000000', 'consum', 0.0211, 'lps'),
	(671696, 133, '2015-02-01 00:10:55.000000', 'consum', 0.0220, 'lps'),
	(671697, 133, '2015-02-01 00:10:56.000000', 'consum', 0.0220, 'lps'),
	(671698, 133, '2015-02-01 00:10:57.000000', 'consum', 0.0218, 'lps'),
	(671699, 133, '2015-02-01 00:10:58.000000', 'consum', 0.0221, 'lps'),
	(671700, 133, '2015-02-01 00:10:59.000000', 'consum', 0.0216, 'lps'),
	(671701, 133, '2015-02-01 00:11:00.000000', 'consum', 0.0221, 'lps'),
	(671702, 133, '2015-02-01 00:11:01.000000', 'consum', 0.0212, 'lps'),
	(671703, 133, '2015-02-01 00:11:02.000000', 'consum', 0.0211, 'lps'),
	(671704, 133, '2015-02-01 00:11:03.000000', 'consum', 0.0221, 'lps'),
	(671705, 133, '2015-02-01 00:11:04.000000', 'consum', 0.0213, 'lps'),
	(671706, 133, '2015-02-01 00:11:05.000000', 'consum', 0.0218, 'lps'),
	(671707, 133, '2015-02-01 00:11:06.000000', 'consum', 0.0217, 'lps'),
	(671708, 133, '2015-02-01 00:11:07.000000', 'consum', 0.0211, 'lps'),
	(671709, 133, '2015-02-01 00:11:08.000000', 'consum', 0.0217, 'lps'),
	(671710, 133, '2015-02-01 00:11:09.000000', 'consum', 0.0218, 'lps'),
	(671711, 133, '2015-02-01 00:11:10.000000', 'consum', 0.0216, 'lps'),
	(671712, 133, '2015-02-01 00:11:11.000000', 'consum', 0.0220, 'lps'),
	(671713, 133, '2015-02-01 00:11:12.000000', 'consum', 0.0217, 'lps'),
	(671714, 133, '2015-02-01 00:11:13.000000', 'consum', 0.0217, 'lps'),
	(671715, 133, '2015-02-01 00:11:14.000000', 'consum', 0.0212, 'lps'),
	(671716, 133, '2015-02-01 00:11:15.000000', 'consum', 0.0212, 'lps'),
	(671717, 133, '2015-02-01 00:11:16.000000', 'consum', 0.0215, 'lps'),
	(671718, 133, '2015-02-01 00:11:17.000000', 'consum', 0.0218, 'lps'),
	(671719, 133, '2015-02-01 00:11:18.000000', 'consum', 0.0210, 'lps'),
	(671720, 133, '2015-02-01 00:11:19.000000', 'consum', 0.0211, 'lps'),
	(671721, 133, '2015-02-01 00:11:20.000000', 'consum', 0.0215, 'lps'),
	(671722, 133, '2015-02-01 00:11:21.000000', 'consum', 0.0219, 'lps'),
	(671723, 133, '2015-02-01 00:11:22.000000', 'consum', 0.0219, 'lps'),
	(671724, 133, '2015-02-01 00:11:23.000000', 'consum', 0.0213, 'lps'),
	(671725, 133, '2015-02-01 00:11:24.000000', 'consum', 0.0214, 'lps'),
	(671726, 133, '2015-02-01 00:11:25.000000', 'consum', 0.0210, 'lps'),
	(671727, 133, '2015-02-01 00:11:26.000000', 'consum', 0.0211, 'lps'),
	(671728, 133, '2015-02-01 00:11:27.000000', 'consum', 0.0213, 'lps'),
	(671729, 133, '2015-02-01 00:11:28.000000', 'consum', 0.0211, 'lps'),
	(671730, 133, '2015-02-01 00:11:29.000000', 'consum', 0.0218, 'lps'),
	(671731, 133, '2015-02-01 00:11:30.000000', 'consum', 0.0214, 'lps'),
	(671732, 133, '2015-02-01 00:11:31.000000', 'consum', 0.0217, 'lps'),
	(671733, 133, '2015-02-01 00:11:32.000000', 'consum', 0.0210, 'lps'),
	(671734, 133, '2015-02-01 00:11:33.000000', 'consum', 0.0213, 'lps'),
	(671735, 133, '2015-02-01 00:11:34.000000', 'consum', 0.0213, 'lps'),
	(671736, 133, '2015-02-01 00:11:35.000000', 'consum', 0.0217, 'lps'),
	(671737, 133, '2015-02-01 00:11:36.000000', 'consum', 0.0214, 'lps'),
	(671738, 133, '2015-02-01 00:11:37.000000', 'consum', 0.0220, 'lps'),
	(671739, 133, '2015-02-01 00:11:38.000000', 'consum', 0.0212, 'lps'),
	(671740, 133, '2015-02-01 00:11:39.000000', 'consum', 0.0217, 'lps'),
	(671741, 133, '2015-02-01 00:11:40.000000', 'consum', 0.0212, 'lps'),
	(671742, 133, '2015-02-01 00:11:41.000000', 'consum', 0.0215, 'lps'),
	(671743, 133, '2015-02-01 00:11:42.000000', 'consum', 0.0216, 'lps'),
	(671744, 133, '2015-02-01 00:11:43.000000', 'consum', 0.0212, 'lps'),
	(671745, 133, '2015-02-01 00:11:44.000000', 'consum', 0.0214, 'lps'),
	(671746, 133, '2015-02-01 00:11:45.000000', 'consum', 0.0215, 'lps'),
	(671747, 133, '2015-02-01 00:11:46.000000', 'consum', 0.0211, 'lps'),
	(671748, 133, '2015-02-01 00:11:47.000000', 'consum', 0.0213, 'lps'),
	(671749, 133, '2015-02-01 00:11:48.000000', 'consum', 0.0212, 'lps'),
	(671750, 133, '2015-02-01 00:11:49.000000', 'consum', 0.0221, 'lps'),
	(671751, 133, '2015-02-01 00:11:50.000000', 'consum', 0.0211, 'lps'),
	(671752, 133, '2015-02-01 00:11:51.000000', 'consum', 0.0218, 'lps'),
	(671753, 133, '2015-02-01 00:11:52.000000', 'consum', 0.0212, 'lps'),
	(671754, 133, '2015-02-01 00:11:53.000000', 'consum', 0.0221, 'lps'),
	(671755, 133, '2015-02-01 00:11:54.000000', 'consum', 0.0212, 'lps'),
	(671756, 133, '2015-02-01 00:11:55.000000', 'consum', 0.0212, 'lps'),
	(671757, 133, '2015-02-01 00:11:56.000000', 'consum', 0.0212, 'lps'),
	(671758, 133, '2015-02-01 00:11:57.000000', 'consum', 0.0216, 'lps'),
	(671759, 133, '2015-02-01 00:11:58.000000', 'consum', 0.0212, 'lps'),
	(671760, 133, '2015-02-01 00:11:59.000000', 'consum', 0.0213, 'lps'),
	(671761, 133, '2015-02-01 00:12:00.000000', 'consum', 0.0219, 'lps'),
	(671762, 133, '2015-02-01 00:12:01.000000', 'consum', 0.0211, 'lps'),
	(671763, 133, '2015-02-01 00:12:02.000000', 'consum', 0.0210, 'lps'),
	(671764, 133, '2015-02-01 00:12:03.000000', 'consum', 0.0211, 'lps'),
	(671765, 133, '2015-02-01 00:12:04.000000', 'consum', 0.0215, 'lps'),
	(671766, 133, '2015-02-01 00:12:05.000000', 'consum', 0.0218, 'lps'),
	(671767, 133, '2015-02-01 00:12:06.000000', 'consum', 0.0215, 'lps'),
	(671768, 133, '2015-02-01 00:12:07.000000', 'consum', 0.0221, 'lps'),
	(671769, 133, '2015-02-01 00:12:08.000000', 'consum', 0.0216, 'lps'),
	(671770, 133, '2015-02-01 00:12:09.000000', 'consum', 0.0220, 'lps'),
	(671771, 133, '2015-02-01 00:12:10.000000', 'consum', 0.0217, 'lps'),
	(671772, 133, '2015-02-01 00:12:11.000000', 'consum', 0.0217, 'lps'),
	(671773, 133, '2015-02-01 00:12:12.000000', 'consum', 0.0210, 'lps'),
	(671774, 133, '2015-02-01 00:12:13.000000', 'consum', 0.0217, 'lps'),
	(671775, 133, '2015-02-01 00:12:14.000000', 'consum', 0.0219, 'lps'),
	(671776, 133, '2015-02-01 00:12:15.000000', 'consum', 0.0211, 'lps'),
	(671777, 133, '2015-02-01 00:12:16.000000', 'consum', 0.0211, 'lps'),
	(671778, 133, '2015-02-01 00:12:17.000000', 'consum', 0.0214, 'lps'),
	(671779, 133, '2015-02-01 00:12:18.000000', 'consum', 0.0217, 'lps'),
	(671780, 133, '2015-02-01 00:12:19.000000', 'consum', 0.0220, 'lps'),
	(671781, 133, '2015-02-01 00:12:20.000000', 'consum', 0.0214, 'lps'),
	(671782, 133, '2015-02-01 00:12:21.000000', 'consum', 0.0216, 'lps'),
	(671783, 133, '2015-02-01 00:12:22.000000', 'consum', 0.0214, 'lps'),
	(671784, 133, '2015-02-01 00:12:23.000000', 'consum', 0.0211, 'lps'),
	(671785, 133, '2015-02-01 00:12:24.000000', 'consum', 0.0218, 'lps'),
	(671786, 133, '2015-02-01 00:12:25.000000', 'consum', 0.0210, 'lps'),
	(671787, 133, '2015-02-01 00:12:26.000000', 'consum', 0.0212, 'lps'),
	(671788, 133, '2015-02-01 00:12:27.000000', 'consum', 0.0218, 'lps'),
	(671789, 133, '2015-02-01 00:12:28.000000', 'consum', 0.0210, 'lps'),
	(671790, 133, '2015-02-01 00:12:29.000000', 'consum', 0.0210, 'lps'),
	(671791, 133, '2015-02-01 00:12:30.000000', 'consum', 0.0210, 'lps'),
	(671792, 133, '2015-02-01 00:12:31.000000', 'consum', 0.0212, 'lps'),
	(671793, 133, '2015-02-01 00:12:32.000000', 'consum', 0.0220, 'lps'),
	(671794, 133, '2015-02-01 00:12:33.000000', 'consum', 0.0217, 'lps'),
	(671795, 133, '2015-02-01 00:12:34.000000', 'consum', 0.0218, 'lps'),
	(671796, 133, '2015-02-01 00:12:35.000000', 'consum', 0.0217, 'lps'),
	(671797, 133, '2015-02-01 00:12:36.000000', 'consum', 0.0220, 'lps'),
	(671798, 133, '2015-02-01 00:12:37.000000', 'consum', 0.0216, 'lps'),
	(671799, 133, '2015-02-01 00:12:38.000000', 'consum', 0.0212, 'lps'),
	(671800, 133, '2015-02-01 00:12:39.000000', 'consum', 0.0212, 'lps'),
	(671801, 133, '2015-02-01 00:12:40.000000', 'consum', 0.0215, 'lps'),
	(671802, 133, '2015-02-01 00:12:41.000000', 'consum', 0.0217, 'lps'),
	(671803, 133, '2015-02-01 00:12:42.000000', 'consum', 0.0219, 'lps'),
	(671804, 133, '2015-02-01 00:12:43.000000', 'consum', 0.0210, 'lps'),
	(671805, 133, '2015-02-01 00:12:44.000000', 'consum', 0.0219, 'lps'),
	(671806, 133, '2015-02-01 00:12:45.000000', 'consum', 0.0219, 'lps'),
	(671807, 133, '2015-02-01 00:12:46.000000', 'consum', 0.0216, 'lps'),
	(671808, 133, '2015-02-01 00:12:47.000000', 'consum', 0.0214, 'lps'),
	(671809, 133, '2015-02-01 00:12:48.000000', 'consum', 0.0214, 'lps'),
	(671810, 133, '2015-02-01 00:12:49.000000', 'consum', 0.0219, 'lps'),
	(671811, 133, '2015-02-01 00:12:50.000000', 'consum', 0.0219, 'lps'),
	(671812, 133, '2015-02-01 00:12:51.000000', 'consum', 0.0214, 'lps'),
	(671813, 133, '2015-02-01 00:12:52.000000', 'consum', 0.0218, 'lps'),
	(671814, 133, '2015-02-01 00:12:53.000000', 'consum', 0.0215, 'lps'),
	(671815, 133, '2015-02-01 00:12:54.000000', 'consum', 0.0221, 'lps'),
	(671816, 133, '2015-02-01 00:12:55.000000', 'consum', 0.0216, 'lps'),
	(671817, 133, '2015-02-01 00:12:56.000000', 'consum', 0.0221, 'lps'),
	(671818, 133, '2015-02-01 00:12:57.000000', 'consum', 0.0221, 'lps'),
	(671819, 133, '2015-02-01 00:12:58.000000', 'consum', 0.0211, 'lps'),
	(671820, 133, '2015-02-01 00:12:59.000000', 'consum', 0.0217, 'lps'),
	(671821, 133, '2015-02-01 00:13:00.000000', 'consum', 0.0219, 'lps'),
	(671822, 133, '2015-02-01 00:13:01.000000', 'consum', 0.0211, 'lps'),
	(671823, 133, '2015-02-01 00:13:02.000000', 'consum', 0.0211, 'lps'),
	(671824, 133, '2015-02-01 00:13:03.000000', 'consum', 0.0212, 'lps'),
	(671825, 133, '2015-02-01 00:13:04.000000', 'consum', 0.0219, 'lps'),
	(671826, 133, '2015-02-01 00:13:05.000000', 'consum', 0.0215, 'lps'),
	(671827, 133, '2015-02-01 00:13:06.000000', 'consum', 0.0219, 'lps'),
	(671828, 133, '2015-02-01 00:13:07.000000', 'consum', 0.0216, 'lps'),
	(671829, 133, '2015-02-01 00:13:08.000000', 'consum', 0.0215, 'lps'),
	(671830, 133, '2015-02-01 00:13:09.000000', 'consum', 0.0215, 'lps'),
	(671831, 133, '2015-02-01 00:13:10.000000', 'consum', 0.0212, 'lps'),
	(671832, 133, '2015-02-01 00:13:11.000000', 'consum', 0.0215, 'lps'),
	(671833, 133, '2015-02-01 00:13:12.000000', 'consum', 0.0218, 'lps'),
	(671834, 133, '2015-02-01 00:13:13.000000', 'consum', 0.0212, 'lps'),
	(671835, 133, '2015-02-01 00:13:14.000000', 'consum', 0.0220, 'lps'),
	(671836, 133, '2015-02-01 00:13:15.000000', 'consum', 0.0220, 'lps'),
	(671837, 133, '2015-02-01 00:13:16.000000', 'consum', 0.0218, 'lps'),
	(671838, 133, '2015-02-01 00:13:17.000000', 'consum', 0.0221, 'lps'),
	(671839, 133, '2015-02-01 00:13:18.000000', 'consum', 0.0215, 'lps'),
	(671840, 133, '2015-02-01 00:13:19.000000', 'consum', 0.0217, 'lps'),
	(671841, 133, '2015-02-01 00:13:20.000000', 'consum', 0.0220, 'lps'),
	(671842, 133, '2015-02-01 00:13:21.000000', 'consum', 0.0212, 'lps'),
	(671843, 133, '2015-02-01 00:13:22.000000', 'consum', 0.0217, 'lps'),
	(671844, 133, '2015-02-01 00:13:23.000000', 'consum', 0.0214, 'lps'),
	(671845, 133, '2015-02-01 00:13:24.000000', 'consum', 0.0220, 'lps'),
	(671846, 133, '2015-02-01 00:13:25.000000', 'consum', 0.0214, 'lps'),
	(671847, 133, '2015-02-01 00:13:26.000000', 'consum', 0.0212, 'lps'),
	(671848, 133, '2015-02-01 00:13:27.000000', 'consum', 0.0220, 'lps'),
	(671849, 133, '2015-02-01 00:13:28.000000', 'consum', 0.0220, 'lps'),
	(671850, 133, '2015-02-01 00:13:29.000000', 'consum', 0.0220, 'lps'),
	(671851, 133, '2015-02-01 00:13:30.000000', 'consum', 0.0216, 'lps'),
	(671852, 133, '2015-02-01 00:13:31.000000', 'consum', 0.0211, 'lps'),
	(671853, 133, '2015-02-01 00:13:32.000000', 'consum', 0.0220, 'lps'),
	(671854, 133, '2015-02-01 00:13:33.000000', 'consum', 0.0211, 'lps'),
	(671855, 133, '2015-02-01 00:13:34.000000', 'consum', 0.0210, 'lps'),
	(671856, 133, '2015-02-01 00:13:35.000000', 'consum', 0.0217, 'lps'),
	(671857, 133, '2015-02-01 00:13:36.000000', 'consum', 0.0212, 'lps'),
	(671858, 133, '2015-02-01 00:13:37.000000', 'consum', 0.0210, 'lps'),
	(671859, 133, '2015-02-01 00:13:38.000000', 'consum', 0.0218, 'lps'),
	(671860, 133, '2015-02-01 00:13:39.000000', 'consum', 0.0215, 'lps'),
	(671861, 133, '2015-02-01 00:13:40.000000', 'consum', 0.0213, 'lps'),
	(671862, 133, '2015-02-01 00:13:41.000000', 'consum', 0.0219, 'lps'),
	(671863, 133, '2015-02-01 00:13:42.000000', 'consum', 0.0212, 'lps'),
	(671864, 133, '2015-02-01 00:13:43.000000', 'consum', 0.0215, 'lps'),
	(671865, 133, '2015-02-01 00:13:44.000000', 'consum', 0.0220, 'lps'),
	(671866, 133, '2015-02-01 00:13:45.000000', 'consum', 0.0210, 'lps'),
	(671867, 133, '2015-02-01 00:13:46.000000', 'consum', 0.0217, 'lps'),
	(671868, 133, '2015-02-01 00:13:47.000000', 'consum', 0.0210, 'lps'),
	(671869, 133, '2015-02-01 00:13:48.000000', 'consum', 0.0213, 'lps'),
	(671870, 133, '2015-02-01 00:13:49.000000', 'consum', 0.0215, 'lps'),
	(671871, 133, '2015-02-01 00:13:50.000000', 'consum', 0.0214, 'lps'),
	(671872, 133, '2015-02-01 00:13:51.000000', 'consum', 0.0213, 'lps'),
	(671873, 133, '2015-02-01 00:13:52.000000', 'consum', 0.0216, 'lps'),
	(671874, 133, '2015-02-01 00:13:53.000000', 'consum', 0.0217, 'lps'),
	(671875, 133, '2015-02-01 00:13:54.000000', 'consum', 0.0216, 'lps'),
	(671876, 133, '2015-02-01 00:13:55.000000', 'consum', 0.0220, 'lps'),
	(671877, 133, '2015-02-01 00:13:56.000000', 'consum', 0.0217, 'lps'),
	(671878, 133, '2015-02-01 00:13:57.000000', 'consum', 0.0218, 'lps'),
	(671879, 133, '2015-02-01 00:13:58.000000', 'consum', 0.0216, 'lps'),
	(671880, 133, '2015-02-01 00:13:59.000000', 'consum', 0.0215, 'lps'),
	(671881, 133, '2015-02-01 00:14:00.000000', 'consum', 0.0219, 'lps'),
	(671882, 133, '2015-02-01 00:14:01.000000', 'consum', 0.0217, 'lps'),
	(671883, 133, '2015-02-01 00:14:02.000000', 'consum', 0.0218, 'lps'),
	(671884, 133, '2015-02-01 00:14:03.000000', 'consum', 0.0218, 'lps'),
	(671885, 133, '2015-02-01 00:14:04.000000', 'consum', 0.0215, 'lps'),
	(671886, 133, '2015-02-01 00:14:05.000000', 'consum', 0.0212, 'lps'),
	(671887, 133, '2015-02-01 00:14:06.000000', 'consum', 0.0219, 'lps'),
	(671888, 133, '2015-02-01 00:14:07.000000', 'consum', 0.0210, 'lps'),
	(671889, 133, '2015-02-01 00:14:08.000000', 'consum', 0.0210, 'lps'),
	(671890, 133, '2015-02-01 00:14:09.000000', 'consum', 0.0210, 'lps'),
	(671891, 133, '2015-02-01 00:14:10.000000', 'consum', 0.0212, 'lps'),
	(671892, 133, '2015-02-01 00:14:11.000000', 'consum', 0.0219, 'lps'),
	(671893, 133, '2015-02-01 00:14:12.000000', 'consum', 0.0214, 'lps'),
	(671894, 133, '2015-02-01 00:14:13.000000', 'consum', 0.0214, 'lps'),
	(671895, 133, '2015-02-01 00:14:14.000000', 'consum', 0.0221, 'lps'),
	(671896, 133, '2015-02-01 00:14:15.000000', 'consum', 0.0218, 'lps'),
	(671897, 133, '2015-02-01 00:14:16.000000', 'consum', 0.0217, 'lps'),
	(671898, 133, '2015-02-01 00:14:17.000000', 'consum', 0.0220, 'lps'),
	(671899, 133, '2015-02-01 00:14:18.000000', 'consum', 0.0216, 'lps'),
	(671900, 133, '2015-02-01 00:14:19.000000', 'consum', 0.0212, 'lps'),
	(671901, 133, '2015-02-01 00:14:20.000000', 'consum', 0.0212, 'lps'),
	(671902, 133, '2015-02-01 00:14:21.000000', 'consum', 0.0215, 'lps'),
	(671903, 133, '2015-02-01 00:14:22.000000', 'consum', 0.0217, 'lps'),
	(671904, 133, '2015-02-01 00:14:23.000000', 'consum', 0.0219, 'lps'),
	(671905, 133, '2015-02-01 00:14:24.000000', 'consum', 0.0210, 'lps'),
	(671906, 133, '2015-02-01 00:14:25.000000', 'consum', 0.0221, 'lps'),
	(671907, 133, '2015-02-01 00:14:26.000000', 'consum', 0.0216, 'lps'),
	(671908, 133, '2015-02-01 00:14:27.000000', 'consum', 0.0210, 'lps'),
	(671909, 133, '2015-02-01 00:14:28.000000', 'consum', 0.0214, 'lps'),
	(671910, 133, '2015-02-01 00:14:29.000000', 'consum', 0.0220, 'lps'),
	(671911, 133, '2015-02-01 00:14:30.000000', 'consum', 0.0213, 'lps'),
	(671912, 133, '2015-02-01 00:14:31.000000', 'consum', 0.0219, 'lps'),
	(671913, 133, '2015-02-01 00:14:32.000000', 'consum', 0.0221, 'lps'),
	(671914, 133, '2015-02-01 00:14:33.000000', 'consum', 0.0214, 'lps'),
	(671915, 133, '2015-02-01 00:14:34.000000', 'consum', 0.0210, 'lps'),
	(671916, 133, '2015-02-01 00:14:35.000000', 'consum', 0.0211, 'lps'),
	(671917, 133, '2015-02-01 00:14:36.000000', 'consum', 0.0214, 'lps'),
	(671918, 133, '2015-02-01 00:14:37.000000', 'consum', 0.0216, 'lps'),
	(671919, 133, '2015-02-01 00:14:38.000000', 'consum', 0.0218, 'lps'),
	(671920, 133, '2015-02-01 00:14:39.000000', 'consum', 0.0218, 'lps'),
	(671921, 133, '2015-02-01 00:14:40.000000', 'consum', 0.0215, 'lps'),
	(671922, 133, '2015-02-01 00:14:41.000000', 'consum', 0.0213, 'lps'),
	(671923, 133, '2015-02-01 00:14:42.000000', 'consum', 0.0220, 'lps'),
	(671924, 133, '2015-02-01 00:14:43.000000', 'consum', 0.0218, 'lps'),
	(671925, 133, '2015-02-01 00:14:44.000000', 'consum', 0.0220, 'lps'),
	(671926, 133, '2015-02-01 00:14:45.000000', 'consum', 0.0210, 'lps'),
	(671927, 133, '2015-02-01 00:14:46.000000', 'consum', 0.0219, 'lps'),
	(671928, 133, '2015-02-01 00:14:47.000000', 'consum', 0.0221, 'lps'),
	(671929, 133, '2015-02-01 00:14:48.000000', 'consum', 0.0213, 'lps'),
	(671930, 133, '2015-02-01 00:14:49.000000', 'consum', 0.0215, 'lps'),
	(671931, 133, '2015-02-01 00:14:50.000000', 'consum', 0.0214, 'lps'),
	(671932, 133, '2015-02-01 00:14:51.000000', 'consum', 0.0218, 'lps'),
	(671933, 133, '2015-02-01 00:14:52.000000', 'consum', 0.0211, 'lps'),
	(671934, 133, '2015-02-01 00:14:53.000000', 'consum', 0.0219, 'lps'),
	(671935, 133, '2015-02-01 00:14:54.000000', 'consum', 0.0217, 'lps'),
	(671936, 133, '2015-02-01 00:14:55.000000', 'consum', 0.0215, 'lps'),
	(671937, 133, '2015-02-01 00:14:56.000000', 'consum', 0.0217, 'lps'),
	(671938, 133, '2015-02-01 00:14:57.000000', 'consum', 0.0220, 'lps'),
	(671939, 133, '2015-02-01 00:14:58.000000', 'consum', 0.0214, 'lps'),
	(671940, 133, '2015-02-01 00:14:59.000000', 'consum', 0.0210, 'lps'),
	(671941, 133, '2015-02-01 00:15:00.000000', 'consum', 0.0214, 'lps'),
	(671942, 133, '2015-02-01 00:15:01.000000', 'consum', 0.0219, 'lps'),
	(671943, 133, '2015-02-01 00:15:02.000000', 'consum', 0.0217, 'lps'),
	(671944, 133, '2015-02-01 00:15:03.000000', 'consum', 0.0219, 'lps'),
	(671945, 133, '2015-02-01 00:15:04.000000', 'consum', 0.0221, 'lps'),
	(671946, 133, '2015-02-01 00:15:05.000000', 'consum', 0.0217, 'lps'),
	(671947, 133, '2015-02-01 00:15:06.000000', 'consum', 0.0211, 'lps'),
	(671948, 133, '2015-02-01 00:15:07.000000', 'consum', 0.0217, 'lps'),
	(671949, 133, '2015-02-01 00:15:08.000000', 'consum', 0.0221, 'lps'),
	(671950, 133, '2015-02-01 00:15:09.000000', 'consum', 0.0220, 'lps'),
	(671951, 133, '2015-02-01 00:15:10.000000', 'consum', 0.0213, 'lps'),
	(671952, 133, '2015-02-01 00:15:11.000000', 'consum', 0.0210, 'lps'),
	(671953, 133, '2015-02-01 00:15:12.000000', 'consum', 0.0213, 'lps'),
	(671954, 133, '2015-02-01 00:15:13.000000', 'consum', 0.0214, 'lps'),
	(671955, 133, '2015-02-01 00:15:14.000000', 'consum', 0.0220, 'lps'),
	(671956, 133, '2015-02-01 00:15:15.000000', 'consum', 0.0215, 'lps'),
	(671957, 133, '2015-02-01 00:15:16.000000', 'consum', 0.0217, 'lps'),
	(671958, 133, '2015-02-01 00:15:17.000000', 'consum', 0.0220, 'lps'),
	(671959, 133, '2015-02-01 00:15:18.000000', 'consum', 0.0214, 'lps'),
	(671960, 133, '2015-02-01 00:15:19.000000', 'consum', 0.0211, 'lps'),
	(671961, 133, '2015-02-01 00:15:20.000000', 'consum', 0.0218, 'lps'),
	(671962, 133, '2015-02-01 00:15:21.000000', 'consum', 0.0212, 'lps'),
	(671963, 133, '2015-02-01 00:15:22.000000', 'consum', 0.0218, 'lps'),
	(671964, 133, '2015-02-01 00:15:23.000000', 'consum', 0.0221, 'lps'),
	(671965, 133, '2015-02-01 00:15:24.000000', 'consum', 0.0216, 'lps'),
	(671966, 133, '2015-02-01 00:15:25.000000', 'consum', 0.0220, 'lps'),
	(671967, 133, '2015-02-01 00:15:26.000000', 'consum', 0.0220, 'lps'),
	(671968, 133, '2015-02-01 00:15:27.000000', 'consum', 0.0218, 'lps'),
	(671969, 133, '2015-02-01 00:15:28.000000', 'consum', 0.0219, 'lps'),
	(671970, 133, '2015-02-01 00:15:29.000000', 'consum', 0.0211, 'lps'),
	(671971, 133, '2015-02-01 00:15:30.000000', 'consum', 0.0221, 'lps'),
	(671972, 133, '2015-02-01 00:15:31.000000', 'consum', 0.0216, 'lps'),
	(671973, 133, '2015-02-01 00:15:32.000000', 'consum', 0.0220, 'lps'),
	(671974, 133, '2015-02-01 00:15:33.000000', 'consum', 0.0216, 'lps'),
	(671975, 133, '2015-02-01 00:15:34.000000', 'consum', 0.0214, 'lps'),
	(671976, 133, '2015-02-01 00:15:35.000000', 'consum', 0.0211, 'lps'),
	(671977, 133, '2015-02-01 00:15:36.000000', 'consum', 0.0215, 'lps'),
	(671978, 133, '2015-02-01 00:15:37.000000', 'consum', 0.0221, 'lps'),
	(671979, 133, '2015-02-01 00:15:38.000000', 'consum', 0.0214, 'lps'),
	(671980, 133, '2015-02-01 00:15:39.000000', 'consum', 0.0210, 'lps'),
	(671981, 133, '2015-02-01 00:15:40.000000', 'consum', 0.0221, 'lps'),
	(671982, 133, '2015-02-01 00:15:41.000000', 'consum', 0.0217, 'lps'),
	(671983, 133, '2015-02-01 00:15:42.000000', 'consum', 0.0214, 'lps'),
	(671984, 133, '2015-02-01 00:15:43.000000', 'consum', 0.0219, 'lps'),
	(671985, 133, '2015-02-01 00:15:44.000000', 'consum', 0.0211, 'lps'),
	(671986, 133, '2015-02-01 00:15:45.000000', 'consum', 0.0211, 'lps'),
	(671987, 133, '2015-02-01 00:15:46.000000', 'consum', 0.0211, 'lps'),
	(671988, 133, '2015-02-01 00:15:47.000000', 'consum', 0.0213, 'lps'),
	(671989, 133, '2015-02-01 00:15:48.000000', 'consum', 0.0212, 'lps'),
	(671990, 133, '2015-02-01 00:15:49.000000', 'consum', 0.0221, 'lps'),
	(671991, 133, '2015-02-01 00:15:50.000000', 'consum', 0.0213, 'lps'),
	(671992, 133, '2015-02-01 00:15:51.000000', 'consum', 0.0215, 'lps'),
	(671993, 133, '2015-02-01 00:15:52.000000', 'consum', 0.0215, 'lps'),
	(671994, 133, '2015-02-01 00:15:53.000000', 'consum', 0.0220, 'lps'),
	(671995, 133, '2015-02-01 00:15:54.000000', 'consum', 0.0212, 'lps'),
	(671996, 133, '2015-02-01 00:15:55.000000', 'consum', 0.0211, 'lps'),
	(671997, 133, '2015-02-01 00:15:56.000000', 'consum', 0.0211, 'lps'),
	(671998, 133, '2015-02-01 00:15:57.000000', 'consum', 0.0214, 'lps'),
	(671999, 133, '2015-02-01 00:15:58.000000', 'consum', 0.0215, 'lps'),
	(672000, 133, '2015-02-01 00:15:59.000000', 'consum', 0.0211, 'lps'),
	(672001, 133, '2015-02-01 00:16:00.000000', 'consum', 0.0213, 'lps'),
	(672002, 133, '2015-02-01 00:16:01.000000', 'consum', 0.0210, 'lps'),
	(672003, 133, '2015-02-01 00:16:02.000000', 'consum', 0.0215, 'lps'),
	(672004, 133, '2015-02-01 00:16:03.000000', 'consum', 0.0212, 'lps'),
	(672005, 133, '2015-02-01 00:16:04.000000', 'consum', 0.0215, 'lps'),
	(672006, 133, '2015-02-01 00:16:05.000000', 'consum', 0.0219, 'lps'),
	(672007, 133, '2015-02-01 00:16:06.000000', 'consum', 0.0215, 'lps'),
	(672008, 133, '2015-02-01 00:16:07.000000', 'consum', 0.0220, 'lps'),
	(672009, 133, '2015-02-01 00:16:08.000000', 'consum', 0.0220, 'lps'),
	(672010, 133, '2015-02-01 00:16:09.000000', 'consum', 0.0210, 'lps'),
	(672011, 133, '2015-02-01 00:16:10.000000', 'consum', 0.0216, 'lps'),
	(672012, 133, '2015-02-01 00:16:11.000000', 'consum', 0.0217, 'lps'),
	(672013, 133, '2015-02-01 00:16:12.000000', 'consum', 0.0214, 'lps'),
	(672014, 133, '2015-02-01 00:16:13.000000', 'consum', 0.0210, 'lps'),
	(672015, 133, '2015-02-01 00:16:14.000000', 'consum', 0.0212, 'lps'),
	(672016, 133, '2015-02-01 00:16:15.000000', 'consum', 0.0219, 'lps'),
	(672017, 133, '2015-02-01 00:16:16.000000', 'consum', 0.0216, 'lps'),
	(672018, 133, '2015-02-01 00:16:17.000000', 'consum', 0.0212, 'lps'),
	(672019, 133, '2015-02-01 00:16:18.000000', 'consum', 0.0213, 'lps'),
	(672020, 133, '2015-02-01 00:16:19.000000', 'consum', 0.0221, 'lps'),
	(672021, 133, '2015-02-01 00:16:20.000000', 'consum', 0.0219, 'lps'),
	(672022, 133, '2015-02-01 00:16:21.000000', 'consum', 0.0211, 'lps'),
	(672023, 133, '2015-02-01 00:16:22.000000', 'consum', 0.0213, 'lps'),
	(672024, 133, '2015-02-01 00:16:23.000000', 'consum', 0.0211, 'lps'),
	(672025, 133, '2015-02-01 00:16:24.000000', 'consum', 0.0220, 'lps'),
	(672026, 133, '2015-02-01 00:16:25.000000', 'consum', 0.0220, 'lps'),
	(672027, 133, '2015-02-01 00:16:26.000000', 'consum', 0.0218, 'lps'),
	(672028, 133, '2015-02-01 00:16:27.000000', 'consum', 0.0221, 'lps'),
	(672029, 133, '2015-02-01 00:16:28.000000', 'consum', 0.0216, 'lps'),
	(672030, 133, '2015-02-01 00:16:29.000000', 'consum', 0.0221, 'lps'),
	(672031, 133, '2015-02-01 00:16:30.000000', 'consum', 0.0210, 'lps'),
	(672032, 133, '2015-02-01 00:16:31.000000', 'consum', 0.0213, 'lps'),
	(672033, 133, '2015-02-01 00:16:32.000000', 'consum', 0.0216, 'lps'),
	(672034, 133, '2015-02-01 00:16:33.000000', 'consum', 0.0218, 'lps'),
	(672035, 133, '2015-02-01 00:16:34.000000', 'consum', 0.0210, 'lps'),
	(672036, 133, '2015-02-01 00:16:35.000000', 'consum', 0.0210, 'lps'),
	(672037, 133, '2015-02-01 00:16:36.000000', 'consum', 0.0210, 'lps'),
	(672038, 133, '2015-02-01 00:16:37.000000', 'consum', 0.0212, 'lps'),
	(672039, 133, '2015-02-01 00:16:38.000000', 'consum', 0.0218, 'lps'),
	(672040, 133, '2015-02-01 00:16:39.000000', 'consum', 0.0220, 'lps'),
	(672041, 133, '2015-02-01 00:16:40.000000', 'consum', 0.0212, 'lps'),
	(672042, 133, '2015-02-01 00:16:41.000000', 'consum', 0.0214, 'lps'),
	(672043, 133, '2015-02-01 00:16:42.000000', 'consum', 0.0216, 'lps'),
	(672044, 133, '2015-02-01 00:16:43.000000', 'consum', 0.0213, 'lps'),
	(672045, 133, '2015-02-01 00:16:44.000000', 'consum', 0.0220, 'lps'),
	(672046, 133, '2015-02-01 00:16:45.000000', 'consum', 0.0216, 'lps'),
	(672047, 133, '2015-02-01 00:16:46.000000', 'consum', 0.0212, 'lps'),
	(672048, 133, '2015-02-01 00:16:47.000000', 'consum', 0.0213, 'lps'),
	(672049, 133, '2015-02-01 00:16:48.000000', 'consum', 0.0218, 'lps'),
	(672050, 133, '2015-02-01 00:16:49.000000', 'consum', 0.0218, 'lps'),
	(672051, 133, '2015-02-01 00:16:50.000000', 'consum', 0.0215, 'lps'),
	(672052, 133, '2015-02-01 00:16:51.000000', 'consum', 0.0212, 'lps'),
	(672053, 133, '2015-02-01 00:16:52.000000', 'consum', 0.0217, 'lps'),
	(672054, 133, '2015-02-01 00:16:53.000000', 'consum', 0.0217, 'lps'),
	(672055, 133, '2015-02-01 00:16:54.000000', 'consum', 0.0213, 'lps'),
	(672056, 133, '2015-02-01 00:16:55.000000', 'consum', 0.0215, 'lps'),
	(672057, 133, '2015-02-01 00:16:56.000000', 'consum', 0.0216, 'lps'),
	(672058, 133, '2015-02-01 00:16:57.000000', 'consum', 0.0212, 'lps'),
	(672059, 133, '2015-02-01 00:16:58.000000', 'consum', 0.0214, 'lps'),
	(672060, 133, '2015-02-01 00:16:59.000000', 'consum', 0.0214, 'lps'),
	(672061, 133, '2015-02-01 00:17:00.000000', 'consum', 0.0217, 'lps'),
	(672062, 133, '2015-02-01 00:17:01.000000', 'consum', 0.0211, 'lps'),
	(672063, 133, '2015-02-01 00:17:02.000000', 'consum', 0.0218, 'lps'),
	(672064, 133, '2015-02-01 00:17:03.000000', 'consum', 0.0213, 'lps'),
	(672065, 133, '2015-02-01 00:17:04.000000', 'consum', 0.0211, 'lps'),
	(672066, 133, '2015-02-01 00:17:05.000000', 'consum', 0.0219, 'lps'),
	(672067, 133, '2015-02-01 00:17:06.000000', 'consum', 0.0217, 'lps'),
	(672068, 133, '2015-02-01 00:17:07.000000', 'consum', 0.0219, 'lps'),
	(672069, 133, '2015-02-01 00:17:08.000000', 'consum', 0.0221, 'lps'),
	(672070, 133, '2015-02-01 00:17:09.000000', 'consum', 0.0217, 'lps'),
	(672071, 133, '2015-02-01 00:17:10.000000', 'consum', 0.0212, 'lps'),
	(672072, 133, '2015-02-01 00:17:11.000000', 'consum', 0.0210, 'lps'),
	(672073, 133, '2015-02-01 00:17:12.000000', 'consum', 0.0217, 'lps'),
	(672074, 133, '2015-02-01 00:17:13.000000', 'consum', 0.0220, 'lps'),
	(672075, 133, '2015-02-01 00:17:14.000000', 'consum', 0.0217, 'lps'),
	(672076, 133, '2015-02-01 00:17:15.000000', 'consum', 0.0214, 'lps'),
	(672077, 133, '2015-02-01 00:17:16.000000', 'consum', 0.0221, 'lps'),
	(672078, 133, '2015-02-01 00:17:17.000000', 'consum', 0.0220, 'lps'),
	(672079, 133, '2015-02-01 00:17:18.000000', 'consum', 0.0214, 'lps'),
	(672080, 133, '2015-02-01 00:17:19.000000', 'consum', 0.0213, 'lps'),
	(672081, 133, '2015-02-01 00:17:20.000000', 'consum', 0.0214, 'lps'),
	(672082, 133, '2015-02-01 00:17:21.000000', 'consum', 0.0211, 'lps'),
	(672083, 133, '2015-02-01 00:17:22.000000', 'consum', 0.0215, 'lps'),
	(672084, 133, '2015-02-01 00:17:23.000000', 'consum', 0.0220, 'lps'),
	(672085, 133, '2015-02-01 00:17:24.000000', 'consum', 0.0219, 'lps'),
	(672086, 133, '2015-02-01 00:17:25.000000', 'consum', 0.0217, 'lps'),
	(672087, 133, '2015-02-01 00:17:26.000000', 'consum', 0.0215, 'lps'),
	(672088, 133, '2015-02-01 00:17:27.000000', 'consum', 0.0218, 'lps'),
	(672089, 133, '2015-02-01 00:17:28.000000', 'consum', 0.0221, 'lps'),
	(672090, 133, '2015-02-01 00:17:29.000000', 'consum', 0.0217, 'lps'),
	(672091, 133, '2015-02-01 00:17:30.000000', 'consum', 0.0215, 'lps'),
	(672092, 133, '2015-02-01 00:17:31.000000', 'consum', 0.0213, 'lps'),
	(672093, 133, '2015-02-01 00:17:32.000000', 'consum', 0.0221, 'lps'),
	(672094, 133, '2015-02-01 00:17:33.000000', 'consum', 0.0210, 'lps'),
	(672095, 133, '2015-02-01 00:17:34.000000', 'consum', 0.0214, 'lps'),
	(672096, 133, '2015-02-01 00:17:35.000000', 'consum', 0.0218, 'lps'),
	(672097, 133, '2015-02-01 00:17:36.000000', 'consum', 0.0216, 'lps'),
	(672098, 133, '2015-02-01 00:17:37.000000', 'consum', 0.0216, 'lps'),
	(672099, 133, '2015-02-01 00:17:38.000000', 'consum', 0.0212, 'lps'),
	(672100, 133, '2015-02-01 00:17:39.000000', 'consum', 0.0211, 'lps'),
	(672101, 133, '2015-02-01 00:17:40.000000', 'consum', 0.0212, 'lps'),
	(672102, 133, '2015-02-01 00:17:41.000000', 'consum', 0.0216, 'lps'),
	(672103, 133, '2015-02-01 00:17:42.000000', 'consum', 0.0213, 'lps'),
	(672104, 133, '2015-02-01 00:17:43.000000', 'consum', 0.0218, 'lps'),
	(672105, 133, '2015-02-01 00:17:44.000000', 'consum', 0.0216, 'lps'),
	(672106, 133, '2015-02-01 00:17:45.000000', 'consum', 0.0217, 'lps'),
	(672107, 133, '2015-02-01 00:17:46.000000', 'consum', 0.0218, 'lps'),
	(672108, 133, '2015-02-01 00:17:47.000000', 'consum', 0.0216, 'lps'),
	(672109, 133, '2015-02-01 00:17:48.000000', 'consum', 0.0218, 'lps'),
	(672110, 133, '2015-02-01 00:17:49.000000', 'consum', 0.0219, 'lps'),
	(672111, 133, '2015-02-01 00:17:50.000000', 'consum', 0.0219, 'lps'),
	(672112, 133, '2015-02-01 00:17:51.000000', 'consum', 0.0218, 'lps'),
	(672113, 133, '2015-02-01 00:17:52.000000', 'consum', 0.0221, 'lps'),
	(672114, 133, '2015-02-01 00:17:53.000000', 'consum', 0.0218, 'lps'),
	(672115, 133, '2015-02-01 00:17:54.000000', 'consum', 0.0218, 'lps'),
	(672116, 133, '2015-02-01 00:17:55.000000', 'consum', 0.0214, 'lps'),
	(672117, 133, '2015-02-01 00:17:56.000000', 'consum', 0.0220, 'lps'),
	(672118, 133, '2015-02-01 00:17:57.000000', 'consum', 0.0210, 'lps'),
	(672119, 133, '2015-02-01 00:17:58.000000', 'consum', 0.0218, 'lps'),
	(672120, 133, '2015-02-01 00:17:59.000000', 'consum', 0.0216, 'lps'),
	(672121, 133, '2015-02-01 00:18:00.000000', 'consum', 0.0216, 'lps'),
	(672122, 133, '2015-02-01 00:18:01.000000', 'consum', 0.0210, 'lps'),
	(672123, 133, '2015-02-01 00:18:02.000000', 'consum', 0.0218, 'lps'),
	(672124, 133, '2015-02-01 00:18:03.000000', 'consum', 0.0215, 'lps'),
	(672125, 133, '2015-02-01 00:18:04.000000', 'consum', 0.0221, 'lps'),
	(672126, 133, '2015-02-01 00:18:05.000000', 'consum', 0.0215, 'lps'),
	(672127, 133, '2015-02-01 00:18:06.000000', 'consum', 0.0216, 'lps'),
	(672128, 133, '2015-02-01 00:18:07.000000', 'consum', 0.0211, 'lps'),
	(672129, 133, '2015-02-01 00:18:08.000000', 'consum', 0.0211, 'lps'),
	(672130, 133, '2015-02-01 00:18:09.000000', 'consum', 0.0211, 'lps'),
	(672131, 133, '2015-02-01 00:18:10.000000', 'consum', 0.0214, 'lps'),
	(672132, 133, '2015-02-01 00:18:11.000000', 'consum', 0.0215, 'lps'),
	(672133, 133, '2015-02-01 00:18:12.000000', 'consum', 0.0221, 'lps'),
	(672134, 133, '2015-02-01 00:18:13.000000', 'consum', 0.0218, 'lps'),
	(672135, 133, '2015-02-01 00:18:14.000000', 'consum', 0.0217, 'lps'),
	(672136, 133, '2015-02-01 00:18:15.000000', 'consum', 0.0210, 'lps'),
	(672137, 133, '2015-02-01 00:18:16.000000', 'consum', 0.0213, 'lps'),
	(672138, 133, '2015-02-01 00:18:17.000000', 'consum', 0.0215, 'lps'),
	(672139, 133, '2015-02-01 00:18:18.000000', 'consum', 0.0215, 'lps'),
	(672140, 133, '2015-02-01 00:18:19.000000', 'consum', 0.0221, 'lps'),
	(672141, 133, '2015-02-01 00:18:20.000000', 'consum', 0.0214, 'lps'),
	(672142, 133, '2015-02-01 00:18:21.000000', 'consum', 0.0210, 'lps'),
	(672143, 133, '2015-02-01 00:18:22.000000', 'consum', 0.0212, 'lps'),
	(672144, 133, '2015-02-01 00:18:23.000000', 'consum', 0.0218, 'lps'),
	(672145, 133, '2015-02-01 00:18:24.000000', 'consum', 0.0220, 'lps'),
	(672146, 133, '2015-02-01 00:18:25.000000', 'consum', 0.0215, 'lps'),
	(672147, 133, '2015-02-01 00:18:26.000000', 'consum', 0.0218, 'lps'),
	(672148, 133, '2015-02-01 00:18:27.000000', 'consum', 0.0211, 'lps'),
	(672149, 133, '2015-02-01 00:18:28.000000', 'consum', 0.0214, 'lps'),
	(672150, 133, '2015-02-01 00:18:29.000000', 'consum', 0.0215, 'lps'),
	(672151, 133, '2015-02-01 00:18:30.000000', 'consum', 0.0214, 'lps'),
	(672152, 133, '2015-02-01 00:18:31.000000', 'consum', 0.0215, 'lps'),
	(672153, 133, '2015-02-01 00:18:32.000000', 'consum', 0.0221, 'lps'),
	(672154, 133, '2015-02-01 00:18:33.000000', 'consum', 0.0217, 'lps'),
	(672155, 133, '2015-02-01 00:18:34.000000', 'consum', 0.0210, 'lps'),
	(672156, 133, '2015-02-01 00:18:35.000000', 'consum', 0.0214, 'lps'),
	(672157, 133, '2015-02-01 00:18:36.000000', 'consum', 0.0217, 'lps'),
	(672158, 133, '2015-02-01 00:18:37.000000', 'consum', 0.0211, 'lps'),
	(672159, 133, '2015-02-01 00:18:38.000000', 'consum', 0.0220, 'lps'),
	(672160, 133, '2015-02-01 00:18:39.000000', 'consum', 0.0210, 'lps'),
	(672161, 133, '2015-02-01 00:18:40.000000', 'consum', 0.0215, 'lps'),
	(672162, 133, '2015-02-01 00:18:41.000000', 'consum', 0.0211, 'lps'),
	(672163, 133, '2015-02-01 00:18:42.000000', 'consum', 0.0212, 'lps'),
	(672164, 133, '2015-02-01 00:18:43.000000', 'consum', 0.0218, 'lps'),
	(672165, 133, '2015-02-01 00:18:44.000000', 'consum', 0.0220, 'lps'),
	(672166, 133, '2015-02-01 00:18:45.000000', 'consum', 0.0214, 'lps'),
	(672167, 133, '2015-02-01 00:18:46.000000', 'consum', 0.0211, 'lps'),
	(672168, 133, '2015-02-01 00:18:47.000000', 'consum', 0.0215, 'lps'),
	(672169, 133, '2015-02-01 00:18:48.000000', 'consum', 0.0210, 'lps'),
	(672170, 133, '2015-02-01 00:18:49.000000', 'consum', 0.0218, 'lps'),
	(672171, 133, '2015-02-01 00:18:50.000000', 'consum', 0.0214, 'lps'),
	(672172, 133, '2015-02-01 00:18:51.000000', 'consum', 0.0219, 'lps'),
	(672173, 133, '2015-02-01 00:18:52.000000', 'consum', 0.0219, 'lps'),
	(672174, 133, '2015-02-01 00:18:53.000000', 'consum', 0.0217, 'lps'),
	(672175, 133, '2015-02-01 00:18:54.000000', 'consum', 0.0221, 'lps'),
	(672176, 133, '2015-02-01 00:18:55.000000', 'consum', 0.0217, 'lps'),
	(672177, 133, '2015-02-01 00:18:56.000000', 'consum', 0.0215, 'lps'),
	(672178, 133, '2015-02-01 00:18:57.000000', 'consum', 0.0212, 'lps'),
	(672179, 133, '2015-02-01 00:18:58.000000', 'consum', 0.0221, 'lps'),
	(672180, 133, '2015-02-01 00:18:59.000000', 'consum', 0.0221, 'lps'),
	(672181, 133, '2015-02-01 00:19:00.000000', 'consum', 0.0221, 'lps'),
	(672182, 133, '2015-02-01 00:19:01.000000', 'consum', 0.0219, 'lps'),
	(672183, 133, '2015-02-01 00:19:02.000000', 'consum', 0.0210, 'lps'),
	(672184, 133, '2015-02-01 00:19:03.000000', 'consum', 0.0220, 'lps'),
	(672185, 133, '2015-02-01 00:19:04.000000', 'consum', 0.0212, 'lps'),
	(672186, 133, '2015-02-01 00:19:05.000000', 'consum', 0.0213, 'lps'),
	(672187, 133, '2015-02-01 00:19:06.000000', 'consum', 0.0210, 'lps'),
	(672188, 133, '2015-02-01 00:19:07.000000', 'consum', 0.0214, 'lps'),
	(672189, 133, '2015-02-01 00:19:08.000000', 'consum', 0.0216, 'lps'),
	(672190, 133, '2015-02-01 00:19:09.000000', 'consum', 0.0216, 'lps'),
	(672191, 133, '2015-02-01 00:19:10.000000', 'consum', 0.0211, 'lps'),
	(672192, 133, '2015-02-01 00:19:11.000000', 'consum', 0.0210, 'lps'),
	(672193, 133, '2015-02-01 00:19:12.000000', 'consum', 0.0221, 'lps'),
	(672194, 133, '2015-02-01 00:19:13.000000', 'consum', 0.0215, 'lps'),
	(672195, 133, '2015-02-01 00:19:14.000000', 'consum', 0.0216, 'lps'),
	(672196, 133, '2015-02-01 00:19:15.000000', 'consum', 0.0214, 'lps'),
	(672197, 133, '2015-02-01 00:19:16.000000', 'consum', 0.0214, 'lps'),
	(672198, 133, '2015-02-01 00:19:17.000000', 'consum', 0.0216, 'lps'),
	(672199, 133, '2015-02-01 00:19:18.000000', 'consum', 0.0219, 'lps'),
	(672200, 133, '2015-02-01 00:19:19.000000', 'consum', 0.0213, 'lps'),
	(672201, 133, '2015-02-01 00:19:20.000000', 'consum', 0.0211, 'lps'),
	(672202, 133, '2015-02-01 00:19:21.000000', 'consum', 0.0218, 'lps'),
	(672203, 133, '2015-02-01 00:19:22.000000', 'consum', 0.0211, 'lps'),
	(672204, 133, '2015-02-01 00:19:23.000000', 'consum', 0.0216, 'lps'),
	(672205, 133, '2015-02-01 00:19:24.000000', 'consum', 0.0213, 'lps'),
	(672206, 133, '2015-02-01 00:19:25.000000', 'consum', 0.0221, 'lps'),
	(672207, 133, '2015-02-01 00:19:26.000000', 'consum', 0.0219, 'lps'),
	(672208, 133, '2015-02-01 00:19:27.000000', 'consum', 0.0212, 'lps'),
	(672209, 133, '2015-02-01 00:19:28.000000', 'consum', 0.0218, 'lps'),
	(672210, 133, '2015-02-01 00:19:29.000000', 'consum', 0.0221, 'lps'),
	(672211, 133, '2015-02-01 00:19:30.000000', 'consum', 0.0219, 'lps'),
	(672212, 133, '2015-02-01 00:19:31.000000', 'consum', 0.0219, 'lps'),
	(672213, 133, '2015-02-01 00:19:32.000000', 'consum', 0.0218, 'lps'),
	(672214, 133, '2015-02-01 00:19:33.000000', 'consum', 0.0213, 'lps'),
	(672215, 133, '2015-02-01 00:19:34.000000', 'consum', 0.0210, 'lps'),
	(672216, 133, '2015-02-01 00:19:35.000000', 'consum', 0.0216, 'lps'),
	(672217, 133, '2015-02-01 00:19:36.000000', 'consum', 0.0217, 'lps'),
	(672218, 133, '2015-02-01 00:19:37.000000', 'consum', 0.0216, 'lps'),
	(672219, 133, '2015-02-01 00:19:38.000000', 'consum', 0.0217, 'lps'),
	(672220, 133, '2015-02-01 00:19:39.000000', 'consum', 0.0217, 'lps'),
	(672221, 133, '2015-02-01 00:19:40.000000', 'consum', 0.0210, 'lps'),
	(672222, 133, '2015-02-01 00:19:41.000000', 'consum', 0.0216, 'lps'),
	(672223, 133, '2015-02-01 00:19:42.000000', 'consum', 0.0216, 'lps'),
	(672224, 133, '2015-02-01 00:19:43.000000', 'consum', 0.0211, 'lps'),
	(672225, 133, '2015-02-01 00:19:44.000000', 'consum', 0.0220, 'lps'),
	(672226, 133, '2015-02-01 00:19:45.000000', 'consum', 0.0211, 'lps'),
	(672227, 133, '2015-02-01 00:19:46.000000', 'consum', 0.0210, 'lps'),
	(672228, 133, '2015-02-01 00:19:47.000000', 'consum', 0.0220, 'lps'),
	(672229, 133, '2015-02-01 00:19:48.000000', 'consum', 0.0212, 'lps'),
	(672230, 133, '2015-02-01 00:19:49.000000', 'consum', 0.0213, 'lps'),
	(672231, 133, '2015-02-01 00:19:50.000000', 'consum', 0.0221, 'lps'),
	(672232, 133, '2015-02-01 00:19:51.000000', 'consum', 0.0219, 'lps'),
	(672233, 133, '2015-02-01 00:19:52.000000', 'consum', 0.0211, 'lps'),
	(672234, 133, '2015-02-01 00:19:53.000000', 'consum', 0.0211, 'lps'),
	(672235, 133, '2015-02-01 00:19:54.000000', 'consum', 0.0214, 'lps'),
	(672236, 133, '2015-02-01 00:19:55.000000', 'consum', 0.0214, 'lps'),
	(672237, 133, '2015-02-01 00:19:56.000000', 'consum', 0.0221, 'lps'),
	(672238, 133, '2015-02-01 00:19:57.000000', 'consum', 0.0218, 'lps'),
	(672239, 133, '2015-02-01 00:19:58.000000', 'consum', 0.0217, 'lps'),
	(672240, 133, '2015-02-01 00:19:59.000000', 'consum', 0.0210, 'lps'),
	(672241, 133, '2015-02-01 00:20:00.000000', 'consum', 0.0215, 'lps'),
	(672242, 133, '2015-02-01 00:20:01.000000', 'consum', 0.0220, 'lps'),
	(672243, 133, '2015-02-01 00:20:02.000000', 'consum', 0.0211, 'lps'),
	(672244, 133, '2015-02-01 00:20:03.000000', 'consum', 0.0220, 'lps'),
	(672245, 133, '2015-02-01 00:20:04.000000', 'consum', 0.0221, 'lps'),
	(672246, 133, '2015-02-01 00:20:05.000000', 'consum', 0.0211, 'lps'),
	(672247, 133, '2015-02-01 00:20:06.000000', 'consum', 0.0221, 'lps'),
	(672248, 133, '2015-02-01 00:20:07.000000', 'consum', 0.0214, 'lps'),
	(672249, 133, '2015-02-01 00:20:08.000000', 'consum', 0.0221, 'lps'),
	(672250, 133, '2015-02-01 00:20:09.000000', 'consum', 0.0216, 'lps'),
	(672251, 133, '2015-02-01 00:20:10.000000', 'consum', 0.0221, 'lps'),
	(672252, 133, '2015-02-01 00:20:11.000000', 'consum', 0.0212, 'lps'),
	(672253, 133, '2015-02-01 00:20:12.000000', 'consum', 0.0221, 'lps'),
	(672254, 133, '2015-02-01 00:20:13.000000', 'consum', 0.0213, 'lps'),
	(672255, 133, '2015-02-01 00:20:14.000000', 'consum', 0.0217, 'lps'),
	(672256, 133, '2015-02-01 00:20:15.000000', 'consum', 0.0210, 'lps'),
	(672257, 133, '2015-02-01 00:20:16.000000', 'consum', 0.0217, 'lps'),
	(672258, 133, '2015-02-01 00:20:17.000000', 'consum', 0.0220, 'lps'),
	(672259, 133, '2015-02-01 00:20:18.000000', 'consum', 0.0215, 'lps'),
	(672260, 133, '2015-02-01 00:20:19.000000', 'consum', 0.0218, 'lps'),
	(672261, 133, '2015-02-01 00:20:20.000000', 'consum', 0.0212, 'lps'),
	(672262, 133, '2015-02-01 00:20:21.000000', 'consum', 0.0218, 'lps'),
	(672263, 133, '2015-02-01 00:20:22.000000', 'consum', 0.0211, 'lps'),
	(672264, 133, '2015-02-01 00:20:23.000000', 'consum', 0.0216, 'lps'),
	(672265, 133, '2015-02-01 00:20:24.000000', 'consum', 0.0211, 'lps'),
	(672266, 133, '2015-02-01 00:20:25.000000', 'consum', 0.0211, 'lps'),
	(672267, 133, '2015-02-01 00:20:26.000000', 'consum', 0.0212, 'lps'),
	(672268, 133, '2015-02-01 00:20:27.000000', 'consum', 0.0216, 'lps'),
	(672269, 133, '2015-02-01 00:20:28.000000', 'consum', 0.0213, 'lps'),
	(672270, 133, '2015-02-01 00:20:29.000000', 'consum', 0.0218, 'lps'),
	(672271, 133, '2015-02-01 00:20:30.000000', 'consum', 0.0216, 'lps'),
	(672272, 133, '2015-02-01 00:20:31.000000', 'consum', 0.0217, 'lps'),
	(672273, 133, '2015-02-01 00:20:32.000000', 'consum', 0.0217, 'lps'),
	(672274, 133, '2015-02-01 00:20:33.000000', 'consum', 0.0210, 'lps'),
	(672275, 133, '2015-02-01 00:20:34.000000', 'consum', 0.0215, 'lps'),
	(672276, 133, '2015-02-01 00:20:35.000000', 'consum', 0.0211, 'lps'),
	(672277, 133, '2015-02-01 00:20:36.000000', 'consum', 0.0211, 'lps'),
	(672278, 133, '2015-02-01 00:20:37.000000', 'consum', 0.0216, 'lps'),
	(672279, 133, '2015-02-01 00:20:38.000000', 'consum', 0.0211, 'lps'),
	(672280, 133, '2015-02-01 00:20:39.000000', 'consum', 0.0211, 'lps'),
	(672281, 133, '2015-02-01 00:20:40.000000', 'consum', 0.0214, 'lps'),
	(672282, 133, '2015-02-01 00:20:41.000000', 'consum', 0.0212, 'lps'),
	(672283, 133, '2015-02-01 00:20:42.000000', 'consum', 0.0211, 'lps'),
	(672284, 133, '2015-02-01 00:20:43.000000', 'consum', 0.0220, 'lps'),
	(672285, 133, '2015-02-01 00:20:44.000000', 'consum', 0.0210, 'lps'),
	(672286, 133, '2015-02-01 00:20:45.000000', 'consum', 0.0219, 'lps'),
	(672287, 133, '2015-02-01 00:20:46.000000', 'consum', 0.0216, 'lps'),
	(672288, 133, '2015-02-01 00:20:47.000000', 'consum', 0.0216, 'lps'),
	(672289, 133, '2015-02-01 00:20:48.000000', 'consum', 0.0210, 'lps'),
	(672290, 133, '2015-02-01 00:20:49.000000', 'consum', 0.0216, 'lps'),
	(672291, 133, '2015-02-01 00:20:50.000000', 'consum', 0.0217, 'lps'),
	(672292, 133, '2015-02-01 00:20:51.000000', 'consum', 0.0217, 'lps'),
	(672293, 133, '2015-02-01 00:20:52.000000', 'consum', 0.0213, 'lps'),
	(672294, 133, '2015-02-01 00:20:53.000000', 'consum', 0.0214, 'lps'),
	(672295, 133, '2015-02-01 00:20:54.000000', 'consum', 0.0221, 'lps'),
	(672296, 133, '2015-02-01 00:20:55.000000', 'consum', 0.0218, 'lps'),
	(672297, 133, '2015-02-01 00:20:56.000000', 'consum', 0.0218, 'lps'),
	(672298, 133, '2015-02-01 00:20:57.000000', 'consum', 0.0215, 'lps'),
	(672299, 133, '2015-02-01 00:20:58.000000', 'consum', 0.0212, 'lps'),
	(672300, 133, '2015-02-01 00:20:59.000000', 'consum', 0.0218, 'lps'),
	(672301, 133, '2015-02-01 00:21:00.000000', 'consum', 0.0218, 'lps'),
	(672302, 133, '2015-02-01 00:21:01.000000', 'consum', 0.0215, 'lps'),
	(672303, 133, '2015-02-01 00:21:02.000000', 'consum', 0.0214, 'lps'),
	(672304, 133, '2015-02-01 00:21:03.000000', 'consum', 0.0213, 'lps'),
	(672305, 133, '2015-02-01 00:21:04.000000', 'consum', 0.0213, 'lps'),
	(672306, 133, '2015-02-01 00:21:05.000000', 'consum', 0.0217, 'lps'),
	(672307, 133, '2015-02-01 00:21:06.000000', 'consum', 0.0213, 'lps'),
	(672308, 133, '2015-02-01 00:21:07.000000', 'consum', 0.0218, 'lps'),
	(672309, 133, '2015-02-01 00:21:08.000000', 'consum', 0.0217, 'lps'),
	(672310, 133, '2015-02-01 00:21:09.000000', 'consum', 0.0210, 'lps'),
	(672311, 133, '2015-02-01 00:21:10.000000', 'consum', 0.0211, 'lps'),
	(672312, 133, '2015-02-01 00:21:11.000000', 'consum', 0.0217, 'lps'),
	(672313, 133, '2015-02-01 00:21:12.000000', 'consum', 0.0218, 'lps'),
	(672314, 133, '2015-02-01 00:21:13.000000', 'consum', 0.0217, 'lps'),
	(672315, 133, '2015-02-01 00:21:14.000000', 'consum', 0.0211, 'lps'),
	(672316, 133, '2015-02-01 00:21:15.000000', 'consum', 0.0216, 'lps'),
	(672317, 133, '2015-02-01 00:21:16.000000', 'consum', 0.0215, 'lps'),
	(672318, 133, '2015-02-01 00:21:17.000000', 'consum', 0.0219, 'lps'),
	(672319, 133, '2015-02-01 00:21:18.000000', 'consum', 0.0214, 'lps'),
	(672320, 133, '2015-02-01 00:21:19.000000', 'consum', 0.0218, 'lps'),
	(672321, 133, '2015-02-01 00:21:20.000000', 'consum', 0.0213, 'lps'),
	(672322, 133, '2015-02-01 00:21:21.000000', 'consum', 0.0215, 'lps'),
	(672323, 133, '2015-02-01 00:21:22.000000', 'consum', 0.0212, 'lps'),
	(672324, 133, '2015-02-01 00:21:23.000000', 'consum', 0.0219, 'lps'),
	(672325, 133, '2015-02-01 00:21:24.000000', 'consum', 0.0215, 'lps'),
	(672326, 133, '2015-02-01 00:21:25.000000', 'consum', 0.0219, 'lps'),
	(672327, 133, '2015-02-01 00:21:26.000000', 'consum', 0.0216, 'lps'),
	(672328, 133, '2015-02-01 00:21:27.000000', 'consum', 0.0213, 'lps'),
	(672329, 133, '2015-02-01 00:21:28.000000', 'consum', 0.0218, 'lps'),
	(672330, 133, '2015-02-01 00:21:29.000000', 'consum', 0.0221, 'lps'),
	(672331, 133, '2015-02-01 00:21:30.000000', 'consum', 0.0216, 'lps'),
	(672332, 133, '2015-02-01 00:21:31.000000', 'consum', 0.0221, 'lps'),
	(672333, 133, '2015-02-01 00:21:32.000000', 'consum', 0.0210, 'lps'),
	(672334, 133, '2015-02-01 00:21:33.000000', 'consum', 0.0214, 'lps'),
	(672335, 133, '2015-02-01 00:21:34.000000', 'consum', 0.0219, 'lps'),
	(672336, 133, '2015-02-01 00:21:35.000000', 'consum', 0.0221, 'lps'),
	(672337, 133, '2015-02-01 00:21:36.000000', 'consum', 0.0212, 'lps'),
	(672338, 133, '2015-02-01 00:21:37.000000', 'consum', 0.0214, 'lps'),
	(672339, 133, '2015-02-01 00:21:38.000000', 'consum', 0.0213, 'lps'),
	(672340, 133, '2015-02-01 00:21:39.000000', 'consum', 0.0211, 'lps'),
	(672341, 133, '2015-02-01 00:21:40.000000', 'consum', 0.0220, 'lps'),
	(672342, 133, '2015-02-01 00:21:41.000000', 'consum', 0.0211, 'lps'),
	(672343, 133, '2015-02-01 00:21:42.000000', 'consum', 0.0220, 'lps'),
	(672344, 133, '2015-02-01 00:21:43.000000', 'consum', 0.0221, 'lps'),
	(672345, 133, '2015-02-01 00:21:44.000000', 'consum', 0.0214, 'lps'),
	(672346, 133, '2015-02-01 00:21:45.000000', 'consum', 0.0219, 'lps'),
	(672347, 133, '2015-02-01 00:21:46.000000', 'consum', 0.0219, 'lps'),
	(672348, 133, '2015-02-01 00:21:47.000000', 'consum', 0.0219, 'lps'),
	(672349, 133, '2015-02-01 00:21:48.000000', 'consum', 0.0217, 'lps'),
	(672350, 133, '2015-02-01 00:21:49.000000', 'consum', 0.0217, 'lps'),
	(672351, 133, '2015-02-01 00:21:50.000000', 'consum', 0.0214, 'lps'),
	(672352, 133, '2015-02-01 00:21:51.000000', 'consum', 0.0210, 'lps'),
	(672353, 133, '2015-02-01 00:21:52.000000', 'consum', 0.0211, 'lps'),
	(672354, 133, '2015-02-01 00:21:53.000000', 'consum', 0.0213, 'lps'),
	(672355, 133, '2015-02-01 00:21:54.000000', 'consum', 0.0213, 'lps'),
	(672356, 133, '2015-02-01 00:21:55.000000', 'consum', 0.0217, 'lps'),
	(672357, 133, '2015-02-01 00:21:56.000000', 'consum', 0.0211, 'lps'),
	(672358, 133, '2015-02-01 00:21:57.000000', 'consum', 0.0220, 'lps'),
	(672359, 133, '2015-02-01 00:21:58.000000', 'consum', 0.0219, 'lps'),
	(672360, 133, '2015-02-01 00:21:59.000000', 'consum', 0.0216, 'lps'),
	(672361, 133, '2015-02-01 00:22:00.000000', 'consum', 0.0211, 'lps'),
	(672362, 133, '2015-02-01 00:22:01.000000', 'consum', 0.0211, 'lps'),
	(672363, 133, '2015-02-01 00:22:02.000000', 'consum', 0.0211, 'lps'),
	(672364, 133, '2015-02-01 00:22:03.000000', 'consum', 0.0214, 'lps'),
	(672365, 133, '2015-02-01 00:22:04.000000', 'consum', 0.0214, 'lps'),
	(672366, 133, '2015-02-01 00:22:05.000000', 'consum', 0.0218, 'lps'),
	(672367, 133, '2015-02-01 00:22:06.000000', 'consum', 0.0213, 'lps'),
	(672368, 133, '2015-02-01 00:22:07.000000', 'consum', 0.0217, 'lps'),
	(672369, 133, '2015-02-01 00:22:08.000000', 'consum', 0.0212, 'lps'),
	(672370, 133, '2015-02-01 00:22:09.000000', 'consum', 0.0210, 'lps'),
	(672371, 133, '2015-02-01 00:22:10.000000', 'consum', 0.0219, 'lps'),
	(672372, 133, '2015-02-01 00:22:11.000000', 'consum', 0.0217, 'lps'),
	(672373, 133, '2015-02-01 00:22:12.000000', 'consum', 0.0221, 'lps'),
	(672374, 133, '2015-02-01 00:22:13.000000', 'consum', 0.0221, 'lps'),
	(672375, 133, '2015-02-01 00:22:14.000000', 'consum', 0.0221, 'lps'),
	(672376, 133, '2015-02-01 00:22:15.000000', 'consum', 0.0218, 'lps'),
	(672377, 133, '2015-02-01 00:22:16.000000', 'consum', 0.0217, 'lps'),
	(672378, 133, '2015-02-01 00:22:17.000000', 'consum', 0.0212, 'lps'),
	(672379, 133, '2015-02-01 00:22:18.000000', 'consum', 0.0212, 'lps'),
	(672380, 133, '2015-02-01 00:22:19.000000', 'consum', 0.0213, 'lps'),
	(672381, 133, '2015-02-01 00:22:20.000000', 'consum', 0.0219, 'lps'),
	(672382, 133, '2015-02-01 00:22:21.000000', 'consum', 0.0210, 'lps'),
	(672383, 133, '2015-02-01 00:22:22.000000', 'consum', 0.0220, 'lps'),
	(672384, 133, '2015-02-01 00:22:23.000000', 'consum', 0.0214, 'lps'),
	(672385, 133, '2015-02-01 00:22:24.000000', 'consum', 0.0213, 'lps'),
	(672386, 133, '2015-02-01 00:22:25.000000', 'consum', 0.0214, 'lps'),
	(672387, 133, '2015-02-01 00:22:26.000000', 'consum', 0.0219, 'lps'),
	(672388, 133, '2015-02-01 00:22:27.000000', 'consum', 0.0221, 'lps'),
	(672389, 133, '2015-02-01 00:22:28.000000', 'consum', 0.0216, 'lps'),
	(672390, 133, '2015-02-01 00:22:29.000000', 'consum', 0.0217, 'lps'),
	(672391, 133, '2015-02-01 00:22:30.000000', 'consum', 0.0218, 'lps'),
	(672392, 133, '2015-02-01 00:22:31.000000', 'consum', 0.0217, 'lps'),
	(672393, 133, '2015-02-01 00:22:32.000000', 'consum', 0.0219, 'lps'),
	(672394, 133, '2015-02-01 00:22:33.000000', 'consum', 0.0213, 'lps'),
	(672395, 133, '2015-02-01 00:22:34.000000', 'consum', 0.0220, 'lps'),
	(672396, 133, '2015-02-01 00:22:35.000000', 'consum', 0.0217, 'lps'),
	(672397, 133, '2015-02-01 00:22:36.000000', 'consum', 0.0214, 'lps'),
	(672398, 133, '2015-02-01 00:22:37.000000', 'consum', 0.0220, 'lps'),
	(672399, 133, '2015-02-01 00:22:38.000000', 'consum', 0.0216, 'lps'),
	(672400, 133, '2015-02-01 00:22:39.000000', 'consum', 0.0220, 'lps'),
	(672401, 133, '2015-02-01 00:22:40.000000', 'consum', 0.0221, 'lps'),
	(672402, 133, '2015-02-01 00:22:41.000000', 'consum', 0.0221, 'lps'),
	(672403, 133, '2015-02-01 00:22:42.000000', 'consum', 0.0210, 'lps'),
	(672404, 133, '2015-02-01 00:22:43.000000', 'consum', 0.0212, 'lps'),
	(672405, 133, '2015-02-01 00:22:44.000000', 'consum', 0.0220, 'lps'),
	(672406, 133, '2015-02-01 00:22:45.000000', 'consum', 0.0220, 'lps'),
	(672407, 133, '2015-02-01 00:22:46.000000', 'consum', 0.0219, 'lps'),
	(672408, 133, '2015-02-01 00:22:47.000000', 'consum', 0.0211, 'lps'),
	(672409, 133, '2015-02-01 00:22:48.000000', 'consum', 0.0213, 'lps'),
	(672410, 133, '2015-02-01 00:22:49.000000', 'consum', 0.0210, 'lps'),
	(672411, 133, '2015-02-01 00:22:50.000000', 'consum', 0.0215, 'lps'),
	(672412, 133, '2015-02-01 00:22:51.000000', 'consum', 0.0213, 'lps'),
	(672413, 133, '2015-02-01 00:22:52.000000', 'consum', 0.0221, 'lps'),
	(672414, 133, '2015-02-01 00:22:53.000000', 'consum', 0.0219, 'lps'),
	(672415, 133, '2015-02-01 00:22:54.000000', 'consum', 0.0213, 'lps'),
	(672416, 133, '2015-02-01 00:22:55.000000', 'consum', 0.0221, 'lps'),
	(672417, 133, '2015-02-01 00:22:56.000000', 'consum', 0.0210, 'lps'),
	(672418, 133, '2015-02-01 00:22:57.000000', 'consum', 0.0213, 'lps'),
	(672419, 133, '2015-02-01 00:22:58.000000', 'consum', 0.0212, 'lps'),
	(672420, 133, '2015-02-01 00:22:59.000000', 'consum', 0.0213, 'lps'),
	(672421, 133, '2015-02-01 00:23:00.000000', 'consum', 0.0219, 'lps'),
	(672422, 133, '2015-02-01 00:23:01.000000', 'consum', 0.0211, 'lps'),
	(672423, 133, '2015-02-01 00:23:02.000000', 'consum', 0.0211, 'lps'),
	(672424, 133, '2015-02-01 00:23:03.000000', 'consum', 0.0211, 'lps'),
	(672425, 133, '2015-02-01 00:23:04.000000', 'consum', 0.0215, 'lps'),
	(672426, 133, '2015-02-01 00:23:05.000000', 'consum', 0.0221, 'lps'),
	(672427, 133, '2015-02-01 00:23:06.000000', 'consum', 0.0212, 'lps'),
	(672428, 133, '2015-02-01 00:23:07.000000', 'consum', 0.0212, 'lps'),
	(672429, 133, '2015-02-01 00:23:08.000000', 'consum', 0.0216, 'lps'),
	(672430, 133, '2015-02-01 00:23:09.000000', 'consum', 0.0221, 'lps'),
	(672431, 133, '2015-02-01 00:23:10.000000', 'consum', 0.0214, 'lps'),
	(672432, 133, '2015-02-01 00:23:11.000000', 'consum', 0.0219, 'lps'),
	(672433, 133, '2015-02-01 00:23:12.000000', 'consum', 0.0220, 'lps'),
	(672434, 133, '2015-02-01 00:23:13.000000', 'consum', 0.0210, 'lps'),
	(672435, 133, '2015-02-01 00:23:14.000000', 'consum', 0.0215, 'lps'),
	(672436, 133, '2015-02-01 00:23:15.000000', 'consum', 0.0213, 'lps'),
	(672437, 133, '2015-02-01 00:23:16.000000', 'consum', 0.0210, 'lps'),
	(672438, 133, '2015-02-01 00:23:17.000000', 'consum', 0.0214, 'lps'),
	(672439, 133, '2015-02-01 00:23:18.000000', 'consum', 0.0218, 'lps'),
	(672440, 133, '2015-02-01 00:23:19.000000', 'consum', 0.0216, 'lps'),
	(672441, 133, '2015-02-01 00:23:20.000000', 'consum', 0.0217, 'lps'),
	(672442, 133, '2015-02-01 00:23:21.000000', 'consum', 0.0215, 'lps'),
	(672443, 133, '2015-02-01 00:23:22.000000', 'consum', 0.0213, 'lps'),
	(672444, 133, '2015-02-01 00:23:23.000000', 'consum', 0.0213, 'lps'),
	(672445, 133, '2015-02-01 00:23:24.000000', 'consum', 0.0213, 'lps'),
	(672446, 133, '2015-02-01 00:23:25.000000', 'consum', 0.0219, 'lps'),
	(672447, 133, '2015-02-01 00:23:26.000000', 'consum', 0.0212, 'lps'),
	(672448, 133, '2015-02-01 00:23:27.000000', 'consum', 0.0216, 'lps'),
	(672449, 133, '2015-02-01 00:23:28.000000', 'consum', 0.0211, 'lps'),
	(672450, 133, '2015-02-01 00:23:29.000000', 'consum', 0.0220, 'lps'),
	(672451, 133, '2015-02-01 00:23:30.000000', 'consum', 0.0210, 'lps'),
	(672452, 133, '2015-02-01 00:23:31.000000', 'consum', 0.0218, 'lps'),
	(672453, 133, '2015-02-01 00:23:32.000000', 'consum', 0.0216, 'lps'),
	(672454, 133, '2015-02-01 00:23:33.000000', 'consum', 0.0213, 'lps'),
	(672455, 133, '2015-02-01 00:23:34.000000', 'consum', 0.0210, 'lps'),
	(672456, 133, '2015-02-01 00:23:35.000000', 'consum', 0.0214, 'lps'),
	(672457, 133, '2015-02-01 00:23:36.000000', 'consum', 0.0216, 'lps'),
	(672458, 133, '2015-02-01 00:23:37.000000', 'consum', 0.0219, 'lps'),
	(672459, 133, '2015-02-01 00:23:38.000000', 'consum', 0.0214, 'lps'),
	(672460, 133, '2015-02-01 00:23:39.000000', 'consum', 0.0214, 'lps'),
	(672461, 133, '2015-02-01 00:23:40.000000', 'consum', 0.0217, 'lps'),
	(672462, 133, '2015-02-01 00:23:41.000000', 'consum', 0.0210, 'lps'),
	(672463, 133, '2015-02-01 00:23:42.000000', 'consum', 0.0212, 'lps'),
	(672464, 133, '2015-02-01 00:23:43.000000', 'consum', 0.0210, 'lps'),
	(672465, 133, '2015-02-01 00:23:44.000000', 'consum', 0.0215, 'lps'),
	(672466, 133, '2015-02-01 00:23:45.000000', 'consum', 0.0212, 'lps'),
	(672467, 133, '2015-02-01 00:23:46.000000', 'consum', 0.0220, 'lps'),
	(672468, 133, '2015-02-01 00:23:47.000000', 'consum', 0.0217, 'lps'),
	(672469, 133, '2015-02-01 00:23:48.000000', 'consum', 0.0214, 'lps'),
	(672470, 133, '2015-02-01 00:23:49.000000', 'consum', 0.0211, 'lps'),
	(672471, 133, '2015-02-01 00:23:50.000000', 'consum', 0.0214, 'lps'),
	(672472, 133, '2015-02-01 00:23:51.000000', 'consum', 0.0218, 'lps'),
	(672473, 133, '2015-02-01 00:23:52.000000', 'consum', 0.0215, 'lps'),
	(672474, 133, '2015-02-01 00:23:53.000000', 'consum', 0.0210, 'lps'),
	(672475, 133, '2015-02-01 00:23:54.000000', 'consum', 0.0221, 'lps'),
	(672476, 133, '2015-02-01 00:23:55.000000', 'consum', 0.0217, 'lps'),
	(672477, 133, '2015-02-01 00:23:56.000000', 'consum', 0.0212, 'lps'),
	(672478, 133, '2015-02-01 00:23:57.000000', 'consum', 0.0210, 'lps'),
	(672479, 133, '2015-02-01 00:23:58.000000', 'consum', 0.0217, 'lps'),
	(672480, 133, '2015-02-01 00:23:59.000000', 'consum', 0.0212, 'lps'),
	(672481, 133, '2015-02-01 00:24:00.000000', 'consum', 0.0221, 'lps'),
	(672482, 133, '2015-02-01 00:24:01.000000', 'consum', 0.0213, 'lps'),
	(672483, 133, '2015-02-01 00:24:02.000000', 'consum', 0.0218, 'lps'),
	(672484, 133, '2015-02-01 00:24:03.000000', 'consum', 0.0215, 'lps'),
	(672485, 133, '2015-02-01 00:24:04.000000', 'consum', 0.0211, 'lps'),
	(672486, 133, '2015-02-01 00:24:05.000000', 'consum', 0.0213, 'lps'),
	(672487, 133, '2015-02-01 00:24:06.000000', 'consum', 0.0221, 'lps'),
	(672488, 133, '2015-02-01 00:24:07.000000', 'consum', 0.0210, 'lps'),
	(672489, 133, '2015-02-01 00:24:08.000000', 'consum', 0.0215, 'lps'),
	(672490, 133, '2015-02-01 00:24:09.000000', 'consum', 0.0211, 'lps'),
	(672491, 133, '2015-02-01 00:24:10.000000', 'consum', 0.0213, 'lps'),
	(672492, 133, '2015-02-01 00:24:11.000000', 'consum', 0.0211, 'lps'),
	(672493, 133, '2015-02-01 00:24:12.000000', 'consum', 0.0219, 'lps'),
	(672494, 133, '2015-02-01 00:24:13.000000', 'consum', 0.0214, 'lps'),
	(672495, 133, '2015-02-01 00:24:14.000000', 'consum', 0.0217, 'lps'),
	(672496, 133, '2015-02-01 00:24:15.000000', 'consum', 0.0221, 'lps'),
	(672497, 133, '2015-02-01 00:24:16.000000', 'consum', 0.0210, 'lps'),
	(672498, 133, '2015-02-01 00:24:17.000000', 'consum', 0.0213, 'lps'),
	(672499, 133, '2015-02-01 00:24:18.000000', 'consum', 0.0214, 'lps'),
	(672500, 133, '2015-02-01 00:24:19.000000', 'consum', 0.0211, 'lps'),
	(672501, 133, '2015-02-01 00:24:20.000000', 'consum', 0.0214, 'lps'),
	(672502, 133, '2015-02-01 00:24:21.000000', 'consum', 0.0216, 'lps'),
	(672503, 133, '2015-02-01 00:24:22.000000', 'consum', 0.0218, 'lps'),
	(672504, 133, '2015-02-01 00:24:23.000000', 'consum', 0.0220, 'lps'),
	(672505, 133, '2015-02-01 00:24:24.000000', 'consum', 0.0211, 'lps'),
	(672506, 133, '2015-02-01 00:24:25.000000', 'consum', 0.0212, 'lps'),
	(672507, 133, '2015-02-01 00:24:26.000000', 'consum', 0.0216, 'lps'),
	(672508, 133, '2015-02-01 00:24:27.000000', 'consum', 0.0212, 'lps'),
	(672509, 133, '2015-02-01 00:24:28.000000', 'consum', 0.0215, 'lps'),
	(672510, 133, '2015-02-01 00:24:29.000000', 'consum', 0.0215, 'lps'),
	(672511, 133, '2015-02-01 00:24:30.000000', 'consum', 0.0221, 'lps'),
	(672512, 133, '2015-02-01 00:24:31.000000', 'consum', 0.0215, 'lps'),
	(672513, 133, '2015-02-01 00:24:32.000000', 'consum', 0.0213, 'lps'),
	(672514, 133, '2015-02-01 00:24:33.000000', 'consum', 0.0212, 'lps'),
	(672515, 133, '2015-02-01 00:24:34.000000', 'consum', 0.0211, 'lps'),
	(672516, 133, '2015-02-01 00:24:35.000000', 'consum', 0.0220, 'lps'),
	(672517, 133, '2015-02-01 00:24:36.000000', 'consum', 0.0210, 'lps'),
	(672518, 133, '2015-02-01 00:24:37.000000', 'consum', 0.0216, 'lps'),
	(672519, 133, '2015-02-01 00:24:38.000000', 'consum', 0.0216, 'lps'),
	(672520, 133, '2015-02-01 00:24:39.000000', 'consum', 0.0212, 'lps'),
	(672521, 133, '2015-02-01 00:24:40.000000', 'consum', 0.0216, 'lps'),
	(672522, 133, '2015-02-01 00:24:41.000000', 'consum', 0.0220, 'lps'),
	(672523, 133, '2015-02-01 00:24:42.000000', 'consum', 0.0221, 'lps'),
	(672524, 133, '2015-02-01 00:24:43.000000', 'consum', 0.0221, 'lps'),
	(672525, 133, '2015-02-01 00:24:44.000000', 'consum', 0.0212, 'lps'),
	(672526, 133, '2015-02-01 00:24:45.000000', 'consum', 0.0220, 'lps'),
	(672527, 133, '2015-02-01 00:24:46.000000', 'consum', 0.0219, 'lps'),
	(672528, 133, '2015-02-01 00:24:47.000000', 'consum', 0.0212, 'lps'),
	(672529, 133, '2015-02-01 00:24:48.000000', 'consum', 0.0218, 'lps'),
	(672530, 133, '2015-02-01 00:24:49.000000', 'consum', 0.0210, 'lps'),
	(672531, 133, '2015-02-01 00:24:50.000000', 'consum', 0.0211, 'lps'),
	(672532, 133, '2015-02-01 00:24:51.000000', 'consum', 0.0215, 'lps'),
	(672533, 133, '2015-02-01 00:24:52.000000', 'consum', 0.0210, 'lps'),
	(672534, 133, '2015-02-01 00:24:53.000000', 'consum', 0.0219, 'lps'),
	(672535, 133, '2015-02-01 00:24:54.000000', 'consum', 0.0221, 'lps'),
	(672536, 133, '2015-02-01 00:24:55.000000', 'consum', 0.0211, 'lps'),
	(672537, 133, '2015-02-01 00:24:56.000000', 'consum', 0.0220, 'lps'),
	(672538, 133, '2015-02-01 00:24:57.000000', 'consum', 0.0221, 'lps'),
	(672539, 133, '2015-02-01 00:24:58.000000', 'consum', 0.0214, 'lps'),
	(672540, 133, '2015-02-01 00:24:59.000000', 'consum', 0.0220, 'lps'),
	(672541, 133, '2015-02-01 00:25:00.000000', 'consum', 0.0212, 'lps'),
	(672542, 133, '2015-02-01 00:25:01.000000', 'consum', 0.0216, 'lps'),
	(672543, 133, '2015-02-01 00:25:02.000000', 'consum', 0.0220, 'lps'),
	(672544, 133, '2015-02-01 00:25:03.000000', 'consum', 0.0221, 'lps'),
	(672545, 133, '2015-02-01 00:25:04.000000', 'consum', 0.0221, 'lps'),
	(672546, 133, '2015-02-01 00:25:05.000000', 'consum', 0.0221, 'lps'),
	(672547, 133, '2015-02-01 00:25:06.000000', 'consum', 0.0221, 'lps'),
	(672548, 133, '2015-02-01 00:25:07.000000', 'consum', 0.0220, 'lps'),
	(672549, 133, '2015-02-01 00:25:08.000000', 'consum', 0.0215, 'lps'),
	(672550, 133, '2015-02-01 00:25:09.000000', 'consum', 0.0218, 'lps'),
	(672551, 133, '2015-02-01 00:25:10.000000', 'consum', 0.0213, 'lps'),
	(672552, 133, '2015-02-01 00:25:11.000000', 'consum', 0.0212, 'lps'),
	(672553, 133, '2015-02-01 00:25:12.000000', 'consum', 0.0212, 'lps'),
	(672554, 133, '2015-02-01 00:25:13.000000', 'consum', 0.0216, 'lps'),
	(672555, 133, '2015-02-01 00:25:14.000000', 'consum', 0.0221, 'lps'),
	(672556, 133, '2015-02-01 00:25:15.000000', 'consum', 0.0211, 'lps'),
	(672557, 133, '2015-02-01 00:25:16.000000', 'consum', 0.0217, 'lps'),
	(672558, 133, '2015-02-01 00:25:17.000000', 'consum', 0.0221, 'lps'),
	(672559, 133, '2015-02-01 00:25:18.000000', 'consum', 0.0219, 'lps'),
	(672560, 133, '2015-02-01 00:25:19.000000', 'consum', 0.0221, 'lps'),
	(672561, 133, '2015-02-01 00:25:20.000000', 'consum', 0.0217, 'lps'),
	(672562, 133, '2015-02-01 00:25:21.000000', 'consum', 0.0212, 'lps'),
	(672563, 133, '2015-02-01 00:25:22.000000', 'consum', 0.0211, 'lps'),
	(672564, 133, '2015-02-01 00:25:23.000000', 'consum', 0.0220, 'lps'),
	(672565, 133, '2015-02-01 00:25:24.000000', 'consum', 0.0210, 'lps'),
	(672566, 133, '2015-02-01 00:25:25.000000', 'consum', 0.0215, 'lps'),
	(672567, 133, '2015-02-01 00:25:26.000000', 'consum', 0.0212, 'lps'),
	(672568, 133, '2015-02-01 00:25:27.000000', 'consum', 0.0220, 'lps'),
	(672569, 133, '2015-02-01 00:25:28.000000', 'consum', 0.0217, 'lps'),
	(672570, 133, '2015-02-01 00:25:29.000000', 'consum', 0.0214, 'lps'),
	(672571, 133, '2015-02-01 00:25:30.000000', 'consum', 0.0221, 'lps'),
	(672572, 133, '2015-02-01 00:25:31.000000', 'consum', 0.0220, 'lps'),
	(672573, 133, '2015-02-01 00:25:32.000000', 'consum', 0.0215, 'lps'),
	(672574, 133, '2015-02-01 00:25:33.000000', 'consum', 0.0216, 'lps'),
	(672575, 133, '2015-02-01 00:25:34.000000', 'consum', 0.0214, 'lps'),
	(672576, 133, '2015-02-01 00:25:35.000000', 'consum', 0.0212, 'lps'),
	(672577, 133, '2015-02-01 00:25:36.000000', 'consum', 0.0211, 'lps'),
	(672578, 133, '2015-02-01 00:25:37.000000', 'consum', 0.0219, 'lps'),
	(672579, 133, '2015-02-01 00:25:38.000000', 'consum', 0.0219, 'lps'),
	(672580, 133, '2015-02-01 00:25:39.000000', 'consum', 0.0216, 'lps'),
	(672581, 133, '2015-02-01 00:25:40.000000', 'consum', 0.0211, 'lps'),
	(672582, 133, '2015-02-01 00:25:41.000000', 'consum', 0.0212, 'lps'),
	(672583, 133, '2015-02-01 00:25:42.000000', 'consum', 0.0215, 'lps'),
	(672584, 133, '2015-02-01 00:25:43.000000', 'consum', 0.0219, 'lps'),
	(672585, 133, '2015-02-01 00:25:44.000000', 'consum', 0.0216, 'lps'),
	(672586, 133, '2015-02-01 00:25:45.000000', 'consum', 0.0213, 'lps'),
	(672587, 133, '2015-02-01 00:25:46.000000', 'consum', 0.0220, 'lps'),
	(672588, 133, '2015-02-01 00:25:47.000000', 'consum', 0.0217, 'lps'),
	(672589, 133, '2015-02-01 00:25:48.000000', 'consum', 0.0214, 'lps'),
	(672590, 133, '2015-02-01 00:25:49.000000', 'consum', 0.0221, 'lps'),
	(672591, 133, '2015-02-01 00:25:50.000000', 'consum', 0.0217, 'lps'),
	(672592, 133, '2015-02-01 00:25:51.000000', 'consum', 0.0212, 'lps'),
	(672593, 133, '2015-02-01 00:25:52.000000', 'consum', 0.0213, 'lps'),
	(672594, 133, '2015-02-01 00:25:53.000000', 'consum', 0.0218, 'lps'),
	(672595, 133, '2015-02-01 00:25:54.000000', 'consum', 0.0219, 'lps'),
	(672596, 133, '2015-02-01 00:25:55.000000', 'consum', 0.0218, 'lps'),
	(672597, 133, '2015-02-01 00:25:56.000000', 'consum', 0.0211, 'lps'),
	(672598, 133, '2015-02-01 00:25:57.000000', 'consum', 0.0218, 'lps'),
	(672599, 133, '2015-02-01 00:25:58.000000', 'consum', 0.0210, 'lps'),
	(672600, 133, '2015-02-01 00:25:59.000000', 'consum', 0.0211, 'lps'),
	(672601, 133, '2015-02-01 00:26:00.000000', 'consum', 0.0217, 'lps'),
	(672602, 133, '2015-02-01 00:26:01.000000', 'consum', 0.0217, 'lps'),
	(672603, 133, '2015-02-01 00:26:02.000000', 'consum', 0.0213, 'lps'),
	(672604, 133, '2015-02-01 00:26:03.000000', 'consum', 0.0217, 'lps'),
	(672605, 133, '2015-02-01 00:26:04.000000', 'consum', 0.0210, 'lps'),
	(672606, 133, '2015-02-01 00:26:05.000000', 'consum', 0.0216, 'lps'),
	(672607, 133, '2015-02-01 00:26:06.000000', 'consum', 0.0217, 'lps'),
	(672608, 133, '2015-02-01 00:26:07.000000', 'consum', 0.0217, 'lps'),
	(672609, 133, '2015-02-01 00:26:08.000000', 'consum', 0.0210, 'lps'),
	(672610, 133, '2015-02-01 00:26:09.000000', 'consum', 0.0212, 'lps'),
	(672611, 133, '2015-02-01 00:26:10.000000', 'consum', 0.0212, 'lps'),
	(672612, 133, '2015-02-01 00:26:11.000000', 'consum', 0.0212, 'lps'),
	(672613, 133, '2015-02-01 00:26:12.000000', 'consum', 0.0217, 'lps'),
	(672614, 133, '2015-02-01 00:26:13.000000', 'consum', 0.0214, 'lps'),
	(672615, 133, '2015-02-01 00:26:14.000000', 'consum', 0.0210, 'lps'),
	(672616, 133, '2015-02-01 00:26:15.000000', 'consum', 0.0221, 'lps'),
	(672617, 133, '2015-02-01 00:26:16.000000', 'consum', 0.0217, 'lps'),
	(672618, 133, '2015-02-01 00:26:17.000000', 'consum', 0.0213, 'lps'),
	(672619, 133, '2015-02-01 00:26:18.000000', 'consum', 0.0216, 'lps'),
	(672620, 133, '2015-02-01 00:26:19.000000', 'consum', 0.0219, 'lps'),
	(672621, 133, '2015-02-01 00:26:20.000000', 'consum', 0.0212, 'lps'),
	(672622, 133, '2015-02-01 00:26:21.000000', 'consum', 0.0220, 'lps'),
	(672623, 133, '2015-02-01 00:26:22.000000', 'consum', 0.0219, 'lps'),
	(672624, 133, '2015-02-01 00:26:23.000000', 'consum', 0.0212, 'lps'),
	(672625, 133, '2015-02-01 00:26:24.000000', 'consum', 0.0218, 'lps'),
	(672626, 133, '2015-02-01 00:26:25.000000', 'consum', 0.0210, 'lps'),
	(672627, 133, '2015-02-01 00:26:26.000000', 'consum', 0.0212, 'lps'),
	(672628, 133, '2015-02-01 00:26:27.000000', 'consum', 0.0217, 'lps'),
	(672629, 133, '2015-02-01 00:26:28.000000', 'consum', 0.0215, 'lps'),
	(672630, 133, '2015-02-01 00:26:29.000000', 'consum', 0.0216, 'lps'),
	(672631, 133, '2015-02-01 00:26:30.000000', 'consum', 0.0214, 'lps'),
	(672632, 133, '2015-02-01 00:26:31.000000', 'consum', 0.0212, 'lps'),
	(672633, 133, '2015-02-01 00:26:32.000000', 'consum', 0.0221, 'lps'),
	(672634, 133, '2015-02-01 00:26:33.000000', 'consum', 0.0212, 'lps'),
	(672635, 133, '2015-02-01 00:26:34.000000', 'consum', 0.0212, 'lps'),
	(672636, 133, '2015-02-01 00:26:35.000000', 'consum', 0.0213, 'lps'),
	(672637, 133, '2015-02-01 00:26:36.000000', 'consum', 0.0219, 'lps'),
	(672638, 133, '2015-02-01 00:26:37.000000', 'consum', 0.0212, 'lps'),
	(672639, 133, '2015-02-01 00:26:38.000000', 'consum', 0.0215, 'lps'),
	(672640, 133, '2015-02-01 00:26:39.000000', 'consum', 0.0219, 'lps'),
	(672641, 133, '2015-02-01 00:26:40.000000', 'consum', 0.0218, 'lps'),
	(672642, 133, '2015-02-01 00:26:41.000000', 'consum', 0.0211, 'lps'),
	(672643, 133, '2015-02-01 00:26:42.000000', 'consum', 0.0214, 'lps'),
	(672644, 133, '2015-02-01 00:26:43.000000', 'consum', 0.0217, 'lps'),
	(672645, 133, '2015-02-01 00:26:44.000000', 'consum', 0.0219, 'lps'),
	(672646, 133, '2015-02-01 00:26:45.000000', 'consum', 0.0213, 'lps'),
	(672647, 133, '2015-02-01 00:26:46.000000', 'consum', 0.0220, 'lps'),
	(672648, 133, '2015-02-01 00:26:47.000000', 'consum', 0.0215, 'lps'),
	(672649, 133, '2015-02-01 00:26:48.000000', 'consum', 0.0219, 'lps'),
	(672650, 133, '2015-02-01 00:26:49.000000', 'consum', 0.0215, 'lps'),
	(672651, 133, '2015-02-01 00:26:50.000000', 'consum', 0.0221, 'lps'),
	(672652, 133, '2015-02-01 00:26:51.000000', 'consum', 0.0216, 'lps'),
	(672653, 133, '2015-02-01 00:26:52.000000', 'consum', 0.0217, 'lps'),
	(672654, 133, '2015-02-01 00:26:53.000000', 'consum', 0.0215, 'lps'),
	(672655, 133, '2015-02-01 00:26:54.000000', 'consum', 0.0214, 'lps'),
	(672656, 133, '2015-02-01 00:26:55.000000', 'consum', 0.0216, 'lps'),
	(672657, 133, '2015-02-01 00:26:56.000000', 'consum', 0.0216, 'lps'),
	(672658, 133, '2015-02-01 00:26:57.000000', 'consum', 0.0212, 'lps'),
	(672659, 133, '2015-02-01 00:26:58.000000', 'consum', 0.0213, 'lps'),
	(672660, 133, '2015-02-01 00:26:59.000000', 'consum', 0.0210, 'lps'),
	(672661, 133, '2015-02-01 00:27:00.000000', 'consum', 0.0212, 'lps'),
	(672662, 133, '2015-02-01 00:27:01.000000', 'consum', 0.0219, 'lps'),
	(672663, 133, '2015-02-01 00:27:02.000000', 'consum', 0.0215, 'lps'),
	(672664, 133, '2015-02-01 00:27:03.000000', 'consum', 0.0220, 'lps'),
	(672665, 133, '2015-02-01 00:27:04.000000', 'consum', 0.0212, 'lps'),
	(672666, 133, '2015-02-01 00:27:05.000000', 'consum', 0.0211, 'lps'),
	(672667, 133, '2015-02-01 00:27:06.000000', 'consum', 0.0213, 'lps'),
	(672668, 133, '2015-02-01 00:27:07.000000', 'consum', 0.0221, 'lps'),
	(672669, 133, '2015-02-01 00:27:08.000000', 'consum', 0.0220, 'lps'),
	(672670, 133, '2015-02-01 00:27:09.000000', 'consum', 0.0214, 'lps'),
	(672671, 133, '2015-02-01 00:27:10.000000', 'consum', 0.0213, 'lps'),
	(672672, 133, '2015-02-01 00:27:11.000000', 'consum', 0.0212, 'lps'),
	(672673, 133, '2015-02-01 00:27:12.000000', 'consum', 0.0215, 'lps'),
	(672674, 133, '2015-02-01 00:27:13.000000', 'consum', 0.0215, 'lps'),
	(672675, 133, '2015-02-01 00:27:14.000000', 'consum', 0.0221, 'lps'),
	(672676, 133, '2015-02-01 00:27:15.000000', 'consum', 0.0216, 'lps'),
	(672677, 133, '2015-02-01 00:27:16.000000', 'consum', 0.0219, 'lps'),
	(672678, 133, '2015-02-01 00:27:17.000000', 'consum', 0.0211, 'lps'),
	(672679, 133, '2015-02-01 00:27:18.000000', 'consum', 0.0215, 'lps'),
	(672680, 133, '2015-02-01 00:27:19.000000', 'consum', 0.0219, 'lps'),
	(672681, 133, '2015-02-01 00:27:20.000000', 'consum', 0.0217, 'lps'),
	(672682, 133, '2015-02-01 00:27:21.000000', 'consum', 0.0220, 'lps'),
	(672683, 133, '2015-02-01 00:27:22.000000', 'consum', 0.0216, 'lps'),
	(672684, 133, '2015-02-01 00:27:23.000000', 'consum', 0.0221, 'lps'),
	(672685, 133, '2015-02-01 00:27:24.000000', 'consum', 0.0211, 'lps'),
	(672686, 133, '2015-02-01 00:27:25.000000', 'consum', 0.0218, 'lps'),
	(672687, 133, '2015-02-01 00:27:26.000000', 'consum', 0.0213, 'lps'),
	(672688, 133, '2015-02-01 00:27:27.000000', 'consum', 0.0215, 'lps'),
	(672689, 133, '2015-02-01 00:27:28.000000', 'consum', 0.0211, 'lps'),
	(672690, 133, '2015-02-01 00:27:29.000000', 'consum', 0.0215, 'lps'),
	(672691, 133, '2015-02-01 00:27:30.000000', 'consum', 0.0210, 'lps'),
	(672692, 133, '2015-02-01 00:27:31.000000', 'consum', 0.0217, 'lps'),
	(672693, 133, '2015-02-01 00:27:32.000000', 'consum', 0.0221, 'lps'),
	(672694, 133, '2015-02-01 00:27:33.000000', 'consum', 0.0210, 'lps'),
	(672695, 133, '2015-02-01 00:27:34.000000', 'consum', 0.0212, 'lps'),
	(672696, 133, '2015-02-01 00:27:35.000000', 'consum', 0.0211, 'lps'),
	(672697, 133, '2015-02-01 00:27:36.000000', 'consum', 0.0218, 'lps'),
	(672698, 133, '2015-02-01 00:27:37.000000', 'consum', 0.0215, 'lps'),
	(672699, 133, '2015-02-01 00:27:38.000000', 'consum', 0.0211, 'lps'),
	(672700, 133, '2015-02-01 00:27:39.000000', 'consum', 0.0210, 'lps'),
	(672701, 133, '2015-02-01 00:27:40.000000', 'consum', 0.0221, 'lps'),
	(672702, 133, '2015-02-01 00:27:41.000000', 'consum', 0.0218, 'lps'),
	(672703, 133, '2015-02-01 00:27:42.000000', 'consum', 0.0218, 'lps'),
	(672704, 133, '2015-02-01 00:27:43.000000', 'consum', 0.0216, 'lps'),
	(672705, 133, '2015-02-01 00:27:44.000000', 'consum', 0.0215, 'lps'),
	(672706, 133, '2015-02-01 00:27:45.000000', 'consum', 0.0216, 'lps'),
	(672707, 133, '2015-02-01 00:27:46.000000', 'consum', 0.0213, 'lps'),
	(672708, 133, '2015-02-01 00:27:47.000000', 'consum', 0.0221, 'lps'),
	(672709, 133, '2015-02-01 00:27:48.000000', 'consum', 0.0221, 'lps'),
	(672710, 133, '2015-02-01 00:27:49.000000', 'consum', 0.0219, 'lps'),
	(672711, 133, '2015-02-01 00:27:50.000000', 'consum', 0.0210, 'lps'),
	(672712, 133, '2015-02-01 00:27:51.000000', 'consum', 0.0210, 'lps'),
	(672713, 133, '2015-02-01 00:27:52.000000', 'consum', 0.0220, 'lps'),
	(672714, 133, '2015-02-01 00:27:53.000000', 'consum', 0.0213, 'lps'),
	(672715, 133, '2015-02-01 00:27:54.000000', 'consum', 0.0221, 'lps'),
	(672716, 133, '2015-02-01 00:27:55.000000', 'consum', 0.0221, 'lps'),
	(672717, 133, '2015-02-01 00:27:56.000000', 'consum', 0.0218, 'lps'),
	(672718, 133, '2015-02-01 00:27:57.000000', 'consum', 0.0218, 'lps'),
	(672719, 133, '2015-02-01 00:27:58.000000', 'consum', 0.0214, 'lps'),
	(672720, 133, '2015-02-01 00:27:59.000000', 'consum', 0.0219, 'lps'),
	(672721, 133, '2015-02-01 00:28:00.000000', 'consum', 0.0219, 'lps'),
	(672722, 133, '2015-02-01 00:28:01.000000', 'consum', 0.0217, 'lps'),
	(672723, 133, '2015-02-01 00:28:02.000000', 'consum', 0.0217, 'lps'),
	(672724, 133, '2015-02-01 00:28:03.000000', 'consum', 0.0213, 'lps'),
	(672725, 133, '2015-02-01 00:28:04.000000', 'consum', 0.0218, 'lps'),
	(672726, 133, '2015-02-01 00:28:05.000000', 'consum', 0.0217, 'lps'),
	(672727, 133, '2015-02-01 00:28:06.000000', 'consum', 0.0211, 'lps'),
	(672728, 133, '2015-02-01 00:28:07.000000', 'consum', 0.0217, 'lps'),
	(672729, 133, '2015-02-01 00:28:08.000000', 'consum', 0.0220, 'lps'),
	(672730, 133, '2015-02-01 00:28:09.000000', 'consum', 0.0215, 'lps'),
	(672731, 133, '2015-02-01 00:28:10.000000', 'consum', 0.0219, 'lps'),
	(672732, 133, '2015-02-01 00:28:11.000000', 'consum', 0.0217, 'lps'),
	(672733, 133, '2015-02-01 00:28:12.000000', 'consum', 0.0216, 'lps'),
	(672734, 133, '2015-02-01 00:28:13.000000', 'consum', 0.0210, 'lps'),
	(672735, 133, '2015-02-01 00:28:14.000000', 'consum', 0.0215, 'lps'),
	(672736, 133, '2015-02-01 00:28:15.000000', 'consum', 0.0213, 'lps'),
	(672737, 133, '2015-02-01 00:28:16.000000', 'consum', 0.0220, 'lps'),
	(672738, 133, '2015-02-01 00:28:17.000000', 'consum', 0.0218, 'lps'),
	(672739, 133, '2015-02-01 00:28:18.000000', 'consum', 0.0220, 'lps'),
	(672740, 133, '2015-02-01 00:28:19.000000', 'consum', 0.0214, 'lps'),
	(672741, 133, '2015-02-01 00:28:20.000000', 'consum', 0.0221, 'lps'),
	(672742, 133, '2015-02-01 00:28:21.000000', 'consum', 0.0220, 'lps'),
	(672743, 133, '2015-02-01 00:28:22.000000', 'consum', 0.0213, 'lps'),
	(672744, 133, '2015-02-01 00:28:23.000000', 'consum', 0.0221, 'lps'),
	(672745, 133, '2015-02-01 00:28:24.000000', 'consum', 0.0221, 'lps'),
	(672746, 133, '2015-02-01 00:28:25.000000', 'consum', 0.0220, 'lps'),
	(672747, 133, '2015-02-01 00:28:26.000000', 'consum', 0.0214, 'lps'),
	(672748, 133, '2015-02-01 00:28:27.000000', 'consum', 0.0216, 'lps'),
	(672749, 133, '2015-02-01 00:28:28.000000', 'consum', 0.0213, 'lps'),
	(672750, 133, '2015-02-01 00:28:29.000000', 'consum', 0.0210, 'lps'),
	(672751, 133, '2015-02-01 00:28:30.000000', 'consum', 0.0211, 'lps'),
	(672752, 133, '2015-02-01 00:28:31.000000', 'consum', 0.0217, 'lps'),
	(672753, 133, '2015-02-01 00:28:32.000000', 'consum', 0.0219, 'lps'),
	(672754, 133, '2015-02-01 00:28:33.000000', 'consum', 0.0212, 'lps'),
	(672755, 133, '2015-02-01 00:28:34.000000', 'consum', 0.0215, 'lps'),
	(672756, 133, '2015-02-01 00:28:35.000000', 'consum', 0.0220, 'lps'),
	(672757, 133, '2015-02-01 00:28:36.000000', 'consum', 0.0220, 'lps'),
	(672758, 133, '2015-02-01 00:28:37.000000', 'consum', 0.0217, 'lps'),
	(672759, 133, '2015-02-01 00:28:38.000000', 'consum', 0.0219, 'lps'),
	(672760, 133, '2015-02-01 00:28:39.000000', 'consum', 0.0220, 'lps'),
	(672761, 133, '2015-02-01 00:28:40.000000', 'consum', 0.0210, 'lps'),
	(672762, 133, '2015-02-01 00:28:41.000000', 'consum', 0.0218, 'lps'),
	(672763, 133, '2015-02-01 00:28:42.000000', 'consum', 0.0214, 'lps'),
	(672764, 133, '2015-02-01 00:28:43.000000', 'consum', 0.0216, 'lps'),
	(672765, 133, '2015-02-01 00:28:44.000000', 'consum', 0.0219, 'lps'),
	(672766, 133, '2015-02-01 00:28:45.000000', 'consum', 0.0213, 'lps'),
	(672767, 133, '2015-02-01 00:28:46.000000', 'consum', 0.0211, 'lps'),
	(672768, 133, '2015-02-01 00:28:47.000000', 'consum', 0.0216, 'lps'),
	(672769, 133, '2015-02-01 00:28:48.000000', 'consum', 0.0215, 'lps'),
	(672770, 133, '2015-02-01 00:28:49.000000', 'consum', 0.0217, 'lps'),
	(672771, 133, '2015-02-01 00:28:50.000000', 'consum', 0.0220, 'lps'),
	(672772, 133, '2015-02-01 00:28:51.000000', 'consum', 0.0216, 'lps'),
	(672773, 133, '2015-02-01 00:28:52.000000', 'consum', 0.0221, 'lps'),
	(672774, 133, '2015-02-01 00:28:53.000000', 'consum', 0.0213, 'lps'),
	(672775, 133, '2015-02-01 00:28:54.000000', 'consum', 0.0217, 'lps'),
	(672776, 133, '2015-02-01 00:28:55.000000', 'consum', 0.0211, 'lps'),
	(672777, 133, '2015-02-01 00:28:56.000000', 'consum', 0.0219, 'lps'),
	(672778, 133, '2015-02-01 00:28:57.000000', 'consum', 0.0219, 'lps'),
	(672779, 133, '2015-02-01 00:28:58.000000', 'consum', 0.0213, 'lps'),
	(672780, 133, '2015-02-01 00:28:59.000000', 'consum', 0.0210, 'lps'),
	(672781, 133, '2015-02-01 00:29:00.000000', 'consum', 0.0214, 'lps'),
	(672782, 133, '2015-02-01 00:29:01.000000', 'consum', 0.0220, 'lps'),
	(672783, 133, '2015-02-01 00:29:02.000000', 'consum', 0.0210, 'lps'),
	(672784, 133, '2015-02-01 00:29:03.000000', 'consum', 0.0217, 'lps'),
	(672785, 133, '2015-02-01 00:29:04.000000', 'consum', 0.0212, 'lps'),
	(672786, 133, '2015-02-01 00:29:05.000000', 'consum', 0.0221, 'lps'),
	(672787, 133, '2015-02-01 00:29:06.000000', 'consum', 0.0211, 'lps'),
	(672788, 133, '2015-02-01 00:29:07.000000', 'consum', 0.0219, 'lps'),
	(672789, 133, '2015-02-01 00:29:08.000000', 'consum', 0.0218, 'lps'),
	(672790, 133, '2015-02-01 00:29:09.000000', 'consum', 0.0210, 'lps'),
	(672791, 133, '2015-02-01 00:29:10.000000', 'consum', 0.0211, 'lps'),
	(672792, 133, '2015-02-01 00:29:11.000000', 'consum', 0.0216, 'lps'),
	(672793, 133, '2015-02-01 00:29:12.000000', 'consum', 0.0215, 'lps'),
	(672794, 133, '2015-02-01 00:29:13.000000', 'consum', 0.0215, 'lps'),
	(672795, 133, '2015-02-01 00:29:14.000000', 'consum', 0.0221, 'lps'),
	(672796, 133, '2015-02-01 00:29:15.000000', 'consum', 0.0214, 'lps'),
	(672797, 133, '2015-02-01 00:29:16.000000', 'consum', 0.0211, 'lps'),
	(672798, 133, '2015-02-01 00:29:17.000000', 'consum', 0.0214, 'lps'),
	(672799, 133, '2015-02-01 00:29:18.000000', 'consum', 0.0217, 'lps'),
	(672800, 133, '2015-02-01 00:29:19.000000', 'consum', 0.0219, 'lps'),
	(672801, 133, '2015-02-01 00:29:20.000000', 'consum', 0.0211, 'lps'),
	(672802, 133, '2015-02-01 00:29:21.000000', 'consum', 0.0213, 'lps'),
	(672803, 133, '2015-02-01 00:29:22.000000', 'consum', 0.0210, 'lps'),
	(672804, 133, '2015-02-01 00:29:23.000000', 'consum', 0.0213, 'lps'),
	(672805, 133, '2015-02-01 00:29:24.000000', 'consum', 0.0215, 'lps'),
	(672806, 133, '2015-02-01 00:29:25.000000', 'consum', 0.0216, 'lps'),
	(672807, 133, '2015-02-01 00:29:26.000000', 'consum', 0.0212, 'lps'),
	(672808, 133, '2015-02-01 00:29:27.000000', 'consum', 0.0214, 'lps'),
	(672809, 133, '2015-02-01 00:29:28.000000', 'consum', 0.0212, 'lps'),
	(672810, 133, '2015-02-01 00:29:29.000000', 'consum', 0.0220, 'lps'),
	(672811, 133, '2015-02-01 00:29:30.000000', 'consum', 0.0221, 'lps'),
	(672812, 133, '2015-02-01 00:29:31.000000', 'consum', 0.0210, 'lps'),
	(672813, 133, '2015-02-01 00:29:32.000000', 'consum', 0.0212, 'lps'),
	(672814, 133, '2015-02-01 00:29:33.000000', 'consum', 0.0221, 'lps'),
	(672815, 133, '2015-02-01 00:29:34.000000', 'consum', 0.0213, 'lps'),
	(672816, 133, '2015-02-01 00:29:35.000000', 'consum', 0.0216, 'lps'),
	(672817, 133, '2015-02-01 00:29:36.000000', 'consum', 0.0218, 'lps'),
	(672818, 133, '2015-02-01 00:29:37.000000', 'consum', 0.0211, 'lps'),
	(672819, 133, '2015-02-01 00:29:38.000000', 'consum', 0.0214, 'lps'),
	(672820, 133, '2015-02-01 00:29:39.000000', 'consum', 0.0218, 'lps'),
	(672821, 133, '2015-02-01 00:29:40.000000', 'consum', 0.0212, 'lps'),
	(672822, 133, '2015-02-01 00:29:41.000000', 'consum', 0.0210, 'lps'),
	(672823, 133, '2015-02-01 00:29:42.000000', 'consum', 0.0216, 'lps'),
	(672824, 133, '2015-02-01 00:29:43.000000', 'consum', 0.0216, 'lps'),
	(672825, 133, '2015-02-01 00:29:44.000000', 'consum', 0.0212, 'lps'),
	(672826, 133, '2015-02-01 00:29:45.000000', 'consum', 0.0215, 'lps'),
	(672827, 133, '2015-02-01 00:29:46.000000', 'consum', 0.0215, 'lps'),
	(672828, 133, '2015-02-01 00:29:47.000000', 'consum', 0.0212, 'lps'),
	(672829, 133, '2015-02-01 00:29:48.000000', 'consum', 0.0214, 'lps'),
	(672830, 133, '2015-02-01 00:29:49.000000', 'consum', 0.0213, 'lps'),
	(672831, 133, '2015-02-01 00:29:50.000000', 'consum', 0.0214, 'lps'),
	(672832, 133, '2015-02-01 00:29:51.000000', 'consum', 0.0220, 'lps'),
	(672833, 133, '2015-02-01 00:29:52.000000', 'consum', 0.0215, 'lps'),
	(672834, 133, '2015-02-01 00:29:53.000000', 'consum', 0.0216, 'lps'),
	(672835, 133, '2015-02-01 00:29:54.000000', 'consum', 0.0215, 'lps'),
	(672836, 133, '2015-02-01 00:29:55.000000', 'consum', 0.0217, 'lps'),
	(672837, 133, '2015-02-01 00:29:56.000000', 'consum', 0.0217, 'lps'),
	(672838, 133, '2015-02-01 00:29:57.000000', 'consum', 0.0213, 'lps'),
	(672839, 133, '2015-02-01 00:29:58.000000', 'consum', 0.0217, 'lps'),
	(672840, 133, '2015-02-01 00:29:59.000000', 'consum', 0.0212, 'lps'),
	(672841, 133, '2015-02-01 00:30:00.000000', 'consum', 0.0211, 'lps'),
	(672842, 133, '2015-02-01 00:30:01.000000', 'consum', 0.0211, 'lps'),
	(672843, 133, '2015-02-01 00:30:02.000000', 'consum', 0.0213, 'lps'),
	(672844, 133, '2015-02-01 00:30:03.000000', 'consum', 0.0212, 'lps'),
	(672845, 133, '2015-02-01 00:30:04.000000', 'consum', 0.0221, 'lps'),
	(672846, 133, '2015-02-01 00:30:05.000000', 'consum', 0.0211, 'lps'),
	(672847, 133, '2015-02-01 00:30:06.000000', 'consum', 0.0220, 'lps'),
	(672848, 133, '2015-02-01 00:30:07.000000', 'consum', 0.0210, 'lps'),
	(672849, 133, '2015-02-01 00:30:08.000000', 'consum', 0.0218, 'lps'),
	(672850, 133, '2015-02-01 00:30:09.000000', 'consum', 0.0213, 'lps'),
	(672851, 133, '2015-02-01 00:30:10.000000', 'consum', 0.0212, 'lps'),
	(672852, 133, '2015-02-01 00:30:11.000000', 'consum', 0.0213, 'lps'),
	(672853, 133, '2015-02-01 00:30:12.000000', 'consum', 0.0218, 'lps'),
	(672854, 133, '2015-02-01 00:30:13.000000', 'consum', 0.0217, 'lps'),
	(672855, 133, '2015-02-01 00:30:14.000000', 'consum', 0.0221, 'lps'),
	(672856, 133, '2015-02-01 00:30:15.000000', 'consum', 0.0211, 'lps'),
	(672857, 133, '2015-02-01 00:30:16.000000', 'consum', 0.0219, 'lps'),
	(672858, 133, '2015-02-01 00:30:17.000000', 'consum', 0.0214, 'lps'),
	(672859, 133, '2015-02-01 00:30:18.000000', 'consum', 0.0217, 'lps'),
	(672860, 133, '2015-02-01 00:30:19.000000', 'consum', 0.0220, 'lps'),
	(672861, 133, '2015-02-01 00:30:20.000000', 'consum', 0.0218, 'lps'),
	(672862, 133, '2015-02-01 00:30:21.000000', 'consum', 0.0220, 'lps'),
	(672863, 133, '2015-02-01 00:30:22.000000', 'consum', 0.0214, 'lps'),
	(672864, 133, '2015-02-01 00:30:23.000000', 'consum', 0.0211, 'lps'),
	(672865, 133, '2015-02-01 00:30:24.000000', 'consum', 0.0215, 'lps'),
	(672866, 133, '2015-02-01 00:30:25.000000', 'consum', 0.0210, 'lps'),
	(672867, 133, '2015-02-01 00:30:26.000000', 'consum', 0.0221, 'lps'),
	(672868, 133, '2015-02-01 00:30:27.000000', 'consum', 0.0214, 'lps'),
	(672869, 133, '2015-02-01 00:30:28.000000', 'consum', 0.0212, 'lps'),
	(672870, 133, '2015-02-01 00:30:29.000000', 'consum', 0.0221, 'lps'),
	(672871, 133, '2015-02-01 00:30:30.000000', 'consum', 0.0221, 'lps'),
	(672872, 133, '2015-02-01 00:30:31.000000', 'consum', 0.0210, 'lps'),
	(672873, 133, '2015-02-01 00:30:32.000000', 'consum', 0.0212, 'lps'),
	(672874, 133, '2015-02-01 00:30:33.000000', 'consum', 0.0221, 'lps'),
	(672875, 133, '2015-02-01 00:30:34.000000', 'consum', 0.0212, 'lps'),
	(672876, 133, '2015-02-01 00:30:35.000000', 'consum', 0.0211, 'lps'),
	(672877, 133, '2015-02-01 00:30:36.000000', 'consum', 0.0220, 'lps'),
	(672878, 133, '2015-02-01 00:30:37.000000', 'consum', 0.0221, 'lps'),
	(672879, 133, '2015-02-01 00:30:38.000000', 'consum', 0.0213, 'lps'),
	(672880, 133, '2015-02-01 00:30:39.000000', 'consum', 0.0215, 'lps'),
	(672881, 133, '2015-02-01 00:30:40.000000', 'consum', 0.0216, 'lps'),
	(672882, 133, '2015-02-01 00:30:41.000000', 'consum', 0.0213, 'lps'),
	(672883, 133, '2015-02-01 00:30:42.000000', 'consum', 0.0218, 'lps'),
	(672884, 133, '2015-02-01 00:30:43.000000', 'consum', 0.0217, 'lps'),
	(672885, 133, '2015-02-01 00:30:44.000000', 'consum', 0.0210, 'lps'),
	(672886, 133, '2015-02-01 00:30:45.000000', 'consum', 0.0216, 'lps'),
	(672887, 133, '2015-02-01 00:30:46.000000', 'consum', 0.0214, 'lps'),
	(672888, 133, '2015-02-01 00:30:47.000000', 'consum', 0.0211, 'lps'),
	(672889, 133, '2015-02-01 00:30:48.000000', 'consum', 0.0219, 'lps'),
	(672890, 133, '2015-02-01 00:30:49.000000', 'consum', 0.0215, 'lps'),
	(672891, 133, '2015-02-01 00:30:50.000000', 'consum', 0.0210, 'lps'),
	(672892, 133, '2015-02-01 00:30:51.000000', 'consum', 0.0217, 'lps'),
	(672893, 133, '2015-02-01 00:30:52.000000', 'consum', 0.0210, 'lps'),
	(672894, 133, '2015-02-01 00:30:53.000000', 'consum', 0.0215, 'lps'),
	(672895, 133, '2015-02-01 00:30:54.000000', 'consum', 0.0210, 'lps'),
	(672896, 133, '2015-02-01 00:30:55.000000', 'consum', 0.0221, 'lps'),
	(672897, 133, '2015-02-01 00:30:56.000000', 'consum', 0.0217, 'lps'),
	(672898, 133, '2015-02-01 00:30:57.000000', 'consum', 0.0214, 'lps'),
	(672899, 133, '2015-02-01 00:30:58.000000', 'consum', 0.0219, 'lps'),
	(672900, 133, '2015-02-01 00:30:59.000000', 'consum', 0.0220, 'lps'),
	(672901, 133, '2015-02-01 00:31:00.000000', 'consum', 0.0221, 'lps'),
	(672902, 133, '2015-02-01 00:31:01.000000', 'consum', 0.0212, 'lps'),
	(672903, 133, '2015-02-01 00:31:02.000000', 'consum', 0.0213, 'lps'),
	(672904, 133, '2015-02-01 00:31:03.000000', 'consum', 0.0217, 'lps'),
	(672905, 133, '2015-02-01 00:31:04.000000', 'consum', 0.0213, 'lps'),
	(672906, 133, '2015-02-01 00:31:05.000000', 'consum', 0.0217, 'lps'),
	(672907, 133, '2015-02-01 00:31:06.000000', 'consum', 0.0212, 'lps'),
	(672908, 133, '2015-02-01 00:31:07.000000', 'consum', 0.0212, 'lps'),
	(672909, 133, '2015-02-01 00:31:08.000000', 'consum', 0.0215, 'lps'),
	(672910, 133, '2015-02-01 00:31:09.000000', 'consum', 0.0217, 'lps'),
	(672911, 133, '2015-02-01 00:31:10.000000', 'consum', 0.0218, 'lps'),
	(672912, 133, '2015-02-01 00:31:11.000000', 'consum', 0.0216, 'lps'),
	(672913, 133, '2015-02-01 00:31:12.000000', 'consum', 0.0218, 'lps'),
	(672914, 133, '2015-02-01 00:31:13.000000', 'consum', 0.0218, 'lps'),
	(672915, 133, '2015-02-01 00:31:14.000000', 'consum', 0.0218, 'lps'),
	(672916, 133, '2015-02-01 00:31:15.000000', 'consum', 0.0211, 'lps'),
	(672917, 133, '2015-02-01 00:31:16.000000', 'consum', 0.0218, 'lps'),
	(672918, 133, '2015-02-01 00:31:17.000000', 'consum', 0.0212, 'lps'),
	(672919, 133, '2015-02-01 00:31:18.000000', 'consum', 0.0219, 'lps'),
	(672920, 133, '2015-02-01 00:31:19.000000', 'consum', 0.0212, 'lps'),
	(672921, 133, '2015-02-01 00:31:20.000000', 'consum', 0.0219, 'lps'),
	(672922, 133, '2015-02-01 00:31:21.000000', 'consum', 0.0215, 'lps'),
	(672923, 133, '2015-02-01 00:31:22.000000', 'consum', 0.0221, 'lps'),
	(672924, 133, '2015-02-01 00:31:23.000000', 'consum', 0.0215, 'lps'),
	(672925, 133, '2015-02-01 00:31:24.000000', 'consum', 0.0212, 'lps'),
	(672926, 133, '2015-02-01 00:31:25.000000', 'consum', 0.0220, 'lps'),
	(672927, 133, '2015-02-01 00:31:26.000000', 'consum', 0.0218, 'lps'),
	(672928, 133, '2015-02-01 00:31:27.000000', 'consum', 0.0210, 'lps'),
	(672929, 133, '2015-02-01 00:31:28.000000', 'consum', 0.0219, 'lps'),
	(672930, 133, '2015-02-01 00:31:29.000000', 'consum', 0.0210, 'lps'),
	(672931, 133, '2015-02-01 00:31:30.000000', 'consum', 0.0219, 'lps'),
	(672932, 133, '2015-02-01 00:31:31.000000', 'consum', 0.0220, 'lps'),
	(672933, 133, '2015-02-01 00:31:32.000000', 'consum', 0.0220, 'lps'),
	(672934, 133, '2015-02-01 00:31:33.000000', 'consum', 0.0220, 'lps'),
	(672935, 133, '2015-02-01 00:31:34.000000', 'consum', 0.0220, 'lps'),
	(672936, 133, '2015-02-01 00:31:35.000000', 'consum', 0.0216, 'lps'),
	(672937, 133, '2015-02-01 00:31:36.000000', 'consum', 0.0213, 'lps'),
	(672938, 133, '2015-02-01 00:31:37.000000', 'consum', 0.0218, 'lps'),
	(672939, 133, '2015-02-01 00:31:38.000000', 'consum', 0.0216, 'lps'),
	(672940, 133, '2015-02-01 00:31:39.000000', 'consum', 0.0219, 'lps'),
	(672941, 133, '2015-02-01 00:31:40.000000', 'consum', 0.0214, 'lps'),
	(672942, 133, '2015-02-01 00:31:41.000000', 'consum', 0.0216, 'lps'),
	(672943, 133, '2015-02-01 00:31:42.000000', 'consum', 0.0215, 'lps'),
	(672944, 133, '2015-02-01 00:31:43.000000', 'consum', 0.0216, 'lps'),
	(672945, 133, '2015-02-01 00:31:44.000000', 'consum', 0.0216, 'lps'),
	(672946, 133, '2015-02-01 00:31:45.000000', 'consum', 0.0220, 'lps'),
	(672947, 133, '2015-02-01 00:31:46.000000', 'consum', 0.0219, 'lps'),
	(672948, 133, '2015-02-01 00:31:47.000000', 'consum', 0.0216, 'lps'),
	(672949, 133, '2015-02-01 00:31:48.000000', 'consum', 0.0212, 'lps'),
	(672950, 133, '2015-02-01 00:31:49.000000', 'consum', 0.0216, 'lps'),
	(672951, 133, '2015-02-01 00:31:50.000000', 'consum', 0.0221, 'lps'),
	(672952, 133, '2015-02-01 00:31:51.000000', 'consum', 0.0211, 'lps'),
	(672953, 133, '2015-02-01 00:31:52.000000', 'consum', 0.0221, 'lps'),
	(672954, 133, '2015-02-01 00:31:53.000000', 'consum', 0.0214, 'lps'),
	(672955, 133, '2015-02-01 00:31:54.000000', 'consum', 0.0210, 'lps'),
	(672956, 133, '2015-02-01 00:31:55.000000', 'consum', 0.0220, 'lps'),
	(672957, 133, '2015-02-01 00:31:56.000000', 'consum', 0.0214, 'lps'),
	(672958, 133, '2015-02-01 00:31:57.000000', 'consum', 0.0212, 'lps'),
	(672959, 133, '2015-02-01 00:31:58.000000', 'consum', 0.0219, 'lps'),
	(672960, 133, '2015-02-01 00:31:59.000000', 'consum', 0.0216, 'lps'),
	(672961, 133, '2015-02-01 00:32:00.000000', 'consum', 0.0211, 'lps'),
	(672962, 133, '2015-02-01 00:32:01.000000', 'consum', 0.0211, 'lps'),
	(672963, 133, '2015-02-01 00:32:02.000000', 'consum', 0.0211, 'lps'),
	(672964, 133, '2015-02-01 00:32:03.000000', 'consum', 0.0213, 'lps'),
	(672965, 133, '2015-02-01 00:32:04.000000', 'consum', 0.0210, 'lps'),
	(672966, 133, '2015-02-01 00:32:05.000000', 'consum', 0.0215, 'lps'),
	(672967, 133, '2015-02-01 00:32:06.000000', 'consum', 0.0212, 'lps'),
	(672968, 133, '2015-02-01 00:32:07.000000', 'consum', 0.0215, 'lps'),
	(672969, 133, '2015-02-01 00:32:08.000000', 'consum', 0.0217, 'lps'),
	(672970, 133, '2015-02-01 00:32:09.000000', 'consum', 0.0219, 'lps'),
	(672971, 133, '2015-02-01 00:32:10.000000', 'consum', 0.0213, 'lps'),
	(672972, 133, '2015-02-01 00:32:11.000000', 'consum', 0.0219, 'lps'),
	(672973, 133, '2015-02-01 00:32:12.000000', 'consum', 0.0213, 'lps'),
	(672974, 133, '2015-02-01 00:32:13.000000', 'consum', 0.0221, 'lps'),
	(672975, 133, '2015-02-01 00:32:14.000000', 'consum', 0.0221, 'lps'),
	(672976, 133, '2015-02-01 00:32:15.000000', 'consum', 0.0221, 'lps'),
	(672977, 133, '2015-02-01 00:32:16.000000', 'consum', 0.0221, 'lps'),
	(672978, 133, '2015-02-01 00:32:17.000000', 'consum', 0.0210, 'lps'),
	(672979, 133, '2015-02-01 00:32:18.000000', 'consum', 0.0210, 'lps'),
	(672980, 133, '2015-02-01 00:32:19.000000', 'consum', 0.0212, 'lps'),
	(672981, 133, '2015-02-01 00:32:20.000000', 'consum', 0.0219, 'lps'),
	(672982, 133, '2015-02-01 00:32:21.000000', 'consum', 0.0216, 'lps'),
	(672983, 133, '2015-02-01 00:32:22.000000', 'consum', 0.0215, 'lps'),
	(672984, 133, '2015-02-01 00:32:23.000000', 'consum', 0.0214, 'lps'),
	(672985, 133, '2015-02-01 00:32:24.000000', 'consum', 0.0215, 'lps'),
	(672986, 133, '2015-02-01 00:32:25.000000', 'consum', 0.0213, 'lps'),
	(672987, 133, '2015-02-01 00:32:26.000000', 'consum', 0.0212, 'lps'),
	(672988, 133, '2015-02-01 00:32:27.000000', 'consum', 0.0210, 'lps'),
	(672989, 133, '2015-02-01 00:32:28.000000', 'consum', 0.0215, 'lps'),
	(672990, 133, '2015-02-01 00:32:29.000000', 'consum', 0.0211, 'lps'),
	(672991, 133, '2015-02-01 00:32:30.000000', 'consum', 0.0215, 'lps'),
	(672992, 133, '2015-02-01 00:32:31.000000', 'consum', 0.0218, 'lps'),
	(672993, 133, '2015-02-01 00:32:32.000000', 'consum', 0.0211, 'lps'),
	(672994, 133, '2015-02-01 00:32:33.000000', 'consum', 0.0218, 'lps'),
	(672995, 133, '2015-02-01 00:32:34.000000', 'consum', 0.0210, 'lps'),
	(672996, 133, '2015-02-01 00:32:35.000000', 'consum', 0.0221, 'lps'),
	(672997, 133, '2015-02-01 00:32:36.000000', 'consum', 0.0221, 'lps'),
	(672998, 133, '2015-02-01 00:32:37.000000', 'consum', 0.0218, 'lps'),
	(672999, 133, '2015-02-01 00:32:38.000000', 'consum', 0.0220, 'lps'),
	(673000, 133, '2015-02-01 00:32:39.000000', 'consum', 0.0212, 'lps'),
	(673001, 133, '2015-02-01 00:32:40.000000', 'consum', 0.0215, 'lps'),
	(673002, 133, '2015-02-01 00:32:41.000000', 'consum', 0.0217, 'lps'),
	(673003, 133, '2015-02-01 00:32:42.000000', 'consum', 0.0219, 'lps'),
	(673004, 133, '2015-02-01 00:32:43.000000', 'consum', 0.0211, 'lps'),
	(673005, 133, '2015-02-01 00:32:44.000000', 'consum', 0.0210, 'lps'),
	(673006, 133, '2015-02-01 00:32:45.000000', 'consum', 0.0210, 'lps'),
	(673007, 133, '2015-02-01 00:32:46.000000', 'consum', 0.0212, 'lps'),
	(673008, 133, '2015-02-01 00:32:47.000000', 'consum', 0.0217, 'lps'),
	(673009, 133, '2015-02-01 00:32:48.000000', 'consum', 0.0217, 'lps'),
	(673010, 133, '2015-02-01 00:32:49.000000', 'consum', 0.0211, 'lps'),
	(673011, 133, '2015-02-01 00:32:50.000000', 'consum', 0.0219, 'lps'),
	(673012, 133, '2015-02-01 00:32:51.000000', 'consum', 0.0218, 'lps'),
	(673013, 133, '2015-02-01 00:32:52.000000', 'consum', 0.0212, 'lps'),
	(673014, 133, '2015-02-01 00:32:53.000000', 'consum', 0.0220, 'lps'),
	(673015, 133, '2015-02-01 00:32:54.000000', 'consum', 0.0220, 'lps'),
	(673016, 133, '2015-02-01 00:32:55.000000', 'consum', 0.0216, 'lps'),
	(673017, 133, '2015-02-01 00:32:56.000000', 'consum', 0.0212, 'lps'),
	(673018, 133, '2015-02-01 00:32:57.000000', 'consum', 0.0214, 'lps'),
	(673019, 133, '2015-02-01 00:32:58.000000', 'consum', 0.0213, 'lps'),
	(673020, 133, '2015-02-01 00:32:59.000000', 'consum', 0.0214, 'lps'),
	(673021, 133, '2015-02-01 00:33:00.000000', 'consum', 0.0221, 'lps'),
	(673022, 133, '2015-02-01 00:33:01.000000', 'consum', 0.0215, 'lps'),
	(673023, 133, '2015-02-01 00:33:02.000000', 'consum', 0.0218, 'lps'),
	(673024, 133, '2015-02-01 00:33:03.000000', 'consum', 0.0220, 'lps'),
	(673025, 133, '2015-02-01 00:33:04.000000', 'consum', 0.0215, 'lps'),
	(673026, 133, '2015-02-01 00:33:05.000000', 'consum', 0.0215, 'lps'),
	(673027, 133, '2015-02-01 00:33:06.000000', 'consum', 0.0211, 'lps'),
	(673028, 133, '2015-02-01 00:33:07.000000', 'consum', 0.0212, 'lps'),
	(673029, 133, '2015-02-01 00:33:08.000000', 'consum', 0.0217, 'lps'),
	(673030, 133, '2015-02-01 00:33:09.000000', 'consum', 0.0216, 'lps'),
	(673031, 133, '2015-02-01 00:33:10.000000', 'consum', 0.0221, 'lps'),
	(673032, 133, '2015-02-01 00:33:11.000000', 'consum', 0.0211, 'lps'),
	(673033, 133, '2015-02-01 00:33:12.000000', 'consum', 0.0220, 'lps'),
	(673034, 133, '2015-02-01 00:33:13.000000', 'consum', 0.0219, 'lps'),
	(673035, 133, '2015-02-01 00:33:14.000000', 'consum', 0.0213, 'lps'),
	(673036, 133, '2015-02-01 00:33:15.000000', 'consum', 0.0212, 'lps'),
	(673037, 133, '2015-02-01 00:33:16.000000', 'consum', 0.0213, 'lps'),
	(673038, 133, '2015-02-01 00:33:17.000000', 'consum', 0.0216, 'lps'),
	(673039, 133, '2015-02-01 00:33:18.000000', 'consum', 0.0221, 'lps'),
	(673040, 133, '2015-02-01 00:33:19.000000', 'consum', 0.0213, 'lps'),
	(673041, 133, '2015-02-01 00:33:20.000000', 'consum', 0.0216, 'lps'),
	(673042, 133, '2015-02-01 00:33:21.000000', 'consum', 0.0219, 'lps'),
	(673043, 133, '2015-02-01 00:33:22.000000', 'consum', 0.0214, 'lps'),
	(673044, 133, '2015-02-01 00:33:23.000000', 'consum', 0.0217, 'lps'),
	(673045, 133, '2015-02-01 00:33:24.000000', 'consum', 0.0221, 'lps'),
	(673046, 133, '2015-02-01 00:33:25.000000', 'consum', 0.0218, 'lps'),
	(673047, 133, '2015-02-01 00:33:26.000000', 'consum', 0.0220, 'lps'),
	(673048, 133, '2015-02-01 00:33:27.000000', 'consum', 0.0211, 'lps'),
	(673049, 133, '2015-02-01 00:33:28.000000', 'consum', 0.0210, 'lps'),
	(673050, 133, '2015-02-01 00:33:29.000000', 'consum', 0.0220, 'lps'),
	(673051, 133, '2015-02-01 00:33:30.000000', 'consum', 0.0213, 'lps'),
	(673052, 133, '2015-02-01 00:33:31.000000', 'consum', 0.0218, 'lps'),
	(673053, 133, '2015-02-01 00:33:32.000000', 'consum', 0.0219, 'lps'),
	(673054, 133, '2015-02-01 00:33:33.000000', 'consum', 0.0217, 'lps'),
	(673055, 133, '2015-02-01 00:33:34.000000', 'consum', 0.0210, 'lps'),
	(673056, 133, '2015-02-01 00:33:35.000000', 'consum', 0.0210, 'lps'),
	(673057, 133, '2015-02-01 00:33:36.000000', 'consum', 0.0211, 'lps'),
	(673058, 133, '2015-02-01 00:33:37.000000', 'consum', 0.0218, 'lps'),
	(673059, 133, '2015-02-01 00:33:38.000000', 'consum', 0.0221, 'lps'),
	(673060, 133, '2015-02-01 00:33:39.000000', 'consum', 0.0217, 'lps'),
	(673061, 133, '2015-02-01 00:33:40.000000', 'consum', 0.0212, 'lps'),
	(673062, 133, '2015-02-01 00:33:41.000000', 'consum', 0.0213, 'lps'),
	(673063, 133, '2015-02-01 00:33:42.000000', 'consum', 0.0221, 'lps'),
	(673064, 133, '2015-02-01 00:33:43.000000', 'consum', 0.0219, 'lps'),
	(673065, 133, '2015-02-01 00:33:44.000000', 'consum', 0.0212, 'lps'),
	(673066, 133, '2015-02-01 00:33:45.000000', 'consum', 0.0214, 'lps'),
	(673067, 133, '2015-02-01 00:33:46.000000', 'consum', 0.0216, 'lps'),
	(673068, 133, '2015-02-01 00:33:47.000000', 'consum', 0.0216, 'lps'),
	(673069, 133, '2015-02-01 00:33:48.000000', 'consum', 0.0211, 'lps'),
	(673070, 133, '2015-02-01 00:33:49.000000', 'consum', 0.0219, 'lps'),
	(673071, 133, '2015-02-01 00:33:50.000000', 'consum', 0.0218, 'lps'),
	(673072, 133, '2015-02-01 00:33:51.000000', 'consum', 0.0211, 'lps'),
	(673073, 133, '2015-02-01 00:33:52.000000', 'consum', 0.0214, 'lps'),
	(673074, 133, '2015-02-01 00:33:53.000000', 'consum', 0.0215, 'lps'),
	(673075, 133, '2015-02-01 00:33:54.000000', 'consum', 0.0213, 'lps'),
	(673076, 133, '2015-02-01 00:33:55.000000', 'consum', 0.0220, 'lps'),
	(673077, 133, '2015-02-01 00:33:56.000000', 'consum', 0.0218, 'lps'),
	(673078, 133, '2015-02-01 00:33:57.000000', 'consum', 0.0220, 'lps'),
	(673079, 133, '2015-02-01 00:33:58.000000', 'consum', 0.0212, 'lps'),
	(673080, 133, '2015-02-01 00:33:59.000000', 'consum', 0.0215, 'lps'),
	(673081, 133, '2015-02-01 00:34:00.000000', 'consum', 0.0217, 'lps'),
	(673082, 133, '2015-02-01 00:34:01.000000', 'consum', 0.0219, 'lps'),
	(673083, 133, '2015-02-01 00:34:02.000000', 'consum', 0.0212, 'lps'),
	(673084, 133, '2015-02-01 00:34:03.000000', 'consum', 0.0216, 'lps'),
	(673085, 133, '2015-02-01 00:34:04.000000', 'consum', 0.0221, 'lps'),
	(673086, 133, '2015-02-01 00:34:05.000000', 'consum', 0.0212, 'lps'),
	(673087, 133, '2015-02-01 00:34:06.000000', 'consum', 0.0213, 'lps'),
	(673088, 133, '2015-02-01 00:34:07.000000', 'consum', 0.0217, 'lps'),
	(673089, 133, '2015-02-01 00:34:08.000000', 'consum', 0.0214, 'lps'),
	(673090, 133, '2015-02-01 00:34:09.000000', 'consum', 0.0221, 'lps'),
	(673091, 133, '2015-02-01 00:34:10.000000', 'consum', 0.0219, 'lps'),
	(673092, 133, '2015-02-01 00:34:11.000000', 'consum', 0.0221, 'lps'),
	(673093, 133, '2015-02-01 00:34:12.000000', 'consum', 0.0213, 'lps'),
	(673094, 133, '2015-02-01 00:34:13.000000', 'consum', 0.0218, 'lps'),
	(673095, 133, '2015-02-01 00:34:14.000000', 'consum', 0.0218, 'lps'),
	(673096, 133, '2015-02-01 00:34:15.000000', 'consum', 0.0214, 'lps'),
	(673097, 133, '2015-02-01 00:34:16.000000', 'consum', 0.0220, 'lps'),
	(673098, 133, '2015-02-01 00:34:17.000000', 'consum', 0.0213, 'lps'),
	(673099, 133, '2015-02-01 00:34:18.000000', 'consum', 0.0219, 'lps'),
	(673100, 133, '2015-02-01 00:34:19.000000', 'consum', 0.0210, 'lps'),
	(673101, 133, '2015-02-01 00:34:20.000000', 'consum', 0.0220, 'lps'),
	(673102, 133, '2015-02-01 00:34:21.000000', 'consum', 0.0211, 'lps'),
	(673103, 133, '2015-02-01 00:34:22.000000', 'consum', 0.0212, 'lps'),
	(673104, 133, '2015-02-01 00:34:23.000000', 'consum', 0.0216, 'lps'),
	(673105, 133, '2015-02-01 00:34:24.000000', 'consum', 0.0210, 'lps'),
	(673106, 133, '2015-02-01 00:34:25.000000', 'consum', 0.0216, 'lps'),
	(673107, 133, '2015-02-01 00:34:26.000000', 'consum', 0.0217, 'lps'),
	(673108, 133, '2015-02-01 00:34:27.000000', 'consum', 0.0216, 'lps'),
	(673109, 133, '2015-02-01 00:34:28.000000', 'consum', 0.0218, 'lps'),
	(673110, 133, '2015-02-01 00:34:29.000000', 'consum', 0.0211, 'lps'),
	(673111, 133, '2015-02-01 00:34:30.000000', 'consum', 0.0213, 'lps'),
	(673112, 133, '2015-02-01 00:34:31.000000', 'consum', 0.0212, 'lps'),
	(673113, 133, '2015-02-01 00:34:32.000000', 'consum', 0.0212, 'lps'),
	(673114, 133, '2015-02-01 00:34:33.000000', 'consum', 0.0215, 'lps'),
	(673115, 133, '2015-02-01 00:34:34.000000', 'consum', 0.0217, 'lps'),
	(673116, 133, '2015-02-01 00:34:35.000000', 'consum', 0.0217, 'lps'),
	(673117, 133, '2015-02-01 00:34:36.000000', 'consum', 0.0212, 'lps'),
	(673118, 133, '2015-02-01 00:34:37.000000', 'consum', 0.0212, 'lps'),
	(673119, 133, '2015-02-01 00:34:38.000000', 'consum', 0.0214, 'lps'),
	(673120, 133, '2015-02-01 00:34:39.000000', 'consum', 0.0214, 'lps'),
	(673121, 133, '2015-02-01 00:34:40.000000', 'consum', 0.0217, 'lps'),
	(673122, 133, '2015-02-01 00:34:41.000000', 'consum', 0.0210, 'lps'),
	(673123, 133, '2015-02-01 00:34:42.000000', 'consum', 0.0216, 'lps'),
	(673124, 133, '2015-02-01 00:34:43.000000', 'consum', 0.0213, 'lps'),
	(673125, 133, '2015-02-01 00:34:44.000000', 'consum', 0.0220, 'lps'),
	(673126, 133, '2015-02-01 00:34:45.000000', 'consum', 0.0214, 'lps'),
	(673127, 133, '2015-02-01 00:34:46.000000', 'consum', 0.0214, 'lps'),
	(673128, 133, '2015-02-01 00:34:47.000000', 'consum', 0.0217, 'lps'),
	(673129, 133, '2015-02-01 00:34:48.000000', 'consum', 0.0210, 'lps'),
	(673130, 133, '2015-02-01 00:34:49.000000', 'consum', 0.0215, 'lps'),
	(673131, 133, '2015-02-01 00:34:50.000000', 'consum', 0.0210, 'lps'),
	(673132, 133, '2015-02-01 00:34:51.000000', 'consum', 0.0221, 'lps'),
	(673133, 133, '2015-02-01 00:34:52.000000', 'consum', 0.0216, 'lps'),
	(673134, 133, '2015-02-01 00:34:53.000000', 'consum', 0.0221, 'lps'),
	(673135, 133, '2015-02-01 00:34:54.000000', 'consum', 0.0212, 'lps'),
	(673136, 133, '2015-02-01 00:34:55.000000', 'consum', 0.0210, 'lps'),
	(673137, 133, '2015-02-01 00:34:56.000000', 'consum', 0.0217, 'lps'),
	(673138, 133, '2015-02-01 00:34:57.000000', 'consum', 0.0219, 'lps'),
	(673139, 133, '2015-02-01 00:34:58.000000', 'consum', 0.0214, 'lps'),
	(673140, 133, '2015-02-01 00:34:59.000000', 'consum', 0.0215, 'lps'),
	(673141, 133, '2015-02-01 00:35:00.000000', 'consum', 0.0210, 'lps'),
	(673142, 133, '2015-02-01 00:35:01.000000', 'consum', 0.0210, 'lps'),
	(673143, 133, '2015-02-01 00:35:02.000000', 'consum', 0.0220, 'lps'),
	(673144, 133, '2015-02-01 00:35:03.000000', 'consum', 0.0214, 'lps'),
	(673145, 133, '2015-02-01 00:35:04.000000', 'consum', 0.0210, 'lps'),
	(673146, 133, '2015-02-01 00:35:05.000000', 'consum', 0.0214, 'lps'),
	(673147, 133, '2015-02-01 00:35:06.000000', 'consum', 0.0217, 'lps'),
	(673148, 133, '2015-02-01 00:35:07.000000', 'consum', 0.0221, 'lps'),
	(673149, 133, '2015-02-01 00:35:08.000000', 'consum', 0.0219, 'lps'),
	(673150, 133, '2015-02-01 00:35:09.000000', 'consum', 0.0213, 'lps'),
	(673151, 133, '2015-02-01 00:35:10.000000', 'consum', 0.0210, 'lps'),
	(673152, 133, '2015-02-01 00:35:11.000000', 'consum', 0.0214, 'lps'),
	(673153, 133, '2015-02-01 00:35:12.000000', 'consum', 0.0216, 'lps'),
	(673154, 133, '2015-02-01 00:35:13.000000', 'consum', 0.0220, 'lps'),
	(673155, 133, '2015-02-01 00:35:14.000000', 'consum', 0.0215, 'lps'),
	(673156, 133, '2015-02-01 00:35:15.000000', 'consum', 0.0220, 'lps'),
	(673157, 133, '2015-02-01 00:35:16.000000', 'consum', 0.0220, 'lps'),
	(673158, 133, '2015-02-01 00:35:17.000000', 'consum', 0.0219, 'lps'),
	(673159, 133, '2015-02-01 00:35:18.000000', 'consum', 0.0215, 'lps'),
	(673160, 133, '2015-02-01 00:35:19.000000', 'consum', 0.0221, 'lps'),
	(673161, 133, '2015-02-01 00:35:20.000000', 'consum', 0.0215, 'lps'),
	(673162, 133, '2015-02-01 00:35:21.000000', 'consum', 0.0214, 'lps'),
	(673163, 133, '2015-02-01 00:35:22.000000', 'consum', 0.0216, 'lps'),
	(673164, 133, '2015-02-01 00:35:23.000000', 'consum', 0.0218, 'lps'),
	(673165, 133, '2015-02-01 00:35:24.000000', 'consum', 0.0219, 'lps'),
	(673166, 133, '2015-02-01 00:35:25.000000', 'consum', 0.0218, 'lps'),
	(673167, 133, '2015-02-01 00:35:26.000000', 'consum', 0.0213, 'lps'),
	(673168, 133, '2015-02-01 00:35:27.000000', 'consum', 0.0213, 'lps'),
	(673169, 133, '2015-02-01 00:35:28.000000', 'consum', 0.0215, 'lps'),
	(673170, 133, '2015-02-01 00:35:29.000000', 'consum', 0.0215, 'lps'),
	(673171, 133, '2015-02-01 00:35:30.000000', 'consum', 0.0219, 'lps'),
	(673172, 133, '2015-02-01 00:35:31.000000', 'consum', 0.0218, 'lps'),
	(673173, 133, '2015-02-01 00:35:32.000000', 'consum', 0.0213, 'lps'),
	(673174, 133, '2015-02-01 00:35:33.000000', 'consum', 0.0211, 'lps'),
	(673175, 133, '2015-02-01 00:35:34.000000', 'consum', 0.0220, 'lps'),
	(673176, 133, '2015-02-01 00:35:35.000000', 'consum', 0.0210, 'lps'),
	(673177, 133, '2015-02-01 00:35:36.000000', 'consum', 0.0216, 'lps'),
	(673178, 133, '2015-02-01 00:35:37.000000', 'consum', 0.0216, 'lps'),
	(673179, 133, '2015-02-01 00:35:38.000000', 'consum', 0.0211, 'lps'),
	(673180, 133, '2015-02-01 00:35:39.000000', 'consum', 0.0221, 'lps'),
	(673181, 133, '2015-02-01 00:35:40.000000', 'consum', 0.0215, 'lps'),
	(673182, 133, '2015-02-01 00:35:41.000000', 'consum', 0.0216, 'lps'),
	(673183, 133, '2015-02-01 00:35:42.000000', 'consum', 0.0213, 'lps'),
	(673184, 133, '2015-02-01 00:35:43.000000', 'consum', 0.0219, 'lps'),
	(673185, 133, '2015-02-01 00:35:44.000000', 'consum', 0.0210, 'lps'),
	(673186, 133, '2015-02-01 00:35:45.000000', 'consum', 0.0219, 'lps'),
	(673187, 133, '2015-02-01 00:35:46.000000', 'consum', 0.0210, 'lps'),
	(673188, 133, '2015-02-01 00:35:47.000000', 'consum', 0.0218, 'lps'),
	(673189, 133, '2015-02-01 00:35:48.000000', 'consum', 0.0213, 'lps'),
	(673190, 133, '2015-02-01 00:35:49.000000', 'consum', 0.0215, 'lps'),
	(673191, 133, '2015-02-01 00:35:50.000000', 'consum', 0.0216, 'lps'),
	(673192, 133, '2015-02-01 00:35:51.000000', 'consum', 0.0212, 'lps'),
	(673193, 133, '2015-02-01 00:35:52.000000', 'consum', 0.0213, 'lps'),
	(673194, 133, '2015-02-01 00:35:53.000000', 'consum', 0.0221, 'lps'),
	(673195, 133, '2015-02-01 00:35:54.000000', 'consum', 0.0219, 'lps'),
	(673196, 133, '2015-02-01 00:35:55.000000', 'consum', 0.0221, 'lps'),
	(673197, 133, '2015-02-01 00:35:56.000000', 'consum', 0.0218, 'lps'),
	(673198, 133, '2015-02-01 00:35:57.000000', 'consum', 0.0214, 'lps'),
	(673199, 133, '2015-02-01 00:35:58.000000', 'consum', 0.0210, 'lps'),
	(673200, 133, '2015-02-01 00:35:59.000000', 'consum', 0.0219, 'lps'),
	(673201, 133, '2015-02-01 00:36:00.000000', 'consum', 0.0210, 'lps'),
	(673202, 133, '2015-02-01 00:36:01.000000', 'consum', 0.0217, 'lps'),
	(673203, 133, '2015-02-01 00:36:02.000000', 'consum', 0.0210, 'lps'),
	(673204, 133, '2015-02-01 00:36:03.000000', 'consum', 0.0215, 'lps'),
	(673205, 133, '2015-02-01 00:36:04.000000', 'consum', 0.0211, 'lps'),
	(673206, 133, '2015-02-01 00:36:05.000000', 'consum', 0.0211, 'lps'),
	(673207, 133, '2015-02-01 00:36:06.000000', 'consum', 0.0214, 'lps'),
	(673208, 133, '2015-02-01 00:36:07.000000', 'consum', 0.0216, 'lps'),
	(673209, 133, '2015-02-01 00:36:08.000000', 'consum', 0.0215, 'lps'),
	(673210, 133, '2015-02-01 00:36:09.000000', 'consum', 0.0220, 'lps'),
	(673211, 133, '2015-02-01 00:36:10.000000', 'consum', 0.0220, 'lps'),
	(673212, 133, '2015-02-01 00:36:11.000000', 'consum', 0.0219, 'lps'),
	(673213, 133, '2015-02-01 00:36:12.000000', 'consum', 0.0212, 'lps'),
	(673214, 133, '2015-02-01 00:36:13.000000', 'consum', 0.0219, 'lps'),
	(673215, 133, '2015-02-01 00:36:14.000000', 'consum', 0.0213, 'lps'),
	(673216, 133, '2015-02-01 00:36:15.000000', 'consum', 0.0211, 'lps'),
	(673217, 133, '2015-02-01 00:36:16.000000', 'consum', 0.0219, 'lps'),
	(673218, 133, '2015-02-01 00:36:17.000000', 'consum', 0.0216, 'lps'),
	(673219, 133, '2015-02-01 00:36:18.000000', 'consum', 0.0213, 'lps'),
	(673220, 133, '2015-02-01 00:36:19.000000', 'consum', 0.0219, 'lps'),
	(673221, 133, '2015-02-01 00:36:20.000000', 'consum', 0.0210, 'lps'),
	(673222, 133, '2015-02-01 00:36:21.000000', 'consum', 0.0210, 'lps'),
	(673223, 133, '2015-02-01 00:36:22.000000', 'consum', 0.0211, 'lps'),
	(673224, 133, '2015-02-01 00:36:23.000000', 'consum', 0.0213, 'lps'),
	(673225, 133, '2015-02-01 00:36:24.000000', 'consum', 0.0210, 'lps'),
	(673226, 133, '2015-02-01 00:36:25.000000', 'consum', 0.0214, 'lps'),
	(673227, 133, '2015-02-01 00:36:26.000000', 'consum', 0.0217, 'lps'),
	(673228, 133, '2015-02-01 00:36:27.000000', 'consum', 0.0210, 'lps'),
	(673229, 133, '2015-02-01 00:36:28.000000', 'consum', 0.0216, 'lps'),
	(673230, 133, '2015-02-01 00:36:29.000000', 'consum', 0.0213, 'lps'),
	(673231, 133, '2015-02-01 00:36:30.000000', 'consum', 0.0211, 'lps'),
	(673232, 133, '2015-02-01 00:36:31.000000', 'consum', 0.0215, 'lps'),
	(673233, 133, '2015-02-01 00:36:32.000000', 'consum', 0.0210, 'lps'),
	(673234, 133, '2015-02-01 00:36:33.000000', 'consum', 0.0220, 'lps'),
	(673235, 133, '2015-02-01 00:36:34.000000', 'consum', 0.0211, 'lps'),
	(673236, 133, '2015-02-01 00:36:35.000000', 'consum', 0.0221, 'lps'),
	(673237, 133, '2015-02-01 00:36:36.000000', 'consum', 0.0214, 'lps'),
	(673238, 133, '2015-02-01 00:36:37.000000', 'consum', 0.0221, 'lps'),
	(673239, 133, '2015-02-01 00:36:38.000000', 'consum', 0.0219, 'lps'),
	(673240, 133, '2015-02-01 00:36:39.000000', 'consum', 0.0210, 'lps'),
	(673241, 133, '2015-02-01 00:36:40.000000', 'consum', 0.0220, 'lps'),
	(673242, 133, '2015-02-01 00:36:41.000000', 'consum', 0.0211, 'lps'),
	(673243, 133, '2015-02-01 00:36:42.000000', 'consum', 0.0210, 'lps'),
	(673244, 133, '2015-02-01 00:36:43.000000', 'consum', 0.0218, 'lps'),
	(673245, 133, '2015-02-01 00:36:44.000000', 'consum', 0.0215, 'lps'),
	(673246, 133, '2015-02-01 00:36:45.000000', 'consum', 0.0210, 'lps'),
	(673247, 133, '2015-02-01 00:36:46.000000', 'consum', 0.0221, 'lps'),
	(673248, 133, '2015-02-01 00:36:47.000000', 'consum', 0.0218, 'lps'),
	(673249, 133, '2015-02-01 00:36:48.000000', 'consum', 0.0217, 'lps'),
	(673250, 133, '2015-02-01 00:36:49.000000', 'consum', 0.0212, 'lps'),
	(673251, 133, '2015-02-01 00:36:50.000000', 'consum', 0.0220, 'lps'),
	(673252, 133, '2015-02-01 00:36:51.000000', 'consum', 0.0219, 'lps'),
	(673253, 133, '2015-02-01 00:36:52.000000', 'consum', 0.0215, 'lps'),
	(673254, 133, '2015-02-01 00:36:53.000000', 'consum', 0.0219, 'lps'),
	(673255, 133, '2015-02-01 00:36:54.000000', 'consum', 0.0216, 'lps'),
	(673256, 133, '2015-02-01 00:36:55.000000', 'consum', 0.0216, 'lps'),
	(673257, 133, '2015-02-01 00:36:56.000000', 'consum', 0.0220, 'lps'),
	(673258, 133, '2015-02-01 00:36:57.000000', 'consum', 0.0217, 'lps'),
	(673259, 133, '2015-02-01 00:36:58.000000', 'consum', 0.0219, 'lps'),
	(673260, 133, '2015-02-01 00:36:59.000000', 'consum', 0.0219, 'lps'),
	(673261, 133, '2015-02-01 00:37:00.000000', 'consum', 0.0218, 'lps'),
	(673262, 133, '2015-02-01 00:37:01.000000', 'consum', 0.0213, 'lps'),
	(673263, 133, '2015-02-01 00:37:02.000000', 'consum', 0.0214, 'lps'),
	(673264, 133, '2015-02-01 00:37:03.000000', 'consum', 0.0210, 'lps'),
	(673265, 133, '2015-02-01 00:37:04.000000', 'consum', 0.0221, 'lps'),
	(673266, 133, '2015-02-01 00:37:05.000000', 'consum', 0.0217, 'lps'),
	(673267, 133, '2015-02-01 00:37:06.000000', 'consum', 0.0211, 'lps'),
	(673268, 133, '2015-02-01 00:37:07.000000', 'consum', 0.0210, 'lps'),
	(673269, 133, '2015-02-01 00:37:08.000000', 'consum', 0.0217, 'lps'),
	(673270, 133, '2015-02-01 00:37:09.000000', 'consum', 0.0221, 'lps'),
	(673271, 133, '2015-02-01 00:37:10.000000', 'consum', 0.0211, 'lps'),
	(673272, 133, '2015-02-01 00:37:11.000000', 'consum', 0.0219, 'lps'),
	(673273, 133, '2015-02-01 00:37:12.000000', 'consum', 0.0213, 'lps'),
	(673274, 133, '2015-02-01 00:37:13.000000', 'consum', 0.0213, 'lps'),
	(673275, 133, '2015-02-01 00:37:14.000000', 'consum', 0.0218, 'lps'),
	(673276, 133, '2015-02-01 00:37:15.000000', 'consum', 0.0215, 'lps'),
	(673277, 133, '2015-02-01 00:37:16.000000', 'consum', 0.0210, 'lps'),
	(673278, 133, '2015-02-01 00:37:17.000000', 'consum', 0.0210, 'lps'),
	(673279, 133, '2015-02-01 00:37:18.000000', 'consum', 0.0220, 'lps'),
	(673280, 133, '2015-02-01 00:37:19.000000', 'consum', 0.0214, 'lps'),
	(673281, 133, '2015-02-01 00:37:20.000000', 'consum', 0.0210, 'lps'),
	(673282, 133, '2015-02-01 00:37:21.000000', 'consum', 0.0214, 'lps'),
	(673283, 133, '2015-02-01 00:37:22.000000', 'consum', 0.0215, 'lps'),
	(673284, 133, '2015-02-01 00:37:23.000000', 'consum', 0.0215, 'lps'),
	(673285, 133, '2015-02-01 00:37:24.000000', 'consum', 0.0219, 'lps'),
	(673286, 133, '2015-02-01 00:37:25.000000', 'consum', 0.0218, 'lps'),
	(673287, 133, '2015-02-01 00:37:26.000000', 'consum', 0.0221, 'lps'),
	(673288, 133, '2015-02-01 00:37:27.000000', 'consum', 0.0219, 'lps'),
	(673289, 133, '2015-02-01 00:37:28.000000', 'consum', 0.0212, 'lps'),
	(673290, 133, '2015-02-01 00:37:29.000000', 'consum', 0.0216, 'lps'),
	(673291, 133, '2015-02-01 00:37:30.000000', 'consum', 0.0210, 'lps'),
	(673292, 133, '2015-02-01 00:37:31.000000', 'consum', 0.0215, 'lps'),
	(673293, 133, '2015-02-01 00:37:32.000000', 'consum', 0.0215, 'lps'),
	(673294, 133, '2015-02-01 00:37:33.000000', 'consum', 0.0219, 'lps'),
	(673295, 133, '2015-02-01 00:37:34.000000', 'consum', 0.0216, 'lps'),
	(673296, 133, '2015-02-01 00:37:35.000000', 'consum', 0.0216, 'lps'),
	(673297, 133, '2015-02-01 00:37:36.000000', 'consum', 0.0221, 'lps'),
	(673298, 133, '2015-02-01 00:37:37.000000', 'consum', 0.0211, 'lps'),
	(673299, 133, '2015-02-01 00:37:38.000000', 'consum', 0.0217, 'lps'),
	(673300, 133, '2015-02-01 00:37:39.000000', 'consum', 0.0219, 'lps'),
	(673301, 133, '2015-02-01 00:37:40.000000', 'consum', 0.0211, 'lps'),
	(673302, 133, '2015-02-01 00:37:41.000000', 'consum', 0.0212, 'lps'),
	(673303, 133, '2015-02-01 00:37:42.000000', 'consum', 0.0217, 'lps'),
	(673304, 133, '2015-02-01 00:37:43.000000', 'consum', 0.0217, 'lps'),
	(673305, 133, '2015-02-01 00:37:44.000000', 'consum', 0.0212, 'lps'),
	(673306, 133, '2015-02-01 00:37:45.000000', 'consum', 0.0212, 'lps'),
	(673307, 133, '2015-02-01 00:37:46.000000', 'consum', 0.0216, 'lps'),
	(673308, 133, '2015-02-01 00:37:47.000000', 'consum', 0.0219, 'lps'),
	(673309, 133, '2015-02-01 00:37:48.000000', 'consum', 0.0217, 'lps'),
	(673310, 133, '2015-02-01 00:37:49.000000', 'consum', 0.0217, 'lps'),
	(673311, 133, '2015-02-01 00:37:50.000000', 'consum', 0.0211, 'lps'),
	(673312, 133, '2015-02-01 00:37:51.000000', 'consum', 0.0220, 'lps'),
	(673313, 133, '2015-02-01 00:37:52.000000', 'consum', 0.0210, 'lps'),
	(673314, 133, '2015-02-01 00:37:53.000000', 'consum', 0.0214, 'lps'),
	(673315, 133, '2015-02-01 00:37:54.000000', 'consum', 0.0220, 'lps'),
	(673316, 133, '2015-02-01 00:37:55.000000', 'consum', 0.0213, 'lps'),
	(673317, 133, '2015-02-01 00:37:56.000000', 'consum', 0.0219, 'lps'),
	(673318, 133, '2015-02-01 00:37:57.000000', 'consum', 0.0221, 'lps'),
	(673319, 133, '2015-02-01 00:37:58.000000', 'consum', 0.0214, 'lps'),
	(673320, 133, '2015-02-01 00:37:59.000000', 'consum', 0.0210, 'lps'),
	(673321, 133, '2015-02-01 00:38:00.000000', 'consum', 0.0211, 'lps'),
	(673322, 133, '2015-02-01 00:38:01.000000', 'consum', 0.0216, 'lps'),
	(673323, 133, '2015-02-01 00:38:02.000000', 'consum', 0.0215, 'lps'),
	(673324, 133, '2015-02-01 00:38:03.000000', 'consum', 0.0217, 'lps'),
	(673325, 133, '2015-02-01 00:38:04.000000', 'consum', 0.0217, 'lps'),
	(673326, 133, '2015-02-01 00:38:05.000000', 'consum', 0.0215, 'lps'),
	(673327, 133, '2015-02-01 00:38:06.000000', 'consum', 0.0212, 'lps'),
	(673328, 133, '2015-02-01 00:38:07.000000', 'consum', 0.0219, 'lps'),
	(673329, 133, '2015-02-01 00:38:08.000000', 'consum', 0.0215, 'lps'),
	(673330, 133, '2015-02-01 00:38:09.000000', 'consum', 0.0219, 'lps'),
	(673331, 133, '2015-02-01 00:38:10.000000', 'consum', 0.0217, 'lps'),
	(673332, 133, '2015-02-01 00:38:11.000000', 'consum', 0.0220, 'lps'),
	(673333, 133, '2015-02-01 00:38:12.000000', 'consum', 0.0213, 'lps'),
	(673334, 133, '2015-02-01 00:38:13.000000', 'consum', 0.0221, 'lps'),
	(673335, 133, '2015-02-01 00:38:14.000000', 'consum', 0.0221, 'lps'),
	(673336, 133, '2015-02-01 00:38:15.000000', 'consum', 0.0221, 'lps'),
	(673337, 133, '2015-02-01 00:38:16.000000', 'consum', 0.0219, 'lps'),
	(673338, 133, '2015-02-01 00:38:17.000000', 'consum', 0.0210, 'lps'),
	(673339, 133, '2015-02-01 00:38:18.000000', 'consum', 0.0210, 'lps'),
	(673340, 133, '2015-02-01 00:38:19.000000', 'consum', 0.0220, 'lps'),
	(673341, 133, '2015-02-01 00:38:20.000000', 'consum', 0.0214, 'lps'),
	(673342, 133, '2015-02-01 00:38:21.000000', 'consum', 0.0213, 'lps'),
	(673343, 133, '2015-02-01 00:38:22.000000', 'consum', 0.0213, 'lps'),
	(673344, 133, '2015-02-01 00:38:23.000000', 'consum', 0.0216, 'lps'),
	(673345, 133, '2015-02-01 00:38:24.000000', 'consum', 0.0219, 'lps'),
	(673346, 133, '2015-02-01 00:38:25.000000', 'consum', 0.0212, 'lps'),
	(673347, 133, '2015-02-01 00:38:26.000000', 'consum', 0.0221, 'lps'),
	(673348, 133, '2015-02-01 00:38:27.000000', 'consum', 0.0220, 'lps'),
	(673349, 133, '2015-02-01 00:38:28.000000', 'consum', 0.0219, 'lps'),
	(673350, 133, '2015-02-01 00:38:29.000000', 'consum', 0.0211, 'lps'),
	(673351, 133, '2015-02-01 00:38:30.000000', 'consum', 0.0214, 'lps'),
	(673352, 133, '2015-02-01 00:38:31.000000', 'consum', 0.0214, 'lps'),
	(673353, 133, '2015-02-01 00:38:32.000000', 'consum', 0.0220, 'lps'),
	(673354, 133, '2015-02-01 00:38:33.000000', 'consum', 0.0212, 'lps'),
	(673355, 133, '2015-02-01 00:38:34.000000', 'consum', 0.0216, 'lps'),
	(673356, 133, '2015-02-01 00:38:35.000000', 'consum', 0.0221, 'lps'),
	(673357, 133, '2015-02-01 00:38:36.000000', 'consum', 0.0213, 'lps'),
	(673358, 133, '2015-02-01 00:38:37.000000', 'consum', 0.0216, 'lps'),
	(673359, 133, '2015-02-01 00:38:38.000000', 'consum', 0.0220, 'lps'),
	(673360, 133, '2015-02-01 00:38:39.000000', 'consum', 0.0219, 'lps'),
	(673361, 133, '2015-02-01 00:38:40.000000', 'consum', 0.0213, 'lps'),
	(673362, 133, '2015-02-01 00:38:41.000000', 'consum', 0.0211, 'lps'),
	(673363, 133, '2015-02-01 00:38:42.000000', 'consum', 0.0219, 'lps'),
	(673364, 133, '2015-02-01 00:38:43.000000', 'consum', 0.0215, 'lps'),
	(673365, 133, '2015-02-01 00:38:44.000000', 'consum', 0.0220, 'lps'),
	(673366, 133, '2015-02-01 00:38:45.000000', 'consum', 0.0211, 'lps'),
	(673367, 133, '2015-02-01 00:38:46.000000', 'consum', 0.0210, 'lps'),
	(673368, 133, '2015-02-01 00:38:47.000000', 'consum', 0.0218, 'lps'),
	(673369, 133, '2015-02-01 00:38:48.000000', 'consum', 0.0215, 'lps'),
	(673370, 133, '2015-02-01 00:38:49.000000', 'consum', 0.0211, 'lps'),
	(673371, 133, '2015-02-01 00:38:50.000000', 'consum', 0.0212, 'lps'),
	(673372, 133, '2015-02-01 00:38:51.000000', 'consum', 0.0216, 'lps'),
	(673373, 133, '2015-02-01 00:38:52.000000', 'consum', 0.0212, 'lps'),
	(673374, 133, '2015-02-01 00:38:53.000000', 'consum', 0.0215, 'lps'),
	(673375, 133, '2015-02-01 00:38:54.000000', 'consum', 0.0215, 'lps'),
	(673376, 133, '2015-02-01 00:38:55.000000', 'consum', 0.0210, 'lps'),
	(673377, 133, '2015-02-01 00:38:56.000000', 'consum', 0.0221, 'lps'),
	(673378, 133, '2015-02-01 00:38:57.000000', 'consum', 0.0217, 'lps'),
	(673379, 133, '2015-02-01 00:38:58.000000', 'consum', 0.0214, 'lps'),
	(673380, 133, '2015-02-01 00:38:59.000000', 'consum', 0.0219, 'lps'),
	(673381, 133, '2015-02-01 00:39:00.000000', 'consum', 0.0221, 'lps'),
	(673382, 133, '2015-02-01 00:39:01.000000', 'consum', 0.0215, 'lps'),
	(673383, 133, '2015-02-01 00:39:02.000000', 'consum', 0.0213, 'lps'),
	(673384, 133, '2015-02-01 00:39:03.000000', 'consum', 0.0221, 'lps'),
	(673385, 133, '2015-02-01 00:39:04.000000', 'consum', 0.0212, 'lps'),
	(673386, 133, '2015-02-01 00:39:05.000000', 'consum', 0.0221, 'lps'),
	(673387, 133, '2015-02-01 00:39:06.000000', 'consum', 0.0211, 'lps'),
	(673388, 133, '2015-02-01 00:39:07.000000', 'consum', 0.0220, 'lps'),
	(673389, 133, '2015-02-01 00:39:08.000000', 'consum', 0.0210, 'lps'),
	(673390, 133, '2015-02-01 00:39:09.000000', 'consum', 0.0216, 'lps'),
	(673391, 133, '2015-02-01 00:39:10.000000', 'consum', 0.0215, 'lps'),
	(673392, 133, '2015-02-01 00:39:11.000000', 'consum', 0.0217, 'lps'),
	(673393, 133, '2015-02-01 00:39:12.000000', 'consum', 0.0221, 'lps'),
	(673394, 133, '2015-02-01 00:39:13.000000', 'consum', 0.0221, 'lps'),
	(673395, 133, '2015-02-01 00:39:14.000000', 'consum', 0.0221, 'lps'),
	(673396, 133, '2015-02-01 00:39:15.000000', 'consum', 0.0218, 'lps'),
	(673397, 133, '2015-02-01 00:39:16.000000', 'consum', 0.0217, 'lps'),
	(673398, 133, '2015-02-01 00:39:17.000000', 'consum', 0.0211, 'lps'),
	(673399, 133, '2015-02-01 00:39:18.000000', 'consum', 0.0218, 'lps'),
	(673400, 133, '2015-02-01 00:39:19.000000', 'consum', 0.0210, 'lps'),
	(673401, 133, '2015-02-01 00:39:20.000000', 'consum', 0.0211, 'lps'),
	(673402, 133, '2015-02-01 00:39:21.000000', 'consum', 0.0215, 'lps'),
	(673403, 133, '2015-02-01 00:39:22.000000', 'consum', 0.0221, 'lps'),
	(673404, 133, '2015-02-01 00:39:23.000000', 'consum', 0.0214, 'lps'),
	(673405, 133, '2015-02-01 00:39:24.000000', 'consum', 0.0211, 'lps'),
	(673406, 133, '2015-02-01 00:39:25.000000', 'consum', 0.0215, 'lps'),
	(673407, 133, '2015-02-01 00:39:26.000000', 'consum', 0.0210, 'lps'),
	(673408, 133, '2015-02-01 00:39:27.000000', 'consum', 0.0219, 'lps'),
	(673409, 133, '2015-02-01 00:39:28.000000', 'consum', 0.0217, 'lps'),
	(673410, 133, '2015-02-01 00:39:29.000000', 'consum', 0.0219, 'lps'),
	(673411, 133, '2015-02-01 00:39:30.000000', 'consum', 0.0213, 'lps'),
	(673412, 133, '2015-02-01 00:39:31.000000', 'consum', 0.0221, 'lps'),
	(673413, 133, '2015-02-01 00:39:32.000000', 'consum', 0.0211, 'lps'),
	(673414, 133, '2015-02-01 00:39:33.000000', 'consum', 0.0215, 'lps'),
	(673415, 133, '2015-02-01 00:39:34.000000', 'consum', 0.0211, 'lps'),
	(673416, 133, '2015-02-01 00:39:35.000000', 'consum', 0.0210, 'lps'),
	(673417, 133, '2015-02-01 00:39:36.000000', 'consum', 0.0210, 'lps'),
	(673418, 133, '2015-02-01 00:39:37.000000', 'consum', 0.0221, 'lps'),
	(673419, 133, '2015-02-01 00:39:38.000000', 'consum', 0.0218, 'lps'),
	(673420, 133, '2015-02-01 00:39:39.000000', 'consum', 0.0217, 'lps'),
	(673421, 133, '2015-02-01 00:39:40.000000', 'consum', 0.0221, 'lps'),
	(673422, 133, '2015-02-01 00:39:41.000000', 'consum', 0.0220, 'lps'),
	(673423, 133, '2015-02-01 00:39:42.000000', 'consum', 0.0217, 'lps'),
	(673424, 133, '2015-02-01 00:39:43.000000', 'consum', 0.0217, 'lps'),
	(673425, 133, '2015-02-01 00:39:44.000000', 'consum', 0.0221, 'lps'),
	(673426, 133, '2015-02-01 00:39:45.000000', 'consum', 0.0212, 'lps'),
	(673427, 133, '2015-02-01 00:39:46.000000', 'consum', 0.0210, 'lps'),
	(673428, 133, '2015-02-01 00:39:47.000000', 'consum', 0.0218, 'lps'),
	(673429, 133, '2015-02-01 00:39:48.000000', 'consum', 0.0213, 'lps'),
	(673430, 133, '2015-02-01 00:39:49.000000', 'consum', 0.0212, 'lps'),
	(673431, 133, '2015-02-01 00:39:50.000000', 'consum', 0.0213, 'lps'),
	(673432, 133, '2015-02-01 00:39:51.000000', 'consum', 0.0218, 'lps'),
	(673433, 133, '2015-02-01 00:39:52.000000', 'consum', 0.0216, 'lps'),
	(673434, 133, '2015-02-01 00:39:53.000000', 'consum', 0.0220, 'lps'),
	(673435, 133, '2015-02-01 00:39:54.000000', 'consum', 0.0217, 'lps'),
	(673436, 133, '2015-02-01 00:39:55.000000', 'consum', 0.0216, 'lps'),
	(673437, 133, '2015-02-01 00:39:56.000000', 'consum', 0.0220, 'lps'),
	(673438, 133, '2015-02-01 00:39:57.000000', 'consum', 0.0216, 'lps'),
	(673439, 133, '2015-02-01 00:39:58.000000', 'consum', 0.0212, 'lps'),
	(673440, 133, '2015-02-01 00:39:59.000000', 'consum', 0.0215, 'lps'),
	(673441, 133, '2015-02-01 00:40:00.000000', 'consum', 0.0217, 'lps'),
	(673442, 133, '2015-02-01 00:40:01.000000', 'consum', 0.0218, 'lps'),
	(673443, 133, '2015-02-01 00:40:02.000000', 'consum', 0.0217, 'lps'),
	(673444, 133, '2015-02-01 00:40:03.000000', 'consum', 0.0211, 'lps'),
	(673445, 133, '2015-02-01 00:40:04.000000', 'consum', 0.0217, 'lps'),
	(673446, 133, '2015-02-01 00:40:05.000000', 'consum', 0.0219, 'lps'),
	(673447, 133, '2015-02-01 00:40:06.000000', 'consum', 0.0212, 'lps'),
	(673448, 133, '2015-02-01 00:40:07.000000', 'consum', 0.0218, 'lps'),
	(673449, 133, '2015-02-01 00:40:08.000000', 'consum', 0.0219, 'lps'),
	(673450, 133, '2015-02-01 00:40:09.000000', 'consum', 0.0220, 'lps'),
	(673451, 133, '2015-02-01 00:40:10.000000', 'consum', 0.0211, 'lps'),
	(673452, 133, '2015-02-01 00:40:11.000000', 'consum', 0.0219, 'lps'),
	(673453, 133, '2015-02-01 00:40:12.000000', 'consum', 0.0217, 'lps'),
	(673454, 133, '2015-02-01 00:40:13.000000', 'consum', 0.0218, 'lps'),
	(673455, 133, '2015-02-01 00:40:14.000000', 'consum', 0.0216, 'lps'),
	(673456, 133, '2015-02-01 00:40:15.000000', 'consum', 0.0219, 'lps'),
	(673457, 133, '2015-02-01 00:40:16.000000', 'consum', 0.0215, 'lps'),
	(673458, 133, '2015-02-01 00:40:17.000000', 'consum', 0.0218, 'lps'),
	(673459, 133, '2015-02-01 00:40:18.000000', 'consum', 0.0213, 'lps'),
	(673460, 133, '2015-02-01 00:40:19.000000', 'consum', 0.0213, 'lps'),
	(673461, 133, '2015-02-01 00:40:20.000000', 'consum', 0.0214, 'lps'),
	(673462, 133, '2015-02-01 00:40:21.000000', 'consum', 0.0213, 'lps'),
	(673463, 133, '2015-02-01 00:40:22.000000', 'consum', 0.0213, 'lps'),
	(673464, 133, '2015-02-01 00:40:23.000000', 'consum', 0.0216, 'lps'),
	(673465, 133, '2015-02-01 00:40:24.000000', 'consum', 0.0219, 'lps'),
	(673466, 133, '2015-02-01 00:40:25.000000', 'consum', 0.0213, 'lps'),
	(673467, 133, '2015-02-01 00:40:26.000000', 'consum', 0.0211, 'lps'),
	(673468, 133, '2015-02-01 00:40:27.000000', 'consum', 0.0218, 'lps'),
	(673469, 133, '2015-02-01 00:40:28.000000', 'consum', 0.0213, 'lps'),
	(673470, 133, '2015-02-01 00:40:29.000000', 'consum', 0.0213, 'lps'),
	(673471, 133, '2015-02-01 00:40:30.000000', 'consum', 0.0216, 'lps'),
	(673472, 133, '2015-02-01 00:40:31.000000', 'consum', 0.0220, 'lps'),
	(673473, 133, '2015-02-01 00:40:32.000000', 'consum', 0.0220, 'lps'),
	(673474, 133, '2015-02-01 00:40:33.000000', 'consum', 0.0216, 'lps'),
	(673475, 133, '2015-02-01 00:40:34.000000', 'consum', 0.0211, 'lps'),
	(673476, 133, '2015-02-01 00:40:35.000000', 'consum', 0.0220, 'lps'),
	(673477, 133, '2015-02-01 00:40:36.000000', 'consum', 0.0212, 'lps'),
	(673478, 133, '2015-02-01 00:40:37.000000', 'consum', 0.0214, 'lps'),
	(673479, 133, '2015-02-01 00:40:38.000000', 'consum', 0.0212, 'lps'),
	(673480, 133, '2015-02-01 00:40:39.000000', 'consum', 0.0221, 'lps'),
	(673481, 133, '2015-02-01 00:40:40.000000', 'consum', 0.0212, 'lps'),
	(673482, 133, '2015-02-01 00:40:41.000000', 'consum', 0.0212, 'lps'),
	(673483, 133, '2015-02-01 00:40:42.000000', 'consum', 0.0213, 'lps'),
	(673484, 133, '2015-02-01 00:40:43.000000', 'consum', 0.0220, 'lps'),
	(673485, 133, '2015-02-01 00:40:44.000000', 'consum', 0.0216, 'lps'),
	(673486, 133, '2015-02-01 00:40:45.000000', 'consum', 0.0220, 'lps'),
	(673487, 133, '2015-02-01 00:40:46.000000', 'consum', 0.0220, 'lps'),
	(673488, 133, '2015-02-01 00:40:47.000000', 'consum', 0.0221, 'lps'),
	(673489, 133, '2015-02-01 00:40:48.000000', 'consum', 0.0220, 'lps'),
	(673490, 133, '2015-02-01 00:40:49.000000', 'consum', 0.0218, 'lps'),
	(673491, 133, '2015-02-01 00:40:50.000000', 'consum', 0.0220, 'lps'),
	(673492, 133, '2015-02-01 00:40:51.000000', 'consum', 0.0210, 'lps'),
	(673493, 133, '2015-02-01 00:40:52.000000', 'consum', 0.0219, 'lps'),
	(673494, 133, '2015-02-01 00:40:53.000000', 'consum', 0.0221, 'lps'),
	(673495, 133, '2015-02-01 00:40:54.000000', 'consum', 0.0212, 'lps'),
	(673496, 133, '2015-02-01 00:40:55.000000', 'consum', 0.0212, 'lps'),
	(673497, 133, '2015-02-01 00:40:56.000000', 'consum', 0.0215, 'lps'),
	(673498, 133, '2015-02-01 00:40:57.000000', 'consum', 0.0218, 'lps'),
	(673499, 133, '2015-02-01 00:40:58.000000', 'consum', 0.0210, 'lps'),
	(673500, 133, '2015-02-01 00:40:59.000000', 'consum', 0.0221, 'lps'),
	(673501, 133, '2015-02-01 00:41:00.000000', 'consum', 0.0220, 'lps'),
	(673502, 133, '2015-02-01 00:41:01.000000', 'consum', 0.0215, 'lps'),
	(673503, 133, '2015-02-01 00:41:02.000000', 'consum', 0.0218, 'lps'),
	(673504, 133, '2015-02-01 00:41:03.000000', 'consum', 0.0211, 'lps'),
	(673505, 133, '2015-02-01 00:41:04.000000', 'consum', 0.0213, 'lps'),
	(673506, 133, '2015-02-01 00:41:05.000000', 'consum', 0.0214, 'lps'),
	(673507, 133, '2015-02-01 00:41:06.000000', 'consum', 0.0210, 'lps'),
	(673508, 133, '2015-02-01 00:41:07.000000', 'consum', 0.0220, 'lps'),
	(673509, 133, '2015-02-01 00:41:08.000000', 'consum', 0.0212, 'lps'),
	(673510, 133, '2015-02-01 00:41:09.000000', 'consum', 0.0217, 'lps'),
	(673511, 133, '2015-02-01 00:41:10.000000', 'consum', 0.0215, 'lps'),
	(673512, 133, '2015-02-01 00:41:11.000000', 'consum', 0.0212, 'lps'),
	(673513, 133, '2015-02-01 00:41:12.000000', 'consum', 0.0220, 'lps'),
	(673514, 133, '2015-02-01 00:41:13.000000', 'consum', 0.0216, 'lps'),
	(673515, 133, '2015-02-01 00:41:14.000000', 'consum', 0.0213, 'lps'),
	(673516, 133, '2015-02-01 00:41:15.000000', 'consum', 0.0218, 'lps'),
	(673517, 133, '2015-02-01 00:41:16.000000', 'consum', 0.0219, 'lps'),
	(673518, 133, '2015-02-01 00:41:17.000000', 'consum', 0.0218, 'lps'),
	(673519, 133, '2015-02-01 00:41:18.000000', 'consum', 0.0210, 'lps'),
	(673520, 133, '2015-02-01 00:41:19.000000', 'consum', 0.0213, 'lps'),
	(673521, 133, '2015-02-01 00:41:20.000000', 'consum', 0.0211, 'lps'),
	(673522, 133, '2015-02-01 00:41:21.000000', 'consum', 0.0218, 'lps'),
	(673523, 133, '2015-02-01 00:41:22.000000', 'consum', 0.0215, 'lps'),
	(673524, 133, '2015-02-01 00:41:23.000000', 'consum', 0.0220, 'lps'),
	(673525, 133, '2015-02-01 00:41:24.000000', 'consum', 0.0213, 'lps'),
	(673526, 133, '2015-02-01 00:41:25.000000', 'consum', 0.0217, 'lps'),
	(673527, 133, '2015-02-01 00:41:26.000000', 'consum', 0.0213, 'lps'),
	(673528, 133, '2015-02-01 00:41:27.000000', 'consum', 0.0218, 'lps'),
	(673529, 133, '2015-02-01 00:41:28.000000', 'consum', 0.0215, 'lps'),
	(673530, 133, '2015-02-01 00:41:29.000000', 'consum', 0.0213, 'lps'),
	(673531, 133, '2015-02-01 00:41:30.000000', 'consum', 0.0211, 'lps'),
	(673532, 133, '2015-02-01 00:41:31.000000', 'consum', 0.0217, 'lps'),
	(673533, 133, '2015-02-01 00:41:32.000000', 'consum', 0.0218, 'lps'),
	(673534, 133, '2015-02-01 00:41:33.000000', 'consum', 0.0218, 'lps'),
	(673535, 133, '2015-02-01 00:41:34.000000', 'consum', 0.0213, 'lps'),
	(673536, 133, '2015-02-01 00:41:35.000000', 'consum', 0.0216, 'lps'),
	(673537, 133, '2015-02-01 00:41:36.000000', 'consum', 0.0217, 'lps'),
	(673538, 133, '2015-02-01 00:41:37.000000', 'consum', 0.0214, 'lps'),
	(673539, 133, '2015-02-01 00:41:38.000000', 'consum', 0.0213, 'lps'),
	(673540, 133, '2015-02-01 00:41:39.000000', 'consum', 0.0214, 'lps'),
	(673541, 133, '2015-02-01 00:41:40.000000', 'consum', 0.0221, 'lps'),
	(673542, 133, '2015-02-01 00:41:41.000000', 'consum', 0.0218, 'lps'),
	(673543, 133, '2015-02-01 00:41:42.000000', 'consum', 0.0217, 'lps'),
	(673544, 133, '2015-02-01 00:41:43.000000', 'consum', 0.0210, 'lps'),
	(673545, 133, '2015-02-01 00:41:44.000000', 'consum', 0.0215, 'lps'),
	(673546, 133, '2015-02-01 00:41:45.000000', 'consum', 0.0220, 'lps'),
	(673547, 133, '2015-02-01 00:41:46.000000', 'consum', 0.0213, 'lps'),
	(673548, 133, '2015-02-01 00:41:47.000000', 'consum', 0.0219, 'lps'),
	(673549, 133, '2015-02-01 00:41:48.000000', 'consum', 0.0221, 'lps'),
	(673550, 133, '2015-02-01 00:41:49.000000', 'consum', 0.0214, 'lps'),
	(673551, 133, '2015-02-01 00:41:50.000000', 'consum', 0.0212, 'lps'),
	(673552, 133, '2015-02-01 00:41:51.000000', 'consum', 0.0220, 'lps'),
	(673553, 133, '2015-02-01 00:41:52.000000', 'consum', 0.0220, 'lps'),
	(673554, 133, '2015-02-01 00:41:53.000000', 'consum', 0.0217, 'lps'),
	(673555, 133, '2015-02-01 00:41:54.000000', 'consum', 0.0216, 'lps'),
	(673556, 133, '2015-02-01 00:41:55.000000', 'consum', 0.0217, 'lps'),
	(673557, 133, '2015-02-01 00:41:56.000000', 'consum', 0.0218, 'lps'),
	(673558, 133, '2015-02-01 00:41:57.000000', 'consum', 0.0217, 'lps'),
	(673559, 133, '2015-02-01 00:41:58.000000', 'consum', 0.0221, 'lps'),
	(673560, 133, '2015-02-01 00:41:59.000000', 'consum', 0.0219, 'lps'),
	(673561, 133, '2015-02-01 00:42:00.000000', 'consum', 0.0211, 'lps'),
	(673562, 133, '2015-02-01 00:42:01.000000', 'consum', 0.0211, 'lps'),
	(673563, 133, '2015-02-01 00:42:02.000000', 'consum', 0.0215, 'lps'),
	(673564, 133, '2015-02-01 00:42:03.000000', 'consum', 0.0218, 'lps'),
	(673565, 133, '2015-02-01 00:42:04.000000', 'consum', 0.0214, 'lps'),
	(673566, 133, '2015-02-01 00:42:05.000000', 'consum', 0.0218, 'lps'),
	(673567, 133, '2015-02-01 00:42:06.000000', 'consum', 0.0216, 'lps'),
	(673568, 133, '2015-02-01 00:42:07.000000', 'consum', 0.0216, 'lps'),
	(673569, 133, '2015-02-01 00:42:08.000000', 'consum', 0.0221, 'lps'),
	(673570, 133, '2015-02-01 00:42:09.000000', 'consum', 0.0213, 'lps'),
	(673571, 133, '2015-02-01 00:42:10.000000', 'consum', 0.0214, 'lps'),
	(673572, 133, '2015-02-01 00:42:11.000000', 'consum', 0.0212, 'lps'),
	(673573, 133, '2015-02-01 00:42:12.000000', 'consum', 0.0218, 'lps'),
	(673574, 133, '2015-02-01 00:42:13.000000', 'consum', 0.0211, 'lps'),
	(673575, 133, '2015-02-01 00:42:14.000000', 'consum', 0.0214, 'lps'),
	(673576, 133, '2015-02-01 00:42:15.000000', 'consum', 0.0216, 'lps'),
	(673577, 133, '2015-02-01 00:42:16.000000', 'consum', 0.0216, 'lps'),
	(673578, 133, '2015-02-01 00:42:17.000000', 'consum', 0.0210, 'lps'),
	(673579, 133, '2015-02-01 00:42:18.000000', 'consum', 0.0218, 'lps'),
	(673580, 133, '2015-02-01 00:42:19.000000', 'consum', 0.0213, 'lps'),
	(673581, 133, '2015-02-01 00:42:20.000000', 'consum', 0.0216, 'lps'),
	(673582, 133, '2015-02-01 00:42:21.000000', 'consum', 0.0219, 'lps'),
	(673583, 133, '2015-02-01 00:42:22.000000', 'consum', 0.0212, 'lps'),
	(673584, 133, '2015-02-01 00:42:23.000000', 'consum', 0.0220, 'lps'),
	(673585, 133, '2015-02-01 00:42:24.000000', 'consum', 0.0216, 'lps'),
	(673586, 133, '2015-02-01 00:42:25.000000', 'consum', 0.0211, 'lps'),
	(673587, 133, '2015-02-01 00:42:26.000000', 'consum', 0.0221, 'lps'),
	(673588, 133, '2015-02-01 00:42:27.000000', 'consum', 0.0213, 'lps'),
	(673589, 133, '2015-02-01 00:42:28.000000', 'consum', 0.0219, 'lps'),
	(673590, 133, '2015-02-01 00:42:29.000000', 'consum', 0.0212, 'lps'),
	(673591, 133, '2015-02-01 00:42:30.000000', 'consum', 0.0215, 'lps'),
	(673592, 133, '2015-02-01 00:42:31.000000', 'consum', 0.0216, 'lps'),
	(673593, 133, '2015-02-01 00:42:32.000000', 'consum', 0.0217, 'lps'),
	(673594, 133, '2015-02-01 00:42:33.000000', 'consum', 0.0214, 'lps'),
	(673595, 133, '2015-02-01 00:42:34.000000', 'consum', 0.0220, 'lps'),
	(673596, 133, '2015-02-01 00:42:35.000000', 'consum', 0.0213, 'lps'),
	(673597, 133, '2015-02-01 00:42:36.000000', 'consum', 0.0221, 'lps'),
	(673598, 133, '2015-02-01 00:42:37.000000', 'consum', 0.0220, 'lps'),
	(673599, 133, '2015-02-01 00:42:38.000000', 'consum', 0.0217, 'lps'),
	(673600, 133, '2015-02-01 00:42:39.000000', 'consum', 0.0213, 'lps'),
	(673601, 133, '2015-02-01 00:42:40.000000', 'consum', 0.0216, 'lps'),
	(673602, 133, '2015-02-01 00:42:41.000000', 'consum', 0.0210, 'lps'),
	(673603, 133, '2015-02-01 00:42:42.000000', 'consum', 0.0214, 'lps'),
	(673604, 133, '2015-02-01 00:42:43.000000', 'consum', 0.0221, 'lps'),
	(673605, 133, '2015-02-01 00:42:44.000000', 'consum', 0.0215, 'lps'),
	(673606, 133, '2015-02-01 00:42:45.000000', 'consum', 0.0214, 'lps'),
	(673607, 133, '2015-02-01 00:42:46.000000', 'consum', 0.0218, 'lps'),
	(673608, 133, '2015-02-01 00:42:47.000000', 'consum', 0.0215, 'lps'),
	(673609, 133, '2015-02-01 00:42:48.000000', 'consum', 0.0211, 'lps'),
	(673610, 133, '2015-02-01 00:42:49.000000', 'consum', 0.0212, 'lps'),
	(673611, 133, '2015-02-01 00:42:50.000000', 'consum', 0.0219, 'lps'),
	(673612, 133, '2015-02-01 00:42:51.000000', 'consum', 0.0214, 'lps'),
	(673613, 133, '2015-02-01 00:42:52.000000', 'consum', 0.0216, 'lps'),
	(673614, 133, '2015-02-01 00:42:53.000000', 'consum', 0.0215, 'lps'),
	(673615, 133, '2015-02-01 00:42:54.000000', 'consum', 0.0217, 'lps'),
	(673616, 133, '2015-02-01 00:42:55.000000', 'consum', 0.0220, 'lps'),
	(673617, 133, '2015-02-01 00:42:56.000000', 'consum', 0.0217, 'lps'),
	(673618, 133, '2015-02-01 00:42:57.000000', 'consum', 0.0214, 'lps'),
	(673619, 133, '2015-02-01 00:42:58.000000', 'consum', 0.0221, 'lps'),
	(673620, 133, '2015-02-01 00:42:59.000000', 'consum', 0.0218, 'lps'),
	(673621, 133, '2015-02-01 00:43:00.000000', 'consum', 0.0219, 'lps'),
	(673622, 133, '2015-02-01 00:43:01.000000', 'consum', 0.0219, 'lps'),
	(673623, 133, '2015-02-01 00:43:02.000000', 'consum', 0.0216, 'lps'),
	(673624, 133, '2015-02-01 00:43:03.000000', 'consum', 0.0215, 'lps'),
	(673625, 133, '2015-02-01 00:43:04.000000', 'consum', 0.0218, 'lps'),
	(673626, 133, '2015-02-01 00:43:05.000000', 'consum', 0.0221, 'lps'),
	(673627, 133, '2015-02-01 00:43:06.000000', 'consum', 0.0220, 'lps'),
	(673628, 133, '2015-02-01 00:43:07.000000', 'consum', 0.0214, 'lps'),
	(673629, 133, '2015-02-01 00:43:08.000000', 'consum', 0.0213, 'lps'),
	(673630, 133, '2015-02-01 00:43:09.000000', 'consum', 0.0215, 'lps'),
	(673631, 133, '2015-02-01 00:43:10.000000', 'consum', 0.0213, 'lps'),
	(673632, 133, '2015-02-01 00:43:11.000000', 'consum', 0.0210, 'lps'),
	(673633, 133, '2015-02-01 00:43:12.000000', 'consum', 0.0214, 'lps'),
	(673634, 133, '2015-02-01 00:43:13.000000', 'consum', 0.0217, 'lps'),
	(673635, 133, '2015-02-01 00:43:14.000000', 'consum', 0.0211, 'lps'),
	(673636, 133, '2015-02-01 00:43:15.000000', 'consum', 0.0216, 'lps'),
	(673637, 133, '2015-02-01 00:43:16.000000', 'consum', 0.0217, 'lps'),
	(673638, 133, '2015-02-01 00:43:17.000000', 'consum', 0.0213, 'lps'),
	(673639, 133, '2015-02-01 00:43:18.000000', 'consum', 0.0219, 'lps'),
	(673640, 133, '2015-02-01 00:43:19.000000', 'consum', 0.0221, 'lps'),
	(673641, 133, '2015-02-01 00:43:20.000000', 'consum', 0.0215, 'lps'),
	(673642, 133, '2015-02-01 00:43:21.000000', 'consum', 0.0214, 'lps'),
	(673643, 133, '2015-02-01 00:43:22.000000', 'consum', 0.0217, 'lps'),
	(673644, 133, '2015-02-01 00:43:23.000000', 'consum', 0.0221, 'lps'),
	(673645, 133, '2015-02-01 00:43:24.000000', 'consum', 0.0221, 'lps'),
	(673646, 133, '2015-02-01 00:43:25.000000', 'consum', 0.0221, 'lps'),
	(673647, 133, '2015-02-01 00:43:26.000000', 'consum', 0.0219, 'lps'),
	(673648, 133, '2015-02-01 00:43:27.000000', 'consum', 0.0212, 'lps'),
	(673649, 133, '2015-02-01 00:43:28.000000', 'consum', 0.0218, 'lps'),
	(673650, 133, '2015-02-01 00:43:29.000000', 'consum', 0.0221, 'lps'),
	(673651, 133, '2015-02-01 00:43:30.000000', 'consum', 0.0215, 'lps'),
	(673652, 133, '2015-02-01 00:43:31.000000', 'consum', 0.0214, 'lps'),
	(673653, 133, '2015-02-01 00:43:32.000000', 'consum', 0.0218, 'lps'),
	(673654, 133, '2015-02-01 00:43:33.000000', 'consum', 0.0216, 'lps'),
	(673655, 133, '2015-02-01 00:43:34.000000', 'consum', 0.0213, 'lps'),
	(673656, 133, '2015-02-01 00:43:35.000000', 'consum', 0.0221, 'lps'),
	(673657, 133, '2015-02-01 00:43:36.000000', 'consum', 0.0210, 'lps'),
	(673658, 133, '2015-02-01 00:43:37.000000', 'consum', 0.0211, 'lps'),
	(673659, 133, '2015-02-01 00:43:38.000000', 'consum', 0.0216, 'lps'),
	(673660, 133, '2015-02-01 00:43:39.000000', 'consum', 0.0214, 'lps'),
	(673661, 133, '2015-02-01 00:43:40.000000', 'consum', 0.0210, 'lps'),
	(673662, 133, '2015-02-01 00:43:41.000000', 'consum', 0.0213, 'lps'),
	(673663, 133, '2015-02-01 00:43:42.000000', 'consum', 0.0213, 'lps'),
	(673664, 133, '2015-02-01 00:43:43.000000', 'consum', 0.0217, 'lps'),
	(673665, 133, '2015-02-01 00:43:44.000000', 'consum', 0.0213, 'lps'),
	(673666, 133, '2015-02-01 00:43:45.000000', 'consum', 0.0216, 'lps'),
	(673667, 133, '2015-02-01 00:43:46.000000', 'consum', 0.0220, 'lps'),
	(673668, 133, '2015-02-01 00:43:47.000000', 'consum', 0.0217, 'lps'),
	(673669, 133, '2015-02-01 00:43:48.000000', 'consum', 0.0215, 'lps'),
	(673670, 133, '2015-02-01 00:43:49.000000', 'consum', 0.0214, 'lps'),
	(673671, 133, '2015-02-01 00:43:50.000000', 'consum', 0.0218, 'lps'),
	(673672, 133, '2015-02-01 00:43:51.000000', 'consum', 0.0215, 'lps'),
	(673673, 133, '2015-02-01 00:43:52.000000', 'consum', 0.0210, 'lps'),
	(673674, 133, '2015-02-01 00:43:53.000000', 'consum', 0.0210, 'lps'),
	(673675, 133, '2015-02-01 00:43:54.000000', 'consum', 0.0219, 'lps'),
	(673676, 133, '2015-02-01 00:43:55.000000', 'consum', 0.0220, 'lps'),
	(673677, 133, '2015-02-01 00:43:56.000000', 'consum', 0.0210, 'lps'),
	(673678, 133, '2015-02-01 00:43:57.000000', 'consum', 0.0218, 'lps'),
	(673679, 133, '2015-02-01 00:43:58.000000', 'consum', 0.0214, 'lps'),
	(673680, 133, '2015-02-01 00:43:59.000000', 'consum', 0.0220, 'lps'),
	(673681, 133, '2015-02-01 00:44:00.000000', 'consum', 0.0210, 'lps'),
	(673682, 133, '2015-02-01 00:44:01.000000', 'consum', 0.0219, 'lps'),
	(673683, 133, '2015-02-01 00:44:02.000000', 'consum', 0.0218, 'lps'),
	(673684, 133, '2015-02-01 00:44:03.000000', 'consum', 0.0214, 'lps'),
	(673685, 133, '2015-02-01 00:44:04.000000', 'consum', 0.0215, 'lps'),
	(673686, 133, '2015-02-01 00:44:05.000000', 'consum', 0.0213, 'lps'),
	(673687, 133, '2015-02-01 00:44:06.000000', 'consum', 0.0212, 'lps'),
	(673688, 133, '2015-02-01 00:44:07.000000', 'consum', 0.0210, 'lps'),
	(673689, 133, '2015-02-01 00:44:08.000000', 'consum', 0.0218, 'lps'),
	(673690, 133, '2015-02-01 00:44:09.000000', 'consum', 0.0214, 'lps'),
	(673691, 133, '2015-02-01 00:44:10.000000', 'consum', 0.0218, 'lps'),
	(673692, 133, '2015-02-01 00:44:11.000000', 'consum', 0.0215, 'lps'),
	(673693, 133, '2015-02-01 00:44:12.000000', 'consum', 0.0211, 'lps'),
	(673694, 133, '2015-02-01 00:44:13.000000', 'consum', 0.0213, 'lps'),
	(673695, 133, '2015-02-01 00:44:14.000000', 'consum', 0.0210, 'lps'),
	(673696, 133, '2015-02-01 00:44:15.000000', 'consum', 0.0216, 'lps'),
	(673697, 133, '2015-02-01 00:44:16.000000', 'consum', 0.0213, 'lps'),
	(673698, 133, '2015-02-01 00:44:17.000000', 'consum', 0.0220, 'lps'),
	(673699, 133, '2015-02-01 00:44:18.000000', 'consum', 0.0216, 'lps'),
	(673700, 133, '2015-02-01 00:44:19.000000', 'consum', 0.0210, 'lps'),
	(673701, 133, '2015-02-01 00:44:20.000000', 'consum', 0.0218, 'lps'),
	(673702, 133, '2015-02-01 00:44:21.000000', 'consum', 0.0214, 'lps'),
	(673703, 133, '2015-02-01 00:44:22.000000', 'consum', 0.0220, 'lps'),
	(673704, 133, '2015-02-01 00:44:23.000000', 'consum', 0.0212, 'lps'),
	(673705, 133, '2015-02-01 00:44:24.000000', 'consum', 0.0214, 'lps'),
	(673706, 133, '2015-02-01 00:44:25.000000', 'consum', 0.0214, 'lps'),
	(673707, 133, '2015-02-01 00:44:26.000000', 'consum', 0.0217, 'lps'),
	(673708, 133, '2015-02-01 00:44:27.000000', 'consum', 0.0220, 'lps'),
	(673709, 133, '2015-02-01 00:44:28.000000', 'consum', 0.0218, 'lps'),
	(673710, 133, '2015-02-01 00:44:29.000000', 'consum', 0.0220, 'lps'),
	(673711, 133, '2015-02-01 00:44:30.000000', 'consum', 0.0212, 'lps'),
	(673712, 133, '2015-02-01 00:44:31.000000', 'consum', 0.0215, 'lps'),
	(673713, 133, '2015-02-01 00:44:32.000000', 'consum', 0.0217, 'lps'),
	(673714, 133, '2015-02-01 00:44:33.000000', 'consum', 0.0220, 'lps'),
	(673715, 133, '2015-02-01 00:44:34.000000', 'consum', 0.0214, 'lps'),
	(673716, 133, '2015-02-01 00:44:35.000000', 'consum', 0.0214, 'lps'),
	(673717, 133, '2015-02-01 00:44:36.000000', 'consum', 0.0220, 'lps'),
	(673718, 133, '2015-02-01 00:44:37.000000', 'consum', 0.0221, 'lps'),
	(673719, 133, '2015-02-01 00:44:38.000000', 'consum', 0.0215, 'lps'),
	(673720, 133, '2015-02-01 00:44:39.000000', 'consum', 0.0212, 'lps'),
	(673721, 133, '2015-02-01 00:44:40.000000', 'consum', 0.0219, 'lps'),
	(673722, 133, '2015-02-01 00:44:41.000000', 'consum', 0.0214, 'lps'),
	(673723, 133, '2015-02-01 00:44:42.000000', 'consum', 0.0215, 'lps'),
	(673724, 133, '2015-02-01 00:44:43.000000', 'consum', 0.0210, 'lps'),
	(673725, 133, '2015-02-01 00:44:44.000000', 'consum', 0.0221, 'lps'),
	(673726, 133, '2015-02-01 00:44:45.000000', 'consum', 0.0215, 'lps'),
	(673727, 133, '2015-02-01 00:44:46.000000', 'consum', 0.0216, 'lps'),
	(673728, 133, '2015-02-01 00:44:47.000000', 'consum', 0.0213, 'lps'),
	(673729, 133, '2015-02-01 00:44:48.000000', 'consum', 0.0221, 'lps'),
	(673730, 133, '2015-02-01 00:44:49.000000', 'consum', 0.0218, 'lps'),
	(673731, 133, '2015-02-01 00:44:50.000000', 'consum', 0.0217, 'lps'),
	(673732, 133, '2015-02-01 00:44:51.000000', 'consum', 0.0211, 'lps'),
	(673733, 133, '2015-02-01 00:44:52.000000', 'consum', 0.0219, 'lps'),
	(673734, 133, '2015-02-01 00:44:53.000000', 'consum', 0.0215, 'lps'),
	(673735, 133, '2015-02-01 00:44:54.000000', 'consum', 0.0211, 'lps'),
	(673736, 133, '2015-02-01 00:44:55.000000', 'consum', 0.0210, 'lps'),
	(673737, 133, '2015-02-01 00:44:56.000000', 'consum', 0.0210, 'lps'),
	(673738, 133, '2015-02-01 00:44:57.000000', 'consum', 0.0220, 'lps'),
	(673739, 133, '2015-02-01 00:44:58.000000', 'consum', 0.0215, 'lps'),
	(673740, 133, '2015-02-01 00:44:59.000000', 'consum', 0.0218, 'lps'),
	(673741, 133, '2015-02-01 00:45:00.000000', 'consum', 0.0210, 'lps'),
	(673742, 133, '2015-02-01 00:45:01.000000', 'consum', 0.0210, 'lps'),
	(673743, 133, '2015-02-01 00:45:02.000000', 'consum', 0.0211, 'lps'),
	(673744, 133, '2015-02-01 00:45:03.000000', 'consum', 0.0214, 'lps'),
	(673745, 133, '2015-02-01 00:45:04.000000', 'consum', 0.0215, 'lps'),
	(673746, 133, '2015-02-01 00:45:05.000000', 'consum', 0.0212, 'lps'),
	(673747, 133, '2015-02-01 00:45:06.000000', 'consum', 0.0219, 'lps'),
	(673748, 133, '2015-02-01 00:45:07.000000', 'consum', 0.0212, 'lps'),
	(673749, 133, '2015-02-01 00:45:08.000000', 'consum', 0.0218, 'lps'),
	(673750, 133, '2015-02-01 00:45:09.000000', 'consum', 0.0210, 'lps'),
	(673751, 133, '2015-02-01 00:45:10.000000', 'consum', 0.0210, 'lps'),
	(673752, 133, '2015-02-01 00:45:11.000000', 'consum', 0.0210, 'lps'),
	(673753, 133, '2015-02-01 00:45:12.000000', 'consum', 0.0212, 'lps'),
	(673754, 133, '2015-02-01 00:45:13.000000', 'consum', 0.0221, 'lps'),
	(673755, 133, '2015-02-01 00:45:14.000000', 'consum', 0.0212, 'lps'),
	(673756, 133, '2015-02-01 00:45:15.000000', 'consum', 0.0220, 'lps'),
	(673757, 133, '2015-02-01 00:45:16.000000', 'consum', 0.0210, 'lps'),
	(673758, 133, '2015-02-01 00:45:17.000000', 'consum', 0.0216, 'lps'),
	(673759, 133, '2015-02-01 00:45:18.000000', 'consum', 0.0217, 'lps'),
	(673760, 133, '2015-02-01 00:45:19.000000', 'consum', 0.0213, 'lps'),
	(673761, 133, '2015-02-01 00:45:20.000000', 'consum', 0.0219, 'lps'),
	(673762, 133, '2015-02-01 00:45:21.000000', 'consum', 0.0220, 'lps'),
	(673763, 133, '2015-02-01 00:45:22.000000', 'consum', 0.0221, 'lps'),
	(673764, 133, '2015-02-01 00:45:23.000000', 'consum', 0.0211, 'lps'),
	(673765, 133, '2015-02-01 00:45:24.000000', 'consum', 0.0220, 'lps'),
	(673766, 133, '2015-02-01 00:45:25.000000', 'consum', 0.0219, 'lps'),
	(673767, 133, '2015-02-01 00:45:26.000000', 'consum', 0.0217, 'lps'),
	(673768, 133, '2015-02-01 00:45:27.000000', 'consum', 0.0217, 'lps'),
	(673769, 133, '2015-02-01 00:45:28.000000', 'consum', 0.0211, 'lps'),
	(673770, 133, '2015-02-01 00:45:29.000000', 'consum', 0.0218, 'lps'),
	(673771, 133, '2015-02-01 00:45:30.000000', 'consum', 0.0214, 'lps'),
	(673772, 133, '2015-02-01 00:45:31.000000', 'consum', 0.0219, 'lps'),
	(673773, 133, '2015-02-01 00:45:32.000000', 'consum', 0.0220, 'lps'),
	(673774, 133, '2015-02-01 00:45:33.000000', 'consum', 0.0210, 'lps'),
	(673775, 133, '2015-02-01 00:45:34.000000', 'consum', 0.0215, 'lps'),
	(673776, 133, '2015-02-01 00:45:35.000000', 'consum', 0.0213, 'lps'),
	(673777, 133, '2015-02-01 00:45:36.000000', 'consum', 0.0211, 'lps'),
	(673778, 133, '2015-02-01 00:45:37.000000', 'consum', 0.0218, 'lps'),
	(673779, 133, '2015-02-01 00:45:38.000000', 'consum', 0.0211, 'lps'),
	(673780, 133, '2015-02-01 00:45:39.000000', 'consum', 0.0216, 'lps'),
	(673781, 133, '2015-02-01 00:45:40.000000', 'consum', 0.0215, 'lps'),
	(673782, 133, '2015-02-01 00:45:41.000000', 'consum', 0.0215, 'lps'),
	(673783, 133, '2015-02-01 00:45:42.000000', 'consum', 0.0220, 'lps'),
	(673784, 133, '2015-02-01 00:45:43.000000', 'consum', 0.0210, 'lps'),
	(673785, 133, '2015-02-01 00:45:44.000000', 'consum', 0.0217, 'lps'),
	(673786, 133, '2015-02-01 00:45:45.000000', 'consum', 0.0211, 'lps'),
	(673787, 133, '2015-02-01 00:45:46.000000', 'consum', 0.0218, 'lps'),
	(673788, 133, '2015-02-01 00:45:47.000000', 'consum', 0.0210, 'lps'),
	(673789, 133, '2015-02-01 00:45:48.000000', 'consum', 0.0212, 'lps'),
	(673790, 133, '2015-02-01 00:45:49.000000', 'consum', 0.0220, 'lps'),
	(673791, 133, '2015-02-01 00:45:50.000000', 'consum', 0.0220, 'lps'),
	(673792, 133, '2015-02-01 00:45:51.000000', 'consum', 0.0218, 'lps'),
	(673793, 133, '2015-02-01 00:45:52.000000', 'consum', 0.0221, 'lps'),
	(673794, 133, '2015-02-01 00:45:53.000000', 'consum', 0.0219, 'lps'),
	(673795, 133, '2015-02-01 00:45:54.000000', 'consum', 0.0221, 'lps'),
	(673796, 133, '2015-02-01 00:45:55.000000', 'consum', 0.0214, 'lps'),
	(673797, 133, '2015-02-01 00:45:56.000000', 'consum', 0.0221, 'lps'),
	(673798, 133, '2015-02-01 00:45:57.000000', 'consum', 0.0218, 'lps'),
	(673799, 133, '2015-02-01 00:45:58.000000', 'consum', 0.0217, 'lps'),
	(673800, 133, '2015-02-01 00:45:59.000000', 'consum', 0.0212, 'lps'),
	(673801, 133, '2015-02-01 00:46:00.000000', 'consum', 0.0221, 'lps'),
	(673802, 133, '2015-02-01 00:46:01.000000', 'consum', 0.0213, 'lps'),
	(673803, 133, '2015-02-01 00:46:02.000000', 'consum', 0.0214, 'lps'),
	(673804, 133, '2015-02-01 00:46:03.000000', 'consum', 0.0212, 'lps'),
	(673805, 133, '2015-02-01 00:46:04.000000', 'consum', 0.0219, 'lps'),
	(673806, 133, '2015-02-01 00:46:05.000000', 'consum', 0.0213, 'lps'),
	(673807, 133, '2015-02-01 00:46:06.000000', 'consum', 0.0210, 'lps'),
	(673808, 133, '2015-02-01 00:46:07.000000', 'consum', 0.0215, 'lps'),
	(673809, 133, '2015-02-01 00:46:08.000000', 'consum', 0.0213, 'lps'),
	(673810, 133, '2015-02-01 00:46:09.000000', 'consum', 0.0220, 'lps'),
	(673811, 133, '2015-02-01 00:46:10.000000', 'consum', 0.0215, 'lps'),
	(673812, 133, '2015-02-01 00:46:11.000000', 'consum', 0.0217, 'lps'),
	(673813, 133, '2015-02-01 00:46:12.000000', 'consum', 0.0217, 'lps'),
	(673814, 133, '2015-02-01 00:46:13.000000', 'consum', 0.0216, 'lps'),
	(673815, 133, '2015-02-01 00:46:14.000000', 'consum', 0.0219, 'lps'),
	(673816, 133, '2015-02-01 00:46:15.000000', 'consum', 0.0214, 'lps'),
	(673817, 133, '2015-02-01 00:46:16.000000', 'consum', 0.0216, 'lps'),
	(673818, 133, '2015-02-01 00:46:17.000000', 'consum', 0.0217, 'lps'),
	(673819, 133, '2015-02-01 00:46:18.000000', 'consum', 0.0213, 'lps'),
	(673820, 133, '2015-02-01 00:46:19.000000', 'consum', 0.0218, 'lps'),
	(673821, 133, '2015-02-01 00:46:20.000000', 'consum', 0.0218, 'lps'),
	(673822, 133, '2015-02-01 00:46:21.000000', 'consum', 0.0212, 'lps'),
	(673823, 133, '2015-02-01 00:46:22.000000', 'consum', 0.0210, 'lps'),
	(673824, 133, '2015-02-01 00:46:23.000000', 'consum', 0.0217, 'lps'),
	(673825, 133, '2015-02-01 00:46:24.000000', 'consum', 0.0219, 'lps'),
	(673826, 133, '2015-02-01 00:46:25.000000', 'consum', 0.0213, 'lps'),
	(673827, 133, '2015-02-01 00:46:26.000000', 'consum', 0.0220, 'lps'),
	(673828, 133, '2015-02-01 00:46:27.000000', 'consum', 0.0216, 'lps'),
	(673829, 133, '2015-02-01 00:46:28.000000', 'consum', 0.0211, 'lps'),
	(673830, 133, '2015-02-01 00:46:29.000000', 'consum', 0.0210, 'lps'),
	(673831, 133, '2015-02-01 00:46:30.000000', 'consum', 0.0220, 'lps'),
	(673832, 133, '2015-02-01 00:46:31.000000', 'consum', 0.0213, 'lps'),
	(673833, 133, '2015-02-01 00:46:32.000000', 'consum', 0.0219, 'lps'),
	(673834, 133, '2015-02-01 00:46:33.000000', 'consum', 0.0211, 'lps'),
	(673835, 133, '2015-02-01 00:46:34.000000', 'consum', 0.0211, 'lps'),
	(673836, 133, '2015-02-01 00:46:35.000000', 'consum', 0.0214, 'lps'),
	(673837, 133, '2015-02-01 00:46:36.000000', 'consum', 0.0216, 'lps'),
	(673838, 133, '2015-02-01 00:46:37.000000', 'consum', 0.0215, 'lps'),
	(673839, 133, '2015-02-01 00:46:38.000000', 'consum', 0.0218, 'lps'),
	(673840, 133, '2015-02-01 00:46:39.000000', 'consum', 0.0211, 'lps'),
	(673841, 133, '2015-02-01 00:46:40.000000', 'consum', 0.0217, 'lps'),
	(673842, 133, '2015-02-01 00:46:41.000000', 'consum', 0.0217, 'lps'),
	(673843, 133, '2015-02-01 00:46:42.000000', 'consum', 0.0214, 'lps'),
	(673844, 133, '2015-02-01 00:46:43.000000', 'consum', 0.0211, 'lps'),
	(673845, 133, '2015-02-01 00:46:44.000000', 'consum', 0.0212, 'lps'),
	(673846, 133, '2015-02-01 00:46:45.000000', 'consum', 0.0219, 'lps'),
	(673847, 133, '2015-02-01 00:46:46.000000', 'consum', 0.0214, 'lps'),
	(673848, 133, '2015-02-01 00:46:47.000000', 'consum', 0.0215, 'lps'),
	(673849, 133, '2015-02-01 00:46:48.000000', 'consum', 0.0212, 'lps'),
	(673850, 133, '2015-02-01 00:46:49.000000', 'consum', 0.0219, 'lps'),
	(673851, 133, '2015-02-01 00:46:50.000000', 'consum', 0.0214, 'lps'),
	(673852, 133, '2015-02-01 00:46:51.000000', 'consum', 0.0213, 'lps'),
	(673853, 133, '2015-02-01 00:46:52.000000', 'consum', 0.0213, 'lps'),
	(673854, 133, '2015-02-01 00:46:53.000000', 'consum', 0.0216, 'lps'),
	(673855, 133, '2015-02-01 00:46:54.000000', 'consum', 0.0219, 'lps'),
	(673856, 133, '2015-02-01 00:46:55.000000', 'consum', 0.0216, 'lps'),
	(673857, 133, '2015-02-01 00:46:56.000000', 'consum', 0.0213, 'lps'),
	(673858, 133, '2015-02-01 00:46:57.000000', 'consum', 0.0221, 'lps'),
	(673859, 133, '2015-02-01 00:46:58.000000', 'consum', 0.0220, 'lps'),
	(673860, 133, '2015-02-01 00:46:59.000000', 'consum', 0.0217, 'lps'),
	(673861, 133, '2015-02-01 00:47:00.000000', 'consum', 0.0214, 'lps'),
	(673862, 133, '2015-02-01 00:47:01.000000', 'consum', 0.0212, 'lps'),
	(673863, 133, '2015-02-01 00:47:02.000000', 'consum', 0.0217, 'lps'),
	(673864, 133, '2015-02-01 00:47:03.000000', 'consum', 0.0216, 'lps'),
	(673865, 133, '2015-02-01 00:47:04.000000', 'consum', 0.0221, 'lps'),
	(673866, 133, '2015-02-01 00:47:05.000000', 'consum', 0.0210, 'lps'),
	(673867, 133, '2015-02-01 00:47:06.000000', 'consum', 0.0212, 'lps'),
	(673868, 133, '2015-02-01 00:47:07.000000', 'consum', 0.0210, 'lps'),
	(673869, 133, '2015-02-01 00:47:08.000000', 'consum', 0.0215, 'lps'),
	(673870, 133, '2015-02-01 00:47:09.000000', 'consum', 0.0212, 'lps'),
	(673871, 133, '2015-02-01 00:47:10.000000', 'consum', 0.0219, 'lps'),
	(673872, 133, '2015-02-01 00:47:11.000000', 'consum', 0.0212, 'lps'),
	(673873, 133, '2015-02-01 00:47:12.000000', 'consum', 0.0220, 'lps'),
	(673874, 133, '2015-02-01 00:47:13.000000', 'consum', 0.0218, 'lps'),
	(673875, 133, '2015-02-01 00:47:14.000000', 'consum', 0.0218, 'lps'),
	(673876, 133, '2015-02-01 00:47:15.000000', 'consum', 0.0216, 'lps'),
	(673877, 133, '2015-02-01 00:47:16.000000', 'consum', 0.0218, 'lps'),
	(673878, 133, '2015-02-01 00:47:17.000000', 'consum', 0.0220, 'lps'),
	(673879, 133, '2015-02-01 00:47:18.000000', 'consum', 0.0212, 'lps'),
	(673880, 133, '2015-02-01 00:47:19.000000', 'consum', 0.0215, 'lps'),
	(673881, 133, '2015-02-01 00:47:20.000000', 'consum', 0.0219, 'lps'),
	(673882, 133, '2015-02-01 00:47:21.000000', 'consum', 0.0214, 'lps'),
	(673883, 133, '2015-02-01 00:47:22.000000', 'consum', 0.0218, 'lps'),
	(673884, 133, '2015-02-01 00:47:23.000000', 'consum', 0.0212, 'lps'),
	(673885, 133, '2015-02-01 00:47:24.000000', 'consum', 0.0211, 'lps'),
	(673886, 133, '2015-02-01 00:47:25.000000', 'consum', 0.0210, 'lps'),
	(673887, 133, '2015-02-01 00:47:26.000000', 'consum', 0.0218, 'lps'),
	(673888, 133, '2015-02-01 00:47:27.000000', 'consum', 0.0214, 'lps'),
	(673889, 133, '2015-02-01 00:47:28.000000', 'consum', 0.0218, 'lps'),
	(673890, 133, '2015-02-01 00:47:29.000000', 'consum', 0.0213, 'lps'),
	(673891, 133, '2015-02-01 00:47:30.000000', 'consum', 0.0216, 'lps'),
	(673892, 133, '2015-02-01 00:47:31.000000', 'consum', 0.0220, 'lps'),
	(673893, 133, '2015-02-01 00:47:32.000000', 'consum', 0.0217, 'lps'),
	(673894, 133, '2015-02-01 00:47:33.000000', 'consum', 0.0215, 'lps'),
	(673895, 133, '2015-02-01 00:47:34.000000', 'consum', 0.0215, 'lps'),
	(673896, 133, '2015-02-01 00:47:35.000000', 'consum', 0.0219, 'lps'),
	(673897, 133, '2015-02-01 00:47:36.000000', 'consum', 0.0219, 'lps'),
	(673898, 133, '2015-02-01 00:47:37.000000', 'consum', 0.0218, 'lps'),
	(673899, 133, '2015-02-01 00:47:38.000000', 'consum', 0.0220, 'lps'),
	(673900, 133, '2015-02-01 00:47:39.000000', 'consum', 0.0214, 'lps'),
	(673901, 133, '2015-02-01 00:47:40.000000', 'consum', 0.0213, 'lps'),
	(673902, 133, '2015-02-01 00:47:41.000000', 'consum', 0.0213, 'lps'),
	(673903, 133, '2015-02-01 00:47:42.000000', 'consum', 0.0218, 'lps'),
	(673904, 133, '2015-02-01 00:47:43.000000', 'consum', 0.0215, 'lps'),
	(673905, 133, '2015-02-01 00:47:44.000000', 'consum', 0.0212, 'lps'),
	(673906, 133, '2015-02-01 00:47:45.000000', 'consum', 0.0217, 'lps'),
	(673907, 133, '2015-02-01 00:47:46.000000', 'consum', 0.0216, 'lps'),
	(673908, 133, '2015-02-01 00:47:47.000000', 'consum', 0.0218, 'lps'),
	(673909, 133, '2015-02-01 00:47:48.000000', 'consum', 0.0221, 'lps'),
	(673910, 133, '2015-02-01 00:47:49.000000', 'consum', 0.0218, 'lps'),
	(673911, 133, '2015-02-01 00:47:50.000000', 'consum', 0.0219, 'lps'),
	(673912, 133, '2015-02-01 00:47:51.000000', 'consum', 0.0217, 'lps'),
	(673913, 133, '2015-02-01 00:47:52.000000', 'consum', 0.0221, 'lps'),
	(673914, 133, '2015-02-01 00:47:53.000000', 'consum', 0.0220, 'lps'),
	(673915, 133, '2015-02-01 00:47:54.000000', 'consum', 0.0215, 'lps'),
	(673916, 133, '2015-02-01 00:47:55.000000', 'consum', 0.0219, 'lps'),
	(673917, 133, '2015-02-01 00:47:56.000000', 'consum', 0.0218, 'lps'),
	(673918, 133, '2015-02-01 00:47:57.000000', 'consum', 0.0220, 'lps'),
	(673919, 133, '2015-02-01 00:47:58.000000', 'consum', 0.0213, 'lps'),
	(673920, 133, '2015-02-01 00:47:59.000000', 'consum', 0.0221, 'lps'),
	(673921, 133, '2015-02-01 00:48:00.000000', 'consum', 0.0221, 'lps'),
	(673922, 133, '2015-02-01 00:48:01.000000', 'consum', 0.0220, 'lps'),
	(673923, 133, '2015-02-01 00:48:02.000000', 'consum', 0.0217, 'lps'),
	(673924, 133, '2015-02-01 00:48:03.000000', 'consum', 0.0215, 'lps'),
	(673925, 133, '2015-02-01 00:48:04.000000', 'consum', 0.0215, 'lps'),
	(673926, 133, '2015-02-01 00:48:05.000000', 'consum', 0.0218, 'lps'),
	(673927, 133, '2015-02-01 00:48:06.000000', 'consum', 0.0212, 'lps'),
	(673928, 133, '2015-02-01 00:48:07.000000', 'consum', 0.0220, 'lps'),
	(673929, 133, '2015-02-01 00:48:08.000000', 'consum', 0.0217, 'lps'),
	(673930, 133, '2015-02-01 00:48:09.000000', 'consum', 0.0218, 'lps'),
	(673931, 133, '2015-02-01 00:48:10.000000', 'consum', 0.0215, 'lps'),
	(673932, 133, '2015-02-01 00:48:11.000000', 'consum', 0.0211, 'lps'),
	(673933, 133, '2015-02-01 00:48:12.000000', 'consum', 0.0216, 'lps'),
	(673934, 133, '2015-02-01 00:48:13.000000', 'consum', 0.0211, 'lps'),
	(673935, 133, '2015-02-01 00:48:14.000000', 'consum', 0.0210, 'lps'),
	(673936, 133, '2015-02-01 00:48:15.000000', 'consum', 0.0218, 'lps'),
	(673937, 133, '2015-02-01 00:48:16.000000', 'consum', 0.0217, 'lps'),
	(673938, 133, '2015-02-01 00:48:17.000000', 'consum', 0.0221, 'lps'),
	(673939, 133, '2015-02-01 00:48:18.000000', 'consum', 0.0219, 'lps'),
	(673940, 133, '2015-02-01 00:48:19.000000', 'consum', 0.0213, 'lps'),
	(673941, 133, '2015-02-01 00:48:20.000000', 'consum', 0.0210, 'lps'),
	(673942, 133, '2015-02-01 00:48:21.000000', 'consum', 0.0211, 'lps'),
	(673943, 133, '2015-02-01 00:48:22.000000', 'consum', 0.0219, 'lps'),
	(673944, 133, '2015-02-01 00:48:23.000000', 'consum', 0.0215, 'lps'),
	(673945, 133, '2015-02-01 00:48:24.000000', 'consum', 0.0219, 'lps'),
	(673946, 133, '2015-02-01 00:48:25.000000', 'consum', 0.0216, 'lps'),
	(673947, 133, '2015-02-01 00:48:26.000000', 'consum', 0.0215, 'lps'),
	(673948, 133, '2015-02-01 00:48:27.000000', 'consum', 0.0215, 'lps'),
	(673949, 133, '2015-02-01 00:48:28.000000', 'consum', 0.0211, 'lps'),
	(673950, 133, '2015-02-01 00:48:29.000000', 'consum', 0.0212, 'lps'),
	(673951, 133, '2015-02-01 00:48:30.000000', 'consum', 0.0216, 'lps'),
	(673952, 133, '2015-02-01 00:48:31.000000', 'consum', 0.0213, 'lps'),
	(673953, 133, '2015-02-01 00:48:32.000000', 'consum', 0.0217, 'lps'),
	(673954, 133, '2015-02-01 00:48:33.000000', 'consum', 0.0214, 'lps'),
	(673955, 133, '2015-02-01 00:48:34.000000', 'consum', 0.0211, 'lps'),
	(673956, 133, '2015-02-01 00:48:35.000000', 'consum', 0.0215, 'lps'),
	(673957, 133, '2015-02-01 00:48:36.000000', 'consum', 0.0210, 'lps'),
	(673958, 133, '2015-02-01 00:48:37.000000', 'consum', 0.0217, 'lps'),
	(673959, 133, '2015-02-01 00:48:38.000000', 'consum', 0.0210, 'lps'),
	(673960, 133, '2015-02-01 00:48:39.000000', 'consum', 0.0214, 'lps'),
	(673961, 133, '2015-02-01 00:48:40.000000', 'consum', 0.0220, 'lps'),
	(673962, 133, '2015-02-01 00:48:41.000000', 'consum', 0.0210, 'lps'),
	(673963, 133, '2015-02-01 00:48:42.000000', 'consum', 0.0217, 'lps'),
	(673964, 133, '2015-02-01 00:48:43.000000', 'consum', 0.0220, 'lps'),
	(673965, 133, '2015-02-01 00:48:44.000000', 'consum', 0.0215, 'lps'),
	(673966, 133, '2015-02-01 00:48:45.000000', 'consum', 0.0220, 'lps'),
	(673967, 133, '2015-02-01 00:48:46.000000', 'consum', 0.0220, 'lps'),
	(673968, 133, '2015-02-01 00:48:47.000000', 'consum', 0.0217, 'lps'),
	(673969, 133, '2015-02-01 00:48:48.000000', 'consum', 0.0216, 'lps'),
	(673970, 133, '2015-02-01 00:48:49.000000', 'consum', 0.0210, 'lps'),
	(673971, 133, '2015-02-01 00:48:50.000000', 'consum', 0.0215, 'lps'),
	(673972, 133, '2015-02-01 00:48:51.000000', 'consum', 0.0210, 'lps'),
	(673973, 133, '2015-02-01 00:48:52.000000', 'consum', 0.0221, 'lps'),
	(673974, 133, '2015-02-01 00:48:53.000000', 'consum', 0.0216, 'lps'),
	(673975, 133, '2015-02-01 00:48:54.000000', 'consum', 0.0220, 'lps'),
	(673976, 133, '2015-02-01 00:48:55.000000', 'consum', 0.0220, 'lps'),
	(673977, 133, '2015-02-01 00:48:56.000000', 'consum', 0.0220, 'lps'),
	(673978, 133, '2015-02-01 00:48:57.000000', 'consum', 0.0216, 'lps'),
	(673979, 133, '2015-02-01 00:48:58.000000', 'consum', 0.0221, 'lps'),
	(673980, 133, '2015-02-01 00:48:59.000000', 'consum', 0.0214, 'lps'),
	(673981, 133, '2015-02-01 00:49:00.000000', 'consum', 0.0210, 'lps'),
	(673982, 133, '2015-02-01 00:49:01.000000', 'consum', 0.0210, 'lps'),
	(673983, 133, '2015-02-01 00:49:02.000000', 'consum', 0.0210, 'lps'),
	(673984, 133, '2015-02-01 00:49:03.000000', 'consum', 0.0211, 'lps'),
	(673985, 133, '2015-02-01 00:49:04.000000', 'consum', 0.0217, 'lps'),
	(673986, 133, '2015-02-01 00:49:05.000000', 'consum', 0.0219, 'lps'),
	(673987, 133, '2015-02-01 00:49:06.000000', 'consum', 0.0221, 'lps'),
	(673988, 133, '2015-02-01 00:49:07.000000', 'consum', 0.0214, 'lps'),
	(673989, 133, '2015-02-01 00:49:08.000000', 'consum', 0.0210, 'lps'),
	(673990, 133, '2015-02-01 00:49:09.000000', 'consum', 0.0210, 'lps'),
	(673991, 133, '2015-02-01 00:49:10.000000', 'consum', 0.0210, 'lps'),
	(673992, 133, '2015-02-01 00:49:11.000000', 'consum', 0.0211, 'lps'),
	(673993, 133, '2015-02-01 00:49:12.000000', 'consum', 0.0214, 'lps'),
	(673994, 133, '2015-02-01 00:49:13.000000', 'consum', 0.0217, 'lps'),
	(673995, 133, '2015-02-01 00:49:14.000000', 'consum', 0.0221, 'lps'),
	(673996, 133, '2015-02-01 00:49:15.000000', 'consum', 0.0221, 'lps'),
	(673997, 133, '2015-02-01 00:49:16.000000', 'consum', 0.0219, 'lps'),
	(673998, 133, '2015-02-01 00:49:17.000000', 'consum', 0.0212, 'lps'),
	(673999, 133, '2015-02-01 00:49:18.000000', 'consum', 0.0217, 'lps'),
	(674000, 133, '2015-02-01 00:49:19.000000', 'consum', 0.0215, 'lps'),
	(674001, 133, '2015-02-01 00:49:20.000000', 'consum', 0.0213, 'lps'),
	(674002, 133, '2015-02-01 00:49:21.000000', 'consum', 0.0211, 'lps'),
	(674003, 133, '2015-02-01 00:49:22.000000', 'consum', 0.0219, 'lps'),
	(674004, 133, '2015-02-01 00:49:23.000000', 'consum', 0.0215, 'lps'),
	(674005, 133, '2015-02-01 00:49:24.000000', 'consum', 0.0220, 'lps'),
	(674006, 133, '2015-02-01 00:49:25.000000', 'consum', 0.0210, 'lps'),
	(674007, 133, '2015-02-01 00:49:26.000000', 'consum', 0.0215, 'lps'),
	(674008, 133, '2015-02-01 00:49:27.000000', 'consum', 0.0212, 'lps'),
	(674009, 133, '2015-02-01 00:49:28.000000', 'consum', 0.0219, 'lps'),
	(674010, 133, '2015-02-01 00:49:29.000000', 'consum', 0.0213, 'lps'),
	(674011, 133, '2015-02-01 00:49:30.000000', 'consum', 0.0212, 'lps'),
	(674012, 133, '2015-02-01 00:49:31.000000', 'consum', 0.0220, 'lps'),
	(674013, 133, '2015-02-01 00:49:32.000000', 'consum', 0.0210, 'lps'),
	(674014, 133, '2015-02-01 00:49:33.000000', 'consum', 0.0216, 'lps'),
	(674015, 133, '2015-02-01 00:49:34.000000', 'consum', 0.0214, 'lps'),
	(674016, 133, '2015-02-01 00:49:35.000000', 'consum', 0.0215, 'lps'),
	(674017, 133, '2015-02-01 00:49:36.000000', 'consum', 0.0221, 'lps'),
	(674018, 133, '2015-02-01 00:49:37.000000', 'consum', 0.0216, 'lps'),
	(674019, 133, '2015-02-01 00:49:38.000000', 'consum', 0.0218, 'lps'),
	(674020, 133, '2015-02-01 00:49:39.000000', 'consum', 0.0220, 'lps'),
	(674021, 133, '2015-02-01 00:49:40.000000', 'consum', 0.0215, 'lps'),
	(674022, 133, '2015-02-01 00:49:41.000000', 'consum', 0.0216, 'lps'),
	(674023, 133, '2015-02-01 00:49:42.000000', 'consum', 0.0212, 'lps'),
	(674024, 133, '2015-02-01 00:49:43.000000', 'consum', 0.0216, 'lps'),
	(674025, 133, '2015-02-01 00:49:44.000000', 'consum', 0.0221, 'lps'),
	(674026, 133, '2015-02-01 00:49:45.000000', 'consum', 0.0211, 'lps'),
	(674027, 133, '2015-02-01 00:49:46.000000', 'consum', 0.0220, 'lps'),
	(674028, 133, '2015-02-01 00:49:47.000000', 'consum', 0.0221, 'lps'),
	(674029, 133, '2015-02-01 00:49:48.000000', 'consum', 0.0211, 'lps'),
	(674030, 133, '2015-02-01 00:49:49.000000', 'consum', 0.0218, 'lps'),
	(674031, 133, '2015-02-01 00:49:50.000000', 'consum', 0.0214, 'lps'),
	(674032, 133, '2015-02-01 00:49:51.000000', 'consum', 0.0217, 'lps'),
	(674033, 133, '2015-02-01 00:49:52.000000', 'consum', 0.0211, 'lps'),
	(674034, 133, '2015-02-01 00:49:53.000000', 'consum', 0.0216, 'lps'),
	(674035, 133, '2015-02-01 00:49:54.000000', 'consum', 0.0215, 'lps'),
	(674036, 133, '2015-02-01 00:49:55.000000', 'consum', 0.0219, 'lps'),
	(674037, 133, '2015-02-01 00:49:56.000000', 'consum', 0.0214, 'lps'),
	(674038, 133, '2015-02-01 00:49:57.000000', 'consum', 0.0217, 'lps'),
	(674039, 133, '2015-02-01 00:49:58.000000', 'consum', 0.0221, 'lps'),
	(674040, 133, '2015-02-01 00:49:59.000000', 'consum', 0.0211, 'lps'),
	(674041, 133, '2015-02-01 00:50:00.000000', 'consum', 0.0215, 'lps'),
	(674042, 133, '2015-02-01 00:50:01.000000', 'consum', 0.0210, 'lps'),
	(674043, 133, '2015-02-01 00:50:02.000000', 'consum', 0.0221, 'lps'),
	(674044, 133, '2015-02-01 00:50:03.000000', 'consum', 0.0214, 'lps'),
	(674045, 133, '2015-02-01 00:50:04.000000', 'consum', 0.0213, 'lps'),
	(674046, 133, '2015-02-01 00:50:05.000000', 'consum', 0.0213, 'lps'),
	(674047, 133, '2015-02-01 00:50:06.000000', 'consum', 0.0216, 'lps'),
	(674048, 133, '2015-02-01 00:50:07.000000', 'consum', 0.0218, 'lps'),
	(674049, 133, '2015-02-01 00:50:08.000000', 'consum', 0.0211, 'lps'),
	(674050, 133, '2015-02-01 00:50:09.000000', 'consum', 0.0215, 'lps'),
	(674051, 133, '2015-02-01 00:50:10.000000', 'consum', 0.0218, 'lps'),
	(674052, 133, '2015-02-01 00:50:11.000000', 'consum', 0.0214, 'lps'),
	(674053, 133, '2015-02-01 00:50:12.000000', 'consum', 0.0217, 'lps'),
	(674054, 133, '2015-02-01 00:50:13.000000', 'consum', 0.0221, 'lps'),
	(674055, 133, '2015-02-01 00:50:14.000000', 'consum', 0.0221, 'lps'),
	(674056, 133, '2015-02-01 00:50:15.000000', 'consum', 0.0210, 'lps'),
	(674057, 133, '2015-02-01 00:50:16.000000', 'consum', 0.0213, 'lps'),
	(674058, 133, '2015-02-01 00:50:17.000000', 'consum', 0.0214, 'lps'),
	(674059, 133, '2015-02-01 00:50:18.000000', 'consum', 0.0220, 'lps'),
	(674060, 133, '2015-02-01 00:50:19.000000', 'consum', 0.0214, 'lps'),
	(674061, 133, '2015-02-01 00:50:20.000000', 'consum', 0.0211, 'lps'),
	(674062, 133, '2015-02-01 00:50:21.000000', 'consum', 0.0218, 'lps'),
	(674063, 133, '2015-02-01 00:50:22.000000', 'consum', 0.0211, 'lps'),
	(674064, 133, '2015-02-01 00:50:23.000000', 'consum', 0.0217, 'lps'),
	(674065, 133, '2015-02-01 00:50:24.000000', 'consum', 0.0215, 'lps'),
	(674066, 133, '2015-02-01 00:50:25.000000', 'consum', 0.0216, 'lps'),
	(674067, 133, '2015-02-01 00:50:26.000000', 'consum', 0.0215, 'lps'),
	(674068, 133, '2015-02-01 00:50:27.000000', 'consum', 0.0216, 'lps'),
	(674069, 133, '2015-02-01 00:50:28.000000', 'consum', 0.0212, 'lps'),
	(674070, 133, '2015-02-01 00:50:29.000000', 'consum', 0.0215, 'lps'),
	(674071, 133, '2015-02-01 00:50:30.000000', 'consum', 0.0218, 'lps'),
	(674072, 133, '2015-02-01 00:50:31.000000', 'consum', 0.0211, 'lps'),
	(674073, 133, '2015-02-01 00:50:32.000000', 'consum', 0.0215, 'lps'),
	(674074, 133, '2015-02-01 00:50:33.000000', 'consum', 0.0220, 'lps'),
	(674075, 133, '2015-02-01 00:50:34.000000', 'consum', 0.0220, 'lps'),
	(674076, 133, '2015-02-01 00:50:35.000000', 'consum', 0.0210, 'lps'),
	(674077, 133, '2015-02-01 00:50:36.000000', 'consum', 0.0214, 'lps'),
	(674078, 133, '2015-02-01 00:50:37.000000', 'consum', 0.0217, 'lps'),
	(674079, 133, '2015-02-01 00:50:38.000000', 'consum', 0.0213, 'lps'),
	(674080, 133, '2015-02-01 00:50:39.000000', 'consum', 0.0215, 'lps'),
	(674081, 133, '2015-02-01 00:50:40.000000', 'consum', 0.0213, 'lps'),
	(674082, 133, '2015-02-01 00:50:41.000000', 'consum', 0.0211, 'lps'),
	(674083, 133, '2015-02-01 00:50:42.000000', 'consum', 0.0217, 'lps'),
	(674084, 133, '2015-02-01 00:50:43.000000', 'consum', 0.0220, 'lps'),
	(674085, 133, '2015-02-01 00:50:44.000000', 'consum', 0.0214, 'lps'),
	(674086, 133, '2015-02-01 00:50:45.000000', 'consum', 0.0212, 'lps'),
	(674087, 133, '2015-02-01 00:50:46.000000', 'consum', 0.0210, 'lps'),
	(674088, 133, '2015-02-01 00:50:47.000000', 'consum', 0.0215, 'lps'),
	(674089, 133, '2015-02-01 00:50:48.000000', 'consum', 0.0211, 'lps'),
	(674090, 133, '2015-02-01 00:50:49.000000', 'consum', 0.0214, 'lps'),
	(674091, 133, '2015-02-01 00:50:50.000000', 'consum', 0.0214, 'lps'),
	(674092, 133, '2015-02-01 00:50:51.000000', 'consum', 0.0219, 'lps'),
	(674093, 133, '2015-02-01 00:50:52.000000', 'consum', 0.0218, 'lps'),
	(674094, 133, '2015-02-01 00:50:53.000000', 'consum', 0.0213, 'lps'),
	(674095, 133, '2015-02-01 00:50:54.000000', 'consum', 0.0213, 'lps'),
	(674096, 133, '2015-02-01 00:50:55.000000', 'consum', 0.0216, 'lps'),
	(674097, 133, '2015-02-01 00:50:56.000000', 'consum', 0.0221, 'lps'),
	(674098, 133, '2015-02-01 00:50:57.000000', 'consum', 0.0211, 'lps'),
	(674099, 133, '2015-02-01 00:50:58.000000', 'consum', 0.0218, 'lps'),
	(674100, 133, '2015-02-01 00:50:59.000000', 'consum', 0.0210, 'lps'),
	(674101, 133, '2015-02-01 00:51:00.000000', 'consum', 0.0213, 'lps'),
	(674102, 133, '2015-02-01 00:51:01.000000', 'consum', 0.0211, 'lps'),
	(674103, 133, '2015-02-01 00:51:02.000000', 'consum', 0.0221, 'lps'),
	(674104, 133, '2015-02-01 00:51:03.000000', 'consum', 0.0211, 'lps'),
	(674105, 133, '2015-02-01 00:51:04.000000', 'consum', 0.0210, 'lps'),
	(674106, 133, '2015-02-01 00:51:05.000000', 'consum', 0.0218, 'lps'),
	(674107, 133, '2015-02-01 00:51:06.000000', 'consum', 0.0216, 'lps'),
	(674108, 133, '2015-02-01 00:51:07.000000', 'consum', 0.0218, 'lps'),
	(674109, 133, '2015-02-01 00:51:08.000000', 'consum', 0.0218, 'lps'),
	(674110, 133, '2015-02-01 00:51:09.000000', 'consum', 0.0213, 'lps'),
	(674111, 133, '2015-02-01 00:51:10.000000', 'consum', 0.0215, 'lps'),
	(674112, 133, '2015-02-01 00:51:11.000000', 'consum', 0.0215, 'lps'),
	(674113, 133, '2015-02-01 00:51:12.000000', 'consum', 0.0221, 'lps'),
	(674114, 133, '2015-02-01 00:51:13.000000', 'consum', 0.0213, 'lps'),
	(674115, 133, '2015-02-01 00:51:14.000000', 'consum', 0.0218, 'lps'),
	(674116, 133, '2015-02-01 00:51:15.000000', 'consum', 0.0215, 'lps'),
	(674117, 133, '2015-02-01 00:51:16.000000', 'consum', 0.0212, 'lps'),
	(674118, 133, '2015-02-01 00:51:17.000000', 'consum', 0.0219, 'lps'),
	(674119, 133, '2015-02-01 00:51:18.000000', 'consum', 0.0211, 'lps'),
	(674120, 133, '2015-02-01 00:51:19.000000', 'consum', 0.0213, 'lps'),
	(674121, 133, '2015-02-01 00:51:20.000000', 'consum', 0.0213, 'lps'),
	(674122, 133, '2015-02-01 00:51:21.000000', 'consum', 0.0214, 'lps'),
	(674123, 133, '2015-02-01 00:51:22.000000', 'consum', 0.0221, 'lps'),
	(674124, 133, '2015-02-01 00:51:23.000000', 'consum', 0.0217, 'lps'),
	(674125, 133, '2015-02-01 00:51:24.000000', 'consum', 0.0213, 'lps'),
	(674126, 133, '2015-02-01 00:51:25.000000', 'consum', 0.0219, 'lps'),
	(674127, 133, '2015-02-01 00:51:26.000000', 'consum', 0.0221, 'lps'),
	(674128, 133, '2015-02-01 00:51:27.000000', 'consum', 0.0213, 'lps'),
	(674129, 133, '2015-02-01 00:51:28.000000', 'consum', 0.0216, 'lps'),
	(674130, 133, '2015-02-01 00:51:29.000000', 'consum', 0.0210, 'lps'),
	(674131, 133, '2015-02-01 00:51:30.000000', 'consum', 0.0216, 'lps'),
	(674132, 133, '2015-02-01 00:51:31.000000', 'consum', 0.0216, 'lps'),
	(674133, 133, '2015-02-01 00:51:32.000000', 'consum', 0.0221, 'lps'),
	(674134, 133, '2015-02-01 00:51:33.000000', 'consum', 0.0213, 'lps'),
	(674135, 133, '2015-02-01 00:51:34.000000', 'consum', 0.0215, 'lps'),
	(674136, 133, '2015-02-01 00:51:35.000000', 'consum', 0.0217, 'lps'),
	(674137, 133, '2015-02-01 00:51:36.000000', 'consum', 0.0218, 'lps'),
	(674138, 133, '2015-02-01 00:51:37.000000', 'consum', 0.0215, 'lps'),
	(674139, 133, '2015-02-01 00:51:38.000000', 'consum', 0.0215, 'lps'),
	(674140, 133, '2015-02-01 00:51:39.000000', 'consum', 0.0217, 'lps'),
	(674141, 133, '2015-02-01 00:51:40.000000', 'consum', 0.0221, 'lps'),
	(674142, 133, '2015-02-01 00:51:41.000000', 'consum', 0.0219, 'lps'),
	(674143, 133, '2015-02-01 00:51:42.000000', 'consum', 0.0210, 'lps'),
	(674144, 133, '2015-02-01 00:51:43.000000', 'consum', 0.0210, 'lps'),
	(674145, 133, '2015-02-01 00:51:44.000000', 'consum', 0.0220, 'lps'),
	(674146, 133, '2015-02-01 00:51:45.000000', 'consum', 0.0212, 'lps'),
	(674147, 133, '2015-02-01 00:51:46.000000', 'consum', 0.0215, 'lps'),
	(674148, 133, '2015-02-01 00:51:47.000000', 'consum', 0.0216, 'lps'),
	(674149, 133, '2015-02-01 00:51:48.000000', 'consum', 0.0215, 'lps'),
	(674150, 133, '2015-02-01 00:51:49.000000', 'consum', 0.0219, 'lps'),
	(674151, 133, '2015-02-01 00:51:50.000000', 'consum', 0.0216, 'lps'),
	(674152, 133, '2015-02-01 00:51:51.000000', 'consum', 0.0213, 'lps'),
	(674153, 133, '2015-02-01 00:51:52.000000', 'consum', 0.0219, 'lps'),
	(674154, 133, '2015-02-01 00:51:53.000000', 'consum', 0.0210, 'lps'),
	(674155, 133, '2015-02-01 00:51:54.000000', 'consum', 0.0219, 'lps'),
	(674156, 133, '2015-02-01 00:51:55.000000', 'consum', 0.0219, 'lps'),
	(674157, 133, '2015-02-01 00:51:56.000000', 'consum', 0.0217, 'lps'),
	(674158, 133, '2015-02-01 00:51:57.000000', 'consum', 0.0217, 'lps'),
	(674159, 133, '2015-02-01 00:51:58.000000', 'consum', 0.0214, 'lps'),
	(674160, 133, '2015-02-01 00:51:59.000000', 'consum', 0.0221, 'lps'),
	(674161, 133, '2015-02-01 00:52:00.000000', 'consum', 0.0216, 'lps'),
	(674162, 133, '2015-02-01 00:52:01.000000', 'consum', 0.0221, 'lps'),
	(674163, 133, '2015-02-01 00:52:02.000000', 'consum', 0.0212, 'lps'),
	(674164, 133, '2015-02-01 00:52:03.000000', 'consum', 0.0211, 'lps'),
	(674165, 133, '2015-02-01 00:52:04.000000', 'consum', 0.0212, 'lps'),
	(674166, 133, '2015-02-01 00:52:05.000000', 'consum', 0.0214, 'lps'),
	(674167, 133, '2015-02-01 00:52:06.000000', 'consum', 0.0213, 'lps'),
	(674168, 133, '2015-02-01 00:52:07.000000', 'consum', 0.0215, 'lps'),
	(674169, 133, '2015-02-01 00:52:08.000000', 'consum', 0.0212, 'lps'),
	(674170, 133, '2015-02-01 00:52:09.000000', 'consum', 0.0220, 'lps'),
	(674171, 133, '2015-02-01 00:52:10.000000', 'consum', 0.0218, 'lps'),
	(674172, 133, '2015-02-01 00:52:11.000000', 'consum', 0.0221, 'lps'),
	(674173, 133, '2015-02-01 00:52:12.000000', 'consum', 0.0218, 'lps'),
	(674174, 133, '2015-02-01 00:52:13.000000', 'consum', 0.0218, 'lps'),
	(674175, 133, '2015-02-01 00:52:14.000000', 'consum', 0.0212, 'lps'),
	(674176, 133, '2015-02-01 00:52:15.000000', 'consum', 0.0210, 'lps'),
	(674177, 133, '2015-02-01 00:52:16.000000', 'consum', 0.0215, 'lps'),
	(674178, 133, '2015-02-01 00:52:17.000000', 'consum', 0.0213, 'lps'),
	(674179, 133, '2015-02-01 00:52:18.000000', 'consum', 0.0220, 'lps'),
	(674180, 133, '2015-02-01 00:52:19.000000', 'consum', 0.0219, 'lps'),
	(674181, 133, '2015-02-01 00:52:20.000000', 'consum', 0.0212, 'lps'),
	(674182, 133, '2015-02-01 00:52:21.000000', 'consum', 0.0217, 'lps'),
	(674183, 133, '2015-02-01 00:52:22.000000', 'consum', 0.0214, 'lps'),
	(674184, 133, '2015-02-01 00:52:23.000000', 'consum', 0.0213, 'lps'),
	(674185, 133, '2015-02-01 00:52:24.000000', 'consum', 0.0211, 'lps'),
	(674186, 133, '2015-02-01 00:52:25.000000', 'consum', 0.0218, 'lps'),
	(674187, 133, '2015-02-01 00:52:26.000000', 'consum', 0.0213, 'lps'),
	(674188, 133, '2015-02-01 00:52:27.000000', 'consum', 0.0213, 'lps'),
	(674189, 133, '2015-02-01 00:52:28.000000', 'consum', 0.0216, 'lps'),
	(674190, 133, '2015-02-01 00:52:29.000000', 'consum', 0.0221, 'lps'),
	(674191, 133, '2015-02-01 00:52:30.000000', 'consum', 0.0212, 'lps'),
	(674192, 133, '2015-02-01 00:52:31.000000', 'consum', 0.0212, 'lps'),
	(674193, 133, '2015-02-01 00:52:32.000000', 'consum', 0.0212, 'lps'),
	(674194, 133, '2015-02-01 00:52:33.000000', 'consum', 0.0218, 'lps'),
	(674195, 133, '2015-02-01 00:52:34.000000', 'consum', 0.0217, 'lps'),
	(674196, 133, '2015-02-01 00:52:35.000000', 'consum', 0.0212, 'lps'),
	(674197, 133, '2015-02-01 00:52:36.000000', 'consum', 0.0221, 'lps'),
	(674198, 133, '2015-02-01 00:52:37.000000', 'consum', 0.0212, 'lps'),
	(674199, 133, '2015-02-01 00:52:38.000000', 'consum', 0.0213, 'lps'),
	(674200, 133, '2015-02-01 00:52:39.000000', 'consum', 0.0219, 'lps'),
	(674201, 133, '2015-02-01 00:52:40.000000', 'consum', 0.0211, 'lps'),
	(674202, 133, '2015-02-01 00:52:41.000000', 'consum', 0.0213, 'lps'),
	(674203, 133, '2015-02-01 00:52:42.000000', 'consum', 0.0212, 'lps'),
	(674204, 133, '2015-02-01 00:52:43.000000', 'consum', 0.0221, 'lps'),
	(674205, 133, '2015-02-01 00:52:44.000000', 'consum', 0.0213, 'lps'),
	(674206, 133, '2015-02-01 00:52:45.000000', 'consum', 0.0217, 'lps'),
	(674207, 133, '2015-02-01 00:52:46.000000', 'consum', 0.0210, 'lps'),
	(674208, 133, '2015-02-01 00:52:47.000000', 'consum', 0.0217, 'lps'),
	(674209, 133, '2015-02-01 00:52:48.000000', 'consum', 0.0218, 'lps'),
	(674210, 133, '2015-02-01 00:52:49.000000', 'consum', 0.0221, 'lps'),
	(674211, 133, '2015-02-01 00:52:50.000000', 'consum', 0.0216, 'lps'),
	(674212, 133, '2015-02-01 00:52:51.000000', 'consum', 0.0218, 'lps'),
	(674213, 133, '2015-02-01 00:52:52.000000', 'consum', 0.0210, 'lps'),
	(674214, 133, '2015-02-01 00:52:53.000000', 'consum', 0.0210, 'lps'),
	(674215, 133, '2015-02-01 00:52:54.000000', 'consum', 0.0221, 'lps'),
	(674216, 133, '2015-02-01 00:52:55.000000', 'consum', 0.0218, 'lps'),
	(674217, 133, '2015-02-01 00:52:56.000000', 'consum', 0.0218, 'lps'),
	(674218, 133, '2015-02-01 00:52:57.000000', 'consum', 0.0216, 'lps'),
	(674219, 133, '2015-02-01 00:52:58.000000', 'consum', 0.0217, 'lps'),
	(674220, 133, '2015-02-01 00:52:59.000000', 'consum', 0.0214, 'lps'),
	(674221, 133, '2015-02-01 00:53:00.000000', 'consum', 0.0221, 'lps'),
	(674222, 133, '2015-02-01 00:53:01.000000', 'consum', 0.0218, 'lps'),
	(674223, 133, '2015-02-01 00:53:02.000000', 'consum', 0.0219, 'lps'),
	(674224, 133, '2015-02-01 00:53:03.000000', 'consum', 0.0217, 'lps'),
	(674225, 133, '2015-02-01 00:53:04.000000', 'consum', 0.0220, 'lps'),
	(674226, 133, '2015-02-01 00:53:05.000000', 'consum', 0.0217, 'lps'),
	(674227, 133, '2015-02-01 00:53:06.000000', 'consum', 0.0214, 'lps'),
	(674228, 133, '2015-02-01 00:53:07.000000', 'consum', 0.0220, 'lps'),
	(674229, 133, '2015-02-01 00:53:08.000000', 'consum', 0.0213, 'lps'),
	(674230, 133, '2015-02-01 00:53:09.000000', 'consum', 0.0218, 'lps'),
	(674231, 133, '2015-02-01 00:53:10.000000', 'consum', 0.0220, 'lps'),
	(674232, 133, '2015-02-01 00:53:11.000000', 'consum', 0.0210, 'lps'),
	(674233, 133, '2015-02-01 00:53:12.000000', 'consum', 0.0216, 'lps'),
	(674234, 133, '2015-02-01 00:53:13.000000', 'consum', 0.0217, 'lps'),
	(674235, 133, '2015-02-01 00:53:14.000000', 'consum', 0.0217, 'lps'),
	(674236, 133, '2015-02-01 00:53:15.000000', 'consum', 0.0213, 'lps'),
	(674237, 133, '2015-02-01 00:53:16.000000', 'consum', 0.0214, 'lps'),
	(674238, 133, '2015-02-01 00:53:17.000000', 'consum', 0.0221, 'lps'),
	(674239, 133, '2015-02-01 00:53:18.000000', 'consum', 0.0220, 'lps'),
	(674240, 133, '2015-02-01 00:53:19.000000', 'consum', 0.0216, 'lps'),
	(674241, 133, '2015-02-01 00:53:20.000000', 'consum', 0.0221, 'lps'),
	(674242, 133, '2015-02-01 00:53:21.000000', 'consum', 0.0211, 'lps'),
	(674243, 133, '2015-02-01 00:53:22.000000', 'consum', 0.0219, 'lps'),
	(674244, 133, '2015-02-01 00:53:23.000000', 'consum', 0.0217, 'lps'),
	(674245, 133, '2015-02-01 00:53:24.000000', 'consum', 0.0216, 'lps'),
	(674246, 133, '2015-02-01 00:53:25.000000', 'consum', 0.0210, 'lps'),
	(674247, 133, '2015-02-01 00:53:26.000000', 'consum', 0.0217, 'lps'),
	(674248, 133, '2015-02-01 00:53:27.000000', 'consum', 0.0210, 'lps'),
	(674249, 133, '2015-02-01 00:53:28.000000', 'consum', 0.0212, 'lps'),
	(674250, 133, '2015-02-01 00:53:29.000000', 'consum', 0.0220, 'lps'),
	(674251, 133, '2015-02-01 00:53:30.000000', 'consum', 0.0217, 'lps'),
	(674252, 133, '2015-02-01 00:53:31.000000', 'consum', 0.0217, 'lps'),
	(674253, 133, '2015-02-01 00:53:32.000000', 'consum', 0.0214, 'lps'),
	(674254, 133, '2015-02-01 00:53:33.000000', 'consum', 0.0210, 'lps'),
	(674255, 133, '2015-02-01 00:53:34.000000', 'consum', 0.0210, 'lps'),
	(674256, 133, '2015-02-01 00:53:35.000000', 'consum', 0.0211, 'lps'),
	(674257, 133, '2015-02-01 00:53:36.000000', 'consum', 0.0216, 'lps'),
	(674258, 133, '2015-02-01 00:53:37.000000', 'consum', 0.0213, 'lps'),
	(674259, 133, '2015-02-01 00:53:38.000000', 'consum', 0.0219, 'lps'),
	(674260, 133, '2015-02-01 00:53:39.000000', 'consum', 0.0211, 'lps'),
	(674261, 133, '2015-02-01 00:53:40.000000', 'consum', 0.0211, 'lps'),
	(674262, 133, '2015-02-01 00:53:41.000000', 'consum', 0.0215, 'lps'),
	(674263, 133, '2015-02-01 00:53:42.000000', 'consum', 0.0221, 'lps'),
	(674264, 133, '2015-02-01 00:53:43.000000', 'consum', 0.0212, 'lps'),
	(674265, 133, '2015-02-01 00:53:44.000000', 'consum', 0.0212, 'lps'),
	(674266, 133, '2015-02-01 00:53:45.000000', 'consum', 0.0217, 'lps'),
	(674267, 133, '2015-02-01 00:53:46.000000', 'consum', 0.0213, 'lps'),
	(674268, 133, '2015-02-01 00:53:47.000000', 'consum', 0.0215, 'lps'),
	(674269, 133, '2015-02-01 00:53:48.000000', 'consum', 0.0218, 'lps'),
	(674270, 133, '2015-02-01 00:53:49.000000', 'consum', 0.0221, 'lps'),
	(674271, 133, '2015-02-01 00:53:50.000000', 'consum', 0.0217, 'lps'),
	(674272, 133, '2015-02-01 00:53:51.000000', 'consum', 0.0212, 'lps'),
	(674273, 133, '2015-02-01 00:53:52.000000', 'consum', 0.0212, 'lps'),
	(674274, 133, '2015-02-01 00:53:53.000000', 'consum', 0.0214, 'lps'),
	(674275, 133, '2015-02-01 00:53:54.000000', 'consum', 0.0211, 'lps'),
	(674276, 133, '2015-02-01 00:53:55.000000', 'consum', 0.0219, 'lps'),
	(674277, 133, '2015-02-01 00:53:56.000000', 'consum', 0.0215, 'lps'),
	(674278, 133, '2015-02-01 00:53:57.000000', 'consum', 0.0219, 'lps'),
	(674279, 133, '2015-02-01 00:53:58.000000', 'consum', 0.0217, 'lps'),
	(674280, 133, '2015-02-01 00:53:59.000000', 'consum', 0.0218, 'lps'),
	(674281, 133, '2015-02-01 00:54:00.000000', 'consum', 0.0217, 'lps'),
	(674282, 133, '2015-02-01 00:54:01.000000', 'consum', 0.0220, 'lps'),
	(674283, 133, '2015-02-01 00:54:02.000000', 'consum', 0.0218, 'lps'),
	(674284, 133, '2015-02-01 00:54:03.000000', 'consum', 0.0219, 'lps'),
	(674285, 133, '2015-02-01 00:54:04.000000', 'consum', 0.0220, 'lps'),
	(674286, 133, '2015-02-01 00:54:05.000000', 'consum', 0.0211, 'lps'),
	(674287, 133, '2015-02-01 00:54:06.000000', 'consum', 0.0220, 'lps'),
	(674288, 133, '2015-02-01 00:54:07.000000', 'consum', 0.0210, 'lps'),
	(674289, 133, '2015-02-01 00:54:08.000000', 'consum', 0.0217, 'lps'),
	(674290, 133, '2015-02-01 00:54:09.000000', 'consum', 0.0211, 'lps'),
	(674291, 133, '2015-02-01 00:54:10.000000', 'consum', 0.0217, 'lps'),
	(674292, 133, '2015-02-01 00:54:11.000000', 'consum', 0.0218, 'lps'),
	(674293, 133, '2015-02-01 00:54:12.000000', 'consum', 0.0219, 'lps'),
	(674294, 133, '2015-02-01 00:54:13.000000', 'consum', 0.0217, 'lps'),
	(674295, 133, '2015-02-01 00:54:14.000000', 'consum', 0.0219, 'lps'),
	(674296, 133, '2015-02-01 00:54:15.000000', 'consum', 0.0221, 'lps'),
	(674297, 133, '2015-02-01 00:54:16.000000', 'consum', 0.0216, 'lps'),
	(674298, 133, '2015-02-01 00:54:17.000000', 'consum', 0.0220, 'lps'),
	(674299, 133, '2015-02-01 00:54:18.000000', 'consum', 0.0219, 'lps'),
	(674300, 133, '2015-02-01 00:54:19.000000', 'consum', 0.0212, 'lps'),
	(674301, 133, '2015-02-01 00:54:20.000000', 'consum', 0.0218, 'lps'),
	(674302, 133, '2015-02-01 00:54:21.000000', 'consum', 0.0210, 'lps'),
	(674303, 133, '2015-02-01 00:54:22.000000', 'consum', 0.0221, 'lps'),
	(674304, 133, '2015-02-01 00:54:23.000000', 'consum', 0.0216, 'lps'),
	(674305, 133, '2015-02-01 00:54:24.000000', 'consum', 0.0220, 'lps'),
	(674306, 133, '2015-02-01 00:54:25.000000', 'consum', 0.0218, 'lps'),
	(674307, 133, '2015-02-01 00:54:26.000000', 'consum', 0.0210, 'lps'),
	(674308, 133, '2015-02-01 00:54:27.000000', 'consum', 0.0211, 'lps'),
	(674309, 133, '2015-02-01 00:54:28.000000', 'consum', 0.0217, 'lps'),
	(674310, 133, '2015-02-01 00:54:29.000000', 'consum', 0.0216, 'lps'),
	(674311, 133, '2015-02-01 00:54:30.000000', 'consum', 0.0210, 'lps'),
	(674312, 133, '2015-02-01 00:54:31.000000', 'consum', 0.0216, 'lps'),
	(674313, 133, '2015-02-01 00:54:32.000000', 'consum', 0.0218, 'lps'),
	(674314, 133, '2015-02-01 00:54:33.000000', 'consum', 0.0219, 'lps'),
	(674315, 133, '2015-02-01 00:54:34.000000', 'consum', 0.0218, 'lps'),
	(674316, 133, '2015-02-01 00:54:35.000000', 'consum', 0.0214, 'lps'),
	(674317, 133, '2015-02-01 00:54:36.000000', 'consum', 0.0219, 'lps'),
	(674318, 133, '2015-02-01 00:54:37.000000', 'consum', 0.0219, 'lps'),
	(674319, 133, '2015-02-01 00:54:38.000000', 'consum', 0.0216, 'lps'),
	(674320, 133, '2015-02-01 00:54:39.000000', 'consum', 0.0212, 'lps'),
	(674321, 133, '2015-02-01 00:54:40.000000', 'consum', 0.0216, 'lps'),
	(674322, 133, '2015-02-01 00:54:41.000000', 'consum', 0.0210, 'lps'),
	(674323, 133, '2015-02-01 00:54:42.000000', 'consum', 0.0216, 'lps'),
	(674324, 133, '2015-02-01 00:54:43.000000', 'consum', 0.0219, 'lps'),
	(674325, 133, '2015-02-01 00:54:44.000000', 'consum', 0.0212, 'lps'),
	(674326, 133, '2015-02-01 00:54:45.000000', 'consum', 0.0219, 'lps'),
	(674327, 133, '2015-02-01 00:54:46.000000', 'consum', 0.0211, 'lps'),
	(674328, 133, '2015-02-01 00:54:47.000000', 'consum', 0.0212, 'lps'),
	(674329, 133, '2015-02-01 00:54:48.000000', 'consum', 0.0220, 'lps'),
	(674330, 133, '2015-02-01 00:54:49.000000', 'consum', 0.0217, 'lps'),
	(674331, 133, '2015-02-01 00:54:50.000000', 'consum', 0.0217, 'lps'),
	(674332, 133, '2015-02-01 00:54:51.000000', 'consum', 0.0211, 'lps'),
	(674333, 133, '2015-02-01 00:54:52.000000', 'consum', 0.0217, 'lps'),
	(674334, 133, '2015-02-01 00:54:53.000000', 'consum', 0.0220, 'lps'),
	(674335, 133, '2015-02-01 00:54:54.000000', 'consum', 0.0215, 'lps'),
	(674336, 133, '2015-02-01 00:54:55.000000', 'consum', 0.0218, 'lps'),
	(674337, 133, '2015-02-01 00:54:56.000000', 'consum', 0.0212, 'lps'),
	(674338, 133, '2015-02-01 00:54:57.000000', 'consum', 0.0221, 'lps'),
	(674339, 133, '2015-02-01 00:54:58.000000', 'consum', 0.0213, 'lps'),
	(674340, 133, '2015-02-01 00:54:59.000000', 'consum', 0.0215, 'lps'),
	(674341, 133, '2015-02-01 00:55:00.000000', 'consum', 0.0212, 'lps'),
	(674342, 133, '2015-02-01 00:55:01.000000', 'consum', 0.0221, 'lps'),
	(674343, 133, '2015-02-01 00:55:02.000000', 'consum', 0.0211, 'lps'),
	(674344, 133, '2015-02-01 00:55:03.000000', 'consum', 0.0219, 'lps'),
	(674345, 133, '2015-02-01 00:55:04.000000', 'consum', 0.0217, 'lps'),
	(674346, 133, '2015-02-01 00:55:05.000000', 'consum', 0.0216, 'lps'),
	(674347, 133, '2015-02-01 00:55:06.000000', 'consum', 0.0219, 'lps'),
	(674348, 133, '2015-02-01 00:55:07.000000', 'consum', 0.0214, 'lps'),
	(674349, 133, '2015-02-01 00:55:08.000000', 'consum', 0.0215, 'lps'),
	(674350, 133, '2015-02-01 00:55:09.000000', 'consum', 0.0214, 'lps'),
	(674351, 133, '2015-02-01 00:55:10.000000', 'consum', 0.0214, 'lps'),
	(674352, 133, '2015-02-01 00:55:11.000000', 'consum', 0.0218, 'lps'),
	(674353, 133, '2015-02-01 00:55:12.000000', 'consum', 0.0216, 'lps'),
	(674354, 133, '2015-02-01 00:55:13.000000', 'consum', 0.0216, 'lps'),
	(674355, 133, '2015-02-01 00:55:14.000000', 'consum', 0.0212, 'lps'),
	(674356, 133, '2015-02-01 00:55:15.000000', 'consum', 0.0212, 'lps'),
	(674357, 133, '2015-02-01 00:55:16.000000', 'consum', 0.0217, 'lps'),
	(674358, 133, '2015-02-01 00:55:17.000000', 'consum', 0.0215, 'lps'),
	(674359, 133, '2015-02-01 00:55:18.000000', 'consum', 0.0215, 'lps'),
	(674360, 133, '2015-02-01 00:55:19.000000', 'consum', 0.0221, 'lps'),
	(674361, 133, '2015-02-01 00:55:20.000000', 'consum', 0.0215, 'lps'),
	(674362, 133, '2015-02-01 00:55:21.000000', 'consum', 0.0215, 'lps'),
	(674363, 133, '2015-02-01 00:55:22.000000', 'consum', 0.0218, 'lps'),
	(674364, 133, '2015-02-01 00:55:23.000000', 'consum', 0.0214, 'lps'),
	(674365, 133, '2015-02-01 00:55:24.000000', 'consum', 0.0218, 'lps'),
	(674366, 133, '2015-02-01 00:55:25.000000', 'consum', 0.0213, 'lps'),
	(674367, 133, '2015-02-01 00:55:26.000000', 'consum', 0.0216, 'lps'),
	(674368, 133, '2015-02-01 00:55:27.000000', 'consum', 0.0219, 'lps'),
	(674369, 133, '2015-02-01 00:55:28.000000', 'consum', 0.0212, 'lps'),
	(674370, 133, '2015-02-01 00:55:29.000000', 'consum', 0.0217, 'lps'),
	(674371, 133, '2015-02-01 00:55:30.000000', 'consum', 0.0218, 'lps'),
	(674372, 133, '2015-02-01 00:55:31.000000', 'consum', 0.0216, 'lps'),
	(674373, 133, '2015-02-01 00:55:32.000000', 'consum', 0.0216, 'lps'),
	(674374, 133, '2015-02-01 00:55:33.000000', 'consum', 0.0210, 'lps'),
	(674375, 133, '2015-02-01 00:55:34.000000', 'consum', 0.0216, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(674376, 133, '2015-02-01 00:55:35.000000', 'consum', 0.0217, 'lps'),
	(674377, 133, '2015-02-01 00:55:36.000000', 'consum', 0.0218, 'lps'),
	(674378, 133, '2015-02-01 00:55:37.000000', 'consum', 0.0214, 'lps'),
	(674379, 133, '2015-02-01 00:55:38.000000', 'consum', 0.0220, 'lps'),
	(674380, 133, '2015-02-01 00:55:39.000000', 'consum', 0.0211, 'lps'),
	(674381, 133, '2015-02-01 00:55:40.000000', 'consum', 0.0212, 'lps'),
	(674382, 133, '2015-02-01 00:55:41.000000', 'consum', 0.0215, 'lps'),
	(674383, 133, '2015-02-01 00:55:42.000000', 'consum', 0.0219, 'lps'),
	(674384, 133, '2015-02-01 00:55:43.000000', 'consum', 0.0216, 'lps'),
	(674385, 133, '2015-02-01 00:55:44.000000', 'consum', 0.0216, 'lps'),
	(674386, 133, '2015-02-01 00:55:45.000000', 'consum', 0.0219, 'lps'),
	(674387, 133, '2015-02-01 00:55:46.000000', 'consum', 0.0216, 'lps'),
	(674388, 133, '2015-02-01 00:55:47.000000', 'consum', 0.0211, 'lps'),
	(674389, 133, '2015-02-01 00:55:48.000000', 'consum', 0.0212, 'lps'),
	(674390, 133, '2015-02-01 00:55:49.000000', 'consum', 0.0217, 'lps'),
	(674391, 133, '2015-02-01 00:55:50.000000', 'consum', 0.0216, 'lps'),
	(674392, 133, '2015-02-01 00:55:51.000000', 'consum', 0.0220, 'lps'),
	(674393, 133, '2015-02-01 00:55:52.000000', 'consum', 0.0216, 'lps'),
	(674394, 133, '2015-02-01 00:55:53.000000', 'consum', 0.0211, 'lps'),
	(674395, 133, '2015-02-01 00:55:54.000000', 'consum', 0.0210, 'lps'),
	(674396, 133, '2015-02-01 00:55:55.000000', 'consum', 0.0218, 'lps'),
	(674397, 133, '2015-02-01 00:55:56.000000', 'consum', 0.0215, 'lps'),
	(674398, 133, '2015-02-01 00:55:57.000000', 'consum', 0.0214, 'lps'),
	(674399, 133, '2015-02-01 00:55:58.000000', 'consum', 0.0213, 'lps'),
	(674400, 133, '2015-02-01 00:55:59.000000', 'consum', 0.0214, 'lps'),
	(674401, 133, '2015-02-01 00:56:00.000000', 'consum', 0.0211, 'lps'),
	(674402, 133, '2015-02-01 00:56:01.000000', 'consum', 0.0216, 'lps'),
	(674403, 133, '2015-02-01 00:56:02.000000', 'consum', 0.0211, 'lps'),
	(674404, 133, '2015-02-01 00:56:03.000000', 'consum', 0.0221, 'lps'),
	(674405, 133, '2015-02-01 00:56:04.000000', 'consum', 0.0215, 'lps'),
	(674406, 133, '2015-02-01 00:56:05.000000', 'consum', 0.0215, 'lps'),
	(674407, 133, '2015-02-01 00:56:06.000000', 'consum', 0.0220, 'lps'),
	(674408, 133, '2015-02-01 00:56:07.000000', 'consum', 0.0211, 'lps'),
	(674409, 133, '2015-02-01 00:56:08.000000', 'consum', 0.0220, 'lps'),
	(674410, 133, '2015-02-01 00:56:09.000000', 'consum', 0.0221, 'lps'),
	(674411, 133, '2015-02-01 00:56:10.000000', 'consum', 0.0212, 'lps'),
	(674412, 133, '2015-02-01 00:56:11.000000', 'consum', 0.0212, 'lps'),
	(674413, 133, '2015-02-01 00:56:12.000000', 'consum', 0.0216, 'lps'),
	(674414, 133, '2015-02-01 00:56:13.000000', 'consum', 0.0221, 'lps'),
	(674415, 133, '2015-02-01 00:56:14.000000', 'consum', 0.0212, 'lps'),
	(674416, 133, '2015-02-01 00:56:15.000000', 'consum', 0.0210, 'lps'),
	(674417, 133, '2015-02-01 00:56:16.000000', 'consum', 0.0220, 'lps'),
	(674418, 133, '2015-02-01 00:56:17.000000', 'consum', 0.0221, 'lps'),
	(674419, 133, '2015-02-01 00:56:18.000000', 'consum', 0.0211, 'lps'),
	(674420, 133, '2015-02-01 00:56:19.000000', 'consum', 0.0220, 'lps'),
	(674421, 133, '2015-02-01 00:56:20.000000', 'consum', 0.0210, 'lps'),
	(674422, 133, '2015-02-01 00:56:21.000000', 'consum', 0.0216, 'lps'),
	(674423, 133, '2015-02-01 00:56:22.000000', 'consum', 0.0215, 'lps'),
	(674424, 133, '2015-02-01 00:56:23.000000', 'consum', 0.0221, 'lps'),
	(674425, 133, '2015-02-01 00:56:24.000000', 'consum', 0.0211, 'lps'),
	(674426, 133, '2015-02-01 00:56:25.000000', 'consum', 0.0220, 'lps'),
	(674427, 133, '2015-02-01 00:56:26.000000', 'consum', 0.0221, 'lps'),
	(674428, 133, '2015-02-01 00:56:27.000000', 'consum', 0.0211, 'lps'),
	(674429, 133, '2015-02-01 00:56:28.000000', 'consum', 0.0219, 'lps'),
	(674430, 133, '2015-02-01 00:56:29.000000', 'consum', 0.0218, 'lps'),
	(674431, 133, '2015-02-01 00:56:30.000000', 'consum', 0.0211, 'lps'),
	(674432, 133, '2015-02-01 00:56:31.000000', 'consum', 0.0214, 'lps'),
	(674433, 133, '2015-02-01 00:56:32.000000', 'consum', 0.0215, 'lps'),
	(674434, 133, '2015-02-01 00:56:33.000000', 'consum', 0.0214, 'lps'),
	(674435, 133, '2015-02-01 00:56:34.000000', 'consum', 0.0216, 'lps'),
	(674436, 133, '2015-02-01 00:56:35.000000', 'consum', 0.0217, 'lps'),
	(674437, 133, '2015-02-01 00:56:36.000000', 'consum', 0.0214, 'lps'),
	(674438, 133, '2015-02-01 00:56:37.000000', 'consum', 0.0210, 'lps'),
	(674439, 133, '2015-02-01 00:56:38.000000', 'consum', 0.0220, 'lps'),
	(674440, 133, '2015-02-01 00:56:39.000000', 'consum', 0.0215, 'lps'),
	(674441, 133, '2015-02-01 00:56:40.000000', 'consum', 0.0218, 'lps'),
	(674442, 133, '2015-02-01 00:56:41.000000', 'consum', 0.0212, 'lps'),
	(674443, 133, '2015-02-01 00:56:42.000000', 'consum', 0.0210, 'lps'),
	(674444, 133, '2015-02-01 00:56:43.000000', 'consum', 0.0213, 'lps'),
	(674445, 133, '2015-02-01 00:56:44.000000', 'consum', 0.0216, 'lps'),
	(674446, 133, '2015-02-01 00:56:45.000000', 'consum', 0.0218, 'lps'),
	(674447, 133, '2015-02-01 00:56:46.000000', 'consum', 0.0219, 'lps'),
	(674448, 133, '2015-02-01 00:56:47.000000', 'consum', 0.0210, 'lps'),
	(674449, 133, '2015-02-01 00:56:48.000000', 'consum', 0.0217, 'lps'),
	(674450, 133, '2015-02-01 00:56:49.000000', 'consum', 0.0221, 'lps'),
	(674451, 133, '2015-02-01 00:56:50.000000', 'consum', 0.0221, 'lps'),
	(674452, 133, '2015-02-01 00:56:51.000000', 'consum', 0.0210, 'lps'),
	(674453, 133, '2015-02-01 00:56:52.000000', 'consum', 0.0214, 'lps'),
	(674454, 133, '2015-02-01 00:56:53.000000', 'consum', 0.0219, 'lps'),
	(674455, 133, '2015-02-01 00:56:54.000000', 'consum', 0.0218, 'lps'),
	(674456, 133, '2015-02-01 00:56:55.000000', 'consum', 0.0212, 'lps'),
	(674457, 133, '2015-02-01 00:56:56.000000', 'consum', 0.0210, 'lps'),
	(674458, 133, '2015-02-01 00:56:57.000000', 'consum', 0.0217, 'lps'),
	(674459, 133, '2015-02-01 00:56:58.000000', 'consum', 0.0220, 'lps'),
	(674460, 133, '2015-02-01 00:56:59.000000', 'consum', 0.0216, 'lps'),
	(674461, 133, '2015-02-01 00:57:00.000000', 'consum', 0.0210, 'lps'),
	(674462, 133, '2015-02-01 00:57:01.000000', 'consum', 0.0217, 'lps'),
	(674463, 133, '2015-02-01 00:57:02.000000', 'consum', 0.0220, 'lps'),
	(674464, 133, '2015-02-01 00:57:03.000000', 'consum', 0.0218, 'lps'),
	(674465, 133, '2015-02-01 00:57:04.000000', 'consum', 0.0218, 'lps'),
	(674466, 133, '2015-02-01 00:57:05.000000', 'consum', 0.0214, 'lps'),
	(674467, 133, '2015-02-01 00:57:06.000000', 'consum', 0.0220, 'lps'),
	(674468, 133, '2015-02-01 00:57:07.000000', 'consum', 0.0214, 'lps'),
	(674469, 133, '2015-02-01 00:57:08.000000', 'consum', 0.0211, 'lps'),
	(674470, 133, '2015-02-01 00:57:09.000000', 'consum', 0.0215, 'lps'),
	(674471, 133, '2015-02-01 00:57:10.000000', 'consum', 0.0220, 'lps'),
	(674472, 133, '2015-02-01 00:57:11.000000', 'consum', 0.0221, 'lps'),
	(674473, 133, '2015-02-01 00:57:12.000000', 'consum', 0.0214, 'lps'),
	(674474, 133, '2015-02-01 00:57:13.000000', 'consum', 0.0221, 'lps'),
	(674475, 133, '2015-02-01 00:57:14.000000', 'consum', 0.0216, 'lps'),
	(674476, 133, '2015-02-01 00:57:15.000000', 'consum', 0.0210, 'lps'),
	(674477, 133, '2015-02-01 00:57:16.000000', 'consum', 0.0214, 'lps'),
	(674478, 133, '2015-02-01 00:57:17.000000', 'consum', 0.0221, 'lps'),
	(674479, 133, '2015-02-01 00:57:18.000000', 'consum', 0.0217, 'lps'),
	(674480, 133, '2015-02-01 00:57:19.000000', 'consum', 0.0211, 'lps'),
	(674481, 133, '2015-02-01 00:57:20.000000', 'consum', 0.0221, 'lps'),
	(674482, 133, '2015-02-01 00:57:21.000000', 'consum', 0.0215, 'lps'),
	(674483, 133, '2015-02-01 00:57:22.000000', 'consum', 0.0212, 'lps'),
	(674484, 133, '2015-02-01 00:57:23.000000', 'consum', 0.0219, 'lps'),
	(674485, 133, '2015-02-01 00:57:24.000000', 'consum', 0.0214, 'lps'),
	(674486, 133, '2015-02-01 00:57:25.000000', 'consum', 0.0215, 'lps'),
	(674487, 133, '2015-02-01 00:57:26.000000', 'consum', 0.0213, 'lps'),
	(674488, 133, '2015-02-01 00:57:27.000000', 'consum', 0.0220, 'lps'),
	(674489, 133, '2015-02-01 00:57:28.000000', 'consum', 0.0217, 'lps'),
	(674490, 133, '2015-02-01 00:57:29.000000', 'consum', 0.0216, 'lps'),
	(674491, 133, '2015-02-01 00:57:30.000000', 'consum', 0.0218, 'lps'),
	(674492, 133, '2015-02-01 00:57:31.000000', 'consum', 0.0220, 'lps'),
	(674493, 133, '2015-02-01 00:57:32.000000', 'consum', 0.0215, 'lps'),
	(674494, 133, '2015-02-01 00:57:33.000000', 'consum', 0.0216, 'lps'),
	(674495, 133, '2015-02-01 00:57:34.000000', 'consum', 0.0214, 'lps'),
	(674496, 133, '2015-02-01 00:57:35.000000', 'consum', 0.0213, 'lps'),
	(674497, 133, '2015-02-01 00:57:36.000000', 'consum', 0.0215, 'lps'),
	(674498, 133, '2015-02-01 00:57:37.000000', 'consum', 0.0211, 'lps'),
	(674499, 133, '2015-02-01 00:57:38.000000', 'consum', 0.0215, 'lps'),
	(674500, 133, '2015-02-01 00:57:39.000000', 'consum', 0.0221, 'lps'),
	(674501, 133, '2015-02-01 00:57:40.000000', 'consum', 0.0214, 'lps'),
	(674502, 133, '2015-02-01 00:57:41.000000', 'consum', 0.0220, 'lps'),
	(674503, 133, '2015-02-01 00:57:42.000000', 'consum', 0.0211, 'lps'),
	(674504, 133, '2015-02-01 00:57:43.000000', 'consum', 0.0212, 'lps'),
	(674505, 133, '2015-02-01 00:57:44.000000', 'consum', 0.0218, 'lps'),
	(674506, 133, '2015-02-01 00:57:45.000000', 'consum', 0.0218, 'lps'),
	(674507, 133, '2015-02-01 00:57:46.000000', 'consum', 0.0217, 'lps'),
	(674508, 133, '2015-02-01 00:57:47.000000', 'consum', 0.0219, 'lps'),
	(674509, 133, '2015-02-01 00:57:48.000000', 'consum', 0.0211, 'lps'),
	(674510, 133, '2015-02-01 00:57:49.000000', 'consum', 0.0212, 'lps'),
	(674511, 133, '2015-02-01 00:57:50.000000', 'consum', 0.0219, 'lps'),
	(674512, 133, '2015-02-01 00:57:51.000000', 'consum', 0.0213, 'lps'),
	(674513, 133, '2015-02-01 00:57:52.000000', 'consum', 0.0211, 'lps'),
	(674514, 133, '2015-02-01 00:57:53.000000', 'consum', 0.0217, 'lps'),
	(674515, 133, '2015-02-01 00:57:54.000000', 'consum', 0.0218, 'lps'),
	(674516, 133, '2015-02-01 00:57:55.000000', 'consum', 0.0216, 'lps'),
	(674517, 133, '2015-02-01 00:57:56.000000', 'consum', 0.0219, 'lps'),
	(674518, 133, '2015-02-01 00:57:57.000000', 'consum', 0.0214, 'lps'),
	(674519, 133, '2015-02-01 00:57:58.000000', 'consum', 0.0213, 'lps'),
	(674520, 133, '2015-02-01 00:57:59.000000', 'consum', 0.0216, 'lps'),
	(674521, 133, '2015-02-01 00:58:00.000000', 'consum', 0.0220, 'lps'),
	(674522, 133, '2015-02-01 00:58:01.000000', 'consum', 0.0218, 'lps'),
	(674523, 133, '2015-02-01 00:58:02.000000', 'consum', 0.0221, 'lps'),
	(674524, 133, '2015-02-01 00:58:03.000000', 'consum', 0.0218, 'lps'),
	(674525, 133, '2015-02-01 00:58:04.000000', 'consum', 0.0219, 'lps'),
	(674526, 133, '2015-02-01 00:58:05.000000', 'consum', 0.0217, 'lps'),
	(674527, 133, '2015-02-01 00:58:06.000000', 'consum', 0.0221, 'lps'),
	(674528, 133, '2015-02-01 00:58:07.000000', 'consum', 0.0220, 'lps'),
	(674529, 133, '2015-02-01 00:58:08.000000', 'consum', 0.0215, 'lps'),
	(674530, 133, '2015-02-01 00:58:09.000000', 'consum', 0.0218, 'lps'),
	(674531, 133, '2015-02-01 00:58:10.000000', 'consum', 0.0210, 'lps'),
	(674532, 133, '2015-02-01 00:58:11.000000', 'consum', 0.0211, 'lps'),
	(674533, 133, '2015-02-01 00:58:12.000000', 'consum', 0.0217, 'lps'),
	(674534, 133, '2015-02-01 00:58:13.000000', 'consum', 0.0216, 'lps'),
	(674535, 133, '2015-02-01 00:58:14.000000', 'consum', 0.0219, 'lps'),
	(674536, 133, '2015-02-01 00:58:15.000000', 'consum', 0.0215, 'lps'),
	(674537, 133, '2015-02-01 00:58:16.000000', 'consum', 0.0221, 'lps'),
	(674538, 133, '2015-02-01 00:58:17.000000', 'consum', 0.0214, 'lps'),
	(674539, 133, '2015-02-01 00:58:18.000000', 'consum', 0.0221, 'lps'),
	(674540, 133, '2015-02-01 00:58:19.000000', 'consum', 0.0217, 'lps'),
	(674541, 133, '2015-02-01 00:58:20.000000', 'consum', 0.0211, 'lps'),
	(674542, 133, '2015-02-01 00:58:21.000000', 'consum', 0.0221, 'lps'),
	(674543, 133, '2015-02-01 00:58:22.000000', 'consum', 0.0212, 'lps'),
	(674544, 133, '2015-02-01 00:58:23.000000', 'consum', 0.0212, 'lps'),
	(674545, 133, '2015-02-01 00:58:24.000000', 'consum', 0.0214, 'lps'),
	(674546, 133, '2015-02-01 00:58:25.000000', 'consum', 0.0214, 'lps'),
	(674547, 133, '2015-02-01 00:58:26.000000', 'consum', 0.0216, 'lps'),
	(674548, 133, '2015-02-01 00:58:27.000000', 'consum', 0.0220, 'lps'),
	(674549, 133, '2015-02-01 00:58:28.000000', 'consum', 0.0216, 'lps'),
	(674550, 133, '2015-02-01 00:58:29.000000', 'consum', 0.0211, 'lps'),
	(674551, 133, '2015-02-01 00:58:30.000000', 'consum', 0.0221, 'lps'),
	(674552, 133, '2015-02-01 00:58:31.000000', 'consum', 0.0213, 'lps'),
	(674553, 133, '2015-02-01 00:58:32.000000', 'consum', 0.0218, 'lps'),
	(674554, 133, '2015-02-01 00:58:33.000000', 'consum', 0.0219, 'lps'),
	(674555, 133, '2015-02-01 00:58:34.000000', 'consum', 0.0220, 'lps'),
	(674556, 133, '2015-02-01 00:58:35.000000', 'consum', 0.0219, 'lps'),
	(674557, 133, '2015-02-01 00:58:36.000000', 'consum', 0.0216, 'lps'),
	(674558, 133, '2015-02-01 00:58:37.000000', 'consum', 0.0214, 'lps'),
	(674559, 133, '2015-02-01 00:58:38.000000', 'consum', 0.0213, 'lps'),
	(674560, 133, '2015-02-01 00:58:39.000000', 'consum', 0.0213, 'lps'),
	(674561, 133, '2015-02-01 00:58:40.000000', 'consum', 0.0214, 'lps'),
	(674562, 133, '2015-02-01 00:58:41.000000', 'consum', 0.0212, 'lps'),
	(674563, 133, '2015-02-01 00:58:42.000000', 'consum', 0.0219, 'lps'),
	(674564, 133, '2015-02-01 00:58:43.000000', 'consum', 0.0216, 'lps'),
	(674565, 133, '2015-02-01 00:58:44.000000', 'consum', 0.0211, 'lps'),
	(674566, 133, '2015-02-01 00:58:45.000000', 'consum', 0.0212, 'lps'),
	(674567, 133, '2015-02-01 00:58:46.000000', 'consum', 0.0215, 'lps'),
	(674568, 133, '2015-02-01 00:58:47.000000', 'consum', 0.0216, 'lps'),
	(674569, 133, '2015-02-01 00:58:48.000000', 'consum', 0.0217, 'lps'),
	(674570, 133, '2015-02-01 00:58:49.000000', 'consum', 0.0212, 'lps'),
	(674571, 133, '2015-02-01 00:58:50.000000', 'consum', 0.0215, 'lps'),
	(674572, 133, '2015-02-01 00:58:51.000000', 'consum', 0.0216, 'lps'),
	(674573, 133, '2015-02-01 00:58:52.000000', 'consum', 0.0214, 'lps'),
	(674574, 133, '2015-02-01 00:58:53.000000', 'consum', 0.0213, 'lps'),
	(674575, 133, '2015-02-01 00:58:54.000000', 'consum', 0.0215, 'lps'),
	(674576, 133, '2015-02-01 00:58:55.000000', 'consum', 0.0212, 'lps'),
	(674577, 133, '2015-02-01 00:58:56.000000', 'consum', 0.0217, 'lps'),
	(674578, 133, '2015-02-01 00:58:57.000000', 'consum', 0.0215, 'lps'),
	(674579, 133, '2015-02-01 00:58:58.000000', 'consum', 0.0217, 'lps'),
	(674580, 133, '2015-02-01 00:58:59.000000', 'consum', 0.0219, 'lps'),
	(674581, 133, '2015-02-01 00:59:00.000000', 'consum', 0.0221, 'lps'),
	(674582, 133, '2015-02-01 00:59:01.000000', 'consum', 0.0215, 'lps'),
	(674583, 133, '2015-02-01 00:59:02.000000', 'consum', 0.0215, 'lps'),
	(674584, 133, '2015-02-01 00:59:03.000000', 'consum', 0.0219, 'lps'),
	(674585, 133, '2015-02-01 00:59:04.000000', 'consum', 0.0219, 'lps'),
	(674586, 133, '2015-02-01 00:59:05.000000', 'consum', 0.0214, 'lps'),
	(674587, 133, '2015-02-01 00:59:06.000000', 'consum', 0.0214, 'lps'),
	(674588, 133, '2015-02-01 00:59:07.000000', 'consum', 0.0210, 'lps'),
	(674589, 133, '2015-02-01 00:59:08.000000', 'consum', 0.0221, 'lps'),
	(674590, 133, '2015-02-01 00:59:09.000000', 'consum', 0.0216, 'lps'),
	(674591, 133, '2015-02-01 00:59:10.000000', 'consum', 0.0211, 'lps'),
	(674592, 133, '2015-02-01 00:59:11.000000', 'consum', 0.0218, 'lps'),
	(674593, 133, '2015-02-01 00:59:12.000000', 'consum', 0.0214, 'lps'),
	(674594, 133, '2015-02-01 00:59:13.000000', 'consum', 0.0218, 'lps'),
	(674595, 133, '2015-02-01 00:59:14.000000', 'consum', 0.0213, 'lps'),
	(674596, 133, '2015-02-01 00:59:15.000000', 'consum', 0.0215, 'lps'),
	(674597, 133, '2015-02-01 00:59:16.000000', 'consum', 0.0214, 'lps'),
	(674598, 133, '2015-02-01 00:59:17.000000', 'consum', 0.0217, 'lps'),
	(674599, 133, '2015-02-01 00:59:18.000000', 'consum', 0.0221, 'lps'),
	(674600, 133, '2015-02-01 00:59:19.000000', 'consum', 0.0221, 'lps'),
	(674601, 133, '2015-02-01 00:59:20.000000', 'consum', 0.0218, 'lps'),
	(674602, 133, '2015-02-01 00:59:21.000000', 'consum', 0.0219, 'lps'),
	(674603, 133, '2015-02-01 00:59:22.000000', 'consum', 0.0220, 'lps'),
	(674604, 133, '2015-02-01 00:59:23.000000', 'consum', 0.0221, 'lps'),
	(674605, 133, '2015-02-01 00:59:24.000000', 'consum', 0.0211, 'lps'),
	(674606, 133, '2015-02-01 00:59:25.000000', 'consum', 0.0220, 'lps'),
	(674607, 133, '2015-02-01 00:59:26.000000', 'consum', 0.0210, 'lps'),
	(674608, 133, '2015-02-01 00:59:27.000000', 'consum', 0.0216, 'lps'),
	(674609, 133, '2015-02-01 00:59:28.000000', 'consum', 0.0215, 'lps'),
	(674610, 133, '2015-02-01 00:59:29.000000', 'consum', 0.0217, 'lps'),
	(674611, 133, '2015-02-01 00:59:30.000000', 'consum', 0.0221, 'lps'),
	(674612, 133, '2015-02-01 00:59:31.000000', 'consum', 0.0220, 'lps'),
	(674613, 133, '2015-02-01 00:59:32.000000', 'consum', 0.0214, 'lps'),
	(674614, 133, '2015-02-01 00:59:33.000000', 'consum', 0.0212, 'lps'),
	(674615, 133, '2015-02-01 00:59:34.000000', 'consum', 0.0221, 'lps'),
	(674616, 133, '2015-02-01 00:59:35.000000', 'consum', 0.0213, 'lps'),
	(674617, 133, '2015-02-01 00:59:36.000000', 'consum', 0.0216, 'lps'),
	(674618, 133, '2015-02-01 00:59:37.000000', 'consum', 0.0220, 'lps'),
	(674619, 133, '2015-02-01 00:59:38.000000', 'consum', 0.0219, 'lps'),
	(674620, 133, '2015-02-01 00:59:39.000000', 'consum', 0.0213, 'lps'),
	(674621, 133, '2015-02-01 00:59:40.000000', 'consum', 0.0221, 'lps'),
	(674622, 133, '2015-02-01 00:59:41.000000', 'consum', 0.0211, 'lps'),
	(674623, 133, '2015-02-01 00:59:42.000000', 'consum', 0.0219, 'lps'),
	(674624, 133, '2015-02-01 00:59:43.000000', 'consum', 0.0216, 'lps'),
	(674625, 133, '2015-02-01 00:59:44.000000', 'consum', 0.0212, 'lps'),
	(674626, 133, '2015-02-01 00:59:45.000000', 'consum', 0.0216, 'lps'),
	(674627, 133, '2015-02-01 00:59:46.000000', 'consum', 0.0210, 'lps'),
	(674628, 133, '2015-02-01 00:59:47.000000', 'consum', 0.0215, 'lps'),
	(674629, 133, '2015-02-01 00:59:48.000000', 'consum', 0.0214, 'lps'),
	(674630, 133, '2015-02-01 00:59:49.000000', 'consum', 0.0215, 'lps'),
	(674631, 133, '2015-02-01 00:59:50.000000', 'consum', 0.0211, 'lps'),
	(674632, 133, '2015-02-01 00:59:51.000000', 'consum', 0.0213, 'lps'),
	(674633, 133, '2015-02-01 00:59:52.000000', 'consum', 0.0210, 'lps'),
	(674634, 133, '2015-02-01 00:59:53.000000', 'consum', 0.0215, 'lps'),
	(674635, 133, '2015-02-01 00:59:54.000000', 'consum', 0.0221, 'lps'),
	(674636, 133, '2015-02-01 00:59:55.000000', 'consum', 0.0218, 'lps'),
	(674637, 133, '2015-02-01 00:59:56.000000', 'consum', 0.0214, 'lps'),
	(674638, 133, '2015-02-01 00:59:57.000000', 'consum', 0.0221, 'lps'),
	(674639, 133, '2015-02-01 00:59:58.000000', 'consum', 0.0217, 'lps'),
	(674640, 133, '2015-02-01 00:59:59.000000', 'consum', 0.0211, 'lps'),
	(674641, 133, '2015-02-01 01:00:00.000000', 'consum', 0.0219, 'lps'),
	(674642, 133, '2015-02-01 01:00:01.000000', 'consum', 0.0219, 'lps'),
	(674643, 133, '2015-02-01 01:00:02.000000', 'consum', 0.0214, 'lps'),
	(674644, 133, '2015-02-01 01:00:03.000000', 'consum', 0.0218, 'lps'),
	(674645, 133, '2015-02-01 01:00:04.000000', 'consum', 0.0213, 'lps'),
	(674646, 133, '2015-02-01 01:00:05.000000', 'consum', 0.0213, 'lps'),
	(674647, 133, '2015-02-01 01:00:06.000000', 'consum', 0.0217, 'lps'),
	(674648, 133, '2015-02-01 01:00:07.000000', 'consum', 0.0215, 'lps'),
	(674649, 133, '2015-02-01 01:00:08.000000', 'consum', 0.0211, 'lps'),
	(674650, 133, '2015-02-01 01:00:09.000000', 'consum', 0.0212, 'lps'),
	(674651, 133, '2015-02-01 01:00:10.000000', 'consum', 0.0219, 'lps'),
	(674652, 133, '2015-02-01 01:00:11.000000', 'consum', 0.0213, 'lps'),
	(674653, 133, '2015-02-01 01:00:12.000000', 'consum', 0.0212, 'lps'),
	(674654, 133, '2015-02-01 01:00:13.000000', 'consum', 0.0212, 'lps'),
	(674655, 133, '2015-02-01 01:00:14.000000', 'consum', 0.0214, 'lps'),
	(674656, 133, '2015-02-01 01:00:15.000000', 'consum', 0.0211, 'lps'),
	(674657, 133, '2015-02-01 01:00:16.000000', 'consum', 0.0216, 'lps'),
	(674658, 133, '2015-02-01 01:00:17.000000', 'consum', 0.0212, 'lps'),
	(674659, 133, '2015-02-01 01:00:18.000000', 'consum', 0.0215, 'lps'),
	(674660, 133, '2015-02-01 01:00:19.000000', 'consum', 0.0219, 'lps'),
	(674661, 133, '2015-02-01 01:00:20.000000', 'consum', 0.0215, 'lps'),
	(674662, 133, '2015-02-01 01:00:21.000000', 'consum', 0.0220, 'lps'),
	(674663, 133, '2015-02-01 01:00:22.000000', 'consum', 0.0211, 'lps'),
	(674664, 133, '2015-02-01 01:00:23.000000', 'consum', 0.0221, 'lps'),
	(674665, 133, '2015-02-01 01:00:24.000000', 'consum', 0.0213, 'lps'),
	(674666, 133, '2015-02-01 01:00:25.000000', 'consum', 0.0220, 'lps'),
	(674667, 133, '2015-02-01 01:00:26.000000', 'consum', 0.0212, 'lps'),
	(674668, 133, '2015-02-01 01:00:27.000000', 'consum', 0.0216, 'lps'),
	(674669, 133, '2015-02-01 01:00:28.000000', 'consum', 0.0210, 'lps'),
	(674670, 133, '2015-02-01 01:00:29.000000', 'consum', 0.0217, 'lps'),
	(674671, 133, '2015-02-01 01:00:30.000000', 'consum', 0.0211, 'lps'),
	(674672, 133, '2015-02-01 01:00:31.000000', 'consum', 0.0218, 'lps'),
	(674673, 133, '2015-02-01 01:00:32.000000', 'consum', 0.0213, 'lps'),
	(674674, 133, '2015-02-01 01:00:33.000000', 'consum', 0.0213, 'lps'),
	(674675, 133, '2015-02-01 01:00:34.000000', 'consum', 0.0215, 'lps'),
	(674676, 133, '2015-02-01 01:00:35.000000', 'consum', 0.0214, 'lps'),
	(674677, 133, '2015-02-01 01:00:36.000000', 'consum', 0.0214, 'lps'),
	(674678, 133, '2015-02-01 01:00:37.000000', 'consum', 0.0221, 'lps'),
	(674679, 133, '2015-02-01 01:00:38.000000', 'consum', 0.0218, 'lps'),
	(674680, 133, '2015-02-01 01:00:39.000000', 'consum', 0.0215, 'lps'),
	(674681, 133, '2015-02-01 01:00:40.000000', 'consum', 0.0212, 'lps'),
	(674682, 133, '2015-02-01 01:00:41.000000', 'consum', 0.0220, 'lps'),
	(674683, 133, '2015-02-01 01:00:42.000000', 'consum', 0.0216, 'lps'),
	(674684, 133, '2015-02-01 01:00:43.000000', 'consum', 0.0212, 'lps'),
	(674685, 133, '2015-02-01 01:00:44.000000', 'consum', 0.0215, 'lps'),
	(674686, 133, '2015-02-01 01:00:45.000000', 'consum', 0.0215, 'lps'),
	(674687, 133, '2015-02-01 01:00:46.000000', 'consum', 0.0220, 'lps'),
	(674688, 133, '2015-02-01 01:00:47.000000', 'consum', 0.0212, 'lps'),
	(674689, 133, '2015-02-01 01:00:48.000000', 'consum', 0.0213, 'lps'),
	(674690, 133, '2015-02-01 01:00:49.000000', 'consum', 0.0218, 'lps'),
	(674691, 133, '2015-02-01 01:00:50.000000', 'consum', 0.0219, 'lps'),
	(674692, 133, '2015-02-01 01:00:51.000000', 'consum', 0.0220, 'lps'),
	(674693, 133, '2015-02-01 01:00:52.000000', 'consum', 0.0220, 'lps'),
	(674694, 133, '2015-02-01 01:00:53.000000', 'consum', 0.0219, 'lps'),
	(674695, 133, '2015-02-01 01:00:54.000000', 'consum', 0.0215, 'lps'),
	(674696, 133, '2015-02-01 01:00:55.000000', 'consum', 0.0220, 'lps'),
	(674697, 133, '2015-02-01 01:00:56.000000', 'consum', 0.0221, 'lps'),
	(674698, 133, '2015-02-01 01:00:57.000000', 'consum', 0.0210, 'lps'),
	(674699, 133, '2015-02-01 01:00:58.000000', 'consum', 0.0216, 'lps'),
	(674700, 133, '2015-02-01 01:00:59.000000', 'consum', 0.0215, 'lps'),
	(674701, 133, '2015-02-01 01:01:00.000000', 'consum', 0.0218, 'lps'),
	(674702, 133, '2015-02-01 01:01:01.000000', 'consum', 0.0210, 'lps'),
	(674703, 133, '2015-02-01 01:01:02.000000', 'consum', 0.0210, 'lps'),
	(674704, 133, '2015-02-01 01:01:03.000000', 'consum', 0.0210, 'lps'),
	(674705, 133, '2015-02-01 01:01:04.000000', 'consum', 0.0211, 'lps'),
	(674706, 133, '2015-02-01 01:01:05.000000', 'consum', 0.0217, 'lps'),
	(674707, 133, '2015-02-01 01:01:06.000000', 'consum', 0.0219, 'lps'),
	(674708, 133, '2015-02-01 01:01:07.000000', 'consum', 0.0210, 'lps'),
	(674709, 133, '2015-02-01 01:01:08.000000', 'consum', 0.0218, 'lps'),
	(674710, 133, '2015-02-01 01:01:09.000000', 'consum', 0.0217, 'lps'),
	(674711, 133, '2015-02-01 01:01:10.000000', 'consum', 0.0210, 'lps'),
	(674712, 133, '2015-02-01 01:01:11.000000', 'consum', 0.0211, 'lps'),
	(674713, 133, '2015-02-01 01:01:12.000000', 'consum', 0.0217, 'lps'),
	(674714, 133, '2015-02-01 01:01:13.000000', 'consum', 0.0218, 'lps'),
	(674715, 133, '2015-02-01 01:01:14.000000', 'consum', 0.0218, 'lps'),
	(674716, 133, '2015-02-01 01:01:15.000000', 'consum', 0.0214, 'lps'),
	(674717, 133, '2015-02-01 01:01:16.000000', 'consum', 0.0219, 'lps'),
	(674718, 133, '2015-02-01 01:01:17.000000', 'consum', 0.0218, 'lps'),
	(674719, 133, '2015-02-01 01:01:18.000000', 'consum', 0.0213, 'lps'),
	(674720, 133, '2015-02-01 01:01:19.000000', 'consum', 0.0215, 'lps'),
	(674721, 133, '2015-02-01 01:01:20.000000', 'consum', 0.0214, 'lps'),
	(674722, 133, '2015-02-01 01:01:21.000000', 'consum', 0.0213, 'lps'),
	(674723, 133, '2015-02-01 01:01:22.000000', 'consum', 0.0215, 'lps'),
	(674724, 133, '2015-02-01 01:01:23.000000', 'consum', 0.0214, 'lps'),
	(674725, 133, '2015-02-01 01:01:24.000000', 'consum', 0.0215, 'lps'),
	(674726, 133, '2015-02-01 01:01:25.000000', 'consum', 0.0211, 'lps'),
	(674727, 133, '2015-02-01 01:01:26.000000', 'consum', 0.0215, 'lps'),
	(674728, 133, '2015-02-01 01:01:27.000000', 'consum', 0.0218, 'lps'),
	(674729, 133, '2015-02-01 01:01:28.000000', 'consum', 0.0212, 'lps'),
	(674730, 133, '2015-02-01 01:01:29.000000', 'consum', 0.0210, 'lps'),
	(674731, 133, '2015-02-01 01:01:30.000000', 'consum', 0.0217, 'lps'),
	(674732, 133, '2015-02-01 01:01:31.000000', 'consum', 0.0210, 'lps'),
	(674733, 133, '2015-02-01 01:01:32.000000', 'consum', 0.0211, 'lps'),
	(674734, 133, '2015-02-01 01:01:33.000000', 'consum', 0.0217, 'lps'),
	(674735, 133, '2015-02-01 01:01:34.000000', 'consum', 0.0220, 'lps'),
	(674736, 133, '2015-02-01 01:01:35.000000', 'consum', 0.0214, 'lps'),
	(674737, 133, '2015-02-01 01:01:36.000000', 'consum', 0.0213, 'lps'),
	(674738, 133, '2015-02-01 01:01:37.000000', 'consum', 0.0212, 'lps'),
	(674739, 133, '2015-02-01 01:01:38.000000', 'consum', 0.0214, 'lps'),
	(674740, 133, '2015-02-01 01:01:39.000000', 'consum', 0.0212, 'lps'),
	(674741, 133, '2015-02-01 01:01:40.000000', 'consum', 0.0221, 'lps'),
	(674742, 133, '2015-02-01 01:01:41.000000', 'consum', 0.0212, 'lps'),
	(674743, 133, '2015-02-01 01:01:42.000000', 'consum', 0.0210, 'lps'),
	(674744, 133, '2015-02-01 01:01:43.000000', 'consum', 0.0217, 'lps'),
	(674745, 133, '2015-02-01 01:01:44.000000', 'consum', 0.0211, 'lps'),
	(674746, 133, '2015-02-01 01:01:45.000000', 'consum', 0.0217, 'lps'),
	(674747, 133, '2015-02-01 01:01:46.000000', 'consum', 0.0217, 'lps'),
	(674748, 133, '2015-02-01 01:01:47.000000', 'consum', 0.0213, 'lps'),
	(674749, 133, '2015-02-01 01:01:48.000000', 'consum', 0.0217, 'lps'),
	(674750, 133, '2015-02-01 01:01:49.000000', 'consum', 0.0212, 'lps'),
	(674751, 133, '2015-02-01 01:01:50.000000', 'consum', 0.0212, 'lps'),
	(674752, 133, '2015-02-01 01:01:51.000000', 'consum', 0.0216, 'lps'),
	(674753, 133, '2015-02-01 01:01:52.000000', 'consum', 0.0210, 'lps'),
	(674754, 133, '2015-02-01 01:01:53.000000', 'consum', 0.0218, 'lps'),
	(674755, 133, '2015-02-01 01:01:54.000000', 'consum', 0.0211, 'lps'),
	(674756, 133, '2015-02-01 01:01:55.000000', 'consum', 0.0217, 'lps'),
	(674757, 133, '2015-02-01 01:01:56.000000', 'consum', 0.0221, 'lps'),
	(674758, 133, '2015-02-01 01:01:57.000000', 'consum', 0.0217, 'lps'),
	(674759, 133, '2015-02-01 01:01:58.000000', 'consum', 0.0213, 'lps'),
	(674760, 133, '2015-02-01 01:01:59.000000', 'consum', 0.0218, 'lps'),
	(674761, 133, '2015-02-01 01:02:00.000000', 'consum', 0.0217, 'lps'),
	(674762, 133, '2015-02-01 01:02:01.000000', 'consum', 0.0211, 'lps'),
	(674763, 133, '2015-02-01 01:02:02.000000', 'consum', 0.0215, 'lps'),
	(674764, 133, '2015-02-01 01:02:03.000000', 'consum', 0.0212, 'lps'),
	(674765, 133, '2015-02-01 01:02:04.000000', 'consum', 0.0216, 'lps'),
	(674766, 133, '2015-02-01 01:02:05.000000', 'consum', 0.0213, 'lps'),
	(674767, 133, '2015-02-01 01:02:06.000000', 'consum', 0.0216, 'lps'),
	(674768, 133, '2015-02-01 01:02:07.000000', 'consum', 0.0221, 'lps'),
	(674769, 133, '2015-02-01 01:02:08.000000', 'consum', 0.0212, 'lps'),
	(674770, 133, '2015-02-01 01:02:09.000000', 'consum', 0.0221, 'lps'),
	(674771, 133, '2015-02-01 01:02:10.000000', 'consum', 0.0214, 'lps'),
	(674772, 133, '2015-02-01 01:02:11.000000', 'consum', 0.0220, 'lps'),
	(674773, 133, '2015-02-01 01:02:12.000000', 'consum', 0.0212, 'lps'),
	(674774, 133, '2015-02-01 01:02:13.000000', 'consum', 0.0215, 'lps'),
	(674775, 133, '2015-02-01 01:02:14.000000', 'consum', 0.0219, 'lps'),
	(674776, 133, '2015-02-01 01:02:15.000000', 'consum', 0.0216, 'lps'),
	(674777, 133, '2015-02-01 01:02:16.000000', 'consum', 0.0214, 'lps'),
	(674778, 133, '2015-02-01 01:02:17.000000', 'consum', 0.0214, 'lps'),
	(674779, 133, '2015-02-01 01:02:18.000000', 'consum', 0.0215, 'lps'),
	(674780, 133, '2015-02-01 01:02:19.000000', 'consum', 0.0214, 'lps'),
	(674781, 133, '2015-02-01 01:02:20.000000', 'consum', 0.0217, 'lps'),
	(674782, 133, '2015-02-01 01:02:21.000000', 'consum', 0.0218, 'lps'),
	(674783, 133, '2015-02-01 01:02:22.000000', 'consum', 0.0220, 'lps'),
	(674784, 133, '2015-02-01 01:02:23.000000', 'consum', 0.0212, 'lps'),
	(674785, 133, '2015-02-01 01:02:24.000000', 'consum', 0.0215, 'lps'),
	(674786, 133, '2015-02-01 01:02:25.000000', 'consum', 0.0216, 'lps'),
	(674787, 133, '2015-02-01 01:02:26.000000', 'consum', 0.0213, 'lps'),
	(674788, 133, '2015-02-01 01:02:27.000000', 'consum', 0.0221, 'lps'),
	(674789, 133, '2015-02-01 01:02:28.000000', 'consum', 0.0210, 'lps'),
	(674790, 133, '2015-02-01 01:02:29.000000', 'consum', 0.0212, 'lps'),
	(674791, 133, '2015-02-01 01:02:30.000000', 'consum', 0.0219, 'lps'),
	(674792, 133, '2015-02-01 01:02:31.000000', 'consum', 0.0215, 'lps'),
	(674793, 133, '2015-02-01 01:02:32.000000', 'consum', 0.0221, 'lps'),
	(674794, 133, '2015-02-01 01:02:33.000000', 'consum', 0.0215, 'lps'),
	(674795, 133, '2015-02-01 01:02:34.000000', 'consum', 0.0214, 'lps'),
	(674796, 133, '2015-02-01 01:02:35.000000', 'consum', 0.0216, 'lps'),
	(674797, 133, '2015-02-01 01:02:36.000000', 'consum', 0.0217, 'lps'),
	(674798, 133, '2015-02-01 01:02:37.000000', 'consum', 0.0216, 'lps'),
	(674799, 133, '2015-02-01 01:02:38.000000', 'consum', 0.0221, 'lps'),
	(674800, 133, '2015-02-01 01:02:39.000000', 'consum', 0.0221, 'lps'),
	(674801, 133, '2015-02-01 01:02:40.000000', 'consum', 0.0220, 'lps'),
	(674802, 133, '2015-02-01 01:02:41.000000', 'consum', 0.0217, 'lps'),
	(674803, 133, '2015-02-01 01:02:42.000000', 'consum', 0.0215, 'lps'),
	(674804, 133, '2015-02-01 01:02:43.000000', 'consum', 0.0213, 'lps'),
	(674805, 133, '2015-02-01 01:02:44.000000', 'consum', 0.0211, 'lps'),
	(674806, 133, '2015-02-01 01:02:45.000000', 'consum', 0.0217, 'lps'),
	(674807, 133, '2015-02-01 01:02:46.000000', 'consum', 0.0219, 'lps'),
	(674808, 133, '2015-02-01 01:02:47.000000', 'consum', 0.0210, 'lps'),
	(674809, 133, '2015-02-01 01:02:48.000000', 'consum', 0.0220, 'lps'),
	(674810, 133, '2015-02-01 01:02:49.000000', 'consum', 0.0211, 'lps'),
	(674811, 133, '2015-02-01 01:02:50.000000', 'consum', 0.0211, 'lps'),
	(674812, 133, '2015-02-01 01:02:51.000000', 'consum', 0.0214, 'lps'),
	(674813, 133, '2015-02-01 01:02:52.000000', 'consum', 0.0212, 'lps'),
	(674814, 133, '2015-02-01 01:02:53.000000', 'consum', 0.0211, 'lps'),
	(674815, 133, '2015-02-01 01:02:54.000000', 'consum', 0.0221, 'lps'),
	(674816, 133, '2015-02-01 01:02:55.000000', 'consum', 0.0216, 'lps'),
	(674817, 133, '2015-02-01 01:02:56.000000', 'consum', 0.0218, 'lps'),
	(674818, 133, '2015-02-01 01:02:57.000000', 'consum', 0.0221, 'lps'),
	(674819, 133, '2015-02-01 01:02:58.000000', 'consum', 0.0217, 'lps'),
	(674820, 133, '2015-02-01 01:02:59.000000', 'consum', 0.0213, 'lps'),
	(674821, 133, '2015-02-01 01:03:00.000000', 'consum', 0.0217, 'lps'),
	(674822, 133, '2015-02-01 01:03:01.000000', 'consum', 0.0211, 'lps'),
	(674823, 133, '2015-02-01 01:03:02.000000', 'consum', 0.0220, 'lps'),
	(674824, 133, '2015-02-01 01:03:03.000000', 'consum', 0.0220, 'lps'),
	(674825, 133, '2015-02-01 01:03:04.000000', 'consum', 0.0218, 'lps'),
	(674826, 133, '2015-02-01 01:03:05.000000', 'consum', 0.0221, 'lps'),
	(674827, 133, '2015-02-01 01:03:06.000000', 'consum', 0.0216, 'lps'),
	(674828, 133, '2015-02-01 01:03:07.000000', 'consum', 0.0221, 'lps'),
	(674829, 133, '2015-02-01 01:03:08.000000', 'consum', 0.0210, 'lps'),
	(674830, 133, '2015-02-01 01:03:09.000000', 'consum', 0.0212, 'lps'),
	(674831, 133, '2015-02-01 01:03:10.000000', 'consum', 0.0212, 'lps'),
	(674832, 133, '2015-02-01 01:03:11.000000', 'consum', 0.0214, 'lps'),
	(674833, 133, '2015-02-01 01:03:12.000000', 'consum', 0.0212, 'lps'),
	(674834, 133, '2015-02-01 01:03:13.000000', 'consum', 0.0218, 'lps'),
	(674835, 133, '2015-02-01 01:03:14.000000', 'consum', 0.0212, 'lps'),
	(674836, 133, '2015-02-01 01:03:15.000000', 'consum', 0.0221, 'lps'),
	(674837, 133, '2015-02-01 01:03:16.000000', 'consum', 0.0221, 'lps'),
	(674838, 133, '2015-02-01 01:03:17.000000', 'consum', 0.0221, 'lps'),
	(674839, 133, '2015-02-01 01:03:18.000000', 'consum', 0.0219, 'lps'),
	(674840, 133, '2015-02-01 01:03:19.000000', 'consum', 0.0211, 'lps'),
	(674841, 133, '2015-02-01 01:03:20.000000', 'consum', 0.0212, 'lps'),
	(674842, 133, '2015-02-01 01:03:21.000000', 'consum', 0.0217, 'lps'),
	(674843, 133, '2015-02-01 01:03:22.000000', 'consum', 0.0216, 'lps'),
	(674844, 133, '2015-02-01 01:03:23.000000', 'consum', 0.0220, 'lps'),
	(674845, 133, '2015-02-01 01:03:24.000000', 'consum', 0.0218, 'lps'),
	(674846, 133, '2015-02-01 01:03:25.000000', 'consum', 0.0210, 'lps'),
	(674847, 133, '2015-02-01 01:03:26.000000', 'consum', 0.0212, 'lps'),
	(674848, 133, '2015-02-01 01:03:27.000000', 'consum', 0.0217, 'lps'),
	(674849, 133, '2015-02-01 01:03:28.000000', 'consum', 0.0218, 'lps'),
	(674850, 133, '2015-02-01 01:03:29.000000', 'consum', 0.0215, 'lps'),
	(674851, 133, '2015-02-01 01:03:30.000000', 'consum', 0.0214, 'lps'),
	(674852, 133, '2015-02-01 01:03:31.000000', 'consum', 0.0214, 'lps'),
	(674853, 133, '2015-02-01 01:03:32.000000', 'consum', 0.0219, 'lps'),
	(674854, 133, '2015-02-01 01:03:33.000000', 'consum', 0.0218, 'lps'),
	(674855, 133, '2015-02-01 01:03:34.000000', 'consum', 0.0213, 'lps'),
	(674856, 133, '2015-02-01 01:03:35.000000', 'consum', 0.0212, 'lps'),
	(674857, 133, '2015-02-01 01:03:36.000000', 'consum', 0.0213, 'lps'),
	(674858, 133, '2015-02-01 01:03:37.000000', 'consum', 0.0219, 'lps'),
	(674859, 133, '2015-02-01 01:03:38.000000', 'consum', 0.0212, 'lps'),
	(674860, 133, '2015-02-01 01:03:39.000000', 'consum', 0.0216, 'lps'),
	(674861, 133, '2015-02-01 01:03:40.000000', 'consum', 0.0210, 'lps'),
	(674862, 133, '2015-02-01 01:03:41.000000', 'consum', 0.0217, 'lps'),
	(674863, 133, '2015-02-01 01:03:42.000000', 'consum', 0.0211, 'lps'),
	(674864, 133, '2015-02-01 01:03:43.000000', 'consum', 0.0217, 'lps'),
	(674865, 133, '2015-02-01 01:03:44.000000', 'consum', 0.0218, 'lps'),
	(674866, 133, '2015-02-01 01:03:45.000000', 'consum', 0.0220, 'lps'),
	(674867, 133, '2015-02-01 01:03:46.000000', 'consum', 0.0211, 'lps'),
	(674868, 133, '2015-02-01 01:03:47.000000', 'consum', 0.0210, 'lps'),
	(674869, 133, '2015-02-01 01:03:48.000000', 'consum', 0.0219, 'lps'),
	(674870, 133, '2015-02-01 01:03:49.000000', 'consum', 0.0219, 'lps'),
	(674871, 133, '2015-02-01 01:03:50.000000', 'consum', 0.0217, 'lps'),
	(674872, 133, '2015-02-01 01:03:51.000000', 'consum', 0.0218, 'lps'),
	(674873, 133, '2015-02-01 01:03:52.000000', 'consum', 0.0219, 'lps'),
	(674874, 133, '2015-02-01 01:03:53.000000', 'consum', 0.0218, 'lps'),
	(674875, 133, '2015-02-01 01:03:54.000000', 'consum', 0.0212, 'lps'),
	(674876, 133, '2015-02-01 01:03:55.000000', 'consum', 0.0210, 'lps'),
	(674877, 133, '2015-02-01 01:03:56.000000', 'consum', 0.0215, 'lps'),
	(674878, 133, '2015-02-01 01:03:57.000000', 'consum', 0.0214, 'lps'),
	(674879, 133, '2015-02-01 01:03:58.000000', 'consum', 0.0213, 'lps'),
	(674880, 133, '2015-02-01 01:03:59.000000', 'consum', 0.0216, 'lps'),
	(674881, 133, '2015-02-01 01:04:00.000000', 'consum', 0.0216, 'lps'),
	(674882, 133, '2015-02-01 01:04:01.000000', 'consum', 0.0214, 'lps'),
	(674883, 133, '2015-02-01 01:04:02.000000', 'consum', 0.0211, 'lps'),
	(674884, 133, '2015-02-01 01:04:03.000000', 'consum', 0.0217, 'lps'),
	(674885, 133, '2015-02-01 01:04:04.000000', 'consum', 0.0218, 'lps'),
	(674886, 133, '2015-02-01 01:04:05.000000', 'consum', 0.0218, 'lps'),
	(674887, 133, '2015-02-01 01:04:06.000000', 'consum', 0.0212, 'lps'),
	(674888, 133, '2015-02-01 01:04:07.000000', 'consum', 0.0210, 'lps'),
	(674889, 133, '2015-02-01 01:04:08.000000', 'consum', 0.0215, 'lps'),
	(674890, 133, '2015-02-01 01:04:09.000000', 'consum', 0.0211, 'lps'),
	(674891, 133, '2015-02-01 01:04:10.000000', 'consum', 0.0214, 'lps'),
	(674892, 133, '2015-02-01 01:04:11.000000', 'consum', 0.0215, 'lps'),
	(674893, 133, '2015-02-01 01:04:12.000000', 'consum', 0.0211, 'lps'),
	(674894, 133, '2015-02-01 01:04:13.000000', 'consum', 0.0215, 'lps'),
	(674895, 133, '2015-02-01 01:04:14.000000', 'consum', 0.0218, 'lps'),
	(674896, 133, '2015-02-01 01:04:15.000000', 'consum', 0.0211, 'lps'),
	(674897, 133, '2015-02-01 01:04:16.000000', 'consum', 0.0218, 'lps'),
	(674898, 133, '2015-02-01 01:04:17.000000', 'consum', 0.0210, 'lps'),
	(674899, 133, '2015-02-01 01:04:18.000000', 'consum', 0.0210, 'lps'),
	(674900, 133, '2015-02-01 01:04:19.000000', 'consum', 0.0210, 'lps'),
	(674901, 133, '2015-02-01 01:04:20.000000', 'consum', 0.0210, 'lps'),
	(674902, 133, '2015-02-01 01:04:21.000000', 'consum', 0.0213, 'lps'),
	(674903, 133, '2015-02-01 01:04:22.000000', 'consum', 0.0210, 'lps'),
	(674904, 133, '2015-02-01 01:04:23.000000', 'consum', 0.0217, 'lps'),
	(674905, 133, '2015-02-01 01:04:24.000000', 'consum', 0.0221, 'lps'),
	(674906, 133, '2015-02-01 01:04:25.000000', 'consum', 0.0220, 'lps'),
	(674907, 133, '2015-02-01 01:04:26.000000', 'consum', 0.0215, 'lps'),
	(674908, 133, '2015-02-01 01:04:27.000000', 'consum', 0.0217, 'lps'),
	(674909, 133, '2015-02-01 01:04:28.000000', 'consum', 0.0219, 'lps'),
	(674910, 133, '2015-02-01 01:04:29.000000', 'consum', 0.0211, 'lps'),
	(674911, 133, '2015-02-01 01:04:30.000000', 'consum', 0.0211, 'lps'),
	(674912, 133, '2015-02-01 01:04:31.000000', 'consum', 0.0214, 'lps'),
	(674913, 133, '2015-02-01 01:04:32.000000', 'consum', 0.0215, 'lps'),
	(674914, 133, '2015-02-01 01:04:33.000000', 'consum', 0.0211, 'lps'),
	(674915, 133, '2015-02-01 01:04:34.000000', 'consum', 0.0211, 'lps'),
	(674916, 133, '2015-02-01 01:04:35.000000', 'consum', 0.0215, 'lps'),
	(674917, 133, '2015-02-01 01:04:36.000000', 'consum', 0.0219, 'lps'),
	(674918, 133, '2015-02-01 01:04:37.000000', 'consum', 0.0217, 'lps'),
	(674919, 133, '2015-02-01 01:04:38.000000', 'consum', 0.0220, 'lps'),
	(674920, 133, '2015-02-01 01:04:39.000000', 'consum', 0.0213, 'lps'),
	(674921, 133, '2015-02-01 01:04:40.000000', 'consum', 0.0210, 'lps'),
	(674922, 133, '2015-02-01 01:04:41.000000', 'consum', 0.0211, 'lps'),
	(674923, 133, '2015-02-01 01:04:42.000000', 'consum', 0.0218, 'lps'),
	(674924, 133, '2015-02-01 01:04:43.000000', 'consum', 0.0211, 'lps'),
	(674925, 133, '2015-02-01 01:04:44.000000', 'consum', 0.0216, 'lps'),
	(674926, 133, '2015-02-01 01:04:45.000000', 'consum', 0.0213, 'lps'),
	(674927, 133, '2015-02-01 01:04:46.000000', 'consum', 0.0221, 'lps'),
	(674928, 133, '2015-02-01 01:04:47.000000', 'consum', 0.0220, 'lps'),
	(674929, 133, '2015-02-01 01:04:48.000000', 'consum', 0.0213, 'lps'),
	(674930, 133, '2015-02-01 01:04:49.000000', 'consum', 0.0211, 'lps'),
	(674931, 133, '2015-02-01 01:04:50.000000', 'consum', 0.0216, 'lps'),
	(674932, 133, '2015-02-01 01:04:51.000000', 'consum', 0.0214, 'lps'),
	(674933, 133, '2015-02-01 01:04:52.000000', 'consum', 0.0212, 'lps'),
	(674934, 133, '2015-02-01 01:04:53.000000', 'consum', 0.0211, 'lps'),
	(674935, 133, '2015-02-01 01:04:54.000000', 'consum', 0.0219, 'lps'),
	(674936, 133, '2015-02-01 01:04:55.000000', 'consum', 0.0218, 'lps'),
	(674937, 133, '2015-02-01 01:04:56.000000', 'consum', 0.0211, 'lps'),
	(674938, 133, '2015-02-01 01:04:57.000000', 'consum', 0.0216, 'lps'),
	(674939, 133, '2015-02-01 01:04:58.000000', 'consum', 0.0214, 'lps'),
	(674940, 133, '2015-02-01 01:04:59.000000', 'consum', 0.0213, 'lps'),
	(674941, 133, '2015-02-01 01:05:00.000000', 'consum', 0.0215, 'lps'),
	(674942, 133, '2015-02-01 01:05:01.000000', 'consum', 0.0211, 'lps'),
	(674943, 133, '2015-02-01 01:05:02.000000', 'consum', 0.0215, 'lps'),
	(674944, 133, '2015-02-01 01:05:03.000000', 'consum', 0.0210, 'lps'),
	(674945, 133, '2015-02-01 01:05:04.000000', 'consum', 0.0216, 'lps'),
	(674946, 133, '2015-02-01 01:05:05.000000', 'consum', 0.0218, 'lps'),
	(674947, 133, '2015-02-01 01:05:06.000000', 'consum', 0.0221, 'lps'),
	(674948, 133, '2015-02-01 01:05:07.000000', 'consum', 0.0216, 'lps'),
	(674949, 133, '2015-02-01 01:05:08.000000', 'consum', 0.0220, 'lps'),
	(674950, 133, '2015-02-01 01:05:09.000000', 'consum', 0.0219, 'lps'),
	(674951, 133, '2015-02-01 01:05:10.000000', 'consum', 0.0215, 'lps'),
	(674952, 133, '2015-02-01 01:05:11.000000', 'consum', 0.0218, 'lps'),
	(674953, 133, '2015-02-01 01:05:12.000000', 'consum', 0.0212, 'lps'),
	(674954, 133, '2015-02-01 01:05:13.000000', 'consum', 0.0219, 'lps'),
	(674955, 133, '2015-02-01 01:05:14.000000', 'consum', 0.0216, 'lps'),
	(674956, 133, '2015-02-01 01:05:15.000000', 'consum', 0.0212, 'lps'),
	(674957, 133, '2015-02-01 01:05:16.000000', 'consum', 0.0214, 'lps'),
	(674958, 133, '2015-02-01 01:05:17.000000', 'consum', 0.0211, 'lps'),
	(674959, 133, '2015-02-01 01:05:18.000000', 'consum', 0.0218, 'lps'),
	(674960, 133, '2015-02-01 01:05:19.000000', 'consum', 0.0210, 'lps'),
	(674961, 133, '2015-02-01 01:05:20.000000', 'consum', 0.0211, 'lps'),
	(674962, 133, '2015-02-01 01:05:21.000000', 'consum', 0.0216, 'lps'),
	(674963, 133, '2015-02-01 01:05:22.000000', 'consum', 0.0213, 'lps'),
	(674964, 133, '2015-02-01 01:05:23.000000', 'consum', 0.0221, 'lps'),
	(674965, 133, '2015-02-01 01:05:24.000000', 'consum', 0.0219, 'lps'),
	(674966, 133, '2015-02-01 01:05:25.000000', 'consum', 0.0221, 'lps'),
	(674967, 133, '2015-02-01 01:05:26.000000', 'consum', 0.0215, 'lps'),
	(674968, 133, '2015-02-01 01:05:27.000000', 'consum', 0.0215, 'lps'),
	(674969, 133, '2015-02-01 01:05:28.000000', 'consum', 0.0220, 'lps'),
	(674970, 133, '2015-02-01 01:05:29.000000', 'consum', 0.0212, 'lps'),
	(674971, 133, '2015-02-01 01:05:30.000000', 'consum', 0.0213, 'lps'),
	(674972, 133, '2015-02-01 01:05:31.000000', 'consum', 0.0220, 'lps'),
	(674973, 133, '2015-02-01 01:05:32.000000', 'consum', 0.0214, 'lps'),
	(674974, 133, '2015-02-01 01:05:33.000000', 'consum', 0.0214, 'lps'),
	(674975, 133, '2015-02-01 01:05:34.000000', 'consum', 0.0219, 'lps'),
	(674976, 133, '2015-02-01 01:05:35.000000', 'consum', 0.0217, 'lps'),
	(674977, 133, '2015-02-01 01:05:36.000000', 'consum', 0.0220, 'lps'),
	(674978, 133, '2015-02-01 01:05:37.000000', 'consum', 0.0214, 'lps'),
	(674979, 133, '2015-02-01 01:05:38.000000', 'consum', 0.0213, 'lps'),
	(674980, 133, '2015-02-01 01:05:39.000000', 'consum', 0.0213, 'lps'),
	(674981, 133, '2015-02-01 01:05:40.000000', 'consum', 0.0218, 'lps'),
	(674982, 133, '2015-02-01 01:05:41.000000', 'consum', 0.0215, 'lps'),
	(674983, 133, '2015-02-01 01:05:42.000000', 'consum', 0.0214, 'lps'),
	(674984, 133, '2015-02-01 01:05:43.000000', 'consum', 0.0214, 'lps'),
	(674985, 133, '2015-02-01 01:05:44.000000', 'consum', 0.0220, 'lps'),
	(674986, 133, '2015-02-01 01:05:45.000000', 'consum', 0.0210, 'lps'),
	(674987, 133, '2015-02-01 01:05:46.000000', 'consum', 0.0218, 'lps'),
	(674988, 133, '2015-02-01 01:05:47.000000', 'consum', 0.0215, 'lps'),
	(674989, 133, '2015-02-01 01:05:48.000000', 'consum', 0.0212, 'lps'),
	(674990, 133, '2015-02-01 01:05:49.000000', 'consum', 0.0216, 'lps'),
	(674991, 133, '2015-02-01 01:05:50.000000', 'consum', 0.0213, 'lps'),
	(674992, 133, '2015-02-01 01:05:51.000000', 'consum', 0.0216, 'lps'),
	(674993, 133, '2015-02-01 01:05:52.000000', 'consum', 0.0221, 'lps'),
	(674994, 133, '2015-02-01 01:05:53.000000', 'consum', 0.0214, 'lps'),
	(674995, 133, '2015-02-01 01:05:54.000000', 'consum', 0.0218, 'lps'),
	(674996, 133, '2015-02-01 01:05:55.000000', 'consum', 0.0214, 'lps'),
	(674997, 133, '2015-02-01 01:05:56.000000', 'consum', 0.0221, 'lps'),
	(674998, 133, '2015-02-01 01:05:57.000000', 'consum', 0.0216, 'lps'),
	(674999, 133, '2015-02-01 01:05:58.000000', 'consum', 0.0220, 'lps'),
	(675000, 133, '2015-02-01 01:05:59.000000', 'consum', 0.0217, 'lps'),
	(675001, 133, '2015-02-01 01:06:00.000000', 'consum', 0.0217, 'lps'),
	(675002, 133, '2015-02-01 01:06:01.000000', 'consum', 0.0213, 'lps'),
	(675003, 133, '2015-02-01 01:06:02.000000', 'consum', 0.0215, 'lps'),
	(675004, 133, '2015-02-01 01:06:03.000000', 'consum', 0.0217, 'lps'),
	(675005, 133, '2015-02-01 01:06:04.000000', 'consum', 0.0216, 'lps'),
	(675006, 133, '2015-02-01 01:06:05.000000', 'consum', 0.0221, 'lps'),
	(675007, 133, '2015-02-01 01:06:06.000000', 'consum', 0.0211, 'lps'),
	(675008, 133, '2015-02-01 01:06:07.000000', 'consum', 0.0216, 'lps'),
	(675009, 133, '2015-02-01 01:06:08.000000', 'consum', 0.0217, 'lps'),
	(675010, 133, '2015-02-01 01:06:09.000000', 'consum', 0.0215, 'lps'),
	(675011, 133, '2015-02-01 01:06:10.000000', 'consum', 0.0216, 'lps'),
	(675012, 133, '2015-02-01 01:06:11.000000', 'consum', 0.0213, 'lps'),
	(675013, 133, '2015-02-01 01:06:12.000000', 'consum', 0.0218, 'lps'),
	(675014, 133, '2015-02-01 01:06:13.000000', 'consum', 0.0216, 'lps'),
	(675015, 133, '2015-02-01 01:06:14.000000', 'consum', 0.0219, 'lps'),
	(675016, 133, '2015-02-01 01:06:15.000000', 'consum', 0.0215, 'lps'),
	(675017, 133, '2015-02-01 01:06:16.000000', 'consum', 0.0219, 'lps'),
	(675018, 133, '2015-02-01 01:06:17.000000', 'consum', 0.0215, 'lps'),
	(675019, 133, '2015-02-01 01:06:18.000000', 'consum', 0.0221, 'lps'),
	(675020, 133, '2015-02-01 01:06:19.000000', 'consum', 0.0216, 'lps'),
	(675021, 133, '2015-02-01 01:06:20.000000', 'consum', 0.0219, 'lps'),
	(675022, 133, '2015-02-01 01:06:21.000000', 'consum', 0.0213, 'lps'),
	(675023, 133, '2015-02-01 01:06:22.000000', 'consum', 0.0211, 'lps'),
	(675024, 133, '2015-02-01 01:06:23.000000', 'consum', 0.0217, 'lps'),
	(675025, 133, '2015-02-01 01:06:24.000000', 'consum', 0.0221, 'lps'),
	(675026, 133, '2015-02-01 01:06:25.000000', 'consum', 0.0219, 'lps'),
	(675027, 133, '2015-02-01 01:06:26.000000', 'consum', 0.0212, 'lps'),
	(675028, 133, '2015-02-01 01:06:27.000000', 'consum', 0.0215, 'lps'),
	(675029, 133, '2015-02-01 01:06:28.000000', 'consum', 0.0218, 'lps'),
	(675030, 133, '2015-02-01 01:06:29.000000', 'consum', 0.0212, 'lps'),
	(675031, 133, '2015-02-01 01:06:30.000000', 'consum', 0.0221, 'lps'),
	(675032, 133, '2015-02-01 01:06:31.000000', 'consum', 0.0211, 'lps'),
	(675033, 133, '2015-02-01 01:06:32.000000', 'consum', 0.0220, 'lps'),
	(675034, 133, '2015-02-01 01:06:33.000000', 'consum', 0.0220, 'lps'),
	(675035, 133, '2015-02-01 01:06:34.000000', 'consum', 0.0218, 'lps'),
	(675036, 133, '2015-02-01 01:06:35.000000', 'consum', 0.0210, 'lps'),
	(675037, 133, '2015-02-01 01:06:36.000000', 'consum', 0.0211, 'lps'),
	(675038, 133, '2015-02-01 01:06:37.000000', 'consum', 0.0217, 'lps'),
	(675039, 133, '2015-02-01 01:06:38.000000', 'consum', 0.0216, 'lps'),
	(675040, 133, '2015-02-01 01:06:39.000000', 'consum', 0.0218, 'lps'),
	(675041, 133, '2015-02-01 01:06:40.000000', 'consum', 0.0212, 'lps'),
	(675042, 133, '2015-02-01 01:06:41.000000', 'consum', 0.0218, 'lps'),
	(675043, 133, '2015-02-01 01:06:42.000000', 'consum', 0.0210, 'lps'),
	(675044, 133, '2015-02-01 01:06:43.000000', 'consum', 0.0210, 'lps'),
	(675045, 133, '2015-02-01 01:06:44.000000', 'consum', 0.0221, 'lps'),
	(675046, 133, '2015-02-01 01:06:45.000000', 'consum', 0.0218, 'lps'),
	(675047, 133, '2015-02-01 01:06:46.000000', 'consum', 0.0219, 'lps'),
	(675048, 133, '2015-02-01 01:06:47.000000', 'consum', 0.0218, 'lps'),
	(675049, 133, '2015-02-01 01:06:48.000000', 'consum', 0.0210, 'lps'),
	(675050, 133, '2015-02-01 01:06:49.000000', 'consum', 0.0212, 'lps'),
	(675051, 133, '2015-02-01 01:06:50.000000', 'consum', 0.0210, 'lps'),
	(675052, 133, '2015-02-01 01:06:51.000000', 'consum', 0.0216, 'lps'),
	(675053, 133, '2015-02-01 01:06:52.000000', 'consum', 0.0216, 'lps'),
	(675054, 133, '2015-02-01 01:06:53.000000', 'consum', 0.0220, 'lps'),
	(675055, 133, '2015-02-01 01:06:54.000000', 'consum', 0.0210, 'lps'),
	(675056, 133, '2015-02-01 01:06:55.000000', 'consum', 0.0216, 'lps'),
	(675057, 133, '2015-02-01 01:06:56.000000', 'consum', 0.0216, 'lps'),
	(675058, 133, '2015-02-01 01:06:57.000000', 'consum', 0.0212, 'lps'),
	(675059, 133, '2015-02-01 01:06:58.000000', 'consum', 0.0212, 'lps'),
	(675060, 133, '2015-02-01 01:06:59.000000', 'consum', 0.0215, 'lps'),
	(675061, 133, '2015-02-01 01:07:00.000000', 'consum', 0.0220, 'lps'),
	(675062, 133, '2015-02-01 01:07:01.000000', 'consum', 0.0218, 'lps'),
	(675063, 133, '2015-02-01 01:07:02.000000', 'consum', 0.0212, 'lps'),
	(675064, 133, '2015-02-01 01:07:03.000000', 'consum', 0.0217, 'lps'),
	(675065, 133, '2015-02-01 01:07:04.000000', 'consum', 0.0218, 'lps'),
	(675066, 133, '2015-02-01 01:07:05.000000', 'consum', 0.0217, 'lps'),
	(675067, 133, '2015-02-01 01:07:06.000000', 'consum', 0.0220, 'lps'),
	(675068, 133, '2015-02-01 01:07:07.000000', 'consum', 0.0218, 'lps'),
	(675069, 133, '2015-02-01 01:07:08.000000', 'consum', 0.0219, 'lps'),
	(675070, 133, '2015-02-01 01:07:09.000000', 'consum', 0.0219, 'lps'),
	(675071, 133, '2015-02-01 01:07:10.000000', 'consum', 0.0219, 'lps'),
	(675072, 133, '2015-02-01 01:07:11.000000', 'consum', 0.0214, 'lps'),
	(675073, 133, '2015-02-01 01:07:12.000000', 'consum', 0.0217, 'lps'),
	(675074, 133, '2015-02-01 01:07:13.000000', 'consum', 0.0219, 'lps'),
	(675075, 133, '2015-02-01 01:07:14.000000', 'consum', 0.0213, 'lps'),
	(675076, 133, '2015-02-01 01:07:15.000000', 'consum', 0.0220, 'lps'),
	(675077, 133, '2015-02-01 01:07:16.000000', 'consum', 0.0216, 'lps'),
	(675078, 133, '2015-02-01 01:07:17.000000', 'consum', 0.0221, 'lps'),
	(675079, 133, '2015-02-01 01:07:18.000000', 'consum', 0.0213, 'lps'),
	(675080, 133, '2015-02-01 01:07:19.000000', 'consum', 0.0218, 'lps'),
	(675081, 133, '2015-02-01 01:07:20.000000', 'consum', 0.0216, 'lps'),
	(675082, 133, '2015-02-01 01:07:21.000000', 'consum', 0.0218, 'lps'),
	(675083, 133, '2015-02-01 01:07:22.000000', 'consum', 0.0218, 'lps'),
	(675084, 133, '2015-02-01 01:07:23.000000', 'consum', 0.0215, 'lps'),
	(675085, 133, '2015-02-01 01:07:24.000000', 'consum', 0.0212, 'lps'),
	(675086, 133, '2015-02-01 01:07:25.000000', 'consum', 0.0216, 'lps'),
	(675087, 133, '2015-02-01 01:07:26.000000', 'consum', 0.0210, 'lps'),
	(675088, 133, '2015-02-01 01:07:27.000000', 'consum', 0.0219, 'lps'),
	(675089, 133, '2015-02-01 01:07:28.000000', 'consum', 0.0219, 'lps'),
	(675090, 133, '2015-02-01 01:07:29.000000', 'consum', 0.0214, 'lps'),
	(675091, 133, '2015-02-01 01:07:30.000000', 'consum', 0.0218, 'lps'),
	(675092, 133, '2015-02-01 01:07:31.000000', 'consum', 0.0214, 'lps'),
	(675093, 133, '2015-02-01 01:07:32.000000', 'consum', 0.0218, 'lps'),
	(675094, 133, '2015-02-01 01:07:33.000000', 'consum', 0.0216, 'lps'),
	(675095, 133, '2015-02-01 01:07:34.000000', 'consum', 0.0214, 'lps'),
	(675096, 133, '2015-02-01 01:07:35.000000', 'consum', 0.0213, 'lps'),
	(675097, 133, '2015-02-01 01:07:36.000000', 'consum', 0.0214, 'lps'),
	(675098, 133, '2015-02-01 01:07:37.000000', 'consum', 0.0221, 'lps'),
	(675099, 133, '2015-02-01 01:07:38.000000', 'consum', 0.0218, 'lps'),
	(675100, 133, '2015-02-01 01:07:39.000000', 'consum', 0.0218, 'lps'),
	(675101, 133, '2015-02-01 01:07:40.000000', 'consum', 0.0213, 'lps'),
	(675102, 133, '2015-02-01 01:07:41.000000', 'consum', 0.0216, 'lps'),
	(675103, 133, '2015-02-01 01:07:42.000000', 'consum', 0.0219, 'lps'),
	(675104, 133, '2015-02-01 01:07:43.000000', 'consum', 0.0211, 'lps'),
	(675105, 133, '2015-02-01 01:07:44.000000', 'consum', 0.0215, 'lps'),
	(675106, 133, '2015-02-01 01:07:45.000000', 'consum', 0.0219, 'lps'),
	(675107, 133, '2015-02-01 01:07:46.000000', 'consum', 0.0217, 'lps'),
	(675108, 133, '2015-02-01 01:07:47.000000', 'consum', 0.0220, 'lps'),
	(675109, 133, '2015-02-01 01:07:48.000000', 'consum', 0.0213, 'lps'),
	(675110, 133, '2015-02-01 01:07:49.000000', 'consum', 0.0221, 'lps'),
	(675111, 133, '2015-02-01 01:07:50.000000', 'consum', 0.0219, 'lps'),
	(675112, 133, '2015-02-01 01:07:51.000000', 'consum', 0.0212, 'lps'),
	(675113, 133, '2015-02-01 01:07:52.000000', 'consum', 0.0217, 'lps'),
	(675114, 133, '2015-02-01 01:07:53.000000', 'consum', 0.0215, 'lps'),
	(675115, 133, '2015-02-01 01:07:54.000000', 'consum', 0.0214, 'lps'),
	(675116, 133, '2015-02-01 01:07:55.000000', 'consum', 0.0218, 'lps'),
	(675117, 133, '2015-02-01 01:07:56.000000', 'consum', 0.0213, 'lps'),
	(675118, 133, '2015-02-01 01:07:57.000000', 'consum', 0.0213, 'lps'),
	(675119, 133, '2015-02-01 01:07:58.000000', 'consum', 0.0218, 'lps'),
	(675120, 133, '2015-02-01 01:07:59.000000', 'consum', 0.0219, 'lps'),
	(675121, 133, '2015-02-01 01:08:00.000000', 'consum', 0.0217, 'lps'),
	(675122, 133, '2015-02-01 01:08:01.000000', 'consum', 0.0220, 'lps'),
	(675123, 133, '2015-02-01 01:08:02.000000', 'consum', 0.0216, 'lps'),
	(675124, 133, '2015-02-01 01:08:03.000000', 'consum', 0.0211, 'lps'),
	(675125, 133, '2015-02-01 01:08:04.000000', 'consum', 0.0220, 'lps'),
	(675126, 133, '2015-02-01 01:08:05.000000', 'consum', 0.0212, 'lps'),
	(675127, 133, '2015-02-01 01:08:06.000000', 'consum', 0.0211, 'lps'),
	(675128, 133, '2015-02-01 01:08:07.000000', 'consum', 0.0213, 'lps'),
	(675129, 133, '2015-02-01 01:08:08.000000', 'consum', 0.0221, 'lps'),
	(675130, 133, '2015-02-01 01:08:09.000000', 'consum', 0.0210, 'lps'),
	(675131, 133, '2015-02-01 01:08:10.000000', 'consum', 0.0211, 'lps'),
	(675132, 133, '2015-02-01 01:08:11.000000', 'consum', 0.0215, 'lps'),
	(675133, 133, '2015-02-01 01:08:12.000000', 'consum', 0.0219, 'lps'),
	(675134, 133, '2015-02-01 01:08:13.000000', 'consum', 0.0220, 'lps'),
	(675135, 133, '2015-02-01 01:08:14.000000', 'consum', 0.0210, 'lps'),
	(675136, 133, '2015-02-01 01:08:15.000000', 'consum', 0.0214, 'lps'),
	(675137, 133, '2015-02-01 01:08:16.000000', 'consum', 0.0220, 'lps'),
	(675138, 133, '2015-02-01 01:08:17.000000', 'consum', 0.0211, 'lps'),
	(675139, 133, '2015-02-01 01:08:18.000000', 'consum', 0.0212, 'lps'),
	(675140, 133, '2015-02-01 01:08:19.000000', 'consum', 0.0216, 'lps'),
	(675141, 133, '2015-02-01 01:08:20.000000', 'consum', 0.0211, 'lps'),
	(675142, 133, '2015-02-01 01:08:21.000000', 'consum', 0.0211, 'lps'),
	(675143, 133, '2015-02-01 01:08:22.000000', 'consum', 0.0210, 'lps'),
	(675144, 133, '2015-02-01 01:08:23.000000', 'consum', 0.0220, 'lps'),
	(675145, 133, '2015-02-01 01:08:24.000000', 'consum', 0.0212, 'lps'),
	(675146, 133, '2015-02-01 01:08:25.000000', 'consum', 0.0217, 'lps'),
	(675147, 133, '2015-02-01 01:08:26.000000', 'consum', 0.0213, 'lps'),
	(675148, 133, '2015-02-01 01:08:27.000000', 'consum', 0.0216, 'lps'),
	(675149, 133, '2015-02-01 01:08:28.000000', 'consum', 0.0221, 'lps'),
	(675150, 133, '2015-02-01 01:08:29.000000', 'consum', 0.0213, 'lps'),
	(675151, 133, '2015-02-01 01:08:30.000000', 'consum', 0.0214, 'lps'),
	(675152, 133, '2015-02-01 01:08:31.000000', 'consum', 0.0210, 'lps'),
	(675153, 133, '2015-02-01 01:08:32.000000', 'consum', 0.0213, 'lps'),
	(675154, 133, '2015-02-01 01:08:33.000000', 'consum', 0.0211, 'lps'),
	(675155, 133, '2015-02-01 01:08:34.000000', 'consum', 0.0217, 'lps'),
	(675156, 133, '2015-02-01 01:08:35.000000', 'consum', 0.0210, 'lps'),
	(675157, 133, '2015-02-01 01:08:36.000000', 'consum', 0.0211, 'lps'),
	(675158, 133, '2015-02-01 01:08:37.000000', 'consum', 0.0214, 'lps'),
	(675159, 133, '2015-02-01 01:08:38.000000', 'consum', 0.0219, 'lps'),
	(675160, 133, '2015-02-01 01:08:39.000000', 'consum', 0.0219, 'lps'),
	(675161, 133, '2015-02-01 01:08:40.000000', 'consum', 0.0215, 'lps'),
	(675162, 133, '2015-02-01 01:08:41.000000', 'consum', 0.0220, 'lps'),
	(675163, 133, '2015-02-01 01:08:42.000000', 'consum', 0.0220, 'lps'),
	(675164, 133, '2015-02-01 01:08:43.000000', 'consum', 0.0210, 'lps'),
	(675165, 133, '2015-02-01 01:08:44.000000', 'consum', 0.0215, 'lps'),
	(675166, 133, '2015-02-01 01:08:45.000000', 'consum', 0.0213, 'lps'),
	(675167, 133, '2015-02-01 01:08:46.000000', 'consum', 0.0210, 'lps'),
	(675168, 133, '2015-02-01 01:08:47.000000', 'consum', 0.0213, 'lps'),
	(675169, 133, '2015-02-01 01:08:48.000000', 'consum', 0.0213, 'lps'),
	(675170, 133, '2015-02-01 01:08:49.000000', 'consum', 0.0217, 'lps'),
	(675171, 133, '2015-02-01 01:08:50.000000', 'consum', 0.0212, 'lps'),
	(675172, 133, '2015-02-01 01:08:51.000000', 'consum', 0.0211, 'lps'),
	(675173, 133, '2015-02-01 01:08:52.000000', 'consum', 0.0211, 'lps'),
	(675174, 133, '2015-02-01 01:08:53.000000', 'consum', 0.0210, 'lps'),
	(675175, 133, '2015-02-01 01:08:54.000000', 'consum', 0.0220, 'lps'),
	(675176, 133, '2015-02-01 01:08:55.000000', 'consum', 0.0214, 'lps'),
	(675177, 133, '2015-02-01 01:08:56.000000', 'consum', 0.0211, 'lps'),
	(675178, 133, '2015-02-01 01:08:57.000000', 'consum', 0.0215, 'lps'),
	(675179, 133, '2015-02-01 01:08:58.000000', 'consum', 0.0210, 'lps'),
	(675180, 133, '2015-02-01 01:08:59.000000', 'consum', 0.0221, 'lps'),
	(675181, 133, '2015-02-01 01:09:00.000000', 'consum', 0.0214, 'lps'),
	(675182, 133, '2015-02-01 01:09:01.000000', 'consum', 0.0211, 'lps'),
	(675183, 133, '2015-02-01 01:09:02.000000', 'consum', 0.0217, 'lps'),
	(675184, 133, '2015-02-01 01:09:03.000000', 'consum', 0.0216, 'lps'),
	(675185, 133, '2015-02-01 01:09:04.000000', 'consum', 0.0220, 'lps'),
	(675186, 133, '2015-02-01 01:09:05.000000', 'consum', 0.0218, 'lps'),
	(675187, 133, '2015-02-01 01:09:06.000000', 'consum', 0.0210, 'lps'),
	(675188, 133, '2015-02-01 01:09:07.000000', 'consum', 0.0221, 'lps'),
	(675189, 133, '2015-02-01 01:09:08.000000', 'consum', 0.0219, 'lps'),
	(675190, 133, '2015-02-01 01:09:09.000000', 'consum', 0.0211, 'lps'),
	(675191, 133, '2015-02-01 01:09:10.000000', 'consum', 0.0213, 'lps'),
	(675192, 133, '2015-02-01 01:09:11.000000', 'consum', 0.0210, 'lps'),
	(675193, 133, '2015-02-01 01:09:12.000000', 'consum', 0.0215, 'lps'),
	(675194, 133, '2015-02-01 01:09:13.000000', 'consum', 0.0212, 'lps'),
	(675195, 133, '2015-02-01 01:09:14.000000', 'consum', 0.0215, 'lps'),
	(675196, 133, '2015-02-01 01:09:15.000000', 'consum', 0.0219, 'lps'),
	(675197, 133, '2015-02-01 01:09:16.000000', 'consum', 0.0214, 'lps'),
	(675198, 133, '2015-02-01 01:09:17.000000', 'consum', 0.0218, 'lps'),
	(675199, 133, '2015-02-01 01:09:18.000000', 'consum', 0.0212, 'lps'),
	(675200, 133, '2015-02-01 01:09:19.000000', 'consum', 0.0210, 'lps'),
	(675201, 133, '2015-02-01 01:09:20.000000', 'consum', 0.0218, 'lps'),
	(675202, 133, '2015-02-01 01:09:21.000000', 'consum', 0.0214, 'lps'),
	(675203, 133, '2015-02-01 01:09:22.000000', 'consum', 0.0219, 'lps'),
	(675204, 133, '2015-02-01 01:09:23.000000', 'consum', 0.0218, 'lps'),
	(675205, 133, '2015-02-01 01:09:24.000000', 'consum', 0.0210, 'lps'),
	(675206, 133, '2015-02-01 01:09:25.000000', 'consum', 0.0214, 'lps'),
	(675207, 133, '2015-02-01 01:09:26.000000', 'consum', 0.0216, 'lps'),
	(675208, 133, '2015-02-01 01:09:27.000000', 'consum', 0.0216, 'lps'),
	(675209, 133, '2015-02-01 01:09:28.000000', 'consum', 0.0210, 'lps'),
	(675210, 133, '2015-02-01 01:09:29.000000', 'consum', 0.0216, 'lps'),
	(675211, 133, '2015-02-01 01:09:30.000000', 'consum', 0.0220, 'lps'),
	(675212, 133, '2015-02-01 01:09:31.000000', 'consum', 0.0215, 'lps'),
	(675213, 133, '2015-02-01 01:09:32.000000', 'consum', 0.0218, 'lps'),
	(675214, 133, '2015-02-01 01:09:33.000000', 'consum', 0.0213, 'lps'),
	(675215, 133, '2015-02-01 01:09:34.000000', 'consum', 0.0213, 'lps'),
	(675216, 133, '2015-02-01 01:09:35.000000', 'consum', 0.0214, 'lps'),
	(675217, 133, '2015-02-01 01:09:36.000000', 'consum', 0.0213, 'lps'),
	(675218, 133, '2015-02-01 01:09:37.000000', 'consum', 0.0213, 'lps'),
	(675219, 133, '2015-02-01 01:09:38.000000', 'consum', 0.0214, 'lps'),
	(675220, 133, '2015-02-01 01:09:39.000000', 'consum', 0.0211, 'lps'),
	(675221, 133, '2015-02-01 01:09:40.000000', 'consum', 0.0217, 'lps'),
	(675222, 133, '2015-02-01 01:09:41.000000', 'consum', 0.0217, 'lps'),
	(675223, 133, '2015-02-01 01:09:42.000000', 'consum', 0.0214, 'lps'),
	(675224, 133, '2015-02-01 01:09:43.000000', 'consum', 0.0220, 'lps'),
	(675225, 133, '2015-02-01 01:09:44.000000', 'consum', 0.0211, 'lps'),
	(675226, 133, '2015-02-01 01:09:45.000000', 'consum', 0.0211, 'lps'),
	(675227, 133, '2015-02-01 01:09:46.000000', 'consum', 0.0215, 'lps'),
	(675228, 133, '2015-02-01 01:09:47.000000', 'consum', 0.0217, 'lps'),
	(675229, 133, '2015-02-01 01:09:48.000000', 'consum', 0.0218, 'lps'),
	(675230, 133, '2015-02-01 01:09:49.000000', 'consum', 0.0218, 'lps'),
	(675231, 133, '2015-02-01 01:09:50.000000', 'consum', 0.0216, 'lps'),
	(675232, 133, '2015-02-01 01:09:51.000000', 'consum', 0.0215, 'lps'),
	(675233, 133, '2015-02-01 01:09:52.000000', 'consum', 0.0217, 'lps'),
	(675234, 133, '2015-02-01 01:09:53.000000', 'consum', 0.0219, 'lps'),
	(675235, 133, '2015-02-01 01:09:54.000000', 'consum', 0.0212, 'lps'),
	(675236, 133, '2015-02-01 01:09:55.000000', 'consum', 0.0215, 'lps'),
	(675237, 133, '2015-02-01 01:09:56.000000', 'consum', 0.0220, 'lps'),
	(675238, 133, '2015-02-01 01:09:57.000000', 'consum', 0.0210, 'lps'),
	(675239, 133, '2015-02-01 01:09:58.000000', 'consum', 0.0214, 'lps'),
	(675240, 133, '2015-02-01 01:09:59.000000', 'consum', 0.0221, 'lps'),
	(675241, 133, '2015-02-01 01:10:00.000000', 'consum', 0.0215, 'lps'),
	(675242, 133, '2015-02-01 01:10:01.000000', 'consum', 0.0215, 'lps'),
	(675243, 133, '2015-02-01 01:10:02.000000', 'consum', 0.0210, 'lps'),
	(675244, 133, '2015-02-01 01:10:03.000000', 'consum', 0.0221, 'lps'),
	(675245, 133, '2015-02-01 01:10:04.000000', 'consum', 0.0215, 'lps'),
	(675246, 133, '2015-02-01 01:10:05.000000', 'consum', 0.0214, 'lps'),
	(675247, 133, '2015-02-01 01:10:06.000000', 'consum', 0.0216, 'lps'),
	(675248, 133, '2015-02-01 01:10:07.000000', 'consum', 0.0218, 'lps'),
	(675249, 133, '2015-02-01 01:10:08.000000', 'consum', 0.0219, 'lps'),
	(675250, 133, '2015-02-01 01:10:09.000000', 'consum', 0.0219, 'lps'),
	(675251, 133, '2015-02-01 01:10:10.000000', 'consum', 0.0216, 'lps'),
	(675252, 133, '2015-02-01 01:10:11.000000', 'consum', 0.0214, 'lps'),
	(675253, 133, '2015-02-01 01:10:12.000000', 'consum', 0.0212, 'lps'),
	(675254, 133, '2015-02-01 01:10:13.000000', 'consum', 0.0211, 'lps'),
	(675255, 133, '2015-02-01 01:10:14.000000', 'consum', 0.0220, 'lps'),
	(675256, 133, '2015-02-01 01:10:15.000000', 'consum', 0.0219, 'lps'),
	(675257, 133, '2015-02-01 01:10:16.000000', 'consum', 0.0217, 'lps'),
	(675258, 133, '2015-02-01 01:10:17.000000', 'consum', 0.0219, 'lps'),
	(675259, 133, '2015-02-01 01:10:18.000000', 'consum', 0.0221, 'lps'),
	(675260, 133, '2015-02-01 01:10:19.000000', 'consum', 0.0213, 'lps'),
	(675261, 133, '2015-02-01 01:10:20.000000', 'consum', 0.0219, 'lps'),
	(675262, 133, '2015-02-01 01:10:21.000000', 'consum', 0.0221, 'lps'),
	(675263, 133, '2015-02-01 01:10:22.000000', 'consum', 0.0214, 'lps'),
	(675264, 133, '2015-02-01 01:10:23.000000', 'consum', 0.0210, 'lps'),
	(675265, 133, '2015-02-01 01:10:24.000000', 'consum', 0.0210, 'lps'),
	(675266, 133, '2015-02-01 01:10:25.000000', 'consum', 0.0210, 'lps'),
	(675267, 133, '2015-02-01 01:10:26.000000', 'consum', 0.0211, 'lps'),
	(675268, 133, '2015-02-01 01:10:27.000000', 'consum', 0.0218, 'lps'),
	(675269, 133, '2015-02-01 01:10:28.000000', 'consum', 0.0220, 'lps'),
	(675270, 133, '2015-02-01 01:10:29.000000', 'consum', 0.0215, 'lps'),
	(675271, 133, '2015-02-01 01:10:30.000000', 'consum', 0.0215, 'lps'),
	(675272, 133, '2015-02-01 01:10:31.000000', 'consum', 0.0220, 'lps'),
	(675273, 133, '2015-02-01 01:10:32.000000', 'consum', 0.0211, 'lps'),
	(675274, 133, '2015-02-01 01:10:33.000000', 'consum', 0.0220, 'lps'),
	(675275, 133, '2015-02-01 01:10:34.000000', 'consum', 0.0221, 'lps'),
	(675276, 133, '2015-02-01 01:10:35.000000', 'consum', 0.0212, 'lps'),
	(675277, 133, '2015-02-01 01:10:36.000000', 'consum', 0.0210, 'lps'),
	(675278, 133, '2015-02-01 01:10:37.000000', 'consum', 0.0219, 'lps'),
	(675279, 133, '2015-02-01 01:10:38.000000', 'consum', 0.0219, 'lps'),
	(675280, 133, '2015-02-01 01:10:39.000000', 'consum', 0.0218, 'lps'),
	(675281, 133, '2015-02-01 01:10:40.000000', 'consum', 0.0212, 'lps'),
	(675282, 133, '2015-02-01 01:10:41.000000', 'consum', 0.0217, 'lps'),
	(675283, 133, '2015-02-01 01:10:42.000000', 'consum', 0.0218, 'lps'),
	(675284, 133, '2015-02-01 01:10:43.000000', 'consum', 0.0218, 'lps'),
	(675285, 133, '2015-02-01 01:10:44.000000', 'consum', 0.0216, 'lps'),
	(675286, 133, '2015-02-01 01:10:45.000000', 'consum', 0.0213, 'lps'),
	(675287, 133, '2015-02-01 01:10:46.000000', 'consum', 0.0210, 'lps'),
	(675288, 133, '2015-02-01 01:10:47.000000', 'consum', 0.0214, 'lps'),
	(675289, 133, '2015-02-01 01:10:48.000000', 'consum', 0.0220, 'lps'),
	(675290, 133, '2015-02-01 01:10:49.000000', 'consum', 0.0221, 'lps'),
	(675291, 133, '2015-02-01 01:10:50.000000', 'consum', 0.0212, 'lps'),
	(675292, 133, '2015-02-01 01:10:51.000000', 'consum', 0.0213, 'lps'),
	(675293, 133, '2015-02-01 01:10:52.000000', 'consum', 0.0218, 'lps'),
	(675294, 133, '2015-02-01 01:10:53.000000', 'consum', 0.0219, 'lps'),
	(675295, 133, '2015-02-01 01:10:54.000000', 'consum', 0.0218, 'lps'),
	(675296, 133, '2015-02-01 01:10:55.000000', 'consum', 0.0214, 'lps'),
	(675297, 133, '2015-02-01 01:10:56.000000', 'consum', 0.0217, 'lps'),
	(675298, 133, '2015-02-01 01:10:57.000000', 'consum', 0.0221, 'lps'),
	(675299, 133, '2015-02-01 01:10:58.000000', 'consum', 0.0219, 'lps'),
	(675300, 133, '2015-02-01 01:10:59.000000', 'consum', 0.0211, 'lps'),
	(675301, 133, '2015-02-01 01:11:00.000000', 'consum', 0.0215, 'lps'),
	(675302, 134, '2015-02-01 00:00:00.000000', 'consum', 0.0240, 'lps'),
	(675303, 134, '2015-02-01 00:00:01.000000', 'consum', 0.0304, 'lps'),
	(675304, 134, '2015-02-01 00:00:02.000000', 'consum', 0.0283, 'lps'),
	(675305, 134, '2015-02-01 00:00:03.000000', 'consum', 0.0291, 'lps'),
	(675306, 134, '2015-02-01 00:00:04.000000', 'consum', 0.0294, 'lps'),
	(675307, 134, '2015-02-01 00:00:05.000000', 'consum', 0.0284, 'lps'),
	(675308, 134, '2015-02-01 00:00:06.000000', 'consum', 0.0226, 'lps'),
	(675309, 134, '2015-02-01 00:00:07.000000', 'consum', 0.0273, 'lps'),
	(675310, 134, '2015-02-01 00:00:08.000000', 'consum', 0.0271, 'lps'),
	(675311, 134, '2015-02-01 00:00:09.000000', 'consum', 0.0223, 'lps'),
	(675312, 134, '2015-02-01 00:00:10.000000', 'consum', 0.0298, 'lps'),
	(675313, 134, '2015-02-01 00:00:11.000000', 'consum', 0.0304, 'lps'),
	(675314, 134, '2015-02-01 00:00:12.000000', 'consum', 0.0212, 'lps'),
	(675315, 134, '2015-02-01 00:00:13.000000', 'consum', 0.0245, 'lps'),
	(675316, 134, '2015-02-01 00:00:14.000000', 'consum', 0.0278, 'lps'),
	(675317, 134, '2015-02-01 00:00:15.000000', 'consum', 0.0239, 'lps'),
	(675318, 134, '2015-02-01 00:00:16.000000', 'consum', 0.0256, 'lps'),
	(675319, 134, '2015-02-01 00:00:17.000000', 'consum', 0.0248, 'lps'),
	(675320, 134, '2015-02-01 00:00:18.000000', 'consum', 0.0263, 'lps'),
	(675321, 134, '2015-02-01 00:00:19.000000', 'consum', 0.0260, 'lps'),
	(675322, 134, '2015-02-01 00:00:20.000000', 'consum', 0.0299, 'lps'),
	(675323, 134, '2015-02-01 00:00:21.000000', 'consum', 0.0300, 'lps'),
	(675324, 134, '2015-02-01 00:00:22.000000', 'consum', 0.0289, 'lps'),
	(675325, 134, '2015-02-01 00:00:23.000000', 'consum', 0.0234, 'lps'),
	(675326, 134, '2015-02-01 00:00:24.000000', 'consum', 0.0299, 'lps'),
	(675327, 134, '2015-02-01 00:00:25.000000', 'consum', 0.0276, 'lps'),
	(675328, 134, '2015-02-01 00:00:26.000000', 'consum', 0.0275, 'lps'),
	(675329, 134, '2015-02-01 00:00:27.000000', 'consum', 0.0231, 'lps'),
	(675330, 134, '2015-02-01 00:00:28.000000', 'consum', 0.0226, 'lps'),
	(675331, 134, '2015-02-01 00:00:29.000000', 'consum', 0.0228, 'lps'),
	(675332, 134, '2015-02-01 00:00:30.000000', 'consum', 0.0251, 'lps'),
	(675333, 134, '2015-02-01 00:00:31.000000', 'consum', 0.0261, 'lps'),
	(675334, 134, '2015-02-01 00:00:32.000000', 'consum', 0.0236, 'lps'),
	(675335, 134, '2015-02-01 00:00:33.000000', 'consum', 0.0294, 'lps'),
	(675336, 134, '2015-02-01 00:00:34.000000', 'consum', 0.0241, 'lps'),
	(675337, 134, '2015-02-01 00:00:35.000000', 'consum', 0.0218, 'lps'),
	(675338, 134, '2015-02-01 00:00:36.000000', 'consum', 0.0261, 'lps'),
	(675339, 134, '2015-02-01 00:00:37.000000', 'consum', 0.0235, 'lps'),
	(675340, 134, '2015-02-01 00:00:38.000000', 'consum', 0.0284, 'lps'),
	(675341, 134, '2015-02-01 00:00:39.000000', 'consum', 0.0302, 'lps'),
	(675342, 134, '2015-02-01 00:00:40.000000', 'consum', 0.0241, 'lps'),
	(675343, 134, '2015-02-01 00:00:41.000000', 'consum', 0.0294, 'lps'),
	(675344, 134, '2015-02-01 00:00:42.000000', 'consum', 0.0231, 'lps'),
	(675345, 134, '2015-02-01 00:00:43.000000', 'consum', 0.0270, 'lps'),
	(675346, 134, '2015-02-01 00:00:44.000000', 'consum', 0.0240, 'lps'),
	(675347, 134, '2015-02-01 00:00:45.000000', 'consum', 0.0283, 'lps'),
	(675348, 134, '2015-02-01 00:00:46.000000', 'consum', 0.0278, 'lps'),
	(675349, 134, '2015-02-01 00:00:47.000000', 'consum', 0.0230, 'lps'),
	(675350, 134, '2015-02-01 00:00:48.000000', 'consum', 0.0210, 'lps'),
	(675351, 134, '2015-02-01 00:00:49.000000', 'consum', 0.0253, 'lps'),
	(675352, 134, '2015-02-01 00:00:50.000000', 'consum', 0.0218, 'lps'),
	(675353, 134, '2015-02-01 00:00:51.000000', 'consum', 0.0226, 'lps'),
	(675354, 134, '2015-02-01 00:00:52.000000', 'consum', 0.0264, 'lps'),
	(675355, 134, '2015-02-01 00:00:53.000000', 'consum', 0.0230, 'lps'),
	(675356, 134, '2015-02-01 00:00:54.000000', 'consum', 0.0251, 'lps'),
	(675357, 134, '2015-02-01 00:00:55.000000', 'consum', 0.0251, 'lps'),
	(675358, 134, '2015-02-01 00:00:56.000000', 'consum', 0.0292, 'lps'),
	(675359, 134, '2015-02-01 00:00:57.000000', 'consum', 0.0291, 'lps'),
	(675360, 134, '2015-02-01 00:00:58.000000', 'consum', 0.0269, 'lps'),
	(675361, 134, '2015-02-01 00:00:59.000000', 'consum', 0.0260, 'lps'),
	(675362, 134, '2015-02-01 00:01:00.000000', 'consum', 0.0286, 'lps'),
	(675363, 134, '2015-02-01 00:01:01.000000', 'consum', 0.0235, 'lps'),
	(675364, 134, '2015-02-01 00:01:02.000000', 'consum', 0.0211, 'lps'),
	(675365, 134, '2015-02-01 00:01:03.000000', 'consum', 0.0243, 'lps'),
	(675366, 134, '2015-02-01 00:01:04.000000', 'consum', 0.0269, 'lps'),
	(675367, 134, '2015-02-01 00:01:05.000000', 'consum', 0.0304, 'lps'),
	(675368, 134, '2015-02-01 00:01:06.000000', 'consum', 0.0296, 'lps'),
	(675369, 134, '2015-02-01 00:01:07.000000', 'consum', 0.0257, 'lps'),
	(675370, 134, '2015-02-01 00:01:08.000000', 'consum', 0.0289, 'lps'),
	(675371, 134, '2015-02-01 00:01:09.000000', 'consum', 0.0260, 'lps'),
	(675372, 134, '2015-02-01 00:01:10.000000', 'consum', 0.0225, 'lps'),
	(675373, 134, '2015-02-01 00:01:11.000000', 'consum', 0.0237, 'lps'),
	(675374, 134, '2015-02-01 00:01:12.000000', 'consum', 0.0300, 'lps'),
	(675375, 134, '2015-02-01 00:01:13.000000', 'consum', 0.0270, 'lps'),
	(675376, 134, '2015-02-01 00:01:14.000000', 'consum', 0.0242, 'lps'),
	(675377, 134, '2015-02-01 00:01:15.000000', 'consum', 0.0294, 'lps'),
	(675378, 134, '2015-02-01 00:01:16.000000', 'consum', 0.0224, 'lps'),
	(675379, 134, '2015-02-01 00:01:17.000000', 'consum', 0.0237, 'lps'),
	(675380, 134, '2015-02-01 00:01:18.000000', 'consum', 0.0300, 'lps'),
	(675381, 134, '2015-02-01 00:01:19.000000', 'consum', 0.0273, 'lps'),
	(675382, 134, '2015-02-01 00:01:20.000000', 'consum', 0.0254, 'lps'),
	(675383, 134, '2015-02-01 00:01:21.000000', 'consum', 0.0243, 'lps'),
	(675384, 134, '2015-02-01 00:01:22.000000', 'consum', 0.0243, 'lps'),
	(675385, 134, '2015-02-01 00:01:23.000000', 'consum', 0.0276, 'lps'),
	(675386, 134, '2015-02-01 00:01:24.000000', 'consum', 0.0235, 'lps'),
	(675387, 134, '2015-02-01 00:01:25.000000', 'consum', 0.0240, 'lps'),
	(675388, 134, '2015-02-01 00:01:26.000000', 'consum', 0.0287, 'lps'),
	(675389, 134, '2015-02-01 00:01:27.000000', 'consum', 0.0299, 'lps'),
	(675390, 134, '2015-02-01 00:01:28.000000', 'consum', 0.0218, 'lps'),
	(675391, 134, '2015-02-01 00:01:29.000000', 'consum', 0.0292, 'lps'),
	(675392, 134, '2015-02-01 00:01:30.000000', 'consum', 0.0287, 'lps'),
	(675393, 134, '2015-02-01 00:01:31.000000', 'consum', 0.0247, 'lps'),
	(675394, 134, '2015-02-01 00:01:32.000000', 'consum', 0.0269, 'lps'),
	(675395, 134, '2015-02-01 00:01:33.000000', 'consum', 0.0292, 'lps'),
	(675396, 134, '2015-02-01 00:01:34.000000', 'consum', 0.0237, 'lps'),
	(675397, 134, '2015-02-01 00:01:35.000000', 'consum', 0.0305, 'lps'),
	(675398, 134, '2015-02-01 00:01:36.000000', 'consum', 0.0296, 'lps'),
	(675399, 134, '2015-02-01 00:01:37.000000', 'consum', 0.0252, 'lps'),
	(675400, 134, '2015-02-01 00:01:38.000000', 'consum', 0.0265, 'lps'),
	(675401, 134, '2015-02-01 00:01:39.000000', 'consum', 0.0259, 'lps'),
	(675402, 134, '2015-02-01 00:01:40.000000', 'consum', 0.0288, 'lps'),
	(675403, 134, '2015-02-01 00:01:41.000000', 'consum', 0.0247, 'lps'),
	(675404, 134, '2015-02-01 00:01:42.000000', 'consum', 0.0264, 'lps'),
	(675405, 134, '2015-02-01 00:01:43.000000', 'consum', 0.0266, 'lps'),
	(675406, 134, '2015-02-01 00:01:44.000000', 'consum', 0.0224, 'lps'),
	(675407, 134, '2015-02-01 00:01:45.000000', 'consum', 0.0219, 'lps'),
	(675408, 134, '2015-02-01 00:01:46.000000', 'consum', 0.0214, 'lps'),
	(675409, 134, '2015-02-01 00:01:47.000000', 'consum', 0.0305, 'lps'),
	(675410, 134, '2015-02-01 00:01:48.000000', 'consum', 0.0260, 'lps'),
	(675411, 134, '2015-02-01 00:01:49.000000', 'consum', 0.0278, 'lps'),
	(675412, 134, '2015-02-01 00:01:50.000000', 'consum', 0.0300, 'lps'),
	(675413, 134, '2015-02-01 00:01:51.000000', 'consum', 0.0249, 'lps'),
	(675414, 134, '2015-02-01 00:01:52.000000', 'consum', 0.0240, 'lps'),
	(675415, 134, '2015-02-01 00:01:53.000000', 'consum', 0.0242, 'lps'),
	(675416, 134, '2015-02-01 00:01:54.000000', 'consum', 0.0281, 'lps'),
	(675417, 134, '2015-02-01 00:01:55.000000', 'consum', 0.0262, 'lps'),
	(675418, 134, '2015-02-01 00:01:56.000000', 'consum', 0.0257, 'lps'),
	(675419, 134, '2015-02-01 00:01:57.000000', 'consum', 0.0292, 'lps'),
	(675420, 134, '2015-02-01 00:01:58.000000', 'consum', 0.0274, 'lps'),
	(675421, 134, '2015-02-01 00:01:59.000000', 'consum', 0.0285, 'lps'),
	(675422, 134, '2015-02-01 00:02:00.000000', 'consum', 0.0291, 'lps'),
	(675423, 134, '2015-02-01 00:02:01.000000', 'consum', 0.0284, 'lps'),
	(675424, 134, '2015-02-01 00:02:02.000000', 'consum', 0.0238, 'lps'),
	(675425, 134, '2015-02-01 00:02:03.000000', 'consum', 0.0229, 'lps'),
	(675426, 134, '2015-02-01 00:02:04.000000', 'consum', 0.0220, 'lps'),
	(675427, 134, '2015-02-01 00:02:05.000000', 'consum', 0.0309, 'lps'),
	(675428, 134, '2015-02-01 00:02:06.000000', 'consum', 0.0264, 'lps'),
	(675429, 134, '2015-02-01 00:02:07.000000', 'consum', 0.0288, 'lps'),
	(675430, 134, '2015-02-01 00:02:08.000000', 'consum', 0.0230, 'lps'),
	(675431, 134, '2015-02-01 00:02:09.000000', 'consum', 0.0282, 'lps'),
	(675432, 134, '2015-02-01 00:02:10.000000', 'consum', 0.0305, 'lps'),
	(675433, 134, '2015-02-01 00:02:11.000000', 'consum', 0.0265, 'lps'),
	(675434, 134, '2015-02-01 00:02:12.000000', 'consum', 0.0302, 'lps'),
	(675435, 134, '2015-02-01 00:02:13.000000', 'consum', 0.0302, 'lps'),
	(675436, 134, '2015-02-01 00:02:14.000000', 'consum', 0.0288, 'lps'),
	(675437, 134, '2015-02-01 00:02:15.000000', 'consum', 0.0223, 'lps'),
	(675438, 134, '2015-02-01 00:02:16.000000', 'consum', 0.0248, 'lps'),
	(675439, 134, '2015-02-01 00:02:17.000000', 'consum', 0.0260, 'lps'),
	(675440, 134, '2015-02-01 00:02:18.000000', 'consum', 0.0242, 'lps'),
	(675441, 134, '2015-02-01 00:02:19.000000', 'consum', 0.0220, 'lps'),
	(675442, 134, '2015-02-01 00:02:20.000000', 'consum', 0.0266, 'lps'),
	(675443, 134, '2015-02-01 00:02:21.000000', 'consum', 0.0258, 'lps'),
	(675444, 134, '2015-02-01 00:02:22.000000', 'consum', 0.0280, 'lps'),
	(675445, 134, '2015-02-01 00:02:23.000000', 'consum', 0.0312, 'lps'),
	(675446, 134, '2015-02-01 00:02:24.000000', 'consum', 0.0307, 'lps'),
	(675447, 134, '2015-02-01 00:02:25.000000', 'consum', 0.0287, 'lps'),
	(675448, 134, '2015-02-01 00:02:26.000000', 'consum', 0.0303, 'lps'),
	(675449, 134, '2015-02-01 00:02:27.000000', 'consum', 0.0237, 'lps'),
	(675450, 134, '2015-02-01 00:02:28.000000', 'consum', 0.0273, 'lps'),
	(675451, 134, '2015-02-01 00:02:29.000000', 'consum', 0.0241, 'lps'),
	(675452, 134, '2015-02-01 00:02:30.000000', 'consum', 0.0279, 'lps'),
	(675453, 134, '2015-02-01 00:02:31.000000', 'consum', 0.0255, 'lps'),
	(675454, 134, '2015-02-01 00:02:32.000000', 'consum', 0.0228, 'lps'),
	(675455, 134, '2015-02-01 00:02:33.000000', 'consum', 0.0268, 'lps'),
	(675456, 134, '2015-02-01 00:02:34.000000', 'consum', 0.0241, 'lps'),
	(675457, 134, '2015-02-01 00:02:35.000000', 'consum', 0.0293, 'lps'),
	(675458, 134, '2015-02-01 00:02:36.000000', 'consum', 0.0224, 'lps'),
	(675459, 134, '2015-02-01 00:02:37.000000', 'consum', 0.0236, 'lps'),
	(675460, 134, '2015-02-01 00:02:38.000000', 'consum', 0.0300, 'lps'),
	(675461, 134, '2015-02-01 00:02:39.000000', 'consum', 0.0274, 'lps'),
	(675462, 134, '2015-02-01 00:02:40.000000', 'consum', 0.0261, 'lps'),
	(675463, 134, '2015-02-01 00:02:41.000000', 'consum', 0.0271, 'lps'),
	(675464, 134, '2015-02-01 00:02:42.000000', 'consum', 0.0263, 'lps'),
	(675465, 134, '2015-02-01 00:02:43.000000', 'consum', 0.0289, 'lps'),
	(675466, 134, '2015-02-01 00:02:44.000000', 'consum', 0.0241, 'lps'),
	(675467, 134, '2015-02-01 00:02:45.000000', 'consum', 0.0233, 'lps'),
	(675468, 134, '2015-02-01 00:02:46.000000', 'consum', 0.0231, 'lps'),
	(675469, 134, '2015-02-01 00:02:47.000000', 'consum', 0.0247, 'lps'),
	(675470, 134, '2015-02-01 00:02:48.000000', 'consum', 0.0230, 'lps'),
	(675471, 134, '2015-02-01 00:02:49.000000', 'consum', 0.0303, 'lps'),
	(675472, 134, '2015-02-01 00:02:50.000000', 'consum', 0.0304, 'lps'),
	(675473, 134, '2015-02-01 00:02:51.000000', 'consum', 0.0301, 'lps'),
	(675474, 134, '2015-02-01 00:02:52.000000', 'consum', 0.0278, 'lps'),
	(675475, 134, '2015-02-01 00:02:53.000000', 'consum', 0.0278, 'lps'),
	(675476, 134, '2015-02-01 00:02:54.000000', 'consum', 0.0242, 'lps'),
	(675477, 134, '2015-02-01 00:02:55.000000', 'consum', 0.0272, 'lps'),
	(675478, 134, '2015-02-01 00:02:56.000000', 'consum', 0.0216, 'lps'),
	(675479, 134, '2015-02-01 00:02:57.000000', 'consum', 0.0262, 'lps'),
	(675480, 134, '2015-02-01 00:02:58.000000', 'consum', 0.0248, 'lps'),
	(675481, 134, '2015-02-01 00:02:59.000000', 'consum', 0.0242, 'lps'),
	(675482, 134, '2015-02-01 00:03:00.000000', 'consum', 0.0255, 'lps'),
	(675483, 134, '2015-02-01 00:03:01.000000', 'consum', 0.0240, 'lps'),
	(675484, 134, '2015-02-01 00:03:02.000000', 'consum', 0.0223, 'lps'),
	(675485, 134, '2015-02-01 00:03:03.000000', 'consum', 0.0289, 'lps'),
	(675486, 134, '2015-02-01 00:03:04.000000', 'consum', 0.0260, 'lps'),
	(675487, 134, '2015-02-01 00:03:05.000000', 'consum', 0.0221, 'lps'),
	(675488, 134, '2015-02-01 00:03:06.000000', 'consum', 0.0220, 'lps'),
	(675489, 134, '2015-02-01 00:03:07.000000', 'consum', 0.0225, 'lps'),
	(675490, 134, '2015-02-01 00:03:08.000000', 'consum', 0.0258, 'lps'),
	(675491, 134, '2015-02-01 00:03:09.000000', 'consum', 0.0303, 'lps'),
	(675492, 134, '2015-02-01 00:03:10.000000', 'consum', 0.0220, 'lps'),
	(675493, 134, '2015-02-01 00:03:11.000000', 'consum', 0.0291, 'lps'),
	(675494, 134, '2015-02-01 00:03:12.000000', 'consum', 0.0275, 'lps'),
	(675495, 134, '2015-02-01 00:03:13.000000', 'consum', 0.0293, 'lps'),
	(675496, 134, '2015-02-01 00:03:14.000000', 'consum', 0.0227, 'lps'),
	(675497, 134, '2015-02-01 00:03:15.000000', 'consum', 0.0250, 'lps'),
	(675498, 134, '2015-02-01 00:03:16.000000', 'consum', 0.0256, 'lps'),
	(675499, 134, '2015-02-01 00:03:17.000000', 'consum', 0.0220, 'lps'),
	(675500, 134, '2015-02-01 00:03:18.000000', 'consum', 0.0223, 'lps'),
	(675501, 134, '2015-02-01 00:03:19.000000', 'consum', 0.0245, 'lps'),
	(675502, 134, '2015-02-01 00:03:20.000000', 'consum', 0.0244, 'lps'),
	(675503, 134, '2015-02-01 00:03:21.000000', 'consum', 0.0277, 'lps'),
	(675504, 134, '2015-02-01 00:03:22.000000', 'consum', 0.0235, 'lps'),
	(675505, 134, '2015-02-01 00:03:23.000000', 'consum', 0.0238, 'lps'),
	(675506, 134, '2015-02-01 00:03:24.000000', 'consum', 0.0275, 'lps'),
	(675507, 134, '2015-02-01 00:03:25.000000', 'consum', 0.0245, 'lps'),
	(675508, 134, '2015-02-01 00:03:26.000000', 'consum', 0.0293, 'lps'),
	(675509, 134, '2015-02-01 00:03:27.000000', 'consum', 0.0211, 'lps'),
	(675510, 134, '2015-02-01 00:03:28.000000', 'consum', 0.0278, 'lps'),
	(675511, 134, '2015-02-01 00:03:29.000000', 'consum', 0.0238, 'lps'),
	(675512, 134, '2015-02-01 00:03:30.000000', 'consum', 0.0250, 'lps'),
	(675513, 134, '2015-02-01 00:03:31.000000', 'consum', 0.0223, 'lps'),
	(675514, 134, '2015-02-01 00:03:32.000000', 'consum', 0.0257, 'lps'),
	(675515, 134, '2015-02-01 00:03:33.000000', 'consum', 0.0304, 'lps'),
	(675516, 134, '2015-02-01 00:03:34.000000', 'consum', 0.0229, 'lps'),
	(675517, 134, '2015-02-01 00:03:35.000000', 'consum', 0.0231, 'lps'),
	(675518, 134, '2015-02-01 00:03:36.000000', 'consum', 0.0260, 'lps'),
	(675519, 134, '2015-02-01 00:03:37.000000', 'consum', 0.0295, 'lps'),
	(675520, 134, '2015-02-01 00:03:38.000000', 'consum', 0.0279, 'lps'),
	(675521, 134, '2015-02-01 00:03:39.000000', 'consum', 0.0302, 'lps'),
	(675522, 134, '2015-02-01 00:03:40.000000', 'consum', 0.0257, 'lps'),
	(675523, 134, '2015-02-01 00:03:41.000000', 'consum', 0.0272, 'lps'),
	(675524, 134, '2015-02-01 00:03:42.000000', 'consum', 0.0275, 'lps'),
	(675525, 134, '2015-02-01 00:03:43.000000', 'consum', 0.0247, 'lps'),
	(675526, 134, '2015-02-01 00:03:44.000000', 'consum', 0.0305, 'lps'),
	(675527, 134, '2015-02-01 00:03:45.000000', 'consum', 0.0264, 'lps'),
	(675528, 134, '2015-02-01 00:03:46.000000', 'consum', 0.0297, 'lps'),
	(675529, 134, '2015-02-01 00:03:47.000000', 'consum', 0.0279, 'lps'),
	(675530, 134, '2015-02-01 00:03:48.000000', 'consum', 0.0295, 'lps'),
	(675531, 134, '2015-02-01 00:03:49.000000', 'consum', 0.0224, 'lps'),
	(675532, 134, '2015-02-01 00:03:50.000000', 'consum', 0.0229, 'lps'),
	(675533, 134, '2015-02-01 00:03:51.000000', 'consum', 0.0263, 'lps'),
	(675534, 134, '2015-02-01 00:03:52.000000', 'consum', 0.0213, 'lps'),
	(675535, 134, '2015-02-01 00:03:53.000000', 'consum', 0.0275, 'lps'),
	(675536, 134, '2015-02-01 00:03:54.000000', 'consum', 0.0215, 'lps'),
	(675537, 134, '2015-02-01 00:03:55.000000', 'consum', 0.0248, 'lps'),
	(675538, 134, '2015-02-01 00:03:56.000000', 'consum', 0.0284, 'lps'),
	(675539, 134, '2015-02-01 00:03:57.000000', 'consum', 0.0258, 'lps'),
	(675540, 134, '2015-02-01 00:03:58.000000', 'consum', 0.0231, 'lps'),
	(675541, 134, '2015-02-01 00:03:59.000000', 'consum', 0.0273, 'lps'),
	(675542, 134, '2015-02-01 00:04:00.000000', 'consum', 0.0256, 'lps'),
	(675543, 134, '2015-02-01 00:04:01.000000', 'consum', 0.0251, 'lps'),
	(675544, 134, '2015-02-01 00:04:02.000000', 'consum', 0.0277, 'lps'),
	(675545, 134, '2015-02-01 00:04:03.000000', 'consum', 0.0215, 'lps'),
	(675546, 134, '2015-02-01 00:04:04.000000', 'consum', 0.0244, 'lps'),
	(675547, 134, '2015-02-01 00:04:05.000000', 'consum', 0.0261, 'lps'),
	(675548, 134, '2015-02-01 00:04:06.000000', 'consum', 0.0263, 'lps'),
	(675549, 134, '2015-02-01 00:04:07.000000', 'consum', 0.0216, 'lps'),
	(675550, 134, '2015-02-01 00:04:08.000000', 'consum', 0.0290, 'lps'),
	(675551, 134, '2015-02-01 00:04:09.000000', 'consum', 0.0285, 'lps'),
	(675552, 134, '2015-02-01 00:04:10.000000', 'consum', 0.0240, 'lps'),
	(675553, 134, '2015-02-01 00:04:11.000000', 'consum', 0.0239, 'lps'),
	(675554, 134, '2015-02-01 00:04:12.000000', 'consum', 0.0264, 'lps'),
	(675555, 134, '2015-02-01 00:04:13.000000', 'consum', 0.0291, 'lps'),
	(675556, 134, '2015-02-01 00:04:14.000000', 'consum', 0.0246, 'lps'),
	(675557, 134, '2015-02-01 00:04:15.000000', 'consum', 0.0252, 'lps'),
	(675558, 134, '2015-02-01 00:04:16.000000', 'consum', 0.0311, 'lps'),
	(675559, 134, '2015-02-01 00:04:17.000000', 'consum', 0.0282, 'lps'),
	(675560, 134, '2015-02-01 00:04:18.000000', 'consum', 0.0266, 'lps'),
	(675561, 134, '2015-02-01 00:04:19.000000', 'consum', 0.0274, 'lps'),
	(675562, 134, '2015-02-01 00:04:20.000000', 'consum', 0.0261, 'lps'),
	(675563, 134, '2015-02-01 00:04:21.000000', 'consum', 0.0274, 'lps'),
	(675564, 134, '2015-02-01 00:04:22.000000', 'consum', 0.0274, 'lps'),
	(675565, 134, '2015-02-01 00:04:23.000000', 'consum', 0.0235, 'lps'),
	(675566, 134, '2015-02-01 00:04:24.000000', 'consum', 0.0245, 'lps'),
	(675567, 134, '2015-02-01 00:04:25.000000', 'consum', 0.0210, 'lps'),
	(675568, 134, '2015-02-01 00:04:26.000000', 'consum', 0.0311, 'lps'),
	(675569, 134, '2015-02-01 00:04:27.000000', 'consum', 0.0305, 'lps'),
	(675570, 134, '2015-02-01 00:04:28.000000', 'consum', 0.0279, 'lps'),
	(675571, 134, '2015-02-01 00:04:29.000000', 'consum', 0.0271, 'lps'),
	(675572, 134, '2015-02-01 00:04:30.000000', 'consum', 0.0309, 'lps'),
	(675573, 134, '2015-02-01 00:04:31.000000', 'consum', 0.0214, 'lps'),
	(675574, 134, '2015-02-01 00:04:32.000000', 'consum', 0.0242, 'lps'),
	(675575, 134, '2015-02-01 00:04:33.000000', 'consum', 0.0254, 'lps'),
	(675576, 134, '2015-02-01 00:04:34.000000', 'consum', 0.0233, 'lps'),
	(675577, 134, '2015-02-01 00:04:35.000000', 'consum', 0.0294, 'lps'),
	(675578, 134, '2015-02-01 00:04:36.000000', 'consum', 0.0254, 'lps'),
	(675579, 134, '2015-02-01 00:04:37.000000', 'consum', 0.0280, 'lps'),
	(675580, 134, '2015-02-01 00:04:38.000000', 'consum', 0.0223, 'lps'),
	(675581, 134, '2015-02-01 00:04:39.000000', 'consum', 0.0271, 'lps'),
	(675582, 134, '2015-02-01 00:04:40.000000', 'consum', 0.0271, 'lps'),
	(675583, 134, '2015-02-01 00:04:41.000000', 'consum', 0.0228, 'lps'),
	(675584, 134, '2015-02-01 00:04:42.000000', 'consum', 0.0220, 'lps'),
	(675585, 134, '2015-02-01 00:04:43.000000', 'consum', 0.0309, 'lps'),
	(675586, 134, '2015-02-01 00:04:44.000000', 'consum', 0.0263, 'lps'),
	(675587, 134, '2015-02-01 00:04:45.000000', 'consum', 0.0284, 'lps'),
	(675588, 134, '2015-02-01 00:04:46.000000', 'consum', 0.0217, 'lps'),
	(675589, 134, '2015-02-01 00:04:47.000000', 'consum', 0.0226, 'lps'),
	(675590, 134, '2015-02-01 00:04:48.000000', 'consum', 0.0270, 'lps'),
	(675591, 134, '2015-02-01 00:04:49.000000', 'consum', 0.0258, 'lps'),
	(675592, 134, '2015-02-01 00:04:50.000000', 'consum', 0.0271, 'lps'),
	(675593, 134, '2015-02-01 00:04:51.000000', 'consum', 0.0268, 'lps'),
	(675594, 134, '2015-02-01 00:04:52.000000', 'consum', 0.0215, 'lps'),
	(675595, 134, '2015-02-01 00:04:53.000000', 'consum', 0.0266, 'lps'),
	(675596, 134, '2015-02-01 00:04:54.000000', 'consum', 0.0269, 'lps'),
	(675597, 134, '2015-02-01 00:04:55.000000', 'consum', 0.0235, 'lps'),
	(675598, 134, '2015-02-01 00:04:56.000000', 'consum', 0.0260, 'lps'),
	(675599, 134, '2015-02-01 00:04:57.000000', 'consum', 0.0285, 'lps'),
	(675600, 134, '2015-02-01 00:04:58.000000', 'consum', 0.0228, 'lps'),
	(675601, 134, '2015-02-01 00:04:59.000000', 'consum', 0.0284, 'lps'),
	(675602, 134, '2015-02-01 00:05:00.000000', 'consum', 0.0216, 'lps'),
	(675603, 134, '2015-02-01 00:05:01.000000', 'consum', 0.0225, 'lps'),
	(675604, 134, '2015-02-01 00:05:02.000000', 'consum', 0.0265, 'lps'),
	(675605, 134, '2015-02-01 00:05:03.000000', 'consum', 0.0237, 'lps'),
	(675606, 134, '2015-02-01 00:05:04.000000', 'consum', 0.0281, 'lps'),
	(675607, 134, '2015-02-01 00:05:05.000000', 'consum', 0.0282, 'lps'),
	(675608, 134, '2015-02-01 00:05:06.000000', 'consum', 0.0252, 'lps'),
	(675609, 134, '2015-02-01 00:05:07.000000', 'consum', 0.0310, 'lps'),
	(675610, 134, '2015-02-01 00:05:08.000000', 'consum', 0.0274, 'lps'),
	(675611, 134, '2015-02-01 00:05:09.000000', 'consum', 0.0230, 'lps'),
	(675612, 134, '2015-02-01 00:05:10.000000', 'consum', 0.0223, 'lps'),
	(675613, 134, '2015-02-01 00:05:11.000000', 'consum', 0.0215, 'lps'),
	(675614, 134, '2015-02-01 00:05:12.000000', 'consum', 0.0298, 'lps'),
	(675615, 134, '2015-02-01 00:05:13.000000', 'consum', 0.0226, 'lps'),
	(675616, 134, '2015-02-01 00:05:14.000000', 'consum', 0.0233, 'lps'),
	(675617, 134, '2015-02-01 00:05:15.000000', 'consum', 0.0278, 'lps'),
	(675618, 134, '2015-02-01 00:05:16.000000', 'consum', 0.0273, 'lps'),
	(675619, 134, '2015-02-01 00:05:17.000000', 'consum', 0.0221, 'lps'),
	(675620, 134, '2015-02-01 00:05:18.000000', 'consum', 0.0279, 'lps'),
	(675621, 134, '2015-02-01 00:05:19.000000', 'consum', 0.0217, 'lps'),
	(675622, 134, '2015-02-01 00:05:20.000000', 'consum', 0.0243, 'lps'),
	(675623, 134, '2015-02-01 00:05:21.000000', 'consum', 0.0252, 'lps'),
	(675624, 134, '2015-02-01 00:05:22.000000', 'consum', 0.0217, 'lps'),
	(675625, 134, '2015-02-01 00:05:23.000000', 'consum', 0.0221, 'lps'),
	(675626, 134, '2015-02-01 00:05:24.000000', 'consum', 0.0248, 'lps'),
	(675627, 134, '2015-02-01 00:05:25.000000', 'consum', 0.0262, 'lps'),
	(675628, 134, '2015-02-01 00:05:26.000000', 'consum', 0.0255, 'lps'),
	(675629, 134, '2015-02-01 00:05:27.000000', 'consum', 0.0278, 'lps'),
	(675630, 134, '2015-02-01 00:05:28.000000', 'consum', 0.0312, 'lps'),
	(675631, 134, '2015-02-01 00:05:29.000000', 'consum', 0.0210, 'lps'),
	(675632, 134, '2015-02-01 00:05:30.000000', 'consum', 0.0214, 'lps'),
	(675633, 134, '2015-02-01 00:05:31.000000', 'consum', 0.0230, 'lps'),
	(675634, 134, '2015-02-01 00:05:32.000000', 'consum', 0.0300, 'lps'),
	(675635, 134, '2015-02-01 00:05:33.000000', 'consum', 0.0290, 'lps'),
	(675636, 134, '2015-02-01 00:05:34.000000', 'consum', 0.0237, 'lps'),
	(675637, 134, '2015-02-01 00:05:35.000000', 'consum', 0.0311, 'lps'),
	(675638, 134, '2015-02-01 00:05:36.000000', 'consum', 0.0221, 'lps'),
	(675639, 134, '2015-02-01 00:05:37.000000', 'consum', 0.0274, 'lps'),
	(675640, 134, '2015-02-01 00:05:38.000000', 'consum', 0.0292, 'lps'),
	(675641, 134, '2015-02-01 00:05:39.000000', 'consum', 0.0222, 'lps'),
	(675642, 134, '2015-02-01 00:05:40.000000', 'consum', 0.0230, 'lps'),
	(675643, 134, '2015-02-01 00:05:41.000000', 'consum', 0.0273, 'lps'),
	(675644, 134, '2015-02-01 00:05:42.000000', 'consum', 0.0259, 'lps'),
	(675645, 134, '2015-02-01 00:05:43.000000', 'consum', 0.0268, 'lps'),
	(675646, 134, '2015-02-01 00:05:44.000000', 'consum', 0.0251, 'lps'),
	(675647, 134, '2015-02-01 00:05:45.000000', 'consum', 0.0243, 'lps'),
	(675648, 134, '2015-02-01 00:05:46.000000', 'consum', 0.0249, 'lps'),
	(675649, 134, '2015-02-01 00:05:47.000000', 'consum', 0.0310, 'lps'),
	(675650, 134, '2015-02-01 00:05:48.000000', 'consum', 0.0281, 'lps'),
	(675651, 134, '2015-02-01 00:05:49.000000', 'consum', 0.0268, 'lps'),
	(675652, 134, '2015-02-01 00:05:50.000000', 'consum', 0.0287, 'lps'),
	(675653, 134, '2015-02-01 00:05:51.000000', 'consum', 0.0214, 'lps'),
	(675654, 134, '2015-02-01 00:05:52.000000', 'consum', 0.0311, 'lps'),
	(675655, 134, '2015-02-01 00:05:53.000000', 'consum', 0.0289, 'lps'),
	(675656, 134, '2015-02-01 00:05:54.000000', 'consum', 0.0303, 'lps'),
	(675657, 134, '2015-02-01 00:05:55.000000', 'consum', 0.0232, 'lps'),
	(675658, 134, '2015-02-01 00:05:56.000000', 'consum', 0.0248, 'lps'),
	(675659, 134, '2015-02-01 00:05:57.000000', 'consum', 0.0229, 'lps'),
	(675660, 134, '2015-02-01 00:05:58.000000', 'consum', 0.0298, 'lps'),
	(675661, 134, '2015-02-01 00:05:59.000000', 'consum', 0.0284, 'lps'),
	(675662, 134, '2015-02-01 00:06:00.000000', 'consum', 0.0212, 'lps'),
	(675663, 134, '2015-02-01 00:06:01.000000', 'consum', 0.0310, 'lps'),
	(675664, 134, '2015-02-01 00:06:02.000000', 'consum', 0.0291, 'lps'),
	(675665, 134, '2015-02-01 00:06:03.000000', 'consum', 0.0212, 'lps'),
	(675666, 134, '2015-02-01 00:06:04.000000', 'consum', 0.0285, 'lps'),
	(675667, 134, '2015-02-01 00:06:05.000000', 'consum', 0.0271, 'lps'),
	(675668, 134, '2015-02-01 00:06:06.000000', 'consum', 0.0293, 'lps'),
	(675669, 134, '2015-02-01 00:06:07.000000', 'consum', 0.0234, 'lps'),
	(675670, 134, '2015-02-01 00:06:08.000000', 'consum', 0.0287, 'lps'),
	(675671, 134, '2015-02-01 00:06:09.000000', 'consum', 0.0215, 'lps'),
	(675672, 134, '2015-02-01 00:06:10.000000', 'consum', 0.0212, 'lps'),
	(675673, 134, '2015-02-01 00:06:11.000000', 'consum', 0.0307, 'lps'),
	(675674, 134, '2015-02-01 00:06:12.000000', 'consum', 0.0278, 'lps'),
	(675675, 134, '2015-02-01 00:06:13.000000', 'consum', 0.0261, 'lps'),
	(675676, 134, '2015-02-01 00:06:14.000000', 'consum', 0.0261, 'lps'),
	(675677, 134, '2015-02-01 00:06:15.000000', 'consum', 0.0311, 'lps'),
	(675678, 134, '2015-02-01 00:06:16.000000', 'consum', 0.0255, 'lps'),
	(675679, 134, '2015-02-01 00:06:17.000000', 'consum', 0.0237, 'lps'),
	(675680, 134, '2015-02-01 00:06:18.000000', 'consum', 0.0311, 'lps'),
	(675681, 134, '2015-02-01 00:06:19.000000', 'consum', 0.0224, 'lps'),
	(675682, 134, '2015-02-01 00:06:20.000000', 'consum', 0.0286, 'lps'),
	(675683, 134, '2015-02-01 00:06:21.000000', 'consum', 0.0240, 'lps'),
	(675684, 134, '2015-02-01 00:06:22.000000', 'consum', 0.0235, 'lps'),
	(675685, 134, '2015-02-01 00:06:23.000000', 'consum', 0.0245, 'lps'),
	(675686, 134, '2015-02-01 00:06:24.000000', 'consum', 0.0310, 'lps'),
	(675687, 134, '2015-02-01 00:06:25.000000', 'consum', 0.0299, 'lps'),
	(675688, 134, '2015-02-01 00:06:26.000000', 'consum', 0.0250, 'lps'),
	(675689, 134, '2015-02-01 00:06:27.000000', 'consum', 0.0247, 'lps'),
	(675690, 134, '2015-02-01 00:06:28.000000', 'consum', 0.0274, 'lps'),
	(675691, 134, '2015-02-01 00:06:29.000000', 'consum', 0.0215, 'lps'),
	(675692, 134, '2015-02-01 00:06:30.000000', 'consum', 0.0249, 'lps'),
	(675693, 134, '2015-02-01 00:06:31.000000', 'consum', 0.0286, 'lps'),
	(675694, 134, '2015-02-01 00:06:32.000000', 'consum', 0.0270, 'lps'),
	(675695, 134, '2015-02-01 00:06:33.000000', 'consum', 0.0283, 'lps'),
	(675696, 134, '2015-02-01 00:06:34.000000', 'consum', 0.0294, 'lps'),
	(675697, 134, '2015-02-01 00:06:35.000000', 'consum', 0.0305, 'lps'),
	(675698, 134, '2015-02-01 00:06:36.000000', 'consum', 0.0227, 'lps'),
	(675699, 134, '2015-02-01 00:06:37.000000', 'consum', 0.0219, 'lps'),
	(675700, 134, '2015-02-01 00:06:38.000000', 'consum', 0.0305, 'lps'),
	(675701, 134, '2015-02-01 00:06:39.000000', 'consum', 0.0246, 'lps'),
	(675702, 134, '2015-02-01 00:06:40.000000', 'consum', 0.0312, 'lps'),
	(675703, 134, '2015-02-01 00:06:41.000000', 'consum', 0.0302, 'lps'),
	(675704, 134, '2015-02-01 00:06:42.000000', 'consum', 0.0264, 'lps'),
	(675705, 134, '2015-02-01 00:06:43.000000', 'consum', 0.0308, 'lps'),
	(675706, 134, '2015-02-01 00:06:44.000000', 'consum', 0.0227, 'lps'),
	(675707, 134, '2015-02-01 00:06:45.000000', 'consum', 0.0311, 'lps'),
	(675708, 134, '2015-02-01 00:06:46.000000', 'consum', 0.0254, 'lps'),
	(675709, 134, '2015-02-01 00:06:47.000000', 'consum', 0.0228, 'lps'),
	(675710, 134, '2015-02-01 00:06:48.000000', 'consum', 0.0273, 'lps'),
	(675711, 134, '2015-02-01 00:06:49.000000', 'consum', 0.0264, 'lps'),
	(675712, 134, '2015-02-01 00:06:50.000000', 'consum', 0.0292, 'lps'),
	(675713, 134, '2015-02-01 00:06:51.000000', 'consum', 0.0251, 'lps'),
	(675714, 134, '2015-02-01 00:06:52.000000', 'consum', 0.0275, 'lps'),
	(675715, 134, '2015-02-01 00:06:53.000000', 'consum', 0.0310, 'lps'),
	(675716, 134, '2015-02-01 00:06:54.000000', 'consum', 0.0307, 'lps'),
	(675717, 134, '2015-02-01 00:06:55.000000', 'consum', 0.0292, 'lps'),
	(675718, 134, '2015-02-01 00:06:56.000000', 'consum', 0.0229, 'lps'),
	(675719, 134, '2015-02-01 00:06:57.000000', 'consum', 0.0262, 'lps'),
	(675720, 134, '2015-02-01 00:06:58.000000', 'consum', 0.0211, 'lps'),
	(675721, 134, '2015-02-01 00:06:59.000000', 'consum', 0.0264, 'lps'),
	(675722, 134, '2015-02-01 00:07:00.000000', 'consum', 0.0271, 'lps'),
	(675723, 134, '2015-02-01 00:07:01.000000', 'consum', 0.0249, 'lps'),
	(675724, 134, '2015-02-01 00:07:02.000000', 'consum', 0.0226, 'lps'),
	(675725, 134, '2015-02-01 00:07:03.000000', 'consum', 0.0273, 'lps'),
	(675726, 134, '2015-02-01 00:07:04.000000', 'consum', 0.0274, 'lps'),
	(675727, 134, '2015-02-01 00:07:05.000000', 'consum', 0.0236, 'lps'),
	(675728, 134, '2015-02-01 00:07:06.000000', 'consum', 0.0255, 'lps'),
	(675729, 134, '2015-02-01 00:07:07.000000', 'consum', 0.0251, 'lps'),
	(675730, 134, '2015-02-01 00:07:08.000000', 'consum', 0.0282, 'lps'),
	(675731, 134, '2015-02-01 00:07:09.000000', 'consum', 0.0242, 'lps'),
	(675732, 134, '2015-02-01 00:07:10.000000', 'consum', 0.0256, 'lps'),
	(675733, 134, '2015-02-01 00:07:11.000000', 'consum', 0.0243, 'lps'),
	(675734, 134, '2015-02-01 00:07:12.000000', 'consum', 0.0237, 'lps'),
	(675735, 134, '2015-02-01 00:07:13.000000', 'consum', 0.0246, 'lps'),
	(675736, 134, '2015-02-01 00:07:14.000000', 'consum', 0.0310, 'lps'),
	(675737, 134, '2015-02-01 00:07:15.000000', 'consum', 0.0293, 'lps'),
	(675738, 134, '2015-02-01 00:07:16.000000', 'consum', 0.0224, 'lps'),
	(675739, 134, '2015-02-01 00:07:17.000000', 'consum', 0.0235, 'lps'),
	(675740, 134, '2015-02-01 00:07:18.000000', 'consum', 0.0294, 'lps'),
	(675741, 134, '2015-02-01 00:07:19.000000', 'consum', 0.0249, 'lps'),
	(675742, 134, '2015-02-01 00:07:20.000000', 'consum', 0.0255, 'lps'),
	(675743, 134, '2015-02-01 00:07:21.000000', 'consum', 0.0217, 'lps'),
	(675744, 134, '2015-02-01 00:07:22.000000', 'consum', 0.0213, 'lps'),
	(675745, 134, '2015-02-01 00:07:23.000000', 'consum', 0.0309, 'lps'),
	(675746, 134, '2015-02-01 00:07:24.000000', 'consum', 0.0284, 'lps'),
	(675747, 134, '2015-02-01 00:07:25.000000', 'consum', 0.0283, 'lps'),
	(675748, 134, '2015-02-01 00:07:26.000000', 'consum', 0.0249, 'lps'),
	(675749, 134, '2015-02-01 00:07:27.000000', 'consum', 0.0290, 'lps'),
	(675750, 134, '2015-02-01 00:07:28.000000', 'consum', 0.0289, 'lps'),
	(675751, 134, '2015-02-01 00:07:29.000000', 'consum', 0.0262, 'lps'),
	(675752, 134, '2015-02-01 00:07:30.000000', 'consum', 0.0233, 'lps'),
	(675753, 134, '2015-02-01 00:07:31.000000', 'consum', 0.0271, 'lps'),
	(675754, 134, '2015-02-01 00:07:32.000000', 'consum', 0.0244, 'lps'),
	(675755, 134, '2015-02-01 00:07:33.000000', 'consum', 0.0297, 'lps'),
	(675756, 134, '2015-02-01 00:07:34.000000', 'consum', 0.0237, 'lps'),
	(675757, 134, '2015-02-01 00:07:35.000000', 'consum', 0.0288, 'lps'),
	(675758, 134, '2015-02-01 00:07:36.000000', 'consum', 0.0213, 'lps'),
	(675759, 134, '2015-02-01 00:07:37.000000', 'consum', 0.0300, 'lps'),
	(675760, 134, '2015-02-01 00:07:38.000000', 'consum', 0.0239, 'lps'),
	(675761, 134, '2015-02-01 00:07:39.000000', 'consum', 0.0292, 'lps'),
	(675762, 134, '2015-02-01 00:07:40.000000', 'consum', 0.0222, 'lps'),
	(675763, 134, '2015-02-01 00:07:41.000000', 'consum', 0.0234, 'lps'),
	(675764, 134, '2015-02-01 00:07:42.000000', 'consum', 0.0293, 'lps'),
	(675765, 134, '2015-02-01 00:07:43.000000', 'consum', 0.0247, 'lps'),
	(675766, 134, '2015-02-01 00:07:44.000000', 'consum', 0.0247, 'lps'),
	(675767, 134, '2015-02-01 00:07:45.000000', 'consum', 0.0284, 'lps'),
	(675768, 134, '2015-02-01 00:07:46.000000', 'consum', 0.0265, 'lps'),
	(675769, 134, '2015-02-01 00:07:47.000000', 'consum', 0.0261, 'lps'),
	(675770, 134, '2015-02-01 00:07:48.000000', 'consum', 0.0303, 'lps'),
	(675771, 134, '2015-02-01 00:07:49.000000', 'consum', 0.0212, 'lps'),
	(675772, 134, '2015-02-01 00:07:50.000000', 'consum', 0.0249, 'lps'),
	(675773, 134, '2015-02-01 00:07:51.000000', 'consum', 0.0299, 'lps'),
	(675774, 134, '2015-02-01 00:07:52.000000', 'consum', 0.0228, 'lps'),
	(675775, 134, '2015-02-01 00:07:53.000000', 'consum', 0.0241, 'lps'),
	(675776, 134, '2015-02-01 00:07:54.000000', 'consum', 0.0312, 'lps'),
	(675777, 134, '2015-02-01 00:07:55.000000', 'consum', 0.0214, 'lps'),
	(675778, 134, '2015-02-01 00:07:56.000000', 'consum', 0.0233, 'lps'),
	(675779, 134, '2015-02-01 00:07:57.000000', 'consum', 0.0312, 'lps'),
	(675780, 134, '2015-02-01 00:07:58.000000', 'consum', 0.0242, 'lps'),
	(675781, 134, '2015-02-01 00:07:59.000000', 'consum', 0.0272, 'lps'),
	(675782, 134, '2015-02-01 00:08:00.000000', 'consum', 0.0217, 'lps'),
	(675783, 134, '2015-02-01 00:08:01.000000', 'consum', 0.0264, 'lps'),
	(675784, 134, '2015-02-01 00:08:02.000000', 'consum', 0.0254, 'lps'),
	(675785, 134, '2015-02-01 00:08:03.000000', 'consum', 0.0271, 'lps'),
	(675786, 134, '2015-02-01 00:08:04.000000', 'consum', 0.0278, 'lps'),
	(675787, 134, '2015-02-01 00:08:05.000000', 'consum', 0.0266, 'lps'),
	(675788, 134, '2015-02-01 00:08:06.000000', 'consum', 0.0284, 'lps'),
	(675789, 134, '2015-02-01 00:08:07.000000', 'consum', 0.0312, 'lps'),
	(675790, 134, '2015-02-01 00:08:08.000000', 'consum', 0.0292, 'lps'),
	(675791, 134, '2015-02-01 00:08:09.000000', 'consum', 0.0210, 'lps'),
	(675792, 134, '2015-02-01 00:08:10.000000', 'consum', 0.0275, 'lps'),
	(675793, 134, '2015-02-01 00:08:11.000000', 'consum', 0.0227, 'lps'),
	(675794, 134, '2015-02-01 00:08:12.000000', 'consum', 0.0305, 'lps'),
	(675795, 134, '2015-02-01 00:08:13.000000', 'consum', 0.0222, 'lps'),
	(675796, 134, '2015-02-01 00:08:14.000000', 'consum', 0.0294, 'lps'),
	(675797, 134, '2015-02-01 00:08:15.000000', 'consum', 0.0288, 'lps'),
	(675798, 134, '2015-02-01 00:08:16.000000', 'consum', 0.0244, 'lps'),
	(675799, 134, '2015-02-01 00:08:17.000000', 'consum', 0.0250, 'lps'),
	(675800, 134, '2015-02-01 00:08:18.000000', 'consum', 0.0307, 'lps'),
	(675801, 134, '2015-02-01 00:08:19.000000', 'consum', 0.0268, 'lps'),
	(675802, 134, '2015-02-01 00:08:20.000000', 'consum', 0.0310, 'lps'),
	(675803, 134, '2015-02-01 00:08:21.000000', 'consum', 0.0231, 'lps'),
	(675804, 134, '2015-02-01 00:08:22.000000', 'consum', 0.0219, 'lps'),
	(675805, 134, '2015-02-01 00:08:23.000000', 'consum', 0.0296, 'lps'),
	(675806, 134, '2015-02-01 00:08:24.000000', 'consum', 0.0306, 'lps'),
	(675807, 134, '2015-02-01 00:08:25.000000', 'consum', 0.0224, 'lps'),
	(675808, 134, '2015-02-01 00:08:26.000000', 'consum', 0.0302, 'lps'),
	(675809, 134, '2015-02-01 00:08:27.000000', 'consum', 0.0217, 'lps'),
	(675810, 134, '2015-02-01 00:08:28.000000', 'consum', 0.0277, 'lps'),
	(675811, 134, '2015-02-01 00:08:29.000000', 'consum', 0.0217, 'lps'),
	(675812, 134, '2015-02-01 00:08:30.000000', 'consum', 0.0250, 'lps'),
	(675813, 134, '2015-02-01 00:08:31.000000', 'consum', 0.0285, 'lps'),
	(675814, 134, '2015-02-01 00:08:32.000000', 'consum', 0.0262, 'lps'),
	(675815, 134, '2015-02-01 00:08:33.000000', 'consum', 0.0244, 'lps'),
	(675816, 134, '2015-02-01 00:08:34.000000', 'consum', 0.0224, 'lps'),
	(675817, 134, '2015-02-01 00:08:35.000000', 'consum', 0.0281, 'lps'),
	(675818, 134, '2015-02-01 00:08:36.000000', 'consum', 0.0216, 'lps'),
	(675819, 134, '2015-02-01 00:08:37.000000', 'consum', 0.0233, 'lps'),
	(675820, 134, '2015-02-01 00:08:38.000000', 'consum', 0.0306, 'lps'),
	(675821, 134, '2015-02-01 00:08:39.000000', 'consum', 0.0212, 'lps'),
	(675822, 134, '2015-02-01 00:08:40.000000', 'consum', 0.0240, 'lps'),
	(675823, 134, '2015-02-01 00:08:41.000000', 'consum', 0.0254, 'lps'),
	(675824, 134, '2015-02-01 00:08:42.000000', 'consum', 0.0234, 'lps'),
	(675825, 134, '2015-02-01 00:08:43.000000', 'consum', 0.0305, 'lps'),
	(675826, 134, '2015-02-01 00:08:44.000000', 'consum', 0.0302, 'lps'),
	(675827, 134, '2015-02-01 00:08:45.000000', 'consum', 0.0284, 'lps'),
	(675828, 134, '2015-02-01 00:08:46.000000', 'consum', 0.0302, 'lps'),
	(675829, 134, '2015-02-01 00:08:47.000000', 'consum', 0.0245, 'lps'),
	(675830, 134, '2015-02-01 00:08:48.000000', 'consum', 0.0211, 'lps'),
	(675831, 134, '2015-02-01 00:08:49.000000', 'consum', 0.0215, 'lps'),
	(675832, 134, '2015-02-01 00:08:50.000000', 'consum', 0.0233, 'lps'),
	(675833, 134, '2015-02-01 00:08:51.000000', 'consum', 0.0309, 'lps'),
	(675834, 134, '2015-02-01 00:08:52.000000', 'consum', 0.0224, 'lps'),
	(675835, 134, '2015-02-01 00:08:53.000000', 'consum', 0.0294, 'lps'),
	(675836, 134, '2015-02-01 00:08:54.000000', 'consum', 0.0277, 'lps'),
	(675837, 134, '2015-02-01 00:08:55.000000', 'consum', 0.0296, 'lps'),
	(675838, 134, '2015-02-01 00:08:56.000000', 'consum', 0.0231, 'lps'),
	(675839, 134, '2015-02-01 00:08:57.000000', 'consum', 0.0265, 'lps'),
	(675840, 134, '2015-02-01 00:08:58.000000', 'consum', 0.0214, 'lps'),
	(675841, 134, '2015-02-01 00:08:59.000000', 'consum', 0.0275, 'lps'),
	(675842, 134, '2015-02-01 00:09:00.000000', 'consum', 0.0211, 'lps'),
	(675843, 134, '2015-02-01 00:09:01.000000', 'consum', 0.0230, 'lps'),
	(675844, 134, '2015-02-01 00:09:02.000000', 'consum', 0.0304, 'lps'),
	(675845, 134, '2015-02-01 00:09:03.000000', 'consum', 0.0212, 'lps'),
	(675846, 134, '2015-02-01 00:09:04.000000', 'consum', 0.0244, 'lps'),
	(675847, 134, '2015-02-01 00:09:05.000000', 'consum', 0.0275, 'lps'),
	(675848, 134, '2015-02-01 00:09:06.000000', 'consum', 0.0225, 'lps'),
	(675849, 134, '2015-02-01 00:09:07.000000', 'consum', 0.0296, 'lps'),
	(675850, 134, '2015-02-01 00:09:08.000000', 'consum', 0.0288, 'lps'),
	(675851, 134, '2015-02-01 00:09:09.000000', 'consum', 0.0238, 'lps'),
	(675852, 134, '2015-02-01 00:09:10.000000', 'consum', 0.0220, 'lps'),
	(675853, 134, '2015-02-01 00:09:11.000000', 'consum', 0.0282, 'lps'),
	(675854, 134, '2015-02-01 00:09:12.000000', 'consum', 0.0228, 'lps'),
	(675855, 134, '2015-02-01 00:09:13.000000', 'consum', 0.0294, 'lps'),
	(675856, 134, '2015-02-01 00:09:14.000000', 'consum', 0.0265, 'lps'),
	(675857, 134, '2015-02-01 00:09:15.000000', 'consum', 0.0234, 'lps'),
	(675858, 134, '2015-02-01 00:09:16.000000', 'consum', 0.0269, 'lps'),
	(675859, 134, '2015-02-01 00:09:17.000000', 'consum', 0.0229, 'lps'),
	(675860, 134, '2015-02-01 00:09:18.000000', 'consum', 0.0229, 'lps'),
	(675861, 134, '2015-02-01 00:09:19.000000', 'consum', 0.0248, 'lps'),
	(675862, 134, '2015-02-01 00:09:20.000000', 'consum', 0.0244, 'lps'),
	(675863, 134, '2015-02-01 00:09:21.000000', 'consum', 0.0263, 'lps'),
	(675864, 134, '2015-02-01 00:09:22.000000', 'consum', 0.0272, 'lps'),
	(675865, 134, '2015-02-01 00:09:23.000000', 'consum', 0.0258, 'lps'),
	(675866, 134, '2015-02-01 00:09:24.000000', 'consum', 0.0264, 'lps'),
	(675867, 134, '2015-02-01 00:09:25.000000', 'consum', 0.0235, 'lps'),
	(675868, 134, '2015-02-01 00:09:26.000000', 'consum', 0.0276, 'lps'),
	(675869, 134, '2015-02-01 00:09:27.000000', 'consum', 0.0261, 'lps'),
	(675870, 134, '2015-02-01 00:09:28.000000', 'consum', 0.0267, 'lps'),
	(675871, 134, '2015-02-01 00:09:29.000000', 'consum', 0.0239, 'lps'),
	(675872, 134, '2015-02-01 00:09:30.000000', 'consum', 0.0285, 'lps'),
	(675873, 134, '2015-02-01 00:09:31.000000', 'consum', 0.0296, 'lps'),
	(675874, 134, '2015-02-01 00:09:32.000000', 'consum', 0.0312, 'lps'),
	(675875, 134, '2015-02-01 00:09:33.000000', 'consum', 0.0255, 'lps'),
	(675876, 134, '2015-02-01 00:09:34.000000', 'consum', 0.0234, 'lps'),
	(675877, 134, '2015-02-01 00:09:35.000000', 'consum', 0.0297, 'lps'),
	(675878, 134, '2015-02-01 00:09:36.000000', 'consum', 0.0264, 'lps'),
	(675879, 134, '2015-02-01 00:09:37.000000', 'consum', 0.0221, 'lps'),
	(675880, 134, '2015-02-01 00:09:38.000000', 'consum', 0.0310, 'lps'),
	(675881, 134, '2015-02-01 00:09:39.000000', 'consum', 0.0263, 'lps'),
	(675882, 134, '2015-02-01 00:09:40.000000', 'consum', 0.0281, 'lps'),
	(675883, 134, '2015-02-01 00:09:41.000000', 'consum', 0.0301, 'lps'),
	(675884, 134, '2015-02-01 00:09:42.000000', 'consum', 0.0249, 'lps'),
	(675885, 134, '2015-02-01 00:09:43.000000', 'consum', 0.0235, 'lps'),
	(675886, 134, '2015-02-01 00:09:44.000000', 'consum', 0.0220, 'lps'),
	(675887, 134, '2015-02-01 00:09:45.000000', 'consum', 0.0288, 'lps'),
	(675888, 134, '2015-02-01 00:09:46.000000', 'consum', 0.0260, 'lps'),
	(675889, 134, '2015-02-01 00:09:47.000000', 'consum', 0.0228, 'lps'),
	(675890, 134, '2015-02-01 00:09:48.000000', 'consum', 0.0254, 'lps'),
	(675891, 134, '2015-02-01 00:09:49.000000', 'consum', 0.0273, 'lps'),
	(675892, 134, '2015-02-01 00:09:50.000000', 'consum', 0.0292, 'lps'),
	(675893, 134, '2015-02-01 00:09:51.000000', 'consum', 0.0224, 'lps'),
	(675894, 134, '2015-02-01 00:09:52.000000', 'consum', 0.0240, 'lps'),
	(675895, 134, '2015-02-01 00:09:53.000000', 'consum', 0.0216, 'lps'),
	(675896, 134, '2015-02-01 00:09:54.000000', 'consum', 0.0254, 'lps'),
	(675897, 134, '2015-02-01 00:09:55.000000', 'consum', 0.0310, 'lps'),
	(675898, 134, '2015-02-01 00:09:56.000000', 'consum', 0.0269, 'lps'),
	(675899, 134, '2015-02-01 00:09:57.000000', 'consum', 0.0310, 'lps'),
	(675900, 134, '2015-02-01 00:09:58.000000', 'consum', 0.0222, 'lps'),
	(675901, 134, '2015-02-01 00:09:59.000000', 'consum', 0.0279, 'lps'),
	(675902, 134, '2015-02-01 00:10:00.000000', 'consum', 0.0210, 'lps'),
	(675903, 134, '2015-02-01 00:10:01.000000', 'consum', 0.0211, 'lps'),
	(675904, 134, '2015-02-01 00:10:02.000000', 'consum', 0.0214, 'lps'),
	(675905, 134, '2015-02-01 00:10:03.000000', 'consum', 0.0230, 'lps'),
	(675906, 134, '2015-02-01 00:10:04.000000', 'consum', 0.0298, 'lps'),
	(675907, 134, '2015-02-01 00:10:05.000000', 'consum', 0.0282, 'lps'),
	(675908, 134, '2015-02-01 00:10:06.000000', 'consum', 0.0305, 'lps'),
	(675909, 134, '2015-02-01 00:10:07.000000', 'consum', 0.0262, 'lps'),
	(675910, 134, '2015-02-01 00:10:08.000000', 'consum', 0.0292, 'lps'),
	(675911, 134, '2015-02-01 00:10:09.000000', 'consum', 0.0256, 'lps'),
	(675912, 134, '2015-02-01 00:10:10.000000', 'consum', 0.0298, 'lps'),
	(675913, 134, '2015-02-01 00:10:11.000000', 'consum', 0.0306, 'lps'),
	(675914, 134, '2015-02-01 00:10:12.000000', 'consum', 0.0222, 'lps'),
	(675915, 134, '2015-02-01 00:10:13.000000', 'consum', 0.0291, 'lps'),
	(675916, 134, '2015-02-01 00:10:14.000000', 'consum', 0.0271, 'lps'),
	(675917, 134, '2015-02-01 00:10:15.000000', 'consum', 0.0272, 'lps'),
	(675918, 134, '2015-02-01 00:10:16.000000', 'consum', 0.0235, 'lps'),
	(675919, 134, '2015-02-01 00:10:17.000000', 'consum', 0.0254, 'lps'),
	(675920, 134, '2015-02-01 00:10:18.000000', 'consum', 0.0252, 'lps'),
	(675921, 134, '2015-02-01 00:10:19.000000', 'consum', 0.0289, 'lps'),
	(675922, 134, '2015-02-01 00:10:20.000000', 'consum', 0.0275, 'lps'),
	(675923, 134, '2015-02-01 00:10:21.000000', 'consum', 0.0296, 'lps'),
	(675924, 134, '2015-02-01 00:10:22.000000', 'consum', 0.0240, 'lps'),
	(675925, 134, '2015-02-01 00:10:23.000000', 'consum', 0.0307, 'lps'),
	(675926, 134, '2015-02-01 00:10:24.000000', 'consum', 0.0296, 'lps'),
	(675927, 134, '2015-02-01 00:10:25.000000', 'consum', 0.0249, 'lps'),
	(675928, 134, '2015-02-01 00:10:26.000000', 'consum', 0.0252, 'lps'),
	(675929, 134, '2015-02-01 00:10:27.000000', 'consum', 0.0300, 'lps'),
	(675930, 134, '2015-02-01 00:10:28.000000', 'consum', 0.0228, 'lps'),
	(675931, 134, '2015-02-01 00:10:29.000000', 'consum', 0.0235, 'lps'),
	(675932, 134, '2015-02-01 00:10:30.000000', 'consum', 0.0283, 'lps'),
	(675933, 134, '2015-02-01 00:10:31.000000', 'consum', 0.0294, 'lps'),
	(675934, 134, '2015-02-01 00:10:32.000000', 'consum', 0.0307, 'lps'),
	(675935, 134, '2015-02-01 00:10:33.000000', 'consum', 0.0238, 'lps'),
	(675936, 134, '2015-02-01 00:10:34.000000', 'consum', 0.0265, 'lps'),
	(675937, 134, '2015-02-01 00:10:35.000000', 'consum', 0.0298, 'lps'),
	(675938, 134, '2015-02-01 00:10:36.000000', 'consum', 0.0280, 'lps'),
	(675939, 134, '2015-02-01 00:10:37.000000', 'consum', 0.0296, 'lps'),
	(675940, 134, '2015-02-01 00:10:38.000000', 'consum', 0.0226, 'lps'),
	(675941, 134, '2015-02-01 00:10:39.000000', 'consum', 0.0240, 'lps'),
	(675942, 134, '2015-02-01 00:10:40.000000', 'consum', 0.0310, 'lps'),
	(675943, 134, '2015-02-01 00:10:41.000000', 'consum', 0.0312, 'lps'),
	(675944, 134, '2015-02-01 00:10:42.000000', 'consum', 0.0215, 'lps'),
	(675945, 134, '2015-02-01 00:10:43.000000', 'consum', 0.0239, 'lps'),
	(675946, 134, '2015-02-01 00:10:44.000000', 'consum', 0.0235, 'lps'),
	(675947, 134, '2015-02-01 00:10:45.000000', 'consum', 0.0251, 'lps'),
	(675948, 134, '2015-02-01 00:10:46.000000', 'consum', 0.0238, 'lps'),
	(675949, 134, '2015-02-01 00:10:47.000000', 'consum', 0.0227, 'lps'),
	(675950, 134, '2015-02-01 00:10:48.000000', 'consum', 0.0211, 'lps'),
	(675951, 134, '2015-02-01 00:10:49.000000', 'consum', 0.0269, 'lps'),
	(675952, 134, '2015-02-01 00:10:50.000000', 'consum', 0.0296, 'lps'),
	(675953, 134, '2015-02-01 00:10:51.000000', 'consum', 0.0256, 'lps'),
	(675954, 134, '2015-02-01 00:10:52.000000', 'consum', 0.0284, 'lps'),
	(675955, 134, '2015-02-01 00:10:53.000000', 'consum', 0.0240, 'lps'),
	(675956, 134, '2015-02-01 00:10:54.000000', 'consum', 0.0240, 'lps'),
	(675957, 134, '2015-02-01 00:10:55.000000', 'consum', 0.0271, 'lps'),
	(675958, 134, '2015-02-01 00:10:56.000000', 'consum', 0.0219, 'lps'),
	(675959, 134, '2015-02-01 00:10:57.000000', 'consum', 0.0280, 'lps'),
	(675960, 134, '2015-02-01 00:10:58.000000', 'consum', 0.0224, 'lps'),
	(675961, 134, '2015-02-01 00:10:59.000000', 'consum', 0.0275, 'lps'),
	(675962, 134, '2015-02-01 00:11:00.000000', 'consum', 0.0290, 'lps'),
	(675963, 134, '2015-02-01 00:11:01.000000', 'consum', 0.0311, 'lps'),
	(675964, 134, '2015-02-01 00:11:02.000000', 'consum', 0.0268, 'lps'),
	(675965, 134, '2015-02-01 00:11:03.000000', 'consum', 0.0302, 'lps'),
	(675966, 134, '2015-02-01 00:11:04.000000', 'consum', 0.0292, 'lps'),
	(675967, 134, '2015-02-01 00:11:05.000000', 'consum', 0.0241, 'lps'),
	(675968, 134, '2015-02-01 00:11:06.000000', 'consum', 0.0224, 'lps'),
	(675969, 134, '2015-02-01 00:11:07.000000', 'consum', 0.0287, 'lps'),
	(675970, 134, '2015-02-01 00:11:08.000000', 'consum', 0.0246, 'lps'),
	(675971, 134, '2015-02-01 00:11:09.000000', 'consum', 0.0264, 'lps'),
	(675972, 134, '2015-02-01 00:11:10.000000', 'consum', 0.0267, 'lps'),
	(675973, 134, '2015-02-01 00:11:11.000000', 'consum', 0.0233, 'lps'),
	(675974, 134, '2015-02-01 00:11:12.000000', 'consum', 0.0256, 'lps'),
	(675975, 134, '2015-02-01 00:11:13.000000', 'consum', 0.0267, 'lps'),
	(675976, 134, '2015-02-01 00:11:14.000000', 'consum', 0.0255, 'lps'),
	(675977, 134, '2015-02-01 00:11:15.000000', 'consum', 0.0264, 'lps'),
	(675978, 134, '2015-02-01 00:11:16.000000', 'consum', 0.0244, 'lps'),
	(675979, 134, '2015-02-01 00:11:17.000000', 'consum', 0.0217, 'lps'),
	(675980, 134, '2015-02-01 00:11:18.000000', 'consum', 0.0249, 'lps'),
	(675981, 134, '2015-02-01 00:11:19.000000', 'consum', 0.0279, 'lps'),
	(675982, 134, '2015-02-01 00:11:20.000000', 'consum', 0.0235, 'lps'),
	(675983, 134, '2015-02-01 00:11:21.000000', 'consum', 0.0230, 'lps'),
	(675984, 134, '2015-02-01 00:11:22.000000', 'consum', 0.0237, 'lps'),
	(675985, 134, '2015-02-01 00:11:23.000000', 'consum', 0.0283, 'lps'),
	(675986, 134, '2015-02-01 00:11:24.000000', 'consum', 0.0290, 'lps'),
	(675987, 134, '2015-02-01 00:11:25.000000', 'consum', 0.0289, 'lps'),
	(675988, 134, '2015-02-01 00:11:26.000000', 'consum', 0.0264, 'lps'),
	(675989, 134, '2015-02-01 00:11:27.000000', 'consum', 0.0242, 'lps'),
	(675990, 134, '2015-02-01 00:11:28.000000', 'consum', 0.0312, 'lps'),
	(675991, 134, '2015-02-01 00:11:29.000000', 'consum', 0.0211, 'lps'),
	(675992, 134, '2015-02-01 00:11:30.000000', 'consum', 0.0220, 'lps'),
	(675993, 134, '2015-02-01 00:11:31.000000', 'consum', 0.0255, 'lps'),
	(675994, 134, '2015-02-01 00:11:32.000000', 'consum', 0.0304, 'lps'),
	(675995, 134, '2015-02-01 00:11:33.000000', 'consum', 0.0238, 'lps'),
	(675996, 134, '2015-02-01 00:11:34.000000', 'consum', 0.0272, 'lps'),
	(675997, 134, '2015-02-01 00:11:35.000000', 'consum', 0.0230, 'lps'),
	(675998, 134, '2015-02-01 00:11:36.000000', 'consum', 0.0229, 'lps'),
	(675999, 134, '2015-02-01 00:11:37.000000', 'consum', 0.0245, 'lps'),
	(676000, 134, '2015-02-01 00:11:38.000000', 'consum', 0.0228, 'lps'),
	(676001, 134, '2015-02-01 00:11:39.000000', 'consum', 0.0295, 'lps'),
	(676002, 134, '2015-02-01 00:11:40.000000', 'consum', 0.0274, 'lps'),
	(676003, 134, '2015-02-01 00:11:41.000000', 'consum', 0.0276, 'lps'),
	(676004, 134, '2015-02-01 00:11:42.000000', 'consum', 0.0247, 'lps'),
	(676005, 134, '2015-02-01 00:11:43.000000', 'consum', 0.0298, 'lps'),
	(676006, 134, '2015-02-01 00:11:44.000000', 'consum', 0.0232, 'lps'),
	(676007, 134, '2015-02-01 00:11:45.000000', 'consum', 0.0263, 'lps'),
	(676008, 134, '2015-02-01 00:11:46.000000', 'consum', 0.0307, 'lps'),
	(676009, 134, '2015-02-01 00:11:47.000000', 'consum', 0.0225, 'lps'),
	(676010, 134, '2015-02-01 00:11:48.000000', 'consum', 0.0306, 'lps'),
	(676011, 134, '2015-02-01 00:11:49.000000', 'consum', 0.0234, 'lps'),
	(676012, 134, '2015-02-01 00:11:50.000000', 'consum', 0.0246, 'lps'),
	(676013, 134, '2015-02-01 00:11:51.000000', 'consum', 0.0216, 'lps'),
	(676014, 134, '2015-02-01 00:11:52.000000', 'consum', 0.0237, 'lps'),
	(676015, 134, '2015-02-01 00:11:53.000000', 'consum', 0.0225, 'lps'),
	(676016, 134, '2015-02-01 00:11:54.000000', 'consum', 0.0306, 'lps'),
	(676017, 134, '2015-02-01 00:11:55.000000', 'consum', 0.0232, 'lps'),
	(676018, 134, '2015-02-01 00:11:56.000000', 'consum', 0.0240, 'lps'),
	(676019, 134, '2015-02-01 00:11:57.000000', 'consum', 0.0295, 'lps'),
	(676020, 134, '2015-02-01 00:11:58.000000', 'consum', 0.0238, 'lps'),
	(676021, 134, '2015-02-01 00:11:59.000000', 'consum', 0.0301, 'lps'),
	(676022, 134, '2015-02-01 00:12:00.000000', 'consum', 0.0272, 'lps'),
	(676023, 134, '2015-02-01 00:12:01.000000', 'consum', 0.0248, 'lps'),
	(676024, 134, '2015-02-01 00:12:02.000000', 'consum', 0.0214, 'lps'),
	(676025, 134, '2015-02-01 00:12:03.000000', 'consum', 0.0218, 'lps'),
	(676026, 134, '2015-02-01 00:12:04.000000', 'consum', 0.0241, 'lps'),
	(676027, 134, '2015-02-01 00:12:05.000000', 'consum', 0.0238, 'lps'),
	(676028, 134, '2015-02-01 00:12:06.000000', 'consum', 0.0258, 'lps'),
	(676029, 134, '2015-02-01 00:12:07.000000', 'consum', 0.0261, 'lps'),
	(676030, 134, '2015-02-01 00:12:08.000000', 'consum', 0.0221, 'lps'),
	(676031, 134, '2015-02-01 00:12:09.000000', 'consum', 0.0217, 'lps'),
	(676032, 134, '2015-02-01 00:12:10.000000', 'consum', 0.0210, 'lps'),
	(676033, 134, '2015-02-01 00:12:11.000000', 'consum', 0.0293, 'lps'),
	(676034, 134, '2015-02-01 00:12:12.000000', 'consum', 0.0212, 'lps'),
	(676035, 134, '2015-02-01 00:12:13.000000', 'consum', 0.0284, 'lps'),
	(676036, 134, '2015-02-01 00:12:14.000000', 'consum', 0.0263, 'lps'),
	(676037, 134, '2015-02-01 00:12:15.000000', 'consum', 0.0253, 'lps'),
	(676038, 134, '2015-02-01 00:12:16.000000', 'consum', 0.0267, 'lps'),
	(676039, 134, '2015-02-01 00:12:17.000000', 'consum', 0.0265, 'lps'),
	(676040, 134, '2015-02-01 00:12:18.000000', 'consum', 0.0211, 'lps'),
	(676041, 134, '2015-02-01 00:12:19.000000', 'consum', 0.0256, 'lps'),
	(676042, 134, '2015-02-01 00:12:20.000000', 'consum', 0.0234, 'lps'),
	(676043, 134, '2015-02-01 00:12:21.000000', 'consum', 0.0292, 'lps'),
	(676044, 134, '2015-02-01 00:12:22.000000', 'consum', 0.0240, 'lps'),
	(676045, 134, '2015-02-01 00:12:23.000000', 'consum', 0.0218, 'lps'),
	(676046, 134, '2015-02-01 00:12:24.000000', 'consum', 0.0264, 'lps'),
	(676047, 134, '2015-02-01 00:12:25.000000', 'consum', 0.0252, 'lps'),
	(676048, 134, '2015-02-01 00:12:26.000000', 'consum', 0.0257, 'lps'),
	(676049, 134, '2015-02-01 00:12:27.000000', 'consum', 0.0218, 'lps'),
	(676050, 134, '2015-02-01 00:12:28.000000', 'consum', 0.0211, 'lps'),
	(676051, 134, '2015-02-01 00:12:29.000000', 'consum', 0.0296, 'lps'),
	(676052, 134, '2015-02-01 00:12:30.000000', 'consum', 0.0226, 'lps'),
	(676053, 134, '2015-02-01 00:12:31.000000', 'consum', 0.0239, 'lps'),
	(676054, 134, '2015-02-01 00:12:32.000000', 'consum', 0.0309, 'lps'),
	(676055, 134, '2015-02-01 00:12:33.000000', 'consum', 0.0306, 'lps'),
	(676056, 134, '2015-02-01 00:12:34.000000', 'consum', 0.0292, 'lps'),
	(676057, 134, '2015-02-01 00:12:35.000000', 'consum', 0.0229, 'lps'),
	(676058, 134, '2015-02-01 00:12:36.000000', 'consum', 0.0266, 'lps'),
	(676059, 134, '2015-02-01 00:12:37.000000', 'consum', 0.0229, 'lps'),
	(676060, 134, '2015-02-01 00:12:38.000000', 'consum', 0.0240, 'lps'),
	(676061, 134, '2015-02-01 00:12:39.000000', 'consum', 0.0302, 'lps'),
	(676062, 134, '2015-02-01 00:12:40.000000', 'consum', 0.0273, 'lps'),
	(676063, 134, '2015-02-01 00:12:41.000000', 'consum', 0.0250, 'lps'),
	(676064, 134, '2015-02-01 00:12:42.000000', 'consum', 0.0219, 'lps'),
	(676065, 134, '2015-02-01 00:12:43.000000', 'consum', 0.0239, 'lps'),
	(676066, 134, '2015-02-01 00:12:44.000000', 'consum', 0.0226, 'lps'),
	(676067, 134, '2015-02-01 00:12:45.000000', 'consum', 0.0305, 'lps'),
	(676068, 134, '2015-02-01 00:12:46.000000', 'consum', 0.0226, 'lps'),
	(676069, 134, '2015-02-01 00:12:47.000000', 'consum', 0.0213, 'lps'),
	(676070, 134, '2015-02-01 00:12:48.000000', 'consum', 0.0282, 'lps'),
	(676071, 134, '2015-02-01 00:12:49.000000', 'consum', 0.0250, 'lps'),
	(676072, 134, '2015-02-01 00:12:50.000000', 'consum', 0.0297, 'lps'),
	(676073, 134, '2015-02-01 00:12:51.000000', 'consum', 0.0216, 'lps'),
	(676074, 134, '2015-02-01 00:12:52.000000', 'consum', 0.0291, 'lps'),
	(676075, 134, '2015-02-01 00:12:53.000000', 'consum', 0.0289, 'lps'),
	(676076, 134, '2015-02-01 00:12:54.000000', 'consum', 0.0258, 'lps'),
	(676077, 134, '2015-02-01 00:12:55.000000', 'consum', 0.0213, 'lps'),
	(676078, 134, '2015-02-01 00:12:56.000000', 'consum', 0.0290, 'lps'),
	(676079, 134, '2015-02-01 00:12:57.000000', 'consum', 0.0290, 'lps'),
	(676080, 134, '2015-02-01 00:12:58.000000', 'consum', 0.0267, 'lps'),
	(676081, 134, '2015-02-01 00:12:59.000000', 'consum', 0.0258, 'lps'),
	(676082, 134, '2015-02-01 00:13:00.000000', 'consum', 0.0279, 'lps'),
	(676083, 134, '2015-02-01 00:13:01.000000', 'consum', 0.0309, 'lps'),
	(676084, 134, '2015-02-01 00:13:02.000000', 'consum', 0.0293, 'lps'),
	(676085, 134, '2015-02-01 00:13:03.000000', 'consum', 0.0225, 'lps'),
	(676086, 134, '2015-02-01 00:13:04.000000', 'consum', 0.0240, 'lps'),
	(676087, 134, '2015-02-01 00:13:05.000000', 'consum', 0.0216, 'lps'),
	(676088, 134, '2015-02-01 00:13:06.000000', 'consum', 0.0253, 'lps'),
	(676089, 134, '2015-02-01 00:13:07.000000', 'consum', 0.0304, 'lps'),
	(676090, 134, '2015-02-01 00:13:08.000000', 'consum', 0.0242, 'lps'),
	(676091, 134, '2015-02-01 00:13:09.000000', 'consum', 0.0294, 'lps'),
	(676092, 134, '2015-02-01 00:13:10.000000', 'consum', 0.0225, 'lps'),
	(676093, 134, '2015-02-01 00:13:11.000000', 'consum', 0.0239, 'lps'),
	(676094, 134, '2015-02-01 00:13:12.000000', 'consum', 0.0312, 'lps'),
	(676095, 134, '2015-02-01 00:13:13.000000', 'consum', 0.0220, 'lps'),
	(676096, 134, '2015-02-01 00:13:14.000000', 'consum', 0.0264, 'lps'),
	(676097, 134, '2015-02-01 00:13:15.000000', 'consum', 0.0244, 'lps'),
	(676098, 134, '2015-02-01 00:13:16.000000', 'consum', 0.0220, 'lps'),
	(676099, 134, '2015-02-01 00:13:17.000000', 'consum', 0.0259, 'lps'),
	(676100, 134, '2015-02-01 00:13:18.000000', 'consum', 0.0222, 'lps'),
	(676101, 134, '2015-02-01 00:13:19.000000', 'consum', 0.0224, 'lps'),
	(676102, 134, '2015-02-01 00:13:20.000000', 'consum', 0.0246, 'lps'),
	(676103, 134, '2015-02-01 00:13:21.000000', 'consum', 0.0247, 'lps'),
	(676104, 134, '2015-02-01 00:13:22.000000', 'consum', 0.0287, 'lps'),
	(676105, 134, '2015-02-01 00:13:23.000000', 'consum', 0.0277, 'lps'),
	(676106, 134, '2015-02-01 00:13:24.000000', 'consum', 0.0212, 'lps'),
	(676107, 134, '2015-02-01 00:13:25.000000', 'consum', 0.0224, 'lps'),
	(676108, 134, '2015-02-01 00:13:26.000000', 'consum', 0.0274, 'lps'),
	(676109, 134, '2015-02-01 00:13:27.000000', 'consum', 0.0284, 'lps'),
	(676110, 134, '2015-02-01 00:13:28.000000', 'consum', 0.0285, 'lps'),
	(676111, 134, '2015-02-01 00:13:29.000000', 'consum', 0.0260, 'lps'),
	(676112, 134, '2015-02-01 00:13:30.000000', 'consum', 0.0234, 'lps'),
	(676113, 134, '2015-02-01 00:13:31.000000', 'consum', 0.0285, 'lps'),
	(676114, 134, '2015-02-01 00:13:32.000000', 'consum', 0.0307, 'lps'),
	(676115, 134, '2015-02-01 00:13:33.000000', 'consum', 0.0264, 'lps'),
	(676116, 134, '2015-02-01 00:13:34.000000', 'consum', 0.0292, 'lps'),
	(676117, 134, '2015-02-01 00:13:35.000000', 'consum', 0.0255, 'lps'),
	(676118, 134, '2015-02-01 00:13:36.000000', 'consum', 0.0290, 'lps'),
	(676119, 134, '2015-02-01 00:13:37.000000', 'consum', 0.0269, 'lps'),
	(676120, 134, '2015-02-01 00:13:38.000000', 'consum', 0.0267, 'lps'),
	(676121, 134, '2015-02-01 00:13:39.000000', 'consum', 0.0217, 'lps'),
	(676122, 134, '2015-02-01 00:13:40.000000', 'consum', 0.0277, 'lps'),
	(676123, 134, '2015-02-01 00:13:41.000000', 'consum', 0.0218, 'lps'),
	(676124, 134, '2015-02-01 00:13:42.000000', 'consum', 0.0255, 'lps'),
	(676125, 134, '2015-02-01 00:13:43.000000', 'consum', 0.0308, 'lps'),
	(676126, 134, '2015-02-01 00:13:44.000000', 'consum', 0.0257, 'lps'),
	(676127, 134, '2015-02-01 00:13:45.000000', 'consum', 0.0255, 'lps'),
	(676128, 134, '2015-02-01 00:13:46.000000', 'consum', 0.0293, 'lps'),
	(676129, 134, '2015-02-01 00:13:47.000000', 'consum', 0.0285, 'lps'),
	(676130, 134, '2015-02-01 00:13:48.000000', 'consum', 0.0234, 'lps'),
	(676131, 134, '2015-02-01 00:13:49.000000', 'consum', 0.0311, 'lps'),
	(676132, 134, '2015-02-01 00:13:50.000000', 'consum', 0.0231, 'lps'),
	(676133, 134, '2015-02-01 00:13:51.000000', 'consum', 0.0220, 'lps'),
	(676134, 134, '2015-02-01 00:13:52.000000', 'consum', 0.0298, 'lps'),
	(676135, 134, '2015-02-01 00:13:53.000000', 'consum', 0.0211, 'lps'),
	(676136, 134, '2015-02-01 00:13:54.000000', 'consum', 0.0261, 'lps'),
	(676137, 134, '2015-02-01 00:13:55.000000', 'consum', 0.0256, 'lps'),
	(676138, 134, '2015-02-01 00:13:56.000000', 'consum', 0.0287, 'lps'),
	(676139, 134, '2015-02-01 00:13:57.000000', 'consum', 0.0251, 'lps'),
	(676140, 134, '2015-02-01 00:13:58.000000', 'consum', 0.0288, 'lps'),
	(676141, 134, '2015-02-01 00:13:59.000000', 'consum', 0.0270, 'lps'),
	(676142, 134, '2015-02-01 00:14:00.000000', 'consum', 0.0278, 'lps'),
	(676143, 134, '2015-02-01 00:14:01.000000', 'consum', 0.0266, 'lps'),
	(676144, 134, '2015-02-01 00:14:02.000000', 'consum', 0.0288, 'lps'),
	(676145, 134, '2015-02-01 00:14:03.000000', 'consum', 0.0225, 'lps'),
	(676146, 134, '2015-02-01 00:14:04.000000', 'consum', 0.0257, 'lps'),
	(676147, 134, '2015-02-01 00:14:05.000000', 'consum', 0.0297, 'lps'),
	(676148, 134, '2015-02-01 00:14:06.000000', 'consum', 0.0301, 'lps'),
	(676149, 134, '2015-02-01 00:14:07.000000', 'consum', 0.0299, 'lps'),
	(676150, 134, '2015-02-01 00:14:08.000000', 'consum', 0.0280, 'lps'),
	(676151, 134, '2015-02-01 00:14:09.000000', 'consum', 0.0293, 'lps'),
	(676152, 134, '2015-02-01 00:14:10.000000', 'consum', 0.0211, 'lps'),
	(676153, 134, '2015-02-01 00:14:11.000000', 'consum', 0.0274, 'lps'),
	(676154, 134, '2015-02-01 00:14:12.000000', 'consum', 0.0221, 'lps'),
	(676155, 134, '2015-02-01 00:14:13.000000', 'consum', 0.0277, 'lps'),
	(676156, 134, '2015-02-01 00:14:14.000000', 'consum', 0.0305, 'lps'),
	(676157, 134, '2015-02-01 00:14:15.000000', 'consum', 0.0281, 'lps'),
	(676158, 134, '2015-02-01 00:14:16.000000', 'consum', 0.0281, 'lps'),
	(676159, 134, '2015-02-01 00:14:17.000000', 'consum', 0.0251, 'lps'),
	(676160, 134, '2015-02-01 00:14:18.000000', 'consum', 0.0303, 'lps'),
	(676161, 134, '2015-02-01 00:14:19.000000', 'consum', 0.0244, 'lps'),
	(676162, 134, '2015-02-01 00:14:20.000000', 'consum', 0.0308, 'lps'),
	(676163, 134, '2015-02-01 00:14:21.000000', 'consum', 0.0288, 'lps'),
	(676164, 134, '2015-02-01 00:14:22.000000', 'consum', 0.0308, 'lps'),
	(676165, 134, '2015-02-01 00:14:23.000000', 'consum', 0.0258, 'lps'),
	(676166, 134, '2015-02-01 00:14:24.000000', 'consum', 0.0261, 'lps'),
	(676167, 134, '2015-02-01 00:14:25.000000', 'consum', 0.0218, 'lps'),
	(676168, 134, '2015-02-01 00:14:26.000000', 'consum', 0.0302, 'lps'),
	(676169, 134, '2015-02-01 00:14:27.000000', 'consum', 0.0235, 'lps'),
	(676170, 134, '2015-02-01 00:14:28.000000', 'consum', 0.0264, 'lps'),
	(676171, 134, '2015-02-01 00:14:29.000000', 'consum', 0.0305, 'lps'),
	(676172, 134, '2015-02-01 00:14:30.000000', 'consum', 0.0214, 'lps'),
	(676173, 134, '2015-02-01 00:14:31.000000', 'consum', 0.0252, 'lps'),
	(676174, 134, '2015-02-01 00:14:32.000000', 'consum', 0.0308, 'lps'),
	(676175, 134, '2015-02-01 00:14:33.000000', 'consum', 0.0265, 'lps'),
	(676176, 134, '2015-02-01 00:14:34.000000', 'consum', 0.0294, 'lps'),
	(676177, 134, '2015-02-01 00:14:35.000000', 'consum', 0.0261, 'lps'),
	(676178, 134, '2015-02-01 00:14:36.000000', 'consum', 0.0214, 'lps'),
	(676179, 134, '2015-02-01 00:14:37.000000', 'consum', 0.0284, 'lps'),
	(676180, 134, '2015-02-01 00:14:38.000000', 'consum', 0.0258, 'lps'),
	(676181, 134, '2015-02-01 00:14:39.000000', 'consum', 0.0228, 'lps'),
	(676182, 134, '2015-02-01 00:14:40.000000', 'consum', 0.0261, 'lps'),
	(676183, 134, '2015-02-01 00:14:41.000000', 'consum', 0.0307, 'lps'),
	(676184, 134, '2015-02-01 00:14:42.000000', 'consum', 0.0235, 'lps'),
	(676185, 134, '2015-02-01 00:14:43.000000', 'consum', 0.0248, 'lps'),
	(676186, 134, '2015-02-01 00:14:44.000000', 'consum', 0.0224, 'lps'),
	(676187, 134, '2015-02-01 00:14:45.000000', 'consum', 0.0268, 'lps'),
	(676188, 134, '2015-02-01 00:14:46.000000', 'consum', 0.0253, 'lps'),
	(676189, 134, '2015-02-01 00:14:47.000000', 'consum', 0.0251, 'lps'),
	(676190, 134, '2015-02-01 00:14:48.000000', 'consum', 0.0288, 'lps'),
	(676191, 134, '2015-02-01 00:14:49.000000', 'consum', 0.0272, 'lps'),
	(676192, 134, '2015-02-01 00:14:50.000000', 'consum', 0.0287, 'lps'),
	(676193, 134, '2015-02-01 00:14:51.000000', 'consum', 0.0306, 'lps'),
	(676194, 134, '2015-02-01 00:14:52.000000', 'consum', 0.0254, 'lps'),
	(676195, 134, '2015-02-01 00:14:53.000000', 'consum', 0.0245, 'lps'),
	(676196, 134, '2015-02-01 00:14:54.000000', 'consum', 0.0253, 'lps'),
	(676197, 134, '2015-02-01 00:14:55.000000', 'consum', 0.0217, 'lps'),
	(676198, 134, '2015-02-01 00:14:56.000000', 'consum', 0.0221, 'lps'),
	(676199, 134, '2015-02-01 00:14:57.000000', 'consum', 0.0245, 'lps'),
	(676200, 134, '2015-02-01 00:14:58.000000', 'consum', 0.0249, 'lps'),
	(676201, 134, '2015-02-01 00:14:59.000000', 'consum', 0.0300, 'lps'),
	(676202, 134, '2015-02-01 00:15:00.000000', 'consum', 0.0233, 'lps'),
	(676203, 134, '2015-02-01 00:15:01.000000', 'consum', 0.0264, 'lps'),
	(676204, 134, '2015-02-01 00:15:02.000000', 'consum', 0.0307, 'lps'),
	(676205, 134, '2015-02-01 00:15:03.000000', 'consum', 0.0225, 'lps'),
	(676206, 134, '2015-02-01 00:15:04.000000', 'consum', 0.0304, 'lps'),
	(676207, 134, '2015-02-01 00:15:05.000000', 'consum', 0.0224, 'lps'),
	(676208, 134, '2015-02-01 00:15:06.000000', 'consum', 0.0307, 'lps'),
	(676209, 134, '2015-02-01 00:15:07.000000', 'consum', 0.0240, 'lps'),
	(676210, 134, '2015-02-01 00:15:08.000000', 'consum', 0.0275, 'lps'),
	(676211, 134, '2015-02-01 00:15:09.000000', 'consum', 0.0241, 'lps'),
	(676212, 134, '2015-02-01 00:15:10.000000', 'consum', 0.0275, 'lps'),
	(676213, 134, '2015-02-01 00:15:11.000000', 'consum', 0.0233, 'lps'),
	(676214, 134, '2015-02-01 00:15:12.000000', 'consum', 0.0236, 'lps'),
	(676215, 134, '2015-02-01 00:15:13.000000', 'consum', 0.0270, 'lps'),
	(676216, 134, '2015-02-01 00:15:14.000000', 'consum', 0.0226, 'lps'),
	(676217, 134, '2015-02-01 00:15:15.000000', 'consum', 0.0213, 'lps'),
	(676218, 134, '2015-02-01 00:15:16.000000', 'consum', 0.0283, 'lps'),
	(676219, 134, '2015-02-01 00:15:17.000000', 'consum', 0.0255, 'lps'),
	(676220, 134, '2015-02-01 00:15:18.000000', 'consum', 0.0218, 'lps'),
	(676221, 134, '2015-02-01 00:15:19.000000', 'consum', 0.0218, 'lps'),
	(676222, 134, '2015-02-01 00:15:20.000000', 'consum', 0.0227, 'lps'),
	(676223, 134, '2015-02-01 00:15:21.000000', 'consum', 0.0271, 'lps'),
	(676224, 134, '2015-02-01 00:15:22.000000', 'consum', 0.0259, 'lps'),
	(676225, 134, '2015-02-01 00:15:23.000000', 'consum', 0.0273, 'lps'),
	(676226, 134, '2015-02-01 00:15:24.000000', 'consum', 0.0276, 'lps'),
	(676227, 134, '2015-02-01 00:15:25.000000', 'consum', 0.0246, 'lps'),
	(676228, 134, '2015-02-01 00:15:26.000000', 'consum', 0.0295, 'lps'),
	(676229, 134, '2015-02-01 00:15:27.000000', 'consum', 0.0221, 'lps'),
	(676230, 134, '2015-02-01 00:15:28.000000', 'consum', 0.0217, 'lps'),
	(676231, 134, '2015-02-01 00:15:29.000000', 'consum', 0.0212, 'lps'),
	(676232, 134, '2015-02-01 00:15:30.000000', 'consum', 0.0301, 'lps'),
	(676233, 134, '2015-02-01 00:15:31.000000', 'consum', 0.0248, 'lps'),
	(676234, 134, '2015-02-01 00:15:32.000000', 'consum', 0.0230, 'lps'),
	(676235, 134, '2015-02-01 00:15:33.000000', 'consum', 0.0302, 'lps'),
	(676236, 134, '2015-02-01 00:15:34.000000', 'consum', 0.0300, 'lps'),
	(676237, 134, '2015-02-01 00:15:35.000000', 'consum', 0.0281, 'lps'),
	(676238, 134, '2015-02-01 00:15:36.000000', 'consum', 0.0296, 'lps'),
	(676239, 134, '2015-02-01 00:15:37.000000', 'consum', 0.0222, 'lps'),
	(676240, 134, '2015-02-01 00:15:38.000000', 'consum', 0.0217, 'lps'),
	(676241, 134, '2015-02-01 00:15:39.000000', 'consum', 0.0212, 'lps'),
	(676242, 134, '2015-02-01 00:15:40.000000', 'consum', 0.0301, 'lps'),
	(676243, 134, '2015-02-01 00:15:41.000000', 'consum', 0.0247, 'lps'),
	(676244, 134, '2015-02-01 00:15:42.000000', 'consum', 0.0228, 'lps'),
	(676245, 134, '2015-02-01 00:15:43.000000', 'consum', 0.0290, 'lps'),
	(676246, 134, '2015-02-01 00:15:44.000000', 'consum', 0.0248, 'lps'),
	(676247, 134, '2015-02-01 00:15:45.000000', 'consum', 0.0264, 'lps'),
	(676248, 134, '2015-02-01 00:15:46.000000', 'consum', 0.0263, 'lps'),
	(676249, 134, '2015-02-01 00:15:47.000000', 'consum', 0.0212, 'lps'),
	(676250, 134, '2015-02-01 00:15:48.000000', 'consum', 0.0267, 'lps'),
	(676251, 134, '2015-02-01 00:15:49.000000', 'consum', 0.0283, 'lps'),
	(676252, 134, '2015-02-01 00:15:50.000000', 'consum', 0.0301, 'lps'),
	(676253, 134, '2015-02-01 00:15:51.000000', 'consum', 0.0239, 'lps'),
	(676254, 134, '2015-02-01 00:15:52.000000', 'consum', 0.0291, 'lps'),
	(676255, 134, '2015-02-01 00:15:53.000000', 'consum', 0.0221, 'lps'),
	(676256, 134, '2015-02-01 00:15:54.000000', 'consum', 0.0226, 'lps'),
	(676257, 134, '2015-02-01 00:15:55.000000', 'consum', 0.0258, 'lps'),
	(676258, 134, '2015-02-01 00:15:56.000000', 'consum', 0.0299, 'lps'),
	(676259, 134, '2015-02-01 00:15:57.000000', 'consum', 0.0306, 'lps'),
	(676260, 134, '2015-02-01 00:15:58.000000', 'consum', 0.0219, 'lps'),
	(676261, 134, '2015-02-01 00:15:59.000000', 'consum', 0.0275, 'lps'),
	(676262, 134, '2015-02-01 00:16:00.000000', 'consum', 0.0303, 'lps'),
	(676263, 134, '2015-02-01 00:16:01.000000', 'consum', 0.0275, 'lps'),
	(676264, 134, '2015-02-01 00:16:02.000000', 'consum', 0.0257, 'lps'),
	(676265, 134, '2015-02-01 00:16:03.000000', 'consum', 0.0250, 'lps'),
	(676266, 134, '2015-02-01 00:16:04.000000', 'consum', 0.0271, 'lps'),
	(676267, 134, '2015-02-01 00:16:05.000000', 'consum', 0.0293, 'lps'),
	(676268, 134, '2015-02-01 00:16:06.000000', 'consum', 0.0234, 'lps'),
	(676269, 134, '2015-02-01 00:16:07.000000', 'consum', 0.0288, 'lps'),
	(676270, 134, '2015-02-01 00:16:08.000000', 'consum', 0.0220, 'lps'),
	(676271, 134, '2015-02-01 00:16:09.000000', 'consum', 0.0232, 'lps'),
	(676272, 134, '2015-02-01 00:16:10.000000', 'consum', 0.0289, 'lps'),
	(676273, 134, '2015-02-01 00:16:11.000000', 'consum', 0.0231, 'lps'),
	(676274, 134, '2015-02-01 00:16:12.000000', 'consum', 0.0286, 'lps'),
	(676275, 134, '2015-02-01 00:16:13.000000', 'consum', 0.0216, 'lps'),
	(676276, 134, '2015-02-01 00:16:14.000000', 'consum', 0.0220, 'lps'),
	(676277, 134, '2015-02-01 00:16:15.000000', 'consum', 0.0244, 'lps'),
	(676278, 134, '2015-02-01 00:16:16.000000', 'consum', 0.0248, 'lps'),
	(676279, 134, '2015-02-01 00:16:17.000000', 'consum', 0.0296, 'lps'),
	(676280, 134, '2015-02-01 00:16:18.000000', 'consum', 0.0219, 'lps'),
	(676281, 134, '2015-02-01 00:16:19.000000', 'consum', 0.0307, 'lps'),
	(676282, 134, '2015-02-01 00:16:20.000000', 'consum', 0.0257, 'lps'),
	(676283, 134, '2015-02-01 00:16:21.000000', 'consum', 0.0256, 'lps'),
	(676284, 134, '2015-02-01 00:16:22.000000', 'consum', 0.0299, 'lps'),
	(676285, 134, '2015-02-01 00:16:23.000000', 'consum', 0.0211, 'lps'),
	(676286, 134, '2015-02-01 00:16:24.000000', 'consum', 0.0257, 'lps'),
	(676287, 134, '2015-02-01 00:16:25.000000', 'consum', 0.0235, 'lps'),
	(676288, 134, '2015-02-01 00:16:26.000000', 'consum', 0.0299, 'lps'),
	(676289, 134, '2015-02-01 00:16:27.000000', 'consum', 0.0272, 'lps'),
	(676290, 134, '2015-02-01 00:16:28.000000', 'consum', 0.0252, 'lps'),
	(676291, 134, '2015-02-01 00:16:29.000000', 'consum', 0.0237, 'lps'),
	(676292, 134, '2015-02-01 00:16:30.000000', 'consum', 0.0217, 'lps'),
	(676293, 134, '2015-02-01 00:16:31.000000', 'consum', 0.0268, 'lps'),
	(676294, 134, '2015-02-01 00:16:32.000000', 'consum', 0.0274, 'lps'),
	(676295, 134, '2015-02-01 00:16:33.000000', 'consum', 0.0252, 'lps'),
	(676296, 134, '2015-02-01 00:16:34.000000', 'consum', 0.0229, 'lps'),
	(676297, 134, '2015-02-01 00:16:35.000000', 'consum', 0.0284, 'lps'),
	(676298, 134, '2015-02-01 00:16:36.000000', 'consum', 0.0213, 'lps'),
	(676299, 134, '2015-02-01 00:16:37.000000', 'consum', 0.0210, 'lps'),
	(676300, 134, '2015-02-01 00:16:38.000000', 'consum', 0.0306, 'lps'),
	(676301, 134, '2015-02-01 00:16:39.000000', 'consum', 0.0279, 'lps'),
	(676302, 134, '2015-02-01 00:16:40.000000', 'consum', 0.0267, 'lps'),
	(676303, 134, '2015-02-01 00:16:41.000000', 'consum', 0.0286, 'lps'),
	(676304, 134, '2015-02-01 00:16:42.000000', 'consum', 0.0216, 'lps'),
	(676305, 134, '2015-02-01 00:16:43.000000', 'consum', 0.0217, 'lps'),
	(676306, 134, '2015-02-01 00:16:44.000000', 'consum', 0.0229, 'lps'),
	(676307, 134, '2015-02-01 00:16:45.000000', 'consum', 0.0284, 'lps'),
	(676308, 134, '2015-02-01 00:16:46.000000', 'consum', 0.0216, 'lps'),
	(676309, 134, '2015-02-01 00:16:47.000000', 'consum', 0.0222, 'lps'),
	(676310, 134, '2015-02-01 00:16:48.000000', 'consum', 0.0255, 'lps'),
	(676311, 134, '2015-02-01 00:16:49.000000', 'consum', 0.0297, 'lps'),
	(676312, 134, '2015-02-01 00:16:50.000000', 'consum', 0.0305, 'lps'),
	(676313, 134, '2015-02-01 00:16:51.000000', 'consum', 0.0216, 'lps'),
	(676314, 134, '2015-02-01 00:16:52.000000', 'consum', 0.0265, 'lps'),
	(676315, 134, '2015-02-01 00:16:53.000000', 'consum', 0.0263, 'lps'),
	(676316, 134, '2015-02-01 00:16:54.000000', 'consum', 0.0311, 'lps'),
	(676317, 134, '2015-02-01 00:16:55.000000', 'consum', 0.0247, 'lps'),
	(676318, 134, '2015-02-01 00:16:56.000000', 'consum', 0.0300, 'lps'),
	(676319, 134, '2015-02-01 00:16:57.000000', 'consum', 0.0239, 'lps'),
	(676320, 134, '2015-02-01 00:16:58.000000', 'consum', 0.0291, 'lps'),
	(676321, 134, '2015-02-01 00:16:59.000000', 'consum', 0.0222, 'lps'),
	(676322, 134, '2015-02-01 00:17:00.000000', 'consum', 0.0232, 'lps'),
	(676323, 134, '2015-02-01 00:17:01.000000', 'consum', 0.0284, 'lps'),
	(676324, 134, '2015-02-01 00:17:02.000000', 'consum', 0.0309, 'lps'),
	(676325, 134, '2015-02-01 00:17:03.000000', 'consum', 0.0275, 'lps'),
	(676326, 134, '2015-02-01 00:17:04.000000', 'consum', 0.0242, 'lps'),
	(676327, 134, '2015-02-01 00:17:05.000000', 'consum', 0.0276, 'lps'),
	(676328, 134, '2015-02-01 00:17:06.000000', 'consum', 0.0240, 'lps'),
	(676329, 134, '2015-02-01 00:17:07.000000', 'consum', 0.0265, 'lps'),
	(676330, 134, '2015-02-01 00:17:08.000000', 'consum', 0.0294, 'lps'),
	(676331, 134, '2015-02-01 00:17:09.000000', 'consum', 0.0257, 'lps'),
	(676332, 134, '2015-02-01 00:17:10.000000', 'consum', 0.0298, 'lps'),
	(676333, 134, '2015-02-01 00:17:11.000000', 'consum', 0.0303, 'lps'),
	(676334, 134, '2015-02-01 00:17:12.000000', 'consum', 0.0308, 'lps'),
	(676335, 134, '2015-02-01 00:17:13.000000', 'consum', 0.0215, 'lps'),
	(676336, 134, '2015-02-01 00:17:14.000000', 'consum', 0.0252, 'lps'),
	(676337, 134, '2015-02-01 00:17:15.000000', 'consum', 0.0300, 'lps'),
	(676338, 134, '2015-02-01 00:17:16.000000', 'consum', 0.0226, 'lps'),
	(676339, 134, '2015-02-01 00:17:17.000000', 'consum', 0.0228, 'lps'),
	(676340, 134, '2015-02-01 00:17:18.000000', 'consum', 0.0253, 'lps'),
	(676341, 134, '2015-02-01 00:17:19.000000', 'consum', 0.0269, 'lps'),
	(676342, 134, '2015-02-01 00:17:20.000000', 'consum', 0.0274, 'lps'),
	(676343, 134, '2015-02-01 00:17:21.000000', 'consum', 0.0250, 'lps'),
	(676344, 134, '2015-02-01 00:17:22.000000', 'consum', 0.0219, 'lps'),
	(676345, 134, '2015-02-01 00:17:23.000000', 'consum', 0.0236, 'lps'),
	(676346, 134, '2015-02-01 00:17:24.000000', 'consum', 0.0211, 'lps'),
	(676347, 134, '2015-02-01 00:17:25.000000', 'consum', 0.0242, 'lps'),
	(676348, 134, '2015-02-01 00:17:26.000000', 'consum', 0.0264, 'lps'),
	(676349, 134, '2015-02-01 00:17:27.000000', 'consum', 0.0281, 'lps'),
	(676350, 134, '2015-02-01 00:17:28.000000', 'consum', 0.0301, 'lps'),
	(676351, 134, '2015-02-01 00:17:29.000000', 'consum', 0.0247, 'lps'),
	(676352, 134, '2015-02-01 00:17:30.000000', 'consum', 0.0224, 'lps'),
	(676353, 134, '2015-02-01 00:17:31.000000', 'consum', 0.0273, 'lps'),
	(676354, 134, '2015-02-01 00:17:32.000000', 'consum', 0.0279, 'lps'),
	(676355, 134, '2015-02-01 00:17:33.000000', 'consum', 0.0261, 'lps'),
	(676356, 134, '2015-02-01 00:17:34.000000', 'consum', 0.0261, 'lps'),
	(676357, 134, '2015-02-01 00:17:35.000000', 'consum', 0.0311, 'lps'),
	(676358, 134, '2015-02-01 00:17:36.000000', 'consum', 0.0254, 'lps'),
	(676359, 134, '2015-02-01 00:17:37.000000', 'consum', 0.0230, 'lps'),
	(676360, 134, '2015-02-01 00:17:38.000000', 'consum', 0.0284, 'lps'),
	(676361, 134, '2015-02-01 00:17:39.000000', 'consum', 0.0210, 'lps'),
	(676362, 134, '2015-02-01 00:17:40.000000', 'consum', 0.0295, 'lps'),
	(676363, 134, '2015-02-01 00:17:41.000000', 'consum', 0.0227, 'lps'),
	(676364, 134, '2015-02-01 00:17:42.000000', 'consum', 0.0245, 'lps'),
	(676365, 134, '2015-02-01 00:17:43.000000', 'consum', 0.0231, 'lps'),
	(676366, 134, '2015-02-01 00:17:44.000000', 'consum', 0.0211, 'lps'),
	(676367, 134, '2015-02-01 00:17:45.000000', 'consum', 0.0257, 'lps'),
	(676368, 134, '2015-02-01 00:17:46.000000', 'consum', 0.0237, 'lps'),
	(676369, 134, '2015-02-01 00:17:47.000000', 'consum', 0.0306, 'lps'),
	(676370, 134, '2015-02-01 00:17:48.000000', 'consum', 0.0303, 'lps'),
	(676371, 134, '2015-02-01 00:17:49.000000', 'consum', 0.0283, 'lps'),
	(676372, 134, '2015-02-01 00:17:50.000000', 'consum', 0.0294, 'lps'),
	(676373, 134, '2015-02-01 00:17:51.000000', 'consum', 0.0312, 'lps'),
	(676374, 134, '2015-02-01 00:17:52.000000', 'consum', 0.0261, 'lps'),
	(676375, 134, '2015-02-01 00:17:53.000000', 'consum', 0.0263, 'lps'),
	(676376, 134, '2015-02-01 00:17:54.000000', 'consum', 0.0219, 'lps'),
	(676377, 134, '2015-02-01 00:17:55.000000', 'consum', 0.0304, 'lps'),
	(676378, 134, '2015-02-01 00:17:56.000000', 'consum', 0.0243, 'lps'),
	(676379, 134, '2015-02-01 00:17:57.000000', 'consum', 0.0297, 'lps'),
	(676380, 134, '2015-02-01 00:17:58.000000', 'consum', 0.0236, 'lps'),
	(676381, 134, '2015-02-01 00:17:59.000000', 'consum', 0.0289, 'lps'),
	(676382, 134, '2015-02-01 00:18:00.000000', 'consum', 0.0215, 'lps'),
	(676383, 134, '2015-02-01 00:18:01.000000', 'consum', 0.0310, 'lps'),
	(676384, 134, '2015-02-01 00:18:02.000000', 'consum', 0.0284, 'lps'),
	(676385, 134, '2015-02-01 00:18:03.000000', 'consum', 0.0279, 'lps'),
	(676386, 134, '2015-02-01 00:18:04.000000', 'consum', 0.0230, 'lps'),
	(676387, 134, '2015-02-01 00:18:05.000000', 'consum', 0.0310, 'lps'),
	(676388, 134, '2015-02-01 00:18:06.000000', 'consum', 0.0237, 'lps'),
	(676389, 134, '2015-02-01 00:18:07.000000', 'consum', 0.0250, 'lps'),
	(676390, 134, '2015-02-01 00:18:08.000000', 'consum', 0.0230, 'lps'),
	(676391, 134, '2015-02-01 00:18:09.000000', 'consum', 0.0294, 'lps'),
	(676392, 134, '2015-02-01 00:18:10.000000', 'consum', 0.0262, 'lps'),
	(676393, 134, '2015-02-01 00:18:11.000000', 'consum', 0.0216, 'lps'),
	(676394, 134, '2015-02-01 00:18:12.000000', 'consum', 0.0293, 'lps'),
	(676395, 134, '2015-02-01 00:18:13.000000', 'consum', 0.0296, 'lps'),
	(676396, 134, '2015-02-01 00:18:14.000000', 'consum', 0.0291, 'lps'),
	(676397, 134, '2015-02-01 00:18:15.000000', 'consum', 0.0253, 'lps'),
	(676398, 134, '2015-02-01 00:18:16.000000', 'consum', 0.0284, 'lps'),
	(676399, 134, '2015-02-01 00:18:17.000000', 'consum', 0.0246, 'lps'),
	(676400, 134, '2015-02-01 00:18:18.000000', 'consum', 0.0272, 'lps'),
	(676401, 134, '2015-02-01 00:18:19.000000', 'consum', 0.0308, 'lps'),
	(676402, 134, '2015-02-01 00:18:20.000000', 'consum', 0.0311, 'lps'),
	(676403, 134, '2015-02-01 00:18:21.000000', 'consum', 0.0215, 'lps'),
	(676404, 134, '2015-02-01 00:18:22.000000', 'consum', 0.0243, 'lps'),
	(676405, 134, '2015-02-01 00:18:23.000000', 'consum', 0.0255, 'lps'),
	(676406, 134, '2015-02-01 00:18:24.000000', 'consum', 0.0236, 'lps'),
	(676407, 134, '2015-02-01 00:18:25.000000', 'consum', 0.0306, 'lps'),
	(676408, 134, '2015-02-01 00:18:26.000000', 'consum', 0.0305, 'lps'),
	(676409, 134, '2015-02-01 00:18:27.000000', 'consum', 0.0293, 'lps'),
	(676410, 134, '2015-02-01 00:18:28.000000', 'consum', 0.0237, 'lps'),
	(676411, 134, '2015-02-01 00:18:29.000000', 'consum', 0.0304, 'lps'),
	(676412, 134, '2015-02-01 00:18:30.000000', 'consum', 0.0292, 'lps'),
	(676413, 134, '2015-02-01 00:18:31.000000', 'consum', 0.0234, 'lps'),
	(676414, 134, '2015-02-01 00:18:32.000000', 'consum', 0.0289, 'lps'),
	(676415, 134, '2015-02-01 00:18:33.000000', 'consum', 0.0226, 'lps'),
	(676416, 134, '2015-02-01 00:18:34.000000', 'consum', 0.0261, 'lps'),
	(676417, 134, '2015-02-01 00:18:35.000000', 'consum', 0.0212, 'lps'),
	(676418, 134, '2015-02-01 00:18:36.000000', 'consum', 0.0271, 'lps'),
	(676419, 134, '2015-02-01 00:18:37.000000', 'consum', 0.0305, 'lps'),
	(676420, 134, '2015-02-01 00:18:38.000000', 'consum', 0.0294, 'lps'),
	(676421, 134, '2015-02-01 00:18:39.000000', 'consum', 0.0245, 'lps'),
	(676422, 134, '2015-02-01 00:18:40.000000', 'consum', 0.0238, 'lps'),
	(676423, 134, '2015-02-01 00:18:41.000000', 'consum', 0.0243, 'lps'),
	(676424, 134, '2015-02-01 00:18:42.000000', 'consum', 0.0293, 'lps'),
	(676425, 134, '2015-02-01 00:18:43.000000', 'consum', 0.0219, 'lps'),
	(676426, 134, '2015-02-01 00:18:44.000000', 'consum', 0.0312, 'lps'),
	(676427, 134, '2015-02-01 00:18:45.000000', 'consum', 0.0284, 'lps'),
	(676428, 134, '2015-02-01 00:18:46.000000', 'consum', 0.0272, 'lps'),
	(676429, 134, '2015-02-01 00:18:47.000000', 'consum', 0.0301, 'lps'),
	(676430, 134, '2015-02-01 00:18:48.000000', 'consum', 0.0274, 'lps'),
	(676431, 134, '2015-02-01 00:18:49.000000', 'consum', 0.0255, 'lps'),
	(676432, 134, '2015-02-01 00:18:50.000000', 'consum', 0.0244, 'lps'),
	(676433, 134, '2015-02-01 00:18:51.000000', 'consum', 0.0245, 'lps'),
	(676434, 134, '2015-02-01 00:18:52.000000', 'consum', 0.0283, 'lps'),
	(676435, 134, '2015-02-01 00:18:53.000000', 'consum', 0.0265, 'lps'),
	(676436, 134, '2015-02-01 00:18:54.000000', 'consum', 0.0267, 'lps'),
	(676437, 134, '2015-02-01 00:18:55.000000', 'consum', 0.0228, 'lps'),
	(676438, 134, '2015-02-01 00:18:56.000000', 'consum', 0.0233, 'lps'),
	(676439, 134, '2015-02-01 00:18:57.000000', 'consum', 0.0272, 'lps'),
	(676440, 134, '2015-02-01 00:18:58.000000', 'consum', 0.0243, 'lps'),
	(676441, 134, '2015-02-01 00:18:59.000000', 'consum', 0.0292, 'lps'),
	(676442, 134, '2015-02-01 00:19:00.000000', 'consum', 0.0214, 'lps'),
	(676443, 134, '2015-02-01 00:19:01.000000', 'consum', 0.0291, 'lps'),
	(676444, 134, '2015-02-01 00:19:02.000000', 'consum', 0.0297, 'lps'),
	(676445, 134, '2015-02-01 00:19:03.000000', 'consum', 0.0299, 'lps'),
	(676446, 134, '2015-02-01 00:19:04.000000', 'consum', 0.0291, 'lps'),
	(676447, 134, '2015-02-01 00:19:05.000000', 'consum', 0.0244, 'lps'),
	(676448, 134, '2015-02-01 00:19:06.000000', 'consum', 0.0243, 'lps'),
	(676449, 134, '2015-02-01 00:19:07.000000', 'consum', 0.0273, 'lps'),
	(676450, 134, '2015-02-01 00:19:08.000000', 'consum', 0.0221, 'lps'),
	(676451, 134, '2015-02-01 00:19:09.000000', 'consum', 0.0282, 'lps'),
	(676452, 134, '2015-02-01 00:19:10.000000', 'consum', 0.0228, 'lps'),
	(676453, 134, '2015-02-01 00:19:11.000000', 'consum', 0.0291, 'lps'),
	(676454, 134, '2015-02-01 00:19:12.000000', 'consum', 0.0252, 'lps'),
	(676455, 134, '2015-02-01 00:19:13.000000', 'consum', 0.0281, 'lps'),
	(676456, 134, '2015-02-01 00:19:14.000000', 'consum', 0.0234, 'lps'),
	(676457, 134, '2015-02-01 00:19:15.000000', 'consum', 0.0219, 'lps'),
	(676458, 134, '2015-02-01 00:19:16.000000', 'consum', 0.0286, 'lps'),
	(676459, 134, '2015-02-01 00:19:17.000000', 'consum', 0.0256, 'lps'),
	(676460, 134, '2015-02-01 00:19:18.000000', 'consum', 0.0213, 'lps'),
	(676461, 134, '2015-02-01 00:19:19.000000', 'consum', 0.0291, 'lps'),
	(676462, 134, '2015-02-01 00:19:20.000000', 'consum', 0.0301, 'lps'),
	(676463, 134, '2015-02-01 00:19:21.000000', 'consum', 0.0213, 'lps'),
	(676464, 134, '2015-02-01 00:19:22.000000', 'consum', 0.0263, 'lps'),
	(676465, 134, '2015-02-01 00:19:23.000000', 'consum', 0.0259, 'lps'),
	(676466, 134, '2015-02-01 00:19:24.000000', 'consum', 0.0297, 'lps'),
	(676467, 134, '2015-02-01 00:19:25.000000', 'consum', 0.0294, 'lps'),
	(676468, 134, '2015-02-01 00:19:26.000000', 'consum', 0.0264, 'lps'),
	(676469, 134, '2015-02-01 00:19:27.000000', 'consum', 0.0229, 'lps'),
	(676470, 134, '2015-02-01 00:19:28.000000', 'consum', 0.0247, 'lps'),
	(676471, 134, '2015-02-01 00:19:29.000000', 'consum', 0.0234, 'lps'),
	(676472, 134, '2015-02-01 00:19:30.000000', 'consum', 0.0220, 'lps'),
	(676473, 134, '2015-02-01 00:19:31.000000', 'consum', 0.0292, 'lps'),
	(676474, 134, '2015-02-01 00:19:32.000000', 'consum', 0.0280, 'lps'),
	(676475, 134, '2015-02-01 00:19:33.000000', 'consum', 0.0211, 'lps'),
	(676476, 134, '2015-02-01 00:19:34.000000', 'consum', 0.0213, 'lps'),
	(676477, 134, '2015-02-01 00:19:35.000000', 'consum', 0.0222, 'lps'),
	(676478, 134, '2015-02-01 00:19:36.000000', 'consum', 0.0261, 'lps'),
	(676479, 134, '2015-02-01 00:19:37.000000', 'consum', 0.0224, 'lps'),
	(676480, 134, '2015-02-01 00:19:38.000000', 'consum', 0.0230, 'lps'),
	(676481, 134, '2015-02-01 00:19:39.000000', 'consum', 0.0271, 'lps'),
	(676482, 134, '2015-02-01 00:19:40.000000', 'consum', 0.0247, 'lps'),
	(676483, 134, '2015-02-01 00:19:41.000000', 'consum', 0.0215, 'lps'),
	(676484, 134, '2015-02-01 00:19:42.000000', 'consum', 0.0226, 'lps'),
	(676485, 134, '2015-02-01 00:19:43.000000', 'consum', 0.0274, 'lps'),
	(676486, 134, '2015-02-01 00:19:44.000000', 'consum', 0.0278, 'lps'),
	(676487, 134, '2015-02-01 00:19:45.000000', 'consum', 0.0253, 'lps'),
	(676488, 134, '2015-02-01 00:19:46.000000', 'consum', 0.0224, 'lps'),
	(676489, 134, '2015-02-01 00:19:47.000000', 'consum', 0.0256, 'lps'),
	(676490, 134, '2015-02-01 00:19:48.000000', 'consum', 0.0293, 'lps'),
	(676491, 134, '2015-02-01 00:19:49.000000', 'consum', 0.0281, 'lps'),
	(676492, 134, '2015-02-01 00:19:50.000000', 'consum', 0.0215, 'lps'),
	(676493, 134, '2015-02-01 00:19:51.000000', 'consum', 0.0229, 'lps'),
	(676494, 134, '2015-02-01 00:19:52.000000', 'consum', 0.0289, 'lps'),
	(676495, 134, '2015-02-01 00:19:53.000000', 'consum', 0.0240, 'lps'),
	(676496, 134, '2015-02-01 00:19:54.000000', 'consum', 0.0228, 'lps'),
	(676497, 134, '2015-02-01 00:19:55.000000', 'consum', 0.0210, 'lps'),
	(676498, 134, '2015-02-01 00:19:56.000000', 'consum', 0.0260, 'lps'),
	(676499, 134, '2015-02-01 00:19:57.000000', 'consum', 0.0254, 'lps'),
	(676500, 134, '2015-02-01 00:19:58.000000', 'consum', 0.0282, 'lps'),
	(676501, 134, '2015-02-01 00:19:59.000000', 'consum', 0.0229, 'lps'),
	(676502, 134, '2015-02-01 00:20:00.000000', 'consum', 0.0299, 'lps'),
	(676503, 134, '2015-02-01 00:20:01.000000', 'consum', 0.0289, 'lps'),
	(676504, 134, '2015-02-01 00:20:02.000000', 'consum', 0.0233, 'lps'),
	(676505, 134, '2015-02-01 00:20:03.000000', 'consum', 0.0298, 'lps'),
	(676506, 134, '2015-02-01 00:20:04.000000', 'consum', 0.0270, 'lps'),
	(676507, 134, '2015-02-01 00:20:05.000000', 'consum', 0.0246, 'lps'),
	(676508, 134, '2015-02-01 00:20:06.000000', 'consum', 0.0210, 'lps'),
	(676509, 134, '2015-02-01 00:20:07.000000', 'consum', 0.0308, 'lps'),
	(676510, 134, '2015-02-01 00:20:08.000000', 'consum', 0.0288, 'lps'),
	(676511, 134, '2015-02-01 00:20:09.000000', 'consum', 0.0309, 'lps'),
	(676512, 134, '2015-02-01 00:20:10.000000', 'consum', 0.0264, 'lps'),
	(676513, 134, '2015-02-01 00:20:11.000000', 'consum', 0.0285, 'lps'),
	(676514, 134, '2015-02-01 00:20:12.000000', 'consum', 0.0220, 'lps'),
	(676515, 134, '2015-02-01 00:20:13.000000', 'consum', 0.0242, 'lps'),
	(676516, 134, '2015-02-01 00:20:14.000000', 'consum', 0.0234, 'lps'),
	(676517, 134, '2015-02-01 00:20:15.000000', 'consum', 0.0238, 'lps'),
	(676518, 134, '2015-02-01 00:20:16.000000', 'consum', 0.0277, 'lps'),
	(676519, 134, '2015-02-01 00:20:17.000000', 'consum', 0.0258, 'lps'),
	(676520, 134, '2015-02-01 00:20:18.000000', 'consum', 0.0247, 'lps'),
	(676521, 134, '2015-02-01 00:20:19.000000', 'consum', 0.0253, 'lps'),
	(676522, 134, '2015-02-01 00:20:20.000000', 'consum', 0.0212, 'lps'),
	(676523, 134, '2015-02-01 00:20:21.000000', 'consum', 0.0298, 'lps'),
	(676524, 134, '2015-02-01 00:20:22.000000', 'consum', 0.0231, 'lps'),
	(676525, 134, '2015-02-01 00:20:23.000000', 'consum', 0.0259, 'lps'),
	(676526, 134, '2015-02-01 00:20:24.000000', 'consum', 0.0287, 'lps'),
	(676527, 134, '2015-02-01 00:20:25.000000', 'consum', 0.0244, 'lps'),
	(676528, 134, '2015-02-01 00:20:26.000000', 'consum', 0.0252, 'lps'),
	(676529, 134, '2015-02-01 00:20:27.000000', 'consum', 0.0218, 'lps'),
	(676530, 134, '2015-02-01 00:20:28.000000', 'consum', 0.0224, 'lps'),
	(676531, 134, '2015-02-01 00:20:29.000000', 'consum', 0.0258, 'lps'),
	(676532, 134, '2015-02-01 00:20:30.000000', 'consum', 0.0304, 'lps'),
	(676533, 134, '2015-02-01 00:20:31.000000', 'consum', 0.0229, 'lps'),
	(676534, 134, '2015-02-01 00:20:32.000000', 'consum', 0.0229, 'lps'),
	(676535, 134, '2015-02-01 00:20:33.000000', 'consum', 0.0250, 'lps'),
	(676536, 134, '2015-02-01 00:20:34.000000', 'consum', 0.0248, 'lps'),
	(676537, 134, '2015-02-01 00:20:35.000000', 'consum', 0.0281, 'lps'),
	(676538, 134, '2015-02-01 00:20:36.000000', 'consum', 0.0246, 'lps'),
	(676539, 134, '2015-02-01 00:20:37.000000', 'consum', 0.0279, 'lps'),
	(676540, 134, '2015-02-01 00:20:38.000000', 'consum', 0.0241, 'lps'),
	(676541, 134, '2015-02-01 00:20:39.000000', 'consum', 0.0264, 'lps'),
	(676542, 134, '2015-02-01 00:20:40.000000', 'consum', 0.0282, 'lps'),
	(676543, 134, '2015-02-01 00:20:41.000000', 'consum', 0.0308, 'lps'),
	(676544, 134, '2015-02-01 00:20:42.000000', 'consum', 0.0278, 'lps'),
	(676545, 134, '2015-02-01 00:20:43.000000', 'consum', 0.0256, 'lps'),
	(676546, 134, '2015-02-01 00:20:44.000000', 'consum', 0.0235, 'lps'),
	(676547, 134, '2015-02-01 00:20:45.000000', 'consum', 0.0300, 'lps'),
	(676548, 134, '2015-02-01 00:20:46.000000', 'consum', 0.0276, 'lps'),
	(676549, 134, '2015-02-01 00:20:47.000000', 'consum', 0.0271, 'lps'),
	(676550, 134, '2015-02-01 00:20:48.000000', 'consum', 0.0213, 'lps'),
	(676551, 134, '2015-02-01 00:20:49.000000', 'consum', 0.0250, 'lps'),
	(676552, 134, '2015-02-01 00:20:50.000000', 'consum', 0.0300, 'lps'),
	(676553, 134, '2015-02-01 00:20:51.000000', 'consum', 0.0229, 'lps'),
	(676554, 134, '2015-02-01 00:20:52.000000', 'consum', 0.0243, 'lps'),
	(676555, 134, '2015-02-01 00:20:53.000000', 'consum', 0.0214, 'lps'),
	(676556, 134, '2015-02-01 00:20:54.000000', 'consum', 0.0233, 'lps'),
	(676557, 134, '2015-02-01 00:20:55.000000', 'consum', 0.0213, 'lps'),
	(676558, 134, '2015-02-01 00:20:56.000000', 'consum', 0.0260, 'lps'),
	(676559, 134, '2015-02-01 00:20:57.000000', 'consum', 0.0243, 'lps'),
	(676560, 134, '2015-02-01 00:20:58.000000', 'consum', 0.0226, 'lps'),
	(676561, 134, '2015-02-01 00:20:59.000000', 'consum', 0.0293, 'lps'),
	(676562, 134, '2015-02-01 00:21:00.000000', 'consum', 0.0272, 'lps'),
	(676563, 134, '2015-02-01 00:21:01.000000', 'consum', 0.0270, 'lps'),
	(676564, 134, '2015-02-01 00:21:02.000000', 'consum', 0.0220, 'lps'),
	(676565, 134, '2015-02-01 00:21:03.000000', 'consum', 0.0289, 'lps'),
	(676566, 134, '2015-02-01 00:21:04.000000', 'consum', 0.0266, 'lps'),
	(676567, 134, '2015-02-01 00:21:05.000000', 'consum', 0.0255, 'lps'),
	(676568, 134, '2015-02-01 00:21:06.000000', 'consum', 0.0265, 'lps'),
	(676569, 134, '2015-02-01 00:21:07.000000', 'consum', 0.0249, 'lps'),
	(676570, 134, '2015-02-01 00:21:08.000000', 'consum', 0.0238, 'lps'),
	(676571, 134, '2015-02-01 00:21:09.000000', 'consum', 0.0237, 'lps'),
	(676572, 134, '2015-02-01 00:21:10.000000', 'consum', 0.0259, 'lps'),
	(676573, 134, '2015-02-01 00:21:11.000000', 'consum', 0.0271, 'lps'),
	(676574, 134, '2015-02-01 00:21:12.000000', 'consum', 0.0268, 'lps'),
	(676575, 134, '2015-02-01 00:21:13.000000', 'consum', 0.0213, 'lps'),
	(676576, 134, '2015-02-01 00:21:14.000000', 'consum', 0.0259, 'lps'),
	(676577, 134, '2015-02-01 00:21:15.000000', 'consum', 0.0241, 'lps'),
	(676578, 134, '2015-02-01 00:21:16.000000', 'consum', 0.0218, 'lps'),
	(676579, 134, '2015-02-01 00:21:17.000000', 'consum', 0.0262, 'lps'),
	(676580, 134, '2015-02-01 00:21:18.000000', 'consum', 0.0238, 'lps'),
	(676581, 134, '2015-02-01 00:21:19.000000', 'consum', 0.0299, 'lps'),
	(676582, 134, '2015-02-01 00:21:20.000000', 'consum', 0.0263, 'lps'),
	(676583, 134, '2015-02-01 00:21:21.000000', 'consum', 0.0312, 'lps'),
	(676584, 134, '2015-02-01 00:21:22.000000', 'consum', 0.0253, 'lps'),
	(676585, 134, '2015-02-01 00:21:23.000000', 'consum', 0.0223, 'lps'),
	(676586, 134, '2015-02-01 00:21:24.000000', 'consum', 0.0249, 'lps'),
	(676587, 134, '2015-02-01 00:21:25.000000', 'consum', 0.0265, 'lps'),
	(676588, 134, '2015-02-01 00:21:26.000000', 'consum', 0.0264, 'lps'),
	(676589, 134, '2015-02-01 00:21:27.000000', 'consum', 0.0211, 'lps'),
	(676590, 134, '2015-02-01 00:21:28.000000', 'consum', 0.0260, 'lps'),
	(676591, 134, '2015-02-01 00:21:29.000000', 'consum', 0.0253, 'lps'),
	(676592, 134, '2015-02-01 00:21:30.000000', 'consum', 0.0275, 'lps'),
	(676593, 134, '2015-02-01 00:21:31.000000', 'consum', 0.0303, 'lps'),
	(676594, 134, '2015-02-01 00:21:32.000000', 'consum', 0.0275, 'lps'),
	(676595, 134, '2015-02-01 00:21:33.000000', 'consum', 0.0256, 'lps'),
	(676596, 134, '2015-02-01 00:21:34.000000', 'consum', 0.0246, 'lps'),
	(676597, 134, '2015-02-01 00:21:35.000000', 'consum', 0.0251, 'lps'),
	(676598, 134, '2015-02-01 00:21:36.000000', 'consum', 0.0309, 'lps'),
	(676599, 134, '2015-02-01 00:21:37.000000', 'consum', 0.0274, 'lps'),
	(676600, 134, '2015-02-01 00:21:38.000000', 'consum', 0.0232, 'lps'),
	(676601, 134, '2015-02-01 00:21:39.000000', 'consum', 0.0234, 'lps'),
	(676602, 134, '2015-02-01 00:21:40.000000', 'consum', 0.0263, 'lps'),
	(676603, 134, '2015-02-01 00:21:41.000000', 'consum', 0.0303, 'lps'),
	(676604, 134, '2015-02-01 00:21:42.000000', 'consum', 0.0308, 'lps'),
	(676605, 134, '2015-02-01 00:21:43.000000', 'consum', 0.0214, 'lps'),
	(676606, 134, '2015-02-01 00:21:44.000000', 'consum', 0.0249, 'lps'),
	(676607, 134, '2015-02-01 00:21:45.000000', 'consum', 0.0287, 'lps'),
	(676608, 134, '2015-02-01 00:21:46.000000', 'consum', 0.0275, 'lps'),
	(676609, 134, '2015-02-01 00:21:47.000000', 'consum', 0.0304, 'lps'),
	(676610, 134, '2015-02-01 00:21:48.000000', 'consum', 0.0281, 'lps'),
	(676611, 134, '2015-02-01 00:21:49.000000', 'consum', 0.0281, 'lps'),
	(676612, 134, '2015-02-01 00:21:50.000000', 'consum', 0.0251, 'lps'),
	(676613, 134, '2015-02-01 00:21:51.000000', 'consum', 0.0306, 'lps'),
	(676614, 134, '2015-02-01 00:21:52.000000', 'consum', 0.0259, 'lps'),
	(676615, 134, '2015-02-01 00:21:53.000000', 'consum', 0.0268, 'lps'),
	(676616, 134, '2015-02-01 00:21:54.000000', 'consum', 0.0250, 'lps'),
	(676617, 134, '2015-02-01 00:21:55.000000', 'consum', 0.0238, 'lps'),
	(676618, 134, '2015-02-01 00:21:56.000000', 'consum', 0.0232, 'lps'),
	(676619, 134, '2015-02-01 00:21:57.000000', 'consum', 0.0234, 'lps'),
	(676620, 134, '2015-02-01 00:21:58.000000', 'consum', 0.0265, 'lps'),
	(676621, 134, '2015-02-01 00:21:59.000000', 'consum', 0.0210, 'lps'),
	(676622, 134, '2015-02-01 00:22:00.000000', 'consum', 0.0249, 'lps'),
	(676623, 134, '2015-02-01 00:22:01.000000', 'consum', 0.0303, 'lps'),
	(676624, 134, '2015-02-01 00:22:02.000000', 'consum', 0.0251, 'lps'),
	(676625, 134, '2015-02-01 00:22:03.000000', 'consum', 0.0240, 'lps'),
	(676626, 134, '2015-02-01 00:22:04.000000', 'consum', 0.0238, 'lps'),
	(676627, 134, '2015-02-01 00:22:05.000000', 'consum', 0.0261, 'lps'),
	(676628, 134, '2015-02-01 00:22:06.000000', 'consum', 0.0278, 'lps'),
	(676629, 134, '2015-02-01 00:22:07.000000', 'consum', 0.0293, 'lps'),
	(676630, 134, '2015-02-01 00:22:08.000000', 'consum', 0.0218, 'lps'),
	(676631, 134, '2015-02-01 00:22:09.000000', 'consum', 0.0311, 'lps'),
	(676632, 134, '2015-02-01 00:22:10.000000', 'consum', 0.0277, 'lps'),
	(676633, 134, '2015-02-01 00:22:11.000000', 'consum', 0.0245, 'lps'),
	(676634, 134, '2015-02-01 00:22:12.000000', 'consum', 0.0286, 'lps'),
	(676635, 134, '2015-02-01 00:22:13.000000', 'consum', 0.0279, 'lps'),
	(676636, 134, '2015-02-01 00:22:14.000000', 'consum', 0.0225, 'lps'),
	(676637, 134, '2015-02-01 00:22:15.000000', 'consum', 0.0284, 'lps'),
	(676638, 134, '2015-02-01 00:22:16.000000', 'consum', 0.0226, 'lps'),
	(676639, 134, '2015-02-01 00:22:17.000000', 'consum', 0.0277, 'lps'),
	(676640, 134, '2015-02-01 00:22:18.000000', 'consum', 0.0290, 'lps'),
	(676641, 134, '2015-02-01 00:22:19.000000', 'consum', 0.0308, 'lps'),
	(676642, 134, '2015-02-01 00:22:20.000000', 'consum', 0.0252, 'lps'),
	(676643, 134, '2015-02-01 00:22:21.000000', 'consum', 0.0229, 'lps'),
	(676644, 134, '2015-02-01 00:22:22.000000', 'consum', 0.0282, 'lps'),
	(676645, 134, '2015-02-01 00:22:23.000000', 'consum', 0.0309, 'lps'),
	(676646, 134, '2015-02-01 00:22:24.000000', 'consum', 0.0282, 'lps'),
	(676647, 134, '2015-02-01 00:22:25.000000', 'consum', 0.0276, 'lps'),
	(676648, 134, '2015-02-01 00:22:26.000000', 'consum', 0.0218, 'lps'),
	(676649, 134, '2015-02-01 00:22:27.000000', 'consum', 0.0262, 'lps'),
	(676650, 134, '2015-02-01 00:22:28.000000', 'consum', 0.0239, 'lps'),
	(676651, 134, '2015-02-01 00:22:29.000000', 'consum', 0.0303, 'lps'),
	(676652, 134, '2015-02-01 00:22:30.000000', 'consum', 0.0281, 'lps'),
	(676653, 134, '2015-02-01 00:22:31.000000', 'consum', 0.0283, 'lps'),
	(676654, 134, '2015-02-01 00:22:32.000000', 'consum', 0.0263, 'lps'),
	(676655, 134, '2015-02-01 00:22:33.000000', 'consum', 0.0254, 'lps'),
	(676656, 134, '2015-02-01 00:22:34.000000', 'consum', 0.0274, 'lps'),
	(676657, 134, '2015-02-01 00:22:35.000000', 'consum', 0.0294, 'lps'),
	(676658, 134, '2015-02-01 00:22:36.000000', 'consum', 0.0233, 'lps'),
	(676659, 134, '2015-02-01 00:22:37.000000', 'consum', 0.0278, 'lps'),
	(676660, 134, '2015-02-01 00:22:38.000000', 'consum', 0.0275, 'lps'),
	(676661, 134, '2015-02-01 00:22:39.000000', 'consum', 0.0229, 'lps'),
	(676662, 134, '2015-02-01 00:22:40.000000', 'consum', 0.0213, 'lps'),
	(676663, 134, '2015-02-01 00:22:41.000000', 'consum', 0.0272, 'lps'),
	(676664, 134, '2015-02-01 00:22:42.000000', 'consum', 0.0304, 'lps'),
	(676665, 134, '2015-02-01 00:22:43.000000', 'consum', 0.0291, 'lps'),
	(676666, 134, '2015-02-01 00:22:44.000000', 'consum', 0.0231, 'lps'),
	(676667, 134, '2015-02-01 00:22:45.000000', 'consum', 0.0277, 'lps'),
	(676668, 134, '2015-02-01 00:22:46.000000', 'consum', 0.0278, 'lps'),
	(676669, 134, '2015-02-01 00:22:47.000000', 'consum', 0.0246, 'lps'),
	(676670, 134, '2015-02-01 00:22:48.000000', 'consum', 0.0289, 'lps'),
	(676671, 134, '2015-02-01 00:22:49.000000', 'consum', 0.0290, 'lps'),
	(676672, 134, '2015-02-01 00:22:50.000000', 'consum', 0.0273, 'lps'),
	(676673, 134, '2015-02-01 00:22:51.000000', 'consum', 0.0286, 'lps'),
	(676674, 134, '2015-02-01 00:22:52.000000', 'consum', 0.0297, 'lps'),
	(676675, 134, '2015-02-01 00:22:53.000000', 'consum', 0.0211, 'lps'),
	(676676, 134, '2015-02-01 00:22:54.000000', 'consum', 0.0263, 'lps'),
	(676677, 134, '2015-02-01 00:22:55.000000', 'consum', 0.0267, 'lps'),
	(676678, 134, '2015-02-01 00:22:56.000000', 'consum', 0.0235, 'lps'),
	(676679, 134, '2015-02-01 00:22:57.000000', 'consum', 0.0266, 'lps'),
	(676680, 134, '2015-02-01 00:22:58.000000', 'consum', 0.0312, 'lps'),
	(676681, 134, '2015-02-01 00:22:59.000000', 'consum', 0.0245, 'lps'),
	(676682, 134, '2015-02-01 00:23:00.000000', 'consum', 0.0286, 'lps'),
	(676683, 134, '2015-02-01 00:23:01.000000', 'consum', 0.0279, 'lps'),
	(676684, 134, '2015-02-01 00:23:02.000000', 'consum', 0.0223, 'lps'),
	(676685, 134, '2015-02-01 00:23:03.000000', 'consum', 0.0277, 'lps'),
	(676686, 134, '2015-02-01 00:23:04.000000', 'consum', 0.0300, 'lps'),
	(676687, 134, '2015-02-01 00:23:05.000000', 'consum', 0.0252, 'lps'),
	(676688, 134, '2015-02-01 00:23:06.000000', 'consum', 0.0253, 'lps'),
	(676689, 134, '2015-02-01 00:23:07.000000', 'consum', 0.0302, 'lps'),
	(676690, 134, '2015-02-01 00:23:08.000000', 'consum', 0.0230, 'lps'),
	(676691, 134, '2015-02-01 00:23:09.000000', 'consum', 0.0242, 'lps'),
	(676692, 134, '2015-02-01 00:23:10.000000', 'consum', 0.0308, 'lps'),
	(676693, 134, '2015-02-01 00:23:11.000000', 'consum', 0.0298, 'lps'),
	(676694, 134, '2015-02-01 00:23:12.000000', 'consum', 0.0253, 'lps'),
	(676695, 134, '2015-02-01 00:23:13.000000', 'consum', 0.0266, 'lps'),
	(676696, 134, '2015-02-01 00:23:14.000000', 'consum', 0.0258, 'lps'),
	(676697, 134, '2015-02-01 00:23:15.000000', 'consum', 0.0282, 'lps'),
	(676698, 134, '2015-02-01 00:23:16.000000', 'consum', 0.0221, 'lps'),
	(676699, 134, '2015-02-01 00:23:17.000000', 'consum', 0.0253, 'lps'),
	(676700, 134, '2015-02-01 00:23:18.000000', 'consum', 0.0293, 'lps'),
	(676701, 134, '2015-02-01 00:23:19.000000', 'consum', 0.0290, 'lps'),
	(676702, 134, '2015-02-01 00:23:20.000000', 'consum', 0.0257, 'lps'),
	(676703, 134, '2015-02-01 00:23:21.000000', 'consum', 0.0308, 'lps'),
	(676704, 134, '2015-02-01 00:23:22.000000', 'consum', 0.0253, 'lps'),
	(676705, 134, '2015-02-01 00:23:23.000000', 'consum', 0.0233, 'lps'),
	(676706, 134, '2015-02-01 00:23:24.000000', 'consum', 0.0299, 'lps'),
	(676707, 134, '2015-02-01 00:23:25.000000', 'consum', 0.0276, 'lps'),
	(676708, 134, '2015-02-01 00:23:26.000000', 'consum', 0.0277, 'lps'),
	(676709, 134, '2015-02-01 00:23:27.000000', 'consum', 0.0243, 'lps'),
	(676710, 134, '2015-02-01 00:23:28.000000', 'consum', 0.0276, 'lps'),
	(676711, 134, '2015-02-01 00:23:29.000000', 'consum', 0.0235, 'lps'),
	(676712, 134, '2015-02-01 00:23:30.000000', 'consum', 0.0241, 'lps'),
	(676713, 134, '2015-02-01 00:23:31.000000', 'consum', 0.0290, 'lps'),
	(676714, 134, '2015-02-01 00:23:32.000000', 'consum', 0.0311, 'lps'),
	(676715, 134, '2015-02-01 00:23:33.000000', 'consum', 0.0269, 'lps'),
	(676716, 134, '2015-02-01 00:23:34.000000', 'consum', 0.0304, 'lps'),
	(676717, 134, '2015-02-01 00:23:35.000000', 'consum', 0.0301, 'lps'),
	(676718, 134, '2015-02-01 00:23:36.000000', 'consum', 0.0277, 'lps'),
	(676719, 134, '2015-02-01 00:23:37.000000', 'consum', 0.0275, 'lps'),
	(676720, 134, '2015-02-01 00:23:38.000000', 'consum', 0.0232, 'lps'),
	(676721, 134, '2015-02-01 00:23:39.000000', 'consum', 0.0226, 'lps'),
	(676722, 134, '2015-02-01 00:23:40.000000', 'consum', 0.0224, 'lps'),
	(676723, 134, '2015-02-01 00:23:41.000000', 'consum', 0.0234, 'lps'),
	(676724, 134, '2015-02-01 00:23:42.000000', 'consum', 0.0286, 'lps'),
	(676725, 134, '2015-02-01 00:23:43.000000', 'consum', 0.0213, 'lps'),
	(676726, 134, '2015-02-01 00:23:44.000000', 'consum', 0.0304, 'lps'),
	(676727, 134, '2015-02-01 00:23:45.000000', 'consum', 0.0260, 'lps'),
	(676728, 134, '2015-02-01 00:23:46.000000', 'consum', 0.0280, 'lps'),
	(676729, 134, '2015-02-01 00:23:47.000000', 'consum', 0.0307, 'lps'),
	(676730, 134, '2015-02-01 00:23:48.000000', 'consum', 0.0280, 'lps'),
	(676731, 134, '2015-02-01 00:23:49.000000', 'consum', 0.0270, 'lps'),
	(676732, 134, '2015-02-01 00:23:50.000000', 'consum', 0.0300, 'lps'),
	(676733, 134, '2015-02-01 00:23:51.000000', 'consum', 0.0276, 'lps'),
	(676734, 134, '2015-02-01 00:23:52.000000', 'consum', 0.0269, 'lps'),
	(676735, 134, '2015-02-01 00:23:53.000000', 'consum', 0.0309, 'lps'),
	(676736, 134, '2015-02-01 00:23:54.000000', 'consum', 0.0218, 'lps'),
	(676737, 134, '2015-02-01 00:23:55.000000', 'consum', 0.0262, 'lps'),
	(676738, 134, '2015-02-01 00:23:56.000000', 'consum', 0.0243, 'lps'),
	(676739, 134, '2015-02-01 00:23:57.000000', 'consum', 0.0219, 'lps'),
	(676740, 134, '2015-02-01 00:23:58.000000', 'consum', 0.0259, 'lps'),
	(676741, 134, '2015-02-01 00:23:59.000000', 'consum', 0.0221, 'lps'),
	(676742, 134, '2015-02-01 00:24:00.000000', 'consum', 0.0221, 'lps'),
	(676743, 134, '2015-02-01 00:24:01.000000', 'consum', 0.0232, 'lps'),
	(676744, 134, '2015-02-01 00:24:02.000000', 'consum', 0.0286, 'lps'),
	(676745, 134, '2015-02-01 00:24:03.000000', 'consum', 0.0219, 'lps'),
	(676746, 134, '2015-02-01 00:24:04.000000', 'consum', 0.0234, 'lps'),
	(676747, 134, '2015-02-01 00:24:05.000000', 'consum', 0.0303, 'lps'),
	(676748, 134, '2015-02-01 00:24:06.000000', 'consum', 0.0296, 'lps'),
	(676749, 134, '2015-02-01 00:24:07.000000', 'consum', 0.0255, 'lps'),
	(676750, 134, '2015-02-01 00:24:08.000000', 'consum', 0.0283, 'lps'),
	(676751, 134, '2015-02-01 00:24:09.000000', 'consum', 0.0233, 'lps'),
	(676752, 134, '2015-02-01 00:24:10.000000', 'consum', 0.0210, 'lps'),
	(676753, 134, '2015-02-01 00:24:11.000000', 'consum', 0.0244, 'lps'),
	(676754, 134, '2015-02-01 00:24:12.000000', 'consum', 0.0280, 'lps'),
	(676755, 134, '2015-02-01 00:24:13.000000', 'consum', 0.0251, 'lps'),
	(676756, 134, '2015-02-01 00:24:14.000000', 'consum', 0.0307, 'lps'),
	(676757, 134, '2015-02-01 00:24:15.000000', 'consum', 0.0265, 'lps'),
	(676758, 134, '2015-02-01 00:24:16.000000', 'consum', 0.0299, 'lps'),
	(676759, 134, '2015-02-01 00:24:17.000000', 'consum', 0.0282, 'lps'),
	(676760, 134, '2015-02-01 00:24:18.000000', 'consum', 0.0306, 'lps'),
	(676761, 134, '2015-02-01 00:24:19.000000', 'consum', 0.0266, 'lps'),
	(676762, 134, '2015-02-01 00:24:20.000000', 'consum', 0.0305, 'lps'),
	(676763, 134, '2015-02-01 00:24:21.000000', 'consum', 0.0310, 'lps'),
	(676764, 134, '2015-02-01 00:24:22.000000', 'consum', 0.0223, 'lps'),
	(676765, 134, '2015-02-01 00:24:23.000000', 'consum', 0.0284, 'lps'),
	(676766, 134, '2015-02-01 00:24:24.000000', 'consum', 0.0233, 'lps'),
	(676767, 134, '2015-02-01 00:24:25.000000', 'consum', 0.0310, 'lps'),
	(676768, 134, '2015-02-01 00:24:26.000000', 'consum', 0.0228, 'lps'),
	(676769, 134, '2015-02-01 00:24:27.000000', 'consum', 0.0312, 'lps'),
	(676770, 134, '2015-02-01 00:24:28.000000', 'consum', 0.0252, 'lps'),
	(676771, 134, '2015-02-01 00:24:29.000000', 'consum', 0.0217, 'lps'),
	(676772, 134, '2015-02-01 00:24:30.000000', 'consum', 0.0225, 'lps'),
	(676773, 134, '2015-02-01 00:24:31.000000', 'consum', 0.0261, 'lps'),
	(676774, 134, '2015-02-01 00:24:32.000000', 'consum', 0.0217, 'lps'),
	(676775, 134, '2015-02-01 00:24:33.000000', 'consum', 0.0300, 'lps'),
	(676776, 134, '2015-02-01 00:24:34.000000', 'consum', 0.0226, 'lps'),
	(676777, 134, '2015-02-01 00:24:35.000000', 'consum', 0.0227, 'lps'),
	(676778, 134, '2015-02-01 00:24:36.000000', 'consum', 0.0246, 'lps'),
	(676779, 134, '2015-02-01 00:24:37.000000', 'consum', 0.0236, 'lps'),
	(676780, 134, '2015-02-01 00:24:38.000000', 'consum', 0.0234, 'lps'),
	(676781, 134, '2015-02-01 00:24:39.000000', 'consum', 0.0253, 'lps'),
	(676782, 134, '2015-02-01 00:24:40.000000', 'consum', 0.0251, 'lps'),
	(676783, 134, '2015-02-01 00:24:41.000000', 'consum', 0.0285, 'lps'),
	(676784, 134, '2015-02-01 00:24:42.000000', 'consum', 0.0257, 'lps'),
	(676785, 134, '2015-02-01 00:24:43.000000', 'consum', 0.0221, 'lps'),
	(676786, 134, '2015-02-01 00:24:44.000000', 'consum', 0.0229, 'lps'),
	(676787, 134, '2015-02-01 00:24:45.000000', 'consum', 0.0271, 'lps'),
	(676788, 134, '2015-02-01 00:24:46.000000', 'consum', 0.0251, 'lps'),
	(676789, 134, '2015-02-01 00:24:47.000000', 'consum', 0.0234, 'lps'),
	(676790, 134, '2015-02-01 00:24:48.000000', 'consum', 0.0309, 'lps'),
	(676791, 134, '2015-02-01 00:24:49.000000', 'consum', 0.0223, 'lps'),
	(676792, 134, '2015-02-01 00:24:50.000000', 'consum', 0.0288, 'lps'),
	(676793, 134, '2015-02-01 00:24:51.000000', 'consum', 0.0253, 'lps'),
	(676794, 134, '2015-02-01 00:24:52.000000', 'consum', 0.0292, 'lps'),
	(676795, 134, '2015-02-01 00:24:53.000000', 'consum', 0.0285, 'lps'),
	(676796, 134, '2015-02-01 00:24:54.000000', 'consum', 0.0237, 'lps'),
	(676797, 134, '2015-02-01 00:24:55.000000', 'consum', 0.0226, 'lps'),
	(676798, 134, '2015-02-01 00:24:56.000000', 'consum', 0.0309, 'lps'),
	(676799, 134, '2015-02-01 00:24:57.000000', 'consum', 0.0249, 'lps'),
	(676800, 134, '2015-02-01 00:24:58.000000', 'consum', 0.0210, 'lps'),
	(676801, 134, '2015-02-01 00:24:59.000000', 'consum', 0.0300, 'lps'),
	(676802, 134, '2015-02-01 00:25:00.000000', 'consum', 0.0248, 'lps'),
	(676803, 134, '2015-02-01 00:25:01.000000', 'consum', 0.0232, 'lps'),
	(676804, 134, '2015-02-01 00:25:02.000000', 'consum', 0.0312, 'lps'),
	(676805, 134, '2015-02-01 00:25:03.000000', 'consum', 0.0241, 'lps'),
	(676806, 134, '2015-02-01 00:25:04.000000', 'consum', 0.0267, 'lps'),
	(676807, 134, '2015-02-01 00:25:05.000000', 'consum', 0.0297, 'lps'),
	(676808, 134, '2015-02-01 00:25:06.000000', 'consum', 0.0271, 'lps'),
	(676809, 134, '2015-02-01 00:25:07.000000', 'consum', 0.0253, 'lps'),
	(676810, 134, '2015-02-01 00:25:08.000000', 'consum', 0.0242, 'lps'),
	(676811, 134, '2015-02-01 00:25:09.000000', 'consum', 0.0244, 'lps'),
	(676812, 134, '2015-02-01 00:25:10.000000', 'consum', 0.0283, 'lps'),
	(676813, 134, '2015-02-01 00:25:11.000000', 'consum', 0.0267, 'lps'),
	(676814, 134, '2015-02-01 00:25:12.000000', 'consum', 0.0276, 'lps'),
	(676815, 134, '2015-02-01 00:25:13.000000', 'consum', 0.0268, 'lps'),
	(676816, 134, '2015-02-01 00:25:14.000000', 'consum', 0.0302, 'lps'),
	(676817, 134, '2015-02-01 00:25:15.000000', 'consum', 0.0290, 'lps'),
	(676818, 134, '2015-02-01 00:25:16.000000', 'consum', 0.0231, 'lps'),
	(676819, 134, '2015-02-01 00:25:17.000000', 'consum', 0.0284, 'lps'),
	(676820, 134, '2015-02-01 00:25:18.000000', 'consum', 0.0310, 'lps'),
	(676821, 134, '2015-02-01 00:25:19.000000', 'consum', 0.0281, 'lps'),
	(676822, 134, '2015-02-01 00:25:20.000000', 'consum', 0.0267, 'lps'),
	(676823, 134, '2015-02-01 00:25:21.000000', 'consum', 0.0280, 'lps'),
	(676824, 134, '2015-02-01 00:25:22.000000', 'consum', 0.0289, 'lps'),
	(676825, 134, '2015-02-01 00:25:23.000000', 'consum', 0.0290, 'lps'),
	(676826, 134, '2015-02-01 00:25:24.000000', 'consum', 0.0273, 'lps'),
	(676827, 134, '2015-02-01 00:25:25.000000', 'consum', 0.0287, 'lps'),
	(676828, 134, '2015-02-01 00:25:26.000000', 'consum', 0.0300, 'lps'),
	(676829, 134, '2015-02-01 00:25:27.000000', 'consum', 0.0225, 'lps'),
	(676830, 134, '2015-02-01 00:25:28.000000', 'consum', 0.0221, 'lps'),
	(676831, 134, '2015-02-01 00:25:29.000000', 'consum', 0.0220, 'lps'),
	(676832, 134, '2015-02-01 00:25:30.000000', 'consum', 0.0228, 'lps'),
	(676833, 134, '2015-02-01 00:25:31.000000', 'consum', 0.0271, 'lps'),
	(676834, 134, '2015-02-01 00:25:32.000000', 'consum', 0.0253, 'lps'),
	(676835, 134, '2015-02-01 00:25:33.000000', 'consum', 0.0244, 'lps'),
	(676836, 134, '2015-02-01 00:25:34.000000', 'consum', 0.0253, 'lps'),
	(676837, 134, '2015-02-01 00:25:35.000000', 'consum', 0.0219, 'lps'),
	(676838, 134, '2015-02-01 00:25:36.000000', 'consum', 0.0232, 'lps'),
	(676839, 134, '2015-02-01 00:25:37.000000', 'consum', 0.0291, 'lps'),
	(676840, 134, '2015-02-01 00:25:38.000000', 'consum', 0.0240, 'lps'),
	(676841, 134, '2015-02-01 00:25:39.000000', 'consum', 0.0223, 'lps'),
	(676842, 134, '2015-02-01 00:25:40.000000', 'consum', 0.0289, 'lps'),
	(676843, 134, '2015-02-01 00:25:41.000000', 'consum', 0.0257, 'lps'),
	(676844, 134, '2015-02-01 00:25:42.000000', 'consum', 0.0310, 'lps'),
	(676845, 134, '2015-02-01 00:25:43.000000', 'consum', 0.0262, 'lps'),
	(676846, 134, '2015-02-01 00:25:44.000000', 'consum', 0.0275, 'lps'),
	(676847, 134, '2015-02-01 00:25:45.000000', 'consum', 0.0275, 'lps'),
	(676848, 134, '2015-02-01 00:25:46.000000', 'consum', 0.0238, 'lps'),
	(676849, 134, '2015-02-01 00:25:47.000000', 'consum', 0.0258, 'lps'),
	(676850, 134, '2015-02-01 00:25:48.000000', 'consum', 0.0262, 'lps'),
	(676851, 134, '2015-02-01 00:25:49.000000', 'consum', 0.0224, 'lps'),
	(676852, 134, '2015-02-01 00:25:50.000000', 'consum', 0.0230, 'lps'),
	(676853, 134, '2015-02-01 00:25:51.000000', 'consum', 0.0266, 'lps'),
	(676854, 134, '2015-02-01 00:25:52.000000', 'consum', 0.0223, 'lps'),
	(676855, 134, '2015-02-01 00:25:53.000000', 'consum', 0.0214, 'lps'),
	(676856, 134, '2015-02-01 00:25:54.000000', 'consum', 0.0294, 'lps'),
	(676857, 134, '2015-02-01 00:25:55.000000', 'consum', 0.0309, 'lps'),
	(676858, 134, '2015-02-01 00:25:56.000000', 'consum', 0.0247, 'lps'),
	(676859, 134, '2015-02-01 00:25:57.000000', 'consum', 0.0305, 'lps'),
	(676860, 134, '2015-02-01 00:25:58.000000', 'consum', 0.0267, 'lps'),
	(676861, 134, '2015-02-01 00:25:59.000000', 'consum', 0.0312, 'lps'),
	(676862, 134, '2015-02-01 00:26:00.000000', 'consum', 0.0239, 'lps'),
	(676863, 134, '2015-02-01 00:26:01.000000', 'consum', 0.0257, 'lps'),
	(676864, 134, '2015-02-01 00:26:02.000000', 'consum', 0.0256, 'lps'),
	(676865, 134, '2015-02-01 00:26:03.000000', 'consum', 0.0300, 'lps'),
	(676866, 134, '2015-02-01 00:26:04.000000', 'consum', 0.0212, 'lps'),
	(676867, 134, '2015-02-01 00:26:05.000000', 'consum', 0.0258, 'lps'),
	(676868, 134, '2015-02-01 00:26:06.000000', 'consum', 0.0241, 'lps'),
	(676869, 134, '2015-02-01 00:26:07.000000', 'consum', 0.0220, 'lps'),
	(676870, 134, '2015-02-01 00:26:08.000000', 'consum', 0.0271, 'lps'),
	(676871, 134, '2015-02-01 00:26:09.000000', 'consum', 0.0280, 'lps'),
	(676872, 134, '2015-02-01 00:26:10.000000', 'consum', 0.0274, 'lps'),
	(676873, 134, '2015-02-01 00:26:11.000000', 'consum', 0.0216, 'lps'),
	(676874, 134, '2015-02-01 00:26:12.000000', 'consum', 0.0256, 'lps'),
	(676875, 134, '2015-02-01 00:26:13.000000', 'consum', 0.0214, 'lps'),
	(676876, 134, '2015-02-01 00:26:14.000000', 'consum', 0.0301, 'lps'),
	(676877, 134, '2015-02-01 00:26:15.000000', 'consum', 0.0242, 'lps'),
	(676878, 134, '2015-02-01 00:26:16.000000', 'consum', 0.0304, 'lps'),
	(676879, 134, '2015-02-01 00:26:17.000000', 'consum', 0.0273, 'lps'),
	(676880, 134, '2015-02-01 00:26:18.000000', 'consum', 0.0244, 'lps'),
	(676881, 134, '2015-02-01 00:26:19.000000', 'consum', 0.0297, 'lps'),
	(676882, 134, '2015-02-01 00:26:20.000000', 'consum', 0.0231, 'lps'),
	(676883, 134, '2015-02-01 00:26:21.000000', 'consum', 0.0264, 'lps'),
	(676884, 134, '2015-02-01 00:26:22.000000', 'consum', 0.0312, 'lps'),
	(676885, 134, '2015-02-01 00:26:23.000000', 'consum', 0.0249, 'lps'),
	(676886, 134, '2015-02-01 00:26:24.000000', 'consum', 0.0306, 'lps'),
	(676887, 134, '2015-02-01 00:26:25.000000', 'consum', 0.0264, 'lps'),
	(676888, 134, '2015-02-01 00:26:26.000000', 'consum', 0.0297, 'lps'),
	(676889, 134, '2015-02-01 00:26:27.000000', 'consum', 0.0277, 'lps'),
	(676890, 134, '2015-02-01 00:26:28.000000', 'consum', 0.0283, 'lps'),
	(676891, 134, '2015-02-01 00:26:29.000000', 'consum', 0.0272, 'lps'),
	(676892, 134, '2015-02-01 00:26:30.000000', 'consum', 0.0303, 'lps'),
	(676893, 134, '2015-02-01 00:26:31.000000', 'consum', 0.0283, 'lps'),
	(676894, 134, '2015-02-01 00:26:32.000000', 'consum', 0.0297, 'lps'),
	(676895, 134, '2015-02-01 00:26:33.000000', 'consum', 0.0221, 'lps'),
	(676896, 134, '2015-02-01 00:26:34.000000', 'consum', 0.0211, 'lps'),
	(676897, 134, '2015-02-01 00:26:35.000000', 'consum', 0.0284, 'lps'),
	(676898, 134, '2015-02-01 00:26:36.000000', 'consum', 0.0270, 'lps'),
	(676899, 134, '2015-02-01 00:26:37.000000', 'consum', 0.0288, 'lps'),
	(676900, 134, '2015-02-01 00:26:38.000000', 'consum', 0.0214, 'lps'),
	(676901, 134, '2015-02-01 00:26:39.000000', 'consum', 0.0306, 'lps'),
	(676902, 134, '2015-02-01 00:26:40.000000', 'consum', 0.0264, 'lps'),
	(676903, 134, '2015-02-01 00:26:41.000000', 'consum', 0.0298, 'lps'),
	(676904, 134, '2015-02-01 00:26:42.000000', 'consum', 0.0282, 'lps'),
	(676905, 134, '2015-02-01 00:26:43.000000', 'consum', 0.0307, 'lps'),
	(676906, 134, '2015-02-01 00:26:44.000000', 'consum', 0.0275, 'lps'),
	(676907, 134, '2015-02-01 00:26:45.000000', 'consum', 0.0243, 'lps'),
	(676908, 134, '2015-02-01 00:26:46.000000', 'consum', 0.0283, 'lps'),
	(676909, 134, '2015-02-01 00:26:47.000000', 'consum', 0.0270, 'lps'),
	(676910, 134, '2015-02-01 00:26:48.000000', 'consum', 0.0293, 'lps'),
	(676911, 134, '2015-02-01 00:26:49.000000', 'consum', 0.0239, 'lps'),
	(676912, 134, '2015-02-01 00:26:50.000000', 'consum', 0.0311, 'lps'),
	(676913, 134, '2015-02-01 00:26:51.000000', 'consum', 0.0215, 'lps'),
	(676914, 134, '2015-02-01 00:26:52.000000', 'consum', 0.0245, 'lps'),
	(676915, 134, '2015-02-01 00:26:53.000000', 'consum', 0.0268, 'lps'),
	(676916, 134, '2015-02-01 00:26:54.000000', 'consum', 0.0289, 'lps'),
	(676917, 134, '2015-02-01 00:26:55.000000', 'consum', 0.0228, 'lps'),
	(676918, 134, '2015-02-01 00:26:56.000000', 'consum', 0.0269, 'lps'),
	(676919, 134, '2015-02-01 00:26:57.000000', 'consum', 0.0247, 'lps'),
	(676920, 134, '2015-02-01 00:26:58.000000', 'consum', 0.0216, 'lps'),
	(676921, 134, '2015-02-01 00:26:59.000000', 'consum', 0.0235, 'lps'),
	(676922, 134, '2015-02-01 00:27:00.000000', 'consum', 0.0213, 'lps'),
	(676923, 134, '2015-02-01 00:27:01.000000', 'consum', 0.0254, 'lps'),
	(676924, 134, '2015-02-01 00:27:02.000000', 'consum', 0.0214, 'lps'),
	(676925, 134, '2015-02-01 00:27:03.000000', 'consum', 0.0303, 'lps'),
	(676926, 134, '2015-02-01 00:27:04.000000', 'consum', 0.0255, 'lps'),
	(676927, 134, '2015-02-01 00:27:05.000000', 'consum', 0.0257, 'lps'),
	(676928, 134, '2015-02-01 00:27:06.000000', 'consum', 0.0210, 'lps'),
	(676929, 134, '2015-02-01 00:27:07.000000', 'consum', 0.0273, 'lps'),
	(676930, 134, '2015-02-01 00:27:08.000000', 'consum', 0.0219, 'lps'),
	(676931, 134, '2015-02-01 00:27:09.000000', 'consum', 0.0270, 'lps'),
	(676932, 134, '2015-02-01 00:27:10.000000', 'consum', 0.0279, 'lps'),
	(676933, 134, '2015-02-01 00:27:11.000000', 'consum', 0.0272, 'lps'),
	(676934, 134, '2015-02-01 00:27:12.000000', 'consum', 0.0312, 'lps'),
	(676935, 134, '2015-02-01 00:27:13.000000', 'consum', 0.0225, 'lps'),
	(676936, 134, '2015-02-01 00:27:14.000000', 'consum', 0.0291, 'lps'),
	(676937, 134, '2015-02-01 00:27:15.000000', 'consum', 0.0261, 'lps'),
	(676938, 134, '2015-02-01 00:27:16.000000', 'consum', 0.0221, 'lps'),
	(676939, 134, '2015-02-01 00:27:17.000000', 'consum', 0.0217, 'lps'),
	(676940, 134, '2015-02-01 00:27:18.000000', 'consum', 0.0212, 'lps'),
	(676941, 134, '2015-02-01 00:27:19.000000', 'consum', 0.0303, 'lps'),
	(676942, 134, '2015-02-01 00:27:20.000000', 'consum', 0.0258, 'lps'),
	(676943, 134, '2015-02-01 00:27:21.000000', 'consum', 0.0274, 'lps'),
	(676944, 134, '2015-02-01 00:27:22.000000', 'consum', 0.0283, 'lps'),
	(676945, 134, '2015-02-01 00:27:23.000000', 'consum', 0.0280, 'lps'),
	(676946, 134, '2015-02-01 00:27:24.000000', 'consum', 0.0241, 'lps'),
	(676947, 134, '2015-02-01 00:27:25.000000', 'consum', 0.0257, 'lps'),
	(676948, 134, '2015-02-01 00:27:26.000000', 'consum', 0.0251, 'lps'),
	(676949, 134, '2015-02-01 00:27:27.000000', 'consum', 0.0272, 'lps'),
	(676950, 134, '2015-02-01 00:27:28.000000', 'consum', 0.0297, 'lps'),
	(676951, 134, '2015-02-01 00:27:29.000000', 'consum', 0.0253, 'lps'),
	(676952, 134, '2015-02-01 00:27:30.000000', 'consum', 0.0266, 'lps'),
	(676953, 134, '2015-02-01 00:27:31.000000', 'consum', 0.0260, 'lps'),
	(676954, 134, '2015-02-01 00:27:32.000000', 'consum', 0.0292, 'lps'),
	(676955, 134, '2015-02-01 00:27:33.000000', 'consum', 0.0265, 'lps'),
	(676956, 134, '2015-02-01 00:27:34.000000', 'consum', 0.0240, 'lps'),
	(676957, 134, '2015-02-01 00:27:35.000000', 'consum', 0.0300, 'lps'),
	(676958, 134, '2015-02-01 00:27:36.000000', 'consum', 0.0259, 'lps'),
	(676959, 134, '2015-02-01 00:27:37.000000', 'consum', 0.0291, 'lps'),
	(676960, 134, '2015-02-01 00:27:38.000000', 'consum', 0.0262, 'lps'),
	(676961, 134, '2015-02-01 00:27:39.000000', 'consum', 0.0226, 'lps'),
	(676962, 134, '2015-02-01 00:27:40.000000', 'consum', 0.0236, 'lps'),
	(676963, 134, '2015-02-01 00:27:41.000000', 'consum', 0.0295, 'lps'),
	(676964, 134, '2015-02-01 00:27:42.000000', 'consum', 0.0247, 'lps'),
	(676965, 134, '2015-02-01 00:27:43.000000', 'consum', 0.0246, 'lps'),
	(676966, 134, '2015-02-01 00:27:44.000000', 'consum', 0.0278, 'lps'),
	(676967, 134, '2015-02-01 00:27:45.000000', 'consum', 0.0236, 'lps'),
	(676968, 134, '2015-02-01 00:27:46.000000', 'consum', 0.0238, 'lps'),
	(676969, 134, '2015-02-01 00:27:47.000000', 'consum', 0.0276, 'lps'),
	(676970, 134, '2015-02-01 00:27:48.000000', 'consum', 0.0247, 'lps'),
	(676971, 134, '2015-02-01 00:27:49.000000', 'consum', 0.0303, 'lps'),
	(676972, 134, '2015-02-01 00:27:50.000000', 'consum', 0.0255, 'lps'),
	(676973, 134, '2015-02-01 00:27:51.000000', 'consum', 0.0261, 'lps'),
	(676974, 134, '2015-02-01 00:27:52.000000', 'consum', 0.0226, 'lps'),
	(676975, 134, '2015-02-01 00:27:53.000000', 'consum', 0.0239, 'lps'),
	(676976, 134, '2015-02-01 00:27:54.000000', 'consum', 0.0310, 'lps'),
	(676977, 134, '2015-02-01 00:27:55.000000', 'consum', 0.0211, 'lps'),
	(676978, 134, '2015-02-01 00:27:56.000000', 'consum', 0.0224, 'lps'),
	(676979, 134, '2015-02-01 00:27:57.000000', 'consum', 0.0279, 'lps'),
	(676980, 134, '2015-02-01 00:27:58.000000', 'consum', 0.0305, 'lps'),
	(676981, 134, '2015-02-01 00:27:59.000000', 'consum', 0.0274, 'lps'),
	(676982, 134, '2015-02-01 00:28:00.000000', 'consum', 0.0243, 'lps'),
	(676983, 134, '2015-02-01 00:28:01.000000', 'consum', 0.0289, 'lps'),
	(676984, 134, '2015-02-01 00:28:02.000000', 'consum', 0.0299, 'lps'),
	(676985, 134, '2015-02-01 00:28:03.000000', 'consum', 0.0213, 'lps'),
	(676986, 134, '2015-02-01 00:28:04.000000', 'consum', 0.0269, 'lps'),
	(676987, 134, '2015-02-01 00:28:05.000000', 'consum', 0.0291, 'lps'),
	(676988, 134, '2015-02-01 00:28:06.000000', 'consum', 0.0233, 'lps'),
	(676989, 134, '2015-02-01 00:28:07.000000', 'consum', 0.0287, 'lps'),
	(676990, 134, '2015-02-01 00:28:08.000000', 'consum', 0.0219, 'lps'),
	(676991, 134, '2015-02-01 00:28:09.000000', 'consum', 0.0231, 'lps'),
	(676992, 134, '2015-02-01 00:28:10.000000', 'consum', 0.0288, 'lps'),
	(676993, 134, '2015-02-01 00:28:11.000000', 'consum', 0.0227, 'lps'),
	(676994, 134, '2015-02-01 00:28:12.000000', 'consum', 0.0270, 'lps'),
	(676995, 134, '2015-02-01 00:28:13.000000', 'consum', 0.0254, 'lps'),
	(676996, 134, '2015-02-01 00:28:14.000000', 'consum', 0.0250, 'lps'),
	(676997, 134, '2015-02-01 00:28:15.000000', 'consum', 0.0277, 'lps'),
	(676998, 134, '2015-02-01 00:28:16.000000', 'consum', 0.0218, 'lps'),
	(676999, 134, '2015-02-01 00:28:17.000000', 'consum', 0.0258, 'lps'),
	(677000, 134, '2015-02-01 00:28:18.000000', 'consum', 0.0218, 'lps'),
	(677001, 134, '2015-02-01 00:28:19.000000', 'consum', 0.0212, 'lps'),
	(677002, 134, '2015-02-01 00:28:20.000000', 'consum', 0.0298, 'lps'),
	(677003, 134, '2015-02-01 00:28:21.000000', 'consum', 0.0233, 'lps'),
	(677004, 134, '2015-02-01 00:28:22.000000', 'consum', 0.0267, 'lps'),
	(677005, 134, '2015-02-01 00:28:23.000000', 'consum', 0.0223, 'lps'),
	(677006, 134, '2015-02-01 00:28:24.000000', 'consum', 0.0308, 'lps'),
	(677007, 134, '2015-02-01 00:28:25.000000', 'consum', 0.0250, 'lps'),
	(677008, 134, '2015-02-01 00:28:26.000000', 'consum', 0.0218, 'lps'),
	(677009, 134, '2015-02-01 00:28:27.000000', 'consum', 0.0233, 'lps'),
	(677010, 134, '2015-02-01 00:28:28.000000', 'consum', 0.0303, 'lps'),
	(677011, 134, '2015-02-01 00:28:29.000000', 'consum', 0.0299, 'lps'),
	(677012, 134, '2015-02-01 00:28:30.000000', 'consum', 0.0271, 'lps'),
	(677013, 134, '2015-02-01 00:28:31.000000', 'consum', 0.0248, 'lps'),
	(677014, 134, '2015-02-01 00:28:32.000000', 'consum', 0.0219, 'lps'),
	(677015, 134, '2015-02-01 00:28:33.000000', 'consum', 0.0244, 'lps'),
	(677016, 134, '2015-02-01 00:28:34.000000', 'consum', 0.0251, 'lps'),
	(677017, 134, '2015-02-01 00:28:35.000000', 'consum', 0.0211, 'lps'),
	(677018, 134, '2015-02-01 00:28:36.000000', 'consum', 0.0300, 'lps'),
	(677019, 134, '2015-02-01 00:28:37.000000', 'consum', 0.0244, 'lps'),
	(677020, 134, '2015-02-01 00:28:38.000000', 'consum', 0.0216, 'lps'),
	(677021, 134, '2015-02-01 00:28:39.000000', 'consum', 0.0238, 'lps'),
	(677022, 134, '2015-02-01 00:28:40.000000', 'consum', 0.0230, 'lps'),
	(677023, 134, '2015-02-01 00:28:41.000000', 'consum', 0.0228, 'lps'),
	(677024, 134, '2015-02-01 00:28:42.000000', 'consum', 0.0239, 'lps'),
	(677025, 134, '2015-02-01 00:28:43.000000', 'consum', 0.0301, 'lps'),
	(677026, 134, '2015-02-01 00:28:44.000000', 'consum', 0.0269, 'lps'),
	(677027, 134, '2015-02-01 00:28:45.000000', 'consum', 0.0234, 'lps'),
	(677028, 134, '2015-02-01 00:28:46.000000', 'consum', 0.0255, 'lps'),
	(677029, 134, '2015-02-01 00:28:47.000000', 'consum', 0.0260, 'lps'),
	(677030, 134, '2015-02-01 00:28:48.000000', 'consum', 0.0222, 'lps'),
	(677031, 134, '2015-02-01 00:28:49.000000', 'consum', 0.0225, 'lps'),
	(677032, 134, '2015-02-01 00:28:50.000000', 'consum', 0.0251, 'lps'),
	(677033, 134, '2015-02-01 00:28:51.000000', 'consum', 0.0267, 'lps'),
	(677034, 134, '2015-02-01 00:28:52.000000', 'consum', 0.0268, 'lps'),
	(677035, 134, '2015-02-01 00:28:53.000000', 'consum', 0.0229, 'lps'),
	(677036, 134, '2015-02-01 00:28:54.000000', 'consum', 0.0232, 'lps'),
	(677037, 134, '2015-02-01 00:28:55.000000', 'consum', 0.0265, 'lps'),
	(677038, 134, '2015-02-01 00:28:56.000000', 'consum', 0.0214, 'lps'),
	(677039, 134, '2015-02-01 00:28:57.000000', 'consum', 0.0270, 'lps'),
	(677040, 134, '2015-02-01 00:28:58.000000', 'consum', 0.0293, 'lps'),
	(677041, 134, '2015-02-01 00:28:59.000000', 'consum', 0.0238, 'lps'),
	(677042, 134, '2015-02-01 00:29:00.000000', 'consum', 0.0308, 'lps'),
	(677043, 134, '2015-02-01 00:29:01.000000', 'consum', 0.0307, 'lps'),
	(677044, 134, '2015-02-01 00:29:02.000000', 'consum', 0.0300, 'lps'),
	(677045, 134, '2015-02-01 00:29:03.000000', 'consum', 0.0266, 'lps'),
	(677046, 134, '2015-02-01 00:29:04.000000', 'consum', 0.0218, 'lps'),
	(677047, 134, '2015-02-01 00:29:05.000000', 'consum', 0.0292, 'lps'),
	(677048, 134, '2015-02-01 00:29:06.000000', 'consum', 0.0285, 'lps'),
	(677049, 134, '2015-02-01 00:29:07.000000', 'consum', 0.0239, 'lps'),
	(677050, 134, '2015-02-01 00:29:08.000000', 'consum', 0.0232, 'lps'),
	(677051, 134, '2015-02-01 00:29:09.000000', 'consum', 0.0232, 'lps'),
	(677052, 134, '2015-02-01 00:29:10.000000', 'consum', 0.0257, 'lps'),
	(677053, 134, '2015-02-01 00:29:11.000000', 'consum', 0.0275, 'lps'),
	(677054, 134, '2015-02-01 00:29:12.000000', 'consum', 0.0292, 'lps'),
	(677055, 134, '2015-02-01 00:29:13.000000', 'consum', 0.0221, 'lps'),
	(677056, 134, '2015-02-01 00:29:14.000000', 'consum', 0.0225, 'lps'),
	(677057, 134, '2015-02-01 00:29:15.000000', 'consum', 0.0251, 'lps'),
	(677058, 134, '2015-02-01 00:29:16.000000', 'consum', 0.0269, 'lps'),
	(677059, 134, '2015-02-01 00:29:17.000000', 'consum', 0.0278, 'lps'),
	(677060, 134, '2015-02-01 00:29:18.000000', 'consum', 0.0269, 'lps'),
	(677061, 134, '2015-02-01 00:29:19.000000', 'consum', 0.0304, 'lps'),
	(677062, 134, '2015-02-01 00:29:20.000000', 'consum', 0.0299, 'lps'),
	(677063, 134, '2015-02-01 00:29:21.000000', 'consum', 0.0269, 'lps'),
	(677064, 134, '2015-02-01 00:29:22.000000', 'consum', 0.0237, 'lps'),
	(677065, 134, '2015-02-01 00:29:23.000000', 'consum', 0.0273, 'lps'),
	(677066, 134, '2015-02-01 00:29:24.000000', 'consum', 0.0239, 'lps'),
	(677067, 134, '2015-02-01 00:29:25.000000', 'consum', 0.0271, 'lps'),
	(677068, 134, '2015-02-01 00:29:26.000000', 'consum', 0.0220, 'lps'),
	(677069, 134, '2015-02-01 00:29:27.000000', 'consum', 0.0285, 'lps'),
	(677070, 134, '2015-02-01 00:29:28.000000', 'consum', 0.0246, 'lps'),
	(677071, 134, '2015-02-01 00:29:29.000000', 'consum', 0.0266, 'lps'),
	(677072, 134, '2015-02-01 00:29:30.000000', 'consum', 0.0283, 'lps'),
	(677073, 134, '2015-02-01 00:29:31.000000', 'consum', 0.0303, 'lps'),
	(677074, 134, '2015-02-01 00:29:32.000000', 'consum', 0.0249, 'lps'),
	(677075, 134, '2015-02-01 00:29:33.000000', 'consum', 0.0230, 'lps'),
	(677076, 134, '2015-02-01 00:29:34.000000', 'consum', 0.0296, 'lps'),
	(677077, 134, '2015-02-01 00:29:35.000000', 'consum', 0.0274, 'lps'),
	(677078, 134, '2015-02-01 00:29:36.000000', 'consum', 0.0271, 'lps'),
	(677079, 134, '2015-02-01 00:29:37.000000', 'consum', 0.0219, 'lps'),
	(677080, 134, '2015-02-01 00:29:38.000000', 'consum', 0.0281, 'lps'),
	(677081, 134, '2015-02-01 00:29:39.000000', 'consum', 0.0230, 'lps'),
	(677082, 134, '2015-02-01 00:29:40.000000', 'consum', 0.0304, 'lps'),
	(677083, 134, '2015-02-01 00:29:41.000000', 'consum', 0.0309, 'lps'),
	(677084, 134, '2015-02-01 00:29:42.000000', 'consum', 0.0218, 'lps'),
	(677085, 134, '2015-02-01 00:29:43.000000', 'consum', 0.0264, 'lps'),
	(677086, 134, '2015-02-01 00:29:44.000000', 'consum', 0.0252, 'lps'),
	(677087, 134, '2015-02-01 00:29:45.000000', 'consum', 0.0256, 'lps'),
	(677088, 134, '2015-02-01 00:29:46.000000', 'consum', 0.0210, 'lps'),
	(677089, 134, '2015-02-01 00:29:47.000000', 'consum', 0.0280, 'lps'),
	(677090, 134, '2015-02-01 00:29:48.000000', 'consum', 0.0252, 'lps'),
	(677091, 134, '2015-02-01 00:29:49.000000', 'consum', 0.0211, 'lps'),
	(677092, 134, '2015-02-01 00:29:50.000000', 'consum', 0.0297, 'lps'),
	(677093, 134, '2015-02-01 00:29:51.000000', 'consum', 0.0229, 'lps'),
	(677094, 134, '2015-02-01 00:29:52.000000', 'consum', 0.0251, 'lps'),
	(677095, 134, '2015-02-01 00:29:53.000000', 'consum', 0.0257, 'lps'),
	(677096, 134, '2015-02-01 00:29:54.000000', 'consum', 0.0217, 'lps'),
	(677097, 134, '2015-02-01 00:29:55.000000', 'consum', 0.0312, 'lps'),
	(677098, 134, '2015-02-01 00:29:56.000000', 'consum', 0.0288, 'lps'),
	(677099, 134, '2015-02-01 00:29:57.000000', 'consum', 0.0294, 'lps'),
	(677100, 134, '2015-02-01 00:29:58.000000', 'consum', 0.0295, 'lps'),
	(677101, 134, '2015-02-01 00:29:59.000000', 'consum', 0.0279, 'lps'),
	(677102, 134, '2015-02-01 00:30:00.000000', 'consum', 0.0300, 'lps'),
	(677103, 134, '2015-02-01 00:30:01.000000', 'consum', 0.0248, 'lps'),
	(677104, 134, '2015-02-01 00:30:02.000000', 'consum', 0.0234, 'lps'),
	(677105, 134, '2015-02-01 00:30:03.000000', 'consum', 0.0216, 'lps'),
	(677106, 134, '2015-02-01 00:30:04.000000', 'consum', 0.0272, 'lps'),
	(677107, 134, '2015-02-01 00:30:05.000000', 'consum', 0.0298, 'lps'),
	(677108, 134, '2015-02-01 00:30:06.000000', 'consum', 0.0258, 'lps'),
	(677109, 134, '2015-02-01 00:30:07.000000', 'consum', 0.0290, 'lps'),
	(677110, 134, '2015-02-01 00:30:08.000000', 'consum', 0.0261, 'lps'),
	(677111, 134, '2015-02-01 00:30:09.000000', 'consum', 0.0224, 'lps'),
	(677112, 134, '2015-02-01 00:30:10.000000', 'consum', 0.0230, 'lps'),
	(677113, 134, '2015-02-01 00:30:11.000000', 'consum', 0.0269, 'lps'),
	(677114, 134, '2015-02-01 00:30:12.000000', 'consum', 0.0240, 'lps'),
	(677115, 134, '2015-02-01 00:30:13.000000', 'consum', 0.0288, 'lps'),
	(677116, 134, '2015-02-01 00:30:14.000000', 'consum', 0.0301, 'lps'),
	(677117, 134, '2015-02-01 00:30:15.000000', 'consum', 0.0228, 'lps'),
	(677118, 134, '2015-02-01 00:30:16.000000', 'consum', 0.0234, 'lps'),
	(677119, 134, '2015-02-01 00:30:17.000000', 'consum', 0.0277, 'lps'),
	(677120, 134, '2015-02-01 00:30:18.000000', 'consum', 0.0268, 'lps'),
	(677121, 134, '2015-02-01 00:30:19.000000', 'consum', 0.0299, 'lps'),
	(677122, 134, '2015-02-01 00:30:20.000000', 'consum', 0.0273, 'lps'),
	(677123, 134, '2015-02-01 00:30:21.000000', 'consum', 0.0262, 'lps'),
	(677124, 134, '2015-02-01 00:30:22.000000', 'consum', 0.0278, 'lps'),
	(677125, 134, '2015-02-01 00:30:23.000000', 'consum', 0.0295, 'lps'),
	(677126, 134, '2015-02-01 00:30:24.000000', 'consum', 0.0225, 'lps'),
	(677127, 134, '2015-02-01 00:30:25.000000', 'consum', 0.0234, 'lps'),
	(677128, 134, '2015-02-01 00:30:26.000000', 'consum', 0.0286, 'lps'),
	(677129, 134, '2015-02-01 00:30:27.000000', 'consum', 0.0210, 'lps'),
	(677130, 134, '2015-02-01 00:30:28.000000', 'consum', 0.0292, 'lps'),
	(677131, 134, '2015-02-01 00:30:29.000000', 'consum', 0.0210, 'lps'),
	(677132, 134, '2015-02-01 00:30:30.000000', 'consum', 0.0272, 'lps'),
	(677133, 134, '2015-02-01 00:30:31.000000', 'consum', 0.0210, 'lps'),
	(677134, 134, '2015-02-01 00:30:32.000000', 'consum', 0.0232, 'lps'),
	(677135, 134, '2015-02-01 00:30:33.000000', 'consum', 0.0218, 'lps'),
	(677136, 134, '2015-02-01 00:30:34.000000', 'consum', 0.0286, 'lps'),
	(677137, 134, '2015-02-01 00:30:35.000000', 'consum', 0.0259, 'lps'),
	(677138, 134, '2015-02-01 00:30:36.000000', 'consum', 0.0229, 'lps'),
	(677139, 134, '2015-02-01 00:30:37.000000', 'consum', 0.0258, 'lps'),
	(677140, 134, '2015-02-01 00:30:38.000000', 'consum', 0.0292, 'lps'),
	(677141, 134, '2015-02-01 00:30:39.000000', 'consum', 0.0272, 'lps'),
	(677142, 134, '2015-02-01 00:30:40.000000', 'consum', 0.0276, 'lps'),
	(677143, 134, '2015-02-01 00:30:41.000000', 'consum', 0.0248, 'lps'),
	(677144, 134, '2015-02-01 00:30:42.000000', 'consum', 0.0305, 'lps'),
	(677145, 134, '2015-02-01 00:30:43.000000', 'consum', 0.0263, 'lps'),
	(677146, 134, '2015-02-01 00:30:44.000000', 'consum', 0.0296, 'lps'),
	(677147, 134, '2015-02-01 00:30:45.000000', 'consum', 0.0274, 'lps'),
	(677148, 134, '2015-02-01 00:30:46.000000', 'consum', 0.0271, 'lps'),
	(677149, 134, '2015-02-01 00:30:47.000000', 'consum', 0.0223, 'lps'),
	(677150, 134, '2015-02-01 00:30:48.000000', 'consum', 0.0299, 'lps'),
	(677151, 134, '2015-02-01 00:30:49.000000', 'consum', 0.0308, 'lps'),
	(677152, 134, '2015-02-01 00:30:50.000000', 'consum', 0.0228, 'lps'),
	(677153, 134, '2015-02-01 00:30:51.000000', 'consum', 0.0212, 'lps'),
	(677154, 134, '2015-02-01 00:30:52.000000', 'consum', 0.0269, 'lps'),
	(677155, 134, '2015-02-01 00:30:53.000000', 'consum', 0.0293, 'lps'),
	(677156, 134, '2015-02-01 00:30:54.000000', 'consum', 0.0242, 'lps'),
	(677157, 134, '2015-02-01 00:30:55.000000', 'consum', 0.0224, 'lps'),
	(677158, 134, '2015-02-01 00:30:56.000000', 'consum', 0.0288, 'lps'),
	(677159, 134, '2015-02-01 00:30:57.000000', 'consum', 0.0251, 'lps'),
	(677160, 134, '2015-02-01 00:30:58.000000', 'consum', 0.0285, 'lps'),
	(677161, 134, '2015-02-01 00:30:59.000000', 'consum', 0.0255, 'lps'),
	(677162, 134, '2015-02-01 00:31:00.000000', 'consum', 0.0211, 'lps'),
	(677163, 134, '2015-02-01 00:31:01.000000', 'consum', 0.0287, 'lps'),
	(677164, 134, '2015-02-01 00:31:02.000000', 'consum', 0.0282, 'lps'),
	(677165, 134, '2015-02-01 00:31:03.000000', 'consum', 0.0238, 'lps'),
	(677166, 134, '2015-02-01 00:31:04.000000', 'consum', 0.0236, 'lps'),
	(677167, 134, '2015-02-01 00:31:05.000000', 'consum', 0.0256, 'lps'),
	(677168, 134, '2015-02-01 00:31:06.000000', 'consum', 0.0262, 'lps'),
	(677169, 134, '2015-02-01 00:31:07.000000', 'consum', 0.0229, 'lps'),
	(677170, 134, '2015-02-01 00:31:08.000000', 'consum', 0.0251, 'lps'),
	(677171, 134, '2015-02-01 00:31:09.000000', 'consum', 0.0255, 'lps'),
	(677172, 134, '2015-02-01 00:31:10.000000', 'consum', 0.0212, 'lps'),
	(677173, 134, '2015-02-01 00:31:11.000000', 'consum', 0.0289, 'lps'),
	(677174, 134, '2015-02-01 00:31:12.000000', 'consum', 0.0292, 'lps'),
	(677175, 134, '2015-02-01 00:31:13.000000', 'consum', 0.0279, 'lps'),
	(677176, 134, '2015-02-01 00:31:14.000000', 'consum', 0.0309, 'lps'),
	(677177, 134, '2015-02-01 00:31:15.000000', 'consum', 0.0292, 'lps'),
	(677178, 134, '2015-02-01 00:31:16.000000', 'consum', 0.0223, 'lps'),
	(677179, 134, '2015-02-01 00:31:17.000000', 'consum', 0.0234, 'lps'),
	(677180, 134, '2015-02-01 00:31:18.000000', 'consum', 0.0291, 'lps'),
	(677181, 134, '2015-02-01 00:31:19.000000', 'consum', 0.0236, 'lps'),
	(677182, 134, '2015-02-01 00:31:20.000000', 'consum', 0.0305, 'lps'),
	(677183, 134, '2015-02-01 00:31:21.000000', 'consum', 0.0297, 'lps'),
	(677184, 134, '2015-02-01 00:31:22.000000', 'consum', 0.0257, 'lps'),
	(677185, 134, '2015-02-01 00:31:23.000000', 'consum', 0.0287, 'lps'),
	(677186, 134, '2015-02-01 00:31:24.000000', 'consum', 0.0247, 'lps'),
	(677187, 134, '2015-02-01 00:31:25.000000', 'consum', 0.0269, 'lps'),
	(677188, 134, '2015-02-01 00:31:26.000000', 'consum', 0.0292, 'lps'),
	(677189, 134, '2015-02-01 00:31:27.000000', 'consum', 0.0237, 'lps'),
	(677190, 134, '2015-02-01 00:31:28.000000', 'consum', 0.0305, 'lps'),
	(677191, 134, '2015-02-01 00:31:29.000000', 'consum', 0.0298, 'lps'),
	(677192, 134, '2015-02-01 00:31:30.000000', 'consum', 0.0261, 'lps'),
	(677193, 134, '2015-02-01 00:31:31.000000', 'consum', 0.0303, 'lps'),
	(677194, 134, '2015-02-01 00:31:32.000000', 'consum', 0.0215, 'lps'),
	(677195, 134, '2015-02-01 00:31:33.000000', 'consum', 0.0266, 'lps'),
	(677196, 134, '2015-02-01 00:31:34.000000', 'consum', 0.0271, 'lps'),
	(677197, 134, '2015-02-01 00:31:35.000000', 'consum', 0.0243, 'lps'),
	(677198, 134, '2015-02-01 00:31:36.000000', 'consum', 0.0294, 'lps'),
	(677199, 134, '2015-02-01 00:31:37.000000', 'consum', 0.0224, 'lps'),
	(677200, 134, '2015-02-01 00:31:38.000000', 'consum', 0.0235, 'lps'),
	(677201, 134, '2015-02-01 00:31:39.000000', 'consum', 0.0295, 'lps'),
	(677202, 134, '2015-02-01 00:31:40.000000', 'consum', 0.0249, 'lps'),
	(677203, 134, '2015-02-01 00:31:41.000000', 'consum', 0.0255, 'lps'),
	(677204, 134, '2015-02-01 00:31:42.000000', 'consum', 0.0216, 'lps'),
	(677205, 134, '2015-02-01 00:31:43.000000', 'consum', 0.0309, 'lps'),
	(677206, 134, '2015-02-01 00:31:44.000000', 'consum', 0.0277, 'lps'),
	(677207, 134, '2015-02-01 00:31:45.000000', 'consum', 0.0248, 'lps'),
	(677208, 134, '2015-02-01 00:31:46.000000', 'consum', 0.0301, 'lps'),
	(677209, 134, '2015-02-01 00:31:47.000000', 'consum', 0.0243, 'lps'),
	(677210, 134, '2015-02-01 00:31:48.000000', 'consum', 0.0311, 'lps'),
	(677211, 134, '2015-02-01 00:31:49.000000', 'consum', 0.0306, 'lps'),
	(677212, 134, '2015-02-01 00:31:50.000000', 'consum', 0.0285, 'lps'),
	(677213, 134, '2015-02-01 00:31:51.000000', 'consum', 0.0297, 'lps'),
	(677214, 134, '2015-02-01 00:31:52.000000', 'consum', 0.0215, 'lps'),
	(677215, 134, '2015-02-01 00:31:53.000000', 'consum', 0.0282, 'lps'),
	(677216, 134, '2015-02-01 00:31:54.000000', 'consum', 0.0247, 'lps'),
	(677217, 134, '2015-02-01 00:31:55.000000', 'consum', 0.0281, 'lps'),
	(677218, 134, '2015-02-01 00:31:56.000000', 'consum', 0.0249, 'lps'),
	(677219, 134, '2015-02-01 00:31:57.000000', 'consum', 0.0296, 'lps'),
	(677220, 134, '2015-02-01 00:31:58.000000', 'consum', 0.0214, 'lps'),
	(677221, 134, '2015-02-01 00:31:59.000000', 'consum', 0.0283, 'lps'),
	(677222, 134, '2015-02-01 00:32:00.000000', 'consum', 0.0256, 'lps'),
	(677223, 134, '2015-02-01 00:32:01.000000', 'consum', 0.0218, 'lps'),
	(677224, 134, '2015-02-01 00:32:02.000000', 'consum', 0.0217, 'lps'),
	(677225, 134, '2015-02-01 00:32:03.000000', 'consum', 0.0220, 'lps'),
	(677226, 134, '2015-02-01 00:32:04.000000', 'consum', 0.0240, 'lps'),
	(677227, 134, '2015-02-01 00:32:05.000000', 'consum', 0.0227, 'lps'),
	(677228, 134, '2015-02-01 00:32:06.000000', 'consum', 0.0311, 'lps'),
	(677229, 134, '2015-02-01 00:32:07.000000', 'consum', 0.0252, 'lps'),
	(677230, 134, '2015-02-01 00:32:08.000000', 'consum', 0.0219, 'lps'),
	(677231, 134, '2015-02-01 00:32:09.000000', 'consum', 0.0232, 'lps'),
	(677232, 134, '2015-02-01 00:32:10.000000', 'consum', 0.0295, 'lps'),
	(677233, 134, '2015-02-01 00:32:11.000000', 'consum', 0.0260, 'lps'),
	(677234, 134, '2015-02-01 00:32:12.000000', 'consum', 0.0308, 'lps'),
	(677235, 134, '2015-02-01 00:32:13.000000', 'consum', 0.0242, 'lps'),
	(677236, 134, '2015-02-01 00:32:14.000000', 'consum', 0.0281, 'lps'),
	(677237, 134, '2015-02-01 00:32:15.000000', 'consum', 0.0263, 'lps'),
	(677238, 134, '2015-02-01 00:32:16.000000', 'consum', 0.0264, 'lps'),
	(677239, 134, '2015-02-01 00:32:17.000000', 'consum', 0.0219, 'lps'),
	(677240, 134, '2015-02-01 00:32:18.000000', 'consum', 0.0298, 'lps'),
	(677241, 134, '2015-02-01 00:32:19.000000', 'consum', 0.0213, 'lps'),
	(677242, 134, '2015-02-01 00:32:20.000000', 'consum', 0.0270, 'lps'),
	(677243, 134, '2015-02-01 00:32:21.000000', 'consum', 0.0294, 'lps'),
	(677244, 134, '2015-02-01 00:32:22.000000', 'consum', 0.0246, 'lps'),
	(677245, 134, '2015-02-01 00:32:23.000000', 'consum', 0.0241, 'lps'),
	(677246, 134, '2015-02-01 00:32:24.000000', 'consum', 0.0257, 'lps'),
	(677247, 134, '2015-02-01 00:32:25.000000', 'consum', 0.0252, 'lps'),
	(677248, 134, '2015-02-01 00:32:26.000000', 'consum', 0.0277, 'lps'),
	(677249, 134, '2015-02-01 00:32:27.000000', 'consum', 0.0213, 'lps'),
	(677250, 134, '2015-02-01 00:32:28.000000', 'consum', 0.0233, 'lps'),
	(677251, 134, '2015-02-01 00:32:29.000000', 'consum', 0.0213, 'lps'),
	(677252, 134, '2015-02-01 00:32:30.000000', 'consum', 0.0260, 'lps'),
	(677253, 134, '2015-02-01 00:32:31.000000', 'consum', 0.0245, 'lps'),
	(677254, 134, '2015-02-01 00:32:32.000000', 'consum', 0.0235, 'lps'),
	(677255, 134, '2015-02-01 00:32:33.000000', 'consum', 0.0229, 'lps'),
	(677256, 134, '2015-02-01 00:32:34.000000', 'consum', 0.0234, 'lps'),
	(677257, 134, '2015-02-01 00:32:35.000000', 'consum', 0.0271, 'lps'),
	(677258, 134, '2015-02-01 00:32:36.000000', 'consum', 0.0238, 'lps'),
	(677259, 134, '2015-02-01 00:32:37.000000', 'consum', 0.0270, 'lps'),
	(677260, 134, '2015-02-01 00:32:38.000000', 'consum', 0.0221, 'lps'),
	(677261, 134, '2015-02-01 00:32:39.000000', 'consum', 0.0290, 'lps'),
	(677262, 134, '2015-02-01 00:32:40.000000', 'consum', 0.0270, 'lps'),
	(677263, 134, '2015-02-01 00:32:41.000000', 'consum', 0.0272, 'lps'),
	(677264, 134, '2015-02-01 00:32:42.000000', 'consum', 0.0236, 'lps'),
	(677265, 134, '2015-02-01 00:32:43.000000', 'consum', 0.0256, 'lps'),
	(677266, 134, '2015-02-01 00:32:44.000000', 'consum', 0.0260, 'lps'),
	(677267, 134, '2015-02-01 00:32:45.000000', 'consum', 0.0219, 'lps'),
	(677268, 134, '2015-02-01 00:32:46.000000', 'consum', 0.0211, 'lps'),
	(677269, 134, '2015-02-01 00:32:47.000000', 'consum', 0.0289, 'lps'),
	(677270, 134, '2015-02-01 00:32:48.000000', 'consum', 0.0293, 'lps'),
	(677271, 134, '2015-02-01 00:32:49.000000', 'consum', 0.0287, 'lps'),
	(677272, 134, '2015-02-01 00:32:50.000000', 'consum', 0.0242, 'lps'),
	(677273, 134, '2015-02-01 00:32:51.000000', 'consum', 0.0242, 'lps'),
	(677274, 134, '2015-02-01 00:32:52.000000', 'consum', 0.0277, 'lps'),
	(677275, 134, '2015-02-01 00:32:53.000000', 'consum', 0.0243, 'lps'),
	(677276, 134, '2015-02-01 00:32:54.000000', 'consum', 0.0277, 'lps'),
	(677277, 134, '2015-02-01 00:32:55.000000', 'consum', 0.0239, 'lps'),
	(677278, 134, '2015-02-01 00:32:56.000000', 'consum', 0.0260, 'lps'),
	(677279, 134, '2015-02-01 00:32:57.000000', 'consum', 0.0269, 'lps'),
	(677280, 134, '2015-02-01 00:32:58.000000', 'consum', 0.0254, 'lps'),
	(677281, 134, '2015-02-01 00:32:59.000000', 'consum', 0.0251, 'lps'),
	(677282, 134, '2015-02-01 00:33:00.000000', 'consum', 0.0287, 'lps'),
	(677283, 134, '2015-02-01 00:33:01.000000', 'consum', 0.0264, 'lps'),
	(677284, 134, '2015-02-01 00:33:02.000000', 'consum', 0.0249, 'lps'),
	(677285, 134, '2015-02-01 00:33:03.000000', 'consum', 0.0245, 'lps'),
	(677286, 134, '2015-02-01 00:33:04.000000', 'consum', 0.0269, 'lps'),
	(677287, 134, '2015-02-01 00:33:05.000000', 'consum', 0.0297, 'lps'),
	(677288, 134, '2015-02-01 00:33:06.000000', 'consum', 0.0260, 'lps'),
	(677289, 134, '2015-02-01 00:33:07.000000', 'consum', 0.0305, 'lps'),
	(677290, 134, '2015-02-01 00:33:08.000000', 'consum', 0.0227, 'lps'),
	(677291, 134, '2015-02-01 00:33:09.000000', 'consum', 0.0217, 'lps'),
	(677292, 134, '2015-02-01 00:33:10.000000', 'consum', 0.0295, 'lps'),
	(677293, 134, '2015-02-01 00:33:11.000000', 'consum', 0.0307, 'lps'),
	(677294, 134, '2015-02-01 00:33:12.000000', 'consum', 0.0234, 'lps'),
	(677295, 134, '2015-02-01 00:33:13.000000', 'consum', 0.0245, 'lps'),
	(677296, 134, '2015-02-01 00:33:14.000000', 'consum', 0.0213, 'lps'),
	(677297, 134, '2015-02-01 00:33:15.000000', 'consum', 0.0220, 'lps'),
	(677298, 134, '2015-02-01 00:33:16.000000', 'consum', 0.0253, 'lps'),
	(677299, 134, '2015-02-01 00:33:17.000000', 'consum', 0.0292, 'lps'),
	(677300, 134, '2015-02-01 00:33:18.000000', 'consum', 0.0287, 'lps'),
	(677301, 134, '2015-02-01 00:33:19.000000', 'consum', 0.0247, 'lps'),
	(677302, 134, '2015-02-01 00:33:20.000000', 'consum', 0.0266, 'lps'),
	(677303, 134, '2015-02-01 00:33:21.000000', 'consum', 0.0276, 'lps'),
	(677304, 134, '2015-02-01 00:33:22.000000', 'consum', 0.0269, 'lps'),
	(677305, 134, '2015-02-01 00:33:23.000000', 'consum', 0.0309, 'lps'),
	(677306, 134, '2015-02-01 00:33:24.000000', 'consum', 0.0221, 'lps'),
	(677307, 134, '2015-02-01 00:33:25.000000', 'consum', 0.0275, 'lps'),
	(677308, 134, '2015-02-01 00:33:26.000000', 'consum', 0.0299, 'lps'),
	(677309, 134, '2015-02-01 00:33:27.000000', 'consum', 0.0255, 'lps'),
	(677310, 134, '2015-02-01 00:33:28.000000', 'consum', 0.0269, 'lps'),
	(677311, 134, '2015-02-01 00:33:29.000000', 'consum', 0.0267, 'lps'),
	(677312, 134, '2015-02-01 00:33:30.000000', 'consum', 0.0217, 'lps'),
	(677313, 134, '2015-02-01 00:33:31.000000', 'consum', 0.0280, 'lps'),
	(677314, 134, '2015-02-01 00:33:32.000000', 'consum', 0.0231, 'lps'),
	(677315, 134, '2015-02-01 00:33:33.000000', 'consum', 0.0310, 'lps'),
	(677316, 134, '2015-02-01 00:33:34.000000', 'consum', 0.0238, 'lps'),
	(677317, 134, '2015-02-01 00:33:35.000000', 'consum', 0.0255, 'lps'),
	(677318, 134, '2015-02-01 00:33:36.000000', 'consum', 0.0250, 'lps'),
	(677319, 134, '2015-02-01 00:33:37.000000', 'consum', 0.0276, 'lps'),
	(677320, 134, '2015-02-01 00:33:38.000000', 'consum', 0.0212, 'lps'),
	(677321, 134, '2015-02-01 00:33:39.000000', 'consum', 0.0229, 'lps'),
	(677322, 134, '2015-02-01 00:33:40.000000', 'consum', 0.0302, 'lps'),
	(677323, 134, '2015-02-01 00:33:41.000000', 'consum', 0.0303, 'lps'),
	(677324, 134, '2015-02-01 00:33:42.000000', 'consum', 0.0294, 'lps'),
	(677325, 134, '2015-02-01 00:33:43.000000', 'consum', 0.0252, 'lps'),
	(677326, 134, '2015-02-01 00:33:44.000000', 'consum', 0.0271, 'lps'),
	(677327, 134, '2015-02-01 00:33:45.000000', 'consum', 0.0287, 'lps'),
	(677328, 134, '2015-02-01 00:33:46.000000', 'consum', 0.0309, 'lps'),
	(677329, 134, '2015-02-01 00:33:47.000000', 'consum', 0.0268, 'lps'),
	(677330, 134, '2015-02-01 00:33:48.000000', 'consum', 0.0306, 'lps'),
	(677331, 134, '2015-02-01 00:33:49.000000', 'consum', 0.0311, 'lps'),
	(677332, 134, '2015-02-01 00:33:50.000000', 'consum', 0.0223, 'lps'),
	(677333, 134, '2015-02-01 00:33:51.000000', 'consum', 0.0278, 'lps'),
	(677334, 134, '2015-02-01 00:33:52.000000', 'consum', 0.0309, 'lps'),
	(677335, 134, '2015-02-01 00:33:53.000000', 'consum', 0.0295, 'lps'),
	(677336, 134, '2015-02-01 00:33:54.000000', 'consum', 0.0236, 'lps'),
	(677337, 134, '2015-02-01 00:33:55.000000', 'consum', 0.0291, 'lps'),
	(677338, 134, '2015-02-01 00:33:56.000000', 'consum', 0.0230, 'lps'),
	(677339, 134, '2015-02-01 00:33:57.000000', 'consum', 0.0274, 'lps'),
	(677340, 134, '2015-02-01 00:33:58.000000', 'consum', 0.0264, 'lps'),
	(677341, 134, '2015-02-01 00:33:59.000000', 'consum', 0.0289, 'lps'),
	(677342, 134, '2015-02-01 00:34:00.000000', 'consum', 0.0235, 'lps'),
	(677343, 134, '2015-02-01 00:34:01.000000', 'consum', 0.0305, 'lps'),
	(677344, 134, '2015-02-01 00:34:02.000000', 'consum', 0.0301, 'lps'),
	(677345, 134, '2015-02-01 00:34:03.000000', 'consum', 0.0277, 'lps'),
	(677346, 134, '2015-02-01 00:34:04.000000', 'consum', 0.0272, 'lps'),
	(677347, 134, '2015-02-01 00:34:05.000000', 'consum', 0.0218, 'lps'),
	(677348, 134, '2015-02-01 00:34:06.000000', 'consum', 0.0270, 'lps'),
	(677349, 134, '2015-02-01 00:34:07.000000', 'consum', 0.0281, 'lps'),
	(677350, 134, '2015-02-01 00:34:08.000000', 'consum', 0.0281, 'lps'),
	(677351, 134, '2015-02-01 00:34:09.000000', 'consum', 0.0250, 'lps'),
	(677352, 134, '2015-02-01 00:34:10.000000', 'consum', 0.0302, 'lps'),
	(677353, 134, '2015-02-01 00:34:11.000000', 'consum', 0.0242, 'lps'),
	(677354, 134, '2015-02-01 00:34:12.000000', 'consum', 0.0298, 'lps'),
	(677355, 134, '2015-02-01 00:34:13.000000', 'consum', 0.0245, 'lps'),
	(677356, 134, '2015-02-01 00:34:14.000000', 'consum', 0.0224, 'lps'),
	(677357, 134, '2015-02-01 00:34:15.000000', 'consum', 0.0278, 'lps'),
	(677358, 134, '2015-02-01 00:34:16.000000', 'consum', 0.0302, 'lps'),
	(677359, 134, '2015-02-01 00:34:17.000000', 'consum', 0.0263, 'lps'),
	(677360, 134, '2015-02-01 00:34:18.000000', 'consum', 0.0300, 'lps'),
	(677361, 134, '2015-02-01 00:34:19.000000', 'consum', 0.0296, 'lps'),
	(677362, 134, '2015-02-01 00:34:20.000000', 'consum', 0.0270, 'lps'),
	(677363, 134, '2015-02-01 00:34:21.000000', 'consum', 0.0251, 'lps'),
	(677364, 134, '2015-02-01 00:34:22.000000', 'consum', 0.0233, 'lps'),
	(677365, 134, '2015-02-01 00:34:23.000000', 'consum', 0.0309, 'lps'),
	(677366, 134, '2015-02-01 00:34:24.000000', 'consum', 0.0223, 'lps'),
	(677367, 134, '2015-02-01 00:34:25.000000', 'consum', 0.0289, 'lps'),
	(677368, 134, '2015-02-01 00:34:26.000000', 'consum', 0.0258, 'lps'),
	(677369, 134, '2015-02-01 00:34:27.000000', 'consum', 0.0213, 'lps'),
	(677370, 134, '2015-02-01 00:34:28.000000', 'consum', 0.0289, 'lps'),
	(677371, 134, '2015-02-01 00:34:29.000000', 'consum', 0.0287, 'lps'),
	(677372, 134, '2015-02-01 00:34:30.000000', 'consum', 0.0255, 'lps'),
	(677373, 134, '2015-02-01 00:34:31.000000', 'consum', 0.0307, 'lps'),
	(677374, 134, '2015-02-01 00:34:32.000000', 'consum', 0.0251, 'lps'),
	(677375, 134, '2015-02-01 00:34:33.000000', 'consum', 0.0230, 'lps'),
	(677376, 134, '2015-02-01 00:34:34.000000', 'consum', 0.0288, 'lps'),
	(677377, 134, '2015-02-01 00:34:35.000000', 'consum', 0.0234, 'lps'),
	(677378, 134, '2015-02-01 00:34:36.000000', 'consum', 0.0300, 'lps'),
	(677379, 134, '2015-02-01 00:34:37.000000', 'consum', 0.0278, 'lps'),
	(677380, 134, '2015-02-01 00:34:38.000000', 'consum', 0.0284, 'lps'),
	(677381, 134, '2015-02-01 00:34:39.000000', 'consum', 0.0271, 'lps'),
	(677382, 134, '2015-02-01 00:34:40.000000', 'consum', 0.0294, 'lps'),
	(677383, 134, '2015-02-01 00:34:41.000000', 'consum', 0.0240, 'lps'),
	(677384, 134, '2015-02-01 00:34:42.000000', 'consum', 0.0212, 'lps'),
	(677385, 134, '2015-02-01 00:34:43.000000', 'consum', 0.0233, 'lps'),
	(677386, 134, '2015-02-01 00:34:44.000000', 'consum', 0.0218, 'lps'),
	(677387, 134, '2015-02-01 00:34:45.000000', 'consum', 0.0284, 'lps'),
	(677388, 134, '2015-02-01 00:34:46.000000', 'consum', 0.0246, 'lps'),
	(677389, 134, '2015-02-01 00:34:47.000000', 'consum', 0.0274, 'lps'),
	(677390, 134, '2015-02-01 00:34:48.000000', 'consum', 0.0217, 'lps'),
	(677391, 134, '2015-02-01 00:34:49.000000', 'consum', 0.0257, 'lps'),
	(677392, 134, '2015-02-01 00:34:50.000000', 'consum', 0.0221, 'lps'),
	(677393, 134, '2015-02-01 00:34:51.000000', 'consum', 0.0226, 'lps'),
	(677394, 134, '2015-02-01 00:34:52.000000', 'consum', 0.0260, 'lps'),
	(677395, 134, '2015-02-01 00:34:53.000000', 'consum', 0.0307, 'lps'),
	(677396, 134, '2015-02-01 00:34:54.000000', 'consum', 0.0236, 'lps'),
	(677397, 134, '2015-02-01 00:34:55.000000', 'consum', 0.0256, 'lps'),
	(677398, 134, '2015-02-01 00:34:56.000000', 'consum', 0.0259, 'lps'),
	(677399, 134, '2015-02-01 00:34:57.000000', 'consum', 0.0215, 'lps'),
	(677400, 134, '2015-02-01 00:34:58.000000', 'consum', 0.0292, 'lps'),
	(677401, 134, '2015-02-01 00:34:59.000000', 'consum', 0.0300, 'lps'),
	(677402, 134, '2015-02-01 00:35:00.000000', 'consum', 0.0309, 'lps'),
	(677403, 134, '2015-02-01 00:35:01.000000', 'consum', 0.0232, 'lps'),
	(677404, 134, '2015-02-01 00:35:02.000000', 'consum', 0.0228, 'lps'),
	(677405, 134, '2015-02-01 00:35:03.000000', 'consum', 0.0235, 'lps'),
	(677406, 134, '2015-02-01 00:35:04.000000', 'consum', 0.0280, 'lps'),
	(677407, 134, '2015-02-01 00:35:05.000000', 'consum', 0.0280, 'lps'),
	(677408, 134, '2015-02-01 00:35:06.000000', 'consum', 0.0246, 'lps'),
	(677409, 134, '2015-02-01 00:35:07.000000', 'consum', 0.0284, 'lps'),
	(677410, 134, '2015-02-01 00:35:08.000000', 'consum', 0.0266, 'lps'),
	(677411, 134, '2015-02-01 00:35:09.000000', 'consum', 0.0270, 'lps'),
	(677412, 134, '2015-02-01 00:35:10.000000', 'consum', 0.0240, 'lps'),
	(677413, 134, '2015-02-01 00:35:11.000000', 'consum', 0.0284, 'lps'),
	(677414, 134, '2015-02-01 00:35:12.000000', 'consum', 0.0282, 'lps'),
	(677415, 134, '2015-02-01 00:35:13.000000', 'consum', 0.0248, 'lps'),
	(677416, 134, '2015-02-01 00:35:14.000000', 'consum', 0.0285, 'lps'),
	(677417, 134, '2015-02-01 00:35:15.000000', 'consum', 0.0267, 'lps'),
	(677418, 134, '2015-02-01 00:35:16.000000', 'consum', 0.0269, 'lps'),
	(677419, 134, '2015-02-01 00:35:17.000000', 'consum', 0.0230, 'lps'),
	(677420, 134, '2015-02-01 00:35:18.000000', 'consum', 0.0240, 'lps'),
	(677421, 134, '2015-02-01 00:35:19.000000', 'consum', 0.0300, 'lps'),
	(677422, 134, '2015-02-01 00:35:20.000000', 'consum', 0.0261, 'lps'),
	(677423, 134, '2015-02-01 00:35:21.000000', 'consum', 0.0298, 'lps'),
	(677424, 134, '2015-02-01 00:35:22.000000', 'consum', 0.0292, 'lps'),
	(677425, 134, '2015-02-01 00:35:23.000000', 'consum', 0.0255, 'lps'),
	(677426, 134, '2015-02-01 00:35:24.000000', 'consum', 0.0293, 'lps'),
	(677427, 134, '2015-02-01 00:35:25.000000', 'consum', 0.0285, 'lps'),
	(677428, 134, '2015-02-01 00:35:26.000000', 'consum', 0.0230, 'lps'),
	(677429, 134, '2015-02-01 00:35:27.000000', 'consum', 0.0295, 'lps'),
	(677430, 134, '2015-02-01 00:35:28.000000', 'consum', 0.0265, 'lps'),
	(677431, 134, '2015-02-01 00:35:29.000000', 'consum', 0.0230, 'lps'),
	(677432, 134, '2015-02-01 00:35:30.000000', 'consum', 0.0248, 'lps'),
	(677433, 134, '2015-02-01 00:35:31.000000', 'consum', 0.0237, 'lps'),
	(677434, 134, '2015-02-01 00:35:32.000000', 'consum', 0.0231, 'lps'),
	(677435, 134, '2015-02-01 00:35:33.000000', 'consum', 0.0236, 'lps'),
	(677436, 134, '2015-02-01 00:35:34.000000', 'consum', 0.0278, 'lps'),
	(677437, 134, '2015-02-01 00:35:35.000000', 'consum', 0.0267, 'lps'),
	(677438, 134, '2015-02-01 00:35:36.000000', 'consum', 0.0292, 'lps'),
	(677439, 134, '2015-02-01 00:35:37.000000', 'consum', 0.0245, 'lps'),
	(677440, 134, '2015-02-01 00:35:38.000000', 'consum', 0.0239, 'lps'),
	(677441, 134, '2015-02-01 00:35:39.000000', 'consum', 0.0253, 'lps'),
	(677442, 134, '2015-02-01 00:35:40.000000', 'consum', 0.0233, 'lps'),
	(677443, 134, '2015-02-01 00:35:41.000000', 'consum', 0.0299, 'lps'),
	(677444, 134, '2015-02-01 00:35:42.000000', 'consum', 0.0277, 'lps'),
	(677445, 134, '2015-02-01 00:35:43.000000', 'consum', 0.0279, 'lps'),
	(677446, 134, '2015-02-01 00:35:44.000000', 'consum', 0.0251, 'lps'),
	(677447, 134, '2015-02-01 00:35:45.000000', 'consum', 0.0211, 'lps'),
	(677448, 134, '2015-02-01 00:35:46.000000', 'consum', 0.0296, 'lps'),
	(677449, 134, '2015-02-01 00:35:47.000000', 'consum', 0.0225, 'lps'),
	(677450, 134, '2015-02-01 00:35:48.000000', 'consum', 0.0234, 'lps'),
	(677451, 134, '2015-02-01 00:35:49.000000', 'consum', 0.0286, 'lps'),
	(677452, 134, '2015-02-01 00:35:50.000000', 'consum', 0.0312, 'lps'),
	(677453, 134, '2015-02-01 00:35:51.000000', 'consum', 0.0285, 'lps'),
	(677454, 134, '2015-02-01 00:35:52.000000', 'consum', 0.0279, 'lps'),
	(677455, 134, '2015-02-01 00:35:53.000000', 'consum', 0.0231, 'lps'),
	(677456, 134, '2015-02-01 00:35:54.000000', 'consum', 0.0312, 'lps'),
	(677457, 134, '2015-02-01 00:35:55.000000', 'consum', 0.0245, 'lps'),
	(677458, 134, '2015-02-01 00:35:56.000000', 'consum', 0.0284, 'lps'),
	(677459, 134, '2015-02-01 00:35:57.000000', 'consum', 0.0272, 'lps'),
	(677460, 134, '2015-02-01 00:35:58.000000', 'consum', 0.0300, 'lps'),
	(677461, 134, '2015-02-01 00:35:59.000000', 'consum', 0.0267, 'lps'),
	(677462, 134, '2015-02-01 00:36:00.000000', 'consum', 0.0225, 'lps'),
	(677463, 134, '2015-02-01 00:36:01.000000', 'consum', 0.0216, 'lps'),
	(677464, 134, '2015-02-01 00:36:02.000000', 'consum', 0.0301, 'lps'),
	(677465, 134, '2015-02-01 00:36:03.000000', 'consum', 0.0233, 'lps'),
	(677466, 134, '2015-02-01 00:36:04.000000', 'consum', 0.0262, 'lps'),
	(677467, 134, '2015-02-01 00:36:05.000000', 'consum', 0.0295, 'lps'),
	(677468, 134, '2015-02-01 00:36:06.000000', 'consum', 0.0275, 'lps'),
	(677469, 134, '2015-02-01 00:36:07.000000', 'consum', 0.0282, 'lps'),
	(677470, 134, '2015-02-01 00:36:08.000000', 'consum', 0.0271, 'lps'),
	(677471, 134, '2015-02-01 00:36:09.000000', 'consum', 0.0300, 'lps'),
	(677472, 134, '2015-02-01 00:36:10.000000', 'consum', 0.0271, 'lps'),
	(677473, 134, '2015-02-01 00:36:11.000000', 'consum', 0.0244, 'lps'),
	(677474, 134, '2015-02-01 00:36:12.000000', 'consum', 0.0303, 'lps'),
	(677475, 134, '2015-02-01 00:36:13.000000', 'consum', 0.0264, 'lps'),
	(677476, 134, '2015-02-01 00:36:14.000000', 'consum', 0.0305, 'lps'),
	(677477, 134, '2015-02-01 00:36:15.000000', 'consum', 0.0214, 'lps'),
	(677478, 134, '2015-02-01 00:36:16.000000', 'consum', 0.0256, 'lps'),
	(677479, 134, '2015-02-01 00:36:17.000000', 'consum', 0.0220, 'lps'),
	(677480, 134, '2015-02-01 00:36:18.000000', 'consum', 0.0224, 'lps'),
	(677481, 134, '2015-02-01 00:36:19.000000', 'consum', 0.0254, 'lps'),
	(677482, 134, '2015-02-01 00:36:20.000000', 'consum', 0.0286, 'lps'),
	(677483, 134, '2015-02-01 00:36:21.000000', 'consum', 0.0251, 'lps'),
	(677484, 134, '2015-02-01 00:36:22.000000', 'consum', 0.0289, 'lps'),
	(677485, 134, '2015-02-01 00:36:23.000000', 'consum', 0.0277, 'lps'),
	(677486, 134, '2015-02-01 00:36:24.000000', 'consum', 0.0308, 'lps'),
	(677487, 134, '2015-02-01 00:36:25.000000', 'consum', 0.0293, 'lps'),
	(677488, 134, '2015-02-01 00:36:26.000000', 'consum', 0.0229, 'lps'),
	(677489, 134, '2015-02-01 00:36:27.000000', 'consum', 0.0261, 'lps'),
	(677490, 134, '2015-02-01 00:36:28.000000', 'consum', 0.0307, 'lps'),
	(677491, 134, '2015-02-01 00:36:29.000000', 'consum', 0.0231, 'lps'),
	(677492, 134, '2015-02-01 00:36:30.000000', 'consum', 0.0234, 'lps'),
	(677493, 134, '2015-02-01 00:36:31.000000', 'consum', 0.0267, 'lps'),
	(677494, 134, '2015-02-01 00:36:32.000000', 'consum', 0.0217, 'lps'),
	(677495, 134, '2015-02-01 00:36:33.000000', 'consum', 0.0281, 'lps'),
	(677496, 134, '2015-02-01 00:36:34.000000', 'consum', 0.0237, 'lps'),
	(677497, 134, '2015-02-01 00:36:35.000000', 'consum', 0.0235, 'lps'),
	(677498, 134, '2015-02-01 00:36:36.000000', 'consum', 0.0253, 'lps'),
	(677499, 134, '2015-02-01 00:36:37.000000', 'consum', 0.0247, 'lps'),
	(677500, 134, '2015-02-01 00:36:38.000000', 'consum', 0.0265, 'lps'),
	(677501, 134, '2015-02-01 00:36:39.000000', 'consum', 0.0274, 'lps'),
	(677502, 134, '2015-02-01 00:36:40.000000', 'consum', 0.0264, 'lps'),
	(677503, 134, '2015-02-01 00:36:41.000000', 'consum', 0.0286, 'lps'),
	(677504, 134, '2015-02-01 00:36:42.000000', 'consum', 0.0223, 'lps'),
	(677505, 134, '2015-02-01 00:36:43.000000', 'consum', 0.0254, 'lps'),
	(677506, 134, '2015-02-01 00:36:44.000000', 'consum', 0.0288, 'lps'),
	(677507, 134, '2015-02-01 00:36:45.000000', 'consum', 0.0264, 'lps'),
	(677508, 134, '2015-02-01 00:36:46.000000', 'consum', 0.0247, 'lps'),
	(677509, 134, '2015-02-01 00:36:47.000000', 'consum', 0.0233, 'lps'),
	(677510, 134, '2015-02-01 00:36:48.000000', 'consum', 0.0213, 'lps'),
	(677511, 134, '2015-02-01 00:36:49.000000', 'consum', 0.0260, 'lps'),
	(677512, 134, '2015-02-01 00:36:50.000000', 'consum', 0.0247, 'lps'),
	(677513, 134, '2015-02-01 00:36:51.000000', 'consum', 0.0244, 'lps'),
	(677514, 134, '2015-02-01 00:36:52.000000', 'consum', 0.0270, 'lps'),
	(677515, 134, '2015-02-01 00:36:53.000000', 'consum', 0.0305, 'lps'),
	(677516, 134, '2015-02-01 00:36:54.000000', 'consum', 0.0299, 'lps'),
	(677517, 134, '2015-02-01 00:36:55.000000', 'consum', 0.0270, 'lps'),
	(677518, 134, '2015-02-01 00:36:56.000000', 'consum', 0.0241, 'lps'),
	(677519, 134, '2015-02-01 00:36:57.000000', 'consum', 0.0289, 'lps'),
	(677520, 134, '2015-02-01 00:36:58.000000', 'consum', 0.0307, 'lps'),
	(677521, 134, '2015-02-01 00:36:59.000000', 'consum', 0.0254, 'lps'),
	(677522, 134, '2015-02-01 00:37:00.000000', 'consum', 0.0243, 'lps'),
	(677523, 134, '2015-02-01 00:37:01.000000', 'consum', 0.0243, 'lps'),
	(677524, 134, '2015-02-01 00:37:02.000000', 'consum', 0.0277, 'lps'),
	(677525, 134, '2015-02-01 00:37:03.000000', 'consum', 0.0240, 'lps'),
	(677526, 134, '2015-02-01 00:37:04.000000', 'consum', 0.0263, 'lps'),
	(677527, 134, '2015-02-01 00:37:05.000000', 'consum', 0.0280, 'lps'),
	(677528, 134, '2015-02-01 00:37:06.000000', 'consum', 0.0300, 'lps'),
	(677529, 134, '2015-02-01 00:37:07.000000', 'consum', 0.0243, 'lps'),
	(677530, 134, '2015-02-01 00:37:08.000000', 'consum', 0.0311, 'lps'),
	(677531, 134, '2015-02-01 00:37:09.000000', 'consum', 0.0309, 'lps'),
	(677532, 134, '2015-02-01 00:37:10.000000', 'consum', 0.0299, 'lps'),
	(677533, 134, '2015-02-01 00:37:11.000000', 'consum', 0.0254, 'lps'),
	(677534, 134, '2015-02-01 00:37:12.000000', 'consum', 0.0268, 'lps'),
	(677535, 134, '2015-02-01 00:37:13.000000', 'consum', 0.0264, 'lps'),
	(677536, 134, '2015-02-01 00:37:14.000000', 'consum', 0.0307, 'lps'),
	(677537, 134, '2015-02-01 00:37:15.000000', 'consum', 0.0224, 'lps'),
	(677538, 134, '2015-02-01 00:37:16.000000', 'consum', 0.0299, 'lps'),
	(677539, 134, '2015-02-01 00:37:17.000000', 'consum', 0.0305, 'lps'),
	(677540, 134, '2015-02-01 00:37:18.000000', 'consum', 0.0213, 'lps'),
	(677541, 134, '2015-02-01 00:37:19.000000', 'consum', 0.0250, 'lps'),
	(677542, 134, '2015-02-01 00:37:20.000000', 'consum', 0.0299, 'lps'),
	(677543, 134, '2015-02-01 00:37:21.000000', 'consum', 0.0225, 'lps'),
	(677544, 134, '2015-02-01 00:37:22.000000', 'consum', 0.0224, 'lps'),
	(677545, 134, '2015-02-01 00:37:23.000000', 'consum', 0.0236, 'lps'),
	(677546, 134, '2015-02-01 00:37:24.000000', 'consum', 0.0301, 'lps'),
	(677547, 134, '2015-02-01 00:37:25.000000', 'consum', 0.0275, 'lps'),
	(677548, 134, '2015-02-01 00:37:26.000000', 'consum', 0.0265, 'lps'),
	(677549, 134, '2015-02-01 00:37:27.000000', 'consum', 0.0291, 'lps'),
	(677550, 134, '2015-02-01 00:37:28.000000', 'consum', 0.0245, 'lps'),
	(677551, 134, '2015-02-01 00:37:29.000000', 'consum', 0.0244, 'lps'),
	(677552, 134, '2015-02-01 00:37:30.000000', 'consum', 0.0278, 'lps'),
	(677553, 134, '2015-02-01 00:37:31.000000', 'consum', 0.0239, 'lps'),
	(677554, 134, '2015-02-01 00:37:32.000000', 'consum', 0.0257, 'lps'),
	(677555, 134, '2015-02-01 00:37:33.000000', 'consum', 0.0257, 'lps'),
	(677556, 134, '2015-02-01 00:37:34.000000', 'consum', 0.0302, 'lps'),
	(677557, 134, '2015-02-01 00:37:35.000000', 'consum', 0.0219, 'lps'),
	(677558, 134, '2015-02-01 00:37:36.000000', 'consum', 0.0292, 'lps'),
	(677559, 134, '2015-02-01 00:37:37.000000', 'consum', 0.0284, 'lps'),
	(677560, 134, '2015-02-01 00:37:38.000000', 'consum', 0.0230, 'lps'),
	(677561, 134, '2015-02-01 00:37:39.000000', 'consum', 0.0293, 'lps'),
	(677562, 134, '2015-02-01 00:37:40.000000', 'consum', 0.0258, 'lps'),
	(677563, 134, '2015-02-01 00:37:41.000000', 'consum', 0.0306, 'lps'),
	(677564, 134, '2015-02-01 00:37:42.000000', 'consum', 0.0236, 'lps'),
	(677565, 134, '2015-02-01 00:37:43.000000', 'consum', 0.0258, 'lps'),
	(677566, 134, '2015-02-01 00:37:44.000000', 'consum', 0.0271, 'lps'),
	(677567, 134, '2015-02-01 00:37:45.000000', 'consum', 0.0269, 'lps'),
	(677568, 134, '2015-02-01 00:37:46.000000', 'consum', 0.0218, 'lps'),
	(677569, 134, '2015-02-01 00:37:47.000000', 'consum', 0.0279, 'lps'),
	(677570, 134, '2015-02-01 00:37:48.000000', 'consum', 0.0223, 'lps'),
	(677571, 134, '2015-02-01 00:37:49.000000', 'consum', 0.0274, 'lps'),
	(677572, 134, '2015-02-01 00:37:50.000000', 'consum', 0.0287, 'lps'),
	(677573, 134, '2015-02-01 00:37:51.000000', 'consum', 0.0299, 'lps'),
	(677574, 134, '2015-02-01 00:37:52.000000', 'consum', 0.0219, 'lps'),
	(677575, 134, '2015-02-01 00:37:53.000000', 'consum', 0.0296, 'lps'),
	(677576, 134, '2015-02-01 00:37:54.000000', 'consum', 0.0307, 'lps'),
	(677577, 134, '2015-02-01 00:37:55.000000', 'consum', 0.0232, 'lps'),
	(677578, 134, '2015-02-01 00:37:56.000000', 'consum', 0.0233, 'lps'),
	(677579, 134, '2015-02-01 00:37:57.000000', 'consum', 0.0260, 'lps'),
	(677580, 134, '2015-02-01 00:37:58.000000', 'consum', 0.0287, 'lps'),
	(677581, 134, '2015-02-01 00:37:59.000000', 'consum', 0.0240, 'lps'),
	(677582, 134, '2015-02-01 00:38:00.000000', 'consum', 0.0234, 'lps'),
	(677583, 134, '2015-02-01 00:38:01.000000', 'consum', 0.0242, 'lps'),
	(677584, 134, '2015-02-01 00:38:02.000000', 'consum', 0.0296, 'lps'),
	(677585, 134, '2015-02-01 00:38:03.000000', 'consum', 0.0236, 'lps'),
	(677586, 134, '2015-02-01 00:38:04.000000', 'consum', 0.0291, 'lps'),
	(677587, 134, '2015-02-01 00:38:05.000000', 'consum', 0.0225, 'lps'),
	(677588, 134, '2015-02-01 00:38:06.000000', 'consum', 0.0250, 'lps'),
	(677589, 134, '2015-02-01 00:38:07.000000', 'consum', 0.0261, 'lps'),
	(677590, 134, '2015-02-01 00:38:08.000000', 'consum', 0.0245, 'lps'),
	(677591, 134, '2015-02-01 00:38:09.000000', 'consum', 0.0234, 'lps'),
	(677592, 134, '2015-02-01 00:38:10.000000', 'consum', 0.0222, 'lps'),
	(677593, 134, '2015-02-01 00:38:11.000000', 'consum', 0.0301, 'lps'),
	(677594, 134, '2015-02-01 00:38:12.000000', 'consum', 0.0218, 'lps'),
	(677595, 134, '2015-02-01 00:38:13.000000', 'consum', 0.0288, 'lps'),
	(677596, 134, '2015-02-01 00:38:14.000000', 'consum', 0.0266, 'lps'),
	(677597, 134, '2015-02-01 00:38:15.000000', 'consum', 0.0255, 'lps'),
	(677598, 134, '2015-02-01 00:38:16.000000', 'consum', 0.0269, 'lps'),
	(677599, 134, '2015-02-01 00:38:17.000000', 'consum', 0.0267, 'lps'),
	(677600, 134, '2015-02-01 00:38:18.000000', 'consum', 0.0215, 'lps'),
	(677601, 134, '2015-02-01 00:38:19.000000', 'consum', 0.0273, 'lps'),
	(677602, 134, '2015-02-01 00:38:20.000000', 'consum', 0.0303, 'lps'),
	(677603, 134, '2015-02-01 00:38:21.000000', 'consum', 0.0281, 'lps'),
	(677604, 134, '2015-02-01 00:38:22.000000', 'consum', 0.0285, 'lps'),
	(677605, 134, '2015-02-01 00:38:23.000000', 'consum', 0.0271, 'lps'),
	(677606, 134, '2015-02-01 00:38:24.000000', 'consum', 0.0289, 'lps'),
	(677607, 134, '2015-02-01 00:38:25.000000', 'consum', 0.0217, 'lps'),
	(677608, 134, '2015-02-01 00:38:26.000000', 'consum', 0.0215, 'lps'),
	(677609, 134, '2015-02-01 00:38:27.000000', 'consum', 0.0212, 'lps'),
	(677610, 134, '2015-02-01 00:38:28.000000', 'consum', 0.0312, 'lps'),
	(677611, 134, '2015-02-01 00:38:29.000000', 'consum', 0.0302, 'lps'),
	(677612, 134, '2015-02-01 00:38:30.000000', 'consum', 0.0261, 'lps'),
	(677613, 134, '2015-02-01 00:38:31.000000', 'consum', 0.0292, 'lps'),
	(677614, 134, '2015-02-01 00:38:32.000000', 'consum', 0.0260, 'lps'),
	(677615, 134, '2015-02-01 00:38:33.000000', 'consum', 0.0214, 'lps'),
	(677616, 134, '2015-02-01 00:38:34.000000', 'consum', 0.0290, 'lps'),
	(677617, 134, '2015-02-01 00:38:35.000000', 'consum', 0.0287, 'lps'),
	(677618, 134, '2015-02-01 00:38:36.000000', 'consum', 0.0252, 'lps'),
	(677619, 134, '2015-02-01 00:38:37.000000', 'consum', 0.0294, 'lps'),
	(677620, 134, '2015-02-01 00:38:38.000000', 'consum', 0.0297, 'lps'),
	(677621, 134, '2015-02-01 00:38:39.000000', 'consum', 0.0290, 'lps'),
	(677622, 134, '2015-02-01 00:38:40.000000', 'consum', 0.0245, 'lps'),
	(677623, 134, '2015-02-01 00:38:41.000000', 'consum', 0.0252, 'lps'),
	(677624, 134, '2015-02-01 00:38:42.000000', 'consum', 0.0211, 'lps'),
	(677625, 134, '2015-02-01 00:38:43.000000', 'consum', 0.0297, 'lps'),
	(677626, 134, '2015-02-01 00:38:44.000000', 'consum', 0.0229, 'lps'),
	(677627, 134, '2015-02-01 00:38:45.000000', 'consum', 0.0251, 'lps'),
	(677628, 134, '2015-02-01 00:38:46.000000', 'consum', 0.0254, 'lps'),
	(677629, 134, '2015-02-01 00:38:47.000000', 'consum', 0.0310, 'lps'),
	(677630, 134, '2015-02-01 00:38:48.000000', 'consum', 0.0270, 'lps'),
	(677631, 134, '2015-02-01 00:38:49.000000', 'consum', 0.0212, 'lps'),
	(677632, 134, '2015-02-01 00:38:50.000000', 'consum', 0.0243, 'lps'),
	(677633, 134, '2015-02-01 00:38:51.000000', 'consum', 0.0266, 'lps'),
	(677634, 134, '2015-02-01 00:38:52.000000', 'consum', 0.0289, 'lps'),
	(677635, 134, '2015-02-01 00:38:53.000000', 'consum', 0.0233, 'lps'),
	(677636, 134, '2015-02-01 00:38:54.000000', 'consum', 0.0295, 'lps'),
	(677637, 134, '2015-02-01 00:38:55.000000', 'consum', 0.0257, 'lps'),
	(677638, 134, '2015-02-01 00:38:56.000000', 'consum', 0.0295, 'lps'),
	(677639, 134, '2015-02-01 00:38:57.000000', 'consum', 0.0288, 'lps'),
	(677640, 134, '2015-02-01 00:38:58.000000', 'consum', 0.0241, 'lps'),
	(677641, 134, '2015-02-01 00:38:59.000000', 'consum', 0.0235, 'lps'),
	(677642, 134, '2015-02-01 00:39:00.000000', 'consum', 0.0245, 'lps'),
	(677643, 134, '2015-02-01 00:39:01.000000', 'consum', 0.0308, 'lps'),
	(677644, 134, '2015-02-01 00:39:02.000000', 'consum', 0.0286, 'lps'),
	(677645, 134, '2015-02-01 00:39:03.000000', 'consum', 0.0298, 'lps'),
	(677646, 134, '2015-02-01 00:39:04.000000', 'consum', 0.0217, 'lps'),
	(677647, 134, '2015-02-01 00:39:05.000000', 'consum', 0.0289, 'lps'),
	(677648, 134, '2015-02-01 00:39:06.000000', 'consum', 0.0274, 'lps'),
	(677649, 134, '2015-02-01 00:39:07.000000', 'consum', 0.0295, 'lps'),
	(677650, 134, '2015-02-01 00:39:08.000000', 'consum', 0.0237, 'lps'),
	(677651, 134, '2015-02-01 00:39:09.000000', 'consum', 0.0297, 'lps'),
	(677652, 134, '2015-02-01 00:39:10.000000', 'consum', 0.0256, 'lps'),
	(677653, 134, '2015-02-01 00:39:11.000000', 'consum', 0.0283, 'lps'),
	(677654, 134, '2015-02-01 00:39:12.000000', 'consum', 0.0231, 'lps'),
	(677655, 134, '2015-02-01 00:39:13.000000', 'consum', 0.0301, 'lps'),
	(677656, 134, '2015-02-01 00:39:14.000000', 'consum', 0.0293, 'lps'),
	(677657, 134, '2015-02-01 00:39:15.000000', 'consum', 0.0250, 'lps'),
	(677658, 134, '2015-02-01 00:39:16.000000', 'consum', 0.0264, 'lps'),
	(677659, 134, '2015-02-01 00:39:17.000000', 'consum', 0.0259, 'lps'),
	(677660, 134, '2015-02-01 00:39:18.000000', 'consum', 0.0294, 'lps'),
	(677661, 134, '2015-02-01 00:39:19.000000', 'consum', 0.0276, 'lps'),
	(677662, 134, '2015-02-01 00:39:20.000000', 'consum', 0.0289, 'lps'),
	(677663, 134, '2015-02-01 00:39:21.000000', 'consum', 0.0307, 'lps'),
	(677664, 134, '2015-02-01 00:39:22.000000', 'consum', 0.0249, 'lps'),
	(677665, 134, '2015-02-01 00:39:23.000000', 'consum', 0.0218, 'lps'),
	(677666, 134, '2015-02-01 00:39:24.000000', 'consum', 0.0235, 'lps'),
	(677667, 134, '2015-02-01 00:39:25.000000', 'consum', 0.0210, 'lps'),
	(677668, 134, '2015-02-01 00:39:26.000000', 'consum', 0.0239, 'lps'),
	(677669, 134, '2015-02-01 00:39:27.000000', 'consum', 0.0253, 'lps'),
	(677670, 134, '2015-02-01 00:39:28.000000', 'consum', 0.0233, 'lps'),
	(677671, 134, '2015-02-01 00:39:29.000000', 'consum', 0.0302, 'lps'),
	(677672, 134, '2015-02-01 00:39:30.000000', 'consum', 0.0291, 'lps'),
	(677673, 134, '2015-02-01 00:39:31.000000', 'consum', 0.0238, 'lps'),
	(677674, 134, '2015-02-01 00:39:32.000000', 'consum', 0.0311, 'lps'),
	(677675, 134, '2015-02-01 00:39:33.000000', 'consum', 0.0220, 'lps'),
	(677676, 134, '2015-02-01 00:39:34.000000', 'consum', 0.0269, 'lps'),
	(677677, 134, '2015-02-01 00:39:35.000000', 'consum', 0.0268, 'lps'),
	(677678, 134, '2015-02-01 00:39:36.000000', 'consum', 0.0220, 'lps'),
	(677679, 134, '2015-02-01 00:39:37.000000', 'consum', 0.0293, 'lps'),
	(677680, 134, '2015-02-01 00:39:38.000000', 'consum', 0.0284, 'lps'),
	(677681, 134, '2015-02-01 00:39:39.000000', 'consum', 0.0232, 'lps'),
	(677682, 134, '2015-02-01 00:39:40.000000', 'consum', 0.0302, 'lps'),
	(677683, 134, '2015-02-01 00:39:41.000000', 'consum', 0.0296, 'lps'),
	(677684, 134, '2015-02-01 00:39:42.000000', 'consum', 0.0262, 'lps'),
	(677685, 134, '2015-02-01 00:39:43.000000', 'consum', 0.0211, 'lps'),
	(677686, 134, '2015-02-01 00:39:44.000000', 'consum', 0.0268, 'lps'),
	(677687, 134, '2015-02-01 00:39:45.000000', 'consum', 0.0289, 'lps'),
	(677688, 134, '2015-02-01 00:39:46.000000', 'consum', 0.0227, 'lps'),
	(677689, 134, '2015-02-01 00:39:47.000000', 'consum', 0.0262, 'lps'),
	(677690, 134, '2015-02-01 00:39:48.000000', 'consum', 0.0216, 'lps'),
	(677691, 134, '2015-02-01 00:39:49.000000', 'consum', 0.0289, 'lps'),
	(677692, 134, '2015-02-01 00:39:50.000000', 'consum', 0.0281, 'lps'),
	(677693, 134, '2015-02-01 00:39:51.000000', 'consum', 0.0222, 'lps'),
	(677694, 134, '2015-02-01 00:39:52.000000', 'consum', 0.0267, 'lps'),
	(677695, 134, '2015-02-01 00:39:53.000000', 'consum', 0.0250, 'lps'),
	(677696, 134, '2015-02-01 00:39:54.000000', 'consum', 0.0243, 'lps'),
	(677697, 134, '2015-02-01 00:39:55.000000', 'consum', 0.0254, 'lps'),
	(677698, 134, '2015-02-01 00:39:56.000000', 'consum', 0.0227, 'lps'),
	(677699, 134, '2015-02-01 00:39:57.000000', 'consum', 0.0269, 'lps'),
	(677700, 134, '2015-02-01 00:39:58.000000', 'consum', 0.0248, 'lps'),
	(677701, 134, '2015-02-01 00:39:59.000000', 'consum', 0.0223, 'lps'),
	(677702, 134, '2015-02-01 00:40:00.000000', 'consum', 0.0267, 'lps'),
	(677703, 134, '2015-02-01 00:40:01.000000', 'consum', 0.0247, 'lps'),
	(677704, 134, '2015-02-01 00:40:02.000000', 'consum', 0.0225, 'lps'),
	(677705, 134, '2015-02-01 00:40:03.000000', 'consum', 0.0276, 'lps'),
	(677706, 134, '2015-02-01 00:40:04.000000', 'consum', 0.0291, 'lps'),
	(677707, 134, '2015-02-01 00:40:05.000000', 'consum', 0.0213, 'lps'),
	(677708, 134, '2015-02-01 00:40:06.000000', 'consum', 0.0290, 'lps'),
	(677709, 134, '2015-02-01 00:40:07.000000', 'consum', 0.0295, 'lps'),
	(677710, 134, '2015-02-01 00:40:08.000000', 'consum', 0.0290, 'lps'),
	(677711, 134, '2015-02-01 00:40:09.000000', 'consum', 0.0255, 'lps'),
	(677712, 134, '2015-02-01 00:40:10.000000', 'consum', 0.0298, 'lps'),
	(677713, 134, '2015-02-01 00:40:11.000000', 'consum', 0.0309, 'lps'),
	(677714, 134, '2015-02-01 00:40:12.000000', 'consum', 0.0235, 'lps'),
	(677715, 134, '2015-02-01 00:40:13.000000', 'consum', 0.0244, 'lps'),
	(677716, 134, '2015-02-01 00:40:14.000000', 'consum', 0.0307, 'lps'),
	(677717, 134, '2015-02-01 00:40:15.000000', 'consum', 0.0285, 'lps'),
	(677718, 134, '2015-02-01 00:40:16.000000', 'consum', 0.0295, 'lps'),
	(677719, 134, '2015-02-01 00:40:17.000000', 'consum', 0.0307, 'lps'),
	(677720, 134, '2015-02-01 00:40:18.000000', 'consum', 0.0235, 'lps'),
	(677721, 134, '2015-02-01 00:40:19.000000', 'consum', 0.0248, 'lps'),
	(677722, 134, '2015-02-01 00:40:20.000000', 'consum', 0.0225, 'lps'),
	(677723, 134, '2015-02-01 00:40:21.000000', 'consum', 0.0272, 'lps'),
	(677724, 134, '2015-02-01 00:40:22.000000', 'consum', 0.0272, 'lps'),
	(677725, 134, '2015-02-01 00:40:23.000000', 'consum', 0.0232, 'lps'),
	(677726, 134, '2015-02-01 00:40:24.000000', 'consum', 0.0237, 'lps'),
	(677727, 134, '2015-02-01 00:40:25.000000', 'consum', 0.0280, 'lps'),
	(677728, 134, '2015-02-01 00:40:26.000000', 'consum', 0.0272, 'lps'),
	(677729, 134, '2015-02-01 00:40:27.000000', 'consum', 0.0312, 'lps'),
	(677730, 134, '2015-02-01 00:40:28.000000', 'consum', 0.0224, 'lps'),
	(677731, 134, '2015-02-01 00:40:29.000000', 'consum', 0.0284, 'lps'),
	(677732, 134, '2015-02-01 00:40:30.000000', 'consum', 0.0228, 'lps'),
	(677733, 134, '2015-02-01 00:40:31.000000', 'consum', 0.0285, 'lps'),
	(677734, 134, '2015-02-01 00:40:32.000000', 'consum', 0.0222, 'lps'),
	(677735, 134, '2015-02-01 00:40:33.000000', 'consum', 0.0252, 'lps'),
	(677736, 134, '2015-02-01 00:40:34.000000', 'consum', 0.0280, 'lps'),
	(677737, 134, '2015-02-01 00:40:35.000000', 'consum', 0.0231, 'lps'),
	(677738, 134, '2015-02-01 00:40:36.000000', 'consum', 0.0309, 'lps'),
	(677739, 134, '2015-02-01 00:40:37.000000', 'consum', 0.0230, 'lps'),
	(677740, 134, '2015-02-01 00:40:38.000000', 'consum', 0.0220, 'lps'),
	(677741, 134, '2015-02-01 00:40:39.000000', 'consum', 0.0306, 'lps'),
	(677742, 134, '2015-02-01 00:40:40.000000', 'consum', 0.0245, 'lps'),
	(677743, 134, '2015-02-01 00:40:41.000000', 'consum', 0.0307, 'lps'),
	(677744, 134, '2015-02-01 00:40:42.000000', 'consum', 0.0279, 'lps'),
	(677745, 134, '2015-02-01 00:40:43.000000', 'consum', 0.0267, 'lps'),
	(677746, 134, '2015-02-01 00:40:44.000000', 'consum', 0.0288, 'lps'),
	(677747, 134, '2015-02-01 00:40:45.000000', 'consum', 0.0223, 'lps'),
	(677748, 134, '2015-02-01 00:40:46.000000', 'consum', 0.0247, 'lps'),
	(677749, 134, '2015-02-01 00:40:47.000000', 'consum', 0.0253, 'lps'),
	(677750, 134, '2015-02-01 00:40:48.000000', 'consum', 0.0210, 'lps'),
	(677751, 134, '2015-02-01 00:40:49.000000', 'consum', 0.0289, 'lps'),
	(677752, 134, '2015-02-01 00:40:50.000000', 'consum', 0.0296, 'lps'),
	(677753, 134, '2015-02-01 00:40:51.000000', 'consum', 0.0299, 'lps'),
	(677754, 134, '2015-02-01 00:40:52.000000', 'consum', 0.0298, 'lps'),
	(677755, 134, '2015-02-01 00:40:53.000000', 'consum', 0.0277, 'lps'),
	(677756, 134, '2015-02-01 00:40:54.000000', 'consum', 0.0284, 'lps'),
	(677757, 134, '2015-02-01 00:40:55.000000', 'consum', 0.0275, 'lps'),
	(677758, 134, '2015-02-01 00:40:56.000000', 'consum', 0.0212, 'lps'),
	(677759, 134, '2015-02-01 00:40:57.000000', 'consum', 0.0230, 'lps'),
	(677760, 134, '2015-02-01 00:40:58.000000', 'consum', 0.0306, 'lps'),
	(677761, 134, '2015-02-01 00:40:59.000000', 'consum', 0.0216, 'lps'),
	(677762, 134, '2015-02-01 00:41:00.000000', 'consum', 0.0263, 'lps'),
	(677763, 134, '2015-02-01 00:41:01.000000', 'consum', 0.0253, 'lps'),
	(677764, 134, '2015-02-01 00:41:02.000000', 'consum', 0.0263, 'lps'),
	(677765, 134, '2015-02-01 00:41:03.000000', 'consum', 0.0247, 'lps'),
	(677766, 134, '2015-02-01 00:41:04.000000', 'consum', 0.0236, 'lps'),
	(677767, 134, '2015-02-01 00:41:05.000000', 'consum', 0.0228, 'lps'),
	(677768, 134, '2015-02-01 00:41:06.000000', 'consum', 0.0224, 'lps'),
	(677769, 134, '2015-02-01 00:41:07.000000', 'consum', 0.0227, 'lps'),
	(677770, 134, '2015-02-01 00:41:08.000000', 'consum', 0.0254, 'lps'),
	(677771, 134, '2015-02-01 00:41:09.000000', 'consum', 0.0274, 'lps'),
	(677772, 134, '2015-02-01 00:41:10.000000', 'consum', 0.0295, 'lps'),
	(677773, 134, '2015-02-01 00:41:11.000000', 'consum', 0.0240, 'lps'),
	(677774, 134, '2015-02-01 00:41:12.000000', 'consum', 0.0309, 'lps'),
	(677775, 134, '2015-02-01 00:41:13.000000', 'consum', 0.0309, 'lps'),
	(677776, 134, '2015-02-01 00:41:14.000000', 'consum', 0.0305, 'lps'),
	(677777, 134, '2015-02-01 00:41:15.000000', 'consum', 0.0284, 'lps'),
	(677778, 134, '2015-02-01 00:41:16.000000', 'consum', 0.0297, 'lps'),
	(677779, 134, '2015-02-01 00:41:17.000000', 'consum', 0.0216, 'lps'),
	(677780, 134, '2015-02-01 00:41:18.000000', 'consum', 0.0289, 'lps'),
	(677781, 134, '2015-02-01 00:41:19.000000', 'consum', 0.0277, 'lps'),
	(677782, 134, '2015-02-01 00:41:20.000000', 'consum', 0.0311, 'lps'),
	(677783, 134, '2015-02-01 00:41:21.000000', 'consum', 0.0306, 'lps'),
	(677784, 134, '2015-02-01 00:41:22.000000', 'consum', 0.0284, 'lps'),
	(677785, 134, '2015-02-01 00:41:23.000000', 'consum', 0.0292, 'lps'),
	(677786, 134, '2015-02-01 00:41:24.000000', 'consum', 0.0298, 'lps'),
	(677787, 134, '2015-02-01 00:41:25.000000', 'consum', 0.0300, 'lps'),
	(677788, 134, '2015-02-01 00:41:26.000000', 'consum', 0.0293, 'lps'),
	(677789, 134, '2015-02-01 00:41:27.000000', 'consum', 0.0254, 'lps'),
	(677790, 134, '2015-02-01 00:41:28.000000', 'consum', 0.0285, 'lps'),
	(677791, 134, '2015-02-01 00:41:29.000000', 'consum', 0.0245, 'lps'),
	(677792, 134, '2015-02-01 00:41:30.000000', 'consum', 0.0266, 'lps'),
	(677793, 134, '2015-02-01 00:41:31.000000', 'consum', 0.0282, 'lps'),
	(677794, 134, '2015-02-01 00:41:32.000000', 'consum', 0.0300, 'lps'),
	(677795, 134, '2015-02-01 00:41:33.000000', 'consum', 0.0240, 'lps'),
	(677796, 134, '2015-02-01 00:41:34.000000', 'consum', 0.0295, 'lps'),
	(677797, 134, '2015-02-01 00:41:35.000000', 'consum', 0.0235, 'lps'),
	(677798, 134, '2015-02-01 00:41:36.000000', 'consum', 0.0287, 'lps'),
	(677799, 134, '2015-02-01 00:41:37.000000', 'consum', 0.0211, 'lps'),
	(677800, 134, '2015-02-01 00:41:38.000000', 'consum', 0.0294, 'lps'),
	(677801, 134, '2015-02-01 00:41:39.000000', 'consum', 0.0215, 'lps'),
	(677802, 134, '2015-02-01 00:41:40.000000', 'consum', 0.0293, 'lps'),
	(677803, 134, '2015-02-01 00:41:41.000000', 'consum', 0.0300, 'lps'),
	(677804, 134, '2015-02-01 00:41:42.000000', 'consum', 0.0307, 'lps'),
	(677805, 134, '2015-02-01 00:41:43.000000', 'consum', 0.0223, 'lps'),
	(677806, 134, '2015-02-01 00:41:44.000000', 'consum', 0.0294, 'lps'),
	(677807, 134, '2015-02-01 00:41:45.000000', 'consum', 0.0281, 'lps'),
	(677808, 134, '2015-02-01 00:41:46.000000', 'consum', 0.0211, 'lps'),
	(677809, 134, '2015-02-01 00:41:47.000000', 'consum', 0.0312, 'lps'),
	(677810, 134, '2015-02-01 00:41:48.000000', 'consum', 0.0304, 'lps'),
	(677811, 134, '2015-02-01 00:41:49.000000', 'consum', 0.0272, 'lps'),
	(677812, 134, '2015-02-01 00:41:50.000000', 'consum', 0.0238, 'lps'),
	(677813, 134, '2015-02-01 00:41:51.000000', 'consum', 0.0267, 'lps'),
	(677814, 134, '2015-02-01 00:41:52.000000', 'consum', 0.0308, 'lps'),
	(677815, 134, '2015-02-01 00:41:53.000000', 'consum', 0.0220, 'lps'),
	(677816, 134, '2015-02-01 00:41:54.000000', 'consum', 0.0277, 'lps'),
	(677817, 134, '2015-02-01 00:41:55.000000', 'consum', 0.0310, 'lps'),
	(677818, 134, '2015-02-01 00:41:56.000000', 'consum', 0.0303, 'lps'),
	(677819, 134, '2015-02-01 00:41:57.000000', 'consum', 0.0272, 'lps'),
	(677820, 134, '2015-02-01 00:41:58.000000', 'consum', 0.0240, 'lps'),
	(677821, 134, '2015-02-01 00:41:59.000000', 'consum', 0.0280, 'lps'),
	(677822, 134, '2015-02-01 00:42:00.000000', 'consum', 0.0265, 'lps'),
	(677823, 134, '2015-02-01 00:42:01.000000', 'consum', 0.0273, 'lps'),
	(677824, 134, '2015-02-01 00:42:02.000000', 'consum', 0.0257, 'lps'),
	(677825, 134, '2015-02-01 00:42:03.000000', 'consum', 0.0258, 'lps'),
	(677826, 134, '2015-02-01 00:42:04.000000', 'consum', 0.0311, 'lps'),
	(677827, 134, '2015-02-01 00:42:05.000000', 'consum', 0.0260, 'lps'),
	(677828, 134, '2015-02-01 00:42:06.000000', 'consum', 0.0260, 'lps'),
	(677829, 134, '2015-02-01 00:42:07.000000', 'consum', 0.0310, 'lps'),
	(677830, 134, '2015-02-01 00:42:08.000000', 'consum', 0.0255, 'lps'),
	(677831, 134, '2015-02-01 00:42:09.000000', 'consum', 0.0235, 'lps'),
	(677832, 134, '2015-02-01 00:42:10.000000', 'consum', 0.0305, 'lps'),
	(677833, 134, '2015-02-01 00:42:11.000000', 'consum', 0.0303, 'lps'),
	(677834, 134, '2015-02-01 00:42:12.000000', 'consum', 0.0288, 'lps'),
	(677835, 134, '2015-02-01 00:42:13.000000', 'consum', 0.0216, 'lps'),
	(677836, 134, '2015-02-01 00:42:14.000000', 'consum', 0.0214, 'lps'),
	(677837, 134, '2015-02-01 00:42:15.000000', 'consum', 0.0213, 'lps'),
	(677838, 134, '2015-02-01 00:42:16.000000', 'consum', 0.0211, 'lps'),
	(677839, 134, '2015-02-01 00:42:17.000000', 'consum', 0.0310, 'lps'),
	(677840, 134, '2015-02-01 00:42:18.000000', 'consum', 0.0295, 'lps'),
	(677841, 134, '2015-02-01 00:42:19.000000', 'consum', 0.0235, 'lps'),
	(677842, 134, '2015-02-01 00:42:20.000000', 'consum', 0.0285, 'lps'),
	(677843, 134, '2015-02-01 00:42:21.000000', 'consum', 0.0304, 'lps'),
	(677844, 134, '2015-02-01 00:42:22.000000', 'consum', 0.0252, 'lps'),
	(677845, 134, '2015-02-01 00:42:23.000000', 'consum', 0.0241, 'lps'),
	(677846, 134, '2015-02-01 00:42:24.000000', 'consum', 0.0237, 'lps'),
	(677847, 134, '2015-02-01 00:42:25.000000', 'consum', 0.0253, 'lps'),
	(677848, 134, '2015-02-01 00:42:26.000000', 'consum', 0.0243, 'lps'),
	(677849, 134, '2015-02-01 00:42:27.000000', 'consum', 0.0246, 'lps'),
	(677850, 134, '2015-02-01 00:42:28.000000', 'consum', 0.0291, 'lps'),
	(677851, 134, '2015-02-01 00:42:29.000000', 'consum', 0.0300, 'lps'),
	(677852, 134, '2015-02-01 00:42:30.000000', 'consum', 0.0214, 'lps'),
	(677853, 134, '2015-02-01 00:42:31.000000', 'consum', 0.0270, 'lps'),
	(677854, 134, '2015-02-01 00:42:32.000000', 'consum', 0.0294, 'lps'),
	(677855, 134, '2015-02-01 00:42:33.000000', 'consum', 0.0241, 'lps'),
	(677856, 134, '2015-02-01 00:42:34.000000', 'consum', 0.0219, 'lps'),
	(677857, 134, '2015-02-01 00:42:35.000000', 'consum', 0.0266, 'lps'),
	(677858, 134, '2015-02-01 00:42:36.000000', 'consum', 0.0255, 'lps'),
	(677859, 134, '2015-02-01 00:42:37.000000', 'consum', 0.0269, 'lps'),
	(677860, 134, '2015-02-01 00:42:38.000000', 'consum', 0.0266, 'lps'),
	(677861, 134, '2015-02-01 00:42:39.000000', 'consum', 0.0210, 'lps'),
	(677862, 134, '2015-02-01 00:42:40.000000', 'consum', 0.0249, 'lps'),
	(677863, 134, '2015-02-01 00:42:41.000000', 'consum', 0.0302, 'lps'),
	(677864, 134, '2015-02-01 00:42:42.000000', 'consum', 0.0247, 'lps'),
	(677865, 134, '2015-02-01 00:42:43.000000', 'consum', 0.0221, 'lps'),
	(677866, 134, '2015-02-01 00:42:44.000000', 'consum', 0.0256, 'lps'),
	(677867, 134, '2015-02-01 00:42:45.000000', 'consum', 0.0304, 'lps'),
	(677868, 134, '2015-02-01 00:42:46.000000', 'consum', 0.0233, 'lps'),
	(677869, 134, '2015-02-01 00:42:47.000000', 'consum', 0.0250, 'lps'),
	(677870, 134, '2015-02-01 00:42:48.000000', 'consum', 0.0239, 'lps'),
	(677871, 134, '2015-02-01 00:42:49.000000', 'consum', 0.0237, 'lps'),
	(677872, 134, '2015-02-01 00:42:50.000000', 'consum', 0.0256, 'lps'),
	(677873, 134, '2015-02-01 00:42:51.000000', 'consum', 0.0259, 'lps'),
	(677874, 134, '2015-02-01 00:42:52.000000', 'consum', 0.0212, 'lps'),
	(677875, 134, '2015-02-01 00:42:53.000000', 'consum', 0.0280, 'lps'),
	(677876, 134, '2015-02-01 00:42:54.000000', 'consum', 0.0244, 'lps'),
	(677877, 134, '2015-02-01 00:42:55.000000', 'consum', 0.0276, 'lps'),
	(677878, 134, '2015-02-01 00:42:56.000000', 'consum', 0.0232, 'lps'),
	(677879, 134, '2015-02-01 00:42:57.000000', 'consum', 0.0226, 'lps'),
	(677880, 134, '2015-02-01 00:42:58.000000', 'consum', 0.0223, 'lps'),
	(677881, 134, '2015-02-01 00:42:59.000000', 'consum', 0.0229, 'lps'),
	(677882, 134, '2015-02-01 00:43:00.000000', 'consum', 0.0264, 'lps'),
	(677883, 134, '2015-02-01 00:43:01.000000', 'consum', 0.0219, 'lps'),
	(677884, 134, '2015-02-01 00:43:02.000000', 'consum', 0.0299, 'lps'),
	(677885, 134, '2015-02-01 00:43:03.000000', 'consum', 0.0215, 'lps'),
	(677886, 134, '2015-02-01 00:43:04.000000', 'consum', 0.0280, 'lps'),
	(677887, 134, '2015-02-01 00:43:05.000000', 'consum', 0.0236, 'lps'),
	(677888, 134, '2015-02-01 00:43:06.000000', 'consum', 0.0234, 'lps'),
	(677889, 134, '2015-02-01 00:43:07.000000', 'consum', 0.0253, 'lps'),
	(677890, 134, '2015-02-01 00:43:08.000000', 'consum', 0.0248, 'lps'),
	(677891, 134, '2015-02-01 00:43:09.000000', 'consum', 0.0273, 'lps'),
	(677892, 134, '2015-02-01 00:43:10.000000', 'consum', 0.0308, 'lps'),
	(677893, 134, '2015-02-01 00:43:11.000000', 'consum', 0.0304, 'lps'),
	(677894, 134, '2015-02-01 00:43:12.000000', 'consum', 0.0285, 'lps'),
	(677895, 134, '2015-02-01 00:43:13.000000', 'consum', 0.0302, 'lps'),
	(677896, 134, '2015-02-01 00:43:14.000000', 'consum', 0.0239, 'lps'),
	(677897, 134, '2015-02-01 00:43:15.000000', 'consum', 0.0286, 'lps'),
	(677898, 134, '2015-02-01 00:43:16.000000', 'consum', 0.0298, 'lps'),
	(677899, 134, '2015-02-01 00:43:17.000000', 'consum', 0.0216, 'lps'),
	(677900, 134, '2015-02-01 00:43:18.000000', 'consum', 0.0286, 'lps'),
	(677901, 134, '2015-02-01 00:43:19.000000', 'consum', 0.0265, 'lps'),
	(677902, 134, '2015-02-01 00:43:20.000000', 'consum', 0.0254, 'lps'),
	(677903, 134, '2015-02-01 00:43:21.000000', 'consum', 0.0269, 'lps'),
	(677904, 134, '2015-02-01 00:43:22.000000', 'consum', 0.0268, 'lps'),
	(677905, 134, '2015-02-01 00:43:23.000000', 'consum', 0.0219, 'lps'),
	(677906, 134, '2015-02-01 00:43:24.000000', 'consum', 0.0290, 'lps'),
	(677907, 134, '2015-02-01 00:43:25.000000', 'consum', 0.0275, 'lps'),
	(677908, 134, '2015-02-01 00:43:26.000000', 'consum', 0.0293, 'lps'),
	(677909, 134, '2015-02-01 00:43:27.000000', 'consum', 0.0226, 'lps'),
	(677910, 134, '2015-02-01 00:43:28.000000', 'consum', 0.0248, 'lps'),
	(677911, 134, '2015-02-01 00:43:29.000000', 'consum', 0.0251, 'lps'),
	(677912, 134, '2015-02-01 00:43:30.000000', 'consum', 0.0300, 'lps'),
	(677913, 134, '2015-02-01 00:43:31.000000', 'consum', 0.0227, 'lps'),
	(677914, 134, '2015-02-01 00:43:32.000000', 'consum', 0.0235, 'lps'),
	(677915, 134, '2015-02-01 00:43:33.000000', 'consum', 0.0282, 'lps'),
	(677916, 134, '2015-02-01 00:43:34.000000', 'consum', 0.0288, 'lps'),
	(677917, 134, '2015-02-01 00:43:35.000000', 'consum', 0.0284, 'lps'),
	(677918, 134, '2015-02-01 00:43:36.000000', 'consum', 0.0245, 'lps'),
	(677919, 134, '2015-02-01 00:43:37.000000', 'consum', 0.0264, 'lps'),
	(677920, 134, '2015-02-01 00:43:38.000000', 'consum', 0.0273, 'lps'),
	(677921, 134, '2015-02-01 00:43:39.000000', 'consum', 0.0260, 'lps'),
	(677922, 134, '2015-02-01 00:43:40.000000', 'consum', 0.0274, 'lps'),
	(677923, 134, '2015-02-01 00:43:41.000000', 'consum', 0.0276, 'lps'),
	(677924, 134, '2015-02-01 00:43:42.000000', 'consum', 0.0245, 'lps'),
	(677925, 134, '2015-02-01 00:43:43.000000', 'consum', 0.0292, 'lps'),
	(677926, 134, '2015-02-01 00:43:44.000000', 'consum', 0.0308, 'lps'),
	(677927, 134, '2015-02-01 00:43:45.000000', 'consum', 0.0250, 'lps'),
	(677928, 134, '2015-02-01 00:43:46.000000', 'consum', 0.0217, 'lps'),
	(677929, 134, '2015-02-01 00:43:47.000000', 'consum', 0.0230, 'lps'),
	(677930, 134, '2015-02-01 00:43:48.000000', 'consum', 0.0291, 'lps'),
	(677931, 134, '2015-02-01 00:43:49.000000', 'consum', 0.0247, 'lps'),
	(677932, 134, '2015-02-01 00:43:50.000000', 'consum', 0.0254, 'lps'),
	(677933, 134, '2015-02-01 00:43:51.000000', 'consum', 0.0217, 'lps'),
	(677934, 134, '2015-02-01 00:43:52.000000', 'consum', 0.0217, 'lps'),
	(677935, 134, '2015-02-01 00:43:53.000000', 'consum', 0.0224, 'lps'),
	(677936, 134, '2015-02-01 00:43:54.000000', 'consum', 0.0261, 'lps'),
	(677937, 134, '2015-02-01 00:43:55.000000', 'consum', 0.0218, 'lps'),
	(677938, 134, '2015-02-01 00:43:56.000000', 'consum', 0.0301, 'lps'),
	(677939, 134, '2015-02-01 00:43:57.000000', 'consum', 0.0230, 'lps'),
	(677940, 134, '2015-02-01 00:43:58.000000', 'consum', 0.0243, 'lps'),
	(677941, 134, '2015-02-01 00:43:59.000000', 'consum', 0.0213, 'lps'),
	(677942, 134, '2015-02-01 00:44:00.000000', 'consum', 0.0230, 'lps'),
	(677943, 134, '2015-02-01 00:44:01.000000', 'consum', 0.0300, 'lps'),
	(677944, 134, '2015-02-01 00:44:02.000000', 'consum', 0.0292, 'lps'),
	(677945, 134, '2015-02-01 00:44:03.000000', 'consum', 0.0246, 'lps'),
	(677946, 134, '2015-02-01 00:44:04.000000', 'consum', 0.0248, 'lps'),
	(677947, 134, '2015-02-01 00:44:05.000000', 'consum', 0.0295, 'lps'),
	(677948, 134, '2015-02-01 00:44:06.000000', 'consum', 0.0212, 'lps'),
	(677949, 134, '2015-02-01 00:44:07.000000', 'consum', 0.0272, 'lps'),
	(677950, 134, '2015-02-01 00:44:08.000000', 'consum', 0.0309, 'lps'),
	(677951, 134, '2015-02-01 00:44:09.000000', 'consum', 0.0212, 'lps'),
	(677952, 134, '2015-02-01 00:44:10.000000', 'consum', 0.0230, 'lps'),
	(677953, 134, '2015-02-01 00:44:11.000000', 'consum', 0.0307, 'lps'),
	(677954, 134, '2015-02-01 00:44:12.000000', 'consum', 0.0225, 'lps'),
	(677955, 134, '2015-02-01 00:44:13.000000', 'consum', 0.0301, 'lps'),
	(677956, 134, '2015-02-01 00:44:14.000000', 'consum', 0.0311, 'lps'),
	(677957, 134, '2015-02-01 00:44:15.000000', 'consum', 0.0236, 'lps'),
	(677958, 134, '2015-02-01 00:44:16.000000', 'consum', 0.0244, 'lps'),
	(677959, 134, '2015-02-01 00:44:17.000000', 'consum', 0.0301, 'lps'),
	(677960, 134, '2015-02-01 00:44:18.000000', 'consum', 0.0255, 'lps'),
	(677961, 134, '2015-02-01 00:44:19.000000', 'consum', 0.0267, 'lps'),
	(677962, 134, '2015-02-01 00:44:20.000000', 'consum', 0.0258, 'lps'),
	(677963, 134, '2015-02-01 00:44:21.000000', 'consum', 0.0277, 'lps'),
	(677964, 134, '2015-02-01 00:44:22.000000', 'consum', 0.0302, 'lps'),
	(677965, 134, '2015-02-01 00:44:23.000000', 'consum', 0.0260, 'lps'),
	(677966, 134, '2015-02-01 00:44:24.000000', 'consum', 0.0288, 'lps'),
	(677967, 134, '2015-02-01 00:44:25.000000', 'consum', 0.0246, 'lps'),
	(677968, 134, '2015-02-01 00:44:26.000000', 'consum', 0.0260, 'lps'),
	(677969, 134, '2015-02-01 00:44:27.000000', 'consum', 0.0250, 'lps'),
	(677970, 134, '2015-02-01 00:44:28.000000', 'consum', 0.0260, 'lps'),
	(677971, 134, '2015-02-01 00:44:29.000000', 'consum', 0.0236, 'lps'),
	(677972, 134, '2015-02-01 00:44:30.000000', 'consum', 0.0295, 'lps'),
	(677973, 134, '2015-02-01 00:44:31.000000', 'consum', 0.0249, 'lps'),
	(677974, 134, '2015-02-01 00:44:32.000000', 'consum', 0.0252, 'lps'),
	(677975, 134, '2015-02-01 00:44:33.000000', 'consum', 0.0305, 'lps'),
	(677976, 134, '2015-02-01 00:44:34.000000', 'consum', 0.0248, 'lps'),
	(677977, 134, '2015-02-01 00:44:35.000000', 'consum', 0.0220, 'lps'),
	(677978, 134, '2015-02-01 00:44:36.000000', 'consum', 0.0250, 'lps'),
	(677979, 134, '2015-02-01 00:44:37.000000', 'consum', 0.0278, 'lps'),
	(677980, 134, '2015-02-01 00:44:38.000000', 'consum', 0.0225, 'lps'),
	(677981, 134, '2015-02-01 00:44:39.000000', 'consum', 0.0287, 'lps'),
	(677982, 134, '2015-02-01 00:44:40.000000', 'consum', 0.0242, 'lps'),
	(677983, 134, '2015-02-01 00:44:41.000000', 'consum', 0.0241, 'lps'),
	(677984, 134, '2015-02-01 00:44:42.000000', 'consum', 0.0271, 'lps'),
	(677985, 134, '2015-02-01 00:44:43.000000', 'consum', 0.0215, 'lps'),
	(677986, 134, '2015-02-01 00:44:44.000000', 'consum', 0.0259, 'lps'),
	(677987, 134, '2015-02-01 00:44:45.000000', 'consum', 0.0233, 'lps'),
	(677988, 134, '2015-02-01 00:44:46.000000', 'consum', 0.0281, 'lps'),
	(677989, 134, '2015-02-01 00:44:47.000000', 'consum', 0.0294, 'lps'),
	(677990, 134, '2015-02-01 00:44:48.000000', 'consum', 0.0311, 'lps'),
	(677991, 134, '2015-02-01 00:44:49.000000', 'consum', 0.0258, 'lps'),
	(677992, 134, '2015-02-01 00:44:50.000000', 'consum', 0.0253, 'lps'),
	(677993, 134, '2015-02-01 00:44:51.000000', 'consum', 0.0278, 'lps'),
	(677994, 134, '2015-02-01 00:44:52.000000', 'consum', 0.0219, 'lps'),
	(677995, 134, '2015-02-01 00:44:53.000000', 'consum', 0.0256, 'lps'),
	(677996, 134, '2015-02-01 00:44:54.000000', 'consum', 0.0310, 'lps'),
	(677997, 134, '2015-02-01 00:44:55.000000', 'consum', 0.0266, 'lps'),
	(677998, 134, '2015-02-01 00:44:56.000000', 'consum', 0.0292, 'lps'),
	(677999, 134, '2015-02-01 00:44:57.000000', 'consum', 0.0246, 'lps'),
	(678000, 134, '2015-02-01 00:44:58.000000', 'consum', 0.0246, 'lps'),
	(678001, 134, '2015-02-01 00:44:59.000000', 'consum', 0.0284, 'lps'),
	(678002, 134, '2015-02-01 00:45:00.000000', 'consum', 0.0268, 'lps'),
	(678003, 134, '2015-02-01 00:45:01.000000', 'consum', 0.0278, 'lps'),
	(678004, 134, '2015-02-01 00:45:02.000000', 'consum', 0.0273, 'lps'),
	(678005, 134, '2015-02-01 00:45:03.000000', 'consum', 0.0216, 'lps'),
	(678006, 134, '2015-02-01 00:45:04.000000', 'consum', 0.0261, 'lps'),
	(678007, 134, '2015-02-01 00:45:05.000000', 'consum', 0.0240, 'lps'),
	(678008, 134, '2015-02-01 00:45:06.000000', 'consum', 0.0312, 'lps'),
	(678009, 134, '2015-02-01 00:45:07.000000', 'consum', 0.0219, 'lps'),
	(678010, 134, '2015-02-01 00:45:08.000000', 'consum', 0.0255, 'lps'),
	(678011, 134, '2015-02-01 00:45:09.000000', 'consum', 0.0309, 'lps'),
	(678012, 134, '2015-02-01 00:45:10.000000', 'consum', 0.0260, 'lps'),
	(678013, 134, '2015-02-01 00:45:11.000000', 'consum', 0.0266, 'lps'),
	(678014, 134, '2015-02-01 00:45:12.000000', 'consum', 0.0238, 'lps'),
	(678015, 134, '2015-02-01 00:45:13.000000', 'consum', 0.0287, 'lps'),
	(678016, 134, '2015-02-01 00:45:14.000000', 'consum', 0.0304, 'lps'),
	(678017, 134, '2015-02-01 00:45:15.000000', 'consum', 0.0246, 'lps'),
	(678018, 134, '2015-02-01 00:45:16.000000', 'consum', 0.0311, 'lps'),
	(678019, 134, '2015-02-01 00:45:17.000000', 'consum', 0.0300, 'lps'),
	(678020, 134, '2015-02-01 00:45:18.000000', 'consum', 0.0254, 'lps'),
	(678021, 134, '2015-02-01 00:45:19.000000', 'consum', 0.0265, 'lps'),
	(678022, 134, '2015-02-01 00:45:20.000000', 'consum', 0.0249, 'lps'),
	(678023, 134, '2015-02-01 00:45:21.000000', 'consum', 0.0239, 'lps'),
	(678024, 134, '2015-02-01 00:45:22.000000', 'consum', 0.0240, 'lps'),
	(678025, 134, '2015-02-01 00:45:23.000000', 'consum', 0.0272, 'lps'),
	(678026, 134, '2015-02-01 00:45:24.000000', 'consum', 0.0224, 'lps'),
	(678027, 134, '2015-02-01 00:45:25.000000', 'consum', 0.0302, 'lps'),
	(678028, 134, '2015-02-01 00:45:26.000000', 'consum', 0.0218, 'lps'),
	(678029, 134, '2015-02-01 00:45:27.000000', 'consum', 0.0283, 'lps'),
	(678030, 134, '2015-02-01 00:45:28.000000', 'consum', 0.0243, 'lps'),
	(678031, 134, '2015-02-01 00:45:29.000000', 'consum', 0.0259, 'lps'),
	(678032, 134, '2015-02-01 00:45:30.000000', 'consum', 0.0255, 'lps'),
	(678033, 134, '2015-02-01 00:45:31.000000', 'consum', 0.0289, 'lps'),
	(678034, 134, '2015-02-01 00:45:32.000000', 'consum', 0.0265, 'lps'),
	(678035, 134, '2015-02-01 00:45:33.000000', 'consum', 0.0249, 'lps'),
	(678036, 134, '2015-02-01 00:45:34.000000', 'consum', 0.0239, 'lps'),
	(678037, 134, '2015-02-01 00:45:35.000000', 'consum', 0.0238, 'lps'),
	(678038, 134, '2015-02-01 00:45:36.000000', 'consum', 0.0263, 'lps'),
	(678039, 134, '2015-02-01 00:45:37.000000', 'consum', 0.0291, 'lps'),
	(678040, 134, '2015-02-01 00:45:38.000000', 'consum', 0.0248, 'lps'),
	(678041, 134, '2015-02-01 00:45:39.000000', 'consum', 0.0263, 'lps'),
	(678042, 134, '2015-02-01 00:45:40.000000', 'consum', 0.0259, 'lps'),
	(678043, 134, '2015-02-01 00:45:41.000000', 'consum', 0.0296, 'lps'),
	(678044, 134, '2015-02-01 00:45:42.000000', 'consum', 0.0286, 'lps'),
	(678045, 134, '2015-02-01 00:45:43.000000', 'consum', 0.0230, 'lps'),
	(678046, 134, '2015-02-01 00:45:44.000000', 'consum', 0.0288, 'lps'),
	(678047, 134, '2015-02-01 00:45:45.000000', 'consum', 0.0231, 'lps'),
	(678048, 134, '2015-02-01 00:45:46.000000', 'consum', 0.0288, 'lps'),
	(678049, 134, '2015-02-01 00:45:47.000000', 'consum', 0.0227, 'lps'),
	(678050, 134, '2015-02-01 00:45:48.000000', 'consum', 0.0268, 'lps'),
	(678051, 134, '2015-02-01 00:45:49.000000', 'consum', 0.0244, 'lps'),
	(678052, 134, '2015-02-01 00:45:50.000000', 'consum', 0.0308, 'lps'),
	(678053, 134, '2015-02-01 00:45:51.000000', 'consum', 0.0290, 'lps'),
	(678054, 134, '2015-02-01 00:45:52.000000', 'consum', 0.0212, 'lps'),
	(678055, 134, '2015-02-01 00:45:53.000000', 'consum', 0.0293, 'lps'),
	(678056, 134, '2015-02-01 00:45:54.000000', 'consum', 0.0307, 'lps'),
	(678057, 134, '2015-02-01 00:45:55.000000', 'consum', 0.0243, 'lps'),
	(678058, 134, '2015-02-01 00:45:56.000000', 'consum', 0.0290, 'lps'),
	(678059, 134, '2015-02-01 00:45:57.000000', 'consum', 0.0306, 'lps'),
	(678060, 134, '2015-02-01 00:45:58.000000', 'consum', 0.0245, 'lps'),
	(678061, 134, '2015-02-01 00:45:59.000000', 'consum', 0.0304, 'lps'),
	(678062, 134, '2015-02-01 00:46:00.000000', 'consum', 0.0267, 'lps'),
	(678063, 134, '2015-02-01 00:46:01.000000', 'consum', 0.0212, 'lps'),
	(678064, 134, '2015-02-01 00:46:02.000000', 'consum', 0.0255, 'lps'),
	(678065, 134, '2015-02-01 00:46:03.000000', 'consum', 0.0223, 'lps'),
	(678066, 134, '2015-02-01 00:46:04.000000', 'consum', 0.0245, 'lps'),
	(678067, 134, '2015-02-01 00:46:05.000000', 'consum', 0.0242, 'lps'),
	(678068, 134, '2015-02-01 00:46:06.000000', 'consum', 0.0266, 'lps'),
	(678069, 134, '2015-02-01 00:46:07.000000', 'consum', 0.0292, 'lps'),
	(678070, 134, '2015-02-01 00:46:08.000000', 'consum', 0.0245, 'lps'),
	(678071, 134, '2015-02-01 00:46:09.000000', 'consum', 0.0243, 'lps'),
	(678072, 134, '2015-02-01 00:46:10.000000', 'consum', 0.0269, 'lps'),
	(678073, 134, '2015-02-01 00:46:11.000000', 'consum', 0.0304, 'lps'),
	(678074, 134, '2015-02-01 00:46:12.000000', 'consum', 0.0299, 'lps'),
	(678075, 134, '2015-02-01 00:46:13.000000', 'consum', 0.0270, 'lps'),
	(678076, 134, '2015-02-01 00:46:14.000000', 'consum', 0.0245, 'lps'),
	(678077, 134, '2015-02-01 00:46:15.000000', 'consum', 0.0308, 'lps'),
	(678078, 134, '2015-02-01 00:46:16.000000', 'consum', 0.0288, 'lps'),
	(678079, 134, '2015-02-01 00:46:17.000000', 'consum', 0.0303, 'lps'),
	(678080, 134, '2015-02-01 00:46:18.000000', 'consum', 0.0237, 'lps'),
	(678081, 134, '2015-02-01 00:46:19.000000', 'consum', 0.0274, 'lps'),
	(678082, 134, '2015-02-01 00:46:20.000000', 'consum', 0.0241, 'lps'),
	(678083, 134, '2015-02-01 00:46:21.000000', 'consum', 0.0278, 'lps'),
	(678084, 134, '2015-02-01 00:46:22.000000', 'consum', 0.0249, 'lps'),
	(678085, 134, '2015-02-01 00:46:23.000000', 'consum', 0.0307, 'lps'),
	(678086, 134, '2015-02-01 00:46:24.000000', 'consum', 0.0268, 'lps'),
	(678087, 134, '2015-02-01 00:46:25.000000', 'consum', 0.0212, 'lps'),
	(678088, 134, '2015-02-01 00:46:26.000000', 'consum', 0.0252, 'lps'),
	(678089, 134, '2015-02-01 00:46:27.000000', 'consum', 0.0309, 'lps'),
	(678090, 134, '2015-02-01 00:46:28.000000', 'consum', 0.0272, 'lps'),
	(678091, 134, '2015-02-01 00:46:29.000000', 'consum', 0.0225, 'lps'),
	(678092, 134, '2015-02-01 00:46:30.000000', 'consum', 0.0304, 'lps'),
	(678093, 134, '2015-02-01 00:46:31.000000', 'consum', 0.0223, 'lps'),
	(678094, 134, '2015-02-01 00:46:32.000000', 'consum', 0.0302, 'lps'),
	(678095, 134, '2015-02-01 00:46:33.000000', 'consum', 0.0221, 'lps'),
	(678096, 134, '2015-02-01 00:46:34.000000', 'consum', 0.0296, 'lps'),
	(678097, 134, '2015-02-01 00:46:35.000000', 'consum', 0.0302, 'lps'),
	(678098, 134, '2015-02-01 00:46:36.000000', 'consum', 0.0307, 'lps'),
	(678099, 134, '2015-02-01 00:46:37.000000', 'consum', 0.0216, 'lps'),
	(678100, 134, '2015-02-01 00:46:38.000000', 'consum', 0.0255, 'lps'),
	(678101, 134, '2015-02-01 00:46:39.000000', 'consum', 0.0214, 'lps'),
	(678102, 134, '2015-02-01 00:46:40.000000', 'consum', 0.0300, 'lps'),
	(678103, 134, '2015-02-01 00:46:41.000000', 'consum', 0.0237, 'lps'),
	(678104, 134, '2015-02-01 00:46:42.000000', 'consum', 0.0283, 'lps'),
	(678105, 134, '2015-02-01 00:46:43.000000', 'consum', 0.0287, 'lps'),
	(678106, 134, '2015-02-01 00:46:44.000000', 'consum', 0.0275, 'lps'),
	(678107, 134, '2015-02-01 00:46:45.000000', 'consum', 0.0302, 'lps'),
	(678108, 134, '2015-02-01 00:46:46.000000', 'consum', 0.0271, 'lps'),
	(678109, 134, '2015-02-01 00:46:47.000000', 'consum', 0.0240, 'lps'),
	(678110, 134, '2015-02-01 00:46:48.000000', 'consum', 0.0281, 'lps'),
	(678111, 134, '2015-02-01 00:46:49.000000', 'consum', 0.0267, 'lps'),
	(678112, 134, '2015-02-01 00:46:50.000000', 'consum', 0.0283, 'lps'),
	(678113, 134, '2015-02-01 00:46:51.000000', 'consum', 0.0300, 'lps'),
	(678114, 134, '2015-02-01 00:46:52.000000', 'consum', 0.0238, 'lps'),
	(678115, 134, '2015-02-01 00:46:53.000000', 'consum', 0.0285, 'lps'),
	(678116, 134, '2015-02-01 00:46:54.000000', 'consum', 0.0296, 'lps'),
	(678117, 134, '2015-02-01 00:46:55.000000', 'consum', 0.0211, 'lps'),
	(678118, 134, '2015-02-01 00:46:56.000000', 'consum', 0.0267, 'lps'),
	(678119, 134, '2015-02-01 00:46:57.000000', 'consum', 0.0284, 'lps'),
	(678120, 134, '2015-02-01 00:46:58.000000', 'consum', 0.0309, 'lps'),
	(678121, 134, '2015-02-01 00:46:59.000000', 'consum', 0.0276, 'lps'),
	(678122, 134, '2015-02-01 00:47:00.000000', 'consum', 0.0244, 'lps'),
	(678123, 134, '2015-02-01 00:47:01.000000', 'consum', 0.0287, 'lps'),
	(678124, 134, '2015-02-01 00:47:02.000000', 'consum', 0.0287, 'lps'),
	(678125, 134, '2015-02-01 00:47:03.000000', 'consum', 0.0260, 'lps'),
	(678126, 134, '2015-02-01 00:47:04.000000', 'consum', 0.0231, 'lps'),
	(678127, 134, '2015-02-01 00:47:05.000000', 'consum', 0.0266, 'lps'),
	(678128, 134, '2015-02-01 00:47:06.000000', 'consum', 0.0224, 'lps'),
	(678129, 134, '2015-02-01 00:47:07.000000', 'consum', 0.0214, 'lps'),
	(678130, 134, '2015-02-01 00:47:08.000000', 'consum', 0.0292, 'lps'),
	(678131, 134, '2015-02-01 00:47:09.000000', 'consum', 0.0301, 'lps'),
	(678132, 134, '2015-02-01 00:47:10.000000', 'consum', 0.0214, 'lps'),
	(678133, 134, '2015-02-01 00:47:11.000000', 'consum', 0.0266, 'lps'),
	(678134, 134, '2015-02-01 00:47:12.000000', 'consum', 0.0273, 'lps'),
	(678135, 134, '2015-02-01 00:47:13.000000', 'consum', 0.0255, 'lps'),
	(678136, 134, '2015-02-01 00:47:14.000000', 'consum', 0.0247, 'lps'),
	(678137, 134, '2015-02-01 00:47:15.000000', 'consum', 0.0260, 'lps'),
	(678138, 134, '2015-02-01 00:47:16.000000', 'consum', 0.0248, 'lps'),
	(678139, 134, '2015-02-01 00:47:17.000000', 'consum', 0.0248, 'lps'),
	(678140, 134, '2015-02-01 00:47:18.000000', 'consum', 0.0287, 'lps'),
	(678141, 134, '2015-02-01 00:47:19.000000', 'consum', 0.0275, 'lps'),
	(678142, 134, '2015-02-01 00:47:20.000000', 'consum', 0.0304, 'lps'),
	(678143, 134, '2015-02-01 00:47:21.000000', 'consum', 0.0280, 'lps'),
	(678144, 134, '2015-02-01 00:47:22.000000', 'consum', 0.0279, 'lps'),
	(678145, 134, '2015-02-01 00:47:23.000000', 'consum', 0.0241, 'lps'),
	(678146, 134, '2015-02-01 00:47:24.000000', 'consum', 0.0264, 'lps'),
	(678147, 134, '2015-02-01 00:47:25.000000', 'consum', 0.0282, 'lps'),
	(678148, 134, '2015-02-01 00:47:26.000000', 'consum', 0.0308, 'lps'),
	(678149, 134, '2015-02-01 00:47:27.000000', 'consum', 0.0276, 'lps'),
	(678150, 134, '2015-02-01 00:47:28.000000', 'consum', 0.0249, 'lps'),
	(678151, 134, '2015-02-01 00:47:29.000000', 'consum', 0.0309, 'lps'),
	(678152, 134, '2015-02-01 00:47:30.000000', 'consum', 0.0279, 'lps'),
	(678153, 134, '2015-02-01 00:47:31.000000', 'consum', 0.0258, 'lps'),
	(678154, 134, '2015-02-01 00:47:32.000000', 'consum', 0.0245, 'lps'),
	(678155, 134, '2015-02-01 00:47:33.000000', 'consum', 0.0239, 'lps'),
	(678156, 134, '2015-02-01 00:47:34.000000', 'consum', 0.0253, 'lps'),
	(678157, 134, '2015-02-01 00:47:35.000000', 'consum', 0.0234, 'lps'),
	(678158, 134, '2015-02-01 00:47:36.000000', 'consum', 0.0304, 'lps'),
	(678159, 134, '2015-02-01 00:47:37.000000', 'consum', 0.0301, 'lps'),
	(678160, 134, '2015-02-01 00:47:38.000000', 'consum', 0.0279, 'lps'),
	(678161, 134, '2015-02-01 00:47:39.000000', 'consum', 0.0285, 'lps'),
	(678162, 134, '2015-02-01 00:47:40.000000', 'consum', 0.0272, 'lps'),
	(678163, 134, '2015-02-01 00:47:41.000000', 'consum', 0.0298, 'lps'),
	(678164, 134, '2015-02-01 00:47:42.000000', 'consum', 0.0257, 'lps'),
	(678165, 134, '2015-02-01 00:47:43.000000', 'consum', 0.0283, 'lps'),
	(678166, 134, '2015-02-01 00:47:44.000000', 'consum', 0.0231, 'lps'),
	(678167, 134, '2015-02-01 00:47:45.000000', 'consum', 0.0301, 'lps'),
	(678168, 134, '2015-02-01 00:47:46.000000', 'consum', 0.0294, 'lps'),
	(678169, 134, '2015-02-01 00:47:47.000000', 'consum', 0.0253, 'lps'),
	(678170, 134, '2015-02-01 00:47:48.000000', 'consum', 0.0279, 'lps'),
	(678171, 134, '2015-02-01 00:47:49.000000', 'consum', 0.0218, 'lps'),
	(678172, 134, '2015-02-01 00:47:50.000000', 'consum', 0.0252, 'lps'),
	(678173, 134, '2015-02-01 00:47:51.000000', 'consum', 0.0291, 'lps'),
	(678174, 134, '2015-02-01 00:47:52.000000', 'consum', 0.0286, 'lps'),
	(678175, 134, '2015-02-01 00:47:53.000000', 'consum', 0.0243, 'lps'),
	(678176, 134, '2015-02-01 00:47:54.000000', 'consum', 0.0252, 'lps'),
	(678177, 134, '2015-02-01 00:47:55.000000', 'consum', 0.0218, 'lps'),
	(678178, 134, '2015-02-01 00:47:56.000000', 'consum', 0.0225, 'lps'),
	(678179, 134, '2015-02-01 00:47:57.000000', 'consum', 0.0265, 'lps'),
	(678180, 134, '2015-02-01 00:47:58.000000', 'consum', 0.0233, 'lps'),
	(678181, 134, '2015-02-01 00:47:59.000000', 'consum', 0.0265, 'lps'),
	(678182, 134, '2015-02-01 00:48:00.000000', 'consum', 0.0311, 'lps'),
	(678183, 134, '2015-02-01 00:48:01.000000', 'consum', 0.0242, 'lps'),
	(678184, 134, '2015-02-01 00:48:02.000000', 'consum', 0.0272, 'lps'),
	(678185, 134, '2015-02-01 00:48:03.000000', 'consum', 0.0219, 'lps'),
	(678186, 134, '2015-02-01 00:48:04.000000', 'consum', 0.0277, 'lps'),
	(678187, 134, '2015-02-01 00:48:05.000000', 'consum', 0.0311, 'lps'),
	(678188, 134, '2015-02-01 00:48:06.000000', 'consum', 0.0309, 'lps'),
	(678189, 134, '2015-02-01 00:48:07.000000', 'consum', 0.0299, 'lps'),
	(678190, 134, '2015-02-01 00:48:08.000000', 'consum', 0.0256, 'lps'),
	(678191, 134, '2015-02-01 00:48:09.000000', 'consum', 0.0275, 'lps'),
	(678192, 134, '2015-02-01 00:48:10.000000', 'consum', 0.0294, 'lps'),
	(678193, 134, '2015-02-01 00:48:11.000000', 'consum', 0.0230, 'lps'),
	(678194, 134, '2015-02-01 00:48:12.000000', 'consum', 0.0265, 'lps'),
	(678195, 134, '2015-02-01 00:48:13.000000', 'consum', 0.0221, 'lps'),
	(678196, 134, '2015-02-01 00:48:14.000000', 'consum', 0.0306, 'lps'),
	(678197, 134, '2015-02-01 00:48:15.000000', 'consum', 0.0246, 'lps'),
	(678198, 134, '2015-02-01 00:48:16.000000', 'consum', 0.0308, 'lps'),
	(678199, 134, '2015-02-01 00:48:17.000000', 'consum', 0.0282, 'lps'),
	(678200, 134, '2015-02-01 00:48:18.000000', 'consum', 0.0277, 'lps'),
	(678201, 134, '2015-02-01 00:48:19.000000', 'consum', 0.0225, 'lps'),
	(678202, 134, '2015-02-01 00:48:20.000000', 'consum', 0.0292, 'lps'),
	(678203, 134, '2015-02-01 00:48:21.000000', 'consum', 0.0265, 'lps'),
	(678204, 134, '2015-02-01 00:48:22.000000', 'consum', 0.0239, 'lps'),
	(678205, 134, '2015-02-01 00:48:23.000000', 'consum', 0.0296, 'lps'),
	(678206, 134, '2015-02-01 00:48:24.000000', 'consum', 0.0244, 'lps'),
	(678207, 134, '2015-02-01 00:48:25.000000', 'consum', 0.0223, 'lps'),
	(678208, 134, '2015-02-01 00:48:26.000000', 'consum', 0.0279, 'lps'),
	(678209, 134, '2015-02-01 00:48:27.000000', 'consum', 0.0310, 'lps'),
	(678210, 134, '2015-02-01 00:48:28.000000', 'consum', 0.0299, 'lps'),
	(678211, 134, '2015-02-01 00:48:29.000000', 'consum', 0.0251, 'lps'),
	(678212, 134, '2015-02-01 00:48:30.000000', 'consum', 0.0253, 'lps'),
	(678213, 134, '2015-02-01 00:48:31.000000', 'consum', 0.0302, 'lps'),
	(678214, 134, '2015-02-01 00:48:32.000000', 'consum', 0.0230, 'lps'),
	(678215, 134, '2015-02-01 00:48:33.000000', 'consum', 0.0243, 'lps'),
	(678216, 134, '2015-02-01 00:48:34.000000', 'consum', 0.0213, 'lps'),
	(678217, 134, '2015-02-01 00:48:35.000000', 'consum', 0.0228, 'lps'),
	(678218, 134, '2015-02-01 00:48:36.000000', 'consum', 0.0294, 'lps'),
	(678219, 134, '2015-02-01 00:48:37.000000', 'consum', 0.0267, 'lps'),
	(678220, 134, '2015-02-01 00:48:38.000000', 'consum', 0.0241, 'lps'),
	(678221, 134, '2015-02-01 00:48:39.000000', 'consum', 0.0300, 'lps'),
	(678222, 134, '2015-02-01 00:48:40.000000', 'consum', 0.0259, 'lps'),
	(678223, 134, '2015-02-01 00:48:41.000000', 'consum', 0.0290, 'lps'),
	(678224, 134, '2015-02-01 00:48:42.000000', 'consum', 0.0254, 'lps'),
	(678225, 134, '2015-02-01 00:48:43.000000', 'consum', 0.0296, 'lps'),
	(678226, 134, '2015-02-01 00:48:44.000000', 'consum', 0.0301, 'lps'),
	(678227, 134, '2015-02-01 00:48:45.000000', 'consum', 0.0304, 'lps'),
	(678228, 134, '2015-02-01 00:48:46.000000', 'consum', 0.0304, 'lps'),
	(678229, 134, '2015-02-01 00:48:47.000000', 'consum', 0.0296, 'lps'),
	(678230, 134, '2015-02-01 00:48:48.000000', 'consum', 0.0254, 'lps'),
	(678231, 134, '2015-02-01 00:48:49.000000', 'consum', 0.0276, 'lps'),
	(678232, 134, '2015-02-01 00:48:50.000000', 'consum', 0.0308, 'lps'),
	(678233, 134, '2015-02-01 00:48:51.000000', 'consum', 0.0295, 'lps'),
	(678234, 134, '2015-02-01 00:48:52.000000', 'consum', 0.0238, 'lps'),
	(678235, 134, '2015-02-01 00:48:53.000000', 'consum', 0.0303, 'lps'),
	(678236, 134, '2015-02-01 00:48:54.000000', 'consum', 0.0281, 'lps'),
	(678237, 134, '2015-02-01 00:48:55.000000', 'consum', 0.0287, 'lps'),
	(678238, 134, '2015-02-01 00:48:56.000000', 'consum', 0.0279, 'lps'),
	(678239, 134, '2015-02-01 00:48:57.000000', 'consum', 0.0222, 'lps'),
	(678240, 134, '2015-02-01 00:48:58.000000', 'consum', 0.0271, 'lps'),
	(678241, 134, '2015-02-01 00:48:59.000000', 'consum', 0.0273, 'lps'),
	(678242, 134, '2015-02-01 00:49:00.000000', 'consum', 0.0238, 'lps'),
	(678243, 134, '2015-02-01 00:49:01.000000', 'consum', 0.0267, 'lps'),
	(678244, 134, '2015-02-01 00:49:02.000000', 'consum', 0.0308, 'lps'),
	(678245, 134, '2015-02-01 00:49:03.000000', 'consum', 0.0219, 'lps'),
	(678246, 134, '2015-02-01 00:49:04.000000', 'consum', 0.0269, 'lps'),
	(678247, 134, '2015-02-01 00:49:05.000000', 'consum', 0.0274, 'lps'),
	(678248, 134, '2015-02-01 00:49:06.000000', 'consum', 0.0253, 'lps'),
	(678249, 134, '2015-02-01 00:49:07.000000', 'consum', 0.0230, 'lps'),
	(678250, 134, '2015-02-01 00:49:08.000000', 'consum', 0.0285, 'lps'),
	(678251, 134, '2015-02-01 00:49:09.000000', 'consum', 0.0216, 'lps'),
	(678252, 134, '2015-02-01 00:49:10.000000', 'consum', 0.0224, 'lps'),
	(678253, 134, '2015-02-01 00:49:11.000000', 'consum', 0.0261, 'lps'),
	(678254, 134, '2015-02-01 00:49:12.000000', 'consum', 0.0218, 'lps'),
	(678255, 134, '2015-02-01 00:49:13.000000', 'consum', 0.0302, 'lps'),
	(678256, 134, '2015-02-01 00:49:14.000000', 'consum', 0.0234, 'lps'),
	(678257, 134, '2015-02-01 00:49:15.000000', 'consum', 0.0261, 'lps'),
	(678258, 134, '2015-02-01 00:49:16.000000', 'consum', 0.0291, 'lps'),
	(678259, 134, '2015-02-01 00:49:17.000000', 'consum', 0.0256, 'lps'),
	(678260, 134, '2015-02-01 00:49:18.000000', 'consum', 0.0300, 'lps'),
	(678261, 134, '2015-02-01 00:49:19.000000', 'consum', 0.0214, 'lps'),
	(678262, 134, '2015-02-01 00:49:20.000000', 'consum', 0.0268, 'lps'),
	(678263, 134, '2015-02-01 00:49:21.000000', 'consum', 0.0285, 'lps'),
	(678264, 134, '2015-02-01 00:49:22.000000', 'consum', 0.0308, 'lps'),
	(678265, 134, '2015-02-01 00:49:23.000000', 'consum', 0.0271, 'lps'),
	(678266, 134, '2015-02-01 00:49:24.000000', 'consum', 0.0221, 'lps'),
	(678267, 134, '2015-02-01 00:49:25.000000', 'consum', 0.0288, 'lps'),
	(678268, 134, '2015-02-01 00:49:26.000000', 'consum', 0.0259, 'lps'),
	(678269, 134, '2015-02-01 00:49:27.000000', 'consum', 0.0219, 'lps'),
	(678270, 134, '2015-02-01 00:49:28.000000', 'consum', 0.0214, 'lps'),
	(678271, 134, '2015-02-01 00:49:29.000000', 'consum', 0.0306, 'lps'),
	(678272, 134, '2015-02-01 00:49:30.000000', 'consum', 0.0267, 'lps'),
	(678273, 134, '2015-02-01 00:49:31.000000', 'consum', 0.0310, 'lps'),
	(678274, 134, '2015-02-01 00:49:32.000000', 'consum', 0.0231, 'lps'),
	(678275, 134, '2015-02-01 00:49:33.000000', 'consum', 0.0219, 'lps'),
	(678276, 134, '2015-02-01 00:49:34.000000', 'consum', 0.0298, 'lps'),
	(678277, 134, '2015-02-01 00:49:35.000000', 'consum', 0.0211, 'lps'),
	(678278, 134, '2015-02-01 00:49:36.000000', 'consum', 0.0260, 'lps'),
	(678279, 134, '2015-02-01 00:49:37.000000', 'consum', 0.0253, 'lps'),
	(678280, 134, '2015-02-01 00:49:38.000000', 'consum', 0.0277, 'lps'),
	(678281, 134, '2015-02-01 00:49:39.000000', 'consum', 0.0310, 'lps'),
	(678282, 134, '2015-02-01 00:49:40.000000', 'consum', 0.0304, 'lps'),
	(678283, 134, '2015-02-01 00:49:41.000000', 'consum', 0.0278, 'lps'),
	(678284, 134, '2015-02-01 00:49:42.000000', 'consum', 0.0267, 'lps'),
	(678285, 134, '2015-02-01 00:49:43.000000', 'consum', 0.0294, 'lps'),
	(678286, 134, '2015-02-01 00:49:44.000000', 'consum', 0.0254, 'lps'),
	(678287, 134, '2015-02-01 00:49:45.000000', 'consum', 0.0282, 'lps'),
	(678288, 134, '2015-02-01 00:49:46.000000', 'consum', 0.0229, 'lps'),
	(678289, 134, '2015-02-01 00:49:47.000000', 'consum', 0.0299, 'lps'),
	(678290, 134, '2015-02-01 00:49:48.000000', 'consum', 0.0286, 'lps'),
	(678291, 134, '2015-02-01 00:49:49.000000', 'consum', 0.0223, 'lps'),
	(678292, 134, '2015-02-01 00:49:50.000000', 'consum', 0.0252, 'lps'),
	(678293, 134, '2015-02-01 00:49:51.000000', 'consum', 0.0278, 'lps'),
	(678294, 134, '2015-02-01 00:49:52.000000', 'consum', 0.0220, 'lps'),
	(678295, 134, '2015-02-01 00:49:53.000000', 'consum', 0.0261, 'lps'),
	(678296, 134, '2015-02-01 00:49:54.000000', 'consum', 0.0229, 'lps'),
	(678297, 134, '2015-02-01 00:49:55.000000', 'consum', 0.0258, 'lps'),
	(678298, 134, '2015-02-01 00:49:56.000000', 'consum', 0.0288, 'lps'),
	(678299, 134, '2015-02-01 00:49:57.000000', 'consum', 0.0250, 'lps'),
	(678300, 134, '2015-02-01 00:49:58.000000', 'consum', 0.0282, 'lps'),
	(678301, 134, '2015-02-01 00:49:59.000000', 'consum', 0.0242, 'lps'),
	(678302, 134, '2015-02-01 00:50:00.000000', 'consum', 0.0257, 'lps'),
	(678303, 134, '2015-02-01 00:50:01.000000', 'consum', 0.0247, 'lps'),
	(678304, 134, '2015-02-01 00:50:02.000000', 'consum', 0.0255, 'lps'),
	(678305, 134, '2015-02-01 00:50:03.000000', 'consum', 0.0220, 'lps'),
	(678306, 134, '2015-02-01 00:50:04.000000', 'consum', 0.0230, 'lps'),
	(678307, 134, '2015-02-01 00:50:05.000000', 'consum', 0.0281, 'lps'),
	(678308, 134, '2015-02-01 00:50:06.000000', 'consum', 0.0300, 'lps'),
	(678309, 134, '2015-02-01 00:50:07.000000', 'consum', 0.0241, 'lps'),
	(678310, 134, '2015-02-01 00:50:08.000000', 'consum', 0.0300, 'lps'),
	(678311, 134, '2015-02-01 00:50:09.000000', 'consum', 0.0260, 'lps'),
	(678312, 134, '2015-02-01 00:50:10.000000', 'consum', 0.0292, 'lps'),
	(678313, 134, '2015-02-01 00:50:11.000000', 'consum', 0.0265, 'lps'),
	(678314, 134, '2015-02-01 00:50:12.000000', 'consum', 0.0240, 'lps'),
	(678315, 134, '2015-02-01 00:50:13.000000', 'consum', 0.0300, 'lps'),
	(678316, 134, '2015-02-01 00:50:14.000000', 'consum', 0.0259, 'lps'),
	(678317, 134, '2015-02-01 00:50:15.000000', 'consum', 0.0290, 'lps'),
	(678318, 134, '2015-02-01 00:50:16.000000', 'consum', 0.0255, 'lps'),
	(678319, 134, '2015-02-01 00:50:17.000000', 'consum', 0.0300, 'lps'),
	(678320, 134, '2015-02-01 00:50:18.000000', 'consum', 0.0217, 'lps'),
	(678321, 134, '2015-02-01 00:50:19.000000', 'consum', 0.0283, 'lps'),
	(678322, 134, '2015-02-01 00:50:20.000000', 'consum', 0.0245, 'lps'),
	(678323, 134, '2015-02-01 00:50:21.000000', 'consum', 0.0269, 'lps'),
	(678324, 134, '2015-02-01 00:50:22.000000', 'consum', 0.0297, 'lps'),
	(678325, 134, '2015-02-01 00:50:23.000000', 'consum', 0.0264, 'lps'),
	(678326, 134, '2015-02-01 00:50:24.000000', 'consum', 0.0219, 'lps'),
	(678327, 134, '2015-02-01 00:50:25.000000', 'consum', 0.0300, 'lps'),
	(678328, 134, '2015-02-01 00:50:26.000000', 'consum', 0.0222, 'lps'),
	(678329, 134, '2015-02-01 00:50:27.000000', 'consum', 0.0307, 'lps'),
	(678330, 134, '2015-02-01 00:50:28.000000', 'consum', 0.0250, 'lps'),
	(678331, 134, '2015-02-01 00:50:29.000000', 'consum', 0.0220, 'lps'),
	(678332, 134, '2015-02-01 00:50:30.000000', 'consum', 0.0246, 'lps'),
	(678333, 134, '2015-02-01 00:50:31.000000', 'consum', 0.0256, 'lps'),
	(678334, 134, '2015-02-01 00:50:32.000000', 'consum', 0.0228, 'lps'),
	(678335, 134, '2015-02-01 00:50:33.000000', 'consum', 0.0269, 'lps'),
	(678336, 134, '2015-02-01 00:50:34.000000', 'consum', 0.0243, 'lps'),
	(678337, 134, '2015-02-01 00:50:35.000000', 'consum', 0.0302, 'lps'),
	(678338, 134, '2015-02-01 00:50:36.000000', 'consum', 0.0262, 'lps'),
	(678339, 134, '2015-02-01 00:50:37.000000', 'consum', 0.0297, 'lps'),
	(678340, 134, '2015-02-01 00:50:38.000000', 'consum', 0.0282, 'lps'),
	(678341, 134, '2015-02-01 00:50:39.000000', 'consum', 0.0210, 'lps'),
	(678342, 134, '2015-02-01 00:50:40.000000', 'consum', 0.0301, 'lps'),
	(678343, 134, '2015-02-01 00:50:41.000000', 'consum', 0.0255, 'lps'),
	(678344, 134, '2015-02-01 00:50:42.000000', 'consum', 0.0267, 'lps'),
	(678345, 134, '2015-02-01 00:50:43.000000', 'consum', 0.0257, 'lps'),
	(678346, 134, '2015-02-01 00:50:44.000000', 'consum', 0.0272, 'lps'),
	(678347, 134, '2015-02-01 00:50:45.000000', 'consum', 0.0278, 'lps'),
	(678348, 134, '2015-02-01 00:50:46.000000', 'consum', 0.0262, 'lps'),
	(678349, 134, '2015-02-01 00:50:47.000000', 'consum', 0.0267, 'lps'),
	(678350, 134, '2015-02-01 00:50:48.000000', 'consum', 0.0237, 'lps'),
	(678351, 134, '2015-02-01 00:50:49.000000', 'consum', 0.0275, 'lps'),
	(678352, 134, '2015-02-01 00:50:50.000000', 'consum', 0.0251, 'lps'),
	(678353, 134, '2015-02-01 00:50:51.000000', 'consum', 0.0221, 'lps'),
	(678354, 134, '2015-02-01 00:50:52.000000', 'consum', 0.0245, 'lps'),
	(678355, 134, '2015-02-01 00:50:53.000000', 'consum', 0.0249, 'lps'),
	(678356, 134, '2015-02-01 00:50:54.000000', 'consum', 0.0300, 'lps'),
	(678357, 134, '2015-02-01 00:50:55.000000', 'consum', 0.0234, 'lps'),
	(678358, 134, '2015-02-01 00:50:56.000000', 'consum', 0.0267, 'lps'),
	(678359, 134, '2015-02-01 00:50:57.000000', 'consum', 0.0218, 'lps'),
	(678360, 134, '2015-02-01 00:50:58.000000', 'consum', 0.0286, 'lps'),
	(678361, 134, '2015-02-01 00:50:59.000000', 'consum', 0.0257, 'lps'),
	(678362, 134, '2015-02-01 00:51:00.000000', 'consum', 0.0216, 'lps'),
	(678363, 134, '2015-02-01 00:51:01.000000', 'consum', 0.0308, 'lps'),
	(678364, 134, '2015-02-01 00:51:02.000000', 'consum', 0.0270, 'lps'),
	(678365, 134, '2015-02-01 00:51:03.000000', 'consum', 0.0216, 'lps'),
	(678366, 134, '2015-02-01 00:51:04.000000', 'consum', 0.0269, 'lps'),
	(678367, 134, '2015-02-01 00:51:05.000000', 'consum', 0.0279, 'lps'),
	(678368, 134, '2015-02-01 00:51:06.000000', 'consum', 0.0274, 'lps'),
	(678369, 134, '2015-02-01 00:51:07.000000', 'consum', 0.0223, 'lps'),
	(678370, 134, '2015-02-01 00:51:08.000000', 'consum', 0.0288, 'lps'),
	(678371, 134, '2015-02-01 00:51:09.000000', 'consum', 0.0253, 'lps'),
	(678372, 134, '2015-02-01 00:51:10.000000', 'consum', 0.0293, 'lps'),
	(678373, 134, '2015-02-01 00:51:11.000000', 'consum', 0.0291, 'lps'),
	(678374, 134, '2015-02-01 00:51:12.000000', 'consum', 0.0264, 'lps'),
	(678375, 134, '2015-02-01 00:51:13.000000', 'consum', 0.0237, 'lps'),
	(678376, 134, '2015-02-01 00:51:14.000000', 'consum', 0.0285, 'lps'),
	(678377, 134, '2015-02-01 00:51:15.000000', 'consum', 0.0300, 'lps'),
	(678378, 134, '2015-02-01 00:51:16.000000', 'consum', 0.0228, 'lps'),
	(678379, 134, '2015-02-01 00:51:17.000000', 'consum', 0.0238, 'lps'),
	(678380, 134, '2015-02-01 00:51:18.000000', 'consum', 0.0295, 'lps'),
	(678381, 134, '2015-02-01 00:51:19.000000', 'consum', 0.0242, 'lps'),
	(678382, 134, '2015-02-01 00:51:20.000000', 'consum', 0.0220, 'lps'),
	(678383, 134, '2015-02-01 00:51:21.000000', 'consum', 0.0269, 'lps'),
	(678384, 134, '2015-02-01 00:51:22.000000', 'consum', 0.0268, 'lps'),
	(678385, 134, '2015-02-01 00:51:23.000000', 'consum', 0.0221, 'lps'),
	(678386, 134, '2015-02-01 00:51:24.000000', 'consum', 0.0299, 'lps'),
	(678387, 134, '2015-02-01 00:51:25.000000', 'consum', 0.0310, 'lps'),
	(678388, 134, '2015-02-01 00:51:26.000000', 'consum', 0.0240, 'lps'),
	(678389, 134, '2015-02-01 00:51:27.000000', 'consum', 0.0266, 'lps'),
	(678390, 134, '2015-02-01 00:51:28.000000', 'consum', 0.0298, 'lps'),
	(678391, 134, '2015-02-01 00:51:29.000000', 'consum', 0.0278, 'lps'),
	(678392, 134, '2015-02-01 00:51:30.000000', 'consum', 0.0285, 'lps'),
	(678393, 134, '2015-02-01 00:51:31.000000', 'consum', 0.0277, 'lps'),
	(678394, 134, '2015-02-01 00:51:32.000000', 'consum', 0.0218, 'lps'),
	(678395, 134, '2015-02-01 00:51:33.000000', 'consum', 0.0257, 'lps'),
	(678396, 134, '2015-02-01 00:51:34.000000', 'consum', 0.0214, 'lps'),
	(678397, 134, '2015-02-01 00:51:35.000000', 'consum', 0.0295, 'lps'),
	(678398, 134, '2015-02-01 00:51:36.000000', 'consum', 0.0212, 'lps'),
	(678399, 134, '2015-02-01 00:51:37.000000', 'consum', 0.0275, 'lps'),
	(678400, 134, '2015-02-01 00:51:38.000000', 'consum', 0.0220, 'lps'),
	(678401, 134, '2015-02-01 00:51:39.000000', 'consum', 0.0272, 'lps'),
	(678402, 134, '2015-02-01 00:51:40.000000', 'consum', 0.0283, 'lps'),
	(678403, 134, '2015-02-01 00:51:41.000000', 'consum', 0.0289, 'lps'),
	(678404, 134, '2015-02-01 00:51:42.000000', 'consum', 0.0284, 'lps'),
	(678405, 134, '2015-02-01 00:51:43.000000', 'consum', 0.0241, 'lps'),
	(678406, 134, '2015-02-01 00:51:44.000000', 'consum', 0.0245, 'lps'),
	(678407, 134, '2015-02-01 00:51:45.000000', 'consum', 0.0293, 'lps'),
	(678408, 134, '2015-02-01 00:51:46.000000', 'consum', 0.0211, 'lps'),
	(678409, 134, '2015-02-01 00:51:47.000000', 'consum', 0.0277, 'lps'),
	(678410, 134, '2015-02-01 00:51:48.000000', 'consum', 0.0234, 'lps'),
	(678411, 134, '2015-02-01 00:51:49.000000', 'consum', 0.0231, 'lps'),
	(678412, 134, '2015-02-01 00:51:50.000000', 'consum', 0.0242, 'lps'),
	(678413, 134, '2015-02-01 00:51:51.000000', 'consum', 0.0311, 'lps'),
	(678414, 134, '2015-02-01 00:51:52.000000', 'consum', 0.0309, 'lps'),
	(678415, 134, '2015-02-01 00:51:53.000000', 'consum', 0.0298, 'lps'),
	(678416, 134, '2015-02-01 00:51:54.000000', 'consum', 0.0250, 'lps'),
	(678417, 134, '2015-02-01 00:51:55.000000', 'consum', 0.0249, 'lps'),
	(678418, 134, '2015-02-01 00:51:56.000000', 'consum', 0.0288, 'lps'),
	(678419, 134, '2015-02-01 00:51:57.000000', 'consum', 0.0276, 'lps'),
	(678420, 134, '2015-02-01 00:51:58.000000', 'consum', 0.0308, 'lps'),
	(678421, 134, '2015-02-01 00:51:59.000000', 'consum', 0.0295, 'lps'),
	(678422, 134, '2015-02-01 00:52:00.000000', 'consum', 0.0238, 'lps'),
	(678423, 134, '2015-02-01 00:52:01.000000', 'consum', 0.0303, 'lps'),
	(678424, 134, '2015-02-01 00:52:02.000000', 'consum', 0.0281, 'lps'),
	(678425, 134, '2015-02-01 00:52:03.000000', 'consum', 0.0288, 'lps'),
	(678426, 134, '2015-02-01 00:52:04.000000', 'consum', 0.0283, 'lps'),
	(678427, 134, '2015-02-01 00:52:05.000000', 'consum', 0.0240, 'lps'),
	(678428, 134, '2015-02-01 00:52:06.000000', 'consum', 0.0245, 'lps'),
	(678429, 134, '2015-02-01 00:52:07.000000', 'consum', 0.0293, 'lps'),
	(678430, 134, '2015-02-01 00:52:08.000000', 'consum', 0.0211, 'lps'),
	(678431, 134, '2015-02-01 00:52:09.000000', 'consum', 0.0278, 'lps'),
	(678432, 134, '2015-02-01 00:52:10.000000', 'consum', 0.0237, 'lps'),
	(678433, 134, '2015-02-01 00:52:11.000000', 'consum', 0.0243, 'lps'),
	(678434, 134, '2015-02-01 00:52:12.000000', 'consum', 0.0296, 'lps'),
	(678435, 134, '2015-02-01 00:52:13.000000', 'consum', 0.0231, 'lps'),
	(678436, 134, '2015-02-01 00:52:14.000000', 'consum', 0.0263, 'lps'),
	(678437, 134, '2015-02-01 00:52:15.000000', 'consum', 0.0310, 'lps'),
	(678438, 134, '2015-02-01 00:52:16.000000', 'consum', 0.0243, 'lps'),
	(678439, 134, '2015-02-01 00:52:17.000000', 'consum', 0.0281, 'lps'),
	(678440, 134, '2015-02-01 00:52:18.000000', 'consum', 0.0260, 'lps'),
	(678441, 134, '2015-02-01 00:52:19.000000', 'consum', 0.0248, 'lps'),
	(678442, 134, '2015-02-01 00:52:20.000000', 'consum', 0.0249, 'lps'),
	(678443, 134, '2015-02-01 00:52:21.000000', 'consum', 0.0295, 'lps'),
	(678444, 134, '2015-02-01 00:52:22.000000', 'consum', 0.0310, 'lps'),
	(678445, 134, '2015-02-01 00:52:23.000000', 'consum', 0.0248, 'lps'),
	(678446, 134, '2015-02-01 00:52:24.000000', 'consum', 0.0309, 'lps'),
	(678447, 134, '2015-02-01 00:52:25.000000', 'consum', 0.0282, 'lps'),
	(678448, 134, '2015-02-01 00:52:26.000000', 'consum', 0.0271, 'lps'),
	(678449, 134, '2015-02-01 00:52:27.000000', 'consum', 0.0302, 'lps'),
	(678450, 134, '2015-02-01 00:52:28.000000', 'consum', 0.0281, 'lps'),
	(678451, 134, '2015-02-01 00:52:29.000000', 'consum', 0.0288, 'lps'),
	(678452, 134, '2015-02-01 00:52:30.000000', 'consum', 0.0284, 'lps'),
	(678453, 134, '2015-02-01 00:52:31.000000', 'consum', 0.0244, 'lps'),
	(678454, 134, '2015-02-01 00:52:32.000000', 'consum', 0.0261, 'lps'),
	(678455, 134, '2015-02-01 00:52:33.000000', 'consum', 0.0259, 'lps'),
	(678456, 134, '2015-02-01 00:52:34.000000', 'consum', 0.0305, 'lps'),
	(678457, 134, '2015-02-01 00:52:35.000000', 'consum', 0.0229, 'lps'),
	(678458, 134, '2015-02-01 00:52:36.000000', 'consum', 0.0225, 'lps'),
	(678459, 134, '2015-02-01 00:52:37.000000', 'consum', 0.0231, 'lps'),
	(678460, 134, '2015-02-01 00:52:38.000000', 'consum', 0.0269, 'lps'),
	(678461, 134, '2015-02-01 00:52:39.000000', 'consum', 0.0238, 'lps'),
	(678462, 134, '2015-02-01 00:52:40.000000', 'consum', 0.0276, 'lps'),
	(678463, 134, '2015-02-01 00:52:41.000000', 'consum', 0.0251, 'lps'),
	(678464, 134, '2015-02-01 00:52:42.000000', 'consum', 0.0217, 'lps'),
	(678465, 134, '2015-02-01 00:52:43.000000', 'consum', 0.0225, 'lps'),
	(678466, 134, '2015-02-01 00:52:44.000000', 'consum', 0.0266, 'lps'),
	(678467, 134, '2015-02-01 00:52:45.000000', 'consum', 0.0239, 'lps'),
	(678468, 134, '2015-02-01 00:52:46.000000', 'consum', 0.0292, 'lps'),
	(678469, 134, '2015-02-01 00:52:47.000000', 'consum', 0.0224, 'lps'),
	(678470, 134, '2015-02-01 00:52:48.000000', 'consum', 0.0240, 'lps'),
	(678471, 134, '2015-02-01 00:52:49.000000', 'consum', 0.0217, 'lps'),
	(678472, 134, '2015-02-01 00:52:50.000000', 'consum', 0.0257, 'lps'),
	(678473, 134, '2015-02-01 00:52:51.000000', 'consum', 0.0219, 'lps'),
	(678474, 134, '2015-02-01 00:52:52.000000', 'consum', 0.0217, 'lps'),
	(678475, 134, '2015-02-01 00:52:53.000000', 'consum', 0.0219, 'lps'),
	(678476, 134, '2015-02-01 00:52:54.000000', 'consum', 0.0235, 'lps'),
	(678477, 134, '2015-02-01 00:52:55.000000', 'consum', 0.0307, 'lps'),
	(678478, 134, '2015-02-01 00:52:56.000000', 'consum', 0.0311, 'lps'),
	(678479, 134, '2015-02-01 00:52:57.000000', 'consum', 0.0219, 'lps'),
	(678480, 134, '2015-02-01 00:52:58.000000', 'consum', 0.0261, 'lps'),
	(678481, 134, '2015-02-01 00:52:59.000000', 'consum', 0.0235, 'lps'),
	(678482, 134, '2015-02-01 00:53:00.000000', 'consum', 0.0283, 'lps'),
	(678483, 134, '2015-02-01 00:53:01.000000', 'consum', 0.0294, 'lps'),
	(678484, 134, '2015-02-01 00:53:02.000000', 'consum', 0.0310, 'lps'),
	(678485, 134, '2015-02-01 00:53:03.000000', 'consum', 0.0253, 'lps'),
	(678486, 134, '2015-02-01 00:53:04.000000', 'consum', 0.0227, 'lps'),
	(678487, 134, '2015-02-01 00:53:05.000000', 'consum', 0.0270, 'lps'),
	(678488, 134, '2015-02-01 00:53:06.000000', 'consum', 0.0253, 'lps'),
	(678489, 134, '2015-02-01 00:53:07.000000', 'consum', 0.0245, 'lps'),
	(678490, 134, '2015-02-01 00:53:08.000000', 'consum', 0.0256, 'lps'),
	(678491, 134, '2015-02-01 00:53:09.000000', 'consum', 0.0232, 'lps'),
	(678492, 134, '2015-02-01 00:53:10.000000', 'consum', 0.0288, 'lps'),
	(678493, 134, '2015-02-01 00:53:11.000000', 'consum', 0.0223, 'lps'),
	(678494, 134, '2015-02-01 00:53:12.000000', 'consum', 0.0249, 'lps'),
	(678495, 134, '2015-02-01 00:53:13.000000', 'consum', 0.0264, 'lps'),
	(678496, 134, '2015-02-01 00:53:14.000000', 'consum', 0.0260, 'lps'),
	(678497, 134, '2015-02-01 00:53:15.000000', 'consum', 0.0298, 'lps'),
	(678498, 134, '2015-02-01 00:53:16.000000', 'consum', 0.0295, 'lps'),
	(678499, 134, '2015-02-01 00:53:17.000000', 'consum', 0.0267, 'lps'),
	(678500, 134, '2015-02-01 00:53:18.000000', 'consum', 0.0243, 'lps'),
	(678501, 134, '2015-02-01 00:53:19.000000', 'consum', 0.0308, 'lps'),
	(678502, 134, '2015-02-01 00:53:20.000000', 'consum', 0.0293, 'lps'),
	(678503, 134, '2015-02-01 00:53:21.000000', 'consum', 0.0226, 'lps'),
	(678504, 134, '2015-02-01 00:53:22.000000', 'consum', 0.0249, 'lps'),
	(678505, 134, '2015-02-01 00:53:23.000000', 'consum', 0.0252, 'lps'),
	(678506, 134, '2015-02-01 00:53:24.000000', 'consum', 0.0306, 'lps'),
	(678507, 134, '2015-02-01 00:53:25.000000', 'consum', 0.0254, 'lps'),
	(678508, 134, '2015-02-01 00:53:26.000000', 'consum', 0.0246, 'lps'),
	(678509, 134, '2015-02-01 00:53:27.000000', 'consum', 0.0256, 'lps'),
	(678510, 134, '2015-02-01 00:53:28.000000', 'consum', 0.0233, 'lps'),
	(678511, 134, '2015-02-01 00:53:29.000000', 'consum', 0.0289, 'lps'),
	(678512, 134, '2015-02-01 00:53:30.000000', 'consum', 0.0229, 'lps'),
	(678513, 134, '2015-02-01 00:53:31.000000', 'consum', 0.0274, 'lps'),
	(678514, 134, '2015-02-01 00:53:32.000000', 'consum', 0.0268, 'lps'),
	(678515, 134, '2015-02-01 00:53:33.000000', 'consum', 0.0309, 'lps'),
	(678516, 134, '2015-02-01 00:53:34.000000', 'consum', 0.0222, 'lps'),
	(678517, 134, '2015-02-01 00:53:35.000000', 'consum', 0.0281, 'lps'),
	(678518, 134, '2015-02-01 00:53:36.000000', 'consum', 0.0221, 'lps'),
	(678519, 134, '2015-02-01 00:53:37.000000', 'consum', 0.0257, 'lps'),
	(678520, 134, '2015-02-01 00:53:38.000000', 'consum', 0.0311, 'lps'),
	(678521, 134, '2015-02-01 00:53:39.000000', 'consum', 0.0267, 'lps'),
	(678522, 134, '2015-02-01 00:53:40.000000', 'consum', 0.0294, 'lps'),
	(678523, 134, '2015-02-01 00:53:41.000000', 'consum', 0.0253, 'lps'),
	(678524, 134, '2015-02-01 00:53:42.000000', 'consum', 0.0275, 'lps'),
	(678525, 134, '2015-02-01 00:53:43.000000', 'consum', 0.0305, 'lps'),
	(678526, 134, '2015-02-01 00:53:44.000000', 'consum', 0.0283, 'lps'),
	(678527, 134, '2015-02-01 00:53:45.000000', 'consum', 0.0293, 'lps'),
	(678528, 134, '2015-02-01 00:53:46.000000', 'consum', 0.0305, 'lps'),
	(678529, 134, '2015-02-01 00:53:47.000000', 'consum', 0.0227, 'lps'),
	(678530, 134, '2015-02-01 00:53:48.000000', 'consum', 0.0216, 'lps'),
	(678531, 134, '2015-02-01 00:53:49.000000', 'consum', 0.0295, 'lps'),
	(678532, 134, '2015-02-01 00:53:50.000000', 'consum', 0.0306, 'lps'),
	(678533, 134, '2015-02-01 00:53:51.000000', 'consum', 0.0230, 'lps'),
	(678534, 134, '2015-02-01 00:53:52.000000', 'consum', 0.0229, 'lps'),
	(678535, 134, '2015-02-01 00:53:53.000000', 'consum', 0.0244, 'lps'),
	(678536, 134, '2015-02-01 00:53:54.000000', 'consum', 0.0221, 'lps'),
	(678537, 134, '2015-02-01 00:53:55.000000', 'consum', 0.0265, 'lps'),
	(678538, 134, '2015-02-01 00:53:56.000000', 'consum', 0.0249, 'lps'),
	(678539, 134, '2015-02-01 00:53:57.000000', 'consum', 0.0238, 'lps'),
	(678540, 134, '2015-02-01 00:53:58.000000', 'consum', 0.0233, 'lps'),
	(678541, 134, '2015-02-01 00:53:59.000000', 'consum', 0.0243, 'lps'),
	(678542, 134, '2015-02-01 00:54:00.000000', 'consum', 0.0308, 'lps'),
	(678543, 134, '2015-02-01 00:54:01.000000', 'consum', 0.0290, 'lps'),
	(678544, 134, '2015-02-01 00:54:02.000000', 'consum', 0.0214, 'lps'),
	(678545, 134, '2015-02-01 00:54:03.000000', 'consum', 0.0298, 'lps'),
	(678546, 134, '2015-02-01 00:54:04.000000', 'consum', 0.0228, 'lps'),
	(678547, 134, '2015-02-01 00:54:05.000000', 'consum', 0.0243, 'lps'),
	(678548, 134, '2015-02-01 00:54:06.000000', 'consum', 0.0219, 'lps'),
	(678549, 134, '2015-02-01 00:54:07.000000', 'consum', 0.0258, 'lps'),
	(678550, 134, '2015-02-01 00:54:08.000000', 'consum', 0.0217, 'lps'),
	(678551, 134, '2015-02-01 00:54:09.000000', 'consum', 0.0306, 'lps'),
	(678552, 134, '2015-02-01 00:54:10.000000', 'consum', 0.0260, 'lps'),
	(678553, 134, '2015-02-01 00:54:11.000000', 'consum', 0.0274, 'lps'),
	(678554, 134, '2015-02-01 00:54:12.000000', 'consum', 0.0276, 'lps'),
	(678555, 134, '2015-02-01 00:54:13.000000', 'consum', 0.0248, 'lps'),
	(678556, 134, '2015-02-01 00:54:14.000000', 'consum', 0.0303, 'lps'),
	(678557, 134, '2015-02-01 00:54:15.000000', 'consum', 0.0254, 'lps'),
	(678558, 134, '2015-02-01 00:54:16.000000', 'consum', 0.0255, 'lps'),
	(678559, 134, '2015-02-01 00:54:17.000000', 'consum', 0.0303, 'lps'),
	(678560, 134, '2015-02-01 00:54:18.000000', 'consum', 0.0232, 'lps'),
	(678561, 134, '2015-02-01 00:54:19.000000', 'consum', 0.0246, 'lps'),
	(678562, 134, '2015-02-01 00:54:20.000000', 'consum', 0.0222, 'lps'),
	(678563, 134, '2015-02-01 00:54:21.000000', 'consum', 0.0265, 'lps'),
	(678564, 134, '2015-02-01 00:54:22.000000', 'consum', 0.0244, 'lps'),
	(678565, 134, '2015-02-01 00:54:23.000000', 'consum', 0.0216, 'lps'),
	(678566, 134, '2015-02-01 00:54:24.000000', 'consum', 0.0242, 'lps'),
	(678567, 134, '2015-02-01 00:54:25.000000', 'consum', 0.0248, 'lps'),
	(678568, 134, '2015-02-01 00:54:26.000000', 'consum', 0.0305, 'lps'),
	(678569, 134, '2015-02-01 00:54:27.000000', 'consum', 0.0263, 'lps'),
	(678570, 134, '2015-02-01 00:54:28.000000', 'consum', 0.0294, 'lps'),
	(678571, 134, '2015-02-01 00:54:29.000000', 'consum', 0.0265, 'lps'),
	(678572, 134, '2015-02-01 00:54:30.000000', 'consum', 0.0235, 'lps'),
	(678573, 134, '2015-02-01 00:54:31.000000', 'consum', 0.0270, 'lps'),
	(678574, 134, '2015-02-01 00:54:32.000000', 'consum', 0.0233, 'lps'),
	(678575, 134, '2015-02-01 00:54:33.000000', 'consum', 0.0246, 'lps'),
	(678576, 134, '2015-02-01 00:54:34.000000', 'consum', 0.0220, 'lps'),
	(678577, 134, '2015-02-01 00:54:35.000000', 'consum', 0.0256, 'lps'),
	(678578, 134, '2015-02-01 00:54:36.000000', 'consum', 0.0306, 'lps'),
	(678579, 134, '2015-02-01 00:54:37.000000', 'consum', 0.0243, 'lps'),
	(678580, 134, '2015-02-01 00:54:38.000000', 'consum', 0.0295, 'lps'),
	(678581, 134, '2015-02-01 00:54:39.000000', 'consum', 0.0228, 'lps'),
	(678582, 134, '2015-02-01 00:54:40.000000', 'consum', 0.0251, 'lps'),
	(678583, 134, '2015-02-01 00:54:41.000000', 'consum', 0.0259, 'lps'),
	(678584, 134, '2015-02-01 00:54:42.000000', 'consum', 0.0231, 'lps'),
	(678585, 134, '2015-02-01 00:54:43.000000', 'consum', 0.0271, 'lps'),
	(678586, 134, '2015-02-01 00:54:44.000000', 'consum', 0.0246, 'lps'),
	(678587, 134, '2015-02-01 00:54:45.000000', 'consum', 0.0308, 'lps'),
	(678588, 134, '2015-02-01 00:54:46.000000', 'consum', 0.0287, 'lps'),
	(678589, 134, '2015-02-01 00:54:47.000000', 'consum', 0.0301, 'lps'),
	(678590, 134, '2015-02-01 00:54:48.000000', 'consum', 0.0229, 'lps'),
	(678591, 134, '2015-02-01 00:54:49.000000', 'consum', 0.0236, 'lps'),
	(678592, 134, '2015-02-01 00:54:50.000000', 'consum', 0.0286, 'lps'),
	(678593, 134, '2015-02-01 00:54:51.000000', 'consum', 0.0306, 'lps'),
	(678594, 134, '2015-02-01 00:54:52.000000', 'consum', 0.0256, 'lps'),
	(678595, 134, '2015-02-01 00:54:53.000000', 'consum', 0.0254, 'lps'),
	(678596, 134, '2015-02-01 00:54:54.000000', 'consum', 0.0294, 'lps'),
	(678597, 134, '2015-02-01 00:54:55.000000', 'consum', 0.0293, 'lps'),
	(678598, 134, '2015-02-01 00:54:56.000000', 'consum', 0.0269, 'lps'),
	(678599, 134, '2015-02-01 00:54:57.000000', 'consum', 0.0257, 'lps'),
	(678600, 134, '2015-02-01 00:54:58.000000', 'consum', 0.0270, 'lps'),
	(678601, 134, '2015-02-01 00:54:59.000000', 'consum', 0.0264, 'lps'),
	(678602, 134, '2015-02-01 00:55:00.000000', 'consum', 0.0301, 'lps'),
	(678603, 134, '2015-02-01 00:55:01.000000', 'consum', 0.0296, 'lps'),
	(678604, 134, '2015-02-01 00:55:02.000000', 'consum', 0.0266, 'lps'),
	(678605, 134, '2015-02-01 00:55:03.000000', 'consum', 0.0231, 'lps'),
	(678606, 134, '2015-02-01 00:55:04.000000', 'consum', 0.0252, 'lps'),
	(678607, 134, '2015-02-01 00:55:05.000000', 'consum', 0.0255, 'lps'),
	(678608, 134, '2015-02-01 00:55:06.000000', 'consum', 0.0307, 'lps'),
	(678609, 134, '2015-02-01 00:55:07.000000', 'consum', 0.0252, 'lps'),
	(678610, 134, '2015-02-01 00:55:08.000000', 'consum', 0.0233, 'lps'),
	(678611, 134, '2015-02-01 00:55:09.000000', 'consum', 0.0302, 'lps'),
	(678612, 134, '2015-02-01 00:55:10.000000', 'consum', 0.0291, 'lps'),
	(678613, 134, '2015-02-01 00:55:11.000000', 'consum', 0.0237, 'lps'),
	(678614, 134, '2015-02-01 00:55:12.000000', 'consum', 0.0311, 'lps'),
	(678615, 134, '2015-02-01 00:55:13.000000', 'consum', 0.0222, 'lps'),
	(678616, 134, '2015-02-01 00:55:14.000000', 'consum', 0.0274, 'lps'),
	(678617, 134, '2015-02-01 00:55:15.000000', 'consum', 0.0289, 'lps'),
	(678618, 134, '2015-02-01 00:55:16.000000', 'consum', 0.0312, 'lps'),
	(678619, 134, '2015-02-01 00:55:17.000000', 'consum', 0.0275, 'lps'),
	(678620, 134, '2015-02-01 00:55:18.000000', 'consum', 0.0230, 'lps'),
	(678621, 134, '2015-02-01 00:55:19.000000', 'consum', 0.0218, 'lps'),
	(678622, 134, '2015-02-01 00:55:20.000000', 'consum', 0.0295, 'lps'),
	(678623, 134, '2015-02-01 00:55:21.000000', 'consum', 0.0300, 'lps'),
	(678624, 134, '2015-02-01 00:55:22.000000', 'consum', 0.0305, 'lps'),
	(678625, 134, '2015-02-01 00:55:23.000000', 'consum', 0.0312, 'lps'),
	(678626, 134, '2015-02-01 00:55:24.000000', 'consum', 0.0229, 'lps'),
	(678627, 134, '2015-02-01 00:55:25.000000', 'consum', 0.0309, 'lps'),
	(678628, 134, '2015-02-01 00:55:26.000000', 'consum', 0.0238, 'lps'),
	(678629, 134, '2015-02-01 00:55:27.000000', 'consum', 0.0257, 'lps'),
	(678630, 134, '2015-02-01 00:55:28.000000', 'consum', 0.0258, 'lps'),
	(678631, 134, '2015-02-01 00:55:29.000000', 'consum', 0.0210, 'lps'),
	(678632, 134, '2015-02-01 00:55:30.000000', 'consum', 0.0269, 'lps'),
	(678633, 134, '2015-02-01 00:55:31.000000', 'consum', 0.0302, 'lps'),
	(678634, 134, '2015-02-01 00:55:32.000000', 'consum', 0.0285, 'lps'),
	(678635, 134, '2015-02-01 00:55:33.000000', 'consum', 0.0309, 'lps'),
	(678636, 134, '2015-02-01 00:55:34.000000', 'consum', 0.0274, 'lps'),
	(678637, 134, '2015-02-01 00:55:35.000000', 'consum', 0.0233, 'lps'),
	(678638, 134, '2015-02-01 00:55:36.000000', 'consum', 0.0239, 'lps'),
	(678639, 134, '2015-02-01 00:55:37.000000', 'consum', 0.0285, 'lps'),
	(678640, 134, '2015-02-01 00:55:38.000000', 'consum', 0.0294, 'lps'),
	(678641, 134, '2015-02-01 00:55:39.000000', 'consum', 0.0301, 'lps'),
	(678642, 134, '2015-02-01 00:55:40.000000', 'consum', 0.0309, 'lps'),
	(678643, 134, '2015-02-01 00:55:41.000000', 'consum', 0.0229, 'lps'),
	(678644, 134, '2015-02-01 00:55:42.000000', 'consum', 0.0215, 'lps'),
	(678645, 134, '2015-02-01 00:55:43.000000', 'consum', 0.0282, 'lps'),
	(678646, 134, '2015-02-01 00:55:44.000000', 'consum', 0.0246, 'lps'),
	(678647, 134, '2015-02-01 00:55:45.000000', 'consum', 0.0278, 'lps'),
	(678648, 134, '2015-02-01 00:55:46.000000', 'consum', 0.0235, 'lps'),
	(678649, 134, '2015-02-01 00:55:47.000000', 'consum', 0.0237, 'lps'),
	(678650, 134, '2015-02-01 00:55:48.000000', 'consum', 0.0269, 'lps'),
	(678651, 134, '2015-02-01 00:55:49.000000', 'consum', 0.0220, 'lps'),
	(678652, 134, '2015-02-01 00:55:50.000000', 'consum', 0.0289, 'lps'),
	(678653, 134, '2015-02-01 00:55:51.000000', 'consum', 0.0267, 'lps'),
	(678654, 134, '2015-02-01 00:55:52.000000', 'consum', 0.0257, 'lps'),
	(678655, 134, '2015-02-01 00:55:53.000000', 'consum', 0.0275, 'lps'),
	(678656, 134, '2015-02-01 00:55:54.000000', 'consum', 0.0291, 'lps'),
	(678657, 134, '2015-02-01 00:55:55.000000', 'consum', 0.0217, 'lps'),
	(678658, 134, '2015-02-01 00:55:56.000000', 'consum', 0.0309, 'lps'),
	(678659, 134, '2015-02-01 00:55:57.000000', 'consum', 0.0275, 'lps'),
	(678660, 134, '2015-02-01 00:55:58.000000', 'consum', 0.0236, 'lps'),
	(678661, 134, '2015-02-01 00:55:59.000000', 'consum', 0.0248, 'lps'),
	(678662, 134, '2015-02-01 00:56:00.000000', 'consum', 0.0221, 'lps'),
	(678663, 134, '2015-02-01 00:56:01.000000', 'consum', 0.0254, 'lps'),
	(678664, 134, '2015-02-01 00:56:02.000000', 'consum', 0.0294, 'lps'),
	(678665, 134, '2015-02-01 00:56:03.000000', 'consum', 0.0294, 'lps'),
	(678666, 134, '2015-02-01 00:56:04.000000', 'consum', 0.0273, 'lps'),
	(678667, 134, '2015-02-01 00:56:05.000000', 'consum', 0.0275, 'lps'),
	(678668, 134, '2015-02-01 00:56:06.000000', 'consum', 0.0242, 'lps'),
	(678669, 134, '2015-02-01 00:56:07.000000', 'consum', 0.0278, 'lps'),
	(678670, 134, '2015-02-01 00:56:08.000000', 'consum', 0.0249, 'lps'),
	(678671, 134, '2015-02-01 00:56:09.000000', 'consum', 0.0303, 'lps'),
	(678672, 134, '2015-02-01 00:56:10.000000', 'consum', 0.0251, 'lps'),
	(678673, 134, '2015-02-01 00:56:11.000000', 'consum', 0.0240, 'lps'),
	(678674, 134, '2015-02-01 00:56:12.000000', 'consum', 0.0239, 'lps'),
	(678675, 134, '2015-02-01 00:56:13.000000', 'consum', 0.0264, 'lps'),
	(678676, 134, '2015-02-01 00:56:14.000000', 'consum', 0.0291, 'lps'),
	(678677, 134, '2015-02-01 00:56:15.000000', 'consum', 0.0248, 'lps'),
	(678678, 134, '2015-02-01 00:56:16.000000', 'consum', 0.0259, 'lps'),
	(678679, 134, '2015-02-01 00:56:17.000000', 'consum', 0.0239, 'lps'),
	(678680, 134, '2015-02-01 00:56:18.000000', 'consum', 0.0210, 'lps'),
	(678681, 134, '2015-02-01 00:56:19.000000', 'consum', 0.0225, 'lps'),
	(678682, 134, '2015-02-01 00:56:20.000000', 'consum', 0.0285, 'lps'),
	(678683, 134, '2015-02-01 00:56:21.000000', 'consum', 0.0233, 'lps'),
	(678684, 134, '2015-02-01 00:56:22.000000', 'consum', 0.0306, 'lps'),
	(678685, 134, '2015-02-01 00:56:23.000000', 'consum', 0.0210, 'lps'),
	(678686, 134, '2015-02-01 00:56:24.000000', 'consum', 0.0231, 'lps'),
	(678687, 134, '2015-02-01 00:56:25.000000', 'consum', 0.0213, 'lps'),
	(678688, 134, '2015-02-01 00:56:26.000000', 'consum', 0.0263, 'lps'),
	(678689, 134, '2015-02-01 00:56:27.000000', 'consum', 0.0263, 'lps'),
	(678690, 134, '2015-02-01 00:56:28.000000', 'consum', 0.0215, 'lps'),
	(678691, 134, '2015-02-01 00:56:29.000000', 'consum', 0.0279, 'lps'),
	(678692, 134, '2015-02-01 00:56:30.000000', 'consum', 0.0232, 'lps'),
	(678693, 134, '2015-02-01 00:56:31.000000', 'consum', 0.0219, 'lps'),
	(678694, 134, '2015-02-01 00:56:32.000000', 'consum', 0.0292, 'lps'),
	(678695, 134, '2015-02-01 00:56:33.000000', 'consum', 0.0282, 'lps'),
	(678696, 134, '2015-02-01 00:56:34.000000', 'consum', 0.0222, 'lps'),
	(678697, 134, '2015-02-01 00:56:35.000000', 'consum', 0.0263, 'lps'),
	(678698, 134, '2015-02-01 00:56:36.000000', 'consum', 0.0231, 'lps'),
	(678699, 134, '2015-02-01 00:56:37.000000', 'consum', 0.0260, 'lps'),
	(678700, 134, '2015-02-01 00:56:38.000000', 'consum', 0.0297, 'lps'),
	(678701, 134, '2015-02-01 00:56:39.000000', 'consum', 0.0287, 'lps'),
	(678702, 134, '2015-02-01 00:56:40.000000', 'consum', 0.0232, 'lps'),
	(678703, 134, '2015-02-01 00:56:41.000000', 'consum', 0.0295, 'lps'),
	(678704, 134, '2015-02-01 00:56:42.000000', 'consum', 0.0263, 'lps'),
	(678705, 134, '2015-02-01 00:56:43.000000', 'consum', 0.0218, 'lps'),
	(678706, 134, '2015-02-01 00:56:44.000000', 'consum', 0.0299, 'lps'),
	(678707, 134, '2015-02-01 00:56:45.000000', 'consum', 0.0218, 'lps'),
	(678708, 134, '2015-02-01 00:56:46.000000', 'consum', 0.0294, 'lps'),
	(678709, 134, '2015-02-01 00:56:47.000000', 'consum', 0.0299, 'lps'),
	(678710, 134, '2015-02-01 00:56:48.000000', 'consum', 0.0297, 'lps'),
	(678711, 134, '2015-02-01 00:56:49.000000', 'consum', 0.0278, 'lps'),
	(678712, 134, '2015-02-01 00:56:50.000000', 'consum', 0.0288, 'lps'),
	(678713, 134, '2015-02-01 00:56:51.000000', 'consum', 0.0292, 'lps'),
	(678714, 134, '2015-02-01 00:56:52.000000', 'consum', 0.0285, 'lps'),
	(678715, 134, '2015-02-01 00:56:53.000000', 'consum', 0.0235, 'lps'),
	(678716, 134, '2015-02-01 00:56:54.000000', 'consum', 0.0214, 'lps'),
	(678717, 134, '2015-02-01 00:56:55.000000', 'consum', 0.0257, 'lps'),
	(678718, 134, '2015-02-01 00:56:56.000000', 'consum', 0.0230, 'lps'),
	(678719, 134, '2015-02-01 00:56:57.000000', 'consum', 0.0273, 'lps'),
	(678720, 134, '2015-02-01 00:56:58.000000', 'consum', 0.0259, 'lps'),
	(678721, 134, '2015-02-01 00:56:59.000000', 'consum', 0.0266, 'lps'),
	(678722, 134, '2015-02-01 00:57:00.000000', 'consum', 0.0240, 'lps'),
	(678723, 134, '2015-02-01 00:57:01.000000', 'consum', 0.0296, 'lps'),
	(678724, 134, '2015-02-01 00:57:02.000000', 'consum', 0.0242, 'lps'),
	(678725, 134, '2015-02-01 00:57:03.000000', 'consum', 0.0215, 'lps'),
	(678726, 134, '2015-02-01 00:57:04.000000', 'consum', 0.0242, 'lps'),
	(678727, 134, '2015-02-01 00:57:05.000000', 'consum', 0.0252, 'lps'),
	(678728, 134, '2015-02-01 00:57:06.000000', 'consum', 0.0223, 'lps'),
	(678729, 134, '2015-02-01 00:57:07.000000', 'consum', 0.0251, 'lps'),
	(678730, 134, '2015-02-01 00:57:08.000000', 'consum', 0.0275, 'lps'),
	(678731, 134, '2015-02-01 00:57:09.000000', 'consum', 0.0309, 'lps'),
	(678732, 134, '2015-02-01 00:57:10.000000', 'consum', 0.0303, 'lps'),
	(678733, 134, '2015-02-01 00:57:11.000000', 'consum', 0.0278, 'lps'),
	(678734, 134, '2015-02-01 00:57:12.000000', 'consum', 0.0270, 'lps'),
	(678735, 134, '2015-02-01 00:57:13.000000', 'consum', 0.0306, 'lps'),
	(678736, 134, '2015-02-01 00:57:14.000000', 'consum', 0.0306, 'lps'),
	(678737, 134, '2015-02-01 00:57:15.000000', 'consum', 0.0300, 'lps'),
	(678738, 134, '2015-02-01 00:57:16.000000', 'consum', 0.0268, 'lps'),
	(678739, 134, '2015-02-01 00:57:17.000000', 'consum', 0.0232, 'lps'),
	(678740, 134, '2015-02-01 00:57:18.000000', 'consum', 0.0251, 'lps'),
	(678741, 134, '2015-02-01 00:57:19.000000', 'consum', 0.0243, 'lps'),
	(678742, 134, '2015-02-01 00:57:20.000000', 'consum', 0.0255, 'lps'),
	(678743, 134, '2015-02-01 00:57:21.000000', 'consum', 0.0234, 'lps'),
	(678744, 134, '2015-02-01 00:57:22.000000', 'consum', 0.0299, 'lps'),
	(678745, 134, '2015-02-01 00:57:23.000000', 'consum', 0.0273, 'lps'),
	(678746, 134, '2015-02-01 00:57:24.000000', 'consum', 0.0260, 'lps'),
	(678747, 134, '2015-02-01 00:57:25.000000', 'consum', 0.0272, 'lps'),
	(678748, 134, '2015-02-01 00:57:26.000000', 'consum', 0.0266, 'lps'),
	(678749, 134, '2015-02-01 00:57:27.000000', 'consum', 0.0307, 'lps'),
	(678750, 134, '2015-02-01 00:57:28.000000', 'consum', 0.0216, 'lps'),
	(678751, 134, '2015-02-01 00:57:29.000000', 'consum', 0.0258, 'lps'),
	(678752, 134, '2015-02-01 00:57:30.000000', 'consum', 0.0227, 'lps'),
	(678753, 134, '2015-02-01 00:57:31.000000', 'consum', 0.0254, 'lps'),
	(678754, 134, '2015-02-01 00:57:32.000000', 'consum', 0.0279, 'lps'),
	(678755, 134, '2015-02-01 00:57:33.000000', 'consum', 0.0216, 'lps'),
	(678756, 134, '2015-02-01 00:57:34.000000', 'consum', 0.0239, 'lps'),
	(678757, 134, '2015-02-01 00:57:35.000000', 'consum', 0.0236, 'lps'),
	(678758, 134, '2015-02-01 00:57:36.000000', 'consum', 0.0254, 'lps'),
	(678759, 134, '2015-02-01 00:57:37.000000', 'consum', 0.0249, 'lps'),
	(678760, 134, '2015-02-01 00:57:38.000000', 'consum', 0.0274, 'lps'),
	(678761, 134, '2015-02-01 00:57:39.000000', 'consum', 0.0311, 'lps'),
	(678762, 134, '2015-02-01 00:57:40.000000', 'consum', 0.0215, 'lps'),
	(678763, 134, '2015-02-01 00:57:41.000000', 'consum', 0.0240, 'lps'),
	(678764, 134, '2015-02-01 00:57:42.000000', 'consum', 0.0243, 'lps'),
	(678765, 134, '2015-02-01 00:57:43.000000', 'consum', 0.0287, 'lps'),
	(678766, 134, '2015-02-01 00:57:44.000000', 'consum', 0.0288, 'lps'),
	(678767, 134, '2015-02-01 00:57:45.000000', 'consum', 0.0269, 'lps'),
	(678768, 134, '2015-02-01 00:57:46.000000', 'consum', 0.0271, 'lps'),
	(678769, 134, '2015-02-01 00:57:47.000000', 'consum', 0.0234, 'lps'),
	(678770, 134, '2015-02-01 00:57:48.000000', 'consum', 0.0251, 'lps'),
	(678771, 134, '2015-02-01 00:57:49.000000', 'consum', 0.0243, 'lps'),
	(678772, 134, '2015-02-01 00:57:50.000000', 'consum', 0.0250, 'lps'),
	(678773, 134, '2015-02-01 00:57:51.000000', 'consum', 0.0312, 'lps'),
	(678774, 134, '2015-02-01 00:57:52.000000', 'consum', 0.0290, 'lps'),
	(678775, 134, '2015-02-01 00:57:53.000000', 'consum', 0.0306, 'lps'),
	(678776, 134, '2015-02-01 00:57:54.000000', 'consum', 0.0245, 'lps'),
	(678777, 134, '2015-02-01 00:57:55.000000', 'consum', 0.0305, 'lps'),
	(678778, 134, '2015-02-01 00:57:56.000000', 'consum', 0.0270, 'lps'),
	(678779, 134, '2015-02-01 00:57:57.000000', 'consum', 0.0227, 'lps'),
	(678780, 134, '2015-02-01 00:57:58.000000', 'consum', 0.0219, 'lps'),
	(678781, 134, '2015-02-01 00:57:59.000000', 'consum', 0.0308, 'lps'),
	(678782, 134, '2015-02-01 00:58:00.000000', 'consum', 0.0262, 'lps'),
	(678783, 134, '2015-02-01 00:58:01.000000', 'consum', 0.0277, 'lps'),
	(678784, 134, '2015-02-01 00:58:02.000000', 'consum', 0.0286, 'lps'),
	(678785, 134, '2015-02-01 00:58:03.000000', 'consum', 0.0287, 'lps'),
	(678786, 134, '2015-02-01 00:58:04.000000', 'consum', 0.0265, 'lps'),
	(678787, 134, '2015-02-01 00:58:05.000000', 'consum', 0.0256, 'lps'),
	(678788, 134, '2015-02-01 00:58:06.000000', 'consum', 0.0273, 'lps'),
	(678789, 134, '2015-02-01 00:58:07.000000', 'consum', 0.0286, 'lps'),
	(678790, 134, '2015-02-01 00:58:08.000000', 'consum', 0.0298, 'lps'),
	(678791, 134, '2015-02-01 00:58:09.000000', 'consum', 0.0215, 'lps'),
	(678792, 134, '2015-02-01 00:58:10.000000', 'consum', 0.0282, 'lps'),
	(678793, 134, '2015-02-01 00:58:11.000000', 'consum', 0.0246, 'lps'),
	(678794, 134, '2015-02-01 00:58:12.000000', 'consum', 0.0279, 'lps'),
	(678795, 134, '2015-02-01 00:58:13.000000', 'consum', 0.0239, 'lps'),
	(678796, 134, '2015-02-01 00:58:14.000000', 'consum', 0.0252, 'lps'),
	(678797, 134, '2015-02-01 00:58:15.000000', 'consum', 0.0229, 'lps'),
	(678798, 134, '2015-02-01 00:58:16.000000', 'consum', 0.0285, 'lps'),
	(678799, 134, '2015-02-01 00:58:17.000000', 'consum', 0.0220, 'lps'),
	(678800, 134, '2015-02-01 00:58:18.000000', 'consum', 0.0241, 'lps'),
	(678801, 134, '2015-02-01 00:58:19.000000', 'consum', 0.0233, 'lps'),
	(678802, 134, '2015-02-01 00:58:20.000000', 'consum', 0.0231, 'lps'),
	(678803, 134, '2015-02-01 00:58:21.000000', 'consum', 0.0248, 'lps'),
	(678804, 134, '2015-02-01 00:58:22.000000', 'consum', 0.0234, 'lps'),
	(678805, 134, '2015-02-01 00:58:23.000000', 'consum', 0.0217, 'lps'),
	(678806, 134, '2015-02-01 00:58:24.000000', 'consum', 0.0277, 'lps'),
	(678807, 134, '2015-02-01 00:58:25.000000', 'consum', 0.0215, 'lps'),
	(678808, 134, '2015-02-01 00:58:26.000000', 'consum', 0.0239, 'lps'),
	(678809, 134, '2015-02-01 00:58:27.000000', 'consum', 0.0239, 'lps'),
	(678810, 134, '2015-02-01 00:58:28.000000', 'consum', 0.0270, 'lps'),
	(678811, 134, '2015-02-01 00:58:29.000000', 'consum', 0.0216, 'lps'),
	(678812, 134, '2015-02-01 00:58:30.000000', 'consum', 0.0266, 'lps'),
	(678813, 134, '2015-02-01 00:58:31.000000', 'consum', 0.0266, 'lps'),
	(678814, 134, '2015-02-01 00:58:32.000000', 'consum', 0.0219, 'lps'),
	(678815, 134, '2015-02-01 00:58:33.000000', 'consum', 0.0295, 'lps'),
	(678816, 134, '2015-02-01 00:58:34.000000', 'consum', 0.0300, 'lps'),
	(678817, 134, '2015-02-01 00:58:35.000000', 'consum', 0.0303, 'lps'),
	(678818, 134, '2015-02-01 00:58:36.000000', 'consum', 0.0300, 'lps'),
	(678819, 134, '2015-02-01 00:58:37.000000', 'consum', 0.0279, 'lps'),
	(678820, 134, '2015-02-01 00:58:38.000000', 'consum', 0.0284, 'lps'),
	(678821, 134, '2015-02-01 00:58:39.000000', 'consum', 0.0272, 'lps'),
	(678822, 134, '2015-02-01 00:58:40.000000', 'consum', 0.0298, 'lps'),
	(678823, 134, '2015-02-01 00:58:41.000000', 'consum', 0.0258, 'lps'),
	(678824, 134, '2015-02-01 00:58:42.000000', 'consum', 0.0291, 'lps'),
	(678825, 134, '2015-02-01 00:58:43.000000', 'consum', 0.0266, 'lps'),
	(678826, 134, '2015-02-01 00:58:44.000000', 'consum', 0.0246, 'lps'),
	(678827, 134, '2015-02-01 00:58:45.000000', 'consum', 0.0222, 'lps'),
	(678828, 134, '2015-02-01 00:58:46.000000', 'consum', 0.0267, 'lps'),
	(678829, 134, '2015-02-01 00:58:47.000000', 'consum', 0.0252, 'lps'),
	(678830, 134, '2015-02-01 00:58:48.000000', 'consum', 0.0249, 'lps'),
	(678831, 134, '2015-02-01 00:58:49.000000', 'consum', 0.0279, 'lps'),
	(678832, 134, '2015-02-01 00:58:50.000000', 'consum', 0.0233, 'lps'),
	(678833, 134, '2015-02-01 00:58:51.000000', 'consum', 0.0221, 'lps'),
	(678834, 134, '2015-02-01 00:58:52.000000', 'consum', 0.0298, 'lps'),
	(678835, 134, '2015-02-01 00:58:53.000000', 'consum', 0.0312, 'lps'),
	(678836, 134, '2015-02-01 00:58:54.000000', 'consum', 0.0249, 'lps'),
	(678837, 134, '2015-02-01 00:58:55.000000', 'consum', 0.0305, 'lps'),
	(678838, 134, '2015-02-01 00:58:56.000000', 'consum', 0.0259, 'lps'),
	(678839, 134, '2015-02-01 00:58:57.000000', 'consum', 0.0275, 'lps'),
	(678840, 134, '2015-02-01 00:58:58.000000', 'consum', 0.0283, 'lps'),
	(678841, 134, '2015-02-01 00:58:59.000000', 'consum', 0.0278, 'lps'),
	(678842, 134, '2015-02-01 00:59:00.000000', 'consum', 0.0229, 'lps'),
	(678843, 134, '2015-02-01 00:59:01.000000', 'consum', 0.0307, 'lps'),
	(678844, 134, '2015-02-01 00:59:02.000000', 'consum', 0.0225, 'lps'),
	(678845, 134, '2015-02-01 00:59:03.000000', 'consum', 0.0304, 'lps'),
	(678846, 134, '2015-02-01 00:59:04.000000', 'consum', 0.0225, 'lps'),
	(678847, 134, '2015-02-01 00:59:05.000000', 'consum', 0.0210, 'lps'),
	(678848, 134, '2015-02-01 00:59:06.000000', 'consum', 0.0266, 'lps'),
	(678849, 134, '2015-02-01 00:59:07.000000', 'consum', 0.0284, 'lps'),
	(678850, 134, '2015-02-01 00:59:08.000000', 'consum', 0.0312, 'lps'),
	(678851, 134, '2015-02-01 00:59:09.000000', 'consum', 0.0293, 'lps'),
	(678852, 134, '2015-02-01 00:59:10.000000', 'consum', 0.0217, 'lps'),
	(678853, 134, '2015-02-01 00:59:11.000000', 'consum', 0.0306, 'lps'),
	(678854, 134, '2015-02-01 00:59:12.000000', 'consum', 0.0258, 'lps'),
	(678855, 134, '2015-02-01 00:59:13.000000', 'consum', 0.0266, 'lps'),
	(678856, 134, '2015-02-01 00:59:14.000000', 'consum', 0.0244, 'lps'),
	(678857, 134, '2015-02-01 00:59:15.000000', 'consum', 0.0213, 'lps'),
	(678858, 134, '2015-02-01 00:59:16.000000', 'consum', 0.0224, 'lps'),
	(678859, 134, '2015-02-01 00:59:17.000000', 'consum', 0.0273, 'lps'),
	(678860, 134, '2015-02-01 00:59:18.000000', 'consum', 0.0278, 'lps'),
	(678861, 134, '2015-02-01 00:59:19.000000', 'consum', 0.0257, 'lps'),
	(678862, 134, '2015-02-01 00:59:20.000000', 'consum', 0.0242, 'lps'),
	(678863, 134, '2015-02-01 00:59:21.000000', 'consum', 0.0232, 'lps'),
	(678864, 134, '2015-02-01 00:59:22.000000', 'consum', 0.0221, 'lps'),
	(678865, 134, '2015-02-01 00:59:23.000000', 'consum', 0.0303, 'lps'),
	(678866, 134, '2015-02-01 00:59:24.000000', 'consum', 0.0233, 'lps'),
	(678867, 134, '2015-02-01 00:59:25.000000', 'consum', 0.0252, 'lps'),
	(678868, 134, '2015-02-01 00:59:26.000000', 'consum', 0.0247, 'lps'),
	(678869, 134, '2015-02-01 00:59:27.000000', 'consum', 0.0272, 'lps'),
	(678870, 134, '2015-02-01 00:59:28.000000', 'consum', 0.0304, 'lps'),
	(678871, 134, '2015-02-01 00:59:29.000000', 'consum', 0.0289, 'lps'),
	(678872, 134, '2015-02-01 00:59:30.000000', 'consum', 0.0220, 'lps'),
	(678873, 134, '2015-02-01 00:59:31.000000', 'consum', 0.0232, 'lps'),
	(678874, 134, '2015-02-01 00:59:32.000000', 'consum', 0.0288, 'lps'),
	(678875, 134, '2015-02-01 00:59:33.000000', 'consum', 0.0226, 'lps'),
	(678876, 134, '2015-02-01 00:59:34.000000', 'consum', 0.0262, 'lps'),
	(678877, 134, '2015-02-01 00:59:35.000000', 'consum', 0.0217, 'lps'),
	(678878, 134, '2015-02-01 00:59:36.000000', 'consum', 0.0296, 'lps'),
	(678879, 134, '2015-02-01 00:59:37.000000', 'consum', 0.0309, 'lps'),
	(678880, 134, '2015-02-01 00:59:38.000000', 'consum', 0.0242, 'lps'),
	(678881, 134, '2015-02-01 00:59:39.000000', 'consum', 0.0279, 'lps'),
	(678882, 134, '2015-02-01 00:59:40.000000', 'consum', 0.0254, 'lps'),
	(678883, 134, '2015-02-01 00:59:41.000000', 'consum', 0.0223, 'lps'),
	(678884, 134, '2015-02-01 00:59:42.000000', 'consum', 0.0247, 'lps'),
	(678885, 134, '2015-02-01 00:59:43.000000', 'consum', 0.0254, 'lps'),
	(678886, 134, '2015-02-01 00:59:44.000000', 'consum', 0.0214, 'lps'),
	(678887, 134, '2015-02-01 00:59:45.000000', 'consum', 0.0306, 'lps'),
	(678888, 134, '2015-02-01 00:59:46.000000', 'consum', 0.0266, 'lps'),
	(678889, 134, '2015-02-01 00:59:47.000000', 'consum', 0.0308, 'lps'),
	(678890, 134, '2015-02-01 00:59:48.000000', 'consum', 0.0221, 'lps'),
	(678891, 134, '2015-02-01 00:59:49.000000', 'consum', 0.0282, 'lps'),
	(678892, 134, '2015-02-01 00:59:50.000000', 'consum', 0.0226, 'lps'),
	(678893, 134, '2015-02-01 00:59:51.000000', 'consum', 0.0284, 'lps'),
	(678894, 134, '2015-02-01 00:59:52.000000', 'consum', 0.0222, 'lps'),
	(678895, 134, '2015-02-01 00:59:53.000000', 'consum', 0.0254, 'lps'),
	(678896, 134, '2015-02-01 00:59:54.000000', 'consum', 0.0291, 'lps'),
	(678897, 134, '2015-02-01 00:59:55.000000', 'consum', 0.0276, 'lps'),
	(678898, 134, '2015-02-01 00:59:56.000000', 'consum', 0.0300, 'lps'),
	(678899, 134, '2015-02-01 00:59:57.000000', 'consum', 0.0255, 'lps'),
	(678900, 134, '2015-02-01 00:59:58.000000', 'consum', 0.0270, 'lps'),
	(678901, 134, '2015-02-01 00:59:59.000000', 'consum', 0.0274, 'lps'),
	(678902, 134, '2015-02-01 01:00:00.000000', 'consum', 0.0245, 'lps'),
	(678903, 134, '2015-02-01 01:00:01.000000', 'consum', 0.0297, 'lps'),
	(678904, 134, '2015-02-01 01:00:02.000000', 'consum', 0.0231, 'lps'),
	(678905, 134, '2015-02-01 01:00:03.000000', 'consum', 0.0259, 'lps'),
	(678906, 134, '2015-02-01 01:00:04.000000', 'consum', 0.0290, 'lps'),
	(678907, 134, '2015-02-01 01:00:05.000000', 'consum', 0.0260, 'lps'),
	(678908, 134, '2015-02-01 01:00:06.000000', 'consum', 0.0219, 'lps'),
	(678909, 134, '2015-02-01 01:00:07.000000', 'consum', 0.0312, 'lps'),
	(678910, 134, '2015-02-01 01:00:08.000000', 'consum', 0.0281, 'lps'),
	(678911, 134, '2015-02-01 01:00:09.000000', 'consum', 0.0258, 'lps'),
	(678912, 134, '2015-02-01 01:00:10.000000', 'consum', 0.0239, 'lps'),
	(678913, 134, '2015-02-01 01:00:11.000000', 'consum', 0.0212, 'lps'),
	(678914, 134, '2015-02-01 01:00:12.000000', 'consum', 0.0238, 'lps'),
	(678915, 134, '2015-02-01 01:00:13.000000', 'consum', 0.0241, 'lps'),
	(678916, 134, '2015-02-01 01:00:14.000000', 'consum', 0.0279, 'lps'),
	(678917, 134, '2015-02-01 01:00:15.000000', 'consum', 0.0258, 'lps'),
	(678918, 134, '2015-02-01 01:00:16.000000', 'consum', 0.0241, 'lps'),
	(678919, 134, '2015-02-01 01:00:17.000000', 'consum', 0.0225, 'lps'),
	(678920, 134, '2015-02-01 01:00:18.000000', 'consum', 0.0294, 'lps'),
	(678921, 134, '2015-02-01 01:00:19.000000', 'consum', 0.0277, 'lps'),
	(678922, 134, '2015-02-01 01:00:20.000000', 'consum', 0.0295, 'lps'),
	(678923, 134, '2015-02-01 01:00:21.000000', 'consum', 0.0228, 'lps'),
	(678924, 134, '2015-02-01 01:00:22.000000', 'consum', 0.0253, 'lps'),
	(678925, 134, '2015-02-01 01:00:23.000000', 'consum', 0.0265, 'lps'),
	(678926, 134, '2015-02-01 01:00:24.000000', 'consum', 0.0255, 'lps'),
	(678927, 134, '2015-02-01 01:00:25.000000', 'consum', 0.0273, 'lps'),
	(678928, 134, '2015-02-01 01:00:26.000000', 'consum', 0.0284, 'lps'),
	(678929, 134, '2015-02-01 01:00:27.000000', 'consum', 0.0289, 'lps'),
	(678930, 134, '2015-02-01 01:00:28.000000', 'consum', 0.0279, 'lps'),
	(678931, 134, '2015-02-01 01:00:29.000000', 'consum', 0.0217, 'lps'),
	(678932, 134, '2015-02-01 01:00:30.000000', 'consum', 0.0244, 'lps'),
	(678933, 134, '2015-02-01 01:00:31.000000', 'consum', 0.0255, 'lps'),
	(678934, 134, '2015-02-01 01:00:32.000000', 'consum', 0.0233, 'lps'),
	(678935, 134, '2015-02-01 01:00:33.000000', 'consum', 0.0291, 'lps'),
	(678936, 134, '2015-02-01 01:00:34.000000', 'consum', 0.0238, 'lps'),
	(678937, 134, '2015-02-01 01:00:35.000000', 'consum', 0.0213, 'lps'),
	(678938, 134, '2015-02-01 01:00:36.000000', 'consum', 0.0243, 'lps'),
	(678939, 134, '2015-02-01 01:00:37.000000', 'consum', 0.0262, 'lps'),
	(678940, 134, '2015-02-01 01:00:38.000000', 'consum', 0.0268, 'lps'),
	(678941, 134, '2015-02-01 01:00:39.000000', 'consum', 0.0241, 'lps'),
	(678942, 134, '2015-02-01 01:00:40.000000', 'consum', 0.0294, 'lps'),
	(678943, 134, '2015-02-01 01:00:41.000000', 'consum', 0.0231, 'lps'),
	(678944, 134, '2015-02-01 01:00:42.000000', 'consum', 0.0268, 'lps'),
	(678945, 134, '2015-02-01 01:00:43.000000', 'consum', 0.0234, 'lps'),
	(678946, 134, '2015-02-01 01:00:44.000000', 'consum', 0.0258, 'lps'),
	(678947, 134, '2015-02-01 01:00:45.000000', 'consum', 0.0275, 'lps'),
	(678948, 134, '2015-02-01 01:00:46.000000', 'consum', 0.0289, 'lps'),
	(678949, 134, '2015-02-01 01:00:47.000000', 'consum', 0.0308, 'lps'),
	(678950, 134, '2015-02-01 01:00:48.000000', 'consum', 0.0258, 'lps'),
	(678951, 134, '2015-02-01 01:00:49.000000', 'consum', 0.0260, 'lps'),
	(678952, 134, '2015-02-01 01:00:50.000000', 'consum', 0.0212, 'lps'),
	(678953, 134, '2015-02-01 01:00:51.000000', 'consum', 0.0279, 'lps'),
	(678954, 134, '2015-02-01 01:00:52.000000', 'consum', 0.0239, 'lps'),
	(678955, 134, '2015-02-01 01:00:53.000000', 'consum', 0.0252, 'lps'),
	(678956, 134, '2015-02-01 01:00:54.000000', 'consum', 0.0231, 'lps'),
	(678957, 134, '2015-02-01 01:00:55.000000', 'consum', 0.0293, 'lps'),
	(678958, 134, '2015-02-01 01:00:56.000000', 'consum', 0.0252, 'lps'),
	(678959, 134, '2015-02-01 01:00:57.000000', 'consum', 0.0273, 'lps'),
	(678960, 134, '2015-02-01 01:00:58.000000', 'consum', 0.0298, 'lps'),
	(678961, 134, '2015-02-01 01:00:59.000000', 'consum', 0.0254, 'lps'),
	(678962, 134, '2015-02-01 01:01:00.000000', 'consum', 0.0270, 'lps'),
	(678963, 134, '2015-02-01 01:01:01.000000', 'consum', 0.0277, 'lps'),
	(678964, 134, '2015-02-01 01:01:02.000000', 'consum', 0.0261, 'lps'),
	(678965, 134, '2015-02-01 01:01:03.000000', 'consum', 0.0263, 'lps'),
	(678966, 134, '2015-02-01 01:01:04.000000', 'consum', 0.0221, 'lps'),
	(678967, 134, '2015-02-01 01:01:05.000000', 'consum', 0.0311, 'lps'),
	(678968, 134, '2015-02-01 01:01:06.000000', 'consum', 0.0271, 'lps'),
	(678969, 134, '2015-02-01 01:01:07.000000', 'consum', 0.0214, 'lps'),
	(678970, 134, '2015-02-01 01:01:08.000000', 'consum', 0.0252, 'lps'),
	(678971, 134, '2015-02-01 01:01:09.000000', 'consum', 0.0305, 'lps'),
	(678972, 134, '2015-02-01 01:01:10.000000', 'consum', 0.0250, 'lps'),
	(678973, 134, '2015-02-01 01:01:11.000000', 'consum', 0.0229, 'lps'),
	(678974, 134, '2015-02-01 01:01:12.000000', 'consum', 0.0287, 'lps'),
	(678975, 134, '2015-02-01 01:01:13.000000', 'consum', 0.0232, 'lps'),
	(678976, 134, '2015-02-01 01:01:14.000000', 'consum', 0.0293, 'lps'),
	(678977, 134, '2015-02-01 01:01:15.000000', 'consum', 0.0253, 'lps'),
	(678978, 134, '2015-02-01 01:01:16.000000', 'consum', 0.0281, 'lps'),
	(678979, 134, '2015-02-01 01:01:17.000000', 'consum', 0.0227, 'lps'),
	(678980, 134, '2015-02-01 01:01:18.000000', 'consum', 0.0290, 'lps'),
	(678981, 134, '2015-02-01 01:01:19.000000', 'consum', 0.0249, 'lps'),
	(678982, 134, '2015-02-01 01:01:20.000000', 'consum', 0.0270, 'lps'),
	(678983, 134, '2015-02-01 01:01:21.000000', 'consum', 0.0292, 'lps'),
	(678984, 134, '2015-02-01 01:01:22.000000', 'consum', 0.0233, 'lps'),
	(678985, 134, '2015-02-01 01:01:23.000000', 'consum', 0.0283, 'lps'),
	(678986, 134, '2015-02-01 01:01:24.000000', 'consum', 0.0304, 'lps'),
	(678987, 134, '2015-02-01 01:01:25.000000', 'consum', 0.0256, 'lps'),
	(678988, 134, '2015-02-01 01:01:26.000000', 'consum', 0.0260, 'lps'),
	(678989, 134, '2015-02-01 01:01:27.000000', 'consum', 0.0220, 'lps'),
	(678990, 134, '2015-02-01 01:01:28.000000', 'consum', 0.0215, 'lps'),
	(678991, 134, '2015-02-01 01:01:29.000000', 'consum', 0.0307, 'lps'),
	(678992, 134, '2015-02-01 01:01:30.000000', 'consum', 0.0268, 'lps'),
	(678993, 134, '2015-02-01 01:01:31.000000', 'consum', 0.0311, 'lps'),
	(678994, 134, '2015-02-01 01:01:32.000000', 'consum', 0.0234, 'lps'),
	(678995, 134, '2015-02-01 01:01:33.000000', 'consum', 0.0232, 'lps'),
	(678996, 134, '2015-02-01 01:01:34.000000', 'consum', 0.0250, 'lps'),
	(678997, 134, '2015-02-01 01:01:35.000000', 'consum', 0.0243, 'lps'),
	(678998, 134, '2015-02-01 01:01:36.000000', 'consum', 0.0255, 'lps'),
	(678999, 134, '2015-02-01 01:01:37.000000', 'consum', 0.0234, 'lps'),
	(679000, 134, '2015-02-01 01:01:38.000000', 'consum', 0.0298, 'lps'),
	(679001, 134, '2015-02-01 01:01:39.000000', 'consum', 0.0271, 'lps'),
	(679002, 134, '2015-02-01 01:01:40.000000', 'consum', 0.0249, 'lps'),
	(679003, 134, '2015-02-01 01:01:41.000000', 'consum', 0.0225, 'lps'),
	(679004, 134, '2015-02-01 01:01:42.000000', 'consum', 0.0272, 'lps'),
	(679005, 134, '2015-02-01 01:01:43.000000', 'consum', 0.0268, 'lps'),
	(679006, 134, '2015-02-01 01:01:44.000000', 'consum', 0.0212, 'lps'),
	(679007, 134, '2015-02-01 01:01:45.000000', 'consum', 0.0253, 'lps'),
	(679008, 134, '2015-02-01 01:01:46.000000', 'consum', 0.0212, 'lps'),
	(679009, 134, '2015-02-01 01:01:47.000000', 'consum', 0.0300, 'lps'),
	(679010, 134, '2015-02-01 01:01:48.000000', 'consum', 0.0240, 'lps'),
	(679011, 134, '2015-02-01 01:01:49.000000', 'consum', 0.0298, 'lps'),
	(679012, 134, '2015-02-01 01:01:50.000000', 'consum', 0.0251, 'lps'),
	(679013, 134, '2015-02-01 01:01:51.000000', 'consum', 0.0256, 'lps'),
	(679014, 134, '2015-02-01 01:01:52.000000', 'consum', 0.0213, 'lps'),
	(679015, 134, '2015-02-01 01:01:53.000000', 'consum', 0.0292, 'lps'),
	(679016, 134, '2015-02-01 01:01:54.000000', 'consum', 0.0304, 'lps'),
	(679017, 134, '2015-02-01 01:01:55.000000', 'consum', 0.0226, 'lps'),
	(679018, 134, '2015-02-01 01:01:56.000000', 'consum', 0.0218, 'lps'),
	(679019, 134, '2015-02-01 01:01:57.000000', 'consum', 0.0304, 'lps'),
	(679020, 134, '2015-02-01 01:01:58.000000', 'consum', 0.0243, 'lps'),
	(679021, 134, '2015-02-01 01:01:59.000000', 'consum', 0.0302, 'lps'),
	(679022, 134, '2015-02-01 01:02:00.000000', 'consum', 0.0263, 'lps'),
	(679023, 134, '2015-02-01 01:02:01.000000', 'consum', 0.0303, 'lps'),
	(679024, 134, '2015-02-01 01:02:02.000000', 'consum', 0.0308, 'lps'),
	(679025, 134, '2015-02-01 01:02:03.000000', 'consum', 0.0218, 'lps'),
	(679026, 134, '2015-02-01 01:02:04.000000', 'consum', 0.0263, 'lps'),
	(679027, 134, '2015-02-01 01:02:05.000000', 'consum', 0.0248, 'lps'),
	(679028, 134, '2015-02-01 01:02:06.000000', 'consum', 0.0241, 'lps'),
	(679029, 134, '2015-02-01 01:02:07.000000', 'consum', 0.0249, 'lps'),
	(679030, 134, '2015-02-01 01:02:08.000000', 'consum', 0.0211, 'lps'),
	(679031, 134, '2015-02-01 01:02:09.000000', 'consum', 0.0305, 'lps'),
	(679032, 134, '2015-02-01 01:02:10.000000', 'consum', 0.0272, 'lps'),
	(679033, 134, '2015-02-01 01:02:11.000000', 'consum', 0.0235, 'lps'),
	(679034, 134, '2015-02-01 01:02:12.000000', 'consum', 0.0253, 'lps'),
	(679035, 134, '2015-02-01 01:02:13.000000', 'consum', 0.0248, 'lps'),
	(679036, 134, '2015-02-01 01:02:14.000000', 'consum', 0.0270, 'lps'),
	(679037, 134, '2015-02-01 01:02:15.000000', 'consum', 0.0292, 'lps'),
	(679038, 134, '2015-02-01 01:02:16.000000', 'consum', 0.0237, 'lps'),
	(679039, 134, '2015-02-01 01:02:17.000000', 'consum', 0.0304, 'lps'),
	(679040, 134, '2015-02-01 01:02:18.000000', 'consum', 0.0293, 'lps'),
	(679041, 134, '2015-02-01 01:02:19.000000', 'consum', 0.0239, 'lps'),
	(679042, 134, '2015-02-01 01:02:20.000000', 'consum', 0.0211, 'lps'),
	(679043, 134, '2015-02-01 01:02:21.000000', 'consum', 0.0229, 'lps'),
	(679044, 134, '2015-02-01 01:02:22.000000', 'consum', 0.0305, 'lps'),
	(679045, 134, '2015-02-01 01:02:23.000000', 'consum', 0.0214, 'lps'),
	(679046, 134, '2015-02-01 01:02:24.000000', 'consum', 0.0253, 'lps'),
	(679047, 134, '2015-02-01 01:02:25.000000', 'consum', 0.0211, 'lps'),
	(679048, 134, '2015-02-01 01:02:26.000000', 'consum', 0.0291, 'lps'),
	(679049, 134, '2015-02-01 01:02:27.000000', 'consum', 0.0305, 'lps'),
	(679050, 134, '2015-02-01 01:02:28.000000', 'consum', 0.0234, 'lps'),
	(679051, 134, '2015-02-01 01:02:29.000000', 'consum', 0.0254, 'lps'),
	(679052, 134, '2015-02-01 01:02:30.000000', 'consum', 0.0255, 'lps'),
	(679053, 134, '2015-02-01 01:02:31.000000', 'consum', 0.0304, 'lps'),
	(679054, 134, '2015-02-01 01:02:32.000000', 'consum', 0.0235, 'lps'),
	(679055, 134, '2015-02-01 01:02:33.000000', 'consum', 0.0261, 'lps'),
	(679056, 134, '2015-02-01 01:02:34.000000', 'consum', 0.0285, 'lps'),
	(679057, 134, '2015-02-01 01:02:35.000000', 'consum', 0.0228, 'lps'),
	(679058, 134, '2015-02-01 01:02:36.000000', 'consum', 0.0282, 'lps'),
	(679059, 134, '2015-02-01 01:02:37.000000', 'consum', 0.0308, 'lps'),
	(679060, 134, '2015-02-01 01:02:38.000000', 'consum', 0.0281, 'lps'),
	(679061, 134, '2015-02-01 01:02:39.000000', 'consum', 0.0273, 'lps'),
	(679062, 134, '2015-02-01 01:02:40.000000', 'consum', 0.0310, 'lps'),
	(679063, 134, '2015-02-01 01:02:41.000000', 'consum', 0.0215, 'lps'),
	(679064, 134, '2015-02-01 01:02:42.000000', 'consum', 0.0243, 'lps'),
	(679065, 134, '2015-02-01 01:02:43.000000', 'consum', 0.0258, 'lps'),
	(679066, 134, '2015-02-01 01:02:44.000000', 'consum', 0.0247, 'lps'),
	(679067, 134, '2015-02-01 01:02:45.000000', 'consum', 0.0252, 'lps'),
	(679068, 134, '2015-02-01 01:02:46.000000', 'consum', 0.0310, 'lps'),
	(679069, 134, '2015-02-01 01:02:47.000000', 'consum', 0.0277, 'lps'),
	(679070, 134, '2015-02-01 01:02:48.000000', 'consum', 0.0246, 'lps'),
	(679071, 134, '2015-02-01 01:02:49.000000', 'consum', 0.0290, 'lps'),
	(679072, 134, '2015-02-01 01:02:50.000000', 'consum', 0.0299, 'lps'),
	(679073, 134, '2015-02-01 01:02:51.000000', 'consum', 0.0210, 'lps'),
	(679074, 134, '2015-02-01 01:02:52.000000', 'consum', 0.0252, 'lps'),
	(679075, 134, '2015-02-01 01:02:53.000000', 'consum', 0.0216, 'lps'),
	(679076, 134, '2015-02-01 01:02:54.000000', 'consum', 0.0216, 'lps'),
	(679077, 134, '2015-02-01 01:02:55.000000', 'consum', 0.0223, 'lps'),
	(679078, 134, '2015-02-01 01:02:56.000000', 'consum', 0.0256, 'lps'),
	(679079, 134, '2015-02-01 01:02:57.000000', 'consum', 0.0298, 'lps'),
	(679080, 134, '2015-02-01 01:02:58.000000', 'consum', 0.0308, 'lps'),
	(679081, 134, '2015-02-01 01:02:59.000000', 'consum', 0.0231, 'lps'),
	(679082, 134, '2015-02-01 01:03:00.000000', 'consum', 0.0227, 'lps'),
	(679083, 134, '2015-02-01 01:03:01.000000', 'consum', 0.0233, 'lps'),
	(679084, 134, '2015-02-01 01:03:02.000000', 'consum', 0.0273, 'lps'),
	(679085, 134, '2015-02-01 01:03:03.000000', 'consum', 0.0250, 'lps'),
	(679086, 134, '2015-02-01 01:03:04.000000', 'consum', 0.0223, 'lps'),
	(679087, 134, '2015-02-01 01:03:05.000000', 'consum', 0.0260, 'lps'),
	(679088, 134, '2015-02-01 01:03:06.000000', 'consum', 0.0214, 'lps'),
	(679089, 134, '2015-02-01 01:03:07.000000', 'consum', 0.0285, 'lps'),
	(679090, 134, '2015-02-01 01:03:08.000000', 'consum', 0.0265, 'lps'),
	(679091, 134, '2015-02-01 01:03:09.000000', 'consum', 0.0260, 'lps'),
	(679092, 134, '2015-02-01 01:03:10.000000', 'consum', 0.0297, 'lps'),
	(679093, 134, '2015-02-01 01:03:11.000000', 'consum', 0.0288, 'lps'),
	(679094, 134, '2015-02-01 01:03:12.000000', 'consum', 0.0237, 'lps'),
	(679095, 134, '2015-02-01 01:03:13.000000', 'consum', 0.0213, 'lps'),
	(679096, 134, '2015-02-01 01:03:14.000000', 'consum', 0.0250, 'lps'),
	(679097, 134, '2015-02-01 01:03:15.000000', 'consum', 0.0299, 'lps'),
	(679098, 134, '2015-02-01 01:03:16.000000', 'consum', 0.0225, 'lps'),
	(679099, 134, '2015-02-01 01:03:17.000000', 'consum', 0.0227, 'lps'),
	(679100, 134, '2015-02-01 01:03:18.000000', 'consum', 0.0248, 'lps'),
	(679101, 134, '2015-02-01 01:03:19.000000', 'consum', 0.0248, 'lps'),
	(679102, 134, '2015-02-01 01:03:20.000000', 'consum', 0.0284, 'lps'),
	(679103, 134, '2015-02-01 01:03:21.000000', 'consum', 0.0264, 'lps'),
	(679104, 134, '2015-02-01 01:03:22.000000', 'consum', 0.0257, 'lps'),
	(679105, 134, '2015-02-01 01:03:23.000000', 'consum', 0.0282, 'lps'),
	(679106, 134, '2015-02-01 01:03:24.000000', 'consum', 0.0225, 'lps'),
	(679107, 134, '2015-02-01 01:03:25.000000', 'consum', 0.0277, 'lps'),
	(679108, 134, '2015-02-01 01:03:26.000000', 'consum', 0.0292, 'lps'),
	(679109, 134, '2015-02-01 01:03:27.000000', 'consum', 0.0213, 'lps'),
	(679110, 134, '2015-02-01 01:03:28.000000', 'consum', 0.0290, 'lps'),
	(679111, 134, '2015-02-01 01:03:29.000000', 'consum', 0.0293, 'lps'),
	(679112, 134, '2015-02-01 01:03:30.000000', 'consum', 0.0281, 'lps'),
	(679113, 134, '2015-02-01 01:03:31.000000', 'consum', 0.0213, 'lps'),
	(679114, 134, '2015-02-01 01:03:32.000000', 'consum', 0.0221, 'lps'),
	(679115, 134, '2015-02-01 01:03:33.000000', 'consum', 0.0254, 'lps'),
	(679116, 134, '2015-02-01 01:03:34.000000', 'consum', 0.0295, 'lps'),
	(679117, 134, '2015-02-01 01:03:35.000000', 'consum', 0.0296, 'lps'),
	(679118, 134, '2015-02-01 01:03:36.000000', 'consum', 0.0285, 'lps'),
	(679119, 134, '2015-02-01 01:03:37.000000', 'consum', 0.0223, 'lps'),
	(679120, 134, '2015-02-01 01:03:38.000000', 'consum', 0.0257, 'lps'),
	(679121, 134, '2015-02-01 01:03:39.000000', 'consum', 0.0301, 'lps'),
	(679122, 134, '2015-02-01 01:03:40.000000', 'consum', 0.0219, 'lps'),
	(679123, 134, '2015-02-01 01:03:41.000000', 'consum', 0.0291, 'lps'),
	(679124, 134, '2015-02-01 01:03:42.000000', 'consum', 0.0278, 'lps'),
	(679125, 134, '2015-02-01 01:03:43.000000', 'consum', 0.0306, 'lps'),
	(679126, 134, '2015-02-01 01:03:44.000000', 'consum', 0.0283, 'lps'),
	(679127, 134, '2015-02-01 01:03:45.000000', 'consum', 0.0288, 'lps'),
	(679128, 134, '2015-02-01 01:03:46.000000', 'consum', 0.0276, 'lps'),
	(679129, 134, '2015-02-01 01:03:47.000000', 'consum', 0.0308, 'lps'),
	(679130, 134, '2015-02-01 01:03:48.000000', 'consum', 0.0296, 'lps'),
	(679131, 134, '2015-02-01 01:03:49.000000', 'consum', 0.0242, 'lps'),
	(679132, 134, '2015-02-01 01:03:50.000000', 'consum', 0.0219, 'lps'),
	(679133, 134, '2015-02-01 01:03:51.000000', 'consum', 0.0259, 'lps'),
	(679134, 134, '2015-02-01 01:03:52.000000', 'consum', 0.0224, 'lps'),
	(679135, 134, '2015-02-01 01:03:53.000000', 'consum', 0.0238, 'lps'),
	(679136, 134, '2015-02-01 01:03:54.000000', 'consum', 0.0306, 'lps'),
	(679137, 134, '2015-02-01 01:03:55.000000', 'consum', 0.0298, 'lps'),
	(679138, 134, '2015-02-01 01:03:56.000000', 'consum', 0.0261, 'lps'),
	(679139, 134, '2015-02-01 01:03:57.000000', 'consum', 0.0304, 'lps'),
	(679140, 134, '2015-02-01 01:03:58.000000', 'consum', 0.0220, 'lps'),
	(679141, 134, '2015-02-01 01:03:59.000000', 'consum', 0.0286, 'lps'),
	(679142, 134, '2015-02-01 01:04:00.000000', 'consum', 0.0250, 'lps'),
	(679143, 134, '2015-02-01 01:04:01.000000', 'consum', 0.0286, 'lps'),
	(679144, 134, '2015-02-01 01:04:02.000000', 'consum', 0.0264, 'lps'),
	(679145, 134, '2015-02-01 01:04:03.000000', 'consum', 0.0253, 'lps'),
	(679146, 134, '2015-02-01 01:04:04.000000', 'consum', 0.0266, 'lps'),
	(679147, 134, '2015-02-01 01:04:05.000000', 'consum', 0.0255, 'lps'),
	(679148, 134, '2015-02-01 01:04:06.000000', 'consum', 0.0269, 'lps'),
	(679149, 134, '2015-02-01 01:04:07.000000', 'consum', 0.0268, 'lps'),
	(679150, 134, '2015-02-01 01:04:08.000000', 'consum', 0.0222, 'lps'),
	(679151, 134, '2015-02-01 01:04:09.000000', 'consum', 0.0301, 'lps'),
	(679152, 134, '2015-02-01 01:04:10.000000', 'consum', 0.0217, 'lps'),
	(679153, 134, '2015-02-01 01:04:11.000000', 'consum', 0.0283, 'lps'),
	(679154, 134, '2015-02-01 01:04:12.000000', 'consum', 0.0245, 'lps'),
	(679155, 134, '2015-02-01 01:04:13.000000', 'consum', 0.0270, 'lps'),
	(679156, 134, '2015-02-01 01:04:14.000000', 'consum', 0.0303, 'lps'),
	(679157, 134, '2015-02-01 01:04:15.000000', 'consum', 0.0288, 'lps'),
	(679158, 134, '2015-02-01 01:04:16.000000', 'consum', 0.0220, 'lps'),
	(679159, 134, '2015-02-01 01:04:17.000000', 'consum', 0.0234, 'lps'),
	(679160, 134, '2015-02-01 01:04:18.000000', 'consum', 0.0298, 'lps'),
	(679161, 134, '2015-02-01 01:04:19.000000', 'consum', 0.0271, 'lps'),
	(679162, 134, '2015-02-01 01:04:20.000000', 'consum', 0.0252, 'lps'),
	(679163, 134, '2015-02-01 01:04:21.000000', 'consum', 0.0238, 'lps'),
	(679164, 134, '2015-02-01 01:04:22.000000', 'consum', 0.0222, 'lps'),
	(679165, 134, '2015-02-01 01:04:23.000000', 'consum', 0.0291, 'lps'),
	(679166, 134, '2015-02-01 01:04:24.000000', 'consum', 0.0268, 'lps'),
	(679167, 134, '2015-02-01 01:04:25.000000', 'consum', 0.0260, 'lps'),
	(679168, 134, '2015-02-01 01:04:26.000000', 'consum', 0.0287, 'lps'),
	(679169, 134, '2015-02-01 01:04:27.000000', 'consum', 0.0237, 'lps'),
	(679170, 134, '2015-02-01 01:04:28.000000', 'consum', 0.0218, 'lps'),
	(679171, 134, '2015-02-01 01:04:29.000000', 'consum', 0.0274, 'lps'),
	(679172, 134, '2015-02-01 01:04:30.000000', 'consum', 0.0300, 'lps'),
	(679173, 134, '2015-02-01 01:04:31.000000', 'consum', 0.0261, 'lps'),
	(679174, 134, '2015-02-01 01:04:32.000000', 'consum', 0.0301, 'lps'),
	(679175, 134, '2015-02-01 01:04:33.000000', 'consum', 0.0307, 'lps'),
	(679176, 134, '2015-02-01 01:04:34.000000', 'consum', 0.0213, 'lps'),
	(679177, 134, '2015-02-01 01:04:35.000000', 'consum', 0.0246, 'lps'),
	(679178, 134, '2015-02-01 01:04:36.000000', 'consum', 0.0279, 'lps'),
	(679179, 134, '2015-02-01 01:04:37.000000', 'consum', 0.0242, 'lps'),
	(679180, 134, '2015-02-01 01:04:38.000000', 'consum', 0.0265, 'lps'),
	(679181, 134, '2015-02-01 01:04:39.000000', 'consum', 0.0287, 'lps'),
	(679182, 134, '2015-02-01 01:04:40.000000', 'consum', 0.0226, 'lps'),
	(679183, 134, '2015-02-01 01:04:41.000000', 'consum', 0.0266, 'lps'),
	(679184, 134, '2015-02-01 01:04:42.000000', 'consum', 0.0234, 'lps'),
	(679185, 134, '2015-02-01 01:04:43.000000', 'consum', 0.0264, 'lps'),
	(679186, 134, '2015-02-01 01:04:44.000000', 'consum', 0.0309, 'lps'),
	(679187, 134, '2015-02-01 01:04:45.000000', 'consum', 0.0233, 'lps'),
	(679188, 134, '2015-02-01 01:04:46.000000', 'consum', 0.0234, 'lps'),
	(679189, 134, '2015-02-01 01:04:47.000000', 'consum', 0.0263, 'lps'),
	(679190, 134, '2015-02-01 01:04:48.000000', 'consum', 0.0298, 'lps'),
	(679191, 134, '2015-02-01 01:04:49.000000', 'consum', 0.0287, 'lps'),
	(679192, 134, '2015-02-01 01:04:50.000000', 'consum', 0.0227, 'lps'),
	(679193, 134, '2015-02-01 01:04:51.000000', 'consum', 0.0270, 'lps'),
	(679194, 134, '2015-02-01 01:04:52.000000', 'consum', 0.0254, 'lps'),
	(679195, 134, '2015-02-01 01:04:53.000000', 'consum', 0.0250, 'lps'),
	(679196, 134, '2015-02-01 01:04:54.000000', 'consum', 0.0278, 'lps'),
	(679197, 134, '2015-02-01 01:04:55.000000', 'consum', 0.0224, 'lps'),
	(679198, 134, '2015-02-01 01:04:56.000000', 'consum', 0.0283, 'lps'),
	(679199, 134, '2015-02-01 01:04:57.000000', 'consum', 0.0224, 'lps'),
	(679200, 134, '2015-02-01 01:04:58.000000', 'consum', 0.0267, 'lps'),
	(679201, 134, '2015-02-01 01:04:59.000000', 'consum', 0.0247, 'lps'),
	(679202, 134, '2015-02-01 01:05:00.000000', 'consum', 0.0227, 'lps'),
	(679203, 134, '2015-02-01 01:05:01.000000', 'consum', 0.0288, 'lps'),
	(679204, 134, '2015-02-01 01:05:02.000000', 'consum', 0.0241, 'lps'),
	(679205, 134, '2015-02-01 01:05:03.000000', 'consum', 0.0233, 'lps'),
	(679206, 134, '2015-02-01 01:05:04.000000', 'consum', 0.0231, 'lps'),
	(679207, 134, '2015-02-01 01:05:05.000000', 'consum', 0.0247, 'lps'),
	(679208, 134, '2015-02-01 01:05:06.000000', 'consum', 0.0230, 'lps'),
	(679209, 134, '2015-02-01 01:05:07.000000', 'consum', 0.0303, 'lps'),
	(679210, 134, '2015-02-01 01:05:08.000000', 'consum', 0.0307, 'lps'),
	(679211, 134, '2015-02-01 01:05:09.000000', 'consum', 0.0312, 'lps'),
	(679212, 134, '2015-02-01 01:05:10.000000', 'consum', 0.0223, 'lps'),
	(679213, 134, '2015-02-01 01:05:11.000000', 'consum', 0.0278, 'lps'),
	(679214, 134, '2015-02-01 01:05:12.000000', 'consum', 0.0305, 'lps'),
	(679215, 134, '2015-02-01 01:05:13.000000', 'consum', 0.0275, 'lps'),
	(679216, 134, '2015-02-01 01:05:14.000000', 'consum', 0.0253, 'lps'),
	(679217, 134, '2015-02-01 01:05:15.000000', 'consum', 0.0229, 'lps'),
	(679218, 134, '2015-02-01 01:05:16.000000', 'consum', 0.0281, 'lps'),
	(679219, 134, '2015-02-01 01:05:17.000000', 'consum', 0.0300, 'lps'),
	(679220, 134, '2015-02-01 01:05:18.000000', 'consum', 0.0243, 'lps'),
	(679221, 134, '2015-02-01 01:05:19.000000', 'consum', 0.0312, 'lps'),
	(679222, 134, '2015-02-01 01:05:20.000000', 'consum', 0.0312, 'lps'),
	(679223, 134, '2015-02-01 01:05:21.000000', 'consum', 0.0312, 'lps'),
	(679224, 134, '2015-02-01 01:05:22.000000', 'consum', 0.0310, 'lps'),
	(679225, 134, '2015-02-01 01:05:23.000000', 'consum', 0.0300, 'lps'),
	(679226, 134, '2015-02-01 01:05:24.000000', 'consum', 0.0260, 'lps'),
	(679227, 134, '2015-02-01 01:05:25.000000', 'consum', 0.0295, 'lps'),
	(679228, 134, '2015-02-01 01:05:26.000000', 'consum', 0.0277, 'lps'),
	(679229, 134, '2015-02-01 01:05:27.000000', 'consum', 0.0291, 'lps'),
	(679230, 134, '2015-02-01 01:05:28.000000', 'consum', 0.0310, 'lps'),
	(679231, 134, '2015-02-01 01:05:29.000000', 'consum', 0.0263, 'lps'),
	(679232, 134, '2015-02-01 01:05:30.000000', 'consum', 0.0280, 'lps'),
	(679233, 134, '2015-02-01 01:05:31.000000', 'consum', 0.0296, 'lps'),
	(679234, 134, '2015-02-01 01:05:32.000000', 'consum', 0.0227, 'lps'),
	(679235, 134, '2015-02-01 01:05:33.000000', 'consum', 0.0243, 'lps'),
	(679236, 134, '2015-02-01 01:05:34.000000', 'consum', 0.0220, 'lps'),
	(679237, 134, '2015-02-01 01:05:35.000000', 'consum', 0.0265, 'lps'),
	(679238, 134, '2015-02-01 01:05:36.000000', 'consum', 0.0249, 'lps'),
	(679239, 134, '2015-02-01 01:05:37.000000', 'consum', 0.0242, 'lps'),
	(679240, 134, '2015-02-01 01:05:38.000000', 'consum', 0.0251, 'lps'),
	(679241, 134, '2015-02-01 01:05:39.000000', 'consum', 0.0216, 'lps'),
	(679242, 134, '2015-02-01 01:05:40.000000', 'consum', 0.0223, 'lps'),
	(679243, 134, '2015-02-01 01:05:41.000000', 'consum', 0.0258, 'lps'),
	(679244, 134, '2015-02-01 01:05:42.000000', 'consum', 0.0306, 'lps'),
	(679245, 134, '2015-02-01 01:05:43.000000', 'consum', 0.0237, 'lps'),
	(679246, 134, '2015-02-01 01:05:44.000000', 'consum', 0.0266, 'lps'),
	(679247, 134, '2015-02-01 01:05:45.000000', 'consum', 0.0304, 'lps'),
	(679248, 134, '2015-02-01 01:05:46.000000', 'consum', 0.0309, 'lps'),
	(679249, 134, '2015-02-01 01:05:47.000000', 'consum', 0.0218, 'lps'),
	(679250, 134, '2015-02-01 01:05:48.000000', 'consum', 0.0263, 'lps'),
	(679251, 134, '2015-02-01 01:05:49.000000', 'consum', 0.0246, 'lps'),
	(679252, 134, '2015-02-01 01:05:50.000000', 'consum', 0.0231, 'lps'),
	(679253, 134, '2015-02-01 01:05:51.000000', 'consum', 0.0309, 'lps'),
	(679254, 134, '2015-02-01 01:05:52.000000', 'consum', 0.0231, 'lps'),
	(679255, 134, '2015-02-01 01:05:53.000000', 'consum', 0.0223, 'lps'),
	(679256, 134, '2015-02-01 01:05:54.000000', 'consum', 0.0215, 'lps'),
	(679257, 134, '2015-02-01 01:05:55.000000', 'consum', 0.0300, 'lps'),
	(679258, 134, '2015-02-01 01:05:56.000000', 'consum', 0.0232, 'lps'),
	(679259, 134, '2015-02-01 01:05:57.000000', 'consum', 0.0258, 'lps'),
	(679260, 134, '2015-02-01 01:05:58.000000', 'consum', 0.0280, 'lps'),
	(679261, 134, '2015-02-01 01:05:59.000000', 'consum', 0.0212, 'lps'),
	(679262, 134, '2015-02-01 01:06:00.000000', 'consum', 0.0215, 'lps'),
	(679263, 134, '2015-02-01 01:06:01.000000', 'consum', 0.0230, 'lps'),
	(679264, 134, '2015-02-01 01:06:02.000000', 'consum', 0.0294, 'lps'),
	(679265, 134, '2015-02-01 01:06:03.000000', 'consum', 0.0265, 'lps'),
	(679266, 134, '2015-02-01 01:06:04.000000', 'consum', 0.0230, 'lps'),
	(679267, 134, '2015-02-01 01:06:05.000000', 'consum', 0.0249, 'lps'),
	(679268, 134, '2015-02-01 01:06:06.000000', 'consum', 0.0241, 'lps'),
	(679269, 134, '2015-02-01 01:06:07.000000', 'consum', 0.0250, 'lps'),
	(679270, 134, '2015-02-01 01:06:08.000000', 'consum', 0.0215, 'lps'),
	(679271, 134, '2015-02-01 01:06:09.000000', 'consum', 0.0217, 'lps'),
	(679272, 134, '2015-02-01 01:06:10.000000', 'consum', 0.0231, 'lps'),
	(679273, 134, '2015-02-01 01:06:11.000000', 'consum', 0.0295, 'lps'),
	(679274, 134, '2015-02-01 01:06:12.000000', 'consum', 0.0264, 'lps'),
	(679275, 134, '2015-02-01 01:06:13.000000', 'consum', 0.0223, 'lps'),
	(679276, 134, '2015-02-01 01:06:14.000000', 'consum', 0.0217, 'lps'),
	(679277, 134, '2015-02-01 01:06:15.000000', 'consum', 0.0312, 'lps'),
	(679278, 134, '2015-02-01 01:06:16.000000', 'consum', 0.0286, 'lps'),
	(679279, 134, '2015-02-01 01:06:17.000000', 'consum', 0.0287, 'lps'),
	(679280, 134, '2015-02-01 01:06:18.000000', 'consum', 0.0261, 'lps'),
	(679281, 134, '2015-02-01 01:06:19.000000', 'consum', 0.0236, 'lps'),
	(679282, 134, '2015-02-01 01:06:20.000000', 'consum', 0.0291, 'lps'),
	(679283, 134, '2015-02-01 01:06:21.000000', 'consum', 0.0226, 'lps'),
	(679284, 134, '2015-02-01 01:06:22.000000', 'consum', 0.0256, 'lps'),
	(679285, 134, '2015-02-01 01:06:23.000000', 'consum', 0.0291, 'lps'),
	(679286, 134, '2015-02-01 01:06:24.000000', 'consum', 0.0269, 'lps'),
	(679287, 134, '2015-02-01 01:06:25.000000', 'consum', 0.0265, 'lps'),
	(679288, 134, '2015-02-01 01:06:26.000000', 'consum', 0.0307, 'lps'),
	(679289, 134, '2015-02-01 01:06:27.000000', 'consum', 0.0222, 'lps'),
	(679290, 134, '2015-02-01 01:06:28.000000', 'consum', 0.0287, 'lps'),
	(679291, 134, '2015-02-01 01:06:29.000000', 'consum', 0.0252, 'lps'),
	(679292, 134, '2015-02-01 01:06:30.000000', 'consum', 0.0291, 'lps'),
	(679293, 134, '2015-02-01 01:06:31.000000', 'consum', 0.0285, 'lps'),
	(679294, 134, '2015-02-01 01:06:32.000000', 'consum', 0.0239, 'lps'),
	(679295, 134, '2015-02-01 01:06:33.000000', 'consum', 0.0233, 'lps'),
	(679296, 134, '2015-02-01 01:06:34.000000', 'consum', 0.0237, 'lps'),
	(679297, 134, '2015-02-01 01:06:35.000000', 'consum', 0.0278, 'lps'),
	(679298, 134, '2015-02-01 01:06:36.000000', 'consum', 0.0262, 'lps'),
	(679299, 134, '2015-02-01 01:06:37.000000', 'consum', 0.0268, 'lps'),
	(679300, 134, '2015-02-01 01:06:38.000000', 'consum', 0.0239, 'lps'),
	(679301, 134, '2015-02-01 01:06:39.000000', 'consum', 0.0287, 'lps'),
	(679302, 134, '2015-02-01 01:06:40.000000', 'consum', 0.0302, 'lps'),
	(679303, 134, '2015-02-01 01:06:41.000000', 'consum', 0.0233, 'lps'),
	(679304, 134, '2015-02-01 01:06:42.000000', 'consum', 0.0254, 'lps'),
	(679305, 134, '2015-02-01 01:06:43.000000', 'consum', 0.0260, 'lps'),
	(679306, 134, '2015-02-01 01:06:44.000000', 'consum', 0.0226, 'lps'),
	(679307, 134, '2015-02-01 01:06:45.000000', 'consum', 0.0245, 'lps'),
	(679308, 134, '2015-02-01 01:06:46.000000', 'consum', 0.0232, 'lps'),
	(679309, 134, '2015-02-01 01:06:47.000000', 'consum', 0.0217, 'lps'),
	(679310, 134, '2015-02-01 01:06:48.000000', 'consum', 0.0280, 'lps'),
	(679311, 134, '2015-02-01 01:06:49.000000', 'consum', 0.0234, 'lps'),
	(679312, 134, '2015-02-01 01:06:50.000000', 'consum', 0.0222, 'lps'),
	(679313, 134, '2015-02-01 01:06:51.000000', 'consum', 0.0299, 'lps'),
	(679314, 134, '2015-02-01 01:06:52.000000', 'consum', 0.0211, 'lps'),
	(679315, 134, '2015-02-01 01:06:53.000000', 'consum', 0.0256, 'lps'),
	(679316, 134, '2015-02-01 01:06:54.000000', 'consum', 0.0232, 'lps'),
	(679317, 134, '2015-02-01 01:06:55.000000', 'consum', 0.0286, 'lps'),
	(679318, 134, '2015-02-01 01:06:56.000000', 'consum', 0.0214, 'lps'),
	(679319, 134, '2015-02-01 01:06:57.000000', 'consum', 0.0311, 'lps'),
	(679320, 134, '2015-02-01 01:06:58.000000', 'consum', 0.0290, 'lps'),
	(679321, 134, '2015-02-01 01:06:59.000000', 'consum', 0.0310, 'lps'),
	(679322, 134, '2015-02-01 01:07:00.000000', 'consum', 0.0264, 'lps'),
	(679323, 134, '2015-02-01 01:07:01.000000', 'consum', 0.0285, 'lps'),
	(679324, 134, '2015-02-01 01:07:02.000000', 'consum', 0.0218, 'lps'),
	(679325, 134, '2015-02-01 01:07:03.000000', 'consum', 0.0231, 'lps'),
	(679326, 134, '2015-02-01 01:07:04.000000', 'consum', 0.0292, 'lps'),
	(679327, 134, '2015-02-01 01:07:05.000000', 'consum', 0.0247, 'lps'),
	(679328, 134, '2015-02-01 01:07:06.000000', 'consum', 0.0253, 'lps'),
	(679329, 134, '2015-02-01 01:07:07.000000', 'consum', 0.0213, 'lps'),
	(679330, 134, '2015-02-01 01:07:08.000000', 'consum', 0.0302, 'lps'),
	(679331, 134, '2015-02-01 01:07:09.000000', 'consum', 0.0248, 'lps'),
	(679332, 134, '2015-02-01 01:07:10.000000', 'consum', 0.0230, 'lps'),
	(679333, 134, '2015-02-01 01:07:11.000000', 'consum', 0.0297, 'lps'),
	(679334, 134, '2015-02-01 01:07:12.000000', 'consum', 0.0276, 'lps'),
	(679335, 134, '2015-02-01 01:07:13.000000', 'consum', 0.0283, 'lps'),
	(679336, 134, '2015-02-01 01:07:14.000000', 'consum', 0.0271, 'lps'),
	(679337, 134, '2015-02-01 01:07:15.000000', 'consum', 0.0298, 'lps'),
	(679338, 134, '2015-02-01 01:07:16.000000', 'consum', 0.0261, 'lps'),
	(679339, 134, '2015-02-01 01:07:17.000000', 'consum', 0.0305, 'lps'),
	(679340, 134, '2015-02-01 01:07:18.000000', 'consum', 0.0223, 'lps'),
	(679341, 134, '2015-02-01 01:07:19.000000', 'consum', 0.0301, 'lps'),
	(679342, 134, '2015-02-01 01:07:20.000000', 'consum', 0.0212, 'lps'),
	(679343, 134, '2015-02-01 01:07:21.000000', 'consum', 0.0258, 'lps'),
	(679344, 134, '2015-02-01 01:07:22.000000', 'consum', 0.0240, 'lps'),
	(679345, 134, '2015-02-01 01:07:23.000000', 'consum', 0.0214, 'lps'),
	(679346, 134, '2015-02-01 01:07:24.000000', 'consum', 0.0246, 'lps'),
	(679347, 134, '2015-02-01 01:07:25.000000', 'consum', 0.0276, 'lps'),
	(679348, 134, '2015-02-01 01:07:26.000000', 'consum', 0.0226, 'lps'),
	(679349, 134, '2015-02-01 01:07:27.000000', 'consum', 0.0299, 'lps'),
	(679350, 134, '2015-02-01 01:07:28.000000', 'consum', 0.0296, 'lps'),
	(679351, 134, '2015-02-01 01:07:29.000000', 'consum', 0.0273, 'lps'),
	(679352, 134, '2015-02-01 01:07:30.000000', 'consum', 0.0266, 'lps'),
	(679353, 134, '2015-02-01 01:07:31.000000', 'consum', 0.0301, 'lps'),
	(679354, 134, '2015-02-01 01:07:32.000000', 'consum', 0.0294, 'lps'),
	(679355, 134, '2015-02-01 01:07:33.000000', 'consum', 0.0251, 'lps'),
	(679356, 134, '2015-02-01 01:07:34.000000', 'consum', 0.0270, 'lps'),
	(679357, 134, '2015-02-01 01:07:35.000000', 'consum', 0.0283, 'lps'),
	(679358, 134, '2015-02-01 01:07:36.000000', 'consum', 0.0292, 'lps'),
	(679359, 134, '2015-02-01 01:07:37.000000', 'consum', 0.0301, 'lps'),
	(679360, 134, '2015-02-01 01:07:38.000000', 'consum', 0.0210, 'lps'),
	(679361, 134, '2015-02-01 01:07:39.000000', 'consum', 0.0250, 'lps'),
	(679362, 134, '2015-02-01 01:07:40.000000', 'consum', 0.0305, 'lps'),
	(679363, 134, '2015-02-01 01:07:41.000000', 'consum', 0.0257, 'lps'),
	(679364, 134, '2015-02-01 01:07:42.000000', 'consum', 0.0262, 'lps'),
	(679365, 134, '2015-02-01 01:07:43.000000', 'consum', 0.0226, 'lps'),
	(679366, 134, '2015-02-01 01:07:44.000000', 'consum', 0.0240, 'lps'),
	(679367, 134, '2015-02-01 01:07:45.000000', 'consum', 0.0210, 'lps'),
	(679368, 134, '2015-02-01 01:07:46.000000', 'consum', 0.0222, 'lps'),
	(679369, 134, '2015-02-01 01:07:47.000000', 'consum', 0.0273, 'lps'),
	(679370, 134, '2015-02-01 01:07:48.000000', 'consum', 0.0281, 'lps'),
	(679371, 134, '2015-02-01 01:07:49.000000', 'consum', 0.0272, 'lps'),
	(679372, 134, '2015-02-01 01:07:50.000000', 'consum', 0.0311, 'lps'),
	(679373, 134, '2015-02-01 01:07:51.000000', 'consum', 0.0219, 'lps'),
	(679374, 134, '2015-02-01 01:07:52.000000', 'consum', 0.0260, 'lps'),
	(679375, 134, '2015-02-01 01:07:53.000000', 'consum', 0.0228, 'lps'),
	(679376, 134, '2015-02-01 01:07:54.000000', 'consum', 0.0255, 'lps'),
	(679377, 134, '2015-02-01 01:07:55.000000', 'consum', 0.0279, 'lps'),
	(679378, 134, '2015-02-01 01:07:56.000000', 'consum', 0.0215, 'lps'),
	(679379, 134, '2015-02-01 01:07:57.000000', 'consum', 0.0235, 'lps'),
	(679380, 134, '2015-02-01 01:07:58.000000', 'consum', 0.0218, 'lps'),
	(679381, 134, '2015-02-01 01:07:59.000000', 'consum', 0.0277, 'lps'),
	(679382, 134, '2015-02-01 01:08:00.000000', 'consum', 0.0215, 'lps'),
	(679383, 134, '2015-02-01 01:08:01.000000', 'consum', 0.0239, 'lps'),
	(679384, 134, '2015-02-01 01:08:02.000000', 'consum', 0.0236, 'lps'),
	(679385, 134, '2015-02-01 01:08:03.000000', 'consum', 0.0253, 'lps'),
	(679386, 134, '2015-02-01 01:08:04.000000', 'consum', 0.0244, 'lps'),
	(679387, 134, '2015-02-01 01:08:05.000000', 'consum', 0.0252, 'lps'),
	(679388, 134, '2015-02-01 01:08:06.000000', 'consum', 0.0216, 'lps'),
	(679389, 134, '2015-02-01 01:08:07.000000', 'consum', 0.0219, 'lps'),
	(679390, 134, '2015-02-01 01:08:08.000000', 'consum', 0.0238, 'lps'),
	(679391, 134, '2015-02-01 01:08:09.000000', 'consum', 0.0219, 'lps'),
	(679392, 134, '2015-02-01 01:08:10.000000', 'consum', 0.0273, 'lps'),
	(679393, 134, '2015-02-01 01:08:11.000000', 'consum', 0.0295, 'lps'),
	(679394, 134, '2015-02-01 01:08:12.000000', 'consum', 0.0238, 'lps'),
	(679395, 134, '2015-02-01 01:08:13.000000', 'consum', 0.0303, 'lps'),
	(679396, 134, '2015-02-01 01:08:14.000000', 'consum', 0.0281, 'lps'),
	(679397, 134, '2015-02-01 01:08:15.000000', 'consum', 0.0287, 'lps'),
	(679398, 134, '2015-02-01 01:08:16.000000', 'consum', 0.0280, 'lps'),
	(679399, 134, '2015-02-01 01:08:17.000000', 'consum', 0.0226, 'lps'),
	(679400, 134, '2015-02-01 01:08:18.000000', 'consum', 0.0286, 'lps'),
	(679401, 134, '2015-02-01 01:08:19.000000', 'consum', 0.0233, 'lps'),
	(679402, 134, '2015-02-01 01:08:20.000000', 'consum', 0.0302, 'lps'),
	(679403, 134, '2015-02-01 01:08:21.000000', 'consum', 0.0295, 'lps'),
	(679404, 134, '2015-02-01 01:08:22.000000', 'consum', 0.0256, 'lps'),
	(679405, 134, '2015-02-01 01:08:23.000000', 'consum', 0.0287, 'lps'),
	(679406, 134, '2015-02-01 01:08:24.000000', 'consum', 0.0254, 'lps'),
	(679407, 134, '2015-02-01 01:08:25.000000', 'consum', 0.0301, 'lps'),
	(679408, 134, '2015-02-01 01:08:26.000000', 'consum', 0.0223, 'lps'),
	(679409, 134, '2015-02-01 01:08:27.000000', 'consum', 0.0210, 'lps'),
	(679410, 134, '2015-02-01 01:08:28.000000', 'consum', 0.0273, 'lps'),
	(679411, 134, '2015-02-01 01:08:29.000000', 'consum', 0.0219, 'lps'),
	(679412, 134, '2015-02-01 01:08:30.000000', 'consum', 0.0273, 'lps'),
	(679413, 134, '2015-02-01 01:08:31.000000', 'consum', 0.0291, 'lps'),
	(679414, 134, '2015-02-01 01:08:32.000000', 'consum', 0.0219, 'lps'),
	(679415, 134, '2015-02-01 01:08:33.000000', 'consum', 0.0219, 'lps'),
	(679416, 134, '2015-02-01 01:08:34.000000', 'consum', 0.0228, 'lps'),
	(679417, 134, '2015-02-01 01:08:35.000000', 'consum', 0.0275, 'lps'),
	(679418, 134, '2015-02-01 01:08:36.000000', 'consum', 0.0275, 'lps'),
	(679419, 134, '2015-02-01 01:08:37.000000', 'consum', 0.0236, 'lps'),
	(679420, 134, '2015-02-01 01:08:38.000000', 'consum', 0.0251, 'lps'),
	(679421, 134, '2015-02-01 01:08:39.000000', 'consum', 0.0235, 'lps'),
	(679422, 134, '2015-02-01 01:08:40.000000', 'consum', 0.0213, 'lps'),
	(679423, 134, '2015-02-01 01:08:41.000000', 'consum', 0.0253, 'lps'),
	(679424, 134, '2015-02-01 01:08:42.000000', 'consum', 0.0312, 'lps'),
	(679425, 134, '2015-02-01 01:08:43.000000', 'consum', 0.0283, 'lps'),
	(679426, 134, '2015-02-01 01:08:44.000000', 'consum', 0.0268, 'lps'),
	(679427, 134, '2015-02-01 01:08:45.000000', 'consum', 0.0283, 'lps'),
	(679428, 134, '2015-02-01 01:08:46.000000', 'consum', 0.0300, 'lps'),
	(679429, 134, '2015-02-01 01:08:47.000000', 'consum', 0.0236, 'lps'),
	(679430, 134, '2015-02-01 01:08:48.000000', 'consum', 0.0274, 'lps'),
	(679431, 134, '2015-02-01 01:08:49.000000', 'consum', 0.0247, 'lps'),
	(679432, 134, '2015-02-01 01:08:50.000000', 'consum', 0.0307, 'lps'),
	(679433, 134, '2015-02-01 01:08:51.000000', 'consum', 0.0278, 'lps'),
	(679434, 134, '2015-02-01 01:08:52.000000', 'consum', 0.0256, 'lps'),
	(679435, 134, '2015-02-01 01:08:53.000000', 'consum', 0.0236, 'lps'),
	(679436, 134, '2015-02-01 01:08:54.000000', 'consum', 0.0305, 'lps'),
	(679437, 134, '2015-02-01 01:08:55.000000', 'consum', 0.0299, 'lps'),
	(679438, 134, '2015-02-01 01:08:56.000000', 'consum', 0.0268, 'lps'),
	(679439, 134, '2015-02-01 01:08:57.000000', 'consum', 0.0233, 'lps'),
	(679440, 134, '2015-02-01 01:08:58.000000', 'consum', 0.0256, 'lps'),
	(679441, 134, '2015-02-01 01:08:59.000000', 'consum', 0.0269, 'lps'),
	(679442, 134, '2015-02-01 01:09:00.000000', 'consum', 0.0263, 'lps'),
	(679443, 134, '2015-02-01 01:09:01.000000', 'consum', 0.0301, 'lps'),
	(679444, 134, '2015-02-01 01:09:02.000000', 'consum', 0.0298, 'lps'),
	(679445, 134, '2015-02-01 01:09:03.000000', 'consum', 0.0275, 'lps'),
	(679446, 134, '2015-02-01 01:09:04.000000', 'consum', 0.0270, 'lps'),
	(679447, 134, '2015-02-01 01:09:05.000000', 'consum', 0.0215, 'lps'),
	(679448, 134, '2015-02-01 01:09:06.000000', 'consum', 0.0262, 'lps'),
	(679449, 134, '2015-02-01 01:09:07.000000', 'consum', 0.0250, 'lps'),
	(679450, 134, '2015-02-01 01:09:08.000000', 'consum', 0.0253, 'lps'),
	(679451, 134, '2015-02-01 01:09:09.000000', 'consum', 0.0306, 'lps'),
	(679452, 134, '2015-02-01 01:09:10.000000', 'consum', 0.0253, 'lps'),
	(679453, 134, '2015-02-01 01:09:11.000000', 'consum', 0.0239, 'lps'),
	(679454, 134, '2015-02-01 01:09:12.000000', 'consum', 0.0228, 'lps'),
	(679455, 134, '2015-02-01 01:09:13.000000', 'consum', 0.0212, 'lps'),
	(679456, 134, '2015-02-01 01:09:14.000000', 'consum', 0.0271, 'lps'),
	(679457, 134, '2015-02-01 01:09:15.000000', 'consum', 0.0303, 'lps'),
	(679458, 134, '2015-02-01 01:09:16.000000', 'consum', 0.0287, 'lps'),
	(679459, 134, '2015-02-01 01:09:17.000000', 'consum', 0.0213, 'lps'),
	(679460, 134, '2015-02-01 01:09:18.000000', 'consum', 0.0302, 'lps'),
	(679461, 134, '2015-02-01 01:09:19.000000', 'consum', 0.0249, 'lps'),
	(679462, 134, '2015-02-01 01:09:20.000000', 'consum', 0.0234, 'lps'),
	(679463, 134, '2015-02-01 01:09:21.000000', 'consum', 0.0213, 'lps'),
	(679464, 134, '2015-02-01 01:09:22.000000', 'consum', 0.0255, 'lps'),
	(679465, 134, '2015-02-01 01:09:23.000000', 'consum', 0.0221, 'lps'),
	(679466, 134, '2015-02-01 01:09:24.000000', 'consum', 0.0234, 'lps'),
	(679467, 134, '2015-02-01 01:09:25.000000', 'consum', 0.0298, 'lps'),
	(679468, 134, '2015-02-01 01:09:26.000000', 'consum', 0.0268, 'lps'),
	(679469, 134, '2015-02-01 01:09:27.000000', 'consum', 0.0239, 'lps'),
	(679470, 134, '2015-02-01 01:09:28.000000', 'consum', 0.0282, 'lps'),
	(679471, 134, '2015-02-01 01:09:29.000000', 'consum', 0.0279, 'lps'),
	(679472, 134, '2015-02-01 01:09:30.000000', 'consum', 0.0237, 'lps'),
	(679473, 134, '2015-02-01 01:09:31.000000', 'consum', 0.0240, 'lps'),
	(679474, 134, '2015-02-01 01:09:32.000000', 'consum', 0.0278, 'lps'),
	(679475, 134, '2015-02-01 01:09:33.000000', 'consum', 0.0258, 'lps'),
	(679476, 134, '2015-02-01 01:09:34.000000', 'consum', 0.0243, 'lps'),
	(679477, 134, '2015-02-01 01:09:35.000000', 'consum', 0.0234, 'lps'),
	(679478, 134, '2015-02-01 01:09:36.000000', 'consum', 0.0232, 'lps'),
	(679479, 134, '2015-02-01 01:09:37.000000', 'consum', 0.0248, 'lps'),
	(679480, 134, '2015-02-01 01:09:38.000000', 'consum', 0.0231, 'lps'),
	(679481, 134, '2015-02-01 01:09:39.000000', 'consum', 0.0304, 'lps'),
	(679482, 134, '2015-02-01 01:09:40.000000', 'consum', 0.0307, 'lps'),
	(679483, 134, '2015-02-01 01:09:41.000000', 'consum', 0.0211, 'lps'),
	(679484, 134, '2015-02-01 01:09:42.000000', 'consum', 0.0231, 'lps'),
	(679485, 134, '2015-02-01 01:09:43.000000', 'consum', 0.0312, 'lps'),
	(679486, 134, '2015-02-01 01:09:44.000000', 'consum', 0.0245, 'lps'),
	(679487, 134, '2015-02-01 01:09:45.000000', 'consum', 0.0285, 'lps'),
	(679488, 134, '2015-02-01 01:09:46.000000', 'consum', 0.0275, 'lps'),
	(679489, 134, '2015-02-01 01:09:47.000000', 'consum', 0.0210, 'lps'),
	(679490, 134, '2015-02-01 01:09:48.000000', 'consum', 0.0219, 'lps'),
	(679491, 134, '2015-02-01 01:09:49.000000', 'consum', 0.0258, 'lps'),
	(679492, 134, '2015-02-01 01:09:50.000000', 'consum', 0.0215, 'lps'),
	(679493, 134, '2015-02-01 01:09:51.000000', 'consum', 0.0300, 'lps'),
	(679494, 134, '2015-02-01 01:09:52.000000', 'consum', 0.0232, 'lps'),
	(679495, 134, '2015-02-01 01:09:53.000000', 'consum', 0.0259, 'lps'),
	(679496, 134, '2015-02-01 01:09:54.000000', 'consum', 0.0283, 'lps'),
	(679497, 134, '2015-02-01 01:09:55.000000', 'consum', 0.0224, 'lps'),
	(679498, 134, '2015-02-01 01:09:56.000000', 'consum', 0.0268, 'lps'),
	(679499, 134, '2015-02-01 01:09:57.000000', 'consum', 0.0252, 'lps'),
	(679500, 134, '2015-02-01 01:09:58.000000', 'consum', 0.0247, 'lps'),
	(679501, 134, '2015-02-01 01:09:59.000000', 'consum', 0.0270, 'lps'),
	(679502, 134, '2015-02-01 01:10:00.000000', 'consum', 0.0298, 'lps'),
	(679503, 134, '2015-02-01 01:10:01.000000', 'consum', 0.0263, 'lps'),
	(679504, 134, '2015-02-01 01:10:02.000000', 'consum', 0.0212, 'lps'),
	(679505, 134, '2015-02-01 01:10:03.000000', 'consum', 0.0268, 'lps'),
	(679506, 134, '2015-02-01 01:10:04.000000', 'consum', 0.0287, 'lps'),
	(679507, 134, '2015-02-01 01:10:05.000000', 'consum', 0.0216, 'lps'),
	(679508, 134, '2015-02-01 01:10:06.000000', 'consum', 0.0216, 'lps'),
	(679509, 134, '2015-02-01 01:10:07.000000', 'consum', 0.0220, 'lps'),
	(679510, 134, '2015-02-01 01:10:08.000000', 'consum', 0.0246, 'lps'),
	(679511, 134, '2015-02-01 01:10:09.000000', 'consum', 0.0254, 'lps'),
	(679512, 134, '2015-02-01 01:10:10.000000', 'consum', 0.0222, 'lps'),
	(679513, 134, '2015-02-01 01:10:11.000000', 'consum', 0.0243, 'lps'),
	(679514, 134, '2015-02-01 01:10:12.000000', 'consum', 0.0234, 'lps'),
	(679515, 134, '2015-02-01 01:10:13.000000', 'consum', 0.0231, 'lps'),
	(679516, 134, '2015-02-01 01:10:14.000000', 'consum', 0.0246, 'lps'),
	(679517, 134, '2015-02-01 01:10:15.000000', 'consum', 0.0222, 'lps'),
	(679518, 134, '2015-02-01 01:10:16.000000', 'consum', 0.0267, 'lps'),
	(679519, 134, '2015-02-01 01:10:17.000000', 'consum', 0.0252, 'lps'),
	(679520, 134, '2015-02-01 01:10:18.000000', 'consum', 0.0248, 'lps'),
	(679521, 134, '2015-02-01 01:10:19.000000', 'consum', 0.0278, 'lps'),
	(679522, 134, '2015-02-01 01:10:20.000000', 'consum', 0.0228, 'lps'),
	(679523, 134, '2015-02-01 01:10:21.000000', 'consum', 0.0305, 'lps'),
	(679524, 134, '2015-02-01 01:10:22.000000', 'consum', 0.0218, 'lps'),
	(679525, 134, '2015-02-01 01:10:23.000000', 'consum', 0.0277, 'lps'),
	(679526, 134, '2015-02-01 01:10:24.000000', 'consum', 0.0312, 'lps'),
	(679527, 134, '2015-02-01 01:10:25.000000', 'consum', 0.0213, 'lps'),
	(679528, 134, '2015-02-01 01:10:26.000000', 'consum', 0.0226, 'lps'),
	(679529, 134, '2015-02-01 01:10:27.000000', 'consum', 0.0284, 'lps'),
	(679530, 134, '2015-02-01 01:10:28.000000', 'consum', 0.0223, 'lps'),
	(679531, 134, '2015-02-01 01:10:29.000000', 'consum', 0.0260, 'lps'),
	(679532, 134, '2015-02-01 01:10:30.000000', 'consum', 0.0213, 'lps'),
	(679533, 134, '2015-02-01 01:10:31.000000', 'consum', 0.0285, 'lps'),
	(679534, 134, '2015-02-01 01:10:32.000000', 'consum', 0.0266, 'lps'),
	(679535, 134, '2015-02-01 01:10:33.000000', 'consum', 0.0266, 'lps'),
	(679536, 134, '2015-02-01 01:10:34.000000', 'consum', 0.0217, 'lps'),
	(679537, 134, '2015-02-01 01:10:35.000000', 'consum', 0.0287, 'lps'),
	(679538, 134, '2015-02-01 01:10:36.000000', 'consum', 0.0264, 'lps'),
	(679539, 134, '2015-02-01 01:10:37.000000', 'consum', 0.0250, 'lps'),
	(679540, 134, '2015-02-01 01:10:38.000000', 'consum', 0.0246, 'lps'),
	(679541, 134, '2015-02-01 01:10:39.000000', 'consum', 0.0274, 'lps'),
	(679542, 134, '2015-02-01 01:10:40.000000', 'consum', 0.0216, 'lps'),
	(679543, 134, '2015-02-01 01:10:41.000000', 'consum', 0.0253, 'lps'),
	(679544, 134, '2015-02-01 01:10:42.000000', 'consum', 0.0306, 'lps'),
	(679545, 134, '2015-02-01 01:10:43.000000', 'consum', 0.0253, 'lps'),
	(679546, 134, '2015-02-01 01:10:44.000000', 'consum', 0.0241, 'lps'),
	(679547, 134, '2015-02-01 01:10:45.000000', 'consum', 0.0235, 'lps'),
	(679548, 134, '2015-02-01 01:10:46.000000', 'consum', 0.0243, 'lps'),
	(679549, 134, '2015-02-01 01:10:47.000000', 'consum', 0.0299, 'lps'),
	(679550, 134, '2015-02-01 01:10:48.000000', 'consum', 0.0249, 'lps'),
	(679551, 134, '2015-02-01 01:10:49.000000', 'consum', 0.0242, 'lps'),
	(679552, 134, '2015-02-01 01:10:50.000000', 'consum', 0.0252, 'lps'),
	(679553, 134, '2015-02-01 01:10:51.000000', 'consum', 0.0220, 'lps'),
	(679554, 134, '2015-02-01 01:10:52.000000', 'consum', 0.0239, 'lps'),
	(679555, 134, '2015-02-01 01:10:53.000000', 'consum', 0.0223, 'lps'),
	(679556, 134, '2015-02-01 01:10:54.000000', 'consum', 0.0293, 'lps'),
	(679557, 134, '2015-02-01 01:10:55.000000', 'consum', 0.0277, 'lps'),
	(679558, 134, '2015-02-01 01:10:56.000000', 'consum', 0.0297, 'lps'),
	(679559, 134, '2015-02-01 01:10:57.000000', 'consum', 0.0236, 'lps'),
	(679560, 134, '2015-02-01 01:10:58.000000', 'consum', 0.0286, 'lps'),
	(679561, 134, '2015-02-01 01:10:59.000000', 'consum', 0.0305, 'lps'),
	(679562, 134, '2015-02-01 01:11:00.000000', 'consum', 0.0255, 'lps'),
	(679563, 134, '2015-02-01 01:11:01.000000', 'consum', 0.0250, 'lps'),
	(679564, 134, '2015-02-01 01:11:02.000000', 'consum', 0.0278, 'lps'),
	(679565, 134, '2015-02-01 01:11:03.000000', 'consum', 0.0222, 'lps'),
	(679566, 134, '2015-02-01 01:11:04.000000', 'consum', 0.0272, 'lps'),
	(679567, 134, '2015-02-01 01:11:05.000000', 'consum', 0.0281, 'lps'),
	(679568, 134, '2015-02-01 01:11:06.000000', 'consum', 0.0277, 'lps'),
	(679569, 134, '2015-02-01 01:11:07.000000', 'consum', 0.0229, 'lps'),
	(679570, 134, '2015-02-01 01:11:08.000000', 'consum', 0.0309, 'lps'),
	(679571, 134, '2015-02-01 01:11:09.000000', 'consum', 0.0236, 'lps'),
	(679572, 134, '2015-02-01 01:11:10.000000', 'consum', 0.0252, 'lps'),
	(679573, 134, '2015-02-01 01:11:11.000000', 'consum', 0.0240, 'lps'),
	(679574, 134, '2015-02-01 01:11:12.000000', 'consum', 0.0231, 'lps'),
	(679575, 134, '2015-02-01 01:11:13.000000', 'consum', 0.0229, 'lps'),
	(679576, 134, '2015-02-01 01:11:14.000000', 'consum', 0.0239, 'lps'),
	(679577, 134, '2015-02-01 01:11:15.000000', 'consum', 0.0301, 'lps'),
	(679578, 134, '2015-02-01 01:11:16.000000', 'consum', 0.0270, 'lps'),
	(679579, 134, '2015-02-01 01:11:17.000000', 'consum', 0.0235, 'lps'),
	(679580, 134, '2015-02-01 01:11:18.000000', 'consum', 0.0260, 'lps'),
	(679581, 134, '2015-02-01 01:11:19.000000', 'consum', 0.0283, 'lps'),
	(679582, 134, '2015-02-01 01:11:20.000000', 'consum', 0.0218, 'lps'),
	(679583, 134, '2015-02-01 01:11:21.000000', 'consum', 0.0239, 'lps'),
	(679584, 134, '2015-02-01 01:11:22.000000', 'consum', 0.0226, 'lps'),
	(679585, 134, '2015-02-01 01:11:23.000000', 'consum', 0.0309, 'lps'),
	(679586, 134, '2015-02-01 01:11:24.000000', 'consum', 0.0244, 'lps'),
	(679587, 134, '2015-02-01 01:11:25.000000', 'consum', 0.0288, 'lps'),
	(679588, 134, '2015-02-01 01:11:26.000000', 'consum', 0.0296, 'lps'),
	(679589, 134, '2015-02-01 01:11:27.000000', 'consum', 0.0302, 'lps'),
	(679590, 134, '2015-02-01 01:11:28.000000', 'consum', 0.0309, 'lps'),
	(679591, 134, '2015-02-01 01:11:29.000000', 'consum', 0.0224, 'lps'),
	(679592, 134, '2015-02-01 01:11:30.000000', 'consum', 0.0291, 'lps'),
	(679593, 134, '2015-02-01 01:11:31.000000', 'consum', 0.0265, 'lps'),
	(679594, 134, '2015-02-01 01:11:32.000000', 'consum', 0.0244, 'lps'),
	(679595, 134, '2015-02-01 01:11:33.000000', 'consum', 0.0215, 'lps'),
	(679596, 134, '2015-02-01 01:11:34.000000', 'consum', 0.0235, 'lps'),
	(679597, 134, '2015-02-01 01:11:35.000000', 'consum', 0.0217, 'lps'),
	(679598, 134, '2015-02-01 01:11:36.000000', 'consum', 0.0274, 'lps'),
	(679599, 134, '2015-02-01 01:11:37.000000', 'consum', 0.0304, 'lps'),
	(679600, 134, '2015-02-01 01:11:38.000000', 'consum', 0.0284, 'lps'),
	(679601, 134, '2015-02-01 01:11:39.000000', 'consum', 0.0297, 'lps'),
	(679602, 134, '2015-02-01 01:11:40.000000', 'consum', 0.0219, 'lps'),
	(679603, 134, '2015-02-01 01:11:41.000000', 'consum', 0.0303, 'lps'),
	(679604, 134, '2015-02-01 01:11:42.000000', 'consum', 0.0236, 'lps'),
	(679605, 134, '2015-02-01 01:11:43.000000', 'consum', 0.0267, 'lps'),
	(679606, 134, '2015-02-01 01:11:44.000000', 'consum', 0.0214, 'lps'),
	(679607, 134, '2015-02-01 01:11:45.000000', 'consum', 0.0264, 'lps'),
	(679608, 134, '2015-02-01 01:11:46.000000', 'consum', 0.0264, 'lps'),
	(679609, 134, '2015-02-01 01:11:47.000000', 'consum', 0.0215, 'lps'),
	(679610, 134, '2015-02-01 01:11:48.000000', 'consum', 0.0280, 'lps'),
	(679611, 134, '2015-02-01 01:11:49.000000', 'consum', 0.0238, 'lps'),
	(679612, 134, '2015-02-01 01:11:50.000000', 'consum', 0.0241, 'lps'),
	(679613, 134, '2015-02-01 01:11:51.000000', 'consum', 0.0282, 'lps'),
	(679614, 134, '2015-02-01 01:11:52.000000', 'consum', 0.0272, 'lps'),
	(679615, 134, '2015-02-01 01:11:53.000000', 'consum', 0.0302, 'lps'),
	(679616, 134, '2015-02-01 01:11:54.000000', 'consum', 0.0281, 'lps'),
	(679617, 134, '2015-02-01 01:11:55.000000', 'consum', 0.0288, 'lps'),
	(679618, 134, '2015-02-01 01:11:56.000000', 'consum', 0.0285, 'lps'),
	(679619, 134, '2015-02-01 01:11:57.000000', 'consum', 0.0248, 'lps'),
	(679620, 134, '2015-02-01 01:11:58.000000', 'consum', 0.0281, 'lps'),
	(679621, 134, '2015-02-01 01:11:59.000000', 'consum', 0.0242, 'lps'),
	(679622, 134, '2015-02-01 01:12:00.000000', 'consum', 0.0262, 'lps'),
	(679623, 134, '2015-02-01 01:12:01.000000', 'consum', 0.0273, 'lps'),
	(679624, 134, '2015-02-01 01:12:02.000000', 'consum', 0.0265, 'lps'),
	(679625, 134, '2015-02-01 01:12:03.000000', 'consum', 0.0295, 'lps'),
	(679626, 134, '2015-02-01 01:12:04.000000', 'consum', 0.0265, 'lps'),
	(679627, 134, '2015-02-01 01:12:05.000000', 'consum', 0.0232, 'lps'),
	(679628, 134, '2015-02-01 01:12:06.000000', 'consum', 0.0256, 'lps'),
	(679629, 134, '2015-02-01 01:12:07.000000', 'consum', 0.0272, 'lps'),
	(679630, 134, '2015-02-01 01:12:08.000000', 'consum', 0.0282, 'lps'),
	(679631, 134, '2015-02-01 01:12:09.000000', 'consum', 0.0279, 'lps'),
	(679632, 134, '2015-02-01 01:12:10.000000', 'consum', 0.0236, 'lps'),
	(679633, 134, '2015-02-01 01:12:11.000000', 'consum', 0.0239, 'lps'),
	(679634, 134, '2015-02-01 01:12:12.000000', 'consum', 0.0275, 'lps'),
	(679635, 134, '2015-02-01 01:12:13.000000', 'consum', 0.0245, 'lps'),
	(679636, 134, '2015-02-01 01:12:14.000000', 'consum', 0.0294, 'lps'),
	(679637, 134, '2015-02-01 01:12:15.000000', 'consum', 0.0214, 'lps'),
	(679638, 134, '2015-02-01 01:12:16.000000', 'consum', 0.0290, 'lps'),
	(679639, 134, '2015-02-01 01:12:17.000000', 'consum', 0.0290, 'lps'),
	(679640, 134, '2015-02-01 01:12:18.000000', 'consum', 0.0268, 'lps'),
	(679641, 134, '2015-02-01 01:12:19.000000', 'consum', 0.0259, 'lps'),
	(679642, 134, '2015-02-01 01:12:20.000000', 'consum', 0.0284, 'lps'),
	(679643, 134, '2015-02-01 01:12:21.000000', 'consum', 0.0224, 'lps'),
	(679644, 134, '2015-02-01 01:12:22.000000', 'consum', 0.0265, 'lps'),
	(679645, 134, '2015-02-01 01:12:23.000000', 'consum', 0.0238, 'lps'),
	(679646, 134, '2015-02-01 01:12:24.000000', 'consum', 0.0289, 'lps'),
	(679647, 134, '2015-02-01 01:12:25.000000', 'consum', 0.0214, 'lps'),
	(679648, 134, '2015-02-01 01:12:26.000000', 'consum', 0.0301, 'lps'),
	(679649, 134, '2015-02-01 01:12:27.000000', 'consum', 0.0242, 'lps'),
	(679650, 134, '2015-02-01 01:12:28.000000', 'consum', 0.0302, 'lps'),
	(679651, 134, '2015-02-01 01:12:29.000000', 'consum', 0.0267, 'lps'),
	(679652, 134, '2015-02-01 01:12:30.000000', 'consum', 0.0221, 'lps'),
	(679653, 134, '2015-02-01 01:12:31.000000', 'consum', 0.0298, 'lps'),
	(679654, 134, '2015-02-01 01:12:32.000000', 'consum', 0.0310, 'lps'),
	(679655, 134, '2015-02-01 01:12:33.000000', 'consum', 0.0238, 'lps'),
	(679656, 134, '2015-02-01 01:12:34.000000', 'consum', 0.0259, 'lps'),
	(679657, 134, '2015-02-01 01:12:35.000000', 'consum', 0.0268, 'lps'),
	(679658, 134, '2015-02-01 01:12:36.000000', 'consum', 0.0250, 'lps'),
	(679659, 134, '2015-02-01 01:12:37.000000', 'consum', 0.0236, 'lps'),
	(679660, 134, '2015-02-01 01:12:38.000000', 'consum', 0.0222, 'lps'),
	(679661, 134, '2015-02-01 01:12:39.000000', 'consum', 0.0295, 'lps'),
	(679662, 134, '2015-02-01 01:12:40.000000', 'consum', 0.0289, 'lps'),
	(679663, 134, '2015-02-01 01:12:41.000000', 'consum', 0.0247, 'lps'),
	(679664, 134, '2015-02-01 01:12:42.000000', 'consum', 0.0263, 'lps'),
	(679665, 134, '2015-02-01 01:12:43.000000', 'consum', 0.0260, 'lps'),
	(679666, 134, '2015-02-01 01:12:44.000000', 'consum', 0.0303, 'lps'),
	(679667, 134, '2015-02-01 01:12:45.000000', 'consum', 0.0215, 'lps'),
	(679668, 134, '2015-02-01 01:12:46.000000', 'consum', 0.0267, 'lps'),
	(679669, 134, '2015-02-01 01:12:47.000000', 'consum', 0.0273, 'lps'),
	(679670, 134, '2015-02-01 01:12:48.000000', 'consum', 0.0254, 'lps'),
	(679671, 134, '2015-02-01 01:12:49.000000', 'consum', 0.0242, 'lps'),
	(679672, 134, '2015-02-01 01:12:50.000000', 'consum', 0.0235, 'lps'),
	(679673, 134, '2015-02-01 01:12:51.000000', 'consum', 0.0242, 'lps'),
	(679674, 134, '2015-02-01 01:12:52.000000', 'consum', 0.0295, 'lps'),
	(679675, 134, '2015-02-01 01:12:53.000000', 'consum', 0.0232, 'lps'),
	(679676, 134, '2015-02-01 01:12:54.000000', 'consum', 0.0268, 'lps'),
	(679677, 134, '2015-02-01 01:12:55.000000', 'consum', 0.0232, 'lps'),
	(679678, 134, '2015-02-01 01:12:56.000000', 'consum', 0.0249, 'lps'),
	(679679, 134, '2015-02-01 01:12:57.000000', 'consum', 0.0234, 'lps'),
	(679680, 134, '2015-02-01 01:12:58.000000', 'consum', 0.0216, 'lps'),
	(679681, 134, '2015-02-01 01:12:59.000000', 'consum', 0.0272, 'lps'),
	(679682, 134, '2015-02-01 01:13:00.000000', 'consum', 0.0297, 'lps'),
	(679683, 134, '2015-02-01 01:13:01.000000', 'consum', 0.0252, 'lps'),
	(679684, 134, '2015-02-01 01:13:02.000000', 'consum', 0.0264, 'lps'),
	(679685, 134, '2015-02-01 01:13:03.000000', 'consum', 0.0251, 'lps'),
	(679686, 134, '2015-02-01 01:13:04.000000', 'consum', 0.0255, 'lps'),
	(679687, 134, '2015-02-01 01:13:05.000000', 'consum', 0.0309, 'lps'),
	(679688, 134, '2015-02-01 01:13:06.000000', 'consum', 0.0264, 'lps'),
	(679689, 134, '2015-02-01 01:13:07.000000', 'consum', 0.0285, 'lps'),
	(679690, 134, '2015-02-01 01:13:08.000000', 'consum', 0.0220, 'lps'),
	(679691, 134, '2015-02-01 01:13:09.000000', 'consum', 0.0240, 'lps'),
	(679692, 134, '2015-02-01 01:13:10.000000', 'consum', 0.0227, 'lps'),
	(679693, 134, '2015-02-01 01:13:11.000000', 'consum', 0.0308, 'lps'),
	(679694, 134, '2015-02-01 01:13:12.000000', 'consum', 0.0237, 'lps'),
	(679695, 134, '2015-02-01 01:13:13.000000', 'consum', 0.0259, 'lps'),
	(679696, 134, '2015-02-01 01:13:14.000000', 'consum', 0.0270, 'lps'),
	(679697, 134, '2015-02-01 01:13:15.000000', 'consum', 0.0260, 'lps'),
	(679698, 134, '2015-02-01 01:13:16.000000', 'consum', 0.0280, 'lps'),
	(679699, 134, '2015-02-01 01:13:17.000000', 'consum', 0.0309, 'lps'),
	(679700, 134, '2015-02-01 01:13:18.000000', 'consum', 0.0288, 'lps'),
	(679701, 134, '2015-02-01 01:13:19.000000', 'consum', 0.0304, 'lps'),
	(679702, 134, '2015-02-01 01:13:20.000000', 'consum', 0.0240, 'lps'),
	(679703, 134, '2015-02-01 01:13:21.000000', 'consum', 0.0286, 'lps'),
	(679704, 134, '2015-02-01 01:13:22.000000', 'consum', 0.0293, 'lps'),
	(679705, 134, '2015-02-01 01:13:23.000000', 'consum', 0.0297, 'lps'),
	(679706, 134, '2015-02-01 01:13:24.000000', 'consum', 0.0290, 'lps'),
	(679707, 134, '2015-02-01 01:13:25.000000', 'consum', 0.0250, 'lps'),
	(679708, 134, '2015-02-01 01:13:26.000000', 'consum', 0.0271, 'lps'),
	(679709, 134, '2015-02-01 01:13:27.000000', 'consum', 0.0294, 'lps'),
	(679710, 134, '2015-02-01 01:13:28.000000', 'consum', 0.0241, 'lps'),
	(679711, 134, '2015-02-01 01:13:29.000000', 'consum', 0.0216, 'lps'),
	(679712, 134, '2015-02-01 01:13:30.000000', 'consum', 0.0253, 'lps'),
	(679713, 134, '2015-02-01 01:13:31.000000', 'consum', 0.0303, 'lps'),
	(679714, 134, '2015-02-01 01:13:32.000000', 'consum', 0.0237, 'lps'),
	(679715, 134, '2015-02-01 01:13:33.000000', 'consum', 0.0271, 'lps'),
	(679716, 134, '2015-02-01 01:13:34.000000', 'consum', 0.0229, 'lps'),
	(679717, 134, '2015-02-01 01:13:35.000000', 'consum', 0.0225, 'lps'),
	(679718, 134, '2015-02-01 01:13:36.000000', 'consum', 0.0228, 'lps'),
	(679719, 134, '2015-02-01 01:13:37.000000', 'consum', 0.0257, 'lps'),
	(679720, 134, '2015-02-01 01:13:38.000000', 'consum', 0.0289, 'lps'),
	(679721, 134, '2015-02-01 01:13:39.000000', 'consum', 0.0258, 'lps'),
	(679722, 134, '2015-02-01 01:13:40.000000', 'consum', 0.0212, 'lps'),
	(679723, 134, '2015-02-01 01:13:41.000000', 'consum', 0.0284, 'lps'),
	(679724, 134, '2015-02-01 01:13:42.000000', 'consum', 0.0264, 'lps'),
	(679725, 134, '2015-02-01 01:13:43.000000', 'consum', 0.0259, 'lps'),
	(679726, 134, '2015-02-01 01:13:44.000000', 'consum', 0.0294, 'lps'),
	(679727, 134, '2015-02-01 01:13:45.000000', 'consum', 0.0276, 'lps'),
	(679728, 134, '2015-02-01 01:13:46.000000', 'consum', 0.0289, 'lps'),
	(679729, 134, '2015-02-01 01:13:47.000000', 'consum', 0.0304, 'lps'),
	(679730, 134, '2015-02-01 01:13:48.000000', 'consum', 0.0236, 'lps'),
	(679731, 134, '2015-02-01 01:13:49.000000', 'consum', 0.0267, 'lps'),
	(679732, 134, '2015-02-01 01:13:50.000000', 'consum', 0.0212, 'lps'),
	(679733, 134, '2015-02-01 01:13:51.000000', 'consum', 0.0254, 'lps'),
	(679734, 134, '2015-02-01 01:13:52.000000', 'consum', 0.0218, 'lps'),
	(679735, 134, '2015-02-01 01:13:53.000000', 'consum', 0.0221, 'lps'),
	(679736, 134, '2015-02-01 01:13:54.000000', 'consum', 0.0243, 'lps'),
	(679737, 134, '2015-02-01 01:13:55.000000', 'consum', 0.0239, 'lps'),
	(679738, 134, '2015-02-01 01:13:56.000000', 'consum', 0.0256, 'lps'),
	(679739, 134, '2015-02-01 01:13:57.000000', 'consum', 0.0250, 'lps'),
	(679740, 134, '2015-02-01 01:13:58.000000', 'consum', 0.0273, 'lps'),
	(679741, 134, '2015-02-01 01:13:59.000000', 'consum', 0.0301, 'lps'),
	(679742, 134, '2015-02-01 01:14:00.000000', 'consum', 0.0273, 'lps'),
	(679743, 134, '2015-02-01 01:14:01.000000', 'consum', 0.0251, 'lps'),
	(679744, 134, '2015-02-01 01:14:02.000000', 'consum', 0.0228, 'lps'),
	(679745, 134, '2015-02-01 01:14:03.000000', 'consum', 0.0278, 'lps'),
	(679746, 134, '2015-02-01 01:14:04.000000', 'consum', 0.0293, 'lps'),
	(679747, 134, '2015-02-01 01:14:05.000000', 'consum', 0.0214, 'lps'),
	(679748, 134, '2015-02-01 01:14:06.000000', 'consum', 0.0289, 'lps'),
	(679749, 134, '2015-02-01 01:14:07.000000', 'consum', 0.0285, 'lps'),
	(679750, 134, '2015-02-01 01:14:08.000000', 'consum', 0.0247, 'lps'),
	(679751, 134, '2015-02-01 01:14:09.000000', 'consum', 0.0274, 'lps'),
	(679752, 134, '2015-02-01 01:14:10.000000', 'consum', 0.0215, 'lps'),
	(679753, 134, '2015-02-01 01:14:11.000000', 'consum', 0.0247, 'lps'),
	(679754, 134, '2015-02-01 01:14:12.000000', 'consum', 0.0278, 'lps'),
	(679755, 134, '2015-02-01 01:14:13.000000', 'consum', 0.0232, 'lps'),
	(679756, 134, '2015-02-01 01:14:14.000000', 'consum', 0.0219, 'lps'),
	(679757, 134, '2015-02-01 01:14:15.000000', 'consum', 0.0294, 'lps'),
	(679758, 134, '2015-02-01 01:14:16.000000', 'consum', 0.0295, 'lps'),
	(679759, 134, '2015-02-01 01:14:17.000000', 'consum', 0.0282, 'lps'),
	(679760, 134, '2015-02-01 01:14:18.000000', 'consum', 0.0211, 'lps'),
	(679761, 134, '2015-02-01 01:14:19.000000', 'consum', 0.0309, 'lps'),
	(679762, 134, '2015-02-01 01:14:20.000000', 'consum', 0.0288, 'lps'),
	(679763, 134, '2015-02-01 01:14:21.000000', 'consum', 0.0307, 'lps'),
	(679764, 134, '2015-02-01 01:14:22.000000', 'consum', 0.0253, 'lps'),
	(679765, 134, '2015-02-01 01:14:23.000000', 'consum', 0.0239, 'lps'),
	(679766, 134, '2015-02-01 01:14:24.000000', 'consum', 0.0228, 'lps'),
	(679767, 134, '2015-02-01 01:14:25.000000', 'consum', 0.0212, 'lps'),
	(679768, 134, '2015-02-01 01:14:26.000000', 'consum', 0.0268, 'lps'),
	(679769, 134, '2015-02-01 01:14:27.000000', 'consum', 0.0291, 'lps'),
	(679770, 134, '2015-02-01 01:14:28.000000', 'consum', 0.0233, 'lps'),
	(679771, 134, '2015-02-01 01:14:29.000000', 'consum', 0.0290, 'lps'),
	(679772, 134, '2015-02-01 01:14:30.000000', 'consum', 0.0234, 'lps'),
	(679773, 134, '2015-02-01 01:14:31.000000', 'consum', 0.0296, 'lps'),
	(679774, 134, '2015-02-01 01:14:32.000000', 'consum', 0.0257, 'lps'),
	(679775, 134, '2015-02-01 01:14:33.000000', 'consum', 0.0294, 'lps'),
	(679776, 134, '2015-02-01 01:14:34.000000', 'consum', 0.0281, 'lps'),
	(679777, 134, '2015-02-01 01:14:35.000000', 'consum', 0.0211, 'lps'),
	(679778, 134, '2015-02-01 01:14:36.000000', 'consum', 0.0211, 'lps'),
	(679779, 134, '2015-02-01 01:14:37.000000', 'consum', 0.0312, 'lps'),
	(679780, 134, '2015-02-01 01:14:38.000000', 'consum', 0.0306, 'lps'),
	(679781, 134, '2015-02-01 01:14:39.000000', 'consum', 0.0282, 'lps'),
	(679782, 134, '2015-02-01 01:14:40.000000', 'consum', 0.0283, 'lps'),
	(679783, 134, '2015-02-01 01:14:41.000000', 'consum', 0.0256, 'lps'),
	(679784, 134, '2015-02-01 01:14:42.000000', 'consum', 0.0221, 'lps'),
	(679785, 134, '2015-02-01 01:14:43.000000', 'consum', 0.0232, 'lps'),
	(679786, 134, '2015-02-01 01:14:44.000000', 'consum', 0.0286, 'lps'),
	(679787, 134, '2015-02-01 01:14:45.000000', 'consum', 0.0216, 'lps'),
	(679788, 134, '2015-02-01 01:14:46.000000', 'consum', 0.0219, 'lps'),
	(679789, 134, '2015-02-01 01:14:47.000000', 'consum', 0.0237, 'lps'),
	(679790, 134, '2015-02-01 01:14:48.000000', 'consum', 0.0215, 'lps'),
	(679791, 134, '2015-02-01 01:14:49.000000', 'consum', 0.0259, 'lps'),
	(679792, 134, '2015-02-01 01:14:50.000000', 'consum', 0.0235, 'lps'),
	(679793, 134, '2015-02-01 01:14:51.000000', 'consum', 0.0293, 'lps'),
	(679794, 134, '2015-02-01 01:14:52.000000', 'consum', 0.0238, 'lps'),
	(679795, 134, '2015-02-01 01:14:53.000000', 'consum', 0.0308, 'lps'),
	(679796, 134, '2015-02-01 01:14:54.000000', 'consum', 0.0310, 'lps'),
	(679797, 134, '2015-02-01 01:14:55.000000', 'consum', 0.0312, 'lps'),
	(679798, 134, '2015-02-01 01:14:56.000000', 'consum', 0.0216, 'lps'),
	(679799, 134, '2015-02-01 01:14:57.000000', 'consum', 0.0242, 'lps'),
	(679800, 134, '2015-02-01 01:14:58.000000', 'consum', 0.0250, 'lps'),
	(679801, 134, '2015-02-01 01:14:59.000000', 'consum', 0.0210, 'lps'),
	(679802, 134, '2015-02-01 01:15:00.000000', 'consum', 0.0297, 'lps'),
	(679803, 134, '2015-02-01 01:15:01.000000', 'consum', 0.0234, 'lps'),
	(679804, 134, '2015-02-01 01:15:02.000000', 'consum', 0.0277, 'lps'),
	(679805, 134, '2015-02-01 01:15:03.000000', 'consum', 0.0266, 'lps'),
	(679806, 134, '2015-02-01 01:15:04.000000', 'consum', 0.0289, 'lps'),
	(679807, 134, '2015-02-01 01:15:05.000000', 'consum', 0.0232, 'lps'),
	(679808, 134, '2015-02-01 01:15:06.000000', 'consum', 0.0290, 'lps'),
	(679809, 134, '2015-02-01 01:15:07.000000', 'consum', 0.0234, 'lps'),
	(679810, 134, '2015-02-01 01:15:08.000000', 'consum', 0.0298, 'lps'),
	(679811, 134, '2015-02-01 01:15:09.000000', 'consum', 0.0270, 'lps'),
	(679812, 134, '2015-02-01 01:15:10.000000', 'consum', 0.0248, 'lps'),
	(679813, 134, '2015-02-01 01:15:11.000000', 'consum', 0.0218, 'lps'),
	(679814, 134, '2015-02-01 01:15:12.000000', 'consum', 0.0242, 'lps'),
	(679815, 134, '2015-02-01 01:15:13.000000', 'consum', 0.0240, 'lps'),
	(679816, 134, '2015-02-01 01:15:14.000000', 'consum', 0.0268, 'lps'),
	(679817, 134, '2015-02-01 01:15:15.000000', 'consum', 0.0307, 'lps'),
	(679818, 134, '2015-02-01 01:15:16.000000', 'consum', 0.0211, 'lps'),
	(679819, 134, '2015-02-01 01:15:17.000000', 'consum', 0.0236, 'lps'),
	(679820, 134, '2015-02-01 01:15:18.000000', 'consum', 0.0234, 'lps'),
	(679821, 134, '2015-02-01 01:15:19.000000', 'consum', 0.0250, 'lps'),
	(679822, 134, '2015-02-01 01:15:20.000000', 'consum', 0.0238, 'lps'),
	(679823, 134, '2015-02-01 01:15:21.000000', 'consum', 0.0231, 'lps'),
	(679824, 134, '2015-02-01 01:15:22.000000', 'consum', 0.0231, 'lps'),
	(679825, 134, '2015-02-01 01:15:23.000000', 'consum', 0.0250, 'lps'),
	(679826, 134, '2015-02-01 01:15:24.000000', 'consum', 0.0248, 'lps'),
	(679827, 134, '2015-02-01 01:15:25.000000', 'consum', 0.0279, 'lps'),
	(679828, 134, '2015-02-01 01:15:26.000000', 'consum', 0.0236, 'lps'),
	(679829, 134, '2015-02-01 01:15:27.000000', 'consum', 0.0237, 'lps'),
	(679830, 134, '2015-02-01 01:15:28.000000', 'consum', 0.0268, 'lps'),
	(679831, 134, '2015-02-01 01:15:29.000000', 'consum', 0.0214, 'lps'),
	(679832, 134, '2015-02-01 01:15:30.000000', 'consum', 0.0261, 'lps'),
	(679833, 134, '2015-02-01 01:15:31.000000', 'consum', 0.0247, 'lps'),
	(679834, 134, '2015-02-01 01:15:32.000000', 'consum', 0.0243, 'lps'),
	(679835, 134, '2015-02-01 01:15:33.000000', 'consum', 0.0266, 'lps'),
	(679836, 134, '2015-02-01 01:15:34.000000', 'consum', 0.0287, 'lps'),
	(679837, 134, '2015-02-01 01:15:35.000000', 'consum', 0.0222, 'lps'),
	(679838, 134, '2015-02-01 01:15:36.000000', 'consum', 0.0244, 'lps'),
	(679839, 134, '2015-02-01 01:15:37.000000', 'consum', 0.0240, 'lps'),
	(679840, 134, '2015-02-01 01:15:38.000000', 'consum', 0.0262, 'lps'),
	(679841, 134, '2015-02-01 01:15:39.000000', 'consum', 0.0275, 'lps'),
	(679842, 134, '2015-02-01 01:15:40.000000', 'consum', 0.0277, 'lps'),
	(679843, 134, '2015-02-01 01:15:41.000000', 'consum', 0.0248, 'lps'),
	(679844, 134, '2015-02-01 01:15:42.000000', 'consum', 0.0301, 'lps'),
	(679845, 134, '2015-02-01 01:15:43.000000', 'consum', 0.0244, 'lps'),
	(679846, 134, '2015-02-01 01:15:44.000000', 'consum', 0.0311, 'lps'),
	(679847, 134, '2015-02-01 01:15:45.000000', 'consum', 0.0308, 'lps'),
	(679848, 134, '2015-02-01 01:15:46.000000', 'consum', 0.0291, 'lps'),
	(679849, 134, '2015-02-01 01:15:47.000000', 'consum', 0.0222, 'lps'),
	(679850, 134, '2015-02-01 01:15:48.000000', 'consum', 0.0231, 'lps'),
	(679851, 134, '2015-02-01 01:15:49.000000', 'consum', 0.0279, 'lps'),
	(679852, 134, '2015-02-01 01:15:50.000000', 'consum', 0.0289, 'lps'),
	(679853, 134, '2015-02-01 01:15:51.000000', 'consum', 0.0294, 'lps'),
	(679854, 134, '2015-02-01 01:15:52.000000', 'consum', 0.0290, 'lps'),
	(679855, 134, '2015-02-01 01:15:53.000000', 'consum', 0.0256, 'lps'),
	(679856, 134, '2015-02-01 01:15:54.000000', 'consum', 0.0302, 'lps'),
	(679857, 134, '2015-02-01 01:15:55.000000', 'consum', 0.0225, 'lps'),
	(679858, 134, '2015-02-01 01:15:56.000000', 'consum', 0.0215, 'lps'),
	(679859, 134, '2015-02-01 01:15:57.000000', 'consum', 0.0294, 'lps'),
	(679860, 134, '2015-02-01 01:15:58.000000', 'consum', 0.0306, 'lps'),
	(679861, 134, '2015-02-01 01:15:59.000000', 'consum', 0.0234, 'lps'),
	(679862, 134, '2015-02-01 01:16:00.000000', 'consum', 0.0246, 'lps'),
	(679863, 134, '2015-02-01 01:16:01.000000', 'consum', 0.0215, 'lps'),
	(679864, 134, '2015-02-01 01:16:02.000000', 'consum', 0.0230, 'lps'),
	(679865, 134, '2015-02-01 01:16:03.000000', 'consum', 0.0295, 'lps'),
	(679866, 134, '2015-02-01 01:16:04.000000', 'consum', 0.0266, 'lps'),
	(679867, 134, '2015-02-01 01:16:05.000000', 'consum', 0.0237, 'lps'),
	(679868, 134, '2015-02-01 01:16:06.000000', 'consum', 0.0281, 'lps'),
	(679869, 134, '2015-02-01 01:16:07.000000', 'consum', 0.0276, 'lps'),
	(679870, 134, '2015-02-01 01:16:08.000000', 'consum', 0.0226, 'lps'),
	(679871, 134, '2015-02-01 01:16:09.000000', 'consum', 0.0296, 'lps'),
	(679872, 134, '2015-02-01 01:16:10.000000', 'consum', 0.0287, 'lps'),
	(679873, 134, '2015-02-01 01:16:11.000000', 'consum', 0.0232, 'lps'),
	(679874, 134, '2015-02-01 01:16:12.000000', 'consum', 0.0296, 'lps'),
	(679875, 134, '2015-02-01 01:16:13.000000', 'consum', 0.0267, 'lps'),
	(679876, 134, '2015-02-01 01:16:14.000000', 'consum', 0.0236, 'lps'),
	(679877, 134, '2015-02-01 01:16:15.000000', 'consum', 0.0274, 'lps'),
	(679878, 135, '2015-02-01 00:00:00.000000', 'consum', 0.0235, 'lps'),
	(679879, 135, '2015-02-01 00:00:01.000000', 'consum', 0.0243, 'lps'),
	(679880, 135, '2015-02-01 00:00:02.000000', 'consum', 0.0249, 'lps'),
	(679881, 135, '2015-02-01 00:00:03.000000', 'consum', 0.0255, 'lps'),
	(679882, 135, '2015-02-01 00:00:04.000000', 'consum', 0.0212, 'lps'),
	(679883, 135, '2015-02-01 00:00:05.000000', 'consum', 0.0246, 'lps'),
	(679884, 135, '2015-02-01 00:00:06.000000', 'consum', 0.0223, 'lps'),
	(679885, 135, '2015-02-01 00:00:07.000000', 'consum', 0.0221, 'lps'),
	(679886, 135, '2015-02-01 00:00:08.000000', 'consum', 0.0227, 'lps'),
	(679887, 135, '2015-02-01 00:00:09.000000', 'consum', 0.0261, 'lps'),
	(679888, 135, '2015-02-01 00:00:10.000000', 'consum', 0.0255, 'lps'),
	(679889, 135, '2015-02-01 00:00:11.000000', 'consum', 0.0232, 'lps'),
	(679890, 135, '2015-02-01 00:00:12.000000', 'consum', 0.0239, 'lps'),
	(679891, 135, '2015-02-01 00:00:13.000000', 'consum', 0.0236, 'lps'),
	(679892, 135, '2015-02-01 00:00:14.000000', 'consum', 0.0254, 'lps'),
	(679893, 135, '2015-02-01 00:00:15.000000', 'consum', 0.0246, 'lps'),
	(679894, 135, '2015-02-01 00:00:16.000000', 'consum', 0.0257, 'lps'),
	(679895, 135, '2015-02-01 00:00:17.000000', 'consum', 0.0231, 'lps'),
	(679896, 135, '2015-02-01 00:00:18.000000', 'consum', 0.0229, 'lps'),
	(679897, 135, '2015-02-01 00:00:19.000000', 'consum', 0.0241, 'lps'),
	(679898, 135, '2015-02-01 00:00:20.000000', 'consum', 0.0256, 'lps'),
	(679899, 135, '2015-02-01 00:00:21.000000', 'consum', 0.0240, 'lps'),
	(679900, 135, '2015-02-01 00:00:22.000000', 'consum', 0.0223, 'lps'),
	(679901, 135, '2015-02-01 00:00:23.000000', 'consum', 0.0239, 'lps'),
	(679902, 135, '2015-02-01 00:00:24.000000', 'consum', 0.0212, 'lps'),
	(679903, 135, '2015-02-01 00:00:25.000000', 'consum', 0.0239, 'lps'),
	(679904, 135, '2015-02-01 00:00:26.000000', 'consum', 0.0243, 'lps'),
	(679905, 135, '2015-02-01 00:00:27.000000', 'consum', 0.0235, 'lps'),
	(679906, 135, '2015-02-01 00:00:28.000000', 'consum', 0.0238, 'lps'),
	(679907, 135, '2015-02-01 00:00:29.000000', 'consum', 0.0220, 'lps'),
	(679908, 135, '2015-02-01 00:00:30.000000', 'consum', 0.0229, 'lps'),
	(679909, 135, '2015-02-01 00:00:31.000000', 'consum', 0.0225, 'lps'),
	(679910, 135, '2015-02-01 00:00:32.000000', 'consum', 0.0227, 'lps'),
	(679911, 135, '2015-02-01 00:00:33.000000', 'consum', 0.0249, 'lps'),
	(679912, 135, '2015-02-01 00:00:34.000000', 'consum', 0.0251, 'lps'),
	(679913, 135, '2015-02-01 00:00:35.000000', 'consum', 0.0246, 'lps'),
	(679914, 135, '2015-02-01 00:00:36.000000', 'consum', 0.0213, 'lps'),
	(679915, 135, '2015-02-01 00:00:37.000000', 'consum', 0.0222, 'lps'),
	(679916, 135, '2015-02-01 00:00:38.000000', 'consum', 0.0212, 'lps'),
	(679917, 135, '2015-02-01 00:00:39.000000', 'consum', 0.0235, 'lps'),
	(679918, 135, '2015-02-01 00:00:40.000000', 'consum', 0.0224, 'lps'),
	(679919, 135, '2015-02-01 00:00:41.000000', 'consum', 0.0258, 'lps'),
	(679920, 135, '2015-02-01 00:00:42.000000', 'consum', 0.0249, 'lps'),
	(679921, 135, '2015-02-01 00:00:43.000000', 'consum', 0.0261, 'lps'),
	(679922, 135, '2015-02-01 00:00:44.000000', 'consum', 0.0244, 'lps'),
	(679923, 135, '2015-02-01 00:00:45.000000', 'consum', 0.0227, 'lps'),
	(679924, 135, '2015-02-01 00:00:46.000000', 'consum', 0.0248, 'lps'),
	(679925, 135, '2015-02-01 00:00:47.000000', 'consum', 0.0243, 'lps'),
	(679926, 135, '2015-02-01 00:00:48.000000', 'consum', 0.0261, 'lps'),
	(679927, 135, '2015-02-01 00:00:49.000000', 'consum', 0.0262, 'lps'),
	(679928, 135, '2015-02-01 00:00:50.000000', 'consum', 0.0212, 'lps'),
	(679929, 135, '2015-02-01 00:00:51.000000', 'consum', 0.0220, 'lps'),
	(679930, 135, '2015-02-01 00:00:52.000000', 'consum', 0.0258, 'lps'),
	(679931, 135, '2015-02-01 00:00:53.000000', 'consum', 0.0259, 'lps'),
	(679932, 135, '2015-02-01 00:00:54.000000', 'consum', 0.0259, 'lps'),
	(679933, 135, '2015-02-01 00:00:55.000000', 'consum', 0.0254, 'lps'),
	(679934, 135, '2015-02-01 00:00:56.000000', 'consum', 0.0232, 'lps'),
	(679935, 135, '2015-02-01 00:00:57.000000', 'consum', 0.0242, 'lps'),
	(679936, 135, '2015-02-01 00:00:58.000000', 'consum', 0.0252, 'lps'),
	(679937, 135, '2015-02-01 00:00:59.000000', 'consum', 0.0216, 'lps'),
	(679938, 135, '2015-02-01 00:01:00.000000', 'consum', 0.0223, 'lps'),
	(679939, 135, '2015-02-01 00:01:01.000000', 'consum', 0.0256, 'lps'),
	(679940, 135, '2015-02-01 00:01:02.000000', 'consum', 0.0243, 'lps'),
	(679941, 135, '2015-02-01 00:01:03.000000', 'consum', 0.0238, 'lps'),
	(679942, 135, '2015-02-01 00:01:04.000000', 'consum', 0.0253, 'lps'),
	(679943, 135, '2015-02-01 00:01:05.000000', 'consum', 0.0232, 'lps'),
	(679944, 135, '2015-02-01 00:01:06.000000', 'consum', 0.0248, 'lps'),
	(679945, 135, '2015-02-01 00:01:07.000000', 'consum', 0.0226, 'lps'),
	(679946, 135, '2015-02-01 00:01:08.000000', 'consum', 0.0231, 'lps'),
	(679947, 135, '2015-02-01 00:01:09.000000', 'consum', 0.0216, 'lps'),
	(679948, 135, '2015-02-01 00:01:10.000000', 'consum', 0.0228, 'lps'),
	(679949, 135, '2015-02-01 00:01:11.000000', 'consum', 0.0230, 'lps'),
	(679950, 135, '2015-02-01 00:01:12.000000', 'consum', 0.0258, 'lps'),
	(679951, 135, '2015-02-01 00:01:13.000000', 'consum', 0.0229, 'lps'),
	(679952, 135, '2015-02-01 00:01:14.000000', 'consum', 0.0217, 'lps'),
	(679953, 135, '2015-02-01 00:01:15.000000', 'consum', 0.0239, 'lps'),
	(679954, 135, '2015-02-01 00:01:16.000000', 'consum', 0.0230, 'lps'),
	(679955, 135, '2015-02-01 00:01:17.000000', 'consum', 0.0224, 'lps'),
	(679956, 135, '2015-02-01 00:01:18.000000', 'consum', 0.0220, 'lps'),
	(679957, 135, '2015-02-01 00:01:19.000000', 'consum', 0.0216, 'lps'),
	(679958, 135, '2015-02-01 00:01:20.000000', 'consum', 0.0214, 'lps'),
	(679959, 135, '2015-02-01 00:01:21.000000', 'consum', 0.0212, 'lps'),
	(679960, 135, '2015-02-01 00:01:22.000000', 'consum', 0.0259, 'lps'),
	(679961, 135, '2015-02-01 00:01:23.000000', 'consum', 0.0240, 'lps'),
	(679962, 135, '2015-02-01 00:01:24.000000', 'consum', 0.0215, 'lps'),
	(679963, 135, '2015-02-01 00:01:25.000000', 'consum', 0.0249, 'lps'),
	(679964, 135, '2015-02-01 00:01:26.000000', 'consum', 0.0231, 'lps'),
	(679965, 135, '2015-02-01 00:01:27.000000', 'consum', 0.0250, 'lps'),
	(679966, 135, '2015-02-01 00:01:28.000000', 'consum', 0.0245, 'lps'),
	(679967, 135, '2015-02-01 00:01:29.000000', 'consum', 0.0212, 'lps'),
	(679968, 135, '2015-02-01 00:01:30.000000', 'consum', 0.0222, 'lps'),
	(679969, 135, '2015-02-01 00:01:31.000000', 'consum', 0.0210, 'lps'),
	(679970, 135, '2015-02-01 00:01:32.000000', 'consum', 0.0228, 'lps'),
	(679971, 135, '2015-02-01 00:01:33.000000', 'consum', 0.0248, 'lps'),
	(679972, 135, '2015-02-01 00:01:34.000000', 'consum', 0.0240, 'lps'),
	(679973, 135, '2015-02-01 00:01:35.000000', 'consum', 0.0248, 'lps'),
	(679974, 135, '2015-02-01 00:01:36.000000', 'consum', 0.0257, 'lps'),
	(679975, 135, '2015-02-01 00:01:37.000000', 'consum', 0.0226, 'lps'),
	(679976, 135, '2015-02-01 00:01:38.000000', 'consum', 0.0256, 'lps'),
	(679977, 135, '2015-02-01 00:01:39.000000', 'consum', 0.0234, 'lps'),
	(679978, 135, '2015-02-01 00:01:40.000000', 'consum', 0.0244, 'lps'),
	(679979, 135, '2015-02-01 00:01:41.000000', 'consum', 0.0255, 'lps'),
	(679980, 135, '2015-02-01 00:01:42.000000', 'consum', 0.0227, 'lps'),
	(679981, 135, '2015-02-01 00:01:43.000000', 'consum', 0.0215, 'lps'),
	(679982, 135, '2015-02-01 00:01:44.000000', 'consum', 0.0239, 'lps'),
	(679983, 135, '2015-02-01 00:01:45.000000', 'consum', 0.0234, 'lps'),
	(679984, 135, '2015-02-01 00:01:46.000000', 'consum', 0.0241, 'lps'),
	(679985, 135, '2015-02-01 00:01:47.000000', 'consum', 0.0241, 'lps'),
	(679986, 135, '2015-02-01 00:01:48.000000', 'consum', 0.0221, 'lps'),
	(679987, 135, '2015-02-01 00:01:49.000000', 'consum', 0.0226, 'lps'),
	(679988, 135, '2015-02-01 00:01:50.000000', 'consum', 0.0258, 'lps'),
	(679989, 135, '2015-02-01 00:01:51.000000', 'consum', 0.0241, 'lps'),
	(679990, 135, '2015-02-01 00:01:52.000000', 'consum', 0.0225, 'lps'),
	(679991, 135, '2015-02-01 00:01:53.000000', 'consum', 0.0242, 'lps'),
	(679992, 135, '2015-02-01 00:01:54.000000', 'consum', 0.0221, 'lps'),
	(679993, 135, '2015-02-01 00:01:55.000000', 'consum', 0.0220, 'lps'),
	(679994, 135, '2015-02-01 00:01:56.000000', 'consum', 0.0231, 'lps'),
	(679995, 135, '2015-02-01 00:01:57.000000', 'consum', 0.0232, 'lps'),
	(679996, 135, '2015-02-01 00:01:58.000000', 'consum', 0.0258, 'lps'),
	(679997, 135, '2015-02-01 00:01:59.000000', 'consum', 0.0225, 'lps'),
	(679998, 135, '2015-02-01 00:02:00.000000', 'consum', 0.0249, 'lps'),
	(679999, 135, '2015-02-01 00:02:01.000000', 'consum', 0.0255, 'lps'),
	(680000, 135, '2015-02-01 00:02:02.000000', 'consum', 0.0211, 'lps'),
	(680001, 135, '2015-02-01 00:02:03.000000', 'consum', 0.0240, 'lps'),
	(680002, 135, '2015-02-01 00:02:04.000000', 'consum', 0.0250, 'lps'),
	(680003, 135, '2015-02-01 00:02:05.000000', 'consum', 0.0214, 'lps'),
	(680004, 135, '2015-02-01 00:02:06.000000', 'consum', 0.0217, 'lps'),
	(680005, 135, '2015-02-01 00:02:07.000000', 'consum', 0.0235, 'lps'),
	(680006, 135, '2015-02-01 00:02:08.000000', 'consum', 0.0261, 'lps'),
	(680007, 135, '2015-02-01 00:02:09.000000', 'consum', 0.0231, 'lps'),
	(680008, 135, '2015-02-01 00:02:10.000000', 'consum', 0.0218, 'lps'),
	(680009, 135, '2015-02-01 00:02:11.000000', 'consum', 0.0237, 'lps'),
	(680010, 135, '2015-02-01 00:02:12.000000', 'consum', 0.0216, 'lps'),
	(680011, 135, '2015-02-01 00:02:13.000000', 'consum', 0.0215, 'lps'),
	(680012, 135, '2015-02-01 00:02:14.000000', 'consum', 0.0216, 'lps'),
	(680013, 135, '2015-02-01 00:02:15.000000', 'consum', 0.0226, 'lps'),
	(680014, 135, '2015-02-01 00:02:16.000000', 'consum', 0.0219, 'lps'),
	(680015, 135, '2015-02-01 00:02:17.000000', 'consum', 0.0210, 'lps'),
	(680016, 135, '2015-02-01 00:02:18.000000', 'consum', 0.0234, 'lps'),
	(680017, 135, '2015-02-01 00:02:19.000000', 'consum', 0.0223, 'lps'),
	(680018, 135, '2015-02-01 00:02:20.000000', 'consum', 0.0258, 'lps'),
	(680019, 135, '2015-02-01 00:02:21.000000', 'consum', 0.0254, 'lps'),
	(680020, 135, '2015-02-01 00:02:22.000000', 'consum', 0.0232, 'lps'),
	(680021, 135, '2015-02-01 00:02:23.000000', 'consum', 0.0241, 'lps'),
	(680022, 135, '2015-02-01 00:02:24.000000', 'consum', 0.0249, 'lps'),
	(680023, 135, '2015-02-01 00:02:25.000000', 'consum', 0.0256, 'lps'),
	(680024, 135, '2015-02-01 00:02:26.000000', 'consum', 0.0220, 'lps'),
	(680025, 135, '2015-02-01 00:02:27.000000', 'consum', 0.0227, 'lps'),
	(680026, 135, '2015-02-01 00:02:28.000000', 'consum', 0.0215, 'lps'),
	(680027, 135, '2015-02-01 00:02:29.000000', 'consum', 0.0237, 'lps'),
	(680028, 135, '2015-02-01 00:02:30.000000', 'consum', 0.0223, 'lps'),
	(680029, 135, '2015-02-01 00:02:31.000000', 'consum', 0.0247, 'lps'),
	(680030, 135, '2015-02-01 00:02:32.000000', 'consum', 0.0252, 'lps'),
	(680031, 135, '2015-02-01 00:02:33.000000', 'consum', 0.0256, 'lps'),
	(680032, 135, '2015-02-01 00:02:34.000000', 'consum', 0.0260, 'lps'),
	(680033, 135, '2015-02-01 00:02:35.000000', 'consum', 0.0217, 'lps'),
	(680034, 135, '2015-02-01 00:02:36.000000', 'consum', 0.0253, 'lps'),
	(680035, 135, '2015-02-01 00:02:37.000000', 'consum', 0.0248, 'lps'),
	(680036, 135, '2015-02-01 00:02:38.000000', 'consum', 0.0219, 'lps'),
	(680037, 135, '2015-02-01 00:02:39.000000', 'consum', 0.0247, 'lps'),
	(680038, 135, '2015-02-01 00:02:40.000000', 'consum', 0.0262, 'lps'),
	(680039, 135, '2015-02-01 00:02:41.000000', 'consum', 0.0252, 'lps'),
	(680040, 135, '2015-02-01 00:02:42.000000', 'consum', 0.0214, 'lps'),
	(680041, 135, '2015-02-01 00:02:43.000000', 'consum', 0.0261, 'lps'),
	(680042, 135, '2015-02-01 00:02:44.000000', 'consum', 0.0244, 'lps'),
	(680043, 135, '2015-02-01 00:02:45.000000', 'consum', 0.0228, 'lps'),
	(680044, 135, '2015-02-01 00:02:46.000000', 'consum', 0.0250, 'lps'),
	(680045, 135, '2015-02-01 00:02:47.000000', 'consum', 0.0250, 'lps'),
	(680046, 135, '2015-02-01 00:02:48.000000', 'consum', 0.0237, 'lps'),
	(680047, 135, '2015-02-01 00:02:49.000000', 'consum', 0.0228, 'lps'),
	(680048, 135, '2015-02-01 00:02:50.000000', 'consum', 0.0217, 'lps'),
	(680049, 135, '2015-02-01 00:02:51.000000', 'consum', 0.0243, 'lps'),
	(680050, 135, '2015-02-01 00:02:52.000000', 'consum', 0.0251, 'lps'),
	(680051, 135, '2015-02-01 00:02:53.000000', 'consum', 0.0212, 'lps'),
	(680052, 135, '2015-02-01 00:02:54.000000', 'consum', 0.0254, 'lps'),
	(680053, 135, '2015-02-01 00:02:55.000000', 'consum', 0.0213, 'lps'),
	(680054, 135, '2015-02-01 00:02:56.000000', 'consum', 0.0252, 'lps'),
	(680055, 135, '2015-02-01 00:02:57.000000', 'consum', 0.0254, 'lps'),
	(680056, 135, '2015-02-01 00:02:58.000000', 'consum', 0.0250, 'lps'),
	(680057, 135, '2015-02-01 00:02:59.000000', 'consum', 0.0225, 'lps'),
	(680058, 135, '2015-02-01 00:03:00.000000', 'consum', 0.0219, 'lps'),
	(680059, 135, '2015-02-01 00:03:01.000000', 'consum', 0.0212, 'lps'),
	(680060, 135, '2015-02-01 00:03:02.000000', 'consum', 0.0244, 'lps'),
	(680061, 135, '2015-02-01 00:03:03.000000', 'consum', 0.0215, 'lps'),
	(680062, 135, '2015-02-01 00:03:04.000000', 'consum', 0.0240, 'lps'),
	(680063, 135, '2015-02-01 00:03:05.000000', 'consum', 0.0241, 'lps'),
	(680064, 135, '2015-02-01 00:03:06.000000', 'consum', 0.0222, 'lps'),
	(680065, 135, '2015-02-01 00:03:07.000000', 'consum', 0.0229, 'lps'),
	(680066, 135, '2015-02-01 00:03:08.000000', 'consum', 0.0218, 'lps'),
	(680067, 135, '2015-02-01 00:03:09.000000', 'consum', 0.0246, 'lps'),
	(680068, 135, '2015-02-01 00:03:10.000000', 'consum', 0.0262, 'lps'),
	(680069, 135, '2015-02-01 00:03:11.000000', 'consum', 0.0256, 'lps'),
	(680070, 135, '2015-02-01 00:03:12.000000', 'consum', 0.0230, 'lps'),
	(680071, 135, '2015-02-01 00:03:13.000000', 'consum', 0.0227, 'lps'),
	(680072, 135, '2015-02-01 00:03:14.000000', 'consum', 0.0235, 'lps'),
	(680073, 135, '2015-02-01 00:03:15.000000', 'consum', 0.0232, 'lps'),
	(680074, 135, '2015-02-01 00:03:16.000000', 'consum', 0.0247, 'lps'),
	(680075, 135, '2015-02-01 00:03:17.000000', 'consum', 0.0220, 'lps'),
	(680076, 135, '2015-02-01 00:03:18.000000', 'consum', 0.0259, 'lps'),
	(680077, 135, '2015-02-01 00:03:19.000000', 'consum', 0.0212, 'lps'),
	(680078, 135, '2015-02-01 00:03:20.000000', 'consum', 0.0234, 'lps'),
	(680079, 135, '2015-02-01 00:03:21.000000', 'consum', 0.0218, 'lps'),
	(680080, 135, '2015-02-01 00:03:22.000000', 'consum', 0.0233, 'lps'),
	(680081, 135, '2015-02-01 00:03:23.000000', 'consum', 0.0246, 'lps'),
	(680082, 135, '2015-02-01 00:03:24.000000', 'consum', 0.0215, 'lps'),
	(680083, 135, '2015-02-01 00:03:25.000000', 'consum', 0.0235, 'lps'),
	(680084, 135, '2015-02-01 00:03:26.000000', 'consum', 0.0214, 'lps'),
	(680085, 135, '2015-02-01 00:03:27.000000', 'consum', 0.0210, 'lps'),
	(680086, 135, '2015-02-01 00:03:28.000000', 'consum', 0.0249, 'lps'),
	(680087, 135, '2015-02-01 00:03:29.000000', 'consum', 0.0246, 'lps'),
	(680088, 135, '2015-02-01 00:03:30.000000', 'consum', 0.0223, 'lps'),
	(680089, 135, '2015-02-01 00:03:31.000000', 'consum', 0.0219, 'lps'),
	(680090, 135, '2015-02-01 00:03:32.000000', 'consum', 0.0216, 'lps'),
	(680091, 135, '2015-02-01 00:03:33.000000', 'consum', 0.0213, 'lps'),
	(680092, 135, '2015-02-01 00:03:34.000000', 'consum', 0.0261, 'lps'),
	(680093, 135, '2015-02-01 00:03:35.000000', 'consum', 0.0246, 'lps'),
	(680094, 135, '2015-02-01 00:03:36.000000', 'consum', 0.0235, 'lps'),
	(680095, 135, '2015-02-01 00:03:37.000000', 'consum', 0.0227, 'lps'),
	(680096, 135, '2015-02-01 00:03:38.000000', 'consum', 0.0220, 'lps'),
	(680097, 135, '2015-02-01 00:03:39.000000', 'consum', 0.0212, 'lps'),
	(680098, 135, '2015-02-01 00:03:40.000000', 'consum', 0.0243, 'lps'),
	(680099, 135, '2015-02-01 00:03:41.000000', 'consum', 0.0212, 'lps'),
	(680100, 135, '2015-02-01 00:03:42.000000', 'consum', 0.0228, 'lps'),
	(680101, 135, '2015-02-01 00:03:43.000000', 'consum', 0.0239, 'lps'),
	(680102, 135, '2015-02-01 00:03:44.000000', 'consum', 0.0248, 'lps'),
	(680103, 135, '2015-02-01 00:03:45.000000', 'consum', 0.0262, 'lps'),
	(680104, 135, '2015-02-01 00:03:46.000000', 'consum', 0.0249, 'lps'),
	(680105, 135, '2015-02-01 00:03:47.000000', 'consum', 0.0250, 'lps'),
	(680106, 135, '2015-02-01 00:03:48.000000', 'consum', 0.0241, 'lps'),
	(680107, 135, '2015-02-01 00:03:49.000000', 'consum', 0.0243, 'lps'),
	(680108, 135, '2015-02-01 00:03:50.000000', 'consum', 0.0233, 'lps'),
	(680109, 135, '2015-02-01 00:03:51.000000', 'consum', 0.0225, 'lps'),
	(680110, 135, '2015-02-01 00:03:52.000000', 'consum', 0.0217, 'lps'),
	(680111, 135, '2015-02-01 00:03:53.000000', 'consum', 0.0253, 'lps'),
	(680112, 135, '2015-02-01 00:03:54.000000', 'consum', 0.0246, 'lps'),
	(680113, 135, '2015-02-01 00:03:55.000000', 'consum', 0.0259, 'lps'),
	(680114, 135, '2015-02-01 00:03:56.000000', 'consum', 0.0244, 'lps'),
	(680115, 135, '2015-02-01 00:03:57.000000', 'consum', 0.0232, 'lps'),
	(680116, 135, '2015-02-01 00:03:58.000000', 'consum', 0.0221, 'lps'),
	(680117, 135, '2015-02-01 00:03:59.000000', 'consum', 0.0250, 'lps'),
	(680118, 135, '2015-02-01 00:04:00.000000', 'consum', 0.0219, 'lps'),
	(680119, 135, '2015-02-01 00:04:01.000000', 'consum', 0.0242, 'lps'),
	(680120, 135, '2015-02-01 00:04:02.000000', 'consum', 0.0236, 'lps'),
	(680121, 135, '2015-02-01 00:04:03.000000', 'consum', 0.0246, 'lps'),
	(680122, 135, '2015-02-01 00:04:04.000000', 'consum', 0.0260, 'lps'),
	(680123, 135, '2015-02-01 00:04:05.000000', 'consum', 0.0246, 'lps'),
	(680124, 135, '2015-02-01 00:04:06.000000', 'consum', 0.0242, 'lps'),
	(680125, 135, '2015-02-01 00:04:07.000000', 'consum', 0.0262, 'lps'),
	(680126, 135, '2015-02-01 00:04:08.000000', 'consum', 0.0214, 'lps'),
	(680127, 135, '2015-02-01 00:04:09.000000', 'consum', 0.0235, 'lps'),
	(680128, 135, '2015-02-01 00:04:10.000000', 'consum', 0.0216, 'lps'),
	(680129, 135, '2015-02-01 00:04:11.000000', 'consum', 0.0219, 'lps'),
	(680130, 135, '2015-02-01 00:04:12.000000', 'consum', 0.0240, 'lps'),
	(680131, 135, '2015-02-01 00:04:13.000000', 'consum', 0.0224, 'lps'),
	(680132, 135, '2015-02-01 00:04:14.000000', 'consum', 0.0244, 'lps'),
	(680133, 135, '2015-02-01 00:04:15.000000', 'consum', 0.0234, 'lps'),
	(680134, 135, '2015-02-01 00:04:16.000000', 'consum', 0.0229, 'lps'),
	(680135, 135, '2015-02-01 00:04:17.000000', 'consum', 0.0234, 'lps'),
	(680136, 135, '2015-02-01 00:04:18.000000', 'consum', 0.0218, 'lps'),
	(680137, 135, '2015-02-01 00:04:19.000000', 'consum', 0.0234, 'lps'),
	(680138, 135, '2015-02-01 00:04:20.000000', 'consum', 0.0252, 'lps'),
	(680139, 135, '2015-02-01 00:04:21.000000', 'consum', 0.0243, 'lps'),
	(680140, 135, '2015-02-01 00:04:22.000000', 'consum', 0.0251, 'lps'),
	(680141, 135, '2015-02-01 00:04:23.000000', 'consum', 0.0210, 'lps'),
	(680142, 135, '2015-02-01 00:04:24.000000', 'consum', 0.0246, 'lps'),
	(680143, 135, '2015-02-01 00:04:25.000000', 'consum', 0.0230, 'lps'),
	(680144, 135, '2015-02-01 00:04:26.000000', 'consum', 0.0256, 'lps'),
	(680145, 135, '2015-02-01 00:04:27.000000', 'consum', 0.0220, 'lps'),
	(680146, 135, '2015-02-01 00:04:28.000000', 'consum', 0.0232, 'lps'),
	(680147, 135, '2015-02-01 00:04:29.000000', 'consum', 0.0234, 'lps'),
	(680148, 135, '2015-02-01 00:04:30.000000', 'consum', 0.0215, 'lps'),
	(680149, 135, '2015-02-01 00:04:31.000000', 'consum', 0.0214, 'lps'),
	(680150, 135, '2015-02-01 00:04:32.000000', 'consum', 0.0215, 'lps'),
	(680151, 135, '2015-02-01 00:04:33.000000', 'consum', 0.0225, 'lps'),
	(680152, 135, '2015-02-01 00:04:34.000000', 'consum', 0.0215, 'lps'),
	(680153, 135, '2015-02-01 00:04:35.000000', 'consum', 0.0245, 'lps'),
	(680154, 135, '2015-02-01 00:04:36.000000', 'consum', 0.0210, 'lps'),
	(680155, 135, '2015-02-01 00:04:37.000000', 'consum', 0.0214, 'lps'),
	(680156, 135, '2015-02-01 00:04:38.000000', 'consum', 0.0229, 'lps'),
	(680157, 135, '2015-02-01 00:04:39.000000', 'consum', 0.0242, 'lps'),
	(680158, 135, '2015-02-01 00:04:40.000000', 'consum', 0.0262, 'lps'),
	(680159, 135, '2015-02-01 00:04:41.000000', 'consum', 0.0212, 'lps'),
	(680160, 135, '2015-02-01 00:04:42.000000', 'consum', 0.0224, 'lps'),
	(680161, 135, '2015-02-01 00:04:43.000000', 'consum', 0.0221, 'lps'),
	(680162, 135, '2015-02-01 00:04:44.000000', 'consum', 0.0223, 'lps'),
	(680163, 135, '2015-02-01 00:04:45.000000', 'consum', 0.0245, 'lps'),
	(680164, 135, '2015-02-01 00:04:46.000000', 'consum', 0.0239, 'lps'),
	(680165, 135, '2015-02-01 00:04:47.000000', 'consum', 0.0252, 'lps'),
	(680166, 135, '2015-02-01 00:04:48.000000', 'consum', 0.0228, 'lps'),
	(680167, 135, '2015-02-01 00:04:49.000000', 'consum', 0.0227, 'lps'),
	(680168, 135, '2015-02-01 00:04:50.000000', 'consum', 0.0240, 'lps'),
	(680169, 135, '2015-02-01 00:04:51.000000', 'consum', 0.0257, 'lps'),
	(680170, 135, '2015-02-01 00:04:52.000000', 'consum', 0.0251, 'lps'),
	(680171, 135, '2015-02-01 00:04:53.000000', 'consum', 0.0221, 'lps'),
	(680172, 135, '2015-02-01 00:04:54.000000', 'consum', 0.0249, 'lps'),
	(680173, 135, '2015-02-01 00:04:55.000000', 'consum', 0.0211, 'lps'),
	(680174, 135, '2015-02-01 00:04:56.000000', 'consum', 0.0258, 'lps'),
	(680175, 135, '2015-02-01 00:04:57.000000', 'consum', 0.0238, 'lps'),
	(680176, 135, '2015-02-01 00:04:58.000000', 'consum', 0.0257, 'lps'),
	(680177, 135, '2015-02-01 00:04:59.000000', 'consum', 0.0255, 'lps'),
	(680178, 135, '2015-02-01 00:05:00.000000', 'consum', 0.0243, 'lps'),
	(680179, 135, '2015-02-01 00:05:01.000000', 'consum', 0.0240, 'lps'),
	(680180, 135, '2015-02-01 00:05:02.000000', 'consum', 0.0260, 'lps'),
	(680181, 135, '2015-02-01 00:05:03.000000', 'consum', 0.0211, 'lps'),
	(680182, 135, '2015-02-01 00:05:04.000000', 'consum', 0.0226, 'lps'),
	(680183, 135, '2015-02-01 00:05:05.000000', 'consum', 0.0234, 'lps'),
	(680184, 135, '2015-02-01 00:05:06.000000', 'consum', 0.0231, 'lps'),
	(680185, 135, '2015-02-01 00:05:07.000000', 'consum', 0.0241, 'lps'),
	(680186, 135, '2015-02-01 00:05:08.000000', 'consum', 0.0250, 'lps'),
	(680187, 135, '2015-02-01 00:05:09.000000', 'consum', 0.0214, 'lps'),
	(680188, 135, '2015-02-01 00:05:10.000000', 'consum', 0.0213, 'lps'),
	(680189, 135, '2015-02-01 00:05:11.000000', 'consum', 0.0216, 'lps'),
	(680190, 135, '2015-02-01 00:05:12.000000', 'consum', 0.0230, 'lps'),
	(680191, 135, '2015-02-01 00:05:13.000000', 'consum', 0.0240, 'lps'),
	(680192, 135, '2015-02-01 00:05:14.000000', 'consum', 0.0247, 'lps'),
	(680193, 135, '2015-02-01 00:05:15.000000', 'consum', 0.0252, 'lps'),
	(680194, 135, '2015-02-01 00:05:16.000000', 'consum', 0.0259, 'lps'),
	(680195, 135, '2015-02-01 00:05:17.000000', 'consum', 0.0221, 'lps'),
	(680196, 135, '2015-02-01 00:05:18.000000', 'consum', 0.0223, 'lps'),
	(680197, 135, '2015-02-01 00:05:19.000000', 'consum', 0.0245, 'lps'),
	(680198, 135, '2015-02-01 00:05:20.000000', 'consum', 0.0240, 'lps'),
	(680199, 135, '2015-02-01 00:05:21.000000', 'consum', 0.0255, 'lps'),
	(680200, 135, '2015-02-01 00:05:22.000000', 'consum', 0.0240, 'lps'),
	(680201, 135, '2015-02-01 00:05:23.000000', 'consum', 0.0227, 'lps'),
	(680202, 135, '2015-02-01 00:05:24.000000', 'consum', 0.0255, 'lps'),
	(680203, 135, '2015-02-01 00:05:25.000000', 'consum', 0.0229, 'lps'),
	(680204, 135, '2015-02-01 00:05:26.000000', 'consum', 0.0220, 'lps'),
	(680205, 135, '2015-02-01 00:05:27.000000', 'consum', 0.0260, 'lps'),
	(680206, 135, '2015-02-01 00:05:28.000000', 'consum', 0.0218, 'lps'),
	(680207, 135, '2015-02-01 00:05:29.000000', 'consum', 0.0257, 'lps'),
	(680208, 135, '2015-02-01 00:05:30.000000', 'consum', 0.0211, 'lps'),
	(680209, 135, '2015-02-01 00:05:31.000000', 'consum', 0.0231, 'lps'),
	(680210, 135, '2015-02-01 00:05:32.000000', 'consum', 0.0210, 'lps'),
	(680211, 135, '2015-02-01 00:05:33.000000', 'consum', 0.0253, 'lps'),
	(680212, 135, '2015-02-01 00:05:34.000000', 'consum', 0.0212, 'lps'),
	(680213, 135, '2015-02-01 00:05:35.000000', 'consum', 0.0250, 'lps'),
	(680214, 135, '2015-02-01 00:05:36.000000', 'consum', 0.0245, 'lps'),
	(680215, 135, '2015-02-01 00:05:37.000000', 'consum', 0.0211, 'lps'),
	(680216, 135, '2015-02-01 00:05:38.000000', 'consum', 0.0220, 'lps'),
	(680217, 135, '2015-02-01 00:05:39.000000', 'consum', 0.0256, 'lps'),
	(680218, 135, '2015-02-01 00:05:40.000000', 'consum', 0.0252, 'lps'),
	(680219, 135, '2015-02-01 00:05:41.000000', 'consum', 0.0230, 'lps'),
	(680220, 135, '2015-02-01 00:05:42.000000', 'consum', 0.0238, 'lps'),
	(680221, 135, '2015-02-01 00:05:43.000000', 'consum', 0.0237, 'lps'),
	(680222, 135, '2015-02-01 00:05:44.000000', 'consum', 0.0260, 'lps'),
	(680223, 135, '2015-02-01 00:05:45.000000', 'consum', 0.0220, 'lps'),
	(680224, 135, '2015-02-01 00:05:46.000000', 'consum', 0.0219, 'lps'),
	(680225, 135, '2015-02-01 00:05:47.000000', 'consum', 0.0224, 'lps'),
	(680226, 135, '2015-02-01 00:05:48.000000', 'consum', 0.0254, 'lps'),
	(680227, 135, '2015-02-01 00:05:49.000000', 'consum', 0.0230, 'lps'),
	(680228, 135, '2015-02-01 00:05:50.000000', 'consum', 0.0230, 'lps'),
	(680229, 135, '2015-02-01 00:05:51.000000', 'consum', 0.0251, 'lps'),
	(680230, 135, '2015-02-01 00:05:52.000000', 'consum', 0.0251, 'lps'),
	(680231, 135, '2015-02-01 00:05:53.000000', 'consum', 0.0237, 'lps'),
	(680232, 135, '2015-02-01 00:05:54.000000', 'consum', 0.0223, 'lps'),
	(680233, 135, '2015-02-01 00:05:55.000000', 'consum', 0.0246, 'lps'),
	(680234, 135, '2015-02-01 00:05:56.000000', 'consum', 0.0248, 'lps'),
	(680235, 135, '2015-02-01 00:05:57.000000', 'consum', 0.0237, 'lps'),
	(680236, 135, '2015-02-01 00:05:58.000000', 'consum', 0.0233, 'lps'),
	(680237, 135, '2015-02-01 00:05:59.000000', 'consum', 0.0243, 'lps'),
	(680238, 135, '2015-02-01 00:06:00.000000', 'consum', 0.0256, 'lps'),
	(680239, 135, '2015-02-01 00:06:01.000000', 'consum', 0.0236, 'lps'),
	(680240, 135, '2015-02-01 00:06:02.000000', 'consum', 0.0254, 'lps'),
	(680241, 135, '2015-02-01 00:06:03.000000', 'consum', 0.0248, 'lps'),
	(680242, 135, '2015-02-01 00:06:04.000000', 'consum', 0.0213, 'lps'),
	(680243, 135, '2015-02-01 00:06:05.000000', 'consum', 0.0218, 'lps'),
	(680244, 135, '2015-02-01 00:06:06.000000', 'consum', 0.0240, 'lps'),
	(680245, 135, '2015-02-01 00:06:07.000000', 'consum', 0.0232, 'lps'),
	(680246, 135, '2015-02-01 00:06:08.000000', 'consum', 0.0233, 'lps'),
	(680247, 135, '2015-02-01 00:06:09.000000', 'consum', 0.0256, 'lps'),
	(680248, 135, '2015-02-01 00:06:10.000000', 'consum', 0.0212, 'lps'),
	(680249, 135, '2015-02-01 00:06:11.000000', 'consum', 0.0244, 'lps'),
	(680250, 135, '2015-02-01 00:06:12.000000', 'consum', 0.0216, 'lps'),
	(680251, 135, '2015-02-01 00:06:13.000000', 'consum', 0.0243, 'lps'),
	(680252, 135, '2015-02-01 00:06:14.000000', 'consum', 0.0252, 'lps'),
	(680253, 135, '2015-02-01 00:06:15.000000', 'consum', 0.0215, 'lps'),
	(680254, 135, '2015-02-01 00:06:16.000000', 'consum', 0.0215, 'lps'),
	(680255, 135, '2015-02-01 00:06:17.000000', 'consum', 0.0219, 'lps'),
	(680256, 135, '2015-02-01 00:06:18.000000', 'consum', 0.0243, 'lps'),
	(680257, 135, '2015-02-01 00:06:19.000000', 'consum', 0.0241, 'lps'),
	(680258, 135, '2015-02-01 00:06:20.000000', 'consum', 0.0216, 'lps'),
	(680259, 135, '2015-02-01 00:06:21.000000', 'consum', 0.0251, 'lps'),
	(680260, 135, '2015-02-01 00:06:22.000000', 'consum', 0.0238, 'lps'),
	(680261, 135, '2015-02-01 00:06:23.000000', 'consum', 0.0229, 'lps'),
	(680262, 135, '2015-02-01 00:06:24.000000', 'consum', 0.0223, 'lps'),
	(680263, 135, '2015-02-01 00:06:25.000000', 'consum', 0.0217, 'lps'),
	(680264, 135, '2015-02-01 00:06:26.000000', 'consum', 0.0262, 'lps'),
	(680265, 135, '2015-02-01 00:06:27.000000', 'consum', 0.0234, 'lps'),
	(680266, 135, '2015-02-01 00:06:28.000000', 'consum', 0.0231, 'lps'),
	(680267, 135, '2015-02-01 00:06:29.000000', 'consum', 0.0241, 'lps'),
	(680268, 135, '2015-02-01 00:06:30.000000', 'consum', 0.0252, 'lps'),
	(680269, 135, '2015-02-01 00:06:31.000000', 'consum', 0.0221, 'lps'),
	(680270, 135, '2015-02-01 00:06:32.000000', 'consum', 0.0245, 'lps'),
	(680271, 135, '2015-02-01 00:06:33.000000', 'consum', 0.0245, 'lps'),
	(680272, 135, '2015-02-01 00:06:34.000000', 'consum', 0.0227, 'lps'),
	(680273, 135, '2015-02-01 00:06:35.000000', 'consum', 0.0244, 'lps'),
	(680274, 135, '2015-02-01 00:06:36.000000', 'consum', 0.0223, 'lps'),
	(680275, 135, '2015-02-01 00:06:37.000000', 'consum', 0.0227, 'lps'),
	(680276, 135, '2015-02-01 00:06:38.000000', 'consum', 0.0256, 'lps'),
	(680277, 135, '2015-02-01 00:06:39.000000', 'consum', 0.0229, 'lps'),
	(680278, 135, '2015-02-01 00:06:40.000000', 'consum', 0.0221, 'lps'),
	(680279, 135, '2015-02-01 00:06:41.000000', 'consum', 0.0262, 'lps'),
	(680280, 135, '2015-02-01 00:06:42.000000', 'consum', 0.0226, 'lps'),
	(680281, 135, '2015-02-01 00:06:43.000000', 'consum', 0.0242, 'lps'),
	(680282, 135, '2015-02-01 00:06:44.000000', 'consum', 0.0214, 'lps'),
	(680283, 135, '2015-02-01 00:06:45.000000', 'consum', 0.0242, 'lps'),
	(680284, 135, '2015-02-01 00:06:46.000000', 'consum', 0.0253, 'lps'),
	(680285, 135, '2015-02-01 00:06:47.000000', 'consum', 0.0224, 'lps'),
	(680286, 135, '2015-02-01 00:06:48.000000', 'consum', 0.0255, 'lps'),
	(680287, 135, '2015-02-01 00:06:49.000000', 'consum', 0.0237, 'lps'),
	(680288, 135, '2015-02-01 00:06:50.000000', 'consum', 0.0210, 'lps'),
	(680289, 135, '2015-02-01 00:06:51.000000', 'consum', 0.0237, 'lps'),
	(680290, 135, '2015-02-01 00:06:52.000000', 'consum', 0.0239, 'lps'),
	(680291, 135, '2015-02-01 00:06:53.000000', 'consum', 0.0221, 'lps'),
	(680292, 135, '2015-02-01 00:06:54.000000', 'consum', 0.0231, 'lps'),
	(680293, 135, '2015-02-01 00:06:55.000000', 'consum', 0.0231, 'lps'),
	(680294, 135, '2015-02-01 00:06:56.000000', 'consum', 0.0250, 'lps'),
	(680295, 135, '2015-02-01 00:06:57.000000', 'consum', 0.0242, 'lps'),
	(680296, 135, '2015-02-01 00:06:58.000000', 'consum', 0.0252, 'lps'),
	(680297, 135, '2015-02-01 00:06:59.000000', 'consum', 0.0220, 'lps'),
	(680298, 135, '2015-02-01 00:07:00.000000', 'consum', 0.0237, 'lps'),
	(680299, 135, '2015-02-01 00:07:01.000000', 'consum', 0.0212, 'lps'),
	(680300, 135, '2015-02-01 00:07:02.000000', 'consum', 0.0244, 'lps'),
	(680301, 135, '2015-02-01 00:07:03.000000', 'consum', 0.0218, 'lps'),
	(680302, 135, '2015-02-01 00:07:04.000000', 'consum', 0.0252, 'lps'),
	(680303, 135, '2015-02-01 00:07:05.000000', 'consum', 0.0239, 'lps'),
	(680304, 135, '2015-02-01 00:07:06.000000', 'consum', 0.0231, 'lps'),
	(680305, 135, '2015-02-01 00:07:07.000000', 'consum', 0.0226, 'lps'),
	(680306, 135, '2015-02-01 00:07:08.000000', 'consum', 0.0228, 'lps'),
	(680307, 135, '2015-02-01 00:07:09.000000', 'consum', 0.0252, 'lps'),
	(680308, 135, '2015-02-01 00:07:10.000000', 'consum', 0.0259, 'lps'),
	(680309, 135, '2015-02-01 00:07:11.000000', 'consum', 0.0226, 'lps'),
	(680310, 135, '2015-02-01 00:07:12.000000', 'consum', 0.0249, 'lps'),
	(680311, 135, '2015-02-01 00:07:13.000000', 'consum', 0.0251, 'lps'),
	(680312, 135, '2015-02-01 00:07:14.000000', 'consum', 0.0244, 'lps'),
	(680313, 135, '2015-02-01 00:07:15.000000', 'consum', 0.0259, 'lps'),
	(680314, 135, '2015-02-01 00:07:16.000000', 'consum', 0.0248, 'lps'),
	(680315, 135, '2015-02-01 00:07:17.000000', 'consum', 0.0254, 'lps'),
	(680316, 135, '2015-02-01 00:07:18.000000', 'consum', 0.0261, 'lps'),
	(680317, 135, '2015-02-01 00:07:19.000000', 'consum', 0.0231, 'lps'),
	(680318, 135, '2015-02-01 00:07:20.000000', 'consum', 0.0212, 'lps'),
	(680319, 135, '2015-02-01 00:07:21.000000', 'consum', 0.0212, 'lps'),
	(680320, 135, '2015-02-01 00:07:22.000000', 'consum', 0.0213, 'lps'),
	(680321, 135, '2015-02-01 00:07:23.000000', 'consum', 0.0220, 'lps'),
	(680322, 135, '2015-02-01 00:07:24.000000', 'consum', 0.0250, 'lps'),
	(680323, 135, '2015-02-01 00:07:25.000000', 'consum', 0.0224, 'lps'),
	(680324, 135, '2015-02-01 00:07:26.000000', 'consum', 0.0213, 'lps'),
	(680325, 135, '2015-02-01 00:07:27.000000', 'consum', 0.0237, 'lps'),
	(680326, 135, '2015-02-01 00:07:28.000000', 'consum', 0.0230, 'lps'),
	(680327, 135, '2015-02-01 00:07:29.000000', 'consum', 0.0230, 'lps'),
	(680328, 135, '2015-02-01 00:07:30.000000', 'consum', 0.0249, 'lps'),
	(680329, 135, '2015-02-01 00:07:31.000000', 'consum', 0.0239, 'lps'),
	(680330, 135, '2015-02-01 00:07:32.000000', 'consum', 0.0238, 'lps'),
	(680331, 135, '2015-02-01 00:07:33.000000', 'consum', 0.0211, 'lps'),
	(680332, 135, '2015-02-01 00:07:34.000000', 'consum', 0.0238, 'lps'),
	(680333, 135, '2015-02-01 00:07:35.000000', 'consum', 0.0243, 'lps'),
	(680334, 135, '2015-02-01 00:07:36.000000', 'consum', 0.0237, 'lps'),
	(680335, 135, '2015-02-01 00:07:37.000000', 'consum', 0.0247, 'lps'),
	(680336, 135, '2015-02-01 00:07:38.000000', 'consum', 0.0262, 'lps'),
	(680337, 135, '2015-02-01 00:07:39.000000', 'consum', 0.0251, 'lps'),
	(680338, 135, '2015-02-01 00:07:40.000000', 'consum', 0.0261, 'lps'),
	(680339, 135, '2015-02-01 00:07:41.000000', 'consum', 0.0235, 'lps'),
	(680340, 135, '2015-02-01 00:07:42.000000', 'consum', 0.0235, 'lps'),
	(680341, 135, '2015-02-01 00:07:43.000000', 'consum', 0.0260, 'lps'),
	(680342, 135, '2015-02-01 00:07:44.000000', 'consum', 0.0226, 'lps'),
	(680343, 135, '2015-02-01 00:07:45.000000', 'consum', 0.0246, 'lps'),
	(680344, 135, '2015-02-01 00:07:46.000000', 'consum', 0.0237, 'lps'),
	(680345, 135, '2015-02-01 00:07:47.000000', 'consum', 0.0236, 'lps'),
	(680346, 135, '2015-02-01 00:07:48.000000', 'consum', 0.0262, 'lps'),
	(680347, 135, '2015-02-01 00:07:49.000000', 'consum', 0.0234, 'lps'),
	(680348, 135, '2015-02-01 00:07:50.000000', 'consum', 0.0225, 'lps'),
	(680349, 135, '2015-02-01 00:07:51.000000', 'consum', 0.0213, 'lps'),
	(680350, 135, '2015-02-01 00:07:52.000000', 'consum', 0.0233, 'lps'),
	(680351, 135, '2015-02-01 00:07:53.000000', 'consum', 0.0210, 'lps'),
	(680352, 135, '2015-02-01 00:07:54.000000', 'consum', 0.0250, 'lps'),
	(680353, 135, '2015-02-01 00:07:55.000000', 'consum', 0.0251, 'lps'),
	(680354, 135, '2015-02-01 00:07:56.000000', 'consum', 0.0240, 'lps'),
	(680355, 135, '2015-02-01 00:07:57.000000', 'consum', 0.0239, 'lps'),
	(680356, 135, '2015-02-01 00:07:58.000000', 'consum', 0.0214, 'lps'),
	(680357, 135, '2015-02-01 00:07:59.000000', 'consum', 0.0248, 'lps'),
	(680358, 135, '2015-02-01 00:08:00.000000', 'consum', 0.0230, 'lps'),
	(680359, 135, '2015-02-01 00:08:01.000000', 'consum', 0.0250, 'lps'),
	(680360, 135, '2015-02-01 00:08:02.000000', 'consum', 0.0244, 'lps'),
	(680361, 135, '2015-02-01 00:08:03.000000', 'consum', 0.0260, 'lps'),
	(680362, 135, '2015-02-01 00:08:04.000000', 'consum', 0.0252, 'lps'),
	(680363, 135, '2015-02-01 00:08:05.000000', 'consum', 0.0216, 'lps'),
	(680364, 135, '2015-02-01 00:08:06.000000', 'consum', 0.0222, 'lps'),
	(680365, 135, '2015-02-01 00:08:07.000000', 'consum', 0.0254, 'lps'),
	(680366, 135, '2015-02-01 00:08:08.000000', 'consum', 0.0237, 'lps'),
	(680367, 135, '2015-02-01 00:08:09.000000', 'consum', 0.0210, 'lps'),
	(680368, 135, '2015-02-01 00:08:10.000000', 'consum', 0.0235, 'lps'),
	(680369, 135, '2015-02-01 00:08:11.000000', 'consum', 0.0232, 'lps'),
	(680370, 135, '2015-02-01 00:08:12.000000', 'consum', 0.0243, 'lps'),
	(680371, 135, '2015-02-01 00:08:13.000000', 'consum', 0.0256, 'lps'),
	(680372, 135, '2015-02-01 00:08:14.000000', 'consum', 0.0238, 'lps'),
	(680373, 135, '2015-02-01 00:08:15.000000', 'consum', 0.0212, 'lps'),
	(680374, 135, '2015-02-01 00:08:16.000000', 'consum', 0.0242, 'lps'),
	(680375, 135, '2015-02-01 00:08:17.000000', 'consum', 0.0260, 'lps'),
	(680376, 135, '2015-02-01 00:08:18.000000', 'consum', 0.0259, 'lps'),
	(680377, 135, '2015-02-01 00:08:19.000000', 'consum', 0.0249, 'lps'),
	(680378, 135, '2015-02-01 00:08:20.000000', 'consum', 0.0262, 'lps'),
	(680379, 135, '2015-02-01 00:08:21.000000', 'consum', 0.0246, 'lps'),
	(680380, 135, '2015-02-01 00:08:22.000000', 'consum', 0.0234, 'lps'),
	(680381, 135, '2015-02-01 00:08:23.000000', 'consum', 0.0222, 'lps'),
	(680382, 135, '2015-02-01 00:08:24.000000', 'consum', 0.0250, 'lps'),
	(680383, 135, '2015-02-01 00:08:25.000000', 'consum', 0.0219, 'lps'),
	(680384, 135, '2015-02-01 00:08:26.000000', 'consum', 0.0239, 'lps'),
	(680385, 135, '2015-02-01 00:08:27.000000', 'consum', 0.0225, 'lps'),
	(680386, 135, '2015-02-01 00:08:28.000000', 'consum', 0.0249, 'lps'),
	(680387, 135, '2015-02-01 00:08:29.000000', 'consum', 0.0255, 'lps'),
	(680388, 135, '2015-02-01 00:08:30.000000', 'consum', 0.0213, 'lps'),
	(680389, 135, '2015-02-01 00:08:31.000000', 'consum', 0.0251, 'lps'),
	(680390, 135, '2015-02-01 00:08:32.000000', 'consum', 0.0248, 'lps'),
	(680391, 135, '2015-02-01 00:08:33.000000', 'consum', 0.0225, 'lps'),
	(680392, 135, '2015-02-01 00:08:34.000000', 'consum', 0.0224, 'lps'),
	(680393, 135, '2015-02-01 00:08:35.000000', 'consum', 0.0233, 'lps'),
	(680394, 135, '2015-02-01 00:08:36.000000', 'consum', 0.0234, 'lps'),
	(680395, 135, '2015-02-01 00:08:37.000000', 'consum', 0.0259, 'lps'),
	(680396, 135, '2015-02-01 00:08:38.000000', 'consum', 0.0225, 'lps'),
	(680397, 135, '2015-02-01 00:08:39.000000', 'consum', 0.0244, 'lps'),
	(680398, 135, '2015-02-01 00:08:40.000000', 'consum', 0.0229, 'lps'),
	(680399, 135, '2015-02-01 00:08:41.000000', 'consum', 0.0257, 'lps'),
	(680400, 135, '2015-02-01 00:08:42.000000', 'consum', 0.0228, 'lps'),
	(680401, 135, '2015-02-01 00:08:43.000000', 'consum', 0.0212, 'lps'),
	(680402, 135, '2015-02-01 00:08:44.000000', 'consum', 0.0221, 'lps'),
	(680403, 135, '2015-02-01 00:08:45.000000', 'consum', 0.0257, 'lps'),
	(680404, 135, '2015-02-01 00:08:46.000000', 'consum', 0.0257, 'lps'),
	(680405, 135, '2015-02-01 00:08:47.000000', 'consum', 0.0251, 'lps'),
	(680406, 135, '2015-02-01 00:08:48.000000', 'consum', 0.0220, 'lps'),
	(680407, 135, '2015-02-01 00:08:49.000000', 'consum', 0.0246, 'lps'),
	(680408, 135, '2015-02-01 00:08:50.000000', 'consum', 0.0252, 'lps'),
	(680409, 135, '2015-02-01 00:08:51.000000', 'consum', 0.0262, 'lps'),
	(680410, 135, '2015-02-01 00:08:52.000000', 'consum', 0.0237, 'lps'),
	(680411, 135, '2015-02-01 00:08:53.000000', 'consum', 0.0242, 'lps'),
	(680412, 135, '2015-02-01 00:08:54.000000', 'consum', 0.0236, 'lps'),
	(680413, 135, '2015-02-01 00:08:55.000000', 'consum', 0.0244, 'lps'),
	(680414, 135, '2015-02-01 00:08:56.000000', 'consum', 0.0249, 'lps'),
	(680415, 135, '2015-02-01 00:08:57.000000', 'consum', 0.0252, 'lps'),
	(680416, 135, '2015-02-01 00:08:58.000000', 'consum', 0.0251, 'lps'),
	(680417, 135, '2015-02-01 00:08:59.000000', 'consum', 0.0237, 'lps'),
	(680418, 135, '2015-02-01 00:09:00.000000', 'consum', 0.0221, 'lps'),
	(680419, 135, '2015-02-01 00:09:01.000000', 'consum', 0.0236, 'lps'),
	(680420, 135, '2015-02-01 00:09:02.000000', 'consum', 0.0256, 'lps'),
	(680421, 135, '2015-02-01 00:09:03.000000', 'consum', 0.0258, 'lps'),
	(680422, 135, '2015-02-01 00:09:04.000000', 'consum', 0.0258, 'lps'),
	(680423, 135, '2015-02-01 00:09:05.000000', 'consum', 0.0252, 'lps'),
	(680424, 135, '2015-02-01 00:09:06.000000', 'consum', 0.0224, 'lps'),
	(680425, 135, '2015-02-01 00:09:07.000000', 'consum', 0.0260, 'lps'),
	(680426, 135, '2015-02-01 00:09:08.000000', 'consum', 0.0261, 'lps'),
	(680427, 135, '2015-02-01 00:09:09.000000', 'consum', 0.0210, 'lps'),
	(680428, 135, '2015-02-01 00:09:10.000000', 'consum', 0.0214, 'lps'),
	(680429, 135, '2015-02-01 00:09:11.000000', 'consum', 0.0232, 'lps'),
	(680430, 135, '2015-02-01 00:09:12.000000', 'consum', 0.0257, 'lps'),
	(680431, 135, '2015-02-01 00:09:13.000000', 'consum', 0.0219, 'lps'),
	(680432, 135, '2015-02-01 00:09:14.000000', 'consum', 0.0220, 'lps'),
	(680433, 135, '2015-02-01 00:09:15.000000', 'consum', 0.0235, 'lps'),
	(680434, 135, '2015-02-01 00:09:16.000000', 'consum', 0.0253, 'lps'),
	(680435, 135, '2015-02-01 00:09:17.000000', 'consum', 0.0244, 'lps'),
	(680436, 135, '2015-02-01 00:09:18.000000', 'consum', 0.0251, 'lps'),
	(680437, 135, '2015-02-01 00:09:19.000000', 'consum', 0.0262, 'lps'),
	(680438, 135, '2015-02-01 00:09:20.000000', 'consum', 0.0242, 'lps'),
	(680439, 135, '2015-02-01 00:09:21.000000', 'consum', 0.0214, 'lps'),
	(680440, 135, '2015-02-01 00:09:22.000000', 'consum', 0.0240, 'lps'),
	(680441, 135, '2015-02-01 00:09:23.000000', 'consum', 0.0243, 'lps'),
	(680442, 135, '2015-02-01 00:09:24.000000', 'consum', 0.0234, 'lps'),
	(680443, 135, '2015-02-01 00:09:25.000000', 'consum', 0.0231, 'lps'),
	(680444, 135, '2015-02-01 00:09:26.000000', 'consum', 0.0243, 'lps'),
	(680445, 135, '2015-02-01 00:09:27.000000', 'consum', 0.0261, 'lps'),
	(680446, 135, '2015-02-01 00:09:28.000000', 'consum', 0.0259, 'lps'),
	(680447, 135, '2015-02-01 00:09:29.000000', 'consum', 0.0250, 'lps'),
	(680448, 135, '2015-02-01 00:09:30.000000', 'consum', 0.0262, 'lps'),
	(680449, 135, '2015-02-01 00:09:31.000000', 'consum', 0.0245, 'lps'),
	(680450, 135, '2015-02-01 00:09:32.000000', 'consum', 0.0229, 'lps'),
	(680451, 135, '2015-02-01 00:09:33.000000', 'consum', 0.0252, 'lps'),
	(680452, 135, '2015-02-01 00:09:34.000000', 'consum', 0.0261, 'lps'),
	(680453, 135, '2015-02-01 00:09:35.000000', 'consum', 0.0232, 'lps'),
	(680454, 135, '2015-02-01 00:09:36.000000', 'consum', 0.0222, 'lps'),
	(680455, 135, '2015-02-01 00:09:37.000000', 'consum', 0.0258, 'lps'),
	(680456, 135, '2015-02-01 00:09:38.000000', 'consum', 0.0255, 'lps'),
	(680457, 135, '2015-02-01 00:09:39.000000', 'consum', 0.0237, 'lps'),
	(680458, 135, '2015-02-01 00:09:40.000000', 'consum', 0.0212, 'lps'),
	(680459, 135, '2015-02-01 00:09:41.000000', 'consum', 0.0243, 'lps'),
	(680460, 135, '2015-02-01 00:09:42.000000', 'consum', 0.0213, 'lps'),
	(680461, 135, '2015-02-01 00:09:43.000000', 'consum', 0.0231, 'lps'),
	(680462, 135, '2015-02-01 00:09:44.000000', 'consum', 0.0254, 'lps'),
	(680463, 135, '2015-02-01 00:09:45.000000', 'consum', 0.0260, 'lps'),
	(680464, 135, '2015-02-01 00:09:46.000000', 'consum', 0.0222, 'lps'),
	(680465, 135, '2015-02-01 00:09:47.000000', 'consum', 0.0229, 'lps'),
	(680466, 135, '2015-02-01 00:09:48.000000', 'consum', 0.0215, 'lps'),
	(680467, 135, '2015-02-01 00:09:49.000000', 'consum', 0.0231, 'lps'),
	(680468, 135, '2015-02-01 00:09:50.000000', 'consum', 0.0248, 'lps'),
	(680469, 135, '2015-02-01 00:09:51.000000', 'consum', 0.0229, 'lps'),
	(680470, 135, '2015-02-01 00:09:52.000000', 'consum', 0.0248, 'lps'),
	(680471, 135, '2015-02-01 00:09:53.000000', 'consum', 0.0238, 'lps'),
	(680472, 135, '2015-02-01 00:09:54.000000', 'consum', 0.0235, 'lps'),
	(680473, 135, '2015-02-01 00:09:55.000000', 'consum', 0.0250, 'lps'),
	(680474, 135, '2015-02-01 00:09:56.000000', 'consum', 0.0231, 'lps'),
	(680475, 135, '2015-02-01 00:09:57.000000', 'consum', 0.0249, 'lps'),
	(680476, 135, '2015-02-01 00:09:58.000000', 'consum', 0.0237, 'lps'),
	(680477, 135, '2015-02-01 00:09:59.000000', 'consum', 0.0229, 'lps'),
	(680478, 135, '2015-02-01 00:10:00.000000', 'consum', 0.0223, 'lps'),
	(680479, 135, '2015-02-01 00:10:01.000000', 'consum', 0.0220, 'lps'),
	(680480, 135, '2015-02-01 00:10:02.000000', 'consum', 0.0219, 'lps'),
	(680481, 135, '2015-02-01 00:10:03.000000', 'consum', 0.0227, 'lps'),
	(680482, 135, '2015-02-01 00:10:04.000000', 'consum', 0.0214, 'lps'),
	(680483, 135, '2015-02-01 00:10:05.000000', 'consum', 0.0234, 'lps'),
	(680484, 135, '2015-02-01 00:10:06.000000', 'consum', 0.0211, 'lps'),
	(680485, 135, '2015-02-01 00:10:07.000000', 'consum', 0.0252, 'lps'),
	(680486, 135, '2015-02-01 00:10:08.000000', 'consum', 0.0259, 'lps'),
	(680487, 135, '2015-02-01 00:10:09.000000', 'consum', 0.0222, 'lps'),
	(680488, 135, '2015-02-01 00:10:10.000000', 'consum', 0.0231, 'lps'),
	(680489, 135, '2015-02-01 00:10:11.000000', 'consum', 0.0226, 'lps'),
	(680490, 135, '2015-02-01 00:10:12.000000', 'consum', 0.0228, 'lps'),
	(680491, 135, '2015-02-01 00:10:13.000000', 'consum', 0.0251, 'lps'),
	(680492, 135, '2015-02-01 00:10:14.000000', 'consum', 0.0257, 'lps'),
	(680493, 135, '2015-02-01 00:10:15.000000', 'consum', 0.0216, 'lps'),
	(680494, 135, '2015-02-01 00:10:16.000000', 'consum', 0.0258, 'lps'),
	(680495, 135, '2015-02-01 00:10:17.000000', 'consum', 0.0220, 'lps'),
	(680496, 135, '2015-02-01 00:10:18.000000', 'consum', 0.0223, 'lps'),
	(680497, 135, '2015-02-01 00:10:19.000000', 'consum', 0.0244, 'lps'),
	(680498, 135, '2015-02-01 00:10:20.000000', 'consum', 0.0236, 'lps'),
	(680499, 135, '2015-02-01 00:10:21.000000', 'consum', 0.0238, 'lps'),
	(680500, 135, '2015-02-01 00:10:22.000000', 'consum', 0.0220, 'lps'),
	(680501, 135, '2015-02-01 00:10:23.000000', 'consum', 0.0230, 'lps'),
	(680502, 135, '2015-02-01 00:10:24.000000', 'consum', 0.0229, 'lps'),
	(680503, 135, '2015-02-01 00:10:25.000000', 'consum', 0.0245, 'lps'),
	(680504, 135, '2015-02-01 00:10:26.000000', 'consum', 0.0221, 'lps'),
	(680505, 135, '2015-02-01 00:10:27.000000', 'consum', 0.0214, 'lps'),
	(680506, 135, '2015-02-01 00:10:28.000000', 'consum', 0.0250, 'lps'),
	(680507, 135, '2015-02-01 00:10:29.000000', 'consum', 0.0241, 'lps'),
	(680508, 135, '2015-02-01 00:10:30.000000', 'consum', 0.0246, 'lps'),
	(680509, 135, '2015-02-01 00:10:31.000000', 'consum', 0.0243, 'lps'),
	(680510, 135, '2015-02-01 00:10:32.000000', 'consum', 0.0216, 'lps'),
	(680511, 135, '2015-02-01 00:10:33.000000', 'consum', 0.0249, 'lps'),
	(680512, 135, '2015-02-01 00:10:34.000000', 'consum', 0.0225, 'lps'),
	(680513, 135, '2015-02-01 00:10:35.000000', 'consum', 0.0225, 'lps'),
	(680514, 135, '2015-02-01 00:10:36.000000', 'consum', 0.0237, 'lps'),
	(680515, 135, '2015-02-01 00:10:37.000000', 'consum', 0.0250, 'lps'),
	(680516, 135, '2015-02-01 00:10:38.000000', 'consum', 0.0221, 'lps'),
	(680517, 135, '2015-02-01 00:10:39.000000', 'consum', 0.0252, 'lps'),
	(680518, 135, '2015-02-01 00:10:40.000000', 'consum', 0.0228, 'lps'),
	(680519, 135, '2015-02-01 00:10:41.000000', 'consum', 0.0228, 'lps'),
	(680520, 135, '2015-02-01 00:10:42.000000', 'consum', 0.0248, 'lps'),
	(680521, 135, '2015-02-01 00:10:43.000000', 'consum', 0.0239, 'lps'),
	(680522, 135, '2015-02-01 00:10:44.000000', 'consum', 0.0240, 'lps'),
	(680523, 135, '2015-02-01 00:10:45.000000', 'consum', 0.0221, 'lps'),
	(680524, 135, '2015-02-01 00:10:46.000000', 'consum', 0.0230, 'lps'),
	(680525, 135, '2015-02-01 00:10:47.000000', 'consum', 0.0222, 'lps'),
	(680526, 135, '2015-02-01 00:10:48.000000', 'consum', 0.0213, 'lps'),
	(680527, 135, '2015-02-01 00:10:49.000000', 'consum', 0.0242, 'lps'),
	(680528, 135, '2015-02-01 00:10:50.000000', 'consum', 0.0254, 'lps'),
	(680529, 135, '2015-02-01 00:10:51.000000', 'consum', 0.0229, 'lps'),
	(680530, 135, '2015-02-01 00:10:52.000000', 'consum', 0.0226, 'lps'),
	(680531, 135, '2015-02-01 00:10:53.000000', 'consum', 0.0235, 'lps'),
	(680532, 135, '2015-02-01 00:10:54.000000', 'consum', 0.0234, 'lps'),
	(680533, 135, '2015-02-01 00:10:55.000000', 'consum', 0.0255, 'lps'),
	(680534, 135, '2015-02-01 00:10:56.000000', 'consum', 0.0258, 'lps'),
	(680535, 135, '2015-02-01 00:10:57.000000', 'consum', 0.0211, 'lps'),
	(680536, 135, '2015-02-01 00:10:58.000000', 'consum', 0.0230, 'lps'),
	(680537, 135, '2015-02-01 00:10:59.000000', 'consum', 0.0253, 'lps'),
	(680538, 135, '2015-02-01 00:11:00.000000', 'consum', 0.0259, 'lps'),
	(680539, 135, '2015-02-01 00:11:01.000000', 'consum', 0.0223, 'lps'),
	(680540, 135, '2015-02-01 00:11:02.000000', 'consum', 0.0235, 'lps'),
	(680541, 135, '2015-02-01 00:11:03.000000', 'consum', 0.0242, 'lps'),
	(680542, 135, '2015-02-01 00:11:04.000000', 'consum', 0.0244, 'lps'),
	(680543, 135, '2015-02-01 00:11:05.000000', 'consum', 0.0231, 'lps'),
	(680544, 135, '2015-02-01 00:11:06.000000', 'consum', 0.0212, 'lps'),
	(680545, 135, '2015-02-01 00:11:07.000000', 'consum', 0.0213, 'lps'),
	(680546, 135, '2015-02-01 00:11:08.000000', 'consum', 0.0217, 'lps'),
	(680547, 135, '2015-02-01 00:11:09.000000', 'consum', 0.0239, 'lps'),
	(680548, 135, '2015-02-01 00:11:10.000000', 'consum', 0.0229, 'lps'),
	(680549, 135, '2015-02-01 00:11:11.000000', 'consum', 0.0217, 'lps'),
	(680550, 135, '2015-02-01 00:11:12.000000', 'consum', 0.0242, 'lps'),
	(680551, 135, '2015-02-01 00:11:13.000000', 'consum', 0.0243, 'lps'),
	(680552, 135, '2015-02-01 00:11:14.000000', 'consum', 0.0229, 'lps'),
	(680553, 135, '2015-02-01 00:11:15.000000', 'consum', 0.0257, 'lps'),
	(680554, 135, '2015-02-01 00:11:16.000000', 'consum', 0.0230, 'lps'),
	(680555, 135, '2015-02-01 00:11:17.000000', 'consum', 0.0223, 'lps'),
	(680556, 135, '2015-02-01 00:11:18.000000', 'consum', 0.0215, 'lps'),
	(680557, 135, '2015-02-01 00:11:19.000000', 'consum', 0.0251, 'lps'),
	(680558, 135, '2015-02-01 00:11:20.000000', 'consum', 0.0238, 'lps'),
	(680559, 135, '2015-02-01 00:11:21.000000', 'consum', 0.0231, 'lps'),
	(680560, 135, '2015-02-01 00:11:22.000000', 'consum', 0.0232, 'lps'),
	(680561, 135, '2015-02-01 00:11:23.000000', 'consum', 0.0256, 'lps'),
	(680562, 135, '2015-02-01 00:11:24.000000', 'consum', 0.0218, 'lps'),
	(680563, 135, '2015-02-01 00:11:25.000000', 'consum', 0.0215, 'lps'),
	(680564, 135, '2015-02-01 00:11:26.000000', 'consum', 0.0213, 'lps'),
	(680565, 135, '2015-02-01 00:11:27.000000', 'consum', 0.0211, 'lps'),
	(680566, 135, '2015-02-01 00:11:28.000000', 'consum', 0.0257, 'lps'),
	(680567, 135, '2015-02-01 00:11:29.000000', 'consum', 0.0233, 'lps'),
	(680568, 135, '2015-02-01 00:11:30.000000', 'consum', 0.0236, 'lps'),
	(680569, 135, '2015-02-01 00:11:31.000000', 'consum', 0.0221, 'lps'),
	(680570, 135, '2015-02-01 00:11:32.000000', 'consum', 0.0239, 'lps'),
	(680571, 135, '2015-02-01 00:11:33.000000', 'consum', 0.0216, 'lps'),
	(680572, 135, '2015-02-01 00:11:34.000000', 'consum', 0.0261, 'lps'),
	(680573, 135, '2015-02-01 00:11:35.000000', 'consum', 0.0237, 'lps'),
	(680574, 135, '2015-02-01 00:11:36.000000', 'consum', 0.0243, 'lps'),
	(680575, 135, '2015-02-01 00:11:37.000000', 'consum', 0.0244, 'lps'),
	(680576, 135, '2015-02-01 00:11:38.000000', 'consum', 0.0227, 'lps'),
	(680577, 135, '2015-02-01 00:11:39.000000', 'consum', 0.0247, 'lps'),
	(680578, 135, '2015-02-01 00:11:40.000000', 'consum', 0.0238, 'lps'),
	(680579, 135, '2015-02-01 00:11:41.000000', 'consum', 0.0240, 'lps'),
	(680580, 135, '2015-02-01 00:11:42.000000', 'consum', 0.0222, 'lps'),
	(680581, 135, '2015-02-01 00:11:43.000000', 'consum', 0.0233, 'lps'),
	(680582, 135, '2015-02-01 00:11:44.000000', 'consum', 0.0238, 'lps'),
	(680583, 135, '2015-02-01 00:11:45.000000', 'consum', 0.0228, 'lps'),
	(680584, 135, '2015-02-01 00:11:46.000000', 'consum', 0.0216, 'lps'),
	(680585, 135, '2015-02-01 00:11:47.000000', 'consum', 0.0242, 'lps'),
	(680586, 135, '2015-02-01 00:11:48.000000', 'consum', 0.0243, 'lps'),
	(680587, 135, '2015-02-01 00:11:49.000000', 'consum', 0.0230, 'lps'),
	(680588, 135, '2015-02-01 00:11:50.000000', 'consum', 0.0262, 'lps'),
	(680589, 135, '2015-02-01 00:11:51.000000', 'consum', 0.0250, 'lps'),
	(680590, 135, '2015-02-01 00:11:52.000000', 'consum', 0.0258, 'lps'),
	(680591, 135, '2015-02-01 00:11:53.000000', 'consum', 0.0223, 'lps'),
	(680592, 135, '2015-02-01 00:11:54.000000', 'consum', 0.0239, 'lps'),
	(680593, 135, '2015-02-01 00:11:55.000000', 'consum', 0.0211, 'lps'),
	(680594, 135, '2015-02-01 00:11:56.000000', 'consum', 0.0235, 'lps'),
	(680595, 135, '2015-02-01 00:11:57.000000', 'consum', 0.0226, 'lps'),
	(680596, 135, '2015-02-01 00:11:58.000000', 'consum', 0.0217, 'lps'),
	(680597, 135, '2015-02-01 00:11:59.000000', 'consum', 0.0249, 'lps'),
	(680598, 135, '2015-02-01 00:12:00.000000', 'consum', 0.0226, 'lps'),
	(680599, 135, '2015-02-01 00:12:01.000000', 'consum', 0.0228, 'lps'),
	(680600, 135, '2015-02-01 00:12:02.000000', 'consum', 0.0252, 'lps'),
	(680601, 135, '2015-02-01 00:12:03.000000', 'consum', 0.0258, 'lps'),
	(680602, 135, '2015-02-01 00:12:04.000000', 'consum', 0.0222, 'lps'),
	(680603, 135, '2015-02-01 00:12:05.000000', 'consum', 0.0229, 'lps'),
	(680604, 135, '2015-02-01 00:12:06.000000', 'consum', 0.0218, 'lps'),
	(680605, 135, '2015-02-01 00:12:07.000000', 'consum', 0.0247, 'lps'),
	(680606, 135, '2015-02-01 00:12:08.000000', 'consum', 0.0213, 'lps'),
	(680607, 135, '2015-02-01 00:12:09.000000', 'consum', 0.0221, 'lps'),
	(680608, 135, '2015-02-01 00:12:10.000000', 'consum', 0.0254, 'lps'),
	(680609, 135, '2015-02-01 00:12:11.000000', 'consum', 0.0240, 'lps'),
	(680610, 135, '2015-02-01 00:12:12.000000', 'consum', 0.0229, 'lps'),
	(680611, 135, '2015-02-01 00:12:13.000000', 'consum', 0.0217, 'lps'),
	(680612, 135, '2015-02-01 00:12:14.000000', 'consum', 0.0240, 'lps'),
	(680613, 135, '2015-02-01 00:12:15.000000', 'consum', 0.0235, 'lps'),
	(680614, 135, '2015-02-01 00:12:16.000000', 'consum', 0.0247, 'lps'),
	(680615, 135, '2015-02-01 00:12:17.000000', 'consum', 0.0211, 'lps'),
	(680616, 135, '2015-02-01 00:12:18.000000', 'consum', 0.0212, 'lps'),
	(680617, 135, '2015-02-01 00:12:19.000000', 'consum', 0.0217, 'lps'),
	(680618, 135, '2015-02-01 00:12:20.000000', 'consum', 0.0238, 'lps'),
	(680619, 135, '2015-02-01 00:12:21.000000', 'consum', 0.0225, 'lps'),
	(680620, 135, '2015-02-01 00:12:22.000000', 'consum', 0.0254, 'lps'),
	(680621, 135, '2015-02-01 00:12:23.000000', 'consum', 0.0226, 'lps'),
	(680622, 135, '2015-02-01 00:12:24.000000', 'consum', 0.0212, 'lps'),
	(680623, 135, '2015-02-01 00:12:25.000000', 'consum', 0.0225, 'lps'),
	(680624, 135, '2015-02-01 00:12:26.000000', 'consum', 0.0225, 'lps'),
	(680625, 135, '2015-02-01 00:12:27.000000', 'consum', 0.0242, 'lps'),
	(680626, 135, '2015-02-01 00:12:28.000000', 'consum', 0.0220, 'lps'),
	(680627, 135, '2015-02-01 00:12:29.000000', 'consum', 0.0217, 'lps'),
	(680628, 135, '2015-02-01 00:12:30.000000', 'consum', 0.0216, 'lps'),
	(680629, 135, '2015-02-01 00:12:31.000000', 'consum', 0.0218, 'lps'),
	(680630, 135, '2015-02-01 00:12:32.000000', 'consum', 0.0234, 'lps'),
	(680631, 135, '2015-02-01 00:12:33.000000', 'consum', 0.0251, 'lps'),
	(680632, 135, '2015-02-01 00:12:34.000000', 'consum', 0.0239, 'lps'),
	(680633, 135, '2015-02-01 00:12:35.000000', 'consum', 0.0235, 'lps'),
	(680634, 135, '2015-02-01 00:12:36.000000', 'consum', 0.0245, 'lps'),
	(680635, 135, '2015-02-01 00:12:37.000000', 'consum', 0.0258, 'lps'),
	(680636, 135, '2015-02-01 00:12:38.000000', 'consum', 0.0239, 'lps'),
	(680637, 135, '2015-02-01 00:12:39.000000', 'consum', 0.0214, 'lps'),
	(680638, 135, '2015-02-01 00:12:40.000000', 'consum', 0.0249, 'lps'),
	(680639, 135, '2015-02-01 00:12:41.000000', 'consum', 0.0233, 'lps'),
	(680640, 135, '2015-02-01 00:12:42.000000', 'consum', 0.0262, 'lps'),
	(680641, 135, '2015-02-01 00:12:43.000000', 'consum', 0.0243, 'lps'),
	(680642, 135, '2015-02-01 00:12:44.000000', 'consum', 0.0221, 'lps'),
	(680643, 135, '2015-02-01 00:12:45.000000', 'consum', 0.0218, 'lps'),
	(680644, 135, '2015-02-01 00:12:46.000000', 'consum', 0.0217, 'lps'),
	(680645, 135, '2015-02-01 00:12:47.000000', 'consum', 0.0223, 'lps'),
	(680646, 135, '2015-02-01 00:12:48.000000', 'consum', 0.0254, 'lps'),
	(680647, 135, '2015-02-01 00:12:49.000000', 'consum', 0.0232, 'lps'),
	(680648, 135, '2015-02-01 00:12:50.000000', 'consum', 0.0240, 'lps'),
	(680649, 135, '2015-02-01 00:12:51.000000', 'consum', 0.0242, 'lps'),
	(680650, 135, '2015-02-01 00:12:52.000000', 'consum', 0.0228, 'lps'),
	(680651, 135, '2015-02-01 00:12:53.000000', 'consum', 0.0257, 'lps'),
	(680652, 135, '2015-02-01 00:12:54.000000', 'consum', 0.0231, 'lps'),
	(680653, 135, '2015-02-01 00:12:55.000000', 'consum', 0.0231, 'lps'),
	(680654, 135, '2015-02-01 00:12:56.000000', 'consum', 0.0249, 'lps'),
	(680655, 135, '2015-02-01 00:12:57.000000', 'consum', 0.0238, 'lps'),
	(680656, 135, '2015-02-01 00:12:58.000000', 'consum', 0.0232, 'lps'),
	(680657, 135, '2015-02-01 00:12:59.000000', 'consum', 0.0238, 'lps'),
	(680658, 135, '2015-02-01 00:13:00.000000', 'consum', 0.0230, 'lps'),
	(680659, 135, '2015-02-01 00:13:01.000000', 'consum', 0.0228, 'lps'),
	(680660, 135, '2015-02-01 00:13:02.000000', 'consum', 0.0239, 'lps'),
	(680661, 135, '2015-02-01 00:13:03.000000', 'consum', 0.0247, 'lps'),
	(680662, 135, '2015-02-01 00:13:04.000000', 'consum', 0.0258, 'lps'),
	(680663, 135, '2015-02-01 00:13:05.000000', 'consum', 0.0232, 'lps'),
	(680664, 135, '2015-02-01 00:13:06.000000', 'consum', 0.0232, 'lps'),
	(680665, 135, '2015-02-01 00:13:07.000000', 'consum', 0.0254, 'lps'),
	(680666, 135, '2015-02-01 00:13:08.000000', 'consum', 0.0257, 'lps'),
	(680667, 135, '2015-02-01 00:13:09.000000', 'consum', 0.0259, 'lps'),
	(680668, 135, '2015-02-01 00:13:10.000000', 'consum', 0.0212, 'lps'),
	(680669, 135, '2015-02-01 00:13:11.000000', 'consum', 0.0230, 'lps'),
	(680670, 135, '2015-02-01 00:13:12.000000', 'consum', 0.0254, 'lps'),
	(680671, 135, '2015-02-01 00:13:13.000000', 'consum', 0.0210, 'lps'),
	(680672, 135, '2015-02-01 00:13:14.000000', 'consum', 0.0238, 'lps'),
	(680673, 135, '2015-02-01 00:13:15.000000', 'consum', 0.0245, 'lps'),
	(680674, 135, '2015-02-01 00:13:16.000000', 'consum', 0.0249, 'lps'),
	(680675, 135, '2015-02-01 00:13:17.000000', 'consum', 0.0246, 'lps'),
	(680676, 135, '2015-02-01 00:13:18.000000', 'consum', 0.0221, 'lps'),
	(680677, 135, '2015-02-01 00:13:19.000000', 'consum', 0.0262, 'lps'),
	(680678, 135, '2015-02-01 00:13:20.000000', 'consum', 0.0228, 'lps'),
	(680679, 135, '2015-02-01 00:13:21.000000', 'consum', 0.0250, 'lps'),
	(680680, 135, '2015-02-01 00:13:22.000000', 'consum', 0.0252, 'lps'),
	(680681, 135, '2015-02-01 00:13:23.000000', 'consum', 0.0247, 'lps'),
	(680682, 135, '2015-02-01 00:13:24.000000', 'consum', 0.0216, 'lps'),
	(680683, 135, '2015-02-01 00:13:25.000000', 'consum', 0.0234, 'lps'),
	(680684, 135, '2015-02-01 00:13:26.000000', 'consum', 0.0210, 'lps'),
	(680685, 135, '2015-02-01 00:13:27.000000', 'consum', 0.0241, 'lps'),
	(680686, 135, '2015-02-01 00:13:28.000000', 'consum', 0.0259, 'lps'),
	(680687, 135, '2015-02-01 00:13:29.000000', 'consum', 0.0260, 'lps'),
	(680688, 135, '2015-02-01 00:13:30.000000', 'consum', 0.0257, 'lps'),
	(680689, 135, '2015-02-01 00:13:31.000000', 'consum', 0.0246, 'lps'),
	(680690, 135, '2015-02-01 00:13:32.000000', 'consum', 0.0246, 'lps'),
	(680691, 135, '2015-02-01 00:13:33.000000', 'consum', 0.0232, 'lps'),
	(680692, 135, '2015-02-01 00:13:34.000000', 'consum', 0.0212, 'lps'),
	(680693, 135, '2015-02-01 00:13:35.000000', 'consum', 0.0259, 'lps'),
	(680694, 135, '2015-02-01 00:13:36.000000', 'consum', 0.0240, 'lps'),
	(680695, 135, '2015-02-01 00:13:37.000000', 'consum', 0.0212, 'lps'),
	(680696, 135, '2015-02-01 00:13:38.000000', 'consum', 0.0239, 'lps'),
	(680697, 135, '2015-02-01 00:13:39.000000', 'consum', 0.0240, 'lps'),
	(680698, 135, '2015-02-01 00:13:40.000000', 'consum', 0.0222, 'lps'),
	(680699, 135, '2015-02-01 00:13:41.000000', 'consum', 0.0234, 'lps'),
	(680700, 135, '2015-02-01 00:13:42.000000', 'consum', 0.0242, 'lps'),
	(680701, 135, '2015-02-01 00:13:43.000000', 'consum', 0.0246, 'lps'),
	(680702, 135, '2015-02-01 00:13:44.000000', 'consum', 0.0241, 'lps'),
	(680703, 135, '2015-02-01 00:13:45.000000', 'consum', 0.0259, 'lps'),
	(680704, 135, '2015-02-01 00:13:46.000000', 'consum', 0.0256, 'lps'),
	(680705, 135, '2015-02-01 00:13:47.000000', 'consum', 0.0242, 'lps'),
	(680706, 135, '2015-02-01 00:13:48.000000', 'consum', 0.0231, 'lps'),
	(680707, 135, '2015-02-01 00:13:49.000000', 'consum', 0.0221, 'lps'),
	(680708, 135, '2015-02-01 00:13:50.000000', 'consum', 0.0255, 'lps'),
	(680709, 135, '2015-02-01 00:13:51.000000', 'consum', 0.0241, 'lps'),
	(680710, 135, '2015-02-01 00:13:52.000000', 'consum', 0.0233, 'lps'),
	(680711, 135, '2015-02-01 00:13:53.000000', 'consum', 0.0233, 'lps'),
	(680712, 135, '2015-02-01 00:13:54.000000', 'consum', 0.0257, 'lps'),
	(680713, 135, '2015-02-01 00:13:55.000000', 'consum', 0.0217, 'lps'),
	(680714, 135, '2015-02-01 00:13:56.000000', 'consum', 0.0211, 'lps'),
	(680715, 135, '2015-02-01 00:13:57.000000', 'consum', 0.0246, 'lps'),
	(680716, 135, '2015-02-01 00:13:58.000000', 'consum', 0.0229, 'lps'),
	(680717, 135, '2015-02-01 00:13:59.000000', 'consum', 0.0253, 'lps'),
	(680718, 135, '2015-02-01 00:14:00.000000', 'consum', 0.0259, 'lps'),
	(680719, 135, '2015-02-01 00:14:01.000000', 'consum', 0.0222, 'lps'),
	(680720, 135, '2015-02-01 00:14:02.000000', 'consum', 0.0228, 'lps'),
	(680721, 135, '2015-02-01 00:14:03.000000', 'consum', 0.0210, 'lps'),
	(680722, 135, '2015-02-01 00:14:04.000000', 'consum', 0.0213, 'lps'),
	(680723, 135, '2015-02-01 00:14:05.000000', 'consum', 0.0225, 'lps'),
	(680724, 135, '2015-02-01 00:14:06.000000', 'consum', 0.0224, 'lps'),
	(680725, 135, '2015-02-01 00:14:07.000000', 'consum', 0.0235, 'lps'),
	(680726, 135, '2015-02-01 00:14:08.000000', 'consum', 0.0239, 'lps'),
	(680727, 135, '2015-02-01 00:14:09.000000', 'consum', 0.0230, 'lps'),
	(680728, 135, '2015-02-01 00:14:10.000000', 'consum', 0.0221, 'lps'),
	(680729, 135, '2015-02-01 00:14:11.000000', 'consum', 0.0260, 'lps'),
	(680730, 135, '2015-02-01 00:14:12.000000', 'consum', 0.0216, 'lps'),
	(680731, 135, '2015-02-01 00:14:13.000000', 'consum', 0.0249, 'lps'),
	(680732, 135, '2015-02-01 00:14:14.000000', 'consum', 0.0229, 'lps'),
	(680733, 135, '2015-02-01 00:14:15.000000', 'consum', 0.0240, 'lps'),
	(680734, 135, '2015-02-01 00:14:16.000000', 'consum', 0.0252, 'lps'),
	(680735, 135, '2015-02-01 00:14:17.000000', 'consum', 0.0225, 'lps'),
	(680736, 135, '2015-02-01 00:14:18.000000', 'consum', 0.0213, 'lps'),
	(680737, 135, '2015-02-01 00:14:19.000000', 'consum', 0.0234, 'lps'),
	(680738, 135, '2015-02-01 00:14:20.000000', 'consum', 0.0216, 'lps'),
	(680739, 135, '2015-02-01 00:14:21.000000', 'consum', 0.0220, 'lps'),
	(680740, 135, '2015-02-01 00:14:22.000000', 'consum', 0.0243, 'lps'),
	(680741, 135, '2015-02-01 00:14:23.000000', 'consum', 0.0239, 'lps'),
	(680742, 135, '2015-02-01 00:14:24.000000', 'consum', 0.0258, 'lps'),
	(680743, 135, '2015-02-01 00:14:25.000000', 'consum', 0.0256, 'lps'),
	(680744, 135, '2015-02-01 00:14:26.000000', 'consum', 0.0244, 'lps'),
	(680745, 135, '2015-02-01 00:14:27.000000', 'consum', 0.0242, 'lps'),
	(680746, 135, '2015-02-01 00:14:28.000000', 'consum', 0.0217, 'lps'),
	(680747, 135, '2015-02-01 00:14:29.000000', 'consum', 0.0255, 'lps'),
	(680748, 135, '2015-02-01 00:14:30.000000', 'consum', 0.0254, 'lps'),
	(680749, 135, '2015-02-01 00:14:31.000000', 'consum', 0.0245, 'lps'),
	(680750, 135, '2015-02-01 00:14:32.000000', 'consum', 0.0251, 'lps'),
	(680751, 135, '2015-02-01 00:14:33.000000', 'consum', 0.0260, 'lps'),
	(680752, 135, '2015-02-01 00:14:34.000000', 'consum', 0.0231, 'lps'),
	(680753, 135, '2015-02-01 00:14:35.000000', 'consum', 0.0217, 'lps'),
	(680754, 135, '2015-02-01 00:14:36.000000', 'consum', 0.0238, 'lps'),
	(680755, 135, '2015-02-01 00:14:37.000000', 'consum', 0.0221, 'lps'),
	(680756, 135, '2015-02-01 00:14:38.000000', 'consum', 0.0236, 'lps'),
	(680757, 135, '2015-02-01 00:14:39.000000', 'consum', 0.0256, 'lps'),
	(680758, 135, '2015-02-01 00:14:40.000000', 'consum', 0.0254, 'lps'),
	(680759, 135, '2015-02-01 00:14:41.000000', 'consum', 0.0240, 'lps'),
	(680760, 135, '2015-02-01 00:14:42.000000', 'consum', 0.0229, 'lps'),
	(680761, 135, '2015-02-01 00:14:43.000000', 'consum', 0.0215, 'lps'),
	(680762, 135, '2015-02-01 00:14:44.000000', 'consum', 0.0233, 'lps'),
	(680763, 135, '2015-02-01 00:14:45.000000', 'consum', 0.0257, 'lps'),
	(680764, 135, '2015-02-01 00:14:46.000000', 'consum', 0.0218, 'lps'),
	(680765, 135, '2015-02-01 00:14:47.000000', 'consum', 0.0213, 'lps'),
	(680766, 135, '2015-02-01 00:14:48.000000', 'consum', 0.0256, 'lps'),
	(680767, 135, '2015-02-01 00:14:49.000000', 'consum', 0.0219, 'lps'),
	(680768, 135, '2015-02-01 00:14:50.000000', 'consum', 0.0226, 'lps'),
	(680769, 135, '2015-02-01 00:14:51.000000', 'consum', 0.0261, 'lps'),
	(680770, 135, '2015-02-01 00:14:52.000000', 'consum', 0.0257, 'lps'),
	(680771, 135, '2015-02-01 00:14:53.000000', 'consum', 0.0241, 'lps'),
	(680772, 135, '2015-02-01 00:14:54.000000', 'consum', 0.0226, 'lps'),
	(680773, 135, '2015-02-01 00:14:55.000000', 'consum', 0.0248, 'lps'),
	(680774, 135, '2015-02-01 00:14:56.000000', 'consum', 0.0246, 'lps'),
	(680775, 135, '2015-02-01 00:14:57.000000', 'consum', 0.0223, 'lps'),
	(680776, 135, '2015-02-01 00:14:58.000000', 'consum', 0.0223, 'lps'),
	(680777, 135, '2015-02-01 00:14:59.000000', 'consum', 0.0234, 'lps'),
	(680778, 135, '2015-02-01 00:15:00.000000', 'consum', 0.0239, 'lps'),
	(680779, 135, '2015-02-01 00:15:01.000000', 'consum', 0.0229, 'lps'),
	(680780, 135, '2015-02-01 00:15:02.000000', 'consum', 0.0221, 'lps'),
	(680781, 135, '2015-02-01 00:15:03.000000', 'consum', 0.0261, 'lps'),
	(680782, 135, '2015-02-01 00:15:04.000000', 'consum', 0.0221, 'lps'),
	(680783, 135, '2015-02-01 00:15:05.000000', 'consum', 0.0218, 'lps'),
	(680784, 135, '2015-02-01 00:15:06.000000', 'consum', 0.0216, 'lps'),
	(680785, 135, '2015-02-01 00:15:07.000000', 'consum', 0.0219, 'lps'),
	(680786, 135, '2015-02-01 00:15:08.000000', 'consum', 0.0237, 'lps'),
	(680787, 135, '2015-02-01 00:15:09.000000', 'consum', 0.0211, 'lps'),
	(680788, 135, '2015-02-01 00:15:10.000000', 'consum', 0.0242, 'lps'),
	(680789, 135, '2015-02-01 00:15:11.000000', 'consum', 0.0259, 'lps'),
	(680790, 135, '2015-02-01 00:15:12.000000', 'consum', 0.0257, 'lps'),
	(680791, 135, '2015-02-01 00:15:13.000000', 'consum', 0.0243, 'lps'),
	(680792, 135, '2015-02-01 00:15:14.000000', 'consum', 0.0236, 'lps'),
	(680793, 135, '2015-02-01 00:15:15.000000', 'consum', 0.0241, 'lps'),
	(680794, 135, '2015-02-01 00:15:16.000000', 'consum', 0.0234, 'lps'),
	(680795, 135, '2015-02-01 00:15:17.000000', 'consum', 0.0239, 'lps'),
	(680796, 135, '2015-02-01 00:15:18.000000', 'consum', 0.0230, 'lps'),
	(680797, 135, '2015-02-01 00:15:19.000000', 'consum', 0.0225, 'lps'),
	(680798, 135, '2015-02-01 00:15:20.000000', 'consum', 0.0224, 'lps'),
	(680799, 135, '2015-02-01 00:15:21.000000', 'consum', 0.0235, 'lps'),
	(680800, 135, '2015-02-01 00:15:22.000000', 'consum', 0.0241, 'lps'),
	(680801, 135, '2015-02-01 00:15:23.000000', 'consum', 0.0238, 'lps'),
	(680802, 135, '2015-02-01 00:15:24.000000', 'consum', 0.0258, 'lps'),
	(680803, 135, '2015-02-01 00:15:25.000000', 'consum', 0.0259, 'lps'),
	(680804, 135, '2015-02-01 00:15:26.000000', 'consum', 0.0258, 'lps'),
	(680805, 135, '2015-02-01 00:15:27.000000', 'consum', 0.0250, 'lps'),
	(680806, 135, '2015-02-01 00:15:28.000000', 'consum', 0.0214, 'lps'),
	(680807, 135, '2015-02-01 00:15:29.000000', 'consum', 0.0216, 'lps'),
	(680808, 135, '2015-02-01 00:15:30.000000', 'consum', 0.0231, 'lps'),
	(680809, 135, '2015-02-01 00:15:31.000000', 'consum', 0.0243, 'lps'),
	(680810, 135, '2015-02-01 00:15:32.000000', 'consum', 0.0259, 'lps'),
	(680811, 135, '2015-02-01 00:15:33.000000', 'consum', 0.0251, 'lps'),
	(680812, 135, '2015-02-01 00:15:34.000000', 'consum', 0.0214, 'lps'),
	(680813, 135, '2015-02-01 00:15:35.000000', 'consum', 0.0215, 'lps'),
	(680814, 135, '2015-02-01 00:15:36.000000', 'consum', 0.0222, 'lps'),
	(680815, 135, '2015-02-01 00:15:37.000000', 'consum', 0.0255, 'lps'),
	(680816, 135, '2015-02-01 00:15:38.000000', 'consum', 0.0242, 'lps'),
	(680817, 135, '2015-02-01 00:15:39.000000', 'consum', 0.0234, 'lps'),
	(680818, 135, '2015-02-01 00:15:40.000000', 'consum', 0.0233, 'lps'),
	(680819, 135, '2015-02-01 00:15:41.000000', 'consum', 0.0256, 'lps'),
	(680820, 135, '2015-02-01 00:15:42.000000', 'consum', 0.0214, 'lps'),
	(680821, 135, '2015-02-01 00:15:43.000000', 'consum', 0.0248, 'lps'),
	(680822, 135, '2015-02-01 00:15:44.000000', 'consum', 0.0233, 'lps'),
	(680823, 135, '2015-02-01 00:15:45.000000', 'consum', 0.0262, 'lps'),
	(680824, 135, '2015-02-01 00:15:46.000000', 'consum', 0.0244, 'lps'),
	(680825, 135, '2015-02-01 00:15:47.000000', 'consum', 0.0224, 'lps'),
	(680826, 135, '2015-02-01 00:15:48.000000', 'consum', 0.0231, 'lps'),
	(680827, 135, '2015-02-01 00:15:49.000000', 'consum', 0.0220, 'lps'),
	(680828, 135, '2015-02-01 00:15:50.000000', 'consum', 0.0252, 'lps'),
	(680829, 135, '2015-02-01 00:15:51.000000', 'consum', 0.0230, 'lps'),
	(680830, 135, '2015-02-01 00:15:52.000000', 'consum', 0.0239, 'lps'),
	(680831, 135, '2015-02-01 00:15:53.000000', 'consum', 0.0244, 'lps'),
	(680832, 135, '2015-02-01 00:15:54.000000', 'consum', 0.0237, 'lps'),
	(680833, 135, '2015-02-01 00:15:55.000000', 'consum', 0.0247, 'lps'),
	(680834, 135, '2015-02-01 00:15:56.000000', 'consum', 0.0260, 'lps'),
	(680835, 135, '2015-02-01 00:15:57.000000', 'consum', 0.0242, 'lps'),
	(680836, 135, '2015-02-01 00:15:58.000000', 'consum', 0.0223, 'lps'),
	(680837, 135, '2015-02-01 00:15:59.000000', 'consum', 0.0232, 'lps'),
	(680838, 135, '2015-02-01 00:16:00.000000', 'consum', 0.0230, 'lps'),
	(680839, 135, '2015-02-01 00:16:01.000000', 'consum', 0.0243, 'lps'),
	(680840, 135, '2015-02-01 00:16:02.000000', 'consum', 0.0262, 'lps'),
	(680841, 135, '2015-02-01 00:16:03.000000', 'consum', 0.0213, 'lps'),
	(680842, 135, '2015-02-01 00:16:04.000000', 'consum', 0.0230, 'lps'),
	(680843, 135, '2015-02-01 00:16:05.000000', 'consum', 0.0248, 'lps'),
	(680844, 135, '2015-02-01 00:16:06.000000', 'consum', 0.0234, 'lps'),
	(680845, 135, '2015-02-01 00:16:07.000000', 'consum', 0.0214, 'lps'),
	(680846, 135, '2015-02-01 00:16:08.000000', 'consum', 0.0215, 'lps'),
	(680847, 135, '2015-02-01 00:16:09.000000', 'consum', 0.0223, 'lps'),
	(680848, 135, '2015-02-01 00:16:10.000000', 'consum', 0.0259, 'lps'),
	(680849, 135, '2015-02-01 00:16:11.000000', 'consum', 0.0259, 'lps'),
	(680850, 135, '2015-02-01 00:16:12.000000', 'consum', 0.0255, 'lps'),
	(680851, 135, '2015-02-01 00:16:13.000000', 'consum', 0.0236, 'lps'),
	(680852, 135, '2015-02-01 00:16:14.000000', 'consum', 0.0258, 'lps'),
	(680853, 135, '2015-02-01 00:16:15.000000', 'consum', 0.0216, 'lps'),
	(680854, 135, '2015-02-01 00:16:16.000000', 'consum', 0.0252, 'lps'),
	(680855, 135, '2015-02-01 00:16:17.000000', 'consum', 0.0244, 'lps'),
	(680856, 135, '2015-02-01 00:16:18.000000', 'consum', 0.0255, 'lps'),
	(680857, 135, '2015-02-01 00:16:19.000000', 'consum', 0.0227, 'lps'),
	(680858, 135, '2015-02-01 00:16:20.000000', 'consum', 0.0213, 'lps'),
	(680859, 135, '2015-02-01 00:16:21.000000', 'consum', 0.0230, 'lps'),
	(680860, 135, '2015-02-01 00:16:22.000000', 'consum', 0.0247, 'lps'),
	(680861, 135, '2015-02-01 00:16:23.000000', 'consum', 0.0229, 'lps'),
	(680862, 135, '2015-02-01 00:16:24.000000', 'consum', 0.0248, 'lps'),
	(680863, 135, '2015-02-01 00:16:25.000000', 'consum', 0.0235, 'lps'),
	(680864, 135, '2015-02-01 00:16:26.000000', 'consum', 0.0225, 'lps'),
	(680865, 135, '2015-02-01 00:16:27.000000', 'consum', 0.0211, 'lps'),
	(680866, 135, '2015-02-01 00:16:28.000000', 'consum', 0.0221, 'lps'),
	(680867, 135, '2015-02-01 00:16:29.000000', 'consum', 0.0211, 'lps'),
	(680868, 135, '2015-02-01 00:16:30.000000', 'consum', 0.0234, 'lps'),
	(680869, 135, '2015-02-01 00:16:31.000000', 'consum', 0.0220, 'lps'),
	(680870, 135, '2015-02-01 00:16:32.000000', 'consum', 0.0245, 'lps'),
	(680871, 135, '2015-02-01 00:16:33.000000', 'consum', 0.0248, 'lps'),
	(680872, 135, '2015-02-01 00:16:34.000000', 'consum', 0.0244, 'lps'),
	(680873, 135, '2015-02-01 00:16:35.000000', 'consum', 0.0214, 'lps'),
	(680874, 135, '2015-02-01 00:16:36.000000', 'consum', 0.0232, 'lps'),
	(680875, 135, '2015-02-01 00:16:37.000000', 'consum', 0.0256, 'lps'),
	(680876, 135, '2015-02-01 00:16:38.000000', 'consum', 0.0216, 'lps'),
	(680877, 135, '2015-02-01 00:16:39.000000', 'consum', 0.0260, 'lps'),
	(680878, 135, '2015-02-01 00:16:40.000000', 'consum', 0.0230, 'lps'),
	(680879, 135, '2015-02-01 00:16:41.000000', 'consum', 0.0216, 'lps'),
	(680880, 135, '2015-02-01 00:16:42.000000', 'consum', 0.0232, 'lps'),
	(680881, 135, '2015-02-01 00:16:43.000000', 'consum', 0.0250, 'lps'),
	(680882, 135, '2015-02-01 00:16:44.000000', 'consum', 0.0240, 'lps'),
	(680883, 135, '2015-02-01 00:16:45.000000', 'consum', 0.0240, 'lps'),
	(680884, 135, '2015-02-01 00:16:46.000000', 'consum', 0.0217, 'lps'),
	(680885, 135, '2015-02-01 00:16:47.000000', 'consum', 0.0210, 'lps'),
	(680886, 135, '2015-02-01 00:16:48.000000', 'consum', 0.0241, 'lps'),
	(680887, 135, '2015-02-01 00:16:49.000000', 'consum', 0.0259, 'lps'),
	(680888, 135, '2015-02-01 00:16:50.000000', 'consum', 0.0257, 'lps'),
	(680889, 135, '2015-02-01 00:16:51.000000', 'consum', 0.0245, 'lps'),
	(680890, 135, '2015-02-01 00:16:52.000000', 'consum', 0.0247, 'lps'),
	(680891, 135, '2015-02-01 00:16:53.000000', 'consum', 0.0234, 'lps'),
	(680892, 135, '2015-02-01 00:16:54.000000', 'consum', 0.0221, 'lps'),
	(680893, 135, '2015-02-01 00:16:55.000000', 'consum', 0.0244, 'lps'),
	(680894, 135, '2015-02-01 00:16:56.000000', 'consum', 0.0245, 'lps'),
	(680895, 135, '2015-02-01 00:16:57.000000', 'consum', 0.0228, 'lps'),
	(680896, 135, '2015-02-01 00:16:58.000000', 'consum', 0.0249, 'lps'),
	(680897, 135, '2015-02-01 00:16:59.000000', 'consum', 0.0245, 'lps'),
	(680898, 135, '2015-02-01 00:17:00.000000', 'consum', 0.0217, 'lps'),
	(680899, 135, '2015-02-01 00:17:01.000000', 'consum', 0.0248, 'lps'),
	(680900, 135, '2015-02-01 00:17:02.000000', 'consum', 0.0217, 'lps'),
	(680901, 135, '2015-02-01 00:17:03.000000', 'consum', 0.0239, 'lps'),
	(680902, 135, '2015-02-01 00:17:04.000000', 'consum', 0.0228, 'lps'),
	(680903, 135, '2015-02-01 00:17:05.000000', 'consum', 0.0215, 'lps'),
	(680904, 135, '2015-02-01 00:17:06.000000', 'consum', 0.0232, 'lps'),
	(680905, 135, '2015-02-01 00:17:07.000000', 'consum', 0.0252, 'lps'),
	(680906, 135, '2015-02-01 00:17:08.000000', 'consum', 0.0248, 'lps'),
	(680907, 135, '2015-02-01 00:17:09.000000', 'consum', 0.0224, 'lps'),
	(680908, 135, '2015-02-01 00:17:10.000000', 'consum', 0.0220, 'lps'),
	(680909, 135, '2015-02-01 00:17:11.000000', 'consum', 0.0218, 'lps'),
	(680910, 135, '2015-02-01 00:17:12.000000', 'consum', 0.0218, 'lps'),
	(680911, 135, '2015-02-01 00:17:13.000000', 'consum', 0.0230, 'lps'),
	(680912, 135, '2015-02-01 00:17:14.000000', 'consum', 0.0231, 'lps'),
	(680913, 135, '2015-02-01 00:17:15.000000', 'consum', 0.0255, 'lps'),
	(680914, 135, '2015-02-01 00:17:16.000000', 'consum', 0.0215, 'lps'),
	(680915, 135, '2015-02-01 00:17:17.000000', 'consum', 0.0258, 'lps'),
	(680916, 135, '2015-02-01 00:17:18.000000', 'consum', 0.0225, 'lps'),
	(680917, 135, '2015-02-01 00:17:19.000000', 'consum', 0.0245, 'lps'),
	(680918, 135, '2015-02-01 00:17:20.000000', 'consum', 0.0236, 'lps'),
	(680919, 135, '2015-02-01 00:17:21.000000', 'consum', 0.0236, 'lps'),
	(680920, 135, '2015-02-01 00:17:22.000000', 'consum', 0.0261, 'lps'),
	(680921, 135, '2015-02-01 00:17:23.000000', 'consum', 0.0229, 'lps'),
	(680922, 135, '2015-02-01 00:17:24.000000', 'consum', 0.0260, 'lps'),
	(680923, 135, '2015-02-01 00:17:25.000000', 'consum', 0.0245, 'lps'),
	(680924, 135, '2015-02-01 00:17:26.000000', 'consum', 0.0235, 'lps'),
	(680925, 135, '2015-02-01 00:17:27.000000', 'consum', 0.0232, 'lps'),
	(680926, 135, '2015-02-01 00:17:28.000000', 'consum', 0.0245, 'lps'),
	(680927, 135, '2015-02-01 00:17:29.000000', 'consum', 0.0213, 'lps'),
	(680928, 135, '2015-02-01 00:17:30.000000', 'consum', 0.0226, 'lps'),
	(680929, 135, '2015-02-01 00:17:31.000000', 'consum', 0.0229, 'lps'),
	(680930, 135, '2015-02-01 00:17:32.000000', 'consum', 0.0258, 'lps'),
	(680931, 135, '2015-02-01 00:17:33.000000', 'consum', 0.0234, 'lps'),
	(680932, 135, '2015-02-01 00:17:34.000000', 'consum', 0.0242, 'lps'),
	(680933, 135, '2015-02-01 00:17:35.000000', 'consum', 0.0242, 'lps'),
	(680934, 135, '2015-02-01 00:17:36.000000', 'consum', 0.0223, 'lps'),
	(680935, 135, '2015-02-01 00:17:37.000000', 'consum', 0.0234, 'lps'),
	(680936, 135, '2015-02-01 00:17:38.000000', 'consum', 0.0239, 'lps'),
	(680937, 135, '2015-02-01 00:17:39.000000', 'consum', 0.0229, 'lps'),
	(680938, 135, '2015-02-01 00:17:40.000000', 'consum', 0.0220, 'lps'),
	(680939, 135, '2015-02-01 00:17:41.000000', 'consum', 0.0255, 'lps'),
	(680940, 135, '2015-02-01 00:17:42.000000', 'consum', 0.0246, 'lps'),
	(680941, 135, '2015-02-01 00:17:43.000000', 'consum', 0.0258, 'lps'),
	(680942, 135, '2015-02-01 00:17:44.000000', 'consum', 0.0236, 'lps'),
	(680943, 135, '2015-02-01 00:17:45.000000', 'consum', 0.0248, 'lps'),
	(680944, 135, '2015-02-01 00:17:46.000000', 'consum', 0.0216, 'lps'),
	(680945, 135, '2015-02-01 00:17:47.000000', 'consum', 0.0232, 'lps'),
	(680946, 135, '2015-02-01 00:17:48.000000', 'consum', 0.0251, 'lps'),
	(680947, 135, '2015-02-01 00:17:49.000000', 'consum', 0.0241, 'lps'),
	(680948, 135, '2015-02-01 00:17:50.000000', 'consum', 0.0244, 'lps'),
	(680949, 135, '2015-02-01 00:17:51.000000', 'consum', 0.0235, 'lps'),
	(680950, 135, '2015-02-01 00:17:52.000000', 'consum', 0.0234, 'lps'),
	(680951, 135, '2015-02-01 00:17:53.000000', 'consum', 0.0255, 'lps'),
	(680952, 135, '2015-02-01 00:17:54.000000', 'consum', 0.0259, 'lps'),
	(680953, 135, '2015-02-01 00:17:55.000000', 'consum', 0.0214, 'lps'),
	(680954, 135, '2015-02-01 00:17:56.000000', 'consum', 0.0241, 'lps'),
	(680955, 135, '2015-02-01 00:17:57.000000', 'consum', 0.0246, 'lps'),
	(680956, 135, '2015-02-01 00:17:58.000000', 'consum', 0.0247, 'lps'),
	(680957, 135, '2015-02-01 00:17:59.000000', 'consum', 0.0232, 'lps'),
	(680958, 135, '2015-02-01 00:18:00.000000', 'consum', 0.0210, 'lps'),
	(680959, 135, '2015-02-01 00:18:01.000000', 'consum', 0.0252, 'lps'),
	(680960, 135, '2015-02-01 00:18:02.000000', 'consum', 0.0260, 'lps'),
	(680961, 135, '2015-02-01 00:18:03.000000', 'consum', 0.0228, 'lps'),
	(680962, 135, '2015-02-01 00:18:04.000000', 'consum', 0.0259, 'lps'),
	(680963, 135, '2015-02-01 00:18:05.000000', 'consum', 0.0243, 'lps'),
	(680964, 135, '2015-02-01 00:18:06.000000', 'consum', 0.0225, 'lps'),
	(680965, 135, '2015-02-01 00:18:07.000000', 'consum', 0.0243, 'lps'),
	(680966, 135, '2015-02-01 00:18:08.000000', 'consum', 0.0223, 'lps'),
	(680967, 135, '2015-02-01 00:18:09.000000', 'consum', 0.0228, 'lps'),
	(680968, 135, '2015-02-01 00:18:10.000000', 'consum', 0.0262, 'lps'),
	(680969, 135, '2015-02-01 00:18:11.000000', 'consum', 0.0260, 'lps'),
	(680970, 135, '2015-02-01 00:18:12.000000', 'consum', 0.0249, 'lps'),
	(680971, 135, '2015-02-01 00:18:13.000000', 'consum', 0.0257, 'lps'),
	(680972, 135, '2015-02-01 00:18:14.000000', 'consum', 0.0223, 'lps'),
	(680973, 135, '2015-02-01 00:18:15.000000', 'consum', 0.0241, 'lps'),
	(680974, 135, '2015-02-01 00:18:16.000000', 'consum', 0.0221, 'lps'),
	(680975, 135, '2015-02-01 00:18:17.000000', 'consum', 0.0224, 'lps'),
	(680976, 135, '2015-02-01 00:18:18.000000', 'consum', 0.0250, 'lps'),
	(680977, 135, '2015-02-01 00:18:19.000000', 'consum', 0.0260, 'lps'),
	(680978, 135, '2015-02-01 00:18:20.000000', 'consum', 0.0235, 'lps'),
	(680979, 135, '2015-02-01 00:18:21.000000', 'consum', 0.0239, 'lps'),
	(680980, 135, '2015-02-01 00:18:22.000000', 'consum', 0.0226, 'lps'),
	(680981, 135, '2015-02-01 00:18:23.000000', 'consum', 0.0256, 'lps'),
	(680982, 135, '2015-02-01 00:18:24.000000', 'consum', 0.0235, 'lps'),
	(680983, 135, '2015-02-01 00:18:25.000000', 'consum', 0.0251, 'lps'),
	(680984, 135, '2015-02-01 00:18:26.000000', 'consum', 0.0232, 'lps'),
	(680985, 135, '2015-02-01 00:18:27.000000', 'consum', 0.0253, 'lps'),
	(680986, 135, '2015-02-01 00:18:28.000000', 'consum', 0.0251, 'lps'),
	(680987, 135, '2015-02-01 00:18:29.000000', 'consum', 0.0234, 'lps'),
	(680988, 135, '2015-02-01 00:18:30.000000', 'consum', 0.0261, 'lps'),
	(680989, 135, '2015-02-01 00:18:31.000000', 'consum', 0.0234, 'lps'),
	(680990, 135, '2015-02-01 00:18:32.000000', 'consum', 0.0230, 'lps'),
	(680991, 135, '2015-02-01 00:18:33.000000', 'consum', 0.0240, 'lps'),
	(680992, 135, '2015-02-01 00:18:34.000000', 'consum', 0.0246, 'lps'),
	(680993, 135, '2015-02-01 00:18:35.000000', 'consum', 0.0249, 'lps'),
	(680994, 135, '2015-02-01 00:18:36.000000', 'consum', 0.0242, 'lps'),
	(680995, 135, '2015-02-01 00:18:37.000000', 'consum', 0.0257, 'lps'),
	(680996, 135, '2015-02-01 00:18:38.000000', 'consum', 0.0241, 'lps'),
	(680997, 135, '2015-02-01 00:18:39.000000', 'consum', 0.0227, 'lps'),
	(680998, 135, '2015-02-01 00:18:40.000000', 'consum', 0.0253, 'lps'),
	(680999, 135, '2015-02-01 00:18:41.000000', 'consum', 0.0216, 'lps'),
	(681000, 135, '2015-02-01 00:18:42.000000', 'consum', 0.0220, 'lps'),
	(681001, 135, '2015-02-01 00:18:43.000000', 'consum', 0.0240, 'lps'),
	(681002, 135, '2015-02-01 00:18:44.000000', 'consum', 0.0226, 'lps'),
	(681003, 135, '2015-02-01 00:18:45.000000', 'consum', 0.0255, 'lps'),
	(681004, 135, '2015-02-01 00:18:46.000000', 'consum', 0.0225, 'lps'),
	(681005, 135, '2015-02-01 00:18:47.000000', 'consum', 0.0258, 'lps'),
	(681006, 135, '2015-02-01 00:18:48.000000', 'consum', 0.0247, 'lps'),
	(681007, 135, '2015-02-01 00:18:49.000000', 'consum', 0.0251, 'lps'),
	(681008, 135, '2015-02-01 00:18:50.000000', 'consum', 0.0251, 'lps'),
	(681009, 135, '2015-02-01 00:18:51.000000', 'consum', 0.0239, 'lps'),
	(681010, 135, '2015-02-01 00:18:52.000000', 'consum', 0.0234, 'lps'),
	(681011, 135, '2015-02-01 00:18:53.000000', 'consum', 0.0242, 'lps'),
	(681012, 135, '2015-02-01 00:18:54.000000', 'consum', 0.0245, 'lps'),
	(681013, 135, '2015-02-01 00:18:55.000000', 'consum', 0.0236, 'lps'),
	(681014, 135, '2015-02-01 00:18:56.000000', 'consum', 0.0235, 'lps'),
	(681015, 135, '2015-02-01 00:18:57.000000', 'consum', 0.0257, 'lps'),
	(681016, 135, '2015-02-01 00:18:58.000000', 'consum', 0.0213, 'lps'),
	(681017, 135, '2015-02-01 00:18:59.000000', 'consum', 0.0244, 'lps'),
	(681018, 135, '2015-02-01 00:19:00.000000', 'consum', 0.0213, 'lps'),
	(681019, 135, '2015-02-01 00:19:01.000000', 'consum', 0.0229, 'lps'),
	(681020, 135, '2015-02-01 00:19:02.000000', 'consum', 0.0243, 'lps'),
	(681021, 135, '2015-02-01 00:19:03.000000', 'consum', 0.0215, 'lps'),
	(681022, 135, '2015-02-01 00:19:04.000000', 'consum', 0.0240, 'lps'),
	(681023, 135, '2015-02-01 00:19:05.000000', 'consum', 0.0240, 'lps'),
	(681024, 135, '2015-02-01 00:19:06.000000', 'consum', 0.0217, 'lps'),
	(681025, 135, '2015-02-01 00:19:07.000000', 'consum', 0.0210, 'lps'),
	(681026, 135, '2015-02-01 00:19:08.000000', 'consum', 0.0241, 'lps'),
	(681027, 135, '2015-02-01 00:19:09.000000', 'consum', 0.0260, 'lps'),
	(681028, 135, '2015-02-01 00:19:10.000000', 'consum', 0.0210, 'lps'),
	(681029, 135, '2015-02-01 00:19:11.000000', 'consum', 0.0219, 'lps'),
	(681030, 135, '2015-02-01 00:19:12.000000', 'consum', 0.0254, 'lps'),
	(681031, 135, '2015-02-01 00:19:13.000000', 'consum', 0.0246, 'lps'),
	(681032, 135, '2015-02-01 00:19:14.000000', 'consum', 0.0260, 'lps'),
	(681033, 135, '2015-02-01 00:19:15.000000', 'consum', 0.0243, 'lps'),
	(681034, 135, '2015-02-01 00:19:16.000000', 'consum', 0.0228, 'lps'),
	(681035, 135, '2015-02-01 00:19:17.000000', 'consum', 0.0254, 'lps'),
	(681036, 135, '2015-02-01 00:19:18.000000', 'consum', 0.0218, 'lps'),
	(681037, 135, '2015-02-01 00:19:19.000000', 'consum', 0.0224, 'lps'),
	(681038, 135, '2015-02-01 00:19:20.000000', 'consum', 0.0259, 'lps'),
	(681039, 135, '2015-02-01 00:19:21.000000', 'consum', 0.0251, 'lps'),
	(681040, 135, '2015-02-01 00:19:22.000000', 'consum', 0.0217, 'lps'),
	(681041, 135, '2015-02-01 00:19:23.000000', 'consum', 0.0227, 'lps'),
	(681042, 135, '2015-02-01 00:19:24.000000', 'consum', 0.0223, 'lps'),
	(681043, 135, '2015-02-01 00:19:25.000000', 'consum', 0.0225, 'lps'),
	(681044, 135, '2015-02-01 00:19:26.000000', 'consum', 0.0244, 'lps'),
	(681045, 135, '2015-02-01 00:19:27.000000', 'consum', 0.0232, 'lps'),
	(681046, 135, '2015-02-01 00:19:28.000000', 'consum', 0.0219, 'lps'),
	(681047, 135, '2015-02-01 00:19:29.000000', 'consum', 0.0242, 'lps'),
	(681048, 135, '2015-02-01 00:19:30.000000', 'consum', 0.0237, 'lps'),
	(681049, 135, '2015-02-01 00:19:31.000000', 'consum', 0.0250, 'lps'),
	(681050, 135, '2015-02-01 00:19:32.000000', 'consum', 0.0222, 'lps'),
	(681051, 135, '2015-02-01 00:19:33.000000', 'consum', 0.0258, 'lps'),
	(681052, 135, '2015-02-01 00:19:34.000000', 'consum', 0.0254, 'lps'),
	(681053, 135, '2015-02-01 00:19:35.000000', 'consum', 0.0234, 'lps'),
	(681054, 135, '2015-02-01 00:19:36.000000', 'consum', 0.0250, 'lps'),
	(681055, 135, '2015-02-01 00:19:37.000000', 'consum', 0.0236, 'lps'),
	(681056, 135, '2015-02-01 00:19:38.000000', 'consum', 0.0218, 'lps'),
	(681057, 135, '2015-02-01 00:19:39.000000', 'consum', 0.0226, 'lps'),
	(681058, 135, '2015-02-01 00:19:40.000000', 'consum', 0.0212, 'lps'),
	(681059, 135, '2015-02-01 00:19:41.000000', 'consum', 0.0227, 'lps'),
	(681060, 135, '2015-02-01 00:19:42.000000', 'consum', 0.0234, 'lps'),
	(681061, 135, '2015-02-01 00:19:43.000000', 'consum', 0.0230, 'lps'),
	(681062, 135, '2015-02-01 00:19:44.000000', 'consum', 0.0237, 'lps'),
	(681063, 135, '2015-02-01 00:19:45.000000', 'consum', 0.0235, 'lps'),
	(681064, 135, '2015-02-01 00:19:46.000000', 'consum', 0.0251, 'lps'),
	(681065, 135, '2015-02-01 00:19:47.000000', 'consum', 0.0235, 'lps'),
	(681066, 135, '2015-02-01 00:19:48.000000', 'consum', 0.0211, 'lps'),
	(681067, 135, '2015-02-01 00:19:49.000000', 'consum', 0.0249, 'lps'),
	(681068, 135, '2015-02-01 00:19:50.000000', 'consum', 0.0242, 'lps'),
	(681069, 135, '2015-02-01 00:19:51.000000', 'consum', 0.0252, 'lps'),
	(681070, 135, '2015-02-01 00:19:52.000000', 'consum', 0.0222, 'lps'),
	(681071, 135, '2015-02-01 00:19:53.000000', 'consum', 0.0249, 'lps'),
	(681072, 135, '2015-02-01 00:19:54.000000', 'consum', 0.0262, 'lps'),
	(681073, 135, '2015-02-01 00:19:55.000000', 'consum', 0.0249, 'lps'),
	(681074, 135, '2015-02-01 00:19:56.000000', 'consum', 0.0248, 'lps'),
	(681075, 135, '2015-02-01 00:19:57.000000', 'consum', 0.0231, 'lps'),
	(681076, 135, '2015-02-01 00:19:58.000000', 'consum', 0.0257, 'lps'),
	(681077, 135, '2015-02-01 00:19:59.000000', 'consum', 0.0220, 'lps'),
	(681078, 135, '2015-02-01 00:20:00.000000', 'consum', 0.0226, 'lps'),
	(681079, 135, '2015-02-01 00:20:01.000000', 'consum', 0.0261, 'lps'),
	(681080, 135, '2015-02-01 00:20:02.000000', 'consum', 0.0258, 'lps'),
	(681081, 135, '2015-02-01 00:20:03.000000', 'consum', 0.0244, 'lps'),
	(681082, 135, '2015-02-01 00:20:04.000000', 'consum', 0.0236, 'lps'),
	(681083, 135, '2015-02-01 00:20:05.000000', 'consum', 0.0240, 'lps'),
	(681084, 135, '2015-02-01 00:20:06.000000', 'consum', 0.0230, 'lps'),
	(681085, 135, '2015-02-01 00:20:07.000000', 'consum', 0.0218, 'lps'),
	(681086, 135, '2015-02-01 00:20:08.000000', 'consum', 0.0244, 'lps'),
	(681087, 135, '2015-02-01 00:20:09.000000', 'consum', 0.0251, 'lps'),
	(681088, 135, '2015-02-01 00:20:10.000000', 'consum', 0.0262, 'lps'),
	(681089, 135, '2015-02-01 00:20:11.000000', 'consum', 0.0240, 'lps'),
	(681090, 135, '2015-02-01 00:20:12.000000', 'consum', 0.0259, 'lps'),
	(681091, 135, '2015-02-01 00:20:13.000000', 'consum', 0.0258, 'lps'),
	(681092, 135, '2015-02-01 00:20:14.000000', 'consum', 0.0253, 'lps'),
	(681093, 135, '2015-02-01 00:20:15.000000', 'consum', 0.0226, 'lps'),
	(681094, 135, '2015-02-01 00:20:16.000000', 'consum', 0.0217, 'lps'),
	(681095, 135, '2015-02-01 00:20:17.000000', 'consum', 0.0250, 'lps'),
	(681096, 135, '2015-02-01 00:20:18.000000', 'consum', 0.0229, 'lps'),
	(681097, 135, '2015-02-01 00:20:19.000000', 'consum', 0.0240, 'lps'),
	(681098, 135, '2015-02-01 00:20:20.000000', 'consum', 0.0251, 'lps'),
	(681099, 135, '2015-02-01 00:20:21.000000', 'consum', 0.0218, 'lps'),
	(681100, 135, '2015-02-01 00:20:22.000000', 'consum', 0.0235, 'lps'),
	(681101, 135, '2015-02-01 00:20:23.000000', 'consum', 0.0257, 'lps'),
	(681102, 135, '2015-02-01 00:20:24.000000', 'consum', 0.0211, 'lps'),
	(681103, 135, '2015-02-01 00:20:25.000000', 'consum', 0.0236, 'lps'),
	(681104, 135, '2015-02-01 00:20:26.000000', 'consum', 0.0231, 'lps'),
	(681105, 135, '2015-02-01 00:20:27.000000', 'consum', 0.0239, 'lps'),
	(681106, 135, '2015-02-01 00:20:28.000000', 'consum', 0.0238, 'lps'),
	(681107, 135, '2015-02-01 00:20:29.000000', 'consum', 0.0212, 'lps'),
	(681108, 135, '2015-02-01 00:20:30.000000', 'consum', 0.0243, 'lps'),
	(681109, 135, '2015-02-01 00:20:31.000000', 'consum', 0.0262, 'lps'),
	(681110, 135, '2015-02-01 00:20:32.000000', 'consum', 0.0213, 'lps'),
	(681111, 135, '2015-02-01 00:20:33.000000', 'consum', 0.0228, 'lps'),
	(681112, 135, '2015-02-01 00:20:34.000000', 'consum', 0.0238, 'lps'),
	(681113, 135, '2015-02-01 00:20:35.000000', 'consum', 0.0245, 'lps'),
	(681114, 135, '2015-02-01 00:20:36.000000', 'consum', 0.0250, 'lps'),
	(681115, 135, '2015-02-01 00:20:37.000000', 'consum', 0.0250, 'lps'),
	(681116, 135, '2015-02-01 00:20:38.000000', 'consum', 0.0236, 'lps'),
	(681117, 135, '2015-02-01 00:20:39.000000', 'consum', 0.0223, 'lps'),
	(681118, 135, '2015-02-01 00:20:40.000000', 'consum', 0.0248, 'lps'),
	(681119, 135, '2015-02-01 00:20:41.000000', 'consum', 0.0256, 'lps'),
	(681120, 135, '2015-02-01 00:20:42.000000', 'consum', 0.0223, 'lps'),
	(681121, 135, '2015-02-01 00:20:43.000000', 'consum', 0.0241, 'lps'),
	(681122, 135, '2015-02-01 00:20:44.000000', 'consum', 0.0222, 'lps'),
	(681123, 135, '2015-02-01 00:20:45.000000', 'consum', 0.0229, 'lps'),
	(681124, 135, '2015-02-01 00:20:46.000000', 'consum', 0.0219, 'lps'),
	(681125, 135, '2015-02-01 00:20:47.000000', 'consum', 0.0252, 'lps'),
	(681126, 135, '2015-02-01 00:20:48.000000', 'consum', 0.0232, 'lps'),
	(681127, 135, '2015-02-01 00:20:49.000000', 'consum', 0.0247, 'lps'),
	(681128, 135, '2015-02-01 00:20:50.000000', 'consum', 0.0226, 'lps'),
	(681129, 135, '2015-02-01 00:20:51.000000', 'consum', 0.0230, 'lps'),
	(681130, 135, '2015-02-01 00:20:52.000000', 'consum', 0.0262, 'lps'),
	(681131, 135, '2015-02-01 00:20:53.000000', 'consum', 0.0251, 'lps'),
	(681132, 135, '2015-02-01 00:20:54.000000', 'consum', 0.0261, 'lps'),
	(681133, 135, '2015-02-01 00:20:55.000000', 'consum', 0.0236, 'lps'),
	(681134, 135, '2015-02-01 00:20:56.000000', 'consum', 0.0242, 'lps'),
	(681135, 135, '2015-02-01 00:20:57.000000', 'consum', 0.0240, 'lps'),
	(681136, 135, '2015-02-01 00:20:58.000000', 'consum', 0.0211, 'lps'),
	(681137, 135, '2015-02-01 00:20:59.000000', 'consum', 0.0233, 'lps'),
	(681138, 135, '2015-02-01 00:21:00.000000', 'consum', 0.0213, 'lps'),
	(681139, 135, '2015-02-01 00:21:01.000000', 'consum', 0.0212, 'lps'),
	(681140, 135, '2015-02-01 00:21:02.000000', 'consum', 0.0211, 'lps'),
	(681141, 135, '2015-02-01 00:21:03.000000', 'consum', 0.0210, 'lps'),
	(681142, 135, '2015-02-01 00:21:04.000000', 'consum', 0.0258, 'lps'),
	(681143, 135, '2015-02-01 00:21:05.000000', 'consum', 0.0242, 'lps'),
	(681144, 135, '2015-02-01 00:21:06.000000', 'consum', 0.0225, 'lps'),
	(681145, 135, '2015-02-01 00:21:07.000000', 'consum', 0.0243, 'lps'),
	(681146, 135, '2015-02-01 00:21:08.000000', 'consum', 0.0223, 'lps'),
	(681147, 135, '2015-02-01 00:21:09.000000', 'consum', 0.0231, 'lps'),
	(681148, 135, '2015-02-01 00:21:10.000000', 'consum', 0.0221, 'lps'),
	(681149, 135, '2015-02-01 00:21:11.000000', 'consum', 0.0257, 'lps'),
	(681150, 135, '2015-02-01 00:21:12.000000', 'consum', 0.0253, 'lps'),
	(681151, 135, '2015-02-01 00:21:13.000000', 'consum', 0.0231, 'lps'),
	(681152, 135, '2015-02-01 00:21:14.000000', 'consum', 0.0241, 'lps'),
	(681153, 135, '2015-02-01 00:21:15.000000', 'consum', 0.0248, 'lps'),
	(681154, 135, '2015-02-01 00:21:16.000000', 'consum', 0.0257, 'lps'),
	(681155, 135, '2015-02-01 00:21:17.000000', 'consum', 0.0224, 'lps'),
	(681156, 135, '2015-02-01 00:21:18.000000', 'consum', 0.0244, 'lps'),
	(681157, 135, '2015-02-01 00:21:19.000000', 'consum', 0.0233, 'lps'),
	(681158, 135, '2015-02-01 00:21:20.000000', 'consum', 0.0223, 'lps'),
	(681159, 135, '2015-02-01 00:21:21.000000', 'consum', 0.0262, 'lps'),
	(681160, 135, '2015-02-01 00:21:22.000000', 'consum', 0.0219, 'lps'),
	(681161, 135, '2015-02-01 00:21:23.000000', 'consum', 0.0258, 'lps'),
	(681162, 135, '2015-02-01 00:21:24.000000', 'consum', 0.0213, 'lps'),
	(681163, 135, '2015-02-01 00:21:25.000000', 'consum', 0.0241, 'lps'),
	(681164, 135, '2015-02-01 00:21:26.000000', 'consum', 0.0247, 'lps'),
	(681165, 135, '2015-02-01 00:21:27.000000', 'consum', 0.0253, 'lps'),
	(681166, 135, '2015-02-01 00:21:28.000000', 'consum', 0.0258, 'lps'),
	(681167, 135, '2015-02-01 00:21:29.000000', 'consum', 0.0218, 'lps'),
	(681168, 135, '2015-02-01 00:21:30.000000', 'consum', 0.0210, 'lps'),
	(681169, 135, '2015-02-01 00:21:31.000000', 'consum', 0.0240, 'lps'),
	(681170, 135, '2015-02-01 00:21:32.000000', 'consum', 0.0254, 'lps'),
	(681171, 135, '2015-02-01 00:21:33.000000', 'consum', 0.0236, 'lps'),
	(681172, 135, '2015-02-01 00:21:34.000000', 'consum', 0.0260, 'lps'),
	(681173, 135, '2015-02-01 00:21:35.000000', 'consum', 0.0225, 'lps'),
	(681174, 135, '2015-02-01 00:21:36.000000', 'consum', 0.0242, 'lps'),
	(681175, 135, '2015-02-01 00:21:37.000000', 'consum', 0.0217, 'lps'),
	(681176, 135, '2015-02-01 00:21:38.000000', 'consum', 0.0256, 'lps'),
	(681177, 135, '2015-02-01 00:21:39.000000', 'consum', 0.0261, 'lps'),
	(681178, 135, '2015-02-01 00:21:40.000000', 'consum', 0.0220, 'lps'),
	(681179, 135, '2015-02-01 00:21:41.000000', 'consum', 0.0215, 'lps'),
	(681180, 135, '2015-02-01 00:21:42.000000', 'consum', 0.0258, 'lps'),
	(681181, 135, '2015-02-01 00:21:43.000000', 'consum', 0.0224, 'lps'),
	(681182, 135, '2015-02-01 00:21:44.000000', 'consum', 0.0240, 'lps'),
	(681183, 135, '2015-02-01 00:21:45.000000', 'consum', 0.0215, 'lps'),
	(681184, 135, '2015-02-01 00:21:46.000000', 'consum', 0.0251, 'lps'),
	(681185, 135, '2015-02-01 00:21:47.000000', 'consum', 0.0242, 'lps'),
	(681186, 135, '2015-02-01 00:21:48.000000', 'consum', 0.0245, 'lps'),
	(681187, 135, '2015-02-01 00:21:49.000000', 'consum', 0.0240, 'lps'),
	(681188, 135, '2015-02-01 00:21:50.000000', 'consum', 0.0254, 'lps'),
	(681189, 135, '2015-02-01 00:21:51.000000', 'consum', 0.0236, 'lps'),
	(681190, 135, '2015-02-01 00:21:52.000000', 'consum', 0.0262, 'lps'),
	(681191, 135, '2015-02-01 00:21:53.000000', 'consum', 0.0234, 'lps'),
	(681192, 135, '2015-02-01 00:21:54.000000', 'consum', 0.0228, 'lps'),
	(681193, 135, '2015-02-01 00:21:55.000000', 'consum', 0.0227, 'lps'),
	(681194, 135, '2015-02-01 00:21:56.000000', 'consum', 0.0241, 'lps'),
	(681195, 135, '2015-02-01 00:21:57.000000', 'consum', 0.0260, 'lps'),
	(681196, 135, '2015-02-01 00:21:58.000000', 'consum', 0.0210, 'lps'),
	(681197, 135, '2015-02-01 00:21:59.000000', 'consum', 0.0219, 'lps'),
	(681198, 135, '2015-02-01 00:22:00.000000', 'consum', 0.0257, 'lps'),
	(681199, 135, '2015-02-01 00:22:01.000000', 'consum', 0.0259, 'lps'),
	(681200, 135, '2015-02-01 00:22:02.000000', 'consum', 0.0210, 'lps'),
	(681201, 135, '2015-02-01 00:22:03.000000', 'consum', 0.0223, 'lps'),
	(681202, 135, '2015-02-01 00:22:04.000000', 'consum', 0.0220, 'lps'),
	(681203, 135, '2015-02-01 00:22:05.000000', 'consum', 0.0222, 'lps'),
	(681204, 135, '2015-02-01 00:22:06.000000', 'consum', 0.0241, 'lps'),
	(681205, 135, '2015-02-01 00:22:07.000000', 'consum', 0.0224, 'lps'),
	(681206, 135, '2015-02-01 00:22:08.000000', 'consum', 0.0242, 'lps'),
	(681207, 135, '2015-02-01 00:22:09.000000', 'consum', 0.0221, 'lps'),
	(681208, 135, '2015-02-01 00:22:10.000000', 'consum', 0.0224, 'lps'),
	(681209, 135, '2015-02-01 00:22:11.000000', 'consum', 0.0248, 'lps'),
	(681210, 135, '2015-02-01 00:22:12.000000', 'consum', 0.0251, 'lps'),
	(681211, 135, '2015-02-01 00:22:13.000000', 'consum', 0.0248, 'lps'),
	(681212, 135, '2015-02-01 00:22:14.000000', 'consum', 0.0227, 'lps'),
	(681213, 135, '2015-02-01 00:22:15.000000', 'consum', 0.0234, 'lps'),
	(681214, 135, '2015-02-01 00:22:16.000000', 'consum', 0.0226, 'lps'),
	(681215, 135, '2015-02-01 00:22:17.000000', 'consum', 0.0218, 'lps'),
	(681216, 135, '2015-02-01 00:22:18.000000', 'consum', 0.0257, 'lps'),
	(681217, 135, '2015-02-01 00:22:19.000000', 'consum', 0.0262, 'lps'),
	(681218, 135, '2015-02-01 00:22:20.000000', 'consum', 0.0224, 'lps'),
	(681219, 135, '2015-02-01 00:22:21.000000', 'consum', 0.0229, 'lps'),
	(681220, 135, '2015-02-01 00:22:22.000000', 'consum', 0.0211, 'lps'),
	(681221, 135, '2015-02-01 00:22:23.000000', 'consum', 0.0213, 'lps'),
	(681222, 135, '2015-02-01 00:22:24.000000', 'consum', 0.0223, 'lps'),
	(681223, 135, '2015-02-01 00:22:25.000000', 'consum', 0.0212, 'lps'),
	(681224, 135, '2015-02-01 00:22:26.000000', 'consum', 0.0236, 'lps'),
	(681225, 135, '2015-02-01 00:22:27.000000', 'consum', 0.0227, 'lps'),
	(681226, 135, '2015-02-01 00:22:28.000000', 'consum', 0.0218, 'lps'),
	(681227, 135, '2015-02-01 00:22:29.000000', 'consum', 0.0252, 'lps'),
	(681228, 135, '2015-02-01 00:22:30.000000', 'consum', 0.0237, 'lps'),
	(681229, 135, '2015-02-01 00:22:31.000000', 'consum', 0.0218, 'lps'),
	(681230, 135, '2015-02-01 00:22:32.000000', 'consum', 0.0225, 'lps'),
	(681231, 135, '2015-02-01 00:22:33.000000', 'consum', 0.0261, 'lps'),
	(681232, 135, '2015-02-01 00:22:34.000000', 'consum', 0.0261, 'lps'),
	(681233, 135, '2015-02-01 00:22:35.000000', 'consum', 0.0258, 'lps'),
	(681234, 135, '2015-02-01 00:22:36.000000', 'consum', 0.0245, 'lps'),
	(681235, 135, '2015-02-01 00:22:37.000000', 'consum', 0.0243, 'lps'),
	(681236, 135, '2015-02-01 00:22:38.000000', 'consum', 0.0215, 'lps'),
	(681237, 135, '2015-02-01 00:22:39.000000', 'consum', 0.0243, 'lps'),
	(681238, 135, '2015-02-01 00:22:40.000000', 'consum', 0.0255, 'lps'),
	(681239, 135, '2015-02-01 00:22:41.000000', 'consum', 0.0231, 'lps'),
	(681240, 135, '2015-02-01 00:22:42.000000', 'consum', 0.0234, 'lps'),
	(681241, 135, '2015-02-01 00:22:43.000000', 'consum', 0.0213, 'lps'),
	(681242, 135, '2015-02-01 00:22:44.000000', 'consum', 0.0258, 'lps'),
	(681243, 135, '2015-02-01 00:22:45.000000', 'consum', 0.0233, 'lps'),
	(681244, 135, '2015-02-01 00:22:46.000000', 'consum', 0.0233, 'lps'),
	(681245, 135, '2015-02-01 00:22:47.000000', 'consum', 0.0257, 'lps'),
	(681246, 135, '2015-02-01 00:22:48.000000', 'consum', 0.0219, 'lps'),
	(681247, 135, '2015-02-01 00:22:49.000000', 'consum', 0.0221, 'lps'),
	(681248, 135, '2015-02-01 00:22:50.000000', 'consum', 0.0236, 'lps'),
	(681249, 135, '2015-02-01 00:22:51.000000', 'consum', 0.0256, 'lps'),
	(681250, 135, '2015-02-01 00:22:52.000000', 'consum', 0.0254, 'lps'),
	(681251, 135, '2015-02-01 00:22:53.000000', 'consum', 0.0243, 'lps'),
	(681252, 135, '2015-02-01 00:22:54.000000', 'consum', 0.0241, 'lps'),
	(681253, 135, '2015-02-01 00:22:55.000000', 'consum', 0.0215, 'lps'),
	(681254, 135, '2015-02-01 00:22:56.000000', 'consum', 0.0246, 'lps'),
	(681255, 135, '2015-02-01 00:22:57.000000', 'consum', 0.0219, 'lps'),
	(681256, 135, '2015-02-01 00:22:58.000000', 'consum', 0.0252, 'lps'),
	(681257, 135, '2015-02-01 00:22:59.000000', 'consum', 0.0233, 'lps'),
	(681258, 135, '2015-02-01 00:23:00.000000', 'consum', 0.0256, 'lps'),
	(681259, 135, '2015-02-01 00:23:01.000000', 'consum', 0.0210, 'lps'),
	(681260, 135, '2015-02-01 00:23:02.000000', 'consum', 0.0233, 'lps'),
	(681261, 135, '2015-02-01 00:23:03.000000', 'consum', 0.0219, 'lps'),
	(681262, 135, '2015-02-01 00:23:04.000000', 'consum', 0.0238, 'lps'),
	(681263, 135, '2015-02-01 00:23:05.000000', 'consum', 0.0220, 'lps'),
	(681264, 135, '2015-02-01 00:23:06.000000', 'consum', 0.0227, 'lps'),
	(681265, 135, '2015-02-01 00:23:07.000000', 'consum', 0.0216, 'lps'),
	(681266, 135, '2015-02-01 00:23:08.000000', 'consum', 0.0239, 'lps'),
	(681267, 135, '2015-02-01 00:23:09.000000', 'consum', 0.0233, 'lps'),
	(681268, 135, '2015-02-01 00:23:10.000000', 'consum', 0.0238, 'lps'),
	(681269, 135, '2015-02-01 00:23:11.000000', 'consum', 0.0230, 'lps'),
	(681270, 135, '2015-02-01 00:23:12.000000', 'consum', 0.0227, 'lps'),
	(681271, 135, '2015-02-01 00:23:13.000000', 'consum', 0.0234, 'lps'),
	(681272, 135, '2015-02-01 00:23:14.000000', 'consum', 0.0229, 'lps'),
	(681273, 135, '2015-02-01 00:23:15.000000', 'consum', 0.0231, 'lps'),
	(681274, 135, '2015-02-01 00:23:16.000000', 'consum', 0.0257, 'lps'),
	(681275, 135, '2015-02-01 00:23:17.000000', 'consum', 0.0226, 'lps'),
	(681276, 135, '2015-02-01 00:23:18.000000', 'consum', 0.0256, 'lps'),
	(681277, 135, '2015-02-01 00:23:19.000000', 'consum', 0.0232, 'lps'),
	(681278, 135, '2015-02-01 00:23:20.000000', 'consum', 0.0234, 'lps'),
	(681279, 135, '2015-02-01 00:23:21.000000', 'consum', 0.0213, 'lps'),
	(681280, 135, '2015-02-01 00:23:22.000000', 'consum', 0.0257, 'lps'),
	(681281, 135, '2015-02-01 00:23:23.000000', 'consum', 0.0228, 'lps'),
	(681282, 135, '2015-02-01 00:23:24.000000', 'consum', 0.0211, 'lps'),
	(681283, 135, '2015-02-01 00:23:25.000000', 'consum', 0.0216, 'lps'),
	(681284, 135, '2015-02-01 00:23:26.000000', 'consum', 0.0235, 'lps'),
	(681285, 135, '2015-02-01 00:23:27.000000', 'consum', 0.0212, 'lps'),
	(681286, 135, '2015-02-01 00:23:28.000000', 'consum', 0.0253, 'lps'),
	(681287, 135, '2015-02-01 00:23:29.000000', 'consum', 0.0259, 'lps'),
	(681288, 135, '2015-02-01 00:23:30.000000', 'consum', 0.0222, 'lps'),
	(681289, 135, '2015-02-01 00:23:31.000000', 'consum', 0.0228, 'lps'),
	(681290, 135, '2015-02-01 00:23:32.000000', 'consum', 0.0212, 'lps'),
	(681291, 135, '2015-02-01 00:23:33.000000', 'consum', 0.0219, 'lps'),
	(681292, 135, '2015-02-01 00:23:34.000000', 'consum', 0.0251, 'lps'),
	(681293, 135, '2015-02-01 00:23:35.000000', 'consum', 0.0228, 'lps'),
	(681294, 135, '2015-02-01 00:23:36.000000', 'consum', 0.0233, 'lps'),
	(681295, 135, '2015-02-01 00:23:37.000000', 'consum', 0.0217, 'lps'),
	(681296, 135, '2015-02-01 00:23:38.000000', 'consum', 0.0230, 'lps'),
	(681297, 135, '2015-02-01 00:23:39.000000', 'consum', 0.0235, 'lps'),
	(681298, 135, '2015-02-01 00:23:40.000000', 'consum', 0.0223, 'lps'),
	(681299, 135, '2015-02-01 00:23:41.000000', 'consum', 0.0255, 'lps'),
	(681300, 135, '2015-02-01 00:23:42.000000', 'consum', 0.0235, 'lps'),
	(681301, 135, '2015-02-01 00:23:43.000000', 'consum', 0.0255, 'lps'),
	(681302, 135, '2015-02-01 00:23:44.000000', 'consum', 0.0255, 'lps'),
	(681303, 135, '2015-02-01 00:23:45.000000', 'consum', 0.0248, 'lps'),
	(681304, 135, '2015-02-01 00:23:46.000000', 'consum', 0.0211, 'lps'),
	(681305, 135, '2015-02-01 00:23:47.000000', 'consum', 0.0261, 'lps'),
	(681306, 135, '2015-02-01 00:23:48.000000', 'consum', 0.0251, 'lps'),
	(681307, 135, '2015-02-01 00:23:49.000000', 'consum', 0.0260, 'lps'),
	(681308, 135, '2015-02-01 00:23:50.000000', 'consum', 0.0234, 'lps'),
	(681309, 135, '2015-02-01 00:23:51.000000', 'consum', 0.0232, 'lps'),
	(681310, 135, '2015-02-01 00:23:52.000000', 'consum', 0.0250, 'lps'),
	(681311, 135, '2015-02-01 00:23:53.000000', 'consum', 0.0238, 'lps'),
	(681312, 135, '2015-02-01 00:23:54.000000', 'consum', 0.0232, 'lps'),
	(681313, 135, '2015-02-01 00:23:55.000000', 'consum', 0.0235, 'lps'),
	(681314, 135, '2015-02-01 00:23:56.000000', 'consum', 0.0215, 'lps'),
	(681315, 135, '2015-02-01 00:23:57.000000', 'consum', 0.0214, 'lps'),
	(681316, 135, '2015-02-01 00:23:58.000000', 'consum', 0.0216, 'lps'),
	(681317, 135, '2015-02-01 00:23:59.000000', 'consum', 0.0230, 'lps'),
	(681318, 135, '2015-02-01 00:24:00.000000', 'consum', 0.0237, 'lps'),
	(681319, 135, '2015-02-01 00:24:01.000000', 'consum', 0.0233, 'lps'),
	(681320, 135, '2015-02-01 00:24:02.000000', 'consum', 0.0244, 'lps'),
	(681321, 135, '2015-02-01 00:24:03.000000', 'consum', 0.0261, 'lps'),
	(681322, 135, '2015-02-01 00:24:04.000000', 'consum', 0.0254, 'lps'),
	(681323, 135, '2015-02-01 00:24:05.000000', 'consum', 0.0226, 'lps'),
	(681324, 135, '2015-02-01 00:24:06.000000', 'consum', 0.0213, 'lps'),
	(681325, 135, '2015-02-01 00:24:07.000000', 'consum', 0.0230, 'lps'),
	(681326, 135, '2015-02-01 00:24:08.000000', 'consum', 0.0247, 'lps'),
	(681327, 135, '2015-02-01 00:24:09.000000', 'consum', 0.0232, 'lps'),
	(681328, 135, '2015-02-01 00:24:10.000000', 'consum', 0.0262, 'lps'),
	(681329, 135, '2015-02-01 00:24:11.000000', 'consum', 0.0244, 'lps'),
	(681330, 135, '2015-02-01 00:24:12.000000', 'consum', 0.0224, 'lps'),
	(681331, 135, '2015-02-01 00:24:13.000000', 'consum', 0.0233, 'lps'),
	(681332, 135, '2015-02-01 00:24:14.000000', 'consum', 0.0230, 'lps'),
	(681333, 135, '2015-02-01 00:24:15.000000', 'consum', 0.0241, 'lps'),
	(681334, 135, '2015-02-01 00:24:16.000000', 'consum', 0.0251, 'lps'),
	(681335, 135, '2015-02-01 00:24:17.000000', 'consum', 0.0220, 'lps'),
	(681336, 135, '2015-02-01 00:24:18.000000', 'consum', 0.0240, 'lps'),
	(681337, 135, '2015-02-01 00:24:19.000000', 'consum', 0.0227, 'lps'),
	(681338, 135, '2015-02-01 00:24:20.000000', 'consum', 0.0256, 'lps'),
	(681339, 135, '2015-02-01 00:24:21.000000', 'consum', 0.0230, 'lps'),
	(681340, 135, '2015-02-01 00:24:22.000000', 'consum', 0.0227, 'lps'),
	(681341, 135, '2015-02-01 00:24:23.000000', 'consum', 0.0237, 'lps'),
	(681342, 135, '2015-02-01 00:24:24.000000', 'consum', 0.0241, 'lps'),
	(681343, 135, '2015-02-01 00:24:25.000000', 'consum', 0.0232, 'lps'),
	(681344, 135, '2015-02-01 00:24:26.000000', 'consum', 0.0225, 'lps'),
	(681345, 135, '2015-02-01 00:24:27.000000', 'consum', 0.0223, 'lps'),
	(681346, 135, '2015-02-01 00:24:28.000000', 'consum', 0.0227, 'lps'),
	(681347, 135, '2015-02-01 00:24:29.000000', 'consum', 0.0259, 'lps'),
	(681348, 135, '2015-02-01 00:24:30.000000', 'consum', 0.0246, 'lps'),
	(681349, 135, '2015-02-01 00:24:31.000000', 'consum', 0.0245, 'lps'),
	(681350, 135, '2015-02-01 00:24:32.000000', 'consum', 0.0222, 'lps'),
	(681351, 135, '2015-02-01 00:24:33.000000', 'consum', 0.0217, 'lps'),
	(681352, 135, '2015-02-01 00:24:34.000000', 'consum', 0.0212, 'lps'),
	(681353, 135, '2015-02-01 00:24:35.000000', 'consum', 0.0250, 'lps'),
	(681354, 135, '2015-02-01 00:24:36.000000', 'consum', 0.0248, 'lps'),
	(681355, 135, '2015-02-01 00:24:37.000000', 'consum', 0.0225, 'lps'),
	(681356, 135, '2015-02-01 00:24:38.000000', 'consum', 0.0225, 'lps'),
	(681357, 135, '2015-02-01 00:24:39.000000', 'consum', 0.0239, 'lps'),
	(681358, 135, '2015-02-01 00:24:40.000000', 'consum', 0.0260, 'lps'),
	(681359, 135, '2015-02-01 00:24:41.000000', 'consum', 0.0212, 'lps'),
	(681360, 135, '2015-02-01 00:24:42.000000', 'consum', 0.0232, 'lps'),
	(681361, 135, '2015-02-01 00:24:43.000000', 'consum', 0.0259, 'lps'),
	(681362, 135, '2015-02-01 00:24:44.000000', 'consum', 0.0233, 'lps'),
	(681363, 135, '2015-02-01 00:24:45.000000', 'consum', 0.0231, 'lps'),
	(681364, 135, '2015-02-01 00:24:46.000000', 'consum', 0.0247, 'lps'),
	(681365, 135, '2015-02-01 00:24:47.000000', 'consum', 0.0226, 'lps'),
	(681366, 135, '2015-02-01 00:24:48.000000', 'consum', 0.0234, 'lps'),
	(681367, 135, '2015-02-01 00:24:49.000000', 'consum', 0.0230, 'lps'),
	(681368, 135, '2015-02-01 00:24:50.000000', 'consum', 0.0238, 'lps'),
	(681369, 135, '2015-02-01 00:24:51.000000', 'consum', 0.0235, 'lps'),
	(681370, 135, '2015-02-01 00:24:52.000000', 'consum', 0.0254, 'lps'),
	(681371, 135, '2015-02-01 00:24:53.000000', 'consum', 0.0251, 'lps'),
	(681372, 135, '2015-02-01 00:24:54.000000', 'consum', 0.0228, 'lps'),
	(681373, 135, '2015-02-01 00:24:55.000000', 'consum', 0.0232, 'lps'),
	(681374, 135, '2015-02-01 00:24:56.000000', 'consum', 0.0214, 'lps'),
	(681375, 135, '2015-02-01 00:24:57.000000', 'consum', 0.0218, 'lps'),
	(681376, 135, '2015-02-01 00:24:58.000000', 'consum', 0.0236, 'lps'),
	(681377, 135, '2015-02-01 00:24:59.000000', 'consum', 0.0211, 'lps'),
	(681378, 135, '2015-02-01 00:25:00.000000', 'consum', 0.0245, 'lps'),
	(681379, 135, '2015-02-01 00:25:01.000000', 'consum', 0.0223, 'lps'),
	(681380, 135, '2015-02-01 00:25:02.000000', 'consum', 0.0224, 'lps'),
	(681381, 135, '2015-02-01 00:25:03.000000', 'consum', 0.0240, 'lps'),
	(681382, 135, '2015-02-01 00:25:04.000000', 'consum', 0.0214, 'lps'),
	(681383, 135, '2015-02-01 00:25:05.000000', 'consum', 0.0246, 'lps'),
	(681384, 135, '2015-02-01 00:25:06.000000', 'consum', 0.0221, 'lps'),
	(681385, 135, '2015-02-01 00:25:07.000000', 'consum', 0.0262, 'lps'),
	(681386, 135, '2015-02-01 00:25:08.000000', 'consum', 0.0224, 'lps'),
	(681387, 135, '2015-02-01 00:25:09.000000', 'consum', 0.0233, 'lps'),
	(681388, 135, '2015-02-01 00:25:10.000000', 'consum', 0.0231, 'lps'),
	(681389, 135, '2015-02-01 00:25:11.000000', 'consum', 0.0245, 'lps'),
	(681390, 135, '2015-02-01 00:25:12.000000', 'consum', 0.0218, 'lps'),
	(681391, 135, '2015-02-01 00:25:13.000000', 'consum', 0.0250, 'lps'),
	(681392, 135, '2015-02-01 00:25:14.000000', 'consum', 0.0229, 'lps'),
	(681393, 135, '2015-02-01 00:25:15.000000', 'consum', 0.0236, 'lps'),
	(681394, 135, '2015-02-01 00:25:16.000000', 'consum', 0.0231, 'lps'),
	(681395, 135, '2015-02-01 00:25:17.000000', 'consum', 0.0237, 'lps'),
	(681396, 135, '2015-02-01 00:25:18.000000', 'consum', 0.0229, 'lps'),
	(681397, 135, '2015-02-01 00:25:19.000000', 'consum', 0.0227, 'lps'),
	(681398, 135, '2015-02-01 00:25:20.000000', 'consum', 0.0238, 'lps'),
	(681399, 135, '2015-02-01 00:25:21.000000', 'consum', 0.0244, 'lps'),
	(681400, 135, '2015-02-01 00:25:22.000000', 'consum', 0.0245, 'lps'),
	(681401, 135, '2015-02-01 00:25:23.000000', 'consum', 0.0229, 'lps'),
	(681402, 135, '2015-02-01 00:25:24.000000', 'consum', 0.0256, 'lps'),
	(681403, 135, '2015-02-01 00:25:25.000000', 'consum', 0.0226, 'lps'),
	(681404, 135, '2015-02-01 00:25:26.000000', 'consum', 0.0255, 'lps'),
	(681405, 135, '2015-02-01 00:25:27.000000', 'consum', 0.0228, 'lps'),
	(681406, 135, '2015-02-01 00:25:28.000000', 'consum', 0.0220, 'lps'),
	(681407, 135, '2015-02-01 00:25:29.000000', 'consum', 0.0260, 'lps'),
	(681408, 135, '2015-02-01 00:25:30.000000', 'consum', 0.0217, 'lps'),
	(681409, 135, '2015-02-01 00:25:31.000000', 'consum', 0.0255, 'lps'),
	(681410, 135, '2015-02-01 00:25:32.000000', 'consum', 0.0254, 'lps'),
	(681411, 135, '2015-02-01 00:25:33.000000', 'consum', 0.0245, 'lps'),
	(681412, 135, '2015-02-01 00:25:34.000000', 'consum', 0.0253, 'lps'),
	(681413, 135, '2015-02-01 00:25:35.000000', 'consum', 0.0215, 'lps'),
	(681414, 135, '2015-02-01 00:25:36.000000', 'consum', 0.0210, 'lps'),
	(681415, 135, '2015-02-01 00:25:37.000000', 'consum', 0.0249, 'lps'),
	(681416, 135, '2015-02-01 00:25:38.000000', 'consum', 0.0249, 'lps'),
	(681417, 135, '2015-02-01 00:25:39.000000', 'consum', 0.0234, 'lps'),
	(681418, 135, '2015-02-01 00:25:40.000000', 'consum', 0.0215, 'lps'),
	(681419, 135, '2015-02-01 00:25:41.000000', 'consum', 0.0217, 'lps'),
	(681420, 135, '2015-02-01 00:25:42.000000', 'consum', 0.0231, 'lps'),
	(681421, 135, '2015-02-01 00:25:43.000000', 'consum', 0.0241, 'lps'),
	(681422, 135, '2015-02-01 00:25:44.000000', 'consum', 0.0249, 'lps'),
	(681423, 135, '2015-02-01 00:25:45.000000', 'consum', 0.0261, 'lps'),
	(681424, 135, '2015-02-01 00:25:46.000000', 'consum', 0.0241, 'lps'),
	(681425, 135, '2015-02-01 00:25:47.000000', 'consum', 0.0213, 'lps'),
	(681426, 135, '2015-02-01 00:25:48.000000', 'consum', 0.0236, 'lps'),
	(681427, 135, '2015-02-01 00:25:49.000000', 'consum', 0.0229, 'lps'),
	(681428, 135, '2015-02-01 00:25:50.000000', 'consum', 0.0225, 'lps'),
	(681429, 135, '2015-02-01 00:25:51.000000', 'consum', 0.0229, 'lps'),
	(681430, 135, '2015-02-01 00:25:52.000000', 'consum', 0.0260, 'lps'),
	(681431, 135, '2015-02-01 00:25:53.000000', 'consum', 0.0244, 'lps'),
	(681432, 135, '2015-02-01 00:25:54.000000', 'consum', 0.0229, 'lps'),
	(681433, 135, '2015-02-01 00:25:55.000000', 'consum', 0.0260, 'lps'),
	(681434, 135, '2015-02-01 00:25:56.000000', 'consum', 0.0244, 'lps'),
	(681435, 135, '2015-02-01 00:25:57.000000', 'consum', 0.0228, 'lps'),
	(681436, 135, '2015-02-01 00:25:58.000000', 'consum', 0.0255, 'lps'),
	(681437, 135, '2015-02-01 00:25:59.000000', 'consum', 0.0219, 'lps'),
	(681438, 135, '2015-02-01 00:26:00.000000', 'consum', 0.0229, 'lps'),
	(681439, 135, '2015-02-01 00:26:01.000000', 'consum', 0.0223, 'lps'),
	(681440, 135, '2015-02-01 00:26:02.000000', 'consum', 0.0222, 'lps'),
	(681441, 135, '2015-02-01 00:26:03.000000', 'consum', 0.0229, 'lps'),
	(681442, 135, '2015-02-01 00:26:04.000000', 'consum', 0.0217, 'lps'),
	(681443, 135, '2015-02-01 00:26:05.000000', 'consum', 0.0244, 'lps'),
	(681444, 135, '2015-02-01 00:26:06.000000', 'consum', 0.0250, 'lps'),
	(681445, 135, '2015-02-01 00:26:07.000000', 'consum', 0.0258, 'lps'),
	(681446, 135, '2015-02-01 00:26:08.000000', 'consum', 0.0225, 'lps'),
	(681447, 135, '2015-02-01 00:26:09.000000', 'consum', 0.0246, 'lps'),
	(681448, 135, '2015-02-01 00:26:10.000000', 'consum', 0.0242, 'lps'),
	(681449, 135, '2015-02-01 00:26:11.000000', 'consum', 0.0261, 'lps'),
	(681450, 135, '2015-02-01 00:26:12.000000', 'consum', 0.0262, 'lps'),
	(681451, 135, '2015-02-01 00:26:13.000000', 'consum', 0.0212, 'lps'),
	(681452, 135, '2015-02-01 00:26:14.000000', 'consum', 0.0223, 'lps'),
	(681453, 135, '2015-02-01 00:26:15.000000', 'consum', 0.0217, 'lps'),
	(681454, 135, '2015-02-01 00:26:16.000000', 'consum', 0.0259, 'lps'),
	(681455, 135, '2015-02-01 00:26:17.000000', 'consum', 0.0223, 'lps'),
	(681456, 135, '2015-02-01 00:26:18.000000', 'consum', 0.0232, 'lps'),
	(681457, 135, '2015-02-01 00:26:19.000000', 'consum', 0.0232, 'lps'),
	(681458, 135, '2015-02-01 00:26:20.000000', 'consum', 0.0251, 'lps'),
	(681459, 135, '2015-02-01 00:26:21.000000', 'consum', 0.0247, 'lps'),
	(681460, 135, '2015-02-01 00:26:22.000000', 'consum', 0.0218, 'lps'),
	(681461, 135, '2015-02-01 00:26:23.000000', 'consum', 0.0245, 'lps'),
	(681462, 135, '2015-02-01 00:26:24.000000', 'consum', 0.0258, 'lps'),
	(681463, 135, '2015-02-01 00:26:25.000000', 'consum', 0.0238, 'lps'),
	(681464, 135, '2015-02-01 00:26:26.000000', 'consum', 0.0260, 'lps'),
	(681465, 135, '2015-02-01 00:26:27.000000', 'consum', 0.0215, 'lps'),
	(681466, 135, '2015-02-01 00:26:28.000000', 'consum', 0.0248, 'lps'),
	(681467, 135, '2015-02-01 00:26:29.000000', 'consum', 0.0224, 'lps'),
	(681468, 135, '2015-02-01 00:26:30.000000', 'consum', 0.0219, 'lps'),
	(681469, 135, '2015-02-01 00:26:31.000000', 'consum', 0.0213, 'lps'),
	(681470, 135, '2015-02-01 00:26:32.000000', 'consum', 0.0250, 'lps'),
	(681471, 135, '2015-02-01 00:26:33.000000', 'consum', 0.0246, 'lps'),
	(681472, 135, '2015-02-01 00:26:34.000000', 'consum', 0.0215, 'lps'),
	(681473, 135, '2015-02-01 00:26:35.000000', 'consum', 0.0236, 'lps'),
	(681474, 135, '2015-02-01 00:26:36.000000', 'consum', 0.0220, 'lps'),
	(681475, 135, '2015-02-01 00:26:37.000000', 'consum', 0.0234, 'lps'),
	(681476, 135, '2015-02-01 00:26:38.000000', 'consum', 0.0246, 'lps'),
	(681477, 135, '2015-02-01 00:26:39.000000', 'consum', 0.0213, 'lps'),
	(681478, 135, '2015-02-01 00:26:40.000000', 'consum', 0.0224, 'lps'),
	(681479, 135, '2015-02-01 00:26:41.000000', 'consum', 0.0217, 'lps'),
	(681480, 135, '2015-02-01 00:26:42.000000', 'consum', 0.0256, 'lps'),
	(681481, 135, '2015-02-01 00:26:43.000000', 'consum', 0.0262, 'lps'),
	(681482, 135, '2015-02-01 00:26:44.000000', 'consum', 0.0225, 'lps'),
	(681483, 135, '2015-02-01 00:26:45.000000', 'consum', 0.0235, 'lps'),
	(681484, 135, '2015-02-01 00:26:46.000000', 'consum', 0.0238, 'lps'),
	(681485, 135, '2015-02-01 00:26:47.000000', 'consum', 0.0221, 'lps'),
	(681486, 135, '2015-02-01 00:26:48.000000', 'consum', 0.0237, 'lps'),
	(681487, 135, '2015-02-01 00:26:49.000000', 'consum', 0.0260, 'lps'),
	(681488, 135, '2015-02-01 00:26:50.000000', 'consum', 0.0218, 'lps'),
	(681489, 135, '2015-02-01 00:26:51.000000', 'consum', 0.0261, 'lps'),
	(681490, 135, '2015-02-01 00:26:52.000000', 'consum', 0.0231, 'lps'),
	(681491, 135, '2015-02-01 00:26:53.000000', 'consum', 0.0212, 'lps'),
	(681492, 135, '2015-02-01 00:26:54.000000', 'consum', 0.0214, 'lps'),
	(681493, 135, '2015-02-01 00:26:55.000000', 'consum', 0.0223, 'lps'),
	(681494, 135, '2015-02-01 00:26:56.000000', 'consum', 0.0211, 'lps'),
	(681495, 135, '2015-02-01 00:26:57.000000', 'consum', 0.0228, 'lps'),
	(681496, 135, '2015-02-01 00:26:58.000000', 'consum', 0.0246, 'lps'),
	(681497, 135, '2015-02-01 00:26:59.000000', 'consum', 0.0231, 'lps'),
	(681498, 135, '2015-02-01 00:27:00.000000', 'consum', 0.0262, 'lps'),
	(681499, 135, '2015-02-01 00:27:01.000000', 'consum', 0.0246, 'lps'),
	(681500, 135, '2015-02-01 00:27:02.000000', 'consum', 0.0236, 'lps'),
	(681501, 135, '2015-02-01 00:27:03.000000', 'consum', 0.0233, 'lps'),
	(681502, 135, '2015-02-01 00:27:04.000000', 'consum', 0.0245, 'lps'),
	(681503, 135, '2015-02-01 00:27:05.000000', 'consum', 0.0211, 'lps'),
	(681504, 135, '2015-02-01 00:27:06.000000', 'consum', 0.0217, 'lps'),
	(681505, 135, '2015-02-01 00:27:07.000000', 'consum', 0.0244, 'lps'),
	(681506, 135, '2015-02-01 00:27:08.000000', 'consum', 0.0253, 'lps'),
	(681507, 135, '2015-02-01 00:27:09.000000', 'consum', 0.0216, 'lps'),
	(681508, 135, '2015-02-01 00:27:10.000000', 'consum', 0.0218, 'lps'),
	(681509, 135, '2015-02-01 00:27:11.000000', 'consum', 0.0232, 'lps'),
	(681510, 135, '2015-02-01 00:27:12.000000', 'consum', 0.0243, 'lps'),
	(681511, 135, '2015-02-01 00:27:13.000000', 'consum', 0.0257, 'lps'),
	(681512, 135, '2015-02-01 00:27:14.000000', 'consum', 0.0239, 'lps'),
	(681513, 135, '2015-02-01 00:27:15.000000', 'consum', 0.0216, 'lps'),
	(681514, 135, '2015-02-01 00:27:16.000000', 'consum', 0.0258, 'lps'),
	(681515, 135, '2015-02-01 00:27:17.000000', 'consum', 0.0219, 'lps'),
	(681516, 135, '2015-02-01 00:27:18.000000', 'consum', 0.0221, 'lps'),
	(681517, 135, '2015-02-01 00:27:19.000000', 'consum', 0.0238, 'lps'),
	(681518, 135, '2015-02-01 00:27:20.000000', 'consum', 0.0262, 'lps'),
	(681519, 135, '2015-02-01 00:27:21.000000', 'consum', 0.0230, 'lps'),
	(681520, 135, '2015-02-01 00:27:22.000000', 'consum', 0.0259, 'lps'),
	(681521, 135, '2015-02-01 00:27:23.000000', 'consum', 0.0236, 'lps'),
	(681522, 135, '2015-02-01 00:27:24.000000', 'consum', 0.0246, 'lps'),
	(681523, 135, '2015-02-01 00:27:25.000000', 'consum', 0.0259, 'lps'),
	(681524, 135, '2015-02-01 00:27:26.000000', 'consum', 0.0244, 'lps'),
	(681525, 135, '2015-02-01 00:27:27.000000', 'consum', 0.0232, 'lps'),
	(681526, 135, '2015-02-01 00:27:28.000000', 'consum', 0.0218, 'lps'),
	(681527, 135, '2015-02-01 00:27:29.000000', 'consum', 0.0238, 'lps'),
	(681528, 135, '2015-02-01 00:27:30.000000', 'consum', 0.0222, 'lps'),
	(681529, 135, '2015-02-01 00:27:31.000000', 'consum', 0.0238, 'lps'),
	(681530, 135, '2015-02-01 00:27:32.000000', 'consum', 0.0211, 'lps'),
	(681531, 135, '2015-02-01 00:27:33.000000', 'consum', 0.0234, 'lps'),
	(681532, 135, '2015-02-01 00:27:34.000000', 'consum', 0.0223, 'lps'),
	(681533, 135, '2015-02-01 00:27:35.000000', 'consum', 0.0255, 'lps'),
	(681534, 135, '2015-02-01 00:27:36.000000', 'consum', 0.0237, 'lps'),
	(681535, 135, '2015-02-01 00:27:37.000000', 'consum', 0.0262, 'lps'),
	(681536, 135, '2015-02-01 00:27:38.000000', 'consum', 0.0234, 'lps'),
	(681537, 135, '2015-02-01 00:27:39.000000', 'consum', 0.0227, 'lps'),
	(681538, 135, '2015-02-01 00:27:40.000000', 'consum', 0.0225, 'lps'),
	(681539, 135, '2015-02-01 00:27:41.000000', 'consum', 0.0232, 'lps'),
	(681540, 135, '2015-02-01 00:27:42.000000', 'consum', 0.0224, 'lps'),
	(681541, 135, '2015-02-01 00:27:43.000000', 'consum', 0.0215, 'lps'),
	(681542, 135, '2015-02-01 00:27:44.000000', 'consum', 0.0244, 'lps'),
	(681543, 135, '2015-02-01 00:27:45.000000', 'consum', 0.0210, 'lps'),
	(681544, 135, '2015-02-01 00:27:46.000000', 'consum', 0.0212, 'lps'),
	(681545, 135, '2015-02-01 00:27:47.000000', 'consum', 0.0219, 'lps'),
	(681546, 135, '2015-02-01 00:27:48.000000', 'consum', 0.0253, 'lps'),
	(681547, 135, '2015-02-01 00:27:49.000000', 'consum', 0.0238, 'lps'),
	(681548, 135, '2015-02-01 00:27:50.000000', 'consum', 0.0222, 'lps'),
	(681549, 135, '2015-02-01 00:27:51.000000', 'consum', 0.0239, 'lps'),
	(681550, 135, '2015-02-01 00:27:52.000000', 'consum', 0.0215, 'lps'),
	(681551, 135, '2015-02-01 00:27:53.000000', 'consum', 0.0253, 'lps'),
	(681552, 135, '2015-02-01 00:27:54.000000', 'consum', 0.0254, 'lps'),
	(681553, 135, '2015-02-01 00:27:55.000000', 'consum', 0.0245, 'lps'),
	(681554, 135, '2015-02-01 00:27:56.000000', 'consum', 0.0257, 'lps'),
	(681555, 135, '2015-02-01 00:27:57.000000', 'consum', 0.0233, 'lps'),
	(681556, 135, '2015-02-01 00:27:58.000000', 'consum', 0.0237, 'lps'),
	(681557, 135, '2015-02-01 00:27:59.000000', 'consum', 0.0222, 'lps'),
	(681558, 135, '2015-02-01 00:28:00.000000', 'consum', 0.0245, 'lps'),
	(681559, 135, '2015-02-01 00:28:01.000000', 'consum', 0.0245, 'lps'),
	(681560, 135, '2015-02-01 00:28:02.000000', 'consum', 0.0225, 'lps'),
	(681561, 135, '2015-02-01 00:28:03.000000', 'consum', 0.0234, 'lps'),
	(681562, 135, '2015-02-01 00:28:04.000000', 'consum', 0.0231, 'lps'),
	(681563, 135, '2015-02-01 00:28:05.000000', 'consum', 0.0243, 'lps'),
	(681564, 135, '2015-02-01 00:28:06.000000', 'consum', 0.0260, 'lps'),
	(681565, 135, '2015-02-01 00:28:07.000000', 'consum', 0.0258, 'lps'),
	(681566, 135, '2015-02-01 00:28:08.000000', 'consum', 0.0246, 'lps'),
	(681567, 135, '2015-02-01 00:28:09.000000', 'consum', 0.0246, 'lps'),
	(681568, 135, '2015-02-01 00:28:10.000000', 'consum', 0.0228, 'lps'),
	(681569, 135, '2015-02-01 00:28:11.000000', 'consum', 0.0246, 'lps'),
	(681570, 135, '2015-02-01 00:28:12.000000', 'consum', 0.0233, 'lps'),
	(681571, 135, '2015-02-01 00:28:13.000000', 'consum', 0.0215, 'lps'),
	(681572, 135, '2015-02-01 00:28:14.000000', 'consum', 0.0222, 'lps'),
	(681573, 135, '2015-02-01 00:28:15.000000', 'consum', 0.0256, 'lps'),
	(681574, 135, '2015-02-01 00:28:16.000000', 'consum', 0.0245, 'lps'),
	(681575, 135, '2015-02-01 00:28:17.000000', 'consum', 0.0247, 'lps'),
	(681576, 135, '2015-02-01 00:28:18.000000', 'consum', 0.0237, 'lps'),
	(681577, 135, '2015-02-01 00:28:19.000000', 'consum', 0.0234, 'lps'),
	(681578, 135, '2015-02-01 00:28:20.000000', 'consum', 0.0251, 'lps'),
	(681579, 135, '2015-02-01 00:28:21.000000', 'consum', 0.0236, 'lps'),
	(681580, 135, '2015-02-01 00:28:22.000000', 'consum', 0.0217, 'lps'),
	(681581, 135, '2015-02-01 00:28:23.000000', 'consum', 0.0222, 'lps'),
	(681582, 135, '2015-02-01 00:28:24.000000', 'consum', 0.0250, 'lps'),
	(681583, 135, '2015-02-01 00:28:25.000000', 'consum', 0.0216, 'lps'),
	(681584, 135, '2015-02-01 00:28:26.000000', 'consum', 0.0227, 'lps'),
	(681585, 135, '2015-02-01 00:28:27.000000', 'consum', 0.0225, 'lps'),
	(681586, 135, '2015-02-01 00:28:28.000000', 'consum', 0.0235, 'lps'),
	(681587, 135, '2015-02-01 00:28:29.000000', 'consum', 0.0237, 'lps'),
	(681588, 135, '2015-02-01 00:28:30.000000', 'consum', 0.0218, 'lps'),
	(681589, 135, '2015-02-01 00:28:31.000000', 'consum', 0.0222, 'lps'),
	(681590, 135, '2015-02-01 00:28:32.000000', 'consum', 0.0245, 'lps'),
	(681591, 135, '2015-02-01 00:28:33.000000', 'consum', 0.0244, 'lps'),
	(681592, 135, '2015-02-01 00:28:34.000000', 'consum', 0.0225, 'lps'),
	(681593, 135, '2015-02-01 00:28:35.000000', 'consum', 0.0234, 'lps'),
	(681594, 135, '2015-02-01 00:28:36.000000', 'consum', 0.0232, 'lps'),
	(681595, 135, '2015-02-01 00:28:37.000000', 'consum', 0.0251, 'lps'),
	(681596, 135, '2015-02-01 00:28:38.000000', 'consum', 0.0242, 'lps'),
	(681597, 135, '2015-02-01 00:28:39.000000', 'consum', 0.0248, 'lps'),
	(681598, 135, '2015-02-01 00:28:40.000000', 'consum', 0.0251, 'lps'),
	(681599, 135, '2015-02-01 00:28:41.000000', 'consum', 0.0248, 'lps'),
	(681600, 135, '2015-02-01 00:28:42.000000', 'consum', 0.0224, 'lps'),
	(681601, 135, '2015-02-01 00:28:43.000000', 'consum', 0.0220, 'lps'),
	(681602, 135, '2015-02-01 00:28:44.000000', 'consum', 0.0221, 'lps'),
	(681603, 135, '2015-02-01 00:28:45.000000', 'consum', 0.0232, 'lps'),
	(681604, 135, '2015-02-01 00:28:46.000000', 'consum', 0.0236, 'lps'),
	(681605, 135, '2015-02-01 00:28:47.000000', 'consum', 0.0222, 'lps'),
	(681606, 135, '2015-02-01 00:28:48.000000', 'consum', 0.0245, 'lps'),
	(681607, 135, '2015-02-01 00:28:49.000000', 'consum', 0.0244, 'lps'),
	(681608, 135, '2015-02-01 00:28:50.000000', 'consum', 0.0220, 'lps'),
	(681609, 135, '2015-02-01 00:28:51.000000', 'consum', 0.0214, 'lps'),
	(681610, 135, '2015-02-01 00:28:52.000000', 'consum', 0.0254, 'lps'),
	(681611, 135, '2015-02-01 00:28:53.000000', 'consum', 0.0260, 'lps'),
	(681612, 135, '2015-02-01 00:28:54.000000', 'consum', 0.0223, 'lps'),
	(681613, 135, '2015-02-01 00:28:55.000000', 'consum', 0.0232, 'lps'),
	(681614, 135, '2015-02-01 00:28:56.000000', 'consum', 0.0229, 'lps'),
	(681615, 135, '2015-02-01 00:28:57.000000', 'consum', 0.0240, 'lps'),
	(681616, 135, '2015-02-01 00:28:58.000000', 'consum', 0.0247, 'lps'),
	(681617, 135, '2015-02-01 00:28:59.000000', 'consum', 0.0256, 'lps'),
	(681618, 135, '2015-02-01 00:29:00.000000', 'consum', 0.0222, 'lps'),
	(681619, 135, '2015-02-01 00:29:01.000000', 'consum', 0.0240, 'lps'),
	(681620, 135, '2015-02-01 00:29:02.000000', 'consum', 0.0220, 'lps'),
	(681621, 135, '2015-02-01 00:29:03.000000', 'consum', 0.0220, 'lps'),
	(681622, 135, '2015-02-01 00:29:04.000000', 'consum', 0.0230, 'lps'),
	(681623, 135, '2015-02-01 00:29:05.000000', 'consum', 0.0231, 'lps'),
	(681624, 135, '2015-02-01 00:29:06.000000', 'consum', 0.0253, 'lps'),
	(681625, 135, '2015-02-01 00:29:07.000000', 'consum', 0.0259, 'lps'),
	(681626, 135, '2015-02-01 00:29:08.000000', 'consum', 0.0218, 'lps'),
	(681627, 135, '2015-02-01 00:29:09.000000', 'consum', 0.0210, 'lps'),
	(681628, 135, '2015-02-01 00:29:10.000000', 'consum', 0.0242, 'lps'),
	(681629, 135, '2015-02-01 00:29:11.000000', 'consum', 0.0262, 'lps'),
	(681630, 135, '2015-02-01 00:29:12.000000', 'consum', 0.0216, 'lps'),
	(681631, 135, '2015-02-01 00:29:13.000000', 'consum', 0.0242, 'lps'),
	(681632, 135, '2015-02-01 00:29:14.000000', 'consum', 0.0248, 'lps'),
	(681633, 135, '2015-02-01 00:29:15.000000', 'consum', 0.0250, 'lps'),
	(681634, 135, '2015-02-01 00:29:16.000000', 'consum', 0.0245, 'lps'),
	(681635, 135, '2015-02-01 00:29:17.000000', 'consum', 0.0212, 'lps'),
	(681636, 135, '2015-02-01 00:29:18.000000', 'consum', 0.0222, 'lps'),
	(681637, 135, '2015-02-01 00:29:19.000000', 'consum', 0.0210, 'lps'),
	(681638, 135, '2015-02-01 00:29:20.000000', 'consum', 0.0229, 'lps'),
	(681639, 135, '2015-02-01 00:29:21.000000', 'consum', 0.0251, 'lps'),
	(681640, 135, '2015-02-01 00:29:22.000000', 'consum', 0.0252, 'lps'),
	(681641, 135, '2015-02-01 00:29:23.000000', 'consum', 0.0247, 'lps'),
	(681642, 135, '2015-02-01 00:29:24.000000', 'consum', 0.0217, 'lps'),
	(681643, 135, '2015-02-01 00:29:25.000000', 'consum', 0.0240, 'lps'),
	(681644, 135, '2015-02-01 00:29:26.000000', 'consum', 0.0233, 'lps'),
	(681645, 135, '2015-02-01 00:29:27.000000', 'consum', 0.0234, 'lps'),
	(681646, 135, '2015-02-01 00:29:28.000000', 'consum', 0.0261, 'lps'),
	(681647, 135, '2015-02-01 00:29:29.000000', 'consum', 0.0234, 'lps'),
	(681648, 135, '2015-02-01 00:29:30.000000', 'consum', 0.0232, 'lps'),
	(681649, 135, '2015-02-01 00:29:31.000000', 'consum', 0.0247, 'lps'),
	(681650, 135, '2015-02-01 00:29:32.000000', 'consum', 0.0226, 'lps'),
	(681651, 135, '2015-02-01 00:29:33.000000', 'consum', 0.0233, 'lps'),
	(681652, 135, '2015-02-01 00:29:34.000000', 'consum', 0.0224, 'lps'),
	(681653, 135, '2015-02-01 00:29:35.000000', 'consum', 0.0211, 'lps'),
	(681654, 135, '2015-02-01 00:29:36.000000', 'consum', 0.0225, 'lps'),
	(681655, 135, '2015-02-01 00:29:37.000000', 'consum', 0.0230, 'lps'),
	(681656, 135, '2015-02-01 00:29:38.000000', 'consum', 0.0212, 'lps'),
	(681657, 135, '2015-02-01 00:29:39.000000', 'consum', 0.0215, 'lps'),
	(681658, 135, '2015-02-01 00:29:40.000000', 'consum', 0.0229, 'lps'),
	(681659, 135, '2015-02-01 00:29:41.000000', 'consum', 0.0236, 'lps'),
	(681660, 135, '2015-02-01 00:29:42.000000', 'consum', 0.0230, 'lps'),
	(681661, 135, '2015-02-01 00:29:43.000000', 'consum', 0.0233, 'lps'),
	(681662, 135, '2015-02-01 00:29:44.000000', 'consum', 0.0212, 'lps'),
	(681663, 135, '2015-02-01 00:29:45.000000', 'consum', 0.0260, 'lps'),
	(681664, 135, '2015-02-01 00:29:46.000000', 'consum', 0.0241, 'lps'),
	(681665, 135, '2015-02-01 00:29:47.000000', 'consum', 0.0216, 'lps'),
	(681666, 135, '2015-02-01 00:29:48.000000', 'consum', 0.0251, 'lps'),
	(681667, 135, '2015-02-01 00:29:49.000000', 'consum', 0.0242, 'lps'),
	(681668, 135, '2015-02-01 00:29:50.000000', 'consum', 0.0246, 'lps'),
	(681669, 135, '2015-02-01 00:29:51.000000', 'consum', 0.0241, 'lps'),
	(681670, 135, '2015-02-01 00:29:52.000000', 'consum', 0.0257, 'lps'),
	(681671, 135, '2015-02-01 00:29:53.000000', 'consum', 0.0248, 'lps'),
	(681672, 135, '2015-02-01 00:29:54.000000', 'consum', 0.0257, 'lps'),
	(681673, 135, '2015-02-01 00:29:55.000000', 'consum', 0.0229, 'lps'),
	(681674, 135, '2015-02-01 00:29:56.000000', 'consum', 0.0214, 'lps'),
	(681675, 135, '2015-02-01 00:29:57.000000', 'consum', 0.0227, 'lps'),
	(681676, 135, '2015-02-01 00:29:58.000000', 'consum', 0.0233, 'lps'),
	(681677, 135, '2015-02-01 00:29:59.000000', 'consum', 0.0220, 'lps'),
	(681678, 135, '2015-02-01 00:30:00.000000', 'consum', 0.0247, 'lps'),
	(681679, 135, '2015-02-01 00:30:01.000000', 'consum', 0.0256, 'lps'),
	(681680, 135, '2015-02-01 00:30:02.000000', 'consum', 0.0224, 'lps'),
	(681681, 135, '2015-02-01 00:30:03.000000', 'consum', 0.0248, 'lps'),
	(681682, 135, '2015-02-01 00:30:04.000000', 'consum', 0.0252, 'lps'),
	(681683, 135, '2015-02-01 00:30:05.000000', 'consum', 0.0255, 'lps'),
	(681684, 135, '2015-02-01 00:30:06.000000', 'consum', 0.0254, 'lps'),
	(681685, 135, '2015-02-01 00:30:07.000000', 'consum', 0.0244, 'lps'),
	(681686, 135, '2015-02-01 00:30:08.000000', 'consum', 0.0249, 'lps'),
	(681687, 135, '2015-02-01 00:30:09.000000', 'consum', 0.0248, 'lps'),
	(681688, 135, '2015-02-01 00:30:10.000000', 'consum', 0.0232, 'lps'),
	(681689, 135, '2015-02-01 00:30:11.000000', 'consum', 0.0260, 'lps'),
	(681690, 135, '2015-02-01 00:30:12.000000', 'consum', 0.0236, 'lps'),
	(681691, 135, '2015-02-01 00:30:13.000000', 'consum', 0.0244, 'lps'),
	(681692, 135, '2015-02-01 00:30:14.000000', 'consum', 0.0247, 'lps'),
	(681693, 135, '2015-02-01 00:30:15.000000', 'consum', 0.0242, 'lps'),
	(681694, 135, '2015-02-01 00:30:16.000000', 'consum', 0.0259, 'lps'),
	(681695, 135, '2015-02-01 00:30:17.000000', 'consum', 0.0254, 'lps'),
	(681696, 135, '2015-02-01 00:30:18.000000', 'consum', 0.0232, 'lps'),
	(681697, 135, '2015-02-01 00:30:19.000000', 'consum', 0.0239, 'lps'),
	(681698, 135, '2015-02-01 00:30:20.000000', 'consum', 0.0237, 'lps'),
	(681699, 135, '2015-02-01 00:30:21.000000', 'consum', 0.0259, 'lps'),
	(681700, 135, '2015-02-01 00:30:22.000000', 'consum', 0.0217, 'lps'),
	(681701, 135, '2015-02-01 00:30:23.000000', 'consum', 0.0258, 'lps'),
	(681702, 135, '2015-02-01 00:30:24.000000', 'consum', 0.0215, 'lps'),
	(681703, 135, '2015-02-01 00:30:25.000000', 'consum', 0.0251, 'lps'),
	(681704, 135, '2015-02-01 00:30:26.000000', 'consum', 0.0241, 'lps'),
	(681705, 135, '2015-02-01 00:30:27.000000', 'consum', 0.0243, 'lps'),
	(681706, 135, '2015-02-01 00:30:28.000000', 'consum', 0.0231, 'lps'),
	(681707, 135, '2015-02-01 00:30:29.000000', 'consum', 0.0217, 'lps'),
	(681708, 135, '2015-02-01 00:30:30.000000', 'consum', 0.0235, 'lps'),
	(681709, 135, '2015-02-01 00:30:31.000000', 'consum', 0.0262, 'lps'),
	(681710, 135, '2015-02-01 00:30:32.000000', 'consum', 0.0235, 'lps'),
	(681711, 135, '2015-02-01 00:30:33.000000', 'consum', 0.0232, 'lps'),
	(681712, 135, '2015-02-01 00:30:34.000000', 'consum', 0.0246, 'lps'),
	(681713, 135, '2015-02-01 00:30:35.000000', 'consum', 0.0220, 'lps'),
	(681714, 135, '2015-02-01 00:30:36.000000', 'consum', 0.0258, 'lps'),
	(681715, 135, '2015-02-01 00:30:37.000000', 'consum', 0.0260, 'lps'),
	(681716, 135, '2015-02-01 00:30:38.000000', 'consum', 0.0262, 'lps'),
	(681717, 135, '2015-02-01 00:30:39.000000', 'consum', 0.0218, 'lps'),
	(681718, 135, '2015-02-01 00:30:40.000000', 'consum', 0.0253, 'lps'),
	(681719, 135, '2015-02-01 00:30:41.000000', 'consum', 0.0244, 'lps'),
	(681720, 135, '2015-02-01 00:30:42.000000', 'consum', 0.0249, 'lps'),
	(681721, 135, '2015-02-01 00:30:43.000000', 'consum', 0.0250, 'lps'),
	(681722, 135, '2015-02-01 00:30:44.000000', 'consum', 0.0243, 'lps'),
	(681723, 135, '2015-02-01 00:30:45.000000', 'consum', 0.0255, 'lps'),
	(681724, 135, '2015-02-01 00:30:46.000000', 'consum', 0.0228, 'lps'),
	(681725, 135, '2015-02-01 00:30:47.000000', 'consum', 0.0221, 'lps'),
	(681726, 135, '2015-02-01 00:30:48.000000', 'consum', 0.0210, 'lps'),
	(681727, 135, '2015-02-01 00:30:49.000000', 'consum', 0.0229, 'lps'),
	(681728, 135, '2015-02-01 00:30:50.000000', 'consum', 0.0256, 'lps'),
	(681729, 135, '2015-02-01 00:30:51.000000', 'consum', 0.0221, 'lps'),
	(681730, 135, '2015-02-01 00:30:52.000000', 'consum', 0.0234, 'lps'),
	(681731, 135, '2015-02-01 00:30:53.000000', 'consum', 0.0247, 'lps'),
	(681732, 135, '2015-02-01 00:30:54.000000', 'consum', 0.0217, 'lps'),
	(681733, 135, '2015-02-01 00:30:55.000000', 'consum', 0.0241, 'lps'),
	(681734, 135, '2015-02-01 00:30:56.000000', 'consum', 0.0236, 'lps'),
	(681735, 135, '2015-02-01 00:30:57.000000', 'consum', 0.0250, 'lps'),
	(681736, 135, '2015-02-01 00:30:58.000000', 'consum', 0.0227, 'lps'),
	(681737, 135, '2015-02-01 00:30:59.000000', 'consum', 0.0229, 'lps'),
	(681738, 135, '2015-02-01 00:31:00.000000', 'consum', 0.0254, 'lps'),
	(681739, 135, '2015-02-01 00:31:01.000000', 'consum', 0.0214, 'lps'),
	(681740, 135, '2015-02-01 00:31:02.000000', 'consum', 0.0259, 'lps'),
	(681741, 135, '2015-02-01 00:31:03.000000', 'consum', 0.0230, 'lps'),
	(681742, 135, '2015-02-01 00:31:04.000000', 'consum', 0.0218, 'lps'),
	(681743, 135, '2015-02-01 00:31:05.000000', 'consum', 0.0244, 'lps'),
	(681744, 135, '2015-02-01 00:31:06.000000', 'consum', 0.0251, 'lps'),
	(681745, 135, '2015-02-01 00:31:07.000000', 'consum', 0.0261, 'lps'),
	(681746, 135, '2015-02-01 00:31:08.000000', 'consum', 0.0235, 'lps'),
	(681747, 135, '2015-02-01 00:31:09.000000', 'consum', 0.0235, 'lps'),
	(681748, 135, '2015-02-01 00:31:10.000000', 'consum', 0.0261, 'lps'),
	(681749, 135, '2015-02-01 00:31:11.000000', 'consum', 0.0233, 'lps'),
	(681750, 135, '2015-02-01 00:31:12.000000', 'consum', 0.0226, 'lps'),
	(681751, 135, '2015-02-01 00:31:13.000000', 'consum', 0.0218, 'lps'),
	(681752, 135, '2015-02-01 00:31:14.000000', 'consum', 0.0259, 'lps'),
	(681753, 135, '2015-02-01 00:31:15.000000', 'consum', 0.0217, 'lps'),
	(681754, 135, '2015-02-01 00:31:16.000000', 'consum', 0.0258, 'lps'),
	(681755, 135, '2015-02-01 00:31:17.000000', 'consum', 0.0219, 'lps'),
	(681756, 135, '2015-02-01 00:31:18.000000', 'consum', 0.0217, 'lps'),
	(681757, 135, '2015-02-01 00:31:19.000000', 'consum', 0.0219, 'lps'),
	(681758, 135, '2015-02-01 00:31:20.000000', 'consum', 0.0233, 'lps'),
	(681759, 135, '2015-02-01 00:31:21.000000', 'consum', 0.0247, 'lps'),
	(681760, 135, '2015-02-01 00:31:22.000000', 'consum', 0.0219, 'lps'),
	(681761, 135, '2015-02-01 00:31:23.000000', 'consum', 0.0250, 'lps'),
	(681762, 135, '2015-02-01 00:31:24.000000', 'consum', 0.0227, 'lps'),
	(681763, 135, '2015-02-01 00:31:25.000000', 'consum', 0.0226, 'lps'),
	(681764, 135, '2015-02-01 00:31:26.000000', 'consum', 0.0241, 'lps'),
	(681765, 135, '2015-02-01 00:31:27.000000', 'consum', 0.0210, 'lps'),
	(681766, 135, '2015-02-01 00:31:28.000000', 'consum', 0.0226, 'lps'),
	(681767, 135, '2015-02-01 00:31:29.000000', 'consum', 0.0236, 'lps'),
	(681768, 135, '2015-02-01 00:31:30.000000', 'consum', 0.0239, 'lps'),
	(681769, 135, '2015-02-01 00:31:31.000000', 'consum', 0.0227, 'lps'),
	(681770, 135, '2015-02-01 00:31:32.000000', 'consum', 0.0259, 'lps'),
	(681771, 135, '2015-02-01 00:31:33.000000', 'consum', 0.0247, 'lps'),
	(681772, 135, '2015-02-01 00:31:34.000000', 'consum', 0.0248, 'lps'),
	(681773, 135, '2015-02-01 00:31:35.000000', 'consum', 0.0235, 'lps'),
	(681774, 135, '2015-02-01 00:31:36.000000', 'consum', 0.0224, 'lps'),
	(681775, 135, '2015-02-01 00:31:37.000000', 'consum', 0.0260, 'lps'),
	(681776, 135, '2015-02-01 00:31:38.000000', 'consum', 0.0256, 'lps'),
	(681777, 135, '2015-02-01 00:31:39.000000', 'consum', 0.0238, 'lps'),
	(681778, 135, '2015-02-01 00:31:40.000000', 'consum', 0.0211, 'lps'),
	(681779, 135, '2015-02-01 00:31:41.000000', 'consum', 0.0240, 'lps'),
	(681780, 135, '2015-02-01 00:31:42.000000', 'consum', 0.0251, 'lps'),
	(681781, 135, '2015-02-01 00:31:43.000000', 'consum', 0.0219, 'lps'),
	(681782, 135, '2015-02-01 00:31:44.000000', 'consum', 0.0238, 'lps'),
	(681783, 135, '2015-02-01 00:31:45.000000', 'consum', 0.0218, 'lps'),
	(681784, 135, '2015-02-01 00:31:46.000000', 'consum', 0.0218, 'lps'),
	(681785, 135, '2015-02-01 00:31:47.000000', 'consum', 0.0228, 'lps'),
	(681786, 135, '2015-02-01 00:31:48.000000', 'consum', 0.0221, 'lps'),
	(681787, 135, '2015-02-01 00:31:49.000000', 'consum', 0.0214, 'lps'),
	(681788, 135, '2015-02-01 00:31:50.000000', 'consum', 0.0250, 'lps'),
	(681789, 135, '2015-02-01 00:31:51.000000', 'consum', 0.0239, 'lps'),
	(681790, 135, '2015-02-01 00:31:52.000000', 'consum', 0.0234, 'lps'),
	(681791, 135, '2015-02-01 00:31:53.000000', 'consum', 0.0243, 'lps'),
	(681792, 135, '2015-02-01 00:31:54.000000', 'consum', 0.0254, 'lps'),
	(681793, 135, '2015-02-01 00:31:55.000000', 'consum', 0.0222, 'lps'),
	(681794, 135, '2015-02-01 00:31:56.000000', 'consum', 0.0247, 'lps'),
	(681795, 135, '2015-02-01 00:31:57.000000', 'consum', 0.0251, 'lps'),
	(681796, 135, '2015-02-01 00:31:58.000000', 'consum', 0.0254, 'lps'),
	(681797, 135, '2015-02-01 00:31:59.000000', 'consum', 0.0253, 'lps'),
	(681798, 135, '2015-02-01 00:32:00.000000', 'consum', 0.0241, 'lps'),
	(681799, 135, '2015-02-01 00:32:01.000000', 'consum', 0.0234, 'lps'),
	(681800, 135, '2015-02-01 00:32:02.000000', 'consum', 0.0241, 'lps'),
	(681801, 135, '2015-02-01 00:32:03.000000', 'consum', 0.0240, 'lps'),
	(681802, 135, '2015-02-01 00:32:04.000000', 'consum', 0.0212, 'lps'),
	(681803, 135, '2015-02-01 00:32:05.000000', 'consum', 0.0237, 'lps'),
	(681804, 135, '2015-02-01 00:32:06.000000', 'consum', 0.0235, 'lps'),
	(681805, 135, '2015-02-01 00:32:07.000000', 'consum', 0.0255, 'lps'),
	(681806, 135, '2015-02-01 00:32:08.000000', 'consum', 0.0254, 'lps'),
	(681807, 135, '2015-02-01 00:32:09.000000', 'consum', 0.0241, 'lps'),
	(681808, 135, '2015-02-01 00:32:10.000000', 'consum', 0.0234, 'lps'),
	(681809, 135, '2015-02-01 00:32:11.000000', 'consum', 0.0236, 'lps'),
	(681810, 135, '2015-02-01 00:32:12.000000', 'consum', 0.0216, 'lps'),
	(681811, 135, '2015-02-01 00:32:13.000000', 'consum', 0.0215, 'lps'),
	(681812, 135, '2015-02-01 00:32:14.000000', 'consum', 0.0219, 'lps'),
	(681813, 135, '2015-02-01 00:32:15.000000', 'consum', 0.0241, 'lps'),
	(681814, 135, '2015-02-01 00:32:16.000000', 'consum', 0.0233, 'lps'),
	(681815, 135, '2015-02-01 00:32:17.000000', 'consum', 0.0233, 'lps'),
	(681816, 135, '2015-02-01 00:32:18.000000', 'consum', 0.0254, 'lps'),
	(681817, 135, '2015-02-01 00:32:19.000000', 'consum', 0.0258, 'lps'),
	(681818, 135, '2015-02-01 00:32:20.000000', 'consum', 0.0212, 'lps'),
	(681819, 135, '2015-02-01 00:32:21.000000', 'consum', 0.0235, 'lps'),
	(681820, 135, '2015-02-01 00:32:22.000000', 'consum', 0.0226, 'lps'),
	(681821, 135, '2015-02-01 00:32:23.000000', 'consum', 0.0213, 'lps'),
	(681822, 135, '2015-02-01 00:32:24.000000', 'consum', 0.0229, 'lps'),
	(681823, 135, '2015-02-01 00:32:25.000000', 'consum', 0.0245, 'lps'),
	(681824, 135, '2015-02-01 00:32:26.000000', 'consum', 0.0222, 'lps'),
	(681825, 135, '2015-02-01 00:32:27.000000', 'consum', 0.0220, 'lps'),
	(681826, 135, '2015-02-01 00:32:28.000000', 'consum', 0.0224, 'lps'),
	(681827, 135, '2015-02-01 00:32:29.000000', 'consum', 0.0249, 'lps'),
	(681828, 135, '2015-02-01 00:32:30.000000', 'consum', 0.0260, 'lps'),
	(681829, 135, '2015-02-01 00:32:31.000000', 'consum', 0.0237, 'lps'),
	(681830, 135, '2015-02-01 00:32:32.000000', 'consum', 0.0250, 'lps'),
	(681831, 135, '2015-02-01 00:32:33.000000', 'consum', 0.0222, 'lps'),
	(681832, 135, '2015-02-01 00:32:34.000000', 'consum', 0.0257, 'lps'),
	(681833, 135, '2015-02-01 00:32:35.000000', 'consum', 0.0251, 'lps'),
	(681834, 135, '2015-02-01 00:32:36.000000', 'consum', 0.0221, 'lps'),
	(681835, 135, '2015-02-01 00:32:37.000000', 'consum', 0.0250, 'lps'),
	(681836, 135, '2015-02-01 00:32:38.000000', 'consum', 0.0217, 'lps'),
	(681837, 135, '2015-02-01 00:32:39.000000', 'consum', 0.0230, 'lps'),
	(681838, 135, '2015-02-01 00:32:40.000000', 'consum', 0.0239, 'lps'),
	(681839, 135, '2015-02-01 00:32:41.000000', 'consum', 0.0243, 'lps'),
	(681840, 135, '2015-02-01 00:32:42.000000', 'consum', 0.0233, 'lps'),
	(681841, 135, '2015-02-01 00:32:43.000000', 'consum', 0.0230, 'lps'),
	(681842, 135, '2015-02-01 00:32:44.000000', 'consum', 0.0238, 'lps'),
	(681843, 135, '2015-02-01 00:32:45.000000', 'consum', 0.0238, 'lps'),
	(681844, 135, '2015-02-01 00:32:46.000000', 'consum', 0.0213, 'lps'),
	(681845, 135, '2015-02-01 00:32:47.000000', 'consum', 0.0248, 'lps'),
	(681846, 135, '2015-02-01 00:32:48.000000', 'consum', 0.0231, 'lps'),
	(681847, 135, '2015-02-01 00:32:49.000000', 'consum', 0.0254, 'lps'),
	(681848, 135, '2015-02-01 00:32:50.000000', 'consum', 0.0261, 'lps'),
	(681849, 135, '2015-02-01 00:32:51.000000', 'consum', 0.0228, 'lps'),
	(681850, 135, '2015-02-01 00:32:52.000000', 'consum', 0.0256, 'lps'),
	(681851, 135, '2015-02-01 00:32:53.000000', 'consum', 0.0224, 'lps'),
	(681852, 135, '2015-02-01 00:32:54.000000', 'consum', 0.0250, 'lps'),
	(681853, 135, '2015-02-01 00:32:55.000000', 'consum', 0.0211, 'lps'),
	(681854, 135, '2015-02-01 00:32:56.000000', 'consum', 0.0253, 'lps'),
	(681855, 135, '2015-02-01 00:32:57.000000', 'consum', 0.0210, 'lps'),
	(681856, 135, '2015-02-01 00:32:58.000000', 'consum', 0.0240, 'lps'),
	(681857, 135, '2015-02-01 00:32:59.000000', 'consum', 0.0256, 'lps'),
	(681858, 135, '2015-02-01 00:33:00.000000', 'consum', 0.0246, 'lps'),
	(681859, 135, '2015-02-01 00:33:01.000000', 'consum', 0.0251, 'lps'),
	(681860, 135, '2015-02-01 00:33:02.000000', 'consum', 0.0254, 'lps'),
	(681861, 135, '2015-02-01 00:33:03.000000', 'consum', 0.0253, 'lps'),
	(681862, 135, '2015-02-01 00:33:04.000000', 'consum', 0.0243, 'lps'),
	(681863, 135, '2015-02-01 00:33:05.000000', 'consum', 0.0247, 'lps'),
	(681864, 135, '2015-02-01 00:33:06.000000', 'consum', 0.0242, 'lps'),
	(681865, 135, '2015-02-01 00:33:07.000000', 'consum', 0.0259, 'lps'),
	(681866, 135, '2015-02-01 00:33:08.000000', 'consum', 0.0254, 'lps'),
	(681867, 135, '2015-02-01 00:33:09.000000', 'consum', 0.0232, 'lps'),
	(681868, 135, '2015-02-01 00:33:10.000000', 'consum', 0.0241, 'lps'),
	(681869, 135, '2015-02-01 00:33:11.000000', 'consum', 0.0246, 'lps'),
	(681870, 135, '2015-02-01 00:33:12.000000', 'consum', 0.0243, 'lps'),
	(681871, 135, '2015-02-01 00:33:13.000000', 'consum', 0.0217, 'lps'),
	(681872, 135, '2015-02-01 00:33:14.000000', 'consum', 0.0252, 'lps'),
	(681873, 135, '2015-02-01 00:33:15.000000', 'consum', 0.0242, 'lps'),
	(681874, 135, '2015-02-01 00:33:16.000000', 'consum', 0.0244, 'lps'),
	(681875, 135, '2015-02-01 00:33:17.000000', 'consum', 0.0233, 'lps'),
	(681876, 135, '2015-02-01 00:33:18.000000', 'consum', 0.0221, 'lps'),
	(681877, 135, '2015-02-01 00:33:19.000000', 'consum', 0.0251, 'lps'),
	(681878, 135, '2015-02-01 00:33:20.000000', 'consum', 0.0221, 'lps'),
	(681879, 135, '2015-02-01 00:33:21.000000', 'consum', 0.0250, 'lps'),
	(681880, 135, '2015-02-01 00:33:22.000000', 'consum', 0.0218, 'lps'),
	(681881, 135, '2015-02-01 00:33:23.000000', 'consum', 0.0236, 'lps'),
	(681882, 135, '2015-02-01 00:33:24.000000', 'consum', 0.0211, 'lps'),
	(681883, 135, '2015-02-01 00:33:25.000000', 'consum', 0.0243, 'lps'),
	(681884, 135, '2015-02-01 00:33:26.000000', 'consum', 0.0212, 'lps'),
	(681885, 135, '2015-02-01 00:33:27.000000', 'consum', 0.0228, 'lps'),
	(681886, 135, '2015-02-01 00:33:28.000000', 'consum', 0.0241, 'lps'),
	(681887, 135, '2015-02-01 00:33:29.000000', 'consum', 0.0258, 'lps'),
	(681888, 135, '2015-02-01 00:33:30.000000', 'consum', 0.0251, 'lps'),
	(681889, 135, '2015-02-01 00:33:31.000000', 'consum', 0.0218, 'lps'),
	(681890, 135, '2015-02-01 00:33:32.000000', 'consum', 0.0234, 'lps'),
	(681891, 135, '2015-02-01 00:33:33.000000', 'consum', 0.0255, 'lps'),
	(681892, 135, '2015-02-01 00:33:34.000000', 'consum', 0.0255, 'lps'),
	(681893, 135, '2015-02-01 00:33:35.000000', 'consum', 0.0250, 'lps'),
	(681894, 135, '2015-02-01 00:33:36.000000', 'consum', 0.0224, 'lps'),
	(681895, 135, '2015-02-01 00:33:37.000000', 'consum', 0.0210, 'lps'),
	(681896, 135, '2015-02-01 00:33:38.000000', 'consum', 0.0225, 'lps'),
	(681897, 135, '2015-02-01 00:33:39.000000', 'consum', 0.0230, 'lps'),
	(681898, 135, '2015-02-01 00:33:40.000000', 'consum', 0.0212, 'lps'),
	(681899, 135, '2015-02-01 00:33:41.000000', 'consum', 0.0214, 'lps'),
	(681900, 135, '2015-02-01 00:33:42.000000', 'consum', 0.0225, 'lps'),
	(681901, 135, '2015-02-01 00:33:43.000000', 'consum', 0.0222, 'lps'),
	(681902, 135, '2015-02-01 00:33:44.000000', 'consum', 0.0223, 'lps'),
	(681903, 135, '2015-02-01 00:33:45.000000', 'consum', 0.0242, 'lps'),
	(681904, 135, '2015-02-01 00:33:46.000000', 'consum', 0.0224, 'lps'),
	(681905, 135, '2015-02-01 00:33:47.000000', 'consum', 0.0237, 'lps'),
	(681906, 135, '2015-02-01 00:33:48.000000', 'consum', 0.0250, 'lps'),
	(681907, 135, '2015-02-01 00:33:49.000000', 'consum', 0.0225, 'lps'),
	(681908, 135, '2015-02-01 00:33:50.000000', 'consum', 0.0218, 'lps'),
	(681909, 135, '2015-02-01 00:33:51.000000', 'consum', 0.0257, 'lps'),
	(681910, 135, '2015-02-01 00:33:52.000000', 'consum', 0.0212, 'lps'),
	(681911, 135, '2015-02-01 00:33:53.000000', 'consum', 0.0237, 'lps'),
	(681912, 135, '2015-02-01 00:33:54.000000', 'consum', 0.0233, 'lps'),
	(681913, 135, '2015-02-01 00:33:55.000000', 'consum', 0.0246, 'lps'),
	(681914, 135, '2015-02-01 00:33:56.000000', 'consum', 0.0214, 'lps'),
	(681915, 135, '2015-02-01 00:33:57.000000', 'consum', 0.0231, 'lps'),
	(681916, 135, '2015-02-01 00:33:58.000000', 'consum', 0.0249, 'lps'),
	(681917, 135, '2015-02-01 00:33:59.000000', 'consum', 0.0238, 'lps'),
	(681918, 135, '2015-02-01 00:34:00.000000', 'consum', 0.0233, 'lps'),
	(681919, 135, '2015-02-01 00:34:01.000000', 'consum', 0.0241, 'lps'),
	(681920, 135, '2015-02-01 00:34:02.000000', 'consum', 0.0242, 'lps'),
	(681921, 135, '2015-02-01 00:34:03.000000', 'consum', 0.0225, 'lps'),
	(681922, 135, '2015-02-01 00:34:04.000000', 'consum', 0.0244, 'lps'),
	(681923, 135, '2015-02-01 00:34:05.000000', 'consum', 0.0229, 'lps'),
	(681924, 135, '2015-02-01 00:34:06.000000', 'consum', 0.0257, 'lps'),
	(681925, 135, '2015-02-01 00:34:07.000000', 'consum', 0.0229, 'lps'),
	(681926, 135, '2015-02-01 00:34:08.000000', 'consum', 0.0216, 'lps'),
	(681927, 135, '2015-02-01 00:34:09.000000', 'consum', 0.0238, 'lps'),
	(681928, 135, '2015-02-01 00:34:10.000000', 'consum', 0.0228, 'lps'),
	(681929, 135, '2015-02-01 00:34:11.000000', 'consum', 0.0214, 'lps'),
	(681930, 135, '2015-02-01 00:34:12.000000', 'consum', 0.0230, 'lps'),
	(681931, 135, '2015-02-01 00:34:13.000000', 'consum', 0.0247, 'lps'),
	(681932, 135, '2015-02-01 00:34:14.000000', 'consum', 0.0230, 'lps'),
	(681933, 135, '2015-02-01 00:34:15.000000', 'consum', 0.0250, 'lps'),
	(681934, 135, '2015-02-01 00:34:16.000000', 'consum', 0.0247, 'lps'),
	(681935, 135, '2015-02-01 00:34:17.000000', 'consum', 0.0223, 'lps'),
	(681936, 135, '2015-02-01 00:34:18.000000', 'consum', 0.0217, 'lps'),
	(681937, 135, '2015-02-01 00:34:19.000000', 'consum', 0.0259, 'lps'),
	(681938, 135, '2015-02-01 00:34:20.000000', 'consum', 0.0223, 'lps'),
	(681939, 135, '2015-02-01 00:34:21.000000', 'consum', 0.0233, 'lps'),
	(681940, 135, '2015-02-01 00:34:22.000000', 'consum', 0.0232, 'lps'),
	(681941, 135, '2015-02-01 00:34:23.000000', 'consum', 0.0255, 'lps'),
	(681942, 135, '2015-02-01 00:34:24.000000', 'consum', 0.0210, 'lps'),
	(681943, 135, '2015-02-01 00:34:25.000000', 'consum', 0.0234, 'lps'),
	(681944, 135, '2015-02-01 00:34:26.000000', 'consum', 0.0224, 'lps'),
	(681945, 135, '2015-02-01 00:34:27.000000', 'consum', 0.0261, 'lps'),
	(681946, 135, '2015-02-01 00:34:28.000000', 'consum', 0.0211, 'lps'),
	(681947, 135, '2015-02-01 00:34:29.000000', 'consum', 0.0221, 'lps'),
	(681948, 135, '2015-02-01 00:34:30.000000', 'consum', 0.0210, 'lps'),
	(681949, 135, '2015-02-01 00:34:31.000000', 'consum', 0.0231, 'lps'),
	(681950, 135, '2015-02-01 00:34:32.000000', 'consum', 0.0210, 'lps'),
	(681951, 135, '2015-02-01 00:34:33.000000', 'consum', 0.0253, 'lps'),
	(681952, 135, '2015-02-01 00:34:34.000000', 'consum', 0.0213, 'lps'),
	(681953, 135, '2015-02-01 00:34:35.000000', 'consum', 0.0257, 'lps'),
	(681954, 135, '2015-02-01 00:34:36.000000', 'consum', 0.0224, 'lps'),
	(681955, 135, '2015-02-01 00:34:37.000000', 'consum', 0.0246, 'lps'),
	(681956, 135, '2015-02-01 00:34:38.000000', 'consum', 0.0241, 'lps'),
	(681957, 135, '2015-02-01 00:34:39.000000', 'consum', 0.0258, 'lps'),
	(681958, 135, '2015-02-01 00:34:40.000000', 'consum', 0.0250, 'lps'),
	(681959, 135, '2015-02-01 00:34:41.000000', 'consum', 0.0215, 'lps'),
	(681960, 135, '2015-02-01 00:34:42.000000', 'consum', 0.0219, 'lps'),
	(681961, 135, '2015-02-01 00:34:43.000000', 'consum', 0.0244, 'lps'),
	(681962, 135, '2015-02-01 00:34:44.000000', 'consum', 0.0245, 'lps'),
	(681963, 135, '2015-02-01 00:34:45.000000', 'consum', 0.0233, 'lps'),
	(681964, 135, '2015-02-01 00:34:46.000000', 'consum', 0.0221, 'lps'),
	(681965, 135, '2015-02-01 00:34:47.000000', 'consum', 0.0248, 'lps'),
	(681966, 135, '2015-02-01 00:34:48.000000', 'consum', 0.0211, 'lps'),
	(681967, 135, '2015-02-01 00:34:49.000000', 'consum', 0.0257, 'lps'),
	(681968, 135, '2015-02-01 00:34:50.000000', 'consum', 0.0233, 'lps'),
	(681969, 135, '2015-02-01 00:34:51.000000', 'consum', 0.0237, 'lps'),
	(681970, 135, '2015-02-01 00:34:52.000000', 'consum', 0.0225, 'lps'),
	(681971, 135, '2015-02-01 00:34:53.000000', 'consum', 0.0256, 'lps'),
	(681972, 135, '2015-02-01 00:34:54.000000', 'consum', 0.0239, 'lps'),
	(681973, 135, '2015-02-01 00:34:55.000000', 'consum', 0.0214, 'lps'),
	(681974, 135, '2015-02-01 00:34:56.000000', 'consum', 0.0250, 'lps'),
	(681975, 135, '2015-02-01 00:34:57.000000', 'consum', 0.0240, 'lps'),
	(681976, 135, '2015-02-01 00:34:58.000000', 'consum', 0.0241, 'lps'),
	(681977, 135, '2015-02-01 00:34:59.000000', 'consum', 0.0222, 'lps'),
	(681978, 135, '2015-02-01 00:35:00.000000', 'consum', 0.0230, 'lps'),
	(681979, 135, '2015-02-01 00:35:01.000000', 'consum', 0.0220, 'lps'),
	(681980, 135, '2015-02-01 00:35:02.000000', 'consum', 0.0256, 'lps'),
	(681981, 135, '2015-02-01 00:35:03.000000', 'consum', 0.0252, 'lps'),
	(681982, 135, '2015-02-01 00:35:04.000000', 'consum', 0.0227, 'lps'),
	(681983, 135, '2015-02-01 00:35:05.000000', 'consum', 0.0224, 'lps'),
	(681984, 135, '2015-02-01 00:35:06.000000', 'consum', 0.0229, 'lps'),
	(681985, 135, '2015-02-01 00:35:07.000000', 'consum', 0.0211, 'lps'),
	(681986, 135, '2015-02-01 00:35:08.000000', 'consum', 0.0210, 'lps'),
	(681987, 135, '2015-02-01 00:35:09.000000', 'consum', 0.0260, 'lps'),
	(681988, 135, '2015-02-01 00:35:10.000000', 'consum', 0.0248, 'lps'),
	(681989, 135, '2015-02-01 00:35:11.000000', 'consum', 0.0251, 'lps'),
	(681990, 135, '2015-02-01 00:35:12.000000', 'consum', 0.0248, 'lps'),
	(681991, 135, '2015-02-01 00:35:13.000000', 'consum', 0.0224, 'lps'),
	(681992, 135, '2015-02-01 00:35:14.000000', 'consum', 0.0220, 'lps'),
	(681993, 135, '2015-02-01 00:35:15.000000', 'consum', 0.0221, 'lps'),
	(681994, 135, '2015-02-01 00:35:16.000000', 'consum', 0.0232, 'lps'),
	(681995, 135, '2015-02-01 00:35:17.000000', 'consum', 0.0237, 'lps'),
	(681996, 135, '2015-02-01 00:35:18.000000', 'consum', 0.0225, 'lps'),
	(681997, 135, '2015-02-01 00:35:19.000000', 'consum', 0.0259, 'lps'),
	(681998, 135, '2015-02-01 00:35:20.000000', 'consum', 0.0253, 'lps'),
	(681999, 135, '2015-02-01 00:35:21.000000', 'consum', 0.0224, 'lps'),
	(682000, 135, '2015-02-01 00:35:22.000000', 'consum', 0.0255, 'lps'),
	(682001, 135, '2015-02-01 00:35:23.000000', 'consum', 0.0238, 'lps'),
	(682002, 135, '2015-02-01 00:35:24.000000', 'consum', 0.0214, 'lps'),
	(682003, 135, '2015-02-01 00:35:25.000000', 'consum', 0.0253, 'lps'),
	(682004, 135, '2015-02-01 00:35:26.000000', 'consum', 0.0254, 'lps'),
	(682005, 135, '2015-02-01 00:35:27.000000', 'consum', 0.0247, 'lps'),
	(682006, 135, '2015-02-01 00:35:28.000000', 'consum', 0.0211, 'lps'),
	(682007, 135, '2015-02-01 00:35:29.000000', 'consum', 0.0210, 'lps'),
	(682008, 135, '2015-02-01 00:35:30.000000', 'consum', 0.0210, 'lps'),
	(682009, 135, '2015-02-01 00:35:31.000000', 'consum', 0.0260, 'lps'),
	(682010, 135, '2015-02-01 00:35:32.000000', 'consum', 0.0252, 'lps'),
	(682011, 135, '2015-02-01 00:35:33.000000', 'consum', 0.0215, 'lps'),
	(682012, 135, '2015-02-01 00:35:34.000000', 'consum', 0.0217, 'lps'),
	(682013, 135, '2015-02-01 00:35:35.000000', 'consum', 0.0232, 'lps'),
	(682014, 135, '2015-02-01 00:35:36.000000', 'consum', 0.0244, 'lps'),
	(682015, 135, '2015-02-01 00:35:37.000000', 'consum', 0.0210, 'lps'),
	(682016, 135, '2015-02-01 00:35:38.000000', 'consum', 0.0212, 'lps'),
	(682017, 135, '2015-02-01 00:35:39.000000', 'consum', 0.0223, 'lps'),
	(682018, 135, '2015-02-01 00:35:40.000000', 'consum', 0.0214, 'lps'),
	(682019, 135, '2015-02-01 00:35:41.000000', 'consum', 0.0244, 'lps'),
	(682020, 135, '2015-02-01 00:35:42.000000', 'consum', 0.0212, 'lps'),
	(682021, 135, '2015-02-01 00:35:43.000000', 'consum', 0.0225, 'lps'),
	(682022, 135, '2015-02-01 00:35:44.000000', 'consum', 0.0227, 'lps'),
	(682023, 135, '2015-02-01 00:35:45.000000', 'consum', 0.0248, 'lps'),
	(682024, 135, '2015-02-01 00:35:46.000000', 'consum', 0.0243, 'lps'),
	(682025, 135, '2015-02-01 00:35:47.000000', 'consum', 0.0261, 'lps'),
	(682026, 135, '2015-02-01 00:35:48.000000', 'consum', 0.0262, 'lps'),
	(682027, 135, '2015-02-01 00:35:49.000000', 'consum', 0.0212, 'lps'),
	(682028, 135, '2015-02-01 00:35:50.000000', 'consum', 0.0223, 'lps'),
	(682029, 135, '2015-02-01 00:35:51.000000', 'consum', 0.0217, 'lps'),
	(682030, 135, '2015-02-01 00:35:52.000000', 'consum', 0.0260, 'lps'),
	(682031, 135, '2015-02-01 00:35:53.000000', 'consum', 0.0227, 'lps'),
	(682032, 135, '2015-02-01 00:35:54.000000', 'consum', 0.0252, 'lps'),
	(682033, 135, '2015-02-01 00:35:55.000000', 'consum', 0.0212, 'lps'),
	(682034, 135, '2015-02-01 00:35:56.000000', 'consum', 0.0252, 'lps'),
	(682035, 135, '2015-02-01 00:35:57.000000', 'consum', 0.0256, 'lps'),
	(682036, 135, '2015-02-01 00:35:58.000000', 'consum', 0.0261, 'lps'),
	(682037, 135, '2015-02-01 00:35:59.000000', 'consum', 0.0221, 'lps'),
	(682038, 135, '2015-02-01 00:36:00.000000', 'consum', 0.0220, 'lps'),
	(682039, 135, '2015-02-01 00:36:01.000000', 'consum', 0.0225, 'lps'),
	(682040, 135, '2015-02-01 00:36:02.000000', 'consum', 0.0256, 'lps'),
	(682041, 135, '2015-02-01 00:36:03.000000', 'consum', 0.0237, 'lps'),
	(682042, 135, '2015-02-01 00:36:04.000000', 'consum', 0.0261, 'lps'),
	(682043, 135, '2015-02-01 00:36:05.000000', 'consum', 0.0225, 'lps'),
	(682044, 135, '2015-02-01 00:36:06.000000', 'consum', 0.0240, 'lps'),
	(682045, 135, '2015-02-01 00:36:07.000000', 'consum', 0.0262, 'lps'),
	(682046, 135, '2015-02-01 00:36:08.000000', 'consum', 0.0223, 'lps'),
	(682047, 135, '2015-02-01 00:36:09.000000', 'consum', 0.0222, 'lps'),
	(682048, 135, '2015-02-01 00:36:10.000000', 'consum', 0.0235, 'lps'),
	(682049, 135, '2015-02-01 00:36:11.000000', 'consum', 0.0245, 'lps'),
	(682050, 135, '2015-02-01 00:36:12.000000', 'consum', 0.0258, 'lps'),
	(682051, 135, '2015-02-01 00:36:13.000000', 'consum', 0.0241, 'lps'),
	(682052, 135, '2015-02-01 00:36:14.000000', 'consum', 0.0220, 'lps'),
	(682053, 135, '2015-02-01 00:36:15.000000', 'consum', 0.0220, 'lps'),
	(682054, 135, '2015-02-01 00:36:16.000000', 'consum', 0.0233, 'lps'),
	(682055, 135, '2015-02-01 00:36:17.000000', 'consum', 0.0239, 'lps'),
	(682056, 135, '2015-02-01 00:36:18.000000', 'consum', 0.0236, 'lps'),
	(682057, 135, '2015-02-01 00:36:19.000000', 'consum', 0.0251, 'lps'),
	(682058, 135, '2015-02-01 00:36:20.000000', 'consum', 0.0231, 'lps'),
	(682059, 135, '2015-02-01 00:36:21.000000', 'consum', 0.0248, 'lps'),
	(682060, 135, '2015-02-01 00:36:22.000000', 'consum', 0.0232, 'lps'),
	(682061, 135, '2015-02-01 00:36:23.000000', 'consum', 0.0258, 'lps'),
	(682062, 135, '2015-02-01 00:36:24.000000', 'consum', 0.0228, 'lps'),
	(682063, 135, '2015-02-01 00:36:25.000000', 'consum', 0.0259, 'lps'),
	(682064, 135, '2015-02-01 00:36:26.000000', 'consum', 0.0246, 'lps'),
	(682065, 135, '2015-02-01 00:36:27.000000', 'consum', 0.0242, 'lps'),
	(682066, 135, '2015-02-01 00:36:28.000000', 'consum', 0.0262, 'lps'),
	(682067, 135, '2015-02-01 00:36:29.000000', 'consum', 0.0216, 'lps'),
	(682068, 135, '2015-02-01 00:36:30.000000', 'consum', 0.0245, 'lps'),
	(682069, 135, '2015-02-01 00:36:31.000000', 'consum', 0.0259, 'lps'),
	(682070, 135, '2015-02-01 00:36:32.000000', 'consum', 0.0244, 'lps'),
	(682071, 135, '2015-02-01 00:36:33.000000', 'consum', 0.0233, 'lps'),
	(682072, 135, '2015-02-01 00:36:34.000000', 'consum', 0.0225, 'lps'),
	(682073, 135, '2015-02-01 00:36:35.000000', 'consum', 0.0217, 'lps'),
	(682074, 135, '2015-02-01 00:36:36.000000', 'consum', 0.0253, 'lps'),
	(682075, 135, '2015-02-01 00:36:37.000000', 'consum', 0.0244, 'lps'),
	(682076, 135, '2015-02-01 00:36:38.000000', 'consum', 0.0250, 'lps'),
	(682077, 135, '2015-02-01 00:36:39.000000', 'consum', 0.0259, 'lps'),
	(682078, 135, '2015-02-01 00:36:40.000000', 'consum', 0.0229, 'lps'),
	(682079, 135, '2015-02-01 00:36:41.000000', 'consum', 0.0210, 'lps'),
	(682080, 135, '2015-02-01 00:36:42.000000', 'consum', 0.0261, 'lps'),
	(682081, 135, '2015-02-01 00:36:43.000000', 'consum', 0.0251, 'lps'),
	(682082, 135, '2015-02-01 00:36:44.000000', 'consum', 0.0212, 'lps'),
	(682083, 135, '2015-02-01 00:36:45.000000', 'consum', 0.0257, 'lps'),
	(682084, 135, '2015-02-01 00:36:46.000000', 'consum', 0.0226, 'lps'),
	(682085, 135, '2015-02-01 00:36:47.000000', 'consum', 0.0254, 'lps'),
	(682086, 135, '2015-02-01 00:36:48.000000', 'consum', 0.0227, 'lps'),
	(682087, 135, '2015-02-01 00:36:49.000000', 'consum', 0.0214, 'lps'),
	(682088, 135, '2015-02-01 00:36:50.000000', 'consum', 0.0235, 'lps'),
	(682089, 135, '2015-02-01 00:36:51.000000', 'consum', 0.0218, 'lps'),
	(682090, 135, '2015-02-01 00:36:52.000000', 'consum', 0.0226, 'lps'),
	(682091, 135, '2015-02-01 00:36:53.000000', 'consum', 0.0213, 'lps'),
	(682092, 135, '2015-02-01 00:36:54.000000', 'consum', 0.0231, 'lps'),
	(682093, 135, '2015-02-01 00:36:55.000000', 'consum', 0.0253, 'lps'),
	(682094, 135, '2015-02-01 00:36:56.000000', 'consum', 0.0259, 'lps'),
	(682095, 135, '2015-02-01 00:36:57.000000', 'consum', 0.0217, 'lps'),
	(682096, 135, '2015-02-01 00:36:58.000000', 'consum', 0.0260, 'lps'),
	(682097, 135, '2015-02-01 00:36:59.000000', 'consum', 0.0227, 'lps'),
	(682098, 135, '2015-02-01 00:37:00.000000', 'consum', 0.0253, 'lps'),
	(682099, 135, '2015-02-01 00:37:01.000000', 'consum', 0.0215, 'lps'),
	(682100, 135, '2015-02-01 00:37:02.000000', 'consum', 0.0211, 'lps'),
	(682101, 135, '2015-02-01 00:37:03.000000', 'consum', 0.0254, 'lps'),
	(682102, 135, '2015-02-01 00:37:04.000000', 'consum', 0.0215, 'lps'),
	(682103, 135, '2015-02-01 00:37:05.000000', 'consum', 0.0261, 'lps'),
	(682104, 135, '2015-02-01 00:37:06.000000', 'consum', 0.0240, 'lps'),
	(682105, 135, '2015-02-01 00:37:07.000000', 'consum', 0.0260, 'lps'),
	(682106, 135, '2015-02-01 00:37:08.000000', 'consum', 0.0211, 'lps'),
	(682107, 135, '2015-02-01 00:37:09.000000', 'consum', 0.0225, 'lps'),
	(682108, 135, '2015-02-01 00:37:10.000000', 'consum', 0.0230, 'lps'),
	(682109, 135, '2015-02-01 00:37:11.000000', 'consum', 0.0210, 'lps'),
	(682110, 135, '2015-02-01 00:37:12.000000', 'consum', 0.0260, 'lps'),
	(682111, 135, '2015-02-01 00:37:13.000000', 'consum', 0.0246, 'lps'),
	(682112, 135, '2015-02-01 00:37:14.000000', 'consum', 0.0241, 'lps'),
	(682113, 135, '2015-02-01 00:37:15.000000', 'consum', 0.0258, 'lps'),
	(682114, 135, '2015-02-01 00:37:16.000000', 'consum', 0.0250, 'lps'),
	(682115, 135, '2015-02-01 00:37:17.000000', 'consum', 0.0216, 'lps'),
	(682116, 135, '2015-02-01 00:37:18.000000', 'consum', 0.0227, 'lps'),
	(682117, 135, '2015-02-01 00:37:19.000000', 'consum', 0.0223, 'lps'),
	(682118, 135, '2015-02-01 00:37:20.000000', 'consum', 0.0226, 'lps'),
	(682119, 135, '2015-02-01 00:37:21.000000', 'consum', 0.0250, 'lps'),
	(682120, 135, '2015-02-01 00:37:22.000000', 'consum', 0.0257, 'lps'),
	(682121, 135, '2015-02-01 00:37:23.000000', 'consum', 0.0218, 'lps'),
	(682122, 135, '2015-02-01 00:37:24.000000', 'consum', 0.0219, 'lps'),
	(682123, 135, '2015-02-01 00:37:25.000000', 'consum', 0.0228, 'lps'),
	(682124, 135, '2015-02-01 00:37:26.000000', 'consum', 0.0222, 'lps'),
	(682125, 135, '2015-02-01 00:37:27.000000', 'consum', 0.0215, 'lps'),
	(682126, 135, '2015-02-01 00:37:28.000000', 'consum', 0.0253, 'lps'),
	(682127, 135, '2015-02-01 00:37:29.000000', 'consum', 0.0250, 'lps'),
	(682128, 135, '2015-02-01 00:37:30.000000', 'consum', 0.0230, 'lps'),
	(682129, 135, '2015-02-01 00:37:31.000000', 'consum', 0.0245, 'lps'),
	(682130, 135, '2015-02-01 00:37:32.000000', 'consum', 0.0219, 'lps'),
	(682131, 135, '2015-02-01 00:37:33.000000', 'consum', 0.0256, 'lps'),
	(682132, 135, '2015-02-01 00:37:34.000000', 'consum', 0.0254, 'lps'),
	(682133, 135, '2015-02-01 00:37:35.000000', 'consum', 0.0238, 'lps'),
	(682134, 135, '2015-02-01 00:37:36.000000', 'consum', 0.0221, 'lps'),
	(682135, 135, '2015-02-01 00:37:37.000000', 'consum', 0.0233, 'lps'),
	(682136, 135, '2015-02-01 00:37:38.000000', 'consum', 0.0240, 'lps'),
	(682137, 135, '2015-02-01 00:37:39.000000', 'consum', 0.0241, 'lps'),
	(682138, 135, '2015-02-01 00:37:40.000000', 'consum', 0.0219, 'lps'),
	(682139, 135, '2015-02-01 00:37:41.000000', 'consum', 0.0216, 'lps'),
	(682140, 135, '2015-02-01 00:37:42.000000', 'consum', 0.0214, 'lps'),
	(682141, 135, '2015-02-01 00:37:43.000000', 'consum', 0.0211, 'lps'),
	(682142, 135, '2015-02-01 00:37:44.000000', 'consum', 0.0257, 'lps'),
	(682143, 135, '2015-02-01 00:37:45.000000', 'consum', 0.0233, 'lps'),
	(682144, 135, '2015-02-01 00:37:46.000000', 'consum', 0.0234, 'lps'),
	(682145, 135, '2015-02-01 00:37:47.000000', 'consum', 0.0212, 'lps'),
	(682146, 135, '2015-02-01 00:37:48.000000', 'consum', 0.0252, 'lps'),
	(682147, 135, '2015-02-01 00:37:49.000000', 'consum', 0.0254, 'lps'),
	(682148, 135, '2015-02-01 00:37:50.000000', 'consum', 0.0255, 'lps'),
	(682149, 135, '2015-02-01 00:37:51.000000', 'consum', 0.0249, 'lps'),
	(682150, 135, '2015-02-01 00:37:52.000000', 'consum', 0.0219, 'lps'),
	(682151, 135, '2015-02-01 00:37:53.000000', 'consum', 0.0245, 'lps'),
	(682152, 135, '2015-02-01 00:37:54.000000', 'consum', 0.0253, 'lps'),
	(682153, 135, '2015-02-01 00:37:55.000000', 'consum', 0.0214, 'lps'),
	(682154, 135, '2015-02-01 00:37:56.000000', 'consum', 0.0262, 'lps'),
	(682155, 135, '2015-02-01 00:37:57.000000', 'consum', 0.0244, 'lps'),
	(682156, 135, '2015-02-01 00:37:58.000000', 'consum', 0.0226, 'lps'),
	(682157, 135, '2015-02-01 00:37:59.000000', 'consum', 0.0241, 'lps'),
	(682158, 135, '2015-02-01 00:38:00.000000', 'consum', 0.0213, 'lps'),
	(682159, 135, '2015-02-01 00:38:01.000000', 'consum', 0.0236, 'lps'),
	(682160, 135, '2015-02-01 00:38:02.000000', 'consum', 0.0229, 'lps'),
	(682161, 135, '2015-02-01 00:38:03.000000', 'consum', 0.0224, 'lps'),
	(682162, 135, '2015-02-01 00:38:04.000000', 'consum', 0.0224, 'lps'),
	(682163, 135, '2015-02-01 00:38:05.000000', 'consum', 0.0238, 'lps'),
	(682164, 135, '2015-02-01 00:38:06.000000', 'consum', 0.0258, 'lps'),
	(682165, 135, '2015-02-01 00:38:07.000000', 'consum', 0.0261, 'lps'),
	(682166, 135, '2015-02-01 00:38:08.000000', 'consum', 0.0213, 'lps'),
	(682167, 135, '2015-02-01 00:38:09.000000', 'consum', 0.0232, 'lps'),
	(682168, 135, '2015-02-01 00:38:10.000000', 'consum', 0.0258, 'lps'),
	(682169, 135, '2015-02-01 00:38:11.000000', 'consum', 0.0226, 'lps'),
	(682170, 135, '2015-02-01 00:38:12.000000', 'consum', 0.0253, 'lps'),
	(682171, 135, '2015-02-01 00:38:13.000000', 'consum', 0.0217, 'lps'),
	(682172, 135, '2015-02-01 00:38:14.000000', 'consum', 0.0225, 'lps'),
	(682173, 135, '2015-02-01 00:38:15.000000', 'consum', 0.0210, 'lps'),
	(682174, 135, '2015-02-01 00:38:16.000000', 'consum', 0.0217, 'lps'),
	(682175, 135, '2015-02-01 00:38:17.000000', 'consum', 0.0247, 'lps'),
	(682176, 135, '2015-02-01 00:38:18.000000', 'consum', 0.0214, 'lps'),
	(682177, 135, '2015-02-01 00:38:19.000000', 'consum', 0.0227, 'lps'),
	(682178, 135, '2015-02-01 00:38:20.000000', 'consum', 0.0232, 'lps'),
	(682179, 135, '2015-02-01 00:38:21.000000', 'consum', 0.0213, 'lps'),
	(682180, 135, '2015-02-01 00:38:22.000000', 'consum', 0.0215, 'lps'),
	(682181, 135, '2015-02-01 00:38:23.000000', 'consum', 0.0227, 'lps'),
	(682182, 135, '2015-02-01 00:38:24.000000', 'consum', 0.0226, 'lps'),
	(682183, 135, '2015-02-01 00:38:25.000000', 'consum', 0.0241, 'lps'),
	(682184, 135, '2015-02-01 00:38:26.000000', 'consum', 0.0262, 'lps'),
	(682185, 135, '2015-02-01 00:38:27.000000', 'consum', 0.0222, 'lps'),
	(682186, 135, '2015-02-01 00:38:28.000000', 'consum', 0.0217, 'lps'),
	(682187, 135, '2015-02-01 00:38:29.000000', 'consum', 0.0212, 'lps'),
	(682188, 135, '2015-02-01 00:38:30.000000', 'consum', 0.0250, 'lps'),
	(682189, 135, '2015-02-01 00:38:31.000000', 'consum', 0.0245, 'lps'),
	(682190, 135, '2015-02-01 00:38:32.000000', 'consum', 0.0215, 'lps'),
	(682191, 135, '2015-02-01 00:38:33.000000', 'consum', 0.0236, 'lps'),
	(682192, 135, '2015-02-01 00:38:34.000000', 'consum', 0.0220, 'lps'),
	(682193, 135, '2015-02-01 00:38:35.000000', 'consum', 0.0234, 'lps'),
	(682194, 135, '2015-02-01 00:38:36.000000', 'consum', 0.0250, 'lps'),
	(682195, 135, '2015-02-01 00:38:37.000000', 'consum', 0.0230, 'lps'),
	(682196, 135, '2015-02-01 00:38:38.000000', 'consum', 0.0244, 'lps'),
	(682197, 135, '2015-02-01 00:38:39.000000', 'consum', 0.0216, 'lps'),
	(682198, 135, '2015-02-01 00:38:40.000000', 'consum', 0.0242, 'lps'),
	(682199, 135, '2015-02-01 00:38:41.000000', 'consum', 0.0247, 'lps'),
	(682200, 135, '2015-02-01 00:38:42.000000', 'consum', 0.0245, 'lps'),
	(682201, 135, '2015-02-01 00:38:43.000000', 'consum', 0.0225, 'lps'),
	(682202, 135, '2015-02-01 00:38:44.000000', 'consum', 0.0231, 'lps'),
	(682203, 135, '2015-02-01 00:38:45.000000', 'consum', 0.0216, 'lps'),
	(682204, 135, '2015-02-01 00:38:46.000000', 'consum', 0.0234, 'lps'),
	(682205, 135, '2015-02-01 00:38:47.000000', 'consum', 0.0256, 'lps'),
	(682206, 135, '2015-02-01 00:38:48.000000', 'consum', 0.0212, 'lps'),
	(682207, 135, '2015-02-01 00:38:49.000000', 'consum', 0.0241, 'lps'),
	(682208, 135, '2015-02-01 00:38:50.000000', 'consum', 0.0255, 'lps'),
	(682209, 135, '2015-02-01 00:38:51.000000', 'consum', 0.0234, 'lps'),
	(682210, 135, '2015-02-01 00:38:52.000000', 'consum', 0.0250, 'lps'),
	(682211, 135, '2015-02-01 00:38:53.000000', 'consum', 0.0233, 'lps'),
	(682212, 135, '2015-02-01 00:38:54.000000', 'consum', 0.0258, 'lps'),
	(682213, 135, '2015-02-01 00:38:55.000000', 'consum', 0.0224, 'lps'),
	(682214, 135, '2015-02-01 00:38:56.000000', 'consum', 0.0243, 'lps'),
	(682215, 135, '2015-02-01 00:38:57.000000', 'consum', 0.0226, 'lps'),
	(682216, 135, '2015-02-01 00:38:58.000000', 'consum', 0.0246, 'lps'),
	(682217, 135, '2015-02-01 00:38:59.000000', 'consum', 0.0237, 'lps'),
	(682218, 135, '2015-02-01 00:39:00.000000', 'consum', 0.0238, 'lps'),
	(682219, 135, '2015-02-01 00:39:01.000000', 'consum', 0.0218, 'lps'),
	(682220, 135, '2015-02-01 00:39:02.000000', 'consum', 0.0216, 'lps'),
	(682221, 135, '2015-02-01 00:39:03.000000', 'consum', 0.0217, 'lps'),
	(682222, 135, '2015-02-01 00:39:04.000000', 'consum', 0.0226, 'lps'),
	(682223, 135, '2015-02-01 00:39:05.000000', 'consum', 0.0219, 'lps'),
	(682224, 135, '2015-02-01 00:39:06.000000', 'consum', 0.0260, 'lps'),
	(682225, 135, '2015-02-01 00:39:07.000000', 'consum', 0.0220, 'lps'),
	(682226, 135, '2015-02-01 00:39:08.000000', 'consum', 0.0218, 'lps'),
	(682227, 135, '2015-02-01 00:39:09.000000', 'consum', 0.0221, 'lps'),
	(682228, 135, '2015-02-01 00:39:10.000000', 'consum', 0.0242, 'lps'),
	(682229, 135, '2015-02-01 00:39:11.000000', 'consum', 0.0230, 'lps'),
	(682230, 135, '2015-02-01 00:39:12.000000', 'consum', 0.0216, 'lps'),
	(682231, 135, '2015-02-01 00:39:13.000000', 'consum', 0.0234, 'lps'),
	(682232, 135, '2015-02-01 00:39:14.000000', 'consum', 0.0260, 'lps'),
	(682233, 135, '2015-02-01 00:39:15.000000', 'consum', 0.0229, 'lps'),
	(682234, 135, '2015-02-01 00:39:16.000000', 'consum', 0.0261, 'lps'),
	(682235, 135, '2015-02-01 00:39:17.000000', 'consum', 0.0249, 'lps'),
	(682236, 135, '2015-02-01 00:39:18.000000', 'consum', 0.0254, 'lps'),
	(682237, 135, '2015-02-01 00:39:19.000000', 'consum', 0.0258, 'lps'),
	(682238, 135, '2015-02-01 00:39:20.000000', 'consum', 0.0214, 'lps'),
	(682239, 135, '2015-02-01 00:39:21.000000', 'consum', 0.0246, 'lps'),
	(682240, 135, '2015-02-01 00:39:22.000000', 'consum', 0.0221, 'lps'),
	(682241, 135, '2015-02-01 00:39:23.000000', 'consum', 0.0260, 'lps'),
	(682242, 135, '2015-02-01 00:39:24.000000', 'consum', 0.0218, 'lps'),
	(682243, 135, '2015-02-01 00:39:25.000000', 'consum', 0.0258, 'lps'),
	(682244, 135, '2015-02-01 00:39:26.000000', 'consum', 0.0215, 'lps'),
	(682245, 135, '2015-02-01 00:39:27.000000', 'consum', 0.0250, 'lps'),
	(682246, 135, '2015-02-01 00:39:28.000000', 'consum', 0.0237, 'lps'),
	(682247, 135, '2015-02-01 00:39:29.000000', 'consum', 0.0226, 'lps'),
	(682248, 135, '2015-02-01 00:39:30.000000', 'consum', 0.0210, 'lps'),
	(682249, 135, '2015-02-01 00:39:31.000000', 'consum', 0.0216, 'lps'),
	(682250, 135, '2015-02-01 00:39:32.000000', 'consum', 0.0239, 'lps'),
	(682251, 135, '2015-02-01 00:39:33.000000', 'consum', 0.0230, 'lps'),
	(682252, 135, '2015-02-01 00:39:34.000000', 'consum', 0.0226, 'lps'),
	(682253, 135, '2015-02-01 00:39:35.000000', 'consum', 0.0231, 'lps'),
	(682254, 135, '2015-02-01 00:39:36.000000', 'consum', 0.0213, 'lps'),
	(682255, 135, '2015-02-01 00:39:37.000000', 'consum', 0.0214, 'lps'),
	(682256, 135, '2015-02-01 00:39:38.000000', 'consum', 0.0224, 'lps'),
	(682257, 135, '2015-02-01 00:39:39.000000', 'consum', 0.0216, 'lps'),
	(682258, 135, '2015-02-01 00:39:40.000000', 'consum', 0.0249, 'lps'),
	(682259, 135, '2015-02-01 00:39:41.000000', 'consum', 0.0229, 'lps'),
	(682260, 135, '2015-02-01 00:39:42.000000', 'consum', 0.0242, 'lps'),
	(682261, 135, '2015-02-01 00:39:43.000000', 'consum', 0.0260, 'lps'),
	(682262, 135, '2015-02-01 00:39:44.000000', 'consum', 0.0259, 'lps'),
	(682263, 135, '2015-02-01 00:39:45.000000', 'consum', 0.0250, 'lps'),
	(682264, 135, '2015-02-01 00:39:46.000000', 'consum', 0.0213, 'lps'),
	(682265, 135, '2015-02-01 00:39:47.000000', 'consum', 0.0212, 'lps'),
	(682266, 135, '2015-02-01 00:39:48.000000', 'consum', 0.0211, 'lps'),
	(682267, 135, '2015-02-01 00:39:49.000000', 'consum', 0.0211, 'lps'),
	(682268, 135, '2015-02-01 00:39:50.000000', 'consum', 0.0213, 'lps'),
	(682269, 135, '2015-02-01 00:39:51.000000', 'consum', 0.0220, 'lps'),
	(682270, 135, '2015-02-01 00:39:52.000000', 'consum', 0.0254, 'lps'),
	(682271, 135, '2015-02-01 00:39:53.000000', 'consum', 0.0239, 'lps'),
	(682272, 135, '2015-02-01 00:39:54.000000', 'consum', 0.0225, 'lps'),
	(682273, 135, '2015-02-01 00:39:55.000000', 'consum', 0.0250, 'lps'),
	(682274, 135, '2015-02-01 00:39:56.000000', 'consum', 0.0260, 'lps'),
	(682275, 135, '2015-02-01 00:39:57.000000', 'consum', 0.0234, 'lps'),
	(682276, 135, '2015-02-01 00:39:58.000000', 'consum', 0.0234, 'lps'),
	(682277, 135, '2015-02-01 00:39:59.000000', 'consum', 0.0257, 'lps'),
	(682278, 135, '2015-02-01 00:40:00.000000', 'consum', 0.0218, 'lps'),
	(682279, 135, '2015-02-01 00:40:01.000000', 'consum', 0.0212, 'lps'),
	(682280, 135, '2015-02-01 00:40:02.000000', 'consum', 0.0249, 'lps'),
	(682281, 135, '2015-02-01 00:40:03.000000', 'consum', 0.0243, 'lps'),
	(682282, 135, '2015-02-01 00:40:04.000000', 'consum', 0.0257, 'lps'),
	(682283, 135, '2015-02-01 00:40:05.000000', 'consum', 0.0243, 'lps'),
	(682284, 135, '2015-02-01 00:40:06.000000', 'consum', 0.0231, 'lps'),
	(682285, 135, '2015-02-01 00:40:07.000000', 'consum', 0.0218, 'lps'),
	(682286, 135, '2015-02-01 00:40:08.000000', 'consum', 0.0241, 'lps'),
	(682287, 135, '2015-02-01 00:40:09.000000', 'consum', 0.0237, 'lps'),
	(682288, 135, '2015-02-01 00:40:10.000000', 'consum', 0.0251, 'lps'),
	(682289, 135, '2015-02-01 00:40:11.000000', 'consum', 0.0229, 'lps'),
	(682290, 135, '2015-02-01 00:40:12.000000', 'consum', 0.0235, 'lps'),
	(682291, 135, '2015-02-01 00:40:13.000000', 'consum', 0.0227, 'lps'),
	(682292, 135, '2015-02-01 00:40:14.000000', 'consum', 0.0220, 'lps'),
	(682293, 135, '2015-02-01 00:40:15.000000', 'consum', 0.0211, 'lps'),
	(682294, 135, '2015-02-01 00:40:16.000000', 'consum', 0.0237, 'lps'),
	(682295, 135, '2015-02-01 00:40:17.000000', 'consum', 0.0237, 'lps'),
	(682296, 135, '2015-02-01 00:40:18.000000', 'consum', 0.0212, 'lps'),
	(682297, 135, '2015-02-01 00:40:19.000000', 'consum', 0.0246, 'lps'),
	(682298, 135, '2015-02-01 00:40:20.000000', 'consum', 0.0226, 'lps'),
	(682299, 135, '2015-02-01 00:40:21.000000', 'consum', 0.0235, 'lps'),
	(682300, 135, '2015-02-01 00:40:22.000000', 'consum', 0.0234, 'lps'),
	(682301, 135, '2015-02-01 00:40:23.000000', 'consum', 0.0255, 'lps'),
	(682302, 135, '2015-02-01 00:40:24.000000', 'consum', 0.0257, 'lps'),
	(682303, 135, '2015-02-01 00:40:25.000000', 'consum', 0.0259, 'lps'),
	(682304, 135, '2015-02-01 00:40:26.000000', 'consum', 0.0262, 'lps'),
	(682305, 135, '2015-02-01 00:40:27.000000', 'consum', 0.0215, 'lps'),
	(682306, 135, '2015-02-01 00:40:28.000000', 'consum', 0.0239, 'lps'),
	(682307, 135, '2015-02-01 00:40:29.000000', 'consum', 0.0234, 'lps'),
	(682308, 135, '2015-02-01 00:40:30.000000', 'consum', 0.0246, 'lps'),
	(682309, 135, '2015-02-01 00:40:31.000000', 'consum', 0.0212, 'lps'),
	(682310, 135, '2015-02-01 00:40:32.000000', 'consum', 0.0219, 'lps'),
	(682311, 135, '2015-02-01 00:40:33.000000', 'consum', 0.0250, 'lps'),
	(682312, 135, '2015-02-01 00:40:34.000000', 'consum', 0.0224, 'lps'),
	(682313, 135, '2015-02-01 00:40:35.000000', 'consum', 0.0211, 'lps'),
	(682314, 135, '2015-02-01 00:40:36.000000', 'consum', 0.0229, 'lps'),
	(682315, 135, '2015-02-01 00:40:37.000000', 'consum', 0.0250, 'lps'),
	(682316, 135, '2015-02-01 00:40:38.000000', 'consum', 0.0248, 'lps'),
	(682317, 135, '2015-02-01 00:40:39.000000', 'consum', 0.0225, 'lps'),
	(682318, 135, '2015-02-01 00:40:40.000000', 'consum', 0.0226, 'lps'),
	(682319, 135, '2015-02-01 00:40:41.000000', 'consum', 0.0243, 'lps'),
	(682320, 135, '2015-02-01 00:40:42.000000', 'consum', 0.0225, 'lps'),
	(682321, 135, '2015-02-01 00:40:43.000000', 'consum', 0.0236, 'lps'),
	(682322, 135, '2015-02-01 00:40:44.000000', 'consum', 0.0245, 'lps'),
	(682323, 135, '2015-02-01 00:40:45.000000', 'consum', 0.0253, 'lps'),
	(682324, 135, '2015-02-01 00:40:46.000000', 'consum', 0.0217, 'lps'),
	(682325, 135, '2015-02-01 00:40:47.000000', 'consum', 0.0220, 'lps'),
	(682326, 135, '2015-02-01 00:40:48.000000', 'consum', 0.0242, 'lps'),
	(682327, 135, '2015-02-01 00:40:49.000000', 'consum', 0.0232, 'lps'),
	(682328, 135, '2015-02-01 00:40:50.000000', 'consum', 0.0224, 'lps'),
	(682329, 135, '2015-02-01 00:40:51.000000', 'consum', 0.0215, 'lps'),
	(682330, 135, '2015-02-01 00:40:52.000000', 'consum', 0.0247, 'lps'),
	(682331, 135, '2015-02-01 00:40:53.000000', 'consum', 0.0222, 'lps'),
	(682332, 135, '2015-02-01 00:40:54.000000', 'consum', 0.0214, 'lps'),
	(682333, 135, '2015-02-01 00:40:55.000000', 'consum', 0.0246, 'lps'),
	(682334, 135, '2015-02-01 00:40:56.000000', 'consum', 0.0221, 'lps'),
	(682335, 135, '2015-02-01 00:40:57.000000', 'consum', 0.0211, 'lps'),
	(682336, 135, '2015-02-01 00:40:58.000000', 'consum', 0.0234, 'lps'),
	(682337, 135, '2015-02-01 00:40:59.000000', 'consum', 0.0222, 'lps'),
	(682338, 135, '2015-02-01 00:41:00.000000', 'consum', 0.0252, 'lps'),
	(682339, 135, '2015-02-01 00:41:01.000000', 'consum', 0.0223, 'lps'),
	(682340, 135, '2015-02-01 00:41:02.000000', 'consum', 0.0258, 'lps'),
	(682341, 135, '2015-02-01 00:41:03.000000', 'consum', 0.0253, 'lps'),
	(682342, 135, '2015-02-01 00:41:04.000000', 'consum', 0.0229, 'lps'),
	(682343, 135, '2015-02-01 00:41:05.000000', 'consum', 0.0228, 'lps'),
	(682344, 135, '2015-02-01 00:41:06.000000', 'consum', 0.0243, 'lps'),
	(682345, 135, '2015-02-01 00:41:07.000000', 'consum', 0.0215, 'lps'),
	(682346, 135, '2015-02-01 00:41:08.000000', 'consum', 0.0242, 'lps'),
	(682347, 135, '2015-02-01 00:41:09.000000', 'consum', 0.0250, 'lps'),
	(682348, 135, '2015-02-01 00:41:10.000000', 'consum', 0.0262, 'lps'),
	(682349, 135, '2015-02-01 00:41:11.000000', 'consum', 0.0246, 'lps'),
	(682350, 135, '2015-02-01 00:41:12.000000', 'consum', 0.0235, 'lps'),
	(682351, 135, '2015-02-01 00:41:13.000000', 'consum', 0.0227, 'lps'),
	(682352, 135, '2015-02-01 00:41:14.000000', 'consum', 0.0222, 'lps'),
	(682353, 135, '2015-02-01 00:41:15.000000', 'consum', 0.0216, 'lps'),
	(682354, 135, '2015-02-01 00:41:16.000000', 'consum', 0.0261, 'lps'),
	(682355, 135, '2015-02-01 00:41:17.000000', 'consum', 0.0232, 'lps'),
	(682356, 135, '2015-02-01 00:41:18.000000', 'consum', 0.0222, 'lps'),
	(682357, 135, '2015-02-01 00:41:19.000000', 'consum', 0.0259, 'lps'),
	(682358, 135, '2015-02-01 00:41:20.000000', 'consum', 0.0261, 'lps'),
	(682359, 135, '2015-02-01 00:41:21.000000', 'consum', 0.0211, 'lps'),
	(682360, 135, '2015-02-01 00:41:22.000000', 'consum', 0.0224, 'lps'),
	(682361, 135, '2015-02-01 00:41:23.000000', 'consum', 0.0222, 'lps'),
	(682362, 135, '2015-02-01 00:41:24.000000', 'consum', 0.0229, 'lps'),
	(682363, 135, '2015-02-01 00:41:25.000000', 'consum', 0.0217, 'lps'),
	(682364, 135, '2015-02-01 00:41:26.000000', 'consum', 0.0243, 'lps'),
	(682365, 135, '2015-02-01 00:41:27.000000', 'consum', 0.0247, 'lps'),
	(682366, 135, '2015-02-01 00:41:28.000000', 'consum', 0.0245, 'lps'),
	(682367, 135, '2015-02-01 00:41:29.000000', 'consum', 0.0222, 'lps'),
	(682368, 135, '2015-02-01 00:41:30.000000', 'consum', 0.0216, 'lps'),
	(682369, 135, '2015-02-01 00:41:31.000000', 'consum', 0.0258, 'lps'),
	(682370, 135, '2015-02-01 00:41:32.000000', 'consum', 0.0223, 'lps'),
	(682371, 135, '2015-02-01 00:41:33.000000', 'consum', 0.0234, 'lps'),
	(682372, 135, '2015-02-01 00:41:34.000000', 'consum', 0.0240, 'lps'),
	(682373, 135, '2015-02-01 00:41:35.000000', 'consum', 0.0236, 'lps'),
	(682374, 135, '2015-02-01 00:41:36.000000', 'consum', 0.0251, 'lps'),
	(682375, 135, '2015-02-01 00:41:37.000000', 'consum', 0.0233, 'lps'),
	(682376, 135, '2015-02-01 00:41:38.000000', 'consum', 0.0254, 'lps'),
	(682377, 135, '2015-02-01 00:41:39.000000', 'consum', 0.0254, 'lps'),
	(682378, 135, '2015-02-01 00:41:40.000000', 'consum', 0.0246, 'lps'),
	(682379, 135, '2015-02-01 00:41:41.000000', 'consum', 0.0258, 'lps'),
	(682380, 135, '2015-02-01 00:41:42.000000', 'consum', 0.0236, 'lps'),
	(682381, 135, '2015-02-01 00:41:43.000000', 'consum', 0.0252, 'lps'),
	(682382, 135, '2015-02-01 00:41:44.000000', 'consum', 0.0234, 'lps'),
	(682383, 135, '2015-02-01 00:41:45.000000', 'consum', 0.0257, 'lps'),
	(682384, 135, '2015-02-01 00:41:46.000000', 'consum', 0.0214, 'lps'),
	(682385, 135, '2015-02-01 00:41:47.000000', 'consum', 0.0252, 'lps'),
	(682386, 135, '2015-02-01 00:41:48.000000', 'consum', 0.0246, 'lps'),
	(682387, 135, '2015-02-01 00:41:49.000000', 'consum', 0.0212, 'lps'),
	(682388, 135, '2015-02-01 00:41:50.000000', 'consum', 0.0218, 'lps'),
	(682389, 135, '2015-02-01 00:41:51.000000', 'consum', 0.0244, 'lps'),
	(682390, 135, '2015-02-01 00:41:52.000000', 'consum', 0.0251, 'lps'),
	(682391, 135, '2015-02-01 00:41:53.000000', 'consum', 0.0262, 'lps'),
	(682392, 135, '2015-02-01 00:41:54.000000', 'consum', 0.0242, 'lps'),
	(682393, 135, '2015-02-01 00:41:55.000000', 'consum', 0.0216, 'lps'),
	(682394, 135, '2015-02-01 00:41:56.000000', 'consum', 0.0247, 'lps'),
	(682395, 135, '2015-02-01 00:41:57.000000', 'consum', 0.0221, 'lps'),
	(682396, 135, '2015-02-01 00:41:58.000000', 'consum', 0.0259, 'lps'),
	(682397, 135, '2015-02-01 00:41:59.000000', 'consum', 0.0210, 'lps'),
	(682398, 135, '2015-02-01 00:42:00.000000', 'consum', 0.0222, 'lps'),
	(682399, 135, '2015-02-01 00:42:01.000000', 'consum', 0.0219, 'lps'),
	(682400, 135, '2015-02-01 00:42:02.000000', 'consum', 0.0220, 'lps'),
	(682401, 135, '2015-02-01 00:42:03.000000', 'consum', 0.0232, 'lps'),
	(682402, 135, '2015-02-01 00:42:04.000000', 'consum', 0.0239, 'lps'),
	(682403, 135, '2015-02-01 00:42:05.000000', 'consum', 0.0234, 'lps'),
	(682404, 135, '2015-02-01 00:42:06.000000', 'consum', 0.0245, 'lps'),
	(682405, 135, '2015-02-01 00:42:07.000000', 'consum', 0.0262, 'lps'),
	(682406, 135, '2015-02-01 00:42:08.000000', 'consum', 0.0256, 'lps'),
	(682407, 135, '2015-02-01 00:42:09.000000', 'consum', 0.0235, 'lps'),
	(682408, 135, '2015-02-01 00:42:10.000000', 'consum', 0.0250, 'lps'),
	(682409, 135, '2015-02-01 00:42:11.000000', 'consum', 0.0228, 'lps'),
	(682410, 135, '2015-02-01 00:42:12.000000', 'consum', 0.0233, 'lps'),
	(682411, 135, '2015-02-01 00:42:13.000000', 'consum', 0.0220, 'lps'),
	(682412, 135, '2015-02-01 00:42:14.000000', 'consum', 0.0245, 'lps'),
	(682413, 135, '2015-02-01 00:42:15.000000', 'consum', 0.0250, 'lps'),
	(682414, 135, '2015-02-01 00:42:16.000000', 'consum', 0.0251, 'lps'),
	(682415, 135, '2015-02-01 00:42:17.000000', 'consum', 0.0243, 'lps'),
	(682416, 135, '2015-02-01 00:42:18.000000', 'consum', 0.0254, 'lps'),
	(682417, 135, '2015-02-01 00:42:19.000000', 'consum', 0.0224, 'lps'),
	(682418, 135, '2015-02-01 00:42:20.000000', 'consum', 0.0253, 'lps'),
	(682419, 135, '2015-02-01 00:42:21.000000', 'consum', 0.0226, 'lps'),
	(682420, 135, '2015-02-01 00:42:22.000000', 'consum', 0.0214, 'lps'),
	(682421, 135, '2015-02-01 00:42:23.000000', 'consum', 0.0235, 'lps'),
	(682422, 135, '2015-02-01 00:42:24.000000', 'consum', 0.0219, 'lps'),
	(682423, 135, '2015-02-01 00:42:25.000000', 'consum', 0.0233, 'lps'),
	(682424, 135, '2015-02-01 00:42:26.000000', 'consum', 0.0246, 'lps'),
	(682425, 135, '2015-02-01 00:42:27.000000', 'consum', 0.0215, 'lps'),
	(682426, 135, '2015-02-01 00:42:28.000000', 'consum', 0.0233, 'lps'),
	(682427, 135, '2015-02-01 00:42:29.000000', 'consum', 0.0259, 'lps'),
	(682428, 135, '2015-02-01 00:42:30.000000', 'consum', 0.0228, 'lps'),
	(682429, 135, '2015-02-01 00:42:31.000000', 'consum', 0.0261, 'lps'),
	(682430, 135, '2015-02-01 00:42:32.000000', 'consum', 0.0249, 'lps'),
	(682431, 135, '2015-02-01 00:42:33.000000', 'consum', 0.0255, 'lps'),
	(682432, 135, '2015-02-01 00:42:34.000000', 'consum', 0.0210, 'lps'),
	(682433, 135, '2015-02-01 00:42:35.000000', 'consum', 0.0234, 'lps'),
	(682434, 135, '2015-02-01 00:42:36.000000', 'consum', 0.0227, 'lps'),
	(682435, 135, '2015-02-01 00:42:37.000000', 'consum', 0.0221, 'lps'),
	(682436, 135, '2015-02-01 00:42:38.000000', 'consum', 0.0216, 'lps'),
	(682437, 135, '2015-02-01 00:42:39.000000', 'consum', 0.0260, 'lps'),
	(682438, 135, '2015-02-01 00:42:40.000000', 'consum', 0.0229, 'lps'),
	(682439, 135, '2015-02-01 00:42:41.000000', 'consum', 0.0262, 'lps'),
	(682440, 135, '2015-02-01 00:42:42.000000', 'consum', 0.0254, 'lps'),
	(682441, 135, '2015-02-01 00:42:43.000000', 'consum', 0.0224, 'lps'),
	(682442, 135, '2015-02-01 00:42:44.000000', 'consum', 0.0253, 'lps'),
	(682443, 135, '2015-02-01 00:42:45.000000', 'consum', 0.0226, 'lps'),
	(682444, 135, '2015-02-01 00:42:46.000000', 'consum', 0.0214, 'lps'),
	(682445, 135, '2015-02-01 00:42:47.000000', 'consum', 0.0234, 'lps'),
	(682446, 135, '2015-02-01 00:42:48.000000', 'consum', 0.0215, 'lps'),
	(682447, 135, '2015-02-01 00:42:49.000000', 'consum', 0.0216, 'lps'),
	(682448, 135, '2015-02-01 00:42:50.000000', 'consum', 0.0226, 'lps'),
	(682449, 135, '2015-02-01 00:42:51.000000', 'consum', 0.0220, 'lps'),
	(682450, 135, '2015-02-01 00:42:52.000000', 'consum', 0.0211, 'lps'),
	(682451, 135, '2015-02-01 00:42:53.000000', 'consum', 0.0237, 'lps'),
	(682452, 135, '2015-02-01 00:42:54.000000', 'consum', 0.0240, 'lps'),
	(682453, 135, '2015-02-01 00:42:55.000000', 'consum', 0.0225, 'lps'),
	(682454, 135, '2015-02-01 00:42:56.000000', 'consum', 0.0247, 'lps'),
	(682455, 135, '2015-02-01 00:42:57.000000', 'consum', 0.0246, 'lps'),
	(682456, 135, '2015-02-01 00:42:58.000000', 'consum', 0.0227, 'lps'),
	(682457, 135, '2015-02-01 00:42:59.000000', 'consum', 0.0238, 'lps'),
	(682458, 135, '2015-02-01 00:43:00.000000', 'consum', 0.0248, 'lps'),
	(682459, 135, '2015-02-01 00:43:01.000000', 'consum', 0.0211, 'lps'),
	(682460, 135, '2015-02-01 00:43:02.000000', 'consum', 0.0261, 'lps'),
	(682461, 135, '2015-02-01 00:43:03.000000', 'consum', 0.0248, 'lps'),
	(682462, 135, '2015-02-01 00:43:04.000000', 'consum', 0.0248, 'lps'),
	(682463, 135, '2015-02-01 00:43:05.000000', 'consum', 0.0236, 'lps'),
	(682464, 135, '2015-02-01 00:43:06.000000', 'consum', 0.0225, 'lps'),
	(682465, 135, '2015-02-01 00:43:07.000000', 'consum', 0.0259, 'lps'),
	(682466, 135, '2015-02-01 00:43:08.000000', 'consum', 0.0252, 'lps'),
	(682467, 135, '2015-02-01 00:43:09.000000', 'consum', 0.0220, 'lps'),
	(682468, 135, '2015-02-01 00:43:10.000000', 'consum', 0.0241, 'lps'),
	(682469, 135, '2015-02-01 00:43:11.000000', 'consum', 0.0228, 'lps'),
	(682470, 135, '2015-02-01 00:43:12.000000', 'consum', 0.0261, 'lps'),
	(682471, 135, '2015-02-01 00:43:13.000000', 'consum', 0.0254, 'lps'),
	(682472, 135, '2015-02-01 00:43:14.000000', 'consum', 0.0222, 'lps'),
	(682473, 135, '2015-02-01 00:43:15.000000', 'consum', 0.0245, 'lps'),
	(682474, 135, '2015-02-01 00:43:16.000000', 'consum', 0.0244, 'lps'),
	(682475, 135, '2015-02-01 00:43:17.000000', 'consum', 0.0222, 'lps'),
	(682476, 135, '2015-02-01 00:43:18.000000', 'consum', 0.0220, 'lps'),
	(682477, 135, '2015-02-01 00:43:19.000000', 'consum', 0.0227, 'lps'),
	(682478, 135, '2015-02-01 00:43:20.000000', 'consum', 0.0212, 'lps'),
	(682479, 135, '2015-02-01 00:43:21.000000', 'consum', 0.0221, 'lps'),
	(682480, 135, '2015-02-01 00:43:22.000000', 'consum', 0.0260, 'lps'),
	(682481, 135, '2015-02-01 00:43:23.000000', 'consum', 0.0217, 'lps'),
	(682482, 135, '2015-02-01 00:43:24.000000', 'consum', 0.0252, 'lps'),
	(682483, 135, '2015-02-01 00:43:25.000000', 'consum', 0.0243, 'lps'),
	(682484, 135, '2015-02-01 00:43:26.000000', 'consum', 0.0247, 'lps'),
	(682485, 135, '2015-02-01 00:43:27.000000', 'consum', 0.0246, 'lps'),
	(682486, 135, '2015-02-01 00:43:28.000000', 'consum', 0.0226, 'lps'),
	(682487, 135, '2015-02-01 00:43:29.000000', 'consum', 0.0235, 'lps'),
	(682488, 135, '2015-02-01 00:43:30.000000', 'consum', 0.0235, 'lps'),
	(682489, 135, '2015-02-01 00:43:31.000000', 'consum', 0.0259, 'lps'),
	(682490, 135, '2015-02-01 00:43:32.000000', 'consum', 0.0224, 'lps'),
	(682491, 135, '2015-02-01 00:43:33.000000', 'consum', 0.0238, 'lps'),
	(682492, 135, '2015-02-01 00:43:34.000000', 'consum', 0.0257, 'lps'),
	(682493, 135, '2015-02-01 00:43:35.000000', 'consum', 0.0254, 'lps'),
	(682494, 135, '2015-02-01 00:43:36.000000', 'consum', 0.0237, 'lps'),
	(682495, 135, '2015-02-01 00:43:37.000000', 'consum', 0.0214, 'lps'),
	(682496, 135, '2015-02-01 00:43:38.000000', 'consum', 0.0255, 'lps'),
	(682497, 135, '2015-02-01 00:43:39.000000', 'consum', 0.0213, 'lps'),
	(682498, 135, '2015-02-01 00:43:40.000000', 'consum', 0.0248, 'lps'),
	(682499, 135, '2015-02-01 00:43:41.000000', 'consum', 0.0232, 'lps'),
	(682500, 135, '2015-02-01 00:43:42.000000', 'consum', 0.0260, 'lps'),
	(682501, 135, '2015-02-01 00:43:43.000000', 'consum', 0.0234, 'lps'),
	(682502, 135, '2015-02-01 00:43:44.000000', 'consum', 0.0234, 'lps'),
	(682503, 135, '2015-02-01 00:43:45.000000', 'consum', 0.0259, 'lps'),
	(682504, 135, '2015-02-01 00:43:46.000000', 'consum', 0.0223, 'lps'),
	(682505, 135, '2015-02-01 00:43:47.000000', 'consum', 0.0237, 'lps'),
	(682506, 135, '2015-02-01 00:43:48.000000', 'consum', 0.0255, 'lps'),
	(682507, 135, '2015-02-01 00:43:49.000000', 'consum', 0.0245, 'lps'),
	(682508, 135, '2015-02-01 00:43:50.000000', 'consum', 0.0251, 'lps'),
	(682509, 135, '2015-02-01 00:43:51.000000', 'consum', 0.0258, 'lps'),
	(682510, 135, '2015-02-01 00:43:52.000000', 'consum', 0.0221, 'lps'),
	(682511, 135, '2015-02-01 00:43:53.000000', 'consum', 0.0227, 'lps'),
	(682512, 135, '2015-02-01 00:43:54.000000', 'consum', 0.0262, 'lps'),
	(682513, 135, '2015-02-01 00:43:55.000000', 'consum', 0.0210, 'lps'),
	(682514, 135, '2015-02-01 00:43:56.000000', 'consum', 0.0212, 'lps'),
	(682515, 135, '2015-02-01 00:43:57.000000', 'consum', 0.0222, 'lps'),
	(682516, 135, '2015-02-01 00:43:58.000000', 'consum', 0.0262, 'lps'),
	(682517, 135, '2015-02-01 00:43:59.000000', 'consum', 0.0224, 'lps'),
	(682518, 135, '2015-02-01 00:44:00.000000', 'consum', 0.0229, 'lps'),
	(682519, 135, '2015-02-01 00:44:01.000000', 'consum', 0.0213, 'lps'),
	(682520, 135, '2015-02-01 00:44:02.000000', 'consum', 0.0222, 'lps'),
	(682521, 135, '2015-02-01 00:44:03.000000', 'consum', 0.0261, 'lps'),
	(682522, 135, '2015-02-01 00:44:04.000000', 'consum', 0.0216, 'lps'),
	(682523, 135, '2015-02-01 00:44:05.000000', 'consum', 0.0248, 'lps'),
	(682524, 135, '2015-02-01 00:44:06.000000', 'consum', 0.0221, 'lps'),
	(682525, 135, '2015-02-01 00:44:07.000000', 'consum', 0.0260, 'lps'),
	(682526, 135, '2015-02-01 00:44:08.000000', 'consum', 0.0214, 'lps'),
	(682527, 135, '2015-02-01 00:44:09.000000', 'consum', 0.0238, 'lps'),
	(682528, 135, '2015-02-01 00:44:10.000000', 'consum', 0.0234, 'lps'),
	(682529, 135, '2015-02-01 00:44:11.000000', 'consum', 0.0246, 'lps'),
	(682530, 135, '2015-02-01 00:44:12.000000', 'consum', 0.0212, 'lps'),
	(682531, 135, '2015-02-01 00:44:13.000000', 'consum', 0.0219, 'lps'),
	(682532, 135, '2015-02-01 00:44:14.000000', 'consum', 0.0251, 'lps'),
	(682533, 135, '2015-02-01 00:44:15.000000', 'consum', 0.0227, 'lps'),
	(682534, 135, '2015-02-01 00:44:16.000000', 'consum', 0.0225, 'lps'),
	(682535, 135, '2015-02-01 00:44:17.000000', 'consum', 0.0236, 'lps'),
	(682536, 135, '2015-02-01 00:44:18.000000', 'consum', 0.0243, 'lps'),
	(682537, 135, '2015-02-01 00:44:19.000000', 'consum', 0.0243, 'lps'),
	(682538, 135, '2015-02-01 00:44:20.000000', 'consum', 0.0225, 'lps'),
	(682539, 135, '2015-02-01 00:44:21.000000', 'consum', 0.0237, 'lps'),
	(682540, 135, '2015-02-01 00:44:22.000000', 'consum', 0.0248, 'lps'),
	(682541, 135, '2015-02-01 00:44:23.000000', 'consum', 0.0216, 'lps'),
	(682542, 135, '2015-02-01 00:44:24.000000', 'consum', 0.0229, 'lps'),
	(682543, 135, '2015-02-01 00:44:25.000000', 'consum', 0.0238, 'lps'),
	(682544, 135, '2015-02-01 00:44:26.000000', 'consum', 0.0238, 'lps'),
	(682545, 135, '2015-02-01 00:44:27.000000', 'consum', 0.0213, 'lps'),
	(682546, 135, '2015-02-01 00:44:28.000000', 'consum', 0.0250, 'lps'),
	(682547, 135, '2015-02-01 00:44:29.000000', 'consum', 0.0240, 'lps'),
	(682548, 135, '2015-02-01 00:44:30.000000', 'consum', 0.0243, 'lps'),
	(682549, 135, '2015-02-01 00:44:31.000000', 'consum', 0.0233, 'lps'),
	(682550, 135, '2015-02-01 00:44:32.000000', 'consum', 0.0225, 'lps'),
	(682551, 135, '2015-02-01 00:44:33.000000', 'consum', 0.0218, 'lps'),
	(682552, 135, '2015-02-01 00:44:34.000000', 'consum', 0.0258, 'lps'),
	(682553, 135, '2015-02-01 00:44:35.000000', 'consum', 0.0214, 'lps'),
	(682554, 135, '2015-02-01 00:44:36.000000', 'consum', 0.0248, 'lps'),
	(682555, 135, '2015-02-01 00:44:37.000000', 'consum', 0.0226, 'lps'),
	(682556, 135, '2015-02-01 00:44:38.000000', 'consum', 0.0230, 'lps'),
	(682557, 135, '2015-02-01 00:44:39.000000', 'consum', 0.0210, 'lps'),
	(682558, 135, '2015-02-01 00:44:40.000000', 'consum', 0.0257, 'lps'),
	(682559, 135, '2015-02-01 00:44:41.000000', 'consum', 0.0232, 'lps'),
	(682560, 135, '2015-02-01 00:44:42.000000', 'consum', 0.0235, 'lps'),
	(682561, 135, '2015-02-01 00:44:43.000000', 'consum', 0.0217, 'lps'),
	(682562, 135, '2015-02-01 00:44:44.000000', 'consum', 0.0222, 'lps'),
	(682563, 135, '2015-02-01 00:44:45.000000', 'consum', 0.0250, 'lps'),
	(682564, 135, '2015-02-01 00:44:46.000000', 'consum', 0.0216, 'lps'),
	(682565, 135, '2015-02-01 00:44:47.000000', 'consum', 0.0224, 'lps'),
	(682566, 135, '2015-02-01 00:44:48.000000', 'consum', 0.0213, 'lps'),
	(682567, 135, '2015-02-01 00:44:49.000000', 'consum', 0.0235, 'lps'),
	(682568, 135, '2015-02-01 00:44:50.000000', 'consum', 0.0221, 'lps'),
	(682569, 135, '2015-02-01 00:44:51.000000', 'consum', 0.0245, 'lps'),
	(682570, 135, '2015-02-01 00:44:52.000000', 'consum', 0.0244, 'lps'),
	(682571, 135, '2015-02-01 00:44:53.000000', 'consum', 0.0223, 'lps'),
	(682572, 135, '2015-02-01 00:44:54.000000', 'consum', 0.0225, 'lps'),
	(682573, 135, '2015-02-01 00:44:55.000000', 'consum', 0.0247, 'lps'),
	(682574, 135, '2015-02-01 00:44:56.000000', 'consum', 0.0244, 'lps'),
	(682575, 135, '2015-02-01 00:44:57.000000', 'consum', 0.0219, 'lps'),
	(682576, 135, '2015-02-01 00:44:58.000000', 'consum', 0.0259, 'lps'),
	(682577, 135, '2015-02-01 00:44:59.000000', 'consum', 0.0216, 'lps'),
	(682578, 135, '2015-02-01 00:45:00.000000', 'consum', 0.0252, 'lps'),
	(682579, 135, '2015-02-01 00:45:01.000000', 'consum', 0.0243, 'lps'),
	(682580, 135, '2015-02-01 00:45:02.000000', 'consum', 0.0252, 'lps'),
	(682581, 135, '2015-02-01 00:45:03.000000', 'consum', 0.0215, 'lps'),
	(682582, 135, '2015-02-01 00:45:04.000000', 'consum', 0.0213, 'lps'),
	(682583, 135, '2015-02-01 00:45:05.000000', 'consum', 0.0213, 'lps'),
	(682584, 135, '2015-02-01 00:45:06.000000', 'consum', 0.0216, 'lps'),
	(682585, 135, '2015-02-01 00:45:07.000000', 'consum', 0.0233, 'lps'),
	(682586, 135, '2015-02-01 00:45:08.000000', 'consum', 0.0255, 'lps'),
	(682587, 135, '2015-02-01 00:45:09.000000', 'consum', 0.0259, 'lps'),
	(682588, 135, '2015-02-01 00:45:10.000000', 'consum', 0.0214, 'lps'),
	(682589, 135, '2015-02-01 00:45:11.000000', 'consum', 0.0243, 'lps'),
	(682590, 135, '2015-02-01 00:45:12.000000', 'consum', 0.0258, 'lps'),
	(682591, 135, '2015-02-01 00:45:13.000000', 'consum', 0.0244, 'lps'),
	(682592, 135, '2015-02-01 00:45:14.000000', 'consum', 0.0239, 'lps'),
	(682593, 135, '2015-02-01 00:45:15.000000', 'consum', 0.0252, 'lps'),
	(682594, 135, '2015-02-01 00:45:16.000000', 'consum', 0.0226, 'lps'),
	(682595, 135, '2015-02-01 00:45:17.000000', 'consum', 0.0219, 'lps'),
	(682596, 135, '2015-02-01 00:45:18.000000', 'consum', 0.0262, 'lps'),
	(682597, 135, '2015-02-01 00:45:19.000000', 'consum', 0.0230, 'lps'),
	(682598, 135, '2015-02-01 00:45:20.000000', 'consum', 0.0262, 'lps'),
	(682599, 135, '2015-02-01 00:45:21.000000', 'consum', 0.0251, 'lps'),
	(682600, 135, '2015-02-01 00:45:22.000000', 'consum', 0.0259, 'lps'),
	(682601, 135, '2015-02-01 00:45:23.000000', 'consum', 0.0227, 'lps'),
	(682602, 135, '2015-02-01 00:45:24.000000', 'consum', 0.0253, 'lps'),
	(682603, 135, '2015-02-01 00:45:25.000000', 'consum', 0.0215, 'lps'),
	(682604, 135, '2015-02-01 00:45:26.000000', 'consum', 0.0215, 'lps'),
	(682605, 135, '2015-02-01 00:45:27.000000', 'consum', 0.0220, 'lps'),
	(682606, 135, '2015-02-01 00:45:28.000000', 'consum', 0.0245, 'lps'),
	(682607, 135, '2015-02-01 00:45:29.000000', 'consum', 0.0248, 'lps'),
	(682608, 135, '2015-02-01 00:45:30.000000', 'consum', 0.0244, 'lps'),
	(682609, 135, '2015-02-01 00:45:31.000000', 'consum', 0.0213, 'lps'),
	(682610, 135, '2015-02-01 00:45:32.000000', 'consum', 0.0230, 'lps'),
	(682611, 135, '2015-02-01 00:45:33.000000', 'consum', 0.0247, 'lps'),
	(682612, 135, '2015-02-01 00:45:34.000000', 'consum', 0.0232, 'lps'),
	(682613, 135, '2015-02-01 00:45:35.000000', 'consum', 0.0262, 'lps'),
	(682614, 135, '2015-02-01 00:45:36.000000', 'consum', 0.0244, 'lps'),
	(682615, 135, '2015-02-01 00:45:37.000000', 'consum', 0.0226, 'lps'),
	(682616, 135, '2015-02-01 00:45:38.000000', 'consum', 0.0241, 'lps'),
	(682617, 135, '2015-02-01 00:45:39.000000', 'consum', 0.0212, 'lps'),
	(682618, 135, '2015-02-01 00:45:40.000000', 'consum', 0.0235, 'lps'),
	(682619, 135, '2015-02-01 00:45:41.000000', 'consum', 0.0221, 'lps'),
	(682620, 135, '2015-02-01 00:45:42.000000', 'consum', 0.0246, 'lps'),
	(682621, 135, '2015-02-01 00:45:43.000000', 'consum', 0.0252, 'lps'),
	(682622, 135, '2015-02-01 00:45:44.000000', 'consum', 0.0259, 'lps'),
	(682623, 135, '2015-02-01 00:45:45.000000', 'consum', 0.0225, 'lps'),
	(682624, 135, '2015-02-01 00:45:46.000000', 'consum', 0.0242, 'lps'),
	(682625, 135, '2015-02-01 00:45:47.000000', 'consum', 0.0222, 'lps'),
	(682626, 135, '2015-02-01 00:45:48.000000', 'consum', 0.0225, 'lps'),
	(682627, 135, '2015-02-01 00:45:49.000000', 'consum', 0.0249, 'lps'),
	(682628, 135, '2015-02-01 00:45:50.000000', 'consum', 0.0257, 'lps'),
	(682629, 135, '2015-02-01 00:45:51.000000', 'consum', 0.0220, 'lps'),
	(682630, 135, '2015-02-01 00:45:52.000000', 'consum', 0.0227, 'lps'),
	(682631, 135, '2015-02-01 00:45:53.000000', 'consum', 0.0212, 'lps'),
	(682632, 135, '2015-02-01 00:45:54.000000', 'consum', 0.0222, 'lps'),
	(682633, 135, '2015-02-01 00:45:55.000000', 'consum', 0.0214, 'lps'),
	(682634, 135, '2015-02-01 00:45:56.000000', 'consum', 0.0245, 'lps'),
	(682635, 135, '2015-02-01 00:45:57.000000', 'consum', 0.0213, 'lps'),
	(682636, 135, '2015-02-01 00:45:58.000000', 'consum', 0.0229, 'lps'),
	(682637, 135, '2015-02-01 00:45:59.000000', 'consum', 0.0245, 'lps'),
	(682638, 135, '2015-02-01 00:46:00.000000', 'consum', 0.0220, 'lps'),
	(682639, 135, '2015-02-01 00:46:01.000000', 'consum', 0.0261, 'lps'),
	(682640, 135, '2015-02-01 00:46:02.000000', 'consum', 0.0223, 'lps'),
	(682641, 135, '2015-02-01 00:46:03.000000', 'consum', 0.0228, 'lps'),
	(682642, 135, '2015-02-01 00:46:04.000000', 'consum', 0.0261, 'lps'),
	(682643, 135, '2015-02-01 00:46:05.000000', 'consum', 0.0255, 'lps'),
	(682644, 135, '2015-02-01 00:46:06.000000', 'consum', 0.0229, 'lps'),
	(682645, 135, '2015-02-01 00:46:07.000000', 'consum', 0.0222, 'lps'),
	(682646, 135, '2015-02-01 00:46:08.000000', 'consum', 0.0213, 'lps'),
	(682647, 135, '2015-02-01 00:46:09.000000', 'consum', 0.0244, 'lps'),
	(682648, 135, '2015-02-01 00:46:10.000000', 'consum', 0.0211, 'lps'),
	(682649, 135, '2015-02-01 00:46:11.000000', 'consum', 0.0219, 'lps'),
	(682650, 135, '2015-02-01 00:46:12.000000', 'consum', 0.0254, 'lps'),
	(682651, 135, '2015-02-01 00:46:13.000000', 'consum', 0.0242, 'lps'),
	(682652, 135, '2015-02-01 00:46:14.000000', 'consum', 0.0241, 'lps'),
	(682653, 135, '2015-02-01 00:46:15.000000', 'consum', 0.0214, 'lps'),
	(682654, 135, '2015-02-01 00:46:16.000000', 'consum', 0.0246, 'lps'),
	(682655, 135, '2015-02-01 00:46:17.000000', 'consum', 0.0218, 'lps'),
	(682656, 135, '2015-02-01 00:46:18.000000', 'consum', 0.0251, 'lps'),
	(682657, 135, '2015-02-01 00:46:19.000000', 'consum', 0.0229, 'lps'),
	(682658, 135, '2015-02-01 00:46:20.000000', 'consum', 0.0238, 'lps'),
	(682659, 135, '2015-02-01 00:46:21.000000', 'consum', 0.0240, 'lps'),
	(682660, 135, '2015-02-01 00:46:22.000000', 'consum', 0.0225, 'lps'),
	(682661, 135, '2015-02-01 00:46:23.000000', 'consum', 0.0247, 'lps'),
	(682662, 135, '2015-02-01 00:46:24.000000', 'consum', 0.0247, 'lps'),
	(682663, 135, '2015-02-01 00:46:25.000000', 'consum', 0.0228, 'lps'),
	(682664, 135, '2015-02-01 00:46:26.000000', 'consum', 0.0243, 'lps'),
	(682665, 135, '2015-02-01 00:46:27.000000', 'consum', 0.0216, 'lps'),
	(682666, 135, '2015-02-01 00:46:28.000000', 'consum', 0.0249, 'lps'),
	(682667, 135, '2015-02-01 00:46:29.000000', 'consum', 0.0225, 'lps'),
	(682668, 135, '2015-02-01 00:46:30.000000', 'consum', 0.0225, 'lps'),
	(682669, 135, '2015-02-01 00:46:31.000000', 'consum', 0.0241, 'lps'),
	(682670, 135, '2015-02-01 00:46:32.000000', 'consum', 0.0212, 'lps'),
	(682671, 135, '2015-02-01 00:46:33.000000', 'consum', 0.0235, 'lps'),
	(682672, 135, '2015-02-01 00:46:34.000000', 'consum', 0.0224, 'lps'),
	(682673, 135, '2015-02-01 00:46:35.000000', 'consum', 0.0256, 'lps'),
	(682674, 135, '2015-02-01 00:46:36.000000', 'consum', 0.0241, 'lps'),
	(682675, 135, '2015-02-01 00:46:37.000000', 'consum', 0.0228, 'lps'),
	(682676, 135, '2015-02-01 00:46:38.000000', 'consum', 0.0259, 'lps'),
	(682677, 135, '2015-02-01 00:46:39.000000', 'consum', 0.0241, 'lps'),
	(682678, 135, '2015-02-01 00:46:40.000000', 'consum', 0.0221, 'lps'),
	(682679, 135, '2015-02-01 00:46:41.000000', 'consum', 0.0226, 'lps'),
	(682680, 135, '2015-02-01 00:46:42.000000', 'consum', 0.0256, 'lps'),
	(682681, 135, '2015-02-01 00:46:43.000000', 'consum', 0.0234, 'lps'),
	(682682, 135, '2015-02-01 00:46:44.000000', 'consum', 0.0247, 'lps'),
	(682683, 135, '2015-02-01 00:46:45.000000', 'consum', 0.0217, 'lps'),
	(682684, 135, '2015-02-01 00:46:46.000000', 'consum', 0.0239, 'lps'),
	(682685, 135, '2015-02-01 00:46:47.000000', 'consum', 0.0231, 'lps'),
	(682686, 135, '2015-02-01 00:46:48.000000', 'consum', 0.0226, 'lps'),
	(682687, 135, '2015-02-01 00:46:49.000000', 'consum', 0.0227, 'lps'),
	(682688, 135, '2015-02-01 00:46:50.000000', 'consum', 0.0249, 'lps'),
	(682689, 135, '2015-02-01 00:46:51.000000', 'consum', 0.0250, 'lps'),
	(682690, 135, '2015-02-01 00:46:52.000000', 'consum', 0.0238, 'lps'),
	(682691, 135, '2015-02-01 00:46:53.000000', 'consum', 0.0233, 'lps'),
	(682692, 135, '2015-02-01 00:46:54.000000', 'consum', 0.0238, 'lps'),
	(682693, 135, '2015-02-01 00:46:55.000000', 'consum', 0.0232, 'lps'),
	(682694, 135, '2015-02-01 00:46:56.000000', 'consum', 0.0235, 'lps'),
	(682695, 135, '2015-02-01 00:46:57.000000', 'consum', 0.0218, 'lps'),
	(682696, 135, '2015-02-01 00:46:58.000000', 'consum', 0.0226, 'lps'),
	(682697, 135, '2015-02-01 00:46:59.000000', 'consum', 0.0216, 'lps'),
	(682698, 135, '2015-02-01 00:47:00.000000', 'consum', 0.0243, 'lps'),
	(682699, 135, '2015-02-01 00:47:01.000000', 'consum', 0.0253, 'lps'),
	(682700, 135, '2015-02-01 00:47:02.000000', 'consum', 0.0220, 'lps'),
	(682701, 135, '2015-02-01 00:47:03.000000', 'consum', 0.0239, 'lps'),
	(682702, 135, '2015-02-01 00:47:04.000000', 'consum', 0.0220, 'lps'),
	(682703, 135, '2015-02-01 00:47:05.000000', 'consum', 0.0225, 'lps'),
	(682704, 135, '2015-02-01 00:47:06.000000', 'consum', 0.0256, 'lps'),
	(682705, 135, '2015-02-01 00:47:07.000000', 'consum', 0.0234, 'lps'),
	(682706, 135, '2015-02-01 00:47:08.000000', 'consum', 0.0248, 'lps'),
	(682707, 135, '2015-02-01 00:47:09.000000', 'consum', 0.0223, 'lps'),
	(682708, 135, '2015-02-01 00:47:10.000000', 'consum', 0.0214, 'lps'),
	(682709, 135, '2015-02-01 00:47:11.000000', 'consum', 0.0243, 'lps'),
	(682710, 135, '2015-02-01 00:47:12.000000', 'consum', 0.0257, 'lps'),
	(682711, 135, '2015-02-01 00:47:13.000000', 'consum', 0.0241, 'lps'),
	(682712, 135, '2015-02-01 00:47:14.000000', 'consum', 0.0223, 'lps'),
	(682713, 135, '2015-02-01 00:47:15.000000', 'consum', 0.0238, 'lps'),
	(682714, 135, '2015-02-01 00:47:16.000000', 'consum', 0.0258, 'lps'),
	(682715, 135, '2015-02-01 00:47:17.000000', 'consum', 0.0262, 'lps'),
	(682716, 135, '2015-02-01 00:47:18.000000', 'consum', 0.0217, 'lps'),
	(682717, 135, '2015-02-01 00:47:19.000000', 'consum', 0.0252, 'lps'),
	(682718, 135, '2015-02-01 00:47:20.000000', 'consum', 0.0239, 'lps'),
	(682719, 135, '2015-02-01 00:47:21.000000', 'consum', 0.0229, 'lps'),
	(682720, 135, '2015-02-01 00:47:22.000000', 'consum', 0.0220, 'lps'),
	(682721, 135, '2015-02-01 00:47:23.000000', 'consum', 0.0254, 'lps'),
	(682722, 135, '2015-02-01 00:47:24.000000', 'consum', 0.0241, 'lps'),
	(682723, 135, '2015-02-01 00:47:25.000000', 'consum', 0.0236, 'lps'),
	(682724, 135, '2015-02-01 00:47:26.000000', 'consum', 0.0245, 'lps'),
	(682725, 135, '2015-02-01 00:47:27.000000', 'consum', 0.0255, 'lps'),
	(682726, 135, '2015-02-01 00:47:28.000000', 'consum', 0.0223, 'lps'),
	(682727, 135, '2015-02-01 00:47:29.000000', 'consum', 0.0248, 'lps'),
	(682728, 135, '2015-02-01 00:47:30.000000', 'consum', 0.0255, 'lps'),
	(682729, 135, '2015-02-01 00:47:31.000000', 'consum', 0.0214, 'lps'),
	(682730, 135, '2015-02-01 00:47:32.000000', 'consum', 0.0257, 'lps'),
	(682731, 135, '2015-02-01 00:47:33.000000', 'consum', 0.0221, 'lps'),
	(682732, 135, '2015-02-01 00:47:34.000000', 'consum', 0.0232, 'lps'),
	(682733, 135, '2015-02-01 00:47:35.000000', 'consum', 0.0233, 'lps'),
	(682734, 135, '2015-02-01 00:47:36.000000', 'consum', 0.0261, 'lps'),
	(682735, 135, '2015-02-01 00:47:37.000000', 'consum', 0.0237, 'lps'),
	(682736, 135, '2015-02-01 00:47:38.000000', 'consum', 0.0246, 'lps'),
	(682737, 135, '2015-02-01 00:47:39.000000', 'consum', 0.0256, 'lps'),
	(682738, 135, '2015-02-01 00:47:40.000000', 'consum', 0.0228, 'lps'),
	(682739, 135, '2015-02-01 00:47:41.000000', 'consum', 0.0217, 'lps'),
	(682740, 135, '2015-02-01 00:47:42.000000', 'consum', 0.0241, 'lps'),
	(682741, 135, '2015-02-01 00:47:43.000000', 'consum', 0.0238, 'lps'),
	(682742, 135, '2015-02-01 00:47:44.000000', 'consum', 0.0260, 'lps'),
	(682743, 135, '2015-02-01 00:47:45.000000', 'consum', 0.0216, 'lps'),
	(682744, 135, '2015-02-01 00:47:46.000000', 'consum', 0.0251, 'lps'),
	(682745, 135, '2015-02-01 00:47:47.000000', 'consum', 0.0236, 'lps'),
	(682746, 135, '2015-02-01 00:47:48.000000', 'consum', 0.0217, 'lps'),
	(682747, 135, '2015-02-01 00:47:49.000000', 'consum', 0.0223, 'lps'),
	(682748, 135, '2015-02-01 00:47:50.000000', 'consum', 0.0255, 'lps'),
	(682749, 135, '2015-02-01 00:47:51.000000', 'consum', 0.0238, 'lps'),
	(682750, 135, '2015-02-01 00:47:52.000000', 'consum', 0.0213, 'lps'),
	(682751, 135, '2015-02-01 00:47:53.000000', 'consum', 0.0249, 'lps'),
	(682752, 135, '2015-02-01 00:47:54.000000', 'consum', 0.0239, 'lps'),
	(682753, 135, '2015-02-01 00:47:55.000000', 'consum', 0.0237, 'lps'),
	(682754, 135, '2015-02-01 00:47:56.000000', 'consum', 0.0258, 'lps'),
	(682755, 135, '2015-02-01 00:47:57.000000', 'consum', 0.0210, 'lps'),
	(682756, 135, '2015-02-01 00:47:58.000000', 'consum', 0.0225, 'lps'),
	(682757, 135, '2015-02-01 00:47:59.000000', 'consum', 0.0232, 'lps'),
	(682758, 135, '2015-02-01 00:48:00.000000', 'consum', 0.0222, 'lps'),
	(682759, 135, '2015-02-01 00:48:01.000000', 'consum', 0.0258, 'lps'),
	(682760, 135, '2015-02-01 00:48:02.000000', 'consum', 0.0256, 'lps'),
	(682761, 135, '2015-02-01 00:48:03.000000', 'consum', 0.0242, 'lps'),
	(682762, 135, '2015-02-01 00:48:04.000000', 'consum', 0.0234, 'lps'),
	(682763, 135, '2015-02-01 00:48:05.000000', 'consum', 0.0232, 'lps'),
	(682764, 135, '2015-02-01 00:48:06.000000', 'consum', 0.0251, 'lps'),
	(682765, 135, '2015-02-01 00:48:07.000000', 'consum', 0.0242, 'lps'),
	(682766, 135, '2015-02-01 00:48:08.000000', 'consum', 0.0250, 'lps'),
	(682767, 135, '2015-02-01 00:48:09.000000', 'consum', 0.0258, 'lps'),
	(682768, 135, '2015-02-01 00:48:10.000000', 'consum', 0.0228, 'lps'),
	(682769, 135, '2015-02-01 00:48:11.000000', 'consum', 0.0261, 'lps'),
	(682770, 135, '2015-02-01 00:48:12.000000', 'consum', 0.0251, 'lps'),
	(682771, 135, '2015-02-01 00:48:13.000000', 'consum', 0.0212, 'lps'),
	(682772, 135, '2015-02-01 00:48:14.000000', 'consum', 0.0254, 'lps'),
	(682773, 135, '2015-02-01 00:48:15.000000', 'consum', 0.0213, 'lps'),
	(682774, 135, '2015-02-01 00:48:16.000000', 'consum', 0.0253, 'lps'),
	(682775, 135, '2015-02-01 00:48:17.000000', 'consum', 0.0259, 'lps'),
	(682776, 135, '2015-02-01 00:48:18.000000', 'consum', 0.0218, 'lps'),
	(682777, 135, '2015-02-01 00:48:19.000000', 'consum', 0.0212, 'lps'),
	(682778, 135, '2015-02-01 00:48:20.000000', 'consum', 0.0247, 'lps'),
	(682779, 135, '2015-02-01 00:48:21.000000', 'consum', 0.0233, 'lps'),
	(682780, 135, '2015-02-01 00:48:22.000000', 'consum', 0.0215, 'lps'),
	(682781, 135, '2015-02-01 00:48:23.000000', 'consum', 0.0219, 'lps'),
	(682782, 135, '2015-02-01 00:48:24.000000', 'consum', 0.0239, 'lps'),
	(682783, 135, '2015-02-01 00:48:25.000000', 'consum', 0.0224, 'lps'),
	(682784, 135, '2015-02-01 00:48:26.000000', 'consum', 0.0244, 'lps'),
	(682785, 135, '2015-02-01 00:48:27.000000', 'consum', 0.0234, 'lps'),
	(682786, 135, '2015-02-01 00:48:28.000000', 'consum', 0.0227, 'lps'),
	(682787, 135, '2015-02-01 00:48:29.000000', 'consum', 0.0225, 'lps'),
	(682788, 135, '2015-02-01 00:48:30.000000', 'consum', 0.0236, 'lps'),
	(682789, 135, '2015-02-01 00:48:31.000000', 'consum', 0.0241, 'lps'),
	(682790, 135, '2015-02-01 00:48:32.000000', 'consum', 0.0237, 'lps'),
	(682791, 135, '2015-02-01 00:48:33.000000', 'consum', 0.0250, 'lps'),
	(682792, 135, '2015-02-01 00:48:34.000000', 'consum', 0.0223, 'lps'),
	(682793, 135, '2015-02-01 00:48:35.000000', 'consum', 0.0211, 'lps'),
	(682794, 135, '2015-02-01 00:48:36.000000', 'consum', 0.0227, 'lps'),
	(682795, 135, '2015-02-01 00:48:37.000000', 'consum', 0.0242, 'lps'),
	(682796, 135, '2015-02-01 00:48:38.000000', 'consum', 0.0214, 'lps'),
	(682797, 135, '2015-02-01 00:48:39.000000', 'consum', 0.0240, 'lps'),
	(682798, 135, '2015-02-01 00:48:40.000000', 'consum', 0.0241, 'lps'),
	(682799, 135, '2015-02-01 00:48:41.000000', 'consum', 0.0225, 'lps'),
	(682800, 135, '2015-02-01 00:48:42.000000', 'consum', 0.0242, 'lps'),
	(682801, 135, '2015-02-01 00:48:43.000000', 'consum', 0.0222, 'lps'),
	(682802, 135, '2015-02-01 00:48:44.000000', 'consum', 0.0228, 'lps'),
	(682803, 135, '2015-02-01 00:48:45.000000', 'consum', 0.0262, 'lps'),
	(682804, 135, '2015-02-01 00:48:46.000000', 'consum', 0.0260, 'lps'),
	(682805, 135, '2015-02-01 00:48:47.000000', 'consum', 0.0249, 'lps'),
	(682806, 135, '2015-02-01 00:48:48.000000', 'consum', 0.0256, 'lps'),
	(682807, 135, '2015-02-01 00:48:49.000000', 'consum', 0.0218, 'lps'),
	(682808, 135, '2015-02-01 00:48:50.000000', 'consum', 0.0217, 'lps'),
	(682809, 135, '2015-02-01 00:48:51.000000', 'consum', 0.0223, 'lps'),
	(682810, 135, '2015-02-01 00:48:52.000000', 'consum', 0.0254, 'lps'),
	(682811, 135, '2015-02-01 00:48:53.000000', 'consum', 0.0232, 'lps'),
	(682812, 135, '2015-02-01 00:48:54.000000', 'consum', 0.0242, 'lps'),
	(682813, 135, '2015-02-01 00:48:55.000000', 'consum', 0.0253, 'lps'),
	(682814, 135, '2015-02-01 00:48:56.000000', 'consum', 0.0220, 'lps'),
	(682815, 135, '2015-02-01 00:48:57.000000', 'consum', 0.0240, 'lps'),
	(682816, 135, '2015-02-01 00:48:58.000000', 'consum', 0.0225, 'lps'),
	(682817, 135, '2015-02-01 00:48:59.000000', 'consum', 0.0250, 'lps'),
	(682818, 135, '2015-02-01 00:49:00.000000', 'consum', 0.0257, 'lps'),
	(682819, 135, '2015-02-01 00:49:01.000000', 'consum', 0.0220, 'lps'),
	(682820, 135, '2015-02-01 00:49:02.000000', 'consum', 0.0226, 'lps'),
	(682821, 135, '2015-02-01 00:49:03.000000', 'consum', 0.0262, 'lps'),
	(682822, 135, '2015-02-01 00:49:04.000000', 'consum', 0.0210, 'lps'),
	(682823, 135, '2015-02-01 00:49:05.000000', 'consum', 0.0214, 'lps'),
	(682824, 135, '2015-02-01 00:49:06.000000', 'consum', 0.0231, 'lps'),
	(682825, 135, '2015-02-01 00:49:07.000000', 'consum', 0.0248, 'lps'),
	(682826, 135, '2015-02-01 00:49:08.000000', 'consum', 0.0233, 'lps'),
	(682827, 135, '2015-02-01 00:49:09.000000', 'consum', 0.0211, 'lps'),
	(682828, 135, '2015-02-01 00:49:10.000000', 'consum', 0.0254, 'lps'),
	(682829, 135, '2015-02-01 00:49:11.000000', 'consum', 0.0217, 'lps'),
	(682830, 135, '2015-02-01 00:49:12.000000', 'consum', 0.0217, 'lps'),
	(682831, 135, '2015-02-01 00:49:13.000000', 'consum', 0.0223, 'lps'),
	(682832, 135, '2015-02-01 00:49:14.000000', 'consum', 0.0256, 'lps'),
	(682833, 135, '2015-02-01 00:49:15.000000', 'consum', 0.0241, 'lps'),
	(682834, 135, '2015-02-01 00:49:16.000000', 'consum', 0.0228, 'lps'),
	(682835, 135, '2015-02-01 00:49:17.000000', 'consum', 0.0260, 'lps'),
	(682836, 135, '2015-02-01 00:49:18.000000', 'consum', 0.0246, 'lps'),
	(682837, 135, '2015-02-01 00:49:19.000000', 'consum', 0.0244, 'lps'),
	(682838, 135, '2015-02-01 00:49:20.000000', 'consum', 0.0218, 'lps'),
	(682839, 135, '2015-02-01 00:49:21.000000', 'consum', 0.0253, 'lps'),
	(682840, 135, '2015-02-01 00:49:22.000000', 'consum', 0.0243, 'lps'),
	(682841, 135, '2015-02-01 00:49:23.000000', 'consum', 0.0246, 'lps'),
	(682842, 135, '2015-02-01 00:49:24.000000', 'consum', 0.0240, 'lps'),
	(682843, 135, '2015-02-01 00:49:25.000000', 'consum', 0.0252, 'lps'),
	(682844, 135, '2015-02-01 00:49:26.000000', 'consum', 0.0226, 'lps'),
	(682845, 135, '2015-02-01 00:49:27.000000', 'consum', 0.0215, 'lps'),
	(682846, 135, '2015-02-01 00:49:28.000000', 'consum', 0.0243, 'lps'),
	(682847, 135, '2015-02-01 00:49:29.000000', 'consum', 0.0252, 'lps'),
	(682848, 135, '2015-02-01 00:49:30.000000', 'consum', 0.0216, 'lps'),
	(682849, 135, '2015-02-01 00:49:31.000000', 'consum', 0.0220, 'lps'),
	(682850, 135, '2015-02-01 00:49:32.000000', 'consum', 0.0245, 'lps'),
	(682851, 135, '2015-02-01 00:49:33.000000', 'consum', 0.0249, 'lps'),
	(682852, 135, '2015-02-01 00:49:34.000000', 'consum', 0.0246, 'lps'),
	(682853, 135, '2015-02-01 00:49:35.000000', 'consum', 0.0220, 'lps'),
	(682854, 135, '2015-02-01 00:49:36.000000', 'consum', 0.0259, 'lps'),
	(682855, 135, '2015-02-01 00:49:37.000000', 'consum', 0.0212, 'lps'),
	(682856, 135, '2015-02-01 00:49:38.000000', 'consum', 0.0235, 'lps'),
	(682857, 135, '2015-02-01 00:49:39.000000', 'consum', 0.0224, 'lps'),
	(682858, 135, '2015-02-01 00:49:40.000000', 'consum', 0.0258, 'lps'),
	(682859, 135, '2015-02-01 00:49:41.000000', 'consum', 0.0251, 'lps'),
	(682860, 135, '2015-02-01 00:49:42.000000', 'consum', 0.0218, 'lps'),
	(682861, 135, '2015-02-01 00:49:43.000000', 'consum', 0.0233, 'lps'),
	(682862, 135, '2015-02-01 00:49:44.000000', 'consum', 0.0247, 'lps'),
	(682863, 135, '2015-02-01 00:49:45.000000', 'consum', 0.0221, 'lps'),
	(682864, 135, '2015-02-01 00:49:46.000000', 'consum', 0.0262, 'lps'),
	(682865, 135, '2015-02-01 00:49:47.000000', 'consum', 0.0223, 'lps'),
	(682866, 135, '2015-02-01 00:49:48.000000', 'consum', 0.0226, 'lps'),
	(682867, 135, '2015-02-01 00:49:49.000000', 'consum', 0.0251, 'lps'),
	(682868, 135, '2015-02-01 00:49:50.000000', 'consum', 0.0210, 'lps'),
	(682869, 135, '2015-02-01 00:49:51.000000', 'consum', 0.0244, 'lps'),
	(682870, 135, '2015-02-01 00:49:52.000000', 'consum', 0.0225, 'lps'),
	(682871, 135, '2015-02-01 00:49:53.000000', 'consum', 0.0234, 'lps'),
	(682872, 135, '2015-02-01 00:49:54.000000', 'consum', 0.0234, 'lps'),
	(682873, 135, '2015-02-01 00:49:55.000000', 'consum', 0.0257, 'lps'),
	(682874, 135, '2015-02-01 00:49:56.000000', 'consum', 0.0216, 'lps'),
	(682875, 135, '2015-02-01 00:49:57.000000', 'consum', 0.0260, 'lps'),
	(682876, 135, '2015-02-01 00:49:58.000000', 'consum', 0.0228, 'lps'),
	(682877, 135, '2015-02-01 00:49:59.000000', 'consum', 0.0258, 'lps'),
	(682878, 135, '2015-02-01 00:50:00.000000', 'consum', 0.0236, 'lps'),
	(682879, 135, '2015-02-01 00:50:01.000000', 'consum', 0.0249, 'lps'),
	(682880, 135, '2015-02-01 00:50:02.000000', 'consum', 0.0221, 'lps'),
	(682881, 135, '2015-02-01 00:50:03.000000', 'consum', 0.0254, 'lps'),
	(682882, 135, '2015-02-01 00:50:04.000000', 'consum', 0.0238, 'lps'),
	(682883, 135, '2015-02-01 00:50:05.000000', 'consum', 0.0218, 'lps'),
	(682884, 135, '2015-02-01 00:50:06.000000', 'consum', 0.0221, 'lps'),
	(682885, 135, '2015-02-01 00:50:07.000000', 'consum', 0.0243, 'lps'),
	(682886, 135, '2015-02-01 00:50:08.000000', 'consum', 0.0235, 'lps'),
	(682887, 135, '2015-02-01 00:50:09.000000', 'consum', 0.0235, 'lps'),
	(682888, 135, '2015-02-01 00:50:10.000000', 'consum', 0.0261, 'lps'),
	(682889, 135, '2015-02-01 00:50:11.000000', 'consum', 0.0234, 'lps'),
	(682890, 135, '2015-02-01 00:50:12.000000', 'consum', 0.0229, 'lps'),
	(682891, 135, '2015-02-01 00:50:13.000000', 'consum', 0.0233, 'lps'),
	(682892, 135, '2015-02-01 00:50:14.000000', 'consum', 0.0216, 'lps'),
	(682893, 135, '2015-02-01 00:50:15.000000', 'consum', 0.0223, 'lps'),
	(682894, 135, '2015-02-01 00:50:16.000000', 'consum', 0.0257, 'lps'),
	(682895, 135, '2015-02-01 00:50:17.000000', 'consum', 0.0249, 'lps'),
	(682896, 135, '2015-02-01 00:50:18.000000', 'consum', 0.0211, 'lps'),
	(682897, 135, '2015-02-01 00:50:19.000000', 'consum', 0.0259, 'lps'),
	(682898, 135, '2015-02-01 00:50:20.000000', 'consum', 0.0239, 'lps'),
	(682899, 135, '2015-02-01 00:50:21.000000', 'consum', 0.0260, 'lps'),
	(682900, 135, '2015-02-01 00:50:22.000000', 'consum', 0.0218, 'lps'),
	(682901, 135, '2015-02-01 00:50:23.000000', 'consum', 0.0257, 'lps'),
	(682902, 135, '2015-02-01 00:50:24.000000', 'consum', 0.0261, 'lps'),
	(682903, 135, '2015-02-01 00:50:25.000000', 'consum', 0.0222, 'lps'),
	(682904, 135, '2015-02-01 00:50:26.000000', 'consum', 0.0220, 'lps'),
	(682905, 135, '2015-02-01 00:50:27.000000', 'consum', 0.0228, 'lps'),
	(682906, 135, '2015-02-01 00:50:28.000000', 'consum', 0.0216, 'lps'),
	(682907, 135, '2015-02-01 00:50:29.000000', 'consum', 0.0238, 'lps'),
	(682908, 135, '2015-02-01 00:50:30.000000', 'consum', 0.0226, 'lps'),
	(682909, 135, '2015-02-01 00:50:31.000000', 'consum', 0.0210, 'lps'),
	(682910, 135, '2015-02-01 00:50:32.000000', 'consum', 0.0212, 'lps'),
	(682911, 135, '2015-02-01 00:50:33.000000', 'consum', 0.0222, 'lps'),
	(682912, 135, '2015-02-01 00:50:34.000000', 'consum', 0.0213, 'lps'),
	(682913, 135, '2015-02-01 00:50:35.000000', 'consum', 0.0240, 'lps'),
	(682914, 135, '2015-02-01 00:50:36.000000', 'consum', 0.0248, 'lps'),
	(682915, 135, '2015-02-01 00:50:37.000000', 'consum', 0.0258, 'lps'),
	(682916, 135, '2015-02-01 00:50:38.000000', 'consum', 0.0229, 'lps'),
	(682917, 135, '2015-02-01 00:50:39.000000', 'consum', 0.0216, 'lps'),
	(682918, 135, '2015-02-01 00:50:40.000000', 'consum', 0.0234, 'lps'),
	(682919, 135, '2015-02-01 00:50:41.000000', 'consum', 0.0260, 'lps'),
	(682920, 135, '2015-02-01 00:50:42.000000', 'consum', 0.0230, 'lps'),
	(682921, 135, '2015-02-01 00:50:43.000000', 'consum', 0.0213, 'lps'),
	(682922, 135, '2015-02-01 00:50:44.000000', 'consum', 0.0219, 'lps'),
	(682923, 135, '2015-02-01 00:50:45.000000', 'consum', 0.0246, 'lps'),
	(682924, 135, '2015-02-01 00:50:46.000000', 'consum', 0.0259, 'lps'),
	(682925, 135, '2015-02-01 00:50:47.000000', 'consum', 0.0242, 'lps'),
	(682926, 135, '2015-02-01 00:50:48.000000', 'consum', 0.0221, 'lps'),
	(682927, 135, '2015-02-01 00:50:49.000000', 'consum', 0.0224, 'lps'),
	(682928, 135, '2015-02-01 00:50:50.000000', 'consum', 0.0248, 'lps'),
	(682929, 135, '2015-02-01 00:50:51.000000', 'consum', 0.0253, 'lps'),
	(682930, 135, '2015-02-01 00:50:52.000000', 'consum', 0.0258, 'lps'),
	(682931, 135, '2015-02-01 00:50:53.000000', 'consum', 0.0217, 'lps'),
	(682932, 135, '2015-02-01 00:50:54.000000', 'consum', 0.0260, 'lps'),
	(682933, 135, '2015-02-01 00:50:55.000000', 'consum', 0.0226, 'lps'),
	(682934, 135, '2015-02-01 00:50:56.000000', 'consum', 0.0248, 'lps'),
	(682935, 135, '2015-02-01 00:50:57.000000', 'consum', 0.0248, 'lps'),
	(682936, 135, '2015-02-01 00:50:58.000000', 'consum', 0.0232, 'lps'),
	(682937, 135, '2015-02-01 00:50:59.000000', 'consum', 0.0260, 'lps'),
	(682938, 135, '2015-02-01 00:51:00.000000', 'consum', 0.0236, 'lps'),
	(682939, 135, '2015-02-01 00:51:01.000000', 'consum', 0.0242, 'lps'),
	(682940, 135, '2015-02-01 00:51:02.000000', 'consum', 0.0239, 'lps'),
	(682941, 135, '2015-02-01 00:51:03.000000', 'consum', 0.0260, 'lps'),
	(682942, 135, '2015-02-01 00:51:04.000000', 'consum', 0.0214, 'lps'),
	(682943, 135, '2015-02-01 00:51:05.000000', 'consum', 0.0242, 'lps'),
	(682944, 135, '2015-02-01 00:51:06.000000', 'consum', 0.0250, 'lps'),
	(682945, 135, '2015-02-01 00:51:07.000000', 'consum', 0.0211, 'lps'),
	(682946, 135, '2015-02-01 00:51:08.000000', 'consum', 0.0254, 'lps'),
	(682947, 135, '2015-02-01 00:51:09.000000', 'consum', 0.0215, 'lps'),
	(682948, 135, '2015-02-01 00:51:10.000000', 'consum', 0.0262, 'lps'),
	(682949, 135, '2015-02-01 00:51:11.000000', 'consum', 0.0245, 'lps'),
	(682950, 135, '2015-02-01 00:51:12.000000', 'consum', 0.0228, 'lps'),
	(682951, 135, '2015-02-01 00:51:13.000000', 'consum', 0.0250, 'lps'),
	(682952, 135, '2015-02-01 00:51:14.000000', 'consum', 0.0250, 'lps'),
	(682953, 135, '2015-02-01 00:51:15.000000', 'consum', 0.0238, 'lps'),
	(682954, 135, '2015-02-01 00:51:16.000000', 'consum', 0.0231, 'lps'),
	(682955, 135, '2015-02-01 00:51:17.000000', 'consum', 0.0233, 'lps'),
	(682956, 135, '2015-02-01 00:51:18.000000', 'consum', 0.0259, 'lps'),
	(682957, 135, '2015-02-01 00:51:19.000000', 'consum', 0.0230, 'lps'),
	(682958, 135, '2015-02-01 00:51:20.000000', 'consum', 0.0214, 'lps'),
	(682959, 135, '2015-02-01 00:51:21.000000', 'consum', 0.0224, 'lps'),
	(682960, 135, '2015-02-01 00:51:22.000000', 'consum', 0.0217, 'lps'),
	(682961, 135, '2015-02-01 00:51:23.000000', 'consum', 0.0255, 'lps'),
	(682962, 135, '2015-02-01 00:51:24.000000', 'consum', 0.0255, 'lps'),
	(682963, 135, '2015-02-01 00:51:25.000000', 'consum', 0.0249, 'lps'),
	(682964, 135, '2015-02-01 00:51:26.000000', 'consum', 0.0217, 'lps'),
	(682965, 135, '2015-02-01 00:51:27.000000', 'consum', 0.0233, 'lps'),
	(682966, 135, '2015-02-01 00:51:28.000000', 'consum', 0.0253, 'lps'),
	(682967, 135, '2015-02-01 00:51:29.000000', 'consum', 0.0250, 'lps'),
	(682968, 135, '2015-02-01 00:51:30.000000', 'consum', 0.0229, 'lps'),
	(682969, 135, '2015-02-01 00:51:31.000000', 'consum', 0.0238, 'lps'),
	(682970, 135, '2015-02-01 00:51:32.000000', 'consum', 0.0239, 'lps'),
	(682971, 135, '2015-02-01 00:51:33.000000', 'consum', 0.0221, 'lps'),
	(682972, 135, '2015-02-01 00:51:34.000000', 'consum', 0.0229, 'lps'),
	(682973, 135, '2015-02-01 00:51:35.000000', 'consum', 0.0222, 'lps'),
	(682974, 135, '2015-02-01 00:51:36.000000', 'consum', 0.0211, 'lps'),
	(682975, 135, '2015-02-01 00:51:37.000000', 'consum', 0.0233, 'lps'),
	(682976, 135, '2015-02-01 00:51:38.000000', 'consum', 0.0218, 'lps'),
	(682977, 135, '2015-02-01 00:51:39.000000', 'consum', 0.0233, 'lps'),
	(682978, 135, '2015-02-01 00:51:40.000000', 'consum', 0.0250, 'lps'),
	(682979, 135, '2015-02-01 00:51:41.000000', 'consum', 0.0234, 'lps'),
	(682980, 135, '2015-02-01 00:51:42.000000', 'consum', 0.0212, 'lps'),
	(682981, 135, '2015-02-01 00:51:43.000000', 'consum', 0.0252, 'lps'),
	(682982, 135, '2015-02-01 00:51:44.000000', 'consum', 0.0256, 'lps'),
	(682983, 135, '2015-02-01 00:51:45.000000', 'consum', 0.0210, 'lps'),
	(682984, 135, '2015-02-01 00:51:46.000000', 'consum', 0.0232, 'lps'),
	(682985, 135, '2015-02-01 00:51:47.000000', 'consum', 0.0213, 'lps'),
	(682986, 135, '2015-02-01 00:51:48.000000', 'consum', 0.0214, 'lps'),
	(682987, 135, '2015-02-01 00:51:49.000000', 'consum', 0.0220, 'lps'),
	(682988, 135, '2015-02-01 00:51:50.000000', 'consum', 0.0249, 'lps'),
	(682989, 135, '2015-02-01 00:51:51.000000', 'consum', 0.0218, 'lps'),
	(682990, 135, '2015-02-01 00:51:52.000000', 'consum', 0.0239, 'lps'),
	(682991, 135, '2015-02-01 00:51:53.000000', 'consum', 0.0224, 'lps'),
	(682992, 135, '2015-02-01 00:51:54.000000', 'consum', 0.0249, 'lps'),
	(682993, 135, '2015-02-01 00:51:55.000000', 'consum', 0.0257, 'lps'),
	(682994, 135, '2015-02-01 00:51:56.000000', 'consum', 0.0224, 'lps'),
	(682995, 135, '2015-02-01 00:51:57.000000', 'consum', 0.0243, 'lps'),
	(682996, 135, '2015-02-01 00:51:58.000000', 'consum', 0.0230, 'lps'),
	(682997, 135, '2015-02-01 00:51:59.000000', 'consum', 0.0210, 'lps'),
	(682998, 135, '2015-02-01 00:52:00.000000', 'consum', 0.0256, 'lps'),
	(682999, 135, '2015-02-01 00:52:01.000000', 'consum', 0.0227, 'lps'),
	(683000, 135, '2015-02-01 00:52:02.000000', 'consum', 0.0212, 'lps'),
	(683001, 135, '2015-02-01 00:52:03.000000', 'consum', 0.0222, 'lps'),
	(683002, 135, '2015-02-01 00:52:04.000000', 'consum', 0.0211, 'lps'),
	(683003, 135, '2015-02-01 00:52:05.000000', 'consum', 0.0234, 'lps'),
	(683004, 135, '2015-02-01 00:52:06.000000', 'consum', 0.0221, 'lps'),
	(683005, 135, '2015-02-01 00:52:07.000000', 'consum', 0.0246, 'lps'),
	(683006, 135, '2015-02-01 00:52:08.000000', 'consum', 0.0250, 'lps'),
	(683007, 135, '2015-02-01 00:52:09.000000', 'consum', 0.0250, 'lps'),
	(683008, 135, '2015-02-01 00:52:10.000000', 'consum', 0.0238, 'lps'),
	(683009, 135, '2015-02-01 00:52:11.000000', 'consum', 0.0229, 'lps'),
	(683010, 135, '2015-02-01 00:52:12.000000', 'consum', 0.0220, 'lps'),
	(683011, 135, '2015-02-01 00:52:13.000000', 'consum', 0.0260, 'lps'),
	(683012, 135, '2015-02-01 00:52:14.000000', 'consum', 0.0219, 'lps'),
	(683013, 135, '2015-02-01 00:52:15.000000', 'consum', 0.0210, 'lps'),
	(683014, 135, '2015-02-01 00:52:16.000000', 'consum', 0.0238, 'lps'),
	(683015, 135, '2015-02-01 00:52:17.000000', 'consum', 0.0242, 'lps'),
	(683016, 135, '2015-02-01 00:52:18.000000', 'consum', 0.0235, 'lps'),
	(683017, 135, '2015-02-01 00:52:19.000000', 'consum', 0.0239, 'lps'),
	(683018, 135, '2015-02-01 00:52:20.000000', 'consum', 0.0226, 'lps'),
	(683019, 135, '2015-02-01 00:52:21.000000', 'consum', 0.0258, 'lps'),
	(683020, 135, '2015-02-01 00:52:22.000000', 'consum', 0.0242, 'lps'),
	(683021, 135, '2015-02-01 00:52:23.000000', 'consum', 0.0226, 'lps'),
	(683022, 135, '2015-02-01 00:52:24.000000', 'consum', 0.0249, 'lps'),
	(683023, 135, '2015-02-01 00:52:25.000000', 'consum', 0.0251, 'lps'),
	(683024, 135, '2015-02-01 00:52:26.000000', 'consum', 0.0244, 'lps'),
	(683025, 135, '2015-02-01 00:52:27.000000', 'consum', 0.0258, 'lps'),
	(683026, 135, '2015-02-01 00:52:28.000000', 'consum', 0.0241, 'lps'),
	(683027, 135, '2015-02-01 00:52:29.000000', 'consum', 0.0225, 'lps'),
	(683028, 135, '2015-02-01 00:52:30.000000', 'consum', 0.0243, 'lps'),
	(683029, 135, '2015-02-01 00:52:31.000000', 'consum', 0.0227, 'lps'),
	(683030, 135, '2015-02-01 00:52:32.000000', 'consum', 0.0247, 'lps'),
	(683031, 135, '2015-02-01 00:52:33.000000', 'consum', 0.0238, 'lps'),
	(683032, 135, '2015-02-01 00:52:34.000000', 'consum', 0.0241, 'lps'),
	(683033, 135, '2015-02-01 00:52:35.000000', 'consum', 0.0227, 'lps'),
	(683034, 135, '2015-02-01 00:52:36.000000', 'consum', 0.0256, 'lps'),
	(683035, 135, '2015-02-01 00:52:37.000000', 'consum', 0.0230, 'lps'),
	(683036, 135, '2015-02-01 00:52:38.000000', 'consum', 0.0228, 'lps'),
	(683037, 135, '2015-02-01 00:52:39.000000', 'consum', 0.0237, 'lps'),
	(683038, 135, '2015-02-01 00:52:40.000000', 'consum', 0.0241, 'lps'),
	(683039, 135, '2015-02-01 00:52:41.000000', 'consum', 0.0231, 'lps'),
	(683040, 135, '2015-02-01 00:52:42.000000', 'consum', 0.0221, 'lps'),
	(683041, 135, '2015-02-01 00:52:43.000000', 'consum', 0.0256, 'lps'),
	(683042, 135, '2015-02-01 00:52:44.000000', 'consum', 0.0247, 'lps'),
	(683043, 135, '2015-02-01 00:52:45.000000', 'consum', 0.0259, 'lps'),
	(683044, 135, '2015-02-01 00:52:46.000000', 'consum', 0.0240, 'lps'),
	(683045, 135, '2015-02-01 00:52:47.000000', 'consum', 0.0213, 'lps'),
	(683046, 135, '2015-02-01 00:52:48.000000', 'consum', 0.0243, 'lps'),
	(683047, 135, '2015-02-01 00:52:49.000000', 'consum', 0.0258, 'lps'),
	(683048, 135, '2015-02-01 00:52:50.000000', 'consum', 0.0245, 'lps'),
	(683049, 135, '2015-02-01 00:52:51.000000', 'consum', 0.0241, 'lps'),
	(683050, 135, '2015-02-01 00:52:52.000000', 'consum', 0.0261, 'lps'),
	(683051, 135, '2015-02-01 00:52:53.000000', 'consum', 0.0213, 'lps'),
	(683052, 135, '2015-02-01 00:52:54.000000', 'consum', 0.0232, 'lps'),
	(683053, 135, '2015-02-01 00:52:55.000000', 'consum', 0.0260, 'lps'),
	(683054, 135, '2015-02-01 00:52:56.000000', 'consum', 0.0234, 'lps'),
	(683055, 135, '2015-02-01 00:52:57.000000', 'consum', 0.0232, 'lps'),
	(683056, 135, '2015-02-01 00:52:58.000000', 'consum', 0.0250, 'lps'),
	(683057, 135, '2015-02-01 00:52:59.000000', 'consum', 0.0237, 'lps'),
	(683058, 135, '2015-02-01 00:53:00.000000', 'consum', 0.0228, 'lps'),
	(683059, 135, '2015-02-01 00:53:01.000000', 'consum', 0.0219, 'lps'),
	(683060, 135, '2015-02-01 00:53:02.000000', 'consum', 0.0255, 'lps'),
	(683061, 135, '2015-02-01 00:53:03.000000', 'consum', 0.0248, 'lps'),
	(683062, 135, '2015-02-01 00:53:04.000000', 'consum', 0.0215, 'lps'),
	(683063, 135, '2015-02-01 00:53:05.000000', 'consum', 0.0224, 'lps'),
	(683064, 135, '2015-02-01 00:53:06.000000', 'consum', 0.0216, 'lps'),
	(683065, 135, '2015-02-01 00:53:07.000000', 'consum', 0.0249, 'lps'),
	(683066, 135, '2015-02-01 00:53:08.000000', 'consum', 0.0230, 'lps'),
	(683067, 135, '2015-02-01 00:53:09.000000', 'consum', 0.0248, 'lps'),
	(683068, 135, '2015-02-01 00:53:10.000000', 'consum', 0.0233, 'lps'),
	(683069, 135, '2015-02-01 00:53:11.000000', 'consum', 0.0210, 'lps'),
	(683070, 135, '2015-02-01 00:53:12.000000', 'consum', 0.0249, 'lps'),
	(683071, 135, '2015-02-01 00:53:13.000000', 'consum', 0.0247, 'lps'),
	(683072, 135, '2015-02-01 00:53:14.000000', 'consum', 0.0227, 'lps'),
	(683073, 135, '2015-02-01 00:53:15.000000', 'consum', 0.0234, 'lps'),
	(683074, 135, '2015-02-01 00:53:16.000000', 'consum', 0.0228, 'lps'),
	(683075, 135, '2015-02-01 00:53:17.000000', 'consum', 0.0230, 'lps'),
	(683076, 135, '2015-02-01 00:53:18.000000', 'consum', 0.0254, 'lps'),
	(683077, 135, '2015-02-01 00:53:19.000000', 'consum', 0.0214, 'lps'),
	(683078, 135, '2015-02-01 00:53:20.000000', 'consum', 0.0256, 'lps'),
	(683079, 135, '2015-02-01 00:53:21.000000', 'consum', 0.0219, 'lps'),
	(683080, 135, '2015-02-01 00:53:22.000000', 'consum', 0.0221, 'lps'),
	(683081, 135, '2015-02-01 00:53:23.000000', 'consum', 0.0240, 'lps'),
	(683082, 135, '2015-02-01 00:53:24.000000', 'consum', 0.0222, 'lps'),
	(683083, 135, '2015-02-01 00:53:25.000000', 'consum', 0.0233, 'lps'),
	(683084, 135, '2015-02-01 00:53:26.000000', 'consum', 0.0236, 'lps'),
	(683085, 135, '2015-02-01 00:53:27.000000', 'consum', 0.0218, 'lps'),
	(683086, 135, '2015-02-01 00:53:28.000000', 'consum', 0.0225, 'lps'),
	(683087, 135, '2015-02-01 00:53:29.000000', 'consum', 0.0211, 'lps'),
	(683088, 135, '2015-02-01 00:53:30.000000', 'consum', 0.0220, 'lps'),
	(683089, 135, '2015-02-01 00:53:31.000000', 'consum', 0.0260, 'lps'),
	(683090, 135, '2015-02-01 00:53:32.000000', 'consum', 0.0219, 'lps'),
	(683091, 135, '2015-02-01 00:53:33.000000', 'consum', 0.0211, 'lps'),
	(683092, 135, '2015-02-01 00:53:34.000000', 'consum', 0.0242, 'lps'),
	(683093, 135, '2015-02-01 00:53:35.000000', 'consum', 0.0210, 'lps'),
	(683094, 135, '2015-02-01 00:53:36.000000', 'consum', 0.0218, 'lps'),
	(683095, 135, '2015-02-01 00:53:37.000000', 'consum', 0.0249, 'lps'),
	(683096, 135, '2015-02-01 00:53:38.000000', 'consum', 0.0225, 'lps'),
	(683097, 135, '2015-02-01 00:53:39.000000', 'consum', 0.0221, 'lps'),
	(683098, 135, '2015-02-01 00:53:40.000000', 'consum', 0.0219, 'lps'),
	(683099, 135, '2015-02-01 00:53:41.000000', 'consum', 0.0222, 'lps'),
	(683100, 135, '2015-02-01 00:53:42.000000', 'consum', 0.0244, 'lps'),
	(683101, 135, '2015-02-01 00:53:43.000000', 'consum', 0.0238, 'lps'),
	(683102, 135, '2015-02-01 00:53:44.000000', 'consum', 0.0249, 'lps'),
	(683103, 135, '2015-02-01 00:53:45.000000', 'consum', 0.0215, 'lps'),
	(683104, 135, '2015-02-01 00:53:46.000000', 'consum', 0.0225, 'lps'),
	(683105, 135, '2015-02-01 00:53:47.000000', 'consum', 0.0218, 'lps'),
	(683106, 135, '2015-02-01 00:53:48.000000', 'consum', 0.0257, 'lps'),
	(683107, 135, '2015-02-01 00:53:49.000000', 'consum', 0.0212, 'lps'),
	(683108, 135, '2015-02-01 00:53:50.000000', 'consum', 0.0236, 'lps'),
	(683109, 135, '2015-02-01 00:53:51.000000', 'consum', 0.0231, 'lps'),
	(683110, 135, '2015-02-01 00:53:52.000000', 'consum', 0.0237, 'lps'),
	(683111, 135, '2015-02-01 00:53:53.000000', 'consum', 0.0228, 'lps'),
	(683112, 135, '2015-02-01 00:53:54.000000', 'consum', 0.0220, 'lps'),
	(683113, 135, '2015-02-01 00:53:55.000000', 'consum', 0.0258, 'lps'),
	(683114, 135, '2015-02-01 00:53:56.000000', 'consum', 0.0210, 'lps'),
	(683115, 135, '2015-02-01 00:53:57.000000', 'consum', 0.0224, 'lps'),
	(683116, 135, '2015-02-01 00:53:58.000000', 'consum', 0.0230, 'lps'),
	(683117, 135, '2015-02-01 00:53:59.000000', 'consum', 0.0216, 'lps'),
	(683118, 135, '2015-02-01 00:54:00.000000', 'consum', 0.0233, 'lps'),
	(683119, 135, '2015-02-01 00:54:01.000000', 'consum', 0.0252, 'lps'),
	(683120, 135, '2015-02-01 00:54:02.000000', 'consum', 0.0247, 'lps'),
	(683121, 135, '2015-02-01 00:54:03.000000', 'consum', 0.0215, 'lps'),
	(683122, 135, '2015-02-01 00:54:04.000000', 'consum', 0.0229, 'lps'),
	(683123, 135, '2015-02-01 00:54:05.000000', 'consum', 0.0241, 'lps'),
	(683124, 135, '2015-02-01 00:54:06.000000', 'consum', 0.0255, 'lps'),
	(683125, 135, '2015-02-01 00:54:07.000000', 'consum', 0.0236, 'lps'),
	(683126, 135, '2015-02-01 00:54:08.000000', 'consum', 0.0260, 'lps'),
	(683127, 135, '2015-02-01 00:54:09.000000', 'consum', 0.0223, 'lps'),
	(683128, 135, '2015-02-01 00:54:10.000000', 'consum', 0.0231, 'lps'),
	(683129, 135, '2015-02-01 00:54:11.000000', 'consum', 0.0222, 'lps'),
	(683130, 135, '2015-02-01 00:54:12.000000', 'consum', 0.0262, 'lps'),
	(683131, 135, '2015-02-01 00:54:13.000000', 'consum', 0.0224, 'lps'),
	(683132, 135, '2015-02-01 00:54:14.000000', 'consum', 0.0230, 'lps'),
	(683133, 135, '2015-02-01 00:54:15.000000', 'consum', 0.0214, 'lps'),
	(683134, 135, '2015-02-01 00:54:16.000000', 'consum', 0.0225, 'lps'),
	(683135, 135, '2015-02-01 00:54:17.000000', 'consum', 0.0221, 'lps'),
	(683136, 135, '2015-02-01 00:54:18.000000', 'consum', 0.0221, 'lps'),
	(683137, 135, '2015-02-01 00:54:19.000000', 'consum', 0.0231, 'lps'),
	(683138, 135, '2015-02-01 00:54:20.000000', 'consum', 0.0229, 'lps'),
	(683139, 135, '2015-02-01 00:54:21.000000', 'consum', 0.0241, 'lps'),
	(683140, 135, '2015-02-01 00:54:22.000000', 'consum', 0.0257, 'lps'),
	(683141, 135, '2015-02-01 00:54:23.000000', 'consum', 0.0247, 'lps'),
	(683142, 135, '2015-02-01 00:54:24.000000', 'consum', 0.0255, 'lps'),
	(683143, 135, '2015-02-01 00:54:25.000000', 'consum', 0.0216, 'lps'),
	(683144, 135, '2015-02-01 00:54:26.000000', 'consum', 0.0212, 'lps'),
	(683145, 135, '2015-02-01 00:54:27.000000', 'consum', 0.0257, 'lps'),
	(683146, 135, '2015-02-01 00:54:28.000000', 'consum', 0.0227, 'lps'),
	(683147, 135, '2015-02-01 00:54:29.000000', 'consum', 0.0261, 'lps'),
	(683148, 135, '2015-02-01 00:54:30.000000', 'consum', 0.0254, 'lps'),
	(683149, 135, '2015-02-01 00:54:31.000000', 'consum', 0.0224, 'lps'),
	(683150, 135, '2015-02-01 00:54:32.000000', 'consum', 0.0255, 'lps'),
	(683151, 135, '2015-02-01 00:54:33.000000', 'consum', 0.0235, 'lps'),
	(683152, 135, '2015-02-01 00:54:34.000000', 'consum', 0.0253, 'lps'),
	(683153, 135, '2015-02-01 00:54:35.000000', 'consum', 0.0245, 'lps'),
	(683154, 135, '2015-02-01 00:54:36.000000', 'consum', 0.0257, 'lps'),
	(683155, 135, '2015-02-01 00:54:37.000000', 'consum', 0.0236, 'lps'),
	(683156, 135, '2015-02-01 00:54:38.000000', 'consum', 0.0251, 'lps'),
	(683157, 135, '2015-02-01 00:54:39.000000', 'consum', 0.0232, 'lps'),
	(683158, 135, '2015-02-01 00:54:40.000000', 'consum', 0.0249, 'lps'),
	(683159, 135, '2015-02-01 00:54:41.000000', 'consum', 0.0236, 'lps'),
	(683160, 135, '2015-02-01 00:54:42.000000', 'consum', 0.0223, 'lps'),
	(683161, 135, '2015-02-01 00:54:43.000000', 'consum', 0.0252, 'lps'),
	(683162, 135, '2015-02-01 00:54:44.000000', 'consum', 0.0220, 'lps'),
	(683163, 135, '2015-02-01 00:54:45.000000', 'consum', 0.0240, 'lps'),
	(683164, 135, '2015-02-01 00:54:46.000000', 'consum', 0.0228, 'lps'),
	(683165, 135, '2015-02-01 00:54:47.000000', 'consum', 0.0260, 'lps'),
	(683166, 135, '2015-02-01 00:54:48.000000', 'consum', 0.0247, 'lps'),
	(683167, 135, '2015-02-01 00:54:49.000000', 'consum', 0.0246, 'lps'),
	(683168, 135, '2015-02-01 00:54:50.000000', 'consum', 0.0229, 'lps'),
	(683169, 135, '2015-02-01 00:54:51.000000', 'consum', 0.0248, 'lps'),
	(683170, 135, '2015-02-01 00:54:52.000000', 'consum', 0.0238, 'lps'),
	(683171, 135, '2015-02-01 00:54:53.000000', 'consum', 0.0236, 'lps'),
	(683172, 135, '2015-02-01 00:54:54.000000', 'consum', 0.0259, 'lps'),
	(683173, 135, '2015-02-01 00:54:55.000000', 'consum', 0.0216, 'lps'),
	(683174, 135, '2015-02-01 00:54:56.000000', 'consum', 0.0254, 'lps'),
	(683175, 135, '2015-02-01 00:54:57.000000', 'consum', 0.0255, 'lps'),
	(683176, 135, '2015-02-01 00:54:58.000000', 'consum', 0.0249, 'lps'),
	(683177, 135, '2015-02-01 00:54:59.000000', 'consum', 0.0220, 'lps'),
	(683178, 135, '2015-02-01 00:55:00.000000', 'consum', 0.0246, 'lps'),
	(683179, 135, '2015-02-01 00:55:01.000000', 'consum', 0.0255, 'lps'),
	(683180, 135, '2015-02-01 00:55:02.000000', 'consum', 0.0224, 'lps'),
	(683181, 135, '2015-02-01 00:55:03.000000', 'consum', 0.0250, 'lps'),
	(683182, 135, '2015-02-01 00:55:04.000000', 'consum', 0.0260, 'lps'),
	(683183, 135, '2015-02-01 00:55:05.000000', 'consum', 0.0238, 'lps'),
	(683184, 135, '2015-02-01 00:55:06.000000', 'consum', 0.0253, 'lps'),
	(683185, 135, '2015-02-01 00:55:07.000000', 'consum', 0.0237, 'lps'),
	(683186, 135, '2015-02-01 00:55:08.000000', 'consum', 0.0214, 'lps'),
	(683187, 135, '2015-02-01 00:55:09.000000', 'consum', 0.0257, 'lps'),
	(683188, 135, '2015-02-01 00:55:10.000000', 'consum', 0.0221, 'lps'),
	(683189, 135, '2015-02-01 00:55:11.000000', 'consum', 0.0229, 'lps'),
	(683190, 135, '2015-02-01 00:55:12.000000', 'consum', 0.0219, 'lps'),
	(683191, 135, '2015-02-01 00:55:13.000000', 'consum', 0.0251, 'lps'),
	(683192, 135, '2015-02-01 00:55:14.000000', 'consum', 0.0230, 'lps'),
	(683193, 135, '2015-02-01 00:55:15.000000', 'consum', 0.0243, 'lps'),
	(683194, 135, '2015-02-01 00:55:16.000000', 'consum', 0.0261, 'lps'),
	(683195, 135, '2015-02-01 00:55:17.000000', 'consum', 0.0259, 'lps'),
	(683196, 135, '2015-02-01 00:55:18.000000', 'consum', 0.0252, 'lps'),
	(683197, 135, '2015-02-01 00:55:19.000000', 'consum', 0.0220, 'lps'),
	(683198, 135, '2015-02-01 00:55:20.000000', 'consum', 0.0242, 'lps'),
	(683199, 135, '2015-02-01 00:55:21.000000', 'consum', 0.0231, 'lps'),
	(683200, 135, '2015-02-01 00:55:22.000000', 'consum', 0.0222, 'lps'),
	(683201, 135, '2015-02-01 00:55:23.000000', 'consum', 0.0258, 'lps'),
	(683202, 135, '2015-02-01 00:55:24.000000', 'consum', 0.0257, 'lps'),
	(683203, 135, '2015-02-01 00:55:25.000000', 'consum', 0.0250, 'lps'),
	(683204, 135, '2015-02-01 00:55:26.000000', 'consum', 0.0215, 'lps'),
	(683205, 135, '2015-02-01 00:55:27.000000', 'consum', 0.0221, 'lps'),
	(683206, 135, '2015-02-01 00:55:28.000000', 'consum', 0.0250, 'lps'),
	(683207, 135, '2015-02-01 00:55:29.000000', 'consum', 0.0218, 'lps'),
	(683208, 135, '2015-02-01 00:55:30.000000', 'consum', 0.0239, 'lps'),
	(683209, 135, '2015-02-01 00:55:31.000000', 'consum', 0.0225, 'lps'),
	(683210, 135, '2015-02-01 00:55:32.000000', 'consum', 0.0251, 'lps'),
	(683211, 135, '2015-02-01 00:55:33.000000', 'consum', 0.0214, 'lps'),
	(683212, 135, '2015-02-01 00:55:34.000000', 'consum', 0.0210, 'lps'),
	(683213, 135, '2015-02-01 00:55:35.000000', 'consum', 0.0253, 'lps'),
	(683214, 135, '2015-02-01 00:55:36.000000', 'consum', 0.0211, 'lps'),
	(683215, 135, '2015-02-01 00:55:37.000000', 'consum', 0.0249, 'lps'),
	(683216, 135, '2015-02-01 00:55:38.000000', 'consum', 0.0240, 'lps'),
	(683217, 135, '2015-02-01 00:55:39.000000', 'consum', 0.0245, 'lps'),
	(683218, 135, '2015-02-01 00:55:40.000000', 'consum', 0.0244, 'lps'),
	(683219, 135, '2015-02-01 00:55:41.000000', 'consum', 0.0223, 'lps'),
	(683220, 135, '2015-02-01 00:55:42.000000', 'consum', 0.0227, 'lps'),
	(683221, 135, '2015-02-01 00:55:43.000000', 'consum', 0.0255, 'lps'),
	(683222, 135, '2015-02-01 00:55:44.000000', 'consum', 0.0227, 'lps'),
	(683223, 135, '2015-02-01 00:55:45.000000', 'consum', 0.0211, 'lps'),
	(683224, 135, '2015-02-01 00:55:46.000000', 'consum', 0.0219, 'lps'),
	(683225, 135, '2015-02-01 00:55:47.000000', 'consum', 0.0254, 'lps'),
	(683226, 135, '2015-02-01 00:55:48.000000', 'consum', 0.0241, 'lps'),
	(683227, 135, '2015-02-01 00:55:49.000000', 'consum', 0.0237, 'lps'),
	(683228, 135, '2015-02-01 00:55:50.000000', 'consum', 0.0250, 'lps'),
	(683229, 135, '2015-02-01 00:55:51.000000', 'consum', 0.0225, 'lps'),
	(683230, 135, '2015-02-01 00:55:52.000000', 'consum', 0.0216, 'lps'),
	(683231, 135, '2015-02-01 00:55:53.000000', 'consum', 0.0251, 'lps'),
	(683232, 135, '2015-02-01 00:55:54.000000', 'consum', 0.0236, 'lps'),
	(683233, 135, '2015-02-01 00:55:55.000000', 'consum', 0.0221, 'lps'),
	(683234, 135, '2015-02-01 00:55:56.000000', 'consum', 0.0238, 'lps'),
	(683235, 135, '2015-02-01 00:55:57.000000', 'consum', 0.0211, 'lps'),
	(683236, 135, '2015-02-01 00:55:58.000000', 'consum', 0.0240, 'lps'),
	(683237, 135, '2015-02-01 00:55:59.000000', 'consum', 0.0249, 'lps'),
	(683238, 135, '2015-02-01 00:56:00.000000', 'consum', 0.0210, 'lps'),
	(683239, 135, '2015-02-01 00:56:01.000000', 'consum', 0.0253, 'lps'),
	(683240, 135, '2015-02-01 00:56:02.000000', 'consum', 0.0213, 'lps'),
	(683241, 135, '2015-02-01 00:56:03.000000', 'consum', 0.0256, 'lps'),
	(683242, 135, '2015-02-01 00:56:04.000000', 'consum', 0.0220, 'lps'),
	(683243, 135, '2015-02-01 00:56:05.000000', 'consum', 0.0229, 'lps'),
	(683244, 135, '2015-02-01 00:56:06.000000', 'consum', 0.0223, 'lps'),
	(683245, 135, '2015-02-01 00:56:07.000000', 'consum', 0.0219, 'lps'),
	(683246, 135, '2015-02-01 00:56:08.000000', 'consum', 0.0215, 'lps'),
	(683247, 135, '2015-02-01 00:56:09.000000', 'consum', 0.0261, 'lps'),
	(683248, 135, '2015-02-01 00:56:10.000000', 'consum', 0.0241, 'lps'),
	(683249, 135, '2015-02-01 00:56:11.000000', 'consum', 0.0210, 'lps'),
	(683250, 135, '2015-02-01 00:56:12.000000', 'consum', 0.0223, 'lps'),
	(683251, 135, '2015-02-01 00:56:13.000000', 'consum', 0.0222, 'lps'),
	(683252, 135, '2015-02-01 00:56:14.000000', 'consum', 0.0234, 'lps'),
	(683253, 135, '2015-02-01 00:56:15.000000', 'consum', 0.0240, 'lps'),
	(683254, 135, '2015-02-01 00:56:16.000000', 'consum', 0.0237, 'lps'),
	(683255, 135, '2015-02-01 00:56:17.000000', 'consum', 0.0256, 'lps'),
	(683256, 135, '2015-02-01 00:56:18.000000', 'consum', 0.0253, 'lps'),
	(683257, 135, '2015-02-01 00:56:19.000000', 'consum', 0.0234, 'lps'),
	(683258, 135, '2015-02-01 00:56:20.000000', 'consum', 0.0253, 'lps'),
	(683259, 135, '2015-02-01 00:56:21.000000', 'consum', 0.0250, 'lps'),
	(683260, 135, '2015-02-01 00:56:22.000000', 'consum', 0.0230, 'lps'),
	(683261, 135, '2015-02-01 00:56:23.000000', 'consum', 0.0240, 'lps'),
	(683262, 135, '2015-02-01 00:56:24.000000', 'consum', 0.0250, 'lps'),
	(683263, 135, '2015-02-01 00:56:25.000000', 'consum', 0.0214, 'lps'),
	(683264, 135, '2015-02-01 00:56:26.000000', 'consum', 0.0214, 'lps'),
	(683265, 135, '2015-02-01 00:56:27.000000', 'consum', 0.0221, 'lps'),
	(683266, 135, '2015-02-01 00:56:28.000000', 'consum', 0.0253, 'lps'),
	(683267, 135, '2015-02-01 00:56:29.000000', 'consum', 0.0233, 'lps'),
	(683268, 135, '2015-02-01 00:56:30.000000', 'consum', 0.0250, 'lps'),
	(683269, 135, '2015-02-01 00:56:31.000000', 'consum', 0.0234, 'lps'),
	(683270, 135, '2015-02-01 00:56:32.000000', 'consum', 0.0213, 'lps'),
	(683271, 135, '2015-02-01 00:56:33.000000', 'consum', 0.0258, 'lps'),
	(683272, 135, '2015-02-01 00:56:34.000000', 'consum', 0.0231, 'lps'),
	(683273, 135, '2015-02-01 00:56:35.000000', 'consum', 0.0225, 'lps'),
	(683274, 135, '2015-02-01 00:56:36.000000', 'consum', 0.0221, 'lps'),
	(683275, 135, '2015-02-01 00:56:37.000000', 'consum', 0.0222, 'lps'),
	(683276, 135, '2015-02-01 00:56:38.000000', 'consum', 0.0236, 'lps'),
	(683277, 135, '2015-02-01 00:56:39.000000', 'consum', 0.0251, 'lps'),
	(683278, 135, '2015-02-01 00:56:40.000000', 'consum', 0.0233, 'lps'),
	(683279, 135, '2015-02-01 00:56:41.000000', 'consum', 0.0255, 'lps'),
	(683280, 135, '2015-02-01 00:56:42.000000', 'consum', 0.0262, 'lps'),
	(683281, 135, '2015-02-01 00:56:43.000000', 'consum', 0.0228, 'lps'),
	(683282, 135, '2015-02-01 00:56:44.000000', 'consum', 0.0250, 'lps'),
	(683283, 135, '2015-02-01 00:56:45.000000', 'consum', 0.0251, 'lps'),
	(683284, 135, '2015-02-01 00:56:46.000000', 'consum', 0.0242, 'lps'),
	(683285, 135, '2015-02-01 00:56:47.000000', 'consum', 0.0247, 'lps'),
	(683286, 135, '2015-02-01 00:56:48.000000', 'consum', 0.0249, 'lps'),
	(683287, 135, '2015-02-01 00:56:49.000000', 'consum', 0.0240, 'lps'),
	(683288, 135, '2015-02-01 00:56:50.000000', 'consum', 0.0242, 'lps'),
	(683289, 135, '2015-02-01 00:56:51.000000', 'consum', 0.0229, 'lps'),
	(683290, 135, '2015-02-01 00:56:52.000000', 'consum', 0.0210, 'lps'),
	(683291, 135, '2015-02-01 00:56:53.000000', 'consum', 0.0260, 'lps'),
	(683292, 135, '2015-02-01 00:56:54.000000', 'consum', 0.0247, 'lps'),
	(683293, 135, '2015-02-01 00:56:55.000000', 'consum', 0.0247, 'lps'),
	(683294, 135, '2015-02-01 00:56:56.000000', 'consum', 0.0233, 'lps'),
	(683295, 135, '2015-02-01 00:56:57.000000', 'consum', 0.0212, 'lps'),
	(683296, 135, '2015-02-01 00:56:58.000000', 'consum', 0.0257, 'lps'),
	(683297, 135, '2015-02-01 00:56:59.000000', 'consum', 0.0230, 'lps'),
	(683298, 135, '2015-02-01 00:57:00.000000', 'consum', 0.0223, 'lps'),
	(683299, 135, '2015-02-01 00:57:01.000000', 'consum', 0.0215, 'lps'),
	(683300, 135, '2015-02-01 00:57:02.000000', 'consum', 0.0250, 'lps'),
	(683301, 135, '2015-02-01 00:57:03.000000', 'consum', 0.0234, 'lps'),
	(683302, 135, '2015-02-01 00:57:04.000000', 'consum', 0.0211, 'lps'),
	(683303, 135, '2015-02-01 00:57:05.000000', 'consum', 0.0251, 'lps'),
	(683304, 135, '2015-02-01 00:57:06.000000', 'consum', 0.0251, 'lps'),
	(683305, 135, '2015-02-01 00:57:07.000000', 'consum', 0.0243, 'lps'),
	(683306, 135, '2015-02-01 00:57:08.000000', 'consum', 0.0251, 'lps'),
	(683307, 135, '2015-02-01 00:57:09.000000', 'consum', 0.0262, 'lps'),
	(683308, 135, '2015-02-01 00:57:10.000000', 'consum', 0.0242, 'lps'),
	(683309, 135, '2015-02-01 00:57:11.000000', 'consum', 0.0214, 'lps'),
	(683310, 135, '2015-02-01 00:57:12.000000', 'consum', 0.0240, 'lps'),
	(683311, 135, '2015-02-01 00:57:13.000000', 'consum', 0.0245, 'lps'),
	(683312, 135, '2015-02-01 00:57:14.000000', 'consum', 0.0243, 'lps'),
	(683313, 135, '2015-02-01 00:57:15.000000', 'consum', 0.0214, 'lps'),
	(683314, 135, '2015-02-01 00:57:16.000000', 'consum', 0.0241, 'lps'),
	(683315, 135, '2015-02-01 00:57:17.000000', 'consum', 0.0247, 'lps'),
	(683316, 135, '2015-02-01 00:57:18.000000', 'consum', 0.0250, 'lps'),
	(683317, 135, '2015-02-01 00:57:19.000000', 'consum', 0.0245, 'lps'),
	(683318, 135, '2015-02-01 00:57:20.000000', 'consum', 0.0212, 'lps'),
	(683319, 135, '2015-02-01 00:57:21.000000', 'consum', 0.0221, 'lps'),
	(683320, 135, '2015-02-01 00:57:22.000000', 'consum', 0.0261, 'lps'),
	(683321, 135, '2015-02-01 00:57:23.000000', 'consum', 0.0220, 'lps'),
	(683322, 135, '2015-02-01 00:57:24.000000', 'consum', 0.0212, 'lps'),
	(683323, 135, '2015-02-01 00:57:25.000000', 'consum', 0.0245, 'lps'),
	(683324, 135, '2015-02-01 00:57:26.000000', 'consum', 0.0221, 'lps'),
	(683325, 135, '2015-02-01 00:57:27.000000', 'consum', 0.0214, 'lps'),
	(683326, 135, '2015-02-01 00:57:28.000000', 'consum', 0.0249, 'lps'),
	(683327, 135, '2015-02-01 00:57:29.000000', 'consum', 0.0235, 'lps'),
	(683328, 135, '2015-02-01 00:57:30.000000', 'consum', 0.0218, 'lps'),
	(683329, 135, '2015-02-01 00:57:31.000000', 'consum', 0.0229, 'lps'),
	(683330, 135, '2015-02-01 00:57:32.000000', 'consum', 0.0229, 'lps'),
	(683331, 135, '2015-02-01 00:57:33.000000', 'consum', 0.0247, 'lps'),
	(683332, 135, '2015-02-01 00:57:34.000000', 'consum', 0.0233, 'lps'),
	(683333, 135, '2015-02-01 00:57:35.000000', 'consum', 0.0213, 'lps'),
	(683334, 135, '2015-02-01 00:57:36.000000', 'consum', 0.0212, 'lps'),
	(683335, 135, '2015-02-01 00:57:37.000000', 'consum', 0.0211, 'lps'),
	(683336, 135, '2015-02-01 00:57:38.000000', 'consum', 0.0211, 'lps'),
	(683337, 135, '2015-02-01 00:57:39.000000', 'consum', 0.0211, 'lps'),
	(683338, 135, '2015-02-01 00:57:40.000000', 'consum', 0.0212, 'lps'),
	(683339, 135, '2015-02-01 00:57:41.000000', 'consum', 0.0218, 'lps'),
	(683340, 135, '2015-02-01 00:57:42.000000', 'consum', 0.0243, 'lps'),
	(683341, 135, '2015-02-01 00:57:43.000000', 'consum', 0.0246, 'lps'),
	(683342, 135, '2015-02-01 00:57:44.000000', 'consum', 0.0238, 'lps'),
	(683343, 135, '2015-02-01 00:57:45.000000', 'consum', 0.0244, 'lps'),
	(683344, 135, '2015-02-01 00:57:46.000000', 'consum', 0.0243, 'lps'),
	(683345, 135, '2015-02-01 00:57:47.000000', 'consum', 0.0218, 'lps'),
	(683346, 135, '2015-02-01 00:57:48.000000', 'consum', 0.0260, 'lps'),
	(683347, 135, '2015-02-01 00:57:49.000000', 'consum', 0.0225, 'lps'),
	(683348, 135, '2015-02-01 00:57:50.000000', 'consum', 0.0242, 'lps'),
	(683349, 135, '2015-02-01 00:57:51.000000', 'consum', 0.0220, 'lps'),
	(683350, 135, '2015-02-01 00:57:52.000000', 'consum', 0.0218, 'lps'),
	(683351, 135, '2015-02-01 00:57:53.000000', 'consum', 0.0221, 'lps'),
	(683352, 135, '2015-02-01 00:57:54.000000', 'consum', 0.0241, 'lps'),
	(683353, 135, '2015-02-01 00:57:55.000000', 'consum', 0.0228, 'lps'),
	(683354, 135, '2015-02-01 00:57:56.000000', 'consum', 0.0260, 'lps'),
	(683355, 135, '2015-02-01 00:57:57.000000', 'consum', 0.0247, 'lps'),
	(683356, 135, '2015-02-01 00:57:58.000000', 'consum', 0.0246, 'lps'),
	(683357, 135, '2015-02-01 00:57:59.000000', 'consum', 0.0225, 'lps'),
	(683358, 135, '2015-02-01 00:58:00.000000', 'consum', 0.0233, 'lps'),
	(683359, 135, '2015-02-01 00:58:01.000000', 'consum', 0.0228, 'lps'),
	(683360, 135, '2015-02-01 00:58:02.000000', 'consum', 0.0229, 'lps'),
	(683361, 135, '2015-02-01 00:58:03.000000', 'consum', 0.0253, 'lps'),
	(683362, 135, '2015-02-01 00:58:04.000000', 'consum', 0.0261, 'lps'),
	(683363, 135, '2015-02-01 00:58:05.000000', 'consum', 0.0233, 'lps'),
	(683364, 135, '2015-02-01 00:58:06.000000', 'consum', 0.0223, 'lps'),
	(683365, 135, '2015-02-01 00:58:07.000000', 'consum', 0.0261, 'lps'),
	(683366, 135, '2015-02-01 00:58:08.000000', 'consum', 0.0214, 'lps'),
	(683367, 135, '2015-02-01 00:58:09.000000', 'consum', 0.0238, 'lps'),
	(683368, 135, '2015-02-01 00:58:10.000000', 'consum', 0.0231, 'lps'),
	(683369, 135, '2015-02-01 00:58:11.000000', 'consum', 0.0230, 'lps'),
	(683370, 135, '2015-02-01 00:58:12.000000', 'consum', 0.0250, 'lps'),
	(683371, 135, '2015-02-01 00:58:13.000000', 'consum', 0.0243, 'lps'),
	(683372, 135, '2015-02-01 00:58:14.000000', 'consum', 0.0254, 'lps'),
	(683373, 135, '2015-02-01 00:58:15.000000', 'consum', 0.0228, 'lps'),
	(683374, 135, '2015-02-01 00:58:16.000000', 'consum', 0.0221, 'lps'),
	(683375, 135, '2015-02-01 00:58:17.000000', 'consum', 0.0210, 'lps'),
	(683376, 135, '2015-02-01 00:58:18.000000', 'consum', 0.0231, 'lps'),
	(683377, 135, '2015-02-01 00:58:19.000000', 'consum', 0.0262, 'lps'),
	(683378, 135, '2015-02-01 00:58:20.000000', 'consum', 0.0249, 'lps'),
	(683379, 135, '2015-02-01 00:58:21.000000', 'consum', 0.0251, 'lps'),
	(683380, 135, '2015-02-01 00:58:22.000000', 'consum', 0.0246, 'lps'),
	(683381, 135, '2015-02-01 00:58:23.000000', 'consum', 0.0214, 'lps'),
	(683382, 135, '2015-02-01 00:58:24.000000', 'consum', 0.0227, 'lps'),
	(683383, 135, '2015-02-01 00:58:25.000000', 'consum', 0.0230, 'lps'),
	(683384, 135, '2015-02-01 00:58:26.000000', 'consum', 0.0260, 'lps'),
	(683385, 135, '2015-02-01 00:58:27.000000', 'consum', 0.0240, 'lps'),
	(683386, 135, '2015-02-01 00:58:28.000000', 'consum', 0.0213, 'lps'),
	(683387, 135, '2015-02-01 00:58:29.000000', 'consum', 0.0240, 'lps'),
	(683388, 135, '2015-02-01 00:58:30.000000', 'consum', 0.0245, 'lps'),
	(683389, 135, '2015-02-01 00:58:31.000000', 'consum', 0.0242, 'lps'),
	(683390, 135, '2015-02-01 00:58:32.000000', 'consum', 0.0214, 'lps'),
	(683391, 135, '2015-02-01 00:58:33.000000', 'consum', 0.0241, 'lps'),
	(683392, 135, '2015-02-01 00:58:34.000000', 'consum', 0.0245, 'lps'),
	(683393, 135, '2015-02-01 00:58:35.000000', 'consum', 0.0240, 'lps'),
	(683394, 135, '2015-02-01 00:58:36.000000', 'consum', 0.0255, 'lps'),
	(683395, 135, '2015-02-01 00:58:37.000000', 'consum', 0.0241, 'lps'),
	(683396, 135, '2015-02-01 00:58:38.000000', 'consum', 0.0231, 'lps'),
	(683397, 135, '2015-02-01 00:58:39.000000', 'consum', 0.0221, 'lps'),
	(683398, 135, '2015-02-01 00:58:40.000000', 'consum', 0.0254, 'lps'),
	(683399, 135, '2015-02-01 00:58:41.000000', 'consum', 0.0241, 'lps'),
	(683400, 135, '2015-02-01 00:58:42.000000', 'consum', 0.0231, 'lps'),
	(683401, 135, '2015-02-01 00:58:43.000000', 'consum', 0.0225, 'lps'),
	(683402, 135, '2015-02-01 00:58:44.000000', 'consum', 0.0223, 'lps'),
	(683403, 135, '2015-02-01 00:58:45.000000', 'consum', 0.0231, 'lps'),
	(683404, 135, '2015-02-01 00:58:46.000000', 'consum', 0.0223, 'lps'),
	(683405, 135, '2015-02-01 00:58:47.000000', 'consum', 0.0211, 'lps'),
	(683406, 135, '2015-02-01 00:58:48.000000', 'consum', 0.0229, 'lps'),
	(683407, 135, '2015-02-01 00:58:49.000000', 'consum', 0.0249, 'lps'),
	(683408, 135, '2015-02-01 00:58:50.000000', 'consum', 0.0245, 'lps'),
	(683409, 135, '2015-02-01 00:58:51.000000', 'consum', 0.0215, 'lps'),
	(683410, 135, '2015-02-01 00:58:52.000000', 'consum', 0.0237, 'lps'),
	(683411, 135, '2015-02-01 00:58:53.000000', 'consum', 0.0223, 'lps'),
	(683412, 135, '2015-02-01 00:58:54.000000', 'consum', 0.0250, 'lps'),
	(683413, 135, '2015-02-01 00:58:55.000000', 'consum', 0.0211, 'lps'),
	(683414, 135, '2015-02-01 00:58:56.000000', 'consum', 0.0253, 'lps'),
	(683415, 135, '2015-02-01 00:58:57.000000', 'consum', 0.0213, 'lps'),
	(683416, 135, '2015-02-01 00:58:58.000000', 'consum', 0.0253, 'lps'),
	(683417, 135, '2015-02-01 00:58:59.000000', 'consum', 0.0259, 'lps'),
	(683418, 135, '2015-02-01 00:59:00.000000', 'consum', 0.0222, 'lps'),
	(683419, 135, '2015-02-01 00:59:01.000000', 'consum', 0.0228, 'lps'),
	(683420, 135, '2015-02-01 00:59:02.000000', 'consum', 0.0214, 'lps'),
	(683421, 135, '2015-02-01 00:59:03.000000', 'consum', 0.0226, 'lps'),
	(683422, 135, '2015-02-01 00:59:04.000000', 'consum', 0.0228, 'lps'),
	(683423, 135, '2015-02-01 00:59:05.000000', 'consum', 0.0253, 'lps'),
	(683424, 135, '2015-02-01 00:59:06.000000', 'consum', 0.0211, 'lps'),
	(683425, 135, '2015-02-01 00:59:07.000000', 'consum', 0.0245, 'lps'),
	(683426, 135, '2015-02-01 00:59:08.000000', 'consum', 0.0225, 'lps'),
	(683427, 135, '2015-02-01 00:59:09.000000', 'consum', 0.0234, 'lps'),
	(683428, 135, '2015-02-01 00:59:10.000000', 'consum', 0.0230, 'lps'),
	(683429, 135, '2015-02-01 00:59:11.000000', 'consum', 0.0242, 'lps'),
	(683430, 135, '2015-02-01 00:59:12.000000', 'consum', 0.0255, 'lps'),
	(683431, 135, '2015-02-01 00:59:13.000000', 'consum', 0.0232, 'lps'),
	(683432, 135, '2015-02-01 00:59:14.000000', 'consum', 0.0241, 'lps'),
	(683433, 135, '2015-02-01 00:59:15.000000', 'consum', 0.0247, 'lps'),
	(683434, 135, '2015-02-01 00:59:16.000000', 'consum', 0.0250, 'lps'),
	(683435, 135, '2015-02-01 00:59:17.000000', 'consum', 0.0245, 'lps'),
	(683436, 135, '2015-02-01 00:59:18.000000', 'consum', 0.0212, 'lps'),
	(683437, 135, '2015-02-01 00:59:19.000000', 'consum', 0.0221, 'lps'),
	(683438, 135, '2015-02-01 00:59:20.000000', 'consum', 0.0258, 'lps'),
	(683439, 135, '2015-02-01 00:59:21.000000', 'consum', 0.0262, 'lps'),
	(683440, 135, '2015-02-01 00:59:22.000000', 'consum', 0.0220, 'lps'),
	(683441, 135, '2015-02-01 00:59:23.000000', 'consum', 0.0261, 'lps'),
	(683442, 135, '2015-02-01 00:59:24.000000', 'consum', 0.0226, 'lps'),
	(683443, 135, '2015-02-01 00:59:25.000000', 'consum', 0.0243, 'lps'),
	(683444, 135, '2015-02-01 00:59:26.000000', 'consum', 0.0223, 'lps'),
	(683445, 135, '2015-02-01 00:59:27.000000', 'consum', 0.0229, 'lps'),
	(683446, 135, '2015-02-01 00:59:28.000000', 'consum', 0.0211, 'lps'),
	(683447, 135, '2015-02-01 00:59:29.000000', 'consum', 0.0214, 'lps'),
	(683448, 135, '2015-02-01 00:59:30.000000', 'consum', 0.0226, 'lps'),
	(683449, 135, '2015-02-01 00:59:31.000000', 'consum', 0.0226, 'lps'),
	(683450, 135, '2015-02-01 00:59:32.000000', 'consum', 0.0243, 'lps'),
	(683451, 135, '2015-02-01 00:59:33.000000', 'consum', 0.0220, 'lps'),
	(683452, 135, '2015-02-01 00:59:34.000000', 'consum', 0.0217, 'lps'),
	(683453, 135, '2015-02-01 00:59:35.000000', 'consum', 0.0214, 'lps'),
	(683454, 135, '2015-02-01 00:59:36.000000', 'consum', 0.0261, 'lps'),
	(683455, 135, '2015-02-01 00:59:37.000000', 'consum', 0.0242, 'lps'),
	(683456, 135, '2015-02-01 00:59:38.000000', 'consum', 0.0219, 'lps'),
	(683457, 135, '2015-02-01 00:59:39.000000', 'consum', 0.0210, 'lps'),
	(683458, 135, '2015-02-01 00:59:40.000000', 'consum', 0.0237, 'lps'),
	(683459, 135, '2015-02-01 00:59:41.000000', 'consum', 0.0239, 'lps'),
	(683460, 135, '2015-02-01 00:59:42.000000', 'consum', 0.0223, 'lps'),
	(683461, 135, '2015-02-01 00:59:43.000000', 'consum', 0.0240, 'lps'),
	(683462, 135, '2015-02-01 00:59:44.000000', 'consum', 0.0218, 'lps'),
	(683463, 135, '2015-02-01 00:59:45.000000', 'consum', 0.0213, 'lps'),
	(683464, 135, '2015-02-01 00:59:46.000000', 'consum', 0.0256, 'lps'),
	(683465, 135, '2015-02-01 00:59:47.000000', 'consum', 0.0218, 'lps'),
	(683466, 135, '2015-02-01 00:59:48.000000', 'consum', 0.0219, 'lps'),
	(683467, 135, '2015-02-01 00:59:49.000000', 'consum', 0.0231, 'lps'),
	(683468, 135, '2015-02-01 00:59:50.000000', 'consum', 0.0238, 'lps'),
	(683469, 135, '2015-02-01 00:59:51.000000', 'consum', 0.0231, 'lps'),
	(683470, 135, '2015-02-01 00:59:52.000000', 'consum', 0.0234, 'lps'),
	(683471, 135, '2015-02-01 00:59:53.000000', 'consum', 0.0214, 'lps'),
	(683472, 135, '2015-02-01 00:59:54.000000', 'consum', 0.0211, 'lps'),
	(683473, 135, '2015-02-01 00:59:55.000000', 'consum', 0.0256, 'lps'),
	(683474, 135, '2015-02-01 00:59:56.000000', 'consum', 0.0225, 'lps'),
	(683475, 135, '2015-02-01 00:59:57.000000', 'consum', 0.0256, 'lps'),
	(683476, 135, '2015-02-01 00:59:58.000000', 'consum', 0.0234, 'lps'),
	(683477, 135, '2015-02-01 00:59:59.000000', 'consum', 0.0245, 'lps'),
	(683478, 135, '2015-02-01 01:00:00.000000', 'consum', 0.0260, 'lps'),
	(683479, 135, '2015-02-01 01:00:01.000000', 'consum', 0.0249, 'lps'),
	(683480, 135, '2015-02-01 01:00:02.000000', 'consum', 0.0254, 'lps'),
	(683481, 135, '2015-02-01 01:00:03.000000', 'consum', 0.0211, 'lps'),
	(683482, 135, '2015-02-01 01:00:04.000000', 'consum', 0.0242, 'lps'),
	(683483, 135, '2015-02-01 01:00:05.000000', 'consum', 0.0210, 'lps'),
	(683484, 135, '2015-02-01 01:00:06.000000', 'consum', 0.0219, 'lps'),
	(683485, 135, '2015-02-01 01:00:07.000000', 'consum', 0.0255, 'lps'),
	(683486, 135, '2015-02-01 01:00:08.000000', 'consum', 0.0249, 'lps'),
	(683487, 135, '2015-02-01 01:00:09.000000', 'consum', 0.0220, 'lps'),
	(683488, 135, '2015-02-01 01:00:10.000000', 'consum', 0.0248, 'lps'),
	(683489, 135, '2015-02-01 01:00:11.000000', 'consum', 0.0211, 'lps'),
	(683490, 135, '2015-02-01 01:00:12.000000', 'consum', 0.0260, 'lps'),
	(683491, 135, '2015-02-01 01:00:13.000000', 'consum', 0.0245, 'lps'),
	(683492, 135, '2015-02-01 01:00:14.000000', 'consum', 0.0234, 'lps'),
	(683493, 135, '2015-02-01 01:00:15.000000', 'consum', 0.0228, 'lps'),
	(683494, 135, '2015-02-01 01:00:16.000000', 'consum', 0.0230, 'lps'),
	(683495, 135, '2015-02-01 01:00:17.000000', 'consum', 0.0254, 'lps'),
	(683496, 135, '2015-02-01 01:00:18.000000', 'consum', 0.0211, 'lps'),
	(683497, 135, '2015-02-01 01:00:19.000000', 'consum', 0.0245, 'lps'),
	(683498, 135, '2015-02-01 01:00:20.000000', 'consum', 0.0221, 'lps'),
	(683499, 135, '2015-02-01 01:00:21.000000', 'consum', 0.0214, 'lps'),
	(683500, 135, '2015-02-01 01:00:22.000000', 'consum', 0.0250, 'lps'),
	(683501, 135, '2015-02-01 01:00:23.000000', 'consum', 0.0242, 'lps'),
	(683502, 135, '2015-02-01 01:00:24.000000', 'consum', 0.0248, 'lps'),
	(683503, 135, '2015-02-01 01:00:25.000000', 'consum', 0.0252, 'lps'),
	(683504, 135, '2015-02-01 01:00:26.000000', 'consum', 0.0254, 'lps'),
	(683505, 135, '2015-02-01 01:00:27.000000', 'consum', 0.0253, 'lps'),
	(683506, 135, '2015-02-01 01:00:28.000000', 'consum', 0.0238, 'lps'),
	(683507, 135, '2015-02-01 01:00:29.000000', 'consum', 0.0221, 'lps'),
	(683508, 135, '2015-02-01 01:00:30.000000', 'consum', 0.0234, 'lps'),
	(683509, 135, '2015-02-01 01:00:31.000000', 'consum', 0.0244, 'lps'),
	(683510, 135, '2015-02-01 01:00:32.000000', 'consum', 0.0255, 'lps'),
	(683511, 135, '2015-02-01 01:00:33.000000', 'consum', 0.0227, 'lps'),
	(683512, 135, '2015-02-01 01:00:34.000000', 'consum', 0.0215, 'lps'),
	(683513, 135, '2015-02-01 01:00:35.000000', 'consum', 0.0239, 'lps'),
	(683514, 135, '2015-02-01 01:00:36.000000', 'consum', 0.0232, 'lps'),
	(683515, 135, '2015-02-01 01:00:37.000000', 'consum', 0.0235, 'lps'),
	(683516, 135, '2015-02-01 01:00:38.000000', 'consum', 0.0217, 'lps'),
	(683517, 135, '2015-02-01 01:00:39.000000', 'consum', 0.0221, 'lps'),
	(683518, 135, '2015-02-01 01:00:40.000000', 'consum', 0.0247, 'lps'),
	(683519, 135, '2015-02-01 01:00:41.000000', 'consum', 0.0254, 'lps'),
	(683520, 135, '2015-02-01 01:00:42.000000', 'consum', 0.0214, 'lps'),
	(683521, 135, '2015-02-01 01:00:43.000000', 'consum', 0.0257, 'lps'),
	(683522, 135, '2015-02-01 01:00:44.000000', 'consum', 0.0222, 'lps'),
	(683523, 135, '2015-02-01 01:00:45.000000', 'consum', 0.0235, 'lps'),
	(683524, 135, '2015-02-01 01:00:46.000000', 'consum', 0.0247, 'lps'),
	(683525, 135, '2015-02-01 01:00:47.000000', 'consum', 0.0215, 'lps'),
	(683526, 135, '2015-02-01 01:00:48.000000', 'consum', 0.0231, 'lps'),
	(683527, 135, '2015-02-01 01:00:49.000000', 'consum', 0.0248, 'lps'),
	(683528, 135, '2015-02-01 01:00:50.000000', 'consum', 0.0229, 'lps'),
	(683529, 135, '2015-02-01 01:00:51.000000', 'consum', 0.0246, 'lps'),
	(683530, 135, '2015-02-01 01:00:52.000000', 'consum', 0.0226, 'lps'),
	(683531, 135, '2015-02-01 01:00:53.000000', 'consum', 0.0236, 'lps'),
	(683532, 135, '2015-02-01 01:00:54.000000', 'consum', 0.0241, 'lps'),
	(683533, 135, '2015-02-01 01:00:55.000000', 'consum', 0.0232, 'lps'),
	(683534, 135, '2015-02-01 01:00:56.000000', 'consum', 0.0228, 'lps'),
	(683535, 135, '2015-02-01 01:00:57.000000', 'consum', 0.0236, 'lps'),
	(683536, 135, '2015-02-01 01:00:58.000000', 'consum', 0.0234, 'lps'),
	(683537, 135, '2015-02-01 01:00:59.000000', 'consum', 0.0252, 'lps'),
	(683538, 135, '2015-02-01 01:01:00.000000', 'consum', 0.0241, 'lps'),
	(683539, 135, '2015-02-01 01:01:01.000000', 'consum', 0.0240, 'lps'),
	(683540, 135, '2015-02-01 01:01:02.000000', 'consum', 0.0216, 'lps'),
	(683541, 135, '2015-02-01 01:01:03.000000', 'consum', 0.0256, 'lps'),
	(683542, 135, '2015-02-01 01:01:04.000000', 'consum', 0.0212, 'lps'),
	(683543, 135, '2015-02-01 01:01:05.000000', 'consum', 0.0240, 'lps'),
	(683544, 135, '2015-02-01 01:01:06.000000', 'consum', 0.0248, 'lps'),
	(683545, 135, '2015-02-01 01:01:07.000000', 'consum', 0.0258, 'lps'),
	(683546, 135, '2015-02-01 01:01:08.000000', 'consum', 0.0230, 'lps'),
	(683547, 135, '2015-02-01 01:01:09.000000', 'consum', 0.0221, 'lps'),
	(683548, 135, '2015-02-01 01:01:10.000000', 'consum', 0.0258, 'lps'),
	(683549, 135, '2015-02-01 01:01:11.000000', 'consum', 0.0258, 'lps'),
	(683550, 135, '2015-02-01 01:01:12.000000', 'consum', 0.0252, 'lps'),
	(683551, 135, '2015-02-01 01:01:13.000000', 'consum', 0.0223, 'lps'),
	(683552, 135, '2015-02-01 01:01:14.000000', 'consum', 0.0256, 'lps'),
	(683553, 135, '2015-02-01 01:01:15.000000', 'consum', 0.0244, 'lps'),
	(683554, 135, '2015-02-01 01:01:16.000000', 'consum', 0.0241, 'lps'),
	(683555, 135, '2015-02-01 01:01:17.000000', 'consum', 0.0210, 'lps'),
	(683556, 135, '2015-02-01 01:01:18.000000', 'consum', 0.0225, 'lps'),
	(683557, 135, '2015-02-01 01:01:19.000000', 'consum', 0.0232, 'lps'),
	(683558, 135, '2015-02-01 01:01:20.000000', 'consum', 0.0221, 'lps'),
	(683559, 135, '2015-02-01 01:01:21.000000', 'consum', 0.0253, 'lps'),
	(683560, 135, '2015-02-01 01:01:22.000000', 'consum', 0.0234, 'lps'),
	(683561, 135, '2015-02-01 01:01:23.000000', 'consum', 0.0256, 'lps'),
	(683562, 135, '2015-02-01 01:01:24.000000', 'consum', 0.0261, 'lps'),
	(683563, 135, '2015-02-01 01:01:25.000000', 'consum', 0.0223, 'lps'),
	(683564, 135, '2015-02-01 01:01:26.000000', 'consum', 0.0229, 'lps'),
	(683565, 135, '2015-02-01 01:01:27.000000', 'consum', 0.0212, 'lps'),
	(683566, 135, '2015-02-01 01:01:28.000000', 'consum', 0.0219, 'lps'),
	(683567, 135, '2015-02-01 01:01:29.000000', 'consum', 0.0248, 'lps'),
	(683568, 135, '2015-02-01 01:01:30.000000', 'consum', 0.0214, 'lps'),
	(683569, 135, '2015-02-01 01:01:31.000000', 'consum', 0.0224, 'lps'),
	(683570, 135, '2015-02-01 01:01:32.000000', 'consum', 0.0216, 'lps'),
	(683571, 135, '2015-02-01 01:01:33.000000', 'consum', 0.0250, 'lps'),
	(683572, 135, '2015-02-01 01:01:34.000000', 'consum', 0.0233, 'lps'),
	(683573, 135, '2015-02-01 01:01:35.000000', 'consum', 0.0260, 'lps'),
	(683574, 135, '2015-02-01 01:01:36.000000', 'consum', 0.0230, 'lps'),
	(683575, 135, '2015-02-01 01:01:37.000000', 'consum', 0.0214, 'lps'),
	(683576, 135, '2015-02-01 01:01:38.000000', 'consum', 0.0225, 'lps'),
	(683577, 135, '2015-02-01 01:01:39.000000', 'consum', 0.0219, 'lps'),
	(683578, 135, '2015-02-01 01:01:40.000000', 'consum', 0.0212, 'lps'),
	(683579, 135, '2015-02-01 01:01:41.000000', 'consum', 0.0244, 'lps'),
	(683580, 135, '2015-02-01 01:01:42.000000', 'consum', 0.0219, 'lps'),
	(683581, 135, '2015-02-01 01:01:43.000000', 'consum', 0.0256, 'lps'),
	(683582, 135, '2015-02-01 01:01:44.000000', 'consum', 0.0257, 'lps'),
	(683583, 135, '2015-02-01 01:01:45.000000', 'consum', 0.0252, 'lps'),
	(683584, 135, '2015-02-01 01:01:46.000000', 'consum', 0.0229, 'lps'),
	(683585, 135, '2015-02-01 01:01:47.000000', 'consum', 0.0233, 'lps'),
	(683586, 135, '2015-02-01 01:01:48.000000', 'consum', 0.0214, 'lps'),
	(683587, 135, '2015-02-01 01:01:49.000000', 'consum', 0.0215, 'lps'),
	(683588, 135, '2015-02-01 01:01:50.000000', 'consum', 0.0224, 'lps'),
	(683589, 135, '2015-02-01 01:01:51.000000', 'consum', 0.0214, 'lps'),
	(683590, 135, '2015-02-01 01:01:52.000000', 'consum', 0.0239, 'lps'),
	(683591, 135, '2015-02-01 01:01:53.000000', 'consum', 0.0236, 'lps'),
	(683592, 135, '2015-02-01 01:01:54.000000', 'consum', 0.0256, 'lps'),
	(683593, 135, '2015-02-01 01:01:55.000000', 'consum', 0.0257, 'lps'),
	(683594, 135, '2015-02-01 01:01:56.000000', 'consum', 0.0254, 'lps'),
	(683595, 135, '2015-02-01 01:01:57.000000', 'consum', 0.0237, 'lps'),
	(683596, 135, '2015-02-01 01:01:58.000000', 'consum', 0.0211, 'lps'),
	(683597, 135, '2015-02-01 01:01:59.000000', 'consum', 0.0242, 'lps'),
	(683598, 135, '2015-02-01 01:02:00.000000', 'consum', 0.0261, 'lps'),
	(683599, 135, '2015-02-01 01:02:01.000000', 'consum', 0.0211, 'lps'),
	(683600, 135, '2015-02-01 01:02:02.000000', 'consum', 0.0221, 'lps'),
	(683601, 135, '2015-02-01 01:02:03.000000', 'consum', 0.0262, 'lps'),
	(683602, 135, '2015-02-01 01:02:04.000000', 'consum', 0.0227, 'lps'),
	(683603, 135, '2015-02-01 01:02:05.000000', 'consum', 0.0246, 'lps'),
	(683604, 135, '2015-02-01 01:02:06.000000', 'consum', 0.0235, 'lps'),
	(683605, 135, '2015-02-01 01:02:07.000000', 'consum', 0.0225, 'lps'),
	(683606, 135, '2015-02-01 01:02:08.000000', 'consum', 0.0210, 'lps'),
	(683607, 135, '2015-02-01 01:02:09.000000', 'consum', 0.0218, 'lps'),
	(683608, 135, '2015-02-01 01:02:10.000000', 'consum', 0.0253, 'lps'),
	(683609, 135, '2015-02-01 01:02:11.000000', 'consum', 0.0242, 'lps'),
	(683610, 135, '2015-02-01 01:02:12.000000', 'consum', 0.0242, 'lps'),
	(683611, 135, '2015-02-01 01:02:13.000000', 'consum', 0.0221, 'lps'),
	(683612, 135, '2015-02-01 01:02:14.000000', 'consum', 0.0223, 'lps'),
	(683613, 135, '2015-02-01 01:02:15.000000', 'consum', 0.0244, 'lps'),
	(683614, 135, '2015-02-01 01:02:16.000000', 'consum', 0.0233, 'lps'),
	(683615, 135, '2015-02-01 01:02:17.000000', 'consum', 0.0226, 'lps'),
	(683616, 135, '2015-02-01 01:02:18.000000', 'consum', 0.0219, 'lps'),
	(683617, 135, '2015-02-01 01:02:19.000000', 'consum', 0.0211, 'lps'),
	(683618, 135, '2015-02-01 01:02:20.000000', 'consum', 0.0238, 'lps'),
	(683619, 135, '2015-02-01 01:02:21.000000', 'consum', 0.0242, 'lps'),
	(683620, 135, '2015-02-01 01:02:22.000000', 'consum', 0.0234, 'lps'),
	(683621, 135, '2015-02-01 01:02:23.000000', 'consum', 0.0233, 'lps'),
	(683622, 135, '2015-02-01 01:02:24.000000', 'consum', 0.0256, 'lps'),
	(683623, 135, '2015-02-01 01:02:25.000000', 'consum', 0.0211, 'lps'),
	(683624, 135, '2015-02-01 01:02:26.000000', 'consum', 0.0235, 'lps'),
	(683625, 135, '2015-02-01 01:02:27.000000', 'consum', 0.0228, 'lps'),
	(683626, 135, '2015-02-01 01:02:28.000000', 'consum', 0.0226, 'lps'),
	(683627, 135, '2015-02-01 01:02:29.000000', 'consum', 0.0236, 'lps'),
	(683628, 135, '2015-02-01 01:02:30.000000', 'consum', 0.0238, 'lps'),
	(683629, 135, '2015-02-01 01:02:31.000000', 'consum', 0.0221, 'lps'),
	(683630, 135, '2015-02-01 01:02:32.000000', 'consum', 0.0234, 'lps'),
	(683631, 135, '2015-02-01 01:02:33.000000', 'consum', 0.0245, 'lps'),
	(683632, 135, '2015-02-01 01:02:34.000000', 'consum', 0.0258, 'lps'),
	(683633, 135, '2015-02-01 01:02:35.000000', 'consum', 0.0242, 'lps'),
	(683634, 135, '2015-02-01 01:02:36.000000', 'consum', 0.0226, 'lps'),
	(683635, 135, '2015-02-01 01:02:37.000000', 'consum', 0.0247, 'lps'),
	(683636, 135, '2015-02-01 01:02:38.000000', 'consum', 0.0244, 'lps'),
	(683637, 135, '2015-02-01 01:02:39.000000', 'consum', 0.0213, 'lps'),
	(683638, 135, '2015-02-01 01:02:40.000000', 'consum', 0.0232, 'lps'),
	(683639, 135, '2015-02-01 01:02:41.000000', 'consum', 0.0258, 'lps'),
	(683640, 135, '2015-02-01 01:02:42.000000', 'consum', 0.0227, 'lps'),
	(683641, 135, '2015-02-01 01:02:43.000000', 'consum', 0.0256, 'lps'),
	(683642, 135, '2015-02-01 01:02:44.000000', 'consum', 0.0231, 'lps'),
	(683643, 135, '2015-02-01 01:02:45.000000', 'consum', 0.0228, 'lps'),
	(683644, 135, '2015-02-01 01:02:46.000000', 'consum', 0.0240, 'lps'),
	(683645, 135, '2015-02-01 01:02:47.000000', 'consum', 0.0252, 'lps'),
	(683646, 135, '2015-02-01 01:02:48.000000', 'consum', 0.0225, 'lps'),
	(683647, 135, '2015-02-01 01:02:49.000000', 'consum', 0.0214, 'lps'),
	(683648, 135, '2015-02-01 01:02:50.000000', 'consum', 0.0238, 'lps'),
	(683649, 135, '2015-02-01 01:02:51.000000', 'consum', 0.0234, 'lps'),
	(683650, 135, '2015-02-01 01:02:52.000000', 'consum', 0.0243, 'lps'),
	(683651, 135, '2015-02-01 01:02:53.000000', 'consum', 0.0253, 'lps'),
	(683652, 135, '2015-02-01 01:02:54.000000', 'consum', 0.0219, 'lps'),
	(683653, 135, '2015-02-01 01:02:55.000000', 'consum', 0.0233, 'lps'),
	(683654, 135, '2015-02-01 01:02:56.000000', 'consum', 0.0245, 'lps'),
	(683655, 135, '2015-02-01 01:02:57.000000', 'consum', 0.0262, 'lps'),
	(683656, 135, '2015-02-01 01:02:58.000000', 'consum', 0.0260, 'lps'),
	(683657, 135, '2015-02-01 01:02:59.000000', 'consum', 0.0253, 'lps'),
	(683658, 135, '2015-02-01 01:03:00.000000', 'consum', 0.0220, 'lps'),
	(683659, 135, '2015-02-01 01:03:01.000000', 'consum', 0.0240, 'lps'),
	(683660, 135, '2015-02-01 01:03:02.000000', 'consum', 0.0223, 'lps'),
	(683661, 135, '2015-02-01 01:03:03.000000', 'consum', 0.0238, 'lps'),
	(683662, 135, '2015-02-01 01:03:04.000000', 'consum', 0.0259, 'lps'),
	(683663, 135, '2015-02-01 01:03:05.000000', 'consum', 0.0215, 'lps'),
	(683664, 135, '2015-02-01 01:03:06.000000', 'consum', 0.0244, 'lps'),
	(683665, 135, '2015-02-01 01:03:07.000000', 'consum', 0.0260, 'lps'),
	(683666, 135, '2015-02-01 01:03:08.000000', 'consum', 0.0254, 'lps'),
	(683667, 135, '2015-02-01 01:03:09.000000', 'consum', 0.0225, 'lps'),
	(683668, 135, '2015-02-01 01:03:10.000000', 'consum', 0.0261, 'lps'),
	(683669, 135, '2015-02-01 01:03:11.000000', 'consum', 0.0210, 'lps'),
	(683670, 135, '2015-02-01 01:03:12.000000', 'consum', 0.0215, 'lps'),
	(683671, 135, '2015-02-01 01:03:13.000000', 'consum', 0.0234, 'lps'),
	(683672, 135, '2015-02-01 01:03:14.000000', 'consum', 0.0211, 'lps'),
	(683673, 135, '2015-02-01 01:03:15.000000', 'consum', 0.0251, 'lps'),
	(683674, 135, '2015-02-01 01:03:16.000000', 'consum', 0.0251, 'lps'),
	(683675, 135, '2015-02-01 01:03:17.000000', 'consum', 0.0240, 'lps'),
	(683676, 135, '2015-02-01 01:03:18.000000', 'consum', 0.0239, 'lps'),
	(683677, 135, '2015-02-01 01:03:19.000000', 'consum', 0.0210, 'lps'),
	(683678, 135, '2015-02-01 01:03:20.000000', 'consum', 0.0232, 'lps'),
	(683679, 135, '2015-02-01 01:03:21.000000', 'consum', 0.0215, 'lps'),
	(683680, 135, '2015-02-01 01:03:22.000000', 'consum', 0.0223, 'lps'),
	(683681, 135, '2015-02-01 01:03:23.000000', 'consum', 0.0261, 'lps'),
	(683682, 135, '2015-02-01 01:03:24.000000', 'consum', 0.0214, 'lps'),
	(683683, 135, '2015-02-01 01:03:25.000000', 'consum', 0.0237, 'lps'),
	(683684, 135, '2015-02-01 01:03:26.000000', 'consum', 0.0227, 'lps'),
	(683685, 135, '2015-02-01 01:03:27.000000', 'consum', 0.0213, 'lps'),
	(683686, 135, '2015-02-01 01:03:28.000000', 'consum', 0.0228, 'lps'),
	(683687, 135, '2015-02-01 01:03:29.000000', 'consum', 0.0239, 'lps'),
	(683688, 135, '2015-02-01 01:03:30.000000', 'consum', 0.0248, 'lps'),
	(683689, 135, '2015-02-01 01:03:31.000000', 'consum', 0.0262, 'lps'),
	(683690, 135, '2015-02-01 01:03:32.000000', 'consum', 0.0250, 'lps'),
	(683691, 135, '2015-02-01 01:03:33.000000', 'consum', 0.0255, 'lps'),
	(683692, 135, '2015-02-01 01:03:34.000000', 'consum', 0.0262, 'lps'),
	(683693, 135, '2015-02-01 01:03:35.000000', 'consum', 0.0231, 'lps'),
	(683694, 135, '2015-02-01 01:03:36.000000', 'consum', 0.0262, 'lps'),
	(683695, 135, '2015-02-01 01:03:37.000000', 'consum', 0.0252, 'lps'),
	(683696, 135, '2015-02-01 01:03:38.000000', 'consum', 0.0262, 'lps'),
	(683697, 135, '2015-02-01 01:03:39.000000', 'consum', 0.0239, 'lps'),
	(683698, 135, '2015-02-01 01:03:40.000000', 'consum', 0.0252, 'lps'),
	(683699, 135, '2015-02-01 01:03:41.000000', 'consum', 0.0227, 'lps'),
	(683700, 135, '2015-02-01 01:03:42.000000', 'consum', 0.0225, 'lps'),
	(683701, 135, '2015-02-01 01:03:43.000000', 'consum', 0.0232, 'lps'),
	(683702, 135, '2015-02-01 01:03:44.000000', 'consum', 0.0225, 'lps'),
	(683703, 135, '2015-02-01 01:03:45.000000', 'consum', 0.0216, 'lps'),
	(683704, 135, '2015-02-01 01:03:46.000000', 'consum', 0.0252, 'lps'),
	(683705, 135, '2015-02-01 01:03:47.000000', 'consum', 0.0242, 'lps'),
	(683706, 135, '2015-02-01 01:03:48.000000', 'consum', 0.0245, 'lps'),
	(683707, 135, '2015-02-01 01:03:49.000000', 'consum', 0.0235, 'lps'),
	(683708, 135, '2015-02-01 01:03:50.000000', 'consum', 0.0233, 'lps'),
	(683709, 135, '2015-02-01 01:03:51.000000', 'consum', 0.0250, 'lps'),
	(683710, 135, '2015-02-01 01:03:52.000000', 'consum', 0.0234, 'lps'),
	(683711, 135, '2015-02-01 01:03:53.000000', 'consum', 0.0210, 'lps'),
	(683712, 135, '2015-02-01 01:03:54.000000', 'consum', 0.0244, 'lps'),
	(683713, 135, '2015-02-01 01:03:55.000000', 'consum', 0.0222, 'lps'),
	(683714, 135, '2015-02-01 01:03:56.000000', 'consum', 0.0220, 'lps'),
	(683715, 135, '2015-02-01 01:03:57.000000', 'consum', 0.0225, 'lps'),
	(683716, 135, '2015-02-01 01:03:58.000000', 'consum', 0.0254, 'lps'),
	(683717, 135, '2015-02-01 01:03:59.000000', 'consum', 0.0230, 'lps'),
	(683718, 135, '2015-02-01 01:04:00.000000', 'consum', 0.0228, 'lps'),
	(683719, 135, '2015-02-01 01:04:01.000000', 'consum', 0.0243, 'lps'),
	(683720, 135, '2015-02-01 01:04:02.000000', 'consum', 0.0215, 'lps'),
	(683721, 135, '2015-02-01 01:04:03.000000', 'consum', 0.0244, 'lps'),
	(683722, 135, '2015-02-01 01:04:04.000000', 'consum', 0.0260, 'lps'),
	(683723, 135, '2015-02-01 01:04:05.000000', 'consum', 0.0250, 'lps'),
	(683724, 135, '2015-02-01 01:04:06.000000', 'consum', 0.0261, 'lps'),
	(683725, 135, '2015-02-01 01:04:07.000000', 'consum', 0.0239, 'lps'),
	(683726, 135, '2015-02-01 01:04:08.000000', 'consum', 0.0255, 'lps'),
	(683727, 135, '2015-02-01 01:04:09.000000', 'consum', 0.0243, 'lps'),
	(683728, 135, '2015-02-01 01:04:10.000000', 'consum', 0.0241, 'lps'),
	(683729, 135, '2015-02-01 01:04:11.000000', 'consum', 0.0211, 'lps'),
	(683730, 135, '2015-02-01 01:04:12.000000', 'consum', 0.0232, 'lps'),
	(683731, 135, '2015-02-01 01:04:13.000000', 'consum', 0.0262, 'lps'),
	(683732, 135, '2015-02-01 01:04:14.000000', 'consum', 0.0248, 'lps'),
	(683733, 135, '2015-02-01 01:04:15.000000', 'consum', 0.0245, 'lps'),
	(683734, 135, '2015-02-01 01:04:16.000000', 'consum', 0.0216, 'lps'),
	(683735, 135, '2015-02-01 01:04:17.000000', 'consum', 0.0241, 'lps'),
	(683736, 135, '2015-02-01 01:04:18.000000', 'consum', 0.0243, 'lps'),
	(683737, 135, '2015-02-01 01:04:19.000000', 'consum', 0.0228, 'lps'),
	(683738, 135, '2015-02-01 01:04:20.000000', 'consum', 0.0254, 'lps'),
	(683739, 135, '2015-02-01 01:04:21.000000', 'consum', 0.0220, 'lps'),
	(683740, 135, '2015-02-01 01:04:22.000000', 'consum', 0.0234, 'lps'),
	(683741, 135, '2015-02-01 01:04:23.000000', 'consum', 0.0246, 'lps'),
	(683742, 135, '2015-02-01 01:04:24.000000', 'consum', 0.0212, 'lps'),
	(683743, 135, '2015-02-01 01:04:25.000000', 'consum', 0.0220, 'lps'),
	(683744, 135, '2015-02-01 01:04:26.000000', 'consum', 0.0254, 'lps'),
	(683745, 135, '2015-02-01 01:04:27.000000', 'consum', 0.0241, 'lps'),
	(683746, 135, '2015-02-01 01:04:28.000000', 'consum', 0.0233, 'lps'),
	(683747, 135, '2015-02-01 01:04:29.000000', 'consum', 0.0234, 'lps'),
	(683748, 135, '2015-02-01 01:04:30.000000', 'consum', 0.0210, 'lps'),
	(683749, 135, '2015-02-01 01:04:31.000000', 'consum', 0.0241, 'lps'),
	(683750, 135, '2015-02-01 01:04:32.000000', 'consum', 0.0262, 'lps'),
	(683751, 135, '2015-02-01 01:04:33.000000', 'consum', 0.0219, 'lps'),
	(683752, 135, '2015-02-01 01:04:34.000000', 'consum', 0.0258, 'lps'),
	(683753, 135, '2015-02-01 01:04:35.000000', 'consum', 0.0210, 'lps'),
	(683754, 135, '2015-02-01 01:04:36.000000', 'consum', 0.0228, 'lps'),
	(683755, 135, '2015-02-01 01:04:37.000000', 'consum', 0.0245, 'lps'),
	(683756, 135, '2015-02-01 01:04:38.000000', 'consum', 0.0227, 'lps'),
	(683757, 135, '2015-02-01 01:04:39.000000', 'consum', 0.0244, 'lps'),
	(683758, 135, '2015-02-01 01:04:40.000000', 'consum', 0.0225, 'lps'),
	(683759, 135, '2015-02-01 01:04:41.000000', 'consum', 0.0234, 'lps'),
	(683760, 135, '2015-02-01 01:04:42.000000', 'consum', 0.0234, 'lps'),
	(683761, 135, '2015-02-01 01:04:43.000000', 'consum', 0.0256, 'lps'),
	(683762, 135, '2015-02-01 01:04:44.000000', 'consum', 0.0212, 'lps'),
	(683763, 135, '2015-02-01 01:04:45.000000', 'consum', 0.0240, 'lps'),
	(683764, 135, '2015-02-01 01:04:46.000000', 'consum', 0.0249, 'lps'),
	(683765, 135, '2015-02-01 01:04:47.000000', 'consum', 0.0261, 'lps'),
	(683766, 135, '2015-02-01 01:04:48.000000', 'consum', 0.0244, 'lps'),
	(683767, 135, '2015-02-01 01:04:49.000000', 'consum', 0.0226, 'lps'),
	(683768, 135, '2015-02-01 01:04:50.000000', 'consum', 0.0243, 'lps'),
	(683769, 135, '2015-02-01 01:04:51.000000', 'consum', 0.0222, 'lps'),
	(683770, 135, '2015-02-01 01:04:52.000000', 'consum', 0.0222, 'lps'),
	(683771, 135, '2015-02-01 01:04:53.000000', 'consum', 0.0235, 'lps'),
	(683772, 135, '2015-02-01 01:04:54.000000', 'consum', 0.0248, 'lps'),
	(683773, 135, '2015-02-01 01:04:55.000000', 'consum', 0.0217, 'lps'),
	(683774, 135, '2015-02-01 01:04:56.000000', 'consum', 0.0238, 'lps'),
	(683775, 135, '2015-02-01 01:04:57.000000', 'consum', 0.0225, 'lps'),
	(683776, 135, '2015-02-01 01:04:58.000000', 'consum', 0.0253, 'lps'),
	(683777, 135, '2015-02-01 01:04:59.000000', 'consum', 0.0224, 'lps'),
	(683778, 135, '2015-02-01 01:05:00.000000', 'consum', 0.0254, 'lps'),
	(683779, 135, '2015-02-01 01:05:01.000000', 'consum', 0.0232, 'lps'),
	(683780, 135, '2015-02-01 01:05:02.000000', 'consum', 0.0239, 'lps'),
	(683781, 135, '2015-02-01 01:05:03.000000', 'consum', 0.0240, 'lps'),
	(683782, 135, '2015-02-01 01:05:04.000000', 'consum', 0.0217, 'lps'),
	(683783, 135, '2015-02-01 01:05:05.000000', 'consum', 0.0210, 'lps'),
	(683784, 135, '2015-02-01 01:05:06.000000', 'consum', 0.0241, 'lps'),
	(683785, 135, '2015-02-01 01:05:07.000000', 'consum', 0.0259, 'lps'),
	(683786, 135, '2015-02-01 01:05:08.000000', 'consum', 0.0259, 'lps'),
	(683787, 135, '2015-02-01 01:05:09.000000', 'consum', 0.0254, 'lps'),
	(683788, 135, '2015-02-01 01:05:10.000000', 'consum', 0.0232, 'lps'),
	(683789, 135, '2015-02-01 01:05:11.000000', 'consum', 0.0241, 'lps'),
	(683790, 135, '2015-02-01 01:05:12.000000', 'consum', 0.0244, 'lps'),
	(683791, 135, '2015-02-01 01:05:13.000000', 'consum', 0.0237, 'lps'),
	(683792, 135, '2015-02-01 01:05:14.000000', 'consum', 0.0244, 'lps'),
	(683793, 135, '2015-02-01 01:05:15.000000', 'consum', 0.0248, 'lps'),
	(683794, 135, '2015-02-01 01:05:16.000000', 'consum', 0.0243, 'lps'),
	(683795, 135, '2015-02-01 01:05:17.000000', 'consum', 0.0261, 'lps'),
	(683796, 135, '2015-02-01 01:05:18.000000', 'consum', 0.0210, 'lps'),
	(683797, 135, '2015-02-01 01:05:19.000000', 'consum', 0.0214, 'lps'),
	(683798, 135, '2015-02-01 01:05:20.000000', 'consum', 0.0231, 'lps'),
	(683799, 135, '2015-02-01 01:05:21.000000', 'consum', 0.0250, 'lps'),
	(683800, 135, '2015-02-01 01:05:22.000000', 'consum', 0.0242, 'lps'),
	(683801, 135, '2015-02-01 01:05:23.000000', 'consum', 0.0250, 'lps'),
	(683802, 135, '2015-02-01 01:05:24.000000', 'consum', 0.0261, 'lps'),
	(683803, 135, '2015-02-01 01:05:25.000000', 'consum', 0.0240, 'lps'),
	(683804, 135, '2015-02-01 01:05:26.000000', 'consum', 0.0261, 'lps'),
	(683805, 135, '2015-02-01 01:05:27.000000', 'consum', 0.0217, 'lps'),
	(683806, 135, '2015-02-01 01:05:28.000000', 'consum', 0.0251, 'lps'),
	(683807, 135, '2015-02-01 01:05:29.000000', 'consum', 0.0236, 'lps'),
	(683808, 135, '2015-02-01 01:05:30.000000', 'consum', 0.0216, 'lps'),
	(683809, 135, '2015-02-01 01:05:31.000000', 'consum', 0.0218, 'lps'),
	(683810, 135, '2015-02-01 01:05:32.000000', 'consum', 0.0233, 'lps'),
	(683811, 135, '2015-02-01 01:05:33.000000', 'consum', 0.0248, 'lps'),
	(683812, 135, '2015-02-01 01:05:34.000000', 'consum', 0.0225, 'lps'),
	(683813, 135, '2015-02-01 01:05:35.000000', 'consum', 0.0225, 'lps'),
	(683814, 135, '2015-02-01 01:05:36.000000', 'consum', 0.0242, 'lps'),
	(683815, 135, '2015-02-01 01:05:37.000000', 'consum', 0.0218, 'lps'),
	(683816, 135, '2015-02-01 01:05:38.000000', 'consum', 0.0261, 'lps'),
	(683817, 135, '2015-02-01 01:05:39.000000', 'consum', 0.0229, 'lps'),
	(683818, 135, '2015-02-01 01:05:40.000000', 'consum', 0.0259, 'lps'),
	(683819, 135, '2015-02-01 01:05:41.000000', 'consum', 0.0238, 'lps'),
	(683820, 135, '2015-02-01 01:05:42.000000', 'consum', 0.0257, 'lps'),
	(683821, 135, '2015-02-01 01:05:43.000000', 'consum', 0.0257, 'lps'),
	(683822, 135, '2015-02-01 01:05:44.000000', 'consum', 0.0250, 'lps'),
	(683823, 135, '2015-02-01 01:05:45.000000', 'consum', 0.0215, 'lps'),
	(683824, 135, '2015-02-01 01:05:46.000000', 'consum', 0.0224, 'lps'),
	(683825, 135, '2015-02-01 01:05:47.000000', 'consum', 0.0212, 'lps'),
	(683826, 135, '2015-02-01 01:05:48.000000', 'consum', 0.0229, 'lps'),
	(683827, 135, '2015-02-01 01:05:49.000000', 'consum', 0.0250, 'lps'),
	(683828, 135, '2015-02-01 01:05:50.000000', 'consum', 0.0245, 'lps'),
	(683829, 135, '2015-02-01 01:05:51.000000', 'consum', 0.0212, 'lps'),
	(683830, 135, '2015-02-01 01:05:52.000000', 'consum', 0.0222, 'lps'),
	(683831, 135, '2015-02-01 01:05:53.000000', 'consum', 0.0213, 'lps'),
	(683832, 135, '2015-02-01 01:05:54.000000', 'consum', 0.0241, 'lps'),
	(683833, 135, '2015-02-01 01:05:55.000000', 'consum', 0.0253, 'lps'),
	(683834, 135, '2015-02-01 01:05:56.000000', 'consum', 0.0223, 'lps'),
	(683835, 135, '2015-02-01 01:05:57.000000', 'consum', 0.0254, 'lps'),
	(683836, 135, '2015-02-01 01:05:58.000000', 'consum', 0.0232, 'lps'),
	(683837, 135, '2015-02-01 01:05:59.000000', 'consum', 0.0244, 'lps'),
	(683838, 135, '2015-02-01 01:06:00.000000', 'consum', 0.0258, 'lps'),
	(683839, 135, '2015-02-01 01:06:01.000000', 'consum', 0.0244, 'lps'),
	(683840, 135, '2015-02-01 01:06:02.000000', 'consum', 0.0235, 'lps'),
	(683841, 135, '2015-02-01 01:06:03.000000', 'consum', 0.0234, 'lps'),
	(683842, 135, '2015-02-01 01:06:04.000000', 'consum', 0.0258, 'lps'),
	(683843, 135, '2015-02-01 01:06:05.000000', 'consum', 0.0217, 'lps'),
	(683844, 135, '2015-02-01 01:06:06.000000', 'consum', 0.0260, 'lps'),
	(683845, 135, '2015-02-01 01:06:07.000000', 'consum', 0.0227, 'lps'),
	(683846, 135, '2015-02-01 01:06:08.000000', 'consum', 0.0252, 'lps'),
	(683847, 135, '2015-02-01 01:06:09.000000', 'consum', 0.0213, 'lps'),
	(683848, 135, '2015-02-01 01:06:10.000000', 'consum', 0.0256, 'lps'),
	(683849, 135, '2015-02-01 01:06:11.000000', 'consum', 0.0219, 'lps'),
	(683850, 135, '2015-02-01 01:06:12.000000', 'consum', 0.0224, 'lps'),
	(683851, 135, '2015-02-01 01:06:13.000000', 'consum', 0.0252, 'lps'),
	(683852, 135, '2015-02-01 01:06:14.000000', 'consum', 0.0222, 'lps'),
	(683853, 135, '2015-02-01 01:06:15.000000', 'consum', 0.0250, 'lps'),
	(683854, 135, '2015-02-01 01:06:16.000000', 'consum', 0.0214, 'lps'),
	(683855, 135, '2015-02-01 01:06:17.000000', 'consum', 0.0216, 'lps'),
	(683856, 135, '2015-02-01 01:06:18.000000', 'consum', 0.0229, 'lps'),
	(683857, 135, '2015-02-01 01:06:19.000000', 'consum', 0.0235, 'lps'),
	(683858, 135, '2015-02-01 01:06:20.000000', 'consum', 0.0225, 'lps'),
	(683859, 135, '2015-02-01 01:06:21.000000', 'consum', 0.0211, 'lps'),
	(683860, 135, '2015-02-01 01:06:22.000000', 'consum', 0.0222, 'lps'),
	(683861, 135, '2015-02-01 01:06:23.000000', 'consum', 0.0214, 'lps'),
	(683862, 135, '2015-02-01 01:06:24.000000', 'consum', 0.0249, 'lps'),
	(683863, 135, '2015-02-01 01:06:25.000000', 'consum', 0.0232, 'lps'),
	(683864, 135, '2015-02-01 01:06:26.000000', 'consum', 0.0258, 'lps'),
	(683865, 135, '2015-02-01 01:06:27.000000', 'consum', 0.0225, 'lps'),
	(683866, 135, '2015-02-01 01:06:28.000000', 'consum', 0.0250, 'lps'),
	(683867, 135, '2015-02-01 01:06:29.000000', 'consum', 0.0258, 'lps'),
	(683868, 135, '2015-02-01 01:06:30.000000', 'consum', 0.0224, 'lps'),
	(683869, 135, '2015-02-01 01:06:31.000000', 'consum', 0.0242, 'lps'),
	(683870, 135, '2015-02-01 01:06:32.000000', 'consum', 0.0225, 'lps'),
	(683871, 135, '2015-02-01 01:06:33.000000', 'consum', 0.0240, 'lps'),
	(683872, 135, '2015-02-01 01:06:34.000000', 'consum', 0.0262, 'lps'),
	(683873, 135, '2015-02-01 01:06:35.000000', 'consum', 0.0220, 'lps'),
	(683874, 135, '2015-02-01 01:06:36.000000', 'consum', 0.0214, 'lps'),
	(683875, 135, '2015-02-01 01:06:37.000000', 'consum', 0.0252, 'lps'),
	(683876, 135, '2015-02-01 01:06:38.000000', 'consum', 0.0249, 'lps'),
	(683877, 135, '2015-02-01 01:06:39.000000', 'consum', 0.0228, 'lps'),
	(683878, 135, '2015-02-01 01:06:40.000000', 'consum', 0.0237, 'lps'),
	(683879, 135, '2015-02-01 01:06:41.000000', 'consum', 0.0237, 'lps'),
	(683880, 135, '2015-02-01 01:06:42.000000', 'consum', 0.0212, 'lps'),
	(683881, 135, '2015-02-01 01:06:43.000000', 'consum', 0.0248, 'lps'),
	(683882, 135, '2015-02-01 01:06:44.000000', 'consum', 0.0232, 'lps'),
	(683883, 135, '2015-02-01 01:06:45.000000', 'consum', 0.0260, 'lps'),
	(683884, 135, '2015-02-01 01:06:46.000000', 'consum', 0.0237, 'lps'),
	(683885, 135, '2015-02-01 01:06:47.000000', 'consum', 0.0247, 'lps'),
	(683886, 135, '2015-02-01 01:06:48.000000', 'consum', 0.0210, 'lps'),
	(683887, 135, '2015-02-01 01:06:49.000000', 'consum', 0.0258, 'lps'),
	(683888, 135, '2015-02-01 01:06:50.000000', 'consum', 0.0237, 'lps'),
	(683889, 135, '2015-02-01 01:06:51.000000', 'consum', 0.0254, 'lps'),
	(683890, 135, '2015-02-01 01:06:52.000000', 'consum', 0.0246, 'lps'),
	(683891, 135, '2015-02-01 01:06:53.000000', 'consum', 0.0257, 'lps'),
	(683892, 135, '2015-02-01 01:06:54.000000', 'consum', 0.0230, 'lps'),
	(683893, 135, '2015-02-01 01:06:55.000000', 'consum', 0.0224, 'lps'),
	(683894, 135, '2015-02-01 01:06:56.000000', 'consum', 0.0222, 'lps'),
	(683895, 135, '2015-02-01 01:06:57.000000', 'consum', 0.0229, 'lps'),
	(683896, 135, '2015-02-01 01:06:58.000000', 'consum', 0.0214, 'lps'),
	(683897, 135, '2015-02-01 01:06:59.000000', 'consum', 0.0226, 'lps'),
	(683898, 135, '2015-02-01 01:07:00.000000', 'consum', 0.0228, 'lps'),
	(683899, 135, '2015-02-01 01:07:01.000000', 'consum', 0.0251, 'lps'),
	(683900, 135, '2015-02-01 01:07:02.000000', 'consum', 0.0255, 'lps'),
	(683901, 135, '2015-02-01 01:07:03.000000', 'consum', 0.0260, 'lps'),
	(683902, 135, '2015-02-01 01:07:04.000000', 'consum', 0.0219, 'lps'),
	(683903, 135, '2015-02-01 01:07:05.000000', 'consum', 0.0213, 'lps'),
	(683904, 135, '2015-02-01 01:07:06.000000', 'consum', 0.0249, 'lps'),
	(683905, 135, '2015-02-01 01:07:07.000000', 'consum', 0.0238, 'lps'),
	(683906, 135, '2015-02-01 01:07:08.000000', 'consum', 0.0234, 'lps'),
	(683907, 135, '2015-02-01 01:07:09.000000', 'consum', 0.0247, 'lps'),
	(683908, 135, '2015-02-01 01:07:10.000000', 'consum', 0.0217, 'lps'),
	(683909, 135, '2015-02-01 01:07:11.000000', 'consum', 0.0242, 'lps'),
	(683910, 135, '2015-02-01 01:07:12.000000', 'consum', 0.0242, 'lps'),
	(683911, 135, '2015-02-01 01:07:13.000000', 'consum', 0.0223, 'lps'),
	(683912, 135, '2015-02-01 01:07:14.000000', 'consum', 0.0232, 'lps'),
	(683913, 135, '2015-02-01 01:07:15.000000', 'consum', 0.0228, 'lps'),
	(683914, 135, '2015-02-01 01:07:16.000000', 'consum', 0.0235, 'lps'),
	(683915, 135, '2015-02-01 01:07:17.000000', 'consum', 0.0228, 'lps'),
	(683916, 135, '2015-02-01 01:07:18.000000', 'consum', 0.0224, 'lps'),
	(683917, 135, '2015-02-01 01:07:19.000000', 'consum', 0.0226, 'lps'),
	(683918, 135, '2015-02-01 01:07:20.000000', 'consum', 0.0250, 'lps'),
	(683919, 135, '2015-02-01 01:07:21.000000', 'consum', 0.0258, 'lps'),
	(683920, 135, '2015-02-01 01:07:22.000000', 'consum', 0.0223, 'lps'),
	(683921, 135, '2015-02-01 01:07:23.000000', 'consum', 0.0236, 'lps'),
	(683922, 135, '2015-02-01 01:07:24.000000', 'consum', 0.0250, 'lps'),
	(683923, 135, '2015-02-01 01:07:25.000000', 'consum', 0.0226, 'lps'),
	(683924, 135, '2015-02-01 01:07:26.000000', 'consum', 0.0222, 'lps'),
	(683925, 135, '2015-02-01 01:07:27.000000', 'consum', 0.0226, 'lps'),
	(683926, 135, '2015-02-01 01:07:28.000000', 'consum', 0.0252, 'lps'),
	(683927, 135, '2015-02-01 01:07:29.000000', 'consum', 0.0214, 'lps'),
	(683928, 135, '2015-02-01 01:07:30.000000', 'consum', 0.0211, 'lps'),
	(683929, 135, '2015-02-01 01:07:31.000000', 'consum', 0.0255, 'lps'),
	(683930, 135, '2015-02-01 01:07:32.000000', 'consum', 0.0223, 'lps'),
	(683931, 135, '2015-02-01 01:07:33.000000', 'consum', 0.0244, 'lps'),
	(683932, 135, '2015-02-01 01:07:34.000000', 'consum', 0.0236, 'lps'),
	(683933, 135, '2015-02-01 01:07:35.000000', 'consum', 0.0239, 'lps'),
	(683934, 135, '2015-02-01 01:07:36.000000', 'consum', 0.0225, 'lps'),
	(683935, 135, '2015-02-01 01:07:37.000000', 'consum', 0.0249, 'lps'),
	(683936, 135, '2015-02-01 01:07:38.000000', 'consum', 0.0256, 'lps'),
	(683937, 135, '2015-02-01 01:07:39.000000', 'consum', 0.0216, 'lps'),
	(683938, 135, '2015-02-01 01:07:40.000000', 'consum', 0.0210, 'lps'),
	(683939, 135, '2015-02-01 01:07:41.000000', 'consum', 0.0246, 'lps'),
	(683940, 135, '2015-02-01 01:07:42.000000', 'consum', 0.0231, 'lps'),
	(683941, 135, '2015-02-01 01:07:43.000000', 'consum', 0.0261, 'lps'),
	(683942, 135, '2015-02-01 01:07:44.000000', 'consum', 0.0245, 'lps'),
	(683943, 135, '2015-02-01 01:07:45.000000', 'consum', 0.0231, 'lps'),
	(683944, 135, '2015-02-01 01:07:46.000000', 'consum', 0.0212, 'lps'),
	(683945, 135, '2015-02-01 01:07:47.000000', 'consum', 0.0210, 'lps'),
	(683946, 135, '2015-02-01 01:07:48.000000', 'consum', 0.0256, 'lps'),
	(683947, 135, '2015-02-01 01:07:49.000000', 'consum', 0.0231, 'lps'),
	(683948, 135, '2015-02-01 01:07:50.000000', 'consum', 0.0230, 'lps'),
	(683949, 135, '2015-02-01 01:07:51.000000', 'consum', 0.0246, 'lps'),
	(683950, 135, '2015-02-01 01:07:52.000000', 'consum', 0.0226, 'lps'),
	(683951, 135, '2015-02-01 01:07:53.000000', 'consum', 0.0235, 'lps'),
	(683952, 135, '2015-02-01 01:07:54.000000', 'consum', 0.0233, 'lps'),
	(683953, 135, '2015-02-01 01:07:55.000000', 'consum', 0.0253, 'lps'),
	(683954, 135, '2015-02-01 01:07:56.000000', 'consum', 0.0248, 'lps'),
	(683955, 135, '2015-02-01 01:07:57.000000', 'consum', 0.0219, 'lps'),
	(683956, 135, '2015-02-01 01:07:58.000000', 'consum', 0.0247, 'lps'),
	(683957, 135, '2015-02-01 01:07:59.000000', 'consum', 0.0262, 'lps'),
	(683958, 135, '2015-02-01 01:08:00.000000', 'consum', 0.0254, 'lps'),
	(683959, 135, '2015-02-01 01:08:01.000000', 'consum', 0.0222, 'lps'),
	(683960, 135, '2015-02-01 01:08:02.000000', 'consum', 0.0243, 'lps'),
	(683961, 135, '2015-02-01 01:08:03.000000', 'consum', 0.0235, 'lps'),
	(683962, 135, '2015-02-01 01:08:04.000000', 'consum', 0.0235, 'lps'),
	(683963, 135, '2015-02-01 01:08:05.000000', 'consum', 0.0262, 'lps'),
	(683964, 135, '2015-02-01 01:08:06.000000', 'consum', 0.0237, 'lps'),
	(683965, 135, '2015-02-01 01:08:07.000000', 'consum', 0.0242, 'lps'),
	(683966, 135, '2015-02-01 01:08:08.000000', 'consum', 0.0235, 'lps'),
	(683967, 135, '2015-02-01 01:08:09.000000', 'consum', 0.0241, 'lps'),
	(683968, 135, '2015-02-01 01:08:10.000000', 'consum', 0.0238, 'lps'),
	(683969, 135, '2015-02-01 01:08:11.000000', 'consum', 0.0256, 'lps'),
	(683970, 135, '2015-02-01 01:08:12.000000', 'consum', 0.0249, 'lps'),
	(683971, 135, '2015-02-01 01:08:13.000000', 'consum', 0.0216, 'lps'),
	(683972, 135, '2015-02-01 01:08:14.000000', 'consum', 0.0230, 'lps'),
	(683973, 135, '2015-02-01 01:08:15.000000', 'consum', 0.0240, 'lps'),
	(683974, 135, '2015-02-01 01:08:16.000000', 'consum', 0.0245, 'lps'),
	(683975, 135, '2015-02-01 01:08:17.000000', 'consum', 0.0243, 'lps'),
	(683976, 135, '2015-02-01 01:08:18.000000', 'consum', 0.0217, 'lps'),
	(683977, 135, '2015-02-01 01:08:19.000000', 'consum', 0.0253, 'lps'),
	(683978, 135, '2015-02-01 01:08:20.000000', 'consum', 0.0247, 'lps'),
	(683979, 135, '2015-02-01 01:08:21.000000', 'consum', 0.0214, 'lps'),
	(683980, 135, '2015-02-01 01:08:22.000000', 'consum', 0.0226, 'lps'),
	(683981, 135, '2015-02-01 01:08:23.000000', 'consum', 0.0225, 'lps'),
	(683982, 135, '2015-02-01 01:08:24.000000', 'consum', 0.0236, 'lps'),
	(683983, 135, '2015-02-01 01:08:25.000000', 'consum', 0.0242, 'lps'),
	(683984, 135, '2015-02-01 01:08:26.000000', 'consum', 0.0242, 'lps'),
	(683985, 135, '2015-02-01 01:08:27.000000', 'consum', 0.0222, 'lps'),
	(683986, 135, '2015-02-01 01:08:28.000000', 'consum', 0.0228, 'lps'),
	(683987, 135, '2015-02-01 01:08:29.000000', 'consum', 0.0210, 'lps'),
	(683988, 135, '2015-02-01 01:08:30.000000', 'consum', 0.0262, 'lps'),
	(683989, 135, '2015-02-01 01:08:31.000000', 'consum', 0.0260, 'lps'),
	(683990, 135, '2015-02-01 01:08:32.000000', 'consum', 0.0249, 'lps'),
	(683991, 135, '2015-02-01 01:08:33.000000', 'consum', 0.0257, 'lps'),
	(683992, 135, '2015-02-01 01:08:34.000000', 'consum', 0.0221, 'lps'),
	(683993, 135, '2015-02-01 01:08:35.000000', 'consum', 0.0230, 'lps'),
	(683994, 135, '2015-02-01 01:08:36.000000', 'consum', 0.0223, 'lps'),
	(683995, 135, '2015-02-01 01:08:37.000000', 'consum', 0.0219, 'lps'),
	(683996, 135, '2015-02-01 01:08:38.000000', 'consum', 0.0215, 'lps'),
	(683997, 135, '2015-02-01 01:08:39.000000', 'consum', 0.0260, 'lps'),
	(683998, 135, '2015-02-01 01:08:40.000000', 'consum', 0.0237, 'lps'),
	(683999, 135, '2015-02-01 01:08:41.000000', 'consum', 0.0246, 'lps'),
	(684000, 135, '2015-02-01 01:08:42.000000', 'consum', 0.0255, 'lps'),
	(684001, 135, '2015-02-01 01:08:43.000000', 'consum', 0.0224, 'lps'),
	(684002, 135, '2015-02-01 01:08:44.000000', 'consum', 0.0251, 'lps'),
	(684003, 135, '2015-02-01 01:08:45.000000', 'consum', 0.0212, 'lps'),
	(684004, 135, '2015-02-01 01:08:46.000000', 'consum', 0.0259, 'lps'),
	(684005, 135, '2015-02-01 01:08:47.000000', 'consum', 0.0237, 'lps'),
	(684006, 135, '2015-02-01 01:08:48.000000', 'consum', 0.0251, 'lps'),
	(684007, 135, '2015-02-01 01:08:49.000000', 'consum', 0.0229, 'lps'),
	(684008, 135, '2015-02-01 01:08:50.000000', 'consum', 0.0237, 'lps'),
	(684009, 135, '2015-02-01 01:08:51.000000', 'consum', 0.0234, 'lps'),
	(684010, 135, '2015-02-01 01:08:52.000000', 'consum', 0.0249, 'lps'),
	(684011, 135, '2015-02-01 01:08:53.000000', 'consum', 0.0229, 'lps'),
	(684012, 135, '2015-02-01 01:08:54.000000', 'consum', 0.0240, 'lps'),
	(684013, 135, '2015-02-01 01:08:55.000000', 'consum', 0.0252, 'lps'),
	(684014, 135, '2015-02-01 01:08:56.000000', 'consum', 0.0222, 'lps'),
	(684015, 135, '2015-02-01 01:08:57.000000', 'consum', 0.0251, 'lps'),
	(684016, 135, '2015-02-01 01:08:58.000000', 'consum', 0.0219, 'lps'),
	(684017, 135, '2015-02-01 01:08:59.000000', 'consum', 0.0240, 'lps'),
	(684018, 135, '2015-02-01 01:09:00.000000', 'consum', 0.0227, 'lps'),
	(684019, 135, '2015-02-01 01:09:01.000000', 'consum', 0.0258, 'lps'),
	(684020, 135, '2015-02-01 01:09:02.000000', 'consum', 0.0241, 'lps'),
	(684021, 135, '2015-02-01 01:09:03.000000', 'consum', 0.0220, 'lps'),
	(684022, 135, '2015-02-01 01:09:04.000000', 'consum', 0.0223, 'lps'),
	(684023, 135, '2015-02-01 01:09:05.000000', 'consum', 0.0246, 'lps'),
	(684024, 135, '2015-02-01 01:09:06.000000', 'consum', 0.0246, 'lps'),
	(684025, 135, '2015-02-01 01:09:07.000000', 'consum', 0.0229, 'lps'),
	(684026, 135, '2015-02-01 01:09:08.000000', 'consum', 0.0249, 'lps'),
	(684027, 135, '2015-02-01 01:09:09.000000', 'consum', 0.0245, 'lps'),
	(684028, 135, '2015-02-01 01:09:10.000000', 'consum', 0.0216, 'lps'),
	(684029, 135, '2015-02-01 01:09:11.000000', 'consum', 0.0239, 'lps'),
	(684030, 135, '2015-02-01 01:09:12.000000', 'consum', 0.0232, 'lps'),
	(684031, 135, '2015-02-01 01:09:13.000000', 'consum', 0.0234, 'lps'),
	(684032, 135, '2015-02-01 01:09:14.000000', 'consum', 0.0262, 'lps'),
	(684033, 135, '2015-02-01 01:09:15.000000', 'consum', 0.0243, 'lps'),
	(684034, 135, '2015-02-01 01:09:16.000000', 'consum', 0.0217, 'lps'),
	(684035, 135, '2015-02-01 01:09:17.000000', 'consum', 0.0253, 'lps'),
	(684036, 135, '2015-02-01 01:09:18.000000', 'consum', 0.0247, 'lps'),
	(684037, 135, '2015-02-01 01:09:19.000000', 'consum', 0.0214, 'lps'),
	(684038, 135, '2015-02-01 01:09:20.000000', 'consum', 0.0226, 'lps'),
	(684039, 135, '2015-02-01 01:09:21.000000', 'consum', 0.0226, 'lps'),
	(684040, 135, '2015-02-01 01:09:22.000000', 'consum', 0.0242, 'lps'),
	(684041, 135, '2015-02-01 01:09:23.000000', 'consum', 0.0215, 'lps'),
	(684042, 135, '2015-02-01 01:09:24.000000', 'consum', 0.0245, 'lps'),
	(684043, 135, '2015-02-01 01:09:25.000000', 'consum', 0.0213, 'lps'),
	(684044, 135, '2015-02-01 01:09:26.000000', 'consum', 0.0224, 'lps'),
	(684045, 135, '2015-02-01 01:09:27.000000', 'consum', 0.0220, 'lps'),
	(684046, 135, '2015-02-01 01:09:28.000000', 'consum', 0.0221, 'lps'),
	(684047, 135, '2015-02-01 01:09:29.000000', 'consum', 0.0232, 'lps'),
	(684048, 135, '2015-02-01 01:09:30.000000', 'consum', 0.0236, 'lps'),
	(684049, 135, '2015-02-01 01:09:31.000000', 'consum', 0.0219, 'lps'),
	(684050, 135, '2015-02-01 01:09:32.000000', 'consum', 0.0234, 'lps'),
	(684051, 135, '2015-02-01 01:09:33.000000', 'consum', 0.0248, 'lps'),
	(684052, 135, '2015-02-01 01:09:34.000000', 'consum', 0.0225, 'lps'),
	(684053, 135, '2015-02-01 01:09:35.000000', 'consum', 0.0221, 'lps'),
	(684054, 135, '2015-02-01 01:09:36.000000', 'consum', 0.0224, 'lps'),
	(684055, 135, '2015-02-01 01:09:37.000000', 'consum', 0.0246, 'lps'),
	(684056, 135, '2015-02-01 01:09:38.000000', 'consum', 0.0241, 'lps'),
	(684057, 135, '2015-02-01 01:09:39.000000', 'consum', 0.0258, 'lps'),
	(684058, 135, '2015-02-01 01:09:40.000000', 'consum', 0.0251, 'lps'),
	(684059, 135, '2015-02-01 01:09:41.000000', 'consum', 0.0220, 'lps'),
	(684060, 135, '2015-02-01 01:09:42.000000', 'consum', 0.0241, 'lps'),
	(684061, 135, '2015-02-01 01:09:43.000000', 'consum', 0.0233, 'lps'),
	(684062, 135, '2015-02-01 01:09:44.000000', 'consum', 0.0229, 'lps'),
	(684063, 135, '2015-02-01 01:09:45.000000', 'consum', 0.0239, 'lps'),
	(684064, 135, '2015-02-01 01:09:46.000000', 'consum', 0.0245, 'lps'),
	(684065, 135, '2015-02-01 01:09:47.000000', 'consum', 0.0246, 'lps'),
	(684066, 135, '2015-02-01 01:09:48.000000', 'consum', 0.0232, 'lps'),
	(684067, 135, '2015-02-01 01:09:49.000000', 'consum', 0.0213, 'lps'),
	(684068, 135, '2015-02-01 01:09:50.000000', 'consum', 0.0214, 'lps'),
	(684069, 135, '2015-02-01 01:09:51.000000', 'consum', 0.0221, 'lps'),
	(684070, 135, '2015-02-01 01:09:52.000000', 'consum', 0.0251, 'lps'),
	(684071, 135, '2015-02-01 01:09:53.000000', 'consum', 0.0224, 'lps'),
	(684072, 135, '2015-02-01 01:09:54.000000', 'consum', 0.0213, 'lps'),
	(684073, 135, '2015-02-01 01:09:55.000000', 'consum', 0.0235, 'lps'),
	(684074, 135, '2015-02-01 01:09:56.000000', 'consum', 0.0221, 'lps'),
	(684075, 135, '2015-02-01 01:09:57.000000', 'consum', 0.0243, 'lps'),
	(684076, 135, '2015-02-01 01:09:58.000000', 'consum', 0.0238, 'lps'),
	(684077, 135, '2015-02-01 01:09:59.000000', 'consum', 0.0249, 'lps'),
	(684078, 135, '2015-02-01 01:10:00.000000', 'consum', 0.0215, 'lps'),
	(684079, 135, '2015-02-01 01:10:01.000000', 'consum', 0.0227, 'lps'),
	(684080, 135, '2015-02-01 01:10:02.000000', 'consum', 0.0226, 'lps'),
	(684081, 135, '2015-02-01 01:10:03.000000', 'consum', 0.0239, 'lps'),
	(684082, 135, '2015-02-01 01:10:04.000000', 'consum', 0.0255, 'lps'),
	(684083, 135, '2015-02-01 01:10:05.000000', 'consum', 0.0242, 'lps'),
	(684084, 135, '2015-02-01 01:10:06.000000', 'consum', 0.0235, 'lps'),
	(684085, 135, '2015-02-01 01:10:07.000000', 'consum', 0.0241, 'lps'),
	(684086, 135, '2015-02-01 01:10:08.000000', 'consum', 0.0236, 'lps'),
	(684087, 135, '2015-02-01 01:10:09.000000', 'consum', 0.0250, 'lps'),
	(684088, 135, '2015-02-01 01:10:10.000000', 'consum', 0.0223, 'lps'),
	(684089, 135, '2015-02-01 01:10:11.000000', 'consum', 0.0211, 'lps'),
	(684090, 135, '2015-02-01 01:10:12.000000', 'consum', 0.0229, 'lps'),
	(684091, 135, '2015-02-01 01:10:13.000000', 'consum', 0.0251, 'lps'),
	(684092, 135, '2015-02-01 01:10:14.000000', 'consum', 0.0252, 'lps'),
	(684093, 135, '2015-02-01 01:10:15.000000', 'consum', 0.0242, 'lps'),
	(684094, 135, '2015-02-01 01:10:16.000000', 'consum', 0.0247, 'lps'),
	(684095, 135, '2015-02-01 01:10:17.000000', 'consum', 0.0247, 'lps'),
	(684096, 135, '2015-02-01 01:10:18.000000', 'consum', 0.0231, 'lps'),
	(684097, 135, '2015-02-01 01:10:19.000000', 'consum', 0.0256, 'lps'),
	(684098, 135, '2015-02-01 01:10:20.000000', 'consum', 0.0221, 'lps'),
	(684099, 135, '2015-02-01 01:10:21.000000', 'consum', 0.0233, 'lps'),
	(684100, 135, '2015-02-01 01:10:22.000000', 'consum', 0.0238, 'lps'),
	(684101, 135, '2015-02-01 01:10:23.000000', 'consum', 0.0231, 'lps'),
	(684102, 135, '2015-02-01 01:10:24.000000', 'consum', 0.0229, 'lps'),
	(684103, 135, '2015-02-01 01:10:25.000000', 'consum', 0.0242, 'lps'),
	(684104, 135, '2015-02-01 01:10:26.000000', 'consum', 0.0261, 'lps'),
	(684105, 135, '2015-02-01 01:10:27.000000', 'consum', 0.0210, 'lps'),
	(684106, 135, '2015-02-01 01:10:28.000000', 'consum', 0.0216, 'lps'),
	(684107, 135, '2015-02-01 01:10:29.000000', 'consum', 0.0242, 'lps'),
	(684108, 135, '2015-02-01 01:10:30.000000', 'consum', 0.0247, 'lps'),
	(684109, 135, '2015-02-01 01:10:31.000000', 'consum', 0.0248, 'lps'),
	(684110, 135, '2015-02-01 01:10:32.000000', 'consum', 0.0233, 'lps'),
	(684111, 135, '2015-02-01 01:10:33.000000', 'consum', 0.0215, 'lps'),
	(684112, 135, '2015-02-01 01:10:34.000000', 'consum', 0.0218, 'lps'),
	(684113, 135, '2015-02-01 01:10:35.000000', 'consum', 0.0235, 'lps'),
	(684114, 135, '2015-02-01 01:10:36.000000', 'consum', 0.0259, 'lps'),
	(684115, 135, '2015-02-01 01:10:37.000000', 'consum', 0.0222, 'lps'),
	(684116, 135, '2015-02-01 01:10:38.000000', 'consum', 0.0230, 'lps'),
	(684117, 135, '2015-02-01 01:10:39.000000', 'consum', 0.0221, 'lps'),
	(684118, 135, '2015-02-01 01:10:40.000000', 'consum', 0.0260, 'lps'),
	(684119, 135, '2015-02-01 01:10:41.000000', 'consum', 0.0213, 'lps'),
	(684120, 135, '2015-02-01 01:10:42.000000', 'consum', 0.0238, 'lps'),
	(684121, 135, '2015-02-01 01:10:43.000000', 'consum', 0.0232, 'lps'),
	(684122, 135, '2015-02-01 01:10:44.000000', 'consum', 0.0238, 'lps'),
	(684123, 135, '2015-02-01 01:10:45.000000', 'consum', 0.0229, 'lps'),
	(684124, 135, '2015-02-01 01:10:46.000000', 'consum', 0.0225, 'lps'),
	(684125, 135, '2015-02-01 01:10:47.000000', 'consum', 0.0227, 'lps'),
	(684126, 135, '2015-02-01 01:10:48.000000', 'consum', 0.0251, 'lps'),
	(684127, 135, '2015-02-01 01:10:49.000000', 'consum', 0.0257, 'lps'),
	(684128, 135, '2015-02-01 01:10:50.000000', 'consum', 0.0219, 'lps'),
	(684129, 135, '2015-02-01 01:10:51.000000', 'consum', 0.0221, 'lps'),
	(684130, 135, '2015-02-01 01:10:52.000000', 'consum', 0.0239, 'lps'),
	(684131, 135, '2015-02-01 01:10:53.000000', 'consum', 0.0215, 'lps'),
	(684132, 135, '2015-02-01 01:10:54.000000', 'consum', 0.0255, 'lps'),
	(684133, 135, '2015-02-01 01:10:55.000000', 'consum', 0.0210, 'lps'),
	(684134, 135, '2015-02-01 01:10:56.000000', 'consum', 0.0234, 'lps'),
	(684135, 135, '2015-02-01 01:10:57.000000', 'consum', 0.0224, 'lps'),
	(684136, 135, '2015-02-01 01:10:58.000000', 'consum', 0.0262, 'lps'),
	(684137, 135, '2015-02-01 01:10:59.000000', 'consum', 0.0218, 'lps'),
	(684138, 135, '2015-02-01 01:11:00.000000', 'consum', 0.0253, 'lps'),
	(684139, 135, '2015-02-01 01:11:01.000000', 'consum', 0.0242, 'lps'),
	(684140, 135, '2015-02-01 01:11:02.000000', 'consum', 0.0242, 'lps'),
	(684141, 135, '2015-02-01 01:11:03.000000', 'consum', 0.0222, 'lps'),
	(684142, 135, '2015-02-01 01:11:04.000000', 'consum', 0.0225, 'lps'),
	(684143, 135, '2015-02-01 01:11:05.000000', 'consum', 0.0252, 'lps'),
	(684144, 135, '2015-02-01 01:11:06.000000', 'consum', 0.0216, 'lps'),
	(684145, 135, '2015-02-01 01:11:07.000000', 'consum', 0.0219, 'lps'),
	(684146, 135, '2015-02-01 01:11:08.000000', 'consum', 0.0240, 'lps'),
	(684147, 135, '2015-02-01 01:11:09.000000', 'consum', 0.0227, 'lps'),
	(684148, 135, '2015-02-01 01:11:10.000000', 'consum', 0.0258, 'lps'),
	(684149, 135, '2015-02-01 01:11:11.000000', 'consum', 0.0239, 'lps'),
	(684150, 135, '2015-02-01 01:11:12.000000', 'consum', 0.0211, 'lps'),
	(684151, 135, '2015-02-01 01:11:13.000000', 'consum', 0.0237, 'lps'),
	(684152, 135, '2015-02-01 01:11:14.000000', 'consum', 0.0234, 'lps'),
	(684153, 135, '2015-02-01 01:11:15.000000', 'consum', 0.0250, 'lps'),
	(684154, 135, '2015-02-01 01:11:16.000000', 'consum', 0.0234, 'lps'),
	(684155, 135, '2015-02-01 01:11:17.000000', 'consum', 0.0211, 'lps'),
	(684156, 135, '2015-02-01 01:11:18.000000', 'consum', 0.0251, 'lps'),
	(684157, 135, '2015-02-01 01:11:19.000000', 'consum', 0.0250, 'lps'),
	(684158, 135, '2015-02-01 01:11:20.000000', 'consum', 0.0238, 'lps'),
	(684159, 135, '2015-02-01 01:11:21.000000', 'consum', 0.0228, 'lps'),
	(684160, 135, '2015-02-01 01:11:22.000000', 'consum', 0.0218, 'lps'),
	(684161, 135, '2015-02-01 01:11:23.000000', 'consum', 0.0248, 'lps'),
	(684162, 135, '2015-02-01 01:11:24.000000', 'consum', 0.0220, 'lps'),
	(684163, 135, '2015-02-01 01:11:25.000000', 'consum', 0.0251, 'lps'),
	(684164, 135, '2015-02-01 01:11:26.000000', 'consum', 0.0226, 'lps'),
	(684165, 135, '2015-02-01 01:11:27.000000', 'consum', 0.0220, 'lps'),
	(684166, 135, '2015-02-01 01:11:28.000000', 'consum', 0.0212, 'lps'),
	(684167, 135, '2015-02-01 01:11:29.000000', 'consum', 0.0244, 'lps'),
	(684168, 135, '2015-02-01 01:11:30.000000', 'consum', 0.0217, 'lps'),
	(684169, 135, '2015-02-01 01:11:31.000000', 'consum', 0.0247, 'lps'),
	(684170, 135, '2015-02-01 01:11:32.000000', 'consum', 0.0216, 'lps'),
	(684171, 135, '2015-02-01 01:11:33.000000', 'consum', 0.0236, 'lps'),
	(684172, 135, '2015-02-01 01:11:34.000000', 'consum', 0.0215, 'lps'),
	(684173, 135, '2015-02-01 01:11:35.000000', 'consum', 0.0211, 'lps'),
	(684174, 135, '2015-02-01 01:11:36.000000', 'consum', 0.0255, 'lps'),
	(684175, 135, '2015-02-01 01:11:37.000000', 'consum', 0.0219, 'lps'),
	(684176, 135, '2015-02-01 01:11:38.000000', 'consum', 0.0227, 'lps'),
	(684177, 135, '2015-02-01 01:11:39.000000', 'consum', 0.0215, 'lps'),
	(684178, 135, '2015-02-01 01:11:40.000000', 'consum', 0.0238, 'lps'),
	(684179, 135, '2015-02-01 01:11:41.000000', 'consum', 0.0231, 'lps'),
	(684180, 135, '2015-02-01 01:11:42.000000', 'consum', 0.0229, 'lps'),
	(684181, 135, '2015-02-01 01:11:43.000000', 'consum', 0.0243, 'lps'),
	(684182, 135, '2015-02-01 01:11:44.000000', 'consum', 0.0214, 'lps'),
	(684183, 135, '2015-02-01 01:11:45.000000', 'consum', 0.0236, 'lps'),
	(684184, 135, '2015-02-01 01:11:46.000000', 'consum', 0.0224, 'lps'),
	(684185, 135, '2015-02-01 01:11:47.000000', 'consum', 0.0255, 'lps'),
	(684186, 135, '2015-02-01 01:11:48.000000', 'consum', 0.0236, 'lps'),
	(684187, 135, '2015-02-01 01:11:49.000000', 'consum', 0.0259, 'lps'),
	(684188, 135, '2015-02-01 01:11:50.000000', 'consum', 0.0217, 'lps'),
	(684189, 135, '2015-02-01 01:11:51.000000', 'consum', 0.0256, 'lps'),
	(684190, 135, '2015-02-01 01:11:52.000000', 'consum', 0.0262, 'lps'),
	(684191, 135, '2015-02-01 01:11:53.000000', 'consum', 0.0227, 'lps'),
	(684192, 135, '2015-02-01 01:11:54.000000', 'consum', 0.0245, 'lps'),
	(684193, 135, '2015-02-01 01:11:55.000000', 'consum', 0.0227, 'lps'),
	(684194, 135, '2015-02-01 01:11:56.000000', 'consum', 0.0243, 'lps'),
	(684195, 135, '2015-02-01 01:11:57.000000', 'consum', 0.0221, 'lps'),
	(684196, 135, '2015-02-01 01:11:58.000000', 'consum', 0.0220, 'lps'),
	(684197, 135, '2015-02-01 01:11:59.000000', 'consum', 0.0228, 'lps'),
	(684198, 135, '2015-02-01 01:12:00.000000', 'consum', 0.0217, 'lps'),
	(684199, 135, '2015-02-01 01:12:01.000000', 'consum', 0.0243, 'lps'),
	(684200, 135, '2015-02-01 01:12:02.000000', 'consum', 0.0248, 'lps'),
	(684201, 135, '2015-02-01 01:12:03.000000', 'consum', 0.0250, 'lps'),
	(684202, 135, '2015-02-01 01:12:04.000000', 'consum', 0.0244, 'lps'),
	(684203, 135, '2015-02-01 01:12:05.000000', 'consum', 0.0260, 'lps'),
	(684204, 135, '2015-02-01 01:12:06.000000', 'consum', 0.0254, 'lps'),
	(684205, 135, '2015-02-01 01:12:07.000000', 'consum', 0.0226, 'lps'),
	(684206, 135, '2015-02-01 01:12:08.000000', 'consum', 0.0214, 'lps'),
	(684207, 135, '2015-02-01 01:12:09.000000', 'consum', 0.0233, 'lps'),
	(684208, 135, '2015-02-01 01:12:10.000000', 'consum', 0.0260, 'lps'),
	(684209, 135, '2015-02-01 01:12:11.000000', 'consum', 0.0233, 'lps'),
	(684210, 135, '2015-02-01 01:12:12.000000', 'consum', 0.0228, 'lps'),
	(684211, 135, '2015-02-01 01:12:13.000000', 'consum', 0.0233, 'lps'),
	(684212, 135, '2015-02-01 01:12:14.000000', 'consum', 0.0220, 'lps'),
	(684213, 135, '2015-02-01 01:12:15.000000', 'consum', 0.0241, 'lps'),
	(684214, 135, '2015-02-01 01:12:16.000000', 'consum', 0.0233, 'lps'),
	(684215, 135, '2015-02-01 01:12:17.000000', 'consum', 0.0230, 'lps'),
	(684216, 135, '2015-02-01 01:12:18.000000', 'consum', 0.0243, 'lps'),
	(684217, 135, '2015-02-01 01:12:19.000000', 'consum', 0.0210, 'lps'),
	(684218, 135, '2015-02-01 01:12:20.000000', 'consum', 0.0218, 'lps'),
	(684219, 135, '2015-02-01 01:12:21.000000', 'consum', 0.0250, 'lps'),
	(684220, 135, '2015-02-01 01:12:22.000000', 'consum', 0.0227, 'lps'),
	(684221, 135, '2015-02-01 01:12:23.000000', 'consum', 0.0227, 'lps'),
	(684222, 135, '2015-02-01 01:12:24.000000', 'consum', 0.0245, 'lps'),
	(684223, 135, '2015-02-01 01:12:25.000000', 'consum', 0.0230, 'lps'),
	(684224, 135, '2015-02-01 01:12:26.000000', 'consum', 0.0256, 'lps'),
	(684225, 135, '2015-02-01 01:12:27.000000', 'consum', 0.0222, 'lps'),
	(684226, 135, '2015-02-01 01:12:28.000000', 'consum', 0.0238, 'lps'),
	(684227, 135, '2015-02-01 01:12:29.000000', 'consum', 0.0210, 'lps'),
	(684228, 135, '2015-02-01 01:12:30.000000', 'consum', 0.0233, 'lps'),
	(684229, 135, '2015-02-01 01:12:31.000000', 'consum', 0.0220, 'lps'),
	(684230, 135, '2015-02-01 01:12:32.000000', 'consum', 0.0242, 'lps'),
	(684231, 135, '2015-02-01 01:12:33.000000', 'consum', 0.0236, 'lps'),
	(684232, 135, '2015-02-01 01:12:34.000000', 'consum', 0.0243, 'lps'),
	(684233, 135, '2015-02-01 01:12:35.000000', 'consum', 0.0247, 'lps'),
	(684234, 135, '2015-02-01 01:12:36.000000', 'consum', 0.0241, 'lps'),
	(684235, 135, '2015-02-01 01:12:37.000000', 'consum', 0.0254, 'lps'),
	(684236, 135, '2015-02-01 01:12:38.000000', 'consum', 0.0232, 'lps'),
	(684237, 135, '2015-02-01 01:12:39.000000', 'consum', 0.0244, 'lps'),
	(684238, 135, '2015-02-01 01:12:40.000000', 'consum', 0.0259, 'lps'),
	(684239, 135, '2015-02-01 01:12:41.000000', 'consum', 0.0247, 'lps'),
	(684240, 135, '2015-02-01 01:12:42.000000', 'consum', 0.0251, 'lps'),
	(684241, 135, '2015-02-01 01:12:43.000000', 'consum', 0.0250, 'lps'),
	(684242, 135, '2015-02-01 01:12:44.000000', 'consum', 0.0235, 'lps'),
	(684243, 135, '2015-02-01 01:12:45.000000', 'consum', 0.0217, 'lps'),
	(684244, 135, '2015-02-01 01:12:46.000000', 'consum', 0.0224, 'lps'),
	(684245, 135, '2015-02-01 01:12:47.000000', 'consum', 0.0259, 'lps'),
	(684246, 135, '2015-02-01 01:12:48.000000', 'consum', 0.0256, 'lps'),
	(684247, 135, '2015-02-01 01:12:49.000000', 'consum', 0.0237, 'lps'),
	(684248, 135, '2015-02-01 01:12:50.000000', 'consum', 0.0211, 'lps'),
	(684249, 135, '2015-02-01 01:12:51.000000', 'consum', 0.0239, 'lps'),
	(684250, 135, '2015-02-01 01:12:52.000000', 'consum', 0.0248, 'lps'),
	(684251, 135, '2015-02-01 01:12:53.000000', 'consum', 0.0260, 'lps'),
	(684252, 135, '2015-02-01 01:12:54.000000', 'consum', 0.0239, 'lps'),
	(684253, 135, '2015-02-01 01:12:55.000000', 'consum', 0.0260, 'lps'),
	(684254, 135, '2015-02-01 01:12:56.000000', 'consum', 0.0215, 'lps'),
	(684255, 135, '2015-02-01 01:12:57.000000', 'consum', 0.0246, 'lps'),
	(684256, 135, '2015-02-01 01:12:58.000000', 'consum', 0.0214, 'lps'),
	(684257, 135, '2015-02-01 01:12:59.000000', 'consum', 0.0228, 'lps'),
	(684258, 135, '2015-02-01 01:13:00.000000', 'consum', 0.0238, 'lps'),
	(684259, 135, '2015-02-01 01:13:01.000000', 'consum', 0.0244, 'lps'),
	(684260, 135, '2015-02-01 01:13:02.000000', 'consum', 0.0244, 'lps'),
	(684261, 135, '2015-02-01 01:13:03.000000', 'consum', 0.0223, 'lps'),
	(684262, 135, '2015-02-01 01:13:04.000000', 'consum', 0.0228, 'lps'),
	(684263, 135, '2015-02-01 01:13:05.000000', 'consum', 0.0210, 'lps'),
	(684264, 135, '2015-02-01 01:13:06.000000', 'consum', 0.0262, 'lps'),
	(684265, 135, '2015-02-01 01:13:07.000000', 'consum', 0.0257, 'lps'),
	(684266, 135, '2015-02-01 01:13:08.000000', 'consum', 0.0237, 'lps'),
	(684267, 135, '2015-02-01 01:13:09.000000', 'consum', 0.0256, 'lps'),
	(684268, 135, '2015-02-01 01:13:10.000000', 'consum', 0.0255, 'lps'),
	(684269, 135, '2015-02-01 01:13:11.000000', 'consum', 0.0242, 'lps'),
	(684270, 135, '2015-02-01 01:13:12.000000', 'consum', 0.0237, 'lps'),
	(684271, 135, '2015-02-01 01:13:13.000000', 'consum', 0.0251, 'lps'),
	(684272, 135, '2015-02-01 01:13:14.000000', 'consum', 0.0229, 'lps'),
	(684273, 135, '2015-02-01 01:13:15.000000', 'consum', 0.0234, 'lps'),
	(684274, 135, '2015-02-01 01:13:16.000000', 'consum', 0.0223, 'lps'),
	(684275, 135, '2015-02-01 01:13:17.000000', 'consum', 0.0253, 'lps'),
	(684276, 135, '2015-02-01 01:13:18.000000', 'consum', 0.0230, 'lps'),
	(684277, 135, '2015-02-01 01:13:19.000000', 'consum', 0.0234, 'lps'),
	(684278, 135, '2015-02-01 01:13:20.000000', 'consum', 0.0215, 'lps'),
	(684279, 135, '2015-02-01 01:13:21.000000', 'consum', 0.0219, 'lps'),
	(684280, 135, '2015-02-01 01:13:22.000000', 'consum', 0.0240, 'lps'),
	(684281, 135, '2015-02-01 01:13:23.000000', 'consum', 0.0230, 'lps'),
	(684282, 135, '2015-02-01 01:13:24.000000', 'consum', 0.0217, 'lps'),
	(684283, 135, '2015-02-01 01:13:25.000000', 'consum', 0.0238, 'lps'),
	(684284, 135, '2015-02-01 01:13:26.000000', 'consum', 0.0225, 'lps'),
	(684285, 135, '2015-02-01 01:13:27.000000', 'consum', 0.0255, 'lps'),
	(684286, 135, '2015-02-01 01:13:28.000000', 'consum', 0.0230, 'lps'),
	(684287, 135, '2015-02-01 01:13:29.000000', 'consum', 0.0231, 'lps'),
	(684288, 135, '2015-02-01 01:13:30.000000', 'consum', 0.0254, 'lps'),
	(684289, 135, '2015-02-01 01:13:31.000000', 'consum', 0.0260, 'lps'),
	(684290, 135, '2015-02-01 01:13:32.000000', 'consum', 0.0222, 'lps'),
	(684291, 135, '2015-02-01 01:13:33.000000', 'consum', 0.0229, 'lps'),
	(684292, 135, '2015-02-01 01:13:34.000000', 'consum', 0.0217, 'lps'),
	(684293, 135, '2015-02-01 01:13:35.000000', 'consum', 0.0240, 'lps'),
	(684294, 135, '2015-02-01 01:13:36.000000', 'consum', 0.0233, 'lps'),
	(684295, 135, '2015-02-01 01:13:37.000000', 'consum', 0.0238, 'lps'),
	(684296, 135, '2015-02-01 01:13:38.000000', 'consum', 0.0225, 'lps'),
	(684297, 135, '2015-02-01 01:13:39.000000', 'consum', 0.0256, 'lps'),
	(684298, 135, '2015-02-01 01:13:40.000000', 'consum', 0.0237, 'lps'),
	(684299, 135, '2015-02-01 01:13:41.000000', 'consum', 0.0262, 'lps'),
	(684300, 135, '2015-02-01 01:13:42.000000', 'consum', 0.0230, 'lps'),
	(684301, 135, '2015-02-01 01:13:43.000000', 'consum', 0.0261, 'lps'),
	(684302, 135, '2015-02-01 01:13:44.000000', 'consum', 0.0247, 'lps'),
	(684303, 135, '2015-02-01 01:13:45.000000', 'consum', 0.0240, 'lps'),
	(684304, 135, '2015-02-01 01:13:46.000000', 'consum', 0.0251, 'lps'),
	(684305, 135, '2015-02-01 01:13:47.000000', 'consum', 0.0217, 'lps'),
	(684306, 135, '2015-02-01 01:13:48.000000', 'consum', 0.0231, 'lps'),
	(684307, 135, '2015-02-01 01:13:49.000000', 'consum', 0.0243, 'lps'),
	(684308, 135, '2015-02-01 01:13:50.000000', 'consum', 0.0258, 'lps'),
	(684309, 135, '2015-02-01 01:13:51.000000', 'consum', 0.0244, 'lps'),
	(684310, 135, '2015-02-01 01:13:52.000000', 'consum', 0.0239, 'lps'),
	(684311, 135, '2015-02-01 01:13:53.000000', 'consum', 0.0255, 'lps'),
	(684312, 135, '2015-02-01 01:13:54.000000', 'consum', 0.0239, 'lps'),
	(684313, 135, '2015-02-01 01:13:55.000000', 'consum', 0.0222, 'lps'),
	(684314, 135, '2015-02-01 01:13:56.000000', 'consum', 0.0237, 'lps'),
	(684315, 135, '2015-02-01 01:13:57.000000', 'consum', 0.0258, 'lps'),
	(684316, 135, '2015-02-01 01:13:58.000000', 'consum', 0.0260, 'lps'),
	(684317, 135, '2015-02-01 01:13:59.000000', 'consum', 0.0213, 'lps'),
	(684318, 135, '2015-02-01 01:14:00.000000', 'consum', 0.0232, 'lps'),
	(684319, 135, '2015-02-01 01:14:01.000000', 'consum', 0.0259, 'lps'),
	(684320, 135, '2015-02-01 01:14:02.000000', 'consum', 0.0232, 'lps'),
	(684321, 135, '2015-02-01 01:14:03.000000', 'consum', 0.0226, 'lps'),
	(684322, 135, '2015-02-01 01:14:04.000000', 'consum', 0.0226, 'lps'),
	(684323, 135, '2015-02-01 01:14:05.000000', 'consum', 0.0240, 'lps'),
	(684324, 135, '2015-02-01 01:14:06.000000', 'consum', 0.0260, 'lps'),
	(684325, 135, '2015-02-01 01:14:07.000000', 'consum', 0.0211, 'lps'),
	(684326, 135, '2015-02-01 01:14:08.000000', 'consum', 0.0226, 'lps'),
	(684327, 135, '2015-02-01 01:14:09.000000', 'consum', 0.0235, 'lps'),
	(684328, 135, '2015-02-01 01:14:10.000000', 'consum', 0.0232, 'lps'),
	(684329, 135, '2015-02-01 01:14:11.000000', 'consum', 0.0246, 'lps'),
	(684330, 135, '2015-02-01 01:14:12.000000', 'consum', 0.0217, 'lps'),
	(684331, 135, '2015-02-01 01:14:13.000000', 'consum', 0.0245, 'lps'),
	(684332, 135, '2015-02-01 01:14:14.000000', 'consum', 0.0256, 'lps'),
	(684333, 135, '2015-02-01 01:14:15.000000', 'consum', 0.0233, 'lps'),
	(684334, 135, '2015-02-01 01:14:16.000000', 'consum', 0.0239, 'lps'),
	(684335, 135, '2015-02-01 01:14:17.000000', 'consum', 0.0234, 'lps'),
	(684336, 135, '2015-02-01 01:14:18.000000', 'consum', 0.0244, 'lps'),
	(684337, 135, '2015-02-01 01:14:19.000000', 'consum', 0.0255, 'lps'),
	(684338, 135, '2015-02-01 01:14:20.000000', 'consum', 0.0227, 'lps'),
	(684339, 135, '2015-02-01 01:14:21.000000', 'consum', 0.0213, 'lps'),
	(684340, 135, '2015-02-01 01:14:22.000000', 'consum', 0.0228, 'lps'),
	(684341, 135, '2015-02-01 01:14:23.000000', 'consum', 0.0237, 'lps'),
	(684342, 135, '2015-02-01 01:14:24.000000', 'consum', 0.0241, 'lps'),
	(684343, 135, '2015-02-01 01:14:25.000000', 'consum', 0.0230, 'lps'),
	(684344, 135, '2015-02-01 01:14:26.000000', 'consum', 0.0219, 'lps'),
	(684345, 135, '2015-02-01 01:14:27.000000', 'consum', 0.0246, 'lps'),
	(684346, 135, '2015-02-01 01:14:28.000000', 'consum', 0.0257, 'lps'),
	(684347, 135, '2015-02-01 01:14:29.000000', 'consum', 0.0232, 'lps'),
	(684348, 135, '2015-02-01 01:14:30.000000', 'consum', 0.0233, 'lps'),
	(684349, 135, '2015-02-01 01:14:31.000000', 'consum', 0.0261, 'lps'),
	(684350, 135, '2015-02-01 01:14:32.000000', 'consum', 0.0238, 'lps'),
	(684351, 135, '2015-02-01 01:14:33.000000', 'consum', 0.0251, 'lps'),
	(684352, 135, '2015-02-01 01:14:34.000000', 'consum', 0.0225, 'lps'),
	(684353, 135, '2015-02-01 01:14:35.000000', 'consum', 0.0214, 'lps'),
	(684354, 135, '2015-02-01 01:14:36.000000', 'consum', 0.0241, 'lps'),
	(684355, 135, '2015-02-01 01:14:37.000000', 'consum', 0.0245, 'lps'),
	(684356, 135, '2015-02-01 01:14:38.000000', 'consum', 0.0240, 'lps'),
	(684357, 135, '2015-02-01 01:14:39.000000', 'consum', 0.0257, 'lps'),
	(684358, 135, '2015-02-01 01:14:40.000000', 'consum', 0.0247, 'lps'),
	(684359, 135, '2015-02-01 01:14:41.000000', 'consum', 0.0254, 'lps'),
	(684360, 135, '2015-02-01 01:14:42.000000', 'consum', 0.0216, 'lps'),
	(684361, 135, '2015-02-01 01:14:43.000000', 'consum', 0.0214, 'lps'),
	(684362, 135, '2015-02-01 01:14:44.000000', 'consum', 0.0214, 'lps'),
	(684363, 135, '2015-02-01 01:14:45.000000', 'consum', 0.0217, 'lps'),
	(684364, 135, '2015-02-01 01:14:46.000000', 'consum', 0.0232, 'lps'),
	(684365, 135, '2015-02-01 01:14:47.000000', 'consum', 0.0247, 'lps'),
	(684366, 135, '2015-02-01 01:14:48.000000', 'consum', 0.0224, 'lps'),
	(684367, 135, '2015-02-01 01:14:49.000000', 'consum', 0.0224, 'lps'),
	(684368, 135, '2015-02-01 01:14:50.000000', 'consum', 0.0238, 'lps'),
	(684369, 135, '2015-02-01 01:14:51.000000', 'consum', 0.0255, 'lps'),
	(684370, 135, '2015-02-01 01:14:52.000000', 'consum', 0.0247, 'lps'),
	(684371, 135, '2015-02-01 01:14:53.000000', 'consum', 0.0261, 'lps'),
	(684372, 135, '2015-02-01 01:14:54.000000', 'consum', 0.0247, 'lps'),
	(684373, 135, '2015-02-01 01:14:55.000000', 'consum', 0.0243, 'lps'),
	(684374, 135, '2015-02-01 01:14:56.000000', 'consum', 0.0262, 'lps'),
	(684375, 135, '2015-02-01 01:14:57.000000', 'consum', 0.0215, 'lps'),
	(684376, 135, '2015-02-01 01:14:58.000000', 'consum', 0.0239, 'lps'),
	(684377, 135, '2015-02-01 01:14:59.000000', 'consum', 0.0233, 'lps'),
	(684378, 135, '2015-02-01 01:15:00.000000', 'consum', 0.0241, 'lps'),
	(684379, 135, '2015-02-01 01:15:01.000000', 'consum', 0.0240, 'lps'),
	(684380, 135, '2015-02-01 01:15:02.000000', 'consum', 0.0216, 'lps'),
	(684381, 135, '2015-02-01 01:15:03.000000', 'consum', 0.0258, 'lps'),
	(684382, 135, '2015-02-01 01:15:04.000000', 'consum', 0.0218, 'lps'),
	(684383, 135, '2015-02-01 01:15:05.000000', 'consum', 0.0214, 'lps'),
	(684384, 135, '2015-02-01 01:15:06.000000', 'consum', 0.0261, 'lps'),
	(684385, 135, '2015-02-01 01:15:07.000000', 'consum', 0.0240, 'lps'),
	(684386, 135, '2015-02-01 01:15:08.000000', 'consum', 0.0260, 'lps'),
	(684387, 135, '2015-02-01 01:15:09.000000', 'consum', 0.0212, 'lps'),
	(684388, 135, '2015-02-01 01:15:10.000000', 'consum', 0.0229, 'lps'),
	(684389, 135, '2015-02-01 01:15:11.000000', 'consum', 0.0248, 'lps'),
	(684390, 135, '2015-02-01 01:15:12.000000', 'consum', 0.0237, 'lps'),
	(684391, 135, '2015-02-01 01:15:13.000000', 'consum', 0.0231, 'lps'),
	(684392, 135, '2015-02-01 01:15:14.000000', 'consum', 0.0235, 'lps'),
	(684393, 135, '2015-02-01 01:15:15.000000', 'consum', 0.0219, 'lps'),
	(684394, 135, '2015-02-01 01:15:16.000000', 'consum', 0.0233, 'lps'),
	(684395, 135, '2015-02-01 01:15:17.000000', 'consum', 0.0248, 'lps'),
	(684396, 135, '2015-02-01 01:15:18.000000', 'consum', 0.0224, 'lps'),
	(684397, 135, '2015-02-01 01:15:19.000000', 'consum', 0.0222, 'lps'),
	(684398, 135, '2015-02-01 01:15:20.000000', 'consum', 0.0226, 'lps'),
	(684399, 135, '2015-02-01 01:15:21.000000', 'consum', 0.0253, 'lps'),
	(684400, 135, '2015-02-01 01:15:22.000000', 'consum', 0.0220, 'lps'),
	(684401, 135, '2015-02-01 01:15:23.000000', 'consum', 0.0238, 'lps'),
	(684402, 135, '2015-02-01 01:15:24.000000', 'consum', 0.0213, 'lps'),
	(684403, 135, '2015-02-01 01:15:25.000000', 'consum', 0.0248, 'lps'),
	(684404, 135, '2015-02-01 01:15:26.000000', 'consum', 0.0232, 'lps'),
	(684405, 135, '2015-02-01 01:15:27.000000', 'consum', 0.0261, 'lps'),
	(684406, 135, '2015-02-01 01:15:28.000000', 'consum', 0.0241, 'lps'),
	(684407, 135, '2015-02-01 01:15:29.000000', 'consum', 0.0210, 'lps'),
	(684408, 135, '2015-02-01 01:15:30.000000', 'consum', 0.0223, 'lps'),
	(684409, 135, '2015-02-01 01:15:31.000000', 'consum', 0.0225, 'lps'),
	(684410, 135, '2015-02-01 01:15:32.000000', 'consum', 0.0246, 'lps'),
	(684411, 135, '2015-02-01 01:15:33.000000', 'consum', 0.0239, 'lps'),
	(684412, 135, '2015-02-01 01:15:34.000000', 'consum', 0.0247, 'lps'),
	(684413, 135, '2015-02-01 01:15:35.000000', 'consum', 0.0255, 'lps'),
	(684414, 135, '2015-02-01 01:15:36.000000', 'consum', 0.0220, 'lps'),
	(684415, 135, '2015-02-01 01:15:37.000000', 'consum', 0.0231, 'lps'),
	(684416, 135, '2015-02-01 01:15:38.000000', 'consum', 0.0234, 'lps'),
	(684417, 135, '2015-02-01 01:15:39.000000', 'consum', 0.0214, 'lps'),
	(684418, 135, '2015-02-01 01:15:40.000000', 'consum', 0.0213, 'lps'),
	(684419, 135, '2015-02-01 01:15:41.000000', 'consum', 0.0213, 'lps'),
	(684420, 135, '2015-02-01 01:15:42.000000', 'consum', 0.0216, 'lps'),
	(684421, 135, '2015-02-01 01:15:43.000000', 'consum', 0.0233, 'lps'),
	(684422, 135, '2015-02-01 01:15:44.000000', 'consum', 0.0255, 'lps'),
	(684423, 135, '2015-02-01 01:15:45.000000', 'consum', 0.0258, 'lps'),
	(684424, 135, '2015-02-01 01:15:46.000000', 'consum', 0.0262, 'lps'),
	(684425, 135, '2015-02-01 01:15:47.000000', 'consum', 0.0223, 'lps'),
	(684426, 135, '2015-02-01 01:15:48.000000', 'consum', 0.0224, 'lps'),
	(684427, 135, '2015-02-01 01:15:49.000000', 'consum', 0.0243, 'lps'),
	(684428, 135, '2015-02-01 01:15:50.000000', 'consum', 0.0228, 'lps'),
	(684429, 135, '2015-02-01 01:15:51.000000', 'consum', 0.0252, 'lps'),
	(684430, 135, '2015-02-01 01:15:52.000000', 'consum', 0.0210, 'lps'),
	(684431, 135, '2015-02-01 01:15:53.000000', 'consum', 0.0243, 'lps'),
	(684432, 135, '2015-02-01 01:15:54.000000', 'consum', 0.0216, 'lps'),
	(684433, 135, '2015-02-01 01:15:55.000000', 'consum', 0.0248, 'lps'),
	(684434, 135, '2015-02-01 01:15:56.000000', 'consum', 0.0224, 'lps'),
	(684435, 135, '2015-02-01 01:15:57.000000', 'consum', 0.0220, 'lps'),
	(684436, 135, '2015-02-01 01:15:58.000000', 'consum', 0.0217, 'lps'),
	(684437, 135, '2015-02-01 01:15:59.000000', 'consum', 0.0216, 'lps'),
	(684438, 135, '2015-02-01 01:16:00.000000', 'consum', 0.0220, 'lps'),
	(684439, 135, '2015-02-01 01:16:01.000000', 'consum', 0.0244, 'lps'),
	(684440, 135, '2015-02-01 01:16:02.000000', 'consum', 0.0243, 'lps'),
	(684441, 135, '2015-02-01 01:16:03.000000', 'consum', 0.0222, 'lps'),
	(684442, 135, '2015-02-01 01:16:04.000000', 'consum', 0.0226, 'lps'),
	(684443, 135, '2015-02-01 01:16:05.000000', 'consum', 0.0251, 'lps'),
	(684444, 135, '2015-02-01 01:16:06.000000', 'consum', 0.0262, 'lps'),
	(684445, 135, '2015-02-01 01:16:07.000000', 'consum', 0.0240, 'lps'),
	(684446, 135, '2015-02-01 01:16:08.000000', 'consum', 0.0261, 'lps'),
	(684447, 135, '2015-02-01 01:16:09.000000', 'consum', 0.0215, 'lps'),
	(684448, 135, '2015-02-01 01:16:10.000000', 'consum', 0.0241, 'lps'),
	(684449, 135, '2015-02-01 01:16:11.000000', 'consum', 0.0244, 'lps'),
	(684450, 135, '2015-02-01 01:16:12.000000', 'consum', 0.0234, 'lps'),
	(684451, 135, '2015-02-01 01:16:13.000000', 'consum', 0.0230, 'lps'),
	(684452, 135, '2015-02-01 01:16:14.000000', 'consum', 0.0238, 'lps'),
	(684453, 135, '2015-02-01 01:16:15.000000', 'consum', 0.0237, 'lps'),
	(684454, 135, '2015-02-01 01:16:16.000000', 'consum', 0.0210, 'lps'),
	(684455, 135, '2015-02-01 01:16:17.000000', 'consum', 0.0236, 'lps'),
	(684456, 135, '2015-02-01 01:16:18.000000', 'consum', 0.0234, 'lps'),
	(684457, 135, '2015-02-01 01:16:19.000000', 'consum', 0.0252, 'lps'),
	(684458, 135, '2015-02-01 01:16:20.000000', 'consum', 0.0241, 'lps'),
	(684459, 135, '2015-02-01 01:16:21.000000', 'consum', 0.0240, 'lps'),
	(684460, 135, '2015-02-01 01:16:22.000000', 'consum', 0.0217, 'lps'),
	(684461, 135, '2015-02-01 01:16:23.000000', 'consum', 0.0260, 'lps'),
	(684462, 135, '2015-02-01 01:16:24.000000', 'consum', 0.0227, 'lps'),
	(684463, 135, '2015-02-01 01:16:25.000000', 'consum', 0.0254, 'lps'),
	(684464, 135, '2015-02-01 01:16:26.000000', 'consum', 0.0219, 'lps'),
	(684465, 135, '2015-02-01 01:16:27.000000', 'consum', 0.0229, 'lps'),
	(684466, 135, '2015-02-01 01:16:28.000000', 'consum', 0.0226, 'lps'),
	(684467, 135, '2015-02-01 01:16:29.000000', 'consum', 0.0232, 'lps'),
	(684468, 135, '2015-02-01 01:16:30.000000', 'consum', 0.0221, 'lps'),
	(684469, 135, '2015-02-01 01:16:31.000000', 'consum', 0.0253, 'lps'),
	(684470, 135, '2015-02-01 01:16:32.000000', 'consum', 0.0235, 'lps'),
	(684471, 135, '2015-02-01 01:16:33.000000', 'consum', 0.0258, 'lps'),
	(684472, 135, '2015-02-01 01:16:34.000000', 'consum', 0.0216, 'lps'),
	(684473, 135, '2015-02-01 01:16:35.000000', 'consum', 0.0256, 'lps'),
	(684474, 135, '2015-02-01 01:16:36.000000', 'consum', 0.0211, 'lps'),
	(684475, 135, '2015-02-01 01:16:37.000000', 'consum', 0.0237, 'lps'),
	(684476, 135, '2015-02-01 01:16:38.000000', 'consum', 0.0236, 'lps'),
	(684477, 135, '2015-02-01 01:16:39.000000', 'consum', 0.0261, 'lps'),
	(684478, 135, '2015-02-01 01:16:40.000000', 'consum', 0.0229, 'lps'),
	(684479, 135, '2015-02-01 01:16:41.000000', 'consum', 0.0257, 'lps'),
	(684480, 135, '2015-02-01 01:16:42.000000', 'consum', 0.0232, 'lps'),
	(684481, 135, '2015-02-01 01:16:43.000000', 'consum', 0.0230, 'lps'),
	(684482, 135, '2015-02-01 01:16:44.000000', 'consum', 0.0246, 'lps'),
	(684483, 135, '2015-02-01 01:16:45.000000', 'consum', 0.0223, 'lps'),
	(684484, 135, '2015-02-01 01:16:46.000000', 'consum', 0.0219, 'lps'),
	(684485, 135, '2015-02-01 01:16:47.000000', 'consum', 0.0220, 'lps'),
	(684486, 135, '2015-02-01 01:16:48.000000', 'consum', 0.0230, 'lps'),
	(684487, 135, '2015-02-01 01:16:49.000000', 'consum', 0.0231, 'lps'),
	(684488, 135, '2015-02-01 01:16:50.000000', 'consum', 0.0254, 'lps'),
	(684489, 135, '2015-02-01 01:16:51.000000', 'consum', 0.0261, 'lps'),
	(684490, 135, '2015-02-01 01:16:52.000000', 'consum', 0.0230, 'lps'),
	(684491, 135, '2015-02-01 01:16:53.000000', 'consum', 0.0260, 'lps'),
	(684492, 135, '2015-02-01 01:16:54.000000', 'consum', 0.0244, 'lps'),
	(684493, 135, '2015-02-01 01:16:55.000000', 'consum', 0.0230, 'lps'),
	(684494, 135, '2015-02-01 01:16:56.000000', 'consum', 0.0210, 'lps'),
	(684495, 135, '2015-02-01 01:16:57.000000', 'consum', 0.0257, 'lps'),
	(684496, 135, '2015-02-01 01:16:58.000000', 'consum', 0.0232, 'lps'),
	(684497, 135, '2015-02-01 01:16:59.000000', 'consum', 0.0233, 'lps'),
	(684498, 135, '2015-02-01 01:17:00.000000', 'consum', 0.0260, 'lps'),
	(684499, 135, '2015-02-01 01:17:01.000000', 'consum', 0.0234, 'lps'),
	(684500, 135, '2015-02-01 01:17:02.000000', 'consum', 0.0233, 'lps'),
	(684501, 135, '2015-02-01 01:17:03.000000', 'consum', 0.0251, 'lps'),
	(684502, 135, '2015-02-01 01:17:04.000000', 'consum', 0.0244, 'lps'),
	(684503, 135, '2015-02-01 01:17:05.000000', 'consum', 0.0254, 'lps'),
	(684504, 135, '2015-02-01 01:17:06.000000', 'consum', 0.0224, 'lps'),
	(684505, 135, '2015-02-01 01:17:07.000000', 'consum', 0.0256, 'lps'),
	(684506, 135, '2015-02-01 01:17:08.000000', 'consum', 0.0238, 'lps'),
	(684507, 135, '2015-02-01 01:17:09.000000', 'consum', 0.0211, 'lps'),
	(684508, 135, '2015-02-01 01:17:10.000000', 'consum', 0.0239, 'lps'),
	(684509, 135, '2015-02-01 01:17:11.000000', 'consum', 0.0246, 'lps'),
	(684510, 135, '2015-02-01 01:17:12.000000', 'consum', 0.0251, 'lps'),
	(684511, 135, '2015-02-01 01:17:13.000000', 'consum', 0.0256, 'lps'),
	(684512, 135, '2015-02-01 01:17:14.000000', 'consum', 0.0211, 'lps'),
	(684513, 135, '2015-02-01 01:17:15.000000', 'consum', 0.0234, 'lps'),
	(684514, 135, '2015-02-01 01:17:16.000000', 'consum', 0.0224, 'lps'),
	(684515, 135, '2015-02-01 01:17:17.000000', 'consum', 0.0261, 'lps'),
	(684516, 135, '2015-02-01 01:17:18.000000', 'consum', 0.0210, 'lps'),
	(684517, 135, '2015-02-01 01:17:19.000000', 'consum', 0.0216, 'lps'),
	(684518, 135, '2015-02-01 01:17:20.000000', 'consum', 0.0241, 'lps'),
	(684519, 135, '2015-02-01 01:17:21.000000', 'consum', 0.0243, 'lps'),
	(684520, 135, '2015-02-01 01:17:22.000000', 'consum', 0.0228, 'lps'),
	(684521, 135, '2015-02-01 01:17:23.000000', 'consum', 0.0255, 'lps'),
	(684522, 135, '2015-02-01 01:17:24.000000', 'consum', 0.0224, 'lps'),
	(684523, 135, '2015-02-01 01:17:25.000000', 'consum', 0.0252, 'lps'),
	(684524, 135, '2015-02-01 01:17:26.000000', 'consum', 0.0220, 'lps'),
	(684525, 135, '2015-02-01 01:17:27.000000', 'consum', 0.0238, 'lps'),
	(684526, 135, '2015-02-01 01:17:28.000000', 'consum', 0.0215, 'lps'),
	(684527, 135, '2015-02-01 01:17:29.000000', 'consum', 0.0257, 'lps'),
	(684528, 135, '2015-02-01 01:17:30.000000', 'consum', 0.0219, 'lps'),
	(684529, 135, '2015-02-01 01:17:31.000000', 'consum', 0.0219, 'lps'),
	(684530, 135, '2015-02-01 01:17:32.000000', 'consum', 0.0228, 'lps'),
	(684531, 135, '2015-02-01 01:17:33.000000', 'consum', 0.0220, 'lps'),
	(684532, 135, '2015-02-01 01:17:34.000000', 'consum', 0.0262, 'lps'),
	(684533, 135, '2015-02-01 01:17:35.000000', 'consum', 0.0227, 'lps'),
	(684534, 135, '2015-02-01 01:17:36.000000', 'consum', 0.0245, 'lps'),
	(684535, 135, '2015-02-01 01:17:37.000000', 'consum', 0.0230, 'lps'),
	(684536, 135, '2015-02-01 01:17:38.000000', 'consum', 0.0257, 'lps'),
	(684537, 135, '2015-02-01 01:17:39.000000', 'consum', 0.0226, 'lps'),
	(684538, 135, '2015-02-01 01:17:40.000000', 'consum', 0.0256, 'lps'),
	(684539, 135, '2015-02-01 01:17:41.000000', 'consum', 0.0232, 'lps'),
	(684540, 135, '2015-02-01 01:17:42.000000', 'consum', 0.0236, 'lps'),
	(684541, 135, '2015-02-01 01:17:43.000000', 'consum', 0.0222, 'lps'),
	(684542, 135, '2015-02-01 01:17:44.000000', 'consum', 0.0246, 'lps'),
	(684543, 135, '2015-02-01 01:17:45.000000', 'consum', 0.0248, 'lps'),
	(684544, 135, '2015-02-01 01:17:46.000000', 'consum', 0.0241, 'lps'),
	(684545, 135, '2015-02-01 01:17:47.000000', 'consum', 0.0252, 'lps'),
	(684546, 135, '2015-02-01 01:17:48.000000', 'consum', 0.0222, 'lps'),
	(684547, 135, '2015-02-01 01:17:49.000000', 'consum', 0.0249, 'lps'),
	(684548, 135, '2015-02-01 01:17:50.000000', 'consum', 0.0212, 'lps'),
	(684549, 135, '2015-02-01 01:17:51.000000', 'consum', 0.0211, 'lps'),
	(684550, 135, '2015-02-01 01:17:52.000000', 'consum', 0.0260, 'lps'),
	(684551, 135, '2015-02-01 01:17:53.000000', 'consum', 0.0245, 'lps'),
	(684552, 135, '2015-02-01 01:17:54.000000', 'consum', 0.0237, 'lps'),
	(684553, 135, '2015-02-01 01:17:55.000000', 'consum', 0.0241, 'lps'),
	(684554, 135, '2015-02-01 01:17:56.000000', 'consum', 0.0231, 'lps'),
	(684555, 135, '2015-02-01 01:17:57.000000', 'consum', 0.0223, 'lps'),
	(684556, 135, '2015-02-01 01:17:58.000000', 'consum', 0.0211, 'lps'),
	(684557, 135, '2015-02-01 01:17:59.000000', 'consum', 0.0231, 'lps'),
	(684558, 135, '2015-02-01 01:18:00.000000', 'consum', 0.0257, 'lps'),
	(684559, 135, '2015-02-01 01:18:01.000000', 'consum', 0.0227, 'lps'),
	(684560, 135, '2015-02-01 01:18:02.000000', 'consum', 0.0258, 'lps'),
	(684561, 135, '2015-02-01 01:18:03.000000', 'consum', 0.0239, 'lps'),
	(684562, 135, '2015-02-01 01:18:04.000000', 'consum', 0.0214, 'lps'),
	(684563, 135, '2015-02-01 01:18:05.000000', 'consum', 0.0248, 'lps'),
	(684564, 135, '2015-02-01 01:18:06.000000', 'consum', 0.0230, 'lps'),
	(684565, 135, '2015-02-01 01:18:07.000000', 'consum', 0.0248, 'lps'),
	(684566, 135, '2015-02-01 01:18:08.000000', 'consum', 0.0236, 'lps'),
	(684567, 135, '2015-02-01 01:18:09.000000', 'consum', 0.0224, 'lps'),
	(684568, 135, '2015-02-01 01:18:10.000000', 'consum', 0.0257, 'lps'),
	(684569, 135, '2015-02-01 01:18:11.000000', 'consum', 0.0246, 'lps'),
	(684570, 135, '2015-02-01 01:18:12.000000', 'consum', 0.0250, 'lps'),
	(684571, 135, '2015-02-01 01:18:13.000000', 'consum', 0.0250, 'lps'),
	(684572, 135, '2015-02-01 01:18:14.000000', 'consum', 0.0238, 'lps'),
	(684573, 135, '2015-02-01 01:18:15.000000', 'consum', 0.0230, 'lps'),
	(684574, 135, '2015-02-01 01:18:16.000000', 'consum', 0.0225, 'lps'),
	(684575, 135, '2015-02-01 01:18:17.000000', 'consum', 0.0228, 'lps'),
	(684576, 135, '2015-02-01 01:18:18.000000', 'consum', 0.0255, 'lps'),
	(684577, 135, '2015-02-01 01:18:19.000000', 'consum', 0.0220, 'lps'),
	(684578, 135, '2015-02-01 01:18:20.000000', 'consum', 0.0235, 'lps'),
	(684579, 135, '2015-02-01 01:18:21.000000', 'consum', 0.0251, 'lps'),
	(684580, 135, '2015-02-01 01:18:22.000000', 'consum', 0.0232, 'lps'),
	(684581, 135, '2015-02-01 01:18:23.000000', 'consum', 0.0254, 'lps'),
	(684582, 135, '2015-02-01 01:18:24.000000', 'consum', 0.0258, 'lps'),
	(684583, 135, '2015-02-01 01:18:25.000000', 'consum', 0.0212, 'lps'),
	(684584, 135, '2015-02-01 01:18:26.000000', 'consum', 0.0237, 'lps'),
	(684585, 135, '2015-02-01 01:18:27.000000', 'consum', 0.0233, 'lps'),
	(684586, 135, '2015-02-01 01:18:28.000000', 'consum', 0.0245, 'lps'),
	(684587, 135, '2015-02-01 01:18:29.000000', 'consum', 0.0261, 'lps'),
	(684588, 135, '2015-02-01 01:18:30.000000', 'consum', 0.0257, 'lps'),
	(684589, 135, '2015-02-01 01:18:31.000000', 'consum', 0.0237, 'lps'),
	(684590, 135, '2015-02-01 01:18:32.000000', 'consum', 0.0260, 'lps'),
	(684591, 135, '2015-02-01 01:18:33.000000', 'consum', 0.0219, 'lps'),
	(684592, 135, '2015-02-01 01:18:34.000000', 'consum', 0.0211, 'lps'),
	(684593, 135, '2015-02-01 01:18:35.000000', 'consum', 0.0242, 'lps'),
	(684594, 135, '2015-02-01 01:18:36.000000', 'consum', 0.0262, 'lps'),
	(684595, 135, '2015-02-01 01:18:37.000000', 'consum', 0.0216, 'lps'),
	(684596, 135, '2015-02-01 01:18:38.000000', 'consum', 0.0243, 'lps'),
	(684597, 135, '2015-02-01 01:18:39.000000', 'consum', 0.0251, 'lps'),
	(684598, 135, '2015-02-01 01:18:40.000000', 'consum', 0.0262, 'lps'),
	(684599, 135, '2015-02-01 01:18:41.000000', 'consum', 0.0243, 'lps'),
	(684600, 135, '2015-02-01 01:18:42.000000', 'consum', 0.0221, 'lps'),
	(684601, 135, '2015-02-01 01:18:43.000000', 'consum', 0.0216, 'lps'),
	(684602, 135, '2015-02-01 01:18:44.000000', 'consum', 0.0211, 'lps'),
	(684603, 135, '2015-02-01 01:18:45.000000', 'consum', 0.0248, 'lps'),
	(684604, 135, '2015-02-01 01:18:46.000000', 'consum', 0.0241, 'lps'),
	(684605, 135, '2015-02-01 01:18:47.000000', 'consum', 0.0251, 'lps'),
	(684606, 135, '2015-02-01 01:18:48.000000', 'consum', 0.0217, 'lps'),
	(684607, 135, '2015-02-01 01:18:49.000000', 'consum', 0.0226, 'lps'),
	(684608, 135, '2015-02-01 01:18:50.000000', 'consum', 0.0216, 'lps'),
	(684609, 135, '2015-02-01 01:18:51.000000', 'consum', 0.0249, 'lps'),
	(684610, 135, '2015-02-01 01:18:52.000000', 'consum', 0.0226, 'lps'),
	(684611, 135, '2015-02-01 01:18:53.000000', 'consum', 0.0227, 'lps'),
	(684612, 135, '2015-02-01 01:18:54.000000', 'consum', 0.0247, 'lps'),
	(684613, 135, '2015-02-01 01:18:55.000000', 'consum', 0.0238, 'lps'),
	(684614, 135, '2015-02-01 01:18:56.000000', 'consum', 0.0240, 'lps'),
	(684615, 135, '2015-02-01 01:18:57.000000', 'consum', 0.0225, 'lps'),
	(684616, 135, '2015-02-01 01:18:58.000000', 'consum', 0.0249, 'lps'),
	(684617, 135, '2015-02-01 01:18:59.000000', 'consum', 0.0254, 'lps'),
	(684618, 135, '2015-02-01 01:19:00.000000', 'consum', 0.0260, 'lps'),
	(684619, 135, '2015-02-01 01:19:01.000000', 'consum', 0.0222, 'lps'),
	(684620, 135, '2015-02-01 01:19:02.000000', 'consum', 0.0229, 'lps'),
	(684621, 135, '2015-02-01 01:19:03.000000', 'consum', 0.0213, 'lps'),
	(684622, 135, '2015-02-01 01:19:04.000000', 'consum', 0.0223, 'lps'),
	(684623, 135, '2015-02-01 01:19:05.000000', 'consum', 0.0214, 'lps'),
	(684624, 135, '2015-02-01 01:19:06.000000', 'consum', 0.0246, 'lps'),
	(684625, 135, '2015-02-01 01:19:07.000000', 'consum', 0.0219, 'lps'),
	(684626, 135, '2015-02-01 01:19:08.000000', 'consum', 0.0253, 'lps'),
	(684627, 135, '2015-02-01 01:19:09.000000', 'consum', 0.0239, 'lps'),
	(684628, 135, '2015-02-01 01:19:10.000000', 'consum', 0.0225, 'lps'),
	(684629, 135, '2015-02-01 01:19:11.000000', 'consum', 0.0252, 'lps'),
	(684630, 135, '2015-02-01 01:19:12.000000', 'consum', 0.0217, 'lps'),
	(684631, 135, '2015-02-01 01:19:13.000000', 'consum', 0.0225, 'lps'),
	(684632, 135, '2015-02-01 01:19:14.000000', 'consum', 0.0213, 'lps'),
	(684633, 135, '2015-02-01 01:19:15.000000', 'consum', 0.0231, 'lps'),
	(684634, 135, '2015-02-01 01:19:16.000000', 'consum', 0.0255, 'lps'),
	(684635, 135, '2015-02-01 01:19:17.000000', 'consum', 0.0214, 'lps'),
	(684636, 135, '2015-02-01 01:19:18.000000', 'consum', 0.0254, 'lps'),
	(684637, 135, '2015-02-01 01:19:19.000000', 'consum', 0.0260, 'lps'),
	(684638, 135, '2015-02-01 01:19:20.000000', 'consum', 0.0222, 'lps'),
	(684639, 135, '2015-02-01 01:19:21.000000', 'consum', 0.0225, 'lps'),
	(684640, 135, '2015-02-01 01:19:22.000000', 'consum', 0.0252, 'lps'),
	(684641, 135, '2015-02-01 01:19:23.000000', 'consum', 0.0215, 'lps'),
	(684642, 135, '2015-02-01 01:19:24.000000', 'consum', 0.0216, 'lps'),
	(684643, 135, '2015-02-01 01:19:25.000000', 'consum', 0.0224, 'lps'),
	(684644, 135, '2015-02-01 01:19:26.000000', 'consum', 0.0211, 'lps'),
	(684645, 135, '2015-02-01 01:19:27.000000', 'consum', 0.0225, 'lps'),
	(684646, 135, '2015-02-01 01:19:28.000000', 'consum', 0.0231, 'lps'),
	(684647, 135, '2015-02-01 01:19:29.000000', 'consum', 0.0218, 'lps'),
	(684648, 135, '2015-02-01 01:19:30.000000', 'consum', 0.0240, 'lps'),
	(684649, 135, '2015-02-01 01:19:31.000000', 'consum', 0.0230, 'lps'),
	(684650, 135, '2015-02-01 01:19:32.000000', 'consum', 0.0221, 'lps'),
	(684651, 135, '2015-02-01 01:19:33.000000', 'consum', 0.0258, 'lps'),
	(684652, 135, '2015-02-01 01:19:34.000000', 'consum', 0.0259, 'lps'),
	(684653, 135, '2015-02-01 01:19:35.000000', 'consum', 0.0258, 'lps'),
	(684654, 135, '2015-02-01 01:19:36.000000', 'consum', 0.0252, 'lps'),
	(684655, 135, '2015-02-01 01:19:37.000000', 'consum', 0.0223, 'lps'),
	(684656, 135, '2015-02-01 01:19:38.000000', 'consum', 0.0256, 'lps'),
	(684657, 135, '2015-02-01 01:19:39.000000', 'consum', 0.0243, 'lps'),
	(684658, 135, '2015-02-01 01:19:40.000000', 'consum', 0.0236, 'lps'),
	(684659, 135, '2015-02-01 01:19:41.000000', 'consum', 0.0241, 'lps'),
	(684660, 135, '2015-02-01 01:19:42.000000', 'consum', 0.0237, 'lps'),
	(684661, 135, '2015-02-01 01:19:43.000000', 'consum', 0.0252, 'lps'),
	(684662, 135, '2015-02-01 01:19:44.000000', 'consum', 0.0234, 'lps'),
	(684663, 135, '2015-02-01 01:19:45.000000', 'consum', 0.0256, 'lps'),
	(684664, 135, '2015-02-01 01:19:46.000000', 'consum', 0.0210, 'lps'),
	(684665, 135, '2015-02-01 01:19:47.000000', 'consum', 0.0230, 'lps'),
	(684666, 135, '2015-02-01 01:19:48.000000', 'consum', 0.0258, 'lps'),
	(684667, 135, '2015-02-01 01:19:49.000000', 'consum', 0.0234, 'lps'),
	(684668, 135, '2015-02-01 01:19:50.000000', 'consum', 0.0236, 'lps'),
	(684669, 135, '2015-02-01 01:19:51.000000', 'consum', 0.0217, 'lps'),
	(684670, 135, '2015-02-01 01:19:52.000000', 'consum', 0.0219, 'lps'),
	(684671, 135, '2015-02-01 01:19:53.000000', 'consum', 0.0236, 'lps'),
	(684672, 135, '2015-02-01 01:19:54.000000', 'consum', 0.0259, 'lps'),
	(684673, 135, '2015-02-01 01:19:55.000000', 'consum', 0.0219, 'lps'),
	(684674, 135, '2015-02-01 01:19:56.000000', 'consum', 0.0215, 'lps'),
	(684675, 135, '2015-02-01 01:19:57.000000', 'consum', 0.0262, 'lps'),
	(684676, 135, '2015-02-01 01:19:58.000000', 'consum', 0.0242, 'lps'),
	(684677, 135, '2015-02-01 01:19:59.000000', 'consum', 0.0215, 'lps'),
	(684678, 135, '2015-02-01 01:20:00.000000', 'consum', 0.0244, 'lps'),
	(684679, 135, '2015-02-01 01:20:01.000000', 'consum', 0.0262, 'lps'),
	(684680, 135, '2015-02-01 01:20:02.000000', 'consum', 0.0262, 'lps'),
	(684681, 135, '2015-02-01 01:20:03.000000', 'consum', 0.0261, 'lps'),
	(684682, 135, '2015-02-01 01:20:04.000000', 'consum', 0.0255, 'lps'),
	(684683, 135, '2015-02-01 01:20:05.000000', 'consum', 0.0232, 'lps'),
	(684684, 135, '2015-02-01 01:20:06.000000', 'consum', 0.0236, 'lps'),
	(684685, 135, '2015-02-01 01:20:07.000000', 'consum', 0.0224, 'lps'),
	(684686, 135, '2015-02-01 01:20:08.000000', 'consum', 0.0255, 'lps'),
	(684687, 135, '2015-02-01 01:20:09.000000', 'consum', 0.0234, 'lps'),
	(684688, 135, '2015-02-01 01:20:10.000000', 'consum', 0.0247, 'lps'),
	(684689, 135, '2015-02-01 01:20:11.000000', 'consum', 0.0218, 'lps'),
	(684690, 135, '2015-02-01 01:20:12.000000', 'consum', 0.0246, 'lps'),
	(684691, 135, '2015-02-01 01:20:13.000000', 'consum', 0.0259, 'lps'),
	(684692, 135, '2015-02-01 01:20:14.000000', 'consum', 0.0241, 'lps'),
	(684693, 135, '2015-02-01 01:20:15.000000', 'consum', 0.0218, 'lps'),
	(684694, 135, '2015-02-01 01:20:16.000000', 'consum', 0.0211, 'lps'),
	(684695, 135, '2015-02-01 01:20:17.000000', 'consum', 0.0245, 'lps'),
	(684696, 135, '2015-02-01 01:20:18.000000', 'consum', 0.0224, 'lps'),
	(684697, 135, '2015-02-01 01:20:19.000000', 'consum', 0.0227, 'lps'),
	(684698, 135, '2015-02-01 01:20:20.000000', 'consum', 0.0252, 'lps'),
	(684699, 135, '2015-02-01 01:20:21.000000', 'consum', 0.0214, 'lps'),
	(684700, 135, '2015-02-01 01:20:22.000000', 'consum', 0.0210, 'lps'),
	(684701, 135, '2015-02-01 01:20:23.000000', 'consum', 0.0251, 'lps'),
	(684702, 135, '2015-02-01 01:20:24.000000', 'consum', 0.0255, 'lps'),
	(684703, 135, '2015-02-01 01:20:25.000000', 'consum', 0.0259, 'lps'),
	(684704, 135, '2015-02-01 01:20:26.000000', 'consum', 0.0215, 'lps'),
	(684705, 135, '2015-02-01 01:20:27.000000', 'consum', 0.0250, 'lps'),
	(684706, 135, '2015-02-01 01:20:28.000000', 'consum', 0.0235, 'lps'),
	(684707, 135, '2015-02-01 01:20:29.000000', 'consum', 0.0216, 'lps'),
	(684708, 135, '2015-02-01 01:20:30.000000', 'consum', 0.0217, 'lps'),
	(684709, 135, '2015-02-01 01:20:31.000000', 'consum', 0.0228, 'lps'),
	(684710, 135, '2015-02-01 01:20:32.000000', 'consum', 0.0227, 'lps'),
	(684711, 135, '2015-02-01 01:20:33.000000', 'consum', 0.0241, 'lps'),
	(684712, 135, '2015-02-01 01:20:34.000000', 'consum', 0.0260, 'lps'),
	(684713, 135, '2015-02-01 01:20:35.000000', 'consum', 0.0262, 'lps'),
	(684714, 135, '2015-02-01 01:20:36.000000', 'consum', 0.0213, 'lps'),
	(684715, 135, '2015-02-01 01:20:37.000000', 'consum', 0.0231, 'lps'),
	(684716, 135, '2015-02-01 01:20:38.000000', 'consum', 0.0254, 'lps'),
	(684717, 135, '2015-02-01 01:20:39.000000', 'consum', 0.0262, 'lps'),
	(684718, 135, '2015-02-01 01:20:40.000000', 'consum', 0.0231, 'lps'),
	(684719, 135, '2015-02-01 01:20:41.000000', 'consum', 0.0214, 'lps'),
	(684720, 135, '2015-02-01 01:20:42.000000', 'consum', 0.0220, 'lps'),
	(684721, 135, '2015-02-01 01:20:43.000000', 'consum', 0.0249, 'lps'),
	(684722, 135, '2015-02-01 01:20:44.000000', 'consum', 0.0218, 'lps'),
	(684723, 135, '2015-02-01 01:20:45.000000', 'consum', 0.0236, 'lps'),
	(684724, 135, '2015-02-01 01:20:46.000000', 'consum', 0.0213, 'lps'),
	(684725, 135, '2015-02-01 01:20:47.000000', 'consum', 0.0251, 'lps'),
	(684726, 135, '2015-02-01 01:20:48.000000', 'consum', 0.0248, 'lps'),
	(684727, 135, '2015-02-01 01:20:49.000000', 'consum', 0.0226, 'lps'),
	(684728, 135, '2015-02-01 01:20:50.000000', 'consum', 0.0228, 'lps'),
	(684729, 135, '2015-02-01 01:20:51.000000', 'consum', 0.0253, 'lps'),
	(684730, 135, '2015-02-01 01:20:52.000000', 'consum', 0.0213, 'lps'),
	(684731, 135, '2015-02-01 01:20:53.000000', 'consum', 0.0253, 'lps'),
	(684732, 135, '2015-02-01 01:20:54.000000', 'consum', 0.0260, 'lps'),
	(684733, 135, '2015-02-01 01:20:55.000000', 'consum', 0.0224, 'lps'),
	(684734, 135, '2015-02-01 01:20:56.000000', 'consum', 0.0236, 'lps'),
	(684735, 135, '2015-02-01 01:20:57.000000', 'consum', 0.0245, 'lps'),
	(684736, 135, '2015-02-01 01:20:58.000000', 'consum', 0.0254, 'lps'),
	(684737, 135, '2015-02-01 01:20:59.000000', 'consum', 0.0220, 'lps'),
	(684738, 135, '2015-02-01 01:21:00.000000', 'consum', 0.0236, 'lps'),
	(684739, 135, '2015-02-01 01:21:01.000000', 'consum', 0.0256, 'lps'),
	(684740, 135, '2015-02-01 01:21:02.000000', 'consum', 0.0256, 'lps'),
	(684741, 135, '2015-02-01 01:21:03.000000', 'consum', 0.0250, 'lps'),
	(684742, 135, '2015-02-01 01:21:04.000000', 'consum', 0.0219, 'lps'),
	(684743, 135, '2015-02-01 01:21:05.000000', 'consum', 0.0243, 'lps'),
	(684744, 135, '2015-02-01 01:21:06.000000', 'consum', 0.0241, 'lps'),
	(684745, 135, '2015-02-01 01:21:07.000000', 'consum', 0.0215, 'lps'),
	(684746, 135, '2015-02-01 01:21:08.000000', 'consum', 0.0248, 'lps'),
	(684747, 135, '2015-02-01 01:21:09.000000', 'consum', 0.0228, 'lps'),
	(684748, 135, '2015-02-01 01:21:10.000000', 'consum', 0.0237, 'lps'),
	(684749, 135, '2015-02-01 01:21:11.000000', 'consum', 0.0241, 'lps'),
	(684750, 135, '2015-02-01 01:21:12.000000', 'consum', 0.0230, 'lps'),
	(684751, 135, '2015-02-01 01:21:13.000000', 'consum', 0.0220, 'lps'),
	(684752, 135, '2015-02-01 01:21:14.000000', 'consum', 0.0250, 'lps'),
	(684753, 135, '2015-02-01 01:21:15.000000', 'consum', 0.0224, 'lps'),
	(684754, 135, '2015-02-01 01:21:16.000000', 'consum', 0.0214, 'lps'),
	(684755, 135, '2015-02-01 01:21:17.000000', 'consum', 0.0241, 'lps'),
	(684756, 135, '2015-02-01 01:21:18.000000', 'consum', 0.0249, 'lps'),
	(684757, 135, '2015-02-01 01:21:19.000000', 'consum', 0.0258, 'lps'),
	(684758, 135, '2015-02-01 01:21:20.000000', 'consum', 0.0229, 'lps'),
	(684759, 135, '2015-02-01 01:21:21.000000', 'consum', 0.0212, 'lps'),
	(684760, 135, '2015-02-01 01:21:22.000000', 'consum', 0.0219, 'lps'),
	(684761, 135, '2015-02-01 01:21:23.000000', 'consum', 0.0247, 'lps'),
	(684762, 135, '2015-02-01 01:21:24.000000', 'consum', 0.0212, 'lps'),
	(684763, 135, '2015-02-01 01:21:25.000000', 'consum', 0.0214, 'lps'),
	(684764, 135, '2015-02-01 01:21:26.000000', 'consum', 0.0227, 'lps'),
	(684765, 135, '2015-02-01 01:21:27.000000', 'consum', 0.0227, 'lps'),
	(684766, 135, '2015-02-01 01:21:28.000000', 'consum', 0.0248, 'lps'),
	(684767, 135, '2015-02-01 01:21:29.000000', 'consum', 0.0242, 'lps'),
	(684768, 135, '2015-02-01 01:21:30.000000', 'consum', 0.0257, 'lps'),
	(684769, 135, '2015-02-01 01:21:31.000000', 'consum', 0.0245, 'lps'),
	(684770, 135, '2015-02-01 01:21:32.000000', 'consum', 0.0243, 'lps'),
	(684771, 135, '2015-02-01 01:21:33.000000', 'consum', 0.0219, 'lps'),
	(684772, 135, '2015-02-01 01:21:34.000000', 'consum', 0.0261, 'lps'),
	(684773, 135, '2015-02-01 01:21:35.000000', 'consum', 0.0226, 'lps'),
	(684774, 135, '2015-02-01 01:21:36.000000', 'consum', 0.0246, 'lps'),
	(684775, 135, '2015-02-01 01:21:37.000000', 'consum', 0.0233, 'lps'),
	(684776, 135, '2015-02-01 01:21:38.000000', 'consum', 0.0221, 'lps'),
	(684777, 135, '2015-02-01 01:21:39.000000', 'consum', 0.0248, 'lps'),
	(684778, 135, '2015-02-01 01:21:40.000000', 'consum', 0.0260, 'lps'),
	(684779, 135, '2015-02-01 01:21:41.000000', 'consum', 0.0240, 'lps'),
	(684780, 135, '2015-02-01 01:21:42.000000', 'consum', 0.0211, 'lps'),
	(684781, 135, '2015-02-01 01:21:43.000000', 'consum', 0.0233, 'lps'),
	(684782, 135, '2015-02-01 01:21:44.000000', 'consum', 0.0215, 'lps'),
	(684783, 135, '2015-02-01 01:21:45.000000', 'consum', 0.0220, 'lps'),
	(684784, 135, '2015-02-01 01:21:46.000000', 'consum', 0.0246, 'lps'),
	(684785, 135, '2015-02-01 01:21:47.000000', 'consum', 0.0253, 'lps'),
	(684786, 135, '2015-02-01 01:21:48.000000', 'consum', 0.0214, 'lps'),
	(684787, 135, '2015-02-01 01:21:49.000000', 'consum', 0.0259, 'lps'),
	(684788, 135, '2015-02-01 01:21:50.000000', 'consum', 0.0233, 'lps'),
	(684789, 135, '2015-02-01 01:21:51.000000', 'consum', 0.0231, 'lps'),
	(684790, 135, '2015-02-01 01:21:52.000000', 'consum', 0.0245, 'lps'),
	(684791, 135, '2015-02-01 01:21:53.000000', 'consum', 0.0217, 'lps'),
	(684792, 135, '2015-02-01 01:21:54.000000', 'consum', 0.0247, 'lps'),
	(684793, 135, '2015-02-01 01:21:55.000000', 'consum', 0.0217, 'lps'),
	(684794, 135, '2015-02-01 01:21:56.000000', 'consum', 0.0241, 'lps'),
	(684795, 135, '2015-02-01 01:21:57.000000', 'consum', 0.0238, 'lps'),
	(684796, 135, '2015-02-01 01:21:58.000000', 'consum', 0.0259, 'lps'),
	(684797, 135, '2015-02-01 01:21:59.000000', 'consum', 0.0210, 'lps'),
	(684798, 135, '2015-02-01 01:22:00.000000', 'consum', 0.0224, 'lps'),
	(684799, 135, '2015-02-01 01:22:01.000000', 'consum', 0.0228, 'lps'),
	(684800, 135, '2015-02-01 01:22:02.000000', 'consum', 0.0257, 'lps'),
	(684801, 135, '2015-02-01 01:22:03.000000', 'consum', 0.0231, 'lps'),
	(684802, 135, '2015-02-01 01:22:04.000000', 'consum', 0.0230, 'lps'),
	(684803, 135, '2015-02-01 01:22:05.000000', 'consum', 0.0246, 'lps'),
	(684804, 135, '2015-02-01 01:22:06.000000', 'consum', 0.0225, 'lps'),
	(684805, 135, '2015-02-01 01:22:07.000000', 'consum', 0.0231, 'lps'),
	(684806, 135, '2015-02-01 01:22:08.000000', 'consum', 0.0215, 'lps'),
	(684807, 135, '2015-02-01 01:22:09.000000', 'consum', 0.0228, 'lps'),
	(684808, 135, '2015-02-01 01:22:10.000000', 'consum', 0.0233, 'lps'),
	(684809, 135, '2015-02-01 01:22:11.000000', 'consum', 0.0217, 'lps'),
	(684810, 135, '2015-02-01 01:22:12.000000', 'consum', 0.0228, 'lps'),
	(684811, 135, '2015-02-01 01:22:13.000000', 'consum', 0.0229, 'lps'),
	(684812, 135, '2015-02-01 01:22:14.000000', 'consum', 0.0251, 'lps'),
	(684813, 135, '2015-02-01 01:22:15.000000', 'consum', 0.0250, 'lps'),
	(684814, 135, '2015-02-01 01:22:16.000000', 'consum', 0.0237, 'lps'),
	(684815, 135, '2015-02-01 01:22:17.000000', 'consum', 0.0227, 'lps'),
	(684816, 135, '2015-02-01 01:22:18.000000', 'consum', 0.0211, 'lps'),
	(684817, 135, '2015-02-01 01:22:19.000000', 'consum', 0.0220, 'lps'),
	(684818, 135, '2015-02-01 01:22:20.000000', 'consum', 0.0257, 'lps'),
	(684819, 135, '2015-02-01 01:22:21.000000', 'consum', 0.0254, 'lps'),
	(684820, 135, '2015-02-01 01:22:22.000000', 'consum', 0.0240, 'lps'),
	(684821, 135, '2015-02-01 01:22:23.000000', 'consum', 0.0227, 'lps'),
	(684822, 135, '2015-02-01 01:22:24.000000', 'consum', 0.0260, 'lps'),
	(684823, 135, '2015-02-01 01:22:25.000000', 'consum', 0.0252, 'lps'),
	(684824, 135, '2015-02-01 01:22:26.000000', 'consum', 0.0214, 'lps'),
	(684825, 135, '2015-02-01 01:22:27.000000', 'consum', 0.0213, 'lps'),
	(684826, 135, '2015-02-01 01:22:28.000000', 'consum', 0.0213, 'lps'),
	(684827, 135, '2015-02-01 01:22:29.000000', 'consum', 0.0216, 'lps'),
	(684828, 135, '2015-02-01 01:22:30.000000', 'consum', 0.0233, 'lps'),
	(684829, 135, '2015-02-01 01:22:31.000000', 'consum', 0.0253, 'lps'),
	(684830, 135, '2015-02-01 01:22:32.000000', 'consum', 0.0253, 'lps'),
	(684831, 135, '2015-02-01 01:22:33.000000', 'consum', 0.0240, 'lps'),
	(684832, 135, '2015-02-01 01:22:34.000000', 'consum', 0.0234, 'lps'),
	(684833, 135, '2015-02-01 01:22:35.000000', 'consum', 0.0240, 'lps'),
	(684834, 135, '2015-02-01 01:22:36.000000', 'consum', 0.0236, 'lps'),
	(684835, 135, '2015-02-01 01:22:37.000000', 'consum', 0.0251, 'lps'),
	(684836, 135, '2015-02-01 01:22:38.000000', 'consum', 0.0232, 'lps'),
	(684837, 135, '2015-02-01 01:22:39.000000', 'consum', 0.0248, 'lps'),
	(684838, 135, '2015-02-01 01:22:40.000000', 'consum', 0.0230, 'lps'),
	(684839, 135, '2015-02-01 01:22:41.000000', 'consum', 0.0251, 'lps'),
	(684840, 135, '2015-02-01 01:22:42.000000', 'consum', 0.0249, 'lps'),
	(684841, 135, '2015-02-01 01:22:43.000000', 'consum', 0.0227, 'lps'),
	(684842, 135, '2015-02-01 01:22:44.000000', 'consum', 0.0234, 'lps'),
	(684843, 135, '2015-02-01 01:22:45.000000', 'consum', 0.0225, 'lps'),
	(684844, 135, '2015-02-01 01:22:46.000000', 'consum', 0.0214, 'lps'),
	(684845, 135, '2015-02-01 01:22:47.000000', 'consum', 0.0238, 'lps'),
	(684846, 135, '2015-02-01 01:22:48.000000', 'consum', 0.0231, 'lps'),
	(684847, 135, '2015-02-01 01:22:49.000000', 'consum', 0.0233, 'lps'),
	(684848, 135, '2015-02-01 01:22:50.000000', 'consum', 0.0210, 'lps'),
	(684849, 135, '2015-02-01 01:22:51.000000', 'consum', 0.0247, 'lps'),
	(684850, 135, '2015-02-01 01:22:52.000000', 'consum', 0.0234, 'lps'),
	(684851, 135, '2015-02-01 01:22:53.000000', 'consum', 0.0223, 'lps'),
	(684852, 135, '2015-02-01 01:22:54.000000', 'consum', 0.0257, 'lps'),
	(684853, 135, '2015-02-01 01:22:55.000000', 'consum', 0.0246, 'lps'),
	(684854, 135, '2015-02-01 01:22:56.000000', 'consum', 0.0251, 'lps'),
	(684855, 135, '2015-02-01 01:22:57.000000', 'consum', 0.0254, 'lps'),
	(684856, 135, '2015-02-01 01:22:58.000000', 'consum', 0.0256, 'lps'),
	(684857, 135, '2015-02-01 01:22:59.000000', 'consum', 0.0255, 'lps'),
	(684858, 135, '2015-02-01 01:23:00.000000', 'consum', 0.0245, 'lps'),
	(684859, 135, '2015-02-01 01:23:01.000000', 'consum', 0.0252, 'lps'),
	(684860, 135, '2015-02-01 01:23:02.000000', 'consum', 0.0259, 'lps'),
	(684861, 135, '2015-02-01 01:23:03.000000', 'consum', 0.0226, 'lps'),
	(684862, 135, '2015-02-01 01:23:04.000000', 'consum', 0.0247, 'lps'),
	(684863, 135, '2015-02-01 01:23:05.000000', 'consum', 0.0243, 'lps'),
	(684864, 135, '2015-02-01 01:23:06.000000', 'consum', 0.0211, 'lps'),
	(684865, 135, '2015-02-01 01:23:07.000000', 'consum', 0.0223, 'lps'),
	(684866, 135, '2015-02-01 01:23:08.000000', 'consum', 0.0221, 'lps'),
	(684867, 135, '2015-02-01 01:23:09.000000', 'consum', 0.0227, 'lps'),
	(684868, 135, '2015-02-01 01:23:10.000000', 'consum', 0.0261, 'lps'),
	(684869, 135, '2015-02-01 01:23:11.000000', 'consum', 0.0257, 'lps'),
	(684870, 135, '2015-02-01 01:23:12.000000', 'consum', 0.0239, 'lps'),
	(684871, 135, '2015-02-01 01:23:13.000000', 'consum', 0.0215, 'lps'),
	(684872, 135, '2015-02-01 01:23:14.000000', 'consum', 0.0255, 'lps'),
	(684873, 135, '2015-02-01 01:23:15.000000', 'consum', 0.0260, 'lps'),
	(684874, 135, '2015-02-01 01:23:16.000000', 'consum', 0.0220, 'lps'),
	(684875, 135, '2015-02-01 01:23:17.000000', 'consum', 0.0216, 'lps'),
	(684876, 135, '2015-02-01 01:23:18.000000', 'consum', 0.0262, 'lps'),
	(684877, 135, '2015-02-01 01:23:19.000000', 'consum', 0.0244, 'lps'),
	(684878, 135, '2015-02-01 01:23:20.000000', 'consum', 0.0222, 'lps'),
	(684879, 135, '2015-02-01 01:23:21.000000', 'consum', 0.0223, 'lps'),
	(684880, 135, '2015-02-01 01:23:22.000000', 'consum', 0.0238, 'lps'),
	(684881, 135, '2015-02-01 01:23:23.000000', 'consum', 0.0259, 'lps'),
	(684882, 135, '2015-02-01 01:23:24.000000', 'consum', 0.0211, 'lps'),
	(684883, 135, '2015-02-01 01:23:25.000000', 'consum', 0.0229, 'lps'),
	(684884, 135, '2015-02-01 01:23:26.000000', 'consum', 0.0251, 'lps'),
	(684885, 135, '2015-02-01 01:23:27.000000', 'consum', 0.0251, 'lps'),
	(684886, 135, '2015-02-01 01:23:28.000000', 'consum', 0.0242, 'lps'),
	(684887, 135, '2015-02-01 01:23:29.000000', 'consum', 0.0245, 'lps'),
	(684888, 135, '2015-02-01 01:23:30.000000', 'consum', 0.0236, 'lps'),
	(684889, 135, '2015-02-01 01:23:31.000000', 'consum', 0.0236, 'lps'),
	(684890, 135, '2015-02-01 01:23:32.000000', 'consum', 0.0211, 'lps'),
	(684891, 135, '2015-02-01 01:23:33.000000', 'consum', 0.0242, 'lps'),
	(684892, 135, '2015-02-01 01:23:34.000000', 'consum', 0.0261, 'lps'),
	(684893, 135, '2015-02-01 01:23:35.000000', 'consum', 0.0210, 'lps'),
	(684894, 135, '2015-02-01 01:23:36.000000', 'consum', 0.0216, 'lps'),
	(684895, 135, '2015-02-01 01:23:37.000000', 'consum', 0.0240, 'lps'),
	(684896, 135, '2015-02-01 01:23:38.000000', 'consum', 0.0237, 'lps'),
	(684897, 135, '2015-02-01 01:23:39.000000', 'consum', 0.0255, 'lps'),
	(684898, 135, '2015-02-01 01:23:40.000000', 'consum', 0.0251, 'lps'),
	(684899, 135, '2015-02-01 01:23:41.000000', 'consum', 0.0227, 'lps'),
	(684900, 135, '2015-02-01 01:23:42.000000', 'consum', 0.0225, 'lps'),
	(684901, 135, '2015-02-01 01:23:43.000000', 'consum', 0.0233, 'lps'),
	(684902, 135, '2015-02-01 01:23:44.000000', 'consum', 0.0229, 'lps'),
	(684903, 135, '2015-02-01 01:23:45.000000', 'consum', 0.0235, 'lps'),
	(684904, 135, '2015-02-01 01:23:46.000000', 'consum', 0.0226, 'lps'),
	(684905, 135, '2015-02-01 01:23:47.000000', 'consum', 0.0216, 'lps'),
	(684906, 135, '2015-02-01 01:23:48.000000', 'consum', 0.0244, 'lps'),
	(684907, 135, '2015-02-01 01:23:49.000000', 'consum', 0.0257, 'lps'),
	(684908, 135, '2015-02-01 01:23:50.000000', 'consum', 0.0237, 'lps'),
	(684909, 135, '2015-02-01 01:23:51.000000', 'consum', 0.0259, 'lps'),
	(684910, 135, '2015-02-01 01:23:52.000000', 'consum', 0.0216, 'lps'),
	(684911, 135, '2015-02-01 01:23:53.000000', 'consum', 0.0253, 'lps'),
	(684912, 135, '2015-02-01 01:23:54.000000', 'consum', 0.0249, 'lps'),
	(684913, 135, '2015-02-01 01:23:55.000000', 'consum', 0.0224, 'lps'),
	(684914, 135, '2015-02-01 01:23:56.000000', 'consum', 0.0217, 'lps'),
	(684915, 135, '2015-02-01 01:23:57.000000', 'consum', 0.0256, 'lps'),
	(684916, 135, '2015-02-01 01:23:58.000000', 'consum', 0.0260, 'lps'),
	(684917, 135, '2015-02-01 01:23:59.000000', 'consum', 0.0218, 'lps'),
	(684918, 135, '2015-02-01 01:24:00.000000', 'consum', 0.0258, 'lps'),
	(684919, 135, '2015-02-01 01:24:01.000000', 'consum', 0.0215, 'lps'),
	(684920, 135, '2015-02-01 01:24:02.000000', 'consum', 0.0253, 'lps'),
	(684921, 135, '2015-02-01 01:24:03.000000', 'consum', 0.0248, 'lps'),
	(684922, 135, '2015-02-01 01:24:04.000000', 'consum', 0.0218, 'lps'),
	(684923, 135, '2015-02-01 01:24:05.000000', 'consum', 0.0244, 'lps'),
	(684924, 135, '2015-02-01 01:24:06.000000', 'consum', 0.0249, 'lps'),
	(684925, 135, '2015-02-01 01:24:07.000000', 'consum', 0.0250, 'lps'),
	(684926, 135, '2015-02-01 01:24:08.000000', 'consum', 0.0242, 'lps'),
	(684927, 135, '2015-02-01 01:24:09.000000', 'consum', 0.0250, 'lps'),
	(684928, 135, '2015-02-01 01:24:10.000000', 'consum', 0.0260, 'lps'),
	(684929, 135, '2015-02-01 01:24:11.000000', 'consum', 0.0235, 'lps'),
	(684930, 135, '2015-02-01 01:24:12.000000', 'consum', 0.0238, 'lps'),
	(684931, 135, '2015-02-01 01:24:13.000000', 'consum', 0.0222, 'lps'),
	(684932, 135, '2015-02-01 01:24:14.000000', 'consum', 0.0242, 'lps'),
	(684933, 135, '2015-02-01 01:24:15.000000', 'consum', 0.0228, 'lps'),
	(684934, 135, '2015-02-01 01:24:16.000000', 'consum', 0.0258, 'lps'),
	(684935, 135, '2015-02-01 01:24:17.000000', 'consum', 0.0237, 'lps'),
	(684936, 135, '2015-02-01 01:24:18.000000', 'consum', 0.0254, 'lps'),
	(684937, 135, '2015-02-01 01:24:19.000000', 'consum', 0.0243, 'lps'),
	(684938, 135, '2015-02-01 01:24:20.000000', 'consum', 0.0243, 'lps'),
	(684939, 135, '2015-02-01 01:24:21.000000', 'consum', 0.0225, 'lps'),
	(684940, 135, '2015-02-01 01:24:22.000000', 'consum', 0.0241, 'lps'),
	(684941, 135, '2015-02-01 01:24:23.000000', 'consum', 0.0211, 'lps'),
	(684942, 135, '2015-02-01 01:24:24.000000', 'consum', 0.0230, 'lps'),
	(684943, 135, '2015-02-01 01:24:25.000000', 'consum', 0.0256, 'lps'),
	(684944, 135, '2015-02-01 01:24:26.000000', 'consum', 0.0221, 'lps'),
	(684945, 135, '2015-02-01 01:24:27.000000', 'consum', 0.0234, 'lps'),
	(684946, 135, '2015-02-01 01:24:28.000000', 'consum', 0.0243, 'lps'),
	(684947, 135, '2015-02-01 01:24:29.000000', 'consum', 0.0249, 'lps'),
	(684948, 135, '2015-02-01 01:24:30.000000', 'consum', 0.0256, 'lps'),
	(684949, 135, '2015-02-01 01:24:31.000000', 'consum', 0.0217, 'lps'),
	(684950, 135, '2015-02-01 01:24:32.000000', 'consum', 0.0214, 'lps'),
	(684951, 135, '2015-02-01 01:24:33.000000', 'consum', 0.0211, 'lps'),
	(684952, 135, '2015-02-01 01:24:34.000000', 'consum', 0.0254, 'lps'),
	(684953, 135, '2015-02-01 01:24:35.000000', 'consum', 0.0215, 'lps'),
	(684954, 135, '2015-02-01 01:24:36.000000', 'consum', 0.0261, 'lps'),
	(684955, 135, '2015-02-01 01:24:37.000000', 'consum', 0.0242, 'lps'),
	(684956, 135, '2015-02-01 01:24:38.000000', 'consum', 0.0217, 'lps'),
	(684957, 135, '2015-02-01 01:24:39.000000', 'consum', 0.0256, 'lps'),
	(684958, 135, '2015-02-01 01:24:40.000000', 'consum', 0.0258, 'lps'),
	(684959, 135, '2015-02-01 01:24:41.000000', 'consum', 0.0261, 'lps'),
	(684960, 135, '2015-02-01 01:24:42.000000', 'consum', 0.0216, 'lps'),
	(684961, 135, '2015-02-01 01:24:43.000000', 'consum', 0.0247, 'lps'),
	(684962, 135, '2015-02-01 01:24:44.000000', 'consum', 0.0217, 'lps'),
	(684963, 135, '2015-02-01 01:24:45.000000', 'consum', 0.0241, 'lps'),
	(684964, 135, '2015-02-01 01:24:46.000000', 'consum', 0.0239, 'lps'),
	(684965, 135, '2015-02-01 01:24:47.000000', 'consum', 0.0262, 'lps'),
	(684966, 135, '2015-02-01 01:24:48.000000', 'consum', 0.0227, 'lps'),
	(684967, 135, '2015-02-01 01:24:49.000000', 'consum', 0.0242, 'lps'),
	(684968, 135, '2015-02-01 01:24:50.000000', 'consum', 0.0215, 'lps'),
	(684969, 135, '2015-02-01 01:24:51.000000', 'consum', 0.0245, 'lps'),
	(684970, 135, '2015-02-01 01:24:52.000000', 'consum', 0.0212, 'lps'),
	(684971, 135, '2015-02-01 01:24:53.000000', 'consum', 0.0222, 'lps'),
	(684972, 135, '2015-02-01 01:24:54.000000', 'consum', 0.0262, 'lps'),
	(684973, 135, '2015-02-01 01:24:55.000000', 'consum', 0.0224, 'lps'),
	(684974, 135, '2015-02-01 01:24:56.000000', 'consum', 0.0229, 'lps'),
	(684975, 135, '2015-02-01 01:24:57.000000', 'consum', 0.0213, 'lps'),
	(684976, 135, '2015-02-01 01:24:58.000000', 'consum', 0.0220, 'lps'),
	(684977, 135, '2015-02-01 01:24:59.000000', 'consum', 0.0253, 'lps'),
	(684978, 135, '2015-02-01 01:25:00.000000', 'consum', 0.0234, 'lps'),
	(684979, 135, '2015-02-01 01:25:01.000000', 'consum', 0.0255, 'lps'),
	(684980, 135, '2015-02-01 01:25:02.000000', 'consum', 0.0260, 'lps'),
	(684981, 135, '2015-02-01 01:25:03.000000', 'consum', 0.0217, 'lps'),
	(684982, 135, '2015-02-01 01:25:04.000000', 'consum', 0.0256, 'lps'),
	(684983, 135, '2015-02-01 01:25:05.000000', 'consum', 0.0260, 'lps'),
	(684984, 135, '2015-02-01 01:25:06.000000', 'consum', 0.0218, 'lps'),
	(684985, 135, '2015-02-01 01:25:07.000000', 'consum', 0.0258, 'lps'),
	(684986, 135, '2015-02-01 01:25:08.000000', 'consum', 0.0213, 'lps'),
	(684987, 135, '2015-02-01 01:25:09.000000', 'consum', 0.0241, 'lps'),
	(684988, 135, '2015-02-01 01:25:10.000000', 'consum', 0.0253, 'lps'),
	(684989, 135, '2015-02-01 01:25:11.000000', 'consum', 0.0224, 'lps'),
	(684990, 135, '2015-02-01 01:25:12.000000', 'consum', 0.0258, 'lps'),
	(684991, 135, '2015-02-01 01:25:13.000000', 'consum', 0.0248, 'lps'),
	(684992, 135, '2015-02-01 01:25:14.000000', 'consum', 0.0260, 'lps'),
	(684993, 135, '2015-02-01 01:25:15.000000', 'consum', 0.0238, 'lps'),
	(684994, 135, '2015-02-01 01:25:16.000000', 'consum', 0.0252, 'lps'),
	(684995, 135, '2015-02-01 01:25:17.000000', 'consum', 0.0232, 'lps'),
	(684996, 135, '2015-02-01 01:25:18.000000', 'consum', 0.0250, 'lps'),
	(684997, 135, '2015-02-01 01:25:19.000000', 'consum', 0.0235, 'lps'),
	(684998, 135, '2015-02-01 01:25:20.000000', 'consum', 0.0217, 'lps'),
	(684999, 135, '2015-02-01 01:25:21.000000', 'consum', 0.0223, 'lps'),
	(685000, 135, '2015-02-01 01:25:22.000000', 'consum', 0.0254, 'lps'),
	(685001, 135, '2015-02-01 01:25:23.000000', 'consum', 0.0234, 'lps'),
	(685002, 135, '2015-02-01 01:25:24.000000', 'consum', 0.0249, 'lps'),
	(685003, 135, '2015-02-01 01:25:25.000000', 'consum', 0.0230, 'lps'),
	(685004, 135, '2015-02-01 01:25:26.000000', 'consum', 0.0248, 'lps'),
	(685005, 135, '2015-02-01 01:25:27.000000', 'consum', 0.0231, 'lps'),
	(685006, 135, '2015-02-01 01:25:28.000000', 'consum', 0.0255, 'lps'),
	(685007, 135, '2015-02-01 01:25:29.000000', 'consum', 0.0213, 'lps'),
	(685008, 135, '2015-02-01 01:25:30.000000', 'consum', 0.0251, 'lps'),
	(685009, 135, '2015-02-01 01:25:31.000000', 'consum', 0.0246, 'lps'),
	(685010, 135, '2015-02-01 01:25:32.000000', 'consum', 0.0213, 'lps'),
	(685011, 135, '2015-02-01 01:25:33.000000', 'consum', 0.0227, 'lps'),
	(685012, 135, '2015-02-01 01:25:34.000000', 'consum', 0.0233, 'lps'),
	(685013, 135, '2015-02-01 01:25:35.000000', 'consum', 0.0219, 'lps'),
	(685014, 135, '2015-02-01 01:25:36.000000', 'consum', 0.0240, 'lps'),
	(685015, 135, '2015-02-01 01:25:37.000000', 'consum', 0.0230, 'lps'),
	(685016, 135, '2015-02-01 01:25:38.000000', 'consum', 0.0220, 'lps'),
	(685017, 135, '2015-02-01 01:25:39.000000', 'consum', 0.0252, 'lps'),
	(685018, 135, '2015-02-01 01:25:40.000000', 'consum', 0.0234, 'lps'),
	(685019, 135, '2015-02-01 01:25:41.000000', 'consum', 0.0256, 'lps'),
	(685020, 135, '2015-02-01 01:25:42.000000', 'consum', 0.0211, 'lps'),
	(685021, 135, '2015-02-01 01:25:43.000000', 'consum', 0.0237, 'lps'),
	(685022, 135, '2015-02-01 01:25:44.000000', 'consum', 0.0237, 'lps'),
	(685023, 135, '2015-02-01 01:25:45.000000', 'consum', 0.0211, 'lps'),
	(685024, 135, '2015-02-01 01:25:46.000000', 'consum', 0.0240, 'lps'),
	(685025, 135, '2015-02-01 01:25:47.000000', 'consum', 0.0250, 'lps'),
	(685026, 135, '2015-02-01 01:25:48.000000', 'consum', 0.0216, 'lps'),
	(685027, 135, '2015-02-01 01:25:49.000000', 'consum', 0.0225, 'lps'),
	(685028, 135, '2015-02-01 01:25:50.000000', 'consum', 0.0217, 'lps'),
	(685029, 135, '2015-02-01 01:25:51.000000', 'consum', 0.0254, 'lps'),
	(685030, 135, '2015-02-01 01:25:52.000000', 'consum', 0.0248, 'lps'),
	(685031, 135, '2015-02-01 01:25:53.000000', 'consum', 0.0218, 'lps'),
	(685032, 135, '2015-02-01 01:25:54.000000', 'consum', 0.0241, 'lps'),
	(685033, 135, '2015-02-01 01:25:55.000000', 'consum', 0.0237, 'lps'),
	(685034, 135, '2015-02-01 01:25:56.000000', 'consum', 0.0253, 'lps'),
	(685035, 135, '2015-02-01 01:25:57.000000', 'consum', 0.0238, 'lps'),
	(685036, 135, '2015-02-01 01:25:58.000000', 'consum', 0.0220, 'lps'),
	(685037, 135, '2015-02-01 01:25:59.000000', 'consum', 0.0232, 'lps'),
	(685038, 135, '2015-02-01 01:26:00.000000', 'consum', 0.0237, 'lps'),
	(685039, 135, '2015-02-01 01:26:01.000000', 'consum', 0.0228, 'lps'),
	(685040, 135, '2015-02-01 01:26:02.000000', 'consum', 0.0217, 'lps'),
	(685041, 135, '2015-02-01 01:26:03.000000', 'consum', 0.0243, 'lps'),
	(685042, 135, '2015-02-01 01:26:04.000000', 'consum', 0.0251, 'lps'),
	(685043, 135, '2015-02-01 01:26:05.000000', 'consum', 0.0211, 'lps'),
	(685044, 135, '2015-02-01 01:26:06.000000', 'consum', 0.0250, 'lps'),
	(685045, 135, '2015-02-01 01:26:07.000000', 'consum', 0.0250, 'lps'),
	(685046, 135, '2015-02-01 01:26:08.000000', 'consum', 0.0236, 'lps'),
	(685047, 135, '2015-02-01 01:26:09.000000', 'consum', 0.0221, 'lps'),
	(685048, 135, '2015-02-01 01:26:10.000000', 'consum', 0.0241, 'lps'),
	(685049, 135, '2015-02-01 01:26:11.000000', 'consum', 0.0225, 'lps'),
	(685050, 135, '2015-02-01 01:26:12.000000', 'consum', 0.0246, 'lps'),
	(685051, 135, '2015-02-01 01:26:13.000000', 'consum', 0.0242, 'lps'),
	(685052, 135, '2015-02-01 01:26:14.000000', 'consum', 0.0260, 'lps'),
	(685053, 135, '2015-02-01 01:26:15.000000', 'consum', 0.0258, 'lps'),
	(685054, 135, '2015-02-01 01:26:16.000000', 'consum', 0.0246, 'lps'),
	(685055, 135, '2015-02-01 01:26:17.000000', 'consum', 0.0249, 'lps'),
	(685056, 135, '2015-02-01 01:26:18.000000', 'consum', 0.0244, 'lps'),
	(685057, 135, '2015-02-01 01:26:19.000000', 'consum', 0.0210, 'lps'),
	(685058, 135, '2015-02-01 01:26:20.000000', 'consum', 0.0215, 'lps'),
	(685059, 135, '2015-02-01 01:26:21.000000', 'consum', 0.0236, 'lps'),
	(685060, 135, '2015-02-01 01:26:22.000000', 'consum', 0.0217, 'lps'),
	(685061, 135, '2015-02-01 01:26:23.000000', 'consum', 0.0222, 'lps'),
	(685062, 135, '2015-02-01 01:26:24.000000', 'consum', 0.0252, 'lps'),
	(685063, 135, '2015-02-01 01:26:25.000000', 'consum', 0.0222, 'lps'),
	(685064, 135, '2015-02-01 01:26:26.000000', 'consum', 0.0251, 'lps'),
	(685065, 135, '2015-02-01 01:26:27.000000', 'consum', 0.0222, 'lps'),
	(685066, 135, '2015-02-01 01:26:28.000000', 'consum', 0.0255, 'lps'),
	(685067, 135, '2015-02-01 01:26:29.000000', 'consum', 0.0239, 'lps'),
	(685068, 135, '2015-02-01 01:26:30.000000', 'consum', 0.0218, 'lps'),
	(685069, 135, '2015-02-01 01:26:31.000000', 'consum', 0.0220, 'lps'),
	(685070, 135, '2015-02-01 01:26:32.000000', 'consum', 0.0235, 'lps'),
	(685071, 135, '2015-02-01 01:26:33.000000', 'consum', 0.0251, 'lps'),
	(685072, 135, '2015-02-01 01:26:34.000000', 'consum', 0.0234, 'lps'),
	(685073, 135, '2015-02-01 01:26:35.000000', 'consum', 0.0211, 'lps'),
	(685074, 135, '2015-02-01 01:26:36.000000', 'consum', 0.0247, 'lps'),
	(685075, 135, '2015-02-01 01:26:37.000000', 'consum', 0.0233, 'lps'),
	(685076, 135, '2015-02-01 01:26:38.000000', 'consum', 0.0215, 'lps'),
	(685077, 135, '2015-02-01 01:26:39.000000', 'consum', 0.0219, 'lps'),
	(685078, 135, '2015-02-01 01:26:40.000000', 'consum', 0.0241, 'lps'),
	(685079, 135, '2015-02-01 01:26:41.000000', 'consum', 0.0231, 'lps'),
	(685080, 135, '2015-02-01 01:26:42.000000', 'consum', 0.0221, 'lps'),
	(685081, 135, '2015-02-01 01:26:43.000000', 'consum', 0.0259, 'lps'),
	(685082, 135, '2015-02-01 01:26:44.000000', 'consum', 0.0211, 'lps'),
	(685083, 135, '2015-02-01 01:26:45.000000', 'consum', 0.0225, 'lps'),
	(685084, 135, '2015-02-01 01:26:46.000000', 'consum', 0.0230, 'lps'),
	(685085, 135, '2015-02-01 01:26:47.000000', 'consum', 0.0214, 'lps'),
	(685086, 135, '2015-02-01 01:26:48.000000', 'consum', 0.0223, 'lps'),
	(685087, 135, '2015-02-01 01:26:49.000000', 'consum', 0.0210, 'lps'),
	(685088, 135, '2015-02-01 01:26:50.000000', 'consum', 0.0223, 'lps'),
	(685089, 135, '2015-02-01 01:26:51.000000', 'consum', 0.0225, 'lps'),
	(685090, 135, '2015-02-01 01:26:52.000000', 'consum', 0.0247, 'lps'),
	(685091, 135, '2015-02-01 01:26:53.000000', 'consum', 0.0244, 'lps'),
	(685092, 135, '2015-02-01 01:26:54.000000', 'consum', 0.0214, 'lps'),
	(685093, 135, '2015-02-01 01:26:55.000000', 'consum', 0.0237, 'lps'),
	(685094, 135, '2015-02-01 01:26:56.000000', 'consum', 0.0226, 'lps'),
	(685095, 135, '2015-02-01 01:26:57.000000', 'consum', 0.0210, 'lps'),
	(685096, 135, '2015-02-01 01:26:58.000000', 'consum', 0.0215, 'lps'),
	(685097, 135, '2015-02-01 01:26:59.000000', 'consum', 0.0236, 'lps'),
	(685098, 135, '2015-02-01 01:27:00.000000', 'consum', 0.0219, 'lps'),
	(685099, 135, '2015-02-01 01:27:01.000000', 'consum', 0.0231, 'lps'),
	(685100, 135, '2015-02-01 01:27:02.000000', 'consum', 0.0234, 'lps'),
	(685101, 135, '2015-02-01 01:27:03.000000', 'consum', 0.0215, 'lps'),
	(685102, 135, '2015-02-01 01:27:04.000000', 'consum', 0.0218, 'lps'),
	(685103, 135, '2015-02-01 01:27:05.000000', 'consum', 0.0236, 'lps'),
	(685104, 135, '2015-02-01 01:27:06.000000', 'consum', 0.0211, 'lps'),
	(685105, 135, '2015-02-01 01:27:07.000000', 'consum', 0.0243, 'lps'),
	(685106, 135, '2015-02-01 01:27:08.000000', 'consum', 0.0214, 'lps'),
	(685107, 135, '2015-02-01 01:27:09.000000', 'consum', 0.0238, 'lps'),
	(685108, 135, '2015-02-01 01:27:10.000000', 'consum', 0.0230, 'lps'),
	(685109, 135, '2015-02-01 01:27:11.000000', 'consum', 0.0226, 'lps'),
	(685110, 135, '2015-02-01 01:27:12.000000', 'consum', 0.0233, 'lps'),
	(685111, 135, '2015-02-01 01:27:13.000000', 'consum', 0.0222, 'lps'),
	(685112, 135, '2015-02-01 01:27:14.000000', 'consum', 0.0255, 'lps'),
	(685113, 135, '2015-02-01 01:27:15.000000', 'consum', 0.0239, 'lps'),
	(685114, 135, '2015-02-01 01:27:16.000000', 'consum', 0.0222, 'lps'),
	(685115, 135, '2015-02-01 01:27:17.000000', 'consum', 0.0234, 'lps'),
	(685116, 135, '2015-02-01 01:27:18.000000', 'consum', 0.0245, 'lps'),
	(685117, 135, '2015-02-01 01:27:19.000000', 'consum', 0.0258, 'lps'),
	(685118, 135, '2015-02-01 01:27:20.000000', 'consum', 0.0239, 'lps'),
	(685119, 135, '2015-02-01 01:27:21.000000', 'consum', 0.0213, 'lps'),
	(685120, 135, '2015-02-01 01:27:22.000000', 'consum', 0.0244, 'lps'),
	(685121, 135, '2015-02-01 01:27:23.000000', 'consum', 0.0211, 'lps'),
	(685122, 135, '2015-02-01 01:27:24.000000', 'consum', 0.0220, 'lps'),
	(685123, 135, '2015-02-01 01:27:25.000000', 'consum', 0.0259, 'lps'),
	(685124, 135, '2015-02-01 01:27:26.000000', 'consum', 0.0213, 'lps'),
	(685125, 135, '2015-02-01 01:27:27.000000', 'consum', 0.0235, 'lps'),
	(685126, 135, '2015-02-01 01:27:28.000000', 'consum', 0.0223, 'lps'),
	(685127, 135, '2015-02-01 01:27:29.000000', 'consum', 0.0254, 'lps'),
	(685128, 135, '2015-02-01 01:27:30.000000', 'consum', 0.0230, 'lps'),
	(685129, 135, '2015-02-01 01:27:31.000000', 'consum', 0.0233, 'lps'),
	(685130, 135, '2015-02-01 01:27:32.000000', 'consum', 0.0213, 'lps'),
	(685131, 135, '2015-02-01 01:27:33.000000', 'consum', 0.0210, 'lps'),
	(685132, 135, '2015-02-01 01:27:34.000000', 'consum', 0.0253, 'lps'),
	(685133, 135, '2015-02-01 01:27:35.000000', 'consum', 0.0216, 'lps'),
	(685134, 135, '2015-02-01 01:27:36.000000', 'consum', 0.0214, 'lps'),
	(685135, 135, '2015-02-01 01:27:37.000000', 'consum', 0.0216, 'lps'),
	(685136, 135, '2015-02-01 01:27:38.000000', 'consum', 0.0226, 'lps'),
	(685137, 135, '2015-02-01 01:27:39.000000', 'consum', 0.0221, 'lps'),
	(685138, 135, '2015-02-01 01:27:40.000000', 'consum', 0.0215, 'lps'),
	(685139, 135, '2015-02-01 01:27:41.000000', 'consum', 0.0257, 'lps'),
	(685140, 135, '2015-02-01 01:27:42.000000', 'consum', 0.0216, 'lps'),
	(685141, 135, '2015-02-01 01:27:43.000000', 'consum', 0.0261, 'lps'),
	(685142, 135, '2015-02-01 01:27:44.000000', 'consum', 0.0237, 'lps'),
	(685143, 135, '2015-02-01 01:27:45.000000', 'consum', 0.0243, 'lps'),
	(685144, 135, '2015-02-01 01:27:46.000000', 'consum', 0.0243, 'lps'),
	(685145, 135, '2015-02-01 01:27:47.000000', 'consum', 0.0222, 'lps'),
	(685146, 135, '2015-02-01 01:27:48.000000', 'consum', 0.0224, 'lps'),
	(685147, 135, '2015-02-01 01:27:49.000000', 'consum', 0.0244, 'lps'),
	(685148, 135, '2015-02-01 01:27:50.000000', 'consum', 0.0233, 'lps'),
	(685149, 135, '2015-02-01 01:27:51.000000', 'consum', 0.0223, 'lps'),
	(685150, 135, '2015-02-01 01:27:52.000000', 'consum', 0.0259, 'lps'),
	(685151, 135, '2015-02-01 01:27:53.000000', 'consum', 0.0260, 'lps'),
	(685152, 135, '2015-02-01 01:27:54.000000', 'consum', 0.0258, 'lps'),
	(685153, 135, '2015-02-01 01:27:55.000000', 'consum', 0.0250, 'lps'),
	(685154, 135, '2015-02-01 01:27:56.000000', 'consum', 0.0212, 'lps'),
	(685155, 135, '2015-02-01 01:27:57.000000', 'consum', 0.0258, 'lps'),
	(685156, 135, '2015-02-01 01:27:58.000000', 'consum', 0.0235, 'lps'),
	(685157, 135, '2015-02-01 01:27:59.000000', 'consum', 0.0244, 'lps'),
	(685158, 135, '2015-02-01 01:28:00.000000', 'consum', 0.0250, 'lps'),
	(685159, 135, '2015-02-01 01:28:01.000000', 'consum', 0.0257, 'lps'),
	(685160, 135, '2015-02-01 01:28:02.000000', 'consum', 0.0221, 'lps'),
	(685161, 135, '2015-02-01 01:28:03.000000', 'consum', 0.0231, 'lps'),
	(685162, 135, '2015-02-01 01:28:04.000000', 'consum', 0.0229, 'lps'),
	(685163, 135, '2015-02-01 01:28:05.000000', 'consum', 0.0241, 'lps'),
	(685164, 135, '2015-02-01 01:28:06.000000', 'consum', 0.0255, 'lps'),
	(685165, 135, '2015-02-01 01:28:07.000000', 'consum', 0.0237, 'lps'),
	(685166, 135, '2015-02-01 01:28:08.000000', 'consum', 0.0211, 'lps'),
	(685167, 135, '2015-02-01 01:28:09.000000', 'consum', 0.0241, 'lps'),
	(685168, 135, '2015-02-01 01:28:10.000000', 'consum', 0.0258, 'lps'),
	(685169, 135, '2015-02-01 01:28:11.000000', 'consum', 0.0249, 'lps'),
	(685170, 135, '2015-02-01 01:28:12.000000', 'consum', 0.0211, 'lps'),
	(685171, 135, '2015-02-01 01:28:13.000000', 'consum', 0.0258, 'lps'),
	(685172, 135, '2015-02-01 01:28:14.000000', 'consum', 0.0235, 'lps'),
	(685173, 135, '2015-02-01 01:28:15.000000', 'consum', 0.0242, 'lps'),
	(685174, 135, '2015-02-01 01:28:16.000000', 'consum', 0.0245, 'lps'),
	(685175, 135, '2015-02-01 01:28:17.000000', 'consum', 0.0234, 'lps'),
	(685176, 135, '2015-02-01 01:28:18.000000', 'consum', 0.0227, 'lps'),
	(685177, 135, '2015-02-01 01:28:19.000000', 'consum', 0.0222, 'lps'),
	(685178, 135, '2015-02-01 01:28:20.000000', 'consum', 0.0221, 'lps'),
	(685179, 135, '2015-02-01 01:28:21.000000', 'consum', 0.0229, 'lps'),
	(685180, 135, '2015-02-01 01:28:22.000000', 'consum', 0.0221, 'lps'),
	(685181, 135, '2015-02-01 01:28:23.000000', 'consum', 0.0261, 'lps'),
	(685182, 135, '2015-02-01 01:28:24.000000', 'consum', 0.0221, 'lps'),
	(685183, 135, '2015-02-01 01:28:25.000000', 'consum', 0.0217, 'lps'),
	(685184, 135, '2015-02-01 01:28:26.000000', 'consum', 0.0211, 'lps'),
	(685185, 135, '2015-02-01 01:28:27.000000', 'consum', 0.0251, 'lps'),
	(685186, 135, '2015-02-01 01:28:28.000000', 'consum', 0.0251, 'lps'),
	(685187, 135, '2015-02-01 01:28:29.000000', 'consum', 0.0238, 'lps'),
	(685188, 135, '2015-02-01 01:28:30.000000', 'consum', 0.0231, 'lps'),
	(685189, 135, '2015-02-01 01:28:31.000000', 'consum', 0.0228, 'lps'),
	(685190, 135, '2015-02-01 01:28:32.000000', 'consum', 0.0239, 'lps'),
	(685191, 135, '2015-02-01 01:28:33.000000', 'consum', 0.0250, 'lps'),
	(685192, 135, '2015-02-01 01:28:34.000000', 'consum', 0.0215, 'lps'),
	(685193, 135, '2015-02-01 01:28:35.000000', 'consum', 0.0223, 'lps'),
	(685194, 135, '2015-02-01 01:28:36.000000', 'consum', 0.0262, 'lps'),
	(685195, 135, '2015-02-01 01:28:37.000000', 'consum', 0.0218, 'lps'),
	(685196, 135, '2015-02-01 01:28:38.000000', 'consum', 0.0253, 'lps'),
	(685197, 135, '2015-02-01 01:28:39.000000', 'consum', 0.0242, 'lps'),
	(685198, 135, '2015-02-01 01:28:40.000000', 'consum', 0.0243, 'lps'),
	(685199, 135, '2015-02-01 01:28:41.000000', 'consum', 0.0226, 'lps'),
	(685200, 135, '2015-02-01 01:28:42.000000', 'consum', 0.0245, 'lps'),
	(685201, 135, '2015-02-01 01:28:43.000000', 'consum', 0.0233, 'lps'),
	(685202, 135, '2015-02-01 01:28:44.000000', 'consum', 0.0219, 'lps'),
	(685203, 135, '2015-02-01 01:28:45.000000', 'consum', 0.0240, 'lps'),
	(685204, 135, '2015-02-01 01:28:46.000000', 'consum', 0.0225, 'lps'),
	(685205, 135, '2015-02-01 01:28:47.000000', 'consum', 0.0251, 'lps'),
	(685206, 135, '2015-02-01 01:28:48.000000', 'consum', 0.0262, 'lps'),
	(685207, 135, '2015-02-01 01:28:49.000000', 'consum', 0.0242, 'lps'),
	(685208, 135, '2015-02-01 01:28:50.000000', 'consum', 0.0215, 'lps'),
	(685209, 135, '2015-02-01 01:28:51.000000', 'consum', 0.0245, 'lps'),
	(685210, 135, '2015-02-01 01:28:52.000000', 'consum', 0.0211, 'lps'),
	(685211, 135, '2015-02-01 01:28:53.000000', 'consum', 0.0219, 'lps'),
	(685212, 135, '2015-02-01 01:28:54.000000', 'consum', 0.0252, 'lps'),
	(685213, 135, '2015-02-01 01:28:55.000000', 'consum', 0.0233, 'lps'),
	(685214, 135, '2015-02-01 01:28:56.000000', 'consum', 0.0252, 'lps'),
	(685215, 135, '2015-02-01 01:28:57.000000', 'consum', 0.0247, 'lps'),
	(685216, 135, '2015-02-01 01:28:58.000000', 'consum', 0.0215, 'lps'),
	(685217, 135, '2015-02-01 01:28:59.000000', 'consum', 0.0229, 'lps'),
	(685218, 135, '2015-02-01 01:29:00.000000', 'consum', 0.0241, 'lps'),
	(685219, 135, '2015-02-01 01:29:01.000000', 'consum', 0.0253, 'lps'),
	(685220, 135, '2015-02-01 01:29:02.000000', 'consum', 0.0227, 'lps'),
	(685221, 135, '2015-02-01 01:29:03.000000', 'consum', 0.0218, 'lps'),
	(685222, 135, '2015-02-01 01:29:04.000000', 'consum', 0.0255, 'lps'),
	(685223, 135, '2015-02-01 01:29:05.000000', 'consum', 0.0253, 'lps'),
	(685224, 135, '2015-02-01 01:29:06.000000', 'consum', 0.0237, 'lps'),
	(685225, 135, '2015-02-01 01:29:07.000000', 'consum', 0.0214, 'lps'),
	(685226, 135, '2015-02-01 01:29:08.000000', 'consum', 0.0258, 'lps'),
	(685227, 135, '2015-02-01 01:29:09.000000', 'consum', 0.0226, 'lps'),
	(685228, 135, '2015-02-01 01:29:10.000000', 'consum', 0.0254, 'lps'),
	(685229, 135, '2015-02-01 01:29:11.000000', 'consum', 0.0221, 'lps'),
	(685230, 135, '2015-02-01 01:29:12.000000', 'consum', 0.0239, 'lps'),
	(685231, 135, '2015-02-01 01:29:13.000000', 'consum', 0.0219, 'lps'),
	(685232, 135, '2015-02-01 01:29:14.000000', 'consum', 0.0218, 'lps'),
	(685233, 135, '2015-02-01 01:29:15.000000', 'consum', 0.0227, 'lps'),
	(685234, 135, '2015-02-01 01:29:16.000000', 'consum', 0.0218, 'lps'),
	(685235, 135, '2015-02-01 01:29:17.000000', 'consum', 0.0251, 'lps'),
	(685236, 135, '2015-02-01 01:29:18.000000', 'consum', 0.0235, 'lps'),
	(685237, 135, '2015-02-01 01:29:19.000000', 'consum', 0.0211, 'lps'),
	(685238, 135, '2015-02-01 01:29:20.000000', 'consum', 0.0245, 'lps'),
	(685239, 135, '2015-02-01 01:29:21.000000', 'consum', 0.0226, 'lps'),
	(685240, 135, '2015-02-01 01:29:22.000000', 'consum', 0.0239, 'lps'),
	(685241, 135, '2015-02-01 01:29:23.000000', 'consum', 0.0253, 'lps'),
	(685242, 135, '2015-02-01 01:29:24.000000', 'consum', 0.0231, 'lps'),
	(685243, 135, '2015-02-01 01:29:25.000000', 'consum', 0.0242, 'lps'),
	(685244, 135, '2015-02-01 01:29:26.000000', 'consum', 0.0252, 'lps'),
	(685245, 135, '2015-02-01 01:29:27.000000', 'consum', 0.0219, 'lps'),
	(685246, 135, '2015-02-01 01:29:28.000000', 'consum', 0.0237, 'lps'),
	(685247, 135, '2015-02-01 01:29:29.000000', 'consum', 0.0213, 'lps'),
	(685248, 135, '2015-02-01 01:29:30.000000', 'consum', 0.0251, 'lps'),
	(685249, 135, '2015-02-01 01:29:31.000000', 'consum', 0.0246, 'lps'),
	(685250, 135, '2015-02-01 01:29:32.000000', 'consum', 0.0213, 'lps'),
	(685251, 135, '2015-02-01 01:29:33.000000', 'consum', 0.0225, 'lps'),
	(685252, 135, '2015-02-01 01:29:34.000000', 'consum', 0.0223, 'lps'),
	(685253, 135, '2015-02-01 01:29:35.000000', 'consum', 0.0232, 'lps'),
	(685254, 135, '2015-02-01 01:29:36.000000', 'consum', 0.0229, 'lps'),
	(685255, 135, '2015-02-01 01:29:37.000000', 'consum', 0.0239, 'lps'),
	(685256, 135, '2015-02-01 01:29:38.000000', 'consum', 0.0243, 'lps'),
	(685257, 135, '2015-02-01 01:29:39.000000', 'consum', 0.0239, 'lps'),
	(685258, 135, '2015-02-01 01:29:40.000000', 'consum', 0.0253, 'lps'),
	(685259, 135, '2015-02-01 01:29:41.000000', 'consum', 0.0234, 'lps'),
	(685260, 135, '2015-02-01 01:29:42.000000', 'consum', 0.0256, 'lps'),
	(685261, 135, '2015-02-01 01:29:43.000000', 'consum', 0.0260, 'lps'),
	(685262, 135, '2015-02-01 01:29:44.000000', 'consum', 0.0216, 'lps'),
	(685263, 135, '2015-02-01 01:29:45.000000', 'consum', 0.0250, 'lps'),
	(685264, 135, '2015-02-01 01:29:46.000000', 'consum', 0.0233, 'lps'),
	(685265, 135, '2015-02-01 01:29:47.000000', 'consum', 0.0259, 'lps'),
	(685266, 135, '2015-02-01 01:29:48.000000', 'consum', 0.0226, 'lps'),
	(685267, 135, '2015-02-01 01:29:49.000000', 'consum', 0.0251, 'lps'),
	(685268, 135, '2015-02-01 01:29:50.000000', 'consum', 0.0259, 'lps'),
	(685269, 135, '2015-02-01 01:29:51.000000', 'consum', 0.0229, 'lps'),
	(685270, 135, '2015-02-01 01:29:52.000000', 'consum', 0.0210, 'lps'),
	(685271, 135, '2015-02-01 01:29:53.000000', 'consum', 0.0261, 'lps'),
	(685272, 135, '2015-02-01 01:29:54.000000', 'consum', 0.0253, 'lps'),
	(685273, 135, '2015-02-01 01:29:55.000000', 'consum', 0.0218, 'lps'),
	(685274, 135, '2015-02-01 01:29:56.000000', 'consum', 0.0230, 'lps'),
	(685275, 135, '2015-02-01 01:29:57.000000', 'consum', 0.0232, 'lps'),
	(685276, 135, '2015-02-01 01:29:58.000000', 'consum', 0.0260, 'lps'),
	(685277, 135, '2015-02-01 01:29:59.000000', 'consum', 0.0238, 'lps'),
	(685278, 135, '2015-02-01 01:30:00.000000', 'consum', 0.0251, 'lps'),
	(685279, 135, '2015-02-01 01:30:01.000000', 'consum', 0.0228, 'lps'),
	(685280, 135, '2015-02-01 01:30:02.000000', 'consum', 0.0229, 'lps'),
	(685281, 135, '2015-02-01 01:30:03.000000', 'consum', 0.0252, 'lps'),
	(685282, 135, '2015-02-01 01:30:04.000000', 'consum', 0.0259, 'lps'),
	(685283, 135, '2015-02-01 01:30:05.000000', 'consum', 0.0221, 'lps'),
	(685284, 135, '2015-02-01 01:30:06.000000', 'consum', 0.0227, 'lps'),
	(685285, 135, '2015-02-01 01:30:07.000000', 'consum', 0.0262, 'lps'),
	(685286, 135, '2015-02-01 01:30:08.000000', 'consum', 0.0258, 'lps'),
	(685287, 135, '2015-02-01 01:30:09.000000', 'consum', 0.0243, 'lps'),
	(685288, 135, '2015-02-01 01:30:10.000000', 'consum', 0.0231, 'lps'),
	(685289, 135, '2015-02-01 01:30:11.000000', 'consum', 0.0215, 'lps'),
	(685290, 135, '2015-02-01 01:30:12.000000', 'consum', 0.0227, 'lps'),
	(685291, 135, '2015-02-01 01:30:13.000000', 'consum', 0.0229, 'lps'),
	(685292, 135, '2015-02-01 01:30:14.000000', 'consum', 0.0255, 'lps'),
	(685293, 135, '2015-02-01 01:30:15.000000', 'consum', 0.0217, 'lps'),
	(685294, 135, '2015-02-01 01:30:16.000000', 'consum', 0.0219, 'lps'),
	(685295, 135, '2015-02-01 01:30:17.000000', 'consum', 0.0234, 'lps'),
	(685296, 135, '2015-02-01 01:30:18.000000', 'consum', 0.0248, 'lps'),
	(685297, 135, '2015-02-01 01:30:19.000000', 'consum', 0.0224, 'lps'),
	(685298, 135, '2015-02-01 01:30:20.000000', 'consum', 0.0219, 'lps'),
	(685299, 135, '2015-02-01 01:30:21.000000', 'consum', 0.0216, 'lps'),
	(685300, 135, '2015-02-01 01:30:22.000000', 'consum', 0.0211, 'lps'),
	(685301, 135, '2015-02-01 01:30:23.000000', 'consum', 0.0253, 'lps'),
	(685302, 135, '2015-02-01 01:30:24.000000', 'consum', 0.0261, 'lps'),
	(685303, 135, '2015-02-01 01:30:25.000000', 'consum', 0.0230, 'lps'),
	(685304, 135, '2015-02-01 01:30:26.000000', 'consum', 0.0213, 'lps'),
	(685305, 135, '2015-02-01 01:30:27.000000', 'consum', 0.0217, 'lps'),
	(685306, 135, '2015-02-01 01:30:28.000000', 'consum', 0.0236, 'lps'),
	(685307, 135, '2015-02-01 01:30:29.000000', 'consum', 0.0212, 'lps'),
	(685308, 135, '2015-02-01 01:30:30.000000', 'consum', 0.0250, 'lps'),
	(685309, 135, '2015-02-01 01:30:31.000000', 'consum', 0.0246, 'lps'),
	(685310, 135, '2015-02-01 01:30:32.000000', 'consum', 0.0216, 'lps'),
	(685311, 135, '2015-02-01 01:30:33.000000', 'consum', 0.0238, 'lps'),
	(685312, 135, '2015-02-01 01:30:34.000000', 'consum', 0.0226, 'lps'),
	(685313, 135, '2015-02-01 01:30:35.000000', 'consum', 0.0260, 'lps'),
	(685314, 135, '2015-02-01 01:30:36.000000', 'consum', 0.0253, 'lps'),
	(685315, 135, '2015-02-01 01:30:37.000000', 'consum', 0.0221, 'lps'),
	(685316, 135, '2015-02-01 01:30:38.000000', 'consum', 0.0246, 'lps'),
	(685317, 135, '2015-02-01 01:30:39.000000', 'consum', 0.0249, 'lps'),
	(685318, 135, '2015-02-01 01:30:40.000000', 'consum', 0.0247, 'lps'),
	(685319, 135, '2015-02-01 01:30:41.000000', 'consum', 0.0222, 'lps'),
	(685320, 135, '2015-02-01 01:30:42.000000', 'consum', 0.0215, 'lps'),
	(685321, 135, '2015-02-01 01:30:43.000000', 'consum', 0.0252, 'lps'),
	(685322, 135, '2015-02-01 01:30:44.000000', 'consum', 0.0246, 'lps'),
	(685323, 135, '2015-02-01 01:30:45.000000', 'consum', 0.0210, 'lps'),
	(685324, 135, '2015-02-01 01:30:46.000000', 'consum', 0.0262, 'lps'),
	(685325, 135, '2015-02-01 01:30:47.000000', 'consum', 0.0258, 'lps'),
	(685326, 135, '2015-02-01 01:30:48.000000', 'consum', 0.0242, 'lps'),
	(685327, 135, '2015-02-01 01:30:49.000000', 'consum', 0.0225, 'lps'),
	(685328, 135, '2015-02-01 01:30:50.000000', 'consum', 0.0244, 'lps'),
	(685329, 135, '2015-02-01 01:30:51.000000', 'consum', 0.0227, 'lps'),
	(685330, 135, '2015-02-01 01:30:52.000000', 'consum', 0.0250, 'lps'),
	(685331, 135, '2015-02-01 01:30:53.000000', 'consum', 0.0251, 'lps'),
	(685332, 135, '2015-02-01 01:30:54.000000', 'consum', 0.0245, 'lps'),
	(685333, 135, '2015-02-01 01:30:55.000000', 'consum', 0.0260, 'lps'),
	(685334, 135, '2015-02-01 01:30:56.000000', 'consum', 0.0251, 'lps'),
	(685335, 135, '2015-02-01 01:30:57.000000', 'consum', 0.0211, 'lps'),
	(685336, 135, '2015-02-01 01:30:58.000000', 'consum', 0.0252, 'lps'),
	(685337, 135, '2015-02-01 01:30:59.000000', 'consum', 0.0260, 'lps'),
	(685338, 135, '2015-02-01 01:31:00.000000', 'consum', 0.0226, 'lps'),
	(685339, 135, '2015-02-01 01:31:01.000000', 'consum', 0.0247, 'lps'),
	(685340, 135, '2015-02-01 01:31:02.000000', 'consum', 0.0242, 'lps'),
	(685341, 135, '2015-02-01 01:31:03.000000', 'consum', 0.0259, 'lps'),
	(685342, 135, '2015-02-01 01:31:04.000000', 'consum', 0.0256, 'lps'),
	(685343, 135, '2015-02-01 01:31:05.000000', 'consum', 0.0239, 'lps'),
	(685344, 135, '2015-02-01 01:31:06.000000', 'consum', 0.0216, 'lps'),
	(685345, 135, '2015-02-01 01:31:07.000000', 'consum', 0.0259, 'lps'),
	(685346, 135, '2015-02-01 01:31:08.000000', 'consum', 0.0228, 'lps'),
	(685347, 135, '2015-02-01 01:31:09.000000', 'consum', 0.0261, 'lps'),
	(685348, 135, '2015-02-01 01:31:10.000000', 'consum', 0.0249, 'lps'),
	(685349, 135, '2015-02-01 01:31:11.000000', 'consum', 0.0252, 'lps'),
	(685350, 135, '2015-02-01 01:31:12.000000', 'consum', 0.0253, 'lps'),
	(685351, 135, '2015-02-01 01:31:13.000000', 'consum', 0.0246, 'lps'),
	(685352, 135, '2015-02-01 01:31:14.000000', 'consum', 0.0262, 'lps'),
	(685353, 135, '2015-02-01 01:31:15.000000', 'consum', 0.0257, 'lps'),
	(685354, 135, '2015-02-01 01:31:16.000000', 'consum', 0.0235, 'lps'),
	(685355, 135, '2015-02-01 01:31:17.000000', 'consum', 0.0247, 'lps'),
	(685356, 135, '2015-02-01 01:31:18.000000', 'consum', 0.0217, 'lps'),
	(685357, 135, '2015-02-01 01:31:19.000000', 'consum', 0.0238, 'lps'),
	(685358, 135, '2015-02-01 01:31:20.000000', 'consum', 0.0224, 'lps'),
	(685359, 135, '2015-02-01 01:31:21.000000', 'consum', 0.0250, 'lps'),
	(685360, 135, '2015-02-01 01:31:22.000000', 'consum', 0.0210, 'lps'),
	(685361, 135, '2015-02-01 01:31:23.000000', 'consum', 0.0248, 'lps'),
	(685362, 135, '2015-02-01 01:31:24.000000', 'consum', 0.0244, 'lps'),
	(685363, 135, '2015-02-01 01:31:25.000000', 'consum', 0.0210, 'lps'),
	(685364, 135, '2015-02-01 01:31:26.000000', 'consum', 0.0217, 'lps'),
	(685365, 135, '2015-02-01 01:31:27.000000', 'consum', 0.0246, 'lps'),
	(685366, 135, '2015-02-01 01:31:28.000000', 'consum', 0.0212, 'lps'),
	(685367, 135, '2015-02-01 01:31:29.000000', 'consum', 0.0216, 'lps'),
	(685368, 135, '2015-02-01 01:31:30.000000', 'consum', 0.0235, 'lps'),
	(685369, 135, '2015-02-01 01:31:31.000000', 'consum', 0.0212, 'lps'),
	(685370, 135, '2015-02-01 01:31:32.000000', 'consum', 0.0252, 'lps'),
	(685371, 135, '2015-02-01 01:31:33.000000', 'consum', 0.0256, 'lps'),
	(685372, 135, '2015-02-01 01:31:34.000000', 'consum', 0.0259, 'lps'),
	(685373, 135, '2015-02-01 01:31:35.000000', 'consum', 0.0213, 'lps'),
	(685374, 135, '2015-02-01 01:31:36.000000', 'consum', 0.0238, 'lps'),
	(685375, 135, '2015-02-01 01:31:37.000000', 'consum', 0.0234, 'lps'),
	(685376, 135, '2015-02-01 01:31:38.000000', 'consum', 0.0247, 'lps'),
	(685377, 135, '2015-02-01 01:31:39.000000', 'consum', 0.0219, 'lps'),
	(685378, 135, '2015-02-01 01:31:40.000000', 'consum', 0.0250, 'lps'),
	(685379, 135, '2015-02-01 01:31:41.000000', 'consum', 0.0226, 'lps'),
	(685380, 135, '2015-02-01 01:31:42.000000', 'consum', 0.0223, 'lps'),
	(685381, 135, '2015-02-01 01:31:43.000000', 'consum', 0.0228, 'lps'),
	(685382, 135, '2015-02-01 01:31:44.000000', 'consum', 0.0261, 'lps'),
	(685383, 135, '2015-02-01 01:31:45.000000', 'consum', 0.0250, 'lps'),
	(685384, 135, '2015-02-01 01:31:46.000000', 'consum', 0.0261, 'lps'),
	(685385, 135, '2015-02-01 01:31:47.000000', 'consum', 0.0237, 'lps'),
	(685386, 135, '2015-02-01 01:31:48.000000', 'consum', 0.0248, 'lps'),
	(685387, 135, '2015-02-01 01:31:49.000000', 'consum', 0.0211, 'lps'),
	(685388, 135, '2015-02-01 01:31:50.000000', 'consum', 0.0262, 'lps'),
	(685389, 135, '2015-02-01 01:31:51.000000', 'consum', 0.0257, 'lps'),
	(685390, 135, '2015-02-01 01:31:52.000000', 'consum', 0.0236, 'lps'),
	(685391, 135, '2015-02-01 01:31:53.000000', 'consum', 0.0253, 'lps'),
	(685392, 135, '2015-02-01 01:31:54.000000', 'consum', 0.0239, 'lps'),
	(685393, 135, '2015-02-01 01:31:55.000000', 'consum', 0.0227, 'lps'),
	(685394, 135, '2015-02-01 01:31:56.000000', 'consum', 0.0211, 'lps'),
	(685395, 135, '2015-02-01 01:31:57.000000', 'consum', 0.0214, 'lps'),
	(685396, 135, '2015-02-01 01:31:58.000000', 'consum', 0.0230, 'lps'),
	(685397, 135, '2015-02-01 01:31:59.000000', 'consum', 0.0243, 'lps'),
	(685398, 135, '2015-02-01 01:32:00.000000', 'consum', 0.0262, 'lps'),
	(685399, 135, '2015-02-01 01:32:01.000000', 'consum', 0.0215, 'lps'),
	(685400, 135, '2015-02-01 01:32:02.000000', 'consum', 0.0238, 'lps'),
	(685401, 135, '2015-02-01 01:32:03.000000', 'consum', 0.0228, 'lps'),
	(685402, 135, '2015-02-01 01:32:04.000000', 'consum', 0.0216, 'lps'),
	(685403, 135, '2015-02-01 01:32:05.000000', 'consum', 0.0242, 'lps'),
	(685404, 135, '2015-02-01 01:32:06.000000', 'consum', 0.0246, 'lps'),
	(685405, 135, '2015-02-01 01:32:07.000000', 'consum', 0.0241, 'lps'),
	(685406, 135, '2015-02-01 01:32:08.000000', 'consum', 0.0260, 'lps'),
	(685407, 135, '2015-02-01 01:32:09.000000', 'consum', 0.0258, 'lps'),
	(685408, 135, '2015-02-01 01:32:10.000000', 'consum', 0.0250, 'lps'),
	(685409, 135, '2015-02-01 01:32:11.000000', 'consum', 0.0214, 'lps'),
	(685410, 135, '2015-02-01 01:32:12.000000', 'consum', 0.0216, 'lps'),
	(685411, 135, '2015-02-01 01:32:13.000000', 'consum', 0.0227, 'lps'),
	(685412, 135, '2015-02-01 01:32:14.000000', 'consum', 0.0225, 'lps'),
	(685413, 135, '2015-02-01 01:32:15.000000', 'consum', 0.0237, 'lps'),
	(685414, 135, '2015-02-01 01:32:16.000000', 'consum', 0.0244, 'lps'),
	(685415, 135, '2015-02-01 01:32:17.000000', 'consum', 0.0248, 'lps'),
	(685416, 135, '2015-02-01 01:32:18.000000', 'consum', 0.0247, 'lps'),
	(685417, 135, '2015-02-01 01:32:19.000000', 'consum', 0.0226, 'lps'),
	(685418, 135, '2015-02-01 01:32:20.000000', 'consum', 0.0233, 'lps'),
	(685419, 135, '2015-02-01 01:32:21.000000', 'consum', 0.0226, 'lps'),
	(685420, 135, '2015-02-01 01:32:22.000000', 'consum', 0.0220, 'lps'),
	(685421, 135, '2015-02-01 01:32:23.000000', 'consum', 0.0214, 'lps'),
	(685422, 135, '2015-02-01 01:32:24.000000', 'consum', 0.0254, 'lps'),
	(685423, 135, '2015-02-01 01:32:25.000000', 'consum', 0.0259, 'lps'),
	(685424, 135, '2015-02-01 01:32:26.000000', 'consum', 0.0218, 'lps'),
	(685425, 135, '2015-02-01 01:32:27.000000', 'consum', 0.0260, 'lps'),
	(685426, 135, '2015-02-01 01:32:28.000000', 'consum', 0.0228, 'lps'),
	(685427, 135, '2015-02-01 01:32:29.000000', 'consum', 0.0254, 'lps'),
	(685428, 135, '2015-02-01 01:32:30.000000', 'consum', 0.0219, 'lps'),
	(685429, 135, '2015-02-01 01:32:31.000000', 'consum', 0.0227, 'lps'),
	(685430, 135, '2015-02-01 01:32:32.000000', 'consum', 0.0218, 'lps'),
	(685431, 135, '2015-02-01 01:32:33.000000', 'consum', 0.0252, 'lps'),
	(685432, 135, '2015-02-01 01:32:34.000000', 'consum', 0.0237, 'lps'),
	(685433, 135, '2015-02-01 01:32:35.000000', 'consum', 0.0220, 'lps'),
	(685434, 135, '2015-02-01 01:32:36.000000', 'consum', 0.0230, 'lps'),
	(685435, 135, '2015-02-01 01:32:37.000000', 'consum', 0.0230, 'lps'),
	(685436, 135, '2015-02-01 01:32:38.000000', 'consum', 0.0251, 'lps'),
	(685437, 135, '2015-02-01 01:32:39.000000', 'consum', 0.0247, 'lps'),
	(685438, 135, '2015-02-01 01:32:40.000000', 'consum', 0.0222, 'lps'),
	(685439, 135, '2015-02-01 01:32:41.000000', 'consum', 0.0210, 'lps'),
	(685440, 135, '2015-02-01 01:32:42.000000', 'consum', 0.0229, 'lps'),
	(685441, 135, '2015-02-01 01:32:43.000000', 'consum', 0.0251, 'lps'),
	(685442, 135, '2015-02-01 01:32:44.000000', 'consum', 0.0255, 'lps'),
	(685443, 135, '2015-02-01 01:32:45.000000', 'consum', 0.0257, 'lps'),
	(685444, 135, '2015-02-01 01:32:46.000000', 'consum', 0.0257, 'lps'),
	(685445, 135, '2015-02-01 01:32:47.000000', 'consum', 0.0251, 'lps'),
	(685446, 135, '2015-02-01 01:32:48.000000', 'consum', 0.0221, 'lps'),
	(685447, 135, '2015-02-01 01:32:49.000000', 'consum', 0.0249, 'lps'),
	(685448, 135, '2015-02-01 01:32:50.000000', 'consum', 0.0216, 'lps'),
	(685449, 135, '2015-02-01 01:32:51.000000', 'consum', 0.0226, 'lps'),
	(685450, 135, '2015-02-01 01:32:52.000000', 'consum', 0.0220, 'lps'),
	(685451, 135, '2015-02-01 01:32:53.000000', 'consum', 0.0215, 'lps'),
	(685452, 135, '2015-02-01 01:32:54.000000', 'consum', 0.0258, 'lps'),
	(685453, 135, '2015-02-01 01:32:55.000000', 'consum', 0.0222, 'lps'),
	(685454, 135, '2015-02-01 01:32:56.000000', 'consum', 0.0234, 'lps'),
	(685455, 135, '2015-02-01 01:32:57.000000', 'consum', 0.0242, 'lps'),
	(685456, 135, '2015-02-01 01:32:58.000000', 'consum', 0.0244, 'lps'),
	(685457, 135, '2015-02-01 01:32:59.000000', 'consum', 0.0231, 'lps'),
	(685458, 135, '2015-02-01 01:33:00.000000', 'consum', 0.0214, 'lps'),
	(685459, 135, '2015-02-01 01:33:01.000000', 'consum', 0.0222, 'lps'),
	(685460, 135, '2015-02-01 01:33:02.000000', 'consum', 0.0259, 'lps'),
	(685461, 135, '2015-02-01 01:33:03.000000', 'consum', 0.0260, 'lps'),
	(685462, 135, '2015-02-01 01:33:04.000000', 'consum', 0.0262, 'lps'),
	(685463, 135, '2015-02-01 01:33:05.000000', 'consum', 0.0212, 'lps'),
	(685464, 135, '2015-02-01 01:33:06.000000', 'consum', 0.0224, 'lps'),
	(685465, 135, '2015-02-01 01:33:07.000000', 'consum', 0.0222, 'lps'),
	(685466, 135, '2015-02-01 01:33:08.000000', 'consum', 0.0229, 'lps'),
	(685467, 135, '2015-02-01 01:33:09.000000', 'consum', 0.0218, 'lps'),
	(685468, 135, '2015-02-01 01:33:10.000000', 'consum', 0.0243, 'lps'),
	(685469, 135, '2015-02-01 01:33:11.000000', 'consum', 0.0247, 'lps'),
	(685470, 135, '2015-02-01 01:33:12.000000', 'consum', 0.0245, 'lps'),
	(685471, 135, '2015-02-01 01:33:13.000000', 'consum', 0.0219, 'lps'),
	(685472, 135, '2015-02-01 01:33:14.000000', 'consum', 0.0260, 'lps'),
	(685473, 135, '2015-02-01 01:33:15.000000', 'consum', 0.0218, 'lps'),
	(685474, 135, '2015-02-01 01:33:16.000000', 'consum', 0.0262, 'lps'),
	(685475, 135, '2015-02-01 01:33:17.000000', 'consum', 0.0232, 'lps'),
	(685476, 135, '2015-02-01 01:33:18.000000', 'consum', 0.0220, 'lps'),
	(685477, 135, '2015-02-01 01:33:19.000000', 'consum', 0.0246, 'lps'),
	(685478, 135, '2015-02-01 01:33:20.000000', 'consum', 0.0257, 'lps'),
	(685479, 135, '2015-02-01 01:33:21.000000', 'consum', 0.0230, 'lps'),
	(685480, 135, '2015-02-01 01:33:22.000000', 'consum', 0.0220, 'lps'),
	(685481, 135, '2015-02-01 01:33:23.000000', 'consum', 0.0257, 'lps'),
	(685482, 135, '2015-02-01 01:33:24.000000', 'consum', 0.0256, 'lps'),
	(685483, 135, '2015-02-01 01:33:25.000000', 'consum', 0.0245, 'lps'),
	(685484, 135, '2015-02-01 01:33:26.000000', 'consum', 0.0248, 'lps'),
	(685485, 135, '2015-02-01 01:33:27.000000', 'consum', 0.0242, 'lps'),
	(685486, 135, '2015-02-01 01:33:28.000000', 'consum', 0.0258, 'lps'),
	(685487, 135, '2015-02-01 01:33:29.000000', 'consum', 0.0247, 'lps'),
	(685488, 135, '2015-02-01 01:33:30.000000', 'consum', 0.0251, 'lps'),
	(685489, 135, '2015-02-01 01:33:31.000000', 'consum', 0.0251, 'lps'),
	(685490, 135, '2015-02-01 01:33:32.000000', 'consum', 0.0241, 'lps'),
	(685491, 135, '2015-02-01 01:33:33.000000', 'consum', 0.0243, 'lps'),
	(685492, 135, '2015-02-01 01:33:34.000000', 'consum', 0.0228, 'lps'),
	(685493, 135, '2015-02-01 01:33:35.000000', 'consum', 0.0257, 'lps'),
	(685494, 135, '2015-02-01 01:33:36.000000', 'consum', 0.0230, 'lps'),
	(685495, 135, '2015-02-01 01:33:37.000000', 'consum', 0.0222, 'lps'),
	(685496, 135, '2015-02-01 01:33:38.000000', 'consum', 0.0211, 'lps'),
	(685497, 135, '2015-02-01 01:33:39.000000', 'consum', 0.0233, 'lps'),
	(685498, 135, '2015-02-01 01:33:40.000000', 'consum', 0.0216, 'lps'),
	(685499, 135, '2015-02-01 01:33:41.000000', 'consum', 0.0224, 'lps'),
	(685500, 135, '2015-02-01 01:33:42.000000', 'consum', 0.0211, 'lps'),
	(685501, 135, '2015-02-01 01:33:43.000000', 'consum', 0.0227, 'lps'),
	(685502, 135, '2015-02-01 01:33:44.000000', 'consum', 0.0238, 'lps'),
	(685503, 135, '2015-02-01 01:33:45.000000', 'consum', 0.0249, 'lps'),
	(685504, 135, '2015-02-01 01:33:46.000000', 'consum', 0.0214, 'lps'),
	(685505, 135, '2015-02-01 01:33:47.000000', 'consum', 0.0219, 'lps'),
	(685506, 135, '2015-02-01 01:33:48.000000', 'consum', 0.0244, 'lps'),
	(685507, 135, '2015-02-01 01:33:49.000000', 'consum', 0.0247, 'lps'),
	(685508, 135, '2015-02-01 01:33:50.000000', 'consum', 0.0242, 'lps'),
	(685509, 135, '2015-02-01 01:33:51.000000', 'consum', 0.0259, 'lps'),
	(685510, 135, '2015-02-01 01:33:52.000000', 'consum', 0.0253, 'lps'),
	(685511, 135, '2015-02-01 01:33:53.000000', 'consum', 0.0226, 'lps'),
	(685512, 135, '2015-02-01 01:33:54.000000', 'consum', 0.0214, 'lps'),
	(685513, 135, '2015-02-01 01:33:55.000000', 'consum', 0.0235, 'lps'),
	(685514, 135, '2015-02-01 01:33:56.000000', 'consum', 0.0220, 'lps'),
	(685515, 135, '2015-02-01 01:33:57.000000', 'consum', 0.0235, 'lps'),
	(685516, 135, '2015-02-01 01:33:58.000000', 'consum', 0.0255, 'lps'),
	(685517, 135, '2015-02-01 01:33:59.000000', 'consum', 0.0253, 'lps'),
	(685518, 135, '2015-02-01 01:34:00.000000', 'consum', 0.0237, 'lps'),
	(685519, 135, '2015-02-01 01:34:01.000000', 'consum', 0.0219, 'lps'),
	(685520, 135, '2015-02-01 01:34:02.000000', 'consum', 0.0227, 'lps'),
	(685521, 135, '2015-02-01 01:34:03.000000', 'consum', 0.0215, 'lps'),
	(685522, 135, '2015-02-01 01:34:04.000000', 'consum', 0.0237, 'lps'),
	(685523, 135, '2015-02-01 01:34:05.000000', 'consum', 0.0227, 'lps'),
	(685524, 135, '2015-02-01 01:34:06.000000', 'consum', 0.0212, 'lps'),
	(685525, 135, '2015-02-01 01:34:07.000000', 'consum', 0.0225, 'lps'),
	(685526, 135, '2015-02-01 01:34:08.000000', 'consum', 0.0226, 'lps'),
	(685527, 135, '2015-02-01 01:34:09.000000', 'consum', 0.0243, 'lps'),
	(685528, 135, '2015-02-01 01:34:10.000000', 'consum', 0.0223, 'lps'),
	(685529, 135, '2015-02-01 01:34:11.000000', 'consum', 0.0229, 'lps'),
	(685530, 135, '2015-02-01 01:34:12.000000', 'consum', 0.0212, 'lps'),
	(685531, 135, '2015-02-01 01:34:13.000000', 'consum', 0.0218, 'lps'),
	(685532, 135, '2015-02-01 01:34:14.000000', 'consum', 0.0244, 'lps'),
	(685533, 135, '2015-02-01 01:34:15.000000', 'consum', 0.0249, 'lps'),
	(685534, 135, '2015-02-01 01:34:16.000000', 'consum', 0.0252, 'lps'),
	(685535, 135, '2015-02-01 01:34:17.000000', 'consum', 0.0250, 'lps'),
	(685536, 135, '2015-02-01 01:34:18.000000', 'consum', 0.0233, 'lps'),
	(685537, 135, '2015-02-01 01:34:19.000000', 'consum', 0.0259, 'lps'),
	(685538, 135, '2015-02-01 01:34:20.000000', 'consum', 0.0227, 'lps'),
	(685539, 135, '2015-02-01 01:34:21.000000', 'consum', 0.0256, 'lps'),
	(685540, 135, '2015-02-01 01:34:22.000000', 'consum', 0.0230, 'lps'),
	(685541, 135, '2015-02-01 01:34:23.000000', 'consum', 0.0226, 'lps'),
	(685542, 135, '2015-02-01 01:34:24.000000', 'consum', 0.0228, 'lps'),
	(685543, 135, '2015-02-01 01:34:25.000000', 'consum', 0.0254, 'lps'),
	(685544, 135, '2015-02-01 01:34:26.000000', 'consum', 0.0216, 'lps'),
	(685545, 135, '2015-02-01 01:34:27.000000', 'consum', 0.0214, 'lps'),
	(685546, 135, '2015-02-01 01:34:28.000000', 'consum', 0.0213, 'lps'),
	(685547, 135, '2015-02-01 01:34:29.000000', 'consum', 0.0214, 'lps'),
	(685548, 135, '2015-02-01 01:34:30.000000', 'consum', 0.0222, 'lps'),
	(685549, 135, '2015-02-01 01:34:31.000000', 'consum', 0.0258, 'lps'),
	(685550, 135, '2015-02-01 01:34:32.000000', 'consum', 0.0256, 'lps'),
	(685551, 135, '2015-02-01 01:34:33.000000', 'consum', 0.0245, 'lps'),
	(685552, 135, '2015-02-01 01:34:34.000000', 'consum', 0.0245, 'lps'),
	(685553, 135, '2015-02-01 01:34:35.000000', 'consum', 0.0229, 'lps'),
	(685554, 135, '2015-02-01 01:34:36.000000', 'consum', 0.0253, 'lps'),
	(685555, 135, '2015-02-01 01:34:37.000000', 'consum', 0.0262, 'lps'),
	(685556, 135, '2015-02-01 01:34:38.000000', 'consum', 0.0236, 'lps'),
	(685557, 135, '2015-02-01 01:34:39.000000', 'consum', 0.0239, 'lps'),
	(685558, 135, '2015-02-01 01:34:40.000000', 'consum', 0.0223, 'lps'),
	(685559, 135, '2015-02-01 01:34:41.000000', 'consum', 0.0242, 'lps'),
	(685560, 135, '2015-02-01 01:34:42.000000', 'consum', 0.0225, 'lps'),
	(685561, 135, '2015-02-01 01:34:43.000000', 'consum', 0.0244, 'lps'),
	(685562, 135, '2015-02-01 01:34:44.000000', 'consum', 0.0228, 'lps'),
	(685563, 135, '2015-02-01 01:34:45.000000', 'consum', 0.0253, 'lps'),
	(685564, 135, '2015-02-01 01:34:46.000000', 'consum', 0.0211, 'lps'),
	(685565, 135, '2015-02-01 01:34:47.000000', 'consum', 0.0246, 'lps'),
	(685566, 135, '2015-02-01 01:34:48.000000', 'consum', 0.0228, 'lps'),
	(685567, 135, '2015-02-01 01:34:49.000000', 'consum', 0.0244, 'lps'),
	(685568, 135, '2015-02-01 01:34:50.000000', 'consum', 0.0222, 'lps'),
	(685569, 135, '2015-02-01 01:34:51.000000', 'consum', 0.0220, 'lps'),
	(685570, 135, '2015-02-01 01:34:52.000000', 'consum', 0.0227, 'lps'),
	(685571, 135, '2015-02-01 01:34:53.000000', 'consum', 0.0211, 'lps'),
	(685572, 135, '2015-02-01 01:34:54.000000', 'consum', 0.0216, 'lps'),
	(685573, 135, '2015-02-01 01:34:55.000000', 'consum', 0.0241, 'lps'),
	(685574, 135, '2015-02-01 01:34:56.000000', 'consum', 0.0238, 'lps'),
	(685575, 135, '2015-02-01 01:34:57.000000', 'consum', 0.0261, 'lps'),
	(685576, 135, '2015-02-01 01:34:58.000000', 'consum', 0.0220, 'lps'),
	(685577, 135, '2015-02-01 01:34:59.000000', 'consum', 0.0214, 'lps'),
	(685578, 135, '2015-02-01 01:35:00.000000', 'consum', 0.0254, 'lps'),
	(685579, 135, '2015-02-01 01:35:01.000000', 'consum', 0.0258, 'lps'),
	(685580, 135, '2015-02-01 01:35:02.000000', 'consum', 0.0215, 'lps'),
	(685581, 135, '2015-02-01 01:35:03.000000', 'consum', 0.0251, 'lps'),
	(685582, 135, '2015-02-01 01:35:04.000000', 'consum', 0.0239, 'lps'),
	(685583, 135, '2015-02-01 01:35:05.000000', 'consum', 0.0234, 'lps'),
	(685584, 135, '2015-02-01 01:35:06.000000', 'consum', 0.0243, 'lps'),
	(685585, 135, '2015-02-01 01:35:07.000000', 'consum', 0.0249, 'lps'),
	(685586, 135, '2015-02-01 01:35:08.000000', 'consum', 0.0253, 'lps'),
	(685587, 135, '2015-02-01 01:35:09.000000', 'consum', 0.0256, 'lps'),
	(685588, 135, '2015-02-01 01:35:10.000000', 'consum', 0.0258, 'lps'),
	(685589, 135, '2015-02-01 01:35:11.000000', 'consum', 0.0260, 'lps'),
	(685590, 135, '2015-02-01 01:35:12.000000', 'consum', 0.0210, 'lps'),
	(685591, 135, '2015-02-01 01:35:13.000000', 'consum', 0.0221, 'lps'),
	(685592, 135, '2015-02-01 01:35:14.000000', 'consum', 0.0213, 'lps'),
	(685593, 135, '2015-02-01 01:35:15.000000', 'consum', 0.0243, 'lps'),
	(685594, 135, '2015-02-01 01:35:16.000000', 'consum', 0.0262, 'lps'),
	(685595, 135, '2015-02-01 01:35:17.000000', 'consum', 0.0214, 'lps'),
	(685596, 135, '2015-02-01 01:35:18.000000', 'consum', 0.0233, 'lps'),
	(685597, 135, '2015-02-01 01:35:19.000000', 'consum', 0.0262, 'lps'),
	(685598, 135, '2015-02-01 01:35:20.000000', 'consum', 0.0240, 'lps'),
	(685599, 135, '2015-02-01 01:35:21.000000', 'consum', 0.0256, 'lps'),
	(685600, 135, '2015-02-01 01:35:22.000000', 'consum', 0.0248, 'lps'),
	(685601, 135, '2015-02-01 01:35:23.000000', 'consum', 0.0262, 'lps'),
	(685602, 135, '2015-02-01 01:35:24.000000', 'consum', 0.0248, 'lps'),
	(685603, 135, '2015-02-01 01:35:25.000000', 'consum', 0.0245, 'lps'),
	(685604, 135, '2015-02-01 01:35:26.000000', 'consum', 0.0220, 'lps'),
	(685605, 135, '2015-02-01 01:35:27.000000', 'consum', 0.0261, 'lps'),
	(685606, 135, '2015-02-01 01:35:28.000000', 'consum', 0.0224, 'lps'),
	(685607, 136, '2015-02-01 00:00:00.000000', 'consum', 0.0213, 'lps'),
	(685608, 136, '2015-02-01 00:00:01.000000', 'consum', 0.0262, 'lps'),
	(685609, 136, '2015-02-01 00:00:02.000000', 'consum', 0.0267, 'lps'),
	(685610, 136, '2015-02-01 00:00:03.000000', 'consum', 0.0273, 'lps'),
	(685611, 136, '2015-02-01 00:00:04.000000', 'consum', 0.0224, 'lps'),
	(685612, 136, '2015-02-01 00:00:05.000000', 'consum', 0.0221, 'lps'),
	(685613, 136, '2015-02-01 00:00:06.000000', 'consum', 0.0222, 'lps'),
	(685614, 136, '2015-02-01 00:00:07.000000', 'consum', 0.0241, 'lps'),
	(685615, 136, '2015-02-01 00:00:08.000000', 'consum', 0.0263, 'lps'),
	(685616, 136, '2015-02-01 00:00:09.000000', 'consum', 0.0255, 'lps'),
	(685617, 136, '2015-02-01 00:00:10.000000', 'consum', 0.0273, 'lps'),
	(685618, 136, '2015-02-01 00:00:11.000000', 'consum', 0.0264, 'lps'),
	(685619, 136, '2015-02-01 00:00:12.000000', 'consum', 0.0225, 'lps'),
	(685620, 136, '2015-02-01 00:00:13.000000', 'consum', 0.0252, 'lps'),
	(685621, 136, '2015-02-01 00:00:14.000000', 'consum', 0.0246, 'lps'),
	(685622, 136, '2015-02-01 00:00:15.000000', 'consum', 0.0264, 'lps'),
	(685623, 136, '2015-02-01 00:00:16.000000', 'consum', 0.0243, 'lps'),
	(685624, 136, '2015-02-01 00:00:17.000000', 'consum', 0.0212, 'lps'),
	(685625, 136, '2015-02-01 00:00:18.000000', 'consum', 0.0252, 'lps'),
	(685626, 136, '2015-02-01 00:00:19.000000', 'consum', 0.0220, 'lps'),
	(685627, 136, '2015-02-01 00:00:20.000000', 'consum', 0.0265, 'lps'),
	(685628, 136, '2015-02-01 00:00:21.000000', 'consum', 0.0262, 'lps'),
	(685629, 136, '2015-02-01 00:00:22.000000', 'consum', 0.0239, 'lps'),
	(685630, 136, '2015-02-01 00:00:23.000000', 'consum', 0.0263, 'lps'),
	(685631, 136, '2015-02-01 00:00:24.000000', 'consum', 0.0261, 'lps'),
	(685632, 136, '2015-02-01 00:00:25.000000', 'consum', 0.0240, 'lps'),
	(685633, 136, '2015-02-01 00:00:26.000000', 'consum', 0.0274, 'lps'),
	(685634, 136, '2015-02-01 00:00:27.000000', 'consum', 0.0246, 'lps'),
	(685635, 136, '2015-02-01 00:00:28.000000', 'consum', 0.0261, 'lps'),
	(685636, 136, '2015-02-01 00:00:29.000000', 'consum', 0.0228, 'lps'),
	(685637, 136, '2015-02-01 00:00:30.000000', 'consum', 0.0211, 'lps'),
	(685638, 136, '2015-02-01 00:00:31.000000', 'consum', 0.0227, 'lps'),
	(685639, 136, '2015-02-01 00:00:32.000000', 'consum', 0.0229, 'lps'),
	(685640, 136, '2015-02-01 00:00:33.000000', 'consum', 0.0253, 'lps'),
	(685641, 136, '2015-02-01 00:00:34.000000', 'consum', 0.0238, 'lps'),
	(685642, 136, '2015-02-01 00:00:35.000000', 'consum', 0.0224, 'lps'),
	(685643, 136, '2015-02-01 00:00:36.000000', 'consum', 0.0261, 'lps'),
	(685644, 136, '2015-02-01 00:00:37.000000', 'consum', 0.0228, 'lps'),
	(685645, 136, '2015-02-01 00:00:38.000000', 'consum', 0.0211, 'lps'),
	(685646, 136, '2015-02-01 00:00:39.000000', 'consum', 0.0228, 'lps'),
	(685647, 136, '2015-02-01 00:00:40.000000', 'consum', 0.0231, 'lps'),
	(685648, 136, '2015-02-01 00:00:41.000000', 'consum', 0.0264, 'lps'),
	(685649, 136, '2015-02-01 00:00:42.000000', 'consum', 0.0222, 'lps'),
	(685650, 136, '2015-02-01 00:00:43.000000', 'consum', 0.0240, 'lps'),
	(685651, 136, '2015-02-01 00:00:44.000000', 'consum', 0.0257, 'lps'),
	(685652, 136, '2015-02-01 00:00:45.000000', 'consum', 0.0227, 'lps'),
	(685653, 136, '2015-02-01 00:00:46.000000', 'consum', 0.0218, 'lps'),
	(685654, 136, '2015-02-01 00:00:47.000000', 'consum', 0.0266, 'lps'),
	(685655, 136, '2015-02-01 00:00:48.000000', 'consum', 0.0270, 'lps'),
	(685656, 136, '2015-02-01 00:00:49.000000', 'consum', 0.0212, 'lps'),
	(685657, 136, '2015-02-01 00:00:50.000000', 'consum', 0.0234, 'lps'),
	(685658, 136, '2015-02-01 00:00:51.000000', 'consum', 0.0262, 'lps'),
	(685659, 136, '2015-02-01 00:00:52.000000', 'consum', 0.0268, 'lps'),
	(685660, 136, '2015-02-01 00:00:53.000000', 'consum', 0.0216, 'lps'),
	(685661, 136, '2015-02-01 00:00:54.000000', 'consum', 0.0260, 'lps'),
	(685662, 136, '2015-02-01 00:00:55.000000', 'consum', 0.0248, 'lps'),
	(685663, 136, '2015-02-01 00:00:56.000000', 'consum', 0.0250, 'lps'),
	(685664, 136, '2015-02-01 00:00:57.000000', 'consum', 0.0231, 'lps'),
	(685665, 136, '2015-02-01 00:00:58.000000', 'consum', 0.0260, 'lps'),
	(685666, 136, '2015-02-01 00:00:59.000000', 'consum', 0.0268, 'lps'),
	(685667, 136, '2015-02-01 00:01:00.000000', 'consum', 0.0222, 'lps'),
	(685668, 136, '2015-02-01 00:01:01.000000', 'consum', 0.0228, 'lps'),
	(685669, 136, '2015-02-01 00:01:02.000000', 'consum', 0.0261, 'lps'),
	(685670, 136, '2015-02-01 00:01:03.000000', 'consum', 0.0218, 'lps'),
	(685671, 136, '2015-02-01 00:01:04.000000', 'consum', 0.0228, 'lps'),
	(685672, 136, '2015-02-01 00:01:05.000000', 'consum', 0.0210, 'lps'),
	(685673, 136, '2015-02-01 00:01:06.000000', 'consum', 0.0224, 'lps'),
	(685674, 136, '2015-02-01 00:01:07.000000', 'consum', 0.0215, 'lps'),
	(685675, 136, '2015-02-01 00:01:08.000000', 'consum', 0.0258, 'lps'),
	(685676, 136, '2015-02-01 00:01:09.000000', 'consum', 0.0239, 'lps'),
	(685677, 136, '2015-02-01 00:01:10.000000', 'consum', 0.0213, 'lps'),
	(685678, 136, '2015-02-01 00:01:11.000000', 'consum', 0.0266, 'lps'),
	(685679, 136, '2015-02-01 00:01:12.000000', 'consum', 0.0225, 'lps'),
	(685680, 136, '2015-02-01 00:01:13.000000', 'consum', 0.0246, 'lps'),
	(685681, 136, '2015-02-01 00:01:14.000000', 'consum', 0.0217, 'lps'),
	(685682, 136, '2015-02-01 00:01:15.000000', 'consum', 0.0265, 'lps'),
	(685683, 136, '2015-02-01 00:01:16.000000', 'consum', 0.0270, 'lps'),
	(685684, 136, '2015-02-01 00:01:17.000000', 'consum', 0.0217, 'lps'),
	(685685, 136, '2015-02-01 00:01:18.000000', 'consum', 0.0260, 'lps'),
	(685686, 136, '2015-02-01 00:01:19.000000', 'consum', 0.0246, 'lps'),
	(685687, 136, '2015-02-01 00:01:20.000000', 'consum', 0.0238, 'lps'),
	(685688, 136, '2015-02-01 00:01:21.000000', 'consum', 0.0242, 'lps'),
	(685689, 136, '2015-02-01 00:01:22.000000', 'consum', 0.0224, 'lps'),
	(685690, 136, '2015-02-01 00:01:23.000000', 'consum', 0.0248, 'lps'),
	(685691, 136, '2015-02-01 00:01:24.000000', 'consum', 0.0229, 'lps'),
	(685692, 136, '2015-02-01 00:01:25.000000', 'consum', 0.0257, 'lps'),
	(685693, 136, '2015-02-01 00:01:26.000000', 'consum', 0.0260, 'lps'),
	(685694, 136, '2015-02-01 00:01:27.000000', 'consum', 0.0252, 'lps'),
	(685695, 136, '2015-02-01 00:01:28.000000', 'consum', 0.0272, 'lps'),
	(685696, 136, '2015-02-01 00:01:29.000000', 'consum', 0.0266, 'lps'),
	(685697, 136, '2015-02-01 00:01:30.000000', 'consum', 0.0236, 'lps'),
	(685698, 136, '2015-02-01 00:01:31.000000', 'consum', 0.0239, 'lps'),
	(685699, 136, '2015-02-01 00:01:32.000000', 'consum', 0.0214, 'lps'),
	(685700, 136, '2015-02-01 00:01:33.000000', 'consum', 0.0272, 'lps'),
	(685701, 136, '2015-02-01 00:01:34.000000', 'consum', 0.0249, 'lps'),
	(685702, 136, '2015-02-01 00:01:35.000000', 'consum', 0.0217, 'lps'),
	(685703, 136, '2015-02-01 00:01:36.000000', 'consum', 0.0262, 'lps'),
	(685704, 136, '2015-02-01 00:01:37.000000', 'consum', 0.0251, 'lps'),
	(685705, 136, '2015-02-01 00:01:38.000000', 'consum', 0.0263, 'lps'),
	(685706, 136, '2015-02-01 00:01:39.000000', 'consum', 0.0221, 'lps'),
	(685707, 136, '2015-02-01 00:01:40.000000', 'consum', 0.0238, 'lps'),
	(685708, 136, '2015-02-01 00:01:41.000000', 'consum', 0.0251, 'lps'),
	(685709, 136, '2015-02-01 00:01:42.000000', 'consum', 0.0268, 'lps'),
	(685710, 136, '2015-02-01 00:01:43.000000', 'consum', 0.0247, 'lps'),
	(685711, 136, '2015-02-01 00:01:44.000000', 'consum', 0.0220, 'lps'),
	(685712, 136, '2015-02-01 00:01:45.000000', 'consum', 0.0216, 'lps'),
	(685713, 136, '2015-02-01 00:01:46.000000', 'consum', 0.0210, 'lps'),
	(685714, 136, '2015-02-01 00:01:47.000000', 'consum', 0.0257, 'lps'),
	(685715, 136, '2015-02-01 00:01:48.000000', 'consum', 0.0253, 'lps'),
	(685716, 136, '2015-02-01 00:01:49.000000', 'consum', 0.0217, 'lps'),
	(685717, 136, '2015-02-01 00:01:50.000000', 'consum', 0.0248, 'lps'),
	(685718, 136, '2015-02-01 00:01:51.000000', 'consum', 0.0249, 'lps'),
	(685719, 136, '2015-02-01 00:01:52.000000', 'consum', 0.0226, 'lps'),
	(685720, 136, '2015-02-01 00:01:53.000000', 'consum', 0.0239, 'lps'),
	(685721, 136, '2015-02-01 00:01:54.000000', 'consum', 0.0243, 'lps'),
	(685722, 136, '2015-02-01 00:01:55.000000', 'consum', 0.0221, 'lps'),
	(685723, 136, '2015-02-01 00:01:56.000000', 'consum', 0.0234, 'lps'),
	(685724, 136, '2015-02-01 00:01:57.000000', 'consum', 0.0234, 'lps'),
	(685725, 136, '2015-02-01 00:01:58.000000', 'consum', 0.0255, 'lps'),
	(685726, 136, '2015-02-01 00:01:59.000000', 'consum', 0.0236, 'lps'),
	(685727, 136, '2015-02-01 00:02:00.000000', 'consum', 0.0271, 'lps'),
	(685728, 136, '2015-02-01 00:02:01.000000', 'consum', 0.0241, 'lps'),
	(685729, 136, '2015-02-01 00:02:02.000000', 'consum', 0.0246, 'lps'),
	(685730, 136, '2015-02-01 00:02:03.000000', 'consum', 0.0233, 'lps'),
	(685731, 136, '2015-02-01 00:02:04.000000', 'consum', 0.0219, 'lps'),
	(685732, 136, '2015-02-01 00:02:05.000000', 'consum', 0.0252, 'lps'),
	(685733, 136, '2015-02-01 00:02:06.000000', 'consum', 0.0261, 'lps'),
	(685734, 136, '2015-02-01 00:02:07.000000', 'consum', 0.0211, 'lps'),
	(685735, 136, '2015-02-01 00:02:08.000000', 'consum', 0.0257, 'lps'),
	(685736, 136, '2015-02-01 00:02:09.000000', 'consum', 0.0249, 'lps'),
	(685737, 136, '2015-02-01 00:02:10.000000', 'consum', 0.0264, 'lps'),
	(685738, 136, '2015-02-01 00:02:11.000000', 'consum', 0.0232, 'lps'),
	(685739, 136, '2015-02-01 00:02:12.000000', 'consum', 0.0223, 'lps'),
	(685740, 136, '2015-02-01 00:02:13.000000', 'consum', 0.0212, 'lps'),
	(685741, 136, '2015-02-01 00:02:14.000000', 'consum', 0.0246, 'lps'),
	(685742, 136, '2015-02-01 00:02:15.000000', 'consum', 0.0254, 'lps'),
	(685743, 136, '2015-02-01 00:02:16.000000', 'consum', 0.0258, 'lps'),
	(685744, 136, '2015-02-01 00:02:17.000000', 'consum', 0.0251, 'lps'),
	(685745, 136, '2015-02-01 00:02:18.000000', 'consum', 0.0273, 'lps'),
	(685746, 136, '2015-02-01 00:02:19.000000', 'consum', 0.0274, 'lps'),
	(685747, 136, '2015-02-01 00:02:20.000000', 'consum', 0.0212, 'lps'),
	(685748, 136, '2015-02-01 00:02:21.000000', 'consum', 0.0221, 'lps'),
	(685749, 136, '2015-02-01 00:02:22.000000', 'consum', 0.0261, 'lps'),
	(685750, 136, '2015-02-01 00:02:23.000000', 'consum', 0.0239, 'lps'),
	(685751, 136, '2015-02-01 00:02:24.000000', 'consum', 0.0265, 'lps'),
	(685752, 136, '2015-02-01 00:02:25.000000', 'consum', 0.0268, 'lps'),
	(685753, 136, '2015-02-01 00:02:26.000000', 'consum', 0.0272, 'lps'),
	(685754, 136, '2015-02-01 00:02:27.000000', 'consum', 0.0214, 'lps'),
	(685755, 136, '2015-02-01 00:02:28.000000', 'consum', 0.0242, 'lps'),
	(685756, 136, '2015-02-01 00:02:29.000000', 'consum', 0.0227, 'lps'),
	(685757, 136, '2015-02-01 00:02:30.000000', 'consum', 0.0265, 'lps'),
	(685758, 136, '2015-02-01 00:02:31.000000', 'consum', 0.0238, 'lps'),
	(685759, 136, '2015-02-01 00:02:32.000000', 'consum', 0.0251, 'lps'),
	(685760, 136, '2015-02-01 00:02:33.000000', 'consum', 0.0268, 'lps'),
	(685761, 136, '2015-02-01 00:02:34.000000', 'consum', 0.0246, 'lps'),
	(685762, 136, '2015-02-01 00:02:35.000000', 'consum', 0.0215, 'lps'),
	(685763, 136, '2015-02-01 00:02:36.000000', 'consum', 0.0261, 'lps'),
	(685764, 136, '2015-02-01 00:02:37.000000', 'consum', 0.0252, 'lps'),
	(685765, 136, '2015-02-01 00:02:38.000000', 'consum', 0.0269, 'lps'),
	(685766, 136, '2015-02-01 00:02:39.000000', 'consum', 0.0251, 'lps'),
	(685767, 136, '2015-02-01 00:02:40.000000', 'consum', 0.0236, 'lps'),
	(685768, 136, '2015-02-01 00:02:41.000000', 'consum', 0.0218, 'lps'),
	(685769, 136, '2015-02-01 00:02:42.000000', 'consum', 0.0237, 'lps'),
	(685770, 136, '2015-02-01 00:02:43.000000', 'consum', 0.0257, 'lps'),
	(685771, 136, '2015-02-01 00:02:44.000000', 'consum', 0.0236, 'lps'),
	(685772, 136, '2015-02-01 00:02:45.000000', 'consum', 0.0263, 'lps'),
	(685773, 136, '2015-02-01 00:02:46.000000', 'consum', 0.0266, 'lps'),
	(685774, 136, '2015-02-01 00:02:47.000000', 'consum', 0.0269, 'lps'),
	(685775, 136, '2015-02-01 00:02:48.000000', 'consum', 0.0273, 'lps'),
	(685776, 136, '2015-02-01 00:02:49.000000', 'consum', 0.0216, 'lps'),
	(685777, 136, '2015-02-01 00:02:50.000000', 'consum', 0.0249, 'lps'),
	(685778, 136, '2015-02-01 00:02:51.000000', 'consum', 0.0256, 'lps'),
	(685779, 136, '2015-02-01 00:02:52.000000', 'consum', 0.0258, 'lps'),
	(685780, 136, '2015-02-01 00:02:53.000000', 'consum', 0.0246, 'lps'),
	(685781, 136, '2015-02-01 00:02:54.000000', 'consum', 0.0249, 'lps'),
	(685782, 136, '2015-02-01 00:02:55.000000', 'consum', 0.0231, 'lps'),
	(685783, 136, '2015-02-01 00:02:56.000000', 'consum', 0.0263, 'lps'),
	(685784, 136, '2015-02-01 00:02:57.000000', 'consum', 0.0219, 'lps'),
	(685785, 136, '2015-02-01 00:02:58.000000', 'consum', 0.0227, 'lps'),
	(685786, 136, '2015-02-01 00:02:59.000000', 'consum', 0.0268, 'lps'),
	(685787, 136, '2015-02-01 00:03:00.000000', 'consum', 0.0253, 'lps'),
	(685788, 136, '2015-02-01 00:03:01.000000', 'consum', 0.0254, 'lps'),
	(685789, 136, '2015-02-01 00:03:02.000000', 'consum', 0.0236, 'lps'),
	(685790, 136, '2015-02-01 00:03:03.000000', 'consum', 0.0210, 'lps'),
	(685791, 136, '2015-02-01 00:03:04.000000', 'consum', 0.0259, 'lps'),
	(685792, 136, '2015-02-01 00:03:05.000000', 'consum', 0.0262, 'lps'),
	(685793, 136, '2015-02-01 00:03:06.000000', 'consum', 0.0259, 'lps'),
	(685794, 136, '2015-02-01 00:03:07.000000', 'consum', 0.0235, 'lps'),
	(685795, 136, '2015-02-01 00:03:08.000000', 'consum', 0.0253, 'lps'),
	(685796, 136, '2015-02-01 00:03:09.000000', 'consum', 0.0221, 'lps'),
	(685797, 136, '2015-02-01 00:03:10.000000', 'consum', 0.0265, 'lps'),
	(685798, 136, '2015-02-01 00:03:11.000000', 'consum', 0.0258, 'lps'),
	(685799, 136, '2015-02-01 00:03:12.000000', 'consum', 0.0220, 'lps'),
	(685800, 136, '2015-02-01 00:03:13.000000', 'consum', 0.0249, 'lps'),
	(685801, 136, '2015-02-01 00:03:14.000000', 'consum', 0.0242, 'lps'),
	(685802, 136, '2015-02-01 00:03:15.000000', 'consum', 0.0255, 'lps'),
	(685803, 136, '2015-02-01 00:03:16.000000', 'consum', 0.0274, 'lps'),
	(685804, 136, '2015-02-01 00:03:17.000000', 'consum', 0.0266, 'lps'),
	(685805, 136, '2015-02-01 00:03:18.000000', 'consum', 0.0235, 'lps'),
	(685806, 136, '2015-02-01 00:03:19.000000', 'consum', 0.0230, 'lps'),
	(685807, 136, '2015-02-01 00:03:20.000000', 'consum', 0.0236, 'lps'),
	(685808, 136, '2015-02-01 00:03:21.000000', 'consum', 0.0215, 'lps'),
	(685809, 136, '2015-02-01 00:03:22.000000', 'consum', 0.0225, 'lps'),
	(685810, 136, '2015-02-01 00:03:23.000000', 'consum', 0.0270, 'lps'),
	(685811, 136, '2015-02-01 00:03:24.000000', 'consum', 0.0270, 'lps'),
	(685812, 136, '2015-02-01 00:03:25.000000', 'consum', 0.0267, 'lps'),
	(685813, 136, '2015-02-01 00:03:26.000000', 'consum', 0.0247, 'lps'),
	(685814, 136, '2015-02-01 00:03:27.000000', 'consum', 0.0228, 'lps'),
	(685815, 136, '2015-02-01 00:03:28.000000', 'consum', 0.0255, 'lps'),
	(685816, 136, '2015-02-01 00:03:29.000000', 'consum', 0.0249, 'lps'),
	(685817, 136, '2015-02-01 00:03:30.000000', 'consum', 0.0269, 'lps'),
	(685818, 136, '2015-02-01 00:03:31.000000', 'consum', 0.0262, 'lps'),
	(685819, 136, '2015-02-01 00:03:32.000000', 'consum', 0.0225, 'lps'),
	(685820, 136, '2015-02-01 00:03:33.000000', 'consum', 0.0263, 'lps'),
	(685821, 136, '2015-02-01 00:03:34.000000', 'consum', 0.0233, 'lps'),
	(685822, 136, '2015-02-01 00:03:35.000000', 'consum', 0.0230, 'lps'),
	(685823, 136, '2015-02-01 00:03:36.000000', 'consum', 0.0245, 'lps'),
	(685824, 136, '2015-02-01 00:03:37.000000', 'consum', 0.0260, 'lps'),
	(685825, 136, '2015-02-01 00:03:38.000000', 'consum', 0.0224, 'lps'),
	(685826, 136, '2015-02-01 00:03:39.000000', 'consum', 0.0260, 'lps'),
	(685827, 136, '2015-02-01 00:03:40.000000', 'consum', 0.0224, 'lps'),
	(685828, 136, '2015-02-01 00:03:41.000000', 'consum', 0.0261, 'lps'),
	(685829, 136, '2015-02-01 00:03:42.000000', 'consum', 0.0230, 'lps'),
	(685830, 136, '2015-02-01 00:03:43.000000', 'consum', 0.0221, 'lps'),
	(685831, 136, '2015-02-01 00:03:44.000000', 'consum', 0.0272, 'lps'),
	(685832, 136, '2015-02-01 00:03:45.000000', 'consum', 0.0226, 'lps'),
	(685833, 136, '2015-02-01 00:03:46.000000', 'consum', 0.0235, 'lps'),
	(685834, 136, '2015-02-01 00:03:47.000000', 'consum', 0.0222, 'lps'),
	(685835, 136, '2015-02-01 00:03:48.000000', 'consum', 0.0262, 'lps'),
	(685836, 136, '2015-02-01 00:03:49.000000', 'consum', 0.0237, 'lps'),
	(685837, 136, '2015-02-01 00:03:50.000000', 'consum', 0.0254, 'lps'),
	(685838, 136, '2015-02-01 00:03:51.000000', 'consum', 0.0220, 'lps'),
	(685839, 136, '2015-02-01 00:03:52.000000', 'consum', 0.0258, 'lps'),
	(685840, 136, '2015-02-01 00:03:53.000000', 'consum', 0.0225, 'lps'),
	(685841, 136, '2015-02-01 00:03:54.000000', 'consum', 0.0273, 'lps'),
	(685842, 136, '2015-02-01 00:03:55.000000', 'consum', 0.0219, 'lps'),
	(685843, 136, '2015-02-01 00:03:56.000000', 'consum', 0.0260, 'lps'),
	(685844, 136, '2015-02-01 00:03:57.000000', 'consum', 0.0241, 'lps'),
	(685845, 136, '2015-02-01 00:03:58.000000', 'consum', 0.0215, 'lps'),
	(685846, 136, '2015-02-01 00:03:59.000000', 'consum', 0.0272, 'lps'),
	(685847, 136, '2015-02-01 00:04:00.000000', 'consum', 0.0245, 'lps'),
	(685848, 136, '2015-02-01 00:04:01.000000', 'consum', 0.0266, 'lps'),
	(685849, 136, '2015-02-01 00:04:02.000000', 'consum', 0.0256, 'lps'),
	(685850, 136, '2015-02-01 00:04:03.000000', 'consum', 0.0273, 'lps'),
	(685851, 136, '2015-02-01 00:04:04.000000', 'consum', 0.0257, 'lps'),
	(685852, 136, '2015-02-01 00:04:05.000000', 'consum', 0.0257, 'lps'),
	(685853, 136, '2015-02-01 00:04:06.000000', 'consum', 0.0238, 'lps'),
	(685854, 136, '2015-02-01 00:04:07.000000', 'consum', 0.0211, 'lps'),
	(685855, 136, '2015-02-01 00:04:08.000000', 'consum', 0.0262, 'lps'),
	(685856, 136, '2015-02-01 00:04:09.000000', 'consum', 0.0272, 'lps'),
	(685857, 136, '2015-02-01 00:04:10.000000', 'consum', 0.0235, 'lps'),
	(685858, 136, '2015-02-01 00:04:11.000000', 'consum', 0.0214, 'lps'),
	(685859, 136, '2015-02-01 00:04:12.000000', 'consum', 0.0220, 'lps'),
	(685860, 136, '2015-02-01 00:04:13.000000', 'consum', 0.0249, 'lps'),
	(685861, 136, '2015-02-01 00:04:14.000000', 'consum', 0.0244, 'lps'),
	(685862, 136, '2015-02-01 00:04:15.000000', 'consum', 0.0266, 'lps'),
	(685863, 136, '2015-02-01 00:04:16.000000', 'consum', 0.0259, 'lps'),
	(685864, 136, '2015-02-01 00:04:17.000000', 'consum', 0.0221, 'lps'),
	(685865, 136, '2015-02-01 00:04:18.000000', 'consum', 0.0250, 'lps'),
	(685866, 136, '2015-02-01 00:04:19.000000', 'consum', 0.0246, 'lps'),
	(685867, 136, '2015-02-01 00:04:20.000000', 'consum', 0.0270, 'lps'),
	(685868, 136, '2015-02-01 00:04:21.000000', 'consum', 0.0210, 'lps'),
	(685869, 136, '2015-02-01 00:04:22.000000', 'consum', 0.0223, 'lps'),
	(685870, 136, '2015-02-01 00:04:23.000000', 'consum', 0.0210, 'lps'),
	(685871, 136, '2015-02-01 00:04:24.000000', 'consum', 0.0239, 'lps'),
	(685872, 136, '2015-02-01 00:04:25.000000', 'consum', 0.0225, 'lps'),
	(685873, 136, '2015-02-01 00:04:26.000000', 'consum', 0.0264, 'lps'),
	(685874, 136, '2015-02-01 00:04:27.000000', 'consum', 0.0239, 'lps'),
	(685875, 136, '2015-02-01 00:04:28.000000', 'consum', 0.0258, 'lps'),
	(685876, 136, '2015-02-01 00:04:29.000000', 'consum', 0.0234, 'lps'),
	(685877, 136, '2015-02-01 00:04:30.000000', 'consum', 0.0254, 'lps'),
	(685878, 136, '2015-02-01 00:04:31.000000', 'consum', 0.0226, 'lps'),
	(685879, 136, '2015-02-01 00:04:32.000000', 'consum', 0.0224, 'lps'),
	(685880, 136, '2015-02-01 00:04:33.000000', 'consum', 0.0234, 'lps'),
	(685881, 136, '2015-02-01 00:04:34.000000', 'consum', 0.0222, 'lps'),
	(685882, 136, '2015-02-01 00:04:35.000000', 'consum', 0.0264, 'lps'),
	(685883, 136, '2015-02-01 00:04:36.000000', 'consum', 0.0249, 'lps'),
	(685884, 136, '2015-02-01 00:04:37.000000', 'consum', 0.0244, 'lps'),
	(685885, 136, '2015-02-01 00:04:38.000000', 'consum', 0.0265, 'lps'),
	(685886, 136, '2015-02-01 00:04:39.000000', 'consum', 0.0252, 'lps'),
	(685887, 136, '2015-02-01 00:04:40.000000', 'consum', 0.0255, 'lps'),
	(685888, 136, '2015-02-01 00:04:41.000000', 'consum', 0.0244, 'lps'),
	(685889, 136, '2015-02-01 00:04:42.000000', 'consum', 0.0246, 'lps'),
	(685890, 136, '2015-02-01 00:04:43.000000', 'consum', 0.0222, 'lps'),
	(685891, 136, '2015-02-01 00:04:44.000000', 'consum', 0.0228, 'lps'),
	(685892, 136, '2015-02-01 00:04:45.000000', 'consum', 0.0264, 'lps'),
	(685893, 136, '2015-02-01 00:04:46.000000', 'consum', 0.0232, 'lps'),
	(685894, 136, '2015-02-01 00:04:47.000000', 'consum', 0.0226, 'lps'),
	(685895, 136, '2015-02-01 00:04:48.000000', 'consum', 0.0222, 'lps'),
	(685896, 136, '2015-02-01 00:04:49.000000', 'consum', 0.0222, 'lps'),
	(685897, 136, '2015-02-01 00:04:50.000000', 'consum', 0.0235, 'lps'),
	(685898, 136, '2015-02-01 00:04:51.000000', 'consum', 0.0233, 'lps'),
	(685899, 136, '2015-02-01 00:04:52.000000', 'consum', 0.0254, 'lps'),
	(685900, 136, '2015-02-01 00:04:53.000000', 'consum', 0.0228, 'lps'),
	(685901, 136, '2015-02-01 00:04:54.000000', 'consum', 0.0235, 'lps'),
	(685902, 136, '2015-02-01 00:04:55.000000', 'consum', 0.0218, 'lps'),
	(685903, 136, '2015-02-01 00:04:56.000000', 'consum', 0.0239, 'lps'),
	(685904, 136, '2015-02-01 00:04:57.000000', 'consum', 0.0268, 'lps'),
	(685905, 136, '2015-02-01 00:04:58.000000', 'consum', 0.0217, 'lps'),
	(685906, 136, '2015-02-01 00:04:59.000000', 'consum', 0.0266, 'lps'),
	(685907, 136, '2015-02-01 00:05:00.000000', 'consum', 0.0274, 'lps'),
	(685908, 136, '2015-02-01 00:05:01.000000', 'consum', 0.0233, 'lps'),
	(685909, 136, '2015-02-01 00:05:02.000000', 'consum', 0.0265, 'lps'),
	(685910, 136, '2015-02-01 00:05:03.000000', 'consum', 0.0222, 'lps'),
	(685911, 136, '2015-02-01 00:05:04.000000', 'consum', 0.0234, 'lps'),
	(685912, 136, '2015-02-01 00:05:05.000000', 'consum', 0.0228, 'lps'),
	(685913, 136, '2015-02-01 00:05:06.000000', 'consum', 0.0231, 'lps'),
	(685914, 136, '2015-02-01 00:05:07.000000', 'consum', 0.0261, 'lps'),
	(685915, 136, '2015-02-01 00:05:08.000000', 'consum', 0.0270, 'lps'),
	(685916, 136, '2015-02-01 00:05:09.000000', 'consum', 0.0231, 'lps'),
	(685917, 136, '2015-02-01 00:05:10.000000', 'consum', 0.0264, 'lps'),
	(685918, 136, '2015-02-01 00:05:11.000000', 'consum', 0.0221, 'lps'),
	(685919, 136, '2015-02-01 00:05:12.000000', 'consum', 0.0234, 'lps'),
	(685920, 136, '2015-02-01 00:05:13.000000', 'consum', 0.0232, 'lps'),
	(685921, 136, '2015-02-01 00:05:14.000000', 'consum', 0.0248, 'lps'),
	(685922, 136, '2015-02-01 00:05:15.000000', 'consum', 0.0272, 'lps'),
	(685923, 136, '2015-02-01 00:05:16.000000', 'consum', 0.0274, 'lps'),
	(685924, 136, '2015-02-01 00:05:17.000000', 'consum', 0.0216, 'lps'),
	(685925, 136, '2015-02-01 00:05:18.000000', 'consum', 0.0243, 'lps'),
	(685926, 136, '2015-02-01 00:05:19.000000', 'consum', 0.0227, 'lps'),
	(685927, 136, '2015-02-01 00:05:20.000000', 'consum', 0.0263, 'lps'),
	(685928, 136, '2015-02-01 00:05:21.000000', 'consum', 0.0231, 'lps'),
	(685929, 136, '2015-02-01 00:05:22.000000', 'consum', 0.0218, 'lps'),
	(685930, 136, '2015-02-01 00:05:23.000000', 'consum', 0.0256, 'lps'),
	(685931, 136, '2015-02-01 00:05:24.000000', 'consum', 0.0218, 'lps'),
	(685932, 136, '2015-02-01 00:05:25.000000', 'consum', 0.0245, 'lps'),
	(685933, 136, '2015-02-01 00:05:26.000000', 'consum', 0.0233, 'lps'),
	(685934, 136, '2015-02-01 00:05:27.000000', 'consum', 0.0217, 'lps'),
	(685935, 136, '2015-02-01 00:05:28.000000', 'consum', 0.0244, 'lps'),
	(685936, 136, '2015-02-01 00:05:29.000000', 'consum', 0.0227, 'lps'),
	(685937, 136, '2015-02-01 00:05:30.000000', 'consum', 0.0260, 'lps'),
	(685938, 136, '2015-02-01 00:05:31.000000', 'consum', 0.0215, 'lps'),
	(685939, 136, '2015-02-01 00:05:32.000000', 'consum', 0.0214, 'lps'),
	(685940, 136, '2015-02-01 00:05:33.000000', 'consum', 0.0217, 'lps'),
	(685941, 136, '2015-02-01 00:05:34.000000', 'consum', 0.0232, 'lps'),
	(685942, 136, '2015-02-01 00:05:35.000000', 'consum', 0.0233, 'lps'),
	(685943, 136, '2015-02-01 00:05:36.000000', 'consum', 0.0263, 'lps'),
	(685944, 136, '2015-02-01 00:05:37.000000', 'consum', 0.0274, 'lps'),
	(685945, 136, '2015-02-01 00:05:38.000000', 'consum', 0.0243, 'lps'),
	(685946, 136, '2015-02-01 00:05:39.000000', 'consum', 0.0248, 'lps'),
	(685947, 136, '2015-02-01 00:05:40.000000', 'consum', 0.0236, 'lps'),
	(685948, 136, '2015-02-01 00:05:41.000000', 'consum', 0.0225, 'lps'),
	(685949, 136, '2015-02-01 00:05:42.000000', 'consum', 0.0274, 'lps'),
	(685950, 136, '2015-02-01 00:05:43.000000', 'consum', 0.0223, 'lps'),
	(685951, 136, '2015-02-01 00:05:44.000000', 'consum', 0.0217, 'lps'),
	(685952, 136, '2015-02-01 00:05:45.000000', 'consum', 0.0270, 'lps'),
	(685953, 136, '2015-02-01 00:05:46.000000', 'consum', 0.0230, 'lps'),
	(685954, 136, '2015-02-01 00:05:47.000000', 'consum', 0.0260, 'lps'),
	(685955, 136, '2015-02-01 00:05:48.000000', 'consum', 0.0272, 'lps'),
	(685956, 136, '2015-02-01 00:05:49.000000', 'consum', 0.0240, 'lps'),
	(685957, 136, '2015-02-01 00:05:50.000000', 'consum', 0.0241, 'lps'),
	(685958, 136, '2015-02-01 00:05:51.000000', 'consum', 0.0210, 'lps'),
	(685959, 136, '2015-02-01 00:05:52.000000', 'consum', 0.0247, 'lps'),
	(685960, 136, '2015-02-01 00:05:53.000000', 'consum', 0.0264, 'lps'),
	(685961, 136, '2015-02-01 00:05:54.000000', 'consum', 0.0240, 'lps'),
	(685962, 136, '2015-02-01 00:05:55.000000', 'consum', 0.0262, 'lps'),
	(685963, 136, '2015-02-01 00:05:56.000000', 'consum', 0.0253, 'lps'),
	(685964, 136, '2015-02-01 00:05:57.000000', 'consum', 0.0269, 'lps'),
	(685965, 136, '2015-02-01 00:05:58.000000', 'consum', 0.0246, 'lps'),
	(685966, 136, '2015-02-01 00:05:59.000000', 'consum', 0.0212, 'lps'),
	(685967, 136, '2015-02-01 00:06:00.000000', 'consum', 0.0242, 'lps'),
	(685968, 136, '2015-02-01 00:06:01.000000', 'consum', 0.0236, 'lps'),
	(685969, 136, '2015-02-01 00:06:02.000000', 'consum', 0.0244, 'lps'),
	(685970, 136, '2015-02-01 00:06:03.000000', 'consum', 0.0236, 'lps'),
	(685971, 136, '2015-02-01 00:06:04.000000', 'consum', 0.0239, 'lps'),
	(685972, 136, '2015-02-01 00:06:05.000000', 'consum', 0.0211, 'lps'),
	(685973, 136, '2015-02-01 00:06:06.000000', 'consum', 0.0261, 'lps'),
	(685974, 136, '2015-02-01 00:06:07.000000', 'consum', 0.0269, 'lps'),
	(685975, 136, '2015-02-01 00:06:08.000000', 'consum', 0.0219, 'lps'),
	(685976, 136, '2015-02-01 00:06:09.000000', 'consum', 0.0210, 'lps'),
	(685977, 136, '2015-02-01 00:06:10.000000', 'consum', 0.0248, 'lps'),
	(685978, 136, '2015-02-01 00:06:11.000000', 'consum', 0.0269, 'lps'),
	(685979, 136, '2015-02-01 00:06:12.000000', 'consum', 0.0264, 'lps'),
	(685980, 136, '2015-02-01 00:06:13.000000', 'consum', 0.0239, 'lps'),
	(685981, 136, '2015-02-01 00:06:14.000000', 'consum', 0.0258, 'lps'),
	(685982, 136, '2015-02-01 00:06:15.000000', 'consum', 0.0235, 'lps'),
	(685983, 136, '2015-02-01 00:06:16.000000', 'consum', 0.0255, 'lps'),
	(685984, 136, '2015-02-01 00:06:17.000000', 'consum', 0.0229, 'lps'),
	(685985, 136, '2015-02-01 00:06:18.000000', 'consum', 0.0237, 'lps'),
	(685986, 136, '2015-02-01 00:06:19.000000', 'consum', 0.0223, 'lps'),
	(685987, 136, '2015-02-01 00:06:20.000000', 'consum', 0.0259, 'lps'),
	(685988, 136, '2015-02-01 00:06:21.000000', 'consum', 0.0222, 'lps'),
	(685989, 136, '2015-02-01 00:06:22.000000', 'consum', 0.0254, 'lps'),
	(685990, 136, '2015-02-01 00:06:23.000000', 'consum', 0.0265, 'lps'),
	(685991, 136, '2015-02-01 00:06:24.000000', 'consum', 0.0221, 'lps'),
	(685992, 136, '2015-02-01 00:06:25.000000', 'consum', 0.0231, 'lps'),
	(685993, 136, '2015-02-01 00:06:26.000000', 'consum', 0.0218, 'lps'),
	(685994, 136, '2015-02-01 00:06:27.000000', 'consum', 0.0253, 'lps'),
	(685995, 136, '2015-02-01 00:06:28.000000', 'consum', 0.0270, 'lps'),
	(685996, 136, '2015-02-01 00:06:29.000000', 'consum', 0.0252, 'lps'),
	(685997, 136, '2015-02-01 00:06:30.000000', 'consum', 0.0240, 'lps'),
	(685998, 136, '2015-02-01 00:06:31.000000', 'consum', 0.0235, 'lps'),
	(685999, 136, '2015-02-01 00:06:32.000000', 'consum', 0.0245, 'lps'),
	(686000, 136, '2015-02-01 00:06:33.000000', 'consum', 0.0247, 'lps'),
	(686001, 136, '2015-02-01 00:06:34.000000', 'consum', 0.0226, 'lps'),
	(686002, 136, '2015-02-01 00:06:35.000000', 'consum', 0.0245, 'lps'),
	(686003, 136, '2015-02-01 00:06:36.000000', 'consum', 0.0272, 'lps'),
	(686004, 136, '2015-02-01 00:06:37.000000', 'consum', 0.0219, 'lps'),
	(686005, 136, '2015-02-01 00:06:38.000000', 'consum', 0.0264, 'lps'),
	(686006, 136, '2015-02-01 00:06:39.000000', 'consum', 0.0258, 'lps'),
	(686007, 136, '2015-02-01 00:06:40.000000', 'consum', 0.0227, 'lps'),
	(686008, 136, '2015-02-01 00:06:41.000000', 'consum', 0.0213, 'lps'),
	(686009, 136, '2015-02-01 00:06:42.000000', 'consum', 0.0240, 'lps'),
	(686010, 136, '2015-02-01 00:06:43.000000', 'consum', 0.0222, 'lps'),
	(686011, 136, '2015-02-01 00:06:44.000000', 'consum', 0.0245, 'lps'),
	(686012, 136, '2015-02-01 00:06:45.000000', 'consum', 0.0222, 'lps'),
	(686013, 136, '2015-02-01 00:06:46.000000', 'consum', 0.0227, 'lps'),
	(686014, 136, '2015-02-01 00:06:47.000000', 'consum', 0.0261, 'lps'),
	(686015, 136, '2015-02-01 00:06:48.000000', 'consum', 0.0219, 'lps'),
	(686016, 136, '2015-02-01 00:06:49.000000', 'consum', 0.0232, 'lps'),
	(686017, 136, '2015-02-01 00:06:50.000000', 'consum', 0.0229, 'lps'),
	(686018, 136, '2015-02-01 00:06:51.000000', 'consum', 0.0241, 'lps'),
	(686019, 136, '2015-02-01 00:06:52.000000', 'consum', 0.0241, 'lps'),
	(686020, 136, '2015-02-01 00:06:53.000000', 'consum', 0.0210, 'lps'),
	(686021, 136, '2015-02-01 00:06:54.000000', 'consum', 0.0248, 'lps'),
	(686022, 136, '2015-02-01 00:06:55.000000', 'consum', 0.0268, 'lps'),
	(686023, 136, '2015-02-01 00:06:56.000000', 'consum', 0.0257, 'lps'),
	(686024, 136, '2015-02-01 00:06:57.000000', 'consum', 0.0274, 'lps'),
	(686025, 136, '2015-02-01 00:06:58.000000', 'consum', 0.0258, 'lps'),
	(686026, 136, '2015-02-01 00:06:59.000000', 'consum', 0.0258, 'lps'),
	(686027, 136, '2015-02-01 00:07:00.000000', 'consum', 0.0243, 'lps'),
	(686028, 136, '2015-02-01 00:07:01.000000', 'consum', 0.0231, 'lps'),
	(686029, 136, '2015-02-01 00:07:02.000000', 'consum', 0.0215, 'lps'),
	(686030, 136, '2015-02-01 00:07:03.000000', 'consum', 0.0238, 'lps'),
	(686031, 136, '2015-02-01 00:07:04.000000', 'consum', 0.0269, 'lps'),
	(686032, 136, '2015-02-01 00:07:05.000000', 'consum', 0.0227, 'lps'),
	(686033, 136, '2015-02-01 00:07:06.000000', 'consum', 0.0248, 'lps'),
	(686034, 136, '2015-02-01 00:07:07.000000', 'consum', 0.0220, 'lps'),
	(686035, 136, '2015-02-01 00:07:08.000000', 'consum', 0.0212, 'lps'),
	(686036, 136, '2015-02-01 00:07:09.000000', 'consum', 0.0253, 'lps'),
	(686037, 136, '2015-02-01 00:07:10.000000', 'consum', 0.0228, 'lps'),
	(686038, 136, '2015-02-01 00:07:11.000000', 'consum', 0.0235, 'lps'),
	(686039, 136, '2015-02-01 00:07:12.000000', 'consum', 0.0217, 'lps'),
	(686040, 136, '2015-02-01 00:07:13.000000', 'consum', 0.0234, 'lps'),
	(686041, 136, '2015-02-01 00:07:14.000000', 'consum', 0.0247, 'lps'),
	(686042, 136, '2015-02-01 00:07:15.000000', 'consum', 0.0256, 'lps'),
	(686043, 136, '2015-02-01 00:07:16.000000', 'consum', 0.0265, 'lps'),
	(686044, 136, '2015-02-01 00:07:17.000000', 'consum', 0.0216, 'lps'),
	(686045, 136, '2015-02-01 00:07:18.000000', 'consum', 0.0274, 'lps'),
	(686046, 136, '2015-02-01 00:07:19.000000', 'consum', 0.0250, 'lps'),
	(686047, 136, '2015-02-01 00:07:20.000000', 'consum', 0.0217, 'lps'),
	(686048, 136, '2015-02-01 00:07:21.000000', 'consum', 0.0259, 'lps'),
	(686049, 136, '2015-02-01 00:07:22.000000', 'consum', 0.0237, 'lps'),
	(686050, 136, '2015-02-01 00:07:23.000000', 'consum', 0.0264, 'lps'),
	(686051, 136, '2015-02-01 00:07:24.000000', 'consum', 0.0269, 'lps'),
	(686052, 136, '2015-02-01 00:07:25.000000', 'consum', 0.0213, 'lps'),
	(686053, 136, '2015-02-01 00:07:26.000000', 'consum', 0.0245, 'lps'),
	(686054, 136, '2015-02-01 00:07:27.000000', 'consum', 0.0246, 'lps'),
	(686055, 136, '2015-02-01 00:07:28.000000', 'consum', 0.0222, 'lps'),
	(686056, 136, '2015-02-01 00:07:29.000000', 'consum', 0.0227, 'lps'),
	(686057, 136, '2015-02-01 00:07:30.000000', 'consum', 0.0257, 'lps'),
	(686058, 136, '2015-02-01 00:07:31.000000', 'consum', 0.0267, 'lps'),
	(686059, 136, '2015-02-01 00:07:32.000000', 'consum', 0.0225, 'lps'),
	(686060, 136, '2015-02-01 00:07:33.000000', 'consum', 0.0246, 'lps'),
	(686061, 136, '2015-02-01 00:07:34.000000', 'consum', 0.0212, 'lps'),
	(686062, 136, '2015-02-01 00:07:35.000000', 'consum', 0.0244, 'lps'),
	(686063, 136, '2015-02-01 00:07:36.000000', 'consum', 0.0246, 'lps'),
	(686064, 136, '2015-02-01 00:07:37.000000', 'consum', 0.0224, 'lps'),
	(686065, 136, '2015-02-01 00:07:38.000000', 'consum', 0.0236, 'lps'),
	(686066, 136, '2015-02-01 00:07:39.000000', 'consum', 0.0232, 'lps'),
	(686067, 136, '2015-02-01 00:07:40.000000', 'consum', 0.0245, 'lps'),
	(686068, 136, '2015-02-01 00:07:41.000000', 'consum', 0.0252, 'lps'),
	(686069, 136, '2015-02-01 00:07:42.000000', 'consum', 0.0252, 'lps'),
	(686070, 136, '2015-02-01 00:07:43.000000', 'consum', 0.0229, 'lps'),
	(686071, 136, '2015-02-01 00:07:44.000000', 'consum', 0.0244, 'lps'),
	(686072, 136, '2015-02-01 00:07:45.000000', 'consum', 0.0259, 'lps'),
	(686073, 136, '2015-02-01 00:07:46.000000', 'consum', 0.0224, 'lps'),
	(686074, 136, '2015-02-01 00:07:47.000000', 'consum', 0.0265, 'lps'),
	(686075, 136, '2015-02-01 00:07:48.000000', 'consum', 0.0247, 'lps'),
	(686076, 136, '2015-02-01 00:07:49.000000', 'consum', 0.0230, 'lps'),
	(686077, 136, '2015-02-01 00:07:50.000000', 'consum', 0.0265, 'lps'),
	(686078, 136, '2015-02-01 00:07:51.000000', 'consum', 0.0231, 'lps'),
	(686079, 136, '2015-02-01 00:07:52.000000', 'consum', 0.0216, 'lps'),
	(686080, 136, '2015-02-01 00:07:53.000000', 'consum', 0.0244, 'lps'),
	(686081, 136, '2015-02-01 00:07:54.000000', 'consum', 0.0231, 'lps'),
	(686082, 136, '2015-02-01 00:07:55.000000', 'consum', 0.0213, 'lps'),
	(686083, 136, '2015-02-01 00:07:56.000000', 'consum', 0.0228, 'lps'),
	(686084, 136, '2015-02-01 00:07:57.000000', 'consum', 0.0225, 'lps'),
	(686085, 136, '2015-02-01 00:07:58.000000', 'consum', 0.0232, 'lps'),
	(686086, 136, '2015-02-01 00:07:59.000000', 'consum', 0.0274, 'lps'),
	(686087, 136, '2015-02-01 00:08:00.000000', 'consum', 0.0270, 'lps'),
	(686088, 136, '2015-02-01 00:08:01.000000', 'consum', 0.0252, 'lps'),
	(686089, 136, '2015-02-01 00:08:02.000000', 'consum', 0.0243, 'lps'),
	(686090, 136, '2015-02-01 00:08:03.000000', 'consum', 0.0250, 'lps'),
	(686091, 136, '2015-02-01 00:08:04.000000', 'consum', 0.0247, 'lps'),
	(686092, 136, '2015-02-01 00:08:05.000000', 'consum', 0.0273, 'lps'),
	(686093, 136, '2015-02-01 00:08:06.000000', 'consum', 0.0222, 'lps'),
	(686094, 136, '2015-02-01 00:08:07.000000', 'consum', 0.0210, 'lps'),
	(686095, 136, '2015-02-01 00:08:08.000000', 'consum', 0.0239, 'lps'),
	(686096, 136, '2015-02-01 00:08:09.000000', 'consum', 0.0225, 'lps'),
	(686097, 136, '2015-02-01 00:08:10.000000', 'consum', 0.0266, 'lps'),
	(686098, 136, '2015-02-01 00:08:11.000000', 'consum', 0.0248, 'lps'),
	(686099, 136, '2015-02-01 00:08:12.000000', 'consum', 0.0233, 'lps'),
	(686100, 136, '2015-02-01 00:08:13.000000', 'consum', 0.0212, 'lps'),
	(686101, 136, '2015-02-01 00:08:14.000000', 'consum', 0.0217, 'lps'),
	(686102, 136, '2015-02-01 00:08:15.000000', 'consum', 0.0241, 'lps'),
	(686103, 136, '2015-02-01 00:08:16.000000', 'consum', 0.0213, 'lps'),
	(686104, 136, '2015-02-01 00:08:17.000000', 'consum', 0.0261, 'lps'),
	(686105, 136, '2015-02-01 00:08:18.000000', 'consum', 0.0262, 'lps'),
	(686106, 136, '2015-02-01 00:08:19.000000', 'consum', 0.0253, 'lps'),
	(686107, 136, '2015-02-01 00:08:20.000000', 'consum', 0.0269, 'lps'),
	(686108, 136, '2015-02-01 00:08:21.000000', 'consum', 0.0247, 'lps'),
	(686109, 136, '2015-02-01 00:08:22.000000', 'consum', 0.0216, 'lps'),
	(686110, 136, '2015-02-01 00:08:23.000000', 'consum', 0.0263, 'lps'),
	(686111, 136, '2015-02-01 00:08:24.000000', 'consum', 0.0261, 'lps'),
	(686112, 136, '2015-02-01 00:08:25.000000', 'consum', 0.0240, 'lps'),
	(686113, 136, '2015-02-01 00:08:26.000000', 'consum', 0.0272, 'lps'),
	(686114, 136, '2015-02-01 00:08:27.000000', 'consum', 0.0237, 'lps'),
	(686115, 136, '2015-02-01 00:08:28.000000', 'consum', 0.0224, 'lps'),
	(686116, 136, '2015-02-01 00:08:29.000000', 'consum', 0.0267, 'lps'),
	(686117, 136, '2015-02-01 00:08:30.000000', 'consum', 0.0255, 'lps'),
	(686118, 136, '2015-02-01 00:08:31.000000', 'consum', 0.0265, 'lps'),
	(686119, 136, '2015-02-01 00:08:32.000000', 'consum', 0.0222, 'lps'),
	(686120, 136, '2015-02-01 00:08:33.000000', 'consum', 0.0235, 'lps'),
	(686121, 136, '2015-02-01 00:08:34.000000', 'consum', 0.0236, 'lps'),
	(686122, 136, '2015-02-01 00:08:35.000000', 'consum', 0.0263, 'lps'),
	(686123, 136, '2015-02-01 00:08:36.000000', 'consum', 0.0268, 'lps'),
	(686124, 136, '2015-02-01 00:08:37.000000', 'consum', 0.0213, 'lps'),
	(686125, 136, '2015-02-01 00:08:38.000000', 'consum', 0.0244, 'lps'),
	(686126, 136, '2015-02-01 00:08:39.000000', 'consum', 0.0242, 'lps'),
	(686127, 136, '2015-02-01 00:08:40.000000', 'consum', 0.0271, 'lps'),
	(686128, 136, '2015-02-01 00:08:41.000000', 'consum', 0.0221, 'lps'),
	(686129, 136, '2015-02-01 00:08:42.000000', 'consum', 0.0216, 'lps'),
	(686130, 136, '2015-02-01 00:08:43.000000', 'consum', 0.0271, 'lps'),
	(686131, 136, '2015-02-01 00:08:44.000000', 'consum', 0.0239, 'lps'),
	(686132, 136, '2015-02-01 00:08:45.000000', 'consum', 0.0238, 'lps'),
	(686133, 136, '2015-02-01 00:08:46.000000', 'consum', 0.0262, 'lps'),
	(686134, 136, '2015-02-01 00:08:47.000000', 'consum', 0.0257, 'lps'),
	(686135, 136, '2015-02-01 00:08:48.000000', 'consum', 0.0226, 'lps'),
	(686136, 136, '2015-02-01 00:08:49.000000', 'consum', 0.0211, 'lps'),
	(686137, 136, '2015-02-01 00:08:50.000000', 'consum', 0.0236, 'lps'),
	(686138, 136, '2015-02-01 00:08:51.000000', 'consum', 0.0270, 'lps'),
	(686139, 136, '2015-02-01 00:08:52.000000', 'consum', 0.0239, 'lps'),
	(686140, 136, '2015-02-01 00:08:53.000000', 'consum', 0.0241, 'lps'),
	(686141, 136, '2015-02-01 00:08:54.000000', 'consum', 0.0211, 'lps'),
	(686142, 136, '2015-02-01 00:08:55.000000', 'consum', 0.0253, 'lps'),
	(686143, 136, '2015-02-01 00:08:56.000000', 'consum', 0.0227, 'lps'),
	(686144, 136, '2015-02-01 00:08:57.000000', 'consum', 0.0232, 'lps'),
	(686145, 136, '2015-02-01 00:08:58.000000', 'consum', 0.0271, 'lps'),
	(686146, 136, '2015-02-01 00:08:59.000000', 'consum', 0.0255, 'lps'),
	(686147, 136, '2015-02-01 00:09:00.000000', 'consum', 0.0251, 'lps'),
	(686148, 136, '2015-02-01 00:09:01.000000', 'consum', 0.0216, 'lps'),
	(686149, 136, '2015-02-01 00:09:02.000000', 'consum', 0.0247, 'lps'),
	(686150, 136, '2015-02-01 00:09:03.000000', 'consum', 0.0247, 'lps'),
	(686151, 136, '2015-02-01 00:09:04.000000', 'consum', 0.0221, 'lps'),
	(686152, 136, '2015-02-01 00:09:05.000000', 'consum', 0.0218, 'lps'),
	(686153, 136, '2015-02-01 00:09:06.000000', 'consum', 0.0220, 'lps'),
	(686154, 136, '2015-02-01 00:09:07.000000', 'consum', 0.0233, 'lps'),
	(686155, 136, '2015-02-01 00:09:08.000000', 'consum', 0.0233, 'lps'),
	(686156, 136, '2015-02-01 00:09:09.000000', 'consum', 0.0256, 'lps'),
	(686157, 136, '2015-02-01 00:09:10.000000', 'consum', 0.0243, 'lps'),
	(686158, 136, '2015-02-01 00:09:11.000000', 'consum', 0.0237, 'lps'),
	(686159, 136, '2015-02-01 00:09:12.000000', 'consum', 0.0246, 'lps'),
	(686160, 136, '2015-02-01 00:09:13.000000', 'consum', 0.0246, 'lps'),
	(686161, 136, '2015-02-01 00:09:14.000000', 'consum', 0.0218, 'lps'),
	(686162, 136, '2015-02-01 00:09:15.000000', 'consum', 0.0271, 'lps'),
	(686163, 136, '2015-02-01 00:09:16.000000', 'consum', 0.0232, 'lps'),
	(686164, 136, '2015-02-01 00:09:17.000000', 'consum', 0.0269, 'lps'),
	(686165, 136, '2015-02-01 00:09:18.000000', 'consum', 0.0245, 'lps'),
	(686166, 136, '2015-02-01 00:09:19.000000', 'consum', 0.0271, 'lps'),
	(686167, 136, '2015-02-01 00:09:20.000000', 'consum', 0.0218, 'lps'),
	(686168, 136, '2015-02-01 00:09:21.000000', 'consum', 0.0262, 'lps'),
	(686169, 136, '2015-02-01 00:09:22.000000', 'consum', 0.0252, 'lps'),
	(686170, 136, '2015-02-01 00:09:23.000000', 'consum', 0.0262, 'lps'),
	(686171, 136, '2015-02-01 00:09:24.000000', 'consum', 0.0216, 'lps'),
	(686172, 136, '2015-02-01 00:09:25.000000', 'consum', 0.0213, 'lps'),
	(686173, 136, '2015-02-01 00:09:26.000000', 'consum', 0.0272, 'lps'),
	(686174, 136, '2015-02-01 00:09:27.000000', 'consum', 0.0254, 'lps'),
	(686175, 136, '2015-02-01 00:09:28.000000', 'consum', 0.0242, 'lps'),
	(686176, 136, '2015-02-01 00:09:29.000000', 'consum', 0.0237, 'lps'),
	(686177, 136, '2015-02-01 00:09:30.000000', 'consum', 0.0253, 'lps'),
	(686178, 136, '2015-02-01 00:09:31.000000', 'consum', 0.0215, 'lps'),
	(686179, 136, '2015-02-01 00:09:32.000000', 'consum', 0.0235, 'lps'),
	(686180, 136, '2015-02-01 00:09:33.000000', 'consum', 0.0254, 'lps'),
	(686181, 136, '2015-02-01 00:09:34.000000', 'consum', 0.0225, 'lps'),
	(686182, 136, '2015-02-01 00:09:35.000000', 'consum', 0.0222, 'lps'),
	(686183, 136, '2015-02-01 00:09:36.000000', 'consum', 0.0223, 'lps'),
	(686184, 136, '2015-02-01 00:09:37.000000', 'consum', 0.0239, 'lps'),
	(686185, 136, '2015-02-01 00:09:38.000000', 'consum', 0.0251, 'lps'),
	(686186, 136, '2015-02-01 00:09:39.000000', 'consum', 0.0265, 'lps'),
	(686187, 136, '2015-02-01 00:09:40.000000', 'consum', 0.0232, 'lps'),
	(686188, 136, '2015-02-01 00:09:41.000000', 'consum', 0.0219, 'lps'),
	(686189, 136, '2015-02-01 00:09:42.000000', 'consum', 0.0256, 'lps'),
	(686190, 136, '2015-02-01 00:09:43.000000', 'consum', 0.0217, 'lps'),
	(686191, 136, '2015-02-01 00:09:44.000000', 'consum', 0.0236, 'lps'),
	(686192, 136, '2015-02-01 00:09:45.000000', 'consum', 0.0257, 'lps'),
	(686193, 136, '2015-02-01 00:09:46.000000', 'consum', 0.0237, 'lps'),
	(686194, 136, '2015-02-01 00:09:47.000000', 'consum', 0.0269, 'lps'),
	(686195, 136, '2015-02-01 00:09:48.000000', 'consum', 0.0229, 'lps'),
	(686196, 136, '2015-02-01 00:09:49.000000', 'consum', 0.0257, 'lps'),
	(686197, 136, '2015-02-01 00:09:50.000000', 'consum', 0.0261, 'lps'),
	(686198, 136, '2015-02-01 00:09:51.000000', 'consum', 0.0261, 'lps'),
	(686199, 136, '2015-02-01 00:09:52.000000', 'consum', 0.0245, 'lps'),
	(686200, 136, '2015-02-01 00:09:53.000000', 'consum', 0.0234, 'lps'),
	(686201, 136, '2015-02-01 00:09:54.000000', 'consum', 0.0223, 'lps'),
	(686202, 136, '2015-02-01 00:09:55.000000', 'consum', 0.0270, 'lps'),
	(686203, 136, '2015-02-01 00:09:56.000000', 'consum', 0.0212, 'lps'),
	(686204, 136, '2015-02-01 00:09:57.000000', 'consum', 0.0234, 'lps'),
	(686205, 136, '2015-02-01 00:09:58.000000', 'consum', 0.0262, 'lps'),
	(686206, 136, '2015-02-01 00:09:59.000000', 'consum', 0.0269, 'lps'),
	(686207, 136, '2015-02-01 00:10:00.000000', 'consum', 0.0218, 'lps'),
	(686208, 136, '2015-02-01 00:10:01.000000', 'consum', 0.0270, 'lps'),
	(686209, 136, '2015-02-01 00:10:02.000000', 'consum', 0.0224, 'lps'),
	(686210, 136, '2015-02-01 00:10:03.000000', 'consum', 0.0230, 'lps'),
	(686211, 136, '2015-02-01 00:10:04.000000', 'consum', 0.0269, 'lps'),
	(686212, 136, '2015-02-01 00:10:05.000000', 'consum', 0.0250, 'lps'),
	(686213, 136, '2015-02-01 00:10:06.000000', 'consum', 0.0232, 'lps'),
	(686214, 136, '2015-02-01 00:10:07.000000', 'consum', 0.0267, 'lps'),
	(686215, 136, '2015-02-01 00:10:08.000000', 'consum', 0.0235, 'lps'),
	(686216, 136, '2015-02-01 00:10:09.000000', 'consum', 0.0229, 'lps'),
	(686217, 136, '2015-02-01 00:10:10.000000', 'consum', 0.0229, 'lps'),
	(686218, 136, '2015-02-01 00:10:11.000000', 'consum', 0.0249, 'lps'),
	(686219, 136, '2015-02-01 00:10:12.000000', 'consum', 0.0217, 'lps'),
	(686220, 136, '2015-02-01 00:10:13.000000', 'consum', 0.0261, 'lps'),
	(686221, 136, '2015-02-01 00:10:14.000000', 'consum', 0.0250, 'lps'),
	(686222, 136, '2015-02-01 00:10:15.000000', 'consum', 0.0255, 'lps'),
	(686223, 136, '2015-02-01 00:10:16.000000', 'consum', 0.0254, 'lps'),
	(686224, 136, '2015-02-01 00:10:17.000000', 'consum', 0.0227, 'lps'),
	(686225, 136, '2015-02-01 00:10:18.000000', 'consum', 0.0230, 'lps'),
	(686226, 136, '2015-02-01 00:10:19.000000', 'consum', 0.0259, 'lps'),
	(686227, 136, '2015-02-01 00:10:20.000000', 'consum', 0.0264, 'lps'),
	(686228, 136, '2015-02-01 00:10:21.000000', 'consum', 0.0271, 'lps'),
	(686229, 136, '2015-02-01 00:10:22.000000', 'consum', 0.0224, 'lps'),
	(686230, 136, '2015-02-01 00:10:23.000000', 'consum', 0.0227, 'lps'),
	(686231, 136, '2015-02-01 00:10:24.000000', 'consum', 0.0252, 'lps'),
	(686232, 136, '2015-02-01 00:10:25.000000', 'consum', 0.0238, 'lps'),
	(686233, 136, '2015-02-01 00:10:26.000000', 'consum', 0.0228, 'lps'),
	(686234, 136, '2015-02-01 00:10:27.000000', 'consum', 0.0216, 'lps'),
	(686235, 136, '2015-02-01 00:10:28.000000', 'consum', 0.0250, 'lps'),
	(686236, 136, '2015-02-01 00:10:29.000000', 'consum', 0.0263, 'lps'),
	(686237, 136, '2015-02-01 00:10:30.000000', 'consum', 0.0227, 'lps'),
	(686238, 136, '2015-02-01 00:10:31.000000', 'consum', 0.0264, 'lps'),
	(686239, 136, '2015-02-01 00:10:32.000000', 'consum', 0.0237, 'lps'),
	(686240, 136, '2015-02-01 00:10:33.000000', 'consum', 0.0249, 'lps'),
	(686241, 136, '2015-02-01 00:10:34.000000', 'consum', 0.0257, 'lps'),
	(686242, 136, '2015-02-01 00:10:35.000000', 'consum', 0.0265, 'lps'),
	(686243, 136, '2015-02-01 00:10:36.000000', 'consum', 0.0216, 'lps'),
	(686244, 136, '2015-02-01 00:10:37.000000', 'consum', 0.0267, 'lps'),
	(686245, 136, '2015-02-01 00:10:38.000000', 'consum', 0.0221, 'lps'),
	(686246, 136, '2015-02-01 00:10:39.000000', 'consum', 0.0224, 'lps'),
	(686247, 136, '2015-02-01 00:10:40.000000', 'consum', 0.0245, 'lps'),
	(686248, 136, '2015-02-01 00:10:41.000000', 'consum', 0.0215, 'lps'),
	(686249, 136, '2015-02-01 00:10:42.000000', 'consum', 0.0260, 'lps'),
	(686250, 136, '2015-02-01 00:10:43.000000', 'consum', 0.0251, 'lps'),
	(686251, 136, '2015-02-01 00:10:44.000000', 'consum', 0.0266, 'lps'),
	(686252, 136, '2015-02-01 00:10:45.000000', 'consum', 0.0236, 'lps'),
	(686253, 136, '2015-02-01 00:10:46.000000', 'consum', 0.0236, 'lps'),
	(686254, 136, '2015-02-01 00:10:47.000000', 'consum', 0.0264, 'lps'),
	(686255, 136, '2015-02-01 00:10:48.000000', 'consum', 0.0210, 'lps'),
	(686256, 136, '2015-02-01 00:10:49.000000', 'consum', 0.0240, 'lps'),
	(686257, 136, '2015-02-01 00:10:50.000000', 'consum', 0.0231, 'lps'),
	(686258, 136, '2015-02-01 00:10:51.000000', 'consum', 0.0226, 'lps'),
	(686259, 136, '2015-02-01 00:10:52.000000', 'consum', 0.0229, 'lps'),
	(686260, 136, '2015-02-01 00:10:53.000000', 'consum', 0.0258, 'lps'),
	(686261, 136, '2015-02-01 00:10:54.000000', 'consum', 0.0261, 'lps'),
	(686262, 136, '2015-02-01 00:10:55.000000', 'consum', 0.0256, 'lps'),
	(686263, 136, '2015-02-01 00:10:56.000000', 'consum', 0.0223, 'lps'),
	(686264, 136, '2015-02-01 00:10:57.000000', 'consum', 0.0266, 'lps'),
	(686265, 136, '2015-02-01 00:10:58.000000', 'consum', 0.0259, 'lps'),
	(686266, 136, '2015-02-01 00:10:59.000000', 'consum', 0.0223, 'lps'),
	(686267, 136, '2015-02-01 00:11:00.000000', 'consum', 0.0258, 'lps'),
	(686268, 136, '2015-02-01 00:11:01.000000', 'consum', 0.0218, 'lps'),
	(686269, 136, '2015-02-01 00:11:02.000000', 'consum', 0.0234, 'lps'),
	(686270, 136, '2015-02-01 00:11:03.000000', 'consum', 0.0243, 'lps'),
	(686271, 136, '2015-02-01 00:11:04.000000', 'consum', 0.0239, 'lps'),
	(686272, 136, '2015-02-01 00:11:05.000000', 'consum', 0.0258, 'lps'),
	(686273, 136, '2015-02-01 00:11:06.000000', 'consum', 0.0230, 'lps'),
	(686274, 136, '2015-02-01 00:11:07.000000', 'consum', 0.0235, 'lps'),
	(686275, 136, '2015-02-01 00:11:08.000000', 'consum', 0.0274, 'lps'),
	(686276, 136, '2015-02-01 00:11:09.000000', 'consum', 0.0261, 'lps'),
	(686277, 136, '2015-02-01 00:11:10.000000', 'consum', 0.0272, 'lps'),
	(686278, 136, '2015-02-01 00:11:11.000000', 'consum', 0.0238, 'lps'),
	(686279, 136, '2015-02-01 00:11:12.000000', 'consum', 0.0228, 'lps'),
	(686280, 136, '2015-02-01 00:11:13.000000', 'consum', 0.0216, 'lps'),
	(686281, 136, '2015-02-01 00:11:14.000000', 'consum', 0.0255, 'lps'),
	(686282, 136, '2015-02-01 00:11:15.000000', 'consum', 0.0220, 'lps'),
	(686283, 136, '2015-02-01 00:11:16.000000', 'consum', 0.0255, 'lps'),
	(686284, 136, '2015-02-01 00:11:17.000000', 'consum', 0.0212, 'lps'),
	(686285, 136, '2015-02-01 00:11:18.000000', 'consum', 0.0216, 'lps'),
	(686286, 136, '2015-02-01 00:11:19.000000', 'consum', 0.0235, 'lps'),
	(686287, 136, '2015-02-01 00:11:20.000000', 'consum', 0.0251, 'lps'),
	(686288, 136, '2015-02-01 00:11:21.000000', 'consum', 0.0210, 'lps'),
	(686289, 136, '2015-02-01 00:11:22.000000', 'consum', 0.0217, 'lps'),
	(686290, 136, '2015-02-01 00:11:23.000000', 'consum', 0.0245, 'lps'),
	(686291, 136, '2015-02-01 00:11:24.000000', 'consum', 0.0234, 'lps'),
	(686292, 136, '2015-02-01 00:11:25.000000', 'consum', 0.0225, 'lps'),
	(686293, 136, '2015-02-01 00:11:26.000000', 'consum', 0.0214, 'lps'),
	(686294, 136, '2015-02-01 00:11:27.000000', 'consum', 0.0252, 'lps'),
	(686295, 136, '2015-02-01 00:11:28.000000', 'consum', 0.0214, 'lps'),
	(686296, 136, '2015-02-01 00:11:29.000000', 'consum', 0.0235, 'lps'),
	(686297, 136, '2015-02-01 00:11:30.000000', 'consum', 0.0259, 'lps'),
	(686298, 136, '2015-02-01 00:11:31.000000', 'consum', 0.0250, 'lps'),
	(686299, 136, '2015-02-01 00:11:32.000000', 'consum', 0.0262, 'lps'),
	(686300, 136, '2015-02-01 00:11:33.000000', 'consum', 0.0221, 'lps'),
	(686301, 136, '2015-02-01 00:11:34.000000', 'consum', 0.0238, 'lps'),
	(686302, 136, '2015-02-01 00:11:35.000000', 'consum', 0.0253, 'lps'),
	(686303, 136, '2015-02-01 00:11:36.000000', 'consum', 0.0212, 'lps'),
	(686304, 136, '2015-02-01 00:11:37.000000', 'consum', 0.0219, 'lps'),
	(686305, 136, '2015-02-01 00:11:38.000000', 'consum', 0.0253, 'lps'),
	(686306, 136, '2015-02-01 00:11:39.000000', 'consum', 0.0268, 'lps'),
	(686307, 136, '2015-02-01 00:11:40.000000', 'consum', 0.0242, 'lps'),
	(686308, 136, '2015-02-01 00:11:41.000000', 'consum', 0.0260, 'lps'),
	(686309, 136, '2015-02-01 00:11:42.000000', 'consum', 0.0236, 'lps'),
	(686310, 136, '2015-02-01 00:11:43.000000', 'consum', 0.0255, 'lps'),
	(686311, 136, '2015-02-01 00:11:44.000000', 'consum', 0.0228, 'lps'),
	(686312, 136, '2015-02-01 00:11:45.000000', 'consum', 0.0230, 'lps'),
	(686313, 136, '2015-02-01 00:11:46.000000', 'consum', 0.0256, 'lps'),
	(686314, 136, '2015-02-01 00:11:47.000000', 'consum', 0.0250, 'lps'),
	(686315, 136, '2015-02-01 00:11:48.000000', 'consum', 0.0274, 'lps'),
	(686316, 136, '2015-02-01 00:11:49.000000', 'consum', 0.0215, 'lps'),
	(686317, 136, '2015-02-01 00:11:50.000000', 'consum', 0.0238, 'lps'),
	(686318, 136, '2015-02-01 00:11:51.000000', 'consum', 0.0273, 'lps'),
	(686319, 136, '2015-02-01 00:11:52.000000', 'consum', 0.0244, 'lps'),
	(686320, 136, '2015-02-01 00:11:53.000000', 'consum', 0.0258, 'lps'),
	(686321, 136, '2015-02-01 00:11:54.000000', 'consum', 0.0217, 'lps'),
	(686322, 136, '2015-02-01 00:11:55.000000', 'consum', 0.0230, 'lps'),
	(686323, 136, '2015-02-01 00:11:56.000000', 'consum', 0.0228, 'lps'),
	(686324, 136, '2015-02-01 00:11:57.000000', 'consum', 0.0238, 'lps'),
	(686325, 136, '2015-02-01 00:11:58.000000', 'consum', 0.0232, 'lps'),
	(686326, 136, '2015-02-01 00:11:59.000000', 'consum', 0.0236, 'lps'),
	(686327, 136, '2015-02-01 00:12:00.000000', 'consum', 0.0210, 'lps'),
	(686328, 136, '2015-02-01 00:12:01.000000', 'consum', 0.0263, 'lps'),
	(686329, 136, '2015-02-01 00:12:02.000000', 'consum', 0.0213, 'lps'),
	(686330, 136, '2015-02-01 00:12:03.000000', 'consum', 0.0264, 'lps'),
	(686331, 136, '2015-02-01 00:12:04.000000', 'consum', 0.0213, 'lps'),
	(686332, 136, '2015-02-01 00:12:05.000000', 'consum', 0.0256, 'lps'),
	(686333, 136, '2015-02-01 00:12:06.000000', 'consum', 0.0237, 'lps'),
	(686334, 136, '2015-02-01 00:12:07.000000', 'consum', 0.0272, 'lps'),
	(686335, 136, '2015-02-01 00:12:08.000000', 'consum', 0.0244, 'lps'),
	(686336, 136, '2015-02-01 00:12:09.000000', 'consum', 0.0260, 'lps'),
	(686337, 136, '2015-02-01 00:12:10.000000', 'consum', 0.0230, 'lps'),
	(686338, 136, '2015-02-01 00:12:11.000000', 'consum', 0.0224, 'lps'),
	(686339, 136, '2015-02-01 00:12:12.000000', 'consum', 0.0221, 'lps'),
	(686340, 136, '2015-02-01 00:12:13.000000', 'consum', 0.0221, 'lps'),
	(686341, 136, '2015-02-01 00:12:14.000000', 'consum', 0.0236, 'lps'),
	(686342, 136, '2015-02-01 00:12:15.000000', 'consum', 0.0242, 'lps'),
	(686343, 136, '2015-02-01 00:12:16.000000', 'consum', 0.0225, 'lps'),
	(686344, 136, '2015-02-01 00:12:17.000000', 'consum', 0.0258, 'lps'),
	(686345, 136, '2015-02-01 00:12:18.000000', 'consum', 0.0273, 'lps'),
	(686346, 136, '2015-02-01 00:12:19.000000', 'consum', 0.0252, 'lps'),
	(686347, 136, '2015-02-01 00:12:20.000000', 'consum', 0.0230, 'lps'),
	(686348, 136, '2015-02-01 00:12:21.000000', 'consum', 0.0250, 'lps'),
	(686349, 136, '2015-02-01 00:12:22.000000', 'consum', 0.0220, 'lps'),
	(686350, 136, '2015-02-01 00:12:23.000000', 'consum', 0.0272, 'lps'),
	(686351, 136, '2015-02-01 00:12:24.000000', 'consum', 0.0230, 'lps'),
	(686352, 136, '2015-02-01 00:12:25.000000', 'consum', 0.0255, 'lps'),
	(686353, 136, '2015-02-01 00:12:26.000000', 'consum', 0.0247, 'lps'),
	(686354, 136, '2015-02-01 00:12:27.000000', 'consum', 0.0259, 'lps'),
	(686355, 136, '2015-02-01 00:12:28.000000', 'consum', 0.0215, 'lps'),
	(686356, 136, '2015-02-01 00:12:29.000000', 'consum', 0.0217, 'lps'),
	(686357, 136, '2015-02-01 00:12:30.000000', 'consum', 0.0230, 'lps'),
	(686358, 136, '2015-02-01 00:12:31.000000', 'consum', 0.0227, 'lps'),
	(686359, 136, '2015-02-01 00:12:32.000000', 'consum', 0.0234, 'lps'),
	(686360, 136, '2015-02-01 00:12:33.000000', 'consum', 0.0213, 'lps'),
	(686361, 136, '2015-02-01 00:12:34.000000', 'consum', 0.0221, 'lps'),
	(686362, 136, '2015-02-01 00:12:35.000000', 'consum', 0.0257, 'lps'),
	(686363, 136, '2015-02-01 00:12:36.000000', 'consum', 0.0218, 'lps'),
	(686364, 136, '2015-02-01 00:12:37.000000', 'consum', 0.0238, 'lps'),
	(686365, 136, '2015-02-01 00:12:38.000000', 'consum', 0.0263, 'lps'),
	(686366, 136, '2015-02-01 00:12:39.000000', 'consum', 0.0262, 'lps'),
	(686367, 136, '2015-02-01 00:12:40.000000', 'consum', 0.0247, 'lps'),
	(686368, 136, '2015-02-01 00:12:41.000000', 'consum', 0.0240, 'lps'),
	(686369, 136, '2015-02-01 00:12:42.000000', 'consum', 0.0250, 'lps'),
	(686370, 136, '2015-02-01 00:12:43.000000', 'consum', 0.0254, 'lps'),
	(686371, 136, '2015-02-01 00:12:44.000000', 'consum', 0.0247, 'lps'),
	(686372, 136, '2015-02-01 00:12:45.000000', 'consum', 0.0263, 'lps'),
	(686373, 136, '2015-02-01 00:12:46.000000', 'consum', 0.0232, 'lps'),
	(686374, 136, '2015-02-01 00:12:47.000000', 'consum', 0.0230, 'lps'),
	(686375, 136, '2015-02-01 00:12:48.000000', 'consum', 0.0242, 'lps'),
	(686376, 136, '2015-02-01 00:12:49.000000', 'consum', 0.0246, 'lps'),
	(686377, 136, '2015-02-01 00:12:50.000000', 'consum', 0.0232, 'lps'),
	(686378, 136, '2015-02-01 00:12:51.000000', 'consum', 0.0274, 'lps'),
	(686379, 136, '2015-02-01 00:12:52.000000', 'consum', 0.0272, 'lps'),
	(686380, 136, '2015-02-01 00:12:53.000000', 'consum', 0.0263, 'lps'),
	(686381, 136, '2015-02-01 00:12:54.000000', 'consum', 0.0225, 'lps'),
	(686382, 136, '2015-02-01 00:12:55.000000', 'consum', 0.0255, 'lps'),
	(686383, 136, '2015-02-01 00:12:56.000000', 'consum', 0.0259, 'lps'),
	(686384, 136, '2015-02-01 00:12:57.000000', 'consum', 0.0257, 'lps'),
	(686385, 136, '2015-02-01 00:12:58.000000', 'consum', 0.0235, 'lps'),
	(686386, 136, '2015-02-01 00:12:59.000000', 'consum', 0.0260, 'lps'),
	(686387, 136, '2015-02-01 00:13:00.000000', 'consum', 0.0254, 'lps'),
	(686388, 136, '2015-02-01 00:13:01.000000', 'consum', 0.0214, 'lps'),
	(686389, 136, '2015-02-01 00:13:02.000000', 'consum', 0.0230, 'lps'),
	(686390, 136, '2015-02-01 00:13:03.000000', 'consum', 0.0232, 'lps'),
	(686391, 136, '2015-02-01 00:13:04.000000', 'consum', 0.0264, 'lps'),
	(686392, 136, '2015-02-01 00:13:05.000000', 'consum', 0.0216, 'lps'),
	(686393, 136, '2015-02-01 00:13:06.000000', 'consum', 0.0274, 'lps'),
	(686394, 136, '2015-02-01 00:13:07.000000', 'consum', 0.0253, 'lps'),
	(686395, 136, '2015-02-01 00:13:08.000000', 'consum', 0.0233, 'lps'),
	(686396, 136, '2015-02-01 00:13:09.000000', 'consum', 0.0261, 'lps'),
	(686397, 136, '2015-02-01 00:13:10.000000', 'consum', 0.0266, 'lps'),
	(686398, 136, '2015-02-01 00:13:11.000000', 'consum', 0.0271, 'lps'),
	(686399, 136, '2015-02-01 00:13:12.000000', 'consum', 0.0221, 'lps'),
	(686400, 136, '2015-02-01 00:13:13.000000', 'consum', 0.0212, 'lps'),
	(686401, 136, '2015-02-01 00:13:14.000000', 'consum', 0.0252, 'lps'),
	(686402, 136, '2015-02-01 00:13:15.000000', 'consum', 0.0220, 'lps'),
	(686403, 136, '2015-02-01 00:13:16.000000', 'consum', 0.0264, 'lps'),
	(686404, 136, '2015-02-01 00:13:17.000000', 'consum', 0.0254, 'lps'),
	(686405, 136, '2015-02-01 00:13:18.000000', 'consum', 0.0268, 'lps'),
	(686406, 136, '2015-02-01 00:13:19.000000', 'consum', 0.0238, 'lps'),
	(686407, 136, '2015-02-01 00:13:20.000000', 'consum', 0.0244, 'lps'),
	(686408, 136, '2015-02-01 00:13:21.000000', 'consum', 0.0230, 'lps'),
	(686409, 136, '2015-02-01 00:13:22.000000', 'consum', 0.0211, 'lps'),
	(686410, 136, '2015-02-01 00:13:23.000000', 'consum', 0.0217, 'lps'),
	(686411, 136, '2015-02-01 00:13:24.000000', 'consum', 0.0243, 'lps'),
	(686412, 136, '2015-02-01 00:13:25.000000', 'consum', 0.0227, 'lps'),
	(686413, 136, '2015-02-01 00:13:26.000000', 'consum', 0.0260, 'lps'),
	(686414, 136, '2015-02-01 00:13:27.000000', 'consum', 0.0216, 'lps'),
	(686415, 136, '2015-02-01 00:13:28.000000', 'consum', 0.0221, 'lps'),
	(686416, 136, '2015-02-01 00:13:29.000000', 'consum', 0.0246, 'lps'),
	(686417, 136, '2015-02-01 00:13:30.000000', 'consum', 0.0229, 'lps'),
	(686418, 136, '2015-02-01 00:13:31.000000', 'consum', 0.0263, 'lps'),
	(686419, 136, '2015-02-01 00:13:32.000000', 'consum', 0.0222, 'lps'),
	(686420, 136, '2015-02-01 00:13:33.000000', 'consum', 0.0242, 'lps'),
	(686421, 136, '2015-02-01 00:13:34.000000', 'consum', 0.0270, 'lps'),
	(686422, 136, '2015-02-01 00:13:35.000000', 'consum', 0.0217, 'lps'),
	(686423, 136, '2015-02-01 00:13:36.000000', 'consum', 0.0263, 'lps'),
	(686424, 136, '2015-02-01 00:13:37.000000', 'consum', 0.0257, 'lps'),
	(686425, 136, '2015-02-01 00:13:38.000000', 'consum', 0.0224, 'lps'),
	(686426, 136, '2015-02-01 00:13:39.000000', 'consum', 0.0270, 'lps'),
	(686427, 136, '2015-02-01 00:13:40.000000', 'consum', 0.0271, 'lps'),
	(686428, 136, '2015-02-01 00:13:41.000000', 'consum', 0.0273, 'lps'),
	(686429, 136, '2015-02-01 00:13:42.000000', 'consum', 0.0214, 'lps'),
	(686430, 136, '2015-02-01 00:13:43.000000', 'consum', 0.0233, 'lps'),
	(686431, 136, '2015-02-01 00:13:44.000000', 'consum', 0.0248, 'lps'),
	(686432, 136, '2015-02-01 00:13:45.000000', 'consum', 0.0268, 'lps'),
	(686433, 136, '2015-02-01 00:13:46.000000', 'consum', 0.0256, 'lps'),
	(686434, 136, '2015-02-01 00:13:47.000000', 'consum', 0.0267, 'lps'),
	(686435, 136, '2015-02-01 00:13:48.000000', 'consum', 0.0226, 'lps'),
	(686436, 136, '2015-02-01 00:13:49.000000', 'consum', 0.0250, 'lps'),
	(686437, 136, '2015-02-01 00:13:50.000000', 'consum', 0.0232, 'lps'),
	(686438, 136, '2015-02-01 00:13:51.000000', 'consum', 0.0268, 'lps'),
	(686439, 136, '2015-02-01 00:13:52.000000', 'consum', 0.0237, 'lps'),
	(686440, 136, '2015-02-01 00:13:53.000000', 'consum', 0.0239, 'lps'),
	(686441, 136, '2015-02-01 00:13:54.000000', 'consum', 0.0274, 'lps'),
	(686442, 136, '2015-02-01 00:13:55.000000', 'consum', 0.0247, 'lps'),
	(686443, 136, '2015-02-01 00:13:56.000000', 'consum', 0.0268, 'lps'),
	(686444, 136, '2015-02-01 00:13:57.000000', 'consum', 0.0262, 'lps'),
	(686445, 136, '2015-02-01 00:13:58.000000', 'consum', 0.0232, 'lps'),
	(686446, 136, '2015-02-01 00:13:59.000000', 'consum', 0.0230, 'lps'),
	(686447, 136, '2015-02-01 00:14:00.000000', 'consum', 0.0244, 'lps'),
	(686448, 136, '2015-02-01 00:14:01.000000', 'consum', 0.0253, 'lps'),
	(686449, 136, '2015-02-01 00:14:02.000000', 'consum', 0.0261, 'lps'),
	(686450, 136, '2015-02-01 00:14:03.000000', 'consum', 0.0273, 'lps'),
	(686451, 136, '2015-02-01 00:14:04.000000', 'consum', 0.0240, 'lps'),
	(686452, 136, '2015-02-01 00:14:05.000000', 'consum', 0.0236, 'lps'),
	(686453, 136, '2015-02-01 00:14:06.000000', 'consum', 0.0249, 'lps'),
	(686454, 136, '2015-02-01 00:14:07.000000', 'consum', 0.0265, 'lps'),
	(686455, 136, '2015-02-01 00:14:08.000000', 'consum', 0.0237, 'lps'),
	(686456, 136, '2015-02-01 00:14:09.000000', 'consum', 0.0246, 'lps'),
	(686457, 136, '2015-02-01 00:14:10.000000', 'consum', 0.0243, 'lps'),
	(686458, 136, '2015-02-01 00:14:11.000000', 'consum', 0.0268, 'lps'),
	(686459, 136, '2015-02-01 00:14:12.000000', 'consum', 0.0270, 'lps'),
	(686460, 136, '2015-02-01 00:14:13.000000', 'consum', 0.0274, 'lps'),
	(686461, 136, '2015-02-01 00:14:14.000000', 'consum', 0.0218, 'lps'),
	(686462, 136, '2015-02-01 00:14:15.000000', 'consum', 0.0254, 'lps'),
	(686463, 136, '2015-02-01 00:14:16.000000', 'consum', 0.0211, 'lps'),
	(686464, 136, '2015-02-01 00:14:17.000000', 'consum', 0.0213, 'lps'),
	(686465, 136, '2015-02-01 00:14:18.000000', 'consum', 0.0224, 'lps'),
	(686466, 136, '2015-02-01 00:14:19.000000', 'consum', 0.0270, 'lps'),
	(686467, 136, '2015-02-01 00:14:20.000000', 'consum', 0.0272, 'lps'),
	(686468, 136, '2015-02-01 00:14:21.000000', 'consum', 0.0213, 'lps'),
	(686469, 136, '2015-02-01 00:14:22.000000', 'consum', 0.0232, 'lps'),
	(686470, 136, '2015-02-01 00:14:23.000000', 'consum', 0.0249, 'lps'),
	(686471, 136, '2015-02-01 00:14:24.000000', 'consum', 0.0274, 'lps'),
	(686472, 136, '2015-02-01 00:14:25.000000', 'consum', 0.0218, 'lps'),
	(686473, 136, '2015-02-01 00:14:26.000000', 'consum', 0.0254, 'lps'),
	(686474, 136, '2015-02-01 00:14:27.000000', 'consum', 0.0213, 'lps'),
	(686475, 136, '2015-02-01 00:14:28.000000', 'consum', 0.0223, 'lps'),
	(686476, 136, '2015-02-01 00:14:29.000000', 'consum', 0.0266, 'lps'),
	(686477, 136, '2015-02-01 00:14:30.000000', 'consum', 0.0255, 'lps'),
	(686478, 136, '2015-02-01 00:14:31.000000', 'consum', 0.0267, 'lps'),
	(686479, 136, '2015-02-01 00:14:32.000000', 'consum', 0.0232, 'lps'),
	(686480, 136, '2015-02-01 00:14:33.000000', 'consum', 0.0212, 'lps'),
	(686481, 136, '2015-02-01 00:14:34.000000', 'consum', 0.0223, 'lps'),
	(686482, 136, '2015-02-01 00:14:35.000000', 'consum', 0.0266, 'lps'),
	(686483, 136, '2015-02-01 00:14:36.000000', 'consum', 0.0258, 'lps'),
	(686484, 136, '2015-02-01 00:14:37.000000', 'consum', 0.0218, 'lps'),
	(686485, 136, '2015-02-01 00:14:38.000000', 'consum', 0.0236, 'lps'),
	(686486, 136, '2015-02-01 00:14:39.000000', 'consum', 0.0250, 'lps'),
	(686487, 136, '2015-02-01 00:14:40.000000', 'consum', 0.0267, 'lps'),
	(686488, 136, '2015-02-01 00:14:41.000000', 'consum', 0.0247, 'lps'),
	(686489, 136, '2015-02-01 00:14:42.000000', 'consum', 0.0223, 'lps'),
	(686490, 136, '2015-02-01 00:14:43.000000', 'consum', 0.0229, 'lps'),
	(686491, 136, '2015-02-01 00:14:44.000000', 'consum', 0.0266, 'lps'),
	(686492, 136, '2015-02-01 00:14:45.000000', 'consum', 0.0238, 'lps'),
	(686493, 136, '2015-02-01 00:14:46.000000', 'consum', 0.0250, 'lps'),
	(686494, 136, '2015-02-01 00:14:47.000000', 'consum', 0.0260, 'lps'),
	(686495, 136, '2015-02-01 00:14:48.000000', 'consum', 0.0211, 'lps'),
	(686496, 136, '2015-02-01 00:14:49.000000', 'consum', 0.0259, 'lps'),
	(686497, 136, '2015-02-01 00:14:50.000000', 'consum', 0.0261, 'lps'),
	(686498, 136, '2015-02-01 00:14:51.000000', 'consum', 0.0250, 'lps'),
	(686499, 136, '2015-02-01 00:14:52.000000', 'consum', 0.0258, 'lps'),
	(686500, 136, '2015-02-01 00:14:53.000000', 'consum', 0.0264, 'lps'),
	(686501, 136, '2015-02-01 00:14:54.000000', 'consum', 0.0273, 'lps'),
	(686502, 136, '2015-02-01 00:14:55.000000', 'consum', 0.0232, 'lps'),
	(686503, 136, '2015-02-01 00:14:56.000000', 'consum', 0.0260, 'lps'),
	(686504, 136, '2015-02-01 00:14:57.000000', 'consum', 0.0268, 'lps'),
	(686505, 136, '2015-02-01 00:14:58.000000', 'consum', 0.0221, 'lps'),
	(686506, 136, '2015-02-01 00:14:59.000000', 'consum', 0.0219, 'lps'),
	(686507, 136, '2015-02-01 00:15:00.000000', 'consum', 0.0222, 'lps'),
	(686508, 136, '2015-02-01 00:15:01.000000', 'consum', 0.0244, 'lps'),
	(686509, 136, '2015-02-01 00:15:02.000000', 'consum', 0.0216, 'lps'),
	(686510, 136, '2015-02-01 00:15:03.000000', 'consum', 0.0268, 'lps'),
	(686511, 136, '2015-02-01 00:15:04.000000', 'consum', 0.0224, 'lps'),
	(686512, 136, '2015-02-01 00:15:05.000000', 'consum', 0.0234, 'lps'),
	(686513, 136, '2015-02-01 00:15:06.000000', 'consum', 0.0225, 'lps'),
	(686514, 136, '2015-02-01 00:15:07.000000', 'consum', 0.0212, 'lps'),
	(686515, 136, '2015-02-01 00:15:08.000000', 'consum', 0.0240, 'lps'),
	(686516, 136, '2015-02-01 00:15:09.000000', 'consum', 0.0227, 'lps'),
	(686517, 136, '2015-02-01 00:15:10.000000', 'consum', 0.0272, 'lps'),
	(686518, 136, '2015-02-01 00:15:11.000000', 'consum', 0.0271, 'lps'),
	(686519, 136, '2015-02-01 00:15:12.000000', 'consum', 0.0264, 'lps'),
	(686520, 136, '2015-02-01 00:15:13.000000', 'consum', 0.0233, 'lps'),
	(686521, 136, '2015-02-01 00:15:14.000000', 'consum', 0.0230, 'lps'),
	(686522, 136, '2015-02-01 00:15:15.000000', 'consum', 0.0242, 'lps'),
	(686523, 136, '2015-02-01 00:15:16.000000', 'consum', 0.0246, 'lps'),
	(686524, 136, '2015-02-01 00:15:17.000000', 'consum', 0.0230, 'lps'),
	(686525, 136, '2015-02-01 00:15:18.000000', 'consum', 0.0267, 'lps'),
	(686526, 136, '2015-02-01 00:15:19.000000', 'consum', 0.0240, 'lps'),
	(686527, 136, '2015-02-01 00:15:20.000000', 'consum', 0.0256, 'lps'),
	(686528, 136, '2015-02-01 00:15:21.000000', 'consum', 0.0221, 'lps'),
	(686529, 136, '2015-02-01 00:15:22.000000', 'consum', 0.0256, 'lps'),
	(686530, 136, '2015-02-01 00:15:23.000000', 'consum', 0.0211, 'lps'),
	(686531, 136, '2015-02-01 00:15:24.000000', 'consum', 0.0210, 'lps'),
	(686532, 136, '2015-02-01 00:15:25.000000', 'consum', 0.0270, 'lps'),
	(686533, 136, '2015-02-01 00:15:26.000000', 'consum', 0.0252, 'lps'),
	(686534, 136, '2015-02-01 00:15:27.000000', 'consum', 0.0241, 'lps'),
	(686535, 136, '2015-02-01 00:15:28.000000', 'consum', 0.0240, 'lps'),
	(686536, 136, '2015-02-01 00:15:29.000000', 'consum', 0.0266, 'lps'),
	(686537, 136, '2015-02-01 00:15:30.000000', 'consum', 0.0271, 'lps'),
	(686538, 136, '2015-02-01 00:15:31.000000', 'consum', 0.0220, 'lps'),
	(686539, 136, '2015-02-01 00:15:32.000000', 'consum', 0.0269, 'lps'),
	(686540, 136, '2015-02-01 00:15:33.000000', 'consum', 0.0216, 'lps'),
	(686541, 136, '2015-02-01 00:15:34.000000', 'consum', 0.0258, 'lps'),
	(686542, 136, '2015-02-01 00:15:35.000000', 'consum', 0.0237, 'lps'),
	(686543, 136, '2015-02-01 00:15:36.000000', 'consum', 0.0267, 'lps'),
	(686544, 136, '2015-02-01 00:15:37.000000', 'consum', 0.0222, 'lps'),
	(686545, 136, '2015-02-01 00:15:38.000000', 'consum', 0.0227, 'lps'),
	(686546, 136, '2015-02-01 00:15:39.000000', 'consum', 0.0259, 'lps'),
	(686547, 136, '2015-02-01 00:15:40.000000', 'consum', 0.0212, 'lps'),
	(686548, 136, '2015-02-01 00:15:41.000000', 'consum', 0.0268, 'lps'),
	(686549, 136, '2015-02-01 00:15:42.000000', 'consum', 0.0236, 'lps'),
	(686550, 136, '2015-02-01 00:15:43.000000', 'consum', 0.0229, 'lps'),
	(686551, 136, '2015-02-01 00:15:44.000000', 'consum', 0.0229, 'lps'),
	(686552, 136, '2015-02-01 00:15:45.000000', 'consum', 0.0250, 'lps'),
	(686553, 136, '2015-02-01 00:15:46.000000', 'consum', 0.0221, 'lps'),
	(686554, 136, '2015-02-01 00:15:47.000000', 'consum', 0.0211, 'lps'),
	(686555, 136, '2015-02-01 00:15:48.000000', 'consum', 0.0249, 'lps'),
	(686556, 136, '2015-02-01 00:15:49.000000', 'consum', 0.0274, 'lps'),
	(686557, 136, '2015-02-01 00:15:50.000000', 'consum', 0.0215, 'lps'),
	(686558, 136, '2015-02-01 00:15:51.000000', 'consum', 0.0240, 'lps'),
	(686559, 136, '2015-02-01 00:15:52.000000', 'consum', 0.0216, 'lps'),
	(686560, 136, '2015-02-01 00:15:53.000000', 'consum', 0.0213, 'lps'),
	(686561, 136, '2015-02-01 00:15:54.000000', 'consum', 0.0211, 'lps'),
	(686562, 136, '2015-02-01 00:15:55.000000', 'consum', 0.0269, 'lps'),
	(686563, 136, '2015-02-01 00:15:56.000000', 'consum', 0.0244, 'lps'),
	(686564, 136, '2015-02-01 00:15:57.000000', 'consum', 0.0270, 'lps'),
	(686565, 136, '2015-02-01 00:15:58.000000', 'consum', 0.0211, 'lps'),
	(686566, 136, '2015-02-01 00:15:59.000000', 'consum', 0.0230, 'lps'),
	(686567, 136, '2015-02-01 00:16:00.000000', 'consum', 0.0242, 'lps'),
	(686568, 136, '2015-02-01 00:16:01.000000', 'consum', 0.0245, 'lps'),
	(686569, 136, '2015-02-01 00:16:02.000000', 'consum', 0.0226, 'lps'),
	(686570, 136, '2015-02-01 00:16:03.000000', 'consum', 0.0252, 'lps'),
	(686571, 136, '2015-02-01 00:16:04.000000', 'consum', 0.0241, 'lps'),
	(686572, 136, '2015-02-01 00:16:05.000000', 'consum', 0.0238, 'lps'),
	(686573, 136, '2015-02-01 00:16:06.000000', 'consum', 0.0258, 'lps'),
	(686574, 136, '2015-02-01 00:16:07.000000', 'consum', 0.0236, 'lps'),
	(686575, 136, '2015-02-01 00:16:08.000000', 'consum', 0.0260, 'lps'),
	(686576, 136, '2015-02-01 00:16:09.000000', 'consum', 0.0256, 'lps'),
	(686577, 136, '2015-02-01 00:16:10.000000', 'consum', 0.0224, 'lps'),
	(686578, 136, '2015-02-01 00:16:11.000000', 'consum', 0.0271, 'lps'),
	(686579, 136, '2015-02-01 00:16:12.000000', 'consum', 0.0215, 'lps'),
	(686580, 136, '2015-02-01 00:16:13.000000', 'consum', 0.0246, 'lps'),
	(686581, 136, '2015-02-01 00:16:14.000000', 'consum', 0.0248, 'lps'),
	(686582, 136, '2015-02-01 00:16:15.000000', 'consum', 0.0226, 'lps'),
	(686583, 136, '2015-02-01 00:16:16.000000', 'consum', 0.0241, 'lps'),
	(686584, 136, '2015-02-01 00:16:17.000000', 'consum', 0.0254, 'lps'),
	(686585, 136, '2015-02-01 00:16:18.000000', 'consum', 0.0274, 'lps'),
	(686586, 136, '2015-02-01 00:16:19.000000', 'consum', 0.0265, 'lps'),
	(686587, 136, '2015-02-01 00:16:20.000000', 'consum', 0.0232, 'lps'),
	(686588, 136, '2015-02-01 00:16:21.000000', 'consum', 0.0217, 'lps'),
	(686589, 136, '2015-02-01 00:16:22.000000', 'consum', 0.0247, 'lps'),
	(686590, 136, '2015-02-01 00:16:23.000000', 'consum', 0.0244, 'lps'),
	(686591, 136, '2015-02-01 00:16:24.000000', 'consum', 0.0267, 'lps'),
	(686592, 136, '2015-02-01 00:16:25.000000', 'consum', 0.0267, 'lps'),
	(686593, 136, '2015-02-01 00:16:26.000000', 'consum', 0.0256, 'lps'),
	(686594, 136, '2015-02-01 00:16:27.000000', 'consum', 0.0272, 'lps'),
	(686595, 136, '2015-02-01 00:16:28.000000', 'consum', 0.0251, 'lps'),
	(686596, 136, '2015-02-01 00:16:29.000000', 'consum', 0.0231, 'lps'),
	(686597, 136, '2015-02-01 00:16:30.000000', 'consum', 0.0258, 'lps'),
	(686598, 136, '2015-02-01 00:16:31.000000', 'consum', 0.0257, 'lps'),
	(686599, 136, '2015-02-01 00:16:32.000000', 'consum', 0.0237, 'lps'),
	(686600, 136, '2015-02-01 00:16:33.000000', 'consum', 0.0270, 'lps'),
	(686601, 136, '2015-02-01 00:16:34.000000', 'consum', 0.0233, 'lps'),
	(686602, 136, '2015-02-01 00:16:35.000000', 'consum', 0.0210, 'lps'),
	(686603, 136, '2015-02-01 00:16:36.000000', 'consum', 0.0272, 'lps'),
	(686604, 136, '2015-02-01 00:16:37.000000', 'consum', 0.0262, 'lps'),
	(686605, 136, '2015-02-01 00:16:38.000000', 'consum', 0.0217, 'lps'),
	(686606, 136, '2015-02-01 00:16:39.000000', 'consum', 0.0221, 'lps'),
	(686607, 136, '2015-02-01 00:16:40.000000', 'consum', 0.0246, 'lps'),
	(686608, 136, '2015-02-01 00:16:41.000000', 'consum', 0.0228, 'lps'),
	(686609, 136, '2015-02-01 00:16:42.000000', 'consum', 0.0255, 'lps'),
	(686610, 136, '2015-02-01 00:16:43.000000', 'consum', 0.0254, 'lps'),
	(686611, 136, '2015-02-01 00:16:44.000000', 'consum', 0.0230, 'lps'),
	(686612, 136, '2015-02-01 00:16:45.000000', 'consum', 0.0244, 'lps'),
	(686613, 136, '2015-02-01 00:16:46.000000', 'consum', 0.0254, 'lps'),
	(686614, 136, '2015-02-01 00:16:47.000000', 'consum', 0.0265, 'lps'),
	(686615, 136, '2015-02-01 00:16:48.000000', 'consum', 0.0225, 'lps'),
	(686616, 136, '2015-02-01 00:16:49.000000', 'consum', 0.0247, 'lps'),
	(686617, 136, '2015-02-01 00:16:50.000000', 'consum', 0.0223, 'lps'),
	(686618, 136, '2015-02-01 00:16:51.000000', 'consum', 0.0228, 'lps'),
	(686619, 136, '2015-02-01 00:16:52.000000', 'consum', 0.0262, 'lps'),
	(686620, 136, '2015-02-01 00:16:53.000000', 'consum', 0.0223, 'lps'),
	(686621, 136, '2015-02-01 00:16:54.000000', 'consum', 0.0248, 'lps'),
	(686622, 136, '2015-02-01 00:16:55.000000', 'consum', 0.0233, 'lps'),
	(686623, 136, '2015-02-01 00:16:56.000000', 'consum', 0.0213, 'lps'),
	(686624, 136, '2015-02-01 00:16:57.000000', 'consum', 0.0219, 'lps'),
	(686625, 136, '2015-02-01 00:16:58.000000', 'consum', 0.0246, 'lps'),
	(686626, 136, '2015-02-01 00:16:59.000000', 'consum', 0.0236, 'lps'),
	(686627, 136, '2015-02-01 00:17:00.000000', 'consum', 0.0230, 'lps'),
	(686628, 136, '2015-02-01 00:17:01.000000', 'consum', 0.0232, 'lps'),
	(686629, 136, '2015-02-01 00:17:02.000000', 'consum', 0.0264, 'lps'),
	(686630, 136, '2015-02-01 00:17:03.000000', 'consum', 0.0216, 'lps'),
	(686631, 136, '2015-02-01 00:17:04.000000', 'consum', 0.0273, 'lps'),
	(686632, 136, '2015-02-01 00:17:05.000000', 'consum', 0.0250, 'lps'),
	(686633, 136, '2015-02-01 00:17:06.000000', 'consum', 0.0220, 'lps'),
	(686634, 136, '2015-02-01 00:17:07.000000', 'consum', 0.0270, 'lps'),
	(686635, 136, '2015-02-01 00:17:08.000000', 'consum', 0.0219, 'lps'),
	(686636, 136, '2015-02-01 00:17:09.000000', 'consum', 0.0274, 'lps'),
	(686637, 136, '2015-02-01 00:17:10.000000', 'consum', 0.0242, 'lps'),
	(686638, 136, '2015-02-01 00:17:11.000000', 'consum', 0.0244, 'lps'),
	(686639, 136, '2015-02-01 00:17:12.000000', 'consum', 0.0220, 'lps'),
	(686640, 136, '2015-02-01 00:17:13.000000', 'consum', 0.0223, 'lps'),
	(686641, 136, '2015-02-01 00:17:14.000000', 'consum', 0.0246, 'lps'),
	(686642, 136, '2015-02-01 00:17:15.000000', 'consum', 0.0223, 'lps'),
	(686643, 136, '2015-02-01 00:17:16.000000', 'consum', 0.0231, 'lps'),
	(686644, 136, '2015-02-01 00:17:17.000000', 'consum', 0.0213, 'lps'),
	(686645, 136, '2015-02-01 00:17:18.000000', 'consum', 0.0226, 'lps'),
	(686646, 136, '2015-02-01 00:17:19.000000', 'consum', 0.0217, 'lps'),
	(686647, 136, '2015-02-01 00:17:20.000000', 'consum', 0.0264, 'lps'),
	(686648, 136, '2015-02-01 00:17:21.000000', 'consum', 0.0263, 'lps'),
	(686649, 136, '2015-02-01 00:17:22.000000', 'consum', 0.0248, 'lps'),
	(686650, 136, '2015-02-01 00:17:23.000000', 'consum', 0.0244, 'lps'),
	(686651, 136, '2015-02-01 00:17:24.000000', 'consum', 0.0263, 'lps'),
	(686652, 136, '2015-02-01 00:17:25.000000', 'consum', 0.0245, 'lps'),
	(686653, 136, '2015-02-01 00:17:26.000000', 'consum', 0.0228, 'lps'),
	(686654, 136, '2015-02-01 00:17:27.000000', 'consum', 0.0258, 'lps'),
	(686655, 136, '2015-02-01 00:17:28.000000', 'consum', 0.0269, 'lps'),
	(686656, 136, '2015-02-01 00:17:29.000000', 'consum', 0.0232, 'lps'),
	(686657, 136, '2015-02-01 00:17:30.000000', 'consum', 0.0271, 'lps'),
	(686658, 136, '2015-02-01 00:17:31.000000', 'consum', 0.0255, 'lps'),
	(686659, 136, '2015-02-01 00:17:32.000000', 'consum', 0.0255, 'lps'),
	(686660, 136, '2015-02-01 00:17:33.000000', 'consum', 0.0234, 'lps'),
	(686661, 136, '2015-02-01 00:17:34.000000', 'consum', 0.0260, 'lps'),
	(686662, 136, '2015-02-01 00:17:35.000000', 'consum', 0.0257, 'lps'),
	(686663, 136, '2015-02-01 00:17:36.000000', 'consum', 0.0232, 'lps'),
	(686664, 136, '2015-02-01 00:17:37.000000', 'consum', 0.0244, 'lps'),
	(686665, 136, '2015-02-01 00:17:38.000000', 'consum', 0.0248, 'lps'),
	(686666, 136, '2015-02-01 00:17:39.000000', 'consum', 0.0236, 'lps'),
	(686667, 136, '2015-02-01 00:17:40.000000', 'consum', 0.0224, 'lps'),
	(686668, 136, '2015-02-01 00:17:41.000000', 'consum', 0.0271, 'lps'),
	(686669, 136, '2015-02-01 00:17:42.000000', 'consum', 0.0210, 'lps'),
	(686670, 136, '2015-02-01 00:17:43.000000', 'consum', 0.0223, 'lps'),
	(686671, 136, '2015-02-01 00:17:44.000000', 'consum', 0.0212, 'lps'),
	(686672, 136, '2015-02-01 00:17:45.000000', 'consum', 0.0244, 'lps'),
	(686673, 136, '2015-02-01 00:17:46.000000', 'consum', 0.0247, 'lps'),
	(686674, 136, '2015-02-01 00:17:47.000000', 'consum', 0.0229, 'lps'),
	(686675, 136, '2015-02-01 00:17:48.000000', 'consum', 0.0260, 'lps'),
	(686676, 136, '2015-02-01 00:17:49.000000', 'consum', 0.0272, 'lps'),
	(686677, 136, '2015-02-01 00:17:50.000000', 'consum', 0.0239, 'lps'),
	(686678, 136, '2015-02-01 00:17:51.000000', 'consum', 0.0235, 'lps'),
	(686679, 136, '2015-02-01 00:17:52.000000', 'consum', 0.0248, 'lps'),
	(686680, 136, '2015-02-01 00:17:53.000000', 'consum', 0.0262, 'lps'),
	(686681, 136, '2015-02-01 00:17:54.000000', 'consum', 0.0228, 'lps'),
	(686682, 136, '2015-02-01 00:17:55.000000', 'consum', 0.0272, 'lps'),
	(686683, 136, '2015-02-01 00:17:56.000000', 'consum', 0.0272, 'lps'),
	(686684, 136, '2015-02-01 00:17:57.000000', 'consum', 0.0271, 'lps'),
	(686685, 136, '2015-02-01 00:17:58.000000', 'consum', 0.0262, 'lps'),
	(686686, 136, '2015-02-01 00:17:59.000000', 'consum', 0.0225, 'lps'),
	(686687, 136, '2015-02-01 00:18:00.000000', 'consum', 0.0261, 'lps'),
	(686688, 136, '2015-02-01 00:18:01.000000', 'consum', 0.0222, 'lps'),
	(686689, 136, '2015-02-01 00:18:02.000000', 'consum', 0.0249, 'lps'),
	(686690, 136, '2015-02-01 00:18:03.000000', 'consum', 0.0241, 'lps'),
	(686691, 136, '2015-02-01 00:18:04.000000', 'consum', 0.0246, 'lps'),
	(686692, 136, '2015-02-01 00:18:05.000000', 'consum', 0.0231, 'lps'),
	(686693, 136, '2015-02-01 00:18:06.000000', 'consum', 0.0211, 'lps'),
	(686694, 136, '2015-02-01 00:18:07.000000', 'consum', 0.0216, 'lps'),
	(686695, 136, '2015-02-01 00:18:08.000000', 'consum', 0.0239, 'lps'),
	(686696, 136, '2015-02-01 00:18:09.000000', 'consum', 0.0274, 'lps'),
	(686697, 136, '2015-02-01 00:18:10.000000', 'consum', 0.0246, 'lps'),
	(686698, 136, '2015-02-01 00:18:11.000000', 'consum', 0.0262, 'lps'),
	(686699, 136, '2015-02-01 00:18:12.000000', 'consum', 0.0235, 'lps'),
	(686700, 136, '2015-02-01 00:18:13.000000', 'consum', 0.0245, 'lps'),
	(686701, 136, '2015-02-01 00:18:14.000000', 'consum', 0.0243, 'lps'),
	(686702, 136, '2015-02-01 00:18:15.000000', 'consum', 0.0274, 'lps'),
	(686703, 136, '2015-02-01 00:18:16.000000', 'consum', 0.0234, 'lps'),
	(686704, 136, '2015-02-01 00:18:17.000000', 'consum', 0.0268, 'lps'),
	(686705, 136, '2015-02-01 00:18:18.000000', 'consum', 0.0234, 'lps'),
	(686706, 136, '2015-02-01 00:18:19.000000', 'consum', 0.0221, 'lps'),
	(686707, 136, '2015-02-01 00:18:20.000000', 'consum', 0.0257, 'lps'),
	(686708, 136, '2015-02-01 00:18:21.000000', 'consum', 0.0221, 'lps'),
	(686709, 136, '2015-02-01 00:18:22.000000', 'consum', 0.0251, 'lps'),
	(686710, 136, '2015-02-01 00:18:23.000000', 'consum', 0.0254, 'lps'),
	(686711, 136, '2015-02-01 00:18:24.000000', 'consum', 0.0242, 'lps'),
	(686712, 136, '2015-02-01 00:18:25.000000', 'consum', 0.0237, 'lps'),
	(686713, 136, '2015-02-01 00:18:26.000000', 'consum', 0.0249, 'lps'),
	(686714, 136, '2015-02-01 00:18:27.000000', 'consum', 0.0263, 'lps'),
	(686715, 136, '2015-02-01 00:18:28.000000', 'consum', 0.0226, 'lps'),
	(686716, 136, '2015-02-01 00:18:29.000000', 'consum', 0.0264, 'lps'),
	(686717, 136, '2015-02-01 00:18:30.000000', 'consum', 0.0235, 'lps'),
	(686718, 136, '2015-02-01 00:18:31.000000', 'consum', 0.0240, 'lps'),
	(686719, 136, '2015-02-01 00:18:32.000000', 'consum', 0.0222, 'lps'),
	(686720, 136, '2015-02-01 00:18:33.000000', 'consum', 0.0243, 'lps'),
	(686721, 136, '2015-02-01 00:18:34.000000', 'consum', 0.0273, 'lps'),
	(686722, 136, '2015-02-01 00:18:35.000000', 'consum', 0.0234, 'lps'),
	(686723, 136, '2015-02-01 00:18:36.000000', 'consum', 0.0270, 'lps'),
	(686724, 136, '2015-02-01 00:18:37.000000', 'consum', 0.0243, 'lps'),
	(686725, 136, '2015-02-01 00:18:38.000000', 'consum', 0.0259, 'lps'),
	(686726, 136, '2015-02-01 00:18:39.000000', 'consum', 0.0229, 'lps'),
	(686727, 136, '2015-02-01 00:18:40.000000', 'consum', 0.0222, 'lps'),
	(686728, 136, '2015-02-01 00:18:41.000000', 'consum', 0.0213, 'lps'),
	(686729, 136, '2015-02-01 00:18:42.000000', 'consum', 0.0257, 'lps'),
	(686730, 136, '2015-02-01 00:18:43.000000', 'consum', 0.0240, 'lps'),
	(686731, 136, '2015-02-01 00:18:44.000000', 'consum', 0.0220, 'lps'),
	(686732, 136, '2015-02-01 00:18:45.000000', 'consum', 0.0237, 'lps'),
	(686733, 136, '2015-02-01 00:18:46.000000', 'consum', 0.0251, 'lps'),
	(686734, 136, '2015-02-01 00:18:47.000000', 'consum', 0.0269, 'lps'),
	(686735, 136, '2015-02-01 00:18:48.000000', 'consum', 0.0251, 'lps'),
	(686736, 136, '2015-02-01 00:18:49.000000', 'consum', 0.0240, 'lps'),
	(686737, 136, '2015-02-01 00:18:50.000000', 'consum', 0.0237, 'lps'),
	(686738, 136, '2015-02-01 00:18:51.000000', 'consum', 0.0256, 'lps'),
	(686739, 136, '2015-02-01 00:18:52.000000', 'consum', 0.0229, 'lps'),
	(686740, 136, '2015-02-01 00:18:53.000000', 'consum', 0.0231, 'lps'),
	(686741, 136, '2015-02-01 00:18:54.000000', 'consum', 0.0262, 'lps'),
	(686742, 136, '2015-02-01 00:18:55.000000', 'consum', 0.0274, 'lps'),
	(686743, 136, '2015-02-01 00:18:56.000000', 'consum', 0.0246, 'lps'),
	(686744, 136, '2015-02-01 00:18:57.000000', 'consum', 0.0263, 'lps'),
	(686745, 136, '2015-02-01 00:18:58.000000', 'consum', 0.0237, 'lps'),
	(686746, 136, '2015-02-01 00:18:59.000000', 'consum', 0.0251, 'lps'),
	(686747, 136, '2015-02-01 00:19:00.000000', 'consum', 0.0271, 'lps'),
	(686748, 136, '2015-02-01 00:19:01.000000', 'consum', 0.0264, 'lps'),
	(686749, 136, '2015-02-01 00:19:02.000000', 'consum', 0.0229, 'lps'),
	(686750, 136, '2015-02-01 00:19:03.000000', 'consum', 0.0211, 'lps'),
	(686751, 136, '2015-02-01 00:19:04.000000', 'consum', 0.0224, 'lps'),
	(686752, 136, '2015-02-01 00:19:05.000000', 'consum', 0.0212, 'lps'),
	(686753, 136, '2015-02-01 00:19:06.000000', 'consum', 0.0241, 'lps'),
	(686754, 136, '2015-02-01 00:19:07.000000', 'consum', 0.0233, 'lps'),
	(686755, 136, '2015-02-01 00:19:08.000000', 'consum', 0.0230, 'lps'),
	(686756, 136, '2015-02-01 00:19:09.000000', 'consum', 0.0241, 'lps'),
	(686757, 136, '2015-02-01 00:19:10.000000', 'consum', 0.0241, 'lps'),
	(686758, 136, '2015-02-01 00:19:11.000000', 'consum', 0.0273, 'lps'),
	(686759, 136, '2015-02-01 00:19:12.000000', 'consum', 0.0235, 'lps'),
	(686760, 136, '2015-02-01 00:19:13.000000', 'consum', 0.0214, 'lps'),
	(686761, 136, '2015-02-01 00:19:14.000000', 'consum', 0.0221, 'lps'),
	(686762, 136, '2015-02-01 00:19:15.000000', 'consum', 0.0251, 'lps'),
	(686763, 136, '2015-02-01 00:19:16.000000', 'consum', 0.0255, 'lps'),
	(686764, 136, '2015-02-01 00:19:17.000000', 'consum', 0.0246, 'lps'),
	(686765, 136, '2015-02-01 00:19:18.000000', 'consum', 0.0254, 'lps'),
	(686766, 136, '2015-02-01 00:19:19.000000', 'consum', 0.0261, 'lps'),
	(686767, 136, '2015-02-01 00:19:20.000000', 'consum', 0.0266, 'lps'),
	(686768, 136, '2015-02-01 00:19:21.000000', 'consum', 0.0274, 'lps'),
	(686769, 136, '2015-02-01 00:19:22.000000', 'consum', 0.0232, 'lps'),
	(686770, 136, '2015-02-01 00:19:23.000000', 'consum', 0.0256, 'lps'),
	(686771, 136, '2015-02-01 00:19:24.000000', 'consum', 0.0248, 'lps'),
	(686772, 136, '2015-02-01 00:19:25.000000', 'consum', 0.0260, 'lps'),
	(686773, 136, '2015-02-01 00:19:26.000000', 'consum', 0.0218, 'lps'),
	(686774, 136, '2015-02-01 00:19:27.000000', 'consum', 0.0229, 'lps'),
	(686775, 136, '2015-02-01 00:19:28.000000', 'consum', 0.0216, 'lps'),
	(686776, 136, '2015-02-01 00:19:29.000000', 'consum', 0.0250, 'lps'),
	(686777, 136, '2015-02-01 00:19:30.000000', 'consum', 0.0263, 'lps'),
	(686778, 136, '2015-02-01 00:19:31.000000', 'consum', 0.0224, 'lps'),
	(686779, 136, '2015-02-01 00:19:32.000000', 'consum', 0.0250, 'lps'),
	(686780, 136, '2015-02-01 00:19:33.000000', 'consum', 0.0240, 'lps'),
	(686781, 136, '2015-02-01 00:19:34.000000', 'consum', 0.0241, 'lps'),
	(686782, 136, '2015-02-01 00:19:35.000000', 'consum', 0.0210, 'lps'),
	(686783, 136, '2015-02-01 00:19:36.000000', 'consum', 0.0249, 'lps'),
	(686784, 136, '2015-02-01 00:19:37.000000', 'consum', 0.0274, 'lps'),
	(686785, 136, '2015-02-01 00:19:38.000000', 'consum', 0.0220, 'lps'),
	(686786, 136, '2015-02-01 00:19:39.000000', 'consum', 0.0263, 'lps'),
	(686787, 136, '2015-02-01 00:19:40.000000', 'consum', 0.0249, 'lps'),
	(686788, 136, '2015-02-01 00:19:41.000000', 'consum', 0.0246, 'lps'),
	(686789, 136, '2015-02-01 00:19:42.000000', 'consum', 0.0274, 'lps'),
	(686790, 136, '2015-02-01 00:19:43.000000', 'consum', 0.0226, 'lps'),
	(686791, 136, '2015-02-01 00:19:44.000000', 'consum', 0.0231, 'lps'),
	(686792, 136, '2015-02-01 00:19:45.000000', 'consum', 0.0268, 'lps'),
	(686793, 136, '2015-02-01 00:19:46.000000', 'consum', 0.0240, 'lps'),
	(686794, 136, '2015-02-01 00:19:47.000000', 'consum', 0.0254, 'lps'),
	(686795, 136, '2015-02-01 00:19:48.000000', 'consum', 0.0274, 'lps'),
	(686796, 136, '2015-02-01 00:19:49.000000', 'consum', 0.0269, 'lps'),
	(686797, 136, '2015-02-01 00:19:50.000000', 'consum', 0.0250, 'lps'),
	(686798, 136, '2015-02-01 00:19:51.000000', 'consum', 0.0233, 'lps'),
	(686799, 136, '2015-02-01 00:19:52.000000', 'consum', 0.0270, 'lps'),
	(686800, 136, '2015-02-01 00:19:53.000000', 'consum', 0.0247, 'lps'),
	(686801, 136, '2015-02-01 00:19:54.000000', 'consum', 0.0217, 'lps'),
	(686802, 136, '2015-02-01 00:19:55.000000', 'consum', 0.0261, 'lps'),
	(686803, 136, '2015-02-01 00:19:56.000000', 'consum', 0.0252, 'lps'),
	(686804, 136, '2015-02-01 00:19:57.000000', 'consum', 0.0266, 'lps'),
	(686805, 136, '2015-02-01 00:19:58.000000', 'consum', 0.0234, 'lps'),
	(686806, 136, '2015-02-01 00:19:59.000000', 'consum', 0.0229, 'lps'),
	(686807, 136, '2015-02-01 00:20:00.000000', 'consum', 0.0231, 'lps'),
	(686808, 136, '2015-02-01 00:20:01.000000', 'consum', 0.0260, 'lps'),
	(686809, 136, '2015-02-01 00:20:02.000000', 'consum', 0.0267, 'lps'),
	(686810, 136, '2015-02-01 00:20:03.000000', 'consum', 0.0214, 'lps'),
	(686811, 136, '2015-02-01 00:20:04.000000', 'consum', 0.0257, 'lps'),
	(686812, 136, '2015-02-01 00:20:05.000000', 'consum', 0.0236, 'lps'),
	(686813, 136, '2015-02-01 00:20:06.000000', 'consum', 0.0266, 'lps'),
	(686814, 136, '2015-02-01 00:20:07.000000', 'consum', 0.0217, 'lps'),
	(686815, 136, '2015-02-01 00:20:08.000000', 'consum', 0.0272, 'lps'),
	(686816, 136, '2015-02-01 00:20:09.000000', 'consum', 0.0239, 'lps'),
	(686817, 136, '2015-02-01 00:20:10.000000', 'consum', 0.0236, 'lps'),
	(686818, 136, '2015-02-01 00:20:11.000000', 'consum', 0.0251, 'lps'),
	(686819, 136, '2015-02-01 00:20:12.000000', 'consum', 0.0273, 'lps'),
	(686820, 136, '2015-02-01 00:20:13.000000', 'consum', 0.0274, 'lps'),
	(686821, 136, '2015-02-01 00:20:14.000000', 'consum', 0.0210, 'lps'),
	(686822, 136, '2015-02-01 00:20:15.000000', 'consum', 0.0214, 'lps'),
	(686823, 136, '2015-02-01 00:20:16.000000', 'consum', 0.0231, 'lps'),
	(686824, 136, '2015-02-01 00:20:17.000000', 'consum', 0.0237, 'lps'),
	(686825, 136, '2015-02-01 00:20:18.000000', 'consum', 0.0220, 'lps'),
	(686826, 136, '2015-02-01 00:20:19.000000', 'consum', 0.0242, 'lps'),
	(686827, 136, '2015-02-01 00:20:20.000000', 'consum', 0.0211, 'lps'),
	(686828, 136, '2015-02-01 00:20:21.000000', 'consum', 0.0250, 'lps'),
	(686829, 136, '2015-02-01 00:20:22.000000', 'consum', 0.0210, 'lps'),
	(686830, 136, '2015-02-01 00:20:23.000000', 'consum', 0.0224, 'lps'),
	(686831, 136, '2015-02-01 00:20:24.000000', 'consum', 0.0215, 'lps'),
	(686832, 136, '2015-02-01 00:20:25.000000', 'consum', 0.0257, 'lps'),
	(686833, 136, '2015-02-01 00:20:26.000000', 'consum', 0.0235, 'lps'),
	(686834, 136, '2015-02-01 00:20:27.000000', 'consum', 0.0261, 'lps'),
	(686835, 136, '2015-02-01 00:20:28.000000', 'consum', 0.0259, 'lps'),
	(686836, 136, '2015-02-01 00:20:29.000000', 'consum', 0.0237, 'lps'),
	(686837, 136, '2015-02-01 00:20:30.000000', 'consum', 0.0265, 'lps'),
	(686838, 136, '2015-02-01 00:20:31.000000', 'consum', 0.0210, 'lps'),
	(686839, 136, '2015-02-01 00:20:32.000000', 'consum', 0.0242, 'lps'),
	(686840, 136, '2015-02-01 00:20:33.000000', 'consum', 0.0238, 'lps'),
	(686841, 136, '2015-02-01 00:20:34.000000', 'consum', 0.0256, 'lps'),
	(686842, 136, '2015-02-01 00:20:35.000000', 'consum', 0.0226, 'lps'),
	(686843, 136, '2015-02-01 00:20:36.000000', 'consum', 0.0218, 'lps'),
	(686844, 136, '2015-02-01 00:20:37.000000', 'consum', 0.0269, 'lps'),
	(686845, 136, '2015-02-01 00:20:38.000000', 'consum', 0.0220, 'lps'),
	(686846, 136, '2015-02-01 00:20:39.000000', 'consum', 0.0215, 'lps'),
	(686847, 136, '2015-02-01 00:20:40.000000', 'consum', 0.0268, 'lps'),
	(686848, 136, '2015-02-01 00:20:41.000000', 'consum', 0.0226, 'lps'),
	(686849, 136, '2015-02-01 00:20:42.000000', 'consum', 0.0247, 'lps'),
	(686850, 136, '2015-02-01 00:20:43.000000', 'consum', 0.0218, 'lps'),
	(686851, 136, '2015-02-01 00:20:44.000000', 'consum', 0.0269, 'lps'),
	(686852, 136, '2015-02-01 00:20:45.000000', 'consum', 0.0221, 'lps'),
	(686853, 136, '2015-02-01 00:20:46.000000', 'consum', 0.0218, 'lps'),
	(686854, 136, '2015-02-01 00:20:47.000000', 'consum', 0.0216, 'lps'),
	(686855, 136, '2015-02-01 00:20:48.000000', 'consum', 0.0219, 'lps'),
	(686856, 136, '2015-02-01 00:20:49.000000', 'consum', 0.0237, 'lps'),
	(686857, 136, '2015-02-01 00:20:50.000000', 'consum', 0.0254, 'lps'),
	(686858, 136, '2015-02-01 00:20:51.000000', 'consum', 0.0218, 'lps'),
	(686859, 136, '2015-02-01 00:20:52.000000', 'consum', 0.0250, 'lps'),
	(686860, 136, '2015-02-01 00:20:53.000000', 'consum', 0.0256, 'lps'),
	(686861, 136, '2015-02-01 00:20:54.000000', 'consum', 0.0255, 'lps'),
	(686862, 136, '2015-02-01 00:20:55.000000', 'consum', 0.0234, 'lps'),
	(686863, 136, '2015-02-01 00:20:56.000000', 'consum', 0.0260, 'lps'),
	(686864, 136, '2015-02-01 00:20:57.000000', 'consum', 0.0259, 'lps'),
	(686865, 136, '2015-02-01 00:20:58.000000', 'consum', 0.0241, 'lps'),
	(686866, 136, '2015-02-01 00:20:59.000000', 'consum', 0.0218, 'lps'),
	(686867, 136, '2015-02-01 00:21:00.000000', 'consum', 0.0223, 'lps'),
	(686868, 136, '2015-02-01 00:21:01.000000', 'consum', 0.0251, 'lps'),
	(686869, 136, '2015-02-01 00:21:02.000000', 'consum', 0.0248, 'lps'),
	(686870, 136, '2015-02-01 00:21:03.000000', 'consum', 0.0211, 'lps'),
	(686871, 136, '2015-02-01 00:21:04.000000', 'consum', 0.0231, 'lps'),
	(686872, 136, '2015-02-01 00:21:05.000000', 'consum', 0.0246, 'lps'),
	(686873, 136, '2015-02-01 00:21:06.000000', 'consum', 0.0264, 'lps'),
	(686874, 136, '2015-02-01 00:21:07.000000', 'consum', 0.0243, 'lps'),
	(686875, 136, '2015-02-01 00:21:08.000000', 'consum', 0.0212, 'lps'),
	(686876, 136, '2015-02-01 00:21:09.000000', 'consum', 0.0252, 'lps'),
	(686877, 136, '2015-02-01 00:21:10.000000', 'consum', 0.0218, 'lps'),
	(686878, 136, '2015-02-01 00:21:11.000000', 'consum', 0.0256, 'lps'),
	(686879, 136, '2015-02-01 00:21:12.000000', 'consum', 0.0222, 'lps'),
	(686880, 136, '2015-02-01 00:21:13.000000', 'consum', 0.0261, 'lps'),
	(686881, 136, '2015-02-01 00:21:14.000000', 'consum', 0.0235, 'lps'),
	(686882, 136, '2015-02-01 00:21:15.000000', 'consum', 0.0248, 'lps'),
	(686883, 136, '2015-02-01 00:21:16.000000', 'consum', 0.0260, 'lps'),
	(686884, 136, '2015-02-01 00:21:17.000000', 'consum', 0.0216, 'lps'),
	(686885, 136, '2015-02-01 00:21:18.000000', 'consum', 0.0220, 'lps'),
	(686886, 136, '2015-02-01 00:21:19.000000', 'consum', 0.0245, 'lps'),
	(686887, 136, '2015-02-01 00:21:20.000000', 'consum', 0.0225, 'lps'),
	(686888, 136, '2015-02-01 00:21:21.000000', 'consum', 0.0243, 'lps'),
	(686889, 136, '2015-02-01 00:21:22.000000', 'consum', 0.0269, 'lps'),
	(686890, 136, '2015-02-01 00:21:23.000000', 'consum', 0.0273, 'lps'),
	(686891, 136, '2015-02-01 00:21:24.000000', 'consum', 0.0220, 'lps'),
	(686892, 136, '2015-02-01 00:21:25.000000', 'consum', 0.0265, 'lps'),
	(686893, 136, '2015-02-01 00:21:26.000000', 'consum', 0.0262, 'lps'),
	(686894, 136, '2015-02-01 00:21:27.000000', 'consum', 0.0239, 'lps'),
	(686895, 136, '2015-02-01 00:21:28.000000', 'consum', 0.0266, 'lps'),
	(686896, 136, '2015-02-01 00:21:29.000000', 'consum', 0.0274, 'lps'),
	(686897, 136, '2015-02-01 00:21:30.000000', 'consum', 0.0230, 'lps'),
	(686898, 136, '2015-02-01 00:21:31.000000', 'consum', 0.0252, 'lps'),
	(686899, 136, '2015-02-01 00:21:32.000000', 'consum', 0.0228, 'lps'),
	(686900, 136, '2015-02-01 00:21:33.000000', 'consum', 0.0242, 'lps'),
	(686901, 136, '2015-02-01 00:21:34.000000', 'consum', 0.0249, 'lps'),
	(686902, 136, '2015-02-01 00:21:35.000000', 'consum', 0.0245, 'lps'),
	(686903, 136, '2015-02-01 00:21:36.000000', 'consum', 0.0267, 'lps'),
	(686904, 136, '2015-02-01 00:21:37.000000', 'consum', 0.0263, 'lps'),
	(686905, 136, '2015-02-01 00:21:38.000000', 'consum', 0.0237, 'lps'),
	(686906, 136, '2015-02-01 00:21:39.000000', 'consum', 0.0252, 'lps'),
	(686907, 136, '2015-02-01 00:21:40.000000', 'consum', 0.0273, 'lps'),
	(686908, 136, '2015-02-01 00:21:41.000000', 'consum', 0.0272, 'lps'),
	(686909, 136, '2015-02-01 00:21:42.000000', 'consum', 0.0268, 'lps'),
	(686910, 136, '2015-02-01 00:21:43.000000', 'consum', 0.0247, 'lps'),
	(686911, 136, '2015-02-01 00:21:44.000000', 'consum', 0.0222, 'lps'),
	(686912, 136, '2015-02-01 00:21:45.000000', 'consum', 0.0224, 'lps'),
	(686913, 136, '2015-02-01 00:21:46.000000', 'consum', 0.0247, 'lps'),
	(686914, 136, '2015-02-01 00:21:47.000000', 'consum', 0.0221, 'lps'),
	(686915, 136, '2015-02-01 00:21:48.000000', 'consum', 0.0220, 'lps'),
	(686916, 136, '2015-02-01 00:21:49.000000', 'consum', 0.0226, 'lps'),
	(686917, 136, '2015-02-01 00:21:50.000000', 'consum', 0.0264, 'lps'),
	(686918, 136, '2015-02-01 00:21:51.000000', 'consum', 0.0234, 'lps'),
	(686919, 136, '2015-02-01 00:21:52.000000', 'consum', 0.0236, 'lps'),
	(686920, 136, '2015-02-01 00:21:53.000000', 'consum', 0.0269, 'lps'),
	(686921, 136, '2015-02-01 00:21:54.000000', 'consum', 0.0233, 'lps'),
	(686922, 136, '2015-02-01 00:21:55.000000', 'consum', 0.0212, 'lps'),
	(686923, 136, '2015-02-01 00:21:56.000000', 'consum', 0.0219, 'lps'),
	(686924, 136, '2015-02-01 00:21:57.000000', 'consum', 0.0247, 'lps'),
	(686925, 136, '2015-02-01 00:21:58.000000', 'consum', 0.0240, 'lps'),
	(686926, 136, '2015-02-01 00:21:59.000000', 'consum', 0.0250, 'lps'),
	(686927, 136, '2015-02-01 00:22:00.000000', 'consum', 0.0253, 'lps'),
	(686928, 136, '2015-02-01 00:22:01.000000', 'consum', 0.0243, 'lps'),
	(686929, 136, '2015-02-01 00:22:02.000000', 'consum', 0.0245, 'lps'),
	(686930, 136, '2015-02-01 00:22:03.000000', 'consum', 0.0222, 'lps'),
	(686931, 136, '2015-02-01 00:22:04.000000', 'consum', 0.0231, 'lps'),
	(686932, 136, '2015-02-01 00:22:05.000000', 'consum', 0.0215, 'lps'),
	(686933, 136, '2015-02-01 00:22:06.000000', 'consum', 0.0236, 'lps'),
	(686934, 136, '2015-02-01 00:22:07.000000', 'consum', 0.0260, 'lps'),
	(686935, 136, '2015-02-01 00:22:08.000000', 'consum', 0.0254, 'lps'),
	(686936, 136, '2015-02-01 00:22:09.000000', 'consum', 0.0214, 'lps'),
	(686937, 136, '2015-02-01 00:22:10.000000', 'consum', 0.0230, 'lps'),
	(686938, 136, '2015-02-01 00:22:11.000000', 'consum', 0.0233, 'lps'),
	(686939, 136, '2015-02-01 00:22:12.000000', 'consum', 0.0264, 'lps'),
	(686940, 136, '2015-02-01 00:22:13.000000', 'consum', 0.0219, 'lps'),
	(686941, 136, '2015-02-01 00:22:14.000000', 'consum', 0.0222, 'lps'),
	(686942, 136, '2015-02-01 00:22:15.000000', 'consum', 0.0245, 'lps'),
	(686943, 136, '2015-02-01 00:22:16.000000', 'consum', 0.0219, 'lps'),
	(686944, 136, '2015-02-01 00:22:17.000000', 'consum', 0.0214, 'lps'),
	(686945, 136, '2015-02-01 00:22:18.000000', 'consum', 0.0268, 'lps'),
	(686946, 136, '2015-02-01 00:22:19.000000', 'consum', 0.0228, 'lps'),
	(686947, 136, '2015-02-01 00:22:20.000000', 'consum', 0.0256, 'lps'),
	(686948, 136, '2015-02-01 00:22:21.000000', 'consum', 0.0256, 'lps'),
	(686949, 136, '2015-02-01 00:22:22.000000', 'consum', 0.0239, 'lps'),
	(686950, 136, '2015-02-01 00:22:23.000000', 'consum', 0.0217, 'lps'),
	(686951, 136, '2015-02-01 00:22:24.000000', 'consum', 0.0222, 'lps'),
	(686952, 136, '2015-02-01 00:22:25.000000', 'consum', 0.0251, 'lps'),
	(686953, 136, '2015-02-01 00:22:26.000000', 'consum', 0.0251, 'lps'),
	(686954, 136, '2015-02-01 00:22:27.000000', 'consum', 0.0225, 'lps'),
	(686955, 136, '2015-02-01 00:22:28.000000', 'consum', 0.0229, 'lps'),
	(686956, 136, '2015-02-01 00:22:29.000000', 'consum', 0.0258, 'lps'),
	(686957, 136, '2015-02-01 00:22:30.000000', 'consum', 0.0266, 'lps'),
	(686958, 136, '2015-02-01 00:22:31.000000', 'consum', 0.0214, 'lps'),
	(686959, 136, '2015-02-01 00:22:32.000000', 'consum', 0.0257, 'lps'),
	(686960, 136, '2015-02-01 00:22:33.000000', 'consum', 0.0241, 'lps'),
	(686961, 136, '2015-02-01 00:22:34.000000', 'consum', 0.0225, 'lps'),
	(686962, 136, '2015-02-01 00:22:35.000000', 'consum', 0.0257, 'lps'),
	(686963, 136, '2015-02-01 00:22:36.000000', 'consum', 0.0268, 'lps'),
	(686964, 136, '2015-02-01 00:22:37.000000', 'consum', 0.0233, 'lps'),
	(686965, 136, '2015-02-01 00:22:38.000000', 'consum', 0.0213, 'lps'),
	(686966, 136, '2015-02-01 00:22:39.000000', 'consum', 0.0223, 'lps'),
	(686967, 136, '2015-02-01 00:22:40.000000', 'consum', 0.0266, 'lps'),
	(686968, 136, '2015-02-01 00:22:41.000000', 'consum', 0.0255, 'lps'),
	(686969, 136, '2015-02-01 00:22:42.000000', 'consum', 0.0271, 'lps'),
	(686970, 136, '2015-02-01 00:22:43.000000', 'consum', 0.0247, 'lps'),
	(686971, 136, '2015-02-01 00:22:44.000000', 'consum', 0.0213, 'lps'),
	(686972, 136, '2015-02-01 00:22:45.000000', 'consum', 0.0246, 'lps'),
	(686973, 136, '2015-02-01 00:22:46.000000', 'consum', 0.0252, 'lps'),
	(686974, 136, '2015-02-01 00:22:47.000000', 'consum', 0.0248, 'lps'),
	(686975, 136, '2015-02-01 00:22:48.000000', 'consum', 0.0273, 'lps'),
	(686976, 136, '2015-02-01 00:22:49.000000', 'consum', 0.0218, 'lps'),
	(686977, 136, '2015-02-01 00:22:50.000000', 'consum', 0.0254, 'lps'),
	(686978, 136, '2015-02-01 00:22:51.000000', 'consum', 0.0213, 'lps'),
	(686979, 136, '2015-02-01 00:22:52.000000', 'consum', 0.0224, 'lps'),
	(686980, 136, '2015-02-01 00:22:53.000000', 'consum', 0.0270, 'lps'),
	(686981, 136, '2015-02-01 00:22:54.000000', 'consum', 0.0210, 'lps'),
	(686982, 136, '2015-02-01 00:22:55.000000', 'consum', 0.0226, 'lps'),
	(686983, 136, '2015-02-01 00:22:56.000000', 'consum', 0.0226, 'lps'),
	(686984, 136, '2015-02-01 00:22:57.000000', 'consum', 0.0242, 'lps'),
	(686985, 136, '2015-02-01 00:22:58.000000', 'consum', 0.0255, 'lps'),
	(686986, 136, '2015-02-01 00:22:59.000000', 'consum', 0.0212, 'lps'),
	(686987, 136, '2015-02-01 00:23:00.000000', 'consum', 0.0216, 'lps'),
	(686988, 136, '2015-02-01 00:23:01.000000', 'consum', 0.0232, 'lps'),
	(686989, 136, '2015-02-01 00:23:02.000000', 'consum', 0.0240, 'lps'),
	(686990, 136, '2015-02-01 00:23:03.000000', 'consum', 0.0230, 'lps'),
	(686991, 136, '2015-02-01 00:23:04.000000', 'consum', 0.0220, 'lps'),
	(686992, 136, '2015-02-01 00:23:05.000000', 'consum', 0.0264, 'lps'),
	(686993, 136, '2015-02-01 00:23:06.000000', 'consum', 0.0257, 'lps'),
	(686994, 136, '2015-02-01 00:23:07.000000', 'consum', 0.0220, 'lps'),
	(686995, 136, '2015-02-01 00:23:08.000000', 'consum', 0.0247, 'lps'),
	(686996, 136, '2015-02-01 00:23:09.000000', 'consum', 0.0237, 'lps'),
	(686997, 136, '2015-02-01 00:23:10.000000', 'consum', 0.0233, 'lps'),
	(686998, 136, '2015-02-01 00:23:11.000000', 'consum', 0.0247, 'lps'),
	(686999, 136, '2015-02-01 00:23:12.000000', 'consum', 0.0262, 'lps'),
	(687000, 136, '2015-02-01 00:23:13.000000', 'consum', 0.0226, 'lps'),
	(687001, 136, '2015-02-01 00:23:14.000000', 'consum', 0.0267, 'lps'),
	(687002, 136, '2015-02-01 00:23:15.000000', 'consum', 0.0253, 'lps'),
	(687003, 136, '2015-02-01 00:23:16.000000', 'consum', 0.0252, 'lps'),
	(687004, 136, '2015-02-01 00:23:17.000000', 'consum', 0.0228, 'lps'),
	(687005, 136, '2015-02-01 00:23:18.000000', 'consum', 0.0241, 'lps'),
	(687006, 136, '2015-02-01 00:23:19.000000', 'consum', 0.0246, 'lps'),
	(687007, 136, '2015-02-01 00:23:20.000000', 'consum', 0.0234, 'lps'),
	(687008, 136, '2015-02-01 00:23:21.000000', 'consum', 0.0221, 'lps'),
	(687009, 136, '2015-02-01 00:23:22.000000', 'consum', 0.0259, 'lps'),
	(687010, 136, '2015-02-01 00:23:23.000000', 'consum', 0.0228, 'lps'),
	(687011, 136, '2015-02-01 00:23:24.000000', 'consum', 0.0218, 'lps'),
	(687012, 136, '2015-02-01 00:23:25.000000', 'consum', 0.0261, 'lps'),
	(687013, 136, '2015-02-01 00:23:26.000000', 'consum', 0.0248, 'lps'),
	(687014, 136, '2015-02-01 00:23:27.000000', 'consum', 0.0248, 'lps'),
	(687015, 136, '2015-02-01 00:23:28.000000', 'consum', 0.0221, 'lps'),
	(687016, 136, '2015-02-01 00:23:29.000000', 'consum', 0.0216, 'lps'),
	(687017, 136, '2015-02-01 00:23:30.000000', 'consum', 0.0273, 'lps'),
	(687018, 136, '2015-02-01 00:23:31.000000', 'consum', 0.0248, 'lps'),
	(687019, 136, '2015-02-01 00:23:32.000000', 'consum', 0.0274, 'lps'),
	(687020, 136, '2015-02-01 00:23:33.000000', 'consum', 0.0224, 'lps'),
	(687021, 136, '2015-02-01 00:23:34.000000', 'consum', 0.0218, 'lps'),
	(687022, 136, '2015-02-01 00:23:35.000000', 'consum', 0.0272, 'lps'),
	(687023, 136, '2015-02-01 00:23:36.000000', 'consum', 0.0238, 'lps'),
	(687024, 136, '2015-02-01 00:23:37.000000', 'consum', 0.0227, 'lps'),
	(687025, 136, '2015-02-01 00:23:38.000000', 'consum', 0.0215, 'lps'),
	(687026, 136, '2015-02-01 00:23:39.000000', 'consum', 0.0247, 'lps'),
	(687027, 136, '2015-02-01 00:23:40.000000', 'consum', 0.0250, 'lps'),
	(687028, 136, '2015-02-01 00:23:41.000000', 'consum', 0.0236, 'lps'),
	(687029, 136, '2015-02-01 00:23:42.000000', 'consum', 0.0221, 'lps'),
	(687030, 136, '2015-02-01 00:23:43.000000', 'consum', 0.0252, 'lps'),
	(687031, 136, '2015-02-01 00:23:44.000000', 'consum', 0.0255, 'lps'),
	(687032, 136, '2015-02-01 00:23:45.000000', 'consum', 0.0248, 'lps'),
	(687033, 136, '2015-02-01 00:23:46.000000', 'consum', 0.0265, 'lps'),
	(687034, 136, '2015-02-01 00:23:47.000000', 'consum', 0.0240, 'lps'),
	(687035, 136, '2015-02-01 00:23:48.000000', 'consum', 0.0260, 'lps'),
	(687036, 136, '2015-02-01 00:23:49.000000', 'consum', 0.0243, 'lps'),
	(687037, 136, '2015-02-01 00:23:50.000000', 'consum', 0.0222, 'lps'),
	(687038, 136, '2015-02-01 00:23:51.000000', 'consum', 0.0240, 'lps'),
	(687039, 136, '2015-02-01 00:23:52.000000', 'consum', 0.0258, 'lps'),
	(687040, 136, '2015-02-01 00:23:53.000000', 'consum', 0.0230, 'lps'),
	(687041, 136, '2015-02-01 00:23:54.000000', 'consum', 0.0233, 'lps'),
	(687042, 136, '2015-02-01 00:23:55.000000', 'consum', 0.0266, 'lps'),
	(687043, 136, '2015-02-01 00:23:56.000000', 'consum', 0.0226, 'lps'),
	(687044, 136, '2015-02-01 00:23:57.000000', 'consum', 0.0253, 'lps'),
	(687045, 136, '2015-02-01 00:23:58.000000', 'consum', 0.0245, 'lps'),
	(687046, 136, '2015-02-01 00:23:59.000000', 'consum', 0.0260, 'lps'),
	(687047, 136, '2015-02-01 00:24:00.000000', 'consum', 0.0222, 'lps'),
	(687048, 136, '2015-02-01 00:24:01.000000', 'consum', 0.0254, 'lps'),
	(687049, 136, '2015-02-01 00:24:02.000000', 'consum', 0.0263, 'lps'),
	(687050, 136, '2015-02-01 00:24:03.000000', 'consum', 0.0215, 'lps'),
	(687051, 136, '2015-02-01 00:24:04.000000', 'consum', 0.0269, 'lps'),
	(687052, 136, '2015-02-01 00:24:05.000000', 'consum', 0.0230, 'lps'),
	(687053, 136, '2015-02-01 00:24:06.000000', 'consum', 0.0264, 'lps'),
	(687054, 136, '2015-02-01 00:24:07.000000', 'consum', 0.0226, 'lps'),
	(687055, 136, '2015-02-01 00:24:08.000000', 'consum', 0.0257, 'lps'),
	(687056, 136, '2015-02-01 00:24:09.000000', 'consum', 0.0267, 'lps'),
	(687057, 136, '2015-02-01 00:24:10.000000', 'consum', 0.0225, 'lps'),
	(687058, 136, '2015-02-01 00:24:11.000000', 'consum', 0.0243, 'lps'),
	(687059, 136, '2015-02-01 00:24:12.000000', 'consum', 0.0267, 'lps'),
	(687060, 136, '2015-02-01 00:24:13.000000', 'consum', 0.0266, 'lps'),
	(687061, 136, '2015-02-01 00:24:14.000000', 'consum', 0.0254, 'lps'),
	(687062, 136, '2015-02-01 00:24:15.000000', 'consum', 0.0261, 'lps'),
	(687063, 136, '2015-02-01 00:24:16.000000', 'consum', 0.0270, 'lps'),
	(687064, 136, '2015-02-01 00:24:17.000000', 'consum', 0.0227, 'lps'),
	(687065, 136, '2015-02-01 00:24:18.000000', 'consum', 0.0247, 'lps'),
	(687066, 136, '2015-02-01 00:24:19.000000', 'consum', 0.0215, 'lps'),
	(687067, 136, '2015-02-01 00:24:20.000000', 'consum', 0.0253, 'lps'),
	(687068, 136, '2015-02-01 00:24:21.000000', 'consum', 0.0218, 'lps'),
	(687069, 136, '2015-02-01 00:24:22.000000', 'consum', 0.0250, 'lps'),
	(687070, 136, '2015-02-01 00:24:23.000000', 'consum', 0.0255, 'lps'),
	(687071, 136, '2015-02-01 00:24:24.000000', 'consum', 0.0253, 'lps'),
	(687072, 136, '2015-02-01 00:24:25.000000', 'consum', 0.0224, 'lps'),
	(687073, 136, '2015-02-01 00:24:26.000000', 'consum', 0.0216, 'lps'),
	(687074, 136, '2015-02-01 00:24:27.000000', 'consum', 0.0265, 'lps'),
	(687075, 136, '2015-02-01 00:24:28.000000', 'consum', 0.0272, 'lps'),
	(687076, 136, '2015-02-01 00:24:29.000000', 'consum', 0.0226, 'lps'),
	(687077, 136, '2015-02-01 00:24:30.000000', 'consum', 0.0235, 'lps'),
	(687078, 136, '2015-02-01 00:24:31.000000', 'consum', 0.0223, 'lps'),
	(687079, 136, '2015-02-01 00:24:32.000000', 'consum', 0.0265, 'lps'),
	(687080, 136, '2015-02-01 00:24:33.000000', 'consum', 0.0251, 'lps'),
	(687081, 136, '2015-02-01 00:24:34.000000', 'consum', 0.0249, 'lps'),
	(687082, 136, '2015-02-01 00:24:35.000000', 'consum', 0.0217, 'lps'),
	(687083, 136, '2015-02-01 00:24:36.000000', 'consum', 0.0260, 'lps'),
	(687084, 136, '2015-02-01 00:24:37.000000', 'consum', 0.0244, 'lps'),
	(687085, 136, '2015-02-01 00:24:38.000000', 'consum', 0.0230, 'lps'),
	(687086, 136, '2015-02-01 00:24:39.000000', 'consum', 0.0272, 'lps'),
	(687087, 136, '2015-02-01 00:24:40.000000', 'consum', 0.0268, 'lps'),
	(687088, 136, '2015-02-01 00:24:41.000000', 'consum', 0.0249, 'lps'),
	(687089, 136, '2015-02-01 00:24:42.000000', 'consum', 0.0231, 'lps'),
	(687090, 136, '2015-02-01 00:24:43.000000', 'consum', 0.0262, 'lps'),
	(687091, 136, '2015-02-01 00:24:44.000000', 'consum', 0.0215, 'lps'),
	(687092, 136, '2015-02-01 00:24:45.000000', 'consum', 0.0272, 'lps'),
	(687093, 136, '2015-02-01 00:24:46.000000', 'consum', 0.0248, 'lps'),
	(687094, 136, '2015-02-01 00:24:47.000000', 'consum', 0.0212, 'lps'),
	(687095, 136, '2015-02-01 00:24:48.000000', 'consum', 0.0237, 'lps'),
	(687096, 136, '2015-02-01 00:24:49.000000', 'consum', 0.0274, 'lps'),
	(687097, 136, '2015-02-01 00:24:50.000000', 'consum', 0.0256, 'lps'),
	(687098, 136, '2015-02-01 00:24:51.000000', 'consum', 0.0250, 'lps'),
	(687099, 136, '2015-02-01 00:24:52.000000', 'consum', 0.0270, 'lps'),
	(687100, 136, '2015-02-01 00:24:53.000000', 'consum', 0.0261, 'lps'),
	(687101, 136, '2015-02-01 00:24:54.000000', 'consum', 0.0221, 'lps'),
	(687102, 136, '2015-02-01 00:24:55.000000', 'consum', 0.0244, 'lps'),
	(687103, 136, '2015-02-01 00:24:56.000000', 'consum', 0.0218, 'lps'),
	(687104, 136, '2015-02-01 00:24:57.000000', 'consum', 0.0210, 'lps'),
	(687105, 136, '2015-02-01 00:24:58.000000', 'consum', 0.0255, 'lps'),
	(687106, 136, '2015-02-01 00:24:59.000000', 'consum', 0.0238, 'lps'),
	(687107, 136, '2015-02-01 00:25:00.000000', 'consum', 0.0215, 'lps'),
	(687108, 136, '2015-02-01 00:25:01.000000', 'consum', 0.0217, 'lps'),
	(687109, 136, '2015-02-01 00:25:02.000000', 'consum', 0.0232, 'lps'),
	(687110, 136, '2015-02-01 00:25:03.000000', 'consum', 0.0234, 'lps'),
	(687111, 136, '2015-02-01 00:25:04.000000', 'consum', 0.0265, 'lps'),
	(687112, 136, '2015-02-01 00:25:05.000000', 'consum', 0.0219, 'lps'),
	(687113, 136, '2015-02-01 00:25:06.000000', 'consum', 0.0219, 'lps'),
	(687114, 136, '2015-02-01 00:25:07.000000', 'consum', 0.0230, 'lps'),
	(687115, 136, '2015-02-01 00:25:08.000000', 'consum', 0.0216, 'lps'),
	(687116, 136, '2015-02-01 00:25:09.000000', 'consum', 0.0248, 'lps'),
	(687117, 136, '2015-02-01 00:25:10.000000', 'consum', 0.0250, 'lps'),
	(687118, 136, '2015-02-01 00:25:11.000000', 'consum', 0.0231, 'lps'),
	(687119, 136, '2015-02-01 00:25:12.000000', 'consum', 0.0261, 'lps'),
	(687120, 136, '2015-02-01 00:25:13.000000', 'consum', 0.0272, 'lps'),
	(687121, 136, '2015-02-01 00:25:14.000000', 'consum', 0.0240, 'lps'),
	(687122, 136, '2015-02-01 00:25:15.000000', 'consum', 0.0236, 'lps'),
	(687123, 136, '2015-02-01 00:25:16.000000', 'consum', 0.0254, 'lps'),
	(687124, 136, '2015-02-01 00:25:17.000000', 'consum', 0.0221, 'lps'),
	(687125, 136, '2015-02-01 00:25:18.000000', 'consum', 0.0263, 'lps'),
	(687126, 136, '2015-02-01 00:25:19.000000', 'consum', 0.0250, 'lps'),
	(687127, 136, '2015-02-01 00:25:20.000000', 'consum', 0.0250, 'lps'),
	(687128, 136, '2015-02-01 00:25:21.000000', 'consum', 0.0225, 'lps'),
	(687129, 136, '2015-02-01 00:25:22.000000', 'consum', 0.0233, 'lps'),
	(687130, 136, '2015-02-01 00:25:23.000000', 'consum', 0.0214, 'lps'),
	(687131, 136, '2015-02-01 00:25:24.000000', 'consum', 0.0225, 'lps'),
	(687132, 136, '2015-02-01 00:25:25.000000', 'consum', 0.0274, 'lps'),
	(687133, 136, '2015-02-01 00:25:26.000000', 'consum', 0.0227, 'lps'),
	(687134, 136, '2015-02-01 00:25:27.000000', 'consum', 0.0232, 'lps'),
	(687135, 136, '2015-02-01 00:25:28.000000', 'consum', 0.0272, 'lps'),
	(687136, 136, '2015-02-01 00:25:29.000000', 'consum', 0.0258, 'lps'),
	(687137, 136, '2015-02-01 00:25:30.000000', 'consum', 0.0266, 'lps'),
	(687138, 136, '2015-02-01 00:25:31.000000', 'consum', 0.0216, 'lps'),
	(687139, 136, '2015-02-01 00:25:32.000000', 'consum', 0.0267, 'lps'),
	(687140, 136, '2015-02-01 00:25:33.000000', 'consum', 0.0219, 'lps'),
	(687141, 136, '2015-02-01 00:25:34.000000', 'consum', 0.0214, 'lps'),
	(687142, 136, '2015-02-01 00:25:35.000000', 'consum', 0.0267, 'lps'),
	(687143, 136, '2015-02-01 00:25:36.000000', 'consum', 0.0225, 'lps'),
	(687144, 136, '2015-02-01 00:25:37.000000', 'consum', 0.0242, 'lps'),
	(687145, 136, '2015-02-01 00:25:38.000000', 'consum', 0.0263, 'lps'),
	(687146, 136, '2015-02-01 00:25:39.000000', 'consum', 0.0249, 'lps'),
	(687147, 136, '2015-02-01 00:25:40.000000', 'consum', 0.0245, 'lps'),
	(687148, 136, '2015-02-01 00:25:41.000000', 'consum', 0.0270, 'lps'),
	(687149, 136, '2015-02-01 00:25:42.000000', 'consum', 0.0212, 'lps'),
	(687150, 136, '2015-02-01 00:25:43.000000', 'consum', 0.0234, 'lps'),
	(687151, 136, '2015-02-01 00:25:44.000000', 'consum', 0.0261, 'lps'),
	(687152, 136, '2015-02-01 00:25:45.000000', 'consum', 0.0264, 'lps'),
	(687153, 136, '2015-02-01 00:25:46.000000', 'consum', 0.0263, 'lps'),
	(687154, 136, '2015-02-01 00:25:47.000000', 'consum', 0.0250, 'lps'),
	(687155, 136, '2015-02-01 00:25:48.000000', 'consum', 0.0248, 'lps'),
	(687156, 136, '2015-02-01 00:25:49.000000', 'consum', 0.0216, 'lps'),
	(687157, 136, '2015-02-01 00:25:50.000000', 'consum', 0.0257, 'lps'),
	(687158, 136, '2015-02-01 00:25:51.000000', 'consum', 0.0233, 'lps'),
	(687159, 136, '2015-02-01 00:25:52.000000', 'consum', 0.0249, 'lps'),
	(687160, 136, '2015-02-01 00:25:53.000000', 'consum', 0.0271, 'lps'),
	(687161, 136, '2015-02-01 00:25:54.000000', 'consum', 0.0271, 'lps'),
	(687162, 136, '2015-02-01 00:25:55.000000', 'consum', 0.0266, 'lps'),
	(687163, 136, '2015-02-01 00:25:56.000000', 'consum', 0.0241, 'lps'),
	(687164, 136, '2015-02-01 00:25:57.000000', 'consum', 0.0263, 'lps'),
	(687165, 136, '2015-02-01 00:25:58.000000', 'consum', 0.0255, 'lps'),
	(687166, 136, '2015-02-01 00:25:59.000000', 'consum', 0.0274, 'lps'),
	(687167, 136, '2015-02-01 00:26:00.000000', 'consum', 0.0267, 'lps'),
	(687168, 136, '2015-02-01 00:26:01.000000', 'consum', 0.0237, 'lps'),
	(687169, 136, '2015-02-01 00:26:02.000000', 'consum', 0.0241, 'lps'),
	(687170, 136, '2015-02-01 00:26:03.000000', 'consum', 0.0220, 'lps'),
	(687171, 136, '2015-02-01 00:26:04.000000', 'consum', 0.0234, 'lps'),
	(687172, 136, '2015-02-01 00:26:05.000000', 'consum', 0.0233, 'lps'),
	(687173, 136, '2015-02-01 00:26:06.000000', 'consum', 0.0255, 'lps'),
	(687174, 136, '2015-02-01 00:26:07.000000', 'consum', 0.0236, 'lps'),
	(687175, 136, '2015-02-01 00:26:08.000000', 'consum', 0.0269, 'lps'),
	(687176, 136, '2015-02-01 00:26:09.000000', 'consum', 0.0235, 'lps'),
	(687177, 136, '2015-02-01 00:26:10.000000', 'consum', 0.0222, 'lps'),
	(687178, 136, '2015-02-01 00:26:11.000000', 'consum', 0.0262, 'lps'),
	(687179, 136, '2015-02-01 00:26:12.000000', 'consum', 0.0239, 'lps'),
	(687180, 136, '2015-02-01 00:26:13.000000', 'consum', 0.0263, 'lps'),
	(687181, 136, '2015-02-01 00:26:14.000000', 'consum', 0.0259, 'lps'),
	(687182, 136, '2015-02-01 00:26:15.000000', 'consum', 0.0232, 'lps'),
	(687183, 136, '2015-02-01 00:26:16.000000', 'consum', 0.0239, 'lps'),
	(687184, 136, '2015-02-01 00:26:17.000000', 'consum', 0.0225, 'lps'),
	(687185, 136, '2015-02-01 00:26:18.000000', 'consum', 0.0263, 'lps'),
	(687186, 136, '2015-02-01 00:26:19.000000', 'consum', 0.0237, 'lps'),
	(687187, 136, '2015-02-01 00:26:20.000000', 'consum', 0.0251, 'lps'),
	(687188, 136, '2015-02-01 00:26:21.000000', 'consum', 0.0268, 'lps'),
	(687189, 136, '2015-02-01 00:26:22.000000', 'consum', 0.0250, 'lps'),
	(687190, 136, '2015-02-01 00:26:23.000000', 'consum', 0.0235, 'lps'),
	(687191, 136, '2015-02-01 00:26:24.000000', 'consum', 0.0214, 'lps'),
	(687192, 136, '2015-02-01 00:26:25.000000', 'consum', 0.0222, 'lps'),
	(687193, 136, '2015-02-01 00:26:26.000000', 'consum', 0.0259, 'lps'),
	(687194, 136, '2015-02-01 00:26:27.000000', 'consum', 0.0222, 'lps'),
	(687195, 136, '2015-02-01 00:26:28.000000', 'consum', 0.0257, 'lps'),
	(687196, 136, '2015-02-01 00:26:29.000000', 'consum', 0.0213, 'lps'),
	(687197, 136, '2015-02-01 00:26:30.000000', 'consum', 0.0215, 'lps'),
	(687198, 136, '2015-02-01 00:26:31.000000', 'consum', 0.0226, 'lps'),
	(687199, 136, '2015-02-01 00:26:32.000000', 'consum', 0.0212, 'lps'),
	(687200, 136, '2015-02-01 00:26:33.000000', 'consum', 0.0236, 'lps'),
	(687201, 136, '2015-02-01 00:26:34.000000', 'consum', 0.0269, 'lps'),
	(687202, 136, '2015-02-01 00:26:35.000000', 'consum', 0.0233, 'lps'),
	(687203, 136, '2015-02-01 00:26:36.000000', 'consum', 0.0213, 'lps'),
	(687204, 136, '2015-02-01 00:26:37.000000', 'consum', 0.0223, 'lps'),
	(687205, 136, '2015-02-01 00:26:38.000000', 'consum', 0.0264, 'lps'),
	(687206, 136, '2015-02-01 00:26:39.000000', 'consum', 0.0247, 'lps'),
	(687207, 136, '2015-02-01 00:26:40.000000', 'consum', 0.0236, 'lps'),
	(687208, 136, '2015-02-01 00:26:41.000000', 'consum', 0.0228, 'lps'),
	(687209, 136, '2015-02-01 00:26:42.000000', 'consum', 0.0221, 'lps'),
	(687210, 136, '2015-02-01 00:26:43.000000', 'consum', 0.0214, 'lps'),
	(687211, 136, '2015-02-01 00:26:44.000000', 'consum', 0.0262, 'lps'),
	(687212, 136, '2015-02-01 00:26:45.000000', 'consum', 0.0263, 'lps'),
	(687213, 136, '2015-02-01 00:26:46.000000', 'consum', 0.0255, 'lps'),
	(687214, 136, '2015-02-01 00:26:47.000000', 'consum', 0.0212, 'lps'),
	(687215, 136, '2015-02-01 00:26:48.000000', 'consum', 0.0217, 'lps'),
	(687216, 136, '2015-02-01 00:26:49.000000', 'consum', 0.0236, 'lps'),
	(687217, 136, '2015-02-01 00:26:50.000000', 'consum', 0.0257, 'lps'),
	(687218, 136, '2015-02-01 00:26:51.000000', 'consum', 0.0235, 'lps'),
	(687219, 136, '2015-02-01 00:26:52.000000', 'consum', 0.0260, 'lps'),
	(687220, 136, '2015-02-01 00:26:53.000000', 'consum', 0.0256, 'lps'),
	(687221, 136, '2015-02-01 00:26:54.000000', 'consum', 0.0226, 'lps'),
	(687222, 136, '2015-02-01 00:26:55.000000', 'consum', 0.0218, 'lps'),
	(687223, 136, '2015-02-01 00:26:56.000000', 'consum', 0.0268, 'lps'),
	(687224, 136, '2015-02-01 00:26:57.000000', 'consum', 0.0215, 'lps'),
	(687225, 136, '2015-02-01 00:26:58.000000', 'consum', 0.0259, 'lps'),
	(687226, 136, '2015-02-01 00:26:59.000000', 'consum', 0.0244, 'lps'),
	(687227, 136, '2015-02-01 00:27:00.000000', 'consum', 0.0236, 'lps'),
	(687228, 136, '2015-02-01 00:27:01.000000', 'consum', 0.0235, 'lps'),
	(687229, 136, '2015-02-01 00:27:02.000000', 'consum', 0.0258, 'lps'),
	(687230, 136, '2015-02-01 00:27:03.000000', 'consum', 0.0246, 'lps'),
	(687231, 136, '2015-02-01 00:27:04.000000', 'consum', 0.0249, 'lps'),
	(687232, 136, '2015-02-01 00:27:05.000000', 'consum', 0.0229, 'lps'),
	(687233, 136, '2015-02-01 00:27:06.000000', 'consum', 0.0254, 'lps'),
	(687234, 136, '2015-02-01 00:27:07.000000', 'consum', 0.0245, 'lps'),
	(687235, 136, '2015-02-01 00:27:08.000000', 'consum', 0.0253, 'lps'),
	(687236, 136, '2015-02-01 00:27:09.000000', 'consum', 0.0255, 'lps'),
	(687237, 136, '2015-02-01 00:27:10.000000', 'consum', 0.0241, 'lps'),
	(687238, 136, '2015-02-01 00:27:11.000000', 'consum', 0.0230, 'lps'),
	(687239, 136, '2015-02-01 00:27:12.000000', 'consum', 0.0219, 'lps'),
	(687240, 136, '2015-02-01 00:27:13.000000', 'consum', 0.0260, 'lps'),
	(687241, 136, '2015-02-01 00:27:14.000000', 'consum', 0.0237, 'lps'),
	(687242, 136, '2015-02-01 00:27:15.000000', 'consum', 0.0262, 'lps'),
	(687243, 136, '2015-02-01 00:27:16.000000', 'consum', 0.0257, 'lps'),
	(687244, 136, '2015-02-01 00:27:17.000000', 'consum', 0.0227, 'lps'),
	(687245, 136, '2015-02-01 00:27:18.000000', 'consum', 0.0220, 'lps'),
	(687246, 136, '2015-02-01 00:27:19.000000', 'consum', 0.0273, 'lps'),
	(687247, 136, '2015-02-01 00:27:20.000000', 'consum', 0.0236, 'lps'),
	(687248, 136, '2015-02-01 00:27:21.000000', 'consum', 0.0217, 'lps'),
	(687249, 136, '2015-02-01 00:27:22.000000', 'consum', 0.0233, 'lps'),
	(687250, 136, '2015-02-01 00:27:23.000000', 'consum', 0.0238, 'lps'),
	(687251, 136, '2015-02-01 00:27:24.000000', 'consum', 0.0218, 'lps'),
	(687252, 136, '2015-02-01 00:27:25.000000', 'consum', 0.0233, 'lps'),
	(687253, 136, '2015-02-01 00:27:26.000000', 'consum', 0.0235, 'lps'),
	(687254, 136, '2015-02-01 00:27:27.000000', 'consum', 0.0266, 'lps'),
	(687255, 136, '2015-02-01 00:27:28.000000', 'consum', 0.0221, 'lps'),
	(687256, 136, '2015-02-01 00:27:29.000000', 'consum', 0.0228, 'lps'),
	(687257, 136, '2015-02-01 00:27:30.000000', 'consum', 0.0266, 'lps'),
	(687258, 136, '2015-02-01 00:27:31.000000', 'consum', 0.0243, 'lps'),
	(687259, 136, '2015-02-01 00:27:32.000000', 'consum', 0.0273, 'lps'),
	(687260, 136, '2015-02-01 00:27:33.000000', 'consum', 0.0231, 'lps'),
	(687261, 136, '2015-02-01 00:27:34.000000', 'consum', 0.0258, 'lps'),
	(687262, 136, '2015-02-01 00:27:35.000000', 'consum', 0.0256, 'lps'),
	(687263, 136, '2015-02-01 00:27:36.000000', 'consum', 0.0230, 'lps'),
	(687264, 136, '2015-02-01 00:27:37.000000', 'consum', 0.0239, 'lps'),
	(687265, 136, '2015-02-01 00:27:38.000000', 'consum', 0.0229, 'lps'),
	(687266, 136, '2015-02-01 00:27:39.000000', 'consum', 0.0218, 'lps'),
	(687267, 136, '2015-02-01 00:27:40.000000', 'consum', 0.0261, 'lps'),
	(687268, 136, '2015-02-01 00:27:41.000000', 'consum', 0.0246, 'lps'),
	(687269, 136, '2015-02-01 00:27:42.000000', 'consum', 0.0236, 'lps'),
	(687270, 136, '2015-02-01 00:27:43.000000', 'consum', 0.0233, 'lps'),
	(687271, 136, '2015-02-01 00:27:44.000000', 'consum', 0.0246, 'lps'),
	(687272, 136, '2015-02-01 00:27:45.000000', 'consum', 0.0257, 'lps'),
	(687273, 136, '2015-02-01 00:27:46.000000', 'consum', 0.0274, 'lps'),
	(687274, 136, '2015-02-01 00:27:47.000000', 'consum', 0.0261, 'lps'),
	(687275, 136, '2015-02-01 00:27:48.000000', 'consum', 0.0271, 'lps'),
	(687276, 136, '2015-02-01 00:27:49.000000', 'consum', 0.0233, 'lps'),
	(687277, 136, '2015-02-01 00:27:50.000000', 'consum', 0.0273, 'lps'),
	(687278, 136, '2015-02-01 00:27:51.000000', 'consum', 0.0262, 'lps'),
	(687279, 136, '2015-02-01 00:27:52.000000', 'consum', 0.0216, 'lps'),
	(687280, 136, '2015-02-01 00:27:53.000000', 'consum', 0.0214, 'lps'),
	(687281, 136, '2015-02-01 00:27:54.000000', 'consum', 0.0213, 'lps'),
	(687282, 136, '2015-02-01 00:27:55.000000', 'consum', 0.0212, 'lps'),
	(687283, 136, '2015-02-01 00:27:56.000000', 'consum', 0.0213, 'lps'),
	(687284, 136, '2015-02-01 00:27:57.000000', 'consum', 0.0218, 'lps'),
	(687285, 136, '2015-02-01 00:27:58.000000', 'consum', 0.0244, 'lps'),
	(687286, 136, '2015-02-01 00:27:59.000000', 'consum', 0.0226, 'lps'),
	(687287, 136, '2015-02-01 00:28:00.000000', 'consum', 0.0254, 'lps'),
	(687288, 136, '2015-02-01 00:28:01.000000', 'consum', 0.0251, 'lps'),
	(687289, 136, '2015-02-01 00:28:02.000000', 'consum', 0.0221, 'lps'),
	(687290, 136, '2015-02-01 00:28:03.000000', 'consum', 0.0269, 'lps'),
	(687291, 136, '2015-02-01 00:28:04.000000', 'consum', 0.0216, 'lps'),
	(687292, 136, '2015-02-01 00:28:05.000000', 'consum', 0.0258, 'lps'),
	(687293, 136, '2015-02-01 00:28:06.000000', 'consum', 0.0235, 'lps'),
	(687294, 136, '2015-02-01 00:28:07.000000', 'consum', 0.0258, 'lps'),
	(687295, 136, '2015-02-01 00:28:08.000000', 'consum', 0.0244, 'lps'),
	(687296, 136, '2015-02-01 00:28:09.000000', 'consum', 0.0239, 'lps'),
	(687297, 136, '2015-02-01 00:28:10.000000', 'consum', 0.0254, 'lps'),
	(687298, 136, '2015-02-01 00:28:11.000000', 'consum', 0.0214, 'lps'),
	(687299, 136, '2015-02-01 00:28:12.000000', 'consum', 0.0226, 'lps'),
	(687300, 136, '2015-02-01 00:28:13.000000', 'consum', 0.0216, 'lps'),
	(687301, 136, '2015-02-01 00:28:14.000000', 'consum', 0.0257, 'lps'),
	(687302, 136, '2015-02-01 00:28:15.000000', 'consum', 0.0232, 'lps'),
	(687303, 136, '2015-02-01 00:28:16.000000', 'consum', 0.0246, 'lps'),
	(687304, 136, '2015-02-01 00:28:17.000000', 'consum', 0.0259, 'lps'),
	(687305, 136, '2015-02-01 00:28:18.000000', 'consum', 0.0219, 'lps'),
	(687306, 136, '2015-02-01 00:28:19.000000', 'consum', 0.0236, 'lps'),
	(687307, 136, '2015-02-01 00:28:20.000000', 'consum', 0.0249, 'lps'),
	(687308, 136, '2015-02-01 00:28:21.000000', 'consum', 0.0263, 'lps'),
	(687309, 136, '2015-02-01 00:28:22.000000', 'consum', 0.0228, 'lps'),
	(687310, 136, '2015-02-01 00:28:23.000000', 'consum', 0.0271, 'lps'),
	(687311, 136, '2015-02-01 00:28:24.000000', 'consum', 0.0269, 'lps'),
	(687312, 136, '2015-02-01 00:28:25.000000', 'consum', 0.0255, 'lps'),
	(687313, 136, '2015-02-01 00:28:26.000000', 'consum', 0.0259, 'lps'),
	(687314, 136, '2015-02-01 00:28:27.000000', 'consum', 0.0257, 'lps'),
	(687315, 136, '2015-02-01 00:28:28.000000', 'consum', 0.0232, 'lps'),
	(687316, 136, '2015-02-01 00:28:29.000000', 'consum', 0.0247, 'lps'),
	(687317, 136, '2015-02-01 00:28:30.000000', 'consum', 0.0262, 'lps'),
	(687318, 136, '2015-02-01 00:28:31.000000', 'consum', 0.0232, 'lps'),
	(687319, 136, '2015-02-01 00:28:32.000000', 'consum', 0.0226, 'lps'),
	(687320, 136, '2015-02-01 00:28:33.000000', 'consum', 0.0227, 'lps'),
	(687321, 136, '2015-02-01 00:28:34.000000', 'consum', 0.0248, 'lps'),
	(687322, 136, '2015-02-01 00:28:35.000000', 'consum', 0.0217, 'lps'),
	(687323, 136, '2015-02-01 00:28:36.000000', 'consum', 0.0264, 'lps'),
	(687324, 136, '2015-02-01 00:28:37.000000', 'consum', 0.0263, 'lps'),
	(687325, 136, '2015-02-01 00:28:38.000000', 'consum', 0.0249, 'lps'),
	(687326, 136, '2015-02-01 00:28:39.000000', 'consum', 0.0247, 'lps'),
	(687327, 136, '2015-02-01 00:28:40.000000', 'consum', 0.0214, 'lps'),
	(687328, 136, '2015-02-01 00:28:41.000000', 'consum', 0.0248, 'lps'),
	(687329, 136, '2015-02-01 00:28:42.000000', 'consum', 0.0259, 'lps'),
	(687330, 136, '2015-02-01 00:28:43.000000', 'consum', 0.0211, 'lps'),
	(687331, 136, '2015-02-01 00:28:44.000000', 'consum', 0.0262, 'lps'),
	(687332, 136, '2015-02-01 00:28:45.000000', 'consum', 0.0274, 'lps'),
	(687333, 136, '2015-02-01 00:28:46.000000', 'consum', 0.0243, 'lps'),
	(687334, 136, '2015-02-01 00:28:47.000000', 'consum', 0.0250, 'lps'),
	(687335, 136, '2015-02-01 00:28:48.000000', 'consum', 0.0248, 'lps'),
	(687336, 136, '2015-02-01 00:28:49.000000', 'consum', 0.0212, 'lps'),
	(687337, 136, '2015-02-01 00:28:50.000000', 'consum', 0.0239, 'lps'),
	(687338, 136, '2015-02-01 00:28:51.000000', 'consum', 0.0221, 'lps'),
	(687339, 136, '2015-02-01 00:28:52.000000', 'consum', 0.0240, 'lps'),
	(687340, 136, '2015-02-01 00:28:53.000000', 'consum', 0.0264, 'lps'),
	(687341, 136, '2015-02-01 00:28:54.000000', 'consum', 0.0262, 'lps'),
	(687342, 136, '2015-02-01 00:28:55.000000', 'consum', 0.0244, 'lps'),
	(687343, 136, '2015-02-01 00:28:56.000000', 'consum', 0.0221, 'lps'),
	(687344, 136, '2015-02-01 00:28:57.000000', 'consum', 0.0232, 'lps'),
	(687345, 136, '2015-02-01 00:28:58.000000', 'consum', 0.0222, 'lps'),
	(687346, 136, '2015-02-01 00:28:59.000000', 'consum', 0.0270, 'lps'),
	(687347, 136, '2015-02-01 00:29:00.000000', 'consum', 0.0213, 'lps'),
	(687348, 136, '2015-02-01 00:29:01.000000', 'consum', 0.0239, 'lps'),
	(687349, 136, '2015-02-01 00:29:02.000000', 'consum', 0.0218, 'lps'),
	(687350, 136, '2015-02-01 00:29:03.000000', 'consum', 0.0227, 'lps'),
	(687351, 136, '2015-02-01 00:29:04.000000', 'consum', 0.0272, 'lps'),
	(687352, 136, '2015-02-01 00:29:05.000000', 'consum', 0.0211, 'lps'),
	(687353, 136, '2015-02-01 00:29:06.000000', 'consum', 0.0223, 'lps'),
	(687354, 136, '2015-02-01 00:29:07.000000', 'consum', 0.0273, 'lps'),
	(687355, 136, '2015-02-01 00:29:08.000000', 'consum', 0.0227, 'lps'),
	(687356, 136, '2015-02-01 00:29:09.000000', 'consum', 0.0237, 'lps'),
	(687357, 136, '2015-02-01 00:29:10.000000', 'consum', 0.0229, 'lps'),
	(687358, 136, '2015-02-01 00:29:11.000000', 'consum', 0.0223, 'lps'),
	(687359, 136, '2015-02-01 00:29:12.000000', 'consum', 0.0218, 'lps'),
	(687360, 136, '2015-02-01 00:29:13.000000', 'consum', 0.0211, 'lps'),
	(687361, 136, '2015-02-01 00:29:14.000000', 'consum', 0.0257, 'lps'),
	(687362, 136, '2015-02-01 00:29:15.000000', 'consum', 0.0249, 'lps'),
	(687363, 136, '2015-02-01 00:29:16.000000', 'consum', 0.0265, 'lps'),
	(687364, 136, '2015-02-01 00:29:17.000000', 'consum', 0.0236, 'lps'),
	(687365, 136, '2015-02-01 00:29:18.000000', 'consum', 0.0241, 'lps'),
	(687366, 136, '2015-02-01 00:29:19.000000', 'consum', 0.0221, 'lps'),
	(687367, 136, '2015-02-01 00:29:20.000000', 'consum', 0.0239, 'lps'),
	(687368, 136, '2015-02-01 00:29:21.000000', 'consum', 0.0258, 'lps'),
	(687369, 136, '2015-02-01 00:29:22.000000', 'consum', 0.0231, 'lps'),
	(687370, 136, '2015-02-01 00:29:23.000000', 'consum', 0.0238, 'lps'),
	(687371, 136, '2015-02-01 00:29:24.000000', 'consum', 0.0224, 'lps'),
	(687372, 136, '2015-02-01 00:29:25.000000', 'consum', 0.0262, 'lps'),
	(687373, 136, '2015-02-01 00:29:26.000000', 'consum', 0.0234, 'lps'),
	(687374, 136, '2015-02-01 00:29:27.000000', 'consum', 0.0237, 'lps'),
	(687375, 136, '2015-02-01 00:29:28.000000', 'consum', 0.0210, 'lps'),
	(687376, 136, '2015-02-01 00:29:29.000000', 'consum', 0.0261, 'lps'),
	(687377, 136, '2015-02-01 00:29:30.000000', 'consum', 0.0268, 'lps'),
	(687378, 136, '2015-02-01 00:29:31.000000', 'consum', 0.0216, 'lps'),
	(687379, 136, '2015-02-01 00:29:32.000000', 'consum', 0.0265, 'lps'),
	(687380, 136, '2015-02-01 00:29:33.000000', 'consum', 0.0269, 'lps'),
	(687381, 136, '2015-02-01 00:29:34.000000', 'consum', 0.0213, 'lps'),
	(687382, 136, '2015-02-01 00:29:35.000000', 'consum', 0.0241, 'lps'),
	(687383, 136, '2015-02-01 00:29:36.000000', 'consum', 0.0228, 'lps'),
	(687384, 136, '2015-02-01 00:29:37.000000', 'consum', 0.0271, 'lps'),
	(687385, 136, '2015-02-01 00:29:38.000000', 'consum', 0.0267, 'lps'),
	(687386, 136, '2015-02-01 00:29:39.000000', 'consum', 0.0246, 'lps'),
	(687387, 136, '2015-02-01 00:29:40.000000', 'consum', 0.0221, 'lps'),
	(687388, 136, '2015-02-01 00:29:41.000000', 'consum', 0.0224, 'lps'),
	(687389, 136, '2015-02-01 00:29:42.000000', 'consum', 0.0248, 'lps'),
	(687390, 136, '2015-02-01 00:29:43.000000', 'consum', 0.0226, 'lps'),
	(687391, 136, '2015-02-01 00:29:44.000000', 'consum', 0.0243, 'lps'),
	(687392, 136, '2015-02-01 00:29:45.000000', 'consum', 0.0260, 'lps'),
	(687393, 136, '2015-02-01 00:29:46.000000', 'consum', 0.0233, 'lps'),
	(687394, 136, '2015-02-01 00:29:47.000000', 'consum', 0.0241, 'lps'),
	(687395, 136, '2015-02-01 00:29:48.000000', 'consum', 0.0229, 'lps'),
	(687396, 136, '2015-02-01 00:29:49.000000', 'consum', 0.0215, 'lps'),
	(687397, 136, '2015-02-01 00:29:50.000000', 'consum', 0.0244, 'lps'),
	(687398, 136, '2015-02-01 00:29:51.000000', 'consum', 0.0234, 'lps'),
	(687399, 136, '2015-02-01 00:29:52.000000', 'consum', 0.0230, 'lps'),
	(687400, 136, '2015-02-01 00:29:53.000000', 'consum', 0.0237, 'lps'),
	(687401, 136, '2015-02-01 00:29:54.000000', 'consum', 0.0220, 'lps'),
	(687402, 136, '2015-02-01 00:29:55.000000', 'consum', 0.0245, 'lps'),
	(687403, 136, '2015-02-01 00:29:56.000000', 'consum', 0.0227, 'lps'),
	(687404, 136, '2015-02-01 00:29:57.000000', 'consum', 0.0254, 'lps'),
	(687405, 136, '2015-02-01 00:29:58.000000', 'consum', 0.0251, 'lps'),
	(687406, 136, '2015-02-01 00:29:59.000000', 'consum', 0.0219, 'lps'),
	(687407, 136, '2015-02-01 00:30:00.000000', 'consum', 0.0260, 'lps'),
	(687408, 136, '2015-02-01 00:30:01.000000', 'consum', 0.0239, 'lps'),
	(687409, 136, '2015-02-01 00:30:02.000000', 'consum', 0.0272, 'lps'),
	(687410, 136, '2015-02-01 00:30:03.000000', 'consum', 0.0239, 'lps'),
	(687411, 136, '2015-02-01 00:30:04.000000', 'consum', 0.0236, 'lps'),
	(687412, 136, '2015-02-01 00:30:05.000000', 'consum', 0.0250, 'lps'),
	(687413, 136, '2015-02-01 00:30:06.000000', 'consum', 0.0270, 'lps'),
	(687414, 136, '2015-02-01 00:30:07.000000', 'consum', 0.0258, 'lps'),
	(687415, 136, '2015-02-01 00:30:08.000000', 'consum', 0.0270, 'lps'),
	(687416, 136, '2015-02-01 00:30:09.000000', 'consum', 0.0236, 'lps'),
	(687417, 136, '2015-02-01 00:30:10.000000', 'consum', 0.0227, 'lps'),
	(687418, 136, '2015-02-01 00:30:11.000000', 'consum', 0.0219, 'lps'),
	(687419, 136, '2015-02-01 00:30:12.000000', 'consum', 0.0267, 'lps'),
	(687420, 136, '2015-02-01 00:30:13.000000', 'consum', 0.0273, 'lps'),
	(687421, 136, '2015-02-01 00:30:14.000000', 'consum', 0.0225, 'lps'),
	(687422, 136, '2015-02-01 00:30:15.000000', 'consum', 0.0228, 'lps'),
	(687423, 136, '2015-02-01 00:30:16.000000', 'consum', 0.0256, 'lps'),
	(687424, 136, '2015-02-01 00:30:17.000000', 'consum', 0.0256, 'lps'),
	(687425, 136, '2015-02-01 00:30:18.000000', 'consum', 0.0236, 'lps'),
	(687426, 136, '2015-02-01 00:30:19.000000', 'consum', 0.0269, 'lps'),
	(687427, 136, '2015-02-01 00:30:20.000000', 'consum', 0.0231, 'lps'),
	(687428, 136, '2015-02-01 00:30:21.000000', 'consum', 0.0270, 'lps'),
	(687429, 136, '2015-02-01 00:30:22.000000', 'consum', 0.0253, 'lps'),
	(687430, 136, '2015-02-01 00:30:23.000000', 'consum', 0.0243, 'lps'),
	(687431, 136, '2015-02-01 00:30:24.000000', 'consum', 0.0247, 'lps'),
	(687432, 136, '2015-02-01 00:30:25.000000', 'consum', 0.0234, 'lps'),
	(687433, 136, '2015-02-01 00:30:26.000000', 'consum', 0.0217, 'lps'),
	(687434, 136, '2015-02-01 00:30:27.000000', 'consum', 0.0239, 'lps'),
	(687435, 136, '2015-02-01 00:30:28.000000', 'consum', 0.0268, 'lps'),
	(687436, 136, '2015-02-01 00:30:29.000000', 'consum', 0.0218, 'lps'),
	(687437, 136, '2015-02-01 00:30:30.000000', 'consum', 0.0273, 'lps'),
	(687438, 136, '2015-02-01 00:30:31.000000', 'consum', 0.0240, 'lps'),
	(687439, 136, '2015-02-01 00:30:32.000000', 'consum', 0.0237, 'lps'),
	(687440, 136, '2015-02-01 00:30:33.000000', 'consum', 0.0256, 'lps'),
	(687441, 136, '2015-02-01 00:30:34.000000', 'consum', 0.0230, 'lps'),
	(687442, 136, '2015-02-01 00:30:35.000000', 'consum', 0.0239, 'lps'),
	(687443, 136, '2015-02-01 00:30:36.000000', 'consum', 0.0228, 'lps'),
	(687444, 136, '2015-02-01 00:30:37.000000', 'consum', 0.0214, 'lps'),
	(687445, 136, '2015-02-01 00:30:38.000000', 'consum', 0.0241, 'lps'),
	(687446, 136, '2015-02-01 00:30:39.000000', 'consum', 0.0223, 'lps'),
	(687447, 136, '2015-02-01 00:30:40.000000', 'consum', 0.0247, 'lps'),
	(687448, 136, '2015-02-01 00:30:41.000000', 'consum', 0.0228, 'lps'),
	(687449, 136, '2015-02-01 00:30:42.000000', 'consum', 0.0253, 'lps'),
	(687450, 136, '2015-02-01 00:30:43.000000', 'consum', 0.0240, 'lps'),
	(687451, 136, '2015-02-01 00:30:44.000000', 'consum', 0.0235, 'lps'),
	(687452, 136, '2015-02-01 00:30:45.000000', 'consum', 0.0242, 'lps'),
	(687453, 136, '2015-02-01 00:30:46.000000', 'consum', 0.0233, 'lps'),
	(687454, 136, '2015-02-01 00:30:47.000000', 'consum', 0.0229, 'lps'),
	(687455, 136, '2015-02-01 00:30:48.000000', 'consum', 0.0237, 'lps'),
	(687456, 136, '2015-02-01 00:30:49.000000', 'consum', 0.0221, 'lps'),
	(687457, 136, '2015-02-01 00:30:50.000000', 'consum', 0.0252, 'lps'),
	(687458, 136, '2015-02-01 00:30:51.000000', 'consum', 0.0255, 'lps'),
	(687459, 136, '2015-02-01 00:30:52.000000', 'consum', 0.0247, 'lps'),
	(687460, 136, '2015-02-01 00:30:53.000000', 'consum', 0.0258, 'lps'),
	(687461, 136, '2015-02-01 00:30:54.000000', 'consum', 0.0211, 'lps'),
	(687462, 136, '2015-02-01 00:30:55.000000', 'consum', 0.0268, 'lps'),
	(687463, 136, '2015-02-01 00:30:56.000000', 'consum', 0.0237, 'lps'),
	(687464, 136, '2015-02-01 00:30:57.000000', 'consum', 0.0237, 'lps'),
	(687465, 136, '2015-02-01 00:30:58.000000', 'consum', 0.0263, 'lps'),
	(687466, 136, '2015-02-01 00:30:59.000000', 'consum', 0.0265, 'lps'),
	(687467, 136, '2015-02-01 00:31:00.000000', 'consum', 0.0261, 'lps'),
	(687468, 136, '2015-02-01 00:31:01.000000', 'consum', 0.0234, 'lps'),
	(687469, 136, '2015-02-01 00:31:02.000000', 'consum', 0.0245, 'lps'),
	(687470, 136, '2015-02-01 00:31:03.000000', 'consum', 0.0246, 'lps'),
	(687471, 136, '2015-02-01 00:31:04.000000', 'consum', 0.0221, 'lps'),
	(687472, 136, '2015-02-01 00:31:05.000000', 'consum', 0.0221, 'lps'),
	(687473, 136, '2015-02-01 00:31:06.000000', 'consum', 0.0233, 'lps'),
	(687474, 136, '2015-02-01 00:31:07.000000', 'consum', 0.0230, 'lps'),
	(687475, 136, '2015-02-01 00:31:08.000000', 'consum', 0.0240, 'lps'),
	(687476, 136, '2015-02-01 00:31:09.000000', 'consum', 0.0235, 'lps'),
	(687477, 136, '2015-02-01 00:31:10.000000', 'consum', 0.0244, 'lps'),
	(687478, 136, '2015-02-01 00:31:11.000000', 'consum', 0.0243, 'lps'),
	(687479, 136, '2015-02-01 00:31:12.000000', 'consum', 0.0274, 'lps'),
	(687480, 136, '2015-02-01 00:31:13.000000', 'consum', 0.0234, 'lps');
INSERT INTO `telemetria` (`codi_dada`, `component`, `moment`, `ambit`, `valor`, `unitat_de_mesura`) VALUES
	(687481, 136, '2015-02-01 00:31:14.000000', 'consum', 0.0271, 'lps'),
	(687482, 136, '2015-02-01 00:31:15.000000', 'consum', 0.0250, 'lps'),
	(687483, 136, '2015-02-01 00:31:16.000000', 'consum', 0.0224, 'lps'),
	(687484, 136, '2015-02-01 00:31:17.000000', 'consum', 0.0228, 'lps'),
	(687485, 136, '2015-02-01 00:31:18.000000', 'consum', 0.0260, 'lps'),
	(687486, 136, '2015-02-01 00:31:19.000000', 'consum', 0.0273, 'lps'),
	(687487, 136, '2015-02-01 00:31:20.000000', 'consum', 0.0248, 'lps'),
	(687488, 136, '2015-02-01 00:31:21.000000', 'consum', 0.0211, 'lps'),
	(687489, 136, '2015-02-01 00:31:22.000000', 'consum', 0.0233, 'lps'),
	(687490, 136, '2015-02-01 00:31:23.000000', 'consum', 0.0255, 'lps'),
	(687491, 136, '2015-02-01 00:31:24.000000', 'consum', 0.0236, 'lps'),
	(687492, 136, '2015-02-01 00:31:25.000000', 'consum', 0.0271, 'lps'),
	(687493, 136, '2015-02-01 00:31:26.000000', 'consum', 0.0243, 'lps'),
	(687494, 136, '2015-02-01 00:31:27.000000', 'consum', 0.0257, 'lps'),
	(687495, 136, '2015-02-01 00:31:28.000000', 'consum', 0.0217, 'lps'),
	(687496, 136, '2015-02-01 00:31:29.000000', 'consum', 0.0234, 'lps'),
	(687497, 136, '2015-02-01 00:31:30.000000', 'consum', 0.0245, 'lps'),
	(687498, 136, '2015-02-01 00:31:31.000000', 'consum', 0.0249, 'lps'),
	(687499, 136, '2015-02-01 00:31:32.000000', 'consum', 0.0236, 'lps'),
	(687500, 136, '2015-02-01 00:31:33.000000', 'consum', 0.0223, 'lps'),
	(687501, 136, '2015-02-01 00:31:34.000000', 'consum', 0.0263, 'lps'),
	(687502, 136, '2015-02-01 00:31:35.000000', 'consum', 0.0241, 'lps'),
	(687503, 136, '2015-02-01 00:31:36.000000', 'consum', 0.0270, 'lps'),
	(687504, 136, '2015-02-01 00:31:37.000000', 'consum', 0.0222, 'lps'),
	(687505, 136, '2015-02-01 00:31:38.000000', 'consum', 0.0223, 'lps'),
	(687506, 136, '2015-02-01 00:31:39.000000', 'consum', 0.0238, 'lps'),
	(687507, 136, '2015-02-01 00:31:40.000000', 'consum', 0.0248, 'lps'),
	(687508, 136, '2015-02-01 00:31:41.000000', 'consum', 0.0249, 'lps'),
	(687509, 136, '2015-02-01 00:31:42.000000', 'consum', 0.0229, 'lps'),
	(687510, 136, '2015-02-01 00:31:43.000000', 'consum', 0.0252, 'lps'),
	(687511, 136, '2015-02-01 00:31:44.000000', 'consum', 0.0233, 'lps'),
	(687512, 136, '2015-02-01 00:31:45.000000', 'consum', 0.0264, 'lps'),
	(687513, 136, '2015-02-01 00:31:46.000000', 'consum', 0.0219, 'lps'),
	(687514, 136, '2015-02-01 00:31:47.000000', 'consum', 0.0220, 'lps'),
	(687515, 136, '2015-02-01 00:31:48.000000', 'consum', 0.0237, 'lps'),
	(687516, 136, '2015-02-01 00:31:49.000000', 'consum', 0.0249, 'lps'),
	(687517, 136, '2015-02-01 00:31:50.000000', 'consum', 0.0261, 'lps'),
	(687518, 136, '2015-02-01 00:31:51.000000', 'consum', 0.0220, 'lps'),
	(687519, 136, '2015-02-01 00:31:52.000000', 'consum', 0.0234, 'lps'),
	(687520, 136, '2015-02-01 00:31:53.000000', 'consum', 0.0239, 'lps'),
	(687521, 136, '2015-02-01 00:31:54.000000', 'consum', 0.0215, 'lps'),
	(687522, 136, '2015-02-01 00:31:55.000000', 'consum', 0.0215, 'lps'),
	(687523, 136, '2015-02-01 00:31:56.000000', 'consum', 0.0222, 'lps'),
	(687524, 136, '2015-02-01 00:31:57.000000', 'consum', 0.0254, 'lps'),
	(687525, 136, '2015-02-01 00:31:58.000000', 'consum', 0.0265, 'lps'),
	(687526, 136, '2015-02-01 00:31:59.000000', 'consum', 0.0224, 'lps'),
	(687527, 136, '2015-02-01 00:32:00.000000', 'consum', 0.0245, 'lps'),
	(687528, 136, '2015-02-01 00:32:01.000000', 'consum', 0.0212, 'lps'),
	(687529, 136, '2015-02-01 00:32:02.000000', 'consum', 0.0246, 'lps'),
	(687530, 136, '2015-02-01 00:32:03.000000', 'consum', 0.0255, 'lps'),
	(687531, 136, '2015-02-01 00:32:04.000000', 'consum', 0.0261, 'lps'),
	(687532, 136, '2015-02-01 00:32:05.000000', 'consum', 0.0265, 'lps'),
	(687533, 136, '2015-02-01 00:32:06.000000', 'consum', 0.0268, 'lps'),
	(687534, 136, '2015-02-01 00:32:07.000000', 'consum', 0.0271, 'lps'),
	(687535, 136, '2015-02-01 00:32:08.000000', 'consum', 0.0211, 'lps'),
	(687536, 136, '2015-02-01 00:32:09.000000', 'consum', 0.0228, 'lps'),
	(687537, 136, '2015-02-01 00:32:10.000000', 'consum', 0.0230, 'lps'),
	(687538, 136, '2015-02-01 00:32:11.000000', 'consum', 0.0260, 'lps'),
	(687539, 136, '2015-02-01 00:32:12.000000', 'consum', 0.0268, 'lps'),
	(687540, 136, '2015-02-01 00:32:13.000000', 'consum', 0.0219, 'lps'),
	(687541, 136, '2015-02-01 00:32:14.000000', 'consum', 0.0214, 'lps'),
	(687542, 136, '2015-02-01 00:32:15.000000', 'consum', 0.0270, 'lps'),
	(687543, 136, '2015-02-01 00:32:16.000000', 'consum', 0.0235, 'lps'),
	(687544, 136, '2015-02-01 00:32:17.000000', 'consum', 0.0222, 'lps'),
	(687545, 136, '2015-02-01 00:32:18.000000', 'consum', 0.0262, 'lps'),
	(687546, 136, '2015-02-01 00:32:19.000000', 'consum', 0.0240, 'lps'),
	(687547, 136, '2015-02-01 00:32:20.000000', 'consum', 0.0266, 'lps'),
	(687548, 136, '2015-02-01 00:32:21.000000', 'consum', 0.0274, 'lps'),
	(687549, 136, '2015-02-01 00:32:22.000000', 'consum', 0.0230, 'lps'),
	(687550, 136, '2015-02-01 00:32:23.000000', 'consum', 0.0249, 'lps'),
	(687551, 136, '2015-02-01 00:32:24.000000', 'consum', 0.0216, 'lps'),
	(687552, 136, '2015-02-01 00:32:25.000000', 'consum', 0.0253, 'lps'),
	(687553, 136, '2015-02-01 00:32:26.000000', 'consum', 0.0212, 'lps'),
	(687554, 136, '2015-02-01 00:32:27.000000', 'consum', 0.0222, 'lps'),
	(687555, 136, '2015-02-01 00:32:28.000000', 'consum', 0.0267, 'lps'),
	(687556, 136, '2015-02-01 00:32:29.000000', 'consum', 0.0261, 'lps'),
	(687557, 136, '2015-02-01 00:32:30.000000', 'consum', 0.0231, 'lps'),
	(687558, 136, '2015-02-01 00:32:31.000000', 'consum', 0.0229, 'lps'),
	(687559, 136, '2015-02-01 00:32:32.000000', 'consum', 0.0243, 'lps'),
	(687560, 136, '2015-02-01 00:32:33.000000', 'consum', 0.0251, 'lps'),
	(687561, 136, '2015-02-01 00:32:34.000000', 'consum', 0.0254, 'lps'),
	(687562, 136, '2015-02-01 00:32:35.000000', 'consum', 0.0240, 'lps'),
	(687563, 136, '2015-02-01 00:32:36.000000', 'consum', 0.0228, 'lps'),
	(687564, 136, '2015-02-01 00:32:37.000000', 'consum', 0.0212, 'lps'),
	(687565, 136, '2015-02-01 00:32:38.000000', 'consum', 0.0233, 'lps'),
	(687566, 136, '2015-02-01 00:32:39.000000', 'consum', 0.0253, 'lps'),
	(687567, 136, '2015-02-01 00:32:40.000000', 'consum', 0.0226, 'lps'),
	(687568, 136, '2015-02-01 00:32:41.000000', 'consum', 0.0226, 'lps'),
	(687569, 136, '2015-02-01 00:32:42.000000', 'consum', 0.0245, 'lps'),
	(687570, 136, '2015-02-01 00:32:43.000000', 'consum', 0.0271, 'lps'),
	(687571, 136, '2015-02-01 00:32:44.000000', 'consum', 0.0217, 'lps'),
	(687572, 136, '2015-02-01 00:32:45.000000', 'consum', 0.0255, 'lps'),
	(687573, 136, '2015-02-01 00:32:46.000000', 'consum', 0.0223, 'lps'),
	(687574, 136, '2015-02-01 00:32:47.000000', 'consum', 0.0267, 'lps'),
	(687575, 136, '2015-02-01 00:32:48.000000', 'consum', 0.0263, 'lps'),
	(687576, 136, '2015-02-01 00:32:49.000000', 'consum', 0.0241, 'lps'),
	(687577, 136, '2015-02-01 00:32:50.000000', 'consum', 0.0272, 'lps'),
	(687578, 136, '2015-02-01 00:32:51.000000', 'consum', 0.0230, 'lps'),
	(687579, 136, '2015-02-01 00:32:52.000000', 'consum', 0.0254, 'lps'),
	(687580, 136, '2015-02-01 00:32:53.000000', 'consum', 0.0242, 'lps'),
	(687581, 136, '2015-02-01 00:32:54.000000', 'consum', 0.0237, 'lps'),
	(687582, 136, '2015-02-01 00:32:55.000000', 'consum', 0.0250, 'lps'),
	(687583, 136, '2015-02-01 00:32:56.000000', 'consum', 0.0265, 'lps'),
	(687584, 136, '2015-02-01 00:32:57.000000', 'consum', 0.0233, 'lps'),
	(687585, 136, '2015-02-01 00:32:58.000000', 'consum', 0.0229, 'lps'),
	(687586, 136, '2015-02-01 00:32:59.000000', 'consum', 0.0234, 'lps'),
	(687587, 136, '2015-02-01 00:33:00.000000', 'consum', 0.0274, 'lps'),
	(687588, 136, '2015-02-01 00:33:01.000000', 'consum', 0.0265, 'lps'),
	(687589, 136, '2015-02-01 00:33:02.000000', 'consum', 0.0229, 'lps'),
	(687590, 136, '2015-02-01 00:33:03.000000', 'consum', 0.0270, 'lps'),
	(687591, 136, '2015-02-01 00:33:04.000000', 'consum', 0.0258, 'lps'),
	(687592, 136, '2015-02-01 00:33:05.000000', 'consum', 0.0271, 'lps'),
	(687593, 136, '2015-02-01 00:33:06.000000', 'consum', 0.0241, 'lps'),
	(687594, 136, '2015-02-01 00:33:07.000000', 'consum', 0.0248, 'lps'),
	(687595, 136, '2015-02-01 00:33:08.000000', 'consum', 0.0240, 'lps'),
	(687596, 136, '2015-02-01 00:33:09.000000', 'consum', 0.0250, 'lps'),
	(687597, 136, '2015-02-01 00:33:10.000000', 'consum', 0.0253, 'lps'),
	(687598, 136, '2015-02-01 00:33:11.000000', 'consum', 0.0242, 'lps'),
	(687599, 136, '2015-02-01 00:33:12.000000', 'consum', 0.0241, 'lps'),
	(687600, 136, '2015-02-01 00:33:13.000000', 'consum', 0.0268, 'lps'),
	(687601, 136, '2015-02-01 00:33:14.000000', 'consum', 0.0213, 'lps'),
	(687602, 136, '2015-02-01 00:33:15.000000', 'consum', 0.0247, 'lps'),
	(687603, 136, '2015-02-01 00:33:16.000000', 'consum', 0.0257, 'lps'),
	(687604, 136, '2015-02-01 00:33:17.000000', 'consum', 0.0268, 'lps'),
	(687605, 136, '2015-02-01 00:33:18.000000', 'consum', 0.0232, 'lps'),
	(687606, 136, '2015-02-01 00:33:19.000000', 'consum', 0.0274, 'lps'),
	(687607, 136, '2015-02-01 00:33:20.000000', 'consum', 0.0269, 'lps'),
	(687608, 136, '2015-02-01 00:33:21.000000', 'consum', 0.0248, 'lps'),
	(687609, 136, '2015-02-01 00:33:22.000000', 'consum', 0.0222, 'lps'),
	(687610, 136, '2015-02-01 00:33:23.000000', 'consum', 0.0225, 'lps'),
	(687611, 136, '2015-02-01 00:33:24.000000', 'consum', 0.0249, 'lps'),
	(687612, 136, '2015-02-01 00:33:25.000000', 'consum', 0.0232, 'lps'),
	(687613, 136, '2015-02-01 00:33:26.000000', 'consum', 0.0266, 'lps'),
	(687614, 136, '2015-02-01 00:33:27.000000', 'consum', 0.0228, 'lps'),
	(687615, 136, '2015-02-01 00:33:28.000000', 'consum', 0.0266, 'lps'),
	(687616, 136, '2015-02-01 00:33:29.000000', 'consum', 0.0240, 'lps'),
	(687617, 136, '2015-02-01 00:33:30.000000', 'consum', 0.0258, 'lps'),
	(687618, 136, '2015-02-01 00:33:31.000000', 'consum', 0.0229, 'lps'),
	(687619, 136, '2015-02-01 00:33:32.000000', 'consum', 0.0228, 'lps'),
	(687620, 136, '2015-02-01 00:33:33.000000', 'consum', 0.0242, 'lps'),
	(687621, 136, '2015-02-01 00:33:34.000000', 'consum', 0.0252, 'lps'),
	(687622, 136, '2015-02-01 00:33:35.000000', 'consum', 0.0258, 'lps'),
	(687623, 136, '2015-02-01 00:33:36.000000', 'consum', 0.0262, 'lps'),
	(687624, 136, '2015-02-01 00:33:37.000000', 'consum', 0.0261, 'lps'),
	(687625, 136, '2015-02-01 00:33:38.000000', 'consum', 0.0245, 'lps'),
	(687626, 136, '2015-02-01 00:33:39.000000', 'consum', 0.0230, 'lps'),
	(687627, 136, '2015-02-01 00:33:40.000000', 'consum', 0.0271, 'lps'),
	(687628, 136, '2015-02-01 00:33:41.000000', 'consum', 0.0263, 'lps'),
	(687629, 136, '2015-02-01 00:33:42.000000', 'consum', 0.0225, 'lps'),
	(687630, 136, '2015-02-01 00:33:43.000000', 'consum', 0.0256, 'lps'),
	(687631, 136, '2015-02-01 00:33:44.000000', 'consum', 0.0266, 'lps'),
	(687632, 136, '2015-02-01 00:33:45.000000', 'consum', 0.0224, 'lps'),
	(687633, 136, '2015-02-01 00:33:46.000000', 'consum', 0.0241, 'lps'),
	(687634, 136, '2015-02-01 00:33:47.000000', 'consum', 0.0257, 'lps'),
	(687635, 136, '2015-02-01 00:33:48.000000', 'consum', 0.0224, 'lps'),
	(687636, 136, '2015-02-01 00:33:49.000000', 'consum', 0.0269, 'lps'),
	(687637, 136, '2015-02-01 00:33:50.000000', 'consum', 0.0269, 'lps'),
	(687638, 136, '2015-02-01 00:33:51.000000', 'consum', 0.0264, 'lps'),
	(687639, 136, '2015-02-01 00:33:52.000000', 'consum', 0.0238, 'lps'),
	(687640, 136, '2015-02-01 00:33:53.000000', 'consum', 0.0255, 'lps'),
	(687641, 136, '2015-02-01 00:33:54.000000', 'consum', 0.0221, 'lps'),
	(687642, 136, '2015-02-01 00:33:55.000000', 'consum', 0.0261, 'lps'),
	(687643, 136, '2015-02-01 00:33:56.000000', 'consum', 0.0237, 'lps'),
	(687644, 136, '2015-02-01 00:33:57.000000', 'consum', 0.0256, 'lps'),
	(687645, 136, '2015-02-01 00:33:58.000000', 'consum', 0.0231, 'lps'),
	(687646, 136, '2015-02-01 00:33:59.000000', 'consum', 0.0242, 'lps'),
	(687647, 136, '2015-02-01 00:34:00.000000', 'consum', 0.0243, 'lps'),
	(687648, 136, '2015-02-01 00:34:01.000000', 'consum', 0.0216, 'lps'),
	(687649, 136, '2015-02-01 00:34:02.000000', 'consum', 0.0270, 'lps'),
	(687650, 136, '2015-02-01 00:34:03.000000', 'consum', 0.0232, 'lps'),
	(687651, 136, '2015-02-01 00:34:04.000000', 'consum', 0.0272, 'lps'),
	(687652, 136, '2015-02-01 00:34:05.000000', 'consum', 0.0260, 'lps'),
	(687653, 136, '2015-02-01 00:34:06.000000', 'consum', 0.0210, 'lps'),
	(687654, 136, '2015-02-01 00:34:07.000000', 'consum', 0.0256, 'lps'),
	(687655, 136, '2015-02-01 00:34:08.000000', 'consum', 0.0242, 'lps'),
	(687656, 136, '2015-02-01 00:34:09.000000', 'consum', 0.0236, 'lps'),
	(687657, 136, '2015-02-01 00:34:10.000000', 'consum', 0.0245, 'lps'),
	(687658, 136, '2015-02-01 00:34:11.000000', 'consum', 0.0240, 'lps'),
	(687659, 136, '2015-02-01 00:34:12.000000', 'consum', 0.0255, 'lps'),
	(687660, 136, '2015-02-01 00:34:13.000000', 'consum', 0.0218, 'lps'),
	(687661, 136, '2015-02-01 00:34:14.000000', 'consum', 0.0242, 'lps'),
	(687662, 136, '2015-02-01 00:34:15.000000', 'consum', 0.0220, 'lps'),
	(687663, 136, '2015-02-01 00:34:16.000000', 'consum', 0.0227, 'lps'),
	(687664, 136, '2015-02-01 00:34:17.000000', 'consum', 0.0265, 'lps'),
	(687665, 136, '2015-02-01 00:34:18.000000', 'consum', 0.0240, 'lps'),
	(687666, 136, '2015-02-01 00:34:19.000000', 'consum', 0.0259, 'lps'),
	(687667, 136, '2015-02-01 00:34:20.000000', 'consum', 0.0236, 'lps'),
	(687668, 136, '2015-02-01 00:34:21.000000', 'consum', 0.0258, 'lps'),
	(687669, 136, '2015-02-01 00:34:22.000000', 'consum', 0.0242, 'lps'),
	(687670, 136, '2015-02-01 00:34:23.000000', 'consum', 0.0226, 'lps'),
	(687671, 136, '2015-02-01 00:34:24.000000', 'consum', 0.0259, 'lps'),
	(687672, 136, '2015-02-01 00:34:25.000000', 'consum', 0.0213, 'lps'),
	(687673, 136, '2015-02-01 00:34:26.000000', 'consum', 0.0273, 'lps'),
	(687674, 136, '2015-02-01 00:34:27.000000', 'consum', 0.0256, 'lps'),
	(687675, 136, '2015-02-01 00:34:28.000000', 'consum', 0.0253, 'lps'),
	(687676, 136, '2015-02-01 00:34:29.000000', 'consum', 0.0224, 'lps'),
	(687677, 136, '2015-02-01 00:34:30.000000', 'consum', 0.0215, 'lps'),
	(687678, 136, '2015-02-01 00:34:31.000000', 'consum', 0.0258, 'lps'),
	(687679, 136, '2015-02-01 00:34:32.000000', 'consum', 0.0239, 'lps'),
	(687680, 136, '2015-02-01 00:34:33.000000', 'consum', 0.0214, 'lps'),
	(687681, 136, '2015-02-01 00:34:34.000000', 'consum', 0.0271, 'lps'),
	(687682, 136, '2015-02-01 00:34:35.000000', 'consum', 0.0243, 'lps'),
	(687683, 136, '2015-02-01 00:34:36.000000', 'consum', 0.0260, 'lps'),
	(687684, 136, '2015-02-01 00:34:37.000000', 'consum', 0.0230, 'lps'),
	(687685, 136, '2015-02-01 00:34:38.000000', 'consum', 0.0226, 'lps'),
	(687686, 136, '2015-02-01 00:34:39.000000', 'consum', 0.0233, 'lps'),
	(687687, 136, '2015-02-01 00:34:40.000000', 'consum', 0.0274, 'lps'),
	(687688, 136, '2015-02-01 00:34:41.000000', 'consum', 0.0266, 'lps'),
	(687689, 136, '2015-02-01 00:34:42.000000', 'consum', 0.0235, 'lps'),
	(687690, 136, '2015-02-01 00:34:43.000000', 'consum', 0.0234, 'lps'),
	(687691, 136, '2015-02-01 00:34:44.000000', 'consum', 0.0255, 'lps'),
	(687692, 136, '2015-02-01 00:34:45.000000', 'consum', 0.0233, 'lps'),
	(687693, 136, '2015-02-01 00:34:46.000000', 'consum', 0.0255, 'lps'),
	(687694, 136, '2015-02-01 00:34:47.000000', 'consum', 0.0235, 'lps'),
	(687695, 136, '2015-02-01 00:34:48.000000', 'consum', 0.0269, 'lps'),
	(687696, 136, '2015-02-01 00:34:49.000000', 'consum', 0.0232, 'lps'),
	(687697, 136, '2015-02-01 00:34:50.000000', 'consum', 0.0274, 'lps'),
	(687698, 136, '2015-02-01 00:34:51.000000', 'consum', 0.0270, 'lps'),
	(687699, 136, '2015-02-01 00:34:52.000000', 'consum', 0.0255, 'lps'),
	(687700, 136, '2015-02-01 00:34:53.000000', 'consum', 0.0256, 'lps'),
	(687701, 136, '2015-02-01 00:34:54.000000', 'consum', 0.0238, 'lps'),
	(687702, 136, '2015-02-01 00:34:55.000000', 'consum', 0.0214, 'lps'),
	(687703, 136, '2015-02-01 00:34:56.000000', 'consum', 0.0213, 'lps'),
	(687704, 136, '2015-02-01 00:34:57.000000', 'consum', 0.0210, 'lps'),
	(687705, 136, '2015-02-01 00:34:58.000000', 'consum', 0.0269, 'lps'),
	(687706, 136, '2015-02-01 00:34:59.000000', 'consum', 0.0244, 'lps'),
	(687707, 136, '2015-02-01 00:35:00.000000', 'consum', 0.0268, 'lps'),
	(687708, 136, '2015-02-01 00:35:01.000000', 'consum', 0.0269, 'lps'),
	(687709, 136, '2015-02-01 00:35:02.000000', 'consum', 0.0267, 'lps'),
	(687710, 136, '2015-02-01 00:35:03.000000', 'consum', 0.0252, 'lps'),
	(687711, 136, '2015-02-01 00:35:04.000000', 'consum', 0.0249, 'lps'),
	(687712, 136, '2015-02-01 00:35:05.000000', 'consum', 0.0214, 'lps'),
	(687713, 136, '2015-02-01 00:35:06.000000', 'consum', 0.0243, 'lps'),
	(687714, 136, '2015-02-01 00:35:07.000000', 'consum', 0.0235, 'lps'),
	(687715, 136, '2015-02-01 00:35:08.000000', 'consum', 0.0235, 'lps'),
	(687716, 136, '2015-02-01 00:35:09.000000', 'consum', 0.0262, 'lps'),
	(687717, 136, '2015-02-01 00:35:10.000000', 'consum', 0.0266, 'lps'),
	(687718, 136, '2015-02-01 00:35:11.000000', 'consum', 0.0271, 'lps'),
	(687719, 136, '2015-02-01 00:35:12.000000', 'consum', 0.0214, 'lps'),
	(687720, 136, '2015-02-01 00:35:13.000000', 'consum', 0.0246, 'lps'),
	(687721, 136, '2015-02-01 00:35:14.000000', 'consum', 0.0246, 'lps'),
	(687722, 136, '2015-02-01 00:35:15.000000', 'consum', 0.0219, 'lps'),
	(687723, 136, '2015-02-01 00:35:16.000000', 'consum', 0.0212, 'lps'),
	(687724, 136, '2015-02-01 00:35:17.000000', 'consum', 0.0258, 'lps'),
	(687725, 136, '2015-02-01 00:35:18.000000', 'consum', 0.0250, 'lps'),
	(687726, 136, '2015-02-01 00:35:19.000000', 'consum', 0.0267, 'lps'),
	(687727, 136, '2015-02-01 00:35:20.000000', 'consum', 0.0245, 'lps'),
	(687728, 136, '2015-02-01 00:35:21.000000', 'consum', 0.0213, 'lps'),
	(687729, 136, '2015-02-01 00:35:22.000000', 'consum', 0.0250, 'lps'),
	(687730, 136, '2015-02-01 00:35:23.000000', 'consum', 0.0271, 'lps'),
	(687731, 136, '2015-02-01 00:35:24.000000', 'consum', 0.0266, 'lps'),
	(687732, 136, '2015-02-01 00:35:25.000000', 'consum', 0.0241, 'lps'),
	(687733, 136, '2015-02-01 00:35:26.000000', 'consum', 0.0266, 'lps'),
	(687734, 136, '2015-02-01 00:35:27.000000', 'consum', 0.0265, 'lps'),
	(687735, 136, '2015-02-01 00:35:28.000000', 'consum', 0.0253, 'lps'),
	(687736, 136, '2015-02-01 00:35:29.000000', 'consum', 0.0262, 'lps'),
	(687737, 136, '2015-02-01 00:35:30.000000', 'consum', 0.0211, 'lps'),
	(687738, 136, '2015-02-01 00:35:31.000000', 'consum', 0.0256, 'lps'),
	(687739, 136, '2015-02-01 00:35:32.000000', 'consum', 0.0243, 'lps'),
	(687740, 136, '2015-02-01 00:35:33.000000', 'consum', 0.0235, 'lps'),
	(687741, 136, '2015-02-01 00:35:34.000000', 'consum', 0.0236, 'lps'),
	(687742, 136, '2015-02-01 00:35:35.000000', 'consum', 0.0266, 'lps'),
	(687743, 136, '2015-02-01 00:35:36.000000', 'consum', 0.0220, 'lps'),
	(687744, 136, '2015-02-01 00:35:37.000000', 'consum', 0.0220, 'lps'),
	(687745, 136, '2015-02-01 00:35:38.000000', 'consum', 0.0230, 'lps'),
	(687746, 136, '2015-02-01 00:35:39.000000', 'consum', 0.0216, 'lps'),
	(687747, 136, '2015-02-01 00:35:40.000000', 'consum', 0.0244, 'lps'),
	(687748, 136, '2015-02-01 00:35:41.000000', 'consum', 0.0232, 'lps'),
	(687749, 136, '2015-02-01 00:35:42.000000', 'consum', 0.0220, 'lps'),
	(687750, 136, '2015-02-01 00:35:43.000000', 'consum', 0.0261, 'lps'),
	(687751, 136, '2015-02-01 00:35:44.000000', 'consum', 0.0240, 'lps'),
	(687752, 136, '2015-02-01 00:35:45.000000', 'consum', 0.0271, 'lps'),
	(687753, 136, '2015-02-01 00:35:46.000000', 'consum', 0.0230, 'lps'),
	(687754, 136, '2015-02-01 00:35:47.000000', 'consum', 0.0258, 'lps'),
	(687755, 136, '2015-02-01 00:35:48.000000', 'consum', 0.0260, 'lps'),
	(687756, 136, '2015-02-01 00:35:49.000000', 'consum', 0.0251, 'lps'),
	(687757, 136, '2015-02-01 00:35:50.000000', 'consum', 0.0266, 'lps'),
	(687758, 136, '2015-02-01 00:35:51.000000', 'consum', 0.0240, 'lps'),
	(687759, 136, '2015-02-01 00:35:52.000000', 'consum', 0.0254, 'lps'),
	(687760, 136, '2015-02-01 00:35:53.000000', 'consum', 0.0211, 'lps'),
	(687761, 136, '2015-02-01 00:35:54.000000', 'consum', 0.0212, 'lps'),
	(687762, 136, '2015-02-01 00:35:55.000000', 'consum', 0.0220, 'lps'),
	(687763, 136, '2015-02-01 00:35:56.000000', 'consum', 0.0255, 'lps'),
	(687764, 136, '2015-02-01 00:35:57.000000', 'consum', 0.0210, 'lps'),
	(687765, 136, '2015-02-01 00:35:58.000000', 'consum', 0.0270, 'lps'),
	(687766, 136, '2015-02-01 00:35:59.000000', 'consum', 0.0250, 'lps'),
	(687767, 136, '2015-02-01 00:36:00.000000', 'consum', 0.0229, 'lps'),
	(687768, 136, '2015-02-01 00:36:01.000000', 'consum', 0.0252, 'lps'),
	(687769, 136, '2015-02-01 00:36:02.000000', 'consum', 0.0235, 'lps'),
	(687770, 136, '2015-02-01 00:36:03.000000', 'consum', 0.0272, 'lps'),
	(687771, 136, '2015-02-01 00:36:04.000000', 'consum', 0.0252, 'lps'),
	(687772, 136, '2015-02-01 00:36:05.000000', 'consum', 0.0233, 'lps'),
	(687773, 136, '2015-02-01 00:36:06.000000', 'consum', 0.0265, 'lps'),
	(687774, 136, '2015-02-01 00:36:07.000000', 'consum', 0.0224, 'lps'),
	(687775, 136, '2015-02-01 00:36:08.000000', 'consum', 0.0242, 'lps'),
	(687776, 136, '2015-02-01 00:36:09.000000', 'consum', 0.0264, 'lps'),
	(687777, 136, '2015-02-01 00:36:10.000000', 'consum', 0.0256, 'lps'),
	(687778, 136, '2015-02-01 00:36:11.000000', 'consum', 0.0214, 'lps'),
	(687779, 136, '2015-02-01 00:36:12.000000', 'consum', 0.0220, 'lps'),
	(687780, 136, '2015-02-01 00:36:13.000000', 'consum', 0.0251, 'lps'),
	(687781, 136, '2015-02-01 00:36:14.000000', 'consum', 0.0254, 'lps'),
	(687782, 136, '2015-02-01 00:36:15.000000', 'consum', 0.0244, 'lps'),
	(687783, 136, '2015-02-01 00:36:16.000000', 'consum', 0.0248, 'lps'),
	(687784, 136, '2015-02-01 00:36:17.000000', 'consum', 0.0235, 'lps'),
	(687785, 136, '2015-02-01 00:36:18.000000', 'consum', 0.0220, 'lps'),
	(687786, 136, '2015-02-01 00:36:19.000000', 'consum', 0.0251, 'lps'),
	(687787, 136, '2015-02-01 00:36:20.000000', 'consum', 0.0254, 'lps'),
	(687788, 136, '2015-02-01 00:36:21.000000', 'consum', 0.0243, 'lps'),
	(687789, 136, '2015-02-01 00:36:22.000000', 'consum', 0.0242, 'lps'),
	(687790, 136, '2015-02-01 00:36:23.000000', 'consum', 0.0274, 'lps'),
	(687791, 136, '2015-02-01 00:36:24.000000', 'consum', 0.0239, 'lps'),
	(687792, 136, '2015-02-01 00:36:25.000000', 'consum', 0.0230, 'lps'),
	(687793, 136, '2015-02-01 00:36:26.000000', 'consum', 0.0223, 'lps'),
	(687794, 136, '2015-02-01 00:36:27.000000', 'consum', 0.0214, 'lps'),
	(687795, 136, '2015-02-01 00:36:28.000000', 'consum', 0.0256, 'lps'),
	(687796, 136, '2015-02-01 00:36:29.000000', 'consum', 0.0233, 'lps'),
	(687797, 136, '2015-02-01 00:36:30.000000', 'consum', 0.0252, 'lps'),
	(687798, 136, '2015-02-01 00:36:31.000000', 'consum', 0.0222, 'lps'),
	(687799, 136, '2015-02-01 00:36:32.000000', 'consum', 0.0211, 'lps'),
	(687800, 136, '2015-02-01 00:36:33.000000', 'consum', 0.0244, 'lps'),
	(687801, 136, '2015-02-01 00:36:34.000000', 'consum', 0.0245, 'lps'),
	(687802, 136, '2015-02-01 00:36:35.000000', 'consum', 0.0221, 'lps'),
	(687803, 136, '2015-02-01 00:36:36.000000', 'consum', 0.0226, 'lps'),
	(687804, 136, '2015-02-01 00:36:37.000000', 'consum', 0.0257, 'lps'),
	(687805, 136, '2015-02-01 00:36:38.000000', 'consum', 0.0267, 'lps'),
	(687806, 136, '2015-02-01 00:36:39.000000', 'consum', 0.0227, 'lps'),
	(687807, 136, '2015-02-01 00:36:40.000000', 'consum', 0.0251, 'lps'),
	(687808, 136, '2015-02-01 00:36:41.000000', 'consum', 0.0238, 'lps'),
	(687809, 136, '2015-02-01 00:36:42.000000', 'consum', 0.0226, 'lps'),
	(687810, 136, '2015-02-01 00:36:43.000000', 'consum', 0.0271, 'lps'),
	(687811, 136, '2015-02-01 00:36:44.000000', 'consum', 0.0271, 'lps'),
	(687812, 136, '2015-02-01 00:36:45.000000', 'consum', 0.0269, 'lps'),
	(687813, 136, '2015-02-01 00:36:46.000000', 'consum', 0.0258, 'lps'),
	(687814, 136, '2015-02-01 00:36:47.000000', 'consum', 0.0274, 'lps'),
	(687815, 136, '2015-02-01 00:36:48.000000', 'consum', 0.0257, 'lps'),
	(687816, 136, '2015-02-01 00:36:49.000000', 'consum', 0.0252, 'lps'),
	(687817, 136, '2015-02-01 00:36:50.000000', 'consum', 0.0216, 'lps'),
	(687818, 136, '2015-02-01 00:36:51.000000', 'consum', 0.0246, 'lps'),
	(687819, 136, '2015-02-01 00:36:52.000000', 'consum', 0.0241, 'lps'),
	(687820, 136, '2015-02-01 00:36:53.000000', 'consum', 0.0256, 'lps'),
	(687821, 136, '2015-02-01 00:36:54.000000', 'consum', 0.0218, 'lps'),
	(687822, 136, '2015-02-01 00:36:55.000000', 'consum', 0.0244, 'lps'),
	(687823, 136, '2015-02-01 00:36:56.000000', 'consum', 0.0224, 'lps'),
	(687824, 136, '2015-02-01 00:36:57.000000', 'consum', 0.0243, 'lps'),
	(687825, 136, '2015-02-01 00:36:58.000000', 'consum', 0.0270, 'lps'),
	(687826, 136, '2015-02-01 00:36:59.000000', 'consum', 0.0214, 'lps'),
	(687827, 136, '2015-02-01 00:37:00.000000', 'consum', 0.0249, 'lps'),
	(687828, 136, '2015-02-01 00:37:01.000000', 'consum', 0.0263, 'lps'),
	(687829, 136, '2015-02-01 00:37:02.000000', 'consum', 0.0226, 'lps'),
	(687830, 136, '2015-02-01 00:37:03.000000', 'consum', 0.0262, 'lps'),
	(687831, 136, '2015-02-01 00:37:04.000000', 'consum', 0.0230, 'lps'),
	(687832, 136, '2015-02-01 00:37:05.000000', 'consum', 0.0217, 'lps'),
	(687833, 136, '2015-02-01 00:37:06.000000', 'consum', 0.0252, 'lps'),
	(687834, 136, '2015-02-01 00:37:07.000000', 'consum', 0.0267, 'lps'),
	(687835, 136, '2015-02-01 00:37:08.000000', 'consum', 0.0241, 'lps'),
	(687836, 136, '2015-02-01 00:37:09.000000', 'consum', 0.0261, 'lps'),
	(687837, 136, '2015-02-01 00:37:10.000000', 'consum', 0.0242, 'lps'),
	(687838, 136, '2015-02-01 00:37:11.000000', 'consum', 0.0216, 'lps'),
	(687839, 136, '2015-02-01 00:37:12.000000', 'consum', 0.0273, 'lps'),
	(687840, 136, '2015-02-01 00:37:13.000000', 'consum', 0.0250, 'lps'),
	(687841, 136, '2015-02-01 00:37:14.000000', 'consum', 0.0223, 'lps'),
	(687842, 136, '2015-02-01 00:37:15.000000', 'consum', 0.0218, 'lps'),
	(687843, 136, '2015-02-01 00:37:16.000000', 'consum', 0.0211, 'lps'),
	(687844, 136, '2015-02-01 00:37:17.000000', 'consum', 0.0256, 'lps'),
	(687845, 136, '2015-02-01 00:37:18.000000', 'consum', 0.0242, 'lps'),
	(687846, 136, '2015-02-01 00:37:19.000000', 'consum', 0.0233, 'lps'),
	(687847, 136, '2015-02-01 00:37:20.000000', 'consum', 0.0230, 'lps'),
	(687848, 136, '2015-02-01 00:37:21.000000', 'consum', 0.0242, 'lps'),
	(687849, 136, '2015-02-01 00:37:22.000000', 'consum', 0.0243, 'lps'),
	(687850, 136, '2015-02-01 00:37:23.000000', 'consum', 0.0216, 'lps'),
	(687851, 136, '2015-02-01 00:37:24.000000', 'consum', 0.0270, 'lps'),
	(687852, 136, '2015-02-01 00:37:25.000000', 'consum', 0.0234, 'lps'),
	(687853, 136, '2015-02-01 00:37:26.000000', 'consum', 0.0214, 'lps'),
	(687854, 136, '2015-02-01 00:37:27.000000', 'consum', 0.0224, 'lps'),
	(687855, 136, '2015-02-01 00:37:28.000000', 'consum', 0.0270, 'lps'),
	(687856, 136, '2015-02-01 00:37:29.000000', 'consum', 0.0272, 'lps'),
	(687857, 136, '2015-02-01 00:37:30.000000', 'consum', 0.0210, 'lps'),
	(687858, 136, '2015-02-01 00:37:31.000000', 'consum', 0.0219, 'lps'),
	(687859, 136, '2015-02-01 00:37:32.000000', 'consum', 0.0257, 'lps'),
	(687860, 136, '2015-02-01 00:37:33.000000', 'consum', 0.0224, 'lps'),
	(687861, 136, '2015-02-01 00:37:34.000000', 'consum', 0.0270, 'lps'),
	(687862, 136, '2015-02-01 00:37:35.000000', 'consum', 0.0273, 'lps'),
	(687863, 136, '2015-02-01 00:37:36.000000', 'consum', 0.0214, 'lps'),
	(687864, 136, '2015-02-01 00:37:37.000000', 'consum', 0.0236, 'lps'),
	(687865, 136, '2015-02-01 00:37:38.000000', 'consum', 0.0266, 'lps'),
	(687866, 136, '2015-02-01 00:37:39.000000', 'consum', 0.0215, 'lps'),
	(687867, 136, '2015-02-01 00:37:40.000000', 'consum', 0.0262, 'lps'),
	(687868, 136, '2015-02-01 00:37:41.000000', 'consum', 0.0261, 'lps'),
	(687869, 136, '2015-02-01 00:37:42.000000', 'consum', 0.0243, 'lps'),
	(687870, 136, '2015-02-01 00:37:43.000000', 'consum', 0.0224, 'lps'),
	(687871, 136, '2015-02-01 00:37:44.000000', 'consum', 0.0248, 'lps'),
	(687872, 136, '2015-02-01 00:37:45.000000', 'consum', 0.0225, 'lps'),
	(687873, 136, '2015-02-01 00:37:46.000000', 'consum', 0.0240, 'lps'),
	(687874, 136, '2015-02-01 00:37:47.000000', 'consum', 0.0249, 'lps'),
	(687875, 136, '2015-02-01 00:37:48.000000', 'consum', 0.0252, 'lps'),
	(687876, 136, '2015-02-01 00:37:49.000000', 'consum', 0.0239, 'lps'),
	(687877, 136, '2015-02-01 00:37:50.000000', 'consum', 0.0228, 'lps'),
	(687878, 136, '2015-02-01 00:37:51.000000', 'consum', 0.0215, 'lps'),
	(687879, 136, '2015-02-01 00:37:52.000000', 'consum', 0.0245, 'lps'),
	(687880, 136, '2015-02-01 00:37:53.000000', 'consum', 0.0242, 'lps'),
	(687881, 136, '2015-02-01 00:37:54.000000', 'consum', 0.0263, 'lps'),
	(687882, 136, '2015-02-01 00:37:55.000000', 'consum', 0.0250, 'lps'),
	(687883, 136, '2015-02-01 00:37:56.000000', 'consum', 0.0252, 'lps'),
	(687884, 136, '2015-02-01 00:37:57.000000', 'consum', 0.0236, 'lps'),
	(687885, 136, '2015-02-01 00:37:58.000000', 'consum', 0.0216, 'lps'),
	(687886, 136, '2015-02-01 00:37:59.000000', 'consum', 0.0224, 'lps'),
	(687887, 136, '2015-02-01 00:38:00.000000', 'consum', 0.0265, 'lps'),
	(687888, 136, '2015-02-01 00:38:01.000000', 'consum', 0.0247, 'lps'),
	(687889, 136, '2015-02-01 00:38:02.000000', 'consum', 0.0232, 'lps'),
	(687890, 136, '2015-02-01 00:38:03.000000', 'consum', 0.0210, 'lps'),
	(687891, 136, '2015-02-01 00:38:04.000000', 'consum', 0.0274, 'lps'),
	(687892, 136, '2015-02-01 00:38:05.000000', 'consum', 0.0269, 'lps'),
	(687893, 136, '2015-02-01 00:38:06.000000', 'consum', 0.0250, 'lps'),
	(687894, 136, '2015-02-01 00:38:07.000000', 'consum', 0.0232, 'lps'),
	(687895, 136, '2015-02-01 00:38:08.000000', 'consum', 0.0265, 'lps'),
	(687896, 136, '2015-02-01 00:38:09.000000', 'consum', 0.0226, 'lps'),
	(687897, 136, '2015-02-01 00:38:10.000000', 'consum', 0.0253, 'lps'),
	(687898, 136, '2015-02-01 00:38:11.000000', 'consum', 0.0251, 'lps'),
	(687899, 136, '2015-02-01 00:38:12.000000', 'consum', 0.0218, 'lps'),
	(687900, 136, '2015-02-01 00:38:13.000000', 'consum', 0.0259, 'lps'),
	(687901, 136, '2015-02-01 00:38:14.000000', 'consum', 0.0235, 'lps'),
	(687902, 136, '2015-02-01 00:38:15.000000', 'consum', 0.0256, 'lps'),
	(687903, 136, '2015-02-01 00:38:16.000000', 'consum', 0.0235, 'lps'),
	(687904, 136, '2015-02-01 00:38:17.000000', 'consum', 0.0263, 'lps'),
	(687905, 136, '2015-02-01 00:38:18.000000', 'consum', 0.0268, 'lps'),
	(687906, 136, '2015-02-01 00:38:19.000000', 'consum', 0.0213, 'lps'),
	(687907, 136, '2015-02-01 00:38:20.000000', 'consum', 0.0247, 'lps'),
	(687908, 136, '2015-02-01 00:38:21.000000', 'consum', 0.0254, 'lps'),
	(687909, 136, '2015-02-01 00:38:22.000000', 'consum', 0.0257, 'lps'),
	(687910, 136, '2015-02-01 00:38:23.000000', 'consum', 0.0247, 'lps'),
	(687911, 136, '2015-02-01 00:38:24.000000', 'consum', 0.0256, 'lps'),
	(687912, 136, '2015-02-01 00:38:25.000000', 'consum', 0.0265, 'lps'),
	(687913, 136, '2015-02-01 00:38:26.000000', 'consum', 0.0216, 'lps'),
	(687914, 136, '2015-02-01 00:38:27.000000', 'consum', 0.0272, 'lps'),
	(687915, 136, '2015-02-01 00:38:28.000000', 'consum', 0.0243, 'lps'),
	(687916, 136, '2015-02-01 00:38:29.000000', 'consum', 0.0254, 'lps'),
	(687917, 136, '2015-02-01 00:38:30.000000', 'consum', 0.0268, 'lps'),
	(687918, 136, '2015-02-01 00:38:31.000000', 'consum', 0.0238, 'lps'),
	(687919, 136, '2015-02-01 00:38:32.000000', 'consum', 0.0243, 'lps'),
	(687920, 136, '2015-02-01 00:38:33.000000', 'consum', 0.0225, 'lps'),
	(687921, 136, '2015-02-01 00:38:34.000000', 'consum', 0.0253, 'lps'),
	(687922, 136, '2015-02-01 00:38:35.000000', 'consum', 0.0252, 'lps'),
	(687923, 136, '2015-02-01 00:38:36.000000', 'consum', 0.0223, 'lps'),
	(687924, 136, '2015-02-01 00:38:37.000000', 'consum', 0.0217, 'lps'),
	(687925, 136, '2015-02-01 00:38:38.000000', 'consum', 0.0269, 'lps'),
	(687926, 136, '2015-02-01 00:38:39.000000', 'consum', 0.0228, 'lps'),
	(687927, 136, '2015-02-01 00:38:40.000000', 'consum', 0.0251, 'lps'),
	(687928, 136, '2015-02-01 00:38:41.000000', 'consum', 0.0230, 'lps'),
	(687929, 136, '2015-02-01 00:38:42.000000', 'consum', 0.0254, 'lps'),
	(687930, 136, '2015-02-01 00:38:43.000000', 'consum', 0.0240, 'lps'),
	(687931, 136, '2015-02-01 00:38:44.000000', 'consum', 0.0231, 'lps'),
	(687932, 136, '2015-02-01 00:38:45.000000', 'consum', 0.0222, 'lps'),
	(687933, 136, '2015-02-01 00:38:46.000000', 'consum', 0.0210, 'lps'),
	(687934, 136, '2015-02-01 00:38:47.000000', 'consum', 0.0240, 'lps'),
	(687935, 136, '2015-02-01 00:38:48.000000', 'consum', 0.0228, 'lps'),
	(687936, 136, '2015-02-01 00:38:49.000000', 'consum', 0.0211, 'lps'),
	(687937, 136, '2015-02-01 00:38:50.000000', 'consum', 0.0228, 'lps'),
	(687938, 136, '2015-02-01 00:38:51.000000', 'consum', 0.0232, 'lps'),
	(687939, 136, '2015-02-01 00:38:52.000000', 'consum', 0.0264, 'lps'),
	(687940, 136, '2015-02-01 00:38:53.000000', 'consum', 0.0223, 'lps'),
	(687941, 136, '2015-02-01 00:38:54.000000', 'consum', 0.0243, 'lps'),
	(687942, 136, '2015-02-01 00:38:55.000000', 'consum', 0.0272, 'lps'),
	(687943, 136, '2015-02-01 00:38:56.000000', 'consum', 0.0227, 'lps'),
	(687944, 136, '2015-02-01 00:38:57.000000', 'consum', 0.0237, 'lps'),
	(687945, 136, '2015-02-01 00:38:58.000000', 'consum', 0.0231, 'lps'),
	(687946, 136, '2015-02-01 00:38:59.000000', 'consum', 0.0236, 'lps'),
	(687947, 136, '2015-02-01 00:39:00.000000', 'consum', 0.0211, 'lps'),
	(687948, 136, '2015-02-01 00:39:01.000000', 'consum', 0.0267, 'lps'),
	(687949, 136, '2015-02-01 00:39:02.000000', 'consum', 0.0235, 'lps'),
	(687950, 136, '2015-02-01 00:39:03.000000', 'consum', 0.0226, 'lps'),
	(687951, 136, '2015-02-01 00:39:04.000000', 'consum', 0.0218, 'lps'),
	(687952, 136, '2015-02-01 00:39:05.000000', 'consum', 0.0266, 'lps'),
	(687953, 136, '2015-02-01 00:39:06.000000', 'consum', 0.0271, 'lps'),
	(687954, 136, '2015-02-01 00:39:07.000000', 'consum', 0.0217, 'lps'),
	(687955, 136, '2015-02-01 00:39:08.000000', 'consum', 0.0260, 'lps'),
	(687956, 136, '2015-02-01 00:39:09.000000', 'consum', 0.0242, 'lps'),
	(687957, 136, '2015-02-01 00:39:10.000000', 'consum', 0.0221, 'lps'),
	(687958, 136, '2015-02-01 00:39:11.000000', 'consum', 0.0233, 'lps'),
	(687959, 136, '2015-02-01 00:39:12.000000', 'consum', 0.0230, 'lps'),
	(687960, 136, '2015-02-01 00:39:13.000000', 'consum', 0.0239, 'lps'),
	(687961, 136, '2015-02-01 00:39:14.000000', 'consum', 0.0232, 'lps'),
	(687962, 136, '2015-02-01 00:39:15.000000', 'consum', 0.0235, 'lps'),
	(687963, 136, '2015-02-01 00:39:16.000000', 'consum', 0.0270, 'lps'),
	(687964, 136, '2015-02-01 00:39:17.000000', 'consum', 0.0237, 'lps'),
	(687965, 136, '2015-02-01 00:39:18.000000', 'consum', 0.0233, 'lps'),
	(687966, 136, '2015-02-01 00:39:19.000000', 'consum', 0.0243, 'lps'),
	(687967, 136, '2015-02-01 00:39:20.000000', 'consum', 0.0243, 'lps'),
	(687968, 136, '2015-02-01 00:39:21.000000', 'consum', 0.0210, 'lps'),
	(687969, 136, '2015-02-01 00:39:22.000000', 'consum', 0.0240, 'lps'),
	(687970, 136, '2015-02-01 00:39:23.000000', 'consum', 0.0233, 'lps'),
	(687971, 136, '2015-02-01 00:39:24.000000', 'consum', 0.0233, 'lps'),
	(687972, 136, '2015-02-01 00:39:25.000000', 'consum', 0.0260, 'lps'),
	(687973, 136, '2015-02-01 00:39:26.000000', 'consum', 0.0259, 'lps'),
	(687974, 136, '2015-02-01 00:39:27.000000', 'consum', 0.0242, 'lps'),
	(687975, 136, '2015-02-01 00:39:28.000000', 'consum', 0.0223, 'lps'),
	(687976, 136, '2015-02-01 00:39:29.000000', 'consum', 0.0245, 'lps'),
	(687977, 136, '2015-02-01 00:39:30.000000', 'consum', 0.0218, 'lps'),
	(687978, 136, '2015-02-01 00:39:31.000000', 'consum', 0.0274, 'lps'),
	(687979, 136, '2015-02-01 00:39:32.000000', 'consum', 0.0247, 'lps'),
	(687980, 136, '2015-02-01 00:39:33.000000', 'consum', 0.0267, 'lps'),
	(687981, 136, '2015-02-01 00:39:34.000000', 'consum', 0.0255, 'lps'),
	(687982, 136, '2015-02-01 00:39:35.000000', 'consum', 0.0265, 'lps'),
	(687983, 136, '2015-02-01 00:39:36.000000', 'consum', 0.0220, 'lps'),
	(687984, 136, '2015-02-01 00:39:37.000000', 'consum', 0.0226, 'lps'),
	(687985, 136, '2015-02-01 00:39:38.000000', 'consum', 0.0258, 'lps'),
	(687986, 136, '2015-02-01 00:39:39.000000', 'consum', 0.0210, 'lps'),
	(687987, 136, '2015-02-01 00:39:40.000000', 'consum', 0.0263, 'lps'),
	(687988, 136, '2015-02-01 00:39:41.000000', 'consum', 0.0212, 'lps'),
	(687989, 136, '2015-02-01 00:39:42.000000', 'consum', 0.0259, 'lps'),
	(687990, 136, '2015-02-01 00:39:43.000000', 'consum', 0.0254, 'lps'),
	(687991, 136, '2015-02-01 00:39:44.000000', 'consum', 0.0216, 'lps'),
	(687992, 136, '2015-02-01 00:39:45.000000', 'consum', 0.0242, 'lps'),
	(687993, 136, '2015-02-01 00:39:46.000000', 'consum', 0.0222, 'lps'),
	(687994, 136, '2015-02-01 00:39:47.000000', 'consum', 0.0239, 'lps'),
	(687995, 136, '2015-02-01 00:39:48.000000', 'consum', 0.0256, 'lps'),
	(687996, 136, '2015-02-01 00:39:49.000000', 'consum', 0.0222, 'lps'),
	(687997, 136, '2015-02-01 00:39:50.000000', 'consum', 0.0261, 'lps'),
	(687998, 136, '2015-02-01 00:39:51.000000', 'consum', 0.0237, 'lps'),
	(687999, 136, '2015-02-01 00:39:52.000000', 'consum', 0.0256, 'lps'),
	(688000, 136, '2015-02-01 00:39:53.000000', 'consum', 0.0228, 'lps'),
	(688001, 136, '2015-02-01 00:39:54.000000', 'consum', 0.0231, 'lps'),
	(688002, 136, '2015-02-01 00:39:55.000000', 'consum', 0.0258, 'lps'),
	(688003, 136, '2015-02-01 00:39:56.000000', 'consum', 0.0260, 'lps'),
	(688004, 136, '2015-02-01 00:39:57.000000', 'consum', 0.0251, 'lps'),
	(688005, 136, '2015-02-01 00:39:58.000000', 'consum', 0.0263, 'lps'),
	(688006, 136, '2015-02-01 00:39:59.000000', 'consum', 0.0225, 'lps'),
	(688007, 136, '2015-02-01 00:40:00.000000', 'consum', 0.0257, 'lps'),
	(688008, 136, '2015-02-01 00:40:01.000000', 'consum', 0.0269, 'lps'),
	(688009, 136, '2015-02-01 00:40:02.000000', 'consum', 0.0234, 'lps'),
	(688010, 136, '2015-02-01 00:40:03.000000', 'consum', 0.0220, 'lps'),
	(688011, 136, '2015-02-01 00:40:04.000000', 'consum', 0.0252, 'lps'),
	(688012, 136, '2015-02-01 00:40:05.000000', 'consum', 0.0261, 'lps'),
	(688013, 136, '2015-02-01 00:40:06.000000', 'consum', 0.0274, 'lps'),
	(688014, 136, '2015-02-01 00:40:07.000000', 'consum', 0.0249, 'lps'),
	(688015, 136, '2015-02-01 00:40:08.000000', 'consum', 0.0211, 'lps'),
	(688016, 136, '2015-02-01 00:40:09.000000', 'consum', 0.0232, 'lps'),
	(688017, 136, '2015-02-01 00:40:10.000000', 'consum', 0.0250, 'lps'),
	(688018, 136, '2015-02-01 00:40:11.000000', 'consum', 0.0216, 'lps'),
	(688019, 136, '2015-02-01 00:40:12.000000', 'consum', 0.0248, 'lps'),
	(688020, 136, '2015-02-01 00:40:13.000000', 'consum', 0.0254, 'lps'),
	(688021, 136, '2015-02-01 00:40:14.000000', 'consum', 0.0250, 'lps'),
	(688022, 136, '2015-02-01 00:40:15.000000', 'consum', 0.0213, 'lps'),
	(688023, 136, '2015-02-01 00:40:16.000000', 'consum', 0.0236, 'lps'),
	(688024, 136, '2015-02-01 00:40:17.000000', 'consum', 0.0265, 'lps'),
	(688025, 136, '2015-02-01 00:40:18.000000', 'consum', 0.0214, 'lps'),
	(688026, 136, '2015-02-01 00:40:19.000000', 'consum', 0.0262, 'lps'),
	(688027, 136, '2015-02-01 00:40:20.000000', 'consum', 0.0264, 'lps'),
	(688028, 136, '2015-02-01 00:40:21.000000', 'consum', 0.0259, 'lps'),
	(688029, 136, '2015-02-01 00:40:22.000000', 'consum', 0.0227, 'lps'),
	(688030, 136, '2015-02-01 00:40:23.000000', 'consum', 0.0213, 'lps'),
	(688031, 136, '2015-02-01 00:40:24.000000', 'consum', 0.0241, 'lps'),
	(688032, 136, '2015-02-01 00:40:25.000000', 'consum', 0.0225, 'lps'),
	(688033, 136, '2015-02-01 00:40:26.000000', 'consum', 0.0259, 'lps'),
	(688034, 136, '2015-02-01 00:40:27.000000', 'consum', 0.0214, 'lps'),
	(688035, 136, '2015-02-01 00:40:28.000000', 'consum', 0.0215, 'lps'),
	(688036, 136, '2015-02-01 00:40:29.000000', 'consum', 0.0224, 'lps'),
	(688037, 136, '2015-02-01 00:40:30.000000', 'consum', 0.0264, 'lps'),
	(688038, 136, '2015-02-01 00:40:31.000000', 'consum', 0.0243, 'lps'),
	(688039, 136, '2015-02-01 00:40:32.000000', 'consum', 0.0216, 'lps'),
	(688040, 136, '2015-02-01 00:40:33.000000', 'consum', 0.0271, 'lps'),
	(688041, 136, '2015-02-01 00:40:34.000000', 'consum', 0.0237, 'lps'),
	(688042, 136, '2015-02-01 00:40:35.000000', 'consum', 0.0227, 'lps'),
	(688043, 136, '2015-02-01 00:40:36.000000', 'consum', 0.0216, 'lps'),
	(688044, 136, '2015-02-01 00:40:37.000000', 'consum', 0.0254, 'lps'),
	(688045, 136, '2015-02-01 00:40:38.000000', 'consum', 0.0219, 'lps'),
	(688046, 136, '2015-02-01 00:40:39.000000', 'consum', 0.0251, 'lps'),
	(688047, 136, '2015-02-01 00:40:40.000000', 'consum', 0.0260, 'lps'),
	(688048, 136, '2015-02-01 00:40:41.000000', 'consum', 0.0271, 'lps'),
	(688049, 136, '2015-02-01 00:40:42.000000', 'consum', 0.0236, 'lps'),
	(688050, 136, '2015-02-01 00:40:43.000000', 'consum', 0.0223, 'lps'),
	(688051, 136, '2015-02-01 00:40:44.000000', 'consum', 0.0262, 'lps'),
	(688052, 136, '2015-02-01 00:40:45.000000', 'consum', 0.0239, 'lps'),
	(688053, 136, '2015-02-01 00:40:46.000000', 'consum', 0.0262, 'lps'),
	(688054, 136, '2015-02-01 00:40:47.000000', 'consum', 0.0255, 'lps'),
	(688055, 136, '2015-02-01 00:40:48.000000', 'consum', 0.0214, 'lps'),
	(688056, 136, '2015-02-01 00:40:49.000000', 'consum', 0.0224, 'lps'),
	(688057, 136, '2015-02-01 00:40:50.000000', 'consum', 0.0270, 'lps'),
	(688058, 136, '2015-02-01 00:40:51.000000', 'consum', 0.0274, 'lps'),
	(688059, 136, '2015-02-01 00:40:52.000000', 'consum', 0.0218, 'lps'),
	(688060, 136, '2015-02-01 00:40:53.000000', 'consum', 0.0255, 'lps'),
	(688061, 136, '2015-02-01 00:40:54.000000', 'consum', 0.0216, 'lps'),
	(688062, 136, '2015-02-01 00:40:55.000000', 'consum', 0.0235, 'lps'),
	(688063, 136, '2015-02-01 00:40:56.000000', 'consum', 0.0253, 'lps'),
	(688064, 136, '2015-02-01 00:40:57.000000', 'consum', 0.0222, 'lps'),
	(688065, 136, '2015-02-01 00:40:58.000000', 'consum', 0.0269, 'lps'),
	(688066, 136, '2015-02-01 00:40:59.000000', 'consum', 0.0210, 'lps'),
	(688067, 136, '2015-02-01 00:41:00.000000', 'consum', 0.0229, 'lps'),
	(688068, 136, '2015-02-01 00:41:01.000000', 'consum', 0.0241, 'lps'),
	(688069, 136, '2015-02-01 00:41:02.000000', 'consum', 0.0245, 'lps'),
	(688070, 136, '2015-02-01 00:41:03.000000', 'consum', 0.0227, 'lps'),
	(688071, 136, '2015-02-01 00:41:04.000000', 'consum', 0.0254, 'lps'),
	(688072, 136, '2015-02-01 00:41:05.000000', 'consum', 0.0249, 'lps'),
	(688073, 136, '2015-02-01 00:41:06.000000', 'consum', 0.0274, 'lps'),
	(688074, 136, '2015-02-01 00:41:07.000000', 'consum', 0.0219, 'lps'),
	(688075, 136, '2015-02-01 00:41:08.000000', 'consum', 0.0260, 'lps'),
	(688076, 136, '2015-02-01 00:41:09.000000', 'consum', 0.0236, 'lps'),
	(688077, 136, '2015-02-01 00:41:10.000000', 'consum', 0.0257, 'lps'),
	(688078, 136, '2015-02-01 00:41:11.000000', 'consum', 0.0238, 'lps'),
	(688079, 136, '2015-02-01 00:41:12.000000', 'consum', 0.0272, 'lps'),
	(688080, 136, '2015-02-01 00:41:13.000000', 'consum', 0.0243, 'lps'),
	(688081, 136, '2015-02-01 00:41:14.000000', 'consum', 0.0256, 'lps'),
	(688082, 136, '2015-02-01 00:41:15.000000', 'consum', 0.0212, 'lps'),
	(688083, 136, '2015-02-01 00:41:16.000000', 'consum', 0.0211, 'lps'),
	(688084, 136, '2015-02-01 00:41:17.000000', 'consum', 0.0211, 'lps'),
	(688085, 136, '2015-02-01 00:41:18.000000', 'consum', 0.0212, 'lps'),
	(688086, 136, '2015-02-01 00:41:19.000000', 'consum', 0.0215, 'lps'),
	(688087, 136, '2015-02-01 00:41:20.000000', 'consum', 0.0231, 'lps'),
	(688088, 136, '2015-02-01 00:41:21.000000', 'consum', 0.0238, 'lps'),
	(688089, 136, '2015-02-01 00:41:22.000000', 'consum', 0.0219, 'lps'),
	(688090, 136, '2015-02-01 00:41:23.000000', 'consum', 0.0237, 'lps'),
	(688091, 136, '2015-02-01 00:41:24.000000', 'consum', 0.0256, 'lps'),
	(688092, 136, '2015-02-01 00:41:25.000000', 'consum', 0.0227, 'lps'),
	(688093, 136, '2015-02-01 00:41:26.000000', 'consum', 0.0221, 'lps'),
	(688094, 136, '2015-02-01 00:41:27.000000', 'consum', 0.0217, 'lps'),
	(688095, 136, '2015-02-01 00:41:28.000000', 'consum', 0.0212, 'lps'),
	(688096, 136, '2015-02-01 00:41:29.000000', 'consum', 0.0265, 'lps'),
	(688097, 136, '2015-02-01 00:41:30.000000', 'consum', 0.0221, 'lps'),
	(688098, 136, '2015-02-01 00:41:31.000000', 'consum', 0.0230, 'lps'),
	(688099, 136, '2015-02-01 00:41:32.000000', 'consum', 0.0212, 'lps'),
	(688100, 136, '2015-02-01 00:41:33.000000', 'consum', 0.0226, 'lps'),
	(688101, 136, '2015-02-01 00:41:34.000000', 'consum', 0.0220, 'lps'),
	(688102, 136, '2015-02-01 00:41:35.000000', 'consum', 0.0212, 'lps'),
	(688103, 136, '2015-02-01 00:41:36.000000', 'consum', 0.0254, 'lps'),
	(688104, 136, '2015-02-01 00:41:37.000000', 'consum', 0.0230, 'lps'),
	(688105, 136, '2015-02-01 00:41:38.000000', 'consum', 0.0243, 'lps'),
	(688106, 136, '2015-02-01 00:41:39.000000', 'consum', 0.0250, 'lps'),
	(688107, 136, '2015-02-01 00:41:40.000000', 'consum', 0.0245, 'lps'),
	(688108, 136, '2015-02-01 00:41:41.000000', 'consum', 0.0269, 'lps'),
	(688109, 136, '2015-02-01 00:41:42.000000', 'consum', 0.0269, 'lps'),
	(688110, 136, '2015-02-01 00:41:43.000000', 'consum', 0.0263, 'lps'),
	(688111, 136, '2015-02-01 00:41:44.000000', 'consum', 0.0235, 'lps'),
	(688112, 136, '2015-02-01 00:41:45.000000', 'consum', 0.0241, 'lps'),
	(688113, 136, '2015-02-01 00:41:46.000000', 'consum', 0.0224, 'lps'),
	(688114, 136, '2015-02-01 00:41:47.000000', 'consum', 0.0252, 'lps'),
	(688115, 136, '2015-02-01 00:41:48.000000', 'consum', 0.0252, 'lps'),
	(688116, 136, '2015-02-01 00:41:49.000000', 'consum', 0.0226, 'lps'),
	(688117, 136, '2015-02-01 00:41:50.000000', 'consum', 0.0229, 'lps'),
	(688118, 136, '2015-02-01 00:41:51.000000', 'consum', 0.0260, 'lps'),
	(688119, 136, '2015-02-01 00:41:52.000000', 'consum', 0.0271, 'lps'),
	(688120, 136, '2015-02-01 00:41:53.000000', 'consum', 0.0238, 'lps'),
	(688121, 136, '2015-02-01 00:41:54.000000', 'consum', 0.0231, 'lps'),
	(688122, 136, '2015-02-01 00:41:55.000000', 'consum', 0.0232, 'lps'),
	(688123, 136, '2015-02-01 00:41:56.000000', 'consum', 0.0256, 'lps'),
	(688124, 136, '2015-02-01 00:41:57.000000', 'consum', 0.0244, 'lps'),
	(688125, 136, '2015-02-01 00:41:58.000000', 'consum', 0.0244, 'lps'),
	(688126, 136, '2015-02-01 00:41:59.000000', 'consum', 0.0214, 'lps'),
	(688127, 136, '2015-02-01 00:42:00.000000', 'consum', 0.0259, 'lps'),
	(688128, 136, '2015-02-01 00:42:01.000000', 'consum', 0.0248, 'lps'),
	(688129, 136, '2015-02-01 00:42:02.000000', 'consum', 0.0254, 'lps'),
	(688130, 136, '2015-02-01 00:42:03.000000', 'consum', 0.0250, 'lps'),
	(688131, 136, '2015-02-01 00:42:04.000000', 'consum', 0.0214, 'lps'),
	(688132, 136, '2015-02-01 00:42:05.000000', 'consum', 0.0239, 'lps'),
	(688133, 136, '2015-02-01 00:42:06.000000', 'consum', 0.0214, 'lps'),
	(688134, 136, '2015-02-01 00:42:07.000000', 'consum', 0.0274, 'lps'),
	(688135, 136, '2015-02-01 00:42:08.000000', 'consum', 0.0258, 'lps'),
	(688136, 136, '2015-02-01 00:42:09.000000', 'consum', 0.0258, 'lps'),
	(688137, 136, '2015-02-01 00:42:10.000000', 'consum', 0.0242, 'lps'),
	(688138, 136, '2015-02-01 00:42:11.000000', 'consum', 0.0227, 'lps'),
	(688139, 136, '2015-02-01 00:42:12.000000', 'consum', 0.0265, 'lps'),
	(688140, 136, '2015-02-01 00:42:13.000000', 'consum', 0.0238, 'lps'),
	(688141, 136, '2015-02-01 00:42:14.000000', 'consum', 0.0253, 'lps'),
	(688142, 136, '2015-02-01 00:42:15.000000', 'consum', 0.0274, 'lps'),
	(688143, 136, '2015-02-01 00:42:16.000000', 'consum', 0.0274, 'lps'),
	(688144, 136, '2015-02-01 00:42:17.000000', 'consum', 0.0273, 'lps'),
	(688145, 136, '2015-02-01 00:42:18.000000', 'consum', 0.0268, 'lps'),
	(688146, 136, '2015-02-01 00:42:19.000000', 'consum', 0.0247, 'lps'),
	(688147, 136, '2015-02-01 00:42:20.000000', 'consum', 0.0220, 'lps'),
	(688148, 136, '2015-02-01 00:42:21.000000', 'consum', 0.0214, 'lps'),
	(688149, 136, '2015-02-01 00:42:22.000000', 'consum', 0.0268, 'lps'),
	(688150, 136, '2015-02-01 00:42:23.000000', 'consum', 0.0225, 'lps'),
	(688151, 136, '2015-02-01 00:42:24.000000', 'consum', 0.0245, 'lps'),
	(688152, 136, '2015-02-01 00:42:25.000000', 'consum', 0.0272, 'lps'),
	(688153, 136, '2015-02-01 00:42:26.000000', 'consum', 0.0223, 'lps'),
	(688154, 136, '2015-02-01 00:42:27.000000', 'consum', 0.0221, 'lps'),
	(688155, 136, '2015-02-01 00:42:28.000000', 'consum', 0.0223, 'lps'),
	(688156, 136, '2015-02-01 00:42:29.000000', 'consum', 0.0243, 'lps'),
	(688157, 136, '2015-02-01 00:42:30.000000', 'consum', 0.0274, 'lps'),
	(688158, 136, '2015-02-01 00:42:31.000000', 'consum', 0.0236, 'lps'),
	(688159, 136, '2015-02-01 00:42:32.000000', 'consum', 0.0214, 'lps'),
	(688160, 136, '2015-02-01 00:42:33.000000', 'consum', 0.0217, 'lps'),
	(688161, 136, '2015-02-01 00:42:34.000000', 'consum', 0.0235, 'lps'),
	(688162, 136, '2015-02-01 00:42:35.000000', 'consum', 0.0249, 'lps'),
	(688163, 136, '2015-02-01 00:42:36.000000', 'consum', 0.0263, 'lps'),
	(688164, 136, '2015-02-01 00:42:37.000000', 'consum', 0.0230, 'lps'),
	(688165, 136, '2015-02-01 00:42:38.000000', 'consum', 0.0214, 'lps'),
	(688166, 136, '2015-02-01 00:42:39.000000', 'consum', 0.0239, 'lps'),
	(688167, 136, '2015-02-01 00:42:40.000000', 'consum', 0.0212, 'lps'),
	(688168, 136, '2015-02-01 00:42:41.000000', 'consum', 0.0262, 'lps'),
	(688169, 136, '2015-02-01 00:42:42.000000', 'consum', 0.0273, 'lps'),
	(688170, 136, '2015-02-01 00:42:43.000000', 'consum', 0.0236, 'lps'),
	(688171, 136, '2015-02-01 00:42:44.000000', 'consum', 0.0219, 'lps'),
	(688172, 136, '2015-02-01 00:42:45.000000', 'consum', 0.0240, 'lps'),
	(688173, 136, '2015-02-01 00:42:46.000000', 'consum', 0.0270, 'lps'),
	(688174, 136, '2015-02-01 00:42:47.000000', 'consum', 0.0226, 'lps'),
	(688175, 136, '2015-02-01 00:42:48.000000', 'consum', 0.0241, 'lps'),
	(688176, 136, '2015-02-01 00:42:49.000000', 'consum', 0.0250, 'lps'),
	(688177, 136, '2015-02-01 00:42:50.000000', 'consum', 0.0255, 'lps'),
	(688178, 136, '2015-02-01 00:42:51.000000', 'consum', 0.0252, 'lps'),
	(688179, 136, '2015-02-01 00:42:52.000000', 'consum', 0.0217, 'lps'),
	(688180, 136, '2015-02-01 00:42:53.000000', 'consum', 0.0252, 'lps'),
	(688181, 136, '2015-02-01 00:42:54.000000', 'consum', 0.0268, 'lps'),
	(688182, 136, '2015-02-01 00:42:55.000000', 'consum', 0.0244, 'lps'),
	(688183, 136, '2015-02-01 00:42:56.000000', 'consum', 0.0274, 'lps'),
	(688184, 136, '2015-02-01 00:42:57.000000', 'consum', 0.0232, 'lps'),
	(688185, 136, '2015-02-01 00:42:58.000000', 'consum', 0.0259, 'lps'),
	(688186, 136, '2015-02-01 00:42:59.000000', 'consum', 0.0259, 'lps'),
	(688187, 136, '2015-02-01 00:43:00.000000', 'consum', 0.0246, 'lps'),
	(688188, 136, '2015-02-01 00:43:01.000000', 'consum', 0.0240, 'lps'),
	(688189, 136, '2015-02-01 00:43:02.000000', 'consum', 0.0255, 'lps'),
	(688190, 136, '2015-02-01 00:43:03.000000', 'consum', 0.0213, 'lps'),
	(688191, 136, '2015-02-01 00:43:04.000000', 'consum', 0.0220, 'lps'),
	(688192, 136, '2015-02-01 00:43:05.000000', 'consum', 0.0255, 'lps'),
	(688193, 136, '2015-02-01 00:43:06.000000', 'consum', 0.0272, 'lps'),
	(688194, 136, '2015-02-01 00:43:07.000000', 'consum', 0.0257, 'lps'),
	(688195, 136, '2015-02-01 00:43:08.000000', 'consum', 0.0260, 'lps'),
	(688196, 136, '2015-02-01 00:43:09.000000', 'consum', 0.0254, 'lps'),
	(688197, 136, '2015-02-01 00:43:10.000000', 'consum', 0.0214, 'lps'),
	(688198, 136, '2015-02-01 00:43:11.000000', 'consum', 0.0231, 'lps'),
	(688199, 136, '2015-02-01 00:43:12.000000', 'consum', 0.0239, 'lps'),
	(688200, 136, '2015-02-01 00:43:13.000000', 'consum', 0.0227, 'lps'),
	(688201, 136, '2015-02-01 00:43:14.000000', 'consum', 0.0210, 'lps'),
	(688202, 136, '2015-02-01 00:43:15.000000', 'consum', 0.0223, 'lps'),
	(688203, 136, '2015-02-01 00:43:16.000000', 'consum', 0.0210, 'lps'),
	(688204, 136, '2015-02-01 00:43:17.000000', 'consum', 0.0235, 'lps'),
	(688205, 136, '2015-02-01 00:43:18.000000', 'consum', 0.0274, 'lps'),
	(688206, 136, '2015-02-01 00:43:19.000000', 'consum', 0.0258, 'lps'),
	(688207, 136, '2015-02-01 00:43:20.000000', 'consum', 0.0260, 'lps'),
	(688208, 136, '2015-02-01 00:43:21.000000', 'consum', 0.0252, 'lps'),
	(688209, 136, '2015-02-01 00:43:22.000000', 'consum', 0.0272, 'lps'),
	(688210, 136, '2015-02-01 00:43:23.000000', 'consum', 0.0262, 'lps'),
	(688211, 136, '2015-02-01 00:43:24.000000', 'consum', 0.0218, 'lps'),
	(688212, 136, '2015-02-01 00:43:25.000000', 'consum', 0.0228, 'lps'),
	(688213, 136, '2015-02-01 00:43:26.000000', 'consum', 0.0210, 'lps'),
	(688214, 136, '2015-02-01 00:43:27.000000', 'consum', 0.0221, 'lps'),
	(688215, 136, '2015-02-01 00:43:28.000000', 'consum', 0.0267, 'lps'),
	(688216, 136, '2015-02-01 00:43:29.000000', 'consum', 0.0267, 'lps'),
	(688217, 136, '2015-02-01 00:43:30.000000', 'consum', 0.0257, 'lps'),
	(688218, 136, '2015-02-01 00:43:31.000000', 'consum', 0.0213, 'lps'),
	(688219, 136, '2015-02-01 00:43:32.000000', 'consum', 0.0211, 'lps'),
	(688220, 136, '2015-02-01 00:43:33.000000', 'consum', 0.0273, 'lps'),
	(688221, 136, '2015-02-01 00:43:34.000000', 'consum', 0.0264, 'lps'),
	(688222, 136, '2015-02-01 00:43:35.000000', 'consum', 0.0226, 'lps'),
	(688223, 136, '2015-02-01 00:43:36.000000', 'consum', 0.0260, 'lps'),
	(688224, 136, '2015-02-01 00:43:37.000000', 'consum', 0.0216, 'lps'),
	(688225, 136, '2015-02-01 00:43:38.000000', 'consum', 0.0221, 'lps'),
	(688226, 136, '2015-02-01 00:43:39.000000', 'consum', 0.0247, 'lps'),
	(688227, 136, '2015-02-01 00:43:40.000000', 'consum', 0.0234, 'lps'),
	(688228, 136, '2015-02-01 00:43:41.000000', 'consum', 0.0217, 'lps'),
	(688229, 136, '2015-02-01 00:43:42.000000', 'consum', 0.0240, 'lps'),
	(688230, 136, '2015-02-01 00:43:43.000000', 'consum', 0.0210, 'lps'),
	(688231, 136, '2015-02-01 00:43:44.000000', 'consum', 0.0251, 'lps'),
	(688232, 136, '2015-02-01 00:43:45.000000', 'consum', 0.0218, 'lps'),
	(688233, 136, '2015-02-01 00:43:46.000000', 'consum', 0.0258, 'lps'),
	(688234, 136, '2015-02-01 00:43:47.000000', 'consum', 0.0233, 'lps'),
	(688235, 136, '2015-02-01 00:43:48.000000', 'consum', 0.0246, 'lps'),
	(688236, 136, '2015-02-01 00:43:49.000000', 'consum', 0.0258, 'lps'),
	(688237, 136, '2015-02-01 00:43:50.000000', 'consum', 0.0213, 'lps'),
	(688238, 136, '2015-02-01 00:43:51.000000', 'consum', 0.0274, 'lps'),
	(688239, 136, '2015-02-01 00:43:52.000000', 'consum', 0.0262, 'lps'),
	(688240, 136, '2015-02-01 00:43:53.000000', 'consum', 0.0215, 'lps'),
	(688241, 136, '2015-02-01 00:43:54.000000', 'consum', 0.0273, 'lps'),
	(688242, 136, '2015-02-01 00:43:55.000000', 'consum', 0.0252, 'lps'),
	(688243, 136, '2015-02-01 00:43:56.000000', 'consum', 0.0230, 'lps'),
	(688244, 136, '2015-02-01 00:43:57.000000', 'consum', 0.0251, 'lps'),
	(688245, 136, '2015-02-01 00:43:58.000000', 'consum', 0.0227, 'lps'),
	(688246, 136, '2015-02-01 00:43:59.000000', 'consum', 0.0235, 'lps'),
	(688247, 136, '2015-02-01 00:44:00.000000', 'consum', 0.0219, 'lps'),
	(688248, 136, '2015-02-01 00:44:01.000000', 'consum', 0.0245, 'lps'),
	(688249, 136, '2015-02-01 00:44:02.000000', 'consum', 0.0228, 'lps'),
	(688250, 136, '2015-02-01 00:44:03.000000', 'consum', 0.0262, 'lps'),
	(688251, 136, '2015-02-01 00:44:04.000000', 'consum', 0.0220, 'lps'),
	(688252, 136, '2015-02-01 00:44:05.000000', 'consum', 0.0234, 'lps'),
	(688253, 136, '2015-02-01 00:44:06.000000', 'consum', 0.0237, 'lps'),
	(688254, 136, '2015-02-01 00:44:07.000000', 'consum', 0.0271, 'lps'),
	(688255, 136, '2015-02-01 00:44:08.000000', 'consum', 0.0241, 'lps'),
	(688256, 136, '2015-02-01 00:44:09.000000', 'consum', 0.0247, 'lps'),
	(688257, 136, '2015-02-01 00:44:10.000000', 'consum', 0.0237, 'lps'),
	(688258, 136, '2015-02-01 00:44:11.000000', 'consum', 0.0235, 'lps'),
	(688259, 136, '2015-02-01 00:44:12.000000', 'consum', 0.0256, 'lps'),
	(688260, 136, '2015-02-01 00:44:13.000000', 'consum', 0.0234, 'lps'),
	(688261, 136, '2015-02-01 00:44:14.000000', 'consum', 0.0257, 'lps'),
	(688262, 136, '2015-02-01 00:44:15.000000', 'consum', 0.0244, 'lps'),
	(688263, 136, '2015-02-01 00:44:16.000000', 'consum', 0.0240, 'lps'),
	(688264, 136, '2015-02-01 00:44:17.000000', 'consum', 0.0257, 'lps'),
	(688265, 136, '2015-02-01 00:44:18.000000', 'consum', 0.0225, 'lps'),
	(688266, 136, '2015-02-01 00:44:19.000000', 'consum', 0.0274, 'lps'),
	(688267, 136, '2015-02-01 00:44:20.000000', 'consum', 0.0226, 'lps'),
	(688268, 136, '2015-02-01 00:44:21.000000', 'consum', 0.0229, 'lps'),
	(688269, 136, '2015-02-01 00:44:22.000000', 'consum', 0.0258, 'lps'),
	(688270, 136, '2015-02-01 00:44:23.000000', 'consum', 0.0263, 'lps'),
	(688271, 136, '2015-02-01 00:44:24.000000', 'consum', 0.0267, 'lps'),
	(688272, 136, '2015-02-01 00:44:25.000000', 'consum', 0.0270, 'lps'),
	(688273, 136, '2015-02-01 00:44:26.000000', 'consum', 0.0211, 'lps'),
	(688274, 136, '2015-02-01 00:44:27.000000', 'consum', 0.0232, 'lps'),
	(688275, 136, '2015-02-01 00:44:28.000000', 'consum', 0.0251, 'lps'),
	(688276, 136, '2015-02-01 00:44:29.000000', 'consum', 0.0221, 'lps'),
	(688277, 136, '2015-02-01 00:44:30.000000', 'consum', 0.0271, 'lps'),
	(688278, 136, '2015-02-01 00:44:31.000000', 'consum', 0.0222, 'lps'),
	(688279, 136, '2015-02-01 00:44:32.000000', 'consum', 0.0217, 'lps'),
	(688280, 136, '2015-02-01 00:44:33.000000', 'consum', 0.0211, 'lps'),
	(688281, 136, '2015-02-01 00:44:34.000000', 'consum', 0.0258, 'lps'),
	(688282, 136, '2015-02-01 00:44:35.000000', 'consum', 0.0253, 'lps'),
	(688283, 136, '2015-02-01 00:44:36.000000', 'consum', 0.0215, 'lps'),
	(688284, 136, '2015-02-01 00:44:37.000000', 'consum', 0.0236, 'lps'),
	(688285, 136, '2015-02-01 00:44:38.000000', 'consum', 0.0263, 'lps'),
	(688286, 136, '2015-02-01 00:44:39.000000', 'consum', 0.0269, 'lps'),
	(688287, 136, '2015-02-01 00:44:40.000000', 'consum', 0.0213, 'lps'),
	(688288, 136, '2015-02-01 00:44:41.000000', 'consum', 0.0245, 'lps'),
	(688289, 136, '2015-02-01 00:44:42.000000', 'consum', 0.0245, 'lps'),
	(688290, 136, '2015-02-01 00:44:43.000000', 'consum', 0.0215, 'lps'),
	(688291, 136, '2015-02-01 00:44:44.000000', 'consum', 0.0262, 'lps'),
	(688292, 136, '2015-02-01 00:44:45.000000', 'consum', 0.0262, 'lps'),
	(688293, 136, '2015-02-01 00:44:46.000000', 'consum', 0.0247, 'lps'),
	(688294, 136, '2015-02-01 00:44:47.000000', 'consum', 0.0241, 'lps'),
	(688295, 136, '2015-02-01 00:44:48.000000', 'consum', 0.0253, 'lps'),
	(688296, 136, '2015-02-01 00:44:49.000000', 'consum', 0.0270, 'lps'),
	(688297, 136, '2015-02-01 00:44:50.000000', 'consum', 0.0252, 'lps'),
	(688298, 136, '2015-02-01 00:44:51.000000', 'consum', 0.0237, 'lps'),
	(688299, 136, '2015-02-01 00:44:52.000000', 'consum', 0.0222, 'lps'),
	(688300, 136, '2015-02-01 00:44:53.000000', 'consum', 0.0255, 'lps'),
	(688301, 136, '2015-02-01 00:44:54.000000', 'consum', 0.0269, 'lps'),
	(688302, 136, '2015-02-01 00:44:55.000000', 'consum', 0.0240, 'lps'),
	(688303, 136, '2015-02-01 00:44:56.000000', 'consum', 0.0249, 'lps'),
	(688304, 136, '2015-02-01 00:44:57.000000', 'consum', 0.0249, 'lps'),
	(688305, 136, '2015-02-01 00:44:58.000000', 'consum', 0.0223, 'lps'),
	(688306, 136, '2015-02-01 00:44:59.000000', 'consum', 0.0226, 'lps'),
	(688307, 136, '2015-02-01 00:45:00.000000', 'consum', 0.0252, 'lps'),
	(688308, 136, '2015-02-01 00:45:01.000000', 'consum', 0.0240, 'lps'),
	(688309, 136, '2015-02-01 00:45:02.000000', 'consum', 0.0234, 'lps'),
	(688310, 136, '2015-02-01 00:45:03.000000', 'consum', 0.0239, 'lps'),
	(688311, 136, '2015-02-01 00:45:04.000000', 'consum', 0.0222, 'lps'),
	(688312, 136, '2015-02-01 00:45:05.000000', 'consum', 0.0248, 'lps'),
	(688313, 136, '2015-02-01 00:45:06.000000', 'consum', 0.0236, 'lps'),
	(688314, 136, '2015-02-01 00:45:07.000000', 'consum', 0.0223, 'lps'),
	(688315, 136, '2015-02-01 00:45:08.000000', 'consum', 0.0265, 'lps'),
	(688316, 136, '2015-02-01 00:45:09.000000', 'consum', 0.0253, 'lps'),
	(688317, 136, '2015-02-01 00:45:10.000000', 'consum', 0.0258, 'lps'),
	(688318, 136, '2015-02-01 00:45:11.000000', 'consum', 0.0258, 'lps'),
	(688319, 136, '2015-02-01 00:45:12.000000', 'consum', 0.0241, 'lps'),
	(688320, 136, '2015-02-01 00:45:13.000000', 'consum', 0.0223, 'lps'),
	(688321, 136, '2015-02-01 00:45:14.000000', 'consum', 0.0248, 'lps'),
	(688322, 136, '2015-02-01 00:45:15.000000', 'consum', 0.0232, 'lps'),
	(688323, 136, '2015-02-01 00:45:16.000000', 'consum', 0.0269, 'lps'),
	(688324, 136, '2015-02-01 00:45:17.000000', 'consum', 0.0244, 'lps'),
	(688325, 136, '2015-02-01 00:45:18.000000', 'consum', 0.0269, 'lps'),
	(688326, 136, '2015-02-01 00:45:19.000000', 'consum', 0.0273, 'lps'),
	(688327, 136, '2015-02-01 00:45:20.000000', 'consum', 0.0221, 'lps'),
	(688328, 136, '2015-02-01 00:45:21.000000', 'consum', 0.0270, 'lps'),
	(688329, 136, '2015-02-01 00:45:22.000000', 'consum', 0.0216, 'lps'),
	(688330, 136, '2015-02-01 00:45:23.000000', 'consum', 0.0258, 'lps'),
	(688331, 136, '2015-02-01 00:45:24.000000', 'consum', 0.0236, 'lps'),
	(688332, 136, '2015-02-01 00:45:25.000000', 'consum', 0.0260, 'lps'),
	(688333, 136, '2015-02-01 00:45:26.000000', 'consum', 0.0256, 'lps'),
	(688334, 136, '2015-02-01 00:45:27.000000', 'consum', 0.0223, 'lps'),
	(688335, 136, '2015-02-01 00:45:28.000000', 'consum', 0.0267, 'lps'),
	(688336, 136, '2015-02-01 00:45:29.000000', 'consum', 0.0261, 'lps'),
	(688337, 136, '2015-02-01 00:45:30.000000', 'consum', 0.0231, 'lps'),
	(688338, 136, '2015-02-01 00:45:31.000000', 'consum', 0.0228, 'lps'),
	(688339, 136, '2015-02-01 00:45:32.000000', 'consum', 0.0235, 'lps'),
	(688340, 136, '2015-02-01 00:45:33.000000', 'consum', 0.0217, 'lps'),
	(688341, 136, '2015-02-01 00:45:34.000000', 'consum', 0.0236, 'lps'),
	(688342, 136, '2015-02-01 00:45:35.000000', 'consum', 0.0254, 'lps'),
	(688343, 136, '2015-02-01 00:45:36.000000', 'consum', 0.0223, 'lps'),
	(688344, 136, '2015-02-01 00:45:37.000000', 'consum', 0.0273, 'lps'),
	(688345, 136, '2015-02-01 00:45:38.000000', 'consum', 0.0225, 'lps'),
	(688346, 136, '2015-02-01 00:45:39.000000', 'consum', 0.0230, 'lps'),
	(688347, 136, '2015-02-01 00:45:40.000000', 'consum', 0.0263, 'lps'),
	(688348, 136, '2015-02-01 00:45:41.000000', 'consum', 0.0223, 'lps'),
	(688349, 136, '2015-02-01 00:45:42.000000', 'consum', 0.0246, 'lps'),
	(688350, 136, '2015-02-01 00:45:43.000000', 'consum', 0.0221, 'lps'),
	(688351, 136, '2015-02-01 00:45:44.000000', 'consum', 0.0221, 'lps'),
	(688352, 136, '2015-02-01 00:45:45.000000', 'consum', 0.0234, 'lps'),
	(688353, 136, '2015-02-01 00:45:46.000000', 'consum', 0.0232, 'lps'),
	(688354, 136, '2015-02-01 00:45:47.000000', 'consum', 0.0249, 'lps'),
	(688355, 136, '2015-02-01 00:45:48.000000', 'consum', 0.0273, 'lps'),
	(688356, 136, '2015-02-01 00:45:49.000000', 'consum', 0.0214, 'lps'),
	(688357, 136, '2015-02-01 00:45:50.000000', 'consum', 0.0238, 'lps'),
	(688358, 136, '2015-02-01 00:45:51.000000', 'consum', 0.0271, 'lps'),
	(688359, 136, '2015-02-01 00:45:52.000000', 'consum', 0.0236, 'lps'),
	(688360, 136, '2015-02-01 00:45:53.000000', 'consum', 0.0223, 'lps'),
	(688361, 136, '2015-02-01 00:45:54.000000', 'consum', 0.0261, 'lps'),
	(688362, 136, '2015-02-01 00:45:55.000000', 'consum', 0.0234, 'lps'),
	(688363, 136, '2015-02-01 00:45:56.000000', 'consum', 0.0242, 'lps'),
	(688364, 136, '2015-02-01 00:45:57.000000', 'consum', 0.0233, 'lps'),
	(688365, 136, '2015-02-01 00:45:58.000000', 'consum', 0.0230, 'lps'),
	(688366, 136, '2015-02-01 00:45:59.000000', 'consum', 0.0243, 'lps'),
	(688367, 136, '2015-02-01 00:46:00.000000', 'consum', 0.0251, 'lps'),
	(688368, 136, '2015-02-01 00:46:01.000000', 'consum', 0.0251, 'lps'),
	(688369, 136, '2015-02-01 00:46:02.000000', 'consum', 0.0228, 'lps'),
	(688370, 136, '2015-02-01 00:46:03.000000', 'consum', 0.0243, 'lps'),
	(688371, 136, '2015-02-01 00:46:04.000000', 'consum', 0.0254, 'lps'),
	(688372, 136, '2015-02-01 00:46:05.000000', 'consum', 0.0268, 'lps'),
	(688373, 136, '2015-02-01 00:46:06.000000', 'consum', 0.0239, 'lps'),
	(688374, 136, '2015-02-01 00:46:07.000000', 'consum', 0.0245, 'lps'),
	(688375, 136, '2015-02-01 00:46:08.000000', 'consum', 0.0235, 'lps'),
	(688376, 136, '2015-02-01 00:46:09.000000', 'consum', 0.0231, 'lps'),
	(688377, 136, '2015-02-01 00:46:10.000000', 'consum', 0.0241, 'lps'),
	(688378, 136, '2015-02-01 00:46:11.000000', 'consum', 0.0237, 'lps'),
	(688379, 136, '2015-02-01 00:46:12.000000', 'consum', 0.0253, 'lps'),
	(688380, 136, '2015-02-01 00:46:13.000000', 'consum', 0.0216, 'lps'),
	(688381, 136, '2015-02-01 00:46:14.000000', 'consum', 0.0239, 'lps'),
	(688382, 136, '2015-02-01 00:46:15.000000', 'consum', 0.0273, 'lps'),
	(688383, 136, '2015-02-01 00:46:16.000000', 'consum', 0.0246, 'lps'),
	(688384, 136, '2015-02-01 00:46:17.000000', 'consum', 0.0264, 'lps'),
	(688385, 136, '2015-02-01 00:46:18.000000', 'consum', 0.0243, 'lps'),
	(688386, 136, '2015-02-01 00:46:19.000000', 'consum', 0.0215, 'lps'),
	(688387, 136, '2015-02-01 00:46:20.000000', 'consum', 0.0265, 'lps'),
	(688388, 136, '2015-02-01 00:46:21.000000', 'consum', 0.0274, 'lps'),
	(688389, 136, '2015-02-01 00:46:22.000000', 'consum', 0.0238, 'lps'),
	(688390, 136, '2015-02-01 00:46:23.000000', 'consum', 0.0221, 'lps'),
	(688391, 136, '2015-02-01 00:46:24.000000', 'consum', 0.0247, 'lps'),
	(688392, 136, '2015-02-01 00:46:25.000000', 'consum', 0.0234, 'lps'),
	(688393, 136, '2015-02-01 00:46:26.000000', 'consum', 0.0219, 'lps'),
	(688394, 136, '2015-02-01 00:46:27.000000', 'consum', 0.0250, 'lps'),
	(688395, 136, '2015-02-01 00:46:28.000000', 'consum', 0.0250, 'lps'),
	(688396, 136, '2015-02-01 00:46:29.000000', 'consum', 0.0229, 'lps'),
	(688397, 136, '2015-02-01 00:46:30.000000', 'consum', 0.0247, 'lps'),
	(688398, 136, '2015-02-01 00:46:31.000000', 'consum', 0.0212, 'lps'),
	(688399, 136, '2015-02-01 00:46:32.000000', 'consum', 0.0237, 'lps'),
	(688400, 136, '2015-02-01 00:46:33.000000', 'consum', 0.0212, 'lps'),
	(688401, 136, '2015-02-01 00:46:34.000000', 'consum', 0.0267, 'lps'),
	(688402, 136, '2015-02-01 00:46:35.000000', 'consum', 0.0230, 'lps'),
	(688403, 136, '2015-02-01 00:46:36.000000', 'consum', 0.0268, 'lps'),
	(688404, 136, '2015-02-01 00:46:37.000000', 'consum', 0.0246, 'lps'),
	(688405, 136, '2015-02-01 00:46:38.000000', 'consum', 0.0219, 'lps'),
	(688406, 136, '2015-02-01 00:46:39.000000', 'consum', 0.0211, 'lps'),
	(688407, 136, '2015-02-01 00:46:40.000000', 'consum', 0.0253, 'lps'),
	(688408, 136, '2015-02-01 00:46:41.000000', 'consum', 0.0228, 'lps'),
	(688409, 136, '2015-02-01 00:46:42.000000', 'consum', 0.0235, 'lps'),
	(688410, 136, '2015-02-01 00:46:43.000000', 'consum', 0.0216, 'lps'),
	(688411, 136, '2015-02-01 00:46:44.000000', 'consum', 0.0233, 'lps'),
	(688412, 136, '2015-02-01 00:46:45.000000', 'consum', 0.0242, 'lps'),
	(688413, 136, '2015-02-01 00:46:46.000000', 'consum', 0.0237, 'lps'),
	(688414, 136, '2015-02-01 00:46:47.000000', 'consum', 0.0249, 'lps'),
	(688415, 136, '2015-02-01 00:46:48.000000', 'consum', 0.0258, 'lps'),
	(688416, 136, '2015-02-01 00:46:49.000000', 'consum', 0.0269, 'lps'),
	(688417, 136, '2015-02-01 00:46:50.000000', 'consum', 0.0232, 'lps'),
	(688418, 136, '2015-02-01 00:46:51.000000', 'consum', 0.0274, 'lps'),
	(688419, 136, '2015-02-01 00:46:52.000000', 'consum', 0.0269, 'lps'),
	(688420, 136, '2015-02-01 00:46:53.000000', 'consum', 0.0251, 'lps'),
	(688421, 136, '2015-02-01 00:46:54.000000', 'consum', 0.0235, 'lps'),
	(688422, 136, '2015-02-01 00:46:55.000000', 'consum', 0.0213, 'lps'),
	(688423, 136, '2015-02-01 00:46:56.000000', 'consum', 0.0217, 'lps'),
	(688424, 136, '2015-02-01 00:46:57.000000', 'consum', 0.0237, 'lps'),
	(688425, 136, '2015-02-01 00:46:58.000000', 'consum', 0.0260, 'lps'),
	(688426, 136, '2015-02-01 00:46:59.000000', 'consum', 0.0250, 'lps'),
	(688427, 136, '2015-02-01 00:47:00.000000', 'consum', 0.0262, 'lps'),
	(688428, 136, '2015-02-01 00:47:01.000000', 'consum', 0.0217, 'lps'),
	(688429, 136, '2015-02-01 00:47:02.000000', 'consum', 0.0220, 'lps'),
	(688430, 136, '2015-02-01 00:47:03.000000', 'consum', 0.0240, 'lps'),
	(688431, 136, '2015-02-01 00:47:04.000000', 'consum', 0.0266, 'lps'),
	(688432, 136, '2015-02-01 00:47:05.000000', 'consum', 0.0268, 'lps'),
	(688433, 136, '2015-02-01 00:47:06.000000', 'consum', 0.0270, 'lps'),
	(688434, 136, '2015-02-01 00:47:07.000000', 'consum', 0.0269, 'lps'),
	(688435, 136, '2015-02-01 00:47:08.000000', 'consum', 0.0263, 'lps'),
	(688436, 136, '2015-02-01 00:47:09.000000', 'consum', 0.0234, 'lps'),
	(688437, 136, '2015-02-01 00:47:10.000000', 'consum', 0.0236, 'lps'),
	(688438, 136, '2015-02-01 00:47:11.000000', 'consum', 0.0267, 'lps'),
	(688439, 136, '2015-02-01 00:47:12.000000', 'consum', 0.0224, 'lps'),
	(688440, 136, '2015-02-01 00:47:13.000000', 'consum', 0.0241, 'lps'),
	(688441, 136, '2015-02-01 00:47:14.000000', 'consum', 0.0256, 'lps'),
	(688442, 136, '2015-02-01 00:47:15.000000', 'consum', 0.0217, 'lps'),
	(688443, 136, '2015-02-01 00:47:16.000000', 'consum', 0.0238, 'lps'),
	(688444, 136, '2015-02-01 00:47:17.000000', 'consum', 0.0265, 'lps'),
	(688445, 136, '2015-02-01 00:47:18.000000', 'consum', 0.0270, 'lps'),
	(688446, 136, '2015-02-01 00:47:19.000000', 'consum', 0.0215, 'lps'),
	(688447, 136, '2015-02-01 00:47:20.000000', 'consum', 0.0251, 'lps'),
	(688448, 136, '2015-02-01 00:47:21.000000', 'consum', 0.0271, 'lps'),
	(688449, 136, '2015-02-01 00:47:22.000000', 'consum', 0.0261, 'lps'),
	(688450, 136, '2015-02-01 00:47:23.000000', 'consum', 0.0220, 'lps'),
	(688451, 136, '2015-02-01 00:47:24.000000', 'consum', 0.0236, 'lps'),
	(688452, 136, '2015-02-01 00:47:25.000000', 'consum', 0.0246, 'lps'),
	(688453, 136, '2015-02-01 00:47:26.000000', 'consum', 0.0249, 'lps'),
	(688454, 136, '2015-02-01 00:47:27.000000', 'consum', 0.0232, 'lps'),
	(688455, 136, '2015-02-01 00:47:28.000000', 'consum', 0.0268, 'lps'),
	(688456, 136, '2015-02-01 00:47:29.000000', 'consum', 0.0240, 'lps'),
	(688457, 136, '2015-02-01 00:47:30.000000', 'consum', 0.0249, 'lps'),
	(688458, 136, '2015-02-01 00:47:31.000000', 'consum', 0.0253, 'lps'),
	(688459, 136, '2015-02-01 00:47:32.000000', 'consum', 0.0245, 'lps'),
	(688460, 136, '2015-02-01 00:47:33.000000', 'consum', 0.0253, 'lps'),
	(688461, 136, '2015-02-01 00:47:34.000000', 'consum', 0.0259, 'lps'),
	(688462, 136, '2015-02-01 00:47:35.000000', 'consum', 0.0259, 'lps'),
	(688463, 136, '2015-02-01 00:47:36.000000', 'consum', 0.0242, 'lps'),
	(688464, 136, '2015-02-01 00:47:37.000000', 'consum', 0.0225, 'lps'),
	(688465, 136, '2015-02-01 00:47:38.000000', 'consum', 0.0257, 'lps'),
	(688466, 136, '2015-02-01 00:47:39.000000', 'consum', 0.0267, 'lps'),
	(688467, 136, '2015-02-01 00:47:40.000000', 'consum', 0.0227, 'lps'),
	(688468, 136, '2015-02-01 00:47:41.000000', 'consum', 0.0253, 'lps'),
	(688469, 136, '2015-02-01 00:47:42.000000', 'consum', 0.0245, 'lps'),
	(688470, 136, '2015-02-01 00:47:43.000000', 'consum', 0.0256, 'lps'),
	(688471, 136, '2015-02-01 00:47:44.000000', 'consum', 0.0271, 'lps'),
	(688472, 136, '2015-02-01 00:47:45.000000', 'consum', 0.0249, 'lps'),
	(688473, 136, '2015-02-01 00:47:46.000000', 'consum', 0.0220, 'lps'),
	(688474, 136, '2015-02-01 00:47:47.000000', 'consum', 0.0211, 'lps'),
	(688475, 136, '2015-02-01 00:47:48.000000', 'consum', 0.0250, 'lps'),
	(688476, 136, '2015-02-01 00:47:49.000000', 'consum', 0.0211, 'lps'),
	(688477, 136, '2015-02-01 00:47:50.000000', 'consum', 0.0224, 'lps'),
	(688478, 136, '2015-02-01 00:47:51.000000', 'consum', 0.0215, 'lps'),
	(688479, 136, '2015-02-01 00:47:52.000000', 'consum', 0.0257, 'lps'),
	(688480, 136, '2015-02-01 00:47:53.000000', 'consum', 0.0236, 'lps'),
	(688481, 136, '2015-02-01 00:47:54.000000', 'consum', 0.0264, 'lps'),
	(688482, 136, '2015-02-01 00:47:55.000000', 'consum', 0.0274, 'lps'),
	(688483, 136, '2015-02-01 00:47:56.000000', 'consum', 0.0238, 'lps'),
	(688484, 136, '2015-02-01 00:47:57.000000', 'consum', 0.0221, 'lps'),
	(688485, 136, '2015-02-01 00:47:58.000000', 'consum', 0.0250, 'lps'),
	(688486, 136, '2015-02-01 00:47:59.000000', 'consum', 0.0245, 'lps'),
	(688487, 136, '2015-02-01 00:48:00.000000', 'consum', 0.0267, 'lps'),
	(688488, 136, '2015-02-01 00:48:01.000000', 'consum', 0.0259, 'lps'),
	(688489, 136, '2015-02-01 00:48:02.000000', 'consum', 0.0219, 'lps'),
	(688490, 136, '2015-02-01 00:48:03.000000', 'consum', 0.0238, 'lps'),
	(688491, 136, '2015-02-01 00:48:04.000000', 'consum', 0.0260, 'lps'),
	(688492, 136, '2015-02-01 00:48:05.000000', 'consum', 0.0245, 'lps'),
	(688493, 136, '2015-02-01 00:48:06.000000', 'consum', 0.0238, 'lps'),
	(688494, 136, '2015-02-01 00:48:07.000000', 'consum', 0.0245, 'lps'),
	(688495, 136, '2015-02-01 00:48:08.000000', 'consum', 0.0236, 'lps'),
	(688496, 136, '2015-02-01 00:48:09.000000', 'consum', 0.0235, 'lps'),
	(688497, 136, '2015-02-01 00:48:10.000000', 'consum', 0.0256, 'lps'),
	(688498, 136, '2015-02-01 00:48:11.000000', 'consum', 0.0237, 'lps'),
	(688499, 136, '2015-02-01 00:48:12.000000', 'consum', 0.0272, 'lps'),
	(688500, 136, '2015-02-01 00:48:13.000000', 'consum', 0.0245, 'lps'),
	(688501, 136, '2015-02-01 00:48:14.000000', 'consum', 0.0263, 'lps'),
	(688502, 136, '2015-02-01 00:48:15.000000', 'consum', 0.0242, 'lps'),
	(688503, 136, '2015-02-01 00:48:16.000000', 'consum', 0.0211, 'lps'),
	(688504, 136, '2015-02-01 00:48:17.000000', 'consum', 0.0249, 'lps'),
	(688505, 136, '2015-02-01 00:48:18.000000', 'consum', 0.0274, 'lps'),
	(688506, 136, '2015-02-01 00:48:19.000000', 'consum', 0.0219, 'lps'),
	(688507, 136, '2015-02-01 00:48:20.000000', 'consum', 0.0259, 'lps'),
	(688508, 136, '2015-02-01 00:48:21.000000', 'consum', 0.0233, 'lps'),
	(688509, 136, '2015-02-01 00:48:22.000000', 'consum', 0.0243, 'lps'),
	(688510, 136, '2015-02-01 00:48:23.000000', 'consum', 0.0242, 'lps'),
	(688511, 136, '2015-02-01 00:48:24.000000', 'consum', 0.0270, 'lps'),
	(688512, 136, '2015-02-01 00:48:25.000000', 'consum', 0.0220, 'lps'),
	(688513, 136, '2015-02-01 00:48:26.000000', 'consum', 0.0213, 'lps'),
	(688514, 136, '2015-02-01 00:48:27.000000', 'consum', 0.0257, 'lps'),
	(688515, 136, '2015-02-01 00:48:28.000000', 'consum', 0.0243, 'lps'),
	(688516, 136, '2015-02-01 00:48:29.000000', 'consum', 0.0236, 'lps'),
	(688517, 136, '2015-02-01 00:48:30.000000', 'consum', 0.0241, 'lps'),
	(688518, 136, '2015-02-01 00:48:31.000000', 'consum', 0.0221, 'lps'),
	(688519, 136, '2015-02-01 00:48:32.000000', 'consum', 0.0240, 'lps'),
	(688520, 136, '2015-02-01 00:48:33.000000', 'consum', 0.0260, 'lps'),
	(688521, 136, '2015-02-01 00:48:34.000000', 'consum', 0.0243, 'lps'),
	(688522, 136, '2015-02-01 00:48:35.000000', 'consum', 0.0224, 'lps'),
	(688523, 136, '2015-02-01 00:48:36.000000', 'consum', 0.0247, 'lps'),
	(688524, 136, '2015-02-01 00:48:37.000000', 'consum', 0.0224, 'lps'),
	(688525, 136, '2015-02-01 00:48:38.000000', 'consum', 0.0234, 'lps'),
	(688526, 136, '2015-02-01 00:48:39.000000', 'consum', 0.0225, 'lps'),
	(688527, 136, '2015-02-01 00:48:40.000000', 'consum', 0.0213, 'lps'),
	(688528, 136, '2015-02-01 00:48:41.000000', 'consum', 0.0244, 'lps'),
	(688529, 136, '2015-02-01 00:48:42.000000', 'consum', 0.0240, 'lps'),
	(688530, 136, '2015-02-01 00:48:43.000000', 'consum', 0.0262, 'lps'),
	(688531, 136, '2015-02-01 00:48:44.000000', 'consum', 0.0247, 'lps'),
	(688532, 136, '2015-02-01 00:48:45.000000', 'consum', 0.0243, 'lps'),
	(688533, 136, '2015-02-01 00:48:46.000000', 'consum', 0.0264, 'lps'),
	(688534, 136, '2015-02-01 00:48:47.000000', 'consum', 0.0249, 'lps'),
	(688535, 136, '2015-02-01 00:48:48.000000', 'consum', 0.0245, 'lps'),
	(688536, 136, '2015-02-01 00:48:49.000000', 'consum', 0.0266, 'lps'),
	(688537, 136, '2015-02-01 00:48:50.000000', 'consum', 0.0259, 'lps'),
	(688538, 136, '2015-02-01 00:48:51.000000', 'consum', 0.0220, 'lps'),
	(688539, 136, '2015-02-01 00:48:52.000000', 'consum', 0.0245, 'lps'),
	(688540, 136, '2015-02-01 00:48:53.000000', 'consum', 0.0226, 'lps'),
	(688541, 136, '2015-02-01 00:48:54.000000', 'consum', 0.0251, 'lps'),
	(688542, 136, '2015-02-01 00:48:55.000000', 'consum', 0.0235, 'lps'),
	(688543, 136, '2015-02-01 00:48:56.000000', 'consum', 0.0212, 'lps'),
	(688544, 136, '2015-02-01 00:48:57.000000', 'consum', 0.0211, 'lps'),
	(688545, 136, '2015-02-01 00:48:58.000000', 'consum', 0.0212, 'lps'),
	(688546, 136, '2015-02-01 00:48:59.000000', 'consum', 0.0216, 'lps'),
	(688547, 136, '2015-02-01 00:49:00.000000', 'consum', 0.0234, 'lps'),
	(688548, 136, '2015-02-01 00:49:01.000000', 'consum', 0.0247, 'lps'),
	(688549, 136, '2015-02-01 00:49:02.000000', 'consum', 0.0258, 'lps'),
	(688550, 136, '2015-02-01 00:49:03.000000', 'consum', 0.0212, 'lps'),
	(688551, 136, '2015-02-01 00:49:04.000000', 'consum', 0.0269, 'lps'),
	(688552, 136, '2015-02-01 00:49:05.000000', 'consum', 0.0241, 'lps'),
	(688553, 136, '2015-02-01 00:49:06.000000', 'consum', 0.0252, 'lps'),
	(688554, 136, '2015-02-01 00:49:07.000000', 'consum', 0.0265, 'lps'),
	(688555, 136, '2015-02-01 00:49:08.000000', 'consum', 0.0229, 'lps'),
	(688556, 136, '2015-02-01 00:49:09.000000', 'consum', 0.0269, 'lps'),
	(688557, 136, '2015-02-01 00:49:10.000000', 'consum', 0.0254, 'lps'),
	(688558, 136, '2015-02-01 00:49:11.000000', 'consum', 0.0255, 'lps'),
	(688559, 136, '2015-02-01 00:49:12.000000', 'consum', 0.0239, 'lps'),
	(688560, 136, '2015-02-01 00:49:13.000000', 'consum', 0.0219, 'lps'),
	(688561, 136, '2015-02-01 00:49:14.000000', 'consum', 0.0235, 'lps'),
	(688562, 136, '2015-02-01 00:49:15.000000', 'consum', 0.0242, 'lps'),
	(688563, 136, '2015-02-01 00:49:16.000000', 'consum', 0.0230, 'lps'),
	(688564, 136, '2015-02-01 00:49:17.000000', 'consum', 0.0215, 'lps'),
	(688565, 136, '2015-02-01 00:49:18.000000', 'consum', 0.0239, 'lps'),
	(688566, 136, '2015-02-01 00:49:19.000000', 'consum', 0.0210, 'lps'),
	(688567, 136, '2015-02-01 00:49:20.000000', 'consum', 0.0253, 'lps'),
	(688568, 136, '2015-02-01 00:49:21.000000', 'consum', 0.0232, 'lps'),
	(688569, 136, '2015-02-01 00:49:22.000000', 'consum', 0.0255, 'lps'),
	(688570, 136, '2015-02-01 00:49:23.000000', 'consum', 0.0242, 'lps'),
	(688571, 136, '2015-02-01 00:49:24.000000', 'consum', 0.0234, 'lps'),
	(688572, 136, '2015-02-01 00:49:25.000000', 'consum', 0.0233, 'lps'),
	(688573, 136, '2015-02-01 00:49:26.000000', 'consum', 0.0253, 'lps'),
	(688574, 136, '2015-02-01 00:49:27.000000', 'consum', 0.0229, 'lps'),
	(688575, 136, '2015-02-01 00:49:28.000000', 'consum', 0.0243, 'lps'),
	(688576, 136, '2015-02-01 00:49:29.000000', 'consum', 0.0250, 'lps'),
	(688577, 136, '2015-02-01 00:49:30.000000', 'consum', 0.0249, 'lps'),
	(688578, 136, '2015-02-01 00:49:31.000000', 'consum', 0.0220, 'lps'),
	(688579, 136, '2015-02-01 00:49:32.000000', 'consum', 0.0273, 'lps'),
	(688580, 136, '2015-02-01 00:49:33.000000', 'consum', 0.0236, 'lps'),
	(688581, 136, '2015-02-01 00:49:34.000000', 'consum', 0.0215, 'lps'),
	(688582, 136, '2015-02-01 00:49:35.000000', 'consum', 0.0222, 'lps'),
	(688583, 136, '2015-02-01 00:49:36.000000', 'consum', 0.0254, 'lps'),
	(688584, 136, '2015-02-01 00:49:37.000000', 'consum', 0.0268, 'lps'),
	(688585, 136, '2015-02-01 00:49:38.000000', 'consum', 0.0237, 'lps'),
	(688586, 136, '2015-02-01 00:49:39.000000', 'consum', 0.0237, 'lps'),
	(688587, 136, '2015-02-01 00:49:40.000000', 'consum', 0.0263, 'lps'),
	(688588, 136, '2015-02-01 00:49:41.000000', 'consum', 0.0266, 'lps'),
	(688589, 136, '2015-02-01 00:49:42.000000', 'consum', 0.0265, 'lps'),
	(688590, 136, '2015-02-01 00:49:43.000000', 'consum', 0.0255, 'lps'),
	(688591, 136, '2015-02-01 00:49:44.000000', 'consum', 0.0270, 'lps'),
	(688592, 136, '2015-02-01 00:49:45.000000', 'consum', 0.0244, 'lps'),
	(688593, 136, '2015-02-01 00:49:46.000000', 'consum', 0.0266, 'lps'),
	(688594, 136, '2015-02-01 00:49:47.000000', 'consum', 0.0259, 'lps'),
	(688595, 136, '2015-02-01 00:49:48.000000', 'consum', 0.0223, 'lps'),
	(688596, 136, '2015-02-01 00:49:49.000000', 'consum', 0.0259, 'lps'),
	(688597, 136, '2015-02-01 00:49:50.000000', 'consum', 0.0219, 'lps'),
	(688598, 136, '2015-02-01 00:49:51.000000', 'consum', 0.0242, 'lps'),
	(688599, 136, '2015-02-01 00:49:52.000000', 'consum', 0.0210, 'lps'),
	(688600, 136, '2015-02-01 00:49:53.000000', 'consum', 0.0246, 'lps'),
	(688601, 136, '2015-02-01 00:49:54.000000', 'consum', 0.0258, 'lps'),
	(688602, 136, '2015-02-01 00:49:55.000000', 'consum', 0.0216, 'lps'),
	(688603, 136, '2015-02-01 00:49:56.000000', 'consum', 0.0226, 'lps'),
	(688604, 136, '2015-02-01 00:49:57.000000', 'consum', 0.0270, 'lps'),
	(688605, 136, '2015-02-01 00:49:58.000000', 'consum', 0.0271, 'lps'),
	(688606, 136, '2015-02-01 00:49:59.000000', 'consum', 0.0269, 'lps'),
	(688607, 136, '2015-02-01 00:50:00.000000', 'consum', 0.0256, 'lps'),
	(688608, 136, '2015-02-01 00:50:01.000000', 'consum', 0.0263, 'lps'),
	(688609, 136, '2015-02-01 00:50:02.000000', 'consum', 0.0272, 'lps'),
	(688610, 136, '2015-02-01 00:50:03.000000', 'consum', 0.0234, 'lps'),
	(688611, 136, '2015-02-01 00:50:04.000000', 'consum', 0.0210, 'lps'),
	(688612, 136, '2015-02-01 00:50:05.000000', 'consum', 0.0270, 'lps'),
	(688613, 136, '2015-02-01 00:50:06.000000', 'consum', 0.0247, 'lps'),
	(688614, 136, '2015-02-01 00:50:07.000000', 'consum', 0.0216, 'lps'),
	(688615, 136, '2015-02-01 00:50:08.000000', 'consum', 0.0259, 'lps'),
	(688616, 136, '2015-02-01 00:50:09.000000', 'consum', 0.0245, 'lps'),
	(688617, 136, '2015-02-01 00:50:10.000000', 'consum', 0.0238, 'lps'),
	(688618, 136, '2015-02-01 00:50:11.000000', 'consum', 0.0243, 'lps'),
	(688619, 136, '2015-02-01 00:50:12.000000', 'consum', 0.0229, 'lps'),
	(688620, 136, '2015-02-01 00:50:13.000000', 'consum', 0.0271, 'lps'),
	(688621, 136, '2015-02-01 00:50:14.000000', 'consum', 0.0265, 'lps'),
	(688622, 136, '2015-02-01 00:50:15.000000', 'consum', 0.0235, 'lps'),
	(688623, 136, '2015-02-01 00:50:16.000000', 'consum', 0.0238, 'lps'),
	(688624, 136, '2015-02-01 00:50:17.000000', 'consum', 0.0273, 'lps'),
	(688625, 136, '2015-02-01 00:50:18.000000', 'consum', 0.0248, 'lps'),
	(688626, 136, '2015-02-01 00:50:19.000000', 'consum', 0.0212, 'lps'),
	(688627, 136, '2015-02-01 00:50:20.000000', 'consum', 0.0237, 'lps'),
	(688628, 136, '2015-02-01 00:50:21.000000', 'consum', 0.0274, 'lps'),
	(688629, 136, '2015-02-01 00:50:22.000000', 'consum', 0.0254, 'lps'),
	(688630, 136, '2015-02-01 00:50:23.000000', 'consum', 0.0240, 'lps'),
	(688631, 136, '2015-02-01 00:50:24.000000', 'consum', 0.0228, 'lps'),
	(688632, 136, '2015-02-01 00:50:25.000000', 'consum', 0.0274, 'lps'),
	(688633, 136, '2015-02-01 00:50:26.000000', 'consum', 0.0216, 'lps'),
	(688634, 136, '2015-02-01 00:50:27.000000', 'consum', 0.0245, 'lps'),
	(688635, 136, '2015-02-01 00:50:28.000000', 'consum', 0.0238, 'lps'),
	(688636, 136, '2015-02-01 00:50:29.000000', 'consum', 0.0243, 'lps'),
	(688637, 136, '2015-02-01 00:50:30.000000', 'consum', 0.0230, 'lps'),
	(688638, 136, '2015-02-01 00:50:31.000000', 'consum', 0.0274, 'lps'),
	(688639, 136, '2015-02-01 00:50:32.000000', 'consum', 0.0210, 'lps'),
	(688640, 136, '2015-02-01 00:50:33.000000', 'consum', 0.0212, 'lps'),
	(688641, 136, '2015-02-01 00:50:34.000000', 'consum', 0.0224, 'lps'),
	(688642, 136, '2015-02-01 00:50:35.000000', 'consum', 0.0271, 'lps'),
	(688643, 136, '2015-02-01 00:50:36.000000', 'consum', 0.0217, 'lps'),
	(688644, 136, '2015-02-01 00:50:37.000000', 'consum', 0.0255, 'lps'),
	(688645, 136, '2015-02-01 00:50:38.000000', 'consum', 0.0220, 'lps'),
	(688646, 136, '2015-02-01 00:50:39.000000', 'consum', 0.0255, 'lps'),
	(688647, 136, '2015-02-01 00:50:40.000000', 'consum', 0.0210, 'lps'),
	(688648, 136, '2015-02-01 00:50:41.000000', 'consum', 0.0273, 'lps'),
	(688649, 136, '2015-02-01 00:50:42.000000', 'consum', 0.0262, 'lps'),
	(688650, 136, '2015-02-01 00:50:43.000000', 'consum', 0.0220, 'lps'),
	(688651, 136, '2015-02-01 00:50:44.000000', 'consum', 0.0233, 'lps'),
	(688652, 136, '2015-02-01 00:50:45.000000', 'consum', 0.0229, 'lps'),
	(688653, 136, '2015-02-01 00:50:46.000000', 'consum', 0.0237, 'lps'),
	(688654, 136, '2015-02-01 00:50:47.000000', 'consum', 0.0226, 'lps'),
	(688655, 136, '2015-02-01 00:50:48.000000', 'consum', 0.0273, 'lps'),
	(688656, 136, '2015-02-01 00:50:49.000000', 'consum', 0.0219, 'lps'),
	(688657, 136, '2015-02-01 00:50:50.000000', 'consum', 0.0261, 'lps'),
	(688658, 136, '2015-02-01 00:50:51.000000', 'consum', 0.0243, 'lps'),
	(688659, 136, '2015-02-01 00:50:52.000000', 'consum', 0.0222, 'lps'),
	(688660, 136, '2015-02-01 00:50:53.000000', 'consum', 0.0237, 'lps'),
	(688661, 136, '2015-02-01 00:50:54.000000', 'consum', 0.0243, 'lps'),
	(688662, 136, '2015-02-01 00:50:55.000000', 'consum', 0.0229, 'lps'),
	(688663, 136, '2015-02-01 00:50:56.000000', 'consum', 0.0274, 'lps'),
	(688664, 136, '2015-02-01 00:50:57.000000', 'consum', 0.0211, 'lps'),
	(688665, 136, '2015-02-01 00:50:58.000000', 'consum', 0.0221, 'lps'),
	(688666, 136, '2015-02-01 00:50:59.000000', 'consum', 0.0263, 'lps'),
	(688667, 136, '2015-02-01 00:51:00.000000', 'consum', 0.0248, 'lps'),
	(688668, 136, '2015-02-01 00:51:01.000000', 'consum', 0.0241, 'lps'),
	(688669, 136, '2015-02-01 00:51:02.000000', 'consum', 0.0251, 'lps'),
	(688670, 136, '2015-02-01 00:51:03.000000', 'consum', 0.0256, 'lps'),
	(688671, 136, '2015-02-01 00:51:04.000000', 'consum', 0.0255, 'lps'),
	(688672, 136, '2015-02-01 00:51:05.000000', 'consum', 0.0231, 'lps'),
	(688673, 136, '2015-02-01 00:51:06.000000', 'consum', 0.0248, 'lps'),
	(688674, 136, '2015-02-01 00:51:07.000000', 'consum', 0.0271, 'lps'),
	(688675, 136, '2015-02-01 00:51:08.000000', 'consum', 0.0271, 'lps'),
	(688676, 136, '2015-02-01 00:51:09.000000', 'consum', 0.0267, 'lps'),
	(688677, 136, '2015-02-01 00:51:10.000000', 'consum', 0.0247, 'lps'),
	(688678, 136, '2015-02-01 00:51:11.000000', 'consum', 0.0224, 'lps'),
	(688679, 136, '2015-02-01 00:51:12.000000', 'consum', 0.0237, 'lps'),
	(688680, 136, '2015-02-01 00:51:13.000000', 'consum', 0.0238, 'lps'),
	(688681, 136, '2015-02-01 00:51:14.000000', 'consum', 0.0269, 'lps'),
	(688682, 136, '2015-02-01 00:51:15.000000', 'consum', 0.0228, 'lps'),
	(688683, 136, '2015-02-01 00:51:16.000000', 'consum', 0.0252, 'lps'),
	(688684, 136, '2015-02-01 00:51:17.000000', 'consum', 0.0238, 'lps'),
	(688685, 136, '2015-02-01 00:51:18.000000', 'consum', 0.0224, 'lps'),
	(688686, 136, '2015-02-01 00:51:19.000000', 'consum', 0.0261, 'lps'),
	(688687, 136, '2015-02-01 00:51:20.000000', 'consum', 0.0227, 'lps'),
	(688688, 136, '2015-02-01 00:51:21.000000', 'consum', 0.0211, 'lps'),
	(688689, 136, '2015-02-01 00:51:22.000000', 'consum', 0.0226, 'lps'),
	(688690, 136, '2015-02-01 00:51:23.000000', 'consum', 0.0225, 'lps'),
	(688691, 136, '2015-02-01 00:51:24.000000', 'consum', 0.0235, 'lps'),
	(688692, 136, '2015-02-01 00:51:25.000000', 'consum', 0.0225, 'lps'),
	(688693, 136, '2015-02-01 00:51:26.000000', 'consum', 0.0211, 'lps'),
	(688694, 136, '2015-02-01 00:51:27.000000', 'consum', 0.0236, 'lps'),
	(688695, 136, '2015-02-01 00:51:28.000000', 'consum', 0.0271, 'lps'),
	(688696, 136, '2015-02-01 00:51:29.000000', 'consum', 0.0243, 'lps'),
	(688697, 136, '2015-02-01 00:51:30.000000', 'consum', 0.0259, 'lps'),
	(688698, 136, '2015-02-01 00:51:31.000000', 'consum', 0.0225, 'lps'),
	(688699, 136, '2015-02-01 00:51:32.000000', 'consum', 0.0267, 'lps'),
	(688700, 136, '2015-02-01 00:51:33.000000', 'consum', 0.0256, 'lps'),
	(688701, 136, '2015-02-01 00:51:34.000000', 'consum', 0.0271, 'lps'),
	(688702, 136, '2015-02-01 00:51:35.000000', 'consum', 0.0248, 'lps'),
	(688703, 136, '2015-02-01 00:51:36.000000', 'consum', 0.0217, 'lps'),
	(688704, 136, '2015-02-01 00:51:37.000000', 'consum', 0.0260, 'lps'),
	(688705, 136, '2015-02-01 00:51:38.000000', 'consum', 0.0245, 'lps'),
	(688706, 136, '2015-02-01 00:51:39.000000', 'consum', 0.0234, 'lps'),
	(688707, 136, '2015-02-01 00:51:40.000000', 'consum', 0.0226, 'lps'),
	(688708, 136, '2015-02-01 00:51:41.000000', 'consum', 0.0219, 'lps'),
	(688709, 136, '2015-02-01 00:51:42.000000', 'consum', 0.0271, 'lps'),
	(688710, 136, '2015-02-01 00:51:43.000000', 'consum', 0.0227, 'lps'),
	(688711, 136, '2015-02-01 00:51:44.000000', 'consum', 0.0246, 'lps'),
	(688712, 136, '2015-02-01 00:51:45.000000', 'consum', 0.0210, 'lps'),
	(688713, 136, '2015-02-01 00:51:46.000000', 'consum', 0.0232, 'lps'),
	(688714, 136, '2015-02-01 00:51:47.000000', 'consum', 0.0254, 'lps'),
	(688715, 136, '2015-02-01 00:51:48.000000', 'consum', 0.0236, 'lps'),
	(688716, 136, '2015-02-01 00:51:49.000000', 'consum', 0.0210, 'lps'),
	(688717, 136, '2015-02-01 00:51:50.000000', 'consum', 0.0260, 'lps'),
	(688718, 136, '2015-02-01 00:51:51.000000', 'consum', 0.0264, 'lps'),
	(688719, 136, '2015-02-01 00:51:52.000000', 'consum', 0.0268, 'lps'),
	(688720, 136, '2015-02-01 00:51:53.000000', 'consum', 0.0274, 'lps'),
	(688721, 136, '2015-02-01 00:51:54.000000', 'consum', 0.0226, 'lps'),
	(688722, 136, '2015-02-01 00:51:55.000000', 'consum', 0.0226, 'lps'),
	(688723, 136, '2015-02-01 00:51:56.000000', 'consum', 0.0245, 'lps'),
	(688724, 136, '2015-02-01 00:51:57.000000', 'consum', 0.0271, 'lps'),
	(688725, 136, '2015-02-01 00:51:58.000000', 'consum', 0.0216, 'lps'),
	(688726, 136, '2015-02-01 00:51:59.000000', 'consum', 0.0252, 'lps'),
	(688727, 136, '2015-02-01 00:52:00.000000', 'consum', 0.0210, 'lps'),
	(688728, 136, '2015-02-01 00:52:01.000000', 'consum', 0.0213, 'lps'),
	(688729, 136, '2015-02-01 00:52:02.000000', 'consum', 0.0226, 'lps'),
	(688730, 136, '2015-02-01 00:52:03.000000', 'consum', 0.0214, 'lps'),
	(688731, 136, '2015-02-01 00:52:04.000000', 'consum', 0.0251, 'lps'),
	(688732, 136, '2015-02-01 00:52:05.000000', 'consum', 0.0271, 'lps'),
	(688733, 136, '2015-02-01 00:52:06.000000', 'consum', 0.0261, 'lps'),
	(688734, 136, '2015-02-01 00:52:07.000000', 'consum', 0.0221, 'lps'),
	(688735, 136, '2015-02-01 00:52:08.000000', 'consum', 0.0241, 'lps'),
	(688736, 136, '2015-02-01 00:52:09.000000', 'consum', 0.0270, 'lps'),
	(688737, 136, '2015-02-01 00:52:10.000000', 'consum', 0.0220, 'lps'),
	(688738, 136, '2015-02-01 00:52:11.000000', 'consum', 0.0210, 'lps'),
	(688739, 136, '2015-02-01 00:52:12.000000', 'consum', 0.0246, 'lps'),
	(688740, 136, '2015-02-01 00:52:13.000000', 'consum', 0.0259, 'lps'),
	(688741, 136, '2015-02-01 00:52:14.000000', 'consum', 0.0218, 'lps'),
	(688742, 136, '2015-02-01 00:52:15.000000', 'consum', 0.0236, 'lps'),
	(688743, 136, '2015-02-01 00:52:16.000000', 'consum', 0.0250, 'lps'),
	(688744, 136, '2015-02-01 00:52:17.000000', 'consum', 0.0267, 'lps'),
	(688745, 136, '2015-02-01 00:52:18.000000', 'consum', 0.0244, 'lps'),
	(688746, 136, '2015-02-01 00:52:19.000000', 'consum', 0.0211, 'lps'),
	(688747, 136, '2015-02-01 00:52:20.000000', 'consum', 0.0245, 'lps'),
	(688748, 136, '2015-02-01 00:52:21.000000', 'consum', 0.0250, 'lps'),
	(688749, 136, '2015-02-01 00:52:22.000000', 'consum', 0.0241, 'lps'),
	(688750, 136, '2015-02-01 00:52:23.000000', 'consum', 0.0246, 'lps'),
	(688751, 136, '2015-02-01 00:52:24.000000', 'consum', 0.0234, 'lps'),
	(688752, 136, '2015-02-01 00:52:25.000000', 'consum', 0.0222, 'lps'),
	(688753, 136, '2015-02-01 00:52:26.000000', 'consum', 0.0264, 'lps'),
	(688754, 136, '2015-02-01 00:52:27.000000', 'consum', 0.0250, 'lps'),
	(688755, 136, '2015-02-01 00:52:28.000000', 'consum', 0.0246, 'lps'),
	(688756, 136, '2015-02-01 00:52:29.000000', 'consum', 0.0270, 'lps'),
	(688757, 136, '2015-02-01 00:52:30.000000', 'consum', 0.0210, 'lps'),
	(688758, 136, '2015-02-01 00:52:31.000000', 'consum', 0.0223, 'lps'),
	(688759, 136, '2015-02-01 00:52:32.000000', 'consum', 0.0211, 'lps'),
	(688760, 136, '2015-02-01 00:52:33.000000', 'consum', 0.0241, 'lps'),
	(688761, 136, '2015-02-01 00:52:34.000000', 'consum', 0.0233, 'lps'),
	(688762, 136, '2015-02-01 00:52:35.000000', 'consum', 0.0233, 'lps'),
	(688763, 136, '2015-02-01 00:52:36.000000', 'consum', 0.0258, 'lps'),
	(688764, 136, '2015-02-01 00:52:37.000000', 'consum', 0.0249, 'lps'),
	(688765, 136, '2015-02-01 00:52:38.000000', 'consum', 0.0264, 'lps'),
	(688766, 136, '2015-02-01 00:52:39.000000', 'consum', 0.0234, 'lps'),
	(688767, 136, '2015-02-01 00:52:40.000000', 'consum', 0.0230, 'lps'),
	(688768, 136, '2015-02-01 00:52:41.000000', 'consum', 0.0242, 'lps'),
	(688769, 136, '2015-02-01 00:52:42.000000', 'consum', 0.0245, 'lps'),
	(688770, 136, '2015-02-01 00:52:43.000000', 'consum', 0.0226, 'lps'),
	(688771, 136, '2015-02-01 00:52:44.000000', 'consum', 0.0247, 'lps'),
	(688772, 136, '2015-02-01 00:52:45.000000', 'consum', 0.0219, 'lps'),
	(688773, 136, '2015-02-01 00:52:46.000000', 'consum', 0.0210, 'lps'),
	(688774, 136, '2015-02-01 00:52:47.000000', 'consum', 0.0246, 'lps'),
	(688775, 136, '2015-02-01 00:52:48.000000', 'consum', 0.0262, 'lps'),
	(688776, 136, '2015-02-01 00:52:49.000000', 'consum', 0.0234, 'lps'),
	(688777, 136, '2015-02-01 00:52:50.000000', 'consum', 0.0237, 'lps'),
	(688778, 136, '2015-02-01 00:52:51.000000', 'consum', 0.0211, 'lps'),
	(688779, 136, '2015-02-01 00:52:52.000000', 'consum', 0.0265, 'lps'),
	(688780, 136, '2015-02-01 00:52:53.000000', 'consum', 0.0222, 'lps'),
	(688781, 136, '2015-02-01 00:52:54.000000', 'consum', 0.0233, 'lps'),
	(688782, 136, '2015-02-01 00:52:55.000000', 'consum', 0.0227, 'lps'),
	(688783, 136, '2015-02-01 00:52:56.000000', 'consum', 0.0226, 'lps'),
	(688784, 136, '2015-02-01 00:52:57.000000', 'consum', 0.0241, 'lps'),
	(688785, 136, '2015-02-01 00:52:58.000000', 'consum', 0.0253, 'lps'),
	(688786, 136, '2015-02-01 00:52:59.000000', 'consum', 0.0268, 'lps'),
	(688787, 136, '2015-02-01 00:53:00.000000', 'consum', 0.0240, 'lps'),
	(688788, 136, '2015-02-01 00:53:01.000000', 'consum', 0.0254, 'lps'),
	(688789, 136, '2015-02-01 00:53:02.000000', 'consum', 0.0272, 'lps'),
	(688790, 136, '2015-02-01 00:53:03.000000', 'consum', 0.0259, 'lps'),
	(688791, 136, '2015-02-01 00:53:04.000000', 'consum', 0.0270, 'lps'),
	(688792, 136, '2015-02-01 00:53:05.000000', 'consum', 0.0234, 'lps'),
	(688793, 136, '2015-02-01 00:53:06.000000', 'consum', 0.0215, 'lps'),
	(688794, 136, '2015-02-01 00:53:07.000000', 'consum', 0.0228, 'lps'),
	(688795, 136, '2015-02-01 00:53:08.000000', 'consum', 0.0219, 'lps'),
	(688796, 136, '2015-02-01 00:53:09.000000', 'consum', 0.0267, 'lps'),
	(688797, 136, '2015-02-01 00:53:10.000000', 'consum', 0.0210, 'lps'),
	(688798, 136, '2015-02-01 00:53:11.000000', 'consum', 0.0233, 'lps'),
	(688799, 136, '2015-02-01 00:53:12.000000', 'consum', 0.0261, 'lps'),
	(688800, 136, '2015-02-01 00:53:13.000000', 'consum', 0.0268, 'lps'),
	(688801, 136, '2015-02-01 00:53:14.000000', 'consum', 0.0215, 'lps'),
	(688802, 136, '2015-02-01 00:53:15.000000', 'consum', 0.0258, 'lps'),
	(688803, 136, '2015-02-01 00:53:16.000000', 'consum', 0.0240, 'lps'),
	(688804, 136, '2015-02-01 00:53:17.000000', 'consum', 0.0215, 'lps'),
	(688805, 136, '2015-02-01 00:53:18.000000', 'consum', 0.0212, 'lps'),
	(688806, 136, '2015-02-01 00:53:19.000000', 'consum', 0.0270, 'lps'),
	(688807, 136, '2015-02-01 00:53:20.000000', 'consum', 0.0246, 'lps'),
	(688808, 136, '2015-02-01 00:53:21.000000', 'consum', 0.0274, 'lps'),
	(688809, 136, '2015-02-01 00:53:22.000000', 'consum', 0.0227, 'lps'),
	(688810, 136, '2015-02-01 00:53:23.000000', 'consum', 0.0232, 'lps'),
	(688811, 136, '2015-02-01 00:53:24.000000', 'consum', 0.0271, 'lps'),
	(688812, 136, '2015-02-01 00:53:25.000000', 'consum', 0.0254, 'lps'),
	(688813, 136, '2015-02-01 00:53:26.000000', 'consum', 0.0249, 'lps'),
	(688814, 136, '2015-02-01 00:53:27.000000', 'consum', 0.0271, 'lps'),
	(688815, 136, '2015-02-01 00:53:28.000000', 'consum', 0.0269, 'lps'),
	(688816, 136, '2015-02-01 00:53:29.000000', 'consum', 0.0259, 'lps'),
	(688817, 136, '2015-02-01 00:53:30.000000', 'consum', 0.0214, 'lps'),
	(688818, 136, '2015-02-01 00:53:31.000000', 'consum', 0.0213, 'lps'),
	(688819, 136, '2015-02-01 00:53:32.000000', 'consum', 0.0212, 'lps'),
	(688820, 136, '2015-02-01 00:53:33.000000', 'consum', 0.0211, 'lps'),
	(688821, 136, '2015-02-01 00:53:34.000000', 'consum', 0.0274, 'lps'),
	(688822, 136, '2015-02-01 00:53:35.000000', 'consum', 0.0267, 'lps'),
	(688823, 136, '2015-02-01 00:53:36.000000', 'consum', 0.0238, 'lps'),
	(688824, 136, '2015-02-01 00:53:37.000000', 'consum', 0.0246, 'lps'),
	(688825, 136, '2015-02-01 00:53:38.000000', 'consum', 0.0241, 'lps'),
	(688826, 136, '2015-02-01 00:53:39.000000', 'consum', 0.0258, 'lps'),
	(688827, 136, '2015-02-01 00:53:40.000000', 'consum', 0.0226, 'lps'),
	(688828, 136, '2015-02-01 00:53:41.000000', 'consum', 0.0213, 'lps'),
	(688829, 136, '2015-02-01 00:53:42.000000', 'consum', 0.0241, 'lps'),
	(688830, 136, '2015-02-01 00:53:43.000000', 'consum', 0.0229, 'lps'),
	(688831, 136, '2015-02-01 00:53:44.000000', 'consum', 0.0211, 'lps'),
	(688832, 136, '2015-02-01 00:53:45.000000', 'consum', 0.0224, 'lps'),
	(688833, 136, '2015-02-01 00:53:46.000000', 'consum', 0.0211, 'lps'),
	(688834, 136, '2015-02-01 00:53:47.000000', 'consum', 0.0242, 'lps'),
	(688835, 136, '2015-02-01 00:53:48.000000', 'consum', 0.0234, 'lps'),
	(688836, 136, '2015-02-01 00:53:49.000000', 'consum', 0.0234, 'lps'),
	(688837, 136, '2015-02-01 00:53:50.000000', 'consum', 0.0260, 'lps'),
	(688838, 136, '2015-02-01 00:53:51.000000', 'consum', 0.0258, 'lps'),
	(688839, 136, '2015-02-01 00:53:52.000000', 'consum', 0.0234, 'lps'),
	(688840, 136, '2015-02-01 00:53:53.000000', 'consum', 0.0253, 'lps'),
	(688841, 136, '2015-02-01 00:53:54.000000', 'consum', 0.0224, 'lps'),
	(688842, 136, '2015-02-01 00:53:55.000000', 'consum', 0.0217, 'lps'),
	(688843, 136, '2015-02-01 00:53:56.000000', 'consum', 0.0267, 'lps'),
	(688844, 136, '2015-02-01 00:53:57.000000', 'consum', 0.0217, 'lps'),
	(688845, 136, '2015-02-01 00:53:58.000000', 'consum', 0.0266, 'lps'),
	(688846, 136, '2015-02-01 00:53:59.000000', 'consum', 0.0211, 'lps'),
	(688847, 136, '2015-02-01 00:54:00.000000', 'consum', 0.0243, 'lps'),
	(688848, 136, '2015-02-01 00:54:01.000000', 'consum', 0.0240, 'lps'),
	(688849, 136, '2015-02-01 00:54:02.000000', 'consum', 0.0263, 'lps'),
	(688850, 136, '2015-02-01 00:54:03.000000', 'consum', 0.0257, 'lps'),
	(688851, 136, '2015-02-01 00:54:04.000000', 'consum', 0.0221, 'lps'),
	(688852, 136, '2015-02-01 00:54:05.000000', 'consum', 0.0254, 'lps'),
	(688853, 136, '2015-02-01 00:54:06.000000', 'consum', 0.0266, 'lps'),
	(688854, 136, '2015-02-01 00:54:07.000000', 'consum', 0.0231, 'lps'),
	(688855, 136, '2015-02-01 00:54:08.000000', 'consum', 0.0211, 'lps'),
	(688856, 136, '2015-02-01 00:54:09.000000', 'consum', 0.0219, 'lps'),
	(688857, 136, '2015-02-01 00:54:10.000000', 'consum', 0.0253, 'lps'),
	(688858, 136, '2015-02-01 00:54:11.000000', 'consum', 0.0267, 'lps'),
	(688859, 136, '2015-02-01 00:54:12.000000', 'consum', 0.0239, 'lps'),
	(688860, 136, '2015-02-01 00:54:13.000000', 'consum', 0.0248, 'lps'),
	(688861, 136, '2015-02-01 00:54:14.000000', 'consum', 0.0247, 'lps'),
	(688862, 136, '2015-02-01 00:54:15.000000', 'consum', 0.0219, 'lps'),
	(688863, 136, '2015-02-01 00:54:16.000000', 'consum', 0.0272, 'lps'),
	(688864, 136, '2015-02-01 00:54:17.000000', 'consum', 0.0234, 'lps'),
	(688865, 136, '2015-02-01 00:54:18.000000', 'consum', 0.0273, 'lps'),
	(688866, 136, '2015-02-01 00:54:19.000000', 'consum', 0.0261, 'lps'),
	(688867, 136, '2015-02-01 00:54:20.000000', 'consum', 0.0212, 'lps'),
	(688868, 136, '2015-02-01 00:54:21.000000', 'consum', 0.0261, 'lps'),
	(688869, 136, '2015-02-01 00:54:22.000000', 'consum', 0.0263, 'lps'),
	(688870, 136, '2015-02-01 00:54:23.000000', 'consum', 0.0259, 'lps'),
	(688871, 136, '2015-02-01 00:54:24.000000', 'consum', 0.0233, 'lps'),
	(688872, 136, '2015-02-01 00:54:25.000000', 'consum', 0.0242, 'lps'),
	(688873, 136, '2015-02-01 00:54:26.000000', 'consum', 0.0236, 'lps'),
	(688874, 136, '2015-02-01 00:54:27.000000', 'consum', 0.0247, 'lps'),
	(688875, 136, '2015-02-01 00:54:28.000000', 'consum', 0.0251, 'lps'),
	(688876, 136, '2015-02-01 00:54:29.000000', 'consum', 0.0238, 'lps'),
	(688877, 136, '2015-02-01 00:54:30.000000', 'consum', 0.0230, 'lps'),
	(688878, 136, '2015-02-01 00:54:31.000000', 'consum', 0.0223, 'lps'),
	(688879, 136, '2015-02-01 00:54:32.000000', 'consum', 0.0219, 'lps'),
	(688880, 136, '2015-02-01 00:54:33.000000', 'consum', 0.0217, 'lps'),
	(688881, 136, '2015-02-01 00:54:34.000000', 'consum', 0.0216, 'lps'),
	(688882, 136, '2015-02-01 00:54:35.000000', 'consum', 0.0222, 'lps'),
	(688883, 136, '2015-02-01 00:54:36.000000', 'consum', 0.0251, 'lps'),
	(688884, 136, '2015-02-01 00:54:37.000000', 'consum', 0.0250, 'lps'),
	(688885, 136, '2015-02-01 00:54:38.000000', 'consum', 0.0224, 'lps'),
	(688886, 136, '2015-02-01 00:54:39.000000', 'consum', 0.0225, 'lps'),
	(688887, 136, '2015-02-01 00:54:40.000000', 'consum', 0.0244, 'lps'),
	(688888, 136, '2015-02-01 00:54:41.000000', 'consum', 0.0270, 'lps'),
	(688889, 136, '2015-02-01 00:54:42.000000', 'consum', 0.0214, 'lps'),
	(688890, 136, '2015-02-01 00:54:43.000000', 'consum', 0.0246, 'lps'),
	(688891, 136, '2015-02-01 00:54:44.000000', 'consum', 0.0249, 'lps'),
	(688892, 136, '2015-02-01 00:54:45.000000', 'consum', 0.0231, 'lps'),
	(688893, 136, '2015-02-01 00:54:46.000000', 'consum', 0.0263, 'lps'),
	(688894, 136, '2015-02-01 00:54:47.000000', 'consum', 0.0220, 'lps'),
	(688895, 136, '2015-02-01 00:54:48.000000', 'consum', 0.0229, 'lps'),
	(688896, 136, '2015-02-01 00:54:49.000000', 'consum', 0.0210, 'lps'),
	(688897, 136, '2015-02-01 00:54:50.000000', 'consum', 0.0221, 'lps'),
	(688898, 136, '2015-02-01 00:54:51.000000', 'consum', 0.0265, 'lps'),
	(688899, 136, '2015-02-01 00:54:52.000000', 'consum', 0.0258, 'lps'),
	(688900, 136, '2015-02-01 00:54:53.000000', 'consum', 0.0222, 'lps'),
	(688901, 136, '2015-02-01 00:54:54.000000', 'consum', 0.0254, 'lps'),
	(688902, 136, '2015-02-01 00:54:55.000000', 'consum', 0.0264, 'lps'),
	(688903, 136, '2015-02-01 00:54:56.000000', 'consum', 0.0218, 'lps'),
	(688904, 136, '2015-02-01 00:54:57.000000', 'consum', 0.0221, 'lps'),
	(688905, 136, '2015-02-01 00:54:58.000000', 'consum', 0.0238, 'lps'),
	(688906, 136, '2015-02-01 00:54:59.000000', 'consum', 0.0256, 'lps'),
	(688907, 136, '2015-02-01 00:55:00.000000', 'consum', 0.0224, 'lps'),
	(688908, 136, '2015-02-01 00:55:01.000000', 'consum', 0.0210, 'lps'),
	(688909, 136, '2015-02-01 00:55:02.000000', 'consum', 0.0234, 'lps'),
	(688910, 136, '2015-02-01 00:55:03.000000', 'consum', 0.0264, 'lps'),
	(688911, 136, '2015-02-01 00:55:04.000000', 'consum', 0.0214, 'lps'),
	(688912, 136, '2015-02-01 00:55:05.000000', 'consum', 0.0265, 'lps'),
	(688913, 136, '2015-02-01 00:55:06.000000', 'consum', 0.0214, 'lps'),
	(688914, 136, '2015-02-01 00:55:07.000000', 'consum', 0.0260, 'lps'),
	(688915, 136, '2015-02-01 00:55:08.000000', 'consum', 0.0252, 'lps'),
	(688916, 136, '2015-02-01 00:55:09.000000', 'consum', 0.0269, 'lps'),
	(688917, 136, '2015-02-01 00:55:10.000000', 'consum', 0.0252, 'lps'),
	(688918, 136, '2015-02-01 00:55:11.000000', 'consum', 0.0244, 'lps'),
	(688919, 136, '2015-02-01 00:55:12.000000', 'consum', 0.0255, 'lps'),
	(688920, 136, '2015-02-01 00:55:13.000000', 'consum', 0.0267, 'lps'),
	(688921, 136, '2015-02-01 00:55:14.000000', 'consum', 0.0230, 'lps'),
	(688922, 136, '2015-02-01 00:55:15.000000', 'consum', 0.0272, 'lps'),
	(688923, 136, '2015-02-01 00:55:16.000000', 'consum', 0.0262, 'lps'),
	(688924, 136, '2015-02-01 00:55:17.000000', 'consum', 0.0221, 'lps'),
	(688925, 136, '2015-02-01 00:55:18.000000', 'consum', 0.0241, 'lps'),
	(688926, 136, '2015-02-01 00:55:19.000000', 'consum', 0.0265, 'lps'),
	(688927, 136, '2015-02-01 00:55:20.000000', 'consum', 0.0265, 'lps'),
	(688928, 136, '2015-02-01 00:55:21.000000', 'consum', 0.0252, 'lps'),
	(688929, 136, '2015-02-01 00:55:22.000000', 'consum', 0.0259, 'lps'),
	(688930, 136, '2015-02-01 00:55:23.000000', 'consum', 0.0262, 'lps'),
	(688931, 136, '2015-02-01 00:55:24.000000', 'consum', 0.0261, 'lps'),
	(688932, 136, '2015-02-01 00:55:25.000000', 'consum', 0.0243, 'lps'),
	(688933, 136, '2015-02-01 00:55:26.000000', 'consum', 0.0223, 'lps'),
	(688934, 136, '2015-02-01 00:55:27.000000', 'consum', 0.0241, 'lps'),
	(688935, 136, '2015-02-01 00:55:28.000000', 'consum', 0.0262, 'lps'),
	(688936, 136, '2015-02-01 00:55:29.000000', 'consum', 0.0245, 'lps'),
	(688937, 136, '2015-02-01 00:55:30.000000', 'consum', 0.0233, 'lps'),
	(688938, 136, '2015-02-01 00:55:31.000000', 'consum', 0.0219, 'lps'),
	(688939, 136, '2015-02-01 00:55:32.000000', 'consum', 0.0253, 'lps'),
	(688940, 136, '2015-02-01 00:55:33.000000', 'consum', 0.0266, 'lps'),
	(688941, 136, '2015-02-01 00:55:34.000000', 'consum', 0.0233, 'lps'),
	(688942, 136, '2015-02-01 00:55:35.000000', 'consum', 0.0224, 'lps'),
	(688943, 136, '2015-02-01 00:55:36.000000', 'consum', 0.0273, 'lps'),
	(688944, 136, '2015-02-01 00:55:37.000000', 'consum', 0.0226, 'lps'),
	(688945, 136, '2015-02-01 00:55:38.000000', 'consum', 0.0231, 'lps'),
	(688946, 136, '2015-02-01 00:55:39.000000', 'consum', 0.0266, 'lps'),
	(688947, 136, '2015-02-01 00:55:40.000000', 'consum', 0.0234, 'lps'),
	(688948, 136, '2015-02-01 00:55:41.000000', 'consum', 0.0228, 'lps'),
	(688949, 136, '2015-02-01 00:55:42.000000', 'consum', 0.0229, 'lps'),
	(688950, 136, '2015-02-01 00:55:43.000000', 'consum', 0.0250, 'lps'),
	(688951, 136, '2015-02-01 00:55:44.000000', 'consum', 0.0224, 'lps'),
	(688952, 136, '2015-02-01 00:55:45.000000', 'consum', 0.0227, 'lps'),
	(688953, 136, '2015-02-01 00:55:46.000000', 'consum', 0.0252, 'lps'),
	(688954, 136, '2015-02-01 00:55:47.000000', 'consum', 0.0238, 'lps'),
	(688955, 136, '2015-02-01 00:55:48.000000', 'consum', 0.0225, 'lps'),
	(688956, 136, '2015-02-01 00:55:49.000000', 'consum', 0.0265, 'lps'),
	(688957, 136, '2015-02-01 00:55:50.000000', 'consum', 0.0247, 'lps'),
	(688958, 136, '2015-02-01 00:55:51.000000', 'consum', 0.0229, 'lps'),
	(688959, 136, '2015-02-01 00:55:52.000000', 'consum', 0.0259, 'lps'),
	(688960, 136, '2015-02-01 00:55:53.000000', 'consum', 0.0269, 'lps'),
	(688961, 136, '2015-02-01 00:55:54.000000', 'consum', 0.0230, 'lps'),
	(688962, 136, '2015-02-01 00:55:55.000000', 'consum', 0.0264, 'lps'),
	(688963, 136, '2015-02-01 00:55:56.000000', 'consum', 0.0226, 'lps'),
	(688964, 136, '2015-02-01 00:55:57.000000', 'consum', 0.0259, 'lps'),
	(688965, 136, '2015-02-01 00:55:58.000000', 'consum', 0.0210, 'lps'),
	(688966, 136, '2015-02-01 00:55:59.000000', 'consum', 0.0259, 'lps'),
	(688967, 136, '2015-02-01 00:56:00.000000', 'consum', 0.0262, 'lps'),
	(688968, 136, '2015-02-01 00:56:01.000000', 'consum', 0.0259, 'lps'),
	(688969, 136, '2015-02-01 00:56:02.000000', 'consum', 0.0235, 'lps'),
	(688970, 136, '2015-02-01 00:56:03.000000', 'consum', 0.0252, 'lps'),
	(688971, 136, '2015-02-01 00:56:04.000000', 'consum', 0.0217, 'lps'),
	(688972, 136, '2015-02-01 00:56:05.000000', 'consum', 0.0250, 'lps'),
	(688973, 136, '2015-02-01 00:56:06.000000', 'consum', 0.0259, 'lps'),
	(688974, 136, '2015-02-01 00:56:07.000000', 'consum', 0.0268, 'lps'),
	(688975, 136, '2015-02-01 00:56:08.000000', 'consum', 0.0227, 'lps'),
	(688976, 136, '2015-02-01 00:56:09.000000', 'consum', 0.0250, 'lps'),
	(688977, 136, '2015-02-01 00:56:10.000000', 'consum', 0.0230, 'lps'),
	(688978, 136, '2015-02-01 00:56:11.000000', 'consum', 0.0255, 'lps'),
	(688979, 136, '2015-02-01 00:56:12.000000', 'consum', 0.0247, 'lps'),
	(688980, 136, '2015-02-01 00:56:13.000000', 'consum', 0.0261, 'lps'),
	(688981, 136, '2015-02-01 00:56:14.000000', 'consum', 0.0224, 'lps'),
	(688982, 136, '2015-02-01 00:56:15.000000', 'consum', 0.0258, 'lps'),
	(688983, 136, '2015-02-01 00:56:16.000000', 'consum', 0.0214, 'lps'),
	(688984, 136, '2015-02-01 00:56:17.000000', 'consum', 0.0215, 'lps'),
	(688985, 136, '2015-02-01 00:56:18.000000', 'consum', 0.0224, 'lps'),
	(688986, 136, '2015-02-01 00:56:19.000000', 'consum', 0.0264, 'lps'),
	(688987, 136, '2015-02-01 00:56:20.000000', 'consum', 0.0245, 'lps'),
	(688988, 136, '2015-02-01 00:56:21.000000', 'consum', 0.0224, 'lps'),
	(688989, 136, '2015-02-01 00:56:22.000000', 'consum', 0.0238, 'lps'),
	(688990, 136, '2015-02-01 00:56:23.000000', 'consum', 0.0245, 'lps'),
	(688991, 136, '2015-02-01 00:56:24.000000', 'consum', 0.0238, 'lps'),
	(688992, 136, '2015-02-01 00:56:25.000000', 'consum', 0.0244, 'lps'),
	(688993, 136, '2015-02-01 00:56:26.000000', 'consum', 0.0234, 'lps'),
	(688994, 136, '2015-02-01 00:56:27.000000', 'consum', 0.0226, 'lps'),
	(688995, 136, '2015-02-01 00:56:28.000000', 'consum', 0.0217, 'lps'),
	(688996, 136, '2015-02-01 00:56:29.000000', 'consum', 0.0265, 'lps'),
	(688997, 136, '2015-02-01 00:56:30.000000', 'consum', 0.0269, 'lps'),
	(688998, 136, '2015-02-01 00:56:31.000000', 'consum', 0.0211, 'lps'),
	(688999, 136, '2015-02-01 00:56:32.000000', 'consum', 0.0234, 'lps'),
	(689000, 136, '2015-02-01 00:56:33.000000', 'consum', 0.0261, 'lps'),
	(689001, 136, '2015-02-01 00:56:34.000000', 'consum', 0.0263, 'lps'),
	(689002, 136, '2015-02-01 00:56:35.000000', 'consum', 0.0260, 'lps'),
	(689003, 136, '2015-02-01 00:56:36.000000', 'consum', 0.0234, 'lps'),
	(689004, 136, '2015-02-01 00:56:37.000000', 'consum', 0.0245, 'lps'),
	(689005, 136, '2015-02-01 00:56:38.000000', 'consum', 0.0249, 'lps'),
	(689006, 136, '2015-02-01 00:56:39.000000', 'consum', 0.0237, 'lps'),
	(689007, 136, '2015-02-01 00:56:40.000000', 'consum', 0.0229, 'lps'),
	(689008, 136, '2015-02-01 00:56:41.000000', 'consum', 0.0225, 'lps'),
	(689009, 136, '2015-02-01 00:56:42.000000', 'consum', 0.0228, 'lps'),
	(689010, 136, '2015-02-01 00:56:43.000000', 'consum', 0.0255, 'lps'),
	(689011, 136, '2015-02-01 00:56:44.000000', 'consum', 0.0253, 'lps'),
	(689012, 136, '2015-02-01 00:56:45.000000', 'consum', 0.0223, 'lps'),
	(689013, 136, '2015-02-01 00:56:46.000000', 'consum', 0.0214, 'lps'),
	(689014, 136, '2015-02-01 00:56:47.000000', 'consum', 0.0256, 'lps'),
	(689015, 136, '2015-02-01 00:56:48.000000', 'consum', 0.0233, 'lps'),
	(689016, 136, '2015-02-01 00:56:49.000000', 'consum', 0.0254, 'lps'),
	(689017, 136, '2015-02-01 00:56:50.000000', 'consum', 0.0229, 'lps'),
	(689018, 136, '2015-02-01 00:56:51.000000', 'consum', 0.0239, 'lps'),
	(689019, 136, '2015-02-01 00:56:52.000000', 'consum', 0.0233, 'lps'),
	(689020, 136, '2015-02-01 00:56:53.000000', 'consum', 0.0237, 'lps'),
	(689021, 136, '2015-02-01 00:56:54.000000', 'consum', 0.0215, 'lps'),
	(689022, 136, '2015-02-01 00:56:55.000000', 'consum', 0.0218, 'lps'),
	(689023, 136, '2015-02-01 00:56:56.000000', 'consum', 0.0234, 'lps'),
	(689024, 136, '2015-02-01 00:56:57.000000', 'consum', 0.0243, 'lps'),
	(689025, 136, '2015-02-01 00:56:58.000000', 'consum', 0.0237, 'lps'),
	(689026, 136, '2015-02-01 00:56:59.000000', 'consum', 0.0249, 'lps'),
	(689027, 136, '2015-02-01 00:57:00.000000', 'consum', 0.0258, 'lps'),
	(689028, 136, '2015-02-01 00:57:01.000000', 'consum', 0.0268, 'lps'),
	(689029, 136, '2015-02-01 00:57:02.000000', 'consum', 0.0227, 'lps'),
	(689030, 136, '2015-02-01 00:57:03.000000', 'consum', 0.0250, 'lps'),
	(689031, 136, '2015-02-01 00:57:04.000000', 'consum', 0.0231, 'lps'),
	(689032, 136, '2015-02-01 00:57:05.000000', 'consum', 0.0259, 'lps'),
	(689033, 136, '2015-02-01 00:57:06.000000', 'consum', 0.0265, 'lps'),
	(689034, 136, '2015-02-01 00:57:07.000000', 'consum', 0.0274, 'lps'),
	(689035, 136, '2015-02-01 00:57:08.000000', 'consum', 0.0235, 'lps'),
	(689036, 136, '2015-02-01 00:57:09.000000', 'consum', 0.0273, 'lps'),
	(689037, 136, '2015-02-01 00:57:10.000000', 'consum', 0.0257, 'lps'),
	(689038, 136, '2015-02-01 00:57:11.000000', 'consum', 0.0257, 'lps'),
	(689039, 136, '2015-02-01 00:57:12.000000', 'consum', 0.0239, 'lps'),
	(689040, 136, '2015-02-01 00:57:13.000000', 'consum', 0.0215, 'lps'),
	(689041, 136, '2015-02-01 00:57:14.000000', 'consum', 0.0211, 'lps'),
	(689042, 136, '2015-02-01 00:57:15.000000', 'consum', 0.0268, 'lps'),
	(689043, 136, '2015-02-01 00:57:16.000000', 'consum', 0.0236, 'lps'),
	(689044, 136, '2015-02-01 00:57:17.000000', 'consum', 0.0233, 'lps'),
	(689045, 136, '2015-02-01 00:57:18.000000', 'consum', 0.0246, 'lps'),
	(689046, 136, '2015-02-01 00:57:19.000000', 'consum', 0.0258, 'lps'),
	(689047, 136, '2015-02-01 00:57:20.000000', 'consum', 0.0212, 'lps'),
	(689048, 136, '2015-02-01 00:57:21.000000', 'consum', 0.0270, 'lps'),
	(689049, 136, '2015-02-01 00:57:22.000000', 'consum', 0.0246, 'lps'),
	(689050, 136, '2015-02-01 00:57:23.000000', 'consum', 0.0273, 'lps'),
	(689051, 136, '2015-02-01 00:57:24.000000', 'consum', 0.0226, 'lps'),
	(689052, 136, '2015-02-01 00:57:25.000000', 'consum', 0.0228, 'lps'),
	(689053, 136, '2015-02-01 00:57:26.000000', 'consum', 0.0256, 'lps'),
	(689054, 136, '2015-02-01 00:57:27.000000', 'consum', 0.0255, 'lps'),
	(689055, 136, '2015-02-01 00:57:28.000000', 'consum', 0.0234, 'lps'),
	(689056, 136, '2015-02-01 00:57:29.000000', 'consum', 0.0259, 'lps'),
	(689057, 136, '2015-02-01 00:57:30.000000', 'consum', 0.0255, 'lps'),
	(689058, 136, '2015-02-01 00:57:31.000000', 'consum', 0.0224, 'lps'),
	(689059, 136, '2015-02-01 00:57:32.000000', 'consum', 0.0210, 'lps'),
	(689060, 136, '2015-02-01 00:57:33.000000', 'consum', 0.0235, 'lps'),
	(689061, 136, '2015-02-01 00:57:34.000000', 'consum', 0.0269, 'lps'),
	(689062, 136, '2015-02-01 00:57:35.000000', 'consum', 0.0235, 'lps'),
	(689063, 136, '2015-02-01 00:57:36.000000', 'consum', 0.0223, 'lps'),
	(689064, 136, '2015-02-01 00:57:37.000000', 'consum', 0.0268, 'lps'),
	(689065, 136, '2015-02-01 00:57:38.000000', 'consum', 0.0265, 'lps'),
	(689066, 136, '2015-02-01 00:57:39.000000', 'consum', 0.0246, 'lps'),
	(689067, 136, '2015-02-01 00:57:40.000000', 'consum', 0.0225, 'lps'),
	(689068, 136, '2015-02-01 00:57:41.000000', 'consum', 0.0241, 'lps'),
	(689069, 136, '2015-02-01 00:57:42.000000', 'consum', 0.0257, 'lps'),
	(689070, 136, '2015-02-01 00:57:43.000000', 'consum', 0.0223, 'lps'),
	(689071, 136, '2015-02-01 00:57:44.000000', 'consum', 0.0266, 'lps'),
	(689072, 136, '2015-02-01 00:57:45.000000', 'consum', 0.0254, 'lps'),
	(689073, 136, '2015-02-01 00:57:46.000000', 'consum', 0.0263, 'lps'),
	(689074, 136, '2015-02-01 00:57:47.000000', 'consum', 0.0214, 'lps'),
	(689075, 136, '2015-02-01 00:57:48.000000', 'consum', 0.0266, 'lps'),
	(689076, 136, '2015-02-01 00:57:49.000000', 'consum', 0.0221, 'lps'),
	(689077, 136, '2015-02-01 00:57:50.000000', 'consum', 0.0225, 'lps'),
	(689078, 136, '2015-02-01 00:57:51.000000', 'consum', 0.0253, 'lps'),
	(689079, 136, '2015-02-01 00:57:52.000000', 'consum', 0.0251, 'lps'),
	(689080, 136, '2015-02-01 00:57:53.000000', 'consum', 0.0222, 'lps'),
	(689081, 136, '2015-02-01 00:57:54.000000', 'consum', 0.0211, 'lps'),
	(689082, 136, '2015-02-01 00:57:55.000000', 'consum', 0.0245, 'lps'),
	(689083, 136, '2015-02-01 00:57:56.000000', 'consum', 0.0253, 'lps'),
	(689084, 136, '2015-02-01 00:57:57.000000', 'consum', 0.0257, 'lps'),
	(689085, 136, '2015-02-01 00:57:58.000000', 'consum', 0.0249, 'lps'),
	(689086, 136, '2015-02-01 00:57:59.000000', 'consum', 0.0267, 'lps'),
	(689087, 136, '2015-02-01 00:58:00.000000', 'consum', 0.0249, 'lps'),
	(689088, 136, '2015-02-01 00:58:01.000000', 'consum', 0.0232, 'lps'),
	(689089, 136, '2015-02-01 00:58:02.000000', 'consum', 0.0268, 'lps'),
	(689090, 136, '2015-02-01 00:58:03.000000', 'consum', 0.0240, 'lps'),
	(689091, 136, '2015-02-01 00:58:04.000000', 'consum', 0.0251, 'lps'),
	(689092, 136, '2015-02-01 00:58:05.000000', 'consum', 0.0263, 'lps'),
	(689093, 136, '2015-02-01 00:58:06.000000', 'consum', 0.0220, 'lps'),
	(689094, 136, '2015-02-01 00:58:07.000000', 'consum', 0.0232, 'lps'),
	(689095, 136, '2015-02-01 00:58:08.000000', 'consum', 0.0225, 'lps'),
	(689096, 136, '2015-02-01 00:58:09.000000', 'consum', 0.0219, 'lps'),
	(689097, 136, '2015-02-01 00:58:10.000000', 'consum', 0.0211, 'lps'),
	(689098, 136, '2015-02-01 00:58:11.000000', 'consum', 0.0252, 'lps'),
	(689099, 136, '2015-02-01 00:58:12.000000', 'consum', 0.0224, 'lps'),
	(689100, 136, '2015-02-01 00:58:13.000000', 'consum', 0.0220, 'lps'),
	(689101, 136, '2015-02-01 00:58:14.000000', 'consum', 0.0219, 'lps'),
	(689102, 136, '2015-02-01 00:58:15.000000', 'consum', 0.0227, 'lps'),
	(689103, 136, '2015-02-01 00:58:16.000000', 'consum', 0.0265, 'lps'),
	(689104, 136, '2015-02-01 00:58:17.000000', 'consum', 0.0242, 'lps'),
	(689105, 136, '2015-02-01 00:58:18.000000', 'consum', 0.0268, 'lps'),
	(689106, 136, '2015-02-01 00:58:19.000000', 'consum', 0.0211, 'lps'),
	(689107, 136, '2015-02-01 00:58:20.000000', 'consum', 0.0237, 'lps'),
	(689108, 136, '2015-02-01 00:58:21.000000', 'consum', 0.0213, 'lps'),
	(689109, 136, '2015-02-01 00:58:22.000000', 'consum', 0.0273, 'lps'),
	(689110, 136, '2015-02-01 00:58:23.000000', 'consum', 0.0256, 'lps'),
	(689111, 136, '2015-02-01 00:58:24.000000', 'consum', 0.0250, 'lps'),
	(689112, 136, '2015-02-01 00:58:25.000000', 'consum', 0.0210, 'lps'),
	(689113, 136, '2015-02-01 00:58:26.000000', 'consum', 0.0219, 'lps'),
	(689114, 136, '2015-02-01 00:58:27.000000', 'consum', 0.0255, 'lps'),
	(689115, 136, '2015-02-01 00:58:28.000000', 'consum', 0.0216, 'lps'),
	(689116, 136, '2015-02-01 00:58:29.000000', 'consum', 0.0235, 'lps'),
	(689117, 136, '2015-02-01 00:58:30.000000', 'consum', 0.0251, 'lps'),
	(689118, 136, '2015-02-01 00:58:31.000000', 'consum', 0.0210, 'lps'),
	(689119, 136, '2015-02-01 00:58:32.000000', 'consum', 0.0217, 'lps'),
	(689120, 136, '2015-02-01 00:58:33.000000', 'consum', 0.0246, 'lps'),
	(689121, 136, '2015-02-01 00:58:34.000000', 'consum', 0.0241, 'lps'),
	(689122, 136, '2015-02-01 00:58:35.000000', 'consum', 0.0257, 'lps'),
	(689123, 136, '2015-02-01 00:58:36.000000', 'consum', 0.0222, 'lps'),
	(689124, 136, '2015-02-01 00:58:37.000000', 'consum', 0.0258, 'lps'),
	(689125, 136, '2015-02-01 00:58:38.000000', 'consum', 0.0221, 'lps'),
	(689126, 136, '2015-02-01 00:58:39.000000', 'consum', 0.0251, 'lps'),
	(689127, 136, '2015-02-01 00:58:40.000000', 'consum', 0.0254, 'lps'),
	(689128, 136, '2015-02-01 00:58:41.000000', 'consum', 0.0243, 'lps'),
	(689129, 136, '2015-02-01 00:58:42.000000', 'consum', 0.0242, 'lps'),
	(689130, 136, '2015-02-01 00:58:43.000000', 'consum', 0.0272, 'lps'),
	(689131, 136, '2015-02-01 00:58:44.000000', 'consum', 0.0231, 'lps'),
	(689132, 136, '2015-02-01 00:58:45.000000', 'consum', 0.0257, 'lps'),
	(689133, 136, '2015-02-01 00:58:46.000000', 'consum', 0.0253, 'lps'),
	(689134, 136, '2015-02-01 00:58:47.000000', 'consum', 0.0222, 'lps'),
	(689135, 136, '2015-02-01 00:58:48.000000', 'consum', 0.0268, 'lps'),
	(689136, 136, '2015-02-01 00:58:49.000000', 'consum', 0.0273, 'lps'),
	(689137, 136, '2015-02-01 00:58:50.000000', 'consum', 0.0218, 'lps'),
	(689138, 136, '2015-02-01 00:58:51.000000', 'consum', 0.0257, 'lps'),
	(689139, 136, '2015-02-01 00:58:52.000000', 'consum', 0.0229, 'lps'),
	(689140, 136, '2015-02-01 00:58:53.000000', 'consum', 0.0227, 'lps'),
	(689141, 136, '2015-02-01 00:58:54.000000', 'consum', 0.0241, 'lps'),
	(689142, 136, '2015-02-01 00:58:55.000000', 'consum', 0.0248, 'lps'),
	(689143, 136, '2015-02-01 00:58:56.000000', 'consum', 0.0243, 'lps'),
	(689144, 136, '2015-02-01 00:58:57.000000', 'consum', 0.0263, 'lps'),
	(689145, 136, '2015-02-01 00:58:58.000000', 'consum', 0.0247, 'lps'),
	(689146, 136, '2015-02-01 00:58:59.000000', 'consum', 0.0234, 'lps'),
	(689147, 136, '2015-02-01 00:59:00.000000', 'consum', 0.0219, 'lps'),
	(689148, 136, '2015-02-01 00:59:01.000000', 'consum', 0.0250, 'lps'),
	(689149, 136, '2015-02-01 00:59:02.000000', 'consum', 0.0254, 'lps'),
	(689150, 136, '2015-02-01 00:59:03.000000', 'consum', 0.0244, 'lps'),
	(689151, 136, '2015-02-01 00:59:04.000000', 'consum', 0.0249, 'lps'),
	(689152, 136, '2015-02-01 00:59:05.000000', 'consum', 0.0241, 'lps'),
	(689153, 136, '2015-02-01 00:59:06.000000', 'consum', 0.0245, 'lps'),
	(689154, 136, '2015-02-01 00:59:07.000000', 'consum', 0.0228, 'lps'),
	(689155, 136, '2015-02-01 00:59:08.000000', 'consum', 0.0263, 'lps'),
	(689156, 136, '2015-02-01 00:59:09.000000', 'consum', 0.0224, 'lps'),
	(689157, 136, '2015-02-01 00:59:10.000000', 'consum', 0.0254, 'lps'),
	(689158, 136, '2015-02-01 00:59:11.000000', 'consum', 0.0255, 'lps'),
	(689159, 136, '2015-02-01 00:59:12.000000', 'consum', 0.0242, 'lps'),
	(689160, 136, '2015-02-01 00:59:13.000000', 'consum', 0.0232, 'lps'),
	(689161, 136, '2015-02-01 00:59:14.000000', 'consum', 0.0227, 'lps'),
	(689162, 136, '2015-02-01 00:59:15.000000', 'consum', 0.0229, 'lps'),
	(689163, 136, '2015-02-01 00:59:16.000000', 'consum', 0.0256, 'lps'),
	(689164, 136, '2015-02-01 00:59:17.000000', 'consum', 0.0254, 'lps'),
	(689165, 136, '2015-02-01 00:59:18.000000', 'consum', 0.0226, 'lps'),
	(689166, 136, '2015-02-01 00:59:19.000000', 'consum', 0.0222, 'lps'),
	(689167, 136, '2015-02-01 00:59:20.000000', 'consum', 0.0224, 'lps'),
	(689168, 136, '2015-02-01 00:59:21.000000', 'consum', 0.0246, 'lps'),
	(689169, 136, '2015-02-01 00:59:22.000000', 'consum', 0.0219, 'lps'),
	(689170, 136, '2015-02-01 00:59:23.000000', 'consum', 0.0211, 'lps'),
	(689171, 136, '2015-02-01 00:59:24.000000', 'consum', 0.0253, 'lps'),
	(689172, 136, '2015-02-01 00:59:25.000000', 'consum', 0.0228, 'lps'),
	(689173, 136, '2015-02-01 00:59:26.000000', 'consum', 0.0237, 'lps'),
	(689174, 136, '2015-02-01 00:59:27.000000', 'consum', 0.0226, 'lps'),
	(689175, 136, '2015-02-01 00:59:28.000000', 'consum', 0.0210, 'lps'),
	(689176, 136, '2015-02-01 00:59:29.000000', 'consum', 0.0225, 'lps'),
	(689177, 136, '2015-02-01 00:59:30.000000', 'consum', 0.0223, 'lps'),
	(689178, 136, '2015-02-01 00:59:31.000000', 'consum', 0.0229, 'lps'),
	(689179, 136, '2015-02-01 00:59:32.000000', 'consum', 0.0267, 'lps'),
	(689180, 136, '2015-02-01 00:59:33.000000', 'consum', 0.0242, 'lps'),
	(689181, 136, '2015-02-01 00:59:34.000000', 'consum', 0.0267, 'lps'),
	(689182, 136, '2015-02-01 00:59:35.000000', 'consum', 0.0269, 'lps'),
	(689183, 136, '2015-02-01 00:59:36.000000', 'consum', 0.0270, 'lps'),
	(689184, 136, '2015-02-01 00:59:37.000000', 'consum', 0.0267, 'lps'),
	(689185, 136, '2015-02-01 00:59:38.000000', 'consum', 0.0252, 'lps'),
	(689186, 136, '2015-02-01 00:59:39.000000', 'consum', 0.0251, 'lps'),
	(689187, 136, '2015-02-01 00:59:40.000000', 'consum', 0.0221, 'lps'),
	(689188, 136, '2015-02-01 00:59:41.000000', 'consum', 0.0274, 'lps'),
	(689189, 136, '2015-02-01 00:59:42.000000', 'consum', 0.0237, 'lps'),
	(689190, 136, '2015-02-01 00:59:43.000000', 'consum', 0.0220, 'lps'),
	(689191, 136, '2015-02-01 00:59:44.000000', 'consum', 0.0244, 'lps'),
	(689192, 136, '2015-02-01 00:59:45.000000', 'consum', 0.0221, 'lps'),
	(689193, 136, '2015-02-01 00:59:46.000000', 'consum', 0.0228, 'lps'),
	(689194, 136, '2015-02-01 00:59:47.000000', 'consum', 0.0266, 'lps'),
	(689195, 136, '2015-02-01 00:59:48.000000', 'consum', 0.0241, 'lps'),
	(689196, 136, '2015-02-01 00:59:49.000000', 'consum', 0.0262, 'lps'),
	(689197, 136, '2015-02-01 00:59:50.000000', 'consum', 0.0250, 'lps'),
	(689198, 136, '2015-02-01 00:59:51.000000', 'consum', 0.0254, 'lps'),
	(689199, 136, '2015-02-01 00:59:52.000000', 'consum', 0.0244, 'lps'),
	(689200, 136, '2015-02-01 00:59:53.000000', 'consum', 0.0249, 'lps'),
	(689201, 136, '2015-02-01 00:59:54.000000', 'consum', 0.0239, 'lps'),
	(689202, 136, '2015-02-01 00:59:55.000000', 'consum', 0.0238, 'lps'),
	(689203, 136, '2015-02-01 00:59:56.000000', 'consum', 0.0264, 'lps'),
	(689204, 136, '2015-02-01 00:59:57.000000', 'consum', 0.0268, 'lps'),
	(689205, 136, '2015-02-01 00:59:58.000000', 'consum', 0.0273, 'lps'),
	(689206, 136, '2015-02-01 00:59:59.000000', 'consum', 0.0220, 'lps'),
	(689207, 136, '2015-02-01 01:00:00.000000', 'consum', 0.0269, 'lps'),
	(689208, 136, '2015-02-01 01:00:01.000000', 'consum', 0.0213, 'lps'),
	(689209, 136, '2015-02-01 01:00:02.000000', 'consum', 0.0243, 'lps'),
	(689210, 136, '2015-02-01 01:00:03.000000', 'consum', 0.0238, 'lps'),
	(689211, 136, '2015-02-01 01:00:04.000000', 'consum', 0.0250, 'lps'),
	(689212, 136, '2015-02-01 01:00:05.000000', 'consum', 0.0263, 'lps'),
	(689213, 136, '2015-02-01 01:00:06.000000', 'consum', 0.0224, 'lps'),
	(689214, 136, '2015-02-01 01:00:07.000000', 'consum', 0.0251, 'lps'),
	(689215, 136, '2015-02-01 01:00:08.000000', 'consum', 0.0243, 'lps'),
	(689216, 136, '2015-02-01 01:00:09.000000', 'consum', 0.0255, 'lps'),
	(689217, 136, '2015-02-01 01:00:10.000000', 'consum', 0.0268, 'lps'),
	(689218, 136, '2015-02-01 01:00:11.000000', 'consum', 0.0238, 'lps'),
	(689219, 136, '2015-02-01 01:00:12.000000', 'consum', 0.0242, 'lps'),
	(689220, 136, '2015-02-01 01:00:13.000000', 'consum', 0.0221, 'lps'),
	(689221, 136, '2015-02-01 01:00:14.000000', 'consum', 0.0236, 'lps'),
	(689222, 136, '2015-02-01 01:00:15.000000', 'consum', 0.0241, 'lps'),
	(689223, 136, '2015-02-01 01:00:16.000000', 'consum', 0.0224, 'lps'),
	(689224, 136, '2015-02-01 01:00:17.000000', 'consum', 0.0250, 'lps'),
	(689225, 136, '2015-02-01 01:00:18.000000', 'consum', 0.0239, 'lps'),
	(689226, 136, '2015-02-01 01:00:19.000000', 'consum', 0.0238, 'lps'),
	(689227, 136, '2015-02-01 01:00:20.000000', 'consum', 0.0261, 'lps'),
	(689228, 136, '2015-02-01 01:00:21.000000', 'consum', 0.0252, 'lps'),
	(689229, 136, '2015-02-01 01:00:22.000000', 'consum', 0.0268, 'lps'),
	(689230, 136, '2015-02-01 01:00:23.000000', 'consum', 0.0244, 'lps'),
	(689231, 136, '2015-02-01 01:00:24.000000', 'consum', 0.0271, 'lps'),
	(689232, 136, '2015-02-01 01:00:25.000000', 'consum', 0.0217, 'lps'),
	(689233, 136, '2015-02-01 01:00:26.000000', 'consum', 0.0258, 'lps'),
	(689234, 136, '2015-02-01 01:00:27.000000', 'consum', 0.0237, 'lps'),
	(689235, 136, '2015-02-01 01:00:28.000000', 'consum', 0.0266, 'lps'),
	(689236, 136, '2015-02-01 01:00:29.000000', 'consum', 0.0214, 'lps'),
	(689237, 136, '2015-02-01 01:00:30.000000', 'consum', 0.0259, 'lps'),
	(689238, 136, '2015-02-01 01:00:31.000000', 'consum', 0.0247, 'lps'),
	(689239, 136, '2015-02-01 01:00:32.000000', 'consum', 0.0251, 'lps'),
	(689240, 136, '2015-02-01 01:00:33.000000', 'consum', 0.0237, 'lps'),
	(689241, 136, '2015-02-01 01:00:34.000000', 'consum', 0.0225, 'lps'),
	(689242, 136, '2015-02-01 01:00:35.000000', 'consum', 0.0267, 'lps'),
	(689243, 136, '2015-02-01 01:00:36.000000', 'consum', 0.0255, 'lps'),
	(689244, 136, '2015-02-01 01:00:37.000000', 'consum', 0.0265, 'lps'),
	(689245, 136, '2015-02-01 01:00:38.000000', 'consum', 0.0220, 'lps'),
	(689246, 136, '2015-02-01 01:00:39.000000', 'consum', 0.0226, 'lps'),
	(689247, 136, '2015-02-01 01:00:40.000000', 'consum', 0.0259, 'lps'),
	(689248, 136, '2015-02-01 01:00:41.000000', 'consum', 0.0213, 'lps'),
	(689249, 136, '2015-02-01 01:00:42.000000', 'consum', 0.0274, 'lps'),
	(689250, 136, '2015-02-01 01:00:43.000000', 'consum', 0.0261, 'lps'),
	(689251, 136, '2015-02-01 01:00:44.000000', 'consum', 0.0210, 'lps'),
	(689252, 136, '2015-02-01 01:00:45.000000', 'consum', 0.0252, 'lps'),
	(689253, 136, '2015-02-01 01:00:46.000000', 'consum', 0.0224, 'lps'),
	(689254, 136, '2015-02-01 01:00:47.000000', 'consum', 0.0222, 'lps'),
	(689255, 136, '2015-02-01 01:00:48.000000', 'consum', 0.0226, 'lps'),
	(689256, 136, '2015-02-01 01:00:49.000000', 'consum', 0.0255, 'lps'),
	(689257, 136, '2015-02-01 01:00:50.000000', 'consum', 0.0259, 'lps'),
	(689258, 136, '2015-02-01 01:00:51.000000', 'consum', 0.0256, 'lps'),
	(689259, 136, '2015-02-01 01:00:52.000000', 'consum', 0.0227, 'lps'),
	(689260, 136, '2015-02-01 01:00:53.000000', 'consum', 0.0221, 'lps'),
	(689261, 136, '2015-02-01 01:00:54.000000', 'consum', 0.0217, 'lps'),
	(689262, 136, '2015-02-01 01:00:55.000000', 'consum', 0.0211, 'lps'),
	(689263, 136, '2015-02-01 01:00:56.000000', 'consum', 0.0258, 'lps'),
	(689264, 136, '2015-02-01 01:00:57.000000', 'consum', 0.0255, 'lps'),
	(689265, 136, '2015-02-01 01:00:58.000000', 'consum', 0.0225, 'lps'),
	(689266, 136, '2015-02-01 01:00:59.000000', 'consum', 0.0215, 'lps'),
	(689267, 136, '2015-02-01 01:01:00.000000', 'consum', 0.0255, 'lps'),
	(689268, 136, '2015-02-01 01:01:01.000000', 'consum', 0.0227, 'lps'),
	(689269, 136, '2015-02-01 01:01:02.000000', 'consum', 0.0224, 'lps'),
	(689270, 136, '2015-02-01 01:01:03.000000', 'consum', 0.0228, 'lps'),
	(689271, 136, '2015-02-01 01:01:04.000000', 'consum', 0.0262, 'lps'),
	(689272, 136, '2015-02-01 01:01:05.000000', 'consum', 0.0219, 'lps'),
	(689273, 136, '2015-02-01 01:01:06.000000', 'consum', 0.0230, 'lps'),
	(689274, 136, '2015-02-01 01:01:07.000000', 'consum', 0.0220, 'lps'),
	(689275, 136, '2015-02-01 01:01:08.000000', 'consum', 0.0263, 'lps'),
	(689276, 136, '2015-02-01 01:01:09.000000', 'consum', 0.0253, 'lps'),
	(689277, 136, '2015-02-01 01:01:10.000000', 'consum', 0.0267, 'lps'),
	(689278, 136, '2015-02-01 01:01:11.000000', 'consum', 0.0234, 'lps'),
	(689279, 136, '2015-02-01 01:01:12.000000', 'consum', 0.0227, 'lps'),
	(689280, 136, '2015-02-01 01:01:13.000000', 'consum', 0.0223, 'lps'),
	(689281, 136, '2015-02-01 01:01:14.000000', 'consum', 0.0223, 'lps'),
	(689282, 136, '2015-02-01 01:01:15.000000', 'consum', 0.0237, 'lps'),
	(689283, 136, '2015-02-01 01:01:16.000000', 'consum', 0.0242, 'lps'),
	(689284, 136, '2015-02-01 01:01:17.000000', 'consum', 0.0223, 'lps'),
	(689285, 136, '2015-02-01 01:01:18.000000', 'consum', 0.0245, 'lps'),
	(689286, 136, '2015-02-01 01:01:19.000000', 'consum', 0.0218, 'lps'),
	(689287, 136, '2015-02-01 01:01:20.000000', 'consum', 0.0274, 'lps'),
	(689288, 136, '2015-02-01 01:01:21.000000', 'consum', 0.0246, 'lps'),
	(689289, 136, '2015-02-01 01:01:22.000000', 'consum', 0.0264, 'lps'),
	(689290, 136, '2015-02-01 01:01:23.000000', 'consum', 0.0241, 'lps'),
	(689291, 136, '2015-02-01 01:01:24.000000', 'consum', 0.0268, 'lps'),
	(689292, 136, '2015-02-01 01:01:25.000000', 'consum', 0.0215, 'lps'),
	(689293, 136, '2015-02-01 01:01:26.000000', 'consum', 0.0257, 'lps'),
	(689294, 136, '2015-02-01 01:01:27.000000', 'consum', 0.0235, 'lps'),
	(689295, 136, '2015-02-01 01:01:28.000000', 'consum', 0.0261, 'lps'),
	(689296, 136, '2015-02-01 01:01:29.000000', 'consum', 0.0260, 'lps'),
	(689297, 136, '2015-02-01 01:01:30.000000', 'consum', 0.0243, 'lps'),
	(689298, 136, '2015-02-01 01:01:31.000000', 'consum', 0.0223, 'lps'),
	(689299, 136, '2015-02-01 01:01:32.000000', 'consum', 0.0242, 'lps'),
	(689300, 136, '2015-02-01 01:01:33.000000', 'consum', 0.0266, 'lps'),
	(689301, 136, '2015-02-01 01:01:34.000000', 'consum', 0.0263, 'lps'),
	(689302, 136, '2015-02-01 01:01:35.000000', 'consum', 0.0245, 'lps'),
	(689303, 136, '2015-02-01 01:01:36.000000', 'consum', 0.0227, 'lps'),
	(689304, 136, '2015-02-01 01:01:37.000000', 'consum', 0.0256, 'lps'),
	(689305, 136, '2015-02-01 01:01:38.000000', 'consum', 0.0260, 'lps'),
	(689306, 136, '2015-02-01 01:01:39.000000', 'consum', 0.0257, 'lps'),
	(689307, 136, '2015-02-01 01:01:40.000000', 'consum', 0.0229, 'lps'),
	(689308, 136, '2015-02-01 01:01:41.000000', 'consum', 0.0232, 'lps'),
	(689309, 136, '2015-02-01 01:01:42.000000', 'consum', 0.0264, 'lps'),
	(689310, 136, '2015-02-01 01:01:43.000000', 'consum', 0.0219, 'lps'),
	(689311, 136, '2015-02-01 01:01:44.000000', 'consum', 0.0222, 'lps'),
	(689312, 136, '2015-02-01 01:01:45.000000', 'consum', 0.0246, 'lps'),
	(689313, 136, '2015-02-01 01:01:46.000000', 'consum', 0.0223, 'lps'),
	(689314, 136, '2015-02-01 01:01:47.000000', 'consum', 0.0233, 'lps'),
	(689315, 136, '2015-02-01 01:01:48.000000', 'consum', 0.0221, 'lps'),
	(689316, 136, '2015-02-01 01:01:49.000000', 'consum', 0.0263, 'lps'),
	(689317, 136, '2015-02-01 01:01:50.000000', 'consum', 0.0247, 'lps'),
	(689318, 136, '2015-02-01 01:01:51.000000', 'consum', 0.0238, 'lps'),
	(689319, 136, '2015-02-01 01:01:52.000000', 'consum', 0.0239, 'lps'),
	(689320, 136, '2015-02-01 01:01:53.000000', 'consum', 0.0273, 'lps'),
	(689321, 136, '2015-02-01 01:01:54.000000', 'consum', 0.0242, 'lps'),
	(689322, 136, '2015-02-01 01:01:55.000000', 'consum', 0.0249, 'lps'),
	(689323, 136, '2015-02-01 01:01:56.000000', 'consum', 0.0241, 'lps'),
	(689324, 136, '2015-02-01 01:01:57.000000', 'consum', 0.0251, 'lps'),
	(689325, 136, '2015-02-01 01:01:58.000000', 'consum', 0.0259, 'lps'),
	(689326, 136, '2015-02-01 01:01:59.000000', 'consum', 0.0265, 'lps'),
	(689327, 136, '2015-02-01 01:02:00.000000', 'consum', 0.0274, 'lps'),
	(689328, 136, '2015-02-01 01:02:01.000000', 'consum', 0.0234, 'lps'),
	(689329, 136, '2015-02-01 01:02:02.000000', 'consum', 0.0271, 'lps'),
	(689330, 136, '2015-02-01 01:02:03.000000', 'consum', 0.0249, 'lps'),
	(689331, 136, '2015-02-01 01:02:04.000000', 'consum', 0.0220, 'lps'),
	(689332, 136, '2015-02-01 01:02:05.000000', 'consum', 0.0274, 'lps'),
	(689333, 136, '2015-02-01 01:02:06.000000', 'consum', 0.0242, 'lps'),
	(689334, 136, '2015-02-01 01:02:07.000000', 'consum', 0.0241, 'lps'),
	(689335, 136, '2015-02-01 01:02:08.000000', 'consum', 0.0273, 'lps'),
	(689336, 136, '2015-02-01 01:02:09.000000', 'consum', 0.0235, 'lps'),
	(689337, 136, '2015-02-01 01:02:10.000000', 'consum', 0.0213, 'lps'),
	(689338, 136, '2015-02-01 01:02:11.000000', 'consum', 0.0213, 'lps'),
	(689339, 136, '2015-02-01 01:02:12.000000', 'consum', 0.0218, 'lps'),
	(689340, 136, '2015-02-01 01:02:13.000000', 'consum', 0.0241, 'lps'),
	(689341, 136, '2015-02-01 01:02:14.000000', 'consum', 0.0210, 'lps'),
	(689342, 136, '2015-02-01 01:02:15.000000', 'consum', 0.0247, 'lps'),
	(689343, 136, '2015-02-01 01:02:16.000000', 'consum', 0.0269, 'lps'),
	(689344, 136, '2015-02-01 01:02:17.000000', 'consum', 0.0261, 'lps'),
	(689345, 136, '2015-02-01 01:02:18.000000', 'consum', 0.0225, 'lps'),
	(689346, 136, '2015-02-01 01:02:19.000000', 'consum', 0.0263, 'lps'),
	(689347, 136, '2015-02-01 01:02:20.000000', 'consum', 0.0236, 'lps'),
	(689348, 136, '2015-02-01 01:02:21.000000', 'consum', 0.0245, 'lps'),
	(689349, 136, '2015-02-01 01:02:22.000000', 'consum', 0.0243, 'lps'),
	(689350, 136, '2015-02-01 01:02:23.000000', 'consum', 0.0272, 'lps'),
	(689351, 136, '2015-02-01 01:02:24.000000', 'consum', 0.0224, 'lps'),
	(689352, 136, '2015-02-01 01:02:25.000000', 'consum', 0.0227, 'lps'),
	(689353, 136, '2015-02-01 01:02:26.000000', 'consum', 0.0253, 'lps'),
	(689354, 136, '2015-02-01 01:02:27.000000', 'consum', 0.0243, 'lps'),
	(689355, 136, '2015-02-01 01:02:28.000000', 'consum', 0.0245, 'lps'),
	(689356, 136, '2015-02-01 01:02:29.000000', 'consum', 0.0224, 'lps'),
	(689357, 136, '2015-02-01 01:02:30.000000', 'consum', 0.0240, 'lps'),
	(689358, 136, '2015-02-01 01:02:31.000000', 'consum', 0.0254, 'lps'),
	(689359, 136, '2015-02-01 01:02:32.000000', 'consum', 0.0211, 'lps'),
	(689360, 136, '2015-02-01 01:02:33.000000', 'consum', 0.0211, 'lps'),
	(689361, 136, '2015-02-01 01:02:34.000000', 'consum', 0.0215, 'lps'),
	(689362, 136, '2015-02-01 01:02:35.000000', 'consum', 0.0233, 'lps'),
	(689363, 136, '2015-02-01 01:02:36.000000', 'consum', 0.0244, 'lps'),
	(689364, 136, '2015-02-01 01:02:37.000000', 'consum', 0.0247, 'lps'),
	(689365, 136, '2015-02-01 01:02:38.000000', 'consum', 0.0229, 'lps'),
	(689366, 136, '2015-02-01 01:02:39.000000', 'consum', 0.0257, 'lps'),
	(689367, 136, '2015-02-01 01:02:40.000000', 'consum', 0.0260, 'lps'),
	(689368, 136, '2015-02-01 01:02:41.000000', 'consum', 0.0254, 'lps'),
	(689369, 136, '2015-02-01 01:02:42.000000', 'consum', 0.0217, 'lps'),
	(689370, 136, '2015-02-01 01:02:43.000000', 'consum', 0.0241, 'lps'),
	(689371, 136, '2015-02-01 01:02:44.000000', 'consum', 0.0216, 'lps'),
	(689372, 136, '2015-02-01 01:02:45.000000', 'consum', 0.0212, 'lps'),
	(689373, 136, '2015-02-01 01:02:46.000000', 'consum', 0.0266, 'lps'),
	(689374, 136, '2015-02-01 01:02:47.000000', 'consum', 0.0226, 'lps'),
	(689375, 136, '2015-02-01 01:02:48.000000', 'consum', 0.0251, 'lps'),
	(689376, 136, '2015-02-01 01:02:49.000000', 'consum', 0.0238, 'lps'),
	(689377, 136, '2015-02-01 01:02:50.000000', 'consum', 0.0227, 'lps'),
	(689378, 136, '2015-02-01 01:02:51.000000', 'consum', 0.0214, 'lps'),
	(689379, 136, '2015-02-01 01:02:52.000000', 'consum', 0.0242, 'lps'),
	(689380, 136, '2015-02-01 01:02:53.000000', 'consum', 0.0229, 'lps'),
	(689381, 136, '2015-02-01 01:02:54.000000', 'consum', 0.0210, 'lps'),
	(689382, 136, '2015-02-01 01:02:55.000000', 'consum', 0.0220, 'lps'),
	(689383, 136, '2015-02-01 01:02:56.000000', 'consum', 0.0258, 'lps'),
	(689384, 136, '2015-02-01 01:02:57.000000', 'consum', 0.0227, 'lps'),
	(689385, 136, '2015-02-01 01:02:58.000000', 'consum', 0.0218, 'lps'),
	(689386, 136, '2015-02-01 01:02:59.000000', 'consum', 0.0262, 'lps'),
	(689387, 136, '2015-02-01 01:03:00.000000', 'consum', 0.0252, 'lps'),
	(689388, 136, '2015-02-01 01:03:01.000000', 'consum', 0.0264, 'lps'),
	(689389, 136, '2015-02-01 01:03:02.000000', 'consum', 0.0224, 'lps'),
	(689390, 136, '2015-02-01 01:03:03.000000', 'consum', 0.0250, 'lps'),
	(689391, 136, '2015-02-01 01:03:04.000000', 'consum', 0.0240, 'lps'),
	(689392, 136, '2015-02-01 01:03:05.000000', 'consum', 0.0237, 'lps'),
	(689393, 136, '2015-02-01 01:03:06.000000', 'consum', 0.0257, 'lps'),
	(689394, 136, '2015-02-01 01:03:07.000000', 'consum', 0.0234, 'lps'),
	(689395, 136, '2015-02-01 01:03:08.000000', 'consum', 0.0257, 'lps'),
	(689396, 136, '2015-02-01 01:03:09.000000', 'consum', 0.0241, 'lps'),
	(689397, 136, '2015-02-01 01:03:10.000000', 'consum', 0.0227, 'lps'),
	(689398, 136, '2015-02-01 01:03:11.000000', 'consum', 0.0265, 'lps'),
	(689399, 136, '2015-02-01 01:03:12.000000', 'consum', 0.0242, 'lps'),
	(689400, 136, '2015-02-01 01:03:13.000000', 'consum', 0.0270, 'lps'),
	(689401, 136, '2015-02-01 01:03:14.000000', 'consum', 0.0218, 'lps'),
	(689402, 136, '2015-02-01 01:03:15.000000', 'consum', 0.0266, 'lps'),
	(689403, 136, '2015-02-01 01:03:16.000000', 'consum', 0.0272, 'lps'),
	(689404, 136, '2015-02-01 01:03:17.000000', 'consum', 0.0221, 'lps'),
	(689405, 136, '2015-02-01 01:03:18.000000', 'consum', 0.0273, 'lps'),
	(689406, 136, '2015-02-01 01:03:19.000000', 'consum', 0.0236, 'lps'),
	(689407, 136, '2015-02-01 01:03:20.000000', 'consum', 0.0215, 'lps'),
	(689408, 136, '2015-02-01 01:03:21.000000', 'consum', 0.0224, 'lps'),
	(689409, 136, '2015-02-01 01:03:22.000000', 'consum', 0.0266, 'lps'),
	(689410, 136, '2015-02-01 01:03:23.000000', 'consum', 0.0252, 'lps'),
	(689411, 136, '2015-02-01 01:03:24.000000', 'consum', 0.0252, 'lps'),
	(689412, 136, '2015-02-01 01:03:25.000000', 'consum', 0.0231, 'lps'),
	(689413, 136, '2015-02-01 01:03:26.000000', 'consum', 0.0255, 'lps'),
	(689414, 136, '2015-02-01 01:03:27.000000', 'consum', 0.0243, 'lps'),
	(689415, 136, '2015-02-01 01:03:28.000000', 'consum', 0.0238, 'lps'),
	(689416, 136, '2015-02-01 01:03:29.000000', 'consum', 0.0252, 'lps'),
	(689417, 136, '2015-02-01 01:03:30.000000', 'consum', 0.0270, 'lps'),
	(689418, 136, '2015-02-01 01:03:31.000000', 'consum', 0.0258, 'lps'),
	(689419, 136, '2015-02-01 01:03:32.000000', 'consum', 0.0269, 'lps'),
	(689420, 136, '2015-02-01 01:03:33.000000', 'consum', 0.0230, 'lps'),
	(689421, 136, '2015-02-01 01:03:34.000000', 'consum', 0.0266, 'lps'),
	(689422, 136, '2015-02-01 01:03:35.000000', 'consum', 0.0233, 'lps'),
	(689423, 136, '2015-02-01 01:03:36.000000', 'consum', 0.0225, 'lps'),
	(689424, 136, '2015-02-01 01:03:37.000000', 'consum', 0.0216, 'lps'),
	(689425, 136, '2015-02-01 01:03:38.000000', 'consum', 0.0259, 'lps'),
	(689426, 136, '2015-02-01 01:03:39.000000', 'consum', 0.0243, 'lps'),
	(689427, 136, '2015-02-01 01:03:40.000000', 'consum', 0.0227, 'lps'),
	(689428, 136, '2015-02-01 01:03:41.000000', 'consum', 0.0263, 'lps'),
	(689429, 136, '2015-02-01 01:03:42.000000', 'consum', 0.0229, 'lps'),
	(689430, 136, '2015-02-01 01:03:43.000000', 'consum', 0.0213, 'lps'),
	(689431, 136, '2015-02-01 01:03:44.000000', 'consum', 0.0231, 'lps'),
	(689432, 136, '2015-02-01 01:03:45.000000', 'consum', 0.0244, 'lps'),
	(689433, 136, '2015-02-01 01:03:46.000000', 'consum', 0.0250, 'lps'),
	(689434, 136, '2015-02-01 01:03:47.000000', 'consum', 0.0245, 'lps'),
	(689435, 136, '2015-02-01 01:03:48.000000', 'consum', 0.0267, 'lps'),
	(689436, 136, '2015-02-01 01:03:49.000000', 'consum', 0.0258, 'lps'),
	(689437, 136, '2015-02-01 01:03:50.000000', 'consum', 0.0214, 'lps'),
	(689438, 136, '2015-02-01 01:03:51.000000', 'consum', 0.0216, 'lps'),
	(689439, 136, '2015-02-01 01:03:52.000000', 'consum', 0.0230, 'lps'),
	(689440, 136, '2015-02-01 01:03:53.000000', 'consum', 0.0225, 'lps'),
	(689441, 136, '2015-02-01 01:03:54.000000', 'consum', 0.0228, 'lps'),
	(689442, 136, '2015-02-01 01:03:55.000000', 'consum', 0.0257, 'lps'),
	(689443, 136, '2015-02-01 01:03:56.000000', 'consum', 0.0258, 'lps'),
	(689444, 136, '2015-02-01 01:03:57.000000', 'consum', 0.0245, 'lps'),
	(689445, 136, '2015-02-01 01:03:58.000000', 'consum', 0.0243, 'lps'),
	(689446, 136, '2015-02-01 01:03:59.000000', 'consum', 0.0268, 'lps'),
	(689447, 136, '2015-02-01 01:04:00.000000', 'consum', 0.0273, 'lps'),
	(689448, 136, '2015-02-01 01:04:01.000000', 'consum', 0.0221, 'lps'),
	(689449, 136, '2015-02-01 01:04:02.000000', 'consum', 0.0272, 'lps'),
	(689450, 136, '2015-02-01 01:04:03.000000', 'consum', 0.0227, 'lps'),
	(689451, 136, '2015-02-01 01:04:04.000000', 'consum', 0.0239, 'lps'),
	(689452, 136, '2015-02-01 01:04:05.000000', 'consum', 0.0238, 'lps'),
	(689453, 136, '2015-02-01 01:04:06.000000', 'consum', 0.0266, 'lps'),
	(689454, 136, '2015-02-01 01:04:07.000000', 'consum', 0.0211, 'lps'),
	(689455, 136, '2015-02-01 01:04:08.000000', 'consum', 0.0242, 'lps'),
	(689456, 136, '2015-02-01 01:04:09.000000', 'consum', 0.0239, 'lps'),
	(689457, 136, '2015-02-01 01:04:10.000000', 'consum', 0.0260, 'lps'),
	(689458, 136, '2015-02-01 01:04:11.000000', 'consum', 0.0243, 'lps'),
	(689459, 136, '2015-02-01 01:04:12.000000', 'consum', 0.0223, 'lps'),
	(689460, 136, '2015-02-01 01:04:13.000000', 'consum', 0.0244, 'lps'),
	(689461, 136, '2015-02-01 01:04:14.000000', 'consum', 0.0212, 'lps'),
	(689462, 136, '2015-02-01 01:04:15.000000', 'consum', 0.0246, 'lps'),
	(689463, 136, '2015-02-01 01:04:16.000000', 'consum', 0.0256, 'lps'),
	(689464, 136, '2015-02-01 01:04:17.000000', 'consum', 0.0268, 'lps'),
	(689465, 136, '2015-02-01 01:04:18.000000', 'consum', 0.0230, 'lps'),
	(689466, 136, '2015-02-01 01:04:19.000000', 'consum', 0.0270, 'lps'),
	(689467, 136, '2015-02-01 01:04:20.000000', 'consum', 0.0254, 'lps'),
	(689468, 136, '2015-02-01 01:04:21.000000', 'consum', 0.0248, 'lps'),
	(689469, 136, '2015-02-01 01:04:22.000000', 'consum', 0.0272, 'lps'),
	(689470, 136, '2015-02-01 01:04:23.000000', 'consum', 0.0212, 'lps'),
	(689471, 136, '2015-02-01 01:04:24.000000', 'consum', 0.0227, 'lps'),
	(689472, 136, '2015-02-01 01:04:25.000000', 'consum', 0.0225, 'lps'),
	(689473, 136, '2015-02-01 01:04:26.000000', 'consum', 0.0233, 'lps'),
	(689474, 136, '2015-02-01 01:04:27.000000', 'consum', 0.0217, 'lps'),
	(689475, 136, '2015-02-01 01:04:28.000000', 'consum', 0.0240, 'lps'),
	(689476, 136, '2015-02-01 01:04:29.000000', 'consum', 0.0211, 'lps'),
	(689477, 136, '2015-02-01 01:04:30.000000', 'consum', 0.0255, 'lps'),
	(689478, 136, '2015-02-01 01:04:31.000000', 'consum', 0.0237, 'lps'),
	(689479, 136, '2015-02-01 01:04:32.000000', 'consum', 0.0210, 'lps'),
	(689480, 136, '2015-02-01 01:04:33.000000', 'consum', 0.0258, 'lps'),
	(689481, 136, '2015-02-01 01:04:34.000000', 'consum', 0.0257, 'lps'),
	(689482, 136, '2015-02-01 01:04:35.000000', 'consum', 0.0237, 'lps'),
	(689483, 136, '2015-02-01 01:04:36.000000', 'consum', 0.0268, 'lps'),
	(689484, 136, '2015-02-01 01:04:37.000000', 'consum', 0.0227, 'lps'),
	(689485, 136, '2015-02-01 01:04:38.000000', 'consum', 0.0249, 'lps'),
	(689486, 136, '2015-02-01 01:04:39.000000', 'consum', 0.0227, 'lps'),
	(689487, 136, '2015-02-01 01:04:40.000000', 'consum', 0.0241, 'lps'),
	(689488, 136, '2015-02-01 01:04:41.000000', 'consum', 0.0251, 'lps'),
	(689489, 136, '2015-02-01 01:04:42.000000', 'consum', 0.0256, 'lps'),
	(689490, 136, '2015-02-01 01:04:43.000000', 'consum', 0.0254, 'lps'),
	(689491, 136, '2015-02-01 01:04:44.000000', 'consum', 0.0226, 'lps'),
	(689492, 136, '2015-02-01 01:04:45.000000', 'consum', 0.0224, 'lps'),
	(689493, 136, '2015-02-01 01:04:46.000000', 'consum', 0.0235, 'lps'),
	(689494, 136, '2015-02-01 01:04:47.000000', 'consum', 0.0226, 'lps'),
	(689495, 136, '2015-02-01 01:04:48.000000', 'consum', 0.0216, 'lps'),
	(689496, 136, '2015-02-01 01:04:49.000000', 'consum', 0.0257, 'lps'),
	(689497, 136, '2015-02-01 01:04:50.000000', 'consum', 0.0233, 'lps'),
	(689498, 136, '2015-02-01 01:04:51.000000', 'consum', 0.0248, 'lps'),
	(689499, 136, '2015-02-01 01:04:52.000000', 'consum', 0.0265, 'lps'),
	(689500, 136, '2015-02-01 01:04:53.000000', 'consum', 0.0245, 'lps'),
	(689501, 136, '2015-02-01 01:04:54.000000', 'consum', 0.0221, 'lps'),
	(689502, 136, '2015-02-01 01:04:55.000000', 'consum', 0.0223, 'lps'),
	(689503, 136, '2015-02-01 01:04:56.000000', 'consum', 0.0245, 'lps'),
	(689504, 136, '2015-02-01 01:04:57.000000', 'consum', 0.0217, 'lps'),
	(689505, 136, '2015-02-01 01:04:58.000000', 'consum', 0.0272, 'lps'),
	(689506, 136, '2015-02-01 01:04:59.000000', 'consum', 0.0236, 'lps'),
	(689507, 136, '2015-02-01 01:05:00.000000', 'consum', 0.0219, 'lps'),
	(689508, 136, '2015-02-01 01:05:01.000000', 'consum', 0.0244, 'lps'),
	(689509, 136, '2015-02-01 01:05:02.000000', 'consum', 0.0222, 'lps'),
	(689510, 136, '2015-02-01 01:05:03.000000', 'consum', 0.0234, 'lps'),
	(689511, 136, '2015-02-01 01:05:04.000000', 'consum', 0.0229, 'lps'),
	(689512, 136, '2015-02-01 01:05:05.000000', 'consum', 0.0234, 'lps'),
	(689513, 136, '2015-02-01 01:05:06.000000', 'consum', 0.0273, 'lps'),
	(689514, 136, '2015-02-01 01:05:07.000000', 'consum', 0.0258, 'lps'),
	(689515, 136, '2015-02-01 01:05:08.000000', 'consum', 0.0263, 'lps'),
	(689516, 136, '2015-02-01 01:05:09.000000', 'consum', 0.0265, 'lps'),
	(689517, 136, '2015-02-01 01:05:10.000000', 'consum', 0.0261, 'lps'),
	(689518, 136, '2015-02-01 01:05:11.000000', 'consum', 0.0235, 'lps'),
	(689519, 136, '2015-02-01 01:05:12.000000', 'consum', 0.0249, 'lps'),
	(689520, 136, '2015-02-01 01:05:13.000000', 'consum', 0.0264, 'lps'),
	(689521, 136, '2015-02-01 01:05:14.000000', 'consum', 0.0234, 'lps'),
	(689522, 136, '2015-02-01 01:05:15.000000', 'consum', 0.0235, 'lps'),
	(689523, 136, '2015-02-01 01:05:16.000000', 'consum', 0.0261, 'lps'),
	(689524, 136, '2015-02-01 01:05:17.000000', 'consum', 0.0261, 'lps'),
	(689525, 136, '2015-02-01 01:05:18.000000', 'consum', 0.0250, 'lps'),
	(689526, 136, '2015-02-01 01:05:19.000000', 'consum', 0.0255, 'lps'),
	(689527, 136, '2015-02-01 01:05:20.000000', 'consum', 0.0250, 'lps'),
	(689528, 136, '2015-02-01 01:05:21.000000', 'consum', 0.0213, 'lps'),
	(689529, 136, '2015-02-01 01:05:22.000000', 'consum', 0.0236, 'lps'),
	(689530, 136, '2015-02-01 01:05:23.000000', 'consum', 0.0264, 'lps'),
	(689531, 136, '2015-02-01 01:05:24.000000', 'consum', 0.0274, 'lps'),
	(689532, 136, '2015-02-01 01:05:25.000000', 'consum', 0.0239, 'lps'),
	(689533, 136, '2015-02-01 01:05:26.000000', 'consum', 0.0227, 'lps'),
	(689534, 136, '2015-02-01 01:05:27.000000', 'consum', 0.0274, 'lps'),
	(689535, 136, '2015-02-01 01:05:28.000000', 'consum', 0.0218, 'lps'),
	(689536, 136, '2015-02-01 01:05:29.000000', 'consum', 0.0253, 'lps'),
	(689537, 136, '2015-02-01 01:05:30.000000', 'consum', 0.0271, 'lps'),
	(689538, 136, '2015-02-01 01:05:31.000000', 'consum', 0.0257, 'lps'),
	(689539, 136, '2015-02-01 01:05:32.000000', 'consum', 0.0263, 'lps'),
	(689540, 136, '2015-02-01 01:05:33.000000', 'consum', 0.0271, 'lps'),
	(689541, 136, '2015-02-01 01:05:34.000000', 'consum', 0.0225, 'lps'),
	(689542, 136, '2015-02-01 01:05:35.000000', 'consum', 0.0234, 'lps'),
	(689543, 136, '2015-02-01 01:05:36.000000', 'consum', 0.0219, 'lps'),
	(689544, 136, '2015-02-01 01:05:37.000000', 'consum', 0.0247, 'lps'),
	(689545, 136, '2015-02-01 01:05:38.000000', 'consum', 0.0241, 'lps'),
	(689546, 136, '2015-02-01 01:05:39.000000', 'consum', 0.0252, 'lps'),
	(689547, 136, '2015-02-01 01:05:40.000000', 'consum', 0.0265, 'lps'),
	(689548, 136, '2015-02-01 01:05:41.000000', 'consum', 0.0227, 'lps'),
	(689549, 136, '2015-02-01 01:05:42.000000', 'consum', 0.0263, 'lps'),
	(689550, 136, '2015-02-01 01:05:43.000000', 'consum', 0.0229, 'lps'),
	(689551, 136, '2015-02-01 01:05:44.000000', 'consum', 0.0210, 'lps'),
	(689552, 136, '2015-02-01 01:05:45.000000', 'consum', 0.0220, 'lps'),
	(689553, 136, '2015-02-01 01:05:46.000000', 'consum', 0.0260, 'lps'),
	(689554, 136, '2015-02-01 01:05:47.000000', 'consum', 0.0237, 'lps'),
	(689555, 136, '2015-02-01 01:05:48.000000', 'consum', 0.0259, 'lps'),
	(689556, 136, '2015-02-01 01:05:49.000000', 'consum', 0.0247, 'lps'),
	(689557, 136, '2015-02-01 01:05:50.000000', 'consum', 0.0247, 'lps'),
	(689558, 136, '2015-02-01 01:05:51.000000', 'consum', 0.0217, 'lps'),
	(689559, 136, '2015-02-01 01:05:52.000000', 'consum', 0.0268, 'lps'),
	(689560, 136, '2015-02-01 01:05:53.000000', 'consum', 0.0219, 'lps'),
	(689561, 136, '2015-02-01 01:05:54.000000', 'consum', 0.0210, 'lps'),
	(689562, 136, '2015-02-01 01:05:55.000000', 'consum', 0.0248, 'lps'),
	(689563, 136, '2015-02-01 01:05:56.000000', 'consum', 0.0272, 'lps'),
	(689564, 136, '2015-02-01 01:05:57.000000', 'consum', 0.0210, 'lps'),
	(689565, 136, '2015-02-01 01:05:58.000000', 'consum', 0.0220, 'lps'),
	(689566, 136, '2015-02-01 01:05:59.000000', 'consum', 0.0259, 'lps'),
	(689567, 136, '2015-02-01 01:06:00.000000', 'consum', 0.0230, 'lps'),
	(689568, 136, '2015-02-01 01:06:01.000000', 'consum', 0.0231, 'lps'),
	(689569, 136, '2015-02-01 01:06:02.000000', 'consum', 0.0254, 'lps'),
	(689570, 136, '2015-02-01 01:06:03.000000', 'consum', 0.0238, 'lps'),
	(689571, 136, '2015-02-01 01:06:04.000000', 'consum', 0.0218, 'lps'),
	(689572, 136, '2015-02-01 01:06:05.000000', 'consum', 0.0233, 'lps'),
	(689573, 136, '2015-02-01 01:06:06.000000', 'consum', 0.0236, 'lps'),
	(689574, 136, '2015-02-01 01:06:07.000000', 'consum', 0.0272, 'lps'),
	(689575, 136, '2015-02-01 01:06:08.000000', 'consum', 0.0249, 'lps'),
	(689576, 136, '2015-02-01 01:06:09.000000', 'consum', 0.0216, 'lps'),
	(689577, 136, '2015-02-01 01:06:10.000000', 'consum', 0.0255, 'lps'),
	(689578, 136, '2015-02-01 01:06:11.000000', 'consum', 0.0224, 'lps'),
	(689579, 136, '2015-02-01 01:06:12.000000', 'consum', 0.0210, 'lps'),
	(689580, 136, '2015-02-01 01:06:13.000000', 'consum', 0.0234, 'lps'),
	(689581, 136, '2015-02-01 01:06:14.000000', 'consum', 0.0264, 'lps'),
	(689582, 136, '2015-02-01 01:06:15.000000', 'consum', 0.0213, 'lps'),
	(689583, 136, '2015-02-01 01:06:16.000000', 'consum', 0.0261, 'lps'),
	(689584, 136, '2015-02-01 01:06:17.000000', 'consum', 0.0260, 'lps'),
	(689585, 136, '2015-02-01 01:06:18.000000', 'consum', 0.0245, 'lps'),
	(689586, 136, '2015-02-01 01:06:19.000000', 'consum', 0.0233, 'lps'),
	(689587, 136, '2015-02-01 01:06:20.000000', 'consum', 0.0221, 'lps'),
	(689588, 136, '2015-02-01 01:06:21.000000', 'consum', 0.0263, 'lps'),
	(689589, 136, '2015-02-01 01:06:22.000000', 'consum', 0.0245, 'lps'),
	(689590, 136, '2015-02-01 01:06:23.000000', 'consum', 0.0228, 'lps'),
	(689591, 136, '2015-02-01 01:06:24.000000', 'consum', 0.0262, 'lps'),
	(689592, 136, '2015-02-01 01:06:25.000000', 'consum', 0.0219, 'lps'),
	(689593, 136, '2015-02-01 01:06:26.000000', 'consum', 0.0231, 'lps'),
	(689594, 136, '2015-02-01 01:06:27.000000', 'consum', 0.0223, 'lps'),
	(689595, 136, '2015-02-01 01:06:28.000000', 'consum', 0.0212, 'lps'),
	(689596, 136, '2015-02-01 01:06:29.000000', 'consum', 0.0245, 'lps'),
	(689597, 136, '2015-02-01 01:06:30.000000', 'consum', 0.0253, 'lps'),
	(689598, 136, '2015-02-01 01:06:31.000000', 'consum', 0.0254, 'lps'),
	(689599, 136, '2015-02-01 01:06:32.000000', 'consum', 0.0235, 'lps'),
	(689600, 136, '2015-02-01 01:06:33.000000', 'consum', 0.0270, 'lps'),
	(689601, 136, '2015-02-01 01:06:34.000000', 'consum', 0.0241, 'lps'),
	(689602, 136, '2015-02-01 01:06:35.000000', 'consum', 0.0249, 'lps'),
	(689603, 136, '2015-02-01 01:06:36.000000', 'consum', 0.0246, 'lps'),
	(689604, 136, '2015-02-01 01:06:37.000000', 'consum', 0.0210, 'lps'),
	(689605, 136, '2015-02-01 01:06:38.000000', 'consum', 0.0233, 'lps'),
	(689606, 136, '2015-02-01 01:06:39.000000', 'consum', 0.0262, 'lps'),
	(689607, 136, '2015-02-01 01:06:40.000000', 'consum', 0.0270, 'lps'),
	(689608, 136, '2015-02-01 01:06:41.000000', 'consum', 0.0226, 'lps'),
	(689609, 136, '2015-02-01 01:06:42.000000', 'consum', 0.0240, 'lps'),
	(689610, 136, '2015-02-01 01:06:43.000000', 'consum', 0.0248, 'lps'),
	(689611, 136, '2015-02-01 01:06:44.000000', 'consum', 0.0245, 'lps'),
	(689612, 136, '2015-02-01 01:06:45.000000', 'consum', 0.0271, 'lps'),
	(689613, 136, '2015-02-01 01:06:46.000000', 'consum', 0.0217, 'lps'),
	(689614, 136, '2015-02-01 01:06:47.000000', 'consum', 0.0255, 'lps'),
	(689615, 136, '2015-02-01 01:06:48.000000', 'consum', 0.0220, 'lps'),
	(689616, 136, '2015-02-01 01:06:49.000000', 'consum', 0.0255, 'lps'),
	(689617, 136, '2015-02-01 01:06:50.000000', 'consum', 0.0274, 'lps'),
	(689618, 136, '2015-02-01 01:06:51.000000', 'consum', 0.0268, 'lps'),
	(689619, 136, '2015-02-01 01:06:52.000000', 'consum', 0.0244, 'lps'),
	(689620, 136, '2015-02-01 01:06:53.000000', 'consum', 0.0273, 'lps'),
	(689621, 136, '2015-02-01 01:06:54.000000', 'consum', 0.0226, 'lps'),
	(689622, 136, '2015-02-01 01:06:55.000000', 'consum', 0.0231, 'lps'),
	(689623, 136, '2015-02-01 01:06:56.000000', 'consum', 0.0268, 'lps'),
	(689624, 136, '2015-02-01 01:06:57.000000', 'consum', 0.0244, 'lps'),
	(689625, 136, '2015-02-01 01:06:58.000000', 'consum', 0.0270, 'lps'),
	(689626, 136, '2015-02-01 01:06:59.000000', 'consum', 0.0212, 'lps'),
	(689627, 136, '2015-02-01 01:07:00.000000', 'consum', 0.0236, 'lps'),
	(689628, 136, '2015-02-01 01:07:01.000000', 'consum', 0.0271, 'lps'),
	(689629, 136, '2015-02-01 01:07:02.000000', 'consum', 0.0244, 'lps'),
	(689630, 136, '2015-02-01 01:07:03.000000', 'consum', 0.0260, 'lps'),
	(689631, 136, '2015-02-01 01:07:04.000000', 'consum', 0.0228, 'lps'),
	(689632, 136, '2015-02-01 01:07:05.000000', 'consum', 0.0215, 'lps'),
	(689633, 136, '2015-02-01 01:07:06.000000', 'consum', 0.0249, 'lps'),
	(689634, 136, '2015-02-01 01:07:07.000000', 'consum', 0.0261, 'lps'),
	(689635, 136, '2015-02-01 01:07:08.000000', 'consum', 0.0217, 'lps'),
	(689636, 136, '2015-02-01 01:07:09.000000', 'consum', 0.0222, 'lps'),
	(689637, 136, '2015-02-01 01:07:10.000000', 'consum', 0.0250, 'lps'),
	(689638, 136, '2015-02-01 01:07:11.000000', 'consum', 0.0244, 'lps'),
	(689639, 136, '2015-02-01 01:07:12.000000', 'consum', 0.0260, 'lps'),
	(689640, 136, '2015-02-01 01:07:13.000000', 'consum', 0.0227, 'lps'),
	(689641, 136, '2015-02-01 01:07:14.000000', 'consum', 0.0214, 'lps'),
	(689642, 136, '2015-02-01 01:07:15.000000', 'consum', 0.0244, 'lps'),
	(689643, 136, '2015-02-01 01:07:16.000000', 'consum', 0.0236, 'lps'),
	(689644, 136, '2015-02-01 01:07:17.000000', 'consum', 0.0240, 'lps'),
	(689645, 136, '2015-02-01 01:07:18.000000', 'consum', 0.0216, 'lps'),
	(689646, 136, '2015-02-01 01:07:19.000000', 'consum', 0.0215, 'lps'),
	(689647, 136, '2015-02-01 01:07:20.000000', 'consum', 0.0216, 'lps'),
	(689648, 136, '2015-02-01 01:07:21.000000', 'consum', 0.0229, 'lps'),
	(689649, 136, '2015-02-01 01:07:22.000000', 'consum', 0.0221, 'lps'),
	(689650, 136, '2015-02-01 01:07:23.000000', 'consum', 0.0274, 'lps'),
	(689651, 136, '2015-02-01 01:07:24.000000', 'consum', 0.0239, 'lps'),
	(689652, 136, '2015-02-01 01:07:25.000000', 'consum', 0.0229, 'lps'),
	(689653, 136, '2015-02-01 01:07:26.000000', 'consum', 0.0216, 'lps'),
	(689654, 136, '2015-02-01 01:07:27.000000', 'consum', 0.0248, 'lps'),
	(689655, 136, '2015-02-01 01:07:28.000000', 'consum', 0.0254, 'lps'),
	(689656, 136, '2015-02-01 01:07:29.000000', 'consum', 0.0250, 'lps'),
	(689657, 136, '2015-02-01 01:07:30.000000', 'consum', 0.0214, 'lps'),
	(689658, 136, '2015-02-01 01:07:31.000000', 'consum', 0.0241, 'lps'),
	(689659, 136, '2015-02-01 01:07:32.000000', 'consum', 0.0222, 'lps'),
	(689660, 136, '2015-02-01 01:07:33.000000', 'consum', 0.0243, 'lps'),
	(689661, 136, '2015-02-01 01:07:34.000000', 'consum', 0.0212, 'lps'),
	(689662, 136, '2015-02-01 01:07:35.000000', 'consum', 0.0250, 'lps'),
	(689663, 136, '2015-02-01 01:07:36.000000', 'consum', 0.0273, 'lps'),
	(689664, 136, '2015-02-01 01:07:37.000000', 'consum', 0.0211, 'lps'),
	(689665, 136, '2015-02-01 01:07:38.000000', 'consum', 0.0223, 'lps'),
	(689666, 136, '2015-02-01 01:07:39.000000', 'consum', 0.0272, 'lps'),
	(689667, 136, '2015-02-01 01:07:40.000000', 'consum', 0.0221, 'lps'),
	(689668, 136, '2015-02-01 01:07:41.000000', 'consum', 0.0211, 'lps'),
	(689669, 136, '2015-02-01 01:07:42.000000', 'consum', 0.0246, 'lps'),
	(689670, 136, '2015-02-01 01:07:43.000000', 'consum', 0.0259, 'lps'),
	(689671, 136, '2015-02-01 01:07:44.000000', 'consum', 0.0218, 'lps'),
	(689672, 136, '2015-02-01 01:07:45.000000', 'consum', 0.0232, 'lps'),
	(689673, 136, '2015-02-01 01:07:46.000000', 'consum', 0.0233, 'lps'),
	(689674, 136, '2015-02-01 01:07:47.000000', 'consum', 0.0260, 'lps'),
	(689675, 136, '2015-02-01 01:07:48.000000', 'consum', 0.0261, 'lps'),
	(689676, 136, '2015-02-01 01:07:49.000000', 'consum', 0.0249, 'lps'),
	(689677, 136, '2015-02-01 01:07:50.000000', 'consum', 0.0255, 'lps'),
	(689678, 136, '2015-02-01 01:07:51.000000', 'consum', 0.0253, 'lps'),
	(689679, 136, '2015-02-01 01:07:52.000000', 'consum', 0.0226, 'lps'),
	(689680, 136, '2015-02-01 01:07:53.000000', 'consum', 0.0225, 'lps'),
	(689681, 136, '2015-02-01 01:07:54.000000', 'consum', 0.0237, 'lps'),
	(689682, 136, '2015-02-01 01:07:55.000000', 'consum', 0.0238, 'lps'),
	(689683, 136, '2015-02-01 01:07:56.000000', 'consum', 0.0268, 'lps'),
	(689684, 136, '2015-02-01 01:07:57.000000', 'consum', 0.0220, 'lps'),
	(689685, 136, '2015-02-01 01:07:58.000000', 'consum', 0.0220, 'lps'),
	(689686, 136, '2015-02-01 01:07:59.000000', 'consum', 0.0227, 'lps'),
	(689687, 136, '2015-02-01 01:08:00.000000', 'consum', 0.0267, 'lps'),
	(689688, 136, '2015-02-01 01:08:01.000000', 'consum', 0.0251, 'lps'),
	(689689, 136, '2015-02-01 01:08:02.000000', 'consum', 0.0244, 'lps'),
	(689690, 136, '2015-02-01 01:08:03.000000', 'consum', 0.0257, 'lps'),
	(689691, 136, '2015-02-01 01:08:04.000000', 'consum', 0.0212, 'lps'),
	(689692, 136, '2015-02-01 01:08:05.000000', 'consum', 0.0274, 'lps'),
	(689693, 136, '2015-02-01 01:08:06.000000', 'consum', 0.0264, 'lps'),
	(689694, 136, '2015-02-01 01:08:07.000000', 'consum', 0.0223, 'lps'),
	(689695, 136, '2015-02-01 01:08:08.000000', 'consum', 0.0244, 'lps'),
	(689696, 136, '2015-02-01 01:08:09.000000', 'consum', 0.0211, 'lps'),
	(689697, 136, '2015-02-01 01:08:10.000000', 'consum', 0.0245, 'lps'),
	(689698, 136, '2015-02-01 01:08:11.000000', 'consum', 0.0252, 'lps'),
	(689699, 136, '2015-02-01 01:08:12.000000', 'consum', 0.0250, 'lps'),
	(689700, 136, '2015-02-01 01:08:13.000000', 'consum', 0.0219, 'lps'),
	(689701, 136, '2015-02-01 01:08:14.000000', 'consum', 0.0266, 'lps'),
	(689702, 136, '2015-02-01 01:08:15.000000', 'consum', 0.0269, 'lps'),
	(689703, 136, '2015-02-01 01:08:16.000000', 'consum', 0.0272, 'lps'),
	(689704, 136, '2015-02-01 01:08:17.000000', 'consum', 0.0215, 'lps'),
	(689705, 136, '2015-02-01 01:08:18.000000', 'consum', 0.0243, 'lps'),
	(689706, 136, '2015-02-01 01:08:19.000000', 'consum', 0.0231, 'lps'),
	(689707, 136, '2015-02-01 01:08:20.000000', 'consum', 0.0217, 'lps'),
	(689708, 136, '2015-02-01 01:08:21.000000', 'consum', 0.0246, 'lps'),
	(689709, 136, '2015-02-01 01:08:22.000000', 'consum', 0.0240, 'lps'),
	(689710, 136, '2015-02-01 01:08:23.000000', 'consum', 0.0253, 'lps'),
	(689711, 136, '2015-02-01 01:08:24.000000', 'consum', 0.0272, 'lps'),
	(689712, 136, '2015-02-01 01:08:25.000000', 'consum', 0.0261, 'lps'),
	(689713, 136, '2015-02-01 01:08:26.000000', 'consum', 0.0215, 'lps'),
	(689714, 136, '2015-02-01 01:08:27.000000', 'consum', 0.0214, 'lps'),
	(689715, 136, '2015-02-01 01:08:28.000000', 'consum', 0.0213, 'lps'),
	(689716, 136, '2015-02-01 01:08:29.000000', 'consum', 0.0213, 'lps'),
	(689717, 136, '2015-02-01 01:08:30.000000', 'consum', 0.0219, 'lps'),
	(689718, 136, '2015-02-01 01:08:31.000000', 'consum', 0.0246, 'lps'),
	(689719, 136, '2015-02-01 01:08:32.000000', 'consum', 0.0232, 'lps'),
	(689720, 136, '2015-02-01 01:08:33.000000', 'consum', 0.0215, 'lps'),
	(689721, 136, '2015-02-01 01:08:34.000000', 'consum', 0.0231, 'lps'),
	(689722, 136, '2015-02-01 01:08:35.000000', 'consum', 0.0239, 'lps'),
	(689723, 136, '2015-02-01 01:08:36.000000', 'consum', 0.0225, 'lps'),
	(689724, 136, '2015-02-01 01:08:37.000000', 'consum', 0.0262, 'lps'),
	(689725, 136, '2015-02-01 01:08:38.000000', 'consum', 0.0234, 'lps'),
	(689726, 136, '2015-02-01 01:08:39.000000', 'consum', 0.0237, 'lps'),
	(689727, 136, '2015-02-01 01:08:40.000000', 'consum', 0.0272, 'lps'),
	(689728, 136, '2015-02-01 01:08:41.000000', 'consum', 0.0247, 'lps'),
	(689729, 136, '2015-02-01 01:08:42.000000', 'consum', 0.0274, 'lps'),
	(689730, 136, '2015-02-01 01:08:43.000000', 'consum', 0.0224, 'lps'),
	(689731, 136, '2015-02-01 01:08:44.000000', 'consum', 0.0220, 'lps'),
	(689732, 136, '2015-02-01 01:08:45.000000', 'consum', 0.0218, 'lps'),
	(689733, 136, '2015-02-01 01:08:46.000000', 'consum', 0.0220, 'lps'),
	(689734, 136, '2015-02-01 01:08:47.000000', 'consum', 0.0238, 'lps'),
	(689735, 136, '2015-02-01 01:08:48.000000', 'consum', 0.0254, 'lps'),
	(689736, 136, '2015-02-01 01:08:49.000000', 'consum', 0.0218, 'lps'),
	(689737, 136, '2015-02-01 01:08:50.000000', 'consum', 0.0249, 'lps'),
	(689738, 136, '2015-02-01 01:08:51.000000', 'consum', 0.0250, 'lps'),
	(689739, 136, '2015-02-01 01:08:52.000000', 'consum', 0.0228, 'lps'),
	(689740, 136, '2015-02-01 01:08:53.000000', 'consum', 0.0248, 'lps'),
	(689741, 136, '2015-02-01 01:08:54.000000', 'consum', 0.0215, 'lps'),
	(689742, 136, '2015-02-01 01:08:55.000000', 'consum', 0.0252, 'lps'),
	(689743, 136, '2015-02-01 01:08:56.000000', 'consum', 0.0273, 'lps'),
	(689744, 136, '2015-02-01 01:08:57.000000', 'consum', 0.0272, 'lps'),
	(689745, 136, '2015-02-01 01:08:58.000000', 'consum', 0.0266, 'lps'),
	(689746, 136, '2015-02-01 01:08:59.000000', 'consum', 0.0237, 'lps'),
	(689747, 136, '2015-02-01 01:09:00.000000', 'consum', 0.0246, 'lps'),
	(689748, 136, '2015-02-01 01:09:01.000000', 'consum', 0.0242, 'lps'),
	(689749, 136, '2015-02-01 01:09:02.000000', 'consum', 0.0263, 'lps'),
	(689750, 136, '2015-02-01 01:09:03.000000', 'consum', 0.0251, 'lps'),
	(689751, 136, '2015-02-01 01:09:04.000000', 'consum', 0.0258, 'lps'),
	(689752, 136, '2015-02-01 01:09:05.000000', 'consum', 0.0259, 'lps'),
	(689753, 136, '2015-02-01 01:09:06.000000', 'consum', 0.0247, 'lps'),
	(689754, 136, '2015-02-01 01:09:07.000000', 'consum', 0.0248, 'lps'),
	(689755, 136, '2015-02-01 01:09:08.000000', 'consum', 0.0225, 'lps'),
	(689756, 136, '2015-02-01 01:09:09.000000', 'consum', 0.0238, 'lps'),
	(689757, 136, '2015-02-01 01:09:10.000000', 'consum', 0.0241, 'lps'),
	(689758, 136, '2015-02-01 01:09:11.000000', 'consum', 0.0213, 'lps'),
	(689759, 136, '2015-02-01 01:09:12.000000', 'consum', 0.0266, 'lps'),
	(689760, 136, '2015-02-01 01:09:13.000000', 'consum', 0.0219, 'lps'),
	(689761, 136, '2015-02-01 01:09:14.000000', 'consum', 0.0220, 'lps'),
	(689762, 136, '2015-02-01 01:09:15.000000', 'consum', 0.0231, 'lps'),
	(689763, 136, '2015-02-01 01:09:16.000000', 'consum', 0.0221, 'lps'),
	(689764, 136, '2015-02-01 01:09:17.000000', 'consum', 0.0268, 'lps'),
	(689765, 136, '2015-02-01 01:09:18.000000', 'consum', 0.0272, 'lps'),
	(689766, 136, '2015-02-01 01:09:19.000000', 'consum', 0.0216, 'lps'),
	(689767, 136, '2015-02-01 01:09:20.000000', 'consum', 0.0248, 'lps'),
	(689768, 136, '2015-02-01 01:09:21.000000', 'consum', 0.0254, 'lps'),
	(689769, 136, '2015-02-01 01:09:22.000000', 'consum', 0.0253, 'lps'),
	(689770, 136, '2015-02-01 01:09:23.000000', 'consum', 0.0228, 'lps'),
	(689771, 136, '2015-02-01 01:09:24.000000', 'consum', 0.0236, 'lps'),
	(689772, 136, '2015-02-01 01:09:25.000000', 'consum', 0.0220, 'lps'),
	(689773, 136, '2015-02-01 01:09:26.000000', 'consum', 0.0250, 'lps'),
	(689774, 136, '2015-02-01 01:09:27.000000', 'consum', 0.0247, 'lps'),
	(689775, 136, '2015-02-01 01:09:28.000000', 'consum', 0.0214, 'lps'),
	(689776, 136, '2015-02-01 01:09:29.000000', 'consum', 0.0248, 'lps'),
	(689777, 136, '2015-02-01 01:09:30.000000', 'consum', 0.0258, 'lps'),
	(689778, 136, '2015-02-01 01:09:31.000000', 'consum', 0.0272, 'lps'),
	(689779, 136, '2015-02-01 01:09:32.000000', 'consum', 0.0245, 'lps'),
	(689780, 136, '2015-02-01 01:09:33.000000', 'consum', 0.0263, 'lps'),
	(689781, 136, '2015-02-01 01:09:34.000000', 'consum', 0.0244, 'lps'),
	(689782, 136, '2015-02-01 01:09:35.000000', 'consum', 0.0221, 'lps'),
	(689783, 136, '2015-02-01 01:09:36.000000', 'consum', 0.0226, 'lps'),
	(689784, 136, '2015-02-01 01:09:37.000000', 'consum', 0.0259, 'lps'),
	(689785, 136, '2015-02-01 01:09:38.000000', 'consum', 0.0212, 'lps'),
	(689786, 136, '2015-02-01 01:09:39.000000', 'consum', 0.0269, 'lps'),
	(689787, 136, '2015-02-01 01:09:40.000000', 'consum', 0.0238, 'lps'),
	(689788, 136, '2015-02-01 01:09:41.000000', 'consum', 0.0240, 'lps'),
	(689789, 136, '2015-02-01 01:09:42.000000', 'consum', 0.0211, 'lps'),
	(689790, 136, '2015-02-01 01:09:43.000000', 'consum', 0.0256, 'lps'),
	(689791, 136, '2015-02-01 01:09:44.000000', 'consum', 0.0243, 'lps'),
	(689792, 136, '2015-02-01 01:09:45.000000', 'consum', 0.0237, 'lps'),
	(689793, 136, '2015-02-01 01:09:46.000000', 'consum', 0.0248, 'lps'),
	(689794, 136, '2015-02-01 01:09:47.000000', 'consum', 0.0252, 'lps'),
	(689795, 136, '2015-02-01 01:09:48.000000', 'consum', 0.0243, 'lps'),
	(689796, 136, '2015-02-01 01:09:49.000000', 'consum', 0.0251, 'lps'),
	(689797, 136, '2015-02-01 01:09:50.000000', 'consum', 0.0249, 'lps'),
	(689798, 136, '2015-02-01 01:09:51.000000', 'consum', 0.0217, 'lps'),
	(689799, 136, '2015-02-01 01:09:52.000000', 'consum', 0.0259, 'lps'),
	(689800, 136, '2015-02-01 01:09:53.000000', 'consum', 0.0239, 'lps'),
	(689801, 136, '2015-02-01 01:09:54.000000', 'consum', 0.0272, 'lps'),
	(689802, 136, '2015-02-01 01:09:55.000000', 'consum', 0.0242, 'lps'),
	(689803, 136, '2015-02-01 01:09:56.000000', 'consum', 0.0248, 'lps'),
	(689804, 136, '2015-02-01 01:09:57.000000', 'consum', 0.0241, 'lps'),
	(689805, 136, '2015-02-01 01:09:58.000000', 'consum', 0.0251, 'lps'),
	(689806, 136, '2015-02-01 01:09:59.000000', 'consum', 0.0256, 'lps'),
	(689807, 136, '2015-02-01 01:10:00.000000', 'consum', 0.0251, 'lps'),
	(689808, 136, '2015-02-01 01:10:01.000000', 'consum', 0.0215, 'lps'),
	(689809, 136, '2015-02-01 01:10:02.000000', 'consum', 0.0242, 'lps'),
	(689810, 136, '2015-02-01 01:10:03.000000', 'consum', 0.0223, 'lps'),
	(689811, 136, '2015-02-01 01:10:04.000000', 'consum', 0.0248, 'lps'),
	(689812, 136, '2015-02-01 01:10:05.000000', 'consum', 0.0230, 'lps'),
	(689813, 136, '2015-02-01 01:10:06.000000', 'consum', 0.0263, 'lps'),
	(689814, 136, '2015-02-01 01:10:07.000000', 'consum', 0.0220, 'lps'),
	(689815, 136, '2015-02-01 01:10:08.000000', 'consum', 0.0231, 'lps'),
	(689816, 136, '2015-02-01 01:10:09.000000', 'consum', 0.0222, 'lps'),
	(689817, 136, '2015-02-01 01:10:10.000000', 'consum', 0.0272, 'lps'),
	(689818, 136, '2015-02-01 01:10:11.000000', 'consum', 0.0226, 'lps'),
	(689819, 136, '2015-02-01 01:10:12.000000', 'consum', 0.0233, 'lps'),
	(689820, 136, '2015-02-01 01:10:13.000000', 'consum', 0.0213, 'lps'),
	(689821, 136, '2015-02-01 01:10:14.000000', 'consum', 0.0219, 'lps'),
	(689822, 136, '2015-02-01 01:10:15.000000', 'consum', 0.0249, 'lps'),
	(689823, 136, '2015-02-01 01:10:16.000000', 'consum', 0.0248, 'lps'),
	(689824, 136, '2015-02-01 01:10:17.000000', 'consum', 0.0217, 'lps'),
	(689825, 136, '2015-02-01 01:10:18.000000', 'consum', 0.0261, 'lps'),
	(689826, 136, '2015-02-01 01:10:19.000000', 'consum', 0.0249, 'lps'),
	(689827, 136, '2015-02-01 01:10:20.000000', 'consum', 0.0254, 'lps'),
	(689828, 136, '2015-02-01 01:10:21.000000', 'consum', 0.0248, 'lps'),
	(689829, 136, '2015-02-01 01:10:22.000000', 'consum', 0.0269, 'lps'),
	(689830, 136, '2015-02-01 01:10:23.000000', 'consum', 0.0263, 'lps'),
	(689831, 136, '2015-02-01 01:10:24.000000', 'consum', 0.0230, 'lps'),
	(689832, 136, '2015-02-01 01:10:25.000000', 'consum', 0.0219, 'lps'),
	(689833, 136, '2015-02-01 01:10:26.000000', 'consum', 0.0262, 'lps'),
	(689834, 136, '2015-02-01 01:10:27.000000', 'consum', 0.0246, 'lps'),
	(689835, 136, '2015-02-01 01:10:28.000000', 'consum', 0.0236, 'lps'),
	(689836, 136, '2015-02-01 01:10:29.000000', 'consum', 0.0234, 'lps'),
	(689837, 136, '2015-02-01 01:10:30.000000', 'consum', 0.0249, 'lps'),
	(689838, 136, '2015-02-01 01:10:31.000000', 'consum', 0.0270, 'lps'),
	(689839, 136, '2015-02-01 01:10:32.000000', 'consum', 0.0263, 'lps'),
	(689840, 136, '2015-02-01 01:10:33.000000', 'consum', 0.0232, 'lps'),
	(689841, 136, '2015-02-01 01:10:34.000000', 'consum', 0.0227, 'lps'),
	(689842, 136, '2015-02-01 01:10:35.000000', 'consum', 0.0229, 'lps'),
	(689843, 136, '2015-02-01 01:10:36.000000', 'consum', 0.0253, 'lps'),
	(689844, 136, '2015-02-01 01:10:37.000000', 'consum', 0.0241, 'lps'),
	(689845, 136, '2015-02-01 01:10:38.000000', 'consum', 0.0235, 'lps'),
	(689846, 136, '2015-02-01 01:10:39.000000', 'consum', 0.0245, 'lps'),
	(689847, 136, '2015-02-01 01:10:40.000000', 'consum', 0.0243, 'lps'),
	(689848, 136, '2015-02-01 01:10:41.000000', 'consum', 0.0271, 'lps'),
	(689849, 136, '2015-02-01 01:10:42.000000', 'consum', 0.0223, 'lps'),
	(689850, 136, '2015-02-01 01:10:43.000000', 'consum', 0.0221, 'lps'),
	(689851, 136, '2015-02-01 01:10:44.000000', 'consum', 0.0228, 'lps'),
	(689852, 136, '2015-02-01 01:10:45.000000', 'consum', 0.0266, 'lps'),
	(689853, 136, '2015-02-01 01:10:46.000000', 'consum', 0.0243, 'lps'),
	(689854, 136, '2015-02-01 01:10:47.000000', 'consum', 0.0271, 'lps'),
	(689855, 136, '2015-02-01 01:10:48.000000', 'consum', 0.0221, 'lps'),
	(689856, 136, '2015-02-01 01:10:49.000000', 'consum', 0.0211, 'lps'),
	(689857, 136, '2015-02-01 01:10:50.000000', 'consum', 0.0250, 'lps'),
	(689858, 136, '2015-02-01 01:10:51.000000', 'consum', 0.0212, 'lps'),
	(689859, 136, '2015-02-01 01:10:52.000000', 'consum', 0.0230, 'lps'),
	(689860, 136, '2015-02-01 01:10:53.000000', 'consum', 0.0240, 'lps'),
	(689861, 136, '2015-02-01 01:10:54.000000', 'consum', 0.0235, 'lps'),
	(689862, 136, '2015-02-01 01:10:55.000000', 'consum', 0.0245, 'lps'),
	(689863, 136, '2015-02-01 01:10:56.000000', 'consum', 0.0247, 'lps'),
	(689864, 136, '2015-02-01 01:10:57.000000', 'consum', 0.0224, 'lps'),
	(689865, 136, '2015-02-01 01:10:58.000000', 'consum', 0.0234, 'lps'),
	(689866, 136, '2015-02-01 01:10:59.000000', 'consum', 0.0223, 'lps'),
	(689867, 136, '2015-02-01 01:11:00.000000', 'consum', 0.0268, 'lps'),
	(689868, 136, '2015-02-01 01:11:01.000000', 'consum', 0.0267, 'lps'),
	(689869, 136, '2015-02-01 01:11:02.000000', 'consum', 0.0258, 'lps'),
	(689870, 136, '2015-02-01 01:11:03.000000', 'consum', 0.0212, 'lps'),
	(689871, 136, '2015-02-01 01:11:04.000000', 'consum', 0.0273, 'lps'),
	(689872, 136, '2015-02-01 01:11:05.000000', 'consum', 0.0259, 'lps'),
	(689873, 136, '2015-02-01 01:11:06.000000', 'consum', 0.0267, 'lps'),
	(689874, 136, '2015-02-01 01:11:07.000000', 'consum', 0.0219, 'lps'),
	(689875, 136, '2015-02-01 01:11:08.000000', 'consum', 0.0213, 'lps'),
	(689876, 136, '2015-02-01 01:11:09.000000', 'consum', 0.0266, 'lps'),
	(689877, 136, '2015-02-01 01:11:10.000000', 'consum', 0.0220, 'lps'),
	(689878, 136, '2015-02-01 01:11:11.000000', 'consum', 0.0224, 'lps'),
	(689879, 136, '2015-02-01 01:11:12.000000', 'consum', 0.0248, 'lps'),
	(689880, 136, '2015-02-01 01:11:13.000000', 'consum', 0.0230, 'lps'),
	(689881, 136, '2015-02-01 01:11:14.000000', 'consum', 0.0260, 'lps'),
	(689882, 136, '2015-02-01 01:11:15.000000', 'consum', 0.0270, 'lps'),
	(689883, 136, '2015-02-01 01:11:16.000000', 'consum', 0.0233, 'lps'),
	(689884, 136, '2015-02-01 01:11:17.000000', 'consum', 0.0210, 'lps'),
	(689885, 136, '2015-02-01 01:11:18.000000', 'consum', 0.0270, 'lps'),
	(689886, 136, '2015-02-01 01:11:19.000000', 'consum', 0.0252, 'lps'),
	(689887, 136, '2015-02-01 01:11:20.000000', 'consum', 0.0242, 'lps'),
	(689888, 136, '2015-02-01 01:11:21.000000', 'consum', 0.0242, 'lps'),
	(689889, 136, '2015-02-01 01:11:22.000000', 'consum', 0.0210, 'lps'),
	(689890, 136, '2015-02-01 01:11:23.000000', 'consum', 0.0245, 'lps'),
	(689891, 136, '2015-02-01 01:11:24.000000', 'consum', 0.0256, 'lps'),
	(689892, 136, '2015-02-01 01:11:25.000000', 'consum', 0.0270, 'lps'),
	(689893, 136, '2015-02-01 01:11:26.000000', 'consum', 0.0241, 'lps'),
	(689894, 136, '2015-02-01 01:11:27.000000', 'consum', 0.0253, 'lps'),
	(689895, 136, '2015-02-01 01:11:28.000000', 'consum', 0.0265, 'lps'),
	(689896, 136, '2015-02-01 01:11:29.000000', 'consum', 0.0226, 'lps'),
	(689897, 136, '2015-02-01 01:11:30.000000', 'consum', 0.0256, 'lps'),
	(689898, 136, '2015-02-01 01:11:31.000000', 'consum', 0.0262, 'lps'),
	(689899, 136, '2015-02-01 01:11:32.000000', 'consum', 0.0270, 'lps'),
	(689900, 136, '2015-02-01 01:11:33.000000', 'consum', 0.0222, 'lps'),
	(689901, 136, '2015-02-01 01:11:34.000000', 'consum', 0.0222, 'lps'),
	(689902, 136, '2015-02-01 01:11:35.000000', 'consum', 0.0236, 'lps'),
	(689903, 136, '2015-02-01 01:11:36.000000', 'consum', 0.0237, 'lps'),
	(689904, 136, '2015-02-01 01:11:37.000000', 'consum', 0.0270, 'lps'),
	(689905, 136, '2015-02-01 01:11:38.000000', 'consum', 0.0231, 'lps'),
	(689906, 136, '2015-02-01 01:11:39.000000', 'consum', 0.0269, 'lps'),
	(689907, 136, '2015-02-01 01:11:40.000000', 'consum', 0.0245, 'lps'),
	(689908, 136, '2015-02-01 01:11:41.000000', 'consum', 0.0273, 'lps'),
	(689909, 136, '2015-02-01 01:11:42.000000', 'consum', 0.0225, 'lps'),
	(689910, 136, '2015-02-01 01:11:43.000000', 'consum', 0.0225, 'lps'),
	(689911, 136, '2015-02-01 01:11:44.000000', 'consum', 0.0244, 'lps'),
	(689912, 136, '2015-02-01 01:11:45.000000', 'consum', 0.0269, 'lps'),
	(689913, 136, '2015-02-01 01:11:46.000000', 'consum', 0.0274, 'lps'),
	(689914, 136, '2015-02-01 01:11:47.000000', 'consum', 0.0222, 'lps'),
	(689915, 136, '2015-02-01 01:11:48.000000', 'consum', 0.0274, 'lps'),
	(689916, 136, '2015-02-01 01:11:49.000000', 'consum', 0.0236, 'lps'),
	(689917, 136, '2015-02-01 01:11:50.000000', 'consum', 0.0212, 'lps'),
	(689918, 136, '2015-02-01 01:11:51.000000', 'consum', 0.0273, 'lps'),
	(689919, 136, '2015-02-01 01:11:52.000000', 'consum', 0.0261, 'lps'),
	(689920, 136, '2015-02-01 01:11:53.000000', 'consum', 0.0274, 'lps'),
	(689921, 136, '2015-02-01 01:11:54.000000', 'consum', 0.0247, 'lps'),
	(689922, 136, '2015-02-01 01:11:55.000000', 'consum', 0.0271, 'lps'),
	(689923, 136, '2015-02-01 01:11:56.000000', 'consum', 0.0274, 'lps'),
	(689924, 136, '2015-02-01 01:11:57.000000', 'consum', 0.0218, 'lps'),
	(689925, 136, '2015-02-01 01:11:58.000000', 'consum', 0.0255, 'lps'),
	(689926, 136, '2015-02-01 01:11:59.000000', 'consum', 0.0214, 'lps'),
	(689927, 136, '2015-02-01 01:12:00.000000', 'consum', 0.0226, 'lps'),
	(689928, 136, '2015-02-01 01:12:01.000000', 'consum', 0.0213, 'lps'),
	(689929, 136, '2015-02-01 01:12:02.000000', 'consum', 0.0241, 'lps'),
	(689930, 136, '2015-02-01 01:12:03.000000', 'consum', 0.0228, 'lps'),
	(689931, 136, '2015-02-01 01:12:04.000000', 'consum', 0.0272, 'lps'),
	(689932, 136, '2015-02-01 01:12:05.000000', 'consum', 0.0271, 'lps'),
	(689933, 136, '2015-02-01 01:12:06.000000', 'consum', 0.0263, 'lps'),
	(689934, 136, '2015-02-01 01:12:07.000000', 'consum', 0.0229, 'lps'),
	(689935, 136, '2015-02-01 01:12:08.000000', 'consum', 0.0210, 'lps'),
	(689936, 136, '2015-02-01 01:12:09.000000', 'consum', 0.0219, 'lps'),
	(689937, 136, '2015-02-01 01:12:10.000000', 'consum', 0.0258, 'lps'),
	(689938, 136, '2015-02-01 01:12:11.000000', 'consum', 0.0225, 'lps'),
	(689939, 136, '2015-02-01 01:12:12.000000', 'consum', 0.0274, 'lps'),
	(689940, 136, '2015-02-01 01:12:13.000000', 'consum', 0.0226, 'lps'),
	(689941, 136, '2015-02-01 01:12:14.000000', 'consum', 0.0226, 'lps'),
	(689942, 136, '2015-02-01 01:12:15.000000', 'consum', 0.0244, 'lps'),
	(689943, 136, '2015-02-01 01:12:16.000000', 'consum', 0.0265, 'lps'),
	(689944, 136, '2015-02-01 01:12:17.000000', 'consum', 0.0257, 'lps'),
	(689945, 136, '2015-02-01 01:12:18.000000', 'consum', 0.0213, 'lps'),
	(689946, 136, '2015-02-01 01:12:19.000000', 'consum', 0.0215, 'lps'),
	(689947, 136, '2015-02-01 01:12:20.000000', 'consum', 0.0227, 'lps'),
	(689948, 136, '2015-02-01 01:12:21.000000', 'consum', 0.0215, 'lps'),
	(689949, 136, '2015-02-01 01:12:22.000000', 'consum', 0.0250, 'lps'),
	(689950, 136, '2015-02-01 01:12:23.000000', 'consum', 0.0265, 'lps'),
	(689951, 136, '2015-02-01 01:12:24.000000', 'consum', 0.0235, 'lps'),
	(689952, 136, '2015-02-01 01:12:25.000000', 'consum', 0.0234, 'lps'),
	(689953, 136, '2015-02-01 01:12:26.000000', 'consum', 0.0259, 'lps'),
	(689954, 136, '2015-02-01 01:12:27.000000', 'consum', 0.0252, 'lps'),
	(689955, 136, '2015-02-01 01:12:28.000000', 'consum', 0.0273, 'lps'),
	(689956, 136, '2015-02-01 01:12:29.000000', 'consum', 0.0268, 'lps'),
	(689957, 136, '2015-02-01 01:12:30.000000', 'consum', 0.0249, 'lps'),
	(689958, 136, '2015-02-01 01:12:31.000000', 'consum', 0.0229, 'lps'),
	(689959, 136, '2015-02-01 01:12:32.000000', 'consum', 0.0254, 'lps'),
	(689960, 136, '2015-02-01 01:12:33.000000', 'consum', 0.0243, 'lps'),
	(689961, 136, '2015-02-01 01:12:34.000000', 'consum', 0.0246, 'lps'),
	(689962, 136, '2015-02-01 01:12:35.000000', 'consum', 0.0226, 'lps'),
	(689963, 136, '2015-02-01 01:12:36.000000', 'consum', 0.0246, 'lps'),
	(689964, 136, '2015-02-01 01:12:37.000000', 'consum', 0.0213, 'lps'),
	(689965, 136, '2015-02-01 01:12:38.000000', 'consum', 0.0247, 'lps'),
	(689966, 136, '2015-02-01 01:12:39.000000', 'consum', 0.0255, 'lps'),
	(689967, 136, '2015-02-01 01:12:40.000000', 'consum', 0.0262, 'lps'),
	(689968, 136, '2015-02-01 01:12:41.000000', 'consum', 0.0270, 'lps'),
	(689969, 136, '2015-02-01 01:12:42.000000', 'consum', 0.0226, 'lps'),
	(689970, 136, '2015-02-01 01:12:43.000000', 'consum', 0.0239, 'lps'),
	(689971, 136, '2015-02-01 01:12:44.000000', 'consum', 0.0241, 'lps'),
	(689972, 136, '2015-02-01 01:12:45.000000', 'consum', 0.0216, 'lps'),
	(689973, 136, '2015-02-01 01:12:46.000000', 'consum', 0.0212, 'lps'),
	(689974, 136, '2015-02-01 01:12:47.000000', 'consum', 0.0269, 'lps'),
	(689975, 136, '2015-02-01 01:12:48.000000', 'consum', 0.0239, 'lps'),
	(689976, 136, '2015-02-01 01:12:49.000000', 'consum', 0.0244, 'lps'),
	(689977, 136, '2015-02-01 01:12:50.000000', 'consum', 0.0230, 'lps'),
	(689978, 136, '2015-02-01 01:12:51.000000', 'consum', 0.0271, 'lps'),
	(689979, 136, '2015-02-01 01:12:52.000000', 'consum', 0.0259, 'lps'),
	(689980, 136, '2015-02-01 01:12:53.000000', 'consum', 0.0210, 'lps'),
	(689981, 136, '2015-02-01 01:12:54.000000', 'consum', 0.0259, 'lps'),
	(689982, 136, '2015-02-01 01:12:55.000000', 'consum', 0.0261, 'lps'),
	(689983, 136, '2015-02-01 01:12:56.000000', 'consum', 0.0253, 'lps'),
	(689984, 136, '2015-02-01 01:12:57.000000', 'consum', 0.0274, 'lps'),
	(689985, 136, '2015-02-01 01:12:58.000000', 'consum', 0.0270, 'lps'),
	(689986, 136, '2015-02-01 01:12:59.000000', 'consum', 0.0254, 'lps'),
	(689987, 136, '2015-02-01 01:13:00.000000', 'consum', 0.0251, 'lps'),
	(689988, 136, '2015-02-01 01:13:01.000000', 'consum', 0.0220, 'lps'),
	(689989, 136, '2015-02-01 01:13:02.000000', 'consum', 0.0265, 'lps'),
	(689990, 136, '2015-02-01 01:13:03.000000', 'consum', 0.0260, 'lps'),
	(689991, 136, '2015-02-01 01:13:04.000000', 'consum', 0.0231, 'lps'),
	(689992, 136, '2015-02-01 01:13:05.000000', 'consum', 0.0231, 'lps'),
	(689993, 136, '2015-02-01 01:13:06.000000', 'consum', 0.0253, 'lps'),
	(689994, 136, '2015-02-01 01:13:07.000000', 'consum', 0.0231, 'lps'),
	(689995, 136, '2015-02-01 01:13:08.000000', 'consum', 0.0252, 'lps'),
	(689996, 136, '2015-02-01 01:13:09.000000', 'consum', 0.0228, 'lps'),
	(689997, 136, '2015-02-01 01:13:10.000000', 'consum', 0.0238, 'lps'),
	(689998, 136, '2015-02-01 01:13:11.000000', 'consum', 0.0233, 'lps'),
	(689999, 136, '2015-02-01 01:13:12.000000', 'consum', 0.0242, 'lps'),
	(690000, 136, '2015-02-01 01:13:13.000000', 'consum', 0.0234, 'lps'),
	(690001, 136, '2015-02-01 01:13:14.000000', 'consum', 0.0238, 'lps'),
	(690002, 136, '2015-02-01 01:13:15.000000', 'consum', 0.0210, 'lps'),
	(690003, 136, '2015-02-01 01:13:16.000000', 'consum', 0.0260, 'lps'),
	(690004, 136, '2015-02-01 01:13:17.000000', 'consum', 0.0262, 'lps'),
	(690005, 136, '2015-02-01 01:13:18.000000', 'consum', 0.0259, 'lps'),
	(690006, 136, '2015-02-01 01:13:19.000000', 'consum', 0.0232, 'lps'),
	(690007, 136, '2015-02-01 01:13:20.000000', 'consum', 0.0240, 'lps'),
	(690008, 136, '2015-02-01 01:13:21.000000', 'consum', 0.0230, 'lps'),
	(690009, 136, '2015-02-01 01:13:22.000000', 'consum', 0.0218, 'lps'),
	(690010, 136, '2015-02-01 01:13:23.000000', 'consum', 0.0258, 'lps'),
	(690011, 136, '2015-02-01 01:13:24.000000', 'consum', 0.0231, 'lps'),
	(690012, 136, '2015-02-01 01:13:25.000000', 'consum', 0.0237, 'lps'),
	(690013, 136, '2015-02-01 01:13:26.000000', 'consum', 0.0217, 'lps'),
	(690014, 136, '2015-02-01 01:13:27.000000', 'consum', 0.0228, 'lps'),
	(690015, 136, '2015-02-01 01:13:28.000000', 'consum', 0.0217, 'lps'),
	(690016, 136, '2015-02-01 01:13:29.000000', 'consum', 0.0258, 'lps'),
	(690017, 136, '2015-02-01 01:13:30.000000', 'consum', 0.0231, 'lps'),
	(690018, 136, '2015-02-01 01:13:31.000000', 'consum', 0.0237, 'lps'),
	(690019, 136, '2015-02-01 01:13:32.000000', 'consum', 0.0219, 'lps'),
	(690020, 136, '2015-02-01 01:13:33.000000', 'consum', 0.0239, 'lps'),
	(690021, 136, '2015-02-01 01:13:34.000000', 'consum', 0.0263, 'lps'),
	(690022, 136, '2015-02-01 01:13:35.000000', 'consum', 0.0261, 'lps'),
	(690023, 136, '2015-02-01 01:13:36.000000', 'consum', 0.0238, 'lps'),
	(690024, 136, '2015-02-01 01:13:37.000000', 'consum', 0.0265, 'lps'),
	(690025, 136, '2015-02-01 01:13:38.000000', 'consum', 0.0269, 'lps'),
	(690026, 136, '2015-02-01 01:13:39.000000', 'consum', 0.0213, 'lps'),
	(690027, 136, '2015-02-01 01:13:40.000000', 'consum', 0.0244, 'lps'),
	(690028, 136, '2015-02-01 01:13:41.000000', 'consum', 0.0242, 'lps'),
	(690029, 136, '2015-02-01 01:13:42.000000', 'consum', 0.0269, 'lps'),
	(690030, 136, '2015-02-01 01:13:43.000000', 'consum', 0.0213, 'lps'),
	(690031, 136, '2015-02-01 01:13:44.000000', 'consum', 0.0243, 'lps'),
	(690032, 136, '2015-02-01 01:13:45.000000', 'consum', 0.0239, 'lps'),
	(690033, 136, '2015-02-01 01:13:46.000000', 'consum', 0.0256, 'lps'),
	(690034, 136, '2015-02-01 01:13:47.000000', 'consum', 0.0222, 'lps'),
	(690035, 136, '2015-02-01 01:13:48.000000', 'consum', 0.0263, 'lps'),
	(690036, 136, '2015-02-01 01:13:49.000000', 'consum', 0.0246, 'lps'),
	(690037, 136, '2015-02-01 01:13:50.000000', 'consum', 0.0233, 'lps'),
	(690038, 136, '2015-02-01 01:13:51.000000', 'consum', 0.0214, 'lps'),
	(690039, 136, '2015-02-01 01:13:52.000000', 'consum', 0.0227, 'lps'),
	(690040, 136, '2015-02-01 01:13:53.000000', 'consum', 0.0220, 'lps'),
	(690041, 136, '2015-02-01 01:13:54.000000', 'consum', 0.0273, 'lps'),
	(690042, 136, '2015-02-01 01:13:55.000000', 'consum', 0.0237, 'lps'),
	(690043, 136, '2015-02-01 01:13:56.000000', 'consum', 0.0219, 'lps'),
	(690044, 136, '2015-02-01 01:13:57.000000', 'consum', 0.0241, 'lps'),
	(690045, 136, '2015-02-01 01:13:58.000000', 'consum', 0.0272, 'lps'),
	(690046, 136, '2015-02-01 01:13:59.000000', 'consum', 0.0232, 'lps'),
	(690047, 136, '2015-02-01 01:14:00.000000', 'consum', 0.0265, 'lps'),
	(690048, 136, '2015-02-01 01:14:01.000000', 'consum', 0.0223, 'lps'),
	(690049, 136, '2015-02-01 01:14:02.000000', 'consum', 0.0242, 'lps'),
	(690050, 136, '2015-02-01 01:14:03.000000', 'consum', 0.0267, 'lps'),
	(690051, 136, '2015-02-01 01:14:04.000000', 'consum', 0.0270, 'lps'),
	(690052, 136, '2015-02-01 01:14:05.000000', 'consum', 0.0273, 'lps'),
	(690053, 136, '2015-02-01 01:14:06.000000', 'consum', 0.0217, 'lps'),
	(690054, 136, '2015-02-01 01:14:07.000000', 'consum', 0.0253, 'lps'),
	(690055, 136, '2015-02-01 01:14:08.000000', 'consum', 0.0272, 'lps'),
	(690056, 136, '2015-02-01 01:14:09.000000', 'consum', 0.0261, 'lps'),
	(690057, 136, '2015-02-01 01:14:10.000000', 'consum', 0.0216, 'lps'),
	(690058, 136, '2015-02-01 01:14:11.000000', 'consum', 0.0215, 'lps'),
	(690059, 136, '2015-02-01 01:14:12.000000', 'consum', 0.0219, 'lps'),
	(690060, 136, '2015-02-01 01:14:13.000000', 'consum', 0.0238, 'lps'),
	(690061, 136, '2015-02-01 01:14:14.000000', 'consum', 0.0262, 'lps'),
	(690062, 136, '2015-02-01 01:14:15.000000', 'consum', 0.0256, 'lps'),
	(690063, 136, '2015-02-01 01:14:16.000000', 'consum', 0.0219, 'lps'),
	(690064, 136, '2015-02-01 01:14:17.000000', 'consum', 0.0249, 'lps'),
	(690065, 136, '2015-02-01 01:14:18.000000', 'consum', 0.0245, 'lps'),
	(690066, 136, '2015-02-01 01:14:19.000000', 'consum', 0.0272, 'lps'),
	(690067, 136, '2015-02-01 01:14:20.000000', 'consum', 0.0218, 'lps'),
	(690068, 136, '2015-02-01 01:14:21.000000', 'consum', 0.0258, 'lps'),
	(690069, 136, '2015-02-01 01:14:22.000000', 'consum', 0.0235, 'lps'),
	(690070, 136, '2015-02-01 01:14:23.000000', 'consum', 0.0253, 'lps'),
	(690071, 136, '2015-02-01 01:14:24.000000', 'consum', 0.0223, 'lps'),
	(690072, 136, '2015-02-01 01:14:25.000000', 'consum', 0.0274, 'lps'),
	(690073, 136, '2015-02-01 01:14:26.000000', 'consum', 0.0232, 'lps'),
	(690074, 136, '2015-02-01 01:14:27.000000', 'consum', 0.0259, 'lps'),
	(690075, 136, '2015-02-01 01:14:28.000000', 'consum', 0.0258, 'lps'),
	(690076, 136, '2015-02-01 01:14:29.000000', 'consum', 0.0242, 'lps');
/*!40000 ALTER TABLE `telemetria` ENABLE KEYS */;


-- Volcando estructura para tabla fia.temporada
CREATE TABLE IF NOT EXISTS `temporada` (
  `any` year(4) NOT NULL,
  PRIMARY KEY (`any`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Volcando datos para la tabla fia.temporada: ~2 rows (aproximadamente)
DELETE FROM `temporada`;
/*!40000 ALTER TABLE `temporada` DISABLE KEYS */;
INSERT INTO `temporada` (`any`) VALUES
	('2014'),
	('2015');
/*!40000 ALTER TABLE `temporada` ENABLE KEYS */;


-- Volcando estructura para procedimiento fia.alta_circuit
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `alta_circuit`(IN `nom` VARCHAR(50), IN `sobrenom` VARCHAR(50), IN `longitud` SMALLINT, IN `nacionalitat` CHAR(2), OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (10);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

-- Control d'errors

DECLARE EXIT HANDLER FOR 1644 
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT("ERROR: Codi ",state,". ",msg);
END;

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'.Nom de circuit (',nom,') o sobrenom (',IFNULL(sobrenom,"NULL"),') duplicat.');
END;

DECLARE EXIT HANDLER FOR 1452
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. La clau forana (',nacionalitat,') no es correcte.');
END;

DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;


	SET RSP := 'OK';
	
	
	-- Inserta a la taula
	
	INSERT INTO circuit(nom, sobrenom, longitud, pais) VALUES (nom, sobrenom, longitud, nacionalitat);
	

	-- Actualitzar log
		
	SET valor_antic = " - ";
	SET valor_nou = CONCAT_WS(', ',LAST_INSERT_ID(),nom, sobrenom, longitud, nacionalitat);
	SET consulta = CONCAT("alta_circuit ('",nom,"', '",(IFNULL(sobrenom,"NULL")),"', ",(IFNULL(longitud,"NULL")),", '",nacionalitat,"')");
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'circuit', valor_antic, valor_nou, NOW(), consulta);

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.alta_competicio
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `alta_competicio`(IN `nom` VARCHAR(50), IN `acronim` VARCHAR(10), IN `descripcio` TEXT, OUT `RSP` VARCHAR(250))
BEGIN

declare valor_antic VARCHAR (10);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare new_competicio SMALLINT;


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT("ERROR: Codi ",state,". Possiblement la competicio (",nom,") o l'acronim (",acronim,") ja existeix a la taula \'competicio\'.");
END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	
	SET RSP := 'OK';
	
	
	-- Insertar a la taula
	
	INSERT INTO competicio(nom, acronim, descripcio) VALUES (nom, acronim, descripcio);

	SET new_competicio = LAST_INSERT_ID();
	
	
	-- Actualitzar log
	
	set valor_antic = " - ";
	set valor_nou = CONCAT_WS(', ', new_competicio, nom, acronim, descripcio);
	SET consulta = CONCAT("alta_competicio ('",nom,"', '",acronim,"', '",descripcio,"')");
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'competicio', valor_antic, valor_nou, NOW(), consulta);
	
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.alta_component
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `alta_component`(IN `in_fabricant` MEDIUMINT, IN `in_cotxe` MEDIUMINT, IN `descripcio` TEXT, IN `utilitat` TEXT, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (10);
declare valor_nou VARCHAR (512);
declare codi_fabricant MEDIUMINT;
declare codi_cotxe MEDIUMINT;
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare aux_existeix MEDIUMINT;
declare codi_component MEDIUMINT;
declare percentatge_defectuos DECIMAL(4,1);


-- Control d'errors

DECLARE EXIT HANDLER FOR 1452
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement el fabricant (',in_fabricant,') o el cotxe (',in_cotxe,') no son correctes.');
END;


DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. El nom del fabricant o del cotxe no son correctes.' );
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;


	SET RSP := 'OK';
	
	
	-- Es fa servir SELECT INTO per tal de llençar l'excepcio  NOT FOUND si no es troba el codi a la taula
	
	SELECT f.codi_fabricant FROM fabricant f WHERE f.codi_fabricant = in_fabricant INTO codi_fabricant;
	SELECT c.codi_cotxe FROM cotxe c WHERE c.codi_cotxe = in_cotxe INTO codi_cotxe;
	
	
	-- Insertar a la taula
	
	INSERT INTO component (fabricant,cotxe,descripcio,utilitat) VALUES (codi_fabricant, codi_cotxe, descripcio, utilitat);

	
	-- Actualitzar log
	
	SET codi_component = LAST_INSERT_ID();
	SET valor_antic = " - ";
	SET consulta = CONCAT("alta_component ('",in_fabricant,"','",in_cotxe,"', '",descripcio,"', '",utilitat,"')");
	SET valor_nou = CONCAT_WS(', ', codi_component, codi_fabricant, codi_cotxe, descripcio, utilitat);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'component', valor_antic, valor_nou, NOW(),consulta);
	

	-- Actualitzar estadistiques sobre quantitat de components aportats per fabricant
	
	SET aux_existeix = (SELECT components FROM dim_component dc WHERE dc.fabricant = codi_fabricant);				
	
	IF aux_existeix IS NULL THEN
		INSERT INTO dim_component (fabricant, components) 
		VALUES (codi_fabricant, 1);
	ELSE
		UPDATE dim_component dc
		SET dc.components = dc.components + 1
		WHERE dc.fabricant = codi_fabricant;
	END IF;
	
	DELETE FROM fact_table_1 WHERE camp_control = '0xQC';
   INSERT INTO fact_table_1(fabricant, quantitat_components, camp_control) 
   SELECT dc.fabricant, dc.components, '0xQC' FROM dim_component dc ORDER BY dc.components DESC LIMIT 5;
	
	SET aux_existeix = NULL;
	
	
	-- Actualitzar estadistiques sobre quantitat de components defectuosos

	INSERT INTO dim_defectuos (cotxe, component) 
	VALUES (in_cotxe, codi_component);
	
	IF (SELECT camp_control FROM fact_table_1 WHERE camp_control = '0xCD' AND cotxe = in_cotxe) IS NULL THEN
		INSERT INTO fact_table_1 (cotxe, components_defectuosos, camp_control)
		VALUES (in_cotxe, 0, '0xCD');
	ELSE
		SELECT ROUND((SUM(CASE WHEN defectuos = 1 THEN 1 ELSE 0 END)/COUNT(*)*100),1) 
		FROM dim_defectuos WHERE cotxe = in_cotxe
		INTO percentatge_defectuos;

		UPDATE fact_table_1
		SET components_defectuosos = percentatge_defectuos
		WHERE cotxe = in_cotxe
		AND camp_control = '0xCD';
 	END IF;
	
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.alta_cotxe
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `alta_cotxe`(IN `model` VARCHAR(25), IN `any_debut` YEAR, IN `in_equip` MEDIUMINT, IN `temporada` YEAR, OUT `RSP` VARCHAR(250))
BEGIN

declare codi_equip SMALLINT(5);
declare codi_cotxe_afegit MEDIUMINT(8);
declare valor_antic VARCHAR (10);
declare valor_nou VARCHAR (512);
declare consulta_cotxe VARCHAR(512);
declare consulta_equip VARCHAR(512);
declare state VARCHAR(50);
declare msg VARCHAR(250);

declare check_temporada YEAR;


-- Control d'errors

DECLARE EXIT HANDLER FOR 1452
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement la relacio ',model,'-',in_equip,'-',temporada,' ja existeix a la taula \'cotxe_equip\'');
END;

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement el model del cotxe (',model,') ja existeix a la taula \'cotxe\'');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Pot ser que el codi de l\'equip (',in_equip,') no sigui correcte o que la temporada (',temporada,') no existeixi a la taula \'temporada\'');
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;


	SET RSP := 'OK';
	
	-- Es fa servir SELECT INTO per tal de llençar l'excepcio  NOT FOUND si no es troba el codi a la taula
	SELECT e.codi_equip 
	FROM equip e 
	WHERE e.codi_equip = in_equip 
	INTO codi_equip;
	
	SELECT t.any
	FROM temporada t
	WHERE t.any = temporada
	INTO check_temporada;
	
	-- Insertar a la taula
	
	INSERT INTO cotxe(model,any_debut) VALUES (model, any_debut);
	
	
	-- Actualitzar log
	
	SET valor_antic = " - ";
	SET codi_cotxe_afegit = LAST_INSERT_ID();
	SET valor_nou = CONCAT_WS(', ', codi_cotxe_afegit, model, any_debut);
	SET consulta_cotxe = CONCAT("alta_cotxe ('",model,"',",any_debut," '",in_equip,"')");
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'cotxe', valor_antic, valor_nou, NOW(), consulta_cotxe);
	
	
	-- Insertar a la taula
	
	INSERT INTO cotxe_equip VALUES (codi_cotxe_afegit,codi_equip, temporada);
	
	
	-- Actualitzar log
	
	SET valor_nou = CONCAT_WS(', ', codi_cotxe_afegit, codi_equip, temporada);
	SET consulta_equip = CONCAT("INDIRECTE -> alta_cotxe ('",model,"',",any_debut," '",in_equip,"')");
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'cotxe_equip', valor_antic, valor_nou, NOW(), consulta_equip);


END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.alta_cursa
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `alta_cursa`(IN `in_circuit` MEDIUMINT(8), IN `in_pilot` MEDIUMINT(8), IN `in_competicio` SMALLINT(5), IN `in_posicio` SMALLINT, IN `data_cursa` DATE, OUT `RSP` VARCHAR(250))
BEGIN

declare check_circuit MEDIUMINT(8);
declare check_pilot MEDIUMINT(8);
declare check_competicio SMALLINT(5);
declare check_temporada YEAR;
declare check_posicio SMALLINT;
declare valor_antic VARCHAR (10);
declare valor_nou VARCHAR (512);
declare any_temporada YEAR;
declare consulta VARCHAR(512);
declare state VARCHAR(50);
declare msg VARCHAR(250);

declare aux_punts MEDIUMINT;
declare total_punts MEDIUMINT;

declare max_data SMALLINT;
declare loop_data SMALLINT;
declare current_data DATE;
declare current_punts SMALLINT;
declare current_total_punts SMALLINT;

declare pilot_retirat BOOL;
declare current_curses_finalitzades MEDIUMINT;
declare current_victories MEDIUMINT;


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement la cursa ja existeix a la taula \'cursa\'');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,' .Possiblement el pilot (\'',in_pilot,'\'), el codi del circuit (\'',in_circuit,'\') o el codi de la competicio (\'',in_competicio,',', any_temporada,'\') no sigui correcte.');
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';
	SET pilot_retirat = 0;
	SET any_temporada = EXTRACT(YEAR from data_cursa);
	
	-- Es fa servir SELECT INTO per tal de llençar l'excepcio  NOT FOUND si no es troba el codi a la taula
	SELECT ci.codi_circuit 
	FROM circuit ci 
	WHERE ci.codi_circuit = in_circuit 
	INTO check_circuit;
	
	SELECT pi.codi_persona 
	FROM pilot pi 
	JOIN persona pe 
	ON pe.codi_persona = pi.codi_persona 
	WHERE pe.codi_persona = in_pilot 
	INTO check_pilot;
	
	SELECT co.codi_competicio 
	FROM competicio co 
	WHERE co.codi_competicio = in_competicio 
	INTO check_competicio;
	
	SELECT temporada 
	FROM competicio_temporada 
	WHERE temporada = any_temporada
	AND competicio = in_competicio 
	LIMIT 1 
	INTO check_temporada;
	
		
	-- Insertar a la taula
	
	INSERT INTO cursa(circuit,pilot,competicio,posicio,data_cursa) VALUES (in_circuit, in_pilot, in_competicio, in_posicio, data_cursa);

		
	-- Actualitzar log
	
	SET consulta = CONCAT("alta_cursa ('",in_circuit,"', '",in_pilot,"', '",in_competicio,"', ",in_posicio,", ",data_cursa,")");
	SET valor_antic = " - ";
	SET valor_nou = CONCAT_WS(', ', in_circuit, in_pilot, in_competicio, in_posicio, data_cursa);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'cursa', valor_antic, valor_nou, NOW(),consulta);
	
	 CASE in_posicio
      WHEN 1 THEN 
			SET total_punts = 25;
			
			
			-- Actualitzar estadistiques sobre curses guanyades
			
			SET current_victories = (SELECT guanyades FROM dim_resultat dr WHERE dr.pilot = check_pilot );
			
			IF current_victories IS NULL THEN
				INSERT INTO dim_resultat (pilot, guanyades) 
				VALUES (check_pilot, 1);
			ELSE
				UPDATE dim_resultat 
				SET guanyades = guanyades + 1 
				WHERE pilot = check_pilot;
		   END IF;	
			
		   DELETE FROM fact_table_1
			WHERE camp_control = '0xCG';
			
			INSERT INTO fact_table_1(pilot, curses_guanyades, camp_control) 
			SELECT dr.pilot, dr.guanyades, '0xCG' 
			FROM dim_resultat dr 
			ORDER BY dr.guanyades DESC
		LIMIT 10;

      WHEN 2 THEN SET total_punts = 15;
      WHEN 3 THEN SET total_punts = 5;
      WHEN 0 THEN 
      	SET pilot_retirat = 1;
      	SET total_punts = 0;
   ELSE
   	BEGIN
   	SET total_punts = 0;
   	END;
   END CASE;

	
	-- Actualitzar estadistiques sobre curses finalitzades
	
	IF pilot_retirat = 0 THEN
		
		SET current_curses_finalitzades = (SELECT finalitzades FROM dim_resultat dr WHERE dr.pilot = check_pilot );
		
		IF current_curses_finalitzades IS NULL THEN
			INSERT INTO dim_resultat (pilot, finalitzades) 
			VALUES (check_pilot, 1);
		ELSE
			UPDATE dim_resultat 
			SET finalitzades = finalitzades + 1 
			WHERE pilot = check_pilot;
	   END IF;	
		
	   DELETE FROM fact_table_1 
		WHERE camp_control = '0xCF';
		
		INSERT INTO fact_table_1(pilot, curses_finalitzades, camp_control) 
		SELECT dr.pilot, dr.finalitzades, '0xCF' 
		FROM dim_resultat dr 
		ORDER BY dr.finalitzades DESC
		LIMIT 10;
		
	END IF;
	

	-- Actualitzar estadistica classificacio pilots & posicio pilots
	-- La posicio s'escriu directament a la fact table mitjançant un comptador a la select de la taula dim_classificacio a l'hora d'insertar
		
	SET aux_punts = (SELECT punts FROM dim_classificacio WHERE pilot = in_pilot AND competicio = in_competicio AND temporada = any_temporada);
	
	IF aux_punts IS NULL THEN
		INSERT INTO dim_classificacio (competicio, temporada, pilot, punts) 
		VALUES (in_competicio, any_temporada, in_pilot, total_punts);
	ELSE
		UPDATE dim_classificacio 
		SET punts = punts + total_punts
		WHERE pilot = in_pilot 
		AND competicio = in_competicio 
		AND temporada = any_temporada;
   END IF;	
	
   DELETE FROM fact_table_1 
	WHERE camp_control = '0xCP' 
	AND competicio = in_competicio 
	AND temporada = any_temporada ;
   
	INSERT INTO fact_table_1(competicio, temporada, pilot, punts_pilot, posicio_pilot, camp_control) 
   SELECT dc.competicio, dc.temporada, dc.pilot, dc.punts, @rownum:=@rownum+1 posicio, '0xCP' 
	FROM (SELECT @rownum:=0) r, dim_classificacio dc 
	WHERE competicio = in_competicio 
	AND temporada = any_temporada 
	ORDER BY dc.punts DESC;
	
		
	-- Actualitzar estadistica de millor evolucio d'un pilot

	SELECT punts
	INTO current_total_punts
	FROM dim_classificacio
	WHERE temporada = any_temporada
	AND competicio = in_competicio
	AND pilot = in_pilot;
		
	IF(SELECT punts_pilot FROM fact_table_1 ft WHERE ft.camp_control = '0xEP' AND ft.data_cursa = data_cursa AND ft.pilot = in_pilot) IS NULL THEN
		INSERT INTO fact_table_1 (competicio, temporada, pilot, data_cursa, punts_pilot,camp_control) VALUES (in_competicio, any_temporada, in_pilot, data_cursa, current_total_punts, '0xEP');
	END IF;
	
	IF(SELECT punts_pilot FROM fact_table_1 ft WHERE ft.camp_control = '0xEP' AND ft.pilot = in_pilot AND ft.data_cursa != data_cursa AND YEAR(ft.data_cursa) = any_temporada LIMIT 1) IS NOT NULL THEN
		SELECT count(*) 
		INTO max_data 
		FROM (
			SELECT ft.data_cursa FROM fact_table_1 ft 
			WHERE ft.camp_control = '0xEP' 
			AND ft.pilot = in_pilot 
			AND ft.data_cursa != data_cursa 
			AND data_millora IS NULL
			AND YEAR(ft.data_cursa) = any_temporada
		)count_dates;	
				
		SET loop_data = 0;
			
		WHILE loop_data < max_data DO
			
			SELECT ft.data_cursa, ft.punts_pilot
			INTO current_data, current_punts
			FROM fact_table_1 ft 
			WHERE ft.camp_control = '0xEP' 
			AND ft.pilot = in_pilot 
			AND ft.data_cursa != data_cursa 
			AND data_millora IS NULL
			AND YEAR(ft.data_cursa) = any_temporada
			LIMIT loop_data,1;
			
			INSERT INTO fact_table_1 (competicio, temporada, pilot, data_cursa, data_millora, punts_pilot, camp_control) 
			VALUES (in_competicio, any_temporada, in_pilot, current_data, data_cursa, current_total_punts - current_punts, '0xEP');
			
			SET loop_data = loop_data +1;
		END WHILE;
	END IF;
	
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.alta_director
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `alta_director`(IN `in_nom` VARCHAR(100), IN `in_pais` CHAR(2), IN `in_equip` MEDIUMINT, IN `in_estudis` TEXT, IN `in_debut` YEAR, OUT `RSP` VARCHAR(250))
BEGIN

declare codi_equip SMALLINT(5);
declare codi_nacionalitat CHAR(2);
declare codi_persona_afegida MEDIUMINT(8);
declare valor_antic VARCHAR (10);
declare valor_nou VARCHAR (512);
declare consulta_director VARCHAR(512);
declare consulta_persona VARCHAR(512);
declare state VARCHAR(50);
declare msg VARCHAR(250);


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement el director ',codi_persona_afegida,' (',in_nom,') o l\'equip (',in_equip,') ja existeix a la taula \'director\'');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'.Possiblement el nom de l\'equip (',in_equip,') o el codi del pais (',in_pais,') no sigui correcte.');
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;


	SET RSP := 'OK';
	
	-- Es fa servir SELECT INTO per tal de llençar l'excepcio  NOT FOUND si no es troba el codi a la taula.
	SELECT e.codi_equip 
	FROM equip e 
	WHERE e.codi_equip = in_equip 
	INTO codi_equip;
	
	SELECT p.codi_pais 
	FROM pais p 
	WHERE p.codi_pais = in_pais 
	INTO codi_nacionalitat;
	
	-- Si la persona no existeix, cal afegir-la abans que director.
	IF in_nom NOT IN (SELECT nom FROM persona p WHERE p.nom = in_nom) THEN
		INSERT INTO persona(nom,nacionalitat) VALUES (in_nom, codi_nacionalitat);
		SET codi_persona_afegida = LAST_INSERT_ID();
	ELSE
		SET codi_persona_afegida = (SELECT p.codi_persona FROM persona p WHERE p.nom = in_nom);
	END IF;

	
	-- Insertar a la taula
	
	INSERT INTO director VALUES (codi_persona_afegida, codi_equip, in_estudis, in_debut);
	SET valor_nou = CONCAT_WS(', ', codi_persona_afegida, codi_equip, in_estudis, in_debut);
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'pilot', valor_antic, valor_nou, NOW(), consulta_director);
		
		
	-- Actualitzar log
	
	SET consulta_persona = CONCAT("INDIRECTE -> alta_director ('",in_nom,"', '",in_pais,"', '",in_equip,"', '",in_estudis,"', ",in_debut,")");
	SET consulta_director = CONCAT("alta_director ('",in_nom,"', '",in_pais,"', '",in_equip,"', '",in_estudis,"', ",in_debut,")");
	SET valor_antic = " - ";
	SET valor_nou = CONCAT_WS(', ', codi_persona_afegida, in_nom, codi_nacionalitat);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'persona', valor_antic, valor_nou, NOW(), consulta_persona);
	
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.alta_emissora
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `alta_emissora`(IN `nom` VARCHAR(50), IN `nacionalitat` CHAR(2), OUT `RSP` VARCHAR(250))
BEGIN
declare valor_antic VARCHAR (10);
declare valor_nou VARCHAR(512);
declare codi_nacionalitat CHAR(2);
declare consulta VARCHAR(512);
declare state VARCHAR(50);
declare msg VARCHAR(250);


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement el nom de l\'emissora (',nom,') en aquest pais (',codi_nacionalitat,') ja existeix a la taula \'emissora\'');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el codi del pais (',nacionalitat,') no sigui correcte.' );
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;


	SET RSP := 'OK';
	SET consulta = CONCAT("alta_emissora ('",nom,"', '",nacionalitat,"')");
	SELECT p.codi_pais FROM pais p WHERE p.codi_pais = nacionalitat INTO codi_nacionalitat;
	
	
	-- Insertar a la taula
	
	INSERT INTO emissora(nom,pais) VALUES (nom, codi_nacionalitat);
	
		
	-- Actualitzar log
	
	SET valor_nou = CONCAT_WS(', ',LAST_INSERT_ID(),nom, codi_nacionalitat);
	SET consulta = CONCAT("alta_emissora ('",nom,"', '",nacionalitat,"')");
	SET valor_antic = " - ";

	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'emissora', valor_antic, valor_nou, NOW(), consulta);

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.alta_equip
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `alta_equip`(IN `nom` VARCHAR(50), IN `seu` VARCHAR(100), IN `debut` DATE, OUT `RSP` VARCHAR(250))
BEGIN
declare valor_antic VARCHAR (10);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare state VARCHAR(50);
declare msg VARCHAR(250);

-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement el nom de l\'equip (',nom,') ja existeix a la taula \'equip\'');
END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	
	SET RSP := 'OK';
	
	
	-- Insertar a la taula
	
	INSERT INTO equip(nom,seu,data_debut) VALUES (nom, seu, debut);
	

	-- Actualitzar log
	
	set valor_nou = CONCAT_WS(', ',LAST_INSERT_ID(),nom, seu, debut);
	set valor_antic = " - ";
	SET consulta = CONCAT("alta_equip ('",nom,"', '",seu,"', ",debut,")");
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'equip', valor_antic, valor_nou, NOW(), consulta);

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.alta_fabricant
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `alta_fabricant`(IN `nom` VARCHAR(50), IN `debut` YEAR, OUT `RSP` VARCHAR(250))
BEGIN
declare valor_antic VARCHAR (10);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare state VARCHAR(50);
declare msg VARCHAR(250);


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement el nom del fabricant (',nom,') ja existeix a la taula \'fabricant\'');
END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';
	
	
	-- Insertar a la taula
	
	INSERT INTO fabricant(nom,any_debut) VALUES (nom, debut);
	
	
	-- Actualitzar log
	
	SET valor_antic = " - ";
	SET valor_nou = CONCAT_WS(', ',LAST_INSERT_ID(),nom, debut);
	SET consulta = CONCAT("alta_fabricant ('",nom,"', ",debut,")");
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'fabricant', valor_antic, valor_nou, NOW(), consulta);

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.alta_pais
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `alta_pais`(IN `codi` CHAR(2), IN `nom` VARCHAR(50), OUT `RSP` VARCHAR(250))
BEGIN
declare valor_antic VARCHAR (10);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare state VARCHAR(50);
declare msg VARCHAR(250);


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement el nom del pais (',nom,') o el codi (',codi,') ja existeix a la taula \'pais\'.');
END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';
	
	
	-- Insertar a la taula
	
	INSERT INTO pais VALUES (codi, nom);
	
	
	-- Actualitzar log
	
	SET consulta = CONCAT("alta_pais ('",codi,"', '",nom,"')");	
	SET valor_antic = " - ";
	SET valor_nou = CONCAT_WS(', ',LAST_INSERT_ID(),codi, nom);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'pais', valor_antic, valor_nou, NOW(), consulta);
 END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.alta_patrocinador
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `alta_patrocinador`(IN `sector_patrocinador` SMALLINT, IN `nom_patrocinador` VARCHAR(50), OUT `RSP` VARCHAR(250))
BEGIN
declare valor_antic VARCHAR (10);
declare valor_nou VARCHAR (512);
declare codi_sector MEDIUMINT;
declare consulta VARCHAR(512);
declare state VARCHAR(50);
declare msg VARCHAR(250);


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement nom del patrocinador (',nom_patrocinador,') ja existeix a la taula \'patrocinador\'');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el sector del patrocinador (',sector_patrocinador,') no sigui correcte.' );
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;


	SET RSP := 'OK';
		
	SELECT sector.codi_sector FROM sector WHERE sector.codi_sector = sector_patrocinador INTO codi_sector;
	
	
	-- Insertar a la taula
	
	INSERT INTO patrocinador(sector,nom) VALUES (codi_sector, nom_patrocinador);
	
	
	-- Actualitzar log
	
	SET valor_antic = " - ";
	SET valor_nou = CONCAT_WS(', ',LAST_INSERT_ID(),codi_sector, nom_patrocinador);
	SET consulta = CONCAT("alta_patrocinador ('",sector_patrocinador,"', '",nom_patrocinador,"')");
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'patrocinador', valor_antic, valor_nou, NOW(), consulta);

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.alta_patrocini
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `alta_patrocini`(IN `in_patrocinador` MEDIUMINT, IN `in_equip` SMALLINT, IN `temporada` YEAR, IN `cost` INT, OUT `RSP` VARCHAR(250))
BEGIN
declare codi_patrocinador MEDIUMINT(8);
declare codi_equip SMALLINT(5);
declare temporada_check YEAR;
declare valor_antic VARCHAR (10);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare state VARCHAR(50);
declare msg VARCHAR(250);

declare aux_existeix INT;
declare aux_limit TINYINT;
declare aux_delete SMALLINT;


-- Control d'errors

DECLARE EXIT HANDLER FOR 1644 
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT("ERROR: Codi ",state,". ",msg);
END;

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
SET RSP := CONCAT('ERROR: Codi ',state,'. Ja existeix aquest patrocini (',in_patrocinador,', ',in_equip,'), per aquesta temporada (',temporada,') a la taula \'patrocini\'.');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,' .Possiblement l\'equip (\'',in_equip,'\'), el patrocinador (\'',in_patrocinador,'\'), o la temporada (',temporada,') no existeixen al sistema.');
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;


	SET RSP := 'OK';
		
	-- Es fa servir SELECT INTO per tal de llençar l'excepcio  NOT FOUND si no es troba el codi a la taula.
	SELECT p.codi_patrocinador 
	FROM patrocinador p 
	WHERE p.codi_patrocinador = in_patrocinador 
	INTO codi_patrocinador;
	
	SELECT e.codi_equip 
	FROM equip e 
	WHERE e.codi_equip = in_equip 
	INTO codi_equip;
	
	SELECT t.any 
	FROM temporada t 
	WHERE t.any = temporada 
	INTO temporada_check;
	
	INSERT INTO patrocini 
	VALUES (codi_patrocinador, codi_equip, temporada, cost);
	
	
	-- Actualitzar log
	
	SET consulta = CONCAT("alta_patrocini ('",in_patrocinador,"', '",in_equip,"', ",temporada,", ",cost,")");
	SET valor_antic = " - ";
	SET valor_nou = CONCAT_WS(', ', codi_patrocinador, codi_equip, temporada, cost);
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'patrocini', valor_antic, valor_nou, NOW(), consulta);
	

	-- Actualitzar estadistiques
	
	SET aux_existeix = (SELECT cost FROM dim_patrocini  WHERE dim_patrocini.patrocinador = codi_patrocinador);
	
	IF aux_existeix IS NULL THEN
		INSERT INTO dim_patrocini (patrocinador, cost) 
		VALUES (codi_patrocinador, cost);
	ELSE
		UPDATE dim_patrocini 
		SET dim_patrocini.cost = dim_patrocini.cost + cost 
		WHERE dim_patrocini.patrocinador = codi_patrocinador;
   END IF;	
   
   DELETE FROM fact_table_1 WHERE fact_table_1.camp_control = '0xPA';
   INSERT INTO fact_table_1(patrocinador, cost_patrocini, camp_control) 
   SELECT dp.patrocinador, dp.cost, '0xPA' 
	FROM dim_patrocini dp 
	ORDER BY dp.cost DESC 
	LIMIT 5;

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.alta_pilot
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `alta_pilot`(IN `nom` VARCHAR(100), IN `nacionalitat` CHAR(2), IN `in_equip` MEDIUMINT, IN `llicencia` VARCHAR(8), IN `inici` YEAR, OUT `RSP` VARCHAR(250))
BEGIN

declare codi_equip SMALLINT(5);
declare codi_nacionalitat CHAR(2);
declare codi_persona_afegida MEDIUMINT(8);
declare valor_antic VARCHAR (10);
declare valor_nou VARCHAR (512);
declare consulta_pilot VARCHAR(512);
declare consulta_persona VARCHAR(512);
declare state VARCHAR(50);
declare msg VARCHAR(250);


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement el pilot ',codi_persona_afegida,' (',nom,') ja existeix a la taula \'pilot\'');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Pot ser que el codi de l\'equip (',in_equip,') o el codi del pais (',nacionalitat,') no sigui correcte.');
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;


	SET RSP := 'OK';
	
	-- Es fa servir SELECT INTO per tal de llençar l'excepcio  NOT FOUND si no es troba el codi a la taula.
	SELECT e.codi_equip FROM equip e WHERE e.codi_equip = in_equip INTO codi_equip;
	SELECT p.codi_pais FROM pais p WHERE p.codi_pais = nacionalitat INTO codi_nacionalitat;
	
	-- Si la persona no existeix, cal afegir-la abans que director.
	IF nom NOT IN (SELECT nom FROM persona p WHERE p.nom = nom) THEN
		INSERT INTO persona(nom,nacionalitat) VALUES (nom, codi_nacionalitat);
		SET codi_persona_afegida = LAST_INSERT_ID();
	ELSE
		SET codi_persona_afegida = (SELECT p.codi_persona FROM persona p WHERE p.nom = nom);
	END IF;
	
	
	-- Actualitzar log
		
	SET valor_antic = " - ";
	SET consulta_persona = CONCAT("INDIRECTE -> alta_director ('",nom,"', '",nacionalitat,"', '",in_equip,"', '",llicencia,"', ",inici,")");
	SET valor_nou = CONCAT_WS(', ', codi_persona_afegida, nom, codi_nacionalitat);
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'persona', valor_antic, valor_nou, NOW(), consulta_persona);
	
	
	-- Insertar a la taula
	
	INSERT INTO pilot VALUES (codi_persona_afegida, codi_equip, llicencia, inici);
			
	
	-- Actualitzar log
	
	SET consulta_pilot = CONCAT("alta_director ('",nom,"', '",nacionalitat,"', '",in_equip,"', '",llicencia,"', ",inici,")");
	SET valor_nou = CONCAT_WS(', ', codi_persona_afegida, codi_equip, llicencia, inici);
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'pilot', valor_antic, valor_nou, NOW(), consulta_pilot);


END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.alta_pilot_cotxe
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `alta_pilot_cotxe`(IN `in_pilot` MEDIUMINT, IN `in_cotxe` MEDIUMINT, IN `in_temporada` YEAR, OUT `RSP` VARCHAR(250))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare check_pilot MEDIUMINT;
declare check_cotxe MEDIUMINT;
declare check_temporada YEAR;


DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement ja existeix aquesta entrada a la taula pilot_cotxe.');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
	SET RSP := CONCAT('ERROR: Not found. Codi ',state,' .Possiblement el pilot (\'',in_pilot,'\') o el cotxe (\'',in_cotxe,'\') no siguin correctes.');
END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;


		
	SET RSP := 'OK';

	-- Es fa servir SELECT INTO per tal de llençar l'excepcio  NOT FOUND si no es troba el codi a la taula
	SELECT p.codi_persona
	FROM pilot p
	WHERE p.codi_persona = in_pilot 
	INTO check_pilot;
	
	SELECT c.codi_cotxe
	FROM cotxe c
	WHERE c.codi_cotxe = in_cotxe 
	INTO check_cotxe;
	
	SELECT t.any
	FROM temporada t
	WHERE t.any = in_temporada 
	INTO check_temporada;
	
	
	-- Insertar a la taula
	
	INSERT INTO pilot_cotxe VALUES (in_pilot, in_cotxe, in_temporada);
	
	
	-- Actualitzar log
	
	set valor_antic = " - ";
	SET valor_nou = CONCAT_WS(',',in_pilot, in_cotxe, in_temporada);
	SET consulta = CONCAT("alta_pilot_cotxe ('",in_pilot,"', '",in_cotxe,"', '",in_temporada,"')");
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'competicio_temporada', valor_antic, valor_nou, NOW(), consulta);
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.alta_retransmissio
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `alta_retransmissio`(IN `in_emissora` MEDIUMINT, IN `pais_emissio` CHAR(2), IN `in_competicio` VARCHAR(50), OUT `RSP` VARCHAR(250))
BEGIN
declare valor_antic VARCHAR (10);
declare valor_nou VARCHAR (512);
declare codi_nacionalitat CHAR(2);
declare consulta VARCHAR(512);
declare codi_emissora SMALLINT(5);
declare codi_competicio SMALLINT(5);
declare state VARCHAR(50);
declare msg VARCHAR(250);


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
SET RSP := CONCAT('ERROR: Codi ',state,'. Ja existeix aquesta retransmissio (',in_emissora,', ',in_competicio,'), a la taula \'retransmissio\'');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,' .Possiblement l\'emissora (\'',in_emissora,'\'), 
							el codi del pais (\'',pais_emissio,'\') o la competicio (\'',in_competicio,'\') no sigui correcte, o ',in_emissora,' no emet a ',pais_emissio,'.');
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;


	SET RSP := 'OK';
	
	-- Es fa servir SELECT INTO per tal de llençar l'excepcio  NOT FOUND si no es troba el codi a la taula
	SELECT c.codi_competicio FROM competicio c WHERE c.codi_competicio = in_competicio INTO codi_competicio;
	SELECT p.codi_pais FROM pais p WHERE p.codi_pais = pais_emissio INTO codi_nacionalitat;
	SELECT e.codi_emissora FROM emissora e WHERE e.codi_emissora = in_emissora AND e.pais = pais_emissio INTO codi_emissora;
	

	-- Insertar a la taula

	INSERT INTO retransmissio VALUES (codi_emissora, codi_competicio);
				
	
	-- Actualitzar log
	
	SET consulta = CONCAT("alta_retransmissio ('",in_emissora,"', '",codi_nacionalitat,"', '",in_competicio,")");
	SET valor_antic = " - ";
	SET valor_nou = CONCAT_WS(', ', codi_emissora, codi_competicio);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'retransmissio', valor_antic, valor_nou, NOW(), consulta);

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.alta_sector
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `alta_sector`(IN `nom` VARCHAR(50), OUT `RSP` VARCHAR(250))
BEGIN
declare valor_antic VARCHAR (10);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare state VARCHAR(50);
declare msg VARCHAR(250);


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement el nom del sector (',nom,') ja existeix a la taula \'sector\'.');
END;

DECLARE CONTINUE HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';


	-- Insertar a la taula

	INSERT INTO sector(nom) VALUES (nom);

	
	-- Actualitzar log

	SET consulta = CONCAT("alta_sector ('",nom,"')");
	SET valor_antic = " - ";	
	SET valor_nou = CONCAT_WS(', ', LAST_INSERT_ID(), nom);
	
	INSERT INTO log VALUES (default, 'ALTA', 'patrocini', valor_antic, valor_nou, NOW(), consulta);

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.alta_telemetria
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `alta_telemetria`(IN `in_component` MEDIUMINT, IN `in_moment` DATETIME(6), IN `in_ambit` VARCHAR(50), IN `in_valor` FLOAT, IN `in_unitats` VARCHAR(25), OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (10);
declare valor_nou VARCHAR (512);
declare check_component MEDIUMINT;
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare aux_temps TIME;
declare current_dades MEDIUMINT;
declare current_temperatura FLOAT(8,2);
declare current_consum_cotxe FLOAT(10,2);
declare check_cotxe SMALLINT;
declare check_equip SMALLINT;

declare current_year YEAR;
declare current_competicio SMALLINT;
declare current_pilot SMALLINT;
declare current_circuit SMALLINT;

declare comp MEDIUMINT;
declare percentatge_defectuos DECIMAL(4,1);
declare equip_max_punts SMALLINT;


-- Control d'errors

DECLARE EXIT HANDLER FOR 1644 
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT, comp = COLUMN_NAME;
	SET RSP := CONCAT("ERROR: Codi ",state,". ",msg," Component: ",comp);
	
	
	-- Actualitzar estadistiques de component defectuos
	
	SELECT cotxe 
	FROM component c 
	WHERE c.codi_component = comp 
	INTO check_cotxe;
	
	UPDATE dim_defectuos 
	SET defectuos = 1
	WHERE component = comp
	AND cotxe = check_cotxe;
	
	SELECT (SUM(CASE WHEN defectuos = 1 THEN 1 ELSE 0 END)/COUNT(*)*100) 
	FROM dim_defectuos WHERE cotxe = check_cotxe
	INTO percentatge_defectuos;
	
	UPDATE fact_table_1
	SET components_defectuosos = percentatge_defectuos
	WHERE cotxe = check_cotxe
	AND camp_control = '0xCD';
 		
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el codi del component (',in_component,') o la data (',in_moment,') no siguin correctes.' );
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;


	SET RSP := 'OK';
	SET current_year = YEAR(in_moment);
	
	-- Es fa servir SELECT INTO per tal de llençar l'excepcio  NOT FOUND si no es troba el codi a la taula
	SELECT c.codi_component 
	FROM component c 
	WHERE c.codi_component = in_component 
	INTO check_component;
	
	SELECT cotxe 
	FROM component c 
	WHERE c.codi_component = in_component 
	INTO check_cotxe;
	
	SELECT equip 
	FROM cotxe_equip 
	WHERE cotxe = check_cotxe 
	INTO check_equip;
	
	
	-- Insertar a la taula
	
	INSERT INTO telemetria(component,moment,ambit,valor,unitat_de_mesura) 
	VALUES (in_component, in_moment, in_ambit, in_valor, in_unitats);


	-- Actualitzar log
	
	SET valor_antic = " - ";
	SET valor_nou = CONCAT_WS(', ', LAST_INSERT_ID(), in_component, in_moment, in_ambit, in_valor, in_unitats);
	SET consulta = CONCAT("alta_telemetria ('",in_component,"','",in_moment,"', '",in_ambit,"', '",in_valor,"', '",in_unitats,"')");
		
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'telemetria', valor_antic, valor_nou, NOW(),consulta);


	-- Actualitzar estadistiques de consum per competicio i temporada.
	
 	CASE in_ambit
      WHEN 'consum' THEN
			SELECT pilot 
			INTO current_pilot 
			FROM pilot_cotxe 
			WHERE temporada = current_year 
			AND cotxe = check_cotxe;
			
			SELECT competicio 
			INTO current_competicio 
			FROM cursa 
			WHERE data_cursa = DATE(in_moment) 
			AND pilot = current_pilot;
			
			SET current_consum_cotxe = (SELECT consum FROM dim_consum WHERE temporada = current_year AND competicio = current_competicio AND cotxe =  check_cotxe);
			
			IF current_consum_cotxe IS NULL THEN
				INSERT INTO dim_consum (competicio, temporada, cotxe, consum) 
				VALUES (current_competicio, current_year, check_cotxe, in_valor);
			ELSE				
				UPDATE dim_consum dc
				SET dc.consum =  dc.consum + in_valor
				WHERE dc.temporada = current_year 
				AND dc.competicio = current_competicio
				AND dc.cotxe = check_cotxe;
		   END IF;	
		   
		   DELETE FROM fact_table_1 
			WHERE camp_control = '0xCC' 
			AND temporada = current_year 
			AND competicio = current_competicio;
			
		   INSERT INTO fact_table_1(competicio, temporada, cotxe, consum_cotxe, camp_control) 
		   SELECT dc.competicio, dc.temporada, dc.cotxe, dc.consum, '0xCC' 
			FROM dim_consum dc 
			WHERE dc.competicio = current_competicio 
			AND dc.temporada = current_year 
			ORDER BY dc.consum DESC 
			LIMIT 1;
		   
		   
		-- Actualitzar estadistiques de temperatura maxima trobada al sistema (data, la cursa, el cotxe, el pilot i el valor.)
		
      WHEN 'temperatura' THEN
      	SELECT pilot 
			INTO current_pilot 
			FROM pilot_cotxe 
			WHERE temporada = current_year 
			AND cotxe = check_cotxe;
			
			SELECT competicio, circuit 
			INTO current_competicio, current_circuit 
			FROM cursa 
			WHERE data_cursa = DATE(in_moment) 
			AND pilot = current_pilot;
			
      	SET current_temperatura = (SELECT temperatura_maxima FROM fact_table_1 WHERE camp_control = '0xTM');
      	
      	IF current_temperatura IS NULL THEN
				INSERT INTO fact_table_1 (competicio, temporada, pilot, cotxe, circuit, data_cursa, temperatura_maxima, camp_control) 
				VALUES (current_competicio, current_year, current_pilot, check_cotxe, current_circuit, DATE(in_moment), in_valor, '0xTM');
			ELSE
				IF in_valor > (SELECT temperatura_maxima FROM fact_table_1 WHERE camp_control = '0xTM') THEN
					DELETE FROM fact_table_1
					WHERE camp_control = '0xTM';
					
					INSERT INTO fact_table_1 (competicio, temporada, pilot, cotxe, circuit, data_cursa, temperatura_maxima, camp_control) 
					VALUES (current_competicio, current_year, current_pilot, check_cotxe, current_circuit, DATE(in_moment), in_valor, '0xTM');
				END IF;
		   END IF;	
      
      
      -- Actualitzar estadistiques de volta rápida per circuit
      
      WHEN 'temps per volta' THEN
			
			SELECT pilot 
			INTO current_pilot 
			FROM pilot_cotxe 
			WHERE temporada = current_year 
			AND cotxe = check_cotxe;
			
			SELECT circuit 
			INTO current_circuit 
			FROM cursa 
			WHERE data_cursa = DATE(in_moment) 
			AND pilot = current_pilot;
			
			SET aux_temps = (TIME_FORMAT(SEC_TO_TIME(in_valor/1000),'%i:%s'));

			INSERT INTO dim_volta_rapida (circuit, pilot, equip,  data, temps) 
			VALUES (current_circuit, current_pilot, check_equip, DATE(in_moment), aux_temps);

			DELETE FROM fact_table_1 WHERE circuit = current_circuit AND camp_control = '0xVR';			
			
			INSERT INTO fact_table_1 (circuit, pilot, equip, data_cursa, volta_rapida, camp_control) 		
			SELECT dvr.circuit, dvr.pilot, dvr.equip,  dvr.data, dvr.temps, '0xVR'
			FROM dim_volta_rapida dvr
			WHERE dvr.circuit = current_circuit
			ORDER BY temps 
			LIMIT 10;
   ELSE
   	BEGIN
   	
   	END;
   END CASE;


	-- Actualitzar estadistiques de volum telemetria
	
	SET current_dades = (SELECT dades_any FROM dim_telemetria WHERE temporada = current_year AND equip = check_equip);
	
	IF current_dades IS NULL THEN
		INSERT INTO dim_telemetria (temporada, equip, dades_any) 
		VALUES (current_year, check_equip, 1);
	ELSE
		UPDATE dim_telemetria dt
		SET dt.dades_any =  dt.dades_any + 1 
		WHERE dt.temporada = current_year 
		AND dt.equip = check_equip;
   END IF;	
   	
   DELETE FROM fact_table_1 WHERE camp_control = '0xTE' AND temporada = current_year;
   
   SELECT dt.equip 
   INTO equip_max_punts
   FROM dim_telemetria dt
   WHERE dt.temporada = current_year 
   ORDER BY dt.dades_any DESC
	LIMIT 1;
   
   INSERT INTO fact_table_1(temporada, equip, dades_telemetriques, camp_control) 
   SELECT dt.temporada, equip_max_punts, SUM(dt.dades_any), '0xTE' 
	FROM dim_telemetria dt 
	WHERE dt.temporada = current_year 
	ORDER BY dt.dades_any DESC
	LIMIT 1;
	
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.alta_temporada
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `alta_temporada`(IN `any_nou` YEAR, IN `in_competicio` SMALLINT, OUT `RSP` VARCHAR(250))
BEGIN

declare valor_antic VARCHAR (10);
declare valor_nou VARCHAR (512);
declare codi_competicio SMALLINT(5);
declare consulta_temporada VARCHAR(512);
declare consulta_competicio_any VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
SET RSP := CONCAT('ERROR: Codi ',state,'. Ja existeix aquesta competicio (\'',in_competicio,'\'), a aquesta temporada (',any_nou,')');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
	SET RSP := CONCAT('ERROR: Not found. Codi ',state,' .Possiblement la competicio (\'',in_competicio,'\'), no sigui correcte.');
END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';
	SET valor_antic = " - ";
	
	-- Si l'any no existeix a la taula temporada, s'afegeix.
	IF any_nou NOT IN (SELECT t.any FROM temporada t) THEN
		INSERT INTO temporada VALUES (any_nou);
		SET consulta_temporada = CONCAT("INDIRECTE->alta_temporada (",any_nou,"', ",in_competicio,"')");
		SET valor_nou = any_nou;
		INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'temporada', valor_antic, valor_nou, NOW(), consulta_temporada);
	END IF;
	
	SET consulta_competicio_any = CONCAT("alta_temporada (",any_nou,", ",in_competicio,"')");
	SELECT co.codi_competicio FROM competicio co WHERE co.codi_competicio = in_competicio INTO codi_competicio;
	SET valor_nou = CONCAT_WS(', ', any_nou, codi_competicio);
	INSERT INTO competicio_temporada VALUES (codi_competicio, any_nou);
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('ALTA', 'competicio_temporada', valor_antic, valor_nou, NOW(), consulta_competicio_any );

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.baixa_circuit
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `baixa_circuit`(IN `codi` MEDIUMINT, OUT `RSP` VARCHAR(250))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (10);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare nom VARCHAR(50);
declare sobrenom VARCHAR(50);
declare longitud SMALLINT;
declare codi_pais CHAR(2);


-- Control d'errors

DECLARE EXIT HANDLER FOR NOT FOUND
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
	SET RSP := CONCAT('ERROR: Not found. Codi ',state,' .Possiblement el codi circuit (',codi,'), no sigui correcte.');
END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';
	
	SELECT c.nom, c.sobrenom, c.longitud, c.pais 
	INTO nom, sobrenom, longitud, codi_pais 
	FROM circuit c 
	WHERE c.codi_circuit = codi;

	
	-- Esborra de la taula

	DELETE FROM cursa WHERE circuit = codi;
	

	-- Actualitzar log

	SET valor_nou = " - ";
	SET consulta = CONCAT("INDIRECTE -> baixa_circuit (",codi,")");
	SET valor_antic = CONCAT("curses relatives circuit ",codi);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'cursa', valor_antic, valor_nou, NOW(), consulta);
	
	
	-- Esborra de la taula
	
	DELETE FROM circuit  WHERE codi_circuit = codi; 
	

	-- Actualitzar log
	
	SET consulta = CONCAT("baixa_circuit (",codi,")");
	SET valor_antic = CONCAT_WS(',', codi, nom, sobrenom, longitud, codi_pais);

	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'circuit', valor_antic, valor_nou, NOW(), consulta);
	
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.baixa_competicio
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `baixa_competicio`(IN `codi` SMALLINT, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (10);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare nom VARCHAR(50);
declare acronim VARCHAR(10);
declare descripcio TEXT;


-- Control d'errors

DECLARE EXIT HANDLER FOR NOT FOUND
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
	SET RSP := CONCAT('ERROR: Not found. Codi ',state,' .Possiblement el codi competicio (',codi,'), no sigui correcte.');
END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';
	
	SELECT c.nom, c.acronim, c.descripcio
	INTO nom, acronim, descripcio 
	FROM competicio c 
	WHERE c.codi_competicio = codi;
	
	IF (SELECT competicio FROM competicio_temporada WHERE competicio = codi) IS NOT NULL THEN
			
		-- Esborra de la taula
	
		DELETE FROM competicio_temporada WHERE competicio = codi;
			

		-- Actualitzar log
	
		SET valor_nou = " - ";
		SET consulta = CONCAT("INDIRECTE -> baixa_competicio (",codi,")");
		SET valor_antic = CONCAT("files relatives a la competicio ",codi);
		
		INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'competicio_temporada', valor_antic, valor_nou, NOW(), consulta);
	END IF;
	
	IF (SELECT competicio FROM retransmissio WHERE competicio = codi) IS NOT NULL THEN
			
	
		-- Esborra de la taula
	
		DELETE FROM retransmissio WHERE competicio = codi;
			

		-- Actualitzar log
		
		SET consulta = CONCAT("INDIRECTE -> baixa_competicio (",codi,")");
		SET valor_antic = CONCAT("retransmissions relatives a la competicio ",codi);
		
		INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'retransmissio', valor_antic, valor_nou, NOW(), consulta);
	END IF;
	
	IF (SELECT competicio FROM cursa WHERE competicio = codi) IS NOT NULL THEN	
			
	
		-- Esborra de la taula
	
		DELETE FROM cursa WHERE competicio = codi;
			

		-- Actualitzar log
	
		SET consulta = CONCAT("INDIRECTE -> baixa_competicio (",codi,")");
		SET valor_antic = CONCAT("curses relatives a la competicio ",codi);
		
		INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'cursa', valor_antic, valor_nou, NOW(), consulta);
	END IF;
		
	
	-- Esborra de la taula
	
	DELETE FROM competicio WHERE codi_competicio = codi;

	-- Actualitzar log
	
	SET consulta = CONCAT("baixa_competicio (",codi,")");
	SET valor_antic = CONCAT_WS(',', codi, nom, acronim, descripcio);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'competicio', valor_antic, valor_nou, NOW(), consulta);

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.baixa_component
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `baixa_component`(IN `codi` MEDIUMINT, OUT `RSP` VARCHAR(512))
BEGIN


declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (10);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare codi_fabricant MEDIUMINT;
declare codi_cotxe MEDIUMINT;
declare descripcio TEXT;
declare utilitat TEXT;
declare in_telemetria BIGINT;
declare percentatge_defectuos DECIMAL(4,1);


-- Control d'errors

DECLARE EXIT HANDLER FOR NOT FOUND
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
	SET RSP := CONCAT('ERROR: Not found. Codi ',state,' .Possiblement el codi component (',codi,'), no sigui correcte.');
END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';
	
	SELECT c.fabricant, c.cotxe, c.descripcio, c.utilitat
	INTO codi_fabricant, codi_cotxe, descripcio, utilitat
	FROM component c 
	WHERE c.codi_component = codi;
	
	WHILE (SELECT codi_dada FROM telemetria WHERE component = codi LIMIT 1) IS NOT NULL DO
	   SELECT codi_dada FROM telemetria WHERE component = codi LIMIT 1 INTO in_telemetria;
	   call baixa_telemetria(in_telemetria, RSP);
	END WHILE;
				
	
	-- Esborra de la taula
	
	DELETE FROM component WHERE codi_component = codi;
	
	
	-- Actualitzar log
	
	SET valor_nou = " - ";
	SET consulta = CONCAT("baixa_component (",codi,")");
	SET valor_antic = CONCAT_WS(',', codi, codi_fabricant, codi_cotxe, descripcio, utilitat);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'component', valor_antic, valor_nou, NOW(), consulta);
	
	
	-- Actualitzar estadistiques de quantitat de components
	
	UPDATE dim_component dc
	SET dc.components = dc.components - 1
	WHERE dc.fabricant = codi_fabricant;
	
	DELETE FROM fact_table_1 WHERE camp_control = '0xQC';
   INSERT INTO fact_table_1(fabricant, quantitat_components, camp_control) 
   SELECT dc.fabricant, dc.components, '0xQC' FROM dim_component dc ORDER BY dc.components DESC LIMIT 5;
   
   
   -- Actualitzar estadistiques de components defectuosos
   
	DELETE FROM dim_defectuos
	WHERE component = codi
	AND cotxe = codi_cotxe;
	
	SELECT (SUM(CASE WHEN defectuos = 1 THEN 1 ELSE 0 END)/COUNT(*)*100) 
	FROM dim_defectuos WHERE cotxe = codi_cotxe
	INTO percentatge_defectuos;
	
	IF percentatge_defectuos IS NULL THEN
		DELETE FROM fact_table_1
		WHERE cotxe = codi_cotxe
		AND camp_control = '0xCD';
	END IF;
	
	UPDATE fact_table_1
	SET components_defectuosos = percentatge_defectuos
	WHERE cotxe = codi_cotxe
	AND camp_control = '0xCD';

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.baixa_cotxe
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `baixa_cotxe`(IN `codi` MEDIUMINT, OUT `RSP` VARCHAR(512))
BEGIN


declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (10);
declare consulta VARCHAR(512);
declare in_component MEDIUMINT;
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare model VARCHAR(25);
declare any_debut YEAR;


-- Control d'errors

DECLARE EXIT HANDLER FOR NOT FOUND
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
	SET RSP := CONCAT('ERROR: Not found. Codi ',state,' .Possiblement el codi cotxe (',codi,'), no sigui correcte.');
END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';
	
	SELECT c.model, c.any_debut
	INTO model, any_debut
	FROM cotxe c 
	WHERE c.codi_cotxe = codi;
	
	WHILE (SELECT codi_component FROM component WHERE cotxe = codi LIMIT 1) IS NOT NULL DO
	   SELECT codi_component FROM component WHERE cotxe = codi LIMIT 1 INTO in_component;
	   call baixa_component(in_component, RSP);
	END WHILE;
					
	
	-- Esborra de la taula
	
	DELETE FROM cotxe_equip WHERE cotxe = codi;
		
	
	-- Actualitzar log

	SET valor_nou = " - ";
	SET consulta = CONCAT("INDIRECTE -> baixa_cotxe (",codi,")");
	SET valor_antic = CONCAT("files relatives al cotxe ",codi);
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'cotxe_equip', valor_antic, '-', NOW(), consulta);
					
	
	-- Esborra de la taula
	
	DELETE FROM cotxe WHERE codi_cotxe = codi;
	SET consulta = CONCAT("baixa_cotxe (",codi,")");
	SET valor_antic = CONCAT_WS(',', codi, model, any_debut);
			
	
	-- Actualitzar log

	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'cotxe', valor_antic, valor_nou, NOW(), consulta);

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.baixa_cursa
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `baixa_cursa`(IN `in_circuit` MEDIUMINT, IN `in_pilot` MEDIUMINT, IN `in_competicio` SMALLINT, IN `in_data` DATE, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (10);

declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare in_posicio SMALLINT;
declare check_circuit MEDIUMINT;
declare check_pilot MEDIUMINT;
declare check_competicio SMALLINT;
declare total_punts SMALLINT;

declare any_temporada YEAR;
declare pilot_retirat BOOL;


-- Control d'errors

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el codi del circuit (',in_circuit,'), del pilot (',in_pilot,') o de la competicio (',in_competicio,') no sigui correcte.' );
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;


	SET RSP := 'OK';
	SET any_temporada = YEAR(in_data);
	SET pilot_retirat = 0;
	
	SELECT codi_competicio FROM competicio WHERE codi_competicio = in_competicio INTO check_competicio;
	SELECT codi_circuit FROM circuit WHERE codi_circuit = in_circuit INTO check_circuit;
	SELECT codi_persona FROM pilot WHERE codi_persona = in_pilot INTO check_pilot;
	
	SELECT c.posicio
	INTO in_posicio
	FROM cursa c 
	WHERE c.competicio = in_competicio 
	AND c.circuit = in_circuit
	AND c.pilot = in_pilot
	AND c.data_cursa = in_data;
		
	
	-- Esborra de la taula
	
	DELETE FROM cursa 
	WHERE competicio = in_competicio
	AND circuit = in_circuit
	AND pilot = in_pilot
	AND data_cursa = in_data;
	
	
	-- Actualitzar log
	
	SET valor_nou = " - ";
	SET consulta = CONCAT("baixa_cursa (",in_circuit,",",in_pilot,",",in_competicio,")");
	SET valor_antic = CONCAT_WS(',', in_circuit, in_pilot, in_competicio, in_posicio,in_data);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'cursa', valor_antic, valor_nou, NOW(), consulta);

	CASE in_posicio
      WHEN 1 THEN 
			SET total_punts = 25;
			
			-- Actualitzar estadistiques sobre curses guanyades
			
			UPDATE dim_resultat 
			SET guanyades = guanyades - 1 
			WHERE pilot = check_pilot;
			
		   DELETE FROM fact_table_1 
			WHERE camp_control = '0xCG';
			
			INSERT INTO fact_table_1(pilot, curses_guanyades, camp_control) 
			SELECT dr.pilot, dr.guanyades, '0xCG' 
			FROM dim_resultat dr 
			ORDER BY dr.guanyades DESC;

      WHEN 2 THEN SET total_punts = 15;
      WHEN 3 THEN SET total_punts = 25;
      WHEN 0 THEN 
			SET total_punts = 0;
			SET pilot_retirat = 1;      
   ELSE
   	BEGIN
   		SET total_punts = 0;
   	END;
   END CASE;
	
	
	-- Actualitzar estadistiques sobre classificacio i posicio
	
	UPDATE dim_classificacio 
	SET punts = punts - total_punts 
	WHERE pilot = in_pilot 
	AND competicio = in_competicio 
	AND temporada = any_temporada;
	
   DELETE FROM fact_table_1 
	WHERE camp_control = '0xCP' 
	AND competicio = in_competicio 
	AND temporada = any_temporada ;
   
	INSERT INTO fact_table_1(competicio, temporada, pilot, punts_pilot, posicio_pilot, camp_control) 
   SELECT dc.competicio, dc.temporada, dc.pilot, dc.punts, @rownum:=@rownum+1 posicio, '0xCP' 
	FROM (SELECT @rownum:=0) r, dim_classificacio dc 
	WHERE competicio = in_competicio 
	AND temporada = any_temporada 
	ORDER BY dc.punts DESC;
	
	
	-- Actualitzar estadistiques sobre curses finalitzades
	
	IF pilot_retirat = 0 THEN
		UPDATE dim_resultat 
		SET finalitzades = finalitzades - 1 
		WHERE pilot = in_pilot;

	   DELETE FROM fact_table_1 WHERE camp_control = '0xCF';
		INSERT INTO fact_table_1(pilot, curses_finalitzades, camp_control) 
		
		SELECT dr.pilot, dr.finalitzades, '0xCF' 
		FROM dim_resultat dr 
		ORDER BY dr.finalitzades DESC
		LIMIT 10;	
	END IF;
	
	
	-- Actualitzar estadistiques sobre la millor evolucio d'un pilot

	DELETE FROM fact_table_1 
	WHERE camp_control = '0xEP' 
	AND pilot = in_pilot 
	AND (data_cursa = in_data OR data_millora = in_data)
	AND YEAR(data_cursa) = any_temporada
	AND competicio = in_competicio;
	
	UPDATE fact_table_1 ft
	SET ft.punts_pilot = ft.punts_pilot - total_punts
	WHERE ft.camp_control = '0xEP' 
	AND ft.pilot = in_pilot
	AND ft.data_cursa < in_data
	AND ft.data_millora > in_data
	AND YEAR(ft.data_cursa) = any_temporada
	AND competicio = in_competicio; 
	
	UPDATE fact_table_1 ft
	SET ft.punts_pilot = ft.punts_pilot - total_punts
	WHERE ft.camp_control = '0xEP' 
	AND ft.pilot = in_pilot
	AND ft.data_cursa > in_data
	AND ft.data_millora IS NULL
	AND YEAR(ft.data_cursa) = any_temporada
	AND competicio = in_competicio; 
	
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.baixa_director
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `baixa_director`(IN `in_persona` MEDIUMINT, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (10);
declare in_equip SMALLINT;
declare in_estudis TEXT;
declare in_any_inici YEAR;
declare in_nom VARCHAR(100);
declare in_pais CHAR(2);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);


-- Control d'errors

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el codi de la persona (',in_persona,') no sigui correcte.' );
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;


	SET RSP := 'OK';
	SET valor_nou = " - ";
	
	call baixa_pilot;
	SELECT d.equip, d.estudis, d.any_inici
	INTO in_equip, in_estudis, in_any_inici
	FROM director d
	WHERE d.codi_persona = in_persona;
	
	SELECT p.nom, p.nacionalitat
	INTO in_nom, in_pais
	FROM persona p
	WHERE p.codi_persona = in_persona;

	
	-- Esborra de la taula
	
	DELETE FROM director  
	WHERE codi_persona = in_persona;
		
	
	-- Actualitzar log
	
	SET consulta = CONCAT("baixa_director (",in_persona,")");
	SET valor_antic = CONCAT_WS(',',in_persona, in_equip, in_estudis, in_any_inici);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'director', valor_antic, valor_nou, NOW(), consulta);
		
	
	-- Esborra de la taula
	
	DELETE FROM persona  
	WHERE codi_persona = in_persona;
		
	
	-- Actualitzar log
	
	SET consulta = CONCAT("INDIRECTE->baixa_director (",in_persona,")");
	SET valor_antic = CONCAT_WS(',',in_persona, in_nom, in_pais);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'persona', valor_antic, valor_nou, NOW(), consulta);

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.baixa_emissora
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `baixa_emissora`(IN `in_emissora` SMALLINT, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (10);
declare in_competicio SMALLINT;
declare in_nom VARCHAR(50);
declare in_pais CHAR(2);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare del_emissora SMALLINT;
declare del_competicio SMALLINT;


-- Control d'errors

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el codi de la emissora (',in_emissora,') no sigui correcte.' );
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';
		
	SELECT e.nom, e.pais
	INTO in_nom, in_pais
	FROM emissora e
	WHERE e.codi_emissora = in_emissora;
	
	WHILE (SELECT emissora FROM retransmissio WHERE emissora = in_emissora LIMIT 1) IS NOT NULL DO
	   SELECT emissora, competicio FROM retransmissio WHERE emissora = in_emissora INTO del_emissora, del_competicio;
	   call baixa_retransmissio(del_emissora, del_competicio, RSP);
	END WHILE;
	
	
	-- Esborra de la taula
	
	DELETE FROM emissora  
	WHERE codi_emissora = in_emissora;
		

	-- Actualitzar log
	
	SET valor_nou = " - ";
	SET consulta = CONCAT("baixa_emissora (",in_emissora,")");
	SET valor_antic = CONCAT_WS(',',in_emissora, in_nom, in_pais);

	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'emissora', valor_antic, valor_nou, NOW(), consulta);

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.baixa_equip
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `baixa_equip`(IN `in_equip` SMALLINT, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (10);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare in_nom VARCHAR(50);
declare in_seu VARCHAR(100);
declare in_debut DATE;

declare del_director MEDIUMINT;
declare del_pilot MEDIUMINT;
declare del_patrocinador SMALLINT;
declare del_temporada YEAR;
declare del_cotxe MEDIUMINT;


-- Control d'errors

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el codi de l\'equip (',in_equip,') no sigui correcte.' );
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;


	SET RSP := 'OK';

	-- Esborrar el director d'equip si en te
	
	IF (SELECT codi_persona FROM director WHERE equip = in_equip) IS NOT NULL THEN
		SELECT codi_persona FROM director WHERE equip = in_equip INTO del_director;
		CALL baixa_director(del_director, RSP);
	END IF;

	-- Esborrar els pilots d'equip si en te
	
	WHILE (SELECT codi_persona FROM pilot WHERE equip = in_equip LIMIT 1) IS NOT NULL DO
	   SELECT codi_persona FROM pilot WHERE equip = in_equip LIMIT 1 INTO del_pilot;
	   call baixa_pilot(del_pilot, RSP);
	END WHILE;

	-- Esborrar els patrocinis d'equip si en te
	
	WHILE (SELECT equip FROM patrocini WHERE equip = in_equip LIMIT 1) IS NOT NULL DO
	   SELECT patrocinador, temporada FROM patrocini WHERE equip = in_equip LIMIT 1 INTO del_patrocinador, del_temporada;
	   call baixa_patrocini(del_patrocinador, in_equip, del_temporada,  RSP);
	END WHILE;
	
	-- Esborrar els cotxes d'equip si en te
	
	WHILE (SELECT equip FROM cotxe_equip WHERE equip = in_equip LIMIT 1) IS NOT NULL DO
	   SELECT cotxe FROM cotxe_equip WHERE equip = in_equip LIMIT 1 INTO del_cotxe;
	   call baixa_cotxe(del_cotxe, RSP);
	END WHILE;

	
	SELECT e.nom, e.seu, e.data_debut
	INTO in_nom, in_seu, in_debut
	FROM equip e 
	WHERE e.codi_equip = in_equip;
	
	
	-- Esborra de la taula
	
	DELETE FROM equip 
	WHERE  codi_equip = in_equip;
			

	-- Actualitzar log

	SET valor_nou = " - ";
	SET consulta = CONCAT("baixa_equip (",in_equip,")");
	SET valor_antic = CONCAT_WS(',', in_equip, in_nom, in_seu, in_debut);
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'equip', valor_antic, valor_nou, NOW(), consulta);
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.baixa_fabricant
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `baixa_fabricant`(IN `in_fabricant` MEDIUMINT, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (10);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare in_nom VARCHAR(50);
declare in_debut YEAR;

declare del_component MEDIUMINT;


-- Control d'errors

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el codi del fabricant (',in_fabricant,') no sigui correcte.');
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';
		
	SELECT f.nom, f.any_debut
	INTO in_nom, in_debut
	FROM fabricant f
	WHERE `codi_fabricant` = in_fabricant;
			
			
	-- Esborrar els components si en te
	
	WHILE (SELECT `codi_component` FROM component WHERE `fabricant` = in_fabricant LIMIT 1) IS NOT NULL DO
	   SELECT `codi_component` FROM component WHERE `fabricant` = in_fabricant LIMIT 1 INTO del_component;
	   call baixa_component(del_component,  RSP);
	END WHILE;
	
	
	-- Esborra de la taula
		
	DELETE FROM fabricant
	WHERE `codi_fabricant` = in_fabricant;
	
	
	-- Actualitzar log
	
	SET valor_nou = " - ";
	SET consulta = CONCAT("baixa_fabricant (",in_fabricant,")");
	SET valor_antic = CONCAT_WS(',', in_fabricant, in_nom, in_debut);
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'fabricant', valor_antic, valor_nou, NOW(), consulta);
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.baixa_pais
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `baixa_pais`(IN `in_pais` CHAR(2), OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (10);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare in_nom VARCHAR(50);


-- Control d'errors

DECLARE EXIT HANDLER FOR 1451
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Codi ',state,'. No es pot esborrar.  Possiblement el codi del pais (',in_pais,') s\'esta fent servir a altres taules (emissora, persona).' );
 END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el codi del pais (',in_pais,') no sigui correcte.' );
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';
	
	SELECT p.nom
	INTO in_nom
	FROM pais p
	WHERE p.codi_pais = in_pais;


	-- Esborrar de la taula

	DELETE FROM pais 
	WHERE codi_pais = in_pais;
	
	
	-- Actualitzar log

	SET valor_nou = " - ";	
	SET consulta = CONCAT("baixa_pais (",in_pais,")");
	SET valor_antic = CONCAT_WS(',', in_pais, in_nom);
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'pais', valor_antic, valor_nou, NOW(), consulta);
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.baixa_patrocinador
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `baixa_patrocinador`(IN `in_patrocinador` MEDIUMINT, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (10);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare in_sector SMALLINT;
declare in_nom VARCHAR(50);

declare del_equip SMALLINT;
declare del_temporada YEAR;


-- Control d'errors

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el codi del patrocinador (',in_patrocinador,') no sigui correcte.');
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';
	
	SELECT p.sector, p.nom
	INTO in_sector, in_nom
	FROM patrocinador p
	WHERE p.codi_patrocinador = in_patrocinador;
		
		
	-- Esborrar els patrocinis si en te
	
	WHILE (SELECT `patrocinador` FROM patrocini WHERE `patrocinador` = in_patrocinador LIMIT 1) IS NOT NULL DO
	   SELECT equip, temporada FROM patrocini WHERE `patrocinador` = in_patrocinador LIMIT 1 INTO del_equip, del_temporada;
	   call baixa_patrocini(in_patrocinador, del_equip, del_temporada,  RSP);
	END WHILE;
		
			
	-- Esborra de la taula
	
	DELETE FROM patrocinador
	WHERE codi_patrocinador = in_patrocinador;
		
	
	-- Actualitzar log
	
	SET valor_nou = " - ";
	SET consulta = CONCAT("baixa_patrocinador (",in_patrocinador,")");
	SET valor_antic = CONCAT_WS(',',in_patrocinador, in_nom);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'patrocinador', valor_antic, valor_nou, NOW(), consulta);
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.baixa_patrocini
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `baixa_patrocini`(IN `in_patrocinador` MEDIUMINT, IN `in_equip` SMALLINT, IN `in_temporada` YEAR, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (10);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare in_cost INT;


-- Control d'errors

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el codi del patrocinador (',in_patrocinador,'), de l\'equip (',in_equip,') o de l\'any (',in_temporada,') no sigui correcte.' );
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';

	SELECT p.cost
	INTO in_cost
	FROM patrocini p
	WHERE p.patrocinador = in_patrocinador
	AND p.equip = in_equip 
	AND p.temporada = in_temporada;
		
		
	-- Esborra de la taula
	
	DELETE FROM patrocini 
	WHERE patrocinador = in_patrocinador
	AND equip = in_equip 
	AND temporada = in_temporada;
		
	
	-- Actualitzar log

	SET valor_nou = " - ";
	SET consulta = CONCAT("baixa_patrocini (",in_patrocinador,', ', in_equip,', ', in_temporada,")");
	SET valor_antic = CONCAT_WS(',', in_patrocinador, in_equip, in_temporada, in_cost);
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'patrocini', valor_antic, valor_nou, NOW(), consulta);
	
	
	-- Actualitzar estadistiques de patrocini mes alt
	
	UPDATE dim_patrocini 
	SET dim_patrocini.cost = dim_patrocini.cost - in_cost 
	WHERE dim_patrocini.patrocinador = in_patrocinador;

   DELETE FROM fact_table_1 WHERE fact_table_1.camp_control = '0xPA';
   INSERT INTO fact_table_1(patrocinador, cost_patrocini, camp_control) 
   SELECT dp.patrocinador, dp.cost, '0xPA' FROM dim_patrocini dp ORDER BY dp.cost DESC LIMIT 5;
	
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.baixa_pilot
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `baixa_pilot`(IN `in_persona` MEDIUMINT, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (10);
declare in_equip SMALLINT;
declare in_llicencia VARCHAR (8);
declare in_any_inici YEAR;
declare in_nom VARCHAR(100);
declare in_pais CHAR(2);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);


-- Control d'errors

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el codi de la persona (',in_persona,') no sigui correcte.' );
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;


	SET RSP := 'OK';
	
	SELECT p.equip, p.codi_llicencia, p.any_inici
	INTO in_equip, in_llicencia, in_any_inici
	FROM pilot p
	WHERE p.codi_persona = in_persona;
	
	SELECT p.nom, p.nacionalitat
	INTO in_nom, in_pais
	FROM persona p
	WHERE p.codi_persona = in_persona;
		
		
	-- Esborra de la taula
	
	DELETE FROM pilot  
	WHERE codi_persona = in_persona;
	SET consulta = CONCAT("baixa_pilot (",in_persona,")");
	SET valor_antic = CONCAT_WS(',',in_persona, in_equip, in_llicencia, in_any_inici);
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'pilot', valor_antic, valor_nou, NOW(), consulta);
		
	
	-- Esborra de la taula
	
	DELETE FROM persona  
	WHERE codi_persona = in_persona;
		
	
	-- Actualitzar log
	
	SET valor_nou = " - ";
	SET consulta = CONCAT("INDIRECTE->baixa_pilot (",in_persona,")");
	SET valor_antic = CONCAT_WS(',',in_persona, in_nom, in_pais);
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'persona', valor_antic, valor_nou, NOW(), consulta);


END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.baixa_retransmissio
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `baixa_retransmissio`(IN `in_emissora` SMALLINT, IN `in_competicio` SMALLINT, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (10);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare check_competicio SMALLINT;
declare check_emissora SMALLINT;


-- Control d'errors

DECLARE EXIT HANDLER FOR NOT FOUND
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
	SET RSP := CONCAT('ERROR: Not found. Codi ',state,' .Possiblement el codi de l\'emissora (',in_emissora,') o de la competicio (',in_competicio,') no sigui correcte.');
END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';
	
	-- Comprovacio de si existeixn a la taula els arguments
	SELECT r.emissora, r.competicio
	INTO check_emissora, check_competicio
	FROM retransmissio r
	WHERE r.emissora = in_emissora 
	AND r.competicio = in_competicio;
		
	
	-- Esborra de la taula
	
	DELETE FROM retransmissio 
	WHERE competicio = check_competicio 
	AND emissora = check_emissora;
		
	
	-- Actualitzar log
	
	SET valor_nou = " - ";
	SET consulta = CONCAT("baixa_retransmissio (",in_emissora,", ",in_competicio,")");
	SET valor_antic = CONCAT_WS(',', in_emissora, in_competicio );
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'retransmissio', valor_antic, valor_nou, NOW(), consulta);

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.baixa_sector
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `baixa_sector`(IN `in_sector` SMALLINT, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (10);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare in_nom VARCHAR(50);


-- Control d'errors

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el codi del sector (',in_sector,') no sigui correcte.' );
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';
	
	SELECT s.nom
	INTO in_nom
	FROM sector s 
	WHERE s.codi_sector = in_sector;
		
	
	-- Esborra de la taula
	
	DELETE FROM sector 
	WHERE codi_sector = in_sector;
		
	
	-- Actualitzar log

	SET valor_nou = " - ";	
	SET consulta = CONCAT("baixa_sector (",in_sector,")");
	SET valor_antic = CONCAT_WS(',', in_sector, in_nom);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'sector', valor_antic, valor_nou, NOW(), consulta);
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.baixa_telemetria
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `baixa_telemetria`(IN `in_dada` BIGINT, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (10);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare in_component MEDIUMINT;
declare in_moment DATETIME;
declare in_ambit VARCHAR(25);
declare in_valor FLOAT;
declare in_unitats VARCHAR(25);

declare current_cotxe SMALLINT;
declare current_circuit SMALLINT;
declare current_year YEAR;
declare current_equip SMALLINT;
declare current_competicio SMALLINT;
declare current_pilot SMALLINT;

declare temperatura_maxima FLOAT;
declare aux_temps TIME;


-- Control d'errors

DECLARE EXIT HANDLER FOR NOT FOUND
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
	SET RSP := CONCAT('ERROR: Not found. Codi ',state,' .Possiblement el codi de la dada (',in_dada,'), no sigui correcte.');
END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';
	
	SELECT t.component, t.moment, t.ambit, t.valor, t.unitat_de_mesura
	INTO in_component, in_moment, in_ambit, in_valor, in_unitats
	FROM telemetria t 
	WHERE t.codi_dada = in_dada;
		
	
	-- Esborra de la taula
	
	DELETE FROM telemetria WHERE codi_dada = in_dada;
	SET consulta = CONCAT("baixa_telemetria (",in_dada,")");
		
	
	-- Actualitzar log
	
	SET valor_nou = " - ";	
	SET valor_antic = CONCAT_WS(',', in_component, in_moment, in_ambit, in_valor, in_unitats);
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'telemetria', valor_antic, valor_nou, NOW(), consulta);
	
	
	
	-- Actualitzar estadistiques de volum telemetria global
	
	SET current_year = YEAR(in_moment);
	
	SELECT c.cotxe 
	FROM component c 
	WHERE c.codi_component = in_component 
	INTO current_cotxe;
	
	SELECT ce.equip 
	FROM cotxe_equip ce
	WHERE ce.cotxe = current_cotxe 
	INTO current_equip;

	UPDATE dim_telemetria dt
	SET dt.dades_any =  dt.dades_any - 1 
	WHERE dt.temporada = current_year 
	AND dt.equip = current_equip;
	
	SELECT pilot 
	INTO current_pilot 
	FROM pilot_cotxe 
	WHERE temporada = current_year 
	AND cotxe = current_cotxe;
	
	SELECT competicio, circuit
	INTO current_competicio, current_circuit 
	FROM cursa 
	WHERE data_cursa = DATE(in_moment) 
	AND pilot = current_pilot;
	
	DELETE FROM fact_table_1 WHERE camp_control = '0xTE' AND temporada = current_year;
  
   INSERT INTO fact_table_1(temporada, equip, dades_telemetriques, camp_control) 
   SELECT dt.temporada, dt.equip, SUM(dt.dades_any), '0xTE' 
	FROM dim_telemetria dt 
	WHERE dt.temporada = current_year 
	ORDER BY dt.dades_any DESC 
	LIMIT 1;
	
	
	-- Actualitzar estadistiques de consum global
	
	CASE in_ambit
      WHEN 'consum' THEN					
			UPDATE dim_consum dc
			SET dc.consum =  dc.consum - in_valor
			WHERE dc.temporada = current_year 
			AND dc.competicio = current_competicio
			AND dc.cotxe = current_cotxe;

		   
		   DELETE FROM fact_table_1 WHERE camp_control = '0xCC' AND temporada = current_year AND competicio = current_competicio;
		   INSERT INTO fact_table_1(competicio, temporada, cotxe, consum_cotxe, camp_control) 
		   SELECT dc.competicio, dc.temporada, dc.cotxe, dc.consum, '0xCC' FROM dim_consum dc WHERE dc.competicio = current_competicio AND dc.temporada = current_year ORDER BY dc.consum DESC LIMIT 1;
	
	
		-- Actualitzar estadistiques de temperatura maxima
		
	   WHEN 'temperatura' THEN		
			SELECT valor
			INTO temperatura_maxima 
			FROM telemetria 
			WHERE ambit = 'temperatura' 
			ORDER BY valor DESC 
			LIMIT 1;
			
			DELETE FROM fact_table_1
			WHERE camp_control = '0xTM';
			
			INSERT INTO fact_table_1 (competicio, temporada, pilot, cotxe, circuit, data_cursa, temperatura_maxima, camp_control) 
			VALUES (current_competicio, current_year, current_pilot, current_cotxe, current_circuit, DATE(in_moment), temperatura_maxima, '0xTM');


		-- Actualitzar estadistiques de volta rapida
		
	   WHEN 'temps per volta' THEN		
			SET aux_temps = (TIME_FORMAT(SEC_TO_TIME(in_valor/1000),'%i:%s'));

			DELETE FROM dim_volta_rapida 
			WHERE circuit = current_circuit 
			AND pilot = current_pilot
			AND equip = current_equip
			AND data = DATE(in_moment)
			AND temps = aux_temps;

			DELETE FROM fact_table_1 
			WHERE circuit = current_circuit 
			AND camp_control = '0xVR';			
			
			INSERT INTO fact_table_1 (circuit, pilot, equip, data_cursa, volta_rapida, camp_control) 		
			SELECT dvr.circuit, dvr.pilot, dvr.equip,  dvr.data, dvr.temps, '0xVR'
			FROM dim_volta_rapida dvr
			WHERE dvr.circuit = current_circuit
			ORDER BY temps 
			LIMIT 10;
	ELSE
   	BEGIN
   	
   	END;
   END CASE;
	

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.baixa_temporada
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `baixa_temporada`(IN `in_temporada` YEAR, IN `in_competicio` SMALLINT, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (10);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare check_temporada YEAR;
declare check_competicio SMALLINT;


-- Control d'errors

DECLARE EXIT HANDLER FOR 1451
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Codi ',state,'. No es pot esborrar.  Possiblement la temporada (',in_temporada,') s\'esta fent servir a altres taules (patrocini, competicio).' );
 END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el codi la temporada (',in_temporada,') o la competicio (',in_competicio,') no sigui correcte.' );
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';
	
	SELECT `temporada`, `competicio`
	INTO check_temporada, check_competicio
	FROM competicio_temporada
	WHERE `temporada` = in_temporada
	AND `competicio` = in_competicio;	
		
	
	-- Esborra de la taula
	
	DELETE FROM competicio_temporada
	WHERE `temporada` = in_temporada
	AND `competicio` = in_competicio;
		
	
	-- Actualitzar log

	SET valor_nou = " - ";
	SET consulta = CONCAT("baixa_temporada (",in_temporada,", ",in_competicio,")");
	SET valor_antic = CONCAT(in_temporada,", ",in_competicio);
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('BAIXA', 'competicio_temporada', valor_antic, valor_nou, NOW(), consulta);
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.estadistica_classificacio_pilots
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `estadistica_classificacio_pilots`()
BEGIN

declare loop_pilot SMALLINT;
declare max_pilot SMALLINT;
declare current_pilot SMALLINT;

declare loop_competicio SMALLINT;
declare max_competicio SMALLINT;
declare current_competicio SMALLINT;

declare loop_temporada SMALLINT;
declare max_temporada SMALLINT;
declare current_temporada YEAR;

declare aux_punts SMALLINT;
declare total_punts SMALLINT;
declare current_equip SMALLINT (5);
declare current_cotxe MEDIUMINT (8);
declare current_circuit MEDIUMINT (8);


	DELETE FROM fact_table_1 WHERE camp_control = '0xCP';

	SELECT count(*) 
	INTO max_competicio 
	FROM (
		SELECT *
		FROM cursa
		GROUP BY competicio
	)count_competicio;

	SET loop_competicio = 0;
	
	WHILE loop_competicio < max_competicio DO
	
		SELECT competicio
		INTO current_competicio
		FROM cursa 
		GROUP BY competicio
		LIMIT loop_competicio,1;
		
		SELECT count(*) 
		INTO max_temporada 
		FROM (
			SELECT EXTRACT(YEAR from data_cursa)as temporada 
			FROM cursa  
			WHERE competicio = current_competicio 
			GROUP BY temporada
		)count_temporadas;
				
		SET loop_temporada = 0;
			
		WHILE loop_temporada < max_temporada DO
		
      	SELECT (EXTRACT(YEAR from data_cursa))as temporada
			INTO current_temporada
			FROM cursa 
			WHERE competicio = current_competicio 
			GROUP BY temporada
			LIMIT loop_temporada,1;

        	SELECT count(*) 
	  		INTO max_pilot 
	  		FROM (
	  			SELECT pilot
	  			FROM cursa
	  			WHERE EXTRACT(YEAR from data_cursa) = current_temporada
	  			AND competicio = current_competicio
	  			GROUP BY pilot
			  )count_data;

			SET loop_pilot = 0;
  
     		WHILE loop_pilot < max_pilot DO
     		
     			SELECT pilot 
  				INTO current_pilot
  				FROM cursa 
  				WHERE competicio = current_competicio 
  				AND EXTRACT(YEAR from data_cursa) = current_temporada
  				GROUP BY pilot
  				LIMIT loop_pilot,1;

       		SET total_punts = 0;
				SET aux_punts	=	(SELECT count(posicio)*25 as count
									FROM cursa c 
									WHERE c.pilot = current_pilot 
									AND c.competicio = current_competicio 
									AND EXTRACT(YEAR from data_cursa) = current_temporada 
									AND c.posicio = 1 
									GROUP BY posicio);
			
				SET total_punts = total_punts + (SELECT IFNULL(aux_punts,0));
				SET aux_punts	=	(SELECT count(posicio)*15 as count
									FROM cursa c 
									WHERE c.pilot = current_pilot 
									AND c.competicio = current_competicio 
									AND EXTRACT(YEAR from data_cursa) = current_temporada 
									AND c.posicio = 2 
									GROUP BY posicio);
			
				SET total_punts = total_punts + (SELECT IFNULL(aux_punts,0));
				SET aux_punts	=	aux_punts + (SELECT count(posicio)*5 as count
									FROM cursa c 
									WHERE c.pilot = current_pilot 
									AND c.competicio = current_competicio 
									AND EXTRACT(YEAR from data_cursa) = current_temporada 
									AND c.posicio = 3 
									GROUP BY posicio);
									
				SET total_punts = total_punts + (SELECT IFNULL(aux_punts,0));

				INSERT INTO dim_classificacio (competicio, temporada, pilot, punts) 
  				VALUES (current_competicio, current_temporada, current_pilot, total_punts);
				  
				SET loop_pilot = loop_pilot + 1;
			END WHILE; -- Loop pilot
			
			INSERT INTO fact_table_1(competicio, temporada, pilot, punts_pilot, posicio_pilot, camp_control) 
			SELECT dc.competicio, dc.temporada, dc.pilot, dc.punts, @rownum:=@rownum+1 posicio, '0xCP' 
			FROM (SELECT @rownum:=0) r, dim_classificacio dc 
			WHERE competicio = current_competicio 
			AND temporada = current_temporada 
			ORDER BY dc.punts DESC;
  			
			SET loop_temporada = (loop_temporada + 1);
		END WHILE; -- Loop temporada
		
		SET loop_competicio = (loop_competicio + 1);
	END WHILE; -- Loop competicio

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.estadistica_consum_total
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `estadistica_consum_total`()
BEGIN

declare loop_pilot SMALLINT;
declare max_pilot SMALLINT;
declare current_pilot SMALLINT;

declare loop_competicio SMALLINT;
declare max_competicio SMALLINT;
declare current_competicio SMALLINT;

declare loop_temporada SMALLINT;
declare max_temporada SMALLINT;
declare current_temporada YEAR;

declare current_cotxe MEDIUMINT (8);
declare current_component MEDIUMINT (8);
declare current_consum FLOAT(10,2);

declare max_consum FLOAT;
declare max_consum_cotxe SMALLINT;
declare current_consum_global FLOAT(10,2);


	DELETE FROM fact_table_1 WHERE camp_control = '0xCC';

	SELECT count(*) 
	INTO max_competicio 
	FROM (
		SELECT *
		FROM cursa
		GROUP BY competicio
	)count_competicio;

	SET loop_competicio = 0;
	
	WHILE loop_competicio < max_competicio DO
	
		SELECT competicio
		INTO current_competicio
		FROM cursa 
		GROUP BY competicio
		LIMIT loop_competicio,1;
		
		SELECT count(*) 
		INTO max_temporada 
		FROM (
			SELECT EXTRACT(YEAR from data_cursa)as temporada 
			FROM cursa  
			WHERE competicio = current_competicio 
			GROUP BY temporada
		)count_temporadas;
				
		SET loop_temporada = 0;
			
		WHILE loop_temporada < max_temporada DO
		
      	SELECT (EXTRACT(YEAR from data_cursa))as temporada
			INTO current_temporada
			FROM cursa 
			WHERE competicio = current_competicio 
			GROUP BY temporada
			LIMIT loop_temporada,1;


		   DROP TEMPORARY TABLE IF EXISTS classificacio_temp;
	      CREATE TEMPORARY TABLE IF NOT EXISTS classificacio_temp 
			( 
				`competicio` SMALLINT (6),
				`temporada`YEAR,
				`cotxe` MEDIUMINT(8),
				`consum` FLOAT(10,2)
			); 

        	SELECT count(*) 
	  		INTO max_pilot 
	  		FROM (
	  			SELECT pilot
	  			FROM cursa
	  			WHERE EXTRACT(YEAR from data_cursa) = current_temporada
	  			AND competicio = current_competicio
	  			GROUP BY pilot
			  )count_pilots;

			SET loop_pilot = 0;
  
     		WHILE loop_pilot < max_pilot DO
     		
     			SELECT pilot 
  				INTO current_pilot
  				FROM cursa 
  				WHERE competicio = current_competicio 
  				AND YEAR(data_cursa) = current_temporada
  				GROUP BY pilot
  				LIMIT loop_pilot,1;

				SELECT cotxe
				INTO current_cotxe
				FROM pilot_cotxe
				WHERE pilot = current_pilot
				AND temporada = current_temporada;
								
				SELECT sum(valor) as consum 
				INTO current_consum
				FROM telemetria t 
				INNER JOIN component c ON  t.component = c.codi_component 
				WHERE EXTRACT(YEAR FROM t.moment) = current_temporada
				AND t.ambit = 'consum'
				AND c.cotxe = current_cotxe;
 				
  				IF current_consum IS NOT NULL THEN
					INSERT INTO classificacio_temp (competicio, temporada, cotxe, consum) 
					VALUES (current_competicio, current_temporada, current_cotxe, current_consum);
				END IF;
  				
				  
				SET loop_pilot = loop_pilot + 1;
			END WHILE; -- Loop pilot

		  	
		  	INSERT INTO dim_consum (competicio, temporada, cotxe, consum) 
		  	SELECT competicio, temporada, cotxe, consum
		  	FROM classificacio_temp
		  	ORDER BY consum DESC; 	
		  	
		  	DELETE FROM fact_table_1 WHERE camp_control = '0xCC' AND temporada = current_temporada AND competicio = current_competicio;
   		INSERT INTO fact_table_1(competicio, temporada, cotxe, consum_cotxe, camp_control) 
  			SELECT dc.competicio, dc.temporada, dc.cotxe, dc.consum, '0xCC' FROM dim_consum dc WHERE dc.competicio = current_competicio AND dc.temporada = current_temporada ORDER BY dc.consum DESC LIMIT 1;


			SET loop_temporada = (loop_temporada + 1);
		END WHILE; -- Loop temporada
		
		SET loop_competicio = (loop_competicio + 1);
	END WHILE; -- Loop competicio
		  


END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.estadistica_curses_finalitzades
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `estadistica_curses_finalitzades`()
BEGIN

	DELETE FROM fact_table_1 WHERE camp_control = '0xCF';
	DELETE FROM dim_resultat WHERE finalitzades IS NOT NULL;

   INSERT INTO dim_resultat (pilot, finalitzades) 
  	SELECT pilot, SUM(CASE WHEN posicio = 0 THEN 0 ELSE 1 END) finished 
	FROM cursa 
	GROUP BY pilot
	ORDER BY finished DESC;
	
	INSERT INTO fact_table_1(pilot, curses_finalitzades, camp_control) 
	SELECT dr.pilot, dr.finalitzades, '0xCF' 
	FROM dim_resultat dr 
	ORDER BY dr.finalitzades DESC
	LIMIT 10;
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.estadistica_curses_resultat
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `estadistica_curses_resultat`()
BEGIN

	DELETE FROM fact_table_1 WHERE camp_control = '0xCG';
	DELETE FROM fact_table_1 WHERE camp_control = '0xCF';
	TRUNCATE TABLE dim_resultat;

   INSERT INTO dim_resultat (pilot, finalitzades, guanyades) 
  	SELECT pilot, SUM(CASE WHEN posicio = 0 THEN 0 ELSE 1 END) finished, SUM(CASE WHEN posicio = 1 THEN 1 ELSE 0 END) won
	FROM cursa 
	GROUP BY pilot
	ORDER BY finished, won DESC;
	
	INSERT INTO fact_table_1(pilot, curses_guanyades, camp_control) 
	SELECT dr.pilot, dr.guanyades, '0xCG' 
	FROM dim_resultat dr 
	ORDER BY dr.guanyades DESC
	LIMIT 10;
	
	INSERT INTO fact_table_1(pilot, curses_finalitzades, camp_control) 
	SELECT dr.pilot, dr.finalitzades, '0xCF' 
	FROM dim_resultat dr 
	ORDER BY dr.finalitzades DESC
	LIMIT 10;
	
	
	
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.estadistica_patrocini_maxim
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `estadistica_patrocini_maxim`()
BEGIN

declare max_temporades TINYINT;
declare current_temporada YEAR;
declare loop_temporada TINYINT;

	DELETE FROM fact_table_1 WHERE camp_control = '0xPA';

	SELECT count(*) 
	INTO max_temporades 
	FROM (
		SELECT temporada
		FROM patrocini
		GROUP BY temporada
	  )count_temporada;

	SET loop_temporada = 0;

	WHILE loop_temporada < max_temporades DO
		SELECT temporada
		INTO current_temporada
		FROM patrocini
		GROUP BY temporada
		LIMIT loop_temporada,1;

	   INSERT INTO fact_table_1 (temporada, patrocinador, cost_patrocini, camp_control) 
	  	SELECT temporada, patrocinador, sum(cost)cost, '0xPA'
		FROM patrocini 
		WHERE temporada = current_temporada
		GROUP BY patrocinador 
		ORDER BY cost DESC
		LIMIT 5;
		
		SET loop_temporada = loop_temporada +1;
	END WHILE;
		
	INSERT INTO dim_patrocini (patrocinador, cost) 
  	SELECT patrocinador, sum(cost)cost
	FROM patrocini 
	GROUP BY patrocinador 
	ORDER BY cost DESC;

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.estadistica_quantitat_components
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `estadistica_quantitat_components`()
BEGIN

	DELETE FROM fact_table_1 WHERE camp_control = '0xQC';
	TRUNCATE TABLE dim_component;

	INSERT INTO dim_component (fabricant, components) 
	SELECT co.fabricant, count(co.codi_component) as quantitat
	FROM component co
	JOIN pilot_cotxe pc ON pc.cotxe = co.cotxe
	JOIN (
		SELECT c.pilot FROM cursa c GROUP BY pilot
	)AS aux ON aux.pilot = pc.pilot
	GROUP BY co.fabricant
	ORDER BY quantitat DESC;
	
	INSERT INTO fact_table_1 (fabricant, quantitat_components, camp_control) 
	SELECT co.fabricant, co.components, '0xQC'
	FROM dim_component co
	ORDER BY co.components DESC
	LIMIT 5;

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.estadistica_temperatura_maxima
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `estadistica_temperatura_maxima`()
BEGIN

declare current_pilot SMALLINT;
declare current_cotxe MEDIUMINT (8);
declare current_component MEDIUMINT (8);
declare current_data DATE;
declare current_temperatura FLOAT(8,2);
declare current_circuit MEDIUMINT (8); 


	DELETE FROM fact_table_1 WHERE camp_control = '0xTM';

	SELECT component, valor, DATE(moment)
	INTO current_component, current_temperatura, current_data
	FROM telemetria
	WHERE ambit = 'temperatura' 
	ORDER BY valor DESC
	LIMIT 1;

	SELECT cotxe 
	INTO current_cotxe
	FROM component
	WHERE codi_component = current_component;

	SELECT pilot 
	INTO current_pilot
	FROM pilot_cotxe 
	WHERE cotxe = current_cotxe;
	
	SELECT circuit 
	INTO current_circuit
	FROM cursa 
	WHERE pilot = current_pilot
	AND data_cursa = current_data;

   INSERT INTO fact_table_1 (temporada, pilot, cotxe, circuit, data_cursa, temperatura_maxima, camp_control) 
  	VALUES (YEAR(current_data), current_pilot, current_cotxe, current_circuit, current_data, current_temperatura, '0xTM');

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.estadistica_volta_rapida
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `estadistica_volta_rapida`()
BEGIN


declare loop_circuit SMALLINT;
declare max_circuit SMALLINT;
declare current_circuit MEDIUMINT (8);

declare loop_pilot SMALLINT;
declare max_pilot SMALLINT;
declare current_pilot SMALLINT;

declare loop_cotxe SMALLINT;
declare max_cotxe SMALLINT;
declare current_cotxe MEDIUMINT (8);

declare loop_data SMALLINT;
declare max_data SMALLINT;
declare current_data DATE;

declare current_equip SMALLINT (5);
declare current_temps_volta TIME;

	DELETE FROM fact_table_1 WHERE camp_control = '0xVR';
	TRUNCATE TABLE dim_volta_rapida;
	
	SELECT count(*) 
	INTO max_circuit 
	FROM (
		SELECT circuit
		FROM cursa
		GROUP BY circuit
	)count_circuit;

	SET loop_circuit = 0;
	
	WHILE loop_circuit < max_circuit DO

    SELECT circuit 
		INTO current_circuit
		FROM cursa 
		GROUP BY circuit
		LIMIT loop_circuit,1;	

		SELECT count(*) 
  		INTO max_data 
  		FROM (
  			SELECT data_cursa
  			FROM cursa
  			WHERE circuit = current_circuit
  			GROUP BY data_cursa
		  )count_data;

		SET loop_data = 0;
  
  		WHILE loop_data < max_data DO
			SELECT data_cursa 
			INTO current_data
  			FROM cursa
  			WHERE circuit = current_circuit
      GROUP BY data_cursa
			LIMIT loop_data,1;

			SELECT count(*) 
	  		INTO max_pilot 
	  		FROM (
	  			SELECT pilot
	  			FROM cursa
	  			WHERE circuit = current_circuit
	  			AND data_cursa = current_data
	  			GROUP BY pilot
			  )count_pilot;
	
			SET loop_pilot = 0;
	  
	  		WHILE loop_pilot < max_pilot DO
				SELECT pilot 
				INTO current_pilot
	  			FROM cursa
	  			WHERE circuit = current_circuit
	  			AND data_cursa = current_data
	  			GROUP BY pilot
				LIMIT loop_pilot,1;
				
				SELECT equip
				INTO current_equip
				FROM pilot
				WHERE codi_persona = current_pilot;	
				
				SELECT cotxe 
		  		INTO current_cotxe 
		  		FROM pilot_cotxe
		  		WHERE pilot = current_pilot
		  		AND temporada = YEAR(current_data);
				
					INSERT INTO dim_volta_rapida (circuit, pilot, equip, data, temps) 
			  		SELECT current_circuit, current_pilot, current_equip, current_data, TIME_FORMAT(SEC_TO_TIME(valor/1000),'%i:%s')
					FROM telemetria 
					WHERE ambit = 'temps per volta' 
					AND DATE(moment) = current_data
					AND component = (
					  	SELECT codi_component 
						FROM component 
						WHERE descripcio = 'Velocimetre' 
						AND cotxe = current_cotxe
					)
					ORDER BY valor LIMIT 10;

				SET loop_pilot = (loop_pilot + 1);
			END WHILE; -- Loop pilot

     		SET loop_data = (loop_data + 1);
		END WHILE; -- loop data


		INSERT INTO fact_table_1 (circuit, pilot, equip, data_cursa, volta_rapida, camp_control) 		
		SELECT dvr.circuit, dvr.pilot, dvr.equip,  dvr.data, dvr.temps, '0xVR'
		FROM dim_volta_rapida dvr
		WHERE dvr.circuit = current_circuit
		ORDER BY temps 
		LIMIT 10;

		SET loop_circuit = (loop_circuit + 1);
	END WHILE; -- Loop circuit
	

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.estadistica_volum_telemetria
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `estadistica_volum_telemetria`()
BEGIN

declare max_temporades TINYINT;
declare current_temporada YEAR;
declare loop_temporada TINYINT;

declare equip_max_punts SMALLINT;

	DELETE FROM fact_table_1 WHERE camp_control = '0xTE';
	TRUNCATE TABLE dim_telemetria;

	SELECT count(*) 
	INTO max_temporades 
	FROM (
		SELECT YEAR(t.moment)any 
		FROM telemetria t 
		GROUP BY any
	  )count_temporada;

	SET loop_temporada = 0;

	WHILE loop_temporada < max_temporades DO
		SELECT YEAR(t.moment)any 
		INTO current_temporada
		FROM telemetria t 
		GROUP BY any
		LIMIT loop_temporada,1;

		INSERT INTO dim_telemetria (temporada, equip, dades_any) 
		SELECT YEAR(t.moment), ce.equip, count(codi_dada)
		FROM telemetria t
		INNER JOIN component c ON c.codi_component = t.component
		INNER JOIN cotxe_equip ce ON ce.cotxe = c.cotxe
		WHERE YEAR(t.moment) = current_temporada
		GROUP BY ce.equip;
		
		INSERT INTO fact_table_1(temporada, equip, dades_telemetriques, camp_control) 
	   SELECT dt.temporada, dt.equip, SUM(dt.dades_any), '0xTE' 
		FROM dim_telemetria dt 
		WHERE dt.temporada = current_temporada 
		ORDER BY dt.dades_any DESC
		LIMIT 1;
		
		UPDATE fact_table_1
   	SET equip = (
			SELECT dt.equip
			FROM dim_telemetria dt 
			WHERE dt.temporada = current_temporada 
			ORDER BY dt.dades_any DESC
			LIMIT 1)
		WHERE camp_control = '0xTE'
		AND temporada = current_temporada;
	
		SET loop_temporada = loop_temporada +1;
	END WHILE;	
				
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.me_carreres_finalitzades
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `me_carreres_finalitzades`()
BEGIN


SELECT pilot, curses_finalitzades FROM fact_table_1 WHERE camp_control = '0xCF';
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.me_classificacio
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `me_classificacio`(IN in_competicio MEDIUMINT, IN in_temporada YEAR)
BEGIN


	SELECT pilot, punts_pilot 
	FROM fact_table_1 
	WHERE camp_control = '0xCP' 
	AND temporada = in_temporada 
	AND competicio = in_competicio;
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.me_components_defectuosos
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `me_components_defectuosos`()
BEGIN


SELECT cotxe, components_defectuosos as percentatge  FROM fact_table_1 WHERE camp_control = '0xCD';
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.me_consum_maxim
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `me_consum_maxim`(IN in_temporada YEAR, IN in_competicio MEDIUMINT)
BEGIN


	SELECT cotxe, consum_cotxe as consum
	FROM fact_table_1 
	WHERE camp_control = '0xCC' 
	AND competicio = in_competicio 
	and temporada = in_temporada;


		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.me_curses_guanyades
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `me_curses_guanyades`()
BEGIN


	SELECT pilot, curses_guanyades 
	FROM fact_table_1 
	WHERE camp_control = '0xCG';
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.me_dades_telemetriques
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `me_dades_telemetriques`(IN in_temporada YEAR)
BEGIN


 SELECT equip, dades_telemetriques 
 FROM fact_table_1 
 WHERE camp_control = '0xTE' 
 AND temporada = in_temporada;
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.me_millor_evolucio
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `me_millor_evolucio`(IN `in_data_cura` DATE, IN `in_data_millora` DATE)
BEGIN


	SELECT pilot, punts_pilot as evolucio_punts
	FROM fact_table_1 
	WHERE camp_control = '0xEP' 
	AND data_cursa >= in_data_cura 
	AND data_millora <= in_data_millora
	AND data_millora IS NOT NULL 
	ORDER BY punts_pilot DESC 
	LIMIT 1;

		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.me_resultat_pilots
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `me_resultat_pilots`()
BEGIN


SELECT competicio, temporada, pilot, posicio_pilot as posicio FROM fact_table_1 WHERE camp_control = '0xCP';
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.me_temperatura_maxima
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `me_temperatura_maxima`()
BEGIN


	SELECT temporada, competicio, circuit, pilot, cotxe, data_cursa, temperatura_maxima as temperatura
	FROM fact_table_1 
	WHERE camp_control = '0xTM';
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.me_top_fabricants
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `me_top_fabricants`()
BEGIN


	SELECT fabricant, quantitat_components as quantitat
	FROM fact_table_1 
	WHERE camp_control = '0xQC';
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.me_top_patrocinadors
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `me_top_patrocinadors`()
BEGIN


	SELECT patrocinador, cost_patrocini as patrocini
	FROM fact_table_1 
	WHERE camp_control = '0xPA';
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.me_volta_rapida
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `me_volta_rapida`(IN in_circuit MEDIUMINT)
BEGIN


	SELECT pilot, equip, data_cursa, volta_rapida as temps
	FROM fact_table_1 
	WHERE camp_control = '0xVR' 
	AND circuit = in_circuit;
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.modificacio_circuit
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `modificacio_circuit`(IN `in_codi` MEDIUMINT, IN `in_nom` VARCHAR(50), IN `in_sobrenom` VARCHAR(50), IN `in_longitud` SMALLINT, IN `in_nacionalitat` CHAR(2), OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare old_nom VARCHAR(50);
declare old_sobrenom VARCHAR(50);
declare old_longitud SMALLINT;
declare old_nacionalitat CHAR(2);


-- Control d'errors
DECLARE EXIT HANDLER FOR NOT FOUND
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
	SET RSP := CONCAT('ERROR: Not found. Codi ',state,' .Possiblement el codi circuit (',in_codi,'), no sigui correcte.');
END;

DECLARE EXIT HANDLER FOR 1452
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. La clau forana (',in_nacionalitat,') no es correcte.');
END;

-- TRIGGER chk_circuit_long

DECLARE EXIT HANDLER FOR 1644 
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT("ERROR: Codi ",state,". ",msg);
END;

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'.Nom de circuit (',in_nom,') o sobrenom (',IFNULL(in_sobrenom,"NULL"),') duplicat.');
END;


DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';

	SELECT c.nom, c.sobrenom, c.longitud, c.pais 
	INTO old_nom, old_sobrenom, old_longitud, old_nacionalitat 
	FROM circuit c 
	WHERE c.codi_circuit = in_codi;


	-- Modifica la taula
	
	UPDATE circuit c
	SET c.nom = in_nom, c.sobrenom = in_sobrenom, c.longitud = in_longitud, c.pais = in_nacionalitat
	WHERE c.codi_circuit = in_codi;
			
		
	-- Actualitzar log

	SET consulta = CONCAT("modificacio_circuit ('",in_codi,"', '",in_nom,"', '",(IFNULL(in_sobrenom,"NULL")),"', ",(IFNULL(in_longitud,"NULL")),", '",in_nacionalitat,"')");
	SET valor_nou = CONCAT_WS(', ',in_codi, in_nom, in_sobrenom, in_longitud, in_nacionalitat);
	SET valor_antic = CONCAT_WS(',', in_codi, old_nom, old_sobrenom, old_longitud, old_nacionalitat);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('MODIFICACIÓ', 'circuit', valor_antic, valor_nou, NOW(), consulta);

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.modificacio_competicio
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `modificacio_competicio`(IN `in_codi` SMALLINT, IN `in_nom` VARCHAR(50), IN `in_acronim` VARCHAR(10), IN `in_descripcio` TEXT, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare old_nom VARCHAR(50);
declare old_acronim VARCHAR(10);
declare old_descripcio TEXT;


-- Control d'errors

DECLARE EXIT HANDLER FOR NOT FOUND
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
	SET RSP := CONCAT('ERROR: Not found. Codi ',state,' .Possiblement el codi de la competició (',in_codi,'), no sigui correcte.');
END;

-- TRIGGER chk_circuit_long
DECLARE EXIT HANDLER FOR 1644 
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT("ERROR: Codi ",state,". ",msg);
END;

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'.Nom de la competicio (',in_nom,') o acronim (',IFNULL(in_acronim,"NULL"),') duplicat.');
END;

DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';

	SELECT c.nom, c.acronim, c.descripcio
	INTO old_nom, old_acronim, old_descripcio 
	FROM competicio c
	WHERE c.codi_competicio = in_codi;


	-- Modifica la taula
	
	UPDATE competicio c
	SET c.nom = in_nom, c.acronim = in_acronim, c.descripcio = in_descripcio
	WHERE c.codi_competicio = in_codi;
			
		
	-- Actualitzar log

	SET consulta = CONCAT("modificacio_competicio ('",in_codi,"', '",in_nom,"', '",in_acronim,", '",in_descripcio,"')");	
	SET valor_nou = CONCAT_WS(', ',in_codi, in_nom, in_acronim, in_descripcio);
	SET valor_antic = CONCAT_WS(',', in_codi, old_nom, old_acronim, old_descripcio);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('MODIFICACIÓ', 'competicio', valor_antic, valor_nou, NOW(), consulta);

END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.modificacio_component
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `modificacio_component`(IN `in_codi` SMALLINT, IN `in_fabricant` MEDIUMINT, IN `in_cotxe` MEDIUMINT, IN `in_descripcio` TEXT, IN `in_utilitat` TEXT, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare old_fabricant MEDIUMINT;
declare old_cotxe MEDIUMINT;
declare old_descripcio TEXT;
declare old_utilitat TEXT;


-- Control d'errors

DECLARE EXIT HANDLER FOR 1452
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement el fabricant (',in_fabricant,') o el cotxe (',in_cotxe,') no son correctes.');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. El nom del fabricant o del cotxe no son correctes.' );
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	SET RSP := 'OK';

	SELECT c.fabricant, c.cotxe, c.descripcio, c.utilitat
	INTO old_fabricant, old_cotxe, old_descripcio, old_utilitat
	FROM component c
	WHERE  c.codi_component = in_codi;
		

	-- Modifica la taula
	
	UPDATE component c 
	SET c.fabricant = in_fabricant, c.cotxe = in_cotxe, c.descripcio = in_descripcio, c.utilitat = in_utilitat
	WHERE c.codi_component = in_codi;
		
		
	-- Actualitzar log

	SET consulta = CONCAT("modificacio_component ('",in_codi,"','",in_fabricant,"','",in_cotxe,"', '",in_descripcio,"', '",in_utilitat,"')");	
	SET valor_nou = CONCAT_WS(', ',in_codi, in_fabricant, in_cotxe, in_descripcio, in_utilitat);
	SET valor_antic = CONCAT_WS(',',in_codi, old_fabricant, old_cotxe, old_descripcio, old_utilitat);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('MODIFICACIÓ', 'component', valor_antic, valor_nou, NOW(), consulta);
	
	
	
	
	
	
	
	
	
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.modificacio_cotxe
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `modificacio_cotxe`(IN `in_codi` MEDIUMINT, IN `in_model` VARCHAR(25), IN `in_any` YEAR, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare old_model VARCHAR(25);
declare old_any YEAR;
declare old_equip SMALLINT;


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement el model de cotxe (',in_model,') ja existeix a la taula \'cotxe\'.');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. El codi del cotxe no es correcte.' );
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	
	SET RSP := 'OK';
	
	SELECT c.model, c.any_debut
	INTO old_model, old_any
	FROM cotxe c
	WHERE  c.codi_cotxe = in_codi;


	-- Modifica la taula
	
	UPDATE cotxe c 
	SET c.model = in_model, c.any_debut = in_any
	WHERE c.codi_cotxe = in_codi;
			
		
	-- Actualitzar log
	
	SET consulta = CONCAT("modificacio_cotxe ('",in_codi,"','",in_model,"','",in_any,"')");
	SET valor_nou = CONCAT_WS(', ',in_codi, in_model, in_any);
	SET valor_antic = CONCAT_WS(',',in_codi, old_model, old_any);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('MODIFICACIÓ', 'cotxe', valor_antic, valor_nou, NOW(), consulta);
	
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.modificacio_cursa
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `modificacio_cursa`(IN `in_circuit` MEDIUMINT, IN `in_pilot` MEDIUMINT, IN `in_competicio` SMALLINT, IN `in_posicio` SMALLINT, IN `in_data_cursa` DATE, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);
declare check_temporada YEAR;
declare any_temporada YEAR;

declare old_posicio SMALLINT;
declare old_data_cursa DATE;


-- Control d'errors

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el circuit (',in_circuit,'), el pilot (',in_pilot,') o la parella competicio-any (',in_competicio,', ',any_temporada,') no son correctes.' );
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	
	SET RSP := 'OK';
	SET any_temporada = EXTRACT(YEAR from in_data_cursa);
	
	SELECT temporada FROM competicio_temporada WHERE temporada = any_temporada AND competicio = in_competicio INTO check_temporada;
	
	SELECT c.posicio, c.data_cursa
	INTO old_posicio, old_data_cursa
	FROM cursa c
	WHERE c.circuit = in_circuit 
	AND c.pilot = in_pilot 
	AND c.competicio = in_competicio;
		

	-- Modifica la taula
	
	UPDATE cursa c 
	SET c.posicio = in_posicio, c.data_cursa = in_data_cursa
	WHERE c.circuit = in_circuit 
	AND c.pilot = in_pilot 
	AND c.competicio = in_competicio;
		
		
	-- Actualitzar log

	SET consulta = CONCAT("modificacio_cursa ('",in_circuit,"','",in_pilot,"','",in_competicio,"','",in_posicio,"','",in_data_cursa,"')");
	SET valor_nou = CONCAT_WS(', ',in_circuit, in_pilot, in_competicio, in_posicio, in_data_cursa);
	SET valor_antic = CONCAT_WS(',',in_circuit, in_pilot, in_competicio, old_posicio, old_data_cursa);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('MODIFICACIÓ', 'cursa', valor_antic, valor_nou, NOW(), consulta);
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.modificacio_director
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `modificacio_director`(IN `in_codi` MEDIUMINT, IN `in_nom` VARCHAR(100), IN `in_pais` CHAR(2), IN `in_equip` SMALLINT, IN `in_estudis` TEXT, IN `in_inici` YEAR, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (512);
declare consulta_director VARCHAR(512);
declare consulta_persona VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare old_nom VARCHAR(100);
declare old_pais CHAR(2);
declare old_equip SMALLINT;
declare old_estuds TEXT;
declare old_inici YEAR;

declare check_equip SMALLINT;
declare check_nacionalitat CHAR(2);


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement l\'equip (',in_equip,') ja te director assignat.');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el codi de la persona (',in_codi,'), el codi de l\'equip (',in_equip,') o el codi del pais (',in_pais,') no sigui correcte.');
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	
	SET RSP := 'OK';
	
	-- Es fa servir SELECT INTO per tal de llençar l'excepcio  NOT FOUND si no es troba el codi a la taula.
	SELECT e.codi_equip FROM equip e WHERE e.codi_equip = in_equip INTO check_equip;
	SELECT p.codi_pais FROM pais p WHERE p.codi_pais = in_pais INTO check_nacionalitat;
	
	SELECT p.nom, p.nacionalitat, d.equip, d.estudis, d.any_inici
	INTO old_nom, old_pais, old_equip, old_estuds, old_inici
	FROM persona p 
	JOIN director d 
	ON p.codi_persona = d.codi_persona
	AND d.codi_persona = in_codi;
		

	-- Modifica la taula
	
	UPDATE director d
	SET d.equip = in_equip, d.estudis = in_estudis, d.any_inici = in_inici
	WHERE d.codi_persona = in_codi;
					
		
	-- Actualitzar log director
	
	SET consulta_director = CONCAT("modificacio_director ('",in_nom,"', '",in_pais,"', '",in_equip,"', '",in_estudis,"', ",in_inici,"')");
	SET valor_nou = CONCAT_WS(', ',in_codi, in_equip, in_estudis, in_inici);
	SET valor_antic = CONCAT_WS(',',in_codi, old_equip, old_estuds, old_inici);
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('MODIFICACIÓ', 'director', valor_antic, valor_nou, NOW(), consulta_director);
		

	-- Modifica la taula
	
	UPDATE persona p
	SET p.nom = in_nom, p.nacionalitat = in_pais
	WHERE p.codi_persona = in_codi;
			
		
	-- Actualitzar log persona
	
	SET consulta_persona = CONCAT("INDIRECTE -> modificacio_director ('",in_nom,"', '",in_pais,"', '",in_equip,"', '",in_estudis,"', ",in_inici,"')");
	SET valor_nou = CONCAT_WS(', ',in_codi, in_nom, in_pais);
	SET valor_antic = CONCAT_WS(',',in_codi, old_nom, old_pais);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('MODIFICACIÓ', 'persona', valor_antic, valor_nou, NOW(), consulta_persona);
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.modificacio_emissora
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `modificacio_emissora`(IN `in_codi` SMALLINT, IN `in_nom` VARCHAR(50), IN `in_pais` CHAR(2), OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare old_nom VARCHAR(100);
declare old_pais CHAR(2);

declare check_nacionalitat CHAR(2);


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement l\'emissora (',in_nom,') ja existeix a aquest pais (',in_pais,') a la taula \'emissora\'');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'.Possiblement el codi del pais (',in_pais,') no sigui correcte.');
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	
	SET RSP := 'OK';

	-- Es fa servir SELECT INTO per tal de llençar l'excepcio  NOT FOUND si no es troba el codi a la taula.
	SELECT p.codi_pais FROM pais p WHERE p.codi_pais = in_pais INTO check_nacionalitat;
		
	SELECT e.nom, e.pais
	INTO old_nom, old_pais
	FROM emissora e 
	WHERE e.codi_emissora = in_codi;
		

	-- Modifica la taula
	
	UPDATE emissora e
	SET e.nom = in_nom, e.pais = in_pais
	WHERE e.codi_emissora = in_codi;
			
		
	-- Actualitzar log
	
	SET consulta = CONCAT("modificacio_emissora ('",in_codi,"', '",in_nom,"', '",in_pais,"')");
	SET valor_nou = CONCAT_WS(', ',in_codi, in_nom, in_pais);
	SET valor_antic = CONCAT_WS(',',in_codi, old_nom, old_pais);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('MODIFICACIÓ', 'emissora', valor_antic, valor_nou, NOW(), consulta);
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.modificacio_equip
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `modificacio_equip`(IN `in_codi` SMALLINT, IN `in_nom` VARCHAR(50), IN `in_seu` VARCHAR(100), IN `in_debut` DATE, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare old_nom VARCHAR(50);
declare old_seu VARCHAR(100);
declare old_debut DATE;


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement l\'equip (',in_nom,') ja existeix a la taula \'equip\'.');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'.Possiblement el codi de l\'equip (',in_codi,') no sigui correcte.');
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	
	SET RSP := 'OK';
			
	SELECT e.nom, e.seu, e.data_debut
	INTO old_nom, old_seu, old_debut
	FROM equip e 
	WHERE e.codi_equip = in_codi;
		

	-- Modifica la taula
	
	UPDATE equip e
	SET e.nom = in_nom, e.seu = in_seu, e.data_debut = in_debut
	WHERE e.codi_equip = in_codi;
			
		
	-- Actualitzar log
	
	SET consulta = CONCAT("modificacio_equip ('",in_codi,"', '",in_nom,"', '",in_seu,"', '",in_debut,"')");	
	SET valor_nou = CONCAT_WS(', ',in_codi, in_nom, in_seu, in_debut);
	SET valor_antic = CONCAT_WS(',',in_codi, old_nom, old_seu, old_debut);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('MODIFICACIÓ', 'equip', valor_antic, valor_nou, NOW(), consulta);
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.modificacio_fabricant
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `modificacio_fabricant`(IN `in_codi` MEDIUMINT, IN `in_nom` VARCHAR(50), IN `in_debut` YEAR, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare old_nom VARCHAR(50);
declare old_debut YEAR;


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement el nom del fabricant (',in_nom,') ja existeix a la taula \'fabricant\'');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'.Possiblement el codi del fabricant (',in_codi,') no sigui correcte.');
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	
	SET RSP := 'OK';
			
	SELECT f.nom, f.any_debut
	INTO old_nom, old_debut
	FROM fabricant f
	WHERE f.codi_fabricant = in_codi;
	

	-- Modifica la taula
		
	UPDATE fabricant f
	SET f.nom = in_nom, f.any_debut = in_debut
	WHERE f.codi_fabricant = in_codi;
			
		
	-- Actualitzar log
	
	SET consulta = CONCAT("modificacio_fabricant ('",in_codi,"', '",in_nom,"', '",in_debut,")");
	SET valor_nou = CONCAT_WS(', ',in_codi, in_nom, in_debut);
	SET valor_antic = CONCAT_WS(',',in_codi, old_nom, old_debut);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('MODIFICACIÓ', 'fabricant', valor_antic, valor_nou, NOW(), consulta);
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.modificacio_pais
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `modificacio_pais`(IN `in_codi` CHAR(2), IN `in_nom` VARCHAR(50), OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare old_nom VARCHAR(50);


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement el nom del pais (',in_nom,') ja existeix a la taula \'pais\'');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'.Possiblement el codi del pais (',in_codi,') no sigui correcte.');
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	
	SET RSP := 'OK';
			
	SELECT p.nom
	INTO old_nom
	FROM pais p
	WHERE p.codi_pais = in_codi;
		

	-- Modifica la taula
	
	UPDATE pais p
	SET p.nom = in_nom
	WHERE p.codi_pais = in_codi;
			
		
	-- Actualitzar log

	SET consulta = CONCAT("modificacio_pais ('",in_codi,"', '",in_nom,"')");	
	SET valor_nou = CONCAT_WS(', ',in_codi, in_nom);
	SET valor_antic = CONCAT_WS(',',in_codi, old_nom);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('MODIFICACIÓ', 'pais', valor_antic, valor_nou, NOW(), consulta);
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.modificacio_patrocinador
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `modificacio_patrocinador`(IN `in_codi` MEDIUMINT, IN `in_sector` SMALLINT, IN `in_nom` VARCHAR(50), OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare old_nom VARCHAR(50);
declare old_sector SMALLINT;

declare check_sector SMALLINT;


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement nom del patrocinador (',in_nom,') ja existeix a la taula \'patrocinador\'.');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el codi del patrocinador (',in_codi,') o el sector del patrocinador (',in_sector,') no sigui correcte.' );
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

	
	SET RSP := 'OK';
	SELECT codi_sector FROM sector WHERE codi_sector = in_sector INTO check_sector;
	
	SELECT p.sector, p.nom
	INTO old_sector, old_nom
	FROM patrocinador p
	WHERE p.codi_patrocinador = in_codi;
		

	-- Modifica la taula
	
	UPDATE patrocinador p
	SET p.nom = in_nom, p.sector = in_sector
	WHERE p.codi_patrocinador = in_codi;
			
		
	-- Actualitzar log

	SET consulta = CONCAT("modificacio_patrocinador ('",in_codi,"', '",in_sector,"', '",in_nom,"')");
	SET valor_nou = CONCAT_WS(', ',in_codi, in_sector, in_nom);
	SET valor_antic = CONCAT_WS(',',in_codi, old_sector, old_nom);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('MODIFICACIÓ', 'patrocinador', valor_antic, valor_nou, NOW(), consulta);
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.modificacio_patrocini
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `modificacio_patrocini`(IN `in_patrocinador` MEDIUMINT, IN `in_equip` SMALLINT, IN `in_temporada` YEAR, IN `in_cost` INT, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare old_temporada YEAR;
declare old_cost INT;

declare check_temporada YEAR;


-- Control d'errors

DECLARE EXIT HANDLER FOR 1644 
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT("ERROR: Codi ",state,". ",msg);
END;

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
SET RSP := CONCAT('ERROR: Codi ',state,'. Ja existeix aquest patrocini (',in_patrocinador,', ',in_equip,'), per aquesta temporada (',in_temporada,') a la taula \'patrocini\'.');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,' .Possiblement l\'equip (\'',in_equip,'\'), el patrocinador (\'',in_patrocinador,'\'), o la temporada (',in_temporada,') no existeixen al sistema.');
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;
	
	SET RSP := 'OK';
	
	SELECT t.any FROM temporada t
	WHERE t.any = in_temporada 
	INTO check_temporada;
		
	SELECT p.temporada, p.cost
	INTO old_temporada, old_cost
	FROM patrocini p
	WHERE p.patrocinador = in_patrocinador
	AND p.equip = in_equip;
		

	-- Modifica la taula
	
	UPDATE patrocini p
	SET p.temporada = in_temporada, p.cost = in_cost
	WHERE p.patrocinador = in_patrocinador
	AND p.equip = in_equip;
			
		
	-- Actualitzar log
	
	SET consulta = CONCAT("modificacio_patrocini ('",in_patrocinador,"', '",in_equip,"', '",in_temporada,"', '",in_cost,"')");
	SET valor_nou = CONCAT_WS(', ',in_patrocinador, in_equip, in_temporada, in_cost);
	SET valor_antic = CONCAT_WS(',',in_patrocinador, in_equip, old_temporada, old_cost);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('MODIFICACIÓ', 'patrocini', valor_antic, valor_nou, NOW(), consulta);
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.modificacio_pilot
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `modificacio_pilot`(IN `in_persona` MEDIUMINT, IN `in_nom` VARCHAR(100), IN `in_pais` CHAR(2), IN `in_equip` SMALLINT, IN `in_llicencia` VARCHAR(8), IN `in_inici` YEAR, OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (512);
declare consulta_pilot VARCHAR(512);
declare consulta_persona VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare old_nom  VARCHAR(100);
declare old_pais CHAR(2);
declare old_equip SMALLINT;
declare old_llicencia VARCHAR(8);
declare old_inici YEAR;

declare check_pais CHAR(2);
declare check_equip SMALLINT(5);
declare check_temporada YEAR;


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
SET RSP := CONCAT('ERROR: Codi ',state,'. Possiblement la llicencia  (',in_llicencia,') ja existeix a la taula \'pilot\'');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Pot ser que el codi de la persona (',in_persona,'), de l\'equip (',in_equip,') o el codi del pais (',in_pais,') no sigui correcte.');
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;


	SET RSP := 'OK';

	SELECT e.codi_equip FROM equip e WHERE e.codi_equip = in_equip INTO check_equip;
	SELECT p.codi_pais FROM pais p WHERE p.codi_pais = in_pais INTO check_pais;


	SELECT pe.nom, pe.nacionalitat
	INTO old_nom, old_pais
	FROM persona pe
	WHERE pe.codi_persona = in_persona;
		
	SELECT pi.equip, pi.codi_llicencia, pi.any_inici
	INTO old_equip, old_llicencia, old_inici
	FROM pilot pi
	WHERE pi.codi_persona = in_persona;	
		

	-- Modifica la taula
			
	UPDATE persona pe
	SET pe.nom = in_nom, pe.nacionalitat = in_pais 
	WHERE pe.codi_persona = in_persona;
			
		
	-- Actualitzar log
	
	SET consulta_persona = CONCAT("INDIRECTE-> modificacio_pilot ('",in_persona,"', '",in_nom,"', '",in_pais,"', '",in_equip,"', ",in_llicencia,"', ",in_inici,")");
	SET valor_antic = CONCAT_WS(', ',in_persona, old_nom, old_pais);
	SET valor_nou = CONCAT_WS(',',in_persona, in_nom, in_pais);
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('MODIFICACIÓ', 'persona', valor_antic, valor_nou, NOW(), consulta_persona);
			
	UPDATE pilot pi
	SET pi.equip = in_equip, pi.codi_llicencia = in_llicencia, pi.any_inici = in_inici
	WHERE pi.codi_persona = in_persona;	
			
		
	-- Actualitzar log
	
	SET valor_antic = CONCAT_WS(', ',in_persona, old_equip, old_llicencia, old_inici);
	SET valor_nou = CONCAT_WS(',',in_persona, in_equip, in_llicencia, in_inici);
	SET consulta_pilot = CONCAT("modificacio_pilot ('",in_persona,"', '",in_nom,"', '",in_pais,"', '",in_equip,"', ",in_llicencia,"', ",in_inici,")");
	
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('MODIFICACIÓ', 'pilot', valor_antic, valor_nou, NOW(), consulta_pilot);
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.modificacio_sector
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `modificacio_sector`(IN `in_sector` SMALLINT, IN `in_nom` VARCHAR(50), OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare old_nom  VARCHAR(50);


-- Control d'errors

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el codi del sector (',in_sector,') no sigui correcte.');
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;


	SET RSP := 'OK';

	SELECT s.nom
	INTO old_nom
	FROM sector s
	WHERE s.codi_sector = in_sector;


	-- Modifica la taula
				
	UPDATE sector s
	SET s.nom = in_nom
	WHERE s.codi_sector = in_sector;
			
		
	-- Actualitzar log

	SET consulta = CONCAT("modificacio_sector ('",in_sector,"', '",in_nom,")");
	SET valor_antic = CONCAT_WS(', ',in_sector, old_nom);
	SET valor_nou = CONCAT_WS(',',in_sector, in_nom);
		
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('MODIFICACIÓ', 'sector', valor_antic, valor_nou, NOW(), consulta);
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.modificacio_telemetria
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `modificacio_telemetria`(IN `in_dada` BIGINT, IN `in_component` MEDIUMINT, IN `in_moment` DATETIME(6), IN `in_ambit` VARCHAR(50), IN `in_valor` FLOAT, IN `in_unitats` VARCHAR(25), OUT `RSP` VARCHAR(512))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare old_component  MEDIUMINT;
declare old_moment DATETIME(6);
declare old_ambit VARCHAR(50);
declare old_valor FLOAT;
declare old_unitats VARCHAR(25);

declare check_component MEDIUMINT;


-- Control d'errors

DECLARE EXIT HANDLER FOR 1644 
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT("ERROR: Codi ",state,". ",msg);
END;

DECLARE EXIT HANDLER FOR NOT FOUND
 BEGIN
 	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
   SET RSP := CONCAT('ERROR: Not found. Codi ',state,'. Possiblement el codi del component (',in_component,') no sigui correcte.' );
 END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;

		
	SET RSP := 'OK';

	-- Es fa servir SELECT INTO per tal de llençar l'excepcio  NOT FOUND si no es troba el codi a la taula
	SELECT c.codi_component FROM component c WHERE c.codi_component = in_component INTO check_component;

	SELECT t.component, t.moment, t.ambit, t.valor, t.unitat_de_mesura
	INTO old_component, old_moment, old_ambit, old_valor, old_unitats
	FROM telemetria t
	WHERE t.codi_dada = in_dada;

		
	-- Modifica la taula
			
	UPDATE telemetria t
	SET t.component = in_component, t.moment = in_moment, t.ambit = in_ambit, t.valor = in_valor, t.unitat_de_mesura = in_unitats
	WHERE t.codi_dada = in_dada;
			
		
	-- Actualitzar log

	SET consulta = CONCAT("modificacio_telemetria ('",in_dada,"','",in_component,"','",in_moment,"', '",in_ambit,"', '",in_valor,"', '",in_unitats,"')");
	SET valor_antic = CONCAT_WS(', ',in_dada, old_component, old_moment, old_ambit, old_valor, old_unitats);
	SET valor_nou = CONCAT_WS(',',in_dada, in_component, in_moment, in_ambit, in_valor, in_unitats);
		
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('MODIFICACIÓ', 'telemetria', valor_antic, valor_nou, NOW(), consulta);
	
			
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.modificacio_temporada
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `modificacio_temporada`(IN `in_old_any` YEAR, IN `in_old_competicio` SMALLINT, IN `in_nou_any` YEAR, IN `in_nou_competicio` SMALLINT, OUT `RSP` VARCHAR(250))
BEGIN

declare valor_antic VARCHAR (512);
declare valor_nou VARCHAR (512);
declare consulta VARCHAR(512);
declare msg VARCHAR(250);
declare state VARCHAR(50);

declare check_temporada YEAR;
declare check_competicio SMALLINT;


-- Control d'errors

DECLARE EXIT HANDLER FOR 1062 
BEGIN
GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
SET RSP := CONCAT('ERROR: Codi ',state,'. Ja existeix aquesta competicio (\'',in_nou_competicio,'\'), a aquesta temporada (',in_nou_any,')');
END;

DECLARE EXIT HANDLER FOR NOT FOUND
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO;
	SET RSP := CONCAT('ERROR: Not found. Codi ',state,' .Possiblement la parella competicio - temporada (\'',in_old_competicio,' - ',in_old_any,'\') no sigui correcte.');
END;

DECLARE EXIT HANDLER FOR SQLWARNING 
BEGIN 
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Warning. Codi ',state,'. Missatge original: ',msg);
END;

DECLARE EXIT HANDLER FOR SQLEXCEPTION
BEGIN
	GET DIAGNOSTICS CONDITION 1 state = MYSQL_ERRNO, msg = MESSAGE_TEXT;
	SET RSP := CONCAT('ERROR: Desconegut. Codi ',state,'. Missatge original: ',msg);
END;


	SET RSP := 'OK';

	-- Es fa servir SELECT INTO per tal de llençar l'excepcio  NOT FOUND si no es troba el codi a la taula
	SELECT co.competicio, co.temporada 
	FROM competicio_temporada co
	WHERE co.competicio = in_old_competicio 
	AND co.temporada = in_old_any 
	INTO check_competicio, check_temporada;


	-- Modifica la taula
	
	UPDATE competicio_temporada co
	SET co.competicio = in_nou_competicio, co.temporada = in_nou_any
	WHERE co.competicio = in_old_competicio 
	AND co.temporada = in_old_any;
			
		
	-- Actualitzar log
	
	SET consulta = CONCAT("modificacio_temporada ('",in_old_any,"','",in_old_competicio,"','",in_nou_any,"', '",in_nou_competicio,"')");
	SET valor_antic = CONCAT_WS(', ',in_old_any, in_old_competicio);
	SET valor_nou = CONCAT_WS(',',in_nou_any, in_nou_competicio);
		
	INSERT INTO log(operacio, taula,antic_valor,nou_valor,data,consulta) VALUES ('MODIFICACIÓ', 'temporada', valor_antic, valor_nou, NOW(), consulta);
		
END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.simulacio_consum
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `simulacio_consum`(IN `in_component` MEDIUMINT, IN `in_inici` DATETIME(6), IN `in_consum_maxim` INT)
BEGIN

-- 130 litres per carrera
-- 300 km per carrera
-- de 3000 a 6000 dades per carrera
-- 0.022 litres per segon de mitjana 


declare moment_actual DATETIME(6);
declare RSP VARCHAR(512);
declare in_fi DATETIME(6);
	
	SET moment_actual = in_inici;
	SET in_fi = DATE_ADD(moment_actual, INTERVAL (FLOOR(RAND()*(6000-3000)+3000)) SECOND);
	
	WHILE moment_actual < in_fi DO
		call alta_telemetria(in_component,moment_actual,'consum', FLOOR(RAND()*(in_consum_maxim-210)+210)/10000,'lps', RSP);
		SET moment_actual = DATE_ADD(moment_actual, INTERVAL 1 SECOND);
	END WHILE;


END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.simulacio_temperatura
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `simulacio_temperatura`(IN `in_component` MEDIUMINT, IN `in_inici` DATETIME(6))
BEGIN

-- 1200ºC temp maxima
-- 0ºC temp maxima
-- de 3000 a 6000 dades per carrera

declare moment_actual DATETIME(6);
declare in_fi DATETIME(6);
declare RSP VARCHAR(512);
	
	SET moment_actual = in_inici;
	SET in_fi = DATE_ADD(moment_actual, INTERVAL (FLOOR(RAND()*(6000-3000)+3000)) SECOND);
	
	WHILE moment_actual < in_fi DO
		call alta_telemetria(in_component,moment_actual,'temperatura', FLOOR(RAND()*(1200-0)+0),'ºC', RSP);
		SET moment_actual = DATE_ADD(moment_actual, INTERVAL 1 SECOND);
	END WHILE;


END//
DELIMITER ;


-- Volcando estructura para procedimiento fia.simulacio_temps_volta
DELIMITER //
CREATE DEFINER=`root`@`localhost` PROCEDURE `simulacio_temps_volta`(IN `in_component` MEDIUMINT, IN `in_inici` DATETIME(6), IN `in_temps_maxim` TIME(6))
BEGIN


-- 6000 segons per carrera
-- 60 voltes per carrera

declare temps_volta SMALLINT(5);
declare loop_moment DATETIME(6);
declare voltes SMALLINT(5);
declare RSP VARCHAR(512);
	
	SET loop_moment = in_inici;
	SET voltes = 0;
	
	WHILE voltes < 60 DO
		SET temps_volta = FLOOR(RAND()*(in_temps_maxim-90)+90);
		call alta_telemetria(in_component,loop_moment,'temps per volta', temps_volta*1000,'ms', RSP);
		SET loop_moment = DATE_ADD(loop_moment, INTERVAL temps_volta SECOND);
		SET voltes = voltes + 1;
	END WHILE;


END//
DELIMITER ;


-- Volcando estructura para disparador fia.chk_circuit_long_insert
SET @OLDTMP_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_ENGINE_SUBSTITUTION';
DELIMITER //
CREATE TRIGGER `chk_circuit_long_insert` BEFORE INSERT ON `circuit` FOR EACH ROW begin  
      if  NEW.longitud<1000 then
       SIGNAL SQLSTATE '45000'   
	       SET MESSAGE_TEXT = 'Longitud massa petita.';
       end if; 
    end//
DELIMITER ;
SET SQL_MODE=@OLDTMP_SQL_MODE;


-- Volcando estructura para disparador fia.chk_circuit_long_update
SET @OLDTMP_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_ENGINE_SUBSTITUTION';
DELIMITER //
CREATE TRIGGER `chk_circuit_long_update` BEFORE UPDATE ON `circuit` FOR EACH ROW begin  
      if  NEW.longitud<1000 then
       SIGNAL SQLSTATE '45000'   
	       SET MESSAGE_TEXT = 'Longitud massa petita.';
       end if; 
    end//
DELIMITER ;
SET SQL_MODE=@OLDTMP_SQL_MODE;


-- Volcando estructura para disparador fia.chk_cost_patrocini_insert
SET @OLDTMP_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_ENGINE_SUBSTITUTION';
DELIMITER //
CREATE TRIGGER `chk_cost_patrocini_insert` BEFORE INSERT ON `patrocini` FOR EACH ROW begin  
      if  NEW.cost<10000 then
       SIGNAL SQLSTATE '45000'   
	       SET MESSAGE_TEXT = 'Cost massa petit.';
       end if; 
    end//
DELIMITER ;
SET SQL_MODE=@OLDTMP_SQL_MODE;


-- Volcando estructura para disparador fia.chk_cost_patrocini_update
SET @OLDTMP_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_ENGINE_SUBSTITUTION';
DELIMITER //
CREATE TRIGGER `chk_cost_patrocini_update` BEFORE UPDATE ON `patrocini` FOR EACH ROW begin  
      if  NEW.cost<10000 then
       SIGNAL SQLSTATE '45000'   
	       SET MESSAGE_TEXT = 'Cost massa petit.';
       end if; 
    end//
DELIMITER ;
SET SQL_MODE=@OLDTMP_SQL_MODE;


-- Volcando estructura para disparador fia.chk_telemetria_value_insert
SET @OLDTMP_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_ENGINE_SUBSTITUTION';
DELIMITER //
CREATE TRIGGER `chk_telemetria_value_insert` BEFORE INSERT ON `telemetria` FOR EACH ROW begin  
      if  NEW.ambit='velocitat' and NEW.valor>500 then
       SIGNAL SQLSTATE '45000'   
	       SET MESSAGE_TEXT = 'Camp velocitat massa gran.', COLUMN_NAME = NEW.component;
       end if; 
       
      if  NEW.ambit='temps per volta' and NEW.valor=0 then
       SIGNAL SQLSTATE '45000'   
	       SET MESSAGE_TEXT = 'Temps per volta igual a 0.', COLUMN_NAME = NEW.component;
       end if;
       
      if  NEW.valor<0 then
       SIGNAL SQLSTATE '45000'   
	       SET MESSAGE_TEXT = 'Valor negatiu.', COLUMN_NAME = NEW.component;
       end if;
    end//
DELIMITER ;
SET SQL_MODE=@OLDTMP_SQL_MODE;


-- Volcando estructura para disparador fia.chk_telemetria_value_update
SET @OLDTMP_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_ENGINE_SUBSTITUTION';
DELIMITER //
CREATE TRIGGER `chk_telemetria_value_update` BEFORE UPDATE ON `telemetria` FOR EACH ROW begin  
      if  NEW.ambit='velocitat' and NEW.valor>500 then
       SIGNAL SQLSTATE '45000'   
	       SET MESSAGE_TEXT = 'Camp velocitat massa gran.', COLUMN_NAME = NEW.component;
       end if; 
       
      if  NEW.ambit='temps per volta' and NEW.valor=0 then
       SIGNAL SQLSTATE '45000'   
	       SET MESSAGE_TEXT = 'Temps per volta igual a 0.', COLUMN_NAME = NEW.component;
       end if;
       
      if  NEW.valor<0 then
       SIGNAL SQLSTATE '45000'   
	       SET MESSAGE_TEXT = 'Valor negatiu.', COLUMN_NAME = NEW.component;
       end if;
    end//
DELIMITER ;
SET SQL_MODE=@OLDTMP_SQL_MODE;
/*!40101 SET SQL_MODE=IFNULL(@OLD_SQL_MODE, '') */;
/*!40014 SET FOREIGN_KEY_CHECKS=IF(@OLD_FOREIGN_KEY_CHECKS IS NULL, 1, @OLD_FOREIGN_KEY_CHECKS) */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
